// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*eslint-disable block-scoped-var, id-length, no-control-regex, no-magic-numbers, no-prototype-builtins, no-redeclare, no-shadow, no-var, sort-vars*/
(function(global, factory) { /* global define, require, module */

    /* AMD */ if (typeof define === 'function' && define.amd)
        define(["protobufjs/minimal"], factory);

    /* CommonJS */ else if (typeof require === 'function' && typeof module === 'object' && module && module.exports)
        module.exports = factory(require("google-gax/build/src/protobuf").protobufMinimal);

})(this, function($protobuf) {
    "use strict";

    // Common aliases
    var $Reader = $protobuf.Reader, $Writer = $protobuf.Writer, $util = $protobuf.util;
    
    // Exported root namespace
    var $root = $protobuf.roots._google_cloud_compute_protos || ($protobuf.roots._google_cloud_compute_protos = {});
    
    $root.google = (function() {
    
        /**
         * Namespace google.
         * @exports google
         * @namespace
         */
        var google = {};
    
        google.cloud = (function() {
    
            /**
             * Namespace cloud.
             * @memberof google
             * @namespace
             */
            var cloud = {};
    
            cloud.compute = (function() {
    
                /**
                 * Namespace compute.
                 * @memberof google.cloud
                 * @namespace
                 */
                var compute = {};
    
                compute.v1 = (function() {
    
                    /**
                     * Namespace v1.
                     * @memberof google.cloud.compute
                     * @namespace
                     */
                    var v1 = {};
    
                    v1.AbandonInstancesInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of an AbandonInstancesInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAbandonInstancesInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] AbandonInstancesInstanceGroupManagerRequest instanceGroupManager
                         * @property {google.cloud.compute.v1.IInstanceGroupManagersAbandonInstancesRequest|null} [instanceGroupManagersAbandonInstancesRequestResource] AbandonInstancesInstanceGroupManagerRequest instanceGroupManagersAbandonInstancesRequestResource
                         * @property {string|null} [project] AbandonInstancesInstanceGroupManagerRequest project
                         * @property {string|null} [requestId] AbandonInstancesInstanceGroupManagerRequest requestId
                         * @property {string|null} [zone] AbandonInstancesInstanceGroupManagerRequest zone
                         */
    
                        /**
                         * Constructs a new AbandonInstancesInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AbandonInstancesInstanceGroupManagerRequest.
                         * @implements IAbandonInstancesInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAbandonInstancesInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function AbandonInstancesInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AbandonInstancesInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        AbandonInstancesInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * AbandonInstancesInstanceGroupManagerRequest instanceGroupManagersAbandonInstancesRequestResource.
                         * @member {google.cloud.compute.v1.IInstanceGroupManagersAbandonInstancesRequest|null|undefined} instanceGroupManagersAbandonInstancesRequestResource
                         * @memberof google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        AbandonInstancesInstanceGroupManagerRequest.prototype.instanceGroupManagersAbandonInstancesRequestResource = null;
    
                        /**
                         * AbandonInstancesInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        AbandonInstancesInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * AbandonInstancesInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        AbandonInstancesInstanceGroupManagerRequest.prototype.requestId = null;
    
                        /**
                         * AbandonInstancesInstanceGroupManagerRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        AbandonInstancesInstanceGroupManagerRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AbandonInstancesInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(AbandonInstancesInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AbandonInstancesInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAbandonInstancesInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest} AbandonInstancesInstanceGroupManagerRequest instance
                         */
                        AbandonInstancesInstanceGroupManagerRequest.create = function create(properties) {
                            return new AbandonInstancesInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AbandonInstancesInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAbandonInstancesInstanceGroupManagerRequest} message AbandonInstancesInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AbandonInstancesInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            if (message.instanceGroupManagersAbandonInstancesRequestResource != null && Object.hasOwnProperty.call(message, "instanceGroupManagersAbandonInstancesRequestResource"))
                                $root.google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest.encode(message.instanceGroupManagersAbandonInstancesRequestResource, writer.uint32(/* id 320929016, wireType 2 =*/2567432130).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AbandonInstancesInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAbandonInstancesInstanceGroupManagerRequest} message AbandonInstancesInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AbandonInstancesInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AbandonInstancesInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest} AbandonInstancesInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AbandonInstancesInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 320929016: {
                                        message.instanceGroupManagersAbandonInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AbandonInstancesInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest} AbandonInstancesInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AbandonInstancesInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AbandonInstancesInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AbandonInstancesInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.instanceGroupManagersAbandonInstancesRequestResource != null && message.hasOwnProperty("instanceGroupManagersAbandonInstancesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest.verify(message.instanceGroupManagersAbandonInstancesRequestResource);
                                if (error)
                                    return "instanceGroupManagersAbandonInstancesRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AbandonInstancesInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest} AbandonInstancesInstanceGroupManagerRequest
                         */
                        AbandonInstancesInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.instanceGroupManagersAbandonInstancesRequestResource != null) {
                                if (typeof object.instanceGroupManagersAbandonInstancesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest.instanceGroupManagersAbandonInstancesRequestResource: object expected");
                                message.instanceGroupManagersAbandonInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest.fromObject(object.instanceGroupManagersAbandonInstancesRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AbandonInstancesInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest} message AbandonInstancesInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AbandonInstancesInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                                object.instanceGroupManagersAbandonInstancesRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            if (message.instanceGroupManagersAbandonInstancesRequestResource != null && message.hasOwnProperty("instanceGroupManagersAbandonInstancesRequestResource"))
                                object.instanceGroupManagersAbandonInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest.toObject(message.instanceGroupManagersAbandonInstancesRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this AbandonInstancesInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AbandonInstancesInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AbandonInstancesInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AbandonInstancesInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest";
                        };
    
                        return AbandonInstancesInstanceGroupManagerRequest;
                    })();
    
                    v1.AbandonInstancesRegionInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of an AbandonInstancesRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAbandonInstancesRegionInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] AbandonInstancesRegionInstanceGroupManagerRequest instanceGroupManager
                         * @property {string|null} [project] AbandonInstancesRegionInstanceGroupManagerRequest project
                         * @property {string|null} [region] AbandonInstancesRegionInstanceGroupManagerRequest region
                         * @property {google.cloud.compute.v1.IRegionInstanceGroupManagersAbandonInstancesRequest|null} [regionInstanceGroupManagersAbandonInstancesRequestResource] AbandonInstancesRegionInstanceGroupManagerRequest regionInstanceGroupManagersAbandonInstancesRequestResource
                         * @property {string|null} [requestId] AbandonInstancesRegionInstanceGroupManagerRequest requestId
                         */
    
                        /**
                         * Constructs a new AbandonInstancesRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AbandonInstancesRegionInstanceGroupManagerRequest.
                         * @implements IAbandonInstancesRegionInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAbandonInstancesRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function AbandonInstancesRegionInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AbandonInstancesRegionInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        AbandonInstancesRegionInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * AbandonInstancesRegionInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        AbandonInstancesRegionInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * AbandonInstancesRegionInstanceGroupManagerRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        AbandonInstancesRegionInstanceGroupManagerRequest.prototype.region = "";
    
                        /**
                         * AbandonInstancesRegionInstanceGroupManagerRequest regionInstanceGroupManagersAbandonInstancesRequestResource.
                         * @member {google.cloud.compute.v1.IRegionInstanceGroupManagersAbandonInstancesRequest|null|undefined} regionInstanceGroupManagersAbandonInstancesRequestResource
                         * @memberof google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        AbandonInstancesRegionInstanceGroupManagerRequest.prototype.regionInstanceGroupManagersAbandonInstancesRequestResource = null;
    
                        /**
                         * AbandonInstancesRegionInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        AbandonInstancesRegionInstanceGroupManagerRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AbandonInstancesRegionInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(AbandonInstancesRegionInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AbandonInstancesRegionInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAbandonInstancesRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest} AbandonInstancesRegionInstanceGroupManagerRequest instance
                         */
                        AbandonInstancesRegionInstanceGroupManagerRequest.create = function create(properties) {
                            return new AbandonInstancesRegionInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AbandonInstancesRegionInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAbandonInstancesRegionInstanceGroupManagerRequest} message AbandonInstancesRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AbandonInstancesRegionInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            if (message.regionInstanceGroupManagersAbandonInstancesRequestResource != null && Object.hasOwnProperty.call(message, "regionInstanceGroupManagersAbandonInstancesRequestResource"))
                                $root.google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest.encode(message.regionInstanceGroupManagersAbandonInstancesRequestResource, writer.uint32(/* id 488499491, wireType 2 =*/3907995930).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AbandonInstancesRegionInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAbandonInstancesRegionInstanceGroupManagerRequest} message AbandonInstancesRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AbandonInstancesRegionInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AbandonInstancesRegionInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest} AbandonInstancesRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AbandonInstancesRegionInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 488499491: {
                                        message.regionInstanceGroupManagersAbandonInstancesRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AbandonInstancesRegionInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest} AbandonInstancesRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AbandonInstancesRegionInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AbandonInstancesRegionInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AbandonInstancesRegionInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionInstanceGroupManagersAbandonInstancesRequestResource != null && message.hasOwnProperty("regionInstanceGroupManagersAbandonInstancesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest.verify(message.regionInstanceGroupManagersAbandonInstancesRequestResource);
                                if (error)
                                    return "regionInstanceGroupManagersAbandonInstancesRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AbandonInstancesRegionInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest} AbandonInstancesRegionInstanceGroupManagerRequest
                         */
                        AbandonInstancesRegionInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionInstanceGroupManagersAbandonInstancesRequestResource != null) {
                                if (typeof object.regionInstanceGroupManagersAbandonInstancesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest.regionInstanceGroupManagersAbandonInstancesRequestResource: object expected");
                                message.regionInstanceGroupManagersAbandonInstancesRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest.fromObject(object.regionInstanceGroupManagersAbandonInstancesRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AbandonInstancesRegionInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest} message AbandonInstancesRegionInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AbandonInstancesRegionInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                                object.regionInstanceGroupManagersAbandonInstancesRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            if (message.regionInstanceGroupManagersAbandonInstancesRequestResource != null && message.hasOwnProperty("regionInstanceGroupManagersAbandonInstancesRequestResource"))
                                object.regionInstanceGroupManagersAbandonInstancesRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest.toObject(message.regionInstanceGroupManagersAbandonInstancesRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this AbandonInstancesRegionInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AbandonInstancesRegionInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AbandonInstancesRegionInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AbandonInstancesRegionInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest";
                        };
    
                        return AbandonInstancesRegionInstanceGroupManagerRequest;
                    })();
    
                    v1.AcceleratorConfig = (function() {
    
                        /**
                         * Properties of an AcceleratorConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface IAcceleratorConfig
                         * @property {number|null} [acceleratorCount] AcceleratorConfig acceleratorCount
                         * @property {string|null} [acceleratorType] AcceleratorConfig acceleratorType
                         */
    
                        /**
                         * Constructs a new AcceleratorConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AcceleratorConfig.
                         * @implements IAcceleratorConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.IAcceleratorConfig=} [properties] Properties to set
                         */
                        function AcceleratorConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AcceleratorConfig acceleratorCount.
                         * @member {number|null|undefined} acceleratorCount
                         * @memberof google.cloud.compute.v1.AcceleratorConfig
                         * @instance
                         */
                        AcceleratorConfig.prototype.acceleratorCount = null;
    
                        /**
                         * AcceleratorConfig acceleratorType.
                         * @member {string|null|undefined} acceleratorType
                         * @memberof google.cloud.compute.v1.AcceleratorConfig
                         * @instance
                         */
                        AcceleratorConfig.prototype.acceleratorType = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AcceleratorConfig _acceleratorCount.
                         * @member {"acceleratorCount"|undefined} _acceleratorCount
                         * @memberof google.cloud.compute.v1.AcceleratorConfig
                         * @instance
                         */
                        Object.defineProperty(AcceleratorConfig.prototype, "_acceleratorCount", {
                            get: $util.oneOfGetter($oneOfFields = ["acceleratorCount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AcceleratorConfig _acceleratorType.
                         * @member {"acceleratorType"|undefined} _acceleratorType
                         * @memberof google.cloud.compute.v1.AcceleratorConfig
                         * @instance
                         */
                        Object.defineProperty(AcceleratorConfig.prototype, "_acceleratorType", {
                            get: $util.oneOfGetter($oneOfFields = ["acceleratorType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AcceleratorConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AcceleratorConfig
                         * @static
                         * @param {google.cloud.compute.v1.IAcceleratorConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AcceleratorConfig} AcceleratorConfig instance
                         */
                        AcceleratorConfig.create = function create(properties) {
                            return new AcceleratorConfig(properties);
                        };
    
                        /**
                         * Encodes the specified AcceleratorConfig message. Does not implicitly {@link google.cloud.compute.v1.AcceleratorConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AcceleratorConfig
                         * @static
                         * @param {google.cloud.compute.v1.IAcceleratorConfig} message AcceleratorConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AcceleratorConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.acceleratorType != null && Object.hasOwnProperty.call(message, "acceleratorType"))
                                writer.uint32(/* id 138031246, wireType 2 =*/1104249970).string(message.acceleratorType);
                            if (message.acceleratorCount != null && Object.hasOwnProperty.call(message, "acceleratorCount"))
                                writer.uint32(/* id 504879675, wireType 0 =*/4039037400).int32(message.acceleratorCount);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AcceleratorConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AcceleratorConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AcceleratorConfig
                         * @static
                         * @param {google.cloud.compute.v1.IAcceleratorConfig} message AcceleratorConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AcceleratorConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AcceleratorConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AcceleratorConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AcceleratorConfig} AcceleratorConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AcceleratorConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AcceleratorConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 504879675: {
                                        message.acceleratorCount = reader.int32();
                                        break;
                                    }
                                case 138031246: {
                                        message.acceleratorType = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AcceleratorConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AcceleratorConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AcceleratorConfig} AcceleratorConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AcceleratorConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AcceleratorConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AcceleratorConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AcceleratorConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.acceleratorCount != null && message.hasOwnProperty("acceleratorCount")) {
                                properties._acceleratorCount = 1;
                                if (!$util.isInteger(message.acceleratorCount))
                                    return "acceleratorCount: integer expected";
                            }
                            if (message.acceleratorType != null && message.hasOwnProperty("acceleratorType")) {
                                properties._acceleratorType = 1;
                                if (!$util.isString(message.acceleratorType))
                                    return "acceleratorType: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AcceleratorConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AcceleratorConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AcceleratorConfig} AcceleratorConfig
                         */
                        AcceleratorConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AcceleratorConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AcceleratorConfig();
                            if (object.acceleratorCount != null)
                                message.acceleratorCount = object.acceleratorCount | 0;
                            if (object.acceleratorType != null)
                                message.acceleratorType = String(object.acceleratorType);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AcceleratorConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AcceleratorConfig
                         * @static
                         * @param {google.cloud.compute.v1.AcceleratorConfig} message AcceleratorConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AcceleratorConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.acceleratorType != null && message.hasOwnProperty("acceleratorType")) {
                                object.acceleratorType = message.acceleratorType;
                                if (options.oneofs)
                                    object._acceleratorType = "acceleratorType";
                            }
                            if (message.acceleratorCount != null && message.hasOwnProperty("acceleratorCount")) {
                                object.acceleratorCount = message.acceleratorCount;
                                if (options.oneofs)
                                    object._acceleratorCount = "acceleratorCount";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AcceleratorConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AcceleratorConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AcceleratorConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AcceleratorConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AcceleratorConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AcceleratorConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AcceleratorConfig";
                        };
    
                        return AcceleratorConfig;
                    })();
    
                    v1.AcceleratorType = (function() {
    
                        /**
                         * Properties of an AcceleratorType.
                         * @memberof google.cloud.compute.v1
                         * @interface IAcceleratorType
                         * @property {string|null} [creationTimestamp] AcceleratorType creationTimestamp
                         * @property {google.cloud.compute.v1.IDeprecationStatus|null} [deprecated] AcceleratorType deprecated
                         * @property {string|null} [description] AcceleratorType description
                         * @property {number|Long|null} [id] AcceleratorType id
                         * @property {string|null} [kind] AcceleratorType kind
                         * @property {number|null} [maximumCardsPerInstance] AcceleratorType maximumCardsPerInstance
                         * @property {string|null} [name] AcceleratorType name
                         * @property {string|null} [selfLink] AcceleratorType selfLink
                         * @property {string|null} [zone] AcceleratorType zone
                         */
    
                        /**
                         * Constructs a new AcceleratorType.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AcceleratorType.
                         * @implements IAcceleratorType
                         * @constructor
                         * @param {google.cloud.compute.v1.IAcceleratorType=} [properties] Properties to set
                         */
                        function AcceleratorType(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AcceleratorType creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @instance
                         */
                        AcceleratorType.prototype.creationTimestamp = null;
    
                        /**
                         * AcceleratorType deprecated.
                         * @member {google.cloud.compute.v1.IDeprecationStatus|null|undefined} deprecated
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @instance
                         */
                        AcceleratorType.prototype.deprecated = null;
    
                        /**
                         * AcceleratorType description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @instance
                         */
                        AcceleratorType.prototype.description = null;
    
                        /**
                         * AcceleratorType id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @instance
                         */
                        AcceleratorType.prototype.id = null;
    
                        /**
                         * AcceleratorType kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @instance
                         */
                        AcceleratorType.prototype.kind = null;
    
                        /**
                         * AcceleratorType maximumCardsPerInstance.
                         * @member {number|null|undefined} maximumCardsPerInstance
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @instance
                         */
                        AcceleratorType.prototype.maximumCardsPerInstance = null;
    
                        /**
                         * AcceleratorType name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @instance
                         */
                        AcceleratorType.prototype.name = null;
    
                        /**
                         * AcceleratorType selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @instance
                         */
                        AcceleratorType.prototype.selfLink = null;
    
                        /**
                         * AcceleratorType zone.
                         * @member {string|null|undefined} zone
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @instance
                         */
                        AcceleratorType.prototype.zone = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AcceleratorType _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @instance
                         */
                        Object.defineProperty(AcceleratorType.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AcceleratorType _deprecated.
                         * @member {"deprecated"|undefined} _deprecated
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @instance
                         */
                        Object.defineProperty(AcceleratorType.prototype, "_deprecated", {
                            get: $util.oneOfGetter($oneOfFields = ["deprecated"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AcceleratorType _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @instance
                         */
                        Object.defineProperty(AcceleratorType.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AcceleratorType _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @instance
                         */
                        Object.defineProperty(AcceleratorType.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AcceleratorType _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @instance
                         */
                        Object.defineProperty(AcceleratorType.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AcceleratorType _maximumCardsPerInstance.
                         * @member {"maximumCardsPerInstance"|undefined} _maximumCardsPerInstance
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @instance
                         */
                        Object.defineProperty(AcceleratorType.prototype, "_maximumCardsPerInstance", {
                            get: $util.oneOfGetter($oneOfFields = ["maximumCardsPerInstance"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AcceleratorType _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @instance
                         */
                        Object.defineProperty(AcceleratorType.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AcceleratorType _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @instance
                         */
                        Object.defineProperty(AcceleratorType.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AcceleratorType _zone.
                         * @member {"zone"|undefined} _zone
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @instance
                         */
                        Object.defineProperty(AcceleratorType.prototype, "_zone", {
                            get: $util.oneOfGetter($oneOfFields = ["zone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AcceleratorType instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @static
                         * @param {google.cloud.compute.v1.IAcceleratorType=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AcceleratorType} AcceleratorType instance
                         */
                        AcceleratorType.create = function create(properties) {
                            return new AcceleratorType(properties);
                        };
    
                        /**
                         * Encodes the specified AcceleratorType message. Does not implicitly {@link google.cloud.compute.v1.AcceleratorType.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @static
                         * @param {google.cloud.compute.v1.IAcceleratorType} message AcceleratorType message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AcceleratorType.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.maximumCardsPerInstance != null && Object.hasOwnProperty.call(message, "maximumCardsPerInstance"))
                                writer.uint32(/* id 263814482, wireType 0 =*/2110515856).int32(message.maximumCardsPerInstance);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                                $root.google.cloud.compute.v1.DeprecationStatus.encode(message.deprecated, writer.uint32(/* id 515138995, wireType 2 =*/4121111962).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AcceleratorType message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AcceleratorType.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @static
                         * @param {google.cloud.compute.v1.IAcceleratorType} message AcceleratorType message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AcceleratorType.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AcceleratorType message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AcceleratorType} AcceleratorType
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AcceleratorType.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AcceleratorType();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 515138995: {
                                        message.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 263814482: {
                                        message.maximumCardsPerInstance = reader.int32();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AcceleratorType message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AcceleratorType} AcceleratorType
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AcceleratorType.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AcceleratorType message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AcceleratorType.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.deprecated != null && message.hasOwnProperty("deprecated")) {
                                properties._deprecated = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.DeprecationStatus.verify(message.deprecated);
                                    if (error)
                                        return "deprecated." + error;
                                }
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.maximumCardsPerInstance != null && message.hasOwnProperty("maximumCardsPerInstance")) {
                                properties._maximumCardsPerInstance = 1;
                                if (!$util.isInteger(message.maximumCardsPerInstance))
                                    return "maximumCardsPerInstance: integer expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                properties._zone = 1;
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AcceleratorType message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AcceleratorType} AcceleratorType
                         */
                        AcceleratorType.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AcceleratorType)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AcceleratorType();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.deprecated != null) {
                                if (typeof object.deprecated !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AcceleratorType.deprecated: object expected");
                                message.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.fromObject(object.deprecated);
                            }
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.maximumCardsPerInstance != null)
                                message.maximumCardsPerInstance = object.maximumCardsPerInstance | 0;
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AcceleratorType message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @static
                         * @param {google.cloud.compute.v1.AcceleratorType} message AcceleratorType
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AcceleratorType.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                object.zone = message.zone;
                                if (options.oneofs)
                                    object._zone = "zone";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.maximumCardsPerInstance != null && message.hasOwnProperty("maximumCardsPerInstance")) {
                                object.maximumCardsPerInstance = message.maximumCardsPerInstance;
                                if (options.oneofs)
                                    object._maximumCardsPerInstance = "maximumCardsPerInstance";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.deprecated != null && message.hasOwnProperty("deprecated")) {
                                object.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.toObject(message.deprecated, options);
                                if (options.oneofs)
                                    object._deprecated = "deprecated";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AcceleratorType to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AcceleratorType.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AcceleratorType
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AcceleratorType
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AcceleratorType.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AcceleratorType";
                        };
    
                        return AcceleratorType;
                    })();
    
                    v1.AcceleratorTypeAggregatedList = (function() {
    
                        /**
                         * Properties of an AcceleratorTypeAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IAcceleratorTypeAggregatedList
                         * @property {string|null} [id] AcceleratorTypeAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IAcceleratorTypesScopedList>|null} [items] AcceleratorTypeAggregatedList items
                         * @property {string|null} [kind] AcceleratorTypeAggregatedList kind
                         * @property {string|null} [nextPageToken] AcceleratorTypeAggregatedList nextPageToken
                         * @property {string|null} [selfLink] AcceleratorTypeAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] AcceleratorTypeAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] AcceleratorTypeAggregatedList warning
                         */
    
                        /**
                         * Constructs a new AcceleratorTypeAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AcceleratorTypeAggregatedList.
                         * @implements IAcceleratorTypeAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IAcceleratorTypeAggregatedList=} [properties] Properties to set
                         */
                        function AcceleratorTypeAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AcceleratorTypeAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @instance
                         */
                        AcceleratorTypeAggregatedList.prototype.id = null;
    
                        /**
                         * AcceleratorTypeAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IAcceleratorTypesScopedList>} items
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @instance
                         */
                        AcceleratorTypeAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * AcceleratorTypeAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @instance
                         */
                        AcceleratorTypeAggregatedList.prototype.kind = null;
    
                        /**
                         * AcceleratorTypeAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @instance
                         */
                        AcceleratorTypeAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * AcceleratorTypeAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @instance
                         */
                        AcceleratorTypeAggregatedList.prototype.selfLink = null;
    
                        /**
                         * AcceleratorTypeAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @instance
                         */
                        AcceleratorTypeAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * AcceleratorTypeAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @instance
                         */
                        AcceleratorTypeAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AcceleratorTypeAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @instance
                         */
                        Object.defineProperty(AcceleratorTypeAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AcceleratorTypeAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @instance
                         */
                        Object.defineProperty(AcceleratorTypeAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AcceleratorTypeAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @instance
                         */
                        Object.defineProperty(AcceleratorTypeAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AcceleratorTypeAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @instance
                         */
                        Object.defineProperty(AcceleratorTypeAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AcceleratorTypeAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @instance
                         */
                        Object.defineProperty(AcceleratorTypeAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AcceleratorTypeAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IAcceleratorTypeAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AcceleratorTypeAggregatedList} AcceleratorTypeAggregatedList instance
                         */
                        AcceleratorTypeAggregatedList.create = function create(properties) {
                            return new AcceleratorTypeAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified AcceleratorTypeAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.AcceleratorTypeAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IAcceleratorTypeAggregatedList} message AcceleratorTypeAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AcceleratorTypeAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.AcceleratorTypesScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AcceleratorTypeAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AcceleratorTypeAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IAcceleratorTypeAggregatedList} message AcceleratorTypeAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AcceleratorTypeAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AcceleratorTypeAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AcceleratorTypeAggregatedList} AcceleratorTypeAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AcceleratorTypeAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AcceleratorTypeAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.AcceleratorTypesScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AcceleratorTypeAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AcceleratorTypeAggregatedList} AcceleratorTypeAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AcceleratorTypeAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AcceleratorTypeAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AcceleratorTypeAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AcceleratorTypesScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AcceleratorTypeAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AcceleratorTypeAggregatedList} AcceleratorTypeAggregatedList
                         */
                        AcceleratorTypeAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AcceleratorTypeAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AcceleratorTypeAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AcceleratorTypeAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.AcceleratorTypeAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.AcceleratorTypesScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.AcceleratorTypeAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AcceleratorTypeAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AcceleratorTypeAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.AcceleratorTypeAggregatedList} message AcceleratorTypeAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AcceleratorTypeAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.AcceleratorTypesScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AcceleratorTypeAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AcceleratorTypeAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AcceleratorTypeAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AcceleratorTypeAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AcceleratorTypeAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AcceleratorTypeAggregatedList";
                        };
    
                        return AcceleratorTypeAggregatedList;
                    })();
    
                    v1.AcceleratorTypeList = (function() {
    
                        /**
                         * Properties of an AcceleratorTypeList.
                         * @memberof google.cloud.compute.v1
                         * @interface IAcceleratorTypeList
                         * @property {string|null} [id] AcceleratorTypeList id
                         * @property {Array.<google.cloud.compute.v1.IAcceleratorType>|null} [items] AcceleratorTypeList items
                         * @property {string|null} [kind] AcceleratorTypeList kind
                         * @property {string|null} [nextPageToken] AcceleratorTypeList nextPageToken
                         * @property {string|null} [selfLink] AcceleratorTypeList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] AcceleratorTypeList warning
                         */
    
                        /**
                         * Constructs a new AcceleratorTypeList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AcceleratorTypeList.
                         * @implements IAcceleratorTypeList
                         * @constructor
                         * @param {google.cloud.compute.v1.IAcceleratorTypeList=} [properties] Properties to set
                         */
                        function AcceleratorTypeList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AcceleratorTypeList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @instance
                         */
                        AcceleratorTypeList.prototype.id = null;
    
                        /**
                         * AcceleratorTypeList items.
                         * @member {Array.<google.cloud.compute.v1.IAcceleratorType>} items
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @instance
                         */
                        AcceleratorTypeList.prototype.items = $util.emptyArray;
    
                        /**
                         * AcceleratorTypeList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @instance
                         */
                        AcceleratorTypeList.prototype.kind = null;
    
                        /**
                         * AcceleratorTypeList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @instance
                         */
                        AcceleratorTypeList.prototype.nextPageToken = null;
    
                        /**
                         * AcceleratorTypeList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @instance
                         */
                        AcceleratorTypeList.prototype.selfLink = null;
    
                        /**
                         * AcceleratorTypeList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @instance
                         */
                        AcceleratorTypeList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AcceleratorTypeList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @instance
                         */
                        Object.defineProperty(AcceleratorTypeList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AcceleratorTypeList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @instance
                         */
                        Object.defineProperty(AcceleratorTypeList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AcceleratorTypeList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @instance
                         */
                        Object.defineProperty(AcceleratorTypeList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AcceleratorTypeList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @instance
                         */
                        Object.defineProperty(AcceleratorTypeList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AcceleratorTypeList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @instance
                         */
                        Object.defineProperty(AcceleratorTypeList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AcceleratorTypeList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @static
                         * @param {google.cloud.compute.v1.IAcceleratorTypeList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AcceleratorTypeList} AcceleratorTypeList instance
                         */
                        AcceleratorTypeList.create = function create(properties) {
                            return new AcceleratorTypeList(properties);
                        };
    
                        /**
                         * Encodes the specified AcceleratorTypeList message. Does not implicitly {@link google.cloud.compute.v1.AcceleratorTypeList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @static
                         * @param {google.cloud.compute.v1.IAcceleratorTypeList} message AcceleratorTypeList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AcceleratorTypeList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.AcceleratorType.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AcceleratorTypeList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AcceleratorTypeList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @static
                         * @param {google.cloud.compute.v1.IAcceleratorTypeList} message AcceleratorTypeList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AcceleratorTypeList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AcceleratorTypeList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AcceleratorTypeList} AcceleratorTypeList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AcceleratorTypeList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AcceleratorTypeList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.AcceleratorType.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AcceleratorTypeList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AcceleratorTypeList} AcceleratorTypeList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AcceleratorTypeList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AcceleratorTypeList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AcceleratorTypeList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AcceleratorType.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AcceleratorTypeList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AcceleratorTypeList} AcceleratorTypeList
                         */
                        AcceleratorTypeList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AcceleratorTypeList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AcceleratorTypeList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.AcceleratorTypeList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.AcceleratorTypeList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.AcceleratorType.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AcceleratorTypeList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AcceleratorTypeList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @static
                         * @param {google.cloud.compute.v1.AcceleratorTypeList} message AcceleratorTypeList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AcceleratorTypeList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.AcceleratorType.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AcceleratorTypeList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AcceleratorTypeList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AcceleratorTypeList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AcceleratorTypeList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AcceleratorTypeList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AcceleratorTypeList";
                        };
    
                        return AcceleratorTypeList;
                    })();
    
                    v1.AcceleratorTypesScopedList = (function() {
    
                        /**
                         * Properties of an AcceleratorTypesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IAcceleratorTypesScopedList
                         * @property {Array.<google.cloud.compute.v1.IAcceleratorType>|null} [acceleratorTypes] AcceleratorTypesScopedList acceleratorTypes
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] AcceleratorTypesScopedList warning
                         */
    
                        /**
                         * Constructs a new AcceleratorTypesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AcceleratorTypesScopedList.
                         * @implements IAcceleratorTypesScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IAcceleratorTypesScopedList=} [properties] Properties to set
                         */
                        function AcceleratorTypesScopedList(properties) {
                            this.acceleratorTypes = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AcceleratorTypesScopedList acceleratorTypes.
                         * @member {Array.<google.cloud.compute.v1.IAcceleratorType>} acceleratorTypes
                         * @memberof google.cloud.compute.v1.AcceleratorTypesScopedList
                         * @instance
                         */
                        AcceleratorTypesScopedList.prototype.acceleratorTypes = $util.emptyArray;
    
                        /**
                         * AcceleratorTypesScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.AcceleratorTypesScopedList
                         * @instance
                         */
                        AcceleratorTypesScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AcceleratorTypesScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.AcceleratorTypesScopedList
                         * @instance
                         */
                        Object.defineProperty(AcceleratorTypesScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AcceleratorTypesScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AcceleratorTypesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IAcceleratorTypesScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AcceleratorTypesScopedList} AcceleratorTypesScopedList instance
                         */
                        AcceleratorTypesScopedList.create = function create(properties) {
                            return new AcceleratorTypesScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified AcceleratorTypesScopedList message. Does not implicitly {@link google.cloud.compute.v1.AcceleratorTypesScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AcceleratorTypesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IAcceleratorTypesScopedList} message AcceleratorTypesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AcceleratorTypesScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.acceleratorTypes != null && message.acceleratorTypes.length)
                                for (var i = 0; i < message.acceleratorTypes.length; ++i)
                                    $root.google.cloud.compute.v1.AcceleratorType.encode(message.acceleratorTypes[i], writer.uint32(/* id 520872357, wireType 2 =*/4166978858).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AcceleratorTypesScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AcceleratorTypesScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AcceleratorTypesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IAcceleratorTypesScopedList} message AcceleratorTypesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AcceleratorTypesScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AcceleratorTypesScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AcceleratorTypesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AcceleratorTypesScopedList} AcceleratorTypesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AcceleratorTypesScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AcceleratorTypesScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 520872357: {
                                        if (!(message.acceleratorTypes && message.acceleratorTypes.length))
                                            message.acceleratorTypes = [];
                                        message.acceleratorTypes.push($root.google.cloud.compute.v1.AcceleratorType.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AcceleratorTypesScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AcceleratorTypesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AcceleratorTypesScopedList} AcceleratorTypesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AcceleratorTypesScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AcceleratorTypesScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AcceleratorTypesScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AcceleratorTypesScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.acceleratorTypes != null && message.hasOwnProperty("acceleratorTypes")) {
                                if (!Array.isArray(message.acceleratorTypes))
                                    return "acceleratorTypes: array expected";
                                for (var i = 0; i < message.acceleratorTypes.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AcceleratorType.verify(message.acceleratorTypes[i]);
                                    if (error)
                                        return "acceleratorTypes." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AcceleratorTypesScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AcceleratorTypesScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AcceleratorTypesScopedList} AcceleratorTypesScopedList
                         */
                        AcceleratorTypesScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AcceleratorTypesScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AcceleratorTypesScopedList();
                            if (object.acceleratorTypes) {
                                if (!Array.isArray(object.acceleratorTypes))
                                    throw TypeError(".google.cloud.compute.v1.AcceleratorTypesScopedList.acceleratorTypes: array expected");
                                message.acceleratorTypes = [];
                                for (var i = 0; i < object.acceleratorTypes.length; ++i) {
                                    if (typeof object.acceleratorTypes[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.AcceleratorTypesScopedList.acceleratorTypes: object expected");
                                    message.acceleratorTypes[i] = $root.google.cloud.compute.v1.AcceleratorType.fromObject(object.acceleratorTypes[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AcceleratorTypesScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AcceleratorTypesScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AcceleratorTypesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.AcceleratorTypesScopedList} message AcceleratorTypesScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AcceleratorTypesScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.acceleratorTypes = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.acceleratorTypes && message.acceleratorTypes.length) {
                                object.acceleratorTypes = [];
                                for (var j = 0; j < message.acceleratorTypes.length; ++j)
                                    object.acceleratorTypes[j] = $root.google.cloud.compute.v1.AcceleratorType.toObject(message.acceleratorTypes[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AcceleratorTypesScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AcceleratorTypesScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AcceleratorTypesScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AcceleratorTypesScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AcceleratorTypesScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AcceleratorTypesScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AcceleratorTypesScopedList";
                        };
    
                        return AcceleratorTypesScopedList;
                    })();
    
                    v1.Accelerators = (function() {
    
                        /**
                         * Properties of an Accelerators.
                         * @memberof google.cloud.compute.v1
                         * @interface IAccelerators
                         * @property {number|null} [guestAcceleratorCount] Accelerators guestAcceleratorCount
                         * @property {string|null} [guestAcceleratorType] Accelerators guestAcceleratorType
                         */
    
                        /**
                         * Constructs a new Accelerators.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an Accelerators.
                         * @implements IAccelerators
                         * @constructor
                         * @param {google.cloud.compute.v1.IAccelerators=} [properties] Properties to set
                         */
                        function Accelerators(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Accelerators guestAcceleratorCount.
                         * @member {number|null|undefined} guestAcceleratorCount
                         * @memberof google.cloud.compute.v1.Accelerators
                         * @instance
                         */
                        Accelerators.prototype.guestAcceleratorCount = null;
    
                        /**
                         * Accelerators guestAcceleratorType.
                         * @member {string|null|undefined} guestAcceleratorType
                         * @memberof google.cloud.compute.v1.Accelerators
                         * @instance
                         */
                        Accelerators.prototype.guestAcceleratorType = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Accelerators _guestAcceleratorCount.
                         * @member {"guestAcceleratorCount"|undefined} _guestAcceleratorCount
                         * @memberof google.cloud.compute.v1.Accelerators
                         * @instance
                         */
                        Object.defineProperty(Accelerators.prototype, "_guestAcceleratorCount", {
                            get: $util.oneOfGetter($oneOfFields = ["guestAcceleratorCount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Accelerators _guestAcceleratorType.
                         * @member {"guestAcceleratorType"|undefined} _guestAcceleratorType
                         * @memberof google.cloud.compute.v1.Accelerators
                         * @instance
                         */
                        Object.defineProperty(Accelerators.prototype, "_guestAcceleratorType", {
                            get: $util.oneOfGetter($oneOfFields = ["guestAcceleratorType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Accelerators instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Accelerators
                         * @static
                         * @param {google.cloud.compute.v1.IAccelerators=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Accelerators} Accelerators instance
                         */
                        Accelerators.create = function create(properties) {
                            return new Accelerators(properties);
                        };
    
                        /**
                         * Encodes the specified Accelerators message. Does not implicitly {@link google.cloud.compute.v1.Accelerators.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Accelerators
                         * @static
                         * @param {google.cloud.compute.v1.IAccelerators} message Accelerators message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Accelerators.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.guestAcceleratorType != null && Object.hasOwnProperty.call(message, "guestAcceleratorType"))
                                writer.uint32(/* id 293064725, wireType 2 =*/2344517802).string(message.guestAcceleratorType);
                            if (message.guestAcceleratorCount != null && Object.hasOwnProperty.call(message, "guestAcceleratorCount"))
                                writer.uint32(/* id 479079316, wireType 0 =*/3832634528).int32(message.guestAcceleratorCount);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Accelerators message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Accelerators.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Accelerators
                         * @static
                         * @param {google.cloud.compute.v1.IAccelerators} message Accelerators message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Accelerators.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Accelerators message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Accelerators
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Accelerators} Accelerators
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Accelerators.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Accelerators();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 479079316: {
                                        message.guestAcceleratorCount = reader.int32();
                                        break;
                                    }
                                case 293064725: {
                                        message.guestAcceleratorType = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Accelerators message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Accelerators
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Accelerators} Accelerators
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Accelerators.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Accelerators message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Accelerators
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Accelerators.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.guestAcceleratorCount != null && message.hasOwnProperty("guestAcceleratorCount")) {
                                properties._guestAcceleratorCount = 1;
                                if (!$util.isInteger(message.guestAcceleratorCount))
                                    return "guestAcceleratorCount: integer expected";
                            }
                            if (message.guestAcceleratorType != null && message.hasOwnProperty("guestAcceleratorType")) {
                                properties._guestAcceleratorType = 1;
                                if (!$util.isString(message.guestAcceleratorType))
                                    return "guestAcceleratorType: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an Accelerators message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Accelerators
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Accelerators} Accelerators
                         */
                        Accelerators.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Accelerators)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Accelerators();
                            if (object.guestAcceleratorCount != null)
                                message.guestAcceleratorCount = object.guestAcceleratorCount | 0;
                            if (object.guestAcceleratorType != null)
                                message.guestAcceleratorType = String(object.guestAcceleratorType);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Accelerators message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Accelerators
                         * @static
                         * @param {google.cloud.compute.v1.Accelerators} message Accelerators
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Accelerators.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.guestAcceleratorType != null && message.hasOwnProperty("guestAcceleratorType")) {
                                object.guestAcceleratorType = message.guestAcceleratorType;
                                if (options.oneofs)
                                    object._guestAcceleratorType = "guestAcceleratorType";
                            }
                            if (message.guestAcceleratorCount != null && message.hasOwnProperty("guestAcceleratorCount")) {
                                object.guestAcceleratorCount = message.guestAcceleratorCount;
                                if (options.oneofs)
                                    object._guestAcceleratorCount = "guestAcceleratorCount";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Accelerators to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Accelerators
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Accelerators.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Accelerators
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Accelerators
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Accelerators.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Accelerators";
                        };
    
                        return Accelerators;
                    })();
    
                    v1.AccessConfig = (function() {
    
                        /**
                         * Properties of an AccessConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface IAccessConfig
                         * @property {string|null} [externalIpv6] AccessConfig externalIpv6
                         * @property {number|null} [externalIpv6PrefixLength] AccessConfig externalIpv6PrefixLength
                         * @property {string|null} [kind] AccessConfig kind
                         * @property {string|null} [name] AccessConfig name
                         * @property {string|null} [natIP] AccessConfig natIP
                         * @property {string|null} [networkTier] AccessConfig networkTier
                         * @property {string|null} [publicPtrDomainName] AccessConfig publicPtrDomainName
                         * @property {boolean|null} [setPublicPtr] AccessConfig setPublicPtr
                         * @property {string|null} [type] AccessConfig type
                         */
    
                        /**
                         * Constructs a new AccessConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AccessConfig.
                         * @implements IAccessConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.IAccessConfig=} [properties] Properties to set
                         */
                        function AccessConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AccessConfig externalIpv6.
                         * @member {string|null|undefined} externalIpv6
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @instance
                         */
                        AccessConfig.prototype.externalIpv6 = null;
    
                        /**
                         * AccessConfig externalIpv6PrefixLength.
                         * @member {number|null|undefined} externalIpv6PrefixLength
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @instance
                         */
                        AccessConfig.prototype.externalIpv6PrefixLength = null;
    
                        /**
                         * AccessConfig kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @instance
                         */
                        AccessConfig.prototype.kind = null;
    
                        /**
                         * AccessConfig name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @instance
                         */
                        AccessConfig.prototype.name = null;
    
                        /**
                         * AccessConfig natIP.
                         * @member {string|null|undefined} natIP
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @instance
                         */
                        AccessConfig.prototype.natIP = null;
    
                        /**
                         * AccessConfig networkTier.
                         * @member {string|null|undefined} networkTier
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @instance
                         */
                        AccessConfig.prototype.networkTier = null;
    
                        /**
                         * AccessConfig publicPtrDomainName.
                         * @member {string|null|undefined} publicPtrDomainName
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @instance
                         */
                        AccessConfig.prototype.publicPtrDomainName = null;
    
                        /**
                         * AccessConfig setPublicPtr.
                         * @member {boolean|null|undefined} setPublicPtr
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @instance
                         */
                        AccessConfig.prototype.setPublicPtr = null;
    
                        /**
                         * AccessConfig type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @instance
                         */
                        AccessConfig.prototype.type = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AccessConfig _externalIpv6.
                         * @member {"externalIpv6"|undefined} _externalIpv6
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @instance
                         */
                        Object.defineProperty(AccessConfig.prototype, "_externalIpv6", {
                            get: $util.oneOfGetter($oneOfFields = ["externalIpv6"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AccessConfig _externalIpv6PrefixLength.
                         * @member {"externalIpv6PrefixLength"|undefined} _externalIpv6PrefixLength
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @instance
                         */
                        Object.defineProperty(AccessConfig.prototype, "_externalIpv6PrefixLength", {
                            get: $util.oneOfGetter($oneOfFields = ["externalIpv6PrefixLength"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AccessConfig _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @instance
                         */
                        Object.defineProperty(AccessConfig.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AccessConfig _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @instance
                         */
                        Object.defineProperty(AccessConfig.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AccessConfig _natIP.
                         * @member {"natIP"|undefined} _natIP
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @instance
                         */
                        Object.defineProperty(AccessConfig.prototype, "_natIP", {
                            get: $util.oneOfGetter($oneOfFields = ["natIP"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AccessConfig _networkTier.
                         * @member {"networkTier"|undefined} _networkTier
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @instance
                         */
                        Object.defineProperty(AccessConfig.prototype, "_networkTier", {
                            get: $util.oneOfGetter($oneOfFields = ["networkTier"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AccessConfig _publicPtrDomainName.
                         * @member {"publicPtrDomainName"|undefined} _publicPtrDomainName
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @instance
                         */
                        Object.defineProperty(AccessConfig.prototype, "_publicPtrDomainName", {
                            get: $util.oneOfGetter($oneOfFields = ["publicPtrDomainName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AccessConfig _setPublicPtr.
                         * @member {"setPublicPtr"|undefined} _setPublicPtr
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @instance
                         */
                        Object.defineProperty(AccessConfig.prototype, "_setPublicPtr", {
                            get: $util.oneOfGetter($oneOfFields = ["setPublicPtr"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AccessConfig _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @instance
                         */
                        Object.defineProperty(AccessConfig.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AccessConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @static
                         * @param {google.cloud.compute.v1.IAccessConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AccessConfig} AccessConfig instance
                         */
                        AccessConfig.create = function create(properties) {
                            return new AccessConfig(properties);
                        };
    
                        /**
                         * Encodes the specified AccessConfig message. Does not implicitly {@link google.cloud.compute.v1.AccessConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @static
                         * @param {google.cloud.compute.v1.IAccessConfig} message AccessConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            if (message.natIP != null && Object.hasOwnProperty.call(message, "natIP"))
                                writer.uint32(/* id 117634556, wireType 2 =*/941076450).string(message.natIP);
                            if (message.publicPtrDomainName != null && Object.hasOwnProperty.call(message, "publicPtrDomainName"))
                                writer.uint32(/* id 316599167, wireType 2 =*/2532793338).string(message.publicPtrDomainName);
                            if (message.externalIpv6PrefixLength != null && Object.hasOwnProperty.call(message, "externalIpv6PrefixLength"))
                                writer.uint32(/* id 425672143, wireType 0 =*/3405377144).int32(message.externalIpv6PrefixLength);
                            if (message.networkTier != null && Object.hasOwnProperty.call(message, "networkTier"))
                                writer.uint32(/* id 517397843, wireType 2 =*/4139182746).string(message.networkTier);
                            if (message.setPublicPtr != null && Object.hasOwnProperty.call(message, "setPublicPtr"))
                                writer.uint32(/* id 523870229, wireType 0 =*/4190961832).bool(message.setPublicPtr);
                            if (message.externalIpv6 != null && Object.hasOwnProperty.call(message, "externalIpv6"))
                                writer.uint32(/* id 532703707, wireType 2 =*/4261629658).string(message.externalIpv6);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AccessConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AccessConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @static
                         * @param {google.cloud.compute.v1.IAccessConfig} message AccessConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AccessConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AccessConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AccessConfig} AccessConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AccessConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 532703707: {
                                        message.externalIpv6 = reader.string();
                                        break;
                                    }
                                case 425672143: {
                                        message.externalIpv6PrefixLength = reader.int32();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 117634556: {
                                        message.natIP = reader.string();
                                        break;
                                    }
                                case 517397843: {
                                        message.networkTier = reader.string();
                                        break;
                                    }
                                case 316599167: {
                                        message.publicPtrDomainName = reader.string();
                                        break;
                                    }
                                case 523870229: {
                                        message.setPublicPtr = reader.bool();
                                        break;
                                    }
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AccessConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AccessConfig} AccessConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AccessConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AccessConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AccessConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.externalIpv6 != null && message.hasOwnProperty("externalIpv6")) {
                                properties._externalIpv6 = 1;
                                if (!$util.isString(message.externalIpv6))
                                    return "externalIpv6: string expected";
                            }
                            if (message.externalIpv6PrefixLength != null && message.hasOwnProperty("externalIpv6PrefixLength")) {
                                properties._externalIpv6PrefixLength = 1;
                                if (!$util.isInteger(message.externalIpv6PrefixLength))
                                    return "externalIpv6PrefixLength: integer expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.natIP != null && message.hasOwnProperty("natIP")) {
                                properties._natIP = 1;
                                if (!$util.isString(message.natIP))
                                    return "natIP: string expected";
                            }
                            if (message.networkTier != null && message.hasOwnProperty("networkTier")) {
                                properties._networkTier = 1;
                                if (!$util.isString(message.networkTier))
                                    return "networkTier: string expected";
                            }
                            if (message.publicPtrDomainName != null && message.hasOwnProperty("publicPtrDomainName")) {
                                properties._publicPtrDomainName = 1;
                                if (!$util.isString(message.publicPtrDomainName))
                                    return "publicPtrDomainName: string expected";
                            }
                            if (message.setPublicPtr != null && message.hasOwnProperty("setPublicPtr")) {
                                properties._setPublicPtr = 1;
                                if (typeof message.setPublicPtr !== "boolean")
                                    return "setPublicPtr: boolean expected";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AccessConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AccessConfig} AccessConfig
                         */
                        AccessConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AccessConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AccessConfig();
                            if (object.externalIpv6 != null)
                                message.externalIpv6 = String(object.externalIpv6);
                            if (object.externalIpv6PrefixLength != null)
                                message.externalIpv6PrefixLength = object.externalIpv6PrefixLength | 0;
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.natIP != null)
                                message.natIP = String(object.natIP);
                            if (object.networkTier != null)
                                message.networkTier = String(object.networkTier);
                            if (object.publicPtrDomainName != null)
                                message.publicPtrDomainName = String(object.publicPtrDomainName);
                            if (object.setPublicPtr != null)
                                message.setPublicPtr = Boolean(object.setPublicPtr);
                            if (object.type != null)
                                message.type = String(object.type);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AccessConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @static
                         * @param {google.cloud.compute.v1.AccessConfig} message AccessConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AccessConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            if (message.natIP != null && message.hasOwnProperty("natIP")) {
                                object.natIP = message.natIP;
                                if (options.oneofs)
                                    object._natIP = "natIP";
                            }
                            if (message.publicPtrDomainName != null && message.hasOwnProperty("publicPtrDomainName")) {
                                object.publicPtrDomainName = message.publicPtrDomainName;
                                if (options.oneofs)
                                    object._publicPtrDomainName = "publicPtrDomainName";
                            }
                            if (message.externalIpv6PrefixLength != null && message.hasOwnProperty("externalIpv6PrefixLength")) {
                                object.externalIpv6PrefixLength = message.externalIpv6PrefixLength;
                                if (options.oneofs)
                                    object._externalIpv6PrefixLength = "externalIpv6PrefixLength";
                            }
                            if (message.networkTier != null && message.hasOwnProperty("networkTier")) {
                                object.networkTier = message.networkTier;
                                if (options.oneofs)
                                    object._networkTier = "networkTier";
                            }
                            if (message.setPublicPtr != null && message.hasOwnProperty("setPublicPtr")) {
                                object.setPublicPtr = message.setPublicPtr;
                                if (options.oneofs)
                                    object._setPublicPtr = "setPublicPtr";
                            }
                            if (message.externalIpv6 != null && message.hasOwnProperty("externalIpv6")) {
                                object.externalIpv6 = message.externalIpv6;
                                if (options.oneofs)
                                    object._externalIpv6 = "externalIpv6";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AccessConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AccessConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AccessConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AccessConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AccessConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AccessConfig";
                        };
    
                        /**
                         * NetworkTier enum.
                         * @name google.cloud.compute.v1.AccessConfig.NetworkTier
                         * @enum {number}
                         * @property {number} UNDEFINED_NETWORK_TIER=0 UNDEFINED_NETWORK_TIER value
                         * @property {number} FIXED_STANDARD=310464328 FIXED_STANDARD value
                         * @property {number} PREMIUM=399530551 PREMIUM value
                         * @property {number} STANDARD=484642493 STANDARD value
                         * @property {number} STANDARD_OVERRIDES_FIXED_STANDARD=465847234 STANDARD_OVERRIDES_FIXED_STANDARD value
                         */
                        AccessConfig.NetworkTier = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_NETWORK_TIER"] = 0;
                            values[valuesById[310464328] = "FIXED_STANDARD"] = 310464328;
                            values[valuesById[399530551] = "PREMIUM"] = 399530551;
                            values[valuesById[484642493] = "STANDARD"] = 484642493;
                            values[valuesById[465847234] = "STANDARD_OVERRIDES_FIXED_STANDARD"] = 465847234;
                            return values;
                        })();
    
                        /**
                         * Type enum.
                         * @name google.cloud.compute.v1.AccessConfig.Type
                         * @enum {number}
                         * @property {number} UNDEFINED_TYPE=0 UNDEFINED_TYPE value
                         * @property {number} DIRECT_IPV6=4397213 DIRECT_IPV6 value
                         * @property {number} ONE_TO_ONE_NAT=84090205 ONE_TO_ONE_NAT value
                         */
                        AccessConfig.Type = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TYPE"] = 0;
                            values[valuesById[4397213] = "DIRECT_IPV6"] = 4397213;
                            values[valuesById[84090205] = "ONE_TO_ONE_NAT"] = 84090205;
                            return values;
                        })();
    
                        return AccessConfig;
                    })();
    
                    v1.AddAccessConfigInstanceRequest = (function() {
    
                        /**
                         * Properties of an AddAccessConfigInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddAccessConfigInstanceRequest
                         * @property {google.cloud.compute.v1.IAccessConfig|null} [accessConfigResource] AddAccessConfigInstanceRequest accessConfigResource
                         * @property {string|null} [instance] AddAccessConfigInstanceRequest instance
                         * @property {string|null} [networkInterface] AddAccessConfigInstanceRequest networkInterface
                         * @property {string|null} [project] AddAccessConfigInstanceRequest project
                         * @property {string|null} [requestId] AddAccessConfigInstanceRequest requestId
                         * @property {string|null} [zone] AddAccessConfigInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new AddAccessConfigInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddAccessConfigInstanceRequest.
                         * @implements IAddAccessConfigInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddAccessConfigInstanceRequest=} [properties] Properties to set
                         */
                        function AddAccessConfigInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddAccessConfigInstanceRequest accessConfigResource.
                         * @member {google.cloud.compute.v1.IAccessConfig|null|undefined} accessConfigResource
                         * @memberof google.cloud.compute.v1.AddAccessConfigInstanceRequest
                         * @instance
                         */
                        AddAccessConfigInstanceRequest.prototype.accessConfigResource = null;
    
                        /**
                         * AddAccessConfigInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.AddAccessConfigInstanceRequest
                         * @instance
                         */
                        AddAccessConfigInstanceRequest.prototype.instance = "";
    
                        /**
                         * AddAccessConfigInstanceRequest networkInterface.
                         * @member {string} networkInterface
                         * @memberof google.cloud.compute.v1.AddAccessConfigInstanceRequest
                         * @instance
                         */
                        AddAccessConfigInstanceRequest.prototype.networkInterface = "";
    
                        /**
                         * AddAccessConfigInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AddAccessConfigInstanceRequest
                         * @instance
                         */
                        AddAccessConfigInstanceRequest.prototype.project = "";
    
                        /**
                         * AddAccessConfigInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AddAccessConfigInstanceRequest
                         * @instance
                         */
                        AddAccessConfigInstanceRequest.prototype.requestId = null;
    
                        /**
                         * AddAccessConfigInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.AddAccessConfigInstanceRequest
                         * @instance
                         */
                        AddAccessConfigInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddAccessConfigInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AddAccessConfigInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(AddAccessConfigInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddAccessConfigInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddAccessConfigInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddAccessConfigInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddAccessConfigInstanceRequest} AddAccessConfigInstanceRequest instance
                         */
                        AddAccessConfigInstanceRequest.create = function create(properties) {
                            return new AddAccessConfigInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AddAccessConfigInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.AddAccessConfigInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddAccessConfigInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddAccessConfigInstanceRequest} message AddAccessConfigInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddAccessConfigInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.networkInterface != null && Object.hasOwnProperty.call(message, "networkInterface"))
                                writer.uint32(/* id 365387880, wireType 2 =*/2923103042).string(message.networkInterface);
                            if (message.accessConfigResource != null && Object.hasOwnProperty.call(message, "accessConfigResource"))
                                $root.google.cloud.compute.v1.AccessConfig.encode(message.accessConfigResource, writer.uint32(/* id 387825552, wireType 2 =*/3102604418).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddAccessConfigInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddAccessConfigInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddAccessConfigInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddAccessConfigInstanceRequest} message AddAccessConfigInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddAccessConfigInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddAccessConfigInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddAccessConfigInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddAccessConfigInstanceRequest} AddAccessConfigInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddAccessConfigInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddAccessConfigInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 387825552: {
                                        message.accessConfigResource = $root.google.cloud.compute.v1.AccessConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 365387880: {
                                        message.networkInterface = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddAccessConfigInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddAccessConfigInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddAccessConfigInstanceRequest} AddAccessConfigInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddAccessConfigInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddAccessConfigInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddAccessConfigInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddAccessConfigInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.accessConfigResource != null && message.hasOwnProperty("accessConfigResource")) {
                                var error = $root.google.cloud.compute.v1.AccessConfig.verify(message.accessConfigResource);
                                if (error)
                                    return "accessConfigResource." + error;
                            }
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.networkInterface != null && message.hasOwnProperty("networkInterface"))
                                if (!$util.isString(message.networkInterface))
                                    return "networkInterface: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AddAccessConfigInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddAccessConfigInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddAccessConfigInstanceRequest} AddAccessConfigInstanceRequest
                         */
                        AddAccessConfigInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddAccessConfigInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddAccessConfigInstanceRequest();
                            if (object.accessConfigResource != null) {
                                if (typeof object.accessConfigResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddAccessConfigInstanceRequest.accessConfigResource: object expected");
                                message.accessConfigResource = $root.google.cloud.compute.v1.AccessConfig.fromObject(object.accessConfigResource);
                            }
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.networkInterface != null)
                                message.networkInterface = String(object.networkInterface);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddAccessConfigInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddAccessConfigInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.AddAccessConfigInstanceRequest} message AddAccessConfigInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddAccessConfigInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                                object.networkInterface = "";
                                object.accessConfigResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.networkInterface != null && message.hasOwnProperty("networkInterface"))
                                object.networkInterface = message.networkInterface;
                            if (message.accessConfigResource != null && message.hasOwnProperty("accessConfigResource"))
                                object.accessConfigResource = $root.google.cloud.compute.v1.AccessConfig.toObject(message.accessConfigResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this AddAccessConfigInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddAccessConfigInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddAccessConfigInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddAccessConfigInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddAccessConfigInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddAccessConfigInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddAccessConfigInstanceRequest";
                        };
    
                        return AddAccessConfigInstanceRequest;
                    })();
    
                    v1.AddAssociationFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of an AddAssociationFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddAssociationFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] AddAssociationFirewallPolicyRequest firewallPolicy
                         * @property {google.cloud.compute.v1.IFirewallPolicyAssociation|null} [firewallPolicyAssociationResource] AddAssociationFirewallPolicyRequest firewallPolicyAssociationResource
                         * @property {boolean|null} [replaceExistingAssociation] AddAssociationFirewallPolicyRequest replaceExistingAssociation
                         * @property {string|null} [requestId] AddAssociationFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new AddAssociationFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddAssociationFirewallPolicyRequest.
                         * @implements IAddAssociationFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddAssociationFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function AddAssociationFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddAssociationFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.AddAssociationFirewallPolicyRequest
                         * @instance
                         */
                        AddAssociationFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * AddAssociationFirewallPolicyRequest firewallPolicyAssociationResource.
                         * @member {google.cloud.compute.v1.IFirewallPolicyAssociation|null|undefined} firewallPolicyAssociationResource
                         * @memberof google.cloud.compute.v1.AddAssociationFirewallPolicyRequest
                         * @instance
                         */
                        AddAssociationFirewallPolicyRequest.prototype.firewallPolicyAssociationResource = null;
    
                        /**
                         * AddAssociationFirewallPolicyRequest replaceExistingAssociation.
                         * @member {boolean|null|undefined} replaceExistingAssociation
                         * @memberof google.cloud.compute.v1.AddAssociationFirewallPolicyRequest
                         * @instance
                         */
                        AddAssociationFirewallPolicyRequest.prototype.replaceExistingAssociation = null;
    
                        /**
                         * AddAssociationFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AddAssociationFirewallPolicyRequest
                         * @instance
                         */
                        AddAssociationFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddAssociationFirewallPolicyRequest _replaceExistingAssociation.
                         * @member {"replaceExistingAssociation"|undefined} _replaceExistingAssociation
                         * @memberof google.cloud.compute.v1.AddAssociationFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(AddAssociationFirewallPolicyRequest.prototype, "_replaceExistingAssociation", {
                            get: $util.oneOfGetter($oneOfFields = ["replaceExistingAssociation"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddAssociationFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AddAssociationFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(AddAssociationFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddAssociationFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddAssociationFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddAssociationFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddAssociationFirewallPolicyRequest} AddAssociationFirewallPolicyRequest instance
                         */
                        AddAssociationFirewallPolicyRequest.create = function create(properties) {
                            return new AddAssociationFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AddAssociationFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.AddAssociationFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddAssociationFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddAssociationFirewallPolicyRequest} message AddAssociationFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddAssociationFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.replaceExistingAssociation != null && Object.hasOwnProperty.call(message, "replaceExistingAssociation"))
                                writer.uint32(/* id 209541240, wireType 0 =*/1676329920).bool(message.replaceExistingAssociation);
                            if (message.firewallPolicyAssociationResource != null && Object.hasOwnProperty.call(message, "firewallPolicyAssociationResource"))
                                $root.google.cloud.compute.v1.FirewallPolicyAssociation.encode(message.firewallPolicyAssociationResource, writer.uint32(/* id 259546170, wireType 2 =*/2076369362).fork()).ldelim();
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddAssociationFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddAssociationFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddAssociationFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddAssociationFirewallPolicyRequest} message AddAssociationFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddAssociationFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddAssociationFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddAssociationFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddAssociationFirewallPolicyRequest} AddAssociationFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddAssociationFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddAssociationFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 259546170: {
                                        message.firewallPolicyAssociationResource = $root.google.cloud.compute.v1.FirewallPolicyAssociation.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 209541240: {
                                        message.replaceExistingAssociation = reader.bool();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddAssociationFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddAssociationFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddAssociationFirewallPolicyRequest} AddAssociationFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddAssociationFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddAssociationFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddAssociationFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddAssociationFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.firewallPolicyAssociationResource != null && message.hasOwnProperty("firewallPolicyAssociationResource")) {
                                var error = $root.google.cloud.compute.v1.FirewallPolicyAssociation.verify(message.firewallPolicyAssociationResource);
                                if (error)
                                    return "firewallPolicyAssociationResource." + error;
                            }
                            if (message.replaceExistingAssociation != null && message.hasOwnProperty("replaceExistingAssociation")) {
                                properties._replaceExistingAssociation = 1;
                                if (typeof message.replaceExistingAssociation !== "boolean")
                                    return "replaceExistingAssociation: boolean expected";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AddAssociationFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddAssociationFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddAssociationFirewallPolicyRequest} AddAssociationFirewallPolicyRequest
                         */
                        AddAssociationFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddAssociationFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddAssociationFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.firewallPolicyAssociationResource != null) {
                                if (typeof object.firewallPolicyAssociationResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddAssociationFirewallPolicyRequest.firewallPolicyAssociationResource: object expected");
                                message.firewallPolicyAssociationResource = $root.google.cloud.compute.v1.FirewallPolicyAssociation.fromObject(object.firewallPolicyAssociationResource);
                            }
                            if (object.replaceExistingAssociation != null)
                                message.replaceExistingAssociation = Boolean(object.replaceExistingAssociation);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddAssociationFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddAssociationFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.AddAssociationFirewallPolicyRequest} message AddAssociationFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddAssociationFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.firewallPolicyAssociationResource = null;
                                object.firewallPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.replaceExistingAssociation != null && message.hasOwnProperty("replaceExistingAssociation")) {
                                object.replaceExistingAssociation = message.replaceExistingAssociation;
                                if (options.oneofs)
                                    object._replaceExistingAssociation = "replaceExistingAssociation";
                            }
                            if (message.firewallPolicyAssociationResource != null && message.hasOwnProperty("firewallPolicyAssociationResource"))
                                object.firewallPolicyAssociationResource = $root.google.cloud.compute.v1.FirewallPolicyAssociation.toObject(message.firewallPolicyAssociationResource, options);
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this AddAssociationFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddAssociationFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddAssociationFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddAssociationFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddAssociationFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddAssociationFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddAssociationFirewallPolicyRequest";
                        };
    
                        return AddAssociationFirewallPolicyRequest;
                    })();
    
                    v1.AddAssociationNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of an AddAssociationNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddAssociationNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] AddAssociationNetworkFirewallPolicyRequest firewallPolicy
                         * @property {google.cloud.compute.v1.IFirewallPolicyAssociation|null} [firewallPolicyAssociationResource] AddAssociationNetworkFirewallPolicyRequest firewallPolicyAssociationResource
                         * @property {string|null} [project] AddAssociationNetworkFirewallPolicyRequest project
                         * @property {boolean|null} [replaceExistingAssociation] AddAssociationNetworkFirewallPolicyRequest replaceExistingAssociation
                         * @property {string|null} [requestId] AddAssociationNetworkFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new AddAssociationNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddAssociationNetworkFirewallPolicyRequest.
                         * @implements IAddAssociationNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddAssociationNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function AddAssociationNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddAssociationNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddAssociationNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * AddAssociationNetworkFirewallPolicyRequest firewallPolicyAssociationResource.
                         * @member {google.cloud.compute.v1.IFirewallPolicyAssociation|null|undefined} firewallPolicyAssociationResource
                         * @memberof google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddAssociationNetworkFirewallPolicyRequest.prototype.firewallPolicyAssociationResource = null;
    
                        /**
                         * AddAssociationNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddAssociationNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * AddAssociationNetworkFirewallPolicyRequest replaceExistingAssociation.
                         * @member {boolean|null|undefined} replaceExistingAssociation
                         * @memberof google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddAssociationNetworkFirewallPolicyRequest.prototype.replaceExistingAssociation = null;
    
                        /**
                         * AddAssociationNetworkFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddAssociationNetworkFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddAssociationNetworkFirewallPolicyRequest _replaceExistingAssociation.
                         * @member {"replaceExistingAssociation"|undefined} _replaceExistingAssociation
                         * @memberof google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(AddAssociationNetworkFirewallPolicyRequest.prototype, "_replaceExistingAssociation", {
                            get: $util.oneOfGetter($oneOfFields = ["replaceExistingAssociation"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddAssociationNetworkFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(AddAssociationNetworkFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddAssociationNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddAssociationNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest} AddAssociationNetworkFirewallPolicyRequest instance
                         */
                        AddAssociationNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new AddAssociationNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AddAssociationNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddAssociationNetworkFirewallPolicyRequest} message AddAssociationNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddAssociationNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.replaceExistingAssociation != null && Object.hasOwnProperty.call(message, "replaceExistingAssociation"))
                                writer.uint32(/* id 209541240, wireType 0 =*/1676329920).bool(message.replaceExistingAssociation);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewallPolicyAssociationResource != null && Object.hasOwnProperty.call(message, "firewallPolicyAssociationResource"))
                                $root.google.cloud.compute.v1.FirewallPolicyAssociation.encode(message.firewallPolicyAssociationResource, writer.uint32(/* id 259546170, wireType 2 =*/2076369362).fork()).ldelim();
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddAssociationNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddAssociationNetworkFirewallPolicyRequest} message AddAssociationNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddAssociationNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddAssociationNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest} AddAssociationNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddAssociationNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 259546170: {
                                        message.firewallPolicyAssociationResource = $root.google.cloud.compute.v1.FirewallPolicyAssociation.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 209541240: {
                                        message.replaceExistingAssociation = reader.bool();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddAssociationNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest} AddAssociationNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddAssociationNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddAssociationNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddAssociationNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.firewallPolicyAssociationResource != null && message.hasOwnProperty("firewallPolicyAssociationResource")) {
                                var error = $root.google.cloud.compute.v1.FirewallPolicyAssociation.verify(message.firewallPolicyAssociationResource);
                                if (error)
                                    return "firewallPolicyAssociationResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.replaceExistingAssociation != null && message.hasOwnProperty("replaceExistingAssociation")) {
                                properties._replaceExistingAssociation = 1;
                                if (typeof message.replaceExistingAssociation !== "boolean")
                                    return "replaceExistingAssociation: boolean expected";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AddAssociationNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest} AddAssociationNetworkFirewallPolicyRequest
                         */
                        AddAssociationNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.firewallPolicyAssociationResource != null) {
                                if (typeof object.firewallPolicyAssociationResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest.firewallPolicyAssociationResource: object expected");
                                message.firewallPolicyAssociationResource = $root.google.cloud.compute.v1.FirewallPolicyAssociation.fromObject(object.firewallPolicyAssociationResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.replaceExistingAssociation != null)
                                message.replaceExistingAssociation = Boolean(object.replaceExistingAssociation);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddAssociationNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest} message AddAssociationNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddAssociationNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.firewallPolicyAssociationResource = null;
                                object.firewallPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.replaceExistingAssociation != null && message.hasOwnProperty("replaceExistingAssociation")) {
                                object.replaceExistingAssociation = message.replaceExistingAssociation;
                                if (options.oneofs)
                                    object._replaceExistingAssociation = "replaceExistingAssociation";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewallPolicyAssociationResource != null && message.hasOwnProperty("firewallPolicyAssociationResource"))
                                object.firewallPolicyAssociationResource = $root.google.cloud.compute.v1.FirewallPolicyAssociation.toObject(message.firewallPolicyAssociationResource, options);
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this AddAssociationNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddAssociationNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddAssociationNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddAssociationNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest";
                        };
    
                        return AddAssociationNetworkFirewallPolicyRequest;
                    })();
    
                    v1.AddAssociationRegionNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of an AddAssociationRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddAssociationRegionNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] AddAssociationRegionNetworkFirewallPolicyRequest firewallPolicy
                         * @property {google.cloud.compute.v1.IFirewallPolicyAssociation|null} [firewallPolicyAssociationResource] AddAssociationRegionNetworkFirewallPolicyRequest firewallPolicyAssociationResource
                         * @property {string|null} [project] AddAssociationRegionNetworkFirewallPolicyRequest project
                         * @property {string|null} [region] AddAssociationRegionNetworkFirewallPolicyRequest region
                         * @property {boolean|null} [replaceExistingAssociation] AddAssociationRegionNetworkFirewallPolicyRequest replaceExistingAssociation
                         * @property {string|null} [requestId] AddAssociationRegionNetworkFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new AddAssociationRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddAssociationRegionNetworkFirewallPolicyRequest.
                         * @implements IAddAssociationRegionNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddAssociationRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function AddAssociationRegionNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddAssociationRegionNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddAssociationRegionNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * AddAssociationRegionNetworkFirewallPolicyRequest firewallPolicyAssociationResource.
                         * @member {google.cloud.compute.v1.IFirewallPolicyAssociation|null|undefined} firewallPolicyAssociationResource
                         * @memberof google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddAssociationRegionNetworkFirewallPolicyRequest.prototype.firewallPolicyAssociationResource = null;
    
                        /**
                         * AddAssociationRegionNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddAssociationRegionNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * AddAssociationRegionNetworkFirewallPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddAssociationRegionNetworkFirewallPolicyRequest.prototype.region = "";
    
                        /**
                         * AddAssociationRegionNetworkFirewallPolicyRequest replaceExistingAssociation.
                         * @member {boolean|null|undefined} replaceExistingAssociation
                         * @memberof google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddAssociationRegionNetworkFirewallPolicyRequest.prototype.replaceExistingAssociation = null;
    
                        /**
                         * AddAssociationRegionNetworkFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddAssociationRegionNetworkFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddAssociationRegionNetworkFirewallPolicyRequest _replaceExistingAssociation.
                         * @member {"replaceExistingAssociation"|undefined} _replaceExistingAssociation
                         * @memberof google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(AddAssociationRegionNetworkFirewallPolicyRequest.prototype, "_replaceExistingAssociation", {
                            get: $util.oneOfGetter($oneOfFields = ["replaceExistingAssociation"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddAssociationRegionNetworkFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(AddAssociationRegionNetworkFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddAssociationRegionNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddAssociationRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest} AddAssociationRegionNetworkFirewallPolicyRequest instance
                         */
                        AddAssociationRegionNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new AddAssociationRegionNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AddAssociationRegionNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddAssociationRegionNetworkFirewallPolicyRequest} message AddAssociationRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddAssociationRegionNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.replaceExistingAssociation != null && Object.hasOwnProperty.call(message, "replaceExistingAssociation"))
                                writer.uint32(/* id 209541240, wireType 0 =*/1676329920).bool(message.replaceExistingAssociation);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewallPolicyAssociationResource != null && Object.hasOwnProperty.call(message, "firewallPolicyAssociationResource"))
                                $root.google.cloud.compute.v1.FirewallPolicyAssociation.encode(message.firewallPolicyAssociationResource, writer.uint32(/* id 259546170, wireType 2 =*/2076369362).fork()).ldelim();
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddAssociationRegionNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddAssociationRegionNetworkFirewallPolicyRequest} message AddAssociationRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddAssociationRegionNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddAssociationRegionNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest} AddAssociationRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddAssociationRegionNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 259546170: {
                                        message.firewallPolicyAssociationResource = $root.google.cloud.compute.v1.FirewallPolicyAssociation.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 209541240: {
                                        message.replaceExistingAssociation = reader.bool();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddAssociationRegionNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest} AddAssociationRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddAssociationRegionNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddAssociationRegionNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddAssociationRegionNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.firewallPolicyAssociationResource != null && message.hasOwnProperty("firewallPolicyAssociationResource")) {
                                var error = $root.google.cloud.compute.v1.FirewallPolicyAssociation.verify(message.firewallPolicyAssociationResource);
                                if (error)
                                    return "firewallPolicyAssociationResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.replaceExistingAssociation != null && message.hasOwnProperty("replaceExistingAssociation")) {
                                properties._replaceExistingAssociation = 1;
                                if (typeof message.replaceExistingAssociation !== "boolean")
                                    return "replaceExistingAssociation: boolean expected";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AddAssociationRegionNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest} AddAssociationRegionNetworkFirewallPolicyRequest
                         */
                        AddAssociationRegionNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.firewallPolicyAssociationResource != null) {
                                if (typeof object.firewallPolicyAssociationResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest.firewallPolicyAssociationResource: object expected");
                                message.firewallPolicyAssociationResource = $root.google.cloud.compute.v1.FirewallPolicyAssociation.fromObject(object.firewallPolicyAssociationResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.replaceExistingAssociation != null)
                                message.replaceExistingAssociation = Boolean(object.replaceExistingAssociation);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddAssociationRegionNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest} message AddAssociationRegionNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddAssociationRegionNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.firewallPolicyAssociationResource = null;
                                object.firewallPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.replaceExistingAssociation != null && message.hasOwnProperty("replaceExistingAssociation")) {
                                object.replaceExistingAssociation = message.replaceExistingAssociation;
                                if (options.oneofs)
                                    object._replaceExistingAssociation = "replaceExistingAssociation";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewallPolicyAssociationResource != null && message.hasOwnProperty("firewallPolicyAssociationResource"))
                                object.firewallPolicyAssociationResource = $root.google.cloud.compute.v1.FirewallPolicyAssociation.toObject(message.firewallPolicyAssociationResource, options);
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this AddAssociationRegionNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddAssociationRegionNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddAssociationRegionNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddAssociationRegionNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest";
                        };
    
                        return AddAssociationRegionNetworkFirewallPolicyRequest;
                    })();
    
                    v1.AddHealthCheckTargetPoolRequest = (function() {
    
                        /**
                         * Properties of an AddHealthCheckTargetPoolRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddHealthCheckTargetPoolRequest
                         * @property {string|null} [project] AddHealthCheckTargetPoolRequest project
                         * @property {string|null} [region] AddHealthCheckTargetPoolRequest region
                         * @property {string|null} [requestId] AddHealthCheckTargetPoolRequest requestId
                         * @property {string|null} [targetPool] AddHealthCheckTargetPoolRequest targetPool
                         * @property {google.cloud.compute.v1.ITargetPoolsAddHealthCheckRequest|null} [targetPoolsAddHealthCheckRequestResource] AddHealthCheckTargetPoolRequest targetPoolsAddHealthCheckRequestResource
                         */
    
                        /**
                         * Constructs a new AddHealthCheckTargetPoolRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddHealthCheckTargetPoolRequest.
                         * @implements IAddHealthCheckTargetPoolRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddHealthCheckTargetPoolRequest=} [properties] Properties to set
                         */
                        function AddHealthCheckTargetPoolRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddHealthCheckTargetPoolRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AddHealthCheckTargetPoolRequest
                         * @instance
                         */
                        AddHealthCheckTargetPoolRequest.prototype.project = "";
    
                        /**
                         * AddHealthCheckTargetPoolRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.AddHealthCheckTargetPoolRequest
                         * @instance
                         */
                        AddHealthCheckTargetPoolRequest.prototype.region = "";
    
                        /**
                         * AddHealthCheckTargetPoolRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AddHealthCheckTargetPoolRequest
                         * @instance
                         */
                        AddHealthCheckTargetPoolRequest.prototype.requestId = null;
    
                        /**
                         * AddHealthCheckTargetPoolRequest targetPool.
                         * @member {string} targetPool
                         * @memberof google.cloud.compute.v1.AddHealthCheckTargetPoolRequest
                         * @instance
                         */
                        AddHealthCheckTargetPoolRequest.prototype.targetPool = "";
    
                        /**
                         * AddHealthCheckTargetPoolRequest targetPoolsAddHealthCheckRequestResource.
                         * @member {google.cloud.compute.v1.ITargetPoolsAddHealthCheckRequest|null|undefined} targetPoolsAddHealthCheckRequestResource
                         * @memberof google.cloud.compute.v1.AddHealthCheckTargetPoolRequest
                         * @instance
                         */
                        AddHealthCheckTargetPoolRequest.prototype.targetPoolsAddHealthCheckRequestResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddHealthCheckTargetPoolRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AddHealthCheckTargetPoolRequest
                         * @instance
                         */
                        Object.defineProperty(AddHealthCheckTargetPoolRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddHealthCheckTargetPoolRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddHealthCheckTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddHealthCheckTargetPoolRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddHealthCheckTargetPoolRequest} AddHealthCheckTargetPoolRequest instance
                         */
                        AddHealthCheckTargetPoolRequest.create = function create(properties) {
                            return new AddHealthCheckTargetPoolRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AddHealthCheckTargetPoolRequest message. Does not implicitly {@link google.cloud.compute.v1.AddHealthCheckTargetPoolRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddHealthCheckTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddHealthCheckTargetPoolRequest} message AddHealthCheckTargetPoolRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddHealthCheckTargetPoolRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetPool != null && Object.hasOwnProperty.call(message, "targetPool"))
                                writer.uint32(/* id 62796298, wireType 2 =*/502370386).string(message.targetPool);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetPoolsAddHealthCheckRequestResource != null && Object.hasOwnProperty.call(message, "targetPoolsAddHealthCheckRequestResource"))
                                $root.google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest.encode(message.targetPoolsAddHealthCheckRequestResource, writer.uint32(/* id 269573412, wireType 2 =*/2156587298).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddHealthCheckTargetPoolRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddHealthCheckTargetPoolRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddHealthCheckTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddHealthCheckTargetPoolRequest} message AddHealthCheckTargetPoolRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddHealthCheckTargetPoolRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddHealthCheckTargetPoolRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddHealthCheckTargetPoolRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddHealthCheckTargetPoolRequest} AddHealthCheckTargetPoolRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddHealthCheckTargetPoolRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddHealthCheckTargetPoolRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 62796298: {
                                        message.targetPool = reader.string();
                                        break;
                                    }
                                case 269573412: {
                                        message.targetPoolsAddHealthCheckRequestResource = $root.google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddHealthCheckTargetPoolRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddHealthCheckTargetPoolRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddHealthCheckTargetPoolRequest} AddHealthCheckTargetPoolRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddHealthCheckTargetPoolRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddHealthCheckTargetPoolRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddHealthCheckTargetPoolRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddHealthCheckTargetPoolRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetPool != null && message.hasOwnProperty("targetPool"))
                                if (!$util.isString(message.targetPool))
                                    return "targetPool: string expected";
                            if (message.targetPoolsAddHealthCheckRequestResource != null && message.hasOwnProperty("targetPoolsAddHealthCheckRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest.verify(message.targetPoolsAddHealthCheckRequestResource);
                                if (error)
                                    return "targetPoolsAddHealthCheckRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AddHealthCheckTargetPoolRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddHealthCheckTargetPoolRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddHealthCheckTargetPoolRequest} AddHealthCheckTargetPoolRequest
                         */
                        AddHealthCheckTargetPoolRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddHealthCheckTargetPoolRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddHealthCheckTargetPoolRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetPool != null)
                                message.targetPool = String(object.targetPool);
                            if (object.targetPoolsAddHealthCheckRequestResource != null) {
                                if (typeof object.targetPoolsAddHealthCheckRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddHealthCheckTargetPoolRequest.targetPoolsAddHealthCheckRequestResource: object expected");
                                message.targetPoolsAddHealthCheckRequestResource = $root.google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest.fromObject(object.targetPoolsAddHealthCheckRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddHealthCheckTargetPoolRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddHealthCheckTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.AddHealthCheckTargetPoolRequest} message AddHealthCheckTargetPoolRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddHealthCheckTargetPoolRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetPool = "";
                                object.region = "";
                                object.project = "";
                                object.targetPoolsAddHealthCheckRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetPool != null && message.hasOwnProperty("targetPool"))
                                object.targetPool = message.targetPool;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetPoolsAddHealthCheckRequestResource != null && message.hasOwnProperty("targetPoolsAddHealthCheckRequestResource"))
                                object.targetPoolsAddHealthCheckRequestResource = $root.google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest.toObject(message.targetPoolsAddHealthCheckRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this AddHealthCheckTargetPoolRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddHealthCheckTargetPoolRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddHealthCheckTargetPoolRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddHealthCheckTargetPoolRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddHealthCheckTargetPoolRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddHealthCheckTargetPoolRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddHealthCheckTargetPoolRequest";
                        };
    
                        return AddHealthCheckTargetPoolRequest;
                    })();
    
                    v1.AddInstanceTargetPoolRequest = (function() {
    
                        /**
                         * Properties of an AddInstanceTargetPoolRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddInstanceTargetPoolRequest
                         * @property {string|null} [project] AddInstanceTargetPoolRequest project
                         * @property {string|null} [region] AddInstanceTargetPoolRequest region
                         * @property {string|null} [requestId] AddInstanceTargetPoolRequest requestId
                         * @property {string|null} [targetPool] AddInstanceTargetPoolRequest targetPool
                         * @property {google.cloud.compute.v1.ITargetPoolsAddInstanceRequest|null} [targetPoolsAddInstanceRequestResource] AddInstanceTargetPoolRequest targetPoolsAddInstanceRequestResource
                         */
    
                        /**
                         * Constructs a new AddInstanceTargetPoolRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddInstanceTargetPoolRequest.
                         * @implements IAddInstanceTargetPoolRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddInstanceTargetPoolRequest=} [properties] Properties to set
                         */
                        function AddInstanceTargetPoolRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddInstanceTargetPoolRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AddInstanceTargetPoolRequest
                         * @instance
                         */
                        AddInstanceTargetPoolRequest.prototype.project = "";
    
                        /**
                         * AddInstanceTargetPoolRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.AddInstanceTargetPoolRequest
                         * @instance
                         */
                        AddInstanceTargetPoolRequest.prototype.region = "";
    
                        /**
                         * AddInstanceTargetPoolRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AddInstanceTargetPoolRequest
                         * @instance
                         */
                        AddInstanceTargetPoolRequest.prototype.requestId = null;
    
                        /**
                         * AddInstanceTargetPoolRequest targetPool.
                         * @member {string} targetPool
                         * @memberof google.cloud.compute.v1.AddInstanceTargetPoolRequest
                         * @instance
                         */
                        AddInstanceTargetPoolRequest.prototype.targetPool = "";
    
                        /**
                         * AddInstanceTargetPoolRequest targetPoolsAddInstanceRequestResource.
                         * @member {google.cloud.compute.v1.ITargetPoolsAddInstanceRequest|null|undefined} targetPoolsAddInstanceRequestResource
                         * @memberof google.cloud.compute.v1.AddInstanceTargetPoolRequest
                         * @instance
                         */
                        AddInstanceTargetPoolRequest.prototype.targetPoolsAddInstanceRequestResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddInstanceTargetPoolRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AddInstanceTargetPoolRequest
                         * @instance
                         */
                        Object.defineProperty(AddInstanceTargetPoolRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddInstanceTargetPoolRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddInstanceTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddInstanceTargetPoolRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddInstanceTargetPoolRequest} AddInstanceTargetPoolRequest instance
                         */
                        AddInstanceTargetPoolRequest.create = function create(properties) {
                            return new AddInstanceTargetPoolRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AddInstanceTargetPoolRequest message. Does not implicitly {@link google.cloud.compute.v1.AddInstanceTargetPoolRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddInstanceTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddInstanceTargetPoolRequest} message AddInstanceTargetPoolRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddInstanceTargetPoolRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetPool != null && Object.hasOwnProperty.call(message, "targetPool"))
                                writer.uint32(/* id 62796298, wireType 2 =*/502370386).string(message.targetPool);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetPoolsAddInstanceRequestResource != null && Object.hasOwnProperty.call(message, "targetPoolsAddInstanceRequestResource"))
                                $root.google.cloud.compute.v1.TargetPoolsAddInstanceRequest.encode(message.targetPoolsAddInstanceRequestResource, writer.uint32(/* id 428796404, wireType 2 =*/3430371234).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddInstanceTargetPoolRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddInstanceTargetPoolRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddInstanceTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddInstanceTargetPoolRequest} message AddInstanceTargetPoolRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddInstanceTargetPoolRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddInstanceTargetPoolRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddInstanceTargetPoolRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddInstanceTargetPoolRequest} AddInstanceTargetPoolRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddInstanceTargetPoolRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddInstanceTargetPoolRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 62796298: {
                                        message.targetPool = reader.string();
                                        break;
                                    }
                                case 428796404: {
                                        message.targetPoolsAddInstanceRequestResource = $root.google.cloud.compute.v1.TargetPoolsAddInstanceRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddInstanceTargetPoolRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddInstanceTargetPoolRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddInstanceTargetPoolRequest} AddInstanceTargetPoolRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddInstanceTargetPoolRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddInstanceTargetPoolRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddInstanceTargetPoolRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddInstanceTargetPoolRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetPool != null && message.hasOwnProperty("targetPool"))
                                if (!$util.isString(message.targetPool))
                                    return "targetPool: string expected";
                            if (message.targetPoolsAddInstanceRequestResource != null && message.hasOwnProperty("targetPoolsAddInstanceRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TargetPoolsAddInstanceRequest.verify(message.targetPoolsAddInstanceRequestResource);
                                if (error)
                                    return "targetPoolsAddInstanceRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AddInstanceTargetPoolRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddInstanceTargetPoolRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddInstanceTargetPoolRequest} AddInstanceTargetPoolRequest
                         */
                        AddInstanceTargetPoolRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddInstanceTargetPoolRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddInstanceTargetPoolRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetPool != null)
                                message.targetPool = String(object.targetPool);
                            if (object.targetPoolsAddInstanceRequestResource != null) {
                                if (typeof object.targetPoolsAddInstanceRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddInstanceTargetPoolRequest.targetPoolsAddInstanceRequestResource: object expected");
                                message.targetPoolsAddInstanceRequestResource = $root.google.cloud.compute.v1.TargetPoolsAddInstanceRequest.fromObject(object.targetPoolsAddInstanceRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddInstanceTargetPoolRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddInstanceTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.AddInstanceTargetPoolRequest} message AddInstanceTargetPoolRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddInstanceTargetPoolRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetPool = "";
                                object.region = "";
                                object.project = "";
                                object.targetPoolsAddInstanceRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetPool != null && message.hasOwnProperty("targetPool"))
                                object.targetPool = message.targetPool;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetPoolsAddInstanceRequestResource != null && message.hasOwnProperty("targetPoolsAddInstanceRequestResource"))
                                object.targetPoolsAddInstanceRequestResource = $root.google.cloud.compute.v1.TargetPoolsAddInstanceRequest.toObject(message.targetPoolsAddInstanceRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this AddInstanceTargetPoolRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddInstanceTargetPoolRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddInstanceTargetPoolRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddInstanceTargetPoolRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddInstanceTargetPoolRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddInstanceTargetPoolRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddInstanceTargetPoolRequest";
                        };
    
                        return AddInstanceTargetPoolRequest;
                    })();
    
                    v1.AddInstancesInstanceGroupRequest = (function() {
    
                        /**
                         * Properties of an AddInstancesInstanceGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddInstancesInstanceGroupRequest
                         * @property {string|null} [instanceGroup] AddInstancesInstanceGroupRequest instanceGroup
                         * @property {google.cloud.compute.v1.IInstanceGroupsAddInstancesRequest|null} [instanceGroupsAddInstancesRequestResource] AddInstancesInstanceGroupRequest instanceGroupsAddInstancesRequestResource
                         * @property {string|null} [project] AddInstancesInstanceGroupRequest project
                         * @property {string|null} [requestId] AddInstancesInstanceGroupRequest requestId
                         * @property {string|null} [zone] AddInstancesInstanceGroupRequest zone
                         */
    
                        /**
                         * Constructs a new AddInstancesInstanceGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddInstancesInstanceGroupRequest.
                         * @implements IAddInstancesInstanceGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddInstancesInstanceGroupRequest=} [properties] Properties to set
                         */
                        function AddInstancesInstanceGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddInstancesInstanceGroupRequest instanceGroup.
                         * @member {string} instanceGroup
                         * @memberof google.cloud.compute.v1.AddInstancesInstanceGroupRequest
                         * @instance
                         */
                        AddInstancesInstanceGroupRequest.prototype.instanceGroup = "";
    
                        /**
                         * AddInstancesInstanceGroupRequest instanceGroupsAddInstancesRequestResource.
                         * @member {google.cloud.compute.v1.IInstanceGroupsAddInstancesRequest|null|undefined} instanceGroupsAddInstancesRequestResource
                         * @memberof google.cloud.compute.v1.AddInstancesInstanceGroupRequest
                         * @instance
                         */
                        AddInstancesInstanceGroupRequest.prototype.instanceGroupsAddInstancesRequestResource = null;
    
                        /**
                         * AddInstancesInstanceGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AddInstancesInstanceGroupRequest
                         * @instance
                         */
                        AddInstancesInstanceGroupRequest.prototype.project = "";
    
                        /**
                         * AddInstancesInstanceGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AddInstancesInstanceGroupRequest
                         * @instance
                         */
                        AddInstancesInstanceGroupRequest.prototype.requestId = null;
    
                        /**
                         * AddInstancesInstanceGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.AddInstancesInstanceGroupRequest
                         * @instance
                         */
                        AddInstancesInstanceGroupRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddInstancesInstanceGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AddInstancesInstanceGroupRequest
                         * @instance
                         */
                        Object.defineProperty(AddInstancesInstanceGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddInstancesInstanceGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddInstancesInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddInstancesInstanceGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddInstancesInstanceGroupRequest} AddInstancesInstanceGroupRequest instance
                         */
                        AddInstancesInstanceGroupRequest.create = function create(properties) {
                            return new AddInstancesInstanceGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AddInstancesInstanceGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.AddInstancesInstanceGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddInstancesInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddInstancesInstanceGroupRequest} message AddInstancesInstanceGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddInstancesInstanceGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.instanceGroup != null && Object.hasOwnProperty.call(message, "instanceGroup"))
                                writer.uint32(/* id 81095253, wireType 2 =*/648762026).string(message.instanceGroup);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupsAddInstancesRequestResource != null && Object.hasOwnProperty.call(message, "instanceGroupsAddInstancesRequestResource"))
                                $root.google.cloud.compute.v1.InstanceGroupsAddInstancesRequest.encode(message.instanceGroupsAddInstancesRequestResource, writer.uint32(/* id 453713246, wireType 2 =*/3629705970).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddInstancesInstanceGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddInstancesInstanceGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddInstancesInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddInstancesInstanceGroupRequest} message AddInstancesInstanceGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddInstancesInstanceGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddInstancesInstanceGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddInstancesInstanceGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddInstancesInstanceGroupRequest} AddInstancesInstanceGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddInstancesInstanceGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddInstancesInstanceGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 81095253: {
                                        message.instanceGroup = reader.string();
                                        break;
                                    }
                                case 453713246: {
                                        message.instanceGroupsAddInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupsAddInstancesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddInstancesInstanceGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddInstancesInstanceGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddInstancesInstanceGroupRequest} AddInstancesInstanceGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddInstancesInstanceGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddInstancesInstanceGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddInstancesInstanceGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddInstancesInstanceGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroup != null && message.hasOwnProperty("instanceGroup"))
                                if (!$util.isString(message.instanceGroup))
                                    return "instanceGroup: string expected";
                            if (message.instanceGroupsAddInstancesRequestResource != null && message.hasOwnProperty("instanceGroupsAddInstancesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceGroupsAddInstancesRequest.verify(message.instanceGroupsAddInstancesRequestResource);
                                if (error)
                                    return "instanceGroupsAddInstancesRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AddInstancesInstanceGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddInstancesInstanceGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddInstancesInstanceGroupRequest} AddInstancesInstanceGroupRequest
                         */
                        AddInstancesInstanceGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddInstancesInstanceGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddInstancesInstanceGroupRequest();
                            if (object.instanceGroup != null)
                                message.instanceGroup = String(object.instanceGroup);
                            if (object.instanceGroupsAddInstancesRequestResource != null) {
                                if (typeof object.instanceGroupsAddInstancesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddInstancesInstanceGroupRequest.instanceGroupsAddInstancesRequestResource: object expected");
                                message.instanceGroupsAddInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupsAddInstancesRequest.fromObject(object.instanceGroupsAddInstancesRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddInstancesInstanceGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddInstancesInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.AddInstancesInstanceGroupRequest} message AddInstancesInstanceGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddInstancesInstanceGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instanceGroup = "";
                                object.project = "";
                                object.instanceGroupsAddInstancesRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.instanceGroup != null && message.hasOwnProperty("instanceGroup"))
                                object.instanceGroup = message.instanceGroup;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupsAddInstancesRequestResource != null && message.hasOwnProperty("instanceGroupsAddInstancesRequestResource"))
                                object.instanceGroupsAddInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupsAddInstancesRequest.toObject(message.instanceGroupsAddInstancesRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this AddInstancesInstanceGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddInstancesInstanceGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddInstancesInstanceGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddInstancesInstanceGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddInstancesInstanceGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddInstancesInstanceGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddInstancesInstanceGroupRequest";
                        };
    
                        return AddInstancesInstanceGroupRequest;
                    })();
    
                    v1.AddNodesNodeGroupRequest = (function() {
    
                        /**
                         * Properties of an AddNodesNodeGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddNodesNodeGroupRequest
                         * @property {string|null} [nodeGroup] AddNodesNodeGroupRequest nodeGroup
                         * @property {google.cloud.compute.v1.INodeGroupsAddNodesRequest|null} [nodeGroupsAddNodesRequestResource] AddNodesNodeGroupRequest nodeGroupsAddNodesRequestResource
                         * @property {string|null} [project] AddNodesNodeGroupRequest project
                         * @property {string|null} [requestId] AddNodesNodeGroupRequest requestId
                         * @property {string|null} [zone] AddNodesNodeGroupRequest zone
                         */
    
                        /**
                         * Constructs a new AddNodesNodeGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddNodesNodeGroupRequest.
                         * @implements IAddNodesNodeGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddNodesNodeGroupRequest=} [properties] Properties to set
                         */
                        function AddNodesNodeGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddNodesNodeGroupRequest nodeGroup.
                         * @member {string} nodeGroup
                         * @memberof google.cloud.compute.v1.AddNodesNodeGroupRequest
                         * @instance
                         */
                        AddNodesNodeGroupRequest.prototype.nodeGroup = "";
    
                        /**
                         * AddNodesNodeGroupRequest nodeGroupsAddNodesRequestResource.
                         * @member {google.cloud.compute.v1.INodeGroupsAddNodesRequest|null|undefined} nodeGroupsAddNodesRequestResource
                         * @memberof google.cloud.compute.v1.AddNodesNodeGroupRequest
                         * @instance
                         */
                        AddNodesNodeGroupRequest.prototype.nodeGroupsAddNodesRequestResource = null;
    
                        /**
                         * AddNodesNodeGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AddNodesNodeGroupRequest
                         * @instance
                         */
                        AddNodesNodeGroupRequest.prototype.project = "";
    
                        /**
                         * AddNodesNodeGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AddNodesNodeGroupRequest
                         * @instance
                         */
                        AddNodesNodeGroupRequest.prototype.requestId = null;
    
                        /**
                         * AddNodesNodeGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.AddNodesNodeGroupRequest
                         * @instance
                         */
                        AddNodesNodeGroupRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddNodesNodeGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AddNodesNodeGroupRequest
                         * @instance
                         */
                        Object.defineProperty(AddNodesNodeGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddNodesNodeGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddNodesNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddNodesNodeGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddNodesNodeGroupRequest} AddNodesNodeGroupRequest instance
                         */
                        AddNodesNodeGroupRequest.create = function create(properties) {
                            return new AddNodesNodeGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AddNodesNodeGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.AddNodesNodeGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddNodesNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddNodesNodeGroupRequest} message AddNodesNodeGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddNodesNodeGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.nodeGroupsAddNodesRequestResource != null && Object.hasOwnProperty.call(message, "nodeGroupsAddNodesRequestResource"))
                                $root.google.cloud.compute.v1.NodeGroupsAddNodesRequest.encode(message.nodeGroupsAddNodesRequestResource, writer.uint32(/* id 131263288, wireType 2 =*/1050106306).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.nodeGroup != null && Object.hasOwnProperty.call(message, "nodeGroup"))
                                writer.uint32(/* id 469958146, wireType 2 =*/3759665170).string(message.nodeGroup);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddNodesNodeGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddNodesNodeGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddNodesNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddNodesNodeGroupRequest} message AddNodesNodeGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddNodesNodeGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddNodesNodeGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddNodesNodeGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddNodesNodeGroupRequest} AddNodesNodeGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddNodesNodeGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddNodesNodeGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 469958146: {
                                        message.nodeGroup = reader.string();
                                        break;
                                    }
                                case 131263288: {
                                        message.nodeGroupsAddNodesRequestResource = $root.google.cloud.compute.v1.NodeGroupsAddNodesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddNodesNodeGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddNodesNodeGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddNodesNodeGroupRequest} AddNodesNodeGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddNodesNodeGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddNodesNodeGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddNodesNodeGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddNodesNodeGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.nodeGroup != null && message.hasOwnProperty("nodeGroup"))
                                if (!$util.isString(message.nodeGroup))
                                    return "nodeGroup: string expected";
                            if (message.nodeGroupsAddNodesRequestResource != null && message.hasOwnProperty("nodeGroupsAddNodesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.NodeGroupsAddNodesRequest.verify(message.nodeGroupsAddNodesRequestResource);
                                if (error)
                                    return "nodeGroupsAddNodesRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AddNodesNodeGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddNodesNodeGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddNodesNodeGroupRequest} AddNodesNodeGroupRequest
                         */
                        AddNodesNodeGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddNodesNodeGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddNodesNodeGroupRequest();
                            if (object.nodeGroup != null)
                                message.nodeGroup = String(object.nodeGroup);
                            if (object.nodeGroupsAddNodesRequestResource != null) {
                                if (typeof object.nodeGroupsAddNodesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddNodesNodeGroupRequest.nodeGroupsAddNodesRequestResource: object expected");
                                message.nodeGroupsAddNodesRequestResource = $root.google.cloud.compute.v1.NodeGroupsAddNodesRequest.fromObject(object.nodeGroupsAddNodesRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddNodesNodeGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddNodesNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.AddNodesNodeGroupRequest} message AddNodesNodeGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddNodesNodeGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.nodeGroupsAddNodesRequestResource = null;
                                object.project = "";
                                object.nodeGroup = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.nodeGroupsAddNodesRequestResource != null && message.hasOwnProperty("nodeGroupsAddNodesRequestResource"))
                                object.nodeGroupsAddNodesRequestResource = $root.google.cloud.compute.v1.NodeGroupsAddNodesRequest.toObject(message.nodeGroupsAddNodesRequestResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.nodeGroup != null && message.hasOwnProperty("nodeGroup"))
                                object.nodeGroup = message.nodeGroup;
                            return object;
                        };
    
                        /**
                         * Converts this AddNodesNodeGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddNodesNodeGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddNodesNodeGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddNodesNodeGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddNodesNodeGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddNodesNodeGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddNodesNodeGroupRequest";
                        };
    
                        return AddNodesNodeGroupRequest;
                    })();
    
                    v1.AddPeeringNetworkRequest = (function() {
    
                        /**
                         * Properties of an AddPeeringNetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddPeeringNetworkRequest
                         * @property {string|null} [network] AddPeeringNetworkRequest network
                         * @property {google.cloud.compute.v1.INetworksAddPeeringRequest|null} [networksAddPeeringRequestResource] AddPeeringNetworkRequest networksAddPeeringRequestResource
                         * @property {string|null} [project] AddPeeringNetworkRequest project
                         * @property {string|null} [requestId] AddPeeringNetworkRequest requestId
                         */
    
                        /**
                         * Constructs a new AddPeeringNetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddPeeringNetworkRequest.
                         * @implements IAddPeeringNetworkRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddPeeringNetworkRequest=} [properties] Properties to set
                         */
                        function AddPeeringNetworkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddPeeringNetworkRequest network.
                         * @member {string} network
                         * @memberof google.cloud.compute.v1.AddPeeringNetworkRequest
                         * @instance
                         */
                        AddPeeringNetworkRequest.prototype.network = "";
    
                        /**
                         * AddPeeringNetworkRequest networksAddPeeringRequestResource.
                         * @member {google.cloud.compute.v1.INetworksAddPeeringRequest|null|undefined} networksAddPeeringRequestResource
                         * @memberof google.cloud.compute.v1.AddPeeringNetworkRequest
                         * @instance
                         */
                        AddPeeringNetworkRequest.prototype.networksAddPeeringRequestResource = null;
    
                        /**
                         * AddPeeringNetworkRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AddPeeringNetworkRequest
                         * @instance
                         */
                        AddPeeringNetworkRequest.prototype.project = "";
    
                        /**
                         * AddPeeringNetworkRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AddPeeringNetworkRequest
                         * @instance
                         */
                        AddPeeringNetworkRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddPeeringNetworkRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AddPeeringNetworkRequest
                         * @instance
                         */
                        Object.defineProperty(AddPeeringNetworkRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddPeeringNetworkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddPeeringNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddPeeringNetworkRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddPeeringNetworkRequest} AddPeeringNetworkRequest instance
                         */
                        AddPeeringNetworkRequest.create = function create(properties) {
                            return new AddPeeringNetworkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AddPeeringNetworkRequest message. Does not implicitly {@link google.cloud.compute.v1.AddPeeringNetworkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddPeeringNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddPeeringNetworkRequest} message AddPeeringNetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddPeeringNetworkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            if (message.networksAddPeeringRequestResource != null && Object.hasOwnProperty.call(message, "networksAddPeeringRequestResource"))
                                $root.google.cloud.compute.v1.NetworksAddPeeringRequest.encode(message.networksAddPeeringRequestResource, writer.uint32(/* id 388810421, wireType 2 =*/3110483370).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddPeeringNetworkRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddPeeringNetworkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddPeeringNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddPeeringNetworkRequest} message AddPeeringNetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddPeeringNetworkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddPeeringNetworkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddPeeringNetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddPeeringNetworkRequest} AddPeeringNetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddPeeringNetworkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddPeeringNetworkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 388810421: {
                                        message.networksAddPeeringRequestResource = $root.google.cloud.compute.v1.NetworksAddPeeringRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddPeeringNetworkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddPeeringNetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddPeeringNetworkRequest} AddPeeringNetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddPeeringNetworkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddPeeringNetworkRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddPeeringNetworkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddPeeringNetworkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.network != null && message.hasOwnProperty("network"))
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            if (message.networksAddPeeringRequestResource != null && message.hasOwnProperty("networksAddPeeringRequestResource")) {
                                var error = $root.google.cloud.compute.v1.NetworksAddPeeringRequest.verify(message.networksAddPeeringRequestResource);
                                if (error)
                                    return "networksAddPeeringRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AddPeeringNetworkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddPeeringNetworkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddPeeringNetworkRequest} AddPeeringNetworkRequest
                         */
                        AddPeeringNetworkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddPeeringNetworkRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddPeeringNetworkRequest();
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.networksAddPeeringRequestResource != null) {
                                if (typeof object.networksAddPeeringRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddPeeringNetworkRequest.networksAddPeeringRequestResource: object expected");
                                message.networksAddPeeringRequestResource = $root.google.cloud.compute.v1.NetworksAddPeeringRequest.fromObject(object.networksAddPeeringRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddPeeringNetworkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddPeeringNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.AddPeeringNetworkRequest} message AddPeeringNetworkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddPeeringNetworkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.network = "";
                                object.networksAddPeeringRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.network != null && message.hasOwnProperty("network"))
                                object.network = message.network;
                            if (message.networksAddPeeringRequestResource != null && message.hasOwnProperty("networksAddPeeringRequestResource"))
                                object.networksAddPeeringRequestResource = $root.google.cloud.compute.v1.NetworksAddPeeringRequest.toObject(message.networksAddPeeringRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this AddPeeringNetworkRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddPeeringNetworkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddPeeringNetworkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddPeeringNetworkRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddPeeringNetworkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddPeeringNetworkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddPeeringNetworkRequest";
                        };
    
                        return AddPeeringNetworkRequest;
                    })();
    
                    v1.AddResourcePoliciesDiskRequest = (function() {
    
                        /**
                         * Properties of an AddResourcePoliciesDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddResourcePoliciesDiskRequest
                         * @property {string|null} [disk] AddResourcePoliciesDiskRequest disk
                         * @property {google.cloud.compute.v1.IDisksAddResourcePoliciesRequest|null} [disksAddResourcePoliciesRequestResource] AddResourcePoliciesDiskRequest disksAddResourcePoliciesRequestResource
                         * @property {string|null} [project] AddResourcePoliciesDiskRequest project
                         * @property {string|null} [requestId] AddResourcePoliciesDiskRequest requestId
                         * @property {string|null} [zone] AddResourcePoliciesDiskRequest zone
                         */
    
                        /**
                         * Constructs a new AddResourcePoliciesDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddResourcePoliciesDiskRequest.
                         * @implements IAddResourcePoliciesDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddResourcePoliciesDiskRequest=} [properties] Properties to set
                         */
                        function AddResourcePoliciesDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddResourcePoliciesDiskRequest disk.
                         * @member {string} disk
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesDiskRequest
                         * @instance
                         */
                        AddResourcePoliciesDiskRequest.prototype.disk = "";
    
                        /**
                         * AddResourcePoliciesDiskRequest disksAddResourcePoliciesRequestResource.
                         * @member {google.cloud.compute.v1.IDisksAddResourcePoliciesRequest|null|undefined} disksAddResourcePoliciesRequestResource
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesDiskRequest
                         * @instance
                         */
                        AddResourcePoliciesDiskRequest.prototype.disksAddResourcePoliciesRequestResource = null;
    
                        /**
                         * AddResourcePoliciesDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesDiskRequest
                         * @instance
                         */
                        AddResourcePoliciesDiskRequest.prototype.project = "";
    
                        /**
                         * AddResourcePoliciesDiskRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesDiskRequest
                         * @instance
                         */
                        AddResourcePoliciesDiskRequest.prototype.requestId = null;
    
                        /**
                         * AddResourcePoliciesDiskRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesDiskRequest
                         * @instance
                         */
                        AddResourcePoliciesDiskRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddResourcePoliciesDiskRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesDiskRequest
                         * @instance
                         */
                        Object.defineProperty(AddResourcePoliciesDiskRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddResourcePoliciesDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddResourcePoliciesDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddResourcePoliciesDiskRequest} AddResourcePoliciesDiskRequest instance
                         */
                        AddResourcePoliciesDiskRequest.create = function create(properties) {
                            return new AddResourcePoliciesDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AddResourcePoliciesDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.AddResourcePoliciesDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddResourcePoliciesDiskRequest} message AddResourcePoliciesDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddResourcePoliciesDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.disk != null && Object.hasOwnProperty.call(message, "disk"))
                                writer.uint32(/* id 3083677, wireType 2 =*/24669418).string(message.disk);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.disksAddResourcePoliciesRequestResource != null && Object.hasOwnProperty.call(message, "disksAddResourcePoliciesRequestResource"))
                                $root.google.cloud.compute.v1.DisksAddResourcePoliciesRequest.encode(message.disksAddResourcePoliciesRequestResource, writer.uint32(/* id 496483363, wireType 2 =*/3971866906).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddResourcePoliciesDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddResourcePoliciesDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddResourcePoliciesDiskRequest} message AddResourcePoliciesDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddResourcePoliciesDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddResourcePoliciesDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddResourcePoliciesDiskRequest} AddResourcePoliciesDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddResourcePoliciesDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddResourcePoliciesDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3083677: {
                                        message.disk = reader.string();
                                        break;
                                    }
                                case 496483363: {
                                        message.disksAddResourcePoliciesRequestResource = $root.google.cloud.compute.v1.DisksAddResourcePoliciesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddResourcePoliciesDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddResourcePoliciesDiskRequest} AddResourcePoliciesDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddResourcePoliciesDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddResourcePoliciesDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddResourcePoliciesDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                if (!$util.isString(message.disk))
                                    return "disk: string expected";
                            if (message.disksAddResourcePoliciesRequestResource != null && message.hasOwnProperty("disksAddResourcePoliciesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.DisksAddResourcePoliciesRequest.verify(message.disksAddResourcePoliciesRequestResource);
                                if (error)
                                    return "disksAddResourcePoliciesRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AddResourcePoliciesDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddResourcePoliciesDiskRequest} AddResourcePoliciesDiskRequest
                         */
                        AddResourcePoliciesDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddResourcePoliciesDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddResourcePoliciesDiskRequest();
                            if (object.disk != null)
                                message.disk = String(object.disk);
                            if (object.disksAddResourcePoliciesRequestResource != null) {
                                if (typeof object.disksAddResourcePoliciesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddResourcePoliciesDiskRequest.disksAddResourcePoliciesRequestResource: object expected");
                                message.disksAddResourcePoliciesRequestResource = $root.google.cloud.compute.v1.DisksAddResourcePoliciesRequest.fromObject(object.disksAddResourcePoliciesRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddResourcePoliciesDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.AddResourcePoliciesDiskRequest} message AddResourcePoliciesDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddResourcePoliciesDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.disk = "";
                                object.zone = "";
                                object.project = "";
                                object.disksAddResourcePoliciesRequestResource = null;
                            }
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                object.disk = message.disk;
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.disksAddResourcePoliciesRequestResource != null && message.hasOwnProperty("disksAddResourcePoliciesRequestResource"))
                                object.disksAddResourcePoliciesRequestResource = $root.google.cloud.compute.v1.DisksAddResourcePoliciesRequest.toObject(message.disksAddResourcePoliciesRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this AddResourcePoliciesDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddResourcePoliciesDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddResourcePoliciesDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddResourcePoliciesDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddResourcePoliciesDiskRequest";
                        };
    
                        return AddResourcePoliciesDiskRequest;
                    })();
    
                    v1.AddResourcePoliciesInstanceRequest = (function() {
    
                        /**
                         * Properties of an AddResourcePoliciesInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddResourcePoliciesInstanceRequest
                         * @property {string|null} [instance] AddResourcePoliciesInstanceRequest instance
                         * @property {google.cloud.compute.v1.IInstancesAddResourcePoliciesRequest|null} [instancesAddResourcePoliciesRequestResource] AddResourcePoliciesInstanceRequest instancesAddResourcePoliciesRequestResource
                         * @property {string|null} [project] AddResourcePoliciesInstanceRequest project
                         * @property {string|null} [requestId] AddResourcePoliciesInstanceRequest requestId
                         * @property {string|null} [zone] AddResourcePoliciesInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new AddResourcePoliciesInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddResourcePoliciesInstanceRequest.
                         * @implements IAddResourcePoliciesInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddResourcePoliciesInstanceRequest=} [properties] Properties to set
                         */
                        function AddResourcePoliciesInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddResourcePoliciesInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesInstanceRequest
                         * @instance
                         */
                        AddResourcePoliciesInstanceRequest.prototype.instance = "";
    
                        /**
                         * AddResourcePoliciesInstanceRequest instancesAddResourcePoliciesRequestResource.
                         * @member {google.cloud.compute.v1.IInstancesAddResourcePoliciesRequest|null|undefined} instancesAddResourcePoliciesRequestResource
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesInstanceRequest
                         * @instance
                         */
                        AddResourcePoliciesInstanceRequest.prototype.instancesAddResourcePoliciesRequestResource = null;
    
                        /**
                         * AddResourcePoliciesInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesInstanceRequest
                         * @instance
                         */
                        AddResourcePoliciesInstanceRequest.prototype.project = "";
    
                        /**
                         * AddResourcePoliciesInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesInstanceRequest
                         * @instance
                         */
                        AddResourcePoliciesInstanceRequest.prototype.requestId = null;
    
                        /**
                         * AddResourcePoliciesInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesInstanceRequest
                         * @instance
                         */
                        AddResourcePoliciesInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddResourcePoliciesInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(AddResourcePoliciesInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddResourcePoliciesInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddResourcePoliciesInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddResourcePoliciesInstanceRequest} AddResourcePoliciesInstanceRequest instance
                         */
                        AddResourcePoliciesInstanceRequest.create = function create(properties) {
                            return new AddResourcePoliciesInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AddResourcePoliciesInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.AddResourcePoliciesInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddResourcePoliciesInstanceRequest} message AddResourcePoliciesInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddResourcePoliciesInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instancesAddResourcePoliciesRequestResource != null && Object.hasOwnProperty.call(message, "instancesAddResourcePoliciesRequestResource"))
                                $root.google.cloud.compute.v1.InstancesAddResourcePoliciesRequest.encode(message.instancesAddResourcePoliciesRequestResource, writer.uint32(/* id 489351963, wireType 2 =*/3914815706).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddResourcePoliciesInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddResourcePoliciesInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddResourcePoliciesInstanceRequest} message AddResourcePoliciesInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddResourcePoliciesInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddResourcePoliciesInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddResourcePoliciesInstanceRequest} AddResourcePoliciesInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddResourcePoliciesInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddResourcePoliciesInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 489351963: {
                                        message.instancesAddResourcePoliciesRequestResource = $root.google.cloud.compute.v1.InstancesAddResourcePoliciesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddResourcePoliciesInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddResourcePoliciesInstanceRequest} AddResourcePoliciesInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddResourcePoliciesInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddResourcePoliciesInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddResourcePoliciesInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.instancesAddResourcePoliciesRequestResource != null && message.hasOwnProperty("instancesAddResourcePoliciesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.InstancesAddResourcePoliciesRequest.verify(message.instancesAddResourcePoliciesRequestResource);
                                if (error)
                                    return "instancesAddResourcePoliciesRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AddResourcePoliciesInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddResourcePoliciesInstanceRequest} AddResourcePoliciesInstanceRequest
                         */
                        AddResourcePoliciesInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddResourcePoliciesInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddResourcePoliciesInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.instancesAddResourcePoliciesRequestResource != null) {
                                if (typeof object.instancesAddResourcePoliciesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddResourcePoliciesInstanceRequest.instancesAddResourcePoliciesRequestResource: object expected");
                                message.instancesAddResourcePoliciesRequestResource = $root.google.cloud.compute.v1.InstancesAddResourcePoliciesRequest.fromObject(object.instancesAddResourcePoliciesRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddResourcePoliciesInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.AddResourcePoliciesInstanceRequest} message AddResourcePoliciesInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddResourcePoliciesInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                                object.instancesAddResourcePoliciesRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instancesAddResourcePoliciesRequestResource != null && message.hasOwnProperty("instancesAddResourcePoliciesRequestResource"))
                                object.instancesAddResourcePoliciesRequestResource = $root.google.cloud.compute.v1.InstancesAddResourcePoliciesRequest.toObject(message.instancesAddResourcePoliciesRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this AddResourcePoliciesInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddResourcePoliciesInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddResourcePoliciesInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddResourcePoliciesInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddResourcePoliciesInstanceRequest";
                        };
    
                        return AddResourcePoliciesInstanceRequest;
                    })();
    
                    v1.AddResourcePoliciesRegionDiskRequest = (function() {
    
                        /**
                         * Properties of an AddResourcePoliciesRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddResourcePoliciesRegionDiskRequest
                         * @property {string|null} [disk] AddResourcePoliciesRegionDiskRequest disk
                         * @property {string|null} [project] AddResourcePoliciesRegionDiskRequest project
                         * @property {string|null} [region] AddResourcePoliciesRegionDiskRequest region
                         * @property {google.cloud.compute.v1.IRegionDisksAddResourcePoliciesRequest|null} [regionDisksAddResourcePoliciesRequestResource] AddResourcePoliciesRegionDiskRequest regionDisksAddResourcePoliciesRequestResource
                         * @property {string|null} [requestId] AddResourcePoliciesRegionDiskRequest requestId
                         */
    
                        /**
                         * Constructs a new AddResourcePoliciesRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddResourcePoliciesRegionDiskRequest.
                         * @implements IAddResourcePoliciesRegionDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddResourcePoliciesRegionDiskRequest=} [properties] Properties to set
                         */
                        function AddResourcePoliciesRegionDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddResourcePoliciesRegionDiskRequest disk.
                         * @member {string} disk
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest
                         * @instance
                         */
                        AddResourcePoliciesRegionDiskRequest.prototype.disk = "";
    
                        /**
                         * AddResourcePoliciesRegionDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest
                         * @instance
                         */
                        AddResourcePoliciesRegionDiskRequest.prototype.project = "";
    
                        /**
                         * AddResourcePoliciesRegionDiskRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest
                         * @instance
                         */
                        AddResourcePoliciesRegionDiskRequest.prototype.region = "";
    
                        /**
                         * AddResourcePoliciesRegionDiskRequest regionDisksAddResourcePoliciesRequestResource.
                         * @member {google.cloud.compute.v1.IRegionDisksAddResourcePoliciesRequest|null|undefined} regionDisksAddResourcePoliciesRequestResource
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest
                         * @instance
                         */
                        AddResourcePoliciesRegionDiskRequest.prototype.regionDisksAddResourcePoliciesRequestResource = null;
    
                        /**
                         * AddResourcePoliciesRegionDiskRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest
                         * @instance
                         */
                        AddResourcePoliciesRegionDiskRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddResourcePoliciesRegionDiskRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest
                         * @instance
                         */
                        Object.defineProperty(AddResourcePoliciesRegionDiskRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddResourcePoliciesRegionDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddResourcePoliciesRegionDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest} AddResourcePoliciesRegionDiskRequest instance
                         */
                        AddResourcePoliciesRegionDiskRequest.create = function create(properties) {
                            return new AddResourcePoliciesRegionDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AddResourcePoliciesRegionDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddResourcePoliciesRegionDiskRequest} message AddResourcePoliciesRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddResourcePoliciesRegionDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.disk != null && Object.hasOwnProperty.call(message, "disk"))
                                writer.uint32(/* id 3083677, wireType 2 =*/24669418).string(message.disk);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.regionDisksAddResourcePoliciesRequestResource != null && Object.hasOwnProperty.call(message, "regionDisksAddResourcePoliciesRequestResource"))
                                $root.google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest.encode(message.regionDisksAddResourcePoliciesRequestResource, writer.uint32(/* id 284196750, wireType 2 =*/2273574002).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddResourcePoliciesRegionDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddResourcePoliciesRegionDiskRequest} message AddResourcePoliciesRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddResourcePoliciesRegionDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddResourcePoliciesRegionDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest} AddResourcePoliciesRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddResourcePoliciesRegionDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3083677: {
                                        message.disk = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 284196750: {
                                        message.regionDisksAddResourcePoliciesRequestResource = $root.google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddResourcePoliciesRegionDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest} AddResourcePoliciesRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddResourcePoliciesRegionDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddResourcePoliciesRegionDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddResourcePoliciesRegionDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                if (!$util.isString(message.disk))
                                    return "disk: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionDisksAddResourcePoliciesRequestResource != null && message.hasOwnProperty("regionDisksAddResourcePoliciesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest.verify(message.regionDisksAddResourcePoliciesRequestResource);
                                if (error)
                                    return "regionDisksAddResourcePoliciesRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AddResourcePoliciesRegionDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest} AddResourcePoliciesRegionDiskRequest
                         */
                        AddResourcePoliciesRegionDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest();
                            if (object.disk != null)
                                message.disk = String(object.disk);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionDisksAddResourcePoliciesRequestResource != null) {
                                if (typeof object.regionDisksAddResourcePoliciesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest.regionDisksAddResourcePoliciesRequestResource: object expected");
                                message.regionDisksAddResourcePoliciesRequestResource = $root.google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest.fromObject(object.regionDisksAddResourcePoliciesRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddResourcePoliciesRegionDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest} message AddResourcePoliciesRegionDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddResourcePoliciesRegionDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.disk = "";
                                object.region = "";
                                object.project = "";
                                object.regionDisksAddResourcePoliciesRequestResource = null;
                            }
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                object.disk = message.disk;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.regionDisksAddResourcePoliciesRequestResource != null && message.hasOwnProperty("regionDisksAddResourcePoliciesRequestResource"))
                                object.regionDisksAddResourcePoliciesRequestResource = $root.google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest.toObject(message.regionDisksAddResourcePoliciesRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this AddResourcePoliciesRegionDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddResourcePoliciesRegionDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddResourcePoliciesRegionDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddResourcePoliciesRegionDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest";
                        };
    
                        return AddResourcePoliciesRegionDiskRequest;
                    })();
    
                    v1.AddRuleFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of an AddRuleFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddRuleFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] AddRuleFirewallPolicyRequest firewallPolicy
                         * @property {google.cloud.compute.v1.IFirewallPolicyRule|null} [firewallPolicyRuleResource] AddRuleFirewallPolicyRequest firewallPolicyRuleResource
                         * @property {string|null} [requestId] AddRuleFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new AddRuleFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddRuleFirewallPolicyRequest.
                         * @implements IAddRuleFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddRuleFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function AddRuleFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddRuleFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.AddRuleFirewallPolicyRequest
                         * @instance
                         */
                        AddRuleFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * AddRuleFirewallPolicyRequest firewallPolicyRuleResource.
                         * @member {google.cloud.compute.v1.IFirewallPolicyRule|null|undefined} firewallPolicyRuleResource
                         * @memberof google.cloud.compute.v1.AddRuleFirewallPolicyRequest
                         * @instance
                         */
                        AddRuleFirewallPolicyRequest.prototype.firewallPolicyRuleResource = null;
    
                        /**
                         * AddRuleFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AddRuleFirewallPolicyRequest
                         * @instance
                         */
                        AddRuleFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddRuleFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AddRuleFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(AddRuleFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddRuleFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddRuleFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddRuleFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddRuleFirewallPolicyRequest} AddRuleFirewallPolicyRequest instance
                         */
                        AddRuleFirewallPolicyRequest.create = function create(properties) {
                            return new AddRuleFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AddRuleFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.AddRuleFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddRuleFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddRuleFirewallPolicyRequest} message AddRuleFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddRuleFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.firewallPolicyRuleResource != null && Object.hasOwnProperty.call(message, "firewallPolicyRuleResource"))
                                $root.google.cloud.compute.v1.FirewallPolicyRule.encode(message.firewallPolicyRuleResource, writer.uint32(/* id 250523523, wireType 2 =*/2004188186).fork()).ldelim();
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddRuleFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddRuleFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddRuleFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddRuleFirewallPolicyRequest} message AddRuleFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddRuleFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddRuleFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddRuleFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddRuleFirewallPolicyRequest} AddRuleFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddRuleFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddRuleFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 250523523: {
                                        message.firewallPolicyRuleResource = $root.google.cloud.compute.v1.FirewallPolicyRule.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddRuleFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddRuleFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddRuleFirewallPolicyRequest} AddRuleFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddRuleFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddRuleFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddRuleFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddRuleFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.firewallPolicyRuleResource != null && message.hasOwnProperty("firewallPolicyRuleResource")) {
                                var error = $root.google.cloud.compute.v1.FirewallPolicyRule.verify(message.firewallPolicyRuleResource);
                                if (error)
                                    return "firewallPolicyRuleResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AddRuleFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddRuleFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddRuleFirewallPolicyRequest} AddRuleFirewallPolicyRequest
                         */
                        AddRuleFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddRuleFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddRuleFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.firewallPolicyRuleResource != null) {
                                if (typeof object.firewallPolicyRuleResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddRuleFirewallPolicyRequest.firewallPolicyRuleResource: object expected");
                                message.firewallPolicyRuleResource = $root.google.cloud.compute.v1.FirewallPolicyRule.fromObject(object.firewallPolicyRuleResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddRuleFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddRuleFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.AddRuleFirewallPolicyRequest} message AddRuleFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddRuleFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.firewallPolicyRuleResource = null;
                                object.firewallPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.firewallPolicyRuleResource != null && message.hasOwnProperty("firewallPolicyRuleResource"))
                                object.firewallPolicyRuleResource = $root.google.cloud.compute.v1.FirewallPolicyRule.toObject(message.firewallPolicyRuleResource, options);
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this AddRuleFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddRuleFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddRuleFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddRuleFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddRuleFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddRuleFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddRuleFirewallPolicyRequest";
                        };
    
                        return AddRuleFirewallPolicyRequest;
                    })();
    
                    v1.AddRuleNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of an AddRuleNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddRuleNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] AddRuleNetworkFirewallPolicyRequest firewallPolicy
                         * @property {google.cloud.compute.v1.IFirewallPolicyRule|null} [firewallPolicyRuleResource] AddRuleNetworkFirewallPolicyRequest firewallPolicyRuleResource
                         * @property {number|null} [maxPriority] AddRuleNetworkFirewallPolicyRequest maxPriority
                         * @property {number|null} [minPriority] AddRuleNetworkFirewallPolicyRequest minPriority
                         * @property {string|null} [project] AddRuleNetworkFirewallPolicyRequest project
                         * @property {string|null} [requestId] AddRuleNetworkFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new AddRuleNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddRuleNetworkFirewallPolicyRequest.
                         * @implements IAddRuleNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddRuleNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function AddRuleNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddRuleNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddRuleNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * AddRuleNetworkFirewallPolicyRequest firewallPolicyRuleResource.
                         * @member {google.cloud.compute.v1.IFirewallPolicyRule|null|undefined} firewallPolicyRuleResource
                         * @memberof google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddRuleNetworkFirewallPolicyRequest.prototype.firewallPolicyRuleResource = null;
    
                        /**
                         * AddRuleNetworkFirewallPolicyRequest maxPriority.
                         * @member {number|null|undefined} maxPriority
                         * @memberof google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddRuleNetworkFirewallPolicyRequest.prototype.maxPriority = null;
    
                        /**
                         * AddRuleNetworkFirewallPolicyRequest minPriority.
                         * @member {number|null|undefined} minPriority
                         * @memberof google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddRuleNetworkFirewallPolicyRequest.prototype.minPriority = null;
    
                        /**
                         * AddRuleNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddRuleNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * AddRuleNetworkFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddRuleNetworkFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddRuleNetworkFirewallPolicyRequest _maxPriority.
                         * @member {"maxPriority"|undefined} _maxPriority
                         * @memberof google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(AddRuleNetworkFirewallPolicyRequest.prototype, "_maxPriority", {
                            get: $util.oneOfGetter($oneOfFields = ["maxPriority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddRuleNetworkFirewallPolicyRequest _minPriority.
                         * @member {"minPriority"|undefined} _minPriority
                         * @memberof google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(AddRuleNetworkFirewallPolicyRequest.prototype, "_minPriority", {
                            get: $util.oneOfGetter($oneOfFields = ["minPriority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddRuleNetworkFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(AddRuleNetworkFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddRuleNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddRuleNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest} AddRuleNetworkFirewallPolicyRequest instance
                         */
                        AddRuleNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new AddRuleNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AddRuleNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddRuleNetworkFirewallPolicyRequest} message AddRuleNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddRuleNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewallPolicyRuleResource != null && Object.hasOwnProperty.call(message, "firewallPolicyRuleResource"))
                                $root.google.cloud.compute.v1.FirewallPolicyRule.encode(message.firewallPolicyRuleResource, writer.uint32(/* id 250523523, wireType 2 =*/2004188186).fork()).ldelim();
                            if (message.minPriority != null && Object.hasOwnProperty.call(message, "minPriority"))
                                writer.uint32(/* id 267190513, wireType 0 =*/2137524104).int32(message.minPriority);
                            if (message.maxPriority != null && Object.hasOwnProperty.call(message, "maxPriority"))
                                writer.uint32(/* id 329635359, wireType 0 =*/2637082872).int32(message.maxPriority);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddRuleNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddRuleNetworkFirewallPolicyRequest} message AddRuleNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddRuleNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddRuleNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest} AddRuleNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddRuleNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 250523523: {
                                        message.firewallPolicyRuleResource = $root.google.cloud.compute.v1.FirewallPolicyRule.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 329635359: {
                                        message.maxPriority = reader.int32();
                                        break;
                                    }
                                case 267190513: {
                                        message.minPriority = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddRuleNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest} AddRuleNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddRuleNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddRuleNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddRuleNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.firewallPolicyRuleResource != null && message.hasOwnProperty("firewallPolicyRuleResource")) {
                                var error = $root.google.cloud.compute.v1.FirewallPolicyRule.verify(message.firewallPolicyRuleResource);
                                if (error)
                                    return "firewallPolicyRuleResource." + error;
                            }
                            if (message.maxPriority != null && message.hasOwnProperty("maxPriority")) {
                                properties._maxPriority = 1;
                                if (!$util.isInteger(message.maxPriority))
                                    return "maxPriority: integer expected";
                            }
                            if (message.minPriority != null && message.hasOwnProperty("minPriority")) {
                                properties._minPriority = 1;
                                if (!$util.isInteger(message.minPriority))
                                    return "minPriority: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AddRuleNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest} AddRuleNetworkFirewallPolicyRequest
                         */
                        AddRuleNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.firewallPolicyRuleResource != null) {
                                if (typeof object.firewallPolicyRuleResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest.firewallPolicyRuleResource: object expected");
                                message.firewallPolicyRuleResource = $root.google.cloud.compute.v1.FirewallPolicyRule.fromObject(object.firewallPolicyRuleResource);
                            }
                            if (object.maxPriority != null)
                                message.maxPriority = object.maxPriority | 0;
                            if (object.minPriority != null)
                                message.minPriority = object.minPriority | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddRuleNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest} message AddRuleNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddRuleNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.firewallPolicyRuleResource = null;
                                object.firewallPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewallPolicyRuleResource != null && message.hasOwnProperty("firewallPolicyRuleResource"))
                                object.firewallPolicyRuleResource = $root.google.cloud.compute.v1.FirewallPolicyRule.toObject(message.firewallPolicyRuleResource, options);
                            if (message.minPriority != null && message.hasOwnProperty("minPriority")) {
                                object.minPriority = message.minPriority;
                                if (options.oneofs)
                                    object._minPriority = "minPriority";
                            }
                            if (message.maxPriority != null && message.hasOwnProperty("maxPriority")) {
                                object.maxPriority = message.maxPriority;
                                if (options.oneofs)
                                    object._maxPriority = "maxPriority";
                            }
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this AddRuleNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddRuleNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddRuleNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddRuleNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest";
                        };
    
                        return AddRuleNetworkFirewallPolicyRequest;
                    })();
    
                    v1.AddRuleRegionNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of an AddRuleRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddRuleRegionNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] AddRuleRegionNetworkFirewallPolicyRequest firewallPolicy
                         * @property {google.cloud.compute.v1.IFirewallPolicyRule|null} [firewallPolicyRuleResource] AddRuleRegionNetworkFirewallPolicyRequest firewallPolicyRuleResource
                         * @property {number|null} [maxPriority] AddRuleRegionNetworkFirewallPolicyRequest maxPriority
                         * @property {number|null} [minPriority] AddRuleRegionNetworkFirewallPolicyRequest minPriority
                         * @property {string|null} [project] AddRuleRegionNetworkFirewallPolicyRequest project
                         * @property {string|null} [region] AddRuleRegionNetworkFirewallPolicyRequest region
                         * @property {string|null} [requestId] AddRuleRegionNetworkFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new AddRuleRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddRuleRegionNetworkFirewallPolicyRequest.
                         * @implements IAddRuleRegionNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddRuleRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function AddRuleRegionNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddRuleRegionNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddRuleRegionNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * AddRuleRegionNetworkFirewallPolicyRequest firewallPolicyRuleResource.
                         * @member {google.cloud.compute.v1.IFirewallPolicyRule|null|undefined} firewallPolicyRuleResource
                         * @memberof google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddRuleRegionNetworkFirewallPolicyRequest.prototype.firewallPolicyRuleResource = null;
    
                        /**
                         * AddRuleRegionNetworkFirewallPolicyRequest maxPriority.
                         * @member {number|null|undefined} maxPriority
                         * @memberof google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddRuleRegionNetworkFirewallPolicyRequest.prototype.maxPriority = null;
    
                        /**
                         * AddRuleRegionNetworkFirewallPolicyRequest minPriority.
                         * @member {number|null|undefined} minPriority
                         * @memberof google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddRuleRegionNetworkFirewallPolicyRequest.prototype.minPriority = null;
    
                        /**
                         * AddRuleRegionNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddRuleRegionNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * AddRuleRegionNetworkFirewallPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddRuleRegionNetworkFirewallPolicyRequest.prototype.region = "";
    
                        /**
                         * AddRuleRegionNetworkFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        AddRuleRegionNetworkFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddRuleRegionNetworkFirewallPolicyRequest _maxPriority.
                         * @member {"maxPriority"|undefined} _maxPriority
                         * @memberof google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(AddRuleRegionNetworkFirewallPolicyRequest.prototype, "_maxPriority", {
                            get: $util.oneOfGetter($oneOfFields = ["maxPriority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddRuleRegionNetworkFirewallPolicyRequest _minPriority.
                         * @member {"minPriority"|undefined} _minPriority
                         * @memberof google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(AddRuleRegionNetworkFirewallPolicyRequest.prototype, "_minPriority", {
                            get: $util.oneOfGetter($oneOfFields = ["minPriority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddRuleRegionNetworkFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(AddRuleRegionNetworkFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddRuleRegionNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddRuleRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest} AddRuleRegionNetworkFirewallPolicyRequest instance
                         */
                        AddRuleRegionNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new AddRuleRegionNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AddRuleRegionNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddRuleRegionNetworkFirewallPolicyRequest} message AddRuleRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddRuleRegionNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewallPolicyRuleResource != null && Object.hasOwnProperty.call(message, "firewallPolicyRuleResource"))
                                $root.google.cloud.compute.v1.FirewallPolicyRule.encode(message.firewallPolicyRuleResource, writer.uint32(/* id 250523523, wireType 2 =*/2004188186).fork()).ldelim();
                            if (message.minPriority != null && Object.hasOwnProperty.call(message, "minPriority"))
                                writer.uint32(/* id 267190513, wireType 0 =*/2137524104).int32(message.minPriority);
                            if (message.maxPriority != null && Object.hasOwnProperty.call(message, "maxPriority"))
                                writer.uint32(/* id 329635359, wireType 0 =*/2637082872).int32(message.maxPriority);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddRuleRegionNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddRuleRegionNetworkFirewallPolicyRequest} message AddRuleRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddRuleRegionNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddRuleRegionNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest} AddRuleRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddRuleRegionNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 250523523: {
                                        message.firewallPolicyRuleResource = $root.google.cloud.compute.v1.FirewallPolicyRule.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 329635359: {
                                        message.maxPriority = reader.int32();
                                        break;
                                    }
                                case 267190513: {
                                        message.minPriority = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddRuleRegionNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest} AddRuleRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddRuleRegionNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddRuleRegionNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddRuleRegionNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.firewallPolicyRuleResource != null && message.hasOwnProperty("firewallPolicyRuleResource")) {
                                var error = $root.google.cloud.compute.v1.FirewallPolicyRule.verify(message.firewallPolicyRuleResource);
                                if (error)
                                    return "firewallPolicyRuleResource." + error;
                            }
                            if (message.maxPriority != null && message.hasOwnProperty("maxPriority")) {
                                properties._maxPriority = 1;
                                if (!$util.isInteger(message.maxPriority))
                                    return "maxPriority: integer expected";
                            }
                            if (message.minPriority != null && message.hasOwnProperty("minPriority")) {
                                properties._minPriority = 1;
                                if (!$util.isInteger(message.minPriority))
                                    return "minPriority: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AddRuleRegionNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest} AddRuleRegionNetworkFirewallPolicyRequest
                         */
                        AddRuleRegionNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.firewallPolicyRuleResource != null) {
                                if (typeof object.firewallPolicyRuleResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest.firewallPolicyRuleResource: object expected");
                                message.firewallPolicyRuleResource = $root.google.cloud.compute.v1.FirewallPolicyRule.fromObject(object.firewallPolicyRuleResource);
                            }
                            if (object.maxPriority != null)
                                message.maxPriority = object.maxPriority | 0;
                            if (object.minPriority != null)
                                message.minPriority = object.minPriority | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddRuleRegionNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest} message AddRuleRegionNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddRuleRegionNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.firewallPolicyRuleResource = null;
                                object.firewallPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewallPolicyRuleResource != null && message.hasOwnProperty("firewallPolicyRuleResource"))
                                object.firewallPolicyRuleResource = $root.google.cloud.compute.v1.FirewallPolicyRule.toObject(message.firewallPolicyRuleResource, options);
                            if (message.minPriority != null && message.hasOwnProperty("minPriority")) {
                                object.minPriority = message.minPriority;
                                if (options.oneofs)
                                    object._minPriority = "minPriority";
                            }
                            if (message.maxPriority != null && message.hasOwnProperty("maxPriority")) {
                                object.maxPriority = message.maxPriority;
                                if (options.oneofs)
                                    object._maxPriority = "maxPriority";
                            }
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this AddRuleRegionNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddRuleRegionNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddRuleRegionNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddRuleRegionNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest";
                        };
    
                        return AddRuleRegionNetworkFirewallPolicyRequest;
                    })();
    
                    v1.AddRuleSecurityPolicyRequest = (function() {
    
                        /**
                         * Properties of an AddRuleSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddRuleSecurityPolicyRequest
                         * @property {string|null} [project] AddRuleSecurityPolicyRequest project
                         * @property {string|null} [securityPolicy] AddRuleSecurityPolicyRequest securityPolicy
                         * @property {google.cloud.compute.v1.ISecurityPolicyRule|null} [securityPolicyRuleResource] AddRuleSecurityPolicyRequest securityPolicyRuleResource
                         * @property {boolean|null} [validateOnly] AddRuleSecurityPolicyRequest validateOnly
                         */
    
                        /**
                         * Constructs a new AddRuleSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddRuleSecurityPolicyRequest.
                         * @implements IAddRuleSecurityPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddRuleSecurityPolicyRequest=} [properties] Properties to set
                         */
                        function AddRuleSecurityPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddRuleSecurityPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AddRuleSecurityPolicyRequest
                         * @instance
                         */
                        AddRuleSecurityPolicyRequest.prototype.project = "";
    
                        /**
                         * AddRuleSecurityPolicyRequest securityPolicy.
                         * @member {string} securityPolicy
                         * @memberof google.cloud.compute.v1.AddRuleSecurityPolicyRequest
                         * @instance
                         */
                        AddRuleSecurityPolicyRequest.prototype.securityPolicy = "";
    
                        /**
                         * AddRuleSecurityPolicyRequest securityPolicyRuleResource.
                         * @member {google.cloud.compute.v1.ISecurityPolicyRule|null|undefined} securityPolicyRuleResource
                         * @memberof google.cloud.compute.v1.AddRuleSecurityPolicyRequest
                         * @instance
                         */
                        AddRuleSecurityPolicyRequest.prototype.securityPolicyRuleResource = null;
    
                        /**
                         * AddRuleSecurityPolicyRequest validateOnly.
                         * @member {boolean|null|undefined} validateOnly
                         * @memberof google.cloud.compute.v1.AddRuleSecurityPolicyRequest
                         * @instance
                         */
                        AddRuleSecurityPolicyRequest.prototype.validateOnly = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddRuleSecurityPolicyRequest _validateOnly.
                         * @member {"validateOnly"|undefined} _validateOnly
                         * @memberof google.cloud.compute.v1.AddRuleSecurityPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(AddRuleSecurityPolicyRequest.prototype, "_validateOnly", {
                            get: $util.oneOfGetter($oneOfFields = ["validateOnly"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddRuleSecurityPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddRuleSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddRuleSecurityPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddRuleSecurityPolicyRequest} AddRuleSecurityPolicyRequest instance
                         */
                        AddRuleSecurityPolicyRequest.create = function create(properties) {
                            return new AddRuleSecurityPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AddRuleSecurityPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.AddRuleSecurityPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddRuleSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddRuleSecurityPolicyRequest} message AddRuleSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddRuleSecurityPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.securityPolicy != null && Object.hasOwnProperty.call(message, "securityPolicy"))
                                writer.uint32(/* id 171082513, wireType 2 =*/1368660106).string(message.securityPolicy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.validateOnly != null && Object.hasOwnProperty.call(message, "validateOnly"))
                                writer.uint32(/* id 242744629, wireType 0 =*/1941957032).bool(message.validateOnly);
                            if (message.securityPolicyRuleResource != null && Object.hasOwnProperty.call(message, "securityPolicyRuleResource"))
                                $root.google.cloud.compute.v1.SecurityPolicyRule.encode(message.securityPolicyRuleResource, writer.uint32(/* id 402693443, wireType 2 =*/3221547546).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddRuleSecurityPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddRuleSecurityPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddRuleSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddRuleSecurityPolicyRequest} message AddRuleSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddRuleSecurityPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddRuleSecurityPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddRuleSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddRuleSecurityPolicyRequest} AddRuleSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddRuleSecurityPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddRuleSecurityPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 171082513: {
                                        message.securityPolicy = reader.string();
                                        break;
                                    }
                                case 402693443: {
                                        message.securityPolicyRuleResource = $root.google.cloud.compute.v1.SecurityPolicyRule.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 242744629: {
                                        message.validateOnly = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddRuleSecurityPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddRuleSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddRuleSecurityPolicyRequest} AddRuleSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddRuleSecurityPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddRuleSecurityPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddRuleSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddRuleSecurityPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy"))
                                if (!$util.isString(message.securityPolicy))
                                    return "securityPolicy: string expected";
                            if (message.securityPolicyRuleResource != null && message.hasOwnProperty("securityPolicyRuleResource")) {
                                var error = $root.google.cloud.compute.v1.SecurityPolicyRule.verify(message.securityPolicyRuleResource);
                                if (error)
                                    return "securityPolicyRuleResource." + error;
                            }
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly")) {
                                properties._validateOnly = 1;
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AddRuleSecurityPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddRuleSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddRuleSecurityPolicyRequest} AddRuleSecurityPolicyRequest
                         */
                        AddRuleSecurityPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddRuleSecurityPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddRuleSecurityPolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.securityPolicy != null)
                                message.securityPolicy = String(object.securityPolicy);
                            if (object.securityPolicyRuleResource != null) {
                                if (typeof object.securityPolicyRuleResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddRuleSecurityPolicyRequest.securityPolicyRuleResource: object expected");
                                message.securityPolicyRuleResource = $root.google.cloud.compute.v1.SecurityPolicyRule.fromObject(object.securityPolicyRuleResource);
                            }
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddRuleSecurityPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddRuleSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.AddRuleSecurityPolicyRequest} message AddRuleSecurityPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddRuleSecurityPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.securityPolicy = "";
                                object.project = "";
                                object.securityPolicyRuleResource = null;
                            }
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy"))
                                object.securityPolicy = message.securityPolicy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly")) {
                                object.validateOnly = message.validateOnly;
                                if (options.oneofs)
                                    object._validateOnly = "validateOnly";
                            }
                            if (message.securityPolicyRuleResource != null && message.hasOwnProperty("securityPolicyRuleResource"))
                                object.securityPolicyRuleResource = $root.google.cloud.compute.v1.SecurityPolicyRule.toObject(message.securityPolicyRuleResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this AddRuleSecurityPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddRuleSecurityPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddRuleSecurityPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddRuleSecurityPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddRuleSecurityPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddRuleSecurityPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddRuleSecurityPolicyRequest";
                        };
    
                        return AddRuleSecurityPolicyRequest;
                    })();
    
                    v1.AddSignedUrlKeyBackendBucketRequest = (function() {
    
                        /**
                         * Properties of an AddSignedUrlKeyBackendBucketRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddSignedUrlKeyBackendBucketRequest
                         * @property {string|null} [backendBucket] AddSignedUrlKeyBackendBucketRequest backendBucket
                         * @property {string|null} [project] AddSignedUrlKeyBackendBucketRequest project
                         * @property {string|null} [requestId] AddSignedUrlKeyBackendBucketRequest requestId
                         * @property {google.cloud.compute.v1.ISignedUrlKey|null} [signedUrlKeyResource] AddSignedUrlKeyBackendBucketRequest signedUrlKeyResource
                         */
    
                        /**
                         * Constructs a new AddSignedUrlKeyBackendBucketRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddSignedUrlKeyBackendBucketRequest.
                         * @implements IAddSignedUrlKeyBackendBucketRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddSignedUrlKeyBackendBucketRequest=} [properties] Properties to set
                         */
                        function AddSignedUrlKeyBackendBucketRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddSignedUrlKeyBackendBucketRequest backendBucket.
                         * @member {string} backendBucket
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest
                         * @instance
                         */
                        AddSignedUrlKeyBackendBucketRequest.prototype.backendBucket = "";
    
                        /**
                         * AddSignedUrlKeyBackendBucketRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest
                         * @instance
                         */
                        AddSignedUrlKeyBackendBucketRequest.prototype.project = "";
    
                        /**
                         * AddSignedUrlKeyBackendBucketRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest
                         * @instance
                         */
                        AddSignedUrlKeyBackendBucketRequest.prototype.requestId = null;
    
                        /**
                         * AddSignedUrlKeyBackendBucketRequest signedUrlKeyResource.
                         * @member {google.cloud.compute.v1.ISignedUrlKey|null|undefined} signedUrlKeyResource
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest
                         * @instance
                         */
                        AddSignedUrlKeyBackendBucketRequest.prototype.signedUrlKeyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddSignedUrlKeyBackendBucketRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest
                         * @instance
                         */
                        Object.defineProperty(AddSignedUrlKeyBackendBucketRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddSignedUrlKeyBackendBucketRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddSignedUrlKeyBackendBucketRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest} AddSignedUrlKeyBackendBucketRequest instance
                         */
                        AddSignedUrlKeyBackendBucketRequest.create = function create(properties) {
                            return new AddSignedUrlKeyBackendBucketRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AddSignedUrlKeyBackendBucketRequest message. Does not implicitly {@link google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddSignedUrlKeyBackendBucketRequest} message AddSignedUrlKeyBackendBucketRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddSignedUrlKeyBackendBucketRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.backendBucket != null && Object.hasOwnProperty.call(message, "backendBucket"))
                                writer.uint32(/* id 91714037, wireType 2 =*/733712298).string(message.backendBucket);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.signedUrlKeyResource != null && Object.hasOwnProperty.call(message, "signedUrlKeyResource"))
                                $root.google.cloud.compute.v1.SignedUrlKey.encode(message.signedUrlKeyResource, writer.uint32(/* id 457625985, wireType 2 =*/3661007882).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddSignedUrlKeyBackendBucketRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddSignedUrlKeyBackendBucketRequest} message AddSignedUrlKeyBackendBucketRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddSignedUrlKeyBackendBucketRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddSignedUrlKeyBackendBucketRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest} AddSignedUrlKeyBackendBucketRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddSignedUrlKeyBackendBucketRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 91714037: {
                                        message.backendBucket = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 457625985: {
                                        message.signedUrlKeyResource = $root.google.cloud.compute.v1.SignedUrlKey.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddSignedUrlKeyBackendBucketRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest} AddSignedUrlKeyBackendBucketRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddSignedUrlKeyBackendBucketRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddSignedUrlKeyBackendBucketRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddSignedUrlKeyBackendBucketRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendBucket != null && message.hasOwnProperty("backendBucket"))
                                if (!$util.isString(message.backendBucket))
                                    return "backendBucket: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.signedUrlKeyResource != null && message.hasOwnProperty("signedUrlKeyResource")) {
                                var error = $root.google.cloud.compute.v1.SignedUrlKey.verify(message.signedUrlKeyResource);
                                if (error)
                                    return "signedUrlKeyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AddSignedUrlKeyBackendBucketRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest} AddSignedUrlKeyBackendBucketRequest
                         */
                        AddSignedUrlKeyBackendBucketRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest();
                            if (object.backendBucket != null)
                                message.backendBucket = String(object.backendBucket);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.signedUrlKeyResource != null) {
                                if (typeof object.signedUrlKeyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest.signedUrlKeyResource: object expected");
                                message.signedUrlKeyResource = $root.google.cloud.compute.v1.SignedUrlKey.fromObject(object.signedUrlKeyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddSignedUrlKeyBackendBucketRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest} message AddSignedUrlKeyBackendBucketRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddSignedUrlKeyBackendBucketRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.backendBucket = "";
                                object.project = "";
                                object.signedUrlKeyResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.backendBucket != null && message.hasOwnProperty("backendBucket"))
                                object.backendBucket = message.backendBucket;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.signedUrlKeyResource != null && message.hasOwnProperty("signedUrlKeyResource"))
                                object.signedUrlKeyResource = $root.google.cloud.compute.v1.SignedUrlKey.toObject(message.signedUrlKeyResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this AddSignedUrlKeyBackendBucketRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddSignedUrlKeyBackendBucketRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddSignedUrlKeyBackendBucketRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddSignedUrlKeyBackendBucketRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest";
                        };
    
                        return AddSignedUrlKeyBackendBucketRequest;
                    })();
    
                    v1.AddSignedUrlKeyBackendServiceRequest = (function() {
    
                        /**
                         * Properties of an AddSignedUrlKeyBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddSignedUrlKeyBackendServiceRequest
                         * @property {string|null} [backendService] AddSignedUrlKeyBackendServiceRequest backendService
                         * @property {string|null} [project] AddSignedUrlKeyBackendServiceRequest project
                         * @property {string|null} [requestId] AddSignedUrlKeyBackendServiceRequest requestId
                         * @property {google.cloud.compute.v1.ISignedUrlKey|null} [signedUrlKeyResource] AddSignedUrlKeyBackendServiceRequest signedUrlKeyResource
                         */
    
                        /**
                         * Constructs a new AddSignedUrlKeyBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddSignedUrlKeyBackendServiceRequest.
                         * @implements IAddSignedUrlKeyBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddSignedUrlKeyBackendServiceRequest=} [properties] Properties to set
                         */
                        function AddSignedUrlKeyBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddSignedUrlKeyBackendServiceRequest backendService.
                         * @member {string} backendService
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest
                         * @instance
                         */
                        AddSignedUrlKeyBackendServiceRequest.prototype.backendService = "";
    
                        /**
                         * AddSignedUrlKeyBackendServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest
                         * @instance
                         */
                        AddSignedUrlKeyBackendServiceRequest.prototype.project = "";
    
                        /**
                         * AddSignedUrlKeyBackendServiceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest
                         * @instance
                         */
                        AddSignedUrlKeyBackendServiceRequest.prototype.requestId = null;
    
                        /**
                         * AddSignedUrlKeyBackendServiceRequest signedUrlKeyResource.
                         * @member {google.cloud.compute.v1.ISignedUrlKey|null|undefined} signedUrlKeyResource
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest
                         * @instance
                         */
                        AddSignedUrlKeyBackendServiceRequest.prototype.signedUrlKeyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddSignedUrlKeyBackendServiceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest
                         * @instance
                         */
                        Object.defineProperty(AddSignedUrlKeyBackendServiceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddSignedUrlKeyBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddSignedUrlKeyBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest} AddSignedUrlKeyBackendServiceRequest instance
                         */
                        AddSignedUrlKeyBackendServiceRequest.create = function create(properties) {
                            return new AddSignedUrlKeyBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AddSignedUrlKeyBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddSignedUrlKeyBackendServiceRequest} message AddSignedUrlKeyBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddSignedUrlKeyBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.backendService != null && Object.hasOwnProperty.call(message, "backendService"))
                                writer.uint32(/* id 306946058, wireType 2 =*/2455568466).string(message.backendService);
                            if (message.signedUrlKeyResource != null && Object.hasOwnProperty.call(message, "signedUrlKeyResource"))
                                $root.google.cloud.compute.v1.SignedUrlKey.encode(message.signedUrlKeyResource, writer.uint32(/* id 457625985, wireType 2 =*/3661007882).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddSignedUrlKeyBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAddSignedUrlKeyBackendServiceRequest} message AddSignedUrlKeyBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddSignedUrlKeyBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddSignedUrlKeyBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest} AddSignedUrlKeyBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddSignedUrlKeyBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 306946058: {
                                        message.backendService = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 457625985: {
                                        message.signedUrlKeyResource = $root.google.cloud.compute.v1.SignedUrlKey.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddSignedUrlKeyBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest} AddSignedUrlKeyBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddSignedUrlKeyBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddSignedUrlKeyBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddSignedUrlKeyBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                if (!$util.isString(message.backendService))
                                    return "backendService: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.signedUrlKeyResource != null && message.hasOwnProperty("signedUrlKeyResource")) {
                                var error = $root.google.cloud.compute.v1.SignedUrlKey.verify(message.signedUrlKeyResource);
                                if (error)
                                    return "signedUrlKeyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AddSignedUrlKeyBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest} AddSignedUrlKeyBackendServiceRequest
                         */
                        AddSignedUrlKeyBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest();
                            if (object.backendService != null)
                                message.backendService = String(object.backendService);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.signedUrlKeyResource != null) {
                                if (typeof object.signedUrlKeyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest.signedUrlKeyResource: object expected");
                                message.signedUrlKeyResource = $root.google.cloud.compute.v1.SignedUrlKey.fromObject(object.signedUrlKeyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddSignedUrlKeyBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest} message AddSignedUrlKeyBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddSignedUrlKeyBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.backendService = "";
                                object.signedUrlKeyResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                object.backendService = message.backendService;
                            if (message.signedUrlKeyResource != null && message.hasOwnProperty("signedUrlKeyResource"))
                                object.signedUrlKeyResource = $root.google.cloud.compute.v1.SignedUrlKey.toObject(message.signedUrlKeyResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this AddSignedUrlKeyBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddSignedUrlKeyBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddSignedUrlKeyBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddSignedUrlKeyBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest";
                        };
    
                        return AddSignedUrlKeyBackendServiceRequest;
                    })();
    
                    v1.Address = (function() {
    
                        /**
                         * Properties of an Address.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddress
                         * @property {string|null} [address] Address address
                         * @property {string|null} [addressType] Address addressType
                         * @property {string|null} [creationTimestamp] Address creationTimestamp
                         * @property {string|null} [description] Address description
                         * @property {number|Long|null} [id] Address id
                         * @property {string|null} [ipVersion] Address ipVersion
                         * @property {string|null} [ipv6EndpointType] Address ipv6EndpointType
                         * @property {string|null} [kind] Address kind
                         * @property {string|null} [name] Address name
                         * @property {string|null} [network] Address network
                         * @property {string|null} [networkTier] Address networkTier
                         * @property {number|null} [prefixLength] Address prefixLength
                         * @property {string|null} [purpose] Address purpose
                         * @property {string|null} [region] Address region
                         * @property {string|null} [selfLink] Address selfLink
                         * @property {string|null} [status] Address status
                         * @property {string|null} [subnetwork] Address subnetwork
                         * @property {Array.<string>|null} [users] Address users
                         */
    
                        /**
                         * Constructs a new Address.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an Address.
                         * @implements IAddress
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddress=} [properties] Properties to set
                         */
                        function Address(properties) {
                            this.users = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Address address.
                         * @member {string|null|undefined} address
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Address.prototype.address = null;
    
                        /**
                         * Address addressType.
                         * @member {string|null|undefined} addressType
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Address.prototype.addressType = null;
    
                        /**
                         * Address creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Address.prototype.creationTimestamp = null;
    
                        /**
                         * Address description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Address.prototype.description = null;
    
                        /**
                         * Address id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Address.prototype.id = null;
    
                        /**
                         * Address ipVersion.
                         * @member {string|null|undefined} ipVersion
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Address.prototype.ipVersion = null;
    
                        /**
                         * Address ipv6EndpointType.
                         * @member {string|null|undefined} ipv6EndpointType
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Address.prototype.ipv6EndpointType = null;
    
                        /**
                         * Address kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Address.prototype.kind = null;
    
                        /**
                         * Address name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Address.prototype.name = null;
    
                        /**
                         * Address network.
                         * @member {string|null|undefined} network
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Address.prototype.network = null;
    
                        /**
                         * Address networkTier.
                         * @member {string|null|undefined} networkTier
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Address.prototype.networkTier = null;
    
                        /**
                         * Address prefixLength.
                         * @member {number|null|undefined} prefixLength
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Address.prototype.prefixLength = null;
    
                        /**
                         * Address purpose.
                         * @member {string|null|undefined} purpose
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Address.prototype.purpose = null;
    
                        /**
                         * Address region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Address.prototype.region = null;
    
                        /**
                         * Address selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Address.prototype.selfLink = null;
    
                        /**
                         * Address status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Address.prototype.status = null;
    
                        /**
                         * Address subnetwork.
                         * @member {string|null|undefined} subnetwork
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Address.prototype.subnetwork = null;
    
                        /**
                         * Address users.
                         * @member {Array.<string>} users
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Address.prototype.users = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Address _address.
                         * @member {"address"|undefined} _address
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_address", {
                            get: $util.oneOfGetter($oneOfFields = ["address"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _addressType.
                         * @member {"addressType"|undefined} _addressType
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_addressType", {
                            get: $util.oneOfGetter($oneOfFields = ["addressType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _ipVersion.
                         * @member {"ipVersion"|undefined} _ipVersion
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_ipVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["ipVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _ipv6EndpointType.
                         * @member {"ipv6EndpointType"|undefined} _ipv6EndpointType
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_ipv6EndpointType", {
                            get: $util.oneOfGetter($oneOfFields = ["ipv6EndpointType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _network.
                         * @member {"network"|undefined} _network
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_network", {
                            get: $util.oneOfGetter($oneOfFields = ["network"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _networkTier.
                         * @member {"networkTier"|undefined} _networkTier
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_networkTier", {
                            get: $util.oneOfGetter($oneOfFields = ["networkTier"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _prefixLength.
                         * @member {"prefixLength"|undefined} _prefixLength
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_prefixLength", {
                            get: $util.oneOfGetter($oneOfFields = ["prefixLength"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _purpose.
                         * @member {"purpose"|undefined} _purpose
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_purpose", {
                            get: $util.oneOfGetter($oneOfFields = ["purpose"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _subnetwork.
                         * @member {"subnetwork"|undefined} _subnetwork
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_subnetwork", {
                            get: $util.oneOfGetter($oneOfFields = ["subnetwork"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Address instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Address
                         * @static
                         * @param {google.cloud.compute.v1.IAddress=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Address} Address instance
                         */
                        Address.create = function create(properties) {
                            return new Address(properties);
                        };
    
                        /**
                         * Encodes the specified Address message. Does not implicitly {@link google.cloud.compute.v1.Address.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Address
                         * @static
                         * @param {google.cloud.compute.v1.IAddress} message Address message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Address.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.ipv6EndpointType != null && Object.hasOwnProperty.call(message, "ipv6EndpointType"))
                                writer.uint32(/* id 97501004, wireType 2 =*/780008034).string(message.ipv6EndpointType);
                            if (message.users != null && message.users.length)
                                for (var i = 0; i < message.users.length; ++i)
                                    writer.uint32(/* id 111578632, wireType 2 =*/892629058).string(message.users[i]);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            if (message.addressType != null && Object.hasOwnProperty.call(message, "addressType"))
                                writer.uint32(/* id 264307877, wireType 2 =*/2114463018).string(message.addressType);
                            if (message.ipVersion != null && Object.hasOwnProperty.call(message, "ipVersion"))
                                writer.uint32(/* id 294959552, wireType 2 =*/2359676418).string(message.ipVersion);
                            if (message.subnetwork != null && Object.hasOwnProperty.call(message, "subnetwork"))
                                writer.uint32(/* id 307827694, wireType 2 =*/2462621554).string(message.subnetwork);
                            if (message.purpose != null && Object.hasOwnProperty.call(message, "purpose"))
                                writer.uint32(/* id 316407070, wireType 2 =*/2531256562).string(message.purpose);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.prefixLength != null && Object.hasOwnProperty.call(message, "prefixLength"))
                                writer.uint32(/* id 453565747, wireType 0 =*/3628525976).int32(message.prefixLength);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.address != null && Object.hasOwnProperty.call(message, "address"))
                                writer.uint32(/* id 462920692, wireType 2 =*/3703365538).string(message.address);
                            if (message.networkTier != null && Object.hasOwnProperty.call(message, "networkTier"))
                                writer.uint32(/* id 517397843, wireType 2 =*/4139182746).string(message.networkTier);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Address message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Address.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Address
                         * @static
                         * @param {google.cloud.compute.v1.IAddress} message Address message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Address.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Address message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Address
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Address} Address
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Address.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Address();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 462920692: {
                                        message.address = reader.string();
                                        break;
                                    }
                                case 264307877: {
                                        message.addressType = reader.string();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 294959552: {
                                        message.ipVersion = reader.string();
                                        break;
                                    }
                                case 97501004: {
                                        message.ipv6EndpointType = reader.string();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 517397843: {
                                        message.networkTier = reader.string();
                                        break;
                                    }
                                case 453565747: {
                                        message.prefixLength = reader.int32();
                                        break;
                                    }
                                case 316407070: {
                                        message.purpose = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                case 307827694: {
                                        message.subnetwork = reader.string();
                                        break;
                                    }
                                case 111578632: {
                                        if (!(message.users && message.users.length))
                                            message.users = [];
                                        message.users.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Address message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Address
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Address} Address
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Address.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Address message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Address
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Address.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.address != null && message.hasOwnProperty("address")) {
                                properties._address = 1;
                                if (!$util.isString(message.address))
                                    return "address: string expected";
                            }
                            if (message.addressType != null && message.hasOwnProperty("addressType")) {
                                properties._addressType = 1;
                                if (!$util.isString(message.addressType))
                                    return "addressType: string expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.ipVersion != null && message.hasOwnProperty("ipVersion")) {
                                properties._ipVersion = 1;
                                if (!$util.isString(message.ipVersion))
                                    return "ipVersion: string expected";
                            }
                            if (message.ipv6EndpointType != null && message.hasOwnProperty("ipv6EndpointType")) {
                                properties._ipv6EndpointType = 1;
                                if (!$util.isString(message.ipv6EndpointType))
                                    return "ipv6EndpointType: string expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                properties._network = 1;
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            }
                            if (message.networkTier != null && message.hasOwnProperty("networkTier")) {
                                properties._networkTier = 1;
                                if (!$util.isString(message.networkTier))
                                    return "networkTier: string expected";
                            }
                            if (message.prefixLength != null && message.hasOwnProperty("prefixLength")) {
                                properties._prefixLength = 1;
                                if (!$util.isInteger(message.prefixLength))
                                    return "prefixLength: integer expected";
                            }
                            if (message.purpose != null && message.hasOwnProperty("purpose")) {
                                properties._purpose = 1;
                                if (!$util.isString(message.purpose))
                                    return "purpose: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork")) {
                                properties._subnetwork = 1;
                                if (!$util.isString(message.subnetwork))
                                    return "subnetwork: string expected";
                            }
                            if (message.users != null && message.hasOwnProperty("users")) {
                                if (!Array.isArray(message.users))
                                    return "users: array expected";
                                for (var i = 0; i < message.users.length; ++i)
                                    if (!$util.isString(message.users[i]))
                                        return "users: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an Address message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Address
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Address} Address
                         */
                        Address.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Address)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Address();
                            if (object.address != null)
                                message.address = String(object.address);
                            if (object.addressType != null)
                                message.addressType = String(object.addressType);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.ipVersion != null)
                                message.ipVersion = String(object.ipVersion);
                            if (object.ipv6EndpointType != null)
                                message.ipv6EndpointType = String(object.ipv6EndpointType);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.networkTier != null)
                                message.networkTier = String(object.networkTier);
                            if (object.prefixLength != null)
                                message.prefixLength = object.prefixLength | 0;
                            if (object.purpose != null)
                                message.purpose = String(object.purpose);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.status != null)
                                message.status = String(object.status);
                            if (object.subnetwork != null)
                                message.subnetwork = String(object.subnetwork);
                            if (object.users) {
                                if (!Array.isArray(object.users))
                                    throw TypeError(".google.cloud.compute.v1.Address.users: array expected");
                                message.users = [];
                                for (var i = 0; i < object.users.length; ++i)
                                    message.users[i] = String(object.users[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Address message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Address
                         * @static
                         * @param {google.cloud.compute.v1.Address} message Address
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Address.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.users = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.ipv6EndpointType != null && message.hasOwnProperty("ipv6EndpointType")) {
                                object.ipv6EndpointType = message.ipv6EndpointType;
                                if (options.oneofs)
                                    object._ipv6EndpointType = "ipv6EndpointType";
                            }
                            if (message.users && message.users.length) {
                                object.users = [];
                                for (var j = 0; j < message.users.length; ++j)
                                    object.users[j] = message.users[j];
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                object.network = message.network;
                                if (options.oneofs)
                                    object._network = "network";
                            }
                            if (message.addressType != null && message.hasOwnProperty("addressType")) {
                                object.addressType = message.addressType;
                                if (options.oneofs)
                                    object._addressType = "addressType";
                            }
                            if (message.ipVersion != null && message.hasOwnProperty("ipVersion")) {
                                object.ipVersion = message.ipVersion;
                                if (options.oneofs)
                                    object._ipVersion = "ipVersion";
                            }
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork")) {
                                object.subnetwork = message.subnetwork;
                                if (options.oneofs)
                                    object._subnetwork = "subnetwork";
                            }
                            if (message.purpose != null && message.hasOwnProperty("purpose")) {
                                object.purpose = message.purpose;
                                if (options.oneofs)
                                    object._purpose = "purpose";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.prefixLength != null && message.hasOwnProperty("prefixLength")) {
                                object.prefixLength = message.prefixLength;
                                if (options.oneofs)
                                    object._prefixLength = "prefixLength";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.address != null && message.hasOwnProperty("address")) {
                                object.address = message.address;
                                if (options.oneofs)
                                    object._address = "address";
                            }
                            if (message.networkTier != null && message.hasOwnProperty("networkTier")) {
                                object.networkTier = message.networkTier;
                                if (options.oneofs)
                                    object._networkTier = "networkTier";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Address to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Address
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Address.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Address
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Address
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Address.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Address";
                        };
    
                        /**
                         * AddressType enum.
                         * @name google.cloud.compute.v1.Address.AddressType
                         * @enum {number}
                         * @property {number} UNDEFINED_ADDRESS_TYPE=0 UNDEFINED_ADDRESS_TYPE value
                         * @property {number} EXTERNAL=35607499 EXTERNAL value
                         * @property {number} INTERNAL=279295677 INTERNAL value
                         * @property {number} UNSPECIFIED_TYPE=53933922 UNSPECIFIED_TYPE value
                         */
                        Address.AddressType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ADDRESS_TYPE"] = 0;
                            values[valuesById[35607499] = "EXTERNAL"] = 35607499;
                            values[valuesById[279295677] = "INTERNAL"] = 279295677;
                            values[valuesById[53933922] = "UNSPECIFIED_TYPE"] = 53933922;
                            return values;
                        })();
    
                        /**
                         * IpVersion enum.
                         * @name google.cloud.compute.v1.Address.IpVersion
                         * @enum {number}
                         * @property {number} UNDEFINED_IP_VERSION=0 UNDEFINED_IP_VERSION value
                         * @property {number} IPV4=2254341 IPV4 value
                         * @property {number} IPV6=2254343 IPV6 value
                         * @property {number} UNSPECIFIED_VERSION=21850000 UNSPECIFIED_VERSION value
                         */
                        Address.IpVersion = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_IP_VERSION"] = 0;
                            values[valuesById[2254341] = "IPV4"] = 2254341;
                            values[valuesById[2254343] = "IPV6"] = 2254343;
                            values[valuesById[21850000] = "UNSPECIFIED_VERSION"] = 21850000;
                            return values;
                        })();
    
                        /**
                         * Ipv6EndpointType enum.
                         * @name google.cloud.compute.v1.Address.Ipv6EndpointType
                         * @enum {number}
                         * @property {number} UNDEFINED_IPV6_ENDPOINT_TYPE=0 UNDEFINED_IPV6_ENDPOINT_TYPE value
                         * @property {number} NETLB=74173363 NETLB value
                         * @property {number} VM=2743 VM value
                         */
                        Address.Ipv6EndpointType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_IPV6_ENDPOINT_TYPE"] = 0;
                            values[valuesById[74173363] = "NETLB"] = 74173363;
                            values[valuesById[2743] = "VM"] = 2743;
                            return values;
                        })();
    
                        /**
                         * NetworkTier enum.
                         * @name google.cloud.compute.v1.Address.NetworkTier
                         * @enum {number}
                         * @property {number} UNDEFINED_NETWORK_TIER=0 UNDEFINED_NETWORK_TIER value
                         * @property {number} FIXED_STANDARD=310464328 FIXED_STANDARD value
                         * @property {number} PREMIUM=399530551 PREMIUM value
                         * @property {number} STANDARD=484642493 STANDARD value
                         * @property {number} STANDARD_OVERRIDES_FIXED_STANDARD=465847234 STANDARD_OVERRIDES_FIXED_STANDARD value
                         */
                        Address.NetworkTier = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_NETWORK_TIER"] = 0;
                            values[valuesById[310464328] = "FIXED_STANDARD"] = 310464328;
                            values[valuesById[399530551] = "PREMIUM"] = 399530551;
                            values[valuesById[484642493] = "STANDARD"] = 484642493;
                            values[valuesById[465847234] = "STANDARD_OVERRIDES_FIXED_STANDARD"] = 465847234;
                            return values;
                        })();
    
                        /**
                         * Purpose enum.
                         * @name google.cloud.compute.v1.Address.Purpose
                         * @enum {number}
                         * @property {number} UNDEFINED_PURPOSE=0 UNDEFINED_PURPOSE value
                         * @property {number} DNS_RESOLVER=476114556 DNS_RESOLVER value
                         * @property {number} GCE_ENDPOINT=230515243 GCE_ENDPOINT value
                         * @property {number} IPSEC_INTERCONNECT=340437251 IPSEC_INTERCONNECT value
                         * @property {number} NAT_AUTO=163666477 NAT_AUTO value
                         * @property {number} PRIVATE_SERVICE_CONNECT=48134724 PRIVATE_SERVICE_CONNECT value
                         * @property {number} SERVERLESS=270492508 SERVERLESS value
                         * @property {number} SHARED_LOADBALANCER_VIP=294447572 SHARED_LOADBALANCER_VIP value
                         * @property {number} VPC_PEERING=400800170 VPC_PEERING value
                         */
                        Address.Purpose = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PURPOSE"] = 0;
                            values[valuesById[476114556] = "DNS_RESOLVER"] = 476114556;
                            values[valuesById[230515243] = "GCE_ENDPOINT"] = 230515243;
                            values[valuesById[340437251] = "IPSEC_INTERCONNECT"] = 340437251;
                            values[valuesById[163666477] = "NAT_AUTO"] = 163666477;
                            values[valuesById[48134724] = "PRIVATE_SERVICE_CONNECT"] = 48134724;
                            values[valuesById[270492508] = "SERVERLESS"] = 270492508;
                            values[valuesById[294447572] = "SHARED_LOADBALANCER_VIP"] = 294447572;
                            values[valuesById[400800170] = "VPC_PEERING"] = 400800170;
                            return values;
                        })();
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.Address.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} IN_USE=17393485 IN_USE value
                         * @property {number} RESERVED=432241448 RESERVED value
                         * @property {number} RESERVING=514587225 RESERVING value
                         */
                        Address.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[17393485] = "IN_USE"] = 17393485;
                            values[valuesById[432241448] = "RESERVED"] = 432241448;
                            values[valuesById[514587225] = "RESERVING"] = 514587225;
                            return values;
                        })();
    
                        return Address;
                    })();
    
                    v1.AddressAggregatedList = (function() {
    
                        /**
                         * Properties of an AddressAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddressAggregatedList
                         * @property {string|null} [id] AddressAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IAddressesScopedList>|null} [items] AddressAggregatedList items
                         * @property {string|null} [kind] AddressAggregatedList kind
                         * @property {string|null} [nextPageToken] AddressAggregatedList nextPageToken
                         * @property {string|null} [selfLink] AddressAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] AddressAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] AddressAggregatedList warning
                         */
    
                        /**
                         * Constructs a new AddressAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddressAggregatedList.
                         * @implements IAddressAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddressAggregatedList=} [properties] Properties to set
                         */
                        function AddressAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddressAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @instance
                         */
                        AddressAggregatedList.prototype.id = null;
    
                        /**
                         * AddressAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IAddressesScopedList>} items
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @instance
                         */
                        AddressAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * AddressAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @instance
                         */
                        AddressAggregatedList.prototype.kind = null;
    
                        /**
                         * AddressAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @instance
                         */
                        AddressAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * AddressAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @instance
                         */
                        AddressAggregatedList.prototype.selfLink = null;
    
                        /**
                         * AddressAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @instance
                         */
                        AddressAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * AddressAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @instance
                         */
                        AddressAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddressAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @instance
                         */
                        Object.defineProperty(AddressAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddressAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @instance
                         */
                        Object.defineProperty(AddressAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddressAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @instance
                         */
                        Object.defineProperty(AddressAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddressAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @instance
                         */
                        Object.defineProperty(AddressAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddressAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @instance
                         */
                        Object.defineProperty(AddressAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddressAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IAddressAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddressAggregatedList} AddressAggregatedList instance
                         */
                        AddressAggregatedList.create = function create(properties) {
                            return new AddressAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified AddressAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.AddressAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IAddressAggregatedList} message AddressAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddressAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.AddressesScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddressAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddressAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IAddressAggregatedList} message AddressAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddressAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddressAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddressAggregatedList} AddressAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddressAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddressAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.AddressesScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddressAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddressAggregatedList} AddressAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddressAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddressAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddressAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AddressesScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AddressAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddressAggregatedList} AddressAggregatedList
                         */
                        AddressAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddressAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddressAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddressAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.AddressAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.AddressesScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.AddressAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddressAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddressAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.AddressAggregatedList} message AddressAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddressAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.AddressesScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AddressAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddressAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddressAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddressAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddressAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddressAggregatedList";
                        };
    
                        return AddressAggregatedList;
                    })();
    
                    v1.AddressList = (function() {
    
                        /**
                         * Properties of an AddressList.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddressList
                         * @property {string|null} [id] AddressList id
                         * @property {Array.<google.cloud.compute.v1.IAddress>|null} [items] AddressList items
                         * @property {string|null} [kind] AddressList kind
                         * @property {string|null} [nextPageToken] AddressList nextPageToken
                         * @property {string|null} [selfLink] AddressList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] AddressList warning
                         */
    
                        /**
                         * Constructs a new AddressList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddressList.
                         * @implements IAddressList
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddressList=} [properties] Properties to set
                         */
                        function AddressList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddressList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.AddressList
                         * @instance
                         */
                        AddressList.prototype.id = null;
    
                        /**
                         * AddressList items.
                         * @member {Array.<google.cloud.compute.v1.IAddress>} items
                         * @memberof google.cloud.compute.v1.AddressList
                         * @instance
                         */
                        AddressList.prototype.items = $util.emptyArray;
    
                        /**
                         * AddressList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.AddressList
                         * @instance
                         */
                        AddressList.prototype.kind = null;
    
                        /**
                         * AddressList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.AddressList
                         * @instance
                         */
                        AddressList.prototype.nextPageToken = null;
    
                        /**
                         * AddressList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.AddressList
                         * @instance
                         */
                        AddressList.prototype.selfLink = null;
    
                        /**
                         * AddressList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.AddressList
                         * @instance
                         */
                        AddressList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddressList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.AddressList
                         * @instance
                         */
                        Object.defineProperty(AddressList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddressList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.AddressList
                         * @instance
                         */
                        Object.defineProperty(AddressList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddressList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.AddressList
                         * @instance
                         */
                        Object.defineProperty(AddressList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddressList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.AddressList
                         * @instance
                         */
                        Object.defineProperty(AddressList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddressList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.AddressList
                         * @instance
                         */
                        Object.defineProperty(AddressList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddressList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddressList
                         * @static
                         * @param {google.cloud.compute.v1.IAddressList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddressList} AddressList instance
                         */
                        AddressList.create = function create(properties) {
                            return new AddressList(properties);
                        };
    
                        /**
                         * Encodes the specified AddressList message. Does not implicitly {@link google.cloud.compute.v1.AddressList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddressList
                         * @static
                         * @param {google.cloud.compute.v1.IAddressList} message AddressList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddressList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Address.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddressList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddressList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddressList
                         * @static
                         * @param {google.cloud.compute.v1.IAddressList} message AddressList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddressList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddressList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddressList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddressList} AddressList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddressList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddressList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Address.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddressList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddressList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddressList} AddressList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddressList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddressList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddressList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddressList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Address.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AddressList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddressList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddressList} AddressList
                         */
                        AddressList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddressList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddressList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.AddressList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.AddressList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Address.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddressList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddressList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddressList
                         * @static
                         * @param {google.cloud.compute.v1.AddressList} message AddressList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddressList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Address.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AddressList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddressList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddressList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddressList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddressList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddressList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddressList";
                        };
    
                        return AddressList;
                    })();
    
                    v1.AddressesScopedList = (function() {
    
                        /**
                         * Properties of an AddressesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IAddressesScopedList
                         * @property {Array.<google.cloud.compute.v1.IAddress>|null} [addresses] AddressesScopedList addresses
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] AddressesScopedList warning
                         */
    
                        /**
                         * Constructs a new AddressesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AddressesScopedList.
                         * @implements IAddressesScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IAddressesScopedList=} [properties] Properties to set
                         */
                        function AddressesScopedList(properties) {
                            this.addresses = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddressesScopedList addresses.
                         * @member {Array.<google.cloud.compute.v1.IAddress>} addresses
                         * @memberof google.cloud.compute.v1.AddressesScopedList
                         * @instance
                         */
                        AddressesScopedList.prototype.addresses = $util.emptyArray;
    
                        /**
                         * AddressesScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.AddressesScopedList
                         * @instance
                         */
                        AddressesScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddressesScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.AddressesScopedList
                         * @instance
                         */
                        Object.defineProperty(AddressesScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddressesScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AddressesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IAddressesScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AddressesScopedList} AddressesScopedList instance
                         */
                        AddressesScopedList.create = function create(properties) {
                            return new AddressesScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified AddressesScopedList message. Does not implicitly {@link google.cloud.compute.v1.AddressesScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AddressesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IAddressesScopedList} message AddressesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddressesScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.addresses != null && message.addresses.length)
                                for (var i = 0; i < message.addresses.length; ++i)
                                    $root.google.cloud.compute.v1.Address.encode(message.addresses[i], writer.uint32(/* id 337673122, wireType 2 =*/2701384978).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddressesScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AddressesScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AddressesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IAddressesScopedList} message AddressesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddressesScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddressesScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AddressesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AddressesScopedList} AddressesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddressesScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AddressesScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 337673122: {
                                        if (!(message.addresses && message.addresses.length))
                                            message.addresses = [];
                                        message.addresses.push($root.google.cloud.compute.v1.Address.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddressesScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AddressesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AddressesScopedList} AddressesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddressesScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddressesScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AddressesScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddressesScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.addresses != null && message.hasOwnProperty("addresses")) {
                                if (!Array.isArray(message.addresses))
                                    return "addresses: array expected";
                                for (var i = 0; i < message.addresses.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Address.verify(message.addresses[i]);
                                    if (error)
                                        return "addresses." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AddressesScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AddressesScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AddressesScopedList} AddressesScopedList
                         */
                        AddressesScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AddressesScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AddressesScopedList();
                            if (object.addresses) {
                                if (!Array.isArray(object.addresses))
                                    throw TypeError(".google.cloud.compute.v1.AddressesScopedList.addresses: array expected");
                                message.addresses = [];
                                for (var i = 0; i < object.addresses.length; ++i) {
                                    if (typeof object.addresses[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.AddressesScopedList.addresses: object expected");
                                    message.addresses[i] = $root.google.cloud.compute.v1.Address.fromObject(object.addresses[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AddressesScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddressesScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AddressesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.AddressesScopedList} message AddressesScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddressesScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.addresses = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.addresses && message.addresses.length) {
                                object.addresses = [];
                                for (var j = 0; j < message.addresses.length; ++j)
                                    object.addresses[j] = $root.google.cloud.compute.v1.Address.toObject(message.addresses[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AddressesScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AddressesScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddressesScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddressesScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AddressesScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddressesScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AddressesScopedList";
                        };
    
                        return AddressesScopedList;
                    })();
    
                    v1.AdvancedMachineFeatures = (function() {
    
                        /**
                         * Properties of an AdvancedMachineFeatures.
                         * @memberof google.cloud.compute.v1
                         * @interface IAdvancedMachineFeatures
                         * @property {boolean|null} [enableNestedVirtualization] AdvancedMachineFeatures enableNestedVirtualization
                         * @property {boolean|null} [enableUefiNetworking] AdvancedMachineFeatures enableUefiNetworking
                         * @property {number|null} [threadsPerCore] AdvancedMachineFeatures threadsPerCore
                         * @property {number|null} [visibleCoreCount] AdvancedMachineFeatures visibleCoreCount
                         */
    
                        /**
                         * Constructs a new AdvancedMachineFeatures.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AdvancedMachineFeatures.
                         * @implements IAdvancedMachineFeatures
                         * @constructor
                         * @param {google.cloud.compute.v1.IAdvancedMachineFeatures=} [properties] Properties to set
                         */
                        function AdvancedMachineFeatures(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AdvancedMachineFeatures enableNestedVirtualization.
                         * @member {boolean|null|undefined} enableNestedVirtualization
                         * @memberof google.cloud.compute.v1.AdvancedMachineFeatures
                         * @instance
                         */
                        AdvancedMachineFeatures.prototype.enableNestedVirtualization = null;
    
                        /**
                         * AdvancedMachineFeatures enableUefiNetworking.
                         * @member {boolean|null|undefined} enableUefiNetworking
                         * @memberof google.cloud.compute.v1.AdvancedMachineFeatures
                         * @instance
                         */
                        AdvancedMachineFeatures.prototype.enableUefiNetworking = null;
    
                        /**
                         * AdvancedMachineFeatures threadsPerCore.
                         * @member {number|null|undefined} threadsPerCore
                         * @memberof google.cloud.compute.v1.AdvancedMachineFeatures
                         * @instance
                         */
                        AdvancedMachineFeatures.prototype.threadsPerCore = null;
    
                        /**
                         * AdvancedMachineFeatures visibleCoreCount.
                         * @member {number|null|undefined} visibleCoreCount
                         * @memberof google.cloud.compute.v1.AdvancedMachineFeatures
                         * @instance
                         */
                        AdvancedMachineFeatures.prototype.visibleCoreCount = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AdvancedMachineFeatures _enableNestedVirtualization.
                         * @member {"enableNestedVirtualization"|undefined} _enableNestedVirtualization
                         * @memberof google.cloud.compute.v1.AdvancedMachineFeatures
                         * @instance
                         */
                        Object.defineProperty(AdvancedMachineFeatures.prototype, "_enableNestedVirtualization", {
                            get: $util.oneOfGetter($oneOfFields = ["enableNestedVirtualization"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AdvancedMachineFeatures _enableUefiNetworking.
                         * @member {"enableUefiNetworking"|undefined} _enableUefiNetworking
                         * @memberof google.cloud.compute.v1.AdvancedMachineFeatures
                         * @instance
                         */
                        Object.defineProperty(AdvancedMachineFeatures.prototype, "_enableUefiNetworking", {
                            get: $util.oneOfGetter($oneOfFields = ["enableUefiNetworking"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AdvancedMachineFeatures _threadsPerCore.
                         * @member {"threadsPerCore"|undefined} _threadsPerCore
                         * @memberof google.cloud.compute.v1.AdvancedMachineFeatures
                         * @instance
                         */
                        Object.defineProperty(AdvancedMachineFeatures.prototype, "_threadsPerCore", {
                            get: $util.oneOfGetter($oneOfFields = ["threadsPerCore"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AdvancedMachineFeatures _visibleCoreCount.
                         * @member {"visibleCoreCount"|undefined} _visibleCoreCount
                         * @memberof google.cloud.compute.v1.AdvancedMachineFeatures
                         * @instance
                         */
                        Object.defineProperty(AdvancedMachineFeatures.prototype, "_visibleCoreCount", {
                            get: $util.oneOfGetter($oneOfFields = ["visibleCoreCount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AdvancedMachineFeatures instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AdvancedMachineFeatures
                         * @static
                         * @param {google.cloud.compute.v1.IAdvancedMachineFeatures=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AdvancedMachineFeatures} AdvancedMachineFeatures instance
                         */
                        AdvancedMachineFeatures.create = function create(properties) {
                            return new AdvancedMachineFeatures(properties);
                        };
    
                        /**
                         * Encodes the specified AdvancedMachineFeatures message. Does not implicitly {@link google.cloud.compute.v1.AdvancedMachineFeatures.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AdvancedMachineFeatures
                         * @static
                         * @param {google.cloud.compute.v1.IAdvancedMachineFeatures} message AdvancedMachineFeatures message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdvancedMachineFeatures.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.enableNestedVirtualization != null && Object.hasOwnProperty.call(message, "enableNestedVirtualization"))
                                writer.uint32(/* id 16639365, wireType 0 =*/133114920).bool(message.enableNestedVirtualization);
                            if (message.visibleCoreCount != null && Object.hasOwnProperty.call(message, "visibleCoreCount"))
                                writer.uint32(/* id 193198684, wireType 0 =*/1545589472).int32(message.visibleCoreCount);
                            if (message.enableUefiNetworking != null && Object.hasOwnProperty.call(message, "enableUefiNetworking"))
                                writer.uint32(/* id 334485668, wireType 0 =*/2675885344).bool(message.enableUefiNetworking);
                            if (message.threadsPerCore != null && Object.hasOwnProperty.call(message, "threadsPerCore"))
                                writer.uint32(/* id 352611671, wireType 0 =*/2820893368).int32(message.threadsPerCore);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AdvancedMachineFeatures message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AdvancedMachineFeatures.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AdvancedMachineFeatures
                         * @static
                         * @param {google.cloud.compute.v1.IAdvancedMachineFeatures} message AdvancedMachineFeatures message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AdvancedMachineFeatures.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AdvancedMachineFeatures message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AdvancedMachineFeatures
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AdvancedMachineFeatures} AdvancedMachineFeatures
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdvancedMachineFeatures.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AdvancedMachineFeatures();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 16639365: {
                                        message.enableNestedVirtualization = reader.bool();
                                        break;
                                    }
                                case 334485668: {
                                        message.enableUefiNetworking = reader.bool();
                                        break;
                                    }
                                case 352611671: {
                                        message.threadsPerCore = reader.int32();
                                        break;
                                    }
                                case 193198684: {
                                        message.visibleCoreCount = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AdvancedMachineFeatures message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AdvancedMachineFeatures
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AdvancedMachineFeatures} AdvancedMachineFeatures
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AdvancedMachineFeatures.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AdvancedMachineFeatures message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AdvancedMachineFeatures
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AdvancedMachineFeatures.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.enableNestedVirtualization != null && message.hasOwnProperty("enableNestedVirtualization")) {
                                properties._enableNestedVirtualization = 1;
                                if (typeof message.enableNestedVirtualization !== "boolean")
                                    return "enableNestedVirtualization: boolean expected";
                            }
                            if (message.enableUefiNetworking != null && message.hasOwnProperty("enableUefiNetworking")) {
                                properties._enableUefiNetworking = 1;
                                if (typeof message.enableUefiNetworking !== "boolean")
                                    return "enableUefiNetworking: boolean expected";
                            }
                            if (message.threadsPerCore != null && message.hasOwnProperty("threadsPerCore")) {
                                properties._threadsPerCore = 1;
                                if (!$util.isInteger(message.threadsPerCore))
                                    return "threadsPerCore: integer expected";
                            }
                            if (message.visibleCoreCount != null && message.hasOwnProperty("visibleCoreCount")) {
                                properties._visibleCoreCount = 1;
                                if (!$util.isInteger(message.visibleCoreCount))
                                    return "visibleCoreCount: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AdvancedMachineFeatures message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AdvancedMachineFeatures
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AdvancedMachineFeatures} AdvancedMachineFeatures
                         */
                        AdvancedMachineFeatures.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AdvancedMachineFeatures)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AdvancedMachineFeatures();
                            if (object.enableNestedVirtualization != null)
                                message.enableNestedVirtualization = Boolean(object.enableNestedVirtualization);
                            if (object.enableUefiNetworking != null)
                                message.enableUefiNetworking = Boolean(object.enableUefiNetworking);
                            if (object.threadsPerCore != null)
                                message.threadsPerCore = object.threadsPerCore | 0;
                            if (object.visibleCoreCount != null)
                                message.visibleCoreCount = object.visibleCoreCount | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AdvancedMachineFeatures message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AdvancedMachineFeatures
                         * @static
                         * @param {google.cloud.compute.v1.AdvancedMachineFeatures} message AdvancedMachineFeatures
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AdvancedMachineFeatures.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.enableNestedVirtualization != null && message.hasOwnProperty("enableNestedVirtualization")) {
                                object.enableNestedVirtualization = message.enableNestedVirtualization;
                                if (options.oneofs)
                                    object._enableNestedVirtualization = "enableNestedVirtualization";
                            }
                            if (message.visibleCoreCount != null && message.hasOwnProperty("visibleCoreCount")) {
                                object.visibleCoreCount = message.visibleCoreCount;
                                if (options.oneofs)
                                    object._visibleCoreCount = "visibleCoreCount";
                            }
                            if (message.enableUefiNetworking != null && message.hasOwnProperty("enableUefiNetworking")) {
                                object.enableUefiNetworking = message.enableUefiNetworking;
                                if (options.oneofs)
                                    object._enableUefiNetworking = "enableUefiNetworking";
                            }
                            if (message.threadsPerCore != null && message.hasOwnProperty("threadsPerCore")) {
                                object.threadsPerCore = message.threadsPerCore;
                                if (options.oneofs)
                                    object._threadsPerCore = "threadsPerCore";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AdvancedMachineFeatures to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AdvancedMachineFeatures
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AdvancedMachineFeatures.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AdvancedMachineFeatures
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AdvancedMachineFeatures
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AdvancedMachineFeatures.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AdvancedMachineFeatures";
                        };
    
                        return AdvancedMachineFeatures;
                    })();
    
                    v1.AggregatedListAcceleratorTypesRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListAcceleratorTypesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListAcceleratorTypesRequest
                         * @property {string|null} [filter] AggregatedListAcceleratorTypesRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListAcceleratorTypesRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListAcceleratorTypesRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListAcceleratorTypesRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListAcceleratorTypesRequest pageToken
                         * @property {string|null} [project] AggregatedListAcceleratorTypesRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListAcceleratorTypesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListAcceleratorTypesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListAcceleratorTypesRequest.
                         * @implements IAggregatedListAcceleratorTypesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListAcceleratorTypesRequest=} [properties] Properties to set
                         */
                        function AggregatedListAcceleratorTypesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListAcceleratorTypesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @instance
                         */
                        AggregatedListAcceleratorTypesRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListAcceleratorTypesRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @instance
                         */
                        AggregatedListAcceleratorTypesRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListAcceleratorTypesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @instance
                         */
                        AggregatedListAcceleratorTypesRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListAcceleratorTypesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @instance
                         */
                        AggregatedListAcceleratorTypesRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListAcceleratorTypesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @instance
                         */
                        AggregatedListAcceleratorTypesRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListAcceleratorTypesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @instance
                         */
                        AggregatedListAcceleratorTypesRequest.prototype.project = "";
    
                        /**
                         * AggregatedListAcceleratorTypesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @instance
                         */
                        AggregatedListAcceleratorTypesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListAcceleratorTypesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAcceleratorTypesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListAcceleratorTypesRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAcceleratorTypesRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListAcceleratorTypesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAcceleratorTypesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListAcceleratorTypesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAcceleratorTypesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListAcceleratorTypesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAcceleratorTypesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListAcceleratorTypesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAcceleratorTypesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListAcceleratorTypesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListAcceleratorTypesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest} AggregatedListAcceleratorTypesRequest instance
                         */
                        AggregatedListAcceleratorTypesRequest.create = function create(properties) {
                            return new AggregatedListAcceleratorTypesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListAcceleratorTypesRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListAcceleratorTypesRequest} message AggregatedListAcceleratorTypesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListAcceleratorTypesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListAcceleratorTypesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListAcceleratorTypesRequest} message AggregatedListAcceleratorTypesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListAcceleratorTypesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListAcceleratorTypesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest} AggregatedListAcceleratorTypesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListAcceleratorTypesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListAcceleratorTypesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest} AggregatedListAcceleratorTypesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListAcceleratorTypesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListAcceleratorTypesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListAcceleratorTypesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListAcceleratorTypesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest} AggregatedListAcceleratorTypesRequest
                         */
                        AggregatedListAcceleratorTypesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListAcceleratorTypesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest} message AggregatedListAcceleratorTypesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListAcceleratorTypesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListAcceleratorTypesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListAcceleratorTypesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListAcceleratorTypesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListAcceleratorTypesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest";
                        };
    
                        return AggregatedListAcceleratorTypesRequest;
                    })();
    
                    v1.AggregatedListAddressesRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListAddressesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListAddressesRequest
                         * @property {string|null} [filter] AggregatedListAddressesRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListAddressesRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListAddressesRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListAddressesRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListAddressesRequest pageToken
                         * @property {string|null} [project] AggregatedListAddressesRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListAddressesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListAddressesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListAddressesRequest.
                         * @implements IAggregatedListAddressesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListAddressesRequest=} [properties] Properties to set
                         */
                        function AggregatedListAddressesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListAddressesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @instance
                         */
                        AggregatedListAddressesRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListAddressesRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @instance
                         */
                        AggregatedListAddressesRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListAddressesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @instance
                         */
                        AggregatedListAddressesRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListAddressesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @instance
                         */
                        AggregatedListAddressesRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListAddressesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @instance
                         */
                        AggregatedListAddressesRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListAddressesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @instance
                         */
                        AggregatedListAddressesRequest.prototype.project = "";
    
                        /**
                         * AggregatedListAddressesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @instance
                         */
                        AggregatedListAddressesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListAddressesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAddressesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListAddressesRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAddressesRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListAddressesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAddressesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListAddressesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAddressesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListAddressesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAddressesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListAddressesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAddressesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListAddressesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListAddressesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListAddressesRequest} AggregatedListAddressesRequest instance
                         */
                        AggregatedListAddressesRequest.create = function create(properties) {
                            return new AggregatedListAddressesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListAddressesRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListAddressesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListAddressesRequest} message AggregatedListAddressesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListAddressesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListAddressesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListAddressesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListAddressesRequest} message AggregatedListAddressesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListAddressesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListAddressesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListAddressesRequest} AggregatedListAddressesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListAddressesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListAddressesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListAddressesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListAddressesRequest} AggregatedListAddressesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListAddressesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListAddressesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListAddressesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListAddressesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListAddressesRequest} AggregatedListAddressesRequest
                         */
                        AggregatedListAddressesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListAddressesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListAddressesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListAddressesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListAddressesRequest} message AggregatedListAddressesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListAddressesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListAddressesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListAddressesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListAddressesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListAddressesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListAddressesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListAddressesRequest";
                        };
    
                        return AggregatedListAddressesRequest;
                    })();
    
                    v1.AggregatedListAutoscalersRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListAutoscalersRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListAutoscalersRequest
                         * @property {string|null} [filter] AggregatedListAutoscalersRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListAutoscalersRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListAutoscalersRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListAutoscalersRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListAutoscalersRequest pageToken
                         * @property {string|null} [project] AggregatedListAutoscalersRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListAutoscalersRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListAutoscalersRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListAutoscalersRequest.
                         * @implements IAggregatedListAutoscalersRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListAutoscalersRequest=} [properties] Properties to set
                         */
                        function AggregatedListAutoscalersRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListAutoscalersRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @instance
                         */
                        AggregatedListAutoscalersRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListAutoscalersRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @instance
                         */
                        AggregatedListAutoscalersRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListAutoscalersRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @instance
                         */
                        AggregatedListAutoscalersRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListAutoscalersRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @instance
                         */
                        AggregatedListAutoscalersRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListAutoscalersRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @instance
                         */
                        AggregatedListAutoscalersRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListAutoscalersRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @instance
                         */
                        AggregatedListAutoscalersRequest.prototype.project = "";
    
                        /**
                         * AggregatedListAutoscalersRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @instance
                         */
                        AggregatedListAutoscalersRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListAutoscalersRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAutoscalersRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListAutoscalersRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAutoscalersRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListAutoscalersRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAutoscalersRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListAutoscalersRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAutoscalersRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListAutoscalersRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAutoscalersRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListAutoscalersRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAutoscalersRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListAutoscalersRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListAutoscalersRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListAutoscalersRequest} AggregatedListAutoscalersRequest instance
                         */
                        AggregatedListAutoscalersRequest.create = function create(properties) {
                            return new AggregatedListAutoscalersRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListAutoscalersRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListAutoscalersRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListAutoscalersRequest} message AggregatedListAutoscalersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListAutoscalersRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListAutoscalersRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListAutoscalersRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListAutoscalersRequest} message AggregatedListAutoscalersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListAutoscalersRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListAutoscalersRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListAutoscalersRequest} AggregatedListAutoscalersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListAutoscalersRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListAutoscalersRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListAutoscalersRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListAutoscalersRequest} AggregatedListAutoscalersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListAutoscalersRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListAutoscalersRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListAutoscalersRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListAutoscalersRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListAutoscalersRequest} AggregatedListAutoscalersRequest
                         */
                        AggregatedListAutoscalersRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListAutoscalersRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListAutoscalersRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListAutoscalersRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListAutoscalersRequest} message AggregatedListAutoscalersRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListAutoscalersRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListAutoscalersRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListAutoscalersRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListAutoscalersRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListAutoscalersRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListAutoscalersRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListAutoscalersRequest";
                        };
    
                        return AggregatedListAutoscalersRequest;
                    })();
    
                    v1.AggregatedListBackendServicesRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListBackendServicesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListBackendServicesRequest
                         * @property {string|null} [filter] AggregatedListBackendServicesRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListBackendServicesRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListBackendServicesRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListBackendServicesRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListBackendServicesRequest pageToken
                         * @property {string|null} [project] AggregatedListBackendServicesRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListBackendServicesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListBackendServicesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListBackendServicesRequest.
                         * @implements IAggregatedListBackendServicesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListBackendServicesRequest=} [properties] Properties to set
                         */
                        function AggregatedListBackendServicesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListBackendServicesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @instance
                         */
                        AggregatedListBackendServicesRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListBackendServicesRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @instance
                         */
                        AggregatedListBackendServicesRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListBackendServicesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @instance
                         */
                        AggregatedListBackendServicesRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListBackendServicesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @instance
                         */
                        AggregatedListBackendServicesRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListBackendServicesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @instance
                         */
                        AggregatedListBackendServicesRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListBackendServicesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @instance
                         */
                        AggregatedListBackendServicesRequest.prototype.project = "";
    
                        /**
                         * AggregatedListBackendServicesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @instance
                         */
                        AggregatedListBackendServicesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListBackendServicesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListBackendServicesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListBackendServicesRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListBackendServicesRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListBackendServicesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListBackendServicesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListBackendServicesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListBackendServicesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListBackendServicesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListBackendServicesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListBackendServicesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListBackendServicesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListBackendServicesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListBackendServicesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListBackendServicesRequest} AggregatedListBackendServicesRequest instance
                         */
                        AggregatedListBackendServicesRequest.create = function create(properties) {
                            return new AggregatedListBackendServicesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListBackendServicesRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListBackendServicesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListBackendServicesRequest} message AggregatedListBackendServicesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListBackendServicesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListBackendServicesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListBackendServicesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListBackendServicesRequest} message AggregatedListBackendServicesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListBackendServicesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListBackendServicesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListBackendServicesRequest} AggregatedListBackendServicesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListBackendServicesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListBackendServicesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListBackendServicesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListBackendServicesRequest} AggregatedListBackendServicesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListBackendServicesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListBackendServicesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListBackendServicesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListBackendServicesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListBackendServicesRequest} AggregatedListBackendServicesRequest
                         */
                        AggregatedListBackendServicesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListBackendServicesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListBackendServicesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListBackendServicesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListBackendServicesRequest} message AggregatedListBackendServicesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListBackendServicesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListBackendServicesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListBackendServicesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListBackendServicesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListBackendServicesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListBackendServicesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListBackendServicesRequest";
                        };
    
                        return AggregatedListBackendServicesRequest;
                    })();
    
                    v1.AggregatedListDiskTypesRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListDiskTypesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListDiskTypesRequest
                         * @property {string|null} [filter] AggregatedListDiskTypesRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListDiskTypesRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListDiskTypesRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListDiskTypesRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListDiskTypesRequest pageToken
                         * @property {string|null} [project] AggregatedListDiskTypesRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListDiskTypesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListDiskTypesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListDiskTypesRequest.
                         * @implements IAggregatedListDiskTypesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListDiskTypesRequest=} [properties] Properties to set
                         */
                        function AggregatedListDiskTypesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListDiskTypesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @instance
                         */
                        AggregatedListDiskTypesRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListDiskTypesRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @instance
                         */
                        AggregatedListDiskTypesRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListDiskTypesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @instance
                         */
                        AggregatedListDiskTypesRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListDiskTypesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @instance
                         */
                        AggregatedListDiskTypesRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListDiskTypesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @instance
                         */
                        AggregatedListDiskTypesRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListDiskTypesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @instance
                         */
                        AggregatedListDiskTypesRequest.prototype.project = "";
    
                        /**
                         * AggregatedListDiskTypesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @instance
                         */
                        AggregatedListDiskTypesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListDiskTypesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListDiskTypesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListDiskTypesRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListDiskTypesRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListDiskTypesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListDiskTypesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListDiskTypesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListDiskTypesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListDiskTypesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListDiskTypesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListDiskTypesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListDiskTypesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListDiskTypesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListDiskTypesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListDiskTypesRequest} AggregatedListDiskTypesRequest instance
                         */
                        AggregatedListDiskTypesRequest.create = function create(properties) {
                            return new AggregatedListDiskTypesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListDiskTypesRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListDiskTypesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListDiskTypesRequest} message AggregatedListDiskTypesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListDiskTypesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListDiskTypesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListDiskTypesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListDiskTypesRequest} message AggregatedListDiskTypesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListDiskTypesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListDiskTypesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListDiskTypesRequest} AggregatedListDiskTypesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListDiskTypesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListDiskTypesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListDiskTypesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListDiskTypesRequest} AggregatedListDiskTypesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListDiskTypesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListDiskTypesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListDiskTypesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListDiskTypesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListDiskTypesRequest} AggregatedListDiskTypesRequest
                         */
                        AggregatedListDiskTypesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListDiskTypesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListDiskTypesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListDiskTypesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListDiskTypesRequest} message AggregatedListDiskTypesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListDiskTypesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListDiskTypesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListDiskTypesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListDiskTypesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListDiskTypesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListDiskTypesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListDiskTypesRequest";
                        };
    
                        return AggregatedListDiskTypesRequest;
                    })();
    
                    v1.AggregatedListDisksRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListDisksRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListDisksRequest
                         * @property {string|null} [filter] AggregatedListDisksRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListDisksRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListDisksRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListDisksRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListDisksRequest pageToken
                         * @property {string|null} [project] AggregatedListDisksRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListDisksRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListDisksRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListDisksRequest.
                         * @implements IAggregatedListDisksRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListDisksRequest=} [properties] Properties to set
                         */
                        function AggregatedListDisksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListDisksRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @instance
                         */
                        AggregatedListDisksRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListDisksRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @instance
                         */
                        AggregatedListDisksRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListDisksRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @instance
                         */
                        AggregatedListDisksRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListDisksRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @instance
                         */
                        AggregatedListDisksRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListDisksRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @instance
                         */
                        AggregatedListDisksRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListDisksRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @instance
                         */
                        AggregatedListDisksRequest.prototype.project = "";
    
                        /**
                         * AggregatedListDisksRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @instance
                         */
                        AggregatedListDisksRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListDisksRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListDisksRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListDisksRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListDisksRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListDisksRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListDisksRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListDisksRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListDisksRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListDisksRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListDisksRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListDisksRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListDisksRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListDisksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListDisksRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListDisksRequest} AggregatedListDisksRequest instance
                         */
                        AggregatedListDisksRequest.create = function create(properties) {
                            return new AggregatedListDisksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListDisksRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListDisksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListDisksRequest} message AggregatedListDisksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListDisksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListDisksRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListDisksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListDisksRequest} message AggregatedListDisksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListDisksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListDisksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListDisksRequest} AggregatedListDisksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListDisksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListDisksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListDisksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListDisksRequest} AggregatedListDisksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListDisksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListDisksRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListDisksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListDisksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListDisksRequest} AggregatedListDisksRequest
                         */
                        AggregatedListDisksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListDisksRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListDisksRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListDisksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListDisksRequest} message AggregatedListDisksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListDisksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListDisksRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListDisksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListDisksRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListDisksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListDisksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListDisksRequest";
                        };
    
                        return AggregatedListDisksRequest;
                    })();
    
                    v1.AggregatedListForwardingRulesRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListForwardingRulesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListForwardingRulesRequest
                         * @property {string|null} [filter] AggregatedListForwardingRulesRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListForwardingRulesRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListForwardingRulesRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListForwardingRulesRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListForwardingRulesRequest pageToken
                         * @property {string|null} [project] AggregatedListForwardingRulesRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListForwardingRulesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListForwardingRulesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListForwardingRulesRequest.
                         * @implements IAggregatedListForwardingRulesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListForwardingRulesRequest=} [properties] Properties to set
                         */
                        function AggregatedListForwardingRulesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListForwardingRulesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @instance
                         */
                        AggregatedListForwardingRulesRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListForwardingRulesRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @instance
                         */
                        AggregatedListForwardingRulesRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListForwardingRulesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @instance
                         */
                        AggregatedListForwardingRulesRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListForwardingRulesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @instance
                         */
                        AggregatedListForwardingRulesRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListForwardingRulesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @instance
                         */
                        AggregatedListForwardingRulesRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListForwardingRulesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @instance
                         */
                        AggregatedListForwardingRulesRequest.prototype.project = "";
    
                        /**
                         * AggregatedListForwardingRulesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @instance
                         */
                        AggregatedListForwardingRulesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListForwardingRulesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListForwardingRulesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListForwardingRulesRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListForwardingRulesRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListForwardingRulesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListForwardingRulesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListForwardingRulesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListForwardingRulesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListForwardingRulesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListForwardingRulesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListForwardingRulesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListForwardingRulesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListForwardingRulesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListForwardingRulesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListForwardingRulesRequest} AggregatedListForwardingRulesRequest instance
                         */
                        AggregatedListForwardingRulesRequest.create = function create(properties) {
                            return new AggregatedListForwardingRulesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListForwardingRulesRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListForwardingRulesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListForwardingRulesRequest} message AggregatedListForwardingRulesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListForwardingRulesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListForwardingRulesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListForwardingRulesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListForwardingRulesRequest} message AggregatedListForwardingRulesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListForwardingRulesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListForwardingRulesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListForwardingRulesRequest} AggregatedListForwardingRulesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListForwardingRulesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListForwardingRulesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListForwardingRulesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListForwardingRulesRequest} AggregatedListForwardingRulesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListForwardingRulesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListForwardingRulesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListForwardingRulesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListForwardingRulesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListForwardingRulesRequest} AggregatedListForwardingRulesRequest
                         */
                        AggregatedListForwardingRulesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListForwardingRulesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListForwardingRulesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListForwardingRulesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListForwardingRulesRequest} message AggregatedListForwardingRulesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListForwardingRulesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListForwardingRulesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListForwardingRulesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListForwardingRulesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListForwardingRulesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListForwardingRulesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListForwardingRulesRequest";
                        };
    
                        return AggregatedListForwardingRulesRequest;
                    })();
    
                    v1.AggregatedListGlobalOperationsRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListGlobalOperationsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListGlobalOperationsRequest
                         * @property {string|null} [filter] AggregatedListGlobalOperationsRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListGlobalOperationsRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListGlobalOperationsRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListGlobalOperationsRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListGlobalOperationsRequest pageToken
                         * @property {string|null} [project] AggregatedListGlobalOperationsRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListGlobalOperationsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListGlobalOperationsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListGlobalOperationsRequest.
                         * @implements IAggregatedListGlobalOperationsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListGlobalOperationsRequest=} [properties] Properties to set
                         */
                        function AggregatedListGlobalOperationsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListGlobalOperationsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @instance
                         */
                        AggregatedListGlobalOperationsRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListGlobalOperationsRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @instance
                         */
                        AggregatedListGlobalOperationsRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListGlobalOperationsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @instance
                         */
                        AggregatedListGlobalOperationsRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListGlobalOperationsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @instance
                         */
                        AggregatedListGlobalOperationsRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListGlobalOperationsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @instance
                         */
                        AggregatedListGlobalOperationsRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListGlobalOperationsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @instance
                         */
                        AggregatedListGlobalOperationsRequest.prototype.project = "";
    
                        /**
                         * AggregatedListGlobalOperationsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @instance
                         */
                        AggregatedListGlobalOperationsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListGlobalOperationsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListGlobalOperationsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListGlobalOperationsRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListGlobalOperationsRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListGlobalOperationsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListGlobalOperationsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListGlobalOperationsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListGlobalOperationsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListGlobalOperationsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListGlobalOperationsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListGlobalOperationsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListGlobalOperationsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListGlobalOperationsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListGlobalOperationsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListGlobalOperationsRequest} AggregatedListGlobalOperationsRequest instance
                         */
                        AggregatedListGlobalOperationsRequest.create = function create(properties) {
                            return new AggregatedListGlobalOperationsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListGlobalOperationsRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListGlobalOperationsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListGlobalOperationsRequest} message AggregatedListGlobalOperationsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListGlobalOperationsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListGlobalOperationsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListGlobalOperationsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListGlobalOperationsRequest} message AggregatedListGlobalOperationsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListGlobalOperationsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListGlobalOperationsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListGlobalOperationsRequest} AggregatedListGlobalOperationsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListGlobalOperationsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListGlobalOperationsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListGlobalOperationsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListGlobalOperationsRequest} AggregatedListGlobalOperationsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListGlobalOperationsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListGlobalOperationsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListGlobalOperationsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListGlobalOperationsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListGlobalOperationsRequest} AggregatedListGlobalOperationsRequest
                         */
                        AggregatedListGlobalOperationsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListGlobalOperationsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListGlobalOperationsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListGlobalOperationsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListGlobalOperationsRequest} message AggregatedListGlobalOperationsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListGlobalOperationsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListGlobalOperationsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListGlobalOperationsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListGlobalOperationsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListGlobalOperationsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListGlobalOperationsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListGlobalOperationsRequest";
                        };
    
                        return AggregatedListGlobalOperationsRequest;
                    })();
    
                    v1.AggregatedListHealthChecksRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListHealthChecksRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListHealthChecksRequest
                         * @property {string|null} [filter] AggregatedListHealthChecksRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListHealthChecksRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListHealthChecksRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListHealthChecksRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListHealthChecksRequest pageToken
                         * @property {string|null} [project] AggregatedListHealthChecksRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListHealthChecksRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListHealthChecksRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListHealthChecksRequest.
                         * @implements IAggregatedListHealthChecksRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListHealthChecksRequest=} [properties] Properties to set
                         */
                        function AggregatedListHealthChecksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListHealthChecksRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @instance
                         */
                        AggregatedListHealthChecksRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListHealthChecksRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @instance
                         */
                        AggregatedListHealthChecksRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListHealthChecksRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @instance
                         */
                        AggregatedListHealthChecksRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListHealthChecksRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @instance
                         */
                        AggregatedListHealthChecksRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListHealthChecksRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @instance
                         */
                        AggregatedListHealthChecksRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListHealthChecksRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @instance
                         */
                        AggregatedListHealthChecksRequest.prototype.project = "";
    
                        /**
                         * AggregatedListHealthChecksRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @instance
                         */
                        AggregatedListHealthChecksRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListHealthChecksRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListHealthChecksRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListHealthChecksRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListHealthChecksRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListHealthChecksRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListHealthChecksRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListHealthChecksRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListHealthChecksRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListHealthChecksRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListHealthChecksRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListHealthChecksRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListHealthChecksRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListHealthChecksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListHealthChecksRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListHealthChecksRequest} AggregatedListHealthChecksRequest instance
                         */
                        AggregatedListHealthChecksRequest.create = function create(properties) {
                            return new AggregatedListHealthChecksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListHealthChecksRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListHealthChecksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListHealthChecksRequest} message AggregatedListHealthChecksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListHealthChecksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListHealthChecksRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListHealthChecksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListHealthChecksRequest} message AggregatedListHealthChecksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListHealthChecksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListHealthChecksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListHealthChecksRequest} AggregatedListHealthChecksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListHealthChecksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListHealthChecksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListHealthChecksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListHealthChecksRequest} AggregatedListHealthChecksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListHealthChecksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListHealthChecksRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListHealthChecksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListHealthChecksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListHealthChecksRequest} AggregatedListHealthChecksRequest
                         */
                        AggregatedListHealthChecksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListHealthChecksRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListHealthChecksRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListHealthChecksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListHealthChecksRequest} message AggregatedListHealthChecksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListHealthChecksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListHealthChecksRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListHealthChecksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListHealthChecksRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListHealthChecksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListHealthChecksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListHealthChecksRequest";
                        };
    
                        return AggregatedListHealthChecksRequest;
                    })();
    
                    v1.AggregatedListInstanceGroupManagersRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListInstanceGroupManagersRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListInstanceGroupManagersRequest
                         * @property {string|null} [filter] AggregatedListInstanceGroupManagersRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListInstanceGroupManagersRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListInstanceGroupManagersRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListInstanceGroupManagersRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListInstanceGroupManagersRequest pageToken
                         * @property {string|null} [project] AggregatedListInstanceGroupManagersRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListInstanceGroupManagersRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListInstanceGroupManagersRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListInstanceGroupManagersRequest.
                         * @implements IAggregatedListInstanceGroupManagersRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListInstanceGroupManagersRequest=} [properties] Properties to set
                         */
                        function AggregatedListInstanceGroupManagersRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListInstanceGroupManagersRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @instance
                         */
                        AggregatedListInstanceGroupManagersRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListInstanceGroupManagersRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @instance
                         */
                        AggregatedListInstanceGroupManagersRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListInstanceGroupManagersRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @instance
                         */
                        AggregatedListInstanceGroupManagersRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListInstanceGroupManagersRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @instance
                         */
                        AggregatedListInstanceGroupManagersRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListInstanceGroupManagersRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @instance
                         */
                        AggregatedListInstanceGroupManagersRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListInstanceGroupManagersRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @instance
                         */
                        AggregatedListInstanceGroupManagersRequest.prototype.project = "";
    
                        /**
                         * AggregatedListInstanceGroupManagersRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @instance
                         */
                        AggregatedListInstanceGroupManagersRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListInstanceGroupManagersRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInstanceGroupManagersRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListInstanceGroupManagersRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInstanceGroupManagersRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListInstanceGroupManagersRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInstanceGroupManagersRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListInstanceGroupManagersRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInstanceGroupManagersRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListInstanceGroupManagersRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInstanceGroupManagersRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListInstanceGroupManagersRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInstanceGroupManagersRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListInstanceGroupManagersRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListInstanceGroupManagersRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest} AggregatedListInstanceGroupManagersRequest instance
                         */
                        AggregatedListInstanceGroupManagersRequest.create = function create(properties) {
                            return new AggregatedListInstanceGroupManagersRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListInstanceGroupManagersRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListInstanceGroupManagersRequest} message AggregatedListInstanceGroupManagersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListInstanceGroupManagersRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListInstanceGroupManagersRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListInstanceGroupManagersRequest} message AggregatedListInstanceGroupManagersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListInstanceGroupManagersRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListInstanceGroupManagersRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest} AggregatedListInstanceGroupManagersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListInstanceGroupManagersRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListInstanceGroupManagersRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest} AggregatedListInstanceGroupManagersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListInstanceGroupManagersRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListInstanceGroupManagersRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListInstanceGroupManagersRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListInstanceGroupManagersRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest} AggregatedListInstanceGroupManagersRequest
                         */
                        AggregatedListInstanceGroupManagersRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListInstanceGroupManagersRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest} message AggregatedListInstanceGroupManagersRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListInstanceGroupManagersRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListInstanceGroupManagersRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListInstanceGroupManagersRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListInstanceGroupManagersRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListInstanceGroupManagersRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest";
                        };
    
                        return AggregatedListInstanceGroupManagersRequest;
                    })();
    
                    v1.AggregatedListInstanceGroupsRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListInstanceGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListInstanceGroupsRequest
                         * @property {string|null} [filter] AggregatedListInstanceGroupsRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListInstanceGroupsRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListInstanceGroupsRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListInstanceGroupsRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListInstanceGroupsRequest pageToken
                         * @property {string|null} [project] AggregatedListInstanceGroupsRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListInstanceGroupsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListInstanceGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListInstanceGroupsRequest.
                         * @implements IAggregatedListInstanceGroupsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListInstanceGroupsRequest=} [properties] Properties to set
                         */
                        function AggregatedListInstanceGroupsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListInstanceGroupsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @instance
                         */
                        AggregatedListInstanceGroupsRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListInstanceGroupsRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @instance
                         */
                        AggregatedListInstanceGroupsRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListInstanceGroupsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @instance
                         */
                        AggregatedListInstanceGroupsRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListInstanceGroupsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @instance
                         */
                        AggregatedListInstanceGroupsRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListInstanceGroupsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @instance
                         */
                        AggregatedListInstanceGroupsRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListInstanceGroupsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @instance
                         */
                        AggregatedListInstanceGroupsRequest.prototype.project = "";
    
                        /**
                         * AggregatedListInstanceGroupsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @instance
                         */
                        AggregatedListInstanceGroupsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListInstanceGroupsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInstanceGroupsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListInstanceGroupsRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInstanceGroupsRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListInstanceGroupsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInstanceGroupsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListInstanceGroupsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInstanceGroupsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListInstanceGroupsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInstanceGroupsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListInstanceGroupsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInstanceGroupsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListInstanceGroupsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListInstanceGroupsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListInstanceGroupsRequest} AggregatedListInstanceGroupsRequest instance
                         */
                        AggregatedListInstanceGroupsRequest.create = function create(properties) {
                            return new AggregatedListInstanceGroupsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListInstanceGroupsRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListInstanceGroupsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListInstanceGroupsRequest} message AggregatedListInstanceGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListInstanceGroupsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListInstanceGroupsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListInstanceGroupsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListInstanceGroupsRequest} message AggregatedListInstanceGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListInstanceGroupsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListInstanceGroupsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListInstanceGroupsRequest} AggregatedListInstanceGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListInstanceGroupsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListInstanceGroupsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListInstanceGroupsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListInstanceGroupsRequest} AggregatedListInstanceGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListInstanceGroupsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListInstanceGroupsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListInstanceGroupsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListInstanceGroupsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListInstanceGroupsRequest} AggregatedListInstanceGroupsRequest
                         */
                        AggregatedListInstanceGroupsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListInstanceGroupsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListInstanceGroupsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListInstanceGroupsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListInstanceGroupsRequest} message AggregatedListInstanceGroupsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListInstanceGroupsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListInstanceGroupsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListInstanceGroupsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListInstanceGroupsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListInstanceGroupsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListInstanceGroupsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListInstanceGroupsRequest";
                        };
    
                        return AggregatedListInstanceGroupsRequest;
                    })();
    
                    v1.AggregatedListInstancesRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListInstancesRequest
                         * @property {string|null} [filter] AggregatedListInstancesRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListInstancesRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListInstancesRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListInstancesRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListInstancesRequest pageToken
                         * @property {string|null} [project] AggregatedListInstancesRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListInstancesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListInstancesRequest.
                         * @implements IAggregatedListInstancesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListInstancesRequest=} [properties] Properties to set
                         */
                        function AggregatedListInstancesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListInstancesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @instance
                         */
                        AggregatedListInstancesRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListInstancesRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @instance
                         */
                        AggregatedListInstancesRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListInstancesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @instance
                         */
                        AggregatedListInstancesRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListInstancesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @instance
                         */
                        AggregatedListInstancesRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListInstancesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @instance
                         */
                        AggregatedListInstancesRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListInstancesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @instance
                         */
                        AggregatedListInstancesRequest.prototype.project = "";
    
                        /**
                         * AggregatedListInstancesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @instance
                         */
                        AggregatedListInstancesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListInstancesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInstancesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListInstancesRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInstancesRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListInstancesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInstancesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListInstancesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInstancesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListInstancesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInstancesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListInstancesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInstancesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListInstancesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListInstancesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListInstancesRequest} AggregatedListInstancesRequest instance
                         */
                        AggregatedListInstancesRequest.create = function create(properties) {
                            return new AggregatedListInstancesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListInstancesRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListInstancesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListInstancesRequest} message AggregatedListInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListInstancesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListInstancesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListInstancesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListInstancesRequest} message AggregatedListInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListInstancesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListInstancesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListInstancesRequest} AggregatedListInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListInstancesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListInstancesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListInstancesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListInstancesRequest} AggregatedListInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListInstancesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListInstancesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListInstancesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListInstancesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListInstancesRequest} AggregatedListInstancesRequest
                         */
                        AggregatedListInstancesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListInstancesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListInstancesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListInstancesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListInstancesRequest} message AggregatedListInstancesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListInstancesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListInstancesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListInstancesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListInstancesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListInstancesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListInstancesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListInstancesRequest";
                        };
    
                        return AggregatedListInstancesRequest;
                    })();
    
                    v1.AggregatedListInterconnectAttachmentsRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListInterconnectAttachmentsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListInterconnectAttachmentsRequest
                         * @property {string|null} [filter] AggregatedListInterconnectAttachmentsRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListInterconnectAttachmentsRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListInterconnectAttachmentsRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListInterconnectAttachmentsRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListInterconnectAttachmentsRequest pageToken
                         * @property {string|null} [project] AggregatedListInterconnectAttachmentsRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListInterconnectAttachmentsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListInterconnectAttachmentsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListInterconnectAttachmentsRequest.
                         * @implements IAggregatedListInterconnectAttachmentsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListInterconnectAttachmentsRequest=} [properties] Properties to set
                         */
                        function AggregatedListInterconnectAttachmentsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListInterconnectAttachmentsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @instance
                         */
                        AggregatedListInterconnectAttachmentsRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListInterconnectAttachmentsRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @instance
                         */
                        AggregatedListInterconnectAttachmentsRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListInterconnectAttachmentsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @instance
                         */
                        AggregatedListInterconnectAttachmentsRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListInterconnectAttachmentsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @instance
                         */
                        AggregatedListInterconnectAttachmentsRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListInterconnectAttachmentsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @instance
                         */
                        AggregatedListInterconnectAttachmentsRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListInterconnectAttachmentsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @instance
                         */
                        AggregatedListInterconnectAttachmentsRequest.prototype.project = "";
    
                        /**
                         * AggregatedListInterconnectAttachmentsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @instance
                         */
                        AggregatedListInterconnectAttachmentsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListInterconnectAttachmentsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInterconnectAttachmentsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListInterconnectAttachmentsRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInterconnectAttachmentsRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListInterconnectAttachmentsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInterconnectAttachmentsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListInterconnectAttachmentsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInterconnectAttachmentsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListInterconnectAttachmentsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInterconnectAttachmentsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListInterconnectAttachmentsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListInterconnectAttachmentsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListInterconnectAttachmentsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListInterconnectAttachmentsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest} AggregatedListInterconnectAttachmentsRequest instance
                         */
                        AggregatedListInterconnectAttachmentsRequest.create = function create(properties) {
                            return new AggregatedListInterconnectAttachmentsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListInterconnectAttachmentsRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListInterconnectAttachmentsRequest} message AggregatedListInterconnectAttachmentsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListInterconnectAttachmentsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListInterconnectAttachmentsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListInterconnectAttachmentsRequest} message AggregatedListInterconnectAttachmentsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListInterconnectAttachmentsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListInterconnectAttachmentsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest} AggregatedListInterconnectAttachmentsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListInterconnectAttachmentsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListInterconnectAttachmentsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest} AggregatedListInterconnectAttachmentsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListInterconnectAttachmentsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListInterconnectAttachmentsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListInterconnectAttachmentsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListInterconnectAttachmentsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest} AggregatedListInterconnectAttachmentsRequest
                         */
                        AggregatedListInterconnectAttachmentsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListInterconnectAttachmentsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest} message AggregatedListInterconnectAttachmentsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListInterconnectAttachmentsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListInterconnectAttachmentsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListInterconnectAttachmentsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListInterconnectAttachmentsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListInterconnectAttachmentsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest";
                        };
    
                        return AggregatedListInterconnectAttachmentsRequest;
                    })();
    
                    v1.AggregatedListMachineTypesRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListMachineTypesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListMachineTypesRequest
                         * @property {string|null} [filter] AggregatedListMachineTypesRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListMachineTypesRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListMachineTypesRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListMachineTypesRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListMachineTypesRequest pageToken
                         * @property {string|null} [project] AggregatedListMachineTypesRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListMachineTypesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListMachineTypesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListMachineTypesRequest.
                         * @implements IAggregatedListMachineTypesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListMachineTypesRequest=} [properties] Properties to set
                         */
                        function AggregatedListMachineTypesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListMachineTypesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @instance
                         */
                        AggregatedListMachineTypesRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListMachineTypesRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @instance
                         */
                        AggregatedListMachineTypesRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListMachineTypesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @instance
                         */
                        AggregatedListMachineTypesRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListMachineTypesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @instance
                         */
                        AggregatedListMachineTypesRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListMachineTypesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @instance
                         */
                        AggregatedListMachineTypesRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListMachineTypesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @instance
                         */
                        AggregatedListMachineTypesRequest.prototype.project = "";
    
                        /**
                         * AggregatedListMachineTypesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @instance
                         */
                        AggregatedListMachineTypesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListMachineTypesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListMachineTypesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListMachineTypesRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListMachineTypesRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListMachineTypesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListMachineTypesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListMachineTypesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListMachineTypesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListMachineTypesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListMachineTypesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListMachineTypesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListMachineTypesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListMachineTypesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListMachineTypesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListMachineTypesRequest} AggregatedListMachineTypesRequest instance
                         */
                        AggregatedListMachineTypesRequest.create = function create(properties) {
                            return new AggregatedListMachineTypesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListMachineTypesRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListMachineTypesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListMachineTypesRequest} message AggregatedListMachineTypesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListMachineTypesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListMachineTypesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListMachineTypesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListMachineTypesRequest} message AggregatedListMachineTypesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListMachineTypesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListMachineTypesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListMachineTypesRequest} AggregatedListMachineTypesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListMachineTypesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListMachineTypesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListMachineTypesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListMachineTypesRequest} AggregatedListMachineTypesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListMachineTypesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListMachineTypesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListMachineTypesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListMachineTypesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListMachineTypesRequest} AggregatedListMachineTypesRequest
                         */
                        AggregatedListMachineTypesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListMachineTypesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListMachineTypesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListMachineTypesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListMachineTypesRequest} message AggregatedListMachineTypesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListMachineTypesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListMachineTypesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListMachineTypesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListMachineTypesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListMachineTypesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListMachineTypesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListMachineTypesRequest";
                        };
    
                        return AggregatedListMachineTypesRequest;
                    })();
    
                    v1.AggregatedListNetworkEdgeSecurityServicesRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListNetworkEdgeSecurityServicesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListNetworkEdgeSecurityServicesRequest
                         * @property {string|null} [filter] AggregatedListNetworkEdgeSecurityServicesRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListNetworkEdgeSecurityServicesRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListNetworkEdgeSecurityServicesRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListNetworkEdgeSecurityServicesRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListNetworkEdgeSecurityServicesRequest pageToken
                         * @property {string|null} [project] AggregatedListNetworkEdgeSecurityServicesRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListNetworkEdgeSecurityServicesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListNetworkEdgeSecurityServicesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListNetworkEdgeSecurityServicesRequest.
                         * @implements IAggregatedListNetworkEdgeSecurityServicesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListNetworkEdgeSecurityServicesRequest=} [properties] Properties to set
                         */
                        function AggregatedListNetworkEdgeSecurityServicesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListNetworkEdgeSecurityServicesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @instance
                         */
                        AggregatedListNetworkEdgeSecurityServicesRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListNetworkEdgeSecurityServicesRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @instance
                         */
                        AggregatedListNetworkEdgeSecurityServicesRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListNetworkEdgeSecurityServicesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @instance
                         */
                        AggregatedListNetworkEdgeSecurityServicesRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListNetworkEdgeSecurityServicesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @instance
                         */
                        AggregatedListNetworkEdgeSecurityServicesRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListNetworkEdgeSecurityServicesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @instance
                         */
                        AggregatedListNetworkEdgeSecurityServicesRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListNetworkEdgeSecurityServicesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @instance
                         */
                        AggregatedListNetworkEdgeSecurityServicesRequest.prototype.project = "";
    
                        /**
                         * AggregatedListNetworkEdgeSecurityServicesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @instance
                         */
                        AggregatedListNetworkEdgeSecurityServicesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListNetworkEdgeSecurityServicesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNetworkEdgeSecurityServicesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNetworkEdgeSecurityServicesRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNetworkEdgeSecurityServicesRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNetworkEdgeSecurityServicesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNetworkEdgeSecurityServicesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNetworkEdgeSecurityServicesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNetworkEdgeSecurityServicesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNetworkEdgeSecurityServicesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNetworkEdgeSecurityServicesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNetworkEdgeSecurityServicesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNetworkEdgeSecurityServicesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListNetworkEdgeSecurityServicesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListNetworkEdgeSecurityServicesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest} AggregatedListNetworkEdgeSecurityServicesRequest instance
                         */
                        AggregatedListNetworkEdgeSecurityServicesRequest.create = function create(properties) {
                            return new AggregatedListNetworkEdgeSecurityServicesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListNetworkEdgeSecurityServicesRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListNetworkEdgeSecurityServicesRequest} message AggregatedListNetworkEdgeSecurityServicesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListNetworkEdgeSecurityServicesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListNetworkEdgeSecurityServicesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListNetworkEdgeSecurityServicesRequest} message AggregatedListNetworkEdgeSecurityServicesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListNetworkEdgeSecurityServicesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListNetworkEdgeSecurityServicesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest} AggregatedListNetworkEdgeSecurityServicesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListNetworkEdgeSecurityServicesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListNetworkEdgeSecurityServicesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest} AggregatedListNetworkEdgeSecurityServicesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListNetworkEdgeSecurityServicesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListNetworkEdgeSecurityServicesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListNetworkEdgeSecurityServicesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListNetworkEdgeSecurityServicesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest} AggregatedListNetworkEdgeSecurityServicesRequest
                         */
                        AggregatedListNetworkEdgeSecurityServicesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListNetworkEdgeSecurityServicesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest} message AggregatedListNetworkEdgeSecurityServicesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListNetworkEdgeSecurityServicesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListNetworkEdgeSecurityServicesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListNetworkEdgeSecurityServicesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListNetworkEdgeSecurityServicesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListNetworkEdgeSecurityServicesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest";
                        };
    
                        return AggregatedListNetworkEdgeSecurityServicesRequest;
                    })();
    
                    v1.AggregatedListNetworkEndpointGroupsRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListNetworkEndpointGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListNetworkEndpointGroupsRequest
                         * @property {string|null} [filter] AggregatedListNetworkEndpointGroupsRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListNetworkEndpointGroupsRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListNetworkEndpointGroupsRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListNetworkEndpointGroupsRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListNetworkEndpointGroupsRequest pageToken
                         * @property {string|null} [project] AggregatedListNetworkEndpointGroupsRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListNetworkEndpointGroupsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListNetworkEndpointGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListNetworkEndpointGroupsRequest.
                         * @implements IAggregatedListNetworkEndpointGroupsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListNetworkEndpointGroupsRequest=} [properties] Properties to set
                         */
                        function AggregatedListNetworkEndpointGroupsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListNetworkEndpointGroupsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        AggregatedListNetworkEndpointGroupsRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListNetworkEndpointGroupsRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        AggregatedListNetworkEndpointGroupsRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListNetworkEndpointGroupsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        AggregatedListNetworkEndpointGroupsRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListNetworkEndpointGroupsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        AggregatedListNetworkEndpointGroupsRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListNetworkEndpointGroupsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        AggregatedListNetworkEndpointGroupsRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListNetworkEndpointGroupsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        AggregatedListNetworkEndpointGroupsRequest.prototype.project = "";
    
                        /**
                         * AggregatedListNetworkEndpointGroupsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        AggregatedListNetworkEndpointGroupsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListNetworkEndpointGroupsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNetworkEndpointGroupsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNetworkEndpointGroupsRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNetworkEndpointGroupsRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNetworkEndpointGroupsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNetworkEndpointGroupsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNetworkEndpointGroupsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNetworkEndpointGroupsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNetworkEndpointGroupsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNetworkEndpointGroupsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNetworkEndpointGroupsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNetworkEndpointGroupsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListNetworkEndpointGroupsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListNetworkEndpointGroupsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest} AggregatedListNetworkEndpointGroupsRequest instance
                         */
                        AggregatedListNetworkEndpointGroupsRequest.create = function create(properties) {
                            return new AggregatedListNetworkEndpointGroupsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListNetworkEndpointGroupsRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListNetworkEndpointGroupsRequest} message AggregatedListNetworkEndpointGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListNetworkEndpointGroupsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListNetworkEndpointGroupsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListNetworkEndpointGroupsRequest} message AggregatedListNetworkEndpointGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListNetworkEndpointGroupsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListNetworkEndpointGroupsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest} AggregatedListNetworkEndpointGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListNetworkEndpointGroupsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListNetworkEndpointGroupsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest} AggregatedListNetworkEndpointGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListNetworkEndpointGroupsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListNetworkEndpointGroupsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListNetworkEndpointGroupsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListNetworkEndpointGroupsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest} AggregatedListNetworkEndpointGroupsRequest
                         */
                        AggregatedListNetworkEndpointGroupsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListNetworkEndpointGroupsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest} message AggregatedListNetworkEndpointGroupsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListNetworkEndpointGroupsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListNetworkEndpointGroupsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListNetworkEndpointGroupsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListNetworkEndpointGroupsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListNetworkEndpointGroupsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest";
                        };
    
                        return AggregatedListNetworkEndpointGroupsRequest;
                    })();
    
                    v1.AggregatedListNodeGroupsRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListNodeGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListNodeGroupsRequest
                         * @property {string|null} [filter] AggregatedListNodeGroupsRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListNodeGroupsRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListNodeGroupsRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListNodeGroupsRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListNodeGroupsRequest pageToken
                         * @property {string|null} [project] AggregatedListNodeGroupsRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListNodeGroupsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListNodeGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListNodeGroupsRequest.
                         * @implements IAggregatedListNodeGroupsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListNodeGroupsRequest=} [properties] Properties to set
                         */
                        function AggregatedListNodeGroupsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListNodeGroupsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @instance
                         */
                        AggregatedListNodeGroupsRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListNodeGroupsRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @instance
                         */
                        AggregatedListNodeGroupsRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListNodeGroupsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @instance
                         */
                        AggregatedListNodeGroupsRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListNodeGroupsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @instance
                         */
                        AggregatedListNodeGroupsRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListNodeGroupsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @instance
                         */
                        AggregatedListNodeGroupsRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListNodeGroupsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @instance
                         */
                        AggregatedListNodeGroupsRequest.prototype.project = "";
    
                        /**
                         * AggregatedListNodeGroupsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @instance
                         */
                        AggregatedListNodeGroupsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListNodeGroupsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNodeGroupsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNodeGroupsRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNodeGroupsRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNodeGroupsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNodeGroupsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNodeGroupsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNodeGroupsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNodeGroupsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNodeGroupsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNodeGroupsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNodeGroupsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListNodeGroupsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListNodeGroupsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListNodeGroupsRequest} AggregatedListNodeGroupsRequest instance
                         */
                        AggregatedListNodeGroupsRequest.create = function create(properties) {
                            return new AggregatedListNodeGroupsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListNodeGroupsRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListNodeGroupsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListNodeGroupsRequest} message AggregatedListNodeGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListNodeGroupsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListNodeGroupsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListNodeGroupsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListNodeGroupsRequest} message AggregatedListNodeGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListNodeGroupsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListNodeGroupsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListNodeGroupsRequest} AggregatedListNodeGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListNodeGroupsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListNodeGroupsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListNodeGroupsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListNodeGroupsRequest} AggregatedListNodeGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListNodeGroupsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListNodeGroupsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListNodeGroupsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListNodeGroupsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListNodeGroupsRequest} AggregatedListNodeGroupsRequest
                         */
                        AggregatedListNodeGroupsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListNodeGroupsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListNodeGroupsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListNodeGroupsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListNodeGroupsRequest} message AggregatedListNodeGroupsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListNodeGroupsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListNodeGroupsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListNodeGroupsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListNodeGroupsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListNodeGroupsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListNodeGroupsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListNodeGroupsRequest";
                        };
    
                        return AggregatedListNodeGroupsRequest;
                    })();
    
                    v1.AggregatedListNodeTemplatesRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListNodeTemplatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListNodeTemplatesRequest
                         * @property {string|null} [filter] AggregatedListNodeTemplatesRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListNodeTemplatesRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListNodeTemplatesRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListNodeTemplatesRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListNodeTemplatesRequest pageToken
                         * @property {string|null} [project] AggregatedListNodeTemplatesRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListNodeTemplatesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListNodeTemplatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListNodeTemplatesRequest.
                         * @implements IAggregatedListNodeTemplatesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListNodeTemplatesRequest=} [properties] Properties to set
                         */
                        function AggregatedListNodeTemplatesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListNodeTemplatesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @instance
                         */
                        AggregatedListNodeTemplatesRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListNodeTemplatesRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @instance
                         */
                        AggregatedListNodeTemplatesRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListNodeTemplatesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @instance
                         */
                        AggregatedListNodeTemplatesRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListNodeTemplatesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @instance
                         */
                        AggregatedListNodeTemplatesRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListNodeTemplatesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @instance
                         */
                        AggregatedListNodeTemplatesRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListNodeTemplatesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @instance
                         */
                        AggregatedListNodeTemplatesRequest.prototype.project = "";
    
                        /**
                         * AggregatedListNodeTemplatesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @instance
                         */
                        AggregatedListNodeTemplatesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListNodeTemplatesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNodeTemplatesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNodeTemplatesRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNodeTemplatesRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNodeTemplatesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNodeTemplatesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNodeTemplatesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNodeTemplatesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNodeTemplatesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNodeTemplatesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNodeTemplatesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNodeTemplatesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListNodeTemplatesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListNodeTemplatesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListNodeTemplatesRequest} AggregatedListNodeTemplatesRequest instance
                         */
                        AggregatedListNodeTemplatesRequest.create = function create(properties) {
                            return new AggregatedListNodeTemplatesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListNodeTemplatesRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListNodeTemplatesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListNodeTemplatesRequest} message AggregatedListNodeTemplatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListNodeTemplatesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListNodeTemplatesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListNodeTemplatesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListNodeTemplatesRequest} message AggregatedListNodeTemplatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListNodeTemplatesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListNodeTemplatesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListNodeTemplatesRequest} AggregatedListNodeTemplatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListNodeTemplatesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListNodeTemplatesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListNodeTemplatesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListNodeTemplatesRequest} AggregatedListNodeTemplatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListNodeTemplatesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListNodeTemplatesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListNodeTemplatesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListNodeTemplatesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListNodeTemplatesRequest} AggregatedListNodeTemplatesRequest
                         */
                        AggregatedListNodeTemplatesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListNodeTemplatesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListNodeTemplatesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListNodeTemplatesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListNodeTemplatesRequest} message AggregatedListNodeTemplatesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListNodeTemplatesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListNodeTemplatesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListNodeTemplatesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListNodeTemplatesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTemplatesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListNodeTemplatesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListNodeTemplatesRequest";
                        };
    
                        return AggregatedListNodeTemplatesRequest;
                    })();
    
                    v1.AggregatedListNodeTypesRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListNodeTypesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListNodeTypesRequest
                         * @property {string|null} [filter] AggregatedListNodeTypesRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListNodeTypesRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListNodeTypesRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListNodeTypesRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListNodeTypesRequest pageToken
                         * @property {string|null} [project] AggregatedListNodeTypesRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListNodeTypesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListNodeTypesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListNodeTypesRequest.
                         * @implements IAggregatedListNodeTypesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListNodeTypesRequest=} [properties] Properties to set
                         */
                        function AggregatedListNodeTypesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListNodeTypesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @instance
                         */
                        AggregatedListNodeTypesRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListNodeTypesRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @instance
                         */
                        AggregatedListNodeTypesRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListNodeTypesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @instance
                         */
                        AggregatedListNodeTypesRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListNodeTypesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @instance
                         */
                        AggregatedListNodeTypesRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListNodeTypesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @instance
                         */
                        AggregatedListNodeTypesRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListNodeTypesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @instance
                         */
                        AggregatedListNodeTypesRequest.prototype.project = "";
    
                        /**
                         * AggregatedListNodeTypesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @instance
                         */
                        AggregatedListNodeTypesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListNodeTypesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNodeTypesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNodeTypesRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNodeTypesRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNodeTypesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNodeTypesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNodeTypesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNodeTypesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNodeTypesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNodeTypesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListNodeTypesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListNodeTypesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListNodeTypesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListNodeTypesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListNodeTypesRequest} AggregatedListNodeTypesRequest instance
                         */
                        AggregatedListNodeTypesRequest.create = function create(properties) {
                            return new AggregatedListNodeTypesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListNodeTypesRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListNodeTypesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListNodeTypesRequest} message AggregatedListNodeTypesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListNodeTypesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListNodeTypesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListNodeTypesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListNodeTypesRequest} message AggregatedListNodeTypesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListNodeTypesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListNodeTypesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListNodeTypesRequest} AggregatedListNodeTypesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListNodeTypesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListNodeTypesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListNodeTypesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListNodeTypesRequest} AggregatedListNodeTypesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListNodeTypesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListNodeTypesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListNodeTypesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListNodeTypesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListNodeTypesRequest} AggregatedListNodeTypesRequest
                         */
                        AggregatedListNodeTypesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListNodeTypesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListNodeTypesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListNodeTypesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListNodeTypesRequest} message AggregatedListNodeTypesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListNodeTypesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListNodeTypesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListNodeTypesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListNodeTypesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListNodeTypesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListNodeTypesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListNodeTypesRequest";
                        };
    
                        return AggregatedListNodeTypesRequest;
                    })();
    
                    v1.AggregatedListPacketMirroringsRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListPacketMirroringsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListPacketMirroringsRequest
                         * @property {string|null} [filter] AggregatedListPacketMirroringsRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListPacketMirroringsRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListPacketMirroringsRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListPacketMirroringsRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListPacketMirroringsRequest pageToken
                         * @property {string|null} [project] AggregatedListPacketMirroringsRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListPacketMirroringsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListPacketMirroringsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListPacketMirroringsRequest.
                         * @implements IAggregatedListPacketMirroringsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListPacketMirroringsRequest=} [properties] Properties to set
                         */
                        function AggregatedListPacketMirroringsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListPacketMirroringsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @instance
                         */
                        AggregatedListPacketMirroringsRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListPacketMirroringsRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @instance
                         */
                        AggregatedListPacketMirroringsRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListPacketMirroringsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @instance
                         */
                        AggregatedListPacketMirroringsRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListPacketMirroringsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @instance
                         */
                        AggregatedListPacketMirroringsRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListPacketMirroringsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @instance
                         */
                        AggregatedListPacketMirroringsRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListPacketMirroringsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @instance
                         */
                        AggregatedListPacketMirroringsRequest.prototype.project = "";
    
                        /**
                         * AggregatedListPacketMirroringsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @instance
                         */
                        AggregatedListPacketMirroringsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListPacketMirroringsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListPacketMirroringsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListPacketMirroringsRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListPacketMirroringsRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListPacketMirroringsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListPacketMirroringsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListPacketMirroringsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListPacketMirroringsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListPacketMirroringsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListPacketMirroringsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListPacketMirroringsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListPacketMirroringsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListPacketMirroringsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListPacketMirroringsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListPacketMirroringsRequest} AggregatedListPacketMirroringsRequest instance
                         */
                        AggregatedListPacketMirroringsRequest.create = function create(properties) {
                            return new AggregatedListPacketMirroringsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListPacketMirroringsRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListPacketMirroringsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListPacketMirroringsRequest} message AggregatedListPacketMirroringsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListPacketMirroringsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListPacketMirroringsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListPacketMirroringsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListPacketMirroringsRequest} message AggregatedListPacketMirroringsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListPacketMirroringsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListPacketMirroringsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListPacketMirroringsRequest} AggregatedListPacketMirroringsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListPacketMirroringsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListPacketMirroringsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListPacketMirroringsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListPacketMirroringsRequest} AggregatedListPacketMirroringsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListPacketMirroringsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListPacketMirroringsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListPacketMirroringsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListPacketMirroringsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListPacketMirroringsRequest} AggregatedListPacketMirroringsRequest
                         */
                        AggregatedListPacketMirroringsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListPacketMirroringsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListPacketMirroringsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListPacketMirroringsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListPacketMirroringsRequest} message AggregatedListPacketMirroringsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListPacketMirroringsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListPacketMirroringsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListPacketMirroringsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListPacketMirroringsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListPacketMirroringsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListPacketMirroringsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListPacketMirroringsRequest";
                        };
    
                        return AggregatedListPacketMirroringsRequest;
                    })();
    
                    v1.AggregatedListPublicDelegatedPrefixesRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListPublicDelegatedPrefixesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListPublicDelegatedPrefixesRequest
                         * @property {string|null} [filter] AggregatedListPublicDelegatedPrefixesRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListPublicDelegatedPrefixesRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListPublicDelegatedPrefixesRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListPublicDelegatedPrefixesRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListPublicDelegatedPrefixesRequest pageToken
                         * @property {string|null} [project] AggregatedListPublicDelegatedPrefixesRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListPublicDelegatedPrefixesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListPublicDelegatedPrefixesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListPublicDelegatedPrefixesRequest.
                         * @implements IAggregatedListPublicDelegatedPrefixesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListPublicDelegatedPrefixesRequest=} [properties] Properties to set
                         */
                        function AggregatedListPublicDelegatedPrefixesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListPublicDelegatedPrefixesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        AggregatedListPublicDelegatedPrefixesRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListPublicDelegatedPrefixesRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        AggregatedListPublicDelegatedPrefixesRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListPublicDelegatedPrefixesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        AggregatedListPublicDelegatedPrefixesRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListPublicDelegatedPrefixesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        AggregatedListPublicDelegatedPrefixesRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListPublicDelegatedPrefixesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        AggregatedListPublicDelegatedPrefixesRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListPublicDelegatedPrefixesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        AggregatedListPublicDelegatedPrefixesRequest.prototype.project = "";
    
                        /**
                         * AggregatedListPublicDelegatedPrefixesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        AggregatedListPublicDelegatedPrefixesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListPublicDelegatedPrefixesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListPublicDelegatedPrefixesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListPublicDelegatedPrefixesRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListPublicDelegatedPrefixesRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListPublicDelegatedPrefixesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListPublicDelegatedPrefixesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListPublicDelegatedPrefixesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListPublicDelegatedPrefixesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListPublicDelegatedPrefixesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListPublicDelegatedPrefixesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListPublicDelegatedPrefixesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListPublicDelegatedPrefixesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListPublicDelegatedPrefixesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListPublicDelegatedPrefixesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest} AggregatedListPublicDelegatedPrefixesRequest instance
                         */
                        AggregatedListPublicDelegatedPrefixesRequest.create = function create(properties) {
                            return new AggregatedListPublicDelegatedPrefixesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListPublicDelegatedPrefixesRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListPublicDelegatedPrefixesRequest} message AggregatedListPublicDelegatedPrefixesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListPublicDelegatedPrefixesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListPublicDelegatedPrefixesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListPublicDelegatedPrefixesRequest} message AggregatedListPublicDelegatedPrefixesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListPublicDelegatedPrefixesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListPublicDelegatedPrefixesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest} AggregatedListPublicDelegatedPrefixesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListPublicDelegatedPrefixesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListPublicDelegatedPrefixesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest} AggregatedListPublicDelegatedPrefixesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListPublicDelegatedPrefixesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListPublicDelegatedPrefixesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListPublicDelegatedPrefixesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListPublicDelegatedPrefixesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest} AggregatedListPublicDelegatedPrefixesRequest
                         */
                        AggregatedListPublicDelegatedPrefixesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListPublicDelegatedPrefixesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest} message AggregatedListPublicDelegatedPrefixesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListPublicDelegatedPrefixesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListPublicDelegatedPrefixesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListPublicDelegatedPrefixesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListPublicDelegatedPrefixesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListPublicDelegatedPrefixesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest";
                        };
    
                        return AggregatedListPublicDelegatedPrefixesRequest;
                    })();
    
                    v1.AggregatedListRegionCommitmentsRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListRegionCommitmentsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListRegionCommitmentsRequest
                         * @property {string|null} [filter] AggregatedListRegionCommitmentsRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListRegionCommitmentsRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListRegionCommitmentsRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListRegionCommitmentsRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListRegionCommitmentsRequest pageToken
                         * @property {string|null} [project] AggregatedListRegionCommitmentsRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListRegionCommitmentsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListRegionCommitmentsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListRegionCommitmentsRequest.
                         * @implements IAggregatedListRegionCommitmentsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListRegionCommitmentsRequest=} [properties] Properties to set
                         */
                        function AggregatedListRegionCommitmentsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListRegionCommitmentsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @instance
                         */
                        AggregatedListRegionCommitmentsRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListRegionCommitmentsRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @instance
                         */
                        AggregatedListRegionCommitmentsRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListRegionCommitmentsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @instance
                         */
                        AggregatedListRegionCommitmentsRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListRegionCommitmentsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @instance
                         */
                        AggregatedListRegionCommitmentsRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListRegionCommitmentsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @instance
                         */
                        AggregatedListRegionCommitmentsRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListRegionCommitmentsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @instance
                         */
                        AggregatedListRegionCommitmentsRequest.prototype.project = "";
    
                        /**
                         * AggregatedListRegionCommitmentsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @instance
                         */
                        AggregatedListRegionCommitmentsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListRegionCommitmentsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListRegionCommitmentsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListRegionCommitmentsRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListRegionCommitmentsRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListRegionCommitmentsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListRegionCommitmentsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListRegionCommitmentsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListRegionCommitmentsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListRegionCommitmentsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListRegionCommitmentsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListRegionCommitmentsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListRegionCommitmentsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListRegionCommitmentsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListRegionCommitmentsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest} AggregatedListRegionCommitmentsRequest instance
                         */
                        AggregatedListRegionCommitmentsRequest.create = function create(properties) {
                            return new AggregatedListRegionCommitmentsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListRegionCommitmentsRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListRegionCommitmentsRequest} message AggregatedListRegionCommitmentsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListRegionCommitmentsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListRegionCommitmentsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListRegionCommitmentsRequest} message AggregatedListRegionCommitmentsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListRegionCommitmentsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListRegionCommitmentsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest} AggregatedListRegionCommitmentsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListRegionCommitmentsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListRegionCommitmentsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest} AggregatedListRegionCommitmentsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListRegionCommitmentsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListRegionCommitmentsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListRegionCommitmentsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListRegionCommitmentsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest} AggregatedListRegionCommitmentsRequest
                         */
                        AggregatedListRegionCommitmentsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListRegionCommitmentsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest} message AggregatedListRegionCommitmentsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListRegionCommitmentsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListRegionCommitmentsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListRegionCommitmentsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListRegionCommitmentsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListRegionCommitmentsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest";
                        };
    
                        return AggregatedListRegionCommitmentsRequest;
                    })();
    
                    v1.AggregatedListReservationsRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListReservationsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListReservationsRequest
                         * @property {string|null} [filter] AggregatedListReservationsRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListReservationsRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListReservationsRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListReservationsRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListReservationsRequest pageToken
                         * @property {string|null} [project] AggregatedListReservationsRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListReservationsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListReservationsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListReservationsRequest.
                         * @implements IAggregatedListReservationsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListReservationsRequest=} [properties] Properties to set
                         */
                        function AggregatedListReservationsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListReservationsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @instance
                         */
                        AggregatedListReservationsRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListReservationsRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @instance
                         */
                        AggregatedListReservationsRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListReservationsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @instance
                         */
                        AggregatedListReservationsRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListReservationsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @instance
                         */
                        AggregatedListReservationsRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListReservationsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @instance
                         */
                        AggregatedListReservationsRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListReservationsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @instance
                         */
                        AggregatedListReservationsRequest.prototype.project = "";
    
                        /**
                         * AggregatedListReservationsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @instance
                         */
                        AggregatedListReservationsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListReservationsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListReservationsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListReservationsRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListReservationsRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListReservationsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListReservationsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListReservationsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListReservationsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListReservationsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListReservationsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListReservationsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListReservationsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListReservationsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListReservationsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListReservationsRequest} AggregatedListReservationsRequest instance
                         */
                        AggregatedListReservationsRequest.create = function create(properties) {
                            return new AggregatedListReservationsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListReservationsRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListReservationsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListReservationsRequest} message AggregatedListReservationsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListReservationsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListReservationsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListReservationsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListReservationsRequest} message AggregatedListReservationsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListReservationsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListReservationsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListReservationsRequest} AggregatedListReservationsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListReservationsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListReservationsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListReservationsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListReservationsRequest} AggregatedListReservationsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListReservationsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListReservationsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListReservationsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListReservationsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListReservationsRequest} AggregatedListReservationsRequest
                         */
                        AggregatedListReservationsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListReservationsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListReservationsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListReservationsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListReservationsRequest} message AggregatedListReservationsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListReservationsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListReservationsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListReservationsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListReservationsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListReservationsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListReservationsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListReservationsRequest";
                        };
    
                        return AggregatedListReservationsRequest;
                    })();
    
                    v1.AggregatedListResourcePoliciesRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListResourcePoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListResourcePoliciesRequest
                         * @property {string|null} [filter] AggregatedListResourcePoliciesRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListResourcePoliciesRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListResourcePoliciesRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListResourcePoliciesRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListResourcePoliciesRequest pageToken
                         * @property {string|null} [project] AggregatedListResourcePoliciesRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListResourcePoliciesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListResourcePoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListResourcePoliciesRequest.
                         * @implements IAggregatedListResourcePoliciesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListResourcePoliciesRequest=} [properties] Properties to set
                         */
                        function AggregatedListResourcePoliciesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListResourcePoliciesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @instance
                         */
                        AggregatedListResourcePoliciesRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListResourcePoliciesRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @instance
                         */
                        AggregatedListResourcePoliciesRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListResourcePoliciesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @instance
                         */
                        AggregatedListResourcePoliciesRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListResourcePoliciesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @instance
                         */
                        AggregatedListResourcePoliciesRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListResourcePoliciesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @instance
                         */
                        AggregatedListResourcePoliciesRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListResourcePoliciesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @instance
                         */
                        AggregatedListResourcePoliciesRequest.prototype.project = "";
    
                        /**
                         * AggregatedListResourcePoliciesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @instance
                         */
                        AggregatedListResourcePoliciesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListResourcePoliciesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListResourcePoliciesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListResourcePoliciesRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListResourcePoliciesRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListResourcePoliciesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListResourcePoliciesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListResourcePoliciesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListResourcePoliciesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListResourcePoliciesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListResourcePoliciesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListResourcePoliciesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListResourcePoliciesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListResourcePoliciesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListResourcePoliciesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListResourcePoliciesRequest} AggregatedListResourcePoliciesRequest instance
                         */
                        AggregatedListResourcePoliciesRequest.create = function create(properties) {
                            return new AggregatedListResourcePoliciesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListResourcePoliciesRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListResourcePoliciesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListResourcePoliciesRequest} message AggregatedListResourcePoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListResourcePoliciesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListResourcePoliciesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListResourcePoliciesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListResourcePoliciesRequest} message AggregatedListResourcePoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListResourcePoliciesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListResourcePoliciesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListResourcePoliciesRequest} AggregatedListResourcePoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListResourcePoliciesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListResourcePoliciesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListResourcePoliciesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListResourcePoliciesRequest} AggregatedListResourcePoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListResourcePoliciesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListResourcePoliciesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListResourcePoliciesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListResourcePoliciesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListResourcePoliciesRequest} AggregatedListResourcePoliciesRequest
                         */
                        AggregatedListResourcePoliciesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListResourcePoliciesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListResourcePoliciesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListResourcePoliciesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListResourcePoliciesRequest} message AggregatedListResourcePoliciesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListResourcePoliciesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListResourcePoliciesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListResourcePoliciesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListResourcePoliciesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListResourcePoliciesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListResourcePoliciesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListResourcePoliciesRequest";
                        };
    
                        return AggregatedListResourcePoliciesRequest;
                    })();
    
                    v1.AggregatedListRoutersRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListRoutersRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListRoutersRequest
                         * @property {string|null} [filter] AggregatedListRoutersRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListRoutersRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListRoutersRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListRoutersRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListRoutersRequest pageToken
                         * @property {string|null} [project] AggregatedListRoutersRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListRoutersRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListRoutersRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListRoutersRequest.
                         * @implements IAggregatedListRoutersRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListRoutersRequest=} [properties] Properties to set
                         */
                        function AggregatedListRoutersRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListRoutersRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @instance
                         */
                        AggregatedListRoutersRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListRoutersRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @instance
                         */
                        AggregatedListRoutersRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListRoutersRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @instance
                         */
                        AggregatedListRoutersRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListRoutersRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @instance
                         */
                        AggregatedListRoutersRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListRoutersRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @instance
                         */
                        AggregatedListRoutersRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListRoutersRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @instance
                         */
                        AggregatedListRoutersRequest.prototype.project = "";
    
                        /**
                         * AggregatedListRoutersRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @instance
                         */
                        AggregatedListRoutersRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListRoutersRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListRoutersRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListRoutersRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListRoutersRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListRoutersRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListRoutersRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListRoutersRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListRoutersRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListRoutersRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListRoutersRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListRoutersRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListRoutersRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListRoutersRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListRoutersRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListRoutersRequest} AggregatedListRoutersRequest instance
                         */
                        AggregatedListRoutersRequest.create = function create(properties) {
                            return new AggregatedListRoutersRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListRoutersRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListRoutersRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListRoutersRequest} message AggregatedListRoutersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListRoutersRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListRoutersRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListRoutersRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListRoutersRequest} message AggregatedListRoutersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListRoutersRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListRoutersRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListRoutersRequest} AggregatedListRoutersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListRoutersRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListRoutersRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListRoutersRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListRoutersRequest} AggregatedListRoutersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListRoutersRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListRoutersRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListRoutersRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListRoutersRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListRoutersRequest} AggregatedListRoutersRequest
                         */
                        AggregatedListRoutersRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListRoutersRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListRoutersRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListRoutersRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListRoutersRequest} message AggregatedListRoutersRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListRoutersRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListRoutersRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListRoutersRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListRoutersRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListRoutersRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListRoutersRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListRoutersRequest";
                        };
    
                        return AggregatedListRoutersRequest;
                    })();
    
                    v1.AggregatedListSecurityPoliciesRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListSecurityPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListSecurityPoliciesRequest
                         * @property {string|null} [filter] AggregatedListSecurityPoliciesRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListSecurityPoliciesRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListSecurityPoliciesRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListSecurityPoliciesRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListSecurityPoliciesRequest pageToken
                         * @property {string|null} [project] AggregatedListSecurityPoliciesRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListSecurityPoliciesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListSecurityPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListSecurityPoliciesRequest.
                         * @implements IAggregatedListSecurityPoliciesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListSecurityPoliciesRequest=} [properties] Properties to set
                         */
                        function AggregatedListSecurityPoliciesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListSecurityPoliciesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @instance
                         */
                        AggregatedListSecurityPoliciesRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListSecurityPoliciesRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @instance
                         */
                        AggregatedListSecurityPoliciesRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListSecurityPoliciesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @instance
                         */
                        AggregatedListSecurityPoliciesRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListSecurityPoliciesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @instance
                         */
                        AggregatedListSecurityPoliciesRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListSecurityPoliciesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @instance
                         */
                        AggregatedListSecurityPoliciesRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListSecurityPoliciesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @instance
                         */
                        AggregatedListSecurityPoliciesRequest.prototype.project = "";
    
                        /**
                         * AggregatedListSecurityPoliciesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @instance
                         */
                        AggregatedListSecurityPoliciesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListSecurityPoliciesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSecurityPoliciesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListSecurityPoliciesRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSecurityPoliciesRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListSecurityPoliciesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSecurityPoliciesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListSecurityPoliciesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSecurityPoliciesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListSecurityPoliciesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSecurityPoliciesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListSecurityPoliciesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSecurityPoliciesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListSecurityPoliciesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListSecurityPoliciesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest} AggregatedListSecurityPoliciesRequest instance
                         */
                        AggregatedListSecurityPoliciesRequest.create = function create(properties) {
                            return new AggregatedListSecurityPoliciesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListSecurityPoliciesRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListSecurityPoliciesRequest} message AggregatedListSecurityPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListSecurityPoliciesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListSecurityPoliciesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListSecurityPoliciesRequest} message AggregatedListSecurityPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListSecurityPoliciesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListSecurityPoliciesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest} AggregatedListSecurityPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListSecurityPoliciesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListSecurityPoliciesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest} AggregatedListSecurityPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListSecurityPoliciesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListSecurityPoliciesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListSecurityPoliciesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListSecurityPoliciesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest} AggregatedListSecurityPoliciesRequest
                         */
                        AggregatedListSecurityPoliciesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListSecurityPoliciesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest} message AggregatedListSecurityPoliciesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListSecurityPoliciesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListSecurityPoliciesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListSecurityPoliciesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListSecurityPoliciesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListSecurityPoliciesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest";
                        };
    
                        return AggregatedListSecurityPoliciesRequest;
                    })();
    
                    v1.AggregatedListServiceAttachmentsRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListServiceAttachmentsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListServiceAttachmentsRequest
                         * @property {string|null} [filter] AggregatedListServiceAttachmentsRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListServiceAttachmentsRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListServiceAttachmentsRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListServiceAttachmentsRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListServiceAttachmentsRequest pageToken
                         * @property {string|null} [project] AggregatedListServiceAttachmentsRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListServiceAttachmentsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListServiceAttachmentsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListServiceAttachmentsRequest.
                         * @implements IAggregatedListServiceAttachmentsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListServiceAttachmentsRequest=} [properties] Properties to set
                         */
                        function AggregatedListServiceAttachmentsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListServiceAttachmentsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @instance
                         */
                        AggregatedListServiceAttachmentsRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListServiceAttachmentsRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @instance
                         */
                        AggregatedListServiceAttachmentsRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListServiceAttachmentsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @instance
                         */
                        AggregatedListServiceAttachmentsRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListServiceAttachmentsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @instance
                         */
                        AggregatedListServiceAttachmentsRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListServiceAttachmentsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @instance
                         */
                        AggregatedListServiceAttachmentsRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListServiceAttachmentsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @instance
                         */
                        AggregatedListServiceAttachmentsRequest.prototype.project = "";
    
                        /**
                         * AggregatedListServiceAttachmentsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @instance
                         */
                        AggregatedListServiceAttachmentsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListServiceAttachmentsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListServiceAttachmentsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListServiceAttachmentsRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListServiceAttachmentsRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListServiceAttachmentsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListServiceAttachmentsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListServiceAttachmentsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListServiceAttachmentsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListServiceAttachmentsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListServiceAttachmentsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListServiceAttachmentsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListServiceAttachmentsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListServiceAttachmentsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListServiceAttachmentsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest} AggregatedListServiceAttachmentsRequest instance
                         */
                        AggregatedListServiceAttachmentsRequest.create = function create(properties) {
                            return new AggregatedListServiceAttachmentsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListServiceAttachmentsRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListServiceAttachmentsRequest} message AggregatedListServiceAttachmentsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListServiceAttachmentsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListServiceAttachmentsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListServiceAttachmentsRequest} message AggregatedListServiceAttachmentsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListServiceAttachmentsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListServiceAttachmentsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest} AggregatedListServiceAttachmentsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListServiceAttachmentsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListServiceAttachmentsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest} AggregatedListServiceAttachmentsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListServiceAttachmentsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListServiceAttachmentsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListServiceAttachmentsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListServiceAttachmentsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest} AggregatedListServiceAttachmentsRequest
                         */
                        AggregatedListServiceAttachmentsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListServiceAttachmentsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest} message AggregatedListServiceAttachmentsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListServiceAttachmentsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListServiceAttachmentsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListServiceAttachmentsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListServiceAttachmentsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListServiceAttachmentsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest";
                        };
    
                        return AggregatedListServiceAttachmentsRequest;
                    })();
    
                    v1.AggregatedListSslCertificatesRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListSslCertificatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListSslCertificatesRequest
                         * @property {string|null} [filter] AggregatedListSslCertificatesRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListSslCertificatesRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListSslCertificatesRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListSslCertificatesRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListSslCertificatesRequest pageToken
                         * @property {string|null} [project] AggregatedListSslCertificatesRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListSslCertificatesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListSslCertificatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListSslCertificatesRequest.
                         * @implements IAggregatedListSslCertificatesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListSslCertificatesRequest=} [properties] Properties to set
                         */
                        function AggregatedListSslCertificatesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListSslCertificatesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @instance
                         */
                        AggregatedListSslCertificatesRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListSslCertificatesRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @instance
                         */
                        AggregatedListSslCertificatesRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListSslCertificatesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @instance
                         */
                        AggregatedListSslCertificatesRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListSslCertificatesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @instance
                         */
                        AggregatedListSslCertificatesRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListSslCertificatesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @instance
                         */
                        AggregatedListSslCertificatesRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListSslCertificatesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @instance
                         */
                        AggregatedListSslCertificatesRequest.prototype.project = "";
    
                        /**
                         * AggregatedListSslCertificatesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @instance
                         */
                        AggregatedListSslCertificatesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListSslCertificatesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSslCertificatesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListSslCertificatesRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSslCertificatesRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListSslCertificatesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSslCertificatesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListSslCertificatesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSslCertificatesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListSslCertificatesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSslCertificatesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListSslCertificatesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSslCertificatesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListSslCertificatesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListSslCertificatesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListSslCertificatesRequest} AggregatedListSslCertificatesRequest instance
                         */
                        AggregatedListSslCertificatesRequest.create = function create(properties) {
                            return new AggregatedListSslCertificatesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListSslCertificatesRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListSslCertificatesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListSslCertificatesRequest} message AggregatedListSslCertificatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListSslCertificatesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListSslCertificatesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListSslCertificatesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListSslCertificatesRequest} message AggregatedListSslCertificatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListSslCertificatesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListSslCertificatesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListSslCertificatesRequest} AggregatedListSslCertificatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListSslCertificatesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListSslCertificatesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListSslCertificatesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListSslCertificatesRequest} AggregatedListSslCertificatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListSslCertificatesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListSslCertificatesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListSslCertificatesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListSslCertificatesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListSslCertificatesRequest} AggregatedListSslCertificatesRequest
                         */
                        AggregatedListSslCertificatesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListSslCertificatesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListSslCertificatesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListSslCertificatesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListSslCertificatesRequest} message AggregatedListSslCertificatesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListSslCertificatesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListSslCertificatesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListSslCertificatesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListSslCertificatesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListSslCertificatesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListSslCertificatesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListSslCertificatesRequest";
                        };
    
                        return AggregatedListSslCertificatesRequest;
                    })();
    
                    v1.AggregatedListSslPoliciesRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListSslPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListSslPoliciesRequest
                         * @property {string|null} [filter] AggregatedListSslPoliciesRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListSslPoliciesRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListSslPoliciesRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListSslPoliciesRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListSslPoliciesRequest pageToken
                         * @property {string|null} [project] AggregatedListSslPoliciesRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListSslPoliciesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListSslPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListSslPoliciesRequest.
                         * @implements IAggregatedListSslPoliciesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListSslPoliciesRequest=} [properties] Properties to set
                         */
                        function AggregatedListSslPoliciesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListSslPoliciesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @instance
                         */
                        AggregatedListSslPoliciesRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListSslPoliciesRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @instance
                         */
                        AggregatedListSslPoliciesRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListSslPoliciesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @instance
                         */
                        AggregatedListSslPoliciesRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListSslPoliciesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @instance
                         */
                        AggregatedListSslPoliciesRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListSslPoliciesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @instance
                         */
                        AggregatedListSslPoliciesRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListSslPoliciesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @instance
                         */
                        AggregatedListSslPoliciesRequest.prototype.project = "";
    
                        /**
                         * AggregatedListSslPoliciesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @instance
                         */
                        AggregatedListSslPoliciesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListSslPoliciesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSslPoliciesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListSslPoliciesRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSslPoliciesRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListSslPoliciesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSslPoliciesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListSslPoliciesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSslPoliciesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListSslPoliciesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSslPoliciesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListSslPoliciesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSslPoliciesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListSslPoliciesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListSslPoliciesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListSslPoliciesRequest} AggregatedListSslPoliciesRequest instance
                         */
                        AggregatedListSslPoliciesRequest.create = function create(properties) {
                            return new AggregatedListSslPoliciesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListSslPoliciesRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListSslPoliciesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListSslPoliciesRequest} message AggregatedListSslPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListSslPoliciesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListSslPoliciesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListSslPoliciesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListSslPoliciesRequest} message AggregatedListSslPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListSslPoliciesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListSslPoliciesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListSslPoliciesRequest} AggregatedListSslPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListSslPoliciesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListSslPoliciesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListSslPoliciesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListSslPoliciesRequest} AggregatedListSslPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListSslPoliciesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListSslPoliciesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListSslPoliciesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListSslPoliciesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListSslPoliciesRequest} AggregatedListSslPoliciesRequest
                         */
                        AggregatedListSslPoliciesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListSslPoliciesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListSslPoliciesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListSslPoliciesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListSslPoliciesRequest} message AggregatedListSslPoliciesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListSslPoliciesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListSslPoliciesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListSslPoliciesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListSslPoliciesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListSslPoliciesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListSslPoliciesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListSslPoliciesRequest";
                        };
    
                        return AggregatedListSslPoliciesRequest;
                    })();
    
                    v1.AggregatedListSubnetworksRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListSubnetworksRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListSubnetworksRequest
                         * @property {string|null} [filter] AggregatedListSubnetworksRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListSubnetworksRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListSubnetworksRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListSubnetworksRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListSubnetworksRequest pageToken
                         * @property {string|null} [project] AggregatedListSubnetworksRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListSubnetworksRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListSubnetworksRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListSubnetworksRequest.
                         * @implements IAggregatedListSubnetworksRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListSubnetworksRequest=} [properties] Properties to set
                         */
                        function AggregatedListSubnetworksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListSubnetworksRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @instance
                         */
                        AggregatedListSubnetworksRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListSubnetworksRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @instance
                         */
                        AggregatedListSubnetworksRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListSubnetworksRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @instance
                         */
                        AggregatedListSubnetworksRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListSubnetworksRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @instance
                         */
                        AggregatedListSubnetworksRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListSubnetworksRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @instance
                         */
                        AggregatedListSubnetworksRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListSubnetworksRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @instance
                         */
                        AggregatedListSubnetworksRequest.prototype.project = "";
    
                        /**
                         * AggregatedListSubnetworksRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @instance
                         */
                        AggregatedListSubnetworksRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListSubnetworksRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSubnetworksRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListSubnetworksRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSubnetworksRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListSubnetworksRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSubnetworksRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListSubnetworksRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSubnetworksRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListSubnetworksRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSubnetworksRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListSubnetworksRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListSubnetworksRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListSubnetworksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListSubnetworksRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListSubnetworksRequest} AggregatedListSubnetworksRequest instance
                         */
                        AggregatedListSubnetworksRequest.create = function create(properties) {
                            return new AggregatedListSubnetworksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListSubnetworksRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListSubnetworksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListSubnetworksRequest} message AggregatedListSubnetworksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListSubnetworksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListSubnetworksRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListSubnetworksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListSubnetworksRequest} message AggregatedListSubnetworksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListSubnetworksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListSubnetworksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListSubnetworksRequest} AggregatedListSubnetworksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListSubnetworksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListSubnetworksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListSubnetworksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListSubnetworksRequest} AggregatedListSubnetworksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListSubnetworksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListSubnetworksRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListSubnetworksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListSubnetworksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListSubnetworksRequest} AggregatedListSubnetworksRequest
                         */
                        AggregatedListSubnetworksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListSubnetworksRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListSubnetworksRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListSubnetworksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListSubnetworksRequest} message AggregatedListSubnetworksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListSubnetworksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListSubnetworksRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListSubnetworksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListSubnetworksRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListSubnetworksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListSubnetworksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListSubnetworksRequest";
                        };
    
                        return AggregatedListSubnetworksRequest;
                    })();
    
                    v1.AggregatedListTargetHttpProxiesRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListTargetHttpProxiesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListTargetHttpProxiesRequest
                         * @property {string|null} [filter] AggregatedListTargetHttpProxiesRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListTargetHttpProxiesRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListTargetHttpProxiesRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListTargetHttpProxiesRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListTargetHttpProxiesRequest pageToken
                         * @property {string|null} [project] AggregatedListTargetHttpProxiesRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListTargetHttpProxiesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListTargetHttpProxiesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListTargetHttpProxiesRequest.
                         * @implements IAggregatedListTargetHttpProxiesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListTargetHttpProxiesRequest=} [properties] Properties to set
                         */
                        function AggregatedListTargetHttpProxiesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListTargetHttpProxiesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @instance
                         */
                        AggregatedListTargetHttpProxiesRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListTargetHttpProxiesRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @instance
                         */
                        AggregatedListTargetHttpProxiesRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListTargetHttpProxiesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @instance
                         */
                        AggregatedListTargetHttpProxiesRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListTargetHttpProxiesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @instance
                         */
                        AggregatedListTargetHttpProxiesRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListTargetHttpProxiesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @instance
                         */
                        AggregatedListTargetHttpProxiesRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListTargetHttpProxiesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @instance
                         */
                        AggregatedListTargetHttpProxiesRequest.prototype.project = "";
    
                        /**
                         * AggregatedListTargetHttpProxiesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @instance
                         */
                        AggregatedListTargetHttpProxiesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListTargetHttpProxiesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetHttpProxiesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetHttpProxiesRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetHttpProxiesRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetHttpProxiesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetHttpProxiesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetHttpProxiesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetHttpProxiesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetHttpProxiesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetHttpProxiesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetHttpProxiesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetHttpProxiesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListTargetHttpProxiesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListTargetHttpProxiesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest} AggregatedListTargetHttpProxiesRequest instance
                         */
                        AggregatedListTargetHttpProxiesRequest.create = function create(properties) {
                            return new AggregatedListTargetHttpProxiesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListTargetHttpProxiesRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListTargetHttpProxiesRequest} message AggregatedListTargetHttpProxiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListTargetHttpProxiesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListTargetHttpProxiesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListTargetHttpProxiesRequest} message AggregatedListTargetHttpProxiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListTargetHttpProxiesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListTargetHttpProxiesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest} AggregatedListTargetHttpProxiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListTargetHttpProxiesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListTargetHttpProxiesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest} AggregatedListTargetHttpProxiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListTargetHttpProxiesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListTargetHttpProxiesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListTargetHttpProxiesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListTargetHttpProxiesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest} AggregatedListTargetHttpProxiesRequest
                         */
                        AggregatedListTargetHttpProxiesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListTargetHttpProxiesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest} message AggregatedListTargetHttpProxiesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListTargetHttpProxiesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListTargetHttpProxiesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListTargetHttpProxiesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListTargetHttpProxiesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListTargetHttpProxiesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest";
                        };
    
                        return AggregatedListTargetHttpProxiesRequest;
                    })();
    
                    v1.AggregatedListTargetHttpsProxiesRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListTargetHttpsProxiesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListTargetHttpsProxiesRequest
                         * @property {string|null} [filter] AggregatedListTargetHttpsProxiesRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListTargetHttpsProxiesRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListTargetHttpsProxiesRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListTargetHttpsProxiesRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListTargetHttpsProxiesRequest pageToken
                         * @property {string|null} [project] AggregatedListTargetHttpsProxiesRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListTargetHttpsProxiesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListTargetHttpsProxiesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListTargetHttpsProxiesRequest.
                         * @implements IAggregatedListTargetHttpsProxiesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListTargetHttpsProxiesRequest=} [properties] Properties to set
                         */
                        function AggregatedListTargetHttpsProxiesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListTargetHttpsProxiesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @instance
                         */
                        AggregatedListTargetHttpsProxiesRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListTargetHttpsProxiesRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @instance
                         */
                        AggregatedListTargetHttpsProxiesRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListTargetHttpsProxiesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @instance
                         */
                        AggregatedListTargetHttpsProxiesRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListTargetHttpsProxiesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @instance
                         */
                        AggregatedListTargetHttpsProxiesRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListTargetHttpsProxiesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @instance
                         */
                        AggregatedListTargetHttpsProxiesRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListTargetHttpsProxiesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @instance
                         */
                        AggregatedListTargetHttpsProxiesRequest.prototype.project = "";
    
                        /**
                         * AggregatedListTargetHttpsProxiesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @instance
                         */
                        AggregatedListTargetHttpsProxiesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListTargetHttpsProxiesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetHttpsProxiesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetHttpsProxiesRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetHttpsProxiesRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetHttpsProxiesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetHttpsProxiesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetHttpsProxiesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetHttpsProxiesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetHttpsProxiesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetHttpsProxiesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetHttpsProxiesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetHttpsProxiesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListTargetHttpsProxiesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListTargetHttpsProxiesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest} AggregatedListTargetHttpsProxiesRequest instance
                         */
                        AggregatedListTargetHttpsProxiesRequest.create = function create(properties) {
                            return new AggregatedListTargetHttpsProxiesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListTargetHttpsProxiesRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListTargetHttpsProxiesRequest} message AggregatedListTargetHttpsProxiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListTargetHttpsProxiesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListTargetHttpsProxiesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListTargetHttpsProxiesRequest} message AggregatedListTargetHttpsProxiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListTargetHttpsProxiesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListTargetHttpsProxiesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest} AggregatedListTargetHttpsProxiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListTargetHttpsProxiesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListTargetHttpsProxiesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest} AggregatedListTargetHttpsProxiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListTargetHttpsProxiesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListTargetHttpsProxiesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListTargetHttpsProxiesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListTargetHttpsProxiesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest} AggregatedListTargetHttpsProxiesRequest
                         */
                        AggregatedListTargetHttpsProxiesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListTargetHttpsProxiesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest} message AggregatedListTargetHttpsProxiesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListTargetHttpsProxiesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListTargetHttpsProxiesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListTargetHttpsProxiesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListTargetHttpsProxiesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListTargetHttpsProxiesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest";
                        };
    
                        return AggregatedListTargetHttpsProxiesRequest;
                    })();
    
                    v1.AggregatedListTargetInstancesRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListTargetInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListTargetInstancesRequest
                         * @property {string|null} [filter] AggregatedListTargetInstancesRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListTargetInstancesRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListTargetInstancesRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListTargetInstancesRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListTargetInstancesRequest pageToken
                         * @property {string|null} [project] AggregatedListTargetInstancesRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListTargetInstancesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListTargetInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListTargetInstancesRequest.
                         * @implements IAggregatedListTargetInstancesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListTargetInstancesRequest=} [properties] Properties to set
                         */
                        function AggregatedListTargetInstancesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListTargetInstancesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @instance
                         */
                        AggregatedListTargetInstancesRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListTargetInstancesRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @instance
                         */
                        AggregatedListTargetInstancesRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListTargetInstancesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @instance
                         */
                        AggregatedListTargetInstancesRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListTargetInstancesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @instance
                         */
                        AggregatedListTargetInstancesRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListTargetInstancesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @instance
                         */
                        AggregatedListTargetInstancesRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListTargetInstancesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @instance
                         */
                        AggregatedListTargetInstancesRequest.prototype.project = "";
    
                        /**
                         * AggregatedListTargetInstancesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @instance
                         */
                        AggregatedListTargetInstancesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListTargetInstancesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetInstancesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetInstancesRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetInstancesRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetInstancesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetInstancesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetInstancesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetInstancesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetInstancesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetInstancesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetInstancesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetInstancesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListTargetInstancesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListTargetInstancesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListTargetInstancesRequest} AggregatedListTargetInstancesRequest instance
                         */
                        AggregatedListTargetInstancesRequest.create = function create(properties) {
                            return new AggregatedListTargetInstancesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListTargetInstancesRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListTargetInstancesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListTargetInstancesRequest} message AggregatedListTargetInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListTargetInstancesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListTargetInstancesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListTargetInstancesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListTargetInstancesRequest} message AggregatedListTargetInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListTargetInstancesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListTargetInstancesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListTargetInstancesRequest} AggregatedListTargetInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListTargetInstancesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListTargetInstancesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListTargetInstancesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListTargetInstancesRequest} AggregatedListTargetInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListTargetInstancesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListTargetInstancesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListTargetInstancesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListTargetInstancesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListTargetInstancesRequest} AggregatedListTargetInstancesRequest
                         */
                        AggregatedListTargetInstancesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListTargetInstancesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListTargetInstancesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListTargetInstancesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListTargetInstancesRequest} message AggregatedListTargetInstancesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListTargetInstancesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListTargetInstancesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListTargetInstancesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListTargetInstancesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListTargetInstancesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListTargetInstancesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListTargetInstancesRequest";
                        };
    
                        return AggregatedListTargetInstancesRequest;
                    })();
    
                    v1.AggregatedListTargetPoolsRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListTargetPoolsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListTargetPoolsRequest
                         * @property {string|null} [filter] AggregatedListTargetPoolsRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListTargetPoolsRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListTargetPoolsRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListTargetPoolsRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListTargetPoolsRequest pageToken
                         * @property {string|null} [project] AggregatedListTargetPoolsRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListTargetPoolsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListTargetPoolsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListTargetPoolsRequest.
                         * @implements IAggregatedListTargetPoolsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListTargetPoolsRequest=} [properties] Properties to set
                         */
                        function AggregatedListTargetPoolsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListTargetPoolsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @instance
                         */
                        AggregatedListTargetPoolsRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListTargetPoolsRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @instance
                         */
                        AggregatedListTargetPoolsRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListTargetPoolsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @instance
                         */
                        AggregatedListTargetPoolsRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListTargetPoolsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @instance
                         */
                        AggregatedListTargetPoolsRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListTargetPoolsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @instance
                         */
                        AggregatedListTargetPoolsRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListTargetPoolsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @instance
                         */
                        AggregatedListTargetPoolsRequest.prototype.project = "";
    
                        /**
                         * AggregatedListTargetPoolsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @instance
                         */
                        AggregatedListTargetPoolsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListTargetPoolsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetPoolsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetPoolsRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetPoolsRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetPoolsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetPoolsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetPoolsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetPoolsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetPoolsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetPoolsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetPoolsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetPoolsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListTargetPoolsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListTargetPoolsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListTargetPoolsRequest} AggregatedListTargetPoolsRequest instance
                         */
                        AggregatedListTargetPoolsRequest.create = function create(properties) {
                            return new AggregatedListTargetPoolsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListTargetPoolsRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListTargetPoolsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListTargetPoolsRequest} message AggregatedListTargetPoolsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListTargetPoolsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListTargetPoolsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListTargetPoolsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListTargetPoolsRequest} message AggregatedListTargetPoolsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListTargetPoolsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListTargetPoolsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListTargetPoolsRequest} AggregatedListTargetPoolsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListTargetPoolsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListTargetPoolsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListTargetPoolsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListTargetPoolsRequest} AggregatedListTargetPoolsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListTargetPoolsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListTargetPoolsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListTargetPoolsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListTargetPoolsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListTargetPoolsRequest} AggregatedListTargetPoolsRequest
                         */
                        AggregatedListTargetPoolsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListTargetPoolsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListTargetPoolsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListTargetPoolsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListTargetPoolsRequest} message AggregatedListTargetPoolsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListTargetPoolsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListTargetPoolsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListTargetPoolsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListTargetPoolsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListTargetPoolsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListTargetPoolsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListTargetPoolsRequest";
                        };
    
                        return AggregatedListTargetPoolsRequest;
                    })();
    
                    v1.AggregatedListTargetVpnGatewaysRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListTargetVpnGatewaysRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListTargetVpnGatewaysRequest
                         * @property {string|null} [filter] AggregatedListTargetVpnGatewaysRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListTargetVpnGatewaysRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListTargetVpnGatewaysRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListTargetVpnGatewaysRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListTargetVpnGatewaysRequest pageToken
                         * @property {string|null} [project] AggregatedListTargetVpnGatewaysRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListTargetVpnGatewaysRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListTargetVpnGatewaysRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListTargetVpnGatewaysRequest.
                         * @implements IAggregatedListTargetVpnGatewaysRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListTargetVpnGatewaysRequest=} [properties] Properties to set
                         */
                        function AggregatedListTargetVpnGatewaysRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListTargetVpnGatewaysRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @instance
                         */
                        AggregatedListTargetVpnGatewaysRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListTargetVpnGatewaysRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @instance
                         */
                        AggregatedListTargetVpnGatewaysRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListTargetVpnGatewaysRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @instance
                         */
                        AggregatedListTargetVpnGatewaysRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListTargetVpnGatewaysRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @instance
                         */
                        AggregatedListTargetVpnGatewaysRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListTargetVpnGatewaysRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @instance
                         */
                        AggregatedListTargetVpnGatewaysRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListTargetVpnGatewaysRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @instance
                         */
                        AggregatedListTargetVpnGatewaysRequest.prototype.project = "";
    
                        /**
                         * AggregatedListTargetVpnGatewaysRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @instance
                         */
                        AggregatedListTargetVpnGatewaysRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListTargetVpnGatewaysRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetVpnGatewaysRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetVpnGatewaysRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetVpnGatewaysRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetVpnGatewaysRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetVpnGatewaysRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetVpnGatewaysRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetVpnGatewaysRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetVpnGatewaysRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetVpnGatewaysRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListTargetVpnGatewaysRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListTargetVpnGatewaysRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListTargetVpnGatewaysRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListTargetVpnGatewaysRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest} AggregatedListTargetVpnGatewaysRequest instance
                         */
                        AggregatedListTargetVpnGatewaysRequest.create = function create(properties) {
                            return new AggregatedListTargetVpnGatewaysRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListTargetVpnGatewaysRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListTargetVpnGatewaysRequest} message AggregatedListTargetVpnGatewaysRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListTargetVpnGatewaysRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListTargetVpnGatewaysRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListTargetVpnGatewaysRequest} message AggregatedListTargetVpnGatewaysRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListTargetVpnGatewaysRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListTargetVpnGatewaysRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest} AggregatedListTargetVpnGatewaysRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListTargetVpnGatewaysRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListTargetVpnGatewaysRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest} AggregatedListTargetVpnGatewaysRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListTargetVpnGatewaysRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListTargetVpnGatewaysRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListTargetVpnGatewaysRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListTargetVpnGatewaysRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest} AggregatedListTargetVpnGatewaysRequest
                         */
                        AggregatedListTargetVpnGatewaysRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListTargetVpnGatewaysRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest} message AggregatedListTargetVpnGatewaysRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListTargetVpnGatewaysRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListTargetVpnGatewaysRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListTargetVpnGatewaysRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListTargetVpnGatewaysRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListTargetVpnGatewaysRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest";
                        };
    
                        return AggregatedListTargetVpnGatewaysRequest;
                    })();
    
                    v1.AggregatedListUrlMapsRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListUrlMapsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListUrlMapsRequest
                         * @property {string|null} [filter] AggregatedListUrlMapsRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListUrlMapsRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListUrlMapsRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListUrlMapsRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListUrlMapsRequest pageToken
                         * @property {string|null} [project] AggregatedListUrlMapsRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListUrlMapsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListUrlMapsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListUrlMapsRequest.
                         * @implements IAggregatedListUrlMapsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListUrlMapsRequest=} [properties] Properties to set
                         */
                        function AggregatedListUrlMapsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListUrlMapsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @instance
                         */
                        AggregatedListUrlMapsRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListUrlMapsRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @instance
                         */
                        AggregatedListUrlMapsRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListUrlMapsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @instance
                         */
                        AggregatedListUrlMapsRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListUrlMapsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @instance
                         */
                        AggregatedListUrlMapsRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListUrlMapsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @instance
                         */
                        AggregatedListUrlMapsRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListUrlMapsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @instance
                         */
                        AggregatedListUrlMapsRequest.prototype.project = "";
    
                        /**
                         * AggregatedListUrlMapsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @instance
                         */
                        AggregatedListUrlMapsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListUrlMapsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListUrlMapsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListUrlMapsRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListUrlMapsRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListUrlMapsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListUrlMapsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListUrlMapsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListUrlMapsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListUrlMapsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListUrlMapsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListUrlMapsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListUrlMapsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListUrlMapsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListUrlMapsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListUrlMapsRequest} AggregatedListUrlMapsRequest instance
                         */
                        AggregatedListUrlMapsRequest.create = function create(properties) {
                            return new AggregatedListUrlMapsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListUrlMapsRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListUrlMapsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListUrlMapsRequest} message AggregatedListUrlMapsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListUrlMapsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListUrlMapsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListUrlMapsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListUrlMapsRequest} message AggregatedListUrlMapsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListUrlMapsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListUrlMapsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListUrlMapsRequest} AggregatedListUrlMapsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListUrlMapsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListUrlMapsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListUrlMapsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListUrlMapsRequest} AggregatedListUrlMapsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListUrlMapsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListUrlMapsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListUrlMapsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListUrlMapsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListUrlMapsRequest} AggregatedListUrlMapsRequest
                         */
                        AggregatedListUrlMapsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListUrlMapsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListUrlMapsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListUrlMapsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListUrlMapsRequest} message AggregatedListUrlMapsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListUrlMapsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListUrlMapsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListUrlMapsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListUrlMapsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListUrlMapsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListUrlMapsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListUrlMapsRequest";
                        };
    
                        return AggregatedListUrlMapsRequest;
                    })();
    
                    v1.AggregatedListVpnGatewaysRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListVpnGatewaysRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListVpnGatewaysRequest
                         * @property {string|null} [filter] AggregatedListVpnGatewaysRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListVpnGatewaysRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListVpnGatewaysRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListVpnGatewaysRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListVpnGatewaysRequest pageToken
                         * @property {string|null} [project] AggregatedListVpnGatewaysRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListVpnGatewaysRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListVpnGatewaysRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListVpnGatewaysRequest.
                         * @implements IAggregatedListVpnGatewaysRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListVpnGatewaysRequest=} [properties] Properties to set
                         */
                        function AggregatedListVpnGatewaysRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListVpnGatewaysRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @instance
                         */
                        AggregatedListVpnGatewaysRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListVpnGatewaysRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @instance
                         */
                        AggregatedListVpnGatewaysRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListVpnGatewaysRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @instance
                         */
                        AggregatedListVpnGatewaysRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListVpnGatewaysRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @instance
                         */
                        AggregatedListVpnGatewaysRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListVpnGatewaysRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @instance
                         */
                        AggregatedListVpnGatewaysRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListVpnGatewaysRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @instance
                         */
                        AggregatedListVpnGatewaysRequest.prototype.project = "";
    
                        /**
                         * AggregatedListVpnGatewaysRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @instance
                         */
                        AggregatedListVpnGatewaysRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListVpnGatewaysRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListVpnGatewaysRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListVpnGatewaysRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListVpnGatewaysRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListVpnGatewaysRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListVpnGatewaysRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListVpnGatewaysRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListVpnGatewaysRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListVpnGatewaysRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListVpnGatewaysRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListVpnGatewaysRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListVpnGatewaysRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListVpnGatewaysRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListVpnGatewaysRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListVpnGatewaysRequest} AggregatedListVpnGatewaysRequest instance
                         */
                        AggregatedListVpnGatewaysRequest.create = function create(properties) {
                            return new AggregatedListVpnGatewaysRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListVpnGatewaysRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListVpnGatewaysRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListVpnGatewaysRequest} message AggregatedListVpnGatewaysRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListVpnGatewaysRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListVpnGatewaysRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListVpnGatewaysRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListVpnGatewaysRequest} message AggregatedListVpnGatewaysRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListVpnGatewaysRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListVpnGatewaysRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListVpnGatewaysRequest} AggregatedListVpnGatewaysRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListVpnGatewaysRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListVpnGatewaysRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListVpnGatewaysRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListVpnGatewaysRequest} AggregatedListVpnGatewaysRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListVpnGatewaysRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListVpnGatewaysRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListVpnGatewaysRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListVpnGatewaysRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListVpnGatewaysRequest} AggregatedListVpnGatewaysRequest
                         */
                        AggregatedListVpnGatewaysRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListVpnGatewaysRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListVpnGatewaysRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListVpnGatewaysRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListVpnGatewaysRequest} message AggregatedListVpnGatewaysRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListVpnGatewaysRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListVpnGatewaysRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListVpnGatewaysRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListVpnGatewaysRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListVpnGatewaysRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListVpnGatewaysRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListVpnGatewaysRequest";
                        };
    
                        return AggregatedListVpnGatewaysRequest;
                    })();
    
                    v1.AggregatedListVpnTunnelsRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListVpnTunnelsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAggregatedListVpnTunnelsRequest
                         * @property {string|null} [filter] AggregatedListVpnTunnelsRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListVpnTunnelsRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListVpnTunnelsRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListVpnTunnelsRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListVpnTunnelsRequest pageToken
                         * @property {string|null} [project] AggregatedListVpnTunnelsRequest project
                         * @property {boolean|null} [returnPartialSuccess] AggregatedListVpnTunnelsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new AggregatedListVpnTunnelsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AggregatedListVpnTunnelsRequest.
                         * @implements IAggregatedListVpnTunnelsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAggregatedListVpnTunnelsRequest=} [properties] Properties to set
                         */
                        function AggregatedListVpnTunnelsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListVpnTunnelsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @instance
                         */
                        AggregatedListVpnTunnelsRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListVpnTunnelsRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @instance
                         */
                        AggregatedListVpnTunnelsRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListVpnTunnelsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @instance
                         */
                        AggregatedListVpnTunnelsRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListVpnTunnelsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @instance
                         */
                        AggregatedListVpnTunnelsRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListVpnTunnelsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @instance
                         */
                        AggregatedListVpnTunnelsRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListVpnTunnelsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @instance
                         */
                        AggregatedListVpnTunnelsRequest.prototype.project = "";
    
                        /**
                         * AggregatedListVpnTunnelsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @instance
                         */
                        AggregatedListVpnTunnelsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListVpnTunnelsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListVpnTunnelsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListVpnTunnelsRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListVpnTunnelsRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListVpnTunnelsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListVpnTunnelsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListVpnTunnelsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListVpnTunnelsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListVpnTunnelsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListVpnTunnelsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListVpnTunnelsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListVpnTunnelsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListVpnTunnelsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListVpnTunnelsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AggregatedListVpnTunnelsRequest} AggregatedListVpnTunnelsRequest instance
                         */
                        AggregatedListVpnTunnelsRequest.create = function create(properties) {
                            return new AggregatedListVpnTunnelsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListVpnTunnelsRequest message. Does not implicitly {@link google.cloud.compute.v1.AggregatedListVpnTunnelsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListVpnTunnelsRequest} message AggregatedListVpnTunnelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListVpnTunnelsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListVpnTunnelsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AggregatedListVpnTunnelsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAggregatedListVpnTunnelsRequest} message AggregatedListVpnTunnelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListVpnTunnelsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListVpnTunnelsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AggregatedListVpnTunnelsRequest} AggregatedListVpnTunnelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListVpnTunnelsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AggregatedListVpnTunnelsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListVpnTunnelsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AggregatedListVpnTunnelsRequest} AggregatedListVpnTunnelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListVpnTunnelsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListVpnTunnelsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListVpnTunnelsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListVpnTunnelsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AggregatedListVpnTunnelsRequest} AggregatedListVpnTunnelsRequest
                         */
                        AggregatedListVpnTunnelsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AggregatedListVpnTunnelsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AggregatedListVpnTunnelsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListVpnTunnelsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.AggregatedListVpnTunnelsRequest} message AggregatedListVpnTunnelsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListVpnTunnelsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListVpnTunnelsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListVpnTunnelsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListVpnTunnelsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AggregatedListVpnTunnelsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListVpnTunnelsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AggregatedListVpnTunnelsRequest";
                        };
    
                        return AggregatedListVpnTunnelsRequest;
                    })();
    
                    v1.AliasIpRange = (function() {
    
                        /**
                         * Properties of an AliasIpRange.
                         * @memberof google.cloud.compute.v1
                         * @interface IAliasIpRange
                         * @property {string|null} [ipCidrRange] AliasIpRange ipCidrRange
                         * @property {string|null} [subnetworkRangeName] AliasIpRange subnetworkRangeName
                         */
    
                        /**
                         * Constructs a new AliasIpRange.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AliasIpRange.
                         * @implements IAliasIpRange
                         * @constructor
                         * @param {google.cloud.compute.v1.IAliasIpRange=} [properties] Properties to set
                         */
                        function AliasIpRange(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AliasIpRange ipCidrRange.
                         * @member {string|null|undefined} ipCidrRange
                         * @memberof google.cloud.compute.v1.AliasIpRange
                         * @instance
                         */
                        AliasIpRange.prototype.ipCidrRange = null;
    
                        /**
                         * AliasIpRange subnetworkRangeName.
                         * @member {string|null|undefined} subnetworkRangeName
                         * @memberof google.cloud.compute.v1.AliasIpRange
                         * @instance
                         */
                        AliasIpRange.prototype.subnetworkRangeName = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AliasIpRange _ipCidrRange.
                         * @member {"ipCidrRange"|undefined} _ipCidrRange
                         * @memberof google.cloud.compute.v1.AliasIpRange
                         * @instance
                         */
                        Object.defineProperty(AliasIpRange.prototype, "_ipCidrRange", {
                            get: $util.oneOfGetter($oneOfFields = ["ipCidrRange"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AliasIpRange _subnetworkRangeName.
                         * @member {"subnetworkRangeName"|undefined} _subnetworkRangeName
                         * @memberof google.cloud.compute.v1.AliasIpRange
                         * @instance
                         */
                        Object.defineProperty(AliasIpRange.prototype, "_subnetworkRangeName", {
                            get: $util.oneOfGetter($oneOfFields = ["subnetworkRangeName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AliasIpRange instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AliasIpRange
                         * @static
                         * @param {google.cloud.compute.v1.IAliasIpRange=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AliasIpRange} AliasIpRange instance
                         */
                        AliasIpRange.create = function create(properties) {
                            return new AliasIpRange(properties);
                        };
    
                        /**
                         * Encodes the specified AliasIpRange message. Does not implicitly {@link google.cloud.compute.v1.AliasIpRange.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AliasIpRange
                         * @static
                         * @param {google.cloud.compute.v1.IAliasIpRange} message AliasIpRange message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AliasIpRange.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.ipCidrRange != null && Object.hasOwnProperty.call(message, "ipCidrRange"))
                                writer.uint32(/* id 98117322, wireType 2 =*/784938578).string(message.ipCidrRange);
                            if (message.subnetworkRangeName != null && Object.hasOwnProperty.call(message, "subnetworkRangeName"))
                                writer.uint32(/* id 387995966, wireType 2 =*/3103967730).string(message.subnetworkRangeName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AliasIpRange message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AliasIpRange.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AliasIpRange
                         * @static
                         * @param {google.cloud.compute.v1.IAliasIpRange} message AliasIpRange message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AliasIpRange.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AliasIpRange message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AliasIpRange
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AliasIpRange} AliasIpRange
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AliasIpRange.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AliasIpRange();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 98117322: {
                                        message.ipCidrRange = reader.string();
                                        break;
                                    }
                                case 387995966: {
                                        message.subnetworkRangeName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AliasIpRange message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AliasIpRange
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AliasIpRange} AliasIpRange
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AliasIpRange.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AliasIpRange message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AliasIpRange
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AliasIpRange.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.ipCidrRange != null && message.hasOwnProperty("ipCidrRange")) {
                                properties._ipCidrRange = 1;
                                if (!$util.isString(message.ipCidrRange))
                                    return "ipCidrRange: string expected";
                            }
                            if (message.subnetworkRangeName != null && message.hasOwnProperty("subnetworkRangeName")) {
                                properties._subnetworkRangeName = 1;
                                if (!$util.isString(message.subnetworkRangeName))
                                    return "subnetworkRangeName: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AliasIpRange message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AliasIpRange
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AliasIpRange} AliasIpRange
                         */
                        AliasIpRange.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AliasIpRange)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AliasIpRange();
                            if (object.ipCidrRange != null)
                                message.ipCidrRange = String(object.ipCidrRange);
                            if (object.subnetworkRangeName != null)
                                message.subnetworkRangeName = String(object.subnetworkRangeName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AliasIpRange message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AliasIpRange
                         * @static
                         * @param {google.cloud.compute.v1.AliasIpRange} message AliasIpRange
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AliasIpRange.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.ipCidrRange != null && message.hasOwnProperty("ipCidrRange")) {
                                object.ipCidrRange = message.ipCidrRange;
                                if (options.oneofs)
                                    object._ipCidrRange = "ipCidrRange";
                            }
                            if (message.subnetworkRangeName != null && message.hasOwnProperty("subnetworkRangeName")) {
                                object.subnetworkRangeName = message.subnetworkRangeName;
                                if (options.oneofs)
                                    object._subnetworkRangeName = "subnetworkRangeName";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AliasIpRange to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AliasIpRange
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AliasIpRange.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AliasIpRange
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AliasIpRange
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AliasIpRange.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AliasIpRange";
                        };
    
                        return AliasIpRange;
                    })();
    
                    v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk = (function() {
    
                        /**
                         * Properties of an AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.
                         * @memberof google.cloud.compute.v1
                         * @interface IAllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         * @property {number|Long|null} [diskSizeGb] AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk diskSizeGb
                         * @property {string|null} ["interface"] AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk interface
                         */
    
                        /**
                         * Constructs a new AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.
                         * @implements IAllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         * @constructor
                         * @param {google.cloud.compute.v1.IAllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk=} [properties] Properties to set
                         */
                        function AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk diskSizeGb.
                         * @member {number|Long|null|undefined} diskSizeGb
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         * @instance
                         */
                        AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.prototype.diskSizeGb = null;
    
                        /**
                         * AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk interface.
                         * @member {string|null|undefined} interface
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         * @instance
                         */
                        AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.prototype["interface"] = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk _diskSizeGb.
                         * @member {"diskSizeGb"|undefined} _diskSizeGb
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         * @instance
                         */
                        Object.defineProperty(AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.prototype, "_diskSizeGb", {
                            get: $util.oneOfGetter($oneOfFields = ["diskSizeGb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk _interface.
                         * @member {"interface"|undefined} _interface
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         * @instance
                         */
                        Object.defineProperty(AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.prototype, "_interface", {
                            get: $util.oneOfGetter($oneOfFields = ["interface"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         * @static
                         * @param {google.cloud.compute.v1.IAllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk} AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk instance
                         */
                        AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.create = function create(properties) {
                            return new AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk(properties);
                        };
    
                        /**
                         * Encodes the specified AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk message. Does not implicitly {@link google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         * @static
                         * @param {google.cloud.compute.v1.IAllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk} message AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.diskSizeGb != null && Object.hasOwnProperty.call(message, "diskSizeGb"))
                                writer.uint32(/* id 316263735, wireType 0 =*/2530109880).int64(message.diskSizeGb);
                            if (message["interface"] != null && Object.hasOwnProperty.call(message, "interface"))
                                writer.uint32(/* id 502623545, wireType 2 =*/4020988362).string(message["interface"]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         * @static
                         * @param {google.cloud.compute.v1.IAllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk} message AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk} AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 316263735: {
                                        message.diskSizeGb = reader.int64();
                                        break;
                                    }
                                case 502623545: {
                                        message["interface"] = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk} AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.diskSizeGb != null && message.hasOwnProperty("diskSizeGb")) {
                                properties._diskSizeGb = 1;
                                if (!$util.isInteger(message.diskSizeGb) && !(message.diskSizeGb && $util.isInteger(message.diskSizeGb.low) && $util.isInteger(message.diskSizeGb.high)))
                                    return "diskSizeGb: integer|Long expected";
                            }
                            if (message["interface"] != null && message.hasOwnProperty("interface")) {
                                properties._interface = 1;
                                if (!$util.isString(message["interface"]))
                                    return "interface: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk} AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         */
                        AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk();
                            if (object.diskSizeGb != null)
                                if ($util.Long)
                                    (message.diskSizeGb = $util.Long.fromValue(object.diskSizeGb)).unsigned = false;
                                else if (typeof object.diskSizeGb === "string")
                                    message.diskSizeGb = parseInt(object.diskSizeGb, 10);
                                else if (typeof object.diskSizeGb === "number")
                                    message.diskSizeGb = object.diskSizeGb;
                                else if (typeof object.diskSizeGb === "object")
                                    message.diskSizeGb = new $util.LongBits(object.diskSizeGb.low >>> 0, object.diskSizeGb.high >>> 0).toNumber();
                            if (object["interface"] != null)
                                message["interface"] = String(object["interface"]);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         * @static
                         * @param {google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk} message AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.diskSizeGb != null && message.hasOwnProperty("diskSizeGb")) {
                                if (typeof message.diskSizeGb === "number")
                                    object.diskSizeGb = options.longs === String ? String(message.diskSizeGb) : message.diskSizeGb;
                                else
                                    object.diskSizeGb = options.longs === String ? $util.Long.prototype.toString.call(message.diskSizeGb) : options.longs === Number ? new $util.LongBits(message.diskSizeGb.low >>> 0, message.diskSizeGb.high >>> 0).toNumber() : message.diskSizeGb;
                                if (options.oneofs)
                                    object._diskSizeGb = "diskSizeGb";
                            }
                            if (message["interface"] != null && message.hasOwnProperty("interface")) {
                                object["interface"] = message["interface"];
                                if (options.oneofs)
                                    object._interface = "interface";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk";
                        };
    
                        /**
                         * Interface enum.
                         * @name google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.Interface
                         * @enum {number}
                         * @property {number} UNDEFINED_INTERFACE=0 UNDEFINED_INTERFACE value
                         * @property {number} NVME=2408800 NVME value
                         * @property {number} SCSI=2539686 SCSI value
                         */
                        AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.Interface = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_INTERFACE"] = 0;
                            values[valuesById[2408800] = "NVME"] = 2408800;
                            values[valuesById[2539686] = "SCSI"] = 2539686;
                            return values;
                        })();
    
                        return AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk;
                    })();
    
                    v1.AllocationSpecificSKUAllocationReservedInstanceProperties = (function() {
    
                        /**
                         * Properties of an AllocationSpecificSKUAllocationReservedInstanceProperties.
                         * @memberof google.cloud.compute.v1
                         * @interface IAllocationSpecificSKUAllocationReservedInstanceProperties
                         * @property {Array.<google.cloud.compute.v1.IAcceleratorConfig>|null} [guestAccelerators] AllocationSpecificSKUAllocationReservedInstanceProperties guestAccelerators
                         * @property {Array.<google.cloud.compute.v1.IAllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk>|null} [localSsds] AllocationSpecificSKUAllocationReservedInstanceProperties localSsds
                         * @property {string|null} [locationHint] AllocationSpecificSKUAllocationReservedInstanceProperties locationHint
                         * @property {string|null} [machineType] AllocationSpecificSKUAllocationReservedInstanceProperties machineType
                         * @property {string|null} [minCpuPlatform] AllocationSpecificSKUAllocationReservedInstanceProperties minCpuPlatform
                         */
    
                        /**
                         * Constructs a new AllocationSpecificSKUAllocationReservedInstanceProperties.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AllocationSpecificSKUAllocationReservedInstanceProperties.
                         * @implements IAllocationSpecificSKUAllocationReservedInstanceProperties
                         * @constructor
                         * @param {google.cloud.compute.v1.IAllocationSpecificSKUAllocationReservedInstanceProperties=} [properties] Properties to set
                         */
                        function AllocationSpecificSKUAllocationReservedInstanceProperties(properties) {
                            this.guestAccelerators = [];
                            this.localSsds = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AllocationSpecificSKUAllocationReservedInstanceProperties guestAccelerators.
                         * @member {Array.<google.cloud.compute.v1.IAcceleratorConfig>} guestAccelerators
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @instance
                         */
                        AllocationSpecificSKUAllocationReservedInstanceProperties.prototype.guestAccelerators = $util.emptyArray;
    
                        /**
                         * AllocationSpecificSKUAllocationReservedInstanceProperties localSsds.
                         * @member {Array.<google.cloud.compute.v1.IAllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk>} localSsds
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @instance
                         */
                        AllocationSpecificSKUAllocationReservedInstanceProperties.prototype.localSsds = $util.emptyArray;
    
                        /**
                         * AllocationSpecificSKUAllocationReservedInstanceProperties locationHint.
                         * @member {string|null|undefined} locationHint
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @instance
                         */
                        AllocationSpecificSKUAllocationReservedInstanceProperties.prototype.locationHint = null;
    
                        /**
                         * AllocationSpecificSKUAllocationReservedInstanceProperties machineType.
                         * @member {string|null|undefined} machineType
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @instance
                         */
                        AllocationSpecificSKUAllocationReservedInstanceProperties.prototype.machineType = null;
    
                        /**
                         * AllocationSpecificSKUAllocationReservedInstanceProperties minCpuPlatform.
                         * @member {string|null|undefined} minCpuPlatform
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @instance
                         */
                        AllocationSpecificSKUAllocationReservedInstanceProperties.prototype.minCpuPlatform = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AllocationSpecificSKUAllocationReservedInstanceProperties _locationHint.
                         * @member {"locationHint"|undefined} _locationHint
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @instance
                         */
                        Object.defineProperty(AllocationSpecificSKUAllocationReservedInstanceProperties.prototype, "_locationHint", {
                            get: $util.oneOfGetter($oneOfFields = ["locationHint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AllocationSpecificSKUAllocationReservedInstanceProperties _machineType.
                         * @member {"machineType"|undefined} _machineType
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @instance
                         */
                        Object.defineProperty(AllocationSpecificSKUAllocationReservedInstanceProperties.prototype, "_machineType", {
                            get: $util.oneOfGetter($oneOfFields = ["machineType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AllocationSpecificSKUAllocationReservedInstanceProperties _minCpuPlatform.
                         * @member {"minCpuPlatform"|undefined} _minCpuPlatform
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @instance
                         */
                        Object.defineProperty(AllocationSpecificSKUAllocationReservedInstanceProperties.prototype, "_minCpuPlatform", {
                            get: $util.oneOfGetter($oneOfFields = ["minCpuPlatform"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AllocationSpecificSKUAllocationReservedInstanceProperties instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @static
                         * @param {google.cloud.compute.v1.IAllocationSpecificSKUAllocationReservedInstanceProperties=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties} AllocationSpecificSKUAllocationReservedInstanceProperties instance
                         */
                        AllocationSpecificSKUAllocationReservedInstanceProperties.create = function create(properties) {
                            return new AllocationSpecificSKUAllocationReservedInstanceProperties(properties);
                        };
    
                        /**
                         * Encodes the specified AllocationSpecificSKUAllocationReservedInstanceProperties message. Does not implicitly {@link google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @static
                         * @param {google.cloud.compute.v1.IAllocationSpecificSKUAllocationReservedInstanceProperties} message AllocationSpecificSKUAllocationReservedInstanceProperties message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AllocationSpecificSKUAllocationReservedInstanceProperties.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.machineType != null && Object.hasOwnProperty.call(message, "machineType"))
                                writer.uint32(/* id 227711026, wireType 2 =*/1821688210).string(message.machineType);
                            if (message.localSsds != null && message.localSsds.length)
                                for (var i = 0; i < message.localSsds.length; ++i)
                                    $root.google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.encode(message.localSsds[i], writer.uint32(/* id 229951299, wireType 2 =*/1839610394).fork()).ldelim();
                            if (message.minCpuPlatform != null && Object.hasOwnProperty.call(message, "minCpuPlatform"))
                                writer.uint32(/* id 242912759, wireType 2 =*/1943302074).string(message.minCpuPlatform);
                            if (message.locationHint != null && Object.hasOwnProperty.call(message, "locationHint"))
                                writer.uint32(/* id 350519505, wireType 2 =*/2804156042).string(message.locationHint);
                            if (message.guestAccelerators != null && message.guestAccelerators.length)
                                for (var i = 0; i < message.guestAccelerators.length; ++i)
                                    $root.google.cloud.compute.v1.AcceleratorConfig.encode(message.guestAccelerators[i], writer.uint32(/* id 463595119, wireType 2 =*/3708760954).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AllocationSpecificSKUAllocationReservedInstanceProperties message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @static
                         * @param {google.cloud.compute.v1.IAllocationSpecificSKUAllocationReservedInstanceProperties} message AllocationSpecificSKUAllocationReservedInstanceProperties message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AllocationSpecificSKUAllocationReservedInstanceProperties.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AllocationSpecificSKUAllocationReservedInstanceProperties message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties} AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AllocationSpecificSKUAllocationReservedInstanceProperties.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 463595119: {
                                        if (!(message.guestAccelerators && message.guestAccelerators.length))
                                            message.guestAccelerators = [];
                                        message.guestAccelerators.push($root.google.cloud.compute.v1.AcceleratorConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 229951299: {
                                        if (!(message.localSsds && message.localSsds.length))
                                            message.localSsds = [];
                                        message.localSsds.push($root.google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 350519505: {
                                        message.locationHint = reader.string();
                                        break;
                                    }
                                case 227711026: {
                                        message.machineType = reader.string();
                                        break;
                                    }
                                case 242912759: {
                                        message.minCpuPlatform = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AllocationSpecificSKUAllocationReservedInstanceProperties message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties} AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AllocationSpecificSKUAllocationReservedInstanceProperties.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AllocationSpecificSKUAllocationReservedInstanceProperties message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AllocationSpecificSKUAllocationReservedInstanceProperties.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.guestAccelerators != null && message.hasOwnProperty("guestAccelerators")) {
                                if (!Array.isArray(message.guestAccelerators))
                                    return "guestAccelerators: array expected";
                                for (var i = 0; i < message.guestAccelerators.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AcceleratorConfig.verify(message.guestAccelerators[i]);
                                    if (error)
                                        return "guestAccelerators." + error;
                                }
                            }
                            if (message.localSsds != null && message.hasOwnProperty("localSsds")) {
                                if (!Array.isArray(message.localSsds))
                                    return "localSsds: array expected";
                                for (var i = 0; i < message.localSsds.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.verify(message.localSsds[i]);
                                    if (error)
                                        return "localSsds." + error;
                                }
                            }
                            if (message.locationHint != null && message.hasOwnProperty("locationHint")) {
                                properties._locationHint = 1;
                                if (!$util.isString(message.locationHint))
                                    return "locationHint: string expected";
                            }
                            if (message.machineType != null && message.hasOwnProperty("machineType")) {
                                properties._machineType = 1;
                                if (!$util.isString(message.machineType))
                                    return "machineType: string expected";
                            }
                            if (message.minCpuPlatform != null && message.hasOwnProperty("minCpuPlatform")) {
                                properties._minCpuPlatform = 1;
                                if (!$util.isString(message.minCpuPlatform))
                                    return "minCpuPlatform: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AllocationSpecificSKUAllocationReservedInstanceProperties message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties} AllocationSpecificSKUAllocationReservedInstanceProperties
                         */
                        AllocationSpecificSKUAllocationReservedInstanceProperties.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties();
                            if (object.guestAccelerators) {
                                if (!Array.isArray(object.guestAccelerators))
                                    throw TypeError(".google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties.guestAccelerators: array expected");
                                message.guestAccelerators = [];
                                for (var i = 0; i < object.guestAccelerators.length; ++i) {
                                    if (typeof object.guestAccelerators[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties.guestAccelerators: object expected");
                                    message.guestAccelerators[i] = $root.google.cloud.compute.v1.AcceleratorConfig.fromObject(object.guestAccelerators[i]);
                                }
                            }
                            if (object.localSsds) {
                                if (!Array.isArray(object.localSsds))
                                    throw TypeError(".google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties.localSsds: array expected");
                                message.localSsds = [];
                                for (var i = 0; i < object.localSsds.length; ++i) {
                                    if (typeof object.localSsds[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties.localSsds: object expected");
                                    message.localSsds[i] = $root.google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.fromObject(object.localSsds[i]);
                                }
                            }
                            if (object.locationHint != null)
                                message.locationHint = String(object.locationHint);
                            if (object.machineType != null)
                                message.machineType = String(object.machineType);
                            if (object.minCpuPlatform != null)
                                message.minCpuPlatform = String(object.minCpuPlatform);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AllocationSpecificSKUAllocationReservedInstanceProperties message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @static
                         * @param {google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties} message AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AllocationSpecificSKUAllocationReservedInstanceProperties.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.localSsds = [];
                                object.guestAccelerators = [];
                            }
                            if (message.machineType != null && message.hasOwnProperty("machineType")) {
                                object.machineType = message.machineType;
                                if (options.oneofs)
                                    object._machineType = "machineType";
                            }
                            if (message.localSsds && message.localSsds.length) {
                                object.localSsds = [];
                                for (var j = 0; j < message.localSsds.length; ++j)
                                    object.localSsds[j] = $root.google.cloud.compute.v1.AllocationSpecificSKUAllocationAllocatedInstancePropertiesReservedDisk.toObject(message.localSsds[j], options);
                            }
                            if (message.minCpuPlatform != null && message.hasOwnProperty("minCpuPlatform")) {
                                object.minCpuPlatform = message.minCpuPlatform;
                                if (options.oneofs)
                                    object._minCpuPlatform = "minCpuPlatform";
                            }
                            if (message.locationHint != null && message.hasOwnProperty("locationHint")) {
                                object.locationHint = message.locationHint;
                                if (options.oneofs)
                                    object._locationHint = "locationHint";
                            }
                            if (message.guestAccelerators && message.guestAccelerators.length) {
                                object.guestAccelerators = [];
                                for (var j = 0; j < message.guestAccelerators.length; ++j)
                                    object.guestAccelerators[j] = $root.google.cloud.compute.v1.AcceleratorConfig.toObject(message.guestAccelerators[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AllocationSpecificSKUAllocationReservedInstanceProperties to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AllocationSpecificSKUAllocationReservedInstanceProperties.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AllocationSpecificSKUAllocationReservedInstanceProperties.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties";
                        };
    
                        return AllocationSpecificSKUAllocationReservedInstanceProperties;
                    })();
    
                    v1.AllocationSpecificSKUReservation = (function() {
    
                        /**
                         * Properties of an AllocationSpecificSKUReservation.
                         * @memberof google.cloud.compute.v1
                         * @interface IAllocationSpecificSKUReservation
                         * @property {number|Long|null} [assuredCount] AllocationSpecificSKUReservation assuredCount
                         * @property {number|Long|null} [count] AllocationSpecificSKUReservation count
                         * @property {number|Long|null} [inUseCount] AllocationSpecificSKUReservation inUseCount
                         * @property {google.cloud.compute.v1.IAllocationSpecificSKUAllocationReservedInstanceProperties|null} [instanceProperties] AllocationSpecificSKUReservation instanceProperties
                         */
    
                        /**
                         * Constructs a new AllocationSpecificSKUReservation.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AllocationSpecificSKUReservation.
                         * @implements IAllocationSpecificSKUReservation
                         * @constructor
                         * @param {google.cloud.compute.v1.IAllocationSpecificSKUReservation=} [properties] Properties to set
                         */
                        function AllocationSpecificSKUReservation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AllocationSpecificSKUReservation assuredCount.
                         * @member {number|Long|null|undefined} assuredCount
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUReservation
                         * @instance
                         */
                        AllocationSpecificSKUReservation.prototype.assuredCount = null;
    
                        /**
                         * AllocationSpecificSKUReservation count.
                         * @member {number|Long|null|undefined} count
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUReservation
                         * @instance
                         */
                        AllocationSpecificSKUReservation.prototype.count = null;
    
                        /**
                         * AllocationSpecificSKUReservation inUseCount.
                         * @member {number|Long|null|undefined} inUseCount
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUReservation
                         * @instance
                         */
                        AllocationSpecificSKUReservation.prototype.inUseCount = null;
    
                        /**
                         * AllocationSpecificSKUReservation instanceProperties.
                         * @member {google.cloud.compute.v1.IAllocationSpecificSKUAllocationReservedInstanceProperties|null|undefined} instanceProperties
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUReservation
                         * @instance
                         */
                        AllocationSpecificSKUReservation.prototype.instanceProperties = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AllocationSpecificSKUReservation _assuredCount.
                         * @member {"assuredCount"|undefined} _assuredCount
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUReservation
                         * @instance
                         */
                        Object.defineProperty(AllocationSpecificSKUReservation.prototype, "_assuredCount", {
                            get: $util.oneOfGetter($oneOfFields = ["assuredCount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AllocationSpecificSKUReservation _count.
                         * @member {"count"|undefined} _count
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUReservation
                         * @instance
                         */
                        Object.defineProperty(AllocationSpecificSKUReservation.prototype, "_count", {
                            get: $util.oneOfGetter($oneOfFields = ["count"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AllocationSpecificSKUReservation _inUseCount.
                         * @member {"inUseCount"|undefined} _inUseCount
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUReservation
                         * @instance
                         */
                        Object.defineProperty(AllocationSpecificSKUReservation.prototype, "_inUseCount", {
                            get: $util.oneOfGetter($oneOfFields = ["inUseCount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AllocationSpecificSKUReservation _instanceProperties.
                         * @member {"instanceProperties"|undefined} _instanceProperties
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUReservation
                         * @instance
                         */
                        Object.defineProperty(AllocationSpecificSKUReservation.prototype, "_instanceProperties", {
                            get: $util.oneOfGetter($oneOfFields = ["instanceProperties"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AllocationSpecificSKUReservation instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUReservation
                         * @static
                         * @param {google.cloud.compute.v1.IAllocationSpecificSKUReservation=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AllocationSpecificSKUReservation} AllocationSpecificSKUReservation instance
                         */
                        AllocationSpecificSKUReservation.create = function create(properties) {
                            return new AllocationSpecificSKUReservation(properties);
                        };
    
                        /**
                         * Encodes the specified AllocationSpecificSKUReservation message. Does not implicitly {@link google.cloud.compute.v1.AllocationSpecificSKUReservation.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUReservation
                         * @static
                         * @param {google.cloud.compute.v1.IAllocationSpecificSKUReservation} message AllocationSpecificSKUReservation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AllocationSpecificSKUReservation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.count != null && Object.hasOwnProperty.call(message, "count"))
                                writer.uint32(/* id 94851343, wireType 0 =*/758810744).int64(message.count);
                            if (message.instanceProperties != null && Object.hasOwnProperty.call(message, "instanceProperties"))
                                $root.google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties.encode(message.instanceProperties, writer.uint32(/* id 215355165, wireType 2 =*/1722841322).fork()).ldelim();
                            if (message.assuredCount != null && Object.hasOwnProperty.call(message, "assuredCount"))
                                writer.uint32(/* id 281197645, wireType 0 =*/2249581160).int64(message.assuredCount);
                            if (message.inUseCount != null && Object.hasOwnProperty.call(message, "inUseCount"))
                                writer.uint32(/* id 493458877, wireType 0 =*/3947671016).int64(message.inUseCount);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AllocationSpecificSKUReservation message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AllocationSpecificSKUReservation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUReservation
                         * @static
                         * @param {google.cloud.compute.v1.IAllocationSpecificSKUReservation} message AllocationSpecificSKUReservation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AllocationSpecificSKUReservation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AllocationSpecificSKUReservation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUReservation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AllocationSpecificSKUReservation} AllocationSpecificSKUReservation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AllocationSpecificSKUReservation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AllocationSpecificSKUReservation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 281197645: {
                                        message.assuredCount = reader.int64();
                                        break;
                                    }
                                case 94851343: {
                                        message.count = reader.int64();
                                        break;
                                    }
                                case 493458877: {
                                        message.inUseCount = reader.int64();
                                        break;
                                    }
                                case 215355165: {
                                        message.instanceProperties = $root.google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AllocationSpecificSKUReservation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUReservation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AllocationSpecificSKUReservation} AllocationSpecificSKUReservation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AllocationSpecificSKUReservation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AllocationSpecificSKUReservation message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUReservation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AllocationSpecificSKUReservation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.assuredCount != null && message.hasOwnProperty("assuredCount")) {
                                properties._assuredCount = 1;
                                if (!$util.isInteger(message.assuredCount) && !(message.assuredCount && $util.isInteger(message.assuredCount.low) && $util.isInteger(message.assuredCount.high)))
                                    return "assuredCount: integer|Long expected";
                            }
                            if (message.count != null && message.hasOwnProperty("count")) {
                                properties._count = 1;
                                if (!$util.isInteger(message.count) && !(message.count && $util.isInteger(message.count.low) && $util.isInteger(message.count.high)))
                                    return "count: integer|Long expected";
                            }
                            if (message.inUseCount != null && message.hasOwnProperty("inUseCount")) {
                                properties._inUseCount = 1;
                                if (!$util.isInteger(message.inUseCount) && !(message.inUseCount && $util.isInteger(message.inUseCount.low) && $util.isInteger(message.inUseCount.high)))
                                    return "inUseCount: integer|Long expected";
                            }
                            if (message.instanceProperties != null && message.hasOwnProperty("instanceProperties")) {
                                properties._instanceProperties = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties.verify(message.instanceProperties);
                                    if (error)
                                        return "instanceProperties." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AllocationSpecificSKUReservation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUReservation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AllocationSpecificSKUReservation} AllocationSpecificSKUReservation
                         */
                        AllocationSpecificSKUReservation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AllocationSpecificSKUReservation)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AllocationSpecificSKUReservation();
                            if (object.assuredCount != null)
                                if ($util.Long)
                                    (message.assuredCount = $util.Long.fromValue(object.assuredCount)).unsigned = false;
                                else if (typeof object.assuredCount === "string")
                                    message.assuredCount = parseInt(object.assuredCount, 10);
                                else if (typeof object.assuredCount === "number")
                                    message.assuredCount = object.assuredCount;
                                else if (typeof object.assuredCount === "object")
                                    message.assuredCount = new $util.LongBits(object.assuredCount.low >>> 0, object.assuredCount.high >>> 0).toNumber();
                            if (object.count != null)
                                if ($util.Long)
                                    (message.count = $util.Long.fromValue(object.count)).unsigned = false;
                                else if (typeof object.count === "string")
                                    message.count = parseInt(object.count, 10);
                                else if (typeof object.count === "number")
                                    message.count = object.count;
                                else if (typeof object.count === "object")
                                    message.count = new $util.LongBits(object.count.low >>> 0, object.count.high >>> 0).toNumber();
                            if (object.inUseCount != null)
                                if ($util.Long)
                                    (message.inUseCount = $util.Long.fromValue(object.inUseCount)).unsigned = false;
                                else if (typeof object.inUseCount === "string")
                                    message.inUseCount = parseInt(object.inUseCount, 10);
                                else if (typeof object.inUseCount === "number")
                                    message.inUseCount = object.inUseCount;
                                else if (typeof object.inUseCount === "object")
                                    message.inUseCount = new $util.LongBits(object.inUseCount.low >>> 0, object.inUseCount.high >>> 0).toNumber();
                            if (object.instanceProperties != null) {
                                if (typeof object.instanceProperties !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AllocationSpecificSKUReservation.instanceProperties: object expected");
                                message.instanceProperties = $root.google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties.fromObject(object.instanceProperties);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AllocationSpecificSKUReservation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUReservation
                         * @static
                         * @param {google.cloud.compute.v1.AllocationSpecificSKUReservation} message AllocationSpecificSKUReservation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AllocationSpecificSKUReservation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.count != null && message.hasOwnProperty("count")) {
                                if (typeof message.count === "number")
                                    object.count = options.longs === String ? String(message.count) : message.count;
                                else
                                    object.count = options.longs === String ? $util.Long.prototype.toString.call(message.count) : options.longs === Number ? new $util.LongBits(message.count.low >>> 0, message.count.high >>> 0).toNumber() : message.count;
                                if (options.oneofs)
                                    object._count = "count";
                            }
                            if (message.instanceProperties != null && message.hasOwnProperty("instanceProperties")) {
                                object.instanceProperties = $root.google.cloud.compute.v1.AllocationSpecificSKUAllocationReservedInstanceProperties.toObject(message.instanceProperties, options);
                                if (options.oneofs)
                                    object._instanceProperties = "instanceProperties";
                            }
                            if (message.assuredCount != null && message.hasOwnProperty("assuredCount")) {
                                if (typeof message.assuredCount === "number")
                                    object.assuredCount = options.longs === String ? String(message.assuredCount) : message.assuredCount;
                                else
                                    object.assuredCount = options.longs === String ? $util.Long.prototype.toString.call(message.assuredCount) : options.longs === Number ? new $util.LongBits(message.assuredCount.low >>> 0, message.assuredCount.high >>> 0).toNumber() : message.assuredCount;
                                if (options.oneofs)
                                    object._assuredCount = "assuredCount";
                            }
                            if (message.inUseCount != null && message.hasOwnProperty("inUseCount")) {
                                if (typeof message.inUseCount === "number")
                                    object.inUseCount = options.longs === String ? String(message.inUseCount) : message.inUseCount;
                                else
                                    object.inUseCount = options.longs === String ? $util.Long.prototype.toString.call(message.inUseCount) : options.longs === Number ? new $util.LongBits(message.inUseCount.low >>> 0, message.inUseCount.high >>> 0).toNumber() : message.inUseCount;
                                if (options.oneofs)
                                    object._inUseCount = "inUseCount";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AllocationSpecificSKUReservation to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUReservation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AllocationSpecificSKUReservation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AllocationSpecificSKUReservation
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AllocationSpecificSKUReservation
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AllocationSpecificSKUReservation.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AllocationSpecificSKUReservation";
                        };
    
                        return AllocationSpecificSKUReservation;
                    })();
    
                    v1.Allowed = (function() {
    
                        /**
                         * Properties of an Allowed.
                         * @memberof google.cloud.compute.v1
                         * @interface IAllowed
                         * @property {string|null} [IPProtocol] Allowed IPProtocol
                         * @property {Array.<string>|null} [ports] Allowed ports
                         */
    
                        /**
                         * Constructs a new Allowed.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an Allowed.
                         * @implements IAllowed
                         * @constructor
                         * @param {google.cloud.compute.v1.IAllowed=} [properties] Properties to set
                         */
                        function Allowed(properties) {
                            this.ports = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Allowed IPProtocol.
                         * @member {string|null|undefined} IPProtocol
                         * @memberof google.cloud.compute.v1.Allowed
                         * @instance
                         */
                        Allowed.prototype.IPProtocol = null;
    
                        /**
                         * Allowed ports.
                         * @member {Array.<string>} ports
                         * @memberof google.cloud.compute.v1.Allowed
                         * @instance
                         */
                        Allowed.prototype.ports = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Allowed _IPProtocol.
                         * @member {"IPProtocol"|undefined} _IPProtocol
                         * @memberof google.cloud.compute.v1.Allowed
                         * @instance
                         */
                        Object.defineProperty(Allowed.prototype, "_IPProtocol", {
                            get: $util.oneOfGetter($oneOfFields = ["IPProtocol"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Allowed instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Allowed
                         * @static
                         * @param {google.cloud.compute.v1.IAllowed=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Allowed} Allowed instance
                         */
                        Allowed.create = function create(properties) {
                            return new Allowed(properties);
                        };
    
                        /**
                         * Encodes the specified Allowed message. Does not implicitly {@link google.cloud.compute.v1.Allowed.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Allowed
                         * @static
                         * @param {google.cloud.compute.v1.IAllowed} message Allowed message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Allowed.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.ports != null && message.ports.length)
                                for (var i = 0; i < message.ports.length; ++i)
                                    writer.uint32(/* id 106854418, wireType 2 =*/854835346).string(message.ports[i]);
                            if (message.IPProtocol != null && Object.hasOwnProperty.call(message, "IPProtocol"))
                                writer.uint32(/* id 488094525, wireType 2 =*/3904756202).string(message.IPProtocol);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Allowed message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Allowed.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Allowed
                         * @static
                         * @param {google.cloud.compute.v1.IAllowed} message Allowed message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Allowed.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Allowed message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Allowed
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Allowed} Allowed
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Allowed.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Allowed();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 488094525: {
                                        message.IPProtocol = reader.string();
                                        break;
                                    }
                                case 106854418: {
                                        if (!(message.ports && message.ports.length))
                                            message.ports = [];
                                        message.ports.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Allowed message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Allowed
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Allowed} Allowed
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Allowed.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Allowed message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Allowed
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Allowed.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.IPProtocol != null && message.hasOwnProperty("IPProtocol")) {
                                properties._IPProtocol = 1;
                                if (!$util.isString(message.IPProtocol))
                                    return "IPProtocol: string expected";
                            }
                            if (message.ports != null && message.hasOwnProperty("ports")) {
                                if (!Array.isArray(message.ports))
                                    return "ports: array expected";
                                for (var i = 0; i < message.ports.length; ++i)
                                    if (!$util.isString(message.ports[i]))
                                        return "ports: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an Allowed message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Allowed
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Allowed} Allowed
                         */
                        Allowed.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Allowed)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Allowed();
                            if (object.IPProtocol != null)
                                message.IPProtocol = String(object.IPProtocol);
                            if (object.ports) {
                                if (!Array.isArray(object.ports))
                                    throw TypeError(".google.cloud.compute.v1.Allowed.ports: array expected");
                                message.ports = [];
                                for (var i = 0; i < object.ports.length; ++i)
                                    message.ports[i] = String(object.ports[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Allowed message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Allowed
                         * @static
                         * @param {google.cloud.compute.v1.Allowed} message Allowed
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Allowed.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.ports = [];
                            if (message.ports && message.ports.length) {
                                object.ports = [];
                                for (var j = 0; j < message.ports.length; ++j)
                                    object.ports[j] = message.ports[j];
                            }
                            if (message.IPProtocol != null && message.hasOwnProperty("IPProtocol")) {
                                object.IPProtocol = message.IPProtocol;
                                if (options.oneofs)
                                    object._IPProtocol = "IPProtocol";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Allowed to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Allowed
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Allowed.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Allowed
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Allowed
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Allowed.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Allowed";
                        };
    
                        return Allowed;
                    })();
    
                    v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of an ApplyUpdatesToInstancesInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IApplyUpdatesToInstancesInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] ApplyUpdatesToInstancesInstanceGroupManagerRequest instanceGroupManager
                         * @property {google.cloud.compute.v1.IInstanceGroupManagersApplyUpdatesRequest|null} [instanceGroupManagersApplyUpdatesRequestResource] ApplyUpdatesToInstancesInstanceGroupManagerRequest instanceGroupManagersApplyUpdatesRequestResource
                         * @property {string|null} [project] ApplyUpdatesToInstancesInstanceGroupManagerRequest project
                         * @property {string|null} [zone] ApplyUpdatesToInstancesInstanceGroupManagerRequest zone
                         */
    
                        /**
                         * Constructs a new ApplyUpdatesToInstancesInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an ApplyUpdatesToInstancesInstanceGroupManagerRequest.
                         * @implements IApplyUpdatesToInstancesInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IApplyUpdatesToInstancesInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function ApplyUpdatesToInstancesInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ApplyUpdatesToInstancesInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        ApplyUpdatesToInstancesInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * ApplyUpdatesToInstancesInstanceGroupManagerRequest instanceGroupManagersApplyUpdatesRequestResource.
                         * @member {google.cloud.compute.v1.IInstanceGroupManagersApplyUpdatesRequest|null|undefined} instanceGroupManagersApplyUpdatesRequestResource
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        ApplyUpdatesToInstancesInstanceGroupManagerRequest.prototype.instanceGroupManagersApplyUpdatesRequestResource = null;
    
                        /**
                         * ApplyUpdatesToInstancesInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        ApplyUpdatesToInstancesInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * ApplyUpdatesToInstancesInstanceGroupManagerRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        ApplyUpdatesToInstancesInstanceGroupManagerRequest.prototype.zone = "";
    
                        /**
                         * Creates a new ApplyUpdatesToInstancesInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IApplyUpdatesToInstancesInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest} ApplyUpdatesToInstancesInstanceGroupManagerRequest instance
                         */
                        ApplyUpdatesToInstancesInstanceGroupManagerRequest.create = function create(properties) {
                            return new ApplyUpdatesToInstancesInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ApplyUpdatesToInstancesInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IApplyUpdatesToInstancesInstanceGroupManagerRequest} message ApplyUpdatesToInstancesInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ApplyUpdatesToInstancesInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            if (message.instanceGroupManagersApplyUpdatesRequestResource != null && Object.hasOwnProperty.call(message, "instanceGroupManagersApplyUpdatesRequestResource"))
                                $root.google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest.encode(message.instanceGroupManagersApplyUpdatesRequestResource, writer.uint32(/* id 259242835, wireType 2 =*/2073942682).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ApplyUpdatesToInstancesInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IApplyUpdatesToInstancesInstanceGroupManagerRequest} message ApplyUpdatesToInstancesInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ApplyUpdatesToInstancesInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ApplyUpdatesToInstancesInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest} ApplyUpdatesToInstancesInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ApplyUpdatesToInstancesInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 259242835: {
                                        message.instanceGroupManagersApplyUpdatesRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ApplyUpdatesToInstancesInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest} ApplyUpdatesToInstancesInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ApplyUpdatesToInstancesInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ApplyUpdatesToInstancesInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ApplyUpdatesToInstancesInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.instanceGroupManagersApplyUpdatesRequestResource != null && message.hasOwnProperty("instanceGroupManagersApplyUpdatesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest.verify(message.instanceGroupManagersApplyUpdatesRequestResource);
                                if (error)
                                    return "instanceGroupManagersApplyUpdatesRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an ApplyUpdatesToInstancesInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest} ApplyUpdatesToInstancesInstanceGroupManagerRequest
                         */
                        ApplyUpdatesToInstancesInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.instanceGroupManagersApplyUpdatesRequestResource != null) {
                                if (typeof object.instanceGroupManagersApplyUpdatesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest.instanceGroupManagersApplyUpdatesRequestResource: object expected");
                                message.instanceGroupManagersApplyUpdatesRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest.fromObject(object.instanceGroupManagersApplyUpdatesRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ApplyUpdatesToInstancesInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest} message ApplyUpdatesToInstancesInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ApplyUpdatesToInstancesInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                                object.instanceGroupManagersApplyUpdatesRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            if (message.instanceGroupManagersApplyUpdatesRequestResource != null && message.hasOwnProperty("instanceGroupManagersApplyUpdatesRequestResource"))
                                object.instanceGroupManagersApplyUpdatesRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest.toObject(message.instanceGroupManagersApplyUpdatesRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this ApplyUpdatesToInstancesInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ApplyUpdatesToInstancesInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ApplyUpdatesToInstancesInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ApplyUpdatesToInstancesInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest";
                        };
    
                        return ApplyUpdatesToInstancesInstanceGroupManagerRequest;
                    })();
    
                    v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of an ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest instanceGroupManager
                         * @property {string|null} [project] ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest project
                         * @property {string|null} [region] ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest region
                         * @property {google.cloud.compute.v1.IRegionInstanceGroupManagersApplyUpdatesRequest|null} [regionInstanceGroupManagersApplyUpdatesRequestResource] ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest regionInstanceGroupManagersApplyUpdatesRequestResource
                         */
    
                        /**
                         * Constructs a new ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest.
                         * @implements IApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IApplyUpdatesToInstancesRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest.prototype.region = "";
    
                        /**
                         * ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest regionInstanceGroupManagersApplyUpdatesRequestResource.
                         * @member {google.cloud.compute.v1.IRegionInstanceGroupManagersApplyUpdatesRequest|null|undefined} regionInstanceGroupManagersApplyUpdatesRequestResource
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest.prototype.regionInstanceGroupManagersApplyUpdatesRequestResource = null;
    
                        /**
                         * Creates a new ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IApplyUpdatesToInstancesRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest} ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest instance
                         */
                        ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest.create = function create(properties) {
                            return new ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IApplyUpdatesToInstancesRegionInstanceGroupManagerRequest} message ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.regionInstanceGroupManagersApplyUpdatesRequestResource != null && Object.hasOwnProperty.call(message, "regionInstanceGroupManagersApplyUpdatesRequestResource"))
                                $root.google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest.encode(message.regionInstanceGroupManagersApplyUpdatesRequestResource, writer.uint32(/* id 76248318, wireType 2 =*/609986546).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IApplyUpdatesToInstancesRegionInstanceGroupManagerRequest} message ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest} ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 76248318: {
                                        message.regionInstanceGroupManagersApplyUpdatesRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest} ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionInstanceGroupManagersApplyUpdatesRequestResource != null && message.hasOwnProperty("regionInstanceGroupManagersApplyUpdatesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest.verify(message.regionInstanceGroupManagersApplyUpdatesRequestResource);
                                if (error)
                                    return "regionInstanceGroupManagersApplyUpdatesRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest} ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         */
                        ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionInstanceGroupManagersApplyUpdatesRequestResource != null) {
                                if (typeof object.regionInstanceGroupManagersApplyUpdatesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest.regionInstanceGroupManagersApplyUpdatesRequestResource: object expected");
                                message.regionInstanceGroupManagersApplyUpdatesRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest.fromObject(object.regionInstanceGroupManagersApplyUpdatesRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest} message ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.regionInstanceGroupManagersApplyUpdatesRequestResource = null;
                                object.region = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.regionInstanceGroupManagersApplyUpdatesRequestResource != null && message.hasOwnProperty("regionInstanceGroupManagersApplyUpdatesRequestResource"))
                                object.regionInstanceGroupManagersApplyUpdatesRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest.toObject(message.regionInstanceGroupManagersApplyUpdatesRequestResource, options);
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            return object;
                        };
    
                        /**
                         * Converts this ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest";
                        };
    
                        return ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest;
                    })();
    
                    v1.AttachDiskInstanceRequest = (function() {
    
                        /**
                         * Properties of an AttachDiskInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAttachDiskInstanceRequest
                         * @property {google.cloud.compute.v1.IAttachedDisk|null} [attachedDiskResource] AttachDiskInstanceRequest attachedDiskResource
                         * @property {boolean|null} [forceAttach] AttachDiskInstanceRequest forceAttach
                         * @property {string|null} [instance] AttachDiskInstanceRequest instance
                         * @property {string|null} [project] AttachDiskInstanceRequest project
                         * @property {string|null} [requestId] AttachDiskInstanceRequest requestId
                         * @property {string|null} [zone] AttachDiskInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new AttachDiskInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AttachDiskInstanceRequest.
                         * @implements IAttachDiskInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAttachDiskInstanceRequest=} [properties] Properties to set
                         */
                        function AttachDiskInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AttachDiskInstanceRequest attachedDiskResource.
                         * @member {google.cloud.compute.v1.IAttachedDisk|null|undefined} attachedDiskResource
                         * @memberof google.cloud.compute.v1.AttachDiskInstanceRequest
                         * @instance
                         */
                        AttachDiskInstanceRequest.prototype.attachedDiskResource = null;
    
                        /**
                         * AttachDiskInstanceRequest forceAttach.
                         * @member {boolean|null|undefined} forceAttach
                         * @memberof google.cloud.compute.v1.AttachDiskInstanceRequest
                         * @instance
                         */
                        AttachDiskInstanceRequest.prototype.forceAttach = null;
    
                        /**
                         * AttachDiskInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.AttachDiskInstanceRequest
                         * @instance
                         */
                        AttachDiskInstanceRequest.prototype.instance = "";
    
                        /**
                         * AttachDiskInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AttachDiskInstanceRequest
                         * @instance
                         */
                        AttachDiskInstanceRequest.prototype.project = "";
    
                        /**
                         * AttachDiskInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AttachDiskInstanceRequest
                         * @instance
                         */
                        AttachDiskInstanceRequest.prototype.requestId = null;
    
                        /**
                         * AttachDiskInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.AttachDiskInstanceRequest
                         * @instance
                         */
                        AttachDiskInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AttachDiskInstanceRequest _forceAttach.
                         * @member {"forceAttach"|undefined} _forceAttach
                         * @memberof google.cloud.compute.v1.AttachDiskInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(AttachDiskInstanceRequest.prototype, "_forceAttach", {
                            get: $util.oneOfGetter($oneOfFields = ["forceAttach"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachDiskInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AttachDiskInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(AttachDiskInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AttachDiskInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AttachDiskInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAttachDiskInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AttachDiskInstanceRequest} AttachDiskInstanceRequest instance
                         */
                        AttachDiskInstanceRequest.create = function create(properties) {
                            return new AttachDiskInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AttachDiskInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.AttachDiskInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AttachDiskInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAttachDiskInstanceRequest} message AttachDiskInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AttachDiskInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.attachedDiskResource != null && Object.hasOwnProperty.call(message, "attachedDiskResource"))
                                $root.google.cloud.compute.v1.AttachedDisk.encode(message.attachedDiskResource, writer.uint32(/* id 90605845, wireType 2 =*/724846762).fork()).ldelim();
                            if (message.forceAttach != null && Object.hasOwnProperty.call(message, "forceAttach"))
                                writer.uint32(/* id 142758425, wireType 0 =*/1142067400).bool(message.forceAttach);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AttachDiskInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AttachDiskInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AttachDiskInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAttachDiskInstanceRequest} message AttachDiskInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AttachDiskInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AttachDiskInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AttachDiskInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AttachDiskInstanceRequest} AttachDiskInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AttachDiskInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AttachDiskInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 90605845: {
                                        message.attachedDiskResource = $root.google.cloud.compute.v1.AttachedDisk.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 142758425: {
                                        message.forceAttach = reader.bool();
                                        break;
                                    }
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AttachDiskInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AttachDiskInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AttachDiskInstanceRequest} AttachDiskInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AttachDiskInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AttachDiskInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AttachDiskInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AttachDiskInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.attachedDiskResource != null && message.hasOwnProperty("attachedDiskResource")) {
                                var error = $root.google.cloud.compute.v1.AttachedDisk.verify(message.attachedDiskResource);
                                if (error)
                                    return "attachedDiskResource." + error;
                            }
                            if (message.forceAttach != null && message.hasOwnProperty("forceAttach")) {
                                properties._forceAttach = 1;
                                if (typeof message.forceAttach !== "boolean")
                                    return "forceAttach: boolean expected";
                            }
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AttachDiskInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AttachDiskInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AttachDiskInstanceRequest} AttachDiskInstanceRequest
                         */
                        AttachDiskInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AttachDiskInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AttachDiskInstanceRequest();
                            if (object.attachedDiskResource != null) {
                                if (typeof object.attachedDiskResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AttachDiskInstanceRequest.attachedDiskResource: object expected");
                                message.attachedDiskResource = $root.google.cloud.compute.v1.AttachedDisk.fromObject(object.attachedDiskResource);
                            }
                            if (object.forceAttach != null)
                                message.forceAttach = Boolean(object.forceAttach);
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AttachDiskInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AttachDiskInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.AttachDiskInstanceRequest} message AttachDiskInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AttachDiskInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.attachedDiskResource = null;
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.attachedDiskResource != null && message.hasOwnProperty("attachedDiskResource"))
                                object.attachedDiskResource = $root.google.cloud.compute.v1.AttachedDisk.toObject(message.attachedDiskResource, options);
                            if (message.forceAttach != null && message.hasOwnProperty("forceAttach")) {
                                object.forceAttach = message.forceAttach;
                                if (options.oneofs)
                                    object._forceAttach = "forceAttach";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this AttachDiskInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AttachDiskInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AttachDiskInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AttachDiskInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AttachDiskInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AttachDiskInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AttachDiskInstanceRequest";
                        };
    
                        return AttachDiskInstanceRequest;
                    })();
    
                    v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest = (function() {
    
                        /**
                         * Properties of an AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @property {google.cloud.compute.v1.IGlobalNetworkEndpointGroupsAttachEndpointsRequest|null} [globalNetworkEndpointGroupsAttachEndpointsRequestResource] AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest globalNetworkEndpointGroupsAttachEndpointsRequestResource
                         * @property {string|null} [networkEndpointGroup] AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest networkEndpointGroup
                         * @property {string|null} [project] AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest project
                         * @property {string|null} [requestId] AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest requestId
                         */
    
                        /**
                         * Constructs a new AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.
                         * @implements IAttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAttachNetworkEndpointsGlobalNetworkEndpointGroupRequest=} [properties] Properties to set
                         */
                        function AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest globalNetworkEndpointGroupsAttachEndpointsRequestResource.
                         * @member {google.cloud.compute.v1.IGlobalNetworkEndpointGroupsAttachEndpointsRequest|null|undefined} globalNetworkEndpointGroupsAttachEndpointsRequestResource
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @instance
                         */
                        AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.prototype.globalNetworkEndpointGroupsAttachEndpointsRequestResource = null;
    
                        /**
                         * AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest networkEndpointGroup.
                         * @member {string} networkEndpointGroup
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @instance
                         */
                        AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.prototype.networkEndpointGroup = "";
    
                        /**
                         * AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @instance
                         */
                        AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.prototype.project = "";
    
                        /**
                         * AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @instance
                         */
                        AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @instance
                         */
                        Object.defineProperty(AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAttachNetworkEndpointsGlobalNetworkEndpointGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest} AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest instance
                         */
                        AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.create = function create(properties) {
                            return new AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAttachNetworkEndpointsGlobalNetworkEndpointGroupRequest} message AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.globalNetworkEndpointGroupsAttachEndpointsRequestResource != null && Object.hasOwnProperty.call(message, "globalNetworkEndpointGroupsAttachEndpointsRequestResource"))
                                $root.google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest.encode(message.globalNetworkEndpointGroupsAttachEndpointsRequestResource, writer.uint32(/* id 30691563, wireType 2 =*/245532506).fork()).ldelim();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.networkEndpointGroup != null && Object.hasOwnProperty.call(message, "networkEndpointGroup"))
                                writer.uint32(/* id 433907078, wireType 2 =*/3471256626).string(message.networkEndpointGroup);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAttachNetworkEndpointsGlobalNetworkEndpointGroupRequest} message AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest} AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30691563: {
                                        message.globalNetworkEndpointGroupsAttachEndpointsRequestResource = $root.google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 433907078: {
                                        message.networkEndpointGroup = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest} AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.globalNetworkEndpointGroupsAttachEndpointsRequestResource != null && message.hasOwnProperty("globalNetworkEndpointGroupsAttachEndpointsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest.verify(message.globalNetworkEndpointGroupsAttachEndpointsRequestResource);
                                if (error)
                                    return "globalNetworkEndpointGroupsAttachEndpointsRequestResource." + error;
                            }
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                if (!$util.isString(message.networkEndpointGroup))
                                    return "networkEndpointGroup: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest} AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         */
                        AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest();
                            if (object.globalNetworkEndpointGroupsAttachEndpointsRequestResource != null) {
                                if (typeof object.globalNetworkEndpointGroupsAttachEndpointsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.globalNetworkEndpointGroupsAttachEndpointsRequestResource: object expected");
                                message.globalNetworkEndpointGroupsAttachEndpointsRequestResource = $root.google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest.fromObject(object.globalNetworkEndpointGroupsAttachEndpointsRequestResource);
                            }
                            if (object.networkEndpointGroup != null)
                                message.networkEndpointGroup = String(object.networkEndpointGroup);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest} message AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.globalNetworkEndpointGroupsAttachEndpointsRequestResource = null;
                                object.project = "";
                                object.networkEndpointGroup = "";
                            }
                            if (message.globalNetworkEndpointGroupsAttachEndpointsRequestResource != null && message.hasOwnProperty("globalNetworkEndpointGroupsAttachEndpointsRequestResource"))
                                object.globalNetworkEndpointGroupsAttachEndpointsRequestResource = $root.google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest.toObject(message.globalNetworkEndpointGroupsAttachEndpointsRequestResource, options);
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                object.networkEndpointGroup = message.networkEndpointGroup;
                            return object;
                        };
    
                        /**
                         * Converts this AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest";
                        };
    
                        return AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest;
                    })();
    
                    v1.AttachNetworkEndpointsNetworkEndpointGroupRequest = (function() {
    
                        /**
                         * Properties of an AttachNetworkEndpointsNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IAttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @property {string|null} [networkEndpointGroup] AttachNetworkEndpointsNetworkEndpointGroupRequest networkEndpointGroup
                         * @property {google.cloud.compute.v1.INetworkEndpointGroupsAttachEndpointsRequest|null} [networkEndpointGroupsAttachEndpointsRequestResource] AttachNetworkEndpointsNetworkEndpointGroupRequest networkEndpointGroupsAttachEndpointsRequestResource
                         * @property {string|null} [project] AttachNetworkEndpointsNetworkEndpointGroupRequest project
                         * @property {string|null} [requestId] AttachNetworkEndpointsNetworkEndpointGroupRequest requestId
                         * @property {string|null} [zone] AttachNetworkEndpointsNetworkEndpointGroupRequest zone
                         */
    
                        /**
                         * Constructs a new AttachNetworkEndpointsNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AttachNetworkEndpointsNetworkEndpointGroupRequest.
                         * @implements IAttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IAttachNetworkEndpointsNetworkEndpointGroupRequest=} [properties] Properties to set
                         */
                        function AttachNetworkEndpointsNetworkEndpointGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AttachNetworkEndpointsNetworkEndpointGroupRequest networkEndpointGroup.
                         * @member {string} networkEndpointGroup
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @instance
                         */
                        AttachNetworkEndpointsNetworkEndpointGroupRequest.prototype.networkEndpointGroup = "";
    
                        /**
                         * AttachNetworkEndpointsNetworkEndpointGroupRequest networkEndpointGroupsAttachEndpointsRequestResource.
                         * @member {google.cloud.compute.v1.INetworkEndpointGroupsAttachEndpointsRequest|null|undefined} networkEndpointGroupsAttachEndpointsRequestResource
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @instance
                         */
                        AttachNetworkEndpointsNetworkEndpointGroupRequest.prototype.networkEndpointGroupsAttachEndpointsRequestResource = null;
    
                        /**
                         * AttachNetworkEndpointsNetworkEndpointGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @instance
                         */
                        AttachNetworkEndpointsNetworkEndpointGroupRequest.prototype.project = "";
    
                        /**
                         * AttachNetworkEndpointsNetworkEndpointGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @instance
                         */
                        AttachNetworkEndpointsNetworkEndpointGroupRequest.prototype.requestId = null;
    
                        /**
                         * AttachNetworkEndpointsNetworkEndpointGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @instance
                         */
                        AttachNetworkEndpointsNetworkEndpointGroupRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AttachNetworkEndpointsNetworkEndpointGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @instance
                         */
                        Object.defineProperty(AttachNetworkEndpointsNetworkEndpointGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AttachNetworkEndpointsNetworkEndpointGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAttachNetworkEndpointsNetworkEndpointGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest} AttachNetworkEndpointsNetworkEndpointGroupRequest instance
                         */
                        AttachNetworkEndpointsNetworkEndpointGroupRequest.create = function create(properties) {
                            return new AttachNetworkEndpointsNetworkEndpointGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AttachNetworkEndpointsNetworkEndpointGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAttachNetworkEndpointsNetworkEndpointGroupRequest} message AttachNetworkEndpointsNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AttachNetworkEndpointsNetworkEndpointGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.networkEndpointGroupsAttachEndpointsRequestResource != null && Object.hasOwnProperty.call(message, "networkEndpointGroupsAttachEndpointsRequestResource"))
                                $root.google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest.encode(message.networkEndpointGroupsAttachEndpointsRequestResource, writer.uint32(/* id 531079, wireType 2 =*/4248634).fork()).ldelim();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.networkEndpointGroup != null && Object.hasOwnProperty.call(message, "networkEndpointGroup"))
                                writer.uint32(/* id 433907078, wireType 2 =*/3471256626).string(message.networkEndpointGroup);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AttachNetworkEndpointsNetworkEndpointGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IAttachNetworkEndpointsNetworkEndpointGroupRequest} message AttachNetworkEndpointsNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AttachNetworkEndpointsNetworkEndpointGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AttachNetworkEndpointsNetworkEndpointGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest} AttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AttachNetworkEndpointsNetworkEndpointGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 433907078: {
                                        message.networkEndpointGroup = reader.string();
                                        break;
                                    }
                                case 531079: {
                                        message.networkEndpointGroupsAttachEndpointsRequestResource = $root.google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AttachNetworkEndpointsNetworkEndpointGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest} AttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AttachNetworkEndpointsNetworkEndpointGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AttachNetworkEndpointsNetworkEndpointGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AttachNetworkEndpointsNetworkEndpointGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                if (!$util.isString(message.networkEndpointGroup))
                                    return "networkEndpointGroup: string expected";
                            if (message.networkEndpointGroupsAttachEndpointsRequestResource != null && message.hasOwnProperty("networkEndpointGroupsAttachEndpointsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest.verify(message.networkEndpointGroupsAttachEndpointsRequestResource);
                                if (error)
                                    return "networkEndpointGroupsAttachEndpointsRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AttachNetworkEndpointsNetworkEndpointGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest} AttachNetworkEndpointsNetworkEndpointGroupRequest
                         */
                        AttachNetworkEndpointsNetworkEndpointGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest();
                            if (object.networkEndpointGroup != null)
                                message.networkEndpointGroup = String(object.networkEndpointGroup);
                            if (object.networkEndpointGroupsAttachEndpointsRequestResource != null) {
                                if (typeof object.networkEndpointGroupsAttachEndpointsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest.networkEndpointGroupsAttachEndpointsRequestResource: object expected");
                                message.networkEndpointGroupsAttachEndpointsRequestResource = $root.google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest.fromObject(object.networkEndpointGroupsAttachEndpointsRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AttachNetworkEndpointsNetworkEndpointGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest} message AttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AttachNetworkEndpointsNetworkEndpointGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.networkEndpointGroupsAttachEndpointsRequestResource = null;
                                object.zone = "";
                                object.project = "";
                                object.networkEndpointGroup = "";
                            }
                            if (message.networkEndpointGroupsAttachEndpointsRequestResource != null && message.hasOwnProperty("networkEndpointGroupsAttachEndpointsRequestResource"))
                                object.networkEndpointGroupsAttachEndpointsRequestResource = $root.google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest.toObject(message.networkEndpointGroupsAttachEndpointsRequestResource, options);
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                object.networkEndpointGroup = message.networkEndpointGroup;
                            return object;
                        };
    
                        /**
                         * Converts this AttachNetworkEndpointsNetworkEndpointGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AttachNetworkEndpointsNetworkEndpointGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AttachNetworkEndpointsNetworkEndpointGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest";
                        };
    
                        return AttachNetworkEndpointsNetworkEndpointGroupRequest;
                    })();
    
                    v1.AttachedDisk = (function() {
    
                        /**
                         * Properties of an AttachedDisk.
                         * @memberof google.cloud.compute.v1
                         * @interface IAttachedDisk
                         * @property {string|null} [architecture] AttachedDisk architecture
                         * @property {boolean|null} [autoDelete] AttachedDisk autoDelete
                         * @property {boolean|null} [boot] AttachedDisk boot
                         * @property {string|null} [deviceName] AttachedDisk deviceName
                         * @property {google.cloud.compute.v1.ICustomerEncryptionKey|null} [diskEncryptionKey] AttachedDisk diskEncryptionKey
                         * @property {number|Long|null} [diskSizeGb] AttachedDisk diskSizeGb
                         * @property {boolean|null} [forceAttach] AttachedDisk forceAttach
                         * @property {Array.<google.cloud.compute.v1.IGuestOsFeature>|null} [guestOsFeatures] AttachedDisk guestOsFeatures
                         * @property {number|null} [index] AttachedDisk index
                         * @property {google.cloud.compute.v1.IAttachedDiskInitializeParams|null} [initializeParams] AttachedDisk initializeParams
                         * @property {string|null} ["interface"] AttachedDisk interface
                         * @property {string|null} [kind] AttachedDisk kind
                         * @property {Array.<string>|null} [licenses] AttachedDisk licenses
                         * @property {string|null} [mode] AttachedDisk mode
                         * @property {google.cloud.compute.v1.IInitialStateConfig|null} [shieldedInstanceInitialState] AttachedDisk shieldedInstanceInitialState
                         * @property {string|null} [source] AttachedDisk source
                         * @property {string|null} [type] AttachedDisk type
                         */
    
                        /**
                         * Constructs a new AttachedDisk.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AttachedDisk.
                         * @implements IAttachedDisk
                         * @constructor
                         * @param {google.cloud.compute.v1.IAttachedDisk=} [properties] Properties to set
                         */
                        function AttachedDisk(properties) {
                            this.guestOsFeatures = [];
                            this.licenses = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AttachedDisk architecture.
                         * @member {string|null|undefined} architecture
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        AttachedDisk.prototype.architecture = null;
    
                        /**
                         * AttachedDisk autoDelete.
                         * @member {boolean|null|undefined} autoDelete
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        AttachedDisk.prototype.autoDelete = null;
    
                        /**
                         * AttachedDisk boot.
                         * @member {boolean|null|undefined} boot
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        AttachedDisk.prototype.boot = null;
    
                        /**
                         * AttachedDisk deviceName.
                         * @member {string|null|undefined} deviceName
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        AttachedDisk.prototype.deviceName = null;
    
                        /**
                         * AttachedDisk diskEncryptionKey.
                         * @member {google.cloud.compute.v1.ICustomerEncryptionKey|null|undefined} diskEncryptionKey
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        AttachedDisk.prototype.diskEncryptionKey = null;
    
                        /**
                         * AttachedDisk diskSizeGb.
                         * @member {number|Long|null|undefined} diskSizeGb
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        AttachedDisk.prototype.diskSizeGb = null;
    
                        /**
                         * AttachedDisk forceAttach.
                         * @member {boolean|null|undefined} forceAttach
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        AttachedDisk.prototype.forceAttach = null;
    
                        /**
                         * AttachedDisk guestOsFeatures.
                         * @member {Array.<google.cloud.compute.v1.IGuestOsFeature>} guestOsFeatures
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        AttachedDisk.prototype.guestOsFeatures = $util.emptyArray;
    
                        /**
                         * AttachedDisk index.
                         * @member {number|null|undefined} index
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        AttachedDisk.prototype.index = null;
    
                        /**
                         * AttachedDisk initializeParams.
                         * @member {google.cloud.compute.v1.IAttachedDiskInitializeParams|null|undefined} initializeParams
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        AttachedDisk.prototype.initializeParams = null;
    
                        /**
                         * AttachedDisk interface.
                         * @member {string|null|undefined} interface
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        AttachedDisk.prototype["interface"] = null;
    
                        /**
                         * AttachedDisk kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        AttachedDisk.prototype.kind = null;
    
                        /**
                         * AttachedDisk licenses.
                         * @member {Array.<string>} licenses
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        AttachedDisk.prototype.licenses = $util.emptyArray;
    
                        /**
                         * AttachedDisk mode.
                         * @member {string|null|undefined} mode
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        AttachedDisk.prototype.mode = null;
    
                        /**
                         * AttachedDisk shieldedInstanceInitialState.
                         * @member {google.cloud.compute.v1.IInitialStateConfig|null|undefined} shieldedInstanceInitialState
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        AttachedDisk.prototype.shieldedInstanceInitialState = null;
    
                        /**
                         * AttachedDisk source.
                         * @member {string|null|undefined} source
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        AttachedDisk.prototype.source = null;
    
                        /**
                         * AttachedDisk type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        AttachedDisk.prototype.type = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AttachedDisk _architecture.
                         * @member {"architecture"|undefined} _architecture
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        Object.defineProperty(AttachedDisk.prototype, "_architecture", {
                            get: $util.oneOfGetter($oneOfFields = ["architecture"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDisk _autoDelete.
                         * @member {"autoDelete"|undefined} _autoDelete
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        Object.defineProperty(AttachedDisk.prototype, "_autoDelete", {
                            get: $util.oneOfGetter($oneOfFields = ["autoDelete"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDisk _boot.
                         * @member {"boot"|undefined} _boot
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        Object.defineProperty(AttachedDisk.prototype, "_boot", {
                            get: $util.oneOfGetter($oneOfFields = ["boot"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDisk _deviceName.
                         * @member {"deviceName"|undefined} _deviceName
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        Object.defineProperty(AttachedDisk.prototype, "_deviceName", {
                            get: $util.oneOfGetter($oneOfFields = ["deviceName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDisk _diskEncryptionKey.
                         * @member {"diskEncryptionKey"|undefined} _diskEncryptionKey
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        Object.defineProperty(AttachedDisk.prototype, "_diskEncryptionKey", {
                            get: $util.oneOfGetter($oneOfFields = ["diskEncryptionKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDisk _diskSizeGb.
                         * @member {"diskSizeGb"|undefined} _diskSizeGb
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        Object.defineProperty(AttachedDisk.prototype, "_diskSizeGb", {
                            get: $util.oneOfGetter($oneOfFields = ["diskSizeGb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDisk _forceAttach.
                         * @member {"forceAttach"|undefined} _forceAttach
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        Object.defineProperty(AttachedDisk.prototype, "_forceAttach", {
                            get: $util.oneOfGetter($oneOfFields = ["forceAttach"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDisk _index.
                         * @member {"index"|undefined} _index
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        Object.defineProperty(AttachedDisk.prototype, "_index", {
                            get: $util.oneOfGetter($oneOfFields = ["index"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDisk _initializeParams.
                         * @member {"initializeParams"|undefined} _initializeParams
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        Object.defineProperty(AttachedDisk.prototype, "_initializeParams", {
                            get: $util.oneOfGetter($oneOfFields = ["initializeParams"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDisk _interface.
                         * @member {"interface"|undefined} _interface
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        Object.defineProperty(AttachedDisk.prototype, "_interface", {
                            get: $util.oneOfGetter($oneOfFields = ["interface"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDisk _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        Object.defineProperty(AttachedDisk.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDisk _mode.
                         * @member {"mode"|undefined} _mode
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        Object.defineProperty(AttachedDisk.prototype, "_mode", {
                            get: $util.oneOfGetter($oneOfFields = ["mode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDisk _shieldedInstanceInitialState.
                         * @member {"shieldedInstanceInitialState"|undefined} _shieldedInstanceInitialState
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        Object.defineProperty(AttachedDisk.prototype, "_shieldedInstanceInitialState", {
                            get: $util.oneOfGetter($oneOfFields = ["shieldedInstanceInitialState"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDisk _source.
                         * @member {"source"|undefined} _source
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        Object.defineProperty(AttachedDisk.prototype, "_source", {
                            get: $util.oneOfGetter($oneOfFields = ["source"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDisk _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         */
                        Object.defineProperty(AttachedDisk.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AttachedDisk instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @static
                         * @param {google.cloud.compute.v1.IAttachedDisk=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AttachedDisk} AttachedDisk instance
                         */
                        AttachedDisk.create = function create(properties) {
                            return new AttachedDisk(properties);
                        };
    
                        /**
                         * Encodes the specified AttachedDisk message. Does not implicitly {@link google.cloud.compute.v1.AttachedDisk.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @static
                         * @param {google.cloud.compute.v1.IAttachedDisk} message AttachedDisk message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AttachedDisk.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.boot != null && Object.hasOwnProperty.call(message, "boot"))
                                writer.uint32(/* id 3029746, wireType 0 =*/24237968).bool(message.boot);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.mode != null && Object.hasOwnProperty.call(message, "mode"))
                                writer.uint32(/* id 3357091, wireType 2 =*/26856730).string(message.mode);
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            if (message.initializeParams != null && Object.hasOwnProperty.call(message, "initializeParams"))
                                $root.google.cloud.compute.v1.AttachedDiskInitializeParams.encode(message.initializeParams, writer.uint32(/* id 17697045, wireType 2 =*/141576362).fork()).ldelim();
                            if (message.deviceName != null && Object.hasOwnProperty.call(message, "deviceName"))
                                writer.uint32(/* id 67541716, wireType 2 =*/540333730).string(message.deviceName);
                            if (message.guestOsFeatures != null && message.guestOsFeatures.length)
                                for (var i = 0; i < message.guestOsFeatures.length; ++i)
                                    $root.google.cloud.compute.v1.GuestOsFeature.encode(message.guestOsFeatures[i], writer.uint32(/* id 79294545, wireType 2 =*/634356362).fork()).ldelim();
                            if (message.index != null && Object.hasOwnProperty.call(message, "index"))
                                writer.uint32(/* id 100346066, wireType 0 =*/802768528).int32(message.index);
                            if (message.forceAttach != null && Object.hasOwnProperty.call(message, "forceAttach"))
                                writer.uint32(/* id 142758425, wireType 0 =*/1142067400).bool(message.forceAttach);
                            if (message.source != null && Object.hasOwnProperty.call(message, "source"))
                                writer.uint32(/* id 177235995, wireType 2 =*/1417887962).string(message.source);
                            if (message.shieldedInstanceInitialState != null && Object.hasOwnProperty.call(message, "shieldedInstanceInitialState"))
                                $root.google.cloud.compute.v1.InitialStateConfig.encode(message.shieldedInstanceInitialState, writer.uint32(/* id 192356867, wireType 2 =*/1538854938).fork()).ldelim();
                            if (message.diskEncryptionKey != null && Object.hasOwnProperty.call(message, "diskEncryptionKey"))
                                $root.google.cloud.compute.v1.CustomerEncryptionKey.encode(message.diskEncryptionKey, writer.uint32(/* id 271660677, wireType 2 =*/2173285418).fork()).ldelim();
                            if (message.architecture != null && Object.hasOwnProperty.call(message, "architecture"))
                                writer.uint32(/* id 302803283, wireType 2 =*/2422426266).string(message.architecture);
                            if (message.diskSizeGb != null && Object.hasOwnProperty.call(message, "diskSizeGb"))
                                writer.uint32(/* id 316263735, wireType 0 =*/2530109880).int64(message.diskSizeGb);
                            if (message.licenses != null && message.licenses.length)
                                for (var i = 0; i < message.licenses.length; ++i)
                                    writer.uint32(/* id 337642578, wireType 2 =*/2701140626).string(message.licenses[i]);
                            if (message.autoDelete != null && Object.hasOwnProperty.call(message, "autoDelete"))
                                writer.uint32(/* id 464761403, wireType 0 =*/3718091224).bool(message.autoDelete);
                            if (message["interface"] != null && Object.hasOwnProperty.call(message, "interface"))
                                writer.uint32(/* id 502623545, wireType 2 =*/4020988362).string(message["interface"]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AttachedDisk message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AttachedDisk.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @static
                         * @param {google.cloud.compute.v1.IAttachedDisk} message AttachedDisk message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AttachedDisk.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AttachedDisk message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AttachedDisk} AttachedDisk
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AttachedDisk.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AttachedDisk();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 302803283: {
                                        message.architecture = reader.string();
                                        break;
                                    }
                                case 464761403: {
                                        message.autoDelete = reader.bool();
                                        break;
                                    }
                                case 3029746: {
                                        message.boot = reader.bool();
                                        break;
                                    }
                                case 67541716: {
                                        message.deviceName = reader.string();
                                        break;
                                    }
                                case 271660677: {
                                        message.diskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 316263735: {
                                        message.diskSizeGb = reader.int64();
                                        break;
                                    }
                                case 142758425: {
                                        message.forceAttach = reader.bool();
                                        break;
                                    }
                                case 79294545: {
                                        if (!(message.guestOsFeatures && message.guestOsFeatures.length))
                                            message.guestOsFeatures = [];
                                        message.guestOsFeatures.push($root.google.cloud.compute.v1.GuestOsFeature.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 100346066: {
                                        message.index = reader.int32();
                                        break;
                                    }
                                case 17697045: {
                                        message.initializeParams = $root.google.cloud.compute.v1.AttachedDiskInitializeParams.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 502623545: {
                                        message["interface"] = reader.string();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 337642578: {
                                        if (!(message.licenses && message.licenses.length))
                                            message.licenses = [];
                                        message.licenses.push(reader.string());
                                        break;
                                    }
                                case 3357091: {
                                        message.mode = reader.string();
                                        break;
                                    }
                                case 192356867: {
                                        message.shieldedInstanceInitialState = $root.google.cloud.compute.v1.InitialStateConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 177235995: {
                                        message.source = reader.string();
                                        break;
                                    }
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AttachedDisk message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AttachedDisk} AttachedDisk
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AttachedDisk.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AttachedDisk message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AttachedDisk.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.architecture != null && message.hasOwnProperty("architecture")) {
                                properties._architecture = 1;
                                if (!$util.isString(message.architecture))
                                    return "architecture: string expected";
                            }
                            if (message.autoDelete != null && message.hasOwnProperty("autoDelete")) {
                                properties._autoDelete = 1;
                                if (typeof message.autoDelete !== "boolean")
                                    return "autoDelete: boolean expected";
                            }
                            if (message.boot != null && message.hasOwnProperty("boot")) {
                                properties._boot = 1;
                                if (typeof message.boot !== "boolean")
                                    return "boot: boolean expected";
                            }
                            if (message.deviceName != null && message.hasOwnProperty("deviceName")) {
                                properties._deviceName = 1;
                                if (!$util.isString(message.deviceName))
                                    return "deviceName: string expected";
                            }
                            if (message.diskEncryptionKey != null && message.hasOwnProperty("diskEncryptionKey")) {
                                properties._diskEncryptionKey = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.CustomerEncryptionKey.verify(message.diskEncryptionKey);
                                    if (error)
                                        return "diskEncryptionKey." + error;
                                }
                            }
                            if (message.diskSizeGb != null && message.hasOwnProperty("diskSizeGb")) {
                                properties._diskSizeGb = 1;
                                if (!$util.isInteger(message.diskSizeGb) && !(message.diskSizeGb && $util.isInteger(message.diskSizeGb.low) && $util.isInteger(message.diskSizeGb.high)))
                                    return "diskSizeGb: integer|Long expected";
                            }
                            if (message.forceAttach != null && message.hasOwnProperty("forceAttach")) {
                                properties._forceAttach = 1;
                                if (typeof message.forceAttach !== "boolean")
                                    return "forceAttach: boolean expected";
                            }
                            if (message.guestOsFeatures != null && message.hasOwnProperty("guestOsFeatures")) {
                                if (!Array.isArray(message.guestOsFeatures))
                                    return "guestOsFeatures: array expected";
                                for (var i = 0; i < message.guestOsFeatures.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.GuestOsFeature.verify(message.guestOsFeatures[i]);
                                    if (error)
                                        return "guestOsFeatures." + error;
                                }
                            }
                            if (message.index != null && message.hasOwnProperty("index")) {
                                properties._index = 1;
                                if (!$util.isInteger(message.index))
                                    return "index: integer expected";
                            }
                            if (message.initializeParams != null && message.hasOwnProperty("initializeParams")) {
                                properties._initializeParams = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.AttachedDiskInitializeParams.verify(message.initializeParams);
                                    if (error)
                                        return "initializeParams." + error;
                                }
                            }
                            if (message["interface"] != null && message.hasOwnProperty("interface")) {
                                properties._interface = 1;
                                if (!$util.isString(message["interface"]))
                                    return "interface: string expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.licenses != null && message.hasOwnProperty("licenses")) {
                                if (!Array.isArray(message.licenses))
                                    return "licenses: array expected";
                                for (var i = 0; i < message.licenses.length; ++i)
                                    if (!$util.isString(message.licenses[i]))
                                        return "licenses: string[] expected";
                            }
                            if (message.mode != null && message.hasOwnProperty("mode")) {
                                properties._mode = 1;
                                if (!$util.isString(message.mode))
                                    return "mode: string expected";
                            }
                            if (message.shieldedInstanceInitialState != null && message.hasOwnProperty("shieldedInstanceInitialState")) {
                                properties._shieldedInstanceInitialState = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InitialStateConfig.verify(message.shieldedInstanceInitialState);
                                    if (error)
                                        return "shieldedInstanceInitialState." + error;
                                }
                            }
                            if (message.source != null && message.hasOwnProperty("source")) {
                                properties._source = 1;
                                if (!$util.isString(message.source))
                                    return "source: string expected";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AttachedDisk message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AttachedDisk} AttachedDisk
                         */
                        AttachedDisk.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AttachedDisk)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AttachedDisk();
                            if (object.architecture != null)
                                message.architecture = String(object.architecture);
                            if (object.autoDelete != null)
                                message.autoDelete = Boolean(object.autoDelete);
                            if (object.boot != null)
                                message.boot = Boolean(object.boot);
                            if (object.deviceName != null)
                                message.deviceName = String(object.deviceName);
                            if (object.diskEncryptionKey != null) {
                                if (typeof object.diskEncryptionKey !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AttachedDisk.diskEncryptionKey: object expected");
                                message.diskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.fromObject(object.diskEncryptionKey);
                            }
                            if (object.diskSizeGb != null)
                                if ($util.Long)
                                    (message.diskSizeGb = $util.Long.fromValue(object.diskSizeGb)).unsigned = false;
                                else if (typeof object.diskSizeGb === "string")
                                    message.diskSizeGb = parseInt(object.diskSizeGb, 10);
                                else if (typeof object.diskSizeGb === "number")
                                    message.diskSizeGb = object.diskSizeGb;
                                else if (typeof object.diskSizeGb === "object")
                                    message.diskSizeGb = new $util.LongBits(object.diskSizeGb.low >>> 0, object.diskSizeGb.high >>> 0).toNumber();
                            if (object.forceAttach != null)
                                message.forceAttach = Boolean(object.forceAttach);
                            if (object.guestOsFeatures) {
                                if (!Array.isArray(object.guestOsFeatures))
                                    throw TypeError(".google.cloud.compute.v1.AttachedDisk.guestOsFeatures: array expected");
                                message.guestOsFeatures = [];
                                for (var i = 0; i < object.guestOsFeatures.length; ++i) {
                                    if (typeof object.guestOsFeatures[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.AttachedDisk.guestOsFeatures: object expected");
                                    message.guestOsFeatures[i] = $root.google.cloud.compute.v1.GuestOsFeature.fromObject(object.guestOsFeatures[i]);
                                }
                            }
                            if (object.index != null)
                                message.index = object.index | 0;
                            if (object.initializeParams != null) {
                                if (typeof object.initializeParams !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AttachedDisk.initializeParams: object expected");
                                message.initializeParams = $root.google.cloud.compute.v1.AttachedDiskInitializeParams.fromObject(object.initializeParams);
                            }
                            if (object["interface"] != null)
                                message["interface"] = String(object["interface"]);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.licenses) {
                                if (!Array.isArray(object.licenses))
                                    throw TypeError(".google.cloud.compute.v1.AttachedDisk.licenses: array expected");
                                message.licenses = [];
                                for (var i = 0; i < object.licenses.length; ++i)
                                    message.licenses[i] = String(object.licenses[i]);
                            }
                            if (object.mode != null)
                                message.mode = String(object.mode);
                            if (object.shieldedInstanceInitialState != null) {
                                if (typeof object.shieldedInstanceInitialState !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AttachedDisk.shieldedInstanceInitialState: object expected");
                                message.shieldedInstanceInitialState = $root.google.cloud.compute.v1.InitialStateConfig.fromObject(object.shieldedInstanceInitialState);
                            }
                            if (object.source != null)
                                message.source = String(object.source);
                            if (object.type != null)
                                message.type = String(object.type);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AttachedDisk message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @static
                         * @param {google.cloud.compute.v1.AttachedDisk} message AttachedDisk
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AttachedDisk.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.guestOsFeatures = [];
                                object.licenses = [];
                            }
                            if (message.boot != null && message.hasOwnProperty("boot")) {
                                object.boot = message.boot;
                                if (options.oneofs)
                                    object._boot = "boot";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.mode != null && message.hasOwnProperty("mode")) {
                                object.mode = message.mode;
                                if (options.oneofs)
                                    object._mode = "mode";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            if (message.initializeParams != null && message.hasOwnProperty("initializeParams")) {
                                object.initializeParams = $root.google.cloud.compute.v1.AttachedDiskInitializeParams.toObject(message.initializeParams, options);
                                if (options.oneofs)
                                    object._initializeParams = "initializeParams";
                            }
                            if (message.deviceName != null && message.hasOwnProperty("deviceName")) {
                                object.deviceName = message.deviceName;
                                if (options.oneofs)
                                    object._deviceName = "deviceName";
                            }
                            if (message.guestOsFeatures && message.guestOsFeatures.length) {
                                object.guestOsFeatures = [];
                                for (var j = 0; j < message.guestOsFeatures.length; ++j)
                                    object.guestOsFeatures[j] = $root.google.cloud.compute.v1.GuestOsFeature.toObject(message.guestOsFeatures[j], options);
                            }
                            if (message.index != null && message.hasOwnProperty("index")) {
                                object.index = message.index;
                                if (options.oneofs)
                                    object._index = "index";
                            }
                            if (message.forceAttach != null && message.hasOwnProperty("forceAttach")) {
                                object.forceAttach = message.forceAttach;
                                if (options.oneofs)
                                    object._forceAttach = "forceAttach";
                            }
                            if (message.source != null && message.hasOwnProperty("source")) {
                                object.source = message.source;
                                if (options.oneofs)
                                    object._source = "source";
                            }
                            if (message.shieldedInstanceInitialState != null && message.hasOwnProperty("shieldedInstanceInitialState")) {
                                object.shieldedInstanceInitialState = $root.google.cloud.compute.v1.InitialStateConfig.toObject(message.shieldedInstanceInitialState, options);
                                if (options.oneofs)
                                    object._shieldedInstanceInitialState = "shieldedInstanceInitialState";
                            }
                            if (message.diskEncryptionKey != null && message.hasOwnProperty("diskEncryptionKey")) {
                                object.diskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.toObject(message.diskEncryptionKey, options);
                                if (options.oneofs)
                                    object._diskEncryptionKey = "diskEncryptionKey";
                            }
                            if (message.architecture != null && message.hasOwnProperty("architecture")) {
                                object.architecture = message.architecture;
                                if (options.oneofs)
                                    object._architecture = "architecture";
                            }
                            if (message.diskSizeGb != null && message.hasOwnProperty("diskSizeGb")) {
                                if (typeof message.diskSizeGb === "number")
                                    object.diskSizeGb = options.longs === String ? String(message.diskSizeGb) : message.diskSizeGb;
                                else
                                    object.diskSizeGb = options.longs === String ? $util.Long.prototype.toString.call(message.diskSizeGb) : options.longs === Number ? new $util.LongBits(message.diskSizeGb.low >>> 0, message.diskSizeGb.high >>> 0).toNumber() : message.diskSizeGb;
                                if (options.oneofs)
                                    object._diskSizeGb = "diskSizeGb";
                            }
                            if (message.licenses && message.licenses.length) {
                                object.licenses = [];
                                for (var j = 0; j < message.licenses.length; ++j)
                                    object.licenses[j] = message.licenses[j];
                            }
                            if (message.autoDelete != null && message.hasOwnProperty("autoDelete")) {
                                object.autoDelete = message.autoDelete;
                                if (options.oneofs)
                                    object._autoDelete = "autoDelete";
                            }
                            if (message["interface"] != null && message.hasOwnProperty("interface")) {
                                object["interface"] = message["interface"];
                                if (options.oneofs)
                                    object._interface = "interface";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AttachedDisk to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AttachedDisk.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AttachedDisk
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AttachedDisk
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AttachedDisk.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AttachedDisk";
                        };
    
                        /**
                         * Architecture enum.
                         * @name google.cloud.compute.v1.AttachedDisk.Architecture
                         * @enum {number}
                         * @property {number} UNDEFINED_ARCHITECTURE=0 UNDEFINED_ARCHITECTURE value
                         * @property {number} ARCHITECTURE_UNSPECIFIED=394750507 ARCHITECTURE_UNSPECIFIED value
                         * @property {number} ARM64=62547450 ARM64 value
                         * @property {number} X86_64=425300551 X86_64 value
                         */
                        AttachedDisk.Architecture = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ARCHITECTURE"] = 0;
                            values[valuesById[394750507] = "ARCHITECTURE_UNSPECIFIED"] = 394750507;
                            values[valuesById[62547450] = "ARM64"] = 62547450;
                            values[valuesById[425300551] = "X86_64"] = 425300551;
                            return values;
                        })();
    
                        /**
                         * Interface enum.
                         * @name google.cloud.compute.v1.AttachedDisk.Interface
                         * @enum {number}
                         * @property {number} UNDEFINED_INTERFACE=0 UNDEFINED_INTERFACE value
                         * @property {number} NVME=2408800 NVME value
                         * @property {number} SCSI=2539686 SCSI value
                         */
                        AttachedDisk.Interface = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_INTERFACE"] = 0;
                            values[valuesById[2408800] = "NVME"] = 2408800;
                            values[valuesById[2539686] = "SCSI"] = 2539686;
                            return values;
                        })();
    
                        /**
                         * Mode enum.
                         * @name google.cloud.compute.v1.AttachedDisk.Mode
                         * @enum {number}
                         * @property {number} UNDEFINED_MODE=0 UNDEFINED_MODE value
                         * @property {number} READ_ONLY=91950261 READ_ONLY value
                         * @property {number} READ_WRITE=173607894 READ_WRITE value
                         */
                        AttachedDisk.Mode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_MODE"] = 0;
                            values[valuesById[91950261] = "READ_ONLY"] = 91950261;
                            values[valuesById[173607894] = "READ_WRITE"] = 173607894;
                            return values;
                        })();
    
                        /**
                         * Type enum.
                         * @name google.cloud.compute.v1.AttachedDisk.Type
                         * @enum {number}
                         * @property {number} UNDEFINED_TYPE=0 UNDEFINED_TYPE value
                         * @property {number} PERSISTENT=460683927 PERSISTENT value
                         * @property {number} SCRATCH=496778970 SCRATCH value
                         */
                        AttachedDisk.Type = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TYPE"] = 0;
                            values[valuesById[460683927] = "PERSISTENT"] = 460683927;
                            values[valuesById[496778970] = "SCRATCH"] = 496778970;
                            return values;
                        })();
    
                        return AttachedDisk;
                    })();
    
                    v1.AttachedDiskInitializeParams = (function() {
    
                        /**
                         * Properties of an AttachedDiskInitializeParams.
                         * @memberof google.cloud.compute.v1
                         * @interface IAttachedDiskInitializeParams
                         * @property {string|null} [architecture] AttachedDiskInitializeParams architecture
                         * @property {string|null} [description] AttachedDiskInitializeParams description
                         * @property {string|null} [diskName] AttachedDiskInitializeParams diskName
                         * @property {number|Long|null} [diskSizeGb] AttachedDiskInitializeParams diskSizeGb
                         * @property {string|null} [diskType] AttachedDiskInitializeParams diskType
                         * @property {Object.<string,string>|null} [labels] AttachedDiskInitializeParams labels
                         * @property {Array.<string>|null} [licenses] AttachedDiskInitializeParams licenses
                         * @property {string|null} [onUpdateAction] AttachedDiskInitializeParams onUpdateAction
                         * @property {number|Long|null} [provisionedIops] AttachedDiskInitializeParams provisionedIops
                         * @property {Object.<string,string>|null} [resourceManagerTags] AttachedDiskInitializeParams resourceManagerTags
                         * @property {Array.<string>|null} [resourcePolicies] AttachedDiskInitializeParams resourcePolicies
                         * @property {string|null} [sourceImage] AttachedDiskInitializeParams sourceImage
                         * @property {google.cloud.compute.v1.ICustomerEncryptionKey|null} [sourceImageEncryptionKey] AttachedDiskInitializeParams sourceImageEncryptionKey
                         * @property {string|null} [sourceSnapshot] AttachedDiskInitializeParams sourceSnapshot
                         * @property {google.cloud.compute.v1.ICustomerEncryptionKey|null} [sourceSnapshotEncryptionKey] AttachedDiskInitializeParams sourceSnapshotEncryptionKey
                         */
    
                        /**
                         * Constructs a new AttachedDiskInitializeParams.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AttachedDiskInitializeParams.
                         * @implements IAttachedDiskInitializeParams
                         * @constructor
                         * @param {google.cloud.compute.v1.IAttachedDiskInitializeParams=} [properties] Properties to set
                         */
                        function AttachedDiskInitializeParams(properties) {
                            this.labels = {};
                            this.licenses = [];
                            this.resourceManagerTags = {};
                            this.resourcePolicies = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AttachedDiskInitializeParams architecture.
                         * @member {string|null|undefined} architecture
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        AttachedDiskInitializeParams.prototype.architecture = null;
    
                        /**
                         * AttachedDiskInitializeParams description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        AttachedDiskInitializeParams.prototype.description = null;
    
                        /**
                         * AttachedDiskInitializeParams diskName.
                         * @member {string|null|undefined} diskName
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        AttachedDiskInitializeParams.prototype.diskName = null;
    
                        /**
                         * AttachedDiskInitializeParams diskSizeGb.
                         * @member {number|Long|null|undefined} diskSizeGb
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        AttachedDiskInitializeParams.prototype.diskSizeGb = null;
    
                        /**
                         * AttachedDiskInitializeParams diskType.
                         * @member {string|null|undefined} diskType
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        AttachedDiskInitializeParams.prototype.diskType = null;
    
                        /**
                         * AttachedDiskInitializeParams labels.
                         * @member {Object.<string,string>} labels
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        AttachedDiskInitializeParams.prototype.labels = $util.emptyObject;
    
                        /**
                         * AttachedDiskInitializeParams licenses.
                         * @member {Array.<string>} licenses
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        AttachedDiskInitializeParams.prototype.licenses = $util.emptyArray;
    
                        /**
                         * AttachedDiskInitializeParams onUpdateAction.
                         * @member {string|null|undefined} onUpdateAction
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        AttachedDiskInitializeParams.prototype.onUpdateAction = null;
    
                        /**
                         * AttachedDiskInitializeParams provisionedIops.
                         * @member {number|Long|null|undefined} provisionedIops
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        AttachedDiskInitializeParams.prototype.provisionedIops = null;
    
                        /**
                         * AttachedDiskInitializeParams resourceManagerTags.
                         * @member {Object.<string,string>} resourceManagerTags
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        AttachedDiskInitializeParams.prototype.resourceManagerTags = $util.emptyObject;
    
                        /**
                         * AttachedDiskInitializeParams resourcePolicies.
                         * @member {Array.<string>} resourcePolicies
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        AttachedDiskInitializeParams.prototype.resourcePolicies = $util.emptyArray;
    
                        /**
                         * AttachedDiskInitializeParams sourceImage.
                         * @member {string|null|undefined} sourceImage
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        AttachedDiskInitializeParams.prototype.sourceImage = null;
    
                        /**
                         * AttachedDiskInitializeParams sourceImageEncryptionKey.
                         * @member {google.cloud.compute.v1.ICustomerEncryptionKey|null|undefined} sourceImageEncryptionKey
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        AttachedDiskInitializeParams.prototype.sourceImageEncryptionKey = null;
    
                        /**
                         * AttachedDiskInitializeParams sourceSnapshot.
                         * @member {string|null|undefined} sourceSnapshot
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        AttachedDiskInitializeParams.prototype.sourceSnapshot = null;
    
                        /**
                         * AttachedDiskInitializeParams sourceSnapshotEncryptionKey.
                         * @member {google.cloud.compute.v1.ICustomerEncryptionKey|null|undefined} sourceSnapshotEncryptionKey
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        AttachedDiskInitializeParams.prototype.sourceSnapshotEncryptionKey = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AttachedDiskInitializeParams _architecture.
                         * @member {"architecture"|undefined} _architecture
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        Object.defineProperty(AttachedDiskInitializeParams.prototype, "_architecture", {
                            get: $util.oneOfGetter($oneOfFields = ["architecture"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDiskInitializeParams _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        Object.defineProperty(AttachedDiskInitializeParams.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDiskInitializeParams _diskName.
                         * @member {"diskName"|undefined} _diskName
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        Object.defineProperty(AttachedDiskInitializeParams.prototype, "_diskName", {
                            get: $util.oneOfGetter($oneOfFields = ["diskName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDiskInitializeParams _diskSizeGb.
                         * @member {"diskSizeGb"|undefined} _diskSizeGb
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        Object.defineProperty(AttachedDiskInitializeParams.prototype, "_diskSizeGb", {
                            get: $util.oneOfGetter($oneOfFields = ["diskSizeGb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDiskInitializeParams _diskType.
                         * @member {"diskType"|undefined} _diskType
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        Object.defineProperty(AttachedDiskInitializeParams.prototype, "_diskType", {
                            get: $util.oneOfGetter($oneOfFields = ["diskType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDiskInitializeParams _onUpdateAction.
                         * @member {"onUpdateAction"|undefined} _onUpdateAction
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        Object.defineProperty(AttachedDiskInitializeParams.prototype, "_onUpdateAction", {
                            get: $util.oneOfGetter($oneOfFields = ["onUpdateAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDiskInitializeParams _provisionedIops.
                         * @member {"provisionedIops"|undefined} _provisionedIops
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        Object.defineProperty(AttachedDiskInitializeParams.prototype, "_provisionedIops", {
                            get: $util.oneOfGetter($oneOfFields = ["provisionedIops"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDiskInitializeParams _sourceImage.
                         * @member {"sourceImage"|undefined} _sourceImage
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        Object.defineProperty(AttachedDiskInitializeParams.prototype, "_sourceImage", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceImage"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDiskInitializeParams _sourceImageEncryptionKey.
                         * @member {"sourceImageEncryptionKey"|undefined} _sourceImageEncryptionKey
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        Object.defineProperty(AttachedDiskInitializeParams.prototype, "_sourceImageEncryptionKey", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceImageEncryptionKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDiskInitializeParams _sourceSnapshot.
                         * @member {"sourceSnapshot"|undefined} _sourceSnapshot
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        Object.defineProperty(AttachedDiskInitializeParams.prototype, "_sourceSnapshot", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceSnapshot"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AttachedDiskInitializeParams _sourceSnapshotEncryptionKey.
                         * @member {"sourceSnapshotEncryptionKey"|undefined} _sourceSnapshotEncryptionKey
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         */
                        Object.defineProperty(AttachedDiskInitializeParams.prototype, "_sourceSnapshotEncryptionKey", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceSnapshotEncryptionKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AttachedDiskInitializeParams instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @static
                         * @param {google.cloud.compute.v1.IAttachedDiskInitializeParams=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AttachedDiskInitializeParams} AttachedDiskInitializeParams instance
                         */
                        AttachedDiskInitializeParams.create = function create(properties) {
                            return new AttachedDiskInitializeParams(properties);
                        };
    
                        /**
                         * Encodes the specified AttachedDiskInitializeParams message. Does not implicitly {@link google.cloud.compute.v1.AttachedDiskInitializeParams.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @static
                         * @param {google.cloud.compute.v1.IAttachedDiskInitializeParams} message AttachedDiskInitializeParams message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AttachedDiskInitializeParams.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourcePolicies != null && message.resourcePolicies.length)
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    writer.uint32(/* id 22220385, wireType 2 =*/177763082).string(message.resourcePolicies[i]);
                            if (message.sourceImage != null && Object.hasOwnProperty.call(message, "sourceImage"))
                                writer.uint32(/* id 50443319, wireType 2 =*/403546554).string(message.sourceImage);
                            if (message.diskName != null && Object.hasOwnProperty.call(message, "diskName"))
                                writer.uint32(/* id 92807149, wireType 2 =*/742457194).string(message.diskName);
                            if (message.diskType != null && Object.hasOwnProperty.call(message, "diskType"))
                                writer.uint32(/* id 93009052, wireType 2 =*/744072418).string(message.diskType);
                            if (message.sourceSnapshot != null && Object.hasOwnProperty.call(message, "sourceSnapshot"))
                                writer.uint32(/* id 126061928, wireType 2 =*/1008495426).string(message.sourceSnapshot);
                            if (message.provisionedIops != null && Object.hasOwnProperty.call(message, "provisionedIops"))
                                writer.uint32(/* id 186769108, wireType 0 =*/1494152864).int64(message.provisionedIops);
                            if (message.onUpdateAction != null && Object.hasOwnProperty.call(message, "onUpdateAction"))
                                writer.uint32(/* id 202451980, wireType 2 =*/1619615842).string(message.onUpdateAction);
                            if (message.architecture != null && Object.hasOwnProperty.call(message, "architecture"))
                                writer.uint32(/* id 302803283, wireType 2 =*/2422426266).string(message.architecture);
                            if (message.sourceSnapshotEncryptionKey != null && Object.hasOwnProperty.call(message, "sourceSnapshotEncryptionKey"))
                                $root.google.cloud.compute.v1.CustomerEncryptionKey.encode(message.sourceSnapshotEncryptionKey, writer.uint32(/* id 303679322, wireType 2 =*/2429434578).fork()).ldelim();
                            if (message.diskSizeGb != null && Object.hasOwnProperty.call(message, "diskSizeGb"))
                                writer.uint32(/* id 316263735, wireType 0 =*/2530109880).int64(message.diskSizeGb);
                            if (message.licenses != null && message.licenses.length)
                                for (var i = 0; i < message.licenses.length; ++i)
                                    writer.uint32(/* id 337642578, wireType 2 =*/2701140626).string(message.licenses[i]);
                            if (message.resourceManagerTags != null && Object.hasOwnProperty.call(message, "resourceManagerTags"))
                                for (var keys = Object.keys(message.resourceManagerTags), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 377671164, wireType 2 =*/3021369314).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.resourceManagerTags[keys[i]]).ldelim();
                            if (message.sourceImageEncryptionKey != null && Object.hasOwnProperty.call(message, "sourceImageEncryptionKey"))
                                $root.google.cloud.compute.v1.CustomerEncryptionKey.encode(message.sourceImageEncryptionKey, writer.uint32(/* id 381503659, wireType 2 =*/3052029274).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.labels != null && Object.hasOwnProperty.call(message, "labels"))
                                for (var keys = Object.keys(message.labels), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 500195327, wireType 2 =*/4001562618).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.labels[keys[i]]).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AttachedDiskInitializeParams message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AttachedDiskInitializeParams.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @static
                         * @param {google.cloud.compute.v1.IAttachedDiskInitializeParams} message AttachedDiskInitializeParams message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AttachedDiskInitializeParams.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AttachedDiskInitializeParams message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AttachedDiskInitializeParams} AttachedDiskInitializeParams
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AttachedDiskInitializeParams.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AttachedDiskInitializeParams(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 302803283: {
                                        message.architecture = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 92807149: {
                                        message.diskName = reader.string();
                                        break;
                                    }
                                case 316263735: {
                                        message.diskSizeGb = reader.int64();
                                        break;
                                    }
                                case 93009052: {
                                        message.diskType = reader.string();
                                        break;
                                    }
                                case 500195327: {
                                        if (message.labels === $util.emptyObject)
                                            message.labels = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.labels[key] = value;
                                        break;
                                    }
                                case 337642578: {
                                        if (!(message.licenses && message.licenses.length))
                                            message.licenses = [];
                                        message.licenses.push(reader.string());
                                        break;
                                    }
                                case 202451980: {
                                        message.onUpdateAction = reader.string();
                                        break;
                                    }
                                case 186769108: {
                                        message.provisionedIops = reader.int64();
                                        break;
                                    }
                                case 377671164: {
                                        if (message.resourceManagerTags === $util.emptyObject)
                                            message.resourceManagerTags = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.resourceManagerTags[key] = value;
                                        break;
                                    }
                                case 22220385: {
                                        if (!(message.resourcePolicies && message.resourcePolicies.length))
                                            message.resourcePolicies = [];
                                        message.resourcePolicies.push(reader.string());
                                        break;
                                    }
                                case 50443319: {
                                        message.sourceImage = reader.string();
                                        break;
                                    }
                                case 381503659: {
                                        message.sourceImageEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 126061928: {
                                        message.sourceSnapshot = reader.string();
                                        break;
                                    }
                                case 303679322: {
                                        message.sourceSnapshotEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AttachedDiskInitializeParams message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AttachedDiskInitializeParams} AttachedDiskInitializeParams
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AttachedDiskInitializeParams.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AttachedDiskInitializeParams message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AttachedDiskInitializeParams.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.architecture != null && message.hasOwnProperty("architecture")) {
                                properties._architecture = 1;
                                if (!$util.isString(message.architecture))
                                    return "architecture: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.diskName != null && message.hasOwnProperty("diskName")) {
                                properties._diskName = 1;
                                if (!$util.isString(message.diskName))
                                    return "diskName: string expected";
                            }
                            if (message.diskSizeGb != null && message.hasOwnProperty("diskSizeGb")) {
                                properties._diskSizeGb = 1;
                                if (!$util.isInteger(message.diskSizeGb) && !(message.diskSizeGb && $util.isInteger(message.diskSizeGb.low) && $util.isInteger(message.diskSizeGb.high)))
                                    return "diskSizeGb: integer|Long expected";
                            }
                            if (message.diskType != null && message.hasOwnProperty("diskType")) {
                                properties._diskType = 1;
                                if (!$util.isString(message.diskType))
                                    return "diskType: string expected";
                            }
                            if (message.labels != null && message.hasOwnProperty("labels")) {
                                if (!$util.isObject(message.labels))
                                    return "labels: object expected";
                                var key = Object.keys(message.labels);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.labels[key[i]]))
                                        return "labels: string{k:string} expected";
                            }
                            if (message.licenses != null && message.hasOwnProperty("licenses")) {
                                if (!Array.isArray(message.licenses))
                                    return "licenses: array expected";
                                for (var i = 0; i < message.licenses.length; ++i)
                                    if (!$util.isString(message.licenses[i]))
                                        return "licenses: string[] expected";
                            }
                            if (message.onUpdateAction != null && message.hasOwnProperty("onUpdateAction")) {
                                properties._onUpdateAction = 1;
                                if (!$util.isString(message.onUpdateAction))
                                    return "onUpdateAction: string expected";
                            }
                            if (message.provisionedIops != null && message.hasOwnProperty("provisionedIops")) {
                                properties._provisionedIops = 1;
                                if (!$util.isInteger(message.provisionedIops) && !(message.provisionedIops && $util.isInteger(message.provisionedIops.low) && $util.isInteger(message.provisionedIops.high)))
                                    return "provisionedIops: integer|Long expected";
                            }
                            if (message.resourceManagerTags != null && message.hasOwnProperty("resourceManagerTags")) {
                                if (!$util.isObject(message.resourceManagerTags))
                                    return "resourceManagerTags: object expected";
                                var key = Object.keys(message.resourceManagerTags);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.resourceManagerTags[key[i]]))
                                        return "resourceManagerTags: string{k:string} expected";
                            }
                            if (message.resourcePolicies != null && message.hasOwnProperty("resourcePolicies")) {
                                if (!Array.isArray(message.resourcePolicies))
                                    return "resourcePolicies: array expected";
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    if (!$util.isString(message.resourcePolicies[i]))
                                        return "resourcePolicies: string[] expected";
                            }
                            if (message.sourceImage != null && message.hasOwnProperty("sourceImage")) {
                                properties._sourceImage = 1;
                                if (!$util.isString(message.sourceImage))
                                    return "sourceImage: string expected";
                            }
                            if (message.sourceImageEncryptionKey != null && message.hasOwnProperty("sourceImageEncryptionKey")) {
                                properties._sourceImageEncryptionKey = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.CustomerEncryptionKey.verify(message.sourceImageEncryptionKey);
                                    if (error)
                                        return "sourceImageEncryptionKey." + error;
                                }
                            }
                            if (message.sourceSnapshot != null && message.hasOwnProperty("sourceSnapshot")) {
                                properties._sourceSnapshot = 1;
                                if (!$util.isString(message.sourceSnapshot))
                                    return "sourceSnapshot: string expected";
                            }
                            if (message.sourceSnapshotEncryptionKey != null && message.hasOwnProperty("sourceSnapshotEncryptionKey")) {
                                properties._sourceSnapshotEncryptionKey = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.CustomerEncryptionKey.verify(message.sourceSnapshotEncryptionKey);
                                    if (error)
                                        return "sourceSnapshotEncryptionKey." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AttachedDiskInitializeParams message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AttachedDiskInitializeParams} AttachedDiskInitializeParams
                         */
                        AttachedDiskInitializeParams.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AttachedDiskInitializeParams)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AttachedDiskInitializeParams();
                            if (object.architecture != null)
                                message.architecture = String(object.architecture);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.diskName != null)
                                message.diskName = String(object.diskName);
                            if (object.diskSizeGb != null)
                                if ($util.Long)
                                    (message.diskSizeGb = $util.Long.fromValue(object.diskSizeGb)).unsigned = false;
                                else if (typeof object.diskSizeGb === "string")
                                    message.diskSizeGb = parseInt(object.diskSizeGb, 10);
                                else if (typeof object.diskSizeGb === "number")
                                    message.diskSizeGb = object.diskSizeGb;
                                else if (typeof object.diskSizeGb === "object")
                                    message.diskSizeGb = new $util.LongBits(object.diskSizeGb.low >>> 0, object.diskSizeGb.high >>> 0).toNumber();
                            if (object.diskType != null)
                                message.diskType = String(object.diskType);
                            if (object.labels) {
                                if (typeof object.labels !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AttachedDiskInitializeParams.labels: object expected");
                                message.labels = {};
                                for (var keys = Object.keys(object.labels), i = 0; i < keys.length; ++i)
                                    message.labels[keys[i]] = String(object.labels[keys[i]]);
                            }
                            if (object.licenses) {
                                if (!Array.isArray(object.licenses))
                                    throw TypeError(".google.cloud.compute.v1.AttachedDiskInitializeParams.licenses: array expected");
                                message.licenses = [];
                                for (var i = 0; i < object.licenses.length; ++i)
                                    message.licenses[i] = String(object.licenses[i]);
                            }
                            if (object.onUpdateAction != null)
                                message.onUpdateAction = String(object.onUpdateAction);
                            if (object.provisionedIops != null)
                                if ($util.Long)
                                    (message.provisionedIops = $util.Long.fromValue(object.provisionedIops)).unsigned = false;
                                else if (typeof object.provisionedIops === "string")
                                    message.provisionedIops = parseInt(object.provisionedIops, 10);
                                else if (typeof object.provisionedIops === "number")
                                    message.provisionedIops = object.provisionedIops;
                                else if (typeof object.provisionedIops === "object")
                                    message.provisionedIops = new $util.LongBits(object.provisionedIops.low >>> 0, object.provisionedIops.high >>> 0).toNumber();
                            if (object.resourceManagerTags) {
                                if (typeof object.resourceManagerTags !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AttachedDiskInitializeParams.resourceManagerTags: object expected");
                                message.resourceManagerTags = {};
                                for (var keys = Object.keys(object.resourceManagerTags), i = 0; i < keys.length; ++i)
                                    message.resourceManagerTags[keys[i]] = String(object.resourceManagerTags[keys[i]]);
                            }
                            if (object.resourcePolicies) {
                                if (!Array.isArray(object.resourcePolicies))
                                    throw TypeError(".google.cloud.compute.v1.AttachedDiskInitializeParams.resourcePolicies: array expected");
                                message.resourcePolicies = [];
                                for (var i = 0; i < object.resourcePolicies.length; ++i)
                                    message.resourcePolicies[i] = String(object.resourcePolicies[i]);
                            }
                            if (object.sourceImage != null)
                                message.sourceImage = String(object.sourceImage);
                            if (object.sourceImageEncryptionKey != null) {
                                if (typeof object.sourceImageEncryptionKey !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AttachedDiskInitializeParams.sourceImageEncryptionKey: object expected");
                                message.sourceImageEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.fromObject(object.sourceImageEncryptionKey);
                            }
                            if (object.sourceSnapshot != null)
                                message.sourceSnapshot = String(object.sourceSnapshot);
                            if (object.sourceSnapshotEncryptionKey != null) {
                                if (typeof object.sourceSnapshotEncryptionKey !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AttachedDiskInitializeParams.sourceSnapshotEncryptionKey: object expected");
                                message.sourceSnapshotEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.fromObject(object.sourceSnapshotEncryptionKey);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AttachedDiskInitializeParams message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @static
                         * @param {google.cloud.compute.v1.AttachedDiskInitializeParams} message AttachedDiskInitializeParams
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AttachedDiskInitializeParams.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.resourcePolicies = [];
                                object.licenses = [];
                            }
                            if (options.objects || options.defaults) {
                                object.resourceManagerTags = {};
                                object.labels = {};
                            }
                            if (message.resourcePolicies && message.resourcePolicies.length) {
                                object.resourcePolicies = [];
                                for (var j = 0; j < message.resourcePolicies.length; ++j)
                                    object.resourcePolicies[j] = message.resourcePolicies[j];
                            }
                            if (message.sourceImage != null && message.hasOwnProperty("sourceImage")) {
                                object.sourceImage = message.sourceImage;
                                if (options.oneofs)
                                    object._sourceImage = "sourceImage";
                            }
                            if (message.diskName != null && message.hasOwnProperty("diskName")) {
                                object.diskName = message.diskName;
                                if (options.oneofs)
                                    object._diskName = "diskName";
                            }
                            if (message.diskType != null && message.hasOwnProperty("diskType")) {
                                object.diskType = message.diskType;
                                if (options.oneofs)
                                    object._diskType = "diskType";
                            }
                            if (message.sourceSnapshot != null && message.hasOwnProperty("sourceSnapshot")) {
                                object.sourceSnapshot = message.sourceSnapshot;
                                if (options.oneofs)
                                    object._sourceSnapshot = "sourceSnapshot";
                            }
                            if (message.provisionedIops != null && message.hasOwnProperty("provisionedIops")) {
                                if (typeof message.provisionedIops === "number")
                                    object.provisionedIops = options.longs === String ? String(message.provisionedIops) : message.provisionedIops;
                                else
                                    object.provisionedIops = options.longs === String ? $util.Long.prototype.toString.call(message.provisionedIops) : options.longs === Number ? new $util.LongBits(message.provisionedIops.low >>> 0, message.provisionedIops.high >>> 0).toNumber() : message.provisionedIops;
                                if (options.oneofs)
                                    object._provisionedIops = "provisionedIops";
                            }
                            if (message.onUpdateAction != null && message.hasOwnProperty("onUpdateAction")) {
                                object.onUpdateAction = message.onUpdateAction;
                                if (options.oneofs)
                                    object._onUpdateAction = "onUpdateAction";
                            }
                            if (message.architecture != null && message.hasOwnProperty("architecture")) {
                                object.architecture = message.architecture;
                                if (options.oneofs)
                                    object._architecture = "architecture";
                            }
                            if (message.sourceSnapshotEncryptionKey != null && message.hasOwnProperty("sourceSnapshotEncryptionKey")) {
                                object.sourceSnapshotEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.toObject(message.sourceSnapshotEncryptionKey, options);
                                if (options.oneofs)
                                    object._sourceSnapshotEncryptionKey = "sourceSnapshotEncryptionKey";
                            }
                            if (message.diskSizeGb != null && message.hasOwnProperty("diskSizeGb")) {
                                if (typeof message.diskSizeGb === "number")
                                    object.diskSizeGb = options.longs === String ? String(message.diskSizeGb) : message.diskSizeGb;
                                else
                                    object.diskSizeGb = options.longs === String ? $util.Long.prototype.toString.call(message.diskSizeGb) : options.longs === Number ? new $util.LongBits(message.diskSizeGb.low >>> 0, message.diskSizeGb.high >>> 0).toNumber() : message.diskSizeGb;
                                if (options.oneofs)
                                    object._diskSizeGb = "diskSizeGb";
                            }
                            if (message.licenses && message.licenses.length) {
                                object.licenses = [];
                                for (var j = 0; j < message.licenses.length; ++j)
                                    object.licenses[j] = message.licenses[j];
                            }
                            var keys2;
                            if (message.resourceManagerTags && (keys2 = Object.keys(message.resourceManagerTags)).length) {
                                object.resourceManagerTags = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.resourceManagerTags[keys2[j]] = message.resourceManagerTags[keys2[j]];
                            }
                            if (message.sourceImageEncryptionKey != null && message.hasOwnProperty("sourceImageEncryptionKey")) {
                                object.sourceImageEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.toObject(message.sourceImageEncryptionKey, options);
                                if (options.oneofs)
                                    object._sourceImageEncryptionKey = "sourceImageEncryptionKey";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.labels && (keys2 = Object.keys(message.labels)).length) {
                                object.labels = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.labels[keys2[j]] = message.labels[keys2[j]];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AttachedDiskInitializeParams to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AttachedDiskInitializeParams.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AttachedDiskInitializeParams
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AttachedDiskInitializeParams
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AttachedDiskInitializeParams.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AttachedDiskInitializeParams";
                        };
    
                        /**
                         * Architecture enum.
                         * @name google.cloud.compute.v1.AttachedDiskInitializeParams.Architecture
                         * @enum {number}
                         * @property {number} UNDEFINED_ARCHITECTURE=0 UNDEFINED_ARCHITECTURE value
                         * @property {number} ARCHITECTURE_UNSPECIFIED=394750507 ARCHITECTURE_UNSPECIFIED value
                         * @property {number} ARM64=62547450 ARM64 value
                         * @property {number} X86_64=425300551 X86_64 value
                         */
                        AttachedDiskInitializeParams.Architecture = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ARCHITECTURE"] = 0;
                            values[valuesById[394750507] = "ARCHITECTURE_UNSPECIFIED"] = 394750507;
                            values[valuesById[62547450] = "ARM64"] = 62547450;
                            values[valuesById[425300551] = "X86_64"] = 425300551;
                            return values;
                        })();
    
                        /**
                         * OnUpdateAction enum.
                         * @name google.cloud.compute.v1.AttachedDiskInitializeParams.OnUpdateAction
                         * @enum {number}
                         * @property {number} UNDEFINED_ON_UPDATE_ACTION=0 UNDEFINED_ON_UPDATE_ACTION value
                         * @property {number} RECREATE_DISK=494767853 RECREATE_DISK value
                         * @property {number} RECREATE_DISK_IF_SOURCE_CHANGED=398099712 RECREATE_DISK_IF_SOURCE_CHANGED value
                         * @property {number} USE_EXISTING_DISK=232682233 USE_EXISTING_DISK value
                         */
                        AttachedDiskInitializeParams.OnUpdateAction = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ON_UPDATE_ACTION"] = 0;
                            values[valuesById[494767853] = "RECREATE_DISK"] = 494767853;
                            values[valuesById[398099712] = "RECREATE_DISK_IF_SOURCE_CHANGED"] = 398099712;
                            values[valuesById[232682233] = "USE_EXISTING_DISK"] = 232682233;
                            return values;
                        })();
    
                        return AttachedDiskInitializeParams;
                    })();
    
                    v1.AuditConfig = (function() {
    
                        /**
                         * Properties of an AuditConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface IAuditConfig
                         * @property {Array.<google.cloud.compute.v1.IAuditLogConfig>|null} [auditLogConfigs] AuditConfig auditLogConfigs
                         * @property {Array.<string>|null} [exemptedMembers] AuditConfig exemptedMembers
                         * @property {string|null} [service] AuditConfig service
                         */
    
                        /**
                         * Constructs a new AuditConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AuditConfig.
                         * @implements IAuditConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.IAuditConfig=} [properties] Properties to set
                         */
                        function AuditConfig(properties) {
                            this.auditLogConfigs = [];
                            this.exemptedMembers = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AuditConfig auditLogConfigs.
                         * @member {Array.<google.cloud.compute.v1.IAuditLogConfig>} auditLogConfigs
                         * @memberof google.cloud.compute.v1.AuditConfig
                         * @instance
                         */
                        AuditConfig.prototype.auditLogConfigs = $util.emptyArray;
    
                        /**
                         * AuditConfig exemptedMembers.
                         * @member {Array.<string>} exemptedMembers
                         * @memberof google.cloud.compute.v1.AuditConfig
                         * @instance
                         */
                        AuditConfig.prototype.exemptedMembers = $util.emptyArray;
    
                        /**
                         * AuditConfig service.
                         * @member {string|null|undefined} service
                         * @memberof google.cloud.compute.v1.AuditConfig
                         * @instance
                         */
                        AuditConfig.prototype.service = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AuditConfig _service.
                         * @member {"service"|undefined} _service
                         * @memberof google.cloud.compute.v1.AuditConfig
                         * @instance
                         */
                        Object.defineProperty(AuditConfig.prototype, "_service", {
                            get: $util.oneOfGetter($oneOfFields = ["service"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AuditConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AuditConfig
                         * @static
                         * @param {google.cloud.compute.v1.IAuditConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AuditConfig} AuditConfig instance
                         */
                        AuditConfig.create = function create(properties) {
                            return new AuditConfig(properties);
                        };
    
                        /**
                         * Encodes the specified AuditConfig message. Does not implicitly {@link google.cloud.compute.v1.AuditConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AuditConfig
                         * @static
                         * @param {google.cloud.compute.v1.IAuditConfig} message AuditConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AuditConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.exemptedMembers != null && message.exemptedMembers.length)
                                for (var i = 0; i < message.exemptedMembers.length; ++i)
                                    writer.uint32(/* id 232615576, wireType 2 =*/1860924610).string(message.exemptedMembers[i]);
                            if (message.service != null && Object.hasOwnProperty.call(message, "service"))
                                writer.uint32(/* id 373540533, wireType 2 =*/2988324266).string(message.service);
                            if (message.auditLogConfigs != null && message.auditLogConfigs.length)
                                for (var i = 0; i < message.auditLogConfigs.length; ++i)
                                    $root.google.cloud.compute.v1.AuditLogConfig.encode(message.auditLogConfigs[i], writer.uint32(/* id 488420626, wireType 2 =*/3907365010).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AuditConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AuditConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AuditConfig
                         * @static
                         * @param {google.cloud.compute.v1.IAuditConfig} message AuditConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AuditConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AuditConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AuditConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AuditConfig} AuditConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AuditConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AuditConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 488420626: {
                                        if (!(message.auditLogConfigs && message.auditLogConfigs.length))
                                            message.auditLogConfigs = [];
                                        message.auditLogConfigs.push($root.google.cloud.compute.v1.AuditLogConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 232615576: {
                                        if (!(message.exemptedMembers && message.exemptedMembers.length))
                                            message.exemptedMembers = [];
                                        message.exemptedMembers.push(reader.string());
                                        break;
                                    }
                                case 373540533: {
                                        message.service = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AuditConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AuditConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AuditConfig} AuditConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AuditConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AuditConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AuditConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AuditConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.auditLogConfigs != null && message.hasOwnProperty("auditLogConfigs")) {
                                if (!Array.isArray(message.auditLogConfigs))
                                    return "auditLogConfigs: array expected";
                                for (var i = 0; i < message.auditLogConfigs.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AuditLogConfig.verify(message.auditLogConfigs[i]);
                                    if (error)
                                        return "auditLogConfigs." + error;
                                }
                            }
                            if (message.exemptedMembers != null && message.hasOwnProperty("exemptedMembers")) {
                                if (!Array.isArray(message.exemptedMembers))
                                    return "exemptedMembers: array expected";
                                for (var i = 0; i < message.exemptedMembers.length; ++i)
                                    if (!$util.isString(message.exemptedMembers[i]))
                                        return "exemptedMembers: string[] expected";
                            }
                            if (message.service != null && message.hasOwnProperty("service")) {
                                properties._service = 1;
                                if (!$util.isString(message.service))
                                    return "service: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AuditConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AuditConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AuditConfig} AuditConfig
                         */
                        AuditConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AuditConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AuditConfig();
                            if (object.auditLogConfigs) {
                                if (!Array.isArray(object.auditLogConfigs))
                                    throw TypeError(".google.cloud.compute.v1.AuditConfig.auditLogConfigs: array expected");
                                message.auditLogConfigs = [];
                                for (var i = 0; i < object.auditLogConfigs.length; ++i) {
                                    if (typeof object.auditLogConfigs[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.AuditConfig.auditLogConfigs: object expected");
                                    message.auditLogConfigs[i] = $root.google.cloud.compute.v1.AuditLogConfig.fromObject(object.auditLogConfigs[i]);
                                }
                            }
                            if (object.exemptedMembers) {
                                if (!Array.isArray(object.exemptedMembers))
                                    throw TypeError(".google.cloud.compute.v1.AuditConfig.exemptedMembers: array expected");
                                message.exemptedMembers = [];
                                for (var i = 0; i < object.exemptedMembers.length; ++i)
                                    message.exemptedMembers[i] = String(object.exemptedMembers[i]);
                            }
                            if (object.service != null)
                                message.service = String(object.service);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AuditConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AuditConfig
                         * @static
                         * @param {google.cloud.compute.v1.AuditConfig} message AuditConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AuditConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.exemptedMembers = [];
                                object.auditLogConfigs = [];
                            }
                            if (message.exemptedMembers && message.exemptedMembers.length) {
                                object.exemptedMembers = [];
                                for (var j = 0; j < message.exemptedMembers.length; ++j)
                                    object.exemptedMembers[j] = message.exemptedMembers[j];
                            }
                            if (message.service != null && message.hasOwnProperty("service")) {
                                object.service = message.service;
                                if (options.oneofs)
                                    object._service = "service";
                            }
                            if (message.auditLogConfigs && message.auditLogConfigs.length) {
                                object.auditLogConfigs = [];
                                for (var j = 0; j < message.auditLogConfigs.length; ++j)
                                    object.auditLogConfigs[j] = $root.google.cloud.compute.v1.AuditLogConfig.toObject(message.auditLogConfigs[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AuditConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AuditConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AuditConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AuditConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AuditConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AuditConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AuditConfig";
                        };
    
                        return AuditConfig;
                    })();
    
                    v1.AuditLogConfig = (function() {
    
                        /**
                         * Properties of an AuditLogConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface IAuditLogConfig
                         * @property {Array.<string>|null} [exemptedMembers] AuditLogConfig exemptedMembers
                         * @property {boolean|null} [ignoreChildExemptions] AuditLogConfig ignoreChildExemptions
                         * @property {string|null} [logType] AuditLogConfig logType
                         */
    
                        /**
                         * Constructs a new AuditLogConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AuditLogConfig.
                         * @implements IAuditLogConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.IAuditLogConfig=} [properties] Properties to set
                         */
                        function AuditLogConfig(properties) {
                            this.exemptedMembers = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AuditLogConfig exemptedMembers.
                         * @member {Array.<string>} exemptedMembers
                         * @memberof google.cloud.compute.v1.AuditLogConfig
                         * @instance
                         */
                        AuditLogConfig.prototype.exemptedMembers = $util.emptyArray;
    
                        /**
                         * AuditLogConfig ignoreChildExemptions.
                         * @member {boolean|null|undefined} ignoreChildExemptions
                         * @memberof google.cloud.compute.v1.AuditLogConfig
                         * @instance
                         */
                        AuditLogConfig.prototype.ignoreChildExemptions = null;
    
                        /**
                         * AuditLogConfig logType.
                         * @member {string|null|undefined} logType
                         * @memberof google.cloud.compute.v1.AuditLogConfig
                         * @instance
                         */
                        AuditLogConfig.prototype.logType = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AuditLogConfig _ignoreChildExemptions.
                         * @member {"ignoreChildExemptions"|undefined} _ignoreChildExemptions
                         * @memberof google.cloud.compute.v1.AuditLogConfig
                         * @instance
                         */
                        Object.defineProperty(AuditLogConfig.prototype, "_ignoreChildExemptions", {
                            get: $util.oneOfGetter($oneOfFields = ["ignoreChildExemptions"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AuditLogConfig _logType.
                         * @member {"logType"|undefined} _logType
                         * @memberof google.cloud.compute.v1.AuditLogConfig
                         * @instance
                         */
                        Object.defineProperty(AuditLogConfig.prototype, "_logType", {
                            get: $util.oneOfGetter($oneOfFields = ["logType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AuditLogConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AuditLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.IAuditLogConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AuditLogConfig} AuditLogConfig instance
                         */
                        AuditLogConfig.create = function create(properties) {
                            return new AuditLogConfig(properties);
                        };
    
                        /**
                         * Encodes the specified AuditLogConfig message. Does not implicitly {@link google.cloud.compute.v1.AuditLogConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AuditLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.IAuditLogConfig} message AuditLogConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AuditLogConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.ignoreChildExemptions != null && Object.hasOwnProperty.call(message, "ignoreChildExemptions"))
                                writer.uint32(/* id 70141850, wireType 0 =*/561134800).bool(message.ignoreChildExemptions);
                            if (message.exemptedMembers != null && message.exemptedMembers.length)
                                for (var i = 0; i < message.exemptedMembers.length; ++i)
                                    writer.uint32(/* id 232615576, wireType 2 =*/1860924610).string(message.exemptedMembers[i]);
                            if (message.logType != null && Object.hasOwnProperty.call(message, "logType"))
                                writer.uint32(/* id 403115861, wireType 2 =*/3224926890).string(message.logType);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AuditLogConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AuditLogConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AuditLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.IAuditLogConfig} message AuditLogConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AuditLogConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AuditLogConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AuditLogConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AuditLogConfig} AuditLogConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AuditLogConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AuditLogConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 232615576: {
                                        if (!(message.exemptedMembers && message.exemptedMembers.length))
                                            message.exemptedMembers = [];
                                        message.exemptedMembers.push(reader.string());
                                        break;
                                    }
                                case 70141850: {
                                        message.ignoreChildExemptions = reader.bool();
                                        break;
                                    }
                                case 403115861: {
                                        message.logType = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AuditLogConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AuditLogConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AuditLogConfig} AuditLogConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AuditLogConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AuditLogConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AuditLogConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AuditLogConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.exemptedMembers != null && message.hasOwnProperty("exemptedMembers")) {
                                if (!Array.isArray(message.exemptedMembers))
                                    return "exemptedMembers: array expected";
                                for (var i = 0; i < message.exemptedMembers.length; ++i)
                                    if (!$util.isString(message.exemptedMembers[i]))
                                        return "exemptedMembers: string[] expected";
                            }
                            if (message.ignoreChildExemptions != null && message.hasOwnProperty("ignoreChildExemptions")) {
                                properties._ignoreChildExemptions = 1;
                                if (typeof message.ignoreChildExemptions !== "boolean")
                                    return "ignoreChildExemptions: boolean expected";
                            }
                            if (message.logType != null && message.hasOwnProperty("logType")) {
                                properties._logType = 1;
                                if (!$util.isString(message.logType))
                                    return "logType: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AuditLogConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AuditLogConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AuditLogConfig} AuditLogConfig
                         */
                        AuditLogConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AuditLogConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AuditLogConfig();
                            if (object.exemptedMembers) {
                                if (!Array.isArray(object.exemptedMembers))
                                    throw TypeError(".google.cloud.compute.v1.AuditLogConfig.exemptedMembers: array expected");
                                message.exemptedMembers = [];
                                for (var i = 0; i < object.exemptedMembers.length; ++i)
                                    message.exemptedMembers[i] = String(object.exemptedMembers[i]);
                            }
                            if (object.ignoreChildExemptions != null)
                                message.ignoreChildExemptions = Boolean(object.ignoreChildExemptions);
                            if (object.logType != null)
                                message.logType = String(object.logType);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AuditLogConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AuditLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.AuditLogConfig} message AuditLogConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AuditLogConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.exemptedMembers = [];
                            if (message.ignoreChildExemptions != null && message.hasOwnProperty("ignoreChildExemptions")) {
                                object.ignoreChildExemptions = message.ignoreChildExemptions;
                                if (options.oneofs)
                                    object._ignoreChildExemptions = "ignoreChildExemptions";
                            }
                            if (message.exemptedMembers && message.exemptedMembers.length) {
                                object.exemptedMembers = [];
                                for (var j = 0; j < message.exemptedMembers.length; ++j)
                                    object.exemptedMembers[j] = message.exemptedMembers[j];
                            }
                            if (message.logType != null && message.hasOwnProperty("logType")) {
                                object.logType = message.logType;
                                if (options.oneofs)
                                    object._logType = "logType";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AuditLogConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AuditLogConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AuditLogConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AuditLogConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AuditLogConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AuditLogConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AuditLogConfig";
                        };
    
                        /**
                         * LogType enum.
                         * @name google.cloud.compute.v1.AuditLogConfig.LogType
                         * @enum {number}
                         * @property {number} UNDEFINED_LOG_TYPE=0 UNDEFINED_LOG_TYPE value
                         * @property {number} ADMIN_READ=128951462 ADMIN_READ value
                         * @property {number} DATA_READ=305224971 DATA_READ value
                         * @property {number} DATA_WRITE=340181738 DATA_WRITE value
                         * @property {number} LOG_TYPE_UNSPECIFIED=154527053 LOG_TYPE_UNSPECIFIED value
                         */
                        AuditLogConfig.LogType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_LOG_TYPE"] = 0;
                            values[valuesById[128951462] = "ADMIN_READ"] = 128951462;
                            values[valuesById[305224971] = "DATA_READ"] = 305224971;
                            values[valuesById[340181738] = "DATA_WRITE"] = 340181738;
                            values[valuesById[154527053] = "LOG_TYPE_UNSPECIFIED"] = 154527053;
                            return values;
                        })();
    
                        return AuditLogConfig;
                    })();
    
                    v1.AuthorizationLoggingOptions = (function() {
    
                        /**
                         * Properties of an AuthorizationLoggingOptions.
                         * @memberof google.cloud.compute.v1
                         * @interface IAuthorizationLoggingOptions
                         * @property {string|null} [permissionType] AuthorizationLoggingOptions permissionType
                         */
    
                        /**
                         * Constructs a new AuthorizationLoggingOptions.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AuthorizationLoggingOptions.
                         * @implements IAuthorizationLoggingOptions
                         * @constructor
                         * @param {google.cloud.compute.v1.IAuthorizationLoggingOptions=} [properties] Properties to set
                         */
                        function AuthorizationLoggingOptions(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AuthorizationLoggingOptions permissionType.
                         * @member {string|null|undefined} permissionType
                         * @memberof google.cloud.compute.v1.AuthorizationLoggingOptions
                         * @instance
                         */
                        AuthorizationLoggingOptions.prototype.permissionType = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AuthorizationLoggingOptions _permissionType.
                         * @member {"permissionType"|undefined} _permissionType
                         * @memberof google.cloud.compute.v1.AuthorizationLoggingOptions
                         * @instance
                         */
                        Object.defineProperty(AuthorizationLoggingOptions.prototype, "_permissionType", {
                            get: $util.oneOfGetter($oneOfFields = ["permissionType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AuthorizationLoggingOptions instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AuthorizationLoggingOptions
                         * @static
                         * @param {google.cloud.compute.v1.IAuthorizationLoggingOptions=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AuthorizationLoggingOptions} AuthorizationLoggingOptions instance
                         */
                        AuthorizationLoggingOptions.create = function create(properties) {
                            return new AuthorizationLoggingOptions(properties);
                        };
    
                        /**
                         * Encodes the specified AuthorizationLoggingOptions message. Does not implicitly {@link google.cloud.compute.v1.AuthorizationLoggingOptions.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AuthorizationLoggingOptions
                         * @static
                         * @param {google.cloud.compute.v1.IAuthorizationLoggingOptions} message AuthorizationLoggingOptions message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AuthorizationLoggingOptions.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.permissionType != null && Object.hasOwnProperty.call(message, "permissionType"))
                                writer.uint32(/* id 525978538, wireType 2 =*/4207828306).string(message.permissionType);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AuthorizationLoggingOptions message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AuthorizationLoggingOptions.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AuthorizationLoggingOptions
                         * @static
                         * @param {google.cloud.compute.v1.IAuthorizationLoggingOptions} message AuthorizationLoggingOptions message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AuthorizationLoggingOptions.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AuthorizationLoggingOptions message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AuthorizationLoggingOptions
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AuthorizationLoggingOptions} AuthorizationLoggingOptions
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AuthorizationLoggingOptions.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AuthorizationLoggingOptions();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 525978538: {
                                        message.permissionType = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AuthorizationLoggingOptions message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AuthorizationLoggingOptions
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AuthorizationLoggingOptions} AuthorizationLoggingOptions
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AuthorizationLoggingOptions.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AuthorizationLoggingOptions message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AuthorizationLoggingOptions
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AuthorizationLoggingOptions.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.permissionType != null && message.hasOwnProperty("permissionType")) {
                                properties._permissionType = 1;
                                if (!$util.isString(message.permissionType))
                                    return "permissionType: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AuthorizationLoggingOptions message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AuthorizationLoggingOptions
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AuthorizationLoggingOptions} AuthorizationLoggingOptions
                         */
                        AuthorizationLoggingOptions.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AuthorizationLoggingOptions)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AuthorizationLoggingOptions();
                            if (object.permissionType != null)
                                message.permissionType = String(object.permissionType);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AuthorizationLoggingOptions message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AuthorizationLoggingOptions
                         * @static
                         * @param {google.cloud.compute.v1.AuthorizationLoggingOptions} message AuthorizationLoggingOptions
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AuthorizationLoggingOptions.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.permissionType != null && message.hasOwnProperty("permissionType")) {
                                object.permissionType = message.permissionType;
                                if (options.oneofs)
                                    object._permissionType = "permissionType";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AuthorizationLoggingOptions to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AuthorizationLoggingOptions
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AuthorizationLoggingOptions.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AuthorizationLoggingOptions
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AuthorizationLoggingOptions
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AuthorizationLoggingOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AuthorizationLoggingOptions";
                        };
    
                        /**
                         * PermissionType enum.
                         * @name google.cloud.compute.v1.AuthorizationLoggingOptions.PermissionType
                         * @enum {number}
                         * @property {number} UNDEFINED_PERMISSION_TYPE=0 UNDEFINED_PERMISSION_TYPE value
                         * @property {number} ADMIN_READ=128951462 ADMIN_READ value
                         * @property {number} ADMIN_WRITE=244412079 ADMIN_WRITE value
                         * @property {number} DATA_READ=305224971 DATA_READ value
                         * @property {number} DATA_WRITE=340181738 DATA_WRITE value
                         * @property {number} PERMISSION_TYPE_UNSPECIFIED=440313346 PERMISSION_TYPE_UNSPECIFIED value
                         */
                        AuthorizationLoggingOptions.PermissionType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PERMISSION_TYPE"] = 0;
                            values[valuesById[128951462] = "ADMIN_READ"] = 128951462;
                            values[valuesById[244412079] = "ADMIN_WRITE"] = 244412079;
                            values[valuesById[305224971] = "DATA_READ"] = 305224971;
                            values[valuesById[340181738] = "DATA_WRITE"] = 340181738;
                            values[valuesById[440313346] = "PERMISSION_TYPE_UNSPECIFIED"] = 440313346;
                            return values;
                        })();
    
                        return AuthorizationLoggingOptions;
                    })();
    
                    v1.Autoscaler = (function() {
    
                        /**
                         * Properties of an Autoscaler.
                         * @memberof google.cloud.compute.v1
                         * @interface IAutoscaler
                         * @property {google.cloud.compute.v1.IAutoscalingPolicy|null} [autoscalingPolicy] Autoscaler autoscalingPolicy
                         * @property {string|null} [creationTimestamp] Autoscaler creationTimestamp
                         * @property {string|null} [description] Autoscaler description
                         * @property {number|Long|null} [id] Autoscaler id
                         * @property {string|null} [kind] Autoscaler kind
                         * @property {string|null} [name] Autoscaler name
                         * @property {number|null} [recommendedSize] Autoscaler recommendedSize
                         * @property {string|null} [region] Autoscaler region
                         * @property {Object.<string,google.cloud.compute.v1.IScalingScheduleStatus>|null} [scalingScheduleStatus] Autoscaler scalingScheduleStatus
                         * @property {string|null} [selfLink] Autoscaler selfLink
                         * @property {string|null} [status] Autoscaler status
                         * @property {Array.<google.cloud.compute.v1.IAutoscalerStatusDetails>|null} [statusDetails] Autoscaler statusDetails
                         * @property {string|null} [target] Autoscaler target
                         * @property {string|null} [zone] Autoscaler zone
                         */
    
                        /**
                         * Constructs a new Autoscaler.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an Autoscaler.
                         * @implements IAutoscaler
                         * @constructor
                         * @param {google.cloud.compute.v1.IAutoscaler=} [properties] Properties to set
                         */
                        function Autoscaler(properties) {
                            this.scalingScheduleStatus = {};
                            this.statusDetails = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Autoscaler autoscalingPolicy.
                         * @member {google.cloud.compute.v1.IAutoscalingPolicy|null|undefined} autoscalingPolicy
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Autoscaler.prototype.autoscalingPolicy = null;
    
                        /**
                         * Autoscaler creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Autoscaler.prototype.creationTimestamp = null;
    
                        /**
                         * Autoscaler description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Autoscaler.prototype.description = null;
    
                        /**
                         * Autoscaler id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Autoscaler.prototype.id = null;
    
                        /**
                         * Autoscaler kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Autoscaler.prototype.kind = null;
    
                        /**
                         * Autoscaler name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Autoscaler.prototype.name = null;
    
                        /**
                         * Autoscaler recommendedSize.
                         * @member {number|null|undefined} recommendedSize
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Autoscaler.prototype.recommendedSize = null;
    
                        /**
                         * Autoscaler region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Autoscaler.prototype.region = null;
    
                        /**
                         * Autoscaler scalingScheduleStatus.
                         * @member {Object.<string,google.cloud.compute.v1.IScalingScheduleStatus>} scalingScheduleStatus
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Autoscaler.prototype.scalingScheduleStatus = $util.emptyObject;
    
                        /**
                         * Autoscaler selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Autoscaler.prototype.selfLink = null;
    
                        /**
                         * Autoscaler status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Autoscaler.prototype.status = null;
    
                        /**
                         * Autoscaler statusDetails.
                         * @member {Array.<google.cloud.compute.v1.IAutoscalerStatusDetails>} statusDetails
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Autoscaler.prototype.statusDetails = $util.emptyArray;
    
                        /**
                         * Autoscaler target.
                         * @member {string|null|undefined} target
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Autoscaler.prototype.target = null;
    
                        /**
                         * Autoscaler zone.
                         * @member {string|null|undefined} zone
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Autoscaler.prototype.zone = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Autoscaler _autoscalingPolicy.
                         * @member {"autoscalingPolicy"|undefined} _autoscalingPolicy
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Object.defineProperty(Autoscaler.prototype, "_autoscalingPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["autoscalingPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Autoscaler _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Object.defineProperty(Autoscaler.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Autoscaler _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Object.defineProperty(Autoscaler.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Autoscaler _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Object.defineProperty(Autoscaler.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Autoscaler _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Object.defineProperty(Autoscaler.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Autoscaler _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Object.defineProperty(Autoscaler.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Autoscaler _recommendedSize.
                         * @member {"recommendedSize"|undefined} _recommendedSize
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Object.defineProperty(Autoscaler.prototype, "_recommendedSize", {
                            get: $util.oneOfGetter($oneOfFields = ["recommendedSize"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Autoscaler _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Object.defineProperty(Autoscaler.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Autoscaler _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Object.defineProperty(Autoscaler.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Autoscaler _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Object.defineProperty(Autoscaler.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Autoscaler _target.
                         * @member {"target"|undefined} _target
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Object.defineProperty(Autoscaler.prototype, "_target", {
                            get: $util.oneOfGetter($oneOfFields = ["target"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Autoscaler _zone.
                         * @member {"zone"|undefined} _zone
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         */
                        Object.defineProperty(Autoscaler.prototype, "_zone", {
                            get: $util.oneOfGetter($oneOfFields = ["zone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Autoscaler instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscaler=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Autoscaler} Autoscaler instance
                         */
                        Autoscaler.create = function create(properties) {
                            return new Autoscaler(properties);
                        };
    
                        /**
                         * Encodes the specified Autoscaler message. Does not implicitly {@link google.cloud.compute.v1.Autoscaler.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscaler} message Autoscaler message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Autoscaler.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.target != null && Object.hasOwnProperty.call(message, "target"))
                                writer.uint32(/* id 192835985, wireType 2 =*/1542687882).string(message.target);
                            if (message.autoscalingPolicy != null && Object.hasOwnProperty.call(message, "autoscalingPolicy"))
                                $root.google.cloud.compute.v1.AutoscalingPolicy.encode(message.autoscalingPolicy, writer.uint32(/* id 221950041, wireType 2 =*/1775600330).fork()).ldelim();
                            if (message.recommendedSize != null && Object.hasOwnProperty.call(message, "recommendedSize"))
                                writer.uint32(/* id 257915749, wireType 0 =*/2063325992).int32(message.recommendedSize);
                            if (message.statusDetails != null && message.statusDetails.length)
                                for (var i = 0; i < message.statusDetails.length; ++i)
                                    $root.google.cloud.compute.v1.AutoscalerStatusDetails.encode(message.statusDetails[i], writer.uint32(/* id 363353845, wireType 2 =*/2906830762).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.scalingScheduleStatus != null && Object.hasOwnProperty.call(message, "scalingScheduleStatus"))
                                for (var keys = Object.keys(message.scalingScheduleStatus), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 465950178, wireType 2 =*/3727601426).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.ScalingScheduleStatus.encode(message.scalingScheduleStatus[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Autoscaler message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Autoscaler.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscaler} message Autoscaler message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Autoscaler.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Autoscaler message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Autoscaler} Autoscaler
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Autoscaler.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Autoscaler(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 221950041: {
                                        message.autoscalingPolicy = $root.google.cloud.compute.v1.AutoscalingPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 257915749: {
                                        message.recommendedSize = reader.int32();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 465950178: {
                                        if (message.scalingScheduleStatus === $util.emptyObject)
                                            message.scalingScheduleStatus = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.ScalingScheduleStatus.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.scalingScheduleStatus[key] = value;
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                case 363353845: {
                                        if (!(message.statusDetails && message.statusDetails.length))
                                            message.statusDetails = [];
                                        message.statusDetails.push($root.google.cloud.compute.v1.AutoscalerStatusDetails.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 192835985: {
                                        message.target = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Autoscaler message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Autoscaler} Autoscaler
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Autoscaler.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Autoscaler message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Autoscaler.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoscalingPolicy != null && message.hasOwnProperty("autoscalingPolicy")) {
                                properties._autoscalingPolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.AutoscalingPolicy.verify(message.autoscalingPolicy);
                                    if (error)
                                        return "autoscalingPolicy." + error;
                                }
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.recommendedSize != null && message.hasOwnProperty("recommendedSize")) {
                                properties._recommendedSize = 1;
                                if (!$util.isInteger(message.recommendedSize))
                                    return "recommendedSize: integer expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.scalingScheduleStatus != null && message.hasOwnProperty("scalingScheduleStatus")) {
                                if (!$util.isObject(message.scalingScheduleStatus))
                                    return "scalingScheduleStatus: object expected";
                                var key = Object.keys(message.scalingScheduleStatus);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ScalingScheduleStatus.verify(message.scalingScheduleStatus[key[i]]);
                                    if (error)
                                        return "scalingScheduleStatus." + error;
                                }
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            if (message.statusDetails != null && message.hasOwnProperty("statusDetails")) {
                                if (!Array.isArray(message.statusDetails))
                                    return "statusDetails: array expected";
                                for (var i = 0; i < message.statusDetails.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AutoscalerStatusDetails.verify(message.statusDetails[i]);
                                    if (error)
                                        return "statusDetails." + error;
                                }
                            }
                            if (message.target != null && message.hasOwnProperty("target")) {
                                properties._target = 1;
                                if (!$util.isString(message.target))
                                    return "target: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                properties._zone = 1;
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an Autoscaler message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Autoscaler} Autoscaler
                         */
                        Autoscaler.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Autoscaler)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Autoscaler();
                            if (object.autoscalingPolicy != null) {
                                if (typeof object.autoscalingPolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Autoscaler.autoscalingPolicy: object expected");
                                message.autoscalingPolicy = $root.google.cloud.compute.v1.AutoscalingPolicy.fromObject(object.autoscalingPolicy);
                            }
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.recommendedSize != null)
                                message.recommendedSize = object.recommendedSize | 0;
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.scalingScheduleStatus) {
                                if (typeof object.scalingScheduleStatus !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Autoscaler.scalingScheduleStatus: object expected");
                                message.scalingScheduleStatus = {};
                                for (var keys = Object.keys(object.scalingScheduleStatus), i = 0; i < keys.length; ++i) {
                                    if (typeof object.scalingScheduleStatus[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Autoscaler.scalingScheduleStatus: object expected");
                                    message.scalingScheduleStatus[keys[i]] = $root.google.cloud.compute.v1.ScalingScheduleStatus.fromObject(object.scalingScheduleStatus[keys[i]]);
                                }
                            }
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.status != null)
                                message.status = String(object.status);
                            if (object.statusDetails) {
                                if (!Array.isArray(object.statusDetails))
                                    throw TypeError(".google.cloud.compute.v1.Autoscaler.statusDetails: array expected");
                                message.statusDetails = [];
                                for (var i = 0; i < object.statusDetails.length; ++i) {
                                    if (typeof object.statusDetails[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Autoscaler.statusDetails: object expected");
                                    message.statusDetails[i] = $root.google.cloud.compute.v1.AutoscalerStatusDetails.fromObject(object.statusDetails[i]);
                                }
                            }
                            if (object.target != null)
                                message.target = String(object.target);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Autoscaler message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @static
                         * @param {google.cloud.compute.v1.Autoscaler} message Autoscaler
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Autoscaler.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.statusDetails = [];
                            if (options.objects || options.defaults)
                                object.scalingScheduleStatus = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                object.zone = message.zone;
                                if (options.oneofs)
                                    object._zone = "zone";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.target != null && message.hasOwnProperty("target")) {
                                object.target = message.target;
                                if (options.oneofs)
                                    object._target = "target";
                            }
                            if (message.autoscalingPolicy != null && message.hasOwnProperty("autoscalingPolicy")) {
                                object.autoscalingPolicy = $root.google.cloud.compute.v1.AutoscalingPolicy.toObject(message.autoscalingPolicy, options);
                                if (options.oneofs)
                                    object._autoscalingPolicy = "autoscalingPolicy";
                            }
                            if (message.recommendedSize != null && message.hasOwnProperty("recommendedSize")) {
                                object.recommendedSize = message.recommendedSize;
                                if (options.oneofs)
                                    object._recommendedSize = "recommendedSize";
                            }
                            if (message.statusDetails && message.statusDetails.length) {
                                object.statusDetails = [];
                                for (var j = 0; j < message.statusDetails.length; ++j)
                                    object.statusDetails[j] = $root.google.cloud.compute.v1.AutoscalerStatusDetails.toObject(message.statusDetails[j], options);
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            var keys2;
                            if (message.scalingScheduleStatus && (keys2 = Object.keys(message.scalingScheduleStatus)).length) {
                                object.scalingScheduleStatus = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.scalingScheduleStatus[keys2[j]] = $root.google.cloud.compute.v1.ScalingScheduleStatus.toObject(message.scalingScheduleStatus[keys2[j]], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Autoscaler to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Autoscaler.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Autoscaler
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Autoscaler
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Autoscaler.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Autoscaler";
                        };
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.Autoscaler.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} ACTIVE=314733318 ACTIVE value
                         * @property {number} DELETING=528602024 DELETING value
                         * @property {number} ERROR=66247144 ERROR value
                         * @property {number} PENDING=35394935 PENDING value
                         */
                        Autoscaler.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[314733318] = "ACTIVE"] = 314733318;
                            values[valuesById[528602024] = "DELETING"] = 528602024;
                            values[valuesById[66247144] = "ERROR"] = 66247144;
                            values[valuesById[35394935] = "PENDING"] = 35394935;
                            return values;
                        })();
    
                        return Autoscaler;
                    })();
    
                    v1.AutoscalerAggregatedList = (function() {
    
                        /**
                         * Properties of an AutoscalerAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IAutoscalerAggregatedList
                         * @property {string|null} [id] AutoscalerAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IAutoscalersScopedList>|null} [items] AutoscalerAggregatedList items
                         * @property {string|null} [kind] AutoscalerAggregatedList kind
                         * @property {string|null} [nextPageToken] AutoscalerAggregatedList nextPageToken
                         * @property {string|null} [selfLink] AutoscalerAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] AutoscalerAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] AutoscalerAggregatedList warning
                         */
    
                        /**
                         * Constructs a new AutoscalerAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AutoscalerAggregatedList.
                         * @implements IAutoscalerAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IAutoscalerAggregatedList=} [properties] Properties to set
                         */
                        function AutoscalerAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AutoscalerAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @instance
                         */
                        AutoscalerAggregatedList.prototype.id = null;
    
                        /**
                         * AutoscalerAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IAutoscalersScopedList>} items
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @instance
                         */
                        AutoscalerAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * AutoscalerAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @instance
                         */
                        AutoscalerAggregatedList.prototype.kind = null;
    
                        /**
                         * AutoscalerAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @instance
                         */
                        AutoscalerAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * AutoscalerAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @instance
                         */
                        AutoscalerAggregatedList.prototype.selfLink = null;
    
                        /**
                         * AutoscalerAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @instance
                         */
                        AutoscalerAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * AutoscalerAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @instance
                         */
                        AutoscalerAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AutoscalerAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @instance
                         */
                        Object.defineProperty(AutoscalerAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalerAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @instance
                         */
                        Object.defineProperty(AutoscalerAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalerAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @instance
                         */
                        Object.defineProperty(AutoscalerAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalerAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @instance
                         */
                        Object.defineProperty(AutoscalerAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalerAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @instance
                         */
                        Object.defineProperty(AutoscalerAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AutoscalerAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalerAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AutoscalerAggregatedList} AutoscalerAggregatedList instance
                         */
                        AutoscalerAggregatedList.create = function create(properties) {
                            return new AutoscalerAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified AutoscalerAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.AutoscalerAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalerAggregatedList} message AutoscalerAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AutoscalerAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.AutoscalersScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AutoscalerAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AutoscalerAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalerAggregatedList} message AutoscalerAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AutoscalerAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AutoscalerAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AutoscalerAggregatedList} AutoscalerAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AutoscalerAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AutoscalerAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.AutoscalersScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AutoscalerAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AutoscalerAggregatedList} AutoscalerAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AutoscalerAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AutoscalerAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AutoscalerAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AutoscalersScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AutoscalerAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AutoscalerAggregatedList} AutoscalerAggregatedList
                         */
                        AutoscalerAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AutoscalerAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AutoscalerAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AutoscalerAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.AutoscalerAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.AutoscalersScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.AutoscalerAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AutoscalerAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AutoscalerAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.AutoscalerAggregatedList} message AutoscalerAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AutoscalerAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.AutoscalersScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AutoscalerAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AutoscalerAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AutoscalerAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AutoscalerAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AutoscalerAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AutoscalerAggregatedList";
                        };
    
                        return AutoscalerAggregatedList;
                    })();
    
                    v1.AutoscalerList = (function() {
    
                        /**
                         * Properties of an AutoscalerList.
                         * @memberof google.cloud.compute.v1
                         * @interface IAutoscalerList
                         * @property {string|null} [id] AutoscalerList id
                         * @property {Array.<google.cloud.compute.v1.IAutoscaler>|null} [items] AutoscalerList items
                         * @property {string|null} [kind] AutoscalerList kind
                         * @property {string|null} [nextPageToken] AutoscalerList nextPageToken
                         * @property {string|null} [selfLink] AutoscalerList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] AutoscalerList warning
                         */
    
                        /**
                         * Constructs a new AutoscalerList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AutoscalerList.
                         * @implements IAutoscalerList
                         * @constructor
                         * @param {google.cloud.compute.v1.IAutoscalerList=} [properties] Properties to set
                         */
                        function AutoscalerList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AutoscalerList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @instance
                         */
                        AutoscalerList.prototype.id = null;
    
                        /**
                         * AutoscalerList items.
                         * @member {Array.<google.cloud.compute.v1.IAutoscaler>} items
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @instance
                         */
                        AutoscalerList.prototype.items = $util.emptyArray;
    
                        /**
                         * AutoscalerList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @instance
                         */
                        AutoscalerList.prototype.kind = null;
    
                        /**
                         * AutoscalerList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @instance
                         */
                        AutoscalerList.prototype.nextPageToken = null;
    
                        /**
                         * AutoscalerList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @instance
                         */
                        AutoscalerList.prototype.selfLink = null;
    
                        /**
                         * AutoscalerList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @instance
                         */
                        AutoscalerList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AutoscalerList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @instance
                         */
                        Object.defineProperty(AutoscalerList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalerList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @instance
                         */
                        Object.defineProperty(AutoscalerList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalerList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @instance
                         */
                        Object.defineProperty(AutoscalerList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalerList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @instance
                         */
                        Object.defineProperty(AutoscalerList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalerList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @instance
                         */
                        Object.defineProperty(AutoscalerList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AutoscalerList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalerList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AutoscalerList} AutoscalerList instance
                         */
                        AutoscalerList.create = function create(properties) {
                            return new AutoscalerList(properties);
                        };
    
                        /**
                         * Encodes the specified AutoscalerList message. Does not implicitly {@link google.cloud.compute.v1.AutoscalerList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalerList} message AutoscalerList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AutoscalerList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Autoscaler.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AutoscalerList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AutoscalerList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalerList} message AutoscalerList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AutoscalerList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AutoscalerList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AutoscalerList} AutoscalerList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AutoscalerList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AutoscalerList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Autoscaler.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AutoscalerList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AutoscalerList} AutoscalerList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AutoscalerList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AutoscalerList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AutoscalerList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Autoscaler.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AutoscalerList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AutoscalerList} AutoscalerList
                         */
                        AutoscalerList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AutoscalerList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AutoscalerList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.AutoscalerList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.AutoscalerList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Autoscaler.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AutoscalerList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AutoscalerList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @static
                         * @param {google.cloud.compute.v1.AutoscalerList} message AutoscalerList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AutoscalerList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Autoscaler.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AutoscalerList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AutoscalerList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AutoscalerList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AutoscalerList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AutoscalerList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AutoscalerList";
                        };
    
                        return AutoscalerList;
                    })();
    
                    v1.AutoscalerStatusDetails = (function() {
    
                        /**
                         * Properties of an AutoscalerStatusDetails.
                         * @memberof google.cloud.compute.v1
                         * @interface IAutoscalerStatusDetails
                         * @property {string|null} [message] AutoscalerStatusDetails message
                         * @property {string|null} [type] AutoscalerStatusDetails type
                         */
    
                        /**
                         * Constructs a new AutoscalerStatusDetails.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AutoscalerStatusDetails.
                         * @implements IAutoscalerStatusDetails
                         * @constructor
                         * @param {google.cloud.compute.v1.IAutoscalerStatusDetails=} [properties] Properties to set
                         */
                        function AutoscalerStatusDetails(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AutoscalerStatusDetails message.
                         * @member {string|null|undefined} message
                         * @memberof google.cloud.compute.v1.AutoscalerStatusDetails
                         * @instance
                         */
                        AutoscalerStatusDetails.prototype.message = null;
    
                        /**
                         * AutoscalerStatusDetails type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.AutoscalerStatusDetails
                         * @instance
                         */
                        AutoscalerStatusDetails.prototype.type = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AutoscalerStatusDetails _message.
                         * @member {"message"|undefined} _message
                         * @memberof google.cloud.compute.v1.AutoscalerStatusDetails
                         * @instance
                         */
                        Object.defineProperty(AutoscalerStatusDetails.prototype, "_message", {
                            get: $util.oneOfGetter($oneOfFields = ["message"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalerStatusDetails _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.AutoscalerStatusDetails
                         * @instance
                         */
                        Object.defineProperty(AutoscalerStatusDetails.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AutoscalerStatusDetails instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AutoscalerStatusDetails
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalerStatusDetails=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AutoscalerStatusDetails} AutoscalerStatusDetails instance
                         */
                        AutoscalerStatusDetails.create = function create(properties) {
                            return new AutoscalerStatusDetails(properties);
                        };
    
                        /**
                         * Encodes the specified AutoscalerStatusDetails message. Does not implicitly {@link google.cloud.compute.v1.AutoscalerStatusDetails.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AutoscalerStatusDetails
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalerStatusDetails} message AutoscalerStatusDetails message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AutoscalerStatusDetails.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            if (message.message != null && Object.hasOwnProperty.call(message, "message"))
                                writer.uint32(/* id 418054151, wireType 2 =*/3344433210).string(message.message);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AutoscalerStatusDetails message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AutoscalerStatusDetails.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AutoscalerStatusDetails
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalerStatusDetails} message AutoscalerStatusDetails message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AutoscalerStatusDetails.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AutoscalerStatusDetails message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AutoscalerStatusDetails
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AutoscalerStatusDetails} AutoscalerStatusDetails
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AutoscalerStatusDetails.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AutoscalerStatusDetails();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 418054151: {
                                        message.message = reader.string();
                                        break;
                                    }
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AutoscalerStatusDetails message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AutoscalerStatusDetails
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AutoscalerStatusDetails} AutoscalerStatusDetails
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AutoscalerStatusDetails.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AutoscalerStatusDetails message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AutoscalerStatusDetails
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AutoscalerStatusDetails.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.message != null && message.hasOwnProperty("message")) {
                                properties._message = 1;
                                if (!$util.isString(message.message))
                                    return "message: string expected";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AutoscalerStatusDetails message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AutoscalerStatusDetails
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AutoscalerStatusDetails} AutoscalerStatusDetails
                         */
                        AutoscalerStatusDetails.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AutoscalerStatusDetails)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AutoscalerStatusDetails();
                            if (object.message != null)
                                message.message = String(object.message);
                            if (object.type != null)
                                message.type = String(object.type);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AutoscalerStatusDetails message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AutoscalerStatusDetails
                         * @static
                         * @param {google.cloud.compute.v1.AutoscalerStatusDetails} message AutoscalerStatusDetails
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AutoscalerStatusDetails.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            if (message.message != null && message.hasOwnProperty("message")) {
                                object.message = message.message;
                                if (options.oneofs)
                                    object._message = "message";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AutoscalerStatusDetails to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AutoscalerStatusDetails
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AutoscalerStatusDetails.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AutoscalerStatusDetails
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AutoscalerStatusDetails
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AutoscalerStatusDetails.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AutoscalerStatusDetails";
                        };
    
                        /**
                         * Type enum.
                         * @name google.cloud.compute.v1.AutoscalerStatusDetails.Type
                         * @enum {number}
                         * @property {number} UNDEFINED_TYPE=0 UNDEFINED_TYPE value
                         * @property {number} ALL_INSTANCES_UNHEALTHY=404965477 ALL_INSTANCES_UNHEALTHY value
                         * @property {number} BACKEND_SERVICE_DOES_NOT_EXIST=191417626 BACKEND_SERVICE_DOES_NOT_EXIST value
                         * @property {number} CAPPED_AT_MAX_NUM_REPLICAS=518617 CAPPED_AT_MAX_NUM_REPLICAS value
                         * @property {number} CUSTOM_METRIC_DATA_POINTS_TOO_SPARSE=328964659 CUSTOM_METRIC_DATA_POINTS_TOO_SPARSE value
                         * @property {number} CUSTOM_METRIC_INVALID=204430550 CUSTOM_METRIC_INVALID value
                         * @property {number} MIN_EQUALS_MAX=2821361 MIN_EQUALS_MAX value
                         * @property {number} MISSING_CUSTOM_METRIC_DATA_POINTS=94885086 MISSING_CUSTOM_METRIC_DATA_POINTS value
                         * @property {number} MISSING_LOAD_BALANCING_DATA_POINTS=509858898 MISSING_LOAD_BALANCING_DATA_POINTS value
                         * @property {number} MODE_OFF=164169907 MODE_OFF value
                         * @property {number} MODE_ONLY_SCALE_OUT=3840994 MODE_ONLY_SCALE_OUT value
                         * @property {number} MODE_ONLY_UP=100969842 MODE_ONLY_UP value
                         * @property {number} MORE_THAN_ONE_BACKEND_SERVICE=151922141 MORE_THAN_ONE_BACKEND_SERVICE value
                         * @property {number} NOT_ENOUGH_QUOTA_AVAILABLE=403101631 NOT_ENOUGH_QUOTA_AVAILABLE value
                         * @property {number} REGION_RESOURCE_STOCKOUT=528622846 REGION_RESOURCE_STOCKOUT value
                         * @property {number} SCALING_TARGET_DOES_NOT_EXIST=122636699 SCALING_TARGET_DOES_NOT_EXIST value
                         * @property {number} SCHEDULED_INSTANCES_GREATER_THAN_AUTOSCALER_MAX=29275586 SCHEDULED_INSTANCES_GREATER_THAN_AUTOSCALER_MAX value
                         * @property {number} SCHEDULED_INSTANCES_LESS_THAN_AUTOSCALER_MIN=398287669 SCHEDULED_INSTANCES_LESS_THAN_AUTOSCALER_MIN value
                         * @property {number} UNKNOWN=433141802 UNKNOWN value
                         * @property {number} UNSUPPORTED_MAX_RATE_LOAD_BALANCING_CONFIGURATION=330845009 UNSUPPORTED_MAX_RATE_LOAD_BALANCING_CONFIGURATION value
                         * @property {number} ZONE_RESOURCE_STOCKOUT=210200502 ZONE_RESOURCE_STOCKOUT value
                         */
                        AutoscalerStatusDetails.Type = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TYPE"] = 0;
                            values[valuesById[404965477] = "ALL_INSTANCES_UNHEALTHY"] = 404965477;
                            values[valuesById[191417626] = "BACKEND_SERVICE_DOES_NOT_EXIST"] = 191417626;
                            values[valuesById[518617] = "CAPPED_AT_MAX_NUM_REPLICAS"] = 518617;
                            values[valuesById[328964659] = "CUSTOM_METRIC_DATA_POINTS_TOO_SPARSE"] = 328964659;
                            values[valuesById[204430550] = "CUSTOM_METRIC_INVALID"] = 204430550;
                            values[valuesById[2821361] = "MIN_EQUALS_MAX"] = 2821361;
                            values[valuesById[94885086] = "MISSING_CUSTOM_METRIC_DATA_POINTS"] = 94885086;
                            values[valuesById[509858898] = "MISSING_LOAD_BALANCING_DATA_POINTS"] = 509858898;
                            values[valuesById[164169907] = "MODE_OFF"] = 164169907;
                            values[valuesById[3840994] = "MODE_ONLY_SCALE_OUT"] = 3840994;
                            values[valuesById[100969842] = "MODE_ONLY_UP"] = 100969842;
                            values[valuesById[151922141] = "MORE_THAN_ONE_BACKEND_SERVICE"] = 151922141;
                            values[valuesById[403101631] = "NOT_ENOUGH_QUOTA_AVAILABLE"] = 403101631;
                            values[valuesById[528622846] = "REGION_RESOURCE_STOCKOUT"] = 528622846;
                            values[valuesById[122636699] = "SCALING_TARGET_DOES_NOT_EXIST"] = 122636699;
                            values[valuesById[29275586] = "SCHEDULED_INSTANCES_GREATER_THAN_AUTOSCALER_MAX"] = 29275586;
                            values[valuesById[398287669] = "SCHEDULED_INSTANCES_LESS_THAN_AUTOSCALER_MIN"] = 398287669;
                            values[valuesById[433141802] = "UNKNOWN"] = 433141802;
                            values[valuesById[330845009] = "UNSUPPORTED_MAX_RATE_LOAD_BALANCING_CONFIGURATION"] = 330845009;
                            values[valuesById[210200502] = "ZONE_RESOURCE_STOCKOUT"] = 210200502;
                            return values;
                        })();
    
                        return AutoscalerStatusDetails;
                    })();
    
                    v1.AutoscalersScopedList = (function() {
    
                        /**
                         * Properties of an AutoscalersScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IAutoscalersScopedList
                         * @property {Array.<google.cloud.compute.v1.IAutoscaler>|null} [autoscalers] AutoscalersScopedList autoscalers
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] AutoscalersScopedList warning
                         */
    
                        /**
                         * Constructs a new AutoscalersScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AutoscalersScopedList.
                         * @implements IAutoscalersScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IAutoscalersScopedList=} [properties] Properties to set
                         */
                        function AutoscalersScopedList(properties) {
                            this.autoscalers = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AutoscalersScopedList autoscalers.
                         * @member {Array.<google.cloud.compute.v1.IAutoscaler>} autoscalers
                         * @memberof google.cloud.compute.v1.AutoscalersScopedList
                         * @instance
                         */
                        AutoscalersScopedList.prototype.autoscalers = $util.emptyArray;
    
                        /**
                         * AutoscalersScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.AutoscalersScopedList
                         * @instance
                         */
                        AutoscalersScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AutoscalersScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.AutoscalersScopedList
                         * @instance
                         */
                        Object.defineProperty(AutoscalersScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AutoscalersScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AutoscalersScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalersScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AutoscalersScopedList} AutoscalersScopedList instance
                         */
                        AutoscalersScopedList.create = function create(properties) {
                            return new AutoscalersScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified AutoscalersScopedList message. Does not implicitly {@link google.cloud.compute.v1.AutoscalersScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AutoscalersScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalersScopedList} message AutoscalersScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AutoscalersScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.autoscalers != null && message.autoscalers.length)
                                for (var i = 0; i < message.autoscalers.length; ++i)
                                    $root.google.cloud.compute.v1.Autoscaler.encode(message.autoscalers[i], writer.uint32(/* id 465771644, wireType 2 =*/3726173154).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AutoscalersScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AutoscalersScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AutoscalersScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalersScopedList} message AutoscalersScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AutoscalersScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AutoscalersScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AutoscalersScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AutoscalersScopedList} AutoscalersScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AutoscalersScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AutoscalersScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 465771644: {
                                        if (!(message.autoscalers && message.autoscalers.length))
                                            message.autoscalers = [];
                                        message.autoscalers.push($root.google.cloud.compute.v1.Autoscaler.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AutoscalersScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AutoscalersScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AutoscalersScopedList} AutoscalersScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AutoscalersScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AutoscalersScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AutoscalersScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AutoscalersScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoscalers != null && message.hasOwnProperty("autoscalers")) {
                                if (!Array.isArray(message.autoscalers))
                                    return "autoscalers: array expected";
                                for (var i = 0; i < message.autoscalers.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Autoscaler.verify(message.autoscalers[i]);
                                    if (error)
                                        return "autoscalers." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AutoscalersScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AutoscalersScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AutoscalersScopedList} AutoscalersScopedList
                         */
                        AutoscalersScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AutoscalersScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AutoscalersScopedList();
                            if (object.autoscalers) {
                                if (!Array.isArray(object.autoscalers))
                                    throw TypeError(".google.cloud.compute.v1.AutoscalersScopedList.autoscalers: array expected");
                                message.autoscalers = [];
                                for (var i = 0; i < object.autoscalers.length; ++i) {
                                    if (typeof object.autoscalers[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.AutoscalersScopedList.autoscalers: object expected");
                                    message.autoscalers[i] = $root.google.cloud.compute.v1.Autoscaler.fromObject(object.autoscalers[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AutoscalersScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AutoscalersScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AutoscalersScopedList
                         * @static
                         * @param {google.cloud.compute.v1.AutoscalersScopedList} message AutoscalersScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AutoscalersScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.autoscalers = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.autoscalers && message.autoscalers.length) {
                                object.autoscalers = [];
                                for (var j = 0; j < message.autoscalers.length; ++j)
                                    object.autoscalers[j] = $root.google.cloud.compute.v1.Autoscaler.toObject(message.autoscalers[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AutoscalersScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AutoscalersScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AutoscalersScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AutoscalersScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AutoscalersScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AutoscalersScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AutoscalersScopedList";
                        };
    
                        return AutoscalersScopedList;
                    })();
    
                    v1.AutoscalingPolicy = (function() {
    
                        /**
                         * Properties of an AutoscalingPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IAutoscalingPolicy
                         * @property {number|null} [coolDownPeriodSec] AutoscalingPolicy coolDownPeriodSec
                         * @property {google.cloud.compute.v1.IAutoscalingPolicyCpuUtilization|null} [cpuUtilization] AutoscalingPolicy cpuUtilization
                         * @property {Array.<google.cloud.compute.v1.IAutoscalingPolicyCustomMetricUtilization>|null} [customMetricUtilizations] AutoscalingPolicy customMetricUtilizations
                         * @property {google.cloud.compute.v1.IAutoscalingPolicyLoadBalancingUtilization|null} [loadBalancingUtilization] AutoscalingPolicy loadBalancingUtilization
                         * @property {number|null} [maxNumReplicas] AutoscalingPolicy maxNumReplicas
                         * @property {number|null} [minNumReplicas] AutoscalingPolicy minNumReplicas
                         * @property {string|null} [mode] AutoscalingPolicy mode
                         * @property {google.cloud.compute.v1.IAutoscalingPolicyScaleInControl|null} [scaleInControl] AutoscalingPolicy scaleInControl
                         * @property {Object.<string,google.cloud.compute.v1.IAutoscalingPolicyScalingSchedule>|null} [scalingSchedules] AutoscalingPolicy scalingSchedules
                         */
    
                        /**
                         * Constructs a new AutoscalingPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AutoscalingPolicy.
                         * @implements IAutoscalingPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IAutoscalingPolicy=} [properties] Properties to set
                         */
                        function AutoscalingPolicy(properties) {
                            this.customMetricUtilizations = [];
                            this.scalingSchedules = {};
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AutoscalingPolicy coolDownPeriodSec.
                         * @member {number|null|undefined} coolDownPeriodSec
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @instance
                         */
                        AutoscalingPolicy.prototype.coolDownPeriodSec = null;
    
                        /**
                         * AutoscalingPolicy cpuUtilization.
                         * @member {google.cloud.compute.v1.IAutoscalingPolicyCpuUtilization|null|undefined} cpuUtilization
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @instance
                         */
                        AutoscalingPolicy.prototype.cpuUtilization = null;
    
                        /**
                         * AutoscalingPolicy customMetricUtilizations.
                         * @member {Array.<google.cloud.compute.v1.IAutoscalingPolicyCustomMetricUtilization>} customMetricUtilizations
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @instance
                         */
                        AutoscalingPolicy.prototype.customMetricUtilizations = $util.emptyArray;
    
                        /**
                         * AutoscalingPolicy loadBalancingUtilization.
                         * @member {google.cloud.compute.v1.IAutoscalingPolicyLoadBalancingUtilization|null|undefined} loadBalancingUtilization
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @instance
                         */
                        AutoscalingPolicy.prototype.loadBalancingUtilization = null;
    
                        /**
                         * AutoscalingPolicy maxNumReplicas.
                         * @member {number|null|undefined} maxNumReplicas
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @instance
                         */
                        AutoscalingPolicy.prototype.maxNumReplicas = null;
    
                        /**
                         * AutoscalingPolicy minNumReplicas.
                         * @member {number|null|undefined} minNumReplicas
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @instance
                         */
                        AutoscalingPolicy.prototype.minNumReplicas = null;
    
                        /**
                         * AutoscalingPolicy mode.
                         * @member {string|null|undefined} mode
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @instance
                         */
                        AutoscalingPolicy.prototype.mode = null;
    
                        /**
                         * AutoscalingPolicy scaleInControl.
                         * @member {google.cloud.compute.v1.IAutoscalingPolicyScaleInControl|null|undefined} scaleInControl
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @instance
                         */
                        AutoscalingPolicy.prototype.scaleInControl = null;
    
                        /**
                         * AutoscalingPolicy scalingSchedules.
                         * @member {Object.<string,google.cloud.compute.v1.IAutoscalingPolicyScalingSchedule>} scalingSchedules
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @instance
                         */
                        AutoscalingPolicy.prototype.scalingSchedules = $util.emptyObject;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AutoscalingPolicy _coolDownPeriodSec.
                         * @member {"coolDownPeriodSec"|undefined} _coolDownPeriodSec
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicy.prototype, "_coolDownPeriodSec", {
                            get: $util.oneOfGetter($oneOfFields = ["coolDownPeriodSec"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalingPolicy _cpuUtilization.
                         * @member {"cpuUtilization"|undefined} _cpuUtilization
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicy.prototype, "_cpuUtilization", {
                            get: $util.oneOfGetter($oneOfFields = ["cpuUtilization"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalingPolicy _loadBalancingUtilization.
                         * @member {"loadBalancingUtilization"|undefined} _loadBalancingUtilization
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicy.prototype, "_loadBalancingUtilization", {
                            get: $util.oneOfGetter($oneOfFields = ["loadBalancingUtilization"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalingPolicy _maxNumReplicas.
                         * @member {"maxNumReplicas"|undefined} _maxNumReplicas
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicy.prototype, "_maxNumReplicas", {
                            get: $util.oneOfGetter($oneOfFields = ["maxNumReplicas"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalingPolicy _minNumReplicas.
                         * @member {"minNumReplicas"|undefined} _minNumReplicas
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicy.prototype, "_minNumReplicas", {
                            get: $util.oneOfGetter($oneOfFields = ["minNumReplicas"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalingPolicy _mode.
                         * @member {"mode"|undefined} _mode
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicy.prototype, "_mode", {
                            get: $util.oneOfGetter($oneOfFields = ["mode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalingPolicy _scaleInControl.
                         * @member {"scaleInControl"|undefined} _scaleInControl
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicy.prototype, "_scaleInControl", {
                            get: $util.oneOfGetter($oneOfFields = ["scaleInControl"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AutoscalingPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalingPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AutoscalingPolicy} AutoscalingPolicy instance
                         */
                        AutoscalingPolicy.create = function create(properties) {
                            return new AutoscalingPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified AutoscalingPolicy message. Does not implicitly {@link google.cloud.compute.v1.AutoscalingPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalingPolicy} message AutoscalingPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AutoscalingPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.mode != null && Object.hasOwnProperty.call(message, "mode"))
                                writer.uint32(/* id 3357091, wireType 2 =*/26856730).string(message.mode);
                            if (message.maxNumReplicas != null && Object.hasOwnProperty.call(message, "maxNumReplicas"))
                                writer.uint32(/* id 62327375, wireType 0 =*/498619000).int32(message.maxNumReplicas);
                            if (message.coolDownPeriodSec != null && Object.hasOwnProperty.call(message, "coolDownPeriodSec"))
                                writer.uint32(/* id 107692954, wireType 0 =*/861543632).int32(message.coolDownPeriodSec);
                            if (message.customMetricUtilizations != null && message.customMetricUtilizations.length)
                                for (var i = 0; i < message.customMetricUtilizations.length; ++i)
                                    $root.google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization.encode(message.customMetricUtilizations[i], writer.uint32(/* id 131972850, wireType 2 =*/1055782802).fork()).ldelim();
                            if (message.scalingSchedules != null && Object.hasOwnProperty.call(message, "scalingSchedules"))
                                for (var keys = Object.keys(message.scalingSchedules), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 355416580, wireType 2 =*/2843332642).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.AutoscalingPolicyScalingSchedule.encode(message.scalingSchedules[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.cpuUtilization != null && Object.hasOwnProperty.call(message, "cpuUtilization"))
                                $root.google.cloud.compute.v1.AutoscalingPolicyCpuUtilization.encode(message.cpuUtilization, writer.uint32(/* id 381211147, wireType 2 =*/3049689178).fork()).ldelim();
                            if (message.loadBalancingUtilization != null && Object.hasOwnProperty.call(message, "loadBalancingUtilization"))
                                $root.google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization.encode(message.loadBalancingUtilization, writer.uint32(/* id 429746403, wireType 2 =*/3437971226).fork()).ldelim();
                            if (message.scaleInControl != null && Object.hasOwnProperty.call(message, "scaleInControl"))
                                $root.google.cloud.compute.v1.AutoscalingPolicyScaleInControl.encode(message.scaleInControl, writer.uint32(/* id 527670872, wireType 2 =*/4221366978).fork()).ldelim();
                            if (message.minNumReplicas != null && Object.hasOwnProperty.call(message, "minNumReplicas"))
                                writer.uint32(/* id 535329825, wireType 0 =*/4282638600).int32(message.minNumReplicas);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AutoscalingPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AutoscalingPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalingPolicy} message AutoscalingPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AutoscalingPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AutoscalingPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AutoscalingPolicy} AutoscalingPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AutoscalingPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AutoscalingPolicy(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 107692954: {
                                        message.coolDownPeriodSec = reader.int32();
                                        break;
                                    }
                                case 381211147: {
                                        message.cpuUtilization = $root.google.cloud.compute.v1.AutoscalingPolicyCpuUtilization.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 131972850: {
                                        if (!(message.customMetricUtilizations && message.customMetricUtilizations.length))
                                            message.customMetricUtilizations = [];
                                        message.customMetricUtilizations.push($root.google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 429746403: {
                                        message.loadBalancingUtilization = $root.google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 62327375: {
                                        message.maxNumReplicas = reader.int32();
                                        break;
                                    }
                                case 535329825: {
                                        message.minNumReplicas = reader.int32();
                                        break;
                                    }
                                case 3357091: {
                                        message.mode = reader.string();
                                        break;
                                    }
                                case 527670872: {
                                        message.scaleInControl = $root.google.cloud.compute.v1.AutoscalingPolicyScaleInControl.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 355416580: {
                                        if (message.scalingSchedules === $util.emptyObject)
                                            message.scalingSchedules = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.AutoscalingPolicyScalingSchedule.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.scalingSchedules[key] = value;
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AutoscalingPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AutoscalingPolicy} AutoscalingPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AutoscalingPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AutoscalingPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AutoscalingPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.coolDownPeriodSec != null && message.hasOwnProperty("coolDownPeriodSec")) {
                                properties._coolDownPeriodSec = 1;
                                if (!$util.isInteger(message.coolDownPeriodSec))
                                    return "coolDownPeriodSec: integer expected";
                            }
                            if (message.cpuUtilization != null && message.hasOwnProperty("cpuUtilization")) {
                                properties._cpuUtilization = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.AutoscalingPolicyCpuUtilization.verify(message.cpuUtilization);
                                    if (error)
                                        return "cpuUtilization." + error;
                                }
                            }
                            if (message.customMetricUtilizations != null && message.hasOwnProperty("customMetricUtilizations")) {
                                if (!Array.isArray(message.customMetricUtilizations))
                                    return "customMetricUtilizations: array expected";
                                for (var i = 0; i < message.customMetricUtilizations.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization.verify(message.customMetricUtilizations[i]);
                                    if (error)
                                        return "customMetricUtilizations." + error;
                                }
                            }
                            if (message.loadBalancingUtilization != null && message.hasOwnProperty("loadBalancingUtilization")) {
                                properties._loadBalancingUtilization = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization.verify(message.loadBalancingUtilization);
                                    if (error)
                                        return "loadBalancingUtilization." + error;
                                }
                            }
                            if (message.maxNumReplicas != null && message.hasOwnProperty("maxNumReplicas")) {
                                properties._maxNumReplicas = 1;
                                if (!$util.isInteger(message.maxNumReplicas))
                                    return "maxNumReplicas: integer expected";
                            }
                            if (message.minNumReplicas != null && message.hasOwnProperty("minNumReplicas")) {
                                properties._minNumReplicas = 1;
                                if (!$util.isInteger(message.minNumReplicas))
                                    return "minNumReplicas: integer expected";
                            }
                            if (message.mode != null && message.hasOwnProperty("mode")) {
                                properties._mode = 1;
                                if (!$util.isString(message.mode))
                                    return "mode: string expected";
                            }
                            if (message.scaleInControl != null && message.hasOwnProperty("scaleInControl")) {
                                properties._scaleInControl = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.AutoscalingPolicyScaleInControl.verify(message.scaleInControl);
                                    if (error)
                                        return "scaleInControl." + error;
                                }
                            }
                            if (message.scalingSchedules != null && message.hasOwnProperty("scalingSchedules")) {
                                if (!$util.isObject(message.scalingSchedules))
                                    return "scalingSchedules: object expected";
                                var key = Object.keys(message.scalingSchedules);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AutoscalingPolicyScalingSchedule.verify(message.scalingSchedules[key[i]]);
                                    if (error)
                                        return "scalingSchedules." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AutoscalingPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AutoscalingPolicy} AutoscalingPolicy
                         */
                        AutoscalingPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AutoscalingPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AutoscalingPolicy();
                            if (object.coolDownPeriodSec != null)
                                message.coolDownPeriodSec = object.coolDownPeriodSec | 0;
                            if (object.cpuUtilization != null) {
                                if (typeof object.cpuUtilization !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AutoscalingPolicy.cpuUtilization: object expected");
                                message.cpuUtilization = $root.google.cloud.compute.v1.AutoscalingPolicyCpuUtilization.fromObject(object.cpuUtilization);
                            }
                            if (object.customMetricUtilizations) {
                                if (!Array.isArray(object.customMetricUtilizations))
                                    throw TypeError(".google.cloud.compute.v1.AutoscalingPolicy.customMetricUtilizations: array expected");
                                message.customMetricUtilizations = [];
                                for (var i = 0; i < object.customMetricUtilizations.length; ++i) {
                                    if (typeof object.customMetricUtilizations[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.AutoscalingPolicy.customMetricUtilizations: object expected");
                                    message.customMetricUtilizations[i] = $root.google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization.fromObject(object.customMetricUtilizations[i]);
                                }
                            }
                            if (object.loadBalancingUtilization != null) {
                                if (typeof object.loadBalancingUtilization !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AutoscalingPolicy.loadBalancingUtilization: object expected");
                                message.loadBalancingUtilization = $root.google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization.fromObject(object.loadBalancingUtilization);
                            }
                            if (object.maxNumReplicas != null)
                                message.maxNumReplicas = object.maxNumReplicas | 0;
                            if (object.minNumReplicas != null)
                                message.minNumReplicas = object.minNumReplicas | 0;
                            if (object.mode != null)
                                message.mode = String(object.mode);
                            if (object.scaleInControl != null) {
                                if (typeof object.scaleInControl !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AutoscalingPolicy.scaleInControl: object expected");
                                message.scaleInControl = $root.google.cloud.compute.v1.AutoscalingPolicyScaleInControl.fromObject(object.scaleInControl);
                            }
                            if (object.scalingSchedules) {
                                if (typeof object.scalingSchedules !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AutoscalingPolicy.scalingSchedules: object expected");
                                message.scalingSchedules = {};
                                for (var keys = Object.keys(object.scalingSchedules), i = 0; i < keys.length; ++i) {
                                    if (typeof object.scalingSchedules[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.AutoscalingPolicy.scalingSchedules: object expected");
                                    message.scalingSchedules[keys[i]] = $root.google.cloud.compute.v1.AutoscalingPolicyScalingSchedule.fromObject(object.scalingSchedules[keys[i]]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AutoscalingPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.AutoscalingPolicy} message AutoscalingPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AutoscalingPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.customMetricUtilizations = [];
                            if (options.objects || options.defaults)
                                object.scalingSchedules = {};
                            if (message.mode != null && message.hasOwnProperty("mode")) {
                                object.mode = message.mode;
                                if (options.oneofs)
                                    object._mode = "mode";
                            }
                            if (message.maxNumReplicas != null && message.hasOwnProperty("maxNumReplicas")) {
                                object.maxNumReplicas = message.maxNumReplicas;
                                if (options.oneofs)
                                    object._maxNumReplicas = "maxNumReplicas";
                            }
                            if (message.coolDownPeriodSec != null && message.hasOwnProperty("coolDownPeriodSec")) {
                                object.coolDownPeriodSec = message.coolDownPeriodSec;
                                if (options.oneofs)
                                    object._coolDownPeriodSec = "coolDownPeriodSec";
                            }
                            if (message.customMetricUtilizations && message.customMetricUtilizations.length) {
                                object.customMetricUtilizations = [];
                                for (var j = 0; j < message.customMetricUtilizations.length; ++j)
                                    object.customMetricUtilizations[j] = $root.google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization.toObject(message.customMetricUtilizations[j], options);
                            }
                            var keys2;
                            if (message.scalingSchedules && (keys2 = Object.keys(message.scalingSchedules)).length) {
                                object.scalingSchedules = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.scalingSchedules[keys2[j]] = $root.google.cloud.compute.v1.AutoscalingPolicyScalingSchedule.toObject(message.scalingSchedules[keys2[j]], options);
                            }
                            if (message.cpuUtilization != null && message.hasOwnProperty("cpuUtilization")) {
                                object.cpuUtilization = $root.google.cloud.compute.v1.AutoscalingPolicyCpuUtilization.toObject(message.cpuUtilization, options);
                                if (options.oneofs)
                                    object._cpuUtilization = "cpuUtilization";
                            }
                            if (message.loadBalancingUtilization != null && message.hasOwnProperty("loadBalancingUtilization")) {
                                object.loadBalancingUtilization = $root.google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization.toObject(message.loadBalancingUtilization, options);
                                if (options.oneofs)
                                    object._loadBalancingUtilization = "loadBalancingUtilization";
                            }
                            if (message.scaleInControl != null && message.hasOwnProperty("scaleInControl")) {
                                object.scaleInControl = $root.google.cloud.compute.v1.AutoscalingPolicyScaleInControl.toObject(message.scaleInControl, options);
                                if (options.oneofs)
                                    object._scaleInControl = "scaleInControl";
                            }
                            if (message.minNumReplicas != null && message.hasOwnProperty("minNumReplicas")) {
                                object.minNumReplicas = message.minNumReplicas;
                                if (options.oneofs)
                                    object._minNumReplicas = "minNumReplicas";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AutoscalingPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AutoscalingPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AutoscalingPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AutoscalingPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AutoscalingPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AutoscalingPolicy";
                        };
    
                        /**
                         * Mode enum.
                         * @name google.cloud.compute.v1.AutoscalingPolicy.Mode
                         * @enum {number}
                         * @property {number} UNDEFINED_MODE=0 UNDEFINED_MODE value
                         * @property {number} OFF=78159 OFF value
                         * @property {number} ON=2527 ON value
                         * @property {number} ONLY_SCALE_OUT=152713670 ONLY_SCALE_OUT value
                         * @property {number} ONLY_UP=478095374 ONLY_UP value
                         */
                        AutoscalingPolicy.Mode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_MODE"] = 0;
                            values[valuesById[78159] = "OFF"] = 78159;
                            values[valuesById[2527] = "ON"] = 2527;
                            values[valuesById[152713670] = "ONLY_SCALE_OUT"] = 152713670;
                            values[valuesById[478095374] = "ONLY_UP"] = 478095374;
                            return values;
                        })();
    
                        return AutoscalingPolicy;
                    })();
    
                    v1.AutoscalingPolicyCpuUtilization = (function() {
    
                        /**
                         * Properties of an AutoscalingPolicyCpuUtilization.
                         * @memberof google.cloud.compute.v1
                         * @interface IAutoscalingPolicyCpuUtilization
                         * @property {string|null} [predictiveMethod] AutoscalingPolicyCpuUtilization predictiveMethod
                         * @property {number|null} [utilizationTarget] AutoscalingPolicyCpuUtilization utilizationTarget
                         */
    
                        /**
                         * Constructs a new AutoscalingPolicyCpuUtilization.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AutoscalingPolicyCpuUtilization.
                         * @implements IAutoscalingPolicyCpuUtilization
                         * @constructor
                         * @param {google.cloud.compute.v1.IAutoscalingPolicyCpuUtilization=} [properties] Properties to set
                         */
                        function AutoscalingPolicyCpuUtilization(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AutoscalingPolicyCpuUtilization predictiveMethod.
                         * @member {string|null|undefined} predictiveMethod
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCpuUtilization
                         * @instance
                         */
                        AutoscalingPolicyCpuUtilization.prototype.predictiveMethod = null;
    
                        /**
                         * AutoscalingPolicyCpuUtilization utilizationTarget.
                         * @member {number|null|undefined} utilizationTarget
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCpuUtilization
                         * @instance
                         */
                        AutoscalingPolicyCpuUtilization.prototype.utilizationTarget = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AutoscalingPolicyCpuUtilization _predictiveMethod.
                         * @member {"predictiveMethod"|undefined} _predictiveMethod
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCpuUtilization
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicyCpuUtilization.prototype, "_predictiveMethod", {
                            get: $util.oneOfGetter($oneOfFields = ["predictiveMethod"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalingPolicyCpuUtilization _utilizationTarget.
                         * @member {"utilizationTarget"|undefined} _utilizationTarget
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCpuUtilization
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicyCpuUtilization.prototype, "_utilizationTarget", {
                            get: $util.oneOfGetter($oneOfFields = ["utilizationTarget"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AutoscalingPolicyCpuUtilization instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCpuUtilization
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalingPolicyCpuUtilization=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AutoscalingPolicyCpuUtilization} AutoscalingPolicyCpuUtilization instance
                         */
                        AutoscalingPolicyCpuUtilization.create = function create(properties) {
                            return new AutoscalingPolicyCpuUtilization(properties);
                        };
    
                        /**
                         * Encodes the specified AutoscalingPolicyCpuUtilization message. Does not implicitly {@link google.cloud.compute.v1.AutoscalingPolicyCpuUtilization.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCpuUtilization
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalingPolicyCpuUtilization} message AutoscalingPolicyCpuUtilization message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AutoscalingPolicyCpuUtilization.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.utilizationTarget != null && Object.hasOwnProperty.call(message, "utilizationTarget"))
                                writer.uint32(/* id 215905870, wireType 1 =*/1727246961).double(message.utilizationTarget);
                            if (message.predictiveMethod != null && Object.hasOwnProperty.call(message, "predictiveMethod"))
                                writer.uint32(/* id 390220737, wireType 2 =*/3121765898).string(message.predictiveMethod);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AutoscalingPolicyCpuUtilization message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AutoscalingPolicyCpuUtilization.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCpuUtilization
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalingPolicyCpuUtilization} message AutoscalingPolicyCpuUtilization message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AutoscalingPolicyCpuUtilization.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AutoscalingPolicyCpuUtilization message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCpuUtilization
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AutoscalingPolicyCpuUtilization} AutoscalingPolicyCpuUtilization
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AutoscalingPolicyCpuUtilization.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AutoscalingPolicyCpuUtilization();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 390220737: {
                                        message.predictiveMethod = reader.string();
                                        break;
                                    }
                                case 215905870: {
                                        message.utilizationTarget = reader.double();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AutoscalingPolicyCpuUtilization message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCpuUtilization
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AutoscalingPolicyCpuUtilization} AutoscalingPolicyCpuUtilization
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AutoscalingPolicyCpuUtilization.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AutoscalingPolicyCpuUtilization message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCpuUtilization
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AutoscalingPolicyCpuUtilization.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.predictiveMethod != null && message.hasOwnProperty("predictiveMethod")) {
                                properties._predictiveMethod = 1;
                                if (!$util.isString(message.predictiveMethod))
                                    return "predictiveMethod: string expected";
                            }
                            if (message.utilizationTarget != null && message.hasOwnProperty("utilizationTarget")) {
                                properties._utilizationTarget = 1;
                                if (typeof message.utilizationTarget !== "number")
                                    return "utilizationTarget: number expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AutoscalingPolicyCpuUtilization message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCpuUtilization
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AutoscalingPolicyCpuUtilization} AutoscalingPolicyCpuUtilization
                         */
                        AutoscalingPolicyCpuUtilization.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AutoscalingPolicyCpuUtilization)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AutoscalingPolicyCpuUtilization();
                            if (object.predictiveMethod != null)
                                message.predictiveMethod = String(object.predictiveMethod);
                            if (object.utilizationTarget != null)
                                message.utilizationTarget = Number(object.utilizationTarget);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AutoscalingPolicyCpuUtilization message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCpuUtilization
                         * @static
                         * @param {google.cloud.compute.v1.AutoscalingPolicyCpuUtilization} message AutoscalingPolicyCpuUtilization
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AutoscalingPolicyCpuUtilization.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.utilizationTarget != null && message.hasOwnProperty("utilizationTarget")) {
                                object.utilizationTarget = options.json && !isFinite(message.utilizationTarget) ? String(message.utilizationTarget) : message.utilizationTarget;
                                if (options.oneofs)
                                    object._utilizationTarget = "utilizationTarget";
                            }
                            if (message.predictiveMethod != null && message.hasOwnProperty("predictiveMethod")) {
                                object.predictiveMethod = message.predictiveMethod;
                                if (options.oneofs)
                                    object._predictiveMethod = "predictiveMethod";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AutoscalingPolicyCpuUtilization to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCpuUtilization
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AutoscalingPolicyCpuUtilization.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AutoscalingPolicyCpuUtilization
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCpuUtilization
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AutoscalingPolicyCpuUtilization.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AutoscalingPolicyCpuUtilization";
                        };
    
                        /**
                         * PredictiveMethod enum.
                         * @name google.cloud.compute.v1.AutoscalingPolicyCpuUtilization.PredictiveMethod
                         * @enum {number}
                         * @property {number} UNDEFINED_PREDICTIVE_METHOD=0 UNDEFINED_PREDICTIVE_METHOD value
                         * @property {number} NONE=2402104 NONE value
                         * @property {number} OPTIMIZE_AVAILABILITY=11629437 OPTIMIZE_AVAILABILITY value
                         */
                        AutoscalingPolicyCpuUtilization.PredictiveMethod = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PREDICTIVE_METHOD"] = 0;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            values[valuesById[11629437] = "OPTIMIZE_AVAILABILITY"] = 11629437;
                            return values;
                        })();
    
                        return AutoscalingPolicyCpuUtilization;
                    })();
    
                    v1.AutoscalingPolicyCustomMetricUtilization = (function() {
    
                        /**
                         * Properties of an AutoscalingPolicyCustomMetricUtilization.
                         * @memberof google.cloud.compute.v1
                         * @interface IAutoscalingPolicyCustomMetricUtilization
                         * @property {string|null} [filter] AutoscalingPolicyCustomMetricUtilization filter
                         * @property {string|null} [metric] AutoscalingPolicyCustomMetricUtilization metric
                         * @property {number|null} [singleInstanceAssignment] AutoscalingPolicyCustomMetricUtilization singleInstanceAssignment
                         * @property {number|null} [utilizationTarget] AutoscalingPolicyCustomMetricUtilization utilizationTarget
                         * @property {string|null} [utilizationTargetType] AutoscalingPolicyCustomMetricUtilization utilizationTargetType
                         */
    
                        /**
                         * Constructs a new AutoscalingPolicyCustomMetricUtilization.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AutoscalingPolicyCustomMetricUtilization.
                         * @implements IAutoscalingPolicyCustomMetricUtilization
                         * @constructor
                         * @param {google.cloud.compute.v1.IAutoscalingPolicyCustomMetricUtilization=} [properties] Properties to set
                         */
                        function AutoscalingPolicyCustomMetricUtilization(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AutoscalingPolicyCustomMetricUtilization filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization
                         * @instance
                         */
                        AutoscalingPolicyCustomMetricUtilization.prototype.filter = null;
    
                        /**
                         * AutoscalingPolicyCustomMetricUtilization metric.
                         * @member {string|null|undefined} metric
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization
                         * @instance
                         */
                        AutoscalingPolicyCustomMetricUtilization.prototype.metric = null;
    
                        /**
                         * AutoscalingPolicyCustomMetricUtilization singleInstanceAssignment.
                         * @member {number|null|undefined} singleInstanceAssignment
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization
                         * @instance
                         */
                        AutoscalingPolicyCustomMetricUtilization.prototype.singleInstanceAssignment = null;
    
                        /**
                         * AutoscalingPolicyCustomMetricUtilization utilizationTarget.
                         * @member {number|null|undefined} utilizationTarget
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization
                         * @instance
                         */
                        AutoscalingPolicyCustomMetricUtilization.prototype.utilizationTarget = null;
    
                        /**
                         * AutoscalingPolicyCustomMetricUtilization utilizationTargetType.
                         * @member {string|null|undefined} utilizationTargetType
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization
                         * @instance
                         */
                        AutoscalingPolicyCustomMetricUtilization.prototype.utilizationTargetType = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AutoscalingPolicyCustomMetricUtilization _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicyCustomMetricUtilization.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalingPolicyCustomMetricUtilization _metric.
                         * @member {"metric"|undefined} _metric
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicyCustomMetricUtilization.prototype, "_metric", {
                            get: $util.oneOfGetter($oneOfFields = ["metric"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalingPolicyCustomMetricUtilization _singleInstanceAssignment.
                         * @member {"singleInstanceAssignment"|undefined} _singleInstanceAssignment
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicyCustomMetricUtilization.prototype, "_singleInstanceAssignment", {
                            get: $util.oneOfGetter($oneOfFields = ["singleInstanceAssignment"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalingPolicyCustomMetricUtilization _utilizationTarget.
                         * @member {"utilizationTarget"|undefined} _utilizationTarget
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicyCustomMetricUtilization.prototype, "_utilizationTarget", {
                            get: $util.oneOfGetter($oneOfFields = ["utilizationTarget"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalingPolicyCustomMetricUtilization _utilizationTargetType.
                         * @member {"utilizationTargetType"|undefined} _utilizationTargetType
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicyCustomMetricUtilization.prototype, "_utilizationTargetType", {
                            get: $util.oneOfGetter($oneOfFields = ["utilizationTargetType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AutoscalingPolicyCustomMetricUtilization instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalingPolicyCustomMetricUtilization=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization} AutoscalingPolicyCustomMetricUtilization instance
                         */
                        AutoscalingPolicyCustomMetricUtilization.create = function create(properties) {
                            return new AutoscalingPolicyCustomMetricUtilization(properties);
                        };
    
                        /**
                         * Encodes the specified AutoscalingPolicyCustomMetricUtilization message. Does not implicitly {@link google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalingPolicyCustomMetricUtilization} message AutoscalingPolicyCustomMetricUtilization message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AutoscalingPolicyCustomMetricUtilization.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.utilizationTarget != null && Object.hasOwnProperty.call(message, "utilizationTarget"))
                                writer.uint32(/* id 215905870, wireType 1 =*/1727246961).double(message.utilizationTarget);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.utilizationTargetType != null && Object.hasOwnProperty.call(message, "utilizationTargetType"))
                                writer.uint32(/* id 340169355, wireType 2 =*/2721354842).string(message.utilizationTargetType);
                            if (message.singleInstanceAssignment != null && Object.hasOwnProperty.call(message, "singleInstanceAssignment"))
                                writer.uint32(/* id 504768064, wireType 1 =*/4038144513).double(message.singleInstanceAssignment);
                            if (message.metric != null && Object.hasOwnProperty.call(message, "metric"))
                                writer.uint32(/* id 533067184, wireType 2 =*/4264537474).string(message.metric);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AutoscalingPolicyCustomMetricUtilization message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalingPolicyCustomMetricUtilization} message AutoscalingPolicyCustomMetricUtilization message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AutoscalingPolicyCustomMetricUtilization.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AutoscalingPolicyCustomMetricUtilization message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization} AutoscalingPolicyCustomMetricUtilization
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AutoscalingPolicyCustomMetricUtilization.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 533067184: {
                                        message.metric = reader.string();
                                        break;
                                    }
                                case 504768064: {
                                        message.singleInstanceAssignment = reader.double();
                                        break;
                                    }
                                case 215905870: {
                                        message.utilizationTarget = reader.double();
                                        break;
                                    }
                                case 340169355: {
                                        message.utilizationTargetType = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AutoscalingPolicyCustomMetricUtilization message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization} AutoscalingPolicyCustomMetricUtilization
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AutoscalingPolicyCustomMetricUtilization.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AutoscalingPolicyCustomMetricUtilization message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AutoscalingPolicyCustomMetricUtilization.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.metric != null && message.hasOwnProperty("metric")) {
                                properties._metric = 1;
                                if (!$util.isString(message.metric))
                                    return "metric: string expected";
                            }
                            if (message.singleInstanceAssignment != null && message.hasOwnProperty("singleInstanceAssignment")) {
                                properties._singleInstanceAssignment = 1;
                                if (typeof message.singleInstanceAssignment !== "number")
                                    return "singleInstanceAssignment: number expected";
                            }
                            if (message.utilizationTarget != null && message.hasOwnProperty("utilizationTarget")) {
                                properties._utilizationTarget = 1;
                                if (typeof message.utilizationTarget !== "number")
                                    return "utilizationTarget: number expected";
                            }
                            if (message.utilizationTargetType != null && message.hasOwnProperty("utilizationTargetType")) {
                                properties._utilizationTargetType = 1;
                                if (!$util.isString(message.utilizationTargetType))
                                    return "utilizationTargetType: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AutoscalingPolicyCustomMetricUtilization message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization} AutoscalingPolicyCustomMetricUtilization
                         */
                        AutoscalingPolicyCustomMetricUtilization.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.metric != null)
                                message.metric = String(object.metric);
                            if (object.singleInstanceAssignment != null)
                                message.singleInstanceAssignment = Number(object.singleInstanceAssignment);
                            if (object.utilizationTarget != null)
                                message.utilizationTarget = Number(object.utilizationTarget);
                            if (object.utilizationTargetType != null)
                                message.utilizationTargetType = String(object.utilizationTargetType);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AutoscalingPolicyCustomMetricUtilization message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization
                         * @static
                         * @param {google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization} message AutoscalingPolicyCustomMetricUtilization
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AutoscalingPolicyCustomMetricUtilization.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.utilizationTarget != null && message.hasOwnProperty("utilizationTarget")) {
                                object.utilizationTarget = options.json && !isFinite(message.utilizationTarget) ? String(message.utilizationTarget) : message.utilizationTarget;
                                if (options.oneofs)
                                    object._utilizationTarget = "utilizationTarget";
                            }
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.utilizationTargetType != null && message.hasOwnProperty("utilizationTargetType")) {
                                object.utilizationTargetType = message.utilizationTargetType;
                                if (options.oneofs)
                                    object._utilizationTargetType = "utilizationTargetType";
                            }
                            if (message.singleInstanceAssignment != null && message.hasOwnProperty("singleInstanceAssignment")) {
                                object.singleInstanceAssignment = options.json && !isFinite(message.singleInstanceAssignment) ? String(message.singleInstanceAssignment) : message.singleInstanceAssignment;
                                if (options.oneofs)
                                    object._singleInstanceAssignment = "singleInstanceAssignment";
                            }
                            if (message.metric != null && message.hasOwnProperty("metric")) {
                                object.metric = message.metric;
                                if (options.oneofs)
                                    object._metric = "metric";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AutoscalingPolicyCustomMetricUtilization to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AutoscalingPolicyCustomMetricUtilization.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AutoscalingPolicyCustomMetricUtilization
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AutoscalingPolicyCustomMetricUtilization.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization";
                        };
    
                        /**
                         * UtilizationTargetType enum.
                         * @name google.cloud.compute.v1.AutoscalingPolicyCustomMetricUtilization.UtilizationTargetType
                         * @enum {number}
                         * @property {number} UNDEFINED_UTILIZATION_TARGET_TYPE=0 UNDEFINED_UTILIZATION_TARGET_TYPE value
                         * @property {number} DELTA_PER_MINUTE=87432861 DELTA_PER_MINUTE value
                         * @property {number} DELTA_PER_SECOND=255180029 DELTA_PER_SECOND value
                         * @property {number} GAUGE=67590361 GAUGE value
                         */
                        AutoscalingPolicyCustomMetricUtilization.UtilizationTargetType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_UTILIZATION_TARGET_TYPE"] = 0;
                            values[valuesById[87432861] = "DELTA_PER_MINUTE"] = 87432861;
                            values[valuesById[255180029] = "DELTA_PER_SECOND"] = 255180029;
                            values[valuesById[67590361] = "GAUGE"] = 67590361;
                            return values;
                        })();
    
                        return AutoscalingPolicyCustomMetricUtilization;
                    })();
    
                    v1.AutoscalingPolicyLoadBalancingUtilization = (function() {
    
                        /**
                         * Properties of an AutoscalingPolicyLoadBalancingUtilization.
                         * @memberof google.cloud.compute.v1
                         * @interface IAutoscalingPolicyLoadBalancingUtilization
                         * @property {number|null} [utilizationTarget] AutoscalingPolicyLoadBalancingUtilization utilizationTarget
                         */
    
                        /**
                         * Constructs a new AutoscalingPolicyLoadBalancingUtilization.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AutoscalingPolicyLoadBalancingUtilization.
                         * @implements IAutoscalingPolicyLoadBalancingUtilization
                         * @constructor
                         * @param {google.cloud.compute.v1.IAutoscalingPolicyLoadBalancingUtilization=} [properties] Properties to set
                         */
                        function AutoscalingPolicyLoadBalancingUtilization(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AutoscalingPolicyLoadBalancingUtilization utilizationTarget.
                         * @member {number|null|undefined} utilizationTarget
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization
                         * @instance
                         */
                        AutoscalingPolicyLoadBalancingUtilization.prototype.utilizationTarget = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AutoscalingPolicyLoadBalancingUtilization _utilizationTarget.
                         * @member {"utilizationTarget"|undefined} _utilizationTarget
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicyLoadBalancingUtilization.prototype, "_utilizationTarget", {
                            get: $util.oneOfGetter($oneOfFields = ["utilizationTarget"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AutoscalingPolicyLoadBalancingUtilization instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalingPolicyLoadBalancingUtilization=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization} AutoscalingPolicyLoadBalancingUtilization instance
                         */
                        AutoscalingPolicyLoadBalancingUtilization.create = function create(properties) {
                            return new AutoscalingPolicyLoadBalancingUtilization(properties);
                        };
    
                        /**
                         * Encodes the specified AutoscalingPolicyLoadBalancingUtilization message. Does not implicitly {@link google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalingPolicyLoadBalancingUtilization} message AutoscalingPolicyLoadBalancingUtilization message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AutoscalingPolicyLoadBalancingUtilization.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.utilizationTarget != null && Object.hasOwnProperty.call(message, "utilizationTarget"))
                                writer.uint32(/* id 215905870, wireType 1 =*/1727246961).double(message.utilizationTarget);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AutoscalingPolicyLoadBalancingUtilization message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalingPolicyLoadBalancingUtilization} message AutoscalingPolicyLoadBalancingUtilization message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AutoscalingPolicyLoadBalancingUtilization.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AutoscalingPolicyLoadBalancingUtilization message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization} AutoscalingPolicyLoadBalancingUtilization
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AutoscalingPolicyLoadBalancingUtilization.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 215905870: {
                                        message.utilizationTarget = reader.double();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AutoscalingPolicyLoadBalancingUtilization message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization} AutoscalingPolicyLoadBalancingUtilization
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AutoscalingPolicyLoadBalancingUtilization.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AutoscalingPolicyLoadBalancingUtilization message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AutoscalingPolicyLoadBalancingUtilization.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.utilizationTarget != null && message.hasOwnProperty("utilizationTarget")) {
                                properties._utilizationTarget = 1;
                                if (typeof message.utilizationTarget !== "number")
                                    return "utilizationTarget: number expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AutoscalingPolicyLoadBalancingUtilization message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization} AutoscalingPolicyLoadBalancingUtilization
                         */
                        AutoscalingPolicyLoadBalancingUtilization.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization();
                            if (object.utilizationTarget != null)
                                message.utilizationTarget = Number(object.utilizationTarget);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AutoscalingPolicyLoadBalancingUtilization message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization
                         * @static
                         * @param {google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization} message AutoscalingPolicyLoadBalancingUtilization
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AutoscalingPolicyLoadBalancingUtilization.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.utilizationTarget != null && message.hasOwnProperty("utilizationTarget")) {
                                object.utilizationTarget = options.json && !isFinite(message.utilizationTarget) ? String(message.utilizationTarget) : message.utilizationTarget;
                                if (options.oneofs)
                                    object._utilizationTarget = "utilizationTarget";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AutoscalingPolicyLoadBalancingUtilization to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AutoscalingPolicyLoadBalancingUtilization.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AutoscalingPolicyLoadBalancingUtilization
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AutoscalingPolicyLoadBalancingUtilization.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AutoscalingPolicyLoadBalancingUtilization";
                        };
    
                        return AutoscalingPolicyLoadBalancingUtilization;
                    })();
    
                    v1.AutoscalingPolicyScaleInControl = (function() {
    
                        /**
                         * Properties of an AutoscalingPolicyScaleInControl.
                         * @memberof google.cloud.compute.v1
                         * @interface IAutoscalingPolicyScaleInControl
                         * @property {google.cloud.compute.v1.IFixedOrPercent|null} [maxScaledInReplicas] AutoscalingPolicyScaleInControl maxScaledInReplicas
                         * @property {number|null} [timeWindowSec] AutoscalingPolicyScaleInControl timeWindowSec
                         */
    
                        /**
                         * Constructs a new AutoscalingPolicyScaleInControl.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AutoscalingPolicyScaleInControl.
                         * @implements IAutoscalingPolicyScaleInControl
                         * @constructor
                         * @param {google.cloud.compute.v1.IAutoscalingPolicyScaleInControl=} [properties] Properties to set
                         */
                        function AutoscalingPolicyScaleInControl(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AutoscalingPolicyScaleInControl maxScaledInReplicas.
                         * @member {google.cloud.compute.v1.IFixedOrPercent|null|undefined} maxScaledInReplicas
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScaleInControl
                         * @instance
                         */
                        AutoscalingPolicyScaleInControl.prototype.maxScaledInReplicas = null;
    
                        /**
                         * AutoscalingPolicyScaleInControl timeWindowSec.
                         * @member {number|null|undefined} timeWindowSec
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScaleInControl
                         * @instance
                         */
                        AutoscalingPolicyScaleInControl.prototype.timeWindowSec = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AutoscalingPolicyScaleInControl _maxScaledInReplicas.
                         * @member {"maxScaledInReplicas"|undefined} _maxScaledInReplicas
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScaleInControl
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicyScaleInControl.prototype, "_maxScaledInReplicas", {
                            get: $util.oneOfGetter($oneOfFields = ["maxScaledInReplicas"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalingPolicyScaleInControl _timeWindowSec.
                         * @member {"timeWindowSec"|undefined} _timeWindowSec
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScaleInControl
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicyScaleInControl.prototype, "_timeWindowSec", {
                            get: $util.oneOfGetter($oneOfFields = ["timeWindowSec"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AutoscalingPolicyScaleInControl instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScaleInControl
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalingPolicyScaleInControl=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AutoscalingPolicyScaleInControl} AutoscalingPolicyScaleInControl instance
                         */
                        AutoscalingPolicyScaleInControl.create = function create(properties) {
                            return new AutoscalingPolicyScaleInControl(properties);
                        };
    
                        /**
                         * Encodes the specified AutoscalingPolicyScaleInControl message. Does not implicitly {@link google.cloud.compute.v1.AutoscalingPolicyScaleInControl.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScaleInControl
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalingPolicyScaleInControl} message AutoscalingPolicyScaleInControl message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AutoscalingPolicyScaleInControl.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.timeWindowSec != null && Object.hasOwnProperty.call(message, "timeWindowSec"))
                                writer.uint32(/* id 36405300, wireType 0 =*/291242400).int32(message.timeWindowSec);
                            if (message.maxScaledInReplicas != null && Object.hasOwnProperty.call(message, "maxScaledInReplicas"))
                                $root.google.cloud.compute.v1.FixedOrPercent.encode(message.maxScaledInReplicas, writer.uint32(/* id 180710123, wireType 2 =*/1445680986).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AutoscalingPolicyScaleInControl message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AutoscalingPolicyScaleInControl.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScaleInControl
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalingPolicyScaleInControl} message AutoscalingPolicyScaleInControl message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AutoscalingPolicyScaleInControl.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AutoscalingPolicyScaleInControl message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScaleInControl
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AutoscalingPolicyScaleInControl} AutoscalingPolicyScaleInControl
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AutoscalingPolicyScaleInControl.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AutoscalingPolicyScaleInControl();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 180710123: {
                                        message.maxScaledInReplicas = $root.google.cloud.compute.v1.FixedOrPercent.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 36405300: {
                                        message.timeWindowSec = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AutoscalingPolicyScaleInControl message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScaleInControl
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AutoscalingPolicyScaleInControl} AutoscalingPolicyScaleInControl
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AutoscalingPolicyScaleInControl.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AutoscalingPolicyScaleInControl message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScaleInControl
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AutoscalingPolicyScaleInControl.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.maxScaledInReplicas != null && message.hasOwnProperty("maxScaledInReplicas")) {
                                properties._maxScaledInReplicas = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.FixedOrPercent.verify(message.maxScaledInReplicas);
                                    if (error)
                                        return "maxScaledInReplicas." + error;
                                }
                            }
                            if (message.timeWindowSec != null && message.hasOwnProperty("timeWindowSec")) {
                                properties._timeWindowSec = 1;
                                if (!$util.isInteger(message.timeWindowSec))
                                    return "timeWindowSec: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AutoscalingPolicyScaleInControl message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScaleInControl
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AutoscalingPolicyScaleInControl} AutoscalingPolicyScaleInControl
                         */
                        AutoscalingPolicyScaleInControl.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AutoscalingPolicyScaleInControl)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AutoscalingPolicyScaleInControl();
                            if (object.maxScaledInReplicas != null) {
                                if (typeof object.maxScaledInReplicas !== "object")
                                    throw TypeError(".google.cloud.compute.v1.AutoscalingPolicyScaleInControl.maxScaledInReplicas: object expected");
                                message.maxScaledInReplicas = $root.google.cloud.compute.v1.FixedOrPercent.fromObject(object.maxScaledInReplicas);
                            }
                            if (object.timeWindowSec != null)
                                message.timeWindowSec = object.timeWindowSec | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AutoscalingPolicyScaleInControl message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScaleInControl
                         * @static
                         * @param {google.cloud.compute.v1.AutoscalingPolicyScaleInControl} message AutoscalingPolicyScaleInControl
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AutoscalingPolicyScaleInControl.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.timeWindowSec != null && message.hasOwnProperty("timeWindowSec")) {
                                object.timeWindowSec = message.timeWindowSec;
                                if (options.oneofs)
                                    object._timeWindowSec = "timeWindowSec";
                            }
                            if (message.maxScaledInReplicas != null && message.hasOwnProperty("maxScaledInReplicas")) {
                                object.maxScaledInReplicas = $root.google.cloud.compute.v1.FixedOrPercent.toObject(message.maxScaledInReplicas, options);
                                if (options.oneofs)
                                    object._maxScaledInReplicas = "maxScaledInReplicas";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AutoscalingPolicyScaleInControl to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScaleInControl
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AutoscalingPolicyScaleInControl.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AutoscalingPolicyScaleInControl
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScaleInControl
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AutoscalingPolicyScaleInControl.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AutoscalingPolicyScaleInControl";
                        };
    
                        return AutoscalingPolicyScaleInControl;
                    })();
    
                    v1.AutoscalingPolicyScalingSchedule = (function() {
    
                        /**
                         * Properties of an AutoscalingPolicyScalingSchedule.
                         * @memberof google.cloud.compute.v1
                         * @interface IAutoscalingPolicyScalingSchedule
                         * @property {string|null} [description] AutoscalingPolicyScalingSchedule description
                         * @property {boolean|null} [disabled] AutoscalingPolicyScalingSchedule disabled
                         * @property {number|null} [durationSec] AutoscalingPolicyScalingSchedule durationSec
                         * @property {number|null} [minRequiredReplicas] AutoscalingPolicyScalingSchedule minRequiredReplicas
                         * @property {string|null} [schedule] AutoscalingPolicyScalingSchedule schedule
                         * @property {string|null} [timeZone] AutoscalingPolicyScalingSchedule timeZone
                         */
    
                        /**
                         * Constructs a new AutoscalingPolicyScalingSchedule.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AutoscalingPolicyScalingSchedule.
                         * @implements IAutoscalingPolicyScalingSchedule
                         * @constructor
                         * @param {google.cloud.compute.v1.IAutoscalingPolicyScalingSchedule=} [properties] Properties to set
                         */
                        function AutoscalingPolicyScalingSchedule(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AutoscalingPolicyScalingSchedule description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @instance
                         */
                        AutoscalingPolicyScalingSchedule.prototype.description = null;
    
                        /**
                         * AutoscalingPolicyScalingSchedule disabled.
                         * @member {boolean|null|undefined} disabled
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @instance
                         */
                        AutoscalingPolicyScalingSchedule.prototype.disabled = null;
    
                        /**
                         * AutoscalingPolicyScalingSchedule durationSec.
                         * @member {number|null|undefined} durationSec
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @instance
                         */
                        AutoscalingPolicyScalingSchedule.prototype.durationSec = null;
    
                        /**
                         * AutoscalingPolicyScalingSchedule minRequiredReplicas.
                         * @member {number|null|undefined} minRequiredReplicas
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @instance
                         */
                        AutoscalingPolicyScalingSchedule.prototype.minRequiredReplicas = null;
    
                        /**
                         * AutoscalingPolicyScalingSchedule schedule.
                         * @member {string|null|undefined} schedule
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @instance
                         */
                        AutoscalingPolicyScalingSchedule.prototype.schedule = null;
    
                        /**
                         * AutoscalingPolicyScalingSchedule timeZone.
                         * @member {string|null|undefined} timeZone
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @instance
                         */
                        AutoscalingPolicyScalingSchedule.prototype.timeZone = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AutoscalingPolicyScalingSchedule _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicyScalingSchedule.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalingPolicyScalingSchedule _disabled.
                         * @member {"disabled"|undefined} _disabled
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicyScalingSchedule.prototype, "_disabled", {
                            get: $util.oneOfGetter($oneOfFields = ["disabled"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalingPolicyScalingSchedule _durationSec.
                         * @member {"durationSec"|undefined} _durationSec
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicyScalingSchedule.prototype, "_durationSec", {
                            get: $util.oneOfGetter($oneOfFields = ["durationSec"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalingPolicyScalingSchedule _minRequiredReplicas.
                         * @member {"minRequiredReplicas"|undefined} _minRequiredReplicas
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicyScalingSchedule.prototype, "_minRequiredReplicas", {
                            get: $util.oneOfGetter($oneOfFields = ["minRequiredReplicas"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalingPolicyScalingSchedule _schedule.
                         * @member {"schedule"|undefined} _schedule
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicyScalingSchedule.prototype, "_schedule", {
                            get: $util.oneOfGetter($oneOfFields = ["schedule"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AutoscalingPolicyScalingSchedule _timeZone.
                         * @member {"timeZone"|undefined} _timeZone
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @instance
                         */
                        Object.defineProperty(AutoscalingPolicyScalingSchedule.prototype, "_timeZone", {
                            get: $util.oneOfGetter($oneOfFields = ["timeZone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AutoscalingPolicyScalingSchedule instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalingPolicyScalingSchedule=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.AutoscalingPolicyScalingSchedule} AutoscalingPolicyScalingSchedule instance
                         */
                        AutoscalingPolicyScalingSchedule.create = function create(properties) {
                            return new AutoscalingPolicyScalingSchedule(properties);
                        };
    
                        /**
                         * Encodes the specified AutoscalingPolicyScalingSchedule message. Does not implicitly {@link google.cloud.compute.v1.AutoscalingPolicyScalingSchedule.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalingPolicyScalingSchedule} message AutoscalingPolicyScalingSchedule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AutoscalingPolicyScalingSchedule.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.timeZone != null && Object.hasOwnProperty.call(message, "timeZone"))
                                writer.uint32(/* id 36848094, wireType 2 =*/294784754).string(message.timeZone);
                            if (message.durationSec != null && Object.hasOwnProperty.call(message, "durationSec"))
                                writer.uint32(/* id 212356902, wireType 0 =*/1698855216).int32(message.durationSec);
                            if (message.disabled != null && Object.hasOwnProperty.call(message, "disabled"))
                                writer.uint32(/* id 270940796, wireType 0 =*/2167526368).bool(message.disabled);
                            if (message.minRequiredReplicas != null && Object.hasOwnProperty.call(message, "minRequiredReplicas"))
                                writer.uint32(/* id 365514414, wireType 0 =*/2924115312).int32(message.minRequiredReplicas);
                            if (message.schedule != null && Object.hasOwnProperty.call(message, "schedule"))
                                writer.uint32(/* id 375820951, wireType 2 =*/3006567610).string(message.schedule);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AutoscalingPolicyScalingSchedule message, length delimited. Does not implicitly {@link google.cloud.compute.v1.AutoscalingPolicyScalingSchedule.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @static
                         * @param {google.cloud.compute.v1.IAutoscalingPolicyScalingSchedule} message AutoscalingPolicyScalingSchedule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AutoscalingPolicyScalingSchedule.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AutoscalingPolicyScalingSchedule message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.AutoscalingPolicyScalingSchedule} AutoscalingPolicyScalingSchedule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AutoscalingPolicyScalingSchedule.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.AutoscalingPolicyScalingSchedule();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 270940796: {
                                        message.disabled = reader.bool();
                                        break;
                                    }
                                case 212356902: {
                                        message.durationSec = reader.int32();
                                        break;
                                    }
                                case 365514414: {
                                        message.minRequiredReplicas = reader.int32();
                                        break;
                                    }
                                case 375820951: {
                                        message.schedule = reader.string();
                                        break;
                                    }
                                case 36848094: {
                                        message.timeZone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AutoscalingPolicyScalingSchedule message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.AutoscalingPolicyScalingSchedule} AutoscalingPolicyScalingSchedule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AutoscalingPolicyScalingSchedule.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AutoscalingPolicyScalingSchedule message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AutoscalingPolicyScalingSchedule.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.disabled != null && message.hasOwnProperty("disabled")) {
                                properties._disabled = 1;
                                if (typeof message.disabled !== "boolean")
                                    return "disabled: boolean expected";
                            }
                            if (message.durationSec != null && message.hasOwnProperty("durationSec")) {
                                properties._durationSec = 1;
                                if (!$util.isInteger(message.durationSec))
                                    return "durationSec: integer expected";
                            }
                            if (message.minRequiredReplicas != null && message.hasOwnProperty("minRequiredReplicas")) {
                                properties._minRequiredReplicas = 1;
                                if (!$util.isInteger(message.minRequiredReplicas))
                                    return "minRequiredReplicas: integer expected";
                            }
                            if (message.schedule != null && message.hasOwnProperty("schedule")) {
                                properties._schedule = 1;
                                if (!$util.isString(message.schedule))
                                    return "schedule: string expected";
                            }
                            if (message.timeZone != null && message.hasOwnProperty("timeZone")) {
                                properties._timeZone = 1;
                                if (!$util.isString(message.timeZone))
                                    return "timeZone: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AutoscalingPolicyScalingSchedule message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.AutoscalingPolicyScalingSchedule} AutoscalingPolicyScalingSchedule
                         */
                        AutoscalingPolicyScalingSchedule.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.AutoscalingPolicyScalingSchedule)
                                return object;
                            var message = new $root.google.cloud.compute.v1.AutoscalingPolicyScalingSchedule();
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.disabled != null)
                                message.disabled = Boolean(object.disabled);
                            if (object.durationSec != null)
                                message.durationSec = object.durationSec | 0;
                            if (object.minRequiredReplicas != null)
                                message.minRequiredReplicas = object.minRequiredReplicas | 0;
                            if (object.schedule != null)
                                message.schedule = String(object.schedule);
                            if (object.timeZone != null)
                                message.timeZone = String(object.timeZone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AutoscalingPolicyScalingSchedule message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @static
                         * @param {google.cloud.compute.v1.AutoscalingPolicyScalingSchedule} message AutoscalingPolicyScalingSchedule
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AutoscalingPolicyScalingSchedule.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.timeZone != null && message.hasOwnProperty("timeZone")) {
                                object.timeZone = message.timeZone;
                                if (options.oneofs)
                                    object._timeZone = "timeZone";
                            }
                            if (message.durationSec != null && message.hasOwnProperty("durationSec")) {
                                object.durationSec = message.durationSec;
                                if (options.oneofs)
                                    object._durationSec = "durationSec";
                            }
                            if (message.disabled != null && message.hasOwnProperty("disabled")) {
                                object.disabled = message.disabled;
                                if (options.oneofs)
                                    object._disabled = "disabled";
                            }
                            if (message.minRequiredReplicas != null && message.hasOwnProperty("minRequiredReplicas")) {
                                object.minRequiredReplicas = message.minRequiredReplicas;
                                if (options.oneofs)
                                    object._minRequiredReplicas = "minRequiredReplicas";
                            }
                            if (message.schedule != null && message.hasOwnProperty("schedule")) {
                                object.schedule = message.schedule;
                                if (options.oneofs)
                                    object._schedule = "schedule";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AutoscalingPolicyScalingSchedule to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AutoscalingPolicyScalingSchedule.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AutoscalingPolicyScalingSchedule
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.AutoscalingPolicyScalingSchedule
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AutoscalingPolicyScalingSchedule.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.AutoscalingPolicyScalingSchedule";
                        };
    
                        return AutoscalingPolicyScalingSchedule;
                    })();
    
                    v1.Backend = (function() {
    
                        /**
                         * Properties of a Backend.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackend
                         * @property {string|null} [balancingMode] Backend balancingMode
                         * @property {number|null} [capacityScaler] Backend capacityScaler
                         * @property {string|null} [description] Backend description
                         * @property {boolean|null} [failover] Backend failover
                         * @property {string|null} [group] Backend group
                         * @property {number|null} [maxConnections] Backend maxConnections
                         * @property {number|null} [maxConnectionsPerEndpoint] Backend maxConnectionsPerEndpoint
                         * @property {number|null} [maxConnectionsPerInstance] Backend maxConnectionsPerInstance
                         * @property {number|null} [maxRate] Backend maxRate
                         * @property {number|null} [maxRatePerEndpoint] Backend maxRatePerEndpoint
                         * @property {number|null} [maxRatePerInstance] Backend maxRatePerInstance
                         * @property {number|null} [maxUtilization] Backend maxUtilization
                         */
    
                        /**
                         * Constructs a new Backend.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Backend.
                         * @implements IBackend
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackend=} [properties] Properties to set
                         */
                        function Backend(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Backend balancingMode.
                         * @member {string|null|undefined} balancingMode
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Backend.prototype.balancingMode = null;
    
                        /**
                         * Backend capacityScaler.
                         * @member {number|null|undefined} capacityScaler
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Backend.prototype.capacityScaler = null;
    
                        /**
                         * Backend description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Backend.prototype.description = null;
    
                        /**
                         * Backend failover.
                         * @member {boolean|null|undefined} failover
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Backend.prototype.failover = null;
    
                        /**
                         * Backend group.
                         * @member {string|null|undefined} group
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Backend.prototype.group = null;
    
                        /**
                         * Backend maxConnections.
                         * @member {number|null|undefined} maxConnections
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Backend.prototype.maxConnections = null;
    
                        /**
                         * Backend maxConnectionsPerEndpoint.
                         * @member {number|null|undefined} maxConnectionsPerEndpoint
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Backend.prototype.maxConnectionsPerEndpoint = null;
    
                        /**
                         * Backend maxConnectionsPerInstance.
                         * @member {number|null|undefined} maxConnectionsPerInstance
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Backend.prototype.maxConnectionsPerInstance = null;
    
                        /**
                         * Backend maxRate.
                         * @member {number|null|undefined} maxRate
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Backend.prototype.maxRate = null;
    
                        /**
                         * Backend maxRatePerEndpoint.
                         * @member {number|null|undefined} maxRatePerEndpoint
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Backend.prototype.maxRatePerEndpoint = null;
    
                        /**
                         * Backend maxRatePerInstance.
                         * @member {number|null|undefined} maxRatePerInstance
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Backend.prototype.maxRatePerInstance = null;
    
                        /**
                         * Backend maxUtilization.
                         * @member {number|null|undefined} maxUtilization
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Backend.prototype.maxUtilization = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Backend _balancingMode.
                         * @member {"balancingMode"|undefined} _balancingMode
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Object.defineProperty(Backend.prototype, "_balancingMode", {
                            get: $util.oneOfGetter($oneOfFields = ["balancingMode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Backend _capacityScaler.
                         * @member {"capacityScaler"|undefined} _capacityScaler
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Object.defineProperty(Backend.prototype, "_capacityScaler", {
                            get: $util.oneOfGetter($oneOfFields = ["capacityScaler"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Backend _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Object.defineProperty(Backend.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Backend _failover.
                         * @member {"failover"|undefined} _failover
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Object.defineProperty(Backend.prototype, "_failover", {
                            get: $util.oneOfGetter($oneOfFields = ["failover"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Backend _group.
                         * @member {"group"|undefined} _group
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Object.defineProperty(Backend.prototype, "_group", {
                            get: $util.oneOfGetter($oneOfFields = ["group"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Backend _maxConnections.
                         * @member {"maxConnections"|undefined} _maxConnections
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Object.defineProperty(Backend.prototype, "_maxConnections", {
                            get: $util.oneOfGetter($oneOfFields = ["maxConnections"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Backend _maxConnectionsPerEndpoint.
                         * @member {"maxConnectionsPerEndpoint"|undefined} _maxConnectionsPerEndpoint
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Object.defineProperty(Backend.prototype, "_maxConnectionsPerEndpoint", {
                            get: $util.oneOfGetter($oneOfFields = ["maxConnectionsPerEndpoint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Backend _maxConnectionsPerInstance.
                         * @member {"maxConnectionsPerInstance"|undefined} _maxConnectionsPerInstance
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Object.defineProperty(Backend.prototype, "_maxConnectionsPerInstance", {
                            get: $util.oneOfGetter($oneOfFields = ["maxConnectionsPerInstance"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Backend _maxRate.
                         * @member {"maxRate"|undefined} _maxRate
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Object.defineProperty(Backend.prototype, "_maxRate", {
                            get: $util.oneOfGetter($oneOfFields = ["maxRate"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Backend _maxRatePerEndpoint.
                         * @member {"maxRatePerEndpoint"|undefined} _maxRatePerEndpoint
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Object.defineProperty(Backend.prototype, "_maxRatePerEndpoint", {
                            get: $util.oneOfGetter($oneOfFields = ["maxRatePerEndpoint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Backend _maxRatePerInstance.
                         * @member {"maxRatePerInstance"|undefined} _maxRatePerInstance
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Object.defineProperty(Backend.prototype, "_maxRatePerInstance", {
                            get: $util.oneOfGetter($oneOfFields = ["maxRatePerInstance"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Backend _maxUtilization.
                         * @member {"maxUtilization"|undefined} _maxUtilization
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         */
                        Object.defineProperty(Backend.prototype, "_maxUtilization", {
                            get: $util.oneOfGetter($oneOfFields = ["maxUtilization"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Backend instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Backend
                         * @static
                         * @param {google.cloud.compute.v1.IBackend=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Backend} Backend instance
                         */
                        Backend.create = function create(properties) {
                            return new Backend(properties);
                        };
    
                        /**
                         * Encodes the specified Backend message. Does not implicitly {@link google.cloud.compute.v1.Backend.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Backend
                         * @static
                         * @param {google.cloud.compute.v1.IBackend} message Backend message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Backend.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.maxRatePerInstance != null && Object.hasOwnProperty.call(message, "maxRatePerInstance"))
                                writer.uint32(/* id 17599579, wireType 5 =*/140796637).float(message.maxRatePerInstance);
                            if (message.group != null && Object.hasOwnProperty.call(message, "group"))
                                writer.uint32(/* id 98629247, wireType 2 =*/789033978).string(message.group);
                            if (message.maxConnectionsPerInstance != null && Object.hasOwnProperty.call(message, "maxConnectionsPerInstance"))
                                writer.uint32(/* id 104671900, wireType 0 =*/837375200).int32(message.maxConnectionsPerInstance);
                            if (message.maxConnections != null && Object.hasOwnProperty.call(message, "maxConnections"))
                                writer.uint32(/* id 110652154, wireType 0 =*/885217232).int32(message.maxConnections);
                            if (message.maxRatePerEndpoint != null && Object.hasOwnProperty.call(message, "maxRatePerEndpoint"))
                                writer.uint32(/* id 129832283, wireType 5 =*/1038658269).float(message.maxRatePerEndpoint);
                            if (message.failover != null && Object.hasOwnProperty.call(message, "failover"))
                                writer.uint32(/* id 138892530, wireType 0 =*/1111140240).bool(message.failover);
                            if (message.maxUtilization != null && Object.hasOwnProperty.call(message, "maxUtilization"))
                                writer.uint32(/* id 148192199, wireType 5 =*/1185537597).float(message.maxUtilization);
                            if (message.maxConnectionsPerEndpoint != null && Object.hasOwnProperty.call(message, "maxConnectionsPerEndpoint"))
                                writer.uint32(/* id 216904604, wireType 0 =*/1735236832).int32(message.maxConnectionsPerEndpoint);
                            if (message.capacityScaler != null && Object.hasOwnProperty.call(message, "capacityScaler"))
                                writer.uint32(/* id 315958157, wireType 5 =*/2527665261).float(message.capacityScaler);
                            if (message.maxRate != null && Object.hasOwnProperty.call(message, "maxRate"))
                                writer.uint32(/* id 408035035, wireType 0 =*/3264280280).int32(message.maxRate);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.balancingMode != null && Object.hasOwnProperty.call(message, "balancingMode"))
                                writer.uint32(/* id 430286217, wireType 2 =*/3442289738).string(message.balancingMode);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Backend message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Backend.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Backend
                         * @static
                         * @param {google.cloud.compute.v1.IBackend} message Backend message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Backend.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Backend message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Backend
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Backend} Backend
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Backend.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Backend();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 430286217: {
                                        message.balancingMode = reader.string();
                                        break;
                                    }
                                case 315958157: {
                                        message.capacityScaler = reader.float();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 138892530: {
                                        message.failover = reader.bool();
                                        break;
                                    }
                                case 98629247: {
                                        message.group = reader.string();
                                        break;
                                    }
                                case 110652154: {
                                        message.maxConnections = reader.int32();
                                        break;
                                    }
                                case 216904604: {
                                        message.maxConnectionsPerEndpoint = reader.int32();
                                        break;
                                    }
                                case 104671900: {
                                        message.maxConnectionsPerInstance = reader.int32();
                                        break;
                                    }
                                case 408035035: {
                                        message.maxRate = reader.int32();
                                        break;
                                    }
                                case 129832283: {
                                        message.maxRatePerEndpoint = reader.float();
                                        break;
                                    }
                                case 17599579: {
                                        message.maxRatePerInstance = reader.float();
                                        break;
                                    }
                                case 148192199: {
                                        message.maxUtilization = reader.float();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Backend message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Backend
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Backend} Backend
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Backend.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Backend message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Backend
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Backend.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.balancingMode != null && message.hasOwnProperty("balancingMode")) {
                                properties._balancingMode = 1;
                                if (!$util.isString(message.balancingMode))
                                    return "balancingMode: string expected";
                            }
                            if (message.capacityScaler != null && message.hasOwnProperty("capacityScaler")) {
                                properties._capacityScaler = 1;
                                if (typeof message.capacityScaler !== "number")
                                    return "capacityScaler: number expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.failover != null && message.hasOwnProperty("failover")) {
                                properties._failover = 1;
                                if (typeof message.failover !== "boolean")
                                    return "failover: boolean expected";
                            }
                            if (message.group != null && message.hasOwnProperty("group")) {
                                properties._group = 1;
                                if (!$util.isString(message.group))
                                    return "group: string expected";
                            }
                            if (message.maxConnections != null && message.hasOwnProperty("maxConnections")) {
                                properties._maxConnections = 1;
                                if (!$util.isInteger(message.maxConnections))
                                    return "maxConnections: integer expected";
                            }
                            if (message.maxConnectionsPerEndpoint != null && message.hasOwnProperty("maxConnectionsPerEndpoint")) {
                                properties._maxConnectionsPerEndpoint = 1;
                                if (!$util.isInteger(message.maxConnectionsPerEndpoint))
                                    return "maxConnectionsPerEndpoint: integer expected";
                            }
                            if (message.maxConnectionsPerInstance != null && message.hasOwnProperty("maxConnectionsPerInstance")) {
                                properties._maxConnectionsPerInstance = 1;
                                if (!$util.isInteger(message.maxConnectionsPerInstance))
                                    return "maxConnectionsPerInstance: integer expected";
                            }
                            if (message.maxRate != null && message.hasOwnProperty("maxRate")) {
                                properties._maxRate = 1;
                                if (!$util.isInteger(message.maxRate))
                                    return "maxRate: integer expected";
                            }
                            if (message.maxRatePerEndpoint != null && message.hasOwnProperty("maxRatePerEndpoint")) {
                                properties._maxRatePerEndpoint = 1;
                                if (typeof message.maxRatePerEndpoint !== "number")
                                    return "maxRatePerEndpoint: number expected";
                            }
                            if (message.maxRatePerInstance != null && message.hasOwnProperty("maxRatePerInstance")) {
                                properties._maxRatePerInstance = 1;
                                if (typeof message.maxRatePerInstance !== "number")
                                    return "maxRatePerInstance: number expected";
                            }
                            if (message.maxUtilization != null && message.hasOwnProperty("maxUtilization")) {
                                properties._maxUtilization = 1;
                                if (typeof message.maxUtilization !== "number")
                                    return "maxUtilization: number expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Backend message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Backend
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Backend} Backend
                         */
                        Backend.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Backend)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Backend();
                            if (object.balancingMode != null)
                                message.balancingMode = String(object.balancingMode);
                            if (object.capacityScaler != null)
                                message.capacityScaler = Number(object.capacityScaler);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.failover != null)
                                message.failover = Boolean(object.failover);
                            if (object.group != null)
                                message.group = String(object.group);
                            if (object.maxConnections != null)
                                message.maxConnections = object.maxConnections | 0;
                            if (object.maxConnectionsPerEndpoint != null)
                                message.maxConnectionsPerEndpoint = object.maxConnectionsPerEndpoint | 0;
                            if (object.maxConnectionsPerInstance != null)
                                message.maxConnectionsPerInstance = object.maxConnectionsPerInstance | 0;
                            if (object.maxRate != null)
                                message.maxRate = object.maxRate | 0;
                            if (object.maxRatePerEndpoint != null)
                                message.maxRatePerEndpoint = Number(object.maxRatePerEndpoint);
                            if (object.maxRatePerInstance != null)
                                message.maxRatePerInstance = Number(object.maxRatePerInstance);
                            if (object.maxUtilization != null)
                                message.maxUtilization = Number(object.maxUtilization);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Backend message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Backend
                         * @static
                         * @param {google.cloud.compute.v1.Backend} message Backend
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Backend.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.maxRatePerInstance != null && message.hasOwnProperty("maxRatePerInstance")) {
                                object.maxRatePerInstance = options.json && !isFinite(message.maxRatePerInstance) ? String(message.maxRatePerInstance) : message.maxRatePerInstance;
                                if (options.oneofs)
                                    object._maxRatePerInstance = "maxRatePerInstance";
                            }
                            if (message.group != null && message.hasOwnProperty("group")) {
                                object.group = message.group;
                                if (options.oneofs)
                                    object._group = "group";
                            }
                            if (message.maxConnectionsPerInstance != null && message.hasOwnProperty("maxConnectionsPerInstance")) {
                                object.maxConnectionsPerInstance = message.maxConnectionsPerInstance;
                                if (options.oneofs)
                                    object._maxConnectionsPerInstance = "maxConnectionsPerInstance";
                            }
                            if (message.maxConnections != null && message.hasOwnProperty("maxConnections")) {
                                object.maxConnections = message.maxConnections;
                                if (options.oneofs)
                                    object._maxConnections = "maxConnections";
                            }
                            if (message.maxRatePerEndpoint != null && message.hasOwnProperty("maxRatePerEndpoint")) {
                                object.maxRatePerEndpoint = options.json && !isFinite(message.maxRatePerEndpoint) ? String(message.maxRatePerEndpoint) : message.maxRatePerEndpoint;
                                if (options.oneofs)
                                    object._maxRatePerEndpoint = "maxRatePerEndpoint";
                            }
                            if (message.failover != null && message.hasOwnProperty("failover")) {
                                object.failover = message.failover;
                                if (options.oneofs)
                                    object._failover = "failover";
                            }
                            if (message.maxUtilization != null && message.hasOwnProperty("maxUtilization")) {
                                object.maxUtilization = options.json && !isFinite(message.maxUtilization) ? String(message.maxUtilization) : message.maxUtilization;
                                if (options.oneofs)
                                    object._maxUtilization = "maxUtilization";
                            }
                            if (message.maxConnectionsPerEndpoint != null && message.hasOwnProperty("maxConnectionsPerEndpoint")) {
                                object.maxConnectionsPerEndpoint = message.maxConnectionsPerEndpoint;
                                if (options.oneofs)
                                    object._maxConnectionsPerEndpoint = "maxConnectionsPerEndpoint";
                            }
                            if (message.capacityScaler != null && message.hasOwnProperty("capacityScaler")) {
                                object.capacityScaler = options.json && !isFinite(message.capacityScaler) ? String(message.capacityScaler) : message.capacityScaler;
                                if (options.oneofs)
                                    object._capacityScaler = "capacityScaler";
                            }
                            if (message.maxRate != null && message.hasOwnProperty("maxRate")) {
                                object.maxRate = message.maxRate;
                                if (options.oneofs)
                                    object._maxRate = "maxRate";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.balancingMode != null && message.hasOwnProperty("balancingMode")) {
                                object.balancingMode = message.balancingMode;
                                if (options.oneofs)
                                    object._balancingMode = "balancingMode";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Backend to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Backend
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Backend.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Backend
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Backend
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Backend.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Backend";
                        };
    
                        /**
                         * BalancingMode enum.
                         * @name google.cloud.compute.v1.Backend.BalancingMode
                         * @enum {number}
                         * @property {number} UNDEFINED_BALANCING_MODE=0 UNDEFINED_BALANCING_MODE value
                         * @property {number} CONNECTION=246311646 CONNECTION value
                         * @property {number} RATE=2508000 RATE value
                         * @property {number} UTILIZATION=157008386 UTILIZATION value
                         */
                        Backend.BalancingMode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_BALANCING_MODE"] = 0;
                            values[valuesById[246311646] = "CONNECTION"] = 246311646;
                            values[valuesById[2508000] = "RATE"] = 2508000;
                            values[valuesById[157008386] = "UTILIZATION"] = 157008386;
                            return values;
                        })();
    
                        return Backend;
                    })();
    
                    v1.BackendBucket = (function() {
    
                        /**
                         * Properties of a BackendBucket.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendBucket
                         * @property {string|null} [bucketName] BackendBucket bucketName
                         * @property {google.cloud.compute.v1.IBackendBucketCdnPolicy|null} [cdnPolicy] BackendBucket cdnPolicy
                         * @property {string|null} [compressionMode] BackendBucket compressionMode
                         * @property {string|null} [creationTimestamp] BackendBucket creationTimestamp
                         * @property {Array.<string>|null} [customResponseHeaders] BackendBucket customResponseHeaders
                         * @property {string|null} [description] BackendBucket description
                         * @property {string|null} [edgeSecurityPolicy] BackendBucket edgeSecurityPolicy
                         * @property {boolean|null} [enableCdn] BackendBucket enableCdn
                         * @property {number|Long|null} [id] BackendBucket id
                         * @property {string|null} [kind] BackendBucket kind
                         * @property {string|null} [name] BackendBucket name
                         * @property {string|null} [selfLink] BackendBucket selfLink
                         */
    
                        /**
                         * Constructs a new BackendBucket.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendBucket.
                         * @implements IBackendBucket
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendBucket=} [properties] Properties to set
                         */
                        function BackendBucket(properties) {
                            this.customResponseHeaders = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendBucket bucketName.
                         * @member {string|null|undefined} bucketName
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        BackendBucket.prototype.bucketName = null;
    
                        /**
                         * BackendBucket cdnPolicy.
                         * @member {google.cloud.compute.v1.IBackendBucketCdnPolicy|null|undefined} cdnPolicy
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        BackendBucket.prototype.cdnPolicy = null;
    
                        /**
                         * BackendBucket compressionMode.
                         * @member {string|null|undefined} compressionMode
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        BackendBucket.prototype.compressionMode = null;
    
                        /**
                         * BackendBucket creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        BackendBucket.prototype.creationTimestamp = null;
    
                        /**
                         * BackendBucket customResponseHeaders.
                         * @member {Array.<string>} customResponseHeaders
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        BackendBucket.prototype.customResponseHeaders = $util.emptyArray;
    
                        /**
                         * BackendBucket description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        BackendBucket.prototype.description = null;
    
                        /**
                         * BackendBucket edgeSecurityPolicy.
                         * @member {string|null|undefined} edgeSecurityPolicy
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        BackendBucket.prototype.edgeSecurityPolicy = null;
    
                        /**
                         * BackendBucket enableCdn.
                         * @member {boolean|null|undefined} enableCdn
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        BackendBucket.prototype.enableCdn = null;
    
                        /**
                         * BackendBucket id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        BackendBucket.prototype.id = null;
    
                        /**
                         * BackendBucket kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        BackendBucket.prototype.kind = null;
    
                        /**
                         * BackendBucket name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        BackendBucket.prototype.name = null;
    
                        /**
                         * BackendBucket selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        BackendBucket.prototype.selfLink = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendBucket _bucketName.
                         * @member {"bucketName"|undefined} _bucketName
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        Object.defineProperty(BackendBucket.prototype, "_bucketName", {
                            get: $util.oneOfGetter($oneOfFields = ["bucketName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucket _cdnPolicy.
                         * @member {"cdnPolicy"|undefined} _cdnPolicy
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        Object.defineProperty(BackendBucket.prototype, "_cdnPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["cdnPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucket _compressionMode.
                         * @member {"compressionMode"|undefined} _compressionMode
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        Object.defineProperty(BackendBucket.prototype, "_compressionMode", {
                            get: $util.oneOfGetter($oneOfFields = ["compressionMode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucket _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        Object.defineProperty(BackendBucket.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucket _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        Object.defineProperty(BackendBucket.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucket _edgeSecurityPolicy.
                         * @member {"edgeSecurityPolicy"|undefined} _edgeSecurityPolicy
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        Object.defineProperty(BackendBucket.prototype, "_edgeSecurityPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["edgeSecurityPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucket _enableCdn.
                         * @member {"enableCdn"|undefined} _enableCdn
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        Object.defineProperty(BackendBucket.prototype, "_enableCdn", {
                            get: $util.oneOfGetter($oneOfFields = ["enableCdn"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucket _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        Object.defineProperty(BackendBucket.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucket _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        Object.defineProperty(BackendBucket.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucket _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        Object.defineProperty(BackendBucket.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucket _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         */
                        Object.defineProperty(BackendBucket.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendBucket instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @static
                         * @param {google.cloud.compute.v1.IBackendBucket=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendBucket} BackendBucket instance
                         */
                        BackendBucket.create = function create(properties) {
                            return new BackendBucket(properties);
                        };
    
                        /**
                         * Encodes the specified BackendBucket message. Does not implicitly {@link google.cloud.compute.v1.BackendBucket.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @static
                         * @param {google.cloud.compute.v1.IBackendBucket} message BackendBucket message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendBucket.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.edgeSecurityPolicy != null && Object.hasOwnProperty.call(message, "edgeSecurityPolicy"))
                                writer.uint32(/* id 41036943, wireType 2 =*/328295546).string(message.edgeSecurityPolicy);
                            if (message.compressionMode != null && Object.hasOwnProperty.call(message, "compressionMode"))
                                writer.uint32(/* id 95520988, wireType 2 =*/764167906).string(message.compressionMode);
                            if (message.cdnPolicy != null && Object.hasOwnProperty.call(message, "cdnPolicy"))
                                $root.google.cloud.compute.v1.BackendBucketCdnPolicy.encode(message.cdnPolicy, writer.uint32(/* id 213976452, wireType 2 =*/1711811618).fork()).ldelim();
                            if (message.enableCdn != null && Object.hasOwnProperty.call(message, "enableCdn"))
                                writer.uint32(/* id 282942321, wireType 0 =*/2263538568).bool(message.enableCdn);
                            if (message.bucketName != null && Object.hasOwnProperty.call(message, "bucketName"))
                                writer.uint32(/* id 283610048, wireType 2 =*/2268880386).string(message.bucketName);
                            if (message.customResponseHeaders != null && message.customResponseHeaders.length)
                                for (var i = 0; i < message.customResponseHeaders.length; ++i)
                                    writer.uint32(/* id 387539094, wireType 2 =*/3100312754).string(message.customResponseHeaders[i]);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendBucket message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendBucket.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @static
                         * @param {google.cloud.compute.v1.IBackendBucket} message BackendBucket message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendBucket.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendBucket message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendBucket} BackendBucket
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendBucket.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendBucket();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 283610048: {
                                        message.bucketName = reader.string();
                                        break;
                                    }
                                case 213976452: {
                                        message.cdnPolicy = $root.google.cloud.compute.v1.BackendBucketCdnPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 95520988: {
                                        message.compressionMode = reader.string();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 387539094: {
                                        if (!(message.customResponseHeaders && message.customResponseHeaders.length))
                                            message.customResponseHeaders = [];
                                        message.customResponseHeaders.push(reader.string());
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 41036943: {
                                        message.edgeSecurityPolicy = reader.string();
                                        break;
                                    }
                                case 282942321: {
                                        message.enableCdn = reader.bool();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendBucket message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendBucket} BackendBucket
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendBucket.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendBucket message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendBucket.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.bucketName != null && message.hasOwnProperty("bucketName")) {
                                properties._bucketName = 1;
                                if (!$util.isString(message.bucketName))
                                    return "bucketName: string expected";
                            }
                            if (message.cdnPolicy != null && message.hasOwnProperty("cdnPolicy")) {
                                properties._cdnPolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.BackendBucketCdnPolicy.verify(message.cdnPolicy);
                                    if (error)
                                        return "cdnPolicy." + error;
                                }
                            }
                            if (message.compressionMode != null && message.hasOwnProperty("compressionMode")) {
                                properties._compressionMode = 1;
                                if (!$util.isString(message.compressionMode))
                                    return "compressionMode: string expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.customResponseHeaders != null && message.hasOwnProperty("customResponseHeaders")) {
                                if (!Array.isArray(message.customResponseHeaders))
                                    return "customResponseHeaders: array expected";
                                for (var i = 0; i < message.customResponseHeaders.length; ++i)
                                    if (!$util.isString(message.customResponseHeaders[i]))
                                        return "customResponseHeaders: string[] expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.edgeSecurityPolicy != null && message.hasOwnProperty("edgeSecurityPolicy")) {
                                properties._edgeSecurityPolicy = 1;
                                if (!$util.isString(message.edgeSecurityPolicy))
                                    return "edgeSecurityPolicy: string expected";
                            }
                            if (message.enableCdn != null && message.hasOwnProperty("enableCdn")) {
                                properties._enableCdn = 1;
                                if (typeof message.enableCdn !== "boolean")
                                    return "enableCdn: boolean expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendBucket message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendBucket} BackendBucket
                         */
                        BackendBucket.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendBucket)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendBucket();
                            if (object.bucketName != null)
                                message.bucketName = String(object.bucketName);
                            if (object.cdnPolicy != null) {
                                if (typeof object.cdnPolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendBucket.cdnPolicy: object expected");
                                message.cdnPolicy = $root.google.cloud.compute.v1.BackendBucketCdnPolicy.fromObject(object.cdnPolicy);
                            }
                            if (object.compressionMode != null)
                                message.compressionMode = String(object.compressionMode);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.customResponseHeaders) {
                                if (!Array.isArray(object.customResponseHeaders))
                                    throw TypeError(".google.cloud.compute.v1.BackendBucket.customResponseHeaders: array expected");
                                message.customResponseHeaders = [];
                                for (var i = 0; i < object.customResponseHeaders.length; ++i)
                                    message.customResponseHeaders[i] = String(object.customResponseHeaders[i]);
                            }
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.edgeSecurityPolicy != null)
                                message.edgeSecurityPolicy = String(object.edgeSecurityPolicy);
                            if (object.enableCdn != null)
                                message.enableCdn = Boolean(object.enableCdn);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendBucket message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @static
                         * @param {google.cloud.compute.v1.BackendBucket} message BackendBucket
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendBucket.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.customResponseHeaders = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.edgeSecurityPolicy != null && message.hasOwnProperty("edgeSecurityPolicy")) {
                                object.edgeSecurityPolicy = message.edgeSecurityPolicy;
                                if (options.oneofs)
                                    object._edgeSecurityPolicy = "edgeSecurityPolicy";
                            }
                            if (message.compressionMode != null && message.hasOwnProperty("compressionMode")) {
                                object.compressionMode = message.compressionMode;
                                if (options.oneofs)
                                    object._compressionMode = "compressionMode";
                            }
                            if (message.cdnPolicy != null && message.hasOwnProperty("cdnPolicy")) {
                                object.cdnPolicy = $root.google.cloud.compute.v1.BackendBucketCdnPolicy.toObject(message.cdnPolicy, options);
                                if (options.oneofs)
                                    object._cdnPolicy = "cdnPolicy";
                            }
                            if (message.enableCdn != null && message.hasOwnProperty("enableCdn")) {
                                object.enableCdn = message.enableCdn;
                                if (options.oneofs)
                                    object._enableCdn = "enableCdn";
                            }
                            if (message.bucketName != null && message.hasOwnProperty("bucketName")) {
                                object.bucketName = message.bucketName;
                                if (options.oneofs)
                                    object._bucketName = "bucketName";
                            }
                            if (message.customResponseHeaders && message.customResponseHeaders.length) {
                                object.customResponseHeaders = [];
                                for (var j = 0; j < message.customResponseHeaders.length; ++j)
                                    object.customResponseHeaders[j] = message.customResponseHeaders[j];
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendBucket to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendBucket.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendBucket
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendBucket
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendBucket.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendBucket";
                        };
    
                        /**
                         * CompressionMode enum.
                         * @name google.cloud.compute.v1.BackendBucket.CompressionMode
                         * @enum {number}
                         * @property {number} UNDEFINED_COMPRESSION_MODE=0 UNDEFINED_COMPRESSION_MODE value
                         * @property {number} AUTOMATIC=165298699 AUTOMATIC value
                         * @property {number} DISABLED=516696700 DISABLED value
                         */
                        BackendBucket.CompressionMode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_COMPRESSION_MODE"] = 0;
                            values[valuesById[165298699] = "AUTOMATIC"] = 165298699;
                            values[valuesById[516696700] = "DISABLED"] = 516696700;
                            return values;
                        })();
    
                        return BackendBucket;
                    })();
    
                    v1.BackendBucketCdnPolicy = (function() {
    
                        /**
                         * Properties of a BackendBucketCdnPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendBucketCdnPolicy
                         * @property {Array.<google.cloud.compute.v1.IBackendBucketCdnPolicyBypassCacheOnRequestHeader>|null} [bypassCacheOnRequestHeaders] BackendBucketCdnPolicy bypassCacheOnRequestHeaders
                         * @property {google.cloud.compute.v1.IBackendBucketCdnPolicyCacheKeyPolicy|null} [cacheKeyPolicy] BackendBucketCdnPolicy cacheKeyPolicy
                         * @property {string|null} [cacheMode] BackendBucketCdnPolicy cacheMode
                         * @property {number|null} [clientTtl] BackendBucketCdnPolicy clientTtl
                         * @property {number|null} [defaultTtl] BackendBucketCdnPolicy defaultTtl
                         * @property {number|null} [maxTtl] BackendBucketCdnPolicy maxTtl
                         * @property {boolean|null} [negativeCaching] BackendBucketCdnPolicy negativeCaching
                         * @property {Array.<google.cloud.compute.v1.IBackendBucketCdnPolicyNegativeCachingPolicy>|null} [negativeCachingPolicy] BackendBucketCdnPolicy negativeCachingPolicy
                         * @property {boolean|null} [requestCoalescing] BackendBucketCdnPolicy requestCoalescing
                         * @property {number|null} [serveWhileStale] BackendBucketCdnPolicy serveWhileStale
                         * @property {number|Long|null} [signedUrlCacheMaxAgeSec] BackendBucketCdnPolicy signedUrlCacheMaxAgeSec
                         * @property {Array.<string>|null} [signedUrlKeyNames] BackendBucketCdnPolicy signedUrlKeyNames
                         */
    
                        /**
                         * Constructs a new BackendBucketCdnPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendBucketCdnPolicy.
                         * @implements IBackendBucketCdnPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendBucketCdnPolicy=} [properties] Properties to set
                         */
                        function BackendBucketCdnPolicy(properties) {
                            this.bypassCacheOnRequestHeaders = [];
                            this.negativeCachingPolicy = [];
                            this.signedUrlKeyNames = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendBucketCdnPolicy bypassCacheOnRequestHeaders.
                         * @member {Array.<google.cloud.compute.v1.IBackendBucketCdnPolicyBypassCacheOnRequestHeader>} bypassCacheOnRequestHeaders
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        BackendBucketCdnPolicy.prototype.bypassCacheOnRequestHeaders = $util.emptyArray;
    
                        /**
                         * BackendBucketCdnPolicy cacheKeyPolicy.
                         * @member {google.cloud.compute.v1.IBackendBucketCdnPolicyCacheKeyPolicy|null|undefined} cacheKeyPolicy
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        BackendBucketCdnPolicy.prototype.cacheKeyPolicy = null;
    
                        /**
                         * BackendBucketCdnPolicy cacheMode.
                         * @member {string|null|undefined} cacheMode
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        BackendBucketCdnPolicy.prototype.cacheMode = null;
    
                        /**
                         * BackendBucketCdnPolicy clientTtl.
                         * @member {number|null|undefined} clientTtl
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        BackendBucketCdnPolicy.prototype.clientTtl = null;
    
                        /**
                         * BackendBucketCdnPolicy defaultTtl.
                         * @member {number|null|undefined} defaultTtl
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        BackendBucketCdnPolicy.prototype.defaultTtl = null;
    
                        /**
                         * BackendBucketCdnPolicy maxTtl.
                         * @member {number|null|undefined} maxTtl
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        BackendBucketCdnPolicy.prototype.maxTtl = null;
    
                        /**
                         * BackendBucketCdnPolicy negativeCaching.
                         * @member {boolean|null|undefined} negativeCaching
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        BackendBucketCdnPolicy.prototype.negativeCaching = null;
    
                        /**
                         * BackendBucketCdnPolicy negativeCachingPolicy.
                         * @member {Array.<google.cloud.compute.v1.IBackendBucketCdnPolicyNegativeCachingPolicy>} negativeCachingPolicy
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        BackendBucketCdnPolicy.prototype.negativeCachingPolicy = $util.emptyArray;
    
                        /**
                         * BackendBucketCdnPolicy requestCoalescing.
                         * @member {boolean|null|undefined} requestCoalescing
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        BackendBucketCdnPolicy.prototype.requestCoalescing = null;
    
                        /**
                         * BackendBucketCdnPolicy serveWhileStale.
                         * @member {number|null|undefined} serveWhileStale
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        BackendBucketCdnPolicy.prototype.serveWhileStale = null;
    
                        /**
                         * BackendBucketCdnPolicy signedUrlCacheMaxAgeSec.
                         * @member {number|Long|null|undefined} signedUrlCacheMaxAgeSec
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        BackendBucketCdnPolicy.prototype.signedUrlCacheMaxAgeSec = null;
    
                        /**
                         * BackendBucketCdnPolicy signedUrlKeyNames.
                         * @member {Array.<string>} signedUrlKeyNames
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        BackendBucketCdnPolicy.prototype.signedUrlKeyNames = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendBucketCdnPolicy _cacheKeyPolicy.
                         * @member {"cacheKeyPolicy"|undefined} _cacheKeyPolicy
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendBucketCdnPolicy.prototype, "_cacheKeyPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["cacheKeyPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucketCdnPolicy _cacheMode.
                         * @member {"cacheMode"|undefined} _cacheMode
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendBucketCdnPolicy.prototype, "_cacheMode", {
                            get: $util.oneOfGetter($oneOfFields = ["cacheMode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucketCdnPolicy _clientTtl.
                         * @member {"clientTtl"|undefined} _clientTtl
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendBucketCdnPolicy.prototype, "_clientTtl", {
                            get: $util.oneOfGetter($oneOfFields = ["clientTtl"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucketCdnPolicy _defaultTtl.
                         * @member {"defaultTtl"|undefined} _defaultTtl
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendBucketCdnPolicy.prototype, "_defaultTtl", {
                            get: $util.oneOfGetter($oneOfFields = ["defaultTtl"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucketCdnPolicy _maxTtl.
                         * @member {"maxTtl"|undefined} _maxTtl
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendBucketCdnPolicy.prototype, "_maxTtl", {
                            get: $util.oneOfGetter($oneOfFields = ["maxTtl"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucketCdnPolicy _negativeCaching.
                         * @member {"negativeCaching"|undefined} _negativeCaching
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendBucketCdnPolicy.prototype, "_negativeCaching", {
                            get: $util.oneOfGetter($oneOfFields = ["negativeCaching"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucketCdnPolicy _requestCoalescing.
                         * @member {"requestCoalescing"|undefined} _requestCoalescing
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendBucketCdnPolicy.prototype, "_requestCoalescing", {
                            get: $util.oneOfGetter($oneOfFields = ["requestCoalescing"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucketCdnPolicy _serveWhileStale.
                         * @member {"serveWhileStale"|undefined} _serveWhileStale
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendBucketCdnPolicy.prototype, "_serveWhileStale", {
                            get: $util.oneOfGetter($oneOfFields = ["serveWhileStale"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucketCdnPolicy _signedUrlCacheMaxAgeSec.
                         * @member {"signedUrlCacheMaxAgeSec"|undefined} _signedUrlCacheMaxAgeSec
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendBucketCdnPolicy.prototype, "_signedUrlCacheMaxAgeSec", {
                            get: $util.oneOfGetter($oneOfFields = ["signedUrlCacheMaxAgeSec"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendBucketCdnPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendBucketCdnPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendBucketCdnPolicy} BackendBucketCdnPolicy instance
                         */
                        BackendBucketCdnPolicy.create = function create(properties) {
                            return new BackendBucketCdnPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified BackendBucketCdnPolicy message. Does not implicitly {@link google.cloud.compute.v1.BackendBucketCdnPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendBucketCdnPolicy} message BackendBucketCdnPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendBucketCdnPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.cacheMode != null && Object.hasOwnProperty.call(message, "cacheMode"))
                                writer.uint32(/* id 28877888, wireType 2 =*/231023106).string(message.cacheMode);
                            if (message.clientTtl != null && Object.hasOwnProperty.call(message, "clientTtl"))
                                writer.uint32(/* id 29034360, wireType 0 =*/232274880).int32(message.clientTtl);
                            if (message.defaultTtl != null && Object.hasOwnProperty.call(message, "defaultTtl"))
                                writer.uint32(/* id 100253422, wireType 0 =*/802027376).int32(message.defaultTtl);
                            if (message.negativeCachingPolicy != null && message.negativeCachingPolicy.length)
                                for (var i = 0; i < message.negativeCachingPolicy.length; ++i)
                                    $root.google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy.encode(message.negativeCachingPolicy[i], writer.uint32(/* id 155359996, wireType 2 =*/1242879970).fork()).ldelim();
                            if (message.cacheKeyPolicy != null && Object.hasOwnProperty.call(message, "cacheKeyPolicy"))
                                $root.google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy.encode(message.cacheKeyPolicy, writer.uint32(/* id 159263727, wireType 2 =*/1274109818).fork()).ldelim();
                            if (message.serveWhileStale != null && Object.hasOwnProperty.call(message, "serveWhileStale"))
                                writer.uint32(/* id 236682203, wireType 0 =*/1893457624).int32(message.serveWhileStale);
                            if (message.signedUrlCacheMaxAgeSec != null && Object.hasOwnProperty.call(message, "signedUrlCacheMaxAgeSec"))
                                writer.uint32(/* id 269374534, wireType 0 =*/2154996272).int64(message.signedUrlCacheMaxAgeSec);
                            if (message.maxTtl != null && Object.hasOwnProperty.call(message, "maxTtl"))
                                writer.uint32(/* id 307578001, wireType 0 =*/2460624008).int32(message.maxTtl);
                            if (message.negativeCaching != null && Object.hasOwnProperty.call(message, "negativeCaching"))
                                writer.uint32(/* id 336110005, wireType 0 =*/2688880040).bool(message.negativeCaching);
                            if (message.signedUrlKeyNames != null && message.signedUrlKeyNames.length)
                                for (var i = 0; i < message.signedUrlKeyNames.length; ++i)
                                    writer.uint32(/* id 371848885, wireType 2 =*/2974791082).string(message.signedUrlKeyNames[i]);
                            if (message.bypassCacheOnRequestHeaders != null && message.bypassCacheOnRequestHeaders.length)
                                for (var i = 0; i < message.bypassCacheOnRequestHeaders.length; ++i)
                                    $root.google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader.encode(message.bypassCacheOnRequestHeaders[i], writer.uint32(/* id 486203082, wireType 2 =*/3889624658).fork()).ldelim();
                            if (message.requestCoalescing != null && Object.hasOwnProperty.call(message, "requestCoalescing"))
                                writer.uint32(/* id 532808276, wireType 0 =*/4262466208).bool(message.requestCoalescing);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendBucketCdnPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendBucketCdnPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendBucketCdnPolicy} message BackendBucketCdnPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendBucketCdnPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendBucketCdnPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendBucketCdnPolicy} BackendBucketCdnPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendBucketCdnPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendBucketCdnPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 486203082: {
                                        if (!(message.bypassCacheOnRequestHeaders && message.bypassCacheOnRequestHeaders.length))
                                            message.bypassCacheOnRequestHeaders = [];
                                        message.bypassCacheOnRequestHeaders.push($root.google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 159263727: {
                                        message.cacheKeyPolicy = $root.google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 28877888: {
                                        message.cacheMode = reader.string();
                                        break;
                                    }
                                case 29034360: {
                                        message.clientTtl = reader.int32();
                                        break;
                                    }
                                case 100253422: {
                                        message.defaultTtl = reader.int32();
                                        break;
                                    }
                                case 307578001: {
                                        message.maxTtl = reader.int32();
                                        break;
                                    }
                                case 336110005: {
                                        message.negativeCaching = reader.bool();
                                        break;
                                    }
                                case 155359996: {
                                        if (!(message.negativeCachingPolicy && message.negativeCachingPolicy.length))
                                            message.negativeCachingPolicy = [];
                                        message.negativeCachingPolicy.push($root.google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 532808276: {
                                        message.requestCoalescing = reader.bool();
                                        break;
                                    }
                                case 236682203: {
                                        message.serveWhileStale = reader.int32();
                                        break;
                                    }
                                case 269374534: {
                                        message.signedUrlCacheMaxAgeSec = reader.int64();
                                        break;
                                    }
                                case 371848885: {
                                        if (!(message.signedUrlKeyNames && message.signedUrlKeyNames.length))
                                            message.signedUrlKeyNames = [];
                                        message.signedUrlKeyNames.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendBucketCdnPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendBucketCdnPolicy} BackendBucketCdnPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendBucketCdnPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendBucketCdnPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendBucketCdnPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.bypassCacheOnRequestHeaders != null && message.hasOwnProperty("bypassCacheOnRequestHeaders")) {
                                if (!Array.isArray(message.bypassCacheOnRequestHeaders))
                                    return "bypassCacheOnRequestHeaders: array expected";
                                for (var i = 0; i < message.bypassCacheOnRequestHeaders.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader.verify(message.bypassCacheOnRequestHeaders[i]);
                                    if (error)
                                        return "bypassCacheOnRequestHeaders." + error;
                                }
                            }
                            if (message.cacheKeyPolicy != null && message.hasOwnProperty("cacheKeyPolicy")) {
                                properties._cacheKeyPolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy.verify(message.cacheKeyPolicy);
                                    if (error)
                                        return "cacheKeyPolicy." + error;
                                }
                            }
                            if (message.cacheMode != null && message.hasOwnProperty("cacheMode")) {
                                properties._cacheMode = 1;
                                if (!$util.isString(message.cacheMode))
                                    return "cacheMode: string expected";
                            }
                            if (message.clientTtl != null && message.hasOwnProperty("clientTtl")) {
                                properties._clientTtl = 1;
                                if (!$util.isInteger(message.clientTtl))
                                    return "clientTtl: integer expected";
                            }
                            if (message.defaultTtl != null && message.hasOwnProperty("defaultTtl")) {
                                properties._defaultTtl = 1;
                                if (!$util.isInteger(message.defaultTtl))
                                    return "defaultTtl: integer expected";
                            }
                            if (message.maxTtl != null && message.hasOwnProperty("maxTtl")) {
                                properties._maxTtl = 1;
                                if (!$util.isInteger(message.maxTtl))
                                    return "maxTtl: integer expected";
                            }
                            if (message.negativeCaching != null && message.hasOwnProperty("negativeCaching")) {
                                properties._negativeCaching = 1;
                                if (typeof message.negativeCaching !== "boolean")
                                    return "negativeCaching: boolean expected";
                            }
                            if (message.negativeCachingPolicy != null && message.hasOwnProperty("negativeCachingPolicy")) {
                                if (!Array.isArray(message.negativeCachingPolicy))
                                    return "negativeCachingPolicy: array expected";
                                for (var i = 0; i < message.negativeCachingPolicy.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy.verify(message.negativeCachingPolicy[i]);
                                    if (error)
                                        return "negativeCachingPolicy." + error;
                                }
                            }
                            if (message.requestCoalescing != null && message.hasOwnProperty("requestCoalescing")) {
                                properties._requestCoalescing = 1;
                                if (typeof message.requestCoalescing !== "boolean")
                                    return "requestCoalescing: boolean expected";
                            }
                            if (message.serveWhileStale != null && message.hasOwnProperty("serveWhileStale")) {
                                properties._serveWhileStale = 1;
                                if (!$util.isInteger(message.serveWhileStale))
                                    return "serveWhileStale: integer expected";
                            }
                            if (message.signedUrlCacheMaxAgeSec != null && message.hasOwnProperty("signedUrlCacheMaxAgeSec")) {
                                properties._signedUrlCacheMaxAgeSec = 1;
                                if (!$util.isInteger(message.signedUrlCacheMaxAgeSec) && !(message.signedUrlCacheMaxAgeSec && $util.isInteger(message.signedUrlCacheMaxAgeSec.low) && $util.isInteger(message.signedUrlCacheMaxAgeSec.high)))
                                    return "signedUrlCacheMaxAgeSec: integer|Long expected";
                            }
                            if (message.signedUrlKeyNames != null && message.hasOwnProperty("signedUrlKeyNames")) {
                                if (!Array.isArray(message.signedUrlKeyNames))
                                    return "signedUrlKeyNames: array expected";
                                for (var i = 0; i < message.signedUrlKeyNames.length; ++i)
                                    if (!$util.isString(message.signedUrlKeyNames[i]))
                                        return "signedUrlKeyNames: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendBucketCdnPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendBucketCdnPolicy} BackendBucketCdnPolicy
                         */
                        BackendBucketCdnPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendBucketCdnPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendBucketCdnPolicy();
                            if (object.bypassCacheOnRequestHeaders) {
                                if (!Array.isArray(object.bypassCacheOnRequestHeaders))
                                    throw TypeError(".google.cloud.compute.v1.BackendBucketCdnPolicy.bypassCacheOnRequestHeaders: array expected");
                                message.bypassCacheOnRequestHeaders = [];
                                for (var i = 0; i < object.bypassCacheOnRequestHeaders.length; ++i) {
                                    if (typeof object.bypassCacheOnRequestHeaders[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.BackendBucketCdnPolicy.bypassCacheOnRequestHeaders: object expected");
                                    message.bypassCacheOnRequestHeaders[i] = $root.google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader.fromObject(object.bypassCacheOnRequestHeaders[i]);
                                }
                            }
                            if (object.cacheKeyPolicy != null) {
                                if (typeof object.cacheKeyPolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendBucketCdnPolicy.cacheKeyPolicy: object expected");
                                message.cacheKeyPolicy = $root.google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy.fromObject(object.cacheKeyPolicy);
                            }
                            if (object.cacheMode != null)
                                message.cacheMode = String(object.cacheMode);
                            if (object.clientTtl != null)
                                message.clientTtl = object.clientTtl | 0;
                            if (object.defaultTtl != null)
                                message.defaultTtl = object.defaultTtl | 0;
                            if (object.maxTtl != null)
                                message.maxTtl = object.maxTtl | 0;
                            if (object.negativeCaching != null)
                                message.negativeCaching = Boolean(object.negativeCaching);
                            if (object.negativeCachingPolicy) {
                                if (!Array.isArray(object.negativeCachingPolicy))
                                    throw TypeError(".google.cloud.compute.v1.BackendBucketCdnPolicy.negativeCachingPolicy: array expected");
                                message.negativeCachingPolicy = [];
                                for (var i = 0; i < object.negativeCachingPolicy.length; ++i) {
                                    if (typeof object.negativeCachingPolicy[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.BackendBucketCdnPolicy.negativeCachingPolicy: object expected");
                                    message.negativeCachingPolicy[i] = $root.google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy.fromObject(object.negativeCachingPolicy[i]);
                                }
                            }
                            if (object.requestCoalescing != null)
                                message.requestCoalescing = Boolean(object.requestCoalescing);
                            if (object.serveWhileStale != null)
                                message.serveWhileStale = object.serveWhileStale | 0;
                            if (object.signedUrlCacheMaxAgeSec != null)
                                if ($util.Long)
                                    (message.signedUrlCacheMaxAgeSec = $util.Long.fromValue(object.signedUrlCacheMaxAgeSec)).unsigned = false;
                                else if (typeof object.signedUrlCacheMaxAgeSec === "string")
                                    message.signedUrlCacheMaxAgeSec = parseInt(object.signedUrlCacheMaxAgeSec, 10);
                                else if (typeof object.signedUrlCacheMaxAgeSec === "number")
                                    message.signedUrlCacheMaxAgeSec = object.signedUrlCacheMaxAgeSec;
                                else if (typeof object.signedUrlCacheMaxAgeSec === "object")
                                    message.signedUrlCacheMaxAgeSec = new $util.LongBits(object.signedUrlCacheMaxAgeSec.low >>> 0, object.signedUrlCacheMaxAgeSec.high >>> 0).toNumber();
                            if (object.signedUrlKeyNames) {
                                if (!Array.isArray(object.signedUrlKeyNames))
                                    throw TypeError(".google.cloud.compute.v1.BackendBucketCdnPolicy.signedUrlKeyNames: array expected");
                                message.signedUrlKeyNames = [];
                                for (var i = 0; i < object.signedUrlKeyNames.length; ++i)
                                    message.signedUrlKeyNames[i] = String(object.signedUrlKeyNames[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendBucketCdnPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @static
                         * @param {google.cloud.compute.v1.BackendBucketCdnPolicy} message BackendBucketCdnPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendBucketCdnPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.negativeCachingPolicy = [];
                                object.signedUrlKeyNames = [];
                                object.bypassCacheOnRequestHeaders = [];
                            }
                            if (message.cacheMode != null && message.hasOwnProperty("cacheMode")) {
                                object.cacheMode = message.cacheMode;
                                if (options.oneofs)
                                    object._cacheMode = "cacheMode";
                            }
                            if (message.clientTtl != null && message.hasOwnProperty("clientTtl")) {
                                object.clientTtl = message.clientTtl;
                                if (options.oneofs)
                                    object._clientTtl = "clientTtl";
                            }
                            if (message.defaultTtl != null && message.hasOwnProperty("defaultTtl")) {
                                object.defaultTtl = message.defaultTtl;
                                if (options.oneofs)
                                    object._defaultTtl = "defaultTtl";
                            }
                            if (message.negativeCachingPolicy && message.negativeCachingPolicy.length) {
                                object.negativeCachingPolicy = [];
                                for (var j = 0; j < message.negativeCachingPolicy.length; ++j)
                                    object.negativeCachingPolicy[j] = $root.google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy.toObject(message.negativeCachingPolicy[j], options);
                            }
                            if (message.cacheKeyPolicy != null && message.hasOwnProperty("cacheKeyPolicy")) {
                                object.cacheKeyPolicy = $root.google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy.toObject(message.cacheKeyPolicy, options);
                                if (options.oneofs)
                                    object._cacheKeyPolicy = "cacheKeyPolicy";
                            }
                            if (message.serveWhileStale != null && message.hasOwnProperty("serveWhileStale")) {
                                object.serveWhileStale = message.serveWhileStale;
                                if (options.oneofs)
                                    object._serveWhileStale = "serveWhileStale";
                            }
                            if (message.signedUrlCacheMaxAgeSec != null && message.hasOwnProperty("signedUrlCacheMaxAgeSec")) {
                                if (typeof message.signedUrlCacheMaxAgeSec === "number")
                                    object.signedUrlCacheMaxAgeSec = options.longs === String ? String(message.signedUrlCacheMaxAgeSec) : message.signedUrlCacheMaxAgeSec;
                                else
                                    object.signedUrlCacheMaxAgeSec = options.longs === String ? $util.Long.prototype.toString.call(message.signedUrlCacheMaxAgeSec) : options.longs === Number ? new $util.LongBits(message.signedUrlCacheMaxAgeSec.low >>> 0, message.signedUrlCacheMaxAgeSec.high >>> 0).toNumber() : message.signedUrlCacheMaxAgeSec;
                                if (options.oneofs)
                                    object._signedUrlCacheMaxAgeSec = "signedUrlCacheMaxAgeSec";
                            }
                            if (message.maxTtl != null && message.hasOwnProperty("maxTtl")) {
                                object.maxTtl = message.maxTtl;
                                if (options.oneofs)
                                    object._maxTtl = "maxTtl";
                            }
                            if (message.negativeCaching != null && message.hasOwnProperty("negativeCaching")) {
                                object.negativeCaching = message.negativeCaching;
                                if (options.oneofs)
                                    object._negativeCaching = "negativeCaching";
                            }
                            if (message.signedUrlKeyNames && message.signedUrlKeyNames.length) {
                                object.signedUrlKeyNames = [];
                                for (var j = 0; j < message.signedUrlKeyNames.length; ++j)
                                    object.signedUrlKeyNames[j] = message.signedUrlKeyNames[j];
                            }
                            if (message.bypassCacheOnRequestHeaders && message.bypassCacheOnRequestHeaders.length) {
                                object.bypassCacheOnRequestHeaders = [];
                                for (var j = 0; j < message.bypassCacheOnRequestHeaders.length; ++j)
                                    object.bypassCacheOnRequestHeaders[j] = $root.google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader.toObject(message.bypassCacheOnRequestHeaders[j], options);
                            }
                            if (message.requestCoalescing != null && message.hasOwnProperty("requestCoalescing")) {
                                object.requestCoalescing = message.requestCoalescing;
                                if (options.oneofs)
                                    object._requestCoalescing = "requestCoalescing";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendBucketCdnPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendBucketCdnPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendBucketCdnPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendBucketCdnPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendBucketCdnPolicy";
                        };
    
                        /**
                         * CacheMode enum.
                         * @name google.cloud.compute.v1.BackendBucketCdnPolicy.CacheMode
                         * @enum {number}
                         * @property {number} UNDEFINED_CACHE_MODE=0 UNDEFINED_CACHE_MODE value
                         * @property {number} CACHE_ALL_STATIC=355027945 CACHE_ALL_STATIC value
                         * @property {number} FORCE_CACHE_ALL=486026928 FORCE_CACHE_ALL value
                         * @property {number} INVALID_CACHE_MODE=381295560 INVALID_CACHE_MODE value
                         * @property {number} USE_ORIGIN_HEADERS=55380261 USE_ORIGIN_HEADERS value
                         */
                        BackendBucketCdnPolicy.CacheMode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_CACHE_MODE"] = 0;
                            values[valuesById[355027945] = "CACHE_ALL_STATIC"] = 355027945;
                            values[valuesById[486026928] = "FORCE_CACHE_ALL"] = 486026928;
                            values[valuesById[381295560] = "INVALID_CACHE_MODE"] = 381295560;
                            values[valuesById[55380261] = "USE_ORIGIN_HEADERS"] = 55380261;
                            return values;
                        })();
    
                        return BackendBucketCdnPolicy;
                    })();
    
                    v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader = (function() {
    
                        /**
                         * Properties of a BackendBucketCdnPolicyBypassCacheOnRequestHeader.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendBucketCdnPolicyBypassCacheOnRequestHeader
                         * @property {string|null} [headerName] BackendBucketCdnPolicyBypassCacheOnRequestHeader headerName
                         */
    
                        /**
                         * Constructs a new BackendBucketCdnPolicyBypassCacheOnRequestHeader.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendBucketCdnPolicyBypassCacheOnRequestHeader.
                         * @implements IBackendBucketCdnPolicyBypassCacheOnRequestHeader
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendBucketCdnPolicyBypassCacheOnRequestHeader=} [properties] Properties to set
                         */
                        function BackendBucketCdnPolicyBypassCacheOnRequestHeader(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendBucketCdnPolicyBypassCacheOnRequestHeader headerName.
                         * @member {string|null|undefined} headerName
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader
                         * @instance
                         */
                        BackendBucketCdnPolicyBypassCacheOnRequestHeader.prototype.headerName = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendBucketCdnPolicyBypassCacheOnRequestHeader _headerName.
                         * @member {"headerName"|undefined} _headerName
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader
                         * @instance
                         */
                        Object.defineProperty(BackendBucketCdnPolicyBypassCacheOnRequestHeader.prototype, "_headerName", {
                            get: $util.oneOfGetter($oneOfFields = ["headerName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendBucketCdnPolicyBypassCacheOnRequestHeader instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader
                         * @static
                         * @param {google.cloud.compute.v1.IBackendBucketCdnPolicyBypassCacheOnRequestHeader=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader} BackendBucketCdnPolicyBypassCacheOnRequestHeader instance
                         */
                        BackendBucketCdnPolicyBypassCacheOnRequestHeader.create = function create(properties) {
                            return new BackendBucketCdnPolicyBypassCacheOnRequestHeader(properties);
                        };
    
                        /**
                         * Encodes the specified BackendBucketCdnPolicyBypassCacheOnRequestHeader message. Does not implicitly {@link google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader
                         * @static
                         * @param {google.cloud.compute.v1.IBackendBucketCdnPolicyBypassCacheOnRequestHeader} message BackendBucketCdnPolicyBypassCacheOnRequestHeader message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendBucketCdnPolicyBypassCacheOnRequestHeader.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.headerName != null && Object.hasOwnProperty.call(message, "headerName"))
                                writer.uint32(/* id 110223613, wireType 2 =*/881788906).string(message.headerName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendBucketCdnPolicyBypassCacheOnRequestHeader message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader
                         * @static
                         * @param {google.cloud.compute.v1.IBackendBucketCdnPolicyBypassCacheOnRequestHeader} message BackendBucketCdnPolicyBypassCacheOnRequestHeader message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendBucketCdnPolicyBypassCacheOnRequestHeader.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendBucketCdnPolicyBypassCacheOnRequestHeader message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader} BackendBucketCdnPolicyBypassCacheOnRequestHeader
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendBucketCdnPolicyBypassCacheOnRequestHeader.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 110223613: {
                                        message.headerName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendBucketCdnPolicyBypassCacheOnRequestHeader message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader} BackendBucketCdnPolicyBypassCacheOnRequestHeader
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendBucketCdnPolicyBypassCacheOnRequestHeader.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendBucketCdnPolicyBypassCacheOnRequestHeader message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendBucketCdnPolicyBypassCacheOnRequestHeader.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.headerName != null && message.hasOwnProperty("headerName")) {
                                properties._headerName = 1;
                                if (!$util.isString(message.headerName))
                                    return "headerName: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendBucketCdnPolicyBypassCacheOnRequestHeader message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader} BackendBucketCdnPolicyBypassCacheOnRequestHeader
                         */
                        BackendBucketCdnPolicyBypassCacheOnRequestHeader.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader();
                            if (object.headerName != null)
                                message.headerName = String(object.headerName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendBucketCdnPolicyBypassCacheOnRequestHeader message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader
                         * @static
                         * @param {google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader} message BackendBucketCdnPolicyBypassCacheOnRequestHeader
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendBucketCdnPolicyBypassCacheOnRequestHeader.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.headerName != null && message.hasOwnProperty("headerName")) {
                                object.headerName = message.headerName;
                                if (options.oneofs)
                                    object._headerName = "headerName";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendBucketCdnPolicyBypassCacheOnRequestHeader to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendBucketCdnPolicyBypassCacheOnRequestHeader.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendBucketCdnPolicyBypassCacheOnRequestHeader
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendBucketCdnPolicyBypassCacheOnRequestHeader.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendBucketCdnPolicyBypassCacheOnRequestHeader";
                        };
    
                        return BackendBucketCdnPolicyBypassCacheOnRequestHeader;
                    })();
    
                    v1.BackendBucketCdnPolicyCacheKeyPolicy = (function() {
    
                        /**
                         * Properties of a BackendBucketCdnPolicyCacheKeyPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendBucketCdnPolicyCacheKeyPolicy
                         * @property {Array.<string>|null} [includeHttpHeaders] BackendBucketCdnPolicyCacheKeyPolicy includeHttpHeaders
                         * @property {Array.<string>|null} [queryStringWhitelist] BackendBucketCdnPolicyCacheKeyPolicy queryStringWhitelist
                         */
    
                        /**
                         * Constructs a new BackendBucketCdnPolicyCacheKeyPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendBucketCdnPolicyCacheKeyPolicy.
                         * @implements IBackendBucketCdnPolicyCacheKeyPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendBucketCdnPolicyCacheKeyPolicy=} [properties] Properties to set
                         */
                        function BackendBucketCdnPolicyCacheKeyPolicy(properties) {
                            this.includeHttpHeaders = [];
                            this.queryStringWhitelist = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendBucketCdnPolicyCacheKeyPolicy includeHttpHeaders.
                         * @member {Array.<string>} includeHttpHeaders
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy
                         * @instance
                         */
                        BackendBucketCdnPolicyCacheKeyPolicy.prototype.includeHttpHeaders = $util.emptyArray;
    
                        /**
                         * BackendBucketCdnPolicyCacheKeyPolicy queryStringWhitelist.
                         * @member {Array.<string>} queryStringWhitelist
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy
                         * @instance
                         */
                        BackendBucketCdnPolicyCacheKeyPolicy.prototype.queryStringWhitelist = $util.emptyArray;
    
                        /**
                         * Creates a new BackendBucketCdnPolicyCacheKeyPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendBucketCdnPolicyCacheKeyPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy} BackendBucketCdnPolicyCacheKeyPolicy instance
                         */
                        BackendBucketCdnPolicyCacheKeyPolicy.create = function create(properties) {
                            return new BackendBucketCdnPolicyCacheKeyPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified BackendBucketCdnPolicyCacheKeyPolicy message. Does not implicitly {@link google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendBucketCdnPolicyCacheKeyPolicy} message BackendBucketCdnPolicyCacheKeyPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendBucketCdnPolicyCacheKeyPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.includeHttpHeaders != null && message.includeHttpHeaders.length)
                                for (var i = 0; i < message.includeHttpHeaders.length; ++i)
                                    writer.uint32(/* id 2489606, wireType 2 =*/19916850).string(message.includeHttpHeaders[i]);
                            if (message.queryStringWhitelist != null && message.queryStringWhitelist.length)
                                for (var i = 0; i < message.queryStringWhitelist.length; ++i)
                                    writer.uint32(/* id 52456496, wireType 2 =*/419651970).string(message.queryStringWhitelist[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendBucketCdnPolicyCacheKeyPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendBucketCdnPolicyCacheKeyPolicy} message BackendBucketCdnPolicyCacheKeyPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendBucketCdnPolicyCacheKeyPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendBucketCdnPolicyCacheKeyPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy} BackendBucketCdnPolicyCacheKeyPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendBucketCdnPolicyCacheKeyPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2489606: {
                                        if (!(message.includeHttpHeaders && message.includeHttpHeaders.length))
                                            message.includeHttpHeaders = [];
                                        message.includeHttpHeaders.push(reader.string());
                                        break;
                                    }
                                case 52456496: {
                                        if (!(message.queryStringWhitelist && message.queryStringWhitelist.length))
                                            message.queryStringWhitelist = [];
                                        message.queryStringWhitelist.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendBucketCdnPolicyCacheKeyPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy} BackendBucketCdnPolicyCacheKeyPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendBucketCdnPolicyCacheKeyPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendBucketCdnPolicyCacheKeyPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendBucketCdnPolicyCacheKeyPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.includeHttpHeaders != null && message.hasOwnProperty("includeHttpHeaders")) {
                                if (!Array.isArray(message.includeHttpHeaders))
                                    return "includeHttpHeaders: array expected";
                                for (var i = 0; i < message.includeHttpHeaders.length; ++i)
                                    if (!$util.isString(message.includeHttpHeaders[i]))
                                        return "includeHttpHeaders: string[] expected";
                            }
                            if (message.queryStringWhitelist != null && message.hasOwnProperty("queryStringWhitelist")) {
                                if (!Array.isArray(message.queryStringWhitelist))
                                    return "queryStringWhitelist: array expected";
                                for (var i = 0; i < message.queryStringWhitelist.length; ++i)
                                    if (!$util.isString(message.queryStringWhitelist[i]))
                                        return "queryStringWhitelist: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendBucketCdnPolicyCacheKeyPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy} BackendBucketCdnPolicyCacheKeyPolicy
                         */
                        BackendBucketCdnPolicyCacheKeyPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy();
                            if (object.includeHttpHeaders) {
                                if (!Array.isArray(object.includeHttpHeaders))
                                    throw TypeError(".google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy.includeHttpHeaders: array expected");
                                message.includeHttpHeaders = [];
                                for (var i = 0; i < object.includeHttpHeaders.length; ++i)
                                    message.includeHttpHeaders[i] = String(object.includeHttpHeaders[i]);
                            }
                            if (object.queryStringWhitelist) {
                                if (!Array.isArray(object.queryStringWhitelist))
                                    throw TypeError(".google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy.queryStringWhitelist: array expected");
                                message.queryStringWhitelist = [];
                                for (var i = 0; i < object.queryStringWhitelist.length; ++i)
                                    message.queryStringWhitelist[i] = String(object.queryStringWhitelist[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendBucketCdnPolicyCacheKeyPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy
                         * @static
                         * @param {google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy} message BackendBucketCdnPolicyCacheKeyPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendBucketCdnPolicyCacheKeyPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.includeHttpHeaders = [];
                                object.queryStringWhitelist = [];
                            }
                            if (message.includeHttpHeaders && message.includeHttpHeaders.length) {
                                object.includeHttpHeaders = [];
                                for (var j = 0; j < message.includeHttpHeaders.length; ++j)
                                    object.includeHttpHeaders[j] = message.includeHttpHeaders[j];
                            }
                            if (message.queryStringWhitelist && message.queryStringWhitelist.length) {
                                object.queryStringWhitelist = [];
                                for (var j = 0; j < message.queryStringWhitelist.length; ++j)
                                    object.queryStringWhitelist[j] = message.queryStringWhitelist[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendBucketCdnPolicyCacheKeyPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendBucketCdnPolicyCacheKeyPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendBucketCdnPolicyCacheKeyPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendBucketCdnPolicyCacheKeyPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendBucketCdnPolicyCacheKeyPolicy";
                        };
    
                        return BackendBucketCdnPolicyCacheKeyPolicy;
                    })();
    
                    v1.BackendBucketCdnPolicyNegativeCachingPolicy = (function() {
    
                        /**
                         * Properties of a BackendBucketCdnPolicyNegativeCachingPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendBucketCdnPolicyNegativeCachingPolicy
                         * @property {number|null} [code] BackendBucketCdnPolicyNegativeCachingPolicy code
                         * @property {number|null} [ttl] BackendBucketCdnPolicyNegativeCachingPolicy ttl
                         */
    
                        /**
                         * Constructs a new BackendBucketCdnPolicyNegativeCachingPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendBucketCdnPolicyNegativeCachingPolicy.
                         * @implements IBackendBucketCdnPolicyNegativeCachingPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendBucketCdnPolicyNegativeCachingPolicy=} [properties] Properties to set
                         */
                        function BackendBucketCdnPolicyNegativeCachingPolicy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendBucketCdnPolicyNegativeCachingPolicy code.
                         * @member {number|null|undefined} code
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy
                         * @instance
                         */
                        BackendBucketCdnPolicyNegativeCachingPolicy.prototype.code = null;
    
                        /**
                         * BackendBucketCdnPolicyNegativeCachingPolicy ttl.
                         * @member {number|null|undefined} ttl
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy
                         * @instance
                         */
                        BackendBucketCdnPolicyNegativeCachingPolicy.prototype.ttl = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendBucketCdnPolicyNegativeCachingPolicy _code.
                         * @member {"code"|undefined} _code
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendBucketCdnPolicyNegativeCachingPolicy.prototype, "_code", {
                            get: $util.oneOfGetter($oneOfFields = ["code"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucketCdnPolicyNegativeCachingPolicy _ttl.
                         * @member {"ttl"|undefined} _ttl
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendBucketCdnPolicyNegativeCachingPolicy.prototype, "_ttl", {
                            get: $util.oneOfGetter($oneOfFields = ["ttl"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendBucketCdnPolicyNegativeCachingPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendBucketCdnPolicyNegativeCachingPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy} BackendBucketCdnPolicyNegativeCachingPolicy instance
                         */
                        BackendBucketCdnPolicyNegativeCachingPolicy.create = function create(properties) {
                            return new BackendBucketCdnPolicyNegativeCachingPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified BackendBucketCdnPolicyNegativeCachingPolicy message. Does not implicitly {@link google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendBucketCdnPolicyNegativeCachingPolicy} message BackendBucketCdnPolicyNegativeCachingPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendBucketCdnPolicyNegativeCachingPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.ttl != null && Object.hasOwnProperty.call(message, "ttl"))
                                writer.uint32(/* id 115180, wireType 0 =*/921440).int32(message.ttl);
                            if (message.code != null && Object.hasOwnProperty.call(message, "code"))
                                writer.uint32(/* id 3059181, wireType 0 =*/24473448).int32(message.code);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendBucketCdnPolicyNegativeCachingPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendBucketCdnPolicyNegativeCachingPolicy} message BackendBucketCdnPolicyNegativeCachingPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendBucketCdnPolicyNegativeCachingPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendBucketCdnPolicyNegativeCachingPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy} BackendBucketCdnPolicyNegativeCachingPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendBucketCdnPolicyNegativeCachingPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3059181: {
                                        message.code = reader.int32();
                                        break;
                                    }
                                case 115180: {
                                        message.ttl = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendBucketCdnPolicyNegativeCachingPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy} BackendBucketCdnPolicyNegativeCachingPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendBucketCdnPolicyNegativeCachingPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendBucketCdnPolicyNegativeCachingPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendBucketCdnPolicyNegativeCachingPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.code != null && message.hasOwnProperty("code")) {
                                properties._code = 1;
                                if (!$util.isInteger(message.code))
                                    return "code: integer expected";
                            }
                            if (message.ttl != null && message.hasOwnProperty("ttl")) {
                                properties._ttl = 1;
                                if (!$util.isInteger(message.ttl))
                                    return "ttl: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendBucketCdnPolicyNegativeCachingPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy} BackendBucketCdnPolicyNegativeCachingPolicy
                         */
                        BackendBucketCdnPolicyNegativeCachingPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy();
                            if (object.code != null)
                                message.code = object.code | 0;
                            if (object.ttl != null)
                                message.ttl = object.ttl | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendBucketCdnPolicyNegativeCachingPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy} message BackendBucketCdnPolicyNegativeCachingPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendBucketCdnPolicyNegativeCachingPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.ttl != null && message.hasOwnProperty("ttl")) {
                                object.ttl = message.ttl;
                                if (options.oneofs)
                                    object._ttl = "ttl";
                            }
                            if (message.code != null && message.hasOwnProperty("code")) {
                                object.code = message.code;
                                if (options.oneofs)
                                    object._code = "code";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendBucketCdnPolicyNegativeCachingPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendBucketCdnPolicyNegativeCachingPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendBucketCdnPolicyNegativeCachingPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendBucketCdnPolicyNegativeCachingPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendBucketCdnPolicyNegativeCachingPolicy";
                        };
    
                        return BackendBucketCdnPolicyNegativeCachingPolicy;
                    })();
    
                    v1.BackendBucketList = (function() {
    
                        /**
                         * Properties of a BackendBucketList.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendBucketList
                         * @property {string|null} [id] BackendBucketList id
                         * @property {Array.<google.cloud.compute.v1.IBackendBucket>|null} [items] BackendBucketList items
                         * @property {string|null} [kind] BackendBucketList kind
                         * @property {string|null} [nextPageToken] BackendBucketList nextPageToken
                         * @property {string|null} [selfLink] BackendBucketList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] BackendBucketList warning
                         */
    
                        /**
                         * Constructs a new BackendBucketList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendBucketList.
                         * @implements IBackendBucketList
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendBucketList=} [properties] Properties to set
                         */
                        function BackendBucketList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendBucketList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @instance
                         */
                        BackendBucketList.prototype.id = null;
    
                        /**
                         * BackendBucketList items.
                         * @member {Array.<google.cloud.compute.v1.IBackendBucket>} items
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @instance
                         */
                        BackendBucketList.prototype.items = $util.emptyArray;
    
                        /**
                         * BackendBucketList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @instance
                         */
                        BackendBucketList.prototype.kind = null;
    
                        /**
                         * BackendBucketList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @instance
                         */
                        BackendBucketList.prototype.nextPageToken = null;
    
                        /**
                         * BackendBucketList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @instance
                         */
                        BackendBucketList.prototype.selfLink = null;
    
                        /**
                         * BackendBucketList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @instance
                         */
                        BackendBucketList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendBucketList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @instance
                         */
                        Object.defineProperty(BackendBucketList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucketList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @instance
                         */
                        Object.defineProperty(BackendBucketList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucketList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @instance
                         */
                        Object.defineProperty(BackendBucketList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucketList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @instance
                         */
                        Object.defineProperty(BackendBucketList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendBucketList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @instance
                         */
                        Object.defineProperty(BackendBucketList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendBucketList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @static
                         * @param {google.cloud.compute.v1.IBackendBucketList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendBucketList} BackendBucketList instance
                         */
                        BackendBucketList.create = function create(properties) {
                            return new BackendBucketList(properties);
                        };
    
                        /**
                         * Encodes the specified BackendBucketList message. Does not implicitly {@link google.cloud.compute.v1.BackendBucketList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @static
                         * @param {google.cloud.compute.v1.IBackendBucketList} message BackendBucketList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendBucketList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.BackendBucket.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendBucketList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendBucketList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @static
                         * @param {google.cloud.compute.v1.IBackendBucketList} message BackendBucketList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendBucketList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendBucketList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendBucketList} BackendBucketList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendBucketList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendBucketList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.BackendBucket.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendBucketList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendBucketList} BackendBucketList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendBucketList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendBucketList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendBucketList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.BackendBucket.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendBucketList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendBucketList} BackendBucketList
                         */
                        BackendBucketList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendBucketList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendBucketList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.BackendBucketList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.BackendBucketList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.BackendBucket.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendBucketList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendBucketList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @static
                         * @param {google.cloud.compute.v1.BackendBucketList} message BackendBucketList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendBucketList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.BackendBucket.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendBucketList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendBucketList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendBucketList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendBucketList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendBucketList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendBucketList";
                        };
    
                        return BackendBucketList;
                    })();
    
                    v1.BackendService = (function() {
    
                        /**
                         * Properties of a BackendService.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendService
                         * @property {number|null} [affinityCookieTtlSec] BackendService affinityCookieTtlSec
                         * @property {Array.<google.cloud.compute.v1.IBackend>|null} [backends] BackendService backends
                         * @property {google.cloud.compute.v1.IBackendServiceCdnPolicy|null} [cdnPolicy] BackendService cdnPolicy
                         * @property {google.cloud.compute.v1.ICircuitBreakers|null} [circuitBreakers] BackendService circuitBreakers
                         * @property {string|null} [compressionMode] BackendService compressionMode
                         * @property {google.cloud.compute.v1.IConnectionDraining|null} [connectionDraining] BackendService connectionDraining
                         * @property {google.cloud.compute.v1.IBackendServiceConnectionTrackingPolicy|null} [connectionTrackingPolicy] BackendService connectionTrackingPolicy
                         * @property {google.cloud.compute.v1.IConsistentHashLoadBalancerSettings|null} [consistentHash] BackendService consistentHash
                         * @property {string|null} [creationTimestamp] BackendService creationTimestamp
                         * @property {Array.<string>|null} [customRequestHeaders] BackendService customRequestHeaders
                         * @property {Array.<string>|null} [customResponseHeaders] BackendService customResponseHeaders
                         * @property {string|null} [description] BackendService description
                         * @property {string|null} [edgeSecurityPolicy] BackendService edgeSecurityPolicy
                         * @property {boolean|null} [enableCDN] BackendService enableCDN
                         * @property {google.cloud.compute.v1.IBackendServiceFailoverPolicy|null} [failoverPolicy] BackendService failoverPolicy
                         * @property {string|null} [fingerprint] BackendService fingerprint
                         * @property {Array.<string>|null} [healthChecks] BackendService healthChecks
                         * @property {google.cloud.compute.v1.IBackendServiceIAP|null} [iap] BackendService iap
                         * @property {number|Long|null} [id] BackendService id
                         * @property {string|null} [kind] BackendService kind
                         * @property {string|null} [loadBalancingScheme] BackendService loadBalancingScheme
                         * @property {Array.<google.cloud.compute.v1.IBackendServiceLocalityLoadBalancingPolicyConfig>|null} [localityLbPolicies] BackendService localityLbPolicies
                         * @property {string|null} [localityLbPolicy] BackendService localityLbPolicy
                         * @property {google.cloud.compute.v1.IBackendServiceLogConfig|null} [logConfig] BackendService logConfig
                         * @property {google.cloud.compute.v1.IDuration|null} [maxStreamDuration] BackendService maxStreamDuration
                         * @property {string|null} [name] BackendService name
                         * @property {string|null} [network] BackendService network
                         * @property {google.cloud.compute.v1.IOutlierDetection|null} [outlierDetection] BackendService outlierDetection
                         * @property {number|null} [port] BackendService port
                         * @property {string|null} [portName] BackendService portName
                         * @property {string|null} [protocol] BackendService protocol
                         * @property {string|null} [region] BackendService region
                         * @property {string|null} [securityPolicy] BackendService securityPolicy
                         * @property {google.cloud.compute.v1.ISecuritySettings|null} [securitySettings] BackendService securitySettings
                         * @property {string|null} [selfLink] BackendService selfLink
                         * @property {Array.<string>|null} [serviceBindings] BackendService serviceBindings
                         * @property {string|null} [sessionAffinity] BackendService sessionAffinity
                         * @property {google.cloud.compute.v1.ISubsetting|null} [subsetting] BackendService subsetting
                         * @property {number|null} [timeoutSec] BackendService timeoutSec
                         */
    
                        /**
                         * Constructs a new BackendService.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendService.
                         * @implements IBackendService
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendService=} [properties] Properties to set
                         */
                        function BackendService(properties) {
                            this.backends = [];
                            this.customRequestHeaders = [];
                            this.customResponseHeaders = [];
                            this.healthChecks = [];
                            this.localityLbPolicies = [];
                            this.serviceBindings = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendService affinityCookieTtlSec.
                         * @member {number|null|undefined} affinityCookieTtlSec
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.affinityCookieTtlSec = null;
    
                        /**
                         * BackendService backends.
                         * @member {Array.<google.cloud.compute.v1.IBackend>} backends
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.backends = $util.emptyArray;
    
                        /**
                         * BackendService cdnPolicy.
                         * @member {google.cloud.compute.v1.IBackendServiceCdnPolicy|null|undefined} cdnPolicy
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.cdnPolicy = null;
    
                        /**
                         * BackendService circuitBreakers.
                         * @member {google.cloud.compute.v1.ICircuitBreakers|null|undefined} circuitBreakers
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.circuitBreakers = null;
    
                        /**
                         * BackendService compressionMode.
                         * @member {string|null|undefined} compressionMode
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.compressionMode = null;
    
                        /**
                         * BackendService connectionDraining.
                         * @member {google.cloud.compute.v1.IConnectionDraining|null|undefined} connectionDraining
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.connectionDraining = null;
    
                        /**
                         * BackendService connectionTrackingPolicy.
                         * @member {google.cloud.compute.v1.IBackendServiceConnectionTrackingPolicy|null|undefined} connectionTrackingPolicy
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.connectionTrackingPolicy = null;
    
                        /**
                         * BackendService consistentHash.
                         * @member {google.cloud.compute.v1.IConsistentHashLoadBalancerSettings|null|undefined} consistentHash
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.consistentHash = null;
    
                        /**
                         * BackendService creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.creationTimestamp = null;
    
                        /**
                         * BackendService customRequestHeaders.
                         * @member {Array.<string>} customRequestHeaders
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.customRequestHeaders = $util.emptyArray;
    
                        /**
                         * BackendService customResponseHeaders.
                         * @member {Array.<string>} customResponseHeaders
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.customResponseHeaders = $util.emptyArray;
    
                        /**
                         * BackendService description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.description = null;
    
                        /**
                         * BackendService edgeSecurityPolicy.
                         * @member {string|null|undefined} edgeSecurityPolicy
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.edgeSecurityPolicy = null;
    
                        /**
                         * BackendService enableCDN.
                         * @member {boolean|null|undefined} enableCDN
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.enableCDN = null;
    
                        /**
                         * BackendService failoverPolicy.
                         * @member {google.cloud.compute.v1.IBackendServiceFailoverPolicy|null|undefined} failoverPolicy
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.failoverPolicy = null;
    
                        /**
                         * BackendService fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.fingerprint = null;
    
                        /**
                         * BackendService healthChecks.
                         * @member {Array.<string>} healthChecks
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.healthChecks = $util.emptyArray;
    
                        /**
                         * BackendService iap.
                         * @member {google.cloud.compute.v1.IBackendServiceIAP|null|undefined} iap
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.iap = null;
    
                        /**
                         * BackendService id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.id = null;
    
                        /**
                         * BackendService kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.kind = null;
    
                        /**
                         * BackendService loadBalancingScheme.
                         * @member {string|null|undefined} loadBalancingScheme
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.loadBalancingScheme = null;
    
                        /**
                         * BackendService localityLbPolicies.
                         * @member {Array.<google.cloud.compute.v1.IBackendServiceLocalityLoadBalancingPolicyConfig>} localityLbPolicies
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.localityLbPolicies = $util.emptyArray;
    
                        /**
                         * BackendService localityLbPolicy.
                         * @member {string|null|undefined} localityLbPolicy
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.localityLbPolicy = null;
    
                        /**
                         * BackendService logConfig.
                         * @member {google.cloud.compute.v1.IBackendServiceLogConfig|null|undefined} logConfig
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.logConfig = null;
    
                        /**
                         * BackendService maxStreamDuration.
                         * @member {google.cloud.compute.v1.IDuration|null|undefined} maxStreamDuration
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.maxStreamDuration = null;
    
                        /**
                         * BackendService name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.name = null;
    
                        /**
                         * BackendService network.
                         * @member {string|null|undefined} network
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.network = null;
    
                        /**
                         * BackendService outlierDetection.
                         * @member {google.cloud.compute.v1.IOutlierDetection|null|undefined} outlierDetection
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.outlierDetection = null;
    
                        /**
                         * BackendService port.
                         * @member {number|null|undefined} port
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.port = null;
    
                        /**
                         * BackendService portName.
                         * @member {string|null|undefined} portName
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.portName = null;
    
                        /**
                         * BackendService protocol.
                         * @member {string|null|undefined} protocol
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.protocol = null;
    
                        /**
                         * BackendService region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.region = null;
    
                        /**
                         * BackendService securityPolicy.
                         * @member {string|null|undefined} securityPolicy
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.securityPolicy = null;
    
                        /**
                         * BackendService securitySettings.
                         * @member {google.cloud.compute.v1.ISecuritySettings|null|undefined} securitySettings
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.securitySettings = null;
    
                        /**
                         * BackendService selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.selfLink = null;
    
                        /**
                         * BackendService serviceBindings.
                         * @member {Array.<string>} serviceBindings
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.serviceBindings = $util.emptyArray;
    
                        /**
                         * BackendService sessionAffinity.
                         * @member {string|null|undefined} sessionAffinity
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.sessionAffinity = null;
    
                        /**
                         * BackendService subsetting.
                         * @member {google.cloud.compute.v1.ISubsetting|null|undefined} subsetting
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.subsetting = null;
    
                        /**
                         * BackendService timeoutSec.
                         * @member {number|null|undefined} timeoutSec
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        BackendService.prototype.timeoutSec = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendService _affinityCookieTtlSec.
                         * @member {"affinityCookieTtlSec"|undefined} _affinityCookieTtlSec
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_affinityCookieTtlSec", {
                            get: $util.oneOfGetter($oneOfFields = ["affinityCookieTtlSec"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _cdnPolicy.
                         * @member {"cdnPolicy"|undefined} _cdnPolicy
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_cdnPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["cdnPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _circuitBreakers.
                         * @member {"circuitBreakers"|undefined} _circuitBreakers
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_circuitBreakers", {
                            get: $util.oneOfGetter($oneOfFields = ["circuitBreakers"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _compressionMode.
                         * @member {"compressionMode"|undefined} _compressionMode
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_compressionMode", {
                            get: $util.oneOfGetter($oneOfFields = ["compressionMode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _connectionDraining.
                         * @member {"connectionDraining"|undefined} _connectionDraining
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_connectionDraining", {
                            get: $util.oneOfGetter($oneOfFields = ["connectionDraining"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _connectionTrackingPolicy.
                         * @member {"connectionTrackingPolicy"|undefined} _connectionTrackingPolicy
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_connectionTrackingPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["connectionTrackingPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _consistentHash.
                         * @member {"consistentHash"|undefined} _consistentHash
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_consistentHash", {
                            get: $util.oneOfGetter($oneOfFields = ["consistentHash"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _edgeSecurityPolicy.
                         * @member {"edgeSecurityPolicy"|undefined} _edgeSecurityPolicy
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_edgeSecurityPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["edgeSecurityPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _enableCDN.
                         * @member {"enableCDN"|undefined} _enableCDN
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_enableCDN", {
                            get: $util.oneOfGetter($oneOfFields = ["enableCDN"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _failoverPolicy.
                         * @member {"failoverPolicy"|undefined} _failoverPolicy
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_failoverPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["failoverPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _iap.
                         * @member {"iap"|undefined} _iap
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_iap", {
                            get: $util.oneOfGetter($oneOfFields = ["iap"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _loadBalancingScheme.
                         * @member {"loadBalancingScheme"|undefined} _loadBalancingScheme
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_loadBalancingScheme", {
                            get: $util.oneOfGetter($oneOfFields = ["loadBalancingScheme"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _localityLbPolicy.
                         * @member {"localityLbPolicy"|undefined} _localityLbPolicy
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_localityLbPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["localityLbPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _logConfig.
                         * @member {"logConfig"|undefined} _logConfig
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_logConfig", {
                            get: $util.oneOfGetter($oneOfFields = ["logConfig"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _maxStreamDuration.
                         * @member {"maxStreamDuration"|undefined} _maxStreamDuration
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_maxStreamDuration", {
                            get: $util.oneOfGetter($oneOfFields = ["maxStreamDuration"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _network.
                         * @member {"network"|undefined} _network
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_network", {
                            get: $util.oneOfGetter($oneOfFields = ["network"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _outlierDetection.
                         * @member {"outlierDetection"|undefined} _outlierDetection
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_outlierDetection", {
                            get: $util.oneOfGetter($oneOfFields = ["outlierDetection"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _port.
                         * @member {"port"|undefined} _port
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_port", {
                            get: $util.oneOfGetter($oneOfFields = ["port"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _portName.
                         * @member {"portName"|undefined} _portName
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_portName", {
                            get: $util.oneOfGetter($oneOfFields = ["portName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _protocol.
                         * @member {"protocol"|undefined} _protocol
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_protocol", {
                            get: $util.oneOfGetter($oneOfFields = ["protocol"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _securityPolicy.
                         * @member {"securityPolicy"|undefined} _securityPolicy
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_securityPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["securityPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _securitySettings.
                         * @member {"securitySettings"|undefined} _securitySettings
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_securitySettings", {
                            get: $util.oneOfGetter($oneOfFields = ["securitySettings"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _sessionAffinity.
                         * @member {"sessionAffinity"|undefined} _sessionAffinity
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_sessionAffinity", {
                            get: $util.oneOfGetter($oneOfFields = ["sessionAffinity"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _subsetting.
                         * @member {"subsetting"|undefined} _subsetting
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_subsetting", {
                            get: $util.oneOfGetter($oneOfFields = ["subsetting"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendService _timeoutSec.
                         * @member {"timeoutSec"|undefined} _timeoutSec
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         */
                        Object.defineProperty(BackendService.prototype, "_timeoutSec", {
                            get: $util.oneOfGetter($oneOfFields = ["timeoutSec"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendService instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendService
                         * @static
                         * @param {google.cloud.compute.v1.IBackendService=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendService} BackendService instance
                         */
                        BackendService.create = function create(properties) {
                            return new BackendService(properties);
                        };
    
                        /**
                         * Encodes the specified BackendService message. Does not implicitly {@link google.cloud.compute.v1.BackendService.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendService
                         * @static
                         * @param {google.cloud.compute.v1.IBackendService} message BackendService message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendService.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.iap != null && Object.hasOwnProperty.call(message, "iap"))
                                $root.google.cloud.compute.v1.BackendServiceIAP.encode(message.iap, writer.uint32(/* id 104024, wireType 2 =*/832194).fork()).ldelim();
                            if (message.consistentHash != null && Object.hasOwnProperty.call(message, "consistentHash"))
                                $root.google.cloud.compute.v1.ConsistentHashLoadBalancerSettings.encode(message.consistentHash, writer.uint32(/* id 905883, wireType 2 =*/7247066).fork()).ldelim();
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.port != null && Object.hasOwnProperty.call(message, "port"))
                                writer.uint32(/* id 3446913, wireType 0 =*/27575304).int32(message.port);
                            if (message.customRequestHeaders != null && message.customRequestHeaders.length)
                                for (var i = 0; i < message.customRequestHeaders.length; ++i)
                                    writer.uint32(/* id 27977992, wireType 2 =*/223823938).string(message.customRequestHeaders[i]);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.edgeSecurityPolicy != null && Object.hasOwnProperty.call(message, "edgeSecurityPolicy"))
                                writer.uint32(/* id 41036943, wireType 2 =*/328295546).string(message.edgeSecurityPolicy);
                            if (message.portName != null && Object.hasOwnProperty.call(message, "portName"))
                                writer.uint32(/* id 41534345, wireType 2 =*/332274762).string(message.portName);
                            if (message.maxStreamDuration != null && Object.hasOwnProperty.call(message, "maxStreamDuration"))
                                $root.google.cloud.compute.v1.Duration.encode(message.maxStreamDuration, writer.uint32(/* id 61428376, wireType 2 =*/491427010).fork()).ldelim();
                            if (message.timeoutSec != null && Object.hasOwnProperty.call(message, "timeoutSec"))
                                writer.uint32(/* id 79994995, wireType 0 =*/639959960).int32(message.timeoutSec);
                            if (message.protocol != null && Object.hasOwnProperty.call(message, "protocol"))
                                writer.uint32(/* id 84577944, wireType 2 =*/676623554).string(message.protocol);
                            if (message.compressionMode != null && Object.hasOwnProperty.call(message, "compressionMode"))
                                writer.uint32(/* id 95520988, wireType 2 =*/764167906).string(message.compressionMode);
                            if (message.failoverPolicy != null && Object.hasOwnProperty.call(message, "failoverPolicy"))
                                $root.google.cloud.compute.v1.BackendServiceFailoverPolicy.encode(message.failoverPolicy, writer.uint32(/* id 105658655, wireType 2 =*/845269242).fork()).ldelim();
                            if (message.localityLbPolicy != null && Object.hasOwnProperty.call(message, "localityLbPolicy"))
                                writer.uint32(/* id 131431487, wireType 2 =*/1051451898).string(message.localityLbPolicy);
                            if (message.serviceBindings != null && message.serviceBindings.length)
                                for (var i = 0; i < message.serviceBindings.length; ++i)
                                    writer.uint32(/* id 133581016, wireType 2 =*/1068648130).string(message.serviceBindings[i]);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.localityLbPolicies != null && message.localityLbPolicies.length)
                                for (var i = 0; i < message.localityLbPolicies.length; ++i)
                                    $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig.encode(message.localityLbPolicies[i], writer.uint32(/* id 140982557, wireType 2 =*/1127860458).fork()).ldelim();
                            if (message.connectionTrackingPolicy != null && Object.hasOwnProperty.call(message, "connectionTrackingPolicy"))
                                $root.google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy.encode(message.connectionTrackingPolicy, writer.uint32(/* id 143994969, wireType 2 =*/1151959754).fork()).ldelim();
                            if (message.securityPolicy != null && Object.hasOwnProperty.call(message, "securityPolicy"))
                                writer.uint32(/* id 171082513, wireType 2 =*/1368660106).string(message.securityPolicy);
                            if (message.cdnPolicy != null && Object.hasOwnProperty.call(message, "cdnPolicy"))
                                $root.google.cloud.compute.v1.BackendServiceCdnPolicy.encode(message.cdnPolicy, writer.uint32(/* id 213976452, wireType 2 =*/1711811618).fork()).ldelim();
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.enableCDN != null && Object.hasOwnProperty.call(message, "enableCDN"))
                                writer.uint32(/* id 250733499, wireType 0 =*/2005867992).bool(message.enableCDN);
                            if (message.logConfig != null && Object.hasOwnProperty.call(message, "logConfig"))
                                $root.google.cloud.compute.v1.BackendServiceLogConfig.encode(message.logConfig, writer.uint32(/* id 351299741, wireType 2 =*/2810397930).fork()).ldelim();
                            if (message.outlierDetection != null && Object.hasOwnProperty.call(message, "outlierDetection"))
                                $root.google.cloud.compute.v1.OutlierDetection.encode(message.outlierDetection, writer.uint32(/* id 354625086, wireType 2 =*/2837000690).fork()).ldelim();
                            if (message.loadBalancingScheme != null && Object.hasOwnProperty.call(message, "loadBalancingScheme"))
                                writer.uint32(/* id 363890244, wireType 2 =*/2911121954).string(message.loadBalancingScheme);
                            if (message.affinityCookieTtlSec != null && Object.hasOwnProperty.call(message, "affinityCookieTtlSec"))
                                writer.uint32(/* id 369996954, wireType 0 =*/2959975632).int32(message.affinityCookieTtlSec);
                            if (message.customResponseHeaders != null && message.customResponseHeaders.length)
                                for (var i = 0; i < message.customResponseHeaders.length; ++i)
                                    writer.uint32(/* id 387539094, wireType 2 =*/3100312754).string(message.customResponseHeaders[i]);
                            if (message.circuitBreakers != null && Object.hasOwnProperty.call(message, "circuitBreakers"))
                                $root.google.cloud.compute.v1.CircuitBreakers.encode(message.circuitBreakers, writer.uint32(/* id 421340061, wireType 2 =*/3370720490).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.healthChecks != null && message.healthChecks.length)
                                for (var i = 0; i < message.healthChecks.length; ++i)
                                    writer.uint32(/* id 448370606, wireType 2 =*/3586964850).string(message.healthChecks[i]);
                            if (message.subsetting != null && Object.hasOwnProperty.call(message, "subsetting"))
                                $root.google.cloud.compute.v1.Subsetting.encode(message.subsetting, writer.uint32(/* id 450283536, wireType 2 =*/3602268290).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.connectionDraining != null && Object.hasOwnProperty.call(message, "connectionDraining"))
                                $root.google.cloud.compute.v1.ConnectionDraining.encode(message.connectionDraining, writer.uint32(/* id 461096747, wireType 2 =*/3688773978).fork()).ldelim();
                            if (message.sessionAffinity != null && Object.hasOwnProperty.call(message, "sessionAffinity"))
                                writer.uint32(/* id 463888561, wireType 2 =*/3711108490).string(message.sessionAffinity);
                            if (message.securitySettings != null && Object.hasOwnProperty.call(message, "securitySettings"))
                                $root.google.cloud.compute.v1.SecuritySettings.encode(message.securitySettings, writer.uint32(/* id 478649922, wireType 2 =*/3829199378).fork()).ldelim();
                            if (message.backends != null && message.backends.length)
                                for (var i = 0; i < message.backends.length; ++i)
                                    $root.google.cloud.compute.v1.Backend.encode(message.backends[i], writer.uint32(/* id 510839903, wireType 2 =*/4086719226).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendService message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendService.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendService
                         * @static
                         * @param {google.cloud.compute.v1.IBackendService} message BackendService message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendService.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendService message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendService
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendService} BackendService
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendService.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendService();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 369996954: {
                                        message.affinityCookieTtlSec = reader.int32();
                                        break;
                                    }
                                case 510839903: {
                                        if (!(message.backends && message.backends.length))
                                            message.backends = [];
                                        message.backends.push($root.google.cloud.compute.v1.Backend.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 213976452: {
                                        message.cdnPolicy = $root.google.cloud.compute.v1.BackendServiceCdnPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 421340061: {
                                        message.circuitBreakers = $root.google.cloud.compute.v1.CircuitBreakers.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 95520988: {
                                        message.compressionMode = reader.string();
                                        break;
                                    }
                                case 461096747: {
                                        message.connectionDraining = $root.google.cloud.compute.v1.ConnectionDraining.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 143994969: {
                                        message.connectionTrackingPolicy = $root.google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 905883: {
                                        message.consistentHash = $root.google.cloud.compute.v1.ConsistentHashLoadBalancerSettings.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 27977992: {
                                        if (!(message.customRequestHeaders && message.customRequestHeaders.length))
                                            message.customRequestHeaders = [];
                                        message.customRequestHeaders.push(reader.string());
                                        break;
                                    }
                                case 387539094: {
                                        if (!(message.customResponseHeaders && message.customResponseHeaders.length))
                                            message.customResponseHeaders = [];
                                        message.customResponseHeaders.push(reader.string());
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 41036943: {
                                        message.edgeSecurityPolicy = reader.string();
                                        break;
                                    }
                                case 250733499: {
                                        message.enableCDN = reader.bool();
                                        break;
                                    }
                                case 105658655: {
                                        message.failoverPolicy = $root.google.cloud.compute.v1.BackendServiceFailoverPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 448370606: {
                                        if (!(message.healthChecks && message.healthChecks.length))
                                            message.healthChecks = [];
                                        message.healthChecks.push(reader.string());
                                        break;
                                    }
                                case 104024: {
                                        message.iap = $root.google.cloud.compute.v1.BackendServiceIAP.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 363890244: {
                                        message.loadBalancingScheme = reader.string();
                                        break;
                                    }
                                case 140982557: {
                                        if (!(message.localityLbPolicies && message.localityLbPolicies.length))
                                            message.localityLbPolicies = [];
                                        message.localityLbPolicies.push($root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 131431487: {
                                        message.localityLbPolicy = reader.string();
                                        break;
                                    }
                                case 351299741: {
                                        message.logConfig = $root.google.cloud.compute.v1.BackendServiceLogConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 61428376: {
                                        message.maxStreamDuration = $root.google.cloud.compute.v1.Duration.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 354625086: {
                                        message.outlierDetection = $root.google.cloud.compute.v1.OutlierDetection.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3446913: {
                                        message.port = reader.int32();
                                        break;
                                    }
                                case 41534345: {
                                        message.portName = reader.string();
                                        break;
                                    }
                                case 84577944: {
                                        message.protocol = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 171082513: {
                                        message.securityPolicy = reader.string();
                                        break;
                                    }
                                case 478649922: {
                                        message.securitySettings = $root.google.cloud.compute.v1.SecuritySettings.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 133581016: {
                                        if (!(message.serviceBindings && message.serviceBindings.length))
                                            message.serviceBindings = [];
                                        message.serviceBindings.push(reader.string());
                                        break;
                                    }
                                case 463888561: {
                                        message.sessionAffinity = reader.string();
                                        break;
                                    }
                                case 450283536: {
                                        message.subsetting = $root.google.cloud.compute.v1.Subsetting.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 79994995: {
                                        message.timeoutSec = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendService message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendService
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendService} BackendService
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendService.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendService message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendService
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendService.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.affinityCookieTtlSec != null && message.hasOwnProperty("affinityCookieTtlSec")) {
                                properties._affinityCookieTtlSec = 1;
                                if (!$util.isInteger(message.affinityCookieTtlSec))
                                    return "affinityCookieTtlSec: integer expected";
                            }
                            if (message.backends != null && message.hasOwnProperty("backends")) {
                                if (!Array.isArray(message.backends))
                                    return "backends: array expected";
                                for (var i = 0; i < message.backends.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Backend.verify(message.backends[i]);
                                    if (error)
                                        return "backends." + error;
                                }
                            }
                            if (message.cdnPolicy != null && message.hasOwnProperty("cdnPolicy")) {
                                properties._cdnPolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.BackendServiceCdnPolicy.verify(message.cdnPolicy);
                                    if (error)
                                        return "cdnPolicy." + error;
                                }
                            }
                            if (message.circuitBreakers != null && message.hasOwnProperty("circuitBreakers")) {
                                properties._circuitBreakers = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.CircuitBreakers.verify(message.circuitBreakers);
                                    if (error)
                                        return "circuitBreakers." + error;
                                }
                            }
                            if (message.compressionMode != null && message.hasOwnProperty("compressionMode")) {
                                properties._compressionMode = 1;
                                if (!$util.isString(message.compressionMode))
                                    return "compressionMode: string expected";
                            }
                            if (message.connectionDraining != null && message.hasOwnProperty("connectionDraining")) {
                                properties._connectionDraining = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ConnectionDraining.verify(message.connectionDraining);
                                    if (error)
                                        return "connectionDraining." + error;
                                }
                            }
                            if (message.connectionTrackingPolicy != null && message.hasOwnProperty("connectionTrackingPolicy")) {
                                properties._connectionTrackingPolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy.verify(message.connectionTrackingPolicy);
                                    if (error)
                                        return "connectionTrackingPolicy." + error;
                                }
                            }
                            if (message.consistentHash != null && message.hasOwnProperty("consistentHash")) {
                                properties._consistentHash = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ConsistentHashLoadBalancerSettings.verify(message.consistentHash);
                                    if (error)
                                        return "consistentHash." + error;
                                }
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.customRequestHeaders != null && message.hasOwnProperty("customRequestHeaders")) {
                                if (!Array.isArray(message.customRequestHeaders))
                                    return "customRequestHeaders: array expected";
                                for (var i = 0; i < message.customRequestHeaders.length; ++i)
                                    if (!$util.isString(message.customRequestHeaders[i]))
                                        return "customRequestHeaders: string[] expected";
                            }
                            if (message.customResponseHeaders != null && message.hasOwnProperty("customResponseHeaders")) {
                                if (!Array.isArray(message.customResponseHeaders))
                                    return "customResponseHeaders: array expected";
                                for (var i = 0; i < message.customResponseHeaders.length; ++i)
                                    if (!$util.isString(message.customResponseHeaders[i]))
                                        return "customResponseHeaders: string[] expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.edgeSecurityPolicy != null && message.hasOwnProperty("edgeSecurityPolicy")) {
                                properties._edgeSecurityPolicy = 1;
                                if (!$util.isString(message.edgeSecurityPolicy))
                                    return "edgeSecurityPolicy: string expected";
                            }
                            if (message.enableCDN != null && message.hasOwnProperty("enableCDN")) {
                                properties._enableCDN = 1;
                                if (typeof message.enableCDN !== "boolean")
                                    return "enableCDN: boolean expected";
                            }
                            if (message.failoverPolicy != null && message.hasOwnProperty("failoverPolicy")) {
                                properties._failoverPolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.BackendServiceFailoverPolicy.verify(message.failoverPolicy);
                                    if (error)
                                        return "failoverPolicy." + error;
                                }
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.healthChecks != null && message.hasOwnProperty("healthChecks")) {
                                if (!Array.isArray(message.healthChecks))
                                    return "healthChecks: array expected";
                                for (var i = 0; i < message.healthChecks.length; ++i)
                                    if (!$util.isString(message.healthChecks[i]))
                                        return "healthChecks: string[] expected";
                            }
                            if (message.iap != null && message.hasOwnProperty("iap")) {
                                properties._iap = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.BackendServiceIAP.verify(message.iap);
                                    if (error)
                                        return "iap." + error;
                                }
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.loadBalancingScheme != null && message.hasOwnProperty("loadBalancingScheme")) {
                                properties._loadBalancingScheme = 1;
                                if (!$util.isString(message.loadBalancingScheme))
                                    return "loadBalancingScheme: string expected";
                            }
                            if (message.localityLbPolicies != null && message.hasOwnProperty("localityLbPolicies")) {
                                if (!Array.isArray(message.localityLbPolicies))
                                    return "localityLbPolicies: array expected";
                                for (var i = 0; i < message.localityLbPolicies.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig.verify(message.localityLbPolicies[i]);
                                    if (error)
                                        return "localityLbPolicies." + error;
                                }
                            }
                            if (message.localityLbPolicy != null && message.hasOwnProperty("localityLbPolicy")) {
                                properties._localityLbPolicy = 1;
                                if (!$util.isString(message.localityLbPolicy))
                                    return "localityLbPolicy: string expected";
                            }
                            if (message.logConfig != null && message.hasOwnProperty("logConfig")) {
                                properties._logConfig = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.BackendServiceLogConfig.verify(message.logConfig);
                                    if (error)
                                        return "logConfig." + error;
                                }
                            }
                            if (message.maxStreamDuration != null && message.hasOwnProperty("maxStreamDuration")) {
                                properties._maxStreamDuration = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Duration.verify(message.maxStreamDuration);
                                    if (error)
                                        return "maxStreamDuration." + error;
                                }
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                properties._network = 1;
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            }
                            if (message.outlierDetection != null && message.hasOwnProperty("outlierDetection")) {
                                properties._outlierDetection = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.OutlierDetection.verify(message.outlierDetection);
                                    if (error)
                                        return "outlierDetection." + error;
                                }
                            }
                            if (message.port != null && message.hasOwnProperty("port")) {
                                properties._port = 1;
                                if (!$util.isInteger(message.port))
                                    return "port: integer expected";
                            }
                            if (message.portName != null && message.hasOwnProperty("portName")) {
                                properties._portName = 1;
                                if (!$util.isString(message.portName))
                                    return "portName: string expected";
                            }
                            if (message.protocol != null && message.hasOwnProperty("protocol")) {
                                properties._protocol = 1;
                                if (!$util.isString(message.protocol))
                                    return "protocol: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy")) {
                                properties._securityPolicy = 1;
                                if (!$util.isString(message.securityPolicy))
                                    return "securityPolicy: string expected";
                            }
                            if (message.securitySettings != null && message.hasOwnProperty("securitySettings")) {
                                properties._securitySettings = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SecuritySettings.verify(message.securitySettings);
                                    if (error)
                                        return "securitySettings." + error;
                                }
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.serviceBindings != null && message.hasOwnProperty("serviceBindings")) {
                                if (!Array.isArray(message.serviceBindings))
                                    return "serviceBindings: array expected";
                                for (var i = 0; i < message.serviceBindings.length; ++i)
                                    if (!$util.isString(message.serviceBindings[i]))
                                        return "serviceBindings: string[] expected";
                            }
                            if (message.sessionAffinity != null && message.hasOwnProperty("sessionAffinity")) {
                                properties._sessionAffinity = 1;
                                if (!$util.isString(message.sessionAffinity))
                                    return "sessionAffinity: string expected";
                            }
                            if (message.subsetting != null && message.hasOwnProperty("subsetting")) {
                                properties._subsetting = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Subsetting.verify(message.subsetting);
                                    if (error)
                                        return "subsetting." + error;
                                }
                            }
                            if (message.timeoutSec != null && message.hasOwnProperty("timeoutSec")) {
                                properties._timeoutSec = 1;
                                if (!$util.isInteger(message.timeoutSec))
                                    return "timeoutSec: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendService message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendService
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendService} BackendService
                         */
                        BackendService.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendService)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendService();
                            if (object.affinityCookieTtlSec != null)
                                message.affinityCookieTtlSec = object.affinityCookieTtlSec | 0;
                            if (object.backends) {
                                if (!Array.isArray(object.backends))
                                    throw TypeError(".google.cloud.compute.v1.BackendService.backends: array expected");
                                message.backends = [];
                                for (var i = 0; i < object.backends.length; ++i) {
                                    if (typeof object.backends[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.BackendService.backends: object expected");
                                    message.backends[i] = $root.google.cloud.compute.v1.Backend.fromObject(object.backends[i]);
                                }
                            }
                            if (object.cdnPolicy != null) {
                                if (typeof object.cdnPolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendService.cdnPolicy: object expected");
                                message.cdnPolicy = $root.google.cloud.compute.v1.BackendServiceCdnPolicy.fromObject(object.cdnPolicy);
                            }
                            if (object.circuitBreakers != null) {
                                if (typeof object.circuitBreakers !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendService.circuitBreakers: object expected");
                                message.circuitBreakers = $root.google.cloud.compute.v1.CircuitBreakers.fromObject(object.circuitBreakers);
                            }
                            if (object.compressionMode != null)
                                message.compressionMode = String(object.compressionMode);
                            if (object.connectionDraining != null) {
                                if (typeof object.connectionDraining !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendService.connectionDraining: object expected");
                                message.connectionDraining = $root.google.cloud.compute.v1.ConnectionDraining.fromObject(object.connectionDraining);
                            }
                            if (object.connectionTrackingPolicy != null) {
                                if (typeof object.connectionTrackingPolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendService.connectionTrackingPolicy: object expected");
                                message.connectionTrackingPolicy = $root.google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy.fromObject(object.connectionTrackingPolicy);
                            }
                            if (object.consistentHash != null) {
                                if (typeof object.consistentHash !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendService.consistentHash: object expected");
                                message.consistentHash = $root.google.cloud.compute.v1.ConsistentHashLoadBalancerSettings.fromObject(object.consistentHash);
                            }
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.customRequestHeaders) {
                                if (!Array.isArray(object.customRequestHeaders))
                                    throw TypeError(".google.cloud.compute.v1.BackendService.customRequestHeaders: array expected");
                                message.customRequestHeaders = [];
                                for (var i = 0; i < object.customRequestHeaders.length; ++i)
                                    message.customRequestHeaders[i] = String(object.customRequestHeaders[i]);
                            }
                            if (object.customResponseHeaders) {
                                if (!Array.isArray(object.customResponseHeaders))
                                    throw TypeError(".google.cloud.compute.v1.BackendService.customResponseHeaders: array expected");
                                message.customResponseHeaders = [];
                                for (var i = 0; i < object.customResponseHeaders.length; ++i)
                                    message.customResponseHeaders[i] = String(object.customResponseHeaders[i]);
                            }
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.edgeSecurityPolicy != null)
                                message.edgeSecurityPolicy = String(object.edgeSecurityPolicy);
                            if (object.enableCDN != null)
                                message.enableCDN = Boolean(object.enableCDN);
                            if (object.failoverPolicy != null) {
                                if (typeof object.failoverPolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendService.failoverPolicy: object expected");
                                message.failoverPolicy = $root.google.cloud.compute.v1.BackendServiceFailoverPolicy.fromObject(object.failoverPolicy);
                            }
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.healthChecks) {
                                if (!Array.isArray(object.healthChecks))
                                    throw TypeError(".google.cloud.compute.v1.BackendService.healthChecks: array expected");
                                message.healthChecks = [];
                                for (var i = 0; i < object.healthChecks.length; ++i)
                                    message.healthChecks[i] = String(object.healthChecks[i]);
                            }
                            if (object.iap != null) {
                                if (typeof object.iap !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendService.iap: object expected");
                                message.iap = $root.google.cloud.compute.v1.BackendServiceIAP.fromObject(object.iap);
                            }
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.loadBalancingScheme != null)
                                message.loadBalancingScheme = String(object.loadBalancingScheme);
                            if (object.localityLbPolicies) {
                                if (!Array.isArray(object.localityLbPolicies))
                                    throw TypeError(".google.cloud.compute.v1.BackendService.localityLbPolicies: array expected");
                                message.localityLbPolicies = [];
                                for (var i = 0; i < object.localityLbPolicies.length; ++i) {
                                    if (typeof object.localityLbPolicies[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.BackendService.localityLbPolicies: object expected");
                                    message.localityLbPolicies[i] = $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig.fromObject(object.localityLbPolicies[i]);
                                }
                            }
                            if (object.localityLbPolicy != null)
                                message.localityLbPolicy = String(object.localityLbPolicy);
                            if (object.logConfig != null) {
                                if (typeof object.logConfig !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendService.logConfig: object expected");
                                message.logConfig = $root.google.cloud.compute.v1.BackendServiceLogConfig.fromObject(object.logConfig);
                            }
                            if (object.maxStreamDuration != null) {
                                if (typeof object.maxStreamDuration !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendService.maxStreamDuration: object expected");
                                message.maxStreamDuration = $root.google.cloud.compute.v1.Duration.fromObject(object.maxStreamDuration);
                            }
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.outlierDetection != null) {
                                if (typeof object.outlierDetection !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendService.outlierDetection: object expected");
                                message.outlierDetection = $root.google.cloud.compute.v1.OutlierDetection.fromObject(object.outlierDetection);
                            }
                            if (object.port != null)
                                message.port = object.port | 0;
                            if (object.portName != null)
                                message.portName = String(object.portName);
                            if (object.protocol != null)
                                message.protocol = String(object.protocol);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.securityPolicy != null)
                                message.securityPolicy = String(object.securityPolicy);
                            if (object.securitySettings != null) {
                                if (typeof object.securitySettings !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendService.securitySettings: object expected");
                                message.securitySettings = $root.google.cloud.compute.v1.SecuritySettings.fromObject(object.securitySettings);
                            }
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.serviceBindings) {
                                if (!Array.isArray(object.serviceBindings))
                                    throw TypeError(".google.cloud.compute.v1.BackendService.serviceBindings: array expected");
                                message.serviceBindings = [];
                                for (var i = 0; i < object.serviceBindings.length; ++i)
                                    message.serviceBindings[i] = String(object.serviceBindings[i]);
                            }
                            if (object.sessionAffinity != null)
                                message.sessionAffinity = String(object.sessionAffinity);
                            if (object.subsetting != null) {
                                if (typeof object.subsetting !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendService.subsetting: object expected");
                                message.subsetting = $root.google.cloud.compute.v1.Subsetting.fromObject(object.subsetting);
                            }
                            if (object.timeoutSec != null)
                                message.timeoutSec = object.timeoutSec | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendService message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendService
                         * @static
                         * @param {google.cloud.compute.v1.BackendService} message BackendService
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendService.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.customRequestHeaders = [];
                                object.serviceBindings = [];
                                object.localityLbPolicies = [];
                                object.customResponseHeaders = [];
                                object.healthChecks = [];
                                object.backends = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.iap != null && message.hasOwnProperty("iap")) {
                                object.iap = $root.google.cloud.compute.v1.BackendServiceIAP.toObject(message.iap, options);
                                if (options.oneofs)
                                    object._iap = "iap";
                            }
                            if (message.consistentHash != null && message.hasOwnProperty("consistentHash")) {
                                object.consistentHash = $root.google.cloud.compute.v1.ConsistentHashLoadBalancerSettings.toObject(message.consistentHash, options);
                                if (options.oneofs)
                                    object._consistentHash = "consistentHash";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.port != null && message.hasOwnProperty("port")) {
                                object.port = message.port;
                                if (options.oneofs)
                                    object._port = "port";
                            }
                            if (message.customRequestHeaders && message.customRequestHeaders.length) {
                                object.customRequestHeaders = [];
                                for (var j = 0; j < message.customRequestHeaders.length; ++j)
                                    object.customRequestHeaders[j] = message.customRequestHeaders[j];
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.edgeSecurityPolicy != null && message.hasOwnProperty("edgeSecurityPolicy")) {
                                object.edgeSecurityPolicy = message.edgeSecurityPolicy;
                                if (options.oneofs)
                                    object._edgeSecurityPolicy = "edgeSecurityPolicy";
                            }
                            if (message.portName != null && message.hasOwnProperty("portName")) {
                                object.portName = message.portName;
                                if (options.oneofs)
                                    object._portName = "portName";
                            }
                            if (message.maxStreamDuration != null && message.hasOwnProperty("maxStreamDuration")) {
                                object.maxStreamDuration = $root.google.cloud.compute.v1.Duration.toObject(message.maxStreamDuration, options);
                                if (options.oneofs)
                                    object._maxStreamDuration = "maxStreamDuration";
                            }
                            if (message.timeoutSec != null && message.hasOwnProperty("timeoutSec")) {
                                object.timeoutSec = message.timeoutSec;
                                if (options.oneofs)
                                    object._timeoutSec = "timeoutSec";
                            }
                            if (message.protocol != null && message.hasOwnProperty("protocol")) {
                                object.protocol = message.protocol;
                                if (options.oneofs)
                                    object._protocol = "protocol";
                            }
                            if (message.compressionMode != null && message.hasOwnProperty("compressionMode")) {
                                object.compressionMode = message.compressionMode;
                                if (options.oneofs)
                                    object._compressionMode = "compressionMode";
                            }
                            if (message.failoverPolicy != null && message.hasOwnProperty("failoverPolicy")) {
                                object.failoverPolicy = $root.google.cloud.compute.v1.BackendServiceFailoverPolicy.toObject(message.failoverPolicy, options);
                                if (options.oneofs)
                                    object._failoverPolicy = "failoverPolicy";
                            }
                            if (message.localityLbPolicy != null && message.hasOwnProperty("localityLbPolicy")) {
                                object.localityLbPolicy = message.localityLbPolicy;
                                if (options.oneofs)
                                    object._localityLbPolicy = "localityLbPolicy";
                            }
                            if (message.serviceBindings && message.serviceBindings.length) {
                                object.serviceBindings = [];
                                for (var j = 0; j < message.serviceBindings.length; ++j)
                                    object.serviceBindings[j] = message.serviceBindings[j];
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.localityLbPolicies && message.localityLbPolicies.length) {
                                object.localityLbPolicies = [];
                                for (var j = 0; j < message.localityLbPolicies.length; ++j)
                                    object.localityLbPolicies[j] = $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig.toObject(message.localityLbPolicies[j], options);
                            }
                            if (message.connectionTrackingPolicy != null && message.hasOwnProperty("connectionTrackingPolicy")) {
                                object.connectionTrackingPolicy = $root.google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy.toObject(message.connectionTrackingPolicy, options);
                                if (options.oneofs)
                                    object._connectionTrackingPolicy = "connectionTrackingPolicy";
                            }
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy")) {
                                object.securityPolicy = message.securityPolicy;
                                if (options.oneofs)
                                    object._securityPolicy = "securityPolicy";
                            }
                            if (message.cdnPolicy != null && message.hasOwnProperty("cdnPolicy")) {
                                object.cdnPolicy = $root.google.cloud.compute.v1.BackendServiceCdnPolicy.toObject(message.cdnPolicy, options);
                                if (options.oneofs)
                                    object._cdnPolicy = "cdnPolicy";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                object.network = message.network;
                                if (options.oneofs)
                                    object._network = "network";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.enableCDN != null && message.hasOwnProperty("enableCDN")) {
                                object.enableCDN = message.enableCDN;
                                if (options.oneofs)
                                    object._enableCDN = "enableCDN";
                            }
                            if (message.logConfig != null && message.hasOwnProperty("logConfig")) {
                                object.logConfig = $root.google.cloud.compute.v1.BackendServiceLogConfig.toObject(message.logConfig, options);
                                if (options.oneofs)
                                    object._logConfig = "logConfig";
                            }
                            if (message.outlierDetection != null && message.hasOwnProperty("outlierDetection")) {
                                object.outlierDetection = $root.google.cloud.compute.v1.OutlierDetection.toObject(message.outlierDetection, options);
                                if (options.oneofs)
                                    object._outlierDetection = "outlierDetection";
                            }
                            if (message.loadBalancingScheme != null && message.hasOwnProperty("loadBalancingScheme")) {
                                object.loadBalancingScheme = message.loadBalancingScheme;
                                if (options.oneofs)
                                    object._loadBalancingScheme = "loadBalancingScheme";
                            }
                            if (message.affinityCookieTtlSec != null && message.hasOwnProperty("affinityCookieTtlSec")) {
                                object.affinityCookieTtlSec = message.affinityCookieTtlSec;
                                if (options.oneofs)
                                    object._affinityCookieTtlSec = "affinityCookieTtlSec";
                            }
                            if (message.customResponseHeaders && message.customResponseHeaders.length) {
                                object.customResponseHeaders = [];
                                for (var j = 0; j < message.customResponseHeaders.length; ++j)
                                    object.customResponseHeaders[j] = message.customResponseHeaders[j];
                            }
                            if (message.circuitBreakers != null && message.hasOwnProperty("circuitBreakers")) {
                                object.circuitBreakers = $root.google.cloud.compute.v1.CircuitBreakers.toObject(message.circuitBreakers, options);
                                if (options.oneofs)
                                    object._circuitBreakers = "circuitBreakers";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.healthChecks && message.healthChecks.length) {
                                object.healthChecks = [];
                                for (var j = 0; j < message.healthChecks.length; ++j)
                                    object.healthChecks[j] = message.healthChecks[j];
                            }
                            if (message.subsetting != null && message.hasOwnProperty("subsetting")) {
                                object.subsetting = $root.google.cloud.compute.v1.Subsetting.toObject(message.subsetting, options);
                                if (options.oneofs)
                                    object._subsetting = "subsetting";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.connectionDraining != null && message.hasOwnProperty("connectionDraining")) {
                                object.connectionDraining = $root.google.cloud.compute.v1.ConnectionDraining.toObject(message.connectionDraining, options);
                                if (options.oneofs)
                                    object._connectionDraining = "connectionDraining";
                            }
                            if (message.sessionAffinity != null && message.hasOwnProperty("sessionAffinity")) {
                                object.sessionAffinity = message.sessionAffinity;
                                if (options.oneofs)
                                    object._sessionAffinity = "sessionAffinity";
                            }
                            if (message.securitySettings != null && message.hasOwnProperty("securitySettings")) {
                                object.securitySettings = $root.google.cloud.compute.v1.SecuritySettings.toObject(message.securitySettings, options);
                                if (options.oneofs)
                                    object._securitySettings = "securitySettings";
                            }
                            if (message.backends && message.backends.length) {
                                object.backends = [];
                                for (var j = 0; j < message.backends.length; ++j)
                                    object.backends[j] = $root.google.cloud.compute.v1.Backend.toObject(message.backends[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendService to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendService
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendService.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendService
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendService
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendService.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendService";
                        };
    
                        /**
                         * CompressionMode enum.
                         * @name google.cloud.compute.v1.BackendService.CompressionMode
                         * @enum {number}
                         * @property {number} UNDEFINED_COMPRESSION_MODE=0 UNDEFINED_COMPRESSION_MODE value
                         * @property {number} AUTOMATIC=165298699 AUTOMATIC value
                         * @property {number} DISABLED=516696700 DISABLED value
                         */
                        BackendService.CompressionMode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_COMPRESSION_MODE"] = 0;
                            values[valuesById[165298699] = "AUTOMATIC"] = 165298699;
                            values[valuesById[516696700] = "DISABLED"] = 516696700;
                            return values;
                        })();
    
                        /**
                         * LoadBalancingScheme enum.
                         * @name google.cloud.compute.v1.BackendService.LoadBalancingScheme
                         * @enum {number}
                         * @property {number} UNDEFINED_LOAD_BALANCING_SCHEME=0 UNDEFINED_LOAD_BALANCING_SCHEME value
                         * @property {number} EXTERNAL=35607499 EXTERNAL value
                         * @property {number} EXTERNAL_MANAGED=512006923 EXTERNAL_MANAGED value
                         * @property {number} INTERNAL=279295677 INTERNAL value
                         * @property {number} INTERNAL_MANAGED=37350397 INTERNAL_MANAGED value
                         * @property {number} INTERNAL_SELF_MANAGED=236211150 INTERNAL_SELF_MANAGED value
                         * @property {number} INVALID_LOAD_BALANCING_SCHEME=275352060 INVALID_LOAD_BALANCING_SCHEME value
                         */
                        BackendService.LoadBalancingScheme = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_LOAD_BALANCING_SCHEME"] = 0;
                            values[valuesById[35607499] = "EXTERNAL"] = 35607499;
                            values[valuesById[512006923] = "EXTERNAL_MANAGED"] = 512006923;
                            values[valuesById[279295677] = "INTERNAL"] = 279295677;
                            values[valuesById[37350397] = "INTERNAL_MANAGED"] = 37350397;
                            values[valuesById[236211150] = "INTERNAL_SELF_MANAGED"] = 236211150;
                            values[valuesById[275352060] = "INVALID_LOAD_BALANCING_SCHEME"] = 275352060;
                            return values;
                        })();
    
                        /**
                         * LocalityLbPolicy enum.
                         * @name google.cloud.compute.v1.BackendService.LocalityLbPolicy
                         * @enum {number}
                         * @property {number} UNDEFINED_LOCALITY_LB_POLICY=0 UNDEFINED_LOCALITY_LB_POLICY value
                         * @property {number} INVALID_LB_POLICY=323318707 INVALID_LB_POLICY value
                         * @property {number} LEAST_REQUEST=46604921 LEAST_REQUEST value
                         * @property {number} MAGLEV=119180266 MAGLEV value
                         * @property {number} ORIGINAL_DESTINATION=166297216 ORIGINAL_DESTINATION value
                         * @property {number} RANDOM=262527171 RANDOM value
                         * @property {number} RING_HASH=432795069 RING_HASH value
                         * @property {number} ROUND_ROBIN=153895801 ROUND_ROBIN value
                         */
                        BackendService.LocalityLbPolicy = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_LOCALITY_LB_POLICY"] = 0;
                            values[valuesById[323318707] = "INVALID_LB_POLICY"] = 323318707;
                            values[valuesById[46604921] = "LEAST_REQUEST"] = 46604921;
                            values[valuesById[119180266] = "MAGLEV"] = 119180266;
                            values[valuesById[166297216] = "ORIGINAL_DESTINATION"] = 166297216;
                            values[valuesById[262527171] = "RANDOM"] = 262527171;
                            values[valuesById[432795069] = "RING_HASH"] = 432795069;
                            values[valuesById[153895801] = "ROUND_ROBIN"] = 153895801;
                            return values;
                        })();
    
                        /**
                         * Protocol enum.
                         * @name google.cloud.compute.v1.BackendService.Protocol
                         * @enum {number}
                         * @property {number} UNDEFINED_PROTOCOL=0 UNDEFINED_PROTOCOL value
                         * @property {number} GRPC=2196510 GRPC value
                         * @property {number} HTTP=2228360 HTTP value
                         * @property {number} HTTP2=69079210 HTTP2 value
                         * @property {number} HTTPS=69079243 HTTPS value
                         * @property {number} SSL=82412 SSL value
                         * @property {number} TCP=82881 TCP value
                         * @property {number} UDP=83873 UDP value
                         * @property {number} UNSPECIFIED=526786327 UNSPECIFIED value
                         */
                        BackendService.Protocol = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PROTOCOL"] = 0;
                            values[valuesById[2196510] = "GRPC"] = 2196510;
                            values[valuesById[2228360] = "HTTP"] = 2228360;
                            values[valuesById[69079210] = "HTTP2"] = 69079210;
                            values[valuesById[69079243] = "HTTPS"] = 69079243;
                            values[valuesById[82412] = "SSL"] = 82412;
                            values[valuesById[82881] = "TCP"] = 82881;
                            values[valuesById[83873] = "UDP"] = 83873;
                            values[valuesById[526786327] = "UNSPECIFIED"] = 526786327;
                            return values;
                        })();
    
                        /**
                         * SessionAffinity enum.
                         * @name google.cloud.compute.v1.BackendService.SessionAffinity
                         * @enum {number}
                         * @property {number} UNDEFINED_SESSION_AFFINITY=0 UNDEFINED_SESSION_AFFINITY value
                         * @property {number} CLIENT_IP=345665051 CLIENT_IP value
                         * @property {number} CLIENT_IP_NO_DESTINATION=106122516 CLIENT_IP_NO_DESTINATION value
                         * @property {number} CLIENT_IP_PORT_PROTO=221722926 CLIENT_IP_PORT_PROTO value
                         * @property {number} CLIENT_IP_PROTO=25322148 CLIENT_IP_PROTO value
                         * @property {number} GENERATED_COOKIE=370321204 GENERATED_COOKIE value
                         * @property {number} HEADER_FIELD=200737960 HEADER_FIELD value
                         * @property {number} HTTP_COOKIE=494981627 HTTP_COOKIE value
                         * @property {number} NONE=2402104 NONE value
                         */
                        BackendService.SessionAffinity = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_SESSION_AFFINITY"] = 0;
                            values[valuesById[345665051] = "CLIENT_IP"] = 345665051;
                            values[valuesById[106122516] = "CLIENT_IP_NO_DESTINATION"] = 106122516;
                            values[valuesById[221722926] = "CLIENT_IP_PORT_PROTO"] = 221722926;
                            values[valuesById[25322148] = "CLIENT_IP_PROTO"] = 25322148;
                            values[valuesById[370321204] = "GENERATED_COOKIE"] = 370321204;
                            values[valuesById[200737960] = "HEADER_FIELD"] = 200737960;
                            values[valuesById[494981627] = "HTTP_COOKIE"] = 494981627;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            return values;
                        })();
    
                        return BackendService;
                    })();
    
                    v1.BackendServiceAggregatedList = (function() {
    
                        /**
                         * Properties of a BackendServiceAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendServiceAggregatedList
                         * @property {string|null} [id] BackendServiceAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IBackendServicesScopedList>|null} [items] BackendServiceAggregatedList items
                         * @property {string|null} [kind] BackendServiceAggregatedList kind
                         * @property {string|null} [nextPageToken] BackendServiceAggregatedList nextPageToken
                         * @property {string|null} [selfLink] BackendServiceAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] BackendServiceAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] BackendServiceAggregatedList warning
                         */
    
                        /**
                         * Constructs a new BackendServiceAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendServiceAggregatedList.
                         * @implements IBackendServiceAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendServiceAggregatedList=} [properties] Properties to set
                         */
                        function BackendServiceAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendServiceAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @instance
                         */
                        BackendServiceAggregatedList.prototype.id = null;
    
                        /**
                         * BackendServiceAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IBackendServicesScopedList>} items
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @instance
                         */
                        BackendServiceAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * BackendServiceAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @instance
                         */
                        BackendServiceAggregatedList.prototype.kind = null;
    
                        /**
                         * BackendServiceAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @instance
                         */
                        BackendServiceAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * BackendServiceAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @instance
                         */
                        BackendServiceAggregatedList.prototype.selfLink = null;
    
                        /**
                         * BackendServiceAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @instance
                         */
                        BackendServiceAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * BackendServiceAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @instance
                         */
                        BackendServiceAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendServiceAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(BackendServiceAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(BackendServiceAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(BackendServiceAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(BackendServiceAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(BackendServiceAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendServiceAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendServiceAggregatedList} BackendServiceAggregatedList instance
                         */
                        BackendServiceAggregatedList.create = function create(properties) {
                            return new BackendServiceAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified BackendServiceAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.BackendServiceAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceAggregatedList} message BackendServiceAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.BackendServicesScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendServiceAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendServiceAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceAggregatedList} message BackendServiceAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendServiceAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendServiceAggregatedList} BackendServiceAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendServiceAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.BackendServicesScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendServiceAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendServiceAggregatedList} BackendServiceAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendServiceAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendServiceAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.BackendServicesScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendServiceAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendServiceAggregatedList} BackendServiceAggregatedList
                         */
                        BackendServiceAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendServiceAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendServiceAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendServiceAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.BackendServiceAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.BackendServicesScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.BackendServiceAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendServiceAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendServiceAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.BackendServiceAggregatedList} message BackendServiceAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendServiceAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.BackendServicesScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendServiceAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendServiceAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendServiceAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendServiceAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendServiceAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendServiceAggregatedList";
                        };
    
                        return BackendServiceAggregatedList;
                    })();
    
                    v1.BackendServiceCdnPolicy = (function() {
    
                        /**
                         * Properties of a BackendServiceCdnPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendServiceCdnPolicy
                         * @property {Array.<google.cloud.compute.v1.IBackendServiceCdnPolicyBypassCacheOnRequestHeader>|null} [bypassCacheOnRequestHeaders] BackendServiceCdnPolicy bypassCacheOnRequestHeaders
                         * @property {google.cloud.compute.v1.ICacheKeyPolicy|null} [cacheKeyPolicy] BackendServiceCdnPolicy cacheKeyPolicy
                         * @property {string|null} [cacheMode] BackendServiceCdnPolicy cacheMode
                         * @property {number|null} [clientTtl] BackendServiceCdnPolicy clientTtl
                         * @property {number|null} [defaultTtl] BackendServiceCdnPolicy defaultTtl
                         * @property {number|null} [maxTtl] BackendServiceCdnPolicy maxTtl
                         * @property {boolean|null} [negativeCaching] BackendServiceCdnPolicy negativeCaching
                         * @property {Array.<google.cloud.compute.v1.IBackendServiceCdnPolicyNegativeCachingPolicy>|null} [negativeCachingPolicy] BackendServiceCdnPolicy negativeCachingPolicy
                         * @property {boolean|null} [requestCoalescing] BackendServiceCdnPolicy requestCoalescing
                         * @property {number|null} [serveWhileStale] BackendServiceCdnPolicy serveWhileStale
                         * @property {number|Long|null} [signedUrlCacheMaxAgeSec] BackendServiceCdnPolicy signedUrlCacheMaxAgeSec
                         * @property {Array.<string>|null} [signedUrlKeyNames] BackendServiceCdnPolicy signedUrlKeyNames
                         */
    
                        /**
                         * Constructs a new BackendServiceCdnPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendServiceCdnPolicy.
                         * @implements IBackendServiceCdnPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendServiceCdnPolicy=} [properties] Properties to set
                         */
                        function BackendServiceCdnPolicy(properties) {
                            this.bypassCacheOnRequestHeaders = [];
                            this.negativeCachingPolicy = [];
                            this.signedUrlKeyNames = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendServiceCdnPolicy bypassCacheOnRequestHeaders.
                         * @member {Array.<google.cloud.compute.v1.IBackendServiceCdnPolicyBypassCacheOnRequestHeader>} bypassCacheOnRequestHeaders
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        BackendServiceCdnPolicy.prototype.bypassCacheOnRequestHeaders = $util.emptyArray;
    
                        /**
                         * BackendServiceCdnPolicy cacheKeyPolicy.
                         * @member {google.cloud.compute.v1.ICacheKeyPolicy|null|undefined} cacheKeyPolicy
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        BackendServiceCdnPolicy.prototype.cacheKeyPolicy = null;
    
                        /**
                         * BackendServiceCdnPolicy cacheMode.
                         * @member {string|null|undefined} cacheMode
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        BackendServiceCdnPolicy.prototype.cacheMode = null;
    
                        /**
                         * BackendServiceCdnPolicy clientTtl.
                         * @member {number|null|undefined} clientTtl
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        BackendServiceCdnPolicy.prototype.clientTtl = null;
    
                        /**
                         * BackendServiceCdnPolicy defaultTtl.
                         * @member {number|null|undefined} defaultTtl
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        BackendServiceCdnPolicy.prototype.defaultTtl = null;
    
                        /**
                         * BackendServiceCdnPolicy maxTtl.
                         * @member {number|null|undefined} maxTtl
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        BackendServiceCdnPolicy.prototype.maxTtl = null;
    
                        /**
                         * BackendServiceCdnPolicy negativeCaching.
                         * @member {boolean|null|undefined} negativeCaching
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        BackendServiceCdnPolicy.prototype.negativeCaching = null;
    
                        /**
                         * BackendServiceCdnPolicy negativeCachingPolicy.
                         * @member {Array.<google.cloud.compute.v1.IBackendServiceCdnPolicyNegativeCachingPolicy>} negativeCachingPolicy
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        BackendServiceCdnPolicy.prototype.negativeCachingPolicy = $util.emptyArray;
    
                        /**
                         * BackendServiceCdnPolicy requestCoalescing.
                         * @member {boolean|null|undefined} requestCoalescing
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        BackendServiceCdnPolicy.prototype.requestCoalescing = null;
    
                        /**
                         * BackendServiceCdnPolicy serveWhileStale.
                         * @member {number|null|undefined} serveWhileStale
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        BackendServiceCdnPolicy.prototype.serveWhileStale = null;
    
                        /**
                         * BackendServiceCdnPolicy signedUrlCacheMaxAgeSec.
                         * @member {number|Long|null|undefined} signedUrlCacheMaxAgeSec
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        BackendServiceCdnPolicy.prototype.signedUrlCacheMaxAgeSec = null;
    
                        /**
                         * BackendServiceCdnPolicy signedUrlKeyNames.
                         * @member {Array.<string>} signedUrlKeyNames
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        BackendServiceCdnPolicy.prototype.signedUrlKeyNames = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendServiceCdnPolicy _cacheKeyPolicy.
                         * @member {"cacheKeyPolicy"|undefined} _cacheKeyPolicy
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceCdnPolicy.prototype, "_cacheKeyPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["cacheKeyPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceCdnPolicy _cacheMode.
                         * @member {"cacheMode"|undefined} _cacheMode
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceCdnPolicy.prototype, "_cacheMode", {
                            get: $util.oneOfGetter($oneOfFields = ["cacheMode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceCdnPolicy _clientTtl.
                         * @member {"clientTtl"|undefined} _clientTtl
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceCdnPolicy.prototype, "_clientTtl", {
                            get: $util.oneOfGetter($oneOfFields = ["clientTtl"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceCdnPolicy _defaultTtl.
                         * @member {"defaultTtl"|undefined} _defaultTtl
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceCdnPolicy.prototype, "_defaultTtl", {
                            get: $util.oneOfGetter($oneOfFields = ["defaultTtl"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceCdnPolicy _maxTtl.
                         * @member {"maxTtl"|undefined} _maxTtl
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceCdnPolicy.prototype, "_maxTtl", {
                            get: $util.oneOfGetter($oneOfFields = ["maxTtl"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceCdnPolicy _negativeCaching.
                         * @member {"negativeCaching"|undefined} _negativeCaching
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceCdnPolicy.prototype, "_negativeCaching", {
                            get: $util.oneOfGetter($oneOfFields = ["negativeCaching"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceCdnPolicy _requestCoalescing.
                         * @member {"requestCoalescing"|undefined} _requestCoalescing
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceCdnPolicy.prototype, "_requestCoalescing", {
                            get: $util.oneOfGetter($oneOfFields = ["requestCoalescing"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceCdnPolicy _serveWhileStale.
                         * @member {"serveWhileStale"|undefined} _serveWhileStale
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceCdnPolicy.prototype, "_serveWhileStale", {
                            get: $util.oneOfGetter($oneOfFields = ["serveWhileStale"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceCdnPolicy _signedUrlCacheMaxAgeSec.
                         * @member {"signedUrlCacheMaxAgeSec"|undefined} _signedUrlCacheMaxAgeSec
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceCdnPolicy.prototype, "_signedUrlCacheMaxAgeSec", {
                            get: $util.oneOfGetter($oneOfFields = ["signedUrlCacheMaxAgeSec"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendServiceCdnPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceCdnPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendServiceCdnPolicy} BackendServiceCdnPolicy instance
                         */
                        BackendServiceCdnPolicy.create = function create(properties) {
                            return new BackendServiceCdnPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified BackendServiceCdnPolicy message. Does not implicitly {@link google.cloud.compute.v1.BackendServiceCdnPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceCdnPolicy} message BackendServiceCdnPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceCdnPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.cacheMode != null && Object.hasOwnProperty.call(message, "cacheMode"))
                                writer.uint32(/* id 28877888, wireType 2 =*/231023106).string(message.cacheMode);
                            if (message.clientTtl != null && Object.hasOwnProperty.call(message, "clientTtl"))
                                writer.uint32(/* id 29034360, wireType 0 =*/232274880).int32(message.clientTtl);
                            if (message.defaultTtl != null && Object.hasOwnProperty.call(message, "defaultTtl"))
                                writer.uint32(/* id 100253422, wireType 0 =*/802027376).int32(message.defaultTtl);
                            if (message.negativeCachingPolicy != null && message.negativeCachingPolicy.length)
                                for (var i = 0; i < message.negativeCachingPolicy.length; ++i)
                                    $root.google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy.encode(message.negativeCachingPolicy[i], writer.uint32(/* id 155359996, wireType 2 =*/1242879970).fork()).ldelim();
                            if (message.cacheKeyPolicy != null && Object.hasOwnProperty.call(message, "cacheKeyPolicy"))
                                $root.google.cloud.compute.v1.CacheKeyPolicy.encode(message.cacheKeyPolicy, writer.uint32(/* id 159263727, wireType 2 =*/1274109818).fork()).ldelim();
                            if (message.serveWhileStale != null && Object.hasOwnProperty.call(message, "serveWhileStale"))
                                writer.uint32(/* id 236682203, wireType 0 =*/1893457624).int32(message.serveWhileStale);
                            if (message.signedUrlCacheMaxAgeSec != null && Object.hasOwnProperty.call(message, "signedUrlCacheMaxAgeSec"))
                                writer.uint32(/* id 269374534, wireType 0 =*/2154996272).int64(message.signedUrlCacheMaxAgeSec);
                            if (message.maxTtl != null && Object.hasOwnProperty.call(message, "maxTtl"))
                                writer.uint32(/* id 307578001, wireType 0 =*/2460624008).int32(message.maxTtl);
                            if (message.negativeCaching != null && Object.hasOwnProperty.call(message, "negativeCaching"))
                                writer.uint32(/* id 336110005, wireType 0 =*/2688880040).bool(message.negativeCaching);
                            if (message.signedUrlKeyNames != null && message.signedUrlKeyNames.length)
                                for (var i = 0; i < message.signedUrlKeyNames.length; ++i)
                                    writer.uint32(/* id 371848885, wireType 2 =*/2974791082).string(message.signedUrlKeyNames[i]);
                            if (message.bypassCacheOnRequestHeaders != null && message.bypassCacheOnRequestHeaders.length)
                                for (var i = 0; i < message.bypassCacheOnRequestHeaders.length; ++i)
                                    $root.google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader.encode(message.bypassCacheOnRequestHeaders[i], writer.uint32(/* id 486203082, wireType 2 =*/3889624658).fork()).ldelim();
                            if (message.requestCoalescing != null && Object.hasOwnProperty.call(message, "requestCoalescing"))
                                writer.uint32(/* id 532808276, wireType 0 =*/4262466208).bool(message.requestCoalescing);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendServiceCdnPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendServiceCdnPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceCdnPolicy} message BackendServiceCdnPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceCdnPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendServiceCdnPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendServiceCdnPolicy} BackendServiceCdnPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceCdnPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendServiceCdnPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 486203082: {
                                        if (!(message.bypassCacheOnRequestHeaders && message.bypassCacheOnRequestHeaders.length))
                                            message.bypassCacheOnRequestHeaders = [];
                                        message.bypassCacheOnRequestHeaders.push($root.google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 159263727: {
                                        message.cacheKeyPolicy = $root.google.cloud.compute.v1.CacheKeyPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 28877888: {
                                        message.cacheMode = reader.string();
                                        break;
                                    }
                                case 29034360: {
                                        message.clientTtl = reader.int32();
                                        break;
                                    }
                                case 100253422: {
                                        message.defaultTtl = reader.int32();
                                        break;
                                    }
                                case 307578001: {
                                        message.maxTtl = reader.int32();
                                        break;
                                    }
                                case 336110005: {
                                        message.negativeCaching = reader.bool();
                                        break;
                                    }
                                case 155359996: {
                                        if (!(message.negativeCachingPolicy && message.negativeCachingPolicy.length))
                                            message.negativeCachingPolicy = [];
                                        message.negativeCachingPolicy.push($root.google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 532808276: {
                                        message.requestCoalescing = reader.bool();
                                        break;
                                    }
                                case 236682203: {
                                        message.serveWhileStale = reader.int32();
                                        break;
                                    }
                                case 269374534: {
                                        message.signedUrlCacheMaxAgeSec = reader.int64();
                                        break;
                                    }
                                case 371848885: {
                                        if (!(message.signedUrlKeyNames && message.signedUrlKeyNames.length))
                                            message.signedUrlKeyNames = [];
                                        message.signedUrlKeyNames.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendServiceCdnPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendServiceCdnPolicy} BackendServiceCdnPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceCdnPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendServiceCdnPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendServiceCdnPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.bypassCacheOnRequestHeaders != null && message.hasOwnProperty("bypassCacheOnRequestHeaders")) {
                                if (!Array.isArray(message.bypassCacheOnRequestHeaders))
                                    return "bypassCacheOnRequestHeaders: array expected";
                                for (var i = 0; i < message.bypassCacheOnRequestHeaders.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader.verify(message.bypassCacheOnRequestHeaders[i]);
                                    if (error)
                                        return "bypassCacheOnRequestHeaders." + error;
                                }
                            }
                            if (message.cacheKeyPolicy != null && message.hasOwnProperty("cacheKeyPolicy")) {
                                properties._cacheKeyPolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.CacheKeyPolicy.verify(message.cacheKeyPolicy);
                                    if (error)
                                        return "cacheKeyPolicy." + error;
                                }
                            }
                            if (message.cacheMode != null && message.hasOwnProperty("cacheMode")) {
                                properties._cacheMode = 1;
                                if (!$util.isString(message.cacheMode))
                                    return "cacheMode: string expected";
                            }
                            if (message.clientTtl != null && message.hasOwnProperty("clientTtl")) {
                                properties._clientTtl = 1;
                                if (!$util.isInteger(message.clientTtl))
                                    return "clientTtl: integer expected";
                            }
                            if (message.defaultTtl != null && message.hasOwnProperty("defaultTtl")) {
                                properties._defaultTtl = 1;
                                if (!$util.isInteger(message.defaultTtl))
                                    return "defaultTtl: integer expected";
                            }
                            if (message.maxTtl != null && message.hasOwnProperty("maxTtl")) {
                                properties._maxTtl = 1;
                                if (!$util.isInteger(message.maxTtl))
                                    return "maxTtl: integer expected";
                            }
                            if (message.negativeCaching != null && message.hasOwnProperty("negativeCaching")) {
                                properties._negativeCaching = 1;
                                if (typeof message.negativeCaching !== "boolean")
                                    return "negativeCaching: boolean expected";
                            }
                            if (message.negativeCachingPolicy != null && message.hasOwnProperty("negativeCachingPolicy")) {
                                if (!Array.isArray(message.negativeCachingPolicy))
                                    return "negativeCachingPolicy: array expected";
                                for (var i = 0; i < message.negativeCachingPolicy.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy.verify(message.negativeCachingPolicy[i]);
                                    if (error)
                                        return "negativeCachingPolicy." + error;
                                }
                            }
                            if (message.requestCoalescing != null && message.hasOwnProperty("requestCoalescing")) {
                                properties._requestCoalescing = 1;
                                if (typeof message.requestCoalescing !== "boolean")
                                    return "requestCoalescing: boolean expected";
                            }
                            if (message.serveWhileStale != null && message.hasOwnProperty("serveWhileStale")) {
                                properties._serveWhileStale = 1;
                                if (!$util.isInteger(message.serveWhileStale))
                                    return "serveWhileStale: integer expected";
                            }
                            if (message.signedUrlCacheMaxAgeSec != null && message.hasOwnProperty("signedUrlCacheMaxAgeSec")) {
                                properties._signedUrlCacheMaxAgeSec = 1;
                                if (!$util.isInteger(message.signedUrlCacheMaxAgeSec) && !(message.signedUrlCacheMaxAgeSec && $util.isInteger(message.signedUrlCacheMaxAgeSec.low) && $util.isInteger(message.signedUrlCacheMaxAgeSec.high)))
                                    return "signedUrlCacheMaxAgeSec: integer|Long expected";
                            }
                            if (message.signedUrlKeyNames != null && message.hasOwnProperty("signedUrlKeyNames")) {
                                if (!Array.isArray(message.signedUrlKeyNames))
                                    return "signedUrlKeyNames: array expected";
                                for (var i = 0; i < message.signedUrlKeyNames.length; ++i)
                                    if (!$util.isString(message.signedUrlKeyNames[i]))
                                        return "signedUrlKeyNames: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendServiceCdnPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendServiceCdnPolicy} BackendServiceCdnPolicy
                         */
                        BackendServiceCdnPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendServiceCdnPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendServiceCdnPolicy();
                            if (object.bypassCacheOnRequestHeaders) {
                                if (!Array.isArray(object.bypassCacheOnRequestHeaders))
                                    throw TypeError(".google.cloud.compute.v1.BackendServiceCdnPolicy.bypassCacheOnRequestHeaders: array expected");
                                message.bypassCacheOnRequestHeaders = [];
                                for (var i = 0; i < object.bypassCacheOnRequestHeaders.length; ++i) {
                                    if (typeof object.bypassCacheOnRequestHeaders[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.BackendServiceCdnPolicy.bypassCacheOnRequestHeaders: object expected");
                                    message.bypassCacheOnRequestHeaders[i] = $root.google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader.fromObject(object.bypassCacheOnRequestHeaders[i]);
                                }
                            }
                            if (object.cacheKeyPolicy != null) {
                                if (typeof object.cacheKeyPolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendServiceCdnPolicy.cacheKeyPolicy: object expected");
                                message.cacheKeyPolicy = $root.google.cloud.compute.v1.CacheKeyPolicy.fromObject(object.cacheKeyPolicy);
                            }
                            if (object.cacheMode != null)
                                message.cacheMode = String(object.cacheMode);
                            if (object.clientTtl != null)
                                message.clientTtl = object.clientTtl | 0;
                            if (object.defaultTtl != null)
                                message.defaultTtl = object.defaultTtl | 0;
                            if (object.maxTtl != null)
                                message.maxTtl = object.maxTtl | 0;
                            if (object.negativeCaching != null)
                                message.negativeCaching = Boolean(object.negativeCaching);
                            if (object.negativeCachingPolicy) {
                                if (!Array.isArray(object.negativeCachingPolicy))
                                    throw TypeError(".google.cloud.compute.v1.BackendServiceCdnPolicy.negativeCachingPolicy: array expected");
                                message.negativeCachingPolicy = [];
                                for (var i = 0; i < object.negativeCachingPolicy.length; ++i) {
                                    if (typeof object.negativeCachingPolicy[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.BackendServiceCdnPolicy.negativeCachingPolicy: object expected");
                                    message.negativeCachingPolicy[i] = $root.google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy.fromObject(object.negativeCachingPolicy[i]);
                                }
                            }
                            if (object.requestCoalescing != null)
                                message.requestCoalescing = Boolean(object.requestCoalescing);
                            if (object.serveWhileStale != null)
                                message.serveWhileStale = object.serveWhileStale | 0;
                            if (object.signedUrlCacheMaxAgeSec != null)
                                if ($util.Long)
                                    (message.signedUrlCacheMaxAgeSec = $util.Long.fromValue(object.signedUrlCacheMaxAgeSec)).unsigned = false;
                                else if (typeof object.signedUrlCacheMaxAgeSec === "string")
                                    message.signedUrlCacheMaxAgeSec = parseInt(object.signedUrlCacheMaxAgeSec, 10);
                                else if (typeof object.signedUrlCacheMaxAgeSec === "number")
                                    message.signedUrlCacheMaxAgeSec = object.signedUrlCacheMaxAgeSec;
                                else if (typeof object.signedUrlCacheMaxAgeSec === "object")
                                    message.signedUrlCacheMaxAgeSec = new $util.LongBits(object.signedUrlCacheMaxAgeSec.low >>> 0, object.signedUrlCacheMaxAgeSec.high >>> 0).toNumber();
                            if (object.signedUrlKeyNames) {
                                if (!Array.isArray(object.signedUrlKeyNames))
                                    throw TypeError(".google.cloud.compute.v1.BackendServiceCdnPolicy.signedUrlKeyNames: array expected");
                                message.signedUrlKeyNames = [];
                                for (var i = 0; i < object.signedUrlKeyNames.length; ++i)
                                    message.signedUrlKeyNames[i] = String(object.signedUrlKeyNames[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendServiceCdnPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @static
                         * @param {google.cloud.compute.v1.BackendServiceCdnPolicy} message BackendServiceCdnPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendServiceCdnPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.negativeCachingPolicy = [];
                                object.signedUrlKeyNames = [];
                                object.bypassCacheOnRequestHeaders = [];
                            }
                            if (message.cacheMode != null && message.hasOwnProperty("cacheMode")) {
                                object.cacheMode = message.cacheMode;
                                if (options.oneofs)
                                    object._cacheMode = "cacheMode";
                            }
                            if (message.clientTtl != null && message.hasOwnProperty("clientTtl")) {
                                object.clientTtl = message.clientTtl;
                                if (options.oneofs)
                                    object._clientTtl = "clientTtl";
                            }
                            if (message.defaultTtl != null && message.hasOwnProperty("defaultTtl")) {
                                object.defaultTtl = message.defaultTtl;
                                if (options.oneofs)
                                    object._defaultTtl = "defaultTtl";
                            }
                            if (message.negativeCachingPolicy && message.negativeCachingPolicy.length) {
                                object.negativeCachingPolicy = [];
                                for (var j = 0; j < message.negativeCachingPolicy.length; ++j)
                                    object.negativeCachingPolicy[j] = $root.google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy.toObject(message.negativeCachingPolicy[j], options);
                            }
                            if (message.cacheKeyPolicy != null && message.hasOwnProperty("cacheKeyPolicy")) {
                                object.cacheKeyPolicy = $root.google.cloud.compute.v1.CacheKeyPolicy.toObject(message.cacheKeyPolicy, options);
                                if (options.oneofs)
                                    object._cacheKeyPolicy = "cacheKeyPolicy";
                            }
                            if (message.serveWhileStale != null && message.hasOwnProperty("serveWhileStale")) {
                                object.serveWhileStale = message.serveWhileStale;
                                if (options.oneofs)
                                    object._serveWhileStale = "serveWhileStale";
                            }
                            if (message.signedUrlCacheMaxAgeSec != null && message.hasOwnProperty("signedUrlCacheMaxAgeSec")) {
                                if (typeof message.signedUrlCacheMaxAgeSec === "number")
                                    object.signedUrlCacheMaxAgeSec = options.longs === String ? String(message.signedUrlCacheMaxAgeSec) : message.signedUrlCacheMaxAgeSec;
                                else
                                    object.signedUrlCacheMaxAgeSec = options.longs === String ? $util.Long.prototype.toString.call(message.signedUrlCacheMaxAgeSec) : options.longs === Number ? new $util.LongBits(message.signedUrlCacheMaxAgeSec.low >>> 0, message.signedUrlCacheMaxAgeSec.high >>> 0).toNumber() : message.signedUrlCacheMaxAgeSec;
                                if (options.oneofs)
                                    object._signedUrlCacheMaxAgeSec = "signedUrlCacheMaxAgeSec";
                            }
                            if (message.maxTtl != null && message.hasOwnProperty("maxTtl")) {
                                object.maxTtl = message.maxTtl;
                                if (options.oneofs)
                                    object._maxTtl = "maxTtl";
                            }
                            if (message.negativeCaching != null && message.hasOwnProperty("negativeCaching")) {
                                object.negativeCaching = message.negativeCaching;
                                if (options.oneofs)
                                    object._negativeCaching = "negativeCaching";
                            }
                            if (message.signedUrlKeyNames && message.signedUrlKeyNames.length) {
                                object.signedUrlKeyNames = [];
                                for (var j = 0; j < message.signedUrlKeyNames.length; ++j)
                                    object.signedUrlKeyNames[j] = message.signedUrlKeyNames[j];
                            }
                            if (message.bypassCacheOnRequestHeaders && message.bypassCacheOnRequestHeaders.length) {
                                object.bypassCacheOnRequestHeaders = [];
                                for (var j = 0; j < message.bypassCacheOnRequestHeaders.length; ++j)
                                    object.bypassCacheOnRequestHeaders[j] = $root.google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader.toObject(message.bypassCacheOnRequestHeaders[j], options);
                            }
                            if (message.requestCoalescing != null && message.hasOwnProperty("requestCoalescing")) {
                                object.requestCoalescing = message.requestCoalescing;
                                if (options.oneofs)
                                    object._requestCoalescing = "requestCoalescing";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendServiceCdnPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendServiceCdnPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendServiceCdnPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendServiceCdnPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendServiceCdnPolicy";
                        };
    
                        /**
                         * CacheMode enum.
                         * @name google.cloud.compute.v1.BackendServiceCdnPolicy.CacheMode
                         * @enum {number}
                         * @property {number} UNDEFINED_CACHE_MODE=0 UNDEFINED_CACHE_MODE value
                         * @property {number} CACHE_ALL_STATIC=355027945 CACHE_ALL_STATIC value
                         * @property {number} FORCE_CACHE_ALL=486026928 FORCE_CACHE_ALL value
                         * @property {number} INVALID_CACHE_MODE=381295560 INVALID_CACHE_MODE value
                         * @property {number} USE_ORIGIN_HEADERS=55380261 USE_ORIGIN_HEADERS value
                         */
                        BackendServiceCdnPolicy.CacheMode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_CACHE_MODE"] = 0;
                            values[valuesById[355027945] = "CACHE_ALL_STATIC"] = 355027945;
                            values[valuesById[486026928] = "FORCE_CACHE_ALL"] = 486026928;
                            values[valuesById[381295560] = "INVALID_CACHE_MODE"] = 381295560;
                            values[valuesById[55380261] = "USE_ORIGIN_HEADERS"] = 55380261;
                            return values;
                        })();
    
                        return BackendServiceCdnPolicy;
                    })();
    
                    v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader = (function() {
    
                        /**
                         * Properties of a BackendServiceCdnPolicyBypassCacheOnRequestHeader.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendServiceCdnPolicyBypassCacheOnRequestHeader
                         * @property {string|null} [headerName] BackendServiceCdnPolicyBypassCacheOnRequestHeader headerName
                         */
    
                        /**
                         * Constructs a new BackendServiceCdnPolicyBypassCacheOnRequestHeader.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendServiceCdnPolicyBypassCacheOnRequestHeader.
                         * @implements IBackendServiceCdnPolicyBypassCacheOnRequestHeader
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendServiceCdnPolicyBypassCacheOnRequestHeader=} [properties] Properties to set
                         */
                        function BackendServiceCdnPolicyBypassCacheOnRequestHeader(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendServiceCdnPolicyBypassCacheOnRequestHeader headerName.
                         * @member {string|null|undefined} headerName
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader
                         * @instance
                         */
                        BackendServiceCdnPolicyBypassCacheOnRequestHeader.prototype.headerName = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendServiceCdnPolicyBypassCacheOnRequestHeader _headerName.
                         * @member {"headerName"|undefined} _headerName
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader
                         * @instance
                         */
                        Object.defineProperty(BackendServiceCdnPolicyBypassCacheOnRequestHeader.prototype, "_headerName", {
                            get: $util.oneOfGetter($oneOfFields = ["headerName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendServiceCdnPolicyBypassCacheOnRequestHeader instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceCdnPolicyBypassCacheOnRequestHeader=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader} BackendServiceCdnPolicyBypassCacheOnRequestHeader instance
                         */
                        BackendServiceCdnPolicyBypassCacheOnRequestHeader.create = function create(properties) {
                            return new BackendServiceCdnPolicyBypassCacheOnRequestHeader(properties);
                        };
    
                        /**
                         * Encodes the specified BackendServiceCdnPolicyBypassCacheOnRequestHeader message. Does not implicitly {@link google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceCdnPolicyBypassCacheOnRequestHeader} message BackendServiceCdnPolicyBypassCacheOnRequestHeader message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceCdnPolicyBypassCacheOnRequestHeader.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.headerName != null && Object.hasOwnProperty.call(message, "headerName"))
                                writer.uint32(/* id 110223613, wireType 2 =*/881788906).string(message.headerName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendServiceCdnPolicyBypassCacheOnRequestHeader message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceCdnPolicyBypassCacheOnRequestHeader} message BackendServiceCdnPolicyBypassCacheOnRequestHeader message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceCdnPolicyBypassCacheOnRequestHeader.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendServiceCdnPolicyBypassCacheOnRequestHeader message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader} BackendServiceCdnPolicyBypassCacheOnRequestHeader
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceCdnPolicyBypassCacheOnRequestHeader.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 110223613: {
                                        message.headerName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendServiceCdnPolicyBypassCacheOnRequestHeader message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader} BackendServiceCdnPolicyBypassCacheOnRequestHeader
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceCdnPolicyBypassCacheOnRequestHeader.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendServiceCdnPolicyBypassCacheOnRequestHeader message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendServiceCdnPolicyBypassCacheOnRequestHeader.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.headerName != null && message.hasOwnProperty("headerName")) {
                                properties._headerName = 1;
                                if (!$util.isString(message.headerName))
                                    return "headerName: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendServiceCdnPolicyBypassCacheOnRequestHeader message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader} BackendServiceCdnPolicyBypassCacheOnRequestHeader
                         */
                        BackendServiceCdnPolicyBypassCacheOnRequestHeader.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader();
                            if (object.headerName != null)
                                message.headerName = String(object.headerName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendServiceCdnPolicyBypassCacheOnRequestHeader message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader
                         * @static
                         * @param {google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader} message BackendServiceCdnPolicyBypassCacheOnRequestHeader
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendServiceCdnPolicyBypassCacheOnRequestHeader.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.headerName != null && message.hasOwnProperty("headerName")) {
                                object.headerName = message.headerName;
                                if (options.oneofs)
                                    object._headerName = "headerName";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendServiceCdnPolicyBypassCacheOnRequestHeader to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendServiceCdnPolicyBypassCacheOnRequestHeader.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendServiceCdnPolicyBypassCacheOnRequestHeader
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendServiceCdnPolicyBypassCacheOnRequestHeader.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendServiceCdnPolicyBypassCacheOnRequestHeader";
                        };
    
                        return BackendServiceCdnPolicyBypassCacheOnRequestHeader;
                    })();
    
                    v1.BackendServiceCdnPolicyNegativeCachingPolicy = (function() {
    
                        /**
                         * Properties of a BackendServiceCdnPolicyNegativeCachingPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendServiceCdnPolicyNegativeCachingPolicy
                         * @property {number|null} [code] BackendServiceCdnPolicyNegativeCachingPolicy code
                         * @property {number|null} [ttl] BackendServiceCdnPolicyNegativeCachingPolicy ttl
                         */
    
                        /**
                         * Constructs a new BackendServiceCdnPolicyNegativeCachingPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendServiceCdnPolicyNegativeCachingPolicy.
                         * @implements IBackendServiceCdnPolicyNegativeCachingPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendServiceCdnPolicyNegativeCachingPolicy=} [properties] Properties to set
                         */
                        function BackendServiceCdnPolicyNegativeCachingPolicy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendServiceCdnPolicyNegativeCachingPolicy code.
                         * @member {number|null|undefined} code
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy
                         * @instance
                         */
                        BackendServiceCdnPolicyNegativeCachingPolicy.prototype.code = null;
    
                        /**
                         * BackendServiceCdnPolicyNegativeCachingPolicy ttl.
                         * @member {number|null|undefined} ttl
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy
                         * @instance
                         */
                        BackendServiceCdnPolicyNegativeCachingPolicy.prototype.ttl = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendServiceCdnPolicyNegativeCachingPolicy _code.
                         * @member {"code"|undefined} _code
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceCdnPolicyNegativeCachingPolicy.prototype, "_code", {
                            get: $util.oneOfGetter($oneOfFields = ["code"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceCdnPolicyNegativeCachingPolicy _ttl.
                         * @member {"ttl"|undefined} _ttl
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceCdnPolicyNegativeCachingPolicy.prototype, "_ttl", {
                            get: $util.oneOfGetter($oneOfFields = ["ttl"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendServiceCdnPolicyNegativeCachingPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceCdnPolicyNegativeCachingPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy} BackendServiceCdnPolicyNegativeCachingPolicy instance
                         */
                        BackendServiceCdnPolicyNegativeCachingPolicy.create = function create(properties) {
                            return new BackendServiceCdnPolicyNegativeCachingPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified BackendServiceCdnPolicyNegativeCachingPolicy message. Does not implicitly {@link google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceCdnPolicyNegativeCachingPolicy} message BackendServiceCdnPolicyNegativeCachingPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceCdnPolicyNegativeCachingPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.ttl != null && Object.hasOwnProperty.call(message, "ttl"))
                                writer.uint32(/* id 115180, wireType 0 =*/921440).int32(message.ttl);
                            if (message.code != null && Object.hasOwnProperty.call(message, "code"))
                                writer.uint32(/* id 3059181, wireType 0 =*/24473448).int32(message.code);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendServiceCdnPolicyNegativeCachingPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceCdnPolicyNegativeCachingPolicy} message BackendServiceCdnPolicyNegativeCachingPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceCdnPolicyNegativeCachingPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendServiceCdnPolicyNegativeCachingPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy} BackendServiceCdnPolicyNegativeCachingPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceCdnPolicyNegativeCachingPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3059181: {
                                        message.code = reader.int32();
                                        break;
                                    }
                                case 115180: {
                                        message.ttl = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendServiceCdnPolicyNegativeCachingPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy} BackendServiceCdnPolicyNegativeCachingPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceCdnPolicyNegativeCachingPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendServiceCdnPolicyNegativeCachingPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendServiceCdnPolicyNegativeCachingPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.code != null && message.hasOwnProperty("code")) {
                                properties._code = 1;
                                if (!$util.isInteger(message.code))
                                    return "code: integer expected";
                            }
                            if (message.ttl != null && message.hasOwnProperty("ttl")) {
                                properties._ttl = 1;
                                if (!$util.isInteger(message.ttl))
                                    return "ttl: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendServiceCdnPolicyNegativeCachingPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy} BackendServiceCdnPolicyNegativeCachingPolicy
                         */
                        BackendServiceCdnPolicyNegativeCachingPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy();
                            if (object.code != null)
                                message.code = object.code | 0;
                            if (object.ttl != null)
                                message.ttl = object.ttl | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendServiceCdnPolicyNegativeCachingPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy} message BackendServiceCdnPolicyNegativeCachingPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendServiceCdnPolicyNegativeCachingPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.ttl != null && message.hasOwnProperty("ttl")) {
                                object.ttl = message.ttl;
                                if (options.oneofs)
                                    object._ttl = "ttl";
                            }
                            if (message.code != null && message.hasOwnProperty("code")) {
                                object.code = message.code;
                                if (options.oneofs)
                                    object._code = "code";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendServiceCdnPolicyNegativeCachingPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendServiceCdnPolicyNegativeCachingPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendServiceCdnPolicyNegativeCachingPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendServiceCdnPolicyNegativeCachingPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendServiceCdnPolicyNegativeCachingPolicy";
                        };
    
                        return BackendServiceCdnPolicyNegativeCachingPolicy;
                    })();
    
                    v1.BackendServiceConnectionTrackingPolicy = (function() {
    
                        /**
                         * Properties of a BackendServiceConnectionTrackingPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendServiceConnectionTrackingPolicy
                         * @property {string|null} [connectionPersistenceOnUnhealthyBackends] BackendServiceConnectionTrackingPolicy connectionPersistenceOnUnhealthyBackends
                         * @property {boolean|null} [enableStrongAffinity] BackendServiceConnectionTrackingPolicy enableStrongAffinity
                         * @property {number|null} [idleTimeoutSec] BackendServiceConnectionTrackingPolicy idleTimeoutSec
                         * @property {string|null} [trackingMode] BackendServiceConnectionTrackingPolicy trackingMode
                         */
    
                        /**
                         * Constructs a new BackendServiceConnectionTrackingPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendServiceConnectionTrackingPolicy.
                         * @implements IBackendServiceConnectionTrackingPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendServiceConnectionTrackingPolicy=} [properties] Properties to set
                         */
                        function BackendServiceConnectionTrackingPolicy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendServiceConnectionTrackingPolicy connectionPersistenceOnUnhealthyBackends.
                         * @member {string|null|undefined} connectionPersistenceOnUnhealthyBackends
                         * @memberof google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy
                         * @instance
                         */
                        BackendServiceConnectionTrackingPolicy.prototype.connectionPersistenceOnUnhealthyBackends = null;
    
                        /**
                         * BackendServiceConnectionTrackingPolicy enableStrongAffinity.
                         * @member {boolean|null|undefined} enableStrongAffinity
                         * @memberof google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy
                         * @instance
                         */
                        BackendServiceConnectionTrackingPolicy.prototype.enableStrongAffinity = null;
    
                        /**
                         * BackendServiceConnectionTrackingPolicy idleTimeoutSec.
                         * @member {number|null|undefined} idleTimeoutSec
                         * @memberof google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy
                         * @instance
                         */
                        BackendServiceConnectionTrackingPolicy.prototype.idleTimeoutSec = null;
    
                        /**
                         * BackendServiceConnectionTrackingPolicy trackingMode.
                         * @member {string|null|undefined} trackingMode
                         * @memberof google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy
                         * @instance
                         */
                        BackendServiceConnectionTrackingPolicy.prototype.trackingMode = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendServiceConnectionTrackingPolicy _connectionPersistenceOnUnhealthyBackends.
                         * @member {"connectionPersistenceOnUnhealthyBackends"|undefined} _connectionPersistenceOnUnhealthyBackends
                         * @memberof google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceConnectionTrackingPolicy.prototype, "_connectionPersistenceOnUnhealthyBackends", {
                            get: $util.oneOfGetter($oneOfFields = ["connectionPersistenceOnUnhealthyBackends"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceConnectionTrackingPolicy _enableStrongAffinity.
                         * @member {"enableStrongAffinity"|undefined} _enableStrongAffinity
                         * @memberof google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceConnectionTrackingPolicy.prototype, "_enableStrongAffinity", {
                            get: $util.oneOfGetter($oneOfFields = ["enableStrongAffinity"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceConnectionTrackingPolicy _idleTimeoutSec.
                         * @member {"idleTimeoutSec"|undefined} _idleTimeoutSec
                         * @memberof google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceConnectionTrackingPolicy.prototype, "_idleTimeoutSec", {
                            get: $util.oneOfGetter($oneOfFields = ["idleTimeoutSec"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceConnectionTrackingPolicy _trackingMode.
                         * @member {"trackingMode"|undefined} _trackingMode
                         * @memberof google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceConnectionTrackingPolicy.prototype, "_trackingMode", {
                            get: $util.oneOfGetter($oneOfFields = ["trackingMode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendServiceConnectionTrackingPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceConnectionTrackingPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy} BackendServiceConnectionTrackingPolicy instance
                         */
                        BackendServiceConnectionTrackingPolicy.create = function create(properties) {
                            return new BackendServiceConnectionTrackingPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified BackendServiceConnectionTrackingPolicy message. Does not implicitly {@link google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceConnectionTrackingPolicy} message BackendServiceConnectionTrackingPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceConnectionTrackingPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.enableStrongAffinity != null && Object.hasOwnProperty.call(message, "enableStrongAffinity"))
                                writer.uint32(/* id 24539924, wireType 0 =*/196319392).bool(message.enableStrongAffinity);
                            if (message.idleTimeoutSec != null && Object.hasOwnProperty.call(message, "idleTimeoutSec"))
                                writer.uint32(/* id 24977544, wireType 0 =*/199820352).int32(message.idleTimeoutSec);
                            if (message.trackingMode != null && Object.hasOwnProperty.call(message, "trackingMode"))
                                writer.uint32(/* id 127757867, wireType 2 =*/1022062938).string(message.trackingMode);
                            if (message.connectionPersistenceOnUnhealthyBackends != null && Object.hasOwnProperty.call(message, "connectionPersistenceOnUnhealthyBackends"))
                                writer.uint32(/* id 152439033, wireType 2 =*/1219512266).string(message.connectionPersistenceOnUnhealthyBackends);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendServiceConnectionTrackingPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceConnectionTrackingPolicy} message BackendServiceConnectionTrackingPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceConnectionTrackingPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendServiceConnectionTrackingPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy} BackendServiceConnectionTrackingPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceConnectionTrackingPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 152439033: {
                                        message.connectionPersistenceOnUnhealthyBackends = reader.string();
                                        break;
                                    }
                                case 24539924: {
                                        message.enableStrongAffinity = reader.bool();
                                        break;
                                    }
                                case 24977544: {
                                        message.idleTimeoutSec = reader.int32();
                                        break;
                                    }
                                case 127757867: {
                                        message.trackingMode = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendServiceConnectionTrackingPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy} BackendServiceConnectionTrackingPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceConnectionTrackingPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendServiceConnectionTrackingPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendServiceConnectionTrackingPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.connectionPersistenceOnUnhealthyBackends != null && message.hasOwnProperty("connectionPersistenceOnUnhealthyBackends")) {
                                properties._connectionPersistenceOnUnhealthyBackends = 1;
                                if (!$util.isString(message.connectionPersistenceOnUnhealthyBackends))
                                    return "connectionPersistenceOnUnhealthyBackends: string expected";
                            }
                            if (message.enableStrongAffinity != null && message.hasOwnProperty("enableStrongAffinity")) {
                                properties._enableStrongAffinity = 1;
                                if (typeof message.enableStrongAffinity !== "boolean")
                                    return "enableStrongAffinity: boolean expected";
                            }
                            if (message.idleTimeoutSec != null && message.hasOwnProperty("idleTimeoutSec")) {
                                properties._idleTimeoutSec = 1;
                                if (!$util.isInteger(message.idleTimeoutSec))
                                    return "idleTimeoutSec: integer expected";
                            }
                            if (message.trackingMode != null && message.hasOwnProperty("trackingMode")) {
                                properties._trackingMode = 1;
                                if (!$util.isString(message.trackingMode))
                                    return "trackingMode: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendServiceConnectionTrackingPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy} BackendServiceConnectionTrackingPolicy
                         */
                        BackendServiceConnectionTrackingPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy();
                            if (object.connectionPersistenceOnUnhealthyBackends != null)
                                message.connectionPersistenceOnUnhealthyBackends = String(object.connectionPersistenceOnUnhealthyBackends);
                            if (object.enableStrongAffinity != null)
                                message.enableStrongAffinity = Boolean(object.enableStrongAffinity);
                            if (object.idleTimeoutSec != null)
                                message.idleTimeoutSec = object.idleTimeoutSec | 0;
                            if (object.trackingMode != null)
                                message.trackingMode = String(object.trackingMode);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendServiceConnectionTrackingPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy} message BackendServiceConnectionTrackingPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendServiceConnectionTrackingPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.enableStrongAffinity != null && message.hasOwnProperty("enableStrongAffinity")) {
                                object.enableStrongAffinity = message.enableStrongAffinity;
                                if (options.oneofs)
                                    object._enableStrongAffinity = "enableStrongAffinity";
                            }
                            if (message.idleTimeoutSec != null && message.hasOwnProperty("idleTimeoutSec")) {
                                object.idleTimeoutSec = message.idleTimeoutSec;
                                if (options.oneofs)
                                    object._idleTimeoutSec = "idleTimeoutSec";
                            }
                            if (message.trackingMode != null && message.hasOwnProperty("trackingMode")) {
                                object.trackingMode = message.trackingMode;
                                if (options.oneofs)
                                    object._trackingMode = "trackingMode";
                            }
                            if (message.connectionPersistenceOnUnhealthyBackends != null && message.hasOwnProperty("connectionPersistenceOnUnhealthyBackends")) {
                                object.connectionPersistenceOnUnhealthyBackends = message.connectionPersistenceOnUnhealthyBackends;
                                if (options.oneofs)
                                    object._connectionPersistenceOnUnhealthyBackends = "connectionPersistenceOnUnhealthyBackends";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendServiceConnectionTrackingPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendServiceConnectionTrackingPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendServiceConnectionTrackingPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendServiceConnectionTrackingPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy";
                        };
    
                        /**
                         * ConnectionPersistenceOnUnhealthyBackends enum.
                         * @name google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy.ConnectionPersistenceOnUnhealthyBackends
                         * @enum {number}
                         * @property {number} UNDEFINED_CONNECTION_PERSISTENCE_ON_UNHEALTHY_BACKENDS=0 UNDEFINED_CONNECTION_PERSISTENCE_ON_UNHEALTHY_BACKENDS value
                         * @property {number} ALWAYS_PERSIST=38400900 ALWAYS_PERSIST value
                         * @property {number} DEFAULT_FOR_PROTOCOL=145265356 DEFAULT_FOR_PROTOCOL value
                         * @property {number} NEVER_PERSIST=138646241 NEVER_PERSIST value
                         */
                        BackendServiceConnectionTrackingPolicy.ConnectionPersistenceOnUnhealthyBackends = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_CONNECTION_PERSISTENCE_ON_UNHEALTHY_BACKENDS"] = 0;
                            values[valuesById[38400900] = "ALWAYS_PERSIST"] = 38400900;
                            values[valuesById[145265356] = "DEFAULT_FOR_PROTOCOL"] = 145265356;
                            values[valuesById[138646241] = "NEVER_PERSIST"] = 138646241;
                            return values;
                        })();
    
                        /**
                         * TrackingMode enum.
                         * @name google.cloud.compute.v1.BackendServiceConnectionTrackingPolicy.TrackingMode
                         * @enum {number}
                         * @property {number} UNDEFINED_TRACKING_MODE=0 UNDEFINED_TRACKING_MODE value
                         * @property {number} INVALID_TRACKING_MODE=49234371 INVALID_TRACKING_MODE value
                         * @property {number} PER_CONNECTION=85162848 PER_CONNECTION value
                         * @property {number} PER_SESSION=182099252 PER_SESSION value
                         */
                        BackendServiceConnectionTrackingPolicy.TrackingMode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TRACKING_MODE"] = 0;
                            values[valuesById[49234371] = "INVALID_TRACKING_MODE"] = 49234371;
                            values[valuesById[85162848] = "PER_CONNECTION"] = 85162848;
                            values[valuesById[182099252] = "PER_SESSION"] = 182099252;
                            return values;
                        })();
    
                        return BackendServiceConnectionTrackingPolicy;
                    })();
    
                    v1.BackendServiceFailoverPolicy = (function() {
    
                        /**
                         * Properties of a BackendServiceFailoverPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendServiceFailoverPolicy
                         * @property {boolean|null} [disableConnectionDrainOnFailover] BackendServiceFailoverPolicy disableConnectionDrainOnFailover
                         * @property {boolean|null} [dropTrafficIfUnhealthy] BackendServiceFailoverPolicy dropTrafficIfUnhealthy
                         * @property {number|null} [failoverRatio] BackendServiceFailoverPolicy failoverRatio
                         */
    
                        /**
                         * Constructs a new BackendServiceFailoverPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendServiceFailoverPolicy.
                         * @implements IBackendServiceFailoverPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendServiceFailoverPolicy=} [properties] Properties to set
                         */
                        function BackendServiceFailoverPolicy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendServiceFailoverPolicy disableConnectionDrainOnFailover.
                         * @member {boolean|null|undefined} disableConnectionDrainOnFailover
                         * @memberof google.cloud.compute.v1.BackendServiceFailoverPolicy
                         * @instance
                         */
                        BackendServiceFailoverPolicy.prototype.disableConnectionDrainOnFailover = null;
    
                        /**
                         * BackendServiceFailoverPolicy dropTrafficIfUnhealthy.
                         * @member {boolean|null|undefined} dropTrafficIfUnhealthy
                         * @memberof google.cloud.compute.v1.BackendServiceFailoverPolicy
                         * @instance
                         */
                        BackendServiceFailoverPolicy.prototype.dropTrafficIfUnhealthy = null;
    
                        /**
                         * BackendServiceFailoverPolicy failoverRatio.
                         * @member {number|null|undefined} failoverRatio
                         * @memberof google.cloud.compute.v1.BackendServiceFailoverPolicy
                         * @instance
                         */
                        BackendServiceFailoverPolicy.prototype.failoverRatio = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendServiceFailoverPolicy _disableConnectionDrainOnFailover.
                         * @member {"disableConnectionDrainOnFailover"|undefined} _disableConnectionDrainOnFailover
                         * @memberof google.cloud.compute.v1.BackendServiceFailoverPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceFailoverPolicy.prototype, "_disableConnectionDrainOnFailover", {
                            get: $util.oneOfGetter($oneOfFields = ["disableConnectionDrainOnFailover"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceFailoverPolicy _dropTrafficIfUnhealthy.
                         * @member {"dropTrafficIfUnhealthy"|undefined} _dropTrafficIfUnhealthy
                         * @memberof google.cloud.compute.v1.BackendServiceFailoverPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceFailoverPolicy.prototype, "_dropTrafficIfUnhealthy", {
                            get: $util.oneOfGetter($oneOfFields = ["dropTrafficIfUnhealthy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceFailoverPolicy _failoverRatio.
                         * @member {"failoverRatio"|undefined} _failoverRatio
                         * @memberof google.cloud.compute.v1.BackendServiceFailoverPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceFailoverPolicy.prototype, "_failoverRatio", {
                            get: $util.oneOfGetter($oneOfFields = ["failoverRatio"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendServiceFailoverPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendServiceFailoverPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceFailoverPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendServiceFailoverPolicy} BackendServiceFailoverPolicy instance
                         */
                        BackendServiceFailoverPolicy.create = function create(properties) {
                            return new BackendServiceFailoverPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified BackendServiceFailoverPolicy message. Does not implicitly {@link google.cloud.compute.v1.BackendServiceFailoverPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendServiceFailoverPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceFailoverPolicy} message BackendServiceFailoverPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceFailoverPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.dropTrafficIfUnhealthy != null && Object.hasOwnProperty.call(message, "dropTrafficIfUnhealthy"))
                                writer.uint32(/* id 112289428, wireType 0 =*/898315424).bool(message.dropTrafficIfUnhealthy);
                            if (message.disableConnectionDrainOnFailover != null && Object.hasOwnProperty.call(message, "disableConnectionDrainOnFailover"))
                                writer.uint32(/* id 182150753, wireType 0 =*/1457206024).bool(message.disableConnectionDrainOnFailover);
                            if (message.failoverRatio != null && Object.hasOwnProperty.call(message, "failoverRatio"))
                                writer.uint32(/* id 212667006, wireType 5 =*/1701336053).float(message.failoverRatio);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendServiceFailoverPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendServiceFailoverPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceFailoverPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceFailoverPolicy} message BackendServiceFailoverPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceFailoverPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendServiceFailoverPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendServiceFailoverPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendServiceFailoverPolicy} BackendServiceFailoverPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceFailoverPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendServiceFailoverPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 182150753: {
                                        message.disableConnectionDrainOnFailover = reader.bool();
                                        break;
                                    }
                                case 112289428: {
                                        message.dropTrafficIfUnhealthy = reader.bool();
                                        break;
                                    }
                                case 212667006: {
                                        message.failoverRatio = reader.float();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendServiceFailoverPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceFailoverPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendServiceFailoverPolicy} BackendServiceFailoverPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceFailoverPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendServiceFailoverPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendServiceFailoverPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendServiceFailoverPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.disableConnectionDrainOnFailover != null && message.hasOwnProperty("disableConnectionDrainOnFailover")) {
                                properties._disableConnectionDrainOnFailover = 1;
                                if (typeof message.disableConnectionDrainOnFailover !== "boolean")
                                    return "disableConnectionDrainOnFailover: boolean expected";
                            }
                            if (message.dropTrafficIfUnhealthy != null && message.hasOwnProperty("dropTrafficIfUnhealthy")) {
                                properties._dropTrafficIfUnhealthy = 1;
                                if (typeof message.dropTrafficIfUnhealthy !== "boolean")
                                    return "dropTrafficIfUnhealthy: boolean expected";
                            }
                            if (message.failoverRatio != null && message.hasOwnProperty("failoverRatio")) {
                                properties._failoverRatio = 1;
                                if (typeof message.failoverRatio !== "number")
                                    return "failoverRatio: number expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendServiceFailoverPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendServiceFailoverPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendServiceFailoverPolicy} BackendServiceFailoverPolicy
                         */
                        BackendServiceFailoverPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendServiceFailoverPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendServiceFailoverPolicy();
                            if (object.disableConnectionDrainOnFailover != null)
                                message.disableConnectionDrainOnFailover = Boolean(object.disableConnectionDrainOnFailover);
                            if (object.dropTrafficIfUnhealthy != null)
                                message.dropTrafficIfUnhealthy = Boolean(object.dropTrafficIfUnhealthy);
                            if (object.failoverRatio != null)
                                message.failoverRatio = Number(object.failoverRatio);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendServiceFailoverPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendServiceFailoverPolicy
                         * @static
                         * @param {google.cloud.compute.v1.BackendServiceFailoverPolicy} message BackendServiceFailoverPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendServiceFailoverPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.dropTrafficIfUnhealthy != null && message.hasOwnProperty("dropTrafficIfUnhealthy")) {
                                object.dropTrafficIfUnhealthy = message.dropTrafficIfUnhealthy;
                                if (options.oneofs)
                                    object._dropTrafficIfUnhealthy = "dropTrafficIfUnhealthy";
                            }
                            if (message.disableConnectionDrainOnFailover != null && message.hasOwnProperty("disableConnectionDrainOnFailover")) {
                                object.disableConnectionDrainOnFailover = message.disableConnectionDrainOnFailover;
                                if (options.oneofs)
                                    object._disableConnectionDrainOnFailover = "disableConnectionDrainOnFailover";
                            }
                            if (message.failoverRatio != null && message.hasOwnProperty("failoverRatio")) {
                                object.failoverRatio = options.json && !isFinite(message.failoverRatio) ? String(message.failoverRatio) : message.failoverRatio;
                                if (options.oneofs)
                                    object._failoverRatio = "failoverRatio";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendServiceFailoverPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendServiceFailoverPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendServiceFailoverPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendServiceFailoverPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendServiceFailoverPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendServiceFailoverPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendServiceFailoverPolicy";
                        };
    
                        return BackendServiceFailoverPolicy;
                    })();
    
                    v1.BackendServiceGroupHealth = (function() {
    
                        /**
                         * Properties of a BackendServiceGroupHealth.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendServiceGroupHealth
                         * @property {Object.<string,string>|null} [annotations] BackendServiceGroupHealth annotations
                         * @property {Array.<google.cloud.compute.v1.IHealthStatus>|null} [healthStatus] BackendServiceGroupHealth healthStatus
                         * @property {string|null} [kind] BackendServiceGroupHealth kind
                         */
    
                        /**
                         * Constructs a new BackendServiceGroupHealth.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendServiceGroupHealth.
                         * @implements IBackendServiceGroupHealth
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendServiceGroupHealth=} [properties] Properties to set
                         */
                        function BackendServiceGroupHealth(properties) {
                            this.annotations = {};
                            this.healthStatus = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendServiceGroupHealth annotations.
                         * @member {Object.<string,string>} annotations
                         * @memberof google.cloud.compute.v1.BackendServiceGroupHealth
                         * @instance
                         */
                        BackendServiceGroupHealth.prototype.annotations = $util.emptyObject;
    
                        /**
                         * BackendServiceGroupHealth healthStatus.
                         * @member {Array.<google.cloud.compute.v1.IHealthStatus>} healthStatus
                         * @memberof google.cloud.compute.v1.BackendServiceGroupHealth
                         * @instance
                         */
                        BackendServiceGroupHealth.prototype.healthStatus = $util.emptyArray;
    
                        /**
                         * BackendServiceGroupHealth kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.BackendServiceGroupHealth
                         * @instance
                         */
                        BackendServiceGroupHealth.prototype.kind = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendServiceGroupHealth _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.BackendServiceGroupHealth
                         * @instance
                         */
                        Object.defineProperty(BackendServiceGroupHealth.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendServiceGroupHealth instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendServiceGroupHealth
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceGroupHealth=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendServiceGroupHealth} BackendServiceGroupHealth instance
                         */
                        BackendServiceGroupHealth.create = function create(properties) {
                            return new BackendServiceGroupHealth(properties);
                        };
    
                        /**
                         * Encodes the specified BackendServiceGroupHealth message. Does not implicitly {@link google.cloud.compute.v1.BackendServiceGroupHealth.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendServiceGroupHealth
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceGroupHealth} message BackendServiceGroupHealth message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceGroupHealth.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.annotations != null && Object.hasOwnProperty.call(message, "annotations"))
                                for (var keys = Object.keys(message.annotations), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 112032548, wireType 2 =*/896260386).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.annotations[keys[i]]).ldelim();
                            if (message.healthStatus != null && message.healthStatus.length)
                                for (var i = 0; i < message.healthStatus.length; ++i)
                                    $root.google.cloud.compute.v1.HealthStatus.encode(message.healthStatus[i], writer.uint32(/* id 380545845, wireType 2 =*/3044366762).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendServiceGroupHealth message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendServiceGroupHealth.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceGroupHealth
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceGroupHealth} message BackendServiceGroupHealth message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceGroupHealth.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendServiceGroupHealth message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendServiceGroupHealth
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendServiceGroupHealth} BackendServiceGroupHealth
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceGroupHealth.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendServiceGroupHealth(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 112032548: {
                                        if (message.annotations === $util.emptyObject)
                                            message.annotations = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.annotations[key] = value;
                                        break;
                                    }
                                case 380545845: {
                                        if (!(message.healthStatus && message.healthStatus.length))
                                            message.healthStatus = [];
                                        message.healthStatus.push($root.google.cloud.compute.v1.HealthStatus.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendServiceGroupHealth message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceGroupHealth
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendServiceGroupHealth} BackendServiceGroupHealth
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceGroupHealth.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendServiceGroupHealth message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendServiceGroupHealth
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendServiceGroupHealth.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.annotations != null && message.hasOwnProperty("annotations")) {
                                if (!$util.isObject(message.annotations))
                                    return "annotations: object expected";
                                var key = Object.keys(message.annotations);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.annotations[key[i]]))
                                        return "annotations: string{k:string} expected";
                            }
                            if (message.healthStatus != null && message.hasOwnProperty("healthStatus")) {
                                if (!Array.isArray(message.healthStatus))
                                    return "healthStatus: array expected";
                                for (var i = 0; i < message.healthStatus.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.HealthStatus.verify(message.healthStatus[i]);
                                    if (error)
                                        return "healthStatus." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendServiceGroupHealth message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendServiceGroupHealth
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendServiceGroupHealth} BackendServiceGroupHealth
                         */
                        BackendServiceGroupHealth.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendServiceGroupHealth)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendServiceGroupHealth();
                            if (object.annotations) {
                                if (typeof object.annotations !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendServiceGroupHealth.annotations: object expected");
                                message.annotations = {};
                                for (var keys = Object.keys(object.annotations), i = 0; i < keys.length; ++i)
                                    message.annotations[keys[i]] = String(object.annotations[keys[i]]);
                            }
                            if (object.healthStatus) {
                                if (!Array.isArray(object.healthStatus))
                                    throw TypeError(".google.cloud.compute.v1.BackendServiceGroupHealth.healthStatus: array expected");
                                message.healthStatus = [];
                                for (var i = 0; i < object.healthStatus.length; ++i) {
                                    if (typeof object.healthStatus[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.BackendServiceGroupHealth.healthStatus: object expected");
                                    message.healthStatus[i] = $root.google.cloud.compute.v1.HealthStatus.fromObject(object.healthStatus[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendServiceGroupHealth message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendServiceGroupHealth
                         * @static
                         * @param {google.cloud.compute.v1.BackendServiceGroupHealth} message BackendServiceGroupHealth
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendServiceGroupHealth.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.healthStatus = [];
                            if (options.objects || options.defaults)
                                object.annotations = {};
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            var keys2;
                            if (message.annotations && (keys2 = Object.keys(message.annotations)).length) {
                                object.annotations = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.annotations[keys2[j]] = message.annotations[keys2[j]];
                            }
                            if (message.healthStatus && message.healthStatus.length) {
                                object.healthStatus = [];
                                for (var j = 0; j < message.healthStatus.length; ++j)
                                    object.healthStatus[j] = $root.google.cloud.compute.v1.HealthStatus.toObject(message.healthStatus[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendServiceGroupHealth to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendServiceGroupHealth
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendServiceGroupHealth.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendServiceGroupHealth
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendServiceGroupHealth
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendServiceGroupHealth.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendServiceGroupHealth";
                        };
    
                        return BackendServiceGroupHealth;
                    })();
    
                    v1.BackendServiceIAP = (function() {
    
                        /**
                         * Properties of a BackendServiceIAP.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendServiceIAP
                         * @property {boolean|null} [enabled] BackendServiceIAP enabled
                         * @property {string|null} [oauth2ClientId] BackendServiceIAP oauth2ClientId
                         * @property {string|null} [oauth2ClientSecret] BackendServiceIAP oauth2ClientSecret
                         * @property {string|null} [oauth2ClientSecretSha256] BackendServiceIAP oauth2ClientSecretSha256
                         */
    
                        /**
                         * Constructs a new BackendServiceIAP.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendServiceIAP.
                         * @implements IBackendServiceIAP
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendServiceIAP=} [properties] Properties to set
                         */
                        function BackendServiceIAP(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendServiceIAP enabled.
                         * @member {boolean|null|undefined} enabled
                         * @memberof google.cloud.compute.v1.BackendServiceIAP
                         * @instance
                         */
                        BackendServiceIAP.prototype.enabled = null;
    
                        /**
                         * BackendServiceIAP oauth2ClientId.
                         * @member {string|null|undefined} oauth2ClientId
                         * @memberof google.cloud.compute.v1.BackendServiceIAP
                         * @instance
                         */
                        BackendServiceIAP.prototype.oauth2ClientId = null;
    
                        /**
                         * BackendServiceIAP oauth2ClientSecret.
                         * @member {string|null|undefined} oauth2ClientSecret
                         * @memberof google.cloud.compute.v1.BackendServiceIAP
                         * @instance
                         */
                        BackendServiceIAP.prototype.oauth2ClientSecret = null;
    
                        /**
                         * BackendServiceIAP oauth2ClientSecretSha256.
                         * @member {string|null|undefined} oauth2ClientSecretSha256
                         * @memberof google.cloud.compute.v1.BackendServiceIAP
                         * @instance
                         */
                        BackendServiceIAP.prototype.oauth2ClientSecretSha256 = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendServiceIAP _enabled.
                         * @member {"enabled"|undefined} _enabled
                         * @memberof google.cloud.compute.v1.BackendServiceIAP
                         * @instance
                         */
                        Object.defineProperty(BackendServiceIAP.prototype, "_enabled", {
                            get: $util.oneOfGetter($oneOfFields = ["enabled"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceIAP _oauth2ClientId.
                         * @member {"oauth2ClientId"|undefined} _oauth2ClientId
                         * @memberof google.cloud.compute.v1.BackendServiceIAP
                         * @instance
                         */
                        Object.defineProperty(BackendServiceIAP.prototype, "_oauth2ClientId", {
                            get: $util.oneOfGetter($oneOfFields = ["oauth2ClientId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceIAP _oauth2ClientSecret.
                         * @member {"oauth2ClientSecret"|undefined} _oauth2ClientSecret
                         * @memberof google.cloud.compute.v1.BackendServiceIAP
                         * @instance
                         */
                        Object.defineProperty(BackendServiceIAP.prototype, "_oauth2ClientSecret", {
                            get: $util.oneOfGetter($oneOfFields = ["oauth2ClientSecret"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceIAP _oauth2ClientSecretSha256.
                         * @member {"oauth2ClientSecretSha256"|undefined} _oauth2ClientSecretSha256
                         * @memberof google.cloud.compute.v1.BackendServiceIAP
                         * @instance
                         */
                        Object.defineProperty(BackendServiceIAP.prototype, "_oauth2ClientSecretSha256", {
                            get: $util.oneOfGetter($oneOfFields = ["oauth2ClientSecretSha256"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendServiceIAP instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendServiceIAP
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceIAP=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendServiceIAP} BackendServiceIAP instance
                         */
                        BackendServiceIAP.create = function create(properties) {
                            return new BackendServiceIAP(properties);
                        };
    
                        /**
                         * Encodes the specified BackendServiceIAP message. Does not implicitly {@link google.cloud.compute.v1.BackendServiceIAP.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendServiceIAP
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceIAP} message BackendServiceIAP message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceIAP.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.enabled != null && Object.hasOwnProperty.call(message, "enabled"))
                                writer.uint32(/* id 1018689, wireType 0 =*/8149512).bool(message.enabled);
                            if (message.oauth2ClientSecret != null && Object.hasOwnProperty.call(message, "oauth2ClientSecret"))
                                writer.uint32(/* id 50999520, wireType 2 =*/407996162).string(message.oauth2ClientSecret);
                            if (message.oauth2ClientSecretSha256 != null && Object.hasOwnProperty.call(message, "oauth2ClientSecretSha256"))
                                writer.uint32(/* id 112903782, wireType 2 =*/903230258).string(message.oauth2ClientSecretSha256);
                            if (message.oauth2ClientId != null && Object.hasOwnProperty.call(message, "oauth2ClientId"))
                                writer.uint32(/* id 314017611, wireType 2 =*/2512140890).string(message.oauth2ClientId);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendServiceIAP message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendServiceIAP.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceIAP
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceIAP} message BackendServiceIAP message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceIAP.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendServiceIAP message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendServiceIAP
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendServiceIAP} BackendServiceIAP
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceIAP.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendServiceIAP();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1018689: {
                                        message.enabled = reader.bool();
                                        break;
                                    }
                                case 314017611: {
                                        message.oauth2ClientId = reader.string();
                                        break;
                                    }
                                case 50999520: {
                                        message.oauth2ClientSecret = reader.string();
                                        break;
                                    }
                                case 112903782: {
                                        message.oauth2ClientSecretSha256 = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendServiceIAP message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceIAP
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendServiceIAP} BackendServiceIAP
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceIAP.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendServiceIAP message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendServiceIAP
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendServiceIAP.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.enabled != null && message.hasOwnProperty("enabled")) {
                                properties._enabled = 1;
                                if (typeof message.enabled !== "boolean")
                                    return "enabled: boolean expected";
                            }
                            if (message.oauth2ClientId != null && message.hasOwnProperty("oauth2ClientId")) {
                                properties._oauth2ClientId = 1;
                                if (!$util.isString(message.oauth2ClientId))
                                    return "oauth2ClientId: string expected";
                            }
                            if (message.oauth2ClientSecret != null && message.hasOwnProperty("oauth2ClientSecret")) {
                                properties._oauth2ClientSecret = 1;
                                if (!$util.isString(message.oauth2ClientSecret))
                                    return "oauth2ClientSecret: string expected";
                            }
                            if (message.oauth2ClientSecretSha256 != null && message.hasOwnProperty("oauth2ClientSecretSha256")) {
                                properties._oauth2ClientSecretSha256 = 1;
                                if (!$util.isString(message.oauth2ClientSecretSha256))
                                    return "oauth2ClientSecretSha256: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendServiceIAP message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendServiceIAP
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendServiceIAP} BackendServiceIAP
                         */
                        BackendServiceIAP.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendServiceIAP)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendServiceIAP();
                            if (object.enabled != null)
                                message.enabled = Boolean(object.enabled);
                            if (object.oauth2ClientId != null)
                                message.oauth2ClientId = String(object.oauth2ClientId);
                            if (object.oauth2ClientSecret != null)
                                message.oauth2ClientSecret = String(object.oauth2ClientSecret);
                            if (object.oauth2ClientSecretSha256 != null)
                                message.oauth2ClientSecretSha256 = String(object.oauth2ClientSecretSha256);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendServiceIAP message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendServiceIAP
                         * @static
                         * @param {google.cloud.compute.v1.BackendServiceIAP} message BackendServiceIAP
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendServiceIAP.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.enabled != null && message.hasOwnProperty("enabled")) {
                                object.enabled = message.enabled;
                                if (options.oneofs)
                                    object._enabled = "enabled";
                            }
                            if (message.oauth2ClientSecret != null && message.hasOwnProperty("oauth2ClientSecret")) {
                                object.oauth2ClientSecret = message.oauth2ClientSecret;
                                if (options.oneofs)
                                    object._oauth2ClientSecret = "oauth2ClientSecret";
                            }
                            if (message.oauth2ClientSecretSha256 != null && message.hasOwnProperty("oauth2ClientSecretSha256")) {
                                object.oauth2ClientSecretSha256 = message.oauth2ClientSecretSha256;
                                if (options.oneofs)
                                    object._oauth2ClientSecretSha256 = "oauth2ClientSecretSha256";
                            }
                            if (message.oauth2ClientId != null && message.hasOwnProperty("oauth2ClientId")) {
                                object.oauth2ClientId = message.oauth2ClientId;
                                if (options.oneofs)
                                    object._oauth2ClientId = "oauth2ClientId";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendServiceIAP to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendServiceIAP
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendServiceIAP.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendServiceIAP
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendServiceIAP
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendServiceIAP.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendServiceIAP";
                        };
    
                        return BackendServiceIAP;
                    })();
    
                    v1.BackendServiceList = (function() {
    
                        /**
                         * Properties of a BackendServiceList.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendServiceList
                         * @property {string|null} [id] BackendServiceList id
                         * @property {Array.<google.cloud.compute.v1.IBackendService>|null} [items] BackendServiceList items
                         * @property {string|null} [kind] BackendServiceList kind
                         * @property {string|null} [nextPageToken] BackendServiceList nextPageToken
                         * @property {string|null} [selfLink] BackendServiceList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] BackendServiceList warning
                         */
    
                        /**
                         * Constructs a new BackendServiceList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendServiceList.
                         * @implements IBackendServiceList
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendServiceList=} [properties] Properties to set
                         */
                        function BackendServiceList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendServiceList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @instance
                         */
                        BackendServiceList.prototype.id = null;
    
                        /**
                         * BackendServiceList items.
                         * @member {Array.<google.cloud.compute.v1.IBackendService>} items
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @instance
                         */
                        BackendServiceList.prototype.items = $util.emptyArray;
    
                        /**
                         * BackendServiceList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @instance
                         */
                        BackendServiceList.prototype.kind = null;
    
                        /**
                         * BackendServiceList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @instance
                         */
                        BackendServiceList.prototype.nextPageToken = null;
    
                        /**
                         * BackendServiceList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @instance
                         */
                        BackendServiceList.prototype.selfLink = null;
    
                        /**
                         * BackendServiceList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @instance
                         */
                        BackendServiceList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendServiceList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @instance
                         */
                        Object.defineProperty(BackendServiceList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @instance
                         */
                        Object.defineProperty(BackendServiceList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @instance
                         */
                        Object.defineProperty(BackendServiceList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @instance
                         */
                        Object.defineProperty(BackendServiceList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @instance
                         */
                        Object.defineProperty(BackendServiceList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendServiceList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendServiceList} BackendServiceList instance
                         */
                        BackendServiceList.create = function create(properties) {
                            return new BackendServiceList(properties);
                        };
    
                        /**
                         * Encodes the specified BackendServiceList message. Does not implicitly {@link google.cloud.compute.v1.BackendServiceList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceList} message BackendServiceList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.BackendService.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendServiceList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendServiceList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceList} message BackendServiceList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendServiceList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendServiceList} BackendServiceList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendServiceList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.BackendService.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendServiceList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendServiceList} BackendServiceList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendServiceList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendServiceList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.BackendService.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendServiceList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendServiceList} BackendServiceList
                         */
                        BackendServiceList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendServiceList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendServiceList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.BackendServiceList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.BackendServiceList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.BackendService.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendServiceList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendServiceList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @static
                         * @param {google.cloud.compute.v1.BackendServiceList} message BackendServiceList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendServiceList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.BackendService.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendServiceList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendServiceList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendServiceList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendServiceList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendServiceList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendServiceList";
                        };
    
                        return BackendServiceList;
                    })();
    
                    v1.BackendServiceLocalityLoadBalancingPolicyConfig = (function() {
    
                        /**
                         * Properties of a BackendServiceLocalityLoadBalancingPolicyConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendServiceLocalityLoadBalancingPolicyConfig
                         * @property {google.cloud.compute.v1.IBackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy|null} [customPolicy] BackendServiceLocalityLoadBalancingPolicyConfig customPolicy
                         * @property {google.cloud.compute.v1.IBackendServiceLocalityLoadBalancingPolicyConfigPolicy|null} [policy] BackendServiceLocalityLoadBalancingPolicyConfig policy
                         */
    
                        /**
                         * Constructs a new BackendServiceLocalityLoadBalancingPolicyConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendServiceLocalityLoadBalancingPolicyConfig.
                         * @implements IBackendServiceLocalityLoadBalancingPolicyConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendServiceLocalityLoadBalancingPolicyConfig=} [properties] Properties to set
                         */
                        function BackendServiceLocalityLoadBalancingPolicyConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendServiceLocalityLoadBalancingPolicyConfig customPolicy.
                         * @member {google.cloud.compute.v1.IBackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy|null|undefined} customPolicy
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig
                         * @instance
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfig.prototype.customPolicy = null;
    
                        /**
                         * BackendServiceLocalityLoadBalancingPolicyConfig policy.
                         * @member {google.cloud.compute.v1.IBackendServiceLocalityLoadBalancingPolicyConfigPolicy|null|undefined} policy
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig
                         * @instance
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfig.prototype.policy = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendServiceLocalityLoadBalancingPolicyConfig _customPolicy.
                         * @member {"customPolicy"|undefined} _customPolicy
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig
                         * @instance
                         */
                        Object.defineProperty(BackendServiceLocalityLoadBalancingPolicyConfig.prototype, "_customPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["customPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceLocalityLoadBalancingPolicyConfig _policy.
                         * @member {"policy"|undefined} _policy
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig
                         * @instance
                         */
                        Object.defineProperty(BackendServiceLocalityLoadBalancingPolicyConfig.prototype, "_policy", {
                            get: $util.oneOfGetter($oneOfFields = ["policy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendServiceLocalityLoadBalancingPolicyConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceLocalityLoadBalancingPolicyConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig} BackendServiceLocalityLoadBalancingPolicyConfig instance
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfig.create = function create(properties) {
                            return new BackendServiceLocalityLoadBalancingPolicyConfig(properties);
                        };
    
                        /**
                         * Encodes the specified BackendServiceLocalityLoadBalancingPolicyConfig message. Does not implicitly {@link google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceLocalityLoadBalancingPolicyConfig} message BackendServiceLocalityLoadBalancingPolicyConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customPolicy != null && Object.hasOwnProperty.call(message, "customPolicy"))
                                $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.encode(message.customPolicy, writer.uint32(/* id 4818368, wireType 2 =*/38546946).fork()).ldelim();
                            if (message.policy != null && Object.hasOwnProperty.call(message, "policy"))
                                $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy.encode(message.policy, writer.uint32(/* id 91071794, wireType 2 =*/728574354).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendServiceLocalityLoadBalancingPolicyConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceLocalityLoadBalancingPolicyConfig} message BackendServiceLocalityLoadBalancingPolicyConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendServiceLocalityLoadBalancingPolicyConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig} BackendServiceLocalityLoadBalancingPolicyConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4818368: {
                                        message.customPolicy = $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 91071794: {
                                        message.policy = $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendServiceLocalityLoadBalancingPolicyConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig} BackendServiceLocalityLoadBalancingPolicyConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendServiceLocalityLoadBalancingPolicyConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.customPolicy != null && message.hasOwnProperty("customPolicy")) {
                                properties._customPolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.verify(message.customPolicy);
                                    if (error)
                                        return "customPolicy." + error;
                                }
                            }
                            if (message.policy != null && message.hasOwnProperty("policy")) {
                                properties._policy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy.verify(message.policy);
                                    if (error)
                                        return "policy." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendServiceLocalityLoadBalancingPolicyConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig} BackendServiceLocalityLoadBalancingPolicyConfig
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig();
                            if (object.customPolicy != null) {
                                if (typeof object.customPolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig.customPolicy: object expected");
                                message.customPolicy = $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.fromObject(object.customPolicy);
                            }
                            if (object.policy != null) {
                                if (typeof object.policy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig.policy: object expected");
                                message.policy = $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy.fromObject(object.policy);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendServiceLocalityLoadBalancingPolicyConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig
                         * @static
                         * @param {google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig} message BackendServiceLocalityLoadBalancingPolicyConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.customPolicy != null && message.hasOwnProperty("customPolicy")) {
                                object.customPolicy = $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.toObject(message.customPolicy, options);
                                if (options.oneofs)
                                    object._customPolicy = "customPolicy";
                            }
                            if (message.policy != null && message.hasOwnProperty("policy")) {
                                object.policy = $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy.toObject(message.policy, options);
                                if (options.oneofs)
                                    object._policy = "policy";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendServiceLocalityLoadBalancingPolicyConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendServiceLocalityLoadBalancingPolicyConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfig";
                        };
    
                        return BackendServiceLocalityLoadBalancingPolicyConfig;
                    })();
    
                    v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy = (function() {
    
                        /**
                         * Properties of a BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         * @property {string|null} [data] BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy data
                         * @property {string|null} [name] BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy name
                         */
    
                        /**
                         * Constructs a new BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.
                         * @implements IBackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy=} [properties] Properties to set
                         */
                        function BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy data.
                         * @member {string|null|undefined} data
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         * @instance
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.prototype.data = null;
    
                        /**
                         * BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         * @instance
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.prototype.name = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy _data.
                         * @member {"data"|undefined} _data
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.prototype, "_data", {
                            get: $util.oneOfGetter($oneOfFields = ["data"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy} BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy instance
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.create = function create(properties) {
                            return new BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy message. Does not implicitly {@link google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy} message BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.data != null && Object.hasOwnProperty.call(message, "data"))
                                writer.uint32(/* id 3076010, wireType 2 =*/24608082).string(message.data);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy} message BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy} BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3076010: {
                                        message.data = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy} BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.data != null && message.hasOwnProperty("data")) {
                                properties._data = 1;
                                if (!$util.isString(message.data))
                                    return "data: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy} BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy();
                            if (object.data != null)
                                message.data = String(object.data);
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         * @static
                         * @param {google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy} message BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.data != null && message.hasOwnProperty("data")) {
                                object.data = message.data;
                                if (options.oneofs)
                                    object._data = "data";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy";
                        };
    
                        return BackendServiceLocalityLoadBalancingPolicyConfigCustomPolicy;
                    })();
    
                    v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy = (function() {
    
                        /**
                         * Properties of a BackendServiceLocalityLoadBalancingPolicyConfigPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendServiceLocalityLoadBalancingPolicyConfigPolicy
                         * @property {string|null} [name] BackendServiceLocalityLoadBalancingPolicyConfigPolicy name
                         */
    
                        /**
                         * Constructs a new BackendServiceLocalityLoadBalancingPolicyConfigPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendServiceLocalityLoadBalancingPolicyConfigPolicy.
                         * @implements IBackendServiceLocalityLoadBalancingPolicyConfigPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendServiceLocalityLoadBalancingPolicyConfigPolicy=} [properties] Properties to set
                         */
                        function BackendServiceLocalityLoadBalancingPolicyConfigPolicy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendServiceLocalityLoadBalancingPolicyConfigPolicy name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy
                         * @instance
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigPolicy.prototype.name = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendServiceLocalityLoadBalancingPolicyConfigPolicy _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy
                         * @instance
                         */
                        Object.defineProperty(BackendServiceLocalityLoadBalancingPolicyConfigPolicy.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendServiceLocalityLoadBalancingPolicyConfigPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceLocalityLoadBalancingPolicyConfigPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy} BackendServiceLocalityLoadBalancingPolicyConfigPolicy instance
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigPolicy.create = function create(properties) {
                            return new BackendServiceLocalityLoadBalancingPolicyConfigPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified BackendServiceLocalityLoadBalancingPolicyConfigPolicy message. Does not implicitly {@link google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceLocalityLoadBalancingPolicyConfigPolicy} message BackendServiceLocalityLoadBalancingPolicyConfigPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendServiceLocalityLoadBalancingPolicyConfigPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceLocalityLoadBalancingPolicyConfigPolicy} message BackendServiceLocalityLoadBalancingPolicyConfigPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendServiceLocalityLoadBalancingPolicyConfigPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy} BackendServiceLocalityLoadBalancingPolicyConfigPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendServiceLocalityLoadBalancingPolicyConfigPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy} BackendServiceLocalityLoadBalancingPolicyConfigPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendServiceLocalityLoadBalancingPolicyConfigPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendServiceLocalityLoadBalancingPolicyConfigPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy} BackendServiceLocalityLoadBalancingPolicyConfigPolicy
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendServiceLocalityLoadBalancingPolicyConfigPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy
                         * @static
                         * @param {google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy} message BackendServiceLocalityLoadBalancingPolicyConfigPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendServiceLocalityLoadBalancingPolicyConfigPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendServiceLocalityLoadBalancingPolicyConfigPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy";
                        };
    
                        /**
                         * Name enum.
                         * @name google.cloud.compute.v1.BackendServiceLocalityLoadBalancingPolicyConfigPolicy.Name
                         * @enum {number}
                         * @property {number} UNDEFINED_NAME=0 UNDEFINED_NAME value
                         * @property {number} INVALID_LB_POLICY=323318707 INVALID_LB_POLICY value
                         * @property {number} LEAST_REQUEST=46604921 LEAST_REQUEST value
                         * @property {number} MAGLEV=119180266 MAGLEV value
                         * @property {number} ORIGINAL_DESTINATION=166297216 ORIGINAL_DESTINATION value
                         * @property {number} RANDOM=262527171 RANDOM value
                         * @property {number} RING_HASH=432795069 RING_HASH value
                         * @property {number} ROUND_ROBIN=153895801 ROUND_ROBIN value
                         */
                        BackendServiceLocalityLoadBalancingPolicyConfigPolicy.Name = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_NAME"] = 0;
                            values[valuesById[323318707] = "INVALID_LB_POLICY"] = 323318707;
                            values[valuesById[46604921] = "LEAST_REQUEST"] = 46604921;
                            values[valuesById[119180266] = "MAGLEV"] = 119180266;
                            values[valuesById[166297216] = "ORIGINAL_DESTINATION"] = 166297216;
                            values[valuesById[262527171] = "RANDOM"] = 262527171;
                            values[valuesById[432795069] = "RING_HASH"] = 432795069;
                            values[valuesById[153895801] = "ROUND_ROBIN"] = 153895801;
                            return values;
                        })();
    
                        return BackendServiceLocalityLoadBalancingPolicyConfigPolicy;
                    })();
    
                    v1.BackendServiceLogConfig = (function() {
    
                        /**
                         * Properties of a BackendServiceLogConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendServiceLogConfig
                         * @property {boolean|null} [enable] BackendServiceLogConfig enable
                         * @property {number|null} [sampleRate] BackendServiceLogConfig sampleRate
                         */
    
                        /**
                         * Constructs a new BackendServiceLogConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendServiceLogConfig.
                         * @implements IBackendServiceLogConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendServiceLogConfig=} [properties] Properties to set
                         */
                        function BackendServiceLogConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendServiceLogConfig enable.
                         * @member {boolean|null|undefined} enable
                         * @memberof google.cloud.compute.v1.BackendServiceLogConfig
                         * @instance
                         */
                        BackendServiceLogConfig.prototype.enable = null;
    
                        /**
                         * BackendServiceLogConfig sampleRate.
                         * @member {number|null|undefined} sampleRate
                         * @memberof google.cloud.compute.v1.BackendServiceLogConfig
                         * @instance
                         */
                        BackendServiceLogConfig.prototype.sampleRate = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendServiceLogConfig _enable.
                         * @member {"enable"|undefined} _enable
                         * @memberof google.cloud.compute.v1.BackendServiceLogConfig
                         * @instance
                         */
                        Object.defineProperty(BackendServiceLogConfig.prototype, "_enable", {
                            get: $util.oneOfGetter($oneOfFields = ["enable"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BackendServiceLogConfig _sampleRate.
                         * @member {"sampleRate"|undefined} _sampleRate
                         * @memberof google.cloud.compute.v1.BackendServiceLogConfig
                         * @instance
                         */
                        Object.defineProperty(BackendServiceLogConfig.prototype, "_sampleRate", {
                            get: $util.oneOfGetter($oneOfFields = ["sampleRate"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendServiceLogConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendServiceLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceLogConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendServiceLogConfig} BackendServiceLogConfig instance
                         */
                        BackendServiceLogConfig.create = function create(properties) {
                            return new BackendServiceLogConfig(properties);
                        };
    
                        /**
                         * Encodes the specified BackendServiceLogConfig message. Does not implicitly {@link google.cloud.compute.v1.BackendServiceLogConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendServiceLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceLogConfig} message BackendServiceLogConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceLogConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.sampleRate != null && Object.hasOwnProperty.call(message, "sampleRate"))
                                writer.uint32(/* id 153193045, wireType 5 =*/1225544365).float(message.sampleRate);
                            if (message.enable != null && Object.hasOwnProperty.call(message, "enable"))
                                writer.uint32(/* id 311764355, wireType 0 =*/2494114840).bool(message.enable);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendServiceLogConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendServiceLogConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceLogConfig} message BackendServiceLogConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceLogConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendServiceLogConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendServiceLogConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendServiceLogConfig} BackendServiceLogConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceLogConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendServiceLogConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 311764355: {
                                        message.enable = reader.bool();
                                        break;
                                    }
                                case 153193045: {
                                        message.sampleRate = reader.float();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendServiceLogConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceLogConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendServiceLogConfig} BackendServiceLogConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceLogConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendServiceLogConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendServiceLogConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendServiceLogConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.enable != null && message.hasOwnProperty("enable")) {
                                properties._enable = 1;
                                if (typeof message.enable !== "boolean")
                                    return "enable: boolean expected";
                            }
                            if (message.sampleRate != null && message.hasOwnProperty("sampleRate")) {
                                properties._sampleRate = 1;
                                if (typeof message.sampleRate !== "number")
                                    return "sampleRate: number expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendServiceLogConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendServiceLogConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendServiceLogConfig} BackendServiceLogConfig
                         */
                        BackendServiceLogConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendServiceLogConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendServiceLogConfig();
                            if (object.enable != null)
                                message.enable = Boolean(object.enable);
                            if (object.sampleRate != null)
                                message.sampleRate = Number(object.sampleRate);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendServiceLogConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendServiceLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.BackendServiceLogConfig} message BackendServiceLogConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendServiceLogConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.sampleRate != null && message.hasOwnProperty("sampleRate")) {
                                object.sampleRate = options.json && !isFinite(message.sampleRate) ? String(message.sampleRate) : message.sampleRate;
                                if (options.oneofs)
                                    object._sampleRate = "sampleRate";
                            }
                            if (message.enable != null && message.hasOwnProperty("enable")) {
                                object.enable = message.enable;
                                if (options.oneofs)
                                    object._enable = "enable";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendServiceLogConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendServiceLogConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendServiceLogConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendServiceLogConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendServiceLogConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendServiceLogConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendServiceLogConfig";
                        };
    
                        return BackendServiceLogConfig;
                    })();
    
                    v1.BackendServiceReference = (function() {
    
                        /**
                         * Properties of a BackendServiceReference.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendServiceReference
                         * @property {string|null} [backendService] BackendServiceReference backendService
                         */
    
                        /**
                         * Constructs a new BackendServiceReference.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendServiceReference.
                         * @implements IBackendServiceReference
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendServiceReference=} [properties] Properties to set
                         */
                        function BackendServiceReference(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendServiceReference backendService.
                         * @member {string|null|undefined} backendService
                         * @memberof google.cloud.compute.v1.BackendServiceReference
                         * @instance
                         */
                        BackendServiceReference.prototype.backendService = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendServiceReference _backendService.
                         * @member {"backendService"|undefined} _backendService
                         * @memberof google.cloud.compute.v1.BackendServiceReference
                         * @instance
                         */
                        Object.defineProperty(BackendServiceReference.prototype, "_backendService", {
                            get: $util.oneOfGetter($oneOfFields = ["backendService"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendServiceReference instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendServiceReference
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceReference=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendServiceReference} BackendServiceReference instance
                         */
                        BackendServiceReference.create = function create(properties) {
                            return new BackendServiceReference(properties);
                        };
    
                        /**
                         * Encodes the specified BackendServiceReference message. Does not implicitly {@link google.cloud.compute.v1.BackendServiceReference.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendServiceReference
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceReference} message BackendServiceReference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceReference.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.backendService != null && Object.hasOwnProperty.call(message, "backendService"))
                                writer.uint32(/* id 306946058, wireType 2 =*/2455568466).string(message.backendService);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendServiceReference message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendServiceReference.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceReference
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServiceReference} message BackendServiceReference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServiceReference.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendServiceReference message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendServiceReference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendServiceReference} BackendServiceReference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceReference.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendServiceReference();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 306946058: {
                                        message.backendService = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendServiceReference message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServiceReference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendServiceReference} BackendServiceReference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServiceReference.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendServiceReference message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendServiceReference
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendServiceReference.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendService != null && message.hasOwnProperty("backendService")) {
                                properties._backendService = 1;
                                if (!$util.isString(message.backendService))
                                    return "backendService: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendServiceReference message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendServiceReference
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendServiceReference} BackendServiceReference
                         */
                        BackendServiceReference.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendServiceReference)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendServiceReference();
                            if (object.backendService != null)
                                message.backendService = String(object.backendService);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendServiceReference message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendServiceReference
                         * @static
                         * @param {google.cloud.compute.v1.BackendServiceReference} message BackendServiceReference
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendServiceReference.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.backendService != null && message.hasOwnProperty("backendService")) {
                                object.backendService = message.backendService;
                                if (options.oneofs)
                                    object._backendService = "backendService";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendServiceReference to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendServiceReference
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendServiceReference.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendServiceReference
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendServiceReference
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendServiceReference.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendServiceReference";
                        };
    
                        return BackendServiceReference;
                    })();
    
                    v1.BackendServicesScopedList = (function() {
    
                        /**
                         * Properties of a BackendServicesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IBackendServicesScopedList
                         * @property {Array.<google.cloud.compute.v1.IBackendService>|null} [backendServices] BackendServicesScopedList backendServices
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] BackendServicesScopedList warning
                         */
    
                        /**
                         * Constructs a new BackendServicesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendServicesScopedList.
                         * @implements IBackendServicesScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IBackendServicesScopedList=} [properties] Properties to set
                         */
                        function BackendServicesScopedList(properties) {
                            this.backendServices = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BackendServicesScopedList backendServices.
                         * @member {Array.<google.cloud.compute.v1.IBackendService>} backendServices
                         * @memberof google.cloud.compute.v1.BackendServicesScopedList
                         * @instance
                         */
                        BackendServicesScopedList.prototype.backendServices = $util.emptyArray;
    
                        /**
                         * BackendServicesScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.BackendServicesScopedList
                         * @instance
                         */
                        BackendServicesScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BackendServicesScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.BackendServicesScopedList
                         * @instance
                         */
                        Object.defineProperty(BackendServicesScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BackendServicesScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendServicesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServicesScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BackendServicesScopedList} BackendServicesScopedList instance
                         */
                        BackendServicesScopedList.create = function create(properties) {
                            return new BackendServicesScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified BackendServicesScopedList message. Does not implicitly {@link google.cloud.compute.v1.BackendServicesScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BackendServicesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServicesScopedList} message BackendServicesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServicesScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.backendServices != null && message.backendServices.length)
                                for (var i = 0; i < message.backendServices.length; ++i)
                                    $root.google.cloud.compute.v1.BackendService.encode(message.backendServices[i], writer.uint32(/* id 388522409, wireType 2 =*/3108179274).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BackendServicesScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BackendServicesScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServicesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IBackendServicesScopedList} message BackendServicesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BackendServicesScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BackendServicesScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BackendServicesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BackendServicesScopedList} BackendServicesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServicesScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BackendServicesScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 388522409: {
                                        if (!(message.backendServices && message.backendServices.length))
                                            message.backendServices = [];
                                        message.backendServices.push($root.google.cloud.compute.v1.BackendService.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BackendServicesScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BackendServicesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BackendServicesScopedList} BackendServicesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BackendServicesScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BackendServicesScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BackendServicesScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BackendServicesScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendServices != null && message.hasOwnProperty("backendServices")) {
                                if (!Array.isArray(message.backendServices))
                                    return "backendServices: array expected";
                                for (var i = 0; i < message.backendServices.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.BackendService.verify(message.backendServices[i]);
                                    if (error)
                                        return "backendServices." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BackendServicesScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BackendServicesScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BackendServicesScopedList} BackendServicesScopedList
                         */
                        BackendServicesScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BackendServicesScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BackendServicesScopedList();
                            if (object.backendServices) {
                                if (!Array.isArray(object.backendServices))
                                    throw TypeError(".google.cloud.compute.v1.BackendServicesScopedList.backendServices: array expected");
                                message.backendServices = [];
                                for (var i = 0; i < object.backendServices.length; ++i) {
                                    if (typeof object.backendServices[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.BackendServicesScopedList.backendServices: object expected");
                                    message.backendServices[i] = $root.google.cloud.compute.v1.BackendService.fromObject(object.backendServices[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BackendServicesScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BackendServicesScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BackendServicesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.BackendServicesScopedList} message BackendServicesScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BackendServicesScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.backendServices = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.backendServices && message.backendServices.length) {
                                object.backendServices = [];
                                for (var j = 0; j < message.backendServices.length; ++j)
                                    object.backendServices[j] = $root.google.cloud.compute.v1.BackendService.toObject(message.backendServices[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BackendServicesScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BackendServicesScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BackendServicesScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BackendServicesScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BackendServicesScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BackendServicesScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BackendServicesScopedList";
                        };
    
                        return BackendServicesScopedList;
                    })();
    
                    v1.BfdPacket = (function() {
    
                        /**
                         * Properties of a BfdPacket.
                         * @memberof google.cloud.compute.v1
                         * @interface IBfdPacket
                         * @property {boolean|null} [authenticationPresent] BfdPacket authenticationPresent
                         * @property {boolean|null} [controlPlaneIndependent] BfdPacket controlPlaneIndependent
                         * @property {boolean|null} [demand] BfdPacket demand
                         * @property {string|null} [diagnostic] BfdPacket diagnostic
                         * @property {boolean|null} [final] BfdPacket final
                         * @property {number|null} [length] BfdPacket length
                         * @property {number|null} [minEchoRxIntervalMs] BfdPacket minEchoRxIntervalMs
                         * @property {number|null} [minRxIntervalMs] BfdPacket minRxIntervalMs
                         * @property {number|null} [minTxIntervalMs] BfdPacket minTxIntervalMs
                         * @property {number|null} [multiplier] BfdPacket multiplier
                         * @property {boolean|null} [multipoint] BfdPacket multipoint
                         * @property {number|null} [myDiscriminator] BfdPacket myDiscriminator
                         * @property {boolean|null} [poll] BfdPacket poll
                         * @property {string|null} [state] BfdPacket state
                         * @property {number|null} [version] BfdPacket version
                         * @property {number|null} [yourDiscriminator] BfdPacket yourDiscriminator
                         */
    
                        /**
                         * Constructs a new BfdPacket.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BfdPacket.
                         * @implements IBfdPacket
                         * @constructor
                         * @param {google.cloud.compute.v1.IBfdPacket=} [properties] Properties to set
                         */
                        function BfdPacket(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BfdPacket authenticationPresent.
                         * @member {boolean|null|undefined} authenticationPresent
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        BfdPacket.prototype.authenticationPresent = null;
    
                        /**
                         * BfdPacket controlPlaneIndependent.
                         * @member {boolean|null|undefined} controlPlaneIndependent
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        BfdPacket.prototype.controlPlaneIndependent = null;
    
                        /**
                         * BfdPacket demand.
                         * @member {boolean|null|undefined} demand
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        BfdPacket.prototype.demand = null;
    
                        /**
                         * BfdPacket diagnostic.
                         * @member {string|null|undefined} diagnostic
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        BfdPacket.prototype.diagnostic = null;
    
                        /**
                         * BfdPacket final.
                         * @member {boolean|null|undefined} final
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        BfdPacket.prototype.final = null;
    
                        /**
                         * BfdPacket length.
                         * @member {number|null|undefined} length
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        BfdPacket.prototype.length = null;
    
                        /**
                         * BfdPacket minEchoRxIntervalMs.
                         * @member {number|null|undefined} minEchoRxIntervalMs
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        BfdPacket.prototype.minEchoRxIntervalMs = null;
    
                        /**
                         * BfdPacket minRxIntervalMs.
                         * @member {number|null|undefined} minRxIntervalMs
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        BfdPacket.prototype.minRxIntervalMs = null;
    
                        /**
                         * BfdPacket minTxIntervalMs.
                         * @member {number|null|undefined} minTxIntervalMs
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        BfdPacket.prototype.minTxIntervalMs = null;
    
                        /**
                         * BfdPacket multiplier.
                         * @member {number|null|undefined} multiplier
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        BfdPacket.prototype.multiplier = null;
    
                        /**
                         * BfdPacket multipoint.
                         * @member {boolean|null|undefined} multipoint
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        BfdPacket.prototype.multipoint = null;
    
                        /**
                         * BfdPacket myDiscriminator.
                         * @member {number|null|undefined} myDiscriminator
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        BfdPacket.prototype.myDiscriminator = null;
    
                        /**
                         * BfdPacket poll.
                         * @member {boolean|null|undefined} poll
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        BfdPacket.prototype.poll = null;
    
                        /**
                         * BfdPacket state.
                         * @member {string|null|undefined} state
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        BfdPacket.prototype.state = null;
    
                        /**
                         * BfdPacket version.
                         * @member {number|null|undefined} version
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        BfdPacket.prototype.version = null;
    
                        /**
                         * BfdPacket yourDiscriminator.
                         * @member {number|null|undefined} yourDiscriminator
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        BfdPacket.prototype.yourDiscriminator = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BfdPacket _authenticationPresent.
                         * @member {"authenticationPresent"|undefined} _authenticationPresent
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        Object.defineProperty(BfdPacket.prototype, "_authenticationPresent", {
                            get: $util.oneOfGetter($oneOfFields = ["authenticationPresent"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdPacket _controlPlaneIndependent.
                         * @member {"controlPlaneIndependent"|undefined} _controlPlaneIndependent
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        Object.defineProperty(BfdPacket.prototype, "_controlPlaneIndependent", {
                            get: $util.oneOfGetter($oneOfFields = ["controlPlaneIndependent"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdPacket _demand.
                         * @member {"demand"|undefined} _demand
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        Object.defineProperty(BfdPacket.prototype, "_demand", {
                            get: $util.oneOfGetter($oneOfFields = ["demand"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdPacket _diagnostic.
                         * @member {"diagnostic"|undefined} _diagnostic
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        Object.defineProperty(BfdPacket.prototype, "_diagnostic", {
                            get: $util.oneOfGetter($oneOfFields = ["diagnostic"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdPacket _final.
                         * @member {"final"|undefined} _final
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        Object.defineProperty(BfdPacket.prototype, "_final", {
                            get: $util.oneOfGetter($oneOfFields = ["final"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdPacket _length.
                         * @member {"length"|undefined} _length
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        Object.defineProperty(BfdPacket.prototype, "_length", {
                            get: $util.oneOfGetter($oneOfFields = ["length"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdPacket _minEchoRxIntervalMs.
                         * @member {"minEchoRxIntervalMs"|undefined} _minEchoRxIntervalMs
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        Object.defineProperty(BfdPacket.prototype, "_minEchoRxIntervalMs", {
                            get: $util.oneOfGetter($oneOfFields = ["minEchoRxIntervalMs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdPacket _minRxIntervalMs.
                         * @member {"minRxIntervalMs"|undefined} _minRxIntervalMs
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        Object.defineProperty(BfdPacket.prototype, "_minRxIntervalMs", {
                            get: $util.oneOfGetter($oneOfFields = ["minRxIntervalMs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdPacket _minTxIntervalMs.
                         * @member {"minTxIntervalMs"|undefined} _minTxIntervalMs
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        Object.defineProperty(BfdPacket.prototype, "_minTxIntervalMs", {
                            get: $util.oneOfGetter($oneOfFields = ["minTxIntervalMs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdPacket _multiplier.
                         * @member {"multiplier"|undefined} _multiplier
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        Object.defineProperty(BfdPacket.prototype, "_multiplier", {
                            get: $util.oneOfGetter($oneOfFields = ["multiplier"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdPacket _multipoint.
                         * @member {"multipoint"|undefined} _multipoint
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        Object.defineProperty(BfdPacket.prototype, "_multipoint", {
                            get: $util.oneOfGetter($oneOfFields = ["multipoint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdPacket _myDiscriminator.
                         * @member {"myDiscriminator"|undefined} _myDiscriminator
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        Object.defineProperty(BfdPacket.prototype, "_myDiscriminator", {
                            get: $util.oneOfGetter($oneOfFields = ["myDiscriminator"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdPacket _poll.
                         * @member {"poll"|undefined} _poll
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        Object.defineProperty(BfdPacket.prototype, "_poll", {
                            get: $util.oneOfGetter($oneOfFields = ["poll"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdPacket _state.
                         * @member {"state"|undefined} _state
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        Object.defineProperty(BfdPacket.prototype, "_state", {
                            get: $util.oneOfGetter($oneOfFields = ["state"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdPacket _version.
                         * @member {"version"|undefined} _version
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        Object.defineProperty(BfdPacket.prototype, "_version", {
                            get: $util.oneOfGetter($oneOfFields = ["version"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdPacket _yourDiscriminator.
                         * @member {"yourDiscriminator"|undefined} _yourDiscriminator
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         */
                        Object.defineProperty(BfdPacket.prototype, "_yourDiscriminator", {
                            get: $util.oneOfGetter($oneOfFields = ["yourDiscriminator"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BfdPacket instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @static
                         * @param {google.cloud.compute.v1.IBfdPacket=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BfdPacket} BfdPacket instance
                         */
                        BfdPacket.create = function create(properties) {
                            return new BfdPacket(properties);
                        };
    
                        /**
                         * Encodes the specified BfdPacket message. Does not implicitly {@link google.cloud.compute.v1.BfdPacket.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @static
                         * @param {google.cloud.compute.v1.IBfdPacket} message BfdPacket message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BfdPacket.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.poll != null && Object.hasOwnProperty.call(message, "poll"))
                                writer.uint32(/* id 3446719, wireType 0 =*/27573752).bool(message.poll);
                            if (message.controlPlaneIndependent != null && Object.hasOwnProperty.call(message, "controlPlaneIndependent"))
                                writer.uint32(/* id 62363573, wireType 0 =*/498908584).bool(message.controlPlaneIndependent);
                            if (message.diagnostic != null && Object.hasOwnProperty.call(message, "diagnostic"))
                                writer.uint32(/* id 62708647, wireType 2 =*/501669178).string(message.diagnostic);
                            if (message.myDiscriminator != null && Object.hasOwnProperty.call(message, "myDiscriminator"))
                                writer.uint32(/* id 76663113, wireType 0 =*/613304904).uint32(message.myDiscriminator);
                            if (message.minEchoRxIntervalMs != null && Object.hasOwnProperty.call(message, "minEchoRxIntervalMs"))
                                writer.uint32(/* id 97286868, wireType 0 =*/778294944).uint32(message.minEchoRxIntervalMs);
                            if (message.final != null && Object.hasOwnProperty.call(message, "final"))
                                writer.uint32(/* id 97436022, wireType 0 =*/779488176).bool(message.final);
                            if (message.authenticationPresent != null && Object.hasOwnProperty.call(message, "authenticationPresent"))
                                writer.uint32(/* id 105974260, wireType 0 =*/847794080).bool(message.authenticationPresent);
                            if (message.state != null && Object.hasOwnProperty.call(message, "state"))
                                writer.uint32(/* id 109757585, wireType 2 =*/878060682).string(message.state);
                            if (message.multiplier != null && Object.hasOwnProperty.call(message, "multiplier"))
                                writer.uint32(/* id 191331777, wireType 0 =*/1530654216).uint32(message.multiplier);
                            if (message.multipoint != null && Object.hasOwnProperty.call(message, "multipoint"))
                                writer.uint32(/* id 191421431, wireType 0 =*/1531371448).bool(message.multipoint);
                            if (message.demand != null && Object.hasOwnProperty.call(message, "demand"))
                                writer.uint32(/* id 275180107, wireType 0 =*/2201440856).bool(message.demand);
                            if (message.version != null && Object.hasOwnProperty.call(message, "version"))
                                writer.uint32(/* id 351608024, wireType 0 =*/2812864192).uint32(message.version);
                            if (message.minRxIntervalMs != null && Object.hasOwnProperty.call(message, "minRxIntervalMs"))
                                writer.uint32(/* id 463399028, wireType 0 =*/3707192224).uint32(message.minRxIntervalMs);
                            if (message.length != null && Object.hasOwnProperty.call(message, "length"))
                                writer.uint32(/* id 504249062, wireType 0 =*/4033992496).uint32(message.length);
                            if (message.yourDiscriminator != null && Object.hasOwnProperty.call(message, "yourDiscriminator"))
                                writer.uint32(/* id 515634064, wireType 0 =*/4125072512).uint32(message.yourDiscriminator);
                            if (message.minTxIntervalMs != null && Object.hasOwnProperty.call(message, "minTxIntervalMs"))
                                writer.uint32(/* id 526023602, wireType 0 =*/4208188816).uint32(message.minTxIntervalMs);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BfdPacket message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BfdPacket.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @static
                         * @param {google.cloud.compute.v1.IBfdPacket} message BfdPacket message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BfdPacket.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BfdPacket message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BfdPacket} BfdPacket
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BfdPacket.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BfdPacket();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 105974260: {
                                        message.authenticationPresent = reader.bool();
                                        break;
                                    }
                                case 62363573: {
                                        message.controlPlaneIndependent = reader.bool();
                                        break;
                                    }
                                case 275180107: {
                                        message.demand = reader.bool();
                                        break;
                                    }
                                case 62708647: {
                                        message.diagnostic = reader.string();
                                        break;
                                    }
                                case 97436022: {
                                        message.final = reader.bool();
                                        break;
                                    }
                                case 504249062: {
                                        message.length = reader.uint32();
                                        break;
                                    }
                                case 97286868: {
                                        message.minEchoRxIntervalMs = reader.uint32();
                                        break;
                                    }
                                case 463399028: {
                                        message.minRxIntervalMs = reader.uint32();
                                        break;
                                    }
                                case 526023602: {
                                        message.minTxIntervalMs = reader.uint32();
                                        break;
                                    }
                                case 191331777: {
                                        message.multiplier = reader.uint32();
                                        break;
                                    }
                                case 191421431: {
                                        message.multipoint = reader.bool();
                                        break;
                                    }
                                case 76663113: {
                                        message.myDiscriminator = reader.uint32();
                                        break;
                                    }
                                case 3446719: {
                                        message.poll = reader.bool();
                                        break;
                                    }
                                case 109757585: {
                                        message.state = reader.string();
                                        break;
                                    }
                                case 351608024: {
                                        message.version = reader.uint32();
                                        break;
                                    }
                                case 515634064: {
                                        message.yourDiscriminator = reader.uint32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BfdPacket message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BfdPacket} BfdPacket
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BfdPacket.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BfdPacket message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BfdPacket.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.authenticationPresent != null && message.hasOwnProperty("authenticationPresent")) {
                                properties._authenticationPresent = 1;
                                if (typeof message.authenticationPresent !== "boolean")
                                    return "authenticationPresent: boolean expected";
                            }
                            if (message.controlPlaneIndependent != null && message.hasOwnProperty("controlPlaneIndependent")) {
                                properties._controlPlaneIndependent = 1;
                                if (typeof message.controlPlaneIndependent !== "boolean")
                                    return "controlPlaneIndependent: boolean expected";
                            }
                            if (message.demand != null && message.hasOwnProperty("demand")) {
                                properties._demand = 1;
                                if (typeof message.demand !== "boolean")
                                    return "demand: boolean expected";
                            }
                            if (message.diagnostic != null && message.hasOwnProperty("diagnostic")) {
                                properties._diagnostic = 1;
                                if (!$util.isString(message.diagnostic))
                                    return "diagnostic: string expected";
                            }
                            if (message.final != null && message.hasOwnProperty("final")) {
                                properties._final = 1;
                                if (typeof message.final !== "boolean")
                                    return "final: boolean expected";
                            }
                            if (message.length != null && message.hasOwnProperty("length")) {
                                properties._length = 1;
                                if (!$util.isInteger(message.length))
                                    return "length: integer expected";
                            }
                            if (message.minEchoRxIntervalMs != null && message.hasOwnProperty("minEchoRxIntervalMs")) {
                                properties._minEchoRxIntervalMs = 1;
                                if (!$util.isInteger(message.minEchoRxIntervalMs))
                                    return "minEchoRxIntervalMs: integer expected";
                            }
                            if (message.minRxIntervalMs != null && message.hasOwnProperty("minRxIntervalMs")) {
                                properties._minRxIntervalMs = 1;
                                if (!$util.isInteger(message.minRxIntervalMs))
                                    return "minRxIntervalMs: integer expected";
                            }
                            if (message.minTxIntervalMs != null && message.hasOwnProperty("minTxIntervalMs")) {
                                properties._minTxIntervalMs = 1;
                                if (!$util.isInteger(message.minTxIntervalMs))
                                    return "minTxIntervalMs: integer expected";
                            }
                            if (message.multiplier != null && message.hasOwnProperty("multiplier")) {
                                properties._multiplier = 1;
                                if (!$util.isInteger(message.multiplier))
                                    return "multiplier: integer expected";
                            }
                            if (message.multipoint != null && message.hasOwnProperty("multipoint")) {
                                properties._multipoint = 1;
                                if (typeof message.multipoint !== "boolean")
                                    return "multipoint: boolean expected";
                            }
                            if (message.myDiscriminator != null && message.hasOwnProperty("myDiscriminator")) {
                                properties._myDiscriminator = 1;
                                if (!$util.isInteger(message.myDiscriminator))
                                    return "myDiscriminator: integer expected";
                            }
                            if (message.poll != null && message.hasOwnProperty("poll")) {
                                properties._poll = 1;
                                if (typeof message.poll !== "boolean")
                                    return "poll: boolean expected";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                properties._state = 1;
                                if (!$util.isString(message.state))
                                    return "state: string expected";
                            }
                            if (message.version != null && message.hasOwnProperty("version")) {
                                properties._version = 1;
                                if (!$util.isInteger(message.version))
                                    return "version: integer expected";
                            }
                            if (message.yourDiscriminator != null && message.hasOwnProperty("yourDiscriminator")) {
                                properties._yourDiscriminator = 1;
                                if (!$util.isInteger(message.yourDiscriminator))
                                    return "yourDiscriminator: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BfdPacket message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BfdPacket} BfdPacket
                         */
                        BfdPacket.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BfdPacket)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BfdPacket();
                            if (object.authenticationPresent != null)
                                message.authenticationPresent = Boolean(object.authenticationPresent);
                            if (object.controlPlaneIndependent != null)
                                message.controlPlaneIndependent = Boolean(object.controlPlaneIndependent);
                            if (object.demand != null)
                                message.demand = Boolean(object.demand);
                            if (object.diagnostic != null)
                                message.diagnostic = String(object.diagnostic);
                            if (object.final != null)
                                message.final = Boolean(object.final);
                            if (object.length != null)
                                message.length = object.length >>> 0;
                            if (object.minEchoRxIntervalMs != null)
                                message.minEchoRxIntervalMs = object.minEchoRxIntervalMs >>> 0;
                            if (object.minRxIntervalMs != null)
                                message.minRxIntervalMs = object.minRxIntervalMs >>> 0;
                            if (object.minTxIntervalMs != null)
                                message.minTxIntervalMs = object.minTxIntervalMs >>> 0;
                            if (object.multiplier != null)
                                message.multiplier = object.multiplier >>> 0;
                            if (object.multipoint != null)
                                message.multipoint = Boolean(object.multipoint);
                            if (object.myDiscriminator != null)
                                message.myDiscriminator = object.myDiscriminator >>> 0;
                            if (object.poll != null)
                                message.poll = Boolean(object.poll);
                            if (object.state != null)
                                message.state = String(object.state);
                            if (object.version != null)
                                message.version = object.version >>> 0;
                            if (object.yourDiscriminator != null)
                                message.yourDiscriminator = object.yourDiscriminator >>> 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BfdPacket message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @static
                         * @param {google.cloud.compute.v1.BfdPacket} message BfdPacket
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BfdPacket.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.poll != null && message.hasOwnProperty("poll")) {
                                object.poll = message.poll;
                                if (options.oneofs)
                                    object._poll = "poll";
                            }
                            if (message.controlPlaneIndependent != null && message.hasOwnProperty("controlPlaneIndependent")) {
                                object.controlPlaneIndependent = message.controlPlaneIndependent;
                                if (options.oneofs)
                                    object._controlPlaneIndependent = "controlPlaneIndependent";
                            }
                            if (message.diagnostic != null && message.hasOwnProperty("diagnostic")) {
                                object.diagnostic = message.diagnostic;
                                if (options.oneofs)
                                    object._diagnostic = "diagnostic";
                            }
                            if (message.myDiscriminator != null && message.hasOwnProperty("myDiscriminator")) {
                                object.myDiscriminator = message.myDiscriminator;
                                if (options.oneofs)
                                    object._myDiscriminator = "myDiscriminator";
                            }
                            if (message.minEchoRxIntervalMs != null && message.hasOwnProperty("minEchoRxIntervalMs")) {
                                object.minEchoRxIntervalMs = message.minEchoRxIntervalMs;
                                if (options.oneofs)
                                    object._minEchoRxIntervalMs = "minEchoRxIntervalMs";
                            }
                            if (message.final != null && message.hasOwnProperty("final")) {
                                object.final = message.final;
                                if (options.oneofs)
                                    object._final = "final";
                            }
                            if (message.authenticationPresent != null && message.hasOwnProperty("authenticationPresent")) {
                                object.authenticationPresent = message.authenticationPresent;
                                if (options.oneofs)
                                    object._authenticationPresent = "authenticationPresent";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                object.state = message.state;
                                if (options.oneofs)
                                    object._state = "state";
                            }
                            if (message.multiplier != null && message.hasOwnProperty("multiplier")) {
                                object.multiplier = message.multiplier;
                                if (options.oneofs)
                                    object._multiplier = "multiplier";
                            }
                            if (message.multipoint != null && message.hasOwnProperty("multipoint")) {
                                object.multipoint = message.multipoint;
                                if (options.oneofs)
                                    object._multipoint = "multipoint";
                            }
                            if (message.demand != null && message.hasOwnProperty("demand")) {
                                object.demand = message.demand;
                                if (options.oneofs)
                                    object._demand = "demand";
                            }
                            if (message.version != null && message.hasOwnProperty("version")) {
                                object.version = message.version;
                                if (options.oneofs)
                                    object._version = "version";
                            }
                            if (message.minRxIntervalMs != null && message.hasOwnProperty("minRxIntervalMs")) {
                                object.minRxIntervalMs = message.minRxIntervalMs;
                                if (options.oneofs)
                                    object._minRxIntervalMs = "minRxIntervalMs";
                            }
                            if (message.length != null && message.hasOwnProperty("length")) {
                                object.length = message.length;
                                if (options.oneofs)
                                    object._length = "length";
                            }
                            if (message.yourDiscriminator != null && message.hasOwnProperty("yourDiscriminator")) {
                                object.yourDiscriminator = message.yourDiscriminator;
                                if (options.oneofs)
                                    object._yourDiscriminator = "yourDiscriminator";
                            }
                            if (message.minTxIntervalMs != null && message.hasOwnProperty("minTxIntervalMs")) {
                                object.minTxIntervalMs = message.minTxIntervalMs;
                                if (options.oneofs)
                                    object._minTxIntervalMs = "minTxIntervalMs";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BfdPacket to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BfdPacket.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BfdPacket
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BfdPacket
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BfdPacket.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BfdPacket";
                        };
    
                        /**
                         * Diagnostic enum.
                         * @name google.cloud.compute.v1.BfdPacket.Diagnostic
                         * @enum {number}
                         * @property {number} UNDEFINED_DIAGNOSTIC=0 UNDEFINED_DIAGNOSTIC value
                         * @property {number} ADMINISTRATIVELY_DOWN=121685798 ADMINISTRATIVELY_DOWN value
                         * @property {number} CONCATENATED_PATH_DOWN=26186892 CONCATENATED_PATH_DOWN value
                         * @property {number} CONTROL_DETECTION_TIME_EXPIRED=135478383 CONTROL_DETECTION_TIME_EXPIRED value
                         * @property {number} DIAGNOSTIC_UNSPECIFIED=58720895 DIAGNOSTIC_UNSPECIFIED value
                         * @property {number} ECHO_FUNCTION_FAILED=220687466 ECHO_FUNCTION_FAILED value
                         * @property {number} FORWARDING_PLANE_RESET=19715882 FORWARDING_PLANE_RESET value
                         * @property {number} NEIGHBOR_SIGNALED_SESSION_DOWN=374226742 NEIGHBOR_SIGNALED_SESSION_DOWN value
                         * @property {number} NO_DIAGNOSTIC=222503141 NO_DIAGNOSTIC value
                         * @property {number} PATH_DOWN=290605180 PATH_DOWN value
                         * @property {number} REVERSE_CONCATENATED_PATH_DOWN=479337129 REVERSE_CONCATENATED_PATH_DOWN value
                         */
                        BfdPacket.Diagnostic = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_DIAGNOSTIC"] = 0;
                            values[valuesById[121685798] = "ADMINISTRATIVELY_DOWN"] = 121685798;
                            values[valuesById[26186892] = "CONCATENATED_PATH_DOWN"] = 26186892;
                            values[valuesById[135478383] = "CONTROL_DETECTION_TIME_EXPIRED"] = 135478383;
                            values[valuesById[58720895] = "DIAGNOSTIC_UNSPECIFIED"] = 58720895;
                            values[valuesById[220687466] = "ECHO_FUNCTION_FAILED"] = 220687466;
                            values[valuesById[19715882] = "FORWARDING_PLANE_RESET"] = 19715882;
                            values[valuesById[374226742] = "NEIGHBOR_SIGNALED_SESSION_DOWN"] = 374226742;
                            values[valuesById[222503141] = "NO_DIAGNOSTIC"] = 222503141;
                            values[valuesById[290605180] = "PATH_DOWN"] = 290605180;
                            values[valuesById[479337129] = "REVERSE_CONCATENATED_PATH_DOWN"] = 479337129;
                            return values;
                        })();
    
                        /**
                         * State enum.
                         * @name google.cloud.compute.v1.BfdPacket.State
                         * @enum {number}
                         * @property {number} UNDEFINED_STATE=0 UNDEFINED_STATE value
                         * @property {number} ADMIN_DOWN=128544690 ADMIN_DOWN value
                         * @property {number} DOWN=2104482 DOWN value
                         * @property {number} INIT=2252048 INIT value
                         * @property {number} STATE_UNSPECIFIED=470755401 STATE_UNSPECIFIED value
                         * @property {number} UP=2715 UP value
                         */
                        BfdPacket.State = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATE"] = 0;
                            values[valuesById[128544690] = "ADMIN_DOWN"] = 128544690;
                            values[valuesById[2104482] = "DOWN"] = 2104482;
                            values[valuesById[2252048] = "INIT"] = 2252048;
                            values[valuesById[470755401] = "STATE_UNSPECIFIED"] = 470755401;
                            values[valuesById[2715] = "UP"] = 2715;
                            return values;
                        })();
    
                        return BfdPacket;
                    })();
    
                    v1.BfdStatus = (function() {
    
                        /**
                         * Properties of a BfdStatus.
                         * @memberof google.cloud.compute.v1
                         * @interface IBfdStatus
                         * @property {string|null} [bfdSessionInitializationMode] BfdStatus bfdSessionInitializationMode
                         * @property {number|Long|null} [configUpdateTimestampMicros] BfdStatus configUpdateTimestampMicros
                         * @property {google.cloud.compute.v1.IBfdStatusPacketCounts|null} [controlPacketCounts] BfdStatus controlPacketCounts
                         * @property {Array.<google.cloud.compute.v1.IPacketIntervals>|null} [controlPacketIntervals] BfdStatus controlPacketIntervals
                         * @property {string|null} [localDiagnostic] BfdStatus localDiagnostic
                         * @property {string|null} [localState] BfdStatus localState
                         * @property {number|null} [negotiatedLocalControlTxIntervalMs] BfdStatus negotiatedLocalControlTxIntervalMs
                         * @property {google.cloud.compute.v1.IBfdPacket|null} [rxPacket] BfdStatus rxPacket
                         * @property {google.cloud.compute.v1.IBfdPacket|null} [txPacket] BfdStatus txPacket
                         * @property {number|Long|null} [uptimeMs] BfdStatus uptimeMs
                         */
    
                        /**
                         * Constructs a new BfdStatus.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BfdStatus.
                         * @implements IBfdStatus
                         * @constructor
                         * @param {google.cloud.compute.v1.IBfdStatus=} [properties] Properties to set
                         */
                        function BfdStatus(properties) {
                            this.controlPacketIntervals = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BfdStatus bfdSessionInitializationMode.
                         * @member {string|null|undefined} bfdSessionInitializationMode
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @instance
                         */
                        BfdStatus.prototype.bfdSessionInitializationMode = null;
    
                        /**
                         * BfdStatus configUpdateTimestampMicros.
                         * @member {number|Long|null|undefined} configUpdateTimestampMicros
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @instance
                         */
                        BfdStatus.prototype.configUpdateTimestampMicros = null;
    
                        /**
                         * BfdStatus controlPacketCounts.
                         * @member {google.cloud.compute.v1.IBfdStatusPacketCounts|null|undefined} controlPacketCounts
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @instance
                         */
                        BfdStatus.prototype.controlPacketCounts = null;
    
                        /**
                         * BfdStatus controlPacketIntervals.
                         * @member {Array.<google.cloud.compute.v1.IPacketIntervals>} controlPacketIntervals
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @instance
                         */
                        BfdStatus.prototype.controlPacketIntervals = $util.emptyArray;
    
                        /**
                         * BfdStatus localDiagnostic.
                         * @member {string|null|undefined} localDiagnostic
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @instance
                         */
                        BfdStatus.prototype.localDiagnostic = null;
    
                        /**
                         * BfdStatus localState.
                         * @member {string|null|undefined} localState
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @instance
                         */
                        BfdStatus.prototype.localState = null;
    
                        /**
                         * BfdStatus negotiatedLocalControlTxIntervalMs.
                         * @member {number|null|undefined} negotiatedLocalControlTxIntervalMs
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @instance
                         */
                        BfdStatus.prototype.negotiatedLocalControlTxIntervalMs = null;
    
                        /**
                         * BfdStatus rxPacket.
                         * @member {google.cloud.compute.v1.IBfdPacket|null|undefined} rxPacket
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @instance
                         */
                        BfdStatus.prototype.rxPacket = null;
    
                        /**
                         * BfdStatus txPacket.
                         * @member {google.cloud.compute.v1.IBfdPacket|null|undefined} txPacket
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @instance
                         */
                        BfdStatus.prototype.txPacket = null;
    
                        /**
                         * BfdStatus uptimeMs.
                         * @member {number|Long|null|undefined} uptimeMs
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @instance
                         */
                        BfdStatus.prototype.uptimeMs = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BfdStatus _bfdSessionInitializationMode.
                         * @member {"bfdSessionInitializationMode"|undefined} _bfdSessionInitializationMode
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @instance
                         */
                        Object.defineProperty(BfdStatus.prototype, "_bfdSessionInitializationMode", {
                            get: $util.oneOfGetter($oneOfFields = ["bfdSessionInitializationMode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdStatus _configUpdateTimestampMicros.
                         * @member {"configUpdateTimestampMicros"|undefined} _configUpdateTimestampMicros
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @instance
                         */
                        Object.defineProperty(BfdStatus.prototype, "_configUpdateTimestampMicros", {
                            get: $util.oneOfGetter($oneOfFields = ["configUpdateTimestampMicros"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdStatus _controlPacketCounts.
                         * @member {"controlPacketCounts"|undefined} _controlPacketCounts
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @instance
                         */
                        Object.defineProperty(BfdStatus.prototype, "_controlPacketCounts", {
                            get: $util.oneOfGetter($oneOfFields = ["controlPacketCounts"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdStatus _localDiagnostic.
                         * @member {"localDiagnostic"|undefined} _localDiagnostic
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @instance
                         */
                        Object.defineProperty(BfdStatus.prototype, "_localDiagnostic", {
                            get: $util.oneOfGetter($oneOfFields = ["localDiagnostic"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdStatus _localState.
                         * @member {"localState"|undefined} _localState
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @instance
                         */
                        Object.defineProperty(BfdStatus.prototype, "_localState", {
                            get: $util.oneOfGetter($oneOfFields = ["localState"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdStatus _negotiatedLocalControlTxIntervalMs.
                         * @member {"negotiatedLocalControlTxIntervalMs"|undefined} _negotiatedLocalControlTxIntervalMs
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @instance
                         */
                        Object.defineProperty(BfdStatus.prototype, "_negotiatedLocalControlTxIntervalMs", {
                            get: $util.oneOfGetter($oneOfFields = ["negotiatedLocalControlTxIntervalMs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdStatus _rxPacket.
                         * @member {"rxPacket"|undefined} _rxPacket
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @instance
                         */
                        Object.defineProperty(BfdStatus.prototype, "_rxPacket", {
                            get: $util.oneOfGetter($oneOfFields = ["rxPacket"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdStatus _txPacket.
                         * @member {"txPacket"|undefined} _txPacket
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @instance
                         */
                        Object.defineProperty(BfdStatus.prototype, "_txPacket", {
                            get: $util.oneOfGetter($oneOfFields = ["txPacket"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdStatus _uptimeMs.
                         * @member {"uptimeMs"|undefined} _uptimeMs
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @instance
                         */
                        Object.defineProperty(BfdStatus.prototype, "_uptimeMs", {
                            get: $util.oneOfGetter($oneOfFields = ["uptimeMs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BfdStatus instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @static
                         * @param {google.cloud.compute.v1.IBfdStatus=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BfdStatus} BfdStatus instance
                         */
                        BfdStatus.create = function create(properties) {
                            return new BfdStatus(properties);
                        };
    
                        /**
                         * Encodes the specified BfdStatus message. Does not implicitly {@link google.cloud.compute.v1.BfdStatus.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @static
                         * @param {google.cloud.compute.v1.IBfdStatus} message BfdStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BfdStatus.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.negotiatedLocalControlTxIntervalMs != null && Object.hasOwnProperty.call(message, "negotiatedLocalControlTxIntervalMs"))
                                writer.uint32(/* id 21768340, wireType 0 =*/174146720).uint32(message.negotiatedLocalControlTxIntervalMs);
                            if (message.txPacket != null && Object.hasOwnProperty.call(message, "txPacket"))
                                $root.google.cloud.compute.v1.BfdPacket.encode(message.txPacket, writer.uint32(/* id 111386275, wireType 2 =*/891090202).fork()).ldelim();
                            if (message.uptimeMs != null && Object.hasOwnProperty.call(message, "uptimeMs"))
                                writer.uint32(/* id 125398365, wireType 0 =*/1003186920).int64(message.uptimeMs);
                            if (message.controlPacketCounts != null && Object.hasOwnProperty.call(message, "controlPacketCounts"))
                                $root.google.cloud.compute.v1.BfdStatusPacketCounts.encode(message.controlPacketCounts, writer.uint32(/* id 132573561, wireType 2 =*/1060588490).fork()).ldelim();
                            if (message.localState != null && Object.hasOwnProperty.call(message, "localState"))
                                writer.uint32(/* id 149195453, wireType 2 =*/1193563626).string(message.localState);
                            if (message.bfdSessionInitializationMode != null && Object.hasOwnProperty.call(message, "bfdSessionInitializationMode"))
                                writer.uint32(/* id 218156954, wireType 2 =*/1745255634).string(message.bfdSessionInitializationMode);
                            if (message.configUpdateTimestampMicros != null && Object.hasOwnProperty.call(message, "configUpdateTimestampMicros"))
                                writer.uint32(/* id 457195569, wireType 0 =*/3657564552).int64(message.configUpdateTimestampMicros);
                            if (message.localDiagnostic != null && Object.hasOwnProperty.call(message, "localDiagnostic"))
                                writer.uint32(/* id 463737083, wireType 2 =*/3709896666).string(message.localDiagnostic);
                            if (message.controlPacketIntervals != null && message.controlPacketIntervals.length)
                                for (var i = 0; i < message.controlPacketIntervals.length; ++i)
                                    $root.google.cloud.compute.v1.PacketIntervals.encode(message.controlPacketIntervals[i], writer.uint32(/* id 500806649, wireType 2 =*/4006453194).fork()).ldelim();
                            if (message.rxPacket != null && Object.hasOwnProperty.call(message, "rxPacket"))
                                $root.google.cloud.compute.v1.BfdPacket.encode(message.rxPacket, writer.uint32(/* id 505069729, wireType 2 =*/4040557834).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BfdStatus message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BfdStatus.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @static
                         * @param {google.cloud.compute.v1.IBfdStatus} message BfdStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BfdStatus.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BfdStatus message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BfdStatus} BfdStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BfdStatus.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BfdStatus();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 218156954: {
                                        message.bfdSessionInitializationMode = reader.string();
                                        break;
                                    }
                                case 457195569: {
                                        message.configUpdateTimestampMicros = reader.int64();
                                        break;
                                    }
                                case 132573561: {
                                        message.controlPacketCounts = $root.google.cloud.compute.v1.BfdStatusPacketCounts.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 500806649: {
                                        if (!(message.controlPacketIntervals && message.controlPacketIntervals.length))
                                            message.controlPacketIntervals = [];
                                        message.controlPacketIntervals.push($root.google.cloud.compute.v1.PacketIntervals.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 463737083: {
                                        message.localDiagnostic = reader.string();
                                        break;
                                    }
                                case 149195453: {
                                        message.localState = reader.string();
                                        break;
                                    }
                                case 21768340: {
                                        message.negotiatedLocalControlTxIntervalMs = reader.uint32();
                                        break;
                                    }
                                case 505069729: {
                                        message.rxPacket = $root.google.cloud.compute.v1.BfdPacket.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 111386275: {
                                        message.txPacket = $root.google.cloud.compute.v1.BfdPacket.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 125398365: {
                                        message.uptimeMs = reader.int64();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BfdStatus message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BfdStatus} BfdStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BfdStatus.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BfdStatus message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BfdStatus.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.bfdSessionInitializationMode != null && message.hasOwnProperty("bfdSessionInitializationMode")) {
                                properties._bfdSessionInitializationMode = 1;
                                if (!$util.isString(message.bfdSessionInitializationMode))
                                    return "bfdSessionInitializationMode: string expected";
                            }
                            if (message.configUpdateTimestampMicros != null && message.hasOwnProperty("configUpdateTimestampMicros")) {
                                properties._configUpdateTimestampMicros = 1;
                                if (!$util.isInteger(message.configUpdateTimestampMicros) && !(message.configUpdateTimestampMicros && $util.isInteger(message.configUpdateTimestampMicros.low) && $util.isInteger(message.configUpdateTimestampMicros.high)))
                                    return "configUpdateTimestampMicros: integer|Long expected";
                            }
                            if (message.controlPacketCounts != null && message.hasOwnProperty("controlPacketCounts")) {
                                properties._controlPacketCounts = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.BfdStatusPacketCounts.verify(message.controlPacketCounts);
                                    if (error)
                                        return "controlPacketCounts." + error;
                                }
                            }
                            if (message.controlPacketIntervals != null && message.hasOwnProperty("controlPacketIntervals")) {
                                if (!Array.isArray(message.controlPacketIntervals))
                                    return "controlPacketIntervals: array expected";
                                for (var i = 0; i < message.controlPacketIntervals.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PacketIntervals.verify(message.controlPacketIntervals[i]);
                                    if (error)
                                        return "controlPacketIntervals." + error;
                                }
                            }
                            if (message.localDiagnostic != null && message.hasOwnProperty("localDiagnostic")) {
                                properties._localDiagnostic = 1;
                                if (!$util.isString(message.localDiagnostic))
                                    return "localDiagnostic: string expected";
                            }
                            if (message.localState != null && message.hasOwnProperty("localState")) {
                                properties._localState = 1;
                                if (!$util.isString(message.localState))
                                    return "localState: string expected";
                            }
                            if (message.negotiatedLocalControlTxIntervalMs != null && message.hasOwnProperty("negotiatedLocalControlTxIntervalMs")) {
                                properties._negotiatedLocalControlTxIntervalMs = 1;
                                if (!$util.isInteger(message.negotiatedLocalControlTxIntervalMs))
                                    return "negotiatedLocalControlTxIntervalMs: integer expected";
                            }
                            if (message.rxPacket != null && message.hasOwnProperty("rxPacket")) {
                                properties._rxPacket = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.BfdPacket.verify(message.rxPacket);
                                    if (error)
                                        return "rxPacket." + error;
                                }
                            }
                            if (message.txPacket != null && message.hasOwnProperty("txPacket")) {
                                properties._txPacket = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.BfdPacket.verify(message.txPacket);
                                    if (error)
                                        return "txPacket." + error;
                                }
                            }
                            if (message.uptimeMs != null && message.hasOwnProperty("uptimeMs")) {
                                properties._uptimeMs = 1;
                                if (!$util.isInteger(message.uptimeMs) && !(message.uptimeMs && $util.isInteger(message.uptimeMs.low) && $util.isInteger(message.uptimeMs.high)))
                                    return "uptimeMs: integer|Long expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BfdStatus message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BfdStatus} BfdStatus
                         */
                        BfdStatus.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BfdStatus)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BfdStatus();
                            if (object.bfdSessionInitializationMode != null)
                                message.bfdSessionInitializationMode = String(object.bfdSessionInitializationMode);
                            if (object.configUpdateTimestampMicros != null)
                                if ($util.Long)
                                    (message.configUpdateTimestampMicros = $util.Long.fromValue(object.configUpdateTimestampMicros)).unsigned = false;
                                else if (typeof object.configUpdateTimestampMicros === "string")
                                    message.configUpdateTimestampMicros = parseInt(object.configUpdateTimestampMicros, 10);
                                else if (typeof object.configUpdateTimestampMicros === "number")
                                    message.configUpdateTimestampMicros = object.configUpdateTimestampMicros;
                                else if (typeof object.configUpdateTimestampMicros === "object")
                                    message.configUpdateTimestampMicros = new $util.LongBits(object.configUpdateTimestampMicros.low >>> 0, object.configUpdateTimestampMicros.high >>> 0).toNumber();
                            if (object.controlPacketCounts != null) {
                                if (typeof object.controlPacketCounts !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BfdStatus.controlPacketCounts: object expected");
                                message.controlPacketCounts = $root.google.cloud.compute.v1.BfdStatusPacketCounts.fromObject(object.controlPacketCounts);
                            }
                            if (object.controlPacketIntervals) {
                                if (!Array.isArray(object.controlPacketIntervals))
                                    throw TypeError(".google.cloud.compute.v1.BfdStatus.controlPacketIntervals: array expected");
                                message.controlPacketIntervals = [];
                                for (var i = 0; i < object.controlPacketIntervals.length; ++i) {
                                    if (typeof object.controlPacketIntervals[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.BfdStatus.controlPacketIntervals: object expected");
                                    message.controlPacketIntervals[i] = $root.google.cloud.compute.v1.PacketIntervals.fromObject(object.controlPacketIntervals[i]);
                                }
                            }
                            if (object.localDiagnostic != null)
                                message.localDiagnostic = String(object.localDiagnostic);
                            if (object.localState != null)
                                message.localState = String(object.localState);
                            if (object.negotiatedLocalControlTxIntervalMs != null)
                                message.negotiatedLocalControlTxIntervalMs = object.negotiatedLocalControlTxIntervalMs >>> 0;
                            if (object.rxPacket != null) {
                                if (typeof object.rxPacket !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BfdStatus.rxPacket: object expected");
                                message.rxPacket = $root.google.cloud.compute.v1.BfdPacket.fromObject(object.rxPacket);
                            }
                            if (object.txPacket != null) {
                                if (typeof object.txPacket !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BfdStatus.txPacket: object expected");
                                message.txPacket = $root.google.cloud.compute.v1.BfdPacket.fromObject(object.txPacket);
                            }
                            if (object.uptimeMs != null)
                                if ($util.Long)
                                    (message.uptimeMs = $util.Long.fromValue(object.uptimeMs)).unsigned = false;
                                else if (typeof object.uptimeMs === "string")
                                    message.uptimeMs = parseInt(object.uptimeMs, 10);
                                else if (typeof object.uptimeMs === "number")
                                    message.uptimeMs = object.uptimeMs;
                                else if (typeof object.uptimeMs === "object")
                                    message.uptimeMs = new $util.LongBits(object.uptimeMs.low >>> 0, object.uptimeMs.high >>> 0).toNumber();
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BfdStatus message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @static
                         * @param {google.cloud.compute.v1.BfdStatus} message BfdStatus
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BfdStatus.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.controlPacketIntervals = [];
                            if (message.negotiatedLocalControlTxIntervalMs != null && message.hasOwnProperty("negotiatedLocalControlTxIntervalMs")) {
                                object.negotiatedLocalControlTxIntervalMs = message.negotiatedLocalControlTxIntervalMs;
                                if (options.oneofs)
                                    object._negotiatedLocalControlTxIntervalMs = "negotiatedLocalControlTxIntervalMs";
                            }
                            if (message.txPacket != null && message.hasOwnProperty("txPacket")) {
                                object.txPacket = $root.google.cloud.compute.v1.BfdPacket.toObject(message.txPacket, options);
                                if (options.oneofs)
                                    object._txPacket = "txPacket";
                            }
                            if (message.uptimeMs != null && message.hasOwnProperty("uptimeMs")) {
                                if (typeof message.uptimeMs === "number")
                                    object.uptimeMs = options.longs === String ? String(message.uptimeMs) : message.uptimeMs;
                                else
                                    object.uptimeMs = options.longs === String ? $util.Long.prototype.toString.call(message.uptimeMs) : options.longs === Number ? new $util.LongBits(message.uptimeMs.low >>> 0, message.uptimeMs.high >>> 0).toNumber() : message.uptimeMs;
                                if (options.oneofs)
                                    object._uptimeMs = "uptimeMs";
                            }
                            if (message.controlPacketCounts != null && message.hasOwnProperty("controlPacketCounts")) {
                                object.controlPacketCounts = $root.google.cloud.compute.v1.BfdStatusPacketCounts.toObject(message.controlPacketCounts, options);
                                if (options.oneofs)
                                    object._controlPacketCounts = "controlPacketCounts";
                            }
                            if (message.localState != null && message.hasOwnProperty("localState")) {
                                object.localState = message.localState;
                                if (options.oneofs)
                                    object._localState = "localState";
                            }
                            if (message.bfdSessionInitializationMode != null && message.hasOwnProperty("bfdSessionInitializationMode")) {
                                object.bfdSessionInitializationMode = message.bfdSessionInitializationMode;
                                if (options.oneofs)
                                    object._bfdSessionInitializationMode = "bfdSessionInitializationMode";
                            }
                            if (message.configUpdateTimestampMicros != null && message.hasOwnProperty("configUpdateTimestampMicros")) {
                                if (typeof message.configUpdateTimestampMicros === "number")
                                    object.configUpdateTimestampMicros = options.longs === String ? String(message.configUpdateTimestampMicros) : message.configUpdateTimestampMicros;
                                else
                                    object.configUpdateTimestampMicros = options.longs === String ? $util.Long.prototype.toString.call(message.configUpdateTimestampMicros) : options.longs === Number ? new $util.LongBits(message.configUpdateTimestampMicros.low >>> 0, message.configUpdateTimestampMicros.high >>> 0).toNumber() : message.configUpdateTimestampMicros;
                                if (options.oneofs)
                                    object._configUpdateTimestampMicros = "configUpdateTimestampMicros";
                            }
                            if (message.localDiagnostic != null && message.hasOwnProperty("localDiagnostic")) {
                                object.localDiagnostic = message.localDiagnostic;
                                if (options.oneofs)
                                    object._localDiagnostic = "localDiagnostic";
                            }
                            if (message.controlPacketIntervals && message.controlPacketIntervals.length) {
                                object.controlPacketIntervals = [];
                                for (var j = 0; j < message.controlPacketIntervals.length; ++j)
                                    object.controlPacketIntervals[j] = $root.google.cloud.compute.v1.PacketIntervals.toObject(message.controlPacketIntervals[j], options);
                            }
                            if (message.rxPacket != null && message.hasOwnProperty("rxPacket")) {
                                object.rxPacket = $root.google.cloud.compute.v1.BfdPacket.toObject(message.rxPacket, options);
                                if (options.oneofs)
                                    object._rxPacket = "rxPacket";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BfdStatus to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BfdStatus.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BfdStatus
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BfdStatus
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BfdStatus.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BfdStatus";
                        };
    
                        /**
                         * BfdSessionInitializationMode enum.
                         * @name google.cloud.compute.v1.BfdStatus.BfdSessionInitializationMode
                         * @enum {number}
                         * @property {number} UNDEFINED_BFD_SESSION_INITIALIZATION_MODE=0 UNDEFINED_BFD_SESSION_INITIALIZATION_MODE value
                         * @property {number} ACTIVE=314733318 ACTIVE value
                         * @property {number} DISABLED=516696700 DISABLED value
                         * @property {number} PASSIVE=462813959 PASSIVE value
                         */
                        BfdStatus.BfdSessionInitializationMode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_BFD_SESSION_INITIALIZATION_MODE"] = 0;
                            values[valuesById[314733318] = "ACTIVE"] = 314733318;
                            values[valuesById[516696700] = "DISABLED"] = 516696700;
                            values[valuesById[462813959] = "PASSIVE"] = 462813959;
                            return values;
                        })();
    
                        /**
                         * LocalDiagnostic enum.
                         * @name google.cloud.compute.v1.BfdStatus.LocalDiagnostic
                         * @enum {number}
                         * @property {number} UNDEFINED_LOCAL_DIAGNOSTIC=0 UNDEFINED_LOCAL_DIAGNOSTIC value
                         * @property {number} ADMINISTRATIVELY_DOWN=121685798 ADMINISTRATIVELY_DOWN value
                         * @property {number} CONCATENATED_PATH_DOWN=26186892 CONCATENATED_PATH_DOWN value
                         * @property {number} CONTROL_DETECTION_TIME_EXPIRED=135478383 CONTROL_DETECTION_TIME_EXPIRED value
                         * @property {number} DIAGNOSTIC_UNSPECIFIED=58720895 DIAGNOSTIC_UNSPECIFIED value
                         * @property {number} ECHO_FUNCTION_FAILED=220687466 ECHO_FUNCTION_FAILED value
                         * @property {number} FORWARDING_PLANE_RESET=19715882 FORWARDING_PLANE_RESET value
                         * @property {number} NEIGHBOR_SIGNALED_SESSION_DOWN=374226742 NEIGHBOR_SIGNALED_SESSION_DOWN value
                         * @property {number} NO_DIAGNOSTIC=222503141 NO_DIAGNOSTIC value
                         * @property {number} PATH_DOWN=290605180 PATH_DOWN value
                         * @property {number} REVERSE_CONCATENATED_PATH_DOWN=479337129 REVERSE_CONCATENATED_PATH_DOWN value
                         */
                        BfdStatus.LocalDiagnostic = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_LOCAL_DIAGNOSTIC"] = 0;
                            values[valuesById[121685798] = "ADMINISTRATIVELY_DOWN"] = 121685798;
                            values[valuesById[26186892] = "CONCATENATED_PATH_DOWN"] = 26186892;
                            values[valuesById[135478383] = "CONTROL_DETECTION_TIME_EXPIRED"] = 135478383;
                            values[valuesById[58720895] = "DIAGNOSTIC_UNSPECIFIED"] = 58720895;
                            values[valuesById[220687466] = "ECHO_FUNCTION_FAILED"] = 220687466;
                            values[valuesById[19715882] = "FORWARDING_PLANE_RESET"] = 19715882;
                            values[valuesById[374226742] = "NEIGHBOR_SIGNALED_SESSION_DOWN"] = 374226742;
                            values[valuesById[222503141] = "NO_DIAGNOSTIC"] = 222503141;
                            values[valuesById[290605180] = "PATH_DOWN"] = 290605180;
                            values[valuesById[479337129] = "REVERSE_CONCATENATED_PATH_DOWN"] = 479337129;
                            return values;
                        })();
    
                        /**
                         * LocalState enum.
                         * @name google.cloud.compute.v1.BfdStatus.LocalState
                         * @enum {number}
                         * @property {number} UNDEFINED_LOCAL_STATE=0 UNDEFINED_LOCAL_STATE value
                         * @property {number} ADMIN_DOWN=128544690 ADMIN_DOWN value
                         * @property {number} DOWN=2104482 DOWN value
                         * @property {number} INIT=2252048 INIT value
                         * @property {number} STATE_UNSPECIFIED=470755401 STATE_UNSPECIFIED value
                         * @property {number} UP=2715 UP value
                         */
                        BfdStatus.LocalState = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_LOCAL_STATE"] = 0;
                            values[valuesById[128544690] = "ADMIN_DOWN"] = 128544690;
                            values[valuesById[2104482] = "DOWN"] = 2104482;
                            values[valuesById[2252048] = "INIT"] = 2252048;
                            values[valuesById[470755401] = "STATE_UNSPECIFIED"] = 470755401;
                            values[valuesById[2715] = "UP"] = 2715;
                            return values;
                        })();
    
                        return BfdStatus;
                    })();
    
                    v1.BfdStatusPacketCounts = (function() {
    
                        /**
                         * Properties of a BfdStatusPacketCounts.
                         * @memberof google.cloud.compute.v1
                         * @interface IBfdStatusPacketCounts
                         * @property {number|null} [numRx] BfdStatusPacketCounts numRx
                         * @property {number|null} [numRxRejected] BfdStatusPacketCounts numRxRejected
                         * @property {number|null} [numRxSuccessful] BfdStatusPacketCounts numRxSuccessful
                         * @property {number|null} [numTx] BfdStatusPacketCounts numTx
                         */
    
                        /**
                         * Constructs a new BfdStatusPacketCounts.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BfdStatusPacketCounts.
                         * @implements IBfdStatusPacketCounts
                         * @constructor
                         * @param {google.cloud.compute.v1.IBfdStatusPacketCounts=} [properties] Properties to set
                         */
                        function BfdStatusPacketCounts(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BfdStatusPacketCounts numRx.
                         * @member {number|null|undefined} numRx
                         * @memberof google.cloud.compute.v1.BfdStatusPacketCounts
                         * @instance
                         */
                        BfdStatusPacketCounts.prototype.numRx = null;
    
                        /**
                         * BfdStatusPacketCounts numRxRejected.
                         * @member {number|null|undefined} numRxRejected
                         * @memberof google.cloud.compute.v1.BfdStatusPacketCounts
                         * @instance
                         */
                        BfdStatusPacketCounts.prototype.numRxRejected = null;
    
                        /**
                         * BfdStatusPacketCounts numRxSuccessful.
                         * @member {number|null|undefined} numRxSuccessful
                         * @memberof google.cloud.compute.v1.BfdStatusPacketCounts
                         * @instance
                         */
                        BfdStatusPacketCounts.prototype.numRxSuccessful = null;
    
                        /**
                         * BfdStatusPacketCounts numTx.
                         * @member {number|null|undefined} numTx
                         * @memberof google.cloud.compute.v1.BfdStatusPacketCounts
                         * @instance
                         */
                        BfdStatusPacketCounts.prototype.numTx = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BfdStatusPacketCounts _numRx.
                         * @member {"numRx"|undefined} _numRx
                         * @memberof google.cloud.compute.v1.BfdStatusPacketCounts
                         * @instance
                         */
                        Object.defineProperty(BfdStatusPacketCounts.prototype, "_numRx", {
                            get: $util.oneOfGetter($oneOfFields = ["numRx"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdStatusPacketCounts _numRxRejected.
                         * @member {"numRxRejected"|undefined} _numRxRejected
                         * @memberof google.cloud.compute.v1.BfdStatusPacketCounts
                         * @instance
                         */
                        Object.defineProperty(BfdStatusPacketCounts.prototype, "_numRxRejected", {
                            get: $util.oneOfGetter($oneOfFields = ["numRxRejected"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdStatusPacketCounts _numRxSuccessful.
                         * @member {"numRxSuccessful"|undefined} _numRxSuccessful
                         * @memberof google.cloud.compute.v1.BfdStatusPacketCounts
                         * @instance
                         */
                        Object.defineProperty(BfdStatusPacketCounts.prototype, "_numRxSuccessful", {
                            get: $util.oneOfGetter($oneOfFields = ["numRxSuccessful"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BfdStatusPacketCounts _numTx.
                         * @member {"numTx"|undefined} _numTx
                         * @memberof google.cloud.compute.v1.BfdStatusPacketCounts
                         * @instance
                         */
                        Object.defineProperty(BfdStatusPacketCounts.prototype, "_numTx", {
                            get: $util.oneOfGetter($oneOfFields = ["numTx"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BfdStatusPacketCounts instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BfdStatusPacketCounts
                         * @static
                         * @param {google.cloud.compute.v1.IBfdStatusPacketCounts=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BfdStatusPacketCounts} BfdStatusPacketCounts instance
                         */
                        BfdStatusPacketCounts.create = function create(properties) {
                            return new BfdStatusPacketCounts(properties);
                        };
    
                        /**
                         * Encodes the specified BfdStatusPacketCounts message. Does not implicitly {@link google.cloud.compute.v1.BfdStatusPacketCounts.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BfdStatusPacketCounts
                         * @static
                         * @param {google.cloud.compute.v1.IBfdStatusPacketCounts} message BfdStatusPacketCounts message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BfdStatusPacketCounts.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.numRx != null && Object.hasOwnProperty.call(message, "numRx"))
                                writer.uint32(/* id 39375263, wireType 0 =*/315002104).uint32(message.numRx);
                            if (message.numTx != null && Object.hasOwnProperty.call(message, "numTx"))
                                writer.uint32(/* id 39375325, wireType 0 =*/315002600).uint32(message.numTx);
                            if (message.numRxRejected != null && Object.hasOwnProperty.call(message, "numRxRejected"))
                                writer.uint32(/* id 281007902, wireType 0 =*/2248063216).uint32(message.numRxRejected);
                            if (message.numRxSuccessful != null && Object.hasOwnProperty.call(message, "numRxSuccessful"))
                                writer.uint32(/* id 455361850, wireType 0 =*/3642894800).uint32(message.numRxSuccessful);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BfdStatusPacketCounts message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BfdStatusPacketCounts.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BfdStatusPacketCounts
                         * @static
                         * @param {google.cloud.compute.v1.IBfdStatusPacketCounts} message BfdStatusPacketCounts message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BfdStatusPacketCounts.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BfdStatusPacketCounts message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BfdStatusPacketCounts
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BfdStatusPacketCounts} BfdStatusPacketCounts
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BfdStatusPacketCounts.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BfdStatusPacketCounts();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 39375263: {
                                        message.numRx = reader.uint32();
                                        break;
                                    }
                                case 281007902: {
                                        message.numRxRejected = reader.uint32();
                                        break;
                                    }
                                case 455361850: {
                                        message.numRxSuccessful = reader.uint32();
                                        break;
                                    }
                                case 39375325: {
                                        message.numTx = reader.uint32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BfdStatusPacketCounts message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BfdStatusPacketCounts
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BfdStatusPacketCounts} BfdStatusPacketCounts
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BfdStatusPacketCounts.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BfdStatusPacketCounts message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BfdStatusPacketCounts
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BfdStatusPacketCounts.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.numRx != null && message.hasOwnProperty("numRx")) {
                                properties._numRx = 1;
                                if (!$util.isInteger(message.numRx))
                                    return "numRx: integer expected";
                            }
                            if (message.numRxRejected != null && message.hasOwnProperty("numRxRejected")) {
                                properties._numRxRejected = 1;
                                if (!$util.isInteger(message.numRxRejected))
                                    return "numRxRejected: integer expected";
                            }
                            if (message.numRxSuccessful != null && message.hasOwnProperty("numRxSuccessful")) {
                                properties._numRxSuccessful = 1;
                                if (!$util.isInteger(message.numRxSuccessful))
                                    return "numRxSuccessful: integer expected";
                            }
                            if (message.numTx != null && message.hasOwnProperty("numTx")) {
                                properties._numTx = 1;
                                if (!$util.isInteger(message.numTx))
                                    return "numTx: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BfdStatusPacketCounts message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BfdStatusPacketCounts
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BfdStatusPacketCounts} BfdStatusPacketCounts
                         */
                        BfdStatusPacketCounts.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BfdStatusPacketCounts)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BfdStatusPacketCounts();
                            if (object.numRx != null)
                                message.numRx = object.numRx >>> 0;
                            if (object.numRxRejected != null)
                                message.numRxRejected = object.numRxRejected >>> 0;
                            if (object.numRxSuccessful != null)
                                message.numRxSuccessful = object.numRxSuccessful >>> 0;
                            if (object.numTx != null)
                                message.numTx = object.numTx >>> 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BfdStatusPacketCounts message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BfdStatusPacketCounts
                         * @static
                         * @param {google.cloud.compute.v1.BfdStatusPacketCounts} message BfdStatusPacketCounts
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BfdStatusPacketCounts.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.numRx != null && message.hasOwnProperty("numRx")) {
                                object.numRx = message.numRx;
                                if (options.oneofs)
                                    object._numRx = "numRx";
                            }
                            if (message.numTx != null && message.hasOwnProperty("numTx")) {
                                object.numTx = message.numTx;
                                if (options.oneofs)
                                    object._numTx = "numTx";
                            }
                            if (message.numRxRejected != null && message.hasOwnProperty("numRxRejected")) {
                                object.numRxRejected = message.numRxRejected;
                                if (options.oneofs)
                                    object._numRxRejected = "numRxRejected";
                            }
                            if (message.numRxSuccessful != null && message.hasOwnProperty("numRxSuccessful")) {
                                object.numRxSuccessful = message.numRxSuccessful;
                                if (options.oneofs)
                                    object._numRxSuccessful = "numRxSuccessful";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BfdStatusPacketCounts to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BfdStatusPacketCounts
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BfdStatusPacketCounts.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BfdStatusPacketCounts
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BfdStatusPacketCounts
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BfdStatusPacketCounts.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BfdStatusPacketCounts";
                        };
    
                        return BfdStatusPacketCounts;
                    })();
    
                    v1.Binding = (function() {
    
                        /**
                         * Properties of a Binding.
                         * @memberof google.cloud.compute.v1
                         * @interface IBinding
                         * @property {string|null} [bindingId] Binding bindingId
                         * @property {google.cloud.compute.v1.IExpr|null} [condition] Binding condition
                         * @property {Array.<string>|null} [members] Binding members
                         * @property {string|null} [role] Binding role
                         */
    
                        /**
                         * Constructs a new Binding.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Binding.
                         * @implements IBinding
                         * @constructor
                         * @param {google.cloud.compute.v1.IBinding=} [properties] Properties to set
                         */
                        function Binding(properties) {
                            this.members = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Binding bindingId.
                         * @member {string|null|undefined} bindingId
                         * @memberof google.cloud.compute.v1.Binding
                         * @instance
                         */
                        Binding.prototype.bindingId = null;
    
                        /**
                         * Binding condition.
                         * @member {google.cloud.compute.v1.IExpr|null|undefined} condition
                         * @memberof google.cloud.compute.v1.Binding
                         * @instance
                         */
                        Binding.prototype.condition = null;
    
                        /**
                         * Binding members.
                         * @member {Array.<string>} members
                         * @memberof google.cloud.compute.v1.Binding
                         * @instance
                         */
                        Binding.prototype.members = $util.emptyArray;
    
                        /**
                         * Binding role.
                         * @member {string|null|undefined} role
                         * @memberof google.cloud.compute.v1.Binding
                         * @instance
                         */
                        Binding.prototype.role = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Binding _bindingId.
                         * @member {"bindingId"|undefined} _bindingId
                         * @memberof google.cloud.compute.v1.Binding
                         * @instance
                         */
                        Object.defineProperty(Binding.prototype, "_bindingId", {
                            get: $util.oneOfGetter($oneOfFields = ["bindingId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Binding _condition.
                         * @member {"condition"|undefined} _condition
                         * @memberof google.cloud.compute.v1.Binding
                         * @instance
                         */
                        Object.defineProperty(Binding.prototype, "_condition", {
                            get: $util.oneOfGetter($oneOfFields = ["condition"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Binding _role.
                         * @member {"role"|undefined} _role
                         * @memberof google.cloud.compute.v1.Binding
                         * @instance
                         */
                        Object.defineProperty(Binding.prototype, "_role", {
                            get: $util.oneOfGetter($oneOfFields = ["role"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Binding instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Binding
                         * @static
                         * @param {google.cloud.compute.v1.IBinding=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Binding} Binding instance
                         */
                        Binding.create = function create(properties) {
                            return new Binding(properties);
                        };
    
                        /**
                         * Encodes the specified Binding message. Does not implicitly {@link google.cloud.compute.v1.Binding.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Binding
                         * @static
                         * @param {google.cloud.compute.v1.IBinding} message Binding message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Binding.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.role != null && Object.hasOwnProperty.call(message, "role"))
                                writer.uint32(/* id 3506294, wireType 2 =*/28050354).string(message.role);
                            if (message.condition != null && Object.hasOwnProperty.call(message, "condition"))
                                $root.google.cloud.compute.v1.Expr.encode(message.condition, writer.uint32(/* id 212430107, wireType 2 =*/1699440858).fork()).ldelim();
                            if (message.members != null && message.members.length)
                                for (var i = 0; i < message.members.length; ++i)
                                    writer.uint32(/* id 412010777, wireType 2 =*/3296086218).string(message.members[i]);
                            if (message.bindingId != null && Object.hasOwnProperty.call(message, "bindingId"))
                                writer.uint32(/* id 441088277, wireType 2 =*/3528706218).string(message.bindingId);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Binding message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Binding.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Binding
                         * @static
                         * @param {google.cloud.compute.v1.IBinding} message Binding message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Binding.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Binding message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Binding
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Binding} Binding
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Binding.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Binding();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 441088277: {
                                        message.bindingId = reader.string();
                                        break;
                                    }
                                case 212430107: {
                                        message.condition = $root.google.cloud.compute.v1.Expr.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 412010777: {
                                        if (!(message.members && message.members.length))
                                            message.members = [];
                                        message.members.push(reader.string());
                                        break;
                                    }
                                case 3506294: {
                                        message.role = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Binding message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Binding
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Binding} Binding
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Binding.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Binding message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Binding
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Binding.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.bindingId != null && message.hasOwnProperty("bindingId")) {
                                properties._bindingId = 1;
                                if (!$util.isString(message.bindingId))
                                    return "bindingId: string expected";
                            }
                            if (message.condition != null && message.hasOwnProperty("condition")) {
                                properties._condition = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Expr.verify(message.condition);
                                    if (error)
                                        return "condition." + error;
                                }
                            }
                            if (message.members != null && message.hasOwnProperty("members")) {
                                if (!Array.isArray(message.members))
                                    return "members: array expected";
                                for (var i = 0; i < message.members.length; ++i)
                                    if (!$util.isString(message.members[i]))
                                        return "members: string[] expected";
                            }
                            if (message.role != null && message.hasOwnProperty("role")) {
                                properties._role = 1;
                                if (!$util.isString(message.role))
                                    return "role: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Binding message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Binding
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Binding} Binding
                         */
                        Binding.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Binding)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Binding();
                            if (object.bindingId != null)
                                message.bindingId = String(object.bindingId);
                            if (object.condition != null) {
                                if (typeof object.condition !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Binding.condition: object expected");
                                message.condition = $root.google.cloud.compute.v1.Expr.fromObject(object.condition);
                            }
                            if (object.members) {
                                if (!Array.isArray(object.members))
                                    throw TypeError(".google.cloud.compute.v1.Binding.members: array expected");
                                message.members = [];
                                for (var i = 0; i < object.members.length; ++i)
                                    message.members[i] = String(object.members[i]);
                            }
                            if (object.role != null)
                                message.role = String(object.role);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Binding message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Binding
                         * @static
                         * @param {google.cloud.compute.v1.Binding} message Binding
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Binding.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.members = [];
                            if (message.role != null && message.hasOwnProperty("role")) {
                                object.role = message.role;
                                if (options.oneofs)
                                    object._role = "role";
                            }
                            if (message.condition != null && message.hasOwnProperty("condition")) {
                                object.condition = $root.google.cloud.compute.v1.Expr.toObject(message.condition, options);
                                if (options.oneofs)
                                    object._condition = "condition";
                            }
                            if (message.members && message.members.length) {
                                object.members = [];
                                for (var j = 0; j < message.members.length; ++j)
                                    object.members[j] = message.members[j];
                            }
                            if (message.bindingId != null && message.hasOwnProperty("bindingId")) {
                                object.bindingId = message.bindingId;
                                if (options.oneofs)
                                    object._bindingId = "bindingId";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Binding to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Binding
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Binding.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Binding
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Binding
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Binding.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Binding";
                        };
    
                        return Binding;
                    })();
    
                    v1.BulkInsertInstanceRequest = (function() {
    
                        /**
                         * Properties of a BulkInsertInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IBulkInsertInstanceRequest
                         * @property {google.cloud.compute.v1.IBulkInsertInstanceResource|null} [bulkInsertInstanceResourceResource] BulkInsertInstanceRequest bulkInsertInstanceResourceResource
                         * @property {string|null} [project] BulkInsertInstanceRequest project
                         * @property {string|null} [requestId] BulkInsertInstanceRequest requestId
                         * @property {string|null} [zone] BulkInsertInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new BulkInsertInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BulkInsertInstanceRequest.
                         * @implements IBulkInsertInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IBulkInsertInstanceRequest=} [properties] Properties to set
                         */
                        function BulkInsertInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BulkInsertInstanceRequest bulkInsertInstanceResourceResource.
                         * @member {google.cloud.compute.v1.IBulkInsertInstanceResource|null|undefined} bulkInsertInstanceResourceResource
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceRequest
                         * @instance
                         */
                        BulkInsertInstanceRequest.prototype.bulkInsertInstanceResourceResource = null;
    
                        /**
                         * BulkInsertInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceRequest
                         * @instance
                         */
                        BulkInsertInstanceRequest.prototype.project = "";
    
                        /**
                         * BulkInsertInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceRequest
                         * @instance
                         */
                        BulkInsertInstanceRequest.prototype.requestId = null;
    
                        /**
                         * BulkInsertInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceRequest
                         * @instance
                         */
                        BulkInsertInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BulkInsertInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(BulkInsertInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BulkInsertInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IBulkInsertInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BulkInsertInstanceRequest} BulkInsertInstanceRequest instance
                         */
                        BulkInsertInstanceRequest.create = function create(properties) {
                            return new BulkInsertInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified BulkInsertInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.BulkInsertInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IBulkInsertInstanceRequest} message BulkInsertInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BulkInsertInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.bulkInsertInstanceResourceResource != null && Object.hasOwnProperty.call(message, "bulkInsertInstanceResourceResource"))
                                $root.google.cloud.compute.v1.BulkInsertInstanceResource.encode(message.bulkInsertInstanceResourceResource, writer.uint32(/* id 41427278, wireType 2 =*/331418226).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BulkInsertInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BulkInsertInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IBulkInsertInstanceRequest} message BulkInsertInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BulkInsertInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BulkInsertInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BulkInsertInstanceRequest} BulkInsertInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BulkInsertInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BulkInsertInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 41427278: {
                                        message.bulkInsertInstanceResourceResource = $root.google.cloud.compute.v1.BulkInsertInstanceResource.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BulkInsertInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BulkInsertInstanceRequest} BulkInsertInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BulkInsertInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BulkInsertInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BulkInsertInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.bulkInsertInstanceResourceResource != null && message.hasOwnProperty("bulkInsertInstanceResourceResource")) {
                                var error = $root.google.cloud.compute.v1.BulkInsertInstanceResource.verify(message.bulkInsertInstanceResourceResource);
                                if (error)
                                    return "bulkInsertInstanceResourceResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a BulkInsertInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BulkInsertInstanceRequest} BulkInsertInstanceRequest
                         */
                        BulkInsertInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BulkInsertInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BulkInsertInstanceRequest();
                            if (object.bulkInsertInstanceResourceResource != null) {
                                if (typeof object.bulkInsertInstanceResourceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BulkInsertInstanceRequest.bulkInsertInstanceResourceResource: object expected");
                                message.bulkInsertInstanceResourceResource = $root.google.cloud.compute.v1.BulkInsertInstanceResource.fromObject(object.bulkInsertInstanceResourceResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BulkInsertInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.BulkInsertInstanceRequest} message BulkInsertInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BulkInsertInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.bulkInsertInstanceResourceResource = null;
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.bulkInsertInstanceResourceResource != null && message.hasOwnProperty("bulkInsertInstanceResourceResource"))
                                object.bulkInsertInstanceResourceResource = $root.google.cloud.compute.v1.BulkInsertInstanceResource.toObject(message.bulkInsertInstanceResourceResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this BulkInsertInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BulkInsertInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BulkInsertInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BulkInsertInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BulkInsertInstanceRequest";
                        };
    
                        return BulkInsertInstanceRequest;
                    })();
    
                    v1.BulkInsertInstanceResource = (function() {
    
                        /**
                         * Properties of a BulkInsertInstanceResource.
                         * @memberof google.cloud.compute.v1
                         * @interface IBulkInsertInstanceResource
                         * @property {number|Long|null} [count] BulkInsertInstanceResource count
                         * @property {google.cloud.compute.v1.IInstanceProperties|null} [instanceProperties] BulkInsertInstanceResource instanceProperties
                         * @property {google.cloud.compute.v1.ILocationPolicy|null} [locationPolicy] BulkInsertInstanceResource locationPolicy
                         * @property {number|Long|null} [minCount] BulkInsertInstanceResource minCount
                         * @property {string|null} [namePattern] BulkInsertInstanceResource namePattern
                         * @property {Object.<string,google.cloud.compute.v1.IBulkInsertInstanceResourcePerInstanceProperties>|null} [perInstanceProperties] BulkInsertInstanceResource perInstanceProperties
                         * @property {string|null} [sourceInstanceTemplate] BulkInsertInstanceResource sourceInstanceTemplate
                         */
    
                        /**
                         * Constructs a new BulkInsertInstanceResource.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BulkInsertInstanceResource.
                         * @implements IBulkInsertInstanceResource
                         * @constructor
                         * @param {google.cloud.compute.v1.IBulkInsertInstanceResource=} [properties] Properties to set
                         */
                        function BulkInsertInstanceResource(properties) {
                            this.perInstanceProperties = {};
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BulkInsertInstanceResource count.
                         * @member {number|Long|null|undefined} count
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @instance
                         */
                        BulkInsertInstanceResource.prototype.count = null;
    
                        /**
                         * BulkInsertInstanceResource instanceProperties.
                         * @member {google.cloud.compute.v1.IInstanceProperties|null|undefined} instanceProperties
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @instance
                         */
                        BulkInsertInstanceResource.prototype.instanceProperties = null;
    
                        /**
                         * BulkInsertInstanceResource locationPolicy.
                         * @member {google.cloud.compute.v1.ILocationPolicy|null|undefined} locationPolicy
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @instance
                         */
                        BulkInsertInstanceResource.prototype.locationPolicy = null;
    
                        /**
                         * BulkInsertInstanceResource minCount.
                         * @member {number|Long|null|undefined} minCount
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @instance
                         */
                        BulkInsertInstanceResource.prototype.minCount = null;
    
                        /**
                         * BulkInsertInstanceResource namePattern.
                         * @member {string|null|undefined} namePattern
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @instance
                         */
                        BulkInsertInstanceResource.prototype.namePattern = null;
    
                        /**
                         * BulkInsertInstanceResource perInstanceProperties.
                         * @member {Object.<string,google.cloud.compute.v1.IBulkInsertInstanceResourcePerInstanceProperties>} perInstanceProperties
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @instance
                         */
                        BulkInsertInstanceResource.prototype.perInstanceProperties = $util.emptyObject;
    
                        /**
                         * BulkInsertInstanceResource sourceInstanceTemplate.
                         * @member {string|null|undefined} sourceInstanceTemplate
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @instance
                         */
                        BulkInsertInstanceResource.prototype.sourceInstanceTemplate = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BulkInsertInstanceResource _count.
                         * @member {"count"|undefined} _count
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @instance
                         */
                        Object.defineProperty(BulkInsertInstanceResource.prototype, "_count", {
                            get: $util.oneOfGetter($oneOfFields = ["count"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BulkInsertInstanceResource _instanceProperties.
                         * @member {"instanceProperties"|undefined} _instanceProperties
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @instance
                         */
                        Object.defineProperty(BulkInsertInstanceResource.prototype, "_instanceProperties", {
                            get: $util.oneOfGetter($oneOfFields = ["instanceProperties"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BulkInsertInstanceResource _locationPolicy.
                         * @member {"locationPolicy"|undefined} _locationPolicy
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @instance
                         */
                        Object.defineProperty(BulkInsertInstanceResource.prototype, "_locationPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["locationPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BulkInsertInstanceResource _minCount.
                         * @member {"minCount"|undefined} _minCount
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @instance
                         */
                        Object.defineProperty(BulkInsertInstanceResource.prototype, "_minCount", {
                            get: $util.oneOfGetter($oneOfFields = ["minCount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BulkInsertInstanceResource _namePattern.
                         * @member {"namePattern"|undefined} _namePattern
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @instance
                         */
                        Object.defineProperty(BulkInsertInstanceResource.prototype, "_namePattern", {
                            get: $util.oneOfGetter($oneOfFields = ["namePattern"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * BulkInsertInstanceResource _sourceInstanceTemplate.
                         * @member {"sourceInstanceTemplate"|undefined} _sourceInstanceTemplate
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @instance
                         */
                        Object.defineProperty(BulkInsertInstanceResource.prototype, "_sourceInstanceTemplate", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceInstanceTemplate"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BulkInsertInstanceResource instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @static
                         * @param {google.cloud.compute.v1.IBulkInsertInstanceResource=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BulkInsertInstanceResource} BulkInsertInstanceResource instance
                         */
                        BulkInsertInstanceResource.create = function create(properties) {
                            return new BulkInsertInstanceResource(properties);
                        };
    
                        /**
                         * Encodes the specified BulkInsertInstanceResource message. Does not implicitly {@link google.cloud.compute.v1.BulkInsertInstanceResource.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @static
                         * @param {google.cloud.compute.v1.IBulkInsertInstanceResource} message BulkInsertInstanceResource message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BulkInsertInstanceResource.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.count != null && Object.hasOwnProperty.call(message, "count"))
                                writer.uint32(/* id 94851343, wireType 0 =*/758810744).int64(message.count);
                            if (message.perInstanceProperties != null && Object.hasOwnProperty.call(message, "perInstanceProperties"))
                                for (var keys = Object.keys(message.perInstanceProperties), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 108502267, wireType 2 =*/868018138).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties.encode(message.perInstanceProperties[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.instanceProperties != null && Object.hasOwnProperty.call(message, "instanceProperties"))
                                $root.google.cloud.compute.v1.InstanceProperties.encode(message.instanceProperties, writer.uint32(/* id 215355165, wireType 2 =*/1722841322).fork()).ldelim();
                            if (message.sourceInstanceTemplate != null && Object.hasOwnProperty.call(message, "sourceInstanceTemplate"))
                                writer.uint32(/* id 332423616, wireType 2 =*/2659388930).string(message.sourceInstanceTemplate);
                            if (message.namePattern != null && Object.hasOwnProperty.call(message, "namePattern"))
                                writer.uint32(/* id 413815260, wireType 2 =*/3310522082).string(message.namePattern);
                            if (message.locationPolicy != null && Object.hasOwnProperty.call(message, "locationPolicy"))
                                $root.google.cloud.compute.v1.LocationPolicy.encode(message.locationPolicy, writer.uint32(/* id 465689852, wireType 2 =*/3725518818).fork()).ldelim();
                            if (message.minCount != null && Object.hasOwnProperty.call(message, "minCount"))
                                writer.uint32(/* id 523228386, wireType 0 =*/4185827088).int64(message.minCount);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BulkInsertInstanceResource message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BulkInsertInstanceResource.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @static
                         * @param {google.cloud.compute.v1.IBulkInsertInstanceResource} message BulkInsertInstanceResource message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BulkInsertInstanceResource.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BulkInsertInstanceResource message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BulkInsertInstanceResource} BulkInsertInstanceResource
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BulkInsertInstanceResource.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BulkInsertInstanceResource(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 94851343: {
                                        message.count = reader.int64();
                                        break;
                                    }
                                case 215355165: {
                                        message.instanceProperties = $root.google.cloud.compute.v1.InstanceProperties.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 465689852: {
                                        message.locationPolicy = $root.google.cloud.compute.v1.LocationPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 523228386: {
                                        message.minCount = reader.int64();
                                        break;
                                    }
                                case 413815260: {
                                        message.namePattern = reader.string();
                                        break;
                                    }
                                case 108502267: {
                                        if (message.perInstanceProperties === $util.emptyObject)
                                            message.perInstanceProperties = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.perInstanceProperties[key] = value;
                                        break;
                                    }
                                case 332423616: {
                                        message.sourceInstanceTemplate = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BulkInsertInstanceResource message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BulkInsertInstanceResource} BulkInsertInstanceResource
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BulkInsertInstanceResource.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BulkInsertInstanceResource message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BulkInsertInstanceResource.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.count != null && message.hasOwnProperty("count")) {
                                properties._count = 1;
                                if (!$util.isInteger(message.count) && !(message.count && $util.isInteger(message.count.low) && $util.isInteger(message.count.high)))
                                    return "count: integer|Long expected";
                            }
                            if (message.instanceProperties != null && message.hasOwnProperty("instanceProperties")) {
                                properties._instanceProperties = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InstanceProperties.verify(message.instanceProperties);
                                    if (error)
                                        return "instanceProperties." + error;
                                }
                            }
                            if (message.locationPolicy != null && message.hasOwnProperty("locationPolicy")) {
                                properties._locationPolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.LocationPolicy.verify(message.locationPolicy);
                                    if (error)
                                        return "locationPolicy." + error;
                                }
                            }
                            if (message.minCount != null && message.hasOwnProperty("minCount")) {
                                properties._minCount = 1;
                                if (!$util.isInteger(message.minCount) && !(message.minCount && $util.isInteger(message.minCount.low) && $util.isInteger(message.minCount.high)))
                                    return "minCount: integer|Long expected";
                            }
                            if (message.namePattern != null && message.hasOwnProperty("namePattern")) {
                                properties._namePattern = 1;
                                if (!$util.isString(message.namePattern))
                                    return "namePattern: string expected";
                            }
                            if (message.perInstanceProperties != null && message.hasOwnProperty("perInstanceProperties")) {
                                if (!$util.isObject(message.perInstanceProperties))
                                    return "perInstanceProperties: object expected";
                                var key = Object.keys(message.perInstanceProperties);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties.verify(message.perInstanceProperties[key[i]]);
                                    if (error)
                                        return "perInstanceProperties." + error;
                                }
                            }
                            if (message.sourceInstanceTemplate != null && message.hasOwnProperty("sourceInstanceTemplate")) {
                                properties._sourceInstanceTemplate = 1;
                                if (!$util.isString(message.sourceInstanceTemplate))
                                    return "sourceInstanceTemplate: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BulkInsertInstanceResource message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BulkInsertInstanceResource} BulkInsertInstanceResource
                         */
                        BulkInsertInstanceResource.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BulkInsertInstanceResource)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BulkInsertInstanceResource();
                            if (object.count != null)
                                if ($util.Long)
                                    (message.count = $util.Long.fromValue(object.count)).unsigned = false;
                                else if (typeof object.count === "string")
                                    message.count = parseInt(object.count, 10);
                                else if (typeof object.count === "number")
                                    message.count = object.count;
                                else if (typeof object.count === "object")
                                    message.count = new $util.LongBits(object.count.low >>> 0, object.count.high >>> 0).toNumber();
                            if (object.instanceProperties != null) {
                                if (typeof object.instanceProperties !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BulkInsertInstanceResource.instanceProperties: object expected");
                                message.instanceProperties = $root.google.cloud.compute.v1.InstanceProperties.fromObject(object.instanceProperties);
                            }
                            if (object.locationPolicy != null) {
                                if (typeof object.locationPolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BulkInsertInstanceResource.locationPolicy: object expected");
                                message.locationPolicy = $root.google.cloud.compute.v1.LocationPolicy.fromObject(object.locationPolicy);
                            }
                            if (object.minCount != null)
                                if ($util.Long)
                                    (message.minCount = $util.Long.fromValue(object.minCount)).unsigned = false;
                                else if (typeof object.minCount === "string")
                                    message.minCount = parseInt(object.minCount, 10);
                                else if (typeof object.minCount === "number")
                                    message.minCount = object.minCount;
                                else if (typeof object.minCount === "object")
                                    message.minCount = new $util.LongBits(object.minCount.low >>> 0, object.minCount.high >>> 0).toNumber();
                            if (object.namePattern != null)
                                message.namePattern = String(object.namePattern);
                            if (object.perInstanceProperties) {
                                if (typeof object.perInstanceProperties !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BulkInsertInstanceResource.perInstanceProperties: object expected");
                                message.perInstanceProperties = {};
                                for (var keys = Object.keys(object.perInstanceProperties), i = 0; i < keys.length; ++i) {
                                    if (typeof object.perInstanceProperties[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.BulkInsertInstanceResource.perInstanceProperties: object expected");
                                    message.perInstanceProperties[keys[i]] = $root.google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties.fromObject(object.perInstanceProperties[keys[i]]);
                                }
                            }
                            if (object.sourceInstanceTemplate != null)
                                message.sourceInstanceTemplate = String(object.sourceInstanceTemplate);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BulkInsertInstanceResource message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @static
                         * @param {google.cloud.compute.v1.BulkInsertInstanceResource} message BulkInsertInstanceResource
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BulkInsertInstanceResource.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.objects || options.defaults)
                                object.perInstanceProperties = {};
                            if (message.count != null && message.hasOwnProperty("count")) {
                                if (typeof message.count === "number")
                                    object.count = options.longs === String ? String(message.count) : message.count;
                                else
                                    object.count = options.longs === String ? $util.Long.prototype.toString.call(message.count) : options.longs === Number ? new $util.LongBits(message.count.low >>> 0, message.count.high >>> 0).toNumber() : message.count;
                                if (options.oneofs)
                                    object._count = "count";
                            }
                            var keys2;
                            if (message.perInstanceProperties && (keys2 = Object.keys(message.perInstanceProperties)).length) {
                                object.perInstanceProperties = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.perInstanceProperties[keys2[j]] = $root.google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties.toObject(message.perInstanceProperties[keys2[j]], options);
                            }
                            if (message.instanceProperties != null && message.hasOwnProperty("instanceProperties")) {
                                object.instanceProperties = $root.google.cloud.compute.v1.InstanceProperties.toObject(message.instanceProperties, options);
                                if (options.oneofs)
                                    object._instanceProperties = "instanceProperties";
                            }
                            if (message.sourceInstanceTemplate != null && message.hasOwnProperty("sourceInstanceTemplate")) {
                                object.sourceInstanceTemplate = message.sourceInstanceTemplate;
                                if (options.oneofs)
                                    object._sourceInstanceTemplate = "sourceInstanceTemplate";
                            }
                            if (message.namePattern != null && message.hasOwnProperty("namePattern")) {
                                object.namePattern = message.namePattern;
                                if (options.oneofs)
                                    object._namePattern = "namePattern";
                            }
                            if (message.locationPolicy != null && message.hasOwnProperty("locationPolicy")) {
                                object.locationPolicy = $root.google.cloud.compute.v1.LocationPolicy.toObject(message.locationPolicy, options);
                                if (options.oneofs)
                                    object._locationPolicy = "locationPolicy";
                            }
                            if (message.minCount != null && message.hasOwnProperty("minCount")) {
                                if (typeof message.minCount === "number")
                                    object.minCount = options.longs === String ? String(message.minCount) : message.minCount;
                                else
                                    object.minCount = options.longs === String ? $util.Long.prototype.toString.call(message.minCount) : options.longs === Number ? new $util.LongBits(message.minCount.low >>> 0, message.minCount.high >>> 0).toNumber() : message.minCount;
                                if (options.oneofs)
                                    object._minCount = "minCount";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BulkInsertInstanceResource to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BulkInsertInstanceResource.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BulkInsertInstanceResource
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResource
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BulkInsertInstanceResource.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BulkInsertInstanceResource";
                        };
    
                        return BulkInsertInstanceResource;
                    })();
    
                    v1.BulkInsertInstanceResourcePerInstanceProperties = (function() {
    
                        /**
                         * Properties of a BulkInsertInstanceResourcePerInstanceProperties.
                         * @memberof google.cloud.compute.v1
                         * @interface IBulkInsertInstanceResourcePerInstanceProperties
                         * @property {string|null} [name] BulkInsertInstanceResourcePerInstanceProperties name
                         */
    
                        /**
                         * Constructs a new BulkInsertInstanceResourcePerInstanceProperties.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BulkInsertInstanceResourcePerInstanceProperties.
                         * @implements IBulkInsertInstanceResourcePerInstanceProperties
                         * @constructor
                         * @param {google.cloud.compute.v1.IBulkInsertInstanceResourcePerInstanceProperties=} [properties] Properties to set
                         */
                        function BulkInsertInstanceResourcePerInstanceProperties(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BulkInsertInstanceResourcePerInstanceProperties name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties
                         * @instance
                         */
                        BulkInsertInstanceResourcePerInstanceProperties.prototype.name = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BulkInsertInstanceResourcePerInstanceProperties _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties
                         * @instance
                         */
                        Object.defineProperty(BulkInsertInstanceResourcePerInstanceProperties.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BulkInsertInstanceResourcePerInstanceProperties instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties
                         * @static
                         * @param {google.cloud.compute.v1.IBulkInsertInstanceResourcePerInstanceProperties=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties} BulkInsertInstanceResourcePerInstanceProperties instance
                         */
                        BulkInsertInstanceResourcePerInstanceProperties.create = function create(properties) {
                            return new BulkInsertInstanceResourcePerInstanceProperties(properties);
                        };
    
                        /**
                         * Encodes the specified BulkInsertInstanceResourcePerInstanceProperties message. Does not implicitly {@link google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties
                         * @static
                         * @param {google.cloud.compute.v1.IBulkInsertInstanceResourcePerInstanceProperties} message BulkInsertInstanceResourcePerInstanceProperties message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BulkInsertInstanceResourcePerInstanceProperties.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BulkInsertInstanceResourcePerInstanceProperties message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties
                         * @static
                         * @param {google.cloud.compute.v1.IBulkInsertInstanceResourcePerInstanceProperties} message BulkInsertInstanceResourcePerInstanceProperties message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BulkInsertInstanceResourcePerInstanceProperties.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BulkInsertInstanceResourcePerInstanceProperties message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties} BulkInsertInstanceResourcePerInstanceProperties
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BulkInsertInstanceResourcePerInstanceProperties.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BulkInsertInstanceResourcePerInstanceProperties message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties} BulkInsertInstanceResourcePerInstanceProperties
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BulkInsertInstanceResourcePerInstanceProperties.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BulkInsertInstanceResourcePerInstanceProperties message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BulkInsertInstanceResourcePerInstanceProperties.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BulkInsertInstanceResourcePerInstanceProperties message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties} BulkInsertInstanceResourcePerInstanceProperties
                         */
                        BulkInsertInstanceResourcePerInstanceProperties.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BulkInsertInstanceResourcePerInstanceProperties message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties
                         * @static
                         * @param {google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties} message BulkInsertInstanceResourcePerInstanceProperties
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BulkInsertInstanceResourcePerInstanceProperties.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this BulkInsertInstanceResourcePerInstanceProperties to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BulkInsertInstanceResourcePerInstanceProperties.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BulkInsertInstanceResourcePerInstanceProperties
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BulkInsertInstanceResourcePerInstanceProperties.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BulkInsertInstanceResourcePerInstanceProperties";
                        };
    
                        return BulkInsertInstanceResourcePerInstanceProperties;
                    })();
    
                    v1.BulkInsertRegionInstanceRequest = (function() {
    
                        /**
                         * Properties of a BulkInsertRegionInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IBulkInsertRegionInstanceRequest
                         * @property {google.cloud.compute.v1.IBulkInsertInstanceResource|null} [bulkInsertInstanceResourceResource] BulkInsertRegionInstanceRequest bulkInsertInstanceResourceResource
                         * @property {string|null} [project] BulkInsertRegionInstanceRequest project
                         * @property {string|null} [region] BulkInsertRegionInstanceRequest region
                         * @property {string|null} [requestId] BulkInsertRegionInstanceRequest requestId
                         */
    
                        /**
                         * Constructs a new BulkInsertRegionInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BulkInsertRegionInstanceRequest.
                         * @implements IBulkInsertRegionInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IBulkInsertRegionInstanceRequest=} [properties] Properties to set
                         */
                        function BulkInsertRegionInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * BulkInsertRegionInstanceRequest bulkInsertInstanceResourceResource.
                         * @member {google.cloud.compute.v1.IBulkInsertInstanceResource|null|undefined} bulkInsertInstanceResourceResource
                         * @memberof google.cloud.compute.v1.BulkInsertRegionInstanceRequest
                         * @instance
                         */
                        BulkInsertRegionInstanceRequest.prototype.bulkInsertInstanceResourceResource = null;
    
                        /**
                         * BulkInsertRegionInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.BulkInsertRegionInstanceRequest
                         * @instance
                         */
                        BulkInsertRegionInstanceRequest.prototype.project = "";
    
                        /**
                         * BulkInsertRegionInstanceRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.BulkInsertRegionInstanceRequest
                         * @instance
                         */
                        BulkInsertRegionInstanceRequest.prototype.region = "";
    
                        /**
                         * BulkInsertRegionInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.BulkInsertRegionInstanceRequest
                         * @instance
                         */
                        BulkInsertRegionInstanceRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * BulkInsertRegionInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.BulkInsertRegionInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(BulkInsertRegionInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new BulkInsertRegionInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.BulkInsertRegionInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IBulkInsertRegionInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.BulkInsertRegionInstanceRequest} BulkInsertRegionInstanceRequest instance
                         */
                        BulkInsertRegionInstanceRequest.create = function create(properties) {
                            return new BulkInsertRegionInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified BulkInsertRegionInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.BulkInsertRegionInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.BulkInsertRegionInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IBulkInsertRegionInstanceRequest} message BulkInsertRegionInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BulkInsertRegionInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.bulkInsertInstanceResourceResource != null && Object.hasOwnProperty.call(message, "bulkInsertInstanceResourceResource"))
                                $root.google.cloud.compute.v1.BulkInsertInstanceResource.encode(message.bulkInsertInstanceResourceResource, writer.uint32(/* id 41427278, wireType 2 =*/331418226).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified BulkInsertRegionInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.BulkInsertRegionInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.BulkInsertRegionInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IBulkInsertRegionInstanceRequest} message BulkInsertRegionInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        BulkInsertRegionInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a BulkInsertRegionInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.BulkInsertRegionInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.BulkInsertRegionInstanceRequest} BulkInsertRegionInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BulkInsertRegionInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.BulkInsertRegionInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 41427278: {
                                        message.bulkInsertInstanceResourceResource = $root.google.cloud.compute.v1.BulkInsertInstanceResource.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a BulkInsertRegionInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.BulkInsertRegionInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.BulkInsertRegionInstanceRequest} BulkInsertRegionInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        BulkInsertRegionInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a BulkInsertRegionInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.BulkInsertRegionInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        BulkInsertRegionInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.bulkInsertInstanceResourceResource != null && message.hasOwnProperty("bulkInsertInstanceResourceResource")) {
                                var error = $root.google.cloud.compute.v1.BulkInsertInstanceResource.verify(message.bulkInsertInstanceResourceResource);
                                if (error)
                                    return "bulkInsertInstanceResourceResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a BulkInsertRegionInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.BulkInsertRegionInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.BulkInsertRegionInstanceRequest} BulkInsertRegionInstanceRequest
                         */
                        BulkInsertRegionInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.BulkInsertRegionInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.BulkInsertRegionInstanceRequest();
                            if (object.bulkInsertInstanceResourceResource != null) {
                                if (typeof object.bulkInsertInstanceResourceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.BulkInsertRegionInstanceRequest.bulkInsertInstanceResourceResource: object expected");
                                message.bulkInsertInstanceResourceResource = $root.google.cloud.compute.v1.BulkInsertInstanceResource.fromObject(object.bulkInsertInstanceResourceResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a BulkInsertRegionInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.BulkInsertRegionInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.BulkInsertRegionInstanceRequest} message BulkInsertRegionInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        BulkInsertRegionInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.bulkInsertInstanceResourceResource = null;
                                object.region = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.bulkInsertInstanceResourceResource != null && message.hasOwnProperty("bulkInsertInstanceResourceResource"))
                                object.bulkInsertInstanceResourceResource = $root.google.cloud.compute.v1.BulkInsertInstanceResource.toObject(message.bulkInsertInstanceResourceResource, options);
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this BulkInsertRegionInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.BulkInsertRegionInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        BulkInsertRegionInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for BulkInsertRegionInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.BulkInsertRegionInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        BulkInsertRegionInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.BulkInsertRegionInstanceRequest";
                        };
    
                        return BulkInsertRegionInstanceRequest;
                    })();
    
                    v1.CacheInvalidationRule = (function() {
    
                        /**
                         * Properties of a CacheInvalidationRule.
                         * @memberof google.cloud.compute.v1
                         * @interface ICacheInvalidationRule
                         * @property {string|null} [host] CacheInvalidationRule host
                         * @property {string|null} [path] CacheInvalidationRule path
                         */
    
                        /**
                         * Constructs a new CacheInvalidationRule.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a CacheInvalidationRule.
                         * @implements ICacheInvalidationRule
                         * @constructor
                         * @param {google.cloud.compute.v1.ICacheInvalidationRule=} [properties] Properties to set
                         */
                        function CacheInvalidationRule(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CacheInvalidationRule host.
                         * @member {string|null|undefined} host
                         * @memberof google.cloud.compute.v1.CacheInvalidationRule
                         * @instance
                         */
                        CacheInvalidationRule.prototype.host = null;
    
                        /**
                         * CacheInvalidationRule path.
                         * @member {string|null|undefined} path
                         * @memberof google.cloud.compute.v1.CacheInvalidationRule
                         * @instance
                         */
                        CacheInvalidationRule.prototype.path = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * CacheInvalidationRule _host.
                         * @member {"host"|undefined} _host
                         * @memberof google.cloud.compute.v1.CacheInvalidationRule
                         * @instance
                         */
                        Object.defineProperty(CacheInvalidationRule.prototype, "_host", {
                            get: $util.oneOfGetter($oneOfFields = ["host"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CacheInvalidationRule _path.
                         * @member {"path"|undefined} _path
                         * @memberof google.cloud.compute.v1.CacheInvalidationRule
                         * @instance
                         */
                        Object.defineProperty(CacheInvalidationRule.prototype, "_path", {
                            get: $util.oneOfGetter($oneOfFields = ["path"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new CacheInvalidationRule instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.CacheInvalidationRule
                         * @static
                         * @param {google.cloud.compute.v1.ICacheInvalidationRule=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.CacheInvalidationRule} CacheInvalidationRule instance
                         */
                        CacheInvalidationRule.create = function create(properties) {
                            return new CacheInvalidationRule(properties);
                        };
    
                        /**
                         * Encodes the specified CacheInvalidationRule message. Does not implicitly {@link google.cloud.compute.v1.CacheInvalidationRule.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.CacheInvalidationRule
                         * @static
                         * @param {google.cloud.compute.v1.ICacheInvalidationRule} message CacheInvalidationRule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CacheInvalidationRule.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.host != null && Object.hasOwnProperty.call(message, "host"))
                                writer.uint32(/* id 3208616, wireType 2 =*/25668930).string(message.host);
                            if (message.path != null && Object.hasOwnProperty.call(message, "path"))
                                writer.uint32(/* id 3433509, wireType 2 =*/27468074).string(message.path);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CacheInvalidationRule message, length delimited. Does not implicitly {@link google.cloud.compute.v1.CacheInvalidationRule.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.CacheInvalidationRule
                         * @static
                         * @param {google.cloud.compute.v1.ICacheInvalidationRule} message CacheInvalidationRule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CacheInvalidationRule.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CacheInvalidationRule message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.CacheInvalidationRule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.CacheInvalidationRule} CacheInvalidationRule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CacheInvalidationRule.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.CacheInvalidationRule();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3208616: {
                                        message.host = reader.string();
                                        break;
                                    }
                                case 3433509: {
                                        message.path = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CacheInvalidationRule message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.CacheInvalidationRule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.CacheInvalidationRule} CacheInvalidationRule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CacheInvalidationRule.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CacheInvalidationRule message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.CacheInvalidationRule
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CacheInvalidationRule.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.host != null && message.hasOwnProperty("host")) {
                                properties._host = 1;
                                if (!$util.isString(message.host))
                                    return "host: string expected";
                            }
                            if (message.path != null && message.hasOwnProperty("path")) {
                                properties._path = 1;
                                if (!$util.isString(message.path))
                                    return "path: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CacheInvalidationRule message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.CacheInvalidationRule
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.CacheInvalidationRule} CacheInvalidationRule
                         */
                        CacheInvalidationRule.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.CacheInvalidationRule)
                                return object;
                            var message = new $root.google.cloud.compute.v1.CacheInvalidationRule();
                            if (object.host != null)
                                message.host = String(object.host);
                            if (object.path != null)
                                message.path = String(object.path);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CacheInvalidationRule message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.CacheInvalidationRule
                         * @static
                         * @param {google.cloud.compute.v1.CacheInvalidationRule} message CacheInvalidationRule
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CacheInvalidationRule.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.host != null && message.hasOwnProperty("host")) {
                                object.host = message.host;
                                if (options.oneofs)
                                    object._host = "host";
                            }
                            if (message.path != null && message.hasOwnProperty("path")) {
                                object.path = message.path;
                                if (options.oneofs)
                                    object._path = "path";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this CacheInvalidationRule to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.CacheInvalidationRule
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CacheInvalidationRule.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CacheInvalidationRule
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.CacheInvalidationRule
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CacheInvalidationRule.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.CacheInvalidationRule";
                        };
    
                        return CacheInvalidationRule;
                    })();
    
                    v1.CacheKeyPolicy = (function() {
    
                        /**
                         * Properties of a CacheKeyPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface ICacheKeyPolicy
                         * @property {boolean|null} [includeHost] CacheKeyPolicy includeHost
                         * @property {Array.<string>|null} [includeHttpHeaders] CacheKeyPolicy includeHttpHeaders
                         * @property {Array.<string>|null} [includeNamedCookies] CacheKeyPolicy includeNamedCookies
                         * @property {boolean|null} [includeProtocol] CacheKeyPolicy includeProtocol
                         * @property {boolean|null} [includeQueryString] CacheKeyPolicy includeQueryString
                         * @property {Array.<string>|null} [queryStringBlacklist] CacheKeyPolicy queryStringBlacklist
                         * @property {Array.<string>|null} [queryStringWhitelist] CacheKeyPolicy queryStringWhitelist
                         */
    
                        /**
                         * Constructs a new CacheKeyPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a CacheKeyPolicy.
                         * @implements ICacheKeyPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.ICacheKeyPolicy=} [properties] Properties to set
                         */
                        function CacheKeyPolicy(properties) {
                            this.includeHttpHeaders = [];
                            this.includeNamedCookies = [];
                            this.queryStringBlacklist = [];
                            this.queryStringWhitelist = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CacheKeyPolicy includeHost.
                         * @member {boolean|null|undefined} includeHost
                         * @memberof google.cloud.compute.v1.CacheKeyPolicy
                         * @instance
                         */
                        CacheKeyPolicy.prototype.includeHost = null;
    
                        /**
                         * CacheKeyPolicy includeHttpHeaders.
                         * @member {Array.<string>} includeHttpHeaders
                         * @memberof google.cloud.compute.v1.CacheKeyPolicy
                         * @instance
                         */
                        CacheKeyPolicy.prototype.includeHttpHeaders = $util.emptyArray;
    
                        /**
                         * CacheKeyPolicy includeNamedCookies.
                         * @member {Array.<string>} includeNamedCookies
                         * @memberof google.cloud.compute.v1.CacheKeyPolicy
                         * @instance
                         */
                        CacheKeyPolicy.prototype.includeNamedCookies = $util.emptyArray;
    
                        /**
                         * CacheKeyPolicy includeProtocol.
                         * @member {boolean|null|undefined} includeProtocol
                         * @memberof google.cloud.compute.v1.CacheKeyPolicy
                         * @instance
                         */
                        CacheKeyPolicy.prototype.includeProtocol = null;
    
                        /**
                         * CacheKeyPolicy includeQueryString.
                         * @member {boolean|null|undefined} includeQueryString
                         * @memberof google.cloud.compute.v1.CacheKeyPolicy
                         * @instance
                         */
                        CacheKeyPolicy.prototype.includeQueryString = null;
    
                        /**
                         * CacheKeyPolicy queryStringBlacklist.
                         * @member {Array.<string>} queryStringBlacklist
                         * @memberof google.cloud.compute.v1.CacheKeyPolicy
                         * @instance
                         */
                        CacheKeyPolicy.prototype.queryStringBlacklist = $util.emptyArray;
    
                        /**
                         * CacheKeyPolicy queryStringWhitelist.
                         * @member {Array.<string>} queryStringWhitelist
                         * @memberof google.cloud.compute.v1.CacheKeyPolicy
                         * @instance
                         */
                        CacheKeyPolicy.prototype.queryStringWhitelist = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * CacheKeyPolicy _includeHost.
                         * @member {"includeHost"|undefined} _includeHost
                         * @memberof google.cloud.compute.v1.CacheKeyPolicy
                         * @instance
                         */
                        Object.defineProperty(CacheKeyPolicy.prototype, "_includeHost", {
                            get: $util.oneOfGetter($oneOfFields = ["includeHost"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CacheKeyPolicy _includeProtocol.
                         * @member {"includeProtocol"|undefined} _includeProtocol
                         * @memberof google.cloud.compute.v1.CacheKeyPolicy
                         * @instance
                         */
                        Object.defineProperty(CacheKeyPolicy.prototype, "_includeProtocol", {
                            get: $util.oneOfGetter($oneOfFields = ["includeProtocol"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CacheKeyPolicy _includeQueryString.
                         * @member {"includeQueryString"|undefined} _includeQueryString
                         * @memberof google.cloud.compute.v1.CacheKeyPolicy
                         * @instance
                         */
                        Object.defineProperty(CacheKeyPolicy.prototype, "_includeQueryString", {
                            get: $util.oneOfGetter($oneOfFields = ["includeQueryString"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new CacheKeyPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.CacheKeyPolicy
                         * @static
                         * @param {google.cloud.compute.v1.ICacheKeyPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.CacheKeyPolicy} CacheKeyPolicy instance
                         */
                        CacheKeyPolicy.create = function create(properties) {
                            return new CacheKeyPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified CacheKeyPolicy message. Does not implicitly {@link google.cloud.compute.v1.CacheKeyPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.CacheKeyPolicy
                         * @static
                         * @param {google.cloud.compute.v1.ICacheKeyPolicy} message CacheKeyPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CacheKeyPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.includeHttpHeaders != null && message.includeHttpHeaders.length)
                                for (var i = 0; i < message.includeHttpHeaders.length; ++i)
                                    writer.uint32(/* id 2489606, wireType 2 =*/19916850).string(message.includeHttpHeaders[i]);
                            if (message.queryStringWhitelist != null && message.queryStringWhitelist.length)
                                for (var i = 0; i < message.queryStringWhitelist.length; ++i)
                                    writer.uint32(/* id 52456496, wireType 2 =*/419651970).string(message.queryStringWhitelist[i]);
                            if (message.includeNamedCookies != null && message.includeNamedCookies.length)
                                for (var i = 0; i < message.includeNamedCookies.length; ++i)
                                    writer.uint32(/* id 87316530, wireType 2 =*/698532242).string(message.includeNamedCookies[i]);
                            if (message.includeProtocol != null && Object.hasOwnProperty.call(message, "includeProtocol"))
                                writer.uint32(/* id 303507535, wireType 0 =*/2428060280).bool(message.includeProtocol);
                            if (message.queryStringBlacklist != null && message.queryStringBlacklist.length)
                                for (var i = 0; i < message.queryStringBlacklist.length; ++i)
                                    writer.uint32(/* id 354964742, wireType 2 =*/2839717938).string(message.queryStringBlacklist[i]);
                            if (message.includeQueryString != null && Object.hasOwnProperty.call(message, "includeQueryString"))
                                writer.uint32(/* id 474036639, wireType 0 =*/3792293112).bool(message.includeQueryString);
                            if (message.includeHost != null && Object.hasOwnProperty.call(message, "includeHost"))
                                writer.uint32(/* id 486867679, wireType 0 =*/3894941432).bool(message.includeHost);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CacheKeyPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.CacheKeyPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.CacheKeyPolicy
                         * @static
                         * @param {google.cloud.compute.v1.ICacheKeyPolicy} message CacheKeyPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CacheKeyPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CacheKeyPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.CacheKeyPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.CacheKeyPolicy} CacheKeyPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CacheKeyPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.CacheKeyPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 486867679: {
                                        message.includeHost = reader.bool();
                                        break;
                                    }
                                case 2489606: {
                                        if (!(message.includeHttpHeaders && message.includeHttpHeaders.length))
                                            message.includeHttpHeaders = [];
                                        message.includeHttpHeaders.push(reader.string());
                                        break;
                                    }
                                case 87316530: {
                                        if (!(message.includeNamedCookies && message.includeNamedCookies.length))
                                            message.includeNamedCookies = [];
                                        message.includeNamedCookies.push(reader.string());
                                        break;
                                    }
                                case 303507535: {
                                        message.includeProtocol = reader.bool();
                                        break;
                                    }
                                case 474036639: {
                                        message.includeQueryString = reader.bool();
                                        break;
                                    }
                                case 354964742: {
                                        if (!(message.queryStringBlacklist && message.queryStringBlacklist.length))
                                            message.queryStringBlacklist = [];
                                        message.queryStringBlacklist.push(reader.string());
                                        break;
                                    }
                                case 52456496: {
                                        if (!(message.queryStringWhitelist && message.queryStringWhitelist.length))
                                            message.queryStringWhitelist = [];
                                        message.queryStringWhitelist.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CacheKeyPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.CacheKeyPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.CacheKeyPolicy} CacheKeyPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CacheKeyPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CacheKeyPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.CacheKeyPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CacheKeyPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.includeHost != null && message.hasOwnProperty("includeHost")) {
                                properties._includeHost = 1;
                                if (typeof message.includeHost !== "boolean")
                                    return "includeHost: boolean expected";
                            }
                            if (message.includeHttpHeaders != null && message.hasOwnProperty("includeHttpHeaders")) {
                                if (!Array.isArray(message.includeHttpHeaders))
                                    return "includeHttpHeaders: array expected";
                                for (var i = 0; i < message.includeHttpHeaders.length; ++i)
                                    if (!$util.isString(message.includeHttpHeaders[i]))
                                        return "includeHttpHeaders: string[] expected";
                            }
                            if (message.includeNamedCookies != null && message.hasOwnProperty("includeNamedCookies")) {
                                if (!Array.isArray(message.includeNamedCookies))
                                    return "includeNamedCookies: array expected";
                                for (var i = 0; i < message.includeNamedCookies.length; ++i)
                                    if (!$util.isString(message.includeNamedCookies[i]))
                                        return "includeNamedCookies: string[] expected";
                            }
                            if (message.includeProtocol != null && message.hasOwnProperty("includeProtocol")) {
                                properties._includeProtocol = 1;
                                if (typeof message.includeProtocol !== "boolean")
                                    return "includeProtocol: boolean expected";
                            }
                            if (message.includeQueryString != null && message.hasOwnProperty("includeQueryString")) {
                                properties._includeQueryString = 1;
                                if (typeof message.includeQueryString !== "boolean")
                                    return "includeQueryString: boolean expected";
                            }
                            if (message.queryStringBlacklist != null && message.hasOwnProperty("queryStringBlacklist")) {
                                if (!Array.isArray(message.queryStringBlacklist))
                                    return "queryStringBlacklist: array expected";
                                for (var i = 0; i < message.queryStringBlacklist.length; ++i)
                                    if (!$util.isString(message.queryStringBlacklist[i]))
                                        return "queryStringBlacklist: string[] expected";
                            }
                            if (message.queryStringWhitelist != null && message.hasOwnProperty("queryStringWhitelist")) {
                                if (!Array.isArray(message.queryStringWhitelist))
                                    return "queryStringWhitelist: array expected";
                                for (var i = 0; i < message.queryStringWhitelist.length; ++i)
                                    if (!$util.isString(message.queryStringWhitelist[i]))
                                        return "queryStringWhitelist: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CacheKeyPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.CacheKeyPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.CacheKeyPolicy} CacheKeyPolicy
                         */
                        CacheKeyPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.CacheKeyPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.CacheKeyPolicy();
                            if (object.includeHost != null)
                                message.includeHost = Boolean(object.includeHost);
                            if (object.includeHttpHeaders) {
                                if (!Array.isArray(object.includeHttpHeaders))
                                    throw TypeError(".google.cloud.compute.v1.CacheKeyPolicy.includeHttpHeaders: array expected");
                                message.includeHttpHeaders = [];
                                for (var i = 0; i < object.includeHttpHeaders.length; ++i)
                                    message.includeHttpHeaders[i] = String(object.includeHttpHeaders[i]);
                            }
                            if (object.includeNamedCookies) {
                                if (!Array.isArray(object.includeNamedCookies))
                                    throw TypeError(".google.cloud.compute.v1.CacheKeyPolicy.includeNamedCookies: array expected");
                                message.includeNamedCookies = [];
                                for (var i = 0; i < object.includeNamedCookies.length; ++i)
                                    message.includeNamedCookies[i] = String(object.includeNamedCookies[i]);
                            }
                            if (object.includeProtocol != null)
                                message.includeProtocol = Boolean(object.includeProtocol);
                            if (object.includeQueryString != null)
                                message.includeQueryString = Boolean(object.includeQueryString);
                            if (object.queryStringBlacklist) {
                                if (!Array.isArray(object.queryStringBlacklist))
                                    throw TypeError(".google.cloud.compute.v1.CacheKeyPolicy.queryStringBlacklist: array expected");
                                message.queryStringBlacklist = [];
                                for (var i = 0; i < object.queryStringBlacklist.length; ++i)
                                    message.queryStringBlacklist[i] = String(object.queryStringBlacklist[i]);
                            }
                            if (object.queryStringWhitelist) {
                                if (!Array.isArray(object.queryStringWhitelist))
                                    throw TypeError(".google.cloud.compute.v1.CacheKeyPolicy.queryStringWhitelist: array expected");
                                message.queryStringWhitelist = [];
                                for (var i = 0; i < object.queryStringWhitelist.length; ++i)
                                    message.queryStringWhitelist[i] = String(object.queryStringWhitelist[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CacheKeyPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.CacheKeyPolicy
                         * @static
                         * @param {google.cloud.compute.v1.CacheKeyPolicy} message CacheKeyPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CacheKeyPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.includeHttpHeaders = [];
                                object.queryStringWhitelist = [];
                                object.includeNamedCookies = [];
                                object.queryStringBlacklist = [];
                            }
                            if (message.includeHttpHeaders && message.includeHttpHeaders.length) {
                                object.includeHttpHeaders = [];
                                for (var j = 0; j < message.includeHttpHeaders.length; ++j)
                                    object.includeHttpHeaders[j] = message.includeHttpHeaders[j];
                            }
                            if (message.queryStringWhitelist && message.queryStringWhitelist.length) {
                                object.queryStringWhitelist = [];
                                for (var j = 0; j < message.queryStringWhitelist.length; ++j)
                                    object.queryStringWhitelist[j] = message.queryStringWhitelist[j];
                            }
                            if (message.includeNamedCookies && message.includeNamedCookies.length) {
                                object.includeNamedCookies = [];
                                for (var j = 0; j < message.includeNamedCookies.length; ++j)
                                    object.includeNamedCookies[j] = message.includeNamedCookies[j];
                            }
                            if (message.includeProtocol != null && message.hasOwnProperty("includeProtocol")) {
                                object.includeProtocol = message.includeProtocol;
                                if (options.oneofs)
                                    object._includeProtocol = "includeProtocol";
                            }
                            if (message.queryStringBlacklist && message.queryStringBlacklist.length) {
                                object.queryStringBlacklist = [];
                                for (var j = 0; j < message.queryStringBlacklist.length; ++j)
                                    object.queryStringBlacklist[j] = message.queryStringBlacklist[j];
                            }
                            if (message.includeQueryString != null && message.hasOwnProperty("includeQueryString")) {
                                object.includeQueryString = message.includeQueryString;
                                if (options.oneofs)
                                    object._includeQueryString = "includeQueryString";
                            }
                            if (message.includeHost != null && message.hasOwnProperty("includeHost")) {
                                object.includeHost = message.includeHost;
                                if (options.oneofs)
                                    object._includeHost = "includeHost";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this CacheKeyPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.CacheKeyPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CacheKeyPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CacheKeyPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.CacheKeyPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CacheKeyPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.CacheKeyPolicy";
                        };
    
                        return CacheKeyPolicy;
                    })();
    
                    v1.CircuitBreakers = (function() {
    
                        /**
                         * Properties of a CircuitBreakers.
                         * @memberof google.cloud.compute.v1
                         * @interface ICircuitBreakers
                         * @property {number|null} [maxConnections] CircuitBreakers maxConnections
                         * @property {number|null} [maxPendingRequests] CircuitBreakers maxPendingRequests
                         * @property {number|null} [maxRequests] CircuitBreakers maxRequests
                         * @property {number|null} [maxRequestsPerConnection] CircuitBreakers maxRequestsPerConnection
                         * @property {number|null} [maxRetries] CircuitBreakers maxRetries
                         */
    
                        /**
                         * Constructs a new CircuitBreakers.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a CircuitBreakers.
                         * @implements ICircuitBreakers
                         * @constructor
                         * @param {google.cloud.compute.v1.ICircuitBreakers=} [properties] Properties to set
                         */
                        function CircuitBreakers(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CircuitBreakers maxConnections.
                         * @member {number|null|undefined} maxConnections
                         * @memberof google.cloud.compute.v1.CircuitBreakers
                         * @instance
                         */
                        CircuitBreakers.prototype.maxConnections = null;
    
                        /**
                         * CircuitBreakers maxPendingRequests.
                         * @member {number|null|undefined} maxPendingRequests
                         * @memberof google.cloud.compute.v1.CircuitBreakers
                         * @instance
                         */
                        CircuitBreakers.prototype.maxPendingRequests = null;
    
                        /**
                         * CircuitBreakers maxRequests.
                         * @member {number|null|undefined} maxRequests
                         * @memberof google.cloud.compute.v1.CircuitBreakers
                         * @instance
                         */
                        CircuitBreakers.prototype.maxRequests = null;
    
                        /**
                         * CircuitBreakers maxRequestsPerConnection.
                         * @member {number|null|undefined} maxRequestsPerConnection
                         * @memberof google.cloud.compute.v1.CircuitBreakers
                         * @instance
                         */
                        CircuitBreakers.prototype.maxRequestsPerConnection = null;
    
                        /**
                         * CircuitBreakers maxRetries.
                         * @member {number|null|undefined} maxRetries
                         * @memberof google.cloud.compute.v1.CircuitBreakers
                         * @instance
                         */
                        CircuitBreakers.prototype.maxRetries = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * CircuitBreakers _maxConnections.
                         * @member {"maxConnections"|undefined} _maxConnections
                         * @memberof google.cloud.compute.v1.CircuitBreakers
                         * @instance
                         */
                        Object.defineProperty(CircuitBreakers.prototype, "_maxConnections", {
                            get: $util.oneOfGetter($oneOfFields = ["maxConnections"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CircuitBreakers _maxPendingRequests.
                         * @member {"maxPendingRequests"|undefined} _maxPendingRequests
                         * @memberof google.cloud.compute.v1.CircuitBreakers
                         * @instance
                         */
                        Object.defineProperty(CircuitBreakers.prototype, "_maxPendingRequests", {
                            get: $util.oneOfGetter($oneOfFields = ["maxPendingRequests"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CircuitBreakers _maxRequests.
                         * @member {"maxRequests"|undefined} _maxRequests
                         * @memberof google.cloud.compute.v1.CircuitBreakers
                         * @instance
                         */
                        Object.defineProperty(CircuitBreakers.prototype, "_maxRequests", {
                            get: $util.oneOfGetter($oneOfFields = ["maxRequests"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CircuitBreakers _maxRequestsPerConnection.
                         * @member {"maxRequestsPerConnection"|undefined} _maxRequestsPerConnection
                         * @memberof google.cloud.compute.v1.CircuitBreakers
                         * @instance
                         */
                        Object.defineProperty(CircuitBreakers.prototype, "_maxRequestsPerConnection", {
                            get: $util.oneOfGetter($oneOfFields = ["maxRequestsPerConnection"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CircuitBreakers _maxRetries.
                         * @member {"maxRetries"|undefined} _maxRetries
                         * @memberof google.cloud.compute.v1.CircuitBreakers
                         * @instance
                         */
                        Object.defineProperty(CircuitBreakers.prototype, "_maxRetries", {
                            get: $util.oneOfGetter($oneOfFields = ["maxRetries"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new CircuitBreakers instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.CircuitBreakers
                         * @static
                         * @param {google.cloud.compute.v1.ICircuitBreakers=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.CircuitBreakers} CircuitBreakers instance
                         */
                        CircuitBreakers.create = function create(properties) {
                            return new CircuitBreakers(properties);
                        };
    
                        /**
                         * Encodes the specified CircuitBreakers message. Does not implicitly {@link google.cloud.compute.v1.CircuitBreakers.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.CircuitBreakers
                         * @static
                         * @param {google.cloud.compute.v1.ICircuitBreakers} message CircuitBreakers message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CircuitBreakers.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.maxRequests != null && Object.hasOwnProperty.call(message, "maxRequests"))
                                writer.uint32(/* id 28097599, wireType 0 =*/224780792).int32(message.maxRequests);
                            if (message.maxRetries != null && Object.hasOwnProperty.call(message, "maxRetries"))
                                writer.uint32(/* id 55546219, wireType 0 =*/444369752).int32(message.maxRetries);
                            if (message.maxConnections != null && Object.hasOwnProperty.call(message, "maxConnections"))
                                writer.uint32(/* id 110652154, wireType 0 =*/885217232).int32(message.maxConnections);
                            if (message.maxRequestsPerConnection != null && Object.hasOwnProperty.call(message, "maxRequestsPerConnection"))
                                writer.uint32(/* id 361630528, wireType 0 =*/2893044224).int32(message.maxRequestsPerConnection);
                            if (message.maxPendingRequests != null && Object.hasOwnProperty.call(message, "maxPendingRequests"))
                                writer.uint32(/* id 375558887, wireType 0 =*/3004471096).int32(message.maxPendingRequests);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CircuitBreakers message, length delimited. Does not implicitly {@link google.cloud.compute.v1.CircuitBreakers.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.CircuitBreakers
                         * @static
                         * @param {google.cloud.compute.v1.ICircuitBreakers} message CircuitBreakers message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CircuitBreakers.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CircuitBreakers message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.CircuitBreakers
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.CircuitBreakers} CircuitBreakers
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CircuitBreakers.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.CircuitBreakers();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 110652154: {
                                        message.maxConnections = reader.int32();
                                        break;
                                    }
                                case 375558887: {
                                        message.maxPendingRequests = reader.int32();
                                        break;
                                    }
                                case 28097599: {
                                        message.maxRequests = reader.int32();
                                        break;
                                    }
                                case 361630528: {
                                        message.maxRequestsPerConnection = reader.int32();
                                        break;
                                    }
                                case 55546219: {
                                        message.maxRetries = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CircuitBreakers message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.CircuitBreakers
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.CircuitBreakers} CircuitBreakers
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CircuitBreakers.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CircuitBreakers message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.CircuitBreakers
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CircuitBreakers.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.maxConnections != null && message.hasOwnProperty("maxConnections")) {
                                properties._maxConnections = 1;
                                if (!$util.isInteger(message.maxConnections))
                                    return "maxConnections: integer expected";
                            }
                            if (message.maxPendingRequests != null && message.hasOwnProperty("maxPendingRequests")) {
                                properties._maxPendingRequests = 1;
                                if (!$util.isInteger(message.maxPendingRequests))
                                    return "maxPendingRequests: integer expected";
                            }
                            if (message.maxRequests != null && message.hasOwnProperty("maxRequests")) {
                                properties._maxRequests = 1;
                                if (!$util.isInteger(message.maxRequests))
                                    return "maxRequests: integer expected";
                            }
                            if (message.maxRequestsPerConnection != null && message.hasOwnProperty("maxRequestsPerConnection")) {
                                properties._maxRequestsPerConnection = 1;
                                if (!$util.isInteger(message.maxRequestsPerConnection))
                                    return "maxRequestsPerConnection: integer expected";
                            }
                            if (message.maxRetries != null && message.hasOwnProperty("maxRetries")) {
                                properties._maxRetries = 1;
                                if (!$util.isInteger(message.maxRetries))
                                    return "maxRetries: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CircuitBreakers message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.CircuitBreakers
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.CircuitBreakers} CircuitBreakers
                         */
                        CircuitBreakers.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.CircuitBreakers)
                                return object;
                            var message = new $root.google.cloud.compute.v1.CircuitBreakers();
                            if (object.maxConnections != null)
                                message.maxConnections = object.maxConnections | 0;
                            if (object.maxPendingRequests != null)
                                message.maxPendingRequests = object.maxPendingRequests | 0;
                            if (object.maxRequests != null)
                                message.maxRequests = object.maxRequests | 0;
                            if (object.maxRequestsPerConnection != null)
                                message.maxRequestsPerConnection = object.maxRequestsPerConnection | 0;
                            if (object.maxRetries != null)
                                message.maxRetries = object.maxRetries | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CircuitBreakers message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.CircuitBreakers
                         * @static
                         * @param {google.cloud.compute.v1.CircuitBreakers} message CircuitBreakers
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CircuitBreakers.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.maxRequests != null && message.hasOwnProperty("maxRequests")) {
                                object.maxRequests = message.maxRequests;
                                if (options.oneofs)
                                    object._maxRequests = "maxRequests";
                            }
                            if (message.maxRetries != null && message.hasOwnProperty("maxRetries")) {
                                object.maxRetries = message.maxRetries;
                                if (options.oneofs)
                                    object._maxRetries = "maxRetries";
                            }
                            if (message.maxConnections != null && message.hasOwnProperty("maxConnections")) {
                                object.maxConnections = message.maxConnections;
                                if (options.oneofs)
                                    object._maxConnections = "maxConnections";
                            }
                            if (message.maxRequestsPerConnection != null && message.hasOwnProperty("maxRequestsPerConnection")) {
                                object.maxRequestsPerConnection = message.maxRequestsPerConnection;
                                if (options.oneofs)
                                    object._maxRequestsPerConnection = "maxRequestsPerConnection";
                            }
                            if (message.maxPendingRequests != null && message.hasOwnProperty("maxPendingRequests")) {
                                object.maxPendingRequests = message.maxPendingRequests;
                                if (options.oneofs)
                                    object._maxPendingRequests = "maxPendingRequests";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this CircuitBreakers to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.CircuitBreakers
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CircuitBreakers.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CircuitBreakers
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.CircuitBreakers
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CircuitBreakers.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.CircuitBreakers";
                        };
    
                        return CircuitBreakers;
                    })();
    
                    v1.CloneRulesFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a CloneRulesFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ICloneRulesFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] CloneRulesFirewallPolicyRequest firewallPolicy
                         * @property {string|null} [requestId] CloneRulesFirewallPolicyRequest requestId
                         * @property {string|null} [sourceFirewallPolicy] CloneRulesFirewallPolicyRequest sourceFirewallPolicy
                         */
    
                        /**
                         * Constructs a new CloneRulesFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a CloneRulesFirewallPolicyRequest.
                         * @implements ICloneRulesFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ICloneRulesFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function CloneRulesFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CloneRulesFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.CloneRulesFirewallPolicyRequest
                         * @instance
                         */
                        CloneRulesFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * CloneRulesFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.CloneRulesFirewallPolicyRequest
                         * @instance
                         */
                        CloneRulesFirewallPolicyRequest.prototype.requestId = null;
    
                        /**
                         * CloneRulesFirewallPolicyRequest sourceFirewallPolicy.
                         * @member {string|null|undefined} sourceFirewallPolicy
                         * @memberof google.cloud.compute.v1.CloneRulesFirewallPolicyRequest
                         * @instance
                         */
                        CloneRulesFirewallPolicyRequest.prototype.sourceFirewallPolicy = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * CloneRulesFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.CloneRulesFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(CloneRulesFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CloneRulesFirewallPolicyRequest _sourceFirewallPolicy.
                         * @member {"sourceFirewallPolicy"|undefined} _sourceFirewallPolicy
                         * @memberof google.cloud.compute.v1.CloneRulesFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(CloneRulesFirewallPolicyRequest.prototype, "_sourceFirewallPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceFirewallPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new CloneRulesFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.CloneRulesFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICloneRulesFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.CloneRulesFirewallPolicyRequest} CloneRulesFirewallPolicyRequest instance
                         */
                        CloneRulesFirewallPolicyRequest.create = function create(properties) {
                            return new CloneRulesFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CloneRulesFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.CloneRulesFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.CloneRulesFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICloneRulesFirewallPolicyRequest} message CloneRulesFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CloneRulesFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.sourceFirewallPolicy != null && Object.hasOwnProperty.call(message, "sourceFirewallPolicy"))
                                writer.uint32(/* id 25013549, wireType 2 =*/200108394).string(message.sourceFirewallPolicy);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CloneRulesFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.CloneRulesFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.CloneRulesFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICloneRulesFirewallPolicyRequest} message CloneRulesFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CloneRulesFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CloneRulesFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.CloneRulesFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.CloneRulesFirewallPolicyRequest} CloneRulesFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CloneRulesFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.CloneRulesFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 25013549: {
                                        message.sourceFirewallPolicy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CloneRulesFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.CloneRulesFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.CloneRulesFirewallPolicyRequest} CloneRulesFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CloneRulesFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CloneRulesFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.CloneRulesFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CloneRulesFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.sourceFirewallPolicy != null && message.hasOwnProperty("sourceFirewallPolicy")) {
                                properties._sourceFirewallPolicy = 1;
                                if (!$util.isString(message.sourceFirewallPolicy))
                                    return "sourceFirewallPolicy: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CloneRulesFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.CloneRulesFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.CloneRulesFirewallPolicyRequest} CloneRulesFirewallPolicyRequest
                         */
                        CloneRulesFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.CloneRulesFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.CloneRulesFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.sourceFirewallPolicy != null)
                                message.sourceFirewallPolicy = String(object.sourceFirewallPolicy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CloneRulesFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.CloneRulesFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.CloneRulesFirewallPolicyRequest} message CloneRulesFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CloneRulesFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.firewallPolicy = "";
                            if (message.sourceFirewallPolicy != null && message.hasOwnProperty("sourceFirewallPolicy")) {
                                object.sourceFirewallPolicy = message.sourceFirewallPolicy;
                                if (options.oneofs)
                                    object._sourceFirewallPolicy = "sourceFirewallPolicy";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this CloneRulesFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.CloneRulesFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CloneRulesFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CloneRulesFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.CloneRulesFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CloneRulesFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.CloneRulesFirewallPolicyRequest";
                        };
    
                        return CloneRulesFirewallPolicyRequest;
                    })();
    
                    v1.CloneRulesNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a CloneRulesNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ICloneRulesNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] CloneRulesNetworkFirewallPolicyRequest firewallPolicy
                         * @property {string|null} [project] CloneRulesNetworkFirewallPolicyRequest project
                         * @property {string|null} [requestId] CloneRulesNetworkFirewallPolicyRequest requestId
                         * @property {string|null} [sourceFirewallPolicy] CloneRulesNetworkFirewallPolicyRequest sourceFirewallPolicy
                         */
    
                        /**
                         * Constructs a new CloneRulesNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a CloneRulesNetworkFirewallPolicyRequest.
                         * @implements ICloneRulesNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ICloneRulesNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function CloneRulesNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CloneRulesNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest
                         * @instance
                         */
                        CloneRulesNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * CloneRulesNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest
                         * @instance
                         */
                        CloneRulesNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * CloneRulesNetworkFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest
                         * @instance
                         */
                        CloneRulesNetworkFirewallPolicyRequest.prototype.requestId = null;
    
                        /**
                         * CloneRulesNetworkFirewallPolicyRequest sourceFirewallPolicy.
                         * @member {string|null|undefined} sourceFirewallPolicy
                         * @memberof google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest
                         * @instance
                         */
                        CloneRulesNetworkFirewallPolicyRequest.prototype.sourceFirewallPolicy = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * CloneRulesNetworkFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(CloneRulesNetworkFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CloneRulesNetworkFirewallPolicyRequest _sourceFirewallPolicy.
                         * @member {"sourceFirewallPolicy"|undefined} _sourceFirewallPolicy
                         * @memberof google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(CloneRulesNetworkFirewallPolicyRequest.prototype, "_sourceFirewallPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceFirewallPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new CloneRulesNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICloneRulesNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest} CloneRulesNetworkFirewallPolicyRequest instance
                         */
                        CloneRulesNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new CloneRulesNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CloneRulesNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICloneRulesNetworkFirewallPolicyRequest} message CloneRulesNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CloneRulesNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.sourceFirewallPolicy != null && Object.hasOwnProperty.call(message, "sourceFirewallPolicy"))
                                writer.uint32(/* id 25013549, wireType 2 =*/200108394).string(message.sourceFirewallPolicy);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CloneRulesNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICloneRulesNetworkFirewallPolicyRequest} message CloneRulesNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CloneRulesNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CloneRulesNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest} CloneRulesNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CloneRulesNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 25013549: {
                                        message.sourceFirewallPolicy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CloneRulesNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest} CloneRulesNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CloneRulesNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CloneRulesNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CloneRulesNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.sourceFirewallPolicy != null && message.hasOwnProperty("sourceFirewallPolicy")) {
                                properties._sourceFirewallPolicy = 1;
                                if (!$util.isString(message.sourceFirewallPolicy))
                                    return "sourceFirewallPolicy: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CloneRulesNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest} CloneRulesNetworkFirewallPolicyRequest
                         */
                        CloneRulesNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.sourceFirewallPolicy != null)
                                message.sourceFirewallPolicy = String(object.sourceFirewallPolicy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CloneRulesNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest} message CloneRulesNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CloneRulesNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.firewallPolicy = "";
                            }
                            if (message.sourceFirewallPolicy != null && message.hasOwnProperty("sourceFirewallPolicy")) {
                                object.sourceFirewallPolicy = message.sourceFirewallPolicy;
                                if (options.oneofs)
                                    object._sourceFirewallPolicy = "sourceFirewallPolicy";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this CloneRulesNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CloneRulesNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CloneRulesNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CloneRulesNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest";
                        };
    
                        return CloneRulesNetworkFirewallPolicyRequest;
                    })();
    
                    v1.CloneRulesRegionNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a CloneRulesRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ICloneRulesRegionNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] CloneRulesRegionNetworkFirewallPolicyRequest firewallPolicy
                         * @property {string|null} [project] CloneRulesRegionNetworkFirewallPolicyRequest project
                         * @property {string|null} [region] CloneRulesRegionNetworkFirewallPolicyRequest region
                         * @property {string|null} [requestId] CloneRulesRegionNetworkFirewallPolicyRequest requestId
                         * @property {string|null} [sourceFirewallPolicy] CloneRulesRegionNetworkFirewallPolicyRequest sourceFirewallPolicy
                         */
    
                        /**
                         * Constructs a new CloneRulesRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a CloneRulesRegionNetworkFirewallPolicyRequest.
                         * @implements ICloneRulesRegionNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ICloneRulesRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function CloneRulesRegionNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CloneRulesRegionNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        CloneRulesRegionNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * CloneRulesRegionNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        CloneRulesRegionNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * CloneRulesRegionNetworkFirewallPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        CloneRulesRegionNetworkFirewallPolicyRequest.prototype.region = "";
    
                        /**
                         * CloneRulesRegionNetworkFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        CloneRulesRegionNetworkFirewallPolicyRequest.prototype.requestId = null;
    
                        /**
                         * CloneRulesRegionNetworkFirewallPolicyRequest sourceFirewallPolicy.
                         * @member {string|null|undefined} sourceFirewallPolicy
                         * @memberof google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        CloneRulesRegionNetworkFirewallPolicyRequest.prototype.sourceFirewallPolicy = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * CloneRulesRegionNetworkFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(CloneRulesRegionNetworkFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CloneRulesRegionNetworkFirewallPolicyRequest _sourceFirewallPolicy.
                         * @member {"sourceFirewallPolicy"|undefined} _sourceFirewallPolicy
                         * @memberof google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(CloneRulesRegionNetworkFirewallPolicyRequest.prototype, "_sourceFirewallPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceFirewallPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new CloneRulesRegionNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICloneRulesRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest} CloneRulesRegionNetworkFirewallPolicyRequest instance
                         */
                        CloneRulesRegionNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new CloneRulesRegionNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CloneRulesRegionNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICloneRulesRegionNetworkFirewallPolicyRequest} message CloneRulesRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CloneRulesRegionNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.sourceFirewallPolicy != null && Object.hasOwnProperty.call(message, "sourceFirewallPolicy"))
                                writer.uint32(/* id 25013549, wireType 2 =*/200108394).string(message.sourceFirewallPolicy);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CloneRulesRegionNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICloneRulesRegionNetworkFirewallPolicyRequest} message CloneRulesRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CloneRulesRegionNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CloneRulesRegionNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest} CloneRulesRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CloneRulesRegionNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 25013549: {
                                        message.sourceFirewallPolicy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CloneRulesRegionNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest} CloneRulesRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CloneRulesRegionNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CloneRulesRegionNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CloneRulesRegionNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.sourceFirewallPolicy != null && message.hasOwnProperty("sourceFirewallPolicy")) {
                                properties._sourceFirewallPolicy = 1;
                                if (!$util.isString(message.sourceFirewallPolicy))
                                    return "sourceFirewallPolicy: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CloneRulesRegionNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest} CloneRulesRegionNetworkFirewallPolicyRequest
                         */
                        CloneRulesRegionNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.sourceFirewallPolicy != null)
                                message.sourceFirewallPolicy = String(object.sourceFirewallPolicy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CloneRulesRegionNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest} message CloneRulesRegionNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CloneRulesRegionNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.firewallPolicy = "";
                            }
                            if (message.sourceFirewallPolicy != null && message.hasOwnProperty("sourceFirewallPolicy")) {
                                object.sourceFirewallPolicy = message.sourceFirewallPolicy;
                                if (options.oneofs)
                                    object._sourceFirewallPolicy = "sourceFirewallPolicy";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this CloneRulesRegionNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CloneRulesRegionNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CloneRulesRegionNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CloneRulesRegionNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest";
                        };
    
                        return CloneRulesRegionNetworkFirewallPolicyRequest;
                    })();
    
                    v1.Commitment = (function() {
    
                        /**
                         * Properties of a Commitment.
                         * @memberof google.cloud.compute.v1
                         * @interface ICommitment
                         * @property {boolean|null} [autoRenew] Commitment autoRenew
                         * @property {string|null} [category] Commitment category
                         * @property {string|null} [creationTimestamp] Commitment creationTimestamp
                         * @property {string|null} [description] Commitment description
                         * @property {string|null} [endTimestamp] Commitment endTimestamp
                         * @property {number|Long|null} [id] Commitment id
                         * @property {string|null} [kind] Commitment kind
                         * @property {google.cloud.compute.v1.ILicenseResourceCommitment|null} [licenseResource] Commitment licenseResource
                         * @property {Array.<string>|null} [mergeSourceCommitments] Commitment mergeSourceCommitments
                         * @property {string|null} [name] Commitment name
                         * @property {string|null} [plan] Commitment plan
                         * @property {string|null} [region] Commitment region
                         * @property {Array.<google.cloud.compute.v1.IReservation>|null} [reservations] Commitment reservations
                         * @property {Array.<google.cloud.compute.v1.IResourceCommitment>|null} [resources] Commitment resources
                         * @property {string|null} [selfLink] Commitment selfLink
                         * @property {string|null} [splitSourceCommitment] Commitment splitSourceCommitment
                         * @property {string|null} [startTimestamp] Commitment startTimestamp
                         * @property {string|null} [status] Commitment status
                         * @property {string|null} [statusMessage] Commitment statusMessage
                         * @property {string|null} [type] Commitment type
                         */
    
                        /**
                         * Constructs a new Commitment.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Commitment.
                         * @implements ICommitment
                         * @constructor
                         * @param {google.cloud.compute.v1.ICommitment=} [properties] Properties to set
                         */
                        function Commitment(properties) {
                            this.mergeSourceCommitments = [];
                            this.reservations = [];
                            this.resources = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Commitment autoRenew.
                         * @member {boolean|null|undefined} autoRenew
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Commitment.prototype.autoRenew = null;
    
                        /**
                         * Commitment category.
                         * @member {string|null|undefined} category
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Commitment.prototype.category = null;
    
                        /**
                         * Commitment creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Commitment.prototype.creationTimestamp = null;
    
                        /**
                         * Commitment description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Commitment.prototype.description = null;
    
                        /**
                         * Commitment endTimestamp.
                         * @member {string|null|undefined} endTimestamp
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Commitment.prototype.endTimestamp = null;
    
                        /**
                         * Commitment id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Commitment.prototype.id = null;
    
                        /**
                         * Commitment kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Commitment.prototype.kind = null;
    
                        /**
                         * Commitment licenseResource.
                         * @member {google.cloud.compute.v1.ILicenseResourceCommitment|null|undefined} licenseResource
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Commitment.prototype.licenseResource = null;
    
                        /**
                         * Commitment mergeSourceCommitments.
                         * @member {Array.<string>} mergeSourceCommitments
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Commitment.prototype.mergeSourceCommitments = $util.emptyArray;
    
                        /**
                         * Commitment name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Commitment.prototype.name = null;
    
                        /**
                         * Commitment plan.
                         * @member {string|null|undefined} plan
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Commitment.prototype.plan = null;
    
                        /**
                         * Commitment region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Commitment.prototype.region = null;
    
                        /**
                         * Commitment reservations.
                         * @member {Array.<google.cloud.compute.v1.IReservation>} reservations
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Commitment.prototype.reservations = $util.emptyArray;
    
                        /**
                         * Commitment resources.
                         * @member {Array.<google.cloud.compute.v1.IResourceCommitment>} resources
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Commitment.prototype.resources = $util.emptyArray;
    
                        /**
                         * Commitment selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Commitment.prototype.selfLink = null;
    
                        /**
                         * Commitment splitSourceCommitment.
                         * @member {string|null|undefined} splitSourceCommitment
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Commitment.prototype.splitSourceCommitment = null;
    
                        /**
                         * Commitment startTimestamp.
                         * @member {string|null|undefined} startTimestamp
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Commitment.prototype.startTimestamp = null;
    
                        /**
                         * Commitment status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Commitment.prototype.status = null;
    
                        /**
                         * Commitment statusMessage.
                         * @member {string|null|undefined} statusMessage
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Commitment.prototype.statusMessage = null;
    
                        /**
                         * Commitment type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Commitment.prototype.type = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Commitment _autoRenew.
                         * @member {"autoRenew"|undefined} _autoRenew
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Object.defineProperty(Commitment.prototype, "_autoRenew", {
                            get: $util.oneOfGetter($oneOfFields = ["autoRenew"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Commitment _category.
                         * @member {"category"|undefined} _category
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Object.defineProperty(Commitment.prototype, "_category", {
                            get: $util.oneOfGetter($oneOfFields = ["category"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Commitment _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Object.defineProperty(Commitment.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Commitment _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Object.defineProperty(Commitment.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Commitment _endTimestamp.
                         * @member {"endTimestamp"|undefined} _endTimestamp
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Object.defineProperty(Commitment.prototype, "_endTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["endTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Commitment _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Object.defineProperty(Commitment.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Commitment _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Object.defineProperty(Commitment.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Commitment _licenseResource.
                         * @member {"licenseResource"|undefined} _licenseResource
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Object.defineProperty(Commitment.prototype, "_licenseResource", {
                            get: $util.oneOfGetter($oneOfFields = ["licenseResource"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Commitment _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Object.defineProperty(Commitment.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Commitment _plan.
                         * @member {"plan"|undefined} _plan
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Object.defineProperty(Commitment.prototype, "_plan", {
                            get: $util.oneOfGetter($oneOfFields = ["plan"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Commitment _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Object.defineProperty(Commitment.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Commitment _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Object.defineProperty(Commitment.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Commitment _splitSourceCommitment.
                         * @member {"splitSourceCommitment"|undefined} _splitSourceCommitment
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Object.defineProperty(Commitment.prototype, "_splitSourceCommitment", {
                            get: $util.oneOfGetter($oneOfFields = ["splitSourceCommitment"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Commitment _startTimestamp.
                         * @member {"startTimestamp"|undefined} _startTimestamp
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Object.defineProperty(Commitment.prototype, "_startTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["startTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Commitment _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Object.defineProperty(Commitment.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Commitment _statusMessage.
                         * @member {"statusMessage"|undefined} _statusMessage
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Object.defineProperty(Commitment.prototype, "_statusMessage", {
                            get: $util.oneOfGetter($oneOfFields = ["statusMessage"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Commitment _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         */
                        Object.defineProperty(Commitment.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Commitment instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Commitment
                         * @static
                         * @param {google.cloud.compute.v1.ICommitment=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Commitment} Commitment instance
                         */
                        Commitment.create = function create(properties) {
                            return new Commitment(properties);
                        };
    
                        /**
                         * Encodes the specified Commitment message. Does not implicitly {@link google.cloud.compute.v1.Commitment.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Commitment
                         * @static
                         * @param {google.cloud.compute.v1.ICommitment} message Commitment message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Commitment.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.plan != null && Object.hasOwnProperty.call(message, "plan"))
                                writer.uint32(/* id 3443497, wireType 2 =*/27547978).string(message.plan);
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.category != null && Object.hasOwnProperty.call(message, "category"))
                                writer.uint32(/* id 50511102, wireType 2 =*/404088818).string(message.category);
                            if (message.startTimestamp != null && Object.hasOwnProperty.call(message, "startTimestamp"))
                                writer.uint32(/* id 83645817, wireType 2 =*/669166538).string(message.startTimestamp);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resources != null && message.resources.length)
                                for (var i = 0; i < message.resources.length; ++i)
                                    $root.google.cloud.compute.v1.ResourceCommitment.encode(message.resources[i], writer.uint32(/* id 164412965, wireType 2 =*/1315303722).fork()).ldelim();
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.mergeSourceCommitments != null && message.mergeSourceCommitments.length)
                                for (var i = 0; i < message.mergeSourceCommitments.length; ++i)
                                    writer.uint32(/* id 188093761, wireType 2 =*/1504750090).string(message.mergeSourceCommitments[i]);
                            if (message.statusMessage != null && Object.hasOwnProperty.call(message, "statusMessage"))
                                writer.uint32(/* id 297428154, wireType 2 =*/2379425234).string(message.statusMessage);
                            if (message.reservations != null && message.reservations.length)
                                for (var i = 0; i < message.reservations.length; ++i)
                                    $root.google.cloud.compute.v1.Reservation.encode(message.reservations[i], writer.uint32(/* id 399717927, wireType 2 =*/3197743418).fork()).ldelim();
                            if (message.splitSourceCommitment != null && Object.hasOwnProperty.call(message, "splitSourceCommitment"))
                                writer.uint32(/* id 402611156, wireType 2 =*/3220889250).string(message.splitSourceCommitment);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.licenseResource != null && Object.hasOwnProperty.call(message, "licenseResource"))
                                $root.google.cloud.compute.v1.LicenseResourceCommitment.encode(message.licenseResource, writer.uint32(/* id 437955148, wireType 2 =*/3503641186).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.endTimestamp != null && Object.hasOwnProperty.call(message, "endTimestamp"))
                                writer.uint32(/* id 468096690, wireType 2 =*/3744773522).string(message.endTimestamp);
                            if (message.autoRenew != null && Object.hasOwnProperty.call(message, "autoRenew"))
                                writer.uint32(/* id 495520765, wireType 0 =*/3964166120).bool(message.autoRenew);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Commitment message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Commitment.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Commitment
                         * @static
                         * @param {google.cloud.compute.v1.ICommitment} message Commitment message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Commitment.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Commitment message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Commitment
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Commitment} Commitment
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Commitment.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Commitment();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 495520765: {
                                        message.autoRenew = reader.bool();
                                        break;
                                    }
                                case 50511102: {
                                        message.category = reader.string();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 468096690: {
                                        message.endTimestamp = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 437955148: {
                                        message.licenseResource = $root.google.cloud.compute.v1.LicenseResourceCommitment.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 188093761: {
                                        if (!(message.mergeSourceCommitments && message.mergeSourceCommitments.length))
                                            message.mergeSourceCommitments = [];
                                        message.mergeSourceCommitments.push(reader.string());
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 3443497: {
                                        message.plan = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 399717927: {
                                        if (!(message.reservations && message.reservations.length))
                                            message.reservations = [];
                                        message.reservations.push($root.google.cloud.compute.v1.Reservation.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 164412965: {
                                        if (!(message.resources && message.resources.length))
                                            message.resources = [];
                                        message.resources.push($root.google.cloud.compute.v1.ResourceCommitment.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 402611156: {
                                        message.splitSourceCommitment = reader.string();
                                        break;
                                    }
                                case 83645817: {
                                        message.startTimestamp = reader.string();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                case 297428154: {
                                        message.statusMessage = reader.string();
                                        break;
                                    }
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Commitment message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Commitment
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Commitment} Commitment
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Commitment.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Commitment message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Commitment
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Commitment.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoRenew != null && message.hasOwnProperty("autoRenew")) {
                                properties._autoRenew = 1;
                                if (typeof message.autoRenew !== "boolean")
                                    return "autoRenew: boolean expected";
                            }
                            if (message.category != null && message.hasOwnProperty("category")) {
                                properties._category = 1;
                                if (!$util.isString(message.category))
                                    return "category: string expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.endTimestamp != null && message.hasOwnProperty("endTimestamp")) {
                                properties._endTimestamp = 1;
                                if (!$util.isString(message.endTimestamp))
                                    return "endTimestamp: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.licenseResource != null && message.hasOwnProperty("licenseResource")) {
                                properties._licenseResource = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.LicenseResourceCommitment.verify(message.licenseResource);
                                    if (error)
                                        return "licenseResource." + error;
                                }
                            }
                            if (message.mergeSourceCommitments != null && message.hasOwnProperty("mergeSourceCommitments")) {
                                if (!Array.isArray(message.mergeSourceCommitments))
                                    return "mergeSourceCommitments: array expected";
                                for (var i = 0; i < message.mergeSourceCommitments.length; ++i)
                                    if (!$util.isString(message.mergeSourceCommitments[i]))
                                        return "mergeSourceCommitments: string[] expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.plan != null && message.hasOwnProperty("plan")) {
                                properties._plan = 1;
                                if (!$util.isString(message.plan))
                                    return "plan: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.reservations != null && message.hasOwnProperty("reservations")) {
                                if (!Array.isArray(message.reservations))
                                    return "reservations: array expected";
                                for (var i = 0; i < message.reservations.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Reservation.verify(message.reservations[i]);
                                    if (error)
                                        return "reservations." + error;
                                }
                            }
                            if (message.resources != null && message.hasOwnProperty("resources")) {
                                if (!Array.isArray(message.resources))
                                    return "resources: array expected";
                                for (var i = 0; i < message.resources.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ResourceCommitment.verify(message.resources[i]);
                                    if (error)
                                        return "resources." + error;
                                }
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.splitSourceCommitment != null && message.hasOwnProperty("splitSourceCommitment")) {
                                properties._splitSourceCommitment = 1;
                                if (!$util.isString(message.splitSourceCommitment))
                                    return "splitSourceCommitment: string expected";
                            }
                            if (message.startTimestamp != null && message.hasOwnProperty("startTimestamp")) {
                                properties._startTimestamp = 1;
                                if (!$util.isString(message.startTimestamp))
                                    return "startTimestamp: string expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            if (message.statusMessage != null && message.hasOwnProperty("statusMessage")) {
                                properties._statusMessage = 1;
                                if (!$util.isString(message.statusMessage))
                                    return "statusMessage: string expected";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Commitment message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Commitment
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Commitment} Commitment
                         */
                        Commitment.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Commitment)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Commitment();
                            if (object.autoRenew != null)
                                message.autoRenew = Boolean(object.autoRenew);
                            if (object.category != null)
                                message.category = String(object.category);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.endTimestamp != null)
                                message.endTimestamp = String(object.endTimestamp);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.licenseResource != null) {
                                if (typeof object.licenseResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Commitment.licenseResource: object expected");
                                message.licenseResource = $root.google.cloud.compute.v1.LicenseResourceCommitment.fromObject(object.licenseResource);
                            }
                            if (object.mergeSourceCommitments) {
                                if (!Array.isArray(object.mergeSourceCommitments))
                                    throw TypeError(".google.cloud.compute.v1.Commitment.mergeSourceCommitments: array expected");
                                message.mergeSourceCommitments = [];
                                for (var i = 0; i < object.mergeSourceCommitments.length; ++i)
                                    message.mergeSourceCommitments[i] = String(object.mergeSourceCommitments[i]);
                            }
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.plan != null)
                                message.plan = String(object.plan);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.reservations) {
                                if (!Array.isArray(object.reservations))
                                    throw TypeError(".google.cloud.compute.v1.Commitment.reservations: array expected");
                                message.reservations = [];
                                for (var i = 0; i < object.reservations.length; ++i) {
                                    if (typeof object.reservations[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Commitment.reservations: object expected");
                                    message.reservations[i] = $root.google.cloud.compute.v1.Reservation.fromObject(object.reservations[i]);
                                }
                            }
                            if (object.resources) {
                                if (!Array.isArray(object.resources))
                                    throw TypeError(".google.cloud.compute.v1.Commitment.resources: array expected");
                                message.resources = [];
                                for (var i = 0; i < object.resources.length; ++i) {
                                    if (typeof object.resources[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Commitment.resources: object expected");
                                    message.resources[i] = $root.google.cloud.compute.v1.ResourceCommitment.fromObject(object.resources[i]);
                                }
                            }
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.splitSourceCommitment != null)
                                message.splitSourceCommitment = String(object.splitSourceCommitment);
                            if (object.startTimestamp != null)
                                message.startTimestamp = String(object.startTimestamp);
                            if (object.status != null)
                                message.status = String(object.status);
                            if (object.statusMessage != null)
                                message.statusMessage = String(object.statusMessage);
                            if (object.type != null)
                                message.type = String(object.type);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Commitment message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Commitment
                         * @static
                         * @param {google.cloud.compute.v1.Commitment} message Commitment
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Commitment.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.resources = [];
                                object.mergeSourceCommitments = [];
                                object.reservations = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.plan != null && message.hasOwnProperty("plan")) {
                                object.plan = message.plan;
                                if (options.oneofs)
                                    object._plan = "plan";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.category != null && message.hasOwnProperty("category")) {
                                object.category = message.category;
                                if (options.oneofs)
                                    object._category = "category";
                            }
                            if (message.startTimestamp != null && message.hasOwnProperty("startTimestamp")) {
                                object.startTimestamp = message.startTimestamp;
                                if (options.oneofs)
                                    object._startTimestamp = "startTimestamp";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.resources && message.resources.length) {
                                object.resources = [];
                                for (var j = 0; j < message.resources.length; ++j)
                                    object.resources[j] = $root.google.cloud.compute.v1.ResourceCommitment.toObject(message.resources[j], options);
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.mergeSourceCommitments && message.mergeSourceCommitments.length) {
                                object.mergeSourceCommitments = [];
                                for (var j = 0; j < message.mergeSourceCommitments.length; ++j)
                                    object.mergeSourceCommitments[j] = message.mergeSourceCommitments[j];
                            }
                            if (message.statusMessage != null && message.hasOwnProperty("statusMessage")) {
                                object.statusMessage = message.statusMessage;
                                if (options.oneofs)
                                    object._statusMessage = "statusMessage";
                            }
                            if (message.reservations && message.reservations.length) {
                                object.reservations = [];
                                for (var j = 0; j < message.reservations.length; ++j)
                                    object.reservations[j] = $root.google.cloud.compute.v1.Reservation.toObject(message.reservations[j], options);
                            }
                            if (message.splitSourceCommitment != null && message.hasOwnProperty("splitSourceCommitment")) {
                                object.splitSourceCommitment = message.splitSourceCommitment;
                                if (options.oneofs)
                                    object._splitSourceCommitment = "splitSourceCommitment";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.licenseResource != null && message.hasOwnProperty("licenseResource")) {
                                object.licenseResource = $root.google.cloud.compute.v1.LicenseResourceCommitment.toObject(message.licenseResource, options);
                                if (options.oneofs)
                                    object._licenseResource = "licenseResource";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.endTimestamp != null && message.hasOwnProperty("endTimestamp")) {
                                object.endTimestamp = message.endTimestamp;
                                if (options.oneofs)
                                    object._endTimestamp = "endTimestamp";
                            }
                            if (message.autoRenew != null && message.hasOwnProperty("autoRenew")) {
                                object.autoRenew = message.autoRenew;
                                if (options.oneofs)
                                    object._autoRenew = "autoRenew";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Commitment to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Commitment
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Commitment.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Commitment
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Commitment
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Commitment.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Commitment";
                        };
    
                        /**
                         * Category enum.
                         * @name google.cloud.compute.v1.Commitment.Category
                         * @enum {number}
                         * @property {number} UNDEFINED_CATEGORY=0 UNDEFINED_CATEGORY value
                         * @property {number} CATEGORY_UNSPECIFIED=509189462 CATEGORY_UNSPECIFIED value
                         * @property {number} LICENSE=347869217 LICENSE value
                         * @property {number} MACHINE=469553191 MACHINE value
                         */
                        Commitment.Category = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_CATEGORY"] = 0;
                            values[valuesById[509189462] = "CATEGORY_UNSPECIFIED"] = 509189462;
                            values[valuesById[347869217] = "LICENSE"] = 347869217;
                            values[valuesById[469553191] = "MACHINE"] = 469553191;
                            return values;
                        })();
    
                        /**
                         * Plan enum.
                         * @name google.cloud.compute.v1.Commitment.Plan
                         * @enum {number}
                         * @property {number} UNDEFINED_PLAN=0 UNDEFINED_PLAN value
                         * @property {number} INVALID=530283991 INVALID value
                         * @property {number} THIRTY_SIX_MONTH=266295942 THIRTY_SIX_MONTH value
                         * @property {number} TWELVE_MONTH=173083962 TWELVE_MONTH value
                         */
                        Commitment.Plan = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PLAN"] = 0;
                            values[valuesById[530283991] = "INVALID"] = 530283991;
                            values[valuesById[266295942] = "THIRTY_SIX_MONTH"] = 266295942;
                            values[valuesById[173083962] = "TWELVE_MONTH"] = 173083962;
                            return values;
                        })();
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.Commitment.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} ACTIVE=314733318 ACTIVE value
                         * @property {number} CANCELLED=41957681 CANCELLED value
                         * @property {number} CREATING=455564985 CREATING value
                         * @property {number} EXPIRED=482489093 EXPIRED value
                         * @property {number} NOT_YET_ACTIVE=20607337 NOT_YET_ACTIVE value
                         */
                        Commitment.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[314733318] = "ACTIVE"] = 314733318;
                            values[valuesById[41957681] = "CANCELLED"] = 41957681;
                            values[valuesById[455564985] = "CREATING"] = 455564985;
                            values[valuesById[482489093] = "EXPIRED"] = 482489093;
                            values[valuesById[20607337] = "NOT_YET_ACTIVE"] = 20607337;
                            return values;
                        })();
    
                        /**
                         * Type enum.
                         * @name google.cloud.compute.v1.Commitment.Type
                         * @enum {number}
                         * @property {number} UNDEFINED_TYPE=0 UNDEFINED_TYPE value
                         * @property {number} ACCELERATOR_OPTIMIZED=280848403 ACCELERATOR_OPTIMIZED value
                         * @property {number} COMPUTE_OPTIMIZED=158349023 COMPUTE_OPTIMIZED value
                         * @property {number} COMPUTE_OPTIMIZED_C2D=383246453 COMPUTE_OPTIMIZED_C2D value
                         * @property {number} GENERAL_PURPOSE=299793543 GENERAL_PURPOSE value
                         * @property {number} GENERAL_PURPOSE_E2=301911877 GENERAL_PURPOSE_E2 value
                         * @property {number} GENERAL_PURPOSE_N2=301912156 GENERAL_PURPOSE_N2 value
                         * @property {number} GENERAL_PURPOSE_N2D=232471400 GENERAL_PURPOSE_N2D value
                         * @property {number} GENERAL_PURPOSE_T2D=232477166 GENERAL_PURPOSE_T2D value
                         * @property {number} MEMORY_OPTIMIZED=281753417 MEMORY_OPTIMIZED value
                         * @property {number} MEMORY_OPTIMIZED_M3=276301372 MEMORY_OPTIMIZED_M3 value
                         * @property {number} TYPE_UNSPECIFIED=437714322 TYPE_UNSPECIFIED value
                         */
                        Commitment.Type = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TYPE"] = 0;
                            values[valuesById[280848403] = "ACCELERATOR_OPTIMIZED"] = 280848403;
                            values[valuesById[158349023] = "COMPUTE_OPTIMIZED"] = 158349023;
                            values[valuesById[383246453] = "COMPUTE_OPTIMIZED_C2D"] = 383246453;
                            values[valuesById[299793543] = "GENERAL_PURPOSE"] = 299793543;
                            values[valuesById[301911877] = "GENERAL_PURPOSE_E2"] = 301911877;
                            values[valuesById[301912156] = "GENERAL_PURPOSE_N2"] = 301912156;
                            values[valuesById[232471400] = "GENERAL_PURPOSE_N2D"] = 232471400;
                            values[valuesById[232477166] = "GENERAL_PURPOSE_T2D"] = 232477166;
                            values[valuesById[281753417] = "MEMORY_OPTIMIZED"] = 281753417;
                            values[valuesById[276301372] = "MEMORY_OPTIMIZED_M3"] = 276301372;
                            values[valuesById[437714322] = "TYPE_UNSPECIFIED"] = 437714322;
                            return values;
                        })();
    
                        return Commitment;
                    })();
    
                    v1.CommitmentAggregatedList = (function() {
    
                        /**
                         * Properties of a CommitmentAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface ICommitmentAggregatedList
                         * @property {string|null} [id] CommitmentAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.ICommitmentsScopedList>|null} [items] CommitmentAggregatedList items
                         * @property {string|null} [kind] CommitmentAggregatedList kind
                         * @property {string|null} [nextPageToken] CommitmentAggregatedList nextPageToken
                         * @property {string|null} [selfLink] CommitmentAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] CommitmentAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] CommitmentAggregatedList warning
                         */
    
                        /**
                         * Constructs a new CommitmentAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a CommitmentAggregatedList.
                         * @implements ICommitmentAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.ICommitmentAggregatedList=} [properties] Properties to set
                         */
                        function CommitmentAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CommitmentAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @instance
                         */
                        CommitmentAggregatedList.prototype.id = null;
    
                        /**
                         * CommitmentAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.ICommitmentsScopedList>} items
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @instance
                         */
                        CommitmentAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * CommitmentAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @instance
                         */
                        CommitmentAggregatedList.prototype.kind = null;
    
                        /**
                         * CommitmentAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @instance
                         */
                        CommitmentAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * CommitmentAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @instance
                         */
                        CommitmentAggregatedList.prototype.selfLink = null;
    
                        /**
                         * CommitmentAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @instance
                         */
                        CommitmentAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * CommitmentAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @instance
                         */
                        CommitmentAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * CommitmentAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @instance
                         */
                        Object.defineProperty(CommitmentAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CommitmentAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @instance
                         */
                        Object.defineProperty(CommitmentAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CommitmentAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @instance
                         */
                        Object.defineProperty(CommitmentAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CommitmentAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @instance
                         */
                        Object.defineProperty(CommitmentAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CommitmentAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @instance
                         */
                        Object.defineProperty(CommitmentAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new CommitmentAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ICommitmentAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.CommitmentAggregatedList} CommitmentAggregatedList instance
                         */
                        CommitmentAggregatedList.create = function create(properties) {
                            return new CommitmentAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified CommitmentAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.CommitmentAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ICommitmentAggregatedList} message CommitmentAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CommitmentAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.CommitmentsScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CommitmentAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.CommitmentAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ICommitmentAggregatedList} message CommitmentAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CommitmentAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CommitmentAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.CommitmentAggregatedList} CommitmentAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CommitmentAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.CommitmentAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.CommitmentsScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CommitmentAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.CommitmentAggregatedList} CommitmentAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CommitmentAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CommitmentAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CommitmentAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.CommitmentsScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CommitmentAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.CommitmentAggregatedList} CommitmentAggregatedList
                         */
                        CommitmentAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.CommitmentAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.CommitmentAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.CommitmentAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.CommitmentAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.CommitmentsScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.CommitmentAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.CommitmentAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CommitmentAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.CommitmentAggregatedList} message CommitmentAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CommitmentAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.CommitmentsScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this CommitmentAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CommitmentAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CommitmentAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.CommitmentAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CommitmentAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.CommitmentAggregatedList";
                        };
    
                        return CommitmentAggregatedList;
                    })();
    
                    v1.CommitmentList = (function() {
    
                        /**
                         * Properties of a CommitmentList.
                         * @memberof google.cloud.compute.v1
                         * @interface ICommitmentList
                         * @property {string|null} [id] CommitmentList id
                         * @property {Array.<google.cloud.compute.v1.ICommitment>|null} [items] CommitmentList items
                         * @property {string|null} [kind] CommitmentList kind
                         * @property {string|null} [nextPageToken] CommitmentList nextPageToken
                         * @property {string|null} [selfLink] CommitmentList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] CommitmentList warning
                         */
    
                        /**
                         * Constructs a new CommitmentList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a CommitmentList.
                         * @implements ICommitmentList
                         * @constructor
                         * @param {google.cloud.compute.v1.ICommitmentList=} [properties] Properties to set
                         */
                        function CommitmentList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CommitmentList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @instance
                         */
                        CommitmentList.prototype.id = null;
    
                        /**
                         * CommitmentList items.
                         * @member {Array.<google.cloud.compute.v1.ICommitment>} items
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @instance
                         */
                        CommitmentList.prototype.items = $util.emptyArray;
    
                        /**
                         * CommitmentList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @instance
                         */
                        CommitmentList.prototype.kind = null;
    
                        /**
                         * CommitmentList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @instance
                         */
                        CommitmentList.prototype.nextPageToken = null;
    
                        /**
                         * CommitmentList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @instance
                         */
                        CommitmentList.prototype.selfLink = null;
    
                        /**
                         * CommitmentList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @instance
                         */
                        CommitmentList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * CommitmentList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @instance
                         */
                        Object.defineProperty(CommitmentList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CommitmentList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @instance
                         */
                        Object.defineProperty(CommitmentList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CommitmentList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @instance
                         */
                        Object.defineProperty(CommitmentList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CommitmentList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @instance
                         */
                        Object.defineProperty(CommitmentList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CommitmentList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @instance
                         */
                        Object.defineProperty(CommitmentList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new CommitmentList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @static
                         * @param {google.cloud.compute.v1.ICommitmentList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.CommitmentList} CommitmentList instance
                         */
                        CommitmentList.create = function create(properties) {
                            return new CommitmentList(properties);
                        };
    
                        /**
                         * Encodes the specified CommitmentList message. Does not implicitly {@link google.cloud.compute.v1.CommitmentList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @static
                         * @param {google.cloud.compute.v1.ICommitmentList} message CommitmentList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CommitmentList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Commitment.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CommitmentList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.CommitmentList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @static
                         * @param {google.cloud.compute.v1.ICommitmentList} message CommitmentList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CommitmentList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CommitmentList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.CommitmentList} CommitmentList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CommitmentList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.CommitmentList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Commitment.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CommitmentList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.CommitmentList} CommitmentList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CommitmentList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CommitmentList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CommitmentList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Commitment.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CommitmentList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.CommitmentList} CommitmentList
                         */
                        CommitmentList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.CommitmentList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.CommitmentList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.CommitmentList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.CommitmentList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Commitment.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.CommitmentList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CommitmentList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @static
                         * @param {google.cloud.compute.v1.CommitmentList} message CommitmentList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CommitmentList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Commitment.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this CommitmentList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CommitmentList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CommitmentList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.CommitmentList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CommitmentList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.CommitmentList";
                        };
    
                        return CommitmentList;
                    })();
    
                    v1.CommitmentsScopedList = (function() {
    
                        /**
                         * Properties of a CommitmentsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface ICommitmentsScopedList
                         * @property {Array.<google.cloud.compute.v1.ICommitment>|null} [commitments] CommitmentsScopedList commitments
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] CommitmentsScopedList warning
                         */
    
                        /**
                         * Constructs a new CommitmentsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a CommitmentsScopedList.
                         * @implements ICommitmentsScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.ICommitmentsScopedList=} [properties] Properties to set
                         */
                        function CommitmentsScopedList(properties) {
                            this.commitments = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CommitmentsScopedList commitments.
                         * @member {Array.<google.cloud.compute.v1.ICommitment>} commitments
                         * @memberof google.cloud.compute.v1.CommitmentsScopedList
                         * @instance
                         */
                        CommitmentsScopedList.prototype.commitments = $util.emptyArray;
    
                        /**
                         * CommitmentsScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.CommitmentsScopedList
                         * @instance
                         */
                        CommitmentsScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * CommitmentsScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.CommitmentsScopedList
                         * @instance
                         */
                        Object.defineProperty(CommitmentsScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new CommitmentsScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.CommitmentsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ICommitmentsScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.CommitmentsScopedList} CommitmentsScopedList instance
                         */
                        CommitmentsScopedList.create = function create(properties) {
                            return new CommitmentsScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified CommitmentsScopedList message. Does not implicitly {@link google.cloud.compute.v1.CommitmentsScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.CommitmentsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ICommitmentsScopedList} message CommitmentsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CommitmentsScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.commitments != null && message.commitments.length)
                                for (var i = 0; i < message.commitments.length; ++i)
                                    $root.google.cloud.compute.v1.Commitment.encode(message.commitments[i], writer.uint32(/* id 450664446, wireType 2 =*/3605315570).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CommitmentsScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.CommitmentsScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.CommitmentsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ICommitmentsScopedList} message CommitmentsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CommitmentsScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CommitmentsScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.CommitmentsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.CommitmentsScopedList} CommitmentsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CommitmentsScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.CommitmentsScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 450664446: {
                                        if (!(message.commitments && message.commitments.length))
                                            message.commitments = [];
                                        message.commitments.push($root.google.cloud.compute.v1.Commitment.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CommitmentsScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.CommitmentsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.CommitmentsScopedList} CommitmentsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CommitmentsScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CommitmentsScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.CommitmentsScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CommitmentsScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.commitments != null && message.hasOwnProperty("commitments")) {
                                if (!Array.isArray(message.commitments))
                                    return "commitments: array expected";
                                for (var i = 0; i < message.commitments.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Commitment.verify(message.commitments[i]);
                                    if (error)
                                        return "commitments." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CommitmentsScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.CommitmentsScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.CommitmentsScopedList} CommitmentsScopedList
                         */
                        CommitmentsScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.CommitmentsScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.CommitmentsScopedList();
                            if (object.commitments) {
                                if (!Array.isArray(object.commitments))
                                    throw TypeError(".google.cloud.compute.v1.CommitmentsScopedList.commitments: array expected");
                                message.commitments = [];
                                for (var i = 0; i < object.commitments.length; ++i) {
                                    if (typeof object.commitments[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.CommitmentsScopedList.commitments: object expected");
                                    message.commitments[i] = $root.google.cloud.compute.v1.Commitment.fromObject(object.commitments[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.CommitmentsScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CommitmentsScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.CommitmentsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.CommitmentsScopedList} message CommitmentsScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CommitmentsScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.commitments = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.commitments && message.commitments.length) {
                                object.commitments = [];
                                for (var j = 0; j < message.commitments.length; ++j)
                                    object.commitments[j] = $root.google.cloud.compute.v1.Commitment.toObject(message.commitments[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this CommitmentsScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.CommitmentsScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CommitmentsScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CommitmentsScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.CommitmentsScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CommitmentsScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.CommitmentsScopedList";
                        };
    
                        return CommitmentsScopedList;
                    })();
    
                    v1.Condition = (function() {
    
                        /**
                         * Properties of a Condition.
                         * @memberof google.cloud.compute.v1
                         * @interface ICondition
                         * @property {string|null} [iam] Condition iam
                         * @property {string|null} [op] Condition op
                         * @property {string|null} [svc] Condition svc
                         * @property {string|null} [sys] Condition sys
                         * @property {Array.<string>|null} [values] Condition values
                         */
    
                        /**
                         * Constructs a new Condition.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Condition.
                         * @implements ICondition
                         * @constructor
                         * @param {google.cloud.compute.v1.ICondition=} [properties] Properties to set
                         */
                        function Condition(properties) {
                            this.values = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Condition iam.
                         * @member {string|null|undefined} iam
                         * @memberof google.cloud.compute.v1.Condition
                         * @instance
                         */
                        Condition.prototype.iam = null;
    
                        /**
                         * Condition op.
                         * @member {string|null|undefined} op
                         * @memberof google.cloud.compute.v1.Condition
                         * @instance
                         */
                        Condition.prototype.op = null;
    
                        /**
                         * Condition svc.
                         * @member {string|null|undefined} svc
                         * @memberof google.cloud.compute.v1.Condition
                         * @instance
                         */
                        Condition.prototype.svc = null;
    
                        /**
                         * Condition sys.
                         * @member {string|null|undefined} sys
                         * @memberof google.cloud.compute.v1.Condition
                         * @instance
                         */
                        Condition.prototype.sys = null;
    
                        /**
                         * Condition values.
                         * @member {Array.<string>} values
                         * @memberof google.cloud.compute.v1.Condition
                         * @instance
                         */
                        Condition.prototype.values = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Condition _iam.
                         * @member {"iam"|undefined} _iam
                         * @memberof google.cloud.compute.v1.Condition
                         * @instance
                         */
                        Object.defineProperty(Condition.prototype, "_iam", {
                            get: $util.oneOfGetter($oneOfFields = ["iam"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Condition _op.
                         * @member {"op"|undefined} _op
                         * @memberof google.cloud.compute.v1.Condition
                         * @instance
                         */
                        Object.defineProperty(Condition.prototype, "_op", {
                            get: $util.oneOfGetter($oneOfFields = ["op"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Condition _svc.
                         * @member {"svc"|undefined} _svc
                         * @memberof google.cloud.compute.v1.Condition
                         * @instance
                         */
                        Object.defineProperty(Condition.prototype, "_svc", {
                            get: $util.oneOfGetter($oneOfFields = ["svc"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Condition _sys.
                         * @member {"sys"|undefined} _sys
                         * @memberof google.cloud.compute.v1.Condition
                         * @instance
                         */
                        Object.defineProperty(Condition.prototype, "_sys", {
                            get: $util.oneOfGetter($oneOfFields = ["sys"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Condition instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Condition
                         * @static
                         * @param {google.cloud.compute.v1.ICondition=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Condition} Condition instance
                         */
                        Condition.create = function create(properties) {
                            return new Condition(properties);
                        };
    
                        /**
                         * Encodes the specified Condition message. Does not implicitly {@link google.cloud.compute.v1.Condition.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Condition
                         * @static
                         * @param {google.cloud.compute.v1.ICondition} message Condition message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Condition.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.op != null && Object.hasOwnProperty.call(message, "op"))
                                writer.uint32(/* id 3553, wireType 2 =*/28426).string(message.op);
                            if (message.iam != null && Object.hasOwnProperty.call(message, "iam"))
                                writer.uint32(/* id 104021, wireType 2 =*/832170).string(message.iam);
                            if (message.svc != null && Object.hasOwnProperty.call(message, "svc"))
                                writer.uint32(/* id 114272, wireType 2 =*/914178).string(message.svc);
                            if (message.sys != null && Object.hasOwnProperty.call(message, "sys"))
                                writer.uint32(/* id 114381, wireType 2 =*/915050).string(message.sys);
                            if (message.values != null && message.values.length)
                                for (var i = 0; i < message.values.length; ++i)
                                    writer.uint32(/* id 249928994, wireType 2 =*/1999431954).string(message.values[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Condition message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Condition.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Condition
                         * @static
                         * @param {google.cloud.compute.v1.ICondition} message Condition message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Condition.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Condition message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Condition
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Condition} Condition
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Condition.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Condition();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 104021: {
                                        message.iam = reader.string();
                                        break;
                                    }
                                case 3553: {
                                        message.op = reader.string();
                                        break;
                                    }
                                case 114272: {
                                        message.svc = reader.string();
                                        break;
                                    }
                                case 114381: {
                                        message.sys = reader.string();
                                        break;
                                    }
                                case 249928994: {
                                        if (!(message.values && message.values.length))
                                            message.values = [];
                                        message.values.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Condition message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Condition
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Condition} Condition
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Condition.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Condition message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Condition
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Condition.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.iam != null && message.hasOwnProperty("iam")) {
                                properties._iam = 1;
                                if (!$util.isString(message.iam))
                                    return "iam: string expected";
                            }
                            if (message.op != null && message.hasOwnProperty("op")) {
                                properties._op = 1;
                                if (!$util.isString(message.op))
                                    return "op: string expected";
                            }
                            if (message.svc != null && message.hasOwnProperty("svc")) {
                                properties._svc = 1;
                                if (!$util.isString(message.svc))
                                    return "svc: string expected";
                            }
                            if (message.sys != null && message.hasOwnProperty("sys")) {
                                properties._sys = 1;
                                if (!$util.isString(message.sys))
                                    return "sys: string expected";
                            }
                            if (message.values != null && message.hasOwnProperty("values")) {
                                if (!Array.isArray(message.values))
                                    return "values: array expected";
                                for (var i = 0; i < message.values.length; ++i)
                                    if (!$util.isString(message.values[i]))
                                        return "values: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Condition message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Condition
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Condition} Condition
                         */
                        Condition.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Condition)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Condition();
                            if (object.iam != null)
                                message.iam = String(object.iam);
                            if (object.op != null)
                                message.op = String(object.op);
                            if (object.svc != null)
                                message.svc = String(object.svc);
                            if (object.sys != null)
                                message.sys = String(object.sys);
                            if (object.values) {
                                if (!Array.isArray(object.values))
                                    throw TypeError(".google.cloud.compute.v1.Condition.values: array expected");
                                message.values = [];
                                for (var i = 0; i < object.values.length; ++i)
                                    message.values[i] = String(object.values[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Condition message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Condition
                         * @static
                         * @param {google.cloud.compute.v1.Condition} message Condition
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Condition.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.values = [];
                            if (message.op != null && message.hasOwnProperty("op")) {
                                object.op = message.op;
                                if (options.oneofs)
                                    object._op = "op";
                            }
                            if (message.iam != null && message.hasOwnProperty("iam")) {
                                object.iam = message.iam;
                                if (options.oneofs)
                                    object._iam = "iam";
                            }
                            if (message.svc != null && message.hasOwnProperty("svc")) {
                                object.svc = message.svc;
                                if (options.oneofs)
                                    object._svc = "svc";
                            }
                            if (message.sys != null && message.hasOwnProperty("sys")) {
                                object.sys = message.sys;
                                if (options.oneofs)
                                    object._sys = "sys";
                            }
                            if (message.values && message.values.length) {
                                object.values = [];
                                for (var j = 0; j < message.values.length; ++j)
                                    object.values[j] = message.values[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Condition to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Condition
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Condition.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Condition
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Condition
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Condition.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Condition";
                        };
    
                        /**
                         * Iam enum.
                         * @name google.cloud.compute.v1.Condition.Iam
                         * @enum {number}
                         * @property {number} UNDEFINED_IAM=0 UNDEFINED_IAM value
                         * @property {number} APPROVER=357258949 APPROVER value
                         * @property {number} ATTRIBUTION=232465503 ATTRIBUTION value
                         * @property {number} AUTHORITY=504108835 AUTHORITY value
                         * @property {number} CREDENTIALS_TYPE=348222141 CREDENTIALS_TYPE value
                         * @property {number} CREDS_ASSERTION=332343272 CREDS_ASSERTION value
                         * @property {number} JUSTIFICATION_TYPE=206147719 JUSTIFICATION_TYPE value
                         * @property {number} SECURITY_REALM=526269616 SECURITY_REALM value
                         */
                        Condition.Iam = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_IAM"] = 0;
                            values[valuesById[357258949] = "APPROVER"] = 357258949;
                            values[valuesById[232465503] = "ATTRIBUTION"] = 232465503;
                            values[valuesById[504108835] = "AUTHORITY"] = 504108835;
                            values[valuesById[348222141] = "CREDENTIALS_TYPE"] = 348222141;
                            values[valuesById[332343272] = "CREDS_ASSERTION"] = 332343272;
                            values[valuesById[206147719] = "JUSTIFICATION_TYPE"] = 206147719;
                            values[valuesById[526269616] = "SECURITY_REALM"] = 526269616;
                            return values;
                        })();
    
                        /**
                         * Op enum.
                         * @name google.cloud.compute.v1.Condition.Op
                         * @enum {number}
                         * @property {number} UNDEFINED_OP=0 UNDEFINED_OP value
                         * @property {number} DISCHARGED=266338274 DISCHARGED value
                         * @property {number} EQUALS=442201023 EQUALS value
                         * @property {number} IN=2341 IN value
                         * @property {number} NOT_EQUALS=19718859 NOT_EQUALS value
                         * @property {number} NOT_IN=161144369 NOT_IN value
                         * @property {number} NO_OP=74481951 NO_OP value
                         */
                        Condition.Op = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_OP"] = 0;
                            values[valuesById[266338274] = "DISCHARGED"] = 266338274;
                            values[valuesById[442201023] = "EQUALS"] = 442201023;
                            values[valuesById[2341] = "IN"] = 2341;
                            values[valuesById[19718859] = "NOT_EQUALS"] = 19718859;
                            values[valuesById[161144369] = "NOT_IN"] = 161144369;
                            values[valuesById[74481951] = "NO_OP"] = 74481951;
                            return values;
                        })();
    
                        /**
                         * Sys enum.
                         * @name google.cloud.compute.v1.Condition.Sys
                         * @enum {number}
                         * @property {number} UNDEFINED_SYS=0 UNDEFINED_SYS value
                         * @property {number} IP=2343 IP value
                         * @property {number} NAME=2388619 NAME value
                         * @property {number} REGION=266017524 REGION value
                         * @property {number} SERVICE=17781397 SERVICE value
                         */
                        Condition.Sys = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_SYS"] = 0;
                            values[valuesById[2343] = "IP"] = 2343;
                            values[valuesById[2388619] = "NAME"] = 2388619;
                            values[valuesById[266017524] = "REGION"] = 266017524;
                            values[valuesById[17781397] = "SERVICE"] = 17781397;
                            return values;
                        })();
    
                        return Condition;
                    })();
    
                    v1.ConfidentialInstanceConfig = (function() {
    
                        /**
                         * Properties of a ConfidentialInstanceConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface IConfidentialInstanceConfig
                         * @property {boolean|null} [enableConfidentialCompute] ConfidentialInstanceConfig enableConfidentialCompute
                         */
    
                        /**
                         * Constructs a new ConfidentialInstanceConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ConfidentialInstanceConfig.
                         * @implements IConfidentialInstanceConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.IConfidentialInstanceConfig=} [properties] Properties to set
                         */
                        function ConfidentialInstanceConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ConfidentialInstanceConfig enableConfidentialCompute.
                         * @member {boolean|null|undefined} enableConfidentialCompute
                         * @memberof google.cloud.compute.v1.ConfidentialInstanceConfig
                         * @instance
                         */
                        ConfidentialInstanceConfig.prototype.enableConfidentialCompute = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ConfidentialInstanceConfig _enableConfidentialCompute.
                         * @member {"enableConfidentialCompute"|undefined} _enableConfidentialCompute
                         * @memberof google.cloud.compute.v1.ConfidentialInstanceConfig
                         * @instance
                         */
                        Object.defineProperty(ConfidentialInstanceConfig.prototype, "_enableConfidentialCompute", {
                            get: $util.oneOfGetter($oneOfFields = ["enableConfidentialCompute"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ConfidentialInstanceConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ConfidentialInstanceConfig
                         * @static
                         * @param {google.cloud.compute.v1.IConfidentialInstanceConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ConfidentialInstanceConfig} ConfidentialInstanceConfig instance
                         */
                        ConfidentialInstanceConfig.create = function create(properties) {
                            return new ConfidentialInstanceConfig(properties);
                        };
    
                        /**
                         * Encodes the specified ConfidentialInstanceConfig message. Does not implicitly {@link google.cloud.compute.v1.ConfidentialInstanceConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ConfidentialInstanceConfig
                         * @static
                         * @param {google.cloud.compute.v1.IConfidentialInstanceConfig} message ConfidentialInstanceConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConfidentialInstanceConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.enableConfidentialCompute != null && Object.hasOwnProperty.call(message, "enableConfidentialCompute"))
                                writer.uint32(/* id 102135228, wireType 0 =*/817081824).bool(message.enableConfidentialCompute);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ConfidentialInstanceConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ConfidentialInstanceConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ConfidentialInstanceConfig
                         * @static
                         * @param {google.cloud.compute.v1.IConfidentialInstanceConfig} message ConfidentialInstanceConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConfidentialInstanceConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ConfidentialInstanceConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ConfidentialInstanceConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ConfidentialInstanceConfig} ConfidentialInstanceConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConfidentialInstanceConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ConfidentialInstanceConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 102135228: {
                                        message.enableConfidentialCompute = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ConfidentialInstanceConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ConfidentialInstanceConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ConfidentialInstanceConfig} ConfidentialInstanceConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConfidentialInstanceConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ConfidentialInstanceConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ConfidentialInstanceConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConfidentialInstanceConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.enableConfidentialCompute != null && message.hasOwnProperty("enableConfidentialCompute")) {
                                properties._enableConfidentialCompute = 1;
                                if (typeof message.enableConfidentialCompute !== "boolean")
                                    return "enableConfidentialCompute: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ConfidentialInstanceConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ConfidentialInstanceConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ConfidentialInstanceConfig} ConfidentialInstanceConfig
                         */
                        ConfidentialInstanceConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ConfidentialInstanceConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ConfidentialInstanceConfig();
                            if (object.enableConfidentialCompute != null)
                                message.enableConfidentialCompute = Boolean(object.enableConfidentialCompute);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ConfidentialInstanceConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ConfidentialInstanceConfig
                         * @static
                         * @param {google.cloud.compute.v1.ConfidentialInstanceConfig} message ConfidentialInstanceConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConfidentialInstanceConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.enableConfidentialCompute != null && message.hasOwnProperty("enableConfidentialCompute")) {
                                object.enableConfidentialCompute = message.enableConfidentialCompute;
                                if (options.oneofs)
                                    object._enableConfidentialCompute = "enableConfidentialCompute";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ConfidentialInstanceConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ConfidentialInstanceConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConfidentialInstanceConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ConfidentialInstanceConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ConfidentialInstanceConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ConfidentialInstanceConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ConfidentialInstanceConfig";
                        };
    
                        return ConfidentialInstanceConfig;
                    })();
    
                    v1.ConnectionDraining = (function() {
    
                        /**
                         * Properties of a ConnectionDraining.
                         * @memberof google.cloud.compute.v1
                         * @interface IConnectionDraining
                         * @property {number|null} [drainingTimeoutSec] ConnectionDraining drainingTimeoutSec
                         */
    
                        /**
                         * Constructs a new ConnectionDraining.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ConnectionDraining.
                         * @implements IConnectionDraining
                         * @constructor
                         * @param {google.cloud.compute.v1.IConnectionDraining=} [properties] Properties to set
                         */
                        function ConnectionDraining(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ConnectionDraining drainingTimeoutSec.
                         * @member {number|null|undefined} drainingTimeoutSec
                         * @memberof google.cloud.compute.v1.ConnectionDraining
                         * @instance
                         */
                        ConnectionDraining.prototype.drainingTimeoutSec = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ConnectionDraining _drainingTimeoutSec.
                         * @member {"drainingTimeoutSec"|undefined} _drainingTimeoutSec
                         * @memberof google.cloud.compute.v1.ConnectionDraining
                         * @instance
                         */
                        Object.defineProperty(ConnectionDraining.prototype, "_drainingTimeoutSec", {
                            get: $util.oneOfGetter($oneOfFields = ["drainingTimeoutSec"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ConnectionDraining instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ConnectionDraining
                         * @static
                         * @param {google.cloud.compute.v1.IConnectionDraining=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ConnectionDraining} ConnectionDraining instance
                         */
                        ConnectionDraining.create = function create(properties) {
                            return new ConnectionDraining(properties);
                        };
    
                        /**
                         * Encodes the specified ConnectionDraining message. Does not implicitly {@link google.cloud.compute.v1.ConnectionDraining.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ConnectionDraining
                         * @static
                         * @param {google.cloud.compute.v1.IConnectionDraining} message ConnectionDraining message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConnectionDraining.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.drainingTimeoutSec != null && Object.hasOwnProperty.call(message, "drainingTimeoutSec"))
                                writer.uint32(/* id 225127070, wireType 0 =*/1801016560).int32(message.drainingTimeoutSec);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ConnectionDraining message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ConnectionDraining.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ConnectionDraining
                         * @static
                         * @param {google.cloud.compute.v1.IConnectionDraining} message ConnectionDraining message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConnectionDraining.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ConnectionDraining message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ConnectionDraining
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ConnectionDraining} ConnectionDraining
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConnectionDraining.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ConnectionDraining();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 225127070: {
                                        message.drainingTimeoutSec = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ConnectionDraining message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ConnectionDraining
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ConnectionDraining} ConnectionDraining
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConnectionDraining.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ConnectionDraining message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ConnectionDraining
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConnectionDraining.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.drainingTimeoutSec != null && message.hasOwnProperty("drainingTimeoutSec")) {
                                properties._drainingTimeoutSec = 1;
                                if (!$util.isInteger(message.drainingTimeoutSec))
                                    return "drainingTimeoutSec: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ConnectionDraining message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ConnectionDraining
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ConnectionDraining} ConnectionDraining
                         */
                        ConnectionDraining.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ConnectionDraining)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ConnectionDraining();
                            if (object.drainingTimeoutSec != null)
                                message.drainingTimeoutSec = object.drainingTimeoutSec | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ConnectionDraining message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ConnectionDraining
                         * @static
                         * @param {google.cloud.compute.v1.ConnectionDraining} message ConnectionDraining
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConnectionDraining.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.drainingTimeoutSec != null && message.hasOwnProperty("drainingTimeoutSec")) {
                                object.drainingTimeoutSec = message.drainingTimeoutSec;
                                if (options.oneofs)
                                    object._drainingTimeoutSec = "drainingTimeoutSec";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ConnectionDraining to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ConnectionDraining
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConnectionDraining.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ConnectionDraining
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ConnectionDraining
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ConnectionDraining.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ConnectionDraining";
                        };
    
                        return ConnectionDraining;
                    })();
    
                    v1.ConsistentHashLoadBalancerSettings = (function() {
    
                        /**
                         * Properties of a ConsistentHashLoadBalancerSettings.
                         * @memberof google.cloud.compute.v1
                         * @interface IConsistentHashLoadBalancerSettings
                         * @property {google.cloud.compute.v1.IConsistentHashLoadBalancerSettingsHttpCookie|null} [httpCookie] ConsistentHashLoadBalancerSettings httpCookie
                         * @property {string|null} [httpHeaderName] ConsistentHashLoadBalancerSettings httpHeaderName
                         * @property {number|Long|null} [minimumRingSize] ConsistentHashLoadBalancerSettings minimumRingSize
                         */
    
                        /**
                         * Constructs a new ConsistentHashLoadBalancerSettings.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ConsistentHashLoadBalancerSettings.
                         * @implements IConsistentHashLoadBalancerSettings
                         * @constructor
                         * @param {google.cloud.compute.v1.IConsistentHashLoadBalancerSettings=} [properties] Properties to set
                         */
                        function ConsistentHashLoadBalancerSettings(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ConsistentHashLoadBalancerSettings httpCookie.
                         * @member {google.cloud.compute.v1.IConsistentHashLoadBalancerSettingsHttpCookie|null|undefined} httpCookie
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettings
                         * @instance
                         */
                        ConsistentHashLoadBalancerSettings.prototype.httpCookie = null;
    
                        /**
                         * ConsistentHashLoadBalancerSettings httpHeaderName.
                         * @member {string|null|undefined} httpHeaderName
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettings
                         * @instance
                         */
                        ConsistentHashLoadBalancerSettings.prototype.httpHeaderName = null;
    
                        /**
                         * ConsistentHashLoadBalancerSettings minimumRingSize.
                         * @member {number|Long|null|undefined} minimumRingSize
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettings
                         * @instance
                         */
                        ConsistentHashLoadBalancerSettings.prototype.minimumRingSize = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ConsistentHashLoadBalancerSettings _httpCookie.
                         * @member {"httpCookie"|undefined} _httpCookie
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettings
                         * @instance
                         */
                        Object.defineProperty(ConsistentHashLoadBalancerSettings.prototype, "_httpCookie", {
                            get: $util.oneOfGetter($oneOfFields = ["httpCookie"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ConsistentHashLoadBalancerSettings _httpHeaderName.
                         * @member {"httpHeaderName"|undefined} _httpHeaderName
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettings
                         * @instance
                         */
                        Object.defineProperty(ConsistentHashLoadBalancerSettings.prototype, "_httpHeaderName", {
                            get: $util.oneOfGetter($oneOfFields = ["httpHeaderName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ConsistentHashLoadBalancerSettings _minimumRingSize.
                         * @member {"minimumRingSize"|undefined} _minimumRingSize
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettings
                         * @instance
                         */
                        Object.defineProperty(ConsistentHashLoadBalancerSettings.prototype, "_minimumRingSize", {
                            get: $util.oneOfGetter($oneOfFields = ["minimumRingSize"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ConsistentHashLoadBalancerSettings instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettings
                         * @static
                         * @param {google.cloud.compute.v1.IConsistentHashLoadBalancerSettings=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ConsistentHashLoadBalancerSettings} ConsistentHashLoadBalancerSettings instance
                         */
                        ConsistentHashLoadBalancerSettings.create = function create(properties) {
                            return new ConsistentHashLoadBalancerSettings(properties);
                        };
    
                        /**
                         * Encodes the specified ConsistentHashLoadBalancerSettings message. Does not implicitly {@link google.cloud.compute.v1.ConsistentHashLoadBalancerSettings.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettings
                         * @static
                         * @param {google.cloud.compute.v1.IConsistentHashLoadBalancerSettings} message ConsistentHashLoadBalancerSettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConsistentHashLoadBalancerSettings.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.httpCookie != null && Object.hasOwnProperty.call(message, "httpCookie"))
                                $root.google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie.encode(message.httpCookie, writer.uint32(/* id 6673915, wireType 2 =*/53391322).fork()).ldelim();
                            if (message.minimumRingSize != null && Object.hasOwnProperty.call(message, "minimumRingSize"))
                                writer.uint32(/* id 234380735, wireType 0 =*/1875045880).int64(message.minimumRingSize);
                            if (message.httpHeaderName != null && Object.hasOwnProperty.call(message, "httpHeaderName"))
                                writer.uint32(/* id 234798022, wireType 2 =*/1878384178).string(message.httpHeaderName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ConsistentHashLoadBalancerSettings message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ConsistentHashLoadBalancerSettings.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettings
                         * @static
                         * @param {google.cloud.compute.v1.IConsistentHashLoadBalancerSettings} message ConsistentHashLoadBalancerSettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConsistentHashLoadBalancerSettings.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ConsistentHashLoadBalancerSettings message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ConsistentHashLoadBalancerSettings} ConsistentHashLoadBalancerSettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConsistentHashLoadBalancerSettings.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ConsistentHashLoadBalancerSettings();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 6673915: {
                                        message.httpCookie = $root.google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 234798022: {
                                        message.httpHeaderName = reader.string();
                                        break;
                                    }
                                case 234380735: {
                                        message.minimumRingSize = reader.int64();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ConsistentHashLoadBalancerSettings message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ConsistentHashLoadBalancerSettings} ConsistentHashLoadBalancerSettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConsistentHashLoadBalancerSettings.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ConsistentHashLoadBalancerSettings message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettings
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConsistentHashLoadBalancerSettings.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.httpCookie != null && message.hasOwnProperty("httpCookie")) {
                                properties._httpCookie = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie.verify(message.httpCookie);
                                    if (error)
                                        return "httpCookie." + error;
                                }
                            }
                            if (message.httpHeaderName != null && message.hasOwnProperty("httpHeaderName")) {
                                properties._httpHeaderName = 1;
                                if (!$util.isString(message.httpHeaderName))
                                    return "httpHeaderName: string expected";
                            }
                            if (message.minimumRingSize != null && message.hasOwnProperty("minimumRingSize")) {
                                properties._minimumRingSize = 1;
                                if (!$util.isInteger(message.minimumRingSize) && !(message.minimumRingSize && $util.isInteger(message.minimumRingSize.low) && $util.isInteger(message.minimumRingSize.high)))
                                    return "minimumRingSize: integer|Long expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ConsistentHashLoadBalancerSettings message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettings
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ConsistentHashLoadBalancerSettings} ConsistentHashLoadBalancerSettings
                         */
                        ConsistentHashLoadBalancerSettings.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ConsistentHashLoadBalancerSettings)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ConsistentHashLoadBalancerSettings();
                            if (object.httpCookie != null) {
                                if (typeof object.httpCookie !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ConsistentHashLoadBalancerSettings.httpCookie: object expected");
                                message.httpCookie = $root.google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie.fromObject(object.httpCookie);
                            }
                            if (object.httpHeaderName != null)
                                message.httpHeaderName = String(object.httpHeaderName);
                            if (object.minimumRingSize != null)
                                if ($util.Long)
                                    (message.minimumRingSize = $util.Long.fromValue(object.minimumRingSize)).unsigned = false;
                                else if (typeof object.minimumRingSize === "string")
                                    message.minimumRingSize = parseInt(object.minimumRingSize, 10);
                                else if (typeof object.minimumRingSize === "number")
                                    message.minimumRingSize = object.minimumRingSize;
                                else if (typeof object.minimumRingSize === "object")
                                    message.minimumRingSize = new $util.LongBits(object.minimumRingSize.low >>> 0, object.minimumRingSize.high >>> 0).toNumber();
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ConsistentHashLoadBalancerSettings message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettings
                         * @static
                         * @param {google.cloud.compute.v1.ConsistentHashLoadBalancerSettings} message ConsistentHashLoadBalancerSettings
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConsistentHashLoadBalancerSettings.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.httpCookie != null && message.hasOwnProperty("httpCookie")) {
                                object.httpCookie = $root.google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie.toObject(message.httpCookie, options);
                                if (options.oneofs)
                                    object._httpCookie = "httpCookie";
                            }
                            if (message.minimumRingSize != null && message.hasOwnProperty("minimumRingSize")) {
                                if (typeof message.minimumRingSize === "number")
                                    object.minimumRingSize = options.longs === String ? String(message.minimumRingSize) : message.minimumRingSize;
                                else
                                    object.minimumRingSize = options.longs === String ? $util.Long.prototype.toString.call(message.minimumRingSize) : options.longs === Number ? new $util.LongBits(message.minimumRingSize.low >>> 0, message.minimumRingSize.high >>> 0).toNumber() : message.minimumRingSize;
                                if (options.oneofs)
                                    object._minimumRingSize = "minimumRingSize";
                            }
                            if (message.httpHeaderName != null && message.hasOwnProperty("httpHeaderName")) {
                                object.httpHeaderName = message.httpHeaderName;
                                if (options.oneofs)
                                    object._httpHeaderName = "httpHeaderName";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ConsistentHashLoadBalancerSettings to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettings
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConsistentHashLoadBalancerSettings.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ConsistentHashLoadBalancerSettings
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettings
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ConsistentHashLoadBalancerSettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ConsistentHashLoadBalancerSettings";
                        };
    
                        return ConsistentHashLoadBalancerSettings;
                    })();
    
                    v1.ConsistentHashLoadBalancerSettingsHttpCookie = (function() {
    
                        /**
                         * Properties of a ConsistentHashLoadBalancerSettingsHttpCookie.
                         * @memberof google.cloud.compute.v1
                         * @interface IConsistentHashLoadBalancerSettingsHttpCookie
                         * @property {string|null} [name] ConsistentHashLoadBalancerSettingsHttpCookie name
                         * @property {string|null} [path] ConsistentHashLoadBalancerSettingsHttpCookie path
                         * @property {google.cloud.compute.v1.IDuration|null} [ttl] ConsistentHashLoadBalancerSettingsHttpCookie ttl
                         */
    
                        /**
                         * Constructs a new ConsistentHashLoadBalancerSettingsHttpCookie.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ConsistentHashLoadBalancerSettingsHttpCookie.
                         * @implements IConsistentHashLoadBalancerSettingsHttpCookie
                         * @constructor
                         * @param {google.cloud.compute.v1.IConsistentHashLoadBalancerSettingsHttpCookie=} [properties] Properties to set
                         */
                        function ConsistentHashLoadBalancerSettingsHttpCookie(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ConsistentHashLoadBalancerSettingsHttpCookie name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie
                         * @instance
                         */
                        ConsistentHashLoadBalancerSettingsHttpCookie.prototype.name = null;
    
                        /**
                         * ConsistentHashLoadBalancerSettingsHttpCookie path.
                         * @member {string|null|undefined} path
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie
                         * @instance
                         */
                        ConsistentHashLoadBalancerSettingsHttpCookie.prototype.path = null;
    
                        /**
                         * ConsistentHashLoadBalancerSettingsHttpCookie ttl.
                         * @member {google.cloud.compute.v1.IDuration|null|undefined} ttl
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie
                         * @instance
                         */
                        ConsistentHashLoadBalancerSettingsHttpCookie.prototype.ttl = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ConsistentHashLoadBalancerSettingsHttpCookie _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie
                         * @instance
                         */
                        Object.defineProperty(ConsistentHashLoadBalancerSettingsHttpCookie.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ConsistentHashLoadBalancerSettingsHttpCookie _path.
                         * @member {"path"|undefined} _path
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie
                         * @instance
                         */
                        Object.defineProperty(ConsistentHashLoadBalancerSettingsHttpCookie.prototype, "_path", {
                            get: $util.oneOfGetter($oneOfFields = ["path"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ConsistentHashLoadBalancerSettingsHttpCookie _ttl.
                         * @member {"ttl"|undefined} _ttl
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie
                         * @instance
                         */
                        Object.defineProperty(ConsistentHashLoadBalancerSettingsHttpCookie.prototype, "_ttl", {
                            get: $util.oneOfGetter($oneOfFields = ["ttl"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ConsistentHashLoadBalancerSettingsHttpCookie instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie
                         * @static
                         * @param {google.cloud.compute.v1.IConsistentHashLoadBalancerSettingsHttpCookie=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie} ConsistentHashLoadBalancerSettingsHttpCookie instance
                         */
                        ConsistentHashLoadBalancerSettingsHttpCookie.create = function create(properties) {
                            return new ConsistentHashLoadBalancerSettingsHttpCookie(properties);
                        };
    
                        /**
                         * Encodes the specified ConsistentHashLoadBalancerSettingsHttpCookie message. Does not implicitly {@link google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie
                         * @static
                         * @param {google.cloud.compute.v1.IConsistentHashLoadBalancerSettingsHttpCookie} message ConsistentHashLoadBalancerSettingsHttpCookie message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConsistentHashLoadBalancerSettingsHttpCookie.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.ttl != null && Object.hasOwnProperty.call(message, "ttl"))
                                $root.google.cloud.compute.v1.Duration.encode(message.ttl, writer.uint32(/* id 115180, wireType 2 =*/921442).fork()).ldelim();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.path != null && Object.hasOwnProperty.call(message, "path"))
                                writer.uint32(/* id 3433509, wireType 2 =*/27468074).string(message.path);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ConsistentHashLoadBalancerSettingsHttpCookie message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie
                         * @static
                         * @param {google.cloud.compute.v1.IConsistentHashLoadBalancerSettingsHttpCookie} message ConsistentHashLoadBalancerSettingsHttpCookie message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ConsistentHashLoadBalancerSettingsHttpCookie.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ConsistentHashLoadBalancerSettingsHttpCookie message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie} ConsistentHashLoadBalancerSettingsHttpCookie
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConsistentHashLoadBalancerSettingsHttpCookie.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 3433509: {
                                        message.path = reader.string();
                                        break;
                                    }
                                case 115180: {
                                        message.ttl = $root.google.cloud.compute.v1.Duration.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ConsistentHashLoadBalancerSettingsHttpCookie message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie} ConsistentHashLoadBalancerSettingsHttpCookie
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ConsistentHashLoadBalancerSettingsHttpCookie.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ConsistentHashLoadBalancerSettingsHttpCookie message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ConsistentHashLoadBalancerSettingsHttpCookie.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.path != null && message.hasOwnProperty("path")) {
                                properties._path = 1;
                                if (!$util.isString(message.path))
                                    return "path: string expected";
                            }
                            if (message.ttl != null && message.hasOwnProperty("ttl")) {
                                properties._ttl = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Duration.verify(message.ttl);
                                    if (error)
                                        return "ttl." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ConsistentHashLoadBalancerSettingsHttpCookie message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie} ConsistentHashLoadBalancerSettingsHttpCookie
                         */
                        ConsistentHashLoadBalancerSettingsHttpCookie.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.path != null)
                                message.path = String(object.path);
                            if (object.ttl != null) {
                                if (typeof object.ttl !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie.ttl: object expected");
                                message.ttl = $root.google.cloud.compute.v1.Duration.fromObject(object.ttl);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ConsistentHashLoadBalancerSettingsHttpCookie message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie
                         * @static
                         * @param {google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie} message ConsistentHashLoadBalancerSettingsHttpCookie
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ConsistentHashLoadBalancerSettingsHttpCookie.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.ttl != null && message.hasOwnProperty("ttl")) {
                                object.ttl = $root.google.cloud.compute.v1.Duration.toObject(message.ttl, options);
                                if (options.oneofs)
                                    object._ttl = "ttl";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.path != null && message.hasOwnProperty("path")) {
                                object.path = message.path;
                                if (options.oneofs)
                                    object._path = "path";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ConsistentHashLoadBalancerSettingsHttpCookie to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ConsistentHashLoadBalancerSettingsHttpCookie.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ConsistentHashLoadBalancerSettingsHttpCookie
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ConsistentHashLoadBalancerSettingsHttpCookie.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ConsistentHashLoadBalancerSettingsHttpCookie";
                        };
    
                        return ConsistentHashLoadBalancerSettingsHttpCookie;
                    })();
    
                    v1.CorsPolicy = (function() {
    
                        /**
                         * Properties of a CorsPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface ICorsPolicy
                         * @property {boolean|null} [allowCredentials] CorsPolicy allowCredentials
                         * @property {Array.<string>|null} [allowHeaders] CorsPolicy allowHeaders
                         * @property {Array.<string>|null} [allowMethods] CorsPolicy allowMethods
                         * @property {Array.<string>|null} [allowOriginRegexes] CorsPolicy allowOriginRegexes
                         * @property {Array.<string>|null} [allowOrigins] CorsPolicy allowOrigins
                         * @property {boolean|null} [disabled] CorsPolicy disabled
                         * @property {Array.<string>|null} [exposeHeaders] CorsPolicy exposeHeaders
                         * @property {number|null} [maxAge] CorsPolicy maxAge
                         */
    
                        /**
                         * Constructs a new CorsPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a CorsPolicy.
                         * @implements ICorsPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.ICorsPolicy=} [properties] Properties to set
                         */
                        function CorsPolicy(properties) {
                            this.allowHeaders = [];
                            this.allowMethods = [];
                            this.allowOriginRegexes = [];
                            this.allowOrigins = [];
                            this.exposeHeaders = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CorsPolicy allowCredentials.
                         * @member {boolean|null|undefined} allowCredentials
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @instance
                         */
                        CorsPolicy.prototype.allowCredentials = null;
    
                        /**
                         * CorsPolicy allowHeaders.
                         * @member {Array.<string>} allowHeaders
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @instance
                         */
                        CorsPolicy.prototype.allowHeaders = $util.emptyArray;
    
                        /**
                         * CorsPolicy allowMethods.
                         * @member {Array.<string>} allowMethods
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @instance
                         */
                        CorsPolicy.prototype.allowMethods = $util.emptyArray;
    
                        /**
                         * CorsPolicy allowOriginRegexes.
                         * @member {Array.<string>} allowOriginRegexes
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @instance
                         */
                        CorsPolicy.prototype.allowOriginRegexes = $util.emptyArray;
    
                        /**
                         * CorsPolicy allowOrigins.
                         * @member {Array.<string>} allowOrigins
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @instance
                         */
                        CorsPolicy.prototype.allowOrigins = $util.emptyArray;
    
                        /**
                         * CorsPolicy disabled.
                         * @member {boolean|null|undefined} disabled
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @instance
                         */
                        CorsPolicy.prototype.disabled = null;
    
                        /**
                         * CorsPolicy exposeHeaders.
                         * @member {Array.<string>} exposeHeaders
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @instance
                         */
                        CorsPolicy.prototype.exposeHeaders = $util.emptyArray;
    
                        /**
                         * CorsPolicy maxAge.
                         * @member {number|null|undefined} maxAge
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @instance
                         */
                        CorsPolicy.prototype.maxAge = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * CorsPolicy _allowCredentials.
                         * @member {"allowCredentials"|undefined} _allowCredentials
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @instance
                         */
                        Object.defineProperty(CorsPolicy.prototype, "_allowCredentials", {
                            get: $util.oneOfGetter($oneOfFields = ["allowCredentials"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CorsPolicy _disabled.
                         * @member {"disabled"|undefined} _disabled
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @instance
                         */
                        Object.defineProperty(CorsPolicy.prototype, "_disabled", {
                            get: $util.oneOfGetter($oneOfFields = ["disabled"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CorsPolicy _maxAge.
                         * @member {"maxAge"|undefined} _maxAge
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @instance
                         */
                        Object.defineProperty(CorsPolicy.prototype, "_maxAge", {
                            get: $util.oneOfGetter($oneOfFields = ["maxAge"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new CorsPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @static
                         * @param {google.cloud.compute.v1.ICorsPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.CorsPolicy} CorsPolicy instance
                         */
                        CorsPolicy.create = function create(properties) {
                            return new CorsPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified CorsPolicy message. Does not implicitly {@link google.cloud.compute.v1.CorsPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @static
                         * @param {google.cloud.compute.v1.ICorsPolicy} message CorsPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CorsPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.allowHeaders != null && message.allowHeaders.length)
                                for (var i = 0; i < message.allowHeaders.length; ++i)
                                    writer.uint32(/* id 45179024, wireType 2 =*/361432194).string(message.allowHeaders[i]);
                            if (message.allowOrigins != null && message.allowOrigins.length)
                                for (var i = 0; i < message.allowOrigins.length; ++i)
                                    writer.uint32(/* id 194914071, wireType 2 =*/1559312570).string(message.allowOrigins[i]);
                            if (message.allowMethods != null && message.allowMethods.length)
                                for (var i = 0; i < message.allowMethods.length; ++i)
                                    writer.uint32(/* id 205405372, wireType 2 =*/1643242978).string(message.allowMethods[i]);
                            if (message.allowOriginRegexes != null && message.allowOriginRegexes.length)
                                for (var i = 0; i < message.allowOriginRegexes.length; ++i)
                                    writer.uint32(/* id 215385810, wireType 2 =*/1723086482).string(message.allowOriginRegexes[i]);
                            if (message.exposeHeaders != null && message.exposeHeaders.length)
                                for (var i = 0; i < message.exposeHeaders.length; ++i)
                                    writer.uint32(/* id 247604747, wireType 2 =*/1980837978).string(message.exposeHeaders[i]);
                            if (message.disabled != null && Object.hasOwnProperty.call(message, "disabled"))
                                writer.uint32(/* id 270940796, wireType 0 =*/2167526368).bool(message.disabled);
                            if (message.maxAge != null && Object.hasOwnProperty.call(message, "maxAge"))
                                writer.uint32(/* id 307559332, wireType 0 =*/2460474656).int32(message.maxAge);
                            if (message.allowCredentials != null && Object.hasOwnProperty.call(message, "allowCredentials"))
                                writer.uint32(/* id 481263366, wireType 0 =*/3850106928).bool(message.allowCredentials);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CorsPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.CorsPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @static
                         * @param {google.cloud.compute.v1.ICorsPolicy} message CorsPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CorsPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CorsPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.CorsPolicy} CorsPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CorsPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.CorsPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 481263366: {
                                        message.allowCredentials = reader.bool();
                                        break;
                                    }
                                case 45179024: {
                                        if (!(message.allowHeaders && message.allowHeaders.length))
                                            message.allowHeaders = [];
                                        message.allowHeaders.push(reader.string());
                                        break;
                                    }
                                case 205405372: {
                                        if (!(message.allowMethods && message.allowMethods.length))
                                            message.allowMethods = [];
                                        message.allowMethods.push(reader.string());
                                        break;
                                    }
                                case 215385810: {
                                        if (!(message.allowOriginRegexes && message.allowOriginRegexes.length))
                                            message.allowOriginRegexes = [];
                                        message.allowOriginRegexes.push(reader.string());
                                        break;
                                    }
                                case 194914071: {
                                        if (!(message.allowOrigins && message.allowOrigins.length))
                                            message.allowOrigins = [];
                                        message.allowOrigins.push(reader.string());
                                        break;
                                    }
                                case 270940796: {
                                        message.disabled = reader.bool();
                                        break;
                                    }
                                case 247604747: {
                                        if (!(message.exposeHeaders && message.exposeHeaders.length))
                                            message.exposeHeaders = [];
                                        message.exposeHeaders.push(reader.string());
                                        break;
                                    }
                                case 307559332: {
                                        message.maxAge = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CorsPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.CorsPolicy} CorsPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CorsPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CorsPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CorsPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.allowCredentials != null && message.hasOwnProperty("allowCredentials")) {
                                properties._allowCredentials = 1;
                                if (typeof message.allowCredentials !== "boolean")
                                    return "allowCredentials: boolean expected";
                            }
                            if (message.allowHeaders != null && message.hasOwnProperty("allowHeaders")) {
                                if (!Array.isArray(message.allowHeaders))
                                    return "allowHeaders: array expected";
                                for (var i = 0; i < message.allowHeaders.length; ++i)
                                    if (!$util.isString(message.allowHeaders[i]))
                                        return "allowHeaders: string[] expected";
                            }
                            if (message.allowMethods != null && message.hasOwnProperty("allowMethods")) {
                                if (!Array.isArray(message.allowMethods))
                                    return "allowMethods: array expected";
                                for (var i = 0; i < message.allowMethods.length; ++i)
                                    if (!$util.isString(message.allowMethods[i]))
                                        return "allowMethods: string[] expected";
                            }
                            if (message.allowOriginRegexes != null && message.hasOwnProperty("allowOriginRegexes")) {
                                if (!Array.isArray(message.allowOriginRegexes))
                                    return "allowOriginRegexes: array expected";
                                for (var i = 0; i < message.allowOriginRegexes.length; ++i)
                                    if (!$util.isString(message.allowOriginRegexes[i]))
                                        return "allowOriginRegexes: string[] expected";
                            }
                            if (message.allowOrigins != null && message.hasOwnProperty("allowOrigins")) {
                                if (!Array.isArray(message.allowOrigins))
                                    return "allowOrigins: array expected";
                                for (var i = 0; i < message.allowOrigins.length; ++i)
                                    if (!$util.isString(message.allowOrigins[i]))
                                        return "allowOrigins: string[] expected";
                            }
                            if (message.disabled != null && message.hasOwnProperty("disabled")) {
                                properties._disabled = 1;
                                if (typeof message.disabled !== "boolean")
                                    return "disabled: boolean expected";
                            }
                            if (message.exposeHeaders != null && message.hasOwnProperty("exposeHeaders")) {
                                if (!Array.isArray(message.exposeHeaders))
                                    return "exposeHeaders: array expected";
                                for (var i = 0; i < message.exposeHeaders.length; ++i)
                                    if (!$util.isString(message.exposeHeaders[i]))
                                        return "exposeHeaders: string[] expected";
                            }
                            if (message.maxAge != null && message.hasOwnProperty("maxAge")) {
                                properties._maxAge = 1;
                                if (!$util.isInteger(message.maxAge))
                                    return "maxAge: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CorsPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.CorsPolicy} CorsPolicy
                         */
                        CorsPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.CorsPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.CorsPolicy();
                            if (object.allowCredentials != null)
                                message.allowCredentials = Boolean(object.allowCredentials);
                            if (object.allowHeaders) {
                                if (!Array.isArray(object.allowHeaders))
                                    throw TypeError(".google.cloud.compute.v1.CorsPolicy.allowHeaders: array expected");
                                message.allowHeaders = [];
                                for (var i = 0; i < object.allowHeaders.length; ++i)
                                    message.allowHeaders[i] = String(object.allowHeaders[i]);
                            }
                            if (object.allowMethods) {
                                if (!Array.isArray(object.allowMethods))
                                    throw TypeError(".google.cloud.compute.v1.CorsPolicy.allowMethods: array expected");
                                message.allowMethods = [];
                                for (var i = 0; i < object.allowMethods.length; ++i)
                                    message.allowMethods[i] = String(object.allowMethods[i]);
                            }
                            if (object.allowOriginRegexes) {
                                if (!Array.isArray(object.allowOriginRegexes))
                                    throw TypeError(".google.cloud.compute.v1.CorsPolicy.allowOriginRegexes: array expected");
                                message.allowOriginRegexes = [];
                                for (var i = 0; i < object.allowOriginRegexes.length; ++i)
                                    message.allowOriginRegexes[i] = String(object.allowOriginRegexes[i]);
                            }
                            if (object.allowOrigins) {
                                if (!Array.isArray(object.allowOrigins))
                                    throw TypeError(".google.cloud.compute.v1.CorsPolicy.allowOrigins: array expected");
                                message.allowOrigins = [];
                                for (var i = 0; i < object.allowOrigins.length; ++i)
                                    message.allowOrigins[i] = String(object.allowOrigins[i]);
                            }
                            if (object.disabled != null)
                                message.disabled = Boolean(object.disabled);
                            if (object.exposeHeaders) {
                                if (!Array.isArray(object.exposeHeaders))
                                    throw TypeError(".google.cloud.compute.v1.CorsPolicy.exposeHeaders: array expected");
                                message.exposeHeaders = [];
                                for (var i = 0; i < object.exposeHeaders.length; ++i)
                                    message.exposeHeaders[i] = String(object.exposeHeaders[i]);
                            }
                            if (object.maxAge != null)
                                message.maxAge = object.maxAge | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CorsPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @static
                         * @param {google.cloud.compute.v1.CorsPolicy} message CorsPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CorsPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.allowHeaders = [];
                                object.allowOrigins = [];
                                object.allowMethods = [];
                                object.allowOriginRegexes = [];
                                object.exposeHeaders = [];
                            }
                            if (message.allowHeaders && message.allowHeaders.length) {
                                object.allowHeaders = [];
                                for (var j = 0; j < message.allowHeaders.length; ++j)
                                    object.allowHeaders[j] = message.allowHeaders[j];
                            }
                            if (message.allowOrigins && message.allowOrigins.length) {
                                object.allowOrigins = [];
                                for (var j = 0; j < message.allowOrigins.length; ++j)
                                    object.allowOrigins[j] = message.allowOrigins[j];
                            }
                            if (message.allowMethods && message.allowMethods.length) {
                                object.allowMethods = [];
                                for (var j = 0; j < message.allowMethods.length; ++j)
                                    object.allowMethods[j] = message.allowMethods[j];
                            }
                            if (message.allowOriginRegexes && message.allowOriginRegexes.length) {
                                object.allowOriginRegexes = [];
                                for (var j = 0; j < message.allowOriginRegexes.length; ++j)
                                    object.allowOriginRegexes[j] = message.allowOriginRegexes[j];
                            }
                            if (message.exposeHeaders && message.exposeHeaders.length) {
                                object.exposeHeaders = [];
                                for (var j = 0; j < message.exposeHeaders.length; ++j)
                                    object.exposeHeaders[j] = message.exposeHeaders[j];
                            }
                            if (message.disabled != null && message.hasOwnProperty("disabled")) {
                                object.disabled = message.disabled;
                                if (options.oneofs)
                                    object._disabled = "disabled";
                            }
                            if (message.maxAge != null && message.hasOwnProperty("maxAge")) {
                                object.maxAge = message.maxAge;
                                if (options.oneofs)
                                    object._maxAge = "maxAge";
                            }
                            if (message.allowCredentials != null && message.hasOwnProperty("allowCredentials")) {
                                object.allowCredentials = message.allowCredentials;
                                if (options.oneofs)
                                    object._allowCredentials = "allowCredentials";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this CorsPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CorsPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CorsPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.CorsPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CorsPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.CorsPolicy";
                        };
    
                        return CorsPolicy;
                    })();
    
                    v1.CreateInstancesInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a CreateInstancesInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ICreateInstancesInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] CreateInstancesInstanceGroupManagerRequest instanceGroupManager
                         * @property {google.cloud.compute.v1.IInstanceGroupManagersCreateInstancesRequest|null} [instanceGroupManagersCreateInstancesRequestResource] CreateInstancesInstanceGroupManagerRequest instanceGroupManagersCreateInstancesRequestResource
                         * @property {string|null} [project] CreateInstancesInstanceGroupManagerRequest project
                         * @property {string|null} [requestId] CreateInstancesInstanceGroupManagerRequest requestId
                         * @property {string|null} [zone] CreateInstancesInstanceGroupManagerRequest zone
                         */
    
                        /**
                         * Constructs a new CreateInstancesInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a CreateInstancesInstanceGroupManagerRequest.
                         * @implements ICreateInstancesInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ICreateInstancesInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function CreateInstancesInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateInstancesInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        CreateInstancesInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * CreateInstancesInstanceGroupManagerRequest instanceGroupManagersCreateInstancesRequestResource.
                         * @member {google.cloud.compute.v1.IInstanceGroupManagersCreateInstancesRequest|null|undefined} instanceGroupManagersCreateInstancesRequestResource
                         * @memberof google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        CreateInstancesInstanceGroupManagerRequest.prototype.instanceGroupManagersCreateInstancesRequestResource = null;
    
                        /**
                         * CreateInstancesInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        CreateInstancesInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * CreateInstancesInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        CreateInstancesInstanceGroupManagerRequest.prototype.requestId = null;
    
                        /**
                         * CreateInstancesInstanceGroupManagerRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        CreateInstancesInstanceGroupManagerRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * CreateInstancesInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(CreateInstancesInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new CreateInstancesInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICreateInstancesInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest} CreateInstancesInstanceGroupManagerRequest instance
                         */
                        CreateInstancesInstanceGroupManagerRequest.create = function create(properties) {
                            return new CreateInstancesInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateInstancesInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICreateInstancesInstanceGroupManagerRequest} message CreateInstancesInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateInstancesInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instanceGroupManagersCreateInstancesRequestResource != null && Object.hasOwnProperty.call(message, "instanceGroupManagersCreateInstancesRequestResource"))
                                $root.google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest.encode(message.instanceGroupManagersCreateInstancesRequestResource, writer.uint32(/* id 24558867, wireType 2 =*/196470938).fork()).ldelim();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateInstancesInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICreateInstancesInstanceGroupManagerRequest} message CreateInstancesInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateInstancesInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateInstancesInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest} CreateInstancesInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateInstancesInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 24558867: {
                                        message.instanceGroupManagersCreateInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateInstancesInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest} CreateInstancesInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateInstancesInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateInstancesInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateInstancesInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.instanceGroupManagersCreateInstancesRequestResource != null && message.hasOwnProperty("instanceGroupManagersCreateInstancesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest.verify(message.instanceGroupManagersCreateInstancesRequestResource);
                                if (error)
                                    return "instanceGroupManagersCreateInstancesRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a CreateInstancesInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest} CreateInstancesInstanceGroupManagerRequest
                         */
                        CreateInstancesInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.instanceGroupManagersCreateInstancesRequestResource != null) {
                                if (typeof object.instanceGroupManagersCreateInstancesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest.instanceGroupManagersCreateInstancesRequestResource: object expected");
                                message.instanceGroupManagersCreateInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest.fromObject(object.instanceGroupManagersCreateInstancesRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateInstancesInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest} message CreateInstancesInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateInstancesInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instanceGroupManagersCreateInstancesRequestResource = null;
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instanceGroupManagersCreateInstancesRequestResource != null && message.hasOwnProperty("instanceGroupManagersCreateInstancesRequestResource"))
                                object.instanceGroupManagersCreateInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest.toObject(message.instanceGroupManagersCreateInstancesRequestResource, options);
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            return object;
                        };
    
                        /**
                         * Converts this CreateInstancesInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateInstancesInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateInstancesInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateInstancesInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest";
                        };
    
                        return CreateInstancesInstanceGroupManagerRequest;
                    })();
    
                    v1.CreateInstancesRegionInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a CreateInstancesRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ICreateInstancesRegionInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] CreateInstancesRegionInstanceGroupManagerRequest instanceGroupManager
                         * @property {string|null} [project] CreateInstancesRegionInstanceGroupManagerRequest project
                         * @property {string|null} [region] CreateInstancesRegionInstanceGroupManagerRequest region
                         * @property {google.cloud.compute.v1.IRegionInstanceGroupManagersCreateInstancesRequest|null} [regionInstanceGroupManagersCreateInstancesRequestResource] CreateInstancesRegionInstanceGroupManagerRequest regionInstanceGroupManagersCreateInstancesRequestResource
                         * @property {string|null} [requestId] CreateInstancesRegionInstanceGroupManagerRequest requestId
                         */
    
                        /**
                         * Constructs a new CreateInstancesRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a CreateInstancesRegionInstanceGroupManagerRequest.
                         * @implements ICreateInstancesRegionInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ICreateInstancesRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function CreateInstancesRegionInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateInstancesRegionInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        CreateInstancesRegionInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * CreateInstancesRegionInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        CreateInstancesRegionInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * CreateInstancesRegionInstanceGroupManagerRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        CreateInstancesRegionInstanceGroupManagerRequest.prototype.region = "";
    
                        /**
                         * CreateInstancesRegionInstanceGroupManagerRequest regionInstanceGroupManagersCreateInstancesRequestResource.
                         * @member {google.cloud.compute.v1.IRegionInstanceGroupManagersCreateInstancesRequest|null|undefined} regionInstanceGroupManagersCreateInstancesRequestResource
                         * @memberof google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        CreateInstancesRegionInstanceGroupManagerRequest.prototype.regionInstanceGroupManagersCreateInstancesRequestResource = null;
    
                        /**
                         * CreateInstancesRegionInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        CreateInstancesRegionInstanceGroupManagerRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * CreateInstancesRegionInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(CreateInstancesRegionInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new CreateInstancesRegionInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICreateInstancesRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest} CreateInstancesRegionInstanceGroupManagerRequest instance
                         */
                        CreateInstancesRegionInstanceGroupManagerRequest.create = function create(properties) {
                            return new CreateInstancesRegionInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateInstancesRegionInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICreateInstancesRegionInstanceGroupManagerRequest} message CreateInstancesRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateInstancesRegionInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            if (message.regionInstanceGroupManagersCreateInstancesRequestResource != null && Object.hasOwnProperty.call(message, "regionInstanceGroupManagersCreateInstancesRequestResource"))
                                $root.google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest.encode(message.regionInstanceGroupManagersCreateInstancesRequestResource, writer.uint32(/* id 359014280, wireType 2 =*/2872114242).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateInstancesRegionInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICreateInstancesRegionInstanceGroupManagerRequest} message CreateInstancesRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateInstancesRegionInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateInstancesRegionInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest} CreateInstancesRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateInstancesRegionInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 359014280: {
                                        message.regionInstanceGroupManagersCreateInstancesRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateInstancesRegionInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest} CreateInstancesRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateInstancesRegionInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateInstancesRegionInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateInstancesRegionInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionInstanceGroupManagersCreateInstancesRequestResource != null && message.hasOwnProperty("regionInstanceGroupManagersCreateInstancesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest.verify(message.regionInstanceGroupManagersCreateInstancesRequestResource);
                                if (error)
                                    return "regionInstanceGroupManagersCreateInstancesRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateInstancesRegionInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest} CreateInstancesRegionInstanceGroupManagerRequest
                         */
                        CreateInstancesRegionInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionInstanceGroupManagersCreateInstancesRequestResource != null) {
                                if (typeof object.regionInstanceGroupManagersCreateInstancesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest.regionInstanceGroupManagersCreateInstancesRequestResource: object expected");
                                message.regionInstanceGroupManagersCreateInstancesRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest.fromObject(object.regionInstanceGroupManagersCreateInstancesRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateInstancesRegionInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest} message CreateInstancesRegionInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateInstancesRegionInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                                object.regionInstanceGroupManagersCreateInstancesRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            if (message.regionInstanceGroupManagersCreateInstancesRequestResource != null && message.hasOwnProperty("regionInstanceGroupManagersCreateInstancesRequestResource"))
                                object.regionInstanceGroupManagersCreateInstancesRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest.toObject(message.regionInstanceGroupManagersCreateInstancesRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateInstancesRegionInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateInstancesRegionInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateInstancesRegionInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateInstancesRegionInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest";
                        };
    
                        return CreateInstancesRegionInstanceGroupManagerRequest;
                    })();
    
                    v1.CreateSnapshotDiskRequest = (function() {
    
                        /**
                         * Properties of a CreateSnapshotDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ICreateSnapshotDiskRequest
                         * @property {string|null} [disk] CreateSnapshotDiskRequest disk
                         * @property {boolean|null} [guestFlush] CreateSnapshotDiskRequest guestFlush
                         * @property {string|null} [project] CreateSnapshotDiskRequest project
                         * @property {string|null} [requestId] CreateSnapshotDiskRequest requestId
                         * @property {google.cloud.compute.v1.ISnapshot|null} [snapshotResource] CreateSnapshotDiskRequest snapshotResource
                         * @property {string|null} [zone] CreateSnapshotDiskRequest zone
                         */
    
                        /**
                         * Constructs a new CreateSnapshotDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a CreateSnapshotDiskRequest.
                         * @implements ICreateSnapshotDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ICreateSnapshotDiskRequest=} [properties] Properties to set
                         */
                        function CreateSnapshotDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateSnapshotDiskRequest disk.
                         * @member {string} disk
                         * @memberof google.cloud.compute.v1.CreateSnapshotDiskRequest
                         * @instance
                         */
                        CreateSnapshotDiskRequest.prototype.disk = "";
    
                        /**
                         * CreateSnapshotDiskRequest guestFlush.
                         * @member {boolean|null|undefined} guestFlush
                         * @memberof google.cloud.compute.v1.CreateSnapshotDiskRequest
                         * @instance
                         */
                        CreateSnapshotDiskRequest.prototype.guestFlush = null;
    
                        /**
                         * CreateSnapshotDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.CreateSnapshotDiskRequest
                         * @instance
                         */
                        CreateSnapshotDiskRequest.prototype.project = "";
    
                        /**
                         * CreateSnapshotDiskRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.CreateSnapshotDiskRequest
                         * @instance
                         */
                        CreateSnapshotDiskRequest.prototype.requestId = null;
    
                        /**
                         * CreateSnapshotDiskRequest snapshotResource.
                         * @member {google.cloud.compute.v1.ISnapshot|null|undefined} snapshotResource
                         * @memberof google.cloud.compute.v1.CreateSnapshotDiskRequest
                         * @instance
                         */
                        CreateSnapshotDiskRequest.prototype.snapshotResource = null;
    
                        /**
                         * CreateSnapshotDiskRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.CreateSnapshotDiskRequest
                         * @instance
                         */
                        CreateSnapshotDiskRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * CreateSnapshotDiskRequest _guestFlush.
                         * @member {"guestFlush"|undefined} _guestFlush
                         * @memberof google.cloud.compute.v1.CreateSnapshotDiskRequest
                         * @instance
                         */
                        Object.defineProperty(CreateSnapshotDiskRequest.prototype, "_guestFlush", {
                            get: $util.oneOfGetter($oneOfFields = ["guestFlush"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CreateSnapshotDiskRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.CreateSnapshotDiskRequest
                         * @instance
                         */
                        Object.defineProperty(CreateSnapshotDiskRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new CreateSnapshotDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.CreateSnapshotDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICreateSnapshotDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.CreateSnapshotDiskRequest} CreateSnapshotDiskRequest instance
                         */
                        CreateSnapshotDiskRequest.create = function create(properties) {
                            return new CreateSnapshotDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateSnapshotDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.CreateSnapshotDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.CreateSnapshotDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICreateSnapshotDiskRequest} message CreateSnapshotDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateSnapshotDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.disk != null && Object.hasOwnProperty.call(message, "disk"))
                                writer.uint32(/* id 3083677, wireType 2 =*/24669418).string(message.disk);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.guestFlush != null && Object.hasOwnProperty.call(message, "guestFlush"))
                                writer.uint32(/* id 385550813, wireType 0 =*/3084406504).bool(message.guestFlush);
                            if (message.snapshotResource != null && Object.hasOwnProperty.call(message, "snapshotResource"))
                                $root.google.cloud.compute.v1.Snapshot.encode(message.snapshotResource, writer.uint32(/* id 481319977, wireType 2 =*/3850559818).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateSnapshotDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.CreateSnapshotDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.CreateSnapshotDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICreateSnapshotDiskRequest} message CreateSnapshotDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateSnapshotDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateSnapshotDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.CreateSnapshotDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.CreateSnapshotDiskRequest} CreateSnapshotDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateSnapshotDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.CreateSnapshotDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3083677: {
                                        message.disk = reader.string();
                                        break;
                                    }
                                case 385550813: {
                                        message.guestFlush = reader.bool();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 481319977: {
                                        message.snapshotResource = $root.google.cloud.compute.v1.Snapshot.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateSnapshotDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.CreateSnapshotDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.CreateSnapshotDiskRequest} CreateSnapshotDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateSnapshotDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateSnapshotDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.CreateSnapshotDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateSnapshotDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                if (!$util.isString(message.disk))
                                    return "disk: string expected";
                            if (message.guestFlush != null && message.hasOwnProperty("guestFlush")) {
                                properties._guestFlush = 1;
                                if (typeof message.guestFlush !== "boolean")
                                    return "guestFlush: boolean expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.snapshotResource != null && message.hasOwnProperty("snapshotResource")) {
                                var error = $root.google.cloud.compute.v1.Snapshot.verify(message.snapshotResource);
                                if (error)
                                    return "snapshotResource." + error;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a CreateSnapshotDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.CreateSnapshotDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.CreateSnapshotDiskRequest} CreateSnapshotDiskRequest
                         */
                        CreateSnapshotDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.CreateSnapshotDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.CreateSnapshotDiskRequest();
                            if (object.disk != null)
                                message.disk = String(object.disk);
                            if (object.guestFlush != null)
                                message.guestFlush = Boolean(object.guestFlush);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.snapshotResource != null) {
                                if (typeof object.snapshotResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.CreateSnapshotDiskRequest.snapshotResource: object expected");
                                message.snapshotResource = $root.google.cloud.compute.v1.Snapshot.fromObject(object.snapshotResource);
                            }
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateSnapshotDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.CreateSnapshotDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.CreateSnapshotDiskRequest} message CreateSnapshotDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateSnapshotDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.disk = "";
                                object.zone = "";
                                object.project = "";
                                object.snapshotResource = null;
                            }
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                object.disk = message.disk;
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.guestFlush != null && message.hasOwnProperty("guestFlush")) {
                                object.guestFlush = message.guestFlush;
                                if (options.oneofs)
                                    object._guestFlush = "guestFlush";
                            }
                            if (message.snapshotResource != null && message.hasOwnProperty("snapshotResource"))
                                object.snapshotResource = $root.google.cloud.compute.v1.Snapshot.toObject(message.snapshotResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateSnapshotDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.CreateSnapshotDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateSnapshotDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateSnapshotDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.CreateSnapshotDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateSnapshotDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.CreateSnapshotDiskRequest";
                        };
    
                        return CreateSnapshotDiskRequest;
                    })();
    
                    v1.CreateSnapshotRegionDiskRequest = (function() {
    
                        /**
                         * Properties of a CreateSnapshotRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ICreateSnapshotRegionDiskRequest
                         * @property {string|null} [disk] CreateSnapshotRegionDiskRequest disk
                         * @property {string|null} [project] CreateSnapshotRegionDiskRequest project
                         * @property {string|null} [region] CreateSnapshotRegionDiskRequest region
                         * @property {string|null} [requestId] CreateSnapshotRegionDiskRequest requestId
                         * @property {google.cloud.compute.v1.ISnapshot|null} [snapshotResource] CreateSnapshotRegionDiskRequest snapshotResource
                         */
    
                        /**
                         * Constructs a new CreateSnapshotRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a CreateSnapshotRegionDiskRequest.
                         * @implements ICreateSnapshotRegionDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ICreateSnapshotRegionDiskRequest=} [properties] Properties to set
                         */
                        function CreateSnapshotRegionDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CreateSnapshotRegionDiskRequest disk.
                         * @member {string} disk
                         * @memberof google.cloud.compute.v1.CreateSnapshotRegionDiskRequest
                         * @instance
                         */
                        CreateSnapshotRegionDiskRequest.prototype.disk = "";
    
                        /**
                         * CreateSnapshotRegionDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.CreateSnapshotRegionDiskRequest
                         * @instance
                         */
                        CreateSnapshotRegionDiskRequest.prototype.project = "";
    
                        /**
                         * CreateSnapshotRegionDiskRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.CreateSnapshotRegionDiskRequest
                         * @instance
                         */
                        CreateSnapshotRegionDiskRequest.prototype.region = "";
    
                        /**
                         * CreateSnapshotRegionDiskRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.CreateSnapshotRegionDiskRequest
                         * @instance
                         */
                        CreateSnapshotRegionDiskRequest.prototype.requestId = null;
    
                        /**
                         * CreateSnapshotRegionDiskRequest snapshotResource.
                         * @member {google.cloud.compute.v1.ISnapshot|null|undefined} snapshotResource
                         * @memberof google.cloud.compute.v1.CreateSnapshotRegionDiskRequest
                         * @instance
                         */
                        CreateSnapshotRegionDiskRequest.prototype.snapshotResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * CreateSnapshotRegionDiskRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.CreateSnapshotRegionDiskRequest
                         * @instance
                         */
                        Object.defineProperty(CreateSnapshotRegionDiskRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new CreateSnapshotRegionDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.CreateSnapshotRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICreateSnapshotRegionDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.CreateSnapshotRegionDiskRequest} CreateSnapshotRegionDiskRequest instance
                         */
                        CreateSnapshotRegionDiskRequest.create = function create(properties) {
                            return new CreateSnapshotRegionDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified CreateSnapshotRegionDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.CreateSnapshotRegionDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.CreateSnapshotRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICreateSnapshotRegionDiskRequest} message CreateSnapshotRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateSnapshotRegionDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.disk != null && Object.hasOwnProperty.call(message, "disk"))
                                writer.uint32(/* id 3083677, wireType 2 =*/24669418).string(message.disk);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.snapshotResource != null && Object.hasOwnProperty.call(message, "snapshotResource"))
                                $root.google.cloud.compute.v1.Snapshot.encode(message.snapshotResource, writer.uint32(/* id 481319977, wireType 2 =*/3850559818).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CreateSnapshotRegionDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.CreateSnapshotRegionDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.CreateSnapshotRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ICreateSnapshotRegionDiskRequest} message CreateSnapshotRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CreateSnapshotRegionDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CreateSnapshotRegionDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.CreateSnapshotRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.CreateSnapshotRegionDiskRequest} CreateSnapshotRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateSnapshotRegionDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.CreateSnapshotRegionDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3083677: {
                                        message.disk = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 481319977: {
                                        message.snapshotResource = $root.google.cloud.compute.v1.Snapshot.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CreateSnapshotRegionDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.CreateSnapshotRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.CreateSnapshotRegionDiskRequest} CreateSnapshotRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CreateSnapshotRegionDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CreateSnapshotRegionDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.CreateSnapshotRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CreateSnapshotRegionDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                if (!$util.isString(message.disk))
                                    return "disk: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.snapshotResource != null && message.hasOwnProperty("snapshotResource")) {
                                var error = $root.google.cloud.compute.v1.Snapshot.verify(message.snapshotResource);
                                if (error)
                                    return "snapshotResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CreateSnapshotRegionDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.CreateSnapshotRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.CreateSnapshotRegionDiskRequest} CreateSnapshotRegionDiskRequest
                         */
                        CreateSnapshotRegionDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.CreateSnapshotRegionDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.CreateSnapshotRegionDiskRequest();
                            if (object.disk != null)
                                message.disk = String(object.disk);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.snapshotResource != null) {
                                if (typeof object.snapshotResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.CreateSnapshotRegionDiskRequest.snapshotResource: object expected");
                                message.snapshotResource = $root.google.cloud.compute.v1.Snapshot.fromObject(object.snapshotResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CreateSnapshotRegionDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.CreateSnapshotRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.CreateSnapshotRegionDiskRequest} message CreateSnapshotRegionDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CreateSnapshotRegionDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.disk = "";
                                object.region = "";
                                object.project = "";
                                object.snapshotResource = null;
                            }
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                object.disk = message.disk;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.snapshotResource != null && message.hasOwnProperty("snapshotResource"))
                                object.snapshotResource = $root.google.cloud.compute.v1.Snapshot.toObject(message.snapshotResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this CreateSnapshotRegionDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.CreateSnapshotRegionDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CreateSnapshotRegionDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CreateSnapshotRegionDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.CreateSnapshotRegionDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CreateSnapshotRegionDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.CreateSnapshotRegionDiskRequest";
                        };
    
                        return CreateSnapshotRegionDiskRequest;
                    })();
    
                    v1.CustomerEncryptionKey = (function() {
    
                        /**
                         * Properties of a CustomerEncryptionKey.
                         * @memberof google.cloud.compute.v1
                         * @interface ICustomerEncryptionKey
                         * @property {string|null} [kmsKeyName] CustomerEncryptionKey kmsKeyName
                         * @property {string|null} [kmsKeyServiceAccount] CustomerEncryptionKey kmsKeyServiceAccount
                         * @property {string|null} [rawKey] CustomerEncryptionKey rawKey
                         * @property {string|null} [rsaEncryptedKey] CustomerEncryptionKey rsaEncryptedKey
                         * @property {string|null} [sha256] CustomerEncryptionKey sha256
                         */
    
                        /**
                         * Constructs a new CustomerEncryptionKey.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a CustomerEncryptionKey.
                         * @implements ICustomerEncryptionKey
                         * @constructor
                         * @param {google.cloud.compute.v1.ICustomerEncryptionKey=} [properties] Properties to set
                         */
                        function CustomerEncryptionKey(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CustomerEncryptionKey kmsKeyName.
                         * @member {string|null|undefined} kmsKeyName
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKey
                         * @instance
                         */
                        CustomerEncryptionKey.prototype.kmsKeyName = null;
    
                        /**
                         * CustomerEncryptionKey kmsKeyServiceAccount.
                         * @member {string|null|undefined} kmsKeyServiceAccount
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKey
                         * @instance
                         */
                        CustomerEncryptionKey.prototype.kmsKeyServiceAccount = null;
    
                        /**
                         * CustomerEncryptionKey rawKey.
                         * @member {string|null|undefined} rawKey
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKey
                         * @instance
                         */
                        CustomerEncryptionKey.prototype.rawKey = null;
    
                        /**
                         * CustomerEncryptionKey rsaEncryptedKey.
                         * @member {string|null|undefined} rsaEncryptedKey
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKey
                         * @instance
                         */
                        CustomerEncryptionKey.prototype.rsaEncryptedKey = null;
    
                        /**
                         * CustomerEncryptionKey sha256.
                         * @member {string|null|undefined} sha256
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKey
                         * @instance
                         */
                        CustomerEncryptionKey.prototype.sha256 = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * CustomerEncryptionKey _kmsKeyName.
                         * @member {"kmsKeyName"|undefined} _kmsKeyName
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKey
                         * @instance
                         */
                        Object.defineProperty(CustomerEncryptionKey.prototype, "_kmsKeyName", {
                            get: $util.oneOfGetter($oneOfFields = ["kmsKeyName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CustomerEncryptionKey _kmsKeyServiceAccount.
                         * @member {"kmsKeyServiceAccount"|undefined} _kmsKeyServiceAccount
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKey
                         * @instance
                         */
                        Object.defineProperty(CustomerEncryptionKey.prototype, "_kmsKeyServiceAccount", {
                            get: $util.oneOfGetter($oneOfFields = ["kmsKeyServiceAccount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CustomerEncryptionKey _rawKey.
                         * @member {"rawKey"|undefined} _rawKey
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKey
                         * @instance
                         */
                        Object.defineProperty(CustomerEncryptionKey.prototype, "_rawKey", {
                            get: $util.oneOfGetter($oneOfFields = ["rawKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CustomerEncryptionKey _rsaEncryptedKey.
                         * @member {"rsaEncryptedKey"|undefined} _rsaEncryptedKey
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKey
                         * @instance
                         */
                        Object.defineProperty(CustomerEncryptionKey.prototype, "_rsaEncryptedKey", {
                            get: $util.oneOfGetter($oneOfFields = ["rsaEncryptedKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CustomerEncryptionKey _sha256.
                         * @member {"sha256"|undefined} _sha256
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKey
                         * @instance
                         */
                        Object.defineProperty(CustomerEncryptionKey.prototype, "_sha256", {
                            get: $util.oneOfGetter($oneOfFields = ["sha256"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new CustomerEncryptionKey instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKey
                         * @static
                         * @param {google.cloud.compute.v1.ICustomerEncryptionKey=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.CustomerEncryptionKey} CustomerEncryptionKey instance
                         */
                        CustomerEncryptionKey.create = function create(properties) {
                            return new CustomerEncryptionKey(properties);
                        };
    
                        /**
                         * Encodes the specified CustomerEncryptionKey message. Does not implicitly {@link google.cloud.compute.v1.CustomerEncryptionKey.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKey
                         * @static
                         * @param {google.cloud.compute.v1.ICustomerEncryptionKey} message CustomerEncryptionKey message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerEncryptionKey.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.sha256 != null && Object.hasOwnProperty.call(message, "sha256"))
                                writer.uint32(/* id 170112551, wireType 2 =*/1360900410).string(message.sha256);
                            if (message.kmsKeyServiceAccount != null && Object.hasOwnProperty.call(message, "kmsKeyServiceAccount"))
                                writer.uint32(/* id 209986261, wireType 2 =*/1679890090).string(message.kmsKeyServiceAccount);
                            if (message.rsaEncryptedKey != null && Object.hasOwnProperty.call(message, "rsaEncryptedKey"))
                                writer.uint32(/* id 335487397, wireType 2 =*/2683899178).string(message.rsaEncryptedKey);
                            if (message.rawKey != null && Object.hasOwnProperty.call(message, "rawKey"))
                                writer.uint32(/* id 449196488, wireType 2 =*/3593571906).string(message.rawKey);
                            if (message.kmsKeyName != null && Object.hasOwnProperty.call(message, "kmsKeyName"))
                                writer.uint32(/* id 484373913, wireType 2 =*/3874991306).string(message.kmsKeyName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CustomerEncryptionKey message, length delimited. Does not implicitly {@link google.cloud.compute.v1.CustomerEncryptionKey.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKey
                         * @static
                         * @param {google.cloud.compute.v1.ICustomerEncryptionKey} message CustomerEncryptionKey message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerEncryptionKey.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CustomerEncryptionKey message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKey
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.CustomerEncryptionKey} CustomerEncryptionKey
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerEncryptionKey.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.CustomerEncryptionKey();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 484373913: {
                                        message.kmsKeyName = reader.string();
                                        break;
                                    }
                                case 209986261: {
                                        message.kmsKeyServiceAccount = reader.string();
                                        break;
                                    }
                                case 449196488: {
                                        message.rawKey = reader.string();
                                        break;
                                    }
                                case 335487397: {
                                        message.rsaEncryptedKey = reader.string();
                                        break;
                                    }
                                case 170112551: {
                                        message.sha256 = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CustomerEncryptionKey message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKey
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.CustomerEncryptionKey} CustomerEncryptionKey
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerEncryptionKey.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CustomerEncryptionKey message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKey
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerEncryptionKey.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.kmsKeyName != null && message.hasOwnProperty("kmsKeyName")) {
                                properties._kmsKeyName = 1;
                                if (!$util.isString(message.kmsKeyName))
                                    return "kmsKeyName: string expected";
                            }
                            if (message.kmsKeyServiceAccount != null && message.hasOwnProperty("kmsKeyServiceAccount")) {
                                properties._kmsKeyServiceAccount = 1;
                                if (!$util.isString(message.kmsKeyServiceAccount))
                                    return "kmsKeyServiceAccount: string expected";
                            }
                            if (message.rawKey != null && message.hasOwnProperty("rawKey")) {
                                properties._rawKey = 1;
                                if (!$util.isString(message.rawKey))
                                    return "rawKey: string expected";
                            }
                            if (message.rsaEncryptedKey != null && message.hasOwnProperty("rsaEncryptedKey")) {
                                properties._rsaEncryptedKey = 1;
                                if (!$util.isString(message.rsaEncryptedKey))
                                    return "rsaEncryptedKey: string expected";
                            }
                            if (message.sha256 != null && message.hasOwnProperty("sha256")) {
                                properties._sha256 = 1;
                                if (!$util.isString(message.sha256))
                                    return "sha256: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CustomerEncryptionKey message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKey
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.CustomerEncryptionKey} CustomerEncryptionKey
                         */
                        CustomerEncryptionKey.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.CustomerEncryptionKey)
                                return object;
                            var message = new $root.google.cloud.compute.v1.CustomerEncryptionKey();
                            if (object.kmsKeyName != null)
                                message.kmsKeyName = String(object.kmsKeyName);
                            if (object.kmsKeyServiceAccount != null)
                                message.kmsKeyServiceAccount = String(object.kmsKeyServiceAccount);
                            if (object.rawKey != null)
                                message.rawKey = String(object.rawKey);
                            if (object.rsaEncryptedKey != null)
                                message.rsaEncryptedKey = String(object.rsaEncryptedKey);
                            if (object.sha256 != null)
                                message.sha256 = String(object.sha256);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CustomerEncryptionKey message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKey
                         * @static
                         * @param {google.cloud.compute.v1.CustomerEncryptionKey} message CustomerEncryptionKey
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerEncryptionKey.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.sha256 != null && message.hasOwnProperty("sha256")) {
                                object.sha256 = message.sha256;
                                if (options.oneofs)
                                    object._sha256 = "sha256";
                            }
                            if (message.kmsKeyServiceAccount != null && message.hasOwnProperty("kmsKeyServiceAccount")) {
                                object.kmsKeyServiceAccount = message.kmsKeyServiceAccount;
                                if (options.oneofs)
                                    object._kmsKeyServiceAccount = "kmsKeyServiceAccount";
                            }
                            if (message.rsaEncryptedKey != null && message.hasOwnProperty("rsaEncryptedKey")) {
                                object.rsaEncryptedKey = message.rsaEncryptedKey;
                                if (options.oneofs)
                                    object._rsaEncryptedKey = "rsaEncryptedKey";
                            }
                            if (message.rawKey != null && message.hasOwnProperty("rawKey")) {
                                object.rawKey = message.rawKey;
                                if (options.oneofs)
                                    object._rawKey = "rawKey";
                            }
                            if (message.kmsKeyName != null && message.hasOwnProperty("kmsKeyName")) {
                                object.kmsKeyName = message.kmsKeyName;
                                if (options.oneofs)
                                    object._kmsKeyName = "kmsKeyName";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this CustomerEncryptionKey to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKey
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerEncryptionKey.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CustomerEncryptionKey
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKey
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CustomerEncryptionKey.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.CustomerEncryptionKey";
                        };
    
                        return CustomerEncryptionKey;
                    })();
    
                    v1.CustomerEncryptionKeyProtectedDisk = (function() {
    
                        /**
                         * Properties of a CustomerEncryptionKeyProtectedDisk.
                         * @memberof google.cloud.compute.v1
                         * @interface ICustomerEncryptionKeyProtectedDisk
                         * @property {google.cloud.compute.v1.ICustomerEncryptionKey|null} [diskEncryptionKey] CustomerEncryptionKeyProtectedDisk diskEncryptionKey
                         * @property {string|null} [source] CustomerEncryptionKeyProtectedDisk source
                         */
    
                        /**
                         * Constructs a new CustomerEncryptionKeyProtectedDisk.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a CustomerEncryptionKeyProtectedDisk.
                         * @implements ICustomerEncryptionKeyProtectedDisk
                         * @constructor
                         * @param {google.cloud.compute.v1.ICustomerEncryptionKeyProtectedDisk=} [properties] Properties to set
                         */
                        function CustomerEncryptionKeyProtectedDisk(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * CustomerEncryptionKeyProtectedDisk diskEncryptionKey.
                         * @member {google.cloud.compute.v1.ICustomerEncryptionKey|null|undefined} diskEncryptionKey
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk
                         * @instance
                         */
                        CustomerEncryptionKeyProtectedDisk.prototype.diskEncryptionKey = null;
    
                        /**
                         * CustomerEncryptionKeyProtectedDisk source.
                         * @member {string|null|undefined} source
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk
                         * @instance
                         */
                        CustomerEncryptionKeyProtectedDisk.prototype.source = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * CustomerEncryptionKeyProtectedDisk _diskEncryptionKey.
                         * @member {"diskEncryptionKey"|undefined} _diskEncryptionKey
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk
                         * @instance
                         */
                        Object.defineProperty(CustomerEncryptionKeyProtectedDisk.prototype, "_diskEncryptionKey", {
                            get: $util.oneOfGetter($oneOfFields = ["diskEncryptionKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * CustomerEncryptionKeyProtectedDisk _source.
                         * @member {"source"|undefined} _source
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk
                         * @instance
                         */
                        Object.defineProperty(CustomerEncryptionKeyProtectedDisk.prototype, "_source", {
                            get: $util.oneOfGetter($oneOfFields = ["source"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new CustomerEncryptionKeyProtectedDisk instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk
                         * @static
                         * @param {google.cloud.compute.v1.ICustomerEncryptionKeyProtectedDisk=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk} CustomerEncryptionKeyProtectedDisk instance
                         */
                        CustomerEncryptionKeyProtectedDisk.create = function create(properties) {
                            return new CustomerEncryptionKeyProtectedDisk(properties);
                        };
    
                        /**
                         * Encodes the specified CustomerEncryptionKeyProtectedDisk message. Does not implicitly {@link google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk
                         * @static
                         * @param {google.cloud.compute.v1.ICustomerEncryptionKeyProtectedDisk} message CustomerEncryptionKeyProtectedDisk message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerEncryptionKeyProtectedDisk.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.source != null && Object.hasOwnProperty.call(message, "source"))
                                writer.uint32(/* id 177235995, wireType 2 =*/1417887962).string(message.source);
                            if (message.diskEncryptionKey != null && Object.hasOwnProperty.call(message, "diskEncryptionKey"))
                                $root.google.cloud.compute.v1.CustomerEncryptionKey.encode(message.diskEncryptionKey, writer.uint32(/* id 271660677, wireType 2 =*/2173285418).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified CustomerEncryptionKeyProtectedDisk message, length delimited. Does not implicitly {@link google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk
                         * @static
                         * @param {google.cloud.compute.v1.ICustomerEncryptionKeyProtectedDisk} message CustomerEncryptionKeyProtectedDisk message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        CustomerEncryptionKeyProtectedDisk.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a CustomerEncryptionKeyProtectedDisk message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk} CustomerEncryptionKeyProtectedDisk
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerEncryptionKeyProtectedDisk.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 271660677: {
                                        message.diskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 177235995: {
                                        message.source = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a CustomerEncryptionKeyProtectedDisk message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk} CustomerEncryptionKeyProtectedDisk
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        CustomerEncryptionKeyProtectedDisk.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a CustomerEncryptionKeyProtectedDisk message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        CustomerEncryptionKeyProtectedDisk.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.diskEncryptionKey != null && message.hasOwnProperty("diskEncryptionKey")) {
                                properties._diskEncryptionKey = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.CustomerEncryptionKey.verify(message.diskEncryptionKey);
                                    if (error)
                                        return "diskEncryptionKey." + error;
                                }
                            }
                            if (message.source != null && message.hasOwnProperty("source")) {
                                properties._source = 1;
                                if (!$util.isString(message.source))
                                    return "source: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a CustomerEncryptionKeyProtectedDisk message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk} CustomerEncryptionKeyProtectedDisk
                         */
                        CustomerEncryptionKeyProtectedDisk.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk)
                                return object;
                            var message = new $root.google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk();
                            if (object.diskEncryptionKey != null) {
                                if (typeof object.diskEncryptionKey !== "object")
                                    throw TypeError(".google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk.diskEncryptionKey: object expected");
                                message.diskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.fromObject(object.diskEncryptionKey);
                            }
                            if (object.source != null)
                                message.source = String(object.source);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a CustomerEncryptionKeyProtectedDisk message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk
                         * @static
                         * @param {google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk} message CustomerEncryptionKeyProtectedDisk
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        CustomerEncryptionKeyProtectedDisk.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.source != null && message.hasOwnProperty("source")) {
                                object.source = message.source;
                                if (options.oneofs)
                                    object._source = "source";
                            }
                            if (message.diskEncryptionKey != null && message.hasOwnProperty("diskEncryptionKey")) {
                                object.diskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.toObject(message.diskEncryptionKey, options);
                                if (options.oneofs)
                                    object._diskEncryptionKey = "diskEncryptionKey";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this CustomerEncryptionKeyProtectedDisk to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        CustomerEncryptionKeyProtectedDisk.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for CustomerEncryptionKeyProtectedDisk
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        CustomerEncryptionKeyProtectedDisk.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk";
                        };
    
                        return CustomerEncryptionKeyProtectedDisk;
                    })();
    
                    v1.Data = (function() {
    
                        /**
                         * Properties of a Data.
                         * @memberof google.cloud.compute.v1
                         * @interface IData
                         * @property {string|null} [key] Data key
                         * @property {string|null} [value] Data value
                         */
    
                        /**
                         * Constructs a new Data.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Data.
                         * @implements IData
                         * @constructor
                         * @param {google.cloud.compute.v1.IData=} [properties] Properties to set
                         */
                        function Data(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Data key.
                         * @member {string|null|undefined} key
                         * @memberof google.cloud.compute.v1.Data
                         * @instance
                         */
                        Data.prototype.key = null;
    
                        /**
                         * Data value.
                         * @member {string|null|undefined} value
                         * @memberof google.cloud.compute.v1.Data
                         * @instance
                         */
                        Data.prototype.value = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Data _key.
                         * @member {"key"|undefined} _key
                         * @memberof google.cloud.compute.v1.Data
                         * @instance
                         */
                        Object.defineProperty(Data.prototype, "_key", {
                            get: $util.oneOfGetter($oneOfFields = ["key"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Data _value.
                         * @member {"value"|undefined} _value
                         * @memberof google.cloud.compute.v1.Data
                         * @instance
                         */
                        Object.defineProperty(Data.prototype, "_value", {
                            get: $util.oneOfGetter($oneOfFields = ["value"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Data instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Data
                         * @static
                         * @param {google.cloud.compute.v1.IData=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Data} Data instance
                         */
                        Data.create = function create(properties) {
                            return new Data(properties);
                        };
    
                        /**
                         * Encodes the specified Data message. Does not implicitly {@link google.cloud.compute.v1.Data.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Data
                         * @static
                         * @param {google.cloud.compute.v1.IData} message Data message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Data.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.key != null && Object.hasOwnProperty.call(message, "key"))
                                writer.uint32(/* id 106079, wireType 2 =*/848634).string(message.key);
                            if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                writer.uint32(/* id 111972721, wireType 2 =*/895781770).string(message.value);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Data message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Data.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Data
                         * @static
                         * @param {google.cloud.compute.v1.IData} message Data message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Data.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Data message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Data
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Data} Data
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Data.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Data();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 106079: {
                                        message.key = reader.string();
                                        break;
                                    }
                                case 111972721: {
                                        message.value = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Data message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Data
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Data} Data
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Data.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Data message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Data
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Data.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.key != null && message.hasOwnProperty("key")) {
                                properties._key = 1;
                                if (!$util.isString(message.key))
                                    return "key: string expected";
                            }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                properties._value = 1;
                                if (!$util.isString(message.value))
                                    return "value: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Data message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Data
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Data} Data
                         */
                        Data.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Data)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Data();
                            if (object.key != null)
                                message.key = String(object.key);
                            if (object.value != null)
                                message.value = String(object.value);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Data message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Data
                         * @static
                         * @param {google.cloud.compute.v1.Data} message Data
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Data.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.key != null && message.hasOwnProperty("key")) {
                                object.key = message.key;
                                if (options.oneofs)
                                    object._key = "key";
                            }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                object.value = message.value;
                                if (options.oneofs)
                                    object._value = "value";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Data to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Data
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Data.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Data
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Data
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Data.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Data";
                        };
    
                        return Data;
                    })();
    
                    v1.DeleteAccessConfigInstanceRequest = (function() {
    
                        /**
                         * Properties of a DeleteAccessConfigInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteAccessConfigInstanceRequest
                         * @property {string|null} [accessConfig] DeleteAccessConfigInstanceRequest accessConfig
                         * @property {string|null} [instance] DeleteAccessConfigInstanceRequest instance
                         * @property {string|null} [networkInterface] DeleteAccessConfigInstanceRequest networkInterface
                         * @property {string|null} [project] DeleteAccessConfigInstanceRequest project
                         * @property {string|null} [requestId] DeleteAccessConfigInstanceRequest requestId
                         * @property {string|null} [zone] DeleteAccessConfigInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new DeleteAccessConfigInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteAccessConfigInstanceRequest.
                         * @implements IDeleteAccessConfigInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteAccessConfigInstanceRequest=} [properties] Properties to set
                         */
                        function DeleteAccessConfigInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteAccessConfigInstanceRequest accessConfig.
                         * @member {string} accessConfig
                         * @memberof google.cloud.compute.v1.DeleteAccessConfigInstanceRequest
                         * @instance
                         */
                        DeleteAccessConfigInstanceRequest.prototype.accessConfig = "";
    
                        /**
                         * DeleteAccessConfigInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.DeleteAccessConfigInstanceRequest
                         * @instance
                         */
                        DeleteAccessConfigInstanceRequest.prototype.instance = "";
    
                        /**
                         * DeleteAccessConfigInstanceRequest networkInterface.
                         * @member {string} networkInterface
                         * @memberof google.cloud.compute.v1.DeleteAccessConfigInstanceRequest
                         * @instance
                         */
                        DeleteAccessConfigInstanceRequest.prototype.networkInterface = "";
    
                        /**
                         * DeleteAccessConfigInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteAccessConfigInstanceRequest
                         * @instance
                         */
                        DeleteAccessConfigInstanceRequest.prototype.project = "";
    
                        /**
                         * DeleteAccessConfigInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteAccessConfigInstanceRequest
                         * @instance
                         */
                        DeleteAccessConfigInstanceRequest.prototype.requestId = null;
    
                        /**
                         * DeleteAccessConfigInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.DeleteAccessConfigInstanceRequest
                         * @instance
                         */
                        DeleteAccessConfigInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteAccessConfigInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteAccessConfigInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteAccessConfigInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteAccessConfigInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteAccessConfigInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteAccessConfigInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteAccessConfigInstanceRequest} DeleteAccessConfigInstanceRequest instance
                         */
                        DeleteAccessConfigInstanceRequest.create = function create(properties) {
                            return new DeleteAccessConfigInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteAccessConfigInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteAccessConfigInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteAccessConfigInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteAccessConfigInstanceRequest} message DeleteAccessConfigInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteAccessConfigInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.accessConfig != null && Object.hasOwnProperty.call(message, "accessConfig"))
                                writer.uint32(/* id 72856189, wireType 2 =*/582849514).string(message.accessConfig);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.networkInterface != null && Object.hasOwnProperty.call(message, "networkInterface"))
                                writer.uint32(/* id 365387880, wireType 2 =*/2923103042).string(message.networkInterface);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteAccessConfigInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteAccessConfigInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteAccessConfigInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteAccessConfigInstanceRequest} message DeleteAccessConfigInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteAccessConfigInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteAccessConfigInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteAccessConfigInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteAccessConfigInstanceRequest} DeleteAccessConfigInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteAccessConfigInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteAccessConfigInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 72856189: {
                                        message.accessConfig = reader.string();
                                        break;
                                    }
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 365387880: {
                                        message.networkInterface = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteAccessConfigInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteAccessConfigInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteAccessConfigInstanceRequest} DeleteAccessConfigInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteAccessConfigInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteAccessConfigInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteAccessConfigInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteAccessConfigInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.accessConfig != null && message.hasOwnProperty("accessConfig"))
                                if (!$util.isString(message.accessConfig))
                                    return "accessConfig: string expected";
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.networkInterface != null && message.hasOwnProperty("networkInterface"))
                                if (!$util.isString(message.networkInterface))
                                    return "networkInterface: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteAccessConfigInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteAccessConfigInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteAccessConfigInstanceRequest} DeleteAccessConfigInstanceRequest
                         */
                        DeleteAccessConfigInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteAccessConfigInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteAccessConfigInstanceRequest();
                            if (object.accessConfig != null)
                                message.accessConfig = String(object.accessConfig);
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.networkInterface != null)
                                message.networkInterface = String(object.networkInterface);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteAccessConfigInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteAccessConfigInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteAccessConfigInstanceRequest} message DeleteAccessConfigInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteAccessConfigInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.accessConfig = "";
                                object.project = "";
                                object.networkInterface = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.accessConfig != null && message.hasOwnProperty("accessConfig"))
                                object.accessConfig = message.accessConfig;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.networkInterface != null && message.hasOwnProperty("networkInterface"))
                                object.networkInterface = message.networkInterface;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteAccessConfigInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteAccessConfigInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteAccessConfigInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteAccessConfigInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteAccessConfigInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteAccessConfigInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteAccessConfigInstanceRequest";
                        };
    
                        return DeleteAccessConfigInstanceRequest;
                    })();
    
                    v1.DeleteAddressRequest = (function() {
    
                        /**
                         * Properties of a DeleteAddressRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteAddressRequest
                         * @property {string|null} [address] DeleteAddressRequest address
                         * @property {string|null} [project] DeleteAddressRequest project
                         * @property {string|null} [region] DeleteAddressRequest region
                         * @property {string|null} [requestId] DeleteAddressRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteAddressRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteAddressRequest.
                         * @implements IDeleteAddressRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteAddressRequest=} [properties] Properties to set
                         */
                        function DeleteAddressRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteAddressRequest address.
                         * @member {string} address
                         * @memberof google.cloud.compute.v1.DeleteAddressRequest
                         * @instance
                         */
                        DeleteAddressRequest.prototype.address = "";
    
                        /**
                         * DeleteAddressRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteAddressRequest
                         * @instance
                         */
                        DeleteAddressRequest.prototype.project = "";
    
                        /**
                         * DeleteAddressRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteAddressRequest
                         * @instance
                         */
                        DeleteAddressRequest.prototype.region = "";
    
                        /**
                         * DeleteAddressRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteAddressRequest
                         * @instance
                         */
                        DeleteAddressRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteAddressRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteAddressRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteAddressRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteAddressRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteAddressRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteAddressRequest} DeleteAddressRequest instance
                         */
                        DeleteAddressRequest.create = function create(properties) {
                            return new DeleteAddressRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteAddressRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteAddressRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteAddressRequest} message DeleteAddressRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteAddressRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.address != null && Object.hasOwnProperty.call(message, "address"))
                                writer.uint32(/* id 462920692, wireType 2 =*/3703365538).string(message.address);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteAddressRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteAddressRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteAddressRequest} message DeleteAddressRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteAddressRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteAddressRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteAddressRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteAddressRequest} DeleteAddressRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteAddressRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteAddressRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 462920692: {
                                        message.address = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteAddressRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteAddressRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteAddressRequest} DeleteAddressRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteAddressRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteAddressRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteAddressRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteAddressRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.address != null && message.hasOwnProperty("address"))
                                if (!$util.isString(message.address))
                                    return "address: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteAddressRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteAddressRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteAddressRequest} DeleteAddressRequest
                         */
                        DeleteAddressRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteAddressRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteAddressRequest();
                            if (object.address != null)
                                message.address = String(object.address);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteAddressRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteAddressRequest} message DeleteAddressRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteAddressRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.address = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.address != null && message.hasOwnProperty("address"))
                                object.address = message.address;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteAddressRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteAddressRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteAddressRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteAddressRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteAddressRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteAddressRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteAddressRequest";
                        };
    
                        return DeleteAddressRequest;
                    })();
    
                    v1.DeleteAutoscalerRequest = (function() {
    
                        /**
                         * Properties of a DeleteAutoscalerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteAutoscalerRequest
                         * @property {string|null} [autoscaler] DeleteAutoscalerRequest autoscaler
                         * @property {string|null} [project] DeleteAutoscalerRequest project
                         * @property {string|null} [requestId] DeleteAutoscalerRequest requestId
                         * @property {string|null} [zone] DeleteAutoscalerRequest zone
                         */
    
                        /**
                         * Constructs a new DeleteAutoscalerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteAutoscalerRequest.
                         * @implements IDeleteAutoscalerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteAutoscalerRequest=} [properties] Properties to set
                         */
                        function DeleteAutoscalerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteAutoscalerRequest autoscaler.
                         * @member {string} autoscaler
                         * @memberof google.cloud.compute.v1.DeleteAutoscalerRequest
                         * @instance
                         */
                        DeleteAutoscalerRequest.prototype.autoscaler = "";
    
                        /**
                         * DeleteAutoscalerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteAutoscalerRequest
                         * @instance
                         */
                        DeleteAutoscalerRequest.prototype.project = "";
    
                        /**
                         * DeleteAutoscalerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteAutoscalerRequest
                         * @instance
                         */
                        DeleteAutoscalerRequest.prototype.requestId = null;
    
                        /**
                         * DeleteAutoscalerRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.DeleteAutoscalerRequest
                         * @instance
                         */
                        DeleteAutoscalerRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteAutoscalerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteAutoscalerRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteAutoscalerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteAutoscalerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteAutoscalerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteAutoscalerRequest} DeleteAutoscalerRequest instance
                         */
                        DeleteAutoscalerRequest.create = function create(properties) {
                            return new DeleteAutoscalerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteAutoscalerRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteAutoscalerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteAutoscalerRequest} message DeleteAutoscalerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteAutoscalerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.autoscaler != null && Object.hasOwnProperty.call(message, "autoscaler"))
                                writer.uint32(/* id 517258967, wireType 2 =*/4138071738).string(message.autoscaler);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteAutoscalerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteAutoscalerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteAutoscalerRequest} message DeleteAutoscalerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteAutoscalerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteAutoscalerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteAutoscalerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteAutoscalerRequest} DeleteAutoscalerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteAutoscalerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteAutoscalerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 517258967: {
                                        message.autoscaler = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteAutoscalerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteAutoscalerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteAutoscalerRequest} DeleteAutoscalerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteAutoscalerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteAutoscalerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteAutoscalerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteAutoscalerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoscaler != null && message.hasOwnProperty("autoscaler"))
                                if (!$util.isString(message.autoscaler))
                                    return "autoscaler: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteAutoscalerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteAutoscalerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteAutoscalerRequest} DeleteAutoscalerRequest
                         */
                        DeleteAutoscalerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteAutoscalerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteAutoscalerRequest();
                            if (object.autoscaler != null)
                                message.autoscaler = String(object.autoscaler);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteAutoscalerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteAutoscalerRequest} message DeleteAutoscalerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteAutoscalerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.autoscaler = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.autoscaler != null && message.hasOwnProperty("autoscaler"))
                                object.autoscaler = message.autoscaler;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteAutoscalerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteAutoscalerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteAutoscalerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteAutoscalerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteAutoscalerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteAutoscalerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteAutoscalerRequest";
                        };
    
                        return DeleteAutoscalerRequest;
                    })();
    
                    v1.DeleteBackendBucketRequest = (function() {
    
                        /**
                         * Properties of a DeleteBackendBucketRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteBackendBucketRequest
                         * @property {string|null} [backendBucket] DeleteBackendBucketRequest backendBucket
                         * @property {string|null} [project] DeleteBackendBucketRequest project
                         * @property {string|null} [requestId] DeleteBackendBucketRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteBackendBucketRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteBackendBucketRequest.
                         * @implements IDeleteBackendBucketRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteBackendBucketRequest=} [properties] Properties to set
                         */
                        function DeleteBackendBucketRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteBackendBucketRequest backendBucket.
                         * @member {string} backendBucket
                         * @memberof google.cloud.compute.v1.DeleteBackendBucketRequest
                         * @instance
                         */
                        DeleteBackendBucketRequest.prototype.backendBucket = "";
    
                        /**
                         * DeleteBackendBucketRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteBackendBucketRequest
                         * @instance
                         */
                        DeleteBackendBucketRequest.prototype.project = "";
    
                        /**
                         * DeleteBackendBucketRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteBackendBucketRequest
                         * @instance
                         */
                        DeleteBackendBucketRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteBackendBucketRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteBackendBucketRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteBackendBucketRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteBackendBucketRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteBackendBucketRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteBackendBucketRequest} DeleteBackendBucketRequest instance
                         */
                        DeleteBackendBucketRequest.create = function create(properties) {
                            return new DeleteBackendBucketRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteBackendBucketRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteBackendBucketRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteBackendBucketRequest} message DeleteBackendBucketRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteBackendBucketRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.backendBucket != null && Object.hasOwnProperty.call(message, "backendBucket"))
                                writer.uint32(/* id 91714037, wireType 2 =*/733712298).string(message.backendBucket);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteBackendBucketRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteBackendBucketRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteBackendBucketRequest} message DeleteBackendBucketRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteBackendBucketRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteBackendBucketRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteBackendBucketRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteBackendBucketRequest} DeleteBackendBucketRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteBackendBucketRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteBackendBucketRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 91714037: {
                                        message.backendBucket = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteBackendBucketRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteBackendBucketRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteBackendBucketRequest} DeleteBackendBucketRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteBackendBucketRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteBackendBucketRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteBackendBucketRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteBackendBucketRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendBucket != null && message.hasOwnProperty("backendBucket"))
                                if (!$util.isString(message.backendBucket))
                                    return "backendBucket: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteBackendBucketRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteBackendBucketRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteBackendBucketRequest} DeleteBackendBucketRequest
                         */
                        DeleteBackendBucketRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteBackendBucketRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteBackendBucketRequest();
                            if (object.backendBucket != null)
                                message.backendBucket = String(object.backendBucket);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteBackendBucketRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteBackendBucketRequest} message DeleteBackendBucketRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteBackendBucketRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.backendBucket = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.backendBucket != null && message.hasOwnProperty("backendBucket"))
                                object.backendBucket = message.backendBucket;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteBackendBucketRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteBackendBucketRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteBackendBucketRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteBackendBucketRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteBackendBucketRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteBackendBucketRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteBackendBucketRequest";
                        };
    
                        return DeleteBackendBucketRequest;
                    })();
    
                    v1.DeleteBackendServiceRequest = (function() {
    
                        /**
                         * Properties of a DeleteBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteBackendServiceRequest
                         * @property {string|null} [backendService] DeleteBackendServiceRequest backendService
                         * @property {string|null} [project] DeleteBackendServiceRequest project
                         * @property {string|null} [requestId] DeleteBackendServiceRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteBackendServiceRequest.
                         * @implements IDeleteBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteBackendServiceRequest=} [properties] Properties to set
                         */
                        function DeleteBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteBackendServiceRequest backendService.
                         * @member {string} backendService
                         * @memberof google.cloud.compute.v1.DeleteBackendServiceRequest
                         * @instance
                         */
                        DeleteBackendServiceRequest.prototype.backendService = "";
    
                        /**
                         * DeleteBackendServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteBackendServiceRequest
                         * @instance
                         */
                        DeleteBackendServiceRequest.prototype.project = "";
    
                        /**
                         * DeleteBackendServiceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteBackendServiceRequest
                         * @instance
                         */
                        DeleteBackendServiceRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteBackendServiceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteBackendServiceRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteBackendServiceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteBackendServiceRequest} DeleteBackendServiceRequest instance
                         */
                        DeleteBackendServiceRequest.create = function create(properties) {
                            return new DeleteBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteBackendServiceRequest} message DeleteBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.backendService != null && Object.hasOwnProperty.call(message, "backendService"))
                                writer.uint32(/* id 306946058, wireType 2 =*/2455568466).string(message.backendService);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteBackendServiceRequest} message DeleteBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteBackendServiceRequest} DeleteBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 306946058: {
                                        message.backendService = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteBackendServiceRequest} DeleteBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                if (!$util.isString(message.backendService))
                                    return "backendService: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteBackendServiceRequest} DeleteBackendServiceRequest
                         */
                        DeleteBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteBackendServiceRequest();
                            if (object.backendService != null)
                                message.backendService = String(object.backendService);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteBackendServiceRequest} message DeleteBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.backendService = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                object.backendService = message.backendService;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteBackendServiceRequest";
                        };
    
                        return DeleteBackendServiceRequest;
                    })();
    
                    v1.DeleteDiskRequest = (function() {
    
                        /**
                         * Properties of a DeleteDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteDiskRequest
                         * @property {string|null} [disk] DeleteDiskRequest disk
                         * @property {string|null} [project] DeleteDiskRequest project
                         * @property {string|null} [requestId] DeleteDiskRequest requestId
                         * @property {string|null} [zone] DeleteDiskRequest zone
                         */
    
                        /**
                         * Constructs a new DeleteDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteDiskRequest.
                         * @implements IDeleteDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteDiskRequest=} [properties] Properties to set
                         */
                        function DeleteDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteDiskRequest disk.
                         * @member {string} disk
                         * @memberof google.cloud.compute.v1.DeleteDiskRequest
                         * @instance
                         */
                        DeleteDiskRequest.prototype.disk = "";
    
                        /**
                         * DeleteDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteDiskRequest
                         * @instance
                         */
                        DeleteDiskRequest.prototype.project = "";
    
                        /**
                         * DeleteDiskRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteDiskRequest
                         * @instance
                         */
                        DeleteDiskRequest.prototype.requestId = null;
    
                        /**
                         * DeleteDiskRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.DeleteDiskRequest
                         * @instance
                         */
                        DeleteDiskRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteDiskRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteDiskRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteDiskRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteDiskRequest} DeleteDiskRequest instance
                         */
                        DeleteDiskRequest.create = function create(properties) {
                            return new DeleteDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteDiskRequest} message DeleteDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.disk != null && Object.hasOwnProperty.call(message, "disk"))
                                writer.uint32(/* id 3083677, wireType 2 =*/24669418).string(message.disk);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteDiskRequest} message DeleteDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteDiskRequest} DeleteDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3083677: {
                                        message.disk = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteDiskRequest} DeleteDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                if (!$util.isString(message.disk))
                                    return "disk: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteDiskRequest} DeleteDiskRequest
                         */
                        DeleteDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteDiskRequest();
                            if (object.disk != null)
                                message.disk = String(object.disk);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteDiskRequest} message DeleteDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.disk = "";
                                object.zone = "";
                                object.project = "";
                            }
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                object.disk = message.disk;
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteDiskRequest";
                        };
    
                        return DeleteDiskRequest;
                    })();
    
                    v1.DeleteExternalVpnGatewayRequest = (function() {
    
                        /**
                         * Properties of a DeleteExternalVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteExternalVpnGatewayRequest
                         * @property {string|null} [externalVpnGateway] DeleteExternalVpnGatewayRequest externalVpnGateway
                         * @property {string|null} [project] DeleteExternalVpnGatewayRequest project
                         * @property {string|null} [requestId] DeleteExternalVpnGatewayRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteExternalVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteExternalVpnGatewayRequest.
                         * @implements IDeleteExternalVpnGatewayRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteExternalVpnGatewayRequest=} [properties] Properties to set
                         */
                        function DeleteExternalVpnGatewayRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteExternalVpnGatewayRequest externalVpnGateway.
                         * @member {string} externalVpnGateway
                         * @memberof google.cloud.compute.v1.DeleteExternalVpnGatewayRequest
                         * @instance
                         */
                        DeleteExternalVpnGatewayRequest.prototype.externalVpnGateway = "";
    
                        /**
                         * DeleteExternalVpnGatewayRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteExternalVpnGatewayRequest
                         * @instance
                         */
                        DeleteExternalVpnGatewayRequest.prototype.project = "";
    
                        /**
                         * DeleteExternalVpnGatewayRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteExternalVpnGatewayRequest
                         * @instance
                         */
                        DeleteExternalVpnGatewayRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteExternalVpnGatewayRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteExternalVpnGatewayRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteExternalVpnGatewayRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteExternalVpnGatewayRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteExternalVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteExternalVpnGatewayRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteExternalVpnGatewayRequest} DeleteExternalVpnGatewayRequest instance
                         */
                        DeleteExternalVpnGatewayRequest.create = function create(properties) {
                            return new DeleteExternalVpnGatewayRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteExternalVpnGatewayRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteExternalVpnGatewayRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteExternalVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteExternalVpnGatewayRequest} message DeleteExternalVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteExternalVpnGatewayRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.externalVpnGateway != null && Object.hasOwnProperty.call(message, "externalVpnGateway"))
                                writer.uint32(/* id 109898629, wireType 2 =*/879189034).string(message.externalVpnGateway);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteExternalVpnGatewayRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteExternalVpnGatewayRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteExternalVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteExternalVpnGatewayRequest} message DeleteExternalVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteExternalVpnGatewayRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteExternalVpnGatewayRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteExternalVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteExternalVpnGatewayRequest} DeleteExternalVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteExternalVpnGatewayRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteExternalVpnGatewayRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 109898629: {
                                        message.externalVpnGateway = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteExternalVpnGatewayRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteExternalVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteExternalVpnGatewayRequest} DeleteExternalVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteExternalVpnGatewayRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteExternalVpnGatewayRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteExternalVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteExternalVpnGatewayRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.externalVpnGateway != null && message.hasOwnProperty("externalVpnGateway"))
                                if (!$util.isString(message.externalVpnGateway))
                                    return "externalVpnGateway: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteExternalVpnGatewayRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteExternalVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteExternalVpnGatewayRequest} DeleteExternalVpnGatewayRequest
                         */
                        DeleteExternalVpnGatewayRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteExternalVpnGatewayRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteExternalVpnGatewayRequest();
                            if (object.externalVpnGateway != null)
                                message.externalVpnGateway = String(object.externalVpnGateway);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteExternalVpnGatewayRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteExternalVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteExternalVpnGatewayRequest} message DeleteExternalVpnGatewayRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteExternalVpnGatewayRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.externalVpnGateway = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.externalVpnGateway != null && message.hasOwnProperty("externalVpnGateway"))
                                object.externalVpnGateway = message.externalVpnGateway;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteExternalVpnGatewayRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteExternalVpnGatewayRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteExternalVpnGatewayRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteExternalVpnGatewayRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteExternalVpnGatewayRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteExternalVpnGatewayRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteExternalVpnGatewayRequest";
                        };
    
                        return DeleteExternalVpnGatewayRequest;
                    })();
    
                    v1.DeleteFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a DeleteFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] DeleteFirewallPolicyRequest firewallPolicy
                         * @property {string|null} [requestId] DeleteFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteFirewallPolicyRequest.
                         * @implements IDeleteFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function DeleteFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.DeleteFirewallPolicyRequest
                         * @instance
                         */
                        DeleteFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * DeleteFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteFirewallPolicyRequest
                         * @instance
                         */
                        DeleteFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteFirewallPolicyRequest} DeleteFirewallPolicyRequest instance
                         */
                        DeleteFirewallPolicyRequest.create = function create(properties) {
                            return new DeleteFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteFirewallPolicyRequest} message DeleteFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteFirewallPolicyRequest} message DeleteFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteFirewallPolicyRequest} DeleteFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteFirewallPolicyRequest} DeleteFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteFirewallPolicyRequest} DeleteFirewallPolicyRequest
                         */
                        DeleteFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteFirewallPolicyRequest} message DeleteFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.firewallPolicy = "";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteFirewallPolicyRequest";
                        };
    
                        return DeleteFirewallPolicyRequest;
                    })();
    
                    v1.DeleteFirewallRequest = (function() {
    
                        /**
                         * Properties of a DeleteFirewallRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteFirewallRequest
                         * @property {string|null} [firewall] DeleteFirewallRequest firewall
                         * @property {string|null} [project] DeleteFirewallRequest project
                         * @property {string|null} [requestId] DeleteFirewallRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteFirewallRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteFirewallRequest.
                         * @implements IDeleteFirewallRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteFirewallRequest=} [properties] Properties to set
                         */
                        function DeleteFirewallRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteFirewallRequest firewall.
                         * @member {string} firewall
                         * @memberof google.cloud.compute.v1.DeleteFirewallRequest
                         * @instance
                         */
                        DeleteFirewallRequest.prototype.firewall = "";
    
                        /**
                         * DeleteFirewallRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteFirewallRequest
                         * @instance
                         */
                        DeleteFirewallRequest.prototype.project = "";
    
                        /**
                         * DeleteFirewallRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteFirewallRequest
                         * @instance
                         */
                        DeleteFirewallRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteFirewallRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteFirewallRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteFirewallRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteFirewallRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteFirewallRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteFirewallRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteFirewallRequest} DeleteFirewallRequest instance
                         */
                        DeleteFirewallRequest.create = function create(properties) {
                            return new DeleteFirewallRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteFirewallRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteFirewallRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteFirewallRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteFirewallRequest} message DeleteFirewallRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteFirewallRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewall != null && Object.hasOwnProperty.call(message, "firewall"))
                                writer.uint32(/* id 511016192, wireType 2 =*/4088129538).string(message.firewall);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteFirewallRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteFirewallRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteFirewallRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteFirewallRequest} message DeleteFirewallRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteFirewallRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteFirewallRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteFirewallRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteFirewallRequest} DeleteFirewallRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteFirewallRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteFirewallRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 511016192: {
                                        message.firewall = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteFirewallRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteFirewallRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteFirewallRequest} DeleteFirewallRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteFirewallRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteFirewallRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteFirewallRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteFirewallRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewall != null && message.hasOwnProperty("firewall"))
                                if (!$util.isString(message.firewall))
                                    return "firewall: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteFirewallRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteFirewallRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteFirewallRequest} DeleteFirewallRequest
                         */
                        DeleteFirewallRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteFirewallRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteFirewallRequest();
                            if (object.firewall != null)
                                message.firewall = String(object.firewall);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteFirewallRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteFirewallRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteFirewallRequest} message DeleteFirewallRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteFirewallRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.firewall = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewall != null && message.hasOwnProperty("firewall"))
                                object.firewall = message.firewall;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteFirewallRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteFirewallRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteFirewallRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteFirewallRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteFirewallRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteFirewallRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteFirewallRequest";
                        };
    
                        return DeleteFirewallRequest;
                    })();
    
                    v1.DeleteForwardingRuleRequest = (function() {
    
                        /**
                         * Properties of a DeleteForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteForwardingRuleRequest
                         * @property {string|null} [forwardingRule] DeleteForwardingRuleRequest forwardingRule
                         * @property {string|null} [project] DeleteForwardingRuleRequest project
                         * @property {string|null} [region] DeleteForwardingRuleRequest region
                         * @property {string|null} [requestId] DeleteForwardingRuleRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteForwardingRuleRequest.
                         * @implements IDeleteForwardingRuleRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteForwardingRuleRequest=} [properties] Properties to set
                         */
                        function DeleteForwardingRuleRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteForwardingRuleRequest forwardingRule.
                         * @member {string} forwardingRule
                         * @memberof google.cloud.compute.v1.DeleteForwardingRuleRequest
                         * @instance
                         */
                        DeleteForwardingRuleRequest.prototype.forwardingRule = "";
    
                        /**
                         * DeleteForwardingRuleRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteForwardingRuleRequest
                         * @instance
                         */
                        DeleteForwardingRuleRequest.prototype.project = "";
    
                        /**
                         * DeleteForwardingRuleRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteForwardingRuleRequest
                         * @instance
                         */
                        DeleteForwardingRuleRequest.prototype.region = "";
    
                        /**
                         * DeleteForwardingRuleRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteForwardingRuleRequest
                         * @instance
                         */
                        DeleteForwardingRuleRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteForwardingRuleRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteForwardingRuleRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteForwardingRuleRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteForwardingRuleRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteForwardingRuleRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteForwardingRuleRequest} DeleteForwardingRuleRequest instance
                         */
                        DeleteForwardingRuleRequest.create = function create(properties) {
                            return new DeleteForwardingRuleRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteForwardingRuleRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteForwardingRuleRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteForwardingRuleRequest} message DeleteForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteForwardingRuleRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.forwardingRule != null && Object.hasOwnProperty.call(message, "forwardingRule"))
                                writer.uint32(/* id 269964030, wireType 2 =*/2159712242).string(message.forwardingRule);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteForwardingRuleRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteForwardingRuleRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteForwardingRuleRequest} message DeleteForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteForwardingRuleRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteForwardingRuleRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteForwardingRuleRequest} DeleteForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteForwardingRuleRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteForwardingRuleRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 269964030: {
                                        message.forwardingRule = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteForwardingRuleRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteForwardingRuleRequest} DeleteForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteForwardingRuleRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteForwardingRuleRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteForwardingRuleRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule"))
                                if (!$util.isString(message.forwardingRule))
                                    return "forwardingRule: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteForwardingRuleRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteForwardingRuleRequest} DeleteForwardingRuleRequest
                         */
                        DeleteForwardingRuleRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteForwardingRuleRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteForwardingRuleRequest();
                            if (object.forwardingRule != null)
                                message.forwardingRule = String(object.forwardingRule);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteForwardingRuleRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteForwardingRuleRequest} message DeleteForwardingRuleRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteForwardingRuleRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.forwardingRule = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule"))
                                object.forwardingRule = message.forwardingRule;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteForwardingRuleRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteForwardingRuleRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteForwardingRuleRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteForwardingRuleRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteForwardingRuleRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteForwardingRuleRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteForwardingRuleRequest";
                        };
    
                        return DeleteForwardingRuleRequest;
                    })();
    
                    v1.DeleteGlobalAddressRequest = (function() {
    
                        /**
                         * Properties of a DeleteGlobalAddressRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteGlobalAddressRequest
                         * @property {string|null} [address] DeleteGlobalAddressRequest address
                         * @property {string|null} [project] DeleteGlobalAddressRequest project
                         * @property {string|null} [requestId] DeleteGlobalAddressRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteGlobalAddressRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteGlobalAddressRequest.
                         * @implements IDeleteGlobalAddressRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteGlobalAddressRequest=} [properties] Properties to set
                         */
                        function DeleteGlobalAddressRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteGlobalAddressRequest address.
                         * @member {string} address
                         * @memberof google.cloud.compute.v1.DeleteGlobalAddressRequest
                         * @instance
                         */
                        DeleteGlobalAddressRequest.prototype.address = "";
    
                        /**
                         * DeleteGlobalAddressRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteGlobalAddressRequest
                         * @instance
                         */
                        DeleteGlobalAddressRequest.prototype.project = "";
    
                        /**
                         * DeleteGlobalAddressRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteGlobalAddressRequest
                         * @instance
                         */
                        DeleteGlobalAddressRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteGlobalAddressRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteGlobalAddressRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteGlobalAddressRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteGlobalAddressRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteGlobalAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalAddressRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteGlobalAddressRequest} DeleteGlobalAddressRequest instance
                         */
                        DeleteGlobalAddressRequest.create = function create(properties) {
                            return new DeleteGlobalAddressRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteGlobalAddressRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteGlobalAddressRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteGlobalAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalAddressRequest} message DeleteGlobalAddressRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteGlobalAddressRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.address != null && Object.hasOwnProperty.call(message, "address"))
                                writer.uint32(/* id 462920692, wireType 2 =*/3703365538).string(message.address);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteGlobalAddressRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteGlobalAddressRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteGlobalAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalAddressRequest} message DeleteGlobalAddressRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteGlobalAddressRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteGlobalAddressRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteGlobalAddressRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteGlobalAddressRequest} DeleteGlobalAddressRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteGlobalAddressRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteGlobalAddressRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 462920692: {
                                        message.address = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteGlobalAddressRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteGlobalAddressRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteGlobalAddressRequest} DeleteGlobalAddressRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteGlobalAddressRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteGlobalAddressRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteGlobalAddressRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteGlobalAddressRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.address != null && message.hasOwnProperty("address"))
                                if (!$util.isString(message.address))
                                    return "address: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteGlobalAddressRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteGlobalAddressRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteGlobalAddressRequest} DeleteGlobalAddressRequest
                         */
                        DeleteGlobalAddressRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteGlobalAddressRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteGlobalAddressRequest();
                            if (object.address != null)
                                message.address = String(object.address);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteGlobalAddressRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteGlobalAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteGlobalAddressRequest} message DeleteGlobalAddressRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteGlobalAddressRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.address = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.address != null && message.hasOwnProperty("address"))
                                object.address = message.address;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteGlobalAddressRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteGlobalAddressRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteGlobalAddressRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteGlobalAddressRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteGlobalAddressRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteGlobalAddressRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteGlobalAddressRequest";
                        };
    
                        return DeleteGlobalAddressRequest;
                    })();
    
                    v1.DeleteGlobalForwardingRuleRequest = (function() {
    
                        /**
                         * Properties of a DeleteGlobalForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteGlobalForwardingRuleRequest
                         * @property {string|null} [forwardingRule] DeleteGlobalForwardingRuleRequest forwardingRule
                         * @property {string|null} [project] DeleteGlobalForwardingRuleRequest project
                         * @property {string|null} [requestId] DeleteGlobalForwardingRuleRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteGlobalForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteGlobalForwardingRuleRequest.
                         * @implements IDeleteGlobalForwardingRuleRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteGlobalForwardingRuleRequest=} [properties] Properties to set
                         */
                        function DeleteGlobalForwardingRuleRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteGlobalForwardingRuleRequest forwardingRule.
                         * @member {string} forwardingRule
                         * @memberof google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest
                         * @instance
                         */
                        DeleteGlobalForwardingRuleRequest.prototype.forwardingRule = "";
    
                        /**
                         * DeleteGlobalForwardingRuleRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest
                         * @instance
                         */
                        DeleteGlobalForwardingRuleRequest.prototype.project = "";
    
                        /**
                         * DeleteGlobalForwardingRuleRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest
                         * @instance
                         */
                        DeleteGlobalForwardingRuleRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteGlobalForwardingRuleRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteGlobalForwardingRuleRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteGlobalForwardingRuleRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalForwardingRuleRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest} DeleteGlobalForwardingRuleRequest instance
                         */
                        DeleteGlobalForwardingRuleRequest.create = function create(properties) {
                            return new DeleteGlobalForwardingRuleRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteGlobalForwardingRuleRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalForwardingRuleRequest} message DeleteGlobalForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteGlobalForwardingRuleRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.forwardingRule != null && Object.hasOwnProperty.call(message, "forwardingRule"))
                                writer.uint32(/* id 269964030, wireType 2 =*/2159712242).string(message.forwardingRule);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteGlobalForwardingRuleRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalForwardingRuleRequest} message DeleteGlobalForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteGlobalForwardingRuleRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteGlobalForwardingRuleRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest} DeleteGlobalForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteGlobalForwardingRuleRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 269964030: {
                                        message.forwardingRule = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteGlobalForwardingRuleRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest} DeleteGlobalForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteGlobalForwardingRuleRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteGlobalForwardingRuleRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteGlobalForwardingRuleRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule"))
                                if (!$util.isString(message.forwardingRule))
                                    return "forwardingRule: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteGlobalForwardingRuleRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest} DeleteGlobalForwardingRuleRequest
                         */
                        DeleteGlobalForwardingRuleRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest();
                            if (object.forwardingRule != null)
                                message.forwardingRule = String(object.forwardingRule);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteGlobalForwardingRuleRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest} message DeleteGlobalForwardingRuleRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteGlobalForwardingRuleRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.forwardingRule = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule"))
                                object.forwardingRule = message.forwardingRule;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteGlobalForwardingRuleRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteGlobalForwardingRuleRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteGlobalForwardingRuleRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteGlobalForwardingRuleRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest";
                        };
    
                        return DeleteGlobalForwardingRuleRequest;
                    })();
    
                    v1.DeleteGlobalNetworkEndpointGroupRequest = (function() {
    
                        /**
                         * Properties of a DeleteGlobalNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteGlobalNetworkEndpointGroupRequest
                         * @property {string|null} [networkEndpointGroup] DeleteGlobalNetworkEndpointGroupRequest networkEndpointGroup
                         * @property {string|null} [project] DeleteGlobalNetworkEndpointGroupRequest project
                         * @property {string|null} [requestId] DeleteGlobalNetworkEndpointGroupRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteGlobalNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteGlobalNetworkEndpointGroupRequest.
                         * @implements IDeleteGlobalNetworkEndpointGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteGlobalNetworkEndpointGroupRequest=} [properties] Properties to set
                         */
                        function DeleteGlobalNetworkEndpointGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteGlobalNetworkEndpointGroupRequest networkEndpointGroup.
                         * @member {string} networkEndpointGroup
                         * @memberof google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest
                         * @instance
                         */
                        DeleteGlobalNetworkEndpointGroupRequest.prototype.networkEndpointGroup = "";
    
                        /**
                         * DeleteGlobalNetworkEndpointGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest
                         * @instance
                         */
                        DeleteGlobalNetworkEndpointGroupRequest.prototype.project = "";
    
                        /**
                         * DeleteGlobalNetworkEndpointGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest
                         * @instance
                         */
                        DeleteGlobalNetworkEndpointGroupRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteGlobalNetworkEndpointGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteGlobalNetworkEndpointGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteGlobalNetworkEndpointGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalNetworkEndpointGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest} DeleteGlobalNetworkEndpointGroupRequest instance
                         */
                        DeleteGlobalNetworkEndpointGroupRequest.create = function create(properties) {
                            return new DeleteGlobalNetworkEndpointGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteGlobalNetworkEndpointGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalNetworkEndpointGroupRequest} message DeleteGlobalNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteGlobalNetworkEndpointGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.networkEndpointGroup != null && Object.hasOwnProperty.call(message, "networkEndpointGroup"))
                                writer.uint32(/* id 433907078, wireType 2 =*/3471256626).string(message.networkEndpointGroup);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteGlobalNetworkEndpointGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalNetworkEndpointGroupRequest} message DeleteGlobalNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteGlobalNetworkEndpointGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteGlobalNetworkEndpointGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest} DeleteGlobalNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteGlobalNetworkEndpointGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 433907078: {
                                        message.networkEndpointGroup = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteGlobalNetworkEndpointGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest} DeleteGlobalNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteGlobalNetworkEndpointGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteGlobalNetworkEndpointGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteGlobalNetworkEndpointGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                if (!$util.isString(message.networkEndpointGroup))
                                    return "networkEndpointGroup: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteGlobalNetworkEndpointGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest} DeleteGlobalNetworkEndpointGroupRequest
                         */
                        DeleteGlobalNetworkEndpointGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest();
                            if (object.networkEndpointGroup != null)
                                message.networkEndpointGroup = String(object.networkEndpointGroup);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteGlobalNetworkEndpointGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest} message DeleteGlobalNetworkEndpointGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteGlobalNetworkEndpointGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.networkEndpointGroup = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                object.networkEndpointGroup = message.networkEndpointGroup;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteGlobalNetworkEndpointGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteGlobalNetworkEndpointGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteGlobalNetworkEndpointGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteGlobalNetworkEndpointGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest";
                        };
    
                        return DeleteGlobalNetworkEndpointGroupRequest;
                    })();
    
                    v1.DeleteGlobalOperationRequest = (function() {
    
                        /**
                         * Properties of a DeleteGlobalOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteGlobalOperationRequest
                         * @property {string|null} [operation] DeleteGlobalOperationRequest operation
                         * @property {string|null} [project] DeleteGlobalOperationRequest project
                         */
    
                        /**
                         * Constructs a new DeleteGlobalOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteGlobalOperationRequest.
                         * @implements IDeleteGlobalOperationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteGlobalOperationRequest=} [properties] Properties to set
                         */
                        function DeleteGlobalOperationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteGlobalOperationRequest operation.
                         * @member {string} operation
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationRequest
                         * @instance
                         */
                        DeleteGlobalOperationRequest.prototype.operation = "";
    
                        /**
                         * DeleteGlobalOperationRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationRequest
                         * @instance
                         */
                        DeleteGlobalOperationRequest.prototype.project = "";
    
                        /**
                         * Creates a new DeleteGlobalOperationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalOperationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteGlobalOperationRequest} DeleteGlobalOperationRequest instance
                         */
                        DeleteGlobalOperationRequest.create = function create(properties) {
                            return new DeleteGlobalOperationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteGlobalOperationRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteGlobalOperationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalOperationRequest} message DeleteGlobalOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteGlobalOperationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operation != null && Object.hasOwnProperty.call(message, "operation"))
                                writer.uint32(/* id 52090215, wireType 2 =*/416721722).string(message.operation);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteGlobalOperationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteGlobalOperationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalOperationRequest} message DeleteGlobalOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteGlobalOperationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteGlobalOperationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteGlobalOperationRequest} DeleteGlobalOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteGlobalOperationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteGlobalOperationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 52090215: {
                                        message.operation = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteGlobalOperationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteGlobalOperationRequest} DeleteGlobalOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteGlobalOperationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteGlobalOperationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteGlobalOperationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                if (!$util.isString(message.operation))
                                    return "operation: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteGlobalOperationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteGlobalOperationRequest} DeleteGlobalOperationRequest
                         */
                        DeleteGlobalOperationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteGlobalOperationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteGlobalOperationRequest();
                            if (object.operation != null)
                                message.operation = String(object.operation);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteGlobalOperationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteGlobalOperationRequest} message DeleteGlobalOperationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteGlobalOperationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.operation = "";
                                object.project = "";
                            }
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                object.operation = message.operation;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteGlobalOperationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteGlobalOperationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteGlobalOperationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteGlobalOperationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteGlobalOperationRequest";
                        };
    
                        return DeleteGlobalOperationRequest;
                    })();
    
                    v1.DeleteGlobalOperationResponse = (function() {
    
                        /**
                         * Properties of a DeleteGlobalOperationResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteGlobalOperationResponse
                         */
    
                        /**
                         * Constructs a new DeleteGlobalOperationResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteGlobalOperationResponse.
                         * @implements IDeleteGlobalOperationResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteGlobalOperationResponse=} [properties] Properties to set
                         */
                        function DeleteGlobalOperationResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Creates a new DeleteGlobalOperationResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationResponse
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalOperationResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteGlobalOperationResponse} DeleteGlobalOperationResponse instance
                         */
                        DeleteGlobalOperationResponse.create = function create(properties) {
                            return new DeleteGlobalOperationResponse(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteGlobalOperationResponse message. Does not implicitly {@link google.cloud.compute.v1.DeleteGlobalOperationResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationResponse
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalOperationResponse} message DeleteGlobalOperationResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteGlobalOperationResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteGlobalOperationResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteGlobalOperationResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationResponse
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalOperationResponse} message DeleteGlobalOperationResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteGlobalOperationResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteGlobalOperationResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteGlobalOperationResponse} DeleteGlobalOperationResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteGlobalOperationResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteGlobalOperationResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteGlobalOperationResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteGlobalOperationResponse} DeleteGlobalOperationResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteGlobalOperationResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteGlobalOperationResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteGlobalOperationResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteGlobalOperationResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteGlobalOperationResponse} DeleteGlobalOperationResponse
                         */
                        DeleteGlobalOperationResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteGlobalOperationResponse)
                                return object;
                            return new $root.google.cloud.compute.v1.DeleteGlobalOperationResponse();
                        };
    
                        /**
                         * Creates a plain object from a DeleteGlobalOperationResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationResponse
                         * @static
                         * @param {google.cloud.compute.v1.DeleteGlobalOperationResponse} message DeleteGlobalOperationResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteGlobalOperationResponse.toObject = function toObject() {
                            return {};
                        };
    
                        /**
                         * Converts this DeleteGlobalOperationResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteGlobalOperationResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteGlobalOperationResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteGlobalOperationResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteGlobalOperationResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteGlobalOperationResponse";
                        };
    
                        return DeleteGlobalOperationResponse;
                    })();
    
                    v1.DeleteGlobalOrganizationOperationRequest = (function() {
    
                        /**
                         * Properties of a DeleteGlobalOrganizationOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteGlobalOrganizationOperationRequest
                         * @property {string|null} [operation] DeleteGlobalOrganizationOperationRequest operation
                         * @property {string|null} [parentId] DeleteGlobalOrganizationOperationRequest parentId
                         */
    
                        /**
                         * Constructs a new DeleteGlobalOrganizationOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteGlobalOrganizationOperationRequest.
                         * @implements IDeleteGlobalOrganizationOperationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteGlobalOrganizationOperationRequest=} [properties] Properties to set
                         */
                        function DeleteGlobalOrganizationOperationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteGlobalOrganizationOperationRequest operation.
                         * @member {string} operation
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest
                         * @instance
                         */
                        DeleteGlobalOrganizationOperationRequest.prototype.operation = "";
    
                        /**
                         * DeleteGlobalOrganizationOperationRequest parentId.
                         * @member {string|null|undefined} parentId
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest
                         * @instance
                         */
                        DeleteGlobalOrganizationOperationRequest.prototype.parentId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteGlobalOrganizationOperationRequest _parentId.
                         * @member {"parentId"|undefined} _parentId
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteGlobalOrganizationOperationRequest.prototype, "_parentId", {
                            get: $util.oneOfGetter($oneOfFields = ["parentId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteGlobalOrganizationOperationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalOrganizationOperationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest} DeleteGlobalOrganizationOperationRequest instance
                         */
                        DeleteGlobalOrganizationOperationRequest.create = function create(properties) {
                            return new DeleteGlobalOrganizationOperationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteGlobalOrganizationOperationRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalOrganizationOperationRequest} message DeleteGlobalOrganizationOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteGlobalOrganizationOperationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operation != null && Object.hasOwnProperty.call(message, "operation"))
                                writer.uint32(/* id 52090215, wireType 2 =*/416721722).string(message.operation);
                            if (message.parentId != null && Object.hasOwnProperty.call(message, "parentId"))
                                writer.uint32(/* id 459714768, wireType 2 =*/3677718146).string(message.parentId);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteGlobalOrganizationOperationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalOrganizationOperationRequest} message DeleteGlobalOrganizationOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteGlobalOrganizationOperationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteGlobalOrganizationOperationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest} DeleteGlobalOrganizationOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteGlobalOrganizationOperationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 52090215: {
                                        message.operation = reader.string();
                                        break;
                                    }
                                case 459714768: {
                                        message.parentId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteGlobalOrganizationOperationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest} DeleteGlobalOrganizationOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteGlobalOrganizationOperationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteGlobalOrganizationOperationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteGlobalOrganizationOperationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                if (!$util.isString(message.operation))
                                    return "operation: string expected";
                            if (message.parentId != null && message.hasOwnProperty("parentId")) {
                                properties._parentId = 1;
                                if (!$util.isString(message.parentId))
                                    return "parentId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteGlobalOrganizationOperationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest} DeleteGlobalOrganizationOperationRequest
                         */
                        DeleteGlobalOrganizationOperationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest();
                            if (object.operation != null)
                                message.operation = String(object.operation);
                            if (object.parentId != null)
                                message.parentId = String(object.parentId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteGlobalOrganizationOperationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest} message DeleteGlobalOrganizationOperationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteGlobalOrganizationOperationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.operation = "";
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                object.operation = message.operation;
                            if (message.parentId != null && message.hasOwnProperty("parentId")) {
                                object.parentId = message.parentId;
                                if (options.oneofs)
                                    object._parentId = "parentId";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this DeleteGlobalOrganizationOperationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteGlobalOrganizationOperationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteGlobalOrganizationOperationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteGlobalOrganizationOperationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest";
                        };
    
                        return DeleteGlobalOrganizationOperationRequest;
                    })();
    
                    v1.DeleteGlobalOrganizationOperationResponse = (function() {
    
                        /**
                         * Properties of a DeleteGlobalOrganizationOperationResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteGlobalOrganizationOperationResponse
                         */
    
                        /**
                         * Constructs a new DeleteGlobalOrganizationOperationResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteGlobalOrganizationOperationResponse.
                         * @implements IDeleteGlobalOrganizationOperationResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteGlobalOrganizationOperationResponse=} [properties] Properties to set
                         */
                        function DeleteGlobalOrganizationOperationResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Creates a new DeleteGlobalOrganizationOperationResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalOrganizationOperationResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse} DeleteGlobalOrganizationOperationResponse instance
                         */
                        DeleteGlobalOrganizationOperationResponse.create = function create(properties) {
                            return new DeleteGlobalOrganizationOperationResponse(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteGlobalOrganizationOperationResponse message. Does not implicitly {@link google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalOrganizationOperationResponse} message DeleteGlobalOrganizationOperationResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteGlobalOrganizationOperationResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteGlobalOrganizationOperationResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalOrganizationOperationResponse} message DeleteGlobalOrganizationOperationResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteGlobalOrganizationOperationResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteGlobalOrganizationOperationResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse} DeleteGlobalOrganizationOperationResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteGlobalOrganizationOperationResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteGlobalOrganizationOperationResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse} DeleteGlobalOrganizationOperationResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteGlobalOrganizationOperationResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteGlobalOrganizationOperationResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteGlobalOrganizationOperationResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteGlobalOrganizationOperationResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse} DeleteGlobalOrganizationOperationResponse
                         */
                        DeleteGlobalOrganizationOperationResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse)
                                return object;
                            return new $root.google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse();
                        };
    
                        /**
                         * Creates a plain object from a DeleteGlobalOrganizationOperationResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse
                         * @static
                         * @param {google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse} message DeleteGlobalOrganizationOperationResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteGlobalOrganizationOperationResponse.toObject = function toObject() {
                            return {};
                        };
    
                        /**
                         * Converts this DeleteGlobalOrganizationOperationResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteGlobalOrganizationOperationResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteGlobalOrganizationOperationResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteGlobalOrganizationOperationResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse";
                        };
    
                        return DeleteGlobalOrganizationOperationResponse;
                    })();
    
                    v1.DeleteGlobalPublicDelegatedPrefixeRequest = (function() {
    
                        /**
                         * Properties of a DeleteGlobalPublicDelegatedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteGlobalPublicDelegatedPrefixeRequest
                         * @property {string|null} [project] DeleteGlobalPublicDelegatedPrefixeRequest project
                         * @property {string|null} [publicDelegatedPrefix] DeleteGlobalPublicDelegatedPrefixeRequest publicDelegatedPrefix
                         * @property {string|null} [requestId] DeleteGlobalPublicDelegatedPrefixeRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteGlobalPublicDelegatedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteGlobalPublicDelegatedPrefixeRequest.
                         * @implements IDeleteGlobalPublicDelegatedPrefixeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteGlobalPublicDelegatedPrefixeRequest=} [properties] Properties to set
                         */
                        function DeleteGlobalPublicDelegatedPrefixeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteGlobalPublicDelegatedPrefixeRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        DeleteGlobalPublicDelegatedPrefixeRequest.prototype.project = "";
    
                        /**
                         * DeleteGlobalPublicDelegatedPrefixeRequest publicDelegatedPrefix.
                         * @member {string} publicDelegatedPrefix
                         * @memberof google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        DeleteGlobalPublicDelegatedPrefixeRequest.prototype.publicDelegatedPrefix = "";
    
                        /**
                         * DeleteGlobalPublicDelegatedPrefixeRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        DeleteGlobalPublicDelegatedPrefixeRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteGlobalPublicDelegatedPrefixeRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteGlobalPublicDelegatedPrefixeRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteGlobalPublicDelegatedPrefixeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalPublicDelegatedPrefixeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest} DeleteGlobalPublicDelegatedPrefixeRequest instance
                         */
                        DeleteGlobalPublicDelegatedPrefixeRequest.create = function create(properties) {
                            return new DeleteGlobalPublicDelegatedPrefixeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteGlobalPublicDelegatedPrefixeRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalPublicDelegatedPrefixeRequest} message DeleteGlobalPublicDelegatedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteGlobalPublicDelegatedPrefixeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.publicDelegatedPrefix != null && Object.hasOwnProperty.call(message, "publicDelegatedPrefix"))
                                writer.uint32(/* id 204238440, wireType 2 =*/1633907522).string(message.publicDelegatedPrefix);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteGlobalPublicDelegatedPrefixeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteGlobalPublicDelegatedPrefixeRequest} message DeleteGlobalPublicDelegatedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteGlobalPublicDelegatedPrefixeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteGlobalPublicDelegatedPrefixeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest} DeleteGlobalPublicDelegatedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteGlobalPublicDelegatedPrefixeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 204238440: {
                                        message.publicDelegatedPrefix = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteGlobalPublicDelegatedPrefixeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest} DeleteGlobalPublicDelegatedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteGlobalPublicDelegatedPrefixeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteGlobalPublicDelegatedPrefixeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteGlobalPublicDelegatedPrefixeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.publicDelegatedPrefix != null && message.hasOwnProperty("publicDelegatedPrefix"))
                                if (!$util.isString(message.publicDelegatedPrefix))
                                    return "publicDelegatedPrefix: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteGlobalPublicDelegatedPrefixeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest} DeleteGlobalPublicDelegatedPrefixeRequest
                         */
                        DeleteGlobalPublicDelegatedPrefixeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.publicDelegatedPrefix != null)
                                message.publicDelegatedPrefix = String(object.publicDelegatedPrefix);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteGlobalPublicDelegatedPrefixeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest} message DeleteGlobalPublicDelegatedPrefixeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteGlobalPublicDelegatedPrefixeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.publicDelegatedPrefix = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.publicDelegatedPrefix != null && message.hasOwnProperty("publicDelegatedPrefix"))
                                object.publicDelegatedPrefix = message.publicDelegatedPrefix;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteGlobalPublicDelegatedPrefixeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteGlobalPublicDelegatedPrefixeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteGlobalPublicDelegatedPrefixeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteGlobalPublicDelegatedPrefixeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest";
                        };
    
                        return DeleteGlobalPublicDelegatedPrefixeRequest;
                    })();
    
                    v1.DeleteHealthCheckRequest = (function() {
    
                        /**
                         * Properties of a DeleteHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteHealthCheckRequest
                         * @property {string|null} [healthCheck] DeleteHealthCheckRequest healthCheck
                         * @property {string|null} [project] DeleteHealthCheckRequest project
                         * @property {string|null} [requestId] DeleteHealthCheckRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteHealthCheckRequest.
                         * @implements IDeleteHealthCheckRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteHealthCheckRequest=} [properties] Properties to set
                         */
                        function DeleteHealthCheckRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteHealthCheckRequest healthCheck.
                         * @member {string} healthCheck
                         * @memberof google.cloud.compute.v1.DeleteHealthCheckRequest
                         * @instance
                         */
                        DeleteHealthCheckRequest.prototype.healthCheck = "";
    
                        /**
                         * DeleteHealthCheckRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteHealthCheckRequest
                         * @instance
                         */
                        DeleteHealthCheckRequest.prototype.project = "";
    
                        /**
                         * DeleteHealthCheckRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteHealthCheckRequest
                         * @instance
                         */
                        DeleteHealthCheckRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteHealthCheckRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteHealthCheckRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteHealthCheckRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteHealthCheckRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteHealthCheckRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteHealthCheckRequest} DeleteHealthCheckRequest instance
                         */
                        DeleteHealthCheckRequest.create = function create(properties) {
                            return new DeleteHealthCheckRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteHealthCheckRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteHealthCheckRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteHealthCheckRequest} message DeleteHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteHealthCheckRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.healthCheck != null && Object.hasOwnProperty.call(message, "healthCheck"))
                                writer.uint32(/* id 308876645, wireType 2 =*/2471013162).string(message.healthCheck);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteHealthCheckRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteHealthCheckRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteHealthCheckRequest} message DeleteHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteHealthCheckRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteHealthCheckRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteHealthCheckRequest} DeleteHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteHealthCheckRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteHealthCheckRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 308876645: {
                                        message.healthCheck = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteHealthCheckRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteHealthCheckRequest} DeleteHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteHealthCheckRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteHealthCheckRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteHealthCheckRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck"))
                                if (!$util.isString(message.healthCheck))
                                    return "healthCheck: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteHealthCheckRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteHealthCheckRequest} DeleteHealthCheckRequest
                         */
                        DeleteHealthCheckRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteHealthCheckRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteHealthCheckRequest();
                            if (object.healthCheck != null)
                                message.healthCheck = String(object.healthCheck);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteHealthCheckRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteHealthCheckRequest} message DeleteHealthCheckRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteHealthCheckRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.healthCheck = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck"))
                                object.healthCheck = message.healthCheck;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteHealthCheckRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteHealthCheckRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteHealthCheckRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteHealthCheckRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteHealthCheckRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteHealthCheckRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteHealthCheckRequest";
                        };
    
                        return DeleteHealthCheckRequest;
                    })();
    
                    v1.DeleteImageRequest = (function() {
    
                        /**
                         * Properties of a DeleteImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteImageRequest
                         * @property {string|null} [image] DeleteImageRequest image
                         * @property {string|null} [project] DeleteImageRequest project
                         * @property {string|null} [requestId] DeleteImageRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteImageRequest.
                         * @implements IDeleteImageRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteImageRequest=} [properties] Properties to set
                         */
                        function DeleteImageRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteImageRequest image.
                         * @member {string} image
                         * @memberof google.cloud.compute.v1.DeleteImageRequest
                         * @instance
                         */
                        DeleteImageRequest.prototype.image = "";
    
                        /**
                         * DeleteImageRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteImageRequest
                         * @instance
                         */
                        DeleteImageRequest.prototype.project = "";
    
                        /**
                         * DeleteImageRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteImageRequest
                         * @instance
                         */
                        DeleteImageRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteImageRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteImageRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteImageRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteImageRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteImageRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteImageRequest} DeleteImageRequest instance
                         */
                        DeleteImageRequest.create = function create(properties) {
                            return new DeleteImageRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteImageRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteImageRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteImageRequest} message DeleteImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteImageRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.image != null && Object.hasOwnProperty.call(message, "image"))
                                writer.uint32(/* id 100313435, wireType 2 =*/802507482).string(message.image);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteImageRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteImageRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteImageRequest} message DeleteImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteImageRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteImageRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteImageRequest} DeleteImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteImageRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteImageRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 100313435: {
                                        message.image = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteImageRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteImageRequest} DeleteImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteImageRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteImageRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteImageRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteImageRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.image != null && message.hasOwnProperty("image"))
                                if (!$util.isString(message.image))
                                    return "image: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteImageRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteImageRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteImageRequest} DeleteImageRequest
                         */
                        DeleteImageRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteImageRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteImageRequest();
                            if (object.image != null)
                                message.image = String(object.image);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteImageRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteImageRequest} message DeleteImageRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteImageRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.image = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.image != null && message.hasOwnProperty("image"))
                                object.image = message.image;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteImageRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteImageRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteImageRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteImageRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteImageRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteImageRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteImageRequest";
                        };
    
                        return DeleteImageRequest;
                    })();
    
                    v1.DeleteInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a DeleteInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] DeleteInstanceGroupManagerRequest instanceGroupManager
                         * @property {string|null} [project] DeleteInstanceGroupManagerRequest project
                         * @property {string|null} [requestId] DeleteInstanceGroupManagerRequest requestId
                         * @property {string|null} [zone] DeleteInstanceGroupManagerRequest zone
                         */
    
                        /**
                         * Constructs a new DeleteInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteInstanceGroupManagerRequest.
                         * @implements IDeleteInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function DeleteInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupManagerRequest
                         * @instance
                         */
                        DeleteInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * DeleteInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupManagerRequest
                         * @instance
                         */
                        DeleteInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * DeleteInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupManagerRequest
                         * @instance
                         */
                        DeleteInstanceGroupManagerRequest.prototype.requestId = null;
    
                        /**
                         * DeleteInstanceGroupManagerRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupManagerRequest
                         * @instance
                         */
                        DeleteInstanceGroupManagerRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteInstanceGroupManagerRequest} DeleteInstanceGroupManagerRequest instance
                         */
                        DeleteInstanceGroupManagerRequest.create = function create(properties) {
                            return new DeleteInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInstanceGroupManagerRequest} message DeleteInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInstanceGroupManagerRequest} message DeleteInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteInstanceGroupManagerRequest} DeleteInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteInstanceGroupManagerRequest} DeleteInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteInstanceGroupManagerRequest} DeleteInstanceGroupManagerRequest
                         */
                        DeleteInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteInstanceGroupManagerRequest} message DeleteInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteInstanceGroupManagerRequest";
                        };
    
                        return DeleteInstanceGroupManagerRequest;
                    })();
    
                    v1.DeleteInstanceGroupRequest = (function() {
    
                        /**
                         * Properties of a DeleteInstanceGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteInstanceGroupRequest
                         * @property {string|null} [instanceGroup] DeleteInstanceGroupRequest instanceGroup
                         * @property {string|null} [project] DeleteInstanceGroupRequest project
                         * @property {string|null} [requestId] DeleteInstanceGroupRequest requestId
                         * @property {string|null} [zone] DeleteInstanceGroupRequest zone
                         */
    
                        /**
                         * Constructs a new DeleteInstanceGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteInstanceGroupRequest.
                         * @implements IDeleteInstanceGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteInstanceGroupRequest=} [properties] Properties to set
                         */
                        function DeleteInstanceGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteInstanceGroupRequest instanceGroup.
                         * @member {string} instanceGroup
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupRequest
                         * @instance
                         */
                        DeleteInstanceGroupRequest.prototype.instanceGroup = "";
    
                        /**
                         * DeleteInstanceGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupRequest
                         * @instance
                         */
                        DeleteInstanceGroupRequest.prototype.project = "";
    
                        /**
                         * DeleteInstanceGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupRequest
                         * @instance
                         */
                        DeleteInstanceGroupRequest.prototype.requestId = null;
    
                        /**
                         * DeleteInstanceGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupRequest
                         * @instance
                         */
                        DeleteInstanceGroupRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteInstanceGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteInstanceGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteInstanceGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInstanceGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteInstanceGroupRequest} DeleteInstanceGroupRequest instance
                         */
                        DeleteInstanceGroupRequest.create = function create(properties) {
                            return new DeleteInstanceGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteInstanceGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteInstanceGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInstanceGroupRequest} message DeleteInstanceGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteInstanceGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.instanceGroup != null && Object.hasOwnProperty.call(message, "instanceGroup"))
                                writer.uint32(/* id 81095253, wireType 2 =*/648762026).string(message.instanceGroup);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteInstanceGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteInstanceGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInstanceGroupRequest} message DeleteInstanceGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteInstanceGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteInstanceGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteInstanceGroupRequest} DeleteInstanceGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteInstanceGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteInstanceGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 81095253: {
                                        message.instanceGroup = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteInstanceGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteInstanceGroupRequest} DeleteInstanceGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteInstanceGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteInstanceGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteInstanceGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroup != null && message.hasOwnProperty("instanceGroup"))
                                if (!$util.isString(message.instanceGroup))
                                    return "instanceGroup: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteInstanceGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteInstanceGroupRequest} DeleteInstanceGroupRequest
                         */
                        DeleteInstanceGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteInstanceGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteInstanceGroupRequest();
                            if (object.instanceGroup != null)
                                message.instanceGroup = String(object.instanceGroup);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteInstanceGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteInstanceGroupRequest} message DeleteInstanceGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteInstanceGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instanceGroup = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.instanceGroup != null && message.hasOwnProperty("instanceGroup"))
                                object.instanceGroup = message.instanceGroup;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteInstanceGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteInstanceGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteInstanceGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteInstanceGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteInstanceGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteInstanceGroupRequest";
                        };
    
                        return DeleteInstanceGroupRequest;
                    })();
    
                    v1.DeleteInstanceRequest = (function() {
    
                        /**
                         * Properties of a DeleteInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteInstanceRequest
                         * @property {string|null} [instance] DeleteInstanceRequest instance
                         * @property {string|null} [project] DeleteInstanceRequest project
                         * @property {string|null} [requestId] DeleteInstanceRequest requestId
                         * @property {string|null} [zone] DeleteInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new DeleteInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteInstanceRequest.
                         * @implements IDeleteInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteInstanceRequest=} [properties] Properties to set
                         */
                        function DeleteInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.DeleteInstanceRequest
                         * @instance
                         */
                        DeleteInstanceRequest.prototype.instance = "";
    
                        /**
                         * DeleteInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteInstanceRequest
                         * @instance
                         */
                        DeleteInstanceRequest.prototype.project = "";
    
                        /**
                         * DeleteInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteInstanceRequest
                         * @instance
                         */
                        DeleteInstanceRequest.prototype.requestId = null;
    
                        /**
                         * DeleteInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.DeleteInstanceRequest
                         * @instance
                         */
                        DeleteInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteInstanceRequest} DeleteInstanceRequest instance
                         */
                        DeleteInstanceRequest.create = function create(properties) {
                            return new DeleteInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInstanceRequest} message DeleteInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInstanceRequest} message DeleteInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteInstanceRequest} DeleteInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteInstanceRequest} DeleteInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteInstanceRequest} DeleteInstanceRequest
                         */
                        DeleteInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteInstanceRequest} message DeleteInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteInstanceRequest";
                        };
    
                        return DeleteInstanceRequest;
                    })();
    
                    v1.DeleteInstanceTemplateRequest = (function() {
    
                        /**
                         * Properties of a DeleteInstanceTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteInstanceTemplateRequest
                         * @property {string|null} [instanceTemplate] DeleteInstanceTemplateRequest instanceTemplate
                         * @property {string|null} [project] DeleteInstanceTemplateRequest project
                         * @property {string|null} [requestId] DeleteInstanceTemplateRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteInstanceTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteInstanceTemplateRequest.
                         * @implements IDeleteInstanceTemplateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteInstanceTemplateRequest=} [properties] Properties to set
                         */
                        function DeleteInstanceTemplateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteInstanceTemplateRequest instanceTemplate.
                         * @member {string} instanceTemplate
                         * @memberof google.cloud.compute.v1.DeleteInstanceTemplateRequest
                         * @instance
                         */
                        DeleteInstanceTemplateRequest.prototype.instanceTemplate = "";
    
                        /**
                         * DeleteInstanceTemplateRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteInstanceTemplateRequest
                         * @instance
                         */
                        DeleteInstanceTemplateRequest.prototype.project = "";
    
                        /**
                         * DeleteInstanceTemplateRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteInstanceTemplateRequest
                         * @instance
                         */
                        DeleteInstanceTemplateRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteInstanceTemplateRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteInstanceTemplateRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteInstanceTemplateRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteInstanceTemplateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInstanceTemplateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteInstanceTemplateRequest} DeleteInstanceTemplateRequest instance
                         */
                        DeleteInstanceTemplateRequest.create = function create(properties) {
                            return new DeleteInstanceTemplateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteInstanceTemplateRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteInstanceTemplateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInstanceTemplateRequest} message DeleteInstanceTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteInstanceTemplateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceTemplate != null && Object.hasOwnProperty.call(message, "instanceTemplate"))
                                writer.uint32(/* id 309248228, wireType 2 =*/2473985826).string(message.instanceTemplate);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteInstanceTemplateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteInstanceTemplateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInstanceTemplateRequest} message DeleteInstanceTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteInstanceTemplateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteInstanceTemplateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteInstanceTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteInstanceTemplateRequest} DeleteInstanceTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteInstanceTemplateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteInstanceTemplateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 309248228: {
                                        message.instanceTemplate = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteInstanceTemplateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteInstanceTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteInstanceTemplateRequest} DeleteInstanceTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteInstanceTemplateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteInstanceTemplateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteInstanceTemplateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteInstanceTemplateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceTemplate != null && message.hasOwnProperty("instanceTemplate"))
                                if (!$util.isString(message.instanceTemplate))
                                    return "instanceTemplate: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteInstanceTemplateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteInstanceTemplateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteInstanceTemplateRequest} DeleteInstanceTemplateRequest
                         */
                        DeleteInstanceTemplateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteInstanceTemplateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteInstanceTemplateRequest();
                            if (object.instanceTemplate != null)
                                message.instanceTemplate = String(object.instanceTemplate);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteInstanceTemplateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteInstanceTemplateRequest} message DeleteInstanceTemplateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteInstanceTemplateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.instanceTemplate = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceTemplate != null && message.hasOwnProperty("instanceTemplate"))
                                object.instanceTemplate = message.instanceTemplate;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteInstanceTemplateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteInstanceTemplateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteInstanceTemplateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteInstanceTemplateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteInstanceTemplateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteInstanceTemplateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteInstanceTemplateRequest";
                        };
    
                        return DeleteInstanceTemplateRequest;
                    })();
    
                    v1.DeleteInstancesInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a DeleteInstancesInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteInstancesInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] DeleteInstancesInstanceGroupManagerRequest instanceGroupManager
                         * @property {google.cloud.compute.v1.IInstanceGroupManagersDeleteInstancesRequest|null} [instanceGroupManagersDeleteInstancesRequestResource] DeleteInstancesInstanceGroupManagerRequest instanceGroupManagersDeleteInstancesRequestResource
                         * @property {string|null} [project] DeleteInstancesInstanceGroupManagerRequest project
                         * @property {string|null} [requestId] DeleteInstancesInstanceGroupManagerRequest requestId
                         * @property {string|null} [zone] DeleteInstancesInstanceGroupManagerRequest zone
                         */
    
                        /**
                         * Constructs a new DeleteInstancesInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteInstancesInstanceGroupManagerRequest.
                         * @implements IDeleteInstancesInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteInstancesInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function DeleteInstancesInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteInstancesInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        DeleteInstancesInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * DeleteInstancesInstanceGroupManagerRequest instanceGroupManagersDeleteInstancesRequestResource.
                         * @member {google.cloud.compute.v1.IInstanceGroupManagersDeleteInstancesRequest|null|undefined} instanceGroupManagersDeleteInstancesRequestResource
                         * @memberof google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        DeleteInstancesInstanceGroupManagerRequest.prototype.instanceGroupManagersDeleteInstancesRequestResource = null;
    
                        /**
                         * DeleteInstancesInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        DeleteInstancesInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * DeleteInstancesInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        DeleteInstancesInstanceGroupManagerRequest.prototype.requestId = null;
    
                        /**
                         * DeleteInstancesInstanceGroupManagerRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        DeleteInstancesInstanceGroupManagerRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteInstancesInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteInstancesInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteInstancesInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInstancesInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest} DeleteInstancesInstanceGroupManagerRequest instance
                         */
                        DeleteInstancesInstanceGroupManagerRequest.create = function create(properties) {
                            return new DeleteInstancesInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteInstancesInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInstancesInstanceGroupManagerRequest} message DeleteInstancesInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteInstancesInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.instanceGroupManagersDeleteInstancesRequestResource != null && Object.hasOwnProperty.call(message, "instanceGroupManagersDeleteInstancesRequestResource"))
                                $root.google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest.encode(message.instanceGroupManagersDeleteInstancesRequestResource, writer.uint32(/* id 166421252, wireType 2 =*/1331370018).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteInstancesInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInstancesInstanceGroupManagerRequest} message DeleteInstancesInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteInstancesInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteInstancesInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest} DeleteInstancesInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteInstancesInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 166421252: {
                                        message.instanceGroupManagersDeleteInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteInstancesInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest} DeleteInstancesInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteInstancesInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteInstancesInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteInstancesInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.instanceGroupManagersDeleteInstancesRequestResource != null && message.hasOwnProperty("instanceGroupManagersDeleteInstancesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest.verify(message.instanceGroupManagersDeleteInstancesRequestResource);
                                if (error)
                                    return "instanceGroupManagersDeleteInstancesRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteInstancesInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest} DeleteInstancesInstanceGroupManagerRequest
                         */
                        DeleteInstancesInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.instanceGroupManagersDeleteInstancesRequestResource != null) {
                                if (typeof object.instanceGroupManagersDeleteInstancesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest.instanceGroupManagersDeleteInstancesRequestResource: object expected");
                                message.instanceGroupManagersDeleteInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest.fromObject(object.instanceGroupManagersDeleteInstancesRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteInstancesInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest} message DeleteInstancesInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteInstancesInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instanceGroupManagersDeleteInstancesRequestResource = null;
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.instanceGroupManagersDeleteInstancesRequestResource != null && message.hasOwnProperty("instanceGroupManagersDeleteInstancesRequestResource"))
                                object.instanceGroupManagersDeleteInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest.toObject(message.instanceGroupManagersDeleteInstancesRequestResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteInstancesInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteInstancesInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteInstancesInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteInstancesInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest";
                        };
    
                        return DeleteInstancesInstanceGroupManagerRequest;
                    })();
    
                    v1.DeleteInstancesRegionInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a DeleteInstancesRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteInstancesRegionInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] DeleteInstancesRegionInstanceGroupManagerRequest instanceGroupManager
                         * @property {string|null} [project] DeleteInstancesRegionInstanceGroupManagerRequest project
                         * @property {string|null} [region] DeleteInstancesRegionInstanceGroupManagerRequest region
                         * @property {google.cloud.compute.v1.IRegionInstanceGroupManagersDeleteInstancesRequest|null} [regionInstanceGroupManagersDeleteInstancesRequestResource] DeleteInstancesRegionInstanceGroupManagerRequest regionInstanceGroupManagersDeleteInstancesRequestResource
                         * @property {string|null} [requestId] DeleteInstancesRegionInstanceGroupManagerRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteInstancesRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteInstancesRegionInstanceGroupManagerRequest.
                         * @implements IDeleteInstancesRegionInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteInstancesRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function DeleteInstancesRegionInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteInstancesRegionInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        DeleteInstancesRegionInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * DeleteInstancesRegionInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        DeleteInstancesRegionInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * DeleteInstancesRegionInstanceGroupManagerRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        DeleteInstancesRegionInstanceGroupManagerRequest.prototype.region = "";
    
                        /**
                         * DeleteInstancesRegionInstanceGroupManagerRequest regionInstanceGroupManagersDeleteInstancesRequestResource.
                         * @member {google.cloud.compute.v1.IRegionInstanceGroupManagersDeleteInstancesRequest|null|undefined} regionInstanceGroupManagersDeleteInstancesRequestResource
                         * @memberof google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        DeleteInstancesRegionInstanceGroupManagerRequest.prototype.regionInstanceGroupManagersDeleteInstancesRequestResource = null;
    
                        /**
                         * DeleteInstancesRegionInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        DeleteInstancesRegionInstanceGroupManagerRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteInstancesRegionInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteInstancesRegionInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteInstancesRegionInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInstancesRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest} DeleteInstancesRegionInstanceGroupManagerRequest instance
                         */
                        DeleteInstancesRegionInstanceGroupManagerRequest.create = function create(properties) {
                            return new DeleteInstancesRegionInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteInstancesRegionInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInstancesRegionInstanceGroupManagerRequest} message DeleteInstancesRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteInstancesRegionInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            if (message.regionInstanceGroupManagersDeleteInstancesRequestResource != null && Object.hasOwnProperty.call(message, "regionInstanceGroupManagersDeleteInstancesRequestResource"))
                                $root.google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest.encode(message.regionInstanceGroupManagersDeleteInstancesRequestResource, writer.uint32(/* id 500876665, wireType 2 =*/4007013322).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteInstancesRegionInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInstancesRegionInstanceGroupManagerRequest} message DeleteInstancesRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteInstancesRegionInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteInstancesRegionInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest} DeleteInstancesRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteInstancesRegionInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 500876665: {
                                        message.regionInstanceGroupManagersDeleteInstancesRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteInstancesRegionInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest} DeleteInstancesRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteInstancesRegionInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteInstancesRegionInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteInstancesRegionInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionInstanceGroupManagersDeleteInstancesRequestResource != null && message.hasOwnProperty("regionInstanceGroupManagersDeleteInstancesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest.verify(message.regionInstanceGroupManagersDeleteInstancesRequestResource);
                                if (error)
                                    return "regionInstanceGroupManagersDeleteInstancesRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteInstancesRegionInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest} DeleteInstancesRegionInstanceGroupManagerRequest
                         */
                        DeleteInstancesRegionInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionInstanceGroupManagersDeleteInstancesRequestResource != null) {
                                if (typeof object.regionInstanceGroupManagersDeleteInstancesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest.regionInstanceGroupManagersDeleteInstancesRequestResource: object expected");
                                message.regionInstanceGroupManagersDeleteInstancesRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest.fromObject(object.regionInstanceGroupManagersDeleteInstancesRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteInstancesRegionInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest} message DeleteInstancesRegionInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteInstancesRegionInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                                object.regionInstanceGroupManagersDeleteInstancesRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            if (message.regionInstanceGroupManagersDeleteInstancesRequestResource != null && message.hasOwnProperty("regionInstanceGroupManagersDeleteInstancesRequestResource"))
                                object.regionInstanceGroupManagersDeleteInstancesRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest.toObject(message.regionInstanceGroupManagersDeleteInstancesRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this DeleteInstancesRegionInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteInstancesRegionInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteInstancesRegionInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteInstancesRegionInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest";
                        };
    
                        return DeleteInstancesRegionInstanceGroupManagerRequest;
                    })();
    
                    v1.DeleteInterconnectAttachmentRequest = (function() {
    
                        /**
                         * Properties of a DeleteInterconnectAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteInterconnectAttachmentRequest
                         * @property {string|null} [interconnectAttachment] DeleteInterconnectAttachmentRequest interconnectAttachment
                         * @property {string|null} [project] DeleteInterconnectAttachmentRequest project
                         * @property {string|null} [region] DeleteInterconnectAttachmentRequest region
                         * @property {string|null} [requestId] DeleteInterconnectAttachmentRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteInterconnectAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteInterconnectAttachmentRequest.
                         * @implements IDeleteInterconnectAttachmentRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteInterconnectAttachmentRequest=} [properties] Properties to set
                         */
                        function DeleteInterconnectAttachmentRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteInterconnectAttachmentRequest interconnectAttachment.
                         * @member {string} interconnectAttachment
                         * @memberof google.cloud.compute.v1.DeleteInterconnectAttachmentRequest
                         * @instance
                         */
                        DeleteInterconnectAttachmentRequest.prototype.interconnectAttachment = "";
    
                        /**
                         * DeleteInterconnectAttachmentRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteInterconnectAttachmentRequest
                         * @instance
                         */
                        DeleteInterconnectAttachmentRequest.prototype.project = "";
    
                        /**
                         * DeleteInterconnectAttachmentRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteInterconnectAttachmentRequest
                         * @instance
                         */
                        DeleteInterconnectAttachmentRequest.prototype.region = "";
    
                        /**
                         * DeleteInterconnectAttachmentRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteInterconnectAttachmentRequest
                         * @instance
                         */
                        DeleteInterconnectAttachmentRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteInterconnectAttachmentRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteInterconnectAttachmentRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteInterconnectAttachmentRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteInterconnectAttachmentRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteInterconnectAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInterconnectAttachmentRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteInterconnectAttachmentRequest} DeleteInterconnectAttachmentRequest instance
                         */
                        DeleteInterconnectAttachmentRequest.create = function create(properties) {
                            return new DeleteInterconnectAttachmentRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteInterconnectAttachmentRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteInterconnectAttachmentRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteInterconnectAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInterconnectAttachmentRequest} message DeleteInterconnectAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteInterconnectAttachmentRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.interconnectAttachment != null && Object.hasOwnProperty.call(message, "interconnectAttachment"))
                                writer.uint32(/* id 308135284, wireType 2 =*/2465082274).string(message.interconnectAttachment);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteInterconnectAttachmentRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteInterconnectAttachmentRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteInterconnectAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInterconnectAttachmentRequest} message DeleteInterconnectAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteInterconnectAttachmentRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteInterconnectAttachmentRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteInterconnectAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteInterconnectAttachmentRequest} DeleteInterconnectAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteInterconnectAttachmentRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteInterconnectAttachmentRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 308135284: {
                                        message.interconnectAttachment = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteInterconnectAttachmentRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteInterconnectAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteInterconnectAttachmentRequest} DeleteInterconnectAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteInterconnectAttachmentRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteInterconnectAttachmentRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteInterconnectAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteInterconnectAttachmentRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.interconnectAttachment != null && message.hasOwnProperty("interconnectAttachment"))
                                if (!$util.isString(message.interconnectAttachment))
                                    return "interconnectAttachment: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteInterconnectAttachmentRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteInterconnectAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteInterconnectAttachmentRequest} DeleteInterconnectAttachmentRequest
                         */
                        DeleteInterconnectAttachmentRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteInterconnectAttachmentRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteInterconnectAttachmentRequest();
                            if (object.interconnectAttachment != null)
                                message.interconnectAttachment = String(object.interconnectAttachment);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteInterconnectAttachmentRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteInterconnectAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteInterconnectAttachmentRequest} message DeleteInterconnectAttachmentRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteInterconnectAttachmentRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.interconnectAttachment = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.interconnectAttachment != null && message.hasOwnProperty("interconnectAttachment"))
                                object.interconnectAttachment = message.interconnectAttachment;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteInterconnectAttachmentRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteInterconnectAttachmentRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteInterconnectAttachmentRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteInterconnectAttachmentRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteInterconnectAttachmentRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteInterconnectAttachmentRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteInterconnectAttachmentRequest";
                        };
    
                        return DeleteInterconnectAttachmentRequest;
                    })();
    
                    v1.DeleteInterconnectRequest = (function() {
    
                        /**
                         * Properties of a DeleteInterconnectRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteInterconnectRequest
                         * @property {string|null} [interconnect] DeleteInterconnectRequest interconnect
                         * @property {string|null} [project] DeleteInterconnectRequest project
                         * @property {string|null} [requestId] DeleteInterconnectRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteInterconnectRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteInterconnectRequest.
                         * @implements IDeleteInterconnectRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteInterconnectRequest=} [properties] Properties to set
                         */
                        function DeleteInterconnectRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteInterconnectRequest interconnect.
                         * @member {string} interconnect
                         * @memberof google.cloud.compute.v1.DeleteInterconnectRequest
                         * @instance
                         */
                        DeleteInterconnectRequest.prototype.interconnect = "";
    
                        /**
                         * DeleteInterconnectRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteInterconnectRequest
                         * @instance
                         */
                        DeleteInterconnectRequest.prototype.project = "";
    
                        /**
                         * DeleteInterconnectRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteInterconnectRequest
                         * @instance
                         */
                        DeleteInterconnectRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteInterconnectRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteInterconnectRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteInterconnectRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteInterconnectRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInterconnectRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteInterconnectRequest} DeleteInterconnectRequest instance
                         */
                        DeleteInterconnectRequest.create = function create(properties) {
                            return new DeleteInterconnectRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteInterconnectRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteInterconnectRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInterconnectRequest} message DeleteInterconnectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteInterconnectRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.interconnect != null && Object.hasOwnProperty.call(message, "interconnect"))
                                writer.uint32(/* id 224601230, wireType 2 =*/1796809842).string(message.interconnect);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteInterconnectRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteInterconnectRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteInterconnectRequest} message DeleteInterconnectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteInterconnectRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteInterconnectRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteInterconnectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteInterconnectRequest} DeleteInterconnectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteInterconnectRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteInterconnectRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 224601230: {
                                        message.interconnect = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteInterconnectRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteInterconnectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteInterconnectRequest} DeleteInterconnectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteInterconnectRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteInterconnectRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteInterconnectRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteInterconnectRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.interconnect != null && message.hasOwnProperty("interconnect"))
                                if (!$util.isString(message.interconnect))
                                    return "interconnect: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteInterconnectRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteInterconnectRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteInterconnectRequest} DeleteInterconnectRequest
                         */
                        DeleteInterconnectRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteInterconnectRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteInterconnectRequest();
                            if (object.interconnect != null)
                                message.interconnect = String(object.interconnect);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteInterconnectRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteInterconnectRequest} message DeleteInterconnectRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteInterconnectRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.interconnect = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.interconnect != null && message.hasOwnProperty("interconnect"))
                                object.interconnect = message.interconnect;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteInterconnectRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteInterconnectRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteInterconnectRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteInterconnectRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteInterconnectRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteInterconnectRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteInterconnectRequest";
                        };
    
                        return DeleteInterconnectRequest;
                    })();
    
                    v1.DeleteLicenseRequest = (function() {
    
                        /**
                         * Properties of a DeleteLicenseRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteLicenseRequest
                         * @property {string|null} [license] DeleteLicenseRequest license
                         * @property {string|null} [project] DeleteLicenseRequest project
                         * @property {string|null} [requestId] DeleteLicenseRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteLicenseRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteLicenseRequest.
                         * @implements IDeleteLicenseRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteLicenseRequest=} [properties] Properties to set
                         */
                        function DeleteLicenseRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteLicenseRequest license.
                         * @member {string} license
                         * @memberof google.cloud.compute.v1.DeleteLicenseRequest
                         * @instance
                         */
                        DeleteLicenseRequest.prototype.license = "";
    
                        /**
                         * DeleteLicenseRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteLicenseRequest
                         * @instance
                         */
                        DeleteLicenseRequest.prototype.project = "";
    
                        /**
                         * DeleteLicenseRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteLicenseRequest
                         * @instance
                         */
                        DeleteLicenseRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteLicenseRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteLicenseRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteLicenseRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteLicenseRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteLicenseRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteLicenseRequest} DeleteLicenseRequest instance
                         */
                        DeleteLicenseRequest.create = function create(properties) {
                            return new DeleteLicenseRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteLicenseRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteLicenseRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteLicenseRequest} message DeleteLicenseRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteLicenseRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.license != null && Object.hasOwnProperty.call(message, "license"))
                                writer.uint32(/* id 166757441, wireType 2 =*/1334059530).string(message.license);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteLicenseRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteLicenseRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteLicenseRequest} message DeleteLicenseRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteLicenseRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteLicenseRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteLicenseRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteLicenseRequest} DeleteLicenseRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteLicenseRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteLicenseRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 166757441: {
                                        message.license = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteLicenseRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteLicenseRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteLicenseRequest} DeleteLicenseRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteLicenseRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteLicenseRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteLicenseRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteLicenseRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.license != null && message.hasOwnProperty("license"))
                                if (!$util.isString(message.license))
                                    return "license: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteLicenseRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteLicenseRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteLicenseRequest} DeleteLicenseRequest
                         */
                        DeleteLicenseRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteLicenseRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteLicenseRequest();
                            if (object.license != null)
                                message.license = String(object.license);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteLicenseRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteLicenseRequest} message DeleteLicenseRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteLicenseRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.license = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.license != null && message.hasOwnProperty("license"))
                                object.license = message.license;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteLicenseRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteLicenseRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteLicenseRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteLicenseRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteLicenseRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteLicenseRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteLicenseRequest";
                        };
    
                        return DeleteLicenseRequest;
                    })();
    
                    v1.DeleteMachineImageRequest = (function() {
    
                        /**
                         * Properties of a DeleteMachineImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteMachineImageRequest
                         * @property {string|null} [machineImage] DeleteMachineImageRequest machineImage
                         * @property {string|null} [project] DeleteMachineImageRequest project
                         * @property {string|null} [requestId] DeleteMachineImageRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteMachineImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteMachineImageRequest.
                         * @implements IDeleteMachineImageRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteMachineImageRequest=} [properties] Properties to set
                         */
                        function DeleteMachineImageRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteMachineImageRequest machineImage.
                         * @member {string} machineImage
                         * @memberof google.cloud.compute.v1.DeleteMachineImageRequest
                         * @instance
                         */
                        DeleteMachineImageRequest.prototype.machineImage = "";
    
                        /**
                         * DeleteMachineImageRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteMachineImageRequest
                         * @instance
                         */
                        DeleteMachineImageRequest.prototype.project = "";
    
                        /**
                         * DeleteMachineImageRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteMachineImageRequest
                         * @instance
                         */
                        DeleteMachineImageRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteMachineImageRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteMachineImageRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteMachineImageRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteMachineImageRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteMachineImageRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteMachineImageRequest} DeleteMachineImageRequest instance
                         */
                        DeleteMachineImageRequest.create = function create(properties) {
                            return new DeleteMachineImageRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteMachineImageRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteMachineImageRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteMachineImageRequest} message DeleteMachineImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteMachineImageRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.machineImage != null && Object.hasOwnProperty.call(message, "machineImage"))
                                writer.uint32(/* id 69189475, wireType 2 =*/553515802).string(message.machineImage);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteMachineImageRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteMachineImageRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteMachineImageRequest} message DeleteMachineImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteMachineImageRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteMachineImageRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteMachineImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteMachineImageRequest} DeleteMachineImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteMachineImageRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteMachineImageRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 69189475: {
                                        message.machineImage = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteMachineImageRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteMachineImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteMachineImageRequest} DeleteMachineImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteMachineImageRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteMachineImageRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteMachineImageRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteMachineImageRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.machineImage != null && message.hasOwnProperty("machineImage"))
                                if (!$util.isString(message.machineImage))
                                    return "machineImage: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteMachineImageRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteMachineImageRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteMachineImageRequest} DeleteMachineImageRequest
                         */
                        DeleteMachineImageRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteMachineImageRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteMachineImageRequest();
                            if (object.machineImage != null)
                                message.machineImage = String(object.machineImage);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteMachineImageRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteMachineImageRequest} message DeleteMachineImageRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteMachineImageRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.machineImage = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.machineImage != null && message.hasOwnProperty("machineImage"))
                                object.machineImage = message.machineImage;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteMachineImageRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteMachineImageRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteMachineImageRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteMachineImageRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteMachineImageRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteMachineImageRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteMachineImageRequest";
                        };
    
                        return DeleteMachineImageRequest;
                    })();
    
                    v1.DeleteNetworkEdgeSecurityServiceRequest = (function() {
    
                        /**
                         * Properties of a DeleteNetworkEdgeSecurityServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteNetworkEdgeSecurityServiceRequest
                         * @property {string|null} [networkEdgeSecurityService] DeleteNetworkEdgeSecurityServiceRequest networkEdgeSecurityService
                         * @property {string|null} [project] DeleteNetworkEdgeSecurityServiceRequest project
                         * @property {string|null} [region] DeleteNetworkEdgeSecurityServiceRequest region
                         * @property {string|null} [requestId] DeleteNetworkEdgeSecurityServiceRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteNetworkEdgeSecurityServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteNetworkEdgeSecurityServiceRequest.
                         * @implements IDeleteNetworkEdgeSecurityServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteNetworkEdgeSecurityServiceRequest=} [properties] Properties to set
                         */
                        function DeleteNetworkEdgeSecurityServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteNetworkEdgeSecurityServiceRequest networkEdgeSecurityService.
                         * @member {string} networkEdgeSecurityService
                         * @memberof google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        DeleteNetworkEdgeSecurityServiceRequest.prototype.networkEdgeSecurityService = "";
    
                        /**
                         * DeleteNetworkEdgeSecurityServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        DeleteNetworkEdgeSecurityServiceRequest.prototype.project = "";
    
                        /**
                         * DeleteNetworkEdgeSecurityServiceRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        DeleteNetworkEdgeSecurityServiceRequest.prototype.region = "";
    
                        /**
                         * DeleteNetworkEdgeSecurityServiceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        DeleteNetworkEdgeSecurityServiceRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteNetworkEdgeSecurityServiceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteNetworkEdgeSecurityServiceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteNetworkEdgeSecurityServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNetworkEdgeSecurityServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest} DeleteNetworkEdgeSecurityServiceRequest instance
                         */
                        DeleteNetworkEdgeSecurityServiceRequest.create = function create(properties) {
                            return new DeleteNetworkEdgeSecurityServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteNetworkEdgeSecurityServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNetworkEdgeSecurityServiceRequest} message DeleteNetworkEdgeSecurityServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteNetworkEdgeSecurityServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.networkEdgeSecurityService != null && Object.hasOwnProperty.call(message, "networkEdgeSecurityService"))
                                writer.uint32(/* id 157011879, wireType 2 =*/1256095034).string(message.networkEdgeSecurityService);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteNetworkEdgeSecurityServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNetworkEdgeSecurityServiceRequest} message DeleteNetworkEdgeSecurityServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteNetworkEdgeSecurityServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteNetworkEdgeSecurityServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest} DeleteNetworkEdgeSecurityServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteNetworkEdgeSecurityServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 157011879: {
                                        message.networkEdgeSecurityService = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteNetworkEdgeSecurityServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest} DeleteNetworkEdgeSecurityServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteNetworkEdgeSecurityServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteNetworkEdgeSecurityServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteNetworkEdgeSecurityServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.networkEdgeSecurityService != null && message.hasOwnProperty("networkEdgeSecurityService"))
                                if (!$util.isString(message.networkEdgeSecurityService))
                                    return "networkEdgeSecurityService: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteNetworkEdgeSecurityServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest} DeleteNetworkEdgeSecurityServiceRequest
                         */
                        DeleteNetworkEdgeSecurityServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest();
                            if (object.networkEdgeSecurityService != null)
                                message.networkEdgeSecurityService = String(object.networkEdgeSecurityService);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteNetworkEdgeSecurityServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest} message DeleteNetworkEdgeSecurityServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteNetworkEdgeSecurityServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.networkEdgeSecurityService = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.networkEdgeSecurityService != null && message.hasOwnProperty("networkEdgeSecurityService"))
                                object.networkEdgeSecurityService = message.networkEdgeSecurityService;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteNetworkEdgeSecurityServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteNetworkEdgeSecurityServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteNetworkEdgeSecurityServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteNetworkEdgeSecurityServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest";
                        };
    
                        return DeleteNetworkEdgeSecurityServiceRequest;
                    })();
    
                    v1.DeleteNetworkEndpointGroupRequest = (function() {
    
                        /**
                         * Properties of a DeleteNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteNetworkEndpointGroupRequest
                         * @property {string|null} [networkEndpointGroup] DeleteNetworkEndpointGroupRequest networkEndpointGroup
                         * @property {string|null} [project] DeleteNetworkEndpointGroupRequest project
                         * @property {string|null} [requestId] DeleteNetworkEndpointGroupRequest requestId
                         * @property {string|null} [zone] DeleteNetworkEndpointGroupRequest zone
                         */
    
                        /**
                         * Constructs a new DeleteNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteNetworkEndpointGroupRequest.
                         * @implements IDeleteNetworkEndpointGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteNetworkEndpointGroupRequest=} [properties] Properties to set
                         */
                        function DeleteNetworkEndpointGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteNetworkEndpointGroupRequest networkEndpointGroup.
                         * @member {string} networkEndpointGroup
                         * @memberof google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest
                         * @instance
                         */
                        DeleteNetworkEndpointGroupRequest.prototype.networkEndpointGroup = "";
    
                        /**
                         * DeleteNetworkEndpointGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest
                         * @instance
                         */
                        DeleteNetworkEndpointGroupRequest.prototype.project = "";
    
                        /**
                         * DeleteNetworkEndpointGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest
                         * @instance
                         */
                        DeleteNetworkEndpointGroupRequest.prototype.requestId = null;
    
                        /**
                         * DeleteNetworkEndpointGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest
                         * @instance
                         */
                        DeleteNetworkEndpointGroupRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteNetworkEndpointGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteNetworkEndpointGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteNetworkEndpointGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNetworkEndpointGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest} DeleteNetworkEndpointGroupRequest instance
                         */
                        DeleteNetworkEndpointGroupRequest.create = function create(properties) {
                            return new DeleteNetworkEndpointGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteNetworkEndpointGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNetworkEndpointGroupRequest} message DeleteNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteNetworkEndpointGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.networkEndpointGroup != null && Object.hasOwnProperty.call(message, "networkEndpointGroup"))
                                writer.uint32(/* id 433907078, wireType 2 =*/3471256626).string(message.networkEndpointGroup);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteNetworkEndpointGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNetworkEndpointGroupRequest} message DeleteNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteNetworkEndpointGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteNetworkEndpointGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest} DeleteNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteNetworkEndpointGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 433907078: {
                                        message.networkEndpointGroup = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteNetworkEndpointGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest} DeleteNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteNetworkEndpointGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteNetworkEndpointGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteNetworkEndpointGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                if (!$util.isString(message.networkEndpointGroup))
                                    return "networkEndpointGroup: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteNetworkEndpointGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest} DeleteNetworkEndpointGroupRequest
                         */
                        DeleteNetworkEndpointGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest();
                            if (object.networkEndpointGroup != null)
                                message.networkEndpointGroup = String(object.networkEndpointGroup);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteNetworkEndpointGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest} message DeleteNetworkEndpointGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteNetworkEndpointGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.networkEndpointGroup = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                object.networkEndpointGroup = message.networkEndpointGroup;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteNetworkEndpointGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteNetworkEndpointGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteNetworkEndpointGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteNetworkEndpointGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest";
                        };
    
                        return DeleteNetworkEndpointGroupRequest;
                    })();
    
                    v1.DeleteNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a DeleteNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] DeleteNetworkFirewallPolicyRequest firewallPolicy
                         * @property {string|null} [project] DeleteNetworkFirewallPolicyRequest project
                         * @property {string|null} [requestId] DeleteNetworkFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteNetworkFirewallPolicyRequest.
                         * @implements IDeleteNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function DeleteNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest
                         * @instance
                         */
                        DeleteNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * DeleteNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest
                         * @instance
                         */
                        DeleteNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * DeleteNetworkFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest
                         * @instance
                         */
                        DeleteNetworkFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteNetworkFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteNetworkFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest} DeleteNetworkFirewallPolicyRequest instance
                         */
                        DeleteNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new DeleteNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNetworkFirewallPolicyRequest} message DeleteNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNetworkFirewallPolicyRequest} message DeleteNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest} DeleteNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest} DeleteNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest} DeleteNetworkFirewallPolicyRequest
                         */
                        DeleteNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest} message DeleteNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.firewallPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest";
                        };
    
                        return DeleteNetworkFirewallPolicyRequest;
                    })();
    
                    v1.DeleteNetworkRequest = (function() {
    
                        /**
                         * Properties of a DeleteNetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteNetworkRequest
                         * @property {string|null} [network] DeleteNetworkRequest network
                         * @property {string|null} [project] DeleteNetworkRequest project
                         * @property {string|null} [requestId] DeleteNetworkRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteNetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteNetworkRequest.
                         * @implements IDeleteNetworkRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteNetworkRequest=} [properties] Properties to set
                         */
                        function DeleteNetworkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteNetworkRequest network.
                         * @member {string} network
                         * @memberof google.cloud.compute.v1.DeleteNetworkRequest
                         * @instance
                         */
                        DeleteNetworkRequest.prototype.network = "";
    
                        /**
                         * DeleteNetworkRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteNetworkRequest
                         * @instance
                         */
                        DeleteNetworkRequest.prototype.project = "";
    
                        /**
                         * DeleteNetworkRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteNetworkRequest
                         * @instance
                         */
                        DeleteNetworkRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteNetworkRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteNetworkRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteNetworkRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteNetworkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNetworkRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteNetworkRequest} DeleteNetworkRequest instance
                         */
                        DeleteNetworkRequest.create = function create(properties) {
                            return new DeleteNetworkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteNetworkRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteNetworkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNetworkRequest} message DeleteNetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteNetworkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteNetworkRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteNetworkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNetworkRequest} message DeleteNetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteNetworkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteNetworkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteNetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteNetworkRequest} DeleteNetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteNetworkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteNetworkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteNetworkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteNetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteNetworkRequest} DeleteNetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteNetworkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteNetworkRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteNetworkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteNetworkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.network != null && message.hasOwnProperty("network"))
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteNetworkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteNetworkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteNetworkRequest} DeleteNetworkRequest
                         */
                        DeleteNetworkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteNetworkRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteNetworkRequest();
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteNetworkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteNetworkRequest} message DeleteNetworkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteNetworkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.network = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.network != null && message.hasOwnProperty("network"))
                                object.network = message.network;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteNetworkRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteNetworkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteNetworkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteNetworkRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteNetworkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteNetworkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteNetworkRequest";
                        };
    
                        return DeleteNetworkRequest;
                    })();
    
                    v1.DeleteNodeGroupRequest = (function() {
    
                        /**
                         * Properties of a DeleteNodeGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteNodeGroupRequest
                         * @property {string|null} [nodeGroup] DeleteNodeGroupRequest nodeGroup
                         * @property {string|null} [project] DeleteNodeGroupRequest project
                         * @property {string|null} [requestId] DeleteNodeGroupRequest requestId
                         * @property {string|null} [zone] DeleteNodeGroupRequest zone
                         */
    
                        /**
                         * Constructs a new DeleteNodeGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteNodeGroupRequest.
                         * @implements IDeleteNodeGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteNodeGroupRequest=} [properties] Properties to set
                         */
                        function DeleteNodeGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteNodeGroupRequest nodeGroup.
                         * @member {string} nodeGroup
                         * @memberof google.cloud.compute.v1.DeleteNodeGroupRequest
                         * @instance
                         */
                        DeleteNodeGroupRequest.prototype.nodeGroup = "";
    
                        /**
                         * DeleteNodeGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteNodeGroupRequest
                         * @instance
                         */
                        DeleteNodeGroupRequest.prototype.project = "";
    
                        /**
                         * DeleteNodeGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteNodeGroupRequest
                         * @instance
                         */
                        DeleteNodeGroupRequest.prototype.requestId = null;
    
                        /**
                         * DeleteNodeGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.DeleteNodeGroupRequest
                         * @instance
                         */
                        DeleteNodeGroupRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteNodeGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteNodeGroupRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteNodeGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteNodeGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNodeGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteNodeGroupRequest} DeleteNodeGroupRequest instance
                         */
                        DeleteNodeGroupRequest.create = function create(properties) {
                            return new DeleteNodeGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteNodeGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteNodeGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNodeGroupRequest} message DeleteNodeGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteNodeGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.nodeGroup != null && Object.hasOwnProperty.call(message, "nodeGroup"))
                                writer.uint32(/* id 469958146, wireType 2 =*/3759665170).string(message.nodeGroup);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteNodeGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteNodeGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNodeGroupRequest} message DeleteNodeGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteNodeGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteNodeGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteNodeGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteNodeGroupRequest} DeleteNodeGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteNodeGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteNodeGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 469958146: {
                                        message.nodeGroup = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteNodeGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteNodeGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteNodeGroupRequest} DeleteNodeGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteNodeGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteNodeGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteNodeGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteNodeGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.nodeGroup != null && message.hasOwnProperty("nodeGroup"))
                                if (!$util.isString(message.nodeGroup))
                                    return "nodeGroup: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteNodeGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteNodeGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteNodeGroupRequest} DeleteNodeGroupRequest
                         */
                        DeleteNodeGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteNodeGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteNodeGroupRequest();
                            if (object.nodeGroup != null)
                                message.nodeGroup = String(object.nodeGroup);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteNodeGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteNodeGroupRequest} message DeleteNodeGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteNodeGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.nodeGroup = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.nodeGroup != null && message.hasOwnProperty("nodeGroup"))
                                object.nodeGroup = message.nodeGroup;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteNodeGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteNodeGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteNodeGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteNodeGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteNodeGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteNodeGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteNodeGroupRequest";
                        };
    
                        return DeleteNodeGroupRequest;
                    })();
    
                    v1.DeleteNodeTemplateRequest = (function() {
    
                        /**
                         * Properties of a DeleteNodeTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteNodeTemplateRequest
                         * @property {string|null} [nodeTemplate] DeleteNodeTemplateRequest nodeTemplate
                         * @property {string|null} [project] DeleteNodeTemplateRequest project
                         * @property {string|null} [region] DeleteNodeTemplateRequest region
                         * @property {string|null} [requestId] DeleteNodeTemplateRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteNodeTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteNodeTemplateRequest.
                         * @implements IDeleteNodeTemplateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteNodeTemplateRequest=} [properties] Properties to set
                         */
                        function DeleteNodeTemplateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteNodeTemplateRequest nodeTemplate.
                         * @member {string} nodeTemplate
                         * @memberof google.cloud.compute.v1.DeleteNodeTemplateRequest
                         * @instance
                         */
                        DeleteNodeTemplateRequest.prototype.nodeTemplate = "";
    
                        /**
                         * DeleteNodeTemplateRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteNodeTemplateRequest
                         * @instance
                         */
                        DeleteNodeTemplateRequest.prototype.project = "";
    
                        /**
                         * DeleteNodeTemplateRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteNodeTemplateRequest
                         * @instance
                         */
                        DeleteNodeTemplateRequest.prototype.region = "";
    
                        /**
                         * DeleteNodeTemplateRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteNodeTemplateRequest
                         * @instance
                         */
                        DeleteNodeTemplateRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteNodeTemplateRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteNodeTemplateRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteNodeTemplateRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteNodeTemplateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNodeTemplateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteNodeTemplateRequest} DeleteNodeTemplateRequest instance
                         */
                        DeleteNodeTemplateRequest.create = function create(properties) {
                            return new DeleteNodeTemplateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteNodeTemplateRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteNodeTemplateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNodeTemplateRequest} message DeleteNodeTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteNodeTemplateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.nodeTemplate != null && Object.hasOwnProperty.call(message, "nodeTemplate"))
                                writer.uint32(/* id 323154455, wireType 2 =*/2585235642).string(message.nodeTemplate);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteNodeTemplateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteNodeTemplateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNodeTemplateRequest} message DeleteNodeTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteNodeTemplateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteNodeTemplateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteNodeTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteNodeTemplateRequest} DeleteNodeTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteNodeTemplateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteNodeTemplateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 323154455: {
                                        message.nodeTemplate = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteNodeTemplateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteNodeTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteNodeTemplateRequest} DeleteNodeTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteNodeTemplateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteNodeTemplateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteNodeTemplateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteNodeTemplateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.nodeTemplate != null && message.hasOwnProperty("nodeTemplate"))
                                if (!$util.isString(message.nodeTemplate))
                                    return "nodeTemplate: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteNodeTemplateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteNodeTemplateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteNodeTemplateRequest} DeleteNodeTemplateRequest
                         */
                        DeleteNodeTemplateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteNodeTemplateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteNodeTemplateRequest();
                            if (object.nodeTemplate != null)
                                message.nodeTemplate = String(object.nodeTemplate);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteNodeTemplateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteNodeTemplateRequest} message DeleteNodeTemplateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteNodeTemplateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.nodeTemplate = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.nodeTemplate != null && message.hasOwnProperty("nodeTemplate"))
                                object.nodeTemplate = message.nodeTemplate;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteNodeTemplateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteNodeTemplateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteNodeTemplateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteNodeTemplateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteNodeTemplateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteNodeTemplateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteNodeTemplateRequest";
                        };
    
                        return DeleteNodeTemplateRequest;
                    })();
    
                    v1.DeleteNodesNodeGroupRequest = (function() {
    
                        /**
                         * Properties of a DeleteNodesNodeGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteNodesNodeGroupRequest
                         * @property {string|null} [nodeGroup] DeleteNodesNodeGroupRequest nodeGroup
                         * @property {google.cloud.compute.v1.INodeGroupsDeleteNodesRequest|null} [nodeGroupsDeleteNodesRequestResource] DeleteNodesNodeGroupRequest nodeGroupsDeleteNodesRequestResource
                         * @property {string|null} [project] DeleteNodesNodeGroupRequest project
                         * @property {string|null} [requestId] DeleteNodesNodeGroupRequest requestId
                         * @property {string|null} [zone] DeleteNodesNodeGroupRequest zone
                         */
    
                        /**
                         * Constructs a new DeleteNodesNodeGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteNodesNodeGroupRequest.
                         * @implements IDeleteNodesNodeGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteNodesNodeGroupRequest=} [properties] Properties to set
                         */
                        function DeleteNodesNodeGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteNodesNodeGroupRequest nodeGroup.
                         * @member {string} nodeGroup
                         * @memberof google.cloud.compute.v1.DeleteNodesNodeGroupRequest
                         * @instance
                         */
                        DeleteNodesNodeGroupRequest.prototype.nodeGroup = "";
    
                        /**
                         * DeleteNodesNodeGroupRequest nodeGroupsDeleteNodesRequestResource.
                         * @member {google.cloud.compute.v1.INodeGroupsDeleteNodesRequest|null|undefined} nodeGroupsDeleteNodesRequestResource
                         * @memberof google.cloud.compute.v1.DeleteNodesNodeGroupRequest
                         * @instance
                         */
                        DeleteNodesNodeGroupRequest.prototype.nodeGroupsDeleteNodesRequestResource = null;
    
                        /**
                         * DeleteNodesNodeGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteNodesNodeGroupRequest
                         * @instance
                         */
                        DeleteNodesNodeGroupRequest.prototype.project = "";
    
                        /**
                         * DeleteNodesNodeGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteNodesNodeGroupRequest
                         * @instance
                         */
                        DeleteNodesNodeGroupRequest.prototype.requestId = null;
    
                        /**
                         * DeleteNodesNodeGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.DeleteNodesNodeGroupRequest
                         * @instance
                         */
                        DeleteNodesNodeGroupRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteNodesNodeGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteNodesNodeGroupRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteNodesNodeGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteNodesNodeGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteNodesNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNodesNodeGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteNodesNodeGroupRequest} DeleteNodesNodeGroupRequest instance
                         */
                        DeleteNodesNodeGroupRequest.create = function create(properties) {
                            return new DeleteNodesNodeGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteNodesNodeGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteNodesNodeGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteNodesNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNodesNodeGroupRequest} message DeleteNodesNodeGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteNodesNodeGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.nodeGroupsDeleteNodesRequestResource != null && Object.hasOwnProperty.call(message, "nodeGroupsDeleteNodesRequestResource"))
                                $root.google.cloud.compute.v1.NodeGroupsDeleteNodesRequest.encode(message.nodeGroupsDeleteNodesRequestResource, writer.uint32(/* id 183298962, wireType 2 =*/1466391698).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.nodeGroup != null && Object.hasOwnProperty.call(message, "nodeGroup"))
                                writer.uint32(/* id 469958146, wireType 2 =*/3759665170).string(message.nodeGroup);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteNodesNodeGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteNodesNodeGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteNodesNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteNodesNodeGroupRequest} message DeleteNodesNodeGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteNodesNodeGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteNodesNodeGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteNodesNodeGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteNodesNodeGroupRequest} DeleteNodesNodeGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteNodesNodeGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteNodesNodeGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 469958146: {
                                        message.nodeGroup = reader.string();
                                        break;
                                    }
                                case 183298962: {
                                        message.nodeGroupsDeleteNodesRequestResource = $root.google.cloud.compute.v1.NodeGroupsDeleteNodesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteNodesNodeGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteNodesNodeGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteNodesNodeGroupRequest} DeleteNodesNodeGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteNodesNodeGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteNodesNodeGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteNodesNodeGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteNodesNodeGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.nodeGroup != null && message.hasOwnProperty("nodeGroup"))
                                if (!$util.isString(message.nodeGroup))
                                    return "nodeGroup: string expected";
                            if (message.nodeGroupsDeleteNodesRequestResource != null && message.hasOwnProperty("nodeGroupsDeleteNodesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.NodeGroupsDeleteNodesRequest.verify(message.nodeGroupsDeleteNodesRequestResource);
                                if (error)
                                    return "nodeGroupsDeleteNodesRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteNodesNodeGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteNodesNodeGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteNodesNodeGroupRequest} DeleteNodesNodeGroupRequest
                         */
                        DeleteNodesNodeGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteNodesNodeGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteNodesNodeGroupRequest();
                            if (object.nodeGroup != null)
                                message.nodeGroup = String(object.nodeGroup);
                            if (object.nodeGroupsDeleteNodesRequestResource != null) {
                                if (typeof object.nodeGroupsDeleteNodesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.DeleteNodesNodeGroupRequest.nodeGroupsDeleteNodesRequestResource: object expected");
                                message.nodeGroupsDeleteNodesRequestResource = $root.google.cloud.compute.v1.NodeGroupsDeleteNodesRequest.fromObject(object.nodeGroupsDeleteNodesRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteNodesNodeGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteNodesNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteNodesNodeGroupRequest} message DeleteNodesNodeGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteNodesNodeGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.nodeGroupsDeleteNodesRequestResource = null;
                                object.project = "";
                                object.nodeGroup = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.nodeGroupsDeleteNodesRequestResource != null && message.hasOwnProperty("nodeGroupsDeleteNodesRequestResource"))
                                object.nodeGroupsDeleteNodesRequestResource = $root.google.cloud.compute.v1.NodeGroupsDeleteNodesRequest.toObject(message.nodeGroupsDeleteNodesRequestResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.nodeGroup != null && message.hasOwnProperty("nodeGroup"))
                                object.nodeGroup = message.nodeGroup;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteNodesNodeGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteNodesNodeGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteNodesNodeGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteNodesNodeGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteNodesNodeGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteNodesNodeGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteNodesNodeGroupRequest";
                        };
    
                        return DeleteNodesNodeGroupRequest;
                    })();
    
                    v1.DeletePacketMirroringRequest = (function() {
    
                        /**
                         * Properties of a DeletePacketMirroringRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeletePacketMirroringRequest
                         * @property {string|null} [packetMirroring] DeletePacketMirroringRequest packetMirroring
                         * @property {string|null} [project] DeletePacketMirroringRequest project
                         * @property {string|null} [region] DeletePacketMirroringRequest region
                         * @property {string|null} [requestId] DeletePacketMirroringRequest requestId
                         */
    
                        /**
                         * Constructs a new DeletePacketMirroringRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeletePacketMirroringRequest.
                         * @implements IDeletePacketMirroringRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeletePacketMirroringRequest=} [properties] Properties to set
                         */
                        function DeletePacketMirroringRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeletePacketMirroringRequest packetMirroring.
                         * @member {string} packetMirroring
                         * @memberof google.cloud.compute.v1.DeletePacketMirroringRequest
                         * @instance
                         */
                        DeletePacketMirroringRequest.prototype.packetMirroring = "";
    
                        /**
                         * DeletePacketMirroringRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeletePacketMirroringRequest
                         * @instance
                         */
                        DeletePacketMirroringRequest.prototype.project = "";
    
                        /**
                         * DeletePacketMirroringRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeletePacketMirroringRequest
                         * @instance
                         */
                        DeletePacketMirroringRequest.prototype.region = "";
    
                        /**
                         * DeletePacketMirroringRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeletePacketMirroringRequest
                         * @instance
                         */
                        DeletePacketMirroringRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeletePacketMirroringRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeletePacketMirroringRequest
                         * @instance
                         */
                        Object.defineProperty(DeletePacketMirroringRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeletePacketMirroringRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeletePacketMirroringRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeletePacketMirroringRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeletePacketMirroringRequest} DeletePacketMirroringRequest instance
                         */
                        DeletePacketMirroringRequest.create = function create(properties) {
                            return new DeletePacketMirroringRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeletePacketMirroringRequest message. Does not implicitly {@link google.cloud.compute.v1.DeletePacketMirroringRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeletePacketMirroringRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeletePacketMirroringRequest} message DeletePacketMirroringRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeletePacketMirroringRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.packetMirroring != null && Object.hasOwnProperty.call(message, "packetMirroring"))
                                writer.uint32(/* id 22305996, wireType 2 =*/178447970).string(message.packetMirroring);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeletePacketMirroringRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeletePacketMirroringRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeletePacketMirroringRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeletePacketMirroringRequest} message DeletePacketMirroringRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeletePacketMirroringRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeletePacketMirroringRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeletePacketMirroringRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeletePacketMirroringRequest} DeletePacketMirroringRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeletePacketMirroringRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeletePacketMirroringRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 22305996: {
                                        message.packetMirroring = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeletePacketMirroringRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeletePacketMirroringRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeletePacketMirroringRequest} DeletePacketMirroringRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeletePacketMirroringRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeletePacketMirroringRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeletePacketMirroringRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeletePacketMirroringRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.packetMirroring != null && message.hasOwnProperty("packetMirroring"))
                                if (!$util.isString(message.packetMirroring))
                                    return "packetMirroring: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeletePacketMirroringRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeletePacketMirroringRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeletePacketMirroringRequest} DeletePacketMirroringRequest
                         */
                        DeletePacketMirroringRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeletePacketMirroringRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeletePacketMirroringRequest();
                            if (object.packetMirroring != null)
                                message.packetMirroring = String(object.packetMirroring);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeletePacketMirroringRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeletePacketMirroringRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeletePacketMirroringRequest} message DeletePacketMirroringRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeletePacketMirroringRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.packetMirroring = "";
                                object.region = "";
                                object.project = "";
                            }
                            if (message.packetMirroring != null && message.hasOwnProperty("packetMirroring"))
                                object.packetMirroring = message.packetMirroring;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeletePacketMirroringRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeletePacketMirroringRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeletePacketMirroringRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeletePacketMirroringRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeletePacketMirroringRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeletePacketMirroringRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeletePacketMirroringRequest";
                        };
    
                        return DeletePacketMirroringRequest;
                    })();
    
                    v1.DeletePerInstanceConfigsInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a DeletePerInstanceConfigsInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeletePerInstanceConfigsInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] DeletePerInstanceConfigsInstanceGroupManagerRequest instanceGroupManager
                         * @property {google.cloud.compute.v1.IInstanceGroupManagersDeletePerInstanceConfigsReq|null} [instanceGroupManagersDeletePerInstanceConfigsReqResource] DeletePerInstanceConfigsInstanceGroupManagerRequest instanceGroupManagersDeletePerInstanceConfigsReqResource
                         * @property {string|null} [project] DeletePerInstanceConfigsInstanceGroupManagerRequest project
                         * @property {string|null} [zone] DeletePerInstanceConfigsInstanceGroupManagerRequest zone
                         */
    
                        /**
                         * Constructs a new DeletePerInstanceConfigsInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeletePerInstanceConfigsInstanceGroupManagerRequest.
                         * @implements IDeletePerInstanceConfigsInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeletePerInstanceConfigsInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function DeletePerInstanceConfigsInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeletePerInstanceConfigsInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest
                         * @instance
                         */
                        DeletePerInstanceConfigsInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * DeletePerInstanceConfigsInstanceGroupManagerRequest instanceGroupManagersDeletePerInstanceConfigsReqResource.
                         * @member {google.cloud.compute.v1.IInstanceGroupManagersDeletePerInstanceConfigsReq|null|undefined} instanceGroupManagersDeletePerInstanceConfigsReqResource
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest
                         * @instance
                         */
                        DeletePerInstanceConfigsInstanceGroupManagerRequest.prototype.instanceGroupManagersDeletePerInstanceConfigsReqResource = null;
    
                        /**
                         * DeletePerInstanceConfigsInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest
                         * @instance
                         */
                        DeletePerInstanceConfigsInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * DeletePerInstanceConfigsInstanceGroupManagerRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest
                         * @instance
                         */
                        DeletePerInstanceConfigsInstanceGroupManagerRequest.prototype.zone = "";
    
                        /**
                         * Creates a new DeletePerInstanceConfigsInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeletePerInstanceConfigsInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest} DeletePerInstanceConfigsInstanceGroupManagerRequest instance
                         */
                        DeletePerInstanceConfigsInstanceGroupManagerRequest.create = function create(properties) {
                            return new DeletePerInstanceConfigsInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeletePerInstanceConfigsInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeletePerInstanceConfigsInstanceGroupManagerRequest} message DeletePerInstanceConfigsInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeletePerInstanceConfigsInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            if (message.instanceGroupManagersDeletePerInstanceConfigsReqResource != null && Object.hasOwnProperty.call(message, "instanceGroupManagersDeletePerInstanceConfigsReqResource"))
                                $root.google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq.encode(message.instanceGroupManagersDeletePerInstanceConfigsReqResource, writer.uint32(/* id 362427680, wireType 2 =*/2899421442).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeletePerInstanceConfigsInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeletePerInstanceConfigsInstanceGroupManagerRequest} message DeletePerInstanceConfigsInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeletePerInstanceConfigsInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeletePerInstanceConfigsInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest} DeletePerInstanceConfigsInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeletePerInstanceConfigsInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 362427680: {
                                        message.instanceGroupManagersDeletePerInstanceConfigsReqResource = $root.google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeletePerInstanceConfigsInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest} DeletePerInstanceConfigsInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeletePerInstanceConfigsInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeletePerInstanceConfigsInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeletePerInstanceConfigsInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.instanceGroupManagersDeletePerInstanceConfigsReqResource != null && message.hasOwnProperty("instanceGroupManagersDeletePerInstanceConfigsReqResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq.verify(message.instanceGroupManagersDeletePerInstanceConfigsReqResource);
                                if (error)
                                    return "instanceGroupManagersDeletePerInstanceConfigsReqResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeletePerInstanceConfigsInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest} DeletePerInstanceConfigsInstanceGroupManagerRequest
                         */
                        DeletePerInstanceConfigsInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.instanceGroupManagersDeletePerInstanceConfigsReqResource != null) {
                                if (typeof object.instanceGroupManagersDeletePerInstanceConfigsReqResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest.instanceGroupManagersDeletePerInstanceConfigsReqResource: object expected");
                                message.instanceGroupManagersDeletePerInstanceConfigsReqResource = $root.google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq.fromObject(object.instanceGroupManagersDeletePerInstanceConfigsReqResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeletePerInstanceConfigsInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest} message DeletePerInstanceConfigsInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeletePerInstanceConfigsInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                                object.instanceGroupManagersDeletePerInstanceConfigsReqResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            if (message.instanceGroupManagersDeletePerInstanceConfigsReqResource != null && message.hasOwnProperty("instanceGroupManagersDeletePerInstanceConfigsReqResource"))
                                object.instanceGroupManagersDeletePerInstanceConfigsReqResource = $root.google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq.toObject(message.instanceGroupManagersDeletePerInstanceConfigsReqResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this DeletePerInstanceConfigsInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeletePerInstanceConfigsInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeletePerInstanceConfigsInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeletePerInstanceConfigsInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest";
                        };
    
                        return DeletePerInstanceConfigsInstanceGroupManagerRequest;
                    })();
    
                    v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a DeletePerInstanceConfigsRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] DeletePerInstanceConfigsRegionInstanceGroupManagerRequest instanceGroupManager
                         * @property {string|null} [project] DeletePerInstanceConfigsRegionInstanceGroupManagerRequest project
                         * @property {string|null} [region] DeletePerInstanceConfigsRegionInstanceGroupManagerRequest region
                         * @property {google.cloud.compute.v1.IRegionInstanceGroupManagerDeleteInstanceConfigReq|null} [regionInstanceGroupManagerDeleteInstanceConfigReqResource] DeletePerInstanceConfigsRegionInstanceGroupManagerRequest regionInstanceGroupManagerDeleteInstanceConfigReqResource
                         */
    
                        /**
                         * Constructs a new DeletePerInstanceConfigsRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeletePerInstanceConfigsRegionInstanceGroupManagerRequest.
                         * @implements IDeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeletePerInstanceConfigsRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function DeletePerInstanceConfigsRegionInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeletePerInstanceConfigsRegionInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        DeletePerInstanceConfigsRegionInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * DeletePerInstanceConfigsRegionInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        DeletePerInstanceConfigsRegionInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * DeletePerInstanceConfigsRegionInstanceGroupManagerRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        DeletePerInstanceConfigsRegionInstanceGroupManagerRequest.prototype.region = "";
    
                        /**
                         * DeletePerInstanceConfigsRegionInstanceGroupManagerRequest regionInstanceGroupManagerDeleteInstanceConfigReqResource.
                         * @member {google.cloud.compute.v1.IRegionInstanceGroupManagerDeleteInstanceConfigReq|null|undefined} regionInstanceGroupManagerDeleteInstanceConfigReqResource
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        DeletePerInstanceConfigsRegionInstanceGroupManagerRequest.prototype.regionInstanceGroupManagerDeleteInstanceConfigReqResource = null;
    
                        /**
                         * Creates a new DeletePerInstanceConfigsRegionInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeletePerInstanceConfigsRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest} DeletePerInstanceConfigsRegionInstanceGroupManagerRequest instance
                         */
                        DeletePerInstanceConfigsRegionInstanceGroupManagerRequest.create = function create(properties) {
                            return new DeletePerInstanceConfigsRegionInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeletePerInstanceConfigsRegionInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeletePerInstanceConfigsRegionInstanceGroupManagerRequest} message DeletePerInstanceConfigsRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeletePerInstanceConfigsRegionInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.regionInstanceGroupManagerDeleteInstanceConfigReqResource != null && Object.hasOwnProperty.call(message, "regionInstanceGroupManagerDeleteInstanceConfigReqResource"))
                                $root.google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq.encode(message.regionInstanceGroupManagerDeleteInstanceConfigReqResource, writer.uint32(/* id 740741, wireType 2 =*/5925930).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeletePerInstanceConfigsRegionInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeletePerInstanceConfigsRegionInstanceGroupManagerRequest} message DeletePerInstanceConfigsRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeletePerInstanceConfigsRegionInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeletePerInstanceConfigsRegionInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest} DeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeletePerInstanceConfigsRegionInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 740741: {
                                        message.regionInstanceGroupManagerDeleteInstanceConfigReqResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeletePerInstanceConfigsRegionInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest} DeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeletePerInstanceConfigsRegionInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeletePerInstanceConfigsRegionInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeletePerInstanceConfigsRegionInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionInstanceGroupManagerDeleteInstanceConfigReqResource != null && message.hasOwnProperty("regionInstanceGroupManagerDeleteInstanceConfigReqResource")) {
                                var error = $root.google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq.verify(message.regionInstanceGroupManagerDeleteInstanceConfigReqResource);
                                if (error)
                                    return "regionInstanceGroupManagerDeleteInstanceConfigReqResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeletePerInstanceConfigsRegionInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest} DeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         */
                        DeletePerInstanceConfigsRegionInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionInstanceGroupManagerDeleteInstanceConfigReqResource != null) {
                                if (typeof object.regionInstanceGroupManagerDeleteInstanceConfigReqResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest.regionInstanceGroupManagerDeleteInstanceConfigReqResource: object expected");
                                message.regionInstanceGroupManagerDeleteInstanceConfigReqResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq.fromObject(object.regionInstanceGroupManagerDeleteInstanceConfigReqResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeletePerInstanceConfigsRegionInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest} message DeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeletePerInstanceConfigsRegionInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.regionInstanceGroupManagerDeleteInstanceConfigReqResource = null;
                                object.region = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.regionInstanceGroupManagerDeleteInstanceConfigReqResource != null && message.hasOwnProperty("regionInstanceGroupManagerDeleteInstanceConfigReqResource"))
                                object.regionInstanceGroupManagerDeleteInstanceConfigReqResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq.toObject(message.regionInstanceGroupManagerDeleteInstanceConfigReqResource, options);
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            return object;
                        };
    
                        /**
                         * Converts this DeletePerInstanceConfigsRegionInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeletePerInstanceConfigsRegionInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeletePerInstanceConfigsRegionInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest";
                        };
    
                        return DeletePerInstanceConfigsRegionInstanceGroupManagerRequest;
                    })();
    
                    v1.DeletePublicAdvertisedPrefixeRequest = (function() {
    
                        /**
                         * Properties of a DeletePublicAdvertisedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeletePublicAdvertisedPrefixeRequest
                         * @property {string|null} [project] DeletePublicAdvertisedPrefixeRequest project
                         * @property {string|null} [publicAdvertisedPrefix] DeletePublicAdvertisedPrefixeRequest publicAdvertisedPrefix
                         * @property {string|null} [requestId] DeletePublicAdvertisedPrefixeRequest requestId
                         */
    
                        /**
                         * Constructs a new DeletePublicAdvertisedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeletePublicAdvertisedPrefixeRequest.
                         * @implements IDeletePublicAdvertisedPrefixeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeletePublicAdvertisedPrefixeRequest=} [properties] Properties to set
                         */
                        function DeletePublicAdvertisedPrefixeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeletePublicAdvertisedPrefixeRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest
                         * @instance
                         */
                        DeletePublicAdvertisedPrefixeRequest.prototype.project = "";
    
                        /**
                         * DeletePublicAdvertisedPrefixeRequest publicAdvertisedPrefix.
                         * @member {string} publicAdvertisedPrefix
                         * @memberof google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest
                         * @instance
                         */
                        DeletePublicAdvertisedPrefixeRequest.prototype.publicAdvertisedPrefix = "";
    
                        /**
                         * DeletePublicAdvertisedPrefixeRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest
                         * @instance
                         */
                        DeletePublicAdvertisedPrefixeRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeletePublicAdvertisedPrefixeRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest
                         * @instance
                         */
                        Object.defineProperty(DeletePublicAdvertisedPrefixeRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeletePublicAdvertisedPrefixeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeletePublicAdvertisedPrefixeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest} DeletePublicAdvertisedPrefixeRequest instance
                         */
                        DeletePublicAdvertisedPrefixeRequest.create = function create(properties) {
                            return new DeletePublicAdvertisedPrefixeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeletePublicAdvertisedPrefixeRequest message. Does not implicitly {@link google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeletePublicAdvertisedPrefixeRequest} message DeletePublicAdvertisedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeletePublicAdvertisedPrefixeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.publicAdvertisedPrefix != null && Object.hasOwnProperty.call(message, "publicAdvertisedPrefix"))
                                writer.uint32(/* id 101874590, wireType 2 =*/814996722).string(message.publicAdvertisedPrefix);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeletePublicAdvertisedPrefixeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeletePublicAdvertisedPrefixeRequest} message DeletePublicAdvertisedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeletePublicAdvertisedPrefixeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeletePublicAdvertisedPrefixeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest} DeletePublicAdvertisedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeletePublicAdvertisedPrefixeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 101874590: {
                                        message.publicAdvertisedPrefix = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeletePublicAdvertisedPrefixeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest} DeletePublicAdvertisedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeletePublicAdvertisedPrefixeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeletePublicAdvertisedPrefixeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeletePublicAdvertisedPrefixeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.publicAdvertisedPrefix != null && message.hasOwnProperty("publicAdvertisedPrefix"))
                                if (!$util.isString(message.publicAdvertisedPrefix))
                                    return "publicAdvertisedPrefix: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeletePublicAdvertisedPrefixeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest} DeletePublicAdvertisedPrefixeRequest
                         */
                        DeletePublicAdvertisedPrefixeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.publicAdvertisedPrefix != null)
                                message.publicAdvertisedPrefix = String(object.publicAdvertisedPrefix);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeletePublicAdvertisedPrefixeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest} message DeletePublicAdvertisedPrefixeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeletePublicAdvertisedPrefixeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.publicAdvertisedPrefix = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.publicAdvertisedPrefix != null && message.hasOwnProperty("publicAdvertisedPrefix"))
                                object.publicAdvertisedPrefix = message.publicAdvertisedPrefix;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeletePublicAdvertisedPrefixeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeletePublicAdvertisedPrefixeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeletePublicAdvertisedPrefixeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeletePublicAdvertisedPrefixeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest";
                        };
    
                        return DeletePublicAdvertisedPrefixeRequest;
                    })();
    
                    v1.DeletePublicDelegatedPrefixeRequest = (function() {
    
                        /**
                         * Properties of a DeletePublicDelegatedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeletePublicDelegatedPrefixeRequest
                         * @property {string|null} [project] DeletePublicDelegatedPrefixeRequest project
                         * @property {string|null} [publicDelegatedPrefix] DeletePublicDelegatedPrefixeRequest publicDelegatedPrefix
                         * @property {string|null} [region] DeletePublicDelegatedPrefixeRequest region
                         * @property {string|null} [requestId] DeletePublicDelegatedPrefixeRequest requestId
                         */
    
                        /**
                         * Constructs a new DeletePublicDelegatedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeletePublicDelegatedPrefixeRequest.
                         * @implements IDeletePublicDelegatedPrefixeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeletePublicDelegatedPrefixeRequest=} [properties] Properties to set
                         */
                        function DeletePublicDelegatedPrefixeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeletePublicDelegatedPrefixeRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest
                         * @instance
                         */
                        DeletePublicDelegatedPrefixeRequest.prototype.project = "";
    
                        /**
                         * DeletePublicDelegatedPrefixeRequest publicDelegatedPrefix.
                         * @member {string} publicDelegatedPrefix
                         * @memberof google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest
                         * @instance
                         */
                        DeletePublicDelegatedPrefixeRequest.prototype.publicDelegatedPrefix = "";
    
                        /**
                         * DeletePublicDelegatedPrefixeRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest
                         * @instance
                         */
                        DeletePublicDelegatedPrefixeRequest.prototype.region = "";
    
                        /**
                         * DeletePublicDelegatedPrefixeRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest
                         * @instance
                         */
                        DeletePublicDelegatedPrefixeRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeletePublicDelegatedPrefixeRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest
                         * @instance
                         */
                        Object.defineProperty(DeletePublicDelegatedPrefixeRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeletePublicDelegatedPrefixeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeletePublicDelegatedPrefixeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest} DeletePublicDelegatedPrefixeRequest instance
                         */
                        DeletePublicDelegatedPrefixeRequest.create = function create(properties) {
                            return new DeletePublicDelegatedPrefixeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeletePublicDelegatedPrefixeRequest message. Does not implicitly {@link google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeletePublicDelegatedPrefixeRequest} message DeletePublicDelegatedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeletePublicDelegatedPrefixeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.publicDelegatedPrefix != null && Object.hasOwnProperty.call(message, "publicDelegatedPrefix"))
                                writer.uint32(/* id 204238440, wireType 2 =*/1633907522).string(message.publicDelegatedPrefix);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeletePublicDelegatedPrefixeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeletePublicDelegatedPrefixeRequest} message DeletePublicDelegatedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeletePublicDelegatedPrefixeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeletePublicDelegatedPrefixeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest} DeletePublicDelegatedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeletePublicDelegatedPrefixeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 204238440: {
                                        message.publicDelegatedPrefix = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeletePublicDelegatedPrefixeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest} DeletePublicDelegatedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeletePublicDelegatedPrefixeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeletePublicDelegatedPrefixeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeletePublicDelegatedPrefixeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.publicDelegatedPrefix != null && message.hasOwnProperty("publicDelegatedPrefix"))
                                if (!$util.isString(message.publicDelegatedPrefix))
                                    return "publicDelegatedPrefix: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeletePublicDelegatedPrefixeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest} DeletePublicDelegatedPrefixeRequest
                         */
                        DeletePublicDelegatedPrefixeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.publicDelegatedPrefix != null)
                                message.publicDelegatedPrefix = String(object.publicDelegatedPrefix);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeletePublicDelegatedPrefixeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest} message DeletePublicDelegatedPrefixeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeletePublicDelegatedPrefixeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.publicDelegatedPrefix = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.publicDelegatedPrefix != null && message.hasOwnProperty("publicDelegatedPrefix"))
                                object.publicDelegatedPrefix = message.publicDelegatedPrefix;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeletePublicDelegatedPrefixeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeletePublicDelegatedPrefixeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeletePublicDelegatedPrefixeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeletePublicDelegatedPrefixeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest";
                        };
    
                        return DeletePublicDelegatedPrefixeRequest;
                    })();
    
                    v1.DeleteRegionAutoscalerRequest = (function() {
    
                        /**
                         * Properties of a DeleteRegionAutoscalerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteRegionAutoscalerRequest
                         * @property {string|null} [autoscaler] DeleteRegionAutoscalerRequest autoscaler
                         * @property {string|null} [project] DeleteRegionAutoscalerRequest project
                         * @property {string|null} [region] DeleteRegionAutoscalerRequest region
                         * @property {string|null} [requestId] DeleteRegionAutoscalerRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteRegionAutoscalerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteRegionAutoscalerRequest.
                         * @implements IDeleteRegionAutoscalerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteRegionAutoscalerRequest=} [properties] Properties to set
                         */
                        function DeleteRegionAutoscalerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteRegionAutoscalerRequest autoscaler.
                         * @member {string} autoscaler
                         * @memberof google.cloud.compute.v1.DeleteRegionAutoscalerRequest
                         * @instance
                         */
                        DeleteRegionAutoscalerRequest.prototype.autoscaler = "";
    
                        /**
                         * DeleteRegionAutoscalerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteRegionAutoscalerRequest
                         * @instance
                         */
                        DeleteRegionAutoscalerRequest.prototype.project = "";
    
                        /**
                         * DeleteRegionAutoscalerRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteRegionAutoscalerRequest
                         * @instance
                         */
                        DeleteRegionAutoscalerRequest.prototype.region = "";
    
                        /**
                         * DeleteRegionAutoscalerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionAutoscalerRequest
                         * @instance
                         */
                        DeleteRegionAutoscalerRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteRegionAutoscalerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionAutoscalerRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteRegionAutoscalerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteRegionAutoscalerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteRegionAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionAutoscalerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteRegionAutoscalerRequest} DeleteRegionAutoscalerRequest instance
                         */
                        DeleteRegionAutoscalerRequest.create = function create(properties) {
                            return new DeleteRegionAutoscalerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteRegionAutoscalerRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionAutoscalerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteRegionAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionAutoscalerRequest} message DeleteRegionAutoscalerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionAutoscalerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.autoscaler != null && Object.hasOwnProperty.call(message, "autoscaler"))
                                writer.uint32(/* id 517258967, wireType 2 =*/4138071738).string(message.autoscaler);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteRegionAutoscalerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionAutoscalerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionAutoscalerRequest} message DeleteRegionAutoscalerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionAutoscalerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteRegionAutoscalerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteRegionAutoscalerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteRegionAutoscalerRequest} DeleteRegionAutoscalerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionAutoscalerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteRegionAutoscalerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 517258967: {
                                        message.autoscaler = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteRegionAutoscalerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionAutoscalerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteRegionAutoscalerRequest} DeleteRegionAutoscalerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionAutoscalerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteRegionAutoscalerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteRegionAutoscalerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteRegionAutoscalerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoscaler != null && message.hasOwnProperty("autoscaler"))
                                if (!$util.isString(message.autoscaler))
                                    return "autoscaler: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteRegionAutoscalerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteRegionAutoscalerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteRegionAutoscalerRequest} DeleteRegionAutoscalerRequest
                         */
                        DeleteRegionAutoscalerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteRegionAutoscalerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteRegionAutoscalerRequest();
                            if (object.autoscaler != null)
                                message.autoscaler = String(object.autoscaler);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteRegionAutoscalerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteRegionAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteRegionAutoscalerRequest} message DeleteRegionAutoscalerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteRegionAutoscalerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.autoscaler = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.autoscaler != null && message.hasOwnProperty("autoscaler"))
                                object.autoscaler = message.autoscaler;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteRegionAutoscalerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteRegionAutoscalerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteRegionAutoscalerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteRegionAutoscalerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteRegionAutoscalerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteRegionAutoscalerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteRegionAutoscalerRequest";
                        };
    
                        return DeleteRegionAutoscalerRequest;
                    })();
    
                    v1.DeleteRegionBackendServiceRequest = (function() {
    
                        /**
                         * Properties of a DeleteRegionBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteRegionBackendServiceRequest
                         * @property {string|null} [backendService] DeleteRegionBackendServiceRequest backendService
                         * @property {string|null} [project] DeleteRegionBackendServiceRequest project
                         * @property {string|null} [region] DeleteRegionBackendServiceRequest region
                         * @property {string|null} [requestId] DeleteRegionBackendServiceRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteRegionBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteRegionBackendServiceRequest.
                         * @implements IDeleteRegionBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteRegionBackendServiceRequest=} [properties] Properties to set
                         */
                        function DeleteRegionBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteRegionBackendServiceRequest backendService.
                         * @member {string} backendService
                         * @memberof google.cloud.compute.v1.DeleteRegionBackendServiceRequest
                         * @instance
                         */
                        DeleteRegionBackendServiceRequest.prototype.backendService = "";
    
                        /**
                         * DeleteRegionBackendServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteRegionBackendServiceRequest
                         * @instance
                         */
                        DeleteRegionBackendServiceRequest.prototype.project = "";
    
                        /**
                         * DeleteRegionBackendServiceRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteRegionBackendServiceRequest
                         * @instance
                         */
                        DeleteRegionBackendServiceRequest.prototype.region = "";
    
                        /**
                         * DeleteRegionBackendServiceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionBackendServiceRequest
                         * @instance
                         */
                        DeleteRegionBackendServiceRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteRegionBackendServiceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionBackendServiceRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteRegionBackendServiceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteRegionBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteRegionBackendServiceRequest} DeleteRegionBackendServiceRequest instance
                         */
                        DeleteRegionBackendServiceRequest.create = function create(properties) {
                            return new DeleteRegionBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteRegionBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionBackendServiceRequest} message DeleteRegionBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.backendService != null && Object.hasOwnProperty.call(message, "backendService"))
                                writer.uint32(/* id 306946058, wireType 2 =*/2455568466).string(message.backendService);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteRegionBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionBackendServiceRequest} message DeleteRegionBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteRegionBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteRegionBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteRegionBackendServiceRequest} DeleteRegionBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteRegionBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 306946058: {
                                        message.backendService = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteRegionBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteRegionBackendServiceRequest} DeleteRegionBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteRegionBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteRegionBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteRegionBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                if (!$util.isString(message.backendService))
                                    return "backendService: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteRegionBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteRegionBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteRegionBackendServiceRequest} DeleteRegionBackendServiceRequest
                         */
                        DeleteRegionBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteRegionBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteRegionBackendServiceRequest();
                            if (object.backendService != null)
                                message.backendService = String(object.backendService);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteRegionBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteRegionBackendServiceRequest} message DeleteRegionBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteRegionBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.backendService = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                object.backendService = message.backendService;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteRegionBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteRegionBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteRegionBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteRegionBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteRegionBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteRegionBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteRegionBackendServiceRequest";
                        };
    
                        return DeleteRegionBackendServiceRequest;
                    })();
    
                    v1.DeleteRegionDiskRequest = (function() {
    
                        /**
                         * Properties of a DeleteRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteRegionDiskRequest
                         * @property {string|null} [disk] DeleteRegionDiskRequest disk
                         * @property {string|null} [project] DeleteRegionDiskRequest project
                         * @property {string|null} [region] DeleteRegionDiskRequest region
                         * @property {string|null} [requestId] DeleteRegionDiskRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteRegionDiskRequest.
                         * @implements IDeleteRegionDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteRegionDiskRequest=} [properties] Properties to set
                         */
                        function DeleteRegionDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteRegionDiskRequest disk.
                         * @member {string} disk
                         * @memberof google.cloud.compute.v1.DeleteRegionDiskRequest
                         * @instance
                         */
                        DeleteRegionDiskRequest.prototype.disk = "";
    
                        /**
                         * DeleteRegionDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteRegionDiskRequest
                         * @instance
                         */
                        DeleteRegionDiskRequest.prototype.project = "";
    
                        /**
                         * DeleteRegionDiskRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteRegionDiskRequest
                         * @instance
                         */
                        DeleteRegionDiskRequest.prototype.region = "";
    
                        /**
                         * DeleteRegionDiskRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionDiskRequest
                         * @instance
                         */
                        DeleteRegionDiskRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteRegionDiskRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionDiskRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteRegionDiskRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteRegionDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteRegionDiskRequest} DeleteRegionDiskRequest instance
                         */
                        DeleteRegionDiskRequest.create = function create(properties) {
                            return new DeleteRegionDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteRegionDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionDiskRequest} message DeleteRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.disk != null && Object.hasOwnProperty.call(message, "disk"))
                                writer.uint32(/* id 3083677, wireType 2 =*/24669418).string(message.disk);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteRegionDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionDiskRequest} message DeleteRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteRegionDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteRegionDiskRequest} DeleteRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteRegionDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3083677: {
                                        message.disk = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteRegionDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteRegionDiskRequest} DeleteRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteRegionDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteRegionDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                if (!$util.isString(message.disk))
                                    return "disk: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteRegionDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteRegionDiskRequest} DeleteRegionDiskRequest
                         */
                        DeleteRegionDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteRegionDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteRegionDiskRequest();
                            if (object.disk != null)
                                message.disk = String(object.disk);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteRegionDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteRegionDiskRequest} message DeleteRegionDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteRegionDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.disk = "";
                                object.region = "";
                                object.project = "";
                            }
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                object.disk = message.disk;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteRegionDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteRegionDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteRegionDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteRegionDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteRegionDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteRegionDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteRegionDiskRequest";
                        };
    
                        return DeleteRegionDiskRequest;
                    })();
    
                    v1.DeleteRegionHealthCheckRequest = (function() {
    
                        /**
                         * Properties of a DeleteRegionHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteRegionHealthCheckRequest
                         * @property {string|null} [healthCheck] DeleteRegionHealthCheckRequest healthCheck
                         * @property {string|null} [project] DeleteRegionHealthCheckRequest project
                         * @property {string|null} [region] DeleteRegionHealthCheckRequest region
                         * @property {string|null} [requestId] DeleteRegionHealthCheckRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteRegionHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteRegionHealthCheckRequest.
                         * @implements IDeleteRegionHealthCheckRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteRegionHealthCheckRequest=} [properties] Properties to set
                         */
                        function DeleteRegionHealthCheckRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteRegionHealthCheckRequest healthCheck.
                         * @member {string} healthCheck
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckRequest
                         * @instance
                         */
                        DeleteRegionHealthCheckRequest.prototype.healthCheck = "";
    
                        /**
                         * DeleteRegionHealthCheckRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckRequest
                         * @instance
                         */
                        DeleteRegionHealthCheckRequest.prototype.project = "";
    
                        /**
                         * DeleteRegionHealthCheckRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckRequest
                         * @instance
                         */
                        DeleteRegionHealthCheckRequest.prototype.region = "";
    
                        /**
                         * DeleteRegionHealthCheckRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckRequest
                         * @instance
                         */
                        DeleteRegionHealthCheckRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteRegionHealthCheckRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteRegionHealthCheckRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteRegionHealthCheckRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionHealthCheckRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteRegionHealthCheckRequest} DeleteRegionHealthCheckRequest instance
                         */
                        DeleteRegionHealthCheckRequest.create = function create(properties) {
                            return new DeleteRegionHealthCheckRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteRegionHealthCheckRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionHealthCheckRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionHealthCheckRequest} message DeleteRegionHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionHealthCheckRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.healthCheck != null && Object.hasOwnProperty.call(message, "healthCheck"))
                                writer.uint32(/* id 308876645, wireType 2 =*/2471013162).string(message.healthCheck);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteRegionHealthCheckRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionHealthCheckRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionHealthCheckRequest} message DeleteRegionHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionHealthCheckRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteRegionHealthCheckRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteRegionHealthCheckRequest} DeleteRegionHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionHealthCheckRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteRegionHealthCheckRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 308876645: {
                                        message.healthCheck = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteRegionHealthCheckRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteRegionHealthCheckRequest} DeleteRegionHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionHealthCheckRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteRegionHealthCheckRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteRegionHealthCheckRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck"))
                                if (!$util.isString(message.healthCheck))
                                    return "healthCheck: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteRegionHealthCheckRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteRegionHealthCheckRequest} DeleteRegionHealthCheckRequest
                         */
                        DeleteRegionHealthCheckRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteRegionHealthCheckRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteRegionHealthCheckRequest();
                            if (object.healthCheck != null)
                                message.healthCheck = String(object.healthCheck);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteRegionHealthCheckRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteRegionHealthCheckRequest} message DeleteRegionHealthCheckRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteRegionHealthCheckRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.healthCheck = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck"))
                                object.healthCheck = message.healthCheck;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteRegionHealthCheckRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteRegionHealthCheckRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteRegionHealthCheckRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteRegionHealthCheckRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteRegionHealthCheckRequest";
                        };
    
                        return DeleteRegionHealthCheckRequest;
                    })();
    
                    v1.DeleteRegionHealthCheckServiceRequest = (function() {
    
                        /**
                         * Properties of a DeleteRegionHealthCheckServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteRegionHealthCheckServiceRequest
                         * @property {string|null} [healthCheckService] DeleteRegionHealthCheckServiceRequest healthCheckService
                         * @property {string|null} [project] DeleteRegionHealthCheckServiceRequest project
                         * @property {string|null} [region] DeleteRegionHealthCheckServiceRequest region
                         * @property {string|null} [requestId] DeleteRegionHealthCheckServiceRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteRegionHealthCheckServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteRegionHealthCheckServiceRequest.
                         * @implements IDeleteRegionHealthCheckServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteRegionHealthCheckServiceRequest=} [properties] Properties to set
                         */
                        function DeleteRegionHealthCheckServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteRegionHealthCheckServiceRequest healthCheckService.
                         * @member {string} healthCheckService
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest
                         * @instance
                         */
                        DeleteRegionHealthCheckServiceRequest.prototype.healthCheckService = "";
    
                        /**
                         * DeleteRegionHealthCheckServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest
                         * @instance
                         */
                        DeleteRegionHealthCheckServiceRequest.prototype.project = "";
    
                        /**
                         * DeleteRegionHealthCheckServiceRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest
                         * @instance
                         */
                        DeleteRegionHealthCheckServiceRequest.prototype.region = "";
    
                        /**
                         * DeleteRegionHealthCheckServiceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest
                         * @instance
                         */
                        DeleteRegionHealthCheckServiceRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteRegionHealthCheckServiceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteRegionHealthCheckServiceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteRegionHealthCheckServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionHealthCheckServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest} DeleteRegionHealthCheckServiceRequest instance
                         */
                        DeleteRegionHealthCheckServiceRequest.create = function create(properties) {
                            return new DeleteRegionHealthCheckServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteRegionHealthCheckServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionHealthCheckServiceRequest} message DeleteRegionHealthCheckServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionHealthCheckServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.healthCheckService != null && Object.hasOwnProperty.call(message, "healthCheckService"))
                                writer.uint32(/* id 408374747, wireType 2 =*/3266997978).string(message.healthCheckService);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteRegionHealthCheckServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionHealthCheckServiceRequest} message DeleteRegionHealthCheckServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionHealthCheckServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteRegionHealthCheckServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest} DeleteRegionHealthCheckServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionHealthCheckServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 408374747: {
                                        message.healthCheckService = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteRegionHealthCheckServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest} DeleteRegionHealthCheckServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionHealthCheckServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteRegionHealthCheckServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteRegionHealthCheckServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.healthCheckService != null && message.hasOwnProperty("healthCheckService"))
                                if (!$util.isString(message.healthCheckService))
                                    return "healthCheckService: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteRegionHealthCheckServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest} DeleteRegionHealthCheckServiceRequest
                         */
                        DeleteRegionHealthCheckServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest();
                            if (object.healthCheckService != null)
                                message.healthCheckService = String(object.healthCheckService);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteRegionHealthCheckServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest} message DeleteRegionHealthCheckServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteRegionHealthCheckServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.healthCheckService = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.healthCheckService != null && message.hasOwnProperty("healthCheckService"))
                                object.healthCheckService = message.healthCheckService;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteRegionHealthCheckServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteRegionHealthCheckServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteRegionHealthCheckServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteRegionHealthCheckServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest";
                        };
    
                        return DeleteRegionHealthCheckServiceRequest;
                    })();
    
                    v1.DeleteRegionInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a DeleteRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteRegionInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] DeleteRegionInstanceGroupManagerRequest instanceGroupManager
                         * @property {string|null} [project] DeleteRegionInstanceGroupManagerRequest project
                         * @property {string|null} [region] DeleteRegionInstanceGroupManagerRequest region
                         * @property {string|null} [requestId] DeleteRegionInstanceGroupManagerRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteRegionInstanceGroupManagerRequest.
                         * @implements IDeleteRegionInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function DeleteRegionInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteRegionInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        DeleteRegionInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * DeleteRegionInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        DeleteRegionInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * DeleteRegionInstanceGroupManagerRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        DeleteRegionInstanceGroupManagerRequest.prototype.region = "";
    
                        /**
                         * DeleteRegionInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        DeleteRegionInstanceGroupManagerRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteRegionInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteRegionInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteRegionInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest} DeleteRegionInstanceGroupManagerRequest instance
                         */
                        DeleteRegionInstanceGroupManagerRequest.create = function create(properties) {
                            return new DeleteRegionInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteRegionInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionInstanceGroupManagerRequest} message DeleteRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteRegionInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionInstanceGroupManagerRequest} message DeleteRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteRegionInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest} DeleteRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteRegionInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest} DeleteRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteRegionInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteRegionInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteRegionInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest} DeleteRegionInstanceGroupManagerRequest
                         */
                        DeleteRegionInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteRegionInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest} message DeleteRegionInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteRegionInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteRegionInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteRegionInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteRegionInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteRegionInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest";
                        };
    
                        return DeleteRegionInstanceGroupManagerRequest;
                    })();
    
                    v1.DeleteRegionNetworkEndpointGroupRequest = (function() {
    
                        /**
                         * Properties of a DeleteRegionNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteRegionNetworkEndpointGroupRequest
                         * @property {string|null} [networkEndpointGroup] DeleteRegionNetworkEndpointGroupRequest networkEndpointGroup
                         * @property {string|null} [project] DeleteRegionNetworkEndpointGroupRequest project
                         * @property {string|null} [region] DeleteRegionNetworkEndpointGroupRequest region
                         * @property {string|null} [requestId] DeleteRegionNetworkEndpointGroupRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteRegionNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteRegionNetworkEndpointGroupRequest.
                         * @implements IDeleteRegionNetworkEndpointGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteRegionNetworkEndpointGroupRequest=} [properties] Properties to set
                         */
                        function DeleteRegionNetworkEndpointGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteRegionNetworkEndpointGroupRequest networkEndpointGroup.
                         * @member {string} networkEndpointGroup
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest
                         * @instance
                         */
                        DeleteRegionNetworkEndpointGroupRequest.prototype.networkEndpointGroup = "";
    
                        /**
                         * DeleteRegionNetworkEndpointGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest
                         * @instance
                         */
                        DeleteRegionNetworkEndpointGroupRequest.prototype.project = "";
    
                        /**
                         * DeleteRegionNetworkEndpointGroupRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest
                         * @instance
                         */
                        DeleteRegionNetworkEndpointGroupRequest.prototype.region = "";
    
                        /**
                         * DeleteRegionNetworkEndpointGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest
                         * @instance
                         */
                        DeleteRegionNetworkEndpointGroupRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteRegionNetworkEndpointGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteRegionNetworkEndpointGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteRegionNetworkEndpointGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionNetworkEndpointGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest} DeleteRegionNetworkEndpointGroupRequest instance
                         */
                        DeleteRegionNetworkEndpointGroupRequest.create = function create(properties) {
                            return new DeleteRegionNetworkEndpointGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteRegionNetworkEndpointGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionNetworkEndpointGroupRequest} message DeleteRegionNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionNetworkEndpointGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.networkEndpointGroup != null && Object.hasOwnProperty.call(message, "networkEndpointGroup"))
                                writer.uint32(/* id 433907078, wireType 2 =*/3471256626).string(message.networkEndpointGroup);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteRegionNetworkEndpointGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionNetworkEndpointGroupRequest} message DeleteRegionNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionNetworkEndpointGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteRegionNetworkEndpointGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest} DeleteRegionNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionNetworkEndpointGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 433907078: {
                                        message.networkEndpointGroup = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteRegionNetworkEndpointGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest} DeleteRegionNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionNetworkEndpointGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteRegionNetworkEndpointGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteRegionNetworkEndpointGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                if (!$util.isString(message.networkEndpointGroup))
                                    return "networkEndpointGroup: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteRegionNetworkEndpointGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest} DeleteRegionNetworkEndpointGroupRequest
                         */
                        DeleteRegionNetworkEndpointGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest();
                            if (object.networkEndpointGroup != null)
                                message.networkEndpointGroup = String(object.networkEndpointGroup);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteRegionNetworkEndpointGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest} message DeleteRegionNetworkEndpointGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteRegionNetworkEndpointGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.networkEndpointGroup = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                object.networkEndpointGroup = message.networkEndpointGroup;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteRegionNetworkEndpointGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteRegionNetworkEndpointGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteRegionNetworkEndpointGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteRegionNetworkEndpointGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest";
                        };
    
                        return DeleteRegionNetworkEndpointGroupRequest;
                    })();
    
                    v1.DeleteRegionNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a DeleteRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteRegionNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] DeleteRegionNetworkFirewallPolicyRequest firewallPolicy
                         * @property {string|null} [project] DeleteRegionNetworkFirewallPolicyRequest project
                         * @property {string|null} [region] DeleteRegionNetworkFirewallPolicyRequest region
                         * @property {string|null} [requestId] DeleteRegionNetworkFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteRegionNetworkFirewallPolicyRequest.
                         * @implements IDeleteRegionNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function DeleteRegionNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteRegionNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        DeleteRegionNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * DeleteRegionNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        DeleteRegionNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * DeleteRegionNetworkFirewallPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        DeleteRegionNetworkFirewallPolicyRequest.prototype.region = "";
    
                        /**
                         * DeleteRegionNetworkFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        DeleteRegionNetworkFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteRegionNetworkFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteRegionNetworkFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteRegionNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest} DeleteRegionNetworkFirewallPolicyRequest instance
                         */
                        DeleteRegionNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new DeleteRegionNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteRegionNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionNetworkFirewallPolicyRequest} message DeleteRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteRegionNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionNetworkFirewallPolicyRequest} message DeleteRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteRegionNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest} DeleteRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteRegionNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest} DeleteRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteRegionNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteRegionNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteRegionNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest} DeleteRegionNetworkFirewallPolicyRequest
                         */
                        DeleteRegionNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteRegionNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest} message DeleteRegionNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteRegionNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.firewallPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteRegionNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteRegionNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteRegionNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteRegionNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest";
                        };
    
                        return DeleteRegionNetworkFirewallPolicyRequest;
                    })();
    
                    v1.DeleteRegionNotificationEndpointRequest = (function() {
    
                        /**
                         * Properties of a DeleteRegionNotificationEndpointRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteRegionNotificationEndpointRequest
                         * @property {string|null} [notificationEndpoint] DeleteRegionNotificationEndpointRequest notificationEndpoint
                         * @property {string|null} [project] DeleteRegionNotificationEndpointRequest project
                         * @property {string|null} [region] DeleteRegionNotificationEndpointRequest region
                         * @property {string|null} [requestId] DeleteRegionNotificationEndpointRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteRegionNotificationEndpointRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteRegionNotificationEndpointRequest.
                         * @implements IDeleteRegionNotificationEndpointRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteRegionNotificationEndpointRequest=} [properties] Properties to set
                         */
                        function DeleteRegionNotificationEndpointRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteRegionNotificationEndpointRequest notificationEndpoint.
                         * @member {string} notificationEndpoint
                         * @memberof google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest
                         * @instance
                         */
                        DeleteRegionNotificationEndpointRequest.prototype.notificationEndpoint = "";
    
                        /**
                         * DeleteRegionNotificationEndpointRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest
                         * @instance
                         */
                        DeleteRegionNotificationEndpointRequest.prototype.project = "";
    
                        /**
                         * DeleteRegionNotificationEndpointRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest
                         * @instance
                         */
                        DeleteRegionNotificationEndpointRequest.prototype.region = "";
    
                        /**
                         * DeleteRegionNotificationEndpointRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest
                         * @instance
                         */
                        DeleteRegionNotificationEndpointRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteRegionNotificationEndpointRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteRegionNotificationEndpointRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteRegionNotificationEndpointRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionNotificationEndpointRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest} DeleteRegionNotificationEndpointRequest instance
                         */
                        DeleteRegionNotificationEndpointRequest.create = function create(properties) {
                            return new DeleteRegionNotificationEndpointRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteRegionNotificationEndpointRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionNotificationEndpointRequest} message DeleteRegionNotificationEndpointRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionNotificationEndpointRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.notificationEndpoint != null && Object.hasOwnProperty.call(message, "notificationEndpoint"))
                                writer.uint32(/* id 376807017, wireType 2 =*/3014456138).string(message.notificationEndpoint);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteRegionNotificationEndpointRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionNotificationEndpointRequest} message DeleteRegionNotificationEndpointRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionNotificationEndpointRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteRegionNotificationEndpointRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest} DeleteRegionNotificationEndpointRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionNotificationEndpointRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 376807017: {
                                        message.notificationEndpoint = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteRegionNotificationEndpointRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest} DeleteRegionNotificationEndpointRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionNotificationEndpointRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteRegionNotificationEndpointRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteRegionNotificationEndpointRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.notificationEndpoint != null && message.hasOwnProperty("notificationEndpoint"))
                                if (!$util.isString(message.notificationEndpoint))
                                    return "notificationEndpoint: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteRegionNotificationEndpointRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest} DeleteRegionNotificationEndpointRequest
                         */
                        DeleteRegionNotificationEndpointRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest();
                            if (object.notificationEndpoint != null)
                                message.notificationEndpoint = String(object.notificationEndpoint);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteRegionNotificationEndpointRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest} message DeleteRegionNotificationEndpointRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteRegionNotificationEndpointRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.notificationEndpoint = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.notificationEndpoint != null && message.hasOwnProperty("notificationEndpoint"))
                                object.notificationEndpoint = message.notificationEndpoint;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteRegionNotificationEndpointRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteRegionNotificationEndpointRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteRegionNotificationEndpointRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteRegionNotificationEndpointRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest";
                        };
    
                        return DeleteRegionNotificationEndpointRequest;
                    })();
    
                    v1.DeleteRegionOperationRequest = (function() {
    
                        /**
                         * Properties of a DeleteRegionOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteRegionOperationRequest
                         * @property {string|null} [operation] DeleteRegionOperationRequest operation
                         * @property {string|null} [project] DeleteRegionOperationRequest project
                         * @property {string|null} [region] DeleteRegionOperationRequest region
                         */
    
                        /**
                         * Constructs a new DeleteRegionOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteRegionOperationRequest.
                         * @implements IDeleteRegionOperationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteRegionOperationRequest=} [properties] Properties to set
                         */
                        function DeleteRegionOperationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteRegionOperationRequest operation.
                         * @member {string} operation
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationRequest
                         * @instance
                         */
                        DeleteRegionOperationRequest.prototype.operation = "";
    
                        /**
                         * DeleteRegionOperationRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationRequest
                         * @instance
                         */
                        DeleteRegionOperationRequest.prototype.project = "";
    
                        /**
                         * DeleteRegionOperationRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationRequest
                         * @instance
                         */
                        DeleteRegionOperationRequest.prototype.region = "";
    
                        /**
                         * Creates a new DeleteRegionOperationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionOperationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteRegionOperationRequest} DeleteRegionOperationRequest instance
                         */
                        DeleteRegionOperationRequest.create = function create(properties) {
                            return new DeleteRegionOperationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteRegionOperationRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionOperationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionOperationRequest} message DeleteRegionOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionOperationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operation != null && Object.hasOwnProperty.call(message, "operation"))
                                writer.uint32(/* id 52090215, wireType 2 =*/416721722).string(message.operation);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteRegionOperationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionOperationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionOperationRequest} message DeleteRegionOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionOperationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteRegionOperationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteRegionOperationRequest} DeleteRegionOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionOperationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteRegionOperationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 52090215: {
                                        message.operation = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteRegionOperationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteRegionOperationRequest} DeleteRegionOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionOperationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteRegionOperationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteRegionOperationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                if (!$util.isString(message.operation))
                                    return "operation: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteRegionOperationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteRegionOperationRequest} DeleteRegionOperationRequest
                         */
                        DeleteRegionOperationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteRegionOperationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteRegionOperationRequest();
                            if (object.operation != null)
                                message.operation = String(object.operation);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteRegionOperationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteRegionOperationRequest} message DeleteRegionOperationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteRegionOperationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.operation = "";
                                object.region = "";
                                object.project = "";
                            }
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                object.operation = message.operation;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteRegionOperationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteRegionOperationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteRegionOperationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteRegionOperationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteRegionOperationRequest";
                        };
    
                        return DeleteRegionOperationRequest;
                    })();
    
                    v1.DeleteRegionOperationResponse = (function() {
    
                        /**
                         * Properties of a DeleteRegionOperationResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteRegionOperationResponse
                         */
    
                        /**
                         * Constructs a new DeleteRegionOperationResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteRegionOperationResponse.
                         * @implements IDeleteRegionOperationResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteRegionOperationResponse=} [properties] Properties to set
                         */
                        function DeleteRegionOperationResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Creates a new DeleteRegionOperationResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationResponse
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionOperationResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteRegionOperationResponse} DeleteRegionOperationResponse instance
                         */
                        DeleteRegionOperationResponse.create = function create(properties) {
                            return new DeleteRegionOperationResponse(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteRegionOperationResponse message. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionOperationResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationResponse
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionOperationResponse} message DeleteRegionOperationResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionOperationResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteRegionOperationResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionOperationResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationResponse
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionOperationResponse} message DeleteRegionOperationResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionOperationResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteRegionOperationResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteRegionOperationResponse} DeleteRegionOperationResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionOperationResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteRegionOperationResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteRegionOperationResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteRegionOperationResponse} DeleteRegionOperationResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionOperationResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteRegionOperationResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteRegionOperationResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteRegionOperationResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteRegionOperationResponse} DeleteRegionOperationResponse
                         */
                        DeleteRegionOperationResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteRegionOperationResponse)
                                return object;
                            return new $root.google.cloud.compute.v1.DeleteRegionOperationResponse();
                        };
    
                        /**
                         * Creates a plain object from a DeleteRegionOperationResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationResponse
                         * @static
                         * @param {google.cloud.compute.v1.DeleteRegionOperationResponse} message DeleteRegionOperationResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteRegionOperationResponse.toObject = function toObject() {
                            return {};
                        };
    
                        /**
                         * Converts this DeleteRegionOperationResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteRegionOperationResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteRegionOperationResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteRegionOperationResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteRegionOperationResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteRegionOperationResponse";
                        };
    
                        return DeleteRegionOperationResponse;
                    })();
    
                    v1.DeleteRegionSecurityPolicyRequest = (function() {
    
                        /**
                         * Properties of a DeleteRegionSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteRegionSecurityPolicyRequest
                         * @property {string|null} [project] DeleteRegionSecurityPolicyRequest project
                         * @property {string|null} [region] DeleteRegionSecurityPolicyRequest region
                         * @property {string|null} [requestId] DeleteRegionSecurityPolicyRequest requestId
                         * @property {string|null} [securityPolicy] DeleteRegionSecurityPolicyRequest securityPolicy
                         */
    
                        /**
                         * Constructs a new DeleteRegionSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteRegionSecurityPolicyRequest.
                         * @implements IDeleteRegionSecurityPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteRegionSecurityPolicyRequest=} [properties] Properties to set
                         */
                        function DeleteRegionSecurityPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteRegionSecurityPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest
                         * @instance
                         */
                        DeleteRegionSecurityPolicyRequest.prototype.project = "";
    
                        /**
                         * DeleteRegionSecurityPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest
                         * @instance
                         */
                        DeleteRegionSecurityPolicyRequest.prototype.region = "";
    
                        /**
                         * DeleteRegionSecurityPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest
                         * @instance
                         */
                        DeleteRegionSecurityPolicyRequest.prototype.requestId = null;
    
                        /**
                         * DeleteRegionSecurityPolicyRequest securityPolicy.
                         * @member {string} securityPolicy
                         * @memberof google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest
                         * @instance
                         */
                        DeleteRegionSecurityPolicyRequest.prototype.securityPolicy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteRegionSecurityPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteRegionSecurityPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteRegionSecurityPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionSecurityPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest} DeleteRegionSecurityPolicyRequest instance
                         */
                        DeleteRegionSecurityPolicyRequest.create = function create(properties) {
                            return new DeleteRegionSecurityPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteRegionSecurityPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionSecurityPolicyRequest} message DeleteRegionSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionSecurityPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.securityPolicy != null && Object.hasOwnProperty.call(message, "securityPolicy"))
                                writer.uint32(/* id 171082513, wireType 2 =*/1368660106).string(message.securityPolicy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteRegionSecurityPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionSecurityPolicyRequest} message DeleteRegionSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionSecurityPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteRegionSecurityPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest} DeleteRegionSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionSecurityPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 171082513: {
                                        message.securityPolicy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteRegionSecurityPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest} DeleteRegionSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionSecurityPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteRegionSecurityPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteRegionSecurityPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy"))
                                if (!$util.isString(message.securityPolicy))
                                    return "securityPolicy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteRegionSecurityPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest} DeleteRegionSecurityPolicyRequest
                         */
                        DeleteRegionSecurityPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.securityPolicy != null)
                                message.securityPolicy = String(object.securityPolicy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteRegionSecurityPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest} message DeleteRegionSecurityPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteRegionSecurityPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.securityPolicy = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy"))
                                object.securityPolicy = message.securityPolicy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteRegionSecurityPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteRegionSecurityPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteRegionSecurityPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteRegionSecurityPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest";
                        };
    
                        return DeleteRegionSecurityPolicyRequest;
                    })();
    
                    v1.DeleteRegionSslCertificateRequest = (function() {
    
                        /**
                         * Properties of a DeleteRegionSslCertificateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteRegionSslCertificateRequest
                         * @property {string|null} [project] DeleteRegionSslCertificateRequest project
                         * @property {string|null} [region] DeleteRegionSslCertificateRequest region
                         * @property {string|null} [requestId] DeleteRegionSslCertificateRequest requestId
                         * @property {string|null} [sslCertificate] DeleteRegionSslCertificateRequest sslCertificate
                         */
    
                        /**
                         * Constructs a new DeleteRegionSslCertificateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteRegionSslCertificateRequest.
                         * @implements IDeleteRegionSslCertificateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteRegionSslCertificateRequest=} [properties] Properties to set
                         */
                        function DeleteRegionSslCertificateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteRegionSslCertificateRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteRegionSslCertificateRequest
                         * @instance
                         */
                        DeleteRegionSslCertificateRequest.prototype.project = "";
    
                        /**
                         * DeleteRegionSslCertificateRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteRegionSslCertificateRequest
                         * @instance
                         */
                        DeleteRegionSslCertificateRequest.prototype.region = "";
    
                        /**
                         * DeleteRegionSslCertificateRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionSslCertificateRequest
                         * @instance
                         */
                        DeleteRegionSslCertificateRequest.prototype.requestId = null;
    
                        /**
                         * DeleteRegionSslCertificateRequest sslCertificate.
                         * @member {string} sslCertificate
                         * @memberof google.cloud.compute.v1.DeleteRegionSslCertificateRequest
                         * @instance
                         */
                        DeleteRegionSslCertificateRequest.prototype.sslCertificate = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteRegionSslCertificateRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionSslCertificateRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteRegionSslCertificateRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteRegionSslCertificateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteRegionSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionSslCertificateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteRegionSslCertificateRequest} DeleteRegionSslCertificateRequest instance
                         */
                        DeleteRegionSslCertificateRequest.create = function create(properties) {
                            return new DeleteRegionSslCertificateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteRegionSslCertificateRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionSslCertificateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteRegionSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionSslCertificateRequest} message DeleteRegionSslCertificateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionSslCertificateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.sslCertificate != null && Object.hasOwnProperty.call(message, "sslCertificate"))
                                writer.uint32(/* id 46443492, wireType 2 =*/371547938).string(message.sslCertificate);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteRegionSslCertificateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionSslCertificateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionSslCertificateRequest} message DeleteRegionSslCertificateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionSslCertificateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteRegionSslCertificateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteRegionSslCertificateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteRegionSslCertificateRequest} DeleteRegionSslCertificateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionSslCertificateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteRegionSslCertificateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 46443492: {
                                        message.sslCertificate = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteRegionSslCertificateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionSslCertificateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteRegionSslCertificateRequest} DeleteRegionSslCertificateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionSslCertificateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteRegionSslCertificateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteRegionSslCertificateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteRegionSslCertificateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.sslCertificate != null && message.hasOwnProperty("sslCertificate"))
                                if (!$util.isString(message.sslCertificate))
                                    return "sslCertificate: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteRegionSslCertificateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteRegionSslCertificateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteRegionSslCertificateRequest} DeleteRegionSslCertificateRequest
                         */
                        DeleteRegionSslCertificateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteRegionSslCertificateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteRegionSslCertificateRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.sslCertificate != null)
                                message.sslCertificate = String(object.sslCertificate);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteRegionSslCertificateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteRegionSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteRegionSslCertificateRequest} message DeleteRegionSslCertificateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteRegionSslCertificateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.sslCertificate = "";
                                object.region = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.sslCertificate != null && message.hasOwnProperty("sslCertificate"))
                                object.sslCertificate = message.sslCertificate;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteRegionSslCertificateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteRegionSslCertificateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteRegionSslCertificateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteRegionSslCertificateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteRegionSslCertificateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteRegionSslCertificateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteRegionSslCertificateRequest";
                        };
    
                        return DeleteRegionSslCertificateRequest;
                    })();
    
                    v1.DeleteRegionSslPolicyRequest = (function() {
    
                        /**
                         * Properties of a DeleteRegionSslPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteRegionSslPolicyRequest
                         * @property {string|null} [project] DeleteRegionSslPolicyRequest project
                         * @property {string|null} [region] DeleteRegionSslPolicyRequest region
                         * @property {string|null} [requestId] DeleteRegionSslPolicyRequest requestId
                         * @property {string|null} [sslPolicy] DeleteRegionSslPolicyRequest sslPolicy
                         */
    
                        /**
                         * Constructs a new DeleteRegionSslPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteRegionSslPolicyRequest.
                         * @implements IDeleteRegionSslPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteRegionSslPolicyRequest=} [properties] Properties to set
                         */
                        function DeleteRegionSslPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteRegionSslPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteRegionSslPolicyRequest
                         * @instance
                         */
                        DeleteRegionSslPolicyRequest.prototype.project = "";
    
                        /**
                         * DeleteRegionSslPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteRegionSslPolicyRequest
                         * @instance
                         */
                        DeleteRegionSslPolicyRequest.prototype.region = "";
    
                        /**
                         * DeleteRegionSslPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionSslPolicyRequest
                         * @instance
                         */
                        DeleteRegionSslPolicyRequest.prototype.requestId = null;
    
                        /**
                         * DeleteRegionSslPolicyRequest sslPolicy.
                         * @member {string} sslPolicy
                         * @memberof google.cloud.compute.v1.DeleteRegionSslPolicyRequest
                         * @instance
                         */
                        DeleteRegionSslPolicyRequest.prototype.sslPolicy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteRegionSslPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionSslPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteRegionSslPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteRegionSslPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteRegionSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionSslPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteRegionSslPolicyRequest} DeleteRegionSslPolicyRequest instance
                         */
                        DeleteRegionSslPolicyRequest.create = function create(properties) {
                            return new DeleteRegionSslPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteRegionSslPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionSslPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteRegionSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionSslPolicyRequest} message DeleteRegionSslPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionSslPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.sslPolicy != null && Object.hasOwnProperty.call(message, "sslPolicy"))
                                writer.uint32(/* id 295190213, wireType 2 =*/2361521706).string(message.sslPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteRegionSslPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionSslPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionSslPolicyRequest} message DeleteRegionSslPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionSslPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteRegionSslPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteRegionSslPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteRegionSslPolicyRequest} DeleteRegionSslPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionSslPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteRegionSslPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 295190213: {
                                        message.sslPolicy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteRegionSslPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionSslPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteRegionSslPolicyRequest} DeleteRegionSslPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionSslPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteRegionSslPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteRegionSslPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteRegionSslPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.sslPolicy != null && message.hasOwnProperty("sslPolicy"))
                                if (!$util.isString(message.sslPolicy))
                                    return "sslPolicy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteRegionSslPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteRegionSslPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteRegionSslPolicyRequest} DeleteRegionSslPolicyRequest
                         */
                        DeleteRegionSslPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteRegionSslPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteRegionSslPolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.sslPolicy != null)
                                message.sslPolicy = String(object.sslPolicy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteRegionSslPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteRegionSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteRegionSslPolicyRequest} message DeleteRegionSslPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteRegionSslPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.sslPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.sslPolicy != null && message.hasOwnProperty("sslPolicy"))
                                object.sslPolicy = message.sslPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteRegionSslPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteRegionSslPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteRegionSslPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteRegionSslPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteRegionSslPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteRegionSslPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteRegionSslPolicyRequest";
                        };
    
                        return DeleteRegionSslPolicyRequest;
                    })();
    
                    v1.DeleteRegionTargetHttpProxyRequest = (function() {
    
                        /**
                         * Properties of a DeleteRegionTargetHttpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteRegionTargetHttpProxyRequest
                         * @property {string|null} [project] DeleteRegionTargetHttpProxyRequest project
                         * @property {string|null} [region] DeleteRegionTargetHttpProxyRequest region
                         * @property {string|null} [requestId] DeleteRegionTargetHttpProxyRequest requestId
                         * @property {string|null} [targetHttpProxy] DeleteRegionTargetHttpProxyRequest targetHttpProxy
                         */
    
                        /**
                         * Constructs a new DeleteRegionTargetHttpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteRegionTargetHttpProxyRequest.
                         * @implements IDeleteRegionTargetHttpProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteRegionTargetHttpProxyRequest=} [properties] Properties to set
                         */
                        function DeleteRegionTargetHttpProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteRegionTargetHttpProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest
                         * @instance
                         */
                        DeleteRegionTargetHttpProxyRequest.prototype.project = "";
    
                        /**
                         * DeleteRegionTargetHttpProxyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest
                         * @instance
                         */
                        DeleteRegionTargetHttpProxyRequest.prototype.region = "";
    
                        /**
                         * DeleteRegionTargetHttpProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest
                         * @instance
                         */
                        DeleteRegionTargetHttpProxyRequest.prototype.requestId = null;
    
                        /**
                         * DeleteRegionTargetHttpProxyRequest targetHttpProxy.
                         * @member {string} targetHttpProxy
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest
                         * @instance
                         */
                        DeleteRegionTargetHttpProxyRequest.prototype.targetHttpProxy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteRegionTargetHttpProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteRegionTargetHttpProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteRegionTargetHttpProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionTargetHttpProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest} DeleteRegionTargetHttpProxyRequest instance
                         */
                        DeleteRegionTargetHttpProxyRequest.create = function create(properties) {
                            return new DeleteRegionTargetHttpProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteRegionTargetHttpProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionTargetHttpProxyRequest} message DeleteRegionTargetHttpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionTargetHttpProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.targetHttpProxy != null && Object.hasOwnProperty.call(message, "targetHttpProxy"))
                                writer.uint32(/* id 206872421, wireType 2 =*/1654979370).string(message.targetHttpProxy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteRegionTargetHttpProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionTargetHttpProxyRequest} message DeleteRegionTargetHttpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionTargetHttpProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteRegionTargetHttpProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest} DeleteRegionTargetHttpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionTargetHttpProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 206872421: {
                                        message.targetHttpProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteRegionTargetHttpProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest} DeleteRegionTargetHttpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionTargetHttpProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteRegionTargetHttpProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteRegionTargetHttpProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetHttpProxy != null && message.hasOwnProperty("targetHttpProxy"))
                                if (!$util.isString(message.targetHttpProxy))
                                    return "targetHttpProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteRegionTargetHttpProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest} DeleteRegionTargetHttpProxyRequest
                         */
                        DeleteRegionTargetHttpProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetHttpProxy != null)
                                message.targetHttpProxy = String(object.targetHttpProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteRegionTargetHttpProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest} message DeleteRegionTargetHttpProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteRegionTargetHttpProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.targetHttpProxy = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.targetHttpProxy != null && message.hasOwnProperty("targetHttpProxy"))
                                object.targetHttpProxy = message.targetHttpProxy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteRegionTargetHttpProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteRegionTargetHttpProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteRegionTargetHttpProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteRegionTargetHttpProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest";
                        };
    
                        return DeleteRegionTargetHttpProxyRequest;
                    })();
    
                    v1.DeleteRegionTargetHttpsProxyRequest = (function() {
    
                        /**
                         * Properties of a DeleteRegionTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteRegionTargetHttpsProxyRequest
                         * @property {string|null} [project] DeleteRegionTargetHttpsProxyRequest project
                         * @property {string|null} [region] DeleteRegionTargetHttpsProxyRequest region
                         * @property {string|null} [requestId] DeleteRegionTargetHttpsProxyRequest requestId
                         * @property {string|null} [targetHttpsProxy] DeleteRegionTargetHttpsProxyRequest targetHttpsProxy
                         */
    
                        /**
                         * Constructs a new DeleteRegionTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteRegionTargetHttpsProxyRequest.
                         * @implements IDeleteRegionTargetHttpsProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteRegionTargetHttpsProxyRequest=} [properties] Properties to set
                         */
                        function DeleteRegionTargetHttpsProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteRegionTargetHttpsProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        DeleteRegionTargetHttpsProxyRequest.prototype.project = "";
    
                        /**
                         * DeleteRegionTargetHttpsProxyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        DeleteRegionTargetHttpsProxyRequest.prototype.region = "";
    
                        /**
                         * DeleteRegionTargetHttpsProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        DeleteRegionTargetHttpsProxyRequest.prototype.requestId = null;
    
                        /**
                         * DeleteRegionTargetHttpsProxyRequest targetHttpsProxy.
                         * @member {string} targetHttpsProxy
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        DeleteRegionTargetHttpsProxyRequest.prototype.targetHttpsProxy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteRegionTargetHttpsProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteRegionTargetHttpsProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteRegionTargetHttpsProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionTargetHttpsProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest} DeleteRegionTargetHttpsProxyRequest instance
                         */
                        DeleteRegionTargetHttpsProxyRequest.create = function create(properties) {
                            return new DeleteRegionTargetHttpsProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteRegionTargetHttpsProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionTargetHttpsProxyRequest} message DeleteRegionTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionTargetHttpsProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetHttpsProxy != null && Object.hasOwnProperty.call(message, "targetHttpsProxy"))
                                writer.uint32(/* id 52336748, wireType 2 =*/418693986).string(message.targetHttpsProxy);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteRegionTargetHttpsProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionTargetHttpsProxyRequest} message DeleteRegionTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionTargetHttpsProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteRegionTargetHttpsProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest} DeleteRegionTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionTargetHttpsProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 52336748: {
                                        message.targetHttpsProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteRegionTargetHttpsProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest} DeleteRegionTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionTargetHttpsProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteRegionTargetHttpsProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteRegionTargetHttpsProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                if (!$util.isString(message.targetHttpsProxy))
                                    return "targetHttpsProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteRegionTargetHttpsProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest} DeleteRegionTargetHttpsProxyRequest
                         */
                        DeleteRegionTargetHttpsProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetHttpsProxy != null)
                                message.targetHttpsProxy = String(object.targetHttpsProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteRegionTargetHttpsProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest} message DeleteRegionTargetHttpsProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteRegionTargetHttpsProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetHttpsProxy = "";
                                object.region = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                object.targetHttpsProxy = message.targetHttpsProxy;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteRegionTargetHttpsProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteRegionTargetHttpsProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteRegionTargetHttpsProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteRegionTargetHttpsProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest";
                        };
    
                        return DeleteRegionTargetHttpsProxyRequest;
                    })();
    
                    v1.DeleteRegionTargetTcpProxyRequest = (function() {
    
                        /**
                         * Properties of a DeleteRegionTargetTcpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteRegionTargetTcpProxyRequest
                         * @property {string|null} [project] DeleteRegionTargetTcpProxyRequest project
                         * @property {string|null} [region] DeleteRegionTargetTcpProxyRequest region
                         * @property {string|null} [requestId] DeleteRegionTargetTcpProxyRequest requestId
                         * @property {string|null} [targetTcpProxy] DeleteRegionTargetTcpProxyRequest targetTcpProxy
                         */
    
                        /**
                         * Constructs a new DeleteRegionTargetTcpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteRegionTargetTcpProxyRequest.
                         * @implements IDeleteRegionTargetTcpProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteRegionTargetTcpProxyRequest=} [properties] Properties to set
                         */
                        function DeleteRegionTargetTcpProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteRegionTargetTcpProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest
                         * @instance
                         */
                        DeleteRegionTargetTcpProxyRequest.prototype.project = "";
    
                        /**
                         * DeleteRegionTargetTcpProxyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest
                         * @instance
                         */
                        DeleteRegionTargetTcpProxyRequest.prototype.region = "";
    
                        /**
                         * DeleteRegionTargetTcpProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest
                         * @instance
                         */
                        DeleteRegionTargetTcpProxyRequest.prototype.requestId = null;
    
                        /**
                         * DeleteRegionTargetTcpProxyRequest targetTcpProxy.
                         * @member {string} targetTcpProxy
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest
                         * @instance
                         */
                        DeleteRegionTargetTcpProxyRequest.prototype.targetTcpProxy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteRegionTargetTcpProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteRegionTargetTcpProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteRegionTargetTcpProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionTargetTcpProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest} DeleteRegionTargetTcpProxyRequest instance
                         */
                        DeleteRegionTargetTcpProxyRequest.create = function create(properties) {
                            return new DeleteRegionTargetTcpProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteRegionTargetTcpProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionTargetTcpProxyRequest} message DeleteRegionTargetTcpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionTargetTcpProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetTcpProxy != null && Object.hasOwnProperty.call(message, "targetTcpProxy"))
                                writer.uint32(/* id 503065442, wireType 2 =*/4024523538).string(message.targetTcpProxy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteRegionTargetTcpProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionTargetTcpProxyRequest} message DeleteRegionTargetTcpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionTargetTcpProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteRegionTargetTcpProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest} DeleteRegionTargetTcpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionTargetTcpProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 503065442: {
                                        message.targetTcpProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteRegionTargetTcpProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest} DeleteRegionTargetTcpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionTargetTcpProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteRegionTargetTcpProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteRegionTargetTcpProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetTcpProxy != null && message.hasOwnProperty("targetTcpProxy"))
                                if (!$util.isString(message.targetTcpProxy))
                                    return "targetTcpProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteRegionTargetTcpProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest} DeleteRegionTargetTcpProxyRequest
                         */
                        DeleteRegionTargetTcpProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetTcpProxy != null)
                                message.targetTcpProxy = String(object.targetTcpProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteRegionTargetTcpProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest} message DeleteRegionTargetTcpProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteRegionTargetTcpProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.targetTcpProxy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetTcpProxy != null && message.hasOwnProperty("targetTcpProxy"))
                                object.targetTcpProxy = message.targetTcpProxy;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteRegionTargetTcpProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteRegionTargetTcpProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteRegionTargetTcpProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteRegionTargetTcpProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest";
                        };
    
                        return DeleteRegionTargetTcpProxyRequest;
                    })();
    
                    v1.DeleteRegionUrlMapRequest = (function() {
    
                        /**
                         * Properties of a DeleteRegionUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteRegionUrlMapRequest
                         * @property {string|null} [project] DeleteRegionUrlMapRequest project
                         * @property {string|null} [region] DeleteRegionUrlMapRequest region
                         * @property {string|null} [requestId] DeleteRegionUrlMapRequest requestId
                         * @property {string|null} [urlMap] DeleteRegionUrlMapRequest urlMap
                         */
    
                        /**
                         * Constructs a new DeleteRegionUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteRegionUrlMapRequest.
                         * @implements IDeleteRegionUrlMapRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteRegionUrlMapRequest=} [properties] Properties to set
                         */
                        function DeleteRegionUrlMapRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteRegionUrlMapRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteRegionUrlMapRequest
                         * @instance
                         */
                        DeleteRegionUrlMapRequest.prototype.project = "";
    
                        /**
                         * DeleteRegionUrlMapRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteRegionUrlMapRequest
                         * @instance
                         */
                        DeleteRegionUrlMapRequest.prototype.region = "";
    
                        /**
                         * DeleteRegionUrlMapRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionUrlMapRequest
                         * @instance
                         */
                        DeleteRegionUrlMapRequest.prototype.requestId = null;
    
                        /**
                         * DeleteRegionUrlMapRequest urlMap.
                         * @member {string} urlMap
                         * @memberof google.cloud.compute.v1.DeleteRegionUrlMapRequest
                         * @instance
                         */
                        DeleteRegionUrlMapRequest.prototype.urlMap = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteRegionUrlMapRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteRegionUrlMapRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteRegionUrlMapRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteRegionUrlMapRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionUrlMapRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteRegionUrlMapRequest} DeleteRegionUrlMapRequest instance
                         */
                        DeleteRegionUrlMapRequest.create = function create(properties) {
                            return new DeleteRegionUrlMapRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteRegionUrlMapRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionUrlMapRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionUrlMapRequest} message DeleteRegionUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionUrlMapRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.urlMap != null && Object.hasOwnProperty.call(message, "urlMap"))
                                writer.uint32(/* id 367020684, wireType 2 =*/2936165474).string(message.urlMap);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteRegionUrlMapRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteRegionUrlMapRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRegionUrlMapRequest} message DeleteRegionUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRegionUrlMapRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteRegionUrlMapRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteRegionUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteRegionUrlMapRequest} DeleteRegionUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionUrlMapRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteRegionUrlMapRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 367020684: {
                                        message.urlMap = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteRegionUrlMapRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRegionUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteRegionUrlMapRequest} DeleteRegionUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRegionUrlMapRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteRegionUrlMapRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteRegionUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteRegionUrlMapRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                if (!$util.isString(message.urlMap))
                                    return "urlMap: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteRegionUrlMapRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteRegionUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteRegionUrlMapRequest} DeleteRegionUrlMapRequest
                         */
                        DeleteRegionUrlMapRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteRegionUrlMapRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteRegionUrlMapRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.urlMap != null)
                                message.urlMap = String(object.urlMap);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteRegionUrlMapRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteRegionUrlMapRequest} message DeleteRegionUrlMapRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteRegionUrlMapRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.urlMap = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                object.urlMap = message.urlMap;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteRegionUrlMapRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteRegionUrlMapRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteRegionUrlMapRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteRegionUrlMapRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteRegionUrlMapRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteRegionUrlMapRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteRegionUrlMapRequest";
                        };
    
                        return DeleteRegionUrlMapRequest;
                    })();
    
                    v1.DeleteReservationRequest = (function() {
    
                        /**
                         * Properties of a DeleteReservationRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteReservationRequest
                         * @property {string|null} [project] DeleteReservationRequest project
                         * @property {string|null} [requestId] DeleteReservationRequest requestId
                         * @property {string|null} [reservation] DeleteReservationRequest reservation
                         * @property {string|null} [zone] DeleteReservationRequest zone
                         */
    
                        /**
                         * Constructs a new DeleteReservationRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteReservationRequest.
                         * @implements IDeleteReservationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteReservationRequest=} [properties] Properties to set
                         */
                        function DeleteReservationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteReservationRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteReservationRequest
                         * @instance
                         */
                        DeleteReservationRequest.prototype.project = "";
    
                        /**
                         * DeleteReservationRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteReservationRequest
                         * @instance
                         */
                        DeleteReservationRequest.prototype.requestId = null;
    
                        /**
                         * DeleteReservationRequest reservation.
                         * @member {string} reservation
                         * @memberof google.cloud.compute.v1.DeleteReservationRequest
                         * @instance
                         */
                        DeleteReservationRequest.prototype.reservation = "";
    
                        /**
                         * DeleteReservationRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.DeleteReservationRequest
                         * @instance
                         */
                        DeleteReservationRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteReservationRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteReservationRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteReservationRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteReservationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteReservationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteReservationRequest} DeleteReservationRequest instance
                         */
                        DeleteReservationRequest.create = function create(properties) {
                            return new DeleteReservationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteReservationRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteReservationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteReservationRequest} message DeleteReservationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteReservationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.reservation != null && Object.hasOwnProperty.call(message, "reservation"))
                                writer.uint32(/* id 47530956, wireType 2 =*/380247650).string(message.reservation);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteReservationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteReservationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteReservationRequest} message DeleteReservationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteReservationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteReservationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteReservationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteReservationRequest} DeleteReservationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteReservationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteReservationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 47530956: {
                                        message.reservation = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteReservationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteReservationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteReservationRequest} DeleteReservationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteReservationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteReservationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteReservationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteReservationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.reservation != null && message.hasOwnProperty("reservation"))
                                if (!$util.isString(message.reservation))
                                    return "reservation: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteReservationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteReservationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteReservationRequest} DeleteReservationRequest
                         */
                        DeleteReservationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteReservationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteReservationRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.reservation != null)
                                message.reservation = String(object.reservation);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteReservationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteReservationRequest} message DeleteReservationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteReservationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.reservation = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.reservation != null && message.hasOwnProperty("reservation"))
                                object.reservation = message.reservation;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteReservationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteReservationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteReservationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteReservationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteReservationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteReservationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteReservationRequest";
                        };
    
                        return DeleteReservationRequest;
                    })();
    
                    v1.DeleteResourcePolicyRequest = (function() {
    
                        /**
                         * Properties of a DeleteResourcePolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteResourcePolicyRequest
                         * @property {string|null} [project] DeleteResourcePolicyRequest project
                         * @property {string|null} [region] DeleteResourcePolicyRequest region
                         * @property {string|null} [requestId] DeleteResourcePolicyRequest requestId
                         * @property {string|null} [resourcePolicy] DeleteResourcePolicyRequest resourcePolicy
                         */
    
                        /**
                         * Constructs a new DeleteResourcePolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteResourcePolicyRequest.
                         * @implements IDeleteResourcePolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteResourcePolicyRequest=} [properties] Properties to set
                         */
                        function DeleteResourcePolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteResourcePolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteResourcePolicyRequest
                         * @instance
                         */
                        DeleteResourcePolicyRequest.prototype.project = "";
    
                        /**
                         * DeleteResourcePolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteResourcePolicyRequest
                         * @instance
                         */
                        DeleteResourcePolicyRequest.prototype.region = "";
    
                        /**
                         * DeleteResourcePolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteResourcePolicyRequest
                         * @instance
                         */
                        DeleteResourcePolicyRequest.prototype.requestId = null;
    
                        /**
                         * DeleteResourcePolicyRequest resourcePolicy.
                         * @member {string} resourcePolicy
                         * @memberof google.cloud.compute.v1.DeleteResourcePolicyRequest
                         * @instance
                         */
                        DeleteResourcePolicyRequest.prototype.resourcePolicy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteResourcePolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteResourcePolicyRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteResourcePolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteResourcePolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteResourcePolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteResourcePolicyRequest} DeleteResourcePolicyRequest instance
                         */
                        DeleteResourcePolicyRequest.create = function create(properties) {
                            return new DeleteResourcePolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteResourcePolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteResourcePolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteResourcePolicyRequest} message DeleteResourcePolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteResourcePolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resourcePolicy != null && Object.hasOwnProperty.call(message, "resourcePolicy"))
                                writer.uint32(/* id 159240835, wireType 2 =*/1273926682).string(message.resourcePolicy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteResourcePolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteResourcePolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteResourcePolicyRequest} message DeleteResourcePolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteResourcePolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteResourcePolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteResourcePolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteResourcePolicyRequest} DeleteResourcePolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteResourcePolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteResourcePolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 159240835: {
                                        message.resourcePolicy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteResourcePolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteResourcePolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteResourcePolicyRequest} DeleteResourcePolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteResourcePolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteResourcePolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteResourcePolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteResourcePolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.resourcePolicy != null && message.hasOwnProperty("resourcePolicy"))
                                if (!$util.isString(message.resourcePolicy))
                                    return "resourcePolicy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteResourcePolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteResourcePolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteResourcePolicyRequest} DeleteResourcePolicyRequest
                         */
                        DeleteResourcePolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteResourcePolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteResourcePolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.resourcePolicy != null)
                                message.resourcePolicy = String(object.resourcePolicy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteResourcePolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteResourcePolicyRequest} message DeleteResourcePolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteResourcePolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resourcePolicy = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resourcePolicy != null && message.hasOwnProperty("resourcePolicy"))
                                object.resourcePolicy = message.resourcePolicy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteResourcePolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteResourcePolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteResourcePolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteResourcePolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteResourcePolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteResourcePolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteResourcePolicyRequest";
                        };
    
                        return DeleteResourcePolicyRequest;
                    })();
    
                    v1.DeleteRouteRequest = (function() {
    
                        /**
                         * Properties of a DeleteRouteRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteRouteRequest
                         * @property {string|null} [project] DeleteRouteRequest project
                         * @property {string|null} [requestId] DeleteRouteRequest requestId
                         * @property {string|null} [route] DeleteRouteRequest route
                         */
    
                        /**
                         * Constructs a new DeleteRouteRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteRouteRequest.
                         * @implements IDeleteRouteRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteRouteRequest=} [properties] Properties to set
                         */
                        function DeleteRouteRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteRouteRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteRouteRequest
                         * @instance
                         */
                        DeleteRouteRequest.prototype.project = "";
    
                        /**
                         * DeleteRouteRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteRouteRequest
                         * @instance
                         */
                        DeleteRouteRequest.prototype.requestId = null;
    
                        /**
                         * DeleteRouteRequest route.
                         * @member {string} route
                         * @memberof google.cloud.compute.v1.DeleteRouteRequest
                         * @instance
                         */
                        DeleteRouteRequest.prototype.route = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteRouteRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteRouteRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteRouteRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteRouteRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteRouteRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRouteRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteRouteRequest} DeleteRouteRequest instance
                         */
                        DeleteRouteRequest.create = function create(properties) {
                            return new DeleteRouteRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteRouteRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteRouteRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteRouteRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRouteRequest} message DeleteRouteRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRouteRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.route != null && Object.hasOwnProperty.call(message, "route"))
                                writer.uint32(/* id 108704329, wireType 2 =*/869634634).string(message.route);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteRouteRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteRouteRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRouteRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRouteRequest} message DeleteRouteRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRouteRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteRouteRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteRouteRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteRouteRequest} DeleteRouteRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRouteRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteRouteRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 108704329: {
                                        message.route = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteRouteRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRouteRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteRouteRequest} DeleteRouteRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRouteRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteRouteRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteRouteRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteRouteRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.route != null && message.hasOwnProperty("route"))
                                if (!$util.isString(message.route))
                                    return "route: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteRouteRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteRouteRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteRouteRequest} DeleteRouteRequest
                         */
                        DeleteRouteRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteRouteRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteRouteRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.route != null)
                                message.route = String(object.route);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteRouteRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteRouteRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteRouteRequest} message DeleteRouteRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteRouteRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.route = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.route != null && message.hasOwnProperty("route"))
                                object.route = message.route;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteRouteRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteRouteRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteRouteRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteRouteRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteRouteRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteRouteRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteRouteRequest";
                        };
    
                        return DeleteRouteRequest;
                    })();
    
                    v1.DeleteRouterRequest = (function() {
    
                        /**
                         * Properties of a DeleteRouterRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteRouterRequest
                         * @property {string|null} [project] DeleteRouterRequest project
                         * @property {string|null} [region] DeleteRouterRequest region
                         * @property {string|null} [requestId] DeleteRouterRequest requestId
                         * @property {string|null} [router] DeleteRouterRequest router
                         */
    
                        /**
                         * Constructs a new DeleteRouterRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteRouterRequest.
                         * @implements IDeleteRouterRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteRouterRequest=} [properties] Properties to set
                         */
                        function DeleteRouterRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteRouterRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteRouterRequest
                         * @instance
                         */
                        DeleteRouterRequest.prototype.project = "";
    
                        /**
                         * DeleteRouterRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteRouterRequest
                         * @instance
                         */
                        DeleteRouterRequest.prototype.region = "";
    
                        /**
                         * DeleteRouterRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteRouterRequest
                         * @instance
                         */
                        DeleteRouterRequest.prototype.requestId = null;
    
                        /**
                         * DeleteRouterRequest router.
                         * @member {string} router
                         * @memberof google.cloud.compute.v1.DeleteRouterRequest
                         * @instance
                         */
                        DeleteRouterRequest.prototype.router = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteRouterRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteRouterRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteRouterRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteRouterRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRouterRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteRouterRequest} DeleteRouterRequest instance
                         */
                        DeleteRouterRequest.create = function create(properties) {
                            return new DeleteRouterRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteRouterRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteRouterRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRouterRequest} message DeleteRouterRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRouterRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.router != null && Object.hasOwnProperty.call(message, "router"))
                                writer.uint32(/* id 148608841, wireType 2 =*/1188870730).string(message.router);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteRouterRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteRouterRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteRouterRequest} message DeleteRouterRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteRouterRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteRouterRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteRouterRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteRouterRequest} DeleteRouterRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRouterRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteRouterRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 148608841: {
                                        message.router = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteRouterRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteRouterRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteRouterRequest} DeleteRouterRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteRouterRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteRouterRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteRouterRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteRouterRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.router != null && message.hasOwnProperty("router"))
                                if (!$util.isString(message.router))
                                    return "router: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteRouterRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteRouterRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteRouterRequest} DeleteRouterRequest
                         */
                        DeleteRouterRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteRouterRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteRouterRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.router != null)
                                message.router = String(object.router);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteRouterRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteRouterRequest} message DeleteRouterRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteRouterRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.router = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.router != null && message.hasOwnProperty("router"))
                                object.router = message.router;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteRouterRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteRouterRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteRouterRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteRouterRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteRouterRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteRouterRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteRouterRequest";
                        };
    
                        return DeleteRouterRequest;
                    })();
    
                    v1.DeleteSecurityPolicyRequest = (function() {
    
                        /**
                         * Properties of a DeleteSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteSecurityPolicyRequest
                         * @property {string|null} [project] DeleteSecurityPolicyRequest project
                         * @property {string|null} [requestId] DeleteSecurityPolicyRequest requestId
                         * @property {string|null} [securityPolicy] DeleteSecurityPolicyRequest securityPolicy
                         */
    
                        /**
                         * Constructs a new DeleteSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteSecurityPolicyRequest.
                         * @implements IDeleteSecurityPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteSecurityPolicyRequest=} [properties] Properties to set
                         */
                        function DeleteSecurityPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteSecurityPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteSecurityPolicyRequest
                         * @instance
                         */
                        DeleteSecurityPolicyRequest.prototype.project = "";
    
                        /**
                         * DeleteSecurityPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteSecurityPolicyRequest
                         * @instance
                         */
                        DeleteSecurityPolicyRequest.prototype.requestId = null;
    
                        /**
                         * DeleteSecurityPolicyRequest securityPolicy.
                         * @member {string} securityPolicy
                         * @memberof google.cloud.compute.v1.DeleteSecurityPolicyRequest
                         * @instance
                         */
                        DeleteSecurityPolicyRequest.prototype.securityPolicy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteSecurityPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteSecurityPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteSecurityPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteSecurityPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSecurityPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteSecurityPolicyRequest} DeleteSecurityPolicyRequest instance
                         */
                        DeleteSecurityPolicyRequest.create = function create(properties) {
                            return new DeleteSecurityPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteSecurityPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteSecurityPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSecurityPolicyRequest} message DeleteSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteSecurityPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.securityPolicy != null && Object.hasOwnProperty.call(message, "securityPolicy"))
                                writer.uint32(/* id 171082513, wireType 2 =*/1368660106).string(message.securityPolicy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteSecurityPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteSecurityPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSecurityPolicyRequest} message DeleteSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteSecurityPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteSecurityPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteSecurityPolicyRequest} DeleteSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteSecurityPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteSecurityPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 171082513: {
                                        message.securityPolicy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteSecurityPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteSecurityPolicyRequest} DeleteSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteSecurityPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteSecurityPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteSecurityPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy"))
                                if (!$util.isString(message.securityPolicy))
                                    return "securityPolicy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteSecurityPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteSecurityPolicyRequest} DeleteSecurityPolicyRequest
                         */
                        DeleteSecurityPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteSecurityPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteSecurityPolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.securityPolicy != null)
                                message.securityPolicy = String(object.securityPolicy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteSecurityPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteSecurityPolicyRequest} message DeleteSecurityPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteSecurityPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.securityPolicy = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy"))
                                object.securityPolicy = message.securityPolicy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteSecurityPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteSecurityPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteSecurityPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteSecurityPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteSecurityPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteSecurityPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteSecurityPolicyRequest";
                        };
    
                        return DeleteSecurityPolicyRequest;
                    })();
    
                    v1.DeleteServiceAttachmentRequest = (function() {
    
                        /**
                         * Properties of a DeleteServiceAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteServiceAttachmentRequest
                         * @property {string|null} [project] DeleteServiceAttachmentRequest project
                         * @property {string|null} [region] DeleteServiceAttachmentRequest region
                         * @property {string|null} [requestId] DeleteServiceAttachmentRequest requestId
                         * @property {string|null} [serviceAttachment] DeleteServiceAttachmentRequest serviceAttachment
                         */
    
                        /**
                         * Constructs a new DeleteServiceAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteServiceAttachmentRequest.
                         * @implements IDeleteServiceAttachmentRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteServiceAttachmentRequest=} [properties] Properties to set
                         */
                        function DeleteServiceAttachmentRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteServiceAttachmentRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteServiceAttachmentRequest
                         * @instance
                         */
                        DeleteServiceAttachmentRequest.prototype.project = "";
    
                        /**
                         * DeleteServiceAttachmentRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteServiceAttachmentRequest
                         * @instance
                         */
                        DeleteServiceAttachmentRequest.prototype.region = "";
    
                        /**
                         * DeleteServiceAttachmentRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteServiceAttachmentRequest
                         * @instance
                         */
                        DeleteServiceAttachmentRequest.prototype.requestId = null;
    
                        /**
                         * DeleteServiceAttachmentRequest serviceAttachment.
                         * @member {string} serviceAttachment
                         * @memberof google.cloud.compute.v1.DeleteServiceAttachmentRequest
                         * @instance
                         */
                        DeleteServiceAttachmentRequest.prototype.serviceAttachment = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteServiceAttachmentRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteServiceAttachmentRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteServiceAttachmentRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteServiceAttachmentRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteServiceAttachmentRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteServiceAttachmentRequest} DeleteServiceAttachmentRequest instance
                         */
                        DeleteServiceAttachmentRequest.create = function create(properties) {
                            return new DeleteServiceAttachmentRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteServiceAttachmentRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteServiceAttachmentRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteServiceAttachmentRequest} message DeleteServiceAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteServiceAttachmentRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.serviceAttachment != null && Object.hasOwnProperty.call(message, "serviceAttachment"))
                                writer.uint32(/* id 338957549, wireType 2 =*/2711660394).string(message.serviceAttachment);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteServiceAttachmentRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteServiceAttachmentRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteServiceAttachmentRequest} message DeleteServiceAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteServiceAttachmentRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteServiceAttachmentRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteServiceAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteServiceAttachmentRequest} DeleteServiceAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteServiceAttachmentRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteServiceAttachmentRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 338957549: {
                                        message.serviceAttachment = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteServiceAttachmentRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteServiceAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteServiceAttachmentRequest} DeleteServiceAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteServiceAttachmentRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteServiceAttachmentRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteServiceAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteServiceAttachmentRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.serviceAttachment != null && message.hasOwnProperty("serviceAttachment"))
                                if (!$util.isString(message.serviceAttachment))
                                    return "serviceAttachment: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteServiceAttachmentRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteServiceAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteServiceAttachmentRequest} DeleteServiceAttachmentRequest
                         */
                        DeleteServiceAttachmentRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteServiceAttachmentRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteServiceAttachmentRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.serviceAttachment != null)
                                message.serviceAttachment = String(object.serviceAttachment);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteServiceAttachmentRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteServiceAttachmentRequest} message DeleteServiceAttachmentRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteServiceAttachmentRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.serviceAttachment = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.serviceAttachment != null && message.hasOwnProperty("serviceAttachment"))
                                object.serviceAttachment = message.serviceAttachment;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteServiceAttachmentRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteServiceAttachmentRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteServiceAttachmentRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteServiceAttachmentRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteServiceAttachmentRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteServiceAttachmentRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteServiceAttachmentRequest";
                        };
    
                        return DeleteServiceAttachmentRequest;
                    })();
    
                    v1.DeleteSignedUrlKeyBackendBucketRequest = (function() {
    
                        /**
                         * Properties of a DeleteSignedUrlKeyBackendBucketRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteSignedUrlKeyBackendBucketRequest
                         * @property {string|null} [backendBucket] DeleteSignedUrlKeyBackendBucketRequest backendBucket
                         * @property {string|null} [keyName] DeleteSignedUrlKeyBackendBucketRequest keyName
                         * @property {string|null} [project] DeleteSignedUrlKeyBackendBucketRequest project
                         * @property {string|null} [requestId] DeleteSignedUrlKeyBackendBucketRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteSignedUrlKeyBackendBucketRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteSignedUrlKeyBackendBucketRequest.
                         * @implements IDeleteSignedUrlKeyBackendBucketRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteSignedUrlKeyBackendBucketRequest=} [properties] Properties to set
                         */
                        function DeleteSignedUrlKeyBackendBucketRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteSignedUrlKeyBackendBucketRequest backendBucket.
                         * @member {string} backendBucket
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest
                         * @instance
                         */
                        DeleteSignedUrlKeyBackendBucketRequest.prototype.backendBucket = "";
    
                        /**
                         * DeleteSignedUrlKeyBackendBucketRequest keyName.
                         * @member {string} keyName
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest
                         * @instance
                         */
                        DeleteSignedUrlKeyBackendBucketRequest.prototype.keyName = "";
    
                        /**
                         * DeleteSignedUrlKeyBackendBucketRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest
                         * @instance
                         */
                        DeleteSignedUrlKeyBackendBucketRequest.prototype.project = "";
    
                        /**
                         * DeleteSignedUrlKeyBackendBucketRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest
                         * @instance
                         */
                        DeleteSignedUrlKeyBackendBucketRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteSignedUrlKeyBackendBucketRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteSignedUrlKeyBackendBucketRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteSignedUrlKeyBackendBucketRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSignedUrlKeyBackendBucketRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest} DeleteSignedUrlKeyBackendBucketRequest instance
                         */
                        DeleteSignedUrlKeyBackendBucketRequest.create = function create(properties) {
                            return new DeleteSignedUrlKeyBackendBucketRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteSignedUrlKeyBackendBucketRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSignedUrlKeyBackendBucketRequest} message DeleteSignedUrlKeyBackendBucketRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteSignedUrlKeyBackendBucketRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.backendBucket != null && Object.hasOwnProperty.call(message, "backendBucket"))
                                writer.uint32(/* id 91714037, wireType 2 =*/733712298).string(message.backendBucket);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.keyName != null && Object.hasOwnProperty.call(message, "keyName"))
                                writer.uint32(/* id 500938859, wireType 2 =*/4007510874).string(message.keyName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteSignedUrlKeyBackendBucketRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSignedUrlKeyBackendBucketRequest} message DeleteSignedUrlKeyBackendBucketRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteSignedUrlKeyBackendBucketRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteSignedUrlKeyBackendBucketRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest} DeleteSignedUrlKeyBackendBucketRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteSignedUrlKeyBackendBucketRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 91714037: {
                                        message.backendBucket = reader.string();
                                        break;
                                    }
                                case 500938859: {
                                        message.keyName = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteSignedUrlKeyBackendBucketRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest} DeleteSignedUrlKeyBackendBucketRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteSignedUrlKeyBackendBucketRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteSignedUrlKeyBackendBucketRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteSignedUrlKeyBackendBucketRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendBucket != null && message.hasOwnProperty("backendBucket"))
                                if (!$util.isString(message.backendBucket))
                                    return "backendBucket: string expected";
                            if (message.keyName != null && message.hasOwnProperty("keyName"))
                                if (!$util.isString(message.keyName))
                                    return "keyName: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteSignedUrlKeyBackendBucketRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest} DeleteSignedUrlKeyBackendBucketRequest
                         */
                        DeleteSignedUrlKeyBackendBucketRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest();
                            if (object.backendBucket != null)
                                message.backendBucket = String(object.backendBucket);
                            if (object.keyName != null)
                                message.keyName = String(object.keyName);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteSignedUrlKeyBackendBucketRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest} message DeleteSignedUrlKeyBackendBucketRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteSignedUrlKeyBackendBucketRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.backendBucket = "";
                                object.project = "";
                                object.keyName = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.backendBucket != null && message.hasOwnProperty("backendBucket"))
                                object.backendBucket = message.backendBucket;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.keyName != null && message.hasOwnProperty("keyName"))
                                object.keyName = message.keyName;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteSignedUrlKeyBackendBucketRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteSignedUrlKeyBackendBucketRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteSignedUrlKeyBackendBucketRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteSignedUrlKeyBackendBucketRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest";
                        };
    
                        return DeleteSignedUrlKeyBackendBucketRequest;
                    })();
    
                    v1.DeleteSignedUrlKeyBackendServiceRequest = (function() {
    
                        /**
                         * Properties of a DeleteSignedUrlKeyBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteSignedUrlKeyBackendServiceRequest
                         * @property {string|null} [backendService] DeleteSignedUrlKeyBackendServiceRequest backendService
                         * @property {string|null} [keyName] DeleteSignedUrlKeyBackendServiceRequest keyName
                         * @property {string|null} [project] DeleteSignedUrlKeyBackendServiceRequest project
                         * @property {string|null} [requestId] DeleteSignedUrlKeyBackendServiceRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteSignedUrlKeyBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteSignedUrlKeyBackendServiceRequest.
                         * @implements IDeleteSignedUrlKeyBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteSignedUrlKeyBackendServiceRequest=} [properties] Properties to set
                         */
                        function DeleteSignedUrlKeyBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteSignedUrlKeyBackendServiceRequest backendService.
                         * @member {string} backendService
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest
                         * @instance
                         */
                        DeleteSignedUrlKeyBackendServiceRequest.prototype.backendService = "";
    
                        /**
                         * DeleteSignedUrlKeyBackendServiceRequest keyName.
                         * @member {string} keyName
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest
                         * @instance
                         */
                        DeleteSignedUrlKeyBackendServiceRequest.prototype.keyName = "";
    
                        /**
                         * DeleteSignedUrlKeyBackendServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest
                         * @instance
                         */
                        DeleteSignedUrlKeyBackendServiceRequest.prototype.project = "";
    
                        /**
                         * DeleteSignedUrlKeyBackendServiceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest
                         * @instance
                         */
                        DeleteSignedUrlKeyBackendServiceRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteSignedUrlKeyBackendServiceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteSignedUrlKeyBackendServiceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteSignedUrlKeyBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSignedUrlKeyBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest} DeleteSignedUrlKeyBackendServiceRequest instance
                         */
                        DeleteSignedUrlKeyBackendServiceRequest.create = function create(properties) {
                            return new DeleteSignedUrlKeyBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteSignedUrlKeyBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSignedUrlKeyBackendServiceRequest} message DeleteSignedUrlKeyBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteSignedUrlKeyBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.backendService != null && Object.hasOwnProperty.call(message, "backendService"))
                                writer.uint32(/* id 306946058, wireType 2 =*/2455568466).string(message.backendService);
                            if (message.keyName != null && Object.hasOwnProperty.call(message, "keyName"))
                                writer.uint32(/* id 500938859, wireType 2 =*/4007510874).string(message.keyName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteSignedUrlKeyBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSignedUrlKeyBackendServiceRequest} message DeleteSignedUrlKeyBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteSignedUrlKeyBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteSignedUrlKeyBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest} DeleteSignedUrlKeyBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteSignedUrlKeyBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 306946058: {
                                        message.backendService = reader.string();
                                        break;
                                    }
                                case 500938859: {
                                        message.keyName = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteSignedUrlKeyBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest} DeleteSignedUrlKeyBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteSignedUrlKeyBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteSignedUrlKeyBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteSignedUrlKeyBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                if (!$util.isString(message.backendService))
                                    return "backendService: string expected";
                            if (message.keyName != null && message.hasOwnProperty("keyName"))
                                if (!$util.isString(message.keyName))
                                    return "keyName: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteSignedUrlKeyBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest} DeleteSignedUrlKeyBackendServiceRequest
                         */
                        DeleteSignedUrlKeyBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest();
                            if (object.backendService != null)
                                message.backendService = String(object.backendService);
                            if (object.keyName != null)
                                message.keyName = String(object.keyName);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteSignedUrlKeyBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest} message DeleteSignedUrlKeyBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteSignedUrlKeyBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.backendService = "";
                                object.keyName = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                object.backendService = message.backendService;
                            if (message.keyName != null && message.hasOwnProperty("keyName"))
                                object.keyName = message.keyName;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteSignedUrlKeyBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteSignedUrlKeyBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteSignedUrlKeyBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteSignedUrlKeyBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest";
                        };
    
                        return DeleteSignedUrlKeyBackendServiceRequest;
                    })();
    
                    v1.DeleteSnapshotRequest = (function() {
    
                        /**
                         * Properties of a DeleteSnapshotRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteSnapshotRequest
                         * @property {string|null} [project] DeleteSnapshotRequest project
                         * @property {string|null} [requestId] DeleteSnapshotRequest requestId
                         * @property {string|null} [snapshot] DeleteSnapshotRequest snapshot
                         */
    
                        /**
                         * Constructs a new DeleteSnapshotRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteSnapshotRequest.
                         * @implements IDeleteSnapshotRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteSnapshotRequest=} [properties] Properties to set
                         */
                        function DeleteSnapshotRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteSnapshotRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteSnapshotRequest
                         * @instance
                         */
                        DeleteSnapshotRequest.prototype.project = "";
    
                        /**
                         * DeleteSnapshotRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteSnapshotRequest
                         * @instance
                         */
                        DeleteSnapshotRequest.prototype.requestId = null;
    
                        /**
                         * DeleteSnapshotRequest snapshot.
                         * @member {string} snapshot
                         * @memberof google.cloud.compute.v1.DeleteSnapshotRequest
                         * @instance
                         */
                        DeleteSnapshotRequest.prototype.snapshot = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteSnapshotRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteSnapshotRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteSnapshotRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteSnapshotRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteSnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSnapshotRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteSnapshotRequest} DeleteSnapshotRequest instance
                         */
                        DeleteSnapshotRequest.create = function create(properties) {
                            return new DeleteSnapshotRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteSnapshotRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteSnapshotRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteSnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSnapshotRequest} message DeleteSnapshotRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteSnapshotRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.snapshot != null && Object.hasOwnProperty.call(message, "snapshot"))
                                writer.uint32(/* id 284874180, wireType 2 =*/2278993442).string(message.snapshot);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteSnapshotRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteSnapshotRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteSnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSnapshotRequest} message DeleteSnapshotRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteSnapshotRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteSnapshotRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteSnapshotRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteSnapshotRequest} DeleteSnapshotRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteSnapshotRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteSnapshotRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 284874180: {
                                        message.snapshot = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteSnapshotRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteSnapshotRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteSnapshotRequest} DeleteSnapshotRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteSnapshotRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteSnapshotRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteSnapshotRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteSnapshotRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.snapshot != null && message.hasOwnProperty("snapshot"))
                                if (!$util.isString(message.snapshot))
                                    return "snapshot: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteSnapshotRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteSnapshotRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteSnapshotRequest} DeleteSnapshotRequest
                         */
                        DeleteSnapshotRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteSnapshotRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteSnapshotRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.snapshot != null)
                                message.snapshot = String(object.snapshot);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteSnapshotRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteSnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteSnapshotRequest} message DeleteSnapshotRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteSnapshotRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.snapshot = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.snapshot != null && message.hasOwnProperty("snapshot"))
                                object.snapshot = message.snapshot;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteSnapshotRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteSnapshotRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteSnapshotRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteSnapshotRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteSnapshotRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteSnapshotRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteSnapshotRequest";
                        };
    
                        return DeleteSnapshotRequest;
                    })();
    
                    v1.DeleteSslCertificateRequest = (function() {
    
                        /**
                         * Properties of a DeleteSslCertificateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteSslCertificateRequest
                         * @property {string|null} [project] DeleteSslCertificateRequest project
                         * @property {string|null} [requestId] DeleteSslCertificateRequest requestId
                         * @property {string|null} [sslCertificate] DeleteSslCertificateRequest sslCertificate
                         */
    
                        /**
                         * Constructs a new DeleteSslCertificateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteSslCertificateRequest.
                         * @implements IDeleteSslCertificateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteSslCertificateRequest=} [properties] Properties to set
                         */
                        function DeleteSslCertificateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteSslCertificateRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteSslCertificateRequest
                         * @instance
                         */
                        DeleteSslCertificateRequest.prototype.project = "";
    
                        /**
                         * DeleteSslCertificateRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteSslCertificateRequest
                         * @instance
                         */
                        DeleteSslCertificateRequest.prototype.requestId = null;
    
                        /**
                         * DeleteSslCertificateRequest sslCertificate.
                         * @member {string} sslCertificate
                         * @memberof google.cloud.compute.v1.DeleteSslCertificateRequest
                         * @instance
                         */
                        DeleteSslCertificateRequest.prototype.sslCertificate = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteSslCertificateRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteSslCertificateRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteSslCertificateRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteSslCertificateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSslCertificateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteSslCertificateRequest} DeleteSslCertificateRequest instance
                         */
                        DeleteSslCertificateRequest.create = function create(properties) {
                            return new DeleteSslCertificateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteSslCertificateRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteSslCertificateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSslCertificateRequest} message DeleteSslCertificateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteSslCertificateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.sslCertificate != null && Object.hasOwnProperty.call(message, "sslCertificate"))
                                writer.uint32(/* id 46443492, wireType 2 =*/371547938).string(message.sslCertificate);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteSslCertificateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteSslCertificateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSslCertificateRequest} message DeleteSslCertificateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteSslCertificateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteSslCertificateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteSslCertificateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteSslCertificateRequest} DeleteSslCertificateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteSslCertificateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteSslCertificateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 46443492: {
                                        message.sslCertificate = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteSslCertificateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteSslCertificateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteSslCertificateRequest} DeleteSslCertificateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteSslCertificateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteSslCertificateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteSslCertificateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteSslCertificateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.sslCertificate != null && message.hasOwnProperty("sslCertificate"))
                                if (!$util.isString(message.sslCertificate))
                                    return "sslCertificate: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteSslCertificateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteSslCertificateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteSslCertificateRequest} DeleteSslCertificateRequest
                         */
                        DeleteSslCertificateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteSslCertificateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteSslCertificateRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.sslCertificate != null)
                                message.sslCertificate = String(object.sslCertificate);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteSslCertificateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteSslCertificateRequest} message DeleteSslCertificateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteSslCertificateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.sslCertificate = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.sslCertificate != null && message.hasOwnProperty("sslCertificate"))
                                object.sslCertificate = message.sslCertificate;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteSslCertificateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteSslCertificateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteSslCertificateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteSslCertificateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteSslCertificateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteSslCertificateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteSslCertificateRequest";
                        };
    
                        return DeleteSslCertificateRequest;
                    })();
    
                    v1.DeleteSslPolicyRequest = (function() {
    
                        /**
                         * Properties of a DeleteSslPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteSslPolicyRequest
                         * @property {string|null} [project] DeleteSslPolicyRequest project
                         * @property {string|null} [requestId] DeleteSslPolicyRequest requestId
                         * @property {string|null} [sslPolicy] DeleteSslPolicyRequest sslPolicy
                         */
    
                        /**
                         * Constructs a new DeleteSslPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteSslPolicyRequest.
                         * @implements IDeleteSslPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteSslPolicyRequest=} [properties] Properties to set
                         */
                        function DeleteSslPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteSslPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteSslPolicyRequest
                         * @instance
                         */
                        DeleteSslPolicyRequest.prototype.project = "";
    
                        /**
                         * DeleteSslPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteSslPolicyRequest
                         * @instance
                         */
                        DeleteSslPolicyRequest.prototype.requestId = null;
    
                        /**
                         * DeleteSslPolicyRequest sslPolicy.
                         * @member {string} sslPolicy
                         * @memberof google.cloud.compute.v1.DeleteSslPolicyRequest
                         * @instance
                         */
                        DeleteSslPolicyRequest.prototype.sslPolicy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteSslPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteSslPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteSslPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteSslPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSslPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteSslPolicyRequest} DeleteSslPolicyRequest instance
                         */
                        DeleteSslPolicyRequest.create = function create(properties) {
                            return new DeleteSslPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteSslPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteSslPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSslPolicyRequest} message DeleteSslPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteSslPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.sslPolicy != null && Object.hasOwnProperty.call(message, "sslPolicy"))
                                writer.uint32(/* id 295190213, wireType 2 =*/2361521706).string(message.sslPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteSslPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteSslPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSslPolicyRequest} message DeleteSslPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteSslPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteSslPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteSslPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteSslPolicyRequest} DeleteSslPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteSslPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteSslPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 295190213: {
                                        message.sslPolicy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteSslPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteSslPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteSslPolicyRequest} DeleteSslPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteSslPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteSslPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteSslPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteSslPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.sslPolicy != null && message.hasOwnProperty("sslPolicy"))
                                if (!$util.isString(message.sslPolicy))
                                    return "sslPolicy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteSslPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteSslPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteSslPolicyRequest} DeleteSslPolicyRequest
                         */
                        DeleteSslPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteSslPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteSslPolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.sslPolicy != null)
                                message.sslPolicy = String(object.sslPolicy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteSslPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteSslPolicyRequest} message DeleteSslPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteSslPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.sslPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.sslPolicy != null && message.hasOwnProperty("sslPolicy"))
                                object.sslPolicy = message.sslPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteSslPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteSslPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteSslPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteSslPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteSslPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteSslPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteSslPolicyRequest";
                        };
    
                        return DeleteSslPolicyRequest;
                    })();
    
                    v1.DeleteSubnetworkRequest = (function() {
    
                        /**
                         * Properties of a DeleteSubnetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteSubnetworkRequest
                         * @property {string|null} [project] DeleteSubnetworkRequest project
                         * @property {string|null} [region] DeleteSubnetworkRequest region
                         * @property {string|null} [requestId] DeleteSubnetworkRequest requestId
                         * @property {string|null} [subnetwork] DeleteSubnetworkRequest subnetwork
                         */
    
                        /**
                         * Constructs a new DeleteSubnetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteSubnetworkRequest.
                         * @implements IDeleteSubnetworkRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteSubnetworkRequest=} [properties] Properties to set
                         */
                        function DeleteSubnetworkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteSubnetworkRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteSubnetworkRequest
                         * @instance
                         */
                        DeleteSubnetworkRequest.prototype.project = "";
    
                        /**
                         * DeleteSubnetworkRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteSubnetworkRequest
                         * @instance
                         */
                        DeleteSubnetworkRequest.prototype.region = "";
    
                        /**
                         * DeleteSubnetworkRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteSubnetworkRequest
                         * @instance
                         */
                        DeleteSubnetworkRequest.prototype.requestId = null;
    
                        /**
                         * DeleteSubnetworkRequest subnetwork.
                         * @member {string} subnetwork
                         * @memberof google.cloud.compute.v1.DeleteSubnetworkRequest
                         * @instance
                         */
                        DeleteSubnetworkRequest.prototype.subnetwork = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteSubnetworkRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteSubnetworkRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteSubnetworkRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteSubnetworkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSubnetworkRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteSubnetworkRequest} DeleteSubnetworkRequest instance
                         */
                        DeleteSubnetworkRequest.create = function create(properties) {
                            return new DeleteSubnetworkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteSubnetworkRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteSubnetworkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSubnetworkRequest} message DeleteSubnetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteSubnetworkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.subnetwork != null && Object.hasOwnProperty.call(message, "subnetwork"))
                                writer.uint32(/* id 307827694, wireType 2 =*/2462621554).string(message.subnetwork);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteSubnetworkRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteSubnetworkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteSubnetworkRequest} message DeleteSubnetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteSubnetworkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteSubnetworkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteSubnetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteSubnetworkRequest} DeleteSubnetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteSubnetworkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteSubnetworkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 307827694: {
                                        message.subnetwork = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteSubnetworkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteSubnetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteSubnetworkRequest} DeleteSubnetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteSubnetworkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteSubnetworkRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteSubnetworkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteSubnetworkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork"))
                                if (!$util.isString(message.subnetwork))
                                    return "subnetwork: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteSubnetworkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteSubnetworkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteSubnetworkRequest} DeleteSubnetworkRequest
                         */
                        DeleteSubnetworkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteSubnetworkRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteSubnetworkRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.subnetwork != null)
                                message.subnetwork = String(object.subnetwork);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteSubnetworkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteSubnetworkRequest} message DeleteSubnetworkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteSubnetworkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.subnetwork = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork"))
                                object.subnetwork = message.subnetwork;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteSubnetworkRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteSubnetworkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteSubnetworkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteSubnetworkRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteSubnetworkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteSubnetworkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteSubnetworkRequest";
                        };
    
                        return DeleteSubnetworkRequest;
                    })();
    
                    v1.DeleteTargetGrpcProxyRequest = (function() {
    
                        /**
                         * Properties of a DeleteTargetGrpcProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteTargetGrpcProxyRequest
                         * @property {string|null} [project] DeleteTargetGrpcProxyRequest project
                         * @property {string|null} [requestId] DeleteTargetGrpcProxyRequest requestId
                         * @property {string|null} [targetGrpcProxy] DeleteTargetGrpcProxyRequest targetGrpcProxy
                         */
    
                        /**
                         * Constructs a new DeleteTargetGrpcProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteTargetGrpcProxyRequest.
                         * @implements IDeleteTargetGrpcProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteTargetGrpcProxyRequest=} [properties] Properties to set
                         */
                        function DeleteTargetGrpcProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteTargetGrpcProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteTargetGrpcProxyRequest
                         * @instance
                         */
                        DeleteTargetGrpcProxyRequest.prototype.project = "";
    
                        /**
                         * DeleteTargetGrpcProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteTargetGrpcProxyRequest
                         * @instance
                         */
                        DeleteTargetGrpcProxyRequest.prototype.requestId = null;
    
                        /**
                         * DeleteTargetGrpcProxyRequest targetGrpcProxy.
                         * @member {string} targetGrpcProxy
                         * @memberof google.cloud.compute.v1.DeleteTargetGrpcProxyRequest
                         * @instance
                         */
                        DeleteTargetGrpcProxyRequest.prototype.targetGrpcProxy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteTargetGrpcProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteTargetGrpcProxyRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteTargetGrpcProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteTargetGrpcProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteTargetGrpcProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetGrpcProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteTargetGrpcProxyRequest} DeleteTargetGrpcProxyRequest instance
                         */
                        DeleteTargetGrpcProxyRequest.create = function create(properties) {
                            return new DeleteTargetGrpcProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteTargetGrpcProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteTargetGrpcProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteTargetGrpcProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetGrpcProxyRequest} message DeleteTargetGrpcProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteTargetGrpcProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetGrpcProxy != null && Object.hasOwnProperty.call(message, "targetGrpcProxy"))
                                writer.uint32(/* id 5020283, wireType 2 =*/40162266).string(message.targetGrpcProxy);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteTargetGrpcProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteTargetGrpcProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteTargetGrpcProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetGrpcProxyRequest} message DeleteTargetGrpcProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteTargetGrpcProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteTargetGrpcProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteTargetGrpcProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteTargetGrpcProxyRequest} DeleteTargetGrpcProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteTargetGrpcProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteTargetGrpcProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 5020283: {
                                        message.targetGrpcProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteTargetGrpcProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteTargetGrpcProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteTargetGrpcProxyRequest} DeleteTargetGrpcProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteTargetGrpcProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteTargetGrpcProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteTargetGrpcProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteTargetGrpcProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetGrpcProxy != null && message.hasOwnProperty("targetGrpcProxy"))
                                if (!$util.isString(message.targetGrpcProxy))
                                    return "targetGrpcProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteTargetGrpcProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteTargetGrpcProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteTargetGrpcProxyRequest} DeleteTargetGrpcProxyRequest
                         */
                        DeleteTargetGrpcProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteTargetGrpcProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteTargetGrpcProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetGrpcProxy != null)
                                message.targetGrpcProxy = String(object.targetGrpcProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteTargetGrpcProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteTargetGrpcProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteTargetGrpcProxyRequest} message DeleteTargetGrpcProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteTargetGrpcProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetGrpcProxy = "";
                                object.project = "";
                            }
                            if (message.targetGrpcProxy != null && message.hasOwnProperty("targetGrpcProxy"))
                                object.targetGrpcProxy = message.targetGrpcProxy;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteTargetGrpcProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteTargetGrpcProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteTargetGrpcProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteTargetGrpcProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteTargetGrpcProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteTargetGrpcProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteTargetGrpcProxyRequest";
                        };
    
                        return DeleteTargetGrpcProxyRequest;
                    })();
    
                    v1.DeleteTargetHttpProxyRequest = (function() {
    
                        /**
                         * Properties of a DeleteTargetHttpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteTargetHttpProxyRequest
                         * @property {string|null} [project] DeleteTargetHttpProxyRequest project
                         * @property {string|null} [requestId] DeleteTargetHttpProxyRequest requestId
                         * @property {string|null} [targetHttpProxy] DeleteTargetHttpProxyRequest targetHttpProxy
                         */
    
                        /**
                         * Constructs a new DeleteTargetHttpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteTargetHttpProxyRequest.
                         * @implements IDeleteTargetHttpProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteTargetHttpProxyRequest=} [properties] Properties to set
                         */
                        function DeleteTargetHttpProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteTargetHttpProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpProxyRequest
                         * @instance
                         */
                        DeleteTargetHttpProxyRequest.prototype.project = "";
    
                        /**
                         * DeleteTargetHttpProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpProxyRequest
                         * @instance
                         */
                        DeleteTargetHttpProxyRequest.prototype.requestId = null;
    
                        /**
                         * DeleteTargetHttpProxyRequest targetHttpProxy.
                         * @member {string} targetHttpProxy
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpProxyRequest
                         * @instance
                         */
                        DeleteTargetHttpProxyRequest.prototype.targetHttpProxy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteTargetHttpProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpProxyRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteTargetHttpProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteTargetHttpProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetHttpProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteTargetHttpProxyRequest} DeleteTargetHttpProxyRequest instance
                         */
                        DeleteTargetHttpProxyRequest.create = function create(properties) {
                            return new DeleteTargetHttpProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteTargetHttpProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteTargetHttpProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetHttpProxyRequest} message DeleteTargetHttpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteTargetHttpProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetHttpProxy != null && Object.hasOwnProperty.call(message, "targetHttpProxy"))
                                writer.uint32(/* id 206872421, wireType 2 =*/1654979370).string(message.targetHttpProxy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteTargetHttpProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteTargetHttpProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetHttpProxyRequest} message DeleteTargetHttpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteTargetHttpProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteTargetHttpProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteTargetHttpProxyRequest} DeleteTargetHttpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteTargetHttpProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteTargetHttpProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 206872421: {
                                        message.targetHttpProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteTargetHttpProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteTargetHttpProxyRequest} DeleteTargetHttpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteTargetHttpProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteTargetHttpProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteTargetHttpProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetHttpProxy != null && message.hasOwnProperty("targetHttpProxy"))
                                if (!$util.isString(message.targetHttpProxy))
                                    return "targetHttpProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteTargetHttpProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteTargetHttpProxyRequest} DeleteTargetHttpProxyRequest
                         */
                        DeleteTargetHttpProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteTargetHttpProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteTargetHttpProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetHttpProxy != null)
                                message.targetHttpProxy = String(object.targetHttpProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteTargetHttpProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteTargetHttpProxyRequest} message DeleteTargetHttpProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteTargetHttpProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetHttpProxy = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetHttpProxy != null && message.hasOwnProperty("targetHttpProxy"))
                                object.targetHttpProxy = message.targetHttpProxy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteTargetHttpProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteTargetHttpProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteTargetHttpProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteTargetHttpProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteTargetHttpProxyRequest";
                        };
    
                        return DeleteTargetHttpProxyRequest;
                    })();
    
                    v1.DeleteTargetHttpsProxyRequest = (function() {
    
                        /**
                         * Properties of a DeleteTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteTargetHttpsProxyRequest
                         * @property {string|null} [project] DeleteTargetHttpsProxyRequest project
                         * @property {string|null} [requestId] DeleteTargetHttpsProxyRequest requestId
                         * @property {string|null} [targetHttpsProxy] DeleteTargetHttpsProxyRequest targetHttpsProxy
                         */
    
                        /**
                         * Constructs a new DeleteTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteTargetHttpsProxyRequest.
                         * @implements IDeleteTargetHttpsProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteTargetHttpsProxyRequest=} [properties] Properties to set
                         */
                        function DeleteTargetHttpsProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteTargetHttpsProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpsProxyRequest
                         * @instance
                         */
                        DeleteTargetHttpsProxyRequest.prototype.project = "";
    
                        /**
                         * DeleteTargetHttpsProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpsProxyRequest
                         * @instance
                         */
                        DeleteTargetHttpsProxyRequest.prototype.requestId = null;
    
                        /**
                         * DeleteTargetHttpsProxyRequest targetHttpsProxy.
                         * @member {string} targetHttpsProxy
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpsProxyRequest
                         * @instance
                         */
                        DeleteTargetHttpsProxyRequest.prototype.targetHttpsProxy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteTargetHttpsProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpsProxyRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteTargetHttpsProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteTargetHttpsProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetHttpsProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteTargetHttpsProxyRequest} DeleteTargetHttpsProxyRequest instance
                         */
                        DeleteTargetHttpsProxyRequest.create = function create(properties) {
                            return new DeleteTargetHttpsProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteTargetHttpsProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetHttpsProxyRequest} message DeleteTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteTargetHttpsProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetHttpsProxy != null && Object.hasOwnProperty.call(message, "targetHttpsProxy"))
                                writer.uint32(/* id 52336748, wireType 2 =*/418693986).string(message.targetHttpsProxy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteTargetHttpsProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetHttpsProxyRequest} message DeleteTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteTargetHttpsProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteTargetHttpsProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteTargetHttpsProxyRequest} DeleteTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteTargetHttpsProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteTargetHttpsProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 52336748: {
                                        message.targetHttpsProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteTargetHttpsProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteTargetHttpsProxyRequest} DeleteTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteTargetHttpsProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteTargetHttpsProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteTargetHttpsProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                if (!$util.isString(message.targetHttpsProxy))
                                    return "targetHttpsProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteTargetHttpsProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteTargetHttpsProxyRequest} DeleteTargetHttpsProxyRequest
                         */
                        DeleteTargetHttpsProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteTargetHttpsProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteTargetHttpsProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetHttpsProxy != null)
                                message.targetHttpsProxy = String(object.targetHttpsProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteTargetHttpsProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteTargetHttpsProxyRequest} message DeleteTargetHttpsProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteTargetHttpsProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetHttpsProxy = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                object.targetHttpsProxy = message.targetHttpsProxy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteTargetHttpsProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpsProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteTargetHttpsProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteTargetHttpsProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteTargetHttpsProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteTargetHttpsProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteTargetHttpsProxyRequest";
                        };
    
                        return DeleteTargetHttpsProxyRequest;
                    })();
    
                    v1.DeleteTargetInstanceRequest = (function() {
    
                        /**
                         * Properties of a DeleteTargetInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteTargetInstanceRequest
                         * @property {string|null} [project] DeleteTargetInstanceRequest project
                         * @property {string|null} [requestId] DeleteTargetInstanceRequest requestId
                         * @property {string|null} [targetInstance] DeleteTargetInstanceRequest targetInstance
                         * @property {string|null} [zone] DeleteTargetInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new DeleteTargetInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteTargetInstanceRequest.
                         * @implements IDeleteTargetInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteTargetInstanceRequest=} [properties] Properties to set
                         */
                        function DeleteTargetInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteTargetInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteTargetInstanceRequest
                         * @instance
                         */
                        DeleteTargetInstanceRequest.prototype.project = "";
    
                        /**
                         * DeleteTargetInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteTargetInstanceRequest
                         * @instance
                         */
                        DeleteTargetInstanceRequest.prototype.requestId = null;
    
                        /**
                         * DeleteTargetInstanceRequest targetInstance.
                         * @member {string} targetInstance
                         * @memberof google.cloud.compute.v1.DeleteTargetInstanceRequest
                         * @instance
                         */
                        DeleteTargetInstanceRequest.prototype.targetInstance = "";
    
                        /**
                         * DeleteTargetInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.DeleteTargetInstanceRequest
                         * @instance
                         */
                        DeleteTargetInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteTargetInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteTargetInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteTargetInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteTargetInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteTargetInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteTargetInstanceRequest} DeleteTargetInstanceRequest instance
                         */
                        DeleteTargetInstanceRequest.create = function create(properties) {
                            return new DeleteTargetInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteTargetInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteTargetInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteTargetInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetInstanceRequest} message DeleteTargetInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteTargetInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetInstance != null && Object.hasOwnProperty.call(message, "targetInstance"))
                                writer.uint32(/* id 289769347, wireType 2 =*/2318154778).string(message.targetInstance);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteTargetInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteTargetInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteTargetInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetInstanceRequest} message DeleteTargetInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteTargetInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteTargetInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteTargetInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteTargetInstanceRequest} DeleteTargetInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteTargetInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteTargetInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 289769347: {
                                        message.targetInstance = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteTargetInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteTargetInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteTargetInstanceRequest} DeleteTargetInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteTargetInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteTargetInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteTargetInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteTargetInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetInstance != null && message.hasOwnProperty("targetInstance"))
                                if (!$util.isString(message.targetInstance))
                                    return "targetInstance: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteTargetInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteTargetInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteTargetInstanceRequest} DeleteTargetInstanceRequest
                         */
                        DeleteTargetInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteTargetInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteTargetInstanceRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetInstance != null)
                                message.targetInstance = String(object.targetInstance);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteTargetInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteTargetInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteTargetInstanceRequest} message DeleteTargetInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteTargetInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.targetInstance = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetInstance != null && message.hasOwnProperty("targetInstance"))
                                object.targetInstance = message.targetInstance;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteTargetInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteTargetInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteTargetInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteTargetInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteTargetInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteTargetInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteTargetInstanceRequest";
                        };
    
                        return DeleteTargetInstanceRequest;
                    })();
    
                    v1.DeleteTargetPoolRequest = (function() {
    
                        /**
                         * Properties of a DeleteTargetPoolRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteTargetPoolRequest
                         * @property {string|null} [project] DeleteTargetPoolRequest project
                         * @property {string|null} [region] DeleteTargetPoolRequest region
                         * @property {string|null} [requestId] DeleteTargetPoolRequest requestId
                         * @property {string|null} [targetPool] DeleteTargetPoolRequest targetPool
                         */
    
                        /**
                         * Constructs a new DeleteTargetPoolRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteTargetPoolRequest.
                         * @implements IDeleteTargetPoolRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteTargetPoolRequest=} [properties] Properties to set
                         */
                        function DeleteTargetPoolRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteTargetPoolRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteTargetPoolRequest
                         * @instance
                         */
                        DeleteTargetPoolRequest.prototype.project = "";
    
                        /**
                         * DeleteTargetPoolRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteTargetPoolRequest
                         * @instance
                         */
                        DeleteTargetPoolRequest.prototype.region = "";
    
                        /**
                         * DeleteTargetPoolRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteTargetPoolRequest
                         * @instance
                         */
                        DeleteTargetPoolRequest.prototype.requestId = null;
    
                        /**
                         * DeleteTargetPoolRequest targetPool.
                         * @member {string} targetPool
                         * @memberof google.cloud.compute.v1.DeleteTargetPoolRequest
                         * @instance
                         */
                        DeleteTargetPoolRequest.prototype.targetPool = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteTargetPoolRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteTargetPoolRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteTargetPoolRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteTargetPoolRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetPoolRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteTargetPoolRequest} DeleteTargetPoolRequest instance
                         */
                        DeleteTargetPoolRequest.create = function create(properties) {
                            return new DeleteTargetPoolRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteTargetPoolRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteTargetPoolRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetPoolRequest} message DeleteTargetPoolRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteTargetPoolRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetPool != null && Object.hasOwnProperty.call(message, "targetPool"))
                                writer.uint32(/* id 62796298, wireType 2 =*/502370386).string(message.targetPool);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteTargetPoolRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteTargetPoolRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetPoolRequest} message DeleteTargetPoolRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteTargetPoolRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteTargetPoolRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteTargetPoolRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteTargetPoolRequest} DeleteTargetPoolRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteTargetPoolRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteTargetPoolRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 62796298: {
                                        message.targetPool = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteTargetPoolRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteTargetPoolRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteTargetPoolRequest} DeleteTargetPoolRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteTargetPoolRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteTargetPoolRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteTargetPoolRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteTargetPoolRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetPool != null && message.hasOwnProperty("targetPool"))
                                if (!$util.isString(message.targetPool))
                                    return "targetPool: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteTargetPoolRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteTargetPoolRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteTargetPoolRequest} DeleteTargetPoolRequest
                         */
                        DeleteTargetPoolRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteTargetPoolRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteTargetPoolRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetPool != null)
                                message.targetPool = String(object.targetPool);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteTargetPoolRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteTargetPoolRequest} message DeleteTargetPoolRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteTargetPoolRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetPool = "";
                                object.region = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetPool != null && message.hasOwnProperty("targetPool"))
                                object.targetPool = message.targetPool;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteTargetPoolRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteTargetPoolRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteTargetPoolRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteTargetPoolRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteTargetPoolRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteTargetPoolRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteTargetPoolRequest";
                        };
    
                        return DeleteTargetPoolRequest;
                    })();
    
                    v1.DeleteTargetSslProxyRequest = (function() {
    
                        /**
                         * Properties of a DeleteTargetSslProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteTargetSslProxyRequest
                         * @property {string|null} [project] DeleteTargetSslProxyRequest project
                         * @property {string|null} [requestId] DeleteTargetSslProxyRequest requestId
                         * @property {string|null} [targetSslProxy] DeleteTargetSslProxyRequest targetSslProxy
                         */
    
                        /**
                         * Constructs a new DeleteTargetSslProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteTargetSslProxyRequest.
                         * @implements IDeleteTargetSslProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteTargetSslProxyRequest=} [properties] Properties to set
                         */
                        function DeleteTargetSslProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteTargetSslProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteTargetSslProxyRequest
                         * @instance
                         */
                        DeleteTargetSslProxyRequest.prototype.project = "";
    
                        /**
                         * DeleteTargetSslProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteTargetSslProxyRequest
                         * @instance
                         */
                        DeleteTargetSslProxyRequest.prototype.requestId = null;
    
                        /**
                         * DeleteTargetSslProxyRequest targetSslProxy.
                         * @member {string} targetSslProxy
                         * @memberof google.cloud.compute.v1.DeleteTargetSslProxyRequest
                         * @instance
                         */
                        DeleteTargetSslProxyRequest.prototype.targetSslProxy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteTargetSslProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteTargetSslProxyRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteTargetSslProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteTargetSslProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetSslProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteTargetSslProxyRequest} DeleteTargetSslProxyRequest instance
                         */
                        DeleteTargetSslProxyRequest.create = function create(properties) {
                            return new DeleteTargetSslProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteTargetSslProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteTargetSslProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetSslProxyRequest} message DeleteTargetSslProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteTargetSslProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetSslProxy != null && Object.hasOwnProperty.call(message, "targetSslProxy"))
                                writer.uint32(/* id 338795853, wireType 2 =*/2710366826).string(message.targetSslProxy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteTargetSslProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteTargetSslProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetSslProxyRequest} message DeleteTargetSslProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteTargetSslProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteTargetSslProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteTargetSslProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteTargetSslProxyRequest} DeleteTargetSslProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteTargetSslProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteTargetSslProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 338795853: {
                                        message.targetSslProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteTargetSslProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteTargetSslProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteTargetSslProxyRequest} DeleteTargetSslProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteTargetSslProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteTargetSslProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteTargetSslProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteTargetSslProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetSslProxy != null && message.hasOwnProperty("targetSslProxy"))
                                if (!$util.isString(message.targetSslProxy))
                                    return "targetSslProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteTargetSslProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteTargetSslProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteTargetSslProxyRequest} DeleteTargetSslProxyRequest
                         */
                        DeleteTargetSslProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteTargetSslProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteTargetSslProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetSslProxy != null)
                                message.targetSslProxy = String(object.targetSslProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteTargetSslProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteTargetSslProxyRequest} message DeleteTargetSslProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteTargetSslProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.targetSslProxy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetSslProxy != null && message.hasOwnProperty("targetSslProxy"))
                                object.targetSslProxy = message.targetSslProxy;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteTargetSslProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteTargetSslProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteTargetSslProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteTargetSslProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteTargetSslProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteTargetSslProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteTargetSslProxyRequest";
                        };
    
                        return DeleteTargetSslProxyRequest;
                    })();
    
                    v1.DeleteTargetTcpProxyRequest = (function() {
    
                        /**
                         * Properties of a DeleteTargetTcpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteTargetTcpProxyRequest
                         * @property {string|null} [project] DeleteTargetTcpProxyRequest project
                         * @property {string|null} [requestId] DeleteTargetTcpProxyRequest requestId
                         * @property {string|null} [targetTcpProxy] DeleteTargetTcpProxyRequest targetTcpProxy
                         */
    
                        /**
                         * Constructs a new DeleteTargetTcpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteTargetTcpProxyRequest.
                         * @implements IDeleteTargetTcpProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteTargetTcpProxyRequest=} [properties] Properties to set
                         */
                        function DeleteTargetTcpProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteTargetTcpProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteTargetTcpProxyRequest
                         * @instance
                         */
                        DeleteTargetTcpProxyRequest.prototype.project = "";
    
                        /**
                         * DeleteTargetTcpProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteTargetTcpProxyRequest
                         * @instance
                         */
                        DeleteTargetTcpProxyRequest.prototype.requestId = null;
    
                        /**
                         * DeleteTargetTcpProxyRequest targetTcpProxy.
                         * @member {string} targetTcpProxy
                         * @memberof google.cloud.compute.v1.DeleteTargetTcpProxyRequest
                         * @instance
                         */
                        DeleteTargetTcpProxyRequest.prototype.targetTcpProxy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteTargetTcpProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteTargetTcpProxyRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteTargetTcpProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteTargetTcpProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetTcpProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteTargetTcpProxyRequest} DeleteTargetTcpProxyRequest instance
                         */
                        DeleteTargetTcpProxyRequest.create = function create(properties) {
                            return new DeleteTargetTcpProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteTargetTcpProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteTargetTcpProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetTcpProxyRequest} message DeleteTargetTcpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteTargetTcpProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetTcpProxy != null && Object.hasOwnProperty.call(message, "targetTcpProxy"))
                                writer.uint32(/* id 503065442, wireType 2 =*/4024523538).string(message.targetTcpProxy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteTargetTcpProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteTargetTcpProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetTcpProxyRequest} message DeleteTargetTcpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteTargetTcpProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteTargetTcpProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteTargetTcpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteTargetTcpProxyRequest} DeleteTargetTcpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteTargetTcpProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteTargetTcpProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 503065442: {
                                        message.targetTcpProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteTargetTcpProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteTargetTcpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteTargetTcpProxyRequest} DeleteTargetTcpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteTargetTcpProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteTargetTcpProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteTargetTcpProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteTargetTcpProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetTcpProxy != null && message.hasOwnProperty("targetTcpProxy"))
                                if (!$util.isString(message.targetTcpProxy))
                                    return "targetTcpProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteTargetTcpProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteTargetTcpProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteTargetTcpProxyRequest} DeleteTargetTcpProxyRequest
                         */
                        DeleteTargetTcpProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteTargetTcpProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteTargetTcpProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetTcpProxy != null)
                                message.targetTcpProxy = String(object.targetTcpProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteTargetTcpProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteTargetTcpProxyRequest} message DeleteTargetTcpProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteTargetTcpProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.targetTcpProxy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetTcpProxy != null && message.hasOwnProperty("targetTcpProxy"))
                                object.targetTcpProxy = message.targetTcpProxy;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteTargetTcpProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteTargetTcpProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteTargetTcpProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteTargetTcpProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteTargetTcpProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteTargetTcpProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteTargetTcpProxyRequest";
                        };
    
                        return DeleteTargetTcpProxyRequest;
                    })();
    
                    v1.DeleteTargetVpnGatewayRequest = (function() {
    
                        /**
                         * Properties of a DeleteTargetVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteTargetVpnGatewayRequest
                         * @property {string|null} [project] DeleteTargetVpnGatewayRequest project
                         * @property {string|null} [region] DeleteTargetVpnGatewayRequest region
                         * @property {string|null} [requestId] DeleteTargetVpnGatewayRequest requestId
                         * @property {string|null} [targetVpnGateway] DeleteTargetVpnGatewayRequest targetVpnGateway
                         */
    
                        /**
                         * Constructs a new DeleteTargetVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteTargetVpnGatewayRequest.
                         * @implements IDeleteTargetVpnGatewayRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteTargetVpnGatewayRequest=} [properties] Properties to set
                         */
                        function DeleteTargetVpnGatewayRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteTargetVpnGatewayRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteTargetVpnGatewayRequest
                         * @instance
                         */
                        DeleteTargetVpnGatewayRequest.prototype.project = "";
    
                        /**
                         * DeleteTargetVpnGatewayRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteTargetVpnGatewayRequest
                         * @instance
                         */
                        DeleteTargetVpnGatewayRequest.prototype.region = "";
    
                        /**
                         * DeleteTargetVpnGatewayRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteTargetVpnGatewayRequest
                         * @instance
                         */
                        DeleteTargetVpnGatewayRequest.prototype.requestId = null;
    
                        /**
                         * DeleteTargetVpnGatewayRequest targetVpnGateway.
                         * @member {string} targetVpnGateway
                         * @memberof google.cloud.compute.v1.DeleteTargetVpnGatewayRequest
                         * @instance
                         */
                        DeleteTargetVpnGatewayRequest.prototype.targetVpnGateway = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteTargetVpnGatewayRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteTargetVpnGatewayRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteTargetVpnGatewayRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteTargetVpnGatewayRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteTargetVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetVpnGatewayRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteTargetVpnGatewayRequest} DeleteTargetVpnGatewayRequest instance
                         */
                        DeleteTargetVpnGatewayRequest.create = function create(properties) {
                            return new DeleteTargetVpnGatewayRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteTargetVpnGatewayRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteTargetVpnGatewayRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteTargetVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetVpnGatewayRequest} message DeleteTargetVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteTargetVpnGatewayRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetVpnGateway != null && Object.hasOwnProperty.call(message, "targetVpnGateway"))
                                writer.uint32(/* id 532512843, wireType 2 =*/4260102746).string(message.targetVpnGateway);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteTargetVpnGatewayRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteTargetVpnGatewayRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteTargetVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteTargetVpnGatewayRequest} message DeleteTargetVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteTargetVpnGatewayRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteTargetVpnGatewayRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteTargetVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteTargetVpnGatewayRequest} DeleteTargetVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteTargetVpnGatewayRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteTargetVpnGatewayRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 532512843: {
                                        message.targetVpnGateway = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteTargetVpnGatewayRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteTargetVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteTargetVpnGatewayRequest} DeleteTargetVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteTargetVpnGatewayRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteTargetVpnGatewayRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteTargetVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteTargetVpnGatewayRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetVpnGateway != null && message.hasOwnProperty("targetVpnGateway"))
                                if (!$util.isString(message.targetVpnGateway))
                                    return "targetVpnGateway: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteTargetVpnGatewayRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteTargetVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteTargetVpnGatewayRequest} DeleteTargetVpnGatewayRequest
                         */
                        DeleteTargetVpnGatewayRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteTargetVpnGatewayRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteTargetVpnGatewayRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetVpnGateway != null)
                                message.targetVpnGateway = String(object.targetVpnGateway);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteTargetVpnGatewayRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteTargetVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteTargetVpnGatewayRequest} message DeleteTargetVpnGatewayRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteTargetVpnGatewayRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.targetVpnGateway = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetVpnGateway != null && message.hasOwnProperty("targetVpnGateway"))
                                object.targetVpnGateway = message.targetVpnGateway;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteTargetVpnGatewayRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteTargetVpnGatewayRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteTargetVpnGatewayRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteTargetVpnGatewayRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteTargetVpnGatewayRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteTargetVpnGatewayRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteTargetVpnGatewayRequest";
                        };
    
                        return DeleteTargetVpnGatewayRequest;
                    })();
    
                    v1.DeleteUrlMapRequest = (function() {
    
                        /**
                         * Properties of a DeleteUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteUrlMapRequest
                         * @property {string|null} [project] DeleteUrlMapRequest project
                         * @property {string|null} [requestId] DeleteUrlMapRequest requestId
                         * @property {string|null} [urlMap] DeleteUrlMapRequest urlMap
                         */
    
                        /**
                         * Constructs a new DeleteUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteUrlMapRequest.
                         * @implements IDeleteUrlMapRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteUrlMapRequest=} [properties] Properties to set
                         */
                        function DeleteUrlMapRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteUrlMapRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteUrlMapRequest
                         * @instance
                         */
                        DeleteUrlMapRequest.prototype.project = "";
    
                        /**
                         * DeleteUrlMapRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteUrlMapRequest
                         * @instance
                         */
                        DeleteUrlMapRequest.prototype.requestId = null;
    
                        /**
                         * DeleteUrlMapRequest urlMap.
                         * @member {string} urlMap
                         * @memberof google.cloud.compute.v1.DeleteUrlMapRequest
                         * @instance
                         */
                        DeleteUrlMapRequest.prototype.urlMap = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteUrlMapRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteUrlMapRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteUrlMapRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteUrlMapRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteUrlMapRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteUrlMapRequest} DeleteUrlMapRequest instance
                         */
                        DeleteUrlMapRequest.create = function create(properties) {
                            return new DeleteUrlMapRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteUrlMapRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteUrlMapRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteUrlMapRequest} message DeleteUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteUrlMapRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.urlMap != null && Object.hasOwnProperty.call(message, "urlMap"))
                                writer.uint32(/* id 367020684, wireType 2 =*/2936165474).string(message.urlMap);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteUrlMapRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteUrlMapRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteUrlMapRequest} message DeleteUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteUrlMapRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteUrlMapRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteUrlMapRequest} DeleteUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteUrlMapRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteUrlMapRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 367020684: {
                                        message.urlMap = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteUrlMapRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteUrlMapRequest} DeleteUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteUrlMapRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteUrlMapRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteUrlMapRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                if (!$util.isString(message.urlMap))
                                    return "urlMap: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteUrlMapRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteUrlMapRequest} DeleteUrlMapRequest
                         */
                        DeleteUrlMapRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteUrlMapRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteUrlMapRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.urlMap != null)
                                message.urlMap = String(object.urlMap);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteUrlMapRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteUrlMapRequest} message DeleteUrlMapRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteUrlMapRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.urlMap = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                object.urlMap = message.urlMap;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteUrlMapRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteUrlMapRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteUrlMapRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteUrlMapRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteUrlMapRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteUrlMapRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteUrlMapRequest";
                        };
    
                        return DeleteUrlMapRequest;
                    })();
    
                    v1.DeleteVpnGatewayRequest = (function() {
    
                        /**
                         * Properties of a DeleteVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteVpnGatewayRequest
                         * @property {string|null} [project] DeleteVpnGatewayRequest project
                         * @property {string|null} [region] DeleteVpnGatewayRequest region
                         * @property {string|null} [requestId] DeleteVpnGatewayRequest requestId
                         * @property {string|null} [vpnGateway] DeleteVpnGatewayRequest vpnGateway
                         */
    
                        /**
                         * Constructs a new DeleteVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteVpnGatewayRequest.
                         * @implements IDeleteVpnGatewayRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteVpnGatewayRequest=} [properties] Properties to set
                         */
                        function DeleteVpnGatewayRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteVpnGatewayRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteVpnGatewayRequest
                         * @instance
                         */
                        DeleteVpnGatewayRequest.prototype.project = "";
    
                        /**
                         * DeleteVpnGatewayRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteVpnGatewayRequest
                         * @instance
                         */
                        DeleteVpnGatewayRequest.prototype.region = "";
    
                        /**
                         * DeleteVpnGatewayRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteVpnGatewayRequest
                         * @instance
                         */
                        DeleteVpnGatewayRequest.prototype.requestId = null;
    
                        /**
                         * DeleteVpnGatewayRequest vpnGateway.
                         * @member {string} vpnGateway
                         * @memberof google.cloud.compute.v1.DeleteVpnGatewayRequest
                         * @instance
                         */
                        DeleteVpnGatewayRequest.prototype.vpnGateway = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteVpnGatewayRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteVpnGatewayRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteVpnGatewayRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteVpnGatewayRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteVpnGatewayRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteVpnGatewayRequest} DeleteVpnGatewayRequest instance
                         */
                        DeleteVpnGatewayRequest.create = function create(properties) {
                            return new DeleteVpnGatewayRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteVpnGatewayRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteVpnGatewayRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteVpnGatewayRequest} message DeleteVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteVpnGatewayRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.vpnGateway != null && Object.hasOwnProperty.call(message, "vpnGateway"))
                                writer.uint32(/* id 406684153, wireType 2 =*/3253473226).string(message.vpnGateway);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteVpnGatewayRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteVpnGatewayRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteVpnGatewayRequest} message DeleteVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteVpnGatewayRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteVpnGatewayRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteVpnGatewayRequest} DeleteVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteVpnGatewayRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteVpnGatewayRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 406684153: {
                                        message.vpnGateway = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteVpnGatewayRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteVpnGatewayRequest} DeleteVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteVpnGatewayRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteVpnGatewayRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteVpnGatewayRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.vpnGateway != null && message.hasOwnProperty("vpnGateway"))
                                if (!$util.isString(message.vpnGateway))
                                    return "vpnGateway: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteVpnGatewayRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteVpnGatewayRequest} DeleteVpnGatewayRequest
                         */
                        DeleteVpnGatewayRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteVpnGatewayRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteVpnGatewayRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.vpnGateway != null)
                                message.vpnGateway = String(object.vpnGateway);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteVpnGatewayRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteVpnGatewayRequest} message DeleteVpnGatewayRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteVpnGatewayRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.vpnGateway = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.vpnGateway != null && message.hasOwnProperty("vpnGateway"))
                                object.vpnGateway = message.vpnGateway;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteVpnGatewayRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteVpnGatewayRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteVpnGatewayRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteVpnGatewayRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteVpnGatewayRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteVpnGatewayRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteVpnGatewayRequest";
                        };
    
                        return DeleteVpnGatewayRequest;
                    })();
    
                    v1.DeleteVpnTunnelRequest = (function() {
    
                        /**
                         * Properties of a DeleteVpnTunnelRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteVpnTunnelRequest
                         * @property {string|null} [project] DeleteVpnTunnelRequest project
                         * @property {string|null} [region] DeleteVpnTunnelRequest region
                         * @property {string|null} [requestId] DeleteVpnTunnelRequest requestId
                         * @property {string|null} [vpnTunnel] DeleteVpnTunnelRequest vpnTunnel
                         */
    
                        /**
                         * Constructs a new DeleteVpnTunnelRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteVpnTunnelRequest.
                         * @implements IDeleteVpnTunnelRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteVpnTunnelRequest=} [properties] Properties to set
                         */
                        function DeleteVpnTunnelRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteVpnTunnelRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteVpnTunnelRequest
                         * @instance
                         */
                        DeleteVpnTunnelRequest.prototype.project = "";
    
                        /**
                         * DeleteVpnTunnelRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.DeleteVpnTunnelRequest
                         * @instance
                         */
                        DeleteVpnTunnelRequest.prototype.region = "";
    
                        /**
                         * DeleteVpnTunnelRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeleteVpnTunnelRequest
                         * @instance
                         */
                        DeleteVpnTunnelRequest.prototype.requestId = null;
    
                        /**
                         * DeleteVpnTunnelRequest vpnTunnel.
                         * @member {string} vpnTunnel
                         * @memberof google.cloud.compute.v1.DeleteVpnTunnelRequest
                         * @instance
                         */
                        DeleteVpnTunnelRequest.prototype.vpnTunnel = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteVpnTunnelRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeleteVpnTunnelRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteVpnTunnelRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteVpnTunnelRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteVpnTunnelRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteVpnTunnelRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteVpnTunnelRequest} DeleteVpnTunnelRequest instance
                         */
                        DeleteVpnTunnelRequest.create = function create(properties) {
                            return new DeleteVpnTunnelRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteVpnTunnelRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteVpnTunnelRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteVpnTunnelRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteVpnTunnelRequest} message DeleteVpnTunnelRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteVpnTunnelRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.vpnTunnel != null && Object.hasOwnProperty.call(message, "vpnTunnel"))
                                writer.uint32(/* id 143821331, wireType 2 =*/1150570650).string(message.vpnTunnel);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteVpnTunnelRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteVpnTunnelRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteVpnTunnelRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteVpnTunnelRequest} message DeleteVpnTunnelRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteVpnTunnelRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteVpnTunnelRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteVpnTunnelRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteVpnTunnelRequest} DeleteVpnTunnelRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteVpnTunnelRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteVpnTunnelRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 143821331: {
                                        message.vpnTunnel = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteVpnTunnelRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteVpnTunnelRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteVpnTunnelRequest} DeleteVpnTunnelRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteVpnTunnelRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteVpnTunnelRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteVpnTunnelRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteVpnTunnelRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.vpnTunnel != null && message.hasOwnProperty("vpnTunnel"))
                                if (!$util.isString(message.vpnTunnel))
                                    return "vpnTunnel: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteVpnTunnelRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteVpnTunnelRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteVpnTunnelRequest} DeleteVpnTunnelRequest
                         */
                        DeleteVpnTunnelRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteVpnTunnelRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteVpnTunnelRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.vpnTunnel != null)
                                message.vpnTunnel = String(object.vpnTunnel);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteVpnTunnelRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteVpnTunnelRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteVpnTunnelRequest} message DeleteVpnTunnelRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteVpnTunnelRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.vpnTunnel = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.vpnTunnel != null && message.hasOwnProperty("vpnTunnel"))
                                object.vpnTunnel = message.vpnTunnel;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteVpnTunnelRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteVpnTunnelRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteVpnTunnelRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteVpnTunnelRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteVpnTunnelRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteVpnTunnelRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteVpnTunnelRequest";
                        };
    
                        return DeleteVpnTunnelRequest;
                    })();
    
                    v1.DeleteZoneOperationRequest = (function() {
    
                        /**
                         * Properties of a DeleteZoneOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteZoneOperationRequest
                         * @property {string|null} [operation] DeleteZoneOperationRequest operation
                         * @property {string|null} [project] DeleteZoneOperationRequest project
                         * @property {string|null} [zone] DeleteZoneOperationRequest zone
                         */
    
                        /**
                         * Constructs a new DeleteZoneOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteZoneOperationRequest.
                         * @implements IDeleteZoneOperationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteZoneOperationRequest=} [properties] Properties to set
                         */
                        function DeleteZoneOperationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteZoneOperationRequest operation.
                         * @member {string} operation
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationRequest
                         * @instance
                         */
                        DeleteZoneOperationRequest.prototype.operation = "";
    
                        /**
                         * DeleteZoneOperationRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationRequest
                         * @instance
                         */
                        DeleteZoneOperationRequest.prototype.project = "";
    
                        /**
                         * DeleteZoneOperationRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationRequest
                         * @instance
                         */
                        DeleteZoneOperationRequest.prototype.zone = "";
    
                        /**
                         * Creates a new DeleteZoneOperationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteZoneOperationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteZoneOperationRequest} DeleteZoneOperationRequest instance
                         */
                        DeleteZoneOperationRequest.create = function create(properties) {
                            return new DeleteZoneOperationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteZoneOperationRequest message. Does not implicitly {@link google.cloud.compute.v1.DeleteZoneOperationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteZoneOperationRequest} message DeleteZoneOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteZoneOperationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.operation != null && Object.hasOwnProperty.call(message, "operation"))
                                writer.uint32(/* id 52090215, wireType 2 =*/416721722).string(message.operation);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteZoneOperationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteZoneOperationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteZoneOperationRequest} message DeleteZoneOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteZoneOperationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteZoneOperationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteZoneOperationRequest} DeleteZoneOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteZoneOperationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteZoneOperationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 52090215: {
                                        message.operation = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteZoneOperationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteZoneOperationRequest} DeleteZoneOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteZoneOperationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteZoneOperationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteZoneOperationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                if (!$util.isString(message.operation))
                                    return "operation: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteZoneOperationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteZoneOperationRequest} DeleteZoneOperationRequest
                         */
                        DeleteZoneOperationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteZoneOperationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeleteZoneOperationRequest();
                            if (object.operation != null)
                                message.operation = String(object.operation);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteZoneOperationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeleteZoneOperationRequest} message DeleteZoneOperationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteZoneOperationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.operation = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                object.operation = message.operation;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteZoneOperationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteZoneOperationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteZoneOperationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteZoneOperationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteZoneOperationRequest";
                        };
    
                        return DeleteZoneOperationRequest;
                    })();
    
                    v1.DeleteZoneOperationResponse = (function() {
    
                        /**
                         * Properties of a DeleteZoneOperationResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeleteZoneOperationResponse
                         */
    
                        /**
                         * Constructs a new DeleteZoneOperationResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeleteZoneOperationResponse.
                         * @implements IDeleteZoneOperationResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeleteZoneOperationResponse=} [properties] Properties to set
                         */
                        function DeleteZoneOperationResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Creates a new DeleteZoneOperationResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationResponse
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteZoneOperationResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeleteZoneOperationResponse} DeleteZoneOperationResponse instance
                         */
                        DeleteZoneOperationResponse.create = function create(properties) {
                            return new DeleteZoneOperationResponse(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteZoneOperationResponse message. Does not implicitly {@link google.cloud.compute.v1.DeleteZoneOperationResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationResponse
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteZoneOperationResponse} message DeleteZoneOperationResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteZoneOperationResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteZoneOperationResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeleteZoneOperationResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationResponse
                         * @static
                         * @param {google.cloud.compute.v1.IDeleteZoneOperationResponse} message DeleteZoneOperationResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteZoneOperationResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteZoneOperationResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeleteZoneOperationResponse} DeleteZoneOperationResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteZoneOperationResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeleteZoneOperationResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteZoneOperationResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeleteZoneOperationResponse} DeleteZoneOperationResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteZoneOperationResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteZoneOperationResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteZoneOperationResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };
    
                        /**
                         * Creates a DeleteZoneOperationResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeleteZoneOperationResponse} DeleteZoneOperationResponse
                         */
                        DeleteZoneOperationResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeleteZoneOperationResponse)
                                return object;
                            return new $root.google.cloud.compute.v1.DeleteZoneOperationResponse();
                        };
    
                        /**
                         * Creates a plain object from a DeleteZoneOperationResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationResponse
                         * @static
                         * @param {google.cloud.compute.v1.DeleteZoneOperationResponse} message DeleteZoneOperationResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteZoneOperationResponse.toObject = function toObject() {
                            return {};
                        };
    
                        /**
                         * Converts this DeleteZoneOperationResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteZoneOperationResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteZoneOperationResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeleteZoneOperationResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteZoneOperationResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeleteZoneOperationResponse";
                        };
    
                        return DeleteZoneOperationResponse;
                    })();
    
                    v1.Denied = (function() {
    
                        /**
                         * Properties of a Denied.
                         * @memberof google.cloud.compute.v1
                         * @interface IDenied
                         * @property {string|null} [IPProtocol] Denied IPProtocol
                         * @property {Array.<string>|null} [ports] Denied ports
                         */
    
                        /**
                         * Constructs a new Denied.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Denied.
                         * @implements IDenied
                         * @constructor
                         * @param {google.cloud.compute.v1.IDenied=} [properties] Properties to set
                         */
                        function Denied(properties) {
                            this.ports = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Denied IPProtocol.
                         * @member {string|null|undefined} IPProtocol
                         * @memberof google.cloud.compute.v1.Denied
                         * @instance
                         */
                        Denied.prototype.IPProtocol = null;
    
                        /**
                         * Denied ports.
                         * @member {Array.<string>} ports
                         * @memberof google.cloud.compute.v1.Denied
                         * @instance
                         */
                        Denied.prototype.ports = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Denied _IPProtocol.
                         * @member {"IPProtocol"|undefined} _IPProtocol
                         * @memberof google.cloud.compute.v1.Denied
                         * @instance
                         */
                        Object.defineProperty(Denied.prototype, "_IPProtocol", {
                            get: $util.oneOfGetter($oneOfFields = ["IPProtocol"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Denied instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Denied
                         * @static
                         * @param {google.cloud.compute.v1.IDenied=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Denied} Denied instance
                         */
                        Denied.create = function create(properties) {
                            return new Denied(properties);
                        };
    
                        /**
                         * Encodes the specified Denied message. Does not implicitly {@link google.cloud.compute.v1.Denied.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Denied
                         * @static
                         * @param {google.cloud.compute.v1.IDenied} message Denied message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Denied.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.ports != null && message.ports.length)
                                for (var i = 0; i < message.ports.length; ++i)
                                    writer.uint32(/* id 106854418, wireType 2 =*/854835346).string(message.ports[i]);
                            if (message.IPProtocol != null && Object.hasOwnProperty.call(message, "IPProtocol"))
                                writer.uint32(/* id 488094525, wireType 2 =*/3904756202).string(message.IPProtocol);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Denied message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Denied.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Denied
                         * @static
                         * @param {google.cloud.compute.v1.IDenied} message Denied message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Denied.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Denied message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Denied
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Denied} Denied
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Denied.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Denied();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 488094525: {
                                        message.IPProtocol = reader.string();
                                        break;
                                    }
                                case 106854418: {
                                        if (!(message.ports && message.ports.length))
                                            message.ports = [];
                                        message.ports.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Denied message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Denied
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Denied} Denied
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Denied.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Denied message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Denied
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Denied.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.IPProtocol != null && message.hasOwnProperty("IPProtocol")) {
                                properties._IPProtocol = 1;
                                if (!$util.isString(message.IPProtocol))
                                    return "IPProtocol: string expected";
                            }
                            if (message.ports != null && message.hasOwnProperty("ports")) {
                                if (!Array.isArray(message.ports))
                                    return "ports: array expected";
                                for (var i = 0; i < message.ports.length; ++i)
                                    if (!$util.isString(message.ports[i]))
                                        return "ports: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Denied message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Denied
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Denied} Denied
                         */
                        Denied.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Denied)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Denied();
                            if (object.IPProtocol != null)
                                message.IPProtocol = String(object.IPProtocol);
                            if (object.ports) {
                                if (!Array.isArray(object.ports))
                                    throw TypeError(".google.cloud.compute.v1.Denied.ports: array expected");
                                message.ports = [];
                                for (var i = 0; i < object.ports.length; ++i)
                                    message.ports[i] = String(object.ports[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Denied message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Denied
                         * @static
                         * @param {google.cloud.compute.v1.Denied} message Denied
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Denied.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.ports = [];
                            if (message.ports && message.ports.length) {
                                object.ports = [];
                                for (var j = 0; j < message.ports.length; ++j)
                                    object.ports[j] = message.ports[j];
                            }
                            if (message.IPProtocol != null && message.hasOwnProperty("IPProtocol")) {
                                object.IPProtocol = message.IPProtocol;
                                if (options.oneofs)
                                    object._IPProtocol = "IPProtocol";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Denied to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Denied
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Denied.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Denied
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Denied
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Denied.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Denied";
                        };
    
                        return Denied;
                    })();
    
                    v1.DeprecateImageRequest = (function() {
    
                        /**
                         * Properties of a DeprecateImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeprecateImageRequest
                         * @property {google.cloud.compute.v1.IDeprecationStatus|null} [deprecationStatusResource] DeprecateImageRequest deprecationStatusResource
                         * @property {string|null} [image] DeprecateImageRequest image
                         * @property {string|null} [project] DeprecateImageRequest project
                         * @property {string|null} [requestId] DeprecateImageRequest requestId
                         */
    
                        /**
                         * Constructs a new DeprecateImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeprecateImageRequest.
                         * @implements IDeprecateImageRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeprecateImageRequest=} [properties] Properties to set
                         */
                        function DeprecateImageRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeprecateImageRequest deprecationStatusResource.
                         * @member {google.cloud.compute.v1.IDeprecationStatus|null|undefined} deprecationStatusResource
                         * @memberof google.cloud.compute.v1.DeprecateImageRequest
                         * @instance
                         */
                        DeprecateImageRequest.prototype.deprecationStatusResource = null;
    
                        /**
                         * DeprecateImageRequest image.
                         * @member {string} image
                         * @memberof google.cloud.compute.v1.DeprecateImageRequest
                         * @instance
                         */
                        DeprecateImageRequest.prototype.image = "";
    
                        /**
                         * DeprecateImageRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DeprecateImageRequest
                         * @instance
                         */
                        DeprecateImageRequest.prototype.project = "";
    
                        /**
                         * DeprecateImageRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DeprecateImageRequest
                         * @instance
                         */
                        DeprecateImageRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeprecateImageRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DeprecateImageRequest
                         * @instance
                         */
                        Object.defineProperty(DeprecateImageRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeprecateImageRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeprecateImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeprecateImageRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeprecateImageRequest} DeprecateImageRequest instance
                         */
                        DeprecateImageRequest.create = function create(properties) {
                            return new DeprecateImageRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeprecateImageRequest message. Does not implicitly {@link google.cloud.compute.v1.DeprecateImageRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeprecateImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeprecateImageRequest} message DeprecateImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeprecateImageRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.image != null && Object.hasOwnProperty.call(message, "image"))
                                writer.uint32(/* id 100313435, wireType 2 =*/802507482).string(message.image);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.deprecationStatusResource != null && Object.hasOwnProperty.call(message, "deprecationStatusResource"))
                                $root.google.cloud.compute.v1.DeprecationStatus.encode(message.deprecationStatusResource, writer.uint32(/* id 333006064, wireType 2 =*/2664048514).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeprecateImageRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeprecateImageRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeprecateImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDeprecateImageRequest} message DeprecateImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeprecateImageRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeprecateImageRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeprecateImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeprecateImageRequest} DeprecateImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeprecateImageRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeprecateImageRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 333006064: {
                                        message.deprecationStatusResource = $root.google.cloud.compute.v1.DeprecationStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 100313435: {
                                        message.image = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeprecateImageRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeprecateImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeprecateImageRequest} DeprecateImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeprecateImageRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeprecateImageRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeprecateImageRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeprecateImageRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.deprecationStatusResource != null && message.hasOwnProperty("deprecationStatusResource")) {
                                var error = $root.google.cloud.compute.v1.DeprecationStatus.verify(message.deprecationStatusResource);
                                if (error)
                                    return "deprecationStatusResource." + error;
                            }
                            if (message.image != null && message.hasOwnProperty("image"))
                                if (!$util.isString(message.image))
                                    return "image: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeprecateImageRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeprecateImageRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeprecateImageRequest} DeprecateImageRequest
                         */
                        DeprecateImageRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeprecateImageRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeprecateImageRequest();
                            if (object.deprecationStatusResource != null) {
                                if (typeof object.deprecationStatusResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.DeprecateImageRequest.deprecationStatusResource: object expected");
                                message.deprecationStatusResource = $root.google.cloud.compute.v1.DeprecationStatus.fromObject(object.deprecationStatusResource);
                            }
                            if (object.image != null)
                                message.image = String(object.image);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeprecateImageRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeprecateImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.DeprecateImageRequest} message DeprecateImageRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeprecateImageRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.image = "";
                                object.project = "";
                                object.deprecationStatusResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.image != null && message.hasOwnProperty("image"))
                                object.image = message.image;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.deprecationStatusResource != null && message.hasOwnProperty("deprecationStatusResource"))
                                object.deprecationStatusResource = $root.google.cloud.compute.v1.DeprecationStatus.toObject(message.deprecationStatusResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this DeprecateImageRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeprecateImageRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeprecateImageRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeprecateImageRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeprecateImageRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeprecateImageRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeprecateImageRequest";
                        };
    
                        return DeprecateImageRequest;
                    })();
    
                    v1.DeprecationStatus = (function() {
    
                        /**
                         * Properties of a DeprecationStatus.
                         * @memberof google.cloud.compute.v1
                         * @interface IDeprecationStatus
                         * @property {string|null} [deleted] DeprecationStatus deleted
                         * @property {string|null} [deprecated] DeprecationStatus deprecated
                         * @property {string|null} [obsolete] DeprecationStatus obsolete
                         * @property {string|null} [replacement] DeprecationStatus replacement
                         * @property {string|null} [state] DeprecationStatus state
                         */
    
                        /**
                         * Constructs a new DeprecationStatus.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DeprecationStatus.
                         * @implements IDeprecationStatus
                         * @constructor
                         * @param {google.cloud.compute.v1.IDeprecationStatus=} [properties] Properties to set
                         */
                        function DeprecationStatus(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeprecationStatus deleted.
                         * @member {string|null|undefined} deleted
                         * @memberof google.cloud.compute.v1.DeprecationStatus
                         * @instance
                         */
                        DeprecationStatus.prototype.deleted = null;
    
                        /**
                         * DeprecationStatus deprecated.
                         * @member {string|null|undefined} deprecated
                         * @memberof google.cloud.compute.v1.DeprecationStatus
                         * @instance
                         */
                        DeprecationStatus.prototype.deprecated = null;
    
                        /**
                         * DeprecationStatus obsolete.
                         * @member {string|null|undefined} obsolete
                         * @memberof google.cloud.compute.v1.DeprecationStatus
                         * @instance
                         */
                        DeprecationStatus.prototype.obsolete = null;
    
                        /**
                         * DeprecationStatus replacement.
                         * @member {string|null|undefined} replacement
                         * @memberof google.cloud.compute.v1.DeprecationStatus
                         * @instance
                         */
                        DeprecationStatus.prototype.replacement = null;
    
                        /**
                         * DeprecationStatus state.
                         * @member {string|null|undefined} state
                         * @memberof google.cloud.compute.v1.DeprecationStatus
                         * @instance
                         */
                        DeprecationStatus.prototype.state = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeprecationStatus _deleted.
                         * @member {"deleted"|undefined} _deleted
                         * @memberof google.cloud.compute.v1.DeprecationStatus
                         * @instance
                         */
                        Object.defineProperty(DeprecationStatus.prototype, "_deleted", {
                            get: $util.oneOfGetter($oneOfFields = ["deleted"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DeprecationStatus _deprecated.
                         * @member {"deprecated"|undefined} _deprecated
                         * @memberof google.cloud.compute.v1.DeprecationStatus
                         * @instance
                         */
                        Object.defineProperty(DeprecationStatus.prototype, "_deprecated", {
                            get: $util.oneOfGetter($oneOfFields = ["deprecated"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DeprecationStatus _obsolete.
                         * @member {"obsolete"|undefined} _obsolete
                         * @memberof google.cloud.compute.v1.DeprecationStatus
                         * @instance
                         */
                        Object.defineProperty(DeprecationStatus.prototype, "_obsolete", {
                            get: $util.oneOfGetter($oneOfFields = ["obsolete"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DeprecationStatus _replacement.
                         * @member {"replacement"|undefined} _replacement
                         * @memberof google.cloud.compute.v1.DeprecationStatus
                         * @instance
                         */
                        Object.defineProperty(DeprecationStatus.prototype, "_replacement", {
                            get: $util.oneOfGetter($oneOfFields = ["replacement"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DeprecationStatus _state.
                         * @member {"state"|undefined} _state
                         * @memberof google.cloud.compute.v1.DeprecationStatus
                         * @instance
                         */
                        Object.defineProperty(DeprecationStatus.prototype, "_state", {
                            get: $util.oneOfGetter($oneOfFields = ["state"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeprecationStatus instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DeprecationStatus
                         * @static
                         * @param {google.cloud.compute.v1.IDeprecationStatus=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DeprecationStatus} DeprecationStatus instance
                         */
                        DeprecationStatus.create = function create(properties) {
                            return new DeprecationStatus(properties);
                        };
    
                        /**
                         * Encodes the specified DeprecationStatus message. Does not implicitly {@link google.cloud.compute.v1.DeprecationStatus.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DeprecationStatus
                         * @static
                         * @param {google.cloud.compute.v1.IDeprecationStatus} message DeprecationStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeprecationStatus.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.state != null && Object.hasOwnProperty.call(message, "state"))
                                writer.uint32(/* id 109757585, wireType 2 =*/878060682).string(message.state);
                            if (message.obsolete != null && Object.hasOwnProperty.call(message, "obsolete"))
                                writer.uint32(/* id 357647769, wireType 2 =*/2861182154).string(message.obsolete);
                            if (message.replacement != null && Object.hasOwnProperty.call(message, "replacement"))
                                writer.uint32(/* id 430919186, wireType 2 =*/3447353490).string(message.replacement);
                            if (message.deleted != null && Object.hasOwnProperty.call(message, "deleted"))
                                writer.uint32(/* id 476721177, wireType 2 =*/3813769418).string(message.deleted);
                            if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                                writer.uint32(/* id 515138995, wireType 2 =*/4121111962).string(message.deprecated);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeprecationStatus message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DeprecationStatus.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DeprecationStatus
                         * @static
                         * @param {google.cloud.compute.v1.IDeprecationStatus} message DeprecationStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeprecationStatus.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeprecationStatus message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DeprecationStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DeprecationStatus} DeprecationStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeprecationStatus.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DeprecationStatus();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 476721177: {
                                        message.deleted = reader.string();
                                        break;
                                    }
                                case 515138995: {
                                        message.deprecated = reader.string();
                                        break;
                                    }
                                case 357647769: {
                                        message.obsolete = reader.string();
                                        break;
                                    }
                                case 430919186: {
                                        message.replacement = reader.string();
                                        break;
                                    }
                                case 109757585: {
                                        message.state = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeprecationStatus message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DeprecationStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DeprecationStatus} DeprecationStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeprecationStatus.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeprecationStatus message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DeprecationStatus
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeprecationStatus.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.deleted != null && message.hasOwnProperty("deleted")) {
                                properties._deleted = 1;
                                if (!$util.isString(message.deleted))
                                    return "deleted: string expected";
                            }
                            if (message.deprecated != null && message.hasOwnProperty("deprecated")) {
                                properties._deprecated = 1;
                                if (!$util.isString(message.deprecated))
                                    return "deprecated: string expected";
                            }
                            if (message.obsolete != null && message.hasOwnProperty("obsolete")) {
                                properties._obsolete = 1;
                                if (!$util.isString(message.obsolete))
                                    return "obsolete: string expected";
                            }
                            if (message.replacement != null && message.hasOwnProperty("replacement")) {
                                properties._replacement = 1;
                                if (!$util.isString(message.replacement))
                                    return "replacement: string expected";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                properties._state = 1;
                                if (!$util.isString(message.state))
                                    return "state: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeprecationStatus message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DeprecationStatus
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DeprecationStatus} DeprecationStatus
                         */
                        DeprecationStatus.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DeprecationStatus)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DeprecationStatus();
                            if (object.deleted != null)
                                message.deleted = String(object.deleted);
                            if (object.deprecated != null)
                                message.deprecated = String(object.deprecated);
                            if (object.obsolete != null)
                                message.obsolete = String(object.obsolete);
                            if (object.replacement != null)
                                message.replacement = String(object.replacement);
                            if (object.state != null)
                                message.state = String(object.state);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeprecationStatus message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DeprecationStatus
                         * @static
                         * @param {google.cloud.compute.v1.DeprecationStatus} message DeprecationStatus
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeprecationStatus.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.state != null && message.hasOwnProperty("state")) {
                                object.state = message.state;
                                if (options.oneofs)
                                    object._state = "state";
                            }
                            if (message.obsolete != null && message.hasOwnProperty("obsolete")) {
                                object.obsolete = message.obsolete;
                                if (options.oneofs)
                                    object._obsolete = "obsolete";
                            }
                            if (message.replacement != null && message.hasOwnProperty("replacement")) {
                                object.replacement = message.replacement;
                                if (options.oneofs)
                                    object._replacement = "replacement";
                            }
                            if (message.deleted != null && message.hasOwnProperty("deleted")) {
                                object.deleted = message.deleted;
                                if (options.oneofs)
                                    object._deleted = "deleted";
                            }
                            if (message.deprecated != null && message.hasOwnProperty("deprecated")) {
                                object.deprecated = message.deprecated;
                                if (options.oneofs)
                                    object._deprecated = "deprecated";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this DeprecationStatus to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DeprecationStatus
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeprecationStatus.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeprecationStatus
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DeprecationStatus
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeprecationStatus.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DeprecationStatus";
                        };
    
                        /**
                         * State enum.
                         * @name google.cloud.compute.v1.DeprecationStatus.State
                         * @enum {number}
                         * @property {number} UNDEFINED_STATE=0 UNDEFINED_STATE value
                         * @property {number} ACTIVE=314733318 ACTIVE value
                         * @property {number} DELETED=120962041 DELETED value
                         * @property {number} DEPRECATED=463360435 DEPRECATED value
                         * @property {number} OBSOLETE=66532761 OBSOLETE value
                         */
                        DeprecationStatus.State = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATE"] = 0;
                            values[valuesById[314733318] = "ACTIVE"] = 314733318;
                            values[valuesById[120962041] = "DELETED"] = 120962041;
                            values[valuesById[463360435] = "DEPRECATED"] = 463360435;
                            values[valuesById[66532761] = "OBSOLETE"] = 66532761;
                            return values;
                        })();
    
                        return DeprecationStatus;
                    })();
    
                    v1.DetachDiskInstanceRequest = (function() {
    
                        /**
                         * Properties of a DetachDiskInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDetachDiskInstanceRequest
                         * @property {string|null} [deviceName] DetachDiskInstanceRequest deviceName
                         * @property {string|null} [instance] DetachDiskInstanceRequest instance
                         * @property {string|null} [project] DetachDiskInstanceRequest project
                         * @property {string|null} [requestId] DetachDiskInstanceRequest requestId
                         * @property {string|null} [zone] DetachDiskInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new DetachDiskInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DetachDiskInstanceRequest.
                         * @implements IDetachDiskInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDetachDiskInstanceRequest=} [properties] Properties to set
                         */
                        function DetachDiskInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DetachDiskInstanceRequest deviceName.
                         * @member {string} deviceName
                         * @memberof google.cloud.compute.v1.DetachDiskInstanceRequest
                         * @instance
                         */
                        DetachDiskInstanceRequest.prototype.deviceName = "";
    
                        /**
                         * DetachDiskInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.DetachDiskInstanceRequest
                         * @instance
                         */
                        DetachDiskInstanceRequest.prototype.instance = "";
    
                        /**
                         * DetachDiskInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DetachDiskInstanceRequest
                         * @instance
                         */
                        DetachDiskInstanceRequest.prototype.project = "";
    
                        /**
                         * DetachDiskInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DetachDiskInstanceRequest
                         * @instance
                         */
                        DetachDiskInstanceRequest.prototype.requestId = null;
    
                        /**
                         * DetachDiskInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.DetachDiskInstanceRequest
                         * @instance
                         */
                        DetachDiskInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DetachDiskInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DetachDiskInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(DetachDiskInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DetachDiskInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DetachDiskInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDetachDiskInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DetachDiskInstanceRequest} DetachDiskInstanceRequest instance
                         */
                        DetachDiskInstanceRequest.create = function create(properties) {
                            return new DetachDiskInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DetachDiskInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.DetachDiskInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DetachDiskInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDetachDiskInstanceRequest} message DetachDiskInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DetachDiskInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.deviceName != null && Object.hasOwnProperty.call(message, "deviceName"))
                                writer.uint32(/* id 67541716, wireType 2 =*/540333730).string(message.deviceName);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DetachDiskInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DetachDiskInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DetachDiskInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDetachDiskInstanceRequest} message DetachDiskInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DetachDiskInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DetachDiskInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DetachDiskInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DetachDiskInstanceRequest} DetachDiskInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DetachDiskInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DetachDiskInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 67541716: {
                                        message.deviceName = reader.string();
                                        break;
                                    }
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DetachDiskInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DetachDiskInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DetachDiskInstanceRequest} DetachDiskInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DetachDiskInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DetachDiskInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DetachDiskInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DetachDiskInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.deviceName != null && message.hasOwnProperty("deviceName"))
                                if (!$util.isString(message.deviceName))
                                    return "deviceName: string expected";
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DetachDiskInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DetachDiskInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DetachDiskInstanceRequest} DetachDiskInstanceRequest
                         */
                        DetachDiskInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DetachDiskInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DetachDiskInstanceRequest();
                            if (object.deviceName != null)
                                message.deviceName = String(object.deviceName);
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DetachDiskInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DetachDiskInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.DetachDiskInstanceRequest} message DetachDiskInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DetachDiskInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.deviceName = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.deviceName != null && message.hasOwnProperty("deviceName"))
                                object.deviceName = message.deviceName;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DetachDiskInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DetachDiskInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DetachDiskInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DetachDiskInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DetachDiskInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DetachDiskInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DetachDiskInstanceRequest";
                        };
    
                        return DetachDiskInstanceRequest;
                    })();
    
                    v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest = (function() {
    
                        /**
                         * Properties of a DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @property {google.cloud.compute.v1.IGlobalNetworkEndpointGroupsDetachEndpointsRequest|null} [globalNetworkEndpointGroupsDetachEndpointsRequestResource] DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest globalNetworkEndpointGroupsDetachEndpointsRequestResource
                         * @property {string|null} [networkEndpointGroup] DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest networkEndpointGroup
                         * @property {string|null} [project] DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest project
                         * @property {string|null} [requestId] DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest requestId
                         */
    
                        /**
                         * Constructs a new DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.
                         * @implements IDetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDetachNetworkEndpointsGlobalNetworkEndpointGroupRequest=} [properties] Properties to set
                         */
                        function DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest globalNetworkEndpointGroupsDetachEndpointsRequestResource.
                         * @member {google.cloud.compute.v1.IGlobalNetworkEndpointGroupsDetachEndpointsRequest|null|undefined} globalNetworkEndpointGroupsDetachEndpointsRequestResource
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @instance
                         */
                        DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.prototype.globalNetworkEndpointGroupsDetachEndpointsRequestResource = null;
    
                        /**
                         * DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest networkEndpointGroup.
                         * @member {string} networkEndpointGroup
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @instance
                         */
                        DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.prototype.networkEndpointGroup = "";
    
                        /**
                         * DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @instance
                         */
                        DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.prototype.project = "";
    
                        /**
                         * DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @instance
                         */
                        DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @instance
                         */
                        Object.defineProperty(DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDetachNetworkEndpointsGlobalNetworkEndpointGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest} DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest instance
                         */
                        DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.create = function create(properties) {
                            return new DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDetachNetworkEndpointsGlobalNetworkEndpointGroupRequest} message DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.globalNetworkEndpointGroupsDetachEndpointsRequestResource != null && Object.hasOwnProperty.call(message, "globalNetworkEndpointGroupsDetachEndpointsRequestResource"))
                                $root.google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest.encode(message.globalNetworkEndpointGroupsDetachEndpointsRequestResource, writer.uint32(/* id 8898269, wireType 2 =*/71186154).fork()).ldelim();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.networkEndpointGroup != null && Object.hasOwnProperty.call(message, "networkEndpointGroup"))
                                writer.uint32(/* id 433907078, wireType 2 =*/3471256626).string(message.networkEndpointGroup);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDetachNetworkEndpointsGlobalNetworkEndpointGroupRequest} message DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest} DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 8898269: {
                                        message.globalNetworkEndpointGroupsDetachEndpointsRequestResource = $root.google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 433907078: {
                                        message.networkEndpointGroup = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest} DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.globalNetworkEndpointGroupsDetachEndpointsRequestResource != null && message.hasOwnProperty("globalNetworkEndpointGroupsDetachEndpointsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest.verify(message.globalNetworkEndpointGroupsDetachEndpointsRequestResource);
                                if (error)
                                    return "globalNetworkEndpointGroupsDetachEndpointsRequestResource." + error;
                            }
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                if (!$util.isString(message.networkEndpointGroup))
                                    return "networkEndpointGroup: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest} DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         */
                        DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest();
                            if (object.globalNetworkEndpointGroupsDetachEndpointsRequestResource != null) {
                                if (typeof object.globalNetworkEndpointGroupsDetachEndpointsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.globalNetworkEndpointGroupsDetachEndpointsRequestResource: object expected");
                                message.globalNetworkEndpointGroupsDetachEndpointsRequestResource = $root.google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest.fromObject(object.globalNetworkEndpointGroupsDetachEndpointsRequestResource);
                            }
                            if (object.networkEndpointGroup != null)
                                message.networkEndpointGroup = String(object.networkEndpointGroup);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest} message DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.globalNetworkEndpointGroupsDetachEndpointsRequestResource = null;
                                object.project = "";
                                object.networkEndpointGroup = "";
                            }
                            if (message.globalNetworkEndpointGroupsDetachEndpointsRequestResource != null && message.hasOwnProperty("globalNetworkEndpointGroupsDetachEndpointsRequestResource"))
                                object.globalNetworkEndpointGroupsDetachEndpointsRequestResource = $root.google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest.toObject(message.globalNetworkEndpointGroupsDetachEndpointsRequestResource, options);
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                object.networkEndpointGroup = message.networkEndpointGroup;
                            return object;
                        };
    
                        /**
                         * Converts this DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest";
                        };
    
                        return DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest;
                    })();
    
                    v1.DetachNetworkEndpointsNetworkEndpointGroupRequest = (function() {
    
                        /**
                         * Properties of a DetachNetworkEndpointsNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @property {string|null} [networkEndpointGroup] DetachNetworkEndpointsNetworkEndpointGroupRequest networkEndpointGroup
                         * @property {google.cloud.compute.v1.INetworkEndpointGroupsDetachEndpointsRequest|null} [networkEndpointGroupsDetachEndpointsRequestResource] DetachNetworkEndpointsNetworkEndpointGroupRequest networkEndpointGroupsDetachEndpointsRequestResource
                         * @property {string|null} [project] DetachNetworkEndpointsNetworkEndpointGroupRequest project
                         * @property {string|null} [requestId] DetachNetworkEndpointsNetworkEndpointGroupRequest requestId
                         * @property {string|null} [zone] DetachNetworkEndpointsNetworkEndpointGroupRequest zone
                         */
    
                        /**
                         * Constructs a new DetachNetworkEndpointsNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DetachNetworkEndpointsNetworkEndpointGroupRequest.
                         * @implements IDetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDetachNetworkEndpointsNetworkEndpointGroupRequest=} [properties] Properties to set
                         */
                        function DetachNetworkEndpointsNetworkEndpointGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DetachNetworkEndpointsNetworkEndpointGroupRequest networkEndpointGroup.
                         * @member {string} networkEndpointGroup
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @instance
                         */
                        DetachNetworkEndpointsNetworkEndpointGroupRequest.prototype.networkEndpointGroup = "";
    
                        /**
                         * DetachNetworkEndpointsNetworkEndpointGroupRequest networkEndpointGroupsDetachEndpointsRequestResource.
                         * @member {google.cloud.compute.v1.INetworkEndpointGroupsDetachEndpointsRequest|null|undefined} networkEndpointGroupsDetachEndpointsRequestResource
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @instance
                         */
                        DetachNetworkEndpointsNetworkEndpointGroupRequest.prototype.networkEndpointGroupsDetachEndpointsRequestResource = null;
    
                        /**
                         * DetachNetworkEndpointsNetworkEndpointGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @instance
                         */
                        DetachNetworkEndpointsNetworkEndpointGroupRequest.prototype.project = "";
    
                        /**
                         * DetachNetworkEndpointsNetworkEndpointGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @instance
                         */
                        DetachNetworkEndpointsNetworkEndpointGroupRequest.prototype.requestId = null;
    
                        /**
                         * DetachNetworkEndpointsNetworkEndpointGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @instance
                         */
                        DetachNetworkEndpointsNetworkEndpointGroupRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DetachNetworkEndpointsNetworkEndpointGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @instance
                         */
                        Object.defineProperty(DetachNetworkEndpointsNetworkEndpointGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DetachNetworkEndpointsNetworkEndpointGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDetachNetworkEndpointsNetworkEndpointGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest} DetachNetworkEndpointsNetworkEndpointGroupRequest instance
                         */
                        DetachNetworkEndpointsNetworkEndpointGroupRequest.create = function create(properties) {
                            return new DetachNetworkEndpointsNetworkEndpointGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DetachNetworkEndpointsNetworkEndpointGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDetachNetworkEndpointsNetworkEndpointGroupRequest} message DetachNetworkEndpointsNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DetachNetworkEndpointsNetworkEndpointGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.networkEndpointGroup != null && Object.hasOwnProperty.call(message, "networkEndpointGroup"))
                                writer.uint32(/* id 433907078, wireType 2 =*/3471256626).string(message.networkEndpointGroup);
                            if (message.networkEndpointGroupsDetachEndpointsRequestResource != null && Object.hasOwnProperty.call(message, "networkEndpointGroupsDetachEndpointsRequestResource"))
                                $root.google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest.encode(message.networkEndpointGroupsDetachEndpointsRequestResource, writer.uint32(/* id 515608697, wireType 2 =*/4124869578).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DetachNetworkEndpointsNetworkEndpointGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDetachNetworkEndpointsNetworkEndpointGroupRequest} message DetachNetworkEndpointsNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DetachNetworkEndpointsNetworkEndpointGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DetachNetworkEndpointsNetworkEndpointGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest} DetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DetachNetworkEndpointsNetworkEndpointGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 433907078: {
                                        message.networkEndpointGroup = reader.string();
                                        break;
                                    }
                                case 515608697: {
                                        message.networkEndpointGroupsDetachEndpointsRequestResource = $root.google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DetachNetworkEndpointsNetworkEndpointGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest} DetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DetachNetworkEndpointsNetworkEndpointGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DetachNetworkEndpointsNetworkEndpointGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DetachNetworkEndpointsNetworkEndpointGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                if (!$util.isString(message.networkEndpointGroup))
                                    return "networkEndpointGroup: string expected";
                            if (message.networkEndpointGroupsDetachEndpointsRequestResource != null && message.hasOwnProperty("networkEndpointGroupsDetachEndpointsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest.verify(message.networkEndpointGroupsDetachEndpointsRequestResource);
                                if (error)
                                    return "networkEndpointGroupsDetachEndpointsRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a DetachNetworkEndpointsNetworkEndpointGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest} DetachNetworkEndpointsNetworkEndpointGroupRequest
                         */
                        DetachNetworkEndpointsNetworkEndpointGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest();
                            if (object.networkEndpointGroup != null)
                                message.networkEndpointGroup = String(object.networkEndpointGroup);
                            if (object.networkEndpointGroupsDetachEndpointsRequestResource != null) {
                                if (typeof object.networkEndpointGroupsDetachEndpointsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest.networkEndpointGroupsDetachEndpointsRequestResource: object expected");
                                message.networkEndpointGroupsDetachEndpointsRequestResource = $root.google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest.fromObject(object.networkEndpointGroupsDetachEndpointsRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DetachNetworkEndpointsNetworkEndpointGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest} message DetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DetachNetworkEndpointsNetworkEndpointGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.networkEndpointGroup = "";
                                object.networkEndpointGroupsDetachEndpointsRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                object.networkEndpointGroup = message.networkEndpointGroup;
                            if (message.networkEndpointGroupsDetachEndpointsRequestResource != null && message.hasOwnProperty("networkEndpointGroupsDetachEndpointsRequestResource"))
                                object.networkEndpointGroupsDetachEndpointsRequestResource = $root.google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest.toObject(message.networkEndpointGroupsDetachEndpointsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this DetachNetworkEndpointsNetworkEndpointGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DetachNetworkEndpointsNetworkEndpointGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DetachNetworkEndpointsNetworkEndpointGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest";
                        };
    
                        return DetachNetworkEndpointsNetworkEndpointGroupRequest;
                    })();
    
                    v1.DisableXpnHostProjectRequest = (function() {
    
                        /**
                         * Properties of a DisableXpnHostProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDisableXpnHostProjectRequest
                         * @property {string|null} [project] DisableXpnHostProjectRequest project
                         * @property {string|null} [requestId] DisableXpnHostProjectRequest requestId
                         */
    
                        /**
                         * Constructs a new DisableXpnHostProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DisableXpnHostProjectRequest.
                         * @implements IDisableXpnHostProjectRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDisableXpnHostProjectRequest=} [properties] Properties to set
                         */
                        function DisableXpnHostProjectRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DisableXpnHostProjectRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DisableXpnHostProjectRequest
                         * @instance
                         */
                        DisableXpnHostProjectRequest.prototype.project = "";
    
                        /**
                         * DisableXpnHostProjectRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DisableXpnHostProjectRequest
                         * @instance
                         */
                        DisableXpnHostProjectRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DisableXpnHostProjectRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DisableXpnHostProjectRequest
                         * @instance
                         */
                        Object.defineProperty(DisableXpnHostProjectRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DisableXpnHostProjectRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DisableXpnHostProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDisableXpnHostProjectRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DisableXpnHostProjectRequest} DisableXpnHostProjectRequest instance
                         */
                        DisableXpnHostProjectRequest.create = function create(properties) {
                            return new DisableXpnHostProjectRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DisableXpnHostProjectRequest message. Does not implicitly {@link google.cloud.compute.v1.DisableXpnHostProjectRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DisableXpnHostProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDisableXpnHostProjectRequest} message DisableXpnHostProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisableXpnHostProjectRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DisableXpnHostProjectRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DisableXpnHostProjectRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DisableXpnHostProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDisableXpnHostProjectRequest} message DisableXpnHostProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisableXpnHostProjectRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DisableXpnHostProjectRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DisableXpnHostProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DisableXpnHostProjectRequest} DisableXpnHostProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisableXpnHostProjectRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DisableXpnHostProjectRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DisableXpnHostProjectRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DisableXpnHostProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DisableXpnHostProjectRequest} DisableXpnHostProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisableXpnHostProjectRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DisableXpnHostProjectRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DisableXpnHostProjectRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DisableXpnHostProjectRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DisableXpnHostProjectRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DisableXpnHostProjectRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DisableXpnHostProjectRequest} DisableXpnHostProjectRequest
                         */
                        DisableXpnHostProjectRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DisableXpnHostProjectRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DisableXpnHostProjectRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DisableXpnHostProjectRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DisableXpnHostProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.DisableXpnHostProjectRequest} message DisableXpnHostProjectRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DisableXpnHostProjectRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DisableXpnHostProjectRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DisableXpnHostProjectRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DisableXpnHostProjectRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DisableXpnHostProjectRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DisableXpnHostProjectRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DisableXpnHostProjectRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DisableXpnHostProjectRequest";
                        };
    
                        return DisableXpnHostProjectRequest;
                    })();
    
                    v1.DisableXpnResourceProjectRequest = (function() {
    
                        /**
                         * Properties of a DisableXpnResourceProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDisableXpnResourceProjectRequest
                         * @property {string|null} [project] DisableXpnResourceProjectRequest project
                         * @property {google.cloud.compute.v1.IProjectsDisableXpnResourceRequest|null} [projectsDisableXpnResourceRequestResource] DisableXpnResourceProjectRequest projectsDisableXpnResourceRequestResource
                         * @property {string|null} [requestId] DisableXpnResourceProjectRequest requestId
                         */
    
                        /**
                         * Constructs a new DisableXpnResourceProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DisableXpnResourceProjectRequest.
                         * @implements IDisableXpnResourceProjectRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDisableXpnResourceProjectRequest=} [properties] Properties to set
                         */
                        function DisableXpnResourceProjectRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DisableXpnResourceProjectRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.DisableXpnResourceProjectRequest
                         * @instance
                         */
                        DisableXpnResourceProjectRequest.prototype.project = "";
    
                        /**
                         * DisableXpnResourceProjectRequest projectsDisableXpnResourceRequestResource.
                         * @member {google.cloud.compute.v1.IProjectsDisableXpnResourceRequest|null|undefined} projectsDisableXpnResourceRequestResource
                         * @memberof google.cloud.compute.v1.DisableXpnResourceProjectRequest
                         * @instance
                         */
                        DisableXpnResourceProjectRequest.prototype.projectsDisableXpnResourceRequestResource = null;
    
                        /**
                         * DisableXpnResourceProjectRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.DisableXpnResourceProjectRequest
                         * @instance
                         */
                        DisableXpnResourceProjectRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DisableXpnResourceProjectRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.DisableXpnResourceProjectRequest
                         * @instance
                         */
                        Object.defineProperty(DisableXpnResourceProjectRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DisableXpnResourceProjectRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DisableXpnResourceProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDisableXpnResourceProjectRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DisableXpnResourceProjectRequest} DisableXpnResourceProjectRequest instance
                         */
                        DisableXpnResourceProjectRequest.create = function create(properties) {
                            return new DisableXpnResourceProjectRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DisableXpnResourceProjectRequest message. Does not implicitly {@link google.cloud.compute.v1.DisableXpnResourceProjectRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DisableXpnResourceProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDisableXpnResourceProjectRequest} message DisableXpnResourceProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisableXpnResourceProjectRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.projectsDisableXpnResourceRequestResource != null && Object.hasOwnProperty.call(message, "projectsDisableXpnResourceRequestResource"))
                                $root.google.cloud.compute.v1.ProjectsDisableXpnResourceRequest.encode(message.projectsDisableXpnResourceRequestResource, writer.uint32(/* id 209136170, wireType 2 =*/1673089362).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DisableXpnResourceProjectRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DisableXpnResourceProjectRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DisableXpnResourceProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDisableXpnResourceProjectRequest} message DisableXpnResourceProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisableXpnResourceProjectRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DisableXpnResourceProjectRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DisableXpnResourceProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DisableXpnResourceProjectRequest} DisableXpnResourceProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisableXpnResourceProjectRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DisableXpnResourceProjectRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 209136170: {
                                        message.projectsDisableXpnResourceRequestResource = $root.google.cloud.compute.v1.ProjectsDisableXpnResourceRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DisableXpnResourceProjectRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DisableXpnResourceProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DisableXpnResourceProjectRequest} DisableXpnResourceProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisableXpnResourceProjectRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DisableXpnResourceProjectRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DisableXpnResourceProjectRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DisableXpnResourceProjectRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.projectsDisableXpnResourceRequestResource != null && message.hasOwnProperty("projectsDisableXpnResourceRequestResource")) {
                                var error = $root.google.cloud.compute.v1.ProjectsDisableXpnResourceRequest.verify(message.projectsDisableXpnResourceRequestResource);
                                if (error)
                                    return "projectsDisableXpnResourceRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DisableXpnResourceProjectRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DisableXpnResourceProjectRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DisableXpnResourceProjectRequest} DisableXpnResourceProjectRequest
                         */
                        DisableXpnResourceProjectRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DisableXpnResourceProjectRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DisableXpnResourceProjectRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.projectsDisableXpnResourceRequestResource != null) {
                                if (typeof object.projectsDisableXpnResourceRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.DisableXpnResourceProjectRequest.projectsDisableXpnResourceRequestResource: object expected");
                                message.projectsDisableXpnResourceRequestResource = $root.google.cloud.compute.v1.ProjectsDisableXpnResourceRequest.fromObject(object.projectsDisableXpnResourceRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DisableXpnResourceProjectRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DisableXpnResourceProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.DisableXpnResourceProjectRequest} message DisableXpnResourceProjectRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DisableXpnResourceProjectRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.projectsDisableXpnResourceRequestResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.projectsDisableXpnResourceRequestResource != null && message.hasOwnProperty("projectsDisableXpnResourceRequestResource"))
                                object.projectsDisableXpnResourceRequestResource = $root.google.cloud.compute.v1.ProjectsDisableXpnResourceRequest.toObject(message.projectsDisableXpnResourceRequestResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this DisableXpnResourceProjectRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DisableXpnResourceProjectRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DisableXpnResourceProjectRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DisableXpnResourceProjectRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DisableXpnResourceProjectRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DisableXpnResourceProjectRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DisableXpnResourceProjectRequest";
                        };
    
                        return DisableXpnResourceProjectRequest;
                    })();
    
                    v1.Disk = (function() {
    
                        /**
                         * Properties of a Disk.
                         * @memberof google.cloud.compute.v1
                         * @interface IDisk
                         * @property {string|null} [architecture] Disk architecture
                         * @property {string|null} [creationTimestamp] Disk creationTimestamp
                         * @property {string|null} [description] Disk description
                         * @property {google.cloud.compute.v1.ICustomerEncryptionKey|null} [diskEncryptionKey] Disk diskEncryptionKey
                         * @property {Array.<google.cloud.compute.v1.IGuestOsFeature>|null} [guestOsFeatures] Disk guestOsFeatures
                         * @property {number|Long|null} [id] Disk id
                         * @property {string|null} [kind] Disk kind
                         * @property {string|null} [labelFingerprint] Disk labelFingerprint
                         * @property {Object.<string,string>|null} [labels] Disk labels
                         * @property {string|null} [lastAttachTimestamp] Disk lastAttachTimestamp
                         * @property {string|null} [lastDetachTimestamp] Disk lastDetachTimestamp
                         * @property {Array.<number|Long>|null} [licenseCodes] Disk licenseCodes
                         * @property {Array.<string>|null} [licenses] Disk licenses
                         * @property {string|null} [locationHint] Disk locationHint
                         * @property {string|null} [name] Disk name
                         * @property {string|null} [options] Disk options
                         * @property {google.cloud.compute.v1.IDiskParams|null} [params] Disk params
                         * @property {number|Long|null} [physicalBlockSizeBytes] Disk physicalBlockSizeBytes
                         * @property {number|Long|null} [provisionedIops] Disk provisionedIops
                         * @property {string|null} [region] Disk region
                         * @property {Array.<string>|null} [replicaZones] Disk replicaZones
                         * @property {Array.<string>|null} [resourcePolicies] Disk resourcePolicies
                         * @property {boolean|null} [satisfiesPzs] Disk satisfiesPzs
                         * @property {string|null} [selfLink] Disk selfLink
                         * @property {number|Long|null} [sizeGb] Disk sizeGb
                         * @property {string|null} [sourceDisk] Disk sourceDisk
                         * @property {string|null} [sourceDiskId] Disk sourceDiskId
                         * @property {string|null} [sourceImage] Disk sourceImage
                         * @property {google.cloud.compute.v1.ICustomerEncryptionKey|null} [sourceImageEncryptionKey] Disk sourceImageEncryptionKey
                         * @property {string|null} [sourceImageId] Disk sourceImageId
                         * @property {string|null} [sourceSnapshot] Disk sourceSnapshot
                         * @property {google.cloud.compute.v1.ICustomerEncryptionKey|null} [sourceSnapshotEncryptionKey] Disk sourceSnapshotEncryptionKey
                         * @property {string|null} [sourceSnapshotId] Disk sourceSnapshotId
                         * @property {string|null} [sourceStorageObject] Disk sourceStorageObject
                         * @property {string|null} [status] Disk status
                         * @property {string|null} [type] Disk type
                         * @property {Array.<string>|null} [users] Disk users
                         * @property {string|null} [zone] Disk zone
                         */
    
                        /**
                         * Constructs a new Disk.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Disk.
                         * @implements IDisk
                         * @constructor
                         * @param {google.cloud.compute.v1.IDisk=} [properties] Properties to set
                         */
                        function Disk(properties) {
                            this.guestOsFeatures = [];
                            this.labels = {};
                            this.licenseCodes = [];
                            this.licenses = [];
                            this.replicaZones = [];
                            this.resourcePolicies = [];
                            this.users = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Disk architecture.
                         * @member {string|null|undefined} architecture
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.architecture = null;
    
                        /**
                         * Disk creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.creationTimestamp = null;
    
                        /**
                         * Disk description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.description = null;
    
                        /**
                         * Disk diskEncryptionKey.
                         * @member {google.cloud.compute.v1.ICustomerEncryptionKey|null|undefined} diskEncryptionKey
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.diskEncryptionKey = null;
    
                        /**
                         * Disk guestOsFeatures.
                         * @member {Array.<google.cloud.compute.v1.IGuestOsFeature>} guestOsFeatures
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.guestOsFeatures = $util.emptyArray;
    
                        /**
                         * Disk id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.id = null;
    
                        /**
                         * Disk kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.kind = null;
    
                        /**
                         * Disk labelFingerprint.
                         * @member {string|null|undefined} labelFingerprint
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.labelFingerprint = null;
    
                        /**
                         * Disk labels.
                         * @member {Object.<string,string>} labels
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.labels = $util.emptyObject;
    
                        /**
                         * Disk lastAttachTimestamp.
                         * @member {string|null|undefined} lastAttachTimestamp
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.lastAttachTimestamp = null;
    
                        /**
                         * Disk lastDetachTimestamp.
                         * @member {string|null|undefined} lastDetachTimestamp
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.lastDetachTimestamp = null;
    
                        /**
                         * Disk licenseCodes.
                         * @member {Array.<number|Long>} licenseCodes
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.licenseCodes = $util.emptyArray;
    
                        /**
                         * Disk licenses.
                         * @member {Array.<string>} licenses
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.licenses = $util.emptyArray;
    
                        /**
                         * Disk locationHint.
                         * @member {string|null|undefined} locationHint
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.locationHint = null;
    
                        /**
                         * Disk name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.name = null;
    
                        /**
                         * Disk options.
                         * @member {string|null|undefined} options
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.options = null;
    
                        /**
                         * Disk params.
                         * @member {google.cloud.compute.v1.IDiskParams|null|undefined} params
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.params = null;
    
                        /**
                         * Disk physicalBlockSizeBytes.
                         * @member {number|Long|null|undefined} physicalBlockSizeBytes
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.physicalBlockSizeBytes = null;
    
                        /**
                         * Disk provisionedIops.
                         * @member {number|Long|null|undefined} provisionedIops
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.provisionedIops = null;
    
                        /**
                         * Disk region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.region = null;
    
                        /**
                         * Disk replicaZones.
                         * @member {Array.<string>} replicaZones
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.replicaZones = $util.emptyArray;
    
                        /**
                         * Disk resourcePolicies.
                         * @member {Array.<string>} resourcePolicies
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.resourcePolicies = $util.emptyArray;
    
                        /**
                         * Disk satisfiesPzs.
                         * @member {boolean|null|undefined} satisfiesPzs
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.satisfiesPzs = null;
    
                        /**
                         * Disk selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.selfLink = null;
    
                        /**
                         * Disk sizeGb.
                         * @member {number|Long|null|undefined} sizeGb
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.sizeGb = null;
    
                        /**
                         * Disk sourceDisk.
                         * @member {string|null|undefined} sourceDisk
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.sourceDisk = null;
    
                        /**
                         * Disk sourceDiskId.
                         * @member {string|null|undefined} sourceDiskId
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.sourceDiskId = null;
    
                        /**
                         * Disk sourceImage.
                         * @member {string|null|undefined} sourceImage
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.sourceImage = null;
    
                        /**
                         * Disk sourceImageEncryptionKey.
                         * @member {google.cloud.compute.v1.ICustomerEncryptionKey|null|undefined} sourceImageEncryptionKey
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.sourceImageEncryptionKey = null;
    
                        /**
                         * Disk sourceImageId.
                         * @member {string|null|undefined} sourceImageId
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.sourceImageId = null;
    
                        /**
                         * Disk sourceSnapshot.
                         * @member {string|null|undefined} sourceSnapshot
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.sourceSnapshot = null;
    
                        /**
                         * Disk sourceSnapshotEncryptionKey.
                         * @member {google.cloud.compute.v1.ICustomerEncryptionKey|null|undefined} sourceSnapshotEncryptionKey
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.sourceSnapshotEncryptionKey = null;
    
                        /**
                         * Disk sourceSnapshotId.
                         * @member {string|null|undefined} sourceSnapshotId
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.sourceSnapshotId = null;
    
                        /**
                         * Disk sourceStorageObject.
                         * @member {string|null|undefined} sourceStorageObject
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.sourceStorageObject = null;
    
                        /**
                         * Disk status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.status = null;
    
                        /**
                         * Disk type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.type = null;
    
                        /**
                         * Disk users.
                         * @member {Array.<string>} users
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.users = $util.emptyArray;
    
                        /**
                         * Disk zone.
                         * @member {string|null|undefined} zone
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Disk.prototype.zone = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Disk _architecture.
                         * @member {"architecture"|undefined} _architecture
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_architecture", {
                            get: $util.oneOfGetter($oneOfFields = ["architecture"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _diskEncryptionKey.
                         * @member {"diskEncryptionKey"|undefined} _diskEncryptionKey
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_diskEncryptionKey", {
                            get: $util.oneOfGetter($oneOfFields = ["diskEncryptionKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _labelFingerprint.
                         * @member {"labelFingerprint"|undefined} _labelFingerprint
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_labelFingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["labelFingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _lastAttachTimestamp.
                         * @member {"lastAttachTimestamp"|undefined} _lastAttachTimestamp
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_lastAttachTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["lastAttachTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _lastDetachTimestamp.
                         * @member {"lastDetachTimestamp"|undefined} _lastDetachTimestamp
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_lastDetachTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["lastDetachTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _locationHint.
                         * @member {"locationHint"|undefined} _locationHint
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_locationHint", {
                            get: $util.oneOfGetter($oneOfFields = ["locationHint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _options.
                         * @member {"options"|undefined} _options
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_options", {
                            get: $util.oneOfGetter($oneOfFields = ["options"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _params.
                         * @member {"params"|undefined} _params
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_params", {
                            get: $util.oneOfGetter($oneOfFields = ["params"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _physicalBlockSizeBytes.
                         * @member {"physicalBlockSizeBytes"|undefined} _physicalBlockSizeBytes
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_physicalBlockSizeBytes", {
                            get: $util.oneOfGetter($oneOfFields = ["physicalBlockSizeBytes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _provisionedIops.
                         * @member {"provisionedIops"|undefined} _provisionedIops
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_provisionedIops", {
                            get: $util.oneOfGetter($oneOfFields = ["provisionedIops"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _satisfiesPzs.
                         * @member {"satisfiesPzs"|undefined} _satisfiesPzs
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_satisfiesPzs", {
                            get: $util.oneOfGetter($oneOfFields = ["satisfiesPzs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _sizeGb.
                         * @member {"sizeGb"|undefined} _sizeGb
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_sizeGb", {
                            get: $util.oneOfGetter($oneOfFields = ["sizeGb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _sourceDisk.
                         * @member {"sourceDisk"|undefined} _sourceDisk
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_sourceDisk", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceDisk"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _sourceDiskId.
                         * @member {"sourceDiskId"|undefined} _sourceDiskId
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_sourceDiskId", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceDiskId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _sourceImage.
                         * @member {"sourceImage"|undefined} _sourceImage
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_sourceImage", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceImage"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _sourceImageEncryptionKey.
                         * @member {"sourceImageEncryptionKey"|undefined} _sourceImageEncryptionKey
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_sourceImageEncryptionKey", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceImageEncryptionKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _sourceImageId.
                         * @member {"sourceImageId"|undefined} _sourceImageId
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_sourceImageId", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceImageId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _sourceSnapshot.
                         * @member {"sourceSnapshot"|undefined} _sourceSnapshot
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_sourceSnapshot", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceSnapshot"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _sourceSnapshotEncryptionKey.
                         * @member {"sourceSnapshotEncryptionKey"|undefined} _sourceSnapshotEncryptionKey
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_sourceSnapshotEncryptionKey", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceSnapshotEncryptionKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _sourceSnapshotId.
                         * @member {"sourceSnapshotId"|undefined} _sourceSnapshotId
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_sourceSnapshotId", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceSnapshotId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _sourceStorageObject.
                         * @member {"sourceStorageObject"|undefined} _sourceStorageObject
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_sourceStorageObject", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceStorageObject"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Disk _zone.
                         * @member {"zone"|undefined} _zone
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         */
                        Object.defineProperty(Disk.prototype, "_zone", {
                            get: $util.oneOfGetter($oneOfFields = ["zone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Disk instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Disk
                         * @static
                         * @param {google.cloud.compute.v1.IDisk=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Disk} Disk instance
                         */
                        Disk.create = function create(properties) {
                            return new Disk(properties);
                        };
    
                        /**
                         * Encodes the specified Disk message. Does not implicitly {@link google.cloud.compute.v1.Disk.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Disk
                         * @static
                         * @param {google.cloud.compute.v1.IDisk} message Disk message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Disk.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.resourcePolicies != null && message.resourcePolicies.length)
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    writer.uint32(/* id 22220385, wireType 2 =*/177763082).string(message.resourcePolicies[i]);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.lastAttachTimestamp != null && Object.hasOwnProperty.call(message, "lastAttachTimestamp"))
                                writer.uint32(/* id 42159653, wireType 2 =*/337277226).string(message.lastAttachTimestamp);
                            if (message.licenseCodes != null && message.licenseCodes.length) {
                                writer.uint32(/* id 45482664, wireType 2 =*/363861314).fork();
                                for (var i = 0; i < message.licenseCodes.length; ++i)
                                    writer.int64(message.licenseCodes[i]);
                                writer.ldelim();
                            }
                            if (message.replicaZones != null && message.replicaZones.length)
                                for (var i = 0; i < message.replicaZones.length; ++i)
                                    writer.uint32(/* id 48438272, wireType 2 =*/387506178).string(message.replicaZones[i]);
                            if (message.sourceImage != null && Object.hasOwnProperty.call(message, "sourceImage"))
                                writer.uint32(/* id 50443319, wireType 2 =*/403546554).string(message.sourceImage);
                            if (message.sourceImageId != null && Object.hasOwnProperty.call(message, "sourceImageId"))
                                writer.uint32(/* id 55328291, wireType 2 =*/442626330).string(message.sourceImageId);
                            if (message.lastDetachTimestamp != null && Object.hasOwnProperty.call(message, "lastDetachTimestamp"))
                                writer.uint32(/* id 56471027, wireType 2 =*/451768218).string(message.lastDetachTimestamp);
                            if (message.params != null && Object.hasOwnProperty.call(message, "params"))
                                $root.google.cloud.compute.v1.DiskParams.encode(message.params, writer.uint32(/* id 78313862, wireType 2 =*/626510898).fork()).ldelim();
                            if (message.guestOsFeatures != null && message.guestOsFeatures.length)
                                for (var i = 0; i < message.guestOsFeatures.length; ++i)
                                    $root.google.cloud.compute.v1.GuestOsFeature.encode(message.guestOsFeatures[i], writer.uint32(/* id 79294545, wireType 2 =*/634356362).fork()).ldelim();
                            if (message.sourceSnapshotId != null && Object.hasOwnProperty.call(message, "sourceSnapshotId"))
                                writer.uint32(/* id 98962258, wireType 2 =*/791698066).string(message.sourceSnapshotId);
                            if (message.users != null && message.users.length)
                                for (var i = 0; i < message.users.length; ++i)
                                    writer.uint32(/* id 111578632, wireType 2 =*/892629058).string(message.users[i]);
                            if (message.sourceSnapshot != null && Object.hasOwnProperty.call(message, "sourceSnapshot"))
                                writer.uint32(/* id 126061928, wireType 2 =*/1008495426).string(message.sourceSnapshot);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.labelFingerprint != null && Object.hasOwnProperty.call(message, "labelFingerprint"))
                                writer.uint32(/* id 178124825, wireType 2 =*/1424998602).string(message.labelFingerprint);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.provisionedIops != null && Object.hasOwnProperty.call(message, "provisionedIops"))
                                writer.uint32(/* id 186769108, wireType 0 =*/1494152864).int64(message.provisionedIops);
                            if (message.sourceStorageObject != null && Object.hasOwnProperty.call(message, "sourceStorageObject"))
                                writer.uint32(/* id 233052711, wireType 2 =*/1864421690).string(message.sourceStorageObject);
                            if (message.diskEncryptionKey != null && Object.hasOwnProperty.call(message, "diskEncryptionKey"))
                                $root.google.cloud.compute.v1.CustomerEncryptionKey.encode(message.diskEncryptionKey, writer.uint32(/* id 271660677, wireType 2 =*/2173285418).fork()).ldelim();
                            if (message.architecture != null && Object.hasOwnProperty.call(message, "architecture"))
                                writer.uint32(/* id 302803283, wireType 2 =*/2422426266).string(message.architecture);
                            if (message.sourceSnapshotEncryptionKey != null && Object.hasOwnProperty.call(message, "sourceSnapshotEncryptionKey"))
                                $root.google.cloud.compute.v1.CustomerEncryptionKey.encode(message.sourceSnapshotEncryptionKey, writer.uint32(/* id 303679322, wireType 2 =*/2429434578).fork()).ldelim();
                            if (message.licenses != null && message.licenses.length)
                                for (var i = 0; i < message.licenses.length; ++i)
                                    writer.uint32(/* id 337642578, wireType 2 =*/2701140626).string(message.licenses[i]);
                            if (message.locationHint != null && Object.hasOwnProperty.call(message, "locationHint"))
                                writer.uint32(/* id 350519505, wireType 2 =*/2804156042).string(message.locationHint);
                            if (message.options != null && Object.hasOwnProperty.call(message, "options"))
                                writer.uint32(/* id 361137822, wireType 2 =*/2889102578).string(message.options);
                            if (message.sourceImageEncryptionKey != null && Object.hasOwnProperty.call(message, "sourceImageEncryptionKey"))
                                $root.google.cloud.compute.v1.CustomerEncryptionKey.encode(message.sourceImageEncryptionKey, writer.uint32(/* id 381503659, wireType 2 =*/3052029274).fork()).ldelim();
                            if (message.physicalBlockSizeBytes != null && Object.hasOwnProperty.call(message, "physicalBlockSizeBytes"))
                                writer.uint32(/* id 420007943, wireType 0 =*/3360063544).int64(message.physicalBlockSizeBytes);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.sourceDisk != null && Object.hasOwnProperty.call(message, "sourceDisk"))
                                writer.uint32(/* id 451753793, wireType 2 =*/3614030346).string(message.sourceDisk);
                            if (message.sourceDiskId != null && Object.hasOwnProperty.call(message, "sourceDiskId"))
                                writer.uint32(/* id 454190809, wireType 2 =*/3633526474).string(message.sourceDiskId);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.satisfiesPzs != null && Object.hasOwnProperty.call(message, "satisfiesPzs"))
                                writer.uint32(/* id 480964267, wireType 0 =*/3847714136).bool(message.satisfiesPzs);
                            if (message.sizeGb != null && Object.hasOwnProperty.call(message, "sizeGb"))
                                writer.uint32(/* id 494929369, wireType 0 =*/3959434952).int64(message.sizeGb);
                            if (message.labels != null && Object.hasOwnProperty.call(message, "labels"))
                                for (var keys = Object.keys(message.labels), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 500195327, wireType 2 =*/4001562618).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.labels[keys[i]]).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Disk message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Disk.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Disk
                         * @static
                         * @param {google.cloud.compute.v1.IDisk} message Disk message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Disk.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Disk message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Disk
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Disk} Disk
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Disk.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Disk(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 302803283: {
                                        message.architecture = reader.string();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 271660677: {
                                        message.diskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 79294545: {
                                        if (!(message.guestOsFeatures && message.guestOsFeatures.length))
                                            message.guestOsFeatures = [];
                                        message.guestOsFeatures.push($root.google.cloud.compute.v1.GuestOsFeature.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 178124825: {
                                        message.labelFingerprint = reader.string();
                                        break;
                                    }
                                case 500195327: {
                                        if (message.labels === $util.emptyObject)
                                            message.labels = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.labels[key] = value;
                                        break;
                                    }
                                case 42159653: {
                                        message.lastAttachTimestamp = reader.string();
                                        break;
                                    }
                                case 56471027: {
                                        message.lastDetachTimestamp = reader.string();
                                        break;
                                    }
                                case 45482664: {
                                        if (!(message.licenseCodes && message.licenseCodes.length))
                                            message.licenseCodes = [];
                                        if ((tag & 7) === 2) {
                                            var end2 = reader.uint32() + reader.pos;
                                            while (reader.pos < end2)
                                                message.licenseCodes.push(reader.int64());
                                        } else
                                            message.licenseCodes.push(reader.int64());
                                        break;
                                    }
                                case 337642578: {
                                        if (!(message.licenses && message.licenses.length))
                                            message.licenses = [];
                                        message.licenses.push(reader.string());
                                        break;
                                    }
                                case 350519505: {
                                        message.locationHint = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 361137822: {
                                        message.options = reader.string();
                                        break;
                                    }
                                case 78313862: {
                                        message.params = $root.google.cloud.compute.v1.DiskParams.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 420007943: {
                                        message.physicalBlockSizeBytes = reader.int64();
                                        break;
                                    }
                                case 186769108: {
                                        message.provisionedIops = reader.int64();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 48438272: {
                                        if (!(message.replicaZones && message.replicaZones.length))
                                            message.replicaZones = [];
                                        message.replicaZones.push(reader.string());
                                        break;
                                    }
                                case 22220385: {
                                        if (!(message.resourcePolicies && message.resourcePolicies.length))
                                            message.resourcePolicies = [];
                                        message.resourcePolicies.push(reader.string());
                                        break;
                                    }
                                case 480964267: {
                                        message.satisfiesPzs = reader.bool();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 494929369: {
                                        message.sizeGb = reader.int64();
                                        break;
                                    }
                                case 451753793: {
                                        message.sourceDisk = reader.string();
                                        break;
                                    }
                                case 454190809: {
                                        message.sourceDiskId = reader.string();
                                        break;
                                    }
                                case 50443319: {
                                        message.sourceImage = reader.string();
                                        break;
                                    }
                                case 381503659: {
                                        message.sourceImageEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 55328291: {
                                        message.sourceImageId = reader.string();
                                        break;
                                    }
                                case 126061928: {
                                        message.sourceSnapshot = reader.string();
                                        break;
                                    }
                                case 303679322: {
                                        message.sourceSnapshotEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 98962258: {
                                        message.sourceSnapshotId = reader.string();
                                        break;
                                    }
                                case 233052711: {
                                        message.sourceStorageObject = reader.string();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                case 111578632: {
                                        if (!(message.users && message.users.length))
                                            message.users = [];
                                        message.users.push(reader.string());
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Disk message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Disk
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Disk} Disk
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Disk.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Disk message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Disk
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Disk.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.architecture != null && message.hasOwnProperty("architecture")) {
                                properties._architecture = 1;
                                if (!$util.isString(message.architecture))
                                    return "architecture: string expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.diskEncryptionKey != null && message.hasOwnProperty("diskEncryptionKey")) {
                                properties._diskEncryptionKey = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.CustomerEncryptionKey.verify(message.diskEncryptionKey);
                                    if (error)
                                        return "diskEncryptionKey." + error;
                                }
                            }
                            if (message.guestOsFeatures != null && message.hasOwnProperty("guestOsFeatures")) {
                                if (!Array.isArray(message.guestOsFeatures))
                                    return "guestOsFeatures: array expected";
                                for (var i = 0; i < message.guestOsFeatures.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.GuestOsFeature.verify(message.guestOsFeatures[i]);
                                    if (error)
                                        return "guestOsFeatures." + error;
                                }
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                properties._labelFingerprint = 1;
                                if (!$util.isString(message.labelFingerprint))
                                    return "labelFingerprint: string expected";
                            }
                            if (message.labels != null && message.hasOwnProperty("labels")) {
                                if (!$util.isObject(message.labels))
                                    return "labels: object expected";
                                var key = Object.keys(message.labels);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.labels[key[i]]))
                                        return "labels: string{k:string} expected";
                            }
                            if (message.lastAttachTimestamp != null && message.hasOwnProperty("lastAttachTimestamp")) {
                                properties._lastAttachTimestamp = 1;
                                if (!$util.isString(message.lastAttachTimestamp))
                                    return "lastAttachTimestamp: string expected";
                            }
                            if (message.lastDetachTimestamp != null && message.hasOwnProperty("lastDetachTimestamp")) {
                                properties._lastDetachTimestamp = 1;
                                if (!$util.isString(message.lastDetachTimestamp))
                                    return "lastDetachTimestamp: string expected";
                            }
                            if (message.licenseCodes != null && message.hasOwnProperty("licenseCodes")) {
                                if (!Array.isArray(message.licenseCodes))
                                    return "licenseCodes: array expected";
                                for (var i = 0; i < message.licenseCodes.length; ++i)
                                    if (!$util.isInteger(message.licenseCodes[i]) && !(message.licenseCodes[i] && $util.isInteger(message.licenseCodes[i].low) && $util.isInteger(message.licenseCodes[i].high)))
                                        return "licenseCodes: integer|Long[] expected";
                            }
                            if (message.licenses != null && message.hasOwnProperty("licenses")) {
                                if (!Array.isArray(message.licenses))
                                    return "licenses: array expected";
                                for (var i = 0; i < message.licenses.length; ++i)
                                    if (!$util.isString(message.licenses[i]))
                                        return "licenses: string[] expected";
                            }
                            if (message.locationHint != null && message.hasOwnProperty("locationHint")) {
                                properties._locationHint = 1;
                                if (!$util.isString(message.locationHint))
                                    return "locationHint: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.options != null && message.hasOwnProperty("options")) {
                                properties._options = 1;
                                if (!$util.isString(message.options))
                                    return "options: string expected";
                            }
                            if (message.params != null && message.hasOwnProperty("params")) {
                                properties._params = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.DiskParams.verify(message.params);
                                    if (error)
                                        return "params." + error;
                                }
                            }
                            if (message.physicalBlockSizeBytes != null && message.hasOwnProperty("physicalBlockSizeBytes")) {
                                properties._physicalBlockSizeBytes = 1;
                                if (!$util.isInteger(message.physicalBlockSizeBytes) && !(message.physicalBlockSizeBytes && $util.isInteger(message.physicalBlockSizeBytes.low) && $util.isInteger(message.physicalBlockSizeBytes.high)))
                                    return "physicalBlockSizeBytes: integer|Long expected";
                            }
                            if (message.provisionedIops != null && message.hasOwnProperty("provisionedIops")) {
                                properties._provisionedIops = 1;
                                if (!$util.isInteger(message.provisionedIops) && !(message.provisionedIops && $util.isInteger(message.provisionedIops.low) && $util.isInteger(message.provisionedIops.high)))
                                    return "provisionedIops: integer|Long expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.replicaZones != null && message.hasOwnProperty("replicaZones")) {
                                if (!Array.isArray(message.replicaZones))
                                    return "replicaZones: array expected";
                                for (var i = 0; i < message.replicaZones.length; ++i)
                                    if (!$util.isString(message.replicaZones[i]))
                                        return "replicaZones: string[] expected";
                            }
                            if (message.resourcePolicies != null && message.hasOwnProperty("resourcePolicies")) {
                                if (!Array.isArray(message.resourcePolicies))
                                    return "resourcePolicies: array expected";
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    if (!$util.isString(message.resourcePolicies[i]))
                                        return "resourcePolicies: string[] expected";
                            }
                            if (message.satisfiesPzs != null && message.hasOwnProperty("satisfiesPzs")) {
                                properties._satisfiesPzs = 1;
                                if (typeof message.satisfiesPzs !== "boolean")
                                    return "satisfiesPzs: boolean expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.sizeGb != null && message.hasOwnProperty("sizeGb")) {
                                properties._sizeGb = 1;
                                if (!$util.isInteger(message.sizeGb) && !(message.sizeGb && $util.isInteger(message.sizeGb.low) && $util.isInteger(message.sizeGb.high)))
                                    return "sizeGb: integer|Long expected";
                            }
                            if (message.sourceDisk != null && message.hasOwnProperty("sourceDisk")) {
                                properties._sourceDisk = 1;
                                if (!$util.isString(message.sourceDisk))
                                    return "sourceDisk: string expected";
                            }
                            if (message.sourceDiskId != null && message.hasOwnProperty("sourceDiskId")) {
                                properties._sourceDiskId = 1;
                                if (!$util.isString(message.sourceDiskId))
                                    return "sourceDiskId: string expected";
                            }
                            if (message.sourceImage != null && message.hasOwnProperty("sourceImage")) {
                                properties._sourceImage = 1;
                                if (!$util.isString(message.sourceImage))
                                    return "sourceImage: string expected";
                            }
                            if (message.sourceImageEncryptionKey != null && message.hasOwnProperty("sourceImageEncryptionKey")) {
                                properties._sourceImageEncryptionKey = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.CustomerEncryptionKey.verify(message.sourceImageEncryptionKey);
                                    if (error)
                                        return "sourceImageEncryptionKey." + error;
                                }
                            }
                            if (message.sourceImageId != null && message.hasOwnProperty("sourceImageId")) {
                                properties._sourceImageId = 1;
                                if (!$util.isString(message.sourceImageId))
                                    return "sourceImageId: string expected";
                            }
                            if (message.sourceSnapshot != null && message.hasOwnProperty("sourceSnapshot")) {
                                properties._sourceSnapshot = 1;
                                if (!$util.isString(message.sourceSnapshot))
                                    return "sourceSnapshot: string expected";
                            }
                            if (message.sourceSnapshotEncryptionKey != null && message.hasOwnProperty("sourceSnapshotEncryptionKey")) {
                                properties._sourceSnapshotEncryptionKey = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.CustomerEncryptionKey.verify(message.sourceSnapshotEncryptionKey);
                                    if (error)
                                        return "sourceSnapshotEncryptionKey." + error;
                                }
                            }
                            if (message.sourceSnapshotId != null && message.hasOwnProperty("sourceSnapshotId")) {
                                properties._sourceSnapshotId = 1;
                                if (!$util.isString(message.sourceSnapshotId))
                                    return "sourceSnapshotId: string expected";
                            }
                            if (message.sourceStorageObject != null && message.hasOwnProperty("sourceStorageObject")) {
                                properties._sourceStorageObject = 1;
                                if (!$util.isString(message.sourceStorageObject))
                                    return "sourceStorageObject: string expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            if (message.users != null && message.hasOwnProperty("users")) {
                                if (!Array.isArray(message.users))
                                    return "users: array expected";
                                for (var i = 0; i < message.users.length; ++i)
                                    if (!$util.isString(message.users[i]))
                                        return "users: string[] expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                properties._zone = 1;
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Disk message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Disk
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Disk} Disk
                         */
                        Disk.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Disk)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Disk();
                            if (object.architecture != null)
                                message.architecture = String(object.architecture);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.diskEncryptionKey != null) {
                                if (typeof object.diskEncryptionKey !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Disk.diskEncryptionKey: object expected");
                                message.diskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.fromObject(object.diskEncryptionKey);
                            }
                            if (object.guestOsFeatures) {
                                if (!Array.isArray(object.guestOsFeatures))
                                    throw TypeError(".google.cloud.compute.v1.Disk.guestOsFeatures: array expected");
                                message.guestOsFeatures = [];
                                for (var i = 0; i < object.guestOsFeatures.length; ++i) {
                                    if (typeof object.guestOsFeatures[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Disk.guestOsFeatures: object expected");
                                    message.guestOsFeatures[i] = $root.google.cloud.compute.v1.GuestOsFeature.fromObject(object.guestOsFeatures[i]);
                                }
                            }
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.labelFingerprint != null)
                                message.labelFingerprint = String(object.labelFingerprint);
                            if (object.labels) {
                                if (typeof object.labels !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Disk.labels: object expected");
                                message.labels = {};
                                for (var keys = Object.keys(object.labels), i = 0; i < keys.length; ++i)
                                    message.labels[keys[i]] = String(object.labels[keys[i]]);
                            }
                            if (object.lastAttachTimestamp != null)
                                message.lastAttachTimestamp = String(object.lastAttachTimestamp);
                            if (object.lastDetachTimestamp != null)
                                message.lastDetachTimestamp = String(object.lastDetachTimestamp);
                            if (object.licenseCodes) {
                                if (!Array.isArray(object.licenseCodes))
                                    throw TypeError(".google.cloud.compute.v1.Disk.licenseCodes: array expected");
                                message.licenseCodes = [];
                                for (var i = 0; i < object.licenseCodes.length; ++i)
                                    if ($util.Long)
                                        (message.licenseCodes[i] = $util.Long.fromValue(object.licenseCodes[i])).unsigned = false;
                                    else if (typeof object.licenseCodes[i] === "string")
                                        message.licenseCodes[i] = parseInt(object.licenseCodes[i], 10);
                                    else if (typeof object.licenseCodes[i] === "number")
                                        message.licenseCodes[i] = object.licenseCodes[i];
                                    else if (typeof object.licenseCodes[i] === "object")
                                        message.licenseCodes[i] = new $util.LongBits(object.licenseCodes[i].low >>> 0, object.licenseCodes[i].high >>> 0).toNumber();
                            }
                            if (object.licenses) {
                                if (!Array.isArray(object.licenses))
                                    throw TypeError(".google.cloud.compute.v1.Disk.licenses: array expected");
                                message.licenses = [];
                                for (var i = 0; i < object.licenses.length; ++i)
                                    message.licenses[i] = String(object.licenses[i]);
                            }
                            if (object.locationHint != null)
                                message.locationHint = String(object.locationHint);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.options != null)
                                message.options = String(object.options);
                            if (object.params != null) {
                                if (typeof object.params !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Disk.params: object expected");
                                message.params = $root.google.cloud.compute.v1.DiskParams.fromObject(object.params);
                            }
                            if (object.physicalBlockSizeBytes != null)
                                if ($util.Long)
                                    (message.physicalBlockSizeBytes = $util.Long.fromValue(object.physicalBlockSizeBytes)).unsigned = false;
                                else if (typeof object.physicalBlockSizeBytes === "string")
                                    message.physicalBlockSizeBytes = parseInt(object.physicalBlockSizeBytes, 10);
                                else if (typeof object.physicalBlockSizeBytes === "number")
                                    message.physicalBlockSizeBytes = object.physicalBlockSizeBytes;
                                else if (typeof object.physicalBlockSizeBytes === "object")
                                    message.physicalBlockSizeBytes = new $util.LongBits(object.physicalBlockSizeBytes.low >>> 0, object.physicalBlockSizeBytes.high >>> 0).toNumber();
                            if (object.provisionedIops != null)
                                if ($util.Long)
                                    (message.provisionedIops = $util.Long.fromValue(object.provisionedIops)).unsigned = false;
                                else if (typeof object.provisionedIops === "string")
                                    message.provisionedIops = parseInt(object.provisionedIops, 10);
                                else if (typeof object.provisionedIops === "number")
                                    message.provisionedIops = object.provisionedIops;
                                else if (typeof object.provisionedIops === "object")
                                    message.provisionedIops = new $util.LongBits(object.provisionedIops.low >>> 0, object.provisionedIops.high >>> 0).toNumber();
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.replicaZones) {
                                if (!Array.isArray(object.replicaZones))
                                    throw TypeError(".google.cloud.compute.v1.Disk.replicaZones: array expected");
                                message.replicaZones = [];
                                for (var i = 0; i < object.replicaZones.length; ++i)
                                    message.replicaZones[i] = String(object.replicaZones[i]);
                            }
                            if (object.resourcePolicies) {
                                if (!Array.isArray(object.resourcePolicies))
                                    throw TypeError(".google.cloud.compute.v1.Disk.resourcePolicies: array expected");
                                message.resourcePolicies = [];
                                for (var i = 0; i < object.resourcePolicies.length; ++i)
                                    message.resourcePolicies[i] = String(object.resourcePolicies[i]);
                            }
                            if (object.satisfiesPzs != null)
                                message.satisfiesPzs = Boolean(object.satisfiesPzs);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.sizeGb != null)
                                if ($util.Long)
                                    (message.sizeGb = $util.Long.fromValue(object.sizeGb)).unsigned = false;
                                else if (typeof object.sizeGb === "string")
                                    message.sizeGb = parseInt(object.sizeGb, 10);
                                else if (typeof object.sizeGb === "number")
                                    message.sizeGb = object.sizeGb;
                                else if (typeof object.sizeGb === "object")
                                    message.sizeGb = new $util.LongBits(object.sizeGb.low >>> 0, object.sizeGb.high >>> 0).toNumber();
                            if (object.sourceDisk != null)
                                message.sourceDisk = String(object.sourceDisk);
                            if (object.sourceDiskId != null)
                                message.sourceDiskId = String(object.sourceDiskId);
                            if (object.sourceImage != null)
                                message.sourceImage = String(object.sourceImage);
                            if (object.sourceImageEncryptionKey != null) {
                                if (typeof object.sourceImageEncryptionKey !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Disk.sourceImageEncryptionKey: object expected");
                                message.sourceImageEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.fromObject(object.sourceImageEncryptionKey);
                            }
                            if (object.sourceImageId != null)
                                message.sourceImageId = String(object.sourceImageId);
                            if (object.sourceSnapshot != null)
                                message.sourceSnapshot = String(object.sourceSnapshot);
                            if (object.sourceSnapshotEncryptionKey != null) {
                                if (typeof object.sourceSnapshotEncryptionKey !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Disk.sourceSnapshotEncryptionKey: object expected");
                                message.sourceSnapshotEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.fromObject(object.sourceSnapshotEncryptionKey);
                            }
                            if (object.sourceSnapshotId != null)
                                message.sourceSnapshotId = String(object.sourceSnapshotId);
                            if (object.sourceStorageObject != null)
                                message.sourceStorageObject = String(object.sourceStorageObject);
                            if (object.status != null)
                                message.status = String(object.status);
                            if (object.type != null)
                                message.type = String(object.type);
                            if (object.users) {
                                if (!Array.isArray(object.users))
                                    throw TypeError(".google.cloud.compute.v1.Disk.users: array expected");
                                message.users = [];
                                for (var i = 0; i < object.users.length; ++i)
                                    message.users[i] = String(object.users[i]);
                            }
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Disk message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Disk
                         * @static
                         * @param {google.cloud.compute.v1.Disk} message Disk
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Disk.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.resourcePolicies = [];
                                object.licenseCodes = [];
                                object.replicaZones = [];
                                object.guestOsFeatures = [];
                                object.users = [];
                                object.licenses = [];
                            }
                            if (options.objects || options.defaults)
                                object.labels = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                object.zone = message.zone;
                                if (options.oneofs)
                                    object._zone = "zone";
                            }
                            if (message.resourcePolicies && message.resourcePolicies.length) {
                                object.resourcePolicies = [];
                                for (var j = 0; j < message.resourcePolicies.length; ++j)
                                    object.resourcePolicies[j] = message.resourcePolicies[j];
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.lastAttachTimestamp != null && message.hasOwnProperty("lastAttachTimestamp")) {
                                object.lastAttachTimestamp = message.lastAttachTimestamp;
                                if (options.oneofs)
                                    object._lastAttachTimestamp = "lastAttachTimestamp";
                            }
                            if (message.licenseCodes && message.licenseCodes.length) {
                                object.licenseCodes = [];
                                for (var j = 0; j < message.licenseCodes.length; ++j)
                                    if (typeof message.licenseCodes[j] === "number")
                                        object.licenseCodes[j] = options.longs === String ? String(message.licenseCodes[j]) : message.licenseCodes[j];
                                    else
                                        object.licenseCodes[j] = options.longs === String ? $util.Long.prototype.toString.call(message.licenseCodes[j]) : options.longs === Number ? new $util.LongBits(message.licenseCodes[j].low >>> 0, message.licenseCodes[j].high >>> 0).toNumber() : message.licenseCodes[j];
                            }
                            if (message.replicaZones && message.replicaZones.length) {
                                object.replicaZones = [];
                                for (var j = 0; j < message.replicaZones.length; ++j)
                                    object.replicaZones[j] = message.replicaZones[j];
                            }
                            if (message.sourceImage != null && message.hasOwnProperty("sourceImage")) {
                                object.sourceImage = message.sourceImage;
                                if (options.oneofs)
                                    object._sourceImage = "sourceImage";
                            }
                            if (message.sourceImageId != null && message.hasOwnProperty("sourceImageId")) {
                                object.sourceImageId = message.sourceImageId;
                                if (options.oneofs)
                                    object._sourceImageId = "sourceImageId";
                            }
                            if (message.lastDetachTimestamp != null && message.hasOwnProperty("lastDetachTimestamp")) {
                                object.lastDetachTimestamp = message.lastDetachTimestamp;
                                if (options.oneofs)
                                    object._lastDetachTimestamp = "lastDetachTimestamp";
                            }
                            if (message.params != null && message.hasOwnProperty("params")) {
                                object.params = $root.google.cloud.compute.v1.DiskParams.toObject(message.params, options);
                                if (options.oneofs)
                                    object._params = "params";
                            }
                            if (message.guestOsFeatures && message.guestOsFeatures.length) {
                                object.guestOsFeatures = [];
                                for (var j = 0; j < message.guestOsFeatures.length; ++j)
                                    object.guestOsFeatures[j] = $root.google.cloud.compute.v1.GuestOsFeature.toObject(message.guestOsFeatures[j], options);
                            }
                            if (message.sourceSnapshotId != null && message.hasOwnProperty("sourceSnapshotId")) {
                                object.sourceSnapshotId = message.sourceSnapshotId;
                                if (options.oneofs)
                                    object._sourceSnapshotId = "sourceSnapshotId";
                            }
                            if (message.users && message.users.length) {
                                object.users = [];
                                for (var j = 0; j < message.users.length; ++j)
                                    object.users[j] = message.users[j];
                            }
                            if (message.sourceSnapshot != null && message.hasOwnProperty("sourceSnapshot")) {
                                object.sourceSnapshot = message.sourceSnapshot;
                                if (options.oneofs)
                                    object._sourceSnapshot = "sourceSnapshot";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                object.labelFingerprint = message.labelFingerprint;
                                if (options.oneofs)
                                    object._labelFingerprint = "labelFingerprint";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.provisionedIops != null && message.hasOwnProperty("provisionedIops")) {
                                if (typeof message.provisionedIops === "number")
                                    object.provisionedIops = options.longs === String ? String(message.provisionedIops) : message.provisionedIops;
                                else
                                    object.provisionedIops = options.longs === String ? $util.Long.prototype.toString.call(message.provisionedIops) : options.longs === Number ? new $util.LongBits(message.provisionedIops.low >>> 0, message.provisionedIops.high >>> 0).toNumber() : message.provisionedIops;
                                if (options.oneofs)
                                    object._provisionedIops = "provisionedIops";
                            }
                            if (message.sourceStorageObject != null && message.hasOwnProperty("sourceStorageObject")) {
                                object.sourceStorageObject = message.sourceStorageObject;
                                if (options.oneofs)
                                    object._sourceStorageObject = "sourceStorageObject";
                            }
                            if (message.diskEncryptionKey != null && message.hasOwnProperty("diskEncryptionKey")) {
                                object.diskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.toObject(message.diskEncryptionKey, options);
                                if (options.oneofs)
                                    object._diskEncryptionKey = "diskEncryptionKey";
                            }
                            if (message.architecture != null && message.hasOwnProperty("architecture")) {
                                object.architecture = message.architecture;
                                if (options.oneofs)
                                    object._architecture = "architecture";
                            }
                            if (message.sourceSnapshotEncryptionKey != null && message.hasOwnProperty("sourceSnapshotEncryptionKey")) {
                                object.sourceSnapshotEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.toObject(message.sourceSnapshotEncryptionKey, options);
                                if (options.oneofs)
                                    object._sourceSnapshotEncryptionKey = "sourceSnapshotEncryptionKey";
                            }
                            if (message.licenses && message.licenses.length) {
                                object.licenses = [];
                                for (var j = 0; j < message.licenses.length; ++j)
                                    object.licenses[j] = message.licenses[j];
                            }
                            if (message.locationHint != null && message.hasOwnProperty("locationHint")) {
                                object.locationHint = message.locationHint;
                                if (options.oneofs)
                                    object._locationHint = "locationHint";
                            }
                            if (message.options != null && message.hasOwnProperty("options")) {
                                object.options = message.options;
                                if (options.oneofs)
                                    object._options = "options";
                            }
                            if (message.sourceImageEncryptionKey != null && message.hasOwnProperty("sourceImageEncryptionKey")) {
                                object.sourceImageEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.toObject(message.sourceImageEncryptionKey, options);
                                if (options.oneofs)
                                    object._sourceImageEncryptionKey = "sourceImageEncryptionKey";
                            }
                            if (message.physicalBlockSizeBytes != null && message.hasOwnProperty("physicalBlockSizeBytes")) {
                                if (typeof message.physicalBlockSizeBytes === "number")
                                    object.physicalBlockSizeBytes = options.longs === String ? String(message.physicalBlockSizeBytes) : message.physicalBlockSizeBytes;
                                else
                                    object.physicalBlockSizeBytes = options.longs === String ? $util.Long.prototype.toString.call(message.physicalBlockSizeBytes) : options.longs === Number ? new $util.LongBits(message.physicalBlockSizeBytes.low >>> 0, message.physicalBlockSizeBytes.high >>> 0).toNumber() : message.physicalBlockSizeBytes;
                                if (options.oneofs)
                                    object._physicalBlockSizeBytes = "physicalBlockSizeBytes";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.sourceDisk != null && message.hasOwnProperty("sourceDisk")) {
                                object.sourceDisk = message.sourceDisk;
                                if (options.oneofs)
                                    object._sourceDisk = "sourceDisk";
                            }
                            if (message.sourceDiskId != null && message.hasOwnProperty("sourceDiskId")) {
                                object.sourceDiskId = message.sourceDiskId;
                                if (options.oneofs)
                                    object._sourceDiskId = "sourceDiskId";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.satisfiesPzs != null && message.hasOwnProperty("satisfiesPzs")) {
                                object.satisfiesPzs = message.satisfiesPzs;
                                if (options.oneofs)
                                    object._satisfiesPzs = "satisfiesPzs";
                            }
                            if (message.sizeGb != null && message.hasOwnProperty("sizeGb")) {
                                if (typeof message.sizeGb === "number")
                                    object.sizeGb = options.longs === String ? String(message.sizeGb) : message.sizeGb;
                                else
                                    object.sizeGb = options.longs === String ? $util.Long.prototype.toString.call(message.sizeGb) : options.longs === Number ? new $util.LongBits(message.sizeGb.low >>> 0, message.sizeGb.high >>> 0).toNumber() : message.sizeGb;
                                if (options.oneofs)
                                    object._sizeGb = "sizeGb";
                            }
                            var keys2;
                            if (message.labels && (keys2 = Object.keys(message.labels)).length) {
                                object.labels = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.labels[keys2[j]] = message.labels[keys2[j]];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Disk to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Disk
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Disk.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Disk
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Disk
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Disk.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Disk";
                        };
    
                        /**
                         * Architecture enum.
                         * @name google.cloud.compute.v1.Disk.Architecture
                         * @enum {number}
                         * @property {number} UNDEFINED_ARCHITECTURE=0 UNDEFINED_ARCHITECTURE value
                         * @property {number} ARCHITECTURE_UNSPECIFIED=394750507 ARCHITECTURE_UNSPECIFIED value
                         * @property {number} ARM64=62547450 ARM64 value
                         * @property {number} X86_64=425300551 X86_64 value
                         */
                        Disk.Architecture = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ARCHITECTURE"] = 0;
                            values[valuesById[394750507] = "ARCHITECTURE_UNSPECIFIED"] = 394750507;
                            values[valuesById[62547450] = "ARM64"] = 62547450;
                            values[valuesById[425300551] = "X86_64"] = 425300551;
                            return values;
                        })();
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.Disk.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} CREATING=455564985 CREATING value
                         * @property {number} DELETING=528602024 DELETING value
                         * @property {number} FAILED=455706685 FAILED value
                         * @property {number} READY=77848963 READY value
                         * @property {number} RESTORING=404263851 RESTORING value
                         */
                        Disk.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[455564985] = "CREATING"] = 455564985;
                            values[valuesById[528602024] = "DELETING"] = 528602024;
                            values[valuesById[455706685] = "FAILED"] = 455706685;
                            values[valuesById[77848963] = "READY"] = 77848963;
                            values[valuesById[404263851] = "RESTORING"] = 404263851;
                            return values;
                        })();
    
                        return Disk;
                    })();
    
                    v1.DiskAggregatedList = (function() {
    
                        /**
                         * Properties of a DiskAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IDiskAggregatedList
                         * @property {string|null} [id] DiskAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IDisksScopedList>|null} [items] DiskAggregatedList items
                         * @property {string|null} [kind] DiskAggregatedList kind
                         * @property {string|null} [nextPageToken] DiskAggregatedList nextPageToken
                         * @property {string|null} [selfLink] DiskAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] DiskAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] DiskAggregatedList warning
                         */
    
                        /**
                         * Constructs a new DiskAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DiskAggregatedList.
                         * @implements IDiskAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IDiskAggregatedList=} [properties] Properties to set
                         */
                        function DiskAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DiskAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @instance
                         */
                        DiskAggregatedList.prototype.id = null;
    
                        /**
                         * DiskAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IDisksScopedList>} items
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @instance
                         */
                        DiskAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * DiskAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @instance
                         */
                        DiskAggregatedList.prototype.kind = null;
    
                        /**
                         * DiskAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @instance
                         */
                        DiskAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * DiskAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @instance
                         */
                        DiskAggregatedList.prototype.selfLink = null;
    
                        /**
                         * DiskAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @instance
                         */
                        DiskAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * DiskAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @instance
                         */
                        DiskAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DiskAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @instance
                         */
                        Object.defineProperty(DiskAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @instance
                         */
                        Object.defineProperty(DiskAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @instance
                         */
                        Object.defineProperty(DiskAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @instance
                         */
                        Object.defineProperty(DiskAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @instance
                         */
                        Object.defineProperty(DiskAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DiskAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IDiskAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DiskAggregatedList} DiskAggregatedList instance
                         */
                        DiskAggregatedList.create = function create(properties) {
                            return new DiskAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified DiskAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.DiskAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IDiskAggregatedList} message DiskAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DiskAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.DisksScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DiskAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DiskAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IDiskAggregatedList} message DiskAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DiskAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DiskAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DiskAggregatedList} DiskAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DiskAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DiskAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.DisksScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DiskAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DiskAggregatedList} DiskAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DiskAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DiskAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DiskAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.DisksScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DiskAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DiskAggregatedList} DiskAggregatedList
                         */
                        DiskAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DiskAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DiskAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.DiskAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.DiskAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.DisksScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.DiskAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.DiskAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DiskAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.DiskAggregatedList} message DiskAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DiskAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.DisksScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this DiskAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DiskAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DiskAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DiskAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DiskAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DiskAggregatedList";
                        };
    
                        return DiskAggregatedList;
                    })();
    
                    v1.DiskInstantiationConfig = (function() {
    
                        /**
                         * Properties of a DiskInstantiationConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface IDiskInstantiationConfig
                         * @property {boolean|null} [autoDelete] DiskInstantiationConfig autoDelete
                         * @property {string|null} [customImage] DiskInstantiationConfig customImage
                         * @property {string|null} [deviceName] DiskInstantiationConfig deviceName
                         * @property {string|null} [instantiateFrom] DiskInstantiationConfig instantiateFrom
                         */
    
                        /**
                         * Constructs a new DiskInstantiationConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DiskInstantiationConfig.
                         * @implements IDiskInstantiationConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.IDiskInstantiationConfig=} [properties] Properties to set
                         */
                        function DiskInstantiationConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DiskInstantiationConfig autoDelete.
                         * @member {boolean|null|undefined} autoDelete
                         * @memberof google.cloud.compute.v1.DiskInstantiationConfig
                         * @instance
                         */
                        DiskInstantiationConfig.prototype.autoDelete = null;
    
                        /**
                         * DiskInstantiationConfig customImage.
                         * @member {string|null|undefined} customImage
                         * @memberof google.cloud.compute.v1.DiskInstantiationConfig
                         * @instance
                         */
                        DiskInstantiationConfig.prototype.customImage = null;
    
                        /**
                         * DiskInstantiationConfig deviceName.
                         * @member {string|null|undefined} deviceName
                         * @memberof google.cloud.compute.v1.DiskInstantiationConfig
                         * @instance
                         */
                        DiskInstantiationConfig.prototype.deviceName = null;
    
                        /**
                         * DiskInstantiationConfig instantiateFrom.
                         * @member {string|null|undefined} instantiateFrom
                         * @memberof google.cloud.compute.v1.DiskInstantiationConfig
                         * @instance
                         */
                        DiskInstantiationConfig.prototype.instantiateFrom = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DiskInstantiationConfig _autoDelete.
                         * @member {"autoDelete"|undefined} _autoDelete
                         * @memberof google.cloud.compute.v1.DiskInstantiationConfig
                         * @instance
                         */
                        Object.defineProperty(DiskInstantiationConfig.prototype, "_autoDelete", {
                            get: $util.oneOfGetter($oneOfFields = ["autoDelete"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskInstantiationConfig _customImage.
                         * @member {"customImage"|undefined} _customImage
                         * @memberof google.cloud.compute.v1.DiskInstantiationConfig
                         * @instance
                         */
                        Object.defineProperty(DiskInstantiationConfig.prototype, "_customImage", {
                            get: $util.oneOfGetter($oneOfFields = ["customImage"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskInstantiationConfig _deviceName.
                         * @member {"deviceName"|undefined} _deviceName
                         * @memberof google.cloud.compute.v1.DiskInstantiationConfig
                         * @instance
                         */
                        Object.defineProperty(DiskInstantiationConfig.prototype, "_deviceName", {
                            get: $util.oneOfGetter($oneOfFields = ["deviceName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskInstantiationConfig _instantiateFrom.
                         * @member {"instantiateFrom"|undefined} _instantiateFrom
                         * @memberof google.cloud.compute.v1.DiskInstantiationConfig
                         * @instance
                         */
                        Object.defineProperty(DiskInstantiationConfig.prototype, "_instantiateFrom", {
                            get: $util.oneOfGetter($oneOfFields = ["instantiateFrom"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DiskInstantiationConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DiskInstantiationConfig
                         * @static
                         * @param {google.cloud.compute.v1.IDiskInstantiationConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DiskInstantiationConfig} DiskInstantiationConfig instance
                         */
                        DiskInstantiationConfig.create = function create(properties) {
                            return new DiskInstantiationConfig(properties);
                        };
    
                        /**
                         * Encodes the specified DiskInstantiationConfig message. Does not implicitly {@link google.cloud.compute.v1.DiskInstantiationConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DiskInstantiationConfig
                         * @static
                         * @param {google.cloud.compute.v1.IDiskInstantiationConfig} message DiskInstantiationConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DiskInstantiationConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.deviceName != null && Object.hasOwnProperty.call(message, "deviceName"))
                                writer.uint32(/* id 67541716, wireType 2 =*/540333730).string(message.deviceName);
                            if (message.customImage != null && Object.hasOwnProperty.call(message, "customImage"))
                                writer.uint32(/* id 184123149, wireType 2 =*/1472985194).string(message.customImage);
                            if (message.instantiateFrom != null && Object.hasOwnProperty.call(message, "instantiateFrom"))
                                writer.uint32(/* id 393383903, wireType 2 =*/3147071226).string(message.instantiateFrom);
                            if (message.autoDelete != null && Object.hasOwnProperty.call(message, "autoDelete"))
                                writer.uint32(/* id 464761403, wireType 0 =*/3718091224).bool(message.autoDelete);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DiskInstantiationConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DiskInstantiationConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DiskInstantiationConfig
                         * @static
                         * @param {google.cloud.compute.v1.IDiskInstantiationConfig} message DiskInstantiationConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DiskInstantiationConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DiskInstantiationConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DiskInstantiationConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DiskInstantiationConfig} DiskInstantiationConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DiskInstantiationConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DiskInstantiationConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 464761403: {
                                        message.autoDelete = reader.bool();
                                        break;
                                    }
                                case 184123149: {
                                        message.customImage = reader.string();
                                        break;
                                    }
                                case 67541716: {
                                        message.deviceName = reader.string();
                                        break;
                                    }
                                case 393383903: {
                                        message.instantiateFrom = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DiskInstantiationConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DiskInstantiationConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DiskInstantiationConfig} DiskInstantiationConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DiskInstantiationConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DiskInstantiationConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DiskInstantiationConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DiskInstantiationConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoDelete != null && message.hasOwnProperty("autoDelete")) {
                                properties._autoDelete = 1;
                                if (typeof message.autoDelete !== "boolean")
                                    return "autoDelete: boolean expected";
                            }
                            if (message.customImage != null && message.hasOwnProperty("customImage")) {
                                properties._customImage = 1;
                                if (!$util.isString(message.customImage))
                                    return "customImage: string expected";
                            }
                            if (message.deviceName != null && message.hasOwnProperty("deviceName")) {
                                properties._deviceName = 1;
                                if (!$util.isString(message.deviceName))
                                    return "deviceName: string expected";
                            }
                            if (message.instantiateFrom != null && message.hasOwnProperty("instantiateFrom")) {
                                properties._instantiateFrom = 1;
                                if (!$util.isString(message.instantiateFrom))
                                    return "instantiateFrom: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DiskInstantiationConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DiskInstantiationConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DiskInstantiationConfig} DiskInstantiationConfig
                         */
                        DiskInstantiationConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DiskInstantiationConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DiskInstantiationConfig();
                            if (object.autoDelete != null)
                                message.autoDelete = Boolean(object.autoDelete);
                            if (object.customImage != null)
                                message.customImage = String(object.customImage);
                            if (object.deviceName != null)
                                message.deviceName = String(object.deviceName);
                            if (object.instantiateFrom != null)
                                message.instantiateFrom = String(object.instantiateFrom);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DiskInstantiationConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DiskInstantiationConfig
                         * @static
                         * @param {google.cloud.compute.v1.DiskInstantiationConfig} message DiskInstantiationConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DiskInstantiationConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.deviceName != null && message.hasOwnProperty("deviceName")) {
                                object.deviceName = message.deviceName;
                                if (options.oneofs)
                                    object._deviceName = "deviceName";
                            }
                            if (message.customImage != null && message.hasOwnProperty("customImage")) {
                                object.customImage = message.customImage;
                                if (options.oneofs)
                                    object._customImage = "customImage";
                            }
                            if (message.instantiateFrom != null && message.hasOwnProperty("instantiateFrom")) {
                                object.instantiateFrom = message.instantiateFrom;
                                if (options.oneofs)
                                    object._instantiateFrom = "instantiateFrom";
                            }
                            if (message.autoDelete != null && message.hasOwnProperty("autoDelete")) {
                                object.autoDelete = message.autoDelete;
                                if (options.oneofs)
                                    object._autoDelete = "autoDelete";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this DiskInstantiationConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DiskInstantiationConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DiskInstantiationConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DiskInstantiationConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DiskInstantiationConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DiskInstantiationConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DiskInstantiationConfig";
                        };
    
                        /**
                         * InstantiateFrom enum.
                         * @name google.cloud.compute.v1.DiskInstantiationConfig.InstantiateFrom
                         * @enum {number}
                         * @property {number} UNDEFINED_INSTANTIATE_FROM=0 UNDEFINED_INSTANTIATE_FROM value
                         * @property {number} ATTACH_READ_ONLY=513775419 ATTACH_READ_ONLY value
                         * @property {number} BLANK=63281460 BLANK value
                         * @property {number} CUSTOM_IMAGE=196311789 CUSTOM_IMAGE value
                         * @property {number} DEFAULT=115302945 DEFAULT value
                         * @property {number} DO_NOT_INCLUDE=104218952 DO_NOT_INCLUDE value
                         * @property {number} SOURCE_IMAGE=62631959 SOURCE_IMAGE value
                         * @property {number} SOURCE_IMAGE_FAMILY=76850316 SOURCE_IMAGE_FAMILY value
                         */
                        DiskInstantiationConfig.InstantiateFrom = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_INSTANTIATE_FROM"] = 0;
                            values[valuesById[513775419] = "ATTACH_READ_ONLY"] = 513775419;
                            values[valuesById[63281460] = "BLANK"] = 63281460;
                            values[valuesById[196311789] = "CUSTOM_IMAGE"] = 196311789;
                            values[valuesById[115302945] = "DEFAULT"] = 115302945;
                            values[valuesById[104218952] = "DO_NOT_INCLUDE"] = 104218952;
                            values[valuesById[62631959] = "SOURCE_IMAGE"] = 62631959;
                            values[valuesById[76850316] = "SOURCE_IMAGE_FAMILY"] = 76850316;
                            return values;
                        })();
    
                        return DiskInstantiationConfig;
                    })();
    
                    v1.DiskList = (function() {
    
                        /**
                         * Properties of a DiskList.
                         * @memberof google.cloud.compute.v1
                         * @interface IDiskList
                         * @property {string|null} [id] DiskList id
                         * @property {Array.<google.cloud.compute.v1.IDisk>|null} [items] DiskList items
                         * @property {string|null} [kind] DiskList kind
                         * @property {string|null} [nextPageToken] DiskList nextPageToken
                         * @property {string|null} [selfLink] DiskList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] DiskList warning
                         */
    
                        /**
                         * Constructs a new DiskList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DiskList.
                         * @implements IDiskList
                         * @constructor
                         * @param {google.cloud.compute.v1.IDiskList=} [properties] Properties to set
                         */
                        function DiskList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DiskList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.DiskList
                         * @instance
                         */
                        DiskList.prototype.id = null;
    
                        /**
                         * DiskList items.
                         * @member {Array.<google.cloud.compute.v1.IDisk>} items
                         * @memberof google.cloud.compute.v1.DiskList
                         * @instance
                         */
                        DiskList.prototype.items = $util.emptyArray;
    
                        /**
                         * DiskList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.DiskList
                         * @instance
                         */
                        DiskList.prototype.kind = null;
    
                        /**
                         * DiskList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.DiskList
                         * @instance
                         */
                        DiskList.prototype.nextPageToken = null;
    
                        /**
                         * DiskList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.DiskList
                         * @instance
                         */
                        DiskList.prototype.selfLink = null;
    
                        /**
                         * DiskList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.DiskList
                         * @instance
                         */
                        DiskList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DiskList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.DiskList
                         * @instance
                         */
                        Object.defineProperty(DiskList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.DiskList
                         * @instance
                         */
                        Object.defineProperty(DiskList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.DiskList
                         * @instance
                         */
                        Object.defineProperty(DiskList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.DiskList
                         * @instance
                         */
                        Object.defineProperty(DiskList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.DiskList
                         * @instance
                         */
                        Object.defineProperty(DiskList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DiskList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DiskList
                         * @static
                         * @param {google.cloud.compute.v1.IDiskList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DiskList} DiskList instance
                         */
                        DiskList.create = function create(properties) {
                            return new DiskList(properties);
                        };
    
                        /**
                         * Encodes the specified DiskList message. Does not implicitly {@link google.cloud.compute.v1.DiskList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DiskList
                         * @static
                         * @param {google.cloud.compute.v1.IDiskList} message DiskList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DiskList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Disk.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DiskList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DiskList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DiskList
                         * @static
                         * @param {google.cloud.compute.v1.IDiskList} message DiskList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DiskList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DiskList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DiskList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DiskList} DiskList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DiskList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DiskList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Disk.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DiskList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DiskList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DiskList} DiskList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DiskList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DiskList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DiskList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DiskList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Disk.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DiskList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DiskList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DiskList} DiskList
                         */
                        DiskList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DiskList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DiskList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.DiskList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.DiskList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Disk.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.DiskList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DiskList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DiskList
                         * @static
                         * @param {google.cloud.compute.v1.DiskList} message DiskList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DiskList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Disk.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this DiskList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DiskList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DiskList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DiskList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DiskList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DiskList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DiskList";
                        };
    
                        return DiskList;
                    })();
    
                    v1.DiskMoveRequest = (function() {
    
                        /**
                         * Properties of a DiskMoveRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDiskMoveRequest
                         * @property {string|null} [destinationZone] DiskMoveRequest destinationZone
                         * @property {string|null} [targetDisk] DiskMoveRequest targetDisk
                         */
    
                        /**
                         * Constructs a new DiskMoveRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DiskMoveRequest.
                         * @implements IDiskMoveRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDiskMoveRequest=} [properties] Properties to set
                         */
                        function DiskMoveRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DiskMoveRequest destinationZone.
                         * @member {string|null|undefined} destinationZone
                         * @memberof google.cloud.compute.v1.DiskMoveRequest
                         * @instance
                         */
                        DiskMoveRequest.prototype.destinationZone = null;
    
                        /**
                         * DiskMoveRequest targetDisk.
                         * @member {string|null|undefined} targetDisk
                         * @memberof google.cloud.compute.v1.DiskMoveRequest
                         * @instance
                         */
                        DiskMoveRequest.prototype.targetDisk = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DiskMoveRequest _destinationZone.
                         * @member {"destinationZone"|undefined} _destinationZone
                         * @memberof google.cloud.compute.v1.DiskMoveRequest
                         * @instance
                         */
                        Object.defineProperty(DiskMoveRequest.prototype, "_destinationZone", {
                            get: $util.oneOfGetter($oneOfFields = ["destinationZone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskMoveRequest _targetDisk.
                         * @member {"targetDisk"|undefined} _targetDisk
                         * @memberof google.cloud.compute.v1.DiskMoveRequest
                         * @instance
                         */
                        Object.defineProperty(DiskMoveRequest.prototype, "_targetDisk", {
                            get: $util.oneOfGetter($oneOfFields = ["targetDisk"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DiskMoveRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DiskMoveRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDiskMoveRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DiskMoveRequest} DiskMoveRequest instance
                         */
                        DiskMoveRequest.create = function create(properties) {
                            return new DiskMoveRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DiskMoveRequest message. Does not implicitly {@link google.cloud.compute.v1.DiskMoveRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DiskMoveRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDiskMoveRequest} message DiskMoveRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DiskMoveRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetDisk != null && Object.hasOwnProperty.call(message, "targetDisk"))
                                writer.uint32(/* id 62433163, wireType 2 =*/499465306).string(message.targetDisk);
                            if (message.destinationZone != null && Object.hasOwnProperty.call(message, "destinationZone"))
                                writer.uint32(/* id 131854653, wireType 2 =*/1054837226).string(message.destinationZone);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DiskMoveRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DiskMoveRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DiskMoveRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDiskMoveRequest} message DiskMoveRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DiskMoveRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DiskMoveRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DiskMoveRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DiskMoveRequest} DiskMoveRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DiskMoveRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DiskMoveRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 131854653: {
                                        message.destinationZone = reader.string();
                                        break;
                                    }
                                case 62433163: {
                                        message.targetDisk = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DiskMoveRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DiskMoveRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DiskMoveRequest} DiskMoveRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DiskMoveRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DiskMoveRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DiskMoveRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DiskMoveRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.destinationZone != null && message.hasOwnProperty("destinationZone")) {
                                properties._destinationZone = 1;
                                if (!$util.isString(message.destinationZone))
                                    return "destinationZone: string expected";
                            }
                            if (message.targetDisk != null && message.hasOwnProperty("targetDisk")) {
                                properties._targetDisk = 1;
                                if (!$util.isString(message.targetDisk))
                                    return "targetDisk: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DiskMoveRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DiskMoveRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DiskMoveRequest} DiskMoveRequest
                         */
                        DiskMoveRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DiskMoveRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DiskMoveRequest();
                            if (object.destinationZone != null)
                                message.destinationZone = String(object.destinationZone);
                            if (object.targetDisk != null)
                                message.targetDisk = String(object.targetDisk);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DiskMoveRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DiskMoveRequest
                         * @static
                         * @param {google.cloud.compute.v1.DiskMoveRequest} message DiskMoveRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DiskMoveRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.targetDisk != null && message.hasOwnProperty("targetDisk")) {
                                object.targetDisk = message.targetDisk;
                                if (options.oneofs)
                                    object._targetDisk = "targetDisk";
                            }
                            if (message.destinationZone != null && message.hasOwnProperty("destinationZone")) {
                                object.destinationZone = message.destinationZone;
                                if (options.oneofs)
                                    object._destinationZone = "destinationZone";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this DiskMoveRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DiskMoveRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DiskMoveRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DiskMoveRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DiskMoveRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DiskMoveRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DiskMoveRequest";
                        };
    
                        return DiskMoveRequest;
                    })();
    
                    v1.DiskParams = (function() {
    
                        /**
                         * Properties of a DiskParams.
                         * @memberof google.cloud.compute.v1
                         * @interface IDiskParams
                         * @property {Object.<string,string>|null} [resourceManagerTags] DiskParams resourceManagerTags
                         */
    
                        /**
                         * Constructs a new DiskParams.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DiskParams.
                         * @implements IDiskParams
                         * @constructor
                         * @param {google.cloud.compute.v1.IDiskParams=} [properties] Properties to set
                         */
                        function DiskParams(properties) {
                            this.resourceManagerTags = {};
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DiskParams resourceManagerTags.
                         * @member {Object.<string,string>} resourceManagerTags
                         * @memberof google.cloud.compute.v1.DiskParams
                         * @instance
                         */
                        DiskParams.prototype.resourceManagerTags = $util.emptyObject;
    
                        /**
                         * Creates a new DiskParams instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DiskParams
                         * @static
                         * @param {google.cloud.compute.v1.IDiskParams=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DiskParams} DiskParams instance
                         */
                        DiskParams.create = function create(properties) {
                            return new DiskParams(properties);
                        };
    
                        /**
                         * Encodes the specified DiskParams message. Does not implicitly {@link google.cloud.compute.v1.DiskParams.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DiskParams
                         * @static
                         * @param {google.cloud.compute.v1.IDiskParams} message DiskParams message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DiskParams.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceManagerTags != null && Object.hasOwnProperty.call(message, "resourceManagerTags"))
                                for (var keys = Object.keys(message.resourceManagerTags), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 377671164, wireType 2 =*/3021369314).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.resourceManagerTags[keys[i]]).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DiskParams message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DiskParams.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DiskParams
                         * @static
                         * @param {google.cloud.compute.v1.IDiskParams} message DiskParams message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DiskParams.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DiskParams message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DiskParams
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DiskParams} DiskParams
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DiskParams.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DiskParams(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 377671164: {
                                        if (message.resourceManagerTags === $util.emptyObject)
                                            message.resourceManagerTags = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.resourceManagerTags[key] = value;
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DiskParams message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DiskParams
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DiskParams} DiskParams
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DiskParams.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DiskParams message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DiskParams
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DiskParams.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceManagerTags != null && message.hasOwnProperty("resourceManagerTags")) {
                                if (!$util.isObject(message.resourceManagerTags))
                                    return "resourceManagerTags: object expected";
                                var key = Object.keys(message.resourceManagerTags);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.resourceManagerTags[key[i]]))
                                        return "resourceManagerTags: string{k:string} expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DiskParams message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DiskParams
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DiskParams} DiskParams
                         */
                        DiskParams.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DiskParams)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DiskParams();
                            if (object.resourceManagerTags) {
                                if (typeof object.resourceManagerTags !== "object")
                                    throw TypeError(".google.cloud.compute.v1.DiskParams.resourceManagerTags: object expected");
                                message.resourceManagerTags = {};
                                for (var keys = Object.keys(object.resourceManagerTags), i = 0; i < keys.length; ++i)
                                    message.resourceManagerTags[keys[i]] = String(object.resourceManagerTags[keys[i]]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DiskParams message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DiskParams
                         * @static
                         * @param {google.cloud.compute.v1.DiskParams} message DiskParams
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DiskParams.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.objects || options.defaults)
                                object.resourceManagerTags = {};
                            var keys2;
                            if (message.resourceManagerTags && (keys2 = Object.keys(message.resourceManagerTags)).length) {
                                object.resourceManagerTags = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.resourceManagerTags[keys2[j]] = message.resourceManagerTags[keys2[j]];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this DiskParams to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DiskParams
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DiskParams.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DiskParams
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DiskParams
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DiskParams.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DiskParams";
                        };
    
                        return DiskParams;
                    })();
    
                    v1.DiskType = (function() {
    
                        /**
                         * Properties of a DiskType.
                         * @memberof google.cloud.compute.v1
                         * @interface IDiskType
                         * @property {string|null} [creationTimestamp] DiskType creationTimestamp
                         * @property {number|Long|null} [defaultDiskSizeGb] DiskType defaultDiskSizeGb
                         * @property {google.cloud.compute.v1.IDeprecationStatus|null} [deprecated] DiskType deprecated
                         * @property {string|null} [description] DiskType description
                         * @property {number|Long|null} [id] DiskType id
                         * @property {string|null} [kind] DiskType kind
                         * @property {string|null} [name] DiskType name
                         * @property {string|null} [region] DiskType region
                         * @property {string|null} [selfLink] DiskType selfLink
                         * @property {string|null} [validDiskSize] DiskType validDiskSize
                         * @property {string|null} [zone] DiskType zone
                         */
    
                        /**
                         * Constructs a new DiskType.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DiskType.
                         * @implements IDiskType
                         * @constructor
                         * @param {google.cloud.compute.v1.IDiskType=} [properties] Properties to set
                         */
                        function DiskType(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DiskType creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        DiskType.prototype.creationTimestamp = null;
    
                        /**
                         * DiskType defaultDiskSizeGb.
                         * @member {number|Long|null|undefined} defaultDiskSizeGb
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        DiskType.prototype.defaultDiskSizeGb = null;
    
                        /**
                         * DiskType deprecated.
                         * @member {google.cloud.compute.v1.IDeprecationStatus|null|undefined} deprecated
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        DiskType.prototype.deprecated = null;
    
                        /**
                         * DiskType description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        DiskType.prototype.description = null;
    
                        /**
                         * DiskType id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        DiskType.prototype.id = null;
    
                        /**
                         * DiskType kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        DiskType.prototype.kind = null;
    
                        /**
                         * DiskType name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        DiskType.prototype.name = null;
    
                        /**
                         * DiskType region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        DiskType.prototype.region = null;
    
                        /**
                         * DiskType selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        DiskType.prototype.selfLink = null;
    
                        /**
                         * DiskType validDiskSize.
                         * @member {string|null|undefined} validDiskSize
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        DiskType.prototype.validDiskSize = null;
    
                        /**
                         * DiskType zone.
                         * @member {string|null|undefined} zone
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        DiskType.prototype.zone = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DiskType _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        Object.defineProperty(DiskType.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskType _defaultDiskSizeGb.
                         * @member {"defaultDiskSizeGb"|undefined} _defaultDiskSizeGb
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        Object.defineProperty(DiskType.prototype, "_defaultDiskSizeGb", {
                            get: $util.oneOfGetter($oneOfFields = ["defaultDiskSizeGb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskType _deprecated.
                         * @member {"deprecated"|undefined} _deprecated
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        Object.defineProperty(DiskType.prototype, "_deprecated", {
                            get: $util.oneOfGetter($oneOfFields = ["deprecated"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskType _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        Object.defineProperty(DiskType.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskType _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        Object.defineProperty(DiskType.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskType _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        Object.defineProperty(DiskType.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskType _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        Object.defineProperty(DiskType.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskType _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        Object.defineProperty(DiskType.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskType _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        Object.defineProperty(DiskType.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskType _validDiskSize.
                         * @member {"validDiskSize"|undefined} _validDiskSize
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        Object.defineProperty(DiskType.prototype, "_validDiskSize", {
                            get: $util.oneOfGetter($oneOfFields = ["validDiskSize"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskType _zone.
                         * @member {"zone"|undefined} _zone
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         */
                        Object.defineProperty(DiskType.prototype, "_zone", {
                            get: $util.oneOfGetter($oneOfFields = ["zone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DiskType instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DiskType
                         * @static
                         * @param {google.cloud.compute.v1.IDiskType=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DiskType} DiskType instance
                         */
                        DiskType.create = function create(properties) {
                            return new DiskType(properties);
                        };
    
                        /**
                         * Encodes the specified DiskType message. Does not implicitly {@link google.cloud.compute.v1.DiskType.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DiskType
                         * @static
                         * @param {google.cloud.compute.v1.IDiskType} message DiskType message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DiskType.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.defaultDiskSizeGb != null && Object.hasOwnProperty.call(message, "defaultDiskSizeGb"))
                                writer.uint32(/* id 270619253, wireType 0 =*/2164954024).int64(message.defaultDiskSizeGb);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.validDiskSize != null && Object.hasOwnProperty.call(message, "validDiskSize"))
                                writer.uint32(/* id 493962464, wireType 2 =*/3951699714).string(message.validDiskSize);
                            if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                                $root.google.cloud.compute.v1.DeprecationStatus.encode(message.deprecated, writer.uint32(/* id 515138995, wireType 2 =*/4121111962).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DiskType message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DiskType.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DiskType
                         * @static
                         * @param {google.cloud.compute.v1.IDiskType} message DiskType message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DiskType.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DiskType message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DiskType
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DiskType} DiskType
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DiskType.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DiskType();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 270619253: {
                                        message.defaultDiskSizeGb = reader.int64();
                                        break;
                                    }
                                case 515138995: {
                                        message.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 493962464: {
                                        message.validDiskSize = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DiskType message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DiskType
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DiskType} DiskType
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DiskType.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DiskType message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DiskType
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DiskType.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.defaultDiskSizeGb != null && message.hasOwnProperty("defaultDiskSizeGb")) {
                                properties._defaultDiskSizeGb = 1;
                                if (!$util.isInteger(message.defaultDiskSizeGb) && !(message.defaultDiskSizeGb && $util.isInteger(message.defaultDiskSizeGb.low) && $util.isInteger(message.defaultDiskSizeGb.high)))
                                    return "defaultDiskSizeGb: integer|Long expected";
                            }
                            if (message.deprecated != null && message.hasOwnProperty("deprecated")) {
                                properties._deprecated = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.DeprecationStatus.verify(message.deprecated);
                                    if (error)
                                        return "deprecated." + error;
                                }
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.validDiskSize != null && message.hasOwnProperty("validDiskSize")) {
                                properties._validDiskSize = 1;
                                if (!$util.isString(message.validDiskSize))
                                    return "validDiskSize: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                properties._zone = 1;
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DiskType message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DiskType
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DiskType} DiskType
                         */
                        DiskType.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DiskType)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DiskType();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.defaultDiskSizeGb != null)
                                if ($util.Long)
                                    (message.defaultDiskSizeGb = $util.Long.fromValue(object.defaultDiskSizeGb)).unsigned = false;
                                else if (typeof object.defaultDiskSizeGb === "string")
                                    message.defaultDiskSizeGb = parseInt(object.defaultDiskSizeGb, 10);
                                else if (typeof object.defaultDiskSizeGb === "number")
                                    message.defaultDiskSizeGb = object.defaultDiskSizeGb;
                                else if (typeof object.defaultDiskSizeGb === "object")
                                    message.defaultDiskSizeGb = new $util.LongBits(object.defaultDiskSizeGb.low >>> 0, object.defaultDiskSizeGb.high >>> 0).toNumber();
                            if (object.deprecated != null) {
                                if (typeof object.deprecated !== "object")
                                    throw TypeError(".google.cloud.compute.v1.DiskType.deprecated: object expected");
                                message.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.fromObject(object.deprecated);
                            }
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.validDiskSize != null)
                                message.validDiskSize = String(object.validDiskSize);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DiskType message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DiskType
                         * @static
                         * @param {google.cloud.compute.v1.DiskType} message DiskType
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DiskType.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                object.zone = message.zone;
                                if (options.oneofs)
                                    object._zone = "zone";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.defaultDiskSizeGb != null && message.hasOwnProperty("defaultDiskSizeGb")) {
                                if (typeof message.defaultDiskSizeGb === "number")
                                    object.defaultDiskSizeGb = options.longs === String ? String(message.defaultDiskSizeGb) : message.defaultDiskSizeGb;
                                else
                                    object.defaultDiskSizeGb = options.longs === String ? $util.Long.prototype.toString.call(message.defaultDiskSizeGb) : options.longs === Number ? new $util.LongBits(message.defaultDiskSizeGb.low >>> 0, message.defaultDiskSizeGb.high >>> 0).toNumber() : message.defaultDiskSizeGb;
                                if (options.oneofs)
                                    object._defaultDiskSizeGb = "defaultDiskSizeGb";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.validDiskSize != null && message.hasOwnProperty("validDiskSize")) {
                                object.validDiskSize = message.validDiskSize;
                                if (options.oneofs)
                                    object._validDiskSize = "validDiskSize";
                            }
                            if (message.deprecated != null && message.hasOwnProperty("deprecated")) {
                                object.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.toObject(message.deprecated, options);
                                if (options.oneofs)
                                    object._deprecated = "deprecated";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this DiskType to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DiskType
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DiskType.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DiskType
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DiskType
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DiskType.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DiskType";
                        };
    
                        return DiskType;
                    })();
    
                    v1.DiskTypeAggregatedList = (function() {
    
                        /**
                         * Properties of a DiskTypeAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IDiskTypeAggregatedList
                         * @property {string|null} [id] DiskTypeAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IDiskTypesScopedList>|null} [items] DiskTypeAggregatedList items
                         * @property {string|null} [kind] DiskTypeAggregatedList kind
                         * @property {string|null} [nextPageToken] DiskTypeAggregatedList nextPageToken
                         * @property {string|null} [selfLink] DiskTypeAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] DiskTypeAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] DiskTypeAggregatedList warning
                         */
    
                        /**
                         * Constructs a new DiskTypeAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DiskTypeAggregatedList.
                         * @implements IDiskTypeAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IDiskTypeAggregatedList=} [properties] Properties to set
                         */
                        function DiskTypeAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DiskTypeAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @instance
                         */
                        DiskTypeAggregatedList.prototype.id = null;
    
                        /**
                         * DiskTypeAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IDiskTypesScopedList>} items
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @instance
                         */
                        DiskTypeAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * DiskTypeAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @instance
                         */
                        DiskTypeAggregatedList.prototype.kind = null;
    
                        /**
                         * DiskTypeAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @instance
                         */
                        DiskTypeAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * DiskTypeAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @instance
                         */
                        DiskTypeAggregatedList.prototype.selfLink = null;
    
                        /**
                         * DiskTypeAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @instance
                         */
                        DiskTypeAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * DiskTypeAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @instance
                         */
                        DiskTypeAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DiskTypeAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @instance
                         */
                        Object.defineProperty(DiskTypeAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskTypeAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @instance
                         */
                        Object.defineProperty(DiskTypeAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskTypeAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @instance
                         */
                        Object.defineProperty(DiskTypeAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskTypeAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @instance
                         */
                        Object.defineProperty(DiskTypeAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskTypeAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @instance
                         */
                        Object.defineProperty(DiskTypeAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DiskTypeAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IDiskTypeAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DiskTypeAggregatedList} DiskTypeAggregatedList instance
                         */
                        DiskTypeAggregatedList.create = function create(properties) {
                            return new DiskTypeAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified DiskTypeAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.DiskTypeAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IDiskTypeAggregatedList} message DiskTypeAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DiskTypeAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.DiskTypesScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DiskTypeAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DiskTypeAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IDiskTypeAggregatedList} message DiskTypeAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DiskTypeAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DiskTypeAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DiskTypeAggregatedList} DiskTypeAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DiskTypeAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DiskTypeAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.DiskTypesScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DiskTypeAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DiskTypeAggregatedList} DiskTypeAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DiskTypeAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DiskTypeAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DiskTypeAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.DiskTypesScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DiskTypeAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DiskTypeAggregatedList} DiskTypeAggregatedList
                         */
                        DiskTypeAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DiskTypeAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DiskTypeAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.DiskTypeAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.DiskTypeAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.DiskTypesScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.DiskTypeAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.DiskTypeAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DiskTypeAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.DiskTypeAggregatedList} message DiskTypeAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DiskTypeAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.DiskTypesScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this DiskTypeAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DiskTypeAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DiskTypeAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DiskTypeAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DiskTypeAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DiskTypeAggregatedList";
                        };
    
                        return DiskTypeAggregatedList;
                    })();
    
                    v1.DiskTypeList = (function() {
    
                        /**
                         * Properties of a DiskTypeList.
                         * @memberof google.cloud.compute.v1
                         * @interface IDiskTypeList
                         * @property {string|null} [id] DiskTypeList id
                         * @property {Array.<google.cloud.compute.v1.IDiskType>|null} [items] DiskTypeList items
                         * @property {string|null} [kind] DiskTypeList kind
                         * @property {string|null} [nextPageToken] DiskTypeList nextPageToken
                         * @property {string|null} [selfLink] DiskTypeList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] DiskTypeList warning
                         */
    
                        /**
                         * Constructs a new DiskTypeList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DiskTypeList.
                         * @implements IDiskTypeList
                         * @constructor
                         * @param {google.cloud.compute.v1.IDiskTypeList=} [properties] Properties to set
                         */
                        function DiskTypeList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DiskTypeList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @instance
                         */
                        DiskTypeList.prototype.id = null;
    
                        /**
                         * DiskTypeList items.
                         * @member {Array.<google.cloud.compute.v1.IDiskType>} items
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @instance
                         */
                        DiskTypeList.prototype.items = $util.emptyArray;
    
                        /**
                         * DiskTypeList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @instance
                         */
                        DiskTypeList.prototype.kind = null;
    
                        /**
                         * DiskTypeList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @instance
                         */
                        DiskTypeList.prototype.nextPageToken = null;
    
                        /**
                         * DiskTypeList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @instance
                         */
                        DiskTypeList.prototype.selfLink = null;
    
                        /**
                         * DiskTypeList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @instance
                         */
                        DiskTypeList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DiskTypeList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @instance
                         */
                        Object.defineProperty(DiskTypeList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskTypeList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @instance
                         */
                        Object.defineProperty(DiskTypeList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskTypeList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @instance
                         */
                        Object.defineProperty(DiskTypeList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskTypeList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @instance
                         */
                        Object.defineProperty(DiskTypeList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * DiskTypeList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @instance
                         */
                        Object.defineProperty(DiskTypeList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DiskTypeList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @static
                         * @param {google.cloud.compute.v1.IDiskTypeList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DiskTypeList} DiskTypeList instance
                         */
                        DiskTypeList.create = function create(properties) {
                            return new DiskTypeList(properties);
                        };
    
                        /**
                         * Encodes the specified DiskTypeList message. Does not implicitly {@link google.cloud.compute.v1.DiskTypeList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @static
                         * @param {google.cloud.compute.v1.IDiskTypeList} message DiskTypeList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DiskTypeList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.DiskType.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DiskTypeList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DiskTypeList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @static
                         * @param {google.cloud.compute.v1.IDiskTypeList} message DiskTypeList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DiskTypeList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DiskTypeList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DiskTypeList} DiskTypeList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DiskTypeList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DiskTypeList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.DiskType.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DiskTypeList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DiskTypeList} DiskTypeList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DiskTypeList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DiskTypeList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DiskTypeList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.DiskType.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DiskTypeList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DiskTypeList} DiskTypeList
                         */
                        DiskTypeList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DiskTypeList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DiskTypeList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.DiskTypeList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.DiskTypeList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.DiskType.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.DiskTypeList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DiskTypeList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @static
                         * @param {google.cloud.compute.v1.DiskTypeList} message DiskTypeList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DiskTypeList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.DiskType.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this DiskTypeList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DiskTypeList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DiskTypeList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DiskTypeList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DiskTypeList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DiskTypeList";
                        };
    
                        return DiskTypeList;
                    })();
    
                    v1.DiskTypesScopedList = (function() {
    
                        /**
                         * Properties of a DiskTypesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IDiskTypesScopedList
                         * @property {Array.<google.cloud.compute.v1.IDiskType>|null} [diskTypes] DiskTypesScopedList diskTypes
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] DiskTypesScopedList warning
                         */
    
                        /**
                         * Constructs a new DiskTypesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DiskTypesScopedList.
                         * @implements IDiskTypesScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IDiskTypesScopedList=} [properties] Properties to set
                         */
                        function DiskTypesScopedList(properties) {
                            this.diskTypes = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DiskTypesScopedList diskTypes.
                         * @member {Array.<google.cloud.compute.v1.IDiskType>} diskTypes
                         * @memberof google.cloud.compute.v1.DiskTypesScopedList
                         * @instance
                         */
                        DiskTypesScopedList.prototype.diskTypes = $util.emptyArray;
    
                        /**
                         * DiskTypesScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.DiskTypesScopedList
                         * @instance
                         */
                        DiskTypesScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DiskTypesScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.DiskTypesScopedList
                         * @instance
                         */
                        Object.defineProperty(DiskTypesScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DiskTypesScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DiskTypesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IDiskTypesScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DiskTypesScopedList} DiskTypesScopedList instance
                         */
                        DiskTypesScopedList.create = function create(properties) {
                            return new DiskTypesScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified DiskTypesScopedList message. Does not implicitly {@link google.cloud.compute.v1.DiskTypesScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DiskTypesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IDiskTypesScopedList} message DiskTypesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DiskTypesScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.diskTypes != null && message.diskTypes.length)
                                for (var i = 0; i < message.diskTypes.length; ++i)
                                    $root.google.cloud.compute.v1.DiskType.encode(message.diskTypes[i], writer.uint32(/* id 198926167, wireType 2 =*/1591409338).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DiskTypesScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DiskTypesScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DiskTypesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IDiskTypesScopedList} message DiskTypesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DiskTypesScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DiskTypesScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DiskTypesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DiskTypesScopedList} DiskTypesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DiskTypesScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DiskTypesScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 198926167: {
                                        if (!(message.diskTypes && message.diskTypes.length))
                                            message.diskTypes = [];
                                        message.diskTypes.push($root.google.cloud.compute.v1.DiskType.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DiskTypesScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DiskTypesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DiskTypesScopedList} DiskTypesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DiskTypesScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DiskTypesScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DiskTypesScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DiskTypesScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.diskTypes != null && message.hasOwnProperty("diskTypes")) {
                                if (!Array.isArray(message.diskTypes))
                                    return "diskTypes: array expected";
                                for (var i = 0; i < message.diskTypes.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.DiskType.verify(message.diskTypes[i]);
                                    if (error)
                                        return "diskTypes." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DiskTypesScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DiskTypesScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DiskTypesScopedList} DiskTypesScopedList
                         */
                        DiskTypesScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DiskTypesScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DiskTypesScopedList();
                            if (object.diskTypes) {
                                if (!Array.isArray(object.diskTypes))
                                    throw TypeError(".google.cloud.compute.v1.DiskTypesScopedList.diskTypes: array expected");
                                message.diskTypes = [];
                                for (var i = 0; i < object.diskTypes.length; ++i) {
                                    if (typeof object.diskTypes[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.DiskTypesScopedList.diskTypes: object expected");
                                    message.diskTypes[i] = $root.google.cloud.compute.v1.DiskType.fromObject(object.diskTypes[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.DiskTypesScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DiskTypesScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DiskTypesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.DiskTypesScopedList} message DiskTypesScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DiskTypesScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.diskTypes = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.diskTypes && message.diskTypes.length) {
                                object.diskTypes = [];
                                for (var j = 0; j < message.diskTypes.length; ++j)
                                    object.diskTypes[j] = $root.google.cloud.compute.v1.DiskType.toObject(message.diskTypes[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this DiskTypesScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DiskTypesScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DiskTypesScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DiskTypesScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DiskTypesScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DiskTypesScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DiskTypesScopedList";
                        };
    
                        return DiskTypesScopedList;
                    })();
    
                    v1.DisksAddResourcePoliciesRequest = (function() {
    
                        /**
                         * Properties of a DisksAddResourcePoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDisksAddResourcePoliciesRequest
                         * @property {Array.<string>|null} [resourcePolicies] DisksAddResourcePoliciesRequest resourcePolicies
                         */
    
                        /**
                         * Constructs a new DisksAddResourcePoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DisksAddResourcePoliciesRequest.
                         * @implements IDisksAddResourcePoliciesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDisksAddResourcePoliciesRequest=} [properties] Properties to set
                         */
                        function DisksAddResourcePoliciesRequest(properties) {
                            this.resourcePolicies = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DisksAddResourcePoliciesRequest resourcePolicies.
                         * @member {Array.<string>} resourcePolicies
                         * @memberof google.cloud.compute.v1.DisksAddResourcePoliciesRequest
                         * @instance
                         */
                        DisksAddResourcePoliciesRequest.prototype.resourcePolicies = $util.emptyArray;
    
                        /**
                         * Creates a new DisksAddResourcePoliciesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DisksAddResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDisksAddResourcePoliciesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DisksAddResourcePoliciesRequest} DisksAddResourcePoliciesRequest instance
                         */
                        DisksAddResourcePoliciesRequest.create = function create(properties) {
                            return new DisksAddResourcePoliciesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DisksAddResourcePoliciesRequest message. Does not implicitly {@link google.cloud.compute.v1.DisksAddResourcePoliciesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DisksAddResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDisksAddResourcePoliciesRequest} message DisksAddResourcePoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisksAddResourcePoliciesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourcePolicies != null && message.resourcePolicies.length)
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    writer.uint32(/* id 22220385, wireType 2 =*/177763082).string(message.resourcePolicies[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DisksAddResourcePoliciesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DisksAddResourcePoliciesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DisksAddResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDisksAddResourcePoliciesRequest} message DisksAddResourcePoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisksAddResourcePoliciesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DisksAddResourcePoliciesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DisksAddResourcePoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DisksAddResourcePoliciesRequest} DisksAddResourcePoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisksAddResourcePoliciesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DisksAddResourcePoliciesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 22220385: {
                                        if (!(message.resourcePolicies && message.resourcePolicies.length))
                                            message.resourcePolicies = [];
                                        message.resourcePolicies.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DisksAddResourcePoliciesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DisksAddResourcePoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DisksAddResourcePoliciesRequest} DisksAddResourcePoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisksAddResourcePoliciesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DisksAddResourcePoliciesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DisksAddResourcePoliciesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DisksAddResourcePoliciesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourcePolicies != null && message.hasOwnProperty("resourcePolicies")) {
                                if (!Array.isArray(message.resourcePolicies))
                                    return "resourcePolicies: array expected";
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    if (!$util.isString(message.resourcePolicies[i]))
                                        return "resourcePolicies: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DisksAddResourcePoliciesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DisksAddResourcePoliciesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DisksAddResourcePoliciesRequest} DisksAddResourcePoliciesRequest
                         */
                        DisksAddResourcePoliciesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DisksAddResourcePoliciesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DisksAddResourcePoliciesRequest();
                            if (object.resourcePolicies) {
                                if (!Array.isArray(object.resourcePolicies))
                                    throw TypeError(".google.cloud.compute.v1.DisksAddResourcePoliciesRequest.resourcePolicies: array expected");
                                message.resourcePolicies = [];
                                for (var i = 0; i < object.resourcePolicies.length; ++i)
                                    message.resourcePolicies[i] = String(object.resourcePolicies[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DisksAddResourcePoliciesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DisksAddResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.DisksAddResourcePoliciesRequest} message DisksAddResourcePoliciesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DisksAddResourcePoliciesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.resourcePolicies = [];
                            if (message.resourcePolicies && message.resourcePolicies.length) {
                                object.resourcePolicies = [];
                                for (var j = 0; j < message.resourcePolicies.length; ++j)
                                    object.resourcePolicies[j] = message.resourcePolicies[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this DisksAddResourcePoliciesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DisksAddResourcePoliciesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DisksAddResourcePoliciesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DisksAddResourcePoliciesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DisksAddResourcePoliciesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DisksAddResourcePoliciesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DisksAddResourcePoliciesRequest";
                        };
    
                        return DisksAddResourcePoliciesRequest;
                    })();
    
                    v1.DisksRemoveResourcePoliciesRequest = (function() {
    
                        /**
                         * Properties of a DisksRemoveResourcePoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDisksRemoveResourcePoliciesRequest
                         * @property {Array.<string>|null} [resourcePolicies] DisksRemoveResourcePoliciesRequest resourcePolicies
                         */
    
                        /**
                         * Constructs a new DisksRemoveResourcePoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DisksRemoveResourcePoliciesRequest.
                         * @implements IDisksRemoveResourcePoliciesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDisksRemoveResourcePoliciesRequest=} [properties] Properties to set
                         */
                        function DisksRemoveResourcePoliciesRequest(properties) {
                            this.resourcePolicies = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DisksRemoveResourcePoliciesRequest resourcePolicies.
                         * @member {Array.<string>} resourcePolicies
                         * @memberof google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest
                         * @instance
                         */
                        DisksRemoveResourcePoliciesRequest.prototype.resourcePolicies = $util.emptyArray;
    
                        /**
                         * Creates a new DisksRemoveResourcePoliciesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDisksRemoveResourcePoliciesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest} DisksRemoveResourcePoliciesRequest instance
                         */
                        DisksRemoveResourcePoliciesRequest.create = function create(properties) {
                            return new DisksRemoveResourcePoliciesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DisksRemoveResourcePoliciesRequest message. Does not implicitly {@link google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDisksRemoveResourcePoliciesRequest} message DisksRemoveResourcePoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisksRemoveResourcePoliciesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourcePolicies != null && message.resourcePolicies.length)
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    writer.uint32(/* id 22220385, wireType 2 =*/177763082).string(message.resourcePolicies[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DisksRemoveResourcePoliciesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDisksRemoveResourcePoliciesRequest} message DisksRemoveResourcePoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisksRemoveResourcePoliciesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DisksRemoveResourcePoliciesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest} DisksRemoveResourcePoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisksRemoveResourcePoliciesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 22220385: {
                                        if (!(message.resourcePolicies && message.resourcePolicies.length))
                                            message.resourcePolicies = [];
                                        message.resourcePolicies.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DisksRemoveResourcePoliciesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest} DisksRemoveResourcePoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisksRemoveResourcePoliciesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DisksRemoveResourcePoliciesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DisksRemoveResourcePoliciesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourcePolicies != null && message.hasOwnProperty("resourcePolicies")) {
                                if (!Array.isArray(message.resourcePolicies))
                                    return "resourcePolicies: array expected";
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    if (!$util.isString(message.resourcePolicies[i]))
                                        return "resourcePolicies: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DisksRemoveResourcePoliciesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest} DisksRemoveResourcePoliciesRequest
                         */
                        DisksRemoveResourcePoliciesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest();
                            if (object.resourcePolicies) {
                                if (!Array.isArray(object.resourcePolicies))
                                    throw TypeError(".google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest.resourcePolicies: array expected");
                                message.resourcePolicies = [];
                                for (var i = 0; i < object.resourcePolicies.length; ++i)
                                    message.resourcePolicies[i] = String(object.resourcePolicies[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DisksRemoveResourcePoliciesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest} message DisksRemoveResourcePoliciesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DisksRemoveResourcePoliciesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.resourcePolicies = [];
                            if (message.resourcePolicies && message.resourcePolicies.length) {
                                object.resourcePolicies = [];
                                for (var j = 0; j < message.resourcePolicies.length; ++j)
                                    object.resourcePolicies[j] = message.resourcePolicies[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this DisksRemoveResourcePoliciesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DisksRemoveResourcePoliciesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DisksRemoveResourcePoliciesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DisksRemoveResourcePoliciesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest";
                        };
    
                        return DisksRemoveResourcePoliciesRequest;
                    })();
    
                    v1.DisksResizeRequest = (function() {
    
                        /**
                         * Properties of a DisksResizeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IDisksResizeRequest
                         * @property {number|Long|null} [sizeGb] DisksResizeRequest sizeGb
                         */
    
                        /**
                         * Constructs a new DisksResizeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DisksResizeRequest.
                         * @implements IDisksResizeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IDisksResizeRequest=} [properties] Properties to set
                         */
                        function DisksResizeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DisksResizeRequest sizeGb.
                         * @member {number|Long|null|undefined} sizeGb
                         * @memberof google.cloud.compute.v1.DisksResizeRequest
                         * @instance
                         */
                        DisksResizeRequest.prototype.sizeGb = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DisksResizeRequest _sizeGb.
                         * @member {"sizeGb"|undefined} _sizeGb
                         * @memberof google.cloud.compute.v1.DisksResizeRequest
                         * @instance
                         */
                        Object.defineProperty(DisksResizeRequest.prototype, "_sizeGb", {
                            get: $util.oneOfGetter($oneOfFields = ["sizeGb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DisksResizeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DisksResizeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDisksResizeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DisksResizeRequest} DisksResizeRequest instance
                         */
                        DisksResizeRequest.create = function create(properties) {
                            return new DisksResizeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DisksResizeRequest message. Does not implicitly {@link google.cloud.compute.v1.DisksResizeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DisksResizeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDisksResizeRequest} message DisksResizeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisksResizeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.sizeGb != null && Object.hasOwnProperty.call(message, "sizeGb"))
                                writer.uint32(/* id 494929369, wireType 0 =*/3959434952).int64(message.sizeGb);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DisksResizeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DisksResizeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DisksResizeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IDisksResizeRequest} message DisksResizeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisksResizeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DisksResizeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DisksResizeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DisksResizeRequest} DisksResizeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisksResizeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DisksResizeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 494929369: {
                                        message.sizeGb = reader.int64();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DisksResizeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DisksResizeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DisksResizeRequest} DisksResizeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisksResizeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DisksResizeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DisksResizeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DisksResizeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.sizeGb != null && message.hasOwnProperty("sizeGb")) {
                                properties._sizeGb = 1;
                                if (!$util.isInteger(message.sizeGb) && !(message.sizeGb && $util.isInteger(message.sizeGb.low) && $util.isInteger(message.sizeGb.high)))
                                    return "sizeGb: integer|Long expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DisksResizeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DisksResizeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DisksResizeRequest} DisksResizeRequest
                         */
                        DisksResizeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DisksResizeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DisksResizeRequest();
                            if (object.sizeGb != null)
                                if ($util.Long)
                                    (message.sizeGb = $util.Long.fromValue(object.sizeGb)).unsigned = false;
                                else if (typeof object.sizeGb === "string")
                                    message.sizeGb = parseInt(object.sizeGb, 10);
                                else if (typeof object.sizeGb === "number")
                                    message.sizeGb = object.sizeGb;
                                else if (typeof object.sizeGb === "object")
                                    message.sizeGb = new $util.LongBits(object.sizeGb.low >>> 0, object.sizeGb.high >>> 0).toNumber();
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DisksResizeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DisksResizeRequest
                         * @static
                         * @param {google.cloud.compute.v1.DisksResizeRequest} message DisksResizeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DisksResizeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.sizeGb != null && message.hasOwnProperty("sizeGb")) {
                                if (typeof message.sizeGb === "number")
                                    object.sizeGb = options.longs === String ? String(message.sizeGb) : message.sizeGb;
                                else
                                    object.sizeGb = options.longs === String ? $util.Long.prototype.toString.call(message.sizeGb) : options.longs === Number ? new $util.LongBits(message.sizeGb.low >>> 0, message.sizeGb.high >>> 0).toNumber() : message.sizeGb;
                                if (options.oneofs)
                                    object._sizeGb = "sizeGb";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this DisksResizeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DisksResizeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DisksResizeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DisksResizeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DisksResizeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DisksResizeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DisksResizeRequest";
                        };
    
                        return DisksResizeRequest;
                    })();
    
                    v1.DisksScopedList = (function() {
    
                        /**
                         * Properties of a DisksScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IDisksScopedList
                         * @property {Array.<google.cloud.compute.v1.IDisk>|null} [disks] DisksScopedList disks
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] DisksScopedList warning
                         */
    
                        /**
                         * Constructs a new DisksScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DisksScopedList.
                         * @implements IDisksScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IDisksScopedList=} [properties] Properties to set
                         */
                        function DisksScopedList(properties) {
                            this.disks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DisksScopedList disks.
                         * @member {Array.<google.cloud.compute.v1.IDisk>} disks
                         * @memberof google.cloud.compute.v1.DisksScopedList
                         * @instance
                         */
                        DisksScopedList.prototype.disks = $util.emptyArray;
    
                        /**
                         * DisksScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.DisksScopedList
                         * @instance
                         */
                        DisksScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DisksScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.DisksScopedList
                         * @instance
                         */
                        Object.defineProperty(DisksScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DisksScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DisksScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IDisksScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DisksScopedList} DisksScopedList instance
                         */
                        DisksScopedList.create = function create(properties) {
                            return new DisksScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified DisksScopedList message. Does not implicitly {@link google.cloud.compute.v1.DisksScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DisksScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IDisksScopedList} message DisksScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisksScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.disks != null && message.disks.length)
                                for (var i = 0; i < message.disks.length; ++i)
                                    $root.google.cloud.compute.v1.Disk.encode(message.disks[i], writer.uint32(/* id 95594102, wireType 2 =*/764752818).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DisksScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DisksScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DisksScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IDisksScopedList} message DisksScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisksScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DisksScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DisksScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DisksScopedList} DisksScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisksScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DisksScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 95594102: {
                                        if (!(message.disks && message.disks.length))
                                            message.disks = [];
                                        message.disks.push($root.google.cloud.compute.v1.Disk.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DisksScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DisksScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DisksScopedList} DisksScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisksScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DisksScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DisksScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DisksScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.disks != null && message.hasOwnProperty("disks")) {
                                if (!Array.isArray(message.disks))
                                    return "disks: array expected";
                                for (var i = 0; i < message.disks.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Disk.verify(message.disks[i]);
                                    if (error)
                                        return "disks." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DisksScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DisksScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DisksScopedList} DisksScopedList
                         */
                        DisksScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DisksScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DisksScopedList();
                            if (object.disks) {
                                if (!Array.isArray(object.disks))
                                    throw TypeError(".google.cloud.compute.v1.DisksScopedList.disks: array expected");
                                message.disks = [];
                                for (var i = 0; i < object.disks.length; ++i) {
                                    if (typeof object.disks[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.DisksScopedList.disks: object expected");
                                    message.disks[i] = $root.google.cloud.compute.v1.Disk.fromObject(object.disks[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.DisksScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DisksScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DisksScopedList
                         * @static
                         * @param {google.cloud.compute.v1.DisksScopedList} message DisksScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DisksScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.disks = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.disks && message.disks.length) {
                                object.disks = [];
                                for (var j = 0; j < message.disks.length; ++j)
                                    object.disks[j] = $root.google.cloud.compute.v1.Disk.toObject(message.disks[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this DisksScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DisksScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DisksScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DisksScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DisksScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DisksScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DisksScopedList";
                        };
    
                        return DisksScopedList;
                    })();
    
                    v1.DisplayDevice = (function() {
    
                        /**
                         * Properties of a DisplayDevice.
                         * @memberof google.cloud.compute.v1
                         * @interface IDisplayDevice
                         * @property {boolean|null} [enableDisplay] DisplayDevice enableDisplay
                         */
    
                        /**
                         * Constructs a new DisplayDevice.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DisplayDevice.
                         * @implements IDisplayDevice
                         * @constructor
                         * @param {google.cloud.compute.v1.IDisplayDevice=} [properties] Properties to set
                         */
                        function DisplayDevice(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DisplayDevice enableDisplay.
                         * @member {boolean|null|undefined} enableDisplay
                         * @memberof google.cloud.compute.v1.DisplayDevice
                         * @instance
                         */
                        DisplayDevice.prototype.enableDisplay = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DisplayDevice _enableDisplay.
                         * @member {"enableDisplay"|undefined} _enableDisplay
                         * @memberof google.cloud.compute.v1.DisplayDevice
                         * @instance
                         */
                        Object.defineProperty(DisplayDevice.prototype, "_enableDisplay", {
                            get: $util.oneOfGetter($oneOfFields = ["enableDisplay"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DisplayDevice instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DisplayDevice
                         * @static
                         * @param {google.cloud.compute.v1.IDisplayDevice=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DisplayDevice} DisplayDevice instance
                         */
                        DisplayDevice.create = function create(properties) {
                            return new DisplayDevice(properties);
                        };
    
                        /**
                         * Encodes the specified DisplayDevice message. Does not implicitly {@link google.cloud.compute.v1.DisplayDevice.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DisplayDevice
                         * @static
                         * @param {google.cloud.compute.v1.IDisplayDevice} message DisplayDevice message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisplayDevice.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.enableDisplay != null && Object.hasOwnProperty.call(message, "enableDisplay"))
                                writer.uint32(/* id 14266886, wireType 0 =*/114135088).bool(message.enableDisplay);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DisplayDevice message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DisplayDevice.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DisplayDevice
                         * @static
                         * @param {google.cloud.compute.v1.IDisplayDevice} message DisplayDevice message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DisplayDevice.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DisplayDevice message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DisplayDevice
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DisplayDevice} DisplayDevice
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisplayDevice.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DisplayDevice();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 14266886: {
                                        message.enableDisplay = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DisplayDevice message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DisplayDevice
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DisplayDevice} DisplayDevice
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DisplayDevice.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DisplayDevice message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DisplayDevice
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DisplayDevice.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.enableDisplay != null && message.hasOwnProperty("enableDisplay")) {
                                properties._enableDisplay = 1;
                                if (typeof message.enableDisplay !== "boolean")
                                    return "enableDisplay: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DisplayDevice message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DisplayDevice
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DisplayDevice} DisplayDevice
                         */
                        DisplayDevice.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DisplayDevice)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DisplayDevice();
                            if (object.enableDisplay != null)
                                message.enableDisplay = Boolean(object.enableDisplay);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DisplayDevice message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DisplayDevice
                         * @static
                         * @param {google.cloud.compute.v1.DisplayDevice} message DisplayDevice
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DisplayDevice.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.enableDisplay != null && message.hasOwnProperty("enableDisplay")) {
                                object.enableDisplay = message.enableDisplay;
                                if (options.oneofs)
                                    object._enableDisplay = "enableDisplay";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this DisplayDevice to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DisplayDevice
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DisplayDevice.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DisplayDevice
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DisplayDevice
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DisplayDevice.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DisplayDevice";
                        };
    
                        return DisplayDevice;
                    })();
    
                    v1.DistributionPolicy = (function() {
    
                        /**
                         * Properties of a DistributionPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IDistributionPolicy
                         * @property {string|null} [targetShape] DistributionPolicy targetShape
                         * @property {Array.<google.cloud.compute.v1.IDistributionPolicyZoneConfiguration>|null} [zones] DistributionPolicy zones
                         */
    
                        /**
                         * Constructs a new DistributionPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DistributionPolicy.
                         * @implements IDistributionPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IDistributionPolicy=} [properties] Properties to set
                         */
                        function DistributionPolicy(properties) {
                            this.zones = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DistributionPolicy targetShape.
                         * @member {string|null|undefined} targetShape
                         * @memberof google.cloud.compute.v1.DistributionPolicy
                         * @instance
                         */
                        DistributionPolicy.prototype.targetShape = null;
    
                        /**
                         * DistributionPolicy zones.
                         * @member {Array.<google.cloud.compute.v1.IDistributionPolicyZoneConfiguration>} zones
                         * @memberof google.cloud.compute.v1.DistributionPolicy
                         * @instance
                         */
                        DistributionPolicy.prototype.zones = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DistributionPolicy _targetShape.
                         * @member {"targetShape"|undefined} _targetShape
                         * @memberof google.cloud.compute.v1.DistributionPolicy
                         * @instance
                         */
                        Object.defineProperty(DistributionPolicy.prototype, "_targetShape", {
                            get: $util.oneOfGetter($oneOfFields = ["targetShape"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DistributionPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DistributionPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IDistributionPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DistributionPolicy} DistributionPolicy instance
                         */
                        DistributionPolicy.create = function create(properties) {
                            return new DistributionPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified DistributionPolicy message. Does not implicitly {@link google.cloud.compute.v1.DistributionPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DistributionPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IDistributionPolicy} message DistributionPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DistributionPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zones != null && message.zones.length)
                                for (var i = 0; i < message.zones.length; ++i)
                                    $root.google.cloud.compute.v1.DistributionPolicyZoneConfiguration.encode(message.zones[i], writer.uint32(/* id 116085319, wireType 2 =*/928682554).fork()).ldelim();
                            if (message.targetShape != null && Object.hasOwnProperty.call(message, "targetShape"))
                                writer.uint32(/* id 338621299, wireType 2 =*/2708970394).string(message.targetShape);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DistributionPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DistributionPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DistributionPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IDistributionPolicy} message DistributionPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DistributionPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DistributionPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DistributionPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DistributionPolicy} DistributionPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DistributionPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DistributionPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 338621299: {
                                        message.targetShape = reader.string();
                                        break;
                                    }
                                case 116085319: {
                                        if (!(message.zones && message.zones.length))
                                            message.zones = [];
                                        message.zones.push($root.google.cloud.compute.v1.DistributionPolicyZoneConfiguration.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DistributionPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DistributionPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DistributionPolicy} DistributionPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DistributionPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DistributionPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DistributionPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DistributionPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.targetShape != null && message.hasOwnProperty("targetShape")) {
                                properties._targetShape = 1;
                                if (!$util.isString(message.targetShape))
                                    return "targetShape: string expected";
                            }
                            if (message.zones != null && message.hasOwnProperty("zones")) {
                                if (!Array.isArray(message.zones))
                                    return "zones: array expected";
                                for (var i = 0; i < message.zones.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.DistributionPolicyZoneConfiguration.verify(message.zones[i]);
                                    if (error)
                                        return "zones." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DistributionPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DistributionPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DistributionPolicy} DistributionPolicy
                         */
                        DistributionPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DistributionPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DistributionPolicy();
                            if (object.targetShape != null)
                                message.targetShape = String(object.targetShape);
                            if (object.zones) {
                                if (!Array.isArray(object.zones))
                                    throw TypeError(".google.cloud.compute.v1.DistributionPolicy.zones: array expected");
                                message.zones = [];
                                for (var i = 0; i < object.zones.length; ++i) {
                                    if (typeof object.zones[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.DistributionPolicy.zones: object expected");
                                    message.zones[i] = $root.google.cloud.compute.v1.DistributionPolicyZoneConfiguration.fromObject(object.zones[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DistributionPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DistributionPolicy
                         * @static
                         * @param {google.cloud.compute.v1.DistributionPolicy} message DistributionPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DistributionPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.zones = [];
                            if (message.zones && message.zones.length) {
                                object.zones = [];
                                for (var j = 0; j < message.zones.length; ++j)
                                    object.zones[j] = $root.google.cloud.compute.v1.DistributionPolicyZoneConfiguration.toObject(message.zones[j], options);
                            }
                            if (message.targetShape != null && message.hasOwnProperty("targetShape")) {
                                object.targetShape = message.targetShape;
                                if (options.oneofs)
                                    object._targetShape = "targetShape";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this DistributionPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DistributionPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DistributionPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DistributionPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DistributionPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DistributionPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DistributionPolicy";
                        };
    
                        /**
                         * TargetShape enum.
                         * @name google.cloud.compute.v1.DistributionPolicy.TargetShape
                         * @enum {number}
                         * @property {number} UNDEFINED_TARGET_SHAPE=0 UNDEFINED_TARGET_SHAPE value
                         * @property {number} ANY=64972 ANY value
                         * @property {number} BALANCED=468409608 BALANCED value
                         * @property {number} EVEN=2140442 EVEN value
                         */
                        DistributionPolicy.TargetShape = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TARGET_SHAPE"] = 0;
                            values[valuesById[64972] = "ANY"] = 64972;
                            values[valuesById[468409608] = "BALANCED"] = 468409608;
                            values[valuesById[2140442] = "EVEN"] = 2140442;
                            return values;
                        })();
    
                        return DistributionPolicy;
                    })();
    
                    v1.DistributionPolicyZoneConfiguration = (function() {
    
                        /**
                         * Properties of a DistributionPolicyZoneConfiguration.
                         * @memberof google.cloud.compute.v1
                         * @interface IDistributionPolicyZoneConfiguration
                         * @property {string|null} [zone] DistributionPolicyZoneConfiguration zone
                         */
    
                        /**
                         * Constructs a new DistributionPolicyZoneConfiguration.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DistributionPolicyZoneConfiguration.
                         * @implements IDistributionPolicyZoneConfiguration
                         * @constructor
                         * @param {google.cloud.compute.v1.IDistributionPolicyZoneConfiguration=} [properties] Properties to set
                         */
                        function DistributionPolicyZoneConfiguration(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DistributionPolicyZoneConfiguration zone.
                         * @member {string|null|undefined} zone
                         * @memberof google.cloud.compute.v1.DistributionPolicyZoneConfiguration
                         * @instance
                         */
                        DistributionPolicyZoneConfiguration.prototype.zone = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DistributionPolicyZoneConfiguration _zone.
                         * @member {"zone"|undefined} _zone
                         * @memberof google.cloud.compute.v1.DistributionPolicyZoneConfiguration
                         * @instance
                         */
                        Object.defineProperty(DistributionPolicyZoneConfiguration.prototype, "_zone", {
                            get: $util.oneOfGetter($oneOfFields = ["zone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DistributionPolicyZoneConfiguration instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.DistributionPolicyZoneConfiguration
                         * @static
                         * @param {google.cloud.compute.v1.IDistributionPolicyZoneConfiguration=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.DistributionPolicyZoneConfiguration} DistributionPolicyZoneConfiguration instance
                         */
                        DistributionPolicyZoneConfiguration.create = function create(properties) {
                            return new DistributionPolicyZoneConfiguration(properties);
                        };
    
                        /**
                         * Encodes the specified DistributionPolicyZoneConfiguration message. Does not implicitly {@link google.cloud.compute.v1.DistributionPolicyZoneConfiguration.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.DistributionPolicyZoneConfiguration
                         * @static
                         * @param {google.cloud.compute.v1.IDistributionPolicyZoneConfiguration} message DistributionPolicyZoneConfiguration message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DistributionPolicyZoneConfiguration.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DistributionPolicyZoneConfiguration message, length delimited. Does not implicitly {@link google.cloud.compute.v1.DistributionPolicyZoneConfiguration.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.DistributionPolicyZoneConfiguration
                         * @static
                         * @param {google.cloud.compute.v1.IDistributionPolicyZoneConfiguration} message DistributionPolicyZoneConfiguration message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DistributionPolicyZoneConfiguration.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DistributionPolicyZoneConfiguration message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.DistributionPolicyZoneConfiguration
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.DistributionPolicyZoneConfiguration} DistributionPolicyZoneConfiguration
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DistributionPolicyZoneConfiguration.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.DistributionPolicyZoneConfiguration();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DistributionPolicyZoneConfiguration message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.DistributionPolicyZoneConfiguration
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.DistributionPolicyZoneConfiguration} DistributionPolicyZoneConfiguration
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DistributionPolicyZoneConfiguration.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DistributionPolicyZoneConfiguration message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.DistributionPolicyZoneConfiguration
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DistributionPolicyZoneConfiguration.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                properties._zone = 1;
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DistributionPolicyZoneConfiguration message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.DistributionPolicyZoneConfiguration
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.DistributionPolicyZoneConfiguration} DistributionPolicyZoneConfiguration
                         */
                        DistributionPolicyZoneConfiguration.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.DistributionPolicyZoneConfiguration)
                                return object;
                            var message = new $root.google.cloud.compute.v1.DistributionPolicyZoneConfiguration();
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DistributionPolicyZoneConfiguration message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.DistributionPolicyZoneConfiguration
                         * @static
                         * @param {google.cloud.compute.v1.DistributionPolicyZoneConfiguration} message DistributionPolicyZoneConfiguration
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DistributionPolicyZoneConfiguration.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                object.zone = message.zone;
                                if (options.oneofs)
                                    object._zone = "zone";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this DistributionPolicyZoneConfiguration to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.DistributionPolicyZoneConfiguration
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DistributionPolicyZoneConfiguration.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DistributionPolicyZoneConfiguration
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.DistributionPolicyZoneConfiguration
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DistributionPolicyZoneConfiguration.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.DistributionPolicyZoneConfiguration";
                        };
    
                        return DistributionPolicyZoneConfiguration;
                    })();
    
                    v1.Duration = (function() {
    
                        /**
                         * Properties of a Duration.
                         * @memberof google.cloud.compute.v1
                         * @interface IDuration
                         * @property {number|null} [nanos] Duration nanos
                         * @property {number|Long|null} [seconds] Duration seconds
                         */
    
                        /**
                         * Constructs a new Duration.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Duration.
                         * @implements IDuration
                         * @constructor
                         * @param {google.cloud.compute.v1.IDuration=} [properties] Properties to set
                         */
                        function Duration(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Duration nanos.
                         * @member {number|null|undefined} nanos
                         * @memberof google.cloud.compute.v1.Duration
                         * @instance
                         */
                        Duration.prototype.nanos = null;
    
                        /**
                         * Duration seconds.
                         * @member {number|Long|null|undefined} seconds
                         * @memberof google.cloud.compute.v1.Duration
                         * @instance
                         */
                        Duration.prototype.seconds = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Duration _nanos.
                         * @member {"nanos"|undefined} _nanos
                         * @memberof google.cloud.compute.v1.Duration
                         * @instance
                         */
                        Object.defineProperty(Duration.prototype, "_nanos", {
                            get: $util.oneOfGetter($oneOfFields = ["nanos"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Duration _seconds.
                         * @member {"seconds"|undefined} _seconds
                         * @memberof google.cloud.compute.v1.Duration
                         * @instance
                         */
                        Object.defineProperty(Duration.prototype, "_seconds", {
                            get: $util.oneOfGetter($oneOfFields = ["seconds"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Duration instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Duration
                         * @static
                         * @param {google.cloud.compute.v1.IDuration=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Duration} Duration instance
                         */
                        Duration.create = function create(properties) {
                            return new Duration(properties);
                        };
    
                        /**
                         * Encodes the specified Duration message. Does not implicitly {@link google.cloud.compute.v1.Duration.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Duration
                         * @static
                         * @param {google.cloud.compute.v1.IDuration} message Duration message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Duration.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.nanos != null && Object.hasOwnProperty.call(message, "nanos"))
                                writer.uint32(/* id 104586303, wireType 0 =*/836690424).int32(message.nanos);
                            if (message.seconds != null && Object.hasOwnProperty.call(message, "seconds"))
                                writer.uint32(/* id 359484031, wireType 0 =*/2875872248).int64(message.seconds);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Duration message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Duration.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Duration
                         * @static
                         * @param {google.cloud.compute.v1.IDuration} message Duration message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Duration.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Duration message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Duration
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Duration} Duration
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Duration.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Duration();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 104586303: {
                                        message.nanos = reader.int32();
                                        break;
                                    }
                                case 359484031: {
                                        message.seconds = reader.int64();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Duration message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Duration
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Duration} Duration
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Duration.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Duration message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Duration
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Duration.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.nanos != null && message.hasOwnProperty("nanos")) {
                                properties._nanos = 1;
                                if (!$util.isInteger(message.nanos))
                                    return "nanos: integer expected";
                            }
                            if (message.seconds != null && message.hasOwnProperty("seconds")) {
                                properties._seconds = 1;
                                if (!$util.isInteger(message.seconds) && !(message.seconds && $util.isInteger(message.seconds.low) && $util.isInteger(message.seconds.high)))
                                    return "seconds: integer|Long expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Duration message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Duration
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Duration} Duration
                         */
                        Duration.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Duration)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Duration();
                            if (object.nanos != null)
                                message.nanos = object.nanos | 0;
                            if (object.seconds != null)
                                if ($util.Long)
                                    (message.seconds = $util.Long.fromValue(object.seconds)).unsigned = false;
                                else if (typeof object.seconds === "string")
                                    message.seconds = parseInt(object.seconds, 10);
                                else if (typeof object.seconds === "number")
                                    message.seconds = object.seconds;
                                else if (typeof object.seconds === "object")
                                    message.seconds = new $util.LongBits(object.seconds.low >>> 0, object.seconds.high >>> 0).toNumber();
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Duration message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Duration
                         * @static
                         * @param {google.cloud.compute.v1.Duration} message Duration
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Duration.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.nanos != null && message.hasOwnProperty("nanos")) {
                                object.nanos = message.nanos;
                                if (options.oneofs)
                                    object._nanos = "nanos";
                            }
                            if (message.seconds != null && message.hasOwnProperty("seconds")) {
                                if (typeof message.seconds === "number")
                                    object.seconds = options.longs === String ? String(message.seconds) : message.seconds;
                                else
                                    object.seconds = options.longs === String ? $util.Long.prototype.toString.call(message.seconds) : options.longs === Number ? new $util.LongBits(message.seconds.low >>> 0, message.seconds.high >>> 0).toNumber() : message.seconds;
                                if (options.oneofs)
                                    object._seconds = "seconds";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Duration to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Duration
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Duration.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Duration
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Duration
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Duration.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Duration";
                        };
    
                        return Duration;
                    })();
    
                    v1.EnableXpnHostProjectRequest = (function() {
    
                        /**
                         * Properties of an EnableXpnHostProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IEnableXpnHostProjectRequest
                         * @property {string|null} [project] EnableXpnHostProjectRequest project
                         * @property {string|null} [requestId] EnableXpnHostProjectRequest requestId
                         */
    
                        /**
                         * Constructs a new EnableXpnHostProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an EnableXpnHostProjectRequest.
                         * @implements IEnableXpnHostProjectRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IEnableXpnHostProjectRequest=} [properties] Properties to set
                         */
                        function EnableXpnHostProjectRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * EnableXpnHostProjectRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.EnableXpnHostProjectRequest
                         * @instance
                         */
                        EnableXpnHostProjectRequest.prototype.project = "";
    
                        /**
                         * EnableXpnHostProjectRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.EnableXpnHostProjectRequest
                         * @instance
                         */
                        EnableXpnHostProjectRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * EnableXpnHostProjectRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.EnableXpnHostProjectRequest
                         * @instance
                         */
                        Object.defineProperty(EnableXpnHostProjectRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new EnableXpnHostProjectRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.EnableXpnHostProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IEnableXpnHostProjectRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.EnableXpnHostProjectRequest} EnableXpnHostProjectRequest instance
                         */
                        EnableXpnHostProjectRequest.create = function create(properties) {
                            return new EnableXpnHostProjectRequest(properties);
                        };
    
                        /**
                         * Encodes the specified EnableXpnHostProjectRequest message. Does not implicitly {@link google.cloud.compute.v1.EnableXpnHostProjectRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.EnableXpnHostProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IEnableXpnHostProjectRequest} message EnableXpnHostProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        EnableXpnHostProjectRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified EnableXpnHostProjectRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.EnableXpnHostProjectRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.EnableXpnHostProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IEnableXpnHostProjectRequest} message EnableXpnHostProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        EnableXpnHostProjectRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an EnableXpnHostProjectRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.EnableXpnHostProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.EnableXpnHostProjectRequest} EnableXpnHostProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        EnableXpnHostProjectRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.EnableXpnHostProjectRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an EnableXpnHostProjectRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.EnableXpnHostProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.EnableXpnHostProjectRequest} EnableXpnHostProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        EnableXpnHostProjectRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an EnableXpnHostProjectRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.EnableXpnHostProjectRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        EnableXpnHostProjectRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an EnableXpnHostProjectRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.EnableXpnHostProjectRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.EnableXpnHostProjectRequest} EnableXpnHostProjectRequest
                         */
                        EnableXpnHostProjectRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.EnableXpnHostProjectRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.EnableXpnHostProjectRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an EnableXpnHostProjectRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.EnableXpnHostProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.EnableXpnHostProjectRequest} message EnableXpnHostProjectRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        EnableXpnHostProjectRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this EnableXpnHostProjectRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.EnableXpnHostProjectRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        EnableXpnHostProjectRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for EnableXpnHostProjectRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.EnableXpnHostProjectRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        EnableXpnHostProjectRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.EnableXpnHostProjectRequest";
                        };
    
                        return EnableXpnHostProjectRequest;
                    })();
    
                    v1.EnableXpnResourceProjectRequest = (function() {
    
                        /**
                         * Properties of an EnableXpnResourceProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IEnableXpnResourceProjectRequest
                         * @property {string|null} [project] EnableXpnResourceProjectRequest project
                         * @property {google.cloud.compute.v1.IProjectsEnableXpnResourceRequest|null} [projectsEnableXpnResourceRequestResource] EnableXpnResourceProjectRequest projectsEnableXpnResourceRequestResource
                         * @property {string|null} [requestId] EnableXpnResourceProjectRequest requestId
                         */
    
                        /**
                         * Constructs a new EnableXpnResourceProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an EnableXpnResourceProjectRequest.
                         * @implements IEnableXpnResourceProjectRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IEnableXpnResourceProjectRequest=} [properties] Properties to set
                         */
                        function EnableXpnResourceProjectRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * EnableXpnResourceProjectRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.EnableXpnResourceProjectRequest
                         * @instance
                         */
                        EnableXpnResourceProjectRequest.prototype.project = "";
    
                        /**
                         * EnableXpnResourceProjectRequest projectsEnableXpnResourceRequestResource.
                         * @member {google.cloud.compute.v1.IProjectsEnableXpnResourceRequest|null|undefined} projectsEnableXpnResourceRequestResource
                         * @memberof google.cloud.compute.v1.EnableXpnResourceProjectRequest
                         * @instance
                         */
                        EnableXpnResourceProjectRequest.prototype.projectsEnableXpnResourceRequestResource = null;
    
                        /**
                         * EnableXpnResourceProjectRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.EnableXpnResourceProjectRequest
                         * @instance
                         */
                        EnableXpnResourceProjectRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * EnableXpnResourceProjectRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.EnableXpnResourceProjectRequest
                         * @instance
                         */
                        Object.defineProperty(EnableXpnResourceProjectRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new EnableXpnResourceProjectRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.EnableXpnResourceProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IEnableXpnResourceProjectRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.EnableXpnResourceProjectRequest} EnableXpnResourceProjectRequest instance
                         */
                        EnableXpnResourceProjectRequest.create = function create(properties) {
                            return new EnableXpnResourceProjectRequest(properties);
                        };
    
                        /**
                         * Encodes the specified EnableXpnResourceProjectRequest message. Does not implicitly {@link google.cloud.compute.v1.EnableXpnResourceProjectRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.EnableXpnResourceProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IEnableXpnResourceProjectRequest} message EnableXpnResourceProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        EnableXpnResourceProjectRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.projectsEnableXpnResourceRequestResource != null && Object.hasOwnProperty.call(message, "projectsEnableXpnResourceRequestResource"))
                                $root.google.cloud.compute.v1.ProjectsEnableXpnResourceRequest.encode(message.projectsEnableXpnResourceRequestResource, writer.uint32(/* id 421980207, wireType 2 =*/3375841658).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified EnableXpnResourceProjectRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.EnableXpnResourceProjectRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.EnableXpnResourceProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IEnableXpnResourceProjectRequest} message EnableXpnResourceProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        EnableXpnResourceProjectRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an EnableXpnResourceProjectRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.EnableXpnResourceProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.EnableXpnResourceProjectRequest} EnableXpnResourceProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        EnableXpnResourceProjectRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.EnableXpnResourceProjectRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 421980207: {
                                        message.projectsEnableXpnResourceRequestResource = $root.google.cloud.compute.v1.ProjectsEnableXpnResourceRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an EnableXpnResourceProjectRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.EnableXpnResourceProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.EnableXpnResourceProjectRequest} EnableXpnResourceProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        EnableXpnResourceProjectRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an EnableXpnResourceProjectRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.EnableXpnResourceProjectRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        EnableXpnResourceProjectRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.projectsEnableXpnResourceRequestResource != null && message.hasOwnProperty("projectsEnableXpnResourceRequestResource")) {
                                var error = $root.google.cloud.compute.v1.ProjectsEnableXpnResourceRequest.verify(message.projectsEnableXpnResourceRequestResource);
                                if (error)
                                    return "projectsEnableXpnResourceRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an EnableXpnResourceProjectRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.EnableXpnResourceProjectRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.EnableXpnResourceProjectRequest} EnableXpnResourceProjectRequest
                         */
                        EnableXpnResourceProjectRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.EnableXpnResourceProjectRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.EnableXpnResourceProjectRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.projectsEnableXpnResourceRequestResource != null) {
                                if (typeof object.projectsEnableXpnResourceRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.EnableXpnResourceProjectRequest.projectsEnableXpnResourceRequestResource: object expected");
                                message.projectsEnableXpnResourceRequestResource = $root.google.cloud.compute.v1.ProjectsEnableXpnResourceRequest.fromObject(object.projectsEnableXpnResourceRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an EnableXpnResourceProjectRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.EnableXpnResourceProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.EnableXpnResourceProjectRequest} message EnableXpnResourceProjectRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        EnableXpnResourceProjectRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.projectsEnableXpnResourceRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.projectsEnableXpnResourceRequestResource != null && message.hasOwnProperty("projectsEnableXpnResourceRequestResource"))
                                object.projectsEnableXpnResourceRequestResource = $root.google.cloud.compute.v1.ProjectsEnableXpnResourceRequest.toObject(message.projectsEnableXpnResourceRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this EnableXpnResourceProjectRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.EnableXpnResourceProjectRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        EnableXpnResourceProjectRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for EnableXpnResourceProjectRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.EnableXpnResourceProjectRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        EnableXpnResourceProjectRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.EnableXpnResourceProjectRequest";
                        };
    
                        return EnableXpnResourceProjectRequest;
                    })();
    
                    v1.Error = (function() {
    
                        /**
                         * Properties of an Error.
                         * @memberof google.cloud.compute.v1
                         * @interface IError
                         * @property {Array.<google.cloud.compute.v1.IErrors>|null} [errors] Error errors
                         */
    
                        /**
                         * Constructs a new Error.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an Error.
                         * @implements IError
                         * @constructor
                         * @param {google.cloud.compute.v1.IError=} [properties] Properties to set
                         */
                        function Error(properties) {
                            this.errors = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Error errors.
                         * @member {Array.<google.cloud.compute.v1.IErrors>} errors
                         * @memberof google.cloud.compute.v1.Error
                         * @instance
                         */
                        Error.prototype.errors = $util.emptyArray;
    
                        /**
                         * Creates a new Error instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Error
                         * @static
                         * @param {google.cloud.compute.v1.IError=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Error} Error instance
                         */
                        Error.create = function create(properties) {
                            return new Error(properties);
                        };
    
                        /**
                         * Encodes the specified Error message. Does not implicitly {@link google.cloud.compute.v1.Error.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Error
                         * @static
                         * @param {google.cloud.compute.v1.IError} message Error message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Error.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.errors != null && message.errors.length)
                                for (var i = 0; i < message.errors.length; ++i)
                                    $root.google.cloud.compute.v1.Errors.encode(message.errors[i], writer.uint32(/* id 315977579, wireType 2 =*/2527820634).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Error message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Error.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Error
                         * @static
                         * @param {google.cloud.compute.v1.IError} message Error message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Error.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Error message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Error
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Error} Error
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Error.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Error();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 315977579: {
                                        if (!(message.errors && message.errors.length))
                                            message.errors = [];
                                        message.errors.push($root.google.cloud.compute.v1.Errors.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Error message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Error
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Error} Error
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Error.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Error message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Error
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Error.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.errors != null && message.hasOwnProperty("errors")) {
                                if (!Array.isArray(message.errors))
                                    return "errors: array expected";
                                for (var i = 0; i < message.errors.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Errors.verify(message.errors[i]);
                                    if (error)
                                        return "errors." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an Error message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Error
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Error} Error
                         */
                        Error.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Error)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Error();
                            if (object.errors) {
                                if (!Array.isArray(object.errors))
                                    throw TypeError(".google.cloud.compute.v1.Error.errors: array expected");
                                message.errors = [];
                                for (var i = 0; i < object.errors.length; ++i) {
                                    if (typeof object.errors[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Error.errors: object expected");
                                    message.errors[i] = $root.google.cloud.compute.v1.Errors.fromObject(object.errors[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Error message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Error
                         * @static
                         * @param {google.cloud.compute.v1.Error} message Error
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Error.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.errors = [];
                            if (message.errors && message.errors.length) {
                                object.errors = [];
                                for (var j = 0; j < message.errors.length; ++j)
                                    object.errors[j] = $root.google.cloud.compute.v1.Errors.toObject(message.errors[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Error to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Error
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Error.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Error
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Error
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Error.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Error";
                        };
    
                        return Error;
                    })();
    
                    v1.ErrorDetails = (function() {
    
                        /**
                         * Properties of an ErrorDetails.
                         * @memberof google.cloud.compute.v1
                         * @interface IErrorDetails
                         * @property {google.cloud.compute.v1.IErrorInfo|null} [errorInfo] ErrorDetails errorInfo
                         * @property {google.cloud.compute.v1.IHelp|null} [help] ErrorDetails help
                         * @property {google.cloud.compute.v1.ILocalizedMessage|null} [localizedMessage] ErrorDetails localizedMessage
                         * @property {google.cloud.compute.v1.IQuotaExceededInfo|null} [quotaInfo] ErrorDetails quotaInfo
                         */
    
                        /**
                         * Constructs a new ErrorDetails.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an ErrorDetails.
                         * @implements IErrorDetails
                         * @constructor
                         * @param {google.cloud.compute.v1.IErrorDetails=} [properties] Properties to set
                         */
                        function ErrorDetails(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ErrorDetails errorInfo.
                         * @member {google.cloud.compute.v1.IErrorInfo|null|undefined} errorInfo
                         * @memberof google.cloud.compute.v1.ErrorDetails
                         * @instance
                         */
                        ErrorDetails.prototype.errorInfo = null;
    
                        /**
                         * ErrorDetails help.
                         * @member {google.cloud.compute.v1.IHelp|null|undefined} help
                         * @memberof google.cloud.compute.v1.ErrorDetails
                         * @instance
                         */
                        ErrorDetails.prototype.help = null;
    
                        /**
                         * ErrorDetails localizedMessage.
                         * @member {google.cloud.compute.v1.ILocalizedMessage|null|undefined} localizedMessage
                         * @memberof google.cloud.compute.v1.ErrorDetails
                         * @instance
                         */
                        ErrorDetails.prototype.localizedMessage = null;
    
                        /**
                         * ErrorDetails quotaInfo.
                         * @member {google.cloud.compute.v1.IQuotaExceededInfo|null|undefined} quotaInfo
                         * @memberof google.cloud.compute.v1.ErrorDetails
                         * @instance
                         */
                        ErrorDetails.prototype.quotaInfo = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ErrorDetails _errorInfo.
                         * @member {"errorInfo"|undefined} _errorInfo
                         * @memberof google.cloud.compute.v1.ErrorDetails
                         * @instance
                         */
                        Object.defineProperty(ErrorDetails.prototype, "_errorInfo", {
                            get: $util.oneOfGetter($oneOfFields = ["errorInfo"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ErrorDetails _help.
                         * @member {"help"|undefined} _help
                         * @memberof google.cloud.compute.v1.ErrorDetails
                         * @instance
                         */
                        Object.defineProperty(ErrorDetails.prototype, "_help", {
                            get: $util.oneOfGetter($oneOfFields = ["help"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ErrorDetails _localizedMessage.
                         * @member {"localizedMessage"|undefined} _localizedMessage
                         * @memberof google.cloud.compute.v1.ErrorDetails
                         * @instance
                         */
                        Object.defineProperty(ErrorDetails.prototype, "_localizedMessage", {
                            get: $util.oneOfGetter($oneOfFields = ["localizedMessage"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ErrorDetails _quotaInfo.
                         * @member {"quotaInfo"|undefined} _quotaInfo
                         * @memberof google.cloud.compute.v1.ErrorDetails
                         * @instance
                         */
                        Object.defineProperty(ErrorDetails.prototype, "_quotaInfo", {
                            get: $util.oneOfGetter($oneOfFields = ["quotaInfo"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ErrorDetails instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ErrorDetails
                         * @static
                         * @param {google.cloud.compute.v1.IErrorDetails=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ErrorDetails} ErrorDetails instance
                         */
                        ErrorDetails.create = function create(properties) {
                            return new ErrorDetails(properties);
                        };
    
                        /**
                         * Encodes the specified ErrorDetails message. Does not implicitly {@link google.cloud.compute.v1.ErrorDetails.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ErrorDetails
                         * @static
                         * @param {google.cloud.compute.v1.IErrorDetails} message ErrorDetails message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ErrorDetails.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.help != null && Object.hasOwnProperty.call(message, "help"))
                                $root.google.cloud.compute.v1.Help.encode(message.help, writer.uint32(/* id 3198785, wireType 2 =*/25590282).fork()).ldelim();
                            if (message.errorInfo != null && Object.hasOwnProperty.call(message, "errorInfo"))
                                $root.google.cloud.compute.v1.ErrorInfo.encode(message.errorInfo, writer.uint32(/* id 25251973, wireType 2 =*/202015786).fork()).ldelim();
                            if (message.quotaInfo != null && Object.hasOwnProperty.call(message, "quotaInfo"))
                                $root.google.cloud.compute.v1.QuotaExceededInfo.encode(message.quotaInfo, writer.uint32(/* id 93923861, wireType 2 =*/751390890).fork()).ldelim();
                            if (message.localizedMessage != null && Object.hasOwnProperty.call(message, "localizedMessage"))
                                $root.google.cloud.compute.v1.LocalizedMessage.encode(message.localizedMessage, writer.uint32(/* id 404537155, wireType 2 =*/3236297242).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ErrorDetails message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ErrorDetails.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ErrorDetails
                         * @static
                         * @param {google.cloud.compute.v1.IErrorDetails} message ErrorDetails message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ErrorDetails.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ErrorDetails message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ErrorDetails
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ErrorDetails} ErrorDetails
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ErrorDetails.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ErrorDetails();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 25251973: {
                                        message.errorInfo = $root.google.cloud.compute.v1.ErrorInfo.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3198785: {
                                        message.help = $root.google.cloud.compute.v1.Help.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 404537155: {
                                        message.localizedMessage = $root.google.cloud.compute.v1.LocalizedMessage.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 93923861: {
                                        message.quotaInfo = $root.google.cloud.compute.v1.QuotaExceededInfo.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ErrorDetails message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ErrorDetails
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ErrorDetails} ErrorDetails
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ErrorDetails.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ErrorDetails message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ErrorDetails
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ErrorDetails.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.errorInfo != null && message.hasOwnProperty("errorInfo")) {
                                properties._errorInfo = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ErrorInfo.verify(message.errorInfo);
                                    if (error)
                                        return "errorInfo." + error;
                                }
                            }
                            if (message.help != null && message.hasOwnProperty("help")) {
                                properties._help = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Help.verify(message.help);
                                    if (error)
                                        return "help." + error;
                                }
                            }
                            if (message.localizedMessage != null && message.hasOwnProperty("localizedMessage")) {
                                properties._localizedMessage = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.LocalizedMessage.verify(message.localizedMessage);
                                    if (error)
                                        return "localizedMessage." + error;
                                }
                            }
                            if (message.quotaInfo != null && message.hasOwnProperty("quotaInfo")) {
                                properties._quotaInfo = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.QuotaExceededInfo.verify(message.quotaInfo);
                                    if (error)
                                        return "quotaInfo." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an ErrorDetails message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ErrorDetails
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ErrorDetails} ErrorDetails
                         */
                        ErrorDetails.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ErrorDetails)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ErrorDetails();
                            if (object.errorInfo != null) {
                                if (typeof object.errorInfo !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ErrorDetails.errorInfo: object expected");
                                message.errorInfo = $root.google.cloud.compute.v1.ErrorInfo.fromObject(object.errorInfo);
                            }
                            if (object.help != null) {
                                if (typeof object.help !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ErrorDetails.help: object expected");
                                message.help = $root.google.cloud.compute.v1.Help.fromObject(object.help);
                            }
                            if (object.localizedMessage != null) {
                                if (typeof object.localizedMessage !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ErrorDetails.localizedMessage: object expected");
                                message.localizedMessage = $root.google.cloud.compute.v1.LocalizedMessage.fromObject(object.localizedMessage);
                            }
                            if (object.quotaInfo != null) {
                                if (typeof object.quotaInfo !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ErrorDetails.quotaInfo: object expected");
                                message.quotaInfo = $root.google.cloud.compute.v1.QuotaExceededInfo.fromObject(object.quotaInfo);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ErrorDetails message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ErrorDetails
                         * @static
                         * @param {google.cloud.compute.v1.ErrorDetails} message ErrorDetails
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ErrorDetails.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.help != null && message.hasOwnProperty("help")) {
                                object.help = $root.google.cloud.compute.v1.Help.toObject(message.help, options);
                                if (options.oneofs)
                                    object._help = "help";
                            }
                            if (message.errorInfo != null && message.hasOwnProperty("errorInfo")) {
                                object.errorInfo = $root.google.cloud.compute.v1.ErrorInfo.toObject(message.errorInfo, options);
                                if (options.oneofs)
                                    object._errorInfo = "errorInfo";
                            }
                            if (message.quotaInfo != null && message.hasOwnProperty("quotaInfo")) {
                                object.quotaInfo = $root.google.cloud.compute.v1.QuotaExceededInfo.toObject(message.quotaInfo, options);
                                if (options.oneofs)
                                    object._quotaInfo = "quotaInfo";
                            }
                            if (message.localizedMessage != null && message.hasOwnProperty("localizedMessage")) {
                                object.localizedMessage = $root.google.cloud.compute.v1.LocalizedMessage.toObject(message.localizedMessage, options);
                                if (options.oneofs)
                                    object._localizedMessage = "localizedMessage";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ErrorDetails to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ErrorDetails
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ErrorDetails.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ErrorDetails
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ErrorDetails
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ErrorDetails.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ErrorDetails";
                        };
    
                        return ErrorDetails;
                    })();
    
                    v1.ErrorInfo = (function() {
    
                        /**
                         * Properties of an ErrorInfo.
                         * @memberof google.cloud.compute.v1
                         * @interface IErrorInfo
                         * @property {string|null} [domain] ErrorInfo domain
                         * @property {Object.<string,string>|null} [metadatas] ErrorInfo metadatas
                         * @property {string|null} [reason] ErrorInfo reason
                         */
    
                        /**
                         * Constructs a new ErrorInfo.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an ErrorInfo.
                         * @implements IErrorInfo
                         * @constructor
                         * @param {google.cloud.compute.v1.IErrorInfo=} [properties] Properties to set
                         */
                        function ErrorInfo(properties) {
                            this.metadatas = {};
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ErrorInfo domain.
                         * @member {string|null|undefined} domain
                         * @memberof google.cloud.compute.v1.ErrorInfo
                         * @instance
                         */
                        ErrorInfo.prototype.domain = null;
    
                        /**
                         * ErrorInfo metadatas.
                         * @member {Object.<string,string>} metadatas
                         * @memberof google.cloud.compute.v1.ErrorInfo
                         * @instance
                         */
                        ErrorInfo.prototype.metadatas = $util.emptyObject;
    
                        /**
                         * ErrorInfo reason.
                         * @member {string|null|undefined} reason
                         * @memberof google.cloud.compute.v1.ErrorInfo
                         * @instance
                         */
                        ErrorInfo.prototype.reason = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ErrorInfo _domain.
                         * @member {"domain"|undefined} _domain
                         * @memberof google.cloud.compute.v1.ErrorInfo
                         * @instance
                         */
                        Object.defineProperty(ErrorInfo.prototype, "_domain", {
                            get: $util.oneOfGetter($oneOfFields = ["domain"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ErrorInfo _reason.
                         * @member {"reason"|undefined} _reason
                         * @memberof google.cloud.compute.v1.ErrorInfo
                         * @instance
                         */
                        Object.defineProperty(ErrorInfo.prototype, "_reason", {
                            get: $util.oneOfGetter($oneOfFields = ["reason"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ErrorInfo instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ErrorInfo
                         * @static
                         * @param {google.cloud.compute.v1.IErrorInfo=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ErrorInfo} ErrorInfo instance
                         */
                        ErrorInfo.create = function create(properties) {
                            return new ErrorInfo(properties);
                        };
    
                        /**
                         * Encodes the specified ErrorInfo message. Does not implicitly {@link google.cloud.compute.v1.ErrorInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ErrorInfo
                         * @static
                         * @param {google.cloud.compute.v1.IErrorInfo} message ErrorInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ErrorInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.metadatas != null && Object.hasOwnProperty.call(message, "metadatas"))
                                for (var keys = Object.keys(message.metadatas), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 8514340, wireType 2 =*/68114722).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.metadatas[keys[i]]).ldelim();
                            if (message.reason != null && Object.hasOwnProperty.call(message, "reason"))
                                writer.uint32(/* id 138777156, wireType 2 =*/1110217250).string(message.reason);
                            if (message.domain != null && Object.hasOwnProperty.call(message, "domain"))
                                writer.uint32(/* id 284415172, wireType 2 =*/2275321378).string(message.domain);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ErrorInfo message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ErrorInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ErrorInfo
                         * @static
                         * @param {google.cloud.compute.v1.IErrorInfo} message ErrorInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ErrorInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ErrorInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ErrorInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ErrorInfo} ErrorInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ErrorInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ErrorInfo(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 284415172: {
                                        message.domain = reader.string();
                                        break;
                                    }
                                case 8514340: {
                                        if (message.metadatas === $util.emptyObject)
                                            message.metadatas = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.metadatas[key] = value;
                                        break;
                                    }
                                case 138777156: {
                                        message.reason = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ErrorInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ErrorInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ErrorInfo} ErrorInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ErrorInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ErrorInfo message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ErrorInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ErrorInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.domain != null && message.hasOwnProperty("domain")) {
                                properties._domain = 1;
                                if (!$util.isString(message.domain))
                                    return "domain: string expected";
                            }
                            if (message.metadatas != null && message.hasOwnProperty("metadatas")) {
                                if (!$util.isObject(message.metadatas))
                                    return "metadatas: object expected";
                                var key = Object.keys(message.metadatas);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.metadatas[key[i]]))
                                        return "metadatas: string{k:string} expected";
                            }
                            if (message.reason != null && message.hasOwnProperty("reason")) {
                                properties._reason = 1;
                                if (!$util.isString(message.reason))
                                    return "reason: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an ErrorInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ErrorInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ErrorInfo} ErrorInfo
                         */
                        ErrorInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ErrorInfo)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ErrorInfo();
                            if (object.domain != null)
                                message.domain = String(object.domain);
                            if (object.metadatas) {
                                if (typeof object.metadatas !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ErrorInfo.metadatas: object expected");
                                message.metadatas = {};
                                for (var keys = Object.keys(object.metadatas), i = 0; i < keys.length; ++i)
                                    message.metadatas[keys[i]] = String(object.metadatas[keys[i]]);
                            }
                            if (object.reason != null)
                                message.reason = String(object.reason);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ErrorInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ErrorInfo
                         * @static
                         * @param {google.cloud.compute.v1.ErrorInfo} message ErrorInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ErrorInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.objects || options.defaults)
                                object.metadatas = {};
                            var keys2;
                            if (message.metadatas && (keys2 = Object.keys(message.metadatas)).length) {
                                object.metadatas = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.metadatas[keys2[j]] = message.metadatas[keys2[j]];
                            }
                            if (message.reason != null && message.hasOwnProperty("reason")) {
                                object.reason = message.reason;
                                if (options.oneofs)
                                    object._reason = "reason";
                            }
                            if (message.domain != null && message.hasOwnProperty("domain")) {
                                object.domain = message.domain;
                                if (options.oneofs)
                                    object._domain = "domain";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ErrorInfo to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ErrorInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ErrorInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ErrorInfo
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ErrorInfo
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ErrorInfo.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ErrorInfo";
                        };
    
                        return ErrorInfo;
                    })();
    
                    v1.Errors = (function() {
    
                        /**
                         * Properties of an Errors.
                         * @memberof google.cloud.compute.v1
                         * @interface IErrors
                         * @property {string|null} [code] Errors code
                         * @property {Array.<google.cloud.compute.v1.IErrorDetails>|null} [errorDetails] Errors errorDetails
                         * @property {string|null} [location] Errors location
                         * @property {string|null} [message] Errors message
                         */
    
                        /**
                         * Constructs a new Errors.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an Errors.
                         * @implements IErrors
                         * @constructor
                         * @param {google.cloud.compute.v1.IErrors=} [properties] Properties to set
                         */
                        function Errors(properties) {
                            this.errorDetails = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Errors code.
                         * @member {string|null|undefined} code
                         * @memberof google.cloud.compute.v1.Errors
                         * @instance
                         */
                        Errors.prototype.code = null;
    
                        /**
                         * Errors errorDetails.
                         * @member {Array.<google.cloud.compute.v1.IErrorDetails>} errorDetails
                         * @memberof google.cloud.compute.v1.Errors
                         * @instance
                         */
                        Errors.prototype.errorDetails = $util.emptyArray;
    
                        /**
                         * Errors location.
                         * @member {string|null|undefined} location
                         * @memberof google.cloud.compute.v1.Errors
                         * @instance
                         */
                        Errors.prototype.location = null;
    
                        /**
                         * Errors message.
                         * @member {string|null|undefined} message
                         * @memberof google.cloud.compute.v1.Errors
                         * @instance
                         */
                        Errors.prototype.message = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Errors _code.
                         * @member {"code"|undefined} _code
                         * @memberof google.cloud.compute.v1.Errors
                         * @instance
                         */
                        Object.defineProperty(Errors.prototype, "_code", {
                            get: $util.oneOfGetter($oneOfFields = ["code"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Errors _location.
                         * @member {"location"|undefined} _location
                         * @memberof google.cloud.compute.v1.Errors
                         * @instance
                         */
                        Object.defineProperty(Errors.prototype, "_location", {
                            get: $util.oneOfGetter($oneOfFields = ["location"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Errors _message.
                         * @member {"message"|undefined} _message
                         * @memberof google.cloud.compute.v1.Errors
                         * @instance
                         */
                        Object.defineProperty(Errors.prototype, "_message", {
                            get: $util.oneOfGetter($oneOfFields = ["message"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Errors instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Errors
                         * @static
                         * @param {google.cloud.compute.v1.IErrors=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Errors} Errors instance
                         */
                        Errors.create = function create(properties) {
                            return new Errors(properties);
                        };
    
                        /**
                         * Encodes the specified Errors message. Does not implicitly {@link google.cloud.compute.v1.Errors.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Errors
                         * @static
                         * @param {google.cloud.compute.v1.IErrors} message Errors message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Errors.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.code != null && Object.hasOwnProperty.call(message, "code"))
                                writer.uint32(/* id 3059181, wireType 2 =*/24473450).string(message.code);
                            if (message.errorDetails != null && message.errorDetails.length)
                                for (var i = 0; i < message.errorDetails.length; ++i)
                                    $root.google.cloud.compute.v1.ErrorDetails.encode(message.errorDetails[i], writer.uint32(/* id 274653963, wireType 2 =*/2197231706).fork()).ldelim();
                            if (message.location != null && Object.hasOwnProperty.call(message, "location"))
                                writer.uint32(/* id 290430901, wireType 2 =*/2323447210).string(message.location);
                            if (message.message != null && Object.hasOwnProperty.call(message, "message"))
                                writer.uint32(/* id 418054151, wireType 2 =*/3344433210).string(message.message);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Errors message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Errors.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Errors
                         * @static
                         * @param {google.cloud.compute.v1.IErrors} message Errors message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Errors.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Errors message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Errors
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Errors} Errors
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Errors.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Errors();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3059181: {
                                        message.code = reader.string();
                                        break;
                                    }
                                case 274653963: {
                                        if (!(message.errorDetails && message.errorDetails.length))
                                            message.errorDetails = [];
                                        message.errorDetails.push($root.google.cloud.compute.v1.ErrorDetails.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 290430901: {
                                        message.location = reader.string();
                                        break;
                                    }
                                case 418054151: {
                                        message.message = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Errors message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Errors
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Errors} Errors
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Errors.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Errors message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Errors
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Errors.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.code != null && message.hasOwnProperty("code")) {
                                properties._code = 1;
                                if (!$util.isString(message.code))
                                    return "code: string expected";
                            }
                            if (message.errorDetails != null && message.hasOwnProperty("errorDetails")) {
                                if (!Array.isArray(message.errorDetails))
                                    return "errorDetails: array expected";
                                for (var i = 0; i < message.errorDetails.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ErrorDetails.verify(message.errorDetails[i]);
                                    if (error)
                                        return "errorDetails." + error;
                                }
                            }
                            if (message.location != null && message.hasOwnProperty("location")) {
                                properties._location = 1;
                                if (!$util.isString(message.location))
                                    return "location: string expected";
                            }
                            if (message.message != null && message.hasOwnProperty("message")) {
                                properties._message = 1;
                                if (!$util.isString(message.message))
                                    return "message: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an Errors message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Errors
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Errors} Errors
                         */
                        Errors.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Errors)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Errors();
                            if (object.code != null)
                                message.code = String(object.code);
                            if (object.errorDetails) {
                                if (!Array.isArray(object.errorDetails))
                                    throw TypeError(".google.cloud.compute.v1.Errors.errorDetails: array expected");
                                message.errorDetails = [];
                                for (var i = 0; i < object.errorDetails.length; ++i) {
                                    if (typeof object.errorDetails[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Errors.errorDetails: object expected");
                                    message.errorDetails[i] = $root.google.cloud.compute.v1.ErrorDetails.fromObject(object.errorDetails[i]);
                                }
                            }
                            if (object.location != null)
                                message.location = String(object.location);
                            if (object.message != null)
                                message.message = String(object.message);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Errors message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Errors
                         * @static
                         * @param {google.cloud.compute.v1.Errors} message Errors
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Errors.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.errorDetails = [];
                            if (message.code != null && message.hasOwnProperty("code")) {
                                object.code = message.code;
                                if (options.oneofs)
                                    object._code = "code";
                            }
                            if (message.errorDetails && message.errorDetails.length) {
                                object.errorDetails = [];
                                for (var j = 0; j < message.errorDetails.length; ++j)
                                    object.errorDetails[j] = $root.google.cloud.compute.v1.ErrorDetails.toObject(message.errorDetails[j], options);
                            }
                            if (message.location != null && message.hasOwnProperty("location")) {
                                object.location = message.location;
                                if (options.oneofs)
                                    object._location = "location";
                            }
                            if (message.message != null && message.hasOwnProperty("message")) {
                                object.message = message.message;
                                if (options.oneofs)
                                    object._message = "message";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Errors to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Errors
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Errors.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Errors
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Errors
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Errors.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Errors";
                        };
    
                        return Errors;
                    })();
    
                    v1.ExchangedPeeringRoute = (function() {
    
                        /**
                         * Properties of an ExchangedPeeringRoute.
                         * @memberof google.cloud.compute.v1
                         * @interface IExchangedPeeringRoute
                         * @property {string|null} [destRange] ExchangedPeeringRoute destRange
                         * @property {boolean|null} [imported] ExchangedPeeringRoute imported
                         * @property {string|null} [nextHopRegion] ExchangedPeeringRoute nextHopRegion
                         * @property {number|null} [priority] ExchangedPeeringRoute priority
                         * @property {string|null} [type] ExchangedPeeringRoute type
                         */
    
                        /**
                         * Constructs a new ExchangedPeeringRoute.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an ExchangedPeeringRoute.
                         * @implements IExchangedPeeringRoute
                         * @constructor
                         * @param {google.cloud.compute.v1.IExchangedPeeringRoute=} [properties] Properties to set
                         */
                        function ExchangedPeeringRoute(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ExchangedPeeringRoute destRange.
                         * @member {string|null|undefined} destRange
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoute
                         * @instance
                         */
                        ExchangedPeeringRoute.prototype.destRange = null;
    
                        /**
                         * ExchangedPeeringRoute imported.
                         * @member {boolean|null|undefined} imported
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoute
                         * @instance
                         */
                        ExchangedPeeringRoute.prototype.imported = null;
    
                        /**
                         * ExchangedPeeringRoute nextHopRegion.
                         * @member {string|null|undefined} nextHopRegion
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoute
                         * @instance
                         */
                        ExchangedPeeringRoute.prototype.nextHopRegion = null;
    
                        /**
                         * ExchangedPeeringRoute priority.
                         * @member {number|null|undefined} priority
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoute
                         * @instance
                         */
                        ExchangedPeeringRoute.prototype.priority = null;
    
                        /**
                         * ExchangedPeeringRoute type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoute
                         * @instance
                         */
                        ExchangedPeeringRoute.prototype.type = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ExchangedPeeringRoute _destRange.
                         * @member {"destRange"|undefined} _destRange
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoute
                         * @instance
                         */
                        Object.defineProperty(ExchangedPeeringRoute.prototype, "_destRange", {
                            get: $util.oneOfGetter($oneOfFields = ["destRange"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExchangedPeeringRoute _imported.
                         * @member {"imported"|undefined} _imported
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoute
                         * @instance
                         */
                        Object.defineProperty(ExchangedPeeringRoute.prototype, "_imported", {
                            get: $util.oneOfGetter($oneOfFields = ["imported"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExchangedPeeringRoute _nextHopRegion.
                         * @member {"nextHopRegion"|undefined} _nextHopRegion
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoute
                         * @instance
                         */
                        Object.defineProperty(ExchangedPeeringRoute.prototype, "_nextHopRegion", {
                            get: $util.oneOfGetter($oneOfFields = ["nextHopRegion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExchangedPeeringRoute _priority.
                         * @member {"priority"|undefined} _priority
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoute
                         * @instance
                         */
                        Object.defineProperty(ExchangedPeeringRoute.prototype, "_priority", {
                            get: $util.oneOfGetter($oneOfFields = ["priority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExchangedPeeringRoute _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoute
                         * @instance
                         */
                        Object.defineProperty(ExchangedPeeringRoute.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ExchangedPeeringRoute instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoute
                         * @static
                         * @param {google.cloud.compute.v1.IExchangedPeeringRoute=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ExchangedPeeringRoute} ExchangedPeeringRoute instance
                         */
                        ExchangedPeeringRoute.create = function create(properties) {
                            return new ExchangedPeeringRoute(properties);
                        };
    
                        /**
                         * Encodes the specified ExchangedPeeringRoute message. Does not implicitly {@link google.cloud.compute.v1.ExchangedPeeringRoute.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoute
                         * @static
                         * @param {google.cloud.compute.v1.IExchangedPeeringRoute} message ExchangedPeeringRoute message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExchangedPeeringRoute.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            if (message.imported != null && Object.hasOwnProperty.call(message, "imported"))
                                writer.uint32(/* id 114502404, wireType 0 =*/916019232).bool(message.imported);
                            if (message.nextHopRegion != null && Object.hasOwnProperty.call(message, "nextHopRegion"))
                                writer.uint32(/* id 122577014, wireType 2 =*/980616114).string(message.nextHopRegion);
                            if (message.destRange != null && Object.hasOwnProperty.call(message, "destRange"))
                                writer.uint32(/* id 381327712, wireType 2 =*/3050621698).string(message.destRange);
                            if (message.priority != null && Object.hasOwnProperty.call(message, "priority"))
                                writer.uint32(/* id 445151652, wireType 0 =*/3561213216).uint32(message.priority);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ExchangedPeeringRoute message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ExchangedPeeringRoute.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoute
                         * @static
                         * @param {google.cloud.compute.v1.IExchangedPeeringRoute} message ExchangedPeeringRoute message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExchangedPeeringRoute.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ExchangedPeeringRoute message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoute
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ExchangedPeeringRoute} ExchangedPeeringRoute
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExchangedPeeringRoute.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ExchangedPeeringRoute();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 381327712: {
                                        message.destRange = reader.string();
                                        break;
                                    }
                                case 114502404: {
                                        message.imported = reader.bool();
                                        break;
                                    }
                                case 122577014: {
                                        message.nextHopRegion = reader.string();
                                        break;
                                    }
                                case 445151652: {
                                        message.priority = reader.uint32();
                                        break;
                                    }
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ExchangedPeeringRoute message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoute
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ExchangedPeeringRoute} ExchangedPeeringRoute
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExchangedPeeringRoute.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ExchangedPeeringRoute message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoute
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExchangedPeeringRoute.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.destRange != null && message.hasOwnProperty("destRange")) {
                                properties._destRange = 1;
                                if (!$util.isString(message.destRange))
                                    return "destRange: string expected";
                            }
                            if (message.imported != null && message.hasOwnProperty("imported")) {
                                properties._imported = 1;
                                if (typeof message.imported !== "boolean")
                                    return "imported: boolean expected";
                            }
                            if (message.nextHopRegion != null && message.hasOwnProperty("nextHopRegion")) {
                                properties._nextHopRegion = 1;
                                if (!$util.isString(message.nextHopRegion))
                                    return "nextHopRegion: string expected";
                            }
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                properties._priority = 1;
                                if (!$util.isInteger(message.priority))
                                    return "priority: integer expected";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an ExchangedPeeringRoute message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoute
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ExchangedPeeringRoute} ExchangedPeeringRoute
                         */
                        ExchangedPeeringRoute.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ExchangedPeeringRoute)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ExchangedPeeringRoute();
                            if (object.destRange != null)
                                message.destRange = String(object.destRange);
                            if (object.imported != null)
                                message.imported = Boolean(object.imported);
                            if (object.nextHopRegion != null)
                                message.nextHopRegion = String(object.nextHopRegion);
                            if (object.priority != null)
                                message.priority = object.priority >>> 0;
                            if (object.type != null)
                                message.type = String(object.type);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ExchangedPeeringRoute message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoute
                         * @static
                         * @param {google.cloud.compute.v1.ExchangedPeeringRoute} message ExchangedPeeringRoute
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExchangedPeeringRoute.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            if (message.imported != null && message.hasOwnProperty("imported")) {
                                object.imported = message.imported;
                                if (options.oneofs)
                                    object._imported = "imported";
                            }
                            if (message.nextHopRegion != null && message.hasOwnProperty("nextHopRegion")) {
                                object.nextHopRegion = message.nextHopRegion;
                                if (options.oneofs)
                                    object._nextHopRegion = "nextHopRegion";
                            }
                            if (message.destRange != null && message.hasOwnProperty("destRange")) {
                                object.destRange = message.destRange;
                                if (options.oneofs)
                                    object._destRange = "destRange";
                            }
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                object.priority = message.priority;
                                if (options.oneofs)
                                    object._priority = "priority";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ExchangedPeeringRoute to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoute
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExchangedPeeringRoute.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ExchangedPeeringRoute
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoute
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ExchangedPeeringRoute.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ExchangedPeeringRoute";
                        };
    
                        /**
                         * Type enum.
                         * @name google.cloud.compute.v1.ExchangedPeeringRoute.Type
                         * @enum {number}
                         * @property {number} UNDEFINED_TYPE=0 UNDEFINED_TYPE value
                         * @property {number} DYNAMIC_PEERING_ROUTE=469794858 DYNAMIC_PEERING_ROUTE value
                         * @property {number} STATIC_PEERING_ROUTE=473407545 STATIC_PEERING_ROUTE value
                         * @property {number} SUBNET_PEERING_ROUTE=465782504 SUBNET_PEERING_ROUTE value
                         */
                        ExchangedPeeringRoute.Type = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TYPE"] = 0;
                            values[valuesById[469794858] = "DYNAMIC_PEERING_ROUTE"] = 469794858;
                            values[valuesById[473407545] = "STATIC_PEERING_ROUTE"] = 473407545;
                            values[valuesById[465782504] = "SUBNET_PEERING_ROUTE"] = 465782504;
                            return values;
                        })();
    
                        return ExchangedPeeringRoute;
                    })();
    
                    v1.ExchangedPeeringRoutesList = (function() {
    
                        /**
                         * Properties of an ExchangedPeeringRoutesList.
                         * @memberof google.cloud.compute.v1
                         * @interface IExchangedPeeringRoutesList
                         * @property {string|null} [id] ExchangedPeeringRoutesList id
                         * @property {Array.<google.cloud.compute.v1.IExchangedPeeringRoute>|null} [items] ExchangedPeeringRoutesList items
                         * @property {string|null} [kind] ExchangedPeeringRoutesList kind
                         * @property {string|null} [nextPageToken] ExchangedPeeringRoutesList nextPageToken
                         * @property {string|null} [selfLink] ExchangedPeeringRoutesList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] ExchangedPeeringRoutesList warning
                         */
    
                        /**
                         * Constructs a new ExchangedPeeringRoutesList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an ExchangedPeeringRoutesList.
                         * @implements IExchangedPeeringRoutesList
                         * @constructor
                         * @param {google.cloud.compute.v1.IExchangedPeeringRoutesList=} [properties] Properties to set
                         */
                        function ExchangedPeeringRoutesList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ExchangedPeeringRoutesList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @instance
                         */
                        ExchangedPeeringRoutesList.prototype.id = null;
    
                        /**
                         * ExchangedPeeringRoutesList items.
                         * @member {Array.<google.cloud.compute.v1.IExchangedPeeringRoute>} items
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @instance
                         */
                        ExchangedPeeringRoutesList.prototype.items = $util.emptyArray;
    
                        /**
                         * ExchangedPeeringRoutesList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @instance
                         */
                        ExchangedPeeringRoutesList.prototype.kind = null;
    
                        /**
                         * ExchangedPeeringRoutesList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @instance
                         */
                        ExchangedPeeringRoutesList.prototype.nextPageToken = null;
    
                        /**
                         * ExchangedPeeringRoutesList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @instance
                         */
                        ExchangedPeeringRoutesList.prototype.selfLink = null;
    
                        /**
                         * ExchangedPeeringRoutesList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @instance
                         */
                        ExchangedPeeringRoutesList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ExchangedPeeringRoutesList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @instance
                         */
                        Object.defineProperty(ExchangedPeeringRoutesList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExchangedPeeringRoutesList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @instance
                         */
                        Object.defineProperty(ExchangedPeeringRoutesList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExchangedPeeringRoutesList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @instance
                         */
                        Object.defineProperty(ExchangedPeeringRoutesList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExchangedPeeringRoutesList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @instance
                         */
                        Object.defineProperty(ExchangedPeeringRoutesList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExchangedPeeringRoutesList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @instance
                         */
                        Object.defineProperty(ExchangedPeeringRoutesList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ExchangedPeeringRoutesList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @static
                         * @param {google.cloud.compute.v1.IExchangedPeeringRoutesList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ExchangedPeeringRoutesList} ExchangedPeeringRoutesList instance
                         */
                        ExchangedPeeringRoutesList.create = function create(properties) {
                            return new ExchangedPeeringRoutesList(properties);
                        };
    
                        /**
                         * Encodes the specified ExchangedPeeringRoutesList message. Does not implicitly {@link google.cloud.compute.v1.ExchangedPeeringRoutesList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @static
                         * @param {google.cloud.compute.v1.IExchangedPeeringRoutesList} message ExchangedPeeringRoutesList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExchangedPeeringRoutesList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.ExchangedPeeringRoute.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ExchangedPeeringRoutesList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ExchangedPeeringRoutesList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @static
                         * @param {google.cloud.compute.v1.IExchangedPeeringRoutesList} message ExchangedPeeringRoutesList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExchangedPeeringRoutesList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ExchangedPeeringRoutesList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ExchangedPeeringRoutesList} ExchangedPeeringRoutesList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExchangedPeeringRoutesList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ExchangedPeeringRoutesList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.ExchangedPeeringRoute.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ExchangedPeeringRoutesList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ExchangedPeeringRoutesList} ExchangedPeeringRoutesList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExchangedPeeringRoutesList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ExchangedPeeringRoutesList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExchangedPeeringRoutesList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ExchangedPeeringRoute.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an ExchangedPeeringRoutesList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ExchangedPeeringRoutesList} ExchangedPeeringRoutesList
                         */
                        ExchangedPeeringRoutesList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ExchangedPeeringRoutesList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ExchangedPeeringRoutesList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.ExchangedPeeringRoutesList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ExchangedPeeringRoutesList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.ExchangedPeeringRoute.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ExchangedPeeringRoutesList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ExchangedPeeringRoutesList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @static
                         * @param {google.cloud.compute.v1.ExchangedPeeringRoutesList} message ExchangedPeeringRoutesList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExchangedPeeringRoutesList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.ExchangedPeeringRoute.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ExchangedPeeringRoutesList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExchangedPeeringRoutesList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ExchangedPeeringRoutesList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ExchangedPeeringRoutesList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ExchangedPeeringRoutesList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ExchangedPeeringRoutesList";
                        };
    
                        return ExchangedPeeringRoutesList;
                    })();
    
                    v1.ExpandIpCidrRangeSubnetworkRequest = (function() {
    
                        /**
                         * Properties of an ExpandIpCidrRangeSubnetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IExpandIpCidrRangeSubnetworkRequest
                         * @property {string|null} [project] ExpandIpCidrRangeSubnetworkRequest project
                         * @property {string|null} [region] ExpandIpCidrRangeSubnetworkRequest region
                         * @property {string|null} [requestId] ExpandIpCidrRangeSubnetworkRequest requestId
                         * @property {string|null} [subnetwork] ExpandIpCidrRangeSubnetworkRequest subnetwork
                         * @property {google.cloud.compute.v1.ISubnetworksExpandIpCidrRangeRequest|null} [subnetworksExpandIpCidrRangeRequestResource] ExpandIpCidrRangeSubnetworkRequest subnetworksExpandIpCidrRangeRequestResource
                         */
    
                        /**
                         * Constructs a new ExpandIpCidrRangeSubnetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an ExpandIpCidrRangeSubnetworkRequest.
                         * @implements IExpandIpCidrRangeSubnetworkRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IExpandIpCidrRangeSubnetworkRequest=} [properties] Properties to set
                         */
                        function ExpandIpCidrRangeSubnetworkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ExpandIpCidrRangeSubnetworkRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest
                         * @instance
                         */
                        ExpandIpCidrRangeSubnetworkRequest.prototype.project = "";
    
                        /**
                         * ExpandIpCidrRangeSubnetworkRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest
                         * @instance
                         */
                        ExpandIpCidrRangeSubnetworkRequest.prototype.region = "";
    
                        /**
                         * ExpandIpCidrRangeSubnetworkRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest
                         * @instance
                         */
                        ExpandIpCidrRangeSubnetworkRequest.prototype.requestId = null;
    
                        /**
                         * ExpandIpCidrRangeSubnetworkRequest subnetwork.
                         * @member {string} subnetwork
                         * @memberof google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest
                         * @instance
                         */
                        ExpandIpCidrRangeSubnetworkRequest.prototype.subnetwork = "";
    
                        /**
                         * ExpandIpCidrRangeSubnetworkRequest subnetworksExpandIpCidrRangeRequestResource.
                         * @member {google.cloud.compute.v1.ISubnetworksExpandIpCidrRangeRequest|null|undefined} subnetworksExpandIpCidrRangeRequestResource
                         * @memberof google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest
                         * @instance
                         */
                        ExpandIpCidrRangeSubnetworkRequest.prototype.subnetworksExpandIpCidrRangeRequestResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ExpandIpCidrRangeSubnetworkRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest
                         * @instance
                         */
                        Object.defineProperty(ExpandIpCidrRangeSubnetworkRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ExpandIpCidrRangeSubnetworkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IExpandIpCidrRangeSubnetworkRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest} ExpandIpCidrRangeSubnetworkRequest instance
                         */
                        ExpandIpCidrRangeSubnetworkRequest.create = function create(properties) {
                            return new ExpandIpCidrRangeSubnetworkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ExpandIpCidrRangeSubnetworkRequest message. Does not implicitly {@link google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IExpandIpCidrRangeSubnetworkRequest} message ExpandIpCidrRangeSubnetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExpandIpCidrRangeSubnetworkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.subnetwork != null && Object.hasOwnProperty.call(message, "subnetwork"))
                                writer.uint32(/* id 307827694, wireType 2 =*/2462621554).string(message.subnetwork);
                            if (message.subnetworksExpandIpCidrRangeRequestResource != null && Object.hasOwnProperty.call(message, "subnetworksExpandIpCidrRangeRequestResource"))
                                $root.google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest.encode(message.subnetworksExpandIpCidrRangeRequestResource, writer.uint32(/* id 477014110, wireType 2 =*/3816112882).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ExpandIpCidrRangeSubnetworkRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IExpandIpCidrRangeSubnetworkRequest} message ExpandIpCidrRangeSubnetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExpandIpCidrRangeSubnetworkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ExpandIpCidrRangeSubnetworkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest} ExpandIpCidrRangeSubnetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExpandIpCidrRangeSubnetworkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 307827694: {
                                        message.subnetwork = reader.string();
                                        break;
                                    }
                                case 477014110: {
                                        message.subnetworksExpandIpCidrRangeRequestResource = $root.google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ExpandIpCidrRangeSubnetworkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest} ExpandIpCidrRangeSubnetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExpandIpCidrRangeSubnetworkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ExpandIpCidrRangeSubnetworkRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExpandIpCidrRangeSubnetworkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork"))
                                if (!$util.isString(message.subnetwork))
                                    return "subnetwork: string expected";
                            if (message.subnetworksExpandIpCidrRangeRequestResource != null && message.hasOwnProperty("subnetworksExpandIpCidrRangeRequestResource")) {
                                var error = $root.google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest.verify(message.subnetworksExpandIpCidrRangeRequestResource);
                                if (error)
                                    return "subnetworksExpandIpCidrRangeRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an ExpandIpCidrRangeSubnetworkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest} ExpandIpCidrRangeSubnetworkRequest
                         */
                        ExpandIpCidrRangeSubnetworkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.subnetwork != null)
                                message.subnetwork = String(object.subnetwork);
                            if (object.subnetworksExpandIpCidrRangeRequestResource != null) {
                                if (typeof object.subnetworksExpandIpCidrRangeRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest.subnetworksExpandIpCidrRangeRequestResource: object expected");
                                message.subnetworksExpandIpCidrRangeRequestResource = $root.google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest.fromObject(object.subnetworksExpandIpCidrRangeRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ExpandIpCidrRangeSubnetworkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest} message ExpandIpCidrRangeSubnetworkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExpandIpCidrRangeSubnetworkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.subnetwork = "";
                                object.subnetworksExpandIpCidrRangeRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork"))
                                object.subnetwork = message.subnetwork;
                            if (message.subnetworksExpandIpCidrRangeRequestResource != null && message.hasOwnProperty("subnetworksExpandIpCidrRangeRequestResource"))
                                object.subnetworksExpandIpCidrRangeRequestResource = $root.google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest.toObject(message.subnetworksExpandIpCidrRangeRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this ExpandIpCidrRangeSubnetworkRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExpandIpCidrRangeSubnetworkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ExpandIpCidrRangeSubnetworkRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ExpandIpCidrRangeSubnetworkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest";
                        };
    
                        return ExpandIpCidrRangeSubnetworkRequest;
                    })();
    
                    v1.Expr = (function() {
    
                        /**
                         * Properties of an Expr.
                         * @memberof google.cloud.compute.v1
                         * @interface IExpr
                         * @property {string|null} [description] Expr description
                         * @property {string|null} [expression] Expr expression
                         * @property {string|null} [location] Expr location
                         * @property {string|null} [title] Expr title
                         */
    
                        /**
                         * Constructs a new Expr.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an Expr.
                         * @implements IExpr
                         * @constructor
                         * @param {google.cloud.compute.v1.IExpr=} [properties] Properties to set
                         */
                        function Expr(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Expr description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Expr
                         * @instance
                         */
                        Expr.prototype.description = null;
    
                        /**
                         * Expr expression.
                         * @member {string|null|undefined} expression
                         * @memberof google.cloud.compute.v1.Expr
                         * @instance
                         */
                        Expr.prototype.expression = null;
    
                        /**
                         * Expr location.
                         * @member {string|null|undefined} location
                         * @memberof google.cloud.compute.v1.Expr
                         * @instance
                         */
                        Expr.prototype.location = null;
    
                        /**
                         * Expr title.
                         * @member {string|null|undefined} title
                         * @memberof google.cloud.compute.v1.Expr
                         * @instance
                         */
                        Expr.prototype.title = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Expr _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Expr
                         * @instance
                         */
                        Object.defineProperty(Expr.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Expr _expression.
                         * @member {"expression"|undefined} _expression
                         * @memberof google.cloud.compute.v1.Expr
                         * @instance
                         */
                        Object.defineProperty(Expr.prototype, "_expression", {
                            get: $util.oneOfGetter($oneOfFields = ["expression"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Expr _location.
                         * @member {"location"|undefined} _location
                         * @memberof google.cloud.compute.v1.Expr
                         * @instance
                         */
                        Object.defineProperty(Expr.prototype, "_location", {
                            get: $util.oneOfGetter($oneOfFields = ["location"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Expr _title.
                         * @member {"title"|undefined} _title
                         * @memberof google.cloud.compute.v1.Expr
                         * @instance
                         */
                        Object.defineProperty(Expr.prototype, "_title", {
                            get: $util.oneOfGetter($oneOfFields = ["title"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Expr instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Expr
                         * @static
                         * @param {google.cloud.compute.v1.IExpr=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Expr} Expr instance
                         */
                        Expr.create = function create(properties) {
                            return new Expr(properties);
                        };
    
                        /**
                         * Encodes the specified Expr message. Does not implicitly {@link google.cloud.compute.v1.Expr.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Expr
                         * @static
                         * @param {google.cloud.compute.v1.IExpr} message Expr message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Expr.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.title != null && Object.hasOwnProperty.call(message, "title"))
                                writer.uint32(/* id 110371416, wireType 2 =*/882971330).string(message.title);
                            if (message.location != null && Object.hasOwnProperty.call(message, "location"))
                                writer.uint32(/* id 290430901, wireType 2 =*/2323447210).string(message.location);
                            if (message.expression != null && Object.hasOwnProperty.call(message, "expression"))
                                writer.uint32(/* id 352031384, wireType 2 =*/2816251074).string(message.expression);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Expr message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Expr.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Expr
                         * @static
                         * @param {google.cloud.compute.v1.IExpr} message Expr message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Expr.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Expr message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Expr
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Expr} Expr
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Expr.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Expr();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 352031384: {
                                        message.expression = reader.string();
                                        break;
                                    }
                                case 290430901: {
                                        message.location = reader.string();
                                        break;
                                    }
                                case 110371416: {
                                        message.title = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Expr message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Expr
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Expr} Expr
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Expr.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Expr message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Expr
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Expr.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.expression != null && message.hasOwnProperty("expression")) {
                                properties._expression = 1;
                                if (!$util.isString(message.expression))
                                    return "expression: string expected";
                            }
                            if (message.location != null && message.hasOwnProperty("location")) {
                                properties._location = 1;
                                if (!$util.isString(message.location))
                                    return "location: string expected";
                            }
                            if (message.title != null && message.hasOwnProperty("title")) {
                                properties._title = 1;
                                if (!$util.isString(message.title))
                                    return "title: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an Expr message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Expr
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Expr} Expr
                         */
                        Expr.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Expr)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Expr();
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.expression != null)
                                message.expression = String(object.expression);
                            if (object.location != null)
                                message.location = String(object.location);
                            if (object.title != null)
                                message.title = String(object.title);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Expr message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Expr
                         * @static
                         * @param {google.cloud.compute.v1.Expr} message Expr
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Expr.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.title != null && message.hasOwnProperty("title")) {
                                object.title = message.title;
                                if (options.oneofs)
                                    object._title = "title";
                            }
                            if (message.location != null && message.hasOwnProperty("location")) {
                                object.location = message.location;
                                if (options.oneofs)
                                    object._location = "location";
                            }
                            if (message.expression != null && message.hasOwnProperty("expression")) {
                                object.expression = message.expression;
                                if (options.oneofs)
                                    object._expression = "expression";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Expr to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Expr
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Expr.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Expr
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Expr
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Expr.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Expr";
                        };
    
                        return Expr;
                    })();
    
                    v1.ExternalVpnGateway = (function() {
    
                        /**
                         * Properties of an ExternalVpnGateway.
                         * @memberof google.cloud.compute.v1
                         * @interface IExternalVpnGateway
                         * @property {string|null} [creationTimestamp] ExternalVpnGateway creationTimestamp
                         * @property {string|null} [description] ExternalVpnGateway description
                         * @property {number|Long|null} [id] ExternalVpnGateway id
                         * @property {Array.<google.cloud.compute.v1.IExternalVpnGatewayInterface>|null} [interfaces] ExternalVpnGateway interfaces
                         * @property {string|null} [kind] ExternalVpnGateway kind
                         * @property {string|null} [labelFingerprint] ExternalVpnGateway labelFingerprint
                         * @property {Object.<string,string>|null} [labels] ExternalVpnGateway labels
                         * @property {string|null} [name] ExternalVpnGateway name
                         * @property {string|null} [redundancyType] ExternalVpnGateway redundancyType
                         * @property {string|null} [selfLink] ExternalVpnGateway selfLink
                         */
    
                        /**
                         * Constructs a new ExternalVpnGateway.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an ExternalVpnGateway.
                         * @implements IExternalVpnGateway
                         * @constructor
                         * @param {google.cloud.compute.v1.IExternalVpnGateway=} [properties] Properties to set
                         */
                        function ExternalVpnGateway(properties) {
                            this.interfaces = [];
                            this.labels = {};
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ExternalVpnGateway creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @instance
                         */
                        ExternalVpnGateway.prototype.creationTimestamp = null;
    
                        /**
                         * ExternalVpnGateway description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @instance
                         */
                        ExternalVpnGateway.prototype.description = null;
    
                        /**
                         * ExternalVpnGateway id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @instance
                         */
                        ExternalVpnGateway.prototype.id = null;
    
                        /**
                         * ExternalVpnGateway interfaces.
                         * @member {Array.<google.cloud.compute.v1.IExternalVpnGatewayInterface>} interfaces
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @instance
                         */
                        ExternalVpnGateway.prototype.interfaces = $util.emptyArray;
    
                        /**
                         * ExternalVpnGateway kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @instance
                         */
                        ExternalVpnGateway.prototype.kind = null;
    
                        /**
                         * ExternalVpnGateway labelFingerprint.
                         * @member {string|null|undefined} labelFingerprint
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @instance
                         */
                        ExternalVpnGateway.prototype.labelFingerprint = null;
    
                        /**
                         * ExternalVpnGateway labels.
                         * @member {Object.<string,string>} labels
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @instance
                         */
                        ExternalVpnGateway.prototype.labels = $util.emptyObject;
    
                        /**
                         * ExternalVpnGateway name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @instance
                         */
                        ExternalVpnGateway.prototype.name = null;
    
                        /**
                         * ExternalVpnGateway redundancyType.
                         * @member {string|null|undefined} redundancyType
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @instance
                         */
                        ExternalVpnGateway.prototype.redundancyType = null;
    
                        /**
                         * ExternalVpnGateway selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @instance
                         */
                        ExternalVpnGateway.prototype.selfLink = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ExternalVpnGateway _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @instance
                         */
                        Object.defineProperty(ExternalVpnGateway.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExternalVpnGateway _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @instance
                         */
                        Object.defineProperty(ExternalVpnGateway.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExternalVpnGateway _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @instance
                         */
                        Object.defineProperty(ExternalVpnGateway.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExternalVpnGateway _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @instance
                         */
                        Object.defineProperty(ExternalVpnGateway.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExternalVpnGateway _labelFingerprint.
                         * @member {"labelFingerprint"|undefined} _labelFingerprint
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @instance
                         */
                        Object.defineProperty(ExternalVpnGateway.prototype, "_labelFingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["labelFingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExternalVpnGateway _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @instance
                         */
                        Object.defineProperty(ExternalVpnGateway.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExternalVpnGateway _redundancyType.
                         * @member {"redundancyType"|undefined} _redundancyType
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @instance
                         */
                        Object.defineProperty(ExternalVpnGateway.prototype, "_redundancyType", {
                            get: $util.oneOfGetter($oneOfFields = ["redundancyType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExternalVpnGateway _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @instance
                         */
                        Object.defineProperty(ExternalVpnGateway.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ExternalVpnGateway instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @static
                         * @param {google.cloud.compute.v1.IExternalVpnGateway=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ExternalVpnGateway} ExternalVpnGateway instance
                         */
                        ExternalVpnGateway.create = function create(properties) {
                            return new ExternalVpnGateway(properties);
                        };
    
                        /**
                         * Encodes the specified ExternalVpnGateway message. Does not implicitly {@link google.cloud.compute.v1.ExternalVpnGateway.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @static
                         * @param {google.cloud.compute.v1.IExternalVpnGateway} message ExternalVpnGateway message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExternalVpnGateway.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.interfaces != null && message.interfaces.length)
                                for (var i = 0; i < message.interfaces.length; ++i)
                                    $root.google.cloud.compute.v1.ExternalVpnGatewayInterface.encode(message.interfaces[i], writer.uint32(/* id 12073562, wireType 2 =*/96588498).fork()).ldelim();
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.labelFingerprint != null && Object.hasOwnProperty.call(message, "labelFingerprint"))
                                writer.uint32(/* id 178124825, wireType 2 =*/1424998602).string(message.labelFingerprint);
                            if (message.redundancyType != null && Object.hasOwnProperty.call(message, "redundancyType"))
                                writer.uint32(/* id 271443740, wireType 2 =*/2171549922).string(message.redundancyType);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.labels != null && Object.hasOwnProperty.call(message, "labels"))
                                for (var keys = Object.keys(message.labels), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 500195327, wireType 2 =*/4001562618).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.labels[keys[i]]).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ExternalVpnGateway message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ExternalVpnGateway.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @static
                         * @param {google.cloud.compute.v1.IExternalVpnGateway} message ExternalVpnGateway message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExternalVpnGateway.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ExternalVpnGateway message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ExternalVpnGateway} ExternalVpnGateway
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExternalVpnGateway.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ExternalVpnGateway(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 12073562: {
                                        if (!(message.interfaces && message.interfaces.length))
                                            message.interfaces = [];
                                        message.interfaces.push($root.google.cloud.compute.v1.ExternalVpnGatewayInterface.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 178124825: {
                                        message.labelFingerprint = reader.string();
                                        break;
                                    }
                                case 500195327: {
                                        if (message.labels === $util.emptyObject)
                                            message.labels = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.labels[key] = value;
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 271443740: {
                                        message.redundancyType = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ExternalVpnGateway message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ExternalVpnGateway} ExternalVpnGateway
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExternalVpnGateway.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ExternalVpnGateway message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExternalVpnGateway.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.interfaces != null && message.hasOwnProperty("interfaces")) {
                                if (!Array.isArray(message.interfaces))
                                    return "interfaces: array expected";
                                for (var i = 0; i < message.interfaces.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ExternalVpnGatewayInterface.verify(message.interfaces[i]);
                                    if (error)
                                        return "interfaces." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                properties._labelFingerprint = 1;
                                if (!$util.isString(message.labelFingerprint))
                                    return "labelFingerprint: string expected";
                            }
                            if (message.labels != null && message.hasOwnProperty("labels")) {
                                if (!$util.isObject(message.labels))
                                    return "labels: object expected";
                                var key = Object.keys(message.labels);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.labels[key[i]]))
                                        return "labels: string{k:string} expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.redundancyType != null && message.hasOwnProperty("redundancyType")) {
                                properties._redundancyType = 1;
                                if (!$util.isString(message.redundancyType))
                                    return "redundancyType: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an ExternalVpnGateway message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ExternalVpnGateway} ExternalVpnGateway
                         */
                        ExternalVpnGateway.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ExternalVpnGateway)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ExternalVpnGateway();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.interfaces) {
                                if (!Array.isArray(object.interfaces))
                                    throw TypeError(".google.cloud.compute.v1.ExternalVpnGateway.interfaces: array expected");
                                message.interfaces = [];
                                for (var i = 0; i < object.interfaces.length; ++i) {
                                    if (typeof object.interfaces[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ExternalVpnGateway.interfaces: object expected");
                                    message.interfaces[i] = $root.google.cloud.compute.v1.ExternalVpnGatewayInterface.fromObject(object.interfaces[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.labelFingerprint != null)
                                message.labelFingerprint = String(object.labelFingerprint);
                            if (object.labels) {
                                if (typeof object.labels !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ExternalVpnGateway.labels: object expected");
                                message.labels = {};
                                for (var keys = Object.keys(object.labels), i = 0; i < keys.length; ++i)
                                    message.labels[keys[i]] = String(object.labels[keys[i]]);
                            }
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.redundancyType != null)
                                message.redundancyType = String(object.redundancyType);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ExternalVpnGateway message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @static
                         * @param {google.cloud.compute.v1.ExternalVpnGateway} message ExternalVpnGateway
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExternalVpnGateway.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.interfaces = [];
                            if (options.objects || options.defaults)
                                object.labels = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.interfaces && message.interfaces.length) {
                                object.interfaces = [];
                                for (var j = 0; j < message.interfaces.length; ++j)
                                    object.interfaces[j] = $root.google.cloud.compute.v1.ExternalVpnGatewayInterface.toObject(message.interfaces[j], options);
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                object.labelFingerprint = message.labelFingerprint;
                                if (options.oneofs)
                                    object._labelFingerprint = "labelFingerprint";
                            }
                            if (message.redundancyType != null && message.hasOwnProperty("redundancyType")) {
                                object.redundancyType = message.redundancyType;
                                if (options.oneofs)
                                    object._redundancyType = "redundancyType";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            var keys2;
                            if (message.labels && (keys2 = Object.keys(message.labels)).length) {
                                object.labels = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.labels[keys2[j]] = message.labels[keys2[j]];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ExternalVpnGateway to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExternalVpnGateway.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ExternalVpnGateway
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ExternalVpnGateway
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ExternalVpnGateway.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ExternalVpnGateway";
                        };
    
                        /**
                         * RedundancyType enum.
                         * @name google.cloud.compute.v1.ExternalVpnGateway.RedundancyType
                         * @enum {number}
                         * @property {number} UNDEFINED_REDUNDANCY_TYPE=0 UNDEFINED_REDUNDANCY_TYPE value
                         * @property {number} FOUR_IPS_REDUNDANCY=520087913 FOUR_IPS_REDUNDANCY value
                         * @property {number} SINGLE_IP_INTERNALLY_REDUNDANT=133914873 SINGLE_IP_INTERNALLY_REDUNDANT value
                         * @property {number} TWO_IPS_REDUNDANCY=367049635 TWO_IPS_REDUNDANCY value
                         */
                        ExternalVpnGateway.RedundancyType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_REDUNDANCY_TYPE"] = 0;
                            values[valuesById[520087913] = "FOUR_IPS_REDUNDANCY"] = 520087913;
                            values[valuesById[133914873] = "SINGLE_IP_INTERNALLY_REDUNDANT"] = 133914873;
                            values[valuesById[367049635] = "TWO_IPS_REDUNDANCY"] = 367049635;
                            return values;
                        })();
    
                        return ExternalVpnGateway;
                    })();
    
                    v1.ExternalVpnGatewayInterface = (function() {
    
                        /**
                         * Properties of an ExternalVpnGatewayInterface.
                         * @memberof google.cloud.compute.v1
                         * @interface IExternalVpnGatewayInterface
                         * @property {number|null} [id] ExternalVpnGatewayInterface id
                         * @property {string|null} [ipAddress] ExternalVpnGatewayInterface ipAddress
                         */
    
                        /**
                         * Constructs a new ExternalVpnGatewayInterface.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an ExternalVpnGatewayInterface.
                         * @implements IExternalVpnGatewayInterface
                         * @constructor
                         * @param {google.cloud.compute.v1.IExternalVpnGatewayInterface=} [properties] Properties to set
                         */
                        function ExternalVpnGatewayInterface(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ExternalVpnGatewayInterface id.
                         * @member {number|null|undefined} id
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayInterface
                         * @instance
                         */
                        ExternalVpnGatewayInterface.prototype.id = null;
    
                        /**
                         * ExternalVpnGatewayInterface ipAddress.
                         * @member {string|null|undefined} ipAddress
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayInterface
                         * @instance
                         */
                        ExternalVpnGatewayInterface.prototype.ipAddress = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ExternalVpnGatewayInterface _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayInterface
                         * @instance
                         */
                        Object.defineProperty(ExternalVpnGatewayInterface.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExternalVpnGatewayInterface _ipAddress.
                         * @member {"ipAddress"|undefined} _ipAddress
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayInterface
                         * @instance
                         */
                        Object.defineProperty(ExternalVpnGatewayInterface.prototype, "_ipAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["ipAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ExternalVpnGatewayInterface instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayInterface
                         * @static
                         * @param {google.cloud.compute.v1.IExternalVpnGatewayInterface=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ExternalVpnGatewayInterface} ExternalVpnGatewayInterface instance
                         */
                        ExternalVpnGatewayInterface.create = function create(properties) {
                            return new ExternalVpnGatewayInterface(properties);
                        };
    
                        /**
                         * Encodes the specified ExternalVpnGatewayInterface message. Does not implicitly {@link google.cloud.compute.v1.ExternalVpnGatewayInterface.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayInterface
                         * @static
                         * @param {google.cloud.compute.v1.IExternalVpnGatewayInterface} message ExternalVpnGatewayInterface message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExternalVpnGatewayInterface.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint32(message.id);
                            if (message.ipAddress != null && Object.hasOwnProperty.call(message, "ipAddress"))
                                writer.uint32(/* id 406272220, wireType 2 =*/3250177762).string(message.ipAddress);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ExternalVpnGatewayInterface message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ExternalVpnGatewayInterface.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayInterface
                         * @static
                         * @param {google.cloud.compute.v1.IExternalVpnGatewayInterface} message ExternalVpnGatewayInterface message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExternalVpnGatewayInterface.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ExternalVpnGatewayInterface message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayInterface
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ExternalVpnGatewayInterface} ExternalVpnGatewayInterface
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExternalVpnGatewayInterface.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ExternalVpnGatewayInterface();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.uint32();
                                        break;
                                    }
                                case 406272220: {
                                        message.ipAddress = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ExternalVpnGatewayInterface message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayInterface
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ExternalVpnGatewayInterface} ExternalVpnGatewayInterface
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExternalVpnGatewayInterface.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ExternalVpnGatewayInterface message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayInterface
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExternalVpnGatewayInterface.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id))
                                    return "id: integer expected";
                            }
                            if (message.ipAddress != null && message.hasOwnProperty("ipAddress")) {
                                properties._ipAddress = 1;
                                if (!$util.isString(message.ipAddress))
                                    return "ipAddress: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an ExternalVpnGatewayInterface message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayInterface
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ExternalVpnGatewayInterface} ExternalVpnGatewayInterface
                         */
                        ExternalVpnGatewayInterface.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ExternalVpnGatewayInterface)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ExternalVpnGatewayInterface();
                            if (object.id != null)
                                message.id = object.id >>> 0;
                            if (object.ipAddress != null)
                                message.ipAddress = String(object.ipAddress);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ExternalVpnGatewayInterface message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayInterface
                         * @static
                         * @param {google.cloud.compute.v1.ExternalVpnGatewayInterface} message ExternalVpnGatewayInterface
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExternalVpnGatewayInterface.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.ipAddress != null && message.hasOwnProperty("ipAddress")) {
                                object.ipAddress = message.ipAddress;
                                if (options.oneofs)
                                    object._ipAddress = "ipAddress";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ExternalVpnGatewayInterface to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayInterface
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExternalVpnGatewayInterface.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ExternalVpnGatewayInterface
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayInterface
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ExternalVpnGatewayInterface.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ExternalVpnGatewayInterface";
                        };
    
                        return ExternalVpnGatewayInterface;
                    })();
    
                    v1.ExternalVpnGatewayList = (function() {
    
                        /**
                         * Properties of an ExternalVpnGatewayList.
                         * @memberof google.cloud.compute.v1
                         * @interface IExternalVpnGatewayList
                         * @property {string|null} [etag] ExternalVpnGatewayList etag
                         * @property {string|null} [id] ExternalVpnGatewayList id
                         * @property {Array.<google.cloud.compute.v1.IExternalVpnGateway>|null} [items] ExternalVpnGatewayList items
                         * @property {string|null} [kind] ExternalVpnGatewayList kind
                         * @property {string|null} [nextPageToken] ExternalVpnGatewayList nextPageToken
                         * @property {string|null} [selfLink] ExternalVpnGatewayList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] ExternalVpnGatewayList warning
                         */
    
                        /**
                         * Constructs a new ExternalVpnGatewayList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an ExternalVpnGatewayList.
                         * @implements IExternalVpnGatewayList
                         * @constructor
                         * @param {google.cloud.compute.v1.IExternalVpnGatewayList=} [properties] Properties to set
                         */
                        function ExternalVpnGatewayList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ExternalVpnGatewayList etag.
                         * @member {string|null|undefined} etag
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @instance
                         */
                        ExternalVpnGatewayList.prototype.etag = null;
    
                        /**
                         * ExternalVpnGatewayList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @instance
                         */
                        ExternalVpnGatewayList.prototype.id = null;
    
                        /**
                         * ExternalVpnGatewayList items.
                         * @member {Array.<google.cloud.compute.v1.IExternalVpnGateway>} items
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @instance
                         */
                        ExternalVpnGatewayList.prototype.items = $util.emptyArray;
    
                        /**
                         * ExternalVpnGatewayList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @instance
                         */
                        ExternalVpnGatewayList.prototype.kind = null;
    
                        /**
                         * ExternalVpnGatewayList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @instance
                         */
                        ExternalVpnGatewayList.prototype.nextPageToken = null;
    
                        /**
                         * ExternalVpnGatewayList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @instance
                         */
                        ExternalVpnGatewayList.prototype.selfLink = null;
    
                        /**
                         * ExternalVpnGatewayList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @instance
                         */
                        ExternalVpnGatewayList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ExternalVpnGatewayList _etag.
                         * @member {"etag"|undefined} _etag
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @instance
                         */
                        Object.defineProperty(ExternalVpnGatewayList.prototype, "_etag", {
                            get: $util.oneOfGetter($oneOfFields = ["etag"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExternalVpnGatewayList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @instance
                         */
                        Object.defineProperty(ExternalVpnGatewayList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExternalVpnGatewayList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @instance
                         */
                        Object.defineProperty(ExternalVpnGatewayList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExternalVpnGatewayList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @instance
                         */
                        Object.defineProperty(ExternalVpnGatewayList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExternalVpnGatewayList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @instance
                         */
                        Object.defineProperty(ExternalVpnGatewayList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ExternalVpnGatewayList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @instance
                         */
                        Object.defineProperty(ExternalVpnGatewayList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ExternalVpnGatewayList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @static
                         * @param {google.cloud.compute.v1.IExternalVpnGatewayList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ExternalVpnGatewayList} ExternalVpnGatewayList instance
                         */
                        ExternalVpnGatewayList.create = function create(properties) {
                            return new ExternalVpnGatewayList(properties);
                        };
    
                        /**
                         * Encodes the specified ExternalVpnGatewayList message. Does not implicitly {@link google.cloud.compute.v1.ExternalVpnGatewayList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @static
                         * @param {google.cloud.compute.v1.IExternalVpnGatewayList} message ExternalVpnGatewayList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExternalVpnGatewayList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.etag != null && Object.hasOwnProperty.call(message, "etag"))
                                writer.uint32(/* id 3123477, wireType 2 =*/24987818).string(message.etag);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.ExternalVpnGateway.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ExternalVpnGatewayList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ExternalVpnGatewayList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @static
                         * @param {google.cloud.compute.v1.IExternalVpnGatewayList} message ExternalVpnGatewayList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ExternalVpnGatewayList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ExternalVpnGatewayList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ExternalVpnGatewayList} ExternalVpnGatewayList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExternalVpnGatewayList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ExternalVpnGatewayList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3123477: {
                                        message.etag = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.ExternalVpnGateway.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ExternalVpnGatewayList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ExternalVpnGatewayList} ExternalVpnGatewayList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ExternalVpnGatewayList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ExternalVpnGatewayList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ExternalVpnGatewayList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                properties._etag = 1;
                                if (!$util.isString(message.etag))
                                    return "etag: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ExternalVpnGateway.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an ExternalVpnGatewayList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ExternalVpnGatewayList} ExternalVpnGatewayList
                         */
                        ExternalVpnGatewayList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ExternalVpnGatewayList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ExternalVpnGatewayList();
                            if (object.etag != null)
                                message.etag = String(object.etag);
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.ExternalVpnGatewayList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ExternalVpnGatewayList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.ExternalVpnGateway.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ExternalVpnGatewayList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ExternalVpnGatewayList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @static
                         * @param {google.cloud.compute.v1.ExternalVpnGatewayList} message ExternalVpnGatewayList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ExternalVpnGatewayList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                object.etag = message.etag;
                                if (options.oneofs)
                                    object._etag = "etag";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.ExternalVpnGateway.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ExternalVpnGatewayList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ExternalVpnGatewayList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ExternalVpnGatewayList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ExternalVpnGatewayList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ExternalVpnGatewayList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ExternalVpnGatewayList";
                        };
    
                        return ExternalVpnGatewayList;
                    })();
    
                    v1.FileContentBuffer = (function() {
    
                        /**
                         * Properties of a FileContentBuffer.
                         * @memberof google.cloud.compute.v1
                         * @interface IFileContentBuffer
                         * @property {string|null} [content] FileContentBuffer content
                         * @property {string|null} [fileType] FileContentBuffer fileType
                         */
    
                        /**
                         * Constructs a new FileContentBuffer.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a FileContentBuffer.
                         * @implements IFileContentBuffer
                         * @constructor
                         * @param {google.cloud.compute.v1.IFileContentBuffer=} [properties] Properties to set
                         */
                        function FileContentBuffer(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * FileContentBuffer content.
                         * @member {string|null|undefined} content
                         * @memberof google.cloud.compute.v1.FileContentBuffer
                         * @instance
                         */
                        FileContentBuffer.prototype.content = null;
    
                        /**
                         * FileContentBuffer fileType.
                         * @member {string|null|undefined} fileType
                         * @memberof google.cloud.compute.v1.FileContentBuffer
                         * @instance
                         */
                        FileContentBuffer.prototype.fileType = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * FileContentBuffer _content.
                         * @member {"content"|undefined} _content
                         * @memberof google.cloud.compute.v1.FileContentBuffer
                         * @instance
                         */
                        Object.defineProperty(FileContentBuffer.prototype, "_content", {
                            get: $util.oneOfGetter($oneOfFields = ["content"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FileContentBuffer _fileType.
                         * @member {"fileType"|undefined} _fileType
                         * @memberof google.cloud.compute.v1.FileContentBuffer
                         * @instance
                         */
                        Object.defineProperty(FileContentBuffer.prototype, "_fileType", {
                            get: $util.oneOfGetter($oneOfFields = ["fileType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new FileContentBuffer instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.FileContentBuffer
                         * @static
                         * @param {google.cloud.compute.v1.IFileContentBuffer=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.FileContentBuffer} FileContentBuffer instance
                         */
                        FileContentBuffer.create = function create(properties) {
                            return new FileContentBuffer(properties);
                        };
    
                        /**
                         * Encodes the specified FileContentBuffer message. Does not implicitly {@link google.cloud.compute.v1.FileContentBuffer.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.FileContentBuffer
                         * @static
                         * @param {google.cloud.compute.v1.IFileContentBuffer} message FileContentBuffer message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FileContentBuffer.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.fileType != null && Object.hasOwnProperty.call(message, "fileType"))
                                writer.uint32(/* id 294346781, wireType 2 =*/2354774250).string(message.fileType);
                            if (message.content != null && Object.hasOwnProperty.call(message, "content"))
                                writer.uint32(/* id 414659705, wireType 2 =*/3317277642).string(message.content);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified FileContentBuffer message, length delimited. Does not implicitly {@link google.cloud.compute.v1.FileContentBuffer.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.FileContentBuffer
                         * @static
                         * @param {google.cloud.compute.v1.IFileContentBuffer} message FileContentBuffer message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FileContentBuffer.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a FileContentBuffer message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.FileContentBuffer
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.FileContentBuffer} FileContentBuffer
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FileContentBuffer.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.FileContentBuffer();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 414659705: {
                                        message.content = reader.string();
                                        break;
                                    }
                                case 294346781: {
                                        message.fileType = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a FileContentBuffer message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.FileContentBuffer
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.FileContentBuffer} FileContentBuffer
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FileContentBuffer.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a FileContentBuffer message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.FileContentBuffer
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FileContentBuffer.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.content != null && message.hasOwnProperty("content")) {
                                properties._content = 1;
                                if (!$util.isString(message.content))
                                    return "content: string expected";
                            }
                            if (message.fileType != null && message.hasOwnProperty("fileType")) {
                                properties._fileType = 1;
                                if (!$util.isString(message.fileType))
                                    return "fileType: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a FileContentBuffer message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.FileContentBuffer
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.FileContentBuffer} FileContentBuffer
                         */
                        FileContentBuffer.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.FileContentBuffer)
                                return object;
                            var message = new $root.google.cloud.compute.v1.FileContentBuffer();
                            if (object.content != null)
                                message.content = String(object.content);
                            if (object.fileType != null)
                                message.fileType = String(object.fileType);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a FileContentBuffer message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.FileContentBuffer
                         * @static
                         * @param {google.cloud.compute.v1.FileContentBuffer} message FileContentBuffer
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FileContentBuffer.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.fileType != null && message.hasOwnProperty("fileType")) {
                                object.fileType = message.fileType;
                                if (options.oneofs)
                                    object._fileType = "fileType";
                            }
                            if (message.content != null && message.hasOwnProperty("content")) {
                                object.content = message.content;
                                if (options.oneofs)
                                    object._content = "content";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this FileContentBuffer to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.FileContentBuffer
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FileContentBuffer.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for FileContentBuffer
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.FileContentBuffer
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        FileContentBuffer.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.FileContentBuffer";
                        };
    
                        /**
                         * FileType enum.
                         * @name google.cloud.compute.v1.FileContentBuffer.FileType
                         * @enum {number}
                         * @property {number} UNDEFINED_FILE_TYPE=0 UNDEFINED_FILE_TYPE value
                         * @property {number} BIN=65767 BIN value
                         * @property {number} UNDEFINED=137851184 UNDEFINED value
                         * @property {number} X509=2674086 X509 value
                         */
                        FileContentBuffer.FileType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_FILE_TYPE"] = 0;
                            values[valuesById[65767] = "BIN"] = 65767;
                            values[valuesById[137851184] = "UNDEFINED"] = 137851184;
                            values[valuesById[2674086] = "X509"] = 2674086;
                            return values;
                        })();
    
                        return FileContentBuffer;
                    })();
    
                    v1.Firewall = (function() {
    
                        /**
                         * Properties of a Firewall.
                         * @memberof google.cloud.compute.v1
                         * @interface IFirewall
                         * @property {Array.<google.cloud.compute.v1.IAllowed>|null} [allowed] Firewall allowed
                         * @property {string|null} [creationTimestamp] Firewall creationTimestamp
                         * @property {Array.<google.cloud.compute.v1.IDenied>|null} [denied] Firewall denied
                         * @property {string|null} [description] Firewall description
                         * @property {Array.<string>|null} [destinationRanges] Firewall destinationRanges
                         * @property {string|null} [direction] Firewall direction
                         * @property {boolean|null} [disabled] Firewall disabled
                         * @property {number|Long|null} [id] Firewall id
                         * @property {string|null} [kind] Firewall kind
                         * @property {google.cloud.compute.v1.IFirewallLogConfig|null} [logConfig] Firewall logConfig
                         * @property {string|null} [name] Firewall name
                         * @property {string|null} [network] Firewall network
                         * @property {number|null} [priority] Firewall priority
                         * @property {string|null} [selfLink] Firewall selfLink
                         * @property {Array.<string>|null} [sourceRanges] Firewall sourceRanges
                         * @property {Array.<string>|null} [sourceServiceAccounts] Firewall sourceServiceAccounts
                         * @property {Array.<string>|null} [sourceTags] Firewall sourceTags
                         * @property {Array.<string>|null} [targetServiceAccounts] Firewall targetServiceAccounts
                         * @property {Array.<string>|null} [targetTags] Firewall targetTags
                         */
    
                        /**
                         * Constructs a new Firewall.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Firewall.
                         * @implements IFirewall
                         * @constructor
                         * @param {google.cloud.compute.v1.IFirewall=} [properties] Properties to set
                         */
                        function Firewall(properties) {
                            this.allowed = [];
                            this.denied = [];
                            this.destinationRanges = [];
                            this.sourceRanges = [];
                            this.sourceServiceAccounts = [];
                            this.sourceTags = [];
                            this.targetServiceAccounts = [];
                            this.targetTags = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Firewall allowed.
                         * @member {Array.<google.cloud.compute.v1.IAllowed>} allowed
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Firewall.prototype.allowed = $util.emptyArray;
    
                        /**
                         * Firewall creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Firewall.prototype.creationTimestamp = null;
    
                        /**
                         * Firewall denied.
                         * @member {Array.<google.cloud.compute.v1.IDenied>} denied
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Firewall.prototype.denied = $util.emptyArray;
    
                        /**
                         * Firewall description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Firewall.prototype.description = null;
    
                        /**
                         * Firewall destinationRanges.
                         * @member {Array.<string>} destinationRanges
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Firewall.prototype.destinationRanges = $util.emptyArray;
    
                        /**
                         * Firewall direction.
                         * @member {string|null|undefined} direction
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Firewall.prototype.direction = null;
    
                        /**
                         * Firewall disabled.
                         * @member {boolean|null|undefined} disabled
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Firewall.prototype.disabled = null;
    
                        /**
                         * Firewall id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Firewall.prototype.id = null;
    
                        /**
                         * Firewall kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Firewall.prototype.kind = null;
    
                        /**
                         * Firewall logConfig.
                         * @member {google.cloud.compute.v1.IFirewallLogConfig|null|undefined} logConfig
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Firewall.prototype.logConfig = null;
    
                        /**
                         * Firewall name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Firewall.prototype.name = null;
    
                        /**
                         * Firewall network.
                         * @member {string|null|undefined} network
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Firewall.prototype.network = null;
    
                        /**
                         * Firewall priority.
                         * @member {number|null|undefined} priority
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Firewall.prototype.priority = null;
    
                        /**
                         * Firewall selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Firewall.prototype.selfLink = null;
    
                        /**
                         * Firewall sourceRanges.
                         * @member {Array.<string>} sourceRanges
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Firewall.prototype.sourceRanges = $util.emptyArray;
    
                        /**
                         * Firewall sourceServiceAccounts.
                         * @member {Array.<string>} sourceServiceAccounts
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Firewall.prototype.sourceServiceAccounts = $util.emptyArray;
    
                        /**
                         * Firewall sourceTags.
                         * @member {Array.<string>} sourceTags
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Firewall.prototype.sourceTags = $util.emptyArray;
    
                        /**
                         * Firewall targetServiceAccounts.
                         * @member {Array.<string>} targetServiceAccounts
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Firewall.prototype.targetServiceAccounts = $util.emptyArray;
    
                        /**
                         * Firewall targetTags.
                         * @member {Array.<string>} targetTags
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Firewall.prototype.targetTags = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Firewall _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Object.defineProperty(Firewall.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Firewall _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Object.defineProperty(Firewall.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Firewall _direction.
                         * @member {"direction"|undefined} _direction
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Object.defineProperty(Firewall.prototype, "_direction", {
                            get: $util.oneOfGetter($oneOfFields = ["direction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Firewall _disabled.
                         * @member {"disabled"|undefined} _disabled
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Object.defineProperty(Firewall.prototype, "_disabled", {
                            get: $util.oneOfGetter($oneOfFields = ["disabled"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Firewall _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Object.defineProperty(Firewall.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Firewall _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Object.defineProperty(Firewall.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Firewall _logConfig.
                         * @member {"logConfig"|undefined} _logConfig
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Object.defineProperty(Firewall.prototype, "_logConfig", {
                            get: $util.oneOfGetter($oneOfFields = ["logConfig"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Firewall _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Object.defineProperty(Firewall.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Firewall _network.
                         * @member {"network"|undefined} _network
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Object.defineProperty(Firewall.prototype, "_network", {
                            get: $util.oneOfGetter($oneOfFields = ["network"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Firewall _priority.
                         * @member {"priority"|undefined} _priority
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Object.defineProperty(Firewall.prototype, "_priority", {
                            get: $util.oneOfGetter($oneOfFields = ["priority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Firewall _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         */
                        Object.defineProperty(Firewall.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Firewall instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Firewall
                         * @static
                         * @param {google.cloud.compute.v1.IFirewall=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Firewall} Firewall instance
                         */
                        Firewall.create = function create(properties) {
                            return new Firewall(properties);
                        };
    
                        /**
                         * Encodes the specified Firewall message. Does not implicitly {@link google.cloud.compute.v1.Firewall.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Firewall
                         * @static
                         * @param {google.cloud.compute.v1.IFirewall} message Firewall message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Firewall.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.targetTags != null && message.targetTags.length)
                                for (var i = 0; i < message.targetTags.length; ++i)
                                    writer.uint32(/* id 62901767, wireType 2 =*/503214138).string(message.targetTags[i]);
                            if (message.sourceServiceAccounts != null && message.sourceServiceAccounts.length)
                                for (var i = 0; i < message.sourceServiceAccounts.length; ++i)
                                    writer.uint32(/* id 105100756, wireType 2 =*/840806050).string(message.sourceServiceAccounts[i]);
                            if (message.direction != null && Object.hasOwnProperty.call(message, "direction"))
                                writer.uint32(/* id 111150975, wireType 2 =*/889207802).string(message.direction);
                            if (message.allowed != null && message.allowed.length)
                                for (var i = 0; i < message.allowed.length; ++i)
                                    $root.google.cloud.compute.v1.Allowed.encode(message.allowed[i], writer.uint32(/* id 162398632, wireType 2 =*/1299189058).fork()).ldelim();
                            if (message.sourceRanges != null && message.sourceRanges.length)
                                for (var i = 0; i < message.sourceRanges.length; ++i)
                                    writer.uint32(/* id 200097658, wireType 2 =*/1600781266).string(message.sourceRanges[i]);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            if (message.disabled != null && Object.hasOwnProperty.call(message, "disabled"))
                                writer.uint32(/* id 270940796, wireType 0 =*/2167526368).bool(message.disabled);
                            if (message.denied != null && message.denied.length)
                                for (var i = 0; i < message.denied.length; ++i)
                                    $root.google.cloud.compute.v1.Denied.encode(message.denied[i], writer.uint32(/* id 275217307, wireType 2 =*/2201738458).fork()).ldelim();
                            if (message.destinationRanges != null && message.destinationRanges.length)
                                for (var i = 0; i < message.destinationRanges.length; ++i)
                                    writer.uint32(/* id 305699879, wireType 2 =*/2445599034).string(message.destinationRanges[i]);
                            if (message.logConfig != null && Object.hasOwnProperty.call(message, "logConfig"))
                                $root.google.cloud.compute.v1.FirewallLogConfig.encode(message.logConfig, writer.uint32(/* id 351299741, wireType 2 =*/2810397930).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.priority != null && Object.hasOwnProperty.call(message, "priority"))
                                writer.uint32(/* id 445151652, wireType 0 =*/3561213216).int32(message.priority);
                            if (message.sourceTags != null && message.sourceTags.length)
                                for (var i = 0; i < message.sourceTags.length; ++i)
                                    writer.uint32(/* id 452222397, wireType 2 =*/3617779178).string(message.sourceTags[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.targetServiceAccounts != null && message.targetServiceAccounts.length)
                                for (var i = 0; i < message.targetServiceAccounts.length; ++i)
                                    writer.uint32(/* id 457639710, wireType 2 =*/3661117682).string(message.targetServiceAccounts[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Firewall message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Firewall.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Firewall
                         * @static
                         * @param {google.cloud.compute.v1.IFirewall} message Firewall message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Firewall.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Firewall message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Firewall
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Firewall} Firewall
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Firewall.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Firewall();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 162398632: {
                                        if (!(message.allowed && message.allowed.length))
                                            message.allowed = [];
                                        message.allowed.push($root.google.cloud.compute.v1.Allowed.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 275217307: {
                                        if (!(message.denied && message.denied.length))
                                            message.denied = [];
                                        message.denied.push($root.google.cloud.compute.v1.Denied.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 305699879: {
                                        if (!(message.destinationRanges && message.destinationRanges.length))
                                            message.destinationRanges = [];
                                        message.destinationRanges.push(reader.string());
                                        break;
                                    }
                                case 111150975: {
                                        message.direction = reader.string();
                                        break;
                                    }
                                case 270940796: {
                                        message.disabled = reader.bool();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 351299741: {
                                        message.logConfig = $root.google.cloud.compute.v1.FirewallLogConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 445151652: {
                                        message.priority = reader.int32();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 200097658: {
                                        if (!(message.sourceRanges && message.sourceRanges.length))
                                            message.sourceRanges = [];
                                        message.sourceRanges.push(reader.string());
                                        break;
                                    }
                                case 105100756: {
                                        if (!(message.sourceServiceAccounts && message.sourceServiceAccounts.length))
                                            message.sourceServiceAccounts = [];
                                        message.sourceServiceAccounts.push(reader.string());
                                        break;
                                    }
                                case 452222397: {
                                        if (!(message.sourceTags && message.sourceTags.length))
                                            message.sourceTags = [];
                                        message.sourceTags.push(reader.string());
                                        break;
                                    }
                                case 457639710: {
                                        if (!(message.targetServiceAccounts && message.targetServiceAccounts.length))
                                            message.targetServiceAccounts = [];
                                        message.targetServiceAccounts.push(reader.string());
                                        break;
                                    }
                                case 62901767: {
                                        if (!(message.targetTags && message.targetTags.length))
                                            message.targetTags = [];
                                        message.targetTags.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Firewall message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Firewall
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Firewall} Firewall
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Firewall.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Firewall message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Firewall
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Firewall.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.allowed != null && message.hasOwnProperty("allowed")) {
                                if (!Array.isArray(message.allowed))
                                    return "allowed: array expected";
                                for (var i = 0; i < message.allowed.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Allowed.verify(message.allowed[i]);
                                    if (error)
                                        return "allowed." + error;
                                }
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.denied != null && message.hasOwnProperty("denied")) {
                                if (!Array.isArray(message.denied))
                                    return "denied: array expected";
                                for (var i = 0; i < message.denied.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Denied.verify(message.denied[i]);
                                    if (error)
                                        return "denied." + error;
                                }
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.destinationRanges != null && message.hasOwnProperty("destinationRanges")) {
                                if (!Array.isArray(message.destinationRanges))
                                    return "destinationRanges: array expected";
                                for (var i = 0; i < message.destinationRanges.length; ++i)
                                    if (!$util.isString(message.destinationRanges[i]))
                                        return "destinationRanges: string[] expected";
                            }
                            if (message.direction != null && message.hasOwnProperty("direction")) {
                                properties._direction = 1;
                                if (!$util.isString(message.direction))
                                    return "direction: string expected";
                            }
                            if (message.disabled != null && message.hasOwnProperty("disabled")) {
                                properties._disabled = 1;
                                if (typeof message.disabled !== "boolean")
                                    return "disabled: boolean expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.logConfig != null && message.hasOwnProperty("logConfig")) {
                                properties._logConfig = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.FirewallLogConfig.verify(message.logConfig);
                                    if (error)
                                        return "logConfig." + error;
                                }
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                properties._network = 1;
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            }
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                properties._priority = 1;
                                if (!$util.isInteger(message.priority))
                                    return "priority: integer expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.sourceRanges != null && message.hasOwnProperty("sourceRanges")) {
                                if (!Array.isArray(message.sourceRanges))
                                    return "sourceRanges: array expected";
                                for (var i = 0; i < message.sourceRanges.length; ++i)
                                    if (!$util.isString(message.sourceRanges[i]))
                                        return "sourceRanges: string[] expected";
                            }
                            if (message.sourceServiceAccounts != null && message.hasOwnProperty("sourceServiceAccounts")) {
                                if (!Array.isArray(message.sourceServiceAccounts))
                                    return "sourceServiceAccounts: array expected";
                                for (var i = 0; i < message.sourceServiceAccounts.length; ++i)
                                    if (!$util.isString(message.sourceServiceAccounts[i]))
                                        return "sourceServiceAccounts: string[] expected";
                            }
                            if (message.sourceTags != null && message.hasOwnProperty("sourceTags")) {
                                if (!Array.isArray(message.sourceTags))
                                    return "sourceTags: array expected";
                                for (var i = 0; i < message.sourceTags.length; ++i)
                                    if (!$util.isString(message.sourceTags[i]))
                                        return "sourceTags: string[] expected";
                            }
                            if (message.targetServiceAccounts != null && message.hasOwnProperty("targetServiceAccounts")) {
                                if (!Array.isArray(message.targetServiceAccounts))
                                    return "targetServiceAccounts: array expected";
                                for (var i = 0; i < message.targetServiceAccounts.length; ++i)
                                    if (!$util.isString(message.targetServiceAccounts[i]))
                                        return "targetServiceAccounts: string[] expected";
                            }
                            if (message.targetTags != null && message.hasOwnProperty("targetTags")) {
                                if (!Array.isArray(message.targetTags))
                                    return "targetTags: array expected";
                                for (var i = 0; i < message.targetTags.length; ++i)
                                    if (!$util.isString(message.targetTags[i]))
                                        return "targetTags: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Firewall message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Firewall
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Firewall} Firewall
                         */
                        Firewall.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Firewall)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Firewall();
                            if (object.allowed) {
                                if (!Array.isArray(object.allowed))
                                    throw TypeError(".google.cloud.compute.v1.Firewall.allowed: array expected");
                                message.allowed = [];
                                for (var i = 0; i < object.allowed.length; ++i) {
                                    if (typeof object.allowed[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Firewall.allowed: object expected");
                                    message.allowed[i] = $root.google.cloud.compute.v1.Allowed.fromObject(object.allowed[i]);
                                }
                            }
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.denied) {
                                if (!Array.isArray(object.denied))
                                    throw TypeError(".google.cloud.compute.v1.Firewall.denied: array expected");
                                message.denied = [];
                                for (var i = 0; i < object.denied.length; ++i) {
                                    if (typeof object.denied[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Firewall.denied: object expected");
                                    message.denied[i] = $root.google.cloud.compute.v1.Denied.fromObject(object.denied[i]);
                                }
                            }
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.destinationRanges) {
                                if (!Array.isArray(object.destinationRanges))
                                    throw TypeError(".google.cloud.compute.v1.Firewall.destinationRanges: array expected");
                                message.destinationRanges = [];
                                for (var i = 0; i < object.destinationRanges.length; ++i)
                                    message.destinationRanges[i] = String(object.destinationRanges[i]);
                            }
                            if (object.direction != null)
                                message.direction = String(object.direction);
                            if (object.disabled != null)
                                message.disabled = Boolean(object.disabled);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.logConfig != null) {
                                if (typeof object.logConfig !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Firewall.logConfig: object expected");
                                message.logConfig = $root.google.cloud.compute.v1.FirewallLogConfig.fromObject(object.logConfig);
                            }
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.priority != null)
                                message.priority = object.priority | 0;
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.sourceRanges) {
                                if (!Array.isArray(object.sourceRanges))
                                    throw TypeError(".google.cloud.compute.v1.Firewall.sourceRanges: array expected");
                                message.sourceRanges = [];
                                for (var i = 0; i < object.sourceRanges.length; ++i)
                                    message.sourceRanges[i] = String(object.sourceRanges[i]);
                            }
                            if (object.sourceServiceAccounts) {
                                if (!Array.isArray(object.sourceServiceAccounts))
                                    throw TypeError(".google.cloud.compute.v1.Firewall.sourceServiceAccounts: array expected");
                                message.sourceServiceAccounts = [];
                                for (var i = 0; i < object.sourceServiceAccounts.length; ++i)
                                    message.sourceServiceAccounts[i] = String(object.sourceServiceAccounts[i]);
                            }
                            if (object.sourceTags) {
                                if (!Array.isArray(object.sourceTags))
                                    throw TypeError(".google.cloud.compute.v1.Firewall.sourceTags: array expected");
                                message.sourceTags = [];
                                for (var i = 0; i < object.sourceTags.length; ++i)
                                    message.sourceTags[i] = String(object.sourceTags[i]);
                            }
                            if (object.targetServiceAccounts) {
                                if (!Array.isArray(object.targetServiceAccounts))
                                    throw TypeError(".google.cloud.compute.v1.Firewall.targetServiceAccounts: array expected");
                                message.targetServiceAccounts = [];
                                for (var i = 0; i < object.targetServiceAccounts.length; ++i)
                                    message.targetServiceAccounts[i] = String(object.targetServiceAccounts[i]);
                            }
                            if (object.targetTags) {
                                if (!Array.isArray(object.targetTags))
                                    throw TypeError(".google.cloud.compute.v1.Firewall.targetTags: array expected");
                                message.targetTags = [];
                                for (var i = 0; i < object.targetTags.length; ++i)
                                    message.targetTags[i] = String(object.targetTags[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Firewall message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Firewall
                         * @static
                         * @param {google.cloud.compute.v1.Firewall} message Firewall
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Firewall.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.targetTags = [];
                                object.sourceServiceAccounts = [];
                                object.allowed = [];
                                object.sourceRanges = [];
                                object.denied = [];
                                object.destinationRanges = [];
                                object.sourceTags = [];
                                object.targetServiceAccounts = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.targetTags && message.targetTags.length) {
                                object.targetTags = [];
                                for (var j = 0; j < message.targetTags.length; ++j)
                                    object.targetTags[j] = message.targetTags[j];
                            }
                            if (message.sourceServiceAccounts && message.sourceServiceAccounts.length) {
                                object.sourceServiceAccounts = [];
                                for (var j = 0; j < message.sourceServiceAccounts.length; ++j)
                                    object.sourceServiceAccounts[j] = message.sourceServiceAccounts[j];
                            }
                            if (message.direction != null && message.hasOwnProperty("direction")) {
                                object.direction = message.direction;
                                if (options.oneofs)
                                    object._direction = "direction";
                            }
                            if (message.allowed && message.allowed.length) {
                                object.allowed = [];
                                for (var j = 0; j < message.allowed.length; ++j)
                                    object.allowed[j] = $root.google.cloud.compute.v1.Allowed.toObject(message.allowed[j], options);
                            }
                            if (message.sourceRanges && message.sourceRanges.length) {
                                object.sourceRanges = [];
                                for (var j = 0; j < message.sourceRanges.length; ++j)
                                    object.sourceRanges[j] = message.sourceRanges[j];
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                object.network = message.network;
                                if (options.oneofs)
                                    object._network = "network";
                            }
                            if (message.disabled != null && message.hasOwnProperty("disabled")) {
                                object.disabled = message.disabled;
                                if (options.oneofs)
                                    object._disabled = "disabled";
                            }
                            if (message.denied && message.denied.length) {
                                object.denied = [];
                                for (var j = 0; j < message.denied.length; ++j)
                                    object.denied[j] = $root.google.cloud.compute.v1.Denied.toObject(message.denied[j], options);
                            }
                            if (message.destinationRanges && message.destinationRanges.length) {
                                object.destinationRanges = [];
                                for (var j = 0; j < message.destinationRanges.length; ++j)
                                    object.destinationRanges[j] = message.destinationRanges[j];
                            }
                            if (message.logConfig != null && message.hasOwnProperty("logConfig")) {
                                object.logConfig = $root.google.cloud.compute.v1.FirewallLogConfig.toObject(message.logConfig, options);
                                if (options.oneofs)
                                    object._logConfig = "logConfig";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                object.priority = message.priority;
                                if (options.oneofs)
                                    object._priority = "priority";
                            }
                            if (message.sourceTags && message.sourceTags.length) {
                                object.sourceTags = [];
                                for (var j = 0; j < message.sourceTags.length; ++j)
                                    object.sourceTags[j] = message.sourceTags[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.targetServiceAccounts && message.targetServiceAccounts.length) {
                                object.targetServiceAccounts = [];
                                for (var j = 0; j < message.targetServiceAccounts.length; ++j)
                                    object.targetServiceAccounts[j] = message.targetServiceAccounts[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Firewall to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Firewall
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Firewall.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Firewall
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Firewall
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Firewall.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Firewall";
                        };
    
                        /**
                         * Direction enum.
                         * @name google.cloud.compute.v1.Firewall.Direction
                         * @enum {number}
                         * @property {number} UNDEFINED_DIRECTION=0 UNDEFINED_DIRECTION value
                         * @property {number} EGRESS=432880501 EGRESS value
                         * @property {number} INGRESS=516931221 INGRESS value
                         */
                        Firewall.Direction = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_DIRECTION"] = 0;
                            values[valuesById[432880501] = "EGRESS"] = 432880501;
                            values[valuesById[516931221] = "INGRESS"] = 516931221;
                            return values;
                        })();
    
                        return Firewall;
                    })();
    
                    v1.FirewallList = (function() {
    
                        /**
                         * Properties of a FirewallList.
                         * @memberof google.cloud.compute.v1
                         * @interface IFirewallList
                         * @property {string|null} [id] FirewallList id
                         * @property {Array.<google.cloud.compute.v1.IFirewall>|null} [items] FirewallList items
                         * @property {string|null} [kind] FirewallList kind
                         * @property {string|null} [nextPageToken] FirewallList nextPageToken
                         * @property {string|null} [selfLink] FirewallList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] FirewallList warning
                         */
    
                        /**
                         * Constructs a new FirewallList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a FirewallList.
                         * @implements IFirewallList
                         * @constructor
                         * @param {google.cloud.compute.v1.IFirewallList=} [properties] Properties to set
                         */
                        function FirewallList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * FirewallList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @instance
                         */
                        FirewallList.prototype.id = null;
    
                        /**
                         * FirewallList items.
                         * @member {Array.<google.cloud.compute.v1.IFirewall>} items
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @instance
                         */
                        FirewallList.prototype.items = $util.emptyArray;
    
                        /**
                         * FirewallList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @instance
                         */
                        FirewallList.prototype.kind = null;
    
                        /**
                         * FirewallList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @instance
                         */
                        FirewallList.prototype.nextPageToken = null;
    
                        /**
                         * FirewallList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @instance
                         */
                        FirewallList.prototype.selfLink = null;
    
                        /**
                         * FirewallList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @instance
                         */
                        FirewallList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * FirewallList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @instance
                         */
                        Object.defineProperty(FirewallList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @instance
                         */
                        Object.defineProperty(FirewallList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @instance
                         */
                        Object.defineProperty(FirewallList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @instance
                         */
                        Object.defineProperty(FirewallList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @instance
                         */
                        Object.defineProperty(FirewallList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new FirewallList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.FirewallList} FirewallList instance
                         */
                        FirewallList.create = function create(properties) {
                            return new FirewallList(properties);
                        };
    
                        /**
                         * Encodes the specified FirewallList message. Does not implicitly {@link google.cloud.compute.v1.FirewallList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallList} message FirewallList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirewallList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Firewall.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified FirewallList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.FirewallList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallList} message FirewallList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirewallList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a FirewallList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.FirewallList} FirewallList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirewallList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.FirewallList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Firewall.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a FirewallList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.FirewallList} FirewallList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirewallList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a FirewallList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FirewallList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Firewall.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a FirewallList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.FirewallList} FirewallList
                         */
                        FirewallList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.FirewallList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.FirewallList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.FirewallList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.FirewallList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Firewall.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.FirewallList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a FirewallList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @static
                         * @param {google.cloud.compute.v1.FirewallList} message FirewallList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FirewallList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Firewall.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this FirewallList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FirewallList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for FirewallList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.FirewallList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        FirewallList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.FirewallList";
                        };
    
                        return FirewallList;
                    })();
    
                    v1.FirewallLogConfig = (function() {
    
                        /**
                         * Properties of a FirewallLogConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface IFirewallLogConfig
                         * @property {boolean|null} [enable] FirewallLogConfig enable
                         * @property {string|null} [metadata] FirewallLogConfig metadata
                         */
    
                        /**
                         * Constructs a new FirewallLogConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a FirewallLogConfig.
                         * @implements IFirewallLogConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.IFirewallLogConfig=} [properties] Properties to set
                         */
                        function FirewallLogConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * FirewallLogConfig enable.
                         * @member {boolean|null|undefined} enable
                         * @memberof google.cloud.compute.v1.FirewallLogConfig
                         * @instance
                         */
                        FirewallLogConfig.prototype.enable = null;
    
                        /**
                         * FirewallLogConfig metadata.
                         * @member {string|null|undefined} metadata
                         * @memberof google.cloud.compute.v1.FirewallLogConfig
                         * @instance
                         */
                        FirewallLogConfig.prototype.metadata = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * FirewallLogConfig _enable.
                         * @member {"enable"|undefined} _enable
                         * @memberof google.cloud.compute.v1.FirewallLogConfig
                         * @instance
                         */
                        Object.defineProperty(FirewallLogConfig.prototype, "_enable", {
                            get: $util.oneOfGetter($oneOfFields = ["enable"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallLogConfig _metadata.
                         * @member {"metadata"|undefined} _metadata
                         * @memberof google.cloud.compute.v1.FirewallLogConfig
                         * @instance
                         */
                        Object.defineProperty(FirewallLogConfig.prototype, "_metadata", {
                            get: $util.oneOfGetter($oneOfFields = ["metadata"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new FirewallLogConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.FirewallLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallLogConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.FirewallLogConfig} FirewallLogConfig instance
                         */
                        FirewallLogConfig.create = function create(properties) {
                            return new FirewallLogConfig(properties);
                        };
    
                        /**
                         * Encodes the specified FirewallLogConfig message. Does not implicitly {@link google.cloud.compute.v1.FirewallLogConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.FirewallLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallLogConfig} message FirewallLogConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirewallLogConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.metadata != null && Object.hasOwnProperty.call(message, "metadata"))
                                writer.uint32(/* id 86866735, wireType 2 =*/694933882).string(message.metadata);
                            if (message.enable != null && Object.hasOwnProperty.call(message, "enable"))
                                writer.uint32(/* id 311764355, wireType 0 =*/2494114840).bool(message.enable);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified FirewallLogConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.FirewallLogConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.FirewallLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallLogConfig} message FirewallLogConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirewallLogConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a FirewallLogConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.FirewallLogConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.FirewallLogConfig} FirewallLogConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirewallLogConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.FirewallLogConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 311764355: {
                                        message.enable = reader.bool();
                                        break;
                                    }
                                case 86866735: {
                                        message.metadata = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a FirewallLogConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.FirewallLogConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.FirewallLogConfig} FirewallLogConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirewallLogConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a FirewallLogConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.FirewallLogConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FirewallLogConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.enable != null && message.hasOwnProperty("enable")) {
                                properties._enable = 1;
                                if (typeof message.enable !== "boolean")
                                    return "enable: boolean expected";
                            }
                            if (message.metadata != null && message.hasOwnProperty("metadata")) {
                                properties._metadata = 1;
                                if (!$util.isString(message.metadata))
                                    return "metadata: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a FirewallLogConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.FirewallLogConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.FirewallLogConfig} FirewallLogConfig
                         */
                        FirewallLogConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.FirewallLogConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.FirewallLogConfig();
                            if (object.enable != null)
                                message.enable = Boolean(object.enable);
                            if (object.metadata != null)
                                message.metadata = String(object.metadata);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a FirewallLogConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.FirewallLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.FirewallLogConfig} message FirewallLogConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FirewallLogConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.metadata != null && message.hasOwnProperty("metadata")) {
                                object.metadata = message.metadata;
                                if (options.oneofs)
                                    object._metadata = "metadata";
                            }
                            if (message.enable != null && message.hasOwnProperty("enable")) {
                                object.enable = message.enable;
                                if (options.oneofs)
                                    object._enable = "enable";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this FirewallLogConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.FirewallLogConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FirewallLogConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for FirewallLogConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.FirewallLogConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        FirewallLogConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.FirewallLogConfig";
                        };
    
                        /**
                         * Metadata enum.
                         * @name google.cloud.compute.v1.FirewallLogConfig.Metadata
                         * @enum {number}
                         * @property {number} UNDEFINED_METADATA=0 UNDEFINED_METADATA value
                         * @property {number} EXCLUDE_ALL_METADATA=334519954 EXCLUDE_ALL_METADATA value
                         * @property {number} INCLUDE_ALL_METADATA=164619908 INCLUDE_ALL_METADATA value
                         */
                        FirewallLogConfig.Metadata = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_METADATA"] = 0;
                            values[valuesById[334519954] = "EXCLUDE_ALL_METADATA"] = 334519954;
                            values[valuesById[164619908] = "INCLUDE_ALL_METADATA"] = 164619908;
                            return values;
                        })();
    
                        return FirewallLogConfig;
                    })();
    
                    v1.FirewallPoliciesListAssociationsResponse = (function() {
    
                        /**
                         * Properties of a FirewallPoliciesListAssociationsResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface IFirewallPoliciesListAssociationsResponse
                         * @property {Array.<google.cloud.compute.v1.IFirewallPolicyAssociation>|null} [associations] FirewallPoliciesListAssociationsResponse associations
                         * @property {string|null} [kind] FirewallPoliciesListAssociationsResponse kind
                         */
    
                        /**
                         * Constructs a new FirewallPoliciesListAssociationsResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a FirewallPoliciesListAssociationsResponse.
                         * @implements IFirewallPoliciesListAssociationsResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.IFirewallPoliciesListAssociationsResponse=} [properties] Properties to set
                         */
                        function FirewallPoliciesListAssociationsResponse(properties) {
                            this.associations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * FirewallPoliciesListAssociationsResponse associations.
                         * @member {Array.<google.cloud.compute.v1.IFirewallPolicyAssociation>} associations
                         * @memberof google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse
                         * @instance
                         */
                        FirewallPoliciesListAssociationsResponse.prototype.associations = $util.emptyArray;
    
                        /**
                         * FirewallPoliciesListAssociationsResponse kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse
                         * @instance
                         */
                        FirewallPoliciesListAssociationsResponse.prototype.kind = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * FirewallPoliciesListAssociationsResponse _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse
                         * @instance
                         */
                        Object.defineProperty(FirewallPoliciesListAssociationsResponse.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new FirewallPoliciesListAssociationsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPoliciesListAssociationsResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse} FirewallPoliciesListAssociationsResponse instance
                         */
                        FirewallPoliciesListAssociationsResponse.create = function create(properties) {
                            return new FirewallPoliciesListAssociationsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified FirewallPoliciesListAssociationsResponse message. Does not implicitly {@link google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPoliciesListAssociationsResponse} message FirewallPoliciesListAssociationsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirewallPoliciesListAssociationsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.associations != null && message.associations.length)
                                for (var i = 0; i < message.associations.length; ++i)
                                    $root.google.cloud.compute.v1.FirewallPolicyAssociation.encode(message.associations[i], writer.uint32(/* id 508736530, wireType 2 =*/4069892242).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified FirewallPoliciesListAssociationsResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPoliciesListAssociationsResponse} message FirewallPoliciesListAssociationsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirewallPoliciesListAssociationsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a FirewallPoliciesListAssociationsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse} FirewallPoliciesListAssociationsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirewallPoliciesListAssociationsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 508736530: {
                                        if (!(message.associations && message.associations.length))
                                            message.associations = [];
                                        message.associations.push($root.google.cloud.compute.v1.FirewallPolicyAssociation.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a FirewallPoliciesListAssociationsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse} FirewallPoliciesListAssociationsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirewallPoliciesListAssociationsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a FirewallPoliciesListAssociationsResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FirewallPoliciesListAssociationsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.associations != null && message.hasOwnProperty("associations")) {
                                if (!Array.isArray(message.associations))
                                    return "associations: array expected";
                                for (var i = 0; i < message.associations.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.FirewallPolicyAssociation.verify(message.associations[i]);
                                    if (error)
                                        return "associations." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a FirewallPoliciesListAssociationsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse} FirewallPoliciesListAssociationsResponse
                         */
                        FirewallPoliciesListAssociationsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse)
                                return object;
                            var message = new $root.google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse();
                            if (object.associations) {
                                if (!Array.isArray(object.associations))
                                    throw TypeError(".google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse.associations: array expected");
                                message.associations = [];
                                for (var i = 0; i < object.associations.length; ++i) {
                                    if (typeof object.associations[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse.associations: object expected");
                                    message.associations[i] = $root.google.cloud.compute.v1.FirewallPolicyAssociation.fromObject(object.associations[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a FirewallPoliciesListAssociationsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse
                         * @static
                         * @param {google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse} message FirewallPoliciesListAssociationsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FirewallPoliciesListAssociationsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.associations = [];
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.associations && message.associations.length) {
                                object.associations = [];
                                for (var j = 0; j < message.associations.length; ++j)
                                    object.associations[j] = $root.google.cloud.compute.v1.FirewallPolicyAssociation.toObject(message.associations[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this FirewallPoliciesListAssociationsResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FirewallPoliciesListAssociationsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for FirewallPoliciesListAssociationsResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        FirewallPoliciesListAssociationsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse";
                        };
    
                        return FirewallPoliciesListAssociationsResponse;
                    })();
    
                    v1.FirewallPolicy = (function() {
    
                        /**
                         * Properties of a FirewallPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IFirewallPolicy
                         * @property {Array.<google.cloud.compute.v1.IFirewallPolicyAssociation>|null} [associations] FirewallPolicy associations
                         * @property {string|null} [creationTimestamp] FirewallPolicy creationTimestamp
                         * @property {string|null} [description] FirewallPolicy description
                         * @property {string|null} [displayName] FirewallPolicy displayName
                         * @property {string|null} [fingerprint] FirewallPolicy fingerprint
                         * @property {number|Long|null} [id] FirewallPolicy id
                         * @property {string|null} [kind] FirewallPolicy kind
                         * @property {string|null} [name] FirewallPolicy name
                         * @property {string|null} [parent] FirewallPolicy parent
                         * @property {string|null} [region] FirewallPolicy region
                         * @property {number|null} [ruleTupleCount] FirewallPolicy ruleTupleCount
                         * @property {Array.<google.cloud.compute.v1.IFirewallPolicyRule>|null} [rules] FirewallPolicy rules
                         * @property {string|null} [selfLink] FirewallPolicy selfLink
                         * @property {string|null} [selfLinkWithId] FirewallPolicy selfLinkWithId
                         * @property {string|null} [shortName] FirewallPolicy shortName
                         */
    
                        /**
                         * Constructs a new FirewallPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a FirewallPolicy.
                         * @implements IFirewallPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IFirewallPolicy=} [properties] Properties to set
                         */
                        function FirewallPolicy(properties) {
                            this.associations = [];
                            this.rules = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * FirewallPolicy associations.
                         * @member {Array.<google.cloud.compute.v1.IFirewallPolicyAssociation>} associations
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        FirewallPolicy.prototype.associations = $util.emptyArray;
    
                        /**
                         * FirewallPolicy creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        FirewallPolicy.prototype.creationTimestamp = null;
    
                        /**
                         * FirewallPolicy description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        FirewallPolicy.prototype.description = null;
    
                        /**
                         * FirewallPolicy displayName.
                         * @member {string|null|undefined} displayName
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        FirewallPolicy.prototype.displayName = null;
    
                        /**
                         * FirewallPolicy fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        FirewallPolicy.prototype.fingerprint = null;
    
                        /**
                         * FirewallPolicy id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        FirewallPolicy.prototype.id = null;
    
                        /**
                         * FirewallPolicy kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        FirewallPolicy.prototype.kind = null;
    
                        /**
                         * FirewallPolicy name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        FirewallPolicy.prototype.name = null;
    
                        /**
                         * FirewallPolicy parent.
                         * @member {string|null|undefined} parent
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        FirewallPolicy.prototype.parent = null;
    
                        /**
                         * FirewallPolicy region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        FirewallPolicy.prototype.region = null;
    
                        /**
                         * FirewallPolicy ruleTupleCount.
                         * @member {number|null|undefined} ruleTupleCount
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        FirewallPolicy.prototype.ruleTupleCount = null;
    
                        /**
                         * FirewallPolicy rules.
                         * @member {Array.<google.cloud.compute.v1.IFirewallPolicyRule>} rules
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        FirewallPolicy.prototype.rules = $util.emptyArray;
    
                        /**
                         * FirewallPolicy selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        FirewallPolicy.prototype.selfLink = null;
    
                        /**
                         * FirewallPolicy selfLinkWithId.
                         * @member {string|null|undefined} selfLinkWithId
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        FirewallPolicy.prototype.selfLinkWithId = null;
    
                        /**
                         * FirewallPolicy shortName.
                         * @member {string|null|undefined} shortName
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        FirewallPolicy.prototype.shortName = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * FirewallPolicy _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicy.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicy _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicy.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicy _displayName.
                         * @member {"displayName"|undefined} _displayName
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicy.prototype, "_displayName", {
                            get: $util.oneOfGetter($oneOfFields = ["displayName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicy _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicy.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicy _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicy.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicy _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicy.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicy _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicy.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicy _parent.
                         * @member {"parent"|undefined} _parent
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicy.prototype, "_parent", {
                            get: $util.oneOfGetter($oneOfFields = ["parent"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicy _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicy.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicy _ruleTupleCount.
                         * @member {"ruleTupleCount"|undefined} _ruleTupleCount
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicy.prototype, "_ruleTupleCount", {
                            get: $util.oneOfGetter($oneOfFields = ["ruleTupleCount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicy _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicy.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicy _selfLinkWithId.
                         * @member {"selfLinkWithId"|undefined} _selfLinkWithId
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicy.prototype, "_selfLinkWithId", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLinkWithId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicy _shortName.
                         * @member {"shortName"|undefined} _shortName
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicy.prototype, "_shortName", {
                            get: $util.oneOfGetter($oneOfFields = ["shortName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new FirewallPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.FirewallPolicy} FirewallPolicy instance
                         */
                        FirewallPolicy.create = function create(properties) {
                            return new FirewallPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified FirewallPolicy message. Does not implicitly {@link google.cloud.compute.v1.FirewallPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicy} message FirewallPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirewallPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 4473832, wireType 2 =*/35790658).string(message.displayName);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.selfLinkWithId != null && Object.hasOwnProperty.call(message, "selfLinkWithId"))
                                writer.uint32(/* id 44520962, wireType 2 =*/356167698).string(message.selfLinkWithId);
                            if (message.parent != null && Object.hasOwnProperty.call(message, "parent"))
                                writer.uint32(/* id 78317738, wireType 2 =*/626541906).string(message.parent);
                            if (message.rules != null && message.rules.length)
                                for (var i = 0; i < message.rules.length; ++i)
                                    $root.google.cloud.compute.v1.FirewallPolicyRule.encode(message.rules[i], writer.uint32(/* id 108873975, wireType 2 =*/870991802).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.ruleTupleCount != null && Object.hasOwnProperty.call(message, "ruleTupleCount"))
                                writer.uint32(/* id 388342037, wireType 0 =*/3106736296).int32(message.ruleTupleCount);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.shortName != null && Object.hasOwnProperty.call(message, "shortName"))
                                writer.uint32(/* id 492051566, wireType 2 =*/3936412530).string(message.shortName);
                            if (message.associations != null && message.associations.length)
                                for (var i = 0; i < message.associations.length; ++i)
                                    $root.google.cloud.compute.v1.FirewallPolicyAssociation.encode(message.associations[i], writer.uint32(/* id 508736530, wireType 2 =*/4069892242).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified FirewallPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.FirewallPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicy} message FirewallPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirewallPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a FirewallPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.FirewallPolicy} FirewallPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirewallPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.FirewallPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 508736530: {
                                        if (!(message.associations && message.associations.length))
                                            message.associations = [];
                                        message.associations.push($root.google.cloud.compute.v1.FirewallPolicyAssociation.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 4473832: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 78317738: {
                                        message.parent = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 388342037: {
                                        message.ruleTupleCount = reader.int32();
                                        break;
                                    }
                                case 108873975: {
                                        if (!(message.rules && message.rules.length))
                                            message.rules = [];
                                        message.rules.push($root.google.cloud.compute.v1.FirewallPolicyRule.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 44520962: {
                                        message.selfLinkWithId = reader.string();
                                        break;
                                    }
                                case 492051566: {
                                        message.shortName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a FirewallPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.FirewallPolicy} FirewallPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirewallPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a FirewallPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FirewallPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.associations != null && message.hasOwnProperty("associations")) {
                                if (!Array.isArray(message.associations))
                                    return "associations: array expected";
                                for (var i = 0; i < message.associations.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.FirewallPolicyAssociation.verify(message.associations[i]);
                                    if (error)
                                        return "associations." + error;
                                }
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.displayName != null && message.hasOwnProperty("displayName")) {
                                properties._displayName = 1;
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent")) {
                                properties._parent = 1;
                                if (!$util.isString(message.parent))
                                    return "parent: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.ruleTupleCount != null && message.hasOwnProperty("ruleTupleCount")) {
                                properties._ruleTupleCount = 1;
                                if (!$util.isInteger(message.ruleTupleCount))
                                    return "ruleTupleCount: integer expected";
                            }
                            if (message.rules != null && message.hasOwnProperty("rules")) {
                                if (!Array.isArray(message.rules))
                                    return "rules: array expected";
                                for (var i = 0; i < message.rules.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.FirewallPolicyRule.verify(message.rules[i]);
                                    if (error)
                                        return "rules." + error;
                                }
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.selfLinkWithId != null && message.hasOwnProperty("selfLinkWithId")) {
                                properties._selfLinkWithId = 1;
                                if (!$util.isString(message.selfLinkWithId))
                                    return "selfLinkWithId: string expected";
                            }
                            if (message.shortName != null && message.hasOwnProperty("shortName")) {
                                properties._shortName = 1;
                                if (!$util.isString(message.shortName))
                                    return "shortName: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a FirewallPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.FirewallPolicy} FirewallPolicy
                         */
                        FirewallPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.FirewallPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.FirewallPolicy();
                            if (object.associations) {
                                if (!Array.isArray(object.associations))
                                    throw TypeError(".google.cloud.compute.v1.FirewallPolicy.associations: array expected");
                                message.associations = [];
                                for (var i = 0; i < object.associations.length; ++i) {
                                    if (typeof object.associations[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.FirewallPolicy.associations: object expected");
                                    message.associations[i] = $root.google.cloud.compute.v1.FirewallPolicyAssociation.fromObject(object.associations[i]);
                                }
                            }
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.parent != null)
                                message.parent = String(object.parent);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.ruleTupleCount != null)
                                message.ruleTupleCount = object.ruleTupleCount | 0;
                            if (object.rules) {
                                if (!Array.isArray(object.rules))
                                    throw TypeError(".google.cloud.compute.v1.FirewallPolicy.rules: array expected");
                                message.rules = [];
                                for (var i = 0; i < object.rules.length; ++i) {
                                    if (typeof object.rules[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.FirewallPolicy.rules: object expected");
                                    message.rules[i] = $root.google.cloud.compute.v1.FirewallPolicyRule.fromObject(object.rules[i]);
                                }
                            }
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.selfLinkWithId != null)
                                message.selfLinkWithId = String(object.selfLinkWithId);
                            if (object.shortName != null)
                                message.shortName = String(object.shortName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a FirewallPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @static
                         * @param {google.cloud.compute.v1.FirewallPolicy} message FirewallPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FirewallPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.rules = [];
                                object.associations = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.displayName != null && message.hasOwnProperty("displayName")) {
                                object.displayName = message.displayName;
                                if (options.oneofs)
                                    object._displayName = "displayName";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.selfLinkWithId != null && message.hasOwnProperty("selfLinkWithId")) {
                                object.selfLinkWithId = message.selfLinkWithId;
                                if (options.oneofs)
                                    object._selfLinkWithId = "selfLinkWithId";
                            }
                            if (message.parent != null && message.hasOwnProperty("parent")) {
                                object.parent = message.parent;
                                if (options.oneofs)
                                    object._parent = "parent";
                            }
                            if (message.rules && message.rules.length) {
                                object.rules = [];
                                for (var j = 0; j < message.rules.length; ++j)
                                    object.rules[j] = $root.google.cloud.compute.v1.FirewallPolicyRule.toObject(message.rules[j], options);
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.ruleTupleCount != null && message.hasOwnProperty("ruleTupleCount")) {
                                object.ruleTupleCount = message.ruleTupleCount;
                                if (options.oneofs)
                                    object._ruleTupleCount = "ruleTupleCount";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.shortName != null && message.hasOwnProperty("shortName")) {
                                object.shortName = message.shortName;
                                if (options.oneofs)
                                    object._shortName = "shortName";
                            }
                            if (message.associations && message.associations.length) {
                                object.associations = [];
                                for (var j = 0; j < message.associations.length; ++j)
                                    object.associations[j] = $root.google.cloud.compute.v1.FirewallPolicyAssociation.toObject(message.associations[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this FirewallPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FirewallPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for FirewallPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.FirewallPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        FirewallPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.FirewallPolicy";
                        };
    
                        return FirewallPolicy;
                    })();
    
                    v1.FirewallPolicyAssociation = (function() {
    
                        /**
                         * Properties of a FirewallPolicyAssociation.
                         * @memberof google.cloud.compute.v1
                         * @interface IFirewallPolicyAssociation
                         * @property {string|null} [attachmentTarget] FirewallPolicyAssociation attachmentTarget
                         * @property {string|null} [displayName] FirewallPolicyAssociation displayName
                         * @property {string|null} [firewallPolicyId] FirewallPolicyAssociation firewallPolicyId
                         * @property {string|null} [name] FirewallPolicyAssociation name
                         * @property {string|null} [shortName] FirewallPolicyAssociation shortName
                         */
    
                        /**
                         * Constructs a new FirewallPolicyAssociation.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a FirewallPolicyAssociation.
                         * @implements IFirewallPolicyAssociation
                         * @constructor
                         * @param {google.cloud.compute.v1.IFirewallPolicyAssociation=} [properties] Properties to set
                         */
                        function FirewallPolicyAssociation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * FirewallPolicyAssociation attachmentTarget.
                         * @member {string|null|undefined} attachmentTarget
                         * @memberof google.cloud.compute.v1.FirewallPolicyAssociation
                         * @instance
                         */
                        FirewallPolicyAssociation.prototype.attachmentTarget = null;
    
                        /**
                         * FirewallPolicyAssociation displayName.
                         * @member {string|null|undefined} displayName
                         * @memberof google.cloud.compute.v1.FirewallPolicyAssociation
                         * @instance
                         */
                        FirewallPolicyAssociation.prototype.displayName = null;
    
                        /**
                         * FirewallPolicyAssociation firewallPolicyId.
                         * @member {string|null|undefined} firewallPolicyId
                         * @memberof google.cloud.compute.v1.FirewallPolicyAssociation
                         * @instance
                         */
                        FirewallPolicyAssociation.prototype.firewallPolicyId = null;
    
                        /**
                         * FirewallPolicyAssociation name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.FirewallPolicyAssociation
                         * @instance
                         */
                        FirewallPolicyAssociation.prototype.name = null;
    
                        /**
                         * FirewallPolicyAssociation shortName.
                         * @member {string|null|undefined} shortName
                         * @memberof google.cloud.compute.v1.FirewallPolicyAssociation
                         * @instance
                         */
                        FirewallPolicyAssociation.prototype.shortName = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * FirewallPolicyAssociation _attachmentTarget.
                         * @member {"attachmentTarget"|undefined} _attachmentTarget
                         * @memberof google.cloud.compute.v1.FirewallPolicyAssociation
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyAssociation.prototype, "_attachmentTarget", {
                            get: $util.oneOfGetter($oneOfFields = ["attachmentTarget"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicyAssociation _displayName.
                         * @member {"displayName"|undefined} _displayName
                         * @memberof google.cloud.compute.v1.FirewallPolicyAssociation
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyAssociation.prototype, "_displayName", {
                            get: $util.oneOfGetter($oneOfFields = ["displayName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicyAssociation _firewallPolicyId.
                         * @member {"firewallPolicyId"|undefined} _firewallPolicyId
                         * @memberof google.cloud.compute.v1.FirewallPolicyAssociation
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyAssociation.prototype, "_firewallPolicyId", {
                            get: $util.oneOfGetter($oneOfFields = ["firewallPolicyId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicyAssociation _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.FirewallPolicyAssociation
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyAssociation.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicyAssociation _shortName.
                         * @member {"shortName"|undefined} _shortName
                         * @memberof google.cloud.compute.v1.FirewallPolicyAssociation
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyAssociation.prototype, "_shortName", {
                            get: $util.oneOfGetter($oneOfFields = ["shortName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new FirewallPolicyAssociation instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.FirewallPolicyAssociation
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicyAssociation=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.FirewallPolicyAssociation} FirewallPolicyAssociation instance
                         */
                        FirewallPolicyAssociation.create = function create(properties) {
                            return new FirewallPolicyAssociation(properties);
                        };
    
                        /**
                         * Encodes the specified FirewallPolicyAssociation message. Does not implicitly {@link google.cloud.compute.v1.FirewallPolicyAssociation.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.FirewallPolicyAssociation
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicyAssociation} message FirewallPolicyAssociation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirewallPolicyAssociation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 4473832, wireType 2 =*/35790658).string(message.displayName);
                            if (message.attachmentTarget != null && Object.hasOwnProperty.call(message, "attachmentTarget"))
                                writer.uint32(/* id 175773741, wireType 2 =*/1406189930).string(message.attachmentTarget);
                            if (message.firewallPolicyId != null && Object.hasOwnProperty.call(message, "firewallPolicyId"))
                                writer.uint32(/* id 357211849, wireType 2 =*/2857694794).string(message.firewallPolicyId);
                            if (message.shortName != null && Object.hasOwnProperty.call(message, "shortName"))
                                writer.uint32(/* id 492051566, wireType 2 =*/3936412530).string(message.shortName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified FirewallPolicyAssociation message, length delimited. Does not implicitly {@link google.cloud.compute.v1.FirewallPolicyAssociation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.FirewallPolicyAssociation
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicyAssociation} message FirewallPolicyAssociation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirewallPolicyAssociation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a FirewallPolicyAssociation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.FirewallPolicyAssociation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.FirewallPolicyAssociation} FirewallPolicyAssociation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirewallPolicyAssociation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.FirewallPolicyAssociation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 175773741: {
                                        message.attachmentTarget = reader.string();
                                        break;
                                    }
                                case 4473832: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 357211849: {
                                        message.firewallPolicyId = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 492051566: {
                                        message.shortName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a FirewallPolicyAssociation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.FirewallPolicyAssociation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.FirewallPolicyAssociation} FirewallPolicyAssociation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirewallPolicyAssociation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a FirewallPolicyAssociation message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.FirewallPolicyAssociation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FirewallPolicyAssociation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.attachmentTarget != null && message.hasOwnProperty("attachmentTarget")) {
                                properties._attachmentTarget = 1;
                                if (!$util.isString(message.attachmentTarget))
                                    return "attachmentTarget: string expected";
                            }
                            if (message.displayName != null && message.hasOwnProperty("displayName")) {
                                properties._displayName = 1;
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            }
                            if (message.firewallPolicyId != null && message.hasOwnProperty("firewallPolicyId")) {
                                properties._firewallPolicyId = 1;
                                if (!$util.isString(message.firewallPolicyId))
                                    return "firewallPolicyId: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.shortName != null && message.hasOwnProperty("shortName")) {
                                properties._shortName = 1;
                                if (!$util.isString(message.shortName))
                                    return "shortName: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a FirewallPolicyAssociation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.FirewallPolicyAssociation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.FirewallPolicyAssociation} FirewallPolicyAssociation
                         */
                        FirewallPolicyAssociation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.FirewallPolicyAssociation)
                                return object;
                            var message = new $root.google.cloud.compute.v1.FirewallPolicyAssociation();
                            if (object.attachmentTarget != null)
                                message.attachmentTarget = String(object.attachmentTarget);
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.firewallPolicyId != null)
                                message.firewallPolicyId = String(object.firewallPolicyId);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.shortName != null)
                                message.shortName = String(object.shortName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a FirewallPolicyAssociation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.FirewallPolicyAssociation
                         * @static
                         * @param {google.cloud.compute.v1.FirewallPolicyAssociation} message FirewallPolicyAssociation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FirewallPolicyAssociation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.displayName != null && message.hasOwnProperty("displayName")) {
                                object.displayName = message.displayName;
                                if (options.oneofs)
                                    object._displayName = "displayName";
                            }
                            if (message.attachmentTarget != null && message.hasOwnProperty("attachmentTarget")) {
                                object.attachmentTarget = message.attachmentTarget;
                                if (options.oneofs)
                                    object._attachmentTarget = "attachmentTarget";
                            }
                            if (message.firewallPolicyId != null && message.hasOwnProperty("firewallPolicyId")) {
                                object.firewallPolicyId = message.firewallPolicyId;
                                if (options.oneofs)
                                    object._firewallPolicyId = "firewallPolicyId";
                            }
                            if (message.shortName != null && message.hasOwnProperty("shortName")) {
                                object.shortName = message.shortName;
                                if (options.oneofs)
                                    object._shortName = "shortName";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this FirewallPolicyAssociation to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.FirewallPolicyAssociation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FirewallPolicyAssociation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for FirewallPolicyAssociation
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.FirewallPolicyAssociation
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        FirewallPolicyAssociation.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.FirewallPolicyAssociation";
                        };
    
                        return FirewallPolicyAssociation;
                    })();
    
                    v1.FirewallPolicyList = (function() {
    
                        /**
                         * Properties of a FirewallPolicyList.
                         * @memberof google.cloud.compute.v1
                         * @interface IFirewallPolicyList
                         * @property {string|null} [id] FirewallPolicyList id
                         * @property {Array.<google.cloud.compute.v1.IFirewallPolicy>|null} [items] FirewallPolicyList items
                         * @property {string|null} [kind] FirewallPolicyList kind
                         * @property {string|null} [nextPageToken] FirewallPolicyList nextPageToken
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] FirewallPolicyList warning
                         */
    
                        /**
                         * Constructs a new FirewallPolicyList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a FirewallPolicyList.
                         * @implements IFirewallPolicyList
                         * @constructor
                         * @param {google.cloud.compute.v1.IFirewallPolicyList=} [properties] Properties to set
                         */
                        function FirewallPolicyList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * FirewallPolicyList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.FirewallPolicyList
                         * @instance
                         */
                        FirewallPolicyList.prototype.id = null;
    
                        /**
                         * FirewallPolicyList items.
                         * @member {Array.<google.cloud.compute.v1.IFirewallPolicy>} items
                         * @memberof google.cloud.compute.v1.FirewallPolicyList
                         * @instance
                         */
                        FirewallPolicyList.prototype.items = $util.emptyArray;
    
                        /**
                         * FirewallPolicyList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.FirewallPolicyList
                         * @instance
                         */
                        FirewallPolicyList.prototype.kind = null;
    
                        /**
                         * FirewallPolicyList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.FirewallPolicyList
                         * @instance
                         */
                        FirewallPolicyList.prototype.nextPageToken = null;
    
                        /**
                         * FirewallPolicyList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.FirewallPolicyList
                         * @instance
                         */
                        FirewallPolicyList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * FirewallPolicyList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.FirewallPolicyList
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicyList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.FirewallPolicyList
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicyList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.FirewallPolicyList
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicyList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.FirewallPolicyList
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new FirewallPolicyList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.FirewallPolicyList
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicyList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.FirewallPolicyList} FirewallPolicyList instance
                         */
                        FirewallPolicyList.create = function create(properties) {
                            return new FirewallPolicyList(properties);
                        };
    
                        /**
                         * Encodes the specified FirewallPolicyList message. Does not implicitly {@link google.cloud.compute.v1.FirewallPolicyList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.FirewallPolicyList
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicyList} message FirewallPolicyList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirewallPolicyList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.FirewallPolicy.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified FirewallPolicyList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.FirewallPolicyList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.FirewallPolicyList
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicyList} message FirewallPolicyList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirewallPolicyList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a FirewallPolicyList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.FirewallPolicyList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.FirewallPolicyList} FirewallPolicyList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirewallPolicyList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.FirewallPolicyList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.FirewallPolicy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a FirewallPolicyList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.FirewallPolicyList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.FirewallPolicyList} FirewallPolicyList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirewallPolicyList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a FirewallPolicyList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.FirewallPolicyList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FirewallPolicyList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.FirewallPolicy.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a FirewallPolicyList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.FirewallPolicyList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.FirewallPolicyList} FirewallPolicyList
                         */
                        FirewallPolicyList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.FirewallPolicyList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.FirewallPolicyList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.FirewallPolicyList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.FirewallPolicyList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.FirewallPolicy.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.FirewallPolicyList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a FirewallPolicyList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.FirewallPolicyList
                         * @static
                         * @param {google.cloud.compute.v1.FirewallPolicyList} message FirewallPolicyList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FirewallPolicyList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.FirewallPolicy.toObject(message.items[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this FirewallPolicyList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.FirewallPolicyList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FirewallPolicyList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for FirewallPolicyList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.FirewallPolicyList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        FirewallPolicyList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.FirewallPolicyList";
                        };
    
                        return FirewallPolicyList;
                    })();
    
                    v1.FirewallPolicyRule = (function() {
    
                        /**
                         * Properties of a FirewallPolicyRule.
                         * @memberof google.cloud.compute.v1
                         * @interface IFirewallPolicyRule
                         * @property {string|null} [action] FirewallPolicyRule action
                         * @property {string|null} [description] FirewallPolicyRule description
                         * @property {string|null} [direction] FirewallPolicyRule direction
                         * @property {boolean|null} [disabled] FirewallPolicyRule disabled
                         * @property {boolean|null} [enableLogging] FirewallPolicyRule enableLogging
                         * @property {string|null} [kind] FirewallPolicyRule kind
                         * @property {google.cloud.compute.v1.IFirewallPolicyRuleMatcher|null} [match] FirewallPolicyRule match
                         * @property {number|null} [priority] FirewallPolicyRule priority
                         * @property {string|null} [ruleName] FirewallPolicyRule ruleName
                         * @property {number|null} [ruleTupleCount] FirewallPolicyRule ruleTupleCount
                         * @property {Array.<string>|null} [targetResources] FirewallPolicyRule targetResources
                         * @property {Array.<google.cloud.compute.v1.IFirewallPolicyRuleSecureTag>|null} [targetSecureTags] FirewallPolicyRule targetSecureTags
                         * @property {Array.<string>|null} [targetServiceAccounts] FirewallPolicyRule targetServiceAccounts
                         */
    
                        /**
                         * Constructs a new FirewallPolicyRule.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a FirewallPolicyRule.
                         * @implements IFirewallPolicyRule
                         * @constructor
                         * @param {google.cloud.compute.v1.IFirewallPolicyRule=} [properties] Properties to set
                         */
                        function FirewallPolicyRule(properties) {
                            this.targetResources = [];
                            this.targetSecureTags = [];
                            this.targetServiceAccounts = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * FirewallPolicyRule action.
                         * @member {string|null|undefined} action
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        FirewallPolicyRule.prototype.action = null;
    
                        /**
                         * FirewallPolicyRule description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        FirewallPolicyRule.prototype.description = null;
    
                        /**
                         * FirewallPolicyRule direction.
                         * @member {string|null|undefined} direction
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        FirewallPolicyRule.prototype.direction = null;
    
                        /**
                         * FirewallPolicyRule disabled.
                         * @member {boolean|null|undefined} disabled
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        FirewallPolicyRule.prototype.disabled = null;
    
                        /**
                         * FirewallPolicyRule enableLogging.
                         * @member {boolean|null|undefined} enableLogging
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        FirewallPolicyRule.prototype.enableLogging = null;
    
                        /**
                         * FirewallPolicyRule kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        FirewallPolicyRule.prototype.kind = null;
    
                        /**
                         * FirewallPolicyRule match.
                         * @member {google.cloud.compute.v1.IFirewallPolicyRuleMatcher|null|undefined} match
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        FirewallPolicyRule.prototype.match = null;
    
                        /**
                         * FirewallPolicyRule priority.
                         * @member {number|null|undefined} priority
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        FirewallPolicyRule.prototype.priority = null;
    
                        /**
                         * FirewallPolicyRule ruleName.
                         * @member {string|null|undefined} ruleName
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        FirewallPolicyRule.prototype.ruleName = null;
    
                        /**
                         * FirewallPolicyRule ruleTupleCount.
                         * @member {number|null|undefined} ruleTupleCount
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        FirewallPolicyRule.prototype.ruleTupleCount = null;
    
                        /**
                         * FirewallPolicyRule targetResources.
                         * @member {Array.<string>} targetResources
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        FirewallPolicyRule.prototype.targetResources = $util.emptyArray;
    
                        /**
                         * FirewallPolicyRule targetSecureTags.
                         * @member {Array.<google.cloud.compute.v1.IFirewallPolicyRuleSecureTag>} targetSecureTags
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        FirewallPolicyRule.prototype.targetSecureTags = $util.emptyArray;
    
                        /**
                         * FirewallPolicyRule targetServiceAccounts.
                         * @member {Array.<string>} targetServiceAccounts
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        FirewallPolicyRule.prototype.targetServiceAccounts = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * FirewallPolicyRule _action.
                         * @member {"action"|undefined} _action
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyRule.prototype, "_action", {
                            get: $util.oneOfGetter($oneOfFields = ["action"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicyRule _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyRule.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicyRule _direction.
                         * @member {"direction"|undefined} _direction
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyRule.prototype, "_direction", {
                            get: $util.oneOfGetter($oneOfFields = ["direction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicyRule _disabled.
                         * @member {"disabled"|undefined} _disabled
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyRule.prototype, "_disabled", {
                            get: $util.oneOfGetter($oneOfFields = ["disabled"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicyRule _enableLogging.
                         * @member {"enableLogging"|undefined} _enableLogging
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyRule.prototype, "_enableLogging", {
                            get: $util.oneOfGetter($oneOfFields = ["enableLogging"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicyRule _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyRule.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicyRule _match.
                         * @member {"match"|undefined} _match
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyRule.prototype, "_match", {
                            get: $util.oneOfGetter($oneOfFields = ["match"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicyRule _priority.
                         * @member {"priority"|undefined} _priority
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyRule.prototype, "_priority", {
                            get: $util.oneOfGetter($oneOfFields = ["priority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicyRule _ruleName.
                         * @member {"ruleName"|undefined} _ruleName
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyRule.prototype, "_ruleName", {
                            get: $util.oneOfGetter($oneOfFields = ["ruleName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicyRule _ruleTupleCount.
                         * @member {"ruleTupleCount"|undefined} _ruleTupleCount
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyRule.prototype, "_ruleTupleCount", {
                            get: $util.oneOfGetter($oneOfFields = ["ruleTupleCount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new FirewallPolicyRule instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicyRule=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.FirewallPolicyRule} FirewallPolicyRule instance
                         */
                        FirewallPolicyRule.create = function create(properties) {
                            return new FirewallPolicyRule(properties);
                        };
    
                        /**
                         * Encodes the specified FirewallPolicyRule message. Does not implicitly {@link google.cloud.compute.v1.FirewallPolicyRule.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicyRule} message FirewallPolicyRule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirewallPolicyRule.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.ruleName != null && Object.hasOwnProperty.call(message, "ruleName"))
                                writer.uint32(/* id 55286254, wireType 2 =*/442290034).string(message.ruleName);
                            if (message.match != null && Object.hasOwnProperty.call(message, "match"))
                                $root.google.cloud.compute.v1.FirewallPolicyRuleMatcher.encode(message.match, writer.uint32(/* id 103668165, wireType 2 =*/829345322).fork()).ldelim();
                            if (message.direction != null && Object.hasOwnProperty.call(message, "direction"))
                                writer.uint32(/* id 111150975, wireType 2 =*/889207802).string(message.direction);
                            if (message.action != null && Object.hasOwnProperty.call(message, "action"))
                                writer.uint32(/* id 187661878, wireType 2 =*/1501295026).string(message.action);
                            if (message.disabled != null && Object.hasOwnProperty.call(message, "disabled"))
                                writer.uint32(/* id 270940796, wireType 0 =*/2167526368).bool(message.disabled);
                            if (message.enableLogging != null && Object.hasOwnProperty.call(message, "enableLogging"))
                                writer.uint32(/* id 295396515, wireType 0 =*/2363172120).bool(message.enableLogging);
                            if (message.ruleTupleCount != null && Object.hasOwnProperty.call(message, "ruleTupleCount"))
                                writer.uint32(/* id 388342037, wireType 0 =*/3106736296).int32(message.ruleTupleCount);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.priority != null && Object.hasOwnProperty.call(message, "priority"))
                                writer.uint32(/* id 445151652, wireType 0 =*/3561213216).int32(message.priority);
                            if (message.targetServiceAccounts != null && message.targetServiceAccounts.length)
                                for (var i = 0; i < message.targetServiceAccounts.length; ++i)
                                    writer.uint32(/* id 457639710, wireType 2 =*/3661117682).string(message.targetServiceAccounts[i]);
                            if (message.targetSecureTags != null && message.targetSecureTags.length)
                                for (var i = 0; i < message.targetSecureTags.length; ++i)
                                    $root.google.cloud.compute.v1.FirewallPolicyRuleSecureTag.encode(message.targetSecureTags[i], writer.uint32(/* id 468132403, wireType 2 =*/3745059226).fork()).ldelim();
                            if (message.targetResources != null && message.targetResources.length)
                                for (var i = 0; i < message.targetResources.length; ++i)
                                    writer.uint32(/* id 528230647, wireType 2 =*/4225845178).string(message.targetResources[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified FirewallPolicyRule message, length delimited. Does not implicitly {@link google.cloud.compute.v1.FirewallPolicyRule.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicyRule} message FirewallPolicyRule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirewallPolicyRule.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a FirewallPolicyRule message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.FirewallPolicyRule} FirewallPolicyRule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirewallPolicyRule.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.FirewallPolicyRule();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 187661878: {
                                        message.action = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 111150975: {
                                        message.direction = reader.string();
                                        break;
                                    }
                                case 270940796: {
                                        message.disabled = reader.bool();
                                        break;
                                    }
                                case 295396515: {
                                        message.enableLogging = reader.bool();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 103668165: {
                                        message.match = $root.google.cloud.compute.v1.FirewallPolicyRuleMatcher.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 445151652: {
                                        message.priority = reader.int32();
                                        break;
                                    }
                                case 55286254: {
                                        message.ruleName = reader.string();
                                        break;
                                    }
                                case 388342037: {
                                        message.ruleTupleCount = reader.int32();
                                        break;
                                    }
                                case 528230647: {
                                        if (!(message.targetResources && message.targetResources.length))
                                            message.targetResources = [];
                                        message.targetResources.push(reader.string());
                                        break;
                                    }
                                case 468132403: {
                                        if (!(message.targetSecureTags && message.targetSecureTags.length))
                                            message.targetSecureTags = [];
                                        message.targetSecureTags.push($root.google.cloud.compute.v1.FirewallPolicyRuleSecureTag.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 457639710: {
                                        if (!(message.targetServiceAccounts && message.targetServiceAccounts.length))
                                            message.targetServiceAccounts = [];
                                        message.targetServiceAccounts.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a FirewallPolicyRule message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.FirewallPolicyRule} FirewallPolicyRule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirewallPolicyRule.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a FirewallPolicyRule message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FirewallPolicyRule.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.action != null && message.hasOwnProperty("action")) {
                                properties._action = 1;
                                if (!$util.isString(message.action))
                                    return "action: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.direction != null && message.hasOwnProperty("direction")) {
                                properties._direction = 1;
                                if (!$util.isString(message.direction))
                                    return "direction: string expected";
                            }
                            if (message.disabled != null && message.hasOwnProperty("disabled")) {
                                properties._disabled = 1;
                                if (typeof message.disabled !== "boolean")
                                    return "disabled: boolean expected";
                            }
                            if (message.enableLogging != null && message.hasOwnProperty("enableLogging")) {
                                properties._enableLogging = 1;
                                if (typeof message.enableLogging !== "boolean")
                                    return "enableLogging: boolean expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.match != null && message.hasOwnProperty("match")) {
                                properties._match = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.FirewallPolicyRuleMatcher.verify(message.match);
                                    if (error)
                                        return "match." + error;
                                }
                            }
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                properties._priority = 1;
                                if (!$util.isInteger(message.priority))
                                    return "priority: integer expected";
                            }
                            if (message.ruleName != null && message.hasOwnProperty("ruleName")) {
                                properties._ruleName = 1;
                                if (!$util.isString(message.ruleName))
                                    return "ruleName: string expected";
                            }
                            if (message.ruleTupleCount != null && message.hasOwnProperty("ruleTupleCount")) {
                                properties._ruleTupleCount = 1;
                                if (!$util.isInteger(message.ruleTupleCount))
                                    return "ruleTupleCount: integer expected";
                            }
                            if (message.targetResources != null && message.hasOwnProperty("targetResources")) {
                                if (!Array.isArray(message.targetResources))
                                    return "targetResources: array expected";
                                for (var i = 0; i < message.targetResources.length; ++i)
                                    if (!$util.isString(message.targetResources[i]))
                                        return "targetResources: string[] expected";
                            }
                            if (message.targetSecureTags != null && message.hasOwnProperty("targetSecureTags")) {
                                if (!Array.isArray(message.targetSecureTags))
                                    return "targetSecureTags: array expected";
                                for (var i = 0; i < message.targetSecureTags.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.FirewallPolicyRuleSecureTag.verify(message.targetSecureTags[i]);
                                    if (error)
                                        return "targetSecureTags." + error;
                                }
                            }
                            if (message.targetServiceAccounts != null && message.hasOwnProperty("targetServiceAccounts")) {
                                if (!Array.isArray(message.targetServiceAccounts))
                                    return "targetServiceAccounts: array expected";
                                for (var i = 0; i < message.targetServiceAccounts.length; ++i)
                                    if (!$util.isString(message.targetServiceAccounts[i]))
                                        return "targetServiceAccounts: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a FirewallPolicyRule message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.FirewallPolicyRule} FirewallPolicyRule
                         */
                        FirewallPolicyRule.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.FirewallPolicyRule)
                                return object;
                            var message = new $root.google.cloud.compute.v1.FirewallPolicyRule();
                            if (object.action != null)
                                message.action = String(object.action);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.direction != null)
                                message.direction = String(object.direction);
                            if (object.disabled != null)
                                message.disabled = Boolean(object.disabled);
                            if (object.enableLogging != null)
                                message.enableLogging = Boolean(object.enableLogging);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.match != null) {
                                if (typeof object.match !== "object")
                                    throw TypeError(".google.cloud.compute.v1.FirewallPolicyRule.match: object expected");
                                message.match = $root.google.cloud.compute.v1.FirewallPolicyRuleMatcher.fromObject(object.match);
                            }
                            if (object.priority != null)
                                message.priority = object.priority | 0;
                            if (object.ruleName != null)
                                message.ruleName = String(object.ruleName);
                            if (object.ruleTupleCount != null)
                                message.ruleTupleCount = object.ruleTupleCount | 0;
                            if (object.targetResources) {
                                if (!Array.isArray(object.targetResources))
                                    throw TypeError(".google.cloud.compute.v1.FirewallPolicyRule.targetResources: array expected");
                                message.targetResources = [];
                                for (var i = 0; i < object.targetResources.length; ++i)
                                    message.targetResources[i] = String(object.targetResources[i]);
                            }
                            if (object.targetSecureTags) {
                                if (!Array.isArray(object.targetSecureTags))
                                    throw TypeError(".google.cloud.compute.v1.FirewallPolicyRule.targetSecureTags: array expected");
                                message.targetSecureTags = [];
                                for (var i = 0; i < object.targetSecureTags.length; ++i) {
                                    if (typeof object.targetSecureTags[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.FirewallPolicyRule.targetSecureTags: object expected");
                                    message.targetSecureTags[i] = $root.google.cloud.compute.v1.FirewallPolicyRuleSecureTag.fromObject(object.targetSecureTags[i]);
                                }
                            }
                            if (object.targetServiceAccounts) {
                                if (!Array.isArray(object.targetServiceAccounts))
                                    throw TypeError(".google.cloud.compute.v1.FirewallPolicyRule.targetServiceAccounts: array expected");
                                message.targetServiceAccounts = [];
                                for (var i = 0; i < object.targetServiceAccounts.length; ++i)
                                    message.targetServiceAccounts[i] = String(object.targetServiceAccounts[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a FirewallPolicyRule message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @static
                         * @param {google.cloud.compute.v1.FirewallPolicyRule} message FirewallPolicyRule
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FirewallPolicyRule.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.targetServiceAccounts = [];
                                object.targetSecureTags = [];
                                object.targetResources = [];
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.ruleName != null && message.hasOwnProperty("ruleName")) {
                                object.ruleName = message.ruleName;
                                if (options.oneofs)
                                    object._ruleName = "ruleName";
                            }
                            if (message.match != null && message.hasOwnProperty("match")) {
                                object.match = $root.google.cloud.compute.v1.FirewallPolicyRuleMatcher.toObject(message.match, options);
                                if (options.oneofs)
                                    object._match = "match";
                            }
                            if (message.direction != null && message.hasOwnProperty("direction")) {
                                object.direction = message.direction;
                                if (options.oneofs)
                                    object._direction = "direction";
                            }
                            if (message.action != null && message.hasOwnProperty("action")) {
                                object.action = message.action;
                                if (options.oneofs)
                                    object._action = "action";
                            }
                            if (message.disabled != null && message.hasOwnProperty("disabled")) {
                                object.disabled = message.disabled;
                                if (options.oneofs)
                                    object._disabled = "disabled";
                            }
                            if (message.enableLogging != null && message.hasOwnProperty("enableLogging")) {
                                object.enableLogging = message.enableLogging;
                                if (options.oneofs)
                                    object._enableLogging = "enableLogging";
                            }
                            if (message.ruleTupleCount != null && message.hasOwnProperty("ruleTupleCount")) {
                                object.ruleTupleCount = message.ruleTupleCount;
                                if (options.oneofs)
                                    object._ruleTupleCount = "ruleTupleCount";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                object.priority = message.priority;
                                if (options.oneofs)
                                    object._priority = "priority";
                            }
                            if (message.targetServiceAccounts && message.targetServiceAccounts.length) {
                                object.targetServiceAccounts = [];
                                for (var j = 0; j < message.targetServiceAccounts.length; ++j)
                                    object.targetServiceAccounts[j] = message.targetServiceAccounts[j];
                            }
                            if (message.targetSecureTags && message.targetSecureTags.length) {
                                object.targetSecureTags = [];
                                for (var j = 0; j < message.targetSecureTags.length; ++j)
                                    object.targetSecureTags[j] = $root.google.cloud.compute.v1.FirewallPolicyRuleSecureTag.toObject(message.targetSecureTags[j], options);
                            }
                            if (message.targetResources && message.targetResources.length) {
                                object.targetResources = [];
                                for (var j = 0; j < message.targetResources.length; ++j)
                                    object.targetResources[j] = message.targetResources[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this FirewallPolicyRule to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FirewallPolicyRule.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for FirewallPolicyRule
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.FirewallPolicyRule
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        FirewallPolicyRule.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.FirewallPolicyRule";
                        };
    
                        /**
                         * Direction enum.
                         * @name google.cloud.compute.v1.FirewallPolicyRule.Direction
                         * @enum {number}
                         * @property {number} UNDEFINED_DIRECTION=0 UNDEFINED_DIRECTION value
                         * @property {number} EGRESS=432880501 EGRESS value
                         * @property {number} INGRESS=516931221 INGRESS value
                         */
                        FirewallPolicyRule.Direction = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_DIRECTION"] = 0;
                            values[valuesById[432880501] = "EGRESS"] = 432880501;
                            values[valuesById[516931221] = "INGRESS"] = 516931221;
                            return values;
                        })();
    
                        return FirewallPolicyRule;
                    })();
    
                    v1.FirewallPolicyRuleMatcher = (function() {
    
                        /**
                         * Properties of a FirewallPolicyRuleMatcher.
                         * @memberof google.cloud.compute.v1
                         * @interface IFirewallPolicyRuleMatcher
                         * @property {Array.<string>|null} [destIpRanges] FirewallPolicyRuleMatcher destIpRanges
                         * @property {Array.<google.cloud.compute.v1.IFirewallPolicyRuleMatcherLayer4Config>|null} [layer4Configs] FirewallPolicyRuleMatcher layer4Configs
                         * @property {Array.<string>|null} [srcIpRanges] FirewallPolicyRuleMatcher srcIpRanges
                         * @property {Array.<google.cloud.compute.v1.IFirewallPolicyRuleSecureTag>|null} [srcSecureTags] FirewallPolicyRuleMatcher srcSecureTags
                         */
    
                        /**
                         * Constructs a new FirewallPolicyRuleMatcher.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a FirewallPolicyRuleMatcher.
                         * @implements IFirewallPolicyRuleMatcher
                         * @constructor
                         * @param {google.cloud.compute.v1.IFirewallPolicyRuleMatcher=} [properties] Properties to set
                         */
                        function FirewallPolicyRuleMatcher(properties) {
                            this.destIpRanges = [];
                            this.layer4Configs = [];
                            this.srcIpRanges = [];
                            this.srcSecureTags = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * FirewallPolicyRuleMatcher destIpRanges.
                         * @member {Array.<string>} destIpRanges
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcher
                         * @instance
                         */
                        FirewallPolicyRuleMatcher.prototype.destIpRanges = $util.emptyArray;
    
                        /**
                         * FirewallPolicyRuleMatcher layer4Configs.
                         * @member {Array.<google.cloud.compute.v1.IFirewallPolicyRuleMatcherLayer4Config>} layer4Configs
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcher
                         * @instance
                         */
                        FirewallPolicyRuleMatcher.prototype.layer4Configs = $util.emptyArray;
    
                        /**
                         * FirewallPolicyRuleMatcher srcIpRanges.
                         * @member {Array.<string>} srcIpRanges
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcher
                         * @instance
                         */
                        FirewallPolicyRuleMatcher.prototype.srcIpRanges = $util.emptyArray;
    
                        /**
                         * FirewallPolicyRuleMatcher srcSecureTags.
                         * @member {Array.<google.cloud.compute.v1.IFirewallPolicyRuleSecureTag>} srcSecureTags
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcher
                         * @instance
                         */
                        FirewallPolicyRuleMatcher.prototype.srcSecureTags = $util.emptyArray;
    
                        /**
                         * Creates a new FirewallPolicyRuleMatcher instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcher
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicyRuleMatcher=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.FirewallPolicyRuleMatcher} FirewallPolicyRuleMatcher instance
                         */
                        FirewallPolicyRuleMatcher.create = function create(properties) {
                            return new FirewallPolicyRuleMatcher(properties);
                        };
    
                        /**
                         * Encodes the specified FirewallPolicyRuleMatcher message. Does not implicitly {@link google.cloud.compute.v1.FirewallPolicyRuleMatcher.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcher
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicyRuleMatcher} message FirewallPolicyRuleMatcher message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirewallPolicyRuleMatcher.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.destIpRanges != null && message.destIpRanges.length)
                                for (var i = 0; i < message.destIpRanges.length; ++i)
                                    writer.uint32(/* id 337357713, wireType 2 =*/2698861706).string(message.destIpRanges[i]);
                            if (message.layer4Configs != null && message.layer4Configs.length)
                                for (var i = 0; i < message.layer4Configs.length; ++i)
                                    $root.google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config.encode(message.layer4Configs[i], writer.uint32(/* id 373534261, wireType 2 =*/2988274090).fork()).ldelim();
                            if (message.srcIpRanges != null && message.srcIpRanges.length)
                                for (var i = 0; i < message.srcIpRanges.length; ++i)
                                    writer.uint32(/* id 432128083, wireType 2 =*/3457024666).string(message.srcIpRanges[i]);
                            if (message.srcSecureTags != null && message.srcSecureTags.length)
                                for (var i = 0; i < message.srcSecureTags.length; ++i)
                                    $root.google.cloud.compute.v1.FirewallPolicyRuleSecureTag.encode(message.srcSecureTags[i], writer.uint32(/* id 508791302, wireType 2 =*/4070330418).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified FirewallPolicyRuleMatcher message, length delimited. Does not implicitly {@link google.cloud.compute.v1.FirewallPolicyRuleMatcher.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcher
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicyRuleMatcher} message FirewallPolicyRuleMatcher message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirewallPolicyRuleMatcher.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a FirewallPolicyRuleMatcher message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcher
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.FirewallPolicyRuleMatcher} FirewallPolicyRuleMatcher
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirewallPolicyRuleMatcher.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.FirewallPolicyRuleMatcher();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 337357713: {
                                        if (!(message.destIpRanges && message.destIpRanges.length))
                                            message.destIpRanges = [];
                                        message.destIpRanges.push(reader.string());
                                        break;
                                    }
                                case 373534261: {
                                        if (!(message.layer4Configs && message.layer4Configs.length))
                                            message.layer4Configs = [];
                                        message.layer4Configs.push($root.google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 432128083: {
                                        if (!(message.srcIpRanges && message.srcIpRanges.length))
                                            message.srcIpRanges = [];
                                        message.srcIpRanges.push(reader.string());
                                        break;
                                    }
                                case 508791302: {
                                        if (!(message.srcSecureTags && message.srcSecureTags.length))
                                            message.srcSecureTags = [];
                                        message.srcSecureTags.push($root.google.cloud.compute.v1.FirewallPolicyRuleSecureTag.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a FirewallPolicyRuleMatcher message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcher
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.FirewallPolicyRuleMatcher} FirewallPolicyRuleMatcher
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirewallPolicyRuleMatcher.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a FirewallPolicyRuleMatcher message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcher
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FirewallPolicyRuleMatcher.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.destIpRanges != null && message.hasOwnProperty("destIpRanges")) {
                                if (!Array.isArray(message.destIpRanges))
                                    return "destIpRanges: array expected";
                                for (var i = 0; i < message.destIpRanges.length; ++i)
                                    if (!$util.isString(message.destIpRanges[i]))
                                        return "destIpRanges: string[] expected";
                            }
                            if (message.layer4Configs != null && message.hasOwnProperty("layer4Configs")) {
                                if (!Array.isArray(message.layer4Configs))
                                    return "layer4Configs: array expected";
                                for (var i = 0; i < message.layer4Configs.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config.verify(message.layer4Configs[i]);
                                    if (error)
                                        return "layer4Configs." + error;
                                }
                            }
                            if (message.srcIpRanges != null && message.hasOwnProperty("srcIpRanges")) {
                                if (!Array.isArray(message.srcIpRanges))
                                    return "srcIpRanges: array expected";
                                for (var i = 0; i < message.srcIpRanges.length; ++i)
                                    if (!$util.isString(message.srcIpRanges[i]))
                                        return "srcIpRanges: string[] expected";
                            }
                            if (message.srcSecureTags != null && message.hasOwnProperty("srcSecureTags")) {
                                if (!Array.isArray(message.srcSecureTags))
                                    return "srcSecureTags: array expected";
                                for (var i = 0; i < message.srcSecureTags.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.FirewallPolicyRuleSecureTag.verify(message.srcSecureTags[i]);
                                    if (error)
                                        return "srcSecureTags." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a FirewallPolicyRuleMatcher message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcher
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.FirewallPolicyRuleMatcher} FirewallPolicyRuleMatcher
                         */
                        FirewallPolicyRuleMatcher.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.FirewallPolicyRuleMatcher)
                                return object;
                            var message = new $root.google.cloud.compute.v1.FirewallPolicyRuleMatcher();
                            if (object.destIpRanges) {
                                if (!Array.isArray(object.destIpRanges))
                                    throw TypeError(".google.cloud.compute.v1.FirewallPolicyRuleMatcher.destIpRanges: array expected");
                                message.destIpRanges = [];
                                for (var i = 0; i < object.destIpRanges.length; ++i)
                                    message.destIpRanges[i] = String(object.destIpRanges[i]);
                            }
                            if (object.layer4Configs) {
                                if (!Array.isArray(object.layer4Configs))
                                    throw TypeError(".google.cloud.compute.v1.FirewallPolicyRuleMatcher.layer4Configs: array expected");
                                message.layer4Configs = [];
                                for (var i = 0; i < object.layer4Configs.length; ++i) {
                                    if (typeof object.layer4Configs[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.FirewallPolicyRuleMatcher.layer4Configs: object expected");
                                    message.layer4Configs[i] = $root.google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config.fromObject(object.layer4Configs[i]);
                                }
                            }
                            if (object.srcIpRanges) {
                                if (!Array.isArray(object.srcIpRanges))
                                    throw TypeError(".google.cloud.compute.v1.FirewallPolicyRuleMatcher.srcIpRanges: array expected");
                                message.srcIpRanges = [];
                                for (var i = 0; i < object.srcIpRanges.length; ++i)
                                    message.srcIpRanges[i] = String(object.srcIpRanges[i]);
                            }
                            if (object.srcSecureTags) {
                                if (!Array.isArray(object.srcSecureTags))
                                    throw TypeError(".google.cloud.compute.v1.FirewallPolicyRuleMatcher.srcSecureTags: array expected");
                                message.srcSecureTags = [];
                                for (var i = 0; i < object.srcSecureTags.length; ++i) {
                                    if (typeof object.srcSecureTags[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.FirewallPolicyRuleMatcher.srcSecureTags: object expected");
                                    message.srcSecureTags[i] = $root.google.cloud.compute.v1.FirewallPolicyRuleSecureTag.fromObject(object.srcSecureTags[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a FirewallPolicyRuleMatcher message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcher
                         * @static
                         * @param {google.cloud.compute.v1.FirewallPolicyRuleMatcher} message FirewallPolicyRuleMatcher
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FirewallPolicyRuleMatcher.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.destIpRanges = [];
                                object.layer4Configs = [];
                                object.srcIpRanges = [];
                                object.srcSecureTags = [];
                            }
                            if (message.destIpRanges && message.destIpRanges.length) {
                                object.destIpRanges = [];
                                for (var j = 0; j < message.destIpRanges.length; ++j)
                                    object.destIpRanges[j] = message.destIpRanges[j];
                            }
                            if (message.layer4Configs && message.layer4Configs.length) {
                                object.layer4Configs = [];
                                for (var j = 0; j < message.layer4Configs.length; ++j)
                                    object.layer4Configs[j] = $root.google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config.toObject(message.layer4Configs[j], options);
                            }
                            if (message.srcIpRanges && message.srcIpRanges.length) {
                                object.srcIpRanges = [];
                                for (var j = 0; j < message.srcIpRanges.length; ++j)
                                    object.srcIpRanges[j] = message.srcIpRanges[j];
                            }
                            if (message.srcSecureTags && message.srcSecureTags.length) {
                                object.srcSecureTags = [];
                                for (var j = 0; j < message.srcSecureTags.length; ++j)
                                    object.srcSecureTags[j] = $root.google.cloud.compute.v1.FirewallPolicyRuleSecureTag.toObject(message.srcSecureTags[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this FirewallPolicyRuleMatcher to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcher
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FirewallPolicyRuleMatcher.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for FirewallPolicyRuleMatcher
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcher
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        FirewallPolicyRuleMatcher.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.FirewallPolicyRuleMatcher";
                        };
    
                        return FirewallPolicyRuleMatcher;
                    })();
    
                    v1.FirewallPolicyRuleMatcherLayer4Config = (function() {
    
                        /**
                         * Properties of a FirewallPolicyRuleMatcherLayer4Config.
                         * @memberof google.cloud.compute.v1
                         * @interface IFirewallPolicyRuleMatcherLayer4Config
                         * @property {string|null} [ipProtocol] FirewallPolicyRuleMatcherLayer4Config ipProtocol
                         * @property {Array.<string>|null} [ports] FirewallPolicyRuleMatcherLayer4Config ports
                         */
    
                        /**
                         * Constructs a new FirewallPolicyRuleMatcherLayer4Config.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a FirewallPolicyRuleMatcherLayer4Config.
                         * @implements IFirewallPolicyRuleMatcherLayer4Config
                         * @constructor
                         * @param {google.cloud.compute.v1.IFirewallPolicyRuleMatcherLayer4Config=} [properties] Properties to set
                         */
                        function FirewallPolicyRuleMatcherLayer4Config(properties) {
                            this.ports = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * FirewallPolicyRuleMatcherLayer4Config ipProtocol.
                         * @member {string|null|undefined} ipProtocol
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config
                         * @instance
                         */
                        FirewallPolicyRuleMatcherLayer4Config.prototype.ipProtocol = null;
    
                        /**
                         * FirewallPolicyRuleMatcherLayer4Config ports.
                         * @member {Array.<string>} ports
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config
                         * @instance
                         */
                        FirewallPolicyRuleMatcherLayer4Config.prototype.ports = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * FirewallPolicyRuleMatcherLayer4Config _ipProtocol.
                         * @member {"ipProtocol"|undefined} _ipProtocol
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyRuleMatcherLayer4Config.prototype, "_ipProtocol", {
                            get: $util.oneOfGetter($oneOfFields = ["ipProtocol"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new FirewallPolicyRuleMatcherLayer4Config instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicyRuleMatcherLayer4Config=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config} FirewallPolicyRuleMatcherLayer4Config instance
                         */
                        FirewallPolicyRuleMatcherLayer4Config.create = function create(properties) {
                            return new FirewallPolicyRuleMatcherLayer4Config(properties);
                        };
    
                        /**
                         * Encodes the specified FirewallPolicyRuleMatcherLayer4Config message. Does not implicitly {@link google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicyRuleMatcherLayer4Config} message FirewallPolicyRuleMatcherLayer4Config message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirewallPolicyRuleMatcherLayer4Config.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.ports != null && message.ports.length)
                                for (var i = 0; i < message.ports.length; ++i)
                                    writer.uint32(/* id 106854418, wireType 2 =*/854835346).string(message.ports[i]);
                            if (message.ipProtocol != null && Object.hasOwnProperty.call(message, "ipProtocol"))
                                writer.uint32(/* id 475958960, wireType 2 =*/3807671682).string(message.ipProtocol);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified FirewallPolicyRuleMatcherLayer4Config message, length delimited. Does not implicitly {@link google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicyRuleMatcherLayer4Config} message FirewallPolicyRuleMatcherLayer4Config message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirewallPolicyRuleMatcherLayer4Config.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a FirewallPolicyRuleMatcherLayer4Config message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config} FirewallPolicyRuleMatcherLayer4Config
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirewallPolicyRuleMatcherLayer4Config.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 475958960: {
                                        message.ipProtocol = reader.string();
                                        break;
                                    }
                                case 106854418: {
                                        if (!(message.ports && message.ports.length))
                                            message.ports = [];
                                        message.ports.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a FirewallPolicyRuleMatcherLayer4Config message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config} FirewallPolicyRuleMatcherLayer4Config
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirewallPolicyRuleMatcherLayer4Config.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a FirewallPolicyRuleMatcherLayer4Config message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FirewallPolicyRuleMatcherLayer4Config.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.ipProtocol != null && message.hasOwnProperty("ipProtocol")) {
                                properties._ipProtocol = 1;
                                if (!$util.isString(message.ipProtocol))
                                    return "ipProtocol: string expected";
                            }
                            if (message.ports != null && message.hasOwnProperty("ports")) {
                                if (!Array.isArray(message.ports))
                                    return "ports: array expected";
                                for (var i = 0; i < message.ports.length; ++i)
                                    if (!$util.isString(message.ports[i]))
                                        return "ports: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a FirewallPolicyRuleMatcherLayer4Config message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config} FirewallPolicyRuleMatcherLayer4Config
                         */
                        FirewallPolicyRuleMatcherLayer4Config.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config)
                                return object;
                            var message = new $root.google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config();
                            if (object.ipProtocol != null)
                                message.ipProtocol = String(object.ipProtocol);
                            if (object.ports) {
                                if (!Array.isArray(object.ports))
                                    throw TypeError(".google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config.ports: array expected");
                                message.ports = [];
                                for (var i = 0; i < object.ports.length; ++i)
                                    message.ports[i] = String(object.ports[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a FirewallPolicyRuleMatcherLayer4Config message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config
                         * @static
                         * @param {google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config} message FirewallPolicyRuleMatcherLayer4Config
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FirewallPolicyRuleMatcherLayer4Config.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.ports = [];
                            if (message.ports && message.ports.length) {
                                object.ports = [];
                                for (var j = 0; j < message.ports.length; ++j)
                                    object.ports[j] = message.ports[j];
                            }
                            if (message.ipProtocol != null && message.hasOwnProperty("ipProtocol")) {
                                object.ipProtocol = message.ipProtocol;
                                if (options.oneofs)
                                    object._ipProtocol = "ipProtocol";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this FirewallPolicyRuleMatcherLayer4Config to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FirewallPolicyRuleMatcherLayer4Config.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for FirewallPolicyRuleMatcherLayer4Config
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        FirewallPolicyRuleMatcherLayer4Config.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.FirewallPolicyRuleMatcherLayer4Config";
                        };
    
                        return FirewallPolicyRuleMatcherLayer4Config;
                    })();
    
                    v1.FirewallPolicyRuleSecureTag = (function() {
    
                        /**
                         * Properties of a FirewallPolicyRuleSecureTag.
                         * @memberof google.cloud.compute.v1
                         * @interface IFirewallPolicyRuleSecureTag
                         * @property {string|null} [name] FirewallPolicyRuleSecureTag name
                         * @property {string|null} [state] FirewallPolicyRuleSecureTag state
                         */
    
                        /**
                         * Constructs a new FirewallPolicyRuleSecureTag.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a FirewallPolicyRuleSecureTag.
                         * @implements IFirewallPolicyRuleSecureTag
                         * @constructor
                         * @param {google.cloud.compute.v1.IFirewallPolicyRuleSecureTag=} [properties] Properties to set
                         */
                        function FirewallPolicyRuleSecureTag(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * FirewallPolicyRuleSecureTag name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleSecureTag
                         * @instance
                         */
                        FirewallPolicyRuleSecureTag.prototype.name = null;
    
                        /**
                         * FirewallPolicyRuleSecureTag state.
                         * @member {string|null|undefined} state
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleSecureTag
                         * @instance
                         */
                        FirewallPolicyRuleSecureTag.prototype.state = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * FirewallPolicyRuleSecureTag _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleSecureTag
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyRuleSecureTag.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FirewallPolicyRuleSecureTag _state.
                         * @member {"state"|undefined} _state
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleSecureTag
                         * @instance
                         */
                        Object.defineProperty(FirewallPolicyRuleSecureTag.prototype, "_state", {
                            get: $util.oneOfGetter($oneOfFields = ["state"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new FirewallPolicyRuleSecureTag instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleSecureTag
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicyRuleSecureTag=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.FirewallPolicyRuleSecureTag} FirewallPolicyRuleSecureTag instance
                         */
                        FirewallPolicyRuleSecureTag.create = function create(properties) {
                            return new FirewallPolicyRuleSecureTag(properties);
                        };
    
                        /**
                         * Encodes the specified FirewallPolicyRuleSecureTag message. Does not implicitly {@link google.cloud.compute.v1.FirewallPolicyRuleSecureTag.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleSecureTag
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicyRuleSecureTag} message FirewallPolicyRuleSecureTag message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirewallPolicyRuleSecureTag.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.state != null && Object.hasOwnProperty.call(message, "state"))
                                writer.uint32(/* id 109757585, wireType 2 =*/878060682).string(message.state);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified FirewallPolicyRuleSecureTag message, length delimited. Does not implicitly {@link google.cloud.compute.v1.FirewallPolicyRuleSecureTag.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleSecureTag
                         * @static
                         * @param {google.cloud.compute.v1.IFirewallPolicyRuleSecureTag} message FirewallPolicyRuleSecureTag message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FirewallPolicyRuleSecureTag.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a FirewallPolicyRuleSecureTag message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleSecureTag
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.FirewallPolicyRuleSecureTag} FirewallPolicyRuleSecureTag
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirewallPolicyRuleSecureTag.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.FirewallPolicyRuleSecureTag();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 109757585: {
                                        message.state = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a FirewallPolicyRuleSecureTag message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleSecureTag
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.FirewallPolicyRuleSecureTag} FirewallPolicyRuleSecureTag
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FirewallPolicyRuleSecureTag.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a FirewallPolicyRuleSecureTag message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleSecureTag
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FirewallPolicyRuleSecureTag.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                properties._state = 1;
                                if (!$util.isString(message.state))
                                    return "state: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a FirewallPolicyRuleSecureTag message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleSecureTag
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.FirewallPolicyRuleSecureTag} FirewallPolicyRuleSecureTag
                         */
                        FirewallPolicyRuleSecureTag.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.FirewallPolicyRuleSecureTag)
                                return object;
                            var message = new $root.google.cloud.compute.v1.FirewallPolicyRuleSecureTag();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.state != null)
                                message.state = String(object.state);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a FirewallPolicyRuleSecureTag message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleSecureTag
                         * @static
                         * @param {google.cloud.compute.v1.FirewallPolicyRuleSecureTag} message FirewallPolicyRuleSecureTag
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FirewallPolicyRuleSecureTag.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                object.state = message.state;
                                if (options.oneofs)
                                    object._state = "state";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this FirewallPolicyRuleSecureTag to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleSecureTag
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FirewallPolicyRuleSecureTag.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for FirewallPolicyRuleSecureTag
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.FirewallPolicyRuleSecureTag
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        FirewallPolicyRuleSecureTag.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.FirewallPolicyRuleSecureTag";
                        };
    
                        /**
                         * State enum.
                         * @name google.cloud.compute.v1.FirewallPolicyRuleSecureTag.State
                         * @enum {number}
                         * @property {number} UNDEFINED_STATE=0 UNDEFINED_STATE value
                         * @property {number} EFFECTIVE=244201863 EFFECTIVE value
                         * @property {number} INEFFECTIVE=304458242 INEFFECTIVE value
                         */
                        FirewallPolicyRuleSecureTag.State = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATE"] = 0;
                            values[valuesById[244201863] = "EFFECTIVE"] = 244201863;
                            values[valuesById[304458242] = "INEFFECTIVE"] = 304458242;
                            return values;
                        })();
    
                        return FirewallPolicyRuleSecureTag;
                    })();
    
                    v1.FixedOrPercent = (function() {
    
                        /**
                         * Properties of a FixedOrPercent.
                         * @memberof google.cloud.compute.v1
                         * @interface IFixedOrPercent
                         * @property {number|null} [calculated] FixedOrPercent calculated
                         * @property {number|null} [fixed] FixedOrPercent fixed
                         * @property {number|null} [percent] FixedOrPercent percent
                         */
    
                        /**
                         * Constructs a new FixedOrPercent.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a FixedOrPercent.
                         * @implements IFixedOrPercent
                         * @constructor
                         * @param {google.cloud.compute.v1.IFixedOrPercent=} [properties] Properties to set
                         */
                        function FixedOrPercent(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * FixedOrPercent calculated.
                         * @member {number|null|undefined} calculated
                         * @memberof google.cloud.compute.v1.FixedOrPercent
                         * @instance
                         */
                        FixedOrPercent.prototype.calculated = null;
    
                        /**
                         * FixedOrPercent fixed.
                         * @member {number|null|undefined} fixed
                         * @memberof google.cloud.compute.v1.FixedOrPercent
                         * @instance
                         */
                        FixedOrPercent.prototype.fixed = null;
    
                        /**
                         * FixedOrPercent percent.
                         * @member {number|null|undefined} percent
                         * @memberof google.cloud.compute.v1.FixedOrPercent
                         * @instance
                         */
                        FixedOrPercent.prototype.percent = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * FixedOrPercent _calculated.
                         * @member {"calculated"|undefined} _calculated
                         * @memberof google.cloud.compute.v1.FixedOrPercent
                         * @instance
                         */
                        Object.defineProperty(FixedOrPercent.prototype, "_calculated", {
                            get: $util.oneOfGetter($oneOfFields = ["calculated"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FixedOrPercent _fixed.
                         * @member {"fixed"|undefined} _fixed
                         * @memberof google.cloud.compute.v1.FixedOrPercent
                         * @instance
                         */
                        Object.defineProperty(FixedOrPercent.prototype, "_fixed", {
                            get: $util.oneOfGetter($oneOfFields = ["fixed"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * FixedOrPercent _percent.
                         * @member {"percent"|undefined} _percent
                         * @memberof google.cloud.compute.v1.FixedOrPercent
                         * @instance
                         */
                        Object.defineProperty(FixedOrPercent.prototype, "_percent", {
                            get: $util.oneOfGetter($oneOfFields = ["percent"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new FixedOrPercent instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.FixedOrPercent
                         * @static
                         * @param {google.cloud.compute.v1.IFixedOrPercent=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.FixedOrPercent} FixedOrPercent instance
                         */
                        FixedOrPercent.create = function create(properties) {
                            return new FixedOrPercent(properties);
                        };
    
                        /**
                         * Encodes the specified FixedOrPercent message. Does not implicitly {@link google.cloud.compute.v1.FixedOrPercent.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.FixedOrPercent
                         * @static
                         * @param {google.cloud.compute.v1.IFixedOrPercent} message FixedOrPercent message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FixedOrPercent.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.fixed != null && Object.hasOwnProperty.call(message, "fixed"))
                                writer.uint32(/* id 97445748, wireType 0 =*/779565984).int32(message.fixed);
                            if (message.percent != null && Object.hasOwnProperty.call(message, "percent"))
                                writer.uint32(/* id 394814533, wireType 0 =*/3158516264).int32(message.percent);
                            if (message.calculated != null && Object.hasOwnProperty.call(message, "calculated"))
                                writer.uint32(/* id 472082878, wireType 0 =*/3776663024).int32(message.calculated);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified FixedOrPercent message, length delimited. Does not implicitly {@link google.cloud.compute.v1.FixedOrPercent.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.FixedOrPercent
                         * @static
                         * @param {google.cloud.compute.v1.IFixedOrPercent} message FixedOrPercent message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        FixedOrPercent.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a FixedOrPercent message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.FixedOrPercent
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.FixedOrPercent} FixedOrPercent
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FixedOrPercent.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.FixedOrPercent();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 472082878: {
                                        message.calculated = reader.int32();
                                        break;
                                    }
                                case 97445748: {
                                        message.fixed = reader.int32();
                                        break;
                                    }
                                case 394814533: {
                                        message.percent = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a FixedOrPercent message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.FixedOrPercent
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.FixedOrPercent} FixedOrPercent
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        FixedOrPercent.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a FixedOrPercent message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.FixedOrPercent
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        FixedOrPercent.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.calculated != null && message.hasOwnProperty("calculated")) {
                                properties._calculated = 1;
                                if (!$util.isInteger(message.calculated))
                                    return "calculated: integer expected";
                            }
                            if (message.fixed != null && message.hasOwnProperty("fixed")) {
                                properties._fixed = 1;
                                if (!$util.isInteger(message.fixed))
                                    return "fixed: integer expected";
                            }
                            if (message.percent != null && message.hasOwnProperty("percent")) {
                                properties._percent = 1;
                                if (!$util.isInteger(message.percent))
                                    return "percent: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a FixedOrPercent message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.FixedOrPercent
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.FixedOrPercent} FixedOrPercent
                         */
                        FixedOrPercent.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.FixedOrPercent)
                                return object;
                            var message = new $root.google.cloud.compute.v1.FixedOrPercent();
                            if (object.calculated != null)
                                message.calculated = object.calculated | 0;
                            if (object.fixed != null)
                                message.fixed = object.fixed | 0;
                            if (object.percent != null)
                                message.percent = object.percent | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a FixedOrPercent message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.FixedOrPercent
                         * @static
                         * @param {google.cloud.compute.v1.FixedOrPercent} message FixedOrPercent
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        FixedOrPercent.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.fixed != null && message.hasOwnProperty("fixed")) {
                                object.fixed = message.fixed;
                                if (options.oneofs)
                                    object._fixed = "fixed";
                            }
                            if (message.percent != null && message.hasOwnProperty("percent")) {
                                object.percent = message.percent;
                                if (options.oneofs)
                                    object._percent = "percent";
                            }
                            if (message.calculated != null && message.hasOwnProperty("calculated")) {
                                object.calculated = message.calculated;
                                if (options.oneofs)
                                    object._calculated = "calculated";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this FixedOrPercent to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.FixedOrPercent
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        FixedOrPercent.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for FixedOrPercent
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.FixedOrPercent
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        FixedOrPercent.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.FixedOrPercent";
                        };
    
                        return FixedOrPercent;
                    })();
    
                    v1.ForwardingRule = (function() {
    
                        /**
                         * Properties of a ForwardingRule.
                         * @memberof google.cloud.compute.v1
                         * @interface IForwardingRule
                         * @property {string|null} [IPAddress] ForwardingRule IPAddress
                         * @property {string|null} [IPProtocol] ForwardingRule IPProtocol
                         * @property {boolean|null} [allPorts] ForwardingRule allPorts
                         * @property {boolean|null} [allowGlobalAccess] ForwardingRule allowGlobalAccess
                         * @property {string|null} [backendService] ForwardingRule backendService
                         * @property {string|null} [creationTimestamp] ForwardingRule creationTimestamp
                         * @property {string|null} [description] ForwardingRule description
                         * @property {string|null} [fingerprint] ForwardingRule fingerprint
                         * @property {number|Long|null} [id] ForwardingRule id
                         * @property {string|null} [ipVersion] ForwardingRule ipVersion
                         * @property {boolean|null} [isMirroringCollector] ForwardingRule isMirroringCollector
                         * @property {string|null} [kind] ForwardingRule kind
                         * @property {string|null} [labelFingerprint] ForwardingRule labelFingerprint
                         * @property {Object.<string,string>|null} [labels] ForwardingRule labels
                         * @property {string|null} [loadBalancingScheme] ForwardingRule loadBalancingScheme
                         * @property {Array.<google.cloud.compute.v1.IMetadataFilter>|null} [metadataFilters] ForwardingRule metadataFilters
                         * @property {string|null} [name] ForwardingRule name
                         * @property {string|null} [network] ForwardingRule network
                         * @property {string|null} [networkTier] ForwardingRule networkTier
                         * @property {boolean|null} [noAutomateDnsZone] ForwardingRule noAutomateDnsZone
                         * @property {string|null} [portRange] ForwardingRule portRange
                         * @property {Array.<string>|null} [ports] ForwardingRule ports
                         * @property {number|Long|null} [pscConnectionId] ForwardingRule pscConnectionId
                         * @property {string|null} [pscConnectionStatus] ForwardingRule pscConnectionStatus
                         * @property {string|null} [region] ForwardingRule region
                         * @property {string|null} [selfLink] ForwardingRule selfLink
                         * @property {Array.<google.cloud.compute.v1.IForwardingRuleServiceDirectoryRegistration>|null} [serviceDirectoryRegistrations] ForwardingRule serviceDirectoryRegistrations
                         * @property {string|null} [serviceLabel] ForwardingRule serviceLabel
                         * @property {string|null} [serviceName] ForwardingRule serviceName
                         * @property {string|null} [subnetwork] ForwardingRule subnetwork
                         * @property {string|null} [target] ForwardingRule target
                         */
    
                        /**
                         * Constructs a new ForwardingRule.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ForwardingRule.
                         * @implements IForwardingRule
                         * @constructor
                         * @param {google.cloud.compute.v1.IForwardingRule=} [properties] Properties to set
                         */
                        function ForwardingRule(properties) {
                            this.labels = {};
                            this.metadataFilters = [];
                            this.ports = [];
                            this.serviceDirectoryRegistrations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ForwardingRule IPAddress.
                         * @member {string|null|undefined} IPAddress
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.IPAddress = null;
    
                        /**
                         * ForwardingRule IPProtocol.
                         * @member {string|null|undefined} IPProtocol
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.IPProtocol = null;
    
                        /**
                         * ForwardingRule allPorts.
                         * @member {boolean|null|undefined} allPorts
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.allPorts = null;
    
                        /**
                         * ForwardingRule allowGlobalAccess.
                         * @member {boolean|null|undefined} allowGlobalAccess
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.allowGlobalAccess = null;
    
                        /**
                         * ForwardingRule backendService.
                         * @member {string|null|undefined} backendService
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.backendService = null;
    
                        /**
                         * ForwardingRule creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.creationTimestamp = null;
    
                        /**
                         * ForwardingRule description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.description = null;
    
                        /**
                         * ForwardingRule fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.fingerprint = null;
    
                        /**
                         * ForwardingRule id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.id = null;
    
                        /**
                         * ForwardingRule ipVersion.
                         * @member {string|null|undefined} ipVersion
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.ipVersion = null;
    
                        /**
                         * ForwardingRule isMirroringCollector.
                         * @member {boolean|null|undefined} isMirroringCollector
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.isMirroringCollector = null;
    
                        /**
                         * ForwardingRule kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.kind = null;
    
                        /**
                         * ForwardingRule labelFingerprint.
                         * @member {string|null|undefined} labelFingerprint
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.labelFingerprint = null;
    
                        /**
                         * ForwardingRule labels.
                         * @member {Object.<string,string>} labels
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.labels = $util.emptyObject;
    
                        /**
                         * ForwardingRule loadBalancingScheme.
                         * @member {string|null|undefined} loadBalancingScheme
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.loadBalancingScheme = null;
    
                        /**
                         * ForwardingRule metadataFilters.
                         * @member {Array.<google.cloud.compute.v1.IMetadataFilter>} metadataFilters
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.metadataFilters = $util.emptyArray;
    
                        /**
                         * ForwardingRule name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.name = null;
    
                        /**
                         * ForwardingRule network.
                         * @member {string|null|undefined} network
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.network = null;
    
                        /**
                         * ForwardingRule networkTier.
                         * @member {string|null|undefined} networkTier
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.networkTier = null;
    
                        /**
                         * ForwardingRule noAutomateDnsZone.
                         * @member {boolean|null|undefined} noAutomateDnsZone
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.noAutomateDnsZone = null;
    
                        /**
                         * ForwardingRule portRange.
                         * @member {string|null|undefined} portRange
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.portRange = null;
    
                        /**
                         * ForwardingRule ports.
                         * @member {Array.<string>} ports
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.ports = $util.emptyArray;
    
                        /**
                         * ForwardingRule pscConnectionId.
                         * @member {number|Long|null|undefined} pscConnectionId
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.pscConnectionId = null;
    
                        /**
                         * ForwardingRule pscConnectionStatus.
                         * @member {string|null|undefined} pscConnectionStatus
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.pscConnectionStatus = null;
    
                        /**
                         * ForwardingRule region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.region = null;
    
                        /**
                         * ForwardingRule selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.selfLink = null;
    
                        /**
                         * ForwardingRule serviceDirectoryRegistrations.
                         * @member {Array.<google.cloud.compute.v1.IForwardingRuleServiceDirectoryRegistration>} serviceDirectoryRegistrations
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.serviceDirectoryRegistrations = $util.emptyArray;
    
                        /**
                         * ForwardingRule serviceLabel.
                         * @member {string|null|undefined} serviceLabel
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.serviceLabel = null;
    
                        /**
                         * ForwardingRule serviceName.
                         * @member {string|null|undefined} serviceName
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.serviceName = null;
    
                        /**
                         * ForwardingRule subnetwork.
                         * @member {string|null|undefined} subnetwork
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.subnetwork = null;
    
                        /**
                         * ForwardingRule target.
                         * @member {string|null|undefined} target
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        ForwardingRule.prototype.target = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ForwardingRule _IPAddress.
                         * @member {"IPAddress"|undefined} _IPAddress
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_IPAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["IPAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _IPProtocol.
                         * @member {"IPProtocol"|undefined} _IPProtocol
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_IPProtocol", {
                            get: $util.oneOfGetter($oneOfFields = ["IPProtocol"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _allPorts.
                         * @member {"allPorts"|undefined} _allPorts
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_allPorts", {
                            get: $util.oneOfGetter($oneOfFields = ["allPorts"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _allowGlobalAccess.
                         * @member {"allowGlobalAccess"|undefined} _allowGlobalAccess
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_allowGlobalAccess", {
                            get: $util.oneOfGetter($oneOfFields = ["allowGlobalAccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _backendService.
                         * @member {"backendService"|undefined} _backendService
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_backendService", {
                            get: $util.oneOfGetter($oneOfFields = ["backendService"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _ipVersion.
                         * @member {"ipVersion"|undefined} _ipVersion
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_ipVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["ipVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _isMirroringCollector.
                         * @member {"isMirroringCollector"|undefined} _isMirroringCollector
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_isMirroringCollector", {
                            get: $util.oneOfGetter($oneOfFields = ["isMirroringCollector"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _labelFingerprint.
                         * @member {"labelFingerprint"|undefined} _labelFingerprint
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_labelFingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["labelFingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _loadBalancingScheme.
                         * @member {"loadBalancingScheme"|undefined} _loadBalancingScheme
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_loadBalancingScheme", {
                            get: $util.oneOfGetter($oneOfFields = ["loadBalancingScheme"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _network.
                         * @member {"network"|undefined} _network
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_network", {
                            get: $util.oneOfGetter($oneOfFields = ["network"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _networkTier.
                         * @member {"networkTier"|undefined} _networkTier
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_networkTier", {
                            get: $util.oneOfGetter($oneOfFields = ["networkTier"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _noAutomateDnsZone.
                         * @member {"noAutomateDnsZone"|undefined} _noAutomateDnsZone
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_noAutomateDnsZone", {
                            get: $util.oneOfGetter($oneOfFields = ["noAutomateDnsZone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _portRange.
                         * @member {"portRange"|undefined} _portRange
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_portRange", {
                            get: $util.oneOfGetter($oneOfFields = ["portRange"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _pscConnectionId.
                         * @member {"pscConnectionId"|undefined} _pscConnectionId
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_pscConnectionId", {
                            get: $util.oneOfGetter($oneOfFields = ["pscConnectionId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _pscConnectionStatus.
                         * @member {"pscConnectionStatus"|undefined} _pscConnectionStatus
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_pscConnectionStatus", {
                            get: $util.oneOfGetter($oneOfFields = ["pscConnectionStatus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _serviceLabel.
                         * @member {"serviceLabel"|undefined} _serviceLabel
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_serviceLabel", {
                            get: $util.oneOfGetter($oneOfFields = ["serviceLabel"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _serviceName.
                         * @member {"serviceName"|undefined} _serviceName
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_serviceName", {
                            get: $util.oneOfGetter($oneOfFields = ["serviceName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _subnetwork.
                         * @member {"subnetwork"|undefined} _subnetwork
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_subnetwork", {
                            get: $util.oneOfGetter($oneOfFields = ["subnetwork"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRule _target.
                         * @member {"target"|undefined} _target
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         */
                        Object.defineProperty(ForwardingRule.prototype, "_target", {
                            get: $util.oneOfGetter($oneOfFields = ["target"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ForwardingRule instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @static
                         * @param {google.cloud.compute.v1.IForwardingRule=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ForwardingRule} ForwardingRule instance
                         */
                        ForwardingRule.create = function create(properties) {
                            return new ForwardingRule(properties);
                        };
    
                        /**
                         * Encodes the specified ForwardingRule message. Does not implicitly {@link google.cloud.compute.v1.ForwardingRule.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @static
                         * @param {google.cloud.compute.v1.IForwardingRule} message ForwardingRule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ForwardingRule.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.IPAddress != null && Object.hasOwnProperty.call(message, "IPAddress"))
                                writer.uint32(/* id 42976943, wireType 2 =*/343815546).string(message.IPAddress);
                            if (message.noAutomateDnsZone != null && Object.hasOwnProperty.call(message, "noAutomateDnsZone"))
                                writer.uint32(/* id 64546991, wireType 0 =*/516375928).bool(message.noAutomateDnsZone);
                            if (message.ports != null && message.ports.length)
                                for (var i = 0; i < message.ports.length; ++i)
                                    writer.uint32(/* id 106854418, wireType 2 =*/854835346).string(message.ports[i]);
                            if (message.isMirroringCollector != null && Object.hasOwnProperty.call(message, "isMirroringCollector"))
                                writer.uint32(/* id 119255164, wireType 0 =*/954041312).bool(message.isMirroringCollector);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.labelFingerprint != null && Object.hasOwnProperty.call(message, "labelFingerprint"))
                                writer.uint32(/* id 178124825, wireType 2 =*/1424998602).string(message.labelFingerprint);
                            if (message.pscConnectionStatus != null && Object.hasOwnProperty.call(message, "pscConnectionStatus"))
                                writer.uint32(/* id 184149172, wireType 2 =*/1473193378).string(message.pscConnectionStatus);
                            if (message.target != null && Object.hasOwnProperty.call(message, "target"))
                                writer.uint32(/* id 192835985, wireType 2 =*/1542687882).string(message.target);
                            if (message.portRange != null && Object.hasOwnProperty.call(message, "portRange"))
                                writer.uint32(/* id 217518079, wireType 2 =*/1740144634).string(message.portRange);
                            if (message.serviceDirectoryRegistrations != null && message.serviceDirectoryRegistrations.length)
                                for (var i = 0; i < message.serviceDirectoryRegistrations.length; ++i)
                                    $root.google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration.encode(message.serviceDirectoryRegistrations[i], writer.uint32(/* id 223549694, wireType 2 =*/1788397554).fork()).ldelim();
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.pscConnectionId != null && Object.hasOwnProperty.call(message, "pscConnectionId"))
                                writer.uint32(/* id 292082397, wireType 0 =*/2336659176).uint64(message.pscConnectionId);
                            if (message.ipVersion != null && Object.hasOwnProperty.call(message, "ipVersion"))
                                writer.uint32(/* id 294959552, wireType 2 =*/2359676418).string(message.ipVersion);
                            if (message.backendService != null && Object.hasOwnProperty.call(message, "backendService"))
                                writer.uint32(/* id 306946058, wireType 2 =*/2455568466).string(message.backendService);
                            if (message.subnetwork != null && Object.hasOwnProperty.call(message, "subnetwork"))
                                writer.uint32(/* id 307827694, wireType 2 =*/2462621554).string(message.subnetwork);
                            if (message.serviceName != null && Object.hasOwnProperty.call(message, "serviceName"))
                                writer.uint32(/* id 359880149, wireType 2 =*/2879041194).string(message.serviceName);
                            if (message.loadBalancingScheme != null && Object.hasOwnProperty.call(message, "loadBalancingScheme"))
                                writer.uint32(/* id 363890244, wireType 2 =*/2911121954).string(message.loadBalancingScheme);
                            if (message.serviceLabel != null && Object.hasOwnProperty.call(message, "serviceLabel"))
                                writer.uint32(/* id 417008874, wireType 2 =*/3336070994).string(message.serviceLabel);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.allPorts != null && Object.hasOwnProperty.call(message, "allPorts"))
                                writer.uint32(/* id 445175796, wireType 0 =*/3561406368).bool(message.allPorts);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.metadataFilters != null && message.metadataFilters.length)
                                for (var i = 0; i < message.metadataFilters.length; ++i)
                                    $root.google.cloud.compute.v1.MetadataFilter.encode(message.metadataFilters[i], writer.uint32(/* id 464725739, wireType 2 =*/3717805914).fork()).ldelim();
                            if (message.IPProtocol != null && Object.hasOwnProperty.call(message, "IPProtocol"))
                                writer.uint32(/* id 488094525, wireType 2 =*/3904756202).string(message.IPProtocol);
                            if (message.allowGlobalAccess != null && Object.hasOwnProperty.call(message, "allowGlobalAccess"))
                                writer.uint32(/* id 499409674, wireType 0 =*/3995277392).bool(message.allowGlobalAccess);
                            if (message.labels != null && Object.hasOwnProperty.call(message, "labels"))
                                for (var keys = Object.keys(message.labels), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 500195327, wireType 2 =*/4001562618).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.labels[keys[i]]).ldelim();
                            if (message.networkTier != null && Object.hasOwnProperty.call(message, "networkTier"))
                                writer.uint32(/* id 517397843, wireType 2 =*/4139182746).string(message.networkTier);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ForwardingRule message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ForwardingRule.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @static
                         * @param {google.cloud.compute.v1.IForwardingRule} message ForwardingRule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ForwardingRule.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ForwardingRule message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ForwardingRule} ForwardingRule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ForwardingRule.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ForwardingRule(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 42976943: {
                                        message.IPAddress = reader.string();
                                        break;
                                    }
                                case 488094525: {
                                        message.IPProtocol = reader.string();
                                        break;
                                    }
                                case 445175796: {
                                        message.allPorts = reader.bool();
                                        break;
                                    }
                                case 499409674: {
                                        message.allowGlobalAccess = reader.bool();
                                        break;
                                    }
                                case 306946058: {
                                        message.backendService = reader.string();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 294959552: {
                                        message.ipVersion = reader.string();
                                        break;
                                    }
                                case 119255164: {
                                        message.isMirroringCollector = reader.bool();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 178124825: {
                                        message.labelFingerprint = reader.string();
                                        break;
                                    }
                                case 500195327: {
                                        if (message.labels === $util.emptyObject)
                                            message.labels = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.labels[key] = value;
                                        break;
                                    }
                                case 363890244: {
                                        message.loadBalancingScheme = reader.string();
                                        break;
                                    }
                                case 464725739: {
                                        if (!(message.metadataFilters && message.metadataFilters.length))
                                            message.metadataFilters = [];
                                        message.metadataFilters.push($root.google.cloud.compute.v1.MetadataFilter.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 517397843: {
                                        message.networkTier = reader.string();
                                        break;
                                    }
                                case 64546991: {
                                        message.noAutomateDnsZone = reader.bool();
                                        break;
                                    }
                                case 217518079: {
                                        message.portRange = reader.string();
                                        break;
                                    }
                                case 106854418: {
                                        if (!(message.ports && message.ports.length))
                                            message.ports = [];
                                        message.ports.push(reader.string());
                                        break;
                                    }
                                case 292082397: {
                                        message.pscConnectionId = reader.uint64();
                                        break;
                                    }
                                case 184149172: {
                                        message.pscConnectionStatus = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 223549694: {
                                        if (!(message.serviceDirectoryRegistrations && message.serviceDirectoryRegistrations.length))
                                            message.serviceDirectoryRegistrations = [];
                                        message.serviceDirectoryRegistrations.push($root.google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 417008874: {
                                        message.serviceLabel = reader.string();
                                        break;
                                    }
                                case 359880149: {
                                        message.serviceName = reader.string();
                                        break;
                                    }
                                case 307827694: {
                                        message.subnetwork = reader.string();
                                        break;
                                    }
                                case 192835985: {
                                        message.target = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ForwardingRule message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ForwardingRule} ForwardingRule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ForwardingRule.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ForwardingRule message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ForwardingRule.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.IPAddress != null && message.hasOwnProperty("IPAddress")) {
                                properties._IPAddress = 1;
                                if (!$util.isString(message.IPAddress))
                                    return "IPAddress: string expected";
                            }
                            if (message.IPProtocol != null && message.hasOwnProperty("IPProtocol")) {
                                properties._IPProtocol = 1;
                                if (!$util.isString(message.IPProtocol))
                                    return "IPProtocol: string expected";
                            }
                            if (message.allPorts != null && message.hasOwnProperty("allPorts")) {
                                properties._allPorts = 1;
                                if (typeof message.allPorts !== "boolean")
                                    return "allPorts: boolean expected";
                            }
                            if (message.allowGlobalAccess != null && message.hasOwnProperty("allowGlobalAccess")) {
                                properties._allowGlobalAccess = 1;
                                if (typeof message.allowGlobalAccess !== "boolean")
                                    return "allowGlobalAccess: boolean expected";
                            }
                            if (message.backendService != null && message.hasOwnProperty("backendService")) {
                                properties._backendService = 1;
                                if (!$util.isString(message.backendService))
                                    return "backendService: string expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.ipVersion != null && message.hasOwnProperty("ipVersion")) {
                                properties._ipVersion = 1;
                                if (!$util.isString(message.ipVersion))
                                    return "ipVersion: string expected";
                            }
                            if (message.isMirroringCollector != null && message.hasOwnProperty("isMirroringCollector")) {
                                properties._isMirroringCollector = 1;
                                if (typeof message.isMirroringCollector !== "boolean")
                                    return "isMirroringCollector: boolean expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                properties._labelFingerprint = 1;
                                if (!$util.isString(message.labelFingerprint))
                                    return "labelFingerprint: string expected";
                            }
                            if (message.labels != null && message.hasOwnProperty("labels")) {
                                if (!$util.isObject(message.labels))
                                    return "labels: object expected";
                                var key = Object.keys(message.labels);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.labels[key[i]]))
                                        return "labels: string{k:string} expected";
                            }
                            if (message.loadBalancingScheme != null && message.hasOwnProperty("loadBalancingScheme")) {
                                properties._loadBalancingScheme = 1;
                                if (!$util.isString(message.loadBalancingScheme))
                                    return "loadBalancingScheme: string expected";
                            }
                            if (message.metadataFilters != null && message.hasOwnProperty("metadataFilters")) {
                                if (!Array.isArray(message.metadataFilters))
                                    return "metadataFilters: array expected";
                                for (var i = 0; i < message.metadataFilters.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.MetadataFilter.verify(message.metadataFilters[i]);
                                    if (error)
                                        return "metadataFilters." + error;
                                }
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                properties._network = 1;
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            }
                            if (message.networkTier != null && message.hasOwnProperty("networkTier")) {
                                properties._networkTier = 1;
                                if (!$util.isString(message.networkTier))
                                    return "networkTier: string expected";
                            }
                            if (message.noAutomateDnsZone != null && message.hasOwnProperty("noAutomateDnsZone")) {
                                properties._noAutomateDnsZone = 1;
                                if (typeof message.noAutomateDnsZone !== "boolean")
                                    return "noAutomateDnsZone: boolean expected";
                            }
                            if (message.portRange != null && message.hasOwnProperty("portRange")) {
                                properties._portRange = 1;
                                if (!$util.isString(message.portRange))
                                    return "portRange: string expected";
                            }
                            if (message.ports != null && message.hasOwnProperty("ports")) {
                                if (!Array.isArray(message.ports))
                                    return "ports: array expected";
                                for (var i = 0; i < message.ports.length; ++i)
                                    if (!$util.isString(message.ports[i]))
                                        return "ports: string[] expected";
                            }
                            if (message.pscConnectionId != null && message.hasOwnProperty("pscConnectionId")) {
                                properties._pscConnectionId = 1;
                                if (!$util.isInteger(message.pscConnectionId) && !(message.pscConnectionId && $util.isInteger(message.pscConnectionId.low) && $util.isInteger(message.pscConnectionId.high)))
                                    return "pscConnectionId: integer|Long expected";
                            }
                            if (message.pscConnectionStatus != null && message.hasOwnProperty("pscConnectionStatus")) {
                                properties._pscConnectionStatus = 1;
                                if (!$util.isString(message.pscConnectionStatus))
                                    return "pscConnectionStatus: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.serviceDirectoryRegistrations != null && message.hasOwnProperty("serviceDirectoryRegistrations")) {
                                if (!Array.isArray(message.serviceDirectoryRegistrations))
                                    return "serviceDirectoryRegistrations: array expected";
                                for (var i = 0; i < message.serviceDirectoryRegistrations.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration.verify(message.serviceDirectoryRegistrations[i]);
                                    if (error)
                                        return "serviceDirectoryRegistrations." + error;
                                }
                            }
                            if (message.serviceLabel != null && message.hasOwnProperty("serviceLabel")) {
                                properties._serviceLabel = 1;
                                if (!$util.isString(message.serviceLabel))
                                    return "serviceLabel: string expected";
                            }
                            if (message.serviceName != null && message.hasOwnProperty("serviceName")) {
                                properties._serviceName = 1;
                                if (!$util.isString(message.serviceName))
                                    return "serviceName: string expected";
                            }
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork")) {
                                properties._subnetwork = 1;
                                if (!$util.isString(message.subnetwork))
                                    return "subnetwork: string expected";
                            }
                            if (message.target != null && message.hasOwnProperty("target")) {
                                properties._target = 1;
                                if (!$util.isString(message.target))
                                    return "target: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ForwardingRule message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ForwardingRule} ForwardingRule
                         */
                        ForwardingRule.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ForwardingRule)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ForwardingRule();
                            if (object.IPAddress != null)
                                message.IPAddress = String(object.IPAddress);
                            if (object.IPProtocol != null)
                                message.IPProtocol = String(object.IPProtocol);
                            if (object.allPorts != null)
                                message.allPorts = Boolean(object.allPorts);
                            if (object.allowGlobalAccess != null)
                                message.allowGlobalAccess = Boolean(object.allowGlobalAccess);
                            if (object.backendService != null)
                                message.backendService = String(object.backendService);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.ipVersion != null)
                                message.ipVersion = String(object.ipVersion);
                            if (object.isMirroringCollector != null)
                                message.isMirroringCollector = Boolean(object.isMirroringCollector);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.labelFingerprint != null)
                                message.labelFingerprint = String(object.labelFingerprint);
                            if (object.labels) {
                                if (typeof object.labels !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ForwardingRule.labels: object expected");
                                message.labels = {};
                                for (var keys = Object.keys(object.labels), i = 0; i < keys.length; ++i)
                                    message.labels[keys[i]] = String(object.labels[keys[i]]);
                            }
                            if (object.loadBalancingScheme != null)
                                message.loadBalancingScheme = String(object.loadBalancingScheme);
                            if (object.metadataFilters) {
                                if (!Array.isArray(object.metadataFilters))
                                    throw TypeError(".google.cloud.compute.v1.ForwardingRule.metadataFilters: array expected");
                                message.metadataFilters = [];
                                for (var i = 0; i < object.metadataFilters.length; ++i) {
                                    if (typeof object.metadataFilters[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ForwardingRule.metadataFilters: object expected");
                                    message.metadataFilters[i] = $root.google.cloud.compute.v1.MetadataFilter.fromObject(object.metadataFilters[i]);
                                }
                            }
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.networkTier != null)
                                message.networkTier = String(object.networkTier);
                            if (object.noAutomateDnsZone != null)
                                message.noAutomateDnsZone = Boolean(object.noAutomateDnsZone);
                            if (object.portRange != null)
                                message.portRange = String(object.portRange);
                            if (object.ports) {
                                if (!Array.isArray(object.ports))
                                    throw TypeError(".google.cloud.compute.v1.ForwardingRule.ports: array expected");
                                message.ports = [];
                                for (var i = 0; i < object.ports.length; ++i)
                                    message.ports[i] = String(object.ports[i]);
                            }
                            if (object.pscConnectionId != null)
                                if ($util.Long)
                                    (message.pscConnectionId = $util.Long.fromValue(object.pscConnectionId)).unsigned = true;
                                else if (typeof object.pscConnectionId === "string")
                                    message.pscConnectionId = parseInt(object.pscConnectionId, 10);
                                else if (typeof object.pscConnectionId === "number")
                                    message.pscConnectionId = object.pscConnectionId;
                                else if (typeof object.pscConnectionId === "object")
                                    message.pscConnectionId = new $util.LongBits(object.pscConnectionId.low >>> 0, object.pscConnectionId.high >>> 0).toNumber(true);
                            if (object.pscConnectionStatus != null)
                                message.pscConnectionStatus = String(object.pscConnectionStatus);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.serviceDirectoryRegistrations) {
                                if (!Array.isArray(object.serviceDirectoryRegistrations))
                                    throw TypeError(".google.cloud.compute.v1.ForwardingRule.serviceDirectoryRegistrations: array expected");
                                message.serviceDirectoryRegistrations = [];
                                for (var i = 0; i < object.serviceDirectoryRegistrations.length; ++i) {
                                    if (typeof object.serviceDirectoryRegistrations[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ForwardingRule.serviceDirectoryRegistrations: object expected");
                                    message.serviceDirectoryRegistrations[i] = $root.google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration.fromObject(object.serviceDirectoryRegistrations[i]);
                                }
                            }
                            if (object.serviceLabel != null)
                                message.serviceLabel = String(object.serviceLabel);
                            if (object.serviceName != null)
                                message.serviceName = String(object.serviceName);
                            if (object.subnetwork != null)
                                message.subnetwork = String(object.subnetwork);
                            if (object.target != null)
                                message.target = String(object.target);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ForwardingRule message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @static
                         * @param {google.cloud.compute.v1.ForwardingRule} message ForwardingRule
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ForwardingRule.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.ports = [];
                                object.serviceDirectoryRegistrations = [];
                                object.metadataFilters = [];
                            }
                            if (options.objects || options.defaults)
                                object.labels = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.IPAddress != null && message.hasOwnProperty("IPAddress")) {
                                object.IPAddress = message.IPAddress;
                                if (options.oneofs)
                                    object._IPAddress = "IPAddress";
                            }
                            if (message.noAutomateDnsZone != null && message.hasOwnProperty("noAutomateDnsZone")) {
                                object.noAutomateDnsZone = message.noAutomateDnsZone;
                                if (options.oneofs)
                                    object._noAutomateDnsZone = "noAutomateDnsZone";
                            }
                            if (message.ports && message.ports.length) {
                                object.ports = [];
                                for (var j = 0; j < message.ports.length; ++j)
                                    object.ports[j] = message.ports[j];
                            }
                            if (message.isMirroringCollector != null && message.hasOwnProperty("isMirroringCollector")) {
                                object.isMirroringCollector = message.isMirroringCollector;
                                if (options.oneofs)
                                    object._isMirroringCollector = "isMirroringCollector";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                object.labelFingerprint = message.labelFingerprint;
                                if (options.oneofs)
                                    object._labelFingerprint = "labelFingerprint";
                            }
                            if (message.pscConnectionStatus != null && message.hasOwnProperty("pscConnectionStatus")) {
                                object.pscConnectionStatus = message.pscConnectionStatus;
                                if (options.oneofs)
                                    object._pscConnectionStatus = "pscConnectionStatus";
                            }
                            if (message.target != null && message.hasOwnProperty("target")) {
                                object.target = message.target;
                                if (options.oneofs)
                                    object._target = "target";
                            }
                            if (message.portRange != null && message.hasOwnProperty("portRange")) {
                                object.portRange = message.portRange;
                                if (options.oneofs)
                                    object._portRange = "portRange";
                            }
                            if (message.serviceDirectoryRegistrations && message.serviceDirectoryRegistrations.length) {
                                object.serviceDirectoryRegistrations = [];
                                for (var j = 0; j < message.serviceDirectoryRegistrations.length; ++j)
                                    object.serviceDirectoryRegistrations[j] = $root.google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration.toObject(message.serviceDirectoryRegistrations[j], options);
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                object.network = message.network;
                                if (options.oneofs)
                                    object._network = "network";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.pscConnectionId != null && message.hasOwnProperty("pscConnectionId")) {
                                if (typeof message.pscConnectionId === "number")
                                    object.pscConnectionId = options.longs === String ? String(message.pscConnectionId) : message.pscConnectionId;
                                else
                                    object.pscConnectionId = options.longs === String ? $util.Long.prototype.toString.call(message.pscConnectionId) : options.longs === Number ? new $util.LongBits(message.pscConnectionId.low >>> 0, message.pscConnectionId.high >>> 0).toNumber(true) : message.pscConnectionId;
                                if (options.oneofs)
                                    object._pscConnectionId = "pscConnectionId";
                            }
                            if (message.ipVersion != null && message.hasOwnProperty("ipVersion")) {
                                object.ipVersion = message.ipVersion;
                                if (options.oneofs)
                                    object._ipVersion = "ipVersion";
                            }
                            if (message.backendService != null && message.hasOwnProperty("backendService")) {
                                object.backendService = message.backendService;
                                if (options.oneofs)
                                    object._backendService = "backendService";
                            }
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork")) {
                                object.subnetwork = message.subnetwork;
                                if (options.oneofs)
                                    object._subnetwork = "subnetwork";
                            }
                            if (message.serviceName != null && message.hasOwnProperty("serviceName")) {
                                object.serviceName = message.serviceName;
                                if (options.oneofs)
                                    object._serviceName = "serviceName";
                            }
                            if (message.loadBalancingScheme != null && message.hasOwnProperty("loadBalancingScheme")) {
                                object.loadBalancingScheme = message.loadBalancingScheme;
                                if (options.oneofs)
                                    object._loadBalancingScheme = "loadBalancingScheme";
                            }
                            if (message.serviceLabel != null && message.hasOwnProperty("serviceLabel")) {
                                object.serviceLabel = message.serviceLabel;
                                if (options.oneofs)
                                    object._serviceLabel = "serviceLabel";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.allPorts != null && message.hasOwnProperty("allPorts")) {
                                object.allPorts = message.allPorts;
                                if (options.oneofs)
                                    object._allPorts = "allPorts";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.metadataFilters && message.metadataFilters.length) {
                                object.metadataFilters = [];
                                for (var j = 0; j < message.metadataFilters.length; ++j)
                                    object.metadataFilters[j] = $root.google.cloud.compute.v1.MetadataFilter.toObject(message.metadataFilters[j], options);
                            }
                            if (message.IPProtocol != null && message.hasOwnProperty("IPProtocol")) {
                                object.IPProtocol = message.IPProtocol;
                                if (options.oneofs)
                                    object._IPProtocol = "IPProtocol";
                            }
                            if (message.allowGlobalAccess != null && message.hasOwnProperty("allowGlobalAccess")) {
                                object.allowGlobalAccess = message.allowGlobalAccess;
                                if (options.oneofs)
                                    object._allowGlobalAccess = "allowGlobalAccess";
                            }
                            var keys2;
                            if (message.labels && (keys2 = Object.keys(message.labels)).length) {
                                object.labels = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.labels[keys2[j]] = message.labels[keys2[j]];
                            }
                            if (message.networkTier != null && message.hasOwnProperty("networkTier")) {
                                object.networkTier = message.networkTier;
                                if (options.oneofs)
                                    object._networkTier = "networkTier";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ForwardingRule to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ForwardingRule.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ForwardingRule
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ForwardingRule
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ForwardingRule.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ForwardingRule";
                        };
    
                        /**
                         * IPProtocolEnum enum.
                         * @name google.cloud.compute.v1.ForwardingRule.IPProtocolEnum
                         * @enum {number}
                         * @property {number} UNDEFINED_I_P_PROTOCOL_ENUM=0 UNDEFINED_I_P_PROTOCOL_ENUM value
                         * @property {number} AH=2087 AH value
                         * @property {number} ESP=68962 ESP value
                         * @property {number} ICMP=2241597 ICMP value
                         * @property {number} L3_DEFAULT=48151369 L3_DEFAULT value
                         * @property {number} SCTP=2539724 SCTP value
                         * @property {number} TCP=82881 TCP value
                         * @property {number} UDP=83873 UDP value
                         */
                        ForwardingRule.IPProtocolEnum = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_I_P_PROTOCOL_ENUM"] = 0;
                            values[valuesById[2087] = "AH"] = 2087;
                            values[valuesById[68962] = "ESP"] = 68962;
                            values[valuesById[2241597] = "ICMP"] = 2241597;
                            values[valuesById[48151369] = "L3_DEFAULT"] = 48151369;
                            values[valuesById[2539724] = "SCTP"] = 2539724;
                            values[valuesById[82881] = "TCP"] = 82881;
                            values[valuesById[83873] = "UDP"] = 83873;
                            return values;
                        })();
    
                        /**
                         * IpVersion enum.
                         * @name google.cloud.compute.v1.ForwardingRule.IpVersion
                         * @enum {number}
                         * @property {number} UNDEFINED_IP_VERSION=0 UNDEFINED_IP_VERSION value
                         * @property {number} IPV4=2254341 IPV4 value
                         * @property {number} IPV6=2254343 IPV6 value
                         * @property {number} UNSPECIFIED_VERSION=21850000 UNSPECIFIED_VERSION value
                         */
                        ForwardingRule.IpVersion = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_IP_VERSION"] = 0;
                            values[valuesById[2254341] = "IPV4"] = 2254341;
                            values[valuesById[2254343] = "IPV6"] = 2254343;
                            values[valuesById[21850000] = "UNSPECIFIED_VERSION"] = 21850000;
                            return values;
                        })();
    
                        /**
                         * LoadBalancingScheme enum.
                         * @name google.cloud.compute.v1.ForwardingRule.LoadBalancingScheme
                         * @enum {number}
                         * @property {number} UNDEFINED_LOAD_BALANCING_SCHEME=0 UNDEFINED_LOAD_BALANCING_SCHEME value
                         * @property {number} EXTERNAL=35607499 EXTERNAL value
                         * @property {number} EXTERNAL_MANAGED=512006923 EXTERNAL_MANAGED value
                         * @property {number} INTERNAL=279295677 INTERNAL value
                         * @property {number} INTERNAL_MANAGED=37350397 INTERNAL_MANAGED value
                         * @property {number} INTERNAL_SELF_MANAGED=236211150 INTERNAL_SELF_MANAGED value
                         * @property {number} INVALID=530283991 INVALID value
                         */
                        ForwardingRule.LoadBalancingScheme = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_LOAD_BALANCING_SCHEME"] = 0;
                            values[valuesById[35607499] = "EXTERNAL"] = 35607499;
                            values[valuesById[512006923] = "EXTERNAL_MANAGED"] = 512006923;
                            values[valuesById[279295677] = "INTERNAL"] = 279295677;
                            values[valuesById[37350397] = "INTERNAL_MANAGED"] = 37350397;
                            values[valuesById[236211150] = "INTERNAL_SELF_MANAGED"] = 236211150;
                            values[valuesById[530283991] = "INVALID"] = 530283991;
                            return values;
                        })();
    
                        /**
                         * NetworkTier enum.
                         * @name google.cloud.compute.v1.ForwardingRule.NetworkTier
                         * @enum {number}
                         * @property {number} UNDEFINED_NETWORK_TIER=0 UNDEFINED_NETWORK_TIER value
                         * @property {number} FIXED_STANDARD=310464328 FIXED_STANDARD value
                         * @property {number} PREMIUM=399530551 PREMIUM value
                         * @property {number} STANDARD=484642493 STANDARD value
                         * @property {number} STANDARD_OVERRIDES_FIXED_STANDARD=465847234 STANDARD_OVERRIDES_FIXED_STANDARD value
                         */
                        ForwardingRule.NetworkTier = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_NETWORK_TIER"] = 0;
                            values[valuesById[310464328] = "FIXED_STANDARD"] = 310464328;
                            values[valuesById[399530551] = "PREMIUM"] = 399530551;
                            values[valuesById[484642493] = "STANDARD"] = 484642493;
                            values[valuesById[465847234] = "STANDARD_OVERRIDES_FIXED_STANDARD"] = 465847234;
                            return values;
                        })();
    
                        /**
                         * PscConnectionStatus enum.
                         * @name google.cloud.compute.v1.ForwardingRule.PscConnectionStatus
                         * @enum {number}
                         * @property {number} UNDEFINED_PSC_CONNECTION_STATUS=0 UNDEFINED_PSC_CONNECTION_STATUS value
                         * @property {number} ACCEPTED=246714279 ACCEPTED value
                         * @property {number} CLOSED=380163436 CLOSED value
                         * @property {number} NEEDS_ATTENTION=344491452 NEEDS_ATTENTION value
                         * @property {number} PENDING=35394935 PENDING value
                         * @property {number} REJECTED=174130302 REJECTED value
                         * @property {number} STATUS_UNSPECIFIED=42133066 STATUS_UNSPECIFIED value
                         */
                        ForwardingRule.PscConnectionStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PSC_CONNECTION_STATUS"] = 0;
                            values[valuesById[246714279] = "ACCEPTED"] = 246714279;
                            values[valuesById[380163436] = "CLOSED"] = 380163436;
                            values[valuesById[344491452] = "NEEDS_ATTENTION"] = 344491452;
                            values[valuesById[35394935] = "PENDING"] = 35394935;
                            values[valuesById[174130302] = "REJECTED"] = 174130302;
                            values[valuesById[42133066] = "STATUS_UNSPECIFIED"] = 42133066;
                            return values;
                        })();
    
                        return ForwardingRule;
                    })();
    
                    v1.ForwardingRuleAggregatedList = (function() {
    
                        /**
                         * Properties of a ForwardingRuleAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IForwardingRuleAggregatedList
                         * @property {string|null} [id] ForwardingRuleAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IForwardingRulesScopedList>|null} [items] ForwardingRuleAggregatedList items
                         * @property {string|null} [kind] ForwardingRuleAggregatedList kind
                         * @property {string|null} [nextPageToken] ForwardingRuleAggregatedList nextPageToken
                         * @property {string|null} [selfLink] ForwardingRuleAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] ForwardingRuleAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] ForwardingRuleAggregatedList warning
                         */
    
                        /**
                         * Constructs a new ForwardingRuleAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ForwardingRuleAggregatedList.
                         * @implements IForwardingRuleAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IForwardingRuleAggregatedList=} [properties] Properties to set
                         */
                        function ForwardingRuleAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ForwardingRuleAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @instance
                         */
                        ForwardingRuleAggregatedList.prototype.id = null;
    
                        /**
                         * ForwardingRuleAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IForwardingRulesScopedList>} items
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @instance
                         */
                        ForwardingRuleAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * ForwardingRuleAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @instance
                         */
                        ForwardingRuleAggregatedList.prototype.kind = null;
    
                        /**
                         * ForwardingRuleAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @instance
                         */
                        ForwardingRuleAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * ForwardingRuleAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @instance
                         */
                        ForwardingRuleAggregatedList.prototype.selfLink = null;
    
                        /**
                         * ForwardingRuleAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @instance
                         */
                        ForwardingRuleAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * ForwardingRuleAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @instance
                         */
                        ForwardingRuleAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ForwardingRuleAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ForwardingRuleAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRuleAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ForwardingRuleAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRuleAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ForwardingRuleAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRuleAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ForwardingRuleAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRuleAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ForwardingRuleAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ForwardingRuleAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IForwardingRuleAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ForwardingRuleAggregatedList} ForwardingRuleAggregatedList instance
                         */
                        ForwardingRuleAggregatedList.create = function create(properties) {
                            return new ForwardingRuleAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified ForwardingRuleAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.ForwardingRuleAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IForwardingRuleAggregatedList} message ForwardingRuleAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ForwardingRuleAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.ForwardingRulesScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ForwardingRuleAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ForwardingRuleAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IForwardingRuleAggregatedList} message ForwardingRuleAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ForwardingRuleAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ForwardingRuleAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ForwardingRuleAggregatedList} ForwardingRuleAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ForwardingRuleAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ForwardingRuleAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.ForwardingRulesScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ForwardingRuleAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ForwardingRuleAggregatedList} ForwardingRuleAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ForwardingRuleAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ForwardingRuleAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ForwardingRuleAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ForwardingRulesScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ForwardingRuleAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ForwardingRuleAggregatedList} ForwardingRuleAggregatedList
                         */
                        ForwardingRuleAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ForwardingRuleAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ForwardingRuleAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ForwardingRuleAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ForwardingRuleAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.ForwardingRulesScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.ForwardingRuleAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ForwardingRuleAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ForwardingRuleAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ForwardingRuleAggregatedList} message ForwardingRuleAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ForwardingRuleAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.ForwardingRulesScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ForwardingRuleAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ForwardingRuleAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ForwardingRuleAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ForwardingRuleAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ForwardingRuleAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ForwardingRuleAggregatedList";
                        };
    
                        return ForwardingRuleAggregatedList;
                    })();
    
                    v1.ForwardingRuleList = (function() {
    
                        /**
                         * Properties of a ForwardingRuleList.
                         * @memberof google.cloud.compute.v1
                         * @interface IForwardingRuleList
                         * @property {string|null} [id] ForwardingRuleList id
                         * @property {Array.<google.cloud.compute.v1.IForwardingRule>|null} [items] ForwardingRuleList items
                         * @property {string|null} [kind] ForwardingRuleList kind
                         * @property {string|null} [nextPageToken] ForwardingRuleList nextPageToken
                         * @property {string|null} [selfLink] ForwardingRuleList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] ForwardingRuleList warning
                         */
    
                        /**
                         * Constructs a new ForwardingRuleList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ForwardingRuleList.
                         * @implements IForwardingRuleList
                         * @constructor
                         * @param {google.cloud.compute.v1.IForwardingRuleList=} [properties] Properties to set
                         */
                        function ForwardingRuleList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ForwardingRuleList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @instance
                         */
                        ForwardingRuleList.prototype.id = null;
    
                        /**
                         * ForwardingRuleList items.
                         * @member {Array.<google.cloud.compute.v1.IForwardingRule>} items
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @instance
                         */
                        ForwardingRuleList.prototype.items = $util.emptyArray;
    
                        /**
                         * ForwardingRuleList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @instance
                         */
                        ForwardingRuleList.prototype.kind = null;
    
                        /**
                         * ForwardingRuleList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @instance
                         */
                        ForwardingRuleList.prototype.nextPageToken = null;
    
                        /**
                         * ForwardingRuleList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @instance
                         */
                        ForwardingRuleList.prototype.selfLink = null;
    
                        /**
                         * ForwardingRuleList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @instance
                         */
                        ForwardingRuleList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ForwardingRuleList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @instance
                         */
                        Object.defineProperty(ForwardingRuleList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRuleList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @instance
                         */
                        Object.defineProperty(ForwardingRuleList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRuleList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @instance
                         */
                        Object.defineProperty(ForwardingRuleList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRuleList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @instance
                         */
                        Object.defineProperty(ForwardingRuleList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRuleList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @instance
                         */
                        Object.defineProperty(ForwardingRuleList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ForwardingRuleList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @static
                         * @param {google.cloud.compute.v1.IForwardingRuleList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ForwardingRuleList} ForwardingRuleList instance
                         */
                        ForwardingRuleList.create = function create(properties) {
                            return new ForwardingRuleList(properties);
                        };
    
                        /**
                         * Encodes the specified ForwardingRuleList message. Does not implicitly {@link google.cloud.compute.v1.ForwardingRuleList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @static
                         * @param {google.cloud.compute.v1.IForwardingRuleList} message ForwardingRuleList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ForwardingRuleList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.ForwardingRule.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ForwardingRuleList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ForwardingRuleList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @static
                         * @param {google.cloud.compute.v1.IForwardingRuleList} message ForwardingRuleList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ForwardingRuleList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ForwardingRuleList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ForwardingRuleList} ForwardingRuleList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ForwardingRuleList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ForwardingRuleList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.ForwardingRule.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ForwardingRuleList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ForwardingRuleList} ForwardingRuleList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ForwardingRuleList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ForwardingRuleList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ForwardingRuleList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ForwardingRule.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ForwardingRuleList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ForwardingRuleList} ForwardingRuleList
                         */
                        ForwardingRuleList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ForwardingRuleList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ForwardingRuleList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.ForwardingRuleList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ForwardingRuleList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.ForwardingRule.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ForwardingRuleList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ForwardingRuleList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @static
                         * @param {google.cloud.compute.v1.ForwardingRuleList} message ForwardingRuleList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ForwardingRuleList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.ForwardingRule.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ForwardingRuleList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ForwardingRuleList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ForwardingRuleList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ForwardingRuleList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ForwardingRuleList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ForwardingRuleList";
                        };
    
                        return ForwardingRuleList;
                    })();
    
                    v1.ForwardingRuleReference = (function() {
    
                        /**
                         * Properties of a ForwardingRuleReference.
                         * @memberof google.cloud.compute.v1
                         * @interface IForwardingRuleReference
                         * @property {string|null} [forwardingRule] ForwardingRuleReference forwardingRule
                         */
    
                        /**
                         * Constructs a new ForwardingRuleReference.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ForwardingRuleReference.
                         * @implements IForwardingRuleReference
                         * @constructor
                         * @param {google.cloud.compute.v1.IForwardingRuleReference=} [properties] Properties to set
                         */
                        function ForwardingRuleReference(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ForwardingRuleReference forwardingRule.
                         * @member {string|null|undefined} forwardingRule
                         * @memberof google.cloud.compute.v1.ForwardingRuleReference
                         * @instance
                         */
                        ForwardingRuleReference.prototype.forwardingRule = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ForwardingRuleReference _forwardingRule.
                         * @member {"forwardingRule"|undefined} _forwardingRule
                         * @memberof google.cloud.compute.v1.ForwardingRuleReference
                         * @instance
                         */
                        Object.defineProperty(ForwardingRuleReference.prototype, "_forwardingRule", {
                            get: $util.oneOfGetter($oneOfFields = ["forwardingRule"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ForwardingRuleReference instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ForwardingRuleReference
                         * @static
                         * @param {google.cloud.compute.v1.IForwardingRuleReference=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ForwardingRuleReference} ForwardingRuleReference instance
                         */
                        ForwardingRuleReference.create = function create(properties) {
                            return new ForwardingRuleReference(properties);
                        };
    
                        /**
                         * Encodes the specified ForwardingRuleReference message. Does not implicitly {@link google.cloud.compute.v1.ForwardingRuleReference.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ForwardingRuleReference
                         * @static
                         * @param {google.cloud.compute.v1.IForwardingRuleReference} message ForwardingRuleReference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ForwardingRuleReference.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.forwardingRule != null && Object.hasOwnProperty.call(message, "forwardingRule"))
                                writer.uint32(/* id 269964030, wireType 2 =*/2159712242).string(message.forwardingRule);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ForwardingRuleReference message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ForwardingRuleReference.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ForwardingRuleReference
                         * @static
                         * @param {google.cloud.compute.v1.IForwardingRuleReference} message ForwardingRuleReference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ForwardingRuleReference.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ForwardingRuleReference message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ForwardingRuleReference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ForwardingRuleReference} ForwardingRuleReference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ForwardingRuleReference.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ForwardingRuleReference();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 269964030: {
                                        message.forwardingRule = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ForwardingRuleReference message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ForwardingRuleReference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ForwardingRuleReference} ForwardingRuleReference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ForwardingRuleReference.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ForwardingRuleReference message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ForwardingRuleReference
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ForwardingRuleReference.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule")) {
                                properties._forwardingRule = 1;
                                if (!$util.isString(message.forwardingRule))
                                    return "forwardingRule: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ForwardingRuleReference message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ForwardingRuleReference
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ForwardingRuleReference} ForwardingRuleReference
                         */
                        ForwardingRuleReference.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ForwardingRuleReference)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ForwardingRuleReference();
                            if (object.forwardingRule != null)
                                message.forwardingRule = String(object.forwardingRule);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ForwardingRuleReference message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ForwardingRuleReference
                         * @static
                         * @param {google.cloud.compute.v1.ForwardingRuleReference} message ForwardingRuleReference
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ForwardingRuleReference.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule")) {
                                object.forwardingRule = message.forwardingRule;
                                if (options.oneofs)
                                    object._forwardingRule = "forwardingRule";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ForwardingRuleReference to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ForwardingRuleReference
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ForwardingRuleReference.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ForwardingRuleReference
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ForwardingRuleReference
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ForwardingRuleReference.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ForwardingRuleReference";
                        };
    
                        return ForwardingRuleReference;
                    })();
    
                    v1.ForwardingRuleServiceDirectoryRegistration = (function() {
    
                        /**
                         * Properties of a ForwardingRuleServiceDirectoryRegistration.
                         * @memberof google.cloud.compute.v1
                         * @interface IForwardingRuleServiceDirectoryRegistration
                         * @property {string|null} [namespace] ForwardingRuleServiceDirectoryRegistration namespace
                         * @property {string|null} [service] ForwardingRuleServiceDirectoryRegistration service
                         * @property {string|null} [serviceDirectoryRegion] ForwardingRuleServiceDirectoryRegistration serviceDirectoryRegion
                         */
    
                        /**
                         * Constructs a new ForwardingRuleServiceDirectoryRegistration.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ForwardingRuleServiceDirectoryRegistration.
                         * @implements IForwardingRuleServiceDirectoryRegistration
                         * @constructor
                         * @param {google.cloud.compute.v1.IForwardingRuleServiceDirectoryRegistration=} [properties] Properties to set
                         */
                        function ForwardingRuleServiceDirectoryRegistration(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ForwardingRuleServiceDirectoryRegistration namespace.
                         * @member {string|null|undefined} namespace
                         * @memberof google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration
                         * @instance
                         */
                        ForwardingRuleServiceDirectoryRegistration.prototype.namespace = null;
    
                        /**
                         * ForwardingRuleServiceDirectoryRegistration service.
                         * @member {string|null|undefined} service
                         * @memberof google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration
                         * @instance
                         */
                        ForwardingRuleServiceDirectoryRegistration.prototype.service = null;
    
                        /**
                         * ForwardingRuleServiceDirectoryRegistration serviceDirectoryRegion.
                         * @member {string|null|undefined} serviceDirectoryRegion
                         * @memberof google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration
                         * @instance
                         */
                        ForwardingRuleServiceDirectoryRegistration.prototype.serviceDirectoryRegion = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ForwardingRuleServiceDirectoryRegistration _namespace.
                         * @member {"namespace"|undefined} _namespace
                         * @memberof google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration
                         * @instance
                         */
                        Object.defineProperty(ForwardingRuleServiceDirectoryRegistration.prototype, "_namespace", {
                            get: $util.oneOfGetter($oneOfFields = ["namespace"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRuleServiceDirectoryRegistration _service.
                         * @member {"service"|undefined} _service
                         * @memberof google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration
                         * @instance
                         */
                        Object.defineProperty(ForwardingRuleServiceDirectoryRegistration.prototype, "_service", {
                            get: $util.oneOfGetter($oneOfFields = ["service"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ForwardingRuleServiceDirectoryRegistration _serviceDirectoryRegion.
                         * @member {"serviceDirectoryRegion"|undefined} _serviceDirectoryRegion
                         * @memberof google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration
                         * @instance
                         */
                        Object.defineProperty(ForwardingRuleServiceDirectoryRegistration.prototype, "_serviceDirectoryRegion", {
                            get: $util.oneOfGetter($oneOfFields = ["serviceDirectoryRegion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ForwardingRuleServiceDirectoryRegistration instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration
                         * @static
                         * @param {google.cloud.compute.v1.IForwardingRuleServiceDirectoryRegistration=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration} ForwardingRuleServiceDirectoryRegistration instance
                         */
                        ForwardingRuleServiceDirectoryRegistration.create = function create(properties) {
                            return new ForwardingRuleServiceDirectoryRegistration(properties);
                        };
    
                        /**
                         * Encodes the specified ForwardingRuleServiceDirectoryRegistration message. Does not implicitly {@link google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration
                         * @static
                         * @param {google.cloud.compute.v1.IForwardingRuleServiceDirectoryRegistration} message ForwardingRuleServiceDirectoryRegistration message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ForwardingRuleServiceDirectoryRegistration.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.serviceDirectoryRegion != null && Object.hasOwnProperty.call(message, "serviceDirectoryRegion"))
                                writer.uint32(/* id 74030416, wireType 2 =*/592243330).string(message.serviceDirectoryRegion);
                            if (message.namespace != null && Object.hasOwnProperty.call(message, "namespace"))
                                writer.uint32(/* id 178476379, wireType 2 =*/1427811034).string(message.namespace);
                            if (message.service != null && Object.hasOwnProperty.call(message, "service"))
                                writer.uint32(/* id 373540533, wireType 2 =*/2988324266).string(message.service);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ForwardingRuleServiceDirectoryRegistration message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration
                         * @static
                         * @param {google.cloud.compute.v1.IForwardingRuleServiceDirectoryRegistration} message ForwardingRuleServiceDirectoryRegistration message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ForwardingRuleServiceDirectoryRegistration.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ForwardingRuleServiceDirectoryRegistration message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration} ForwardingRuleServiceDirectoryRegistration
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ForwardingRuleServiceDirectoryRegistration.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 178476379: {
                                        message.namespace = reader.string();
                                        break;
                                    }
                                case 373540533: {
                                        message.service = reader.string();
                                        break;
                                    }
                                case 74030416: {
                                        message.serviceDirectoryRegion = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ForwardingRuleServiceDirectoryRegistration message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration} ForwardingRuleServiceDirectoryRegistration
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ForwardingRuleServiceDirectoryRegistration.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ForwardingRuleServiceDirectoryRegistration message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ForwardingRuleServiceDirectoryRegistration.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.namespace != null && message.hasOwnProperty("namespace")) {
                                properties._namespace = 1;
                                if (!$util.isString(message.namespace))
                                    return "namespace: string expected";
                            }
                            if (message.service != null && message.hasOwnProperty("service")) {
                                properties._service = 1;
                                if (!$util.isString(message.service))
                                    return "service: string expected";
                            }
                            if (message.serviceDirectoryRegion != null && message.hasOwnProperty("serviceDirectoryRegion")) {
                                properties._serviceDirectoryRegion = 1;
                                if (!$util.isString(message.serviceDirectoryRegion))
                                    return "serviceDirectoryRegion: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ForwardingRuleServiceDirectoryRegistration message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration} ForwardingRuleServiceDirectoryRegistration
                         */
                        ForwardingRuleServiceDirectoryRegistration.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration();
                            if (object.namespace != null)
                                message.namespace = String(object.namespace);
                            if (object.service != null)
                                message.service = String(object.service);
                            if (object.serviceDirectoryRegion != null)
                                message.serviceDirectoryRegion = String(object.serviceDirectoryRegion);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ForwardingRuleServiceDirectoryRegistration message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration
                         * @static
                         * @param {google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration} message ForwardingRuleServiceDirectoryRegistration
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ForwardingRuleServiceDirectoryRegistration.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.serviceDirectoryRegion != null && message.hasOwnProperty("serviceDirectoryRegion")) {
                                object.serviceDirectoryRegion = message.serviceDirectoryRegion;
                                if (options.oneofs)
                                    object._serviceDirectoryRegion = "serviceDirectoryRegion";
                            }
                            if (message.namespace != null && message.hasOwnProperty("namespace")) {
                                object.namespace = message.namespace;
                                if (options.oneofs)
                                    object._namespace = "namespace";
                            }
                            if (message.service != null && message.hasOwnProperty("service")) {
                                object.service = message.service;
                                if (options.oneofs)
                                    object._service = "service";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ForwardingRuleServiceDirectoryRegistration to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ForwardingRuleServiceDirectoryRegistration.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ForwardingRuleServiceDirectoryRegistration
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ForwardingRuleServiceDirectoryRegistration.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ForwardingRuleServiceDirectoryRegistration";
                        };
    
                        return ForwardingRuleServiceDirectoryRegistration;
                    })();
    
                    v1.ForwardingRulesScopedList = (function() {
    
                        /**
                         * Properties of a ForwardingRulesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IForwardingRulesScopedList
                         * @property {Array.<google.cloud.compute.v1.IForwardingRule>|null} [forwardingRules] ForwardingRulesScopedList forwardingRules
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] ForwardingRulesScopedList warning
                         */
    
                        /**
                         * Constructs a new ForwardingRulesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ForwardingRulesScopedList.
                         * @implements IForwardingRulesScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IForwardingRulesScopedList=} [properties] Properties to set
                         */
                        function ForwardingRulesScopedList(properties) {
                            this.forwardingRules = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ForwardingRulesScopedList forwardingRules.
                         * @member {Array.<google.cloud.compute.v1.IForwardingRule>} forwardingRules
                         * @memberof google.cloud.compute.v1.ForwardingRulesScopedList
                         * @instance
                         */
                        ForwardingRulesScopedList.prototype.forwardingRules = $util.emptyArray;
    
                        /**
                         * ForwardingRulesScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.ForwardingRulesScopedList
                         * @instance
                         */
                        ForwardingRulesScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ForwardingRulesScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.ForwardingRulesScopedList
                         * @instance
                         */
                        Object.defineProperty(ForwardingRulesScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ForwardingRulesScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ForwardingRulesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IForwardingRulesScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ForwardingRulesScopedList} ForwardingRulesScopedList instance
                         */
                        ForwardingRulesScopedList.create = function create(properties) {
                            return new ForwardingRulesScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified ForwardingRulesScopedList message. Does not implicitly {@link google.cloud.compute.v1.ForwardingRulesScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ForwardingRulesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IForwardingRulesScopedList} message ForwardingRulesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ForwardingRulesScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.forwardingRules != null && message.forwardingRules.length)
                                for (var i = 0; i < message.forwardingRules.length; ++i)
                                    $root.google.cloud.compute.v1.ForwardingRule.encode(message.forwardingRules[i], writer.uint32(/* id 315821365, wireType 2 =*/2526570922).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ForwardingRulesScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ForwardingRulesScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ForwardingRulesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IForwardingRulesScopedList} message ForwardingRulesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ForwardingRulesScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ForwardingRulesScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ForwardingRulesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ForwardingRulesScopedList} ForwardingRulesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ForwardingRulesScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ForwardingRulesScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 315821365: {
                                        if (!(message.forwardingRules && message.forwardingRules.length))
                                            message.forwardingRules = [];
                                        message.forwardingRules.push($root.google.cloud.compute.v1.ForwardingRule.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ForwardingRulesScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ForwardingRulesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ForwardingRulesScopedList} ForwardingRulesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ForwardingRulesScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ForwardingRulesScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ForwardingRulesScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ForwardingRulesScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.forwardingRules != null && message.hasOwnProperty("forwardingRules")) {
                                if (!Array.isArray(message.forwardingRules))
                                    return "forwardingRules: array expected";
                                for (var i = 0; i < message.forwardingRules.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ForwardingRule.verify(message.forwardingRules[i]);
                                    if (error)
                                        return "forwardingRules." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ForwardingRulesScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ForwardingRulesScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ForwardingRulesScopedList} ForwardingRulesScopedList
                         */
                        ForwardingRulesScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ForwardingRulesScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ForwardingRulesScopedList();
                            if (object.forwardingRules) {
                                if (!Array.isArray(object.forwardingRules))
                                    throw TypeError(".google.cloud.compute.v1.ForwardingRulesScopedList.forwardingRules: array expected");
                                message.forwardingRules = [];
                                for (var i = 0; i < object.forwardingRules.length; ++i) {
                                    if (typeof object.forwardingRules[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ForwardingRulesScopedList.forwardingRules: object expected");
                                    message.forwardingRules[i] = $root.google.cloud.compute.v1.ForwardingRule.fromObject(object.forwardingRules[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ForwardingRulesScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ForwardingRulesScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ForwardingRulesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ForwardingRulesScopedList} message ForwardingRulesScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ForwardingRulesScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.forwardingRules = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.forwardingRules && message.forwardingRules.length) {
                                object.forwardingRules = [];
                                for (var j = 0; j < message.forwardingRules.length; ++j)
                                    object.forwardingRules[j] = $root.google.cloud.compute.v1.ForwardingRule.toObject(message.forwardingRules[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ForwardingRulesScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ForwardingRulesScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ForwardingRulesScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ForwardingRulesScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ForwardingRulesScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ForwardingRulesScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ForwardingRulesScopedList";
                        };
    
                        return ForwardingRulesScopedList;
                    })();
    
                    v1.GRPCHealthCheck = (function() {
    
                        /**
                         * Properties of a GRPCHealthCheck.
                         * @memberof google.cloud.compute.v1
                         * @interface IGRPCHealthCheck
                         * @property {string|null} [grpcServiceName] GRPCHealthCheck grpcServiceName
                         * @property {number|null} [port] GRPCHealthCheck port
                         * @property {string|null} [portName] GRPCHealthCheck portName
                         * @property {string|null} [portSpecification] GRPCHealthCheck portSpecification
                         */
    
                        /**
                         * Constructs a new GRPCHealthCheck.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GRPCHealthCheck.
                         * @implements IGRPCHealthCheck
                         * @constructor
                         * @param {google.cloud.compute.v1.IGRPCHealthCheck=} [properties] Properties to set
                         */
                        function GRPCHealthCheck(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GRPCHealthCheck grpcServiceName.
                         * @member {string|null|undefined} grpcServiceName
                         * @memberof google.cloud.compute.v1.GRPCHealthCheck
                         * @instance
                         */
                        GRPCHealthCheck.prototype.grpcServiceName = null;
    
                        /**
                         * GRPCHealthCheck port.
                         * @member {number|null|undefined} port
                         * @memberof google.cloud.compute.v1.GRPCHealthCheck
                         * @instance
                         */
                        GRPCHealthCheck.prototype.port = null;
    
                        /**
                         * GRPCHealthCheck portName.
                         * @member {string|null|undefined} portName
                         * @memberof google.cloud.compute.v1.GRPCHealthCheck
                         * @instance
                         */
                        GRPCHealthCheck.prototype.portName = null;
    
                        /**
                         * GRPCHealthCheck portSpecification.
                         * @member {string|null|undefined} portSpecification
                         * @memberof google.cloud.compute.v1.GRPCHealthCheck
                         * @instance
                         */
                        GRPCHealthCheck.prototype.portSpecification = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GRPCHealthCheck _grpcServiceName.
                         * @member {"grpcServiceName"|undefined} _grpcServiceName
                         * @memberof google.cloud.compute.v1.GRPCHealthCheck
                         * @instance
                         */
                        Object.defineProperty(GRPCHealthCheck.prototype, "_grpcServiceName", {
                            get: $util.oneOfGetter($oneOfFields = ["grpcServiceName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GRPCHealthCheck _port.
                         * @member {"port"|undefined} _port
                         * @memberof google.cloud.compute.v1.GRPCHealthCheck
                         * @instance
                         */
                        Object.defineProperty(GRPCHealthCheck.prototype, "_port", {
                            get: $util.oneOfGetter($oneOfFields = ["port"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GRPCHealthCheck _portName.
                         * @member {"portName"|undefined} _portName
                         * @memberof google.cloud.compute.v1.GRPCHealthCheck
                         * @instance
                         */
                        Object.defineProperty(GRPCHealthCheck.prototype, "_portName", {
                            get: $util.oneOfGetter($oneOfFields = ["portName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GRPCHealthCheck _portSpecification.
                         * @member {"portSpecification"|undefined} _portSpecification
                         * @memberof google.cloud.compute.v1.GRPCHealthCheck
                         * @instance
                         */
                        Object.defineProperty(GRPCHealthCheck.prototype, "_portSpecification", {
                            get: $util.oneOfGetter($oneOfFields = ["portSpecification"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GRPCHealthCheck instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GRPCHealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.IGRPCHealthCheck=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GRPCHealthCheck} GRPCHealthCheck instance
                         */
                        GRPCHealthCheck.create = function create(properties) {
                            return new GRPCHealthCheck(properties);
                        };
    
                        /**
                         * Encodes the specified GRPCHealthCheck message. Does not implicitly {@link google.cloud.compute.v1.GRPCHealthCheck.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GRPCHealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.IGRPCHealthCheck} message GRPCHealthCheck message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GRPCHealthCheck.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.port != null && Object.hasOwnProperty.call(message, "port"))
                                writer.uint32(/* id 3446913, wireType 0 =*/27575304).int32(message.port);
                            if (message.portName != null && Object.hasOwnProperty.call(message, "portName"))
                                writer.uint32(/* id 41534345, wireType 2 =*/332274762).string(message.portName);
                            if (message.portSpecification != null && Object.hasOwnProperty.call(message, "portSpecification"))
                                writer.uint32(/* id 51590597, wireType 2 =*/412724778).string(message.portSpecification);
                            if (message.grpcServiceName != null && Object.hasOwnProperty.call(message, "grpcServiceName"))
                                writer.uint32(/* id 136533078, wireType 2 =*/1092264626).string(message.grpcServiceName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GRPCHealthCheck message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GRPCHealthCheck.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GRPCHealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.IGRPCHealthCheck} message GRPCHealthCheck message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GRPCHealthCheck.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GRPCHealthCheck message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GRPCHealthCheck
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GRPCHealthCheck} GRPCHealthCheck
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GRPCHealthCheck.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GRPCHealthCheck();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 136533078: {
                                        message.grpcServiceName = reader.string();
                                        break;
                                    }
                                case 3446913: {
                                        message.port = reader.int32();
                                        break;
                                    }
                                case 41534345: {
                                        message.portName = reader.string();
                                        break;
                                    }
                                case 51590597: {
                                        message.portSpecification = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GRPCHealthCheck message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GRPCHealthCheck
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GRPCHealthCheck} GRPCHealthCheck
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GRPCHealthCheck.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GRPCHealthCheck message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GRPCHealthCheck
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GRPCHealthCheck.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.grpcServiceName != null && message.hasOwnProperty("grpcServiceName")) {
                                properties._grpcServiceName = 1;
                                if (!$util.isString(message.grpcServiceName))
                                    return "grpcServiceName: string expected";
                            }
                            if (message.port != null && message.hasOwnProperty("port")) {
                                properties._port = 1;
                                if (!$util.isInteger(message.port))
                                    return "port: integer expected";
                            }
                            if (message.portName != null && message.hasOwnProperty("portName")) {
                                properties._portName = 1;
                                if (!$util.isString(message.portName))
                                    return "portName: string expected";
                            }
                            if (message.portSpecification != null && message.hasOwnProperty("portSpecification")) {
                                properties._portSpecification = 1;
                                if (!$util.isString(message.portSpecification))
                                    return "portSpecification: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a GRPCHealthCheck message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GRPCHealthCheck
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GRPCHealthCheck} GRPCHealthCheck
                         */
                        GRPCHealthCheck.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GRPCHealthCheck)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GRPCHealthCheck();
                            if (object.grpcServiceName != null)
                                message.grpcServiceName = String(object.grpcServiceName);
                            if (object.port != null)
                                message.port = object.port | 0;
                            if (object.portName != null)
                                message.portName = String(object.portName);
                            if (object.portSpecification != null)
                                message.portSpecification = String(object.portSpecification);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GRPCHealthCheck message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GRPCHealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.GRPCHealthCheck} message GRPCHealthCheck
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GRPCHealthCheck.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.port != null && message.hasOwnProperty("port")) {
                                object.port = message.port;
                                if (options.oneofs)
                                    object._port = "port";
                            }
                            if (message.portName != null && message.hasOwnProperty("portName")) {
                                object.portName = message.portName;
                                if (options.oneofs)
                                    object._portName = "portName";
                            }
                            if (message.portSpecification != null && message.hasOwnProperty("portSpecification")) {
                                object.portSpecification = message.portSpecification;
                                if (options.oneofs)
                                    object._portSpecification = "portSpecification";
                            }
                            if (message.grpcServiceName != null && message.hasOwnProperty("grpcServiceName")) {
                                object.grpcServiceName = message.grpcServiceName;
                                if (options.oneofs)
                                    object._grpcServiceName = "grpcServiceName";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GRPCHealthCheck to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GRPCHealthCheck
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GRPCHealthCheck.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GRPCHealthCheck
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GRPCHealthCheck
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GRPCHealthCheck.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GRPCHealthCheck";
                        };
    
                        /**
                         * PortSpecification enum.
                         * @name google.cloud.compute.v1.GRPCHealthCheck.PortSpecification
                         * @enum {number}
                         * @property {number} UNDEFINED_PORT_SPECIFICATION=0 UNDEFINED_PORT_SPECIFICATION value
                         * @property {number} USE_FIXED_PORT=190235748 USE_FIXED_PORT value
                         * @property {number} USE_NAMED_PORT=349300671 USE_NAMED_PORT value
                         * @property {number} USE_SERVING_PORT=362637516 USE_SERVING_PORT value
                         */
                        GRPCHealthCheck.PortSpecification = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PORT_SPECIFICATION"] = 0;
                            values[valuesById[190235748] = "USE_FIXED_PORT"] = 190235748;
                            values[valuesById[349300671] = "USE_NAMED_PORT"] = 349300671;
                            values[valuesById[362637516] = "USE_SERVING_PORT"] = 362637516;
                            return values;
                        })();
    
                        return GRPCHealthCheck;
                    })();
    
                    v1.GetAcceleratorTypeRequest = (function() {
    
                        /**
                         * Properties of a GetAcceleratorTypeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetAcceleratorTypeRequest
                         * @property {string|null} [acceleratorType] GetAcceleratorTypeRequest acceleratorType
                         * @property {string|null} [project] GetAcceleratorTypeRequest project
                         * @property {string|null} [zone] GetAcceleratorTypeRequest zone
                         */
    
                        /**
                         * Constructs a new GetAcceleratorTypeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetAcceleratorTypeRequest.
                         * @implements IGetAcceleratorTypeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetAcceleratorTypeRequest=} [properties] Properties to set
                         */
                        function GetAcceleratorTypeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetAcceleratorTypeRequest acceleratorType.
                         * @member {string} acceleratorType
                         * @memberof google.cloud.compute.v1.GetAcceleratorTypeRequest
                         * @instance
                         */
                        GetAcceleratorTypeRequest.prototype.acceleratorType = "";
    
                        /**
                         * GetAcceleratorTypeRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetAcceleratorTypeRequest
                         * @instance
                         */
                        GetAcceleratorTypeRequest.prototype.project = "";
    
                        /**
                         * GetAcceleratorTypeRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetAcceleratorTypeRequest
                         * @instance
                         */
                        GetAcceleratorTypeRequest.prototype.zone = "";
    
                        /**
                         * Creates a new GetAcceleratorTypeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetAcceleratorTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetAcceleratorTypeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetAcceleratorTypeRequest} GetAcceleratorTypeRequest instance
                         */
                        GetAcceleratorTypeRequest.create = function create(properties) {
                            return new GetAcceleratorTypeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetAcceleratorTypeRequest message. Does not implicitly {@link google.cloud.compute.v1.GetAcceleratorTypeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetAcceleratorTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetAcceleratorTypeRequest} message GetAcceleratorTypeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAcceleratorTypeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.acceleratorType != null && Object.hasOwnProperty.call(message, "acceleratorType"))
                                writer.uint32(/* id 138031246, wireType 2 =*/1104249970).string(message.acceleratorType);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetAcceleratorTypeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetAcceleratorTypeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetAcceleratorTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetAcceleratorTypeRequest} message GetAcceleratorTypeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAcceleratorTypeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetAcceleratorTypeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetAcceleratorTypeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetAcceleratorTypeRequest} GetAcceleratorTypeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAcceleratorTypeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetAcceleratorTypeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 138031246: {
                                        message.acceleratorType = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetAcceleratorTypeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetAcceleratorTypeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetAcceleratorTypeRequest} GetAcceleratorTypeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAcceleratorTypeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetAcceleratorTypeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetAcceleratorTypeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAcceleratorTypeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.acceleratorType != null && message.hasOwnProperty("acceleratorType"))
                                if (!$util.isString(message.acceleratorType))
                                    return "acceleratorType: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetAcceleratorTypeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetAcceleratorTypeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetAcceleratorTypeRequest} GetAcceleratorTypeRequest
                         */
                        GetAcceleratorTypeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetAcceleratorTypeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetAcceleratorTypeRequest();
                            if (object.acceleratorType != null)
                                message.acceleratorType = String(object.acceleratorType);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetAcceleratorTypeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetAcceleratorTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetAcceleratorTypeRequest} message GetAcceleratorTypeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAcceleratorTypeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.acceleratorType = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.acceleratorType != null && message.hasOwnProperty("acceleratorType"))
                                object.acceleratorType = message.acceleratorType;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetAcceleratorTypeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetAcceleratorTypeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAcceleratorTypeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetAcceleratorTypeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetAcceleratorTypeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetAcceleratorTypeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetAcceleratorTypeRequest";
                        };
    
                        return GetAcceleratorTypeRequest;
                    })();
    
                    v1.GetAddressRequest = (function() {
    
                        /**
                         * Properties of a GetAddressRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetAddressRequest
                         * @property {string|null} [address] GetAddressRequest address
                         * @property {string|null} [project] GetAddressRequest project
                         * @property {string|null} [region] GetAddressRequest region
                         */
    
                        /**
                         * Constructs a new GetAddressRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetAddressRequest.
                         * @implements IGetAddressRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetAddressRequest=} [properties] Properties to set
                         */
                        function GetAddressRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetAddressRequest address.
                         * @member {string} address
                         * @memberof google.cloud.compute.v1.GetAddressRequest
                         * @instance
                         */
                        GetAddressRequest.prototype.address = "";
    
                        /**
                         * GetAddressRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetAddressRequest
                         * @instance
                         */
                        GetAddressRequest.prototype.project = "";
    
                        /**
                         * GetAddressRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetAddressRequest
                         * @instance
                         */
                        GetAddressRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetAddressRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetAddressRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetAddressRequest} GetAddressRequest instance
                         */
                        GetAddressRequest.create = function create(properties) {
                            return new GetAddressRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetAddressRequest message. Does not implicitly {@link google.cloud.compute.v1.GetAddressRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetAddressRequest} message GetAddressRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAddressRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.address != null && Object.hasOwnProperty.call(message, "address"))
                                writer.uint32(/* id 462920692, wireType 2 =*/3703365538).string(message.address);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetAddressRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetAddressRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetAddressRequest} message GetAddressRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAddressRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetAddressRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetAddressRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetAddressRequest} GetAddressRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAddressRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetAddressRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 462920692: {
                                        message.address = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetAddressRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetAddressRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetAddressRequest} GetAddressRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAddressRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetAddressRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetAddressRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAddressRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.address != null && message.hasOwnProperty("address"))
                                if (!$util.isString(message.address))
                                    return "address: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetAddressRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetAddressRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetAddressRequest} GetAddressRequest
                         */
                        GetAddressRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetAddressRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetAddressRequest();
                            if (object.address != null)
                                message.address = String(object.address);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetAddressRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetAddressRequest} message GetAddressRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAddressRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.address = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.address != null && message.hasOwnProperty("address"))
                                object.address = message.address;
                            return object;
                        };
    
                        /**
                         * Converts this GetAddressRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetAddressRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAddressRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetAddressRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetAddressRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetAddressRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetAddressRequest";
                        };
    
                        return GetAddressRequest;
                    })();
    
                    v1.GetAssociationFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a GetAssociationFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetAssociationFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] GetAssociationFirewallPolicyRequest firewallPolicy
                         * @property {string|null} [name] GetAssociationFirewallPolicyRequest name
                         */
    
                        /**
                         * Constructs a new GetAssociationFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetAssociationFirewallPolicyRequest.
                         * @implements IGetAssociationFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetAssociationFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function GetAssociationFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetAssociationFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.GetAssociationFirewallPolicyRequest
                         * @instance
                         */
                        GetAssociationFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * GetAssociationFirewallPolicyRequest name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.GetAssociationFirewallPolicyRequest
                         * @instance
                         */
                        GetAssociationFirewallPolicyRequest.prototype.name = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetAssociationFirewallPolicyRequest _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.GetAssociationFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(GetAssociationFirewallPolicyRequest.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetAssociationFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetAssociationFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetAssociationFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetAssociationFirewallPolicyRequest} GetAssociationFirewallPolicyRequest instance
                         */
                        GetAssociationFirewallPolicyRequest.create = function create(properties) {
                            return new GetAssociationFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetAssociationFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetAssociationFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetAssociationFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetAssociationFirewallPolicyRequest} message GetAssociationFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAssociationFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetAssociationFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetAssociationFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetAssociationFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetAssociationFirewallPolicyRequest} message GetAssociationFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAssociationFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetAssociationFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetAssociationFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetAssociationFirewallPolicyRequest} GetAssociationFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAssociationFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetAssociationFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetAssociationFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetAssociationFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetAssociationFirewallPolicyRequest} GetAssociationFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAssociationFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetAssociationFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetAssociationFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAssociationFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a GetAssociationFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetAssociationFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetAssociationFirewallPolicyRequest} GetAssociationFirewallPolicyRequest
                         */
                        GetAssociationFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetAssociationFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetAssociationFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetAssociationFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetAssociationFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetAssociationFirewallPolicyRequest} message GetAssociationFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAssociationFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.firewallPolicy = "";
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this GetAssociationFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetAssociationFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAssociationFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetAssociationFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetAssociationFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetAssociationFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetAssociationFirewallPolicyRequest";
                        };
    
                        return GetAssociationFirewallPolicyRequest;
                    })();
    
                    v1.GetAssociationNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a GetAssociationNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetAssociationNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] GetAssociationNetworkFirewallPolicyRequest firewallPolicy
                         * @property {string|null} [name] GetAssociationNetworkFirewallPolicyRequest name
                         * @property {string|null} [project] GetAssociationNetworkFirewallPolicyRequest project
                         */
    
                        /**
                         * Constructs a new GetAssociationNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetAssociationNetworkFirewallPolicyRequest.
                         * @implements IGetAssociationNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetAssociationNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function GetAssociationNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetAssociationNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetAssociationNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * GetAssociationNetworkFirewallPolicyRequest name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetAssociationNetworkFirewallPolicyRequest.prototype.name = null;
    
                        /**
                         * GetAssociationNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetAssociationNetworkFirewallPolicyRequest.prototype.project = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetAssociationNetworkFirewallPolicyRequest _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(GetAssociationNetworkFirewallPolicyRequest.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetAssociationNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetAssociationNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest} GetAssociationNetworkFirewallPolicyRequest instance
                         */
                        GetAssociationNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new GetAssociationNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetAssociationNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetAssociationNetworkFirewallPolicyRequest} message GetAssociationNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAssociationNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetAssociationNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetAssociationNetworkFirewallPolicyRequest} message GetAssociationNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAssociationNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetAssociationNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest} GetAssociationNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAssociationNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetAssociationNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest} GetAssociationNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAssociationNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetAssociationNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAssociationNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetAssociationNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest} GetAssociationNetworkFirewallPolicyRequest
                         */
                        GetAssociationNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetAssociationNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest} message GetAssociationNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAssociationNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.firewallPolicy = "";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this GetAssociationNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAssociationNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetAssociationNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetAssociationNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest";
                        };
    
                        return GetAssociationNetworkFirewallPolicyRequest;
                    })();
    
                    v1.GetAssociationRegionNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a GetAssociationRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetAssociationRegionNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] GetAssociationRegionNetworkFirewallPolicyRequest firewallPolicy
                         * @property {string|null} [name] GetAssociationRegionNetworkFirewallPolicyRequest name
                         * @property {string|null} [project] GetAssociationRegionNetworkFirewallPolicyRequest project
                         * @property {string|null} [region] GetAssociationRegionNetworkFirewallPolicyRequest region
                         */
    
                        /**
                         * Constructs a new GetAssociationRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetAssociationRegionNetworkFirewallPolicyRequest.
                         * @implements IGetAssociationRegionNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetAssociationRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function GetAssociationRegionNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetAssociationRegionNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetAssociationRegionNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * GetAssociationRegionNetworkFirewallPolicyRequest name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetAssociationRegionNetworkFirewallPolicyRequest.prototype.name = null;
    
                        /**
                         * GetAssociationRegionNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetAssociationRegionNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * GetAssociationRegionNetworkFirewallPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetAssociationRegionNetworkFirewallPolicyRequest.prototype.region = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetAssociationRegionNetworkFirewallPolicyRequest _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(GetAssociationRegionNetworkFirewallPolicyRequest.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetAssociationRegionNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetAssociationRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest} GetAssociationRegionNetworkFirewallPolicyRequest instance
                         */
                        GetAssociationRegionNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new GetAssociationRegionNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetAssociationRegionNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetAssociationRegionNetworkFirewallPolicyRequest} message GetAssociationRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAssociationRegionNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetAssociationRegionNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetAssociationRegionNetworkFirewallPolicyRequest} message GetAssociationRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAssociationRegionNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetAssociationRegionNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest} GetAssociationRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAssociationRegionNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetAssociationRegionNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest} GetAssociationRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAssociationRegionNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetAssociationRegionNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAssociationRegionNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetAssociationRegionNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest} GetAssociationRegionNetworkFirewallPolicyRequest
                         */
                        GetAssociationRegionNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetAssociationRegionNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest} message GetAssociationRegionNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAssociationRegionNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.firewallPolicy = "";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this GetAssociationRegionNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAssociationRegionNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetAssociationRegionNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetAssociationRegionNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest";
                        };
    
                        return GetAssociationRegionNetworkFirewallPolicyRequest;
                    })();
    
                    v1.GetAutoscalerRequest = (function() {
    
                        /**
                         * Properties of a GetAutoscalerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetAutoscalerRequest
                         * @property {string|null} [autoscaler] GetAutoscalerRequest autoscaler
                         * @property {string|null} [project] GetAutoscalerRequest project
                         * @property {string|null} [zone] GetAutoscalerRequest zone
                         */
    
                        /**
                         * Constructs a new GetAutoscalerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetAutoscalerRequest.
                         * @implements IGetAutoscalerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetAutoscalerRequest=} [properties] Properties to set
                         */
                        function GetAutoscalerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetAutoscalerRequest autoscaler.
                         * @member {string} autoscaler
                         * @memberof google.cloud.compute.v1.GetAutoscalerRequest
                         * @instance
                         */
                        GetAutoscalerRequest.prototype.autoscaler = "";
    
                        /**
                         * GetAutoscalerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetAutoscalerRequest
                         * @instance
                         */
                        GetAutoscalerRequest.prototype.project = "";
    
                        /**
                         * GetAutoscalerRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetAutoscalerRequest
                         * @instance
                         */
                        GetAutoscalerRequest.prototype.zone = "";
    
                        /**
                         * Creates a new GetAutoscalerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetAutoscalerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetAutoscalerRequest} GetAutoscalerRequest instance
                         */
                        GetAutoscalerRequest.create = function create(properties) {
                            return new GetAutoscalerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetAutoscalerRequest message. Does not implicitly {@link google.cloud.compute.v1.GetAutoscalerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetAutoscalerRequest} message GetAutoscalerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAutoscalerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.autoscaler != null && Object.hasOwnProperty.call(message, "autoscaler"))
                                writer.uint32(/* id 517258967, wireType 2 =*/4138071738).string(message.autoscaler);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetAutoscalerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetAutoscalerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetAutoscalerRequest} message GetAutoscalerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetAutoscalerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetAutoscalerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetAutoscalerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetAutoscalerRequest} GetAutoscalerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAutoscalerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetAutoscalerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 517258967: {
                                        message.autoscaler = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetAutoscalerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetAutoscalerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetAutoscalerRequest} GetAutoscalerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetAutoscalerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetAutoscalerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetAutoscalerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetAutoscalerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.autoscaler != null && message.hasOwnProperty("autoscaler"))
                                if (!$util.isString(message.autoscaler))
                                    return "autoscaler: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetAutoscalerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetAutoscalerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetAutoscalerRequest} GetAutoscalerRequest
                         */
                        GetAutoscalerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetAutoscalerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetAutoscalerRequest();
                            if (object.autoscaler != null)
                                message.autoscaler = String(object.autoscaler);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetAutoscalerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetAutoscalerRequest} message GetAutoscalerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetAutoscalerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.autoscaler = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.autoscaler != null && message.hasOwnProperty("autoscaler"))
                                object.autoscaler = message.autoscaler;
                            return object;
                        };
    
                        /**
                         * Converts this GetAutoscalerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetAutoscalerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetAutoscalerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetAutoscalerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetAutoscalerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetAutoscalerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetAutoscalerRequest";
                        };
    
                        return GetAutoscalerRequest;
                    })();
    
                    v1.GetBackendBucketRequest = (function() {
    
                        /**
                         * Properties of a GetBackendBucketRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetBackendBucketRequest
                         * @property {string|null} [backendBucket] GetBackendBucketRequest backendBucket
                         * @property {string|null} [project] GetBackendBucketRequest project
                         */
    
                        /**
                         * Constructs a new GetBackendBucketRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetBackendBucketRequest.
                         * @implements IGetBackendBucketRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetBackendBucketRequest=} [properties] Properties to set
                         */
                        function GetBackendBucketRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetBackendBucketRequest backendBucket.
                         * @member {string} backendBucket
                         * @memberof google.cloud.compute.v1.GetBackendBucketRequest
                         * @instance
                         */
                        GetBackendBucketRequest.prototype.backendBucket = "";
    
                        /**
                         * GetBackendBucketRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetBackendBucketRequest
                         * @instance
                         */
                        GetBackendBucketRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetBackendBucketRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetBackendBucketRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetBackendBucketRequest} GetBackendBucketRequest instance
                         */
                        GetBackendBucketRequest.create = function create(properties) {
                            return new GetBackendBucketRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetBackendBucketRequest message. Does not implicitly {@link google.cloud.compute.v1.GetBackendBucketRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetBackendBucketRequest} message GetBackendBucketRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetBackendBucketRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.backendBucket != null && Object.hasOwnProperty.call(message, "backendBucket"))
                                writer.uint32(/* id 91714037, wireType 2 =*/733712298).string(message.backendBucket);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetBackendBucketRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetBackendBucketRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetBackendBucketRequest} message GetBackendBucketRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetBackendBucketRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetBackendBucketRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetBackendBucketRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetBackendBucketRequest} GetBackendBucketRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetBackendBucketRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetBackendBucketRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 91714037: {
                                        message.backendBucket = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetBackendBucketRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetBackendBucketRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetBackendBucketRequest} GetBackendBucketRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetBackendBucketRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetBackendBucketRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetBackendBucketRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetBackendBucketRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.backendBucket != null && message.hasOwnProperty("backendBucket"))
                                if (!$util.isString(message.backendBucket))
                                    return "backendBucket: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetBackendBucketRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetBackendBucketRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetBackendBucketRequest} GetBackendBucketRequest
                         */
                        GetBackendBucketRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetBackendBucketRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetBackendBucketRequest();
                            if (object.backendBucket != null)
                                message.backendBucket = String(object.backendBucket);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetBackendBucketRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetBackendBucketRequest} message GetBackendBucketRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetBackendBucketRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.backendBucket = "";
                                object.project = "";
                            }
                            if (message.backendBucket != null && message.hasOwnProperty("backendBucket"))
                                object.backendBucket = message.backendBucket;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetBackendBucketRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetBackendBucketRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetBackendBucketRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetBackendBucketRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetBackendBucketRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetBackendBucketRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetBackendBucketRequest";
                        };
    
                        return GetBackendBucketRequest;
                    })();
    
                    v1.GetBackendServiceRequest = (function() {
    
                        /**
                         * Properties of a GetBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetBackendServiceRequest
                         * @property {string|null} [backendService] GetBackendServiceRequest backendService
                         * @property {string|null} [project] GetBackendServiceRequest project
                         */
    
                        /**
                         * Constructs a new GetBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetBackendServiceRequest.
                         * @implements IGetBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetBackendServiceRequest=} [properties] Properties to set
                         */
                        function GetBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetBackendServiceRequest backendService.
                         * @member {string} backendService
                         * @memberof google.cloud.compute.v1.GetBackendServiceRequest
                         * @instance
                         */
                        GetBackendServiceRequest.prototype.backendService = "";
    
                        /**
                         * GetBackendServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetBackendServiceRequest
                         * @instance
                         */
                        GetBackendServiceRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetBackendServiceRequest} GetBackendServiceRequest instance
                         */
                        GetBackendServiceRequest.create = function create(properties) {
                            return new GetBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.GetBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetBackendServiceRequest} message GetBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.backendService != null && Object.hasOwnProperty.call(message, "backendService"))
                                writer.uint32(/* id 306946058, wireType 2 =*/2455568466).string(message.backendService);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetBackendServiceRequest} message GetBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetBackendServiceRequest} GetBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 306946058: {
                                        message.backendService = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetBackendServiceRequest} GetBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                if (!$util.isString(message.backendService))
                                    return "backendService: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetBackendServiceRequest} GetBackendServiceRequest
                         */
                        GetBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetBackendServiceRequest();
                            if (object.backendService != null)
                                message.backendService = String(object.backendService);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetBackendServiceRequest} message GetBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.backendService = "";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                object.backendService = message.backendService;
                            return object;
                        };
    
                        /**
                         * Converts this GetBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetBackendServiceRequest";
                        };
    
                        return GetBackendServiceRequest;
                    })();
    
                    v1.GetDiagnosticsInterconnectRequest = (function() {
    
                        /**
                         * Properties of a GetDiagnosticsInterconnectRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetDiagnosticsInterconnectRequest
                         * @property {string|null} [interconnect] GetDiagnosticsInterconnectRequest interconnect
                         * @property {string|null} [project] GetDiagnosticsInterconnectRequest project
                         */
    
                        /**
                         * Constructs a new GetDiagnosticsInterconnectRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetDiagnosticsInterconnectRequest.
                         * @implements IGetDiagnosticsInterconnectRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetDiagnosticsInterconnectRequest=} [properties] Properties to set
                         */
                        function GetDiagnosticsInterconnectRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetDiagnosticsInterconnectRequest interconnect.
                         * @member {string} interconnect
                         * @memberof google.cloud.compute.v1.GetDiagnosticsInterconnectRequest
                         * @instance
                         */
                        GetDiagnosticsInterconnectRequest.prototype.interconnect = "";
    
                        /**
                         * GetDiagnosticsInterconnectRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetDiagnosticsInterconnectRequest
                         * @instance
                         */
                        GetDiagnosticsInterconnectRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetDiagnosticsInterconnectRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetDiagnosticsInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetDiagnosticsInterconnectRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetDiagnosticsInterconnectRequest} GetDiagnosticsInterconnectRequest instance
                         */
                        GetDiagnosticsInterconnectRequest.create = function create(properties) {
                            return new GetDiagnosticsInterconnectRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetDiagnosticsInterconnectRequest message. Does not implicitly {@link google.cloud.compute.v1.GetDiagnosticsInterconnectRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetDiagnosticsInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetDiagnosticsInterconnectRequest} message GetDiagnosticsInterconnectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDiagnosticsInterconnectRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.interconnect != null && Object.hasOwnProperty.call(message, "interconnect"))
                                writer.uint32(/* id 224601230, wireType 2 =*/1796809842).string(message.interconnect);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetDiagnosticsInterconnectRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetDiagnosticsInterconnectRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetDiagnosticsInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetDiagnosticsInterconnectRequest} message GetDiagnosticsInterconnectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDiagnosticsInterconnectRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetDiagnosticsInterconnectRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetDiagnosticsInterconnectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetDiagnosticsInterconnectRequest} GetDiagnosticsInterconnectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDiagnosticsInterconnectRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetDiagnosticsInterconnectRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 224601230: {
                                        message.interconnect = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetDiagnosticsInterconnectRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetDiagnosticsInterconnectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetDiagnosticsInterconnectRequest} GetDiagnosticsInterconnectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDiagnosticsInterconnectRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetDiagnosticsInterconnectRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetDiagnosticsInterconnectRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetDiagnosticsInterconnectRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.interconnect != null && message.hasOwnProperty("interconnect"))
                                if (!$util.isString(message.interconnect))
                                    return "interconnect: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetDiagnosticsInterconnectRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetDiagnosticsInterconnectRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetDiagnosticsInterconnectRequest} GetDiagnosticsInterconnectRequest
                         */
                        GetDiagnosticsInterconnectRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetDiagnosticsInterconnectRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetDiagnosticsInterconnectRequest();
                            if (object.interconnect != null)
                                message.interconnect = String(object.interconnect);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetDiagnosticsInterconnectRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetDiagnosticsInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetDiagnosticsInterconnectRequest} message GetDiagnosticsInterconnectRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetDiagnosticsInterconnectRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.interconnect = "";
                                object.project = "";
                            }
                            if (message.interconnect != null && message.hasOwnProperty("interconnect"))
                                object.interconnect = message.interconnect;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetDiagnosticsInterconnectRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetDiagnosticsInterconnectRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetDiagnosticsInterconnectRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetDiagnosticsInterconnectRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetDiagnosticsInterconnectRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetDiagnosticsInterconnectRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetDiagnosticsInterconnectRequest";
                        };
    
                        return GetDiagnosticsInterconnectRequest;
                    })();
    
                    v1.GetDiskRequest = (function() {
    
                        /**
                         * Properties of a GetDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetDiskRequest
                         * @property {string|null} [disk] GetDiskRequest disk
                         * @property {string|null} [project] GetDiskRequest project
                         * @property {string|null} [zone] GetDiskRequest zone
                         */
    
                        /**
                         * Constructs a new GetDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetDiskRequest.
                         * @implements IGetDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetDiskRequest=} [properties] Properties to set
                         */
                        function GetDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetDiskRequest disk.
                         * @member {string} disk
                         * @memberof google.cloud.compute.v1.GetDiskRequest
                         * @instance
                         */
                        GetDiskRequest.prototype.disk = "";
    
                        /**
                         * GetDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetDiskRequest
                         * @instance
                         */
                        GetDiskRequest.prototype.project = "";
    
                        /**
                         * GetDiskRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetDiskRequest
                         * @instance
                         */
                        GetDiskRequest.prototype.zone = "";
    
                        /**
                         * Creates a new GetDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetDiskRequest} GetDiskRequest instance
                         */
                        GetDiskRequest.create = function create(properties) {
                            return new GetDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.GetDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetDiskRequest} message GetDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.disk != null && Object.hasOwnProperty.call(message, "disk"))
                                writer.uint32(/* id 3083677, wireType 2 =*/24669418).string(message.disk);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetDiskRequest} message GetDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetDiskRequest} GetDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3083677: {
                                        message.disk = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetDiskRequest} GetDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                if (!$util.isString(message.disk))
                                    return "disk: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetDiskRequest} GetDiskRequest
                         */
                        GetDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetDiskRequest();
                            if (object.disk != null)
                                message.disk = String(object.disk);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetDiskRequest} message GetDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.disk = "";
                                object.zone = "";
                                object.project = "";
                            }
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                object.disk = message.disk;
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetDiskRequest";
                        };
    
                        return GetDiskRequest;
                    })();
    
                    v1.GetDiskTypeRequest = (function() {
    
                        /**
                         * Properties of a GetDiskTypeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetDiskTypeRequest
                         * @property {string|null} [diskType] GetDiskTypeRequest diskType
                         * @property {string|null} [project] GetDiskTypeRequest project
                         * @property {string|null} [zone] GetDiskTypeRequest zone
                         */
    
                        /**
                         * Constructs a new GetDiskTypeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetDiskTypeRequest.
                         * @implements IGetDiskTypeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetDiskTypeRequest=} [properties] Properties to set
                         */
                        function GetDiskTypeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetDiskTypeRequest diskType.
                         * @member {string} diskType
                         * @memberof google.cloud.compute.v1.GetDiskTypeRequest
                         * @instance
                         */
                        GetDiskTypeRequest.prototype.diskType = "";
    
                        /**
                         * GetDiskTypeRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetDiskTypeRequest
                         * @instance
                         */
                        GetDiskTypeRequest.prototype.project = "";
    
                        /**
                         * GetDiskTypeRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetDiskTypeRequest
                         * @instance
                         */
                        GetDiskTypeRequest.prototype.zone = "";
    
                        /**
                         * Creates a new GetDiskTypeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetDiskTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetDiskTypeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetDiskTypeRequest} GetDiskTypeRequest instance
                         */
                        GetDiskTypeRequest.create = function create(properties) {
                            return new GetDiskTypeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetDiskTypeRequest message. Does not implicitly {@link google.cloud.compute.v1.GetDiskTypeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetDiskTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetDiskTypeRequest} message GetDiskTypeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDiskTypeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.diskType != null && Object.hasOwnProperty.call(message, "diskType"))
                                writer.uint32(/* id 93009052, wireType 2 =*/744072418).string(message.diskType);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetDiskTypeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetDiskTypeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetDiskTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetDiskTypeRequest} message GetDiskTypeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetDiskTypeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetDiskTypeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetDiskTypeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetDiskTypeRequest} GetDiskTypeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDiskTypeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetDiskTypeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 93009052: {
                                        message.diskType = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetDiskTypeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetDiskTypeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetDiskTypeRequest} GetDiskTypeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetDiskTypeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetDiskTypeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetDiskTypeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetDiskTypeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.diskType != null && message.hasOwnProperty("diskType"))
                                if (!$util.isString(message.diskType))
                                    return "diskType: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetDiskTypeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetDiskTypeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetDiskTypeRequest} GetDiskTypeRequest
                         */
                        GetDiskTypeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetDiskTypeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetDiskTypeRequest();
                            if (object.diskType != null)
                                message.diskType = String(object.diskType);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetDiskTypeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetDiskTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetDiskTypeRequest} message GetDiskTypeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetDiskTypeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.diskType = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.diskType != null && message.hasOwnProperty("diskType"))
                                object.diskType = message.diskType;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetDiskTypeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetDiskTypeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetDiskTypeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetDiskTypeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetDiskTypeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetDiskTypeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetDiskTypeRequest";
                        };
    
                        return GetDiskTypeRequest;
                    })();
    
                    v1.GetEffectiveFirewallsInstanceRequest = (function() {
    
                        /**
                         * Properties of a GetEffectiveFirewallsInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetEffectiveFirewallsInstanceRequest
                         * @property {string|null} [instance] GetEffectiveFirewallsInstanceRequest instance
                         * @property {string|null} [networkInterface] GetEffectiveFirewallsInstanceRequest networkInterface
                         * @property {string|null} [project] GetEffectiveFirewallsInstanceRequest project
                         * @property {string|null} [zone] GetEffectiveFirewallsInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new GetEffectiveFirewallsInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetEffectiveFirewallsInstanceRequest.
                         * @implements IGetEffectiveFirewallsInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetEffectiveFirewallsInstanceRequest=} [properties] Properties to set
                         */
                        function GetEffectiveFirewallsInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetEffectiveFirewallsInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest
                         * @instance
                         */
                        GetEffectiveFirewallsInstanceRequest.prototype.instance = "";
    
                        /**
                         * GetEffectiveFirewallsInstanceRequest networkInterface.
                         * @member {string} networkInterface
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest
                         * @instance
                         */
                        GetEffectiveFirewallsInstanceRequest.prototype.networkInterface = "";
    
                        /**
                         * GetEffectiveFirewallsInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest
                         * @instance
                         */
                        GetEffectiveFirewallsInstanceRequest.prototype.project = "";
    
                        /**
                         * GetEffectiveFirewallsInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest
                         * @instance
                         */
                        GetEffectiveFirewallsInstanceRequest.prototype.zone = "";
    
                        /**
                         * Creates a new GetEffectiveFirewallsInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetEffectiveFirewallsInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest} GetEffectiveFirewallsInstanceRequest instance
                         */
                        GetEffectiveFirewallsInstanceRequest.create = function create(properties) {
                            return new GetEffectiveFirewallsInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetEffectiveFirewallsInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetEffectiveFirewallsInstanceRequest} message GetEffectiveFirewallsInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetEffectiveFirewallsInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.networkInterface != null && Object.hasOwnProperty.call(message, "networkInterface"))
                                writer.uint32(/* id 365387880, wireType 2 =*/2923103042).string(message.networkInterface);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetEffectiveFirewallsInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetEffectiveFirewallsInstanceRequest} message GetEffectiveFirewallsInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetEffectiveFirewallsInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetEffectiveFirewallsInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest} GetEffectiveFirewallsInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetEffectiveFirewallsInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 365387880: {
                                        message.networkInterface = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetEffectiveFirewallsInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest} GetEffectiveFirewallsInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetEffectiveFirewallsInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetEffectiveFirewallsInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetEffectiveFirewallsInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.networkInterface != null && message.hasOwnProperty("networkInterface"))
                                if (!$util.isString(message.networkInterface))
                                    return "networkInterface: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetEffectiveFirewallsInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest} GetEffectiveFirewallsInstanceRequest
                         */
                        GetEffectiveFirewallsInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.networkInterface != null)
                                message.networkInterface = String(object.networkInterface);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetEffectiveFirewallsInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest} message GetEffectiveFirewallsInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetEffectiveFirewallsInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                                object.networkInterface = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.networkInterface != null && message.hasOwnProperty("networkInterface"))
                                object.networkInterface = message.networkInterface;
                            return object;
                        };
    
                        /**
                         * Converts this GetEffectiveFirewallsInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetEffectiveFirewallsInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetEffectiveFirewallsInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetEffectiveFirewallsInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest";
                        };
    
                        return GetEffectiveFirewallsInstanceRequest;
                    })();
    
                    v1.GetEffectiveFirewallsNetworkRequest = (function() {
    
                        /**
                         * Properties of a GetEffectiveFirewallsNetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetEffectiveFirewallsNetworkRequest
                         * @property {string|null} [network] GetEffectiveFirewallsNetworkRequest network
                         * @property {string|null} [project] GetEffectiveFirewallsNetworkRequest project
                         */
    
                        /**
                         * Constructs a new GetEffectiveFirewallsNetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetEffectiveFirewallsNetworkRequest.
                         * @implements IGetEffectiveFirewallsNetworkRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetEffectiveFirewallsNetworkRequest=} [properties] Properties to set
                         */
                        function GetEffectiveFirewallsNetworkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetEffectiveFirewallsNetworkRequest network.
                         * @member {string} network
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest
                         * @instance
                         */
                        GetEffectiveFirewallsNetworkRequest.prototype.network = "";
    
                        /**
                         * GetEffectiveFirewallsNetworkRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest
                         * @instance
                         */
                        GetEffectiveFirewallsNetworkRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetEffectiveFirewallsNetworkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetEffectiveFirewallsNetworkRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest} GetEffectiveFirewallsNetworkRequest instance
                         */
                        GetEffectiveFirewallsNetworkRequest.create = function create(properties) {
                            return new GetEffectiveFirewallsNetworkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetEffectiveFirewallsNetworkRequest message. Does not implicitly {@link google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetEffectiveFirewallsNetworkRequest} message GetEffectiveFirewallsNetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetEffectiveFirewallsNetworkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetEffectiveFirewallsNetworkRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetEffectiveFirewallsNetworkRequest} message GetEffectiveFirewallsNetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetEffectiveFirewallsNetworkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetEffectiveFirewallsNetworkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest} GetEffectiveFirewallsNetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetEffectiveFirewallsNetworkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetEffectiveFirewallsNetworkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest} GetEffectiveFirewallsNetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetEffectiveFirewallsNetworkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetEffectiveFirewallsNetworkRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetEffectiveFirewallsNetworkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.network != null && message.hasOwnProperty("network"))
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetEffectiveFirewallsNetworkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest} GetEffectiveFirewallsNetworkRequest
                         */
                        GetEffectiveFirewallsNetworkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest();
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetEffectiveFirewallsNetworkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest} message GetEffectiveFirewallsNetworkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetEffectiveFirewallsNetworkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.network = "";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.network != null && message.hasOwnProperty("network"))
                                object.network = message.network;
                            return object;
                        };
    
                        /**
                         * Converts this GetEffectiveFirewallsNetworkRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetEffectiveFirewallsNetworkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetEffectiveFirewallsNetworkRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetEffectiveFirewallsNetworkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest";
                        };
    
                        return GetEffectiveFirewallsNetworkRequest;
                    })();
    
                    v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetEffectiveFirewallsRegionNetworkFirewallPolicyRequest
                         * @property {string|null} [network] GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest network
                         * @property {string|null} [project] GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest project
                         * @property {string|null} [region] GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest region
                         */
    
                        /**
                         * Constructs a new GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest.
                         * @implements IGetEffectiveFirewallsRegionNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetEffectiveFirewallsRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest network.
                         * @member {string} network
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest.prototype.network = "";
    
                        /**
                         * GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetEffectiveFirewallsRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest} GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest instance
                         */
                        GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetEffectiveFirewallsRegionNetworkFirewallPolicyRequest} message GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetEffectiveFirewallsRegionNetworkFirewallPolicyRequest} message GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest} GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest} GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.network != null && message.hasOwnProperty("network"))
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest} GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest
                         */
                        GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest();
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest} message GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.network = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.network != null && message.hasOwnProperty("network"))
                                object.network = message.network;
                            return object;
                        };
    
                        /**
                         * Converts this GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest";
                        };
    
                        return GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest;
                    })();
    
                    v1.GetExternalVpnGatewayRequest = (function() {
    
                        /**
                         * Properties of a GetExternalVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetExternalVpnGatewayRequest
                         * @property {string|null} [externalVpnGateway] GetExternalVpnGatewayRequest externalVpnGateway
                         * @property {string|null} [project] GetExternalVpnGatewayRequest project
                         */
    
                        /**
                         * Constructs a new GetExternalVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetExternalVpnGatewayRequest.
                         * @implements IGetExternalVpnGatewayRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetExternalVpnGatewayRequest=} [properties] Properties to set
                         */
                        function GetExternalVpnGatewayRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetExternalVpnGatewayRequest externalVpnGateway.
                         * @member {string} externalVpnGateway
                         * @memberof google.cloud.compute.v1.GetExternalVpnGatewayRequest
                         * @instance
                         */
                        GetExternalVpnGatewayRequest.prototype.externalVpnGateway = "";
    
                        /**
                         * GetExternalVpnGatewayRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetExternalVpnGatewayRequest
                         * @instance
                         */
                        GetExternalVpnGatewayRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetExternalVpnGatewayRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetExternalVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetExternalVpnGatewayRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetExternalVpnGatewayRequest} GetExternalVpnGatewayRequest instance
                         */
                        GetExternalVpnGatewayRequest.create = function create(properties) {
                            return new GetExternalVpnGatewayRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetExternalVpnGatewayRequest message. Does not implicitly {@link google.cloud.compute.v1.GetExternalVpnGatewayRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetExternalVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetExternalVpnGatewayRequest} message GetExternalVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetExternalVpnGatewayRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.externalVpnGateway != null && Object.hasOwnProperty.call(message, "externalVpnGateway"))
                                writer.uint32(/* id 109898629, wireType 2 =*/879189034).string(message.externalVpnGateway);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetExternalVpnGatewayRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetExternalVpnGatewayRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetExternalVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetExternalVpnGatewayRequest} message GetExternalVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetExternalVpnGatewayRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetExternalVpnGatewayRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetExternalVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetExternalVpnGatewayRequest} GetExternalVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetExternalVpnGatewayRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetExternalVpnGatewayRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 109898629: {
                                        message.externalVpnGateway = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetExternalVpnGatewayRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetExternalVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetExternalVpnGatewayRequest} GetExternalVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetExternalVpnGatewayRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetExternalVpnGatewayRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetExternalVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetExternalVpnGatewayRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.externalVpnGateway != null && message.hasOwnProperty("externalVpnGateway"))
                                if (!$util.isString(message.externalVpnGateway))
                                    return "externalVpnGateway: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetExternalVpnGatewayRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetExternalVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetExternalVpnGatewayRequest} GetExternalVpnGatewayRequest
                         */
                        GetExternalVpnGatewayRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetExternalVpnGatewayRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetExternalVpnGatewayRequest();
                            if (object.externalVpnGateway != null)
                                message.externalVpnGateway = String(object.externalVpnGateway);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetExternalVpnGatewayRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetExternalVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetExternalVpnGatewayRequest} message GetExternalVpnGatewayRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetExternalVpnGatewayRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.externalVpnGateway = "";
                                object.project = "";
                            }
                            if (message.externalVpnGateway != null && message.hasOwnProperty("externalVpnGateway"))
                                object.externalVpnGateway = message.externalVpnGateway;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetExternalVpnGatewayRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetExternalVpnGatewayRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetExternalVpnGatewayRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetExternalVpnGatewayRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetExternalVpnGatewayRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetExternalVpnGatewayRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetExternalVpnGatewayRequest";
                        };
    
                        return GetExternalVpnGatewayRequest;
                    })();
    
                    v1.GetFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a GetFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] GetFirewallPolicyRequest firewallPolicy
                         */
    
                        /**
                         * Constructs a new GetFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetFirewallPolicyRequest.
                         * @implements IGetFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function GetFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.GetFirewallPolicyRequest
                         * @instance
                         */
                        GetFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * Creates a new GetFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetFirewallPolicyRequest} GetFirewallPolicyRequest instance
                         */
                        GetFirewallPolicyRequest.create = function create(properties) {
                            return new GetFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetFirewallPolicyRequest} message GetFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetFirewallPolicyRequest} message GetFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetFirewallPolicyRequest} GetFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetFirewallPolicyRequest} GetFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetFirewallPolicyRequest} GetFirewallPolicyRequest
                         */
                        GetFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetFirewallPolicyRequest} message GetFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.firewallPolicy = "";
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this GetFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetFirewallPolicyRequest";
                        };
    
                        return GetFirewallPolicyRequest;
                    })();
    
                    v1.GetFirewallRequest = (function() {
    
                        /**
                         * Properties of a GetFirewallRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetFirewallRequest
                         * @property {string|null} [firewall] GetFirewallRequest firewall
                         * @property {string|null} [project] GetFirewallRequest project
                         */
    
                        /**
                         * Constructs a new GetFirewallRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetFirewallRequest.
                         * @implements IGetFirewallRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetFirewallRequest=} [properties] Properties to set
                         */
                        function GetFirewallRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetFirewallRequest firewall.
                         * @member {string} firewall
                         * @memberof google.cloud.compute.v1.GetFirewallRequest
                         * @instance
                         */
                        GetFirewallRequest.prototype.firewall = "";
    
                        /**
                         * GetFirewallRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetFirewallRequest
                         * @instance
                         */
                        GetFirewallRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetFirewallRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetFirewallRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetFirewallRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetFirewallRequest} GetFirewallRequest instance
                         */
                        GetFirewallRequest.create = function create(properties) {
                            return new GetFirewallRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetFirewallRequest message. Does not implicitly {@link google.cloud.compute.v1.GetFirewallRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetFirewallRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetFirewallRequest} message GetFirewallRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetFirewallRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewall != null && Object.hasOwnProperty.call(message, "firewall"))
                                writer.uint32(/* id 511016192, wireType 2 =*/4088129538).string(message.firewall);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetFirewallRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetFirewallRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetFirewallRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetFirewallRequest} message GetFirewallRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetFirewallRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetFirewallRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetFirewallRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetFirewallRequest} GetFirewallRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetFirewallRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetFirewallRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 511016192: {
                                        message.firewall = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetFirewallRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetFirewallRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetFirewallRequest} GetFirewallRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetFirewallRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetFirewallRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetFirewallRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetFirewallRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.firewall != null && message.hasOwnProperty("firewall"))
                                if (!$util.isString(message.firewall))
                                    return "firewall: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetFirewallRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetFirewallRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetFirewallRequest} GetFirewallRequest
                         */
                        GetFirewallRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetFirewallRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetFirewallRequest();
                            if (object.firewall != null)
                                message.firewall = String(object.firewall);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetFirewallRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetFirewallRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetFirewallRequest} message GetFirewallRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetFirewallRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.firewall = "";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewall != null && message.hasOwnProperty("firewall"))
                                object.firewall = message.firewall;
                            return object;
                        };
    
                        /**
                         * Converts this GetFirewallRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetFirewallRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetFirewallRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetFirewallRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetFirewallRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetFirewallRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetFirewallRequest";
                        };
    
                        return GetFirewallRequest;
                    })();
    
                    v1.GetForwardingRuleRequest = (function() {
    
                        /**
                         * Properties of a GetForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetForwardingRuleRequest
                         * @property {string|null} [forwardingRule] GetForwardingRuleRequest forwardingRule
                         * @property {string|null} [project] GetForwardingRuleRequest project
                         * @property {string|null} [region] GetForwardingRuleRequest region
                         */
    
                        /**
                         * Constructs a new GetForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetForwardingRuleRequest.
                         * @implements IGetForwardingRuleRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetForwardingRuleRequest=} [properties] Properties to set
                         */
                        function GetForwardingRuleRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetForwardingRuleRequest forwardingRule.
                         * @member {string} forwardingRule
                         * @memberof google.cloud.compute.v1.GetForwardingRuleRequest
                         * @instance
                         */
                        GetForwardingRuleRequest.prototype.forwardingRule = "";
    
                        /**
                         * GetForwardingRuleRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetForwardingRuleRequest
                         * @instance
                         */
                        GetForwardingRuleRequest.prototype.project = "";
    
                        /**
                         * GetForwardingRuleRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetForwardingRuleRequest
                         * @instance
                         */
                        GetForwardingRuleRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetForwardingRuleRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetForwardingRuleRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetForwardingRuleRequest} GetForwardingRuleRequest instance
                         */
                        GetForwardingRuleRequest.create = function create(properties) {
                            return new GetForwardingRuleRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetForwardingRuleRequest message. Does not implicitly {@link google.cloud.compute.v1.GetForwardingRuleRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetForwardingRuleRequest} message GetForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetForwardingRuleRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.forwardingRule != null && Object.hasOwnProperty.call(message, "forwardingRule"))
                                writer.uint32(/* id 269964030, wireType 2 =*/2159712242).string(message.forwardingRule);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetForwardingRuleRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetForwardingRuleRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetForwardingRuleRequest} message GetForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetForwardingRuleRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetForwardingRuleRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetForwardingRuleRequest} GetForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetForwardingRuleRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetForwardingRuleRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 269964030: {
                                        message.forwardingRule = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetForwardingRuleRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetForwardingRuleRequest} GetForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetForwardingRuleRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetForwardingRuleRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetForwardingRuleRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule"))
                                if (!$util.isString(message.forwardingRule))
                                    return "forwardingRule: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetForwardingRuleRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetForwardingRuleRequest} GetForwardingRuleRequest
                         */
                        GetForwardingRuleRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetForwardingRuleRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetForwardingRuleRequest();
                            if (object.forwardingRule != null)
                                message.forwardingRule = String(object.forwardingRule);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetForwardingRuleRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetForwardingRuleRequest} message GetForwardingRuleRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetForwardingRuleRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.forwardingRule = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule"))
                                object.forwardingRule = message.forwardingRule;
                            return object;
                        };
    
                        /**
                         * Converts this GetForwardingRuleRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetForwardingRuleRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetForwardingRuleRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetForwardingRuleRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetForwardingRuleRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetForwardingRuleRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetForwardingRuleRequest";
                        };
    
                        return GetForwardingRuleRequest;
                    })();
    
                    v1.GetFromFamilyImageRequest = (function() {
    
                        /**
                         * Properties of a GetFromFamilyImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetFromFamilyImageRequest
                         * @property {string|null} [family] GetFromFamilyImageRequest family
                         * @property {string|null} [project] GetFromFamilyImageRequest project
                         */
    
                        /**
                         * Constructs a new GetFromFamilyImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetFromFamilyImageRequest.
                         * @implements IGetFromFamilyImageRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetFromFamilyImageRequest=} [properties] Properties to set
                         */
                        function GetFromFamilyImageRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetFromFamilyImageRequest family.
                         * @member {string} family
                         * @memberof google.cloud.compute.v1.GetFromFamilyImageRequest
                         * @instance
                         */
                        GetFromFamilyImageRequest.prototype.family = "";
    
                        /**
                         * GetFromFamilyImageRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetFromFamilyImageRequest
                         * @instance
                         */
                        GetFromFamilyImageRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetFromFamilyImageRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetFromFamilyImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetFromFamilyImageRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetFromFamilyImageRequest} GetFromFamilyImageRequest instance
                         */
                        GetFromFamilyImageRequest.create = function create(properties) {
                            return new GetFromFamilyImageRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetFromFamilyImageRequest message. Does not implicitly {@link google.cloud.compute.v1.GetFromFamilyImageRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetFromFamilyImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetFromFamilyImageRequest} message GetFromFamilyImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetFromFamilyImageRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.family != null && Object.hasOwnProperty.call(message, "family"))
                                writer.uint32(/* id 328751972, wireType 2 =*/2630015778).string(message.family);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetFromFamilyImageRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetFromFamilyImageRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetFromFamilyImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetFromFamilyImageRequest} message GetFromFamilyImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetFromFamilyImageRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetFromFamilyImageRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetFromFamilyImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetFromFamilyImageRequest} GetFromFamilyImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetFromFamilyImageRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetFromFamilyImageRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 328751972: {
                                        message.family = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetFromFamilyImageRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetFromFamilyImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetFromFamilyImageRequest} GetFromFamilyImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetFromFamilyImageRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetFromFamilyImageRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetFromFamilyImageRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetFromFamilyImageRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.family != null && message.hasOwnProperty("family"))
                                if (!$util.isString(message.family))
                                    return "family: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetFromFamilyImageRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetFromFamilyImageRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetFromFamilyImageRequest} GetFromFamilyImageRequest
                         */
                        GetFromFamilyImageRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetFromFamilyImageRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetFromFamilyImageRequest();
                            if (object.family != null)
                                message.family = String(object.family);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetFromFamilyImageRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetFromFamilyImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetFromFamilyImageRequest} message GetFromFamilyImageRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetFromFamilyImageRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.family = "";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.family != null && message.hasOwnProperty("family"))
                                object.family = message.family;
                            return object;
                        };
    
                        /**
                         * Converts this GetFromFamilyImageRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetFromFamilyImageRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetFromFamilyImageRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetFromFamilyImageRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetFromFamilyImageRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetFromFamilyImageRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetFromFamilyImageRequest";
                        };
    
                        return GetFromFamilyImageRequest;
                    })();
    
                    v1.GetGlobalAddressRequest = (function() {
    
                        /**
                         * Properties of a GetGlobalAddressRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetGlobalAddressRequest
                         * @property {string|null} [address] GetGlobalAddressRequest address
                         * @property {string|null} [project] GetGlobalAddressRequest project
                         */
    
                        /**
                         * Constructs a new GetGlobalAddressRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetGlobalAddressRequest.
                         * @implements IGetGlobalAddressRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetGlobalAddressRequest=} [properties] Properties to set
                         */
                        function GetGlobalAddressRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetGlobalAddressRequest address.
                         * @member {string} address
                         * @memberof google.cloud.compute.v1.GetGlobalAddressRequest
                         * @instance
                         */
                        GetGlobalAddressRequest.prototype.address = "";
    
                        /**
                         * GetGlobalAddressRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetGlobalAddressRequest
                         * @instance
                         */
                        GetGlobalAddressRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetGlobalAddressRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetGlobalAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGlobalAddressRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetGlobalAddressRequest} GetGlobalAddressRequest instance
                         */
                        GetGlobalAddressRequest.create = function create(properties) {
                            return new GetGlobalAddressRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetGlobalAddressRequest message. Does not implicitly {@link google.cloud.compute.v1.GetGlobalAddressRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetGlobalAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGlobalAddressRequest} message GetGlobalAddressRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGlobalAddressRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.address != null && Object.hasOwnProperty.call(message, "address"))
                                writer.uint32(/* id 462920692, wireType 2 =*/3703365538).string(message.address);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetGlobalAddressRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetGlobalAddressRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetGlobalAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGlobalAddressRequest} message GetGlobalAddressRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGlobalAddressRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetGlobalAddressRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetGlobalAddressRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetGlobalAddressRequest} GetGlobalAddressRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGlobalAddressRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetGlobalAddressRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 462920692: {
                                        message.address = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetGlobalAddressRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetGlobalAddressRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetGlobalAddressRequest} GetGlobalAddressRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGlobalAddressRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetGlobalAddressRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetGlobalAddressRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetGlobalAddressRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.address != null && message.hasOwnProperty("address"))
                                if (!$util.isString(message.address))
                                    return "address: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetGlobalAddressRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetGlobalAddressRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetGlobalAddressRequest} GetGlobalAddressRequest
                         */
                        GetGlobalAddressRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetGlobalAddressRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetGlobalAddressRequest();
                            if (object.address != null)
                                message.address = String(object.address);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetGlobalAddressRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetGlobalAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetGlobalAddressRequest} message GetGlobalAddressRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetGlobalAddressRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.address = "";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.address != null && message.hasOwnProperty("address"))
                                object.address = message.address;
                            return object;
                        };
    
                        /**
                         * Converts this GetGlobalAddressRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetGlobalAddressRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetGlobalAddressRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetGlobalAddressRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetGlobalAddressRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetGlobalAddressRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetGlobalAddressRequest";
                        };
    
                        return GetGlobalAddressRequest;
                    })();
    
                    v1.GetGlobalForwardingRuleRequest = (function() {
    
                        /**
                         * Properties of a GetGlobalForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetGlobalForwardingRuleRequest
                         * @property {string|null} [forwardingRule] GetGlobalForwardingRuleRequest forwardingRule
                         * @property {string|null} [project] GetGlobalForwardingRuleRequest project
                         */
    
                        /**
                         * Constructs a new GetGlobalForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetGlobalForwardingRuleRequest.
                         * @implements IGetGlobalForwardingRuleRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetGlobalForwardingRuleRequest=} [properties] Properties to set
                         */
                        function GetGlobalForwardingRuleRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetGlobalForwardingRuleRequest forwardingRule.
                         * @member {string} forwardingRule
                         * @memberof google.cloud.compute.v1.GetGlobalForwardingRuleRequest
                         * @instance
                         */
                        GetGlobalForwardingRuleRequest.prototype.forwardingRule = "";
    
                        /**
                         * GetGlobalForwardingRuleRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetGlobalForwardingRuleRequest
                         * @instance
                         */
                        GetGlobalForwardingRuleRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetGlobalForwardingRuleRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGlobalForwardingRuleRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetGlobalForwardingRuleRequest} GetGlobalForwardingRuleRequest instance
                         */
                        GetGlobalForwardingRuleRequest.create = function create(properties) {
                            return new GetGlobalForwardingRuleRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetGlobalForwardingRuleRequest message. Does not implicitly {@link google.cloud.compute.v1.GetGlobalForwardingRuleRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGlobalForwardingRuleRequest} message GetGlobalForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGlobalForwardingRuleRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.forwardingRule != null && Object.hasOwnProperty.call(message, "forwardingRule"))
                                writer.uint32(/* id 269964030, wireType 2 =*/2159712242).string(message.forwardingRule);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetGlobalForwardingRuleRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetGlobalForwardingRuleRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGlobalForwardingRuleRequest} message GetGlobalForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGlobalForwardingRuleRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetGlobalForwardingRuleRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetGlobalForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetGlobalForwardingRuleRequest} GetGlobalForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGlobalForwardingRuleRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetGlobalForwardingRuleRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 269964030: {
                                        message.forwardingRule = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetGlobalForwardingRuleRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetGlobalForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetGlobalForwardingRuleRequest} GetGlobalForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGlobalForwardingRuleRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetGlobalForwardingRuleRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetGlobalForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetGlobalForwardingRuleRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule"))
                                if (!$util.isString(message.forwardingRule))
                                    return "forwardingRule: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetGlobalForwardingRuleRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetGlobalForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetGlobalForwardingRuleRequest} GetGlobalForwardingRuleRequest
                         */
                        GetGlobalForwardingRuleRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetGlobalForwardingRuleRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetGlobalForwardingRuleRequest();
                            if (object.forwardingRule != null)
                                message.forwardingRule = String(object.forwardingRule);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetGlobalForwardingRuleRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetGlobalForwardingRuleRequest} message GetGlobalForwardingRuleRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetGlobalForwardingRuleRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.forwardingRule = "";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule"))
                                object.forwardingRule = message.forwardingRule;
                            return object;
                        };
    
                        /**
                         * Converts this GetGlobalForwardingRuleRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetGlobalForwardingRuleRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetGlobalForwardingRuleRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetGlobalForwardingRuleRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetGlobalForwardingRuleRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetGlobalForwardingRuleRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetGlobalForwardingRuleRequest";
                        };
    
                        return GetGlobalForwardingRuleRequest;
                    })();
    
                    v1.GetGlobalNetworkEndpointGroupRequest = (function() {
    
                        /**
                         * Properties of a GetGlobalNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetGlobalNetworkEndpointGroupRequest
                         * @property {string|null} [networkEndpointGroup] GetGlobalNetworkEndpointGroupRequest networkEndpointGroup
                         * @property {string|null} [project] GetGlobalNetworkEndpointGroupRequest project
                         */
    
                        /**
                         * Constructs a new GetGlobalNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetGlobalNetworkEndpointGroupRequest.
                         * @implements IGetGlobalNetworkEndpointGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetGlobalNetworkEndpointGroupRequest=} [properties] Properties to set
                         */
                        function GetGlobalNetworkEndpointGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetGlobalNetworkEndpointGroupRequest networkEndpointGroup.
                         * @member {string} networkEndpointGroup
                         * @memberof google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest
                         * @instance
                         */
                        GetGlobalNetworkEndpointGroupRequest.prototype.networkEndpointGroup = "";
    
                        /**
                         * GetGlobalNetworkEndpointGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest
                         * @instance
                         */
                        GetGlobalNetworkEndpointGroupRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetGlobalNetworkEndpointGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGlobalNetworkEndpointGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest} GetGlobalNetworkEndpointGroupRequest instance
                         */
                        GetGlobalNetworkEndpointGroupRequest.create = function create(properties) {
                            return new GetGlobalNetworkEndpointGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetGlobalNetworkEndpointGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGlobalNetworkEndpointGroupRequest} message GetGlobalNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGlobalNetworkEndpointGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.networkEndpointGroup != null && Object.hasOwnProperty.call(message, "networkEndpointGroup"))
                                writer.uint32(/* id 433907078, wireType 2 =*/3471256626).string(message.networkEndpointGroup);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetGlobalNetworkEndpointGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGlobalNetworkEndpointGroupRequest} message GetGlobalNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGlobalNetworkEndpointGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetGlobalNetworkEndpointGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest} GetGlobalNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGlobalNetworkEndpointGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 433907078: {
                                        message.networkEndpointGroup = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetGlobalNetworkEndpointGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest} GetGlobalNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGlobalNetworkEndpointGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetGlobalNetworkEndpointGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetGlobalNetworkEndpointGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                if (!$util.isString(message.networkEndpointGroup))
                                    return "networkEndpointGroup: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetGlobalNetworkEndpointGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest} GetGlobalNetworkEndpointGroupRequest
                         */
                        GetGlobalNetworkEndpointGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest();
                            if (object.networkEndpointGroup != null)
                                message.networkEndpointGroup = String(object.networkEndpointGroup);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetGlobalNetworkEndpointGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest} message GetGlobalNetworkEndpointGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetGlobalNetworkEndpointGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.networkEndpointGroup = "";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                object.networkEndpointGroup = message.networkEndpointGroup;
                            return object;
                        };
    
                        /**
                         * Converts this GetGlobalNetworkEndpointGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetGlobalNetworkEndpointGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetGlobalNetworkEndpointGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetGlobalNetworkEndpointGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest";
                        };
    
                        return GetGlobalNetworkEndpointGroupRequest;
                    })();
    
                    v1.GetGlobalOperationRequest = (function() {
    
                        /**
                         * Properties of a GetGlobalOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetGlobalOperationRequest
                         * @property {string|null} [operation] GetGlobalOperationRequest operation
                         * @property {string|null} [project] GetGlobalOperationRequest project
                         */
    
                        /**
                         * Constructs a new GetGlobalOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetGlobalOperationRequest.
                         * @implements IGetGlobalOperationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetGlobalOperationRequest=} [properties] Properties to set
                         */
                        function GetGlobalOperationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetGlobalOperationRequest operation.
                         * @member {string} operation
                         * @memberof google.cloud.compute.v1.GetGlobalOperationRequest
                         * @instance
                         */
                        GetGlobalOperationRequest.prototype.operation = "";
    
                        /**
                         * GetGlobalOperationRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetGlobalOperationRequest
                         * @instance
                         */
                        GetGlobalOperationRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetGlobalOperationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetGlobalOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGlobalOperationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetGlobalOperationRequest} GetGlobalOperationRequest instance
                         */
                        GetGlobalOperationRequest.create = function create(properties) {
                            return new GetGlobalOperationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetGlobalOperationRequest message. Does not implicitly {@link google.cloud.compute.v1.GetGlobalOperationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetGlobalOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGlobalOperationRequest} message GetGlobalOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGlobalOperationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operation != null && Object.hasOwnProperty.call(message, "operation"))
                                writer.uint32(/* id 52090215, wireType 2 =*/416721722).string(message.operation);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetGlobalOperationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetGlobalOperationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetGlobalOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGlobalOperationRequest} message GetGlobalOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGlobalOperationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetGlobalOperationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetGlobalOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetGlobalOperationRequest} GetGlobalOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGlobalOperationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetGlobalOperationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 52090215: {
                                        message.operation = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetGlobalOperationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetGlobalOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetGlobalOperationRequest} GetGlobalOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGlobalOperationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetGlobalOperationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetGlobalOperationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetGlobalOperationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                if (!$util.isString(message.operation))
                                    return "operation: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetGlobalOperationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetGlobalOperationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetGlobalOperationRequest} GetGlobalOperationRequest
                         */
                        GetGlobalOperationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetGlobalOperationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetGlobalOperationRequest();
                            if (object.operation != null)
                                message.operation = String(object.operation);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetGlobalOperationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetGlobalOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetGlobalOperationRequest} message GetGlobalOperationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetGlobalOperationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.operation = "";
                                object.project = "";
                            }
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                object.operation = message.operation;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetGlobalOperationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetGlobalOperationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetGlobalOperationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetGlobalOperationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetGlobalOperationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetGlobalOperationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetGlobalOperationRequest";
                        };
    
                        return GetGlobalOperationRequest;
                    })();
    
                    v1.GetGlobalOrganizationOperationRequest = (function() {
    
                        /**
                         * Properties of a GetGlobalOrganizationOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetGlobalOrganizationOperationRequest
                         * @property {string|null} [operation] GetGlobalOrganizationOperationRequest operation
                         * @property {string|null} [parentId] GetGlobalOrganizationOperationRequest parentId
                         */
    
                        /**
                         * Constructs a new GetGlobalOrganizationOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetGlobalOrganizationOperationRequest.
                         * @implements IGetGlobalOrganizationOperationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetGlobalOrganizationOperationRequest=} [properties] Properties to set
                         */
                        function GetGlobalOrganizationOperationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetGlobalOrganizationOperationRequest operation.
                         * @member {string} operation
                         * @memberof google.cloud.compute.v1.GetGlobalOrganizationOperationRequest
                         * @instance
                         */
                        GetGlobalOrganizationOperationRequest.prototype.operation = "";
    
                        /**
                         * GetGlobalOrganizationOperationRequest parentId.
                         * @member {string|null|undefined} parentId
                         * @memberof google.cloud.compute.v1.GetGlobalOrganizationOperationRequest
                         * @instance
                         */
                        GetGlobalOrganizationOperationRequest.prototype.parentId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetGlobalOrganizationOperationRequest _parentId.
                         * @member {"parentId"|undefined} _parentId
                         * @memberof google.cloud.compute.v1.GetGlobalOrganizationOperationRequest
                         * @instance
                         */
                        Object.defineProperty(GetGlobalOrganizationOperationRequest.prototype, "_parentId", {
                            get: $util.oneOfGetter($oneOfFields = ["parentId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetGlobalOrganizationOperationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetGlobalOrganizationOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGlobalOrganizationOperationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetGlobalOrganizationOperationRequest} GetGlobalOrganizationOperationRequest instance
                         */
                        GetGlobalOrganizationOperationRequest.create = function create(properties) {
                            return new GetGlobalOrganizationOperationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetGlobalOrganizationOperationRequest message. Does not implicitly {@link google.cloud.compute.v1.GetGlobalOrganizationOperationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetGlobalOrganizationOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGlobalOrganizationOperationRequest} message GetGlobalOrganizationOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGlobalOrganizationOperationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operation != null && Object.hasOwnProperty.call(message, "operation"))
                                writer.uint32(/* id 52090215, wireType 2 =*/416721722).string(message.operation);
                            if (message.parentId != null && Object.hasOwnProperty.call(message, "parentId"))
                                writer.uint32(/* id 459714768, wireType 2 =*/3677718146).string(message.parentId);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetGlobalOrganizationOperationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetGlobalOrganizationOperationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetGlobalOrganizationOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGlobalOrganizationOperationRequest} message GetGlobalOrganizationOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGlobalOrganizationOperationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetGlobalOrganizationOperationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetGlobalOrganizationOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetGlobalOrganizationOperationRequest} GetGlobalOrganizationOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGlobalOrganizationOperationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetGlobalOrganizationOperationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 52090215: {
                                        message.operation = reader.string();
                                        break;
                                    }
                                case 459714768: {
                                        message.parentId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetGlobalOrganizationOperationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetGlobalOrganizationOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetGlobalOrganizationOperationRequest} GetGlobalOrganizationOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGlobalOrganizationOperationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetGlobalOrganizationOperationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetGlobalOrganizationOperationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetGlobalOrganizationOperationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                if (!$util.isString(message.operation))
                                    return "operation: string expected";
                            if (message.parentId != null && message.hasOwnProperty("parentId")) {
                                properties._parentId = 1;
                                if (!$util.isString(message.parentId))
                                    return "parentId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a GetGlobalOrganizationOperationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetGlobalOrganizationOperationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetGlobalOrganizationOperationRequest} GetGlobalOrganizationOperationRequest
                         */
                        GetGlobalOrganizationOperationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetGlobalOrganizationOperationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetGlobalOrganizationOperationRequest();
                            if (object.operation != null)
                                message.operation = String(object.operation);
                            if (object.parentId != null)
                                message.parentId = String(object.parentId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetGlobalOrganizationOperationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetGlobalOrganizationOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetGlobalOrganizationOperationRequest} message GetGlobalOrganizationOperationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetGlobalOrganizationOperationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.operation = "";
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                object.operation = message.operation;
                            if (message.parentId != null && message.hasOwnProperty("parentId")) {
                                object.parentId = message.parentId;
                                if (options.oneofs)
                                    object._parentId = "parentId";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetGlobalOrganizationOperationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetGlobalOrganizationOperationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetGlobalOrganizationOperationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetGlobalOrganizationOperationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetGlobalOrganizationOperationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetGlobalOrganizationOperationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetGlobalOrganizationOperationRequest";
                        };
    
                        return GetGlobalOrganizationOperationRequest;
                    })();
    
                    v1.GetGlobalPublicDelegatedPrefixeRequest = (function() {
    
                        /**
                         * Properties of a GetGlobalPublicDelegatedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetGlobalPublicDelegatedPrefixeRequest
                         * @property {string|null} [project] GetGlobalPublicDelegatedPrefixeRequest project
                         * @property {string|null} [publicDelegatedPrefix] GetGlobalPublicDelegatedPrefixeRequest publicDelegatedPrefix
                         */
    
                        /**
                         * Constructs a new GetGlobalPublicDelegatedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetGlobalPublicDelegatedPrefixeRequest.
                         * @implements IGetGlobalPublicDelegatedPrefixeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetGlobalPublicDelegatedPrefixeRequest=} [properties] Properties to set
                         */
                        function GetGlobalPublicDelegatedPrefixeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetGlobalPublicDelegatedPrefixeRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        GetGlobalPublicDelegatedPrefixeRequest.prototype.project = "";
    
                        /**
                         * GetGlobalPublicDelegatedPrefixeRequest publicDelegatedPrefix.
                         * @member {string} publicDelegatedPrefix
                         * @memberof google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        GetGlobalPublicDelegatedPrefixeRequest.prototype.publicDelegatedPrefix = "";
    
                        /**
                         * Creates a new GetGlobalPublicDelegatedPrefixeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGlobalPublicDelegatedPrefixeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest} GetGlobalPublicDelegatedPrefixeRequest instance
                         */
                        GetGlobalPublicDelegatedPrefixeRequest.create = function create(properties) {
                            return new GetGlobalPublicDelegatedPrefixeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetGlobalPublicDelegatedPrefixeRequest message. Does not implicitly {@link google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGlobalPublicDelegatedPrefixeRequest} message GetGlobalPublicDelegatedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGlobalPublicDelegatedPrefixeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.publicDelegatedPrefix != null && Object.hasOwnProperty.call(message, "publicDelegatedPrefix"))
                                writer.uint32(/* id 204238440, wireType 2 =*/1633907522).string(message.publicDelegatedPrefix);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetGlobalPublicDelegatedPrefixeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGlobalPublicDelegatedPrefixeRequest} message GetGlobalPublicDelegatedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGlobalPublicDelegatedPrefixeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetGlobalPublicDelegatedPrefixeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest} GetGlobalPublicDelegatedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGlobalPublicDelegatedPrefixeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 204238440: {
                                        message.publicDelegatedPrefix = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetGlobalPublicDelegatedPrefixeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest} GetGlobalPublicDelegatedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGlobalPublicDelegatedPrefixeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetGlobalPublicDelegatedPrefixeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetGlobalPublicDelegatedPrefixeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.publicDelegatedPrefix != null && message.hasOwnProperty("publicDelegatedPrefix"))
                                if (!$util.isString(message.publicDelegatedPrefix))
                                    return "publicDelegatedPrefix: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetGlobalPublicDelegatedPrefixeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest} GetGlobalPublicDelegatedPrefixeRequest
                         */
                        GetGlobalPublicDelegatedPrefixeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.publicDelegatedPrefix != null)
                                message.publicDelegatedPrefix = String(object.publicDelegatedPrefix);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetGlobalPublicDelegatedPrefixeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest} message GetGlobalPublicDelegatedPrefixeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetGlobalPublicDelegatedPrefixeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.publicDelegatedPrefix = "";
                                object.project = "";
                            }
                            if (message.publicDelegatedPrefix != null && message.hasOwnProperty("publicDelegatedPrefix"))
                                object.publicDelegatedPrefix = message.publicDelegatedPrefix;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetGlobalPublicDelegatedPrefixeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetGlobalPublicDelegatedPrefixeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetGlobalPublicDelegatedPrefixeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetGlobalPublicDelegatedPrefixeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest";
                        };
    
                        return GetGlobalPublicDelegatedPrefixeRequest;
                    })();
    
                    v1.GetGuestAttributesInstanceRequest = (function() {
    
                        /**
                         * Properties of a GetGuestAttributesInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetGuestAttributesInstanceRequest
                         * @property {string|null} [instance] GetGuestAttributesInstanceRequest instance
                         * @property {string|null} [project] GetGuestAttributesInstanceRequest project
                         * @property {string|null} [queryPath] GetGuestAttributesInstanceRequest queryPath
                         * @property {string|null} [variableKey] GetGuestAttributesInstanceRequest variableKey
                         * @property {string|null} [zone] GetGuestAttributesInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new GetGuestAttributesInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetGuestAttributesInstanceRequest.
                         * @implements IGetGuestAttributesInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetGuestAttributesInstanceRequest=} [properties] Properties to set
                         */
                        function GetGuestAttributesInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetGuestAttributesInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.GetGuestAttributesInstanceRequest
                         * @instance
                         */
                        GetGuestAttributesInstanceRequest.prototype.instance = "";
    
                        /**
                         * GetGuestAttributesInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetGuestAttributesInstanceRequest
                         * @instance
                         */
                        GetGuestAttributesInstanceRequest.prototype.project = "";
    
                        /**
                         * GetGuestAttributesInstanceRequest queryPath.
                         * @member {string|null|undefined} queryPath
                         * @memberof google.cloud.compute.v1.GetGuestAttributesInstanceRequest
                         * @instance
                         */
                        GetGuestAttributesInstanceRequest.prototype.queryPath = null;
    
                        /**
                         * GetGuestAttributesInstanceRequest variableKey.
                         * @member {string|null|undefined} variableKey
                         * @memberof google.cloud.compute.v1.GetGuestAttributesInstanceRequest
                         * @instance
                         */
                        GetGuestAttributesInstanceRequest.prototype.variableKey = null;
    
                        /**
                         * GetGuestAttributesInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetGuestAttributesInstanceRequest
                         * @instance
                         */
                        GetGuestAttributesInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetGuestAttributesInstanceRequest _queryPath.
                         * @member {"queryPath"|undefined} _queryPath
                         * @memberof google.cloud.compute.v1.GetGuestAttributesInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(GetGuestAttributesInstanceRequest.prototype, "_queryPath", {
                            get: $util.oneOfGetter($oneOfFields = ["queryPath"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GetGuestAttributesInstanceRequest _variableKey.
                         * @member {"variableKey"|undefined} _variableKey
                         * @memberof google.cloud.compute.v1.GetGuestAttributesInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(GetGuestAttributesInstanceRequest.prototype, "_variableKey", {
                            get: $util.oneOfGetter($oneOfFields = ["variableKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetGuestAttributesInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetGuestAttributesInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGuestAttributesInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetGuestAttributesInstanceRequest} GetGuestAttributesInstanceRequest instance
                         */
                        GetGuestAttributesInstanceRequest.create = function create(properties) {
                            return new GetGuestAttributesInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetGuestAttributesInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.GetGuestAttributesInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetGuestAttributesInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGuestAttributesInstanceRequest} message GetGuestAttributesInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGuestAttributesInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.variableKey != null && Object.hasOwnProperty.call(message, "variableKey"))
                                writer.uint32(/* id 164364828, wireType 2 =*/1314918626).string(message.variableKey);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.queryPath != null && Object.hasOwnProperty.call(message, "queryPath"))
                                writer.uint32(/* id 368591164, wireType 2 =*/2948729314).string(message.queryPath);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetGuestAttributesInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetGuestAttributesInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetGuestAttributesInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetGuestAttributesInstanceRequest} message GetGuestAttributesInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetGuestAttributesInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetGuestAttributesInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetGuestAttributesInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetGuestAttributesInstanceRequest} GetGuestAttributesInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGuestAttributesInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetGuestAttributesInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 368591164: {
                                        message.queryPath = reader.string();
                                        break;
                                    }
                                case 164364828: {
                                        message.variableKey = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetGuestAttributesInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetGuestAttributesInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetGuestAttributesInstanceRequest} GetGuestAttributesInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetGuestAttributesInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetGuestAttributesInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetGuestAttributesInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetGuestAttributesInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.queryPath != null && message.hasOwnProperty("queryPath")) {
                                properties._queryPath = 1;
                                if (!$util.isString(message.queryPath))
                                    return "queryPath: string expected";
                            }
                            if (message.variableKey != null && message.hasOwnProperty("variableKey")) {
                                properties._variableKey = 1;
                                if (!$util.isString(message.variableKey))
                                    return "variableKey: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetGuestAttributesInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetGuestAttributesInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetGuestAttributesInstanceRequest} GetGuestAttributesInstanceRequest
                         */
                        GetGuestAttributesInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetGuestAttributesInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetGuestAttributesInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.queryPath != null)
                                message.queryPath = String(object.queryPath);
                            if (object.variableKey != null)
                                message.variableKey = String(object.variableKey);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetGuestAttributesInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetGuestAttributesInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetGuestAttributesInstanceRequest} message GetGuestAttributesInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetGuestAttributesInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.variableKey != null && message.hasOwnProperty("variableKey")) {
                                object.variableKey = message.variableKey;
                                if (options.oneofs)
                                    object._variableKey = "variableKey";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.queryPath != null && message.hasOwnProperty("queryPath")) {
                                object.queryPath = message.queryPath;
                                if (options.oneofs)
                                    object._queryPath = "queryPath";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetGuestAttributesInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetGuestAttributesInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetGuestAttributesInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetGuestAttributesInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetGuestAttributesInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetGuestAttributesInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetGuestAttributesInstanceRequest";
                        };
    
                        return GetGuestAttributesInstanceRequest;
                    })();
    
                    v1.GetHealthBackendServiceRequest = (function() {
    
                        /**
                         * Properties of a GetHealthBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetHealthBackendServiceRequest
                         * @property {string|null} [backendService] GetHealthBackendServiceRequest backendService
                         * @property {string|null} [project] GetHealthBackendServiceRequest project
                         * @property {google.cloud.compute.v1.IResourceGroupReference|null} [resourceGroupReferenceResource] GetHealthBackendServiceRequest resourceGroupReferenceResource
                         */
    
                        /**
                         * Constructs a new GetHealthBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetHealthBackendServiceRequest.
                         * @implements IGetHealthBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetHealthBackendServiceRequest=} [properties] Properties to set
                         */
                        function GetHealthBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetHealthBackendServiceRequest backendService.
                         * @member {string} backendService
                         * @memberof google.cloud.compute.v1.GetHealthBackendServiceRequest
                         * @instance
                         */
                        GetHealthBackendServiceRequest.prototype.backendService = "";
    
                        /**
                         * GetHealthBackendServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetHealthBackendServiceRequest
                         * @instance
                         */
                        GetHealthBackendServiceRequest.prototype.project = "";
    
                        /**
                         * GetHealthBackendServiceRequest resourceGroupReferenceResource.
                         * @member {google.cloud.compute.v1.IResourceGroupReference|null|undefined} resourceGroupReferenceResource
                         * @memberof google.cloud.compute.v1.GetHealthBackendServiceRequest
                         * @instance
                         */
                        GetHealthBackendServiceRequest.prototype.resourceGroupReferenceResource = null;
    
                        /**
                         * Creates a new GetHealthBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetHealthBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetHealthBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetHealthBackendServiceRequest} GetHealthBackendServiceRequest instance
                         */
                        GetHealthBackendServiceRequest.create = function create(properties) {
                            return new GetHealthBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetHealthBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.GetHealthBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetHealthBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetHealthBackendServiceRequest} message GetHealthBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetHealthBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceGroupReferenceResource != null && Object.hasOwnProperty.call(message, "resourceGroupReferenceResource"))
                                $root.google.cloud.compute.v1.ResourceGroupReference.encode(message.resourceGroupReferenceResource, writer.uint32(/* id 112951123, wireType 2 =*/903608986).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.backendService != null && Object.hasOwnProperty.call(message, "backendService"))
                                writer.uint32(/* id 306946058, wireType 2 =*/2455568466).string(message.backendService);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetHealthBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetHealthBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetHealthBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetHealthBackendServiceRequest} message GetHealthBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetHealthBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetHealthBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetHealthBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetHealthBackendServiceRequest} GetHealthBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetHealthBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetHealthBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 306946058: {
                                        message.backendService = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 112951123: {
                                        message.resourceGroupReferenceResource = $root.google.cloud.compute.v1.ResourceGroupReference.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetHealthBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetHealthBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetHealthBackendServiceRequest} GetHealthBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetHealthBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetHealthBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetHealthBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetHealthBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                if (!$util.isString(message.backendService))
                                    return "backendService: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resourceGroupReferenceResource != null && message.hasOwnProperty("resourceGroupReferenceResource")) {
                                var error = $root.google.cloud.compute.v1.ResourceGroupReference.verify(message.resourceGroupReferenceResource);
                                if (error)
                                    return "resourceGroupReferenceResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a GetHealthBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetHealthBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetHealthBackendServiceRequest} GetHealthBackendServiceRequest
                         */
                        GetHealthBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetHealthBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetHealthBackendServiceRequest();
                            if (object.backendService != null)
                                message.backendService = String(object.backendService);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resourceGroupReferenceResource != null) {
                                if (typeof object.resourceGroupReferenceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.GetHealthBackendServiceRequest.resourceGroupReferenceResource: object expected");
                                message.resourceGroupReferenceResource = $root.google.cloud.compute.v1.ResourceGroupReference.fromObject(object.resourceGroupReferenceResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetHealthBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetHealthBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetHealthBackendServiceRequest} message GetHealthBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetHealthBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceGroupReferenceResource = null;
                                object.project = "";
                                object.backendService = "";
                            }
                            if (message.resourceGroupReferenceResource != null && message.hasOwnProperty("resourceGroupReferenceResource"))
                                object.resourceGroupReferenceResource = $root.google.cloud.compute.v1.ResourceGroupReference.toObject(message.resourceGroupReferenceResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                object.backendService = message.backendService;
                            return object;
                        };
    
                        /**
                         * Converts this GetHealthBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetHealthBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetHealthBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetHealthBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetHealthBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetHealthBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetHealthBackendServiceRequest";
                        };
    
                        return GetHealthBackendServiceRequest;
                    })();
    
                    v1.GetHealthCheckRequest = (function() {
    
                        /**
                         * Properties of a GetHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetHealthCheckRequest
                         * @property {string|null} [healthCheck] GetHealthCheckRequest healthCheck
                         * @property {string|null} [project] GetHealthCheckRequest project
                         */
    
                        /**
                         * Constructs a new GetHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetHealthCheckRequest.
                         * @implements IGetHealthCheckRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetHealthCheckRequest=} [properties] Properties to set
                         */
                        function GetHealthCheckRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetHealthCheckRequest healthCheck.
                         * @member {string} healthCheck
                         * @memberof google.cloud.compute.v1.GetHealthCheckRequest
                         * @instance
                         */
                        GetHealthCheckRequest.prototype.healthCheck = "";
    
                        /**
                         * GetHealthCheckRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetHealthCheckRequest
                         * @instance
                         */
                        GetHealthCheckRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetHealthCheckRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetHealthCheckRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetHealthCheckRequest} GetHealthCheckRequest instance
                         */
                        GetHealthCheckRequest.create = function create(properties) {
                            return new GetHealthCheckRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetHealthCheckRequest message. Does not implicitly {@link google.cloud.compute.v1.GetHealthCheckRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetHealthCheckRequest} message GetHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetHealthCheckRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.healthCheck != null && Object.hasOwnProperty.call(message, "healthCheck"))
                                writer.uint32(/* id 308876645, wireType 2 =*/2471013162).string(message.healthCheck);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetHealthCheckRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetHealthCheckRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetHealthCheckRequest} message GetHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetHealthCheckRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetHealthCheckRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetHealthCheckRequest} GetHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetHealthCheckRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetHealthCheckRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 308876645: {
                                        message.healthCheck = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetHealthCheckRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetHealthCheckRequest} GetHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetHealthCheckRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetHealthCheckRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetHealthCheckRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck"))
                                if (!$util.isString(message.healthCheck))
                                    return "healthCheck: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetHealthCheckRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetHealthCheckRequest} GetHealthCheckRequest
                         */
                        GetHealthCheckRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetHealthCheckRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetHealthCheckRequest();
                            if (object.healthCheck != null)
                                message.healthCheck = String(object.healthCheck);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetHealthCheckRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetHealthCheckRequest} message GetHealthCheckRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetHealthCheckRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.healthCheck = "";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck"))
                                object.healthCheck = message.healthCheck;
                            return object;
                        };
    
                        /**
                         * Converts this GetHealthCheckRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetHealthCheckRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetHealthCheckRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetHealthCheckRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetHealthCheckRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetHealthCheckRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetHealthCheckRequest";
                        };
    
                        return GetHealthCheckRequest;
                    })();
    
                    v1.GetHealthRegionBackendServiceRequest = (function() {
    
                        /**
                         * Properties of a GetHealthRegionBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetHealthRegionBackendServiceRequest
                         * @property {string|null} [backendService] GetHealthRegionBackendServiceRequest backendService
                         * @property {string|null} [project] GetHealthRegionBackendServiceRequest project
                         * @property {string|null} [region] GetHealthRegionBackendServiceRequest region
                         * @property {google.cloud.compute.v1.IResourceGroupReference|null} [resourceGroupReferenceResource] GetHealthRegionBackendServiceRequest resourceGroupReferenceResource
                         */
    
                        /**
                         * Constructs a new GetHealthRegionBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetHealthRegionBackendServiceRequest.
                         * @implements IGetHealthRegionBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetHealthRegionBackendServiceRequest=} [properties] Properties to set
                         */
                        function GetHealthRegionBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetHealthRegionBackendServiceRequest backendService.
                         * @member {string} backendService
                         * @memberof google.cloud.compute.v1.GetHealthRegionBackendServiceRequest
                         * @instance
                         */
                        GetHealthRegionBackendServiceRequest.prototype.backendService = "";
    
                        /**
                         * GetHealthRegionBackendServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetHealthRegionBackendServiceRequest
                         * @instance
                         */
                        GetHealthRegionBackendServiceRequest.prototype.project = "";
    
                        /**
                         * GetHealthRegionBackendServiceRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetHealthRegionBackendServiceRequest
                         * @instance
                         */
                        GetHealthRegionBackendServiceRequest.prototype.region = "";
    
                        /**
                         * GetHealthRegionBackendServiceRequest resourceGroupReferenceResource.
                         * @member {google.cloud.compute.v1.IResourceGroupReference|null|undefined} resourceGroupReferenceResource
                         * @memberof google.cloud.compute.v1.GetHealthRegionBackendServiceRequest
                         * @instance
                         */
                        GetHealthRegionBackendServiceRequest.prototype.resourceGroupReferenceResource = null;
    
                        /**
                         * Creates a new GetHealthRegionBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetHealthRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetHealthRegionBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetHealthRegionBackendServiceRequest} GetHealthRegionBackendServiceRequest instance
                         */
                        GetHealthRegionBackendServiceRequest.create = function create(properties) {
                            return new GetHealthRegionBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetHealthRegionBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.GetHealthRegionBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetHealthRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetHealthRegionBackendServiceRequest} message GetHealthRegionBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetHealthRegionBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceGroupReferenceResource != null && Object.hasOwnProperty.call(message, "resourceGroupReferenceResource"))
                                $root.google.cloud.compute.v1.ResourceGroupReference.encode(message.resourceGroupReferenceResource, writer.uint32(/* id 112951123, wireType 2 =*/903608986).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.backendService != null && Object.hasOwnProperty.call(message, "backendService"))
                                writer.uint32(/* id 306946058, wireType 2 =*/2455568466).string(message.backendService);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetHealthRegionBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetHealthRegionBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetHealthRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetHealthRegionBackendServiceRequest} message GetHealthRegionBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetHealthRegionBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetHealthRegionBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetHealthRegionBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetHealthRegionBackendServiceRequest} GetHealthRegionBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetHealthRegionBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetHealthRegionBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 306946058: {
                                        message.backendService = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 112951123: {
                                        message.resourceGroupReferenceResource = $root.google.cloud.compute.v1.ResourceGroupReference.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetHealthRegionBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetHealthRegionBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetHealthRegionBackendServiceRequest} GetHealthRegionBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetHealthRegionBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetHealthRegionBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetHealthRegionBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetHealthRegionBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                if (!$util.isString(message.backendService))
                                    return "backendService: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.resourceGroupReferenceResource != null && message.hasOwnProperty("resourceGroupReferenceResource")) {
                                var error = $root.google.cloud.compute.v1.ResourceGroupReference.verify(message.resourceGroupReferenceResource);
                                if (error)
                                    return "resourceGroupReferenceResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a GetHealthRegionBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetHealthRegionBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetHealthRegionBackendServiceRequest} GetHealthRegionBackendServiceRequest
                         */
                        GetHealthRegionBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetHealthRegionBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetHealthRegionBackendServiceRequest();
                            if (object.backendService != null)
                                message.backendService = String(object.backendService);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.resourceGroupReferenceResource != null) {
                                if (typeof object.resourceGroupReferenceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.GetHealthRegionBackendServiceRequest.resourceGroupReferenceResource: object expected");
                                message.resourceGroupReferenceResource = $root.google.cloud.compute.v1.ResourceGroupReference.fromObject(object.resourceGroupReferenceResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetHealthRegionBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetHealthRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetHealthRegionBackendServiceRequest} message GetHealthRegionBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetHealthRegionBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourceGroupReferenceResource = null;
                                object.region = "";
                                object.project = "";
                                object.backendService = "";
                            }
                            if (message.resourceGroupReferenceResource != null && message.hasOwnProperty("resourceGroupReferenceResource"))
                                object.resourceGroupReferenceResource = $root.google.cloud.compute.v1.ResourceGroupReference.toObject(message.resourceGroupReferenceResource, options);
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                object.backendService = message.backendService;
                            return object;
                        };
    
                        /**
                         * Converts this GetHealthRegionBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetHealthRegionBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetHealthRegionBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetHealthRegionBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetHealthRegionBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetHealthRegionBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetHealthRegionBackendServiceRequest";
                        };
    
                        return GetHealthRegionBackendServiceRequest;
                    })();
    
                    v1.GetHealthTargetPoolRequest = (function() {
    
                        /**
                         * Properties of a GetHealthTargetPoolRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetHealthTargetPoolRequest
                         * @property {google.cloud.compute.v1.IInstanceReference|null} [instanceReferenceResource] GetHealthTargetPoolRequest instanceReferenceResource
                         * @property {string|null} [project] GetHealthTargetPoolRequest project
                         * @property {string|null} [region] GetHealthTargetPoolRequest region
                         * @property {string|null} [targetPool] GetHealthTargetPoolRequest targetPool
                         */
    
                        /**
                         * Constructs a new GetHealthTargetPoolRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetHealthTargetPoolRequest.
                         * @implements IGetHealthTargetPoolRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetHealthTargetPoolRequest=} [properties] Properties to set
                         */
                        function GetHealthTargetPoolRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetHealthTargetPoolRequest instanceReferenceResource.
                         * @member {google.cloud.compute.v1.IInstanceReference|null|undefined} instanceReferenceResource
                         * @memberof google.cloud.compute.v1.GetHealthTargetPoolRequest
                         * @instance
                         */
                        GetHealthTargetPoolRequest.prototype.instanceReferenceResource = null;
    
                        /**
                         * GetHealthTargetPoolRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetHealthTargetPoolRequest
                         * @instance
                         */
                        GetHealthTargetPoolRequest.prototype.project = "";
    
                        /**
                         * GetHealthTargetPoolRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetHealthTargetPoolRequest
                         * @instance
                         */
                        GetHealthTargetPoolRequest.prototype.region = "";
    
                        /**
                         * GetHealthTargetPoolRequest targetPool.
                         * @member {string} targetPool
                         * @memberof google.cloud.compute.v1.GetHealthTargetPoolRequest
                         * @instance
                         */
                        GetHealthTargetPoolRequest.prototype.targetPool = "";
    
                        /**
                         * Creates a new GetHealthTargetPoolRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetHealthTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetHealthTargetPoolRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetHealthTargetPoolRequest} GetHealthTargetPoolRequest instance
                         */
                        GetHealthTargetPoolRequest.create = function create(properties) {
                            return new GetHealthTargetPoolRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetHealthTargetPoolRequest message. Does not implicitly {@link google.cloud.compute.v1.GetHealthTargetPoolRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetHealthTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetHealthTargetPoolRequest} message GetHealthTargetPoolRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetHealthTargetPoolRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetPool != null && Object.hasOwnProperty.call(message, "targetPool"))
                                writer.uint32(/* id 62796298, wireType 2 =*/502370386).string(message.targetPool);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceReferenceResource != null && Object.hasOwnProperty.call(message, "instanceReferenceResource"))
                                $root.google.cloud.compute.v1.InstanceReference.encode(message.instanceReferenceResource, writer.uint32(/* id 292926060, wireType 2 =*/2343408482).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetHealthTargetPoolRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetHealthTargetPoolRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetHealthTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetHealthTargetPoolRequest} message GetHealthTargetPoolRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetHealthTargetPoolRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetHealthTargetPoolRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetHealthTargetPoolRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetHealthTargetPoolRequest} GetHealthTargetPoolRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetHealthTargetPoolRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetHealthTargetPoolRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 292926060: {
                                        message.instanceReferenceResource = $root.google.cloud.compute.v1.InstanceReference.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 62796298: {
                                        message.targetPool = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetHealthTargetPoolRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetHealthTargetPoolRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetHealthTargetPoolRequest} GetHealthTargetPoolRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetHealthTargetPoolRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetHealthTargetPoolRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetHealthTargetPoolRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetHealthTargetPoolRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instanceReferenceResource != null && message.hasOwnProperty("instanceReferenceResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceReference.verify(message.instanceReferenceResource);
                                if (error)
                                    return "instanceReferenceResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.targetPool != null && message.hasOwnProperty("targetPool"))
                                if (!$util.isString(message.targetPool))
                                    return "targetPool: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetHealthTargetPoolRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetHealthTargetPoolRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetHealthTargetPoolRequest} GetHealthTargetPoolRequest
                         */
                        GetHealthTargetPoolRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetHealthTargetPoolRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetHealthTargetPoolRequest();
                            if (object.instanceReferenceResource != null) {
                                if (typeof object.instanceReferenceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.GetHealthTargetPoolRequest.instanceReferenceResource: object expected");
                                message.instanceReferenceResource = $root.google.cloud.compute.v1.InstanceReference.fromObject(object.instanceReferenceResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.targetPool != null)
                                message.targetPool = String(object.targetPool);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetHealthTargetPoolRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetHealthTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetHealthTargetPoolRequest} message GetHealthTargetPoolRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetHealthTargetPoolRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetPool = "";
                                object.region = "";
                                object.project = "";
                                object.instanceReferenceResource = null;
                            }
                            if (message.targetPool != null && message.hasOwnProperty("targetPool"))
                                object.targetPool = message.targetPool;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceReferenceResource != null && message.hasOwnProperty("instanceReferenceResource"))
                                object.instanceReferenceResource = $root.google.cloud.compute.v1.InstanceReference.toObject(message.instanceReferenceResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this GetHealthTargetPoolRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetHealthTargetPoolRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetHealthTargetPoolRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetHealthTargetPoolRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetHealthTargetPoolRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetHealthTargetPoolRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetHealthTargetPoolRequest";
                        };
    
                        return GetHealthTargetPoolRequest;
                    })();
    
                    v1.GetIamPolicyBackendServiceRequest = (function() {
    
                        /**
                         * Properties of a GetIamPolicyBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetIamPolicyBackendServiceRequest
                         * @property {number|null} [optionsRequestedPolicyVersion] GetIamPolicyBackendServiceRequest optionsRequestedPolicyVersion
                         * @property {string|null} [project] GetIamPolicyBackendServiceRequest project
                         * @property {string|null} [resource] GetIamPolicyBackendServiceRequest resource
                         */
    
                        /**
                         * Constructs a new GetIamPolicyBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetIamPolicyBackendServiceRequest.
                         * @implements IGetIamPolicyBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetIamPolicyBackendServiceRequest=} [properties] Properties to set
                         */
                        function GetIamPolicyBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetIamPolicyBackendServiceRequest optionsRequestedPolicyVersion.
                         * @member {number|null|undefined} optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyBackendServiceRequest
                         * @instance
                         */
                        GetIamPolicyBackendServiceRequest.prototype.optionsRequestedPolicyVersion = null;
    
                        /**
                         * GetIamPolicyBackendServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetIamPolicyBackendServiceRequest
                         * @instance
                         */
                        GetIamPolicyBackendServiceRequest.prototype.project = "";
    
                        /**
                         * GetIamPolicyBackendServiceRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.GetIamPolicyBackendServiceRequest
                         * @instance
                         */
                        GetIamPolicyBackendServiceRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetIamPolicyBackendServiceRequest _optionsRequestedPolicyVersion.
                         * @member {"optionsRequestedPolicyVersion"|undefined} _optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyBackendServiceRequest
                         * @instance
                         */
                        Object.defineProperty(GetIamPolicyBackendServiceRequest.prototype, "_optionsRequestedPolicyVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["optionsRequestedPolicyVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetIamPolicyBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetIamPolicyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetIamPolicyBackendServiceRequest} GetIamPolicyBackendServiceRequest instance
                         */
                        GetIamPolicyBackendServiceRequest.create = function create(properties) {
                            return new GetIamPolicyBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetIamPolicyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyBackendServiceRequest} message GetIamPolicyBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.optionsRequestedPolicyVersion != null && Object.hasOwnProperty.call(message, "optionsRequestedPolicyVersion"))
                                writer.uint32(/* id 499220029, wireType 0 =*/3993760232).int32(message.optionsRequestedPolicyVersion);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyBackendServiceRequest} message GetIamPolicyBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetIamPolicyBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetIamPolicyBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetIamPolicyBackendServiceRequest} GetIamPolicyBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetIamPolicyBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 499220029: {
                                        message.optionsRequestedPolicyVersion = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetIamPolicyBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetIamPolicyBackendServiceRequest} GetIamPolicyBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetIamPolicyBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetIamPolicyBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetIamPolicyBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                properties._optionsRequestedPolicyVersion = 1;
                                if (!$util.isInteger(message.optionsRequestedPolicyVersion))
                                    return "optionsRequestedPolicyVersion: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetIamPolicyBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetIamPolicyBackendServiceRequest} GetIamPolicyBackendServiceRequest
                         */
                        GetIamPolicyBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetIamPolicyBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetIamPolicyBackendServiceRequest();
                            if (object.optionsRequestedPolicyVersion != null)
                                message.optionsRequestedPolicyVersion = object.optionsRequestedPolicyVersion | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetIamPolicyBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetIamPolicyBackendServiceRequest} message GetIamPolicyBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetIamPolicyBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                object.optionsRequestedPolicyVersion = message.optionsRequestedPolicyVersion;
                                if (options.oneofs)
                                    object._optionsRequestedPolicyVersion = "optionsRequestedPolicyVersion";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetIamPolicyBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetIamPolicyBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetIamPolicyBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetIamPolicyBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetIamPolicyBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetIamPolicyBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetIamPolicyBackendServiceRequest";
                        };
    
                        return GetIamPolicyBackendServiceRequest;
                    })();
    
                    v1.GetIamPolicyDiskRequest = (function() {
    
                        /**
                         * Properties of a GetIamPolicyDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetIamPolicyDiskRequest
                         * @property {number|null} [optionsRequestedPolicyVersion] GetIamPolicyDiskRequest optionsRequestedPolicyVersion
                         * @property {string|null} [project] GetIamPolicyDiskRequest project
                         * @property {string|null} [resource] GetIamPolicyDiskRequest resource
                         * @property {string|null} [zone] GetIamPolicyDiskRequest zone
                         */
    
                        /**
                         * Constructs a new GetIamPolicyDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetIamPolicyDiskRequest.
                         * @implements IGetIamPolicyDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetIamPolicyDiskRequest=} [properties] Properties to set
                         */
                        function GetIamPolicyDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetIamPolicyDiskRequest optionsRequestedPolicyVersion.
                         * @member {number|null|undefined} optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyDiskRequest
                         * @instance
                         */
                        GetIamPolicyDiskRequest.prototype.optionsRequestedPolicyVersion = null;
    
                        /**
                         * GetIamPolicyDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetIamPolicyDiskRequest
                         * @instance
                         */
                        GetIamPolicyDiskRequest.prototype.project = "";
    
                        /**
                         * GetIamPolicyDiskRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.GetIamPolicyDiskRequest
                         * @instance
                         */
                        GetIamPolicyDiskRequest.prototype.resource = "";
    
                        /**
                         * GetIamPolicyDiskRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetIamPolicyDiskRequest
                         * @instance
                         */
                        GetIamPolicyDiskRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetIamPolicyDiskRequest _optionsRequestedPolicyVersion.
                         * @member {"optionsRequestedPolicyVersion"|undefined} _optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyDiskRequest
                         * @instance
                         */
                        Object.defineProperty(GetIamPolicyDiskRequest.prototype, "_optionsRequestedPolicyVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["optionsRequestedPolicyVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetIamPolicyDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetIamPolicyDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetIamPolicyDiskRequest} GetIamPolicyDiskRequest instance
                         */
                        GetIamPolicyDiskRequest.create = function create(properties) {
                            return new GetIamPolicyDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetIamPolicyDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyDiskRequest} message GetIamPolicyDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.optionsRequestedPolicyVersion != null && Object.hasOwnProperty.call(message, "optionsRequestedPolicyVersion"))
                                writer.uint32(/* id 499220029, wireType 0 =*/3993760232).int32(message.optionsRequestedPolicyVersion);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyDiskRequest} message GetIamPolicyDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetIamPolicyDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetIamPolicyDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetIamPolicyDiskRequest} GetIamPolicyDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetIamPolicyDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 499220029: {
                                        message.optionsRequestedPolicyVersion = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetIamPolicyDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetIamPolicyDiskRequest} GetIamPolicyDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetIamPolicyDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetIamPolicyDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetIamPolicyDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                properties._optionsRequestedPolicyVersion = 1;
                                if (!$util.isInteger(message.optionsRequestedPolicyVersion))
                                    return "optionsRequestedPolicyVersion: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetIamPolicyDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetIamPolicyDiskRequest} GetIamPolicyDiskRequest
                         */
                        GetIamPolicyDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetIamPolicyDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetIamPolicyDiskRequest();
                            if (object.optionsRequestedPolicyVersion != null)
                                message.optionsRequestedPolicyVersion = object.optionsRequestedPolicyVersion | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetIamPolicyDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetIamPolicyDiskRequest} message GetIamPolicyDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetIamPolicyDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.resource = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                object.optionsRequestedPolicyVersion = message.optionsRequestedPolicyVersion;
                                if (options.oneofs)
                                    object._optionsRequestedPolicyVersion = "optionsRequestedPolicyVersion";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetIamPolicyDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetIamPolicyDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetIamPolicyDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetIamPolicyDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetIamPolicyDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetIamPolicyDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetIamPolicyDiskRequest";
                        };
    
                        return GetIamPolicyDiskRequest;
                    })();
    
                    v1.GetIamPolicyFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a GetIamPolicyFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetIamPolicyFirewallPolicyRequest
                         * @property {number|null} [optionsRequestedPolicyVersion] GetIamPolicyFirewallPolicyRequest optionsRequestedPolicyVersion
                         * @property {string|null} [resource] GetIamPolicyFirewallPolicyRequest resource
                         */
    
                        /**
                         * Constructs a new GetIamPolicyFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetIamPolicyFirewallPolicyRequest.
                         * @implements IGetIamPolicyFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetIamPolicyFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function GetIamPolicyFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetIamPolicyFirewallPolicyRequest optionsRequestedPolicyVersion.
                         * @member {number|null|undefined} optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest
                         * @instance
                         */
                        GetIamPolicyFirewallPolicyRequest.prototype.optionsRequestedPolicyVersion = null;
    
                        /**
                         * GetIamPolicyFirewallPolicyRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest
                         * @instance
                         */
                        GetIamPolicyFirewallPolicyRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetIamPolicyFirewallPolicyRequest _optionsRequestedPolicyVersion.
                         * @member {"optionsRequestedPolicyVersion"|undefined} _optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(GetIamPolicyFirewallPolicyRequest.prototype, "_optionsRequestedPolicyVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["optionsRequestedPolicyVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetIamPolicyFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest} GetIamPolicyFirewallPolicyRequest instance
                         */
                        GetIamPolicyFirewallPolicyRequest.create = function create(properties) {
                            return new GetIamPolicyFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyFirewallPolicyRequest} message GetIamPolicyFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.optionsRequestedPolicyVersion != null && Object.hasOwnProperty.call(message, "optionsRequestedPolicyVersion"))
                                writer.uint32(/* id 499220029, wireType 0 =*/3993760232).int32(message.optionsRequestedPolicyVersion);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyFirewallPolicyRequest} message GetIamPolicyFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetIamPolicyFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest} GetIamPolicyFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 499220029: {
                                        message.optionsRequestedPolicyVersion = reader.int32();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetIamPolicyFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest} GetIamPolicyFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetIamPolicyFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetIamPolicyFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                properties._optionsRequestedPolicyVersion = 1;
                                if (!$util.isInteger(message.optionsRequestedPolicyVersion))
                                    return "optionsRequestedPolicyVersion: integer expected";
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetIamPolicyFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest} GetIamPolicyFirewallPolicyRequest
                         */
                        GetIamPolicyFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest();
                            if (object.optionsRequestedPolicyVersion != null)
                                message.optionsRequestedPolicyVersion = object.optionsRequestedPolicyVersion | 0;
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetIamPolicyFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest} message GetIamPolicyFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetIamPolicyFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.resource = "";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                object.optionsRequestedPolicyVersion = message.optionsRequestedPolicyVersion;
                                if (options.oneofs)
                                    object._optionsRequestedPolicyVersion = "optionsRequestedPolicyVersion";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetIamPolicyFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetIamPolicyFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetIamPolicyFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetIamPolicyFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest";
                        };
    
                        return GetIamPolicyFirewallPolicyRequest;
                    })();
    
                    v1.GetIamPolicyImageRequest = (function() {
    
                        /**
                         * Properties of a GetIamPolicyImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetIamPolicyImageRequest
                         * @property {number|null} [optionsRequestedPolicyVersion] GetIamPolicyImageRequest optionsRequestedPolicyVersion
                         * @property {string|null} [project] GetIamPolicyImageRequest project
                         * @property {string|null} [resource] GetIamPolicyImageRequest resource
                         */
    
                        /**
                         * Constructs a new GetIamPolicyImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetIamPolicyImageRequest.
                         * @implements IGetIamPolicyImageRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetIamPolicyImageRequest=} [properties] Properties to set
                         */
                        function GetIamPolicyImageRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetIamPolicyImageRequest optionsRequestedPolicyVersion.
                         * @member {number|null|undefined} optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyImageRequest
                         * @instance
                         */
                        GetIamPolicyImageRequest.prototype.optionsRequestedPolicyVersion = null;
    
                        /**
                         * GetIamPolicyImageRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetIamPolicyImageRequest
                         * @instance
                         */
                        GetIamPolicyImageRequest.prototype.project = "";
    
                        /**
                         * GetIamPolicyImageRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.GetIamPolicyImageRequest
                         * @instance
                         */
                        GetIamPolicyImageRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetIamPolicyImageRequest _optionsRequestedPolicyVersion.
                         * @member {"optionsRequestedPolicyVersion"|undefined} _optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyImageRequest
                         * @instance
                         */
                        Object.defineProperty(GetIamPolicyImageRequest.prototype, "_optionsRequestedPolicyVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["optionsRequestedPolicyVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetIamPolicyImageRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetIamPolicyImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyImageRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetIamPolicyImageRequest} GetIamPolicyImageRequest instance
                         */
                        GetIamPolicyImageRequest.create = function create(properties) {
                            return new GetIamPolicyImageRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyImageRequest message. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyImageRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetIamPolicyImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyImageRequest} message GetIamPolicyImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyImageRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.optionsRequestedPolicyVersion != null && Object.hasOwnProperty.call(message, "optionsRequestedPolicyVersion"))
                                writer.uint32(/* id 499220029, wireType 0 =*/3993760232).int32(message.optionsRequestedPolicyVersion);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyImageRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyImageRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyImageRequest} message GetIamPolicyImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyImageRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetIamPolicyImageRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetIamPolicyImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetIamPolicyImageRequest} GetIamPolicyImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyImageRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetIamPolicyImageRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 499220029: {
                                        message.optionsRequestedPolicyVersion = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetIamPolicyImageRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetIamPolicyImageRequest} GetIamPolicyImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyImageRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetIamPolicyImageRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetIamPolicyImageRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetIamPolicyImageRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                properties._optionsRequestedPolicyVersion = 1;
                                if (!$util.isInteger(message.optionsRequestedPolicyVersion))
                                    return "optionsRequestedPolicyVersion: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetIamPolicyImageRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyImageRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetIamPolicyImageRequest} GetIamPolicyImageRequest
                         */
                        GetIamPolicyImageRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetIamPolicyImageRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetIamPolicyImageRequest();
                            if (object.optionsRequestedPolicyVersion != null)
                                message.optionsRequestedPolicyVersion = object.optionsRequestedPolicyVersion | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetIamPolicyImageRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetIamPolicyImageRequest} message GetIamPolicyImageRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetIamPolicyImageRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                object.optionsRequestedPolicyVersion = message.optionsRequestedPolicyVersion;
                                if (options.oneofs)
                                    object._optionsRequestedPolicyVersion = "optionsRequestedPolicyVersion";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetIamPolicyImageRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetIamPolicyImageRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetIamPolicyImageRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetIamPolicyImageRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetIamPolicyImageRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetIamPolicyImageRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetIamPolicyImageRequest";
                        };
    
                        return GetIamPolicyImageRequest;
                    })();
    
                    v1.GetIamPolicyInstanceRequest = (function() {
    
                        /**
                         * Properties of a GetIamPolicyInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetIamPolicyInstanceRequest
                         * @property {number|null} [optionsRequestedPolicyVersion] GetIamPolicyInstanceRequest optionsRequestedPolicyVersion
                         * @property {string|null} [project] GetIamPolicyInstanceRequest project
                         * @property {string|null} [resource] GetIamPolicyInstanceRequest resource
                         * @property {string|null} [zone] GetIamPolicyInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new GetIamPolicyInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetIamPolicyInstanceRequest.
                         * @implements IGetIamPolicyInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetIamPolicyInstanceRequest=} [properties] Properties to set
                         */
                        function GetIamPolicyInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetIamPolicyInstanceRequest optionsRequestedPolicyVersion.
                         * @member {number|null|undefined} optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceRequest
                         * @instance
                         */
                        GetIamPolicyInstanceRequest.prototype.optionsRequestedPolicyVersion = null;
    
                        /**
                         * GetIamPolicyInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceRequest
                         * @instance
                         */
                        GetIamPolicyInstanceRequest.prototype.project = "";
    
                        /**
                         * GetIamPolicyInstanceRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceRequest
                         * @instance
                         */
                        GetIamPolicyInstanceRequest.prototype.resource = "";
    
                        /**
                         * GetIamPolicyInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceRequest
                         * @instance
                         */
                        GetIamPolicyInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetIamPolicyInstanceRequest _optionsRequestedPolicyVersion.
                         * @member {"optionsRequestedPolicyVersion"|undefined} _optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(GetIamPolicyInstanceRequest.prototype, "_optionsRequestedPolicyVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["optionsRequestedPolicyVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetIamPolicyInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetIamPolicyInstanceRequest} GetIamPolicyInstanceRequest instance
                         */
                        GetIamPolicyInstanceRequest.create = function create(properties) {
                            return new GetIamPolicyInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyInstanceRequest} message GetIamPolicyInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.optionsRequestedPolicyVersion != null && Object.hasOwnProperty.call(message, "optionsRequestedPolicyVersion"))
                                writer.uint32(/* id 499220029, wireType 0 =*/3993760232).int32(message.optionsRequestedPolicyVersion);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyInstanceRequest} message GetIamPolicyInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetIamPolicyInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetIamPolicyInstanceRequest} GetIamPolicyInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetIamPolicyInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 499220029: {
                                        message.optionsRequestedPolicyVersion = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetIamPolicyInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetIamPolicyInstanceRequest} GetIamPolicyInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetIamPolicyInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetIamPolicyInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                properties._optionsRequestedPolicyVersion = 1;
                                if (!$util.isInteger(message.optionsRequestedPolicyVersion))
                                    return "optionsRequestedPolicyVersion: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetIamPolicyInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetIamPolicyInstanceRequest} GetIamPolicyInstanceRequest
                         */
                        GetIamPolicyInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetIamPolicyInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetIamPolicyInstanceRequest();
                            if (object.optionsRequestedPolicyVersion != null)
                                message.optionsRequestedPolicyVersion = object.optionsRequestedPolicyVersion | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetIamPolicyInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetIamPolicyInstanceRequest} message GetIamPolicyInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetIamPolicyInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.resource = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                object.optionsRequestedPolicyVersion = message.optionsRequestedPolicyVersion;
                                if (options.oneofs)
                                    object._optionsRequestedPolicyVersion = "optionsRequestedPolicyVersion";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetIamPolicyInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetIamPolicyInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetIamPolicyInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetIamPolicyInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetIamPolicyInstanceRequest";
                        };
    
                        return GetIamPolicyInstanceRequest;
                    })();
    
                    v1.GetIamPolicyInstanceTemplateRequest = (function() {
    
                        /**
                         * Properties of a GetIamPolicyInstanceTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetIamPolicyInstanceTemplateRequest
                         * @property {number|null} [optionsRequestedPolicyVersion] GetIamPolicyInstanceTemplateRequest optionsRequestedPolicyVersion
                         * @property {string|null} [project] GetIamPolicyInstanceTemplateRequest project
                         * @property {string|null} [resource] GetIamPolicyInstanceTemplateRequest resource
                         */
    
                        /**
                         * Constructs a new GetIamPolicyInstanceTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetIamPolicyInstanceTemplateRequest.
                         * @implements IGetIamPolicyInstanceTemplateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetIamPolicyInstanceTemplateRequest=} [properties] Properties to set
                         */
                        function GetIamPolicyInstanceTemplateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetIamPolicyInstanceTemplateRequest optionsRequestedPolicyVersion.
                         * @member {number|null|undefined} optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest
                         * @instance
                         */
                        GetIamPolicyInstanceTemplateRequest.prototype.optionsRequestedPolicyVersion = null;
    
                        /**
                         * GetIamPolicyInstanceTemplateRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest
                         * @instance
                         */
                        GetIamPolicyInstanceTemplateRequest.prototype.project = "";
    
                        /**
                         * GetIamPolicyInstanceTemplateRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest
                         * @instance
                         */
                        GetIamPolicyInstanceTemplateRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetIamPolicyInstanceTemplateRequest _optionsRequestedPolicyVersion.
                         * @member {"optionsRequestedPolicyVersion"|undefined} _optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest
                         * @instance
                         */
                        Object.defineProperty(GetIamPolicyInstanceTemplateRequest.prototype, "_optionsRequestedPolicyVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["optionsRequestedPolicyVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetIamPolicyInstanceTemplateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyInstanceTemplateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest} GetIamPolicyInstanceTemplateRequest instance
                         */
                        GetIamPolicyInstanceTemplateRequest.create = function create(properties) {
                            return new GetIamPolicyInstanceTemplateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyInstanceTemplateRequest message. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyInstanceTemplateRequest} message GetIamPolicyInstanceTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyInstanceTemplateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.optionsRequestedPolicyVersion != null && Object.hasOwnProperty.call(message, "optionsRequestedPolicyVersion"))
                                writer.uint32(/* id 499220029, wireType 0 =*/3993760232).int32(message.optionsRequestedPolicyVersion);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyInstanceTemplateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyInstanceTemplateRequest} message GetIamPolicyInstanceTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyInstanceTemplateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetIamPolicyInstanceTemplateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest} GetIamPolicyInstanceTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyInstanceTemplateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 499220029: {
                                        message.optionsRequestedPolicyVersion = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetIamPolicyInstanceTemplateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest} GetIamPolicyInstanceTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyInstanceTemplateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetIamPolicyInstanceTemplateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetIamPolicyInstanceTemplateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                properties._optionsRequestedPolicyVersion = 1;
                                if (!$util.isInteger(message.optionsRequestedPolicyVersion))
                                    return "optionsRequestedPolicyVersion: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetIamPolicyInstanceTemplateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest} GetIamPolicyInstanceTemplateRequest
                         */
                        GetIamPolicyInstanceTemplateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest();
                            if (object.optionsRequestedPolicyVersion != null)
                                message.optionsRequestedPolicyVersion = object.optionsRequestedPolicyVersion | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetIamPolicyInstanceTemplateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest} message GetIamPolicyInstanceTemplateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetIamPolicyInstanceTemplateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                object.optionsRequestedPolicyVersion = message.optionsRequestedPolicyVersion;
                                if (options.oneofs)
                                    object._optionsRequestedPolicyVersion = "optionsRequestedPolicyVersion";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetIamPolicyInstanceTemplateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetIamPolicyInstanceTemplateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetIamPolicyInstanceTemplateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetIamPolicyInstanceTemplateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest";
                        };
    
                        return GetIamPolicyInstanceTemplateRequest;
                    })();
    
                    v1.GetIamPolicyLicenseRequest = (function() {
    
                        /**
                         * Properties of a GetIamPolicyLicenseRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetIamPolicyLicenseRequest
                         * @property {number|null} [optionsRequestedPolicyVersion] GetIamPolicyLicenseRequest optionsRequestedPolicyVersion
                         * @property {string|null} [project] GetIamPolicyLicenseRequest project
                         * @property {string|null} [resource] GetIamPolicyLicenseRequest resource
                         */
    
                        /**
                         * Constructs a new GetIamPolicyLicenseRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetIamPolicyLicenseRequest.
                         * @implements IGetIamPolicyLicenseRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetIamPolicyLicenseRequest=} [properties] Properties to set
                         */
                        function GetIamPolicyLicenseRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetIamPolicyLicenseRequest optionsRequestedPolicyVersion.
                         * @member {number|null|undefined} optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyLicenseRequest
                         * @instance
                         */
                        GetIamPolicyLicenseRequest.prototype.optionsRequestedPolicyVersion = null;
    
                        /**
                         * GetIamPolicyLicenseRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetIamPolicyLicenseRequest
                         * @instance
                         */
                        GetIamPolicyLicenseRequest.prototype.project = "";
    
                        /**
                         * GetIamPolicyLicenseRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.GetIamPolicyLicenseRequest
                         * @instance
                         */
                        GetIamPolicyLicenseRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetIamPolicyLicenseRequest _optionsRequestedPolicyVersion.
                         * @member {"optionsRequestedPolicyVersion"|undefined} _optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyLicenseRequest
                         * @instance
                         */
                        Object.defineProperty(GetIamPolicyLicenseRequest.prototype, "_optionsRequestedPolicyVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["optionsRequestedPolicyVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetIamPolicyLicenseRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetIamPolicyLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyLicenseRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetIamPolicyLicenseRequest} GetIamPolicyLicenseRequest instance
                         */
                        GetIamPolicyLicenseRequest.create = function create(properties) {
                            return new GetIamPolicyLicenseRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyLicenseRequest message. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyLicenseRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetIamPolicyLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyLicenseRequest} message GetIamPolicyLicenseRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyLicenseRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.optionsRequestedPolicyVersion != null && Object.hasOwnProperty.call(message, "optionsRequestedPolicyVersion"))
                                writer.uint32(/* id 499220029, wireType 0 =*/3993760232).int32(message.optionsRequestedPolicyVersion);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyLicenseRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyLicenseRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyLicenseRequest} message GetIamPolicyLicenseRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyLicenseRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetIamPolicyLicenseRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetIamPolicyLicenseRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetIamPolicyLicenseRequest} GetIamPolicyLicenseRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyLicenseRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetIamPolicyLicenseRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 499220029: {
                                        message.optionsRequestedPolicyVersion = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetIamPolicyLicenseRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyLicenseRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetIamPolicyLicenseRequest} GetIamPolicyLicenseRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyLicenseRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetIamPolicyLicenseRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetIamPolicyLicenseRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetIamPolicyLicenseRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                properties._optionsRequestedPolicyVersion = 1;
                                if (!$util.isInteger(message.optionsRequestedPolicyVersion))
                                    return "optionsRequestedPolicyVersion: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetIamPolicyLicenseRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyLicenseRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetIamPolicyLicenseRequest} GetIamPolicyLicenseRequest
                         */
                        GetIamPolicyLicenseRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetIamPolicyLicenseRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetIamPolicyLicenseRequest();
                            if (object.optionsRequestedPolicyVersion != null)
                                message.optionsRequestedPolicyVersion = object.optionsRequestedPolicyVersion | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetIamPolicyLicenseRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetIamPolicyLicenseRequest} message GetIamPolicyLicenseRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetIamPolicyLicenseRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                object.optionsRequestedPolicyVersion = message.optionsRequestedPolicyVersion;
                                if (options.oneofs)
                                    object._optionsRequestedPolicyVersion = "optionsRequestedPolicyVersion";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetIamPolicyLicenseRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetIamPolicyLicenseRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetIamPolicyLicenseRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetIamPolicyLicenseRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetIamPolicyLicenseRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetIamPolicyLicenseRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetIamPolicyLicenseRequest";
                        };
    
                        return GetIamPolicyLicenseRequest;
                    })();
    
                    v1.GetIamPolicyMachineImageRequest = (function() {
    
                        /**
                         * Properties of a GetIamPolicyMachineImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetIamPolicyMachineImageRequest
                         * @property {number|null} [optionsRequestedPolicyVersion] GetIamPolicyMachineImageRequest optionsRequestedPolicyVersion
                         * @property {string|null} [project] GetIamPolicyMachineImageRequest project
                         * @property {string|null} [resource] GetIamPolicyMachineImageRequest resource
                         */
    
                        /**
                         * Constructs a new GetIamPolicyMachineImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetIamPolicyMachineImageRequest.
                         * @implements IGetIamPolicyMachineImageRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetIamPolicyMachineImageRequest=} [properties] Properties to set
                         */
                        function GetIamPolicyMachineImageRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetIamPolicyMachineImageRequest optionsRequestedPolicyVersion.
                         * @member {number|null|undefined} optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyMachineImageRequest
                         * @instance
                         */
                        GetIamPolicyMachineImageRequest.prototype.optionsRequestedPolicyVersion = null;
    
                        /**
                         * GetIamPolicyMachineImageRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetIamPolicyMachineImageRequest
                         * @instance
                         */
                        GetIamPolicyMachineImageRequest.prototype.project = "";
    
                        /**
                         * GetIamPolicyMachineImageRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.GetIamPolicyMachineImageRequest
                         * @instance
                         */
                        GetIamPolicyMachineImageRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetIamPolicyMachineImageRequest _optionsRequestedPolicyVersion.
                         * @member {"optionsRequestedPolicyVersion"|undefined} _optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyMachineImageRequest
                         * @instance
                         */
                        Object.defineProperty(GetIamPolicyMachineImageRequest.prototype, "_optionsRequestedPolicyVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["optionsRequestedPolicyVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetIamPolicyMachineImageRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetIamPolicyMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyMachineImageRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetIamPolicyMachineImageRequest} GetIamPolicyMachineImageRequest instance
                         */
                        GetIamPolicyMachineImageRequest.create = function create(properties) {
                            return new GetIamPolicyMachineImageRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyMachineImageRequest message. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyMachineImageRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetIamPolicyMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyMachineImageRequest} message GetIamPolicyMachineImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyMachineImageRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.optionsRequestedPolicyVersion != null && Object.hasOwnProperty.call(message, "optionsRequestedPolicyVersion"))
                                writer.uint32(/* id 499220029, wireType 0 =*/3993760232).int32(message.optionsRequestedPolicyVersion);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyMachineImageRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyMachineImageRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyMachineImageRequest} message GetIamPolicyMachineImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyMachineImageRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetIamPolicyMachineImageRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetIamPolicyMachineImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetIamPolicyMachineImageRequest} GetIamPolicyMachineImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyMachineImageRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetIamPolicyMachineImageRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 499220029: {
                                        message.optionsRequestedPolicyVersion = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetIamPolicyMachineImageRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyMachineImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetIamPolicyMachineImageRequest} GetIamPolicyMachineImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyMachineImageRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetIamPolicyMachineImageRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetIamPolicyMachineImageRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetIamPolicyMachineImageRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                properties._optionsRequestedPolicyVersion = 1;
                                if (!$util.isInteger(message.optionsRequestedPolicyVersion))
                                    return "optionsRequestedPolicyVersion: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetIamPolicyMachineImageRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyMachineImageRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetIamPolicyMachineImageRequest} GetIamPolicyMachineImageRequest
                         */
                        GetIamPolicyMachineImageRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetIamPolicyMachineImageRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetIamPolicyMachineImageRequest();
                            if (object.optionsRequestedPolicyVersion != null)
                                message.optionsRequestedPolicyVersion = object.optionsRequestedPolicyVersion | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetIamPolicyMachineImageRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetIamPolicyMachineImageRequest} message GetIamPolicyMachineImageRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetIamPolicyMachineImageRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                object.optionsRequestedPolicyVersion = message.optionsRequestedPolicyVersion;
                                if (options.oneofs)
                                    object._optionsRequestedPolicyVersion = "optionsRequestedPolicyVersion";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetIamPolicyMachineImageRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetIamPolicyMachineImageRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetIamPolicyMachineImageRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetIamPolicyMachineImageRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetIamPolicyMachineImageRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetIamPolicyMachineImageRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetIamPolicyMachineImageRequest";
                        };
    
                        return GetIamPolicyMachineImageRequest;
                    })();
    
                    v1.GetIamPolicyNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a GetIamPolicyNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetIamPolicyNetworkFirewallPolicyRequest
                         * @property {number|null} [optionsRequestedPolicyVersion] GetIamPolicyNetworkFirewallPolicyRequest optionsRequestedPolicyVersion
                         * @property {string|null} [project] GetIamPolicyNetworkFirewallPolicyRequest project
                         * @property {string|null} [resource] GetIamPolicyNetworkFirewallPolicyRequest resource
                         */
    
                        /**
                         * Constructs a new GetIamPolicyNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetIamPolicyNetworkFirewallPolicyRequest.
                         * @implements IGetIamPolicyNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetIamPolicyNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function GetIamPolicyNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetIamPolicyNetworkFirewallPolicyRequest optionsRequestedPolicyVersion.
                         * @member {number|null|undefined} optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetIamPolicyNetworkFirewallPolicyRequest.prototype.optionsRequestedPolicyVersion = null;
    
                        /**
                         * GetIamPolicyNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetIamPolicyNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * GetIamPolicyNetworkFirewallPolicyRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetIamPolicyNetworkFirewallPolicyRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetIamPolicyNetworkFirewallPolicyRequest _optionsRequestedPolicyVersion.
                         * @member {"optionsRequestedPolicyVersion"|undefined} _optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(GetIamPolicyNetworkFirewallPolicyRequest.prototype, "_optionsRequestedPolicyVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["optionsRequestedPolicyVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetIamPolicyNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest} GetIamPolicyNetworkFirewallPolicyRequest instance
                         */
                        GetIamPolicyNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new GetIamPolicyNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyNetworkFirewallPolicyRequest} message GetIamPolicyNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.optionsRequestedPolicyVersion != null && Object.hasOwnProperty.call(message, "optionsRequestedPolicyVersion"))
                                writer.uint32(/* id 499220029, wireType 0 =*/3993760232).int32(message.optionsRequestedPolicyVersion);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyNetworkFirewallPolicyRequest} message GetIamPolicyNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetIamPolicyNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest} GetIamPolicyNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 499220029: {
                                        message.optionsRequestedPolicyVersion = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetIamPolicyNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest} GetIamPolicyNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetIamPolicyNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetIamPolicyNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                properties._optionsRequestedPolicyVersion = 1;
                                if (!$util.isInteger(message.optionsRequestedPolicyVersion))
                                    return "optionsRequestedPolicyVersion: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetIamPolicyNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest} GetIamPolicyNetworkFirewallPolicyRequest
                         */
                        GetIamPolicyNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest();
                            if (object.optionsRequestedPolicyVersion != null)
                                message.optionsRequestedPolicyVersion = object.optionsRequestedPolicyVersion | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetIamPolicyNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest} message GetIamPolicyNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetIamPolicyNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                object.optionsRequestedPolicyVersion = message.optionsRequestedPolicyVersion;
                                if (options.oneofs)
                                    object._optionsRequestedPolicyVersion = "optionsRequestedPolicyVersion";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetIamPolicyNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetIamPolicyNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetIamPolicyNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetIamPolicyNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest";
                        };
    
                        return GetIamPolicyNetworkFirewallPolicyRequest;
                    })();
    
                    v1.GetIamPolicyNodeGroupRequest = (function() {
    
                        /**
                         * Properties of a GetIamPolicyNodeGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetIamPolicyNodeGroupRequest
                         * @property {number|null} [optionsRequestedPolicyVersion] GetIamPolicyNodeGroupRequest optionsRequestedPolicyVersion
                         * @property {string|null} [project] GetIamPolicyNodeGroupRequest project
                         * @property {string|null} [resource] GetIamPolicyNodeGroupRequest resource
                         * @property {string|null} [zone] GetIamPolicyNodeGroupRequest zone
                         */
    
                        /**
                         * Constructs a new GetIamPolicyNodeGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetIamPolicyNodeGroupRequest.
                         * @implements IGetIamPolicyNodeGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetIamPolicyNodeGroupRequest=} [properties] Properties to set
                         */
                        function GetIamPolicyNodeGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetIamPolicyNodeGroupRequest optionsRequestedPolicyVersion.
                         * @member {number|null|undefined} optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeGroupRequest
                         * @instance
                         */
                        GetIamPolicyNodeGroupRequest.prototype.optionsRequestedPolicyVersion = null;
    
                        /**
                         * GetIamPolicyNodeGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeGroupRequest
                         * @instance
                         */
                        GetIamPolicyNodeGroupRequest.prototype.project = "";
    
                        /**
                         * GetIamPolicyNodeGroupRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeGroupRequest
                         * @instance
                         */
                        GetIamPolicyNodeGroupRequest.prototype.resource = "";
    
                        /**
                         * GetIamPolicyNodeGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeGroupRequest
                         * @instance
                         */
                        GetIamPolicyNodeGroupRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetIamPolicyNodeGroupRequest _optionsRequestedPolicyVersion.
                         * @member {"optionsRequestedPolicyVersion"|undefined} _optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeGroupRequest
                         * @instance
                         */
                        Object.defineProperty(GetIamPolicyNodeGroupRequest.prototype, "_optionsRequestedPolicyVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["optionsRequestedPolicyVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetIamPolicyNodeGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyNodeGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetIamPolicyNodeGroupRequest} GetIamPolicyNodeGroupRequest instance
                         */
                        GetIamPolicyNodeGroupRequest.create = function create(properties) {
                            return new GetIamPolicyNodeGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyNodeGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyNodeGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyNodeGroupRequest} message GetIamPolicyNodeGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyNodeGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.optionsRequestedPolicyVersion != null && Object.hasOwnProperty.call(message, "optionsRequestedPolicyVersion"))
                                writer.uint32(/* id 499220029, wireType 0 =*/3993760232).int32(message.optionsRequestedPolicyVersion);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyNodeGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyNodeGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyNodeGroupRequest} message GetIamPolicyNodeGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyNodeGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetIamPolicyNodeGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetIamPolicyNodeGroupRequest} GetIamPolicyNodeGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyNodeGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetIamPolicyNodeGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 499220029: {
                                        message.optionsRequestedPolicyVersion = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetIamPolicyNodeGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetIamPolicyNodeGroupRequest} GetIamPolicyNodeGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyNodeGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetIamPolicyNodeGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetIamPolicyNodeGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                properties._optionsRequestedPolicyVersion = 1;
                                if (!$util.isInteger(message.optionsRequestedPolicyVersion))
                                    return "optionsRequestedPolicyVersion: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetIamPolicyNodeGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetIamPolicyNodeGroupRequest} GetIamPolicyNodeGroupRequest
                         */
                        GetIamPolicyNodeGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetIamPolicyNodeGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetIamPolicyNodeGroupRequest();
                            if (object.optionsRequestedPolicyVersion != null)
                                message.optionsRequestedPolicyVersion = object.optionsRequestedPolicyVersion | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetIamPolicyNodeGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetIamPolicyNodeGroupRequest} message GetIamPolicyNodeGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetIamPolicyNodeGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.resource = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                object.optionsRequestedPolicyVersion = message.optionsRequestedPolicyVersion;
                                if (options.oneofs)
                                    object._optionsRequestedPolicyVersion = "optionsRequestedPolicyVersion";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetIamPolicyNodeGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetIamPolicyNodeGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetIamPolicyNodeGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetIamPolicyNodeGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetIamPolicyNodeGroupRequest";
                        };
    
                        return GetIamPolicyNodeGroupRequest;
                    })();
    
                    v1.GetIamPolicyNodeTemplateRequest = (function() {
    
                        /**
                         * Properties of a GetIamPolicyNodeTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetIamPolicyNodeTemplateRequest
                         * @property {number|null} [optionsRequestedPolicyVersion] GetIamPolicyNodeTemplateRequest optionsRequestedPolicyVersion
                         * @property {string|null} [project] GetIamPolicyNodeTemplateRequest project
                         * @property {string|null} [region] GetIamPolicyNodeTemplateRequest region
                         * @property {string|null} [resource] GetIamPolicyNodeTemplateRequest resource
                         */
    
                        /**
                         * Constructs a new GetIamPolicyNodeTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetIamPolicyNodeTemplateRequest.
                         * @implements IGetIamPolicyNodeTemplateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetIamPolicyNodeTemplateRequest=} [properties] Properties to set
                         */
                        function GetIamPolicyNodeTemplateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetIamPolicyNodeTemplateRequest optionsRequestedPolicyVersion.
                         * @member {number|null|undefined} optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest
                         * @instance
                         */
                        GetIamPolicyNodeTemplateRequest.prototype.optionsRequestedPolicyVersion = null;
    
                        /**
                         * GetIamPolicyNodeTemplateRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest
                         * @instance
                         */
                        GetIamPolicyNodeTemplateRequest.prototype.project = "";
    
                        /**
                         * GetIamPolicyNodeTemplateRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest
                         * @instance
                         */
                        GetIamPolicyNodeTemplateRequest.prototype.region = "";
    
                        /**
                         * GetIamPolicyNodeTemplateRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest
                         * @instance
                         */
                        GetIamPolicyNodeTemplateRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetIamPolicyNodeTemplateRequest _optionsRequestedPolicyVersion.
                         * @member {"optionsRequestedPolicyVersion"|undefined} _optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest
                         * @instance
                         */
                        Object.defineProperty(GetIamPolicyNodeTemplateRequest.prototype, "_optionsRequestedPolicyVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["optionsRequestedPolicyVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetIamPolicyNodeTemplateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyNodeTemplateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest} GetIamPolicyNodeTemplateRequest instance
                         */
                        GetIamPolicyNodeTemplateRequest.create = function create(properties) {
                            return new GetIamPolicyNodeTemplateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyNodeTemplateRequest message. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyNodeTemplateRequest} message GetIamPolicyNodeTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyNodeTemplateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.optionsRequestedPolicyVersion != null && Object.hasOwnProperty.call(message, "optionsRequestedPolicyVersion"))
                                writer.uint32(/* id 499220029, wireType 0 =*/3993760232).int32(message.optionsRequestedPolicyVersion);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyNodeTemplateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyNodeTemplateRequest} message GetIamPolicyNodeTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyNodeTemplateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetIamPolicyNodeTemplateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest} GetIamPolicyNodeTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyNodeTemplateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 499220029: {
                                        message.optionsRequestedPolicyVersion = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetIamPolicyNodeTemplateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest} GetIamPolicyNodeTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyNodeTemplateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetIamPolicyNodeTemplateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetIamPolicyNodeTemplateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                properties._optionsRequestedPolicyVersion = 1;
                                if (!$util.isInteger(message.optionsRequestedPolicyVersion))
                                    return "optionsRequestedPolicyVersion: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetIamPolicyNodeTemplateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest} GetIamPolicyNodeTemplateRequest
                         */
                        GetIamPolicyNodeTemplateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest();
                            if (object.optionsRequestedPolicyVersion != null)
                                message.optionsRequestedPolicyVersion = object.optionsRequestedPolicyVersion | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetIamPolicyNodeTemplateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest} message GetIamPolicyNodeTemplateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetIamPolicyNodeTemplateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                object.optionsRequestedPolicyVersion = message.optionsRequestedPolicyVersion;
                                if (options.oneofs)
                                    object._optionsRequestedPolicyVersion = "optionsRequestedPolicyVersion";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetIamPolicyNodeTemplateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetIamPolicyNodeTemplateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetIamPolicyNodeTemplateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetIamPolicyNodeTemplateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest";
                        };
    
                        return GetIamPolicyNodeTemplateRequest;
                    })();
    
                    v1.GetIamPolicyRegionBackendServiceRequest = (function() {
    
                        /**
                         * Properties of a GetIamPolicyRegionBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetIamPolicyRegionBackendServiceRequest
                         * @property {number|null} [optionsRequestedPolicyVersion] GetIamPolicyRegionBackendServiceRequest optionsRequestedPolicyVersion
                         * @property {string|null} [project] GetIamPolicyRegionBackendServiceRequest project
                         * @property {string|null} [region] GetIamPolicyRegionBackendServiceRequest region
                         * @property {string|null} [resource] GetIamPolicyRegionBackendServiceRequest resource
                         */
    
                        /**
                         * Constructs a new GetIamPolicyRegionBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetIamPolicyRegionBackendServiceRequest.
                         * @implements IGetIamPolicyRegionBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetIamPolicyRegionBackendServiceRequest=} [properties] Properties to set
                         */
                        function GetIamPolicyRegionBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetIamPolicyRegionBackendServiceRequest optionsRequestedPolicyVersion.
                         * @member {number|null|undefined} optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest
                         * @instance
                         */
                        GetIamPolicyRegionBackendServiceRequest.prototype.optionsRequestedPolicyVersion = null;
    
                        /**
                         * GetIamPolicyRegionBackendServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest
                         * @instance
                         */
                        GetIamPolicyRegionBackendServiceRequest.prototype.project = "";
    
                        /**
                         * GetIamPolicyRegionBackendServiceRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest
                         * @instance
                         */
                        GetIamPolicyRegionBackendServiceRequest.prototype.region = "";
    
                        /**
                         * GetIamPolicyRegionBackendServiceRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest
                         * @instance
                         */
                        GetIamPolicyRegionBackendServiceRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetIamPolicyRegionBackendServiceRequest _optionsRequestedPolicyVersion.
                         * @member {"optionsRequestedPolicyVersion"|undefined} _optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest
                         * @instance
                         */
                        Object.defineProperty(GetIamPolicyRegionBackendServiceRequest.prototype, "_optionsRequestedPolicyVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["optionsRequestedPolicyVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetIamPolicyRegionBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyRegionBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest} GetIamPolicyRegionBackendServiceRequest instance
                         */
                        GetIamPolicyRegionBackendServiceRequest.create = function create(properties) {
                            return new GetIamPolicyRegionBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyRegionBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyRegionBackendServiceRequest} message GetIamPolicyRegionBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyRegionBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.optionsRequestedPolicyVersion != null && Object.hasOwnProperty.call(message, "optionsRequestedPolicyVersion"))
                                writer.uint32(/* id 499220029, wireType 0 =*/3993760232).int32(message.optionsRequestedPolicyVersion);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyRegionBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyRegionBackendServiceRequest} message GetIamPolicyRegionBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyRegionBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetIamPolicyRegionBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest} GetIamPolicyRegionBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyRegionBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 499220029: {
                                        message.optionsRequestedPolicyVersion = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetIamPolicyRegionBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest} GetIamPolicyRegionBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyRegionBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetIamPolicyRegionBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetIamPolicyRegionBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                properties._optionsRequestedPolicyVersion = 1;
                                if (!$util.isInteger(message.optionsRequestedPolicyVersion))
                                    return "optionsRequestedPolicyVersion: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetIamPolicyRegionBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest} GetIamPolicyRegionBackendServiceRequest
                         */
                        GetIamPolicyRegionBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest();
                            if (object.optionsRequestedPolicyVersion != null)
                                message.optionsRequestedPolicyVersion = object.optionsRequestedPolicyVersion | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetIamPolicyRegionBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest} message GetIamPolicyRegionBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetIamPolicyRegionBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                object.optionsRequestedPolicyVersion = message.optionsRequestedPolicyVersion;
                                if (options.oneofs)
                                    object._optionsRequestedPolicyVersion = "optionsRequestedPolicyVersion";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetIamPolicyRegionBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetIamPolicyRegionBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetIamPolicyRegionBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetIamPolicyRegionBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest";
                        };
    
                        return GetIamPolicyRegionBackendServiceRequest;
                    })();
    
                    v1.GetIamPolicyRegionDiskRequest = (function() {
    
                        /**
                         * Properties of a GetIamPolicyRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetIamPolicyRegionDiskRequest
                         * @property {number|null} [optionsRequestedPolicyVersion] GetIamPolicyRegionDiskRequest optionsRequestedPolicyVersion
                         * @property {string|null} [project] GetIamPolicyRegionDiskRequest project
                         * @property {string|null} [region] GetIamPolicyRegionDiskRequest region
                         * @property {string|null} [resource] GetIamPolicyRegionDiskRequest resource
                         */
    
                        /**
                         * Constructs a new GetIamPolicyRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetIamPolicyRegionDiskRequest.
                         * @implements IGetIamPolicyRegionDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetIamPolicyRegionDiskRequest=} [properties] Properties to set
                         */
                        function GetIamPolicyRegionDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetIamPolicyRegionDiskRequest optionsRequestedPolicyVersion.
                         * @member {number|null|undefined} optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionDiskRequest
                         * @instance
                         */
                        GetIamPolicyRegionDiskRequest.prototype.optionsRequestedPolicyVersion = null;
    
                        /**
                         * GetIamPolicyRegionDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionDiskRequest
                         * @instance
                         */
                        GetIamPolicyRegionDiskRequest.prototype.project = "";
    
                        /**
                         * GetIamPolicyRegionDiskRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionDiskRequest
                         * @instance
                         */
                        GetIamPolicyRegionDiskRequest.prototype.region = "";
    
                        /**
                         * GetIamPolicyRegionDiskRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionDiskRequest
                         * @instance
                         */
                        GetIamPolicyRegionDiskRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetIamPolicyRegionDiskRequest _optionsRequestedPolicyVersion.
                         * @member {"optionsRequestedPolicyVersion"|undefined} _optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionDiskRequest
                         * @instance
                         */
                        Object.defineProperty(GetIamPolicyRegionDiskRequest.prototype, "_optionsRequestedPolicyVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["optionsRequestedPolicyVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetIamPolicyRegionDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyRegionDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetIamPolicyRegionDiskRequest} GetIamPolicyRegionDiskRequest instance
                         */
                        GetIamPolicyRegionDiskRequest.create = function create(properties) {
                            return new GetIamPolicyRegionDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyRegionDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyRegionDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyRegionDiskRequest} message GetIamPolicyRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyRegionDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.optionsRequestedPolicyVersion != null && Object.hasOwnProperty.call(message, "optionsRequestedPolicyVersion"))
                                writer.uint32(/* id 499220029, wireType 0 =*/3993760232).int32(message.optionsRequestedPolicyVersion);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyRegionDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyRegionDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyRegionDiskRequest} message GetIamPolicyRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyRegionDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetIamPolicyRegionDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetIamPolicyRegionDiskRequest} GetIamPolicyRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyRegionDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetIamPolicyRegionDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 499220029: {
                                        message.optionsRequestedPolicyVersion = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetIamPolicyRegionDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetIamPolicyRegionDiskRequest} GetIamPolicyRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyRegionDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetIamPolicyRegionDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetIamPolicyRegionDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                properties._optionsRequestedPolicyVersion = 1;
                                if (!$util.isInteger(message.optionsRequestedPolicyVersion))
                                    return "optionsRequestedPolicyVersion: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetIamPolicyRegionDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetIamPolicyRegionDiskRequest} GetIamPolicyRegionDiskRequest
                         */
                        GetIamPolicyRegionDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetIamPolicyRegionDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetIamPolicyRegionDiskRequest();
                            if (object.optionsRequestedPolicyVersion != null)
                                message.optionsRequestedPolicyVersion = object.optionsRequestedPolicyVersion | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetIamPolicyRegionDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetIamPolicyRegionDiskRequest} message GetIamPolicyRegionDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetIamPolicyRegionDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                object.optionsRequestedPolicyVersion = message.optionsRequestedPolicyVersion;
                                if (options.oneofs)
                                    object._optionsRequestedPolicyVersion = "optionsRequestedPolicyVersion";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetIamPolicyRegionDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetIamPolicyRegionDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetIamPolicyRegionDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetIamPolicyRegionDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetIamPolicyRegionDiskRequest";
                        };
    
                        return GetIamPolicyRegionDiskRequest;
                    })();
    
                    v1.GetIamPolicyRegionNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a GetIamPolicyRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @property {number|null} [optionsRequestedPolicyVersion] GetIamPolicyRegionNetworkFirewallPolicyRequest optionsRequestedPolicyVersion
                         * @property {string|null} [project] GetIamPolicyRegionNetworkFirewallPolicyRequest project
                         * @property {string|null} [region] GetIamPolicyRegionNetworkFirewallPolicyRequest region
                         * @property {string|null} [resource] GetIamPolicyRegionNetworkFirewallPolicyRequest resource
                         */
    
                        /**
                         * Constructs a new GetIamPolicyRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetIamPolicyRegionNetworkFirewallPolicyRequest.
                         * @implements IGetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetIamPolicyRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function GetIamPolicyRegionNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetIamPolicyRegionNetworkFirewallPolicyRequest optionsRequestedPolicyVersion.
                         * @member {number|null|undefined} optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetIamPolicyRegionNetworkFirewallPolicyRequest.prototype.optionsRequestedPolicyVersion = null;
    
                        /**
                         * GetIamPolicyRegionNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetIamPolicyRegionNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * GetIamPolicyRegionNetworkFirewallPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetIamPolicyRegionNetworkFirewallPolicyRequest.prototype.region = "";
    
                        /**
                         * GetIamPolicyRegionNetworkFirewallPolicyRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetIamPolicyRegionNetworkFirewallPolicyRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetIamPolicyRegionNetworkFirewallPolicyRequest _optionsRequestedPolicyVersion.
                         * @member {"optionsRequestedPolicyVersion"|undefined} _optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(GetIamPolicyRegionNetworkFirewallPolicyRequest.prototype, "_optionsRequestedPolicyVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["optionsRequestedPolicyVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetIamPolicyRegionNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest} GetIamPolicyRegionNetworkFirewallPolicyRequest instance
                         */
                        GetIamPolicyRegionNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new GetIamPolicyRegionNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyRegionNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyRegionNetworkFirewallPolicyRequest} message GetIamPolicyRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyRegionNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.optionsRequestedPolicyVersion != null && Object.hasOwnProperty.call(message, "optionsRequestedPolicyVersion"))
                                writer.uint32(/* id 499220029, wireType 0 =*/3993760232).int32(message.optionsRequestedPolicyVersion);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyRegionNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyRegionNetworkFirewallPolicyRequest} message GetIamPolicyRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyRegionNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetIamPolicyRegionNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest} GetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyRegionNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 499220029: {
                                        message.optionsRequestedPolicyVersion = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetIamPolicyRegionNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest} GetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyRegionNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetIamPolicyRegionNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetIamPolicyRegionNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                properties._optionsRequestedPolicyVersion = 1;
                                if (!$util.isInteger(message.optionsRequestedPolicyVersion))
                                    return "optionsRequestedPolicyVersion: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetIamPolicyRegionNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest} GetIamPolicyRegionNetworkFirewallPolicyRequest
                         */
                        GetIamPolicyRegionNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest();
                            if (object.optionsRequestedPolicyVersion != null)
                                message.optionsRequestedPolicyVersion = object.optionsRequestedPolicyVersion | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetIamPolicyRegionNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest} message GetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetIamPolicyRegionNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                object.optionsRequestedPolicyVersion = message.optionsRequestedPolicyVersion;
                                if (options.oneofs)
                                    object._optionsRequestedPolicyVersion = "optionsRequestedPolicyVersion";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetIamPolicyRegionNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetIamPolicyRegionNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetIamPolicyRegionNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest";
                        };
    
                        return GetIamPolicyRegionNetworkFirewallPolicyRequest;
                    })();
    
                    v1.GetIamPolicyReservationRequest = (function() {
    
                        /**
                         * Properties of a GetIamPolicyReservationRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetIamPolicyReservationRequest
                         * @property {number|null} [optionsRequestedPolicyVersion] GetIamPolicyReservationRequest optionsRequestedPolicyVersion
                         * @property {string|null} [project] GetIamPolicyReservationRequest project
                         * @property {string|null} [resource] GetIamPolicyReservationRequest resource
                         * @property {string|null} [zone] GetIamPolicyReservationRequest zone
                         */
    
                        /**
                         * Constructs a new GetIamPolicyReservationRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetIamPolicyReservationRequest.
                         * @implements IGetIamPolicyReservationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetIamPolicyReservationRequest=} [properties] Properties to set
                         */
                        function GetIamPolicyReservationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetIamPolicyReservationRequest optionsRequestedPolicyVersion.
                         * @member {number|null|undefined} optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyReservationRequest
                         * @instance
                         */
                        GetIamPolicyReservationRequest.prototype.optionsRequestedPolicyVersion = null;
    
                        /**
                         * GetIamPolicyReservationRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetIamPolicyReservationRequest
                         * @instance
                         */
                        GetIamPolicyReservationRequest.prototype.project = "";
    
                        /**
                         * GetIamPolicyReservationRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.GetIamPolicyReservationRequest
                         * @instance
                         */
                        GetIamPolicyReservationRequest.prototype.resource = "";
    
                        /**
                         * GetIamPolicyReservationRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetIamPolicyReservationRequest
                         * @instance
                         */
                        GetIamPolicyReservationRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetIamPolicyReservationRequest _optionsRequestedPolicyVersion.
                         * @member {"optionsRequestedPolicyVersion"|undefined} _optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyReservationRequest
                         * @instance
                         */
                        Object.defineProperty(GetIamPolicyReservationRequest.prototype, "_optionsRequestedPolicyVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["optionsRequestedPolicyVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetIamPolicyReservationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetIamPolicyReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyReservationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetIamPolicyReservationRequest} GetIamPolicyReservationRequest instance
                         */
                        GetIamPolicyReservationRequest.create = function create(properties) {
                            return new GetIamPolicyReservationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyReservationRequest message. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyReservationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetIamPolicyReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyReservationRequest} message GetIamPolicyReservationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyReservationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.optionsRequestedPolicyVersion != null && Object.hasOwnProperty.call(message, "optionsRequestedPolicyVersion"))
                                writer.uint32(/* id 499220029, wireType 0 =*/3993760232).int32(message.optionsRequestedPolicyVersion);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyReservationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyReservationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyReservationRequest} message GetIamPolicyReservationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyReservationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetIamPolicyReservationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetIamPolicyReservationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetIamPolicyReservationRequest} GetIamPolicyReservationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyReservationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetIamPolicyReservationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 499220029: {
                                        message.optionsRequestedPolicyVersion = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetIamPolicyReservationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyReservationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetIamPolicyReservationRequest} GetIamPolicyReservationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyReservationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetIamPolicyReservationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetIamPolicyReservationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetIamPolicyReservationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                properties._optionsRequestedPolicyVersion = 1;
                                if (!$util.isInteger(message.optionsRequestedPolicyVersion))
                                    return "optionsRequestedPolicyVersion: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetIamPolicyReservationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyReservationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetIamPolicyReservationRequest} GetIamPolicyReservationRequest
                         */
                        GetIamPolicyReservationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetIamPolicyReservationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetIamPolicyReservationRequest();
                            if (object.optionsRequestedPolicyVersion != null)
                                message.optionsRequestedPolicyVersion = object.optionsRequestedPolicyVersion | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetIamPolicyReservationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetIamPolicyReservationRequest} message GetIamPolicyReservationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetIamPolicyReservationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.resource = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                object.optionsRequestedPolicyVersion = message.optionsRequestedPolicyVersion;
                                if (options.oneofs)
                                    object._optionsRequestedPolicyVersion = "optionsRequestedPolicyVersion";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetIamPolicyReservationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetIamPolicyReservationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetIamPolicyReservationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetIamPolicyReservationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetIamPolicyReservationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetIamPolicyReservationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetIamPolicyReservationRequest";
                        };
    
                        return GetIamPolicyReservationRequest;
                    })();
    
                    v1.GetIamPolicyResourcePolicyRequest = (function() {
    
                        /**
                         * Properties of a GetIamPolicyResourcePolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetIamPolicyResourcePolicyRequest
                         * @property {number|null} [optionsRequestedPolicyVersion] GetIamPolicyResourcePolicyRequest optionsRequestedPolicyVersion
                         * @property {string|null} [project] GetIamPolicyResourcePolicyRequest project
                         * @property {string|null} [region] GetIamPolicyResourcePolicyRequest region
                         * @property {string|null} [resource] GetIamPolicyResourcePolicyRequest resource
                         */
    
                        /**
                         * Constructs a new GetIamPolicyResourcePolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetIamPolicyResourcePolicyRequest.
                         * @implements IGetIamPolicyResourcePolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetIamPolicyResourcePolicyRequest=} [properties] Properties to set
                         */
                        function GetIamPolicyResourcePolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetIamPolicyResourcePolicyRequest optionsRequestedPolicyVersion.
                         * @member {number|null|undefined} optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest
                         * @instance
                         */
                        GetIamPolicyResourcePolicyRequest.prototype.optionsRequestedPolicyVersion = null;
    
                        /**
                         * GetIamPolicyResourcePolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest
                         * @instance
                         */
                        GetIamPolicyResourcePolicyRequest.prototype.project = "";
    
                        /**
                         * GetIamPolicyResourcePolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest
                         * @instance
                         */
                        GetIamPolicyResourcePolicyRequest.prototype.region = "";
    
                        /**
                         * GetIamPolicyResourcePolicyRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest
                         * @instance
                         */
                        GetIamPolicyResourcePolicyRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetIamPolicyResourcePolicyRequest _optionsRequestedPolicyVersion.
                         * @member {"optionsRequestedPolicyVersion"|undefined} _optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest
                         * @instance
                         */
                        Object.defineProperty(GetIamPolicyResourcePolicyRequest.prototype, "_optionsRequestedPolicyVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["optionsRequestedPolicyVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetIamPolicyResourcePolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyResourcePolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest} GetIamPolicyResourcePolicyRequest instance
                         */
                        GetIamPolicyResourcePolicyRequest.create = function create(properties) {
                            return new GetIamPolicyResourcePolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyResourcePolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyResourcePolicyRequest} message GetIamPolicyResourcePolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyResourcePolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.optionsRequestedPolicyVersion != null && Object.hasOwnProperty.call(message, "optionsRequestedPolicyVersion"))
                                writer.uint32(/* id 499220029, wireType 0 =*/3993760232).int32(message.optionsRequestedPolicyVersion);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyResourcePolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyResourcePolicyRequest} message GetIamPolicyResourcePolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyResourcePolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetIamPolicyResourcePolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest} GetIamPolicyResourcePolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyResourcePolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 499220029: {
                                        message.optionsRequestedPolicyVersion = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetIamPolicyResourcePolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest} GetIamPolicyResourcePolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyResourcePolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetIamPolicyResourcePolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetIamPolicyResourcePolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                properties._optionsRequestedPolicyVersion = 1;
                                if (!$util.isInteger(message.optionsRequestedPolicyVersion))
                                    return "optionsRequestedPolicyVersion: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetIamPolicyResourcePolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest} GetIamPolicyResourcePolicyRequest
                         */
                        GetIamPolicyResourcePolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest();
                            if (object.optionsRequestedPolicyVersion != null)
                                message.optionsRequestedPolicyVersion = object.optionsRequestedPolicyVersion | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetIamPolicyResourcePolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest} message GetIamPolicyResourcePolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetIamPolicyResourcePolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                object.optionsRequestedPolicyVersion = message.optionsRequestedPolicyVersion;
                                if (options.oneofs)
                                    object._optionsRequestedPolicyVersion = "optionsRequestedPolicyVersion";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetIamPolicyResourcePolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetIamPolicyResourcePolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetIamPolicyResourcePolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetIamPolicyResourcePolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest";
                        };
    
                        return GetIamPolicyResourcePolicyRequest;
                    })();
    
                    v1.GetIamPolicyServiceAttachmentRequest = (function() {
    
                        /**
                         * Properties of a GetIamPolicyServiceAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetIamPolicyServiceAttachmentRequest
                         * @property {number|null} [optionsRequestedPolicyVersion] GetIamPolicyServiceAttachmentRequest optionsRequestedPolicyVersion
                         * @property {string|null} [project] GetIamPolicyServiceAttachmentRequest project
                         * @property {string|null} [region] GetIamPolicyServiceAttachmentRequest region
                         * @property {string|null} [resource] GetIamPolicyServiceAttachmentRequest resource
                         */
    
                        /**
                         * Constructs a new GetIamPolicyServiceAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetIamPolicyServiceAttachmentRequest.
                         * @implements IGetIamPolicyServiceAttachmentRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetIamPolicyServiceAttachmentRequest=} [properties] Properties to set
                         */
                        function GetIamPolicyServiceAttachmentRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetIamPolicyServiceAttachmentRequest optionsRequestedPolicyVersion.
                         * @member {number|null|undefined} optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest
                         * @instance
                         */
                        GetIamPolicyServiceAttachmentRequest.prototype.optionsRequestedPolicyVersion = null;
    
                        /**
                         * GetIamPolicyServiceAttachmentRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest
                         * @instance
                         */
                        GetIamPolicyServiceAttachmentRequest.prototype.project = "";
    
                        /**
                         * GetIamPolicyServiceAttachmentRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest
                         * @instance
                         */
                        GetIamPolicyServiceAttachmentRequest.prototype.region = "";
    
                        /**
                         * GetIamPolicyServiceAttachmentRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest
                         * @instance
                         */
                        GetIamPolicyServiceAttachmentRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetIamPolicyServiceAttachmentRequest _optionsRequestedPolicyVersion.
                         * @member {"optionsRequestedPolicyVersion"|undefined} _optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest
                         * @instance
                         */
                        Object.defineProperty(GetIamPolicyServiceAttachmentRequest.prototype, "_optionsRequestedPolicyVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["optionsRequestedPolicyVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetIamPolicyServiceAttachmentRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyServiceAttachmentRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest} GetIamPolicyServiceAttachmentRequest instance
                         */
                        GetIamPolicyServiceAttachmentRequest.create = function create(properties) {
                            return new GetIamPolicyServiceAttachmentRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyServiceAttachmentRequest message. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyServiceAttachmentRequest} message GetIamPolicyServiceAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyServiceAttachmentRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.optionsRequestedPolicyVersion != null && Object.hasOwnProperty.call(message, "optionsRequestedPolicyVersion"))
                                writer.uint32(/* id 499220029, wireType 0 =*/3993760232).int32(message.optionsRequestedPolicyVersion);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetIamPolicyServiceAttachmentRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicyServiceAttachmentRequest} message GetIamPolicyServiceAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicyServiceAttachmentRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetIamPolicyServiceAttachmentRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest} GetIamPolicyServiceAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyServiceAttachmentRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 499220029: {
                                        message.optionsRequestedPolicyVersion = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetIamPolicyServiceAttachmentRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest} GetIamPolicyServiceAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicyServiceAttachmentRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetIamPolicyServiceAttachmentRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetIamPolicyServiceAttachmentRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                properties._optionsRequestedPolicyVersion = 1;
                                if (!$util.isInteger(message.optionsRequestedPolicyVersion))
                                    return "optionsRequestedPolicyVersion: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetIamPolicyServiceAttachmentRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest} GetIamPolicyServiceAttachmentRequest
                         */
                        GetIamPolicyServiceAttachmentRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest();
                            if (object.optionsRequestedPolicyVersion != null)
                                message.optionsRequestedPolicyVersion = object.optionsRequestedPolicyVersion | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetIamPolicyServiceAttachmentRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest} message GetIamPolicyServiceAttachmentRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetIamPolicyServiceAttachmentRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                object.optionsRequestedPolicyVersion = message.optionsRequestedPolicyVersion;
                                if (options.oneofs)
                                    object._optionsRequestedPolicyVersion = "optionsRequestedPolicyVersion";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetIamPolicyServiceAttachmentRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetIamPolicyServiceAttachmentRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetIamPolicyServiceAttachmentRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetIamPolicyServiceAttachmentRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest";
                        };
    
                        return GetIamPolicyServiceAttachmentRequest;
                    })();
    
                    v1.GetIamPolicySnapshotRequest = (function() {
    
                        /**
                         * Properties of a GetIamPolicySnapshotRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetIamPolicySnapshotRequest
                         * @property {number|null} [optionsRequestedPolicyVersion] GetIamPolicySnapshotRequest optionsRequestedPolicyVersion
                         * @property {string|null} [project] GetIamPolicySnapshotRequest project
                         * @property {string|null} [resource] GetIamPolicySnapshotRequest resource
                         */
    
                        /**
                         * Constructs a new GetIamPolicySnapshotRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetIamPolicySnapshotRequest.
                         * @implements IGetIamPolicySnapshotRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetIamPolicySnapshotRequest=} [properties] Properties to set
                         */
                        function GetIamPolicySnapshotRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetIamPolicySnapshotRequest optionsRequestedPolicyVersion.
                         * @member {number|null|undefined} optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicySnapshotRequest
                         * @instance
                         */
                        GetIamPolicySnapshotRequest.prototype.optionsRequestedPolicyVersion = null;
    
                        /**
                         * GetIamPolicySnapshotRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetIamPolicySnapshotRequest
                         * @instance
                         */
                        GetIamPolicySnapshotRequest.prototype.project = "";
    
                        /**
                         * GetIamPolicySnapshotRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.GetIamPolicySnapshotRequest
                         * @instance
                         */
                        GetIamPolicySnapshotRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetIamPolicySnapshotRequest _optionsRequestedPolicyVersion.
                         * @member {"optionsRequestedPolicyVersion"|undefined} _optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicySnapshotRequest
                         * @instance
                         */
                        Object.defineProperty(GetIamPolicySnapshotRequest.prototype, "_optionsRequestedPolicyVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["optionsRequestedPolicyVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetIamPolicySnapshotRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetIamPolicySnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicySnapshotRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetIamPolicySnapshotRequest} GetIamPolicySnapshotRequest instance
                         */
                        GetIamPolicySnapshotRequest.create = function create(properties) {
                            return new GetIamPolicySnapshotRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetIamPolicySnapshotRequest message. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicySnapshotRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetIamPolicySnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicySnapshotRequest} message GetIamPolicySnapshotRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicySnapshotRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.optionsRequestedPolicyVersion != null && Object.hasOwnProperty.call(message, "optionsRequestedPolicyVersion"))
                                writer.uint32(/* id 499220029, wireType 0 =*/3993760232).int32(message.optionsRequestedPolicyVersion);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetIamPolicySnapshotRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicySnapshotRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicySnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicySnapshotRequest} message GetIamPolicySnapshotRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicySnapshotRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetIamPolicySnapshotRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetIamPolicySnapshotRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetIamPolicySnapshotRequest} GetIamPolicySnapshotRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicySnapshotRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetIamPolicySnapshotRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 499220029: {
                                        message.optionsRequestedPolicyVersion = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetIamPolicySnapshotRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicySnapshotRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetIamPolicySnapshotRequest} GetIamPolicySnapshotRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicySnapshotRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetIamPolicySnapshotRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetIamPolicySnapshotRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetIamPolicySnapshotRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                properties._optionsRequestedPolicyVersion = 1;
                                if (!$util.isInteger(message.optionsRequestedPolicyVersion))
                                    return "optionsRequestedPolicyVersion: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetIamPolicySnapshotRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetIamPolicySnapshotRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetIamPolicySnapshotRequest} GetIamPolicySnapshotRequest
                         */
                        GetIamPolicySnapshotRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetIamPolicySnapshotRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetIamPolicySnapshotRequest();
                            if (object.optionsRequestedPolicyVersion != null)
                                message.optionsRequestedPolicyVersion = object.optionsRequestedPolicyVersion | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetIamPolicySnapshotRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetIamPolicySnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetIamPolicySnapshotRequest} message GetIamPolicySnapshotRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetIamPolicySnapshotRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                object.optionsRequestedPolicyVersion = message.optionsRequestedPolicyVersion;
                                if (options.oneofs)
                                    object._optionsRequestedPolicyVersion = "optionsRequestedPolicyVersion";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetIamPolicySnapshotRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetIamPolicySnapshotRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetIamPolicySnapshotRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetIamPolicySnapshotRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetIamPolicySnapshotRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetIamPolicySnapshotRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetIamPolicySnapshotRequest";
                        };
    
                        return GetIamPolicySnapshotRequest;
                    })();
    
                    v1.GetIamPolicySubnetworkRequest = (function() {
    
                        /**
                         * Properties of a GetIamPolicySubnetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetIamPolicySubnetworkRequest
                         * @property {number|null} [optionsRequestedPolicyVersion] GetIamPolicySubnetworkRequest optionsRequestedPolicyVersion
                         * @property {string|null} [project] GetIamPolicySubnetworkRequest project
                         * @property {string|null} [region] GetIamPolicySubnetworkRequest region
                         * @property {string|null} [resource] GetIamPolicySubnetworkRequest resource
                         */
    
                        /**
                         * Constructs a new GetIamPolicySubnetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetIamPolicySubnetworkRequest.
                         * @implements IGetIamPolicySubnetworkRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetIamPolicySubnetworkRequest=} [properties] Properties to set
                         */
                        function GetIamPolicySubnetworkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetIamPolicySubnetworkRequest optionsRequestedPolicyVersion.
                         * @member {number|null|undefined} optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicySubnetworkRequest
                         * @instance
                         */
                        GetIamPolicySubnetworkRequest.prototype.optionsRequestedPolicyVersion = null;
    
                        /**
                         * GetIamPolicySubnetworkRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetIamPolicySubnetworkRequest
                         * @instance
                         */
                        GetIamPolicySubnetworkRequest.prototype.project = "";
    
                        /**
                         * GetIamPolicySubnetworkRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetIamPolicySubnetworkRequest
                         * @instance
                         */
                        GetIamPolicySubnetworkRequest.prototype.region = "";
    
                        /**
                         * GetIamPolicySubnetworkRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.GetIamPolicySubnetworkRequest
                         * @instance
                         */
                        GetIamPolicySubnetworkRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetIamPolicySubnetworkRequest _optionsRequestedPolicyVersion.
                         * @member {"optionsRequestedPolicyVersion"|undefined} _optionsRequestedPolicyVersion
                         * @memberof google.cloud.compute.v1.GetIamPolicySubnetworkRequest
                         * @instance
                         */
                        Object.defineProperty(GetIamPolicySubnetworkRequest.prototype, "_optionsRequestedPolicyVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["optionsRequestedPolicyVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetIamPolicySubnetworkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetIamPolicySubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicySubnetworkRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetIamPolicySubnetworkRequest} GetIamPolicySubnetworkRequest instance
                         */
                        GetIamPolicySubnetworkRequest.create = function create(properties) {
                            return new GetIamPolicySubnetworkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetIamPolicySubnetworkRequest message. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicySubnetworkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetIamPolicySubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicySubnetworkRequest} message GetIamPolicySubnetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicySubnetworkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.optionsRequestedPolicyVersion != null && Object.hasOwnProperty.call(message, "optionsRequestedPolicyVersion"))
                                writer.uint32(/* id 499220029, wireType 0 =*/3993760232).int32(message.optionsRequestedPolicyVersion);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetIamPolicySubnetworkRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetIamPolicySubnetworkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicySubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetIamPolicySubnetworkRequest} message GetIamPolicySubnetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetIamPolicySubnetworkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetIamPolicySubnetworkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetIamPolicySubnetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetIamPolicySubnetworkRequest} GetIamPolicySubnetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicySubnetworkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetIamPolicySubnetworkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 499220029: {
                                        message.optionsRequestedPolicyVersion = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetIamPolicySubnetworkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetIamPolicySubnetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetIamPolicySubnetworkRequest} GetIamPolicySubnetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetIamPolicySubnetworkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetIamPolicySubnetworkRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetIamPolicySubnetworkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetIamPolicySubnetworkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                properties._optionsRequestedPolicyVersion = 1;
                                if (!$util.isInteger(message.optionsRequestedPolicyVersion))
                                    return "optionsRequestedPolicyVersion: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetIamPolicySubnetworkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetIamPolicySubnetworkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetIamPolicySubnetworkRequest} GetIamPolicySubnetworkRequest
                         */
                        GetIamPolicySubnetworkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetIamPolicySubnetworkRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetIamPolicySubnetworkRequest();
                            if (object.optionsRequestedPolicyVersion != null)
                                message.optionsRequestedPolicyVersion = object.optionsRequestedPolicyVersion | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetIamPolicySubnetworkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetIamPolicySubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetIamPolicySubnetworkRequest} message GetIamPolicySubnetworkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetIamPolicySubnetworkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.optionsRequestedPolicyVersion != null && message.hasOwnProperty("optionsRequestedPolicyVersion")) {
                                object.optionsRequestedPolicyVersion = message.optionsRequestedPolicyVersion;
                                if (options.oneofs)
                                    object._optionsRequestedPolicyVersion = "optionsRequestedPolicyVersion";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetIamPolicySubnetworkRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetIamPolicySubnetworkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetIamPolicySubnetworkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetIamPolicySubnetworkRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetIamPolicySubnetworkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetIamPolicySubnetworkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetIamPolicySubnetworkRequest";
                        };
    
                        return GetIamPolicySubnetworkRequest;
                    })();
    
                    v1.GetImageFamilyViewRequest = (function() {
    
                        /**
                         * Properties of a GetImageFamilyViewRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetImageFamilyViewRequest
                         * @property {string|null} [family] GetImageFamilyViewRequest family
                         * @property {string|null} [project] GetImageFamilyViewRequest project
                         * @property {string|null} [zone] GetImageFamilyViewRequest zone
                         */
    
                        /**
                         * Constructs a new GetImageFamilyViewRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetImageFamilyViewRequest.
                         * @implements IGetImageFamilyViewRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetImageFamilyViewRequest=} [properties] Properties to set
                         */
                        function GetImageFamilyViewRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetImageFamilyViewRequest family.
                         * @member {string} family
                         * @memberof google.cloud.compute.v1.GetImageFamilyViewRequest
                         * @instance
                         */
                        GetImageFamilyViewRequest.prototype.family = "";
    
                        /**
                         * GetImageFamilyViewRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetImageFamilyViewRequest
                         * @instance
                         */
                        GetImageFamilyViewRequest.prototype.project = "";
    
                        /**
                         * GetImageFamilyViewRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetImageFamilyViewRequest
                         * @instance
                         */
                        GetImageFamilyViewRequest.prototype.zone = "";
    
                        /**
                         * Creates a new GetImageFamilyViewRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetImageFamilyViewRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetImageFamilyViewRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetImageFamilyViewRequest} GetImageFamilyViewRequest instance
                         */
                        GetImageFamilyViewRequest.create = function create(properties) {
                            return new GetImageFamilyViewRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetImageFamilyViewRequest message. Does not implicitly {@link google.cloud.compute.v1.GetImageFamilyViewRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetImageFamilyViewRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetImageFamilyViewRequest} message GetImageFamilyViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetImageFamilyViewRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.family != null && Object.hasOwnProperty.call(message, "family"))
                                writer.uint32(/* id 328751972, wireType 2 =*/2630015778).string(message.family);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetImageFamilyViewRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetImageFamilyViewRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetImageFamilyViewRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetImageFamilyViewRequest} message GetImageFamilyViewRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetImageFamilyViewRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetImageFamilyViewRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetImageFamilyViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetImageFamilyViewRequest} GetImageFamilyViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetImageFamilyViewRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetImageFamilyViewRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 328751972: {
                                        message.family = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetImageFamilyViewRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetImageFamilyViewRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetImageFamilyViewRequest} GetImageFamilyViewRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetImageFamilyViewRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetImageFamilyViewRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetImageFamilyViewRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetImageFamilyViewRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.family != null && message.hasOwnProperty("family"))
                                if (!$util.isString(message.family))
                                    return "family: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetImageFamilyViewRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetImageFamilyViewRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetImageFamilyViewRequest} GetImageFamilyViewRequest
                         */
                        GetImageFamilyViewRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetImageFamilyViewRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetImageFamilyViewRequest();
                            if (object.family != null)
                                message.family = String(object.family);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetImageFamilyViewRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetImageFamilyViewRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetImageFamilyViewRequest} message GetImageFamilyViewRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetImageFamilyViewRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.family = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.family != null && message.hasOwnProperty("family"))
                                object.family = message.family;
                            return object;
                        };
    
                        /**
                         * Converts this GetImageFamilyViewRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetImageFamilyViewRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetImageFamilyViewRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetImageFamilyViewRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetImageFamilyViewRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetImageFamilyViewRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetImageFamilyViewRequest";
                        };
    
                        return GetImageFamilyViewRequest;
                    })();
    
                    v1.GetImageRequest = (function() {
    
                        /**
                         * Properties of a GetImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetImageRequest
                         * @property {string|null} [image] GetImageRequest image
                         * @property {string|null} [project] GetImageRequest project
                         */
    
                        /**
                         * Constructs a new GetImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetImageRequest.
                         * @implements IGetImageRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetImageRequest=} [properties] Properties to set
                         */
                        function GetImageRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetImageRequest image.
                         * @member {string} image
                         * @memberof google.cloud.compute.v1.GetImageRequest
                         * @instance
                         */
                        GetImageRequest.prototype.image = "";
    
                        /**
                         * GetImageRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetImageRequest
                         * @instance
                         */
                        GetImageRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetImageRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetImageRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetImageRequest} GetImageRequest instance
                         */
                        GetImageRequest.create = function create(properties) {
                            return new GetImageRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetImageRequest message. Does not implicitly {@link google.cloud.compute.v1.GetImageRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetImageRequest} message GetImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetImageRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.image != null && Object.hasOwnProperty.call(message, "image"))
                                writer.uint32(/* id 100313435, wireType 2 =*/802507482).string(message.image);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetImageRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetImageRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetImageRequest} message GetImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetImageRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetImageRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetImageRequest} GetImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetImageRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetImageRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 100313435: {
                                        message.image = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetImageRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetImageRequest} GetImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetImageRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetImageRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetImageRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetImageRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.image != null && message.hasOwnProperty("image"))
                                if (!$util.isString(message.image))
                                    return "image: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetImageRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetImageRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetImageRequest} GetImageRequest
                         */
                        GetImageRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetImageRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetImageRequest();
                            if (object.image != null)
                                message.image = String(object.image);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetImageRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetImageRequest} message GetImageRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetImageRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.image = "";
                                object.project = "";
                            }
                            if (message.image != null && message.hasOwnProperty("image"))
                                object.image = message.image;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetImageRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetImageRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetImageRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetImageRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetImageRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetImageRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetImageRequest";
                        };
    
                        return GetImageRequest;
                    })();
    
                    v1.GetInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a GetInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] GetInstanceGroupManagerRequest instanceGroupManager
                         * @property {string|null} [project] GetInstanceGroupManagerRequest project
                         * @property {string|null} [zone] GetInstanceGroupManagerRequest zone
                         */
    
                        /**
                         * Constructs a new GetInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetInstanceGroupManagerRequest.
                         * @implements IGetInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function GetInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.GetInstanceGroupManagerRequest
                         * @instance
                         */
                        GetInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * GetInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetInstanceGroupManagerRequest
                         * @instance
                         */
                        GetInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * GetInstanceGroupManagerRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetInstanceGroupManagerRequest
                         * @instance
                         */
                        GetInstanceGroupManagerRequest.prototype.zone = "";
    
                        /**
                         * Creates a new GetInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetInstanceGroupManagerRequest} GetInstanceGroupManagerRequest instance
                         */
                        GetInstanceGroupManagerRequest.create = function create(properties) {
                            return new GetInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.GetInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInstanceGroupManagerRequest} message GetInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInstanceGroupManagerRequest} message GetInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetInstanceGroupManagerRequest} GetInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetInstanceGroupManagerRequest} GetInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetInstanceGroupManagerRequest} GetInstanceGroupManagerRequest
                         */
                        GetInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetInstanceGroupManagerRequest} message GetInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            return object;
                        };
    
                        /**
                         * Converts this GetInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetInstanceGroupManagerRequest";
                        };
    
                        return GetInstanceGroupManagerRequest;
                    })();
    
                    v1.GetInstanceGroupRequest = (function() {
    
                        /**
                         * Properties of a GetInstanceGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetInstanceGroupRequest
                         * @property {string|null} [instanceGroup] GetInstanceGroupRequest instanceGroup
                         * @property {string|null} [project] GetInstanceGroupRequest project
                         * @property {string|null} [zone] GetInstanceGroupRequest zone
                         */
    
                        /**
                         * Constructs a new GetInstanceGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetInstanceGroupRequest.
                         * @implements IGetInstanceGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetInstanceGroupRequest=} [properties] Properties to set
                         */
                        function GetInstanceGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetInstanceGroupRequest instanceGroup.
                         * @member {string} instanceGroup
                         * @memberof google.cloud.compute.v1.GetInstanceGroupRequest
                         * @instance
                         */
                        GetInstanceGroupRequest.prototype.instanceGroup = "";
    
                        /**
                         * GetInstanceGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetInstanceGroupRequest
                         * @instance
                         */
                        GetInstanceGroupRequest.prototype.project = "";
    
                        /**
                         * GetInstanceGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetInstanceGroupRequest
                         * @instance
                         */
                        GetInstanceGroupRequest.prototype.zone = "";
    
                        /**
                         * Creates a new GetInstanceGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInstanceGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetInstanceGroupRequest} GetInstanceGroupRequest instance
                         */
                        GetInstanceGroupRequest.create = function create(properties) {
                            return new GetInstanceGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetInstanceGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.GetInstanceGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInstanceGroupRequest} message GetInstanceGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetInstanceGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instanceGroup != null && Object.hasOwnProperty.call(message, "instanceGroup"))
                                writer.uint32(/* id 81095253, wireType 2 =*/648762026).string(message.instanceGroup);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetInstanceGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetInstanceGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInstanceGroupRequest} message GetInstanceGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetInstanceGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetInstanceGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetInstanceGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetInstanceGroupRequest} GetInstanceGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetInstanceGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetInstanceGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 81095253: {
                                        message.instanceGroup = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetInstanceGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetInstanceGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetInstanceGroupRequest} GetInstanceGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetInstanceGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetInstanceGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetInstanceGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetInstanceGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instanceGroup != null && message.hasOwnProperty("instanceGroup"))
                                if (!$util.isString(message.instanceGroup))
                                    return "instanceGroup: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetInstanceGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetInstanceGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetInstanceGroupRequest} GetInstanceGroupRequest
                         */
                        GetInstanceGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetInstanceGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetInstanceGroupRequest();
                            if (object.instanceGroup != null)
                                message.instanceGroup = String(object.instanceGroup);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetInstanceGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetInstanceGroupRequest} message GetInstanceGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetInstanceGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instanceGroup = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instanceGroup != null && message.hasOwnProperty("instanceGroup"))
                                object.instanceGroup = message.instanceGroup;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetInstanceGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetInstanceGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetInstanceGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetInstanceGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetInstanceGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetInstanceGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetInstanceGroupRequest";
                        };
    
                        return GetInstanceGroupRequest;
                    })();
    
                    v1.GetInstanceRequest = (function() {
    
                        /**
                         * Properties of a GetInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetInstanceRequest
                         * @property {string|null} [instance] GetInstanceRequest instance
                         * @property {string|null} [project] GetInstanceRequest project
                         * @property {string|null} [zone] GetInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new GetInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetInstanceRequest.
                         * @implements IGetInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetInstanceRequest=} [properties] Properties to set
                         */
                        function GetInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.GetInstanceRequest
                         * @instance
                         */
                        GetInstanceRequest.prototype.instance = "";
    
                        /**
                         * GetInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetInstanceRequest
                         * @instance
                         */
                        GetInstanceRequest.prototype.project = "";
    
                        /**
                         * GetInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetInstanceRequest
                         * @instance
                         */
                        GetInstanceRequest.prototype.zone = "";
    
                        /**
                         * Creates a new GetInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetInstanceRequest} GetInstanceRequest instance
                         */
                        GetInstanceRequest.create = function create(properties) {
                            return new GetInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.GetInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInstanceRequest} message GetInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInstanceRequest} message GetInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetInstanceRequest} GetInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetInstanceRequest} GetInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetInstanceRequest} GetInstanceRequest
                         */
                        GetInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetInstanceRequest} message GetInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetInstanceRequest";
                        };
    
                        return GetInstanceRequest;
                    })();
    
                    v1.GetInstanceTemplateRequest = (function() {
    
                        /**
                         * Properties of a GetInstanceTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetInstanceTemplateRequest
                         * @property {string|null} [instanceTemplate] GetInstanceTemplateRequest instanceTemplate
                         * @property {string|null} [project] GetInstanceTemplateRequest project
                         */
    
                        /**
                         * Constructs a new GetInstanceTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetInstanceTemplateRequest.
                         * @implements IGetInstanceTemplateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetInstanceTemplateRequest=} [properties] Properties to set
                         */
                        function GetInstanceTemplateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetInstanceTemplateRequest instanceTemplate.
                         * @member {string} instanceTemplate
                         * @memberof google.cloud.compute.v1.GetInstanceTemplateRequest
                         * @instance
                         */
                        GetInstanceTemplateRequest.prototype.instanceTemplate = "";
    
                        /**
                         * GetInstanceTemplateRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetInstanceTemplateRequest
                         * @instance
                         */
                        GetInstanceTemplateRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetInstanceTemplateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInstanceTemplateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetInstanceTemplateRequest} GetInstanceTemplateRequest instance
                         */
                        GetInstanceTemplateRequest.create = function create(properties) {
                            return new GetInstanceTemplateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetInstanceTemplateRequest message. Does not implicitly {@link google.cloud.compute.v1.GetInstanceTemplateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInstanceTemplateRequest} message GetInstanceTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetInstanceTemplateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceTemplate != null && Object.hasOwnProperty.call(message, "instanceTemplate"))
                                writer.uint32(/* id 309248228, wireType 2 =*/2473985826).string(message.instanceTemplate);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetInstanceTemplateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetInstanceTemplateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInstanceTemplateRequest} message GetInstanceTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetInstanceTemplateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetInstanceTemplateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetInstanceTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetInstanceTemplateRequest} GetInstanceTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetInstanceTemplateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetInstanceTemplateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 309248228: {
                                        message.instanceTemplate = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetInstanceTemplateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetInstanceTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetInstanceTemplateRequest} GetInstanceTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetInstanceTemplateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetInstanceTemplateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetInstanceTemplateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetInstanceTemplateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instanceTemplate != null && message.hasOwnProperty("instanceTemplate"))
                                if (!$util.isString(message.instanceTemplate))
                                    return "instanceTemplate: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetInstanceTemplateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetInstanceTemplateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetInstanceTemplateRequest} GetInstanceTemplateRequest
                         */
                        GetInstanceTemplateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetInstanceTemplateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetInstanceTemplateRequest();
                            if (object.instanceTemplate != null)
                                message.instanceTemplate = String(object.instanceTemplate);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetInstanceTemplateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetInstanceTemplateRequest} message GetInstanceTemplateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetInstanceTemplateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.instanceTemplate = "";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceTemplate != null && message.hasOwnProperty("instanceTemplate"))
                                object.instanceTemplate = message.instanceTemplate;
                            return object;
                        };
    
                        /**
                         * Converts this GetInstanceTemplateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetInstanceTemplateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetInstanceTemplateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetInstanceTemplateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetInstanceTemplateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetInstanceTemplateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetInstanceTemplateRequest";
                        };
    
                        return GetInstanceTemplateRequest;
                    })();
    
                    v1.GetInterconnectAttachmentRequest = (function() {
    
                        /**
                         * Properties of a GetInterconnectAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetInterconnectAttachmentRequest
                         * @property {string|null} [interconnectAttachment] GetInterconnectAttachmentRequest interconnectAttachment
                         * @property {string|null} [project] GetInterconnectAttachmentRequest project
                         * @property {string|null} [region] GetInterconnectAttachmentRequest region
                         */
    
                        /**
                         * Constructs a new GetInterconnectAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetInterconnectAttachmentRequest.
                         * @implements IGetInterconnectAttachmentRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetInterconnectAttachmentRequest=} [properties] Properties to set
                         */
                        function GetInterconnectAttachmentRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetInterconnectAttachmentRequest interconnectAttachment.
                         * @member {string} interconnectAttachment
                         * @memberof google.cloud.compute.v1.GetInterconnectAttachmentRequest
                         * @instance
                         */
                        GetInterconnectAttachmentRequest.prototype.interconnectAttachment = "";
    
                        /**
                         * GetInterconnectAttachmentRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetInterconnectAttachmentRequest
                         * @instance
                         */
                        GetInterconnectAttachmentRequest.prototype.project = "";
    
                        /**
                         * GetInterconnectAttachmentRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetInterconnectAttachmentRequest
                         * @instance
                         */
                        GetInterconnectAttachmentRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetInterconnectAttachmentRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetInterconnectAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInterconnectAttachmentRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetInterconnectAttachmentRequest} GetInterconnectAttachmentRequest instance
                         */
                        GetInterconnectAttachmentRequest.create = function create(properties) {
                            return new GetInterconnectAttachmentRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetInterconnectAttachmentRequest message. Does not implicitly {@link google.cloud.compute.v1.GetInterconnectAttachmentRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetInterconnectAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInterconnectAttachmentRequest} message GetInterconnectAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetInterconnectAttachmentRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.interconnectAttachment != null && Object.hasOwnProperty.call(message, "interconnectAttachment"))
                                writer.uint32(/* id 308135284, wireType 2 =*/2465082274).string(message.interconnectAttachment);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetInterconnectAttachmentRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetInterconnectAttachmentRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetInterconnectAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInterconnectAttachmentRequest} message GetInterconnectAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetInterconnectAttachmentRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetInterconnectAttachmentRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetInterconnectAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetInterconnectAttachmentRequest} GetInterconnectAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetInterconnectAttachmentRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetInterconnectAttachmentRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 308135284: {
                                        message.interconnectAttachment = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetInterconnectAttachmentRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetInterconnectAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetInterconnectAttachmentRequest} GetInterconnectAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetInterconnectAttachmentRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetInterconnectAttachmentRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetInterconnectAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetInterconnectAttachmentRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.interconnectAttachment != null && message.hasOwnProperty("interconnectAttachment"))
                                if (!$util.isString(message.interconnectAttachment))
                                    return "interconnectAttachment: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetInterconnectAttachmentRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetInterconnectAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetInterconnectAttachmentRequest} GetInterconnectAttachmentRequest
                         */
                        GetInterconnectAttachmentRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetInterconnectAttachmentRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetInterconnectAttachmentRequest();
                            if (object.interconnectAttachment != null)
                                message.interconnectAttachment = String(object.interconnectAttachment);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetInterconnectAttachmentRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetInterconnectAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetInterconnectAttachmentRequest} message GetInterconnectAttachmentRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetInterconnectAttachmentRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.interconnectAttachment = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.interconnectAttachment != null && message.hasOwnProperty("interconnectAttachment"))
                                object.interconnectAttachment = message.interconnectAttachment;
                            return object;
                        };
    
                        /**
                         * Converts this GetInterconnectAttachmentRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetInterconnectAttachmentRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetInterconnectAttachmentRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetInterconnectAttachmentRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetInterconnectAttachmentRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetInterconnectAttachmentRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetInterconnectAttachmentRequest";
                        };
    
                        return GetInterconnectAttachmentRequest;
                    })();
    
                    v1.GetInterconnectLocationRequest = (function() {
    
                        /**
                         * Properties of a GetInterconnectLocationRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetInterconnectLocationRequest
                         * @property {string|null} [interconnectLocation] GetInterconnectLocationRequest interconnectLocation
                         * @property {string|null} [project] GetInterconnectLocationRequest project
                         */
    
                        /**
                         * Constructs a new GetInterconnectLocationRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetInterconnectLocationRequest.
                         * @implements IGetInterconnectLocationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetInterconnectLocationRequest=} [properties] Properties to set
                         */
                        function GetInterconnectLocationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetInterconnectLocationRequest interconnectLocation.
                         * @member {string} interconnectLocation
                         * @memberof google.cloud.compute.v1.GetInterconnectLocationRequest
                         * @instance
                         */
                        GetInterconnectLocationRequest.prototype.interconnectLocation = "";
    
                        /**
                         * GetInterconnectLocationRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetInterconnectLocationRequest
                         * @instance
                         */
                        GetInterconnectLocationRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetInterconnectLocationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetInterconnectLocationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInterconnectLocationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetInterconnectLocationRequest} GetInterconnectLocationRequest instance
                         */
                        GetInterconnectLocationRequest.create = function create(properties) {
                            return new GetInterconnectLocationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetInterconnectLocationRequest message. Does not implicitly {@link google.cloud.compute.v1.GetInterconnectLocationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetInterconnectLocationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInterconnectLocationRequest} message GetInterconnectLocationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetInterconnectLocationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.interconnectLocation != null && Object.hasOwnProperty.call(message, "interconnectLocation"))
                                writer.uint32(/* id 492235846, wireType 2 =*/3937886770).string(message.interconnectLocation);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetInterconnectLocationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetInterconnectLocationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetInterconnectLocationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInterconnectLocationRequest} message GetInterconnectLocationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetInterconnectLocationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetInterconnectLocationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetInterconnectLocationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetInterconnectLocationRequest} GetInterconnectLocationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetInterconnectLocationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetInterconnectLocationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 492235846: {
                                        message.interconnectLocation = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetInterconnectLocationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetInterconnectLocationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetInterconnectLocationRequest} GetInterconnectLocationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetInterconnectLocationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetInterconnectLocationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetInterconnectLocationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetInterconnectLocationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.interconnectLocation != null && message.hasOwnProperty("interconnectLocation"))
                                if (!$util.isString(message.interconnectLocation))
                                    return "interconnectLocation: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetInterconnectLocationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetInterconnectLocationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetInterconnectLocationRequest} GetInterconnectLocationRequest
                         */
                        GetInterconnectLocationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetInterconnectLocationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetInterconnectLocationRequest();
                            if (object.interconnectLocation != null)
                                message.interconnectLocation = String(object.interconnectLocation);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetInterconnectLocationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetInterconnectLocationRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetInterconnectLocationRequest} message GetInterconnectLocationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetInterconnectLocationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.interconnectLocation = "";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.interconnectLocation != null && message.hasOwnProperty("interconnectLocation"))
                                object.interconnectLocation = message.interconnectLocation;
                            return object;
                        };
    
                        /**
                         * Converts this GetInterconnectLocationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetInterconnectLocationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetInterconnectLocationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetInterconnectLocationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetInterconnectLocationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetInterconnectLocationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetInterconnectLocationRequest";
                        };
    
                        return GetInterconnectLocationRequest;
                    })();
    
                    v1.GetInterconnectRequest = (function() {
    
                        /**
                         * Properties of a GetInterconnectRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetInterconnectRequest
                         * @property {string|null} [interconnect] GetInterconnectRequest interconnect
                         * @property {string|null} [project] GetInterconnectRequest project
                         */
    
                        /**
                         * Constructs a new GetInterconnectRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetInterconnectRequest.
                         * @implements IGetInterconnectRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetInterconnectRequest=} [properties] Properties to set
                         */
                        function GetInterconnectRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetInterconnectRequest interconnect.
                         * @member {string} interconnect
                         * @memberof google.cloud.compute.v1.GetInterconnectRequest
                         * @instance
                         */
                        GetInterconnectRequest.prototype.interconnect = "";
    
                        /**
                         * GetInterconnectRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetInterconnectRequest
                         * @instance
                         */
                        GetInterconnectRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetInterconnectRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInterconnectRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetInterconnectRequest} GetInterconnectRequest instance
                         */
                        GetInterconnectRequest.create = function create(properties) {
                            return new GetInterconnectRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetInterconnectRequest message. Does not implicitly {@link google.cloud.compute.v1.GetInterconnectRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInterconnectRequest} message GetInterconnectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetInterconnectRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.interconnect != null && Object.hasOwnProperty.call(message, "interconnect"))
                                writer.uint32(/* id 224601230, wireType 2 =*/1796809842).string(message.interconnect);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetInterconnectRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetInterconnectRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetInterconnectRequest} message GetInterconnectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetInterconnectRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetInterconnectRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetInterconnectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetInterconnectRequest} GetInterconnectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetInterconnectRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetInterconnectRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 224601230: {
                                        message.interconnect = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetInterconnectRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetInterconnectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetInterconnectRequest} GetInterconnectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetInterconnectRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetInterconnectRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetInterconnectRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetInterconnectRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.interconnect != null && message.hasOwnProperty("interconnect"))
                                if (!$util.isString(message.interconnect))
                                    return "interconnect: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetInterconnectRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetInterconnectRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetInterconnectRequest} GetInterconnectRequest
                         */
                        GetInterconnectRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetInterconnectRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetInterconnectRequest();
                            if (object.interconnect != null)
                                message.interconnect = String(object.interconnect);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetInterconnectRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetInterconnectRequest} message GetInterconnectRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetInterconnectRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.interconnect = "";
                                object.project = "";
                            }
                            if (message.interconnect != null && message.hasOwnProperty("interconnect"))
                                object.interconnect = message.interconnect;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetInterconnectRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetInterconnectRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetInterconnectRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetInterconnectRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetInterconnectRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetInterconnectRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetInterconnectRequest";
                        };
    
                        return GetInterconnectRequest;
                    })();
    
                    v1.GetLicenseCodeRequest = (function() {
    
                        /**
                         * Properties of a GetLicenseCodeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetLicenseCodeRequest
                         * @property {string|null} [licenseCode] GetLicenseCodeRequest licenseCode
                         * @property {string|null} [project] GetLicenseCodeRequest project
                         */
    
                        /**
                         * Constructs a new GetLicenseCodeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetLicenseCodeRequest.
                         * @implements IGetLicenseCodeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetLicenseCodeRequest=} [properties] Properties to set
                         */
                        function GetLicenseCodeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetLicenseCodeRequest licenseCode.
                         * @member {string} licenseCode
                         * @memberof google.cloud.compute.v1.GetLicenseCodeRequest
                         * @instance
                         */
                        GetLicenseCodeRequest.prototype.licenseCode = "";
    
                        /**
                         * GetLicenseCodeRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetLicenseCodeRequest
                         * @instance
                         */
                        GetLicenseCodeRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetLicenseCodeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetLicenseCodeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetLicenseCodeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetLicenseCodeRequest} GetLicenseCodeRequest instance
                         */
                        GetLicenseCodeRequest.create = function create(properties) {
                            return new GetLicenseCodeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetLicenseCodeRequest message. Does not implicitly {@link google.cloud.compute.v1.GetLicenseCodeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetLicenseCodeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetLicenseCodeRequest} message GetLicenseCodeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetLicenseCodeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.licenseCode != null && Object.hasOwnProperty.call(message, "licenseCode"))
                                writer.uint32(/* id 1467179, wireType 2 =*/11737434).string(message.licenseCode);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetLicenseCodeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetLicenseCodeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetLicenseCodeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetLicenseCodeRequest} message GetLicenseCodeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetLicenseCodeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetLicenseCodeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetLicenseCodeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetLicenseCodeRequest} GetLicenseCodeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetLicenseCodeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetLicenseCodeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 1467179: {
                                        message.licenseCode = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetLicenseCodeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetLicenseCodeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetLicenseCodeRequest} GetLicenseCodeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetLicenseCodeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetLicenseCodeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetLicenseCodeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetLicenseCodeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.licenseCode != null && message.hasOwnProperty("licenseCode"))
                                if (!$util.isString(message.licenseCode))
                                    return "licenseCode: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetLicenseCodeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetLicenseCodeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetLicenseCodeRequest} GetLicenseCodeRequest
                         */
                        GetLicenseCodeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetLicenseCodeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetLicenseCodeRequest();
                            if (object.licenseCode != null)
                                message.licenseCode = String(object.licenseCode);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetLicenseCodeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetLicenseCodeRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetLicenseCodeRequest} message GetLicenseCodeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetLicenseCodeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.licenseCode = "";
                                object.project = "";
                            }
                            if (message.licenseCode != null && message.hasOwnProperty("licenseCode"))
                                object.licenseCode = message.licenseCode;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetLicenseCodeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetLicenseCodeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetLicenseCodeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetLicenseCodeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetLicenseCodeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetLicenseCodeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetLicenseCodeRequest";
                        };
    
                        return GetLicenseCodeRequest;
                    })();
    
                    v1.GetLicenseRequest = (function() {
    
                        /**
                         * Properties of a GetLicenseRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetLicenseRequest
                         * @property {string|null} [license] GetLicenseRequest license
                         * @property {string|null} [project] GetLicenseRequest project
                         */
    
                        /**
                         * Constructs a new GetLicenseRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetLicenseRequest.
                         * @implements IGetLicenseRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetLicenseRequest=} [properties] Properties to set
                         */
                        function GetLicenseRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetLicenseRequest license.
                         * @member {string} license
                         * @memberof google.cloud.compute.v1.GetLicenseRequest
                         * @instance
                         */
                        GetLicenseRequest.prototype.license = "";
    
                        /**
                         * GetLicenseRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetLicenseRequest
                         * @instance
                         */
                        GetLicenseRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetLicenseRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetLicenseRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetLicenseRequest} GetLicenseRequest instance
                         */
                        GetLicenseRequest.create = function create(properties) {
                            return new GetLicenseRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetLicenseRequest message. Does not implicitly {@link google.cloud.compute.v1.GetLicenseRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetLicenseRequest} message GetLicenseRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetLicenseRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.license != null && Object.hasOwnProperty.call(message, "license"))
                                writer.uint32(/* id 166757441, wireType 2 =*/1334059530).string(message.license);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetLicenseRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetLicenseRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetLicenseRequest} message GetLicenseRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetLicenseRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetLicenseRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetLicenseRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetLicenseRequest} GetLicenseRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetLicenseRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetLicenseRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 166757441: {
                                        message.license = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetLicenseRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetLicenseRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetLicenseRequest} GetLicenseRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetLicenseRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetLicenseRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetLicenseRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetLicenseRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.license != null && message.hasOwnProperty("license"))
                                if (!$util.isString(message.license))
                                    return "license: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetLicenseRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetLicenseRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetLicenseRequest} GetLicenseRequest
                         */
                        GetLicenseRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetLicenseRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetLicenseRequest();
                            if (object.license != null)
                                message.license = String(object.license);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetLicenseRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetLicenseRequest} message GetLicenseRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetLicenseRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.license = "";
                                object.project = "";
                            }
                            if (message.license != null && message.hasOwnProperty("license"))
                                object.license = message.license;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetLicenseRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetLicenseRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetLicenseRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetLicenseRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetLicenseRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetLicenseRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetLicenseRequest";
                        };
    
                        return GetLicenseRequest;
                    })();
    
                    v1.GetMachineImageRequest = (function() {
    
                        /**
                         * Properties of a GetMachineImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetMachineImageRequest
                         * @property {string|null} [machineImage] GetMachineImageRequest machineImage
                         * @property {string|null} [project] GetMachineImageRequest project
                         */
    
                        /**
                         * Constructs a new GetMachineImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetMachineImageRequest.
                         * @implements IGetMachineImageRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetMachineImageRequest=} [properties] Properties to set
                         */
                        function GetMachineImageRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetMachineImageRequest machineImage.
                         * @member {string} machineImage
                         * @memberof google.cloud.compute.v1.GetMachineImageRequest
                         * @instance
                         */
                        GetMachineImageRequest.prototype.machineImage = "";
    
                        /**
                         * GetMachineImageRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetMachineImageRequest
                         * @instance
                         */
                        GetMachineImageRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetMachineImageRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetMachineImageRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetMachineImageRequest} GetMachineImageRequest instance
                         */
                        GetMachineImageRequest.create = function create(properties) {
                            return new GetMachineImageRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetMachineImageRequest message. Does not implicitly {@link google.cloud.compute.v1.GetMachineImageRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetMachineImageRequest} message GetMachineImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetMachineImageRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.machineImage != null && Object.hasOwnProperty.call(message, "machineImage"))
                                writer.uint32(/* id 69189475, wireType 2 =*/553515802).string(message.machineImage);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetMachineImageRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetMachineImageRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetMachineImageRequest} message GetMachineImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetMachineImageRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetMachineImageRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetMachineImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetMachineImageRequest} GetMachineImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetMachineImageRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetMachineImageRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 69189475: {
                                        message.machineImage = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetMachineImageRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetMachineImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetMachineImageRequest} GetMachineImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetMachineImageRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetMachineImageRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetMachineImageRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetMachineImageRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.machineImage != null && message.hasOwnProperty("machineImage"))
                                if (!$util.isString(message.machineImage))
                                    return "machineImage: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetMachineImageRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetMachineImageRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetMachineImageRequest} GetMachineImageRequest
                         */
                        GetMachineImageRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetMachineImageRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetMachineImageRequest();
                            if (object.machineImage != null)
                                message.machineImage = String(object.machineImage);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetMachineImageRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetMachineImageRequest} message GetMachineImageRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetMachineImageRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.machineImage = "";
                                object.project = "";
                            }
                            if (message.machineImage != null && message.hasOwnProperty("machineImage"))
                                object.machineImage = message.machineImage;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetMachineImageRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetMachineImageRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetMachineImageRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetMachineImageRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetMachineImageRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetMachineImageRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetMachineImageRequest";
                        };
    
                        return GetMachineImageRequest;
                    })();
    
                    v1.GetMachineTypeRequest = (function() {
    
                        /**
                         * Properties of a GetMachineTypeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetMachineTypeRequest
                         * @property {string|null} [machineType] GetMachineTypeRequest machineType
                         * @property {string|null} [project] GetMachineTypeRequest project
                         * @property {string|null} [zone] GetMachineTypeRequest zone
                         */
    
                        /**
                         * Constructs a new GetMachineTypeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetMachineTypeRequest.
                         * @implements IGetMachineTypeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetMachineTypeRequest=} [properties] Properties to set
                         */
                        function GetMachineTypeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetMachineTypeRequest machineType.
                         * @member {string} machineType
                         * @memberof google.cloud.compute.v1.GetMachineTypeRequest
                         * @instance
                         */
                        GetMachineTypeRequest.prototype.machineType = "";
    
                        /**
                         * GetMachineTypeRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetMachineTypeRequest
                         * @instance
                         */
                        GetMachineTypeRequest.prototype.project = "";
    
                        /**
                         * GetMachineTypeRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetMachineTypeRequest
                         * @instance
                         */
                        GetMachineTypeRequest.prototype.zone = "";
    
                        /**
                         * Creates a new GetMachineTypeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetMachineTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetMachineTypeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetMachineTypeRequest} GetMachineTypeRequest instance
                         */
                        GetMachineTypeRequest.create = function create(properties) {
                            return new GetMachineTypeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetMachineTypeRequest message. Does not implicitly {@link google.cloud.compute.v1.GetMachineTypeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetMachineTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetMachineTypeRequest} message GetMachineTypeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetMachineTypeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.machineType != null && Object.hasOwnProperty.call(message, "machineType"))
                                writer.uint32(/* id 227711026, wireType 2 =*/1821688210).string(message.machineType);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetMachineTypeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetMachineTypeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetMachineTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetMachineTypeRequest} message GetMachineTypeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetMachineTypeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetMachineTypeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetMachineTypeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetMachineTypeRequest} GetMachineTypeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetMachineTypeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetMachineTypeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227711026: {
                                        message.machineType = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetMachineTypeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetMachineTypeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetMachineTypeRequest} GetMachineTypeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetMachineTypeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetMachineTypeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetMachineTypeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetMachineTypeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.machineType != null && message.hasOwnProperty("machineType"))
                                if (!$util.isString(message.machineType))
                                    return "machineType: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetMachineTypeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetMachineTypeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetMachineTypeRequest} GetMachineTypeRequest
                         */
                        GetMachineTypeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetMachineTypeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetMachineTypeRequest();
                            if (object.machineType != null)
                                message.machineType = String(object.machineType);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetMachineTypeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetMachineTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetMachineTypeRequest} message GetMachineTypeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetMachineTypeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.machineType = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.machineType != null && message.hasOwnProperty("machineType"))
                                object.machineType = message.machineType;
                            return object;
                        };
    
                        /**
                         * Converts this GetMachineTypeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetMachineTypeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetMachineTypeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetMachineTypeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetMachineTypeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetMachineTypeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetMachineTypeRequest";
                        };
    
                        return GetMachineTypeRequest;
                    })();
    
                    v1.GetNatMappingInfoRoutersRequest = (function() {
    
                        /**
                         * Properties of a GetNatMappingInfoRoutersRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetNatMappingInfoRoutersRequest
                         * @property {string|null} [filter] GetNatMappingInfoRoutersRequest filter
                         * @property {number|null} [maxResults] GetNatMappingInfoRoutersRequest maxResults
                         * @property {string|null} [orderBy] GetNatMappingInfoRoutersRequest orderBy
                         * @property {string|null} [pageToken] GetNatMappingInfoRoutersRequest pageToken
                         * @property {string|null} [project] GetNatMappingInfoRoutersRequest project
                         * @property {string|null} [region] GetNatMappingInfoRoutersRequest region
                         * @property {boolean|null} [returnPartialSuccess] GetNatMappingInfoRoutersRequest returnPartialSuccess
                         * @property {string|null} [router] GetNatMappingInfoRoutersRequest router
                         */
    
                        /**
                         * Constructs a new GetNatMappingInfoRoutersRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetNatMappingInfoRoutersRequest.
                         * @implements IGetNatMappingInfoRoutersRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetNatMappingInfoRoutersRequest=} [properties] Properties to set
                         */
                        function GetNatMappingInfoRoutersRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetNatMappingInfoRoutersRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @instance
                         */
                        GetNatMappingInfoRoutersRequest.prototype.filter = null;
    
                        /**
                         * GetNatMappingInfoRoutersRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @instance
                         */
                        GetNatMappingInfoRoutersRequest.prototype.maxResults = null;
    
                        /**
                         * GetNatMappingInfoRoutersRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @instance
                         */
                        GetNatMappingInfoRoutersRequest.prototype.orderBy = null;
    
                        /**
                         * GetNatMappingInfoRoutersRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @instance
                         */
                        GetNatMappingInfoRoutersRequest.prototype.pageToken = null;
    
                        /**
                         * GetNatMappingInfoRoutersRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @instance
                         */
                        GetNatMappingInfoRoutersRequest.prototype.project = "";
    
                        /**
                         * GetNatMappingInfoRoutersRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @instance
                         */
                        GetNatMappingInfoRoutersRequest.prototype.region = "";
    
                        /**
                         * GetNatMappingInfoRoutersRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @instance
                         */
                        GetNatMappingInfoRoutersRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * GetNatMappingInfoRoutersRequest router.
                         * @member {string} router
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @instance
                         */
                        GetNatMappingInfoRoutersRequest.prototype.router = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetNatMappingInfoRoutersRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @instance
                         */
                        Object.defineProperty(GetNatMappingInfoRoutersRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GetNatMappingInfoRoutersRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @instance
                         */
                        Object.defineProperty(GetNatMappingInfoRoutersRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GetNatMappingInfoRoutersRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @instance
                         */
                        Object.defineProperty(GetNatMappingInfoRoutersRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GetNatMappingInfoRoutersRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @instance
                         */
                        Object.defineProperty(GetNatMappingInfoRoutersRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GetNatMappingInfoRoutersRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @instance
                         */
                        Object.defineProperty(GetNatMappingInfoRoutersRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetNatMappingInfoRoutersRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNatMappingInfoRoutersRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetNatMappingInfoRoutersRequest} GetNatMappingInfoRoutersRequest instance
                         */
                        GetNatMappingInfoRoutersRequest.create = function create(properties) {
                            return new GetNatMappingInfoRoutersRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetNatMappingInfoRoutersRequest message. Does not implicitly {@link google.cloud.compute.v1.GetNatMappingInfoRoutersRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNatMappingInfoRoutersRequest} message GetNatMappingInfoRoutersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetNatMappingInfoRoutersRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.router != null && Object.hasOwnProperty.call(message, "router"))
                                writer.uint32(/* id 148608841, wireType 2 =*/1188870730).string(message.router);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetNatMappingInfoRoutersRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetNatMappingInfoRoutersRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNatMappingInfoRoutersRequest} message GetNatMappingInfoRoutersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetNatMappingInfoRoutersRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetNatMappingInfoRoutersRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetNatMappingInfoRoutersRequest} GetNatMappingInfoRoutersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetNatMappingInfoRoutersRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetNatMappingInfoRoutersRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 148608841: {
                                        message.router = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetNatMappingInfoRoutersRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetNatMappingInfoRoutersRequest} GetNatMappingInfoRoutersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetNatMappingInfoRoutersRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetNatMappingInfoRoutersRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetNatMappingInfoRoutersRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.router != null && message.hasOwnProperty("router"))
                                if (!$util.isString(message.router))
                                    return "router: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetNatMappingInfoRoutersRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetNatMappingInfoRoutersRequest} GetNatMappingInfoRoutersRequest
                         */
                        GetNatMappingInfoRoutersRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetNatMappingInfoRoutersRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetNatMappingInfoRoutersRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.router != null)
                                message.router = String(object.router);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetNatMappingInfoRoutersRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetNatMappingInfoRoutersRequest} message GetNatMappingInfoRoutersRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetNatMappingInfoRoutersRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.router = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.router != null && message.hasOwnProperty("router"))
                                object.router = message.router;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetNatMappingInfoRoutersRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetNatMappingInfoRoutersRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetNatMappingInfoRoutersRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetNatMappingInfoRoutersRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetNatMappingInfoRoutersRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetNatMappingInfoRoutersRequest";
                        };
    
                        return GetNatMappingInfoRoutersRequest;
                    })();
    
                    v1.GetNetworkEdgeSecurityServiceRequest = (function() {
    
                        /**
                         * Properties of a GetNetworkEdgeSecurityServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetNetworkEdgeSecurityServiceRequest
                         * @property {string|null} [networkEdgeSecurityService] GetNetworkEdgeSecurityServiceRequest networkEdgeSecurityService
                         * @property {string|null} [project] GetNetworkEdgeSecurityServiceRequest project
                         * @property {string|null} [region] GetNetworkEdgeSecurityServiceRequest region
                         */
    
                        /**
                         * Constructs a new GetNetworkEdgeSecurityServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetNetworkEdgeSecurityServiceRequest.
                         * @implements IGetNetworkEdgeSecurityServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetNetworkEdgeSecurityServiceRequest=} [properties] Properties to set
                         */
                        function GetNetworkEdgeSecurityServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetNetworkEdgeSecurityServiceRequest networkEdgeSecurityService.
                         * @member {string} networkEdgeSecurityService
                         * @memberof google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        GetNetworkEdgeSecurityServiceRequest.prototype.networkEdgeSecurityService = "";
    
                        /**
                         * GetNetworkEdgeSecurityServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        GetNetworkEdgeSecurityServiceRequest.prototype.project = "";
    
                        /**
                         * GetNetworkEdgeSecurityServiceRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        GetNetworkEdgeSecurityServiceRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetNetworkEdgeSecurityServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNetworkEdgeSecurityServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest} GetNetworkEdgeSecurityServiceRequest instance
                         */
                        GetNetworkEdgeSecurityServiceRequest.create = function create(properties) {
                            return new GetNetworkEdgeSecurityServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetNetworkEdgeSecurityServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNetworkEdgeSecurityServiceRequest} message GetNetworkEdgeSecurityServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetNetworkEdgeSecurityServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.networkEdgeSecurityService != null && Object.hasOwnProperty.call(message, "networkEdgeSecurityService"))
                                writer.uint32(/* id 157011879, wireType 2 =*/1256095034).string(message.networkEdgeSecurityService);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetNetworkEdgeSecurityServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNetworkEdgeSecurityServiceRequest} message GetNetworkEdgeSecurityServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetNetworkEdgeSecurityServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetNetworkEdgeSecurityServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest} GetNetworkEdgeSecurityServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetNetworkEdgeSecurityServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 157011879: {
                                        message.networkEdgeSecurityService = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetNetworkEdgeSecurityServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest} GetNetworkEdgeSecurityServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetNetworkEdgeSecurityServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetNetworkEdgeSecurityServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetNetworkEdgeSecurityServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.networkEdgeSecurityService != null && message.hasOwnProperty("networkEdgeSecurityService"))
                                if (!$util.isString(message.networkEdgeSecurityService))
                                    return "networkEdgeSecurityService: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetNetworkEdgeSecurityServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest} GetNetworkEdgeSecurityServiceRequest
                         */
                        GetNetworkEdgeSecurityServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest();
                            if (object.networkEdgeSecurityService != null)
                                message.networkEdgeSecurityService = String(object.networkEdgeSecurityService);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetNetworkEdgeSecurityServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest} message GetNetworkEdgeSecurityServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetNetworkEdgeSecurityServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.networkEdgeSecurityService = "";
                                object.project = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.networkEdgeSecurityService != null && message.hasOwnProperty("networkEdgeSecurityService"))
                                object.networkEdgeSecurityService = message.networkEdgeSecurityService;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetNetworkEdgeSecurityServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetNetworkEdgeSecurityServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetNetworkEdgeSecurityServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetNetworkEdgeSecurityServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest";
                        };
    
                        return GetNetworkEdgeSecurityServiceRequest;
                    })();
    
                    v1.GetNetworkEndpointGroupRequest = (function() {
    
                        /**
                         * Properties of a GetNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetNetworkEndpointGroupRequest
                         * @property {string|null} [networkEndpointGroup] GetNetworkEndpointGroupRequest networkEndpointGroup
                         * @property {string|null} [project] GetNetworkEndpointGroupRequest project
                         * @property {string|null} [zone] GetNetworkEndpointGroupRequest zone
                         */
    
                        /**
                         * Constructs a new GetNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetNetworkEndpointGroupRequest.
                         * @implements IGetNetworkEndpointGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetNetworkEndpointGroupRequest=} [properties] Properties to set
                         */
                        function GetNetworkEndpointGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetNetworkEndpointGroupRequest networkEndpointGroup.
                         * @member {string} networkEndpointGroup
                         * @memberof google.cloud.compute.v1.GetNetworkEndpointGroupRequest
                         * @instance
                         */
                        GetNetworkEndpointGroupRequest.prototype.networkEndpointGroup = "";
    
                        /**
                         * GetNetworkEndpointGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetNetworkEndpointGroupRequest
                         * @instance
                         */
                        GetNetworkEndpointGroupRequest.prototype.project = "";
    
                        /**
                         * GetNetworkEndpointGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetNetworkEndpointGroupRequest
                         * @instance
                         */
                        GetNetworkEndpointGroupRequest.prototype.zone = "";
    
                        /**
                         * Creates a new GetNetworkEndpointGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNetworkEndpointGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetNetworkEndpointGroupRequest} GetNetworkEndpointGroupRequest instance
                         */
                        GetNetworkEndpointGroupRequest.create = function create(properties) {
                            return new GetNetworkEndpointGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetNetworkEndpointGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.GetNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNetworkEndpointGroupRequest} message GetNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetNetworkEndpointGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.networkEndpointGroup != null && Object.hasOwnProperty.call(message, "networkEndpointGroup"))
                                writer.uint32(/* id 433907078, wireType 2 =*/3471256626).string(message.networkEndpointGroup);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetNetworkEndpointGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNetworkEndpointGroupRequest} message GetNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetNetworkEndpointGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetNetworkEndpointGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetNetworkEndpointGroupRequest} GetNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetNetworkEndpointGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetNetworkEndpointGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 433907078: {
                                        message.networkEndpointGroup = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetNetworkEndpointGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetNetworkEndpointGroupRequest} GetNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetNetworkEndpointGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetNetworkEndpointGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetNetworkEndpointGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                if (!$util.isString(message.networkEndpointGroup))
                                    return "networkEndpointGroup: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetNetworkEndpointGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetNetworkEndpointGroupRequest} GetNetworkEndpointGroupRequest
                         */
                        GetNetworkEndpointGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetNetworkEndpointGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetNetworkEndpointGroupRequest();
                            if (object.networkEndpointGroup != null)
                                message.networkEndpointGroup = String(object.networkEndpointGroup);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetNetworkEndpointGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetNetworkEndpointGroupRequest} message GetNetworkEndpointGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetNetworkEndpointGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.networkEndpointGroup = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                object.networkEndpointGroup = message.networkEndpointGroup;
                            return object;
                        };
    
                        /**
                         * Converts this GetNetworkEndpointGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetNetworkEndpointGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetNetworkEndpointGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetNetworkEndpointGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetNetworkEndpointGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetNetworkEndpointGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetNetworkEndpointGroupRequest";
                        };
    
                        return GetNetworkEndpointGroupRequest;
                    })();
    
                    v1.GetNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a GetNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] GetNetworkFirewallPolicyRequest firewallPolicy
                         * @property {string|null} [project] GetNetworkFirewallPolicyRequest project
                         */
    
                        /**
                         * Constructs a new GetNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetNetworkFirewallPolicyRequest.
                         * @implements IGetNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function GetNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.GetNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * GetNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetNetworkFirewallPolicyRequest} GetNetworkFirewallPolicyRequest instance
                         */
                        GetNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new GetNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNetworkFirewallPolicyRequest} message GetNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNetworkFirewallPolicyRequest} message GetNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetNetworkFirewallPolicyRequest} GetNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetNetworkFirewallPolicyRequest} GetNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetNetworkFirewallPolicyRequest} GetNetworkFirewallPolicyRequest
                         */
                        GetNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetNetworkFirewallPolicyRequest} message GetNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.firewallPolicy = "";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this GetNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetNetworkFirewallPolicyRequest";
                        };
    
                        return GetNetworkFirewallPolicyRequest;
                    })();
    
                    v1.GetNetworkRequest = (function() {
    
                        /**
                         * Properties of a GetNetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetNetworkRequest
                         * @property {string|null} [network] GetNetworkRequest network
                         * @property {string|null} [project] GetNetworkRequest project
                         */
    
                        /**
                         * Constructs a new GetNetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetNetworkRequest.
                         * @implements IGetNetworkRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetNetworkRequest=} [properties] Properties to set
                         */
                        function GetNetworkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetNetworkRequest network.
                         * @member {string} network
                         * @memberof google.cloud.compute.v1.GetNetworkRequest
                         * @instance
                         */
                        GetNetworkRequest.prototype.network = "";
    
                        /**
                         * GetNetworkRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetNetworkRequest
                         * @instance
                         */
                        GetNetworkRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetNetworkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNetworkRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetNetworkRequest} GetNetworkRequest instance
                         */
                        GetNetworkRequest.create = function create(properties) {
                            return new GetNetworkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetNetworkRequest message. Does not implicitly {@link google.cloud.compute.v1.GetNetworkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNetworkRequest} message GetNetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetNetworkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetNetworkRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetNetworkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNetworkRequest} message GetNetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetNetworkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetNetworkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetNetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetNetworkRequest} GetNetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetNetworkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetNetworkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetNetworkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetNetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetNetworkRequest} GetNetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetNetworkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetNetworkRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetNetworkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetNetworkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.network != null && message.hasOwnProperty("network"))
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetNetworkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetNetworkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetNetworkRequest} GetNetworkRequest
                         */
                        GetNetworkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetNetworkRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetNetworkRequest();
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetNetworkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetNetworkRequest} message GetNetworkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetNetworkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.network = "";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.network != null && message.hasOwnProperty("network"))
                                object.network = message.network;
                            return object;
                        };
    
                        /**
                         * Converts this GetNetworkRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetNetworkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetNetworkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetNetworkRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetNetworkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetNetworkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetNetworkRequest";
                        };
    
                        return GetNetworkRequest;
                    })();
    
                    v1.GetNodeGroupRequest = (function() {
    
                        /**
                         * Properties of a GetNodeGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetNodeGroupRequest
                         * @property {string|null} [nodeGroup] GetNodeGroupRequest nodeGroup
                         * @property {string|null} [project] GetNodeGroupRequest project
                         * @property {string|null} [zone] GetNodeGroupRequest zone
                         */
    
                        /**
                         * Constructs a new GetNodeGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetNodeGroupRequest.
                         * @implements IGetNodeGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetNodeGroupRequest=} [properties] Properties to set
                         */
                        function GetNodeGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetNodeGroupRequest nodeGroup.
                         * @member {string} nodeGroup
                         * @memberof google.cloud.compute.v1.GetNodeGroupRequest
                         * @instance
                         */
                        GetNodeGroupRequest.prototype.nodeGroup = "";
    
                        /**
                         * GetNodeGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetNodeGroupRequest
                         * @instance
                         */
                        GetNodeGroupRequest.prototype.project = "";
    
                        /**
                         * GetNodeGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetNodeGroupRequest
                         * @instance
                         */
                        GetNodeGroupRequest.prototype.zone = "";
    
                        /**
                         * Creates a new GetNodeGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNodeGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetNodeGroupRequest} GetNodeGroupRequest instance
                         */
                        GetNodeGroupRequest.create = function create(properties) {
                            return new GetNodeGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetNodeGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.GetNodeGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNodeGroupRequest} message GetNodeGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetNodeGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.nodeGroup != null && Object.hasOwnProperty.call(message, "nodeGroup"))
                                writer.uint32(/* id 469958146, wireType 2 =*/3759665170).string(message.nodeGroup);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetNodeGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetNodeGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNodeGroupRequest} message GetNodeGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetNodeGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetNodeGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetNodeGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetNodeGroupRequest} GetNodeGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetNodeGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetNodeGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 469958146: {
                                        message.nodeGroup = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetNodeGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetNodeGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetNodeGroupRequest} GetNodeGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetNodeGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetNodeGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetNodeGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetNodeGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.nodeGroup != null && message.hasOwnProperty("nodeGroup"))
                                if (!$util.isString(message.nodeGroup))
                                    return "nodeGroup: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetNodeGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetNodeGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetNodeGroupRequest} GetNodeGroupRequest
                         */
                        GetNodeGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetNodeGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetNodeGroupRequest();
                            if (object.nodeGroup != null)
                                message.nodeGroup = String(object.nodeGroup);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetNodeGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetNodeGroupRequest} message GetNodeGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetNodeGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.nodeGroup = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.nodeGroup != null && message.hasOwnProperty("nodeGroup"))
                                object.nodeGroup = message.nodeGroup;
                            return object;
                        };
    
                        /**
                         * Converts this GetNodeGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetNodeGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetNodeGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetNodeGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetNodeGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetNodeGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetNodeGroupRequest";
                        };
    
                        return GetNodeGroupRequest;
                    })();
    
                    v1.GetNodeTemplateRequest = (function() {
    
                        /**
                         * Properties of a GetNodeTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetNodeTemplateRequest
                         * @property {string|null} [nodeTemplate] GetNodeTemplateRequest nodeTemplate
                         * @property {string|null} [project] GetNodeTemplateRequest project
                         * @property {string|null} [region] GetNodeTemplateRequest region
                         */
    
                        /**
                         * Constructs a new GetNodeTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetNodeTemplateRequest.
                         * @implements IGetNodeTemplateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetNodeTemplateRequest=} [properties] Properties to set
                         */
                        function GetNodeTemplateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetNodeTemplateRequest nodeTemplate.
                         * @member {string} nodeTemplate
                         * @memberof google.cloud.compute.v1.GetNodeTemplateRequest
                         * @instance
                         */
                        GetNodeTemplateRequest.prototype.nodeTemplate = "";
    
                        /**
                         * GetNodeTemplateRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetNodeTemplateRequest
                         * @instance
                         */
                        GetNodeTemplateRequest.prototype.project = "";
    
                        /**
                         * GetNodeTemplateRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetNodeTemplateRequest
                         * @instance
                         */
                        GetNodeTemplateRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetNodeTemplateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNodeTemplateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetNodeTemplateRequest} GetNodeTemplateRequest instance
                         */
                        GetNodeTemplateRequest.create = function create(properties) {
                            return new GetNodeTemplateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetNodeTemplateRequest message. Does not implicitly {@link google.cloud.compute.v1.GetNodeTemplateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNodeTemplateRequest} message GetNodeTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetNodeTemplateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.nodeTemplate != null && Object.hasOwnProperty.call(message, "nodeTemplate"))
                                writer.uint32(/* id 323154455, wireType 2 =*/2585235642).string(message.nodeTemplate);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetNodeTemplateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetNodeTemplateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNodeTemplateRequest} message GetNodeTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetNodeTemplateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetNodeTemplateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetNodeTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetNodeTemplateRequest} GetNodeTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetNodeTemplateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetNodeTemplateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 323154455: {
                                        message.nodeTemplate = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetNodeTemplateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetNodeTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetNodeTemplateRequest} GetNodeTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetNodeTemplateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetNodeTemplateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetNodeTemplateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetNodeTemplateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.nodeTemplate != null && message.hasOwnProperty("nodeTemplate"))
                                if (!$util.isString(message.nodeTemplate))
                                    return "nodeTemplate: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetNodeTemplateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetNodeTemplateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetNodeTemplateRequest} GetNodeTemplateRequest
                         */
                        GetNodeTemplateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetNodeTemplateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetNodeTemplateRequest();
                            if (object.nodeTemplate != null)
                                message.nodeTemplate = String(object.nodeTemplate);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetNodeTemplateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetNodeTemplateRequest} message GetNodeTemplateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetNodeTemplateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.nodeTemplate = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.nodeTemplate != null && message.hasOwnProperty("nodeTemplate"))
                                object.nodeTemplate = message.nodeTemplate;
                            return object;
                        };
    
                        /**
                         * Converts this GetNodeTemplateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetNodeTemplateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetNodeTemplateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetNodeTemplateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetNodeTemplateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetNodeTemplateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetNodeTemplateRequest";
                        };
    
                        return GetNodeTemplateRequest;
                    })();
    
                    v1.GetNodeTypeRequest = (function() {
    
                        /**
                         * Properties of a GetNodeTypeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetNodeTypeRequest
                         * @property {string|null} [nodeType] GetNodeTypeRequest nodeType
                         * @property {string|null} [project] GetNodeTypeRequest project
                         * @property {string|null} [zone] GetNodeTypeRequest zone
                         */
    
                        /**
                         * Constructs a new GetNodeTypeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetNodeTypeRequest.
                         * @implements IGetNodeTypeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetNodeTypeRequest=} [properties] Properties to set
                         */
                        function GetNodeTypeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetNodeTypeRequest nodeType.
                         * @member {string} nodeType
                         * @memberof google.cloud.compute.v1.GetNodeTypeRequest
                         * @instance
                         */
                        GetNodeTypeRequest.prototype.nodeType = "";
    
                        /**
                         * GetNodeTypeRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetNodeTypeRequest
                         * @instance
                         */
                        GetNodeTypeRequest.prototype.project = "";
    
                        /**
                         * GetNodeTypeRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetNodeTypeRequest
                         * @instance
                         */
                        GetNodeTypeRequest.prototype.zone = "";
    
                        /**
                         * Creates a new GetNodeTypeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetNodeTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNodeTypeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetNodeTypeRequest} GetNodeTypeRequest instance
                         */
                        GetNodeTypeRequest.create = function create(properties) {
                            return new GetNodeTypeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetNodeTypeRequest message. Does not implicitly {@link google.cloud.compute.v1.GetNodeTypeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetNodeTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNodeTypeRequest} message GetNodeTypeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetNodeTypeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.nodeType != null && Object.hasOwnProperty.call(message, "nodeType"))
                                writer.uint32(/* id 465832791, wireType 2 =*/3726662330).string(message.nodeType);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetNodeTypeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetNodeTypeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetNodeTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetNodeTypeRequest} message GetNodeTypeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetNodeTypeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetNodeTypeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetNodeTypeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetNodeTypeRequest} GetNodeTypeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetNodeTypeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetNodeTypeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 465832791: {
                                        message.nodeType = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetNodeTypeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetNodeTypeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetNodeTypeRequest} GetNodeTypeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetNodeTypeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetNodeTypeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetNodeTypeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetNodeTypeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.nodeType != null && message.hasOwnProperty("nodeType"))
                                if (!$util.isString(message.nodeType))
                                    return "nodeType: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetNodeTypeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetNodeTypeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetNodeTypeRequest} GetNodeTypeRequest
                         */
                        GetNodeTypeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetNodeTypeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetNodeTypeRequest();
                            if (object.nodeType != null)
                                message.nodeType = String(object.nodeType);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetNodeTypeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetNodeTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetNodeTypeRequest} message GetNodeTypeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetNodeTypeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.nodeType = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.nodeType != null && message.hasOwnProperty("nodeType"))
                                object.nodeType = message.nodeType;
                            return object;
                        };
    
                        /**
                         * Converts this GetNodeTypeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetNodeTypeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetNodeTypeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetNodeTypeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetNodeTypeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetNodeTypeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetNodeTypeRequest";
                        };
    
                        return GetNodeTypeRequest;
                    })();
    
                    v1.GetPacketMirroringRequest = (function() {
    
                        /**
                         * Properties of a GetPacketMirroringRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetPacketMirroringRequest
                         * @property {string|null} [packetMirroring] GetPacketMirroringRequest packetMirroring
                         * @property {string|null} [project] GetPacketMirroringRequest project
                         * @property {string|null} [region] GetPacketMirroringRequest region
                         */
    
                        /**
                         * Constructs a new GetPacketMirroringRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetPacketMirroringRequest.
                         * @implements IGetPacketMirroringRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetPacketMirroringRequest=} [properties] Properties to set
                         */
                        function GetPacketMirroringRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetPacketMirroringRequest packetMirroring.
                         * @member {string} packetMirroring
                         * @memberof google.cloud.compute.v1.GetPacketMirroringRequest
                         * @instance
                         */
                        GetPacketMirroringRequest.prototype.packetMirroring = "";
    
                        /**
                         * GetPacketMirroringRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetPacketMirroringRequest
                         * @instance
                         */
                        GetPacketMirroringRequest.prototype.project = "";
    
                        /**
                         * GetPacketMirroringRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetPacketMirroringRequest
                         * @instance
                         */
                        GetPacketMirroringRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetPacketMirroringRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetPacketMirroringRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetPacketMirroringRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetPacketMirroringRequest} GetPacketMirroringRequest instance
                         */
                        GetPacketMirroringRequest.create = function create(properties) {
                            return new GetPacketMirroringRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetPacketMirroringRequest message. Does not implicitly {@link google.cloud.compute.v1.GetPacketMirroringRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetPacketMirroringRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetPacketMirroringRequest} message GetPacketMirroringRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetPacketMirroringRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.packetMirroring != null && Object.hasOwnProperty.call(message, "packetMirroring"))
                                writer.uint32(/* id 22305996, wireType 2 =*/178447970).string(message.packetMirroring);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetPacketMirroringRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetPacketMirroringRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetPacketMirroringRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetPacketMirroringRequest} message GetPacketMirroringRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetPacketMirroringRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetPacketMirroringRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetPacketMirroringRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetPacketMirroringRequest} GetPacketMirroringRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetPacketMirroringRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetPacketMirroringRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 22305996: {
                                        message.packetMirroring = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetPacketMirroringRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetPacketMirroringRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetPacketMirroringRequest} GetPacketMirroringRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetPacketMirroringRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetPacketMirroringRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetPacketMirroringRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetPacketMirroringRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.packetMirroring != null && message.hasOwnProperty("packetMirroring"))
                                if (!$util.isString(message.packetMirroring))
                                    return "packetMirroring: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetPacketMirroringRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetPacketMirroringRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetPacketMirroringRequest} GetPacketMirroringRequest
                         */
                        GetPacketMirroringRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetPacketMirroringRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetPacketMirroringRequest();
                            if (object.packetMirroring != null)
                                message.packetMirroring = String(object.packetMirroring);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetPacketMirroringRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetPacketMirroringRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetPacketMirroringRequest} message GetPacketMirroringRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetPacketMirroringRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.packetMirroring = "";
                                object.region = "";
                                object.project = "";
                            }
                            if (message.packetMirroring != null && message.hasOwnProperty("packetMirroring"))
                                object.packetMirroring = message.packetMirroring;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetPacketMirroringRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetPacketMirroringRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetPacketMirroringRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetPacketMirroringRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetPacketMirroringRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetPacketMirroringRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetPacketMirroringRequest";
                        };
    
                        return GetPacketMirroringRequest;
                    })();
    
                    v1.GetProjectRequest = (function() {
    
                        /**
                         * Properties of a GetProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetProjectRequest
                         * @property {string|null} [project] GetProjectRequest project
                         */
    
                        /**
                         * Constructs a new GetProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetProjectRequest.
                         * @implements IGetProjectRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetProjectRequest=} [properties] Properties to set
                         */
                        function GetProjectRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetProjectRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetProjectRequest
                         * @instance
                         */
                        GetProjectRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetProjectRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetProjectRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetProjectRequest} GetProjectRequest instance
                         */
                        GetProjectRequest.create = function create(properties) {
                            return new GetProjectRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetProjectRequest message. Does not implicitly {@link google.cloud.compute.v1.GetProjectRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetProjectRequest} message GetProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetProjectRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetProjectRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetProjectRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetProjectRequest} message GetProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetProjectRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetProjectRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetProjectRequest} GetProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetProjectRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetProjectRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetProjectRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetProjectRequest} GetProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetProjectRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetProjectRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetProjectRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetProjectRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetProjectRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetProjectRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetProjectRequest} GetProjectRequest
                         */
                        GetProjectRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetProjectRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetProjectRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetProjectRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetProjectRequest} message GetProjectRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetProjectRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetProjectRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetProjectRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetProjectRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetProjectRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetProjectRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetProjectRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetProjectRequest";
                        };
    
                        return GetProjectRequest;
                    })();
    
                    v1.GetPublicAdvertisedPrefixeRequest = (function() {
    
                        /**
                         * Properties of a GetPublicAdvertisedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetPublicAdvertisedPrefixeRequest
                         * @property {string|null} [project] GetPublicAdvertisedPrefixeRequest project
                         * @property {string|null} [publicAdvertisedPrefix] GetPublicAdvertisedPrefixeRequest publicAdvertisedPrefix
                         */
    
                        /**
                         * Constructs a new GetPublicAdvertisedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetPublicAdvertisedPrefixeRequest.
                         * @implements IGetPublicAdvertisedPrefixeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetPublicAdvertisedPrefixeRequest=} [properties] Properties to set
                         */
                        function GetPublicAdvertisedPrefixeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetPublicAdvertisedPrefixeRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest
                         * @instance
                         */
                        GetPublicAdvertisedPrefixeRequest.prototype.project = "";
    
                        /**
                         * GetPublicAdvertisedPrefixeRequest publicAdvertisedPrefix.
                         * @member {string} publicAdvertisedPrefix
                         * @memberof google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest
                         * @instance
                         */
                        GetPublicAdvertisedPrefixeRequest.prototype.publicAdvertisedPrefix = "";
    
                        /**
                         * Creates a new GetPublicAdvertisedPrefixeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetPublicAdvertisedPrefixeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest} GetPublicAdvertisedPrefixeRequest instance
                         */
                        GetPublicAdvertisedPrefixeRequest.create = function create(properties) {
                            return new GetPublicAdvertisedPrefixeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetPublicAdvertisedPrefixeRequest message. Does not implicitly {@link google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetPublicAdvertisedPrefixeRequest} message GetPublicAdvertisedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetPublicAdvertisedPrefixeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.publicAdvertisedPrefix != null && Object.hasOwnProperty.call(message, "publicAdvertisedPrefix"))
                                writer.uint32(/* id 101874590, wireType 2 =*/814996722).string(message.publicAdvertisedPrefix);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetPublicAdvertisedPrefixeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetPublicAdvertisedPrefixeRequest} message GetPublicAdvertisedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetPublicAdvertisedPrefixeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetPublicAdvertisedPrefixeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest} GetPublicAdvertisedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetPublicAdvertisedPrefixeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 101874590: {
                                        message.publicAdvertisedPrefix = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetPublicAdvertisedPrefixeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest} GetPublicAdvertisedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetPublicAdvertisedPrefixeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetPublicAdvertisedPrefixeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetPublicAdvertisedPrefixeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.publicAdvertisedPrefix != null && message.hasOwnProperty("publicAdvertisedPrefix"))
                                if (!$util.isString(message.publicAdvertisedPrefix))
                                    return "publicAdvertisedPrefix: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetPublicAdvertisedPrefixeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest} GetPublicAdvertisedPrefixeRequest
                         */
                        GetPublicAdvertisedPrefixeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.publicAdvertisedPrefix != null)
                                message.publicAdvertisedPrefix = String(object.publicAdvertisedPrefix);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetPublicAdvertisedPrefixeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest} message GetPublicAdvertisedPrefixeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetPublicAdvertisedPrefixeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.publicAdvertisedPrefix = "";
                                object.project = "";
                            }
                            if (message.publicAdvertisedPrefix != null && message.hasOwnProperty("publicAdvertisedPrefix"))
                                object.publicAdvertisedPrefix = message.publicAdvertisedPrefix;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetPublicAdvertisedPrefixeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetPublicAdvertisedPrefixeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetPublicAdvertisedPrefixeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetPublicAdvertisedPrefixeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest";
                        };
    
                        return GetPublicAdvertisedPrefixeRequest;
                    })();
    
                    v1.GetPublicDelegatedPrefixeRequest = (function() {
    
                        /**
                         * Properties of a GetPublicDelegatedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetPublicDelegatedPrefixeRequest
                         * @property {string|null} [project] GetPublicDelegatedPrefixeRequest project
                         * @property {string|null} [publicDelegatedPrefix] GetPublicDelegatedPrefixeRequest publicDelegatedPrefix
                         * @property {string|null} [region] GetPublicDelegatedPrefixeRequest region
                         */
    
                        /**
                         * Constructs a new GetPublicDelegatedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetPublicDelegatedPrefixeRequest.
                         * @implements IGetPublicDelegatedPrefixeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetPublicDelegatedPrefixeRequest=} [properties] Properties to set
                         */
                        function GetPublicDelegatedPrefixeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetPublicDelegatedPrefixeRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        GetPublicDelegatedPrefixeRequest.prototype.project = "";
    
                        /**
                         * GetPublicDelegatedPrefixeRequest publicDelegatedPrefix.
                         * @member {string} publicDelegatedPrefix
                         * @memberof google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        GetPublicDelegatedPrefixeRequest.prototype.publicDelegatedPrefix = "";
    
                        /**
                         * GetPublicDelegatedPrefixeRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        GetPublicDelegatedPrefixeRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetPublicDelegatedPrefixeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetPublicDelegatedPrefixeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest} GetPublicDelegatedPrefixeRequest instance
                         */
                        GetPublicDelegatedPrefixeRequest.create = function create(properties) {
                            return new GetPublicDelegatedPrefixeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetPublicDelegatedPrefixeRequest message. Does not implicitly {@link google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetPublicDelegatedPrefixeRequest} message GetPublicDelegatedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetPublicDelegatedPrefixeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.publicDelegatedPrefix != null && Object.hasOwnProperty.call(message, "publicDelegatedPrefix"))
                                writer.uint32(/* id 204238440, wireType 2 =*/1633907522).string(message.publicDelegatedPrefix);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetPublicDelegatedPrefixeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetPublicDelegatedPrefixeRequest} message GetPublicDelegatedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetPublicDelegatedPrefixeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetPublicDelegatedPrefixeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest} GetPublicDelegatedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetPublicDelegatedPrefixeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 204238440: {
                                        message.publicDelegatedPrefix = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetPublicDelegatedPrefixeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest} GetPublicDelegatedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetPublicDelegatedPrefixeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetPublicDelegatedPrefixeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetPublicDelegatedPrefixeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.publicDelegatedPrefix != null && message.hasOwnProperty("publicDelegatedPrefix"))
                                if (!$util.isString(message.publicDelegatedPrefix))
                                    return "publicDelegatedPrefix: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetPublicDelegatedPrefixeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest} GetPublicDelegatedPrefixeRequest
                         */
                        GetPublicDelegatedPrefixeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.publicDelegatedPrefix != null)
                                message.publicDelegatedPrefix = String(object.publicDelegatedPrefix);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetPublicDelegatedPrefixeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest} message GetPublicDelegatedPrefixeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetPublicDelegatedPrefixeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.publicDelegatedPrefix = "";
                                object.project = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.publicDelegatedPrefix != null && message.hasOwnProperty("publicDelegatedPrefix"))
                                object.publicDelegatedPrefix = message.publicDelegatedPrefix;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetPublicDelegatedPrefixeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetPublicDelegatedPrefixeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetPublicDelegatedPrefixeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetPublicDelegatedPrefixeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest";
                        };
    
                        return GetPublicDelegatedPrefixeRequest;
                    })();
    
                    v1.GetRegionAutoscalerRequest = (function() {
    
                        /**
                         * Properties of a GetRegionAutoscalerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionAutoscalerRequest
                         * @property {string|null} [autoscaler] GetRegionAutoscalerRequest autoscaler
                         * @property {string|null} [project] GetRegionAutoscalerRequest project
                         * @property {string|null} [region] GetRegionAutoscalerRequest region
                         */
    
                        /**
                         * Constructs a new GetRegionAutoscalerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionAutoscalerRequest.
                         * @implements IGetRegionAutoscalerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionAutoscalerRequest=} [properties] Properties to set
                         */
                        function GetRegionAutoscalerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionAutoscalerRequest autoscaler.
                         * @member {string} autoscaler
                         * @memberof google.cloud.compute.v1.GetRegionAutoscalerRequest
                         * @instance
                         */
                        GetRegionAutoscalerRequest.prototype.autoscaler = "";
    
                        /**
                         * GetRegionAutoscalerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionAutoscalerRequest
                         * @instance
                         */
                        GetRegionAutoscalerRequest.prototype.project = "";
    
                        /**
                         * GetRegionAutoscalerRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionAutoscalerRequest
                         * @instance
                         */
                        GetRegionAutoscalerRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetRegionAutoscalerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionAutoscalerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionAutoscalerRequest} GetRegionAutoscalerRequest instance
                         */
                        GetRegionAutoscalerRequest.create = function create(properties) {
                            return new GetRegionAutoscalerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionAutoscalerRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionAutoscalerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionAutoscalerRequest} message GetRegionAutoscalerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionAutoscalerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.autoscaler != null && Object.hasOwnProperty.call(message, "autoscaler"))
                                writer.uint32(/* id 517258967, wireType 2 =*/4138071738).string(message.autoscaler);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionAutoscalerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionAutoscalerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionAutoscalerRequest} message GetRegionAutoscalerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionAutoscalerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionAutoscalerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionAutoscalerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionAutoscalerRequest} GetRegionAutoscalerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionAutoscalerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionAutoscalerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 517258967: {
                                        message.autoscaler = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionAutoscalerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionAutoscalerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionAutoscalerRequest} GetRegionAutoscalerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionAutoscalerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionAutoscalerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionAutoscalerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionAutoscalerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.autoscaler != null && message.hasOwnProperty("autoscaler"))
                                if (!$util.isString(message.autoscaler))
                                    return "autoscaler: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionAutoscalerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionAutoscalerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionAutoscalerRequest} GetRegionAutoscalerRequest
                         */
                        GetRegionAutoscalerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionAutoscalerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionAutoscalerRequest();
                            if (object.autoscaler != null)
                                message.autoscaler = String(object.autoscaler);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionAutoscalerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionAutoscalerRequest} message GetRegionAutoscalerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionAutoscalerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.autoscaler = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.autoscaler != null && message.hasOwnProperty("autoscaler"))
                                object.autoscaler = message.autoscaler;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionAutoscalerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionAutoscalerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionAutoscalerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionAutoscalerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionAutoscalerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionAutoscalerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionAutoscalerRequest";
                        };
    
                        return GetRegionAutoscalerRequest;
                    })();
    
                    v1.GetRegionBackendServiceRequest = (function() {
    
                        /**
                         * Properties of a GetRegionBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionBackendServiceRequest
                         * @property {string|null} [backendService] GetRegionBackendServiceRequest backendService
                         * @property {string|null} [project] GetRegionBackendServiceRequest project
                         * @property {string|null} [region] GetRegionBackendServiceRequest region
                         */
    
                        /**
                         * Constructs a new GetRegionBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionBackendServiceRequest.
                         * @implements IGetRegionBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionBackendServiceRequest=} [properties] Properties to set
                         */
                        function GetRegionBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionBackendServiceRequest backendService.
                         * @member {string} backendService
                         * @memberof google.cloud.compute.v1.GetRegionBackendServiceRequest
                         * @instance
                         */
                        GetRegionBackendServiceRequest.prototype.backendService = "";
    
                        /**
                         * GetRegionBackendServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionBackendServiceRequest
                         * @instance
                         */
                        GetRegionBackendServiceRequest.prototype.project = "";
    
                        /**
                         * GetRegionBackendServiceRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionBackendServiceRequest
                         * @instance
                         */
                        GetRegionBackendServiceRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetRegionBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionBackendServiceRequest} GetRegionBackendServiceRequest instance
                         */
                        GetRegionBackendServiceRequest.create = function create(properties) {
                            return new GetRegionBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionBackendServiceRequest} message GetRegionBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.backendService != null && Object.hasOwnProperty.call(message, "backendService"))
                                writer.uint32(/* id 306946058, wireType 2 =*/2455568466).string(message.backendService);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionBackendServiceRequest} message GetRegionBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionBackendServiceRequest} GetRegionBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 306946058: {
                                        message.backendService = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionBackendServiceRequest} GetRegionBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                if (!$util.isString(message.backendService))
                                    return "backendService: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionBackendServiceRequest} GetRegionBackendServiceRequest
                         */
                        GetRegionBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionBackendServiceRequest();
                            if (object.backendService != null)
                                message.backendService = String(object.backendService);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionBackendServiceRequest} message GetRegionBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.backendService = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                object.backendService = message.backendService;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionBackendServiceRequest";
                        };
    
                        return GetRegionBackendServiceRequest;
                    })();
    
                    v1.GetRegionCommitmentRequest = (function() {
    
                        /**
                         * Properties of a GetRegionCommitmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionCommitmentRequest
                         * @property {string|null} [commitment] GetRegionCommitmentRequest commitment
                         * @property {string|null} [project] GetRegionCommitmentRequest project
                         * @property {string|null} [region] GetRegionCommitmentRequest region
                         */
    
                        /**
                         * Constructs a new GetRegionCommitmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionCommitmentRequest.
                         * @implements IGetRegionCommitmentRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionCommitmentRequest=} [properties] Properties to set
                         */
                        function GetRegionCommitmentRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionCommitmentRequest commitment.
                         * @member {string} commitment
                         * @memberof google.cloud.compute.v1.GetRegionCommitmentRequest
                         * @instance
                         */
                        GetRegionCommitmentRequest.prototype.commitment = "";
    
                        /**
                         * GetRegionCommitmentRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionCommitmentRequest
                         * @instance
                         */
                        GetRegionCommitmentRequest.prototype.project = "";
    
                        /**
                         * GetRegionCommitmentRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionCommitmentRequest
                         * @instance
                         */
                        GetRegionCommitmentRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetRegionCommitmentRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionCommitmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionCommitmentRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionCommitmentRequest} GetRegionCommitmentRequest instance
                         */
                        GetRegionCommitmentRequest.create = function create(properties) {
                            return new GetRegionCommitmentRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionCommitmentRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionCommitmentRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionCommitmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionCommitmentRequest} message GetRegionCommitmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionCommitmentRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.commitment != null && Object.hasOwnProperty.call(message, "commitment"))
                                writer.uint32(/* id 482134805, wireType 2 =*/3857078442).string(message.commitment);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionCommitmentRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionCommitmentRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionCommitmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionCommitmentRequest} message GetRegionCommitmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionCommitmentRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionCommitmentRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionCommitmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionCommitmentRequest} GetRegionCommitmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionCommitmentRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionCommitmentRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 482134805: {
                                        message.commitment = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionCommitmentRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionCommitmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionCommitmentRequest} GetRegionCommitmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionCommitmentRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionCommitmentRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionCommitmentRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionCommitmentRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.commitment != null && message.hasOwnProperty("commitment"))
                                if (!$util.isString(message.commitment))
                                    return "commitment: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionCommitmentRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionCommitmentRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionCommitmentRequest} GetRegionCommitmentRequest
                         */
                        GetRegionCommitmentRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionCommitmentRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionCommitmentRequest();
                            if (object.commitment != null)
                                message.commitment = String(object.commitment);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionCommitmentRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionCommitmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionCommitmentRequest} message GetRegionCommitmentRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionCommitmentRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.commitment = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.commitment != null && message.hasOwnProperty("commitment"))
                                object.commitment = message.commitment;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionCommitmentRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionCommitmentRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionCommitmentRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionCommitmentRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionCommitmentRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionCommitmentRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionCommitmentRequest";
                        };
    
                        return GetRegionCommitmentRequest;
                    })();
    
                    v1.GetRegionDiskRequest = (function() {
    
                        /**
                         * Properties of a GetRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionDiskRequest
                         * @property {string|null} [disk] GetRegionDiskRequest disk
                         * @property {string|null} [project] GetRegionDiskRequest project
                         * @property {string|null} [region] GetRegionDiskRequest region
                         */
    
                        /**
                         * Constructs a new GetRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionDiskRequest.
                         * @implements IGetRegionDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionDiskRequest=} [properties] Properties to set
                         */
                        function GetRegionDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionDiskRequest disk.
                         * @member {string} disk
                         * @memberof google.cloud.compute.v1.GetRegionDiskRequest
                         * @instance
                         */
                        GetRegionDiskRequest.prototype.disk = "";
    
                        /**
                         * GetRegionDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionDiskRequest
                         * @instance
                         */
                        GetRegionDiskRequest.prototype.project = "";
    
                        /**
                         * GetRegionDiskRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionDiskRequest
                         * @instance
                         */
                        GetRegionDiskRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetRegionDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionDiskRequest} GetRegionDiskRequest instance
                         */
                        GetRegionDiskRequest.create = function create(properties) {
                            return new GetRegionDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionDiskRequest} message GetRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.disk != null && Object.hasOwnProperty.call(message, "disk"))
                                writer.uint32(/* id 3083677, wireType 2 =*/24669418).string(message.disk);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionDiskRequest} message GetRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionDiskRequest} GetRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3083677: {
                                        message.disk = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionDiskRequest} GetRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                if (!$util.isString(message.disk))
                                    return "disk: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionDiskRequest} GetRegionDiskRequest
                         */
                        GetRegionDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionDiskRequest();
                            if (object.disk != null)
                                message.disk = String(object.disk);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionDiskRequest} message GetRegionDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.disk = "";
                                object.region = "";
                                object.project = "";
                            }
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                object.disk = message.disk;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionDiskRequest";
                        };
    
                        return GetRegionDiskRequest;
                    })();
    
                    v1.GetRegionDiskTypeRequest = (function() {
    
                        /**
                         * Properties of a GetRegionDiskTypeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionDiskTypeRequest
                         * @property {string|null} [diskType] GetRegionDiskTypeRequest diskType
                         * @property {string|null} [project] GetRegionDiskTypeRequest project
                         * @property {string|null} [region] GetRegionDiskTypeRequest region
                         */
    
                        /**
                         * Constructs a new GetRegionDiskTypeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionDiskTypeRequest.
                         * @implements IGetRegionDiskTypeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionDiskTypeRequest=} [properties] Properties to set
                         */
                        function GetRegionDiskTypeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionDiskTypeRequest diskType.
                         * @member {string} diskType
                         * @memberof google.cloud.compute.v1.GetRegionDiskTypeRequest
                         * @instance
                         */
                        GetRegionDiskTypeRequest.prototype.diskType = "";
    
                        /**
                         * GetRegionDiskTypeRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionDiskTypeRequest
                         * @instance
                         */
                        GetRegionDiskTypeRequest.prototype.project = "";
    
                        /**
                         * GetRegionDiskTypeRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionDiskTypeRequest
                         * @instance
                         */
                        GetRegionDiskTypeRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetRegionDiskTypeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionDiskTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionDiskTypeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionDiskTypeRequest} GetRegionDiskTypeRequest instance
                         */
                        GetRegionDiskTypeRequest.create = function create(properties) {
                            return new GetRegionDiskTypeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionDiskTypeRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionDiskTypeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionDiskTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionDiskTypeRequest} message GetRegionDiskTypeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionDiskTypeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.diskType != null && Object.hasOwnProperty.call(message, "diskType"))
                                writer.uint32(/* id 93009052, wireType 2 =*/744072418).string(message.diskType);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionDiskTypeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionDiskTypeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionDiskTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionDiskTypeRequest} message GetRegionDiskTypeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionDiskTypeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionDiskTypeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionDiskTypeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionDiskTypeRequest} GetRegionDiskTypeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionDiskTypeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionDiskTypeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 93009052: {
                                        message.diskType = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionDiskTypeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionDiskTypeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionDiskTypeRequest} GetRegionDiskTypeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionDiskTypeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionDiskTypeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionDiskTypeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionDiskTypeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.diskType != null && message.hasOwnProperty("diskType"))
                                if (!$util.isString(message.diskType))
                                    return "diskType: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionDiskTypeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionDiskTypeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionDiskTypeRequest} GetRegionDiskTypeRequest
                         */
                        GetRegionDiskTypeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionDiskTypeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionDiskTypeRequest();
                            if (object.diskType != null)
                                message.diskType = String(object.diskType);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionDiskTypeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionDiskTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionDiskTypeRequest} message GetRegionDiskTypeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionDiskTypeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.diskType = "";
                                object.region = "";
                                object.project = "";
                            }
                            if (message.diskType != null && message.hasOwnProperty("diskType"))
                                object.diskType = message.diskType;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionDiskTypeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionDiskTypeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionDiskTypeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionDiskTypeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionDiskTypeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionDiskTypeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionDiskTypeRequest";
                        };
    
                        return GetRegionDiskTypeRequest;
                    })();
    
                    v1.GetRegionHealthCheckRequest = (function() {
    
                        /**
                         * Properties of a GetRegionHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionHealthCheckRequest
                         * @property {string|null} [healthCheck] GetRegionHealthCheckRequest healthCheck
                         * @property {string|null} [project] GetRegionHealthCheckRequest project
                         * @property {string|null} [region] GetRegionHealthCheckRequest region
                         */
    
                        /**
                         * Constructs a new GetRegionHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionHealthCheckRequest.
                         * @implements IGetRegionHealthCheckRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionHealthCheckRequest=} [properties] Properties to set
                         */
                        function GetRegionHealthCheckRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionHealthCheckRequest healthCheck.
                         * @member {string} healthCheck
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckRequest
                         * @instance
                         */
                        GetRegionHealthCheckRequest.prototype.healthCheck = "";
    
                        /**
                         * GetRegionHealthCheckRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckRequest
                         * @instance
                         */
                        GetRegionHealthCheckRequest.prototype.project = "";
    
                        /**
                         * GetRegionHealthCheckRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckRequest
                         * @instance
                         */
                        GetRegionHealthCheckRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetRegionHealthCheckRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionHealthCheckRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionHealthCheckRequest} GetRegionHealthCheckRequest instance
                         */
                        GetRegionHealthCheckRequest.create = function create(properties) {
                            return new GetRegionHealthCheckRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionHealthCheckRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionHealthCheckRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionHealthCheckRequest} message GetRegionHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionHealthCheckRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.healthCheck != null && Object.hasOwnProperty.call(message, "healthCheck"))
                                writer.uint32(/* id 308876645, wireType 2 =*/2471013162).string(message.healthCheck);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionHealthCheckRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionHealthCheckRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionHealthCheckRequest} message GetRegionHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionHealthCheckRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionHealthCheckRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionHealthCheckRequest} GetRegionHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionHealthCheckRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionHealthCheckRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 308876645: {
                                        message.healthCheck = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionHealthCheckRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionHealthCheckRequest} GetRegionHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionHealthCheckRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionHealthCheckRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionHealthCheckRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck"))
                                if (!$util.isString(message.healthCheck))
                                    return "healthCheck: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionHealthCheckRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionHealthCheckRequest} GetRegionHealthCheckRequest
                         */
                        GetRegionHealthCheckRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionHealthCheckRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionHealthCheckRequest();
                            if (object.healthCheck != null)
                                message.healthCheck = String(object.healthCheck);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionHealthCheckRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionHealthCheckRequest} message GetRegionHealthCheckRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionHealthCheckRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.healthCheck = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck"))
                                object.healthCheck = message.healthCheck;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionHealthCheckRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionHealthCheckRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionHealthCheckRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionHealthCheckRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionHealthCheckRequest";
                        };
    
                        return GetRegionHealthCheckRequest;
                    })();
    
                    v1.GetRegionHealthCheckServiceRequest = (function() {
    
                        /**
                         * Properties of a GetRegionHealthCheckServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionHealthCheckServiceRequest
                         * @property {string|null} [healthCheckService] GetRegionHealthCheckServiceRequest healthCheckService
                         * @property {string|null} [project] GetRegionHealthCheckServiceRequest project
                         * @property {string|null} [region] GetRegionHealthCheckServiceRequest region
                         */
    
                        /**
                         * Constructs a new GetRegionHealthCheckServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionHealthCheckServiceRequest.
                         * @implements IGetRegionHealthCheckServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionHealthCheckServiceRequest=} [properties] Properties to set
                         */
                        function GetRegionHealthCheckServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionHealthCheckServiceRequest healthCheckService.
                         * @member {string} healthCheckService
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckServiceRequest
                         * @instance
                         */
                        GetRegionHealthCheckServiceRequest.prototype.healthCheckService = "";
    
                        /**
                         * GetRegionHealthCheckServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckServiceRequest
                         * @instance
                         */
                        GetRegionHealthCheckServiceRequest.prototype.project = "";
    
                        /**
                         * GetRegionHealthCheckServiceRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckServiceRequest
                         * @instance
                         */
                        GetRegionHealthCheckServiceRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetRegionHealthCheckServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionHealthCheckServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionHealthCheckServiceRequest} GetRegionHealthCheckServiceRequest instance
                         */
                        GetRegionHealthCheckServiceRequest.create = function create(properties) {
                            return new GetRegionHealthCheckServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionHealthCheckServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionHealthCheckServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionHealthCheckServiceRequest} message GetRegionHealthCheckServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionHealthCheckServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.healthCheckService != null && Object.hasOwnProperty.call(message, "healthCheckService"))
                                writer.uint32(/* id 408374747, wireType 2 =*/3266997978).string(message.healthCheckService);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionHealthCheckServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionHealthCheckServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionHealthCheckServiceRequest} message GetRegionHealthCheckServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionHealthCheckServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionHealthCheckServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionHealthCheckServiceRequest} GetRegionHealthCheckServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionHealthCheckServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionHealthCheckServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 408374747: {
                                        message.healthCheckService = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionHealthCheckServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionHealthCheckServiceRequest} GetRegionHealthCheckServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionHealthCheckServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionHealthCheckServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionHealthCheckServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.healthCheckService != null && message.hasOwnProperty("healthCheckService"))
                                if (!$util.isString(message.healthCheckService))
                                    return "healthCheckService: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionHealthCheckServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionHealthCheckServiceRequest} GetRegionHealthCheckServiceRequest
                         */
                        GetRegionHealthCheckServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionHealthCheckServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionHealthCheckServiceRequest();
                            if (object.healthCheckService != null)
                                message.healthCheckService = String(object.healthCheckService);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionHealthCheckServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionHealthCheckServiceRequest} message GetRegionHealthCheckServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionHealthCheckServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.healthCheckService = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.healthCheckService != null && message.hasOwnProperty("healthCheckService"))
                                object.healthCheckService = message.healthCheckService;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionHealthCheckServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionHealthCheckServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionHealthCheckServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionHealthCheckServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionHealthCheckServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionHealthCheckServiceRequest";
                        };
    
                        return GetRegionHealthCheckServiceRequest;
                    })();
    
                    v1.GetRegionInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a GetRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] GetRegionInstanceGroupManagerRequest instanceGroupManager
                         * @property {string|null} [project] GetRegionInstanceGroupManagerRequest project
                         * @property {string|null} [region] GetRegionInstanceGroupManagerRequest region
                         */
    
                        /**
                         * Constructs a new GetRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionInstanceGroupManagerRequest.
                         * @implements IGetRegionInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function GetRegionInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        GetRegionInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * GetRegionInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        GetRegionInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * GetRegionInstanceGroupManagerRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        GetRegionInstanceGroupManagerRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetRegionInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest} GetRegionInstanceGroupManagerRequest instance
                         */
                        GetRegionInstanceGroupManagerRequest.create = function create(properties) {
                            return new GetRegionInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionInstanceGroupManagerRequest} message GetRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionInstanceGroupManagerRequest} message GetRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest} GetRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest} GetRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest} GetRegionInstanceGroupManagerRequest
                         */
                        GetRegionInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest} message GetRegionInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest";
                        };
    
                        return GetRegionInstanceGroupManagerRequest;
                    })();
    
                    v1.GetRegionInstanceGroupRequest = (function() {
    
                        /**
                         * Properties of a GetRegionInstanceGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionInstanceGroupRequest
                         * @property {string|null} [instanceGroup] GetRegionInstanceGroupRequest instanceGroup
                         * @property {string|null} [project] GetRegionInstanceGroupRequest project
                         * @property {string|null} [region] GetRegionInstanceGroupRequest region
                         */
    
                        /**
                         * Constructs a new GetRegionInstanceGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionInstanceGroupRequest.
                         * @implements IGetRegionInstanceGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionInstanceGroupRequest=} [properties] Properties to set
                         */
                        function GetRegionInstanceGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionInstanceGroupRequest instanceGroup.
                         * @member {string} instanceGroup
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupRequest
                         * @instance
                         */
                        GetRegionInstanceGroupRequest.prototype.instanceGroup = "";
    
                        /**
                         * GetRegionInstanceGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupRequest
                         * @instance
                         */
                        GetRegionInstanceGroupRequest.prototype.project = "";
    
                        /**
                         * GetRegionInstanceGroupRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupRequest
                         * @instance
                         */
                        GetRegionInstanceGroupRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetRegionInstanceGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionInstanceGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionInstanceGroupRequest} GetRegionInstanceGroupRequest instance
                         */
                        GetRegionInstanceGroupRequest.create = function create(properties) {
                            return new GetRegionInstanceGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionInstanceGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionInstanceGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionInstanceGroupRequest} message GetRegionInstanceGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionInstanceGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instanceGroup != null && Object.hasOwnProperty.call(message, "instanceGroup"))
                                writer.uint32(/* id 81095253, wireType 2 =*/648762026).string(message.instanceGroup);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionInstanceGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionInstanceGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionInstanceGroupRequest} message GetRegionInstanceGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionInstanceGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionInstanceGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionInstanceGroupRequest} GetRegionInstanceGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionInstanceGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionInstanceGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 81095253: {
                                        message.instanceGroup = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionInstanceGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionInstanceGroupRequest} GetRegionInstanceGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionInstanceGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionInstanceGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionInstanceGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instanceGroup != null && message.hasOwnProperty("instanceGroup"))
                                if (!$util.isString(message.instanceGroup))
                                    return "instanceGroup: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionInstanceGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionInstanceGroupRequest} GetRegionInstanceGroupRequest
                         */
                        GetRegionInstanceGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionInstanceGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionInstanceGroupRequest();
                            if (object.instanceGroup != null)
                                message.instanceGroup = String(object.instanceGroup);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionInstanceGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionInstanceGroupRequest} message GetRegionInstanceGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionInstanceGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.instanceGroup = "";
                                object.region = "";
                                object.project = "";
                            }
                            if (message.instanceGroup != null && message.hasOwnProperty("instanceGroup"))
                                object.instanceGroup = message.instanceGroup;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionInstanceGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionInstanceGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionInstanceGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionInstanceGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionInstanceGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionInstanceGroupRequest";
                        };
    
                        return GetRegionInstanceGroupRequest;
                    })();
    
                    v1.GetRegionNetworkEndpointGroupRequest = (function() {
    
                        /**
                         * Properties of a GetRegionNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionNetworkEndpointGroupRequest
                         * @property {string|null} [networkEndpointGroup] GetRegionNetworkEndpointGroupRequest networkEndpointGroup
                         * @property {string|null} [project] GetRegionNetworkEndpointGroupRequest project
                         * @property {string|null} [region] GetRegionNetworkEndpointGroupRequest region
                         */
    
                        /**
                         * Constructs a new GetRegionNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionNetworkEndpointGroupRequest.
                         * @implements IGetRegionNetworkEndpointGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionNetworkEndpointGroupRequest=} [properties] Properties to set
                         */
                        function GetRegionNetworkEndpointGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionNetworkEndpointGroupRequest networkEndpointGroup.
                         * @member {string} networkEndpointGroup
                         * @memberof google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest
                         * @instance
                         */
                        GetRegionNetworkEndpointGroupRequest.prototype.networkEndpointGroup = "";
    
                        /**
                         * GetRegionNetworkEndpointGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest
                         * @instance
                         */
                        GetRegionNetworkEndpointGroupRequest.prototype.project = "";
    
                        /**
                         * GetRegionNetworkEndpointGroupRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest
                         * @instance
                         */
                        GetRegionNetworkEndpointGroupRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetRegionNetworkEndpointGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionNetworkEndpointGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest} GetRegionNetworkEndpointGroupRequest instance
                         */
                        GetRegionNetworkEndpointGroupRequest.create = function create(properties) {
                            return new GetRegionNetworkEndpointGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionNetworkEndpointGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionNetworkEndpointGroupRequest} message GetRegionNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionNetworkEndpointGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.networkEndpointGroup != null && Object.hasOwnProperty.call(message, "networkEndpointGroup"))
                                writer.uint32(/* id 433907078, wireType 2 =*/3471256626).string(message.networkEndpointGroup);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionNetworkEndpointGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionNetworkEndpointGroupRequest} message GetRegionNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionNetworkEndpointGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionNetworkEndpointGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest} GetRegionNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionNetworkEndpointGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 433907078: {
                                        message.networkEndpointGroup = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionNetworkEndpointGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest} GetRegionNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionNetworkEndpointGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionNetworkEndpointGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionNetworkEndpointGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                if (!$util.isString(message.networkEndpointGroup))
                                    return "networkEndpointGroup: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionNetworkEndpointGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest} GetRegionNetworkEndpointGroupRequest
                         */
                        GetRegionNetworkEndpointGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest();
                            if (object.networkEndpointGroup != null)
                                message.networkEndpointGroup = String(object.networkEndpointGroup);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionNetworkEndpointGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest} message GetRegionNetworkEndpointGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionNetworkEndpointGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.networkEndpointGroup = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                object.networkEndpointGroup = message.networkEndpointGroup;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionNetworkEndpointGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionNetworkEndpointGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionNetworkEndpointGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionNetworkEndpointGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest";
                        };
    
                        return GetRegionNetworkEndpointGroupRequest;
                    })();
    
                    v1.GetRegionNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a GetRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] GetRegionNetworkFirewallPolicyRequest firewallPolicy
                         * @property {string|null} [project] GetRegionNetworkFirewallPolicyRequest project
                         * @property {string|null} [region] GetRegionNetworkFirewallPolicyRequest region
                         */
    
                        /**
                         * Constructs a new GetRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionNetworkFirewallPolicyRequest.
                         * @implements IGetRegionNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function GetRegionNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetRegionNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * GetRegionNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetRegionNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * GetRegionNetworkFirewallPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetRegionNetworkFirewallPolicyRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetRegionNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest} GetRegionNetworkFirewallPolicyRequest instance
                         */
                        GetRegionNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new GetRegionNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionNetworkFirewallPolicyRequest} message GetRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionNetworkFirewallPolicyRequest} message GetRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest} GetRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest} GetRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest} GetRegionNetworkFirewallPolicyRequest
                         */
                        GetRegionNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest} message GetRegionNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.firewallPolicy = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest";
                        };
    
                        return GetRegionNetworkFirewallPolicyRequest;
                    })();
    
                    v1.GetRegionNotificationEndpointRequest = (function() {
    
                        /**
                         * Properties of a GetRegionNotificationEndpointRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionNotificationEndpointRequest
                         * @property {string|null} [notificationEndpoint] GetRegionNotificationEndpointRequest notificationEndpoint
                         * @property {string|null} [project] GetRegionNotificationEndpointRequest project
                         * @property {string|null} [region] GetRegionNotificationEndpointRequest region
                         */
    
                        /**
                         * Constructs a new GetRegionNotificationEndpointRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionNotificationEndpointRequest.
                         * @implements IGetRegionNotificationEndpointRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionNotificationEndpointRequest=} [properties] Properties to set
                         */
                        function GetRegionNotificationEndpointRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionNotificationEndpointRequest notificationEndpoint.
                         * @member {string} notificationEndpoint
                         * @memberof google.cloud.compute.v1.GetRegionNotificationEndpointRequest
                         * @instance
                         */
                        GetRegionNotificationEndpointRequest.prototype.notificationEndpoint = "";
    
                        /**
                         * GetRegionNotificationEndpointRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionNotificationEndpointRequest
                         * @instance
                         */
                        GetRegionNotificationEndpointRequest.prototype.project = "";
    
                        /**
                         * GetRegionNotificationEndpointRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionNotificationEndpointRequest
                         * @instance
                         */
                        GetRegionNotificationEndpointRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetRegionNotificationEndpointRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionNotificationEndpointRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionNotificationEndpointRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionNotificationEndpointRequest} GetRegionNotificationEndpointRequest instance
                         */
                        GetRegionNotificationEndpointRequest.create = function create(properties) {
                            return new GetRegionNotificationEndpointRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionNotificationEndpointRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionNotificationEndpointRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionNotificationEndpointRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionNotificationEndpointRequest} message GetRegionNotificationEndpointRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionNotificationEndpointRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.notificationEndpoint != null && Object.hasOwnProperty.call(message, "notificationEndpoint"))
                                writer.uint32(/* id 376807017, wireType 2 =*/3014456138).string(message.notificationEndpoint);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionNotificationEndpointRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionNotificationEndpointRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionNotificationEndpointRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionNotificationEndpointRequest} message GetRegionNotificationEndpointRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionNotificationEndpointRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionNotificationEndpointRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionNotificationEndpointRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionNotificationEndpointRequest} GetRegionNotificationEndpointRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionNotificationEndpointRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionNotificationEndpointRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 376807017: {
                                        message.notificationEndpoint = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionNotificationEndpointRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionNotificationEndpointRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionNotificationEndpointRequest} GetRegionNotificationEndpointRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionNotificationEndpointRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionNotificationEndpointRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionNotificationEndpointRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionNotificationEndpointRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.notificationEndpoint != null && message.hasOwnProperty("notificationEndpoint"))
                                if (!$util.isString(message.notificationEndpoint))
                                    return "notificationEndpoint: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionNotificationEndpointRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionNotificationEndpointRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionNotificationEndpointRequest} GetRegionNotificationEndpointRequest
                         */
                        GetRegionNotificationEndpointRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionNotificationEndpointRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionNotificationEndpointRequest();
                            if (object.notificationEndpoint != null)
                                message.notificationEndpoint = String(object.notificationEndpoint);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionNotificationEndpointRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionNotificationEndpointRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionNotificationEndpointRequest} message GetRegionNotificationEndpointRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionNotificationEndpointRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.notificationEndpoint = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.notificationEndpoint != null && message.hasOwnProperty("notificationEndpoint"))
                                object.notificationEndpoint = message.notificationEndpoint;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionNotificationEndpointRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionNotificationEndpointRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionNotificationEndpointRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionNotificationEndpointRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionNotificationEndpointRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionNotificationEndpointRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionNotificationEndpointRequest";
                        };
    
                        return GetRegionNotificationEndpointRequest;
                    })();
    
                    v1.GetRegionOperationRequest = (function() {
    
                        /**
                         * Properties of a GetRegionOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionOperationRequest
                         * @property {string|null} [operation] GetRegionOperationRequest operation
                         * @property {string|null} [project] GetRegionOperationRequest project
                         * @property {string|null} [region] GetRegionOperationRequest region
                         */
    
                        /**
                         * Constructs a new GetRegionOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionOperationRequest.
                         * @implements IGetRegionOperationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionOperationRequest=} [properties] Properties to set
                         */
                        function GetRegionOperationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionOperationRequest operation.
                         * @member {string} operation
                         * @memberof google.cloud.compute.v1.GetRegionOperationRequest
                         * @instance
                         */
                        GetRegionOperationRequest.prototype.operation = "";
    
                        /**
                         * GetRegionOperationRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionOperationRequest
                         * @instance
                         */
                        GetRegionOperationRequest.prototype.project = "";
    
                        /**
                         * GetRegionOperationRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionOperationRequest
                         * @instance
                         */
                        GetRegionOperationRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetRegionOperationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionOperationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionOperationRequest} GetRegionOperationRequest instance
                         */
                        GetRegionOperationRequest.create = function create(properties) {
                            return new GetRegionOperationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionOperationRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionOperationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionOperationRequest} message GetRegionOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionOperationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operation != null && Object.hasOwnProperty.call(message, "operation"))
                                writer.uint32(/* id 52090215, wireType 2 =*/416721722).string(message.operation);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionOperationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionOperationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionOperationRequest} message GetRegionOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionOperationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionOperationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionOperationRequest} GetRegionOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionOperationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionOperationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 52090215: {
                                        message.operation = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionOperationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionOperationRequest} GetRegionOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionOperationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionOperationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionOperationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionOperationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                if (!$util.isString(message.operation))
                                    return "operation: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionOperationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionOperationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionOperationRequest} GetRegionOperationRequest
                         */
                        GetRegionOperationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionOperationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionOperationRequest();
                            if (object.operation != null)
                                message.operation = String(object.operation);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionOperationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionOperationRequest} message GetRegionOperationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionOperationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.operation = "";
                                object.region = "";
                                object.project = "";
                            }
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                object.operation = message.operation;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionOperationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionOperationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionOperationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionOperationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionOperationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionOperationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionOperationRequest";
                        };
    
                        return GetRegionOperationRequest;
                    })();
    
                    v1.GetRegionRequest = (function() {
    
                        /**
                         * Properties of a GetRegionRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionRequest
                         * @property {string|null} [project] GetRegionRequest project
                         * @property {string|null} [region] GetRegionRequest region
                         */
    
                        /**
                         * Constructs a new GetRegionRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionRequest.
                         * @implements IGetRegionRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionRequest=} [properties] Properties to set
                         */
                        function GetRegionRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionRequest
                         * @instance
                         */
                        GetRegionRequest.prototype.project = "";
    
                        /**
                         * GetRegionRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionRequest
                         * @instance
                         */
                        GetRegionRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetRegionRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionRequest} GetRegionRequest instance
                         */
                        GetRegionRequest.create = function create(properties) {
                            return new GetRegionRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionRequest} message GetRegionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionRequest} message GetRegionRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionRequest} GetRegionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionRequest} GetRegionRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionRequest} GetRegionRequest
                         */
                        GetRegionRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionRequest} message GetRegionRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionRequest";
                        };
    
                        return GetRegionRequest;
                    })();
    
                    v1.GetRegionSecurityPolicyRequest = (function() {
    
                        /**
                         * Properties of a GetRegionSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionSecurityPolicyRequest
                         * @property {string|null} [project] GetRegionSecurityPolicyRequest project
                         * @property {string|null} [region] GetRegionSecurityPolicyRequest region
                         * @property {string|null} [securityPolicy] GetRegionSecurityPolicyRequest securityPolicy
                         */
    
                        /**
                         * Constructs a new GetRegionSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionSecurityPolicyRequest.
                         * @implements IGetRegionSecurityPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionSecurityPolicyRequest=} [properties] Properties to set
                         */
                        function GetRegionSecurityPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionSecurityPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionSecurityPolicyRequest
                         * @instance
                         */
                        GetRegionSecurityPolicyRequest.prototype.project = "";
    
                        /**
                         * GetRegionSecurityPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionSecurityPolicyRequest
                         * @instance
                         */
                        GetRegionSecurityPolicyRequest.prototype.region = "";
    
                        /**
                         * GetRegionSecurityPolicyRequest securityPolicy.
                         * @member {string} securityPolicy
                         * @memberof google.cloud.compute.v1.GetRegionSecurityPolicyRequest
                         * @instance
                         */
                        GetRegionSecurityPolicyRequest.prototype.securityPolicy = "";
    
                        /**
                         * Creates a new GetRegionSecurityPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionSecurityPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionSecurityPolicyRequest} GetRegionSecurityPolicyRequest instance
                         */
                        GetRegionSecurityPolicyRequest.create = function create(properties) {
                            return new GetRegionSecurityPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionSecurityPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionSecurityPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionSecurityPolicyRequest} message GetRegionSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionSecurityPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.securityPolicy != null && Object.hasOwnProperty.call(message, "securityPolicy"))
                                writer.uint32(/* id 171082513, wireType 2 =*/1368660106).string(message.securityPolicy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionSecurityPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionSecurityPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionSecurityPolicyRequest} message GetRegionSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionSecurityPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionSecurityPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionSecurityPolicyRequest} GetRegionSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionSecurityPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionSecurityPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 171082513: {
                                        message.securityPolicy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionSecurityPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionSecurityPolicyRequest} GetRegionSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionSecurityPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionSecurityPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionSecurityPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy"))
                                if (!$util.isString(message.securityPolicy))
                                    return "securityPolicy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionSecurityPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionSecurityPolicyRequest} GetRegionSecurityPolicyRequest
                         */
                        GetRegionSecurityPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionSecurityPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionSecurityPolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.securityPolicy != null)
                                message.securityPolicy = String(object.securityPolicy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionSecurityPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionSecurityPolicyRequest} message GetRegionSecurityPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionSecurityPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.securityPolicy = "";
                                object.project = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy"))
                                object.securityPolicy = message.securityPolicy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionSecurityPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionSecurityPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionSecurityPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionSecurityPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionSecurityPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionSecurityPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionSecurityPolicyRequest";
                        };
    
                        return GetRegionSecurityPolicyRequest;
                    })();
    
                    v1.GetRegionSslCertificateRequest = (function() {
    
                        /**
                         * Properties of a GetRegionSslCertificateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionSslCertificateRequest
                         * @property {string|null} [project] GetRegionSslCertificateRequest project
                         * @property {string|null} [region] GetRegionSslCertificateRequest region
                         * @property {string|null} [sslCertificate] GetRegionSslCertificateRequest sslCertificate
                         */
    
                        /**
                         * Constructs a new GetRegionSslCertificateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionSslCertificateRequest.
                         * @implements IGetRegionSslCertificateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionSslCertificateRequest=} [properties] Properties to set
                         */
                        function GetRegionSslCertificateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionSslCertificateRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionSslCertificateRequest
                         * @instance
                         */
                        GetRegionSslCertificateRequest.prototype.project = "";
    
                        /**
                         * GetRegionSslCertificateRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionSslCertificateRequest
                         * @instance
                         */
                        GetRegionSslCertificateRequest.prototype.region = "";
    
                        /**
                         * GetRegionSslCertificateRequest sslCertificate.
                         * @member {string} sslCertificate
                         * @memberof google.cloud.compute.v1.GetRegionSslCertificateRequest
                         * @instance
                         */
                        GetRegionSslCertificateRequest.prototype.sslCertificate = "";
    
                        /**
                         * Creates a new GetRegionSslCertificateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionSslCertificateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionSslCertificateRequest} GetRegionSslCertificateRequest instance
                         */
                        GetRegionSslCertificateRequest.create = function create(properties) {
                            return new GetRegionSslCertificateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionSslCertificateRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionSslCertificateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionSslCertificateRequest} message GetRegionSslCertificateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionSslCertificateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.sslCertificate != null && Object.hasOwnProperty.call(message, "sslCertificate"))
                                writer.uint32(/* id 46443492, wireType 2 =*/371547938).string(message.sslCertificate);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionSslCertificateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionSslCertificateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionSslCertificateRequest} message GetRegionSslCertificateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionSslCertificateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionSslCertificateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionSslCertificateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionSslCertificateRequest} GetRegionSslCertificateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionSslCertificateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionSslCertificateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 46443492: {
                                        message.sslCertificate = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionSslCertificateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionSslCertificateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionSslCertificateRequest} GetRegionSslCertificateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionSslCertificateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionSslCertificateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionSslCertificateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionSslCertificateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.sslCertificate != null && message.hasOwnProperty("sslCertificate"))
                                if (!$util.isString(message.sslCertificate))
                                    return "sslCertificate: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionSslCertificateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionSslCertificateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionSslCertificateRequest} GetRegionSslCertificateRequest
                         */
                        GetRegionSslCertificateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionSslCertificateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionSslCertificateRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.sslCertificate != null)
                                message.sslCertificate = String(object.sslCertificate);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionSslCertificateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionSslCertificateRequest} message GetRegionSslCertificateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionSslCertificateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.sslCertificate = "";
                                object.region = "";
                                object.project = "";
                            }
                            if (message.sslCertificate != null && message.hasOwnProperty("sslCertificate"))
                                object.sslCertificate = message.sslCertificate;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionSslCertificateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionSslCertificateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionSslCertificateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionSslCertificateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionSslCertificateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionSslCertificateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionSslCertificateRequest";
                        };
    
                        return GetRegionSslCertificateRequest;
                    })();
    
                    v1.GetRegionSslPolicyRequest = (function() {
    
                        /**
                         * Properties of a GetRegionSslPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionSslPolicyRequest
                         * @property {string|null} [project] GetRegionSslPolicyRequest project
                         * @property {string|null} [region] GetRegionSslPolicyRequest region
                         * @property {string|null} [sslPolicy] GetRegionSslPolicyRequest sslPolicy
                         */
    
                        /**
                         * Constructs a new GetRegionSslPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionSslPolicyRequest.
                         * @implements IGetRegionSslPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionSslPolicyRequest=} [properties] Properties to set
                         */
                        function GetRegionSslPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionSslPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionSslPolicyRequest
                         * @instance
                         */
                        GetRegionSslPolicyRequest.prototype.project = "";
    
                        /**
                         * GetRegionSslPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionSslPolicyRequest
                         * @instance
                         */
                        GetRegionSslPolicyRequest.prototype.region = "";
    
                        /**
                         * GetRegionSslPolicyRequest sslPolicy.
                         * @member {string} sslPolicy
                         * @memberof google.cloud.compute.v1.GetRegionSslPolicyRequest
                         * @instance
                         */
                        GetRegionSslPolicyRequest.prototype.sslPolicy = "";
    
                        /**
                         * Creates a new GetRegionSslPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionSslPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionSslPolicyRequest} GetRegionSslPolicyRequest instance
                         */
                        GetRegionSslPolicyRequest.create = function create(properties) {
                            return new GetRegionSslPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionSslPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionSslPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionSslPolicyRequest} message GetRegionSslPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionSslPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.sslPolicy != null && Object.hasOwnProperty.call(message, "sslPolicy"))
                                writer.uint32(/* id 295190213, wireType 2 =*/2361521706).string(message.sslPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionSslPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionSslPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionSslPolicyRequest} message GetRegionSslPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionSslPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionSslPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionSslPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionSslPolicyRequest} GetRegionSslPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionSslPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionSslPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 295190213: {
                                        message.sslPolicy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionSslPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionSslPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionSslPolicyRequest} GetRegionSslPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionSslPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionSslPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionSslPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionSslPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.sslPolicy != null && message.hasOwnProperty("sslPolicy"))
                                if (!$util.isString(message.sslPolicy))
                                    return "sslPolicy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionSslPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionSslPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionSslPolicyRequest} GetRegionSslPolicyRequest
                         */
                        GetRegionSslPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionSslPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionSslPolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.sslPolicy != null)
                                message.sslPolicy = String(object.sslPolicy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionSslPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionSslPolicyRequest} message GetRegionSslPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionSslPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.sslPolicy = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.sslPolicy != null && message.hasOwnProperty("sslPolicy"))
                                object.sslPolicy = message.sslPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionSslPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionSslPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionSslPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionSslPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionSslPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionSslPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionSslPolicyRequest";
                        };
    
                        return GetRegionSslPolicyRequest;
                    })();
    
                    v1.GetRegionTargetHttpProxyRequest = (function() {
    
                        /**
                         * Properties of a GetRegionTargetHttpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionTargetHttpProxyRequest
                         * @property {string|null} [project] GetRegionTargetHttpProxyRequest project
                         * @property {string|null} [region] GetRegionTargetHttpProxyRequest region
                         * @property {string|null} [targetHttpProxy] GetRegionTargetHttpProxyRequest targetHttpProxy
                         */
    
                        /**
                         * Constructs a new GetRegionTargetHttpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionTargetHttpProxyRequest.
                         * @implements IGetRegionTargetHttpProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionTargetHttpProxyRequest=} [properties] Properties to set
                         */
                        function GetRegionTargetHttpProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionTargetHttpProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpProxyRequest
                         * @instance
                         */
                        GetRegionTargetHttpProxyRequest.prototype.project = "";
    
                        /**
                         * GetRegionTargetHttpProxyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpProxyRequest
                         * @instance
                         */
                        GetRegionTargetHttpProxyRequest.prototype.region = "";
    
                        /**
                         * GetRegionTargetHttpProxyRequest targetHttpProxy.
                         * @member {string} targetHttpProxy
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpProxyRequest
                         * @instance
                         */
                        GetRegionTargetHttpProxyRequest.prototype.targetHttpProxy = "";
    
                        /**
                         * Creates a new GetRegionTargetHttpProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionTargetHttpProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionTargetHttpProxyRequest} GetRegionTargetHttpProxyRequest instance
                         */
                        GetRegionTargetHttpProxyRequest.create = function create(properties) {
                            return new GetRegionTargetHttpProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionTargetHttpProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionTargetHttpProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionTargetHttpProxyRequest} message GetRegionTargetHttpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionTargetHttpProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.targetHttpProxy != null && Object.hasOwnProperty.call(message, "targetHttpProxy"))
                                writer.uint32(/* id 206872421, wireType 2 =*/1654979370).string(message.targetHttpProxy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionTargetHttpProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionTargetHttpProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionTargetHttpProxyRequest} message GetRegionTargetHttpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionTargetHttpProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionTargetHttpProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionTargetHttpProxyRequest} GetRegionTargetHttpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionTargetHttpProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionTargetHttpProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 206872421: {
                                        message.targetHttpProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionTargetHttpProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionTargetHttpProxyRequest} GetRegionTargetHttpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionTargetHttpProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionTargetHttpProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionTargetHttpProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.targetHttpProxy != null && message.hasOwnProperty("targetHttpProxy"))
                                if (!$util.isString(message.targetHttpProxy))
                                    return "targetHttpProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionTargetHttpProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionTargetHttpProxyRequest} GetRegionTargetHttpProxyRequest
                         */
                        GetRegionTargetHttpProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionTargetHttpProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionTargetHttpProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.targetHttpProxy != null)
                                message.targetHttpProxy = String(object.targetHttpProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionTargetHttpProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionTargetHttpProxyRequest} message GetRegionTargetHttpProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionTargetHttpProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.targetHttpProxy = "";
                                object.project = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.targetHttpProxy != null && message.hasOwnProperty("targetHttpProxy"))
                                object.targetHttpProxy = message.targetHttpProxy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionTargetHttpProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionTargetHttpProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionTargetHttpProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionTargetHttpProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionTargetHttpProxyRequest";
                        };
    
                        return GetRegionTargetHttpProxyRequest;
                    })();
    
                    v1.GetRegionTargetHttpsProxyRequest = (function() {
    
                        /**
                         * Properties of a GetRegionTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionTargetHttpsProxyRequest
                         * @property {string|null} [project] GetRegionTargetHttpsProxyRequest project
                         * @property {string|null} [region] GetRegionTargetHttpsProxyRequest region
                         * @property {string|null} [targetHttpsProxy] GetRegionTargetHttpsProxyRequest targetHttpsProxy
                         */
    
                        /**
                         * Constructs a new GetRegionTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionTargetHttpsProxyRequest.
                         * @implements IGetRegionTargetHttpsProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionTargetHttpsProxyRequest=} [properties] Properties to set
                         */
                        function GetRegionTargetHttpsProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionTargetHttpsProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        GetRegionTargetHttpsProxyRequest.prototype.project = "";
    
                        /**
                         * GetRegionTargetHttpsProxyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        GetRegionTargetHttpsProxyRequest.prototype.region = "";
    
                        /**
                         * GetRegionTargetHttpsProxyRequest targetHttpsProxy.
                         * @member {string} targetHttpsProxy
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        GetRegionTargetHttpsProxyRequest.prototype.targetHttpsProxy = "";
    
                        /**
                         * Creates a new GetRegionTargetHttpsProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionTargetHttpsProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest} GetRegionTargetHttpsProxyRequest instance
                         */
                        GetRegionTargetHttpsProxyRequest.create = function create(properties) {
                            return new GetRegionTargetHttpsProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionTargetHttpsProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionTargetHttpsProxyRequest} message GetRegionTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionTargetHttpsProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetHttpsProxy != null && Object.hasOwnProperty.call(message, "targetHttpsProxy"))
                                writer.uint32(/* id 52336748, wireType 2 =*/418693986).string(message.targetHttpsProxy);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionTargetHttpsProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionTargetHttpsProxyRequest} message GetRegionTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionTargetHttpsProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionTargetHttpsProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest} GetRegionTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionTargetHttpsProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 52336748: {
                                        message.targetHttpsProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionTargetHttpsProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest} GetRegionTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionTargetHttpsProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionTargetHttpsProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionTargetHttpsProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                if (!$util.isString(message.targetHttpsProxy))
                                    return "targetHttpsProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionTargetHttpsProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest} GetRegionTargetHttpsProxyRequest
                         */
                        GetRegionTargetHttpsProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.targetHttpsProxy != null)
                                message.targetHttpsProxy = String(object.targetHttpsProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionTargetHttpsProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest} message GetRegionTargetHttpsProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionTargetHttpsProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetHttpsProxy = "";
                                object.region = "";
                                object.project = "";
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                object.targetHttpsProxy = message.targetHttpsProxy;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionTargetHttpsProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionTargetHttpsProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionTargetHttpsProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionTargetHttpsProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest";
                        };
    
                        return GetRegionTargetHttpsProxyRequest;
                    })();
    
                    v1.GetRegionTargetTcpProxyRequest = (function() {
    
                        /**
                         * Properties of a GetRegionTargetTcpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionTargetTcpProxyRequest
                         * @property {string|null} [project] GetRegionTargetTcpProxyRequest project
                         * @property {string|null} [region] GetRegionTargetTcpProxyRequest region
                         * @property {string|null} [targetTcpProxy] GetRegionTargetTcpProxyRequest targetTcpProxy
                         */
    
                        /**
                         * Constructs a new GetRegionTargetTcpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionTargetTcpProxyRequest.
                         * @implements IGetRegionTargetTcpProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionTargetTcpProxyRequest=} [properties] Properties to set
                         */
                        function GetRegionTargetTcpProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionTargetTcpProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionTargetTcpProxyRequest
                         * @instance
                         */
                        GetRegionTargetTcpProxyRequest.prototype.project = "";
    
                        /**
                         * GetRegionTargetTcpProxyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionTargetTcpProxyRequest
                         * @instance
                         */
                        GetRegionTargetTcpProxyRequest.prototype.region = "";
    
                        /**
                         * GetRegionTargetTcpProxyRequest targetTcpProxy.
                         * @member {string} targetTcpProxy
                         * @memberof google.cloud.compute.v1.GetRegionTargetTcpProxyRequest
                         * @instance
                         */
                        GetRegionTargetTcpProxyRequest.prototype.targetTcpProxy = "";
    
                        /**
                         * Creates a new GetRegionTargetTcpProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionTargetTcpProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionTargetTcpProxyRequest} GetRegionTargetTcpProxyRequest instance
                         */
                        GetRegionTargetTcpProxyRequest.create = function create(properties) {
                            return new GetRegionTargetTcpProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionTargetTcpProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionTargetTcpProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionTargetTcpProxyRequest} message GetRegionTargetTcpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionTargetTcpProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetTcpProxy != null && Object.hasOwnProperty.call(message, "targetTcpProxy"))
                                writer.uint32(/* id 503065442, wireType 2 =*/4024523538).string(message.targetTcpProxy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionTargetTcpProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionTargetTcpProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionTargetTcpProxyRequest} message GetRegionTargetTcpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionTargetTcpProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionTargetTcpProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionTargetTcpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionTargetTcpProxyRequest} GetRegionTargetTcpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionTargetTcpProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionTargetTcpProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 503065442: {
                                        message.targetTcpProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionTargetTcpProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionTargetTcpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionTargetTcpProxyRequest} GetRegionTargetTcpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionTargetTcpProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionTargetTcpProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionTargetTcpProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionTargetTcpProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.targetTcpProxy != null && message.hasOwnProperty("targetTcpProxy"))
                                if (!$util.isString(message.targetTcpProxy))
                                    return "targetTcpProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionTargetTcpProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionTargetTcpProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionTargetTcpProxyRequest} GetRegionTargetTcpProxyRequest
                         */
                        GetRegionTargetTcpProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionTargetTcpProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionTargetTcpProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.targetTcpProxy != null)
                                message.targetTcpProxy = String(object.targetTcpProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionTargetTcpProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionTargetTcpProxyRequest} message GetRegionTargetTcpProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionTargetTcpProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.targetTcpProxy = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetTcpProxy != null && message.hasOwnProperty("targetTcpProxy"))
                                object.targetTcpProxy = message.targetTcpProxy;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionTargetTcpProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionTargetTcpProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionTargetTcpProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionTargetTcpProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionTargetTcpProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionTargetTcpProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionTargetTcpProxyRequest";
                        };
    
                        return GetRegionTargetTcpProxyRequest;
                    })();
    
                    v1.GetRegionUrlMapRequest = (function() {
    
                        /**
                         * Properties of a GetRegionUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRegionUrlMapRequest
                         * @property {string|null} [project] GetRegionUrlMapRequest project
                         * @property {string|null} [region] GetRegionUrlMapRequest region
                         * @property {string|null} [urlMap] GetRegionUrlMapRequest urlMap
                         */
    
                        /**
                         * Constructs a new GetRegionUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRegionUrlMapRequest.
                         * @implements IGetRegionUrlMapRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRegionUrlMapRequest=} [properties] Properties to set
                         */
                        function GetRegionUrlMapRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionUrlMapRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRegionUrlMapRequest
                         * @instance
                         */
                        GetRegionUrlMapRequest.prototype.project = "";
    
                        /**
                         * GetRegionUrlMapRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRegionUrlMapRequest
                         * @instance
                         */
                        GetRegionUrlMapRequest.prototype.region = "";
    
                        /**
                         * GetRegionUrlMapRequest urlMap.
                         * @member {string} urlMap
                         * @memberof google.cloud.compute.v1.GetRegionUrlMapRequest
                         * @instance
                         */
                        GetRegionUrlMapRequest.prototype.urlMap = "";
    
                        /**
                         * Creates a new GetRegionUrlMapRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionUrlMapRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRegionUrlMapRequest} GetRegionUrlMapRequest instance
                         */
                        GetRegionUrlMapRequest.create = function create(properties) {
                            return new GetRegionUrlMapRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionUrlMapRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRegionUrlMapRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionUrlMapRequest} message GetRegionUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionUrlMapRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.urlMap != null && Object.hasOwnProperty.call(message, "urlMap"))
                                writer.uint32(/* id 367020684, wireType 2 =*/2936165474).string(message.urlMap);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionUrlMapRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRegionUrlMapRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRegionUrlMapRequest} message GetRegionUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionUrlMapRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionUrlMapRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRegionUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRegionUrlMapRequest} GetRegionUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionUrlMapRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRegionUrlMapRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 367020684: {
                                        message.urlMap = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionUrlMapRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRegionUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRegionUrlMapRequest} GetRegionUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionUrlMapRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionUrlMapRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRegionUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionUrlMapRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                if (!$util.isString(message.urlMap))
                                    return "urlMap: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionUrlMapRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRegionUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRegionUrlMapRequest} GetRegionUrlMapRequest
                         */
                        GetRegionUrlMapRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRegionUrlMapRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRegionUrlMapRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.urlMap != null)
                                message.urlMap = String(object.urlMap);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionUrlMapRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRegionUrlMapRequest} message GetRegionUrlMapRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionUrlMapRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.urlMap = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                object.urlMap = message.urlMap;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionUrlMapRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRegionUrlMapRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionUrlMapRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionUrlMapRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRegionUrlMapRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionUrlMapRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRegionUrlMapRequest";
                        };
    
                        return GetRegionUrlMapRequest;
                    })();
    
                    v1.GetReservationRequest = (function() {
    
                        /**
                         * Properties of a GetReservationRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetReservationRequest
                         * @property {string|null} [project] GetReservationRequest project
                         * @property {string|null} [reservation] GetReservationRequest reservation
                         * @property {string|null} [zone] GetReservationRequest zone
                         */
    
                        /**
                         * Constructs a new GetReservationRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetReservationRequest.
                         * @implements IGetReservationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetReservationRequest=} [properties] Properties to set
                         */
                        function GetReservationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetReservationRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetReservationRequest
                         * @instance
                         */
                        GetReservationRequest.prototype.project = "";
    
                        /**
                         * GetReservationRequest reservation.
                         * @member {string} reservation
                         * @memberof google.cloud.compute.v1.GetReservationRequest
                         * @instance
                         */
                        GetReservationRequest.prototype.reservation = "";
    
                        /**
                         * GetReservationRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetReservationRequest
                         * @instance
                         */
                        GetReservationRequest.prototype.zone = "";
    
                        /**
                         * Creates a new GetReservationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetReservationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetReservationRequest} GetReservationRequest instance
                         */
                        GetReservationRequest.create = function create(properties) {
                            return new GetReservationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetReservationRequest message. Does not implicitly {@link google.cloud.compute.v1.GetReservationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetReservationRequest} message GetReservationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetReservationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.reservation != null && Object.hasOwnProperty.call(message, "reservation"))
                                writer.uint32(/* id 47530956, wireType 2 =*/380247650).string(message.reservation);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetReservationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetReservationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetReservationRequest} message GetReservationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetReservationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetReservationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetReservationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetReservationRequest} GetReservationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetReservationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetReservationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 47530956: {
                                        message.reservation = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetReservationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetReservationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetReservationRequest} GetReservationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetReservationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetReservationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetReservationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetReservationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.reservation != null && message.hasOwnProperty("reservation"))
                                if (!$util.isString(message.reservation))
                                    return "reservation: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetReservationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetReservationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetReservationRequest} GetReservationRequest
                         */
                        GetReservationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetReservationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetReservationRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.reservation != null)
                                message.reservation = String(object.reservation);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetReservationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetReservationRequest} message GetReservationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetReservationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.reservation = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.reservation != null && message.hasOwnProperty("reservation"))
                                object.reservation = message.reservation;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetReservationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetReservationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetReservationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetReservationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetReservationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetReservationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetReservationRequest";
                        };
    
                        return GetReservationRequest;
                    })();
    
                    v1.GetResourcePolicyRequest = (function() {
    
                        /**
                         * Properties of a GetResourcePolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetResourcePolicyRequest
                         * @property {string|null} [project] GetResourcePolicyRequest project
                         * @property {string|null} [region] GetResourcePolicyRequest region
                         * @property {string|null} [resourcePolicy] GetResourcePolicyRequest resourcePolicy
                         */
    
                        /**
                         * Constructs a new GetResourcePolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetResourcePolicyRequest.
                         * @implements IGetResourcePolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetResourcePolicyRequest=} [properties] Properties to set
                         */
                        function GetResourcePolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetResourcePolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetResourcePolicyRequest
                         * @instance
                         */
                        GetResourcePolicyRequest.prototype.project = "";
    
                        /**
                         * GetResourcePolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetResourcePolicyRequest
                         * @instance
                         */
                        GetResourcePolicyRequest.prototype.region = "";
    
                        /**
                         * GetResourcePolicyRequest resourcePolicy.
                         * @member {string} resourcePolicy
                         * @memberof google.cloud.compute.v1.GetResourcePolicyRequest
                         * @instance
                         */
                        GetResourcePolicyRequest.prototype.resourcePolicy = "";
    
                        /**
                         * Creates a new GetResourcePolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetResourcePolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetResourcePolicyRequest} GetResourcePolicyRequest instance
                         */
                        GetResourcePolicyRequest.create = function create(properties) {
                            return new GetResourcePolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetResourcePolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetResourcePolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetResourcePolicyRequest} message GetResourcePolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetResourcePolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resourcePolicy != null && Object.hasOwnProperty.call(message, "resourcePolicy"))
                                writer.uint32(/* id 159240835, wireType 2 =*/1273926682).string(message.resourcePolicy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetResourcePolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetResourcePolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetResourcePolicyRequest} message GetResourcePolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetResourcePolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetResourcePolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetResourcePolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetResourcePolicyRequest} GetResourcePolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetResourcePolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetResourcePolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 159240835: {
                                        message.resourcePolicy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetResourcePolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetResourcePolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetResourcePolicyRequest} GetResourcePolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetResourcePolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetResourcePolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetResourcePolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetResourcePolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.resourcePolicy != null && message.hasOwnProperty("resourcePolicy"))
                                if (!$util.isString(message.resourcePolicy))
                                    return "resourcePolicy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetResourcePolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetResourcePolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetResourcePolicyRequest} GetResourcePolicyRequest
                         */
                        GetResourcePolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetResourcePolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetResourcePolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.resourcePolicy != null)
                                message.resourcePolicy = String(object.resourcePolicy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetResourcePolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetResourcePolicyRequest} message GetResourcePolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetResourcePolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resourcePolicy = "";
                                object.project = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resourcePolicy != null && message.hasOwnProperty("resourcePolicy"))
                                object.resourcePolicy = message.resourcePolicy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetResourcePolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetResourcePolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetResourcePolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetResourcePolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetResourcePolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetResourcePolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetResourcePolicyRequest";
                        };
    
                        return GetResourcePolicyRequest;
                    })();
    
                    v1.GetRouteRequest = (function() {
    
                        /**
                         * Properties of a GetRouteRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRouteRequest
                         * @property {string|null} [project] GetRouteRequest project
                         * @property {string|null} [route] GetRouteRequest route
                         */
    
                        /**
                         * Constructs a new GetRouteRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRouteRequest.
                         * @implements IGetRouteRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRouteRequest=} [properties] Properties to set
                         */
                        function GetRouteRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRouteRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRouteRequest
                         * @instance
                         */
                        GetRouteRequest.prototype.project = "";
    
                        /**
                         * GetRouteRequest route.
                         * @member {string} route
                         * @memberof google.cloud.compute.v1.GetRouteRequest
                         * @instance
                         */
                        GetRouteRequest.prototype.route = "";
    
                        /**
                         * Creates a new GetRouteRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRouteRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRouteRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRouteRequest} GetRouteRequest instance
                         */
                        GetRouteRequest.create = function create(properties) {
                            return new GetRouteRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRouteRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRouteRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRouteRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRouteRequest} message GetRouteRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRouteRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.route != null && Object.hasOwnProperty.call(message, "route"))
                                writer.uint32(/* id 108704329, wireType 2 =*/869634634).string(message.route);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRouteRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRouteRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRouteRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRouteRequest} message GetRouteRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRouteRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRouteRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRouteRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRouteRequest} GetRouteRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRouteRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRouteRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 108704329: {
                                        message.route = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRouteRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRouteRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRouteRequest} GetRouteRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRouteRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRouteRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRouteRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRouteRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.route != null && message.hasOwnProperty("route"))
                                if (!$util.isString(message.route))
                                    return "route: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRouteRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRouteRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRouteRequest} GetRouteRequest
                         */
                        GetRouteRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRouteRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRouteRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.route != null)
                                message.route = String(object.route);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRouteRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRouteRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRouteRequest} message GetRouteRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRouteRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.route = "";
                                object.project = "";
                            }
                            if (message.route != null && message.hasOwnProperty("route"))
                                object.route = message.route;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetRouteRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRouteRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRouteRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRouteRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRouteRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRouteRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRouteRequest";
                        };
    
                        return GetRouteRequest;
                    })();
    
                    v1.GetRouterRequest = (function() {
    
                        /**
                         * Properties of a GetRouterRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRouterRequest
                         * @property {string|null} [project] GetRouterRequest project
                         * @property {string|null} [region] GetRouterRequest region
                         * @property {string|null} [router] GetRouterRequest router
                         */
    
                        /**
                         * Constructs a new GetRouterRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRouterRequest.
                         * @implements IGetRouterRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRouterRequest=} [properties] Properties to set
                         */
                        function GetRouterRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRouterRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRouterRequest
                         * @instance
                         */
                        GetRouterRequest.prototype.project = "";
    
                        /**
                         * GetRouterRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRouterRequest
                         * @instance
                         */
                        GetRouterRequest.prototype.region = "";
    
                        /**
                         * GetRouterRequest router.
                         * @member {string} router
                         * @memberof google.cloud.compute.v1.GetRouterRequest
                         * @instance
                         */
                        GetRouterRequest.prototype.router = "";
    
                        /**
                         * Creates a new GetRouterRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRouterRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRouterRequest} GetRouterRequest instance
                         */
                        GetRouterRequest.create = function create(properties) {
                            return new GetRouterRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRouterRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRouterRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRouterRequest} message GetRouterRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRouterRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.router != null && Object.hasOwnProperty.call(message, "router"))
                                writer.uint32(/* id 148608841, wireType 2 =*/1188870730).string(message.router);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRouterRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRouterRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRouterRequest} message GetRouterRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRouterRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRouterRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRouterRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRouterRequest} GetRouterRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRouterRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRouterRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 148608841: {
                                        message.router = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRouterRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRouterRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRouterRequest} GetRouterRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRouterRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRouterRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRouterRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRouterRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.router != null && message.hasOwnProperty("router"))
                                if (!$util.isString(message.router))
                                    return "router: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRouterRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRouterRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRouterRequest} GetRouterRequest
                         */
                        GetRouterRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRouterRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRouterRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.router != null)
                                message.router = String(object.router);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRouterRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRouterRequest} message GetRouterRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRouterRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.router = "";
                                object.project = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.router != null && message.hasOwnProperty("router"))
                                object.router = message.router;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetRouterRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRouterRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRouterRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRouterRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRouterRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRouterRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRouterRequest";
                        };
    
                        return GetRouterRequest;
                    })();
    
                    v1.GetRouterStatusRouterRequest = (function() {
    
                        /**
                         * Properties of a GetRouterStatusRouterRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRouterStatusRouterRequest
                         * @property {string|null} [project] GetRouterStatusRouterRequest project
                         * @property {string|null} [region] GetRouterStatusRouterRequest region
                         * @property {string|null} [router] GetRouterStatusRouterRequest router
                         */
    
                        /**
                         * Constructs a new GetRouterStatusRouterRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRouterStatusRouterRequest.
                         * @implements IGetRouterStatusRouterRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRouterStatusRouterRequest=} [properties] Properties to set
                         */
                        function GetRouterStatusRouterRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRouterStatusRouterRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRouterStatusRouterRequest
                         * @instance
                         */
                        GetRouterStatusRouterRequest.prototype.project = "";
    
                        /**
                         * GetRouterStatusRouterRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRouterStatusRouterRequest
                         * @instance
                         */
                        GetRouterStatusRouterRequest.prototype.region = "";
    
                        /**
                         * GetRouterStatusRouterRequest router.
                         * @member {string} router
                         * @memberof google.cloud.compute.v1.GetRouterStatusRouterRequest
                         * @instance
                         */
                        GetRouterStatusRouterRequest.prototype.router = "";
    
                        /**
                         * Creates a new GetRouterStatusRouterRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRouterStatusRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRouterStatusRouterRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRouterStatusRouterRequest} GetRouterStatusRouterRequest instance
                         */
                        GetRouterStatusRouterRequest.create = function create(properties) {
                            return new GetRouterStatusRouterRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRouterStatusRouterRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRouterStatusRouterRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRouterStatusRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRouterStatusRouterRequest} message GetRouterStatusRouterRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRouterStatusRouterRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.router != null && Object.hasOwnProperty.call(message, "router"))
                                writer.uint32(/* id 148608841, wireType 2 =*/1188870730).string(message.router);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRouterStatusRouterRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRouterStatusRouterRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRouterStatusRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRouterStatusRouterRequest} message GetRouterStatusRouterRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRouterStatusRouterRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRouterStatusRouterRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRouterStatusRouterRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRouterStatusRouterRequest} GetRouterStatusRouterRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRouterStatusRouterRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRouterStatusRouterRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 148608841: {
                                        message.router = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRouterStatusRouterRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRouterStatusRouterRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRouterStatusRouterRequest} GetRouterStatusRouterRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRouterStatusRouterRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRouterStatusRouterRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRouterStatusRouterRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRouterStatusRouterRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.router != null && message.hasOwnProperty("router"))
                                if (!$util.isString(message.router))
                                    return "router: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRouterStatusRouterRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRouterStatusRouterRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRouterStatusRouterRequest} GetRouterStatusRouterRequest
                         */
                        GetRouterStatusRouterRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRouterStatusRouterRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRouterStatusRouterRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.router != null)
                                message.router = String(object.router);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRouterStatusRouterRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRouterStatusRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRouterStatusRouterRequest} message GetRouterStatusRouterRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRouterStatusRouterRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.router = "";
                                object.project = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.router != null && message.hasOwnProperty("router"))
                                object.router = message.router;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetRouterStatusRouterRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRouterStatusRouterRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRouterStatusRouterRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRouterStatusRouterRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRouterStatusRouterRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRouterStatusRouterRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRouterStatusRouterRequest";
                        };
    
                        return GetRouterStatusRouterRequest;
                    })();
    
                    v1.GetRuleFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a GetRuleFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRuleFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] GetRuleFirewallPolicyRequest firewallPolicy
                         * @property {number|null} [priority] GetRuleFirewallPolicyRequest priority
                         */
    
                        /**
                         * Constructs a new GetRuleFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRuleFirewallPolicyRequest.
                         * @implements IGetRuleFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRuleFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function GetRuleFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRuleFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.GetRuleFirewallPolicyRequest
                         * @instance
                         */
                        GetRuleFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * GetRuleFirewallPolicyRequest priority.
                         * @member {number|null|undefined} priority
                         * @memberof google.cloud.compute.v1.GetRuleFirewallPolicyRequest
                         * @instance
                         */
                        GetRuleFirewallPolicyRequest.prototype.priority = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetRuleFirewallPolicyRequest _priority.
                         * @member {"priority"|undefined} _priority
                         * @memberof google.cloud.compute.v1.GetRuleFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(GetRuleFirewallPolicyRequest.prototype, "_priority", {
                            get: $util.oneOfGetter($oneOfFields = ["priority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetRuleFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRuleFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRuleFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRuleFirewallPolicyRequest} GetRuleFirewallPolicyRequest instance
                         */
                        GetRuleFirewallPolicyRequest.create = function create(properties) {
                            return new GetRuleFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRuleFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRuleFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRuleFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRuleFirewallPolicyRequest} message GetRuleFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRuleFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.priority != null && Object.hasOwnProperty.call(message, "priority"))
                                writer.uint32(/* id 445151652, wireType 0 =*/3561213216).int32(message.priority);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRuleFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRuleFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRuleFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRuleFirewallPolicyRequest} message GetRuleFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRuleFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRuleFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRuleFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRuleFirewallPolicyRequest} GetRuleFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRuleFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRuleFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 445151652: {
                                        message.priority = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRuleFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRuleFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRuleFirewallPolicyRequest} GetRuleFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRuleFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRuleFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRuleFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRuleFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                properties._priority = 1;
                                if (!$util.isInteger(message.priority))
                                    return "priority: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a GetRuleFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRuleFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRuleFirewallPolicyRequest} GetRuleFirewallPolicyRequest
                         */
                        GetRuleFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRuleFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRuleFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.priority != null)
                                message.priority = object.priority | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRuleFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRuleFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRuleFirewallPolicyRequest} message GetRuleFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRuleFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.firewallPolicy = "";
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                object.priority = message.priority;
                                if (options.oneofs)
                                    object._priority = "priority";
                            }
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this GetRuleFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRuleFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRuleFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRuleFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRuleFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRuleFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRuleFirewallPolicyRequest";
                        };
    
                        return GetRuleFirewallPolicyRequest;
                    })();
    
                    v1.GetRuleNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a GetRuleNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRuleNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] GetRuleNetworkFirewallPolicyRequest firewallPolicy
                         * @property {number|null} [priority] GetRuleNetworkFirewallPolicyRequest priority
                         * @property {string|null} [project] GetRuleNetworkFirewallPolicyRequest project
                         */
    
                        /**
                         * Constructs a new GetRuleNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRuleNetworkFirewallPolicyRequest.
                         * @implements IGetRuleNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRuleNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function GetRuleNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRuleNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetRuleNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * GetRuleNetworkFirewallPolicyRequest priority.
                         * @member {number|null|undefined} priority
                         * @memberof google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetRuleNetworkFirewallPolicyRequest.prototype.priority = null;
    
                        /**
                         * GetRuleNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetRuleNetworkFirewallPolicyRequest.prototype.project = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetRuleNetworkFirewallPolicyRequest _priority.
                         * @member {"priority"|undefined} _priority
                         * @memberof google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(GetRuleNetworkFirewallPolicyRequest.prototype, "_priority", {
                            get: $util.oneOfGetter($oneOfFields = ["priority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetRuleNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRuleNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest} GetRuleNetworkFirewallPolicyRequest instance
                         */
                        GetRuleNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new GetRuleNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRuleNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRuleNetworkFirewallPolicyRequest} message GetRuleNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRuleNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.priority != null && Object.hasOwnProperty.call(message, "priority"))
                                writer.uint32(/* id 445151652, wireType 0 =*/3561213216).int32(message.priority);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRuleNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRuleNetworkFirewallPolicyRequest} message GetRuleNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRuleNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRuleNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest} GetRuleNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRuleNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 445151652: {
                                        message.priority = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRuleNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest} GetRuleNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRuleNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRuleNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRuleNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                properties._priority = 1;
                                if (!$util.isInteger(message.priority))
                                    return "priority: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRuleNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest} GetRuleNetworkFirewallPolicyRequest
                         */
                        GetRuleNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.priority != null)
                                message.priority = object.priority | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRuleNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest} message GetRuleNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRuleNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.firewallPolicy = "";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                object.priority = message.priority;
                                if (options.oneofs)
                                    object._priority = "priority";
                            }
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this GetRuleNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRuleNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRuleNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRuleNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest";
                        };
    
                        return GetRuleNetworkFirewallPolicyRequest;
                    })();
    
                    v1.GetRuleRegionNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a GetRuleRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRuleRegionNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] GetRuleRegionNetworkFirewallPolicyRequest firewallPolicy
                         * @property {number|null} [priority] GetRuleRegionNetworkFirewallPolicyRequest priority
                         * @property {string|null} [project] GetRuleRegionNetworkFirewallPolicyRequest project
                         * @property {string|null} [region] GetRuleRegionNetworkFirewallPolicyRequest region
                         */
    
                        /**
                         * Constructs a new GetRuleRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRuleRegionNetworkFirewallPolicyRequest.
                         * @implements IGetRuleRegionNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRuleRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function GetRuleRegionNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRuleRegionNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetRuleRegionNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * GetRuleRegionNetworkFirewallPolicyRequest priority.
                         * @member {number|null|undefined} priority
                         * @memberof google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetRuleRegionNetworkFirewallPolicyRequest.prototype.priority = null;
    
                        /**
                         * GetRuleRegionNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetRuleRegionNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * GetRuleRegionNetworkFirewallPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        GetRuleRegionNetworkFirewallPolicyRequest.prototype.region = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetRuleRegionNetworkFirewallPolicyRequest _priority.
                         * @member {"priority"|undefined} _priority
                         * @memberof google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(GetRuleRegionNetworkFirewallPolicyRequest.prototype, "_priority", {
                            get: $util.oneOfGetter($oneOfFields = ["priority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetRuleRegionNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRuleRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest} GetRuleRegionNetworkFirewallPolicyRequest instance
                         */
                        GetRuleRegionNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new GetRuleRegionNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRuleRegionNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRuleRegionNetworkFirewallPolicyRequest} message GetRuleRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRuleRegionNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.priority != null && Object.hasOwnProperty.call(message, "priority"))
                                writer.uint32(/* id 445151652, wireType 0 =*/3561213216).int32(message.priority);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRuleRegionNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRuleRegionNetworkFirewallPolicyRequest} message GetRuleRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRuleRegionNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRuleRegionNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest} GetRuleRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRuleRegionNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 445151652: {
                                        message.priority = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRuleRegionNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest} GetRuleRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRuleRegionNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRuleRegionNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRuleRegionNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                properties._priority = 1;
                                if (!$util.isInteger(message.priority))
                                    return "priority: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRuleRegionNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest} GetRuleRegionNetworkFirewallPolicyRequest
                         */
                        GetRuleRegionNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.priority != null)
                                message.priority = object.priority | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRuleRegionNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest} message GetRuleRegionNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRuleRegionNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.firewallPolicy = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                object.priority = message.priority;
                                if (options.oneofs)
                                    object._priority = "priority";
                            }
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this GetRuleRegionNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRuleRegionNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRuleRegionNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRuleRegionNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest";
                        };
    
                        return GetRuleRegionNetworkFirewallPolicyRequest;
                    })();
    
                    v1.GetRuleSecurityPolicyRequest = (function() {
    
                        /**
                         * Properties of a GetRuleSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetRuleSecurityPolicyRequest
                         * @property {number|null} [priority] GetRuleSecurityPolicyRequest priority
                         * @property {string|null} [project] GetRuleSecurityPolicyRequest project
                         * @property {string|null} [securityPolicy] GetRuleSecurityPolicyRequest securityPolicy
                         */
    
                        /**
                         * Constructs a new GetRuleSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetRuleSecurityPolicyRequest.
                         * @implements IGetRuleSecurityPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetRuleSecurityPolicyRequest=} [properties] Properties to set
                         */
                        function GetRuleSecurityPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRuleSecurityPolicyRequest priority.
                         * @member {number|null|undefined} priority
                         * @memberof google.cloud.compute.v1.GetRuleSecurityPolicyRequest
                         * @instance
                         */
                        GetRuleSecurityPolicyRequest.prototype.priority = null;
    
                        /**
                         * GetRuleSecurityPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetRuleSecurityPolicyRequest
                         * @instance
                         */
                        GetRuleSecurityPolicyRequest.prototype.project = "";
    
                        /**
                         * GetRuleSecurityPolicyRequest securityPolicy.
                         * @member {string} securityPolicy
                         * @memberof google.cloud.compute.v1.GetRuleSecurityPolicyRequest
                         * @instance
                         */
                        GetRuleSecurityPolicyRequest.prototype.securityPolicy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetRuleSecurityPolicyRequest _priority.
                         * @member {"priority"|undefined} _priority
                         * @memberof google.cloud.compute.v1.GetRuleSecurityPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(GetRuleSecurityPolicyRequest.prototype, "_priority", {
                            get: $util.oneOfGetter($oneOfFields = ["priority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetRuleSecurityPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetRuleSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRuleSecurityPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetRuleSecurityPolicyRequest} GetRuleSecurityPolicyRequest instance
                         */
                        GetRuleSecurityPolicyRequest.create = function create(properties) {
                            return new GetRuleSecurityPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRuleSecurityPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetRuleSecurityPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetRuleSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRuleSecurityPolicyRequest} message GetRuleSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRuleSecurityPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.securityPolicy != null && Object.hasOwnProperty.call(message, "securityPolicy"))
                                writer.uint32(/* id 171082513, wireType 2 =*/1368660106).string(message.securityPolicy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.priority != null && Object.hasOwnProperty.call(message, "priority"))
                                writer.uint32(/* id 445151652, wireType 0 =*/3561213216).int32(message.priority);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRuleSecurityPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetRuleSecurityPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetRuleSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetRuleSecurityPolicyRequest} message GetRuleSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRuleSecurityPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRuleSecurityPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetRuleSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetRuleSecurityPolicyRequest} GetRuleSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRuleSecurityPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetRuleSecurityPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 445151652: {
                                        message.priority = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 171082513: {
                                        message.securityPolicy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRuleSecurityPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetRuleSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetRuleSecurityPolicyRequest} GetRuleSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRuleSecurityPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRuleSecurityPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetRuleSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRuleSecurityPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                properties._priority = 1;
                                if (!$util.isInteger(message.priority))
                                    return "priority: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy"))
                                if (!$util.isString(message.securityPolicy))
                                    return "securityPolicy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRuleSecurityPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetRuleSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetRuleSecurityPolicyRequest} GetRuleSecurityPolicyRequest
                         */
                        GetRuleSecurityPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetRuleSecurityPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetRuleSecurityPolicyRequest();
                            if (object.priority != null)
                                message.priority = object.priority | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.securityPolicy != null)
                                message.securityPolicy = String(object.securityPolicy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRuleSecurityPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetRuleSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetRuleSecurityPolicyRequest} message GetRuleSecurityPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRuleSecurityPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.securityPolicy = "";
                                object.project = "";
                            }
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy"))
                                object.securityPolicy = message.securityPolicy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                object.priority = message.priority;
                                if (options.oneofs)
                                    object._priority = "priority";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetRuleSecurityPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetRuleSecurityPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRuleSecurityPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRuleSecurityPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetRuleSecurityPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRuleSecurityPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetRuleSecurityPolicyRequest";
                        };
    
                        return GetRuleSecurityPolicyRequest;
                    })();
    
                    v1.GetScreenshotInstanceRequest = (function() {
    
                        /**
                         * Properties of a GetScreenshotInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetScreenshotInstanceRequest
                         * @property {string|null} [instance] GetScreenshotInstanceRequest instance
                         * @property {string|null} [project] GetScreenshotInstanceRequest project
                         * @property {string|null} [zone] GetScreenshotInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new GetScreenshotInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetScreenshotInstanceRequest.
                         * @implements IGetScreenshotInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetScreenshotInstanceRequest=} [properties] Properties to set
                         */
                        function GetScreenshotInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetScreenshotInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.GetScreenshotInstanceRequest
                         * @instance
                         */
                        GetScreenshotInstanceRequest.prototype.instance = "";
    
                        /**
                         * GetScreenshotInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetScreenshotInstanceRequest
                         * @instance
                         */
                        GetScreenshotInstanceRequest.prototype.project = "";
    
                        /**
                         * GetScreenshotInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetScreenshotInstanceRequest
                         * @instance
                         */
                        GetScreenshotInstanceRequest.prototype.zone = "";
    
                        /**
                         * Creates a new GetScreenshotInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetScreenshotInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetScreenshotInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetScreenshotInstanceRequest} GetScreenshotInstanceRequest instance
                         */
                        GetScreenshotInstanceRequest.create = function create(properties) {
                            return new GetScreenshotInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetScreenshotInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.GetScreenshotInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetScreenshotInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetScreenshotInstanceRequest} message GetScreenshotInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetScreenshotInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetScreenshotInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetScreenshotInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetScreenshotInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetScreenshotInstanceRequest} message GetScreenshotInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetScreenshotInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetScreenshotInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetScreenshotInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetScreenshotInstanceRequest} GetScreenshotInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetScreenshotInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetScreenshotInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetScreenshotInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetScreenshotInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetScreenshotInstanceRequest} GetScreenshotInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetScreenshotInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetScreenshotInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetScreenshotInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetScreenshotInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetScreenshotInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetScreenshotInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetScreenshotInstanceRequest} GetScreenshotInstanceRequest
                         */
                        GetScreenshotInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetScreenshotInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetScreenshotInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetScreenshotInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetScreenshotInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetScreenshotInstanceRequest} message GetScreenshotInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetScreenshotInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetScreenshotInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetScreenshotInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetScreenshotInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetScreenshotInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetScreenshotInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetScreenshotInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetScreenshotInstanceRequest";
                        };
    
                        return GetScreenshotInstanceRequest;
                    })();
    
                    v1.GetSecurityPolicyRequest = (function() {
    
                        /**
                         * Properties of a GetSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetSecurityPolicyRequest
                         * @property {string|null} [project] GetSecurityPolicyRequest project
                         * @property {string|null} [securityPolicy] GetSecurityPolicyRequest securityPolicy
                         */
    
                        /**
                         * Constructs a new GetSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetSecurityPolicyRequest.
                         * @implements IGetSecurityPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetSecurityPolicyRequest=} [properties] Properties to set
                         */
                        function GetSecurityPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetSecurityPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetSecurityPolicyRequest
                         * @instance
                         */
                        GetSecurityPolicyRequest.prototype.project = "";
    
                        /**
                         * GetSecurityPolicyRequest securityPolicy.
                         * @member {string} securityPolicy
                         * @memberof google.cloud.compute.v1.GetSecurityPolicyRequest
                         * @instance
                         */
                        GetSecurityPolicyRequest.prototype.securityPolicy = "";
    
                        /**
                         * Creates a new GetSecurityPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetSecurityPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetSecurityPolicyRequest} GetSecurityPolicyRequest instance
                         */
                        GetSecurityPolicyRequest.create = function create(properties) {
                            return new GetSecurityPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetSecurityPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetSecurityPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetSecurityPolicyRequest} message GetSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetSecurityPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.securityPolicy != null && Object.hasOwnProperty.call(message, "securityPolicy"))
                                writer.uint32(/* id 171082513, wireType 2 =*/1368660106).string(message.securityPolicy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetSecurityPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetSecurityPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetSecurityPolicyRequest} message GetSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetSecurityPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetSecurityPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetSecurityPolicyRequest} GetSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetSecurityPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetSecurityPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 171082513: {
                                        message.securityPolicy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetSecurityPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetSecurityPolicyRequest} GetSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetSecurityPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetSecurityPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetSecurityPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy"))
                                if (!$util.isString(message.securityPolicy))
                                    return "securityPolicy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetSecurityPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetSecurityPolicyRequest} GetSecurityPolicyRequest
                         */
                        GetSecurityPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetSecurityPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetSecurityPolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.securityPolicy != null)
                                message.securityPolicy = String(object.securityPolicy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetSecurityPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetSecurityPolicyRequest} message GetSecurityPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetSecurityPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.securityPolicy = "";
                                object.project = "";
                            }
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy"))
                                object.securityPolicy = message.securityPolicy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetSecurityPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetSecurityPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetSecurityPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetSecurityPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetSecurityPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetSecurityPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetSecurityPolicyRequest";
                        };
    
                        return GetSecurityPolicyRequest;
                    })();
    
                    v1.GetSerialPortOutputInstanceRequest = (function() {
    
                        /**
                         * Properties of a GetSerialPortOutputInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetSerialPortOutputInstanceRequest
                         * @property {string|null} [instance] GetSerialPortOutputInstanceRequest instance
                         * @property {number|null} [port] GetSerialPortOutputInstanceRequest port
                         * @property {string|null} [project] GetSerialPortOutputInstanceRequest project
                         * @property {number|Long|null} [start] GetSerialPortOutputInstanceRequest start
                         * @property {string|null} [zone] GetSerialPortOutputInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new GetSerialPortOutputInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetSerialPortOutputInstanceRequest.
                         * @implements IGetSerialPortOutputInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetSerialPortOutputInstanceRequest=} [properties] Properties to set
                         */
                        function GetSerialPortOutputInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetSerialPortOutputInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.GetSerialPortOutputInstanceRequest
                         * @instance
                         */
                        GetSerialPortOutputInstanceRequest.prototype.instance = "";
    
                        /**
                         * GetSerialPortOutputInstanceRequest port.
                         * @member {number|null|undefined} port
                         * @memberof google.cloud.compute.v1.GetSerialPortOutputInstanceRequest
                         * @instance
                         */
                        GetSerialPortOutputInstanceRequest.prototype.port = null;
    
                        /**
                         * GetSerialPortOutputInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetSerialPortOutputInstanceRequest
                         * @instance
                         */
                        GetSerialPortOutputInstanceRequest.prototype.project = "";
    
                        /**
                         * GetSerialPortOutputInstanceRequest start.
                         * @member {number|Long|null|undefined} start
                         * @memberof google.cloud.compute.v1.GetSerialPortOutputInstanceRequest
                         * @instance
                         */
                        GetSerialPortOutputInstanceRequest.prototype.start = null;
    
                        /**
                         * GetSerialPortOutputInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetSerialPortOutputInstanceRequest
                         * @instance
                         */
                        GetSerialPortOutputInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetSerialPortOutputInstanceRequest _port.
                         * @member {"port"|undefined} _port
                         * @memberof google.cloud.compute.v1.GetSerialPortOutputInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(GetSerialPortOutputInstanceRequest.prototype, "_port", {
                            get: $util.oneOfGetter($oneOfFields = ["port"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GetSerialPortOutputInstanceRequest _start.
                         * @member {"start"|undefined} _start
                         * @memberof google.cloud.compute.v1.GetSerialPortOutputInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(GetSerialPortOutputInstanceRequest.prototype, "_start", {
                            get: $util.oneOfGetter($oneOfFields = ["start"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetSerialPortOutputInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetSerialPortOutputInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetSerialPortOutputInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetSerialPortOutputInstanceRequest} GetSerialPortOutputInstanceRequest instance
                         */
                        GetSerialPortOutputInstanceRequest.create = function create(properties) {
                            return new GetSerialPortOutputInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetSerialPortOutputInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.GetSerialPortOutputInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetSerialPortOutputInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetSerialPortOutputInstanceRequest} message GetSerialPortOutputInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetSerialPortOutputInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.port != null && Object.hasOwnProperty.call(message, "port"))
                                writer.uint32(/* id 3446913, wireType 0 =*/27575304).int32(message.port);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.start != null && Object.hasOwnProperty.call(message, "start"))
                                writer.uint32(/* id 109757538, wireType 0 =*/878060304).int64(message.start);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetSerialPortOutputInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetSerialPortOutputInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetSerialPortOutputInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetSerialPortOutputInstanceRequest} message GetSerialPortOutputInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetSerialPortOutputInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetSerialPortOutputInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetSerialPortOutputInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetSerialPortOutputInstanceRequest} GetSerialPortOutputInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetSerialPortOutputInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetSerialPortOutputInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 3446913: {
                                        message.port = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 109757538: {
                                        message.start = reader.int64();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetSerialPortOutputInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetSerialPortOutputInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetSerialPortOutputInstanceRequest} GetSerialPortOutputInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetSerialPortOutputInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetSerialPortOutputInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetSerialPortOutputInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetSerialPortOutputInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.port != null && message.hasOwnProperty("port")) {
                                properties._port = 1;
                                if (!$util.isInteger(message.port))
                                    return "port: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.start != null && message.hasOwnProperty("start")) {
                                properties._start = 1;
                                if (!$util.isInteger(message.start) && !(message.start && $util.isInteger(message.start.low) && $util.isInteger(message.start.high)))
                                    return "start: integer|Long expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetSerialPortOutputInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetSerialPortOutputInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetSerialPortOutputInstanceRequest} GetSerialPortOutputInstanceRequest
                         */
                        GetSerialPortOutputInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetSerialPortOutputInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetSerialPortOutputInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.port != null)
                                message.port = object.port | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.start != null)
                                if ($util.Long)
                                    (message.start = $util.Long.fromValue(object.start)).unsigned = false;
                                else if (typeof object.start === "string")
                                    message.start = parseInt(object.start, 10);
                                else if (typeof object.start === "number")
                                    message.start = object.start;
                                else if (typeof object.start === "object")
                                    message.start = new $util.LongBits(object.start.low >>> 0, object.start.high >>> 0).toNumber();
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetSerialPortOutputInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetSerialPortOutputInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetSerialPortOutputInstanceRequest} message GetSerialPortOutputInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetSerialPortOutputInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                            }
                            if (message.port != null && message.hasOwnProperty("port")) {
                                object.port = message.port;
                                if (options.oneofs)
                                    object._port = "port";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.start != null && message.hasOwnProperty("start")) {
                                if (typeof message.start === "number")
                                    object.start = options.longs === String ? String(message.start) : message.start;
                                else
                                    object.start = options.longs === String ? $util.Long.prototype.toString.call(message.start) : options.longs === Number ? new $util.LongBits(message.start.low >>> 0, message.start.high >>> 0).toNumber() : message.start;
                                if (options.oneofs)
                                    object._start = "start";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetSerialPortOutputInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetSerialPortOutputInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetSerialPortOutputInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetSerialPortOutputInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetSerialPortOutputInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetSerialPortOutputInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetSerialPortOutputInstanceRequest";
                        };
    
                        return GetSerialPortOutputInstanceRequest;
                    })();
    
                    v1.GetServiceAttachmentRequest = (function() {
    
                        /**
                         * Properties of a GetServiceAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetServiceAttachmentRequest
                         * @property {string|null} [project] GetServiceAttachmentRequest project
                         * @property {string|null} [region] GetServiceAttachmentRequest region
                         * @property {string|null} [serviceAttachment] GetServiceAttachmentRequest serviceAttachment
                         */
    
                        /**
                         * Constructs a new GetServiceAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetServiceAttachmentRequest.
                         * @implements IGetServiceAttachmentRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetServiceAttachmentRequest=} [properties] Properties to set
                         */
                        function GetServiceAttachmentRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetServiceAttachmentRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetServiceAttachmentRequest
                         * @instance
                         */
                        GetServiceAttachmentRequest.prototype.project = "";
    
                        /**
                         * GetServiceAttachmentRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetServiceAttachmentRequest
                         * @instance
                         */
                        GetServiceAttachmentRequest.prototype.region = "";
    
                        /**
                         * GetServiceAttachmentRequest serviceAttachment.
                         * @member {string} serviceAttachment
                         * @memberof google.cloud.compute.v1.GetServiceAttachmentRequest
                         * @instance
                         */
                        GetServiceAttachmentRequest.prototype.serviceAttachment = "";
    
                        /**
                         * Creates a new GetServiceAttachmentRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetServiceAttachmentRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetServiceAttachmentRequest} GetServiceAttachmentRequest instance
                         */
                        GetServiceAttachmentRequest.create = function create(properties) {
                            return new GetServiceAttachmentRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetServiceAttachmentRequest message. Does not implicitly {@link google.cloud.compute.v1.GetServiceAttachmentRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetServiceAttachmentRequest} message GetServiceAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetServiceAttachmentRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.serviceAttachment != null && Object.hasOwnProperty.call(message, "serviceAttachment"))
                                writer.uint32(/* id 338957549, wireType 2 =*/2711660394).string(message.serviceAttachment);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetServiceAttachmentRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetServiceAttachmentRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetServiceAttachmentRequest} message GetServiceAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetServiceAttachmentRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetServiceAttachmentRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetServiceAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetServiceAttachmentRequest} GetServiceAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetServiceAttachmentRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetServiceAttachmentRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 338957549: {
                                        message.serviceAttachment = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetServiceAttachmentRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetServiceAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetServiceAttachmentRequest} GetServiceAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetServiceAttachmentRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetServiceAttachmentRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetServiceAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetServiceAttachmentRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.serviceAttachment != null && message.hasOwnProperty("serviceAttachment"))
                                if (!$util.isString(message.serviceAttachment))
                                    return "serviceAttachment: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetServiceAttachmentRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetServiceAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetServiceAttachmentRequest} GetServiceAttachmentRequest
                         */
                        GetServiceAttachmentRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetServiceAttachmentRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetServiceAttachmentRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.serviceAttachment != null)
                                message.serviceAttachment = String(object.serviceAttachment);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetServiceAttachmentRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetServiceAttachmentRequest} message GetServiceAttachmentRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetServiceAttachmentRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.serviceAttachment = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.serviceAttachment != null && message.hasOwnProperty("serviceAttachment"))
                                object.serviceAttachment = message.serviceAttachment;
                            return object;
                        };
    
                        /**
                         * Converts this GetServiceAttachmentRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetServiceAttachmentRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetServiceAttachmentRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetServiceAttachmentRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetServiceAttachmentRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetServiceAttachmentRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetServiceAttachmentRequest";
                        };
    
                        return GetServiceAttachmentRequest;
                    })();
    
                    v1.GetShieldedInstanceIdentityInstanceRequest = (function() {
    
                        /**
                         * Properties of a GetShieldedInstanceIdentityInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetShieldedInstanceIdentityInstanceRequest
                         * @property {string|null} [instance] GetShieldedInstanceIdentityInstanceRequest instance
                         * @property {string|null} [project] GetShieldedInstanceIdentityInstanceRequest project
                         * @property {string|null} [zone] GetShieldedInstanceIdentityInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new GetShieldedInstanceIdentityInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetShieldedInstanceIdentityInstanceRequest.
                         * @implements IGetShieldedInstanceIdentityInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetShieldedInstanceIdentityInstanceRequest=} [properties] Properties to set
                         */
                        function GetShieldedInstanceIdentityInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetShieldedInstanceIdentityInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest
                         * @instance
                         */
                        GetShieldedInstanceIdentityInstanceRequest.prototype.instance = "";
    
                        /**
                         * GetShieldedInstanceIdentityInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest
                         * @instance
                         */
                        GetShieldedInstanceIdentityInstanceRequest.prototype.project = "";
    
                        /**
                         * GetShieldedInstanceIdentityInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest
                         * @instance
                         */
                        GetShieldedInstanceIdentityInstanceRequest.prototype.zone = "";
    
                        /**
                         * Creates a new GetShieldedInstanceIdentityInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetShieldedInstanceIdentityInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest} GetShieldedInstanceIdentityInstanceRequest instance
                         */
                        GetShieldedInstanceIdentityInstanceRequest.create = function create(properties) {
                            return new GetShieldedInstanceIdentityInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetShieldedInstanceIdentityInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetShieldedInstanceIdentityInstanceRequest} message GetShieldedInstanceIdentityInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetShieldedInstanceIdentityInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetShieldedInstanceIdentityInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetShieldedInstanceIdentityInstanceRequest} message GetShieldedInstanceIdentityInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetShieldedInstanceIdentityInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetShieldedInstanceIdentityInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest} GetShieldedInstanceIdentityInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetShieldedInstanceIdentityInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetShieldedInstanceIdentityInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest} GetShieldedInstanceIdentityInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetShieldedInstanceIdentityInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetShieldedInstanceIdentityInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetShieldedInstanceIdentityInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetShieldedInstanceIdentityInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest} GetShieldedInstanceIdentityInstanceRequest
                         */
                        GetShieldedInstanceIdentityInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetShieldedInstanceIdentityInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest} message GetShieldedInstanceIdentityInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetShieldedInstanceIdentityInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetShieldedInstanceIdentityInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetShieldedInstanceIdentityInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetShieldedInstanceIdentityInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetShieldedInstanceIdentityInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest";
                        };
    
                        return GetShieldedInstanceIdentityInstanceRequest;
                    })();
    
                    v1.GetSnapshotRequest = (function() {
    
                        /**
                         * Properties of a GetSnapshotRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetSnapshotRequest
                         * @property {string|null} [project] GetSnapshotRequest project
                         * @property {string|null} [snapshot] GetSnapshotRequest snapshot
                         */
    
                        /**
                         * Constructs a new GetSnapshotRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetSnapshotRequest.
                         * @implements IGetSnapshotRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetSnapshotRequest=} [properties] Properties to set
                         */
                        function GetSnapshotRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetSnapshotRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetSnapshotRequest
                         * @instance
                         */
                        GetSnapshotRequest.prototype.project = "";
    
                        /**
                         * GetSnapshotRequest snapshot.
                         * @member {string} snapshot
                         * @memberof google.cloud.compute.v1.GetSnapshotRequest
                         * @instance
                         */
                        GetSnapshotRequest.prototype.snapshot = "";
    
                        /**
                         * Creates a new GetSnapshotRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetSnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetSnapshotRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetSnapshotRequest} GetSnapshotRequest instance
                         */
                        GetSnapshotRequest.create = function create(properties) {
                            return new GetSnapshotRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetSnapshotRequest message. Does not implicitly {@link google.cloud.compute.v1.GetSnapshotRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetSnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetSnapshotRequest} message GetSnapshotRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetSnapshotRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.snapshot != null && Object.hasOwnProperty.call(message, "snapshot"))
                                writer.uint32(/* id 284874180, wireType 2 =*/2278993442).string(message.snapshot);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetSnapshotRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetSnapshotRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetSnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetSnapshotRequest} message GetSnapshotRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetSnapshotRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetSnapshotRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetSnapshotRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetSnapshotRequest} GetSnapshotRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetSnapshotRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetSnapshotRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 284874180: {
                                        message.snapshot = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetSnapshotRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetSnapshotRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetSnapshotRequest} GetSnapshotRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetSnapshotRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetSnapshotRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetSnapshotRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetSnapshotRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.snapshot != null && message.hasOwnProperty("snapshot"))
                                if (!$util.isString(message.snapshot))
                                    return "snapshot: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetSnapshotRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetSnapshotRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetSnapshotRequest} GetSnapshotRequest
                         */
                        GetSnapshotRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetSnapshotRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetSnapshotRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.snapshot != null)
                                message.snapshot = String(object.snapshot);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetSnapshotRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetSnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetSnapshotRequest} message GetSnapshotRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetSnapshotRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.snapshot = "";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.snapshot != null && message.hasOwnProperty("snapshot"))
                                object.snapshot = message.snapshot;
                            return object;
                        };
    
                        /**
                         * Converts this GetSnapshotRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetSnapshotRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetSnapshotRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetSnapshotRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetSnapshotRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetSnapshotRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetSnapshotRequest";
                        };
    
                        return GetSnapshotRequest;
                    })();
    
                    v1.GetSslCertificateRequest = (function() {
    
                        /**
                         * Properties of a GetSslCertificateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetSslCertificateRequest
                         * @property {string|null} [project] GetSslCertificateRequest project
                         * @property {string|null} [sslCertificate] GetSslCertificateRequest sslCertificate
                         */
    
                        /**
                         * Constructs a new GetSslCertificateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetSslCertificateRequest.
                         * @implements IGetSslCertificateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetSslCertificateRequest=} [properties] Properties to set
                         */
                        function GetSslCertificateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetSslCertificateRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetSslCertificateRequest
                         * @instance
                         */
                        GetSslCertificateRequest.prototype.project = "";
    
                        /**
                         * GetSslCertificateRequest sslCertificate.
                         * @member {string} sslCertificate
                         * @memberof google.cloud.compute.v1.GetSslCertificateRequest
                         * @instance
                         */
                        GetSslCertificateRequest.prototype.sslCertificate = "";
    
                        /**
                         * Creates a new GetSslCertificateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetSslCertificateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetSslCertificateRequest} GetSslCertificateRequest instance
                         */
                        GetSslCertificateRequest.create = function create(properties) {
                            return new GetSslCertificateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetSslCertificateRequest message. Does not implicitly {@link google.cloud.compute.v1.GetSslCertificateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetSslCertificateRequest} message GetSslCertificateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetSslCertificateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.sslCertificate != null && Object.hasOwnProperty.call(message, "sslCertificate"))
                                writer.uint32(/* id 46443492, wireType 2 =*/371547938).string(message.sslCertificate);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetSslCertificateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetSslCertificateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetSslCertificateRequest} message GetSslCertificateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetSslCertificateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetSslCertificateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetSslCertificateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetSslCertificateRequest} GetSslCertificateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetSslCertificateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetSslCertificateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 46443492: {
                                        message.sslCertificate = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetSslCertificateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetSslCertificateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetSslCertificateRequest} GetSslCertificateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetSslCertificateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetSslCertificateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetSslCertificateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetSslCertificateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.sslCertificate != null && message.hasOwnProperty("sslCertificate"))
                                if (!$util.isString(message.sslCertificate))
                                    return "sslCertificate: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetSslCertificateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetSslCertificateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetSslCertificateRequest} GetSslCertificateRequest
                         */
                        GetSslCertificateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetSslCertificateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetSslCertificateRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.sslCertificate != null)
                                message.sslCertificate = String(object.sslCertificate);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetSslCertificateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetSslCertificateRequest} message GetSslCertificateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetSslCertificateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.sslCertificate = "";
                                object.project = "";
                            }
                            if (message.sslCertificate != null && message.hasOwnProperty("sslCertificate"))
                                object.sslCertificate = message.sslCertificate;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetSslCertificateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetSslCertificateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetSslCertificateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetSslCertificateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetSslCertificateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetSslCertificateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetSslCertificateRequest";
                        };
    
                        return GetSslCertificateRequest;
                    })();
    
                    v1.GetSslPolicyRequest = (function() {
    
                        /**
                         * Properties of a GetSslPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetSslPolicyRequest
                         * @property {string|null} [project] GetSslPolicyRequest project
                         * @property {string|null} [sslPolicy] GetSslPolicyRequest sslPolicy
                         */
    
                        /**
                         * Constructs a new GetSslPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetSslPolicyRequest.
                         * @implements IGetSslPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetSslPolicyRequest=} [properties] Properties to set
                         */
                        function GetSslPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetSslPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetSslPolicyRequest
                         * @instance
                         */
                        GetSslPolicyRequest.prototype.project = "";
    
                        /**
                         * GetSslPolicyRequest sslPolicy.
                         * @member {string} sslPolicy
                         * @memberof google.cloud.compute.v1.GetSslPolicyRequest
                         * @instance
                         */
                        GetSslPolicyRequest.prototype.sslPolicy = "";
    
                        /**
                         * Creates a new GetSslPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetSslPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetSslPolicyRequest} GetSslPolicyRequest instance
                         */
                        GetSslPolicyRequest.create = function create(properties) {
                            return new GetSslPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetSslPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetSslPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetSslPolicyRequest} message GetSslPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetSslPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.sslPolicy != null && Object.hasOwnProperty.call(message, "sslPolicy"))
                                writer.uint32(/* id 295190213, wireType 2 =*/2361521706).string(message.sslPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetSslPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetSslPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetSslPolicyRequest} message GetSslPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetSslPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetSslPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetSslPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetSslPolicyRequest} GetSslPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetSslPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetSslPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 295190213: {
                                        message.sslPolicy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetSslPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetSslPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetSslPolicyRequest} GetSslPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetSslPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetSslPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetSslPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetSslPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.sslPolicy != null && message.hasOwnProperty("sslPolicy"))
                                if (!$util.isString(message.sslPolicy))
                                    return "sslPolicy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetSslPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetSslPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetSslPolicyRequest} GetSslPolicyRequest
                         */
                        GetSslPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetSslPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetSslPolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.sslPolicy != null)
                                message.sslPolicy = String(object.sslPolicy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetSslPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetSslPolicyRequest} message GetSslPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetSslPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.sslPolicy = "";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.sslPolicy != null && message.hasOwnProperty("sslPolicy"))
                                object.sslPolicy = message.sslPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this GetSslPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetSslPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetSslPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetSslPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetSslPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetSslPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetSslPolicyRequest";
                        };
    
                        return GetSslPolicyRequest;
                    })();
    
                    v1.GetStatusVpnGatewayRequest = (function() {
    
                        /**
                         * Properties of a GetStatusVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetStatusVpnGatewayRequest
                         * @property {string|null} [project] GetStatusVpnGatewayRequest project
                         * @property {string|null} [region] GetStatusVpnGatewayRequest region
                         * @property {string|null} [vpnGateway] GetStatusVpnGatewayRequest vpnGateway
                         */
    
                        /**
                         * Constructs a new GetStatusVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetStatusVpnGatewayRequest.
                         * @implements IGetStatusVpnGatewayRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetStatusVpnGatewayRequest=} [properties] Properties to set
                         */
                        function GetStatusVpnGatewayRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetStatusVpnGatewayRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetStatusVpnGatewayRequest
                         * @instance
                         */
                        GetStatusVpnGatewayRequest.prototype.project = "";
    
                        /**
                         * GetStatusVpnGatewayRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetStatusVpnGatewayRequest
                         * @instance
                         */
                        GetStatusVpnGatewayRequest.prototype.region = "";
    
                        /**
                         * GetStatusVpnGatewayRequest vpnGateway.
                         * @member {string} vpnGateway
                         * @memberof google.cloud.compute.v1.GetStatusVpnGatewayRequest
                         * @instance
                         */
                        GetStatusVpnGatewayRequest.prototype.vpnGateway = "";
    
                        /**
                         * Creates a new GetStatusVpnGatewayRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetStatusVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetStatusVpnGatewayRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetStatusVpnGatewayRequest} GetStatusVpnGatewayRequest instance
                         */
                        GetStatusVpnGatewayRequest.create = function create(properties) {
                            return new GetStatusVpnGatewayRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetStatusVpnGatewayRequest message. Does not implicitly {@link google.cloud.compute.v1.GetStatusVpnGatewayRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetStatusVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetStatusVpnGatewayRequest} message GetStatusVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetStatusVpnGatewayRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.vpnGateway != null && Object.hasOwnProperty.call(message, "vpnGateway"))
                                writer.uint32(/* id 406684153, wireType 2 =*/3253473226).string(message.vpnGateway);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetStatusVpnGatewayRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetStatusVpnGatewayRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetStatusVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetStatusVpnGatewayRequest} message GetStatusVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetStatusVpnGatewayRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetStatusVpnGatewayRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetStatusVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetStatusVpnGatewayRequest} GetStatusVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetStatusVpnGatewayRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetStatusVpnGatewayRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 406684153: {
                                        message.vpnGateway = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetStatusVpnGatewayRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetStatusVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetStatusVpnGatewayRequest} GetStatusVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetStatusVpnGatewayRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetStatusVpnGatewayRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetStatusVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetStatusVpnGatewayRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.vpnGateway != null && message.hasOwnProperty("vpnGateway"))
                                if (!$util.isString(message.vpnGateway))
                                    return "vpnGateway: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetStatusVpnGatewayRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetStatusVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetStatusVpnGatewayRequest} GetStatusVpnGatewayRequest
                         */
                        GetStatusVpnGatewayRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetStatusVpnGatewayRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetStatusVpnGatewayRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.vpnGateway != null)
                                message.vpnGateway = String(object.vpnGateway);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetStatusVpnGatewayRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetStatusVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetStatusVpnGatewayRequest} message GetStatusVpnGatewayRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetStatusVpnGatewayRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.vpnGateway = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.vpnGateway != null && message.hasOwnProperty("vpnGateway"))
                                object.vpnGateway = message.vpnGateway;
                            return object;
                        };
    
                        /**
                         * Converts this GetStatusVpnGatewayRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetStatusVpnGatewayRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetStatusVpnGatewayRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetStatusVpnGatewayRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetStatusVpnGatewayRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetStatusVpnGatewayRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetStatusVpnGatewayRequest";
                        };
    
                        return GetStatusVpnGatewayRequest;
                    })();
    
                    v1.GetSubnetworkRequest = (function() {
    
                        /**
                         * Properties of a GetSubnetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetSubnetworkRequest
                         * @property {string|null} [project] GetSubnetworkRequest project
                         * @property {string|null} [region] GetSubnetworkRequest region
                         * @property {string|null} [subnetwork] GetSubnetworkRequest subnetwork
                         */
    
                        /**
                         * Constructs a new GetSubnetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetSubnetworkRequest.
                         * @implements IGetSubnetworkRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetSubnetworkRequest=} [properties] Properties to set
                         */
                        function GetSubnetworkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetSubnetworkRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetSubnetworkRequest
                         * @instance
                         */
                        GetSubnetworkRequest.prototype.project = "";
    
                        /**
                         * GetSubnetworkRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetSubnetworkRequest
                         * @instance
                         */
                        GetSubnetworkRequest.prototype.region = "";
    
                        /**
                         * GetSubnetworkRequest subnetwork.
                         * @member {string} subnetwork
                         * @memberof google.cloud.compute.v1.GetSubnetworkRequest
                         * @instance
                         */
                        GetSubnetworkRequest.prototype.subnetwork = "";
    
                        /**
                         * Creates a new GetSubnetworkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetSubnetworkRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetSubnetworkRequest} GetSubnetworkRequest instance
                         */
                        GetSubnetworkRequest.create = function create(properties) {
                            return new GetSubnetworkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetSubnetworkRequest message. Does not implicitly {@link google.cloud.compute.v1.GetSubnetworkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetSubnetworkRequest} message GetSubnetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetSubnetworkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.subnetwork != null && Object.hasOwnProperty.call(message, "subnetwork"))
                                writer.uint32(/* id 307827694, wireType 2 =*/2462621554).string(message.subnetwork);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetSubnetworkRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetSubnetworkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetSubnetworkRequest} message GetSubnetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetSubnetworkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetSubnetworkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetSubnetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetSubnetworkRequest} GetSubnetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetSubnetworkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetSubnetworkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 307827694: {
                                        message.subnetwork = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetSubnetworkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetSubnetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetSubnetworkRequest} GetSubnetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetSubnetworkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetSubnetworkRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetSubnetworkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetSubnetworkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork"))
                                if (!$util.isString(message.subnetwork))
                                    return "subnetwork: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetSubnetworkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetSubnetworkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetSubnetworkRequest} GetSubnetworkRequest
                         */
                        GetSubnetworkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetSubnetworkRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetSubnetworkRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.subnetwork != null)
                                message.subnetwork = String(object.subnetwork);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetSubnetworkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetSubnetworkRequest} message GetSubnetworkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetSubnetworkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.subnetwork = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork"))
                                object.subnetwork = message.subnetwork;
                            return object;
                        };
    
                        /**
                         * Converts this GetSubnetworkRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetSubnetworkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetSubnetworkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetSubnetworkRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetSubnetworkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetSubnetworkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetSubnetworkRequest";
                        };
    
                        return GetSubnetworkRequest;
                    })();
    
                    v1.GetTargetGrpcProxyRequest = (function() {
    
                        /**
                         * Properties of a GetTargetGrpcProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetTargetGrpcProxyRequest
                         * @property {string|null} [project] GetTargetGrpcProxyRequest project
                         * @property {string|null} [targetGrpcProxy] GetTargetGrpcProxyRequest targetGrpcProxy
                         */
    
                        /**
                         * Constructs a new GetTargetGrpcProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetTargetGrpcProxyRequest.
                         * @implements IGetTargetGrpcProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetTargetGrpcProxyRequest=} [properties] Properties to set
                         */
                        function GetTargetGrpcProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetTargetGrpcProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetTargetGrpcProxyRequest
                         * @instance
                         */
                        GetTargetGrpcProxyRequest.prototype.project = "";
    
                        /**
                         * GetTargetGrpcProxyRequest targetGrpcProxy.
                         * @member {string} targetGrpcProxy
                         * @memberof google.cloud.compute.v1.GetTargetGrpcProxyRequest
                         * @instance
                         */
                        GetTargetGrpcProxyRequest.prototype.targetGrpcProxy = "";
    
                        /**
                         * Creates a new GetTargetGrpcProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetTargetGrpcProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetGrpcProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetTargetGrpcProxyRequest} GetTargetGrpcProxyRequest instance
                         */
                        GetTargetGrpcProxyRequest.create = function create(properties) {
                            return new GetTargetGrpcProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetTargetGrpcProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetTargetGrpcProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetTargetGrpcProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetGrpcProxyRequest} message GetTargetGrpcProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetTargetGrpcProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetGrpcProxy != null && Object.hasOwnProperty.call(message, "targetGrpcProxy"))
                                writer.uint32(/* id 5020283, wireType 2 =*/40162266).string(message.targetGrpcProxy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetTargetGrpcProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetTargetGrpcProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetTargetGrpcProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetGrpcProxyRequest} message GetTargetGrpcProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetTargetGrpcProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetTargetGrpcProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetTargetGrpcProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetTargetGrpcProxyRequest} GetTargetGrpcProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetTargetGrpcProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetTargetGrpcProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 5020283: {
                                        message.targetGrpcProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetTargetGrpcProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetTargetGrpcProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetTargetGrpcProxyRequest} GetTargetGrpcProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetTargetGrpcProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetTargetGrpcProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetTargetGrpcProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetTargetGrpcProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.targetGrpcProxy != null && message.hasOwnProperty("targetGrpcProxy"))
                                if (!$util.isString(message.targetGrpcProxy))
                                    return "targetGrpcProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetTargetGrpcProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetTargetGrpcProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetTargetGrpcProxyRequest} GetTargetGrpcProxyRequest
                         */
                        GetTargetGrpcProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetTargetGrpcProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetTargetGrpcProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.targetGrpcProxy != null)
                                message.targetGrpcProxy = String(object.targetGrpcProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetTargetGrpcProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetTargetGrpcProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetTargetGrpcProxyRequest} message GetTargetGrpcProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetTargetGrpcProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetGrpcProxy = "";
                                object.project = "";
                            }
                            if (message.targetGrpcProxy != null && message.hasOwnProperty("targetGrpcProxy"))
                                object.targetGrpcProxy = message.targetGrpcProxy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetTargetGrpcProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetTargetGrpcProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetTargetGrpcProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetTargetGrpcProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetTargetGrpcProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetTargetGrpcProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetTargetGrpcProxyRequest";
                        };
    
                        return GetTargetGrpcProxyRequest;
                    })();
    
                    v1.GetTargetHttpProxyRequest = (function() {
    
                        /**
                         * Properties of a GetTargetHttpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetTargetHttpProxyRequest
                         * @property {string|null} [project] GetTargetHttpProxyRequest project
                         * @property {string|null} [targetHttpProxy] GetTargetHttpProxyRequest targetHttpProxy
                         */
    
                        /**
                         * Constructs a new GetTargetHttpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetTargetHttpProxyRequest.
                         * @implements IGetTargetHttpProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetTargetHttpProxyRequest=} [properties] Properties to set
                         */
                        function GetTargetHttpProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetTargetHttpProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetTargetHttpProxyRequest
                         * @instance
                         */
                        GetTargetHttpProxyRequest.prototype.project = "";
    
                        /**
                         * GetTargetHttpProxyRequest targetHttpProxy.
                         * @member {string} targetHttpProxy
                         * @memberof google.cloud.compute.v1.GetTargetHttpProxyRequest
                         * @instance
                         */
                        GetTargetHttpProxyRequest.prototype.targetHttpProxy = "";
    
                        /**
                         * Creates a new GetTargetHttpProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetHttpProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetTargetHttpProxyRequest} GetTargetHttpProxyRequest instance
                         */
                        GetTargetHttpProxyRequest.create = function create(properties) {
                            return new GetTargetHttpProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetTargetHttpProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetTargetHttpProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetHttpProxyRequest} message GetTargetHttpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetTargetHttpProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetHttpProxy != null && Object.hasOwnProperty.call(message, "targetHttpProxy"))
                                writer.uint32(/* id 206872421, wireType 2 =*/1654979370).string(message.targetHttpProxy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetTargetHttpProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetTargetHttpProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetHttpProxyRequest} message GetTargetHttpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetTargetHttpProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetTargetHttpProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetTargetHttpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetTargetHttpProxyRequest} GetTargetHttpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetTargetHttpProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetTargetHttpProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 206872421: {
                                        message.targetHttpProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetTargetHttpProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetTargetHttpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetTargetHttpProxyRequest} GetTargetHttpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetTargetHttpProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetTargetHttpProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetTargetHttpProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetTargetHttpProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.targetHttpProxy != null && message.hasOwnProperty("targetHttpProxy"))
                                if (!$util.isString(message.targetHttpProxy))
                                    return "targetHttpProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetTargetHttpProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetTargetHttpProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetTargetHttpProxyRequest} GetTargetHttpProxyRequest
                         */
                        GetTargetHttpProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetTargetHttpProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetTargetHttpProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.targetHttpProxy != null)
                                message.targetHttpProxy = String(object.targetHttpProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetTargetHttpProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetTargetHttpProxyRequest} message GetTargetHttpProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetTargetHttpProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetHttpProxy = "";
                                object.project = "";
                            }
                            if (message.targetHttpProxy != null && message.hasOwnProperty("targetHttpProxy"))
                                object.targetHttpProxy = message.targetHttpProxy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetTargetHttpProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetTargetHttpProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetTargetHttpProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetTargetHttpProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetTargetHttpProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetTargetHttpProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetTargetHttpProxyRequest";
                        };
    
                        return GetTargetHttpProxyRequest;
                    })();
    
                    v1.GetTargetHttpsProxyRequest = (function() {
    
                        /**
                         * Properties of a GetTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetTargetHttpsProxyRequest
                         * @property {string|null} [project] GetTargetHttpsProxyRequest project
                         * @property {string|null} [targetHttpsProxy] GetTargetHttpsProxyRequest targetHttpsProxy
                         */
    
                        /**
                         * Constructs a new GetTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetTargetHttpsProxyRequest.
                         * @implements IGetTargetHttpsProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetTargetHttpsProxyRequest=} [properties] Properties to set
                         */
                        function GetTargetHttpsProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetTargetHttpsProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetTargetHttpsProxyRequest
                         * @instance
                         */
                        GetTargetHttpsProxyRequest.prototype.project = "";
    
                        /**
                         * GetTargetHttpsProxyRequest targetHttpsProxy.
                         * @member {string} targetHttpsProxy
                         * @memberof google.cloud.compute.v1.GetTargetHttpsProxyRequest
                         * @instance
                         */
                        GetTargetHttpsProxyRequest.prototype.targetHttpsProxy = "";
    
                        /**
                         * Creates a new GetTargetHttpsProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetHttpsProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetTargetHttpsProxyRequest} GetTargetHttpsProxyRequest instance
                         */
                        GetTargetHttpsProxyRequest.create = function create(properties) {
                            return new GetTargetHttpsProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetTargetHttpsProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetHttpsProxyRequest} message GetTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetTargetHttpsProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetHttpsProxy != null && Object.hasOwnProperty.call(message, "targetHttpsProxy"))
                                writer.uint32(/* id 52336748, wireType 2 =*/418693986).string(message.targetHttpsProxy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetTargetHttpsProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetHttpsProxyRequest} message GetTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetTargetHttpsProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetTargetHttpsProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetTargetHttpsProxyRequest} GetTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetTargetHttpsProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetTargetHttpsProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 52336748: {
                                        message.targetHttpsProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetTargetHttpsProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetTargetHttpsProxyRequest} GetTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetTargetHttpsProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetTargetHttpsProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetTargetHttpsProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                if (!$util.isString(message.targetHttpsProxy))
                                    return "targetHttpsProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetTargetHttpsProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetTargetHttpsProxyRequest} GetTargetHttpsProxyRequest
                         */
                        GetTargetHttpsProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetTargetHttpsProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetTargetHttpsProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.targetHttpsProxy != null)
                                message.targetHttpsProxy = String(object.targetHttpsProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetTargetHttpsProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetTargetHttpsProxyRequest} message GetTargetHttpsProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetTargetHttpsProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetHttpsProxy = "";
                                object.project = "";
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                object.targetHttpsProxy = message.targetHttpsProxy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetTargetHttpsProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetTargetHttpsProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetTargetHttpsProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetTargetHttpsProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetTargetHttpsProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetTargetHttpsProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetTargetHttpsProxyRequest";
                        };
    
                        return GetTargetHttpsProxyRequest;
                    })();
    
                    v1.GetTargetInstanceRequest = (function() {
    
                        /**
                         * Properties of a GetTargetInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetTargetInstanceRequest
                         * @property {string|null} [project] GetTargetInstanceRequest project
                         * @property {string|null} [targetInstance] GetTargetInstanceRequest targetInstance
                         * @property {string|null} [zone] GetTargetInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new GetTargetInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetTargetInstanceRequest.
                         * @implements IGetTargetInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetTargetInstanceRequest=} [properties] Properties to set
                         */
                        function GetTargetInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetTargetInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetTargetInstanceRequest
                         * @instance
                         */
                        GetTargetInstanceRequest.prototype.project = "";
    
                        /**
                         * GetTargetInstanceRequest targetInstance.
                         * @member {string} targetInstance
                         * @memberof google.cloud.compute.v1.GetTargetInstanceRequest
                         * @instance
                         */
                        GetTargetInstanceRequest.prototype.targetInstance = "";
    
                        /**
                         * GetTargetInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetTargetInstanceRequest
                         * @instance
                         */
                        GetTargetInstanceRequest.prototype.zone = "";
    
                        /**
                         * Creates a new GetTargetInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetTargetInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetTargetInstanceRequest} GetTargetInstanceRequest instance
                         */
                        GetTargetInstanceRequest.create = function create(properties) {
                            return new GetTargetInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetTargetInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.GetTargetInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetTargetInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetInstanceRequest} message GetTargetInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetTargetInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetInstance != null && Object.hasOwnProperty.call(message, "targetInstance"))
                                writer.uint32(/* id 289769347, wireType 2 =*/2318154778).string(message.targetInstance);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetTargetInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetTargetInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetTargetInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetInstanceRequest} message GetTargetInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetTargetInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetTargetInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetTargetInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetTargetInstanceRequest} GetTargetInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetTargetInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetTargetInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 289769347: {
                                        message.targetInstance = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetTargetInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetTargetInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetTargetInstanceRequest} GetTargetInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetTargetInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetTargetInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetTargetInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetTargetInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.targetInstance != null && message.hasOwnProperty("targetInstance"))
                                if (!$util.isString(message.targetInstance))
                                    return "targetInstance: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetTargetInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetTargetInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetTargetInstanceRequest} GetTargetInstanceRequest
                         */
                        GetTargetInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetTargetInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetTargetInstanceRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.targetInstance != null)
                                message.targetInstance = String(object.targetInstance);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetTargetInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetTargetInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetTargetInstanceRequest} message GetTargetInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetTargetInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.targetInstance = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetInstance != null && message.hasOwnProperty("targetInstance"))
                                object.targetInstance = message.targetInstance;
                            return object;
                        };
    
                        /**
                         * Converts this GetTargetInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetTargetInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetTargetInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetTargetInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetTargetInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetTargetInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetTargetInstanceRequest";
                        };
    
                        return GetTargetInstanceRequest;
                    })();
    
                    v1.GetTargetPoolRequest = (function() {
    
                        /**
                         * Properties of a GetTargetPoolRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetTargetPoolRequest
                         * @property {string|null} [project] GetTargetPoolRequest project
                         * @property {string|null} [region] GetTargetPoolRequest region
                         * @property {string|null} [targetPool] GetTargetPoolRequest targetPool
                         */
    
                        /**
                         * Constructs a new GetTargetPoolRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetTargetPoolRequest.
                         * @implements IGetTargetPoolRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetTargetPoolRequest=} [properties] Properties to set
                         */
                        function GetTargetPoolRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetTargetPoolRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetTargetPoolRequest
                         * @instance
                         */
                        GetTargetPoolRequest.prototype.project = "";
    
                        /**
                         * GetTargetPoolRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetTargetPoolRequest
                         * @instance
                         */
                        GetTargetPoolRequest.prototype.region = "";
    
                        /**
                         * GetTargetPoolRequest targetPool.
                         * @member {string} targetPool
                         * @memberof google.cloud.compute.v1.GetTargetPoolRequest
                         * @instance
                         */
                        GetTargetPoolRequest.prototype.targetPool = "";
    
                        /**
                         * Creates a new GetTargetPoolRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetPoolRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetTargetPoolRequest} GetTargetPoolRequest instance
                         */
                        GetTargetPoolRequest.create = function create(properties) {
                            return new GetTargetPoolRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetTargetPoolRequest message. Does not implicitly {@link google.cloud.compute.v1.GetTargetPoolRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetPoolRequest} message GetTargetPoolRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetTargetPoolRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetPool != null && Object.hasOwnProperty.call(message, "targetPool"))
                                writer.uint32(/* id 62796298, wireType 2 =*/502370386).string(message.targetPool);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetTargetPoolRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetTargetPoolRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetPoolRequest} message GetTargetPoolRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetTargetPoolRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetTargetPoolRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetTargetPoolRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetTargetPoolRequest} GetTargetPoolRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetTargetPoolRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetTargetPoolRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 62796298: {
                                        message.targetPool = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetTargetPoolRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetTargetPoolRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetTargetPoolRequest} GetTargetPoolRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetTargetPoolRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetTargetPoolRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetTargetPoolRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetTargetPoolRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.targetPool != null && message.hasOwnProperty("targetPool"))
                                if (!$util.isString(message.targetPool))
                                    return "targetPool: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetTargetPoolRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetTargetPoolRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetTargetPoolRequest} GetTargetPoolRequest
                         */
                        GetTargetPoolRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetTargetPoolRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetTargetPoolRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.targetPool != null)
                                message.targetPool = String(object.targetPool);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetTargetPoolRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetTargetPoolRequest} message GetTargetPoolRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetTargetPoolRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetPool = "";
                                object.region = "";
                                object.project = "";
                            }
                            if (message.targetPool != null && message.hasOwnProperty("targetPool"))
                                object.targetPool = message.targetPool;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetTargetPoolRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetTargetPoolRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetTargetPoolRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetTargetPoolRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetTargetPoolRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetTargetPoolRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetTargetPoolRequest";
                        };
    
                        return GetTargetPoolRequest;
                    })();
    
                    v1.GetTargetSslProxyRequest = (function() {
    
                        /**
                         * Properties of a GetTargetSslProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetTargetSslProxyRequest
                         * @property {string|null} [project] GetTargetSslProxyRequest project
                         * @property {string|null} [targetSslProxy] GetTargetSslProxyRequest targetSslProxy
                         */
    
                        /**
                         * Constructs a new GetTargetSslProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetTargetSslProxyRequest.
                         * @implements IGetTargetSslProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetTargetSslProxyRequest=} [properties] Properties to set
                         */
                        function GetTargetSslProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetTargetSslProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetTargetSslProxyRequest
                         * @instance
                         */
                        GetTargetSslProxyRequest.prototype.project = "";
    
                        /**
                         * GetTargetSslProxyRequest targetSslProxy.
                         * @member {string} targetSslProxy
                         * @memberof google.cloud.compute.v1.GetTargetSslProxyRequest
                         * @instance
                         */
                        GetTargetSslProxyRequest.prototype.targetSslProxy = "";
    
                        /**
                         * Creates a new GetTargetSslProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetSslProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetTargetSslProxyRequest} GetTargetSslProxyRequest instance
                         */
                        GetTargetSslProxyRequest.create = function create(properties) {
                            return new GetTargetSslProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetTargetSslProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetTargetSslProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetSslProxyRequest} message GetTargetSslProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetTargetSslProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetSslProxy != null && Object.hasOwnProperty.call(message, "targetSslProxy"))
                                writer.uint32(/* id 338795853, wireType 2 =*/2710366826).string(message.targetSslProxy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetTargetSslProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetTargetSslProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetSslProxyRequest} message GetTargetSslProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetTargetSslProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetTargetSslProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetTargetSslProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetTargetSslProxyRequest} GetTargetSslProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetTargetSslProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetTargetSslProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 338795853: {
                                        message.targetSslProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetTargetSslProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetTargetSslProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetTargetSslProxyRequest} GetTargetSslProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetTargetSslProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetTargetSslProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetTargetSslProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetTargetSslProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.targetSslProxy != null && message.hasOwnProperty("targetSslProxy"))
                                if (!$util.isString(message.targetSslProxy))
                                    return "targetSslProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetTargetSslProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetTargetSslProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetTargetSslProxyRequest} GetTargetSslProxyRequest
                         */
                        GetTargetSslProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetTargetSslProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetTargetSslProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.targetSslProxy != null)
                                message.targetSslProxy = String(object.targetSslProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetTargetSslProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetTargetSslProxyRequest} message GetTargetSslProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetTargetSslProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.targetSslProxy = "";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetSslProxy != null && message.hasOwnProperty("targetSslProxy"))
                                object.targetSslProxy = message.targetSslProxy;
                            return object;
                        };
    
                        /**
                         * Converts this GetTargetSslProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetTargetSslProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetTargetSslProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetTargetSslProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetTargetSslProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetTargetSslProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetTargetSslProxyRequest";
                        };
    
                        return GetTargetSslProxyRequest;
                    })();
    
                    v1.GetTargetTcpProxyRequest = (function() {
    
                        /**
                         * Properties of a GetTargetTcpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetTargetTcpProxyRequest
                         * @property {string|null} [project] GetTargetTcpProxyRequest project
                         * @property {string|null} [targetTcpProxy] GetTargetTcpProxyRequest targetTcpProxy
                         */
    
                        /**
                         * Constructs a new GetTargetTcpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetTargetTcpProxyRequest.
                         * @implements IGetTargetTcpProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetTargetTcpProxyRequest=} [properties] Properties to set
                         */
                        function GetTargetTcpProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetTargetTcpProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetTargetTcpProxyRequest
                         * @instance
                         */
                        GetTargetTcpProxyRequest.prototype.project = "";
    
                        /**
                         * GetTargetTcpProxyRequest targetTcpProxy.
                         * @member {string} targetTcpProxy
                         * @memberof google.cloud.compute.v1.GetTargetTcpProxyRequest
                         * @instance
                         */
                        GetTargetTcpProxyRequest.prototype.targetTcpProxy = "";
    
                        /**
                         * Creates a new GetTargetTcpProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetTcpProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetTargetTcpProxyRequest} GetTargetTcpProxyRequest instance
                         */
                        GetTargetTcpProxyRequest.create = function create(properties) {
                            return new GetTargetTcpProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetTargetTcpProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.GetTargetTcpProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetTcpProxyRequest} message GetTargetTcpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetTargetTcpProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetTcpProxy != null && Object.hasOwnProperty.call(message, "targetTcpProxy"))
                                writer.uint32(/* id 503065442, wireType 2 =*/4024523538).string(message.targetTcpProxy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetTargetTcpProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetTargetTcpProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetTcpProxyRequest} message GetTargetTcpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetTargetTcpProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetTargetTcpProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetTargetTcpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetTargetTcpProxyRequest} GetTargetTcpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetTargetTcpProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetTargetTcpProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 503065442: {
                                        message.targetTcpProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetTargetTcpProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetTargetTcpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetTargetTcpProxyRequest} GetTargetTcpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetTargetTcpProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetTargetTcpProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetTargetTcpProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetTargetTcpProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.targetTcpProxy != null && message.hasOwnProperty("targetTcpProxy"))
                                if (!$util.isString(message.targetTcpProxy))
                                    return "targetTcpProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetTargetTcpProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetTargetTcpProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetTargetTcpProxyRequest} GetTargetTcpProxyRequest
                         */
                        GetTargetTcpProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetTargetTcpProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetTargetTcpProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.targetTcpProxy != null)
                                message.targetTcpProxy = String(object.targetTcpProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetTargetTcpProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetTargetTcpProxyRequest} message GetTargetTcpProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetTargetTcpProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.targetTcpProxy = "";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetTcpProxy != null && message.hasOwnProperty("targetTcpProxy"))
                                object.targetTcpProxy = message.targetTcpProxy;
                            return object;
                        };
    
                        /**
                         * Converts this GetTargetTcpProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetTargetTcpProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetTargetTcpProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetTargetTcpProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetTargetTcpProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetTargetTcpProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetTargetTcpProxyRequest";
                        };
    
                        return GetTargetTcpProxyRequest;
                    })();
    
                    v1.GetTargetVpnGatewayRequest = (function() {
    
                        /**
                         * Properties of a GetTargetVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetTargetVpnGatewayRequest
                         * @property {string|null} [project] GetTargetVpnGatewayRequest project
                         * @property {string|null} [region] GetTargetVpnGatewayRequest region
                         * @property {string|null} [targetVpnGateway] GetTargetVpnGatewayRequest targetVpnGateway
                         */
    
                        /**
                         * Constructs a new GetTargetVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetTargetVpnGatewayRequest.
                         * @implements IGetTargetVpnGatewayRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetTargetVpnGatewayRequest=} [properties] Properties to set
                         */
                        function GetTargetVpnGatewayRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetTargetVpnGatewayRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetTargetVpnGatewayRequest
                         * @instance
                         */
                        GetTargetVpnGatewayRequest.prototype.project = "";
    
                        /**
                         * GetTargetVpnGatewayRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetTargetVpnGatewayRequest
                         * @instance
                         */
                        GetTargetVpnGatewayRequest.prototype.region = "";
    
                        /**
                         * GetTargetVpnGatewayRequest targetVpnGateway.
                         * @member {string} targetVpnGateway
                         * @memberof google.cloud.compute.v1.GetTargetVpnGatewayRequest
                         * @instance
                         */
                        GetTargetVpnGatewayRequest.prototype.targetVpnGateway = "";
    
                        /**
                         * Creates a new GetTargetVpnGatewayRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetTargetVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetVpnGatewayRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetTargetVpnGatewayRequest} GetTargetVpnGatewayRequest instance
                         */
                        GetTargetVpnGatewayRequest.create = function create(properties) {
                            return new GetTargetVpnGatewayRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetTargetVpnGatewayRequest message. Does not implicitly {@link google.cloud.compute.v1.GetTargetVpnGatewayRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetTargetVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetVpnGatewayRequest} message GetTargetVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetTargetVpnGatewayRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetVpnGateway != null && Object.hasOwnProperty.call(message, "targetVpnGateway"))
                                writer.uint32(/* id 532512843, wireType 2 =*/4260102746).string(message.targetVpnGateway);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetTargetVpnGatewayRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetTargetVpnGatewayRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetTargetVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetTargetVpnGatewayRequest} message GetTargetVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetTargetVpnGatewayRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetTargetVpnGatewayRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetTargetVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetTargetVpnGatewayRequest} GetTargetVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetTargetVpnGatewayRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetTargetVpnGatewayRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 532512843: {
                                        message.targetVpnGateway = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetTargetVpnGatewayRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetTargetVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetTargetVpnGatewayRequest} GetTargetVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetTargetVpnGatewayRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetTargetVpnGatewayRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetTargetVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetTargetVpnGatewayRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.targetVpnGateway != null && message.hasOwnProperty("targetVpnGateway"))
                                if (!$util.isString(message.targetVpnGateway))
                                    return "targetVpnGateway: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetTargetVpnGatewayRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetTargetVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetTargetVpnGatewayRequest} GetTargetVpnGatewayRequest
                         */
                        GetTargetVpnGatewayRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetTargetVpnGatewayRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetTargetVpnGatewayRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.targetVpnGateway != null)
                                message.targetVpnGateway = String(object.targetVpnGateway);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetTargetVpnGatewayRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetTargetVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetTargetVpnGatewayRequest} message GetTargetVpnGatewayRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetTargetVpnGatewayRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.targetVpnGateway = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetVpnGateway != null && message.hasOwnProperty("targetVpnGateway"))
                                object.targetVpnGateway = message.targetVpnGateway;
                            return object;
                        };
    
                        /**
                         * Converts this GetTargetVpnGatewayRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetTargetVpnGatewayRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetTargetVpnGatewayRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetTargetVpnGatewayRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetTargetVpnGatewayRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetTargetVpnGatewayRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetTargetVpnGatewayRequest";
                        };
    
                        return GetTargetVpnGatewayRequest;
                    })();
    
                    v1.GetUrlMapRequest = (function() {
    
                        /**
                         * Properties of a GetUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetUrlMapRequest
                         * @property {string|null} [project] GetUrlMapRequest project
                         * @property {string|null} [urlMap] GetUrlMapRequest urlMap
                         */
    
                        /**
                         * Constructs a new GetUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetUrlMapRequest.
                         * @implements IGetUrlMapRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetUrlMapRequest=} [properties] Properties to set
                         */
                        function GetUrlMapRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetUrlMapRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetUrlMapRequest
                         * @instance
                         */
                        GetUrlMapRequest.prototype.project = "";
    
                        /**
                         * GetUrlMapRequest urlMap.
                         * @member {string} urlMap
                         * @memberof google.cloud.compute.v1.GetUrlMapRequest
                         * @instance
                         */
                        GetUrlMapRequest.prototype.urlMap = "";
    
                        /**
                         * Creates a new GetUrlMapRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetUrlMapRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetUrlMapRequest} GetUrlMapRequest instance
                         */
                        GetUrlMapRequest.create = function create(properties) {
                            return new GetUrlMapRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetUrlMapRequest message. Does not implicitly {@link google.cloud.compute.v1.GetUrlMapRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetUrlMapRequest} message GetUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetUrlMapRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.urlMap != null && Object.hasOwnProperty.call(message, "urlMap"))
                                writer.uint32(/* id 367020684, wireType 2 =*/2936165474).string(message.urlMap);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetUrlMapRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetUrlMapRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetUrlMapRequest} message GetUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetUrlMapRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetUrlMapRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetUrlMapRequest} GetUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetUrlMapRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetUrlMapRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 367020684: {
                                        message.urlMap = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetUrlMapRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetUrlMapRequest} GetUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetUrlMapRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetUrlMapRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetUrlMapRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                if (!$util.isString(message.urlMap))
                                    return "urlMap: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetUrlMapRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetUrlMapRequest} GetUrlMapRequest
                         */
                        GetUrlMapRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetUrlMapRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetUrlMapRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.urlMap != null)
                                message.urlMap = String(object.urlMap);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetUrlMapRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetUrlMapRequest} message GetUrlMapRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetUrlMapRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.urlMap = "";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                object.urlMap = message.urlMap;
                            return object;
                        };
    
                        /**
                         * Converts this GetUrlMapRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetUrlMapRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetUrlMapRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetUrlMapRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetUrlMapRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetUrlMapRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetUrlMapRequest";
                        };
    
                        return GetUrlMapRequest;
                    })();
    
                    v1.GetVpnGatewayRequest = (function() {
    
                        /**
                         * Properties of a GetVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetVpnGatewayRequest
                         * @property {string|null} [project] GetVpnGatewayRequest project
                         * @property {string|null} [region] GetVpnGatewayRequest region
                         * @property {string|null} [vpnGateway] GetVpnGatewayRequest vpnGateway
                         */
    
                        /**
                         * Constructs a new GetVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetVpnGatewayRequest.
                         * @implements IGetVpnGatewayRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetVpnGatewayRequest=} [properties] Properties to set
                         */
                        function GetVpnGatewayRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetVpnGatewayRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetVpnGatewayRequest
                         * @instance
                         */
                        GetVpnGatewayRequest.prototype.project = "";
    
                        /**
                         * GetVpnGatewayRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetVpnGatewayRequest
                         * @instance
                         */
                        GetVpnGatewayRequest.prototype.region = "";
    
                        /**
                         * GetVpnGatewayRequest vpnGateway.
                         * @member {string} vpnGateway
                         * @memberof google.cloud.compute.v1.GetVpnGatewayRequest
                         * @instance
                         */
                        GetVpnGatewayRequest.prototype.vpnGateway = "";
    
                        /**
                         * Creates a new GetVpnGatewayRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetVpnGatewayRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetVpnGatewayRequest} GetVpnGatewayRequest instance
                         */
                        GetVpnGatewayRequest.create = function create(properties) {
                            return new GetVpnGatewayRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetVpnGatewayRequest message. Does not implicitly {@link google.cloud.compute.v1.GetVpnGatewayRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetVpnGatewayRequest} message GetVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetVpnGatewayRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.vpnGateway != null && Object.hasOwnProperty.call(message, "vpnGateway"))
                                writer.uint32(/* id 406684153, wireType 2 =*/3253473226).string(message.vpnGateway);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetVpnGatewayRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetVpnGatewayRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetVpnGatewayRequest} message GetVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetVpnGatewayRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetVpnGatewayRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetVpnGatewayRequest} GetVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetVpnGatewayRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetVpnGatewayRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 406684153: {
                                        message.vpnGateway = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetVpnGatewayRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetVpnGatewayRequest} GetVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetVpnGatewayRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetVpnGatewayRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetVpnGatewayRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.vpnGateway != null && message.hasOwnProperty("vpnGateway"))
                                if (!$util.isString(message.vpnGateway))
                                    return "vpnGateway: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetVpnGatewayRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetVpnGatewayRequest} GetVpnGatewayRequest
                         */
                        GetVpnGatewayRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetVpnGatewayRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetVpnGatewayRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.vpnGateway != null)
                                message.vpnGateway = String(object.vpnGateway);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetVpnGatewayRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetVpnGatewayRequest} message GetVpnGatewayRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetVpnGatewayRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.vpnGateway = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.vpnGateway != null && message.hasOwnProperty("vpnGateway"))
                                object.vpnGateway = message.vpnGateway;
                            return object;
                        };
    
                        /**
                         * Converts this GetVpnGatewayRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetVpnGatewayRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetVpnGatewayRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetVpnGatewayRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetVpnGatewayRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetVpnGatewayRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetVpnGatewayRequest";
                        };
    
                        return GetVpnGatewayRequest;
                    })();
    
                    v1.GetVpnTunnelRequest = (function() {
    
                        /**
                         * Properties of a GetVpnTunnelRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetVpnTunnelRequest
                         * @property {string|null} [project] GetVpnTunnelRequest project
                         * @property {string|null} [region] GetVpnTunnelRequest region
                         * @property {string|null} [vpnTunnel] GetVpnTunnelRequest vpnTunnel
                         */
    
                        /**
                         * Constructs a new GetVpnTunnelRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetVpnTunnelRequest.
                         * @implements IGetVpnTunnelRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetVpnTunnelRequest=} [properties] Properties to set
                         */
                        function GetVpnTunnelRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetVpnTunnelRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetVpnTunnelRequest
                         * @instance
                         */
                        GetVpnTunnelRequest.prototype.project = "";
    
                        /**
                         * GetVpnTunnelRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.GetVpnTunnelRequest
                         * @instance
                         */
                        GetVpnTunnelRequest.prototype.region = "";
    
                        /**
                         * GetVpnTunnelRequest vpnTunnel.
                         * @member {string} vpnTunnel
                         * @memberof google.cloud.compute.v1.GetVpnTunnelRequest
                         * @instance
                         */
                        GetVpnTunnelRequest.prototype.vpnTunnel = "";
    
                        /**
                         * Creates a new GetVpnTunnelRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetVpnTunnelRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetVpnTunnelRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetVpnTunnelRequest} GetVpnTunnelRequest instance
                         */
                        GetVpnTunnelRequest.create = function create(properties) {
                            return new GetVpnTunnelRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetVpnTunnelRequest message. Does not implicitly {@link google.cloud.compute.v1.GetVpnTunnelRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetVpnTunnelRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetVpnTunnelRequest} message GetVpnTunnelRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetVpnTunnelRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.vpnTunnel != null && Object.hasOwnProperty.call(message, "vpnTunnel"))
                                writer.uint32(/* id 143821331, wireType 2 =*/1150570650).string(message.vpnTunnel);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetVpnTunnelRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetVpnTunnelRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetVpnTunnelRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetVpnTunnelRequest} message GetVpnTunnelRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetVpnTunnelRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetVpnTunnelRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetVpnTunnelRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetVpnTunnelRequest} GetVpnTunnelRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetVpnTunnelRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetVpnTunnelRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 143821331: {
                                        message.vpnTunnel = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetVpnTunnelRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetVpnTunnelRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetVpnTunnelRequest} GetVpnTunnelRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetVpnTunnelRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetVpnTunnelRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetVpnTunnelRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetVpnTunnelRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.vpnTunnel != null && message.hasOwnProperty("vpnTunnel"))
                                if (!$util.isString(message.vpnTunnel))
                                    return "vpnTunnel: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetVpnTunnelRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetVpnTunnelRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetVpnTunnelRequest} GetVpnTunnelRequest
                         */
                        GetVpnTunnelRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetVpnTunnelRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetVpnTunnelRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.vpnTunnel != null)
                                message.vpnTunnel = String(object.vpnTunnel);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetVpnTunnelRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetVpnTunnelRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetVpnTunnelRequest} message GetVpnTunnelRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetVpnTunnelRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.vpnTunnel = "";
                                object.project = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.vpnTunnel != null && message.hasOwnProperty("vpnTunnel"))
                                object.vpnTunnel = message.vpnTunnel;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetVpnTunnelRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetVpnTunnelRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetVpnTunnelRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetVpnTunnelRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetVpnTunnelRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetVpnTunnelRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetVpnTunnelRequest";
                        };
    
                        return GetVpnTunnelRequest;
                    })();
    
                    v1.GetXpnHostProjectRequest = (function() {
    
                        /**
                         * Properties of a GetXpnHostProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetXpnHostProjectRequest
                         * @property {string|null} [project] GetXpnHostProjectRequest project
                         */
    
                        /**
                         * Constructs a new GetXpnHostProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetXpnHostProjectRequest.
                         * @implements IGetXpnHostProjectRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetXpnHostProjectRequest=} [properties] Properties to set
                         */
                        function GetXpnHostProjectRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetXpnHostProjectRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetXpnHostProjectRequest
                         * @instance
                         */
                        GetXpnHostProjectRequest.prototype.project = "";
    
                        /**
                         * Creates a new GetXpnHostProjectRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetXpnHostProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetXpnHostProjectRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetXpnHostProjectRequest} GetXpnHostProjectRequest instance
                         */
                        GetXpnHostProjectRequest.create = function create(properties) {
                            return new GetXpnHostProjectRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetXpnHostProjectRequest message. Does not implicitly {@link google.cloud.compute.v1.GetXpnHostProjectRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetXpnHostProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetXpnHostProjectRequest} message GetXpnHostProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetXpnHostProjectRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetXpnHostProjectRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetXpnHostProjectRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetXpnHostProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetXpnHostProjectRequest} message GetXpnHostProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetXpnHostProjectRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetXpnHostProjectRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetXpnHostProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetXpnHostProjectRequest} GetXpnHostProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetXpnHostProjectRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetXpnHostProjectRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetXpnHostProjectRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetXpnHostProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetXpnHostProjectRequest} GetXpnHostProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetXpnHostProjectRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetXpnHostProjectRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetXpnHostProjectRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetXpnHostProjectRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetXpnHostProjectRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetXpnHostProjectRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetXpnHostProjectRequest} GetXpnHostProjectRequest
                         */
                        GetXpnHostProjectRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetXpnHostProjectRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetXpnHostProjectRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetXpnHostProjectRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetXpnHostProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetXpnHostProjectRequest} message GetXpnHostProjectRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetXpnHostProjectRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetXpnHostProjectRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetXpnHostProjectRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetXpnHostProjectRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetXpnHostProjectRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetXpnHostProjectRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetXpnHostProjectRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetXpnHostProjectRequest";
                        };
    
                        return GetXpnHostProjectRequest;
                    })();
    
                    v1.GetXpnResourcesProjectsRequest = (function() {
    
                        /**
                         * Properties of a GetXpnResourcesProjectsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetXpnResourcesProjectsRequest
                         * @property {string|null} [filter] GetXpnResourcesProjectsRequest filter
                         * @property {number|null} [maxResults] GetXpnResourcesProjectsRequest maxResults
                         * @property {string|null} [orderBy] GetXpnResourcesProjectsRequest orderBy
                         * @property {string|null} [pageToken] GetXpnResourcesProjectsRequest pageToken
                         * @property {string|null} [project] GetXpnResourcesProjectsRequest project
                         * @property {boolean|null} [returnPartialSuccess] GetXpnResourcesProjectsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new GetXpnResourcesProjectsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetXpnResourcesProjectsRequest.
                         * @implements IGetXpnResourcesProjectsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetXpnResourcesProjectsRequest=} [properties] Properties to set
                         */
                        function GetXpnResourcesProjectsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetXpnResourcesProjectsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @instance
                         */
                        GetXpnResourcesProjectsRequest.prototype.filter = null;
    
                        /**
                         * GetXpnResourcesProjectsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @instance
                         */
                        GetXpnResourcesProjectsRequest.prototype.maxResults = null;
    
                        /**
                         * GetXpnResourcesProjectsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @instance
                         */
                        GetXpnResourcesProjectsRequest.prototype.orderBy = null;
    
                        /**
                         * GetXpnResourcesProjectsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @instance
                         */
                        GetXpnResourcesProjectsRequest.prototype.pageToken = null;
    
                        /**
                         * GetXpnResourcesProjectsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @instance
                         */
                        GetXpnResourcesProjectsRequest.prototype.project = "";
    
                        /**
                         * GetXpnResourcesProjectsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @instance
                         */
                        GetXpnResourcesProjectsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GetXpnResourcesProjectsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @instance
                         */
                        Object.defineProperty(GetXpnResourcesProjectsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GetXpnResourcesProjectsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @instance
                         */
                        Object.defineProperty(GetXpnResourcesProjectsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GetXpnResourcesProjectsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @instance
                         */
                        Object.defineProperty(GetXpnResourcesProjectsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GetXpnResourcesProjectsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @instance
                         */
                        Object.defineProperty(GetXpnResourcesProjectsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GetXpnResourcesProjectsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @instance
                         */
                        Object.defineProperty(GetXpnResourcesProjectsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GetXpnResourcesProjectsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetXpnResourcesProjectsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetXpnResourcesProjectsRequest} GetXpnResourcesProjectsRequest instance
                         */
                        GetXpnResourcesProjectsRequest.create = function create(properties) {
                            return new GetXpnResourcesProjectsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetXpnResourcesProjectsRequest message. Does not implicitly {@link google.cloud.compute.v1.GetXpnResourcesProjectsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetXpnResourcesProjectsRequest} message GetXpnResourcesProjectsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetXpnResourcesProjectsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetXpnResourcesProjectsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetXpnResourcesProjectsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetXpnResourcesProjectsRequest} message GetXpnResourcesProjectsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetXpnResourcesProjectsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetXpnResourcesProjectsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetXpnResourcesProjectsRequest} GetXpnResourcesProjectsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetXpnResourcesProjectsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetXpnResourcesProjectsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetXpnResourcesProjectsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetXpnResourcesProjectsRequest} GetXpnResourcesProjectsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetXpnResourcesProjectsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetXpnResourcesProjectsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetXpnResourcesProjectsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a GetXpnResourcesProjectsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetXpnResourcesProjectsRequest} GetXpnResourcesProjectsRequest
                         */
                        GetXpnResourcesProjectsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetXpnResourcesProjectsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetXpnResourcesProjectsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetXpnResourcesProjectsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetXpnResourcesProjectsRequest} message GetXpnResourcesProjectsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetXpnResourcesProjectsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GetXpnResourcesProjectsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetXpnResourcesProjectsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetXpnResourcesProjectsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetXpnResourcesProjectsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetXpnResourcesProjectsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetXpnResourcesProjectsRequest";
                        };
    
                        return GetXpnResourcesProjectsRequest;
                    })();
    
                    v1.GetZoneOperationRequest = (function() {
    
                        /**
                         * Properties of a GetZoneOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetZoneOperationRequest
                         * @property {string|null} [operation] GetZoneOperationRequest operation
                         * @property {string|null} [project] GetZoneOperationRequest project
                         * @property {string|null} [zone] GetZoneOperationRequest zone
                         */
    
                        /**
                         * Constructs a new GetZoneOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetZoneOperationRequest.
                         * @implements IGetZoneOperationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetZoneOperationRequest=} [properties] Properties to set
                         */
                        function GetZoneOperationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetZoneOperationRequest operation.
                         * @member {string} operation
                         * @memberof google.cloud.compute.v1.GetZoneOperationRequest
                         * @instance
                         */
                        GetZoneOperationRequest.prototype.operation = "";
    
                        /**
                         * GetZoneOperationRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetZoneOperationRequest
                         * @instance
                         */
                        GetZoneOperationRequest.prototype.project = "";
    
                        /**
                         * GetZoneOperationRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetZoneOperationRequest
                         * @instance
                         */
                        GetZoneOperationRequest.prototype.zone = "";
    
                        /**
                         * Creates a new GetZoneOperationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetZoneOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetZoneOperationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetZoneOperationRequest} GetZoneOperationRequest instance
                         */
                        GetZoneOperationRequest.create = function create(properties) {
                            return new GetZoneOperationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetZoneOperationRequest message. Does not implicitly {@link google.cloud.compute.v1.GetZoneOperationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetZoneOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetZoneOperationRequest} message GetZoneOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetZoneOperationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.operation != null && Object.hasOwnProperty.call(message, "operation"))
                                writer.uint32(/* id 52090215, wireType 2 =*/416721722).string(message.operation);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetZoneOperationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetZoneOperationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetZoneOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetZoneOperationRequest} message GetZoneOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetZoneOperationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetZoneOperationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetZoneOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetZoneOperationRequest} GetZoneOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetZoneOperationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetZoneOperationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 52090215: {
                                        message.operation = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetZoneOperationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetZoneOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetZoneOperationRequest} GetZoneOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetZoneOperationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetZoneOperationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetZoneOperationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetZoneOperationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                if (!$util.isString(message.operation))
                                    return "operation: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetZoneOperationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetZoneOperationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetZoneOperationRequest} GetZoneOperationRequest
                         */
                        GetZoneOperationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetZoneOperationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetZoneOperationRequest();
                            if (object.operation != null)
                                message.operation = String(object.operation);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetZoneOperationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetZoneOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetZoneOperationRequest} message GetZoneOperationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetZoneOperationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.operation = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                object.operation = message.operation;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetZoneOperationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetZoneOperationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetZoneOperationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetZoneOperationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetZoneOperationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetZoneOperationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetZoneOperationRequest";
                        };
    
                        return GetZoneOperationRequest;
                    })();
    
                    v1.GetZoneRequest = (function() {
    
                        /**
                         * Properties of a GetZoneRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGetZoneRequest
                         * @property {string|null} [project] GetZoneRequest project
                         * @property {string|null} [zone] GetZoneRequest zone
                         */
    
                        /**
                         * Constructs a new GetZoneRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GetZoneRequest.
                         * @implements IGetZoneRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGetZoneRequest=} [properties] Properties to set
                         */
                        function GetZoneRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetZoneRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.GetZoneRequest
                         * @instance
                         */
                        GetZoneRequest.prototype.project = "";
    
                        /**
                         * GetZoneRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.GetZoneRequest
                         * @instance
                         */
                        GetZoneRequest.prototype.zone = "";
    
                        /**
                         * Creates a new GetZoneRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GetZoneRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetZoneRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GetZoneRequest} GetZoneRequest instance
                         */
                        GetZoneRequest.create = function create(properties) {
                            return new GetZoneRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetZoneRequest message. Does not implicitly {@link google.cloud.compute.v1.GetZoneRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GetZoneRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetZoneRequest} message GetZoneRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetZoneRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetZoneRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GetZoneRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GetZoneRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGetZoneRequest} message GetZoneRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetZoneRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetZoneRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GetZoneRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GetZoneRequest} GetZoneRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetZoneRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GetZoneRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetZoneRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GetZoneRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GetZoneRequest} GetZoneRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetZoneRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetZoneRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GetZoneRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetZoneRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetZoneRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GetZoneRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GetZoneRequest} GetZoneRequest
                         */
                        GetZoneRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GetZoneRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GetZoneRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetZoneRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GetZoneRequest
                         * @static
                         * @param {google.cloud.compute.v1.GetZoneRequest} message GetZoneRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetZoneRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetZoneRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GetZoneRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetZoneRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetZoneRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GetZoneRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetZoneRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GetZoneRequest";
                        };
    
                        return GetZoneRequest;
                    })();
    
                    v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest = (function() {
    
                        /**
                         * Properties of a GlobalNetworkEndpointGroupsAttachEndpointsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGlobalNetworkEndpointGroupsAttachEndpointsRequest
                         * @property {Array.<google.cloud.compute.v1.INetworkEndpoint>|null} [networkEndpoints] GlobalNetworkEndpointGroupsAttachEndpointsRequest networkEndpoints
                         */
    
                        /**
                         * Constructs a new GlobalNetworkEndpointGroupsAttachEndpointsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GlobalNetworkEndpointGroupsAttachEndpointsRequest.
                         * @implements IGlobalNetworkEndpointGroupsAttachEndpointsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGlobalNetworkEndpointGroupsAttachEndpointsRequest=} [properties] Properties to set
                         */
                        function GlobalNetworkEndpointGroupsAttachEndpointsRequest(properties) {
                            this.networkEndpoints = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GlobalNetworkEndpointGroupsAttachEndpointsRequest networkEndpoints.
                         * @member {Array.<google.cloud.compute.v1.INetworkEndpoint>} networkEndpoints
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest
                         * @instance
                         */
                        GlobalNetworkEndpointGroupsAttachEndpointsRequest.prototype.networkEndpoints = $util.emptyArray;
    
                        /**
                         * Creates a new GlobalNetworkEndpointGroupsAttachEndpointsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGlobalNetworkEndpointGroupsAttachEndpointsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest} GlobalNetworkEndpointGroupsAttachEndpointsRequest instance
                         */
                        GlobalNetworkEndpointGroupsAttachEndpointsRequest.create = function create(properties) {
                            return new GlobalNetworkEndpointGroupsAttachEndpointsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GlobalNetworkEndpointGroupsAttachEndpointsRequest message. Does not implicitly {@link google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGlobalNetworkEndpointGroupsAttachEndpointsRequest} message GlobalNetworkEndpointGroupsAttachEndpointsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GlobalNetworkEndpointGroupsAttachEndpointsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.networkEndpoints != null && message.networkEndpoints.length)
                                for (var i = 0; i < message.networkEndpoints.length; ++i)
                                    $root.google.cloud.compute.v1.NetworkEndpoint.encode(message.networkEndpoints[i], writer.uint32(/* id 149850285, wireType 2 =*/1198802282).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GlobalNetworkEndpointGroupsAttachEndpointsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGlobalNetworkEndpointGroupsAttachEndpointsRequest} message GlobalNetworkEndpointGroupsAttachEndpointsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GlobalNetworkEndpointGroupsAttachEndpointsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GlobalNetworkEndpointGroupsAttachEndpointsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest} GlobalNetworkEndpointGroupsAttachEndpointsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GlobalNetworkEndpointGroupsAttachEndpointsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 149850285: {
                                        if (!(message.networkEndpoints && message.networkEndpoints.length))
                                            message.networkEndpoints = [];
                                        message.networkEndpoints.push($root.google.cloud.compute.v1.NetworkEndpoint.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GlobalNetworkEndpointGroupsAttachEndpointsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest} GlobalNetworkEndpointGroupsAttachEndpointsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GlobalNetworkEndpointGroupsAttachEndpointsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GlobalNetworkEndpointGroupsAttachEndpointsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GlobalNetworkEndpointGroupsAttachEndpointsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.networkEndpoints != null && message.hasOwnProperty("networkEndpoints")) {
                                if (!Array.isArray(message.networkEndpoints))
                                    return "networkEndpoints: array expected";
                                for (var i = 0; i < message.networkEndpoints.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NetworkEndpoint.verify(message.networkEndpoints[i]);
                                    if (error)
                                        return "networkEndpoints." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a GlobalNetworkEndpointGroupsAttachEndpointsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest} GlobalNetworkEndpointGroupsAttachEndpointsRequest
                         */
                        GlobalNetworkEndpointGroupsAttachEndpointsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest();
                            if (object.networkEndpoints) {
                                if (!Array.isArray(object.networkEndpoints))
                                    throw TypeError(".google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest.networkEndpoints: array expected");
                                message.networkEndpoints = [];
                                for (var i = 0; i < object.networkEndpoints.length; ++i) {
                                    if (typeof object.networkEndpoints[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest.networkEndpoints: object expected");
                                    message.networkEndpoints[i] = $root.google.cloud.compute.v1.NetworkEndpoint.fromObject(object.networkEndpoints[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GlobalNetworkEndpointGroupsAttachEndpointsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest} message GlobalNetworkEndpointGroupsAttachEndpointsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GlobalNetworkEndpointGroupsAttachEndpointsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.networkEndpoints = [];
                            if (message.networkEndpoints && message.networkEndpoints.length) {
                                object.networkEndpoints = [];
                                for (var j = 0; j < message.networkEndpoints.length; ++j)
                                    object.networkEndpoints[j] = $root.google.cloud.compute.v1.NetworkEndpoint.toObject(message.networkEndpoints[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GlobalNetworkEndpointGroupsAttachEndpointsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GlobalNetworkEndpointGroupsAttachEndpointsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GlobalNetworkEndpointGroupsAttachEndpointsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GlobalNetworkEndpointGroupsAttachEndpointsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GlobalNetworkEndpointGroupsAttachEndpointsRequest";
                        };
    
                        return GlobalNetworkEndpointGroupsAttachEndpointsRequest;
                    })();
    
                    v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest = (function() {
    
                        /**
                         * Properties of a GlobalNetworkEndpointGroupsDetachEndpointsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGlobalNetworkEndpointGroupsDetachEndpointsRequest
                         * @property {Array.<google.cloud.compute.v1.INetworkEndpoint>|null} [networkEndpoints] GlobalNetworkEndpointGroupsDetachEndpointsRequest networkEndpoints
                         */
    
                        /**
                         * Constructs a new GlobalNetworkEndpointGroupsDetachEndpointsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GlobalNetworkEndpointGroupsDetachEndpointsRequest.
                         * @implements IGlobalNetworkEndpointGroupsDetachEndpointsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGlobalNetworkEndpointGroupsDetachEndpointsRequest=} [properties] Properties to set
                         */
                        function GlobalNetworkEndpointGroupsDetachEndpointsRequest(properties) {
                            this.networkEndpoints = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GlobalNetworkEndpointGroupsDetachEndpointsRequest networkEndpoints.
                         * @member {Array.<google.cloud.compute.v1.INetworkEndpoint>} networkEndpoints
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest
                         * @instance
                         */
                        GlobalNetworkEndpointGroupsDetachEndpointsRequest.prototype.networkEndpoints = $util.emptyArray;
    
                        /**
                         * Creates a new GlobalNetworkEndpointGroupsDetachEndpointsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGlobalNetworkEndpointGroupsDetachEndpointsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest} GlobalNetworkEndpointGroupsDetachEndpointsRequest instance
                         */
                        GlobalNetworkEndpointGroupsDetachEndpointsRequest.create = function create(properties) {
                            return new GlobalNetworkEndpointGroupsDetachEndpointsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GlobalNetworkEndpointGroupsDetachEndpointsRequest message. Does not implicitly {@link google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGlobalNetworkEndpointGroupsDetachEndpointsRequest} message GlobalNetworkEndpointGroupsDetachEndpointsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GlobalNetworkEndpointGroupsDetachEndpointsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.networkEndpoints != null && message.networkEndpoints.length)
                                for (var i = 0; i < message.networkEndpoints.length; ++i)
                                    $root.google.cloud.compute.v1.NetworkEndpoint.encode(message.networkEndpoints[i], writer.uint32(/* id 149850285, wireType 2 =*/1198802282).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GlobalNetworkEndpointGroupsDetachEndpointsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGlobalNetworkEndpointGroupsDetachEndpointsRequest} message GlobalNetworkEndpointGroupsDetachEndpointsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GlobalNetworkEndpointGroupsDetachEndpointsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GlobalNetworkEndpointGroupsDetachEndpointsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest} GlobalNetworkEndpointGroupsDetachEndpointsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GlobalNetworkEndpointGroupsDetachEndpointsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 149850285: {
                                        if (!(message.networkEndpoints && message.networkEndpoints.length))
                                            message.networkEndpoints = [];
                                        message.networkEndpoints.push($root.google.cloud.compute.v1.NetworkEndpoint.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GlobalNetworkEndpointGroupsDetachEndpointsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest} GlobalNetworkEndpointGroupsDetachEndpointsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GlobalNetworkEndpointGroupsDetachEndpointsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GlobalNetworkEndpointGroupsDetachEndpointsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GlobalNetworkEndpointGroupsDetachEndpointsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.networkEndpoints != null && message.hasOwnProperty("networkEndpoints")) {
                                if (!Array.isArray(message.networkEndpoints))
                                    return "networkEndpoints: array expected";
                                for (var i = 0; i < message.networkEndpoints.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NetworkEndpoint.verify(message.networkEndpoints[i]);
                                    if (error)
                                        return "networkEndpoints." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a GlobalNetworkEndpointGroupsDetachEndpointsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest} GlobalNetworkEndpointGroupsDetachEndpointsRequest
                         */
                        GlobalNetworkEndpointGroupsDetachEndpointsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest();
                            if (object.networkEndpoints) {
                                if (!Array.isArray(object.networkEndpoints))
                                    throw TypeError(".google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest.networkEndpoints: array expected");
                                message.networkEndpoints = [];
                                for (var i = 0; i < object.networkEndpoints.length; ++i) {
                                    if (typeof object.networkEndpoints[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest.networkEndpoints: object expected");
                                    message.networkEndpoints[i] = $root.google.cloud.compute.v1.NetworkEndpoint.fromObject(object.networkEndpoints[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GlobalNetworkEndpointGroupsDetachEndpointsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest} message GlobalNetworkEndpointGroupsDetachEndpointsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GlobalNetworkEndpointGroupsDetachEndpointsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.networkEndpoints = [];
                            if (message.networkEndpoints && message.networkEndpoints.length) {
                                object.networkEndpoints = [];
                                for (var j = 0; j < message.networkEndpoints.length; ++j)
                                    object.networkEndpoints[j] = $root.google.cloud.compute.v1.NetworkEndpoint.toObject(message.networkEndpoints[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GlobalNetworkEndpointGroupsDetachEndpointsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GlobalNetworkEndpointGroupsDetachEndpointsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GlobalNetworkEndpointGroupsDetachEndpointsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GlobalNetworkEndpointGroupsDetachEndpointsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GlobalNetworkEndpointGroupsDetachEndpointsRequest";
                        };
    
                        return GlobalNetworkEndpointGroupsDetachEndpointsRequest;
                    })();
    
                    v1.GlobalOrganizationSetPolicyRequest = (function() {
    
                        /**
                         * Properties of a GlobalOrganizationSetPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGlobalOrganizationSetPolicyRequest
                         * @property {Array.<google.cloud.compute.v1.IBinding>|null} [bindings] GlobalOrganizationSetPolicyRequest bindings
                         * @property {string|null} [etag] GlobalOrganizationSetPolicyRequest etag
                         * @property {google.cloud.compute.v1.IPolicy|null} [policy] GlobalOrganizationSetPolicyRequest policy
                         */
    
                        /**
                         * Constructs a new GlobalOrganizationSetPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GlobalOrganizationSetPolicyRequest.
                         * @implements IGlobalOrganizationSetPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGlobalOrganizationSetPolicyRequest=} [properties] Properties to set
                         */
                        function GlobalOrganizationSetPolicyRequest(properties) {
                            this.bindings = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GlobalOrganizationSetPolicyRequest bindings.
                         * @member {Array.<google.cloud.compute.v1.IBinding>} bindings
                         * @memberof google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest
                         * @instance
                         */
                        GlobalOrganizationSetPolicyRequest.prototype.bindings = $util.emptyArray;
    
                        /**
                         * GlobalOrganizationSetPolicyRequest etag.
                         * @member {string|null|undefined} etag
                         * @memberof google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest
                         * @instance
                         */
                        GlobalOrganizationSetPolicyRequest.prototype.etag = null;
    
                        /**
                         * GlobalOrganizationSetPolicyRequest policy.
                         * @member {google.cloud.compute.v1.IPolicy|null|undefined} policy
                         * @memberof google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest
                         * @instance
                         */
                        GlobalOrganizationSetPolicyRequest.prototype.policy = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GlobalOrganizationSetPolicyRequest _etag.
                         * @member {"etag"|undefined} _etag
                         * @memberof google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(GlobalOrganizationSetPolicyRequest.prototype, "_etag", {
                            get: $util.oneOfGetter($oneOfFields = ["etag"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GlobalOrganizationSetPolicyRequest _policy.
                         * @member {"policy"|undefined} _policy
                         * @memberof google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(GlobalOrganizationSetPolicyRequest.prototype, "_policy", {
                            get: $util.oneOfGetter($oneOfFields = ["policy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GlobalOrganizationSetPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGlobalOrganizationSetPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest} GlobalOrganizationSetPolicyRequest instance
                         */
                        GlobalOrganizationSetPolicyRequest.create = function create(properties) {
                            return new GlobalOrganizationSetPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GlobalOrganizationSetPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGlobalOrganizationSetPolicyRequest} message GlobalOrganizationSetPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GlobalOrganizationSetPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.etag != null && Object.hasOwnProperty.call(message, "etag"))
                                writer.uint32(/* id 3123477, wireType 2 =*/24987818).string(message.etag);
                            if (message.policy != null && Object.hasOwnProperty.call(message, "policy"))
                                $root.google.cloud.compute.v1.Policy.encode(message.policy, writer.uint32(/* id 91071794, wireType 2 =*/728574354).fork()).ldelim();
                            if (message.bindings != null && message.bindings.length)
                                for (var i = 0; i < message.bindings.length; ++i)
                                    $root.google.cloud.compute.v1.Binding.encode(message.bindings[i], writer.uint32(/* id 403251854, wireType 2 =*/3226014834).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GlobalOrganizationSetPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGlobalOrganizationSetPolicyRequest} message GlobalOrganizationSetPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GlobalOrganizationSetPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GlobalOrganizationSetPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest} GlobalOrganizationSetPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GlobalOrganizationSetPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 403251854: {
                                        if (!(message.bindings && message.bindings.length))
                                            message.bindings = [];
                                        message.bindings.push($root.google.cloud.compute.v1.Binding.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3123477: {
                                        message.etag = reader.string();
                                        break;
                                    }
                                case 91071794: {
                                        message.policy = $root.google.cloud.compute.v1.Policy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GlobalOrganizationSetPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest} GlobalOrganizationSetPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GlobalOrganizationSetPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GlobalOrganizationSetPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GlobalOrganizationSetPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.bindings != null && message.hasOwnProperty("bindings")) {
                                if (!Array.isArray(message.bindings))
                                    return "bindings: array expected";
                                for (var i = 0; i < message.bindings.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Binding.verify(message.bindings[i]);
                                    if (error)
                                        return "bindings." + error;
                                }
                            }
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                properties._etag = 1;
                                if (!$util.isString(message.etag))
                                    return "etag: string expected";
                            }
                            if (message.policy != null && message.hasOwnProperty("policy")) {
                                properties._policy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Policy.verify(message.policy);
                                    if (error)
                                        return "policy." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a GlobalOrganizationSetPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest} GlobalOrganizationSetPolicyRequest
                         */
                        GlobalOrganizationSetPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest();
                            if (object.bindings) {
                                if (!Array.isArray(object.bindings))
                                    throw TypeError(".google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest.bindings: array expected");
                                message.bindings = [];
                                for (var i = 0; i < object.bindings.length; ++i) {
                                    if (typeof object.bindings[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest.bindings: object expected");
                                    message.bindings[i] = $root.google.cloud.compute.v1.Binding.fromObject(object.bindings[i]);
                                }
                            }
                            if (object.etag != null)
                                message.etag = String(object.etag);
                            if (object.policy != null) {
                                if (typeof object.policy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest.policy: object expected");
                                message.policy = $root.google.cloud.compute.v1.Policy.fromObject(object.policy);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GlobalOrganizationSetPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest} message GlobalOrganizationSetPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GlobalOrganizationSetPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.bindings = [];
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                object.etag = message.etag;
                                if (options.oneofs)
                                    object._etag = "etag";
                            }
                            if (message.policy != null && message.hasOwnProperty("policy")) {
                                object.policy = $root.google.cloud.compute.v1.Policy.toObject(message.policy, options);
                                if (options.oneofs)
                                    object._policy = "policy";
                            }
                            if (message.bindings && message.bindings.length) {
                                object.bindings = [];
                                for (var j = 0; j < message.bindings.length; ++j)
                                    object.bindings[j] = $root.google.cloud.compute.v1.Binding.toObject(message.bindings[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GlobalOrganizationSetPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GlobalOrganizationSetPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GlobalOrganizationSetPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GlobalOrganizationSetPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest";
                        };
    
                        return GlobalOrganizationSetPolicyRequest;
                    })();
    
                    v1.GlobalSetLabelsRequest = (function() {
    
                        /**
                         * Properties of a GlobalSetLabelsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGlobalSetLabelsRequest
                         * @property {string|null} [labelFingerprint] GlobalSetLabelsRequest labelFingerprint
                         * @property {Object.<string,string>|null} [labels] GlobalSetLabelsRequest labels
                         */
    
                        /**
                         * Constructs a new GlobalSetLabelsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GlobalSetLabelsRequest.
                         * @implements IGlobalSetLabelsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGlobalSetLabelsRequest=} [properties] Properties to set
                         */
                        function GlobalSetLabelsRequest(properties) {
                            this.labels = {};
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GlobalSetLabelsRequest labelFingerprint.
                         * @member {string|null|undefined} labelFingerprint
                         * @memberof google.cloud.compute.v1.GlobalSetLabelsRequest
                         * @instance
                         */
                        GlobalSetLabelsRequest.prototype.labelFingerprint = null;
    
                        /**
                         * GlobalSetLabelsRequest labels.
                         * @member {Object.<string,string>} labels
                         * @memberof google.cloud.compute.v1.GlobalSetLabelsRequest
                         * @instance
                         */
                        GlobalSetLabelsRequest.prototype.labels = $util.emptyObject;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GlobalSetLabelsRequest _labelFingerprint.
                         * @member {"labelFingerprint"|undefined} _labelFingerprint
                         * @memberof google.cloud.compute.v1.GlobalSetLabelsRequest
                         * @instance
                         */
                        Object.defineProperty(GlobalSetLabelsRequest.prototype, "_labelFingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["labelFingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GlobalSetLabelsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GlobalSetLabelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGlobalSetLabelsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GlobalSetLabelsRequest} GlobalSetLabelsRequest instance
                         */
                        GlobalSetLabelsRequest.create = function create(properties) {
                            return new GlobalSetLabelsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GlobalSetLabelsRequest message. Does not implicitly {@link google.cloud.compute.v1.GlobalSetLabelsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GlobalSetLabelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGlobalSetLabelsRequest} message GlobalSetLabelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GlobalSetLabelsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.labelFingerprint != null && Object.hasOwnProperty.call(message, "labelFingerprint"))
                                writer.uint32(/* id 178124825, wireType 2 =*/1424998602).string(message.labelFingerprint);
                            if (message.labels != null && Object.hasOwnProperty.call(message, "labels"))
                                for (var keys = Object.keys(message.labels), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 500195327, wireType 2 =*/4001562618).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.labels[keys[i]]).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GlobalSetLabelsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GlobalSetLabelsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GlobalSetLabelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGlobalSetLabelsRequest} message GlobalSetLabelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GlobalSetLabelsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GlobalSetLabelsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GlobalSetLabelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GlobalSetLabelsRequest} GlobalSetLabelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GlobalSetLabelsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GlobalSetLabelsRequest(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 178124825: {
                                        message.labelFingerprint = reader.string();
                                        break;
                                    }
                                case 500195327: {
                                        if (message.labels === $util.emptyObject)
                                            message.labels = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.labels[key] = value;
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GlobalSetLabelsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GlobalSetLabelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GlobalSetLabelsRequest} GlobalSetLabelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GlobalSetLabelsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GlobalSetLabelsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GlobalSetLabelsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GlobalSetLabelsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                properties._labelFingerprint = 1;
                                if (!$util.isString(message.labelFingerprint))
                                    return "labelFingerprint: string expected";
                            }
                            if (message.labels != null && message.hasOwnProperty("labels")) {
                                if (!$util.isObject(message.labels))
                                    return "labels: object expected";
                                var key = Object.keys(message.labels);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.labels[key[i]]))
                                        return "labels: string{k:string} expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a GlobalSetLabelsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GlobalSetLabelsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GlobalSetLabelsRequest} GlobalSetLabelsRequest
                         */
                        GlobalSetLabelsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GlobalSetLabelsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GlobalSetLabelsRequest();
                            if (object.labelFingerprint != null)
                                message.labelFingerprint = String(object.labelFingerprint);
                            if (object.labels) {
                                if (typeof object.labels !== "object")
                                    throw TypeError(".google.cloud.compute.v1.GlobalSetLabelsRequest.labels: object expected");
                                message.labels = {};
                                for (var keys = Object.keys(object.labels), i = 0; i < keys.length; ++i)
                                    message.labels[keys[i]] = String(object.labels[keys[i]]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GlobalSetLabelsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GlobalSetLabelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.GlobalSetLabelsRequest} message GlobalSetLabelsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GlobalSetLabelsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.objects || options.defaults)
                                object.labels = {};
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                object.labelFingerprint = message.labelFingerprint;
                                if (options.oneofs)
                                    object._labelFingerprint = "labelFingerprint";
                            }
                            var keys2;
                            if (message.labels && (keys2 = Object.keys(message.labels)).length) {
                                object.labels = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.labels[keys2[j]] = message.labels[keys2[j]];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GlobalSetLabelsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GlobalSetLabelsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GlobalSetLabelsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GlobalSetLabelsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GlobalSetLabelsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GlobalSetLabelsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GlobalSetLabelsRequest";
                        };
    
                        return GlobalSetLabelsRequest;
                    })();
    
                    v1.GlobalSetPolicyRequest = (function() {
    
                        /**
                         * Properties of a GlobalSetPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IGlobalSetPolicyRequest
                         * @property {Array.<google.cloud.compute.v1.IBinding>|null} [bindings] GlobalSetPolicyRequest bindings
                         * @property {string|null} [etag] GlobalSetPolicyRequest etag
                         * @property {google.cloud.compute.v1.IPolicy|null} [policy] GlobalSetPolicyRequest policy
                         */
    
                        /**
                         * Constructs a new GlobalSetPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GlobalSetPolicyRequest.
                         * @implements IGlobalSetPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IGlobalSetPolicyRequest=} [properties] Properties to set
                         */
                        function GlobalSetPolicyRequest(properties) {
                            this.bindings = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GlobalSetPolicyRequest bindings.
                         * @member {Array.<google.cloud.compute.v1.IBinding>} bindings
                         * @memberof google.cloud.compute.v1.GlobalSetPolicyRequest
                         * @instance
                         */
                        GlobalSetPolicyRequest.prototype.bindings = $util.emptyArray;
    
                        /**
                         * GlobalSetPolicyRequest etag.
                         * @member {string|null|undefined} etag
                         * @memberof google.cloud.compute.v1.GlobalSetPolicyRequest
                         * @instance
                         */
                        GlobalSetPolicyRequest.prototype.etag = null;
    
                        /**
                         * GlobalSetPolicyRequest policy.
                         * @member {google.cloud.compute.v1.IPolicy|null|undefined} policy
                         * @memberof google.cloud.compute.v1.GlobalSetPolicyRequest
                         * @instance
                         */
                        GlobalSetPolicyRequest.prototype.policy = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GlobalSetPolicyRequest _etag.
                         * @member {"etag"|undefined} _etag
                         * @memberof google.cloud.compute.v1.GlobalSetPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(GlobalSetPolicyRequest.prototype, "_etag", {
                            get: $util.oneOfGetter($oneOfFields = ["etag"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GlobalSetPolicyRequest _policy.
                         * @member {"policy"|undefined} _policy
                         * @memberof google.cloud.compute.v1.GlobalSetPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(GlobalSetPolicyRequest.prototype, "_policy", {
                            get: $util.oneOfGetter($oneOfFields = ["policy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GlobalSetPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GlobalSetPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGlobalSetPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GlobalSetPolicyRequest} GlobalSetPolicyRequest instance
                         */
                        GlobalSetPolicyRequest.create = function create(properties) {
                            return new GlobalSetPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GlobalSetPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.GlobalSetPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GlobalSetPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGlobalSetPolicyRequest} message GlobalSetPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GlobalSetPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.etag != null && Object.hasOwnProperty.call(message, "etag"))
                                writer.uint32(/* id 3123477, wireType 2 =*/24987818).string(message.etag);
                            if (message.policy != null && Object.hasOwnProperty.call(message, "policy"))
                                $root.google.cloud.compute.v1.Policy.encode(message.policy, writer.uint32(/* id 91071794, wireType 2 =*/728574354).fork()).ldelim();
                            if (message.bindings != null && message.bindings.length)
                                for (var i = 0; i < message.bindings.length; ++i)
                                    $root.google.cloud.compute.v1.Binding.encode(message.bindings[i], writer.uint32(/* id 403251854, wireType 2 =*/3226014834).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GlobalSetPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GlobalSetPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GlobalSetPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IGlobalSetPolicyRequest} message GlobalSetPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GlobalSetPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GlobalSetPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GlobalSetPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GlobalSetPolicyRequest} GlobalSetPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GlobalSetPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GlobalSetPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 403251854: {
                                        if (!(message.bindings && message.bindings.length))
                                            message.bindings = [];
                                        message.bindings.push($root.google.cloud.compute.v1.Binding.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3123477: {
                                        message.etag = reader.string();
                                        break;
                                    }
                                case 91071794: {
                                        message.policy = $root.google.cloud.compute.v1.Policy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GlobalSetPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GlobalSetPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GlobalSetPolicyRequest} GlobalSetPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GlobalSetPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GlobalSetPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GlobalSetPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GlobalSetPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.bindings != null && message.hasOwnProperty("bindings")) {
                                if (!Array.isArray(message.bindings))
                                    return "bindings: array expected";
                                for (var i = 0; i < message.bindings.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Binding.verify(message.bindings[i]);
                                    if (error)
                                        return "bindings." + error;
                                }
                            }
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                properties._etag = 1;
                                if (!$util.isString(message.etag))
                                    return "etag: string expected";
                            }
                            if (message.policy != null && message.hasOwnProperty("policy")) {
                                properties._policy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Policy.verify(message.policy);
                                    if (error)
                                        return "policy." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a GlobalSetPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GlobalSetPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GlobalSetPolicyRequest} GlobalSetPolicyRequest
                         */
                        GlobalSetPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GlobalSetPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GlobalSetPolicyRequest();
                            if (object.bindings) {
                                if (!Array.isArray(object.bindings))
                                    throw TypeError(".google.cloud.compute.v1.GlobalSetPolicyRequest.bindings: array expected");
                                message.bindings = [];
                                for (var i = 0; i < object.bindings.length; ++i) {
                                    if (typeof object.bindings[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.GlobalSetPolicyRequest.bindings: object expected");
                                    message.bindings[i] = $root.google.cloud.compute.v1.Binding.fromObject(object.bindings[i]);
                                }
                            }
                            if (object.etag != null)
                                message.etag = String(object.etag);
                            if (object.policy != null) {
                                if (typeof object.policy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.GlobalSetPolicyRequest.policy: object expected");
                                message.policy = $root.google.cloud.compute.v1.Policy.fromObject(object.policy);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GlobalSetPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GlobalSetPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.GlobalSetPolicyRequest} message GlobalSetPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GlobalSetPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.bindings = [];
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                object.etag = message.etag;
                                if (options.oneofs)
                                    object._etag = "etag";
                            }
                            if (message.policy != null && message.hasOwnProperty("policy")) {
                                object.policy = $root.google.cloud.compute.v1.Policy.toObject(message.policy, options);
                                if (options.oneofs)
                                    object._policy = "policy";
                            }
                            if (message.bindings && message.bindings.length) {
                                object.bindings = [];
                                for (var j = 0; j < message.bindings.length; ++j)
                                    object.bindings[j] = $root.google.cloud.compute.v1.Binding.toObject(message.bindings[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GlobalSetPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GlobalSetPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GlobalSetPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GlobalSetPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GlobalSetPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GlobalSetPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GlobalSetPolicyRequest";
                        };
    
                        return GlobalSetPolicyRequest;
                    })();
    
                    v1.GuestAttributes = (function() {
    
                        /**
                         * Properties of a GuestAttributes.
                         * @memberof google.cloud.compute.v1
                         * @interface IGuestAttributes
                         * @property {string|null} [kind] GuestAttributes kind
                         * @property {string|null} [queryPath] GuestAttributes queryPath
                         * @property {google.cloud.compute.v1.IGuestAttributesValue|null} [queryValue] GuestAttributes queryValue
                         * @property {string|null} [selfLink] GuestAttributes selfLink
                         * @property {string|null} [variableKey] GuestAttributes variableKey
                         * @property {string|null} [variableValue] GuestAttributes variableValue
                         */
    
                        /**
                         * Constructs a new GuestAttributes.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GuestAttributes.
                         * @implements IGuestAttributes
                         * @constructor
                         * @param {google.cloud.compute.v1.IGuestAttributes=} [properties] Properties to set
                         */
                        function GuestAttributes(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GuestAttributes kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @instance
                         */
                        GuestAttributes.prototype.kind = null;
    
                        /**
                         * GuestAttributes queryPath.
                         * @member {string|null|undefined} queryPath
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @instance
                         */
                        GuestAttributes.prototype.queryPath = null;
    
                        /**
                         * GuestAttributes queryValue.
                         * @member {google.cloud.compute.v1.IGuestAttributesValue|null|undefined} queryValue
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @instance
                         */
                        GuestAttributes.prototype.queryValue = null;
    
                        /**
                         * GuestAttributes selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @instance
                         */
                        GuestAttributes.prototype.selfLink = null;
    
                        /**
                         * GuestAttributes variableKey.
                         * @member {string|null|undefined} variableKey
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @instance
                         */
                        GuestAttributes.prototype.variableKey = null;
    
                        /**
                         * GuestAttributes variableValue.
                         * @member {string|null|undefined} variableValue
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @instance
                         */
                        GuestAttributes.prototype.variableValue = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GuestAttributes _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @instance
                         */
                        Object.defineProperty(GuestAttributes.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GuestAttributes _queryPath.
                         * @member {"queryPath"|undefined} _queryPath
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @instance
                         */
                        Object.defineProperty(GuestAttributes.prototype, "_queryPath", {
                            get: $util.oneOfGetter($oneOfFields = ["queryPath"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GuestAttributes _queryValue.
                         * @member {"queryValue"|undefined} _queryValue
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @instance
                         */
                        Object.defineProperty(GuestAttributes.prototype, "_queryValue", {
                            get: $util.oneOfGetter($oneOfFields = ["queryValue"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GuestAttributes _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @instance
                         */
                        Object.defineProperty(GuestAttributes.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GuestAttributes _variableKey.
                         * @member {"variableKey"|undefined} _variableKey
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @instance
                         */
                        Object.defineProperty(GuestAttributes.prototype, "_variableKey", {
                            get: $util.oneOfGetter($oneOfFields = ["variableKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GuestAttributes _variableValue.
                         * @member {"variableValue"|undefined} _variableValue
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @instance
                         */
                        Object.defineProperty(GuestAttributes.prototype, "_variableValue", {
                            get: $util.oneOfGetter($oneOfFields = ["variableValue"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GuestAttributes instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @static
                         * @param {google.cloud.compute.v1.IGuestAttributes=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GuestAttributes} GuestAttributes instance
                         */
                        GuestAttributes.create = function create(properties) {
                            return new GuestAttributes(properties);
                        };
    
                        /**
                         * Encodes the specified GuestAttributes message. Does not implicitly {@link google.cloud.compute.v1.GuestAttributes.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @static
                         * @param {google.cloud.compute.v1.IGuestAttributes} message GuestAttributes message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GuestAttributes.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.variableValue != null && Object.hasOwnProperty.call(message, "variableValue"))
                                writer.uint32(/* id 124582382, wireType 2 =*/996659058).string(message.variableValue);
                            if (message.queryValue != null && Object.hasOwnProperty.call(message, "queryValue"))
                                $root.google.cloud.compute.v1.GuestAttributesValue.encode(message.queryValue, writer.uint32(/* id 157570874, wireType 2 =*/1260566994).fork()).ldelim();
                            if (message.variableKey != null && Object.hasOwnProperty.call(message, "variableKey"))
                                writer.uint32(/* id 164364828, wireType 2 =*/1314918626).string(message.variableKey);
                            if (message.queryPath != null && Object.hasOwnProperty.call(message, "queryPath"))
                                writer.uint32(/* id 368591164, wireType 2 =*/2948729314).string(message.queryPath);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GuestAttributes message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GuestAttributes.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @static
                         * @param {google.cloud.compute.v1.IGuestAttributes} message GuestAttributes message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GuestAttributes.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GuestAttributes message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GuestAttributes} GuestAttributes
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GuestAttributes.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GuestAttributes();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 368591164: {
                                        message.queryPath = reader.string();
                                        break;
                                    }
                                case 157570874: {
                                        message.queryValue = $root.google.cloud.compute.v1.GuestAttributesValue.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 164364828: {
                                        message.variableKey = reader.string();
                                        break;
                                    }
                                case 124582382: {
                                        message.variableValue = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GuestAttributes message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GuestAttributes} GuestAttributes
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GuestAttributes.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GuestAttributes message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GuestAttributes.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.queryPath != null && message.hasOwnProperty("queryPath")) {
                                properties._queryPath = 1;
                                if (!$util.isString(message.queryPath))
                                    return "queryPath: string expected";
                            }
                            if (message.queryValue != null && message.hasOwnProperty("queryValue")) {
                                properties._queryValue = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.GuestAttributesValue.verify(message.queryValue);
                                    if (error)
                                        return "queryValue." + error;
                                }
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.variableKey != null && message.hasOwnProperty("variableKey")) {
                                properties._variableKey = 1;
                                if (!$util.isString(message.variableKey))
                                    return "variableKey: string expected";
                            }
                            if (message.variableValue != null && message.hasOwnProperty("variableValue")) {
                                properties._variableValue = 1;
                                if (!$util.isString(message.variableValue))
                                    return "variableValue: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a GuestAttributes message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GuestAttributes} GuestAttributes
                         */
                        GuestAttributes.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GuestAttributes)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GuestAttributes();
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.queryPath != null)
                                message.queryPath = String(object.queryPath);
                            if (object.queryValue != null) {
                                if (typeof object.queryValue !== "object")
                                    throw TypeError(".google.cloud.compute.v1.GuestAttributes.queryValue: object expected");
                                message.queryValue = $root.google.cloud.compute.v1.GuestAttributesValue.fromObject(object.queryValue);
                            }
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.variableKey != null)
                                message.variableKey = String(object.variableKey);
                            if (object.variableValue != null)
                                message.variableValue = String(object.variableValue);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GuestAttributes message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @static
                         * @param {google.cloud.compute.v1.GuestAttributes} message GuestAttributes
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GuestAttributes.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.variableValue != null && message.hasOwnProperty("variableValue")) {
                                object.variableValue = message.variableValue;
                                if (options.oneofs)
                                    object._variableValue = "variableValue";
                            }
                            if (message.queryValue != null && message.hasOwnProperty("queryValue")) {
                                object.queryValue = $root.google.cloud.compute.v1.GuestAttributesValue.toObject(message.queryValue, options);
                                if (options.oneofs)
                                    object._queryValue = "queryValue";
                            }
                            if (message.variableKey != null && message.hasOwnProperty("variableKey")) {
                                object.variableKey = message.variableKey;
                                if (options.oneofs)
                                    object._variableKey = "variableKey";
                            }
                            if (message.queryPath != null && message.hasOwnProperty("queryPath")) {
                                object.queryPath = message.queryPath;
                                if (options.oneofs)
                                    object._queryPath = "queryPath";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GuestAttributes to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GuestAttributes.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GuestAttributes
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GuestAttributes
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GuestAttributes.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GuestAttributes";
                        };
    
                        return GuestAttributes;
                    })();
    
                    v1.GuestAttributesEntry = (function() {
    
                        /**
                         * Properties of a GuestAttributesEntry.
                         * @memberof google.cloud.compute.v1
                         * @interface IGuestAttributesEntry
                         * @property {string|null} [key] GuestAttributesEntry key
                         * @property {string|null} [namespace] GuestAttributesEntry namespace
                         * @property {string|null} [value] GuestAttributesEntry value
                         */
    
                        /**
                         * Constructs a new GuestAttributesEntry.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GuestAttributesEntry.
                         * @implements IGuestAttributesEntry
                         * @constructor
                         * @param {google.cloud.compute.v1.IGuestAttributesEntry=} [properties] Properties to set
                         */
                        function GuestAttributesEntry(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GuestAttributesEntry key.
                         * @member {string|null|undefined} key
                         * @memberof google.cloud.compute.v1.GuestAttributesEntry
                         * @instance
                         */
                        GuestAttributesEntry.prototype.key = null;
    
                        /**
                         * GuestAttributesEntry namespace.
                         * @member {string|null|undefined} namespace
                         * @memberof google.cloud.compute.v1.GuestAttributesEntry
                         * @instance
                         */
                        GuestAttributesEntry.prototype.namespace = null;
    
                        /**
                         * GuestAttributesEntry value.
                         * @member {string|null|undefined} value
                         * @memberof google.cloud.compute.v1.GuestAttributesEntry
                         * @instance
                         */
                        GuestAttributesEntry.prototype.value = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GuestAttributesEntry _key.
                         * @member {"key"|undefined} _key
                         * @memberof google.cloud.compute.v1.GuestAttributesEntry
                         * @instance
                         */
                        Object.defineProperty(GuestAttributesEntry.prototype, "_key", {
                            get: $util.oneOfGetter($oneOfFields = ["key"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GuestAttributesEntry _namespace.
                         * @member {"namespace"|undefined} _namespace
                         * @memberof google.cloud.compute.v1.GuestAttributesEntry
                         * @instance
                         */
                        Object.defineProperty(GuestAttributesEntry.prototype, "_namespace", {
                            get: $util.oneOfGetter($oneOfFields = ["namespace"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * GuestAttributesEntry _value.
                         * @member {"value"|undefined} _value
                         * @memberof google.cloud.compute.v1.GuestAttributesEntry
                         * @instance
                         */
                        Object.defineProperty(GuestAttributesEntry.prototype, "_value", {
                            get: $util.oneOfGetter($oneOfFields = ["value"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GuestAttributesEntry instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GuestAttributesEntry
                         * @static
                         * @param {google.cloud.compute.v1.IGuestAttributesEntry=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GuestAttributesEntry} GuestAttributesEntry instance
                         */
                        GuestAttributesEntry.create = function create(properties) {
                            return new GuestAttributesEntry(properties);
                        };
    
                        /**
                         * Encodes the specified GuestAttributesEntry message. Does not implicitly {@link google.cloud.compute.v1.GuestAttributesEntry.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GuestAttributesEntry
                         * @static
                         * @param {google.cloud.compute.v1.IGuestAttributesEntry} message GuestAttributesEntry message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GuestAttributesEntry.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.key != null && Object.hasOwnProperty.call(message, "key"))
                                writer.uint32(/* id 106079, wireType 2 =*/848634).string(message.key);
                            if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                writer.uint32(/* id 111972721, wireType 2 =*/895781770).string(message.value);
                            if (message.namespace != null && Object.hasOwnProperty.call(message, "namespace"))
                                writer.uint32(/* id 178476379, wireType 2 =*/1427811034).string(message.namespace);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GuestAttributesEntry message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GuestAttributesEntry.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GuestAttributesEntry
                         * @static
                         * @param {google.cloud.compute.v1.IGuestAttributesEntry} message GuestAttributesEntry message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GuestAttributesEntry.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GuestAttributesEntry message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GuestAttributesEntry
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GuestAttributesEntry} GuestAttributesEntry
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GuestAttributesEntry.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GuestAttributesEntry();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 106079: {
                                        message.key = reader.string();
                                        break;
                                    }
                                case 178476379: {
                                        message.namespace = reader.string();
                                        break;
                                    }
                                case 111972721: {
                                        message.value = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GuestAttributesEntry message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GuestAttributesEntry
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GuestAttributesEntry} GuestAttributesEntry
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GuestAttributesEntry.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GuestAttributesEntry message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GuestAttributesEntry
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GuestAttributesEntry.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.key != null && message.hasOwnProperty("key")) {
                                properties._key = 1;
                                if (!$util.isString(message.key))
                                    return "key: string expected";
                            }
                            if (message.namespace != null && message.hasOwnProperty("namespace")) {
                                properties._namespace = 1;
                                if (!$util.isString(message.namespace))
                                    return "namespace: string expected";
                            }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                properties._value = 1;
                                if (!$util.isString(message.value))
                                    return "value: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a GuestAttributesEntry message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GuestAttributesEntry
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GuestAttributesEntry} GuestAttributesEntry
                         */
                        GuestAttributesEntry.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GuestAttributesEntry)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GuestAttributesEntry();
                            if (object.key != null)
                                message.key = String(object.key);
                            if (object.namespace != null)
                                message.namespace = String(object.namespace);
                            if (object.value != null)
                                message.value = String(object.value);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GuestAttributesEntry message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GuestAttributesEntry
                         * @static
                         * @param {google.cloud.compute.v1.GuestAttributesEntry} message GuestAttributesEntry
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GuestAttributesEntry.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.key != null && message.hasOwnProperty("key")) {
                                object.key = message.key;
                                if (options.oneofs)
                                    object._key = "key";
                            }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                object.value = message.value;
                                if (options.oneofs)
                                    object._value = "value";
                            }
                            if (message.namespace != null && message.hasOwnProperty("namespace")) {
                                object.namespace = message.namespace;
                                if (options.oneofs)
                                    object._namespace = "namespace";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GuestAttributesEntry to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GuestAttributesEntry
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GuestAttributesEntry.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GuestAttributesEntry
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GuestAttributesEntry
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GuestAttributesEntry.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GuestAttributesEntry";
                        };
    
                        return GuestAttributesEntry;
                    })();
    
                    v1.GuestAttributesValue = (function() {
    
                        /**
                         * Properties of a GuestAttributesValue.
                         * @memberof google.cloud.compute.v1
                         * @interface IGuestAttributesValue
                         * @property {Array.<google.cloud.compute.v1.IGuestAttributesEntry>|null} [items] GuestAttributesValue items
                         */
    
                        /**
                         * Constructs a new GuestAttributesValue.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GuestAttributesValue.
                         * @implements IGuestAttributesValue
                         * @constructor
                         * @param {google.cloud.compute.v1.IGuestAttributesValue=} [properties] Properties to set
                         */
                        function GuestAttributesValue(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GuestAttributesValue items.
                         * @member {Array.<google.cloud.compute.v1.IGuestAttributesEntry>} items
                         * @memberof google.cloud.compute.v1.GuestAttributesValue
                         * @instance
                         */
                        GuestAttributesValue.prototype.items = $util.emptyArray;
    
                        /**
                         * Creates a new GuestAttributesValue instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GuestAttributesValue
                         * @static
                         * @param {google.cloud.compute.v1.IGuestAttributesValue=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GuestAttributesValue} GuestAttributesValue instance
                         */
                        GuestAttributesValue.create = function create(properties) {
                            return new GuestAttributesValue(properties);
                        };
    
                        /**
                         * Encodes the specified GuestAttributesValue message. Does not implicitly {@link google.cloud.compute.v1.GuestAttributesValue.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GuestAttributesValue
                         * @static
                         * @param {google.cloud.compute.v1.IGuestAttributesValue} message GuestAttributesValue message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GuestAttributesValue.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.GuestAttributesEntry.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GuestAttributesValue message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GuestAttributesValue.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GuestAttributesValue
                         * @static
                         * @param {google.cloud.compute.v1.IGuestAttributesValue} message GuestAttributesValue message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GuestAttributesValue.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GuestAttributesValue message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GuestAttributesValue
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GuestAttributesValue} GuestAttributesValue
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GuestAttributesValue.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GuestAttributesValue();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.GuestAttributesEntry.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GuestAttributesValue message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GuestAttributesValue
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GuestAttributesValue} GuestAttributesValue
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GuestAttributesValue.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GuestAttributesValue message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GuestAttributesValue
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GuestAttributesValue.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.GuestAttributesEntry.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a GuestAttributesValue message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GuestAttributesValue
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GuestAttributesValue} GuestAttributesValue
                         */
                        GuestAttributesValue.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GuestAttributesValue)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GuestAttributesValue();
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.GuestAttributesValue.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.GuestAttributesValue.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.GuestAttributesEntry.fromObject(object.items[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GuestAttributesValue message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GuestAttributesValue
                         * @static
                         * @param {google.cloud.compute.v1.GuestAttributesValue} message GuestAttributesValue
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GuestAttributesValue.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.GuestAttributesEntry.toObject(message.items[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GuestAttributesValue to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GuestAttributesValue
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GuestAttributesValue.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GuestAttributesValue
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GuestAttributesValue
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GuestAttributesValue.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GuestAttributesValue";
                        };
    
                        return GuestAttributesValue;
                    })();
    
                    v1.GuestOsFeature = (function() {
    
                        /**
                         * Properties of a GuestOsFeature.
                         * @memberof google.cloud.compute.v1
                         * @interface IGuestOsFeature
                         * @property {string|null} [type] GuestOsFeature type
                         */
    
                        /**
                         * Constructs a new GuestOsFeature.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GuestOsFeature.
                         * @implements IGuestOsFeature
                         * @constructor
                         * @param {google.cloud.compute.v1.IGuestOsFeature=} [properties] Properties to set
                         */
                        function GuestOsFeature(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GuestOsFeature type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.GuestOsFeature
                         * @instance
                         */
                        GuestOsFeature.prototype.type = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * GuestOsFeature _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.GuestOsFeature
                         * @instance
                         */
                        Object.defineProperty(GuestOsFeature.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new GuestOsFeature instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.GuestOsFeature
                         * @static
                         * @param {google.cloud.compute.v1.IGuestOsFeature=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.GuestOsFeature} GuestOsFeature instance
                         */
                        GuestOsFeature.create = function create(properties) {
                            return new GuestOsFeature(properties);
                        };
    
                        /**
                         * Encodes the specified GuestOsFeature message. Does not implicitly {@link google.cloud.compute.v1.GuestOsFeature.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.GuestOsFeature
                         * @static
                         * @param {google.cloud.compute.v1.IGuestOsFeature} message GuestOsFeature message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GuestOsFeature.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GuestOsFeature message, length delimited. Does not implicitly {@link google.cloud.compute.v1.GuestOsFeature.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.GuestOsFeature
                         * @static
                         * @param {google.cloud.compute.v1.IGuestOsFeature} message GuestOsFeature message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GuestOsFeature.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GuestOsFeature message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.GuestOsFeature
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.GuestOsFeature} GuestOsFeature
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GuestOsFeature.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.GuestOsFeature();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GuestOsFeature message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.GuestOsFeature
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.GuestOsFeature} GuestOsFeature
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GuestOsFeature.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GuestOsFeature message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.GuestOsFeature
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GuestOsFeature.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a GuestOsFeature message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.GuestOsFeature
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.GuestOsFeature} GuestOsFeature
                         */
                        GuestOsFeature.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.GuestOsFeature)
                                return object;
                            var message = new $root.google.cloud.compute.v1.GuestOsFeature();
                            if (object.type != null)
                                message.type = String(object.type);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GuestOsFeature message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.GuestOsFeature
                         * @static
                         * @param {google.cloud.compute.v1.GuestOsFeature} message GuestOsFeature
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GuestOsFeature.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this GuestOsFeature to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.GuestOsFeature
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GuestOsFeature.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GuestOsFeature
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.GuestOsFeature
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GuestOsFeature.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.GuestOsFeature";
                        };
    
                        /**
                         * Type enum.
                         * @name google.cloud.compute.v1.GuestOsFeature.Type
                         * @enum {number}
                         * @property {number} UNDEFINED_TYPE=0 UNDEFINED_TYPE value
                         * @property {number} FEATURE_TYPE_UNSPECIFIED=531767259 FEATURE_TYPE_UNSPECIFIED value
                         * @property {number} GVNIC=68209305 GVNIC value
                         * @property {number} MULTI_IP_SUBNET=151776719 MULTI_IP_SUBNET value
                         * @property {number} SECURE_BOOT=376811194 SECURE_BOOT value
                         * @property {number} SEV_CAPABLE=87083793 SEV_CAPABLE value
                         * @property {number} UEFI_COMPATIBLE=195865408 UEFI_COMPATIBLE value
                         * @property {number} VIRTIO_SCSI_MULTIQUEUE=201597069 VIRTIO_SCSI_MULTIQUEUE value
                         * @property {number} WINDOWS=456863331 WINDOWS value
                         */
                        GuestOsFeature.Type = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TYPE"] = 0;
                            values[valuesById[531767259] = "FEATURE_TYPE_UNSPECIFIED"] = 531767259;
                            values[valuesById[68209305] = "GVNIC"] = 68209305;
                            values[valuesById[151776719] = "MULTI_IP_SUBNET"] = 151776719;
                            values[valuesById[376811194] = "SECURE_BOOT"] = 376811194;
                            values[valuesById[87083793] = "SEV_CAPABLE"] = 87083793;
                            values[valuesById[195865408] = "UEFI_COMPATIBLE"] = 195865408;
                            values[valuesById[201597069] = "VIRTIO_SCSI_MULTIQUEUE"] = 201597069;
                            values[valuesById[456863331] = "WINDOWS"] = 456863331;
                            return values;
                        })();
    
                        return GuestOsFeature;
                    })();
    
                    v1.HTTP2HealthCheck = (function() {
    
                        /**
                         * Properties of a HTTP2HealthCheck.
                         * @memberof google.cloud.compute.v1
                         * @interface IHTTP2HealthCheck
                         * @property {string|null} [host] HTTP2HealthCheck host
                         * @property {number|null} [port] HTTP2HealthCheck port
                         * @property {string|null} [portName] HTTP2HealthCheck portName
                         * @property {string|null} [portSpecification] HTTP2HealthCheck portSpecification
                         * @property {string|null} [proxyHeader] HTTP2HealthCheck proxyHeader
                         * @property {string|null} [requestPath] HTTP2HealthCheck requestPath
                         * @property {string|null} [response] HTTP2HealthCheck response
                         */
    
                        /**
                         * Constructs a new HTTP2HealthCheck.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HTTP2HealthCheck.
                         * @implements IHTTP2HealthCheck
                         * @constructor
                         * @param {google.cloud.compute.v1.IHTTP2HealthCheck=} [properties] Properties to set
                         */
                        function HTTP2HealthCheck(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HTTP2HealthCheck host.
                         * @member {string|null|undefined} host
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @instance
                         */
                        HTTP2HealthCheck.prototype.host = null;
    
                        /**
                         * HTTP2HealthCheck port.
                         * @member {number|null|undefined} port
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @instance
                         */
                        HTTP2HealthCheck.prototype.port = null;
    
                        /**
                         * HTTP2HealthCheck portName.
                         * @member {string|null|undefined} portName
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @instance
                         */
                        HTTP2HealthCheck.prototype.portName = null;
    
                        /**
                         * HTTP2HealthCheck portSpecification.
                         * @member {string|null|undefined} portSpecification
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @instance
                         */
                        HTTP2HealthCheck.prototype.portSpecification = null;
    
                        /**
                         * HTTP2HealthCheck proxyHeader.
                         * @member {string|null|undefined} proxyHeader
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @instance
                         */
                        HTTP2HealthCheck.prototype.proxyHeader = null;
    
                        /**
                         * HTTP2HealthCheck requestPath.
                         * @member {string|null|undefined} requestPath
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @instance
                         */
                        HTTP2HealthCheck.prototype.requestPath = null;
    
                        /**
                         * HTTP2HealthCheck response.
                         * @member {string|null|undefined} response
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @instance
                         */
                        HTTP2HealthCheck.prototype.response = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HTTP2HealthCheck _host.
                         * @member {"host"|undefined} _host
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTP2HealthCheck.prototype, "_host", {
                            get: $util.oneOfGetter($oneOfFields = ["host"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HTTP2HealthCheck _port.
                         * @member {"port"|undefined} _port
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTP2HealthCheck.prototype, "_port", {
                            get: $util.oneOfGetter($oneOfFields = ["port"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HTTP2HealthCheck _portName.
                         * @member {"portName"|undefined} _portName
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTP2HealthCheck.prototype, "_portName", {
                            get: $util.oneOfGetter($oneOfFields = ["portName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HTTP2HealthCheck _portSpecification.
                         * @member {"portSpecification"|undefined} _portSpecification
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTP2HealthCheck.prototype, "_portSpecification", {
                            get: $util.oneOfGetter($oneOfFields = ["portSpecification"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HTTP2HealthCheck _proxyHeader.
                         * @member {"proxyHeader"|undefined} _proxyHeader
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTP2HealthCheck.prototype, "_proxyHeader", {
                            get: $util.oneOfGetter($oneOfFields = ["proxyHeader"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HTTP2HealthCheck _requestPath.
                         * @member {"requestPath"|undefined} _requestPath
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTP2HealthCheck.prototype, "_requestPath", {
                            get: $util.oneOfGetter($oneOfFields = ["requestPath"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HTTP2HealthCheck _response.
                         * @member {"response"|undefined} _response
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTP2HealthCheck.prototype, "_response", {
                            get: $util.oneOfGetter($oneOfFields = ["response"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HTTP2HealthCheck instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.IHTTP2HealthCheck=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HTTP2HealthCheck} HTTP2HealthCheck instance
                         */
                        HTTP2HealthCheck.create = function create(properties) {
                            return new HTTP2HealthCheck(properties);
                        };
    
                        /**
                         * Encodes the specified HTTP2HealthCheck message. Does not implicitly {@link google.cloud.compute.v1.HTTP2HealthCheck.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.IHTTP2HealthCheck} message HTTP2HealthCheck message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HTTP2HealthCheck.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.host != null && Object.hasOwnProperty.call(message, "host"))
                                writer.uint32(/* id 3208616, wireType 2 =*/25668930).string(message.host);
                            if (message.port != null && Object.hasOwnProperty.call(message, "port"))
                                writer.uint32(/* id 3446913, wireType 0 =*/27575304).int32(message.port);
                            if (message.portName != null && Object.hasOwnProperty.call(message, "portName"))
                                writer.uint32(/* id 41534345, wireType 2 =*/332274762).string(message.portName);
                            if (message.portSpecification != null && Object.hasOwnProperty.call(message, "portSpecification"))
                                writer.uint32(/* id 51590597, wireType 2 =*/412724778).string(message.portSpecification);
                            if (message.proxyHeader != null && Object.hasOwnProperty.call(message, "proxyHeader"))
                                writer.uint32(/* id 160374142, wireType 2 =*/1282993138).string(message.proxyHeader);
                            if (message.response != null && Object.hasOwnProperty.call(message, "response"))
                                writer.uint32(/* id 196547649, wireType 2 =*/1572381194).string(message.response);
                            if (message.requestPath != null && Object.hasOwnProperty.call(message, "requestPath"))
                                writer.uint32(/* id 229403605, wireType 2 =*/1835228842).string(message.requestPath);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HTTP2HealthCheck message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HTTP2HealthCheck.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.IHTTP2HealthCheck} message HTTP2HealthCheck message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HTTP2HealthCheck.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HTTP2HealthCheck message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HTTP2HealthCheck} HTTP2HealthCheck
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HTTP2HealthCheck.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HTTP2HealthCheck();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3208616: {
                                        message.host = reader.string();
                                        break;
                                    }
                                case 3446913: {
                                        message.port = reader.int32();
                                        break;
                                    }
                                case 41534345: {
                                        message.portName = reader.string();
                                        break;
                                    }
                                case 51590597: {
                                        message.portSpecification = reader.string();
                                        break;
                                    }
                                case 160374142: {
                                        message.proxyHeader = reader.string();
                                        break;
                                    }
                                case 229403605: {
                                        message.requestPath = reader.string();
                                        break;
                                    }
                                case 196547649: {
                                        message.response = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HTTP2HealthCheck message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HTTP2HealthCheck} HTTP2HealthCheck
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HTTP2HealthCheck.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HTTP2HealthCheck message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HTTP2HealthCheck.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.host != null && message.hasOwnProperty("host")) {
                                properties._host = 1;
                                if (!$util.isString(message.host))
                                    return "host: string expected";
                            }
                            if (message.port != null && message.hasOwnProperty("port")) {
                                properties._port = 1;
                                if (!$util.isInteger(message.port))
                                    return "port: integer expected";
                            }
                            if (message.portName != null && message.hasOwnProperty("portName")) {
                                properties._portName = 1;
                                if (!$util.isString(message.portName))
                                    return "portName: string expected";
                            }
                            if (message.portSpecification != null && message.hasOwnProperty("portSpecification")) {
                                properties._portSpecification = 1;
                                if (!$util.isString(message.portSpecification))
                                    return "portSpecification: string expected";
                            }
                            if (message.proxyHeader != null && message.hasOwnProperty("proxyHeader")) {
                                properties._proxyHeader = 1;
                                if (!$util.isString(message.proxyHeader))
                                    return "proxyHeader: string expected";
                            }
                            if (message.requestPath != null && message.hasOwnProperty("requestPath")) {
                                properties._requestPath = 1;
                                if (!$util.isString(message.requestPath))
                                    return "requestPath: string expected";
                            }
                            if (message.response != null && message.hasOwnProperty("response")) {
                                properties._response = 1;
                                if (!$util.isString(message.response))
                                    return "response: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HTTP2HealthCheck message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HTTP2HealthCheck} HTTP2HealthCheck
                         */
                        HTTP2HealthCheck.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HTTP2HealthCheck)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HTTP2HealthCheck();
                            if (object.host != null)
                                message.host = String(object.host);
                            if (object.port != null)
                                message.port = object.port | 0;
                            if (object.portName != null)
                                message.portName = String(object.portName);
                            if (object.portSpecification != null)
                                message.portSpecification = String(object.portSpecification);
                            if (object.proxyHeader != null)
                                message.proxyHeader = String(object.proxyHeader);
                            if (object.requestPath != null)
                                message.requestPath = String(object.requestPath);
                            if (object.response != null)
                                message.response = String(object.response);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HTTP2HealthCheck message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.HTTP2HealthCheck} message HTTP2HealthCheck
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HTTP2HealthCheck.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.host != null && message.hasOwnProperty("host")) {
                                object.host = message.host;
                                if (options.oneofs)
                                    object._host = "host";
                            }
                            if (message.port != null && message.hasOwnProperty("port")) {
                                object.port = message.port;
                                if (options.oneofs)
                                    object._port = "port";
                            }
                            if (message.portName != null && message.hasOwnProperty("portName")) {
                                object.portName = message.portName;
                                if (options.oneofs)
                                    object._portName = "portName";
                            }
                            if (message.portSpecification != null && message.hasOwnProperty("portSpecification")) {
                                object.portSpecification = message.portSpecification;
                                if (options.oneofs)
                                    object._portSpecification = "portSpecification";
                            }
                            if (message.proxyHeader != null && message.hasOwnProperty("proxyHeader")) {
                                object.proxyHeader = message.proxyHeader;
                                if (options.oneofs)
                                    object._proxyHeader = "proxyHeader";
                            }
                            if (message.response != null && message.hasOwnProperty("response")) {
                                object.response = message.response;
                                if (options.oneofs)
                                    object._response = "response";
                            }
                            if (message.requestPath != null && message.hasOwnProperty("requestPath")) {
                                object.requestPath = message.requestPath;
                                if (options.oneofs)
                                    object._requestPath = "requestPath";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HTTP2HealthCheck to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HTTP2HealthCheck.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HTTP2HealthCheck
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HTTP2HealthCheck
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HTTP2HealthCheck.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HTTP2HealthCheck";
                        };
    
                        /**
                         * PortSpecification enum.
                         * @name google.cloud.compute.v1.HTTP2HealthCheck.PortSpecification
                         * @enum {number}
                         * @property {number} UNDEFINED_PORT_SPECIFICATION=0 UNDEFINED_PORT_SPECIFICATION value
                         * @property {number} USE_FIXED_PORT=190235748 USE_FIXED_PORT value
                         * @property {number} USE_NAMED_PORT=349300671 USE_NAMED_PORT value
                         * @property {number} USE_SERVING_PORT=362637516 USE_SERVING_PORT value
                         */
                        HTTP2HealthCheck.PortSpecification = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PORT_SPECIFICATION"] = 0;
                            values[valuesById[190235748] = "USE_FIXED_PORT"] = 190235748;
                            values[valuesById[349300671] = "USE_NAMED_PORT"] = 349300671;
                            values[valuesById[362637516] = "USE_SERVING_PORT"] = 362637516;
                            return values;
                        })();
    
                        /**
                         * ProxyHeader enum.
                         * @name google.cloud.compute.v1.HTTP2HealthCheck.ProxyHeader
                         * @enum {number}
                         * @property {number} UNDEFINED_PROXY_HEADER=0 UNDEFINED_PROXY_HEADER value
                         * @property {number} NONE=2402104 NONE value
                         * @property {number} PROXY_V1=334352940 PROXY_V1 value
                         */
                        HTTP2HealthCheck.ProxyHeader = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PROXY_HEADER"] = 0;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            values[valuesById[334352940] = "PROXY_V1"] = 334352940;
                            return values;
                        })();
    
                        return HTTP2HealthCheck;
                    })();
    
                    v1.HTTPHealthCheck = (function() {
    
                        /**
                         * Properties of a HTTPHealthCheck.
                         * @memberof google.cloud.compute.v1
                         * @interface IHTTPHealthCheck
                         * @property {string|null} [host] HTTPHealthCheck host
                         * @property {number|null} [port] HTTPHealthCheck port
                         * @property {string|null} [portName] HTTPHealthCheck portName
                         * @property {string|null} [portSpecification] HTTPHealthCheck portSpecification
                         * @property {string|null} [proxyHeader] HTTPHealthCheck proxyHeader
                         * @property {string|null} [requestPath] HTTPHealthCheck requestPath
                         * @property {string|null} [response] HTTPHealthCheck response
                         */
    
                        /**
                         * Constructs a new HTTPHealthCheck.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HTTPHealthCheck.
                         * @implements IHTTPHealthCheck
                         * @constructor
                         * @param {google.cloud.compute.v1.IHTTPHealthCheck=} [properties] Properties to set
                         */
                        function HTTPHealthCheck(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HTTPHealthCheck host.
                         * @member {string|null|undefined} host
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @instance
                         */
                        HTTPHealthCheck.prototype.host = null;
    
                        /**
                         * HTTPHealthCheck port.
                         * @member {number|null|undefined} port
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @instance
                         */
                        HTTPHealthCheck.prototype.port = null;
    
                        /**
                         * HTTPHealthCheck portName.
                         * @member {string|null|undefined} portName
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @instance
                         */
                        HTTPHealthCheck.prototype.portName = null;
    
                        /**
                         * HTTPHealthCheck portSpecification.
                         * @member {string|null|undefined} portSpecification
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @instance
                         */
                        HTTPHealthCheck.prototype.portSpecification = null;
    
                        /**
                         * HTTPHealthCheck proxyHeader.
                         * @member {string|null|undefined} proxyHeader
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @instance
                         */
                        HTTPHealthCheck.prototype.proxyHeader = null;
    
                        /**
                         * HTTPHealthCheck requestPath.
                         * @member {string|null|undefined} requestPath
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @instance
                         */
                        HTTPHealthCheck.prototype.requestPath = null;
    
                        /**
                         * HTTPHealthCheck response.
                         * @member {string|null|undefined} response
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @instance
                         */
                        HTTPHealthCheck.prototype.response = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HTTPHealthCheck _host.
                         * @member {"host"|undefined} _host
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTPHealthCheck.prototype, "_host", {
                            get: $util.oneOfGetter($oneOfFields = ["host"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HTTPHealthCheck _port.
                         * @member {"port"|undefined} _port
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTPHealthCheck.prototype, "_port", {
                            get: $util.oneOfGetter($oneOfFields = ["port"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HTTPHealthCheck _portName.
                         * @member {"portName"|undefined} _portName
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTPHealthCheck.prototype, "_portName", {
                            get: $util.oneOfGetter($oneOfFields = ["portName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HTTPHealthCheck _portSpecification.
                         * @member {"portSpecification"|undefined} _portSpecification
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTPHealthCheck.prototype, "_portSpecification", {
                            get: $util.oneOfGetter($oneOfFields = ["portSpecification"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HTTPHealthCheck _proxyHeader.
                         * @member {"proxyHeader"|undefined} _proxyHeader
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTPHealthCheck.prototype, "_proxyHeader", {
                            get: $util.oneOfGetter($oneOfFields = ["proxyHeader"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HTTPHealthCheck _requestPath.
                         * @member {"requestPath"|undefined} _requestPath
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTPHealthCheck.prototype, "_requestPath", {
                            get: $util.oneOfGetter($oneOfFields = ["requestPath"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HTTPHealthCheck _response.
                         * @member {"response"|undefined} _response
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTPHealthCheck.prototype, "_response", {
                            get: $util.oneOfGetter($oneOfFields = ["response"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HTTPHealthCheck instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.IHTTPHealthCheck=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HTTPHealthCheck} HTTPHealthCheck instance
                         */
                        HTTPHealthCheck.create = function create(properties) {
                            return new HTTPHealthCheck(properties);
                        };
    
                        /**
                         * Encodes the specified HTTPHealthCheck message. Does not implicitly {@link google.cloud.compute.v1.HTTPHealthCheck.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.IHTTPHealthCheck} message HTTPHealthCheck message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HTTPHealthCheck.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.host != null && Object.hasOwnProperty.call(message, "host"))
                                writer.uint32(/* id 3208616, wireType 2 =*/25668930).string(message.host);
                            if (message.port != null && Object.hasOwnProperty.call(message, "port"))
                                writer.uint32(/* id 3446913, wireType 0 =*/27575304).int32(message.port);
                            if (message.portName != null && Object.hasOwnProperty.call(message, "portName"))
                                writer.uint32(/* id 41534345, wireType 2 =*/332274762).string(message.portName);
                            if (message.portSpecification != null && Object.hasOwnProperty.call(message, "portSpecification"))
                                writer.uint32(/* id 51590597, wireType 2 =*/412724778).string(message.portSpecification);
                            if (message.proxyHeader != null && Object.hasOwnProperty.call(message, "proxyHeader"))
                                writer.uint32(/* id 160374142, wireType 2 =*/1282993138).string(message.proxyHeader);
                            if (message.response != null && Object.hasOwnProperty.call(message, "response"))
                                writer.uint32(/* id 196547649, wireType 2 =*/1572381194).string(message.response);
                            if (message.requestPath != null && Object.hasOwnProperty.call(message, "requestPath"))
                                writer.uint32(/* id 229403605, wireType 2 =*/1835228842).string(message.requestPath);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HTTPHealthCheck message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HTTPHealthCheck.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.IHTTPHealthCheck} message HTTPHealthCheck message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HTTPHealthCheck.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HTTPHealthCheck message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HTTPHealthCheck} HTTPHealthCheck
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HTTPHealthCheck.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HTTPHealthCheck();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3208616: {
                                        message.host = reader.string();
                                        break;
                                    }
                                case 3446913: {
                                        message.port = reader.int32();
                                        break;
                                    }
                                case 41534345: {
                                        message.portName = reader.string();
                                        break;
                                    }
                                case 51590597: {
                                        message.portSpecification = reader.string();
                                        break;
                                    }
                                case 160374142: {
                                        message.proxyHeader = reader.string();
                                        break;
                                    }
                                case 229403605: {
                                        message.requestPath = reader.string();
                                        break;
                                    }
                                case 196547649: {
                                        message.response = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HTTPHealthCheck message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HTTPHealthCheck} HTTPHealthCheck
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HTTPHealthCheck.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HTTPHealthCheck message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HTTPHealthCheck.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.host != null && message.hasOwnProperty("host")) {
                                properties._host = 1;
                                if (!$util.isString(message.host))
                                    return "host: string expected";
                            }
                            if (message.port != null && message.hasOwnProperty("port")) {
                                properties._port = 1;
                                if (!$util.isInteger(message.port))
                                    return "port: integer expected";
                            }
                            if (message.portName != null && message.hasOwnProperty("portName")) {
                                properties._portName = 1;
                                if (!$util.isString(message.portName))
                                    return "portName: string expected";
                            }
                            if (message.portSpecification != null && message.hasOwnProperty("portSpecification")) {
                                properties._portSpecification = 1;
                                if (!$util.isString(message.portSpecification))
                                    return "portSpecification: string expected";
                            }
                            if (message.proxyHeader != null && message.hasOwnProperty("proxyHeader")) {
                                properties._proxyHeader = 1;
                                if (!$util.isString(message.proxyHeader))
                                    return "proxyHeader: string expected";
                            }
                            if (message.requestPath != null && message.hasOwnProperty("requestPath")) {
                                properties._requestPath = 1;
                                if (!$util.isString(message.requestPath))
                                    return "requestPath: string expected";
                            }
                            if (message.response != null && message.hasOwnProperty("response")) {
                                properties._response = 1;
                                if (!$util.isString(message.response))
                                    return "response: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HTTPHealthCheck message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HTTPHealthCheck} HTTPHealthCheck
                         */
                        HTTPHealthCheck.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HTTPHealthCheck)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HTTPHealthCheck();
                            if (object.host != null)
                                message.host = String(object.host);
                            if (object.port != null)
                                message.port = object.port | 0;
                            if (object.portName != null)
                                message.portName = String(object.portName);
                            if (object.portSpecification != null)
                                message.portSpecification = String(object.portSpecification);
                            if (object.proxyHeader != null)
                                message.proxyHeader = String(object.proxyHeader);
                            if (object.requestPath != null)
                                message.requestPath = String(object.requestPath);
                            if (object.response != null)
                                message.response = String(object.response);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HTTPHealthCheck message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.HTTPHealthCheck} message HTTPHealthCheck
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HTTPHealthCheck.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.host != null && message.hasOwnProperty("host")) {
                                object.host = message.host;
                                if (options.oneofs)
                                    object._host = "host";
                            }
                            if (message.port != null && message.hasOwnProperty("port")) {
                                object.port = message.port;
                                if (options.oneofs)
                                    object._port = "port";
                            }
                            if (message.portName != null && message.hasOwnProperty("portName")) {
                                object.portName = message.portName;
                                if (options.oneofs)
                                    object._portName = "portName";
                            }
                            if (message.portSpecification != null && message.hasOwnProperty("portSpecification")) {
                                object.portSpecification = message.portSpecification;
                                if (options.oneofs)
                                    object._portSpecification = "portSpecification";
                            }
                            if (message.proxyHeader != null && message.hasOwnProperty("proxyHeader")) {
                                object.proxyHeader = message.proxyHeader;
                                if (options.oneofs)
                                    object._proxyHeader = "proxyHeader";
                            }
                            if (message.response != null && message.hasOwnProperty("response")) {
                                object.response = message.response;
                                if (options.oneofs)
                                    object._response = "response";
                            }
                            if (message.requestPath != null && message.hasOwnProperty("requestPath")) {
                                object.requestPath = message.requestPath;
                                if (options.oneofs)
                                    object._requestPath = "requestPath";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HTTPHealthCheck to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HTTPHealthCheck.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HTTPHealthCheck
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HTTPHealthCheck
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HTTPHealthCheck.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HTTPHealthCheck";
                        };
    
                        /**
                         * PortSpecification enum.
                         * @name google.cloud.compute.v1.HTTPHealthCheck.PortSpecification
                         * @enum {number}
                         * @property {number} UNDEFINED_PORT_SPECIFICATION=0 UNDEFINED_PORT_SPECIFICATION value
                         * @property {number} USE_FIXED_PORT=190235748 USE_FIXED_PORT value
                         * @property {number} USE_NAMED_PORT=349300671 USE_NAMED_PORT value
                         * @property {number} USE_SERVING_PORT=362637516 USE_SERVING_PORT value
                         */
                        HTTPHealthCheck.PortSpecification = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PORT_SPECIFICATION"] = 0;
                            values[valuesById[190235748] = "USE_FIXED_PORT"] = 190235748;
                            values[valuesById[349300671] = "USE_NAMED_PORT"] = 349300671;
                            values[valuesById[362637516] = "USE_SERVING_PORT"] = 362637516;
                            return values;
                        })();
    
                        /**
                         * ProxyHeader enum.
                         * @name google.cloud.compute.v1.HTTPHealthCheck.ProxyHeader
                         * @enum {number}
                         * @property {number} UNDEFINED_PROXY_HEADER=0 UNDEFINED_PROXY_HEADER value
                         * @property {number} NONE=2402104 NONE value
                         * @property {number} PROXY_V1=334352940 PROXY_V1 value
                         */
                        HTTPHealthCheck.ProxyHeader = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PROXY_HEADER"] = 0;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            values[valuesById[334352940] = "PROXY_V1"] = 334352940;
                            return values;
                        })();
    
                        return HTTPHealthCheck;
                    })();
    
                    v1.HTTPSHealthCheck = (function() {
    
                        /**
                         * Properties of a HTTPSHealthCheck.
                         * @memberof google.cloud.compute.v1
                         * @interface IHTTPSHealthCheck
                         * @property {string|null} [host] HTTPSHealthCheck host
                         * @property {number|null} [port] HTTPSHealthCheck port
                         * @property {string|null} [portName] HTTPSHealthCheck portName
                         * @property {string|null} [portSpecification] HTTPSHealthCheck portSpecification
                         * @property {string|null} [proxyHeader] HTTPSHealthCheck proxyHeader
                         * @property {string|null} [requestPath] HTTPSHealthCheck requestPath
                         * @property {string|null} [response] HTTPSHealthCheck response
                         */
    
                        /**
                         * Constructs a new HTTPSHealthCheck.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HTTPSHealthCheck.
                         * @implements IHTTPSHealthCheck
                         * @constructor
                         * @param {google.cloud.compute.v1.IHTTPSHealthCheck=} [properties] Properties to set
                         */
                        function HTTPSHealthCheck(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HTTPSHealthCheck host.
                         * @member {string|null|undefined} host
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @instance
                         */
                        HTTPSHealthCheck.prototype.host = null;
    
                        /**
                         * HTTPSHealthCheck port.
                         * @member {number|null|undefined} port
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @instance
                         */
                        HTTPSHealthCheck.prototype.port = null;
    
                        /**
                         * HTTPSHealthCheck portName.
                         * @member {string|null|undefined} portName
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @instance
                         */
                        HTTPSHealthCheck.prototype.portName = null;
    
                        /**
                         * HTTPSHealthCheck portSpecification.
                         * @member {string|null|undefined} portSpecification
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @instance
                         */
                        HTTPSHealthCheck.prototype.portSpecification = null;
    
                        /**
                         * HTTPSHealthCheck proxyHeader.
                         * @member {string|null|undefined} proxyHeader
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @instance
                         */
                        HTTPSHealthCheck.prototype.proxyHeader = null;
    
                        /**
                         * HTTPSHealthCheck requestPath.
                         * @member {string|null|undefined} requestPath
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @instance
                         */
                        HTTPSHealthCheck.prototype.requestPath = null;
    
                        /**
                         * HTTPSHealthCheck response.
                         * @member {string|null|undefined} response
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @instance
                         */
                        HTTPSHealthCheck.prototype.response = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HTTPSHealthCheck _host.
                         * @member {"host"|undefined} _host
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTPSHealthCheck.prototype, "_host", {
                            get: $util.oneOfGetter($oneOfFields = ["host"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HTTPSHealthCheck _port.
                         * @member {"port"|undefined} _port
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTPSHealthCheck.prototype, "_port", {
                            get: $util.oneOfGetter($oneOfFields = ["port"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HTTPSHealthCheck _portName.
                         * @member {"portName"|undefined} _portName
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTPSHealthCheck.prototype, "_portName", {
                            get: $util.oneOfGetter($oneOfFields = ["portName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HTTPSHealthCheck _portSpecification.
                         * @member {"portSpecification"|undefined} _portSpecification
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTPSHealthCheck.prototype, "_portSpecification", {
                            get: $util.oneOfGetter($oneOfFields = ["portSpecification"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HTTPSHealthCheck _proxyHeader.
                         * @member {"proxyHeader"|undefined} _proxyHeader
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTPSHealthCheck.prototype, "_proxyHeader", {
                            get: $util.oneOfGetter($oneOfFields = ["proxyHeader"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HTTPSHealthCheck _requestPath.
                         * @member {"requestPath"|undefined} _requestPath
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTPSHealthCheck.prototype, "_requestPath", {
                            get: $util.oneOfGetter($oneOfFields = ["requestPath"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HTTPSHealthCheck _response.
                         * @member {"response"|undefined} _response
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @instance
                         */
                        Object.defineProperty(HTTPSHealthCheck.prototype, "_response", {
                            get: $util.oneOfGetter($oneOfFields = ["response"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HTTPSHealthCheck instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.IHTTPSHealthCheck=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HTTPSHealthCheck} HTTPSHealthCheck instance
                         */
                        HTTPSHealthCheck.create = function create(properties) {
                            return new HTTPSHealthCheck(properties);
                        };
    
                        /**
                         * Encodes the specified HTTPSHealthCheck message. Does not implicitly {@link google.cloud.compute.v1.HTTPSHealthCheck.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.IHTTPSHealthCheck} message HTTPSHealthCheck message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HTTPSHealthCheck.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.host != null && Object.hasOwnProperty.call(message, "host"))
                                writer.uint32(/* id 3208616, wireType 2 =*/25668930).string(message.host);
                            if (message.port != null && Object.hasOwnProperty.call(message, "port"))
                                writer.uint32(/* id 3446913, wireType 0 =*/27575304).int32(message.port);
                            if (message.portName != null && Object.hasOwnProperty.call(message, "portName"))
                                writer.uint32(/* id 41534345, wireType 2 =*/332274762).string(message.portName);
                            if (message.portSpecification != null && Object.hasOwnProperty.call(message, "portSpecification"))
                                writer.uint32(/* id 51590597, wireType 2 =*/412724778).string(message.portSpecification);
                            if (message.proxyHeader != null && Object.hasOwnProperty.call(message, "proxyHeader"))
                                writer.uint32(/* id 160374142, wireType 2 =*/1282993138).string(message.proxyHeader);
                            if (message.response != null && Object.hasOwnProperty.call(message, "response"))
                                writer.uint32(/* id 196547649, wireType 2 =*/1572381194).string(message.response);
                            if (message.requestPath != null && Object.hasOwnProperty.call(message, "requestPath"))
                                writer.uint32(/* id 229403605, wireType 2 =*/1835228842).string(message.requestPath);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HTTPSHealthCheck message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HTTPSHealthCheck.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.IHTTPSHealthCheck} message HTTPSHealthCheck message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HTTPSHealthCheck.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HTTPSHealthCheck message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HTTPSHealthCheck} HTTPSHealthCheck
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HTTPSHealthCheck.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HTTPSHealthCheck();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3208616: {
                                        message.host = reader.string();
                                        break;
                                    }
                                case 3446913: {
                                        message.port = reader.int32();
                                        break;
                                    }
                                case 41534345: {
                                        message.portName = reader.string();
                                        break;
                                    }
                                case 51590597: {
                                        message.portSpecification = reader.string();
                                        break;
                                    }
                                case 160374142: {
                                        message.proxyHeader = reader.string();
                                        break;
                                    }
                                case 229403605: {
                                        message.requestPath = reader.string();
                                        break;
                                    }
                                case 196547649: {
                                        message.response = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HTTPSHealthCheck message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HTTPSHealthCheck} HTTPSHealthCheck
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HTTPSHealthCheck.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HTTPSHealthCheck message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HTTPSHealthCheck.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.host != null && message.hasOwnProperty("host")) {
                                properties._host = 1;
                                if (!$util.isString(message.host))
                                    return "host: string expected";
                            }
                            if (message.port != null && message.hasOwnProperty("port")) {
                                properties._port = 1;
                                if (!$util.isInteger(message.port))
                                    return "port: integer expected";
                            }
                            if (message.portName != null && message.hasOwnProperty("portName")) {
                                properties._portName = 1;
                                if (!$util.isString(message.portName))
                                    return "portName: string expected";
                            }
                            if (message.portSpecification != null && message.hasOwnProperty("portSpecification")) {
                                properties._portSpecification = 1;
                                if (!$util.isString(message.portSpecification))
                                    return "portSpecification: string expected";
                            }
                            if (message.proxyHeader != null && message.hasOwnProperty("proxyHeader")) {
                                properties._proxyHeader = 1;
                                if (!$util.isString(message.proxyHeader))
                                    return "proxyHeader: string expected";
                            }
                            if (message.requestPath != null && message.hasOwnProperty("requestPath")) {
                                properties._requestPath = 1;
                                if (!$util.isString(message.requestPath))
                                    return "requestPath: string expected";
                            }
                            if (message.response != null && message.hasOwnProperty("response")) {
                                properties._response = 1;
                                if (!$util.isString(message.response))
                                    return "response: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HTTPSHealthCheck message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HTTPSHealthCheck} HTTPSHealthCheck
                         */
                        HTTPSHealthCheck.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HTTPSHealthCheck)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HTTPSHealthCheck();
                            if (object.host != null)
                                message.host = String(object.host);
                            if (object.port != null)
                                message.port = object.port | 0;
                            if (object.portName != null)
                                message.portName = String(object.portName);
                            if (object.portSpecification != null)
                                message.portSpecification = String(object.portSpecification);
                            if (object.proxyHeader != null)
                                message.proxyHeader = String(object.proxyHeader);
                            if (object.requestPath != null)
                                message.requestPath = String(object.requestPath);
                            if (object.response != null)
                                message.response = String(object.response);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HTTPSHealthCheck message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.HTTPSHealthCheck} message HTTPSHealthCheck
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HTTPSHealthCheck.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.host != null && message.hasOwnProperty("host")) {
                                object.host = message.host;
                                if (options.oneofs)
                                    object._host = "host";
                            }
                            if (message.port != null && message.hasOwnProperty("port")) {
                                object.port = message.port;
                                if (options.oneofs)
                                    object._port = "port";
                            }
                            if (message.portName != null && message.hasOwnProperty("portName")) {
                                object.portName = message.portName;
                                if (options.oneofs)
                                    object._portName = "portName";
                            }
                            if (message.portSpecification != null && message.hasOwnProperty("portSpecification")) {
                                object.portSpecification = message.portSpecification;
                                if (options.oneofs)
                                    object._portSpecification = "portSpecification";
                            }
                            if (message.proxyHeader != null && message.hasOwnProperty("proxyHeader")) {
                                object.proxyHeader = message.proxyHeader;
                                if (options.oneofs)
                                    object._proxyHeader = "proxyHeader";
                            }
                            if (message.response != null && message.hasOwnProperty("response")) {
                                object.response = message.response;
                                if (options.oneofs)
                                    object._response = "response";
                            }
                            if (message.requestPath != null && message.hasOwnProperty("requestPath")) {
                                object.requestPath = message.requestPath;
                                if (options.oneofs)
                                    object._requestPath = "requestPath";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HTTPSHealthCheck to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HTTPSHealthCheck.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HTTPSHealthCheck
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HTTPSHealthCheck
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HTTPSHealthCheck.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HTTPSHealthCheck";
                        };
    
                        /**
                         * PortSpecification enum.
                         * @name google.cloud.compute.v1.HTTPSHealthCheck.PortSpecification
                         * @enum {number}
                         * @property {number} UNDEFINED_PORT_SPECIFICATION=0 UNDEFINED_PORT_SPECIFICATION value
                         * @property {number} USE_FIXED_PORT=190235748 USE_FIXED_PORT value
                         * @property {number} USE_NAMED_PORT=349300671 USE_NAMED_PORT value
                         * @property {number} USE_SERVING_PORT=362637516 USE_SERVING_PORT value
                         */
                        HTTPSHealthCheck.PortSpecification = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PORT_SPECIFICATION"] = 0;
                            values[valuesById[190235748] = "USE_FIXED_PORT"] = 190235748;
                            values[valuesById[349300671] = "USE_NAMED_PORT"] = 349300671;
                            values[valuesById[362637516] = "USE_SERVING_PORT"] = 362637516;
                            return values;
                        })();
    
                        /**
                         * ProxyHeader enum.
                         * @name google.cloud.compute.v1.HTTPSHealthCheck.ProxyHeader
                         * @enum {number}
                         * @property {number} UNDEFINED_PROXY_HEADER=0 UNDEFINED_PROXY_HEADER value
                         * @property {number} NONE=2402104 NONE value
                         * @property {number} PROXY_V1=334352940 PROXY_V1 value
                         */
                        HTTPSHealthCheck.ProxyHeader = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PROXY_HEADER"] = 0;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            values[valuesById[334352940] = "PROXY_V1"] = 334352940;
                            return values;
                        })();
    
                        return HTTPSHealthCheck;
                    })();
    
                    v1.HealthCheck = (function() {
    
                        /**
                         * Properties of a HealthCheck.
                         * @memberof google.cloud.compute.v1
                         * @interface IHealthCheck
                         * @property {number|null} [checkIntervalSec] HealthCheck checkIntervalSec
                         * @property {string|null} [creationTimestamp] HealthCheck creationTimestamp
                         * @property {string|null} [description] HealthCheck description
                         * @property {google.cloud.compute.v1.IGRPCHealthCheck|null} [grpcHealthCheck] HealthCheck grpcHealthCheck
                         * @property {number|null} [healthyThreshold] HealthCheck healthyThreshold
                         * @property {google.cloud.compute.v1.IHTTP2HealthCheck|null} [http2HealthCheck] HealthCheck http2HealthCheck
                         * @property {google.cloud.compute.v1.IHTTPHealthCheck|null} [httpHealthCheck] HealthCheck httpHealthCheck
                         * @property {google.cloud.compute.v1.IHTTPSHealthCheck|null} [httpsHealthCheck] HealthCheck httpsHealthCheck
                         * @property {number|Long|null} [id] HealthCheck id
                         * @property {string|null} [kind] HealthCheck kind
                         * @property {google.cloud.compute.v1.IHealthCheckLogConfig|null} [logConfig] HealthCheck logConfig
                         * @property {string|null} [name] HealthCheck name
                         * @property {string|null} [region] HealthCheck region
                         * @property {string|null} [selfLink] HealthCheck selfLink
                         * @property {google.cloud.compute.v1.ISSLHealthCheck|null} [sslHealthCheck] HealthCheck sslHealthCheck
                         * @property {google.cloud.compute.v1.ITCPHealthCheck|null} [tcpHealthCheck] HealthCheck tcpHealthCheck
                         * @property {number|null} [timeoutSec] HealthCheck timeoutSec
                         * @property {string|null} [type] HealthCheck type
                         * @property {number|null} [unhealthyThreshold] HealthCheck unhealthyThreshold
                         */
    
                        /**
                         * Constructs a new HealthCheck.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HealthCheck.
                         * @implements IHealthCheck
                         * @constructor
                         * @param {google.cloud.compute.v1.IHealthCheck=} [properties] Properties to set
                         */
                        function HealthCheck(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HealthCheck checkIntervalSec.
                         * @member {number|null|undefined} checkIntervalSec
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        HealthCheck.prototype.checkIntervalSec = null;
    
                        /**
                         * HealthCheck creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        HealthCheck.prototype.creationTimestamp = null;
    
                        /**
                         * HealthCheck description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        HealthCheck.prototype.description = null;
    
                        /**
                         * HealthCheck grpcHealthCheck.
                         * @member {google.cloud.compute.v1.IGRPCHealthCheck|null|undefined} grpcHealthCheck
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        HealthCheck.prototype.grpcHealthCheck = null;
    
                        /**
                         * HealthCheck healthyThreshold.
                         * @member {number|null|undefined} healthyThreshold
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        HealthCheck.prototype.healthyThreshold = null;
    
                        /**
                         * HealthCheck http2HealthCheck.
                         * @member {google.cloud.compute.v1.IHTTP2HealthCheck|null|undefined} http2HealthCheck
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        HealthCheck.prototype.http2HealthCheck = null;
    
                        /**
                         * HealthCheck httpHealthCheck.
                         * @member {google.cloud.compute.v1.IHTTPHealthCheck|null|undefined} httpHealthCheck
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        HealthCheck.prototype.httpHealthCheck = null;
    
                        /**
                         * HealthCheck httpsHealthCheck.
                         * @member {google.cloud.compute.v1.IHTTPSHealthCheck|null|undefined} httpsHealthCheck
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        HealthCheck.prototype.httpsHealthCheck = null;
    
                        /**
                         * HealthCheck id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        HealthCheck.prototype.id = null;
    
                        /**
                         * HealthCheck kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        HealthCheck.prototype.kind = null;
    
                        /**
                         * HealthCheck logConfig.
                         * @member {google.cloud.compute.v1.IHealthCheckLogConfig|null|undefined} logConfig
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        HealthCheck.prototype.logConfig = null;
    
                        /**
                         * HealthCheck name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        HealthCheck.prototype.name = null;
    
                        /**
                         * HealthCheck region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        HealthCheck.prototype.region = null;
    
                        /**
                         * HealthCheck selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        HealthCheck.prototype.selfLink = null;
    
                        /**
                         * HealthCheck sslHealthCheck.
                         * @member {google.cloud.compute.v1.ISSLHealthCheck|null|undefined} sslHealthCheck
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        HealthCheck.prototype.sslHealthCheck = null;
    
                        /**
                         * HealthCheck tcpHealthCheck.
                         * @member {google.cloud.compute.v1.ITCPHealthCheck|null|undefined} tcpHealthCheck
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        HealthCheck.prototype.tcpHealthCheck = null;
    
                        /**
                         * HealthCheck timeoutSec.
                         * @member {number|null|undefined} timeoutSec
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        HealthCheck.prototype.timeoutSec = null;
    
                        /**
                         * HealthCheck type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        HealthCheck.prototype.type = null;
    
                        /**
                         * HealthCheck unhealthyThreshold.
                         * @member {number|null|undefined} unhealthyThreshold
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        HealthCheck.prototype.unhealthyThreshold = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HealthCheck _checkIntervalSec.
                         * @member {"checkIntervalSec"|undefined} _checkIntervalSec
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HealthCheck.prototype, "_checkIntervalSec", {
                            get: $util.oneOfGetter($oneOfFields = ["checkIntervalSec"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheck _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HealthCheck.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheck _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HealthCheck.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheck _grpcHealthCheck.
                         * @member {"grpcHealthCheck"|undefined} _grpcHealthCheck
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HealthCheck.prototype, "_grpcHealthCheck", {
                            get: $util.oneOfGetter($oneOfFields = ["grpcHealthCheck"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheck _healthyThreshold.
                         * @member {"healthyThreshold"|undefined} _healthyThreshold
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HealthCheck.prototype, "_healthyThreshold", {
                            get: $util.oneOfGetter($oneOfFields = ["healthyThreshold"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheck _http2HealthCheck.
                         * @member {"http2HealthCheck"|undefined} _http2HealthCheck
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HealthCheck.prototype, "_http2HealthCheck", {
                            get: $util.oneOfGetter($oneOfFields = ["http2HealthCheck"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheck _httpHealthCheck.
                         * @member {"httpHealthCheck"|undefined} _httpHealthCheck
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HealthCheck.prototype, "_httpHealthCheck", {
                            get: $util.oneOfGetter($oneOfFields = ["httpHealthCheck"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheck _httpsHealthCheck.
                         * @member {"httpsHealthCheck"|undefined} _httpsHealthCheck
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HealthCheck.prototype, "_httpsHealthCheck", {
                            get: $util.oneOfGetter($oneOfFields = ["httpsHealthCheck"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheck _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HealthCheck.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheck _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HealthCheck.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheck _logConfig.
                         * @member {"logConfig"|undefined} _logConfig
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HealthCheck.prototype, "_logConfig", {
                            get: $util.oneOfGetter($oneOfFields = ["logConfig"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheck _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HealthCheck.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheck _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HealthCheck.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheck _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HealthCheck.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheck _sslHealthCheck.
                         * @member {"sslHealthCheck"|undefined} _sslHealthCheck
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HealthCheck.prototype, "_sslHealthCheck", {
                            get: $util.oneOfGetter($oneOfFields = ["sslHealthCheck"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheck _tcpHealthCheck.
                         * @member {"tcpHealthCheck"|undefined} _tcpHealthCheck
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HealthCheck.prototype, "_tcpHealthCheck", {
                            get: $util.oneOfGetter($oneOfFields = ["tcpHealthCheck"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheck _timeoutSec.
                         * @member {"timeoutSec"|undefined} _timeoutSec
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HealthCheck.prototype, "_timeoutSec", {
                            get: $util.oneOfGetter($oneOfFields = ["timeoutSec"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheck _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HealthCheck.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheck _unhealthyThreshold.
                         * @member {"unhealthyThreshold"|undefined} _unhealthyThreshold
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         */
                        Object.defineProperty(HealthCheck.prototype, "_unhealthyThreshold", {
                            get: $util.oneOfGetter($oneOfFields = ["unhealthyThreshold"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HealthCheck instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheck=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HealthCheck} HealthCheck instance
                         */
                        HealthCheck.create = function create(properties) {
                            return new HealthCheck(properties);
                        };
    
                        /**
                         * Encodes the specified HealthCheck message. Does not implicitly {@link google.cloud.compute.v1.HealthCheck.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheck} message HealthCheck message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthCheck.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            if (message.http2HealthCheck != null && Object.hasOwnProperty.call(message, "http2HealthCheck"))
                                $root.google.cloud.compute.v1.HTTP2HealthCheck.encode(message.http2HealthCheck, writer.uint32(/* id 11360986, wireType 2 =*/90887890).fork()).ldelim();
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.timeoutSec != null && Object.hasOwnProperty.call(message, "timeoutSec"))
                                writer.uint32(/* id 79994995, wireType 0 =*/639959960).int32(message.timeoutSec);
                            if (message.grpcHealthCheck != null && Object.hasOwnProperty.call(message, "grpcHealthCheck"))
                                $root.google.cloud.compute.v1.GRPCHealthCheck.encode(message.grpcHealthCheck, writer.uint32(/* id 85529574, wireType 2 =*/684236594).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.unhealthyThreshold != null && Object.hasOwnProperty.call(message, "unhealthyThreshold"))
                                writer.uint32(/* id 227958480, wireType 0 =*/1823667840).int32(message.unhealthyThreshold);
                            if (message.sslHealthCheck != null && Object.hasOwnProperty.call(message, "sslHealthCheck"))
                                $root.google.cloud.compute.v1.SSLHealthCheck.encode(message.sslHealthCheck, writer.uint32(/* id 280032440, wireType 2 =*/2240259522).fork()).ldelim();
                            if (message.checkIntervalSec != null && Object.hasOwnProperty.call(message, "checkIntervalSec"))
                                writer.uint32(/* id 345561006, wireType 0 =*/2764488048).int32(message.checkIntervalSec);
                            if (message.logConfig != null && Object.hasOwnProperty.call(message, "logConfig"))
                                $root.google.cloud.compute.v1.HealthCheckLogConfig.encode(message.logConfig, writer.uint32(/* id 351299741, wireType 2 =*/2810397930).fork()).ldelim();
                            if (message.healthyThreshold != null && Object.hasOwnProperty.call(message, "healthyThreshold"))
                                writer.uint32(/* id 403212361, wireType 0 =*/3225698888).int32(message.healthyThreshold);
                            if (message.httpHealthCheck != null && Object.hasOwnProperty.call(message, "httpHealthCheck"))
                                $root.google.cloud.compute.v1.HTTPHealthCheck.encode(message.httpHealthCheck, writer.uint32(/* id 412586940, wireType 2 =*/3300695522).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.httpsHealthCheck != null && Object.hasOwnProperty.call(message, "httpsHealthCheck"))
                                $root.google.cloud.compute.v1.HTTPSHealthCheck.encode(message.httpsHealthCheck, writer.uint32(/* id 436046905, wireType 2 =*/3488375242).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.tcpHealthCheck != null && Object.hasOwnProperty.call(message, "tcpHealthCheck"))
                                $root.google.cloud.compute.v1.TCPHealthCheck.encode(message.tcpHealthCheck, writer.uint32(/* id 469980419, wireType 2 =*/3759843354).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HealthCheck message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HealthCheck.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheck} message HealthCheck message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthCheck.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HealthCheck message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HealthCheck} HealthCheck
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthCheck.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HealthCheck();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 345561006: {
                                        message.checkIntervalSec = reader.int32();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 85529574: {
                                        message.grpcHealthCheck = $root.google.cloud.compute.v1.GRPCHealthCheck.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 403212361: {
                                        message.healthyThreshold = reader.int32();
                                        break;
                                    }
                                case 11360986: {
                                        message.http2HealthCheck = $root.google.cloud.compute.v1.HTTP2HealthCheck.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 412586940: {
                                        message.httpHealthCheck = $root.google.cloud.compute.v1.HTTPHealthCheck.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 436046905: {
                                        message.httpsHealthCheck = $root.google.cloud.compute.v1.HTTPSHealthCheck.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 351299741: {
                                        message.logConfig = $root.google.cloud.compute.v1.HealthCheckLogConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 280032440: {
                                        message.sslHealthCheck = $root.google.cloud.compute.v1.SSLHealthCheck.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 469980419: {
                                        message.tcpHealthCheck = $root.google.cloud.compute.v1.TCPHealthCheck.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 79994995: {
                                        message.timeoutSec = reader.int32();
                                        break;
                                    }
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                case 227958480: {
                                        message.unhealthyThreshold = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HealthCheck message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HealthCheck} HealthCheck
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthCheck.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HealthCheck message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HealthCheck.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.checkIntervalSec != null && message.hasOwnProperty("checkIntervalSec")) {
                                properties._checkIntervalSec = 1;
                                if (!$util.isInteger(message.checkIntervalSec))
                                    return "checkIntervalSec: integer expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.grpcHealthCheck != null && message.hasOwnProperty("grpcHealthCheck")) {
                                properties._grpcHealthCheck = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.GRPCHealthCheck.verify(message.grpcHealthCheck);
                                    if (error)
                                        return "grpcHealthCheck." + error;
                                }
                            }
                            if (message.healthyThreshold != null && message.hasOwnProperty("healthyThreshold")) {
                                properties._healthyThreshold = 1;
                                if (!$util.isInteger(message.healthyThreshold))
                                    return "healthyThreshold: integer expected";
                            }
                            if (message.http2HealthCheck != null && message.hasOwnProperty("http2HealthCheck")) {
                                properties._http2HealthCheck = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HTTP2HealthCheck.verify(message.http2HealthCheck);
                                    if (error)
                                        return "http2HealthCheck." + error;
                                }
                            }
                            if (message.httpHealthCheck != null && message.hasOwnProperty("httpHealthCheck")) {
                                properties._httpHealthCheck = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HTTPHealthCheck.verify(message.httpHealthCheck);
                                    if (error)
                                        return "httpHealthCheck." + error;
                                }
                            }
                            if (message.httpsHealthCheck != null && message.hasOwnProperty("httpsHealthCheck")) {
                                properties._httpsHealthCheck = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HTTPSHealthCheck.verify(message.httpsHealthCheck);
                                    if (error)
                                        return "httpsHealthCheck." + error;
                                }
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.logConfig != null && message.hasOwnProperty("logConfig")) {
                                properties._logConfig = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HealthCheckLogConfig.verify(message.logConfig);
                                    if (error)
                                        return "logConfig." + error;
                                }
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.sslHealthCheck != null && message.hasOwnProperty("sslHealthCheck")) {
                                properties._sslHealthCheck = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SSLHealthCheck.verify(message.sslHealthCheck);
                                    if (error)
                                        return "sslHealthCheck." + error;
                                }
                            }
                            if (message.tcpHealthCheck != null && message.hasOwnProperty("tcpHealthCheck")) {
                                properties._tcpHealthCheck = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.TCPHealthCheck.verify(message.tcpHealthCheck);
                                    if (error)
                                        return "tcpHealthCheck." + error;
                                }
                            }
                            if (message.timeoutSec != null && message.hasOwnProperty("timeoutSec")) {
                                properties._timeoutSec = 1;
                                if (!$util.isInteger(message.timeoutSec))
                                    return "timeoutSec: integer expected";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            if (message.unhealthyThreshold != null && message.hasOwnProperty("unhealthyThreshold")) {
                                properties._unhealthyThreshold = 1;
                                if (!$util.isInteger(message.unhealthyThreshold))
                                    return "unhealthyThreshold: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HealthCheck message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HealthCheck} HealthCheck
                         */
                        HealthCheck.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HealthCheck)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HealthCheck();
                            if (object.checkIntervalSec != null)
                                message.checkIntervalSec = object.checkIntervalSec | 0;
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.grpcHealthCheck != null) {
                                if (typeof object.grpcHealthCheck !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HealthCheck.grpcHealthCheck: object expected");
                                message.grpcHealthCheck = $root.google.cloud.compute.v1.GRPCHealthCheck.fromObject(object.grpcHealthCheck);
                            }
                            if (object.healthyThreshold != null)
                                message.healthyThreshold = object.healthyThreshold | 0;
                            if (object.http2HealthCheck != null) {
                                if (typeof object.http2HealthCheck !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HealthCheck.http2HealthCheck: object expected");
                                message.http2HealthCheck = $root.google.cloud.compute.v1.HTTP2HealthCheck.fromObject(object.http2HealthCheck);
                            }
                            if (object.httpHealthCheck != null) {
                                if (typeof object.httpHealthCheck !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HealthCheck.httpHealthCheck: object expected");
                                message.httpHealthCheck = $root.google.cloud.compute.v1.HTTPHealthCheck.fromObject(object.httpHealthCheck);
                            }
                            if (object.httpsHealthCheck != null) {
                                if (typeof object.httpsHealthCheck !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HealthCheck.httpsHealthCheck: object expected");
                                message.httpsHealthCheck = $root.google.cloud.compute.v1.HTTPSHealthCheck.fromObject(object.httpsHealthCheck);
                            }
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.logConfig != null) {
                                if (typeof object.logConfig !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HealthCheck.logConfig: object expected");
                                message.logConfig = $root.google.cloud.compute.v1.HealthCheckLogConfig.fromObject(object.logConfig);
                            }
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.sslHealthCheck != null) {
                                if (typeof object.sslHealthCheck !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HealthCheck.sslHealthCheck: object expected");
                                message.sslHealthCheck = $root.google.cloud.compute.v1.SSLHealthCheck.fromObject(object.sslHealthCheck);
                            }
                            if (object.tcpHealthCheck != null) {
                                if (typeof object.tcpHealthCheck !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HealthCheck.tcpHealthCheck: object expected");
                                message.tcpHealthCheck = $root.google.cloud.compute.v1.TCPHealthCheck.fromObject(object.tcpHealthCheck);
                            }
                            if (object.timeoutSec != null)
                                message.timeoutSec = object.timeoutSec | 0;
                            if (object.type != null)
                                message.type = String(object.type);
                            if (object.unhealthyThreshold != null)
                                message.unhealthyThreshold = object.unhealthyThreshold | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HealthCheck message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.HealthCheck} message HealthCheck
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HealthCheck.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            if (message.http2HealthCheck != null && message.hasOwnProperty("http2HealthCheck")) {
                                object.http2HealthCheck = $root.google.cloud.compute.v1.HTTP2HealthCheck.toObject(message.http2HealthCheck, options);
                                if (options.oneofs)
                                    object._http2HealthCheck = "http2HealthCheck";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.timeoutSec != null && message.hasOwnProperty("timeoutSec")) {
                                object.timeoutSec = message.timeoutSec;
                                if (options.oneofs)
                                    object._timeoutSec = "timeoutSec";
                            }
                            if (message.grpcHealthCheck != null && message.hasOwnProperty("grpcHealthCheck")) {
                                object.grpcHealthCheck = $root.google.cloud.compute.v1.GRPCHealthCheck.toObject(message.grpcHealthCheck, options);
                                if (options.oneofs)
                                    object._grpcHealthCheck = "grpcHealthCheck";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.unhealthyThreshold != null && message.hasOwnProperty("unhealthyThreshold")) {
                                object.unhealthyThreshold = message.unhealthyThreshold;
                                if (options.oneofs)
                                    object._unhealthyThreshold = "unhealthyThreshold";
                            }
                            if (message.sslHealthCheck != null && message.hasOwnProperty("sslHealthCheck")) {
                                object.sslHealthCheck = $root.google.cloud.compute.v1.SSLHealthCheck.toObject(message.sslHealthCheck, options);
                                if (options.oneofs)
                                    object._sslHealthCheck = "sslHealthCheck";
                            }
                            if (message.checkIntervalSec != null && message.hasOwnProperty("checkIntervalSec")) {
                                object.checkIntervalSec = message.checkIntervalSec;
                                if (options.oneofs)
                                    object._checkIntervalSec = "checkIntervalSec";
                            }
                            if (message.logConfig != null && message.hasOwnProperty("logConfig")) {
                                object.logConfig = $root.google.cloud.compute.v1.HealthCheckLogConfig.toObject(message.logConfig, options);
                                if (options.oneofs)
                                    object._logConfig = "logConfig";
                            }
                            if (message.healthyThreshold != null && message.hasOwnProperty("healthyThreshold")) {
                                object.healthyThreshold = message.healthyThreshold;
                                if (options.oneofs)
                                    object._healthyThreshold = "healthyThreshold";
                            }
                            if (message.httpHealthCheck != null && message.hasOwnProperty("httpHealthCheck")) {
                                object.httpHealthCheck = $root.google.cloud.compute.v1.HTTPHealthCheck.toObject(message.httpHealthCheck, options);
                                if (options.oneofs)
                                    object._httpHealthCheck = "httpHealthCheck";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.httpsHealthCheck != null && message.hasOwnProperty("httpsHealthCheck")) {
                                object.httpsHealthCheck = $root.google.cloud.compute.v1.HTTPSHealthCheck.toObject(message.httpsHealthCheck, options);
                                if (options.oneofs)
                                    object._httpsHealthCheck = "httpsHealthCheck";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.tcpHealthCheck != null && message.hasOwnProperty("tcpHealthCheck")) {
                                object.tcpHealthCheck = $root.google.cloud.compute.v1.TCPHealthCheck.toObject(message.tcpHealthCheck, options);
                                if (options.oneofs)
                                    object._tcpHealthCheck = "tcpHealthCheck";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HealthCheck to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HealthCheck.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HealthCheck
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HealthCheck
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HealthCheck.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HealthCheck";
                        };
    
                        /**
                         * Type enum.
                         * @name google.cloud.compute.v1.HealthCheck.Type
                         * @enum {number}
                         * @property {number} UNDEFINED_TYPE=0 UNDEFINED_TYPE value
                         * @property {number} GRPC=2196510 GRPC value
                         * @property {number} HTTP=2228360 HTTP value
                         * @property {number} HTTP2=69079210 HTTP2 value
                         * @property {number} HTTPS=69079243 HTTPS value
                         * @property {number} INVALID=530283991 INVALID value
                         * @property {number} SSL=82412 SSL value
                         * @property {number} TCP=82881 TCP value
                         */
                        HealthCheck.Type = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TYPE"] = 0;
                            values[valuesById[2196510] = "GRPC"] = 2196510;
                            values[valuesById[2228360] = "HTTP"] = 2228360;
                            values[valuesById[69079210] = "HTTP2"] = 69079210;
                            values[valuesById[69079243] = "HTTPS"] = 69079243;
                            values[valuesById[530283991] = "INVALID"] = 530283991;
                            values[valuesById[82412] = "SSL"] = 82412;
                            values[valuesById[82881] = "TCP"] = 82881;
                            return values;
                        })();
    
                        return HealthCheck;
                    })();
    
                    v1.HealthCheckList = (function() {
    
                        /**
                         * Properties of a HealthCheckList.
                         * @memberof google.cloud.compute.v1
                         * @interface IHealthCheckList
                         * @property {string|null} [id] HealthCheckList id
                         * @property {Array.<google.cloud.compute.v1.IHealthCheck>|null} [items] HealthCheckList items
                         * @property {string|null} [kind] HealthCheckList kind
                         * @property {string|null} [nextPageToken] HealthCheckList nextPageToken
                         * @property {string|null} [selfLink] HealthCheckList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] HealthCheckList warning
                         */
    
                        /**
                         * Constructs a new HealthCheckList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HealthCheckList.
                         * @implements IHealthCheckList
                         * @constructor
                         * @param {google.cloud.compute.v1.IHealthCheckList=} [properties] Properties to set
                         */
                        function HealthCheckList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HealthCheckList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @instance
                         */
                        HealthCheckList.prototype.id = null;
    
                        /**
                         * HealthCheckList items.
                         * @member {Array.<google.cloud.compute.v1.IHealthCheck>} items
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @instance
                         */
                        HealthCheckList.prototype.items = $util.emptyArray;
    
                        /**
                         * HealthCheckList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @instance
                         */
                        HealthCheckList.prototype.kind = null;
    
                        /**
                         * HealthCheckList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @instance
                         */
                        HealthCheckList.prototype.nextPageToken = null;
    
                        /**
                         * HealthCheckList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @instance
                         */
                        HealthCheckList.prototype.selfLink = null;
    
                        /**
                         * HealthCheckList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @instance
                         */
                        HealthCheckList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HealthCheckList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @instance
                         */
                        Object.defineProperty(HealthCheckList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheckList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @instance
                         */
                        Object.defineProperty(HealthCheckList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheckList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @instance
                         */
                        Object.defineProperty(HealthCheckList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheckList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @instance
                         */
                        Object.defineProperty(HealthCheckList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheckList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @instance
                         */
                        Object.defineProperty(HealthCheckList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HealthCheckList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheckList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HealthCheckList} HealthCheckList instance
                         */
                        HealthCheckList.create = function create(properties) {
                            return new HealthCheckList(properties);
                        };
    
                        /**
                         * Encodes the specified HealthCheckList message. Does not implicitly {@link google.cloud.compute.v1.HealthCheckList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheckList} message HealthCheckList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthCheckList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.HealthCheck.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HealthCheckList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HealthCheckList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheckList} message HealthCheckList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthCheckList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HealthCheckList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HealthCheckList} HealthCheckList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthCheckList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HealthCheckList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.HealthCheck.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HealthCheckList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HealthCheckList} HealthCheckList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthCheckList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HealthCheckList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HealthCheckList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.HealthCheck.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HealthCheckList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HealthCheckList} HealthCheckList
                         */
                        HealthCheckList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HealthCheckList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HealthCheckList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.HealthCheckList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.HealthCheckList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.HealthCheck.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HealthCheckList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HealthCheckList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @static
                         * @param {google.cloud.compute.v1.HealthCheckList} message HealthCheckList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HealthCheckList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.HealthCheck.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HealthCheckList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HealthCheckList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HealthCheckList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HealthCheckList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HealthCheckList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HealthCheckList";
                        };
    
                        return HealthCheckList;
                    })();
    
                    v1.HealthCheckLogConfig = (function() {
    
                        /**
                         * Properties of a HealthCheckLogConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface IHealthCheckLogConfig
                         * @property {boolean|null} [enable] HealthCheckLogConfig enable
                         */
    
                        /**
                         * Constructs a new HealthCheckLogConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HealthCheckLogConfig.
                         * @implements IHealthCheckLogConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.IHealthCheckLogConfig=} [properties] Properties to set
                         */
                        function HealthCheckLogConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HealthCheckLogConfig enable.
                         * @member {boolean|null|undefined} enable
                         * @memberof google.cloud.compute.v1.HealthCheckLogConfig
                         * @instance
                         */
                        HealthCheckLogConfig.prototype.enable = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HealthCheckLogConfig _enable.
                         * @member {"enable"|undefined} _enable
                         * @memberof google.cloud.compute.v1.HealthCheckLogConfig
                         * @instance
                         */
                        Object.defineProperty(HealthCheckLogConfig.prototype, "_enable", {
                            get: $util.oneOfGetter($oneOfFields = ["enable"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HealthCheckLogConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HealthCheckLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheckLogConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HealthCheckLogConfig} HealthCheckLogConfig instance
                         */
                        HealthCheckLogConfig.create = function create(properties) {
                            return new HealthCheckLogConfig(properties);
                        };
    
                        /**
                         * Encodes the specified HealthCheckLogConfig message. Does not implicitly {@link google.cloud.compute.v1.HealthCheckLogConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HealthCheckLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheckLogConfig} message HealthCheckLogConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthCheckLogConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.enable != null && Object.hasOwnProperty.call(message, "enable"))
                                writer.uint32(/* id 311764355, wireType 0 =*/2494114840).bool(message.enable);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HealthCheckLogConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HealthCheckLogConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HealthCheckLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheckLogConfig} message HealthCheckLogConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthCheckLogConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HealthCheckLogConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HealthCheckLogConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HealthCheckLogConfig} HealthCheckLogConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthCheckLogConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HealthCheckLogConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 311764355: {
                                        message.enable = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HealthCheckLogConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HealthCheckLogConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HealthCheckLogConfig} HealthCheckLogConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthCheckLogConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HealthCheckLogConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HealthCheckLogConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HealthCheckLogConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.enable != null && message.hasOwnProperty("enable")) {
                                properties._enable = 1;
                                if (typeof message.enable !== "boolean")
                                    return "enable: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HealthCheckLogConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HealthCheckLogConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HealthCheckLogConfig} HealthCheckLogConfig
                         */
                        HealthCheckLogConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HealthCheckLogConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HealthCheckLogConfig();
                            if (object.enable != null)
                                message.enable = Boolean(object.enable);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HealthCheckLogConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HealthCheckLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.HealthCheckLogConfig} message HealthCheckLogConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HealthCheckLogConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.enable != null && message.hasOwnProperty("enable")) {
                                object.enable = message.enable;
                                if (options.oneofs)
                                    object._enable = "enable";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HealthCheckLogConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HealthCheckLogConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HealthCheckLogConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HealthCheckLogConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HealthCheckLogConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HealthCheckLogConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HealthCheckLogConfig";
                        };
    
                        return HealthCheckLogConfig;
                    })();
    
                    v1.HealthCheckReference = (function() {
    
                        /**
                         * Properties of a HealthCheckReference.
                         * @memberof google.cloud.compute.v1
                         * @interface IHealthCheckReference
                         * @property {string|null} [healthCheck] HealthCheckReference healthCheck
                         */
    
                        /**
                         * Constructs a new HealthCheckReference.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HealthCheckReference.
                         * @implements IHealthCheckReference
                         * @constructor
                         * @param {google.cloud.compute.v1.IHealthCheckReference=} [properties] Properties to set
                         */
                        function HealthCheckReference(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HealthCheckReference healthCheck.
                         * @member {string|null|undefined} healthCheck
                         * @memberof google.cloud.compute.v1.HealthCheckReference
                         * @instance
                         */
                        HealthCheckReference.prototype.healthCheck = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HealthCheckReference _healthCheck.
                         * @member {"healthCheck"|undefined} _healthCheck
                         * @memberof google.cloud.compute.v1.HealthCheckReference
                         * @instance
                         */
                        Object.defineProperty(HealthCheckReference.prototype, "_healthCheck", {
                            get: $util.oneOfGetter($oneOfFields = ["healthCheck"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HealthCheckReference instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HealthCheckReference
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheckReference=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HealthCheckReference} HealthCheckReference instance
                         */
                        HealthCheckReference.create = function create(properties) {
                            return new HealthCheckReference(properties);
                        };
    
                        /**
                         * Encodes the specified HealthCheckReference message. Does not implicitly {@link google.cloud.compute.v1.HealthCheckReference.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HealthCheckReference
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheckReference} message HealthCheckReference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthCheckReference.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.healthCheck != null && Object.hasOwnProperty.call(message, "healthCheck"))
                                writer.uint32(/* id 308876645, wireType 2 =*/2471013162).string(message.healthCheck);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HealthCheckReference message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HealthCheckReference.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HealthCheckReference
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheckReference} message HealthCheckReference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthCheckReference.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HealthCheckReference message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HealthCheckReference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HealthCheckReference} HealthCheckReference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthCheckReference.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HealthCheckReference();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 308876645: {
                                        message.healthCheck = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HealthCheckReference message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HealthCheckReference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HealthCheckReference} HealthCheckReference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthCheckReference.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HealthCheckReference message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HealthCheckReference
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HealthCheckReference.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck")) {
                                properties._healthCheck = 1;
                                if (!$util.isString(message.healthCheck))
                                    return "healthCheck: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HealthCheckReference message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HealthCheckReference
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HealthCheckReference} HealthCheckReference
                         */
                        HealthCheckReference.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HealthCheckReference)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HealthCheckReference();
                            if (object.healthCheck != null)
                                message.healthCheck = String(object.healthCheck);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HealthCheckReference message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HealthCheckReference
                         * @static
                         * @param {google.cloud.compute.v1.HealthCheckReference} message HealthCheckReference
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HealthCheckReference.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck")) {
                                object.healthCheck = message.healthCheck;
                                if (options.oneofs)
                                    object._healthCheck = "healthCheck";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HealthCheckReference to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HealthCheckReference
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HealthCheckReference.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HealthCheckReference
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HealthCheckReference
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HealthCheckReference.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HealthCheckReference";
                        };
    
                        return HealthCheckReference;
                    })();
    
                    v1.HealthCheckService = (function() {
    
                        /**
                         * Properties of a HealthCheckService.
                         * @memberof google.cloud.compute.v1
                         * @interface IHealthCheckService
                         * @property {string|null} [creationTimestamp] HealthCheckService creationTimestamp
                         * @property {string|null} [description] HealthCheckService description
                         * @property {string|null} [fingerprint] HealthCheckService fingerprint
                         * @property {Array.<string>|null} [healthChecks] HealthCheckService healthChecks
                         * @property {string|null} [healthStatusAggregationPolicy] HealthCheckService healthStatusAggregationPolicy
                         * @property {number|Long|null} [id] HealthCheckService id
                         * @property {string|null} [kind] HealthCheckService kind
                         * @property {string|null} [name] HealthCheckService name
                         * @property {Array.<string>|null} [networkEndpointGroups] HealthCheckService networkEndpointGroups
                         * @property {Array.<string>|null} [notificationEndpoints] HealthCheckService notificationEndpoints
                         * @property {string|null} [region] HealthCheckService region
                         * @property {string|null} [selfLink] HealthCheckService selfLink
                         */
    
                        /**
                         * Constructs a new HealthCheckService.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HealthCheckService.
                         * @implements IHealthCheckService
                         * @constructor
                         * @param {google.cloud.compute.v1.IHealthCheckService=} [properties] Properties to set
                         */
                        function HealthCheckService(properties) {
                            this.healthChecks = [];
                            this.networkEndpointGroups = [];
                            this.notificationEndpoints = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HealthCheckService creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        HealthCheckService.prototype.creationTimestamp = null;
    
                        /**
                         * HealthCheckService description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        HealthCheckService.prototype.description = null;
    
                        /**
                         * HealthCheckService fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        HealthCheckService.prototype.fingerprint = null;
    
                        /**
                         * HealthCheckService healthChecks.
                         * @member {Array.<string>} healthChecks
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        HealthCheckService.prototype.healthChecks = $util.emptyArray;
    
                        /**
                         * HealthCheckService healthStatusAggregationPolicy.
                         * @member {string|null|undefined} healthStatusAggregationPolicy
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        HealthCheckService.prototype.healthStatusAggregationPolicy = null;
    
                        /**
                         * HealthCheckService id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        HealthCheckService.prototype.id = null;
    
                        /**
                         * HealthCheckService kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        HealthCheckService.prototype.kind = null;
    
                        /**
                         * HealthCheckService name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        HealthCheckService.prototype.name = null;
    
                        /**
                         * HealthCheckService networkEndpointGroups.
                         * @member {Array.<string>} networkEndpointGroups
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        HealthCheckService.prototype.networkEndpointGroups = $util.emptyArray;
    
                        /**
                         * HealthCheckService notificationEndpoints.
                         * @member {Array.<string>} notificationEndpoints
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        HealthCheckService.prototype.notificationEndpoints = $util.emptyArray;
    
                        /**
                         * HealthCheckService region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        HealthCheckService.prototype.region = null;
    
                        /**
                         * HealthCheckService selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        HealthCheckService.prototype.selfLink = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HealthCheckService _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        Object.defineProperty(HealthCheckService.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheckService _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        Object.defineProperty(HealthCheckService.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheckService _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        Object.defineProperty(HealthCheckService.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheckService _healthStatusAggregationPolicy.
                         * @member {"healthStatusAggregationPolicy"|undefined} _healthStatusAggregationPolicy
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        Object.defineProperty(HealthCheckService.prototype, "_healthStatusAggregationPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["healthStatusAggregationPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheckService _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        Object.defineProperty(HealthCheckService.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheckService _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        Object.defineProperty(HealthCheckService.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheckService _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        Object.defineProperty(HealthCheckService.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheckService _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        Object.defineProperty(HealthCheckService.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheckService _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         */
                        Object.defineProperty(HealthCheckService.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HealthCheckService instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheckService=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HealthCheckService} HealthCheckService instance
                         */
                        HealthCheckService.create = function create(properties) {
                            return new HealthCheckService(properties);
                        };
    
                        /**
                         * Encodes the specified HealthCheckService message. Does not implicitly {@link google.cloud.compute.v1.HealthCheckService.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheckService} message HealthCheckService message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthCheckService.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.networkEndpointGroups != null && message.networkEndpointGroups.length)
                                for (var i = 0; i < message.networkEndpointGroups.length; ++i)
                                    writer.uint32(/* id 29346733, wireType 2 =*/234773866).string(message.networkEndpointGroups[i]);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.healthStatusAggregationPolicy != null && Object.hasOwnProperty.call(message, "healthStatusAggregationPolicy"))
                                writer.uint32(/* id 253163129, wireType 2 =*/2025305034).string(message.healthStatusAggregationPolicy);
                            if (message.notificationEndpoints != null && message.notificationEndpoints.length)
                                for (var i = 0; i < message.notificationEndpoints.length; ++i)
                                    writer.uint32(/* id 406728490, wireType 2 =*/3253827922).string(message.notificationEndpoints[i]);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.healthChecks != null && message.healthChecks.length)
                                for (var i = 0; i < message.healthChecks.length; ++i)
                                    writer.uint32(/* id 448370606, wireType 2 =*/3586964850).string(message.healthChecks[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HealthCheckService message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HealthCheckService.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheckService} message HealthCheckService message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthCheckService.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HealthCheckService message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HealthCheckService} HealthCheckService
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthCheckService.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HealthCheckService();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 448370606: {
                                        if (!(message.healthChecks && message.healthChecks.length))
                                            message.healthChecks = [];
                                        message.healthChecks.push(reader.string());
                                        break;
                                    }
                                case 253163129: {
                                        message.healthStatusAggregationPolicy = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 29346733: {
                                        if (!(message.networkEndpointGroups && message.networkEndpointGroups.length))
                                            message.networkEndpointGroups = [];
                                        message.networkEndpointGroups.push(reader.string());
                                        break;
                                    }
                                case 406728490: {
                                        if (!(message.notificationEndpoints && message.notificationEndpoints.length))
                                            message.notificationEndpoints = [];
                                        message.notificationEndpoints.push(reader.string());
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HealthCheckService message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HealthCheckService} HealthCheckService
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthCheckService.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HealthCheckService message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HealthCheckService.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.healthChecks != null && message.hasOwnProperty("healthChecks")) {
                                if (!Array.isArray(message.healthChecks))
                                    return "healthChecks: array expected";
                                for (var i = 0; i < message.healthChecks.length; ++i)
                                    if (!$util.isString(message.healthChecks[i]))
                                        return "healthChecks: string[] expected";
                            }
                            if (message.healthStatusAggregationPolicy != null && message.hasOwnProperty("healthStatusAggregationPolicy")) {
                                properties._healthStatusAggregationPolicy = 1;
                                if (!$util.isString(message.healthStatusAggregationPolicy))
                                    return "healthStatusAggregationPolicy: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.networkEndpointGroups != null && message.hasOwnProperty("networkEndpointGroups")) {
                                if (!Array.isArray(message.networkEndpointGroups))
                                    return "networkEndpointGroups: array expected";
                                for (var i = 0; i < message.networkEndpointGroups.length; ++i)
                                    if (!$util.isString(message.networkEndpointGroups[i]))
                                        return "networkEndpointGroups: string[] expected";
                            }
                            if (message.notificationEndpoints != null && message.hasOwnProperty("notificationEndpoints")) {
                                if (!Array.isArray(message.notificationEndpoints))
                                    return "notificationEndpoints: array expected";
                                for (var i = 0; i < message.notificationEndpoints.length; ++i)
                                    if (!$util.isString(message.notificationEndpoints[i]))
                                        return "notificationEndpoints: string[] expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HealthCheckService message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HealthCheckService} HealthCheckService
                         */
                        HealthCheckService.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HealthCheckService)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HealthCheckService();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.healthChecks) {
                                if (!Array.isArray(object.healthChecks))
                                    throw TypeError(".google.cloud.compute.v1.HealthCheckService.healthChecks: array expected");
                                message.healthChecks = [];
                                for (var i = 0; i < object.healthChecks.length; ++i)
                                    message.healthChecks[i] = String(object.healthChecks[i]);
                            }
                            if (object.healthStatusAggregationPolicy != null)
                                message.healthStatusAggregationPolicy = String(object.healthStatusAggregationPolicy);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.networkEndpointGroups) {
                                if (!Array.isArray(object.networkEndpointGroups))
                                    throw TypeError(".google.cloud.compute.v1.HealthCheckService.networkEndpointGroups: array expected");
                                message.networkEndpointGroups = [];
                                for (var i = 0; i < object.networkEndpointGroups.length; ++i)
                                    message.networkEndpointGroups[i] = String(object.networkEndpointGroups[i]);
                            }
                            if (object.notificationEndpoints) {
                                if (!Array.isArray(object.notificationEndpoints))
                                    throw TypeError(".google.cloud.compute.v1.HealthCheckService.notificationEndpoints: array expected");
                                message.notificationEndpoints = [];
                                for (var i = 0; i < object.notificationEndpoints.length; ++i)
                                    message.notificationEndpoints[i] = String(object.notificationEndpoints[i]);
                            }
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HealthCheckService message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @static
                         * @param {google.cloud.compute.v1.HealthCheckService} message HealthCheckService
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HealthCheckService.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.networkEndpointGroups = [];
                                object.notificationEndpoints = [];
                                object.healthChecks = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.networkEndpointGroups && message.networkEndpointGroups.length) {
                                object.networkEndpointGroups = [];
                                for (var j = 0; j < message.networkEndpointGroups.length; ++j)
                                    object.networkEndpointGroups[j] = message.networkEndpointGroups[j];
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.healthStatusAggregationPolicy != null && message.hasOwnProperty("healthStatusAggregationPolicy")) {
                                object.healthStatusAggregationPolicy = message.healthStatusAggregationPolicy;
                                if (options.oneofs)
                                    object._healthStatusAggregationPolicy = "healthStatusAggregationPolicy";
                            }
                            if (message.notificationEndpoints && message.notificationEndpoints.length) {
                                object.notificationEndpoints = [];
                                for (var j = 0; j < message.notificationEndpoints.length; ++j)
                                    object.notificationEndpoints[j] = message.notificationEndpoints[j];
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.healthChecks && message.healthChecks.length) {
                                object.healthChecks = [];
                                for (var j = 0; j < message.healthChecks.length; ++j)
                                    object.healthChecks[j] = message.healthChecks[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HealthCheckService to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HealthCheckService.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HealthCheckService
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HealthCheckService
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HealthCheckService.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HealthCheckService";
                        };
    
                        /**
                         * HealthStatusAggregationPolicy enum.
                         * @name google.cloud.compute.v1.HealthCheckService.HealthStatusAggregationPolicy
                         * @enum {number}
                         * @property {number} UNDEFINED_HEALTH_STATUS_AGGREGATION_POLICY=0 UNDEFINED_HEALTH_STATUS_AGGREGATION_POLICY value
                         * @property {number} AND=64951 AND value
                         * @property {number} NO_AGGREGATION=426445124 NO_AGGREGATION value
                         */
                        HealthCheckService.HealthStatusAggregationPolicy = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_HEALTH_STATUS_AGGREGATION_POLICY"] = 0;
                            values[valuesById[64951] = "AND"] = 64951;
                            values[valuesById[426445124] = "NO_AGGREGATION"] = 426445124;
                            return values;
                        })();
    
                        return HealthCheckService;
                    })();
    
                    v1.HealthCheckServiceReference = (function() {
    
                        /**
                         * Properties of a HealthCheckServiceReference.
                         * @memberof google.cloud.compute.v1
                         * @interface IHealthCheckServiceReference
                         * @property {string|null} [healthCheckService] HealthCheckServiceReference healthCheckService
                         */
    
                        /**
                         * Constructs a new HealthCheckServiceReference.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HealthCheckServiceReference.
                         * @implements IHealthCheckServiceReference
                         * @constructor
                         * @param {google.cloud.compute.v1.IHealthCheckServiceReference=} [properties] Properties to set
                         */
                        function HealthCheckServiceReference(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HealthCheckServiceReference healthCheckService.
                         * @member {string|null|undefined} healthCheckService
                         * @memberof google.cloud.compute.v1.HealthCheckServiceReference
                         * @instance
                         */
                        HealthCheckServiceReference.prototype.healthCheckService = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HealthCheckServiceReference _healthCheckService.
                         * @member {"healthCheckService"|undefined} _healthCheckService
                         * @memberof google.cloud.compute.v1.HealthCheckServiceReference
                         * @instance
                         */
                        Object.defineProperty(HealthCheckServiceReference.prototype, "_healthCheckService", {
                            get: $util.oneOfGetter($oneOfFields = ["healthCheckService"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HealthCheckServiceReference instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HealthCheckServiceReference
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheckServiceReference=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HealthCheckServiceReference} HealthCheckServiceReference instance
                         */
                        HealthCheckServiceReference.create = function create(properties) {
                            return new HealthCheckServiceReference(properties);
                        };
    
                        /**
                         * Encodes the specified HealthCheckServiceReference message. Does not implicitly {@link google.cloud.compute.v1.HealthCheckServiceReference.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HealthCheckServiceReference
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheckServiceReference} message HealthCheckServiceReference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthCheckServiceReference.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.healthCheckService != null && Object.hasOwnProperty.call(message, "healthCheckService"))
                                writer.uint32(/* id 408374747, wireType 2 =*/3266997978).string(message.healthCheckService);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HealthCheckServiceReference message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HealthCheckServiceReference.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HealthCheckServiceReference
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheckServiceReference} message HealthCheckServiceReference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthCheckServiceReference.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HealthCheckServiceReference message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HealthCheckServiceReference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HealthCheckServiceReference} HealthCheckServiceReference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthCheckServiceReference.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HealthCheckServiceReference();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 408374747: {
                                        message.healthCheckService = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HealthCheckServiceReference message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HealthCheckServiceReference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HealthCheckServiceReference} HealthCheckServiceReference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthCheckServiceReference.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HealthCheckServiceReference message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HealthCheckServiceReference
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HealthCheckServiceReference.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.healthCheckService != null && message.hasOwnProperty("healthCheckService")) {
                                properties._healthCheckService = 1;
                                if (!$util.isString(message.healthCheckService))
                                    return "healthCheckService: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HealthCheckServiceReference message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HealthCheckServiceReference
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HealthCheckServiceReference} HealthCheckServiceReference
                         */
                        HealthCheckServiceReference.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HealthCheckServiceReference)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HealthCheckServiceReference();
                            if (object.healthCheckService != null)
                                message.healthCheckService = String(object.healthCheckService);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HealthCheckServiceReference message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HealthCheckServiceReference
                         * @static
                         * @param {google.cloud.compute.v1.HealthCheckServiceReference} message HealthCheckServiceReference
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HealthCheckServiceReference.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.healthCheckService != null && message.hasOwnProperty("healthCheckService")) {
                                object.healthCheckService = message.healthCheckService;
                                if (options.oneofs)
                                    object._healthCheckService = "healthCheckService";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HealthCheckServiceReference to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HealthCheckServiceReference
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HealthCheckServiceReference.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HealthCheckServiceReference
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HealthCheckServiceReference
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HealthCheckServiceReference.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HealthCheckServiceReference";
                        };
    
                        return HealthCheckServiceReference;
                    })();
    
                    v1.HealthCheckServicesList = (function() {
    
                        /**
                         * Properties of a HealthCheckServicesList.
                         * @memberof google.cloud.compute.v1
                         * @interface IHealthCheckServicesList
                         * @property {string|null} [id] HealthCheckServicesList id
                         * @property {Array.<google.cloud.compute.v1.IHealthCheckService>|null} [items] HealthCheckServicesList items
                         * @property {string|null} [kind] HealthCheckServicesList kind
                         * @property {string|null} [nextPageToken] HealthCheckServicesList nextPageToken
                         * @property {string|null} [selfLink] HealthCheckServicesList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] HealthCheckServicesList warning
                         */
    
                        /**
                         * Constructs a new HealthCheckServicesList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HealthCheckServicesList.
                         * @implements IHealthCheckServicesList
                         * @constructor
                         * @param {google.cloud.compute.v1.IHealthCheckServicesList=} [properties] Properties to set
                         */
                        function HealthCheckServicesList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HealthCheckServicesList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @instance
                         */
                        HealthCheckServicesList.prototype.id = null;
    
                        /**
                         * HealthCheckServicesList items.
                         * @member {Array.<google.cloud.compute.v1.IHealthCheckService>} items
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @instance
                         */
                        HealthCheckServicesList.prototype.items = $util.emptyArray;
    
                        /**
                         * HealthCheckServicesList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @instance
                         */
                        HealthCheckServicesList.prototype.kind = null;
    
                        /**
                         * HealthCheckServicesList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @instance
                         */
                        HealthCheckServicesList.prototype.nextPageToken = null;
    
                        /**
                         * HealthCheckServicesList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @instance
                         */
                        HealthCheckServicesList.prototype.selfLink = null;
    
                        /**
                         * HealthCheckServicesList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @instance
                         */
                        HealthCheckServicesList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HealthCheckServicesList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @instance
                         */
                        Object.defineProperty(HealthCheckServicesList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheckServicesList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @instance
                         */
                        Object.defineProperty(HealthCheckServicesList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheckServicesList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @instance
                         */
                        Object.defineProperty(HealthCheckServicesList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheckServicesList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @instance
                         */
                        Object.defineProperty(HealthCheckServicesList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthCheckServicesList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @instance
                         */
                        Object.defineProperty(HealthCheckServicesList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HealthCheckServicesList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheckServicesList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HealthCheckServicesList} HealthCheckServicesList instance
                         */
                        HealthCheckServicesList.create = function create(properties) {
                            return new HealthCheckServicesList(properties);
                        };
    
                        /**
                         * Encodes the specified HealthCheckServicesList message. Does not implicitly {@link google.cloud.compute.v1.HealthCheckServicesList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheckServicesList} message HealthCheckServicesList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthCheckServicesList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.HealthCheckService.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HealthCheckServicesList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HealthCheckServicesList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @static
                         * @param {google.cloud.compute.v1.IHealthCheckServicesList} message HealthCheckServicesList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthCheckServicesList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HealthCheckServicesList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HealthCheckServicesList} HealthCheckServicesList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthCheckServicesList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HealthCheckServicesList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.HealthCheckService.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HealthCheckServicesList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HealthCheckServicesList} HealthCheckServicesList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthCheckServicesList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HealthCheckServicesList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HealthCheckServicesList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.HealthCheckService.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HealthCheckServicesList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HealthCheckServicesList} HealthCheckServicesList
                         */
                        HealthCheckServicesList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HealthCheckServicesList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HealthCheckServicesList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.HealthCheckServicesList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.HealthCheckServicesList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.HealthCheckService.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HealthCheckServicesList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HealthCheckServicesList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @static
                         * @param {google.cloud.compute.v1.HealthCheckServicesList} message HealthCheckServicesList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HealthCheckServicesList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.HealthCheckService.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HealthCheckServicesList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HealthCheckServicesList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HealthCheckServicesList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HealthCheckServicesList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HealthCheckServicesList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HealthCheckServicesList";
                        };
    
                        return HealthCheckServicesList;
                    })();
    
                    v1.HealthChecksAggregatedList = (function() {
    
                        /**
                         * Properties of a HealthChecksAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IHealthChecksAggregatedList
                         * @property {string|null} [id] HealthChecksAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IHealthChecksScopedList>|null} [items] HealthChecksAggregatedList items
                         * @property {string|null} [kind] HealthChecksAggregatedList kind
                         * @property {string|null} [nextPageToken] HealthChecksAggregatedList nextPageToken
                         * @property {string|null} [selfLink] HealthChecksAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] HealthChecksAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] HealthChecksAggregatedList warning
                         */
    
                        /**
                         * Constructs a new HealthChecksAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HealthChecksAggregatedList.
                         * @implements IHealthChecksAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IHealthChecksAggregatedList=} [properties] Properties to set
                         */
                        function HealthChecksAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HealthChecksAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @instance
                         */
                        HealthChecksAggregatedList.prototype.id = null;
    
                        /**
                         * HealthChecksAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IHealthChecksScopedList>} items
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @instance
                         */
                        HealthChecksAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * HealthChecksAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @instance
                         */
                        HealthChecksAggregatedList.prototype.kind = null;
    
                        /**
                         * HealthChecksAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @instance
                         */
                        HealthChecksAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * HealthChecksAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @instance
                         */
                        HealthChecksAggregatedList.prototype.selfLink = null;
    
                        /**
                         * HealthChecksAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @instance
                         */
                        HealthChecksAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * HealthChecksAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @instance
                         */
                        HealthChecksAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HealthChecksAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @instance
                         */
                        Object.defineProperty(HealthChecksAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthChecksAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @instance
                         */
                        Object.defineProperty(HealthChecksAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthChecksAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @instance
                         */
                        Object.defineProperty(HealthChecksAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthChecksAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @instance
                         */
                        Object.defineProperty(HealthChecksAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthChecksAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @instance
                         */
                        Object.defineProperty(HealthChecksAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HealthChecksAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IHealthChecksAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HealthChecksAggregatedList} HealthChecksAggregatedList instance
                         */
                        HealthChecksAggregatedList.create = function create(properties) {
                            return new HealthChecksAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified HealthChecksAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.HealthChecksAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IHealthChecksAggregatedList} message HealthChecksAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthChecksAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.HealthChecksScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HealthChecksAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HealthChecksAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IHealthChecksAggregatedList} message HealthChecksAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthChecksAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HealthChecksAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HealthChecksAggregatedList} HealthChecksAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthChecksAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HealthChecksAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.HealthChecksScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HealthChecksAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HealthChecksAggregatedList} HealthChecksAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthChecksAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HealthChecksAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HealthChecksAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.HealthChecksScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HealthChecksAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HealthChecksAggregatedList} HealthChecksAggregatedList
                         */
                        HealthChecksAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HealthChecksAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HealthChecksAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HealthChecksAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.HealthChecksAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.HealthChecksScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.HealthChecksAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HealthChecksAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HealthChecksAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.HealthChecksAggregatedList} message HealthChecksAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HealthChecksAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.HealthChecksScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HealthChecksAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HealthChecksAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HealthChecksAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HealthChecksAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HealthChecksAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HealthChecksAggregatedList";
                        };
    
                        return HealthChecksAggregatedList;
                    })();
    
                    v1.HealthChecksScopedList = (function() {
    
                        /**
                         * Properties of a HealthChecksScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IHealthChecksScopedList
                         * @property {Array.<google.cloud.compute.v1.IHealthCheck>|null} [healthChecks] HealthChecksScopedList healthChecks
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] HealthChecksScopedList warning
                         */
    
                        /**
                         * Constructs a new HealthChecksScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HealthChecksScopedList.
                         * @implements IHealthChecksScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IHealthChecksScopedList=} [properties] Properties to set
                         */
                        function HealthChecksScopedList(properties) {
                            this.healthChecks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HealthChecksScopedList healthChecks.
                         * @member {Array.<google.cloud.compute.v1.IHealthCheck>} healthChecks
                         * @memberof google.cloud.compute.v1.HealthChecksScopedList
                         * @instance
                         */
                        HealthChecksScopedList.prototype.healthChecks = $util.emptyArray;
    
                        /**
                         * HealthChecksScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.HealthChecksScopedList
                         * @instance
                         */
                        HealthChecksScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HealthChecksScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.HealthChecksScopedList
                         * @instance
                         */
                        Object.defineProperty(HealthChecksScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HealthChecksScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HealthChecksScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IHealthChecksScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HealthChecksScopedList} HealthChecksScopedList instance
                         */
                        HealthChecksScopedList.create = function create(properties) {
                            return new HealthChecksScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified HealthChecksScopedList message. Does not implicitly {@link google.cloud.compute.v1.HealthChecksScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HealthChecksScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IHealthChecksScopedList} message HealthChecksScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthChecksScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.healthChecks != null && message.healthChecks.length)
                                for (var i = 0; i < message.healthChecks.length; ++i)
                                    $root.google.cloud.compute.v1.HealthCheck.encode(message.healthChecks[i], writer.uint32(/* id 448370606, wireType 2 =*/3586964850).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HealthChecksScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HealthChecksScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HealthChecksScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IHealthChecksScopedList} message HealthChecksScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthChecksScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HealthChecksScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HealthChecksScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HealthChecksScopedList} HealthChecksScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthChecksScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HealthChecksScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 448370606: {
                                        if (!(message.healthChecks && message.healthChecks.length))
                                            message.healthChecks = [];
                                        message.healthChecks.push($root.google.cloud.compute.v1.HealthCheck.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HealthChecksScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HealthChecksScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HealthChecksScopedList} HealthChecksScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthChecksScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HealthChecksScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HealthChecksScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HealthChecksScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.healthChecks != null && message.hasOwnProperty("healthChecks")) {
                                if (!Array.isArray(message.healthChecks))
                                    return "healthChecks: array expected";
                                for (var i = 0; i < message.healthChecks.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.HealthCheck.verify(message.healthChecks[i]);
                                    if (error)
                                        return "healthChecks." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HealthChecksScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HealthChecksScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HealthChecksScopedList} HealthChecksScopedList
                         */
                        HealthChecksScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HealthChecksScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HealthChecksScopedList();
                            if (object.healthChecks) {
                                if (!Array.isArray(object.healthChecks))
                                    throw TypeError(".google.cloud.compute.v1.HealthChecksScopedList.healthChecks: array expected");
                                message.healthChecks = [];
                                for (var i = 0; i < object.healthChecks.length; ++i) {
                                    if (typeof object.healthChecks[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.HealthChecksScopedList.healthChecks: object expected");
                                    message.healthChecks[i] = $root.google.cloud.compute.v1.HealthCheck.fromObject(object.healthChecks[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HealthChecksScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HealthChecksScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HealthChecksScopedList
                         * @static
                         * @param {google.cloud.compute.v1.HealthChecksScopedList} message HealthChecksScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HealthChecksScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.healthChecks = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.healthChecks && message.healthChecks.length) {
                                object.healthChecks = [];
                                for (var j = 0; j < message.healthChecks.length; ++j)
                                    object.healthChecks[j] = $root.google.cloud.compute.v1.HealthCheck.toObject(message.healthChecks[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HealthChecksScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HealthChecksScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HealthChecksScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HealthChecksScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HealthChecksScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HealthChecksScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HealthChecksScopedList";
                        };
    
                        return HealthChecksScopedList;
                    })();
    
                    v1.HealthStatus = (function() {
    
                        /**
                         * Properties of a HealthStatus.
                         * @memberof google.cloud.compute.v1
                         * @interface IHealthStatus
                         * @property {Object.<string,string>|null} [annotations] HealthStatus annotations
                         * @property {string|null} [forwardingRule] HealthStatus forwardingRule
                         * @property {string|null} [forwardingRuleIp] HealthStatus forwardingRuleIp
                         * @property {string|null} [healthState] HealthStatus healthState
                         * @property {string|null} [instance] HealthStatus instance
                         * @property {string|null} [ipAddress] HealthStatus ipAddress
                         * @property {number|null} [port] HealthStatus port
                         * @property {string|null} [weight] HealthStatus weight
                         * @property {string|null} [weightError] HealthStatus weightError
                         */
    
                        /**
                         * Constructs a new HealthStatus.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HealthStatus.
                         * @implements IHealthStatus
                         * @constructor
                         * @param {google.cloud.compute.v1.IHealthStatus=} [properties] Properties to set
                         */
                        function HealthStatus(properties) {
                            this.annotations = {};
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HealthStatus annotations.
                         * @member {Object.<string,string>} annotations
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @instance
                         */
                        HealthStatus.prototype.annotations = $util.emptyObject;
    
                        /**
                         * HealthStatus forwardingRule.
                         * @member {string|null|undefined} forwardingRule
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @instance
                         */
                        HealthStatus.prototype.forwardingRule = null;
    
                        /**
                         * HealthStatus forwardingRuleIp.
                         * @member {string|null|undefined} forwardingRuleIp
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @instance
                         */
                        HealthStatus.prototype.forwardingRuleIp = null;
    
                        /**
                         * HealthStatus healthState.
                         * @member {string|null|undefined} healthState
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @instance
                         */
                        HealthStatus.prototype.healthState = null;
    
                        /**
                         * HealthStatus instance.
                         * @member {string|null|undefined} instance
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @instance
                         */
                        HealthStatus.prototype.instance = null;
    
                        /**
                         * HealthStatus ipAddress.
                         * @member {string|null|undefined} ipAddress
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @instance
                         */
                        HealthStatus.prototype.ipAddress = null;
    
                        /**
                         * HealthStatus port.
                         * @member {number|null|undefined} port
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @instance
                         */
                        HealthStatus.prototype.port = null;
    
                        /**
                         * HealthStatus weight.
                         * @member {string|null|undefined} weight
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @instance
                         */
                        HealthStatus.prototype.weight = null;
    
                        /**
                         * HealthStatus weightError.
                         * @member {string|null|undefined} weightError
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @instance
                         */
                        HealthStatus.prototype.weightError = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HealthStatus _forwardingRule.
                         * @member {"forwardingRule"|undefined} _forwardingRule
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @instance
                         */
                        Object.defineProperty(HealthStatus.prototype, "_forwardingRule", {
                            get: $util.oneOfGetter($oneOfFields = ["forwardingRule"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthStatus _forwardingRuleIp.
                         * @member {"forwardingRuleIp"|undefined} _forwardingRuleIp
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @instance
                         */
                        Object.defineProperty(HealthStatus.prototype, "_forwardingRuleIp", {
                            get: $util.oneOfGetter($oneOfFields = ["forwardingRuleIp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthStatus _healthState.
                         * @member {"healthState"|undefined} _healthState
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @instance
                         */
                        Object.defineProperty(HealthStatus.prototype, "_healthState", {
                            get: $util.oneOfGetter($oneOfFields = ["healthState"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthStatus _instance.
                         * @member {"instance"|undefined} _instance
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @instance
                         */
                        Object.defineProperty(HealthStatus.prototype, "_instance", {
                            get: $util.oneOfGetter($oneOfFields = ["instance"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthStatus _ipAddress.
                         * @member {"ipAddress"|undefined} _ipAddress
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @instance
                         */
                        Object.defineProperty(HealthStatus.prototype, "_ipAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["ipAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthStatus _port.
                         * @member {"port"|undefined} _port
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @instance
                         */
                        Object.defineProperty(HealthStatus.prototype, "_port", {
                            get: $util.oneOfGetter($oneOfFields = ["port"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthStatus _weight.
                         * @member {"weight"|undefined} _weight
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @instance
                         */
                        Object.defineProperty(HealthStatus.prototype, "_weight", {
                            get: $util.oneOfGetter($oneOfFields = ["weight"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthStatus _weightError.
                         * @member {"weightError"|undefined} _weightError
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @instance
                         */
                        Object.defineProperty(HealthStatus.prototype, "_weightError", {
                            get: $util.oneOfGetter($oneOfFields = ["weightError"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HealthStatus instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @static
                         * @param {google.cloud.compute.v1.IHealthStatus=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HealthStatus} HealthStatus instance
                         */
                        HealthStatus.create = function create(properties) {
                            return new HealthStatus(properties);
                        };
    
                        /**
                         * Encodes the specified HealthStatus message. Does not implicitly {@link google.cloud.compute.v1.HealthStatus.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @static
                         * @param {google.cloud.compute.v1.IHealthStatus} message HealthStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthStatus.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.port != null && Object.hasOwnProperty.call(message, "port"))
                                writer.uint32(/* id 3446913, wireType 0 =*/27575304).int32(message.port);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.annotations != null && Object.hasOwnProperty.call(message, "annotations"))
                                for (var keys = Object.keys(message.annotations), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 112032548, wireType 2 =*/896260386).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.annotations[keys[i]]).ldelim();
                            if (message.forwardingRuleIp != null && Object.hasOwnProperty.call(message, "forwardingRuleIp"))
                                writer.uint32(/* id 172250632, wireType 2 =*/1378005058).string(message.forwardingRuleIp);
                            if (message.forwardingRule != null && Object.hasOwnProperty.call(message, "forwardingRule"))
                                writer.uint32(/* id 269964030, wireType 2 =*/2159712242).string(message.forwardingRule);
                            if (message.weight != null && Object.hasOwnProperty.call(message, "weight"))
                                writer.uint32(/* id 282149496, wireType 2 =*/2257195970).string(message.weight);
                            if (message.healthState != null && Object.hasOwnProperty.call(message, "healthState"))
                                writer.uint32(/* id 324007150, wireType 2 =*/2592057202).string(message.healthState);
                            if (message.ipAddress != null && Object.hasOwnProperty.call(message, "ipAddress"))
                                writer.uint32(/* id 406272220, wireType 2 =*/3250177762).string(message.ipAddress);
                            if (message.weightError != null && Object.hasOwnProperty.call(message, "weightError"))
                                writer.uint32(/* id 522501505, wireType 2 =*/4180012042).string(message.weightError);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HealthStatus message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HealthStatus.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @static
                         * @param {google.cloud.compute.v1.IHealthStatus} message HealthStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthStatus.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HealthStatus message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HealthStatus} HealthStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthStatus.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HealthStatus(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 112032548: {
                                        if (message.annotations === $util.emptyObject)
                                            message.annotations = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.annotations[key] = value;
                                        break;
                                    }
                                case 269964030: {
                                        message.forwardingRule = reader.string();
                                        break;
                                    }
                                case 172250632: {
                                        message.forwardingRuleIp = reader.string();
                                        break;
                                    }
                                case 324007150: {
                                        message.healthState = reader.string();
                                        break;
                                    }
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 406272220: {
                                        message.ipAddress = reader.string();
                                        break;
                                    }
                                case 3446913: {
                                        message.port = reader.int32();
                                        break;
                                    }
                                case 282149496: {
                                        message.weight = reader.string();
                                        break;
                                    }
                                case 522501505: {
                                        message.weightError = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HealthStatus message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HealthStatus} HealthStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthStatus.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HealthStatus message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HealthStatus.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.annotations != null && message.hasOwnProperty("annotations")) {
                                if (!$util.isObject(message.annotations))
                                    return "annotations: object expected";
                                var key = Object.keys(message.annotations);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.annotations[key[i]]))
                                        return "annotations: string{k:string} expected";
                            }
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule")) {
                                properties._forwardingRule = 1;
                                if (!$util.isString(message.forwardingRule))
                                    return "forwardingRule: string expected";
                            }
                            if (message.forwardingRuleIp != null && message.hasOwnProperty("forwardingRuleIp")) {
                                properties._forwardingRuleIp = 1;
                                if (!$util.isString(message.forwardingRuleIp))
                                    return "forwardingRuleIp: string expected";
                            }
                            if (message.healthState != null && message.hasOwnProperty("healthState")) {
                                properties._healthState = 1;
                                if (!$util.isString(message.healthState))
                                    return "healthState: string expected";
                            }
                            if (message.instance != null && message.hasOwnProperty("instance")) {
                                properties._instance = 1;
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            }
                            if (message.ipAddress != null && message.hasOwnProperty("ipAddress")) {
                                properties._ipAddress = 1;
                                if (!$util.isString(message.ipAddress))
                                    return "ipAddress: string expected";
                            }
                            if (message.port != null && message.hasOwnProperty("port")) {
                                properties._port = 1;
                                if (!$util.isInteger(message.port))
                                    return "port: integer expected";
                            }
                            if (message.weight != null && message.hasOwnProperty("weight")) {
                                properties._weight = 1;
                                if (!$util.isString(message.weight))
                                    return "weight: string expected";
                            }
                            if (message.weightError != null && message.hasOwnProperty("weightError")) {
                                properties._weightError = 1;
                                if (!$util.isString(message.weightError))
                                    return "weightError: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HealthStatus message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HealthStatus} HealthStatus
                         */
                        HealthStatus.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HealthStatus)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HealthStatus();
                            if (object.annotations) {
                                if (typeof object.annotations !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HealthStatus.annotations: object expected");
                                message.annotations = {};
                                for (var keys = Object.keys(object.annotations), i = 0; i < keys.length; ++i)
                                    message.annotations[keys[i]] = String(object.annotations[keys[i]]);
                            }
                            if (object.forwardingRule != null)
                                message.forwardingRule = String(object.forwardingRule);
                            if (object.forwardingRuleIp != null)
                                message.forwardingRuleIp = String(object.forwardingRuleIp);
                            if (object.healthState != null)
                                message.healthState = String(object.healthState);
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.ipAddress != null)
                                message.ipAddress = String(object.ipAddress);
                            if (object.port != null)
                                message.port = object.port | 0;
                            if (object.weight != null)
                                message.weight = String(object.weight);
                            if (object.weightError != null)
                                message.weightError = String(object.weightError);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HealthStatus message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @static
                         * @param {google.cloud.compute.v1.HealthStatus} message HealthStatus
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HealthStatus.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.objects || options.defaults)
                                object.annotations = {};
                            if (message.port != null && message.hasOwnProperty("port")) {
                                object.port = message.port;
                                if (options.oneofs)
                                    object._port = "port";
                            }
                            if (message.instance != null && message.hasOwnProperty("instance")) {
                                object.instance = message.instance;
                                if (options.oneofs)
                                    object._instance = "instance";
                            }
                            var keys2;
                            if (message.annotations && (keys2 = Object.keys(message.annotations)).length) {
                                object.annotations = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.annotations[keys2[j]] = message.annotations[keys2[j]];
                            }
                            if (message.forwardingRuleIp != null && message.hasOwnProperty("forwardingRuleIp")) {
                                object.forwardingRuleIp = message.forwardingRuleIp;
                                if (options.oneofs)
                                    object._forwardingRuleIp = "forwardingRuleIp";
                            }
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule")) {
                                object.forwardingRule = message.forwardingRule;
                                if (options.oneofs)
                                    object._forwardingRule = "forwardingRule";
                            }
                            if (message.weight != null && message.hasOwnProperty("weight")) {
                                object.weight = message.weight;
                                if (options.oneofs)
                                    object._weight = "weight";
                            }
                            if (message.healthState != null && message.hasOwnProperty("healthState")) {
                                object.healthState = message.healthState;
                                if (options.oneofs)
                                    object._healthState = "healthState";
                            }
                            if (message.ipAddress != null && message.hasOwnProperty("ipAddress")) {
                                object.ipAddress = message.ipAddress;
                                if (options.oneofs)
                                    object._ipAddress = "ipAddress";
                            }
                            if (message.weightError != null && message.hasOwnProperty("weightError")) {
                                object.weightError = message.weightError;
                                if (options.oneofs)
                                    object._weightError = "weightError";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HealthStatus to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HealthStatus.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HealthStatus
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HealthStatus
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HealthStatus.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HealthStatus";
                        };
    
                        /**
                         * HealthState enum.
                         * @name google.cloud.compute.v1.HealthStatus.HealthState
                         * @enum {number}
                         * @property {number} UNDEFINED_HEALTH_STATE=0 UNDEFINED_HEALTH_STATE value
                         * @property {number} HEALTHY=439801213 HEALTHY value
                         * @property {number} UNHEALTHY=462118084 UNHEALTHY value
                         */
                        HealthStatus.HealthState = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_HEALTH_STATE"] = 0;
                            values[valuesById[439801213] = "HEALTHY"] = 439801213;
                            values[valuesById[462118084] = "UNHEALTHY"] = 462118084;
                            return values;
                        })();
    
                        /**
                         * WeightError enum.
                         * @name google.cloud.compute.v1.HealthStatus.WeightError
                         * @enum {number}
                         * @property {number} UNDEFINED_WEIGHT_ERROR=0 UNDEFINED_WEIGHT_ERROR value
                         * @property {number} INVALID_WEIGHT=383698400 INVALID_WEIGHT value
                         * @property {number} MISSING_WEIGHT=384027537 MISSING_WEIGHT value
                         * @property {number} UNAVAILABLE_WEIGHT=439464295 UNAVAILABLE_WEIGHT value
                         * @property {number} WEIGHT_NONE=502428831 WEIGHT_NONE value
                         */
                        HealthStatus.WeightError = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_WEIGHT_ERROR"] = 0;
                            values[valuesById[383698400] = "INVALID_WEIGHT"] = 383698400;
                            values[valuesById[384027537] = "MISSING_WEIGHT"] = 384027537;
                            values[valuesById[439464295] = "UNAVAILABLE_WEIGHT"] = 439464295;
                            values[valuesById[502428831] = "WEIGHT_NONE"] = 502428831;
                            return values;
                        })();
    
                        return HealthStatus;
                    })();
    
                    v1.HealthStatusForNetworkEndpoint = (function() {
    
                        /**
                         * Properties of a HealthStatusForNetworkEndpoint.
                         * @memberof google.cloud.compute.v1
                         * @interface IHealthStatusForNetworkEndpoint
                         * @property {google.cloud.compute.v1.IBackendServiceReference|null} [backendService] HealthStatusForNetworkEndpoint backendService
                         * @property {google.cloud.compute.v1.IForwardingRuleReference|null} [forwardingRule] HealthStatusForNetworkEndpoint forwardingRule
                         * @property {google.cloud.compute.v1.IHealthCheckReference|null} [healthCheck] HealthStatusForNetworkEndpoint healthCheck
                         * @property {google.cloud.compute.v1.IHealthCheckServiceReference|null} [healthCheckService] HealthStatusForNetworkEndpoint healthCheckService
                         * @property {string|null} [healthState] HealthStatusForNetworkEndpoint healthState
                         */
    
                        /**
                         * Constructs a new HealthStatusForNetworkEndpoint.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HealthStatusForNetworkEndpoint.
                         * @implements IHealthStatusForNetworkEndpoint
                         * @constructor
                         * @param {google.cloud.compute.v1.IHealthStatusForNetworkEndpoint=} [properties] Properties to set
                         */
                        function HealthStatusForNetworkEndpoint(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HealthStatusForNetworkEndpoint backendService.
                         * @member {google.cloud.compute.v1.IBackendServiceReference|null|undefined} backendService
                         * @memberof google.cloud.compute.v1.HealthStatusForNetworkEndpoint
                         * @instance
                         */
                        HealthStatusForNetworkEndpoint.prototype.backendService = null;
    
                        /**
                         * HealthStatusForNetworkEndpoint forwardingRule.
                         * @member {google.cloud.compute.v1.IForwardingRuleReference|null|undefined} forwardingRule
                         * @memberof google.cloud.compute.v1.HealthStatusForNetworkEndpoint
                         * @instance
                         */
                        HealthStatusForNetworkEndpoint.prototype.forwardingRule = null;
    
                        /**
                         * HealthStatusForNetworkEndpoint healthCheck.
                         * @member {google.cloud.compute.v1.IHealthCheckReference|null|undefined} healthCheck
                         * @memberof google.cloud.compute.v1.HealthStatusForNetworkEndpoint
                         * @instance
                         */
                        HealthStatusForNetworkEndpoint.prototype.healthCheck = null;
    
                        /**
                         * HealthStatusForNetworkEndpoint healthCheckService.
                         * @member {google.cloud.compute.v1.IHealthCheckServiceReference|null|undefined} healthCheckService
                         * @memberof google.cloud.compute.v1.HealthStatusForNetworkEndpoint
                         * @instance
                         */
                        HealthStatusForNetworkEndpoint.prototype.healthCheckService = null;
    
                        /**
                         * HealthStatusForNetworkEndpoint healthState.
                         * @member {string|null|undefined} healthState
                         * @memberof google.cloud.compute.v1.HealthStatusForNetworkEndpoint
                         * @instance
                         */
                        HealthStatusForNetworkEndpoint.prototype.healthState = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HealthStatusForNetworkEndpoint _backendService.
                         * @member {"backendService"|undefined} _backendService
                         * @memberof google.cloud.compute.v1.HealthStatusForNetworkEndpoint
                         * @instance
                         */
                        Object.defineProperty(HealthStatusForNetworkEndpoint.prototype, "_backendService", {
                            get: $util.oneOfGetter($oneOfFields = ["backendService"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthStatusForNetworkEndpoint _forwardingRule.
                         * @member {"forwardingRule"|undefined} _forwardingRule
                         * @memberof google.cloud.compute.v1.HealthStatusForNetworkEndpoint
                         * @instance
                         */
                        Object.defineProperty(HealthStatusForNetworkEndpoint.prototype, "_forwardingRule", {
                            get: $util.oneOfGetter($oneOfFields = ["forwardingRule"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthStatusForNetworkEndpoint _healthCheck.
                         * @member {"healthCheck"|undefined} _healthCheck
                         * @memberof google.cloud.compute.v1.HealthStatusForNetworkEndpoint
                         * @instance
                         */
                        Object.defineProperty(HealthStatusForNetworkEndpoint.prototype, "_healthCheck", {
                            get: $util.oneOfGetter($oneOfFields = ["healthCheck"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthStatusForNetworkEndpoint _healthCheckService.
                         * @member {"healthCheckService"|undefined} _healthCheckService
                         * @memberof google.cloud.compute.v1.HealthStatusForNetworkEndpoint
                         * @instance
                         */
                        Object.defineProperty(HealthStatusForNetworkEndpoint.prototype, "_healthCheckService", {
                            get: $util.oneOfGetter($oneOfFields = ["healthCheckService"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HealthStatusForNetworkEndpoint _healthState.
                         * @member {"healthState"|undefined} _healthState
                         * @memberof google.cloud.compute.v1.HealthStatusForNetworkEndpoint
                         * @instance
                         */
                        Object.defineProperty(HealthStatusForNetworkEndpoint.prototype, "_healthState", {
                            get: $util.oneOfGetter($oneOfFields = ["healthState"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HealthStatusForNetworkEndpoint instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HealthStatusForNetworkEndpoint
                         * @static
                         * @param {google.cloud.compute.v1.IHealthStatusForNetworkEndpoint=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HealthStatusForNetworkEndpoint} HealthStatusForNetworkEndpoint instance
                         */
                        HealthStatusForNetworkEndpoint.create = function create(properties) {
                            return new HealthStatusForNetworkEndpoint(properties);
                        };
    
                        /**
                         * Encodes the specified HealthStatusForNetworkEndpoint message. Does not implicitly {@link google.cloud.compute.v1.HealthStatusForNetworkEndpoint.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HealthStatusForNetworkEndpoint
                         * @static
                         * @param {google.cloud.compute.v1.IHealthStatusForNetworkEndpoint} message HealthStatusForNetworkEndpoint message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthStatusForNetworkEndpoint.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.forwardingRule != null && Object.hasOwnProperty.call(message, "forwardingRule"))
                                $root.google.cloud.compute.v1.ForwardingRuleReference.encode(message.forwardingRule, writer.uint32(/* id 269964030, wireType 2 =*/2159712242).fork()).ldelim();
                            if (message.backendService != null && Object.hasOwnProperty.call(message, "backendService"))
                                $root.google.cloud.compute.v1.BackendServiceReference.encode(message.backendService, writer.uint32(/* id 306946058, wireType 2 =*/2455568466).fork()).ldelim();
                            if (message.healthCheck != null && Object.hasOwnProperty.call(message, "healthCheck"))
                                $root.google.cloud.compute.v1.HealthCheckReference.encode(message.healthCheck, writer.uint32(/* id 308876645, wireType 2 =*/2471013162).fork()).ldelim();
                            if (message.healthState != null && Object.hasOwnProperty.call(message, "healthState"))
                                writer.uint32(/* id 324007150, wireType 2 =*/2592057202).string(message.healthState);
                            if (message.healthCheckService != null && Object.hasOwnProperty.call(message, "healthCheckService"))
                                $root.google.cloud.compute.v1.HealthCheckServiceReference.encode(message.healthCheckService, writer.uint32(/* id 408374747, wireType 2 =*/3266997978).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HealthStatusForNetworkEndpoint message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HealthStatusForNetworkEndpoint.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HealthStatusForNetworkEndpoint
                         * @static
                         * @param {google.cloud.compute.v1.IHealthStatusForNetworkEndpoint} message HealthStatusForNetworkEndpoint message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HealthStatusForNetworkEndpoint.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HealthStatusForNetworkEndpoint message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HealthStatusForNetworkEndpoint
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HealthStatusForNetworkEndpoint} HealthStatusForNetworkEndpoint
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthStatusForNetworkEndpoint.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HealthStatusForNetworkEndpoint();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 306946058: {
                                        message.backendService = $root.google.cloud.compute.v1.BackendServiceReference.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 269964030: {
                                        message.forwardingRule = $root.google.cloud.compute.v1.ForwardingRuleReference.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 308876645: {
                                        message.healthCheck = $root.google.cloud.compute.v1.HealthCheckReference.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 408374747: {
                                        message.healthCheckService = $root.google.cloud.compute.v1.HealthCheckServiceReference.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 324007150: {
                                        message.healthState = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HealthStatusForNetworkEndpoint message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HealthStatusForNetworkEndpoint
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HealthStatusForNetworkEndpoint} HealthStatusForNetworkEndpoint
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HealthStatusForNetworkEndpoint.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HealthStatusForNetworkEndpoint message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HealthStatusForNetworkEndpoint
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HealthStatusForNetworkEndpoint.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendService != null && message.hasOwnProperty("backendService")) {
                                properties._backendService = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.BackendServiceReference.verify(message.backendService);
                                    if (error)
                                        return "backendService." + error;
                                }
                            }
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule")) {
                                properties._forwardingRule = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ForwardingRuleReference.verify(message.forwardingRule);
                                    if (error)
                                        return "forwardingRule." + error;
                                }
                            }
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck")) {
                                properties._healthCheck = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HealthCheckReference.verify(message.healthCheck);
                                    if (error)
                                        return "healthCheck." + error;
                                }
                            }
                            if (message.healthCheckService != null && message.hasOwnProperty("healthCheckService")) {
                                properties._healthCheckService = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HealthCheckServiceReference.verify(message.healthCheckService);
                                    if (error)
                                        return "healthCheckService." + error;
                                }
                            }
                            if (message.healthState != null && message.hasOwnProperty("healthState")) {
                                properties._healthState = 1;
                                if (!$util.isString(message.healthState))
                                    return "healthState: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HealthStatusForNetworkEndpoint message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HealthStatusForNetworkEndpoint
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HealthStatusForNetworkEndpoint} HealthStatusForNetworkEndpoint
                         */
                        HealthStatusForNetworkEndpoint.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HealthStatusForNetworkEndpoint)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HealthStatusForNetworkEndpoint();
                            if (object.backendService != null) {
                                if (typeof object.backendService !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HealthStatusForNetworkEndpoint.backendService: object expected");
                                message.backendService = $root.google.cloud.compute.v1.BackendServiceReference.fromObject(object.backendService);
                            }
                            if (object.forwardingRule != null) {
                                if (typeof object.forwardingRule !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HealthStatusForNetworkEndpoint.forwardingRule: object expected");
                                message.forwardingRule = $root.google.cloud.compute.v1.ForwardingRuleReference.fromObject(object.forwardingRule);
                            }
                            if (object.healthCheck != null) {
                                if (typeof object.healthCheck !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HealthStatusForNetworkEndpoint.healthCheck: object expected");
                                message.healthCheck = $root.google.cloud.compute.v1.HealthCheckReference.fromObject(object.healthCheck);
                            }
                            if (object.healthCheckService != null) {
                                if (typeof object.healthCheckService !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HealthStatusForNetworkEndpoint.healthCheckService: object expected");
                                message.healthCheckService = $root.google.cloud.compute.v1.HealthCheckServiceReference.fromObject(object.healthCheckService);
                            }
                            if (object.healthState != null)
                                message.healthState = String(object.healthState);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HealthStatusForNetworkEndpoint message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HealthStatusForNetworkEndpoint
                         * @static
                         * @param {google.cloud.compute.v1.HealthStatusForNetworkEndpoint} message HealthStatusForNetworkEndpoint
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HealthStatusForNetworkEndpoint.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule")) {
                                object.forwardingRule = $root.google.cloud.compute.v1.ForwardingRuleReference.toObject(message.forwardingRule, options);
                                if (options.oneofs)
                                    object._forwardingRule = "forwardingRule";
                            }
                            if (message.backendService != null && message.hasOwnProperty("backendService")) {
                                object.backendService = $root.google.cloud.compute.v1.BackendServiceReference.toObject(message.backendService, options);
                                if (options.oneofs)
                                    object._backendService = "backendService";
                            }
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck")) {
                                object.healthCheck = $root.google.cloud.compute.v1.HealthCheckReference.toObject(message.healthCheck, options);
                                if (options.oneofs)
                                    object._healthCheck = "healthCheck";
                            }
                            if (message.healthState != null && message.hasOwnProperty("healthState")) {
                                object.healthState = message.healthState;
                                if (options.oneofs)
                                    object._healthState = "healthState";
                            }
                            if (message.healthCheckService != null && message.hasOwnProperty("healthCheckService")) {
                                object.healthCheckService = $root.google.cloud.compute.v1.HealthCheckServiceReference.toObject(message.healthCheckService, options);
                                if (options.oneofs)
                                    object._healthCheckService = "healthCheckService";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HealthStatusForNetworkEndpoint to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HealthStatusForNetworkEndpoint
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HealthStatusForNetworkEndpoint.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HealthStatusForNetworkEndpoint
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HealthStatusForNetworkEndpoint
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HealthStatusForNetworkEndpoint.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HealthStatusForNetworkEndpoint";
                        };
    
                        /**
                         * HealthState enum.
                         * @name google.cloud.compute.v1.HealthStatusForNetworkEndpoint.HealthState
                         * @enum {number}
                         * @property {number} UNDEFINED_HEALTH_STATE=0 UNDEFINED_HEALTH_STATE value
                         * @property {number} DRAINING=480455402 DRAINING value
                         * @property {number} HEALTHY=439801213 HEALTHY value
                         * @property {number} UNHEALTHY=462118084 UNHEALTHY value
                         * @property {number} UNKNOWN=433141802 UNKNOWN value
                         */
                        HealthStatusForNetworkEndpoint.HealthState = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_HEALTH_STATE"] = 0;
                            values[valuesById[480455402] = "DRAINING"] = 480455402;
                            values[valuesById[439801213] = "HEALTHY"] = 439801213;
                            values[valuesById[462118084] = "UNHEALTHY"] = 462118084;
                            values[valuesById[433141802] = "UNKNOWN"] = 433141802;
                            return values;
                        })();
    
                        return HealthStatusForNetworkEndpoint;
                    })();
    
                    v1.Help = (function() {
    
                        /**
                         * Properties of a Help.
                         * @memberof google.cloud.compute.v1
                         * @interface IHelp
                         * @property {Array.<google.cloud.compute.v1.IHelpLink>|null} [links] Help links
                         */
    
                        /**
                         * Constructs a new Help.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Help.
                         * @implements IHelp
                         * @constructor
                         * @param {google.cloud.compute.v1.IHelp=} [properties] Properties to set
                         */
                        function Help(properties) {
                            this.links = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Help links.
                         * @member {Array.<google.cloud.compute.v1.IHelpLink>} links
                         * @memberof google.cloud.compute.v1.Help
                         * @instance
                         */
                        Help.prototype.links = $util.emptyArray;
    
                        /**
                         * Creates a new Help instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Help
                         * @static
                         * @param {google.cloud.compute.v1.IHelp=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Help} Help instance
                         */
                        Help.create = function create(properties) {
                            return new Help(properties);
                        };
    
                        /**
                         * Encodes the specified Help message. Does not implicitly {@link google.cloud.compute.v1.Help.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Help
                         * @static
                         * @param {google.cloud.compute.v1.IHelp} message Help message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Help.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.links != null && message.links.length)
                                for (var i = 0; i < message.links.length; ++i)
                                    $root.google.cloud.compute.v1.HelpLink.encode(message.links[i], writer.uint32(/* id 102977465, wireType 2 =*/823819722).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Help message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Help.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Help
                         * @static
                         * @param {google.cloud.compute.v1.IHelp} message Help message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Help.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Help message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Help
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Help} Help
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Help.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Help();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 102977465: {
                                        if (!(message.links && message.links.length))
                                            message.links = [];
                                        message.links.push($root.google.cloud.compute.v1.HelpLink.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Help message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Help
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Help} Help
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Help.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Help message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Help
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Help.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.links != null && message.hasOwnProperty("links")) {
                                if (!Array.isArray(message.links))
                                    return "links: array expected";
                                for (var i = 0; i < message.links.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.HelpLink.verify(message.links[i]);
                                    if (error)
                                        return "links." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Help message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Help
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Help} Help
                         */
                        Help.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Help)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Help();
                            if (object.links) {
                                if (!Array.isArray(object.links))
                                    throw TypeError(".google.cloud.compute.v1.Help.links: array expected");
                                message.links = [];
                                for (var i = 0; i < object.links.length; ++i) {
                                    if (typeof object.links[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Help.links: object expected");
                                    message.links[i] = $root.google.cloud.compute.v1.HelpLink.fromObject(object.links[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Help message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Help
                         * @static
                         * @param {google.cloud.compute.v1.Help} message Help
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Help.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.links = [];
                            if (message.links && message.links.length) {
                                object.links = [];
                                for (var j = 0; j < message.links.length; ++j)
                                    object.links[j] = $root.google.cloud.compute.v1.HelpLink.toObject(message.links[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Help to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Help
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Help.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Help
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Help
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Help.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Help";
                        };
    
                        return Help;
                    })();
    
                    v1.HelpLink = (function() {
    
                        /**
                         * Properties of a HelpLink.
                         * @memberof google.cloud.compute.v1
                         * @interface IHelpLink
                         * @property {string|null} [description] HelpLink description
                         * @property {string|null} [url] HelpLink url
                         */
    
                        /**
                         * Constructs a new HelpLink.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HelpLink.
                         * @implements IHelpLink
                         * @constructor
                         * @param {google.cloud.compute.v1.IHelpLink=} [properties] Properties to set
                         */
                        function HelpLink(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HelpLink description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.HelpLink
                         * @instance
                         */
                        HelpLink.prototype.description = null;
    
                        /**
                         * HelpLink url.
                         * @member {string|null|undefined} url
                         * @memberof google.cloud.compute.v1.HelpLink
                         * @instance
                         */
                        HelpLink.prototype.url = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HelpLink _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.HelpLink
                         * @instance
                         */
                        Object.defineProperty(HelpLink.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HelpLink _url.
                         * @member {"url"|undefined} _url
                         * @memberof google.cloud.compute.v1.HelpLink
                         * @instance
                         */
                        Object.defineProperty(HelpLink.prototype, "_url", {
                            get: $util.oneOfGetter($oneOfFields = ["url"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HelpLink instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HelpLink
                         * @static
                         * @param {google.cloud.compute.v1.IHelpLink=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HelpLink} HelpLink instance
                         */
                        HelpLink.create = function create(properties) {
                            return new HelpLink(properties);
                        };
    
                        /**
                         * Encodes the specified HelpLink message. Does not implicitly {@link google.cloud.compute.v1.HelpLink.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HelpLink
                         * @static
                         * @param {google.cloud.compute.v1.IHelpLink} message HelpLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HelpLink.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.url != null && Object.hasOwnProperty.call(message, "url"))
                                writer.uint32(/* id 116079, wireType 2 =*/928634).string(message.url);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HelpLink message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HelpLink.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HelpLink
                         * @static
                         * @param {google.cloud.compute.v1.IHelpLink} message HelpLink message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HelpLink.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HelpLink message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HelpLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HelpLink} HelpLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HelpLink.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HelpLink();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 116079: {
                                        message.url = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HelpLink message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HelpLink
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HelpLink} HelpLink
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HelpLink.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HelpLink message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HelpLink
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HelpLink.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.url != null && message.hasOwnProperty("url")) {
                                properties._url = 1;
                                if (!$util.isString(message.url))
                                    return "url: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HelpLink message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HelpLink
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HelpLink} HelpLink
                         */
                        HelpLink.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HelpLink)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HelpLink();
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.url != null)
                                message.url = String(object.url);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HelpLink message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HelpLink
                         * @static
                         * @param {google.cloud.compute.v1.HelpLink} message HelpLink
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HelpLink.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.url != null && message.hasOwnProperty("url")) {
                                object.url = message.url;
                                if (options.oneofs)
                                    object._url = "url";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HelpLink to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HelpLink
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HelpLink.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HelpLink
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HelpLink
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HelpLink.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HelpLink";
                        };
    
                        return HelpLink;
                    })();
    
                    v1.HostRule = (function() {
    
                        /**
                         * Properties of a HostRule.
                         * @memberof google.cloud.compute.v1
                         * @interface IHostRule
                         * @property {string|null} [description] HostRule description
                         * @property {Array.<string>|null} [hosts] HostRule hosts
                         * @property {string|null} [pathMatcher] HostRule pathMatcher
                         */
    
                        /**
                         * Constructs a new HostRule.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HostRule.
                         * @implements IHostRule
                         * @constructor
                         * @param {google.cloud.compute.v1.IHostRule=} [properties] Properties to set
                         */
                        function HostRule(properties) {
                            this.hosts = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HostRule description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.HostRule
                         * @instance
                         */
                        HostRule.prototype.description = null;
    
                        /**
                         * HostRule hosts.
                         * @member {Array.<string>} hosts
                         * @memberof google.cloud.compute.v1.HostRule
                         * @instance
                         */
                        HostRule.prototype.hosts = $util.emptyArray;
    
                        /**
                         * HostRule pathMatcher.
                         * @member {string|null|undefined} pathMatcher
                         * @memberof google.cloud.compute.v1.HostRule
                         * @instance
                         */
                        HostRule.prototype.pathMatcher = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HostRule _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.HostRule
                         * @instance
                         */
                        Object.defineProperty(HostRule.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HostRule _pathMatcher.
                         * @member {"pathMatcher"|undefined} _pathMatcher
                         * @memberof google.cloud.compute.v1.HostRule
                         * @instance
                         */
                        Object.defineProperty(HostRule.prototype, "_pathMatcher", {
                            get: $util.oneOfGetter($oneOfFields = ["pathMatcher"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HostRule instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HostRule
                         * @static
                         * @param {google.cloud.compute.v1.IHostRule=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HostRule} HostRule instance
                         */
                        HostRule.create = function create(properties) {
                            return new HostRule(properties);
                        };
    
                        /**
                         * Encodes the specified HostRule message. Does not implicitly {@link google.cloud.compute.v1.HostRule.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HostRule
                         * @static
                         * @param {google.cloud.compute.v1.IHostRule} message HostRule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HostRule.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.hosts != null && message.hosts.length)
                                for (var i = 0; i < message.hosts.length; ++i)
                                    writer.uint32(/* id 99467211, wireType 2 =*/795737690).string(message.hosts[i]);
                            if (message.pathMatcher != null && Object.hasOwnProperty.call(message, "pathMatcher"))
                                writer.uint32(/* id 337813272, wireType 2 =*/2702506178).string(message.pathMatcher);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HostRule message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HostRule.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HostRule
                         * @static
                         * @param {google.cloud.compute.v1.IHostRule} message HostRule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HostRule.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HostRule message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HostRule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HostRule} HostRule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HostRule.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HostRule();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 99467211: {
                                        if (!(message.hosts && message.hosts.length))
                                            message.hosts = [];
                                        message.hosts.push(reader.string());
                                        break;
                                    }
                                case 337813272: {
                                        message.pathMatcher = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HostRule message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HostRule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HostRule} HostRule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HostRule.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HostRule message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HostRule
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HostRule.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.hosts != null && message.hasOwnProperty("hosts")) {
                                if (!Array.isArray(message.hosts))
                                    return "hosts: array expected";
                                for (var i = 0; i < message.hosts.length; ++i)
                                    if (!$util.isString(message.hosts[i]))
                                        return "hosts: string[] expected";
                            }
                            if (message.pathMatcher != null && message.hasOwnProperty("pathMatcher")) {
                                properties._pathMatcher = 1;
                                if (!$util.isString(message.pathMatcher))
                                    return "pathMatcher: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HostRule message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HostRule
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HostRule} HostRule
                         */
                        HostRule.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HostRule)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HostRule();
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.hosts) {
                                if (!Array.isArray(object.hosts))
                                    throw TypeError(".google.cloud.compute.v1.HostRule.hosts: array expected");
                                message.hosts = [];
                                for (var i = 0; i < object.hosts.length; ++i)
                                    message.hosts[i] = String(object.hosts[i]);
                            }
                            if (object.pathMatcher != null)
                                message.pathMatcher = String(object.pathMatcher);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HostRule message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HostRule
                         * @static
                         * @param {google.cloud.compute.v1.HostRule} message HostRule
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HostRule.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.hosts = [];
                            if (message.hosts && message.hosts.length) {
                                object.hosts = [];
                                for (var j = 0; j < message.hosts.length; ++j)
                                    object.hosts[j] = message.hosts[j];
                            }
                            if (message.pathMatcher != null && message.hasOwnProperty("pathMatcher")) {
                                object.pathMatcher = message.pathMatcher;
                                if (options.oneofs)
                                    object._pathMatcher = "pathMatcher";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HostRule to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HostRule
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HostRule.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HostRule
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HostRule
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HostRule.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HostRule";
                        };
    
                        return HostRule;
                    })();
    
                    v1.HttpFaultAbort = (function() {
    
                        /**
                         * Properties of a HttpFaultAbort.
                         * @memberof google.cloud.compute.v1
                         * @interface IHttpFaultAbort
                         * @property {number|null} [httpStatus] HttpFaultAbort httpStatus
                         * @property {number|null} [percentage] HttpFaultAbort percentage
                         */
    
                        /**
                         * Constructs a new HttpFaultAbort.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HttpFaultAbort.
                         * @implements IHttpFaultAbort
                         * @constructor
                         * @param {google.cloud.compute.v1.IHttpFaultAbort=} [properties] Properties to set
                         */
                        function HttpFaultAbort(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HttpFaultAbort httpStatus.
                         * @member {number|null|undefined} httpStatus
                         * @memberof google.cloud.compute.v1.HttpFaultAbort
                         * @instance
                         */
                        HttpFaultAbort.prototype.httpStatus = null;
    
                        /**
                         * HttpFaultAbort percentage.
                         * @member {number|null|undefined} percentage
                         * @memberof google.cloud.compute.v1.HttpFaultAbort
                         * @instance
                         */
                        HttpFaultAbort.prototype.percentage = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HttpFaultAbort _httpStatus.
                         * @member {"httpStatus"|undefined} _httpStatus
                         * @memberof google.cloud.compute.v1.HttpFaultAbort
                         * @instance
                         */
                        Object.defineProperty(HttpFaultAbort.prototype, "_httpStatus", {
                            get: $util.oneOfGetter($oneOfFields = ["httpStatus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpFaultAbort _percentage.
                         * @member {"percentage"|undefined} _percentage
                         * @memberof google.cloud.compute.v1.HttpFaultAbort
                         * @instance
                         */
                        Object.defineProperty(HttpFaultAbort.prototype, "_percentage", {
                            get: $util.oneOfGetter($oneOfFields = ["percentage"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HttpFaultAbort instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HttpFaultAbort
                         * @static
                         * @param {google.cloud.compute.v1.IHttpFaultAbort=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HttpFaultAbort} HttpFaultAbort instance
                         */
                        HttpFaultAbort.create = function create(properties) {
                            return new HttpFaultAbort(properties);
                        };
    
                        /**
                         * Encodes the specified HttpFaultAbort message. Does not implicitly {@link google.cloud.compute.v1.HttpFaultAbort.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HttpFaultAbort
                         * @static
                         * @param {google.cloud.compute.v1.IHttpFaultAbort} message HttpFaultAbort message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpFaultAbort.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.percentage != null && Object.hasOwnProperty.call(message, "percentage"))
                                writer.uint32(/* id 151909018, wireType 1 =*/1215272145).double(message.percentage);
                            if (message.httpStatus != null && Object.hasOwnProperty.call(message, "httpStatus"))
                                writer.uint32(/* id 468949897, wireType 0 =*/3751599176).uint32(message.httpStatus);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HttpFaultAbort message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HttpFaultAbort.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HttpFaultAbort
                         * @static
                         * @param {google.cloud.compute.v1.IHttpFaultAbort} message HttpFaultAbort message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpFaultAbort.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HttpFaultAbort message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HttpFaultAbort
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HttpFaultAbort} HttpFaultAbort
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpFaultAbort.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HttpFaultAbort();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 468949897: {
                                        message.httpStatus = reader.uint32();
                                        break;
                                    }
                                case 151909018: {
                                        message.percentage = reader.double();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HttpFaultAbort message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HttpFaultAbort
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HttpFaultAbort} HttpFaultAbort
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpFaultAbort.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HttpFaultAbort message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HttpFaultAbort
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HttpFaultAbort.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.httpStatus != null && message.hasOwnProperty("httpStatus")) {
                                properties._httpStatus = 1;
                                if (!$util.isInteger(message.httpStatus))
                                    return "httpStatus: integer expected";
                            }
                            if (message.percentage != null && message.hasOwnProperty("percentage")) {
                                properties._percentage = 1;
                                if (typeof message.percentage !== "number")
                                    return "percentage: number expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HttpFaultAbort message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HttpFaultAbort
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HttpFaultAbort} HttpFaultAbort
                         */
                        HttpFaultAbort.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HttpFaultAbort)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HttpFaultAbort();
                            if (object.httpStatus != null)
                                message.httpStatus = object.httpStatus >>> 0;
                            if (object.percentage != null)
                                message.percentage = Number(object.percentage);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HttpFaultAbort message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HttpFaultAbort
                         * @static
                         * @param {google.cloud.compute.v1.HttpFaultAbort} message HttpFaultAbort
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HttpFaultAbort.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.percentage != null && message.hasOwnProperty("percentage")) {
                                object.percentage = options.json && !isFinite(message.percentage) ? String(message.percentage) : message.percentage;
                                if (options.oneofs)
                                    object._percentage = "percentage";
                            }
                            if (message.httpStatus != null && message.hasOwnProperty("httpStatus")) {
                                object.httpStatus = message.httpStatus;
                                if (options.oneofs)
                                    object._httpStatus = "httpStatus";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HttpFaultAbort to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HttpFaultAbort
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HttpFaultAbort.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HttpFaultAbort
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HttpFaultAbort
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HttpFaultAbort.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HttpFaultAbort";
                        };
    
                        return HttpFaultAbort;
                    })();
    
                    v1.HttpFaultDelay = (function() {
    
                        /**
                         * Properties of a HttpFaultDelay.
                         * @memberof google.cloud.compute.v1
                         * @interface IHttpFaultDelay
                         * @property {google.cloud.compute.v1.IDuration|null} [fixedDelay] HttpFaultDelay fixedDelay
                         * @property {number|null} [percentage] HttpFaultDelay percentage
                         */
    
                        /**
                         * Constructs a new HttpFaultDelay.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HttpFaultDelay.
                         * @implements IHttpFaultDelay
                         * @constructor
                         * @param {google.cloud.compute.v1.IHttpFaultDelay=} [properties] Properties to set
                         */
                        function HttpFaultDelay(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HttpFaultDelay fixedDelay.
                         * @member {google.cloud.compute.v1.IDuration|null|undefined} fixedDelay
                         * @memberof google.cloud.compute.v1.HttpFaultDelay
                         * @instance
                         */
                        HttpFaultDelay.prototype.fixedDelay = null;
    
                        /**
                         * HttpFaultDelay percentage.
                         * @member {number|null|undefined} percentage
                         * @memberof google.cloud.compute.v1.HttpFaultDelay
                         * @instance
                         */
                        HttpFaultDelay.prototype.percentage = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HttpFaultDelay _fixedDelay.
                         * @member {"fixedDelay"|undefined} _fixedDelay
                         * @memberof google.cloud.compute.v1.HttpFaultDelay
                         * @instance
                         */
                        Object.defineProperty(HttpFaultDelay.prototype, "_fixedDelay", {
                            get: $util.oneOfGetter($oneOfFields = ["fixedDelay"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpFaultDelay _percentage.
                         * @member {"percentage"|undefined} _percentage
                         * @memberof google.cloud.compute.v1.HttpFaultDelay
                         * @instance
                         */
                        Object.defineProperty(HttpFaultDelay.prototype, "_percentage", {
                            get: $util.oneOfGetter($oneOfFields = ["percentage"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HttpFaultDelay instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HttpFaultDelay
                         * @static
                         * @param {google.cloud.compute.v1.IHttpFaultDelay=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HttpFaultDelay} HttpFaultDelay instance
                         */
                        HttpFaultDelay.create = function create(properties) {
                            return new HttpFaultDelay(properties);
                        };
    
                        /**
                         * Encodes the specified HttpFaultDelay message. Does not implicitly {@link google.cloud.compute.v1.HttpFaultDelay.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HttpFaultDelay
                         * @static
                         * @param {google.cloud.compute.v1.IHttpFaultDelay} message HttpFaultDelay message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpFaultDelay.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.percentage != null && Object.hasOwnProperty.call(message, "percentage"))
                                writer.uint32(/* id 151909018, wireType 1 =*/1215272145).double(message.percentage);
                            if (message.fixedDelay != null && Object.hasOwnProperty.call(message, "fixedDelay"))
                                $root.google.cloud.compute.v1.Duration.encode(message.fixedDelay, writer.uint32(/* id 317037816, wireType 2 =*/2536302530).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HttpFaultDelay message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HttpFaultDelay.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HttpFaultDelay
                         * @static
                         * @param {google.cloud.compute.v1.IHttpFaultDelay} message HttpFaultDelay message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpFaultDelay.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HttpFaultDelay message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HttpFaultDelay
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HttpFaultDelay} HttpFaultDelay
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpFaultDelay.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HttpFaultDelay();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 317037816: {
                                        message.fixedDelay = $root.google.cloud.compute.v1.Duration.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 151909018: {
                                        message.percentage = reader.double();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HttpFaultDelay message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HttpFaultDelay
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HttpFaultDelay} HttpFaultDelay
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpFaultDelay.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HttpFaultDelay message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HttpFaultDelay
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HttpFaultDelay.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.fixedDelay != null && message.hasOwnProperty("fixedDelay")) {
                                properties._fixedDelay = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Duration.verify(message.fixedDelay);
                                    if (error)
                                        return "fixedDelay." + error;
                                }
                            }
                            if (message.percentage != null && message.hasOwnProperty("percentage")) {
                                properties._percentage = 1;
                                if (typeof message.percentage !== "number")
                                    return "percentage: number expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HttpFaultDelay message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HttpFaultDelay
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HttpFaultDelay} HttpFaultDelay
                         */
                        HttpFaultDelay.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HttpFaultDelay)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HttpFaultDelay();
                            if (object.fixedDelay != null) {
                                if (typeof object.fixedDelay !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HttpFaultDelay.fixedDelay: object expected");
                                message.fixedDelay = $root.google.cloud.compute.v1.Duration.fromObject(object.fixedDelay);
                            }
                            if (object.percentage != null)
                                message.percentage = Number(object.percentage);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HttpFaultDelay message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HttpFaultDelay
                         * @static
                         * @param {google.cloud.compute.v1.HttpFaultDelay} message HttpFaultDelay
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HttpFaultDelay.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.percentage != null && message.hasOwnProperty("percentage")) {
                                object.percentage = options.json && !isFinite(message.percentage) ? String(message.percentage) : message.percentage;
                                if (options.oneofs)
                                    object._percentage = "percentage";
                            }
                            if (message.fixedDelay != null && message.hasOwnProperty("fixedDelay")) {
                                object.fixedDelay = $root.google.cloud.compute.v1.Duration.toObject(message.fixedDelay, options);
                                if (options.oneofs)
                                    object._fixedDelay = "fixedDelay";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HttpFaultDelay to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HttpFaultDelay
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HttpFaultDelay.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HttpFaultDelay
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HttpFaultDelay
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HttpFaultDelay.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HttpFaultDelay";
                        };
    
                        return HttpFaultDelay;
                    })();
    
                    v1.HttpFaultInjection = (function() {
    
                        /**
                         * Properties of a HttpFaultInjection.
                         * @memberof google.cloud.compute.v1
                         * @interface IHttpFaultInjection
                         * @property {google.cloud.compute.v1.IHttpFaultAbort|null} [abort] HttpFaultInjection abort
                         * @property {google.cloud.compute.v1.IHttpFaultDelay|null} [delay] HttpFaultInjection delay
                         */
    
                        /**
                         * Constructs a new HttpFaultInjection.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HttpFaultInjection.
                         * @implements IHttpFaultInjection
                         * @constructor
                         * @param {google.cloud.compute.v1.IHttpFaultInjection=} [properties] Properties to set
                         */
                        function HttpFaultInjection(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HttpFaultInjection abort.
                         * @member {google.cloud.compute.v1.IHttpFaultAbort|null|undefined} abort
                         * @memberof google.cloud.compute.v1.HttpFaultInjection
                         * @instance
                         */
                        HttpFaultInjection.prototype.abort = null;
    
                        /**
                         * HttpFaultInjection delay.
                         * @member {google.cloud.compute.v1.IHttpFaultDelay|null|undefined} delay
                         * @memberof google.cloud.compute.v1.HttpFaultInjection
                         * @instance
                         */
                        HttpFaultInjection.prototype.delay = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HttpFaultInjection _abort.
                         * @member {"abort"|undefined} _abort
                         * @memberof google.cloud.compute.v1.HttpFaultInjection
                         * @instance
                         */
                        Object.defineProperty(HttpFaultInjection.prototype, "_abort", {
                            get: $util.oneOfGetter($oneOfFields = ["abort"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpFaultInjection _delay.
                         * @member {"delay"|undefined} _delay
                         * @memberof google.cloud.compute.v1.HttpFaultInjection
                         * @instance
                         */
                        Object.defineProperty(HttpFaultInjection.prototype, "_delay", {
                            get: $util.oneOfGetter($oneOfFields = ["delay"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HttpFaultInjection instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HttpFaultInjection
                         * @static
                         * @param {google.cloud.compute.v1.IHttpFaultInjection=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HttpFaultInjection} HttpFaultInjection instance
                         */
                        HttpFaultInjection.create = function create(properties) {
                            return new HttpFaultInjection(properties);
                        };
    
                        /**
                         * Encodes the specified HttpFaultInjection message. Does not implicitly {@link google.cloud.compute.v1.HttpFaultInjection.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HttpFaultInjection
                         * @static
                         * @param {google.cloud.compute.v1.IHttpFaultInjection} message HttpFaultInjection message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpFaultInjection.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.abort != null && Object.hasOwnProperty.call(message, "abort"))
                                $root.google.cloud.compute.v1.HttpFaultAbort.encode(message.abort, writer.uint32(/* id 92611376, wireType 2 =*/740891010).fork()).ldelim();
                            if (message.delay != null && Object.hasOwnProperty.call(message, "delay"))
                                $root.google.cloud.compute.v1.HttpFaultDelay.encode(message.delay, writer.uint32(/* id 95467907, wireType 2 =*/763743258).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HttpFaultInjection message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HttpFaultInjection.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HttpFaultInjection
                         * @static
                         * @param {google.cloud.compute.v1.IHttpFaultInjection} message HttpFaultInjection message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpFaultInjection.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HttpFaultInjection message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HttpFaultInjection
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HttpFaultInjection} HttpFaultInjection
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpFaultInjection.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HttpFaultInjection();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 92611376: {
                                        message.abort = $root.google.cloud.compute.v1.HttpFaultAbort.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 95467907: {
                                        message.delay = $root.google.cloud.compute.v1.HttpFaultDelay.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HttpFaultInjection message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HttpFaultInjection
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HttpFaultInjection} HttpFaultInjection
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpFaultInjection.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HttpFaultInjection message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HttpFaultInjection
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HttpFaultInjection.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.abort != null && message.hasOwnProperty("abort")) {
                                properties._abort = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HttpFaultAbort.verify(message.abort);
                                    if (error)
                                        return "abort." + error;
                                }
                            }
                            if (message.delay != null && message.hasOwnProperty("delay")) {
                                properties._delay = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HttpFaultDelay.verify(message.delay);
                                    if (error)
                                        return "delay." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HttpFaultInjection message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HttpFaultInjection
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HttpFaultInjection} HttpFaultInjection
                         */
                        HttpFaultInjection.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HttpFaultInjection)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HttpFaultInjection();
                            if (object.abort != null) {
                                if (typeof object.abort !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HttpFaultInjection.abort: object expected");
                                message.abort = $root.google.cloud.compute.v1.HttpFaultAbort.fromObject(object.abort);
                            }
                            if (object.delay != null) {
                                if (typeof object.delay !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HttpFaultInjection.delay: object expected");
                                message.delay = $root.google.cloud.compute.v1.HttpFaultDelay.fromObject(object.delay);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HttpFaultInjection message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HttpFaultInjection
                         * @static
                         * @param {google.cloud.compute.v1.HttpFaultInjection} message HttpFaultInjection
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HttpFaultInjection.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.abort != null && message.hasOwnProperty("abort")) {
                                object.abort = $root.google.cloud.compute.v1.HttpFaultAbort.toObject(message.abort, options);
                                if (options.oneofs)
                                    object._abort = "abort";
                            }
                            if (message.delay != null && message.hasOwnProperty("delay")) {
                                object.delay = $root.google.cloud.compute.v1.HttpFaultDelay.toObject(message.delay, options);
                                if (options.oneofs)
                                    object._delay = "delay";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HttpFaultInjection to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HttpFaultInjection
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HttpFaultInjection.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HttpFaultInjection
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HttpFaultInjection
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HttpFaultInjection.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HttpFaultInjection";
                        };
    
                        return HttpFaultInjection;
                    })();
    
                    v1.HttpHeaderAction = (function() {
    
                        /**
                         * Properties of a HttpHeaderAction.
                         * @memberof google.cloud.compute.v1
                         * @interface IHttpHeaderAction
                         * @property {Array.<google.cloud.compute.v1.IHttpHeaderOption>|null} [requestHeadersToAdd] HttpHeaderAction requestHeadersToAdd
                         * @property {Array.<string>|null} [requestHeadersToRemove] HttpHeaderAction requestHeadersToRemove
                         * @property {Array.<google.cloud.compute.v1.IHttpHeaderOption>|null} [responseHeadersToAdd] HttpHeaderAction responseHeadersToAdd
                         * @property {Array.<string>|null} [responseHeadersToRemove] HttpHeaderAction responseHeadersToRemove
                         */
    
                        /**
                         * Constructs a new HttpHeaderAction.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HttpHeaderAction.
                         * @implements IHttpHeaderAction
                         * @constructor
                         * @param {google.cloud.compute.v1.IHttpHeaderAction=} [properties] Properties to set
                         */
                        function HttpHeaderAction(properties) {
                            this.requestHeadersToAdd = [];
                            this.requestHeadersToRemove = [];
                            this.responseHeadersToAdd = [];
                            this.responseHeadersToRemove = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HttpHeaderAction requestHeadersToAdd.
                         * @member {Array.<google.cloud.compute.v1.IHttpHeaderOption>} requestHeadersToAdd
                         * @memberof google.cloud.compute.v1.HttpHeaderAction
                         * @instance
                         */
                        HttpHeaderAction.prototype.requestHeadersToAdd = $util.emptyArray;
    
                        /**
                         * HttpHeaderAction requestHeadersToRemove.
                         * @member {Array.<string>} requestHeadersToRemove
                         * @memberof google.cloud.compute.v1.HttpHeaderAction
                         * @instance
                         */
                        HttpHeaderAction.prototype.requestHeadersToRemove = $util.emptyArray;
    
                        /**
                         * HttpHeaderAction responseHeadersToAdd.
                         * @member {Array.<google.cloud.compute.v1.IHttpHeaderOption>} responseHeadersToAdd
                         * @memberof google.cloud.compute.v1.HttpHeaderAction
                         * @instance
                         */
                        HttpHeaderAction.prototype.responseHeadersToAdd = $util.emptyArray;
    
                        /**
                         * HttpHeaderAction responseHeadersToRemove.
                         * @member {Array.<string>} responseHeadersToRemove
                         * @memberof google.cloud.compute.v1.HttpHeaderAction
                         * @instance
                         */
                        HttpHeaderAction.prototype.responseHeadersToRemove = $util.emptyArray;
    
                        /**
                         * Creates a new HttpHeaderAction instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HttpHeaderAction
                         * @static
                         * @param {google.cloud.compute.v1.IHttpHeaderAction=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HttpHeaderAction} HttpHeaderAction instance
                         */
                        HttpHeaderAction.create = function create(properties) {
                            return new HttpHeaderAction(properties);
                        };
    
                        /**
                         * Encodes the specified HttpHeaderAction message. Does not implicitly {@link google.cloud.compute.v1.HttpHeaderAction.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HttpHeaderAction
                         * @static
                         * @param {google.cloud.compute.v1.IHttpHeaderAction} message HttpHeaderAction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpHeaderAction.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.responseHeadersToAdd != null && message.responseHeadersToAdd.length)
                                for (var i = 0; i < message.responseHeadersToAdd.length; ++i)
                                    $root.google.cloud.compute.v1.HttpHeaderOption.encode(message.responseHeadersToAdd[i], writer.uint32(/* id 32136052, wireType 2 =*/257088418).fork()).ldelim();
                            if (message.requestHeadersToAdd != null && message.requestHeadersToAdd.length)
                                for (var i = 0; i < message.requestHeadersToAdd.length; ++i)
                                    $root.google.cloud.compute.v1.HttpHeaderOption.encode(message.requestHeadersToAdd[i], writer.uint32(/* id 72111974, wireType 2 =*/576895794).fork()).ldelim();
                            if (message.responseHeadersToRemove != null && message.responseHeadersToRemove.length)
                                for (var i = 0; i < message.responseHeadersToRemove.length; ++i)
                                    writer.uint32(/* id 75415761, wireType 2 =*/603326090).string(message.responseHeadersToRemove[i]);
                            if (message.requestHeadersToRemove != null && message.requestHeadersToRemove.length)
                                for (var i = 0; i < message.requestHeadersToRemove.length; ++i)
                                    writer.uint32(/* id 218425247, wireType 2 =*/1747401978).string(message.requestHeadersToRemove[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HttpHeaderAction message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HttpHeaderAction.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HttpHeaderAction
                         * @static
                         * @param {google.cloud.compute.v1.IHttpHeaderAction} message HttpHeaderAction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpHeaderAction.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HttpHeaderAction message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HttpHeaderAction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HttpHeaderAction} HttpHeaderAction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpHeaderAction.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HttpHeaderAction();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 72111974: {
                                        if (!(message.requestHeadersToAdd && message.requestHeadersToAdd.length))
                                            message.requestHeadersToAdd = [];
                                        message.requestHeadersToAdd.push($root.google.cloud.compute.v1.HttpHeaderOption.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 218425247: {
                                        if (!(message.requestHeadersToRemove && message.requestHeadersToRemove.length))
                                            message.requestHeadersToRemove = [];
                                        message.requestHeadersToRemove.push(reader.string());
                                        break;
                                    }
                                case 32136052: {
                                        if (!(message.responseHeadersToAdd && message.responseHeadersToAdd.length))
                                            message.responseHeadersToAdd = [];
                                        message.responseHeadersToAdd.push($root.google.cloud.compute.v1.HttpHeaderOption.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 75415761: {
                                        if (!(message.responseHeadersToRemove && message.responseHeadersToRemove.length))
                                            message.responseHeadersToRemove = [];
                                        message.responseHeadersToRemove.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HttpHeaderAction message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HttpHeaderAction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HttpHeaderAction} HttpHeaderAction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpHeaderAction.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HttpHeaderAction message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HttpHeaderAction
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HttpHeaderAction.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.requestHeadersToAdd != null && message.hasOwnProperty("requestHeadersToAdd")) {
                                if (!Array.isArray(message.requestHeadersToAdd))
                                    return "requestHeadersToAdd: array expected";
                                for (var i = 0; i < message.requestHeadersToAdd.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.HttpHeaderOption.verify(message.requestHeadersToAdd[i]);
                                    if (error)
                                        return "requestHeadersToAdd." + error;
                                }
                            }
                            if (message.requestHeadersToRemove != null && message.hasOwnProperty("requestHeadersToRemove")) {
                                if (!Array.isArray(message.requestHeadersToRemove))
                                    return "requestHeadersToRemove: array expected";
                                for (var i = 0; i < message.requestHeadersToRemove.length; ++i)
                                    if (!$util.isString(message.requestHeadersToRemove[i]))
                                        return "requestHeadersToRemove: string[] expected";
                            }
                            if (message.responseHeadersToAdd != null && message.hasOwnProperty("responseHeadersToAdd")) {
                                if (!Array.isArray(message.responseHeadersToAdd))
                                    return "responseHeadersToAdd: array expected";
                                for (var i = 0; i < message.responseHeadersToAdd.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.HttpHeaderOption.verify(message.responseHeadersToAdd[i]);
                                    if (error)
                                        return "responseHeadersToAdd." + error;
                                }
                            }
                            if (message.responseHeadersToRemove != null && message.hasOwnProperty("responseHeadersToRemove")) {
                                if (!Array.isArray(message.responseHeadersToRemove))
                                    return "responseHeadersToRemove: array expected";
                                for (var i = 0; i < message.responseHeadersToRemove.length; ++i)
                                    if (!$util.isString(message.responseHeadersToRemove[i]))
                                        return "responseHeadersToRemove: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HttpHeaderAction message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HttpHeaderAction
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HttpHeaderAction} HttpHeaderAction
                         */
                        HttpHeaderAction.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HttpHeaderAction)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HttpHeaderAction();
                            if (object.requestHeadersToAdd) {
                                if (!Array.isArray(object.requestHeadersToAdd))
                                    throw TypeError(".google.cloud.compute.v1.HttpHeaderAction.requestHeadersToAdd: array expected");
                                message.requestHeadersToAdd = [];
                                for (var i = 0; i < object.requestHeadersToAdd.length; ++i) {
                                    if (typeof object.requestHeadersToAdd[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.HttpHeaderAction.requestHeadersToAdd: object expected");
                                    message.requestHeadersToAdd[i] = $root.google.cloud.compute.v1.HttpHeaderOption.fromObject(object.requestHeadersToAdd[i]);
                                }
                            }
                            if (object.requestHeadersToRemove) {
                                if (!Array.isArray(object.requestHeadersToRemove))
                                    throw TypeError(".google.cloud.compute.v1.HttpHeaderAction.requestHeadersToRemove: array expected");
                                message.requestHeadersToRemove = [];
                                for (var i = 0; i < object.requestHeadersToRemove.length; ++i)
                                    message.requestHeadersToRemove[i] = String(object.requestHeadersToRemove[i]);
                            }
                            if (object.responseHeadersToAdd) {
                                if (!Array.isArray(object.responseHeadersToAdd))
                                    throw TypeError(".google.cloud.compute.v1.HttpHeaderAction.responseHeadersToAdd: array expected");
                                message.responseHeadersToAdd = [];
                                for (var i = 0; i < object.responseHeadersToAdd.length; ++i) {
                                    if (typeof object.responseHeadersToAdd[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.HttpHeaderAction.responseHeadersToAdd: object expected");
                                    message.responseHeadersToAdd[i] = $root.google.cloud.compute.v1.HttpHeaderOption.fromObject(object.responseHeadersToAdd[i]);
                                }
                            }
                            if (object.responseHeadersToRemove) {
                                if (!Array.isArray(object.responseHeadersToRemove))
                                    throw TypeError(".google.cloud.compute.v1.HttpHeaderAction.responseHeadersToRemove: array expected");
                                message.responseHeadersToRemove = [];
                                for (var i = 0; i < object.responseHeadersToRemove.length; ++i)
                                    message.responseHeadersToRemove[i] = String(object.responseHeadersToRemove[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HttpHeaderAction message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HttpHeaderAction
                         * @static
                         * @param {google.cloud.compute.v1.HttpHeaderAction} message HttpHeaderAction
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HttpHeaderAction.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.responseHeadersToAdd = [];
                                object.requestHeadersToAdd = [];
                                object.responseHeadersToRemove = [];
                                object.requestHeadersToRemove = [];
                            }
                            if (message.responseHeadersToAdd && message.responseHeadersToAdd.length) {
                                object.responseHeadersToAdd = [];
                                for (var j = 0; j < message.responseHeadersToAdd.length; ++j)
                                    object.responseHeadersToAdd[j] = $root.google.cloud.compute.v1.HttpHeaderOption.toObject(message.responseHeadersToAdd[j], options);
                            }
                            if (message.requestHeadersToAdd && message.requestHeadersToAdd.length) {
                                object.requestHeadersToAdd = [];
                                for (var j = 0; j < message.requestHeadersToAdd.length; ++j)
                                    object.requestHeadersToAdd[j] = $root.google.cloud.compute.v1.HttpHeaderOption.toObject(message.requestHeadersToAdd[j], options);
                            }
                            if (message.responseHeadersToRemove && message.responseHeadersToRemove.length) {
                                object.responseHeadersToRemove = [];
                                for (var j = 0; j < message.responseHeadersToRemove.length; ++j)
                                    object.responseHeadersToRemove[j] = message.responseHeadersToRemove[j];
                            }
                            if (message.requestHeadersToRemove && message.requestHeadersToRemove.length) {
                                object.requestHeadersToRemove = [];
                                for (var j = 0; j < message.requestHeadersToRemove.length; ++j)
                                    object.requestHeadersToRemove[j] = message.requestHeadersToRemove[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HttpHeaderAction to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HttpHeaderAction
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HttpHeaderAction.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HttpHeaderAction
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HttpHeaderAction
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HttpHeaderAction.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HttpHeaderAction";
                        };
    
                        return HttpHeaderAction;
                    })();
    
                    v1.HttpHeaderMatch = (function() {
    
                        /**
                         * Properties of a HttpHeaderMatch.
                         * @memberof google.cloud.compute.v1
                         * @interface IHttpHeaderMatch
                         * @property {string|null} [exactMatch] HttpHeaderMatch exactMatch
                         * @property {string|null} [headerName] HttpHeaderMatch headerName
                         * @property {boolean|null} [invertMatch] HttpHeaderMatch invertMatch
                         * @property {string|null} [prefixMatch] HttpHeaderMatch prefixMatch
                         * @property {boolean|null} [presentMatch] HttpHeaderMatch presentMatch
                         * @property {google.cloud.compute.v1.IInt64RangeMatch|null} [rangeMatch] HttpHeaderMatch rangeMatch
                         * @property {string|null} [regexMatch] HttpHeaderMatch regexMatch
                         * @property {string|null} [suffixMatch] HttpHeaderMatch suffixMatch
                         */
    
                        /**
                         * Constructs a new HttpHeaderMatch.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HttpHeaderMatch.
                         * @implements IHttpHeaderMatch
                         * @constructor
                         * @param {google.cloud.compute.v1.IHttpHeaderMatch=} [properties] Properties to set
                         */
                        function HttpHeaderMatch(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HttpHeaderMatch exactMatch.
                         * @member {string|null|undefined} exactMatch
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @instance
                         */
                        HttpHeaderMatch.prototype.exactMatch = null;
    
                        /**
                         * HttpHeaderMatch headerName.
                         * @member {string|null|undefined} headerName
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @instance
                         */
                        HttpHeaderMatch.prototype.headerName = null;
    
                        /**
                         * HttpHeaderMatch invertMatch.
                         * @member {boolean|null|undefined} invertMatch
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @instance
                         */
                        HttpHeaderMatch.prototype.invertMatch = null;
    
                        /**
                         * HttpHeaderMatch prefixMatch.
                         * @member {string|null|undefined} prefixMatch
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @instance
                         */
                        HttpHeaderMatch.prototype.prefixMatch = null;
    
                        /**
                         * HttpHeaderMatch presentMatch.
                         * @member {boolean|null|undefined} presentMatch
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @instance
                         */
                        HttpHeaderMatch.prototype.presentMatch = null;
    
                        /**
                         * HttpHeaderMatch rangeMatch.
                         * @member {google.cloud.compute.v1.IInt64RangeMatch|null|undefined} rangeMatch
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @instance
                         */
                        HttpHeaderMatch.prototype.rangeMatch = null;
    
                        /**
                         * HttpHeaderMatch regexMatch.
                         * @member {string|null|undefined} regexMatch
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @instance
                         */
                        HttpHeaderMatch.prototype.regexMatch = null;
    
                        /**
                         * HttpHeaderMatch suffixMatch.
                         * @member {string|null|undefined} suffixMatch
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @instance
                         */
                        HttpHeaderMatch.prototype.suffixMatch = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HttpHeaderMatch _exactMatch.
                         * @member {"exactMatch"|undefined} _exactMatch
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @instance
                         */
                        Object.defineProperty(HttpHeaderMatch.prototype, "_exactMatch", {
                            get: $util.oneOfGetter($oneOfFields = ["exactMatch"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpHeaderMatch _headerName.
                         * @member {"headerName"|undefined} _headerName
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @instance
                         */
                        Object.defineProperty(HttpHeaderMatch.prototype, "_headerName", {
                            get: $util.oneOfGetter($oneOfFields = ["headerName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpHeaderMatch _invertMatch.
                         * @member {"invertMatch"|undefined} _invertMatch
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @instance
                         */
                        Object.defineProperty(HttpHeaderMatch.prototype, "_invertMatch", {
                            get: $util.oneOfGetter($oneOfFields = ["invertMatch"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpHeaderMatch _prefixMatch.
                         * @member {"prefixMatch"|undefined} _prefixMatch
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @instance
                         */
                        Object.defineProperty(HttpHeaderMatch.prototype, "_prefixMatch", {
                            get: $util.oneOfGetter($oneOfFields = ["prefixMatch"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpHeaderMatch _presentMatch.
                         * @member {"presentMatch"|undefined} _presentMatch
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @instance
                         */
                        Object.defineProperty(HttpHeaderMatch.prototype, "_presentMatch", {
                            get: $util.oneOfGetter($oneOfFields = ["presentMatch"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpHeaderMatch _rangeMatch.
                         * @member {"rangeMatch"|undefined} _rangeMatch
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @instance
                         */
                        Object.defineProperty(HttpHeaderMatch.prototype, "_rangeMatch", {
                            get: $util.oneOfGetter($oneOfFields = ["rangeMatch"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpHeaderMatch _regexMatch.
                         * @member {"regexMatch"|undefined} _regexMatch
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @instance
                         */
                        Object.defineProperty(HttpHeaderMatch.prototype, "_regexMatch", {
                            get: $util.oneOfGetter($oneOfFields = ["regexMatch"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpHeaderMatch _suffixMatch.
                         * @member {"suffixMatch"|undefined} _suffixMatch
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @instance
                         */
                        Object.defineProperty(HttpHeaderMatch.prototype, "_suffixMatch", {
                            get: $util.oneOfGetter($oneOfFields = ["suffixMatch"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HttpHeaderMatch instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @static
                         * @param {google.cloud.compute.v1.IHttpHeaderMatch=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HttpHeaderMatch} HttpHeaderMatch instance
                         */
                        HttpHeaderMatch.create = function create(properties) {
                            return new HttpHeaderMatch(properties);
                        };
    
                        /**
                         * Encodes the specified HttpHeaderMatch message. Does not implicitly {@link google.cloud.compute.v1.HttpHeaderMatch.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @static
                         * @param {google.cloud.compute.v1.IHttpHeaderMatch} message HttpHeaderMatch message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpHeaderMatch.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.presentMatch != null && Object.hasOwnProperty.call(message, "presentMatch"))
                                writer.uint32(/* id 67435841, wireType 0 =*/539486728).bool(message.presentMatch);
                            if (message.rangeMatch != null && Object.hasOwnProperty.call(message, "rangeMatch"))
                                $root.google.cloud.compute.v1.Int64RangeMatch.encode(message.rangeMatch, writer.uint32(/* id 97244227, wireType 2 =*/777953818).fork()).ldelim();
                            if (message.regexMatch != null && Object.hasOwnProperty.call(message, "regexMatch"))
                                writer.uint32(/* id 107387853, wireType 2 =*/859102826).string(message.regexMatch);
                            if (message.headerName != null && Object.hasOwnProperty.call(message, "headerName"))
                                writer.uint32(/* id 110223613, wireType 2 =*/881788906).string(message.headerName);
                            if (message.prefixMatch != null && Object.hasOwnProperty.call(message, "prefixMatch"))
                                writer.uint32(/* id 257898968, wireType 2 =*/2063191746).string(message.prefixMatch);
                            if (message.suffixMatch != null && Object.hasOwnProperty.call(message, "suffixMatch"))
                                writer.uint32(/* id 426488663, wireType 2 =*/3411909306).string(message.suffixMatch);
                            if (message.exactMatch != null && Object.hasOwnProperty.call(message, "exactMatch"))
                                writer.uint32(/* id 457641093, wireType 2 =*/3661128746).string(message.exactMatch);
                            if (message.invertMatch != null && Object.hasOwnProperty.call(message, "invertMatch"))
                                writer.uint32(/* id 501130268, wireType 0 =*/4009042144).bool(message.invertMatch);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HttpHeaderMatch message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HttpHeaderMatch.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @static
                         * @param {google.cloud.compute.v1.IHttpHeaderMatch} message HttpHeaderMatch message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpHeaderMatch.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HttpHeaderMatch message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HttpHeaderMatch} HttpHeaderMatch
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpHeaderMatch.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HttpHeaderMatch();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 457641093: {
                                        message.exactMatch = reader.string();
                                        break;
                                    }
                                case 110223613: {
                                        message.headerName = reader.string();
                                        break;
                                    }
                                case 501130268: {
                                        message.invertMatch = reader.bool();
                                        break;
                                    }
                                case 257898968: {
                                        message.prefixMatch = reader.string();
                                        break;
                                    }
                                case 67435841: {
                                        message.presentMatch = reader.bool();
                                        break;
                                    }
                                case 97244227: {
                                        message.rangeMatch = $root.google.cloud.compute.v1.Int64RangeMatch.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 107387853: {
                                        message.regexMatch = reader.string();
                                        break;
                                    }
                                case 426488663: {
                                        message.suffixMatch = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HttpHeaderMatch message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HttpHeaderMatch} HttpHeaderMatch
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpHeaderMatch.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HttpHeaderMatch message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HttpHeaderMatch.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.exactMatch != null && message.hasOwnProperty("exactMatch")) {
                                properties._exactMatch = 1;
                                if (!$util.isString(message.exactMatch))
                                    return "exactMatch: string expected";
                            }
                            if (message.headerName != null && message.hasOwnProperty("headerName")) {
                                properties._headerName = 1;
                                if (!$util.isString(message.headerName))
                                    return "headerName: string expected";
                            }
                            if (message.invertMatch != null && message.hasOwnProperty("invertMatch")) {
                                properties._invertMatch = 1;
                                if (typeof message.invertMatch !== "boolean")
                                    return "invertMatch: boolean expected";
                            }
                            if (message.prefixMatch != null && message.hasOwnProperty("prefixMatch")) {
                                properties._prefixMatch = 1;
                                if (!$util.isString(message.prefixMatch))
                                    return "prefixMatch: string expected";
                            }
                            if (message.presentMatch != null && message.hasOwnProperty("presentMatch")) {
                                properties._presentMatch = 1;
                                if (typeof message.presentMatch !== "boolean")
                                    return "presentMatch: boolean expected";
                            }
                            if (message.rangeMatch != null && message.hasOwnProperty("rangeMatch")) {
                                properties._rangeMatch = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Int64RangeMatch.verify(message.rangeMatch);
                                    if (error)
                                        return "rangeMatch." + error;
                                }
                            }
                            if (message.regexMatch != null && message.hasOwnProperty("regexMatch")) {
                                properties._regexMatch = 1;
                                if (!$util.isString(message.regexMatch))
                                    return "regexMatch: string expected";
                            }
                            if (message.suffixMatch != null && message.hasOwnProperty("suffixMatch")) {
                                properties._suffixMatch = 1;
                                if (!$util.isString(message.suffixMatch))
                                    return "suffixMatch: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HttpHeaderMatch message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HttpHeaderMatch} HttpHeaderMatch
                         */
                        HttpHeaderMatch.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HttpHeaderMatch)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HttpHeaderMatch();
                            if (object.exactMatch != null)
                                message.exactMatch = String(object.exactMatch);
                            if (object.headerName != null)
                                message.headerName = String(object.headerName);
                            if (object.invertMatch != null)
                                message.invertMatch = Boolean(object.invertMatch);
                            if (object.prefixMatch != null)
                                message.prefixMatch = String(object.prefixMatch);
                            if (object.presentMatch != null)
                                message.presentMatch = Boolean(object.presentMatch);
                            if (object.rangeMatch != null) {
                                if (typeof object.rangeMatch !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HttpHeaderMatch.rangeMatch: object expected");
                                message.rangeMatch = $root.google.cloud.compute.v1.Int64RangeMatch.fromObject(object.rangeMatch);
                            }
                            if (object.regexMatch != null)
                                message.regexMatch = String(object.regexMatch);
                            if (object.suffixMatch != null)
                                message.suffixMatch = String(object.suffixMatch);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HttpHeaderMatch message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @static
                         * @param {google.cloud.compute.v1.HttpHeaderMatch} message HttpHeaderMatch
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HttpHeaderMatch.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.presentMatch != null && message.hasOwnProperty("presentMatch")) {
                                object.presentMatch = message.presentMatch;
                                if (options.oneofs)
                                    object._presentMatch = "presentMatch";
                            }
                            if (message.rangeMatch != null && message.hasOwnProperty("rangeMatch")) {
                                object.rangeMatch = $root.google.cloud.compute.v1.Int64RangeMatch.toObject(message.rangeMatch, options);
                                if (options.oneofs)
                                    object._rangeMatch = "rangeMatch";
                            }
                            if (message.regexMatch != null && message.hasOwnProperty("regexMatch")) {
                                object.regexMatch = message.regexMatch;
                                if (options.oneofs)
                                    object._regexMatch = "regexMatch";
                            }
                            if (message.headerName != null && message.hasOwnProperty("headerName")) {
                                object.headerName = message.headerName;
                                if (options.oneofs)
                                    object._headerName = "headerName";
                            }
                            if (message.prefixMatch != null && message.hasOwnProperty("prefixMatch")) {
                                object.prefixMatch = message.prefixMatch;
                                if (options.oneofs)
                                    object._prefixMatch = "prefixMatch";
                            }
                            if (message.suffixMatch != null && message.hasOwnProperty("suffixMatch")) {
                                object.suffixMatch = message.suffixMatch;
                                if (options.oneofs)
                                    object._suffixMatch = "suffixMatch";
                            }
                            if (message.exactMatch != null && message.hasOwnProperty("exactMatch")) {
                                object.exactMatch = message.exactMatch;
                                if (options.oneofs)
                                    object._exactMatch = "exactMatch";
                            }
                            if (message.invertMatch != null && message.hasOwnProperty("invertMatch")) {
                                object.invertMatch = message.invertMatch;
                                if (options.oneofs)
                                    object._invertMatch = "invertMatch";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HttpHeaderMatch to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HttpHeaderMatch.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HttpHeaderMatch
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HttpHeaderMatch
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HttpHeaderMatch.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HttpHeaderMatch";
                        };
    
                        return HttpHeaderMatch;
                    })();
    
                    v1.HttpHeaderOption = (function() {
    
                        /**
                         * Properties of a HttpHeaderOption.
                         * @memberof google.cloud.compute.v1
                         * @interface IHttpHeaderOption
                         * @property {string|null} [headerName] HttpHeaderOption headerName
                         * @property {string|null} [headerValue] HttpHeaderOption headerValue
                         * @property {boolean|null} [replace] HttpHeaderOption replace
                         */
    
                        /**
                         * Constructs a new HttpHeaderOption.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HttpHeaderOption.
                         * @implements IHttpHeaderOption
                         * @constructor
                         * @param {google.cloud.compute.v1.IHttpHeaderOption=} [properties] Properties to set
                         */
                        function HttpHeaderOption(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HttpHeaderOption headerName.
                         * @member {string|null|undefined} headerName
                         * @memberof google.cloud.compute.v1.HttpHeaderOption
                         * @instance
                         */
                        HttpHeaderOption.prototype.headerName = null;
    
                        /**
                         * HttpHeaderOption headerValue.
                         * @member {string|null|undefined} headerValue
                         * @memberof google.cloud.compute.v1.HttpHeaderOption
                         * @instance
                         */
                        HttpHeaderOption.prototype.headerValue = null;
    
                        /**
                         * HttpHeaderOption replace.
                         * @member {boolean|null|undefined} replace
                         * @memberof google.cloud.compute.v1.HttpHeaderOption
                         * @instance
                         */
                        HttpHeaderOption.prototype.replace = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HttpHeaderOption _headerName.
                         * @member {"headerName"|undefined} _headerName
                         * @memberof google.cloud.compute.v1.HttpHeaderOption
                         * @instance
                         */
                        Object.defineProperty(HttpHeaderOption.prototype, "_headerName", {
                            get: $util.oneOfGetter($oneOfFields = ["headerName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpHeaderOption _headerValue.
                         * @member {"headerValue"|undefined} _headerValue
                         * @memberof google.cloud.compute.v1.HttpHeaderOption
                         * @instance
                         */
                        Object.defineProperty(HttpHeaderOption.prototype, "_headerValue", {
                            get: $util.oneOfGetter($oneOfFields = ["headerValue"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpHeaderOption _replace.
                         * @member {"replace"|undefined} _replace
                         * @memberof google.cloud.compute.v1.HttpHeaderOption
                         * @instance
                         */
                        Object.defineProperty(HttpHeaderOption.prototype, "_replace", {
                            get: $util.oneOfGetter($oneOfFields = ["replace"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HttpHeaderOption instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HttpHeaderOption
                         * @static
                         * @param {google.cloud.compute.v1.IHttpHeaderOption=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HttpHeaderOption} HttpHeaderOption instance
                         */
                        HttpHeaderOption.create = function create(properties) {
                            return new HttpHeaderOption(properties);
                        };
    
                        /**
                         * Encodes the specified HttpHeaderOption message. Does not implicitly {@link google.cloud.compute.v1.HttpHeaderOption.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HttpHeaderOption
                         * @static
                         * @param {google.cloud.compute.v1.IHttpHeaderOption} message HttpHeaderOption message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpHeaderOption.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.replace != null && Object.hasOwnProperty.call(message, "replace"))
                                writer.uint32(/* id 20755124, wireType 0 =*/166040992).bool(message.replace);
                            if (message.headerName != null && Object.hasOwnProperty.call(message, "headerName"))
                                writer.uint32(/* id 110223613, wireType 2 =*/881788906).string(message.headerName);
                            if (message.headerValue != null && Object.hasOwnProperty.call(message, "headerValue"))
                                writer.uint32(/* id 203094335, wireType 2 =*/1624754682).string(message.headerValue);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HttpHeaderOption message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HttpHeaderOption.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HttpHeaderOption
                         * @static
                         * @param {google.cloud.compute.v1.IHttpHeaderOption} message HttpHeaderOption message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpHeaderOption.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HttpHeaderOption message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HttpHeaderOption
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HttpHeaderOption} HttpHeaderOption
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpHeaderOption.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HttpHeaderOption();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 110223613: {
                                        message.headerName = reader.string();
                                        break;
                                    }
                                case 203094335: {
                                        message.headerValue = reader.string();
                                        break;
                                    }
                                case 20755124: {
                                        message.replace = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HttpHeaderOption message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HttpHeaderOption
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HttpHeaderOption} HttpHeaderOption
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpHeaderOption.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HttpHeaderOption message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HttpHeaderOption
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HttpHeaderOption.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.headerName != null && message.hasOwnProperty("headerName")) {
                                properties._headerName = 1;
                                if (!$util.isString(message.headerName))
                                    return "headerName: string expected";
                            }
                            if (message.headerValue != null && message.hasOwnProperty("headerValue")) {
                                properties._headerValue = 1;
                                if (!$util.isString(message.headerValue))
                                    return "headerValue: string expected";
                            }
                            if (message.replace != null && message.hasOwnProperty("replace")) {
                                properties._replace = 1;
                                if (typeof message.replace !== "boolean")
                                    return "replace: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HttpHeaderOption message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HttpHeaderOption
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HttpHeaderOption} HttpHeaderOption
                         */
                        HttpHeaderOption.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HttpHeaderOption)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HttpHeaderOption();
                            if (object.headerName != null)
                                message.headerName = String(object.headerName);
                            if (object.headerValue != null)
                                message.headerValue = String(object.headerValue);
                            if (object.replace != null)
                                message.replace = Boolean(object.replace);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HttpHeaderOption message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HttpHeaderOption
                         * @static
                         * @param {google.cloud.compute.v1.HttpHeaderOption} message HttpHeaderOption
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HttpHeaderOption.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.replace != null && message.hasOwnProperty("replace")) {
                                object.replace = message.replace;
                                if (options.oneofs)
                                    object._replace = "replace";
                            }
                            if (message.headerName != null && message.hasOwnProperty("headerName")) {
                                object.headerName = message.headerName;
                                if (options.oneofs)
                                    object._headerName = "headerName";
                            }
                            if (message.headerValue != null && message.hasOwnProperty("headerValue")) {
                                object.headerValue = message.headerValue;
                                if (options.oneofs)
                                    object._headerValue = "headerValue";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HttpHeaderOption to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HttpHeaderOption
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HttpHeaderOption.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HttpHeaderOption
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HttpHeaderOption
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HttpHeaderOption.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HttpHeaderOption";
                        };
    
                        return HttpHeaderOption;
                    })();
    
                    v1.HttpQueryParameterMatch = (function() {
    
                        /**
                         * Properties of a HttpQueryParameterMatch.
                         * @memberof google.cloud.compute.v1
                         * @interface IHttpQueryParameterMatch
                         * @property {string|null} [exactMatch] HttpQueryParameterMatch exactMatch
                         * @property {string|null} [name] HttpQueryParameterMatch name
                         * @property {boolean|null} [presentMatch] HttpQueryParameterMatch presentMatch
                         * @property {string|null} [regexMatch] HttpQueryParameterMatch regexMatch
                         */
    
                        /**
                         * Constructs a new HttpQueryParameterMatch.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HttpQueryParameterMatch.
                         * @implements IHttpQueryParameterMatch
                         * @constructor
                         * @param {google.cloud.compute.v1.IHttpQueryParameterMatch=} [properties] Properties to set
                         */
                        function HttpQueryParameterMatch(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HttpQueryParameterMatch exactMatch.
                         * @member {string|null|undefined} exactMatch
                         * @memberof google.cloud.compute.v1.HttpQueryParameterMatch
                         * @instance
                         */
                        HttpQueryParameterMatch.prototype.exactMatch = null;
    
                        /**
                         * HttpQueryParameterMatch name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.HttpQueryParameterMatch
                         * @instance
                         */
                        HttpQueryParameterMatch.prototype.name = null;
    
                        /**
                         * HttpQueryParameterMatch presentMatch.
                         * @member {boolean|null|undefined} presentMatch
                         * @memberof google.cloud.compute.v1.HttpQueryParameterMatch
                         * @instance
                         */
                        HttpQueryParameterMatch.prototype.presentMatch = null;
    
                        /**
                         * HttpQueryParameterMatch regexMatch.
                         * @member {string|null|undefined} regexMatch
                         * @memberof google.cloud.compute.v1.HttpQueryParameterMatch
                         * @instance
                         */
                        HttpQueryParameterMatch.prototype.regexMatch = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HttpQueryParameterMatch _exactMatch.
                         * @member {"exactMatch"|undefined} _exactMatch
                         * @memberof google.cloud.compute.v1.HttpQueryParameterMatch
                         * @instance
                         */
                        Object.defineProperty(HttpQueryParameterMatch.prototype, "_exactMatch", {
                            get: $util.oneOfGetter($oneOfFields = ["exactMatch"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpQueryParameterMatch _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.HttpQueryParameterMatch
                         * @instance
                         */
                        Object.defineProperty(HttpQueryParameterMatch.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpQueryParameterMatch _presentMatch.
                         * @member {"presentMatch"|undefined} _presentMatch
                         * @memberof google.cloud.compute.v1.HttpQueryParameterMatch
                         * @instance
                         */
                        Object.defineProperty(HttpQueryParameterMatch.prototype, "_presentMatch", {
                            get: $util.oneOfGetter($oneOfFields = ["presentMatch"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpQueryParameterMatch _regexMatch.
                         * @member {"regexMatch"|undefined} _regexMatch
                         * @memberof google.cloud.compute.v1.HttpQueryParameterMatch
                         * @instance
                         */
                        Object.defineProperty(HttpQueryParameterMatch.prototype, "_regexMatch", {
                            get: $util.oneOfGetter($oneOfFields = ["regexMatch"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HttpQueryParameterMatch instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HttpQueryParameterMatch
                         * @static
                         * @param {google.cloud.compute.v1.IHttpQueryParameterMatch=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HttpQueryParameterMatch} HttpQueryParameterMatch instance
                         */
                        HttpQueryParameterMatch.create = function create(properties) {
                            return new HttpQueryParameterMatch(properties);
                        };
    
                        /**
                         * Encodes the specified HttpQueryParameterMatch message. Does not implicitly {@link google.cloud.compute.v1.HttpQueryParameterMatch.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HttpQueryParameterMatch
                         * @static
                         * @param {google.cloud.compute.v1.IHttpQueryParameterMatch} message HttpQueryParameterMatch message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpQueryParameterMatch.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.presentMatch != null && Object.hasOwnProperty.call(message, "presentMatch"))
                                writer.uint32(/* id 67435841, wireType 0 =*/539486728).bool(message.presentMatch);
                            if (message.regexMatch != null && Object.hasOwnProperty.call(message, "regexMatch"))
                                writer.uint32(/* id 107387853, wireType 2 =*/859102826).string(message.regexMatch);
                            if (message.exactMatch != null && Object.hasOwnProperty.call(message, "exactMatch"))
                                writer.uint32(/* id 457641093, wireType 2 =*/3661128746).string(message.exactMatch);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HttpQueryParameterMatch message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HttpQueryParameterMatch.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HttpQueryParameterMatch
                         * @static
                         * @param {google.cloud.compute.v1.IHttpQueryParameterMatch} message HttpQueryParameterMatch message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpQueryParameterMatch.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HttpQueryParameterMatch message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HttpQueryParameterMatch
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HttpQueryParameterMatch} HttpQueryParameterMatch
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpQueryParameterMatch.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HttpQueryParameterMatch();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 457641093: {
                                        message.exactMatch = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 67435841: {
                                        message.presentMatch = reader.bool();
                                        break;
                                    }
                                case 107387853: {
                                        message.regexMatch = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HttpQueryParameterMatch message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HttpQueryParameterMatch
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HttpQueryParameterMatch} HttpQueryParameterMatch
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpQueryParameterMatch.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HttpQueryParameterMatch message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HttpQueryParameterMatch
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HttpQueryParameterMatch.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.exactMatch != null && message.hasOwnProperty("exactMatch")) {
                                properties._exactMatch = 1;
                                if (!$util.isString(message.exactMatch))
                                    return "exactMatch: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.presentMatch != null && message.hasOwnProperty("presentMatch")) {
                                properties._presentMatch = 1;
                                if (typeof message.presentMatch !== "boolean")
                                    return "presentMatch: boolean expected";
                            }
                            if (message.regexMatch != null && message.hasOwnProperty("regexMatch")) {
                                properties._regexMatch = 1;
                                if (!$util.isString(message.regexMatch))
                                    return "regexMatch: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HttpQueryParameterMatch message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HttpQueryParameterMatch
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HttpQueryParameterMatch} HttpQueryParameterMatch
                         */
                        HttpQueryParameterMatch.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HttpQueryParameterMatch)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HttpQueryParameterMatch();
                            if (object.exactMatch != null)
                                message.exactMatch = String(object.exactMatch);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.presentMatch != null)
                                message.presentMatch = Boolean(object.presentMatch);
                            if (object.regexMatch != null)
                                message.regexMatch = String(object.regexMatch);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HttpQueryParameterMatch message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HttpQueryParameterMatch
                         * @static
                         * @param {google.cloud.compute.v1.HttpQueryParameterMatch} message HttpQueryParameterMatch
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HttpQueryParameterMatch.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.presentMatch != null && message.hasOwnProperty("presentMatch")) {
                                object.presentMatch = message.presentMatch;
                                if (options.oneofs)
                                    object._presentMatch = "presentMatch";
                            }
                            if (message.regexMatch != null && message.hasOwnProperty("regexMatch")) {
                                object.regexMatch = message.regexMatch;
                                if (options.oneofs)
                                    object._regexMatch = "regexMatch";
                            }
                            if (message.exactMatch != null && message.hasOwnProperty("exactMatch")) {
                                object.exactMatch = message.exactMatch;
                                if (options.oneofs)
                                    object._exactMatch = "exactMatch";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HttpQueryParameterMatch to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HttpQueryParameterMatch
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HttpQueryParameterMatch.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HttpQueryParameterMatch
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HttpQueryParameterMatch
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HttpQueryParameterMatch.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HttpQueryParameterMatch";
                        };
    
                        return HttpQueryParameterMatch;
                    })();
    
                    v1.HttpRedirectAction = (function() {
    
                        /**
                         * Properties of a HttpRedirectAction.
                         * @memberof google.cloud.compute.v1
                         * @interface IHttpRedirectAction
                         * @property {string|null} [hostRedirect] HttpRedirectAction hostRedirect
                         * @property {boolean|null} [httpsRedirect] HttpRedirectAction httpsRedirect
                         * @property {string|null} [pathRedirect] HttpRedirectAction pathRedirect
                         * @property {string|null} [prefixRedirect] HttpRedirectAction prefixRedirect
                         * @property {string|null} [redirectResponseCode] HttpRedirectAction redirectResponseCode
                         * @property {boolean|null} [stripQuery] HttpRedirectAction stripQuery
                         */
    
                        /**
                         * Constructs a new HttpRedirectAction.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HttpRedirectAction.
                         * @implements IHttpRedirectAction
                         * @constructor
                         * @param {google.cloud.compute.v1.IHttpRedirectAction=} [properties] Properties to set
                         */
                        function HttpRedirectAction(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HttpRedirectAction hostRedirect.
                         * @member {string|null|undefined} hostRedirect
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @instance
                         */
                        HttpRedirectAction.prototype.hostRedirect = null;
    
                        /**
                         * HttpRedirectAction httpsRedirect.
                         * @member {boolean|null|undefined} httpsRedirect
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @instance
                         */
                        HttpRedirectAction.prototype.httpsRedirect = null;
    
                        /**
                         * HttpRedirectAction pathRedirect.
                         * @member {string|null|undefined} pathRedirect
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @instance
                         */
                        HttpRedirectAction.prototype.pathRedirect = null;
    
                        /**
                         * HttpRedirectAction prefixRedirect.
                         * @member {string|null|undefined} prefixRedirect
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @instance
                         */
                        HttpRedirectAction.prototype.prefixRedirect = null;
    
                        /**
                         * HttpRedirectAction redirectResponseCode.
                         * @member {string|null|undefined} redirectResponseCode
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @instance
                         */
                        HttpRedirectAction.prototype.redirectResponseCode = null;
    
                        /**
                         * HttpRedirectAction stripQuery.
                         * @member {boolean|null|undefined} stripQuery
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @instance
                         */
                        HttpRedirectAction.prototype.stripQuery = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HttpRedirectAction _hostRedirect.
                         * @member {"hostRedirect"|undefined} _hostRedirect
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @instance
                         */
                        Object.defineProperty(HttpRedirectAction.prototype, "_hostRedirect", {
                            get: $util.oneOfGetter($oneOfFields = ["hostRedirect"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpRedirectAction _httpsRedirect.
                         * @member {"httpsRedirect"|undefined} _httpsRedirect
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @instance
                         */
                        Object.defineProperty(HttpRedirectAction.prototype, "_httpsRedirect", {
                            get: $util.oneOfGetter($oneOfFields = ["httpsRedirect"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpRedirectAction _pathRedirect.
                         * @member {"pathRedirect"|undefined} _pathRedirect
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @instance
                         */
                        Object.defineProperty(HttpRedirectAction.prototype, "_pathRedirect", {
                            get: $util.oneOfGetter($oneOfFields = ["pathRedirect"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpRedirectAction _prefixRedirect.
                         * @member {"prefixRedirect"|undefined} _prefixRedirect
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @instance
                         */
                        Object.defineProperty(HttpRedirectAction.prototype, "_prefixRedirect", {
                            get: $util.oneOfGetter($oneOfFields = ["prefixRedirect"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpRedirectAction _redirectResponseCode.
                         * @member {"redirectResponseCode"|undefined} _redirectResponseCode
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @instance
                         */
                        Object.defineProperty(HttpRedirectAction.prototype, "_redirectResponseCode", {
                            get: $util.oneOfGetter($oneOfFields = ["redirectResponseCode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpRedirectAction _stripQuery.
                         * @member {"stripQuery"|undefined} _stripQuery
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @instance
                         */
                        Object.defineProperty(HttpRedirectAction.prototype, "_stripQuery", {
                            get: $util.oneOfGetter($oneOfFields = ["stripQuery"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HttpRedirectAction instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @static
                         * @param {google.cloud.compute.v1.IHttpRedirectAction=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HttpRedirectAction} HttpRedirectAction instance
                         */
                        HttpRedirectAction.create = function create(properties) {
                            return new HttpRedirectAction(properties);
                        };
    
                        /**
                         * Encodes the specified HttpRedirectAction message. Does not implicitly {@link google.cloud.compute.v1.HttpRedirectAction.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @static
                         * @param {google.cloud.compute.v1.IHttpRedirectAction} message HttpRedirectAction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpRedirectAction.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.stripQuery != null && Object.hasOwnProperty.call(message, "stripQuery"))
                                writer.uint32(/* id 52284641, wireType 0 =*/418277128).bool(message.stripQuery);
                            if (message.hostRedirect != null && Object.hasOwnProperty.call(message, "hostRedirect"))
                                writer.uint32(/* id 107417747, wireType 2 =*/859341978).string(message.hostRedirect);
                            if (message.httpsRedirect != null && Object.hasOwnProperty.call(message, "httpsRedirect"))
                                writer.uint32(/* id 170260656, wireType 0 =*/1362085248).bool(message.httpsRedirect);
                            if (message.pathRedirect != null && Object.hasOwnProperty.call(message, "pathRedirect"))
                                writer.uint32(/* id 272342710, wireType 2 =*/2178741682).string(message.pathRedirect);
                            if (message.redirectResponseCode != null && Object.hasOwnProperty.call(message, "redirectResponseCode"))
                                writer.uint32(/* id 436710408, wireType 2 =*/3493683266).string(message.redirectResponseCode);
                            if (message.prefixRedirect != null && Object.hasOwnProperty.call(message, "prefixRedirect"))
                                writer.uint32(/* id 446184169, wireType 2 =*/3569473354).string(message.prefixRedirect);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HttpRedirectAction message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HttpRedirectAction.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @static
                         * @param {google.cloud.compute.v1.IHttpRedirectAction} message HttpRedirectAction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpRedirectAction.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HttpRedirectAction message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HttpRedirectAction} HttpRedirectAction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpRedirectAction.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HttpRedirectAction();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 107417747: {
                                        message.hostRedirect = reader.string();
                                        break;
                                    }
                                case 170260656: {
                                        message.httpsRedirect = reader.bool();
                                        break;
                                    }
                                case 272342710: {
                                        message.pathRedirect = reader.string();
                                        break;
                                    }
                                case 446184169: {
                                        message.prefixRedirect = reader.string();
                                        break;
                                    }
                                case 436710408: {
                                        message.redirectResponseCode = reader.string();
                                        break;
                                    }
                                case 52284641: {
                                        message.stripQuery = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HttpRedirectAction message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HttpRedirectAction} HttpRedirectAction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpRedirectAction.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HttpRedirectAction message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HttpRedirectAction.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.hostRedirect != null && message.hasOwnProperty("hostRedirect")) {
                                properties._hostRedirect = 1;
                                if (!$util.isString(message.hostRedirect))
                                    return "hostRedirect: string expected";
                            }
                            if (message.httpsRedirect != null && message.hasOwnProperty("httpsRedirect")) {
                                properties._httpsRedirect = 1;
                                if (typeof message.httpsRedirect !== "boolean")
                                    return "httpsRedirect: boolean expected";
                            }
                            if (message.pathRedirect != null && message.hasOwnProperty("pathRedirect")) {
                                properties._pathRedirect = 1;
                                if (!$util.isString(message.pathRedirect))
                                    return "pathRedirect: string expected";
                            }
                            if (message.prefixRedirect != null && message.hasOwnProperty("prefixRedirect")) {
                                properties._prefixRedirect = 1;
                                if (!$util.isString(message.prefixRedirect))
                                    return "prefixRedirect: string expected";
                            }
                            if (message.redirectResponseCode != null && message.hasOwnProperty("redirectResponseCode")) {
                                properties._redirectResponseCode = 1;
                                if (!$util.isString(message.redirectResponseCode))
                                    return "redirectResponseCode: string expected";
                            }
                            if (message.stripQuery != null && message.hasOwnProperty("stripQuery")) {
                                properties._stripQuery = 1;
                                if (typeof message.stripQuery !== "boolean")
                                    return "stripQuery: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HttpRedirectAction message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HttpRedirectAction} HttpRedirectAction
                         */
                        HttpRedirectAction.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HttpRedirectAction)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HttpRedirectAction();
                            if (object.hostRedirect != null)
                                message.hostRedirect = String(object.hostRedirect);
                            if (object.httpsRedirect != null)
                                message.httpsRedirect = Boolean(object.httpsRedirect);
                            if (object.pathRedirect != null)
                                message.pathRedirect = String(object.pathRedirect);
                            if (object.prefixRedirect != null)
                                message.prefixRedirect = String(object.prefixRedirect);
                            if (object.redirectResponseCode != null)
                                message.redirectResponseCode = String(object.redirectResponseCode);
                            if (object.stripQuery != null)
                                message.stripQuery = Boolean(object.stripQuery);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HttpRedirectAction message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @static
                         * @param {google.cloud.compute.v1.HttpRedirectAction} message HttpRedirectAction
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HttpRedirectAction.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.stripQuery != null && message.hasOwnProperty("stripQuery")) {
                                object.stripQuery = message.stripQuery;
                                if (options.oneofs)
                                    object._stripQuery = "stripQuery";
                            }
                            if (message.hostRedirect != null && message.hasOwnProperty("hostRedirect")) {
                                object.hostRedirect = message.hostRedirect;
                                if (options.oneofs)
                                    object._hostRedirect = "hostRedirect";
                            }
                            if (message.httpsRedirect != null && message.hasOwnProperty("httpsRedirect")) {
                                object.httpsRedirect = message.httpsRedirect;
                                if (options.oneofs)
                                    object._httpsRedirect = "httpsRedirect";
                            }
                            if (message.pathRedirect != null && message.hasOwnProperty("pathRedirect")) {
                                object.pathRedirect = message.pathRedirect;
                                if (options.oneofs)
                                    object._pathRedirect = "pathRedirect";
                            }
                            if (message.redirectResponseCode != null && message.hasOwnProperty("redirectResponseCode")) {
                                object.redirectResponseCode = message.redirectResponseCode;
                                if (options.oneofs)
                                    object._redirectResponseCode = "redirectResponseCode";
                            }
                            if (message.prefixRedirect != null && message.hasOwnProperty("prefixRedirect")) {
                                object.prefixRedirect = message.prefixRedirect;
                                if (options.oneofs)
                                    object._prefixRedirect = "prefixRedirect";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HttpRedirectAction to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HttpRedirectAction.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HttpRedirectAction
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HttpRedirectAction
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HttpRedirectAction.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HttpRedirectAction";
                        };
    
                        /**
                         * RedirectResponseCode enum.
                         * @name google.cloud.compute.v1.HttpRedirectAction.RedirectResponseCode
                         * @enum {number}
                         * @property {number} UNDEFINED_REDIRECT_RESPONSE_CODE=0 UNDEFINED_REDIRECT_RESPONSE_CODE value
                         * @property {number} FOUND=67084130 FOUND value
                         * @property {number} MOVED_PERMANENTLY_DEFAULT=386698449 MOVED_PERMANENTLY_DEFAULT value
                         * @property {number} PERMANENT_REDIRECT=382006381 PERMANENT_REDIRECT value
                         * @property {number} SEE_OTHER=445380580 SEE_OTHER value
                         * @property {number} TEMPORARY_REDIRECT=489550378 TEMPORARY_REDIRECT value
                         */
                        HttpRedirectAction.RedirectResponseCode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_REDIRECT_RESPONSE_CODE"] = 0;
                            values[valuesById[67084130] = "FOUND"] = 67084130;
                            values[valuesById[386698449] = "MOVED_PERMANENTLY_DEFAULT"] = 386698449;
                            values[valuesById[382006381] = "PERMANENT_REDIRECT"] = 382006381;
                            values[valuesById[445380580] = "SEE_OTHER"] = 445380580;
                            values[valuesById[489550378] = "TEMPORARY_REDIRECT"] = 489550378;
                            return values;
                        })();
    
                        return HttpRedirectAction;
                    })();
    
                    v1.HttpRetryPolicy = (function() {
    
                        /**
                         * Properties of a HttpRetryPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IHttpRetryPolicy
                         * @property {number|null} [numRetries] HttpRetryPolicy numRetries
                         * @property {google.cloud.compute.v1.IDuration|null} [perTryTimeout] HttpRetryPolicy perTryTimeout
                         * @property {Array.<string>|null} [retryConditions] HttpRetryPolicy retryConditions
                         */
    
                        /**
                         * Constructs a new HttpRetryPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HttpRetryPolicy.
                         * @implements IHttpRetryPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IHttpRetryPolicy=} [properties] Properties to set
                         */
                        function HttpRetryPolicy(properties) {
                            this.retryConditions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HttpRetryPolicy numRetries.
                         * @member {number|null|undefined} numRetries
                         * @memberof google.cloud.compute.v1.HttpRetryPolicy
                         * @instance
                         */
                        HttpRetryPolicy.prototype.numRetries = null;
    
                        /**
                         * HttpRetryPolicy perTryTimeout.
                         * @member {google.cloud.compute.v1.IDuration|null|undefined} perTryTimeout
                         * @memberof google.cloud.compute.v1.HttpRetryPolicy
                         * @instance
                         */
                        HttpRetryPolicy.prototype.perTryTimeout = null;
    
                        /**
                         * HttpRetryPolicy retryConditions.
                         * @member {Array.<string>} retryConditions
                         * @memberof google.cloud.compute.v1.HttpRetryPolicy
                         * @instance
                         */
                        HttpRetryPolicy.prototype.retryConditions = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HttpRetryPolicy _numRetries.
                         * @member {"numRetries"|undefined} _numRetries
                         * @memberof google.cloud.compute.v1.HttpRetryPolicy
                         * @instance
                         */
                        Object.defineProperty(HttpRetryPolicy.prototype, "_numRetries", {
                            get: $util.oneOfGetter($oneOfFields = ["numRetries"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpRetryPolicy _perTryTimeout.
                         * @member {"perTryTimeout"|undefined} _perTryTimeout
                         * @memberof google.cloud.compute.v1.HttpRetryPolicy
                         * @instance
                         */
                        Object.defineProperty(HttpRetryPolicy.prototype, "_perTryTimeout", {
                            get: $util.oneOfGetter($oneOfFields = ["perTryTimeout"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HttpRetryPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HttpRetryPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IHttpRetryPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HttpRetryPolicy} HttpRetryPolicy instance
                         */
                        HttpRetryPolicy.create = function create(properties) {
                            return new HttpRetryPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified HttpRetryPolicy message. Does not implicitly {@link google.cloud.compute.v1.HttpRetryPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HttpRetryPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IHttpRetryPolicy} message HttpRetryPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpRetryPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.retryConditions != null && message.retryConditions.length)
                                for (var i = 0; i < message.retryConditions.length; ++i)
                                    writer.uint32(/* id 28815535, wireType 2 =*/230524282).string(message.retryConditions[i]);
                            if (message.numRetries != null && Object.hasOwnProperty.call(message, "numRetries"))
                                writer.uint32(/* id 251680141, wireType 0 =*/2013441128).uint32(message.numRetries);
                            if (message.perTryTimeout != null && Object.hasOwnProperty.call(message, "perTryTimeout"))
                                $root.google.cloud.compute.v1.Duration.encode(message.perTryTimeout, writer.uint32(/* id 280041147, wireType 2 =*/2240329178).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HttpRetryPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HttpRetryPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HttpRetryPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IHttpRetryPolicy} message HttpRetryPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpRetryPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HttpRetryPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HttpRetryPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HttpRetryPolicy} HttpRetryPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpRetryPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HttpRetryPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 251680141: {
                                        message.numRetries = reader.uint32();
                                        break;
                                    }
                                case 280041147: {
                                        message.perTryTimeout = $root.google.cloud.compute.v1.Duration.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 28815535: {
                                        if (!(message.retryConditions && message.retryConditions.length))
                                            message.retryConditions = [];
                                        message.retryConditions.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HttpRetryPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HttpRetryPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HttpRetryPolicy} HttpRetryPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpRetryPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HttpRetryPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HttpRetryPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HttpRetryPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.numRetries != null && message.hasOwnProperty("numRetries")) {
                                properties._numRetries = 1;
                                if (!$util.isInteger(message.numRetries))
                                    return "numRetries: integer expected";
                            }
                            if (message.perTryTimeout != null && message.hasOwnProperty("perTryTimeout")) {
                                properties._perTryTimeout = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Duration.verify(message.perTryTimeout);
                                    if (error)
                                        return "perTryTimeout." + error;
                                }
                            }
                            if (message.retryConditions != null && message.hasOwnProperty("retryConditions")) {
                                if (!Array.isArray(message.retryConditions))
                                    return "retryConditions: array expected";
                                for (var i = 0; i < message.retryConditions.length; ++i)
                                    if (!$util.isString(message.retryConditions[i]))
                                        return "retryConditions: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HttpRetryPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HttpRetryPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HttpRetryPolicy} HttpRetryPolicy
                         */
                        HttpRetryPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HttpRetryPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HttpRetryPolicy();
                            if (object.numRetries != null)
                                message.numRetries = object.numRetries >>> 0;
                            if (object.perTryTimeout != null) {
                                if (typeof object.perTryTimeout !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HttpRetryPolicy.perTryTimeout: object expected");
                                message.perTryTimeout = $root.google.cloud.compute.v1.Duration.fromObject(object.perTryTimeout);
                            }
                            if (object.retryConditions) {
                                if (!Array.isArray(object.retryConditions))
                                    throw TypeError(".google.cloud.compute.v1.HttpRetryPolicy.retryConditions: array expected");
                                message.retryConditions = [];
                                for (var i = 0; i < object.retryConditions.length; ++i)
                                    message.retryConditions[i] = String(object.retryConditions[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HttpRetryPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HttpRetryPolicy
                         * @static
                         * @param {google.cloud.compute.v1.HttpRetryPolicy} message HttpRetryPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HttpRetryPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.retryConditions = [];
                            if (message.retryConditions && message.retryConditions.length) {
                                object.retryConditions = [];
                                for (var j = 0; j < message.retryConditions.length; ++j)
                                    object.retryConditions[j] = message.retryConditions[j];
                            }
                            if (message.numRetries != null && message.hasOwnProperty("numRetries")) {
                                object.numRetries = message.numRetries;
                                if (options.oneofs)
                                    object._numRetries = "numRetries";
                            }
                            if (message.perTryTimeout != null && message.hasOwnProperty("perTryTimeout")) {
                                object.perTryTimeout = $root.google.cloud.compute.v1.Duration.toObject(message.perTryTimeout, options);
                                if (options.oneofs)
                                    object._perTryTimeout = "perTryTimeout";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HttpRetryPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HttpRetryPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HttpRetryPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HttpRetryPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HttpRetryPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HttpRetryPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HttpRetryPolicy";
                        };
    
                        return HttpRetryPolicy;
                    })();
    
                    v1.HttpRouteAction = (function() {
    
                        /**
                         * Properties of a HttpRouteAction.
                         * @memberof google.cloud.compute.v1
                         * @interface IHttpRouteAction
                         * @property {google.cloud.compute.v1.ICorsPolicy|null} [corsPolicy] HttpRouteAction corsPolicy
                         * @property {google.cloud.compute.v1.IHttpFaultInjection|null} [faultInjectionPolicy] HttpRouteAction faultInjectionPolicy
                         * @property {google.cloud.compute.v1.IDuration|null} [maxStreamDuration] HttpRouteAction maxStreamDuration
                         * @property {google.cloud.compute.v1.IRequestMirrorPolicy|null} [requestMirrorPolicy] HttpRouteAction requestMirrorPolicy
                         * @property {google.cloud.compute.v1.IHttpRetryPolicy|null} [retryPolicy] HttpRouteAction retryPolicy
                         * @property {google.cloud.compute.v1.IDuration|null} [timeout] HttpRouteAction timeout
                         * @property {google.cloud.compute.v1.IUrlRewrite|null} [urlRewrite] HttpRouteAction urlRewrite
                         * @property {Array.<google.cloud.compute.v1.IWeightedBackendService>|null} [weightedBackendServices] HttpRouteAction weightedBackendServices
                         */
    
                        /**
                         * Constructs a new HttpRouteAction.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HttpRouteAction.
                         * @implements IHttpRouteAction
                         * @constructor
                         * @param {google.cloud.compute.v1.IHttpRouteAction=} [properties] Properties to set
                         */
                        function HttpRouteAction(properties) {
                            this.weightedBackendServices = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HttpRouteAction corsPolicy.
                         * @member {google.cloud.compute.v1.ICorsPolicy|null|undefined} corsPolicy
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @instance
                         */
                        HttpRouteAction.prototype.corsPolicy = null;
    
                        /**
                         * HttpRouteAction faultInjectionPolicy.
                         * @member {google.cloud.compute.v1.IHttpFaultInjection|null|undefined} faultInjectionPolicy
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @instance
                         */
                        HttpRouteAction.prototype.faultInjectionPolicy = null;
    
                        /**
                         * HttpRouteAction maxStreamDuration.
                         * @member {google.cloud.compute.v1.IDuration|null|undefined} maxStreamDuration
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @instance
                         */
                        HttpRouteAction.prototype.maxStreamDuration = null;
    
                        /**
                         * HttpRouteAction requestMirrorPolicy.
                         * @member {google.cloud.compute.v1.IRequestMirrorPolicy|null|undefined} requestMirrorPolicy
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @instance
                         */
                        HttpRouteAction.prototype.requestMirrorPolicy = null;
    
                        /**
                         * HttpRouteAction retryPolicy.
                         * @member {google.cloud.compute.v1.IHttpRetryPolicy|null|undefined} retryPolicy
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @instance
                         */
                        HttpRouteAction.prototype.retryPolicy = null;
    
                        /**
                         * HttpRouteAction timeout.
                         * @member {google.cloud.compute.v1.IDuration|null|undefined} timeout
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @instance
                         */
                        HttpRouteAction.prototype.timeout = null;
    
                        /**
                         * HttpRouteAction urlRewrite.
                         * @member {google.cloud.compute.v1.IUrlRewrite|null|undefined} urlRewrite
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @instance
                         */
                        HttpRouteAction.prototype.urlRewrite = null;
    
                        /**
                         * HttpRouteAction weightedBackendServices.
                         * @member {Array.<google.cloud.compute.v1.IWeightedBackendService>} weightedBackendServices
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @instance
                         */
                        HttpRouteAction.prototype.weightedBackendServices = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HttpRouteAction _corsPolicy.
                         * @member {"corsPolicy"|undefined} _corsPolicy
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @instance
                         */
                        Object.defineProperty(HttpRouteAction.prototype, "_corsPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["corsPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpRouteAction _faultInjectionPolicy.
                         * @member {"faultInjectionPolicy"|undefined} _faultInjectionPolicy
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @instance
                         */
                        Object.defineProperty(HttpRouteAction.prototype, "_faultInjectionPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["faultInjectionPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpRouteAction _maxStreamDuration.
                         * @member {"maxStreamDuration"|undefined} _maxStreamDuration
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @instance
                         */
                        Object.defineProperty(HttpRouteAction.prototype, "_maxStreamDuration", {
                            get: $util.oneOfGetter($oneOfFields = ["maxStreamDuration"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpRouteAction _requestMirrorPolicy.
                         * @member {"requestMirrorPolicy"|undefined} _requestMirrorPolicy
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @instance
                         */
                        Object.defineProperty(HttpRouteAction.prototype, "_requestMirrorPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["requestMirrorPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpRouteAction _retryPolicy.
                         * @member {"retryPolicy"|undefined} _retryPolicy
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @instance
                         */
                        Object.defineProperty(HttpRouteAction.prototype, "_retryPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["retryPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpRouteAction _timeout.
                         * @member {"timeout"|undefined} _timeout
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @instance
                         */
                        Object.defineProperty(HttpRouteAction.prototype, "_timeout", {
                            get: $util.oneOfGetter($oneOfFields = ["timeout"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpRouteAction _urlRewrite.
                         * @member {"urlRewrite"|undefined} _urlRewrite
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @instance
                         */
                        Object.defineProperty(HttpRouteAction.prototype, "_urlRewrite", {
                            get: $util.oneOfGetter($oneOfFields = ["urlRewrite"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HttpRouteAction instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @static
                         * @param {google.cloud.compute.v1.IHttpRouteAction=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HttpRouteAction} HttpRouteAction instance
                         */
                        HttpRouteAction.create = function create(properties) {
                            return new HttpRouteAction(properties);
                        };
    
                        /**
                         * Encodes the specified HttpRouteAction message. Does not implicitly {@link google.cloud.compute.v1.HttpRouteAction.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @static
                         * @param {google.cloud.compute.v1.IHttpRouteAction} message HttpRouteAction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpRouteAction.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.retryPolicy != null && Object.hasOwnProperty.call(message, "retryPolicy"))
                                $root.google.cloud.compute.v1.HttpRetryPolicy.encode(message.retryPolicy, writer.uint32(/* id 56799913, wireType 2 =*/454399306).fork()).ldelim();
                            if (message.maxStreamDuration != null && Object.hasOwnProperty.call(message, "maxStreamDuration"))
                                $root.google.cloud.compute.v1.Duration.encode(message.maxStreamDuration, writer.uint32(/* id 61428376, wireType 2 =*/491427010).fork()).ldelim();
                            if (message.requestMirrorPolicy != null && Object.hasOwnProperty.call(message, "requestMirrorPolicy"))
                                $root.google.cloud.compute.v1.RequestMirrorPolicy.encode(message.requestMirrorPolicy, writer.uint32(/* id 220196866, wireType 2 =*/1761574930).fork()).ldelim();
                            if (message.urlRewrite != null && Object.hasOwnProperty.call(message, "urlRewrite"))
                                $root.google.cloud.compute.v1.UrlRewrite.encode(message.urlRewrite, writer.uint32(/* id 273333948, wireType 2 =*/2186671586).fork()).ldelim();
                            if (message.timeout != null && Object.hasOwnProperty.call(message, "timeout"))
                                $root.google.cloud.compute.v1.Duration.encode(message.timeout, writer.uint32(/* id 296701281, wireType 2 =*/2373610250).fork()).ldelim();
                            if (message.weightedBackendServices != null && message.weightedBackendServices.length)
                                for (var i = 0; i < message.weightedBackendServices.length; ++i)
                                    $root.google.cloud.compute.v1.WeightedBackendService.encode(message.weightedBackendServices[i], writer.uint32(/* id 337028049, wireType 2 =*/2696224394).fork()).ldelim();
                            if (message.corsPolicy != null && Object.hasOwnProperty.call(message, "corsPolicy"))
                                $root.google.cloud.compute.v1.CorsPolicy.encode(message.corsPolicy, writer.uint32(/* id 398943748, wireType 2 =*/3191549986).fork()).ldelim();
                            if (message.faultInjectionPolicy != null && Object.hasOwnProperty.call(message, "faultInjectionPolicy"))
                                $root.google.cloud.compute.v1.HttpFaultInjection.encode(message.faultInjectionPolicy, writer.uint32(/* id 412781079, wireType 2 =*/3302248634).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HttpRouteAction message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HttpRouteAction.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @static
                         * @param {google.cloud.compute.v1.IHttpRouteAction} message HttpRouteAction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpRouteAction.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HttpRouteAction message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HttpRouteAction} HttpRouteAction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpRouteAction.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HttpRouteAction();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 398943748: {
                                        message.corsPolicy = $root.google.cloud.compute.v1.CorsPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 412781079: {
                                        message.faultInjectionPolicy = $root.google.cloud.compute.v1.HttpFaultInjection.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 61428376: {
                                        message.maxStreamDuration = $root.google.cloud.compute.v1.Duration.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 220196866: {
                                        message.requestMirrorPolicy = $root.google.cloud.compute.v1.RequestMirrorPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 56799913: {
                                        message.retryPolicy = $root.google.cloud.compute.v1.HttpRetryPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 296701281: {
                                        message.timeout = $root.google.cloud.compute.v1.Duration.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 273333948: {
                                        message.urlRewrite = $root.google.cloud.compute.v1.UrlRewrite.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 337028049: {
                                        if (!(message.weightedBackendServices && message.weightedBackendServices.length))
                                            message.weightedBackendServices = [];
                                        message.weightedBackendServices.push($root.google.cloud.compute.v1.WeightedBackendService.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HttpRouteAction message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HttpRouteAction} HttpRouteAction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpRouteAction.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HttpRouteAction message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HttpRouteAction.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.corsPolicy != null && message.hasOwnProperty("corsPolicy")) {
                                properties._corsPolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.CorsPolicy.verify(message.corsPolicy);
                                    if (error)
                                        return "corsPolicy." + error;
                                }
                            }
                            if (message.faultInjectionPolicy != null && message.hasOwnProperty("faultInjectionPolicy")) {
                                properties._faultInjectionPolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HttpFaultInjection.verify(message.faultInjectionPolicy);
                                    if (error)
                                        return "faultInjectionPolicy." + error;
                                }
                            }
                            if (message.maxStreamDuration != null && message.hasOwnProperty("maxStreamDuration")) {
                                properties._maxStreamDuration = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Duration.verify(message.maxStreamDuration);
                                    if (error)
                                        return "maxStreamDuration." + error;
                                }
                            }
                            if (message.requestMirrorPolicy != null && message.hasOwnProperty("requestMirrorPolicy")) {
                                properties._requestMirrorPolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.RequestMirrorPolicy.verify(message.requestMirrorPolicy);
                                    if (error)
                                        return "requestMirrorPolicy." + error;
                                }
                            }
                            if (message.retryPolicy != null && message.hasOwnProperty("retryPolicy")) {
                                properties._retryPolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HttpRetryPolicy.verify(message.retryPolicy);
                                    if (error)
                                        return "retryPolicy." + error;
                                }
                            }
                            if (message.timeout != null && message.hasOwnProperty("timeout")) {
                                properties._timeout = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Duration.verify(message.timeout);
                                    if (error)
                                        return "timeout." + error;
                                }
                            }
                            if (message.urlRewrite != null && message.hasOwnProperty("urlRewrite")) {
                                properties._urlRewrite = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.UrlRewrite.verify(message.urlRewrite);
                                    if (error)
                                        return "urlRewrite." + error;
                                }
                            }
                            if (message.weightedBackendServices != null && message.hasOwnProperty("weightedBackendServices")) {
                                if (!Array.isArray(message.weightedBackendServices))
                                    return "weightedBackendServices: array expected";
                                for (var i = 0; i < message.weightedBackendServices.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.WeightedBackendService.verify(message.weightedBackendServices[i]);
                                    if (error)
                                        return "weightedBackendServices." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HttpRouteAction message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HttpRouteAction} HttpRouteAction
                         */
                        HttpRouteAction.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HttpRouteAction)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HttpRouteAction();
                            if (object.corsPolicy != null) {
                                if (typeof object.corsPolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HttpRouteAction.corsPolicy: object expected");
                                message.corsPolicy = $root.google.cloud.compute.v1.CorsPolicy.fromObject(object.corsPolicy);
                            }
                            if (object.faultInjectionPolicy != null) {
                                if (typeof object.faultInjectionPolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HttpRouteAction.faultInjectionPolicy: object expected");
                                message.faultInjectionPolicy = $root.google.cloud.compute.v1.HttpFaultInjection.fromObject(object.faultInjectionPolicy);
                            }
                            if (object.maxStreamDuration != null) {
                                if (typeof object.maxStreamDuration !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HttpRouteAction.maxStreamDuration: object expected");
                                message.maxStreamDuration = $root.google.cloud.compute.v1.Duration.fromObject(object.maxStreamDuration);
                            }
                            if (object.requestMirrorPolicy != null) {
                                if (typeof object.requestMirrorPolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HttpRouteAction.requestMirrorPolicy: object expected");
                                message.requestMirrorPolicy = $root.google.cloud.compute.v1.RequestMirrorPolicy.fromObject(object.requestMirrorPolicy);
                            }
                            if (object.retryPolicy != null) {
                                if (typeof object.retryPolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HttpRouteAction.retryPolicy: object expected");
                                message.retryPolicy = $root.google.cloud.compute.v1.HttpRetryPolicy.fromObject(object.retryPolicy);
                            }
                            if (object.timeout != null) {
                                if (typeof object.timeout !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HttpRouteAction.timeout: object expected");
                                message.timeout = $root.google.cloud.compute.v1.Duration.fromObject(object.timeout);
                            }
                            if (object.urlRewrite != null) {
                                if (typeof object.urlRewrite !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HttpRouteAction.urlRewrite: object expected");
                                message.urlRewrite = $root.google.cloud.compute.v1.UrlRewrite.fromObject(object.urlRewrite);
                            }
                            if (object.weightedBackendServices) {
                                if (!Array.isArray(object.weightedBackendServices))
                                    throw TypeError(".google.cloud.compute.v1.HttpRouteAction.weightedBackendServices: array expected");
                                message.weightedBackendServices = [];
                                for (var i = 0; i < object.weightedBackendServices.length; ++i) {
                                    if (typeof object.weightedBackendServices[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.HttpRouteAction.weightedBackendServices: object expected");
                                    message.weightedBackendServices[i] = $root.google.cloud.compute.v1.WeightedBackendService.fromObject(object.weightedBackendServices[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HttpRouteAction message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @static
                         * @param {google.cloud.compute.v1.HttpRouteAction} message HttpRouteAction
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HttpRouteAction.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.weightedBackendServices = [];
                            if (message.retryPolicy != null && message.hasOwnProperty("retryPolicy")) {
                                object.retryPolicy = $root.google.cloud.compute.v1.HttpRetryPolicy.toObject(message.retryPolicy, options);
                                if (options.oneofs)
                                    object._retryPolicy = "retryPolicy";
                            }
                            if (message.maxStreamDuration != null && message.hasOwnProperty("maxStreamDuration")) {
                                object.maxStreamDuration = $root.google.cloud.compute.v1.Duration.toObject(message.maxStreamDuration, options);
                                if (options.oneofs)
                                    object._maxStreamDuration = "maxStreamDuration";
                            }
                            if (message.requestMirrorPolicy != null && message.hasOwnProperty("requestMirrorPolicy")) {
                                object.requestMirrorPolicy = $root.google.cloud.compute.v1.RequestMirrorPolicy.toObject(message.requestMirrorPolicy, options);
                                if (options.oneofs)
                                    object._requestMirrorPolicy = "requestMirrorPolicy";
                            }
                            if (message.urlRewrite != null && message.hasOwnProperty("urlRewrite")) {
                                object.urlRewrite = $root.google.cloud.compute.v1.UrlRewrite.toObject(message.urlRewrite, options);
                                if (options.oneofs)
                                    object._urlRewrite = "urlRewrite";
                            }
                            if (message.timeout != null && message.hasOwnProperty("timeout")) {
                                object.timeout = $root.google.cloud.compute.v1.Duration.toObject(message.timeout, options);
                                if (options.oneofs)
                                    object._timeout = "timeout";
                            }
                            if (message.weightedBackendServices && message.weightedBackendServices.length) {
                                object.weightedBackendServices = [];
                                for (var j = 0; j < message.weightedBackendServices.length; ++j)
                                    object.weightedBackendServices[j] = $root.google.cloud.compute.v1.WeightedBackendService.toObject(message.weightedBackendServices[j], options);
                            }
                            if (message.corsPolicy != null && message.hasOwnProperty("corsPolicy")) {
                                object.corsPolicy = $root.google.cloud.compute.v1.CorsPolicy.toObject(message.corsPolicy, options);
                                if (options.oneofs)
                                    object._corsPolicy = "corsPolicy";
                            }
                            if (message.faultInjectionPolicy != null && message.hasOwnProperty("faultInjectionPolicy")) {
                                object.faultInjectionPolicy = $root.google.cloud.compute.v1.HttpFaultInjection.toObject(message.faultInjectionPolicy, options);
                                if (options.oneofs)
                                    object._faultInjectionPolicy = "faultInjectionPolicy";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HttpRouteAction to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HttpRouteAction.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HttpRouteAction
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HttpRouteAction
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HttpRouteAction.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HttpRouteAction";
                        };
    
                        return HttpRouteAction;
                    })();
    
                    v1.HttpRouteRule = (function() {
    
                        /**
                         * Properties of a HttpRouteRule.
                         * @memberof google.cloud.compute.v1
                         * @interface IHttpRouteRule
                         * @property {string|null} [description] HttpRouteRule description
                         * @property {google.cloud.compute.v1.IHttpHeaderAction|null} [headerAction] HttpRouteRule headerAction
                         * @property {Array.<google.cloud.compute.v1.IHttpRouteRuleMatch>|null} [matchRules] HttpRouteRule matchRules
                         * @property {number|null} [priority] HttpRouteRule priority
                         * @property {google.cloud.compute.v1.IHttpRouteAction|null} [routeAction] HttpRouteRule routeAction
                         * @property {string|null} [service] HttpRouteRule service
                         * @property {google.cloud.compute.v1.IHttpRedirectAction|null} [urlRedirect] HttpRouteRule urlRedirect
                         */
    
                        /**
                         * Constructs a new HttpRouteRule.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HttpRouteRule.
                         * @implements IHttpRouteRule
                         * @constructor
                         * @param {google.cloud.compute.v1.IHttpRouteRule=} [properties] Properties to set
                         */
                        function HttpRouteRule(properties) {
                            this.matchRules = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HttpRouteRule description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @instance
                         */
                        HttpRouteRule.prototype.description = null;
    
                        /**
                         * HttpRouteRule headerAction.
                         * @member {google.cloud.compute.v1.IHttpHeaderAction|null|undefined} headerAction
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @instance
                         */
                        HttpRouteRule.prototype.headerAction = null;
    
                        /**
                         * HttpRouteRule matchRules.
                         * @member {Array.<google.cloud.compute.v1.IHttpRouteRuleMatch>} matchRules
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @instance
                         */
                        HttpRouteRule.prototype.matchRules = $util.emptyArray;
    
                        /**
                         * HttpRouteRule priority.
                         * @member {number|null|undefined} priority
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @instance
                         */
                        HttpRouteRule.prototype.priority = null;
    
                        /**
                         * HttpRouteRule routeAction.
                         * @member {google.cloud.compute.v1.IHttpRouteAction|null|undefined} routeAction
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @instance
                         */
                        HttpRouteRule.prototype.routeAction = null;
    
                        /**
                         * HttpRouteRule service.
                         * @member {string|null|undefined} service
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @instance
                         */
                        HttpRouteRule.prototype.service = null;
    
                        /**
                         * HttpRouteRule urlRedirect.
                         * @member {google.cloud.compute.v1.IHttpRedirectAction|null|undefined} urlRedirect
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @instance
                         */
                        HttpRouteRule.prototype.urlRedirect = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HttpRouteRule _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @instance
                         */
                        Object.defineProperty(HttpRouteRule.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpRouteRule _headerAction.
                         * @member {"headerAction"|undefined} _headerAction
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @instance
                         */
                        Object.defineProperty(HttpRouteRule.prototype, "_headerAction", {
                            get: $util.oneOfGetter($oneOfFields = ["headerAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpRouteRule _priority.
                         * @member {"priority"|undefined} _priority
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @instance
                         */
                        Object.defineProperty(HttpRouteRule.prototype, "_priority", {
                            get: $util.oneOfGetter($oneOfFields = ["priority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpRouteRule _routeAction.
                         * @member {"routeAction"|undefined} _routeAction
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @instance
                         */
                        Object.defineProperty(HttpRouteRule.prototype, "_routeAction", {
                            get: $util.oneOfGetter($oneOfFields = ["routeAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpRouteRule _service.
                         * @member {"service"|undefined} _service
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @instance
                         */
                        Object.defineProperty(HttpRouteRule.prototype, "_service", {
                            get: $util.oneOfGetter($oneOfFields = ["service"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpRouteRule _urlRedirect.
                         * @member {"urlRedirect"|undefined} _urlRedirect
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @instance
                         */
                        Object.defineProperty(HttpRouteRule.prototype, "_urlRedirect", {
                            get: $util.oneOfGetter($oneOfFields = ["urlRedirect"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HttpRouteRule instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @static
                         * @param {google.cloud.compute.v1.IHttpRouteRule=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HttpRouteRule} HttpRouteRule instance
                         */
                        HttpRouteRule.create = function create(properties) {
                            return new HttpRouteRule(properties);
                        };
    
                        /**
                         * Encodes the specified HttpRouteRule message. Does not implicitly {@link google.cloud.compute.v1.HttpRouteRule.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @static
                         * @param {google.cloud.compute.v1.IHttpRouteRule} message HttpRouteRule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpRouteRule.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.headerAction != null && Object.hasOwnProperty.call(message, "headerAction"))
                                $root.google.cloud.compute.v1.HttpHeaderAction.encode(message.headerAction, writer.uint32(/* id 328077352, wireType 2 =*/2624618818).fork()).ldelim();
                            if (message.service != null && Object.hasOwnProperty.call(message, "service"))
                                writer.uint32(/* id 373540533, wireType 2 =*/2988324266).string(message.service);
                            if (message.matchRules != null && message.matchRules.length)
                                for (var i = 0; i < message.matchRules.length; ++i)
                                    $root.google.cloud.compute.v1.HttpRouteRuleMatch.encode(message.matchRules[i], writer.uint32(/* id 376200701, wireType 2 =*/3009605610).fork()).ldelim();
                            if (message.urlRedirect != null && Object.hasOwnProperty.call(message, "urlRedirect"))
                                $root.google.cloud.compute.v1.HttpRedirectAction.encode(message.urlRedirect, writer.uint32(/* id 405147820, wireType 2 =*/3241182562).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.routeAction != null && Object.hasOwnProperty.call(message, "routeAction"))
                                $root.google.cloud.compute.v1.HttpRouteAction.encode(message.routeAction, writer.uint32(/* id 424563948, wireType 2 =*/3396511586).fork()).ldelim();
                            if (message.priority != null && Object.hasOwnProperty.call(message, "priority"))
                                writer.uint32(/* id 445151652, wireType 0 =*/3561213216).int32(message.priority);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HttpRouteRule message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HttpRouteRule.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @static
                         * @param {google.cloud.compute.v1.IHttpRouteRule} message HttpRouteRule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpRouteRule.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HttpRouteRule message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HttpRouteRule} HttpRouteRule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpRouteRule.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HttpRouteRule();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 328077352: {
                                        message.headerAction = $root.google.cloud.compute.v1.HttpHeaderAction.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 376200701: {
                                        if (!(message.matchRules && message.matchRules.length))
                                            message.matchRules = [];
                                        message.matchRules.push($root.google.cloud.compute.v1.HttpRouteRuleMatch.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 445151652: {
                                        message.priority = reader.int32();
                                        break;
                                    }
                                case 424563948: {
                                        message.routeAction = $root.google.cloud.compute.v1.HttpRouteAction.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 373540533: {
                                        message.service = reader.string();
                                        break;
                                    }
                                case 405147820: {
                                        message.urlRedirect = $root.google.cloud.compute.v1.HttpRedirectAction.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HttpRouteRule message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HttpRouteRule} HttpRouteRule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpRouteRule.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HttpRouteRule message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HttpRouteRule.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.headerAction != null && message.hasOwnProperty("headerAction")) {
                                properties._headerAction = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HttpHeaderAction.verify(message.headerAction);
                                    if (error)
                                        return "headerAction." + error;
                                }
                            }
                            if (message.matchRules != null && message.hasOwnProperty("matchRules")) {
                                if (!Array.isArray(message.matchRules))
                                    return "matchRules: array expected";
                                for (var i = 0; i < message.matchRules.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.HttpRouteRuleMatch.verify(message.matchRules[i]);
                                    if (error)
                                        return "matchRules." + error;
                                }
                            }
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                properties._priority = 1;
                                if (!$util.isInteger(message.priority))
                                    return "priority: integer expected";
                            }
                            if (message.routeAction != null && message.hasOwnProperty("routeAction")) {
                                properties._routeAction = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HttpRouteAction.verify(message.routeAction);
                                    if (error)
                                        return "routeAction." + error;
                                }
                            }
                            if (message.service != null && message.hasOwnProperty("service")) {
                                properties._service = 1;
                                if (!$util.isString(message.service))
                                    return "service: string expected";
                            }
                            if (message.urlRedirect != null && message.hasOwnProperty("urlRedirect")) {
                                properties._urlRedirect = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HttpRedirectAction.verify(message.urlRedirect);
                                    if (error)
                                        return "urlRedirect." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HttpRouteRule message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HttpRouteRule} HttpRouteRule
                         */
                        HttpRouteRule.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HttpRouteRule)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HttpRouteRule();
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.headerAction != null) {
                                if (typeof object.headerAction !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HttpRouteRule.headerAction: object expected");
                                message.headerAction = $root.google.cloud.compute.v1.HttpHeaderAction.fromObject(object.headerAction);
                            }
                            if (object.matchRules) {
                                if (!Array.isArray(object.matchRules))
                                    throw TypeError(".google.cloud.compute.v1.HttpRouteRule.matchRules: array expected");
                                message.matchRules = [];
                                for (var i = 0; i < object.matchRules.length; ++i) {
                                    if (typeof object.matchRules[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.HttpRouteRule.matchRules: object expected");
                                    message.matchRules[i] = $root.google.cloud.compute.v1.HttpRouteRuleMatch.fromObject(object.matchRules[i]);
                                }
                            }
                            if (object.priority != null)
                                message.priority = object.priority | 0;
                            if (object.routeAction != null) {
                                if (typeof object.routeAction !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HttpRouteRule.routeAction: object expected");
                                message.routeAction = $root.google.cloud.compute.v1.HttpRouteAction.fromObject(object.routeAction);
                            }
                            if (object.service != null)
                                message.service = String(object.service);
                            if (object.urlRedirect != null) {
                                if (typeof object.urlRedirect !== "object")
                                    throw TypeError(".google.cloud.compute.v1.HttpRouteRule.urlRedirect: object expected");
                                message.urlRedirect = $root.google.cloud.compute.v1.HttpRedirectAction.fromObject(object.urlRedirect);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HttpRouteRule message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @static
                         * @param {google.cloud.compute.v1.HttpRouteRule} message HttpRouteRule
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HttpRouteRule.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.matchRules = [];
                            if (message.headerAction != null && message.hasOwnProperty("headerAction")) {
                                object.headerAction = $root.google.cloud.compute.v1.HttpHeaderAction.toObject(message.headerAction, options);
                                if (options.oneofs)
                                    object._headerAction = "headerAction";
                            }
                            if (message.service != null && message.hasOwnProperty("service")) {
                                object.service = message.service;
                                if (options.oneofs)
                                    object._service = "service";
                            }
                            if (message.matchRules && message.matchRules.length) {
                                object.matchRules = [];
                                for (var j = 0; j < message.matchRules.length; ++j)
                                    object.matchRules[j] = $root.google.cloud.compute.v1.HttpRouteRuleMatch.toObject(message.matchRules[j], options);
                            }
                            if (message.urlRedirect != null && message.hasOwnProperty("urlRedirect")) {
                                object.urlRedirect = $root.google.cloud.compute.v1.HttpRedirectAction.toObject(message.urlRedirect, options);
                                if (options.oneofs)
                                    object._urlRedirect = "urlRedirect";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.routeAction != null && message.hasOwnProperty("routeAction")) {
                                object.routeAction = $root.google.cloud.compute.v1.HttpRouteAction.toObject(message.routeAction, options);
                                if (options.oneofs)
                                    object._routeAction = "routeAction";
                            }
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                object.priority = message.priority;
                                if (options.oneofs)
                                    object._priority = "priority";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HttpRouteRule to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HttpRouteRule.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HttpRouteRule
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HttpRouteRule
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HttpRouteRule.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HttpRouteRule";
                        };
    
                        return HttpRouteRule;
                    })();
    
                    v1.HttpRouteRuleMatch = (function() {
    
                        /**
                         * Properties of a HttpRouteRuleMatch.
                         * @memberof google.cloud.compute.v1
                         * @interface IHttpRouteRuleMatch
                         * @property {string|null} [fullPathMatch] HttpRouteRuleMatch fullPathMatch
                         * @property {Array.<google.cloud.compute.v1.IHttpHeaderMatch>|null} [headerMatches] HttpRouteRuleMatch headerMatches
                         * @property {boolean|null} [ignoreCase] HttpRouteRuleMatch ignoreCase
                         * @property {Array.<google.cloud.compute.v1.IMetadataFilter>|null} [metadataFilters] HttpRouteRuleMatch metadataFilters
                         * @property {string|null} [prefixMatch] HttpRouteRuleMatch prefixMatch
                         * @property {Array.<google.cloud.compute.v1.IHttpQueryParameterMatch>|null} [queryParameterMatches] HttpRouteRuleMatch queryParameterMatches
                         * @property {string|null} [regexMatch] HttpRouteRuleMatch regexMatch
                         */
    
                        /**
                         * Constructs a new HttpRouteRuleMatch.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HttpRouteRuleMatch.
                         * @implements IHttpRouteRuleMatch
                         * @constructor
                         * @param {google.cloud.compute.v1.IHttpRouteRuleMatch=} [properties] Properties to set
                         */
                        function HttpRouteRuleMatch(properties) {
                            this.headerMatches = [];
                            this.metadataFilters = [];
                            this.queryParameterMatches = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * HttpRouteRuleMatch fullPathMatch.
                         * @member {string|null|undefined} fullPathMatch
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @instance
                         */
                        HttpRouteRuleMatch.prototype.fullPathMatch = null;
    
                        /**
                         * HttpRouteRuleMatch headerMatches.
                         * @member {Array.<google.cloud.compute.v1.IHttpHeaderMatch>} headerMatches
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @instance
                         */
                        HttpRouteRuleMatch.prototype.headerMatches = $util.emptyArray;
    
                        /**
                         * HttpRouteRuleMatch ignoreCase.
                         * @member {boolean|null|undefined} ignoreCase
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @instance
                         */
                        HttpRouteRuleMatch.prototype.ignoreCase = null;
    
                        /**
                         * HttpRouteRuleMatch metadataFilters.
                         * @member {Array.<google.cloud.compute.v1.IMetadataFilter>} metadataFilters
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @instance
                         */
                        HttpRouteRuleMatch.prototype.metadataFilters = $util.emptyArray;
    
                        /**
                         * HttpRouteRuleMatch prefixMatch.
                         * @member {string|null|undefined} prefixMatch
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @instance
                         */
                        HttpRouteRuleMatch.prototype.prefixMatch = null;
    
                        /**
                         * HttpRouteRuleMatch queryParameterMatches.
                         * @member {Array.<google.cloud.compute.v1.IHttpQueryParameterMatch>} queryParameterMatches
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @instance
                         */
                        HttpRouteRuleMatch.prototype.queryParameterMatches = $util.emptyArray;
    
                        /**
                         * HttpRouteRuleMatch regexMatch.
                         * @member {string|null|undefined} regexMatch
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @instance
                         */
                        HttpRouteRuleMatch.prototype.regexMatch = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * HttpRouteRuleMatch _fullPathMatch.
                         * @member {"fullPathMatch"|undefined} _fullPathMatch
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @instance
                         */
                        Object.defineProperty(HttpRouteRuleMatch.prototype, "_fullPathMatch", {
                            get: $util.oneOfGetter($oneOfFields = ["fullPathMatch"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpRouteRuleMatch _ignoreCase.
                         * @member {"ignoreCase"|undefined} _ignoreCase
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @instance
                         */
                        Object.defineProperty(HttpRouteRuleMatch.prototype, "_ignoreCase", {
                            get: $util.oneOfGetter($oneOfFields = ["ignoreCase"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpRouteRuleMatch _prefixMatch.
                         * @member {"prefixMatch"|undefined} _prefixMatch
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @instance
                         */
                        Object.defineProperty(HttpRouteRuleMatch.prototype, "_prefixMatch", {
                            get: $util.oneOfGetter($oneOfFields = ["prefixMatch"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * HttpRouteRuleMatch _regexMatch.
                         * @member {"regexMatch"|undefined} _regexMatch
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @instance
                         */
                        Object.defineProperty(HttpRouteRuleMatch.prototype, "_regexMatch", {
                            get: $util.oneOfGetter($oneOfFields = ["regexMatch"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new HttpRouteRuleMatch instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @static
                         * @param {google.cloud.compute.v1.IHttpRouteRuleMatch=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.HttpRouteRuleMatch} HttpRouteRuleMatch instance
                         */
                        HttpRouteRuleMatch.create = function create(properties) {
                            return new HttpRouteRuleMatch(properties);
                        };
    
                        /**
                         * Encodes the specified HttpRouteRuleMatch message. Does not implicitly {@link google.cloud.compute.v1.HttpRouteRuleMatch.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @static
                         * @param {google.cloud.compute.v1.IHttpRouteRuleMatch} message HttpRouteRuleMatch message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpRouteRuleMatch.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.regexMatch != null && Object.hasOwnProperty.call(message, "regexMatch"))
                                writer.uint32(/* id 107387853, wireType 2 =*/859102826).string(message.regexMatch);
                            if (message.fullPathMatch != null && Object.hasOwnProperty.call(message, "fullPathMatch"))
                                writer.uint32(/* id 214598875, wireType 2 =*/1716791002).string(message.fullPathMatch);
                            if (message.prefixMatch != null && Object.hasOwnProperty.call(message, "prefixMatch"))
                                writer.uint32(/* id 257898968, wireType 2 =*/2063191746).string(message.prefixMatch);
                            if (message.queryParameterMatches != null && message.queryParameterMatches.length)
                                for (var i = 0; i < message.queryParameterMatches.length; ++i)
                                    $root.google.cloud.compute.v1.HttpQueryParameterMatch.encode(message.queryParameterMatches[i], writer.uint32(/* id 286231270, wireType 2 =*/2289850162).fork()).ldelim();
                            if (message.headerMatches != null && message.headerMatches.length)
                                for (var i = 0; i < message.headerMatches.length; ++i)
                                    $root.google.cloud.compute.v1.HttpHeaderMatch.encode(message.headerMatches[i], writer.uint32(/* id 361903489, wireType 2 =*/2895227914).fork()).ldelim();
                            if (message.ignoreCase != null && Object.hasOwnProperty.call(message, "ignoreCase"))
                                writer.uint32(/* id 464324989, wireType 0 =*/3714599912).bool(message.ignoreCase);
                            if (message.metadataFilters != null && message.metadataFilters.length)
                                for (var i = 0; i < message.metadataFilters.length; ++i)
                                    $root.google.cloud.compute.v1.MetadataFilter.encode(message.metadataFilters[i], writer.uint32(/* id 464725739, wireType 2 =*/3717805914).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified HttpRouteRuleMatch message, length delimited. Does not implicitly {@link google.cloud.compute.v1.HttpRouteRuleMatch.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @static
                         * @param {google.cloud.compute.v1.IHttpRouteRuleMatch} message HttpRouteRuleMatch message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        HttpRouteRuleMatch.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a HttpRouteRuleMatch message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.HttpRouteRuleMatch} HttpRouteRuleMatch
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpRouteRuleMatch.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.HttpRouteRuleMatch();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 214598875: {
                                        message.fullPathMatch = reader.string();
                                        break;
                                    }
                                case 361903489: {
                                        if (!(message.headerMatches && message.headerMatches.length))
                                            message.headerMatches = [];
                                        message.headerMatches.push($root.google.cloud.compute.v1.HttpHeaderMatch.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 464324989: {
                                        message.ignoreCase = reader.bool();
                                        break;
                                    }
                                case 464725739: {
                                        if (!(message.metadataFilters && message.metadataFilters.length))
                                            message.metadataFilters = [];
                                        message.metadataFilters.push($root.google.cloud.compute.v1.MetadataFilter.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 257898968: {
                                        message.prefixMatch = reader.string();
                                        break;
                                    }
                                case 286231270: {
                                        if (!(message.queryParameterMatches && message.queryParameterMatches.length))
                                            message.queryParameterMatches = [];
                                        message.queryParameterMatches.push($root.google.cloud.compute.v1.HttpQueryParameterMatch.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 107387853: {
                                        message.regexMatch = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a HttpRouteRuleMatch message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.HttpRouteRuleMatch} HttpRouteRuleMatch
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        HttpRouteRuleMatch.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a HttpRouteRuleMatch message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        HttpRouteRuleMatch.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.fullPathMatch != null && message.hasOwnProperty("fullPathMatch")) {
                                properties._fullPathMatch = 1;
                                if (!$util.isString(message.fullPathMatch))
                                    return "fullPathMatch: string expected";
                            }
                            if (message.headerMatches != null && message.hasOwnProperty("headerMatches")) {
                                if (!Array.isArray(message.headerMatches))
                                    return "headerMatches: array expected";
                                for (var i = 0; i < message.headerMatches.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.HttpHeaderMatch.verify(message.headerMatches[i]);
                                    if (error)
                                        return "headerMatches." + error;
                                }
                            }
                            if (message.ignoreCase != null && message.hasOwnProperty("ignoreCase")) {
                                properties._ignoreCase = 1;
                                if (typeof message.ignoreCase !== "boolean")
                                    return "ignoreCase: boolean expected";
                            }
                            if (message.metadataFilters != null && message.hasOwnProperty("metadataFilters")) {
                                if (!Array.isArray(message.metadataFilters))
                                    return "metadataFilters: array expected";
                                for (var i = 0; i < message.metadataFilters.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.MetadataFilter.verify(message.metadataFilters[i]);
                                    if (error)
                                        return "metadataFilters." + error;
                                }
                            }
                            if (message.prefixMatch != null && message.hasOwnProperty("prefixMatch")) {
                                properties._prefixMatch = 1;
                                if (!$util.isString(message.prefixMatch))
                                    return "prefixMatch: string expected";
                            }
                            if (message.queryParameterMatches != null && message.hasOwnProperty("queryParameterMatches")) {
                                if (!Array.isArray(message.queryParameterMatches))
                                    return "queryParameterMatches: array expected";
                                for (var i = 0; i < message.queryParameterMatches.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.HttpQueryParameterMatch.verify(message.queryParameterMatches[i]);
                                    if (error)
                                        return "queryParameterMatches." + error;
                                }
                            }
                            if (message.regexMatch != null && message.hasOwnProperty("regexMatch")) {
                                properties._regexMatch = 1;
                                if (!$util.isString(message.regexMatch))
                                    return "regexMatch: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a HttpRouteRuleMatch message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.HttpRouteRuleMatch} HttpRouteRuleMatch
                         */
                        HttpRouteRuleMatch.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.HttpRouteRuleMatch)
                                return object;
                            var message = new $root.google.cloud.compute.v1.HttpRouteRuleMatch();
                            if (object.fullPathMatch != null)
                                message.fullPathMatch = String(object.fullPathMatch);
                            if (object.headerMatches) {
                                if (!Array.isArray(object.headerMatches))
                                    throw TypeError(".google.cloud.compute.v1.HttpRouteRuleMatch.headerMatches: array expected");
                                message.headerMatches = [];
                                for (var i = 0; i < object.headerMatches.length; ++i) {
                                    if (typeof object.headerMatches[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.HttpRouteRuleMatch.headerMatches: object expected");
                                    message.headerMatches[i] = $root.google.cloud.compute.v1.HttpHeaderMatch.fromObject(object.headerMatches[i]);
                                }
                            }
                            if (object.ignoreCase != null)
                                message.ignoreCase = Boolean(object.ignoreCase);
                            if (object.metadataFilters) {
                                if (!Array.isArray(object.metadataFilters))
                                    throw TypeError(".google.cloud.compute.v1.HttpRouteRuleMatch.metadataFilters: array expected");
                                message.metadataFilters = [];
                                for (var i = 0; i < object.metadataFilters.length; ++i) {
                                    if (typeof object.metadataFilters[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.HttpRouteRuleMatch.metadataFilters: object expected");
                                    message.metadataFilters[i] = $root.google.cloud.compute.v1.MetadataFilter.fromObject(object.metadataFilters[i]);
                                }
                            }
                            if (object.prefixMatch != null)
                                message.prefixMatch = String(object.prefixMatch);
                            if (object.queryParameterMatches) {
                                if (!Array.isArray(object.queryParameterMatches))
                                    throw TypeError(".google.cloud.compute.v1.HttpRouteRuleMatch.queryParameterMatches: array expected");
                                message.queryParameterMatches = [];
                                for (var i = 0; i < object.queryParameterMatches.length; ++i) {
                                    if (typeof object.queryParameterMatches[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.HttpRouteRuleMatch.queryParameterMatches: object expected");
                                    message.queryParameterMatches[i] = $root.google.cloud.compute.v1.HttpQueryParameterMatch.fromObject(object.queryParameterMatches[i]);
                                }
                            }
                            if (object.regexMatch != null)
                                message.regexMatch = String(object.regexMatch);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a HttpRouteRuleMatch message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @static
                         * @param {google.cloud.compute.v1.HttpRouteRuleMatch} message HttpRouteRuleMatch
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        HttpRouteRuleMatch.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.queryParameterMatches = [];
                                object.headerMatches = [];
                                object.metadataFilters = [];
                            }
                            if (message.regexMatch != null && message.hasOwnProperty("regexMatch")) {
                                object.regexMatch = message.regexMatch;
                                if (options.oneofs)
                                    object._regexMatch = "regexMatch";
                            }
                            if (message.fullPathMatch != null && message.hasOwnProperty("fullPathMatch")) {
                                object.fullPathMatch = message.fullPathMatch;
                                if (options.oneofs)
                                    object._fullPathMatch = "fullPathMatch";
                            }
                            if (message.prefixMatch != null && message.hasOwnProperty("prefixMatch")) {
                                object.prefixMatch = message.prefixMatch;
                                if (options.oneofs)
                                    object._prefixMatch = "prefixMatch";
                            }
                            if (message.queryParameterMatches && message.queryParameterMatches.length) {
                                object.queryParameterMatches = [];
                                for (var j = 0; j < message.queryParameterMatches.length; ++j)
                                    object.queryParameterMatches[j] = $root.google.cloud.compute.v1.HttpQueryParameterMatch.toObject(message.queryParameterMatches[j], options);
                            }
                            if (message.headerMatches && message.headerMatches.length) {
                                object.headerMatches = [];
                                for (var j = 0; j < message.headerMatches.length; ++j)
                                    object.headerMatches[j] = $root.google.cloud.compute.v1.HttpHeaderMatch.toObject(message.headerMatches[j], options);
                            }
                            if (message.ignoreCase != null && message.hasOwnProperty("ignoreCase")) {
                                object.ignoreCase = message.ignoreCase;
                                if (options.oneofs)
                                    object._ignoreCase = "ignoreCase";
                            }
                            if (message.metadataFilters && message.metadataFilters.length) {
                                object.metadataFilters = [];
                                for (var j = 0; j < message.metadataFilters.length; ++j)
                                    object.metadataFilters[j] = $root.google.cloud.compute.v1.MetadataFilter.toObject(message.metadataFilters[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this HttpRouteRuleMatch to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        HttpRouteRuleMatch.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for HttpRouteRuleMatch
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.HttpRouteRuleMatch
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        HttpRouteRuleMatch.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.HttpRouteRuleMatch";
                        };
    
                        return HttpRouteRuleMatch;
                    })();
    
                    v1.Image = (function() {
    
                        /**
                         * Properties of an Image.
                         * @memberof google.cloud.compute.v1
                         * @interface IImage
                         * @property {string|null} [architecture] Image architecture
                         * @property {number|Long|null} [archiveSizeBytes] Image archiveSizeBytes
                         * @property {string|null} [creationTimestamp] Image creationTimestamp
                         * @property {google.cloud.compute.v1.IDeprecationStatus|null} [deprecated] Image deprecated
                         * @property {string|null} [description] Image description
                         * @property {number|Long|null} [diskSizeGb] Image diskSizeGb
                         * @property {string|null} [family] Image family
                         * @property {Array.<google.cloud.compute.v1.IGuestOsFeature>|null} [guestOsFeatures] Image guestOsFeatures
                         * @property {number|Long|null} [id] Image id
                         * @property {google.cloud.compute.v1.ICustomerEncryptionKey|null} [imageEncryptionKey] Image imageEncryptionKey
                         * @property {string|null} [kind] Image kind
                         * @property {string|null} [labelFingerprint] Image labelFingerprint
                         * @property {Object.<string,string>|null} [labels] Image labels
                         * @property {Array.<number|Long>|null} [licenseCodes] Image licenseCodes
                         * @property {Array.<string>|null} [licenses] Image licenses
                         * @property {string|null} [name] Image name
                         * @property {google.cloud.compute.v1.IRawDisk|null} [rawDisk] Image rawDisk
                         * @property {boolean|null} [satisfiesPzs] Image satisfiesPzs
                         * @property {string|null} [selfLink] Image selfLink
                         * @property {google.cloud.compute.v1.IInitialStateConfig|null} [shieldedInstanceInitialState] Image shieldedInstanceInitialState
                         * @property {string|null} [sourceDisk] Image sourceDisk
                         * @property {google.cloud.compute.v1.ICustomerEncryptionKey|null} [sourceDiskEncryptionKey] Image sourceDiskEncryptionKey
                         * @property {string|null} [sourceDiskId] Image sourceDiskId
                         * @property {string|null} [sourceImage] Image sourceImage
                         * @property {google.cloud.compute.v1.ICustomerEncryptionKey|null} [sourceImageEncryptionKey] Image sourceImageEncryptionKey
                         * @property {string|null} [sourceImageId] Image sourceImageId
                         * @property {string|null} [sourceSnapshot] Image sourceSnapshot
                         * @property {google.cloud.compute.v1.ICustomerEncryptionKey|null} [sourceSnapshotEncryptionKey] Image sourceSnapshotEncryptionKey
                         * @property {string|null} [sourceSnapshotId] Image sourceSnapshotId
                         * @property {string|null} [sourceType] Image sourceType
                         * @property {string|null} [status] Image status
                         * @property {Array.<string>|null} [storageLocations] Image storageLocations
                         */
    
                        /**
                         * Constructs a new Image.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an Image.
                         * @implements IImage
                         * @constructor
                         * @param {google.cloud.compute.v1.IImage=} [properties] Properties to set
                         */
                        function Image(properties) {
                            this.guestOsFeatures = [];
                            this.labels = {};
                            this.licenseCodes = [];
                            this.licenses = [];
                            this.storageLocations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Image architecture.
                         * @member {string|null|undefined} architecture
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.architecture = null;
    
                        /**
                         * Image archiveSizeBytes.
                         * @member {number|Long|null|undefined} archiveSizeBytes
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.archiveSizeBytes = null;
    
                        /**
                         * Image creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.creationTimestamp = null;
    
                        /**
                         * Image deprecated.
                         * @member {google.cloud.compute.v1.IDeprecationStatus|null|undefined} deprecated
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.deprecated = null;
    
                        /**
                         * Image description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.description = null;
    
                        /**
                         * Image diskSizeGb.
                         * @member {number|Long|null|undefined} diskSizeGb
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.diskSizeGb = null;
    
                        /**
                         * Image family.
                         * @member {string|null|undefined} family
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.family = null;
    
                        /**
                         * Image guestOsFeatures.
                         * @member {Array.<google.cloud.compute.v1.IGuestOsFeature>} guestOsFeatures
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.guestOsFeatures = $util.emptyArray;
    
                        /**
                         * Image id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.id = null;
    
                        /**
                         * Image imageEncryptionKey.
                         * @member {google.cloud.compute.v1.ICustomerEncryptionKey|null|undefined} imageEncryptionKey
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.imageEncryptionKey = null;
    
                        /**
                         * Image kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.kind = null;
    
                        /**
                         * Image labelFingerprint.
                         * @member {string|null|undefined} labelFingerprint
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.labelFingerprint = null;
    
                        /**
                         * Image labels.
                         * @member {Object.<string,string>} labels
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.labels = $util.emptyObject;
    
                        /**
                         * Image licenseCodes.
                         * @member {Array.<number|Long>} licenseCodes
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.licenseCodes = $util.emptyArray;
    
                        /**
                         * Image licenses.
                         * @member {Array.<string>} licenses
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.licenses = $util.emptyArray;
    
                        /**
                         * Image name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.name = null;
    
                        /**
                         * Image rawDisk.
                         * @member {google.cloud.compute.v1.IRawDisk|null|undefined} rawDisk
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.rawDisk = null;
    
                        /**
                         * Image satisfiesPzs.
                         * @member {boolean|null|undefined} satisfiesPzs
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.satisfiesPzs = null;
    
                        /**
                         * Image selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.selfLink = null;
    
                        /**
                         * Image shieldedInstanceInitialState.
                         * @member {google.cloud.compute.v1.IInitialStateConfig|null|undefined} shieldedInstanceInitialState
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.shieldedInstanceInitialState = null;
    
                        /**
                         * Image sourceDisk.
                         * @member {string|null|undefined} sourceDisk
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.sourceDisk = null;
    
                        /**
                         * Image sourceDiskEncryptionKey.
                         * @member {google.cloud.compute.v1.ICustomerEncryptionKey|null|undefined} sourceDiskEncryptionKey
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.sourceDiskEncryptionKey = null;
    
                        /**
                         * Image sourceDiskId.
                         * @member {string|null|undefined} sourceDiskId
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.sourceDiskId = null;
    
                        /**
                         * Image sourceImage.
                         * @member {string|null|undefined} sourceImage
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.sourceImage = null;
    
                        /**
                         * Image sourceImageEncryptionKey.
                         * @member {google.cloud.compute.v1.ICustomerEncryptionKey|null|undefined} sourceImageEncryptionKey
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.sourceImageEncryptionKey = null;
    
                        /**
                         * Image sourceImageId.
                         * @member {string|null|undefined} sourceImageId
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.sourceImageId = null;
    
                        /**
                         * Image sourceSnapshot.
                         * @member {string|null|undefined} sourceSnapshot
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.sourceSnapshot = null;
    
                        /**
                         * Image sourceSnapshotEncryptionKey.
                         * @member {google.cloud.compute.v1.ICustomerEncryptionKey|null|undefined} sourceSnapshotEncryptionKey
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.sourceSnapshotEncryptionKey = null;
    
                        /**
                         * Image sourceSnapshotId.
                         * @member {string|null|undefined} sourceSnapshotId
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.sourceSnapshotId = null;
    
                        /**
                         * Image sourceType.
                         * @member {string|null|undefined} sourceType
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.sourceType = null;
    
                        /**
                         * Image status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.status = null;
    
                        /**
                         * Image storageLocations.
                         * @member {Array.<string>} storageLocations
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Image.prototype.storageLocations = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Image _architecture.
                         * @member {"architecture"|undefined} _architecture
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_architecture", {
                            get: $util.oneOfGetter($oneOfFields = ["architecture"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _archiveSizeBytes.
                         * @member {"archiveSizeBytes"|undefined} _archiveSizeBytes
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_archiveSizeBytes", {
                            get: $util.oneOfGetter($oneOfFields = ["archiveSizeBytes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _deprecated.
                         * @member {"deprecated"|undefined} _deprecated
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_deprecated", {
                            get: $util.oneOfGetter($oneOfFields = ["deprecated"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _diskSizeGb.
                         * @member {"diskSizeGb"|undefined} _diskSizeGb
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_diskSizeGb", {
                            get: $util.oneOfGetter($oneOfFields = ["diskSizeGb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _family.
                         * @member {"family"|undefined} _family
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_family", {
                            get: $util.oneOfGetter($oneOfFields = ["family"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _imageEncryptionKey.
                         * @member {"imageEncryptionKey"|undefined} _imageEncryptionKey
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_imageEncryptionKey", {
                            get: $util.oneOfGetter($oneOfFields = ["imageEncryptionKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _labelFingerprint.
                         * @member {"labelFingerprint"|undefined} _labelFingerprint
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_labelFingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["labelFingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _rawDisk.
                         * @member {"rawDisk"|undefined} _rawDisk
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_rawDisk", {
                            get: $util.oneOfGetter($oneOfFields = ["rawDisk"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _satisfiesPzs.
                         * @member {"satisfiesPzs"|undefined} _satisfiesPzs
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_satisfiesPzs", {
                            get: $util.oneOfGetter($oneOfFields = ["satisfiesPzs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _shieldedInstanceInitialState.
                         * @member {"shieldedInstanceInitialState"|undefined} _shieldedInstanceInitialState
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_shieldedInstanceInitialState", {
                            get: $util.oneOfGetter($oneOfFields = ["shieldedInstanceInitialState"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _sourceDisk.
                         * @member {"sourceDisk"|undefined} _sourceDisk
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_sourceDisk", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceDisk"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _sourceDiskEncryptionKey.
                         * @member {"sourceDiskEncryptionKey"|undefined} _sourceDiskEncryptionKey
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_sourceDiskEncryptionKey", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceDiskEncryptionKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _sourceDiskId.
                         * @member {"sourceDiskId"|undefined} _sourceDiskId
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_sourceDiskId", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceDiskId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _sourceImage.
                         * @member {"sourceImage"|undefined} _sourceImage
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_sourceImage", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceImage"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _sourceImageEncryptionKey.
                         * @member {"sourceImageEncryptionKey"|undefined} _sourceImageEncryptionKey
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_sourceImageEncryptionKey", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceImageEncryptionKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _sourceImageId.
                         * @member {"sourceImageId"|undefined} _sourceImageId
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_sourceImageId", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceImageId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _sourceSnapshot.
                         * @member {"sourceSnapshot"|undefined} _sourceSnapshot
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_sourceSnapshot", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceSnapshot"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _sourceSnapshotEncryptionKey.
                         * @member {"sourceSnapshotEncryptionKey"|undefined} _sourceSnapshotEncryptionKey
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_sourceSnapshotEncryptionKey", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceSnapshotEncryptionKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _sourceSnapshotId.
                         * @member {"sourceSnapshotId"|undefined} _sourceSnapshotId
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_sourceSnapshotId", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceSnapshotId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _sourceType.
                         * @member {"sourceType"|undefined} _sourceType
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_sourceType", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Image _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         */
                        Object.defineProperty(Image.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Image instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Image
                         * @static
                         * @param {google.cloud.compute.v1.IImage=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Image} Image instance
                         */
                        Image.create = function create(properties) {
                            return new Image(properties);
                        };
    
                        /**
                         * Encodes the specified Image message. Does not implicitly {@link google.cloud.compute.v1.Image.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Image
                         * @static
                         * @param {google.cloud.compute.v1.IImage} message Image message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Image.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.licenseCodes != null && message.licenseCodes.length) {
                                writer.uint32(/* id 45482664, wireType 2 =*/363861314).fork();
                                for (var i = 0; i < message.licenseCodes.length; ++i)
                                    writer.int64(message.licenseCodes[i]);
                                writer.ldelim();
                            }
                            if (message.sourceImage != null && Object.hasOwnProperty.call(message, "sourceImage"))
                                writer.uint32(/* id 50443319, wireType 2 =*/403546554).string(message.sourceImage);
                            if (message.sourceImageId != null && Object.hasOwnProperty.call(message, "sourceImageId"))
                                writer.uint32(/* id 55328291, wireType 2 =*/442626330).string(message.sourceImageId);
                            if (message.guestOsFeatures != null && message.guestOsFeatures.length)
                                for (var i = 0; i < message.guestOsFeatures.length; ++i)
                                    $root.google.cloud.compute.v1.GuestOsFeature.encode(message.guestOsFeatures[i], writer.uint32(/* id 79294545, wireType 2 =*/634356362).fork()).ldelim();
                            if (message.sourceSnapshotId != null && Object.hasOwnProperty.call(message, "sourceSnapshotId"))
                                writer.uint32(/* id 98962258, wireType 2 =*/791698066).string(message.sourceSnapshotId);
                            if (message.sourceSnapshot != null && Object.hasOwnProperty.call(message, "sourceSnapshot"))
                                writer.uint32(/* id 126061928, wireType 2 =*/1008495426).string(message.sourceSnapshot);
                            if (message.labelFingerprint != null && Object.hasOwnProperty.call(message, "labelFingerprint"))
                                writer.uint32(/* id 178124825, wireType 2 =*/1424998602).string(message.labelFingerprint);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.shieldedInstanceInitialState != null && Object.hasOwnProperty.call(message, "shieldedInstanceInitialState"))
                                $root.google.cloud.compute.v1.InitialStateConfig.encode(message.shieldedInstanceInitialState, writer.uint32(/* id 192356867, wireType 2 =*/1538854938).fork()).ldelim();
                            if (message.architecture != null && Object.hasOwnProperty.call(message, "architecture"))
                                writer.uint32(/* id 302803283, wireType 2 =*/2422426266).string(message.architecture);
                            if (message.sourceSnapshotEncryptionKey != null && Object.hasOwnProperty.call(message, "sourceSnapshotEncryptionKey"))
                                $root.google.cloud.compute.v1.CustomerEncryptionKey.encode(message.sourceSnapshotEncryptionKey, writer.uint32(/* id 303679322, wireType 2 =*/2429434578).fork()).ldelim();
                            if (message.diskSizeGb != null && Object.hasOwnProperty.call(message, "diskSizeGb"))
                                writer.uint32(/* id 316263735, wireType 0 =*/2530109880).int64(message.diskSizeGb);
                            if (message.storageLocations != null && message.storageLocations.length)
                                for (var i = 0; i < message.storageLocations.length; ++i)
                                    writer.uint32(/* id 328005274, wireType 2 =*/2624042194).string(message.storageLocations[i]);
                            if (message.family != null && Object.hasOwnProperty.call(message, "family"))
                                writer.uint32(/* id 328751972, wireType 2 =*/2630015778).string(message.family);
                            if (message.licenses != null && message.licenses.length)
                                for (var i = 0; i < message.licenses.length; ++i)
                                    writer.uint32(/* id 337642578, wireType 2 =*/2701140626).string(message.licenses[i]);
                            if (message.imageEncryptionKey != null && Object.hasOwnProperty.call(message, "imageEncryptionKey"))
                                $root.google.cloud.compute.v1.CustomerEncryptionKey.encode(message.imageEncryptionKey, writer.uint32(/* id 379512583, wireType 2 =*/3036100666).fork()).ldelim();
                            if (message.archiveSizeBytes != null && Object.hasOwnProperty.call(message, "archiveSizeBytes"))
                                writer.uint32(/* id 381093450, wireType 0 =*/3048747600).int64(message.archiveSizeBytes);
                            if (message.sourceImageEncryptionKey != null && Object.hasOwnProperty.call(message, "sourceImageEncryptionKey"))
                                $root.google.cloud.compute.v1.CustomerEncryptionKey.encode(message.sourceImageEncryptionKey, writer.uint32(/* id 381503659, wireType 2 =*/3052029274).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.sourceDisk != null && Object.hasOwnProperty.call(message, "sourceDisk"))
                                writer.uint32(/* id 451753793, wireType 2 =*/3614030346).string(message.sourceDisk);
                            if (message.sourceType != null && Object.hasOwnProperty.call(message, "sourceType"))
                                writer.uint32(/* id 452245726, wireType 2 =*/3617965810).string(message.sourceType);
                            if (message.sourceDiskId != null && Object.hasOwnProperty.call(message, "sourceDiskId"))
                                writer.uint32(/* id 454190809, wireType 2 =*/3633526474).string(message.sourceDiskId);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.satisfiesPzs != null && Object.hasOwnProperty.call(message, "satisfiesPzs"))
                                writer.uint32(/* id 480964267, wireType 0 =*/3847714136).bool(message.satisfiesPzs);
                            if (message.labels != null && Object.hasOwnProperty.call(message, "labels"))
                                for (var keys = Object.keys(message.labels), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 500195327, wireType 2 =*/4001562618).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.labels[keys[i]]).ldelim();
                            if (message.rawDisk != null && Object.hasOwnProperty.call(message, "rawDisk"))
                                $root.google.cloud.compute.v1.RawDisk.encode(message.rawDisk, writer.uint32(/* id 503113556, wireType 2 =*/4024908450).fork()).ldelim();
                            if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                                $root.google.cloud.compute.v1.DeprecationStatus.encode(message.deprecated, writer.uint32(/* id 515138995, wireType 2 =*/4121111962).fork()).ldelim();
                            if (message.sourceDiskEncryptionKey != null && Object.hasOwnProperty.call(message, "sourceDiskEncryptionKey"))
                                $root.google.cloud.compute.v1.CustomerEncryptionKey.encode(message.sourceDiskEncryptionKey, writer.uint32(/* id 531501153, wireType 2 =*/4252009226).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Image message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Image.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Image
                         * @static
                         * @param {google.cloud.compute.v1.IImage} message Image message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Image.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Image message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Image
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Image} Image
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Image.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Image(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 302803283: {
                                        message.architecture = reader.string();
                                        break;
                                    }
                                case 381093450: {
                                        message.archiveSizeBytes = reader.int64();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 515138995: {
                                        message.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 316263735: {
                                        message.diskSizeGb = reader.int64();
                                        break;
                                    }
                                case 328751972: {
                                        message.family = reader.string();
                                        break;
                                    }
                                case 79294545: {
                                        if (!(message.guestOsFeatures && message.guestOsFeatures.length))
                                            message.guestOsFeatures = [];
                                        message.guestOsFeatures.push($root.google.cloud.compute.v1.GuestOsFeature.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 379512583: {
                                        message.imageEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 178124825: {
                                        message.labelFingerprint = reader.string();
                                        break;
                                    }
                                case 500195327: {
                                        if (message.labels === $util.emptyObject)
                                            message.labels = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.labels[key] = value;
                                        break;
                                    }
                                case 45482664: {
                                        if (!(message.licenseCodes && message.licenseCodes.length))
                                            message.licenseCodes = [];
                                        if ((tag & 7) === 2) {
                                            var end2 = reader.uint32() + reader.pos;
                                            while (reader.pos < end2)
                                                message.licenseCodes.push(reader.int64());
                                        } else
                                            message.licenseCodes.push(reader.int64());
                                        break;
                                    }
                                case 337642578: {
                                        if (!(message.licenses && message.licenses.length))
                                            message.licenses = [];
                                        message.licenses.push(reader.string());
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 503113556: {
                                        message.rawDisk = $root.google.cloud.compute.v1.RawDisk.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 480964267: {
                                        message.satisfiesPzs = reader.bool();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 192356867: {
                                        message.shieldedInstanceInitialState = $root.google.cloud.compute.v1.InitialStateConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 451753793: {
                                        message.sourceDisk = reader.string();
                                        break;
                                    }
                                case 531501153: {
                                        message.sourceDiskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 454190809: {
                                        message.sourceDiskId = reader.string();
                                        break;
                                    }
                                case 50443319: {
                                        message.sourceImage = reader.string();
                                        break;
                                    }
                                case 381503659: {
                                        message.sourceImageEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 55328291: {
                                        message.sourceImageId = reader.string();
                                        break;
                                    }
                                case 126061928: {
                                        message.sourceSnapshot = reader.string();
                                        break;
                                    }
                                case 303679322: {
                                        message.sourceSnapshotEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 98962258: {
                                        message.sourceSnapshotId = reader.string();
                                        break;
                                    }
                                case 452245726: {
                                        message.sourceType = reader.string();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                case 328005274: {
                                        if (!(message.storageLocations && message.storageLocations.length))
                                            message.storageLocations = [];
                                        message.storageLocations.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Image message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Image
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Image} Image
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Image.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Image message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Image
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Image.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.architecture != null && message.hasOwnProperty("architecture")) {
                                properties._architecture = 1;
                                if (!$util.isString(message.architecture))
                                    return "architecture: string expected";
                            }
                            if (message.archiveSizeBytes != null && message.hasOwnProperty("archiveSizeBytes")) {
                                properties._archiveSizeBytes = 1;
                                if (!$util.isInteger(message.archiveSizeBytes) && !(message.archiveSizeBytes && $util.isInteger(message.archiveSizeBytes.low) && $util.isInteger(message.archiveSizeBytes.high)))
                                    return "archiveSizeBytes: integer|Long expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.deprecated != null && message.hasOwnProperty("deprecated")) {
                                properties._deprecated = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.DeprecationStatus.verify(message.deprecated);
                                    if (error)
                                        return "deprecated." + error;
                                }
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.diskSizeGb != null && message.hasOwnProperty("diskSizeGb")) {
                                properties._diskSizeGb = 1;
                                if (!$util.isInteger(message.diskSizeGb) && !(message.diskSizeGb && $util.isInteger(message.diskSizeGb.low) && $util.isInteger(message.diskSizeGb.high)))
                                    return "diskSizeGb: integer|Long expected";
                            }
                            if (message.family != null && message.hasOwnProperty("family")) {
                                properties._family = 1;
                                if (!$util.isString(message.family))
                                    return "family: string expected";
                            }
                            if (message.guestOsFeatures != null && message.hasOwnProperty("guestOsFeatures")) {
                                if (!Array.isArray(message.guestOsFeatures))
                                    return "guestOsFeatures: array expected";
                                for (var i = 0; i < message.guestOsFeatures.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.GuestOsFeature.verify(message.guestOsFeatures[i]);
                                    if (error)
                                        return "guestOsFeatures." + error;
                                }
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.imageEncryptionKey != null && message.hasOwnProperty("imageEncryptionKey")) {
                                properties._imageEncryptionKey = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.CustomerEncryptionKey.verify(message.imageEncryptionKey);
                                    if (error)
                                        return "imageEncryptionKey." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                properties._labelFingerprint = 1;
                                if (!$util.isString(message.labelFingerprint))
                                    return "labelFingerprint: string expected";
                            }
                            if (message.labels != null && message.hasOwnProperty("labels")) {
                                if (!$util.isObject(message.labels))
                                    return "labels: object expected";
                                var key = Object.keys(message.labels);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.labels[key[i]]))
                                        return "labels: string{k:string} expected";
                            }
                            if (message.licenseCodes != null && message.hasOwnProperty("licenseCodes")) {
                                if (!Array.isArray(message.licenseCodes))
                                    return "licenseCodes: array expected";
                                for (var i = 0; i < message.licenseCodes.length; ++i)
                                    if (!$util.isInteger(message.licenseCodes[i]) && !(message.licenseCodes[i] && $util.isInteger(message.licenseCodes[i].low) && $util.isInteger(message.licenseCodes[i].high)))
                                        return "licenseCodes: integer|Long[] expected";
                            }
                            if (message.licenses != null && message.hasOwnProperty("licenses")) {
                                if (!Array.isArray(message.licenses))
                                    return "licenses: array expected";
                                for (var i = 0; i < message.licenses.length; ++i)
                                    if (!$util.isString(message.licenses[i]))
                                        return "licenses: string[] expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.rawDisk != null && message.hasOwnProperty("rawDisk")) {
                                properties._rawDisk = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.RawDisk.verify(message.rawDisk);
                                    if (error)
                                        return "rawDisk." + error;
                                }
                            }
                            if (message.satisfiesPzs != null && message.hasOwnProperty("satisfiesPzs")) {
                                properties._satisfiesPzs = 1;
                                if (typeof message.satisfiesPzs !== "boolean")
                                    return "satisfiesPzs: boolean expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.shieldedInstanceInitialState != null && message.hasOwnProperty("shieldedInstanceInitialState")) {
                                properties._shieldedInstanceInitialState = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InitialStateConfig.verify(message.shieldedInstanceInitialState);
                                    if (error)
                                        return "shieldedInstanceInitialState." + error;
                                }
                            }
                            if (message.sourceDisk != null && message.hasOwnProperty("sourceDisk")) {
                                properties._sourceDisk = 1;
                                if (!$util.isString(message.sourceDisk))
                                    return "sourceDisk: string expected";
                            }
                            if (message.sourceDiskEncryptionKey != null && message.hasOwnProperty("sourceDiskEncryptionKey")) {
                                properties._sourceDiskEncryptionKey = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.CustomerEncryptionKey.verify(message.sourceDiskEncryptionKey);
                                    if (error)
                                        return "sourceDiskEncryptionKey." + error;
                                }
                            }
                            if (message.sourceDiskId != null && message.hasOwnProperty("sourceDiskId")) {
                                properties._sourceDiskId = 1;
                                if (!$util.isString(message.sourceDiskId))
                                    return "sourceDiskId: string expected";
                            }
                            if (message.sourceImage != null && message.hasOwnProperty("sourceImage")) {
                                properties._sourceImage = 1;
                                if (!$util.isString(message.sourceImage))
                                    return "sourceImage: string expected";
                            }
                            if (message.sourceImageEncryptionKey != null && message.hasOwnProperty("sourceImageEncryptionKey")) {
                                properties._sourceImageEncryptionKey = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.CustomerEncryptionKey.verify(message.sourceImageEncryptionKey);
                                    if (error)
                                        return "sourceImageEncryptionKey." + error;
                                }
                            }
                            if (message.sourceImageId != null && message.hasOwnProperty("sourceImageId")) {
                                properties._sourceImageId = 1;
                                if (!$util.isString(message.sourceImageId))
                                    return "sourceImageId: string expected";
                            }
                            if (message.sourceSnapshot != null && message.hasOwnProperty("sourceSnapshot")) {
                                properties._sourceSnapshot = 1;
                                if (!$util.isString(message.sourceSnapshot))
                                    return "sourceSnapshot: string expected";
                            }
                            if (message.sourceSnapshotEncryptionKey != null && message.hasOwnProperty("sourceSnapshotEncryptionKey")) {
                                properties._sourceSnapshotEncryptionKey = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.CustomerEncryptionKey.verify(message.sourceSnapshotEncryptionKey);
                                    if (error)
                                        return "sourceSnapshotEncryptionKey." + error;
                                }
                            }
                            if (message.sourceSnapshotId != null && message.hasOwnProperty("sourceSnapshotId")) {
                                properties._sourceSnapshotId = 1;
                                if (!$util.isString(message.sourceSnapshotId))
                                    return "sourceSnapshotId: string expected";
                            }
                            if (message.sourceType != null && message.hasOwnProperty("sourceType")) {
                                properties._sourceType = 1;
                                if (!$util.isString(message.sourceType))
                                    return "sourceType: string expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            if (message.storageLocations != null && message.hasOwnProperty("storageLocations")) {
                                if (!Array.isArray(message.storageLocations))
                                    return "storageLocations: array expected";
                                for (var i = 0; i < message.storageLocations.length; ++i)
                                    if (!$util.isString(message.storageLocations[i]))
                                        return "storageLocations: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an Image message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Image
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Image} Image
                         */
                        Image.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Image)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Image();
                            if (object.architecture != null)
                                message.architecture = String(object.architecture);
                            if (object.archiveSizeBytes != null)
                                if ($util.Long)
                                    (message.archiveSizeBytes = $util.Long.fromValue(object.archiveSizeBytes)).unsigned = false;
                                else if (typeof object.archiveSizeBytes === "string")
                                    message.archiveSizeBytes = parseInt(object.archiveSizeBytes, 10);
                                else if (typeof object.archiveSizeBytes === "number")
                                    message.archiveSizeBytes = object.archiveSizeBytes;
                                else if (typeof object.archiveSizeBytes === "object")
                                    message.archiveSizeBytes = new $util.LongBits(object.archiveSizeBytes.low >>> 0, object.archiveSizeBytes.high >>> 0).toNumber();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.deprecated != null) {
                                if (typeof object.deprecated !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Image.deprecated: object expected");
                                message.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.fromObject(object.deprecated);
                            }
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.diskSizeGb != null)
                                if ($util.Long)
                                    (message.diskSizeGb = $util.Long.fromValue(object.diskSizeGb)).unsigned = false;
                                else if (typeof object.diskSizeGb === "string")
                                    message.diskSizeGb = parseInt(object.diskSizeGb, 10);
                                else if (typeof object.diskSizeGb === "number")
                                    message.diskSizeGb = object.diskSizeGb;
                                else if (typeof object.diskSizeGb === "object")
                                    message.diskSizeGb = new $util.LongBits(object.diskSizeGb.low >>> 0, object.diskSizeGb.high >>> 0).toNumber();
                            if (object.family != null)
                                message.family = String(object.family);
                            if (object.guestOsFeatures) {
                                if (!Array.isArray(object.guestOsFeatures))
                                    throw TypeError(".google.cloud.compute.v1.Image.guestOsFeatures: array expected");
                                message.guestOsFeatures = [];
                                for (var i = 0; i < object.guestOsFeatures.length; ++i) {
                                    if (typeof object.guestOsFeatures[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Image.guestOsFeatures: object expected");
                                    message.guestOsFeatures[i] = $root.google.cloud.compute.v1.GuestOsFeature.fromObject(object.guestOsFeatures[i]);
                                }
                            }
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.imageEncryptionKey != null) {
                                if (typeof object.imageEncryptionKey !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Image.imageEncryptionKey: object expected");
                                message.imageEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.fromObject(object.imageEncryptionKey);
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.labelFingerprint != null)
                                message.labelFingerprint = String(object.labelFingerprint);
                            if (object.labels) {
                                if (typeof object.labels !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Image.labels: object expected");
                                message.labels = {};
                                for (var keys = Object.keys(object.labels), i = 0; i < keys.length; ++i)
                                    message.labels[keys[i]] = String(object.labels[keys[i]]);
                            }
                            if (object.licenseCodes) {
                                if (!Array.isArray(object.licenseCodes))
                                    throw TypeError(".google.cloud.compute.v1.Image.licenseCodes: array expected");
                                message.licenseCodes = [];
                                for (var i = 0; i < object.licenseCodes.length; ++i)
                                    if ($util.Long)
                                        (message.licenseCodes[i] = $util.Long.fromValue(object.licenseCodes[i])).unsigned = false;
                                    else if (typeof object.licenseCodes[i] === "string")
                                        message.licenseCodes[i] = parseInt(object.licenseCodes[i], 10);
                                    else if (typeof object.licenseCodes[i] === "number")
                                        message.licenseCodes[i] = object.licenseCodes[i];
                                    else if (typeof object.licenseCodes[i] === "object")
                                        message.licenseCodes[i] = new $util.LongBits(object.licenseCodes[i].low >>> 0, object.licenseCodes[i].high >>> 0).toNumber();
                            }
                            if (object.licenses) {
                                if (!Array.isArray(object.licenses))
                                    throw TypeError(".google.cloud.compute.v1.Image.licenses: array expected");
                                message.licenses = [];
                                for (var i = 0; i < object.licenses.length; ++i)
                                    message.licenses[i] = String(object.licenses[i]);
                            }
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.rawDisk != null) {
                                if (typeof object.rawDisk !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Image.rawDisk: object expected");
                                message.rawDisk = $root.google.cloud.compute.v1.RawDisk.fromObject(object.rawDisk);
                            }
                            if (object.satisfiesPzs != null)
                                message.satisfiesPzs = Boolean(object.satisfiesPzs);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.shieldedInstanceInitialState != null) {
                                if (typeof object.shieldedInstanceInitialState !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Image.shieldedInstanceInitialState: object expected");
                                message.shieldedInstanceInitialState = $root.google.cloud.compute.v1.InitialStateConfig.fromObject(object.shieldedInstanceInitialState);
                            }
                            if (object.sourceDisk != null)
                                message.sourceDisk = String(object.sourceDisk);
                            if (object.sourceDiskEncryptionKey != null) {
                                if (typeof object.sourceDiskEncryptionKey !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Image.sourceDiskEncryptionKey: object expected");
                                message.sourceDiskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.fromObject(object.sourceDiskEncryptionKey);
                            }
                            if (object.sourceDiskId != null)
                                message.sourceDiskId = String(object.sourceDiskId);
                            if (object.sourceImage != null)
                                message.sourceImage = String(object.sourceImage);
                            if (object.sourceImageEncryptionKey != null) {
                                if (typeof object.sourceImageEncryptionKey !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Image.sourceImageEncryptionKey: object expected");
                                message.sourceImageEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.fromObject(object.sourceImageEncryptionKey);
                            }
                            if (object.sourceImageId != null)
                                message.sourceImageId = String(object.sourceImageId);
                            if (object.sourceSnapshot != null)
                                message.sourceSnapshot = String(object.sourceSnapshot);
                            if (object.sourceSnapshotEncryptionKey != null) {
                                if (typeof object.sourceSnapshotEncryptionKey !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Image.sourceSnapshotEncryptionKey: object expected");
                                message.sourceSnapshotEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.fromObject(object.sourceSnapshotEncryptionKey);
                            }
                            if (object.sourceSnapshotId != null)
                                message.sourceSnapshotId = String(object.sourceSnapshotId);
                            if (object.sourceType != null)
                                message.sourceType = String(object.sourceType);
                            if (object.status != null)
                                message.status = String(object.status);
                            if (object.storageLocations) {
                                if (!Array.isArray(object.storageLocations))
                                    throw TypeError(".google.cloud.compute.v1.Image.storageLocations: array expected");
                                message.storageLocations = [];
                                for (var i = 0; i < object.storageLocations.length; ++i)
                                    message.storageLocations[i] = String(object.storageLocations[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Image message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Image
                         * @static
                         * @param {google.cloud.compute.v1.Image} message Image
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Image.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.licenseCodes = [];
                                object.guestOsFeatures = [];
                                object.storageLocations = [];
                                object.licenses = [];
                            }
                            if (options.objects || options.defaults)
                                object.labels = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.licenseCodes && message.licenseCodes.length) {
                                object.licenseCodes = [];
                                for (var j = 0; j < message.licenseCodes.length; ++j)
                                    if (typeof message.licenseCodes[j] === "number")
                                        object.licenseCodes[j] = options.longs === String ? String(message.licenseCodes[j]) : message.licenseCodes[j];
                                    else
                                        object.licenseCodes[j] = options.longs === String ? $util.Long.prototype.toString.call(message.licenseCodes[j]) : options.longs === Number ? new $util.LongBits(message.licenseCodes[j].low >>> 0, message.licenseCodes[j].high >>> 0).toNumber() : message.licenseCodes[j];
                            }
                            if (message.sourceImage != null && message.hasOwnProperty("sourceImage")) {
                                object.sourceImage = message.sourceImage;
                                if (options.oneofs)
                                    object._sourceImage = "sourceImage";
                            }
                            if (message.sourceImageId != null && message.hasOwnProperty("sourceImageId")) {
                                object.sourceImageId = message.sourceImageId;
                                if (options.oneofs)
                                    object._sourceImageId = "sourceImageId";
                            }
                            if (message.guestOsFeatures && message.guestOsFeatures.length) {
                                object.guestOsFeatures = [];
                                for (var j = 0; j < message.guestOsFeatures.length; ++j)
                                    object.guestOsFeatures[j] = $root.google.cloud.compute.v1.GuestOsFeature.toObject(message.guestOsFeatures[j], options);
                            }
                            if (message.sourceSnapshotId != null && message.hasOwnProperty("sourceSnapshotId")) {
                                object.sourceSnapshotId = message.sourceSnapshotId;
                                if (options.oneofs)
                                    object._sourceSnapshotId = "sourceSnapshotId";
                            }
                            if (message.sourceSnapshot != null && message.hasOwnProperty("sourceSnapshot")) {
                                object.sourceSnapshot = message.sourceSnapshot;
                                if (options.oneofs)
                                    object._sourceSnapshot = "sourceSnapshot";
                            }
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                object.labelFingerprint = message.labelFingerprint;
                                if (options.oneofs)
                                    object._labelFingerprint = "labelFingerprint";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.shieldedInstanceInitialState != null && message.hasOwnProperty("shieldedInstanceInitialState")) {
                                object.shieldedInstanceInitialState = $root.google.cloud.compute.v1.InitialStateConfig.toObject(message.shieldedInstanceInitialState, options);
                                if (options.oneofs)
                                    object._shieldedInstanceInitialState = "shieldedInstanceInitialState";
                            }
                            if (message.architecture != null && message.hasOwnProperty("architecture")) {
                                object.architecture = message.architecture;
                                if (options.oneofs)
                                    object._architecture = "architecture";
                            }
                            if (message.sourceSnapshotEncryptionKey != null && message.hasOwnProperty("sourceSnapshotEncryptionKey")) {
                                object.sourceSnapshotEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.toObject(message.sourceSnapshotEncryptionKey, options);
                                if (options.oneofs)
                                    object._sourceSnapshotEncryptionKey = "sourceSnapshotEncryptionKey";
                            }
                            if (message.diskSizeGb != null && message.hasOwnProperty("diskSizeGb")) {
                                if (typeof message.diskSizeGb === "number")
                                    object.diskSizeGb = options.longs === String ? String(message.diskSizeGb) : message.diskSizeGb;
                                else
                                    object.diskSizeGb = options.longs === String ? $util.Long.prototype.toString.call(message.diskSizeGb) : options.longs === Number ? new $util.LongBits(message.diskSizeGb.low >>> 0, message.diskSizeGb.high >>> 0).toNumber() : message.diskSizeGb;
                                if (options.oneofs)
                                    object._diskSizeGb = "diskSizeGb";
                            }
                            if (message.storageLocations && message.storageLocations.length) {
                                object.storageLocations = [];
                                for (var j = 0; j < message.storageLocations.length; ++j)
                                    object.storageLocations[j] = message.storageLocations[j];
                            }
                            if (message.family != null && message.hasOwnProperty("family")) {
                                object.family = message.family;
                                if (options.oneofs)
                                    object._family = "family";
                            }
                            if (message.licenses && message.licenses.length) {
                                object.licenses = [];
                                for (var j = 0; j < message.licenses.length; ++j)
                                    object.licenses[j] = message.licenses[j];
                            }
                            if (message.imageEncryptionKey != null && message.hasOwnProperty("imageEncryptionKey")) {
                                object.imageEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.toObject(message.imageEncryptionKey, options);
                                if (options.oneofs)
                                    object._imageEncryptionKey = "imageEncryptionKey";
                            }
                            if (message.archiveSizeBytes != null && message.hasOwnProperty("archiveSizeBytes")) {
                                if (typeof message.archiveSizeBytes === "number")
                                    object.archiveSizeBytes = options.longs === String ? String(message.archiveSizeBytes) : message.archiveSizeBytes;
                                else
                                    object.archiveSizeBytes = options.longs === String ? $util.Long.prototype.toString.call(message.archiveSizeBytes) : options.longs === Number ? new $util.LongBits(message.archiveSizeBytes.low >>> 0, message.archiveSizeBytes.high >>> 0).toNumber() : message.archiveSizeBytes;
                                if (options.oneofs)
                                    object._archiveSizeBytes = "archiveSizeBytes";
                            }
                            if (message.sourceImageEncryptionKey != null && message.hasOwnProperty("sourceImageEncryptionKey")) {
                                object.sourceImageEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.toObject(message.sourceImageEncryptionKey, options);
                                if (options.oneofs)
                                    object._sourceImageEncryptionKey = "sourceImageEncryptionKey";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.sourceDisk != null && message.hasOwnProperty("sourceDisk")) {
                                object.sourceDisk = message.sourceDisk;
                                if (options.oneofs)
                                    object._sourceDisk = "sourceDisk";
                            }
                            if (message.sourceType != null && message.hasOwnProperty("sourceType")) {
                                object.sourceType = message.sourceType;
                                if (options.oneofs)
                                    object._sourceType = "sourceType";
                            }
                            if (message.sourceDiskId != null && message.hasOwnProperty("sourceDiskId")) {
                                object.sourceDiskId = message.sourceDiskId;
                                if (options.oneofs)
                                    object._sourceDiskId = "sourceDiskId";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.satisfiesPzs != null && message.hasOwnProperty("satisfiesPzs")) {
                                object.satisfiesPzs = message.satisfiesPzs;
                                if (options.oneofs)
                                    object._satisfiesPzs = "satisfiesPzs";
                            }
                            var keys2;
                            if (message.labels && (keys2 = Object.keys(message.labels)).length) {
                                object.labels = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.labels[keys2[j]] = message.labels[keys2[j]];
                            }
                            if (message.rawDisk != null && message.hasOwnProperty("rawDisk")) {
                                object.rawDisk = $root.google.cloud.compute.v1.RawDisk.toObject(message.rawDisk, options);
                                if (options.oneofs)
                                    object._rawDisk = "rawDisk";
                            }
                            if (message.deprecated != null && message.hasOwnProperty("deprecated")) {
                                object.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.toObject(message.deprecated, options);
                                if (options.oneofs)
                                    object._deprecated = "deprecated";
                            }
                            if (message.sourceDiskEncryptionKey != null && message.hasOwnProperty("sourceDiskEncryptionKey")) {
                                object.sourceDiskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.toObject(message.sourceDiskEncryptionKey, options);
                                if (options.oneofs)
                                    object._sourceDiskEncryptionKey = "sourceDiskEncryptionKey";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Image to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Image
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Image.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Image
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Image
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Image.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Image";
                        };
    
                        /**
                         * Architecture enum.
                         * @name google.cloud.compute.v1.Image.Architecture
                         * @enum {number}
                         * @property {number} UNDEFINED_ARCHITECTURE=0 UNDEFINED_ARCHITECTURE value
                         * @property {number} ARCHITECTURE_UNSPECIFIED=394750507 ARCHITECTURE_UNSPECIFIED value
                         * @property {number} ARM64=62547450 ARM64 value
                         * @property {number} X86_64=425300551 X86_64 value
                         */
                        Image.Architecture = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ARCHITECTURE"] = 0;
                            values[valuesById[394750507] = "ARCHITECTURE_UNSPECIFIED"] = 394750507;
                            values[valuesById[62547450] = "ARM64"] = 62547450;
                            values[valuesById[425300551] = "X86_64"] = 425300551;
                            return values;
                        })();
    
                        /**
                         * SourceType enum.
                         * @name google.cloud.compute.v1.Image.SourceType
                         * @enum {number}
                         * @property {number} UNDEFINED_SOURCE_TYPE=0 UNDEFINED_SOURCE_TYPE value
                         * @property {number} RAW=80904 RAW value
                         */
                        Image.SourceType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_SOURCE_TYPE"] = 0;
                            values[valuesById[80904] = "RAW"] = 80904;
                            return values;
                        })();
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.Image.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} DELETING=528602024 DELETING value
                         * @property {number} FAILED=455706685 FAILED value
                         * @property {number} PENDING=35394935 PENDING value
                         * @property {number} READY=77848963 READY value
                         */
                        Image.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[528602024] = "DELETING"] = 528602024;
                            values[valuesById[455706685] = "FAILED"] = 455706685;
                            values[valuesById[35394935] = "PENDING"] = 35394935;
                            values[valuesById[77848963] = "READY"] = 77848963;
                            return values;
                        })();
    
                        return Image;
                    })();
    
                    v1.ImageFamilyView = (function() {
    
                        /**
                         * Properties of an ImageFamilyView.
                         * @memberof google.cloud.compute.v1
                         * @interface IImageFamilyView
                         * @property {google.cloud.compute.v1.IImage|null} [image] ImageFamilyView image
                         */
    
                        /**
                         * Constructs a new ImageFamilyView.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an ImageFamilyView.
                         * @implements IImageFamilyView
                         * @constructor
                         * @param {google.cloud.compute.v1.IImageFamilyView=} [properties] Properties to set
                         */
                        function ImageFamilyView(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ImageFamilyView image.
                         * @member {google.cloud.compute.v1.IImage|null|undefined} image
                         * @memberof google.cloud.compute.v1.ImageFamilyView
                         * @instance
                         */
                        ImageFamilyView.prototype.image = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ImageFamilyView _image.
                         * @member {"image"|undefined} _image
                         * @memberof google.cloud.compute.v1.ImageFamilyView
                         * @instance
                         */
                        Object.defineProperty(ImageFamilyView.prototype, "_image", {
                            get: $util.oneOfGetter($oneOfFields = ["image"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ImageFamilyView instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ImageFamilyView
                         * @static
                         * @param {google.cloud.compute.v1.IImageFamilyView=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ImageFamilyView} ImageFamilyView instance
                         */
                        ImageFamilyView.create = function create(properties) {
                            return new ImageFamilyView(properties);
                        };
    
                        /**
                         * Encodes the specified ImageFamilyView message. Does not implicitly {@link google.cloud.compute.v1.ImageFamilyView.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ImageFamilyView
                         * @static
                         * @param {google.cloud.compute.v1.IImageFamilyView} message ImageFamilyView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ImageFamilyView.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.image != null && Object.hasOwnProperty.call(message, "image"))
                                $root.google.cloud.compute.v1.Image.encode(message.image, writer.uint32(/* id 100313435, wireType 2 =*/802507482).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ImageFamilyView message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ImageFamilyView.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ImageFamilyView
                         * @static
                         * @param {google.cloud.compute.v1.IImageFamilyView} message ImageFamilyView message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ImageFamilyView.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ImageFamilyView message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ImageFamilyView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ImageFamilyView} ImageFamilyView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ImageFamilyView.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ImageFamilyView();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 100313435: {
                                        message.image = $root.google.cloud.compute.v1.Image.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ImageFamilyView message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ImageFamilyView
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ImageFamilyView} ImageFamilyView
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ImageFamilyView.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ImageFamilyView message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ImageFamilyView
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ImageFamilyView.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.image != null && message.hasOwnProperty("image")) {
                                properties._image = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Image.verify(message.image);
                                    if (error)
                                        return "image." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an ImageFamilyView message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ImageFamilyView
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ImageFamilyView} ImageFamilyView
                         */
                        ImageFamilyView.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ImageFamilyView)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ImageFamilyView();
                            if (object.image != null) {
                                if (typeof object.image !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ImageFamilyView.image: object expected");
                                message.image = $root.google.cloud.compute.v1.Image.fromObject(object.image);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ImageFamilyView message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ImageFamilyView
                         * @static
                         * @param {google.cloud.compute.v1.ImageFamilyView} message ImageFamilyView
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ImageFamilyView.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.image != null && message.hasOwnProperty("image")) {
                                object.image = $root.google.cloud.compute.v1.Image.toObject(message.image, options);
                                if (options.oneofs)
                                    object._image = "image";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ImageFamilyView to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ImageFamilyView
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ImageFamilyView.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ImageFamilyView
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ImageFamilyView
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ImageFamilyView.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ImageFamilyView";
                        };
    
                        return ImageFamilyView;
                    })();
    
                    v1.ImageList = (function() {
    
                        /**
                         * Properties of an ImageList.
                         * @memberof google.cloud.compute.v1
                         * @interface IImageList
                         * @property {string|null} [id] ImageList id
                         * @property {Array.<google.cloud.compute.v1.IImage>|null} [items] ImageList items
                         * @property {string|null} [kind] ImageList kind
                         * @property {string|null} [nextPageToken] ImageList nextPageToken
                         * @property {string|null} [selfLink] ImageList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] ImageList warning
                         */
    
                        /**
                         * Constructs a new ImageList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an ImageList.
                         * @implements IImageList
                         * @constructor
                         * @param {google.cloud.compute.v1.IImageList=} [properties] Properties to set
                         */
                        function ImageList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ImageList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.ImageList
                         * @instance
                         */
                        ImageList.prototype.id = null;
    
                        /**
                         * ImageList items.
                         * @member {Array.<google.cloud.compute.v1.IImage>} items
                         * @memberof google.cloud.compute.v1.ImageList
                         * @instance
                         */
                        ImageList.prototype.items = $util.emptyArray;
    
                        /**
                         * ImageList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.ImageList
                         * @instance
                         */
                        ImageList.prototype.kind = null;
    
                        /**
                         * ImageList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.ImageList
                         * @instance
                         */
                        ImageList.prototype.nextPageToken = null;
    
                        /**
                         * ImageList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.ImageList
                         * @instance
                         */
                        ImageList.prototype.selfLink = null;
    
                        /**
                         * ImageList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.ImageList
                         * @instance
                         */
                        ImageList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ImageList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.ImageList
                         * @instance
                         */
                        Object.defineProperty(ImageList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ImageList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.ImageList
                         * @instance
                         */
                        Object.defineProperty(ImageList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ImageList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.ImageList
                         * @instance
                         */
                        Object.defineProperty(ImageList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ImageList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.ImageList
                         * @instance
                         */
                        Object.defineProperty(ImageList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ImageList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.ImageList
                         * @instance
                         */
                        Object.defineProperty(ImageList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ImageList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ImageList
                         * @static
                         * @param {google.cloud.compute.v1.IImageList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ImageList} ImageList instance
                         */
                        ImageList.create = function create(properties) {
                            return new ImageList(properties);
                        };
    
                        /**
                         * Encodes the specified ImageList message. Does not implicitly {@link google.cloud.compute.v1.ImageList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ImageList
                         * @static
                         * @param {google.cloud.compute.v1.IImageList} message ImageList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ImageList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Image.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ImageList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ImageList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ImageList
                         * @static
                         * @param {google.cloud.compute.v1.IImageList} message ImageList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ImageList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an ImageList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ImageList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ImageList} ImageList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ImageList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ImageList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Image.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an ImageList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ImageList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ImageList} ImageList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ImageList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an ImageList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ImageList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ImageList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Image.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an ImageList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ImageList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ImageList} ImageList
                         */
                        ImageList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ImageList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ImageList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.ImageList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ImageList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Image.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ImageList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an ImageList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ImageList
                         * @static
                         * @param {google.cloud.compute.v1.ImageList} message ImageList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ImageList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Image.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ImageList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ImageList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ImageList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ImageList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ImageList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ImageList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ImageList";
                        };
    
                        return ImageList;
                    })();
    
                    v1.InitialStateConfig = (function() {
    
                        /**
                         * Properties of an InitialStateConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface IInitialStateConfig
                         * @property {Array.<google.cloud.compute.v1.IFileContentBuffer>|null} [dbs] InitialStateConfig dbs
                         * @property {Array.<google.cloud.compute.v1.IFileContentBuffer>|null} [dbxs] InitialStateConfig dbxs
                         * @property {Array.<google.cloud.compute.v1.IFileContentBuffer>|null} [keks] InitialStateConfig keks
                         * @property {google.cloud.compute.v1.IFileContentBuffer|null} [pk] InitialStateConfig pk
                         */
    
                        /**
                         * Constructs a new InitialStateConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InitialStateConfig.
                         * @implements IInitialStateConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.IInitialStateConfig=} [properties] Properties to set
                         */
                        function InitialStateConfig(properties) {
                            this.dbs = [];
                            this.dbxs = [];
                            this.keks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InitialStateConfig dbs.
                         * @member {Array.<google.cloud.compute.v1.IFileContentBuffer>} dbs
                         * @memberof google.cloud.compute.v1.InitialStateConfig
                         * @instance
                         */
                        InitialStateConfig.prototype.dbs = $util.emptyArray;
    
                        /**
                         * InitialStateConfig dbxs.
                         * @member {Array.<google.cloud.compute.v1.IFileContentBuffer>} dbxs
                         * @memberof google.cloud.compute.v1.InitialStateConfig
                         * @instance
                         */
                        InitialStateConfig.prototype.dbxs = $util.emptyArray;
    
                        /**
                         * InitialStateConfig keks.
                         * @member {Array.<google.cloud.compute.v1.IFileContentBuffer>} keks
                         * @memberof google.cloud.compute.v1.InitialStateConfig
                         * @instance
                         */
                        InitialStateConfig.prototype.keks = $util.emptyArray;
    
                        /**
                         * InitialStateConfig pk.
                         * @member {google.cloud.compute.v1.IFileContentBuffer|null|undefined} pk
                         * @memberof google.cloud.compute.v1.InitialStateConfig
                         * @instance
                         */
                        InitialStateConfig.prototype.pk = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InitialStateConfig _pk.
                         * @member {"pk"|undefined} _pk
                         * @memberof google.cloud.compute.v1.InitialStateConfig
                         * @instance
                         */
                        Object.defineProperty(InitialStateConfig.prototype, "_pk", {
                            get: $util.oneOfGetter($oneOfFields = ["pk"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InitialStateConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InitialStateConfig
                         * @static
                         * @param {google.cloud.compute.v1.IInitialStateConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InitialStateConfig} InitialStateConfig instance
                         */
                        InitialStateConfig.create = function create(properties) {
                            return new InitialStateConfig(properties);
                        };
    
                        /**
                         * Encodes the specified InitialStateConfig message. Does not implicitly {@link google.cloud.compute.v1.InitialStateConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InitialStateConfig
                         * @static
                         * @param {google.cloud.compute.v1.IInitialStateConfig} message InitialStateConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InitialStateConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pk != null && Object.hasOwnProperty.call(message, "pk"))
                                $root.google.cloud.compute.v1.FileContentBuffer.encode(message.pk, writer.uint32(/* id 3579, wireType 2 =*/28634).fork()).ldelim();
                            if (message.dbs != null && message.dbs.length)
                                for (var i = 0; i < message.dbs.length; ++i)
                                    $root.google.cloud.compute.v1.FileContentBuffer.encode(message.dbs[i], writer.uint32(/* id 99253, wireType 2 =*/794026).fork()).ldelim();
                            if (message.dbxs != null && message.dbxs.length)
                                for (var i = 0; i < message.dbxs.length; ++i)
                                    $root.google.cloud.compute.v1.FileContentBuffer.encode(message.dbxs[i], writer.uint32(/* id 3077113, wireType 2 =*/24616906).fork()).ldelim();
                            if (message.keks != null && message.keks.length)
                                for (var i = 0; i < message.keks.length; ++i)
                                    $root.google.cloud.compute.v1.FileContentBuffer.encode(message.keks[i], writer.uint32(/* id 3288130, wireType 2 =*/26305042).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InitialStateConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InitialStateConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InitialStateConfig
                         * @static
                         * @param {google.cloud.compute.v1.IInitialStateConfig} message InitialStateConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InitialStateConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InitialStateConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InitialStateConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InitialStateConfig} InitialStateConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InitialStateConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InitialStateConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 99253: {
                                        if (!(message.dbs && message.dbs.length))
                                            message.dbs = [];
                                        message.dbs.push($root.google.cloud.compute.v1.FileContentBuffer.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3077113: {
                                        if (!(message.dbxs && message.dbxs.length))
                                            message.dbxs = [];
                                        message.dbxs.push($root.google.cloud.compute.v1.FileContentBuffer.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3288130: {
                                        if (!(message.keks && message.keks.length))
                                            message.keks = [];
                                        message.keks.push($root.google.cloud.compute.v1.FileContentBuffer.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3579: {
                                        message.pk = $root.google.cloud.compute.v1.FileContentBuffer.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InitialStateConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InitialStateConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InitialStateConfig} InitialStateConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InitialStateConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InitialStateConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InitialStateConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InitialStateConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.dbs != null && message.hasOwnProperty("dbs")) {
                                if (!Array.isArray(message.dbs))
                                    return "dbs: array expected";
                                for (var i = 0; i < message.dbs.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.FileContentBuffer.verify(message.dbs[i]);
                                    if (error)
                                        return "dbs." + error;
                                }
                            }
                            if (message.dbxs != null && message.hasOwnProperty("dbxs")) {
                                if (!Array.isArray(message.dbxs))
                                    return "dbxs: array expected";
                                for (var i = 0; i < message.dbxs.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.FileContentBuffer.verify(message.dbxs[i]);
                                    if (error)
                                        return "dbxs." + error;
                                }
                            }
                            if (message.keks != null && message.hasOwnProperty("keks")) {
                                if (!Array.isArray(message.keks))
                                    return "keks: array expected";
                                for (var i = 0; i < message.keks.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.FileContentBuffer.verify(message.keks[i]);
                                    if (error)
                                        return "keks." + error;
                                }
                            }
                            if (message.pk != null && message.hasOwnProperty("pk")) {
                                properties._pk = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.FileContentBuffer.verify(message.pk);
                                    if (error)
                                        return "pk." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InitialStateConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InitialStateConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InitialStateConfig} InitialStateConfig
                         */
                        InitialStateConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InitialStateConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InitialStateConfig();
                            if (object.dbs) {
                                if (!Array.isArray(object.dbs))
                                    throw TypeError(".google.cloud.compute.v1.InitialStateConfig.dbs: array expected");
                                message.dbs = [];
                                for (var i = 0; i < object.dbs.length; ++i) {
                                    if (typeof object.dbs[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InitialStateConfig.dbs: object expected");
                                    message.dbs[i] = $root.google.cloud.compute.v1.FileContentBuffer.fromObject(object.dbs[i]);
                                }
                            }
                            if (object.dbxs) {
                                if (!Array.isArray(object.dbxs))
                                    throw TypeError(".google.cloud.compute.v1.InitialStateConfig.dbxs: array expected");
                                message.dbxs = [];
                                for (var i = 0; i < object.dbxs.length; ++i) {
                                    if (typeof object.dbxs[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InitialStateConfig.dbxs: object expected");
                                    message.dbxs[i] = $root.google.cloud.compute.v1.FileContentBuffer.fromObject(object.dbxs[i]);
                                }
                            }
                            if (object.keks) {
                                if (!Array.isArray(object.keks))
                                    throw TypeError(".google.cloud.compute.v1.InitialStateConfig.keks: array expected");
                                message.keks = [];
                                for (var i = 0; i < object.keks.length; ++i) {
                                    if (typeof object.keks[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InitialStateConfig.keks: object expected");
                                    message.keks[i] = $root.google.cloud.compute.v1.FileContentBuffer.fromObject(object.keks[i]);
                                }
                            }
                            if (object.pk != null) {
                                if (typeof object.pk !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InitialStateConfig.pk: object expected");
                                message.pk = $root.google.cloud.compute.v1.FileContentBuffer.fromObject(object.pk);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InitialStateConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InitialStateConfig
                         * @static
                         * @param {google.cloud.compute.v1.InitialStateConfig} message InitialStateConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InitialStateConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.dbs = [];
                                object.dbxs = [];
                                object.keks = [];
                            }
                            if (message.pk != null && message.hasOwnProperty("pk")) {
                                object.pk = $root.google.cloud.compute.v1.FileContentBuffer.toObject(message.pk, options);
                                if (options.oneofs)
                                    object._pk = "pk";
                            }
                            if (message.dbs && message.dbs.length) {
                                object.dbs = [];
                                for (var j = 0; j < message.dbs.length; ++j)
                                    object.dbs[j] = $root.google.cloud.compute.v1.FileContentBuffer.toObject(message.dbs[j], options);
                            }
                            if (message.dbxs && message.dbxs.length) {
                                object.dbxs = [];
                                for (var j = 0; j < message.dbxs.length; ++j)
                                    object.dbxs[j] = $root.google.cloud.compute.v1.FileContentBuffer.toObject(message.dbxs[j], options);
                            }
                            if (message.keks && message.keks.length) {
                                object.keks = [];
                                for (var j = 0; j < message.keks.length; ++j)
                                    object.keks[j] = $root.google.cloud.compute.v1.FileContentBuffer.toObject(message.keks[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InitialStateConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InitialStateConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InitialStateConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InitialStateConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InitialStateConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InitialStateConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InitialStateConfig";
                        };
    
                        return InitialStateConfig;
                    })();
    
                    v1.InsertAddressRequest = (function() {
    
                        /**
                         * Properties of an InsertAddressRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertAddressRequest
                         * @property {google.cloud.compute.v1.IAddress|null} [addressResource] InsertAddressRequest addressResource
                         * @property {string|null} [project] InsertAddressRequest project
                         * @property {string|null} [region] InsertAddressRequest region
                         * @property {string|null} [requestId] InsertAddressRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertAddressRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertAddressRequest.
                         * @implements IInsertAddressRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertAddressRequest=} [properties] Properties to set
                         */
                        function InsertAddressRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertAddressRequest addressResource.
                         * @member {google.cloud.compute.v1.IAddress|null|undefined} addressResource
                         * @memberof google.cloud.compute.v1.InsertAddressRequest
                         * @instance
                         */
                        InsertAddressRequest.prototype.addressResource = null;
    
                        /**
                         * InsertAddressRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertAddressRequest
                         * @instance
                         */
                        InsertAddressRequest.prototype.project = "";
    
                        /**
                         * InsertAddressRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertAddressRequest
                         * @instance
                         */
                        InsertAddressRequest.prototype.region = "";
    
                        /**
                         * InsertAddressRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertAddressRequest
                         * @instance
                         */
                        InsertAddressRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertAddressRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertAddressRequest
                         * @instance
                         */
                        Object.defineProperty(InsertAddressRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertAddressRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertAddressRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertAddressRequest} InsertAddressRequest instance
                         */
                        InsertAddressRequest.create = function create(properties) {
                            return new InsertAddressRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertAddressRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertAddressRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertAddressRequest} message InsertAddressRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertAddressRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.addressResource != null && Object.hasOwnProperty.call(message, "addressResource"))
                                $root.google.cloud.compute.v1.Address.encode(message.addressResource, writer.uint32(/* id 483888121, wireType 2 =*/3871104970).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertAddressRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertAddressRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertAddressRequest} message InsertAddressRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertAddressRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertAddressRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertAddressRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertAddressRequest} InsertAddressRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertAddressRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertAddressRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 483888121: {
                                        message.addressResource = $root.google.cloud.compute.v1.Address.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertAddressRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertAddressRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertAddressRequest} InsertAddressRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertAddressRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertAddressRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertAddressRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertAddressRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.addressResource != null && message.hasOwnProperty("addressResource")) {
                                var error = $root.google.cloud.compute.v1.Address.verify(message.addressResource);
                                if (error)
                                    return "addressResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertAddressRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertAddressRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertAddressRequest} InsertAddressRequest
                         */
                        InsertAddressRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertAddressRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertAddressRequest();
                            if (object.addressResource != null) {
                                if (typeof object.addressResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertAddressRequest.addressResource: object expected");
                                message.addressResource = $root.google.cloud.compute.v1.Address.fromObject(object.addressResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertAddressRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertAddressRequest} message InsertAddressRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertAddressRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.addressResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.addressResource != null && message.hasOwnProperty("addressResource"))
                                object.addressResource = $root.google.cloud.compute.v1.Address.toObject(message.addressResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertAddressRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertAddressRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertAddressRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertAddressRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertAddressRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertAddressRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertAddressRequest";
                        };
    
                        return InsertAddressRequest;
                    })();
    
                    v1.InsertAutoscalerRequest = (function() {
    
                        /**
                         * Properties of an InsertAutoscalerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertAutoscalerRequest
                         * @property {google.cloud.compute.v1.IAutoscaler|null} [autoscalerResource] InsertAutoscalerRequest autoscalerResource
                         * @property {string|null} [project] InsertAutoscalerRequest project
                         * @property {string|null} [requestId] InsertAutoscalerRequest requestId
                         * @property {string|null} [zone] InsertAutoscalerRequest zone
                         */
    
                        /**
                         * Constructs a new InsertAutoscalerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertAutoscalerRequest.
                         * @implements IInsertAutoscalerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertAutoscalerRequest=} [properties] Properties to set
                         */
                        function InsertAutoscalerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertAutoscalerRequest autoscalerResource.
                         * @member {google.cloud.compute.v1.IAutoscaler|null|undefined} autoscalerResource
                         * @memberof google.cloud.compute.v1.InsertAutoscalerRequest
                         * @instance
                         */
                        InsertAutoscalerRequest.prototype.autoscalerResource = null;
    
                        /**
                         * InsertAutoscalerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertAutoscalerRequest
                         * @instance
                         */
                        InsertAutoscalerRequest.prototype.project = "";
    
                        /**
                         * InsertAutoscalerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertAutoscalerRequest
                         * @instance
                         */
                        InsertAutoscalerRequest.prototype.requestId = null;
    
                        /**
                         * InsertAutoscalerRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.InsertAutoscalerRequest
                         * @instance
                         */
                        InsertAutoscalerRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertAutoscalerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertAutoscalerRequest
                         * @instance
                         */
                        Object.defineProperty(InsertAutoscalerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertAutoscalerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertAutoscalerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertAutoscalerRequest} InsertAutoscalerRequest instance
                         */
                        InsertAutoscalerRequest.create = function create(properties) {
                            return new InsertAutoscalerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertAutoscalerRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertAutoscalerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertAutoscalerRequest} message InsertAutoscalerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertAutoscalerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.autoscalerResource != null && Object.hasOwnProperty.call(message, "autoscalerResource"))
                                $root.google.cloud.compute.v1.Autoscaler.encode(message.autoscalerResource, writer.uint32(/* id 207616118, wireType 2 =*/1660928946).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertAutoscalerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertAutoscalerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertAutoscalerRequest} message InsertAutoscalerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertAutoscalerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertAutoscalerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertAutoscalerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertAutoscalerRequest} InsertAutoscalerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertAutoscalerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertAutoscalerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 207616118: {
                                        message.autoscalerResource = $root.google.cloud.compute.v1.Autoscaler.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertAutoscalerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertAutoscalerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertAutoscalerRequest} InsertAutoscalerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertAutoscalerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertAutoscalerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertAutoscalerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertAutoscalerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoscalerResource != null && message.hasOwnProperty("autoscalerResource")) {
                                var error = $root.google.cloud.compute.v1.Autoscaler.verify(message.autoscalerResource);
                                if (error)
                                    return "autoscalerResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an InsertAutoscalerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertAutoscalerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertAutoscalerRequest} InsertAutoscalerRequest
                         */
                        InsertAutoscalerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertAutoscalerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertAutoscalerRequest();
                            if (object.autoscalerResource != null) {
                                if (typeof object.autoscalerResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertAutoscalerRequest.autoscalerResource: object expected");
                                message.autoscalerResource = $root.google.cloud.compute.v1.Autoscaler.fromObject(object.autoscalerResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertAutoscalerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertAutoscalerRequest} message InsertAutoscalerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertAutoscalerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.autoscalerResource = null;
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.autoscalerResource != null && message.hasOwnProperty("autoscalerResource"))
                                object.autoscalerResource = $root.google.cloud.compute.v1.Autoscaler.toObject(message.autoscalerResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertAutoscalerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertAutoscalerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertAutoscalerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertAutoscalerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertAutoscalerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertAutoscalerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertAutoscalerRequest";
                        };
    
                        return InsertAutoscalerRequest;
                    })();
    
                    v1.InsertBackendBucketRequest = (function() {
    
                        /**
                         * Properties of an InsertBackendBucketRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertBackendBucketRequest
                         * @property {google.cloud.compute.v1.IBackendBucket|null} [backendBucketResource] InsertBackendBucketRequest backendBucketResource
                         * @property {string|null} [project] InsertBackendBucketRequest project
                         * @property {string|null} [requestId] InsertBackendBucketRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertBackendBucketRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertBackendBucketRequest.
                         * @implements IInsertBackendBucketRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertBackendBucketRequest=} [properties] Properties to set
                         */
                        function InsertBackendBucketRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertBackendBucketRequest backendBucketResource.
                         * @member {google.cloud.compute.v1.IBackendBucket|null|undefined} backendBucketResource
                         * @memberof google.cloud.compute.v1.InsertBackendBucketRequest
                         * @instance
                         */
                        InsertBackendBucketRequest.prototype.backendBucketResource = null;
    
                        /**
                         * InsertBackendBucketRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertBackendBucketRequest
                         * @instance
                         */
                        InsertBackendBucketRequest.prototype.project = "";
    
                        /**
                         * InsertBackendBucketRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertBackendBucketRequest
                         * @instance
                         */
                        InsertBackendBucketRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertBackendBucketRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertBackendBucketRequest
                         * @instance
                         */
                        Object.defineProperty(InsertBackendBucketRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertBackendBucketRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertBackendBucketRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertBackendBucketRequest} InsertBackendBucketRequest instance
                         */
                        InsertBackendBucketRequest.create = function create(properties) {
                            return new InsertBackendBucketRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertBackendBucketRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertBackendBucketRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertBackendBucketRequest} message InsertBackendBucketRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertBackendBucketRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.backendBucketResource != null && Object.hasOwnProperty.call(message, "backendBucketResource"))
                                $root.google.cloud.compute.v1.BackendBucket.encode(message.backendBucketResource, writer.uint32(/* id 380757784, wireType 2 =*/3046062274).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertBackendBucketRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertBackendBucketRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertBackendBucketRequest} message InsertBackendBucketRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertBackendBucketRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertBackendBucketRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertBackendBucketRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertBackendBucketRequest} InsertBackendBucketRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertBackendBucketRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertBackendBucketRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 380757784: {
                                        message.backendBucketResource = $root.google.cloud.compute.v1.BackendBucket.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertBackendBucketRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertBackendBucketRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertBackendBucketRequest} InsertBackendBucketRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertBackendBucketRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertBackendBucketRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertBackendBucketRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertBackendBucketRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendBucketResource != null && message.hasOwnProperty("backendBucketResource")) {
                                var error = $root.google.cloud.compute.v1.BackendBucket.verify(message.backendBucketResource);
                                if (error)
                                    return "backendBucketResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertBackendBucketRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertBackendBucketRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertBackendBucketRequest} InsertBackendBucketRequest
                         */
                        InsertBackendBucketRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertBackendBucketRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertBackendBucketRequest();
                            if (object.backendBucketResource != null) {
                                if (typeof object.backendBucketResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertBackendBucketRequest.backendBucketResource: object expected");
                                message.backendBucketResource = $root.google.cloud.compute.v1.BackendBucket.fromObject(object.backendBucketResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertBackendBucketRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertBackendBucketRequest} message InsertBackendBucketRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertBackendBucketRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.backendBucketResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.backendBucketResource != null && message.hasOwnProperty("backendBucketResource"))
                                object.backendBucketResource = $root.google.cloud.compute.v1.BackendBucket.toObject(message.backendBucketResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertBackendBucketRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertBackendBucketRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertBackendBucketRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertBackendBucketRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertBackendBucketRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertBackendBucketRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertBackendBucketRequest";
                        };
    
                        return InsertBackendBucketRequest;
                    })();
    
                    v1.InsertBackendServiceRequest = (function() {
    
                        /**
                         * Properties of an InsertBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertBackendServiceRequest
                         * @property {google.cloud.compute.v1.IBackendService|null} [backendServiceResource] InsertBackendServiceRequest backendServiceResource
                         * @property {string|null} [project] InsertBackendServiceRequest project
                         * @property {string|null} [requestId] InsertBackendServiceRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertBackendServiceRequest.
                         * @implements IInsertBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertBackendServiceRequest=} [properties] Properties to set
                         */
                        function InsertBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertBackendServiceRequest backendServiceResource.
                         * @member {google.cloud.compute.v1.IBackendService|null|undefined} backendServiceResource
                         * @memberof google.cloud.compute.v1.InsertBackendServiceRequest
                         * @instance
                         */
                        InsertBackendServiceRequest.prototype.backendServiceResource = null;
    
                        /**
                         * InsertBackendServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertBackendServiceRequest
                         * @instance
                         */
                        InsertBackendServiceRequest.prototype.project = "";
    
                        /**
                         * InsertBackendServiceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertBackendServiceRequest
                         * @instance
                         */
                        InsertBackendServiceRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertBackendServiceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertBackendServiceRequest
                         * @instance
                         */
                        Object.defineProperty(InsertBackendServiceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertBackendServiceRequest} InsertBackendServiceRequest instance
                         */
                        InsertBackendServiceRequest.create = function create(properties) {
                            return new InsertBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertBackendServiceRequest} message InsertBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.backendServiceResource != null && Object.hasOwnProperty.call(message, "backendServiceResource"))
                                $root.google.cloud.compute.v1.BackendService.encode(message.backendServiceResource, writer.uint32(/* id 347586723, wireType 2 =*/2780693786).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertBackendServiceRequest} message InsertBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertBackendServiceRequest} InsertBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 347586723: {
                                        message.backendServiceResource = $root.google.cloud.compute.v1.BackendService.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertBackendServiceRequest} InsertBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendServiceResource != null && message.hasOwnProperty("backendServiceResource")) {
                                var error = $root.google.cloud.compute.v1.BackendService.verify(message.backendServiceResource);
                                if (error)
                                    return "backendServiceResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertBackendServiceRequest} InsertBackendServiceRequest
                         */
                        InsertBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertBackendServiceRequest();
                            if (object.backendServiceResource != null) {
                                if (typeof object.backendServiceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertBackendServiceRequest.backendServiceResource: object expected");
                                message.backendServiceResource = $root.google.cloud.compute.v1.BackendService.fromObject(object.backendServiceResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertBackendServiceRequest} message InsertBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.backendServiceResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.backendServiceResource != null && message.hasOwnProperty("backendServiceResource"))
                                object.backendServiceResource = $root.google.cloud.compute.v1.BackendService.toObject(message.backendServiceResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertBackendServiceRequest";
                        };
    
                        return InsertBackendServiceRequest;
                    })();
    
                    v1.InsertDiskRequest = (function() {
    
                        /**
                         * Properties of an InsertDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertDiskRequest
                         * @property {google.cloud.compute.v1.IDisk|null} [diskResource] InsertDiskRequest diskResource
                         * @property {string|null} [project] InsertDiskRequest project
                         * @property {string|null} [requestId] InsertDiskRequest requestId
                         * @property {string|null} [sourceImage] InsertDiskRequest sourceImage
                         * @property {string|null} [zone] InsertDiskRequest zone
                         */
    
                        /**
                         * Constructs a new InsertDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertDiskRequest.
                         * @implements IInsertDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertDiskRequest=} [properties] Properties to set
                         */
                        function InsertDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertDiskRequest diskResource.
                         * @member {google.cloud.compute.v1.IDisk|null|undefined} diskResource
                         * @memberof google.cloud.compute.v1.InsertDiskRequest
                         * @instance
                         */
                        InsertDiskRequest.prototype.diskResource = null;
    
                        /**
                         * InsertDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertDiskRequest
                         * @instance
                         */
                        InsertDiskRequest.prototype.project = "";
    
                        /**
                         * InsertDiskRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertDiskRequest
                         * @instance
                         */
                        InsertDiskRequest.prototype.requestId = null;
    
                        /**
                         * InsertDiskRequest sourceImage.
                         * @member {string|null|undefined} sourceImage
                         * @memberof google.cloud.compute.v1.InsertDiskRequest
                         * @instance
                         */
                        InsertDiskRequest.prototype.sourceImage = null;
    
                        /**
                         * InsertDiskRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.InsertDiskRequest
                         * @instance
                         */
                        InsertDiskRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertDiskRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertDiskRequest
                         * @instance
                         */
                        Object.defineProperty(InsertDiskRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InsertDiskRequest _sourceImage.
                         * @member {"sourceImage"|undefined} _sourceImage
                         * @memberof google.cloud.compute.v1.InsertDiskRequest
                         * @instance
                         */
                        Object.defineProperty(InsertDiskRequest.prototype, "_sourceImage", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceImage"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertDiskRequest} InsertDiskRequest instance
                         */
                        InsertDiskRequest.create = function create(properties) {
                            return new InsertDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertDiskRequest} message InsertDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.diskResource != null && Object.hasOwnProperty.call(message, "diskResource"))
                                $root.google.cloud.compute.v1.Disk.encode(message.diskResource, writer.uint32(/* id 25880688, wireType 2 =*/207045506).fork()).ldelim();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.sourceImage != null && Object.hasOwnProperty.call(message, "sourceImage"))
                                writer.uint32(/* id 50443319, wireType 2 =*/403546554).string(message.sourceImage);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertDiskRequest} message InsertDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertDiskRequest} InsertDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 25880688: {
                                        message.diskResource = $root.google.cloud.compute.v1.Disk.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 50443319: {
                                        message.sourceImage = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertDiskRequest} InsertDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.diskResource != null && message.hasOwnProperty("diskResource")) {
                                var error = $root.google.cloud.compute.v1.Disk.verify(message.diskResource);
                                if (error)
                                    return "diskResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.sourceImage != null && message.hasOwnProperty("sourceImage")) {
                                properties._sourceImage = 1;
                                if (!$util.isString(message.sourceImage))
                                    return "sourceImage: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an InsertDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertDiskRequest} InsertDiskRequest
                         */
                        InsertDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertDiskRequest();
                            if (object.diskResource != null) {
                                if (typeof object.diskResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertDiskRequest.diskResource: object expected");
                                message.diskResource = $root.google.cloud.compute.v1.Disk.fromObject(object.diskResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.sourceImage != null)
                                message.sourceImage = String(object.sourceImage);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertDiskRequest} message InsertDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.diskResource = null;
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.diskResource != null && message.hasOwnProperty("diskResource"))
                                object.diskResource = $root.google.cloud.compute.v1.Disk.toObject(message.diskResource, options);
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.sourceImage != null && message.hasOwnProperty("sourceImage")) {
                                object.sourceImage = message.sourceImage;
                                if (options.oneofs)
                                    object._sourceImage = "sourceImage";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertDiskRequest";
                        };
    
                        return InsertDiskRequest;
                    })();
    
                    v1.InsertExternalVpnGatewayRequest = (function() {
    
                        /**
                         * Properties of an InsertExternalVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertExternalVpnGatewayRequest
                         * @property {google.cloud.compute.v1.IExternalVpnGateway|null} [externalVpnGatewayResource] InsertExternalVpnGatewayRequest externalVpnGatewayResource
                         * @property {string|null} [project] InsertExternalVpnGatewayRequest project
                         * @property {string|null} [requestId] InsertExternalVpnGatewayRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertExternalVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertExternalVpnGatewayRequest.
                         * @implements IInsertExternalVpnGatewayRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertExternalVpnGatewayRequest=} [properties] Properties to set
                         */
                        function InsertExternalVpnGatewayRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertExternalVpnGatewayRequest externalVpnGatewayResource.
                         * @member {google.cloud.compute.v1.IExternalVpnGateway|null|undefined} externalVpnGatewayResource
                         * @memberof google.cloud.compute.v1.InsertExternalVpnGatewayRequest
                         * @instance
                         */
                        InsertExternalVpnGatewayRequest.prototype.externalVpnGatewayResource = null;
    
                        /**
                         * InsertExternalVpnGatewayRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertExternalVpnGatewayRequest
                         * @instance
                         */
                        InsertExternalVpnGatewayRequest.prototype.project = "";
    
                        /**
                         * InsertExternalVpnGatewayRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertExternalVpnGatewayRequest
                         * @instance
                         */
                        InsertExternalVpnGatewayRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertExternalVpnGatewayRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertExternalVpnGatewayRequest
                         * @instance
                         */
                        Object.defineProperty(InsertExternalVpnGatewayRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertExternalVpnGatewayRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertExternalVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertExternalVpnGatewayRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertExternalVpnGatewayRequest} InsertExternalVpnGatewayRequest instance
                         */
                        InsertExternalVpnGatewayRequest.create = function create(properties) {
                            return new InsertExternalVpnGatewayRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertExternalVpnGatewayRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertExternalVpnGatewayRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertExternalVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertExternalVpnGatewayRequest} message InsertExternalVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertExternalVpnGatewayRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.externalVpnGatewayResource != null && Object.hasOwnProperty.call(message, "externalVpnGatewayResource"))
                                $root.google.cloud.compute.v1.ExternalVpnGateway.encode(message.externalVpnGatewayResource, writer.uint32(/* id 486813576, wireType 2 =*/3894508610).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertExternalVpnGatewayRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertExternalVpnGatewayRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertExternalVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertExternalVpnGatewayRequest} message InsertExternalVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertExternalVpnGatewayRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertExternalVpnGatewayRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertExternalVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertExternalVpnGatewayRequest} InsertExternalVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertExternalVpnGatewayRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertExternalVpnGatewayRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 486813576: {
                                        message.externalVpnGatewayResource = $root.google.cloud.compute.v1.ExternalVpnGateway.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertExternalVpnGatewayRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertExternalVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertExternalVpnGatewayRequest} InsertExternalVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertExternalVpnGatewayRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertExternalVpnGatewayRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertExternalVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertExternalVpnGatewayRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.externalVpnGatewayResource != null && message.hasOwnProperty("externalVpnGatewayResource")) {
                                var error = $root.google.cloud.compute.v1.ExternalVpnGateway.verify(message.externalVpnGatewayResource);
                                if (error)
                                    return "externalVpnGatewayResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertExternalVpnGatewayRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertExternalVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertExternalVpnGatewayRequest} InsertExternalVpnGatewayRequest
                         */
                        InsertExternalVpnGatewayRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertExternalVpnGatewayRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertExternalVpnGatewayRequest();
                            if (object.externalVpnGatewayResource != null) {
                                if (typeof object.externalVpnGatewayResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertExternalVpnGatewayRequest.externalVpnGatewayResource: object expected");
                                message.externalVpnGatewayResource = $root.google.cloud.compute.v1.ExternalVpnGateway.fromObject(object.externalVpnGatewayResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertExternalVpnGatewayRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertExternalVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertExternalVpnGatewayRequest} message InsertExternalVpnGatewayRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertExternalVpnGatewayRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.externalVpnGatewayResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.externalVpnGatewayResource != null && message.hasOwnProperty("externalVpnGatewayResource"))
                                object.externalVpnGatewayResource = $root.google.cloud.compute.v1.ExternalVpnGateway.toObject(message.externalVpnGatewayResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertExternalVpnGatewayRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertExternalVpnGatewayRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertExternalVpnGatewayRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertExternalVpnGatewayRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertExternalVpnGatewayRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertExternalVpnGatewayRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertExternalVpnGatewayRequest";
                        };
    
                        return InsertExternalVpnGatewayRequest;
                    })();
    
                    v1.InsertFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of an InsertFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertFirewallPolicyRequest
                         * @property {google.cloud.compute.v1.IFirewallPolicy|null} [firewallPolicyResource] InsertFirewallPolicyRequest firewallPolicyResource
                         * @property {string|null} [parentId] InsertFirewallPolicyRequest parentId
                         * @property {string|null} [requestId] InsertFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertFirewallPolicyRequest.
                         * @implements IInsertFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function InsertFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertFirewallPolicyRequest firewallPolicyResource.
                         * @member {google.cloud.compute.v1.IFirewallPolicy|null|undefined} firewallPolicyResource
                         * @memberof google.cloud.compute.v1.InsertFirewallPolicyRequest
                         * @instance
                         */
                        InsertFirewallPolicyRequest.prototype.firewallPolicyResource = null;
    
                        /**
                         * InsertFirewallPolicyRequest parentId.
                         * @member {string} parentId
                         * @memberof google.cloud.compute.v1.InsertFirewallPolicyRequest
                         * @instance
                         */
                        InsertFirewallPolicyRequest.prototype.parentId = "";
    
                        /**
                         * InsertFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertFirewallPolicyRequest
                         * @instance
                         */
                        InsertFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(InsertFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertFirewallPolicyRequest} InsertFirewallPolicyRequest instance
                         */
                        InsertFirewallPolicyRequest.create = function create(properties) {
                            return new InsertFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertFirewallPolicyRequest} message InsertFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.parentId != null && Object.hasOwnProperty.call(message, "parentId"))
                                writer.uint32(/* id 459714768, wireType 2 =*/3677718146).string(message.parentId);
                            if (message.firewallPolicyResource != null && Object.hasOwnProperty.call(message, "firewallPolicyResource"))
                                $root.google.cloud.compute.v1.FirewallPolicy.encode(message.firewallPolicyResource, writer.uint32(/* id 495049532, wireType 2 =*/3960396258).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertFirewallPolicyRequest} message InsertFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertFirewallPolicyRequest} InsertFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 495049532: {
                                        message.firewallPolicyResource = $root.google.cloud.compute.v1.FirewallPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 459714768: {
                                        message.parentId = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertFirewallPolicyRequest} InsertFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicyResource != null && message.hasOwnProperty("firewallPolicyResource")) {
                                var error = $root.google.cloud.compute.v1.FirewallPolicy.verify(message.firewallPolicyResource);
                                if (error)
                                    return "firewallPolicyResource." + error;
                            }
                            if (message.parentId != null && message.hasOwnProperty("parentId"))
                                if (!$util.isString(message.parentId))
                                    return "parentId: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertFirewallPolicyRequest} InsertFirewallPolicyRequest
                         */
                        InsertFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertFirewallPolicyRequest();
                            if (object.firewallPolicyResource != null) {
                                if (typeof object.firewallPolicyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertFirewallPolicyRequest.firewallPolicyResource: object expected");
                                message.firewallPolicyResource = $root.google.cloud.compute.v1.FirewallPolicy.fromObject(object.firewallPolicyResource);
                            }
                            if (object.parentId != null)
                                message.parentId = String(object.parentId);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertFirewallPolicyRequest} message InsertFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parentId = "";
                                object.firewallPolicyResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.parentId != null && message.hasOwnProperty("parentId"))
                                object.parentId = message.parentId;
                            if (message.firewallPolicyResource != null && message.hasOwnProperty("firewallPolicyResource"))
                                object.firewallPolicyResource = $root.google.cloud.compute.v1.FirewallPolicy.toObject(message.firewallPolicyResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertFirewallPolicyRequest";
                        };
    
                        return InsertFirewallPolicyRequest;
                    })();
    
                    v1.InsertFirewallRequest = (function() {
    
                        /**
                         * Properties of an InsertFirewallRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertFirewallRequest
                         * @property {google.cloud.compute.v1.IFirewall|null} [firewallResource] InsertFirewallRequest firewallResource
                         * @property {string|null} [project] InsertFirewallRequest project
                         * @property {string|null} [requestId] InsertFirewallRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertFirewallRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertFirewallRequest.
                         * @implements IInsertFirewallRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertFirewallRequest=} [properties] Properties to set
                         */
                        function InsertFirewallRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertFirewallRequest firewallResource.
                         * @member {google.cloud.compute.v1.IFirewall|null|undefined} firewallResource
                         * @memberof google.cloud.compute.v1.InsertFirewallRequest
                         * @instance
                         */
                        InsertFirewallRequest.prototype.firewallResource = null;
    
                        /**
                         * InsertFirewallRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertFirewallRequest
                         * @instance
                         */
                        InsertFirewallRequest.prototype.project = "";
    
                        /**
                         * InsertFirewallRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertFirewallRequest
                         * @instance
                         */
                        InsertFirewallRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertFirewallRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertFirewallRequest
                         * @instance
                         */
                        Object.defineProperty(InsertFirewallRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertFirewallRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertFirewallRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertFirewallRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertFirewallRequest} InsertFirewallRequest instance
                         */
                        InsertFirewallRequest.create = function create(properties) {
                            return new InsertFirewallRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertFirewallRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertFirewallRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertFirewallRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertFirewallRequest} message InsertFirewallRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertFirewallRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.firewallResource != null && Object.hasOwnProperty.call(message, "firewallResource"))
                                $root.google.cloud.compute.v1.Firewall.encode(message.firewallResource, writer.uint32(/* id 41425005, wireType 2 =*/331400042).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertFirewallRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertFirewallRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertFirewallRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertFirewallRequest} message InsertFirewallRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertFirewallRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertFirewallRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertFirewallRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertFirewallRequest} InsertFirewallRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertFirewallRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertFirewallRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 41425005: {
                                        message.firewallResource = $root.google.cloud.compute.v1.Firewall.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertFirewallRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertFirewallRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertFirewallRequest} InsertFirewallRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertFirewallRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertFirewallRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertFirewallRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertFirewallRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallResource != null && message.hasOwnProperty("firewallResource")) {
                                var error = $root.google.cloud.compute.v1.Firewall.verify(message.firewallResource);
                                if (error)
                                    return "firewallResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertFirewallRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertFirewallRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertFirewallRequest} InsertFirewallRequest
                         */
                        InsertFirewallRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertFirewallRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertFirewallRequest();
                            if (object.firewallResource != null) {
                                if (typeof object.firewallResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertFirewallRequest.firewallResource: object expected");
                                message.firewallResource = $root.google.cloud.compute.v1.Firewall.fromObject(object.firewallResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertFirewallRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertFirewallRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertFirewallRequest} message InsertFirewallRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertFirewallRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.firewallResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.firewallResource != null && message.hasOwnProperty("firewallResource"))
                                object.firewallResource = $root.google.cloud.compute.v1.Firewall.toObject(message.firewallResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertFirewallRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertFirewallRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertFirewallRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertFirewallRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertFirewallRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertFirewallRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertFirewallRequest";
                        };
    
                        return InsertFirewallRequest;
                    })();
    
                    v1.InsertForwardingRuleRequest = (function() {
    
                        /**
                         * Properties of an InsertForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertForwardingRuleRequest
                         * @property {google.cloud.compute.v1.IForwardingRule|null} [forwardingRuleResource] InsertForwardingRuleRequest forwardingRuleResource
                         * @property {string|null} [project] InsertForwardingRuleRequest project
                         * @property {string|null} [region] InsertForwardingRuleRequest region
                         * @property {string|null} [requestId] InsertForwardingRuleRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertForwardingRuleRequest.
                         * @implements IInsertForwardingRuleRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertForwardingRuleRequest=} [properties] Properties to set
                         */
                        function InsertForwardingRuleRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertForwardingRuleRequest forwardingRuleResource.
                         * @member {google.cloud.compute.v1.IForwardingRule|null|undefined} forwardingRuleResource
                         * @memberof google.cloud.compute.v1.InsertForwardingRuleRequest
                         * @instance
                         */
                        InsertForwardingRuleRequest.prototype.forwardingRuleResource = null;
    
                        /**
                         * InsertForwardingRuleRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertForwardingRuleRequest
                         * @instance
                         */
                        InsertForwardingRuleRequest.prototype.project = "";
    
                        /**
                         * InsertForwardingRuleRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertForwardingRuleRequest
                         * @instance
                         */
                        InsertForwardingRuleRequest.prototype.region = "";
    
                        /**
                         * InsertForwardingRuleRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertForwardingRuleRequest
                         * @instance
                         */
                        InsertForwardingRuleRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertForwardingRuleRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertForwardingRuleRequest
                         * @instance
                         */
                        Object.defineProperty(InsertForwardingRuleRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertForwardingRuleRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertForwardingRuleRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertForwardingRuleRequest} InsertForwardingRuleRequest instance
                         */
                        InsertForwardingRuleRequest.create = function create(properties) {
                            return new InsertForwardingRuleRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertForwardingRuleRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertForwardingRuleRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertForwardingRuleRequest} message InsertForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertForwardingRuleRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.forwardingRuleResource != null && Object.hasOwnProperty.call(message, "forwardingRuleResource"))
                                $root.google.cloud.compute.v1.ForwardingRule.encode(message.forwardingRuleResource, writer.uint32(/* id 301211695, wireType 2 =*/2409693562).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertForwardingRuleRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertForwardingRuleRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertForwardingRuleRequest} message InsertForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertForwardingRuleRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertForwardingRuleRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertForwardingRuleRequest} InsertForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertForwardingRuleRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertForwardingRuleRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 301211695: {
                                        message.forwardingRuleResource = $root.google.cloud.compute.v1.ForwardingRule.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertForwardingRuleRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertForwardingRuleRequest} InsertForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertForwardingRuleRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertForwardingRuleRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertForwardingRuleRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.forwardingRuleResource != null && message.hasOwnProperty("forwardingRuleResource")) {
                                var error = $root.google.cloud.compute.v1.ForwardingRule.verify(message.forwardingRuleResource);
                                if (error)
                                    return "forwardingRuleResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertForwardingRuleRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertForwardingRuleRequest} InsertForwardingRuleRequest
                         */
                        InsertForwardingRuleRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertForwardingRuleRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertForwardingRuleRequest();
                            if (object.forwardingRuleResource != null) {
                                if (typeof object.forwardingRuleResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertForwardingRuleRequest.forwardingRuleResource: object expected");
                                message.forwardingRuleResource = $root.google.cloud.compute.v1.ForwardingRule.fromObject(object.forwardingRuleResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertForwardingRuleRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertForwardingRuleRequest} message InsertForwardingRuleRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertForwardingRuleRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.forwardingRuleResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.forwardingRuleResource != null && message.hasOwnProperty("forwardingRuleResource"))
                                object.forwardingRuleResource = $root.google.cloud.compute.v1.ForwardingRule.toObject(message.forwardingRuleResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertForwardingRuleRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertForwardingRuleRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertForwardingRuleRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertForwardingRuleRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertForwardingRuleRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertForwardingRuleRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertForwardingRuleRequest";
                        };
    
                        return InsertForwardingRuleRequest;
                    })();
    
                    v1.InsertGlobalAddressRequest = (function() {
    
                        /**
                         * Properties of an InsertGlobalAddressRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertGlobalAddressRequest
                         * @property {google.cloud.compute.v1.IAddress|null} [addressResource] InsertGlobalAddressRequest addressResource
                         * @property {string|null} [project] InsertGlobalAddressRequest project
                         * @property {string|null} [requestId] InsertGlobalAddressRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertGlobalAddressRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertGlobalAddressRequest.
                         * @implements IInsertGlobalAddressRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertGlobalAddressRequest=} [properties] Properties to set
                         */
                        function InsertGlobalAddressRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertGlobalAddressRequest addressResource.
                         * @member {google.cloud.compute.v1.IAddress|null|undefined} addressResource
                         * @memberof google.cloud.compute.v1.InsertGlobalAddressRequest
                         * @instance
                         */
                        InsertGlobalAddressRequest.prototype.addressResource = null;
    
                        /**
                         * InsertGlobalAddressRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertGlobalAddressRequest
                         * @instance
                         */
                        InsertGlobalAddressRequest.prototype.project = "";
    
                        /**
                         * InsertGlobalAddressRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertGlobalAddressRequest
                         * @instance
                         */
                        InsertGlobalAddressRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertGlobalAddressRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertGlobalAddressRequest
                         * @instance
                         */
                        Object.defineProperty(InsertGlobalAddressRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertGlobalAddressRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertGlobalAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertGlobalAddressRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertGlobalAddressRequest} InsertGlobalAddressRequest instance
                         */
                        InsertGlobalAddressRequest.create = function create(properties) {
                            return new InsertGlobalAddressRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertGlobalAddressRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertGlobalAddressRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertGlobalAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertGlobalAddressRequest} message InsertGlobalAddressRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertGlobalAddressRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.addressResource != null && Object.hasOwnProperty.call(message, "addressResource"))
                                $root.google.cloud.compute.v1.Address.encode(message.addressResource, writer.uint32(/* id 483888121, wireType 2 =*/3871104970).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertGlobalAddressRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertGlobalAddressRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertGlobalAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertGlobalAddressRequest} message InsertGlobalAddressRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertGlobalAddressRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertGlobalAddressRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertGlobalAddressRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertGlobalAddressRequest} InsertGlobalAddressRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertGlobalAddressRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertGlobalAddressRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 483888121: {
                                        message.addressResource = $root.google.cloud.compute.v1.Address.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertGlobalAddressRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertGlobalAddressRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertGlobalAddressRequest} InsertGlobalAddressRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertGlobalAddressRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertGlobalAddressRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertGlobalAddressRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertGlobalAddressRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.addressResource != null && message.hasOwnProperty("addressResource")) {
                                var error = $root.google.cloud.compute.v1.Address.verify(message.addressResource);
                                if (error)
                                    return "addressResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertGlobalAddressRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertGlobalAddressRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertGlobalAddressRequest} InsertGlobalAddressRequest
                         */
                        InsertGlobalAddressRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertGlobalAddressRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertGlobalAddressRequest();
                            if (object.addressResource != null) {
                                if (typeof object.addressResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertGlobalAddressRequest.addressResource: object expected");
                                message.addressResource = $root.google.cloud.compute.v1.Address.fromObject(object.addressResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertGlobalAddressRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertGlobalAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertGlobalAddressRequest} message InsertGlobalAddressRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertGlobalAddressRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.addressResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.addressResource != null && message.hasOwnProperty("addressResource"))
                                object.addressResource = $root.google.cloud.compute.v1.Address.toObject(message.addressResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertGlobalAddressRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertGlobalAddressRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertGlobalAddressRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertGlobalAddressRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertGlobalAddressRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertGlobalAddressRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertGlobalAddressRequest";
                        };
    
                        return InsertGlobalAddressRequest;
                    })();
    
                    v1.InsertGlobalForwardingRuleRequest = (function() {
    
                        /**
                         * Properties of an InsertGlobalForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertGlobalForwardingRuleRequest
                         * @property {google.cloud.compute.v1.IForwardingRule|null} [forwardingRuleResource] InsertGlobalForwardingRuleRequest forwardingRuleResource
                         * @property {string|null} [project] InsertGlobalForwardingRuleRequest project
                         * @property {string|null} [requestId] InsertGlobalForwardingRuleRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertGlobalForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertGlobalForwardingRuleRequest.
                         * @implements IInsertGlobalForwardingRuleRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertGlobalForwardingRuleRequest=} [properties] Properties to set
                         */
                        function InsertGlobalForwardingRuleRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertGlobalForwardingRuleRequest forwardingRuleResource.
                         * @member {google.cloud.compute.v1.IForwardingRule|null|undefined} forwardingRuleResource
                         * @memberof google.cloud.compute.v1.InsertGlobalForwardingRuleRequest
                         * @instance
                         */
                        InsertGlobalForwardingRuleRequest.prototype.forwardingRuleResource = null;
    
                        /**
                         * InsertGlobalForwardingRuleRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertGlobalForwardingRuleRequest
                         * @instance
                         */
                        InsertGlobalForwardingRuleRequest.prototype.project = "";
    
                        /**
                         * InsertGlobalForwardingRuleRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertGlobalForwardingRuleRequest
                         * @instance
                         */
                        InsertGlobalForwardingRuleRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertGlobalForwardingRuleRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertGlobalForwardingRuleRequest
                         * @instance
                         */
                        Object.defineProperty(InsertGlobalForwardingRuleRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertGlobalForwardingRuleRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertGlobalForwardingRuleRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertGlobalForwardingRuleRequest} InsertGlobalForwardingRuleRequest instance
                         */
                        InsertGlobalForwardingRuleRequest.create = function create(properties) {
                            return new InsertGlobalForwardingRuleRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertGlobalForwardingRuleRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertGlobalForwardingRuleRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertGlobalForwardingRuleRequest} message InsertGlobalForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertGlobalForwardingRuleRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.forwardingRuleResource != null && Object.hasOwnProperty.call(message, "forwardingRuleResource"))
                                $root.google.cloud.compute.v1.ForwardingRule.encode(message.forwardingRuleResource, writer.uint32(/* id 301211695, wireType 2 =*/2409693562).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertGlobalForwardingRuleRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertGlobalForwardingRuleRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertGlobalForwardingRuleRequest} message InsertGlobalForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertGlobalForwardingRuleRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertGlobalForwardingRuleRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertGlobalForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertGlobalForwardingRuleRequest} InsertGlobalForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertGlobalForwardingRuleRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertGlobalForwardingRuleRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 301211695: {
                                        message.forwardingRuleResource = $root.google.cloud.compute.v1.ForwardingRule.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertGlobalForwardingRuleRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertGlobalForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertGlobalForwardingRuleRequest} InsertGlobalForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertGlobalForwardingRuleRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertGlobalForwardingRuleRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertGlobalForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertGlobalForwardingRuleRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.forwardingRuleResource != null && message.hasOwnProperty("forwardingRuleResource")) {
                                var error = $root.google.cloud.compute.v1.ForwardingRule.verify(message.forwardingRuleResource);
                                if (error)
                                    return "forwardingRuleResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertGlobalForwardingRuleRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertGlobalForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertGlobalForwardingRuleRequest} InsertGlobalForwardingRuleRequest
                         */
                        InsertGlobalForwardingRuleRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertGlobalForwardingRuleRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertGlobalForwardingRuleRequest();
                            if (object.forwardingRuleResource != null) {
                                if (typeof object.forwardingRuleResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertGlobalForwardingRuleRequest.forwardingRuleResource: object expected");
                                message.forwardingRuleResource = $root.google.cloud.compute.v1.ForwardingRule.fromObject(object.forwardingRuleResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertGlobalForwardingRuleRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertGlobalForwardingRuleRequest} message InsertGlobalForwardingRuleRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertGlobalForwardingRuleRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.forwardingRuleResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.forwardingRuleResource != null && message.hasOwnProperty("forwardingRuleResource"))
                                object.forwardingRuleResource = $root.google.cloud.compute.v1.ForwardingRule.toObject(message.forwardingRuleResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertGlobalForwardingRuleRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertGlobalForwardingRuleRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertGlobalForwardingRuleRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertGlobalForwardingRuleRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertGlobalForwardingRuleRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertGlobalForwardingRuleRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertGlobalForwardingRuleRequest";
                        };
    
                        return InsertGlobalForwardingRuleRequest;
                    })();
    
                    v1.InsertGlobalNetworkEndpointGroupRequest = (function() {
    
                        /**
                         * Properties of an InsertGlobalNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertGlobalNetworkEndpointGroupRequest
                         * @property {google.cloud.compute.v1.INetworkEndpointGroup|null} [networkEndpointGroupResource] InsertGlobalNetworkEndpointGroupRequest networkEndpointGroupResource
                         * @property {string|null} [project] InsertGlobalNetworkEndpointGroupRequest project
                         * @property {string|null} [requestId] InsertGlobalNetworkEndpointGroupRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertGlobalNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertGlobalNetworkEndpointGroupRequest.
                         * @implements IInsertGlobalNetworkEndpointGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertGlobalNetworkEndpointGroupRequest=} [properties] Properties to set
                         */
                        function InsertGlobalNetworkEndpointGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertGlobalNetworkEndpointGroupRequest networkEndpointGroupResource.
                         * @member {google.cloud.compute.v1.INetworkEndpointGroup|null|undefined} networkEndpointGroupResource
                         * @memberof google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest
                         * @instance
                         */
                        InsertGlobalNetworkEndpointGroupRequest.prototype.networkEndpointGroupResource = null;
    
                        /**
                         * InsertGlobalNetworkEndpointGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest
                         * @instance
                         */
                        InsertGlobalNetworkEndpointGroupRequest.prototype.project = "";
    
                        /**
                         * InsertGlobalNetworkEndpointGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest
                         * @instance
                         */
                        InsertGlobalNetworkEndpointGroupRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertGlobalNetworkEndpointGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest
                         * @instance
                         */
                        Object.defineProperty(InsertGlobalNetworkEndpointGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertGlobalNetworkEndpointGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertGlobalNetworkEndpointGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest} InsertGlobalNetworkEndpointGroupRequest instance
                         */
                        InsertGlobalNetworkEndpointGroupRequest.create = function create(properties) {
                            return new InsertGlobalNetworkEndpointGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertGlobalNetworkEndpointGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertGlobalNetworkEndpointGroupRequest} message InsertGlobalNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertGlobalNetworkEndpointGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.networkEndpointGroupResource != null && Object.hasOwnProperty.call(message, "networkEndpointGroupResource"))
                                $root.google.cloud.compute.v1.NetworkEndpointGroup.encode(message.networkEndpointGroupResource, writer.uint32(/* id 525788839, wireType 2 =*/4206310714).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertGlobalNetworkEndpointGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertGlobalNetworkEndpointGroupRequest} message InsertGlobalNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertGlobalNetworkEndpointGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertGlobalNetworkEndpointGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest} InsertGlobalNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertGlobalNetworkEndpointGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 525788839: {
                                        message.networkEndpointGroupResource = $root.google.cloud.compute.v1.NetworkEndpointGroup.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertGlobalNetworkEndpointGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest} InsertGlobalNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertGlobalNetworkEndpointGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertGlobalNetworkEndpointGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertGlobalNetworkEndpointGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.networkEndpointGroupResource != null && message.hasOwnProperty("networkEndpointGroupResource")) {
                                var error = $root.google.cloud.compute.v1.NetworkEndpointGroup.verify(message.networkEndpointGroupResource);
                                if (error)
                                    return "networkEndpointGroupResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertGlobalNetworkEndpointGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest} InsertGlobalNetworkEndpointGroupRequest
                         */
                        InsertGlobalNetworkEndpointGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest();
                            if (object.networkEndpointGroupResource != null) {
                                if (typeof object.networkEndpointGroupResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest.networkEndpointGroupResource: object expected");
                                message.networkEndpointGroupResource = $root.google.cloud.compute.v1.NetworkEndpointGroup.fromObject(object.networkEndpointGroupResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertGlobalNetworkEndpointGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest} message InsertGlobalNetworkEndpointGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertGlobalNetworkEndpointGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.networkEndpointGroupResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.networkEndpointGroupResource != null && message.hasOwnProperty("networkEndpointGroupResource"))
                                object.networkEndpointGroupResource = $root.google.cloud.compute.v1.NetworkEndpointGroup.toObject(message.networkEndpointGroupResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertGlobalNetworkEndpointGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertGlobalNetworkEndpointGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertGlobalNetworkEndpointGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertGlobalNetworkEndpointGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest";
                        };
    
                        return InsertGlobalNetworkEndpointGroupRequest;
                    })();
    
                    v1.InsertGlobalPublicDelegatedPrefixeRequest = (function() {
    
                        /**
                         * Properties of an InsertGlobalPublicDelegatedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertGlobalPublicDelegatedPrefixeRequest
                         * @property {string|null} [project] InsertGlobalPublicDelegatedPrefixeRequest project
                         * @property {google.cloud.compute.v1.IPublicDelegatedPrefix|null} [publicDelegatedPrefixResource] InsertGlobalPublicDelegatedPrefixeRequest publicDelegatedPrefixResource
                         * @property {string|null} [requestId] InsertGlobalPublicDelegatedPrefixeRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertGlobalPublicDelegatedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertGlobalPublicDelegatedPrefixeRequest.
                         * @implements IInsertGlobalPublicDelegatedPrefixeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertGlobalPublicDelegatedPrefixeRequest=} [properties] Properties to set
                         */
                        function InsertGlobalPublicDelegatedPrefixeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertGlobalPublicDelegatedPrefixeRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        InsertGlobalPublicDelegatedPrefixeRequest.prototype.project = "";
    
                        /**
                         * InsertGlobalPublicDelegatedPrefixeRequest publicDelegatedPrefixResource.
                         * @member {google.cloud.compute.v1.IPublicDelegatedPrefix|null|undefined} publicDelegatedPrefixResource
                         * @memberof google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        InsertGlobalPublicDelegatedPrefixeRequest.prototype.publicDelegatedPrefixResource = null;
    
                        /**
                         * InsertGlobalPublicDelegatedPrefixeRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        InsertGlobalPublicDelegatedPrefixeRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertGlobalPublicDelegatedPrefixeRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        Object.defineProperty(InsertGlobalPublicDelegatedPrefixeRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertGlobalPublicDelegatedPrefixeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertGlobalPublicDelegatedPrefixeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest} InsertGlobalPublicDelegatedPrefixeRequest instance
                         */
                        InsertGlobalPublicDelegatedPrefixeRequest.create = function create(properties) {
                            return new InsertGlobalPublicDelegatedPrefixeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertGlobalPublicDelegatedPrefixeRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertGlobalPublicDelegatedPrefixeRequest} message InsertGlobalPublicDelegatedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertGlobalPublicDelegatedPrefixeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.publicDelegatedPrefixResource != null && Object.hasOwnProperty.call(message, "publicDelegatedPrefixResource"))
                                $root.google.cloud.compute.v1.PublicDelegatedPrefix.encode(message.publicDelegatedPrefixResource, writer.uint32(/* id 47594501, wireType 2 =*/380756010).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertGlobalPublicDelegatedPrefixeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertGlobalPublicDelegatedPrefixeRequest} message InsertGlobalPublicDelegatedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertGlobalPublicDelegatedPrefixeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertGlobalPublicDelegatedPrefixeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest} InsertGlobalPublicDelegatedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertGlobalPublicDelegatedPrefixeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 47594501: {
                                        message.publicDelegatedPrefixResource = $root.google.cloud.compute.v1.PublicDelegatedPrefix.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertGlobalPublicDelegatedPrefixeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest} InsertGlobalPublicDelegatedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertGlobalPublicDelegatedPrefixeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertGlobalPublicDelegatedPrefixeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertGlobalPublicDelegatedPrefixeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.publicDelegatedPrefixResource != null && message.hasOwnProperty("publicDelegatedPrefixResource")) {
                                var error = $root.google.cloud.compute.v1.PublicDelegatedPrefix.verify(message.publicDelegatedPrefixResource);
                                if (error)
                                    return "publicDelegatedPrefixResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertGlobalPublicDelegatedPrefixeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest} InsertGlobalPublicDelegatedPrefixeRequest
                         */
                        InsertGlobalPublicDelegatedPrefixeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.publicDelegatedPrefixResource != null) {
                                if (typeof object.publicDelegatedPrefixResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest.publicDelegatedPrefixResource: object expected");
                                message.publicDelegatedPrefixResource = $root.google.cloud.compute.v1.PublicDelegatedPrefix.fromObject(object.publicDelegatedPrefixResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertGlobalPublicDelegatedPrefixeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest} message InsertGlobalPublicDelegatedPrefixeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertGlobalPublicDelegatedPrefixeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.publicDelegatedPrefixResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.publicDelegatedPrefixResource != null && message.hasOwnProperty("publicDelegatedPrefixResource"))
                                object.publicDelegatedPrefixResource = $root.google.cloud.compute.v1.PublicDelegatedPrefix.toObject(message.publicDelegatedPrefixResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertGlobalPublicDelegatedPrefixeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertGlobalPublicDelegatedPrefixeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertGlobalPublicDelegatedPrefixeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertGlobalPublicDelegatedPrefixeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest";
                        };
    
                        return InsertGlobalPublicDelegatedPrefixeRequest;
                    })();
    
                    v1.InsertHealthCheckRequest = (function() {
    
                        /**
                         * Properties of an InsertHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertHealthCheckRequest
                         * @property {google.cloud.compute.v1.IHealthCheck|null} [healthCheckResource] InsertHealthCheckRequest healthCheckResource
                         * @property {string|null} [project] InsertHealthCheckRequest project
                         * @property {string|null} [requestId] InsertHealthCheckRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertHealthCheckRequest.
                         * @implements IInsertHealthCheckRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertHealthCheckRequest=} [properties] Properties to set
                         */
                        function InsertHealthCheckRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertHealthCheckRequest healthCheckResource.
                         * @member {google.cloud.compute.v1.IHealthCheck|null|undefined} healthCheckResource
                         * @memberof google.cloud.compute.v1.InsertHealthCheckRequest
                         * @instance
                         */
                        InsertHealthCheckRequest.prototype.healthCheckResource = null;
    
                        /**
                         * InsertHealthCheckRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertHealthCheckRequest
                         * @instance
                         */
                        InsertHealthCheckRequest.prototype.project = "";
    
                        /**
                         * InsertHealthCheckRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertHealthCheckRequest
                         * @instance
                         */
                        InsertHealthCheckRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertHealthCheckRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertHealthCheckRequest
                         * @instance
                         */
                        Object.defineProperty(InsertHealthCheckRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertHealthCheckRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertHealthCheckRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertHealthCheckRequest} InsertHealthCheckRequest instance
                         */
                        InsertHealthCheckRequest.create = function create(properties) {
                            return new InsertHealthCheckRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertHealthCheckRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertHealthCheckRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertHealthCheckRequest} message InsertHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertHealthCheckRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.healthCheckResource != null && Object.hasOwnProperty.call(message, "healthCheckResource"))
                                $root.google.cloud.compute.v1.HealthCheck.encode(message.healthCheckResource, writer.uint32(/* id 201925032, wireType 2 =*/1615400258).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertHealthCheckRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertHealthCheckRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertHealthCheckRequest} message InsertHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertHealthCheckRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertHealthCheckRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertHealthCheckRequest} InsertHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertHealthCheckRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertHealthCheckRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 201925032: {
                                        message.healthCheckResource = $root.google.cloud.compute.v1.HealthCheck.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertHealthCheckRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertHealthCheckRequest} InsertHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertHealthCheckRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertHealthCheckRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertHealthCheckRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.healthCheckResource != null && message.hasOwnProperty("healthCheckResource")) {
                                var error = $root.google.cloud.compute.v1.HealthCheck.verify(message.healthCheckResource);
                                if (error)
                                    return "healthCheckResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertHealthCheckRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertHealthCheckRequest} InsertHealthCheckRequest
                         */
                        InsertHealthCheckRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertHealthCheckRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertHealthCheckRequest();
                            if (object.healthCheckResource != null) {
                                if (typeof object.healthCheckResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertHealthCheckRequest.healthCheckResource: object expected");
                                message.healthCheckResource = $root.google.cloud.compute.v1.HealthCheck.fromObject(object.healthCheckResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertHealthCheckRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertHealthCheckRequest} message InsertHealthCheckRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertHealthCheckRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.healthCheckResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.healthCheckResource != null && message.hasOwnProperty("healthCheckResource"))
                                object.healthCheckResource = $root.google.cloud.compute.v1.HealthCheck.toObject(message.healthCheckResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertHealthCheckRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertHealthCheckRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertHealthCheckRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertHealthCheckRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertHealthCheckRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertHealthCheckRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertHealthCheckRequest";
                        };
    
                        return InsertHealthCheckRequest;
                    })();
    
                    v1.InsertImageRequest = (function() {
    
                        /**
                         * Properties of an InsertImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertImageRequest
                         * @property {boolean|null} [forceCreate] InsertImageRequest forceCreate
                         * @property {google.cloud.compute.v1.IImage|null} [imageResource] InsertImageRequest imageResource
                         * @property {string|null} [project] InsertImageRequest project
                         * @property {string|null} [requestId] InsertImageRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertImageRequest.
                         * @implements IInsertImageRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertImageRequest=} [properties] Properties to set
                         */
                        function InsertImageRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertImageRequest forceCreate.
                         * @member {boolean|null|undefined} forceCreate
                         * @memberof google.cloud.compute.v1.InsertImageRequest
                         * @instance
                         */
                        InsertImageRequest.prototype.forceCreate = null;
    
                        /**
                         * InsertImageRequest imageResource.
                         * @member {google.cloud.compute.v1.IImage|null|undefined} imageResource
                         * @memberof google.cloud.compute.v1.InsertImageRequest
                         * @instance
                         */
                        InsertImageRequest.prototype.imageResource = null;
    
                        /**
                         * InsertImageRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertImageRequest
                         * @instance
                         */
                        InsertImageRequest.prototype.project = "";
    
                        /**
                         * InsertImageRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertImageRequest
                         * @instance
                         */
                        InsertImageRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertImageRequest _forceCreate.
                         * @member {"forceCreate"|undefined} _forceCreate
                         * @memberof google.cloud.compute.v1.InsertImageRequest
                         * @instance
                         */
                        Object.defineProperty(InsertImageRequest.prototype, "_forceCreate", {
                            get: $util.oneOfGetter($oneOfFields = ["forceCreate"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InsertImageRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertImageRequest
                         * @instance
                         */
                        Object.defineProperty(InsertImageRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertImageRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertImageRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertImageRequest} InsertImageRequest instance
                         */
                        InsertImageRequest.create = function create(properties) {
                            return new InsertImageRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertImageRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertImageRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertImageRequest} message InsertImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertImageRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.forceCreate != null && Object.hasOwnProperty.call(message, "forceCreate"))
                                writer.uint32(/* id 197723344, wireType 0 =*/1581786752).bool(message.forceCreate);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.imageResource != null && Object.hasOwnProperty.call(message, "imageResource"))
                                $root.google.cloud.compute.v1.Image.encode(message.imageResource, writer.uint32(/* id 371171954, wireType 2 =*/2969375634).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertImageRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertImageRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertImageRequest} message InsertImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertImageRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertImageRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertImageRequest} InsertImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertImageRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertImageRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 197723344: {
                                        message.forceCreate = reader.bool();
                                        break;
                                    }
                                case 371171954: {
                                        message.imageResource = $root.google.cloud.compute.v1.Image.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertImageRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertImageRequest} InsertImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertImageRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertImageRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertImageRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertImageRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.forceCreate != null && message.hasOwnProperty("forceCreate")) {
                                properties._forceCreate = 1;
                                if (typeof message.forceCreate !== "boolean")
                                    return "forceCreate: boolean expected";
                            }
                            if (message.imageResource != null && message.hasOwnProperty("imageResource")) {
                                var error = $root.google.cloud.compute.v1.Image.verify(message.imageResource);
                                if (error)
                                    return "imageResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertImageRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertImageRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertImageRequest} InsertImageRequest
                         */
                        InsertImageRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertImageRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertImageRequest();
                            if (object.forceCreate != null)
                                message.forceCreate = Boolean(object.forceCreate);
                            if (object.imageResource != null) {
                                if (typeof object.imageResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertImageRequest.imageResource: object expected");
                                message.imageResource = $root.google.cloud.compute.v1.Image.fromObject(object.imageResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertImageRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertImageRequest} message InsertImageRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertImageRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.imageResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.forceCreate != null && message.hasOwnProperty("forceCreate")) {
                                object.forceCreate = message.forceCreate;
                                if (options.oneofs)
                                    object._forceCreate = "forceCreate";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.imageResource != null && message.hasOwnProperty("imageResource"))
                                object.imageResource = $root.google.cloud.compute.v1.Image.toObject(message.imageResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertImageRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertImageRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertImageRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertImageRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertImageRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertImageRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertImageRequest";
                        };
    
                        return InsertImageRequest;
                    })();
    
                    v1.InsertInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of an InsertInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertInstanceGroupManagerRequest
                         * @property {google.cloud.compute.v1.IInstanceGroupManager|null} [instanceGroupManagerResource] InsertInstanceGroupManagerRequest instanceGroupManagerResource
                         * @property {string|null} [project] InsertInstanceGroupManagerRequest project
                         * @property {string|null} [requestId] InsertInstanceGroupManagerRequest requestId
                         * @property {string|null} [zone] InsertInstanceGroupManagerRequest zone
                         */
    
                        /**
                         * Constructs a new InsertInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertInstanceGroupManagerRequest.
                         * @implements IInsertInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function InsertInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertInstanceGroupManagerRequest instanceGroupManagerResource.
                         * @member {google.cloud.compute.v1.IInstanceGroupManager|null|undefined} instanceGroupManagerResource
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupManagerRequest
                         * @instance
                         */
                        InsertInstanceGroupManagerRequest.prototype.instanceGroupManagerResource = null;
    
                        /**
                         * InsertInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupManagerRequest
                         * @instance
                         */
                        InsertInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * InsertInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupManagerRequest
                         * @instance
                         */
                        InsertInstanceGroupManagerRequest.prototype.requestId = null;
    
                        /**
                         * InsertInstanceGroupManagerRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupManagerRequest
                         * @instance
                         */
                        InsertInstanceGroupManagerRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(InsertInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertInstanceGroupManagerRequest} InsertInstanceGroupManagerRequest instance
                         */
                        InsertInstanceGroupManagerRequest.create = function create(properties) {
                            return new InsertInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertInstanceGroupManagerRequest} message InsertInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManagerResource != null && Object.hasOwnProperty.call(message, "instanceGroupManagerResource"))
                                $root.google.cloud.compute.v1.InstanceGroupManager.encode(message.instanceGroupManagerResource, writer.uint32(/* id 261063946, wireType 2 =*/2088511570).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertInstanceGroupManagerRequest} message InsertInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertInstanceGroupManagerRequest} InsertInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 261063946: {
                                        message.instanceGroupManagerResource = $root.google.cloud.compute.v1.InstanceGroupManager.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertInstanceGroupManagerRequest} InsertInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManagerResource != null && message.hasOwnProperty("instanceGroupManagerResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceGroupManager.verify(message.instanceGroupManagerResource);
                                if (error)
                                    return "instanceGroupManagerResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an InsertInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertInstanceGroupManagerRequest} InsertInstanceGroupManagerRequest
                         */
                        InsertInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertInstanceGroupManagerRequest();
                            if (object.instanceGroupManagerResource != null) {
                                if (typeof object.instanceGroupManagerResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertInstanceGroupManagerRequest.instanceGroupManagerResource: object expected");
                                message.instanceGroupManagerResource = $root.google.cloud.compute.v1.InstanceGroupManager.fromObject(object.instanceGroupManagerResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertInstanceGroupManagerRequest} message InsertInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.instanceGroupManagerResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManagerResource != null && message.hasOwnProperty("instanceGroupManagerResource"))
                                object.instanceGroupManagerResource = $root.google.cloud.compute.v1.InstanceGroupManager.toObject(message.instanceGroupManagerResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertInstanceGroupManagerRequest";
                        };
    
                        return InsertInstanceGroupManagerRequest;
                    })();
    
                    v1.InsertInstanceGroupRequest = (function() {
    
                        /**
                         * Properties of an InsertInstanceGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertInstanceGroupRequest
                         * @property {google.cloud.compute.v1.IInstanceGroup|null} [instanceGroupResource] InsertInstanceGroupRequest instanceGroupResource
                         * @property {string|null} [project] InsertInstanceGroupRequest project
                         * @property {string|null} [requestId] InsertInstanceGroupRequest requestId
                         * @property {string|null} [zone] InsertInstanceGroupRequest zone
                         */
    
                        /**
                         * Constructs a new InsertInstanceGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertInstanceGroupRequest.
                         * @implements IInsertInstanceGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertInstanceGroupRequest=} [properties] Properties to set
                         */
                        function InsertInstanceGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertInstanceGroupRequest instanceGroupResource.
                         * @member {google.cloud.compute.v1.IInstanceGroup|null|undefined} instanceGroupResource
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupRequest
                         * @instance
                         */
                        InsertInstanceGroupRequest.prototype.instanceGroupResource = null;
    
                        /**
                         * InsertInstanceGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupRequest
                         * @instance
                         */
                        InsertInstanceGroupRequest.prototype.project = "";
    
                        /**
                         * InsertInstanceGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupRequest
                         * @instance
                         */
                        InsertInstanceGroupRequest.prototype.requestId = null;
    
                        /**
                         * InsertInstanceGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupRequest
                         * @instance
                         */
                        InsertInstanceGroupRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertInstanceGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupRequest
                         * @instance
                         */
                        Object.defineProperty(InsertInstanceGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertInstanceGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertInstanceGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertInstanceGroupRequest} InsertInstanceGroupRequest instance
                         */
                        InsertInstanceGroupRequest.create = function create(properties) {
                            return new InsertInstanceGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertInstanceGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertInstanceGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertInstanceGroupRequest} message InsertInstanceGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertInstanceGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupResource != null && Object.hasOwnProperty.call(message, "instanceGroupResource"))
                                $root.google.cloud.compute.v1.InstanceGroup.encode(message.instanceGroupResource, writer.uint32(/* id 286612152, wireType 2 =*/2292897218).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertInstanceGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertInstanceGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertInstanceGroupRequest} message InsertInstanceGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertInstanceGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertInstanceGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertInstanceGroupRequest} InsertInstanceGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertInstanceGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertInstanceGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 286612152: {
                                        message.instanceGroupResource = $root.google.cloud.compute.v1.InstanceGroup.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertInstanceGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertInstanceGroupRequest} InsertInstanceGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertInstanceGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertInstanceGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertInstanceGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupResource != null && message.hasOwnProperty("instanceGroupResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceGroup.verify(message.instanceGroupResource);
                                if (error)
                                    return "instanceGroupResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an InsertInstanceGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertInstanceGroupRequest} InsertInstanceGroupRequest
                         */
                        InsertInstanceGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertInstanceGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertInstanceGroupRequest();
                            if (object.instanceGroupResource != null) {
                                if (typeof object.instanceGroupResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertInstanceGroupRequest.instanceGroupResource: object expected");
                                message.instanceGroupResource = $root.google.cloud.compute.v1.InstanceGroup.fromObject(object.instanceGroupResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertInstanceGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertInstanceGroupRequest} message InsertInstanceGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertInstanceGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.instanceGroupResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupResource != null && message.hasOwnProperty("instanceGroupResource"))
                                object.instanceGroupResource = $root.google.cloud.compute.v1.InstanceGroup.toObject(message.instanceGroupResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertInstanceGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertInstanceGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertInstanceGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertInstanceGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertInstanceGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertInstanceGroupRequest";
                        };
    
                        return InsertInstanceGroupRequest;
                    })();
    
                    v1.InsertInstanceRequest = (function() {
    
                        /**
                         * Properties of an InsertInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertInstanceRequest
                         * @property {google.cloud.compute.v1.IInstance|null} [instanceResource] InsertInstanceRequest instanceResource
                         * @property {string|null} [project] InsertInstanceRequest project
                         * @property {string|null} [requestId] InsertInstanceRequest requestId
                         * @property {string|null} [sourceInstanceTemplate] InsertInstanceRequest sourceInstanceTemplate
                         * @property {string|null} [sourceMachineImage] InsertInstanceRequest sourceMachineImage
                         * @property {string|null} [zone] InsertInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new InsertInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertInstanceRequest.
                         * @implements IInsertInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertInstanceRequest=} [properties] Properties to set
                         */
                        function InsertInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertInstanceRequest instanceResource.
                         * @member {google.cloud.compute.v1.IInstance|null|undefined} instanceResource
                         * @memberof google.cloud.compute.v1.InsertInstanceRequest
                         * @instance
                         */
                        InsertInstanceRequest.prototype.instanceResource = null;
    
                        /**
                         * InsertInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertInstanceRequest
                         * @instance
                         */
                        InsertInstanceRequest.prototype.project = "";
    
                        /**
                         * InsertInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertInstanceRequest
                         * @instance
                         */
                        InsertInstanceRequest.prototype.requestId = null;
    
                        /**
                         * InsertInstanceRequest sourceInstanceTemplate.
                         * @member {string|null|undefined} sourceInstanceTemplate
                         * @memberof google.cloud.compute.v1.InsertInstanceRequest
                         * @instance
                         */
                        InsertInstanceRequest.prototype.sourceInstanceTemplate = null;
    
                        /**
                         * InsertInstanceRequest sourceMachineImage.
                         * @member {string|null|undefined} sourceMachineImage
                         * @memberof google.cloud.compute.v1.InsertInstanceRequest
                         * @instance
                         */
                        InsertInstanceRequest.prototype.sourceMachineImage = null;
    
                        /**
                         * InsertInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.InsertInstanceRequest
                         * @instance
                         */
                        InsertInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(InsertInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InsertInstanceRequest _sourceInstanceTemplate.
                         * @member {"sourceInstanceTemplate"|undefined} _sourceInstanceTemplate
                         * @memberof google.cloud.compute.v1.InsertInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(InsertInstanceRequest.prototype, "_sourceInstanceTemplate", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceInstanceTemplate"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InsertInstanceRequest _sourceMachineImage.
                         * @member {"sourceMachineImage"|undefined} _sourceMachineImage
                         * @memberof google.cloud.compute.v1.InsertInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(InsertInstanceRequest.prototype, "_sourceMachineImage", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceMachineImage"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertInstanceRequest} InsertInstanceRequest instance
                         */
                        InsertInstanceRequest.create = function create(properties) {
                            return new InsertInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertInstanceRequest} message InsertInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.sourceMachineImage != null && Object.hasOwnProperty.call(message, "sourceMachineImage"))
                                writer.uint32(/* id 21769791, wireType 2 =*/174158330).string(message.sourceMachineImage);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.instanceResource != null && Object.hasOwnProperty.call(message, "instanceResource"))
                                $root.google.cloud.compute.v1.Instance.encode(message.instanceResource, writer.uint32(/* id 215988344, wireType 2 =*/1727906754).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.sourceInstanceTemplate != null && Object.hasOwnProperty.call(message, "sourceInstanceTemplate"))
                                writer.uint32(/* id 332423616, wireType 2 =*/2659388930).string(message.sourceInstanceTemplate);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertInstanceRequest} message InsertInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertInstanceRequest} InsertInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 215988344: {
                                        message.instanceResource = $root.google.cloud.compute.v1.Instance.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 332423616: {
                                        message.sourceInstanceTemplate = reader.string();
                                        break;
                                    }
                                case 21769791: {
                                        message.sourceMachineImage = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertInstanceRequest} InsertInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceResource != null && message.hasOwnProperty("instanceResource")) {
                                var error = $root.google.cloud.compute.v1.Instance.verify(message.instanceResource);
                                if (error)
                                    return "instanceResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.sourceInstanceTemplate != null && message.hasOwnProperty("sourceInstanceTemplate")) {
                                properties._sourceInstanceTemplate = 1;
                                if (!$util.isString(message.sourceInstanceTemplate))
                                    return "sourceInstanceTemplate: string expected";
                            }
                            if (message.sourceMachineImage != null && message.hasOwnProperty("sourceMachineImage")) {
                                properties._sourceMachineImage = 1;
                                if (!$util.isString(message.sourceMachineImage))
                                    return "sourceMachineImage: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an InsertInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertInstanceRequest} InsertInstanceRequest
                         */
                        InsertInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertInstanceRequest();
                            if (object.instanceResource != null) {
                                if (typeof object.instanceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertInstanceRequest.instanceResource: object expected");
                                message.instanceResource = $root.google.cloud.compute.v1.Instance.fromObject(object.instanceResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.sourceInstanceTemplate != null)
                                message.sourceInstanceTemplate = String(object.sourceInstanceTemplate);
                            if (object.sourceMachineImage != null)
                                message.sourceMachineImage = String(object.sourceMachineImage);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertInstanceRequest} message InsertInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instanceResource = null;
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.sourceMachineImage != null && message.hasOwnProperty("sourceMachineImage")) {
                                object.sourceMachineImage = message.sourceMachineImage;
                                if (options.oneofs)
                                    object._sourceMachineImage = "sourceMachineImage";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.instanceResource != null && message.hasOwnProperty("instanceResource"))
                                object.instanceResource = $root.google.cloud.compute.v1.Instance.toObject(message.instanceResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.sourceInstanceTemplate != null && message.hasOwnProperty("sourceInstanceTemplate")) {
                                object.sourceInstanceTemplate = message.sourceInstanceTemplate;
                                if (options.oneofs)
                                    object._sourceInstanceTemplate = "sourceInstanceTemplate";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InsertInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertInstanceRequest";
                        };
    
                        return InsertInstanceRequest;
                    })();
    
                    v1.InsertInstanceTemplateRequest = (function() {
    
                        /**
                         * Properties of an InsertInstanceTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertInstanceTemplateRequest
                         * @property {google.cloud.compute.v1.IInstanceTemplate|null} [instanceTemplateResource] InsertInstanceTemplateRequest instanceTemplateResource
                         * @property {string|null} [project] InsertInstanceTemplateRequest project
                         * @property {string|null} [requestId] InsertInstanceTemplateRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertInstanceTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertInstanceTemplateRequest.
                         * @implements IInsertInstanceTemplateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertInstanceTemplateRequest=} [properties] Properties to set
                         */
                        function InsertInstanceTemplateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertInstanceTemplateRequest instanceTemplateResource.
                         * @member {google.cloud.compute.v1.IInstanceTemplate|null|undefined} instanceTemplateResource
                         * @memberof google.cloud.compute.v1.InsertInstanceTemplateRequest
                         * @instance
                         */
                        InsertInstanceTemplateRequest.prototype.instanceTemplateResource = null;
    
                        /**
                         * InsertInstanceTemplateRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertInstanceTemplateRequest
                         * @instance
                         */
                        InsertInstanceTemplateRequest.prototype.project = "";
    
                        /**
                         * InsertInstanceTemplateRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertInstanceTemplateRequest
                         * @instance
                         */
                        InsertInstanceTemplateRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertInstanceTemplateRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertInstanceTemplateRequest
                         * @instance
                         */
                        Object.defineProperty(InsertInstanceTemplateRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertInstanceTemplateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertInstanceTemplateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertInstanceTemplateRequest} InsertInstanceTemplateRequest instance
                         */
                        InsertInstanceTemplateRequest.create = function create(properties) {
                            return new InsertInstanceTemplateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertInstanceTemplateRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertInstanceTemplateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertInstanceTemplateRequest} message InsertInstanceTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertInstanceTemplateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instanceTemplateResource != null && Object.hasOwnProperty.call(message, "instanceTemplateResource"))
                                $root.google.cloud.compute.v1.InstanceTemplate.encode(message.instanceTemplateResource, writer.uint32(/* id 10679561, wireType 2 =*/85436490).fork()).ldelim();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertInstanceTemplateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertInstanceTemplateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertInstanceTemplateRequest} message InsertInstanceTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertInstanceTemplateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertInstanceTemplateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertInstanceTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertInstanceTemplateRequest} InsertInstanceTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertInstanceTemplateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertInstanceTemplateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 10679561: {
                                        message.instanceTemplateResource = $root.google.cloud.compute.v1.InstanceTemplate.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertInstanceTemplateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertInstanceTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertInstanceTemplateRequest} InsertInstanceTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertInstanceTemplateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertInstanceTemplateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertInstanceTemplateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertInstanceTemplateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceTemplateResource != null && message.hasOwnProperty("instanceTemplateResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceTemplate.verify(message.instanceTemplateResource);
                                if (error)
                                    return "instanceTemplateResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertInstanceTemplateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertInstanceTemplateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertInstanceTemplateRequest} InsertInstanceTemplateRequest
                         */
                        InsertInstanceTemplateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertInstanceTemplateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertInstanceTemplateRequest();
                            if (object.instanceTemplateResource != null) {
                                if (typeof object.instanceTemplateResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertInstanceTemplateRequest.instanceTemplateResource: object expected");
                                message.instanceTemplateResource = $root.google.cloud.compute.v1.InstanceTemplate.fromObject(object.instanceTemplateResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertInstanceTemplateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertInstanceTemplateRequest} message InsertInstanceTemplateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertInstanceTemplateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.instanceTemplateResource = null;
                                object.project = "";
                            }
                            if (message.instanceTemplateResource != null && message.hasOwnProperty("instanceTemplateResource"))
                                object.instanceTemplateResource = $root.google.cloud.compute.v1.InstanceTemplate.toObject(message.instanceTemplateResource, options);
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertInstanceTemplateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertInstanceTemplateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertInstanceTemplateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertInstanceTemplateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertInstanceTemplateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertInstanceTemplateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertInstanceTemplateRequest";
                        };
    
                        return InsertInstanceTemplateRequest;
                    })();
    
                    v1.InsertInterconnectAttachmentRequest = (function() {
    
                        /**
                         * Properties of an InsertInterconnectAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertInterconnectAttachmentRequest
                         * @property {google.cloud.compute.v1.IInterconnectAttachment|null} [interconnectAttachmentResource] InsertInterconnectAttachmentRequest interconnectAttachmentResource
                         * @property {string|null} [project] InsertInterconnectAttachmentRequest project
                         * @property {string|null} [region] InsertInterconnectAttachmentRequest region
                         * @property {string|null} [requestId] InsertInterconnectAttachmentRequest requestId
                         * @property {boolean|null} [validateOnly] InsertInterconnectAttachmentRequest validateOnly
                         */
    
                        /**
                         * Constructs a new InsertInterconnectAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertInterconnectAttachmentRequest.
                         * @implements IInsertInterconnectAttachmentRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertInterconnectAttachmentRequest=} [properties] Properties to set
                         */
                        function InsertInterconnectAttachmentRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertInterconnectAttachmentRequest interconnectAttachmentResource.
                         * @member {google.cloud.compute.v1.IInterconnectAttachment|null|undefined} interconnectAttachmentResource
                         * @memberof google.cloud.compute.v1.InsertInterconnectAttachmentRequest
                         * @instance
                         */
                        InsertInterconnectAttachmentRequest.prototype.interconnectAttachmentResource = null;
    
                        /**
                         * InsertInterconnectAttachmentRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertInterconnectAttachmentRequest
                         * @instance
                         */
                        InsertInterconnectAttachmentRequest.prototype.project = "";
    
                        /**
                         * InsertInterconnectAttachmentRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertInterconnectAttachmentRequest
                         * @instance
                         */
                        InsertInterconnectAttachmentRequest.prototype.region = "";
    
                        /**
                         * InsertInterconnectAttachmentRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertInterconnectAttachmentRequest
                         * @instance
                         */
                        InsertInterconnectAttachmentRequest.prototype.requestId = null;
    
                        /**
                         * InsertInterconnectAttachmentRequest validateOnly.
                         * @member {boolean|null|undefined} validateOnly
                         * @memberof google.cloud.compute.v1.InsertInterconnectAttachmentRequest
                         * @instance
                         */
                        InsertInterconnectAttachmentRequest.prototype.validateOnly = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertInterconnectAttachmentRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertInterconnectAttachmentRequest
                         * @instance
                         */
                        Object.defineProperty(InsertInterconnectAttachmentRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InsertInterconnectAttachmentRequest _validateOnly.
                         * @member {"validateOnly"|undefined} _validateOnly
                         * @memberof google.cloud.compute.v1.InsertInterconnectAttachmentRequest
                         * @instance
                         */
                        Object.defineProperty(InsertInterconnectAttachmentRequest.prototype, "_validateOnly", {
                            get: $util.oneOfGetter($oneOfFields = ["validateOnly"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertInterconnectAttachmentRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertInterconnectAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertInterconnectAttachmentRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertInterconnectAttachmentRequest} InsertInterconnectAttachmentRequest instance
                         */
                        InsertInterconnectAttachmentRequest.create = function create(properties) {
                            return new InsertInterconnectAttachmentRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertInterconnectAttachmentRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertInterconnectAttachmentRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertInterconnectAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertInterconnectAttachmentRequest} message InsertInterconnectAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertInterconnectAttachmentRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.interconnectAttachmentResource != null && Object.hasOwnProperty.call(message, "interconnectAttachmentResource"))
                                $root.google.cloud.compute.v1.InterconnectAttachment.encode(message.interconnectAttachmentResource, writer.uint32(/* id 212341369, wireType 2 =*/1698730954).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.validateOnly != null && Object.hasOwnProperty.call(message, "validateOnly"))
                                writer.uint32(/* id 242744629, wireType 0 =*/1941957032).bool(message.validateOnly);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertInterconnectAttachmentRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertInterconnectAttachmentRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertInterconnectAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertInterconnectAttachmentRequest} message InsertInterconnectAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertInterconnectAttachmentRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertInterconnectAttachmentRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertInterconnectAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertInterconnectAttachmentRequest} InsertInterconnectAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertInterconnectAttachmentRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertInterconnectAttachmentRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 212341369: {
                                        message.interconnectAttachmentResource = $root.google.cloud.compute.v1.InterconnectAttachment.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 242744629: {
                                        message.validateOnly = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertInterconnectAttachmentRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertInterconnectAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertInterconnectAttachmentRequest} InsertInterconnectAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertInterconnectAttachmentRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertInterconnectAttachmentRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertInterconnectAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertInterconnectAttachmentRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.interconnectAttachmentResource != null && message.hasOwnProperty("interconnectAttachmentResource")) {
                                var error = $root.google.cloud.compute.v1.InterconnectAttachment.verify(message.interconnectAttachmentResource);
                                if (error)
                                    return "interconnectAttachmentResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly")) {
                                properties._validateOnly = 1;
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertInterconnectAttachmentRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertInterconnectAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertInterconnectAttachmentRequest} InsertInterconnectAttachmentRequest
                         */
                        InsertInterconnectAttachmentRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertInterconnectAttachmentRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertInterconnectAttachmentRequest();
                            if (object.interconnectAttachmentResource != null) {
                                if (typeof object.interconnectAttachmentResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertInterconnectAttachmentRequest.interconnectAttachmentResource: object expected");
                                message.interconnectAttachmentResource = $root.google.cloud.compute.v1.InterconnectAttachment.fromObject(object.interconnectAttachmentResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertInterconnectAttachmentRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertInterconnectAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertInterconnectAttachmentRequest} message InsertInterconnectAttachmentRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertInterconnectAttachmentRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.interconnectAttachmentResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.interconnectAttachmentResource != null && message.hasOwnProperty("interconnectAttachmentResource"))
                                object.interconnectAttachmentResource = $root.google.cloud.compute.v1.InterconnectAttachment.toObject(message.interconnectAttachmentResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly")) {
                                object.validateOnly = message.validateOnly;
                                if (options.oneofs)
                                    object._validateOnly = "validateOnly";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InsertInterconnectAttachmentRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertInterconnectAttachmentRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertInterconnectAttachmentRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertInterconnectAttachmentRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertInterconnectAttachmentRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertInterconnectAttachmentRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertInterconnectAttachmentRequest";
                        };
    
                        return InsertInterconnectAttachmentRequest;
                    })();
    
                    v1.InsertInterconnectRequest = (function() {
    
                        /**
                         * Properties of an InsertInterconnectRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertInterconnectRequest
                         * @property {google.cloud.compute.v1.IInterconnect|null} [interconnectResource] InsertInterconnectRequest interconnectResource
                         * @property {string|null} [project] InsertInterconnectRequest project
                         * @property {string|null} [requestId] InsertInterconnectRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertInterconnectRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertInterconnectRequest.
                         * @implements IInsertInterconnectRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertInterconnectRequest=} [properties] Properties to set
                         */
                        function InsertInterconnectRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertInterconnectRequest interconnectResource.
                         * @member {google.cloud.compute.v1.IInterconnect|null|undefined} interconnectResource
                         * @memberof google.cloud.compute.v1.InsertInterconnectRequest
                         * @instance
                         */
                        InsertInterconnectRequest.prototype.interconnectResource = null;
    
                        /**
                         * InsertInterconnectRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertInterconnectRequest
                         * @instance
                         */
                        InsertInterconnectRequest.prototype.project = "";
    
                        /**
                         * InsertInterconnectRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertInterconnectRequest
                         * @instance
                         */
                        InsertInterconnectRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertInterconnectRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertInterconnectRequest
                         * @instance
                         */
                        Object.defineProperty(InsertInterconnectRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertInterconnectRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertInterconnectRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertInterconnectRequest} InsertInterconnectRequest instance
                         */
                        InsertInterconnectRequest.create = function create(properties) {
                            return new InsertInterconnectRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertInterconnectRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertInterconnectRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertInterconnectRequest} message InsertInterconnectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertInterconnectRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.interconnectResource != null && Object.hasOwnProperty.call(message, "interconnectResource"))
                                $root.google.cloud.compute.v1.Interconnect.encode(message.interconnectResource, writer.uint32(/* id 397611167, wireType 2 =*/3180889338).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertInterconnectRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertInterconnectRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertInterconnectRequest} message InsertInterconnectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertInterconnectRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertInterconnectRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertInterconnectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertInterconnectRequest} InsertInterconnectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertInterconnectRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertInterconnectRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 397611167: {
                                        message.interconnectResource = $root.google.cloud.compute.v1.Interconnect.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertInterconnectRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertInterconnectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertInterconnectRequest} InsertInterconnectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertInterconnectRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertInterconnectRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertInterconnectRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertInterconnectRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.interconnectResource != null && message.hasOwnProperty("interconnectResource")) {
                                var error = $root.google.cloud.compute.v1.Interconnect.verify(message.interconnectResource);
                                if (error)
                                    return "interconnectResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertInterconnectRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertInterconnectRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertInterconnectRequest} InsertInterconnectRequest
                         */
                        InsertInterconnectRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertInterconnectRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertInterconnectRequest();
                            if (object.interconnectResource != null) {
                                if (typeof object.interconnectResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertInterconnectRequest.interconnectResource: object expected");
                                message.interconnectResource = $root.google.cloud.compute.v1.Interconnect.fromObject(object.interconnectResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertInterconnectRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertInterconnectRequest} message InsertInterconnectRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertInterconnectRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.interconnectResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.interconnectResource != null && message.hasOwnProperty("interconnectResource"))
                                object.interconnectResource = $root.google.cloud.compute.v1.Interconnect.toObject(message.interconnectResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertInterconnectRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertInterconnectRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertInterconnectRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertInterconnectRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertInterconnectRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertInterconnectRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertInterconnectRequest";
                        };
    
                        return InsertInterconnectRequest;
                    })();
    
                    v1.InsertLicenseRequest = (function() {
    
                        /**
                         * Properties of an InsertLicenseRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertLicenseRequest
                         * @property {google.cloud.compute.v1.ILicense|null} [licenseResource] InsertLicenseRequest licenseResource
                         * @property {string|null} [project] InsertLicenseRequest project
                         * @property {string|null} [requestId] InsertLicenseRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertLicenseRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertLicenseRequest.
                         * @implements IInsertLicenseRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertLicenseRequest=} [properties] Properties to set
                         */
                        function InsertLicenseRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertLicenseRequest licenseResource.
                         * @member {google.cloud.compute.v1.ILicense|null|undefined} licenseResource
                         * @memberof google.cloud.compute.v1.InsertLicenseRequest
                         * @instance
                         */
                        InsertLicenseRequest.prototype.licenseResource = null;
    
                        /**
                         * InsertLicenseRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertLicenseRequest
                         * @instance
                         */
                        InsertLicenseRequest.prototype.project = "";
    
                        /**
                         * InsertLicenseRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertLicenseRequest
                         * @instance
                         */
                        InsertLicenseRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertLicenseRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertLicenseRequest
                         * @instance
                         */
                        Object.defineProperty(InsertLicenseRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertLicenseRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertLicenseRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertLicenseRequest} InsertLicenseRequest instance
                         */
                        InsertLicenseRequest.create = function create(properties) {
                            return new InsertLicenseRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertLicenseRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertLicenseRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertLicenseRequest} message InsertLicenseRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertLicenseRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.licenseResource != null && Object.hasOwnProperty.call(message, "licenseResource"))
                                $root.google.cloud.compute.v1.License.encode(message.licenseResource, writer.uint32(/* id 437955148, wireType 2 =*/3503641186).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertLicenseRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertLicenseRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertLicenseRequest} message InsertLicenseRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertLicenseRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertLicenseRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertLicenseRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertLicenseRequest} InsertLicenseRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertLicenseRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertLicenseRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 437955148: {
                                        message.licenseResource = $root.google.cloud.compute.v1.License.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertLicenseRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertLicenseRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertLicenseRequest} InsertLicenseRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertLicenseRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertLicenseRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertLicenseRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertLicenseRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.licenseResource != null && message.hasOwnProperty("licenseResource")) {
                                var error = $root.google.cloud.compute.v1.License.verify(message.licenseResource);
                                if (error)
                                    return "licenseResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertLicenseRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertLicenseRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertLicenseRequest} InsertLicenseRequest
                         */
                        InsertLicenseRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertLicenseRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertLicenseRequest();
                            if (object.licenseResource != null) {
                                if (typeof object.licenseResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertLicenseRequest.licenseResource: object expected");
                                message.licenseResource = $root.google.cloud.compute.v1.License.fromObject(object.licenseResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertLicenseRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertLicenseRequest} message InsertLicenseRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertLicenseRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.licenseResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.licenseResource != null && message.hasOwnProperty("licenseResource"))
                                object.licenseResource = $root.google.cloud.compute.v1.License.toObject(message.licenseResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertLicenseRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertLicenseRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertLicenseRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertLicenseRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertLicenseRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertLicenseRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertLicenseRequest";
                        };
    
                        return InsertLicenseRequest;
                    })();
    
                    v1.InsertMachineImageRequest = (function() {
    
                        /**
                         * Properties of an InsertMachineImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertMachineImageRequest
                         * @property {google.cloud.compute.v1.IMachineImage|null} [machineImageResource] InsertMachineImageRequest machineImageResource
                         * @property {string|null} [project] InsertMachineImageRequest project
                         * @property {string|null} [requestId] InsertMachineImageRequest requestId
                         * @property {string|null} [sourceInstance] InsertMachineImageRequest sourceInstance
                         */
    
                        /**
                         * Constructs a new InsertMachineImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertMachineImageRequest.
                         * @implements IInsertMachineImageRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertMachineImageRequest=} [properties] Properties to set
                         */
                        function InsertMachineImageRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertMachineImageRequest machineImageResource.
                         * @member {google.cloud.compute.v1.IMachineImage|null|undefined} machineImageResource
                         * @memberof google.cloud.compute.v1.InsertMachineImageRequest
                         * @instance
                         */
                        InsertMachineImageRequest.prototype.machineImageResource = null;
    
                        /**
                         * InsertMachineImageRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertMachineImageRequest
                         * @instance
                         */
                        InsertMachineImageRequest.prototype.project = "";
    
                        /**
                         * InsertMachineImageRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertMachineImageRequest
                         * @instance
                         */
                        InsertMachineImageRequest.prototype.requestId = null;
    
                        /**
                         * InsertMachineImageRequest sourceInstance.
                         * @member {string|null|undefined} sourceInstance
                         * @memberof google.cloud.compute.v1.InsertMachineImageRequest
                         * @instance
                         */
                        InsertMachineImageRequest.prototype.sourceInstance = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertMachineImageRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertMachineImageRequest
                         * @instance
                         */
                        Object.defineProperty(InsertMachineImageRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InsertMachineImageRequest _sourceInstance.
                         * @member {"sourceInstance"|undefined} _sourceInstance
                         * @memberof google.cloud.compute.v1.InsertMachineImageRequest
                         * @instance
                         */
                        Object.defineProperty(InsertMachineImageRequest.prototype, "_sourceInstance", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceInstance"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertMachineImageRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertMachineImageRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertMachineImageRequest} InsertMachineImageRequest instance
                         */
                        InsertMachineImageRequest.create = function create(properties) {
                            return new InsertMachineImageRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertMachineImageRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertMachineImageRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertMachineImageRequest} message InsertMachineImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertMachineImageRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.machineImageResource != null && Object.hasOwnProperty.call(message, "machineImageResource"))
                                $root.google.cloud.compute.v1.MachineImage.encode(message.machineImageResource, writer.uint32(/* id 60740970, wireType 2 =*/485927762).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.sourceInstance != null && Object.hasOwnProperty.call(message, "sourceInstance"))
                                writer.uint32(/* id 396315705, wireType 2 =*/3170525642).string(message.sourceInstance);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertMachineImageRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertMachineImageRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertMachineImageRequest} message InsertMachineImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertMachineImageRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertMachineImageRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertMachineImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertMachineImageRequest} InsertMachineImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertMachineImageRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertMachineImageRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 60740970: {
                                        message.machineImageResource = $root.google.cloud.compute.v1.MachineImage.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 396315705: {
                                        message.sourceInstance = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertMachineImageRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertMachineImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertMachineImageRequest} InsertMachineImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertMachineImageRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertMachineImageRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertMachineImageRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertMachineImageRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.machineImageResource != null && message.hasOwnProperty("machineImageResource")) {
                                var error = $root.google.cloud.compute.v1.MachineImage.verify(message.machineImageResource);
                                if (error)
                                    return "machineImageResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.sourceInstance != null && message.hasOwnProperty("sourceInstance")) {
                                properties._sourceInstance = 1;
                                if (!$util.isString(message.sourceInstance))
                                    return "sourceInstance: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertMachineImageRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertMachineImageRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertMachineImageRequest} InsertMachineImageRequest
                         */
                        InsertMachineImageRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertMachineImageRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertMachineImageRequest();
                            if (object.machineImageResource != null) {
                                if (typeof object.machineImageResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertMachineImageRequest.machineImageResource: object expected");
                                message.machineImageResource = $root.google.cloud.compute.v1.MachineImage.fromObject(object.machineImageResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.sourceInstance != null)
                                message.sourceInstance = String(object.sourceInstance);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertMachineImageRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertMachineImageRequest} message InsertMachineImageRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertMachineImageRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.machineImageResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.machineImageResource != null && message.hasOwnProperty("machineImageResource"))
                                object.machineImageResource = $root.google.cloud.compute.v1.MachineImage.toObject(message.machineImageResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.sourceInstance != null && message.hasOwnProperty("sourceInstance")) {
                                object.sourceInstance = message.sourceInstance;
                                if (options.oneofs)
                                    object._sourceInstance = "sourceInstance";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InsertMachineImageRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertMachineImageRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertMachineImageRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertMachineImageRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertMachineImageRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertMachineImageRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertMachineImageRequest";
                        };
    
                        return InsertMachineImageRequest;
                    })();
    
                    v1.InsertNetworkEdgeSecurityServiceRequest = (function() {
    
                        /**
                         * Properties of an InsertNetworkEdgeSecurityServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertNetworkEdgeSecurityServiceRequest
                         * @property {google.cloud.compute.v1.INetworkEdgeSecurityService|null} [networkEdgeSecurityServiceResource] InsertNetworkEdgeSecurityServiceRequest networkEdgeSecurityServiceResource
                         * @property {string|null} [project] InsertNetworkEdgeSecurityServiceRequest project
                         * @property {string|null} [region] InsertNetworkEdgeSecurityServiceRequest region
                         * @property {string|null} [requestId] InsertNetworkEdgeSecurityServiceRequest requestId
                         * @property {boolean|null} [validateOnly] InsertNetworkEdgeSecurityServiceRequest validateOnly
                         */
    
                        /**
                         * Constructs a new InsertNetworkEdgeSecurityServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertNetworkEdgeSecurityServiceRequest.
                         * @implements IInsertNetworkEdgeSecurityServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertNetworkEdgeSecurityServiceRequest=} [properties] Properties to set
                         */
                        function InsertNetworkEdgeSecurityServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertNetworkEdgeSecurityServiceRequest networkEdgeSecurityServiceResource.
                         * @member {google.cloud.compute.v1.INetworkEdgeSecurityService|null|undefined} networkEdgeSecurityServiceResource
                         * @memberof google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        InsertNetworkEdgeSecurityServiceRequest.prototype.networkEdgeSecurityServiceResource = null;
    
                        /**
                         * InsertNetworkEdgeSecurityServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        InsertNetworkEdgeSecurityServiceRequest.prototype.project = "";
    
                        /**
                         * InsertNetworkEdgeSecurityServiceRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        InsertNetworkEdgeSecurityServiceRequest.prototype.region = "";
    
                        /**
                         * InsertNetworkEdgeSecurityServiceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        InsertNetworkEdgeSecurityServiceRequest.prototype.requestId = null;
    
                        /**
                         * InsertNetworkEdgeSecurityServiceRequest validateOnly.
                         * @member {boolean|null|undefined} validateOnly
                         * @memberof google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        InsertNetworkEdgeSecurityServiceRequest.prototype.validateOnly = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertNetworkEdgeSecurityServiceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        Object.defineProperty(InsertNetworkEdgeSecurityServiceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InsertNetworkEdgeSecurityServiceRequest _validateOnly.
                         * @member {"validateOnly"|undefined} _validateOnly
                         * @memberof google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        Object.defineProperty(InsertNetworkEdgeSecurityServiceRequest.prototype, "_validateOnly", {
                            get: $util.oneOfGetter($oneOfFields = ["validateOnly"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertNetworkEdgeSecurityServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertNetworkEdgeSecurityServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest} InsertNetworkEdgeSecurityServiceRequest instance
                         */
                        InsertNetworkEdgeSecurityServiceRequest.create = function create(properties) {
                            return new InsertNetworkEdgeSecurityServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertNetworkEdgeSecurityServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertNetworkEdgeSecurityServiceRequest} message InsertNetworkEdgeSecurityServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertNetworkEdgeSecurityServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.validateOnly != null && Object.hasOwnProperty.call(message, "validateOnly"))
                                writer.uint32(/* id 242744629, wireType 0 =*/1941957032).bool(message.validateOnly);
                            if (message.networkEdgeSecurityServiceResource != null && Object.hasOwnProperty.call(message, "networkEdgeSecurityServiceResource"))
                                $root.google.cloud.compute.v1.NetworkEdgeSecurityService.encode(message.networkEdgeSecurityServiceResource, writer.uint32(/* id 477548966, wireType 2 =*/3820391730).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertNetworkEdgeSecurityServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertNetworkEdgeSecurityServiceRequest} message InsertNetworkEdgeSecurityServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertNetworkEdgeSecurityServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertNetworkEdgeSecurityServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest} InsertNetworkEdgeSecurityServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertNetworkEdgeSecurityServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 477548966: {
                                        message.networkEdgeSecurityServiceResource = $root.google.cloud.compute.v1.NetworkEdgeSecurityService.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 242744629: {
                                        message.validateOnly = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertNetworkEdgeSecurityServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest} InsertNetworkEdgeSecurityServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertNetworkEdgeSecurityServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertNetworkEdgeSecurityServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertNetworkEdgeSecurityServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.networkEdgeSecurityServiceResource != null && message.hasOwnProperty("networkEdgeSecurityServiceResource")) {
                                var error = $root.google.cloud.compute.v1.NetworkEdgeSecurityService.verify(message.networkEdgeSecurityServiceResource);
                                if (error)
                                    return "networkEdgeSecurityServiceResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly")) {
                                properties._validateOnly = 1;
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertNetworkEdgeSecurityServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest} InsertNetworkEdgeSecurityServiceRequest
                         */
                        InsertNetworkEdgeSecurityServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest();
                            if (object.networkEdgeSecurityServiceResource != null) {
                                if (typeof object.networkEdgeSecurityServiceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest.networkEdgeSecurityServiceResource: object expected");
                                message.networkEdgeSecurityServiceResource = $root.google.cloud.compute.v1.NetworkEdgeSecurityService.fromObject(object.networkEdgeSecurityServiceResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertNetworkEdgeSecurityServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest} message InsertNetworkEdgeSecurityServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertNetworkEdgeSecurityServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.networkEdgeSecurityServiceResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly")) {
                                object.validateOnly = message.validateOnly;
                                if (options.oneofs)
                                    object._validateOnly = "validateOnly";
                            }
                            if (message.networkEdgeSecurityServiceResource != null && message.hasOwnProperty("networkEdgeSecurityServiceResource"))
                                object.networkEdgeSecurityServiceResource = $root.google.cloud.compute.v1.NetworkEdgeSecurityService.toObject(message.networkEdgeSecurityServiceResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertNetworkEdgeSecurityServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertNetworkEdgeSecurityServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertNetworkEdgeSecurityServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertNetworkEdgeSecurityServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest";
                        };
    
                        return InsertNetworkEdgeSecurityServiceRequest;
                    })();
    
                    v1.InsertNetworkEndpointGroupRequest = (function() {
    
                        /**
                         * Properties of an InsertNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertNetworkEndpointGroupRequest
                         * @property {google.cloud.compute.v1.INetworkEndpointGroup|null} [networkEndpointGroupResource] InsertNetworkEndpointGroupRequest networkEndpointGroupResource
                         * @property {string|null} [project] InsertNetworkEndpointGroupRequest project
                         * @property {string|null} [requestId] InsertNetworkEndpointGroupRequest requestId
                         * @property {string|null} [zone] InsertNetworkEndpointGroupRequest zone
                         */
    
                        /**
                         * Constructs a new InsertNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertNetworkEndpointGroupRequest.
                         * @implements IInsertNetworkEndpointGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertNetworkEndpointGroupRequest=} [properties] Properties to set
                         */
                        function InsertNetworkEndpointGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertNetworkEndpointGroupRequest networkEndpointGroupResource.
                         * @member {google.cloud.compute.v1.INetworkEndpointGroup|null|undefined} networkEndpointGroupResource
                         * @memberof google.cloud.compute.v1.InsertNetworkEndpointGroupRequest
                         * @instance
                         */
                        InsertNetworkEndpointGroupRequest.prototype.networkEndpointGroupResource = null;
    
                        /**
                         * InsertNetworkEndpointGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertNetworkEndpointGroupRequest
                         * @instance
                         */
                        InsertNetworkEndpointGroupRequest.prototype.project = "";
    
                        /**
                         * InsertNetworkEndpointGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertNetworkEndpointGroupRequest
                         * @instance
                         */
                        InsertNetworkEndpointGroupRequest.prototype.requestId = null;
    
                        /**
                         * InsertNetworkEndpointGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.InsertNetworkEndpointGroupRequest
                         * @instance
                         */
                        InsertNetworkEndpointGroupRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertNetworkEndpointGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertNetworkEndpointGroupRequest
                         * @instance
                         */
                        Object.defineProperty(InsertNetworkEndpointGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertNetworkEndpointGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertNetworkEndpointGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertNetworkEndpointGroupRequest} InsertNetworkEndpointGroupRequest instance
                         */
                        InsertNetworkEndpointGroupRequest.create = function create(properties) {
                            return new InsertNetworkEndpointGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertNetworkEndpointGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertNetworkEndpointGroupRequest} message InsertNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertNetworkEndpointGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.networkEndpointGroupResource != null && Object.hasOwnProperty.call(message, "networkEndpointGroupResource"))
                                $root.google.cloud.compute.v1.NetworkEndpointGroup.encode(message.networkEndpointGroupResource, writer.uint32(/* id 525788839, wireType 2 =*/4206310714).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertNetworkEndpointGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertNetworkEndpointGroupRequest} message InsertNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertNetworkEndpointGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertNetworkEndpointGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertNetworkEndpointGroupRequest} InsertNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertNetworkEndpointGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertNetworkEndpointGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 525788839: {
                                        message.networkEndpointGroupResource = $root.google.cloud.compute.v1.NetworkEndpointGroup.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertNetworkEndpointGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertNetworkEndpointGroupRequest} InsertNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertNetworkEndpointGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertNetworkEndpointGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertNetworkEndpointGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.networkEndpointGroupResource != null && message.hasOwnProperty("networkEndpointGroupResource")) {
                                var error = $root.google.cloud.compute.v1.NetworkEndpointGroup.verify(message.networkEndpointGroupResource);
                                if (error)
                                    return "networkEndpointGroupResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an InsertNetworkEndpointGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertNetworkEndpointGroupRequest} InsertNetworkEndpointGroupRequest
                         */
                        InsertNetworkEndpointGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertNetworkEndpointGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertNetworkEndpointGroupRequest();
                            if (object.networkEndpointGroupResource != null) {
                                if (typeof object.networkEndpointGroupResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertNetworkEndpointGroupRequest.networkEndpointGroupResource: object expected");
                                message.networkEndpointGroupResource = $root.google.cloud.compute.v1.NetworkEndpointGroup.fromObject(object.networkEndpointGroupResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertNetworkEndpointGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertNetworkEndpointGroupRequest} message InsertNetworkEndpointGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertNetworkEndpointGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.networkEndpointGroupResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.networkEndpointGroupResource != null && message.hasOwnProperty("networkEndpointGroupResource"))
                                object.networkEndpointGroupResource = $root.google.cloud.compute.v1.NetworkEndpointGroup.toObject(message.networkEndpointGroupResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertNetworkEndpointGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertNetworkEndpointGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertNetworkEndpointGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertNetworkEndpointGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertNetworkEndpointGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertNetworkEndpointGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertNetworkEndpointGroupRequest";
                        };
    
                        return InsertNetworkEndpointGroupRequest;
                    })();
    
                    v1.InsertNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of an InsertNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertNetworkFirewallPolicyRequest
                         * @property {google.cloud.compute.v1.IFirewallPolicy|null} [firewallPolicyResource] InsertNetworkFirewallPolicyRequest firewallPolicyResource
                         * @property {string|null} [project] InsertNetworkFirewallPolicyRequest project
                         * @property {string|null} [requestId] InsertNetworkFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertNetworkFirewallPolicyRequest.
                         * @implements IInsertNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function InsertNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertNetworkFirewallPolicyRequest firewallPolicyResource.
                         * @member {google.cloud.compute.v1.IFirewallPolicy|null|undefined} firewallPolicyResource
                         * @memberof google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest
                         * @instance
                         */
                        InsertNetworkFirewallPolicyRequest.prototype.firewallPolicyResource = null;
    
                        /**
                         * InsertNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest
                         * @instance
                         */
                        InsertNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * InsertNetworkFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest
                         * @instance
                         */
                        InsertNetworkFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertNetworkFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(InsertNetworkFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest} InsertNetworkFirewallPolicyRequest instance
                         */
                        InsertNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new InsertNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertNetworkFirewallPolicyRequest} message InsertNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewallPolicyResource != null && Object.hasOwnProperty.call(message, "firewallPolicyResource"))
                                $root.google.cloud.compute.v1.FirewallPolicy.encode(message.firewallPolicyResource, writer.uint32(/* id 495049532, wireType 2 =*/3960396258).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertNetworkFirewallPolicyRequest} message InsertNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest} InsertNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 495049532: {
                                        message.firewallPolicyResource = $root.google.cloud.compute.v1.FirewallPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest} InsertNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicyResource != null && message.hasOwnProperty("firewallPolicyResource")) {
                                var error = $root.google.cloud.compute.v1.FirewallPolicy.verify(message.firewallPolicyResource);
                                if (error)
                                    return "firewallPolicyResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest} InsertNetworkFirewallPolicyRequest
                         */
                        InsertNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest();
                            if (object.firewallPolicyResource != null) {
                                if (typeof object.firewallPolicyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest.firewallPolicyResource: object expected");
                                message.firewallPolicyResource = $root.google.cloud.compute.v1.FirewallPolicy.fromObject(object.firewallPolicyResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest} message InsertNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.firewallPolicyResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewallPolicyResource != null && message.hasOwnProperty("firewallPolicyResource"))
                                object.firewallPolicyResource = $root.google.cloud.compute.v1.FirewallPolicy.toObject(message.firewallPolicyResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest";
                        };
    
                        return InsertNetworkFirewallPolicyRequest;
                    })();
    
                    v1.InsertNetworkRequest = (function() {
    
                        /**
                         * Properties of an InsertNetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertNetworkRequest
                         * @property {google.cloud.compute.v1.INetwork|null} [networkResource] InsertNetworkRequest networkResource
                         * @property {string|null} [project] InsertNetworkRequest project
                         * @property {string|null} [requestId] InsertNetworkRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertNetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertNetworkRequest.
                         * @implements IInsertNetworkRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertNetworkRequest=} [properties] Properties to set
                         */
                        function InsertNetworkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertNetworkRequest networkResource.
                         * @member {google.cloud.compute.v1.INetwork|null|undefined} networkResource
                         * @memberof google.cloud.compute.v1.InsertNetworkRequest
                         * @instance
                         */
                        InsertNetworkRequest.prototype.networkResource = null;
    
                        /**
                         * InsertNetworkRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertNetworkRequest
                         * @instance
                         */
                        InsertNetworkRequest.prototype.project = "";
    
                        /**
                         * InsertNetworkRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertNetworkRequest
                         * @instance
                         */
                        InsertNetworkRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertNetworkRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertNetworkRequest
                         * @instance
                         */
                        Object.defineProperty(InsertNetworkRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertNetworkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertNetworkRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertNetworkRequest} InsertNetworkRequest instance
                         */
                        InsertNetworkRequest.create = function create(properties) {
                            return new InsertNetworkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertNetworkRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertNetworkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertNetworkRequest} message InsertNetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertNetworkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.networkResource != null && Object.hasOwnProperty.call(message, "networkResource"))
                                $root.google.cloud.compute.v1.Network.encode(message.networkResource, writer.uint32(/* id 122105599, wireType 2 =*/976844794).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertNetworkRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertNetworkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertNetworkRequest} message InsertNetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertNetworkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertNetworkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertNetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertNetworkRequest} InsertNetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertNetworkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertNetworkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 122105599: {
                                        message.networkResource = $root.google.cloud.compute.v1.Network.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertNetworkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertNetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertNetworkRequest} InsertNetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertNetworkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertNetworkRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertNetworkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertNetworkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.networkResource != null && message.hasOwnProperty("networkResource")) {
                                var error = $root.google.cloud.compute.v1.Network.verify(message.networkResource);
                                if (error)
                                    return "networkResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertNetworkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertNetworkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertNetworkRequest} InsertNetworkRequest
                         */
                        InsertNetworkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertNetworkRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertNetworkRequest();
                            if (object.networkResource != null) {
                                if (typeof object.networkResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertNetworkRequest.networkResource: object expected");
                                message.networkResource = $root.google.cloud.compute.v1.Network.fromObject(object.networkResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertNetworkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertNetworkRequest} message InsertNetworkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertNetworkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.networkResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.networkResource != null && message.hasOwnProperty("networkResource"))
                                object.networkResource = $root.google.cloud.compute.v1.Network.toObject(message.networkResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertNetworkRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertNetworkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertNetworkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertNetworkRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertNetworkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertNetworkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertNetworkRequest";
                        };
    
                        return InsertNetworkRequest;
                    })();
    
                    v1.InsertNodeGroupRequest = (function() {
    
                        /**
                         * Properties of an InsertNodeGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertNodeGroupRequest
                         * @property {number|null} [initialNodeCount] InsertNodeGroupRequest initialNodeCount
                         * @property {google.cloud.compute.v1.INodeGroup|null} [nodeGroupResource] InsertNodeGroupRequest nodeGroupResource
                         * @property {string|null} [project] InsertNodeGroupRequest project
                         * @property {string|null} [requestId] InsertNodeGroupRequest requestId
                         * @property {string|null} [zone] InsertNodeGroupRequest zone
                         */
    
                        /**
                         * Constructs a new InsertNodeGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertNodeGroupRequest.
                         * @implements IInsertNodeGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertNodeGroupRequest=} [properties] Properties to set
                         */
                        function InsertNodeGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertNodeGroupRequest initialNodeCount.
                         * @member {number} initialNodeCount
                         * @memberof google.cloud.compute.v1.InsertNodeGroupRequest
                         * @instance
                         */
                        InsertNodeGroupRequest.prototype.initialNodeCount = 0;
    
                        /**
                         * InsertNodeGroupRequest nodeGroupResource.
                         * @member {google.cloud.compute.v1.INodeGroup|null|undefined} nodeGroupResource
                         * @memberof google.cloud.compute.v1.InsertNodeGroupRequest
                         * @instance
                         */
                        InsertNodeGroupRequest.prototype.nodeGroupResource = null;
    
                        /**
                         * InsertNodeGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertNodeGroupRequest
                         * @instance
                         */
                        InsertNodeGroupRequest.prototype.project = "";
    
                        /**
                         * InsertNodeGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertNodeGroupRequest
                         * @instance
                         */
                        InsertNodeGroupRequest.prototype.requestId = null;
    
                        /**
                         * InsertNodeGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.InsertNodeGroupRequest
                         * @instance
                         */
                        InsertNodeGroupRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertNodeGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertNodeGroupRequest
                         * @instance
                         */
                        Object.defineProperty(InsertNodeGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertNodeGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertNodeGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertNodeGroupRequest} InsertNodeGroupRequest instance
                         */
                        InsertNodeGroupRequest.create = function create(properties) {
                            return new InsertNodeGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertNodeGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertNodeGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertNodeGroupRequest} message InsertNodeGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertNodeGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.initialNodeCount != null && Object.hasOwnProperty.call(message, "initialNodeCount"))
                                writer.uint32(/* id 71951469, wireType 0 =*/575611752).int32(message.initialNodeCount);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.nodeGroupResource != null && Object.hasOwnProperty.call(message, "nodeGroupResource"))
                                $root.google.cloud.compute.v1.NodeGroup.encode(message.nodeGroupResource, writer.uint32(/* id 505321899, wireType 2 =*/4042575194).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertNodeGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertNodeGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertNodeGroupRequest} message InsertNodeGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertNodeGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertNodeGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertNodeGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertNodeGroupRequest} InsertNodeGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertNodeGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertNodeGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 71951469: {
                                        message.initialNodeCount = reader.int32();
                                        break;
                                    }
                                case 505321899: {
                                        message.nodeGroupResource = $root.google.cloud.compute.v1.NodeGroup.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertNodeGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertNodeGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertNodeGroupRequest} InsertNodeGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertNodeGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertNodeGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertNodeGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertNodeGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.initialNodeCount != null && message.hasOwnProperty("initialNodeCount"))
                                if (!$util.isInteger(message.initialNodeCount))
                                    return "initialNodeCount: integer expected";
                            if (message.nodeGroupResource != null && message.hasOwnProperty("nodeGroupResource")) {
                                var error = $root.google.cloud.compute.v1.NodeGroup.verify(message.nodeGroupResource);
                                if (error)
                                    return "nodeGroupResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an InsertNodeGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertNodeGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertNodeGroupRequest} InsertNodeGroupRequest
                         */
                        InsertNodeGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertNodeGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertNodeGroupRequest();
                            if (object.initialNodeCount != null)
                                message.initialNodeCount = object.initialNodeCount | 0;
                            if (object.nodeGroupResource != null) {
                                if (typeof object.nodeGroupResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertNodeGroupRequest.nodeGroupResource: object expected");
                                message.nodeGroupResource = $root.google.cloud.compute.v1.NodeGroup.fromObject(object.nodeGroupResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertNodeGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertNodeGroupRequest} message InsertNodeGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertNodeGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.initialNodeCount = 0;
                                object.project = "";
                                object.nodeGroupResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.initialNodeCount != null && message.hasOwnProperty("initialNodeCount"))
                                object.initialNodeCount = message.initialNodeCount;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.nodeGroupResource != null && message.hasOwnProperty("nodeGroupResource"))
                                object.nodeGroupResource = $root.google.cloud.compute.v1.NodeGroup.toObject(message.nodeGroupResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertNodeGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertNodeGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertNodeGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertNodeGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertNodeGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertNodeGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertNodeGroupRequest";
                        };
    
                        return InsertNodeGroupRequest;
                    })();
    
                    v1.InsertNodeTemplateRequest = (function() {
    
                        /**
                         * Properties of an InsertNodeTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertNodeTemplateRequest
                         * @property {google.cloud.compute.v1.INodeTemplate|null} [nodeTemplateResource] InsertNodeTemplateRequest nodeTemplateResource
                         * @property {string|null} [project] InsertNodeTemplateRequest project
                         * @property {string|null} [region] InsertNodeTemplateRequest region
                         * @property {string|null} [requestId] InsertNodeTemplateRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertNodeTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertNodeTemplateRequest.
                         * @implements IInsertNodeTemplateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertNodeTemplateRequest=} [properties] Properties to set
                         */
                        function InsertNodeTemplateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertNodeTemplateRequest nodeTemplateResource.
                         * @member {google.cloud.compute.v1.INodeTemplate|null|undefined} nodeTemplateResource
                         * @memberof google.cloud.compute.v1.InsertNodeTemplateRequest
                         * @instance
                         */
                        InsertNodeTemplateRequest.prototype.nodeTemplateResource = null;
    
                        /**
                         * InsertNodeTemplateRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertNodeTemplateRequest
                         * @instance
                         */
                        InsertNodeTemplateRequest.prototype.project = "";
    
                        /**
                         * InsertNodeTemplateRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertNodeTemplateRequest
                         * @instance
                         */
                        InsertNodeTemplateRequest.prototype.region = "";
    
                        /**
                         * InsertNodeTemplateRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertNodeTemplateRequest
                         * @instance
                         */
                        InsertNodeTemplateRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertNodeTemplateRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertNodeTemplateRequest
                         * @instance
                         */
                        Object.defineProperty(InsertNodeTemplateRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertNodeTemplateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertNodeTemplateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertNodeTemplateRequest} InsertNodeTemplateRequest instance
                         */
                        InsertNodeTemplateRequest.create = function create(properties) {
                            return new InsertNodeTemplateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertNodeTemplateRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertNodeTemplateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertNodeTemplateRequest} message InsertNodeTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertNodeTemplateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.nodeTemplateResource != null && Object.hasOwnProperty.call(message, "nodeTemplateResource"))
                                $root.google.cloud.compute.v1.NodeTemplate.encode(message.nodeTemplateResource, writer.uint32(/* id 127364406, wireType 2 =*/1018915250).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertNodeTemplateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertNodeTemplateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertNodeTemplateRequest} message InsertNodeTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertNodeTemplateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertNodeTemplateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertNodeTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertNodeTemplateRequest} InsertNodeTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertNodeTemplateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertNodeTemplateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 127364406: {
                                        message.nodeTemplateResource = $root.google.cloud.compute.v1.NodeTemplate.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertNodeTemplateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertNodeTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertNodeTemplateRequest} InsertNodeTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertNodeTemplateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertNodeTemplateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertNodeTemplateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertNodeTemplateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.nodeTemplateResource != null && message.hasOwnProperty("nodeTemplateResource")) {
                                var error = $root.google.cloud.compute.v1.NodeTemplate.verify(message.nodeTemplateResource);
                                if (error)
                                    return "nodeTemplateResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertNodeTemplateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertNodeTemplateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertNodeTemplateRequest} InsertNodeTemplateRequest
                         */
                        InsertNodeTemplateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertNodeTemplateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertNodeTemplateRequest();
                            if (object.nodeTemplateResource != null) {
                                if (typeof object.nodeTemplateResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertNodeTemplateRequest.nodeTemplateResource: object expected");
                                message.nodeTemplateResource = $root.google.cloud.compute.v1.NodeTemplate.fromObject(object.nodeTemplateResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertNodeTemplateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertNodeTemplateRequest} message InsertNodeTemplateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertNodeTemplateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.nodeTemplateResource = null;
                                object.region = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.nodeTemplateResource != null && message.hasOwnProperty("nodeTemplateResource"))
                                object.nodeTemplateResource = $root.google.cloud.compute.v1.NodeTemplate.toObject(message.nodeTemplateResource, options);
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertNodeTemplateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertNodeTemplateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertNodeTemplateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertNodeTemplateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertNodeTemplateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertNodeTemplateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertNodeTemplateRequest";
                        };
    
                        return InsertNodeTemplateRequest;
                    })();
    
                    v1.InsertPacketMirroringRequest = (function() {
    
                        /**
                         * Properties of an InsertPacketMirroringRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertPacketMirroringRequest
                         * @property {google.cloud.compute.v1.IPacketMirroring|null} [packetMirroringResource] InsertPacketMirroringRequest packetMirroringResource
                         * @property {string|null} [project] InsertPacketMirroringRequest project
                         * @property {string|null} [region] InsertPacketMirroringRequest region
                         * @property {string|null} [requestId] InsertPacketMirroringRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertPacketMirroringRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertPacketMirroringRequest.
                         * @implements IInsertPacketMirroringRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertPacketMirroringRequest=} [properties] Properties to set
                         */
                        function InsertPacketMirroringRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertPacketMirroringRequest packetMirroringResource.
                         * @member {google.cloud.compute.v1.IPacketMirroring|null|undefined} packetMirroringResource
                         * @memberof google.cloud.compute.v1.InsertPacketMirroringRequest
                         * @instance
                         */
                        InsertPacketMirroringRequest.prototype.packetMirroringResource = null;
    
                        /**
                         * InsertPacketMirroringRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertPacketMirroringRequest
                         * @instance
                         */
                        InsertPacketMirroringRequest.prototype.project = "";
    
                        /**
                         * InsertPacketMirroringRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertPacketMirroringRequest
                         * @instance
                         */
                        InsertPacketMirroringRequest.prototype.region = "";
    
                        /**
                         * InsertPacketMirroringRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertPacketMirroringRequest
                         * @instance
                         */
                        InsertPacketMirroringRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertPacketMirroringRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertPacketMirroringRequest
                         * @instance
                         */
                        Object.defineProperty(InsertPacketMirroringRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertPacketMirroringRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertPacketMirroringRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertPacketMirroringRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertPacketMirroringRequest} InsertPacketMirroringRequest instance
                         */
                        InsertPacketMirroringRequest.create = function create(properties) {
                            return new InsertPacketMirroringRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertPacketMirroringRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertPacketMirroringRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertPacketMirroringRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertPacketMirroringRequest} message InsertPacketMirroringRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertPacketMirroringRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.packetMirroringResource != null && Object.hasOwnProperty.call(message, "packetMirroringResource"))
                                $root.google.cloud.compute.v1.PacketMirroring.encode(message.packetMirroringResource, writer.uint32(/* id 493501985, wireType 2 =*/3948015882).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertPacketMirroringRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertPacketMirroringRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertPacketMirroringRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertPacketMirroringRequest} message InsertPacketMirroringRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertPacketMirroringRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertPacketMirroringRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertPacketMirroringRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertPacketMirroringRequest} InsertPacketMirroringRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertPacketMirroringRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertPacketMirroringRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 493501985: {
                                        message.packetMirroringResource = $root.google.cloud.compute.v1.PacketMirroring.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertPacketMirroringRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertPacketMirroringRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertPacketMirroringRequest} InsertPacketMirroringRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertPacketMirroringRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertPacketMirroringRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertPacketMirroringRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertPacketMirroringRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.packetMirroringResource != null && message.hasOwnProperty("packetMirroringResource")) {
                                var error = $root.google.cloud.compute.v1.PacketMirroring.verify(message.packetMirroringResource);
                                if (error)
                                    return "packetMirroringResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertPacketMirroringRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertPacketMirroringRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertPacketMirroringRequest} InsertPacketMirroringRequest
                         */
                        InsertPacketMirroringRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertPacketMirroringRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertPacketMirroringRequest();
                            if (object.packetMirroringResource != null) {
                                if (typeof object.packetMirroringResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertPacketMirroringRequest.packetMirroringResource: object expected");
                                message.packetMirroringResource = $root.google.cloud.compute.v1.PacketMirroring.fromObject(object.packetMirroringResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertPacketMirroringRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertPacketMirroringRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertPacketMirroringRequest} message InsertPacketMirroringRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertPacketMirroringRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.packetMirroringResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.packetMirroringResource != null && message.hasOwnProperty("packetMirroringResource"))
                                object.packetMirroringResource = $root.google.cloud.compute.v1.PacketMirroring.toObject(message.packetMirroringResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertPacketMirroringRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertPacketMirroringRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertPacketMirroringRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertPacketMirroringRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertPacketMirroringRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertPacketMirroringRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertPacketMirroringRequest";
                        };
    
                        return InsertPacketMirroringRequest;
                    })();
    
                    v1.InsertPublicAdvertisedPrefixeRequest = (function() {
    
                        /**
                         * Properties of an InsertPublicAdvertisedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertPublicAdvertisedPrefixeRequest
                         * @property {string|null} [project] InsertPublicAdvertisedPrefixeRequest project
                         * @property {google.cloud.compute.v1.IPublicAdvertisedPrefix|null} [publicAdvertisedPrefixResource] InsertPublicAdvertisedPrefixeRequest publicAdvertisedPrefixResource
                         * @property {string|null} [requestId] InsertPublicAdvertisedPrefixeRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertPublicAdvertisedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertPublicAdvertisedPrefixeRequest.
                         * @implements IInsertPublicAdvertisedPrefixeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertPublicAdvertisedPrefixeRequest=} [properties] Properties to set
                         */
                        function InsertPublicAdvertisedPrefixeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertPublicAdvertisedPrefixeRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest
                         * @instance
                         */
                        InsertPublicAdvertisedPrefixeRequest.prototype.project = "";
    
                        /**
                         * InsertPublicAdvertisedPrefixeRequest publicAdvertisedPrefixResource.
                         * @member {google.cloud.compute.v1.IPublicAdvertisedPrefix|null|undefined} publicAdvertisedPrefixResource
                         * @memberof google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest
                         * @instance
                         */
                        InsertPublicAdvertisedPrefixeRequest.prototype.publicAdvertisedPrefixResource = null;
    
                        /**
                         * InsertPublicAdvertisedPrefixeRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest
                         * @instance
                         */
                        InsertPublicAdvertisedPrefixeRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertPublicAdvertisedPrefixeRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest
                         * @instance
                         */
                        Object.defineProperty(InsertPublicAdvertisedPrefixeRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertPublicAdvertisedPrefixeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertPublicAdvertisedPrefixeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest} InsertPublicAdvertisedPrefixeRequest instance
                         */
                        InsertPublicAdvertisedPrefixeRequest.create = function create(properties) {
                            return new InsertPublicAdvertisedPrefixeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertPublicAdvertisedPrefixeRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertPublicAdvertisedPrefixeRequest} message InsertPublicAdvertisedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertPublicAdvertisedPrefixeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.publicAdvertisedPrefixResource != null && Object.hasOwnProperty.call(message, "publicAdvertisedPrefixResource"))
                                $root.google.cloud.compute.v1.PublicAdvertisedPrefix.encode(message.publicAdvertisedPrefixResource, writer.uint32(/* id 233614223, wireType 2 =*/1868913786).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertPublicAdvertisedPrefixeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertPublicAdvertisedPrefixeRequest} message InsertPublicAdvertisedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertPublicAdvertisedPrefixeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertPublicAdvertisedPrefixeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest} InsertPublicAdvertisedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertPublicAdvertisedPrefixeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 233614223: {
                                        message.publicAdvertisedPrefixResource = $root.google.cloud.compute.v1.PublicAdvertisedPrefix.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertPublicAdvertisedPrefixeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest} InsertPublicAdvertisedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertPublicAdvertisedPrefixeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertPublicAdvertisedPrefixeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertPublicAdvertisedPrefixeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.publicAdvertisedPrefixResource != null && message.hasOwnProperty("publicAdvertisedPrefixResource")) {
                                var error = $root.google.cloud.compute.v1.PublicAdvertisedPrefix.verify(message.publicAdvertisedPrefixResource);
                                if (error)
                                    return "publicAdvertisedPrefixResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertPublicAdvertisedPrefixeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest} InsertPublicAdvertisedPrefixeRequest
                         */
                        InsertPublicAdvertisedPrefixeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.publicAdvertisedPrefixResource != null) {
                                if (typeof object.publicAdvertisedPrefixResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest.publicAdvertisedPrefixResource: object expected");
                                message.publicAdvertisedPrefixResource = $root.google.cloud.compute.v1.PublicAdvertisedPrefix.fromObject(object.publicAdvertisedPrefixResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertPublicAdvertisedPrefixeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest} message InsertPublicAdvertisedPrefixeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertPublicAdvertisedPrefixeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.publicAdvertisedPrefixResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.publicAdvertisedPrefixResource != null && message.hasOwnProperty("publicAdvertisedPrefixResource"))
                                object.publicAdvertisedPrefixResource = $root.google.cloud.compute.v1.PublicAdvertisedPrefix.toObject(message.publicAdvertisedPrefixResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertPublicAdvertisedPrefixeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertPublicAdvertisedPrefixeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertPublicAdvertisedPrefixeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertPublicAdvertisedPrefixeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest";
                        };
    
                        return InsertPublicAdvertisedPrefixeRequest;
                    })();
    
                    v1.InsertPublicDelegatedPrefixeRequest = (function() {
    
                        /**
                         * Properties of an InsertPublicDelegatedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertPublicDelegatedPrefixeRequest
                         * @property {string|null} [project] InsertPublicDelegatedPrefixeRequest project
                         * @property {google.cloud.compute.v1.IPublicDelegatedPrefix|null} [publicDelegatedPrefixResource] InsertPublicDelegatedPrefixeRequest publicDelegatedPrefixResource
                         * @property {string|null} [region] InsertPublicDelegatedPrefixeRequest region
                         * @property {string|null} [requestId] InsertPublicDelegatedPrefixeRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertPublicDelegatedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertPublicDelegatedPrefixeRequest.
                         * @implements IInsertPublicDelegatedPrefixeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertPublicDelegatedPrefixeRequest=} [properties] Properties to set
                         */
                        function InsertPublicDelegatedPrefixeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertPublicDelegatedPrefixeRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        InsertPublicDelegatedPrefixeRequest.prototype.project = "";
    
                        /**
                         * InsertPublicDelegatedPrefixeRequest publicDelegatedPrefixResource.
                         * @member {google.cloud.compute.v1.IPublicDelegatedPrefix|null|undefined} publicDelegatedPrefixResource
                         * @memberof google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        InsertPublicDelegatedPrefixeRequest.prototype.publicDelegatedPrefixResource = null;
    
                        /**
                         * InsertPublicDelegatedPrefixeRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        InsertPublicDelegatedPrefixeRequest.prototype.region = "";
    
                        /**
                         * InsertPublicDelegatedPrefixeRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        InsertPublicDelegatedPrefixeRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertPublicDelegatedPrefixeRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        Object.defineProperty(InsertPublicDelegatedPrefixeRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertPublicDelegatedPrefixeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertPublicDelegatedPrefixeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest} InsertPublicDelegatedPrefixeRequest instance
                         */
                        InsertPublicDelegatedPrefixeRequest.create = function create(properties) {
                            return new InsertPublicDelegatedPrefixeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertPublicDelegatedPrefixeRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertPublicDelegatedPrefixeRequest} message InsertPublicDelegatedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertPublicDelegatedPrefixeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.publicDelegatedPrefixResource != null && Object.hasOwnProperty.call(message, "publicDelegatedPrefixResource"))
                                $root.google.cloud.compute.v1.PublicDelegatedPrefix.encode(message.publicDelegatedPrefixResource, writer.uint32(/* id 47594501, wireType 2 =*/380756010).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertPublicDelegatedPrefixeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertPublicDelegatedPrefixeRequest} message InsertPublicDelegatedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertPublicDelegatedPrefixeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertPublicDelegatedPrefixeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest} InsertPublicDelegatedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertPublicDelegatedPrefixeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 47594501: {
                                        message.publicDelegatedPrefixResource = $root.google.cloud.compute.v1.PublicDelegatedPrefix.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertPublicDelegatedPrefixeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest} InsertPublicDelegatedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertPublicDelegatedPrefixeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertPublicDelegatedPrefixeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertPublicDelegatedPrefixeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.publicDelegatedPrefixResource != null && message.hasOwnProperty("publicDelegatedPrefixResource")) {
                                var error = $root.google.cloud.compute.v1.PublicDelegatedPrefix.verify(message.publicDelegatedPrefixResource);
                                if (error)
                                    return "publicDelegatedPrefixResource." + error;
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertPublicDelegatedPrefixeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest} InsertPublicDelegatedPrefixeRequest
                         */
                        InsertPublicDelegatedPrefixeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.publicDelegatedPrefixResource != null) {
                                if (typeof object.publicDelegatedPrefixResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest.publicDelegatedPrefixResource: object expected");
                                message.publicDelegatedPrefixResource = $root.google.cloud.compute.v1.PublicDelegatedPrefix.fromObject(object.publicDelegatedPrefixResource);
                            }
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertPublicDelegatedPrefixeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest} message InsertPublicDelegatedPrefixeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertPublicDelegatedPrefixeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.publicDelegatedPrefixResource = null;
                                object.region = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.publicDelegatedPrefixResource != null && message.hasOwnProperty("publicDelegatedPrefixResource"))
                                object.publicDelegatedPrefixResource = $root.google.cloud.compute.v1.PublicDelegatedPrefix.toObject(message.publicDelegatedPrefixResource, options);
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertPublicDelegatedPrefixeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertPublicDelegatedPrefixeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertPublicDelegatedPrefixeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertPublicDelegatedPrefixeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest";
                        };
    
                        return InsertPublicDelegatedPrefixeRequest;
                    })();
    
                    v1.InsertRegionAutoscalerRequest = (function() {
    
                        /**
                         * Properties of an InsertRegionAutoscalerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertRegionAutoscalerRequest
                         * @property {google.cloud.compute.v1.IAutoscaler|null} [autoscalerResource] InsertRegionAutoscalerRequest autoscalerResource
                         * @property {string|null} [project] InsertRegionAutoscalerRequest project
                         * @property {string|null} [region] InsertRegionAutoscalerRequest region
                         * @property {string|null} [requestId] InsertRegionAutoscalerRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertRegionAutoscalerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertRegionAutoscalerRequest.
                         * @implements IInsertRegionAutoscalerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertRegionAutoscalerRequest=} [properties] Properties to set
                         */
                        function InsertRegionAutoscalerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertRegionAutoscalerRequest autoscalerResource.
                         * @member {google.cloud.compute.v1.IAutoscaler|null|undefined} autoscalerResource
                         * @memberof google.cloud.compute.v1.InsertRegionAutoscalerRequest
                         * @instance
                         */
                        InsertRegionAutoscalerRequest.prototype.autoscalerResource = null;
    
                        /**
                         * InsertRegionAutoscalerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertRegionAutoscalerRequest
                         * @instance
                         */
                        InsertRegionAutoscalerRequest.prototype.project = "";
    
                        /**
                         * InsertRegionAutoscalerRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertRegionAutoscalerRequest
                         * @instance
                         */
                        InsertRegionAutoscalerRequest.prototype.region = "";
    
                        /**
                         * InsertRegionAutoscalerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertRegionAutoscalerRequest
                         * @instance
                         */
                        InsertRegionAutoscalerRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertRegionAutoscalerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertRegionAutoscalerRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRegionAutoscalerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertRegionAutoscalerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertRegionAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionAutoscalerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertRegionAutoscalerRequest} InsertRegionAutoscalerRequest instance
                         */
                        InsertRegionAutoscalerRequest.create = function create(properties) {
                            return new InsertRegionAutoscalerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertRegionAutoscalerRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertRegionAutoscalerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertRegionAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionAutoscalerRequest} message InsertRegionAutoscalerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionAutoscalerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.autoscalerResource != null && Object.hasOwnProperty.call(message, "autoscalerResource"))
                                $root.google.cloud.compute.v1.Autoscaler.encode(message.autoscalerResource, writer.uint32(/* id 207616118, wireType 2 =*/1660928946).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertRegionAutoscalerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertRegionAutoscalerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionAutoscalerRequest} message InsertRegionAutoscalerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionAutoscalerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertRegionAutoscalerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertRegionAutoscalerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertRegionAutoscalerRequest} InsertRegionAutoscalerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionAutoscalerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertRegionAutoscalerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 207616118: {
                                        message.autoscalerResource = $root.google.cloud.compute.v1.Autoscaler.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertRegionAutoscalerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionAutoscalerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertRegionAutoscalerRequest} InsertRegionAutoscalerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionAutoscalerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertRegionAutoscalerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertRegionAutoscalerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertRegionAutoscalerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoscalerResource != null && message.hasOwnProperty("autoscalerResource")) {
                                var error = $root.google.cloud.compute.v1.Autoscaler.verify(message.autoscalerResource);
                                if (error)
                                    return "autoscalerResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertRegionAutoscalerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertRegionAutoscalerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertRegionAutoscalerRequest} InsertRegionAutoscalerRequest
                         */
                        InsertRegionAutoscalerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertRegionAutoscalerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertRegionAutoscalerRequest();
                            if (object.autoscalerResource != null) {
                                if (typeof object.autoscalerResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertRegionAutoscalerRequest.autoscalerResource: object expected");
                                message.autoscalerResource = $root.google.cloud.compute.v1.Autoscaler.fromObject(object.autoscalerResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertRegionAutoscalerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertRegionAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertRegionAutoscalerRequest} message InsertRegionAutoscalerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertRegionAutoscalerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.autoscalerResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.autoscalerResource != null && message.hasOwnProperty("autoscalerResource"))
                                object.autoscalerResource = $root.google.cloud.compute.v1.Autoscaler.toObject(message.autoscalerResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertRegionAutoscalerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertRegionAutoscalerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertRegionAutoscalerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertRegionAutoscalerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertRegionAutoscalerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertRegionAutoscalerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertRegionAutoscalerRequest";
                        };
    
                        return InsertRegionAutoscalerRequest;
                    })();
    
                    v1.InsertRegionBackendServiceRequest = (function() {
    
                        /**
                         * Properties of an InsertRegionBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertRegionBackendServiceRequest
                         * @property {google.cloud.compute.v1.IBackendService|null} [backendServiceResource] InsertRegionBackendServiceRequest backendServiceResource
                         * @property {string|null} [project] InsertRegionBackendServiceRequest project
                         * @property {string|null} [region] InsertRegionBackendServiceRequest region
                         * @property {string|null} [requestId] InsertRegionBackendServiceRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertRegionBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertRegionBackendServiceRequest.
                         * @implements IInsertRegionBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertRegionBackendServiceRequest=} [properties] Properties to set
                         */
                        function InsertRegionBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertRegionBackendServiceRequest backendServiceResource.
                         * @member {google.cloud.compute.v1.IBackendService|null|undefined} backendServiceResource
                         * @memberof google.cloud.compute.v1.InsertRegionBackendServiceRequest
                         * @instance
                         */
                        InsertRegionBackendServiceRequest.prototype.backendServiceResource = null;
    
                        /**
                         * InsertRegionBackendServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertRegionBackendServiceRequest
                         * @instance
                         */
                        InsertRegionBackendServiceRequest.prototype.project = "";
    
                        /**
                         * InsertRegionBackendServiceRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertRegionBackendServiceRequest
                         * @instance
                         */
                        InsertRegionBackendServiceRequest.prototype.region = "";
    
                        /**
                         * InsertRegionBackendServiceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertRegionBackendServiceRequest
                         * @instance
                         */
                        InsertRegionBackendServiceRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertRegionBackendServiceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertRegionBackendServiceRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRegionBackendServiceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertRegionBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertRegionBackendServiceRequest} InsertRegionBackendServiceRequest instance
                         */
                        InsertRegionBackendServiceRequest.create = function create(properties) {
                            return new InsertRegionBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertRegionBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertRegionBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionBackendServiceRequest} message InsertRegionBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.backendServiceResource != null && Object.hasOwnProperty.call(message, "backendServiceResource"))
                                $root.google.cloud.compute.v1.BackendService.encode(message.backendServiceResource, writer.uint32(/* id 347586723, wireType 2 =*/2780693786).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertRegionBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertRegionBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionBackendServiceRequest} message InsertRegionBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertRegionBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertRegionBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertRegionBackendServiceRequest} InsertRegionBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertRegionBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 347586723: {
                                        message.backendServiceResource = $root.google.cloud.compute.v1.BackendService.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertRegionBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertRegionBackendServiceRequest} InsertRegionBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertRegionBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertRegionBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertRegionBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendServiceResource != null && message.hasOwnProperty("backendServiceResource")) {
                                var error = $root.google.cloud.compute.v1.BackendService.verify(message.backendServiceResource);
                                if (error)
                                    return "backendServiceResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertRegionBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertRegionBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertRegionBackendServiceRequest} InsertRegionBackendServiceRequest
                         */
                        InsertRegionBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertRegionBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertRegionBackendServiceRequest();
                            if (object.backendServiceResource != null) {
                                if (typeof object.backendServiceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertRegionBackendServiceRequest.backendServiceResource: object expected");
                                message.backendServiceResource = $root.google.cloud.compute.v1.BackendService.fromObject(object.backendServiceResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertRegionBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertRegionBackendServiceRequest} message InsertRegionBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertRegionBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.backendServiceResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.backendServiceResource != null && message.hasOwnProperty("backendServiceResource"))
                                object.backendServiceResource = $root.google.cloud.compute.v1.BackendService.toObject(message.backendServiceResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertRegionBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertRegionBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertRegionBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertRegionBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertRegionBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertRegionBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertRegionBackendServiceRequest";
                        };
    
                        return InsertRegionBackendServiceRequest;
                    })();
    
                    v1.InsertRegionCommitmentRequest = (function() {
    
                        /**
                         * Properties of an InsertRegionCommitmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertRegionCommitmentRequest
                         * @property {google.cloud.compute.v1.ICommitment|null} [commitmentResource] InsertRegionCommitmentRequest commitmentResource
                         * @property {string|null} [project] InsertRegionCommitmentRequest project
                         * @property {string|null} [region] InsertRegionCommitmentRequest region
                         * @property {string|null} [requestId] InsertRegionCommitmentRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertRegionCommitmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertRegionCommitmentRequest.
                         * @implements IInsertRegionCommitmentRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertRegionCommitmentRequest=} [properties] Properties to set
                         */
                        function InsertRegionCommitmentRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertRegionCommitmentRequest commitmentResource.
                         * @member {google.cloud.compute.v1.ICommitment|null|undefined} commitmentResource
                         * @memberof google.cloud.compute.v1.InsertRegionCommitmentRequest
                         * @instance
                         */
                        InsertRegionCommitmentRequest.prototype.commitmentResource = null;
    
                        /**
                         * InsertRegionCommitmentRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertRegionCommitmentRequest
                         * @instance
                         */
                        InsertRegionCommitmentRequest.prototype.project = "";
    
                        /**
                         * InsertRegionCommitmentRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertRegionCommitmentRequest
                         * @instance
                         */
                        InsertRegionCommitmentRequest.prototype.region = "";
    
                        /**
                         * InsertRegionCommitmentRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertRegionCommitmentRequest
                         * @instance
                         */
                        InsertRegionCommitmentRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertRegionCommitmentRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertRegionCommitmentRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRegionCommitmentRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertRegionCommitmentRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertRegionCommitmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionCommitmentRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertRegionCommitmentRequest} InsertRegionCommitmentRequest instance
                         */
                        InsertRegionCommitmentRequest.create = function create(properties) {
                            return new InsertRegionCommitmentRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertRegionCommitmentRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertRegionCommitmentRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertRegionCommitmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionCommitmentRequest} message InsertRegionCommitmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionCommitmentRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.commitmentResource != null && Object.hasOwnProperty.call(message, "commitmentResource"))
                                $root.google.cloud.compute.v1.Commitment.encode(message.commitmentResource, writer.uint32(/* id 244240888, wireType 2 =*/1953927106).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertRegionCommitmentRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertRegionCommitmentRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionCommitmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionCommitmentRequest} message InsertRegionCommitmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionCommitmentRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertRegionCommitmentRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertRegionCommitmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertRegionCommitmentRequest} InsertRegionCommitmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionCommitmentRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertRegionCommitmentRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 244240888: {
                                        message.commitmentResource = $root.google.cloud.compute.v1.Commitment.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertRegionCommitmentRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionCommitmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertRegionCommitmentRequest} InsertRegionCommitmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionCommitmentRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertRegionCommitmentRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertRegionCommitmentRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertRegionCommitmentRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.commitmentResource != null && message.hasOwnProperty("commitmentResource")) {
                                var error = $root.google.cloud.compute.v1.Commitment.verify(message.commitmentResource);
                                if (error)
                                    return "commitmentResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertRegionCommitmentRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertRegionCommitmentRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertRegionCommitmentRequest} InsertRegionCommitmentRequest
                         */
                        InsertRegionCommitmentRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertRegionCommitmentRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertRegionCommitmentRequest();
                            if (object.commitmentResource != null) {
                                if (typeof object.commitmentResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertRegionCommitmentRequest.commitmentResource: object expected");
                                message.commitmentResource = $root.google.cloud.compute.v1.Commitment.fromObject(object.commitmentResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertRegionCommitmentRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertRegionCommitmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertRegionCommitmentRequest} message InsertRegionCommitmentRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertRegionCommitmentRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.commitmentResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.commitmentResource != null && message.hasOwnProperty("commitmentResource"))
                                object.commitmentResource = $root.google.cloud.compute.v1.Commitment.toObject(message.commitmentResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertRegionCommitmentRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertRegionCommitmentRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertRegionCommitmentRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertRegionCommitmentRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertRegionCommitmentRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertRegionCommitmentRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertRegionCommitmentRequest";
                        };
    
                        return InsertRegionCommitmentRequest;
                    })();
    
                    v1.InsertRegionDiskRequest = (function() {
    
                        /**
                         * Properties of an InsertRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertRegionDiskRequest
                         * @property {google.cloud.compute.v1.IDisk|null} [diskResource] InsertRegionDiskRequest diskResource
                         * @property {string|null} [project] InsertRegionDiskRequest project
                         * @property {string|null} [region] InsertRegionDiskRequest region
                         * @property {string|null} [requestId] InsertRegionDiskRequest requestId
                         * @property {string|null} [sourceImage] InsertRegionDiskRequest sourceImage
                         */
    
                        /**
                         * Constructs a new InsertRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertRegionDiskRequest.
                         * @implements IInsertRegionDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertRegionDiskRequest=} [properties] Properties to set
                         */
                        function InsertRegionDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertRegionDiskRequest diskResource.
                         * @member {google.cloud.compute.v1.IDisk|null|undefined} diskResource
                         * @memberof google.cloud.compute.v1.InsertRegionDiskRequest
                         * @instance
                         */
                        InsertRegionDiskRequest.prototype.diskResource = null;
    
                        /**
                         * InsertRegionDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertRegionDiskRequest
                         * @instance
                         */
                        InsertRegionDiskRequest.prototype.project = "";
    
                        /**
                         * InsertRegionDiskRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertRegionDiskRequest
                         * @instance
                         */
                        InsertRegionDiskRequest.prototype.region = "";
    
                        /**
                         * InsertRegionDiskRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertRegionDiskRequest
                         * @instance
                         */
                        InsertRegionDiskRequest.prototype.requestId = null;
    
                        /**
                         * InsertRegionDiskRequest sourceImage.
                         * @member {string|null|undefined} sourceImage
                         * @memberof google.cloud.compute.v1.InsertRegionDiskRequest
                         * @instance
                         */
                        InsertRegionDiskRequest.prototype.sourceImage = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertRegionDiskRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertRegionDiskRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRegionDiskRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InsertRegionDiskRequest _sourceImage.
                         * @member {"sourceImage"|undefined} _sourceImage
                         * @memberof google.cloud.compute.v1.InsertRegionDiskRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRegionDiskRequest.prototype, "_sourceImage", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceImage"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertRegionDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertRegionDiskRequest} InsertRegionDiskRequest instance
                         */
                        InsertRegionDiskRequest.create = function create(properties) {
                            return new InsertRegionDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertRegionDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertRegionDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionDiskRequest} message InsertRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.diskResource != null && Object.hasOwnProperty.call(message, "diskResource"))
                                $root.google.cloud.compute.v1.Disk.encode(message.diskResource, writer.uint32(/* id 25880688, wireType 2 =*/207045506).fork()).ldelim();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.sourceImage != null && Object.hasOwnProperty.call(message, "sourceImage"))
                                writer.uint32(/* id 50443319, wireType 2 =*/403546554).string(message.sourceImage);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertRegionDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertRegionDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionDiskRequest} message InsertRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertRegionDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertRegionDiskRequest} InsertRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertRegionDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 25880688: {
                                        message.diskResource = $root.google.cloud.compute.v1.Disk.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 50443319: {
                                        message.sourceImage = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertRegionDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertRegionDiskRequest} InsertRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertRegionDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertRegionDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.diskResource != null && message.hasOwnProperty("diskResource")) {
                                var error = $root.google.cloud.compute.v1.Disk.verify(message.diskResource);
                                if (error)
                                    return "diskResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.sourceImage != null && message.hasOwnProperty("sourceImage")) {
                                properties._sourceImage = 1;
                                if (!$util.isString(message.sourceImage))
                                    return "sourceImage: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertRegionDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertRegionDiskRequest} InsertRegionDiskRequest
                         */
                        InsertRegionDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertRegionDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertRegionDiskRequest();
                            if (object.diskResource != null) {
                                if (typeof object.diskResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertRegionDiskRequest.diskResource: object expected");
                                message.diskResource = $root.google.cloud.compute.v1.Disk.fromObject(object.diskResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.sourceImage != null)
                                message.sourceImage = String(object.sourceImage);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertRegionDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertRegionDiskRequest} message InsertRegionDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertRegionDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.diskResource = null;
                                object.region = "";
                                object.project = "";
                            }
                            if (message.diskResource != null && message.hasOwnProperty("diskResource"))
                                object.diskResource = $root.google.cloud.compute.v1.Disk.toObject(message.diskResource, options);
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.sourceImage != null && message.hasOwnProperty("sourceImage")) {
                                object.sourceImage = message.sourceImage;
                                if (options.oneofs)
                                    object._sourceImage = "sourceImage";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertRegionDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertRegionDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertRegionDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertRegionDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertRegionDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertRegionDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertRegionDiskRequest";
                        };
    
                        return InsertRegionDiskRequest;
                    })();
    
                    v1.InsertRegionHealthCheckRequest = (function() {
    
                        /**
                         * Properties of an InsertRegionHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertRegionHealthCheckRequest
                         * @property {google.cloud.compute.v1.IHealthCheck|null} [healthCheckResource] InsertRegionHealthCheckRequest healthCheckResource
                         * @property {string|null} [project] InsertRegionHealthCheckRequest project
                         * @property {string|null} [region] InsertRegionHealthCheckRequest region
                         * @property {string|null} [requestId] InsertRegionHealthCheckRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertRegionHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertRegionHealthCheckRequest.
                         * @implements IInsertRegionHealthCheckRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertRegionHealthCheckRequest=} [properties] Properties to set
                         */
                        function InsertRegionHealthCheckRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertRegionHealthCheckRequest healthCheckResource.
                         * @member {google.cloud.compute.v1.IHealthCheck|null|undefined} healthCheckResource
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckRequest
                         * @instance
                         */
                        InsertRegionHealthCheckRequest.prototype.healthCheckResource = null;
    
                        /**
                         * InsertRegionHealthCheckRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckRequest
                         * @instance
                         */
                        InsertRegionHealthCheckRequest.prototype.project = "";
    
                        /**
                         * InsertRegionHealthCheckRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckRequest
                         * @instance
                         */
                        InsertRegionHealthCheckRequest.prototype.region = "";
    
                        /**
                         * InsertRegionHealthCheckRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckRequest
                         * @instance
                         */
                        InsertRegionHealthCheckRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertRegionHealthCheckRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRegionHealthCheckRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertRegionHealthCheckRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionHealthCheckRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertRegionHealthCheckRequest} InsertRegionHealthCheckRequest instance
                         */
                        InsertRegionHealthCheckRequest.create = function create(properties) {
                            return new InsertRegionHealthCheckRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertRegionHealthCheckRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertRegionHealthCheckRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionHealthCheckRequest} message InsertRegionHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionHealthCheckRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.healthCheckResource != null && Object.hasOwnProperty.call(message, "healthCheckResource"))
                                $root.google.cloud.compute.v1.HealthCheck.encode(message.healthCheckResource, writer.uint32(/* id 201925032, wireType 2 =*/1615400258).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertRegionHealthCheckRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertRegionHealthCheckRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionHealthCheckRequest} message InsertRegionHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionHealthCheckRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertRegionHealthCheckRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertRegionHealthCheckRequest} InsertRegionHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionHealthCheckRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertRegionHealthCheckRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 201925032: {
                                        message.healthCheckResource = $root.google.cloud.compute.v1.HealthCheck.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertRegionHealthCheckRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertRegionHealthCheckRequest} InsertRegionHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionHealthCheckRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertRegionHealthCheckRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertRegionHealthCheckRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.healthCheckResource != null && message.hasOwnProperty("healthCheckResource")) {
                                var error = $root.google.cloud.compute.v1.HealthCheck.verify(message.healthCheckResource);
                                if (error)
                                    return "healthCheckResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertRegionHealthCheckRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertRegionHealthCheckRequest} InsertRegionHealthCheckRequest
                         */
                        InsertRegionHealthCheckRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertRegionHealthCheckRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertRegionHealthCheckRequest();
                            if (object.healthCheckResource != null) {
                                if (typeof object.healthCheckResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertRegionHealthCheckRequest.healthCheckResource: object expected");
                                message.healthCheckResource = $root.google.cloud.compute.v1.HealthCheck.fromObject(object.healthCheckResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertRegionHealthCheckRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertRegionHealthCheckRequest} message InsertRegionHealthCheckRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertRegionHealthCheckRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.healthCheckResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.healthCheckResource != null && message.hasOwnProperty("healthCheckResource"))
                                object.healthCheckResource = $root.google.cloud.compute.v1.HealthCheck.toObject(message.healthCheckResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertRegionHealthCheckRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertRegionHealthCheckRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertRegionHealthCheckRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertRegionHealthCheckRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertRegionHealthCheckRequest";
                        };
    
                        return InsertRegionHealthCheckRequest;
                    })();
    
                    v1.InsertRegionHealthCheckServiceRequest = (function() {
    
                        /**
                         * Properties of an InsertRegionHealthCheckServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertRegionHealthCheckServiceRequest
                         * @property {google.cloud.compute.v1.IHealthCheckService|null} [healthCheckServiceResource] InsertRegionHealthCheckServiceRequest healthCheckServiceResource
                         * @property {string|null} [project] InsertRegionHealthCheckServiceRequest project
                         * @property {string|null} [region] InsertRegionHealthCheckServiceRequest region
                         * @property {string|null} [requestId] InsertRegionHealthCheckServiceRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertRegionHealthCheckServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertRegionHealthCheckServiceRequest.
                         * @implements IInsertRegionHealthCheckServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertRegionHealthCheckServiceRequest=} [properties] Properties to set
                         */
                        function InsertRegionHealthCheckServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertRegionHealthCheckServiceRequest healthCheckServiceResource.
                         * @member {google.cloud.compute.v1.IHealthCheckService|null|undefined} healthCheckServiceResource
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest
                         * @instance
                         */
                        InsertRegionHealthCheckServiceRequest.prototype.healthCheckServiceResource = null;
    
                        /**
                         * InsertRegionHealthCheckServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest
                         * @instance
                         */
                        InsertRegionHealthCheckServiceRequest.prototype.project = "";
    
                        /**
                         * InsertRegionHealthCheckServiceRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest
                         * @instance
                         */
                        InsertRegionHealthCheckServiceRequest.prototype.region = "";
    
                        /**
                         * InsertRegionHealthCheckServiceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest
                         * @instance
                         */
                        InsertRegionHealthCheckServiceRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertRegionHealthCheckServiceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRegionHealthCheckServiceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertRegionHealthCheckServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionHealthCheckServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest} InsertRegionHealthCheckServiceRequest instance
                         */
                        InsertRegionHealthCheckServiceRequest.create = function create(properties) {
                            return new InsertRegionHealthCheckServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertRegionHealthCheckServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionHealthCheckServiceRequest} message InsertRegionHealthCheckServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionHealthCheckServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.healthCheckServiceResource != null && Object.hasOwnProperty.call(message, "healthCheckServiceResource"))
                                $root.google.cloud.compute.v1.HealthCheckService.encode(message.healthCheckServiceResource, writer.uint32(/* id 477367794, wireType 2 =*/3818942354).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertRegionHealthCheckServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionHealthCheckServiceRequest} message InsertRegionHealthCheckServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionHealthCheckServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertRegionHealthCheckServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest} InsertRegionHealthCheckServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionHealthCheckServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 477367794: {
                                        message.healthCheckServiceResource = $root.google.cloud.compute.v1.HealthCheckService.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertRegionHealthCheckServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest} InsertRegionHealthCheckServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionHealthCheckServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertRegionHealthCheckServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertRegionHealthCheckServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.healthCheckServiceResource != null && message.hasOwnProperty("healthCheckServiceResource")) {
                                var error = $root.google.cloud.compute.v1.HealthCheckService.verify(message.healthCheckServiceResource);
                                if (error)
                                    return "healthCheckServiceResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertRegionHealthCheckServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest} InsertRegionHealthCheckServiceRequest
                         */
                        InsertRegionHealthCheckServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest();
                            if (object.healthCheckServiceResource != null) {
                                if (typeof object.healthCheckServiceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest.healthCheckServiceResource: object expected");
                                message.healthCheckServiceResource = $root.google.cloud.compute.v1.HealthCheckService.fromObject(object.healthCheckServiceResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertRegionHealthCheckServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest} message InsertRegionHealthCheckServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertRegionHealthCheckServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.healthCheckServiceResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.healthCheckServiceResource != null && message.hasOwnProperty("healthCheckServiceResource"))
                                object.healthCheckServiceResource = $root.google.cloud.compute.v1.HealthCheckService.toObject(message.healthCheckServiceResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertRegionHealthCheckServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertRegionHealthCheckServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertRegionHealthCheckServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertRegionHealthCheckServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest";
                        };
    
                        return InsertRegionHealthCheckServiceRequest;
                    })();
    
                    v1.InsertRegionInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of an InsertRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertRegionInstanceGroupManagerRequest
                         * @property {google.cloud.compute.v1.IInstanceGroupManager|null} [instanceGroupManagerResource] InsertRegionInstanceGroupManagerRequest instanceGroupManagerResource
                         * @property {string|null} [project] InsertRegionInstanceGroupManagerRequest project
                         * @property {string|null} [region] InsertRegionInstanceGroupManagerRequest region
                         * @property {string|null} [requestId] InsertRegionInstanceGroupManagerRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertRegionInstanceGroupManagerRequest.
                         * @implements IInsertRegionInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function InsertRegionInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertRegionInstanceGroupManagerRequest instanceGroupManagerResource.
                         * @member {google.cloud.compute.v1.IInstanceGroupManager|null|undefined} instanceGroupManagerResource
                         * @memberof google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        InsertRegionInstanceGroupManagerRequest.prototype.instanceGroupManagerResource = null;
    
                        /**
                         * InsertRegionInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        InsertRegionInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * InsertRegionInstanceGroupManagerRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        InsertRegionInstanceGroupManagerRequest.prototype.region = "";
    
                        /**
                         * InsertRegionInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        InsertRegionInstanceGroupManagerRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertRegionInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRegionInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertRegionInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest} InsertRegionInstanceGroupManagerRequest instance
                         */
                        InsertRegionInstanceGroupManagerRequest.create = function create(properties) {
                            return new InsertRegionInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertRegionInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionInstanceGroupManagerRequest} message InsertRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManagerResource != null && Object.hasOwnProperty.call(message, "instanceGroupManagerResource"))
                                $root.google.cloud.compute.v1.InstanceGroupManager.encode(message.instanceGroupManagerResource, writer.uint32(/* id 261063946, wireType 2 =*/2088511570).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertRegionInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionInstanceGroupManagerRequest} message InsertRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertRegionInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest} InsertRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 261063946: {
                                        message.instanceGroupManagerResource = $root.google.cloud.compute.v1.InstanceGroupManager.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertRegionInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest} InsertRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertRegionInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertRegionInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManagerResource != null && message.hasOwnProperty("instanceGroupManagerResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceGroupManager.verify(message.instanceGroupManagerResource);
                                if (error)
                                    return "instanceGroupManagerResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertRegionInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest} InsertRegionInstanceGroupManagerRequest
                         */
                        InsertRegionInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest();
                            if (object.instanceGroupManagerResource != null) {
                                if (typeof object.instanceGroupManagerResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest.instanceGroupManagerResource: object expected");
                                message.instanceGroupManagerResource = $root.google.cloud.compute.v1.InstanceGroupManager.fromObject(object.instanceGroupManagerResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertRegionInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest} message InsertRegionInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertRegionInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.instanceGroupManagerResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManagerResource != null && message.hasOwnProperty("instanceGroupManagerResource"))
                                object.instanceGroupManagerResource = $root.google.cloud.compute.v1.InstanceGroupManager.toObject(message.instanceGroupManagerResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertRegionInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertRegionInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertRegionInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertRegionInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest";
                        };
    
                        return InsertRegionInstanceGroupManagerRequest;
                    })();
    
                    v1.InsertRegionNetworkEndpointGroupRequest = (function() {
    
                        /**
                         * Properties of an InsertRegionNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertRegionNetworkEndpointGroupRequest
                         * @property {google.cloud.compute.v1.INetworkEndpointGroup|null} [networkEndpointGroupResource] InsertRegionNetworkEndpointGroupRequest networkEndpointGroupResource
                         * @property {string|null} [project] InsertRegionNetworkEndpointGroupRequest project
                         * @property {string|null} [region] InsertRegionNetworkEndpointGroupRequest region
                         * @property {string|null} [requestId] InsertRegionNetworkEndpointGroupRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertRegionNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertRegionNetworkEndpointGroupRequest.
                         * @implements IInsertRegionNetworkEndpointGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertRegionNetworkEndpointGroupRequest=} [properties] Properties to set
                         */
                        function InsertRegionNetworkEndpointGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertRegionNetworkEndpointGroupRequest networkEndpointGroupResource.
                         * @member {google.cloud.compute.v1.INetworkEndpointGroup|null|undefined} networkEndpointGroupResource
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest
                         * @instance
                         */
                        InsertRegionNetworkEndpointGroupRequest.prototype.networkEndpointGroupResource = null;
    
                        /**
                         * InsertRegionNetworkEndpointGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest
                         * @instance
                         */
                        InsertRegionNetworkEndpointGroupRequest.prototype.project = "";
    
                        /**
                         * InsertRegionNetworkEndpointGroupRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest
                         * @instance
                         */
                        InsertRegionNetworkEndpointGroupRequest.prototype.region = "";
    
                        /**
                         * InsertRegionNetworkEndpointGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest
                         * @instance
                         */
                        InsertRegionNetworkEndpointGroupRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertRegionNetworkEndpointGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRegionNetworkEndpointGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertRegionNetworkEndpointGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionNetworkEndpointGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest} InsertRegionNetworkEndpointGroupRequest instance
                         */
                        InsertRegionNetworkEndpointGroupRequest.create = function create(properties) {
                            return new InsertRegionNetworkEndpointGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertRegionNetworkEndpointGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionNetworkEndpointGroupRequest} message InsertRegionNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionNetworkEndpointGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.networkEndpointGroupResource != null && Object.hasOwnProperty.call(message, "networkEndpointGroupResource"))
                                $root.google.cloud.compute.v1.NetworkEndpointGroup.encode(message.networkEndpointGroupResource, writer.uint32(/* id 525788839, wireType 2 =*/4206310714).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertRegionNetworkEndpointGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionNetworkEndpointGroupRequest} message InsertRegionNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionNetworkEndpointGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertRegionNetworkEndpointGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest} InsertRegionNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionNetworkEndpointGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 525788839: {
                                        message.networkEndpointGroupResource = $root.google.cloud.compute.v1.NetworkEndpointGroup.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertRegionNetworkEndpointGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest} InsertRegionNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionNetworkEndpointGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertRegionNetworkEndpointGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertRegionNetworkEndpointGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.networkEndpointGroupResource != null && message.hasOwnProperty("networkEndpointGroupResource")) {
                                var error = $root.google.cloud.compute.v1.NetworkEndpointGroup.verify(message.networkEndpointGroupResource);
                                if (error)
                                    return "networkEndpointGroupResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertRegionNetworkEndpointGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest} InsertRegionNetworkEndpointGroupRequest
                         */
                        InsertRegionNetworkEndpointGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest();
                            if (object.networkEndpointGroupResource != null) {
                                if (typeof object.networkEndpointGroupResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest.networkEndpointGroupResource: object expected");
                                message.networkEndpointGroupResource = $root.google.cloud.compute.v1.NetworkEndpointGroup.fromObject(object.networkEndpointGroupResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertRegionNetworkEndpointGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest} message InsertRegionNetworkEndpointGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertRegionNetworkEndpointGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.networkEndpointGroupResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.networkEndpointGroupResource != null && message.hasOwnProperty("networkEndpointGroupResource"))
                                object.networkEndpointGroupResource = $root.google.cloud.compute.v1.NetworkEndpointGroup.toObject(message.networkEndpointGroupResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertRegionNetworkEndpointGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertRegionNetworkEndpointGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertRegionNetworkEndpointGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertRegionNetworkEndpointGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest";
                        };
    
                        return InsertRegionNetworkEndpointGroupRequest;
                    })();
    
                    v1.InsertRegionNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of an InsertRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertRegionNetworkFirewallPolicyRequest
                         * @property {google.cloud.compute.v1.IFirewallPolicy|null} [firewallPolicyResource] InsertRegionNetworkFirewallPolicyRequest firewallPolicyResource
                         * @property {string|null} [project] InsertRegionNetworkFirewallPolicyRequest project
                         * @property {string|null} [region] InsertRegionNetworkFirewallPolicyRequest region
                         * @property {string|null} [requestId] InsertRegionNetworkFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertRegionNetworkFirewallPolicyRequest.
                         * @implements IInsertRegionNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function InsertRegionNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertRegionNetworkFirewallPolicyRequest firewallPolicyResource.
                         * @member {google.cloud.compute.v1.IFirewallPolicy|null|undefined} firewallPolicyResource
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        InsertRegionNetworkFirewallPolicyRequest.prototype.firewallPolicyResource = null;
    
                        /**
                         * InsertRegionNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        InsertRegionNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * InsertRegionNetworkFirewallPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        InsertRegionNetworkFirewallPolicyRequest.prototype.region = "";
    
                        /**
                         * InsertRegionNetworkFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        InsertRegionNetworkFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertRegionNetworkFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRegionNetworkFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertRegionNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest} InsertRegionNetworkFirewallPolicyRequest instance
                         */
                        InsertRegionNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new InsertRegionNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertRegionNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionNetworkFirewallPolicyRequest} message InsertRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewallPolicyResource != null && Object.hasOwnProperty.call(message, "firewallPolicyResource"))
                                $root.google.cloud.compute.v1.FirewallPolicy.encode(message.firewallPolicyResource, writer.uint32(/* id 495049532, wireType 2 =*/3960396258).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertRegionNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionNetworkFirewallPolicyRequest} message InsertRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertRegionNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest} InsertRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 495049532: {
                                        message.firewallPolicyResource = $root.google.cloud.compute.v1.FirewallPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertRegionNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest} InsertRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertRegionNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertRegionNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicyResource != null && message.hasOwnProperty("firewallPolicyResource")) {
                                var error = $root.google.cloud.compute.v1.FirewallPolicy.verify(message.firewallPolicyResource);
                                if (error)
                                    return "firewallPolicyResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertRegionNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest} InsertRegionNetworkFirewallPolicyRequest
                         */
                        InsertRegionNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest();
                            if (object.firewallPolicyResource != null) {
                                if (typeof object.firewallPolicyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest.firewallPolicyResource: object expected");
                                message.firewallPolicyResource = $root.google.cloud.compute.v1.FirewallPolicy.fromObject(object.firewallPolicyResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertRegionNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest} message InsertRegionNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertRegionNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.firewallPolicyResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewallPolicyResource != null && message.hasOwnProperty("firewallPolicyResource"))
                                object.firewallPolicyResource = $root.google.cloud.compute.v1.FirewallPolicy.toObject(message.firewallPolicyResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertRegionNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertRegionNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertRegionNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertRegionNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest";
                        };
    
                        return InsertRegionNetworkFirewallPolicyRequest;
                    })();
    
                    v1.InsertRegionNotificationEndpointRequest = (function() {
    
                        /**
                         * Properties of an InsertRegionNotificationEndpointRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertRegionNotificationEndpointRequest
                         * @property {google.cloud.compute.v1.INotificationEndpoint|null} [notificationEndpointResource] InsertRegionNotificationEndpointRequest notificationEndpointResource
                         * @property {string|null} [project] InsertRegionNotificationEndpointRequest project
                         * @property {string|null} [region] InsertRegionNotificationEndpointRequest region
                         * @property {string|null} [requestId] InsertRegionNotificationEndpointRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertRegionNotificationEndpointRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertRegionNotificationEndpointRequest.
                         * @implements IInsertRegionNotificationEndpointRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertRegionNotificationEndpointRequest=} [properties] Properties to set
                         */
                        function InsertRegionNotificationEndpointRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertRegionNotificationEndpointRequest notificationEndpointResource.
                         * @member {google.cloud.compute.v1.INotificationEndpoint|null|undefined} notificationEndpointResource
                         * @memberof google.cloud.compute.v1.InsertRegionNotificationEndpointRequest
                         * @instance
                         */
                        InsertRegionNotificationEndpointRequest.prototype.notificationEndpointResource = null;
    
                        /**
                         * InsertRegionNotificationEndpointRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertRegionNotificationEndpointRequest
                         * @instance
                         */
                        InsertRegionNotificationEndpointRequest.prototype.project = "";
    
                        /**
                         * InsertRegionNotificationEndpointRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertRegionNotificationEndpointRequest
                         * @instance
                         */
                        InsertRegionNotificationEndpointRequest.prototype.region = "";
    
                        /**
                         * InsertRegionNotificationEndpointRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertRegionNotificationEndpointRequest
                         * @instance
                         */
                        InsertRegionNotificationEndpointRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertRegionNotificationEndpointRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertRegionNotificationEndpointRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRegionNotificationEndpointRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertRegionNotificationEndpointRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertRegionNotificationEndpointRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionNotificationEndpointRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertRegionNotificationEndpointRequest} InsertRegionNotificationEndpointRequest instance
                         */
                        InsertRegionNotificationEndpointRequest.create = function create(properties) {
                            return new InsertRegionNotificationEndpointRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertRegionNotificationEndpointRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertRegionNotificationEndpointRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertRegionNotificationEndpointRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionNotificationEndpointRequest} message InsertRegionNotificationEndpointRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionNotificationEndpointRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.notificationEndpointResource != null && Object.hasOwnProperty.call(message, "notificationEndpointResource"))
                                $root.google.cloud.compute.v1.NotificationEndpoint.encode(message.notificationEndpointResource, writer.uint32(/* id 338459940, wireType 2 =*/2707679522).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertRegionNotificationEndpointRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertRegionNotificationEndpointRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionNotificationEndpointRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionNotificationEndpointRequest} message InsertRegionNotificationEndpointRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionNotificationEndpointRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertRegionNotificationEndpointRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertRegionNotificationEndpointRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertRegionNotificationEndpointRequest} InsertRegionNotificationEndpointRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionNotificationEndpointRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertRegionNotificationEndpointRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 338459940: {
                                        message.notificationEndpointResource = $root.google.cloud.compute.v1.NotificationEndpoint.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertRegionNotificationEndpointRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionNotificationEndpointRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertRegionNotificationEndpointRequest} InsertRegionNotificationEndpointRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionNotificationEndpointRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertRegionNotificationEndpointRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertRegionNotificationEndpointRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertRegionNotificationEndpointRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.notificationEndpointResource != null && message.hasOwnProperty("notificationEndpointResource")) {
                                var error = $root.google.cloud.compute.v1.NotificationEndpoint.verify(message.notificationEndpointResource);
                                if (error)
                                    return "notificationEndpointResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertRegionNotificationEndpointRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertRegionNotificationEndpointRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertRegionNotificationEndpointRequest} InsertRegionNotificationEndpointRequest
                         */
                        InsertRegionNotificationEndpointRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertRegionNotificationEndpointRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertRegionNotificationEndpointRequest();
                            if (object.notificationEndpointResource != null) {
                                if (typeof object.notificationEndpointResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertRegionNotificationEndpointRequest.notificationEndpointResource: object expected");
                                message.notificationEndpointResource = $root.google.cloud.compute.v1.NotificationEndpoint.fromObject(object.notificationEndpointResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertRegionNotificationEndpointRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertRegionNotificationEndpointRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertRegionNotificationEndpointRequest} message InsertRegionNotificationEndpointRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertRegionNotificationEndpointRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.notificationEndpointResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.notificationEndpointResource != null && message.hasOwnProperty("notificationEndpointResource"))
                                object.notificationEndpointResource = $root.google.cloud.compute.v1.NotificationEndpoint.toObject(message.notificationEndpointResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertRegionNotificationEndpointRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertRegionNotificationEndpointRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertRegionNotificationEndpointRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertRegionNotificationEndpointRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertRegionNotificationEndpointRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertRegionNotificationEndpointRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertRegionNotificationEndpointRequest";
                        };
    
                        return InsertRegionNotificationEndpointRequest;
                    })();
    
                    v1.InsertRegionSecurityPolicyRequest = (function() {
    
                        /**
                         * Properties of an InsertRegionSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertRegionSecurityPolicyRequest
                         * @property {string|null} [project] InsertRegionSecurityPolicyRequest project
                         * @property {string|null} [region] InsertRegionSecurityPolicyRequest region
                         * @property {string|null} [requestId] InsertRegionSecurityPolicyRequest requestId
                         * @property {google.cloud.compute.v1.ISecurityPolicy|null} [securityPolicyResource] InsertRegionSecurityPolicyRequest securityPolicyResource
                         * @property {boolean|null} [validateOnly] InsertRegionSecurityPolicyRequest validateOnly
                         */
    
                        /**
                         * Constructs a new InsertRegionSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertRegionSecurityPolicyRequest.
                         * @implements IInsertRegionSecurityPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertRegionSecurityPolicyRequest=} [properties] Properties to set
                         */
                        function InsertRegionSecurityPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertRegionSecurityPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertRegionSecurityPolicyRequest
                         * @instance
                         */
                        InsertRegionSecurityPolicyRequest.prototype.project = "";
    
                        /**
                         * InsertRegionSecurityPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertRegionSecurityPolicyRequest
                         * @instance
                         */
                        InsertRegionSecurityPolicyRequest.prototype.region = "";
    
                        /**
                         * InsertRegionSecurityPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertRegionSecurityPolicyRequest
                         * @instance
                         */
                        InsertRegionSecurityPolicyRequest.prototype.requestId = null;
    
                        /**
                         * InsertRegionSecurityPolicyRequest securityPolicyResource.
                         * @member {google.cloud.compute.v1.ISecurityPolicy|null|undefined} securityPolicyResource
                         * @memberof google.cloud.compute.v1.InsertRegionSecurityPolicyRequest
                         * @instance
                         */
                        InsertRegionSecurityPolicyRequest.prototype.securityPolicyResource = null;
    
                        /**
                         * InsertRegionSecurityPolicyRequest validateOnly.
                         * @member {boolean|null|undefined} validateOnly
                         * @memberof google.cloud.compute.v1.InsertRegionSecurityPolicyRequest
                         * @instance
                         */
                        InsertRegionSecurityPolicyRequest.prototype.validateOnly = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertRegionSecurityPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertRegionSecurityPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRegionSecurityPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InsertRegionSecurityPolicyRequest _validateOnly.
                         * @member {"validateOnly"|undefined} _validateOnly
                         * @memberof google.cloud.compute.v1.InsertRegionSecurityPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRegionSecurityPolicyRequest.prototype, "_validateOnly", {
                            get: $util.oneOfGetter($oneOfFields = ["validateOnly"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertRegionSecurityPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertRegionSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionSecurityPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertRegionSecurityPolicyRequest} InsertRegionSecurityPolicyRequest instance
                         */
                        InsertRegionSecurityPolicyRequest.create = function create(properties) {
                            return new InsertRegionSecurityPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertRegionSecurityPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertRegionSecurityPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertRegionSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionSecurityPolicyRequest} message InsertRegionSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionSecurityPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.securityPolicyResource != null && Object.hasOwnProperty.call(message, "securityPolicyResource"))
                                $root.google.cloud.compute.v1.SecurityPolicy.encode(message.securityPolicyResource, writer.uint32(/* id 216159612, wireType 2 =*/1729276898).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.validateOnly != null && Object.hasOwnProperty.call(message, "validateOnly"))
                                writer.uint32(/* id 242744629, wireType 0 =*/1941957032).bool(message.validateOnly);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertRegionSecurityPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertRegionSecurityPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionSecurityPolicyRequest} message InsertRegionSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionSecurityPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertRegionSecurityPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertRegionSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertRegionSecurityPolicyRequest} InsertRegionSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionSecurityPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertRegionSecurityPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 216159612: {
                                        message.securityPolicyResource = $root.google.cloud.compute.v1.SecurityPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 242744629: {
                                        message.validateOnly = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertRegionSecurityPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertRegionSecurityPolicyRequest} InsertRegionSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionSecurityPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertRegionSecurityPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertRegionSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertRegionSecurityPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.securityPolicyResource != null && message.hasOwnProperty("securityPolicyResource")) {
                                var error = $root.google.cloud.compute.v1.SecurityPolicy.verify(message.securityPolicyResource);
                                if (error)
                                    return "securityPolicyResource." + error;
                            }
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly")) {
                                properties._validateOnly = 1;
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertRegionSecurityPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertRegionSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertRegionSecurityPolicyRequest} InsertRegionSecurityPolicyRequest
                         */
                        InsertRegionSecurityPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertRegionSecurityPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertRegionSecurityPolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.securityPolicyResource != null) {
                                if (typeof object.securityPolicyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertRegionSecurityPolicyRequest.securityPolicyResource: object expected");
                                message.securityPolicyResource = $root.google.cloud.compute.v1.SecurityPolicy.fromObject(object.securityPolicyResource);
                            }
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertRegionSecurityPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertRegionSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertRegionSecurityPolicyRequest} message InsertRegionSecurityPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertRegionSecurityPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.securityPolicyResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.securityPolicyResource != null && message.hasOwnProperty("securityPolicyResource"))
                                object.securityPolicyResource = $root.google.cloud.compute.v1.SecurityPolicy.toObject(message.securityPolicyResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly")) {
                                object.validateOnly = message.validateOnly;
                                if (options.oneofs)
                                    object._validateOnly = "validateOnly";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InsertRegionSecurityPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertRegionSecurityPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertRegionSecurityPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertRegionSecurityPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertRegionSecurityPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertRegionSecurityPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertRegionSecurityPolicyRequest";
                        };
    
                        return InsertRegionSecurityPolicyRequest;
                    })();
    
                    v1.InsertRegionSslCertificateRequest = (function() {
    
                        /**
                         * Properties of an InsertRegionSslCertificateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertRegionSslCertificateRequest
                         * @property {string|null} [project] InsertRegionSslCertificateRequest project
                         * @property {string|null} [region] InsertRegionSslCertificateRequest region
                         * @property {string|null} [requestId] InsertRegionSslCertificateRequest requestId
                         * @property {google.cloud.compute.v1.ISslCertificate|null} [sslCertificateResource] InsertRegionSslCertificateRequest sslCertificateResource
                         */
    
                        /**
                         * Constructs a new InsertRegionSslCertificateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertRegionSslCertificateRequest.
                         * @implements IInsertRegionSslCertificateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertRegionSslCertificateRequest=} [properties] Properties to set
                         */
                        function InsertRegionSslCertificateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertRegionSslCertificateRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertRegionSslCertificateRequest
                         * @instance
                         */
                        InsertRegionSslCertificateRequest.prototype.project = "";
    
                        /**
                         * InsertRegionSslCertificateRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertRegionSslCertificateRequest
                         * @instance
                         */
                        InsertRegionSslCertificateRequest.prototype.region = "";
    
                        /**
                         * InsertRegionSslCertificateRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertRegionSslCertificateRequest
                         * @instance
                         */
                        InsertRegionSslCertificateRequest.prototype.requestId = null;
    
                        /**
                         * InsertRegionSslCertificateRequest sslCertificateResource.
                         * @member {google.cloud.compute.v1.ISslCertificate|null|undefined} sslCertificateResource
                         * @memberof google.cloud.compute.v1.InsertRegionSslCertificateRequest
                         * @instance
                         */
                        InsertRegionSslCertificateRequest.prototype.sslCertificateResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertRegionSslCertificateRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertRegionSslCertificateRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRegionSslCertificateRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertRegionSslCertificateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertRegionSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionSslCertificateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertRegionSslCertificateRequest} InsertRegionSslCertificateRequest instance
                         */
                        InsertRegionSslCertificateRequest.create = function create(properties) {
                            return new InsertRegionSslCertificateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertRegionSslCertificateRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertRegionSslCertificateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertRegionSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionSslCertificateRequest} message InsertRegionSslCertificateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionSslCertificateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.sslCertificateResource != null && Object.hasOwnProperty.call(message, "sslCertificateResource"))
                                $root.google.cloud.compute.v1.SslCertificate.encode(message.sslCertificateResource, writer.uint32(/* id 180709897, wireType 2 =*/1445679178).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertRegionSslCertificateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertRegionSslCertificateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionSslCertificateRequest} message InsertRegionSslCertificateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionSslCertificateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertRegionSslCertificateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertRegionSslCertificateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertRegionSslCertificateRequest} InsertRegionSslCertificateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionSslCertificateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertRegionSslCertificateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 180709897: {
                                        message.sslCertificateResource = $root.google.cloud.compute.v1.SslCertificate.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertRegionSslCertificateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionSslCertificateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertRegionSslCertificateRequest} InsertRegionSslCertificateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionSslCertificateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertRegionSslCertificateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertRegionSslCertificateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertRegionSslCertificateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.sslCertificateResource != null && message.hasOwnProperty("sslCertificateResource")) {
                                var error = $root.google.cloud.compute.v1.SslCertificate.verify(message.sslCertificateResource);
                                if (error)
                                    return "sslCertificateResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertRegionSslCertificateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertRegionSslCertificateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertRegionSslCertificateRequest} InsertRegionSslCertificateRequest
                         */
                        InsertRegionSslCertificateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertRegionSslCertificateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertRegionSslCertificateRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.sslCertificateResource != null) {
                                if (typeof object.sslCertificateResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertRegionSslCertificateRequest.sslCertificateResource: object expected");
                                message.sslCertificateResource = $root.google.cloud.compute.v1.SslCertificate.fromObject(object.sslCertificateResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertRegionSslCertificateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertRegionSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertRegionSslCertificateRequest} message InsertRegionSslCertificateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertRegionSslCertificateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.sslCertificateResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.sslCertificateResource != null && message.hasOwnProperty("sslCertificateResource"))
                                object.sslCertificateResource = $root.google.cloud.compute.v1.SslCertificate.toObject(message.sslCertificateResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertRegionSslCertificateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertRegionSslCertificateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertRegionSslCertificateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertRegionSslCertificateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertRegionSslCertificateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertRegionSslCertificateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertRegionSslCertificateRequest";
                        };
    
                        return InsertRegionSslCertificateRequest;
                    })();
    
                    v1.InsertRegionSslPolicyRequest = (function() {
    
                        /**
                         * Properties of an InsertRegionSslPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertRegionSslPolicyRequest
                         * @property {string|null} [project] InsertRegionSslPolicyRequest project
                         * @property {string|null} [region] InsertRegionSslPolicyRequest region
                         * @property {string|null} [requestId] InsertRegionSslPolicyRequest requestId
                         * @property {google.cloud.compute.v1.ISslPolicy|null} [sslPolicyResource] InsertRegionSslPolicyRequest sslPolicyResource
                         */
    
                        /**
                         * Constructs a new InsertRegionSslPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertRegionSslPolicyRequest.
                         * @implements IInsertRegionSslPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertRegionSslPolicyRequest=} [properties] Properties to set
                         */
                        function InsertRegionSslPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertRegionSslPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertRegionSslPolicyRequest
                         * @instance
                         */
                        InsertRegionSslPolicyRequest.prototype.project = "";
    
                        /**
                         * InsertRegionSslPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertRegionSslPolicyRequest
                         * @instance
                         */
                        InsertRegionSslPolicyRequest.prototype.region = "";
    
                        /**
                         * InsertRegionSslPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertRegionSslPolicyRequest
                         * @instance
                         */
                        InsertRegionSslPolicyRequest.prototype.requestId = null;
    
                        /**
                         * InsertRegionSslPolicyRequest sslPolicyResource.
                         * @member {google.cloud.compute.v1.ISslPolicy|null|undefined} sslPolicyResource
                         * @memberof google.cloud.compute.v1.InsertRegionSslPolicyRequest
                         * @instance
                         */
                        InsertRegionSslPolicyRequest.prototype.sslPolicyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertRegionSslPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertRegionSslPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRegionSslPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertRegionSslPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertRegionSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionSslPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertRegionSslPolicyRequest} InsertRegionSslPolicyRequest instance
                         */
                        InsertRegionSslPolicyRequest.create = function create(properties) {
                            return new InsertRegionSslPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertRegionSslPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertRegionSslPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertRegionSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionSslPolicyRequest} message InsertRegionSslPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionSslPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.sslPolicyResource != null && Object.hasOwnProperty.call(message, "sslPolicyResource"))
                                $root.google.cloud.compute.v1.SslPolicy.encode(message.sslPolicyResource, writer.uint32(/* id 274891848, wireType 2 =*/2199134786).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertRegionSslPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertRegionSslPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionSslPolicyRequest} message InsertRegionSslPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionSslPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertRegionSslPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertRegionSslPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertRegionSslPolicyRequest} InsertRegionSslPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionSslPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertRegionSslPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 274891848: {
                                        message.sslPolicyResource = $root.google.cloud.compute.v1.SslPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertRegionSslPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionSslPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertRegionSslPolicyRequest} InsertRegionSslPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionSslPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertRegionSslPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertRegionSslPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertRegionSslPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.sslPolicyResource != null && message.hasOwnProperty("sslPolicyResource")) {
                                var error = $root.google.cloud.compute.v1.SslPolicy.verify(message.sslPolicyResource);
                                if (error)
                                    return "sslPolicyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertRegionSslPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertRegionSslPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertRegionSslPolicyRequest} InsertRegionSslPolicyRequest
                         */
                        InsertRegionSslPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertRegionSslPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertRegionSslPolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.sslPolicyResource != null) {
                                if (typeof object.sslPolicyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertRegionSslPolicyRequest.sslPolicyResource: object expected");
                                message.sslPolicyResource = $root.google.cloud.compute.v1.SslPolicy.fromObject(object.sslPolicyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertRegionSslPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertRegionSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertRegionSslPolicyRequest} message InsertRegionSslPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertRegionSslPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.sslPolicyResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.sslPolicyResource != null && message.hasOwnProperty("sslPolicyResource"))
                                object.sslPolicyResource = $root.google.cloud.compute.v1.SslPolicy.toObject(message.sslPolicyResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertRegionSslPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertRegionSslPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertRegionSslPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertRegionSslPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertRegionSslPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertRegionSslPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertRegionSslPolicyRequest";
                        };
    
                        return InsertRegionSslPolicyRequest;
                    })();
    
                    v1.InsertRegionTargetHttpProxyRequest = (function() {
    
                        /**
                         * Properties of an InsertRegionTargetHttpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertRegionTargetHttpProxyRequest
                         * @property {string|null} [project] InsertRegionTargetHttpProxyRequest project
                         * @property {string|null} [region] InsertRegionTargetHttpProxyRequest region
                         * @property {string|null} [requestId] InsertRegionTargetHttpProxyRequest requestId
                         * @property {google.cloud.compute.v1.ITargetHttpProxy|null} [targetHttpProxyResource] InsertRegionTargetHttpProxyRequest targetHttpProxyResource
                         */
    
                        /**
                         * Constructs a new InsertRegionTargetHttpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertRegionTargetHttpProxyRequest.
                         * @implements IInsertRegionTargetHttpProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertRegionTargetHttpProxyRequest=} [properties] Properties to set
                         */
                        function InsertRegionTargetHttpProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertRegionTargetHttpProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest
                         * @instance
                         */
                        InsertRegionTargetHttpProxyRequest.prototype.project = "";
    
                        /**
                         * InsertRegionTargetHttpProxyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest
                         * @instance
                         */
                        InsertRegionTargetHttpProxyRequest.prototype.region = "";
    
                        /**
                         * InsertRegionTargetHttpProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest
                         * @instance
                         */
                        InsertRegionTargetHttpProxyRequest.prototype.requestId = null;
    
                        /**
                         * InsertRegionTargetHttpProxyRequest targetHttpProxyResource.
                         * @member {google.cloud.compute.v1.ITargetHttpProxy|null|undefined} targetHttpProxyResource
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest
                         * @instance
                         */
                        InsertRegionTargetHttpProxyRequest.prototype.targetHttpProxyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertRegionTargetHttpProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRegionTargetHttpProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertRegionTargetHttpProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionTargetHttpProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest} InsertRegionTargetHttpProxyRequest instance
                         */
                        InsertRegionTargetHttpProxyRequest.create = function create(properties) {
                            return new InsertRegionTargetHttpProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertRegionTargetHttpProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionTargetHttpProxyRequest} message InsertRegionTargetHttpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionTargetHttpProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetHttpProxyResource != null && Object.hasOwnProperty.call(message, "targetHttpProxyResource"))
                                $root.google.cloud.compute.v1.TargetHttpProxy.encode(message.targetHttpProxyResource, writer.uint32(/* id 24696744, wireType 2 =*/197573954).fork()).ldelim();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertRegionTargetHttpProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionTargetHttpProxyRequest} message InsertRegionTargetHttpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionTargetHttpProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertRegionTargetHttpProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest} InsertRegionTargetHttpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionTargetHttpProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 24696744: {
                                        message.targetHttpProxyResource = $root.google.cloud.compute.v1.TargetHttpProxy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertRegionTargetHttpProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest} InsertRegionTargetHttpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionTargetHttpProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertRegionTargetHttpProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertRegionTargetHttpProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetHttpProxyResource != null && message.hasOwnProperty("targetHttpProxyResource")) {
                                var error = $root.google.cloud.compute.v1.TargetHttpProxy.verify(message.targetHttpProxyResource);
                                if (error)
                                    return "targetHttpProxyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertRegionTargetHttpProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest} InsertRegionTargetHttpProxyRequest
                         */
                        InsertRegionTargetHttpProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetHttpProxyResource != null) {
                                if (typeof object.targetHttpProxyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest.targetHttpProxyResource: object expected");
                                message.targetHttpProxyResource = $root.google.cloud.compute.v1.TargetHttpProxy.fromObject(object.targetHttpProxyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertRegionTargetHttpProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest} message InsertRegionTargetHttpProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertRegionTargetHttpProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetHttpProxyResource = null;
                                object.region = "";
                                object.project = "";
                            }
                            if (message.targetHttpProxyResource != null && message.hasOwnProperty("targetHttpProxyResource"))
                                object.targetHttpProxyResource = $root.google.cloud.compute.v1.TargetHttpProxy.toObject(message.targetHttpProxyResource, options);
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertRegionTargetHttpProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertRegionTargetHttpProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertRegionTargetHttpProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertRegionTargetHttpProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest";
                        };
    
                        return InsertRegionTargetHttpProxyRequest;
                    })();
    
                    v1.InsertRegionTargetHttpsProxyRequest = (function() {
    
                        /**
                         * Properties of an InsertRegionTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertRegionTargetHttpsProxyRequest
                         * @property {string|null} [project] InsertRegionTargetHttpsProxyRequest project
                         * @property {string|null} [region] InsertRegionTargetHttpsProxyRequest region
                         * @property {string|null} [requestId] InsertRegionTargetHttpsProxyRequest requestId
                         * @property {google.cloud.compute.v1.ITargetHttpsProxy|null} [targetHttpsProxyResource] InsertRegionTargetHttpsProxyRequest targetHttpsProxyResource
                         */
    
                        /**
                         * Constructs a new InsertRegionTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertRegionTargetHttpsProxyRequest.
                         * @implements IInsertRegionTargetHttpsProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertRegionTargetHttpsProxyRequest=} [properties] Properties to set
                         */
                        function InsertRegionTargetHttpsProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertRegionTargetHttpsProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        InsertRegionTargetHttpsProxyRequest.prototype.project = "";
    
                        /**
                         * InsertRegionTargetHttpsProxyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        InsertRegionTargetHttpsProxyRequest.prototype.region = "";
    
                        /**
                         * InsertRegionTargetHttpsProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        InsertRegionTargetHttpsProxyRequest.prototype.requestId = null;
    
                        /**
                         * InsertRegionTargetHttpsProxyRequest targetHttpsProxyResource.
                         * @member {google.cloud.compute.v1.ITargetHttpsProxy|null|undefined} targetHttpsProxyResource
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        InsertRegionTargetHttpsProxyRequest.prototype.targetHttpsProxyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertRegionTargetHttpsProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRegionTargetHttpsProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertRegionTargetHttpsProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionTargetHttpsProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest} InsertRegionTargetHttpsProxyRequest instance
                         */
                        InsertRegionTargetHttpsProxyRequest.create = function create(properties) {
                            return new InsertRegionTargetHttpsProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertRegionTargetHttpsProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionTargetHttpsProxyRequest} message InsertRegionTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionTargetHttpsProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetHttpsProxyResource != null && Object.hasOwnProperty.call(message, "targetHttpsProxyResource"))
                                $root.google.cloud.compute.v1.TargetHttpsProxy.encode(message.targetHttpsProxyResource, writer.uint32(/* id 433657473, wireType 2 =*/3469259786).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertRegionTargetHttpsProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionTargetHttpsProxyRequest} message InsertRegionTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionTargetHttpsProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertRegionTargetHttpsProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest} InsertRegionTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionTargetHttpsProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 433657473: {
                                        message.targetHttpsProxyResource = $root.google.cloud.compute.v1.TargetHttpsProxy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertRegionTargetHttpsProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest} InsertRegionTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionTargetHttpsProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertRegionTargetHttpsProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertRegionTargetHttpsProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetHttpsProxyResource != null && message.hasOwnProperty("targetHttpsProxyResource")) {
                                var error = $root.google.cloud.compute.v1.TargetHttpsProxy.verify(message.targetHttpsProxyResource);
                                if (error)
                                    return "targetHttpsProxyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertRegionTargetHttpsProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest} InsertRegionTargetHttpsProxyRequest
                         */
                        InsertRegionTargetHttpsProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetHttpsProxyResource != null) {
                                if (typeof object.targetHttpsProxyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest.targetHttpsProxyResource: object expected");
                                message.targetHttpsProxyResource = $root.google.cloud.compute.v1.TargetHttpsProxy.fromObject(object.targetHttpsProxyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertRegionTargetHttpsProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest} message InsertRegionTargetHttpsProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertRegionTargetHttpsProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.targetHttpsProxyResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetHttpsProxyResource != null && message.hasOwnProperty("targetHttpsProxyResource"))
                                object.targetHttpsProxyResource = $root.google.cloud.compute.v1.TargetHttpsProxy.toObject(message.targetHttpsProxyResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertRegionTargetHttpsProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertRegionTargetHttpsProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertRegionTargetHttpsProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertRegionTargetHttpsProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest";
                        };
    
                        return InsertRegionTargetHttpsProxyRequest;
                    })();
    
                    v1.InsertRegionTargetTcpProxyRequest = (function() {
    
                        /**
                         * Properties of an InsertRegionTargetTcpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertRegionTargetTcpProxyRequest
                         * @property {string|null} [project] InsertRegionTargetTcpProxyRequest project
                         * @property {string|null} [region] InsertRegionTargetTcpProxyRequest region
                         * @property {string|null} [requestId] InsertRegionTargetTcpProxyRequest requestId
                         * @property {google.cloud.compute.v1.ITargetTcpProxy|null} [targetTcpProxyResource] InsertRegionTargetTcpProxyRequest targetTcpProxyResource
                         */
    
                        /**
                         * Constructs a new InsertRegionTargetTcpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertRegionTargetTcpProxyRequest.
                         * @implements IInsertRegionTargetTcpProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertRegionTargetTcpProxyRequest=} [properties] Properties to set
                         */
                        function InsertRegionTargetTcpProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertRegionTargetTcpProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest
                         * @instance
                         */
                        InsertRegionTargetTcpProxyRequest.prototype.project = "";
    
                        /**
                         * InsertRegionTargetTcpProxyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest
                         * @instance
                         */
                        InsertRegionTargetTcpProxyRequest.prototype.region = "";
    
                        /**
                         * InsertRegionTargetTcpProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest
                         * @instance
                         */
                        InsertRegionTargetTcpProxyRequest.prototype.requestId = null;
    
                        /**
                         * InsertRegionTargetTcpProxyRequest targetTcpProxyResource.
                         * @member {google.cloud.compute.v1.ITargetTcpProxy|null|undefined} targetTcpProxyResource
                         * @memberof google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest
                         * @instance
                         */
                        InsertRegionTargetTcpProxyRequest.prototype.targetTcpProxyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertRegionTargetTcpProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRegionTargetTcpProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertRegionTargetTcpProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionTargetTcpProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest} InsertRegionTargetTcpProxyRequest instance
                         */
                        InsertRegionTargetTcpProxyRequest.create = function create(properties) {
                            return new InsertRegionTargetTcpProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertRegionTargetTcpProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionTargetTcpProxyRequest} message InsertRegionTargetTcpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionTargetTcpProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.targetTcpProxyResource != null && Object.hasOwnProperty.call(message, "targetTcpProxyResource"))
                                $root.google.cloud.compute.v1.TargetTcpProxy.encode(message.targetTcpProxyResource, writer.uint32(/* id 145913931, wireType 2 =*/1167311450).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertRegionTargetTcpProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionTargetTcpProxyRequest} message InsertRegionTargetTcpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionTargetTcpProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertRegionTargetTcpProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest} InsertRegionTargetTcpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionTargetTcpProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 145913931: {
                                        message.targetTcpProxyResource = $root.google.cloud.compute.v1.TargetTcpProxy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertRegionTargetTcpProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest} InsertRegionTargetTcpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionTargetTcpProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertRegionTargetTcpProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertRegionTargetTcpProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetTcpProxyResource != null && message.hasOwnProperty("targetTcpProxyResource")) {
                                var error = $root.google.cloud.compute.v1.TargetTcpProxy.verify(message.targetTcpProxyResource);
                                if (error)
                                    return "targetTcpProxyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertRegionTargetTcpProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest} InsertRegionTargetTcpProxyRequest
                         */
                        InsertRegionTargetTcpProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetTcpProxyResource != null) {
                                if (typeof object.targetTcpProxyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest.targetTcpProxyResource: object expected");
                                message.targetTcpProxyResource = $root.google.cloud.compute.v1.TargetTcpProxy.fromObject(object.targetTcpProxyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertRegionTargetTcpProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest} message InsertRegionTargetTcpProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertRegionTargetTcpProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.targetTcpProxyResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.targetTcpProxyResource != null && message.hasOwnProperty("targetTcpProxyResource"))
                                object.targetTcpProxyResource = $root.google.cloud.compute.v1.TargetTcpProxy.toObject(message.targetTcpProxyResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertRegionTargetTcpProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertRegionTargetTcpProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertRegionTargetTcpProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertRegionTargetTcpProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest";
                        };
    
                        return InsertRegionTargetTcpProxyRequest;
                    })();
    
                    v1.InsertRegionUrlMapRequest = (function() {
    
                        /**
                         * Properties of an InsertRegionUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertRegionUrlMapRequest
                         * @property {string|null} [project] InsertRegionUrlMapRequest project
                         * @property {string|null} [region] InsertRegionUrlMapRequest region
                         * @property {string|null} [requestId] InsertRegionUrlMapRequest requestId
                         * @property {google.cloud.compute.v1.IUrlMap|null} [urlMapResource] InsertRegionUrlMapRequest urlMapResource
                         */
    
                        /**
                         * Constructs a new InsertRegionUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertRegionUrlMapRequest.
                         * @implements IInsertRegionUrlMapRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertRegionUrlMapRequest=} [properties] Properties to set
                         */
                        function InsertRegionUrlMapRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertRegionUrlMapRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertRegionUrlMapRequest
                         * @instance
                         */
                        InsertRegionUrlMapRequest.prototype.project = "";
    
                        /**
                         * InsertRegionUrlMapRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertRegionUrlMapRequest
                         * @instance
                         */
                        InsertRegionUrlMapRequest.prototype.region = "";
    
                        /**
                         * InsertRegionUrlMapRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertRegionUrlMapRequest
                         * @instance
                         */
                        InsertRegionUrlMapRequest.prototype.requestId = null;
    
                        /**
                         * InsertRegionUrlMapRequest urlMapResource.
                         * @member {google.cloud.compute.v1.IUrlMap|null|undefined} urlMapResource
                         * @memberof google.cloud.compute.v1.InsertRegionUrlMapRequest
                         * @instance
                         */
                        InsertRegionUrlMapRequest.prototype.urlMapResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertRegionUrlMapRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertRegionUrlMapRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRegionUrlMapRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertRegionUrlMapRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionUrlMapRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertRegionUrlMapRequest} InsertRegionUrlMapRequest instance
                         */
                        InsertRegionUrlMapRequest.create = function create(properties) {
                            return new InsertRegionUrlMapRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertRegionUrlMapRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertRegionUrlMapRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionUrlMapRequest} message InsertRegionUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionUrlMapRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.urlMapResource != null && Object.hasOwnProperty.call(message, "urlMapResource"))
                                $root.google.cloud.compute.v1.UrlMap.encode(message.urlMapResource, writer.uint32(/* id 168675425, wireType 2 =*/1349403402).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertRegionUrlMapRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertRegionUrlMapRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRegionUrlMapRequest} message InsertRegionUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRegionUrlMapRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertRegionUrlMapRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertRegionUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertRegionUrlMapRequest} InsertRegionUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionUrlMapRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertRegionUrlMapRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 168675425: {
                                        message.urlMapResource = $root.google.cloud.compute.v1.UrlMap.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertRegionUrlMapRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRegionUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertRegionUrlMapRequest} InsertRegionUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRegionUrlMapRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertRegionUrlMapRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertRegionUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertRegionUrlMapRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.urlMapResource != null && message.hasOwnProperty("urlMapResource")) {
                                var error = $root.google.cloud.compute.v1.UrlMap.verify(message.urlMapResource);
                                if (error)
                                    return "urlMapResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertRegionUrlMapRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertRegionUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertRegionUrlMapRequest} InsertRegionUrlMapRequest
                         */
                        InsertRegionUrlMapRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertRegionUrlMapRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertRegionUrlMapRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.urlMapResource != null) {
                                if (typeof object.urlMapResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertRegionUrlMapRequest.urlMapResource: object expected");
                                message.urlMapResource = $root.google.cloud.compute.v1.UrlMap.fromObject(object.urlMapResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertRegionUrlMapRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertRegionUrlMapRequest} message InsertRegionUrlMapRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertRegionUrlMapRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.urlMapResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.urlMapResource != null && message.hasOwnProperty("urlMapResource"))
                                object.urlMapResource = $root.google.cloud.compute.v1.UrlMap.toObject(message.urlMapResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertRegionUrlMapRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertRegionUrlMapRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertRegionUrlMapRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertRegionUrlMapRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertRegionUrlMapRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertRegionUrlMapRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertRegionUrlMapRequest";
                        };
    
                        return InsertRegionUrlMapRequest;
                    })();
    
                    v1.InsertReservationRequest = (function() {
    
                        /**
                         * Properties of an InsertReservationRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertReservationRequest
                         * @property {string|null} [project] InsertReservationRequest project
                         * @property {string|null} [requestId] InsertReservationRequest requestId
                         * @property {google.cloud.compute.v1.IReservation|null} [reservationResource] InsertReservationRequest reservationResource
                         * @property {string|null} [zone] InsertReservationRequest zone
                         */
    
                        /**
                         * Constructs a new InsertReservationRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertReservationRequest.
                         * @implements IInsertReservationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertReservationRequest=} [properties] Properties to set
                         */
                        function InsertReservationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertReservationRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertReservationRequest
                         * @instance
                         */
                        InsertReservationRequest.prototype.project = "";
    
                        /**
                         * InsertReservationRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertReservationRequest
                         * @instance
                         */
                        InsertReservationRequest.prototype.requestId = null;
    
                        /**
                         * InsertReservationRequest reservationResource.
                         * @member {google.cloud.compute.v1.IReservation|null|undefined} reservationResource
                         * @memberof google.cloud.compute.v1.InsertReservationRequest
                         * @instance
                         */
                        InsertReservationRequest.prototype.reservationResource = null;
    
                        /**
                         * InsertReservationRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.InsertReservationRequest
                         * @instance
                         */
                        InsertReservationRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertReservationRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertReservationRequest
                         * @instance
                         */
                        Object.defineProperty(InsertReservationRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertReservationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertReservationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertReservationRequest} InsertReservationRequest instance
                         */
                        InsertReservationRequest.create = function create(properties) {
                            return new InsertReservationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertReservationRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertReservationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertReservationRequest} message InsertReservationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertReservationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.reservationResource != null && Object.hasOwnProperty.call(message, "reservationResource"))
                                $root.google.cloud.compute.v1.Reservation.encode(message.reservationResource, writer.uint32(/* id 285030177, wireType 2 =*/2280241418).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertReservationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertReservationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertReservationRequest} message InsertReservationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertReservationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertReservationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertReservationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertReservationRequest} InsertReservationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertReservationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertReservationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 285030177: {
                                        message.reservationResource = $root.google.cloud.compute.v1.Reservation.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertReservationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertReservationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertReservationRequest} InsertReservationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertReservationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertReservationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertReservationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertReservationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.reservationResource != null && message.hasOwnProperty("reservationResource")) {
                                var error = $root.google.cloud.compute.v1.Reservation.verify(message.reservationResource);
                                if (error)
                                    return "reservationResource." + error;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an InsertReservationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertReservationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertReservationRequest} InsertReservationRequest
                         */
                        InsertReservationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertReservationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertReservationRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.reservationResource != null) {
                                if (typeof object.reservationResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertReservationRequest.reservationResource: object expected");
                                message.reservationResource = $root.google.cloud.compute.v1.Reservation.fromObject(object.reservationResource);
                            }
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertReservationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertReservationRequest} message InsertReservationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertReservationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.reservationResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.reservationResource != null && message.hasOwnProperty("reservationResource"))
                                object.reservationResource = $root.google.cloud.compute.v1.Reservation.toObject(message.reservationResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertReservationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertReservationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertReservationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertReservationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertReservationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertReservationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertReservationRequest";
                        };
    
                        return InsertReservationRequest;
                    })();
    
                    v1.InsertResourcePolicyRequest = (function() {
    
                        /**
                         * Properties of an InsertResourcePolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertResourcePolicyRequest
                         * @property {string|null} [project] InsertResourcePolicyRequest project
                         * @property {string|null} [region] InsertResourcePolicyRequest region
                         * @property {string|null} [requestId] InsertResourcePolicyRequest requestId
                         * @property {google.cloud.compute.v1.IResourcePolicy|null} [resourcePolicyResource] InsertResourcePolicyRequest resourcePolicyResource
                         */
    
                        /**
                         * Constructs a new InsertResourcePolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertResourcePolicyRequest.
                         * @implements IInsertResourcePolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertResourcePolicyRequest=} [properties] Properties to set
                         */
                        function InsertResourcePolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertResourcePolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertResourcePolicyRequest
                         * @instance
                         */
                        InsertResourcePolicyRequest.prototype.project = "";
    
                        /**
                         * InsertResourcePolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertResourcePolicyRequest
                         * @instance
                         */
                        InsertResourcePolicyRequest.prototype.region = "";
    
                        /**
                         * InsertResourcePolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertResourcePolicyRequest
                         * @instance
                         */
                        InsertResourcePolicyRequest.prototype.requestId = null;
    
                        /**
                         * InsertResourcePolicyRequest resourcePolicyResource.
                         * @member {google.cloud.compute.v1.IResourcePolicy|null|undefined} resourcePolicyResource
                         * @memberof google.cloud.compute.v1.InsertResourcePolicyRequest
                         * @instance
                         */
                        InsertResourcePolicyRequest.prototype.resourcePolicyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertResourcePolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertResourcePolicyRequest
                         * @instance
                         */
                        Object.defineProperty(InsertResourcePolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertResourcePolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertResourcePolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertResourcePolicyRequest} InsertResourcePolicyRequest instance
                         */
                        InsertResourcePolicyRequest.create = function create(properties) {
                            return new InsertResourcePolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertResourcePolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertResourcePolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertResourcePolicyRequest} message InsertResourcePolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertResourcePolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.resourcePolicyResource != null && Object.hasOwnProperty.call(message, "resourcePolicyResource"))
                                $root.google.cloud.compute.v1.ResourcePolicy.encode(message.resourcePolicyResource, writer.uint32(/* id 76826186, wireType 2 =*/614609490).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertResourcePolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertResourcePolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertResourcePolicyRequest} message InsertResourcePolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertResourcePolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertResourcePolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertResourcePolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertResourcePolicyRequest} InsertResourcePolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertResourcePolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertResourcePolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 76826186: {
                                        message.resourcePolicyResource = $root.google.cloud.compute.v1.ResourcePolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertResourcePolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertResourcePolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertResourcePolicyRequest} InsertResourcePolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertResourcePolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertResourcePolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertResourcePolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertResourcePolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.resourcePolicyResource != null && message.hasOwnProperty("resourcePolicyResource")) {
                                var error = $root.google.cloud.compute.v1.ResourcePolicy.verify(message.resourcePolicyResource);
                                if (error)
                                    return "resourcePolicyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertResourcePolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertResourcePolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertResourcePolicyRequest} InsertResourcePolicyRequest
                         */
                        InsertResourcePolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertResourcePolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertResourcePolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.resourcePolicyResource != null) {
                                if (typeof object.resourcePolicyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertResourcePolicyRequest.resourcePolicyResource: object expected");
                                message.resourcePolicyResource = $root.google.cloud.compute.v1.ResourcePolicy.fromObject(object.resourcePolicyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertResourcePolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertResourcePolicyRequest} message InsertResourcePolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertResourcePolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resourcePolicyResource = null;
                                object.region = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.resourcePolicyResource != null && message.hasOwnProperty("resourcePolicyResource"))
                                object.resourcePolicyResource = $root.google.cloud.compute.v1.ResourcePolicy.toObject(message.resourcePolicyResource, options);
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertResourcePolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertResourcePolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertResourcePolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertResourcePolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertResourcePolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertResourcePolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertResourcePolicyRequest";
                        };
    
                        return InsertResourcePolicyRequest;
                    })();
    
                    v1.InsertRouteRequest = (function() {
    
                        /**
                         * Properties of an InsertRouteRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertRouteRequest
                         * @property {string|null} [project] InsertRouteRequest project
                         * @property {string|null} [requestId] InsertRouteRequest requestId
                         * @property {google.cloud.compute.v1.IRoute|null} [routeResource] InsertRouteRequest routeResource
                         */
    
                        /**
                         * Constructs a new InsertRouteRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertRouteRequest.
                         * @implements IInsertRouteRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertRouteRequest=} [properties] Properties to set
                         */
                        function InsertRouteRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertRouteRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertRouteRequest
                         * @instance
                         */
                        InsertRouteRequest.prototype.project = "";
    
                        /**
                         * InsertRouteRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertRouteRequest
                         * @instance
                         */
                        InsertRouteRequest.prototype.requestId = null;
    
                        /**
                         * InsertRouteRequest routeResource.
                         * @member {google.cloud.compute.v1.IRoute|null|undefined} routeResource
                         * @memberof google.cloud.compute.v1.InsertRouteRequest
                         * @instance
                         */
                        InsertRouteRequest.prototype.routeResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertRouteRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertRouteRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRouteRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertRouteRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertRouteRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRouteRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertRouteRequest} InsertRouteRequest instance
                         */
                        InsertRouteRequest.create = function create(properties) {
                            return new InsertRouteRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertRouteRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertRouteRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertRouteRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRouteRequest} message InsertRouteRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRouteRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.routeResource != null && Object.hasOwnProperty.call(message, "routeResource"))
                                $root.google.cloud.compute.v1.Route.encode(message.routeResource, writer.uint32(/* id 225428804, wireType 2 =*/1803430434).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertRouteRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertRouteRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRouteRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRouteRequest} message InsertRouteRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRouteRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertRouteRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertRouteRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertRouteRequest} InsertRouteRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRouteRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertRouteRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 225428804: {
                                        message.routeResource = $root.google.cloud.compute.v1.Route.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertRouteRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRouteRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertRouteRequest} InsertRouteRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRouteRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertRouteRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertRouteRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertRouteRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.routeResource != null && message.hasOwnProperty("routeResource")) {
                                var error = $root.google.cloud.compute.v1.Route.verify(message.routeResource);
                                if (error)
                                    return "routeResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertRouteRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertRouteRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertRouteRequest} InsertRouteRequest
                         */
                        InsertRouteRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertRouteRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertRouteRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.routeResource != null) {
                                if (typeof object.routeResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertRouteRequest.routeResource: object expected");
                                message.routeResource = $root.google.cloud.compute.v1.Route.fromObject(object.routeResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertRouteRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertRouteRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertRouteRequest} message InsertRouteRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertRouteRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.routeResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.routeResource != null && message.hasOwnProperty("routeResource"))
                                object.routeResource = $root.google.cloud.compute.v1.Route.toObject(message.routeResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertRouteRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertRouteRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertRouteRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertRouteRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertRouteRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertRouteRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertRouteRequest";
                        };
    
                        return InsertRouteRequest;
                    })();
    
                    v1.InsertRouterRequest = (function() {
    
                        /**
                         * Properties of an InsertRouterRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertRouterRequest
                         * @property {string|null} [project] InsertRouterRequest project
                         * @property {string|null} [region] InsertRouterRequest region
                         * @property {string|null} [requestId] InsertRouterRequest requestId
                         * @property {google.cloud.compute.v1.IRouter|null} [routerResource] InsertRouterRequest routerResource
                         */
    
                        /**
                         * Constructs a new InsertRouterRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertRouterRequest.
                         * @implements IInsertRouterRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertRouterRequest=} [properties] Properties to set
                         */
                        function InsertRouterRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertRouterRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertRouterRequest
                         * @instance
                         */
                        InsertRouterRequest.prototype.project = "";
    
                        /**
                         * InsertRouterRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertRouterRequest
                         * @instance
                         */
                        InsertRouterRequest.prototype.region = "";
    
                        /**
                         * InsertRouterRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertRouterRequest
                         * @instance
                         */
                        InsertRouterRequest.prototype.requestId = null;
    
                        /**
                         * InsertRouterRequest routerResource.
                         * @member {google.cloud.compute.v1.IRouter|null|undefined} routerResource
                         * @memberof google.cloud.compute.v1.InsertRouterRequest
                         * @instance
                         */
                        InsertRouterRequest.prototype.routerResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertRouterRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertRouterRequest
                         * @instance
                         */
                        Object.defineProperty(InsertRouterRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertRouterRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRouterRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertRouterRequest} InsertRouterRequest instance
                         */
                        InsertRouterRequest.create = function create(properties) {
                            return new InsertRouterRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertRouterRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertRouterRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRouterRequest} message InsertRouterRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRouterRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.routerResource != null && Object.hasOwnProperty.call(message, "routerResource"))
                                $root.google.cloud.compute.v1.Router.encode(message.routerResource, writer.uint32(/* id 155222084, wireType 2 =*/1241776674).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertRouterRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertRouterRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertRouterRequest} message InsertRouterRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertRouterRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertRouterRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertRouterRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertRouterRequest} InsertRouterRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRouterRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertRouterRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 155222084: {
                                        message.routerResource = $root.google.cloud.compute.v1.Router.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertRouterRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertRouterRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertRouterRequest} InsertRouterRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertRouterRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertRouterRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertRouterRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertRouterRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.routerResource != null && message.hasOwnProperty("routerResource")) {
                                var error = $root.google.cloud.compute.v1.Router.verify(message.routerResource);
                                if (error)
                                    return "routerResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertRouterRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertRouterRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertRouterRequest} InsertRouterRequest
                         */
                        InsertRouterRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertRouterRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertRouterRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.routerResource != null) {
                                if (typeof object.routerResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertRouterRequest.routerResource: object expected");
                                message.routerResource = $root.google.cloud.compute.v1.Router.fromObject(object.routerResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertRouterRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertRouterRequest} message InsertRouterRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertRouterRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.routerResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.routerResource != null && message.hasOwnProperty("routerResource"))
                                object.routerResource = $root.google.cloud.compute.v1.Router.toObject(message.routerResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertRouterRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertRouterRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertRouterRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertRouterRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertRouterRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertRouterRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertRouterRequest";
                        };
    
                        return InsertRouterRequest;
                    })();
    
                    v1.InsertSecurityPolicyRequest = (function() {
    
                        /**
                         * Properties of an InsertSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertSecurityPolicyRequest
                         * @property {string|null} [project] InsertSecurityPolicyRequest project
                         * @property {string|null} [requestId] InsertSecurityPolicyRequest requestId
                         * @property {google.cloud.compute.v1.ISecurityPolicy|null} [securityPolicyResource] InsertSecurityPolicyRequest securityPolicyResource
                         * @property {boolean|null} [validateOnly] InsertSecurityPolicyRequest validateOnly
                         */
    
                        /**
                         * Constructs a new InsertSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertSecurityPolicyRequest.
                         * @implements IInsertSecurityPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertSecurityPolicyRequest=} [properties] Properties to set
                         */
                        function InsertSecurityPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertSecurityPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertSecurityPolicyRequest
                         * @instance
                         */
                        InsertSecurityPolicyRequest.prototype.project = "";
    
                        /**
                         * InsertSecurityPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertSecurityPolicyRequest
                         * @instance
                         */
                        InsertSecurityPolicyRequest.prototype.requestId = null;
    
                        /**
                         * InsertSecurityPolicyRequest securityPolicyResource.
                         * @member {google.cloud.compute.v1.ISecurityPolicy|null|undefined} securityPolicyResource
                         * @memberof google.cloud.compute.v1.InsertSecurityPolicyRequest
                         * @instance
                         */
                        InsertSecurityPolicyRequest.prototype.securityPolicyResource = null;
    
                        /**
                         * InsertSecurityPolicyRequest validateOnly.
                         * @member {boolean|null|undefined} validateOnly
                         * @memberof google.cloud.compute.v1.InsertSecurityPolicyRequest
                         * @instance
                         */
                        InsertSecurityPolicyRequest.prototype.validateOnly = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertSecurityPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertSecurityPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(InsertSecurityPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InsertSecurityPolicyRequest _validateOnly.
                         * @member {"validateOnly"|undefined} _validateOnly
                         * @memberof google.cloud.compute.v1.InsertSecurityPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(InsertSecurityPolicyRequest.prototype, "_validateOnly", {
                            get: $util.oneOfGetter($oneOfFields = ["validateOnly"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertSecurityPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertSecurityPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertSecurityPolicyRequest} InsertSecurityPolicyRequest instance
                         */
                        InsertSecurityPolicyRequest.create = function create(properties) {
                            return new InsertSecurityPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertSecurityPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertSecurityPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertSecurityPolicyRequest} message InsertSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertSecurityPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.securityPolicyResource != null && Object.hasOwnProperty.call(message, "securityPolicyResource"))
                                $root.google.cloud.compute.v1.SecurityPolicy.encode(message.securityPolicyResource, writer.uint32(/* id 216159612, wireType 2 =*/1729276898).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.validateOnly != null && Object.hasOwnProperty.call(message, "validateOnly"))
                                writer.uint32(/* id 242744629, wireType 0 =*/1941957032).bool(message.validateOnly);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertSecurityPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertSecurityPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertSecurityPolicyRequest} message InsertSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertSecurityPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertSecurityPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertSecurityPolicyRequest} InsertSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertSecurityPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertSecurityPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 216159612: {
                                        message.securityPolicyResource = $root.google.cloud.compute.v1.SecurityPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 242744629: {
                                        message.validateOnly = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertSecurityPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertSecurityPolicyRequest} InsertSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertSecurityPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertSecurityPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertSecurityPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.securityPolicyResource != null && message.hasOwnProperty("securityPolicyResource")) {
                                var error = $root.google.cloud.compute.v1.SecurityPolicy.verify(message.securityPolicyResource);
                                if (error)
                                    return "securityPolicyResource." + error;
                            }
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly")) {
                                properties._validateOnly = 1;
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertSecurityPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertSecurityPolicyRequest} InsertSecurityPolicyRequest
                         */
                        InsertSecurityPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertSecurityPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertSecurityPolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.securityPolicyResource != null) {
                                if (typeof object.securityPolicyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertSecurityPolicyRequest.securityPolicyResource: object expected");
                                message.securityPolicyResource = $root.google.cloud.compute.v1.SecurityPolicy.fromObject(object.securityPolicyResource);
                            }
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertSecurityPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertSecurityPolicyRequest} message InsertSecurityPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertSecurityPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.securityPolicyResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.securityPolicyResource != null && message.hasOwnProperty("securityPolicyResource"))
                                object.securityPolicyResource = $root.google.cloud.compute.v1.SecurityPolicy.toObject(message.securityPolicyResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly")) {
                                object.validateOnly = message.validateOnly;
                                if (options.oneofs)
                                    object._validateOnly = "validateOnly";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InsertSecurityPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertSecurityPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertSecurityPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertSecurityPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertSecurityPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertSecurityPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertSecurityPolicyRequest";
                        };
    
                        return InsertSecurityPolicyRequest;
                    })();
    
                    v1.InsertServiceAttachmentRequest = (function() {
    
                        /**
                         * Properties of an InsertServiceAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertServiceAttachmentRequest
                         * @property {string|null} [project] InsertServiceAttachmentRequest project
                         * @property {string|null} [region] InsertServiceAttachmentRequest region
                         * @property {string|null} [requestId] InsertServiceAttachmentRequest requestId
                         * @property {google.cloud.compute.v1.IServiceAttachment|null} [serviceAttachmentResource] InsertServiceAttachmentRequest serviceAttachmentResource
                         */
    
                        /**
                         * Constructs a new InsertServiceAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertServiceAttachmentRequest.
                         * @implements IInsertServiceAttachmentRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertServiceAttachmentRequest=} [properties] Properties to set
                         */
                        function InsertServiceAttachmentRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertServiceAttachmentRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertServiceAttachmentRequest
                         * @instance
                         */
                        InsertServiceAttachmentRequest.prototype.project = "";
    
                        /**
                         * InsertServiceAttachmentRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertServiceAttachmentRequest
                         * @instance
                         */
                        InsertServiceAttachmentRequest.prototype.region = "";
    
                        /**
                         * InsertServiceAttachmentRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertServiceAttachmentRequest
                         * @instance
                         */
                        InsertServiceAttachmentRequest.prototype.requestId = null;
    
                        /**
                         * InsertServiceAttachmentRequest serviceAttachmentResource.
                         * @member {google.cloud.compute.v1.IServiceAttachment|null|undefined} serviceAttachmentResource
                         * @memberof google.cloud.compute.v1.InsertServiceAttachmentRequest
                         * @instance
                         */
                        InsertServiceAttachmentRequest.prototype.serviceAttachmentResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertServiceAttachmentRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertServiceAttachmentRequest
                         * @instance
                         */
                        Object.defineProperty(InsertServiceAttachmentRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertServiceAttachmentRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertServiceAttachmentRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertServiceAttachmentRequest} InsertServiceAttachmentRequest instance
                         */
                        InsertServiceAttachmentRequest.create = function create(properties) {
                            return new InsertServiceAttachmentRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertServiceAttachmentRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertServiceAttachmentRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertServiceAttachmentRequest} message InsertServiceAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertServiceAttachmentRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.serviceAttachmentResource != null && Object.hasOwnProperty.call(message, "serviceAttachmentResource"))
                                $root.google.cloud.compute.v1.ServiceAttachment.encode(message.serviceAttachmentResource, writer.uint32(/* id 472980256, wireType 2 =*/3783842050).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertServiceAttachmentRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertServiceAttachmentRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertServiceAttachmentRequest} message InsertServiceAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertServiceAttachmentRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertServiceAttachmentRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertServiceAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertServiceAttachmentRequest} InsertServiceAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertServiceAttachmentRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertServiceAttachmentRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 472980256: {
                                        message.serviceAttachmentResource = $root.google.cloud.compute.v1.ServiceAttachment.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertServiceAttachmentRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertServiceAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertServiceAttachmentRequest} InsertServiceAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertServiceAttachmentRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertServiceAttachmentRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertServiceAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertServiceAttachmentRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.serviceAttachmentResource != null && message.hasOwnProperty("serviceAttachmentResource")) {
                                var error = $root.google.cloud.compute.v1.ServiceAttachment.verify(message.serviceAttachmentResource);
                                if (error)
                                    return "serviceAttachmentResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertServiceAttachmentRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertServiceAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertServiceAttachmentRequest} InsertServiceAttachmentRequest
                         */
                        InsertServiceAttachmentRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertServiceAttachmentRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertServiceAttachmentRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.serviceAttachmentResource != null) {
                                if (typeof object.serviceAttachmentResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertServiceAttachmentRequest.serviceAttachmentResource: object expected");
                                message.serviceAttachmentResource = $root.google.cloud.compute.v1.ServiceAttachment.fromObject(object.serviceAttachmentResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertServiceAttachmentRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertServiceAttachmentRequest} message InsertServiceAttachmentRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertServiceAttachmentRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.serviceAttachmentResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.serviceAttachmentResource != null && message.hasOwnProperty("serviceAttachmentResource"))
                                object.serviceAttachmentResource = $root.google.cloud.compute.v1.ServiceAttachment.toObject(message.serviceAttachmentResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertServiceAttachmentRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertServiceAttachmentRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertServiceAttachmentRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertServiceAttachmentRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertServiceAttachmentRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertServiceAttachmentRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertServiceAttachmentRequest";
                        };
    
                        return InsertServiceAttachmentRequest;
                    })();
    
                    v1.InsertSnapshotRequest = (function() {
    
                        /**
                         * Properties of an InsertSnapshotRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertSnapshotRequest
                         * @property {string|null} [project] InsertSnapshotRequest project
                         * @property {string|null} [requestId] InsertSnapshotRequest requestId
                         * @property {google.cloud.compute.v1.ISnapshot|null} [snapshotResource] InsertSnapshotRequest snapshotResource
                         */
    
                        /**
                         * Constructs a new InsertSnapshotRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertSnapshotRequest.
                         * @implements IInsertSnapshotRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertSnapshotRequest=} [properties] Properties to set
                         */
                        function InsertSnapshotRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertSnapshotRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertSnapshotRequest
                         * @instance
                         */
                        InsertSnapshotRequest.prototype.project = "";
    
                        /**
                         * InsertSnapshotRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertSnapshotRequest
                         * @instance
                         */
                        InsertSnapshotRequest.prototype.requestId = null;
    
                        /**
                         * InsertSnapshotRequest snapshotResource.
                         * @member {google.cloud.compute.v1.ISnapshot|null|undefined} snapshotResource
                         * @memberof google.cloud.compute.v1.InsertSnapshotRequest
                         * @instance
                         */
                        InsertSnapshotRequest.prototype.snapshotResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertSnapshotRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertSnapshotRequest
                         * @instance
                         */
                        Object.defineProperty(InsertSnapshotRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertSnapshotRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertSnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertSnapshotRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertSnapshotRequest} InsertSnapshotRequest instance
                         */
                        InsertSnapshotRequest.create = function create(properties) {
                            return new InsertSnapshotRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertSnapshotRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertSnapshotRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertSnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertSnapshotRequest} message InsertSnapshotRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertSnapshotRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.snapshotResource != null && Object.hasOwnProperty.call(message, "snapshotResource"))
                                $root.google.cloud.compute.v1.Snapshot.encode(message.snapshotResource, writer.uint32(/* id 481319977, wireType 2 =*/3850559818).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertSnapshotRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertSnapshotRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertSnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertSnapshotRequest} message InsertSnapshotRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertSnapshotRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertSnapshotRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertSnapshotRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertSnapshotRequest} InsertSnapshotRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertSnapshotRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertSnapshotRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 481319977: {
                                        message.snapshotResource = $root.google.cloud.compute.v1.Snapshot.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertSnapshotRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertSnapshotRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertSnapshotRequest} InsertSnapshotRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertSnapshotRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertSnapshotRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertSnapshotRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertSnapshotRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.snapshotResource != null && message.hasOwnProperty("snapshotResource")) {
                                var error = $root.google.cloud.compute.v1.Snapshot.verify(message.snapshotResource);
                                if (error)
                                    return "snapshotResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertSnapshotRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertSnapshotRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertSnapshotRequest} InsertSnapshotRequest
                         */
                        InsertSnapshotRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertSnapshotRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertSnapshotRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.snapshotResource != null) {
                                if (typeof object.snapshotResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertSnapshotRequest.snapshotResource: object expected");
                                message.snapshotResource = $root.google.cloud.compute.v1.Snapshot.fromObject(object.snapshotResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertSnapshotRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertSnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertSnapshotRequest} message InsertSnapshotRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertSnapshotRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.snapshotResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.snapshotResource != null && message.hasOwnProperty("snapshotResource"))
                                object.snapshotResource = $root.google.cloud.compute.v1.Snapshot.toObject(message.snapshotResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertSnapshotRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertSnapshotRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertSnapshotRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertSnapshotRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertSnapshotRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertSnapshotRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertSnapshotRequest";
                        };
    
                        return InsertSnapshotRequest;
                    })();
    
                    v1.InsertSslCertificateRequest = (function() {
    
                        /**
                         * Properties of an InsertSslCertificateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertSslCertificateRequest
                         * @property {string|null} [project] InsertSslCertificateRequest project
                         * @property {string|null} [requestId] InsertSslCertificateRequest requestId
                         * @property {google.cloud.compute.v1.ISslCertificate|null} [sslCertificateResource] InsertSslCertificateRequest sslCertificateResource
                         */
    
                        /**
                         * Constructs a new InsertSslCertificateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertSslCertificateRequest.
                         * @implements IInsertSslCertificateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertSslCertificateRequest=} [properties] Properties to set
                         */
                        function InsertSslCertificateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertSslCertificateRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertSslCertificateRequest
                         * @instance
                         */
                        InsertSslCertificateRequest.prototype.project = "";
    
                        /**
                         * InsertSslCertificateRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertSslCertificateRequest
                         * @instance
                         */
                        InsertSslCertificateRequest.prototype.requestId = null;
    
                        /**
                         * InsertSslCertificateRequest sslCertificateResource.
                         * @member {google.cloud.compute.v1.ISslCertificate|null|undefined} sslCertificateResource
                         * @memberof google.cloud.compute.v1.InsertSslCertificateRequest
                         * @instance
                         */
                        InsertSslCertificateRequest.prototype.sslCertificateResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertSslCertificateRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertSslCertificateRequest
                         * @instance
                         */
                        Object.defineProperty(InsertSslCertificateRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertSslCertificateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertSslCertificateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertSslCertificateRequest} InsertSslCertificateRequest instance
                         */
                        InsertSslCertificateRequest.create = function create(properties) {
                            return new InsertSslCertificateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertSslCertificateRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertSslCertificateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertSslCertificateRequest} message InsertSslCertificateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertSslCertificateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.sslCertificateResource != null && Object.hasOwnProperty.call(message, "sslCertificateResource"))
                                $root.google.cloud.compute.v1.SslCertificate.encode(message.sslCertificateResource, writer.uint32(/* id 180709897, wireType 2 =*/1445679178).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertSslCertificateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertSslCertificateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertSslCertificateRequest} message InsertSslCertificateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertSslCertificateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertSslCertificateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertSslCertificateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertSslCertificateRequest} InsertSslCertificateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertSslCertificateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertSslCertificateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 180709897: {
                                        message.sslCertificateResource = $root.google.cloud.compute.v1.SslCertificate.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertSslCertificateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertSslCertificateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertSslCertificateRequest} InsertSslCertificateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertSslCertificateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertSslCertificateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertSslCertificateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertSslCertificateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.sslCertificateResource != null && message.hasOwnProperty("sslCertificateResource")) {
                                var error = $root.google.cloud.compute.v1.SslCertificate.verify(message.sslCertificateResource);
                                if (error)
                                    return "sslCertificateResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertSslCertificateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertSslCertificateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertSslCertificateRequest} InsertSslCertificateRequest
                         */
                        InsertSslCertificateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertSslCertificateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertSslCertificateRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.sslCertificateResource != null) {
                                if (typeof object.sslCertificateResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertSslCertificateRequest.sslCertificateResource: object expected");
                                message.sslCertificateResource = $root.google.cloud.compute.v1.SslCertificate.fromObject(object.sslCertificateResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertSslCertificateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertSslCertificateRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertSslCertificateRequest} message InsertSslCertificateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertSslCertificateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.sslCertificateResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.sslCertificateResource != null && message.hasOwnProperty("sslCertificateResource"))
                                object.sslCertificateResource = $root.google.cloud.compute.v1.SslCertificate.toObject(message.sslCertificateResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertSslCertificateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertSslCertificateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertSslCertificateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertSslCertificateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertSslCertificateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertSslCertificateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertSslCertificateRequest";
                        };
    
                        return InsertSslCertificateRequest;
                    })();
    
                    v1.InsertSslPolicyRequest = (function() {
    
                        /**
                         * Properties of an InsertSslPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertSslPolicyRequest
                         * @property {string|null} [project] InsertSslPolicyRequest project
                         * @property {string|null} [requestId] InsertSslPolicyRequest requestId
                         * @property {google.cloud.compute.v1.ISslPolicy|null} [sslPolicyResource] InsertSslPolicyRequest sslPolicyResource
                         */
    
                        /**
                         * Constructs a new InsertSslPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertSslPolicyRequest.
                         * @implements IInsertSslPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertSslPolicyRequest=} [properties] Properties to set
                         */
                        function InsertSslPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertSslPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertSslPolicyRequest
                         * @instance
                         */
                        InsertSslPolicyRequest.prototype.project = "";
    
                        /**
                         * InsertSslPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertSslPolicyRequest
                         * @instance
                         */
                        InsertSslPolicyRequest.prototype.requestId = null;
    
                        /**
                         * InsertSslPolicyRequest sslPolicyResource.
                         * @member {google.cloud.compute.v1.ISslPolicy|null|undefined} sslPolicyResource
                         * @memberof google.cloud.compute.v1.InsertSslPolicyRequest
                         * @instance
                         */
                        InsertSslPolicyRequest.prototype.sslPolicyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertSslPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertSslPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(InsertSslPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertSslPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertSslPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertSslPolicyRequest} InsertSslPolicyRequest instance
                         */
                        InsertSslPolicyRequest.create = function create(properties) {
                            return new InsertSslPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertSslPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertSslPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertSslPolicyRequest} message InsertSslPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertSslPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.sslPolicyResource != null && Object.hasOwnProperty.call(message, "sslPolicyResource"))
                                $root.google.cloud.compute.v1.SslPolicy.encode(message.sslPolicyResource, writer.uint32(/* id 274891848, wireType 2 =*/2199134786).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertSslPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertSslPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertSslPolicyRequest} message InsertSslPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertSslPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertSslPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertSslPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertSslPolicyRequest} InsertSslPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertSslPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertSslPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 274891848: {
                                        message.sslPolicyResource = $root.google.cloud.compute.v1.SslPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertSslPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertSslPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertSslPolicyRequest} InsertSslPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertSslPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertSslPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertSslPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertSslPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.sslPolicyResource != null && message.hasOwnProperty("sslPolicyResource")) {
                                var error = $root.google.cloud.compute.v1.SslPolicy.verify(message.sslPolicyResource);
                                if (error)
                                    return "sslPolicyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertSslPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertSslPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertSslPolicyRequest} InsertSslPolicyRequest
                         */
                        InsertSslPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertSslPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertSslPolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.sslPolicyResource != null) {
                                if (typeof object.sslPolicyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertSslPolicyRequest.sslPolicyResource: object expected");
                                message.sslPolicyResource = $root.google.cloud.compute.v1.SslPolicy.fromObject(object.sslPolicyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertSslPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertSslPolicyRequest} message InsertSslPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertSslPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.sslPolicyResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.sslPolicyResource != null && message.hasOwnProperty("sslPolicyResource"))
                                object.sslPolicyResource = $root.google.cloud.compute.v1.SslPolicy.toObject(message.sslPolicyResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertSslPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertSslPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertSslPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertSslPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertSslPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertSslPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertSslPolicyRequest";
                        };
    
                        return InsertSslPolicyRequest;
                    })();
    
                    v1.InsertSubnetworkRequest = (function() {
    
                        /**
                         * Properties of an InsertSubnetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertSubnetworkRequest
                         * @property {string|null} [project] InsertSubnetworkRequest project
                         * @property {string|null} [region] InsertSubnetworkRequest region
                         * @property {string|null} [requestId] InsertSubnetworkRequest requestId
                         * @property {google.cloud.compute.v1.ISubnetwork|null} [subnetworkResource] InsertSubnetworkRequest subnetworkResource
                         */
    
                        /**
                         * Constructs a new InsertSubnetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertSubnetworkRequest.
                         * @implements IInsertSubnetworkRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertSubnetworkRequest=} [properties] Properties to set
                         */
                        function InsertSubnetworkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertSubnetworkRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertSubnetworkRequest
                         * @instance
                         */
                        InsertSubnetworkRequest.prototype.project = "";
    
                        /**
                         * InsertSubnetworkRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertSubnetworkRequest
                         * @instance
                         */
                        InsertSubnetworkRequest.prototype.region = "";
    
                        /**
                         * InsertSubnetworkRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertSubnetworkRequest
                         * @instance
                         */
                        InsertSubnetworkRequest.prototype.requestId = null;
    
                        /**
                         * InsertSubnetworkRequest subnetworkResource.
                         * @member {google.cloud.compute.v1.ISubnetwork|null|undefined} subnetworkResource
                         * @memberof google.cloud.compute.v1.InsertSubnetworkRequest
                         * @instance
                         */
                        InsertSubnetworkRequest.prototype.subnetworkResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertSubnetworkRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertSubnetworkRequest
                         * @instance
                         */
                        Object.defineProperty(InsertSubnetworkRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertSubnetworkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertSubnetworkRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertSubnetworkRequest} InsertSubnetworkRequest instance
                         */
                        InsertSubnetworkRequest.create = function create(properties) {
                            return new InsertSubnetworkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertSubnetworkRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertSubnetworkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertSubnetworkRequest} message InsertSubnetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertSubnetworkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.subnetworkResource != null && Object.hasOwnProperty.call(message, "subnetworkResource"))
                                $root.google.cloud.compute.v1.Subnetwork.encode(message.subnetworkResource, writer.uint32(/* id 42233151, wireType 2 =*/337865210).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertSubnetworkRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertSubnetworkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertSubnetworkRequest} message InsertSubnetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertSubnetworkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertSubnetworkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertSubnetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertSubnetworkRequest} InsertSubnetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertSubnetworkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertSubnetworkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 42233151: {
                                        message.subnetworkResource = $root.google.cloud.compute.v1.Subnetwork.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertSubnetworkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertSubnetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertSubnetworkRequest} InsertSubnetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertSubnetworkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertSubnetworkRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertSubnetworkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertSubnetworkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.subnetworkResource != null && message.hasOwnProperty("subnetworkResource")) {
                                var error = $root.google.cloud.compute.v1.Subnetwork.verify(message.subnetworkResource);
                                if (error)
                                    return "subnetworkResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertSubnetworkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertSubnetworkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertSubnetworkRequest} InsertSubnetworkRequest
                         */
                        InsertSubnetworkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertSubnetworkRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertSubnetworkRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.subnetworkResource != null) {
                                if (typeof object.subnetworkResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertSubnetworkRequest.subnetworkResource: object expected");
                                message.subnetworkResource = $root.google.cloud.compute.v1.Subnetwork.fromObject(object.subnetworkResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertSubnetworkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertSubnetworkRequest} message InsertSubnetworkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertSubnetworkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.subnetworkResource = null;
                                object.region = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.subnetworkResource != null && message.hasOwnProperty("subnetworkResource"))
                                object.subnetworkResource = $root.google.cloud.compute.v1.Subnetwork.toObject(message.subnetworkResource, options);
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertSubnetworkRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertSubnetworkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertSubnetworkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertSubnetworkRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertSubnetworkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertSubnetworkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertSubnetworkRequest";
                        };
    
                        return InsertSubnetworkRequest;
                    })();
    
                    v1.InsertTargetGrpcProxyRequest = (function() {
    
                        /**
                         * Properties of an InsertTargetGrpcProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertTargetGrpcProxyRequest
                         * @property {string|null} [project] InsertTargetGrpcProxyRequest project
                         * @property {string|null} [requestId] InsertTargetGrpcProxyRequest requestId
                         * @property {google.cloud.compute.v1.ITargetGrpcProxy|null} [targetGrpcProxyResource] InsertTargetGrpcProxyRequest targetGrpcProxyResource
                         */
    
                        /**
                         * Constructs a new InsertTargetGrpcProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertTargetGrpcProxyRequest.
                         * @implements IInsertTargetGrpcProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertTargetGrpcProxyRequest=} [properties] Properties to set
                         */
                        function InsertTargetGrpcProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertTargetGrpcProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertTargetGrpcProxyRequest
                         * @instance
                         */
                        InsertTargetGrpcProxyRequest.prototype.project = "";
    
                        /**
                         * InsertTargetGrpcProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertTargetGrpcProxyRequest
                         * @instance
                         */
                        InsertTargetGrpcProxyRequest.prototype.requestId = null;
    
                        /**
                         * InsertTargetGrpcProxyRequest targetGrpcProxyResource.
                         * @member {google.cloud.compute.v1.ITargetGrpcProxy|null|undefined} targetGrpcProxyResource
                         * @memberof google.cloud.compute.v1.InsertTargetGrpcProxyRequest
                         * @instance
                         */
                        InsertTargetGrpcProxyRequest.prototype.targetGrpcProxyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertTargetGrpcProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertTargetGrpcProxyRequest
                         * @instance
                         */
                        Object.defineProperty(InsertTargetGrpcProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertTargetGrpcProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertTargetGrpcProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetGrpcProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertTargetGrpcProxyRequest} InsertTargetGrpcProxyRequest instance
                         */
                        InsertTargetGrpcProxyRequest.create = function create(properties) {
                            return new InsertTargetGrpcProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertTargetGrpcProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertTargetGrpcProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertTargetGrpcProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetGrpcProxyRequest} message InsertTargetGrpcProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertTargetGrpcProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetGrpcProxyResource != null && Object.hasOwnProperty.call(message, "targetGrpcProxyResource"))
                                $root.google.cloud.compute.v1.TargetGrpcProxy.encode(message.targetGrpcProxyResource, writer.uint32(/* id 328922450, wireType 2 =*/2631379602).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertTargetGrpcProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertTargetGrpcProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertTargetGrpcProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetGrpcProxyRequest} message InsertTargetGrpcProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertTargetGrpcProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertTargetGrpcProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertTargetGrpcProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertTargetGrpcProxyRequest} InsertTargetGrpcProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertTargetGrpcProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertTargetGrpcProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 328922450: {
                                        message.targetGrpcProxyResource = $root.google.cloud.compute.v1.TargetGrpcProxy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertTargetGrpcProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertTargetGrpcProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertTargetGrpcProxyRequest} InsertTargetGrpcProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertTargetGrpcProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertTargetGrpcProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertTargetGrpcProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertTargetGrpcProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetGrpcProxyResource != null && message.hasOwnProperty("targetGrpcProxyResource")) {
                                var error = $root.google.cloud.compute.v1.TargetGrpcProxy.verify(message.targetGrpcProxyResource);
                                if (error)
                                    return "targetGrpcProxyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertTargetGrpcProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertTargetGrpcProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertTargetGrpcProxyRequest} InsertTargetGrpcProxyRequest
                         */
                        InsertTargetGrpcProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertTargetGrpcProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertTargetGrpcProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetGrpcProxyResource != null) {
                                if (typeof object.targetGrpcProxyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertTargetGrpcProxyRequest.targetGrpcProxyResource: object expected");
                                message.targetGrpcProxyResource = $root.google.cloud.compute.v1.TargetGrpcProxy.fromObject(object.targetGrpcProxyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertTargetGrpcProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertTargetGrpcProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertTargetGrpcProxyRequest} message InsertTargetGrpcProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertTargetGrpcProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.targetGrpcProxyResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetGrpcProxyResource != null && message.hasOwnProperty("targetGrpcProxyResource"))
                                object.targetGrpcProxyResource = $root.google.cloud.compute.v1.TargetGrpcProxy.toObject(message.targetGrpcProxyResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertTargetGrpcProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertTargetGrpcProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertTargetGrpcProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertTargetGrpcProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertTargetGrpcProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertTargetGrpcProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertTargetGrpcProxyRequest";
                        };
    
                        return InsertTargetGrpcProxyRequest;
                    })();
    
                    v1.InsertTargetHttpProxyRequest = (function() {
    
                        /**
                         * Properties of an InsertTargetHttpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertTargetHttpProxyRequest
                         * @property {string|null} [project] InsertTargetHttpProxyRequest project
                         * @property {string|null} [requestId] InsertTargetHttpProxyRequest requestId
                         * @property {google.cloud.compute.v1.ITargetHttpProxy|null} [targetHttpProxyResource] InsertTargetHttpProxyRequest targetHttpProxyResource
                         */
    
                        /**
                         * Constructs a new InsertTargetHttpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertTargetHttpProxyRequest.
                         * @implements IInsertTargetHttpProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertTargetHttpProxyRequest=} [properties] Properties to set
                         */
                        function InsertTargetHttpProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertTargetHttpProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertTargetHttpProxyRequest
                         * @instance
                         */
                        InsertTargetHttpProxyRequest.prototype.project = "";
    
                        /**
                         * InsertTargetHttpProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertTargetHttpProxyRequest
                         * @instance
                         */
                        InsertTargetHttpProxyRequest.prototype.requestId = null;
    
                        /**
                         * InsertTargetHttpProxyRequest targetHttpProxyResource.
                         * @member {google.cloud.compute.v1.ITargetHttpProxy|null|undefined} targetHttpProxyResource
                         * @memberof google.cloud.compute.v1.InsertTargetHttpProxyRequest
                         * @instance
                         */
                        InsertTargetHttpProxyRequest.prototype.targetHttpProxyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertTargetHttpProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertTargetHttpProxyRequest
                         * @instance
                         */
                        Object.defineProperty(InsertTargetHttpProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertTargetHttpProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetHttpProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertTargetHttpProxyRequest} InsertTargetHttpProxyRequest instance
                         */
                        InsertTargetHttpProxyRequest.create = function create(properties) {
                            return new InsertTargetHttpProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertTargetHttpProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertTargetHttpProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetHttpProxyRequest} message InsertTargetHttpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertTargetHttpProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetHttpProxyResource != null && Object.hasOwnProperty.call(message, "targetHttpProxyResource"))
                                $root.google.cloud.compute.v1.TargetHttpProxy.encode(message.targetHttpProxyResource, writer.uint32(/* id 24696744, wireType 2 =*/197573954).fork()).ldelim();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertTargetHttpProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertTargetHttpProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetHttpProxyRequest} message InsertTargetHttpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertTargetHttpProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertTargetHttpProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertTargetHttpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertTargetHttpProxyRequest} InsertTargetHttpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertTargetHttpProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertTargetHttpProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 24696744: {
                                        message.targetHttpProxyResource = $root.google.cloud.compute.v1.TargetHttpProxy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertTargetHttpProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertTargetHttpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertTargetHttpProxyRequest} InsertTargetHttpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertTargetHttpProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertTargetHttpProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertTargetHttpProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertTargetHttpProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetHttpProxyResource != null && message.hasOwnProperty("targetHttpProxyResource")) {
                                var error = $root.google.cloud.compute.v1.TargetHttpProxy.verify(message.targetHttpProxyResource);
                                if (error)
                                    return "targetHttpProxyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertTargetHttpProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertTargetHttpProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertTargetHttpProxyRequest} InsertTargetHttpProxyRequest
                         */
                        InsertTargetHttpProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertTargetHttpProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertTargetHttpProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetHttpProxyResource != null) {
                                if (typeof object.targetHttpProxyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertTargetHttpProxyRequest.targetHttpProxyResource: object expected");
                                message.targetHttpProxyResource = $root.google.cloud.compute.v1.TargetHttpProxy.fromObject(object.targetHttpProxyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertTargetHttpProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertTargetHttpProxyRequest} message InsertTargetHttpProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertTargetHttpProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetHttpProxyResource = null;
                                object.project = "";
                            }
                            if (message.targetHttpProxyResource != null && message.hasOwnProperty("targetHttpProxyResource"))
                                object.targetHttpProxyResource = $root.google.cloud.compute.v1.TargetHttpProxy.toObject(message.targetHttpProxyResource, options);
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertTargetHttpProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertTargetHttpProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertTargetHttpProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertTargetHttpProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertTargetHttpProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertTargetHttpProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertTargetHttpProxyRequest";
                        };
    
                        return InsertTargetHttpProxyRequest;
                    })();
    
                    v1.InsertTargetHttpsProxyRequest = (function() {
    
                        /**
                         * Properties of an InsertTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertTargetHttpsProxyRequest
                         * @property {string|null} [project] InsertTargetHttpsProxyRequest project
                         * @property {string|null} [requestId] InsertTargetHttpsProxyRequest requestId
                         * @property {google.cloud.compute.v1.ITargetHttpsProxy|null} [targetHttpsProxyResource] InsertTargetHttpsProxyRequest targetHttpsProxyResource
                         */
    
                        /**
                         * Constructs a new InsertTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertTargetHttpsProxyRequest.
                         * @implements IInsertTargetHttpsProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertTargetHttpsProxyRequest=} [properties] Properties to set
                         */
                        function InsertTargetHttpsProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertTargetHttpsProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertTargetHttpsProxyRequest
                         * @instance
                         */
                        InsertTargetHttpsProxyRequest.prototype.project = "";
    
                        /**
                         * InsertTargetHttpsProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertTargetHttpsProxyRequest
                         * @instance
                         */
                        InsertTargetHttpsProxyRequest.prototype.requestId = null;
    
                        /**
                         * InsertTargetHttpsProxyRequest targetHttpsProxyResource.
                         * @member {google.cloud.compute.v1.ITargetHttpsProxy|null|undefined} targetHttpsProxyResource
                         * @memberof google.cloud.compute.v1.InsertTargetHttpsProxyRequest
                         * @instance
                         */
                        InsertTargetHttpsProxyRequest.prototype.targetHttpsProxyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertTargetHttpsProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertTargetHttpsProxyRequest
                         * @instance
                         */
                        Object.defineProperty(InsertTargetHttpsProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertTargetHttpsProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetHttpsProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertTargetHttpsProxyRequest} InsertTargetHttpsProxyRequest instance
                         */
                        InsertTargetHttpsProxyRequest.create = function create(properties) {
                            return new InsertTargetHttpsProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertTargetHttpsProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetHttpsProxyRequest} message InsertTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertTargetHttpsProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetHttpsProxyResource != null && Object.hasOwnProperty.call(message, "targetHttpsProxyResource"))
                                $root.google.cloud.compute.v1.TargetHttpsProxy.encode(message.targetHttpsProxyResource, writer.uint32(/* id 433657473, wireType 2 =*/3469259786).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertTargetHttpsProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetHttpsProxyRequest} message InsertTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertTargetHttpsProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertTargetHttpsProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertTargetHttpsProxyRequest} InsertTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertTargetHttpsProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertTargetHttpsProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 433657473: {
                                        message.targetHttpsProxyResource = $root.google.cloud.compute.v1.TargetHttpsProxy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertTargetHttpsProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertTargetHttpsProxyRequest} InsertTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertTargetHttpsProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertTargetHttpsProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertTargetHttpsProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetHttpsProxyResource != null && message.hasOwnProperty("targetHttpsProxyResource")) {
                                var error = $root.google.cloud.compute.v1.TargetHttpsProxy.verify(message.targetHttpsProxyResource);
                                if (error)
                                    return "targetHttpsProxyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertTargetHttpsProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertTargetHttpsProxyRequest} InsertTargetHttpsProxyRequest
                         */
                        InsertTargetHttpsProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertTargetHttpsProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertTargetHttpsProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetHttpsProxyResource != null) {
                                if (typeof object.targetHttpsProxyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertTargetHttpsProxyRequest.targetHttpsProxyResource: object expected");
                                message.targetHttpsProxyResource = $root.google.cloud.compute.v1.TargetHttpsProxy.fromObject(object.targetHttpsProxyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertTargetHttpsProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertTargetHttpsProxyRequest} message InsertTargetHttpsProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertTargetHttpsProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.targetHttpsProxyResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetHttpsProxyResource != null && message.hasOwnProperty("targetHttpsProxyResource"))
                                object.targetHttpsProxyResource = $root.google.cloud.compute.v1.TargetHttpsProxy.toObject(message.targetHttpsProxyResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertTargetHttpsProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertTargetHttpsProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertTargetHttpsProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertTargetHttpsProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertTargetHttpsProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertTargetHttpsProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertTargetHttpsProxyRequest";
                        };
    
                        return InsertTargetHttpsProxyRequest;
                    })();
    
                    v1.InsertTargetInstanceRequest = (function() {
    
                        /**
                         * Properties of an InsertTargetInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertTargetInstanceRequest
                         * @property {string|null} [project] InsertTargetInstanceRequest project
                         * @property {string|null} [requestId] InsertTargetInstanceRequest requestId
                         * @property {google.cloud.compute.v1.ITargetInstance|null} [targetInstanceResource] InsertTargetInstanceRequest targetInstanceResource
                         * @property {string|null} [zone] InsertTargetInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new InsertTargetInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertTargetInstanceRequest.
                         * @implements IInsertTargetInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertTargetInstanceRequest=} [properties] Properties to set
                         */
                        function InsertTargetInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertTargetInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertTargetInstanceRequest
                         * @instance
                         */
                        InsertTargetInstanceRequest.prototype.project = "";
    
                        /**
                         * InsertTargetInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertTargetInstanceRequest
                         * @instance
                         */
                        InsertTargetInstanceRequest.prototype.requestId = null;
    
                        /**
                         * InsertTargetInstanceRequest targetInstanceResource.
                         * @member {google.cloud.compute.v1.ITargetInstance|null|undefined} targetInstanceResource
                         * @memberof google.cloud.compute.v1.InsertTargetInstanceRequest
                         * @instance
                         */
                        InsertTargetInstanceRequest.prototype.targetInstanceResource = null;
    
                        /**
                         * InsertTargetInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.InsertTargetInstanceRequest
                         * @instance
                         */
                        InsertTargetInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertTargetInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertTargetInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(InsertTargetInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertTargetInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertTargetInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertTargetInstanceRequest} InsertTargetInstanceRequest instance
                         */
                        InsertTargetInstanceRequest.create = function create(properties) {
                            return new InsertTargetInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertTargetInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertTargetInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertTargetInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetInstanceRequest} message InsertTargetInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertTargetInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetInstanceResource != null && Object.hasOwnProperty.call(message, "targetInstanceResource"))
                                $root.google.cloud.compute.v1.TargetInstance.encode(message.targetInstanceResource, writer.uint32(/* id 430453066, wireType 2 =*/3443624530).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertTargetInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertTargetInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertTargetInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetInstanceRequest} message InsertTargetInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertTargetInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertTargetInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertTargetInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertTargetInstanceRequest} InsertTargetInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertTargetInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertTargetInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 430453066: {
                                        message.targetInstanceResource = $root.google.cloud.compute.v1.TargetInstance.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertTargetInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertTargetInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertTargetInstanceRequest} InsertTargetInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertTargetInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertTargetInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertTargetInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertTargetInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetInstanceResource != null && message.hasOwnProperty("targetInstanceResource")) {
                                var error = $root.google.cloud.compute.v1.TargetInstance.verify(message.targetInstanceResource);
                                if (error)
                                    return "targetInstanceResource." + error;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an InsertTargetInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertTargetInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertTargetInstanceRequest} InsertTargetInstanceRequest
                         */
                        InsertTargetInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertTargetInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertTargetInstanceRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetInstanceResource != null) {
                                if (typeof object.targetInstanceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertTargetInstanceRequest.targetInstanceResource: object expected");
                                message.targetInstanceResource = $root.google.cloud.compute.v1.TargetInstance.fromObject(object.targetInstanceResource);
                            }
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertTargetInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertTargetInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertTargetInstanceRequest} message InsertTargetInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertTargetInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.targetInstanceResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetInstanceResource != null && message.hasOwnProperty("targetInstanceResource"))
                                object.targetInstanceResource = $root.google.cloud.compute.v1.TargetInstance.toObject(message.targetInstanceResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertTargetInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertTargetInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertTargetInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertTargetInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertTargetInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertTargetInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertTargetInstanceRequest";
                        };
    
                        return InsertTargetInstanceRequest;
                    })();
    
                    v1.InsertTargetPoolRequest = (function() {
    
                        /**
                         * Properties of an InsertTargetPoolRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertTargetPoolRequest
                         * @property {string|null} [project] InsertTargetPoolRequest project
                         * @property {string|null} [region] InsertTargetPoolRequest region
                         * @property {string|null} [requestId] InsertTargetPoolRequest requestId
                         * @property {google.cloud.compute.v1.ITargetPool|null} [targetPoolResource] InsertTargetPoolRequest targetPoolResource
                         */
    
                        /**
                         * Constructs a new InsertTargetPoolRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertTargetPoolRequest.
                         * @implements IInsertTargetPoolRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertTargetPoolRequest=} [properties] Properties to set
                         */
                        function InsertTargetPoolRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertTargetPoolRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertTargetPoolRequest
                         * @instance
                         */
                        InsertTargetPoolRequest.prototype.project = "";
    
                        /**
                         * InsertTargetPoolRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertTargetPoolRequest
                         * @instance
                         */
                        InsertTargetPoolRequest.prototype.region = "";
    
                        /**
                         * InsertTargetPoolRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertTargetPoolRequest
                         * @instance
                         */
                        InsertTargetPoolRequest.prototype.requestId = null;
    
                        /**
                         * InsertTargetPoolRequest targetPoolResource.
                         * @member {google.cloud.compute.v1.ITargetPool|null|undefined} targetPoolResource
                         * @memberof google.cloud.compute.v1.InsertTargetPoolRequest
                         * @instance
                         */
                        InsertTargetPoolRequest.prototype.targetPoolResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertTargetPoolRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertTargetPoolRequest
                         * @instance
                         */
                        Object.defineProperty(InsertTargetPoolRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertTargetPoolRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetPoolRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertTargetPoolRequest} InsertTargetPoolRequest instance
                         */
                        InsertTargetPoolRequest.create = function create(properties) {
                            return new InsertTargetPoolRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertTargetPoolRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertTargetPoolRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetPoolRequest} message InsertTargetPoolRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertTargetPoolRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetPoolResource != null && Object.hasOwnProperty.call(message, "targetPoolResource"))
                                $root.google.cloud.compute.v1.TargetPool.encode(message.targetPoolResource, writer.uint32(/* id 101281443, wireType 2 =*/810251546).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertTargetPoolRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertTargetPoolRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetPoolRequest} message InsertTargetPoolRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertTargetPoolRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertTargetPoolRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertTargetPoolRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertTargetPoolRequest} InsertTargetPoolRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertTargetPoolRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertTargetPoolRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 101281443: {
                                        message.targetPoolResource = $root.google.cloud.compute.v1.TargetPool.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertTargetPoolRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertTargetPoolRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertTargetPoolRequest} InsertTargetPoolRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertTargetPoolRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertTargetPoolRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertTargetPoolRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertTargetPoolRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetPoolResource != null && message.hasOwnProperty("targetPoolResource")) {
                                var error = $root.google.cloud.compute.v1.TargetPool.verify(message.targetPoolResource);
                                if (error)
                                    return "targetPoolResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertTargetPoolRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertTargetPoolRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertTargetPoolRequest} InsertTargetPoolRequest
                         */
                        InsertTargetPoolRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertTargetPoolRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertTargetPoolRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetPoolResource != null) {
                                if (typeof object.targetPoolResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertTargetPoolRequest.targetPoolResource: object expected");
                                message.targetPoolResource = $root.google.cloud.compute.v1.TargetPool.fromObject(object.targetPoolResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertTargetPoolRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertTargetPoolRequest} message InsertTargetPoolRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertTargetPoolRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetPoolResource = null;
                                object.region = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetPoolResource != null && message.hasOwnProperty("targetPoolResource"))
                                object.targetPoolResource = $root.google.cloud.compute.v1.TargetPool.toObject(message.targetPoolResource, options);
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertTargetPoolRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertTargetPoolRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertTargetPoolRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertTargetPoolRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertTargetPoolRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertTargetPoolRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertTargetPoolRequest";
                        };
    
                        return InsertTargetPoolRequest;
                    })();
    
                    v1.InsertTargetSslProxyRequest = (function() {
    
                        /**
                         * Properties of an InsertTargetSslProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertTargetSslProxyRequest
                         * @property {string|null} [project] InsertTargetSslProxyRequest project
                         * @property {string|null} [requestId] InsertTargetSslProxyRequest requestId
                         * @property {google.cloud.compute.v1.ITargetSslProxy|null} [targetSslProxyResource] InsertTargetSslProxyRequest targetSslProxyResource
                         */
    
                        /**
                         * Constructs a new InsertTargetSslProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertTargetSslProxyRequest.
                         * @implements IInsertTargetSslProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertTargetSslProxyRequest=} [properties] Properties to set
                         */
                        function InsertTargetSslProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertTargetSslProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertTargetSslProxyRequest
                         * @instance
                         */
                        InsertTargetSslProxyRequest.prototype.project = "";
    
                        /**
                         * InsertTargetSslProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertTargetSslProxyRequest
                         * @instance
                         */
                        InsertTargetSslProxyRequest.prototype.requestId = null;
    
                        /**
                         * InsertTargetSslProxyRequest targetSslProxyResource.
                         * @member {google.cloud.compute.v1.ITargetSslProxy|null|undefined} targetSslProxyResource
                         * @memberof google.cloud.compute.v1.InsertTargetSslProxyRequest
                         * @instance
                         */
                        InsertTargetSslProxyRequest.prototype.targetSslProxyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertTargetSslProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertTargetSslProxyRequest
                         * @instance
                         */
                        Object.defineProperty(InsertTargetSslProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertTargetSslProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetSslProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertTargetSslProxyRequest} InsertTargetSslProxyRequest instance
                         */
                        InsertTargetSslProxyRequest.create = function create(properties) {
                            return new InsertTargetSslProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertTargetSslProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertTargetSslProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetSslProxyRequest} message InsertTargetSslProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertTargetSslProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetSslProxyResource != null && Object.hasOwnProperty.call(message, "targetSslProxyResource"))
                                $root.google.cloud.compute.v1.TargetSslProxy.encode(message.targetSslProxyResource, writer.uint32(/* id 142016192, wireType 2 =*/1136129538).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertTargetSslProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertTargetSslProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetSslProxyRequest} message InsertTargetSslProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertTargetSslProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertTargetSslProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertTargetSslProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertTargetSslProxyRequest} InsertTargetSslProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertTargetSslProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertTargetSslProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 142016192: {
                                        message.targetSslProxyResource = $root.google.cloud.compute.v1.TargetSslProxy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertTargetSslProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertTargetSslProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertTargetSslProxyRequest} InsertTargetSslProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertTargetSslProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertTargetSslProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertTargetSslProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertTargetSslProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetSslProxyResource != null && message.hasOwnProperty("targetSslProxyResource")) {
                                var error = $root.google.cloud.compute.v1.TargetSslProxy.verify(message.targetSslProxyResource);
                                if (error)
                                    return "targetSslProxyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertTargetSslProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertTargetSslProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertTargetSslProxyRequest} InsertTargetSslProxyRequest
                         */
                        InsertTargetSslProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertTargetSslProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertTargetSslProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetSslProxyResource != null) {
                                if (typeof object.targetSslProxyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertTargetSslProxyRequest.targetSslProxyResource: object expected");
                                message.targetSslProxyResource = $root.google.cloud.compute.v1.TargetSslProxy.fromObject(object.targetSslProxyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertTargetSslProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertTargetSslProxyRequest} message InsertTargetSslProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertTargetSslProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetSslProxyResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetSslProxyResource != null && message.hasOwnProperty("targetSslProxyResource"))
                                object.targetSslProxyResource = $root.google.cloud.compute.v1.TargetSslProxy.toObject(message.targetSslProxyResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertTargetSslProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertTargetSslProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertTargetSslProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertTargetSslProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertTargetSslProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertTargetSslProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertTargetSslProxyRequest";
                        };
    
                        return InsertTargetSslProxyRequest;
                    })();
    
                    v1.InsertTargetTcpProxyRequest = (function() {
    
                        /**
                         * Properties of an InsertTargetTcpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertTargetTcpProxyRequest
                         * @property {string|null} [project] InsertTargetTcpProxyRequest project
                         * @property {string|null} [requestId] InsertTargetTcpProxyRequest requestId
                         * @property {google.cloud.compute.v1.ITargetTcpProxy|null} [targetTcpProxyResource] InsertTargetTcpProxyRequest targetTcpProxyResource
                         */
    
                        /**
                         * Constructs a new InsertTargetTcpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertTargetTcpProxyRequest.
                         * @implements IInsertTargetTcpProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertTargetTcpProxyRequest=} [properties] Properties to set
                         */
                        function InsertTargetTcpProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertTargetTcpProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertTargetTcpProxyRequest
                         * @instance
                         */
                        InsertTargetTcpProxyRequest.prototype.project = "";
    
                        /**
                         * InsertTargetTcpProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertTargetTcpProxyRequest
                         * @instance
                         */
                        InsertTargetTcpProxyRequest.prototype.requestId = null;
    
                        /**
                         * InsertTargetTcpProxyRequest targetTcpProxyResource.
                         * @member {google.cloud.compute.v1.ITargetTcpProxy|null|undefined} targetTcpProxyResource
                         * @memberof google.cloud.compute.v1.InsertTargetTcpProxyRequest
                         * @instance
                         */
                        InsertTargetTcpProxyRequest.prototype.targetTcpProxyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertTargetTcpProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertTargetTcpProxyRequest
                         * @instance
                         */
                        Object.defineProperty(InsertTargetTcpProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertTargetTcpProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetTcpProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertTargetTcpProxyRequest} InsertTargetTcpProxyRequest instance
                         */
                        InsertTargetTcpProxyRequest.create = function create(properties) {
                            return new InsertTargetTcpProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertTargetTcpProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertTargetTcpProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetTcpProxyRequest} message InsertTargetTcpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertTargetTcpProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetTcpProxyResource != null && Object.hasOwnProperty.call(message, "targetTcpProxyResource"))
                                $root.google.cloud.compute.v1.TargetTcpProxy.encode(message.targetTcpProxyResource, writer.uint32(/* id 145913931, wireType 2 =*/1167311450).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertTargetTcpProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertTargetTcpProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetTcpProxyRequest} message InsertTargetTcpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertTargetTcpProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertTargetTcpProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertTargetTcpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertTargetTcpProxyRequest} InsertTargetTcpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertTargetTcpProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertTargetTcpProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 145913931: {
                                        message.targetTcpProxyResource = $root.google.cloud.compute.v1.TargetTcpProxy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertTargetTcpProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertTargetTcpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertTargetTcpProxyRequest} InsertTargetTcpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertTargetTcpProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertTargetTcpProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertTargetTcpProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertTargetTcpProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetTcpProxyResource != null && message.hasOwnProperty("targetTcpProxyResource")) {
                                var error = $root.google.cloud.compute.v1.TargetTcpProxy.verify(message.targetTcpProxyResource);
                                if (error)
                                    return "targetTcpProxyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertTargetTcpProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertTargetTcpProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertTargetTcpProxyRequest} InsertTargetTcpProxyRequest
                         */
                        InsertTargetTcpProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertTargetTcpProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertTargetTcpProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetTcpProxyResource != null) {
                                if (typeof object.targetTcpProxyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertTargetTcpProxyRequest.targetTcpProxyResource: object expected");
                                message.targetTcpProxyResource = $root.google.cloud.compute.v1.TargetTcpProxy.fromObject(object.targetTcpProxyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertTargetTcpProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertTargetTcpProxyRequest} message InsertTargetTcpProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertTargetTcpProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetTcpProxyResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetTcpProxyResource != null && message.hasOwnProperty("targetTcpProxyResource"))
                                object.targetTcpProxyResource = $root.google.cloud.compute.v1.TargetTcpProxy.toObject(message.targetTcpProxyResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertTargetTcpProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertTargetTcpProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertTargetTcpProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertTargetTcpProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertTargetTcpProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertTargetTcpProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertTargetTcpProxyRequest";
                        };
    
                        return InsertTargetTcpProxyRequest;
                    })();
    
                    v1.InsertTargetVpnGatewayRequest = (function() {
    
                        /**
                         * Properties of an InsertTargetVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertTargetVpnGatewayRequest
                         * @property {string|null} [project] InsertTargetVpnGatewayRequest project
                         * @property {string|null} [region] InsertTargetVpnGatewayRequest region
                         * @property {string|null} [requestId] InsertTargetVpnGatewayRequest requestId
                         * @property {google.cloud.compute.v1.ITargetVpnGateway|null} [targetVpnGatewayResource] InsertTargetVpnGatewayRequest targetVpnGatewayResource
                         */
    
                        /**
                         * Constructs a new InsertTargetVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertTargetVpnGatewayRequest.
                         * @implements IInsertTargetVpnGatewayRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertTargetVpnGatewayRequest=} [properties] Properties to set
                         */
                        function InsertTargetVpnGatewayRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertTargetVpnGatewayRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertTargetVpnGatewayRequest
                         * @instance
                         */
                        InsertTargetVpnGatewayRequest.prototype.project = "";
    
                        /**
                         * InsertTargetVpnGatewayRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertTargetVpnGatewayRequest
                         * @instance
                         */
                        InsertTargetVpnGatewayRequest.prototype.region = "";
    
                        /**
                         * InsertTargetVpnGatewayRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertTargetVpnGatewayRequest
                         * @instance
                         */
                        InsertTargetVpnGatewayRequest.prototype.requestId = null;
    
                        /**
                         * InsertTargetVpnGatewayRequest targetVpnGatewayResource.
                         * @member {google.cloud.compute.v1.ITargetVpnGateway|null|undefined} targetVpnGatewayResource
                         * @memberof google.cloud.compute.v1.InsertTargetVpnGatewayRequest
                         * @instance
                         */
                        InsertTargetVpnGatewayRequest.prototype.targetVpnGatewayResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertTargetVpnGatewayRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertTargetVpnGatewayRequest
                         * @instance
                         */
                        Object.defineProperty(InsertTargetVpnGatewayRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertTargetVpnGatewayRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertTargetVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetVpnGatewayRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertTargetVpnGatewayRequest} InsertTargetVpnGatewayRequest instance
                         */
                        InsertTargetVpnGatewayRequest.create = function create(properties) {
                            return new InsertTargetVpnGatewayRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertTargetVpnGatewayRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertTargetVpnGatewayRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertTargetVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetVpnGatewayRequest} message InsertTargetVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertTargetVpnGatewayRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetVpnGatewayResource != null && Object.hasOwnProperty.call(message, "targetVpnGatewayResource"))
                                $root.google.cloud.compute.v1.TargetVpnGateway.encode(message.targetVpnGatewayResource, writer.uint32(/* id 498050, wireType 2 =*/3984402).fork()).ldelim();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertTargetVpnGatewayRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertTargetVpnGatewayRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertTargetVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertTargetVpnGatewayRequest} message InsertTargetVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertTargetVpnGatewayRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertTargetVpnGatewayRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertTargetVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertTargetVpnGatewayRequest} InsertTargetVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertTargetVpnGatewayRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertTargetVpnGatewayRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 498050: {
                                        message.targetVpnGatewayResource = $root.google.cloud.compute.v1.TargetVpnGateway.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertTargetVpnGatewayRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertTargetVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertTargetVpnGatewayRequest} InsertTargetVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertTargetVpnGatewayRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertTargetVpnGatewayRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertTargetVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertTargetVpnGatewayRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetVpnGatewayResource != null && message.hasOwnProperty("targetVpnGatewayResource")) {
                                var error = $root.google.cloud.compute.v1.TargetVpnGateway.verify(message.targetVpnGatewayResource);
                                if (error)
                                    return "targetVpnGatewayResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertTargetVpnGatewayRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertTargetVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertTargetVpnGatewayRequest} InsertTargetVpnGatewayRequest
                         */
                        InsertTargetVpnGatewayRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertTargetVpnGatewayRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertTargetVpnGatewayRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetVpnGatewayResource != null) {
                                if (typeof object.targetVpnGatewayResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertTargetVpnGatewayRequest.targetVpnGatewayResource: object expected");
                                message.targetVpnGatewayResource = $root.google.cloud.compute.v1.TargetVpnGateway.fromObject(object.targetVpnGatewayResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertTargetVpnGatewayRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertTargetVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertTargetVpnGatewayRequest} message InsertTargetVpnGatewayRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertTargetVpnGatewayRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetVpnGatewayResource = null;
                                object.region = "";
                                object.project = "";
                            }
                            if (message.targetVpnGatewayResource != null && message.hasOwnProperty("targetVpnGatewayResource"))
                                object.targetVpnGatewayResource = $root.google.cloud.compute.v1.TargetVpnGateway.toObject(message.targetVpnGatewayResource, options);
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertTargetVpnGatewayRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertTargetVpnGatewayRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertTargetVpnGatewayRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertTargetVpnGatewayRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertTargetVpnGatewayRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertTargetVpnGatewayRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertTargetVpnGatewayRequest";
                        };
    
                        return InsertTargetVpnGatewayRequest;
                    })();
    
                    v1.InsertUrlMapRequest = (function() {
    
                        /**
                         * Properties of an InsertUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertUrlMapRequest
                         * @property {string|null} [project] InsertUrlMapRequest project
                         * @property {string|null} [requestId] InsertUrlMapRequest requestId
                         * @property {google.cloud.compute.v1.IUrlMap|null} [urlMapResource] InsertUrlMapRequest urlMapResource
                         */
    
                        /**
                         * Constructs a new InsertUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertUrlMapRequest.
                         * @implements IInsertUrlMapRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertUrlMapRequest=} [properties] Properties to set
                         */
                        function InsertUrlMapRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertUrlMapRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertUrlMapRequest
                         * @instance
                         */
                        InsertUrlMapRequest.prototype.project = "";
    
                        /**
                         * InsertUrlMapRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertUrlMapRequest
                         * @instance
                         */
                        InsertUrlMapRequest.prototype.requestId = null;
    
                        /**
                         * InsertUrlMapRequest urlMapResource.
                         * @member {google.cloud.compute.v1.IUrlMap|null|undefined} urlMapResource
                         * @memberof google.cloud.compute.v1.InsertUrlMapRequest
                         * @instance
                         */
                        InsertUrlMapRequest.prototype.urlMapResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertUrlMapRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertUrlMapRequest
                         * @instance
                         */
                        Object.defineProperty(InsertUrlMapRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertUrlMapRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertUrlMapRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertUrlMapRequest} InsertUrlMapRequest instance
                         */
                        InsertUrlMapRequest.create = function create(properties) {
                            return new InsertUrlMapRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertUrlMapRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertUrlMapRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertUrlMapRequest} message InsertUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertUrlMapRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.urlMapResource != null && Object.hasOwnProperty.call(message, "urlMapResource"))
                                $root.google.cloud.compute.v1.UrlMap.encode(message.urlMapResource, writer.uint32(/* id 168675425, wireType 2 =*/1349403402).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertUrlMapRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertUrlMapRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertUrlMapRequest} message InsertUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertUrlMapRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertUrlMapRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertUrlMapRequest} InsertUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertUrlMapRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertUrlMapRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 168675425: {
                                        message.urlMapResource = $root.google.cloud.compute.v1.UrlMap.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertUrlMapRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertUrlMapRequest} InsertUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertUrlMapRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertUrlMapRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertUrlMapRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.urlMapResource != null && message.hasOwnProperty("urlMapResource")) {
                                var error = $root.google.cloud.compute.v1.UrlMap.verify(message.urlMapResource);
                                if (error)
                                    return "urlMapResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertUrlMapRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertUrlMapRequest} InsertUrlMapRequest
                         */
                        InsertUrlMapRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertUrlMapRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertUrlMapRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.urlMapResource != null) {
                                if (typeof object.urlMapResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertUrlMapRequest.urlMapResource: object expected");
                                message.urlMapResource = $root.google.cloud.compute.v1.UrlMap.fromObject(object.urlMapResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertUrlMapRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertUrlMapRequest} message InsertUrlMapRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertUrlMapRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.urlMapResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.urlMapResource != null && message.hasOwnProperty("urlMapResource"))
                                object.urlMapResource = $root.google.cloud.compute.v1.UrlMap.toObject(message.urlMapResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertUrlMapRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertUrlMapRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertUrlMapRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertUrlMapRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertUrlMapRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertUrlMapRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertUrlMapRequest";
                        };
    
                        return InsertUrlMapRequest;
                    })();
    
                    v1.InsertVpnGatewayRequest = (function() {
    
                        /**
                         * Properties of an InsertVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertVpnGatewayRequest
                         * @property {string|null} [project] InsertVpnGatewayRequest project
                         * @property {string|null} [region] InsertVpnGatewayRequest region
                         * @property {string|null} [requestId] InsertVpnGatewayRequest requestId
                         * @property {google.cloud.compute.v1.IVpnGateway|null} [vpnGatewayResource] InsertVpnGatewayRequest vpnGatewayResource
                         */
    
                        /**
                         * Constructs a new InsertVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertVpnGatewayRequest.
                         * @implements IInsertVpnGatewayRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertVpnGatewayRequest=} [properties] Properties to set
                         */
                        function InsertVpnGatewayRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertVpnGatewayRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertVpnGatewayRequest
                         * @instance
                         */
                        InsertVpnGatewayRequest.prototype.project = "";
    
                        /**
                         * InsertVpnGatewayRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertVpnGatewayRequest
                         * @instance
                         */
                        InsertVpnGatewayRequest.prototype.region = "";
    
                        /**
                         * InsertVpnGatewayRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertVpnGatewayRequest
                         * @instance
                         */
                        InsertVpnGatewayRequest.prototype.requestId = null;
    
                        /**
                         * InsertVpnGatewayRequest vpnGatewayResource.
                         * @member {google.cloud.compute.v1.IVpnGateway|null|undefined} vpnGatewayResource
                         * @memberof google.cloud.compute.v1.InsertVpnGatewayRequest
                         * @instance
                         */
                        InsertVpnGatewayRequest.prototype.vpnGatewayResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertVpnGatewayRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertVpnGatewayRequest
                         * @instance
                         */
                        Object.defineProperty(InsertVpnGatewayRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertVpnGatewayRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertVpnGatewayRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertVpnGatewayRequest} InsertVpnGatewayRequest instance
                         */
                        InsertVpnGatewayRequest.create = function create(properties) {
                            return new InsertVpnGatewayRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertVpnGatewayRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertVpnGatewayRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertVpnGatewayRequest} message InsertVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertVpnGatewayRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.vpnGatewayResource != null && Object.hasOwnProperty.call(message, "vpnGatewayResource"))
                                $root.google.cloud.compute.v1.VpnGateway.encode(message.vpnGatewayResource, writer.uint32(/* id 182688660, wireType 2 =*/1461509282).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertVpnGatewayRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertVpnGatewayRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertVpnGatewayRequest} message InsertVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertVpnGatewayRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertVpnGatewayRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertVpnGatewayRequest} InsertVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertVpnGatewayRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertVpnGatewayRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 182688660: {
                                        message.vpnGatewayResource = $root.google.cloud.compute.v1.VpnGateway.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertVpnGatewayRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertVpnGatewayRequest} InsertVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertVpnGatewayRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertVpnGatewayRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertVpnGatewayRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.vpnGatewayResource != null && message.hasOwnProperty("vpnGatewayResource")) {
                                var error = $root.google.cloud.compute.v1.VpnGateway.verify(message.vpnGatewayResource);
                                if (error)
                                    return "vpnGatewayResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertVpnGatewayRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertVpnGatewayRequest} InsertVpnGatewayRequest
                         */
                        InsertVpnGatewayRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertVpnGatewayRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertVpnGatewayRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.vpnGatewayResource != null) {
                                if (typeof object.vpnGatewayResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertVpnGatewayRequest.vpnGatewayResource: object expected");
                                message.vpnGatewayResource = $root.google.cloud.compute.v1.VpnGateway.fromObject(object.vpnGatewayResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertVpnGatewayRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertVpnGatewayRequest} message InsertVpnGatewayRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertVpnGatewayRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.vpnGatewayResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.vpnGatewayResource != null && message.hasOwnProperty("vpnGatewayResource"))
                                object.vpnGatewayResource = $root.google.cloud.compute.v1.VpnGateway.toObject(message.vpnGatewayResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertVpnGatewayRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertVpnGatewayRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertVpnGatewayRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertVpnGatewayRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertVpnGatewayRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertVpnGatewayRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertVpnGatewayRequest";
                        };
    
                        return InsertVpnGatewayRequest;
                    })();
    
                    v1.InsertVpnTunnelRequest = (function() {
    
                        /**
                         * Properties of an InsertVpnTunnelRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInsertVpnTunnelRequest
                         * @property {string|null} [project] InsertVpnTunnelRequest project
                         * @property {string|null} [region] InsertVpnTunnelRequest region
                         * @property {string|null} [requestId] InsertVpnTunnelRequest requestId
                         * @property {google.cloud.compute.v1.IVpnTunnel|null} [vpnTunnelResource] InsertVpnTunnelRequest vpnTunnelResource
                         */
    
                        /**
                         * Constructs a new InsertVpnTunnelRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InsertVpnTunnelRequest.
                         * @implements IInsertVpnTunnelRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInsertVpnTunnelRequest=} [properties] Properties to set
                         */
                        function InsertVpnTunnelRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertVpnTunnelRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InsertVpnTunnelRequest
                         * @instance
                         */
                        InsertVpnTunnelRequest.prototype.project = "";
    
                        /**
                         * InsertVpnTunnelRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.InsertVpnTunnelRequest
                         * @instance
                         */
                        InsertVpnTunnelRequest.prototype.region = "";
    
                        /**
                         * InsertVpnTunnelRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InsertVpnTunnelRequest
                         * @instance
                         */
                        InsertVpnTunnelRequest.prototype.requestId = null;
    
                        /**
                         * InsertVpnTunnelRequest vpnTunnelResource.
                         * @member {google.cloud.compute.v1.IVpnTunnel|null|undefined} vpnTunnelResource
                         * @memberof google.cloud.compute.v1.InsertVpnTunnelRequest
                         * @instance
                         */
                        InsertVpnTunnelRequest.prototype.vpnTunnelResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertVpnTunnelRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InsertVpnTunnelRequest
                         * @instance
                         */
                        Object.defineProperty(InsertVpnTunnelRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertVpnTunnelRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InsertVpnTunnelRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertVpnTunnelRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InsertVpnTunnelRequest} InsertVpnTunnelRequest instance
                         */
                        InsertVpnTunnelRequest.create = function create(properties) {
                            return new InsertVpnTunnelRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertVpnTunnelRequest message. Does not implicitly {@link google.cloud.compute.v1.InsertVpnTunnelRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InsertVpnTunnelRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertVpnTunnelRequest} message InsertVpnTunnelRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertVpnTunnelRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.vpnTunnelResource != null && Object.hasOwnProperty.call(message, "vpnTunnelResource"))
                                $root.google.cloud.compute.v1.VpnTunnel.encode(message.vpnTunnelResource, writer.uint32(/* id 86839482, wireType 2 =*/694715858).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertVpnTunnelRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InsertVpnTunnelRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InsertVpnTunnelRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInsertVpnTunnelRequest} message InsertVpnTunnelRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertVpnTunnelRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertVpnTunnelRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InsertVpnTunnelRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InsertVpnTunnelRequest} InsertVpnTunnelRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertVpnTunnelRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InsertVpnTunnelRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 86839482: {
                                        message.vpnTunnelResource = $root.google.cloud.compute.v1.VpnTunnel.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertVpnTunnelRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InsertVpnTunnelRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InsertVpnTunnelRequest} InsertVpnTunnelRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertVpnTunnelRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertVpnTunnelRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InsertVpnTunnelRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertVpnTunnelRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.vpnTunnelResource != null && message.hasOwnProperty("vpnTunnelResource")) {
                                var error = $root.google.cloud.compute.v1.VpnTunnel.verify(message.vpnTunnelResource);
                                if (error)
                                    return "vpnTunnelResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertVpnTunnelRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InsertVpnTunnelRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InsertVpnTunnelRequest} InsertVpnTunnelRequest
                         */
                        InsertVpnTunnelRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InsertVpnTunnelRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InsertVpnTunnelRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.vpnTunnelResource != null) {
                                if (typeof object.vpnTunnelResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InsertVpnTunnelRequest.vpnTunnelResource: object expected");
                                message.vpnTunnelResource = $root.google.cloud.compute.v1.VpnTunnel.fromObject(object.vpnTunnelResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertVpnTunnelRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InsertVpnTunnelRequest
                         * @static
                         * @param {google.cloud.compute.v1.InsertVpnTunnelRequest} message InsertVpnTunnelRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertVpnTunnelRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.vpnTunnelResource = null;
                                object.region = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.vpnTunnelResource != null && message.hasOwnProperty("vpnTunnelResource"))
                                object.vpnTunnelResource = $root.google.cloud.compute.v1.VpnTunnel.toObject(message.vpnTunnelResource, options);
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this InsertVpnTunnelRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InsertVpnTunnelRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertVpnTunnelRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertVpnTunnelRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InsertVpnTunnelRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertVpnTunnelRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InsertVpnTunnelRequest";
                        };
    
                        return InsertVpnTunnelRequest;
                    })();
    
                    v1.Instance = (function() {
    
                        /**
                         * Properties of an Instance.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstance
                         * @property {google.cloud.compute.v1.IAdvancedMachineFeatures|null} [advancedMachineFeatures] Instance advancedMachineFeatures
                         * @property {boolean|null} [canIpForward] Instance canIpForward
                         * @property {google.cloud.compute.v1.IConfidentialInstanceConfig|null} [confidentialInstanceConfig] Instance confidentialInstanceConfig
                         * @property {string|null} [cpuPlatform] Instance cpuPlatform
                         * @property {string|null} [creationTimestamp] Instance creationTimestamp
                         * @property {boolean|null} [deletionProtection] Instance deletionProtection
                         * @property {string|null} [description] Instance description
                         * @property {Array.<google.cloud.compute.v1.IAttachedDisk>|null} [disks] Instance disks
                         * @property {google.cloud.compute.v1.IDisplayDevice|null} [displayDevice] Instance displayDevice
                         * @property {string|null} [fingerprint] Instance fingerprint
                         * @property {Array.<google.cloud.compute.v1.IAcceleratorConfig>|null} [guestAccelerators] Instance guestAccelerators
                         * @property {string|null} [hostname] Instance hostname
                         * @property {number|Long|null} [id] Instance id
                         * @property {string|null} [keyRevocationActionType] Instance keyRevocationActionType
                         * @property {string|null} [kind] Instance kind
                         * @property {string|null} [labelFingerprint] Instance labelFingerprint
                         * @property {Object.<string,string>|null} [labels] Instance labels
                         * @property {string|null} [lastStartTimestamp] Instance lastStartTimestamp
                         * @property {string|null} [lastStopTimestamp] Instance lastStopTimestamp
                         * @property {string|null} [lastSuspendedTimestamp] Instance lastSuspendedTimestamp
                         * @property {string|null} [machineType] Instance machineType
                         * @property {google.cloud.compute.v1.IMetadata|null} [metadata] Instance metadata
                         * @property {string|null} [minCpuPlatform] Instance minCpuPlatform
                         * @property {string|null} [name] Instance name
                         * @property {Array.<google.cloud.compute.v1.INetworkInterface>|null} [networkInterfaces] Instance networkInterfaces
                         * @property {google.cloud.compute.v1.INetworkPerformanceConfig|null} [networkPerformanceConfig] Instance networkPerformanceConfig
                         * @property {google.cloud.compute.v1.IInstanceParams|null} [params] Instance params
                         * @property {string|null} [privateIpv6GoogleAccess] Instance privateIpv6GoogleAccess
                         * @property {google.cloud.compute.v1.IReservationAffinity|null} [reservationAffinity] Instance reservationAffinity
                         * @property {Array.<string>|null} [resourcePolicies] Instance resourcePolicies
                         * @property {google.cloud.compute.v1.IResourceStatus|null} [resourceStatus] Instance resourceStatus
                         * @property {boolean|null} [satisfiesPzs] Instance satisfiesPzs
                         * @property {google.cloud.compute.v1.IScheduling|null} [scheduling] Instance scheduling
                         * @property {string|null} [selfLink] Instance selfLink
                         * @property {Array.<google.cloud.compute.v1.IServiceAccount>|null} [serviceAccounts] Instance serviceAccounts
                         * @property {google.cloud.compute.v1.IShieldedInstanceConfig|null} [shieldedInstanceConfig] Instance shieldedInstanceConfig
                         * @property {google.cloud.compute.v1.IShieldedInstanceIntegrityPolicy|null} [shieldedInstanceIntegrityPolicy] Instance shieldedInstanceIntegrityPolicy
                         * @property {string|null} [sourceMachineImage] Instance sourceMachineImage
                         * @property {google.cloud.compute.v1.ICustomerEncryptionKey|null} [sourceMachineImageEncryptionKey] Instance sourceMachineImageEncryptionKey
                         * @property {boolean|null} [startRestricted] Instance startRestricted
                         * @property {string|null} [status] Instance status
                         * @property {string|null} [statusMessage] Instance statusMessage
                         * @property {google.cloud.compute.v1.ITags|null} [tags] Instance tags
                         * @property {string|null} [zone] Instance zone
                         */
    
                        /**
                         * Constructs a new Instance.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an Instance.
                         * @implements IInstance
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstance=} [properties] Properties to set
                         */
                        function Instance(properties) {
                            this.disks = [];
                            this.guestAccelerators = [];
                            this.labels = {};
                            this.networkInterfaces = [];
                            this.resourcePolicies = [];
                            this.serviceAccounts = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Instance advancedMachineFeatures.
                         * @member {google.cloud.compute.v1.IAdvancedMachineFeatures|null|undefined} advancedMachineFeatures
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.advancedMachineFeatures = null;
    
                        /**
                         * Instance canIpForward.
                         * @member {boolean|null|undefined} canIpForward
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.canIpForward = null;
    
                        /**
                         * Instance confidentialInstanceConfig.
                         * @member {google.cloud.compute.v1.IConfidentialInstanceConfig|null|undefined} confidentialInstanceConfig
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.confidentialInstanceConfig = null;
    
                        /**
                         * Instance cpuPlatform.
                         * @member {string|null|undefined} cpuPlatform
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.cpuPlatform = null;
    
                        /**
                         * Instance creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.creationTimestamp = null;
    
                        /**
                         * Instance deletionProtection.
                         * @member {boolean|null|undefined} deletionProtection
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.deletionProtection = null;
    
                        /**
                         * Instance description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.description = null;
    
                        /**
                         * Instance disks.
                         * @member {Array.<google.cloud.compute.v1.IAttachedDisk>} disks
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.disks = $util.emptyArray;
    
                        /**
                         * Instance displayDevice.
                         * @member {google.cloud.compute.v1.IDisplayDevice|null|undefined} displayDevice
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.displayDevice = null;
    
                        /**
                         * Instance fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.fingerprint = null;
    
                        /**
                         * Instance guestAccelerators.
                         * @member {Array.<google.cloud.compute.v1.IAcceleratorConfig>} guestAccelerators
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.guestAccelerators = $util.emptyArray;
    
                        /**
                         * Instance hostname.
                         * @member {string|null|undefined} hostname
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.hostname = null;
    
                        /**
                         * Instance id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.id = null;
    
                        /**
                         * Instance keyRevocationActionType.
                         * @member {string|null|undefined} keyRevocationActionType
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.keyRevocationActionType = null;
    
                        /**
                         * Instance kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.kind = null;
    
                        /**
                         * Instance labelFingerprint.
                         * @member {string|null|undefined} labelFingerprint
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.labelFingerprint = null;
    
                        /**
                         * Instance labels.
                         * @member {Object.<string,string>} labels
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.labels = $util.emptyObject;
    
                        /**
                         * Instance lastStartTimestamp.
                         * @member {string|null|undefined} lastStartTimestamp
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.lastStartTimestamp = null;
    
                        /**
                         * Instance lastStopTimestamp.
                         * @member {string|null|undefined} lastStopTimestamp
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.lastStopTimestamp = null;
    
                        /**
                         * Instance lastSuspendedTimestamp.
                         * @member {string|null|undefined} lastSuspendedTimestamp
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.lastSuspendedTimestamp = null;
    
                        /**
                         * Instance machineType.
                         * @member {string|null|undefined} machineType
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.machineType = null;
    
                        /**
                         * Instance metadata.
                         * @member {google.cloud.compute.v1.IMetadata|null|undefined} metadata
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.metadata = null;
    
                        /**
                         * Instance minCpuPlatform.
                         * @member {string|null|undefined} minCpuPlatform
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.minCpuPlatform = null;
    
                        /**
                         * Instance name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.name = null;
    
                        /**
                         * Instance networkInterfaces.
                         * @member {Array.<google.cloud.compute.v1.INetworkInterface>} networkInterfaces
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.networkInterfaces = $util.emptyArray;
    
                        /**
                         * Instance networkPerformanceConfig.
                         * @member {google.cloud.compute.v1.INetworkPerformanceConfig|null|undefined} networkPerformanceConfig
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.networkPerformanceConfig = null;
    
                        /**
                         * Instance params.
                         * @member {google.cloud.compute.v1.IInstanceParams|null|undefined} params
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.params = null;
    
                        /**
                         * Instance privateIpv6GoogleAccess.
                         * @member {string|null|undefined} privateIpv6GoogleAccess
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.privateIpv6GoogleAccess = null;
    
                        /**
                         * Instance reservationAffinity.
                         * @member {google.cloud.compute.v1.IReservationAffinity|null|undefined} reservationAffinity
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.reservationAffinity = null;
    
                        /**
                         * Instance resourcePolicies.
                         * @member {Array.<string>} resourcePolicies
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.resourcePolicies = $util.emptyArray;
    
                        /**
                         * Instance resourceStatus.
                         * @member {google.cloud.compute.v1.IResourceStatus|null|undefined} resourceStatus
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.resourceStatus = null;
    
                        /**
                         * Instance satisfiesPzs.
                         * @member {boolean|null|undefined} satisfiesPzs
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.satisfiesPzs = null;
    
                        /**
                         * Instance scheduling.
                         * @member {google.cloud.compute.v1.IScheduling|null|undefined} scheduling
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.scheduling = null;
    
                        /**
                         * Instance selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.selfLink = null;
    
                        /**
                         * Instance serviceAccounts.
                         * @member {Array.<google.cloud.compute.v1.IServiceAccount>} serviceAccounts
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.serviceAccounts = $util.emptyArray;
    
                        /**
                         * Instance shieldedInstanceConfig.
                         * @member {google.cloud.compute.v1.IShieldedInstanceConfig|null|undefined} shieldedInstanceConfig
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.shieldedInstanceConfig = null;
    
                        /**
                         * Instance shieldedInstanceIntegrityPolicy.
                         * @member {google.cloud.compute.v1.IShieldedInstanceIntegrityPolicy|null|undefined} shieldedInstanceIntegrityPolicy
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.shieldedInstanceIntegrityPolicy = null;
    
                        /**
                         * Instance sourceMachineImage.
                         * @member {string|null|undefined} sourceMachineImage
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.sourceMachineImage = null;
    
                        /**
                         * Instance sourceMachineImageEncryptionKey.
                         * @member {google.cloud.compute.v1.ICustomerEncryptionKey|null|undefined} sourceMachineImageEncryptionKey
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.sourceMachineImageEncryptionKey = null;
    
                        /**
                         * Instance startRestricted.
                         * @member {boolean|null|undefined} startRestricted
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.startRestricted = null;
    
                        /**
                         * Instance status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.status = null;
    
                        /**
                         * Instance statusMessage.
                         * @member {string|null|undefined} statusMessage
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.statusMessage = null;
    
                        /**
                         * Instance tags.
                         * @member {google.cloud.compute.v1.ITags|null|undefined} tags
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.tags = null;
    
                        /**
                         * Instance zone.
                         * @member {string|null|undefined} zone
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Instance.prototype.zone = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Instance _advancedMachineFeatures.
                         * @member {"advancedMachineFeatures"|undefined} _advancedMachineFeatures
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_advancedMachineFeatures", {
                            get: $util.oneOfGetter($oneOfFields = ["advancedMachineFeatures"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _canIpForward.
                         * @member {"canIpForward"|undefined} _canIpForward
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_canIpForward", {
                            get: $util.oneOfGetter($oneOfFields = ["canIpForward"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _confidentialInstanceConfig.
                         * @member {"confidentialInstanceConfig"|undefined} _confidentialInstanceConfig
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_confidentialInstanceConfig", {
                            get: $util.oneOfGetter($oneOfFields = ["confidentialInstanceConfig"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _cpuPlatform.
                         * @member {"cpuPlatform"|undefined} _cpuPlatform
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_cpuPlatform", {
                            get: $util.oneOfGetter($oneOfFields = ["cpuPlatform"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _deletionProtection.
                         * @member {"deletionProtection"|undefined} _deletionProtection
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_deletionProtection", {
                            get: $util.oneOfGetter($oneOfFields = ["deletionProtection"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _displayDevice.
                         * @member {"displayDevice"|undefined} _displayDevice
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_displayDevice", {
                            get: $util.oneOfGetter($oneOfFields = ["displayDevice"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _hostname.
                         * @member {"hostname"|undefined} _hostname
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_hostname", {
                            get: $util.oneOfGetter($oneOfFields = ["hostname"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _keyRevocationActionType.
                         * @member {"keyRevocationActionType"|undefined} _keyRevocationActionType
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_keyRevocationActionType", {
                            get: $util.oneOfGetter($oneOfFields = ["keyRevocationActionType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _labelFingerprint.
                         * @member {"labelFingerprint"|undefined} _labelFingerprint
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_labelFingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["labelFingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _lastStartTimestamp.
                         * @member {"lastStartTimestamp"|undefined} _lastStartTimestamp
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_lastStartTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["lastStartTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _lastStopTimestamp.
                         * @member {"lastStopTimestamp"|undefined} _lastStopTimestamp
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_lastStopTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["lastStopTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _lastSuspendedTimestamp.
                         * @member {"lastSuspendedTimestamp"|undefined} _lastSuspendedTimestamp
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_lastSuspendedTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["lastSuspendedTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _machineType.
                         * @member {"machineType"|undefined} _machineType
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_machineType", {
                            get: $util.oneOfGetter($oneOfFields = ["machineType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _metadata.
                         * @member {"metadata"|undefined} _metadata
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_metadata", {
                            get: $util.oneOfGetter($oneOfFields = ["metadata"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _minCpuPlatform.
                         * @member {"minCpuPlatform"|undefined} _minCpuPlatform
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_minCpuPlatform", {
                            get: $util.oneOfGetter($oneOfFields = ["minCpuPlatform"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _networkPerformanceConfig.
                         * @member {"networkPerformanceConfig"|undefined} _networkPerformanceConfig
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_networkPerformanceConfig", {
                            get: $util.oneOfGetter($oneOfFields = ["networkPerformanceConfig"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _params.
                         * @member {"params"|undefined} _params
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_params", {
                            get: $util.oneOfGetter($oneOfFields = ["params"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _privateIpv6GoogleAccess.
                         * @member {"privateIpv6GoogleAccess"|undefined} _privateIpv6GoogleAccess
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_privateIpv6GoogleAccess", {
                            get: $util.oneOfGetter($oneOfFields = ["privateIpv6GoogleAccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _reservationAffinity.
                         * @member {"reservationAffinity"|undefined} _reservationAffinity
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_reservationAffinity", {
                            get: $util.oneOfGetter($oneOfFields = ["reservationAffinity"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _resourceStatus.
                         * @member {"resourceStatus"|undefined} _resourceStatus
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_resourceStatus", {
                            get: $util.oneOfGetter($oneOfFields = ["resourceStatus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _satisfiesPzs.
                         * @member {"satisfiesPzs"|undefined} _satisfiesPzs
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_satisfiesPzs", {
                            get: $util.oneOfGetter($oneOfFields = ["satisfiesPzs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _scheduling.
                         * @member {"scheduling"|undefined} _scheduling
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_scheduling", {
                            get: $util.oneOfGetter($oneOfFields = ["scheduling"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _shieldedInstanceConfig.
                         * @member {"shieldedInstanceConfig"|undefined} _shieldedInstanceConfig
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_shieldedInstanceConfig", {
                            get: $util.oneOfGetter($oneOfFields = ["shieldedInstanceConfig"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _shieldedInstanceIntegrityPolicy.
                         * @member {"shieldedInstanceIntegrityPolicy"|undefined} _shieldedInstanceIntegrityPolicy
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_shieldedInstanceIntegrityPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["shieldedInstanceIntegrityPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _sourceMachineImage.
                         * @member {"sourceMachineImage"|undefined} _sourceMachineImage
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_sourceMachineImage", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceMachineImage"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _sourceMachineImageEncryptionKey.
                         * @member {"sourceMachineImageEncryptionKey"|undefined} _sourceMachineImageEncryptionKey
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_sourceMachineImageEncryptionKey", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceMachineImageEncryptionKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _startRestricted.
                         * @member {"startRestricted"|undefined} _startRestricted
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_startRestricted", {
                            get: $util.oneOfGetter($oneOfFields = ["startRestricted"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _statusMessage.
                         * @member {"statusMessage"|undefined} _statusMessage
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_statusMessage", {
                            get: $util.oneOfGetter($oneOfFields = ["statusMessage"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _tags.
                         * @member {"tags"|undefined} _tags
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_tags", {
                            get: $util.oneOfGetter($oneOfFields = ["tags"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Instance _zone.
                         * @member {"zone"|undefined} _zone
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         */
                        Object.defineProperty(Instance.prototype, "_zone", {
                            get: $util.oneOfGetter($oneOfFields = ["zone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Instance instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Instance
                         * @static
                         * @param {google.cloud.compute.v1.IInstance=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Instance} Instance instance
                         */
                        Instance.create = function create(properties) {
                            return new Instance(properties);
                        };
    
                        /**
                         * Encodes the specified Instance message. Does not implicitly {@link google.cloud.compute.v1.Instance.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Instance
                         * @static
                         * @param {google.cloud.compute.v1.IInstance} message Instance message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Instance.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.tags != null && Object.hasOwnProperty.call(message, "tags"))
                                $root.google.cloud.compute.v1.Tags.encode(message.tags, writer.uint32(/* id 3552281, wireType 2 =*/28418250).fork()).ldelim();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.shieldedInstanceConfig != null && Object.hasOwnProperty.call(message, "shieldedInstanceConfig"))
                                $root.google.cloud.compute.v1.ShieldedInstanceConfig.encode(message.shieldedInstanceConfig, writer.uint32(/* id 12862901, wireType 2 =*/102903210).fork()).ldelim();
                            if (message.sourceMachineImage != null && Object.hasOwnProperty.call(message, "sourceMachineImage"))
                                writer.uint32(/* id 21769791, wireType 2 =*/174158330).string(message.sourceMachineImage);
                            if (message.resourcePolicies != null && message.resourcePolicies.length)
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    writer.uint32(/* id 22220385, wireType 2 =*/177763082).string(message.resourcePolicies[i]);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.privateIpv6GoogleAccess != null && Object.hasOwnProperty.call(message, "privateIpv6GoogleAccess"))
                                writer.uint32(/* id 48277006, wireType 2 =*/386216050).string(message.privateIpv6GoogleAccess);
                            if (message.networkInterfaces != null && message.networkInterfaces.length)
                                for (var i = 0; i < message.networkInterfaces.length; ++i)
                                    $root.google.cloud.compute.v1.NetworkInterface.encode(message.networkInterfaces[i], writer.uint32(/* id 52735243, wireType 2 =*/421881946).fork()).ldelim();
                            if (message.params != null && Object.hasOwnProperty.call(message, "params"))
                                $root.google.cloud.compute.v1.InstanceParams.encode(message.params, writer.uint32(/* id 78313862, wireType 2 =*/626510898).fork()).ldelim();
                            if (message.metadata != null && Object.hasOwnProperty.call(message, "metadata"))
                                $root.google.cloud.compute.v1.Metadata.encode(message.metadata, writer.uint32(/* id 86866735, wireType 2 =*/694933882).fork()).ldelim();
                            if (message.disks != null && message.disks.length)
                                for (var i = 0; i < message.disks.length; ++i)
                                    $root.google.cloud.compute.v1.AttachedDisk.encode(message.disks[i], writer.uint32(/* id 95594102, wireType 2 =*/764752818).fork()).ldelim();
                            if (message.startRestricted != null && Object.hasOwnProperty.call(message, "startRestricted"))
                                writer.uint32(/* id 123693144, wireType 0 =*/989545152).bool(message.startRestricted);
                            if (message.reservationAffinity != null && Object.hasOwnProperty.call(message, "reservationAffinity"))
                                $root.google.cloud.compute.v1.ReservationAffinity.encode(message.reservationAffinity, writer.uint32(/* id 157850683, wireType 2 =*/1262805466).fork()).ldelim();
                            if (message.shieldedInstanceIntegrityPolicy != null && Object.hasOwnProperty.call(message, "shieldedInstanceIntegrityPolicy"))
                                $root.google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy.encode(message.shieldedInstanceIntegrityPolicy, writer.uint32(/* id 163696919, wireType 2 =*/1309575354).fork()).ldelim();
                            if (message.labelFingerprint != null && Object.hasOwnProperty.call(message, "labelFingerprint"))
                                writer.uint32(/* id 178124825, wireType 2 =*/1424998602).string(message.labelFingerprint);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.sourceMachineImageEncryptionKey != null && Object.hasOwnProperty.call(message, "sourceMachineImageEncryptionKey"))
                                $root.google.cloud.compute.v1.CustomerEncryptionKey.encode(message.sourceMachineImageEncryptionKey, writer.uint32(/* id 192839075, wireType 2 =*/1542712602).fork()).ldelim();
                            if (message.machineType != null && Object.hasOwnProperty.call(message, "machineType"))
                                writer.uint32(/* id 227711026, wireType 2 =*/1821688210).string(message.machineType);
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.keyRevocationActionType != null && Object.hasOwnProperty.call(message, "keyRevocationActionType"))
                                writer.uint32(/* id 235941474, wireType 2 =*/1887531794).string(message.keyRevocationActionType);
                            if (message.hostname != null && Object.hasOwnProperty.call(message, "hostname"))
                                writer.uint32(/* id 237067315, wireType 2 =*/1896538522).string(message.hostname);
                            if (message.minCpuPlatform != null && Object.hasOwnProperty.call(message, "minCpuPlatform"))
                                writer.uint32(/* id 242912759, wireType 2 =*/1943302074).string(message.minCpuPlatform);
                            if (message.resourceStatus != null && Object.hasOwnProperty.call(message, "resourceStatus"))
                                $root.google.cloud.compute.v1.ResourceStatus.encode(message.resourceStatus, writer.uint32(/* id 249429315, wireType 2 =*/1995434522).fork()).ldelim();
                            if (message.displayDevice != null && Object.hasOwnProperty.call(message, "displayDevice"))
                                $root.google.cloud.compute.v1.DisplayDevice.encode(message.displayDevice, writer.uint32(/* id 258933875, wireType 2 =*/2071471002).fork()).ldelim();
                            if (message.serviceAccounts != null && message.serviceAccounts.length)
                                for (var i = 0; i < message.serviceAccounts.length; ++i)
                                    $root.google.cloud.compute.v1.ServiceAccount.encode(message.serviceAccounts[i], writer.uint32(/* id 277537328, wireType 2 =*/2220298626).fork()).ldelim();
                            if (message.statusMessage != null && Object.hasOwnProperty.call(message, "statusMessage"))
                                writer.uint32(/* id 297428154, wireType 2 =*/2379425234).string(message.statusMessage);
                            if (message.lastSuspendedTimestamp != null && Object.hasOwnProperty.call(message, "lastSuspendedTimestamp"))
                                writer.uint32(/* id 356275337, wireType 2 =*/2850202698).string(message.lastSuspendedTimestamp);
                            if (message.scheduling != null && Object.hasOwnProperty.call(message, "scheduling"))
                                $root.google.cloud.compute.v1.Scheduling.encode(message.scheduling, writer.uint32(/* id 386688404, wireType 2 =*/3093507234).fork()).ldelim();
                            if (message.networkPerformanceConfig != null && Object.hasOwnProperty.call(message, "networkPerformanceConfig"))
                                $root.google.cloud.compute.v1.NetworkPerformanceConfig.encode(message.networkPerformanceConfig, writer.uint32(/* id 398330850, wireType 2 =*/3186646802).fork()).ldelim();
                            if (message.advancedMachineFeatures != null && Object.hasOwnProperty.call(message, "advancedMachineFeatures"))
                                $root.google.cloud.compute.v1.AdvancedMachineFeatures.encode(message.advancedMachineFeatures, writer.uint32(/* id 409646002, wireType 2 =*/3277168018).fork()).ldelim();
                            if (message.cpuPlatform != null && Object.hasOwnProperty.call(message, "cpuPlatform"))
                                writer.uint32(/* id 410285354, wireType 2 =*/3282282834).string(message.cpuPlatform);
                            if (message.lastStopTimestamp != null && Object.hasOwnProperty.call(message, "lastStopTimestamp"))
                                writer.uint32(/* id 412823010, wireType 2 =*/3302584082).string(message.lastStopTimestamp);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.lastStartTimestamp != null && Object.hasOwnProperty.call(message, "lastStartTimestamp"))
                                writer.uint32(/* id 443830736, wireType 2 =*/3550645890).string(message.lastStartTimestamp);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.deletionProtection != null && Object.hasOwnProperty.call(message, "deletionProtection"))
                                writer.uint32(/* id 458014698, wireType 0 =*/3664117584).bool(message.deletionProtection);
                            if (message.guestAccelerators != null && message.guestAccelerators.length)
                                for (var i = 0; i < message.guestAccelerators.length; ++i)
                                    $root.google.cloud.compute.v1.AcceleratorConfig.encode(message.guestAccelerators[i], writer.uint32(/* id 463595119, wireType 2 =*/3708760954).fork()).ldelim();
                            if (message.canIpForward != null && Object.hasOwnProperty.call(message, "canIpForward"))
                                writer.uint32(/* id 467731324, wireType 0 =*/3741850592).bool(message.canIpForward);
                            if (message.satisfiesPzs != null && Object.hasOwnProperty.call(message, "satisfiesPzs"))
                                writer.uint32(/* id 480964267, wireType 0 =*/3847714136).bool(message.satisfiesPzs);
                            if (message.confidentialInstanceConfig != null && Object.hasOwnProperty.call(message, "confidentialInstanceConfig"))
                                $root.google.cloud.compute.v1.ConfidentialInstanceConfig.encode(message.confidentialInstanceConfig, writer.uint32(/* id 490637685, wireType 2 =*/3925101482).fork()).ldelim();
                            if (message.labels != null && Object.hasOwnProperty.call(message, "labels"))
                                for (var keys = Object.keys(message.labels), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 500195327, wireType 2 =*/4001562618).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.labels[keys[i]]).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Instance message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Instance.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Instance
                         * @static
                         * @param {google.cloud.compute.v1.IInstance} message Instance message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Instance.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Instance message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Instance
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Instance} Instance
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Instance.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Instance(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 409646002: {
                                        message.advancedMachineFeatures = $root.google.cloud.compute.v1.AdvancedMachineFeatures.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 467731324: {
                                        message.canIpForward = reader.bool();
                                        break;
                                    }
                                case 490637685: {
                                        message.confidentialInstanceConfig = $root.google.cloud.compute.v1.ConfidentialInstanceConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 410285354: {
                                        message.cpuPlatform = reader.string();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 458014698: {
                                        message.deletionProtection = reader.bool();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 95594102: {
                                        if (!(message.disks && message.disks.length))
                                            message.disks = [];
                                        message.disks.push($root.google.cloud.compute.v1.AttachedDisk.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 258933875: {
                                        message.displayDevice = $root.google.cloud.compute.v1.DisplayDevice.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 463595119: {
                                        if (!(message.guestAccelerators && message.guestAccelerators.length))
                                            message.guestAccelerators = [];
                                        message.guestAccelerators.push($root.google.cloud.compute.v1.AcceleratorConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 237067315: {
                                        message.hostname = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 235941474: {
                                        message.keyRevocationActionType = reader.string();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 178124825: {
                                        message.labelFingerprint = reader.string();
                                        break;
                                    }
                                case 500195327: {
                                        if (message.labels === $util.emptyObject)
                                            message.labels = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.labels[key] = value;
                                        break;
                                    }
                                case 443830736: {
                                        message.lastStartTimestamp = reader.string();
                                        break;
                                    }
                                case 412823010: {
                                        message.lastStopTimestamp = reader.string();
                                        break;
                                    }
                                case 356275337: {
                                        message.lastSuspendedTimestamp = reader.string();
                                        break;
                                    }
                                case 227711026: {
                                        message.machineType = reader.string();
                                        break;
                                    }
                                case 86866735: {
                                        message.metadata = $root.google.cloud.compute.v1.Metadata.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 242912759: {
                                        message.minCpuPlatform = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 52735243: {
                                        if (!(message.networkInterfaces && message.networkInterfaces.length))
                                            message.networkInterfaces = [];
                                        message.networkInterfaces.push($root.google.cloud.compute.v1.NetworkInterface.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 398330850: {
                                        message.networkPerformanceConfig = $root.google.cloud.compute.v1.NetworkPerformanceConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 78313862: {
                                        message.params = $root.google.cloud.compute.v1.InstanceParams.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 48277006: {
                                        message.privateIpv6GoogleAccess = reader.string();
                                        break;
                                    }
                                case 157850683: {
                                        message.reservationAffinity = $root.google.cloud.compute.v1.ReservationAffinity.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 22220385: {
                                        if (!(message.resourcePolicies && message.resourcePolicies.length))
                                            message.resourcePolicies = [];
                                        message.resourcePolicies.push(reader.string());
                                        break;
                                    }
                                case 249429315: {
                                        message.resourceStatus = $root.google.cloud.compute.v1.ResourceStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 480964267: {
                                        message.satisfiesPzs = reader.bool();
                                        break;
                                    }
                                case 386688404: {
                                        message.scheduling = $root.google.cloud.compute.v1.Scheduling.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 277537328: {
                                        if (!(message.serviceAccounts && message.serviceAccounts.length))
                                            message.serviceAccounts = [];
                                        message.serviceAccounts.push($root.google.cloud.compute.v1.ServiceAccount.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 12862901: {
                                        message.shieldedInstanceConfig = $root.google.cloud.compute.v1.ShieldedInstanceConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 163696919: {
                                        message.shieldedInstanceIntegrityPolicy = $root.google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 21769791: {
                                        message.sourceMachineImage = reader.string();
                                        break;
                                    }
                                case 192839075: {
                                        message.sourceMachineImageEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 123693144: {
                                        message.startRestricted = reader.bool();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                case 297428154: {
                                        message.statusMessage = reader.string();
                                        break;
                                    }
                                case 3552281: {
                                        message.tags = $root.google.cloud.compute.v1.Tags.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Instance message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Instance
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Instance} Instance
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Instance.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Instance message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Instance
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Instance.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.advancedMachineFeatures != null && message.hasOwnProperty("advancedMachineFeatures")) {
                                properties._advancedMachineFeatures = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.AdvancedMachineFeatures.verify(message.advancedMachineFeatures);
                                    if (error)
                                        return "advancedMachineFeatures." + error;
                                }
                            }
                            if (message.canIpForward != null && message.hasOwnProperty("canIpForward")) {
                                properties._canIpForward = 1;
                                if (typeof message.canIpForward !== "boolean")
                                    return "canIpForward: boolean expected";
                            }
                            if (message.confidentialInstanceConfig != null && message.hasOwnProperty("confidentialInstanceConfig")) {
                                properties._confidentialInstanceConfig = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ConfidentialInstanceConfig.verify(message.confidentialInstanceConfig);
                                    if (error)
                                        return "confidentialInstanceConfig." + error;
                                }
                            }
                            if (message.cpuPlatform != null && message.hasOwnProperty("cpuPlatform")) {
                                properties._cpuPlatform = 1;
                                if (!$util.isString(message.cpuPlatform))
                                    return "cpuPlatform: string expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.deletionProtection != null && message.hasOwnProperty("deletionProtection")) {
                                properties._deletionProtection = 1;
                                if (typeof message.deletionProtection !== "boolean")
                                    return "deletionProtection: boolean expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.disks != null && message.hasOwnProperty("disks")) {
                                if (!Array.isArray(message.disks))
                                    return "disks: array expected";
                                for (var i = 0; i < message.disks.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AttachedDisk.verify(message.disks[i]);
                                    if (error)
                                        return "disks." + error;
                                }
                            }
                            if (message.displayDevice != null && message.hasOwnProperty("displayDevice")) {
                                properties._displayDevice = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.DisplayDevice.verify(message.displayDevice);
                                    if (error)
                                        return "displayDevice." + error;
                                }
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.guestAccelerators != null && message.hasOwnProperty("guestAccelerators")) {
                                if (!Array.isArray(message.guestAccelerators))
                                    return "guestAccelerators: array expected";
                                for (var i = 0; i < message.guestAccelerators.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AcceleratorConfig.verify(message.guestAccelerators[i]);
                                    if (error)
                                        return "guestAccelerators." + error;
                                }
                            }
                            if (message.hostname != null && message.hasOwnProperty("hostname")) {
                                properties._hostname = 1;
                                if (!$util.isString(message.hostname))
                                    return "hostname: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.keyRevocationActionType != null && message.hasOwnProperty("keyRevocationActionType")) {
                                properties._keyRevocationActionType = 1;
                                if (!$util.isString(message.keyRevocationActionType))
                                    return "keyRevocationActionType: string expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                properties._labelFingerprint = 1;
                                if (!$util.isString(message.labelFingerprint))
                                    return "labelFingerprint: string expected";
                            }
                            if (message.labels != null && message.hasOwnProperty("labels")) {
                                if (!$util.isObject(message.labels))
                                    return "labels: object expected";
                                var key = Object.keys(message.labels);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.labels[key[i]]))
                                        return "labels: string{k:string} expected";
                            }
                            if (message.lastStartTimestamp != null && message.hasOwnProperty("lastStartTimestamp")) {
                                properties._lastStartTimestamp = 1;
                                if (!$util.isString(message.lastStartTimestamp))
                                    return "lastStartTimestamp: string expected";
                            }
                            if (message.lastStopTimestamp != null && message.hasOwnProperty("lastStopTimestamp")) {
                                properties._lastStopTimestamp = 1;
                                if (!$util.isString(message.lastStopTimestamp))
                                    return "lastStopTimestamp: string expected";
                            }
                            if (message.lastSuspendedTimestamp != null && message.hasOwnProperty("lastSuspendedTimestamp")) {
                                properties._lastSuspendedTimestamp = 1;
                                if (!$util.isString(message.lastSuspendedTimestamp))
                                    return "lastSuspendedTimestamp: string expected";
                            }
                            if (message.machineType != null && message.hasOwnProperty("machineType")) {
                                properties._machineType = 1;
                                if (!$util.isString(message.machineType))
                                    return "machineType: string expected";
                            }
                            if (message.metadata != null && message.hasOwnProperty("metadata")) {
                                properties._metadata = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Metadata.verify(message.metadata);
                                    if (error)
                                        return "metadata." + error;
                                }
                            }
                            if (message.minCpuPlatform != null && message.hasOwnProperty("minCpuPlatform")) {
                                properties._minCpuPlatform = 1;
                                if (!$util.isString(message.minCpuPlatform))
                                    return "minCpuPlatform: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.networkInterfaces != null && message.hasOwnProperty("networkInterfaces")) {
                                if (!Array.isArray(message.networkInterfaces))
                                    return "networkInterfaces: array expected";
                                for (var i = 0; i < message.networkInterfaces.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NetworkInterface.verify(message.networkInterfaces[i]);
                                    if (error)
                                        return "networkInterfaces." + error;
                                }
                            }
                            if (message.networkPerformanceConfig != null && message.hasOwnProperty("networkPerformanceConfig")) {
                                properties._networkPerformanceConfig = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.NetworkPerformanceConfig.verify(message.networkPerformanceConfig);
                                    if (error)
                                        return "networkPerformanceConfig." + error;
                                }
                            }
                            if (message.params != null && message.hasOwnProperty("params")) {
                                properties._params = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InstanceParams.verify(message.params);
                                    if (error)
                                        return "params." + error;
                                }
                            }
                            if (message.privateIpv6GoogleAccess != null && message.hasOwnProperty("privateIpv6GoogleAccess")) {
                                properties._privateIpv6GoogleAccess = 1;
                                if (!$util.isString(message.privateIpv6GoogleAccess))
                                    return "privateIpv6GoogleAccess: string expected";
                            }
                            if (message.reservationAffinity != null && message.hasOwnProperty("reservationAffinity")) {
                                properties._reservationAffinity = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ReservationAffinity.verify(message.reservationAffinity);
                                    if (error)
                                        return "reservationAffinity." + error;
                                }
                            }
                            if (message.resourcePolicies != null && message.hasOwnProperty("resourcePolicies")) {
                                if (!Array.isArray(message.resourcePolicies))
                                    return "resourcePolicies: array expected";
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    if (!$util.isString(message.resourcePolicies[i]))
                                        return "resourcePolicies: string[] expected";
                            }
                            if (message.resourceStatus != null && message.hasOwnProperty("resourceStatus")) {
                                properties._resourceStatus = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ResourceStatus.verify(message.resourceStatus);
                                    if (error)
                                        return "resourceStatus." + error;
                                }
                            }
                            if (message.satisfiesPzs != null && message.hasOwnProperty("satisfiesPzs")) {
                                properties._satisfiesPzs = 1;
                                if (typeof message.satisfiesPzs !== "boolean")
                                    return "satisfiesPzs: boolean expected";
                            }
                            if (message.scheduling != null && message.hasOwnProperty("scheduling")) {
                                properties._scheduling = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Scheduling.verify(message.scheduling);
                                    if (error)
                                        return "scheduling." + error;
                                }
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.serviceAccounts != null && message.hasOwnProperty("serviceAccounts")) {
                                if (!Array.isArray(message.serviceAccounts))
                                    return "serviceAccounts: array expected";
                                for (var i = 0; i < message.serviceAccounts.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ServiceAccount.verify(message.serviceAccounts[i]);
                                    if (error)
                                        return "serviceAccounts." + error;
                                }
                            }
                            if (message.shieldedInstanceConfig != null && message.hasOwnProperty("shieldedInstanceConfig")) {
                                properties._shieldedInstanceConfig = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ShieldedInstanceConfig.verify(message.shieldedInstanceConfig);
                                    if (error)
                                        return "shieldedInstanceConfig." + error;
                                }
                            }
                            if (message.shieldedInstanceIntegrityPolicy != null && message.hasOwnProperty("shieldedInstanceIntegrityPolicy")) {
                                properties._shieldedInstanceIntegrityPolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy.verify(message.shieldedInstanceIntegrityPolicy);
                                    if (error)
                                        return "shieldedInstanceIntegrityPolicy." + error;
                                }
                            }
                            if (message.sourceMachineImage != null && message.hasOwnProperty("sourceMachineImage")) {
                                properties._sourceMachineImage = 1;
                                if (!$util.isString(message.sourceMachineImage))
                                    return "sourceMachineImage: string expected";
                            }
                            if (message.sourceMachineImageEncryptionKey != null && message.hasOwnProperty("sourceMachineImageEncryptionKey")) {
                                properties._sourceMachineImageEncryptionKey = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.CustomerEncryptionKey.verify(message.sourceMachineImageEncryptionKey);
                                    if (error)
                                        return "sourceMachineImageEncryptionKey." + error;
                                }
                            }
                            if (message.startRestricted != null && message.hasOwnProperty("startRestricted")) {
                                properties._startRestricted = 1;
                                if (typeof message.startRestricted !== "boolean")
                                    return "startRestricted: boolean expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            if (message.statusMessage != null && message.hasOwnProperty("statusMessage")) {
                                properties._statusMessage = 1;
                                if (!$util.isString(message.statusMessage))
                                    return "statusMessage: string expected";
                            }
                            if (message.tags != null && message.hasOwnProperty("tags")) {
                                properties._tags = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Tags.verify(message.tags);
                                    if (error)
                                        return "tags." + error;
                                }
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                properties._zone = 1;
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an Instance message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Instance
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Instance} Instance
                         */
                        Instance.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Instance)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Instance();
                            if (object.advancedMachineFeatures != null) {
                                if (typeof object.advancedMachineFeatures !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Instance.advancedMachineFeatures: object expected");
                                message.advancedMachineFeatures = $root.google.cloud.compute.v1.AdvancedMachineFeatures.fromObject(object.advancedMachineFeatures);
                            }
                            if (object.canIpForward != null)
                                message.canIpForward = Boolean(object.canIpForward);
                            if (object.confidentialInstanceConfig != null) {
                                if (typeof object.confidentialInstanceConfig !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Instance.confidentialInstanceConfig: object expected");
                                message.confidentialInstanceConfig = $root.google.cloud.compute.v1.ConfidentialInstanceConfig.fromObject(object.confidentialInstanceConfig);
                            }
                            if (object.cpuPlatform != null)
                                message.cpuPlatform = String(object.cpuPlatform);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.deletionProtection != null)
                                message.deletionProtection = Boolean(object.deletionProtection);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.disks) {
                                if (!Array.isArray(object.disks))
                                    throw TypeError(".google.cloud.compute.v1.Instance.disks: array expected");
                                message.disks = [];
                                for (var i = 0; i < object.disks.length; ++i) {
                                    if (typeof object.disks[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Instance.disks: object expected");
                                    message.disks[i] = $root.google.cloud.compute.v1.AttachedDisk.fromObject(object.disks[i]);
                                }
                            }
                            if (object.displayDevice != null) {
                                if (typeof object.displayDevice !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Instance.displayDevice: object expected");
                                message.displayDevice = $root.google.cloud.compute.v1.DisplayDevice.fromObject(object.displayDevice);
                            }
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.guestAccelerators) {
                                if (!Array.isArray(object.guestAccelerators))
                                    throw TypeError(".google.cloud.compute.v1.Instance.guestAccelerators: array expected");
                                message.guestAccelerators = [];
                                for (var i = 0; i < object.guestAccelerators.length; ++i) {
                                    if (typeof object.guestAccelerators[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Instance.guestAccelerators: object expected");
                                    message.guestAccelerators[i] = $root.google.cloud.compute.v1.AcceleratorConfig.fromObject(object.guestAccelerators[i]);
                                }
                            }
                            if (object.hostname != null)
                                message.hostname = String(object.hostname);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.keyRevocationActionType != null)
                                message.keyRevocationActionType = String(object.keyRevocationActionType);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.labelFingerprint != null)
                                message.labelFingerprint = String(object.labelFingerprint);
                            if (object.labels) {
                                if (typeof object.labels !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Instance.labels: object expected");
                                message.labels = {};
                                for (var keys = Object.keys(object.labels), i = 0; i < keys.length; ++i)
                                    message.labels[keys[i]] = String(object.labels[keys[i]]);
                            }
                            if (object.lastStartTimestamp != null)
                                message.lastStartTimestamp = String(object.lastStartTimestamp);
                            if (object.lastStopTimestamp != null)
                                message.lastStopTimestamp = String(object.lastStopTimestamp);
                            if (object.lastSuspendedTimestamp != null)
                                message.lastSuspendedTimestamp = String(object.lastSuspendedTimestamp);
                            if (object.machineType != null)
                                message.machineType = String(object.machineType);
                            if (object.metadata != null) {
                                if (typeof object.metadata !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Instance.metadata: object expected");
                                message.metadata = $root.google.cloud.compute.v1.Metadata.fromObject(object.metadata);
                            }
                            if (object.minCpuPlatform != null)
                                message.minCpuPlatform = String(object.minCpuPlatform);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.networkInterfaces) {
                                if (!Array.isArray(object.networkInterfaces))
                                    throw TypeError(".google.cloud.compute.v1.Instance.networkInterfaces: array expected");
                                message.networkInterfaces = [];
                                for (var i = 0; i < object.networkInterfaces.length; ++i) {
                                    if (typeof object.networkInterfaces[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Instance.networkInterfaces: object expected");
                                    message.networkInterfaces[i] = $root.google.cloud.compute.v1.NetworkInterface.fromObject(object.networkInterfaces[i]);
                                }
                            }
                            if (object.networkPerformanceConfig != null) {
                                if (typeof object.networkPerformanceConfig !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Instance.networkPerformanceConfig: object expected");
                                message.networkPerformanceConfig = $root.google.cloud.compute.v1.NetworkPerformanceConfig.fromObject(object.networkPerformanceConfig);
                            }
                            if (object.params != null) {
                                if (typeof object.params !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Instance.params: object expected");
                                message.params = $root.google.cloud.compute.v1.InstanceParams.fromObject(object.params);
                            }
                            if (object.privateIpv6GoogleAccess != null)
                                message.privateIpv6GoogleAccess = String(object.privateIpv6GoogleAccess);
                            if (object.reservationAffinity != null) {
                                if (typeof object.reservationAffinity !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Instance.reservationAffinity: object expected");
                                message.reservationAffinity = $root.google.cloud.compute.v1.ReservationAffinity.fromObject(object.reservationAffinity);
                            }
                            if (object.resourcePolicies) {
                                if (!Array.isArray(object.resourcePolicies))
                                    throw TypeError(".google.cloud.compute.v1.Instance.resourcePolicies: array expected");
                                message.resourcePolicies = [];
                                for (var i = 0; i < object.resourcePolicies.length; ++i)
                                    message.resourcePolicies[i] = String(object.resourcePolicies[i]);
                            }
                            if (object.resourceStatus != null) {
                                if (typeof object.resourceStatus !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Instance.resourceStatus: object expected");
                                message.resourceStatus = $root.google.cloud.compute.v1.ResourceStatus.fromObject(object.resourceStatus);
                            }
                            if (object.satisfiesPzs != null)
                                message.satisfiesPzs = Boolean(object.satisfiesPzs);
                            if (object.scheduling != null) {
                                if (typeof object.scheduling !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Instance.scheduling: object expected");
                                message.scheduling = $root.google.cloud.compute.v1.Scheduling.fromObject(object.scheduling);
                            }
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.serviceAccounts) {
                                if (!Array.isArray(object.serviceAccounts))
                                    throw TypeError(".google.cloud.compute.v1.Instance.serviceAccounts: array expected");
                                message.serviceAccounts = [];
                                for (var i = 0; i < object.serviceAccounts.length; ++i) {
                                    if (typeof object.serviceAccounts[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Instance.serviceAccounts: object expected");
                                    message.serviceAccounts[i] = $root.google.cloud.compute.v1.ServiceAccount.fromObject(object.serviceAccounts[i]);
                                }
                            }
                            if (object.shieldedInstanceConfig != null) {
                                if (typeof object.shieldedInstanceConfig !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Instance.shieldedInstanceConfig: object expected");
                                message.shieldedInstanceConfig = $root.google.cloud.compute.v1.ShieldedInstanceConfig.fromObject(object.shieldedInstanceConfig);
                            }
                            if (object.shieldedInstanceIntegrityPolicy != null) {
                                if (typeof object.shieldedInstanceIntegrityPolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Instance.shieldedInstanceIntegrityPolicy: object expected");
                                message.shieldedInstanceIntegrityPolicy = $root.google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy.fromObject(object.shieldedInstanceIntegrityPolicy);
                            }
                            if (object.sourceMachineImage != null)
                                message.sourceMachineImage = String(object.sourceMachineImage);
                            if (object.sourceMachineImageEncryptionKey != null) {
                                if (typeof object.sourceMachineImageEncryptionKey !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Instance.sourceMachineImageEncryptionKey: object expected");
                                message.sourceMachineImageEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.fromObject(object.sourceMachineImageEncryptionKey);
                            }
                            if (object.startRestricted != null)
                                message.startRestricted = Boolean(object.startRestricted);
                            if (object.status != null)
                                message.status = String(object.status);
                            if (object.statusMessage != null)
                                message.statusMessage = String(object.statusMessage);
                            if (object.tags != null) {
                                if (typeof object.tags !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Instance.tags: object expected");
                                message.tags = $root.google.cloud.compute.v1.Tags.fromObject(object.tags);
                            }
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Instance message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Instance
                         * @static
                         * @param {google.cloud.compute.v1.Instance} message Instance
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Instance.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.resourcePolicies = [];
                                object.networkInterfaces = [];
                                object.disks = [];
                                object.serviceAccounts = [];
                                object.guestAccelerators = [];
                            }
                            if (options.objects || options.defaults)
                                object.labels = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.tags != null && message.hasOwnProperty("tags")) {
                                object.tags = $root.google.cloud.compute.v1.Tags.toObject(message.tags, options);
                                if (options.oneofs)
                                    object._tags = "tags";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                object.zone = message.zone;
                                if (options.oneofs)
                                    object._zone = "zone";
                            }
                            if (message.shieldedInstanceConfig != null && message.hasOwnProperty("shieldedInstanceConfig")) {
                                object.shieldedInstanceConfig = $root.google.cloud.compute.v1.ShieldedInstanceConfig.toObject(message.shieldedInstanceConfig, options);
                                if (options.oneofs)
                                    object._shieldedInstanceConfig = "shieldedInstanceConfig";
                            }
                            if (message.sourceMachineImage != null && message.hasOwnProperty("sourceMachineImage")) {
                                object.sourceMachineImage = message.sourceMachineImage;
                                if (options.oneofs)
                                    object._sourceMachineImage = "sourceMachineImage";
                            }
                            if (message.resourcePolicies && message.resourcePolicies.length) {
                                object.resourcePolicies = [];
                                for (var j = 0; j < message.resourcePolicies.length; ++j)
                                    object.resourcePolicies[j] = message.resourcePolicies[j];
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.privateIpv6GoogleAccess != null && message.hasOwnProperty("privateIpv6GoogleAccess")) {
                                object.privateIpv6GoogleAccess = message.privateIpv6GoogleAccess;
                                if (options.oneofs)
                                    object._privateIpv6GoogleAccess = "privateIpv6GoogleAccess";
                            }
                            if (message.networkInterfaces && message.networkInterfaces.length) {
                                object.networkInterfaces = [];
                                for (var j = 0; j < message.networkInterfaces.length; ++j)
                                    object.networkInterfaces[j] = $root.google.cloud.compute.v1.NetworkInterface.toObject(message.networkInterfaces[j], options);
                            }
                            if (message.params != null && message.hasOwnProperty("params")) {
                                object.params = $root.google.cloud.compute.v1.InstanceParams.toObject(message.params, options);
                                if (options.oneofs)
                                    object._params = "params";
                            }
                            if (message.metadata != null && message.hasOwnProperty("metadata")) {
                                object.metadata = $root.google.cloud.compute.v1.Metadata.toObject(message.metadata, options);
                                if (options.oneofs)
                                    object._metadata = "metadata";
                            }
                            if (message.disks && message.disks.length) {
                                object.disks = [];
                                for (var j = 0; j < message.disks.length; ++j)
                                    object.disks[j] = $root.google.cloud.compute.v1.AttachedDisk.toObject(message.disks[j], options);
                            }
                            if (message.startRestricted != null && message.hasOwnProperty("startRestricted")) {
                                object.startRestricted = message.startRestricted;
                                if (options.oneofs)
                                    object._startRestricted = "startRestricted";
                            }
                            if (message.reservationAffinity != null && message.hasOwnProperty("reservationAffinity")) {
                                object.reservationAffinity = $root.google.cloud.compute.v1.ReservationAffinity.toObject(message.reservationAffinity, options);
                                if (options.oneofs)
                                    object._reservationAffinity = "reservationAffinity";
                            }
                            if (message.shieldedInstanceIntegrityPolicy != null && message.hasOwnProperty("shieldedInstanceIntegrityPolicy")) {
                                object.shieldedInstanceIntegrityPolicy = $root.google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy.toObject(message.shieldedInstanceIntegrityPolicy, options);
                                if (options.oneofs)
                                    object._shieldedInstanceIntegrityPolicy = "shieldedInstanceIntegrityPolicy";
                            }
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                object.labelFingerprint = message.labelFingerprint;
                                if (options.oneofs)
                                    object._labelFingerprint = "labelFingerprint";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.sourceMachineImageEncryptionKey != null && message.hasOwnProperty("sourceMachineImageEncryptionKey")) {
                                object.sourceMachineImageEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.toObject(message.sourceMachineImageEncryptionKey, options);
                                if (options.oneofs)
                                    object._sourceMachineImageEncryptionKey = "sourceMachineImageEncryptionKey";
                            }
                            if (message.machineType != null && message.hasOwnProperty("machineType")) {
                                object.machineType = message.machineType;
                                if (options.oneofs)
                                    object._machineType = "machineType";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.keyRevocationActionType != null && message.hasOwnProperty("keyRevocationActionType")) {
                                object.keyRevocationActionType = message.keyRevocationActionType;
                                if (options.oneofs)
                                    object._keyRevocationActionType = "keyRevocationActionType";
                            }
                            if (message.hostname != null && message.hasOwnProperty("hostname")) {
                                object.hostname = message.hostname;
                                if (options.oneofs)
                                    object._hostname = "hostname";
                            }
                            if (message.minCpuPlatform != null && message.hasOwnProperty("minCpuPlatform")) {
                                object.minCpuPlatform = message.minCpuPlatform;
                                if (options.oneofs)
                                    object._minCpuPlatform = "minCpuPlatform";
                            }
                            if (message.resourceStatus != null && message.hasOwnProperty("resourceStatus")) {
                                object.resourceStatus = $root.google.cloud.compute.v1.ResourceStatus.toObject(message.resourceStatus, options);
                                if (options.oneofs)
                                    object._resourceStatus = "resourceStatus";
                            }
                            if (message.displayDevice != null && message.hasOwnProperty("displayDevice")) {
                                object.displayDevice = $root.google.cloud.compute.v1.DisplayDevice.toObject(message.displayDevice, options);
                                if (options.oneofs)
                                    object._displayDevice = "displayDevice";
                            }
                            if (message.serviceAccounts && message.serviceAccounts.length) {
                                object.serviceAccounts = [];
                                for (var j = 0; j < message.serviceAccounts.length; ++j)
                                    object.serviceAccounts[j] = $root.google.cloud.compute.v1.ServiceAccount.toObject(message.serviceAccounts[j], options);
                            }
                            if (message.statusMessage != null && message.hasOwnProperty("statusMessage")) {
                                object.statusMessage = message.statusMessage;
                                if (options.oneofs)
                                    object._statusMessage = "statusMessage";
                            }
                            if (message.lastSuspendedTimestamp != null && message.hasOwnProperty("lastSuspendedTimestamp")) {
                                object.lastSuspendedTimestamp = message.lastSuspendedTimestamp;
                                if (options.oneofs)
                                    object._lastSuspendedTimestamp = "lastSuspendedTimestamp";
                            }
                            if (message.scheduling != null && message.hasOwnProperty("scheduling")) {
                                object.scheduling = $root.google.cloud.compute.v1.Scheduling.toObject(message.scheduling, options);
                                if (options.oneofs)
                                    object._scheduling = "scheduling";
                            }
                            if (message.networkPerformanceConfig != null && message.hasOwnProperty("networkPerformanceConfig")) {
                                object.networkPerformanceConfig = $root.google.cloud.compute.v1.NetworkPerformanceConfig.toObject(message.networkPerformanceConfig, options);
                                if (options.oneofs)
                                    object._networkPerformanceConfig = "networkPerformanceConfig";
                            }
                            if (message.advancedMachineFeatures != null && message.hasOwnProperty("advancedMachineFeatures")) {
                                object.advancedMachineFeatures = $root.google.cloud.compute.v1.AdvancedMachineFeatures.toObject(message.advancedMachineFeatures, options);
                                if (options.oneofs)
                                    object._advancedMachineFeatures = "advancedMachineFeatures";
                            }
                            if (message.cpuPlatform != null && message.hasOwnProperty("cpuPlatform")) {
                                object.cpuPlatform = message.cpuPlatform;
                                if (options.oneofs)
                                    object._cpuPlatform = "cpuPlatform";
                            }
                            if (message.lastStopTimestamp != null && message.hasOwnProperty("lastStopTimestamp")) {
                                object.lastStopTimestamp = message.lastStopTimestamp;
                                if (options.oneofs)
                                    object._lastStopTimestamp = "lastStopTimestamp";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.lastStartTimestamp != null && message.hasOwnProperty("lastStartTimestamp")) {
                                object.lastStartTimestamp = message.lastStartTimestamp;
                                if (options.oneofs)
                                    object._lastStartTimestamp = "lastStartTimestamp";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.deletionProtection != null && message.hasOwnProperty("deletionProtection")) {
                                object.deletionProtection = message.deletionProtection;
                                if (options.oneofs)
                                    object._deletionProtection = "deletionProtection";
                            }
                            if (message.guestAccelerators && message.guestAccelerators.length) {
                                object.guestAccelerators = [];
                                for (var j = 0; j < message.guestAccelerators.length; ++j)
                                    object.guestAccelerators[j] = $root.google.cloud.compute.v1.AcceleratorConfig.toObject(message.guestAccelerators[j], options);
                            }
                            if (message.canIpForward != null && message.hasOwnProperty("canIpForward")) {
                                object.canIpForward = message.canIpForward;
                                if (options.oneofs)
                                    object._canIpForward = "canIpForward";
                            }
                            if (message.satisfiesPzs != null && message.hasOwnProperty("satisfiesPzs")) {
                                object.satisfiesPzs = message.satisfiesPzs;
                                if (options.oneofs)
                                    object._satisfiesPzs = "satisfiesPzs";
                            }
                            if (message.confidentialInstanceConfig != null && message.hasOwnProperty("confidentialInstanceConfig")) {
                                object.confidentialInstanceConfig = $root.google.cloud.compute.v1.ConfidentialInstanceConfig.toObject(message.confidentialInstanceConfig, options);
                                if (options.oneofs)
                                    object._confidentialInstanceConfig = "confidentialInstanceConfig";
                            }
                            var keys2;
                            if (message.labels && (keys2 = Object.keys(message.labels)).length) {
                                object.labels = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.labels[keys2[j]] = message.labels[keys2[j]];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Instance to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Instance
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Instance.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Instance
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Instance
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Instance.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Instance";
                        };
    
                        /**
                         * KeyRevocationActionType enum.
                         * @name google.cloud.compute.v1.Instance.KeyRevocationActionType
                         * @enum {number}
                         * @property {number} UNDEFINED_KEY_REVOCATION_ACTION_TYPE=0 UNDEFINED_KEY_REVOCATION_ACTION_TYPE value
                         * @property {number} KEY_REVOCATION_ACTION_TYPE_UNSPECIFIED=467110106 KEY_REVOCATION_ACTION_TYPE_UNSPECIFIED value
                         * @property {number} NONE=2402104 NONE value
                         * @property {number} STOP=2555906 STOP value
                         */
                        Instance.KeyRevocationActionType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_KEY_REVOCATION_ACTION_TYPE"] = 0;
                            values[valuesById[467110106] = "KEY_REVOCATION_ACTION_TYPE_UNSPECIFIED"] = 467110106;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            values[valuesById[2555906] = "STOP"] = 2555906;
                            return values;
                        })();
    
                        /**
                         * PrivateIpv6GoogleAccess enum.
                         * @name google.cloud.compute.v1.Instance.PrivateIpv6GoogleAccess
                         * @enum {number}
                         * @property {number} UNDEFINED_PRIVATE_IPV6_GOOGLE_ACCESS=0 UNDEFINED_PRIVATE_IPV6_GOOGLE_ACCESS value
                         * @property {number} ENABLE_BIDIRECTIONAL_ACCESS_TO_GOOGLE=427975994 ENABLE_BIDIRECTIONAL_ACCESS_TO_GOOGLE value
                         * @property {number} ENABLE_OUTBOUND_VM_ACCESS_TO_GOOGLE=288210263 ENABLE_OUTBOUND_VM_ACCESS_TO_GOOGLE value
                         * @property {number} INHERIT_FROM_SUBNETWORK=530256959 INHERIT_FROM_SUBNETWORK value
                         */
                        Instance.PrivateIpv6GoogleAccess = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PRIVATE_IPV6_GOOGLE_ACCESS"] = 0;
                            values[valuesById[427975994] = "ENABLE_BIDIRECTIONAL_ACCESS_TO_GOOGLE"] = 427975994;
                            values[valuesById[288210263] = "ENABLE_OUTBOUND_VM_ACCESS_TO_GOOGLE"] = 288210263;
                            values[valuesById[530256959] = "INHERIT_FROM_SUBNETWORK"] = 530256959;
                            return values;
                        })();
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.Instance.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} DEPROVISIONING=428935662 DEPROVISIONING value
                         * @property {number} PROVISIONING=290896621 PROVISIONING value
                         * @property {number} REPAIRING=413483285 REPAIRING value
                         * @property {number} RUNNING=121282975 RUNNING value
                         * @property {number} STAGING=431072283 STAGING value
                         * @property {number} STOPPED=444276141 STOPPED value
                         * @property {number} STOPPING=350791796 STOPPING value
                         * @property {number} SUSPENDED=51223995 SUSPENDED value
                         * @property {number} SUSPENDING=514206246 SUSPENDING value
                         * @property {number} TERMINATED=250018339 TERMINATED value
                         */
                        Instance.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[428935662] = "DEPROVISIONING"] = 428935662;
                            values[valuesById[290896621] = "PROVISIONING"] = 290896621;
                            values[valuesById[413483285] = "REPAIRING"] = 413483285;
                            values[valuesById[121282975] = "RUNNING"] = 121282975;
                            values[valuesById[431072283] = "STAGING"] = 431072283;
                            values[valuesById[444276141] = "STOPPED"] = 444276141;
                            values[valuesById[350791796] = "STOPPING"] = 350791796;
                            values[valuesById[51223995] = "SUSPENDED"] = 51223995;
                            values[valuesById[514206246] = "SUSPENDING"] = 514206246;
                            values[valuesById[250018339] = "TERMINATED"] = 250018339;
                            return values;
                        })();
    
                        return Instance;
                    })();
    
                    v1.InstanceAggregatedList = (function() {
    
                        /**
                         * Properties of an InstanceAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceAggregatedList
                         * @property {string|null} [id] InstanceAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IInstancesScopedList>|null} [items] InstanceAggregatedList items
                         * @property {string|null} [kind] InstanceAggregatedList kind
                         * @property {string|null} [nextPageToken] InstanceAggregatedList nextPageToken
                         * @property {string|null} [selfLink] InstanceAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] InstanceAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] InstanceAggregatedList warning
                         */
    
                        /**
                         * Constructs a new InstanceAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceAggregatedList.
                         * @implements IInstanceAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceAggregatedList=} [properties] Properties to set
                         */
                        function InstanceAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @instance
                         */
                        InstanceAggregatedList.prototype.id = null;
    
                        /**
                         * InstanceAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IInstancesScopedList>} items
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @instance
                         */
                        InstanceAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * InstanceAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @instance
                         */
                        InstanceAggregatedList.prototype.kind = null;
    
                        /**
                         * InstanceAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @instance
                         */
                        InstanceAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * InstanceAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @instance
                         */
                        InstanceAggregatedList.prototype.selfLink = null;
    
                        /**
                         * InstanceAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @instance
                         */
                        InstanceAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * InstanceAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @instance
                         */
                        InstanceAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(InstanceAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(InstanceAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(InstanceAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(InstanceAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(InstanceAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceAggregatedList} InstanceAggregatedList instance
                         */
                        InstanceAggregatedList.create = function create(properties) {
                            return new InstanceAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.InstanceAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceAggregatedList} message InstanceAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.InstancesScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceAggregatedList} message InstanceAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceAggregatedList} InstanceAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.InstancesScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceAggregatedList} InstanceAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstancesScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceAggregatedList} InstanceAggregatedList
                         */
                        InstanceAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.InstancesScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.InstanceAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.InstanceAggregatedList} message InstanceAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.InstancesScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceAggregatedList";
                        };
    
                        return InstanceAggregatedList;
                    })();
    
                    v1.InstanceConsumptionData = (function() {
    
                        /**
                         * Properties of an InstanceConsumptionData.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceConsumptionData
                         * @property {google.cloud.compute.v1.IInstanceConsumptionInfo|null} [consumptionInfo] InstanceConsumptionData consumptionInfo
                         * @property {string|null} [instance] InstanceConsumptionData instance
                         */
    
                        /**
                         * Constructs a new InstanceConsumptionData.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceConsumptionData.
                         * @implements IInstanceConsumptionData
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceConsumptionData=} [properties] Properties to set
                         */
                        function InstanceConsumptionData(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceConsumptionData consumptionInfo.
                         * @member {google.cloud.compute.v1.IInstanceConsumptionInfo|null|undefined} consumptionInfo
                         * @memberof google.cloud.compute.v1.InstanceConsumptionData
                         * @instance
                         */
                        InstanceConsumptionData.prototype.consumptionInfo = null;
    
                        /**
                         * InstanceConsumptionData instance.
                         * @member {string|null|undefined} instance
                         * @memberof google.cloud.compute.v1.InstanceConsumptionData
                         * @instance
                         */
                        InstanceConsumptionData.prototype.instance = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceConsumptionData _consumptionInfo.
                         * @member {"consumptionInfo"|undefined} _consumptionInfo
                         * @memberof google.cloud.compute.v1.InstanceConsumptionData
                         * @instance
                         */
                        Object.defineProperty(InstanceConsumptionData.prototype, "_consumptionInfo", {
                            get: $util.oneOfGetter($oneOfFields = ["consumptionInfo"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceConsumptionData _instance.
                         * @member {"instance"|undefined} _instance
                         * @memberof google.cloud.compute.v1.InstanceConsumptionData
                         * @instance
                         */
                        Object.defineProperty(InstanceConsumptionData.prototype, "_instance", {
                            get: $util.oneOfGetter($oneOfFields = ["instance"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceConsumptionData instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceConsumptionData
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceConsumptionData=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceConsumptionData} InstanceConsumptionData instance
                         */
                        InstanceConsumptionData.create = function create(properties) {
                            return new InstanceConsumptionData(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceConsumptionData message. Does not implicitly {@link google.cloud.compute.v1.InstanceConsumptionData.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceConsumptionData
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceConsumptionData} message InstanceConsumptionData message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceConsumptionData.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.consumptionInfo != null && Object.hasOwnProperty.call(message, "consumptionInfo"))
                                $root.google.cloud.compute.v1.InstanceConsumptionInfo.encode(message.consumptionInfo, writer.uint32(/* id 146354898, wireType 2 =*/1170839186).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceConsumptionData message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceConsumptionData.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceConsumptionData
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceConsumptionData} message InstanceConsumptionData message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceConsumptionData.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceConsumptionData message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceConsumptionData
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceConsumptionData} InstanceConsumptionData
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceConsumptionData.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceConsumptionData();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 146354898: {
                                        message.consumptionInfo = $root.google.cloud.compute.v1.InstanceConsumptionInfo.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceConsumptionData message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceConsumptionData
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceConsumptionData} InstanceConsumptionData
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceConsumptionData.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceConsumptionData message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceConsumptionData
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceConsumptionData.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.consumptionInfo != null && message.hasOwnProperty("consumptionInfo")) {
                                properties._consumptionInfo = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InstanceConsumptionInfo.verify(message.consumptionInfo);
                                    if (error)
                                        return "consumptionInfo." + error;
                                }
                            }
                            if (message.instance != null && message.hasOwnProperty("instance")) {
                                properties._instance = 1;
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceConsumptionData message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceConsumptionData
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceConsumptionData} InstanceConsumptionData
                         */
                        InstanceConsumptionData.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceConsumptionData)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceConsumptionData();
                            if (object.consumptionInfo != null) {
                                if (typeof object.consumptionInfo !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceConsumptionData.consumptionInfo: object expected");
                                message.consumptionInfo = $root.google.cloud.compute.v1.InstanceConsumptionInfo.fromObject(object.consumptionInfo);
                            }
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceConsumptionData message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceConsumptionData
                         * @static
                         * @param {google.cloud.compute.v1.InstanceConsumptionData} message InstanceConsumptionData
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceConsumptionData.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.instance != null && message.hasOwnProperty("instance")) {
                                object.instance = message.instance;
                                if (options.oneofs)
                                    object._instance = "instance";
                            }
                            if (message.consumptionInfo != null && message.hasOwnProperty("consumptionInfo")) {
                                object.consumptionInfo = $root.google.cloud.compute.v1.InstanceConsumptionInfo.toObject(message.consumptionInfo, options);
                                if (options.oneofs)
                                    object._consumptionInfo = "consumptionInfo";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceConsumptionData to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceConsumptionData
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceConsumptionData.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceConsumptionData
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceConsumptionData
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceConsumptionData.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceConsumptionData";
                        };
    
                        return InstanceConsumptionData;
                    })();
    
                    v1.InstanceConsumptionInfo = (function() {
    
                        /**
                         * Properties of an InstanceConsumptionInfo.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceConsumptionInfo
                         * @property {number|null} [guestCpus] InstanceConsumptionInfo guestCpus
                         * @property {number|null} [localSsdGb] InstanceConsumptionInfo localSsdGb
                         * @property {number|null} [memoryMb] InstanceConsumptionInfo memoryMb
                         * @property {number|null} [minNodeCpus] InstanceConsumptionInfo minNodeCpus
                         */
    
                        /**
                         * Constructs a new InstanceConsumptionInfo.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceConsumptionInfo.
                         * @implements IInstanceConsumptionInfo
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceConsumptionInfo=} [properties] Properties to set
                         */
                        function InstanceConsumptionInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceConsumptionInfo guestCpus.
                         * @member {number|null|undefined} guestCpus
                         * @memberof google.cloud.compute.v1.InstanceConsumptionInfo
                         * @instance
                         */
                        InstanceConsumptionInfo.prototype.guestCpus = null;
    
                        /**
                         * InstanceConsumptionInfo localSsdGb.
                         * @member {number|null|undefined} localSsdGb
                         * @memberof google.cloud.compute.v1.InstanceConsumptionInfo
                         * @instance
                         */
                        InstanceConsumptionInfo.prototype.localSsdGb = null;
    
                        /**
                         * InstanceConsumptionInfo memoryMb.
                         * @member {number|null|undefined} memoryMb
                         * @memberof google.cloud.compute.v1.InstanceConsumptionInfo
                         * @instance
                         */
                        InstanceConsumptionInfo.prototype.memoryMb = null;
    
                        /**
                         * InstanceConsumptionInfo minNodeCpus.
                         * @member {number|null|undefined} minNodeCpus
                         * @memberof google.cloud.compute.v1.InstanceConsumptionInfo
                         * @instance
                         */
                        InstanceConsumptionInfo.prototype.minNodeCpus = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceConsumptionInfo _guestCpus.
                         * @member {"guestCpus"|undefined} _guestCpus
                         * @memberof google.cloud.compute.v1.InstanceConsumptionInfo
                         * @instance
                         */
                        Object.defineProperty(InstanceConsumptionInfo.prototype, "_guestCpus", {
                            get: $util.oneOfGetter($oneOfFields = ["guestCpus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceConsumptionInfo _localSsdGb.
                         * @member {"localSsdGb"|undefined} _localSsdGb
                         * @memberof google.cloud.compute.v1.InstanceConsumptionInfo
                         * @instance
                         */
                        Object.defineProperty(InstanceConsumptionInfo.prototype, "_localSsdGb", {
                            get: $util.oneOfGetter($oneOfFields = ["localSsdGb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceConsumptionInfo _memoryMb.
                         * @member {"memoryMb"|undefined} _memoryMb
                         * @memberof google.cloud.compute.v1.InstanceConsumptionInfo
                         * @instance
                         */
                        Object.defineProperty(InstanceConsumptionInfo.prototype, "_memoryMb", {
                            get: $util.oneOfGetter($oneOfFields = ["memoryMb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceConsumptionInfo _minNodeCpus.
                         * @member {"minNodeCpus"|undefined} _minNodeCpus
                         * @memberof google.cloud.compute.v1.InstanceConsumptionInfo
                         * @instance
                         */
                        Object.defineProperty(InstanceConsumptionInfo.prototype, "_minNodeCpus", {
                            get: $util.oneOfGetter($oneOfFields = ["minNodeCpus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceConsumptionInfo instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceConsumptionInfo
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceConsumptionInfo=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceConsumptionInfo} InstanceConsumptionInfo instance
                         */
                        InstanceConsumptionInfo.create = function create(properties) {
                            return new InstanceConsumptionInfo(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceConsumptionInfo message. Does not implicitly {@link google.cloud.compute.v1.InstanceConsumptionInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceConsumptionInfo
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceConsumptionInfo} message InstanceConsumptionInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceConsumptionInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.memoryMb != null && Object.hasOwnProperty.call(message, "memoryMb"))
                                writer.uint32(/* id 116001171, wireType 0 =*/928009368).int32(message.memoryMb);
                            if (message.minNodeCpus != null && Object.hasOwnProperty.call(message, "minNodeCpus"))
                                writer.uint32(/* id 317231675, wireType 0 =*/2537853400).int32(message.minNodeCpus);
                            if (message.localSsdGb != null && Object.hasOwnProperty.call(message, "localSsdGb"))
                                writer.uint32(/* id 329237578, wireType 0 =*/2633900624).int32(message.localSsdGb);
                            if (message.guestCpus != null && Object.hasOwnProperty.call(message, "guestCpus"))
                                writer.uint32(/* id 393356754, wireType 0 =*/3146854032).int32(message.guestCpus);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceConsumptionInfo message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceConsumptionInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceConsumptionInfo
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceConsumptionInfo} message InstanceConsumptionInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceConsumptionInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceConsumptionInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceConsumptionInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceConsumptionInfo} InstanceConsumptionInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceConsumptionInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceConsumptionInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 393356754: {
                                        message.guestCpus = reader.int32();
                                        break;
                                    }
                                case 329237578: {
                                        message.localSsdGb = reader.int32();
                                        break;
                                    }
                                case 116001171: {
                                        message.memoryMb = reader.int32();
                                        break;
                                    }
                                case 317231675: {
                                        message.minNodeCpus = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceConsumptionInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceConsumptionInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceConsumptionInfo} InstanceConsumptionInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceConsumptionInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceConsumptionInfo message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceConsumptionInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceConsumptionInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.guestCpus != null && message.hasOwnProperty("guestCpus")) {
                                properties._guestCpus = 1;
                                if (!$util.isInteger(message.guestCpus))
                                    return "guestCpus: integer expected";
                            }
                            if (message.localSsdGb != null && message.hasOwnProperty("localSsdGb")) {
                                properties._localSsdGb = 1;
                                if (!$util.isInteger(message.localSsdGb))
                                    return "localSsdGb: integer expected";
                            }
                            if (message.memoryMb != null && message.hasOwnProperty("memoryMb")) {
                                properties._memoryMb = 1;
                                if (!$util.isInteger(message.memoryMb))
                                    return "memoryMb: integer expected";
                            }
                            if (message.minNodeCpus != null && message.hasOwnProperty("minNodeCpus")) {
                                properties._minNodeCpus = 1;
                                if (!$util.isInteger(message.minNodeCpus))
                                    return "minNodeCpus: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceConsumptionInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceConsumptionInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceConsumptionInfo} InstanceConsumptionInfo
                         */
                        InstanceConsumptionInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceConsumptionInfo)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceConsumptionInfo();
                            if (object.guestCpus != null)
                                message.guestCpus = object.guestCpus | 0;
                            if (object.localSsdGb != null)
                                message.localSsdGb = object.localSsdGb | 0;
                            if (object.memoryMb != null)
                                message.memoryMb = object.memoryMb | 0;
                            if (object.minNodeCpus != null)
                                message.minNodeCpus = object.minNodeCpus | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceConsumptionInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceConsumptionInfo
                         * @static
                         * @param {google.cloud.compute.v1.InstanceConsumptionInfo} message InstanceConsumptionInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceConsumptionInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.memoryMb != null && message.hasOwnProperty("memoryMb")) {
                                object.memoryMb = message.memoryMb;
                                if (options.oneofs)
                                    object._memoryMb = "memoryMb";
                            }
                            if (message.minNodeCpus != null && message.hasOwnProperty("minNodeCpus")) {
                                object.minNodeCpus = message.minNodeCpus;
                                if (options.oneofs)
                                    object._minNodeCpus = "minNodeCpus";
                            }
                            if (message.localSsdGb != null && message.hasOwnProperty("localSsdGb")) {
                                object.localSsdGb = message.localSsdGb;
                                if (options.oneofs)
                                    object._localSsdGb = "localSsdGb";
                            }
                            if (message.guestCpus != null && message.hasOwnProperty("guestCpus")) {
                                object.guestCpus = message.guestCpus;
                                if (options.oneofs)
                                    object._guestCpus = "guestCpus";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceConsumptionInfo to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceConsumptionInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceConsumptionInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceConsumptionInfo
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceConsumptionInfo
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceConsumptionInfo.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceConsumptionInfo";
                        };
    
                        return InstanceConsumptionInfo;
                    })();
    
                    v1.InstanceGroup = (function() {
    
                        /**
                         * Properties of an InstanceGroup.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroup
                         * @property {string|null} [creationTimestamp] InstanceGroup creationTimestamp
                         * @property {string|null} [description] InstanceGroup description
                         * @property {string|null} [fingerprint] InstanceGroup fingerprint
                         * @property {number|Long|null} [id] InstanceGroup id
                         * @property {string|null} [kind] InstanceGroup kind
                         * @property {string|null} [name] InstanceGroup name
                         * @property {Array.<google.cloud.compute.v1.INamedPort>|null} [namedPorts] InstanceGroup namedPorts
                         * @property {string|null} [network] InstanceGroup network
                         * @property {string|null} [region] InstanceGroup region
                         * @property {string|null} [selfLink] InstanceGroup selfLink
                         * @property {number|null} [size] InstanceGroup size
                         * @property {string|null} [subnetwork] InstanceGroup subnetwork
                         * @property {string|null} [zone] InstanceGroup zone
                         */
    
                        /**
                         * Constructs a new InstanceGroup.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroup.
                         * @implements IInstanceGroup
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroup=} [properties] Properties to set
                         */
                        function InstanceGroup(properties) {
                            this.namedPorts = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroup creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        InstanceGroup.prototype.creationTimestamp = null;
    
                        /**
                         * InstanceGroup description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        InstanceGroup.prototype.description = null;
    
                        /**
                         * InstanceGroup fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        InstanceGroup.prototype.fingerprint = null;
    
                        /**
                         * InstanceGroup id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        InstanceGroup.prototype.id = null;
    
                        /**
                         * InstanceGroup kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        InstanceGroup.prototype.kind = null;
    
                        /**
                         * InstanceGroup name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        InstanceGroup.prototype.name = null;
    
                        /**
                         * InstanceGroup namedPorts.
                         * @member {Array.<google.cloud.compute.v1.INamedPort>} namedPorts
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        InstanceGroup.prototype.namedPorts = $util.emptyArray;
    
                        /**
                         * InstanceGroup network.
                         * @member {string|null|undefined} network
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        InstanceGroup.prototype.network = null;
    
                        /**
                         * InstanceGroup region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        InstanceGroup.prototype.region = null;
    
                        /**
                         * InstanceGroup selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        InstanceGroup.prototype.selfLink = null;
    
                        /**
                         * InstanceGroup size.
                         * @member {number|null|undefined} size
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        InstanceGroup.prototype.size = null;
    
                        /**
                         * InstanceGroup subnetwork.
                         * @member {string|null|undefined} subnetwork
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        InstanceGroup.prototype.subnetwork = null;
    
                        /**
                         * InstanceGroup zone.
                         * @member {string|null|undefined} zone
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        InstanceGroup.prototype.zone = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroup _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        Object.defineProperty(InstanceGroup.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroup _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        Object.defineProperty(InstanceGroup.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroup _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        Object.defineProperty(InstanceGroup.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroup _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        Object.defineProperty(InstanceGroup.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroup _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        Object.defineProperty(InstanceGroup.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroup _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        Object.defineProperty(InstanceGroup.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroup _network.
                         * @member {"network"|undefined} _network
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        Object.defineProperty(InstanceGroup.prototype, "_network", {
                            get: $util.oneOfGetter($oneOfFields = ["network"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroup _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        Object.defineProperty(InstanceGroup.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroup _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        Object.defineProperty(InstanceGroup.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroup _size.
                         * @member {"size"|undefined} _size
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        Object.defineProperty(InstanceGroup.prototype, "_size", {
                            get: $util.oneOfGetter($oneOfFields = ["size"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroup _subnetwork.
                         * @member {"subnetwork"|undefined} _subnetwork
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        Object.defineProperty(InstanceGroup.prototype, "_subnetwork", {
                            get: $util.oneOfGetter($oneOfFields = ["subnetwork"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroup _zone.
                         * @member {"zone"|undefined} _zone
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         */
                        Object.defineProperty(InstanceGroup.prototype, "_zone", {
                            get: $util.oneOfGetter($oneOfFields = ["zone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroup instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroup=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroup} InstanceGroup instance
                         */
                        InstanceGroup.create = function create(properties) {
                            return new InstanceGroup(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroup message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroup.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroup} message InstanceGroup message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroup.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.size != null && Object.hasOwnProperty.call(message, "size"))
                                writer.uint32(/* id 3530753, wireType 0 =*/28246024).int32(message.size);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.subnetwork != null && Object.hasOwnProperty.call(message, "subnetwork"))
                                writer.uint32(/* id 307827694, wireType 2 =*/2462621554).string(message.subnetwork);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.namedPorts != null && message.namedPorts.length)
                                for (var i = 0; i < message.namedPorts.length; ++i)
                                    $root.google.cloud.compute.v1.NamedPort.encode(message.namedPorts[i], writer.uint32(/* id 427598732, wireType 2 =*/3420789858).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroup message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroup.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroup} message InstanceGroup message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroup.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroup message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroup} InstanceGroup
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroup.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroup();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 427598732: {
                                        if (!(message.namedPorts && message.namedPorts.length))
                                            message.namedPorts = [];
                                        message.namedPorts.push($root.google.cloud.compute.v1.NamedPort.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 3530753: {
                                        message.size = reader.int32();
                                        break;
                                    }
                                case 307827694: {
                                        message.subnetwork = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroup message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroup} InstanceGroup
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroup.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroup message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroup.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.namedPorts != null && message.hasOwnProperty("namedPorts")) {
                                if (!Array.isArray(message.namedPorts))
                                    return "namedPorts: array expected";
                                for (var i = 0; i < message.namedPorts.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NamedPort.verify(message.namedPorts[i]);
                                    if (error)
                                        return "namedPorts." + error;
                                }
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                properties._network = 1;
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.size != null && message.hasOwnProperty("size")) {
                                properties._size = 1;
                                if (!$util.isInteger(message.size))
                                    return "size: integer expected";
                            }
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork")) {
                                properties._subnetwork = 1;
                                if (!$util.isString(message.subnetwork))
                                    return "subnetwork: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                properties._zone = 1;
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroup message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroup} InstanceGroup
                         */
                        InstanceGroup.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroup)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroup();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.namedPorts) {
                                if (!Array.isArray(object.namedPorts))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroup.namedPorts: array expected");
                                message.namedPorts = [];
                                for (var i = 0; i < object.namedPorts.length; ++i) {
                                    if (typeof object.namedPorts[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceGroup.namedPorts: object expected");
                                    message.namedPorts[i] = $root.google.cloud.compute.v1.NamedPort.fromObject(object.namedPorts[i]);
                                }
                            }
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.size != null)
                                message.size = object.size | 0;
                            if (object.subnetwork != null)
                                message.subnetwork = String(object.subnetwork);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroup message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroup} message InstanceGroup
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroup.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.namedPorts = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.size != null && message.hasOwnProperty("size")) {
                                object.size = message.size;
                                if (options.oneofs)
                                    object._size = "size";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                object.zone = message.zone;
                                if (options.oneofs)
                                    object._zone = "zone";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                object.network = message.network;
                                if (options.oneofs)
                                    object._network = "network";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork")) {
                                object.subnetwork = message.subnetwork;
                                if (options.oneofs)
                                    object._subnetwork = "subnetwork";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.namedPorts && message.namedPorts.length) {
                                object.namedPorts = [];
                                for (var j = 0; j < message.namedPorts.length; ++j)
                                    object.namedPorts[j] = $root.google.cloud.compute.v1.NamedPort.toObject(message.namedPorts[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroup to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroup.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroup
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroup
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroup.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroup";
                        };
    
                        return InstanceGroup;
                    })();
    
                    v1.InstanceGroupAggregatedList = (function() {
    
                        /**
                         * Properties of an InstanceGroupAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupAggregatedList
                         * @property {string|null} [id] InstanceGroupAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IInstanceGroupsScopedList>|null} [items] InstanceGroupAggregatedList items
                         * @property {string|null} [kind] InstanceGroupAggregatedList kind
                         * @property {string|null} [nextPageToken] InstanceGroupAggregatedList nextPageToken
                         * @property {string|null} [selfLink] InstanceGroupAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] InstanceGroupAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] InstanceGroupAggregatedList warning
                         */
    
                        /**
                         * Constructs a new InstanceGroupAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupAggregatedList.
                         * @implements IInstanceGroupAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupAggregatedList=} [properties] Properties to set
                         */
                        function InstanceGroupAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @instance
                         */
                        InstanceGroupAggregatedList.prototype.id = null;
    
                        /**
                         * InstanceGroupAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IInstanceGroupsScopedList>} items
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @instance
                         */
                        InstanceGroupAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * InstanceGroupAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @instance
                         */
                        InstanceGroupAggregatedList.prototype.kind = null;
    
                        /**
                         * InstanceGroupAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @instance
                         */
                        InstanceGroupAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * InstanceGroupAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @instance
                         */
                        InstanceGroupAggregatedList.prototype.selfLink = null;
    
                        /**
                         * InstanceGroupAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @instance
                         */
                        InstanceGroupAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * InstanceGroupAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @instance
                         */
                        InstanceGroupAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupAggregatedList} InstanceGroupAggregatedList instance
                         */
                        InstanceGroupAggregatedList.create = function create(properties) {
                            return new InstanceGroupAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupAggregatedList} message InstanceGroupAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.InstanceGroupsScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupAggregatedList} message InstanceGroupAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupAggregatedList} InstanceGroupAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.InstanceGroupsScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupAggregatedList} InstanceGroupAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstanceGroupsScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupAggregatedList} InstanceGroupAggregatedList
                         */
                        InstanceGroupAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceGroupAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.InstanceGroupsScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupAggregatedList} message InstanceGroupAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.InstanceGroupsScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupAggregatedList";
                        };
    
                        return InstanceGroupAggregatedList;
                    })();
    
                    v1.InstanceGroupList = (function() {
    
                        /**
                         * Properties of an InstanceGroupList.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupList
                         * @property {string|null} [id] InstanceGroupList id
                         * @property {Array.<google.cloud.compute.v1.IInstanceGroup>|null} [items] InstanceGroupList items
                         * @property {string|null} [kind] InstanceGroupList kind
                         * @property {string|null} [nextPageToken] InstanceGroupList nextPageToken
                         * @property {string|null} [selfLink] InstanceGroupList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] InstanceGroupList warning
                         */
    
                        /**
                         * Constructs a new InstanceGroupList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupList.
                         * @implements IInstanceGroupList
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupList=} [properties] Properties to set
                         */
                        function InstanceGroupList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @instance
                         */
                        InstanceGroupList.prototype.id = null;
    
                        /**
                         * InstanceGroupList items.
                         * @member {Array.<google.cloud.compute.v1.IInstanceGroup>} items
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @instance
                         */
                        InstanceGroupList.prototype.items = $util.emptyArray;
    
                        /**
                         * InstanceGroupList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @instance
                         */
                        InstanceGroupList.prototype.kind = null;
    
                        /**
                         * InstanceGroupList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @instance
                         */
                        InstanceGroupList.prototype.nextPageToken = null;
    
                        /**
                         * InstanceGroupList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @instance
                         */
                        InstanceGroupList.prototype.selfLink = null;
    
                        /**
                         * InstanceGroupList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @instance
                         */
                        InstanceGroupList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupList} InstanceGroupList instance
                         */
                        InstanceGroupList.create = function create(properties) {
                            return new InstanceGroupList(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupList message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupList} message InstanceGroupList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.InstanceGroup.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupList} message InstanceGroupList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupList} InstanceGroupList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.InstanceGroup.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupList} InstanceGroupList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstanceGroup.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupList} InstanceGroupList
                         */
                        InstanceGroupList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceGroupList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.InstanceGroup.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupList} message InstanceGroupList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.InstanceGroup.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupList";
                        };
    
                        return InstanceGroupList;
                    })();
    
                    v1.InstanceGroupManager = (function() {
    
                        /**
                         * Properties of an InstanceGroupManager.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManager
                         * @property {Array.<google.cloud.compute.v1.IInstanceGroupManagerAutoHealingPolicy>|null} [autoHealingPolicies] InstanceGroupManager autoHealingPolicies
                         * @property {string|null} [baseInstanceName] InstanceGroupManager baseInstanceName
                         * @property {string|null} [creationTimestamp] InstanceGroupManager creationTimestamp
                         * @property {google.cloud.compute.v1.IInstanceGroupManagerActionsSummary|null} [currentActions] InstanceGroupManager currentActions
                         * @property {string|null} [description] InstanceGroupManager description
                         * @property {google.cloud.compute.v1.IDistributionPolicy|null} [distributionPolicy] InstanceGroupManager distributionPolicy
                         * @property {string|null} [fingerprint] InstanceGroupManager fingerprint
                         * @property {number|Long|null} [id] InstanceGroupManager id
                         * @property {string|null} [instanceGroup] InstanceGroupManager instanceGroup
                         * @property {string|null} [instanceTemplate] InstanceGroupManager instanceTemplate
                         * @property {string|null} [kind] InstanceGroupManager kind
                         * @property {string|null} [listManagedInstancesResults] InstanceGroupManager listManagedInstancesResults
                         * @property {string|null} [name] InstanceGroupManager name
                         * @property {Array.<google.cloud.compute.v1.INamedPort>|null} [namedPorts] InstanceGroupManager namedPorts
                         * @property {string|null} [region] InstanceGroupManager region
                         * @property {string|null} [selfLink] InstanceGroupManager selfLink
                         * @property {google.cloud.compute.v1.IStatefulPolicy|null} [statefulPolicy] InstanceGroupManager statefulPolicy
                         * @property {google.cloud.compute.v1.IInstanceGroupManagerStatus|null} [status] InstanceGroupManager status
                         * @property {Array.<string>|null} [targetPools] InstanceGroupManager targetPools
                         * @property {number|null} [targetSize] InstanceGroupManager targetSize
                         * @property {google.cloud.compute.v1.IInstanceGroupManagerUpdatePolicy|null} [updatePolicy] InstanceGroupManager updatePolicy
                         * @property {Array.<google.cloud.compute.v1.IInstanceGroupManagerVersion>|null} [versions] InstanceGroupManager versions
                         * @property {string|null} [zone] InstanceGroupManager zone
                         */
    
                        /**
                         * Constructs a new InstanceGroupManager.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManager.
                         * @implements IInstanceGroupManager
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManager=} [properties] Properties to set
                         */
                        function InstanceGroupManager(properties) {
                            this.autoHealingPolicies = [];
                            this.namedPorts = [];
                            this.targetPools = [];
                            this.versions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManager autoHealingPolicies.
                         * @member {Array.<google.cloud.compute.v1.IInstanceGroupManagerAutoHealingPolicy>} autoHealingPolicies
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.autoHealingPolicies = $util.emptyArray;
    
                        /**
                         * InstanceGroupManager baseInstanceName.
                         * @member {string|null|undefined} baseInstanceName
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.baseInstanceName = null;
    
                        /**
                         * InstanceGroupManager creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.creationTimestamp = null;
    
                        /**
                         * InstanceGroupManager currentActions.
                         * @member {google.cloud.compute.v1.IInstanceGroupManagerActionsSummary|null|undefined} currentActions
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.currentActions = null;
    
                        /**
                         * InstanceGroupManager description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.description = null;
    
                        /**
                         * InstanceGroupManager distributionPolicy.
                         * @member {google.cloud.compute.v1.IDistributionPolicy|null|undefined} distributionPolicy
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.distributionPolicy = null;
    
                        /**
                         * InstanceGroupManager fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.fingerprint = null;
    
                        /**
                         * InstanceGroupManager id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.id = null;
    
                        /**
                         * InstanceGroupManager instanceGroup.
                         * @member {string|null|undefined} instanceGroup
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.instanceGroup = null;
    
                        /**
                         * InstanceGroupManager instanceTemplate.
                         * @member {string|null|undefined} instanceTemplate
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.instanceTemplate = null;
    
                        /**
                         * InstanceGroupManager kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.kind = null;
    
                        /**
                         * InstanceGroupManager listManagedInstancesResults.
                         * @member {string|null|undefined} listManagedInstancesResults
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.listManagedInstancesResults = null;
    
                        /**
                         * InstanceGroupManager name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.name = null;
    
                        /**
                         * InstanceGroupManager namedPorts.
                         * @member {Array.<google.cloud.compute.v1.INamedPort>} namedPorts
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.namedPorts = $util.emptyArray;
    
                        /**
                         * InstanceGroupManager region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.region = null;
    
                        /**
                         * InstanceGroupManager selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.selfLink = null;
    
                        /**
                         * InstanceGroupManager statefulPolicy.
                         * @member {google.cloud.compute.v1.IStatefulPolicy|null|undefined} statefulPolicy
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.statefulPolicy = null;
    
                        /**
                         * InstanceGroupManager status.
                         * @member {google.cloud.compute.v1.IInstanceGroupManagerStatus|null|undefined} status
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.status = null;
    
                        /**
                         * InstanceGroupManager targetPools.
                         * @member {Array.<string>} targetPools
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.targetPools = $util.emptyArray;
    
                        /**
                         * InstanceGroupManager targetSize.
                         * @member {number|null|undefined} targetSize
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.targetSize = null;
    
                        /**
                         * InstanceGroupManager updatePolicy.
                         * @member {google.cloud.compute.v1.IInstanceGroupManagerUpdatePolicy|null|undefined} updatePolicy
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.updatePolicy = null;
    
                        /**
                         * InstanceGroupManager versions.
                         * @member {Array.<google.cloud.compute.v1.IInstanceGroupManagerVersion>} versions
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.versions = $util.emptyArray;
    
                        /**
                         * InstanceGroupManager zone.
                         * @member {string|null|undefined} zone
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        InstanceGroupManager.prototype.zone = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupManager _baseInstanceName.
                         * @member {"baseInstanceName"|undefined} _baseInstanceName
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManager.prototype, "_baseInstanceName", {
                            get: $util.oneOfGetter($oneOfFields = ["baseInstanceName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManager _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManager.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManager _currentActions.
                         * @member {"currentActions"|undefined} _currentActions
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManager.prototype, "_currentActions", {
                            get: $util.oneOfGetter($oneOfFields = ["currentActions"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManager _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManager.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManager _distributionPolicy.
                         * @member {"distributionPolicy"|undefined} _distributionPolicy
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManager.prototype, "_distributionPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["distributionPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManager _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManager.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManager _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManager.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManager _instanceGroup.
                         * @member {"instanceGroup"|undefined} _instanceGroup
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManager.prototype, "_instanceGroup", {
                            get: $util.oneOfGetter($oneOfFields = ["instanceGroup"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManager _instanceTemplate.
                         * @member {"instanceTemplate"|undefined} _instanceTemplate
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManager.prototype, "_instanceTemplate", {
                            get: $util.oneOfGetter($oneOfFields = ["instanceTemplate"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManager _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManager.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManager _listManagedInstancesResults.
                         * @member {"listManagedInstancesResults"|undefined} _listManagedInstancesResults
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManager.prototype, "_listManagedInstancesResults", {
                            get: $util.oneOfGetter($oneOfFields = ["listManagedInstancesResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManager _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManager.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManager _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManager.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManager _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManager.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManager _statefulPolicy.
                         * @member {"statefulPolicy"|undefined} _statefulPolicy
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManager.prototype, "_statefulPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["statefulPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManager _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManager.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManager _targetSize.
                         * @member {"targetSize"|undefined} _targetSize
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManager.prototype, "_targetSize", {
                            get: $util.oneOfGetter($oneOfFields = ["targetSize"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManager _updatePolicy.
                         * @member {"updatePolicy"|undefined} _updatePolicy
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManager.prototype, "_updatePolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["updatePolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManager _zone.
                         * @member {"zone"|undefined} _zone
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManager.prototype, "_zone", {
                            get: $util.oneOfGetter($oneOfFields = ["zone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupManager instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManager=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManager} InstanceGroupManager instance
                         */
                        InstanceGroupManager.create = function create(properties) {
                            return new InstanceGroupManager(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManager message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManager.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManager} message InstanceGroupManager message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManager.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.statefulPolicy != null && Object.hasOwnProperty.call(message, "statefulPolicy"))
                                $root.google.cloud.compute.v1.StatefulPolicy.encode(message.statefulPolicy, writer.uint32(/* id 47538565, wireType 2 =*/380308522).fork()).ldelim();
                            if (message.targetSize != null && Object.hasOwnProperty.call(message, "targetSize"))
                                writer.uint32(/* id 62880239, wireType 0 =*/503041912).int32(message.targetSize);
                            if (message.instanceGroup != null && Object.hasOwnProperty.call(message, "instanceGroup"))
                                writer.uint32(/* id 81095253, wireType 2 =*/648762026).string(message.instanceGroup);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.versions != null && message.versions.length)
                                for (var i = 0; i < message.versions.length; ++i)
                                    $root.google.cloud.compute.v1.InstanceGroupManagerVersion.encode(message.versions[i], writer.uint32(/* id 162430619, wireType 2 =*/1299444954).fork()).ldelim();
                            if (message.currentActions != null && Object.hasOwnProperty.call(message, "currentActions"))
                                $root.google.cloud.compute.v1.InstanceGroupManagerActionsSummary.encode(message.currentActions, writer.uint32(/* id 164045879, wireType 2 =*/1312367034).fork()).ldelim();
                            if (message.updatePolicy != null && Object.hasOwnProperty.call(message, "updatePolicy"))
                                $root.google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy.encode(message.updatePolicy, writer.uint32(/* id 175809896, wireType 2 =*/1406479170).fork()).ldelim();
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                $root.google.cloud.compute.v1.InstanceGroupManagerStatus.encode(message.status, writer.uint32(/* id 181260274, wireType 2 =*/1450082194).fork()).ldelim();
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.listManagedInstancesResults != null && Object.hasOwnProperty.call(message, "listManagedInstancesResults"))
                                writer.uint32(/* id 296047156, wireType 2 =*/2368377250).string(message.listManagedInstancesResults);
                            if (message.instanceTemplate != null && Object.hasOwnProperty.call(message, "instanceTemplate"))
                                writer.uint32(/* id 309248228, wireType 2 =*/2473985826).string(message.instanceTemplate);
                            if (message.targetPools != null && message.targetPools.length)
                                for (var i = 0; i < message.targetPools.length; ++i)
                                    writer.uint32(/* id 336072617, wireType 2 =*/2688580938).string(message.targetPools[i]);
                            if (message.baseInstanceName != null && Object.hasOwnProperty.call(message, "baseInstanceName"))
                                writer.uint32(/* id 389106439, wireType 2 =*/3112851514).string(message.baseInstanceName);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.namedPorts != null && message.namedPorts.length)
                                for (var i = 0; i < message.namedPorts.length; ++i)
                                    $root.google.cloud.compute.v1.NamedPort.encode(message.namedPorts[i], writer.uint32(/* id 427598732, wireType 2 =*/3420789858).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.autoHealingPolicies != null && message.autoHealingPolicies.length)
                                for (var i = 0; i < message.autoHealingPolicies.length; ++i)
                                    $root.google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy.encode(message.autoHealingPolicies[i], writer.uint32(/* id 456799109, wireType 2 =*/3654392874).fork()).ldelim();
                            if (message.distributionPolicy != null && Object.hasOwnProperty.call(message, "distributionPolicy"))
                                $root.google.cloud.compute.v1.DistributionPolicy.encode(message.distributionPolicy, writer.uint32(/* id 534558541, wireType 2 =*/4276468330).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManager message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManager.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManager} message InstanceGroupManager message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManager.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManager message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManager} InstanceGroupManager
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManager.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManager();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 456799109: {
                                        if (!(message.autoHealingPolicies && message.autoHealingPolicies.length))
                                            message.autoHealingPolicies = [];
                                        message.autoHealingPolicies.push($root.google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 389106439: {
                                        message.baseInstanceName = reader.string();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 164045879: {
                                        message.currentActions = $root.google.cloud.compute.v1.InstanceGroupManagerActionsSummary.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 534558541: {
                                        message.distributionPolicy = $root.google.cloud.compute.v1.DistributionPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 81095253: {
                                        message.instanceGroup = reader.string();
                                        break;
                                    }
                                case 309248228: {
                                        message.instanceTemplate = reader.string();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 296047156: {
                                        message.listManagedInstancesResults = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 427598732: {
                                        if (!(message.namedPorts && message.namedPorts.length))
                                            message.namedPorts = [];
                                        message.namedPorts.push($root.google.cloud.compute.v1.NamedPort.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 47538565: {
                                        message.statefulPolicy = $root.google.cloud.compute.v1.StatefulPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 181260274: {
                                        message.status = $root.google.cloud.compute.v1.InstanceGroupManagerStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 336072617: {
                                        if (!(message.targetPools && message.targetPools.length))
                                            message.targetPools = [];
                                        message.targetPools.push(reader.string());
                                        break;
                                    }
                                case 62880239: {
                                        message.targetSize = reader.int32();
                                        break;
                                    }
                                case 175809896: {
                                        message.updatePolicy = $root.google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 162430619: {
                                        if (!(message.versions && message.versions.length))
                                            message.versions = [];
                                        message.versions.push($root.google.cloud.compute.v1.InstanceGroupManagerVersion.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManager message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManager} InstanceGroupManager
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManager.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManager message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManager.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoHealingPolicies != null && message.hasOwnProperty("autoHealingPolicies")) {
                                if (!Array.isArray(message.autoHealingPolicies))
                                    return "autoHealingPolicies: array expected";
                                for (var i = 0; i < message.autoHealingPolicies.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy.verify(message.autoHealingPolicies[i]);
                                    if (error)
                                        return "autoHealingPolicies." + error;
                                }
                            }
                            if (message.baseInstanceName != null && message.hasOwnProperty("baseInstanceName")) {
                                properties._baseInstanceName = 1;
                                if (!$util.isString(message.baseInstanceName))
                                    return "baseInstanceName: string expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.currentActions != null && message.hasOwnProperty("currentActions")) {
                                properties._currentActions = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InstanceGroupManagerActionsSummary.verify(message.currentActions);
                                    if (error)
                                        return "currentActions." + error;
                                }
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.distributionPolicy != null && message.hasOwnProperty("distributionPolicy")) {
                                properties._distributionPolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.DistributionPolicy.verify(message.distributionPolicy);
                                    if (error)
                                        return "distributionPolicy." + error;
                                }
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.instanceGroup != null && message.hasOwnProperty("instanceGroup")) {
                                properties._instanceGroup = 1;
                                if (!$util.isString(message.instanceGroup))
                                    return "instanceGroup: string expected";
                            }
                            if (message.instanceTemplate != null && message.hasOwnProperty("instanceTemplate")) {
                                properties._instanceTemplate = 1;
                                if (!$util.isString(message.instanceTemplate))
                                    return "instanceTemplate: string expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.listManagedInstancesResults != null && message.hasOwnProperty("listManagedInstancesResults")) {
                                properties._listManagedInstancesResults = 1;
                                if (!$util.isString(message.listManagedInstancesResults))
                                    return "listManagedInstancesResults: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.namedPorts != null && message.hasOwnProperty("namedPorts")) {
                                if (!Array.isArray(message.namedPorts))
                                    return "namedPorts: array expected";
                                for (var i = 0; i < message.namedPorts.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NamedPort.verify(message.namedPorts[i]);
                                    if (error)
                                        return "namedPorts." + error;
                                }
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.statefulPolicy != null && message.hasOwnProperty("statefulPolicy")) {
                                properties._statefulPolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.StatefulPolicy.verify(message.statefulPolicy);
                                    if (error)
                                        return "statefulPolicy." + error;
                                }
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InstanceGroupManagerStatus.verify(message.status);
                                    if (error)
                                        return "status." + error;
                                }
                            }
                            if (message.targetPools != null && message.hasOwnProperty("targetPools")) {
                                if (!Array.isArray(message.targetPools))
                                    return "targetPools: array expected";
                                for (var i = 0; i < message.targetPools.length; ++i)
                                    if (!$util.isString(message.targetPools[i]))
                                        return "targetPools: string[] expected";
                            }
                            if (message.targetSize != null && message.hasOwnProperty("targetSize")) {
                                properties._targetSize = 1;
                                if (!$util.isInteger(message.targetSize))
                                    return "targetSize: integer expected";
                            }
                            if (message.updatePolicy != null && message.hasOwnProperty("updatePolicy")) {
                                properties._updatePolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy.verify(message.updatePolicy);
                                    if (error)
                                        return "updatePolicy." + error;
                                }
                            }
                            if (message.versions != null && message.hasOwnProperty("versions")) {
                                if (!Array.isArray(message.versions))
                                    return "versions: array expected";
                                for (var i = 0; i < message.versions.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstanceGroupManagerVersion.verify(message.versions[i]);
                                    if (error)
                                        return "versions." + error;
                                }
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                properties._zone = 1;
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManager message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManager} InstanceGroupManager
                         */
                        InstanceGroupManager.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManager)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManager();
                            if (object.autoHealingPolicies) {
                                if (!Array.isArray(object.autoHealingPolicies))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManager.autoHealingPolicies: array expected");
                                message.autoHealingPolicies = [];
                                for (var i = 0; i < object.autoHealingPolicies.length; ++i) {
                                    if (typeof object.autoHealingPolicies[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceGroupManager.autoHealingPolicies: object expected");
                                    message.autoHealingPolicies[i] = $root.google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy.fromObject(object.autoHealingPolicies[i]);
                                }
                            }
                            if (object.baseInstanceName != null)
                                message.baseInstanceName = String(object.baseInstanceName);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.currentActions != null) {
                                if (typeof object.currentActions !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManager.currentActions: object expected");
                                message.currentActions = $root.google.cloud.compute.v1.InstanceGroupManagerActionsSummary.fromObject(object.currentActions);
                            }
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.distributionPolicy != null) {
                                if (typeof object.distributionPolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManager.distributionPolicy: object expected");
                                message.distributionPolicy = $root.google.cloud.compute.v1.DistributionPolicy.fromObject(object.distributionPolicy);
                            }
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.instanceGroup != null)
                                message.instanceGroup = String(object.instanceGroup);
                            if (object.instanceTemplate != null)
                                message.instanceTemplate = String(object.instanceTemplate);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.listManagedInstancesResults != null)
                                message.listManagedInstancesResults = String(object.listManagedInstancesResults);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.namedPorts) {
                                if (!Array.isArray(object.namedPorts))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManager.namedPorts: array expected");
                                message.namedPorts = [];
                                for (var i = 0; i < object.namedPorts.length; ++i) {
                                    if (typeof object.namedPorts[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceGroupManager.namedPorts: object expected");
                                    message.namedPorts[i] = $root.google.cloud.compute.v1.NamedPort.fromObject(object.namedPorts[i]);
                                }
                            }
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.statefulPolicy != null) {
                                if (typeof object.statefulPolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManager.statefulPolicy: object expected");
                                message.statefulPolicy = $root.google.cloud.compute.v1.StatefulPolicy.fromObject(object.statefulPolicy);
                            }
                            if (object.status != null) {
                                if (typeof object.status !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManager.status: object expected");
                                message.status = $root.google.cloud.compute.v1.InstanceGroupManagerStatus.fromObject(object.status);
                            }
                            if (object.targetPools) {
                                if (!Array.isArray(object.targetPools))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManager.targetPools: array expected");
                                message.targetPools = [];
                                for (var i = 0; i < object.targetPools.length; ++i)
                                    message.targetPools[i] = String(object.targetPools[i]);
                            }
                            if (object.targetSize != null)
                                message.targetSize = object.targetSize | 0;
                            if (object.updatePolicy != null) {
                                if (typeof object.updatePolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManager.updatePolicy: object expected");
                                message.updatePolicy = $root.google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy.fromObject(object.updatePolicy);
                            }
                            if (object.versions) {
                                if (!Array.isArray(object.versions))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManager.versions: array expected");
                                message.versions = [];
                                for (var i = 0; i < object.versions.length; ++i) {
                                    if (typeof object.versions[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceGroupManager.versions: object expected");
                                    message.versions[i] = $root.google.cloud.compute.v1.InstanceGroupManagerVersion.fromObject(object.versions[i]);
                                }
                            }
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManager message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManager} message InstanceGroupManager
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManager.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.versions = [];
                                object.targetPools = [];
                                object.namedPorts = [];
                                object.autoHealingPolicies = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                object.zone = message.zone;
                                if (options.oneofs)
                                    object._zone = "zone";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.statefulPolicy != null && message.hasOwnProperty("statefulPolicy")) {
                                object.statefulPolicy = $root.google.cloud.compute.v1.StatefulPolicy.toObject(message.statefulPolicy, options);
                                if (options.oneofs)
                                    object._statefulPolicy = "statefulPolicy";
                            }
                            if (message.targetSize != null && message.hasOwnProperty("targetSize")) {
                                object.targetSize = message.targetSize;
                                if (options.oneofs)
                                    object._targetSize = "targetSize";
                            }
                            if (message.instanceGroup != null && message.hasOwnProperty("instanceGroup")) {
                                object.instanceGroup = message.instanceGroup;
                                if (options.oneofs)
                                    object._instanceGroup = "instanceGroup";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.versions && message.versions.length) {
                                object.versions = [];
                                for (var j = 0; j < message.versions.length; ++j)
                                    object.versions[j] = $root.google.cloud.compute.v1.InstanceGroupManagerVersion.toObject(message.versions[j], options);
                            }
                            if (message.currentActions != null && message.hasOwnProperty("currentActions")) {
                                object.currentActions = $root.google.cloud.compute.v1.InstanceGroupManagerActionsSummary.toObject(message.currentActions, options);
                                if (options.oneofs)
                                    object._currentActions = "currentActions";
                            }
                            if (message.updatePolicy != null && message.hasOwnProperty("updatePolicy")) {
                                object.updatePolicy = $root.google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy.toObject(message.updatePolicy, options);
                                if (options.oneofs)
                                    object._updatePolicy = "updatePolicy";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = $root.google.cloud.compute.v1.InstanceGroupManagerStatus.toObject(message.status, options);
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.listManagedInstancesResults != null && message.hasOwnProperty("listManagedInstancesResults")) {
                                object.listManagedInstancesResults = message.listManagedInstancesResults;
                                if (options.oneofs)
                                    object._listManagedInstancesResults = "listManagedInstancesResults";
                            }
                            if (message.instanceTemplate != null && message.hasOwnProperty("instanceTemplate")) {
                                object.instanceTemplate = message.instanceTemplate;
                                if (options.oneofs)
                                    object._instanceTemplate = "instanceTemplate";
                            }
                            if (message.targetPools && message.targetPools.length) {
                                object.targetPools = [];
                                for (var j = 0; j < message.targetPools.length; ++j)
                                    object.targetPools[j] = message.targetPools[j];
                            }
                            if (message.baseInstanceName != null && message.hasOwnProperty("baseInstanceName")) {
                                object.baseInstanceName = message.baseInstanceName;
                                if (options.oneofs)
                                    object._baseInstanceName = "baseInstanceName";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.namedPorts && message.namedPorts.length) {
                                object.namedPorts = [];
                                for (var j = 0; j < message.namedPorts.length; ++j)
                                    object.namedPorts[j] = $root.google.cloud.compute.v1.NamedPort.toObject(message.namedPorts[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.autoHealingPolicies && message.autoHealingPolicies.length) {
                                object.autoHealingPolicies = [];
                                for (var j = 0; j < message.autoHealingPolicies.length; ++j)
                                    object.autoHealingPolicies[j] = $root.google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy.toObject(message.autoHealingPolicies[j], options);
                            }
                            if (message.distributionPolicy != null && message.hasOwnProperty("distributionPolicy")) {
                                object.distributionPolicy = $root.google.cloud.compute.v1.DistributionPolicy.toObject(message.distributionPolicy, options);
                                if (options.oneofs)
                                    object._distributionPolicy = "distributionPolicy";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManager to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManager.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManager
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManager
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManager.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManager";
                        };
    
                        /**
                         * ListManagedInstancesResults enum.
                         * @name google.cloud.compute.v1.InstanceGroupManager.ListManagedInstancesResults
                         * @enum {number}
                         * @property {number} UNDEFINED_LIST_MANAGED_INSTANCES_RESULTS=0 UNDEFINED_LIST_MANAGED_INSTANCES_RESULTS value
                         * @property {number} PAGELESS=32183464 PAGELESS value
                         * @property {number} PAGINATED=40190637 PAGINATED value
                         */
                        InstanceGroupManager.ListManagedInstancesResults = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_LIST_MANAGED_INSTANCES_RESULTS"] = 0;
                            values[valuesById[32183464] = "PAGELESS"] = 32183464;
                            values[valuesById[40190637] = "PAGINATED"] = 40190637;
                            return values;
                        })();
    
                        return InstanceGroupManager;
                    })();
    
                    v1.InstanceGroupManagerActionsSummary = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagerActionsSummary.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagerActionsSummary
                         * @property {number|null} [abandoning] InstanceGroupManagerActionsSummary abandoning
                         * @property {number|null} [creating] InstanceGroupManagerActionsSummary creating
                         * @property {number|null} [creatingWithoutRetries] InstanceGroupManagerActionsSummary creatingWithoutRetries
                         * @property {number|null} [deleting] InstanceGroupManagerActionsSummary deleting
                         * @property {number|null} [none] InstanceGroupManagerActionsSummary none
                         * @property {number|null} [recreating] InstanceGroupManagerActionsSummary recreating
                         * @property {number|null} [refreshing] InstanceGroupManagerActionsSummary refreshing
                         * @property {number|null} [restarting] InstanceGroupManagerActionsSummary restarting
                         * @property {number|null} [resuming] InstanceGroupManagerActionsSummary resuming
                         * @property {number|null} [starting] InstanceGroupManagerActionsSummary starting
                         * @property {number|null} [stopping] InstanceGroupManagerActionsSummary stopping
                         * @property {number|null} [suspending] InstanceGroupManagerActionsSummary suspending
                         * @property {number|null} [verifying] InstanceGroupManagerActionsSummary verifying
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagerActionsSummary.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagerActionsSummary.
                         * @implements IInstanceGroupManagerActionsSummary
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerActionsSummary=} [properties] Properties to set
                         */
                        function InstanceGroupManagerActionsSummary(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagerActionsSummary abandoning.
                         * @member {number|null|undefined} abandoning
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        InstanceGroupManagerActionsSummary.prototype.abandoning = null;
    
                        /**
                         * InstanceGroupManagerActionsSummary creating.
                         * @member {number|null|undefined} creating
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        InstanceGroupManagerActionsSummary.prototype.creating = null;
    
                        /**
                         * InstanceGroupManagerActionsSummary creatingWithoutRetries.
                         * @member {number|null|undefined} creatingWithoutRetries
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        InstanceGroupManagerActionsSummary.prototype.creatingWithoutRetries = null;
    
                        /**
                         * InstanceGroupManagerActionsSummary deleting.
                         * @member {number|null|undefined} deleting
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        InstanceGroupManagerActionsSummary.prototype.deleting = null;
    
                        /**
                         * InstanceGroupManagerActionsSummary none.
                         * @member {number|null|undefined} none
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        InstanceGroupManagerActionsSummary.prototype.none = null;
    
                        /**
                         * InstanceGroupManagerActionsSummary recreating.
                         * @member {number|null|undefined} recreating
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        InstanceGroupManagerActionsSummary.prototype.recreating = null;
    
                        /**
                         * InstanceGroupManagerActionsSummary refreshing.
                         * @member {number|null|undefined} refreshing
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        InstanceGroupManagerActionsSummary.prototype.refreshing = null;
    
                        /**
                         * InstanceGroupManagerActionsSummary restarting.
                         * @member {number|null|undefined} restarting
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        InstanceGroupManagerActionsSummary.prototype.restarting = null;
    
                        /**
                         * InstanceGroupManagerActionsSummary resuming.
                         * @member {number|null|undefined} resuming
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        InstanceGroupManagerActionsSummary.prototype.resuming = null;
    
                        /**
                         * InstanceGroupManagerActionsSummary starting.
                         * @member {number|null|undefined} starting
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        InstanceGroupManagerActionsSummary.prototype.starting = null;
    
                        /**
                         * InstanceGroupManagerActionsSummary stopping.
                         * @member {number|null|undefined} stopping
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        InstanceGroupManagerActionsSummary.prototype.stopping = null;
    
                        /**
                         * InstanceGroupManagerActionsSummary suspending.
                         * @member {number|null|undefined} suspending
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        InstanceGroupManagerActionsSummary.prototype.suspending = null;
    
                        /**
                         * InstanceGroupManagerActionsSummary verifying.
                         * @member {number|null|undefined} verifying
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        InstanceGroupManagerActionsSummary.prototype.verifying = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupManagerActionsSummary _abandoning.
                         * @member {"abandoning"|undefined} _abandoning
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerActionsSummary.prototype, "_abandoning", {
                            get: $util.oneOfGetter($oneOfFields = ["abandoning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerActionsSummary _creating.
                         * @member {"creating"|undefined} _creating
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerActionsSummary.prototype, "_creating", {
                            get: $util.oneOfGetter($oneOfFields = ["creating"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerActionsSummary _creatingWithoutRetries.
                         * @member {"creatingWithoutRetries"|undefined} _creatingWithoutRetries
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerActionsSummary.prototype, "_creatingWithoutRetries", {
                            get: $util.oneOfGetter($oneOfFields = ["creatingWithoutRetries"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerActionsSummary _deleting.
                         * @member {"deleting"|undefined} _deleting
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerActionsSummary.prototype, "_deleting", {
                            get: $util.oneOfGetter($oneOfFields = ["deleting"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerActionsSummary _none.
                         * @member {"none"|undefined} _none
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerActionsSummary.prototype, "_none", {
                            get: $util.oneOfGetter($oneOfFields = ["none"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerActionsSummary _recreating.
                         * @member {"recreating"|undefined} _recreating
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerActionsSummary.prototype, "_recreating", {
                            get: $util.oneOfGetter($oneOfFields = ["recreating"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerActionsSummary _refreshing.
                         * @member {"refreshing"|undefined} _refreshing
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerActionsSummary.prototype, "_refreshing", {
                            get: $util.oneOfGetter($oneOfFields = ["refreshing"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerActionsSummary _restarting.
                         * @member {"restarting"|undefined} _restarting
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerActionsSummary.prototype, "_restarting", {
                            get: $util.oneOfGetter($oneOfFields = ["restarting"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerActionsSummary _resuming.
                         * @member {"resuming"|undefined} _resuming
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerActionsSummary.prototype, "_resuming", {
                            get: $util.oneOfGetter($oneOfFields = ["resuming"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerActionsSummary _starting.
                         * @member {"starting"|undefined} _starting
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerActionsSummary.prototype, "_starting", {
                            get: $util.oneOfGetter($oneOfFields = ["starting"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerActionsSummary _stopping.
                         * @member {"stopping"|undefined} _stopping
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerActionsSummary.prototype, "_stopping", {
                            get: $util.oneOfGetter($oneOfFields = ["stopping"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerActionsSummary _suspending.
                         * @member {"suspending"|undefined} _suspending
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerActionsSummary.prototype, "_suspending", {
                            get: $util.oneOfGetter($oneOfFields = ["suspending"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerActionsSummary _verifying.
                         * @member {"verifying"|undefined} _verifying
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerActionsSummary.prototype, "_verifying", {
                            get: $util.oneOfGetter($oneOfFields = ["verifying"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupManagerActionsSummary instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerActionsSummary=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerActionsSummary} InstanceGroupManagerActionsSummary instance
                         */
                        InstanceGroupManagerActionsSummary.create = function create(properties) {
                            return new InstanceGroupManagerActionsSummary(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagerActionsSummary message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagerActionsSummary.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerActionsSummary} message InstanceGroupManagerActionsSummary message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagerActionsSummary.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.none != null && Object.hasOwnProperty.call(message, "none"))
                                writer.uint32(/* id 3387192, wireType 0 =*/27097536).int32(message.none);
                            if (message.suspending != null && Object.hasOwnProperty.call(message, "suspending"))
                                writer.uint32(/* id 29113894, wireType 0 =*/232911152).int32(message.suspending);
                            if (message.stopping != null && Object.hasOwnProperty.call(message, "stopping"))
                                writer.uint32(/* id 105035892, wireType 0 =*/840287136).int32(message.stopping);
                            if (message.resuming != null && Object.hasOwnProperty.call(message, "resuming"))
                                writer.uint32(/* id 201100714, wireType 0 =*/1608805712).int32(message.resuming);
                            if (message.creating != null && Object.hasOwnProperty.call(message, "creating"))
                                writer.uint32(/* id 209809081, wireType 0 =*/1678472648).int32(message.creating);
                            if (message.refreshing != null && Object.hasOwnProperty.call(message, "refreshing"))
                                writer.uint32(/* id 215044903, wireType 0 =*/1720359224).int32(message.refreshing);
                            if (message.starting != null && Object.hasOwnProperty.call(message, "starting"))
                                writer.uint32(/* id 243064896, wireType 0 =*/1944519168).int32(message.starting);
                            if (message.deleting != null && Object.hasOwnProperty.call(message, "deleting"))
                                writer.uint32(/* id 282846120, wireType 0 =*/2262768960).int32(message.deleting);
                            if (message.recreating != null && Object.hasOwnProperty.call(message, "recreating"))
                                writer.uint32(/* id 339057132, wireType 0 =*/2712457056).int32(message.recreating);
                            if (message.creatingWithoutRetries != null && Object.hasOwnProperty.call(message, "creatingWithoutRetries"))
                                writer.uint32(/* id 369916745, wireType 0 =*/2959333960).int32(message.creatingWithoutRetries);
                            if (message.restarting != null && Object.hasOwnProperty.call(message, "restarting"))
                                writer.uint32(/* id 372312947, wireType 0 =*/2978503576).int32(message.restarting);
                            if (message.abandoning != null && Object.hasOwnProperty.call(message, "abandoning"))
                                writer.uint32(/* id 440023373, wireType 0 =*/3520186984).int32(message.abandoning);
                            if (message.verifying != null && Object.hasOwnProperty.call(message, "verifying"))
                                writer.uint32(/* id 451612873, wireType 0 =*/3612902984).int32(message.verifying);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagerActionsSummary message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagerActionsSummary.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerActionsSummary} message InstanceGroupManagerActionsSummary message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagerActionsSummary.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagerActionsSummary message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerActionsSummary} InstanceGroupManagerActionsSummary
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagerActionsSummary.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagerActionsSummary();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 440023373: {
                                        message.abandoning = reader.int32();
                                        break;
                                    }
                                case 209809081: {
                                        message.creating = reader.int32();
                                        break;
                                    }
                                case 369916745: {
                                        message.creatingWithoutRetries = reader.int32();
                                        break;
                                    }
                                case 282846120: {
                                        message.deleting = reader.int32();
                                        break;
                                    }
                                case 3387192: {
                                        message.none = reader.int32();
                                        break;
                                    }
                                case 339057132: {
                                        message.recreating = reader.int32();
                                        break;
                                    }
                                case 215044903: {
                                        message.refreshing = reader.int32();
                                        break;
                                    }
                                case 372312947: {
                                        message.restarting = reader.int32();
                                        break;
                                    }
                                case 201100714: {
                                        message.resuming = reader.int32();
                                        break;
                                    }
                                case 243064896: {
                                        message.starting = reader.int32();
                                        break;
                                    }
                                case 105035892: {
                                        message.stopping = reader.int32();
                                        break;
                                    }
                                case 29113894: {
                                        message.suspending = reader.int32();
                                        break;
                                    }
                                case 451612873: {
                                        message.verifying = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagerActionsSummary message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerActionsSummary} InstanceGroupManagerActionsSummary
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagerActionsSummary.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagerActionsSummary message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagerActionsSummary.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.abandoning != null && message.hasOwnProperty("abandoning")) {
                                properties._abandoning = 1;
                                if (!$util.isInteger(message.abandoning))
                                    return "abandoning: integer expected";
                            }
                            if (message.creating != null && message.hasOwnProperty("creating")) {
                                properties._creating = 1;
                                if (!$util.isInteger(message.creating))
                                    return "creating: integer expected";
                            }
                            if (message.creatingWithoutRetries != null && message.hasOwnProperty("creatingWithoutRetries")) {
                                properties._creatingWithoutRetries = 1;
                                if (!$util.isInteger(message.creatingWithoutRetries))
                                    return "creatingWithoutRetries: integer expected";
                            }
                            if (message.deleting != null && message.hasOwnProperty("deleting")) {
                                properties._deleting = 1;
                                if (!$util.isInteger(message.deleting))
                                    return "deleting: integer expected";
                            }
                            if (message.none != null && message.hasOwnProperty("none")) {
                                properties._none = 1;
                                if (!$util.isInteger(message.none))
                                    return "none: integer expected";
                            }
                            if (message.recreating != null && message.hasOwnProperty("recreating")) {
                                properties._recreating = 1;
                                if (!$util.isInteger(message.recreating))
                                    return "recreating: integer expected";
                            }
                            if (message.refreshing != null && message.hasOwnProperty("refreshing")) {
                                properties._refreshing = 1;
                                if (!$util.isInteger(message.refreshing))
                                    return "refreshing: integer expected";
                            }
                            if (message.restarting != null && message.hasOwnProperty("restarting")) {
                                properties._restarting = 1;
                                if (!$util.isInteger(message.restarting))
                                    return "restarting: integer expected";
                            }
                            if (message.resuming != null && message.hasOwnProperty("resuming")) {
                                properties._resuming = 1;
                                if (!$util.isInteger(message.resuming))
                                    return "resuming: integer expected";
                            }
                            if (message.starting != null && message.hasOwnProperty("starting")) {
                                properties._starting = 1;
                                if (!$util.isInteger(message.starting))
                                    return "starting: integer expected";
                            }
                            if (message.stopping != null && message.hasOwnProperty("stopping")) {
                                properties._stopping = 1;
                                if (!$util.isInteger(message.stopping))
                                    return "stopping: integer expected";
                            }
                            if (message.suspending != null && message.hasOwnProperty("suspending")) {
                                properties._suspending = 1;
                                if (!$util.isInteger(message.suspending))
                                    return "suspending: integer expected";
                            }
                            if (message.verifying != null && message.hasOwnProperty("verifying")) {
                                properties._verifying = 1;
                                if (!$util.isInteger(message.verifying))
                                    return "verifying: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagerActionsSummary message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerActionsSummary} InstanceGroupManagerActionsSummary
                         */
                        InstanceGroupManagerActionsSummary.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagerActionsSummary)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagerActionsSummary();
                            if (object.abandoning != null)
                                message.abandoning = object.abandoning | 0;
                            if (object.creating != null)
                                message.creating = object.creating | 0;
                            if (object.creatingWithoutRetries != null)
                                message.creatingWithoutRetries = object.creatingWithoutRetries | 0;
                            if (object.deleting != null)
                                message.deleting = object.deleting | 0;
                            if (object.none != null)
                                message.none = object.none | 0;
                            if (object.recreating != null)
                                message.recreating = object.recreating | 0;
                            if (object.refreshing != null)
                                message.refreshing = object.refreshing | 0;
                            if (object.restarting != null)
                                message.restarting = object.restarting | 0;
                            if (object.resuming != null)
                                message.resuming = object.resuming | 0;
                            if (object.starting != null)
                                message.starting = object.starting | 0;
                            if (object.stopping != null)
                                message.stopping = object.stopping | 0;
                            if (object.suspending != null)
                                message.suspending = object.suspending | 0;
                            if (object.verifying != null)
                                message.verifying = object.verifying | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagerActionsSummary message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagerActionsSummary} message InstanceGroupManagerActionsSummary
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagerActionsSummary.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.none != null && message.hasOwnProperty("none")) {
                                object.none = message.none;
                                if (options.oneofs)
                                    object._none = "none";
                            }
                            if (message.suspending != null && message.hasOwnProperty("suspending")) {
                                object.suspending = message.suspending;
                                if (options.oneofs)
                                    object._suspending = "suspending";
                            }
                            if (message.stopping != null && message.hasOwnProperty("stopping")) {
                                object.stopping = message.stopping;
                                if (options.oneofs)
                                    object._stopping = "stopping";
                            }
                            if (message.resuming != null && message.hasOwnProperty("resuming")) {
                                object.resuming = message.resuming;
                                if (options.oneofs)
                                    object._resuming = "resuming";
                            }
                            if (message.creating != null && message.hasOwnProperty("creating")) {
                                object.creating = message.creating;
                                if (options.oneofs)
                                    object._creating = "creating";
                            }
                            if (message.refreshing != null && message.hasOwnProperty("refreshing")) {
                                object.refreshing = message.refreshing;
                                if (options.oneofs)
                                    object._refreshing = "refreshing";
                            }
                            if (message.starting != null && message.hasOwnProperty("starting")) {
                                object.starting = message.starting;
                                if (options.oneofs)
                                    object._starting = "starting";
                            }
                            if (message.deleting != null && message.hasOwnProperty("deleting")) {
                                object.deleting = message.deleting;
                                if (options.oneofs)
                                    object._deleting = "deleting";
                            }
                            if (message.recreating != null && message.hasOwnProperty("recreating")) {
                                object.recreating = message.recreating;
                                if (options.oneofs)
                                    object._recreating = "recreating";
                            }
                            if (message.creatingWithoutRetries != null && message.hasOwnProperty("creatingWithoutRetries")) {
                                object.creatingWithoutRetries = message.creatingWithoutRetries;
                                if (options.oneofs)
                                    object._creatingWithoutRetries = "creatingWithoutRetries";
                            }
                            if (message.restarting != null && message.hasOwnProperty("restarting")) {
                                object.restarting = message.restarting;
                                if (options.oneofs)
                                    object._restarting = "restarting";
                            }
                            if (message.abandoning != null && message.hasOwnProperty("abandoning")) {
                                object.abandoning = message.abandoning;
                                if (options.oneofs)
                                    object._abandoning = "abandoning";
                            }
                            if (message.verifying != null && message.hasOwnProperty("verifying")) {
                                object.verifying = message.verifying;
                                if (options.oneofs)
                                    object._verifying = "verifying";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagerActionsSummary to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagerActionsSummary.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagerActionsSummary
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerActionsSummary
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagerActionsSummary.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagerActionsSummary";
                        };
    
                        return InstanceGroupManagerActionsSummary;
                    })();
    
                    v1.InstanceGroupManagerAggregatedList = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagerAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagerAggregatedList
                         * @property {string|null} [id] InstanceGroupManagerAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IInstanceGroupManagersScopedList>|null} [items] InstanceGroupManagerAggregatedList items
                         * @property {string|null} [kind] InstanceGroupManagerAggregatedList kind
                         * @property {string|null} [nextPageToken] InstanceGroupManagerAggregatedList nextPageToken
                         * @property {string|null} [selfLink] InstanceGroupManagerAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] InstanceGroupManagerAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] InstanceGroupManagerAggregatedList warning
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagerAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagerAggregatedList.
                         * @implements IInstanceGroupManagerAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerAggregatedList=} [properties] Properties to set
                         */
                        function InstanceGroupManagerAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagerAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @instance
                         */
                        InstanceGroupManagerAggregatedList.prototype.id = null;
    
                        /**
                         * InstanceGroupManagerAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IInstanceGroupManagersScopedList>} items
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @instance
                         */
                        InstanceGroupManagerAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * InstanceGroupManagerAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @instance
                         */
                        InstanceGroupManagerAggregatedList.prototype.kind = null;
    
                        /**
                         * InstanceGroupManagerAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @instance
                         */
                        InstanceGroupManagerAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * InstanceGroupManagerAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @instance
                         */
                        InstanceGroupManagerAggregatedList.prototype.selfLink = null;
    
                        /**
                         * InstanceGroupManagerAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @instance
                         */
                        InstanceGroupManagerAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * InstanceGroupManagerAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @instance
                         */
                        InstanceGroupManagerAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupManagerAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupManagerAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerAggregatedList} InstanceGroupManagerAggregatedList instance
                         */
                        InstanceGroupManagerAggregatedList.create = function create(properties) {
                            return new InstanceGroupManagerAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagerAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagerAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerAggregatedList} message InstanceGroupManagerAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagerAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.InstanceGroupManagersScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagerAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagerAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerAggregatedList} message InstanceGroupManagerAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagerAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagerAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerAggregatedList} InstanceGroupManagerAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagerAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagerAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.InstanceGroupManagersScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagerAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerAggregatedList} InstanceGroupManagerAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagerAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagerAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagerAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstanceGroupManagersScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagerAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerAggregatedList} InstanceGroupManagerAggregatedList
                         */
                        InstanceGroupManagerAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagerAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagerAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagerAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceGroupManagerAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.InstanceGroupManagersScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagerAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagerAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagerAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagerAggregatedList} message InstanceGroupManagerAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagerAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.InstanceGroupManagersScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagerAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagerAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagerAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagerAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagerAggregatedList";
                        };
    
                        return InstanceGroupManagerAggregatedList;
                    })();
    
                    v1.InstanceGroupManagerAutoHealingPolicy = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagerAutoHealingPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagerAutoHealingPolicy
                         * @property {string|null} [healthCheck] InstanceGroupManagerAutoHealingPolicy healthCheck
                         * @property {number|null} [initialDelaySec] InstanceGroupManagerAutoHealingPolicy initialDelaySec
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagerAutoHealingPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagerAutoHealingPolicy.
                         * @implements IInstanceGroupManagerAutoHealingPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerAutoHealingPolicy=} [properties] Properties to set
                         */
                        function InstanceGroupManagerAutoHealingPolicy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagerAutoHealingPolicy healthCheck.
                         * @member {string|null|undefined} healthCheck
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy
                         * @instance
                         */
                        InstanceGroupManagerAutoHealingPolicy.prototype.healthCheck = null;
    
                        /**
                         * InstanceGroupManagerAutoHealingPolicy initialDelaySec.
                         * @member {number|null|undefined} initialDelaySec
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy
                         * @instance
                         */
                        InstanceGroupManagerAutoHealingPolicy.prototype.initialDelaySec = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupManagerAutoHealingPolicy _healthCheck.
                         * @member {"healthCheck"|undefined} _healthCheck
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerAutoHealingPolicy.prototype, "_healthCheck", {
                            get: $util.oneOfGetter($oneOfFields = ["healthCheck"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerAutoHealingPolicy _initialDelaySec.
                         * @member {"initialDelaySec"|undefined} _initialDelaySec
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerAutoHealingPolicy.prototype, "_initialDelaySec", {
                            get: $util.oneOfGetter($oneOfFields = ["initialDelaySec"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupManagerAutoHealingPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerAutoHealingPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy} InstanceGroupManagerAutoHealingPolicy instance
                         */
                        InstanceGroupManagerAutoHealingPolicy.create = function create(properties) {
                            return new InstanceGroupManagerAutoHealingPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagerAutoHealingPolicy message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerAutoHealingPolicy} message InstanceGroupManagerAutoHealingPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagerAutoHealingPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.initialDelaySec != null && Object.hasOwnProperty.call(message, "initialDelaySec"))
                                writer.uint32(/* id 263207002, wireType 0 =*/2105656016).int32(message.initialDelaySec);
                            if (message.healthCheck != null && Object.hasOwnProperty.call(message, "healthCheck"))
                                writer.uint32(/* id 308876645, wireType 2 =*/2471013162).string(message.healthCheck);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagerAutoHealingPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerAutoHealingPolicy} message InstanceGroupManagerAutoHealingPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagerAutoHealingPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagerAutoHealingPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy} InstanceGroupManagerAutoHealingPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagerAutoHealingPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 308876645: {
                                        message.healthCheck = reader.string();
                                        break;
                                    }
                                case 263207002: {
                                        message.initialDelaySec = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagerAutoHealingPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy} InstanceGroupManagerAutoHealingPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagerAutoHealingPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagerAutoHealingPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagerAutoHealingPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck")) {
                                properties._healthCheck = 1;
                                if (!$util.isString(message.healthCheck))
                                    return "healthCheck: string expected";
                            }
                            if (message.initialDelaySec != null && message.hasOwnProperty("initialDelaySec")) {
                                properties._initialDelaySec = 1;
                                if (!$util.isInteger(message.initialDelaySec))
                                    return "initialDelaySec: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagerAutoHealingPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy} InstanceGroupManagerAutoHealingPolicy
                         */
                        InstanceGroupManagerAutoHealingPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy();
                            if (object.healthCheck != null)
                                message.healthCheck = String(object.healthCheck);
                            if (object.initialDelaySec != null)
                                message.initialDelaySec = object.initialDelaySec | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagerAutoHealingPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy} message InstanceGroupManagerAutoHealingPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagerAutoHealingPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.initialDelaySec != null && message.hasOwnProperty("initialDelaySec")) {
                                object.initialDelaySec = message.initialDelaySec;
                                if (options.oneofs)
                                    object._initialDelaySec = "initialDelaySec";
                            }
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck")) {
                                object.healthCheck = message.healthCheck;
                                if (options.oneofs)
                                    object._healthCheck = "healthCheck";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagerAutoHealingPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagerAutoHealingPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagerAutoHealingPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagerAutoHealingPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagerAutoHealingPolicy";
                        };
    
                        return InstanceGroupManagerAutoHealingPolicy;
                    })();
    
                    v1.InstanceGroupManagerList = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagerList.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagerList
                         * @property {string|null} [id] InstanceGroupManagerList id
                         * @property {Array.<google.cloud.compute.v1.IInstanceGroupManager>|null} [items] InstanceGroupManagerList items
                         * @property {string|null} [kind] InstanceGroupManagerList kind
                         * @property {string|null} [nextPageToken] InstanceGroupManagerList nextPageToken
                         * @property {string|null} [selfLink] InstanceGroupManagerList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] InstanceGroupManagerList warning
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagerList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagerList.
                         * @implements IInstanceGroupManagerList
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerList=} [properties] Properties to set
                         */
                        function InstanceGroupManagerList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagerList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @instance
                         */
                        InstanceGroupManagerList.prototype.id = null;
    
                        /**
                         * InstanceGroupManagerList items.
                         * @member {Array.<google.cloud.compute.v1.IInstanceGroupManager>} items
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @instance
                         */
                        InstanceGroupManagerList.prototype.items = $util.emptyArray;
    
                        /**
                         * InstanceGroupManagerList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @instance
                         */
                        InstanceGroupManagerList.prototype.kind = null;
    
                        /**
                         * InstanceGroupManagerList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @instance
                         */
                        InstanceGroupManagerList.prototype.nextPageToken = null;
    
                        /**
                         * InstanceGroupManagerList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @instance
                         */
                        InstanceGroupManagerList.prototype.selfLink = null;
    
                        /**
                         * InstanceGroupManagerList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @instance
                         */
                        InstanceGroupManagerList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupManagerList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupManagerList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerList} InstanceGroupManagerList instance
                         */
                        InstanceGroupManagerList.create = function create(properties) {
                            return new InstanceGroupManagerList(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagerList message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagerList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerList} message InstanceGroupManagerList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagerList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.InstanceGroupManager.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagerList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagerList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerList} message InstanceGroupManagerList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagerList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagerList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerList} InstanceGroupManagerList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagerList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagerList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.InstanceGroupManager.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagerList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerList} InstanceGroupManagerList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagerList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagerList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagerList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstanceGroupManager.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagerList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerList} InstanceGroupManagerList
                         */
                        InstanceGroupManagerList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagerList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagerList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagerList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceGroupManagerList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.InstanceGroupManager.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagerList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagerList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagerList} message InstanceGroupManagerList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagerList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.InstanceGroupManager.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagerList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagerList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagerList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagerList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagerList";
                        };
    
                        return InstanceGroupManagerList;
                    })();
    
                    v1.InstanceGroupManagerStatus = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagerStatus.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagerStatus
                         * @property {string|null} [autoscaler] InstanceGroupManagerStatus autoscaler
                         * @property {boolean|null} [isStable] InstanceGroupManagerStatus isStable
                         * @property {google.cloud.compute.v1.IInstanceGroupManagerStatusStateful|null} [stateful] InstanceGroupManagerStatus stateful
                         * @property {google.cloud.compute.v1.IInstanceGroupManagerStatusVersionTarget|null} [versionTarget] InstanceGroupManagerStatus versionTarget
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagerStatus.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagerStatus.
                         * @implements IInstanceGroupManagerStatus
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerStatus=} [properties] Properties to set
                         */
                        function InstanceGroupManagerStatus(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagerStatus autoscaler.
                         * @member {string|null|undefined} autoscaler
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatus
                         * @instance
                         */
                        InstanceGroupManagerStatus.prototype.autoscaler = null;
    
                        /**
                         * InstanceGroupManagerStatus isStable.
                         * @member {boolean|null|undefined} isStable
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatus
                         * @instance
                         */
                        InstanceGroupManagerStatus.prototype.isStable = null;
    
                        /**
                         * InstanceGroupManagerStatus stateful.
                         * @member {google.cloud.compute.v1.IInstanceGroupManagerStatusStateful|null|undefined} stateful
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatus
                         * @instance
                         */
                        InstanceGroupManagerStatus.prototype.stateful = null;
    
                        /**
                         * InstanceGroupManagerStatus versionTarget.
                         * @member {google.cloud.compute.v1.IInstanceGroupManagerStatusVersionTarget|null|undefined} versionTarget
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatus
                         * @instance
                         */
                        InstanceGroupManagerStatus.prototype.versionTarget = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupManagerStatus _autoscaler.
                         * @member {"autoscaler"|undefined} _autoscaler
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatus
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerStatus.prototype, "_autoscaler", {
                            get: $util.oneOfGetter($oneOfFields = ["autoscaler"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerStatus _isStable.
                         * @member {"isStable"|undefined} _isStable
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatus
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerStatus.prototype, "_isStable", {
                            get: $util.oneOfGetter($oneOfFields = ["isStable"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerStatus _stateful.
                         * @member {"stateful"|undefined} _stateful
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatus
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerStatus.prototype, "_stateful", {
                            get: $util.oneOfGetter($oneOfFields = ["stateful"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerStatus _versionTarget.
                         * @member {"versionTarget"|undefined} _versionTarget
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatus
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerStatus.prototype, "_versionTarget", {
                            get: $util.oneOfGetter($oneOfFields = ["versionTarget"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupManagerStatus instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatus
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerStatus=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerStatus} InstanceGroupManagerStatus instance
                         */
                        InstanceGroupManagerStatus.create = function create(properties) {
                            return new InstanceGroupManagerStatus(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagerStatus message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagerStatus.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatus
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerStatus} message InstanceGroupManagerStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagerStatus.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.isStable != null && Object.hasOwnProperty.call(message, "isStable"))
                                writer.uint32(/* id 108410864, wireType 0 =*/867286912).bool(message.isStable);
                            if (message.stateful != null && Object.hasOwnProperty.call(message, "stateful"))
                                $root.google.cloud.compute.v1.InstanceGroupManagerStatusStateful.encode(message.stateful, writer.uint32(/* id 244462412, wireType 2 =*/1955699298).fork()).ldelim();
                            if (message.versionTarget != null && Object.hasOwnProperty.call(message, "versionTarget"))
                                $root.google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget.encode(message.versionTarget, writer.uint32(/* id 289386200, wireType 2 =*/2315089602).fork()).ldelim();
                            if (message.autoscaler != null && Object.hasOwnProperty.call(message, "autoscaler"))
                                writer.uint32(/* id 517258967, wireType 2 =*/4138071738).string(message.autoscaler);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagerStatus message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagerStatus.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatus
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerStatus} message InstanceGroupManagerStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagerStatus.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagerStatus message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerStatus} InstanceGroupManagerStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagerStatus.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagerStatus();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 517258967: {
                                        message.autoscaler = reader.string();
                                        break;
                                    }
                                case 108410864: {
                                        message.isStable = reader.bool();
                                        break;
                                    }
                                case 244462412: {
                                        message.stateful = $root.google.cloud.compute.v1.InstanceGroupManagerStatusStateful.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 289386200: {
                                        message.versionTarget = $root.google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagerStatus message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerStatus} InstanceGroupManagerStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagerStatus.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagerStatus message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatus
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagerStatus.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoscaler != null && message.hasOwnProperty("autoscaler")) {
                                properties._autoscaler = 1;
                                if (!$util.isString(message.autoscaler))
                                    return "autoscaler: string expected";
                            }
                            if (message.isStable != null && message.hasOwnProperty("isStable")) {
                                properties._isStable = 1;
                                if (typeof message.isStable !== "boolean")
                                    return "isStable: boolean expected";
                            }
                            if (message.stateful != null && message.hasOwnProperty("stateful")) {
                                properties._stateful = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InstanceGroupManagerStatusStateful.verify(message.stateful);
                                    if (error)
                                        return "stateful." + error;
                                }
                            }
                            if (message.versionTarget != null && message.hasOwnProperty("versionTarget")) {
                                properties._versionTarget = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget.verify(message.versionTarget);
                                    if (error)
                                        return "versionTarget." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagerStatus message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatus
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerStatus} InstanceGroupManagerStatus
                         */
                        InstanceGroupManagerStatus.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagerStatus)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagerStatus();
                            if (object.autoscaler != null)
                                message.autoscaler = String(object.autoscaler);
                            if (object.isStable != null)
                                message.isStable = Boolean(object.isStable);
                            if (object.stateful != null) {
                                if (typeof object.stateful !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagerStatus.stateful: object expected");
                                message.stateful = $root.google.cloud.compute.v1.InstanceGroupManagerStatusStateful.fromObject(object.stateful);
                            }
                            if (object.versionTarget != null) {
                                if (typeof object.versionTarget !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagerStatus.versionTarget: object expected");
                                message.versionTarget = $root.google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget.fromObject(object.versionTarget);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagerStatus message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatus
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagerStatus} message InstanceGroupManagerStatus
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagerStatus.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.isStable != null && message.hasOwnProperty("isStable")) {
                                object.isStable = message.isStable;
                                if (options.oneofs)
                                    object._isStable = "isStable";
                            }
                            if (message.stateful != null && message.hasOwnProperty("stateful")) {
                                object.stateful = $root.google.cloud.compute.v1.InstanceGroupManagerStatusStateful.toObject(message.stateful, options);
                                if (options.oneofs)
                                    object._stateful = "stateful";
                            }
                            if (message.versionTarget != null && message.hasOwnProperty("versionTarget")) {
                                object.versionTarget = $root.google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget.toObject(message.versionTarget, options);
                                if (options.oneofs)
                                    object._versionTarget = "versionTarget";
                            }
                            if (message.autoscaler != null && message.hasOwnProperty("autoscaler")) {
                                object.autoscaler = message.autoscaler;
                                if (options.oneofs)
                                    object._autoscaler = "autoscaler";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagerStatus to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatus
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagerStatus.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagerStatus
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatus
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagerStatus.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagerStatus";
                        };
    
                        return InstanceGroupManagerStatus;
                    })();
    
                    v1.InstanceGroupManagerStatusStateful = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagerStatusStateful.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagerStatusStateful
                         * @property {boolean|null} [hasStatefulConfig] InstanceGroupManagerStatusStateful hasStatefulConfig
                         * @property {google.cloud.compute.v1.IInstanceGroupManagerStatusStatefulPerInstanceConfigs|null} [perInstanceConfigs] InstanceGroupManagerStatusStateful perInstanceConfigs
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagerStatusStateful.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagerStatusStateful.
                         * @implements IInstanceGroupManagerStatusStateful
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerStatusStateful=} [properties] Properties to set
                         */
                        function InstanceGroupManagerStatusStateful(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagerStatusStateful hasStatefulConfig.
                         * @member {boolean|null|undefined} hasStatefulConfig
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStateful
                         * @instance
                         */
                        InstanceGroupManagerStatusStateful.prototype.hasStatefulConfig = null;
    
                        /**
                         * InstanceGroupManagerStatusStateful perInstanceConfigs.
                         * @member {google.cloud.compute.v1.IInstanceGroupManagerStatusStatefulPerInstanceConfigs|null|undefined} perInstanceConfigs
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStateful
                         * @instance
                         */
                        InstanceGroupManagerStatusStateful.prototype.perInstanceConfigs = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupManagerStatusStateful _hasStatefulConfig.
                         * @member {"hasStatefulConfig"|undefined} _hasStatefulConfig
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStateful
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerStatusStateful.prototype, "_hasStatefulConfig", {
                            get: $util.oneOfGetter($oneOfFields = ["hasStatefulConfig"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerStatusStateful _perInstanceConfigs.
                         * @member {"perInstanceConfigs"|undefined} _perInstanceConfigs
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStateful
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerStatusStateful.prototype, "_perInstanceConfigs", {
                            get: $util.oneOfGetter($oneOfFields = ["perInstanceConfigs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupManagerStatusStateful instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStateful
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerStatusStateful=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerStatusStateful} InstanceGroupManagerStatusStateful instance
                         */
                        InstanceGroupManagerStatusStateful.create = function create(properties) {
                            return new InstanceGroupManagerStatusStateful(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagerStatusStateful message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagerStatusStateful.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStateful
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerStatusStateful} message InstanceGroupManagerStatusStateful message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagerStatusStateful.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.hasStatefulConfig != null && Object.hasOwnProperty.call(message, "hasStatefulConfig"))
                                writer.uint32(/* id 110474224, wireType 0 =*/883793792).bool(message.hasStatefulConfig);
                            if (message.perInstanceConfigs != null && Object.hasOwnProperty.call(message, "perInstanceConfigs"))
                                $root.google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs.encode(message.perInstanceConfigs, writer.uint32(/* id 526265001, wireType 2 =*/4210120010).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagerStatusStateful message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagerStatusStateful.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStateful
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerStatusStateful} message InstanceGroupManagerStatusStateful message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagerStatusStateful.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagerStatusStateful message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStateful
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerStatusStateful} InstanceGroupManagerStatusStateful
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagerStatusStateful.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagerStatusStateful();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 110474224: {
                                        message.hasStatefulConfig = reader.bool();
                                        break;
                                    }
                                case 526265001: {
                                        message.perInstanceConfigs = $root.google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagerStatusStateful message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStateful
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerStatusStateful} InstanceGroupManagerStatusStateful
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagerStatusStateful.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagerStatusStateful message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStateful
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagerStatusStateful.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.hasStatefulConfig != null && message.hasOwnProperty("hasStatefulConfig")) {
                                properties._hasStatefulConfig = 1;
                                if (typeof message.hasStatefulConfig !== "boolean")
                                    return "hasStatefulConfig: boolean expected";
                            }
                            if (message.perInstanceConfigs != null && message.hasOwnProperty("perInstanceConfigs")) {
                                properties._perInstanceConfigs = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs.verify(message.perInstanceConfigs);
                                    if (error)
                                        return "perInstanceConfigs." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagerStatusStateful message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStateful
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerStatusStateful} InstanceGroupManagerStatusStateful
                         */
                        InstanceGroupManagerStatusStateful.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagerStatusStateful)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagerStatusStateful();
                            if (object.hasStatefulConfig != null)
                                message.hasStatefulConfig = Boolean(object.hasStatefulConfig);
                            if (object.perInstanceConfigs != null) {
                                if (typeof object.perInstanceConfigs !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagerStatusStateful.perInstanceConfigs: object expected");
                                message.perInstanceConfigs = $root.google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs.fromObject(object.perInstanceConfigs);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagerStatusStateful message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStateful
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagerStatusStateful} message InstanceGroupManagerStatusStateful
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagerStatusStateful.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.hasStatefulConfig != null && message.hasOwnProperty("hasStatefulConfig")) {
                                object.hasStatefulConfig = message.hasStatefulConfig;
                                if (options.oneofs)
                                    object._hasStatefulConfig = "hasStatefulConfig";
                            }
                            if (message.perInstanceConfigs != null && message.hasOwnProperty("perInstanceConfigs")) {
                                object.perInstanceConfigs = $root.google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs.toObject(message.perInstanceConfigs, options);
                                if (options.oneofs)
                                    object._perInstanceConfigs = "perInstanceConfigs";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagerStatusStateful to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStateful
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagerStatusStateful.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagerStatusStateful
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStateful
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagerStatusStateful.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagerStatusStateful";
                        };
    
                        return InstanceGroupManagerStatusStateful;
                    })();
    
                    v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagerStatusStatefulPerInstanceConfigs.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagerStatusStatefulPerInstanceConfigs
                         * @property {boolean|null} [allEffective] InstanceGroupManagerStatusStatefulPerInstanceConfigs allEffective
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagerStatusStatefulPerInstanceConfigs.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagerStatusStatefulPerInstanceConfigs.
                         * @implements IInstanceGroupManagerStatusStatefulPerInstanceConfigs
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerStatusStatefulPerInstanceConfigs=} [properties] Properties to set
                         */
                        function InstanceGroupManagerStatusStatefulPerInstanceConfigs(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagerStatusStatefulPerInstanceConfigs allEffective.
                         * @member {boolean|null|undefined} allEffective
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs
                         * @instance
                         */
                        InstanceGroupManagerStatusStatefulPerInstanceConfigs.prototype.allEffective = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupManagerStatusStatefulPerInstanceConfigs _allEffective.
                         * @member {"allEffective"|undefined} _allEffective
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerStatusStatefulPerInstanceConfigs.prototype, "_allEffective", {
                            get: $util.oneOfGetter($oneOfFields = ["allEffective"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupManagerStatusStatefulPerInstanceConfigs instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerStatusStatefulPerInstanceConfigs=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs} InstanceGroupManagerStatusStatefulPerInstanceConfigs instance
                         */
                        InstanceGroupManagerStatusStatefulPerInstanceConfigs.create = function create(properties) {
                            return new InstanceGroupManagerStatusStatefulPerInstanceConfigs(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagerStatusStatefulPerInstanceConfigs message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerStatusStatefulPerInstanceConfigs} message InstanceGroupManagerStatusStatefulPerInstanceConfigs message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagerStatusStatefulPerInstanceConfigs.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.allEffective != null && Object.hasOwnProperty.call(message, "allEffective"))
                                writer.uint32(/* id 516540553, wireType 0 =*/4132324424).bool(message.allEffective);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagerStatusStatefulPerInstanceConfigs message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerStatusStatefulPerInstanceConfigs} message InstanceGroupManagerStatusStatefulPerInstanceConfigs message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagerStatusStatefulPerInstanceConfigs.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagerStatusStatefulPerInstanceConfigs message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs} InstanceGroupManagerStatusStatefulPerInstanceConfigs
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagerStatusStatefulPerInstanceConfigs.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 516540553: {
                                        message.allEffective = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagerStatusStatefulPerInstanceConfigs message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs} InstanceGroupManagerStatusStatefulPerInstanceConfigs
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagerStatusStatefulPerInstanceConfigs.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagerStatusStatefulPerInstanceConfigs message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagerStatusStatefulPerInstanceConfigs.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.allEffective != null && message.hasOwnProperty("allEffective")) {
                                properties._allEffective = 1;
                                if (typeof message.allEffective !== "boolean")
                                    return "allEffective: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagerStatusStatefulPerInstanceConfigs message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs} InstanceGroupManagerStatusStatefulPerInstanceConfigs
                         */
                        InstanceGroupManagerStatusStatefulPerInstanceConfigs.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs();
                            if (object.allEffective != null)
                                message.allEffective = Boolean(object.allEffective);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagerStatusStatefulPerInstanceConfigs message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs} message InstanceGroupManagerStatusStatefulPerInstanceConfigs
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagerStatusStatefulPerInstanceConfigs.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.allEffective != null && message.hasOwnProperty("allEffective")) {
                                object.allEffective = message.allEffective;
                                if (options.oneofs)
                                    object._allEffective = "allEffective";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagerStatusStatefulPerInstanceConfigs to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagerStatusStatefulPerInstanceConfigs.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagerStatusStatefulPerInstanceConfigs
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagerStatusStatefulPerInstanceConfigs.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagerStatusStatefulPerInstanceConfigs";
                        };
    
                        return InstanceGroupManagerStatusStatefulPerInstanceConfigs;
                    })();
    
                    v1.InstanceGroupManagerStatusVersionTarget = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagerStatusVersionTarget.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagerStatusVersionTarget
                         * @property {boolean|null} [isReached] InstanceGroupManagerStatusVersionTarget isReached
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagerStatusVersionTarget.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagerStatusVersionTarget.
                         * @implements IInstanceGroupManagerStatusVersionTarget
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerStatusVersionTarget=} [properties] Properties to set
                         */
                        function InstanceGroupManagerStatusVersionTarget(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagerStatusVersionTarget isReached.
                         * @member {boolean|null|undefined} isReached
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget
                         * @instance
                         */
                        InstanceGroupManagerStatusVersionTarget.prototype.isReached = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupManagerStatusVersionTarget _isReached.
                         * @member {"isReached"|undefined} _isReached
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerStatusVersionTarget.prototype, "_isReached", {
                            get: $util.oneOfGetter($oneOfFields = ["isReached"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupManagerStatusVersionTarget instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerStatusVersionTarget=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget} InstanceGroupManagerStatusVersionTarget instance
                         */
                        InstanceGroupManagerStatusVersionTarget.create = function create(properties) {
                            return new InstanceGroupManagerStatusVersionTarget(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagerStatusVersionTarget message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerStatusVersionTarget} message InstanceGroupManagerStatusVersionTarget message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagerStatusVersionTarget.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.isReached != null && Object.hasOwnProperty.call(message, "isReached"))
                                writer.uint32(/* id 433209149, wireType 0 =*/3465673192).bool(message.isReached);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagerStatusVersionTarget message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerStatusVersionTarget} message InstanceGroupManagerStatusVersionTarget message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagerStatusVersionTarget.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagerStatusVersionTarget message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget} InstanceGroupManagerStatusVersionTarget
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagerStatusVersionTarget.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 433209149: {
                                        message.isReached = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagerStatusVersionTarget message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget} InstanceGroupManagerStatusVersionTarget
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagerStatusVersionTarget.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagerStatusVersionTarget message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagerStatusVersionTarget.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.isReached != null && message.hasOwnProperty("isReached")) {
                                properties._isReached = 1;
                                if (typeof message.isReached !== "boolean")
                                    return "isReached: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagerStatusVersionTarget message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget} InstanceGroupManagerStatusVersionTarget
                         */
                        InstanceGroupManagerStatusVersionTarget.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget();
                            if (object.isReached != null)
                                message.isReached = Boolean(object.isReached);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagerStatusVersionTarget message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget} message InstanceGroupManagerStatusVersionTarget
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagerStatusVersionTarget.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.isReached != null && message.hasOwnProperty("isReached")) {
                                object.isReached = message.isReached;
                                if (options.oneofs)
                                    object._isReached = "isReached";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagerStatusVersionTarget to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagerStatusVersionTarget.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagerStatusVersionTarget
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagerStatusVersionTarget.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagerStatusVersionTarget";
                        };
    
                        return InstanceGroupManagerStatusVersionTarget;
                    })();
    
                    v1.InstanceGroupManagerUpdatePolicy = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagerUpdatePolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagerUpdatePolicy
                         * @property {string|null} [instanceRedistributionType] InstanceGroupManagerUpdatePolicy instanceRedistributionType
                         * @property {google.cloud.compute.v1.IFixedOrPercent|null} [maxSurge] InstanceGroupManagerUpdatePolicy maxSurge
                         * @property {google.cloud.compute.v1.IFixedOrPercent|null} [maxUnavailable] InstanceGroupManagerUpdatePolicy maxUnavailable
                         * @property {string|null} [minimalAction] InstanceGroupManagerUpdatePolicy minimalAction
                         * @property {string|null} [mostDisruptiveAllowedAction] InstanceGroupManagerUpdatePolicy mostDisruptiveAllowedAction
                         * @property {string|null} [replacementMethod] InstanceGroupManagerUpdatePolicy replacementMethod
                         * @property {string|null} [type] InstanceGroupManagerUpdatePolicy type
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagerUpdatePolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagerUpdatePolicy.
                         * @implements IInstanceGroupManagerUpdatePolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerUpdatePolicy=} [properties] Properties to set
                         */
                        function InstanceGroupManagerUpdatePolicy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagerUpdatePolicy instanceRedistributionType.
                         * @member {string|null|undefined} instanceRedistributionType
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @instance
                         */
                        InstanceGroupManagerUpdatePolicy.prototype.instanceRedistributionType = null;
    
                        /**
                         * InstanceGroupManagerUpdatePolicy maxSurge.
                         * @member {google.cloud.compute.v1.IFixedOrPercent|null|undefined} maxSurge
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @instance
                         */
                        InstanceGroupManagerUpdatePolicy.prototype.maxSurge = null;
    
                        /**
                         * InstanceGroupManagerUpdatePolicy maxUnavailable.
                         * @member {google.cloud.compute.v1.IFixedOrPercent|null|undefined} maxUnavailable
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @instance
                         */
                        InstanceGroupManagerUpdatePolicy.prototype.maxUnavailable = null;
    
                        /**
                         * InstanceGroupManagerUpdatePolicy minimalAction.
                         * @member {string|null|undefined} minimalAction
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @instance
                         */
                        InstanceGroupManagerUpdatePolicy.prototype.minimalAction = null;
    
                        /**
                         * InstanceGroupManagerUpdatePolicy mostDisruptiveAllowedAction.
                         * @member {string|null|undefined} mostDisruptiveAllowedAction
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @instance
                         */
                        InstanceGroupManagerUpdatePolicy.prototype.mostDisruptiveAllowedAction = null;
    
                        /**
                         * InstanceGroupManagerUpdatePolicy replacementMethod.
                         * @member {string|null|undefined} replacementMethod
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @instance
                         */
                        InstanceGroupManagerUpdatePolicy.prototype.replacementMethod = null;
    
                        /**
                         * InstanceGroupManagerUpdatePolicy type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @instance
                         */
                        InstanceGroupManagerUpdatePolicy.prototype.type = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupManagerUpdatePolicy _instanceRedistributionType.
                         * @member {"instanceRedistributionType"|undefined} _instanceRedistributionType
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerUpdatePolicy.prototype, "_instanceRedistributionType", {
                            get: $util.oneOfGetter($oneOfFields = ["instanceRedistributionType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerUpdatePolicy _maxSurge.
                         * @member {"maxSurge"|undefined} _maxSurge
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerUpdatePolicy.prototype, "_maxSurge", {
                            get: $util.oneOfGetter($oneOfFields = ["maxSurge"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerUpdatePolicy _maxUnavailable.
                         * @member {"maxUnavailable"|undefined} _maxUnavailable
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerUpdatePolicy.prototype, "_maxUnavailable", {
                            get: $util.oneOfGetter($oneOfFields = ["maxUnavailable"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerUpdatePolicy _minimalAction.
                         * @member {"minimalAction"|undefined} _minimalAction
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerUpdatePolicy.prototype, "_minimalAction", {
                            get: $util.oneOfGetter($oneOfFields = ["minimalAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerUpdatePolicy _mostDisruptiveAllowedAction.
                         * @member {"mostDisruptiveAllowedAction"|undefined} _mostDisruptiveAllowedAction
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerUpdatePolicy.prototype, "_mostDisruptiveAllowedAction", {
                            get: $util.oneOfGetter($oneOfFields = ["mostDisruptiveAllowedAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerUpdatePolicy _replacementMethod.
                         * @member {"replacementMethod"|undefined} _replacementMethod
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerUpdatePolicy.prototype, "_replacementMethod", {
                            get: $util.oneOfGetter($oneOfFields = ["replacementMethod"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerUpdatePolicy _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerUpdatePolicy.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupManagerUpdatePolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerUpdatePolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy} InstanceGroupManagerUpdatePolicy instance
                         */
                        InstanceGroupManagerUpdatePolicy.create = function create(properties) {
                            return new InstanceGroupManagerUpdatePolicy(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagerUpdatePolicy message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerUpdatePolicy} message InstanceGroupManagerUpdatePolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagerUpdatePolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            if (message.mostDisruptiveAllowedAction != null && Object.hasOwnProperty.call(message, "mostDisruptiveAllowedAction"))
                                writer.uint32(/* id 66103053, wireType 2 =*/528824426).string(message.mostDisruptiveAllowedAction);
                            if (message.minimalAction != null && Object.hasOwnProperty.call(message, "minimalAction"))
                                writer.uint32(/* id 270567060, wireType 2 =*/2164536482).string(message.minimalAction);
                            if (message.instanceRedistributionType != null && Object.hasOwnProperty.call(message, "instanceRedistributionType"))
                                writer.uint32(/* id 292630424, wireType 2 =*/2341043394).string(message.instanceRedistributionType);
                            if (message.maxSurge != null && Object.hasOwnProperty.call(message, "maxSurge"))
                                $root.google.cloud.compute.v1.FixedOrPercent.encode(message.maxSurge, writer.uint32(/* id 302572691, wireType 2 =*/2420581530).fork()).ldelim();
                            if (message.maxUnavailable != null && Object.hasOwnProperty.call(message, "maxUnavailable"))
                                $root.google.cloud.compute.v1.FixedOrPercent.encode(message.maxUnavailable, writer.uint32(/* id 404940277, wireType 2 =*/3239522218).fork()).ldelim();
                            if (message.replacementMethod != null && Object.hasOwnProperty.call(message, "replacementMethod"))
                                writer.uint32(/* id 505931694, wireType 2 =*/4047453554).string(message.replacementMethod);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagerUpdatePolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerUpdatePolicy} message InstanceGroupManagerUpdatePolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagerUpdatePolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagerUpdatePolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy} InstanceGroupManagerUpdatePolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagerUpdatePolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 292630424: {
                                        message.instanceRedistributionType = reader.string();
                                        break;
                                    }
                                case 302572691: {
                                        message.maxSurge = $root.google.cloud.compute.v1.FixedOrPercent.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 404940277: {
                                        message.maxUnavailable = $root.google.cloud.compute.v1.FixedOrPercent.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 270567060: {
                                        message.minimalAction = reader.string();
                                        break;
                                    }
                                case 66103053: {
                                        message.mostDisruptiveAllowedAction = reader.string();
                                        break;
                                    }
                                case 505931694: {
                                        message.replacementMethod = reader.string();
                                        break;
                                    }
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagerUpdatePolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy} InstanceGroupManagerUpdatePolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagerUpdatePolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagerUpdatePolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagerUpdatePolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceRedistributionType != null && message.hasOwnProperty("instanceRedistributionType")) {
                                properties._instanceRedistributionType = 1;
                                if (!$util.isString(message.instanceRedistributionType))
                                    return "instanceRedistributionType: string expected";
                            }
                            if (message.maxSurge != null && message.hasOwnProperty("maxSurge")) {
                                properties._maxSurge = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.FixedOrPercent.verify(message.maxSurge);
                                    if (error)
                                        return "maxSurge." + error;
                                }
                            }
                            if (message.maxUnavailable != null && message.hasOwnProperty("maxUnavailable")) {
                                properties._maxUnavailable = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.FixedOrPercent.verify(message.maxUnavailable);
                                    if (error)
                                        return "maxUnavailable." + error;
                                }
                            }
                            if (message.minimalAction != null && message.hasOwnProperty("minimalAction")) {
                                properties._minimalAction = 1;
                                if (!$util.isString(message.minimalAction))
                                    return "minimalAction: string expected";
                            }
                            if (message.mostDisruptiveAllowedAction != null && message.hasOwnProperty("mostDisruptiveAllowedAction")) {
                                properties._mostDisruptiveAllowedAction = 1;
                                if (!$util.isString(message.mostDisruptiveAllowedAction))
                                    return "mostDisruptiveAllowedAction: string expected";
                            }
                            if (message.replacementMethod != null && message.hasOwnProperty("replacementMethod")) {
                                properties._replacementMethod = 1;
                                if (!$util.isString(message.replacementMethod))
                                    return "replacementMethod: string expected";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagerUpdatePolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy} InstanceGroupManagerUpdatePolicy
                         */
                        InstanceGroupManagerUpdatePolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy();
                            if (object.instanceRedistributionType != null)
                                message.instanceRedistributionType = String(object.instanceRedistributionType);
                            if (object.maxSurge != null) {
                                if (typeof object.maxSurge !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy.maxSurge: object expected");
                                message.maxSurge = $root.google.cloud.compute.v1.FixedOrPercent.fromObject(object.maxSurge);
                            }
                            if (object.maxUnavailable != null) {
                                if (typeof object.maxUnavailable !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy.maxUnavailable: object expected");
                                message.maxUnavailable = $root.google.cloud.compute.v1.FixedOrPercent.fromObject(object.maxUnavailable);
                            }
                            if (object.minimalAction != null)
                                message.minimalAction = String(object.minimalAction);
                            if (object.mostDisruptiveAllowedAction != null)
                                message.mostDisruptiveAllowedAction = String(object.mostDisruptiveAllowedAction);
                            if (object.replacementMethod != null)
                                message.replacementMethod = String(object.replacementMethod);
                            if (object.type != null)
                                message.type = String(object.type);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagerUpdatePolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy} message InstanceGroupManagerUpdatePolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagerUpdatePolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            if (message.mostDisruptiveAllowedAction != null && message.hasOwnProperty("mostDisruptiveAllowedAction")) {
                                object.mostDisruptiveAllowedAction = message.mostDisruptiveAllowedAction;
                                if (options.oneofs)
                                    object._mostDisruptiveAllowedAction = "mostDisruptiveAllowedAction";
                            }
                            if (message.minimalAction != null && message.hasOwnProperty("minimalAction")) {
                                object.minimalAction = message.minimalAction;
                                if (options.oneofs)
                                    object._minimalAction = "minimalAction";
                            }
                            if (message.instanceRedistributionType != null && message.hasOwnProperty("instanceRedistributionType")) {
                                object.instanceRedistributionType = message.instanceRedistributionType;
                                if (options.oneofs)
                                    object._instanceRedistributionType = "instanceRedistributionType";
                            }
                            if (message.maxSurge != null && message.hasOwnProperty("maxSurge")) {
                                object.maxSurge = $root.google.cloud.compute.v1.FixedOrPercent.toObject(message.maxSurge, options);
                                if (options.oneofs)
                                    object._maxSurge = "maxSurge";
                            }
                            if (message.maxUnavailable != null && message.hasOwnProperty("maxUnavailable")) {
                                object.maxUnavailable = $root.google.cloud.compute.v1.FixedOrPercent.toObject(message.maxUnavailable, options);
                                if (options.oneofs)
                                    object._maxUnavailable = "maxUnavailable";
                            }
                            if (message.replacementMethod != null && message.hasOwnProperty("replacementMethod")) {
                                object.replacementMethod = message.replacementMethod;
                                if (options.oneofs)
                                    object._replacementMethod = "replacementMethod";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagerUpdatePolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagerUpdatePolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagerUpdatePolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagerUpdatePolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy";
                        };
    
                        /**
                         * InstanceRedistributionType enum.
                         * @name google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy.InstanceRedistributionType
                         * @enum {number}
                         * @property {number} UNDEFINED_INSTANCE_REDISTRIBUTION_TYPE=0 UNDEFINED_INSTANCE_REDISTRIBUTION_TYPE value
                         */
                        InstanceGroupManagerUpdatePolicy.InstanceRedistributionType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_INSTANCE_REDISTRIBUTION_TYPE"] = 0;
                            return values;
                        })();
    
                        /**
                         * MinimalAction enum.
                         * @name google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy.MinimalAction
                         * @enum {number}
                         * @property {number} UNDEFINED_MINIMAL_ACTION=0 UNDEFINED_MINIMAL_ACTION value
                         */
                        InstanceGroupManagerUpdatePolicy.MinimalAction = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_MINIMAL_ACTION"] = 0;
                            return values;
                        })();
    
                        /**
                         * MostDisruptiveAllowedAction enum.
                         * @name google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy.MostDisruptiveAllowedAction
                         * @enum {number}
                         * @property {number} UNDEFINED_MOST_DISRUPTIVE_ALLOWED_ACTION=0 UNDEFINED_MOST_DISRUPTIVE_ALLOWED_ACTION value
                         */
                        InstanceGroupManagerUpdatePolicy.MostDisruptiveAllowedAction = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_MOST_DISRUPTIVE_ALLOWED_ACTION"] = 0;
                            return values;
                        })();
    
                        /**
                         * ReplacementMethod enum.
                         * @name google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy.ReplacementMethod
                         * @enum {number}
                         * @property {number} UNDEFINED_REPLACEMENT_METHOD=0 UNDEFINED_REPLACEMENT_METHOD value
                         * @property {number} RECREATE=522644719 RECREATE value
                         * @property {number} SUBSTITUTE=280924314 SUBSTITUTE value
                         */
                        InstanceGroupManagerUpdatePolicy.ReplacementMethod = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_REPLACEMENT_METHOD"] = 0;
                            values[valuesById[522644719] = "RECREATE"] = 522644719;
                            values[valuesById[280924314] = "SUBSTITUTE"] = 280924314;
                            return values;
                        })();
    
                        /**
                         * Type enum.
                         * @name google.cloud.compute.v1.InstanceGroupManagerUpdatePolicy.Type
                         * @enum {number}
                         * @property {number} UNDEFINED_TYPE=0 UNDEFINED_TYPE value
                         * @property {number} OPPORTUNISTIC=429530089 OPPORTUNISTIC value
                         */
                        InstanceGroupManagerUpdatePolicy.Type = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TYPE"] = 0;
                            values[valuesById[429530089] = "OPPORTUNISTIC"] = 429530089;
                            return values;
                        })();
    
                        return InstanceGroupManagerUpdatePolicy;
                    })();
    
                    v1.InstanceGroupManagerVersion = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagerVersion.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagerVersion
                         * @property {string|null} [instanceTemplate] InstanceGroupManagerVersion instanceTemplate
                         * @property {string|null} [name] InstanceGroupManagerVersion name
                         * @property {google.cloud.compute.v1.IFixedOrPercent|null} [targetSize] InstanceGroupManagerVersion targetSize
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagerVersion.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagerVersion.
                         * @implements IInstanceGroupManagerVersion
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerVersion=} [properties] Properties to set
                         */
                        function InstanceGroupManagerVersion(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagerVersion instanceTemplate.
                         * @member {string|null|undefined} instanceTemplate
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerVersion
                         * @instance
                         */
                        InstanceGroupManagerVersion.prototype.instanceTemplate = null;
    
                        /**
                         * InstanceGroupManagerVersion name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerVersion
                         * @instance
                         */
                        InstanceGroupManagerVersion.prototype.name = null;
    
                        /**
                         * InstanceGroupManagerVersion targetSize.
                         * @member {google.cloud.compute.v1.IFixedOrPercent|null|undefined} targetSize
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerVersion
                         * @instance
                         */
                        InstanceGroupManagerVersion.prototype.targetSize = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupManagerVersion _instanceTemplate.
                         * @member {"instanceTemplate"|undefined} _instanceTemplate
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerVersion
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerVersion.prototype, "_instanceTemplate", {
                            get: $util.oneOfGetter($oneOfFields = ["instanceTemplate"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerVersion _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerVersion
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerVersion.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagerVersion _targetSize.
                         * @member {"targetSize"|undefined} _targetSize
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerVersion
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagerVersion.prototype, "_targetSize", {
                            get: $util.oneOfGetter($oneOfFields = ["targetSize"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupManagerVersion instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerVersion
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerVersion=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerVersion} InstanceGroupManagerVersion instance
                         */
                        InstanceGroupManagerVersion.create = function create(properties) {
                            return new InstanceGroupManagerVersion(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagerVersion message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagerVersion.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerVersion
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerVersion} message InstanceGroupManagerVersion message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagerVersion.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.targetSize != null && Object.hasOwnProperty.call(message, "targetSize"))
                                $root.google.cloud.compute.v1.FixedOrPercent.encode(message.targetSize, writer.uint32(/* id 62880239, wireType 2 =*/503041914).fork()).ldelim();
                            if (message.instanceTemplate != null && Object.hasOwnProperty.call(message, "instanceTemplate"))
                                writer.uint32(/* id 309248228, wireType 2 =*/2473985826).string(message.instanceTemplate);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagerVersion message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagerVersion.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerVersion
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagerVersion} message InstanceGroupManagerVersion message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagerVersion.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagerVersion message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerVersion
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerVersion} InstanceGroupManagerVersion
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagerVersion.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagerVersion();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 309248228: {
                                        message.instanceTemplate = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 62880239: {
                                        message.targetSize = $root.google.cloud.compute.v1.FixedOrPercent.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagerVersion message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerVersion
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerVersion} InstanceGroupManagerVersion
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagerVersion.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagerVersion message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerVersion
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagerVersion.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceTemplate != null && message.hasOwnProperty("instanceTemplate")) {
                                properties._instanceTemplate = 1;
                                if (!$util.isString(message.instanceTemplate))
                                    return "instanceTemplate: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.targetSize != null && message.hasOwnProperty("targetSize")) {
                                properties._targetSize = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.FixedOrPercent.verify(message.targetSize);
                                    if (error)
                                        return "targetSize." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagerVersion message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerVersion
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagerVersion} InstanceGroupManagerVersion
                         */
                        InstanceGroupManagerVersion.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagerVersion)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagerVersion();
                            if (object.instanceTemplate != null)
                                message.instanceTemplate = String(object.instanceTemplate);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.targetSize != null) {
                                if (typeof object.targetSize !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagerVersion.targetSize: object expected");
                                message.targetSize = $root.google.cloud.compute.v1.FixedOrPercent.fromObject(object.targetSize);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagerVersion message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerVersion
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagerVersion} message InstanceGroupManagerVersion
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagerVersion.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.targetSize != null && message.hasOwnProperty("targetSize")) {
                                object.targetSize = $root.google.cloud.compute.v1.FixedOrPercent.toObject(message.targetSize, options);
                                if (options.oneofs)
                                    object._targetSize = "targetSize";
                            }
                            if (message.instanceTemplate != null && message.hasOwnProperty("instanceTemplate")) {
                                object.instanceTemplate = message.instanceTemplate;
                                if (options.oneofs)
                                    object._instanceTemplate = "instanceTemplate";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagerVersion to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerVersion
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagerVersion.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagerVersion
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagerVersion
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagerVersion.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagerVersion";
                        };
    
                        return InstanceGroupManagerVersion;
                    })();
    
                    v1.InstanceGroupManagersAbandonInstancesRequest = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagersAbandonInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagersAbandonInstancesRequest
                         * @property {Array.<string>|null} [instances] InstanceGroupManagersAbandonInstancesRequest instances
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagersAbandonInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagersAbandonInstancesRequest.
                         * @implements IInstanceGroupManagersAbandonInstancesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersAbandonInstancesRequest=} [properties] Properties to set
                         */
                        function InstanceGroupManagersAbandonInstancesRequest(properties) {
                            this.instances = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagersAbandonInstancesRequest instances.
                         * @member {Array.<string>} instances
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest
                         * @instance
                         */
                        InstanceGroupManagersAbandonInstancesRequest.prototype.instances = $util.emptyArray;
    
                        /**
                         * Creates a new InstanceGroupManagersAbandonInstancesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersAbandonInstancesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest} InstanceGroupManagersAbandonInstancesRequest instance
                         */
                        InstanceGroupManagersAbandonInstancesRequest.create = function create(properties) {
                            return new InstanceGroupManagersAbandonInstancesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersAbandonInstancesRequest message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersAbandonInstancesRequest} message InstanceGroupManagersAbandonInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersAbandonInstancesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instances != null && message.instances.length)
                                for (var i = 0; i < message.instances.length; ++i)
                                    writer.uint32(/* id 29097598, wireType 2 =*/232780786).string(message.instances[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersAbandonInstancesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersAbandonInstancesRequest} message InstanceGroupManagersAbandonInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersAbandonInstancesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersAbandonInstancesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest} InstanceGroupManagersAbandonInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersAbandonInstancesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 29097598: {
                                        if (!(message.instances && message.instances.length))
                                            message.instances = [];
                                        message.instances.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersAbandonInstancesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest} InstanceGroupManagersAbandonInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersAbandonInstancesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagersAbandonInstancesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagersAbandonInstancesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instances != null && message.hasOwnProperty("instances")) {
                                if (!Array.isArray(message.instances))
                                    return "instances: array expected";
                                for (var i = 0; i < message.instances.length; ++i)
                                    if (!$util.isString(message.instances[i]))
                                        return "instances: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagersAbandonInstancesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest} InstanceGroupManagersAbandonInstancesRequest
                         */
                        InstanceGroupManagersAbandonInstancesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest();
                            if (object.instances) {
                                if (!Array.isArray(object.instances))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest.instances: array expected");
                                message.instances = [];
                                for (var i = 0; i < object.instances.length; ++i)
                                    message.instances[i] = String(object.instances[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagersAbandonInstancesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest} message InstanceGroupManagersAbandonInstancesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagersAbandonInstancesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.instances = [];
                            if (message.instances && message.instances.length) {
                                object.instances = [];
                                for (var j = 0; j < message.instances.length; ++j)
                                    object.instances[j] = message.instances[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagersAbandonInstancesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagersAbandonInstancesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagersAbandonInstancesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagersAbandonInstancesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagersAbandonInstancesRequest";
                        };
    
                        return InstanceGroupManagersAbandonInstancesRequest;
                    })();
    
                    v1.InstanceGroupManagersApplyUpdatesRequest = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagersApplyUpdatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagersApplyUpdatesRequest
                         * @property {boolean|null} [allInstances] InstanceGroupManagersApplyUpdatesRequest allInstances
                         * @property {Array.<string>|null} [instances] InstanceGroupManagersApplyUpdatesRequest instances
                         * @property {string|null} [minimalAction] InstanceGroupManagersApplyUpdatesRequest minimalAction
                         * @property {string|null} [mostDisruptiveAllowedAction] InstanceGroupManagersApplyUpdatesRequest mostDisruptiveAllowedAction
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagersApplyUpdatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagersApplyUpdatesRequest.
                         * @implements IInstanceGroupManagersApplyUpdatesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersApplyUpdatesRequest=} [properties] Properties to set
                         */
                        function InstanceGroupManagersApplyUpdatesRequest(properties) {
                            this.instances = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagersApplyUpdatesRequest allInstances.
                         * @member {boolean|null|undefined} allInstances
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest
                         * @instance
                         */
                        InstanceGroupManagersApplyUpdatesRequest.prototype.allInstances = null;
    
                        /**
                         * InstanceGroupManagersApplyUpdatesRequest instances.
                         * @member {Array.<string>} instances
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest
                         * @instance
                         */
                        InstanceGroupManagersApplyUpdatesRequest.prototype.instances = $util.emptyArray;
    
                        /**
                         * InstanceGroupManagersApplyUpdatesRequest minimalAction.
                         * @member {string|null|undefined} minimalAction
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest
                         * @instance
                         */
                        InstanceGroupManagersApplyUpdatesRequest.prototype.minimalAction = null;
    
                        /**
                         * InstanceGroupManagersApplyUpdatesRequest mostDisruptiveAllowedAction.
                         * @member {string|null|undefined} mostDisruptiveAllowedAction
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest
                         * @instance
                         */
                        InstanceGroupManagersApplyUpdatesRequest.prototype.mostDisruptiveAllowedAction = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupManagersApplyUpdatesRequest _allInstances.
                         * @member {"allInstances"|undefined} _allInstances
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagersApplyUpdatesRequest.prototype, "_allInstances", {
                            get: $util.oneOfGetter($oneOfFields = ["allInstances"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagersApplyUpdatesRequest _minimalAction.
                         * @member {"minimalAction"|undefined} _minimalAction
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagersApplyUpdatesRequest.prototype, "_minimalAction", {
                            get: $util.oneOfGetter($oneOfFields = ["minimalAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagersApplyUpdatesRequest _mostDisruptiveAllowedAction.
                         * @member {"mostDisruptiveAllowedAction"|undefined} _mostDisruptiveAllowedAction
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagersApplyUpdatesRequest.prototype, "_mostDisruptiveAllowedAction", {
                            get: $util.oneOfGetter($oneOfFields = ["mostDisruptiveAllowedAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupManagersApplyUpdatesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersApplyUpdatesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest} InstanceGroupManagersApplyUpdatesRequest instance
                         */
                        InstanceGroupManagersApplyUpdatesRequest.create = function create(properties) {
                            return new InstanceGroupManagersApplyUpdatesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersApplyUpdatesRequest message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersApplyUpdatesRequest} message InstanceGroupManagersApplyUpdatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersApplyUpdatesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instances != null && message.instances.length)
                                for (var i = 0; i < message.instances.length; ++i)
                                    writer.uint32(/* id 29097598, wireType 2 =*/232780786).string(message.instances[i]);
                            if (message.mostDisruptiveAllowedAction != null && Object.hasOwnProperty.call(message, "mostDisruptiveAllowedAction"))
                                writer.uint32(/* id 66103053, wireType 2 =*/528824426).string(message.mostDisruptiveAllowedAction);
                            if (message.minimalAction != null && Object.hasOwnProperty.call(message, "minimalAction"))
                                writer.uint32(/* id 270567060, wireType 2 =*/2164536482).string(message.minimalAction);
                            if (message.allInstances != null && Object.hasOwnProperty.call(message, "allInstances"))
                                writer.uint32(/* id 403676512, wireType 0 =*/3229412096).bool(message.allInstances);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersApplyUpdatesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersApplyUpdatesRequest} message InstanceGroupManagersApplyUpdatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersApplyUpdatesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersApplyUpdatesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest} InstanceGroupManagersApplyUpdatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersApplyUpdatesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 403676512: {
                                        message.allInstances = reader.bool();
                                        break;
                                    }
                                case 29097598: {
                                        if (!(message.instances && message.instances.length))
                                            message.instances = [];
                                        message.instances.push(reader.string());
                                        break;
                                    }
                                case 270567060: {
                                        message.minimalAction = reader.string();
                                        break;
                                    }
                                case 66103053: {
                                        message.mostDisruptiveAllowedAction = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersApplyUpdatesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest} InstanceGroupManagersApplyUpdatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersApplyUpdatesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagersApplyUpdatesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagersApplyUpdatesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.allInstances != null && message.hasOwnProperty("allInstances")) {
                                properties._allInstances = 1;
                                if (typeof message.allInstances !== "boolean")
                                    return "allInstances: boolean expected";
                            }
                            if (message.instances != null && message.hasOwnProperty("instances")) {
                                if (!Array.isArray(message.instances))
                                    return "instances: array expected";
                                for (var i = 0; i < message.instances.length; ++i)
                                    if (!$util.isString(message.instances[i]))
                                        return "instances: string[] expected";
                            }
                            if (message.minimalAction != null && message.hasOwnProperty("minimalAction")) {
                                properties._minimalAction = 1;
                                if (!$util.isString(message.minimalAction))
                                    return "minimalAction: string expected";
                            }
                            if (message.mostDisruptiveAllowedAction != null && message.hasOwnProperty("mostDisruptiveAllowedAction")) {
                                properties._mostDisruptiveAllowedAction = 1;
                                if (!$util.isString(message.mostDisruptiveAllowedAction))
                                    return "mostDisruptiveAllowedAction: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagersApplyUpdatesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest} InstanceGroupManagersApplyUpdatesRequest
                         */
                        InstanceGroupManagersApplyUpdatesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest();
                            if (object.allInstances != null)
                                message.allInstances = Boolean(object.allInstances);
                            if (object.instances) {
                                if (!Array.isArray(object.instances))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest.instances: array expected");
                                message.instances = [];
                                for (var i = 0; i < object.instances.length; ++i)
                                    message.instances[i] = String(object.instances[i]);
                            }
                            if (object.minimalAction != null)
                                message.minimalAction = String(object.minimalAction);
                            if (object.mostDisruptiveAllowedAction != null)
                                message.mostDisruptiveAllowedAction = String(object.mostDisruptiveAllowedAction);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagersApplyUpdatesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest} message InstanceGroupManagersApplyUpdatesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagersApplyUpdatesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.instances = [];
                            if (message.instances && message.instances.length) {
                                object.instances = [];
                                for (var j = 0; j < message.instances.length; ++j)
                                    object.instances[j] = message.instances[j];
                            }
                            if (message.mostDisruptiveAllowedAction != null && message.hasOwnProperty("mostDisruptiveAllowedAction")) {
                                object.mostDisruptiveAllowedAction = message.mostDisruptiveAllowedAction;
                                if (options.oneofs)
                                    object._mostDisruptiveAllowedAction = "mostDisruptiveAllowedAction";
                            }
                            if (message.minimalAction != null && message.hasOwnProperty("minimalAction")) {
                                object.minimalAction = message.minimalAction;
                                if (options.oneofs)
                                    object._minimalAction = "minimalAction";
                            }
                            if (message.allInstances != null && message.hasOwnProperty("allInstances")) {
                                object.allInstances = message.allInstances;
                                if (options.oneofs)
                                    object._allInstances = "allInstances";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagersApplyUpdatesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagersApplyUpdatesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagersApplyUpdatesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagersApplyUpdatesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest";
                        };
    
                        /**
                         * MinimalAction enum.
                         * @name google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest.MinimalAction
                         * @enum {number}
                         * @property {number} UNDEFINED_MINIMAL_ACTION=0 UNDEFINED_MINIMAL_ACTION value
                         */
                        InstanceGroupManagersApplyUpdatesRequest.MinimalAction = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_MINIMAL_ACTION"] = 0;
                            return values;
                        })();
    
                        /**
                         * MostDisruptiveAllowedAction enum.
                         * @name google.cloud.compute.v1.InstanceGroupManagersApplyUpdatesRequest.MostDisruptiveAllowedAction
                         * @enum {number}
                         * @property {number} UNDEFINED_MOST_DISRUPTIVE_ALLOWED_ACTION=0 UNDEFINED_MOST_DISRUPTIVE_ALLOWED_ACTION value
                         */
                        InstanceGroupManagersApplyUpdatesRequest.MostDisruptiveAllowedAction = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_MOST_DISRUPTIVE_ALLOWED_ACTION"] = 0;
                            return values;
                        })();
    
                        return InstanceGroupManagersApplyUpdatesRequest;
                    })();
    
                    v1.InstanceGroupManagersCreateInstancesRequest = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagersCreateInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagersCreateInstancesRequest
                         * @property {Array.<google.cloud.compute.v1.IPerInstanceConfig>|null} [instances] InstanceGroupManagersCreateInstancesRequest instances
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagersCreateInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagersCreateInstancesRequest.
                         * @implements IInstanceGroupManagersCreateInstancesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersCreateInstancesRequest=} [properties] Properties to set
                         */
                        function InstanceGroupManagersCreateInstancesRequest(properties) {
                            this.instances = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagersCreateInstancesRequest instances.
                         * @member {Array.<google.cloud.compute.v1.IPerInstanceConfig>} instances
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest
                         * @instance
                         */
                        InstanceGroupManagersCreateInstancesRequest.prototype.instances = $util.emptyArray;
    
                        /**
                         * Creates a new InstanceGroupManagersCreateInstancesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersCreateInstancesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest} InstanceGroupManagersCreateInstancesRequest instance
                         */
                        InstanceGroupManagersCreateInstancesRequest.create = function create(properties) {
                            return new InstanceGroupManagersCreateInstancesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersCreateInstancesRequest message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersCreateInstancesRequest} message InstanceGroupManagersCreateInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersCreateInstancesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instances != null && message.instances.length)
                                for (var i = 0; i < message.instances.length; ++i)
                                    $root.google.cloud.compute.v1.PerInstanceConfig.encode(message.instances[i], writer.uint32(/* id 29097598, wireType 2 =*/232780786).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersCreateInstancesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersCreateInstancesRequest} message InstanceGroupManagersCreateInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersCreateInstancesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersCreateInstancesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest} InstanceGroupManagersCreateInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersCreateInstancesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 29097598: {
                                        if (!(message.instances && message.instances.length))
                                            message.instances = [];
                                        message.instances.push($root.google.cloud.compute.v1.PerInstanceConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersCreateInstancesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest} InstanceGroupManagersCreateInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersCreateInstancesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagersCreateInstancesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagersCreateInstancesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instances != null && message.hasOwnProperty("instances")) {
                                if (!Array.isArray(message.instances))
                                    return "instances: array expected";
                                for (var i = 0; i < message.instances.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PerInstanceConfig.verify(message.instances[i]);
                                    if (error)
                                        return "instances." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagersCreateInstancesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest} InstanceGroupManagersCreateInstancesRequest
                         */
                        InstanceGroupManagersCreateInstancesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest();
                            if (object.instances) {
                                if (!Array.isArray(object.instances))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest.instances: array expected");
                                message.instances = [];
                                for (var i = 0; i < object.instances.length; ++i) {
                                    if (typeof object.instances[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest.instances: object expected");
                                    message.instances[i] = $root.google.cloud.compute.v1.PerInstanceConfig.fromObject(object.instances[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagersCreateInstancesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest} message InstanceGroupManagersCreateInstancesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagersCreateInstancesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.instances = [];
                            if (message.instances && message.instances.length) {
                                object.instances = [];
                                for (var j = 0; j < message.instances.length; ++j)
                                    object.instances[j] = $root.google.cloud.compute.v1.PerInstanceConfig.toObject(message.instances[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagersCreateInstancesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagersCreateInstancesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagersCreateInstancesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagersCreateInstancesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagersCreateInstancesRequest";
                        };
    
                        return InstanceGroupManagersCreateInstancesRequest;
                    })();
    
                    v1.InstanceGroupManagersDeleteInstancesRequest = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagersDeleteInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagersDeleteInstancesRequest
                         * @property {Array.<string>|null} [instances] InstanceGroupManagersDeleteInstancesRequest instances
                         * @property {boolean|null} [skipInstancesOnValidationError] InstanceGroupManagersDeleteInstancesRequest skipInstancesOnValidationError
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagersDeleteInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagersDeleteInstancesRequest.
                         * @implements IInstanceGroupManagersDeleteInstancesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersDeleteInstancesRequest=} [properties] Properties to set
                         */
                        function InstanceGroupManagersDeleteInstancesRequest(properties) {
                            this.instances = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagersDeleteInstancesRequest instances.
                         * @member {Array.<string>} instances
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest
                         * @instance
                         */
                        InstanceGroupManagersDeleteInstancesRequest.prototype.instances = $util.emptyArray;
    
                        /**
                         * InstanceGroupManagersDeleteInstancesRequest skipInstancesOnValidationError.
                         * @member {boolean|null|undefined} skipInstancesOnValidationError
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest
                         * @instance
                         */
                        InstanceGroupManagersDeleteInstancesRequest.prototype.skipInstancesOnValidationError = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupManagersDeleteInstancesRequest _skipInstancesOnValidationError.
                         * @member {"skipInstancesOnValidationError"|undefined} _skipInstancesOnValidationError
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagersDeleteInstancesRequest.prototype, "_skipInstancesOnValidationError", {
                            get: $util.oneOfGetter($oneOfFields = ["skipInstancesOnValidationError"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupManagersDeleteInstancesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersDeleteInstancesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest} InstanceGroupManagersDeleteInstancesRequest instance
                         */
                        InstanceGroupManagersDeleteInstancesRequest.create = function create(properties) {
                            return new InstanceGroupManagersDeleteInstancesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersDeleteInstancesRequest message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersDeleteInstancesRequest} message InstanceGroupManagersDeleteInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersDeleteInstancesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instances != null && message.instances.length)
                                for (var i = 0; i < message.instances.length; ++i)
                                    writer.uint32(/* id 29097598, wireType 2 =*/232780786).string(message.instances[i]);
                            if (message.skipInstancesOnValidationError != null && Object.hasOwnProperty.call(message, "skipInstancesOnValidationError"))
                                writer.uint32(/* id 40631073, wireType 0 =*/325048584).bool(message.skipInstancesOnValidationError);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersDeleteInstancesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersDeleteInstancesRequest} message InstanceGroupManagersDeleteInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersDeleteInstancesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersDeleteInstancesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest} InstanceGroupManagersDeleteInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersDeleteInstancesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 29097598: {
                                        if (!(message.instances && message.instances.length))
                                            message.instances = [];
                                        message.instances.push(reader.string());
                                        break;
                                    }
                                case 40631073: {
                                        message.skipInstancesOnValidationError = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersDeleteInstancesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest} InstanceGroupManagersDeleteInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersDeleteInstancesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagersDeleteInstancesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagersDeleteInstancesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instances != null && message.hasOwnProperty("instances")) {
                                if (!Array.isArray(message.instances))
                                    return "instances: array expected";
                                for (var i = 0; i < message.instances.length; ++i)
                                    if (!$util.isString(message.instances[i]))
                                        return "instances: string[] expected";
                            }
                            if (message.skipInstancesOnValidationError != null && message.hasOwnProperty("skipInstancesOnValidationError")) {
                                properties._skipInstancesOnValidationError = 1;
                                if (typeof message.skipInstancesOnValidationError !== "boolean")
                                    return "skipInstancesOnValidationError: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagersDeleteInstancesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest} InstanceGroupManagersDeleteInstancesRequest
                         */
                        InstanceGroupManagersDeleteInstancesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest();
                            if (object.instances) {
                                if (!Array.isArray(object.instances))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest.instances: array expected");
                                message.instances = [];
                                for (var i = 0; i < object.instances.length; ++i)
                                    message.instances[i] = String(object.instances[i]);
                            }
                            if (object.skipInstancesOnValidationError != null)
                                message.skipInstancesOnValidationError = Boolean(object.skipInstancesOnValidationError);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagersDeleteInstancesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest} message InstanceGroupManagersDeleteInstancesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagersDeleteInstancesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.instances = [];
                            if (message.instances && message.instances.length) {
                                object.instances = [];
                                for (var j = 0; j < message.instances.length; ++j)
                                    object.instances[j] = message.instances[j];
                            }
                            if (message.skipInstancesOnValidationError != null && message.hasOwnProperty("skipInstancesOnValidationError")) {
                                object.skipInstancesOnValidationError = message.skipInstancesOnValidationError;
                                if (options.oneofs)
                                    object._skipInstancesOnValidationError = "skipInstancesOnValidationError";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagersDeleteInstancesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagersDeleteInstancesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagersDeleteInstancesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagersDeleteInstancesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagersDeleteInstancesRequest";
                        };
    
                        return InstanceGroupManagersDeleteInstancesRequest;
                    })();
    
                    v1.InstanceGroupManagersDeletePerInstanceConfigsReq = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagersDeletePerInstanceConfigsReq.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagersDeletePerInstanceConfigsReq
                         * @property {Array.<string>|null} [names] InstanceGroupManagersDeletePerInstanceConfigsReq names
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagersDeletePerInstanceConfigsReq.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagersDeletePerInstanceConfigsReq.
                         * @implements IInstanceGroupManagersDeletePerInstanceConfigsReq
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersDeletePerInstanceConfigsReq=} [properties] Properties to set
                         */
                        function InstanceGroupManagersDeletePerInstanceConfigsReq(properties) {
                            this.names = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagersDeletePerInstanceConfigsReq names.
                         * @member {Array.<string>} names
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq
                         * @instance
                         */
                        InstanceGroupManagersDeletePerInstanceConfigsReq.prototype.names = $util.emptyArray;
    
                        /**
                         * Creates a new InstanceGroupManagersDeletePerInstanceConfigsReq instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersDeletePerInstanceConfigsReq=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq} InstanceGroupManagersDeletePerInstanceConfigsReq instance
                         */
                        InstanceGroupManagersDeletePerInstanceConfigsReq.create = function create(properties) {
                            return new InstanceGroupManagersDeletePerInstanceConfigsReq(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersDeletePerInstanceConfigsReq message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersDeletePerInstanceConfigsReq} message InstanceGroupManagersDeletePerInstanceConfigsReq message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersDeletePerInstanceConfigsReq.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.names != null && message.names.length)
                                for (var i = 0; i < message.names.length; ++i)
                                    writer.uint32(/* id 104585032, wireType 2 =*/836680258).string(message.names[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersDeletePerInstanceConfigsReq message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersDeletePerInstanceConfigsReq} message InstanceGroupManagersDeletePerInstanceConfigsReq message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersDeletePerInstanceConfigsReq.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersDeletePerInstanceConfigsReq message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq} InstanceGroupManagersDeletePerInstanceConfigsReq
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersDeletePerInstanceConfigsReq.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 104585032: {
                                        if (!(message.names && message.names.length))
                                            message.names = [];
                                        message.names.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersDeletePerInstanceConfigsReq message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq} InstanceGroupManagersDeletePerInstanceConfigsReq
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersDeletePerInstanceConfigsReq.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagersDeletePerInstanceConfigsReq message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagersDeletePerInstanceConfigsReq.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.names != null && message.hasOwnProperty("names")) {
                                if (!Array.isArray(message.names))
                                    return "names: array expected";
                                for (var i = 0; i < message.names.length; ++i)
                                    if (!$util.isString(message.names[i]))
                                        return "names: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagersDeletePerInstanceConfigsReq message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq} InstanceGroupManagersDeletePerInstanceConfigsReq
                         */
                        InstanceGroupManagersDeletePerInstanceConfigsReq.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq();
                            if (object.names) {
                                if (!Array.isArray(object.names))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq.names: array expected");
                                message.names = [];
                                for (var i = 0; i < object.names.length; ++i)
                                    message.names[i] = String(object.names[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagersDeletePerInstanceConfigsReq message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq} message InstanceGroupManagersDeletePerInstanceConfigsReq
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagersDeletePerInstanceConfigsReq.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.names = [];
                            if (message.names && message.names.length) {
                                object.names = [];
                                for (var j = 0; j < message.names.length; ++j)
                                    object.names[j] = message.names[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagersDeletePerInstanceConfigsReq to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagersDeletePerInstanceConfigsReq.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagersDeletePerInstanceConfigsReq
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagersDeletePerInstanceConfigsReq.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagersDeletePerInstanceConfigsReq";
                        };
    
                        return InstanceGroupManagersDeletePerInstanceConfigsReq;
                    })();
    
                    v1.InstanceGroupManagersListErrorsResponse = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagersListErrorsResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagersListErrorsResponse
                         * @property {Array.<google.cloud.compute.v1.IInstanceManagedByIgmError>|null} [items] InstanceGroupManagersListErrorsResponse items
                         * @property {string|null} [nextPageToken] InstanceGroupManagersListErrorsResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagersListErrorsResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagersListErrorsResponse.
                         * @implements IInstanceGroupManagersListErrorsResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersListErrorsResponse=} [properties] Properties to set
                         */
                        function InstanceGroupManagersListErrorsResponse(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagersListErrorsResponse items.
                         * @member {Array.<google.cloud.compute.v1.IInstanceManagedByIgmError>} items
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse
                         * @instance
                         */
                        InstanceGroupManagersListErrorsResponse.prototype.items = $util.emptyArray;
    
                        /**
                         * InstanceGroupManagersListErrorsResponse nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse
                         * @instance
                         */
                        InstanceGroupManagersListErrorsResponse.prototype.nextPageToken = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupManagersListErrorsResponse _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagersListErrorsResponse.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupManagersListErrorsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersListErrorsResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse} InstanceGroupManagersListErrorsResponse instance
                         */
                        InstanceGroupManagersListErrorsResponse.create = function create(properties) {
                            return new InstanceGroupManagersListErrorsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersListErrorsResponse message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersListErrorsResponse} message InstanceGroupManagersListErrorsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersListErrorsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.InstanceManagedByIgmError.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersListErrorsResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersListErrorsResponse} message InstanceGroupManagersListErrorsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersListErrorsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersListErrorsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse} InstanceGroupManagersListErrorsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersListErrorsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.InstanceManagedByIgmError.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersListErrorsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse} InstanceGroupManagersListErrorsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersListErrorsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagersListErrorsResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagersListErrorsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstanceManagedByIgmError.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagersListErrorsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse} InstanceGroupManagersListErrorsResponse
                         */
                        InstanceGroupManagersListErrorsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse();
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.InstanceManagedByIgmError.fromObject(object.items[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagersListErrorsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse} message InstanceGroupManagersListErrorsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagersListErrorsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.InstanceManagedByIgmError.toObject(message.items[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagersListErrorsResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagersListErrorsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagersListErrorsResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagersListErrorsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse";
                        };
    
                        return InstanceGroupManagersListErrorsResponse;
                    })();
    
                    v1.InstanceGroupManagersListManagedInstancesResponse = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagersListManagedInstancesResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagersListManagedInstancesResponse
                         * @property {Array.<google.cloud.compute.v1.IManagedInstance>|null} [managedInstances] InstanceGroupManagersListManagedInstancesResponse managedInstances
                         * @property {string|null} [nextPageToken] InstanceGroupManagersListManagedInstancesResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagersListManagedInstancesResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagersListManagedInstancesResponse.
                         * @implements IInstanceGroupManagersListManagedInstancesResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersListManagedInstancesResponse=} [properties] Properties to set
                         */
                        function InstanceGroupManagersListManagedInstancesResponse(properties) {
                            this.managedInstances = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagersListManagedInstancesResponse managedInstances.
                         * @member {Array.<google.cloud.compute.v1.IManagedInstance>} managedInstances
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse
                         * @instance
                         */
                        InstanceGroupManagersListManagedInstancesResponse.prototype.managedInstances = $util.emptyArray;
    
                        /**
                         * InstanceGroupManagersListManagedInstancesResponse nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse
                         * @instance
                         */
                        InstanceGroupManagersListManagedInstancesResponse.prototype.nextPageToken = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupManagersListManagedInstancesResponse _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagersListManagedInstancesResponse.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupManagersListManagedInstancesResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersListManagedInstancesResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse} InstanceGroupManagersListManagedInstancesResponse instance
                         */
                        InstanceGroupManagersListManagedInstancesResponse.create = function create(properties) {
                            return new InstanceGroupManagersListManagedInstancesResponse(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersListManagedInstancesResponse message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersListManagedInstancesResponse} message InstanceGroupManagersListManagedInstancesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersListManagedInstancesResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.managedInstances != null && message.managedInstances.length)
                                for (var i = 0; i < message.managedInstances.length; ++i)
                                    $root.google.cloud.compute.v1.ManagedInstance.encode(message.managedInstances[i], writer.uint32(/* id 336219614, wireType 2 =*/2689756914).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersListManagedInstancesResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersListManagedInstancesResponse} message InstanceGroupManagersListManagedInstancesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersListManagedInstancesResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersListManagedInstancesResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse} InstanceGroupManagersListManagedInstancesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersListManagedInstancesResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336219614: {
                                        if (!(message.managedInstances && message.managedInstances.length))
                                            message.managedInstances = [];
                                        message.managedInstances.push($root.google.cloud.compute.v1.ManagedInstance.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersListManagedInstancesResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse} InstanceGroupManagersListManagedInstancesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersListManagedInstancesResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagersListManagedInstancesResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagersListManagedInstancesResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.managedInstances != null && message.hasOwnProperty("managedInstances")) {
                                if (!Array.isArray(message.managedInstances))
                                    return "managedInstances: array expected";
                                for (var i = 0; i < message.managedInstances.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ManagedInstance.verify(message.managedInstances[i]);
                                    if (error)
                                        return "managedInstances." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagersListManagedInstancesResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse} InstanceGroupManagersListManagedInstancesResponse
                         */
                        InstanceGroupManagersListManagedInstancesResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse();
                            if (object.managedInstances) {
                                if (!Array.isArray(object.managedInstances))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse.managedInstances: array expected");
                                message.managedInstances = [];
                                for (var i = 0; i < object.managedInstances.length; ++i) {
                                    if (typeof object.managedInstances[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse.managedInstances: object expected");
                                    message.managedInstances[i] = $root.google.cloud.compute.v1.ManagedInstance.fromObject(object.managedInstances[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagersListManagedInstancesResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse} message InstanceGroupManagersListManagedInstancesResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagersListManagedInstancesResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.managedInstances = [];
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.managedInstances && message.managedInstances.length) {
                                object.managedInstances = [];
                                for (var j = 0; j < message.managedInstances.length; ++j)
                                    object.managedInstances[j] = $root.google.cloud.compute.v1.ManagedInstance.toObject(message.managedInstances[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagersListManagedInstancesResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagersListManagedInstancesResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagersListManagedInstancesResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagersListManagedInstancesResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse";
                        };
    
                        return InstanceGroupManagersListManagedInstancesResponse;
                    })();
    
                    v1.InstanceGroupManagersListPerInstanceConfigsResp = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagersListPerInstanceConfigsResp.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagersListPerInstanceConfigsResp
                         * @property {Array.<google.cloud.compute.v1.IPerInstanceConfig>|null} [items] InstanceGroupManagersListPerInstanceConfigsResp items
                         * @property {string|null} [nextPageToken] InstanceGroupManagersListPerInstanceConfigsResp nextPageToken
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] InstanceGroupManagersListPerInstanceConfigsResp warning
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagersListPerInstanceConfigsResp.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagersListPerInstanceConfigsResp.
                         * @implements IInstanceGroupManagersListPerInstanceConfigsResp
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersListPerInstanceConfigsResp=} [properties] Properties to set
                         */
                        function InstanceGroupManagersListPerInstanceConfigsResp(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagersListPerInstanceConfigsResp items.
                         * @member {Array.<google.cloud.compute.v1.IPerInstanceConfig>} items
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp
                         * @instance
                         */
                        InstanceGroupManagersListPerInstanceConfigsResp.prototype.items = $util.emptyArray;
    
                        /**
                         * InstanceGroupManagersListPerInstanceConfigsResp nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp
                         * @instance
                         */
                        InstanceGroupManagersListPerInstanceConfigsResp.prototype.nextPageToken = null;
    
                        /**
                         * InstanceGroupManagersListPerInstanceConfigsResp warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp
                         * @instance
                         */
                        InstanceGroupManagersListPerInstanceConfigsResp.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupManagersListPerInstanceConfigsResp _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagersListPerInstanceConfigsResp.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupManagersListPerInstanceConfigsResp _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagersListPerInstanceConfigsResp.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupManagersListPerInstanceConfigsResp instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersListPerInstanceConfigsResp=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp} InstanceGroupManagersListPerInstanceConfigsResp instance
                         */
                        InstanceGroupManagersListPerInstanceConfigsResp.create = function create(properties) {
                            return new InstanceGroupManagersListPerInstanceConfigsResp(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersListPerInstanceConfigsResp message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersListPerInstanceConfigsResp} message InstanceGroupManagersListPerInstanceConfigsResp message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersListPerInstanceConfigsResp.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.PerInstanceConfig.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersListPerInstanceConfigsResp message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersListPerInstanceConfigsResp} message InstanceGroupManagersListPerInstanceConfigsResp message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersListPerInstanceConfigsResp.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersListPerInstanceConfigsResp message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp} InstanceGroupManagersListPerInstanceConfigsResp
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersListPerInstanceConfigsResp.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.PerInstanceConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersListPerInstanceConfigsResp message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp} InstanceGroupManagersListPerInstanceConfigsResp
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersListPerInstanceConfigsResp.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagersListPerInstanceConfigsResp message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagersListPerInstanceConfigsResp.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PerInstanceConfig.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagersListPerInstanceConfigsResp message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp} InstanceGroupManagersListPerInstanceConfigsResp
                         */
                        InstanceGroupManagersListPerInstanceConfigsResp.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp();
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.PerInstanceConfig.fromObject(object.items[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagersListPerInstanceConfigsResp message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp} message InstanceGroupManagersListPerInstanceConfigsResp
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagersListPerInstanceConfigsResp.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.PerInstanceConfig.toObject(message.items[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagersListPerInstanceConfigsResp to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagersListPerInstanceConfigsResp.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagersListPerInstanceConfigsResp
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagersListPerInstanceConfigsResp.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp";
                        };
    
                        return InstanceGroupManagersListPerInstanceConfigsResp;
                    })();
    
                    v1.InstanceGroupManagersPatchPerInstanceConfigsReq = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagersPatchPerInstanceConfigsReq.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagersPatchPerInstanceConfigsReq
                         * @property {Array.<google.cloud.compute.v1.IPerInstanceConfig>|null} [perInstanceConfigs] InstanceGroupManagersPatchPerInstanceConfigsReq perInstanceConfigs
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagersPatchPerInstanceConfigsReq.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagersPatchPerInstanceConfigsReq.
                         * @implements IInstanceGroupManagersPatchPerInstanceConfigsReq
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersPatchPerInstanceConfigsReq=} [properties] Properties to set
                         */
                        function InstanceGroupManagersPatchPerInstanceConfigsReq(properties) {
                            this.perInstanceConfigs = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagersPatchPerInstanceConfigsReq perInstanceConfigs.
                         * @member {Array.<google.cloud.compute.v1.IPerInstanceConfig>} perInstanceConfigs
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq
                         * @instance
                         */
                        InstanceGroupManagersPatchPerInstanceConfigsReq.prototype.perInstanceConfigs = $util.emptyArray;
    
                        /**
                         * Creates a new InstanceGroupManagersPatchPerInstanceConfigsReq instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersPatchPerInstanceConfigsReq=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq} InstanceGroupManagersPatchPerInstanceConfigsReq instance
                         */
                        InstanceGroupManagersPatchPerInstanceConfigsReq.create = function create(properties) {
                            return new InstanceGroupManagersPatchPerInstanceConfigsReq(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersPatchPerInstanceConfigsReq message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersPatchPerInstanceConfigsReq} message InstanceGroupManagersPatchPerInstanceConfigsReq message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersPatchPerInstanceConfigsReq.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.perInstanceConfigs != null && message.perInstanceConfigs.length)
                                for (var i = 0; i < message.perInstanceConfigs.length; ++i)
                                    $root.google.cloud.compute.v1.PerInstanceConfig.encode(message.perInstanceConfigs[i], writer.uint32(/* id 526265001, wireType 2 =*/4210120010).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersPatchPerInstanceConfigsReq message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersPatchPerInstanceConfigsReq} message InstanceGroupManagersPatchPerInstanceConfigsReq message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersPatchPerInstanceConfigsReq.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersPatchPerInstanceConfigsReq message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq} InstanceGroupManagersPatchPerInstanceConfigsReq
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersPatchPerInstanceConfigsReq.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 526265001: {
                                        if (!(message.perInstanceConfigs && message.perInstanceConfigs.length))
                                            message.perInstanceConfigs = [];
                                        message.perInstanceConfigs.push($root.google.cloud.compute.v1.PerInstanceConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersPatchPerInstanceConfigsReq message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq} InstanceGroupManagersPatchPerInstanceConfigsReq
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersPatchPerInstanceConfigsReq.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagersPatchPerInstanceConfigsReq message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagersPatchPerInstanceConfigsReq.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.perInstanceConfigs != null && message.hasOwnProperty("perInstanceConfigs")) {
                                if (!Array.isArray(message.perInstanceConfigs))
                                    return "perInstanceConfigs: array expected";
                                for (var i = 0; i < message.perInstanceConfigs.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PerInstanceConfig.verify(message.perInstanceConfigs[i]);
                                    if (error)
                                        return "perInstanceConfigs." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagersPatchPerInstanceConfigsReq message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq} InstanceGroupManagersPatchPerInstanceConfigsReq
                         */
                        InstanceGroupManagersPatchPerInstanceConfigsReq.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq();
                            if (object.perInstanceConfigs) {
                                if (!Array.isArray(object.perInstanceConfigs))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq.perInstanceConfigs: array expected");
                                message.perInstanceConfigs = [];
                                for (var i = 0; i < object.perInstanceConfigs.length; ++i) {
                                    if (typeof object.perInstanceConfigs[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq.perInstanceConfigs: object expected");
                                    message.perInstanceConfigs[i] = $root.google.cloud.compute.v1.PerInstanceConfig.fromObject(object.perInstanceConfigs[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagersPatchPerInstanceConfigsReq message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq} message InstanceGroupManagersPatchPerInstanceConfigsReq
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagersPatchPerInstanceConfigsReq.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.perInstanceConfigs = [];
                            if (message.perInstanceConfigs && message.perInstanceConfigs.length) {
                                object.perInstanceConfigs = [];
                                for (var j = 0; j < message.perInstanceConfigs.length; ++j)
                                    object.perInstanceConfigs[j] = $root.google.cloud.compute.v1.PerInstanceConfig.toObject(message.perInstanceConfigs[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagersPatchPerInstanceConfigsReq to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagersPatchPerInstanceConfigsReq.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagersPatchPerInstanceConfigsReq
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagersPatchPerInstanceConfigsReq.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq";
                        };
    
                        return InstanceGroupManagersPatchPerInstanceConfigsReq;
                    })();
    
                    v1.InstanceGroupManagersRecreateInstancesRequest = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagersRecreateInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagersRecreateInstancesRequest
                         * @property {Array.<string>|null} [instances] InstanceGroupManagersRecreateInstancesRequest instances
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagersRecreateInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagersRecreateInstancesRequest.
                         * @implements IInstanceGroupManagersRecreateInstancesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersRecreateInstancesRequest=} [properties] Properties to set
                         */
                        function InstanceGroupManagersRecreateInstancesRequest(properties) {
                            this.instances = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagersRecreateInstancesRequest instances.
                         * @member {Array.<string>} instances
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest
                         * @instance
                         */
                        InstanceGroupManagersRecreateInstancesRequest.prototype.instances = $util.emptyArray;
    
                        /**
                         * Creates a new InstanceGroupManagersRecreateInstancesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersRecreateInstancesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest} InstanceGroupManagersRecreateInstancesRequest instance
                         */
                        InstanceGroupManagersRecreateInstancesRequest.create = function create(properties) {
                            return new InstanceGroupManagersRecreateInstancesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersRecreateInstancesRequest message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersRecreateInstancesRequest} message InstanceGroupManagersRecreateInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersRecreateInstancesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instances != null && message.instances.length)
                                for (var i = 0; i < message.instances.length; ++i)
                                    writer.uint32(/* id 29097598, wireType 2 =*/232780786).string(message.instances[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersRecreateInstancesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersRecreateInstancesRequest} message InstanceGroupManagersRecreateInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersRecreateInstancesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersRecreateInstancesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest} InstanceGroupManagersRecreateInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersRecreateInstancesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 29097598: {
                                        if (!(message.instances && message.instances.length))
                                            message.instances = [];
                                        message.instances.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersRecreateInstancesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest} InstanceGroupManagersRecreateInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersRecreateInstancesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagersRecreateInstancesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagersRecreateInstancesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instances != null && message.hasOwnProperty("instances")) {
                                if (!Array.isArray(message.instances))
                                    return "instances: array expected";
                                for (var i = 0; i < message.instances.length; ++i)
                                    if (!$util.isString(message.instances[i]))
                                        return "instances: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagersRecreateInstancesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest} InstanceGroupManagersRecreateInstancesRequest
                         */
                        InstanceGroupManagersRecreateInstancesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest();
                            if (object.instances) {
                                if (!Array.isArray(object.instances))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest.instances: array expected");
                                message.instances = [];
                                for (var i = 0; i < object.instances.length; ++i)
                                    message.instances[i] = String(object.instances[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagersRecreateInstancesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest} message InstanceGroupManagersRecreateInstancesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagersRecreateInstancesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.instances = [];
                            if (message.instances && message.instances.length) {
                                object.instances = [];
                                for (var j = 0; j < message.instances.length; ++j)
                                    object.instances[j] = message.instances[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagersRecreateInstancesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagersRecreateInstancesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagersRecreateInstancesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagersRecreateInstancesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest";
                        };
    
                        return InstanceGroupManagersRecreateInstancesRequest;
                    })();
    
                    v1.InstanceGroupManagersScopedList = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagersScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagersScopedList
                         * @property {Array.<google.cloud.compute.v1.IInstanceGroupManager>|null} [instanceGroupManagers] InstanceGroupManagersScopedList instanceGroupManagers
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] InstanceGroupManagersScopedList warning
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagersScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagersScopedList.
                         * @implements IInstanceGroupManagersScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersScopedList=} [properties] Properties to set
                         */
                        function InstanceGroupManagersScopedList(properties) {
                            this.instanceGroupManagers = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagersScopedList instanceGroupManagers.
                         * @member {Array.<google.cloud.compute.v1.IInstanceGroupManager>} instanceGroupManagers
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersScopedList
                         * @instance
                         */
                        InstanceGroupManagersScopedList.prototype.instanceGroupManagers = $util.emptyArray;
    
                        /**
                         * InstanceGroupManagersScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersScopedList
                         * @instance
                         */
                        InstanceGroupManagersScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupManagersScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersScopedList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagersScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupManagersScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersScopedList} InstanceGroupManagersScopedList instance
                         */
                        InstanceGroupManagersScopedList.create = function create(properties) {
                            return new InstanceGroupManagersScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersScopedList message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersScopedList} message InstanceGroupManagersScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.instanceGroupManagers != null && message.instanceGroupManagers.length)
                                for (var i = 0; i < message.instanceGroupManagers.length; ++i)
                                    $root.google.cloud.compute.v1.InstanceGroupManager.encode(message.instanceGroupManagers[i], writer.uint32(/* id 214072592, wireType 2 =*/1712580738).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersScopedList} message InstanceGroupManagersScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersScopedList} InstanceGroupManagersScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagersScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 214072592: {
                                        if (!(message.instanceGroupManagers && message.instanceGroupManagers.length))
                                            message.instanceGroupManagers = [];
                                        message.instanceGroupManagers.push($root.google.cloud.compute.v1.InstanceGroupManager.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersScopedList} InstanceGroupManagersScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagersScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagersScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManagers != null && message.hasOwnProperty("instanceGroupManagers")) {
                                if (!Array.isArray(message.instanceGroupManagers))
                                    return "instanceGroupManagers: array expected";
                                for (var i = 0; i < message.instanceGroupManagers.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstanceGroupManager.verify(message.instanceGroupManagers[i]);
                                    if (error)
                                        return "instanceGroupManagers." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagersScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersScopedList} InstanceGroupManagersScopedList
                         */
                        InstanceGroupManagersScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagersScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagersScopedList();
                            if (object.instanceGroupManagers) {
                                if (!Array.isArray(object.instanceGroupManagers))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersScopedList.instanceGroupManagers: array expected");
                                message.instanceGroupManagers = [];
                                for (var i = 0; i < object.instanceGroupManagers.length; ++i) {
                                    if (typeof object.instanceGroupManagers[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersScopedList.instanceGroupManagers: object expected");
                                    message.instanceGroupManagers[i] = $root.google.cloud.compute.v1.InstanceGroupManager.fromObject(object.instanceGroupManagers[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagersScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersScopedList
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagersScopedList} message InstanceGroupManagersScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagersScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.instanceGroupManagers = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.instanceGroupManagers && message.instanceGroupManagers.length) {
                                object.instanceGroupManagers = [];
                                for (var j = 0; j < message.instanceGroupManagers.length; ++j)
                                    object.instanceGroupManagers[j] = $root.google.cloud.compute.v1.InstanceGroupManager.toObject(message.instanceGroupManagers[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagersScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagersScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagersScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagersScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagersScopedList";
                        };
    
                        return InstanceGroupManagersScopedList;
                    })();
    
                    v1.InstanceGroupManagersSetInstanceTemplateRequest = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagersSetInstanceTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagersSetInstanceTemplateRequest
                         * @property {string|null} [instanceTemplate] InstanceGroupManagersSetInstanceTemplateRequest instanceTemplate
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagersSetInstanceTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagersSetInstanceTemplateRequest.
                         * @implements IInstanceGroupManagersSetInstanceTemplateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersSetInstanceTemplateRequest=} [properties] Properties to set
                         */
                        function InstanceGroupManagersSetInstanceTemplateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagersSetInstanceTemplateRequest instanceTemplate.
                         * @member {string|null|undefined} instanceTemplate
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest
                         * @instance
                         */
                        InstanceGroupManagersSetInstanceTemplateRequest.prototype.instanceTemplate = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupManagersSetInstanceTemplateRequest _instanceTemplate.
                         * @member {"instanceTemplate"|undefined} _instanceTemplate
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagersSetInstanceTemplateRequest.prototype, "_instanceTemplate", {
                            get: $util.oneOfGetter($oneOfFields = ["instanceTemplate"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupManagersSetInstanceTemplateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersSetInstanceTemplateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest} InstanceGroupManagersSetInstanceTemplateRequest instance
                         */
                        InstanceGroupManagersSetInstanceTemplateRequest.create = function create(properties) {
                            return new InstanceGroupManagersSetInstanceTemplateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersSetInstanceTemplateRequest message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersSetInstanceTemplateRequest} message InstanceGroupManagersSetInstanceTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersSetInstanceTemplateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instanceTemplate != null && Object.hasOwnProperty.call(message, "instanceTemplate"))
                                writer.uint32(/* id 309248228, wireType 2 =*/2473985826).string(message.instanceTemplate);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersSetInstanceTemplateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersSetInstanceTemplateRequest} message InstanceGroupManagersSetInstanceTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersSetInstanceTemplateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersSetInstanceTemplateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest} InstanceGroupManagersSetInstanceTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersSetInstanceTemplateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 309248228: {
                                        message.instanceTemplate = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersSetInstanceTemplateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest} InstanceGroupManagersSetInstanceTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersSetInstanceTemplateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagersSetInstanceTemplateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagersSetInstanceTemplateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceTemplate != null && message.hasOwnProperty("instanceTemplate")) {
                                properties._instanceTemplate = 1;
                                if (!$util.isString(message.instanceTemplate))
                                    return "instanceTemplate: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagersSetInstanceTemplateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest} InstanceGroupManagersSetInstanceTemplateRequest
                         */
                        InstanceGroupManagersSetInstanceTemplateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest();
                            if (object.instanceTemplate != null)
                                message.instanceTemplate = String(object.instanceTemplate);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagersSetInstanceTemplateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest} message InstanceGroupManagersSetInstanceTemplateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagersSetInstanceTemplateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.instanceTemplate != null && message.hasOwnProperty("instanceTemplate")) {
                                object.instanceTemplate = message.instanceTemplate;
                                if (options.oneofs)
                                    object._instanceTemplate = "instanceTemplate";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagersSetInstanceTemplateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagersSetInstanceTemplateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagersSetInstanceTemplateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagersSetInstanceTemplateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest";
                        };
    
                        return InstanceGroupManagersSetInstanceTemplateRequest;
                    })();
    
                    v1.InstanceGroupManagersSetTargetPoolsRequest = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagersSetTargetPoolsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagersSetTargetPoolsRequest
                         * @property {string|null} [fingerprint] InstanceGroupManagersSetTargetPoolsRequest fingerprint
                         * @property {Array.<string>|null} [targetPools] InstanceGroupManagersSetTargetPoolsRequest targetPools
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagersSetTargetPoolsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagersSetTargetPoolsRequest.
                         * @implements IInstanceGroupManagersSetTargetPoolsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersSetTargetPoolsRequest=} [properties] Properties to set
                         */
                        function InstanceGroupManagersSetTargetPoolsRequest(properties) {
                            this.targetPools = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagersSetTargetPoolsRequest fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest
                         * @instance
                         */
                        InstanceGroupManagersSetTargetPoolsRequest.prototype.fingerprint = null;
    
                        /**
                         * InstanceGroupManagersSetTargetPoolsRequest targetPools.
                         * @member {Array.<string>} targetPools
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest
                         * @instance
                         */
                        InstanceGroupManagersSetTargetPoolsRequest.prototype.targetPools = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupManagersSetTargetPoolsRequest _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupManagersSetTargetPoolsRequest.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupManagersSetTargetPoolsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersSetTargetPoolsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest} InstanceGroupManagersSetTargetPoolsRequest instance
                         */
                        InstanceGroupManagersSetTargetPoolsRequest.create = function create(properties) {
                            return new InstanceGroupManagersSetTargetPoolsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersSetTargetPoolsRequest message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersSetTargetPoolsRequest} message InstanceGroupManagersSetTargetPoolsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersSetTargetPoolsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.targetPools != null && message.targetPools.length)
                                for (var i = 0; i < message.targetPools.length; ++i)
                                    writer.uint32(/* id 336072617, wireType 2 =*/2688580938).string(message.targetPools[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersSetTargetPoolsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersSetTargetPoolsRequest} message InstanceGroupManagersSetTargetPoolsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersSetTargetPoolsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersSetTargetPoolsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest} InstanceGroupManagersSetTargetPoolsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersSetTargetPoolsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 336072617: {
                                        if (!(message.targetPools && message.targetPools.length))
                                            message.targetPools = [];
                                        message.targetPools.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersSetTargetPoolsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest} InstanceGroupManagersSetTargetPoolsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersSetTargetPoolsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagersSetTargetPoolsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagersSetTargetPoolsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.targetPools != null && message.hasOwnProperty("targetPools")) {
                                if (!Array.isArray(message.targetPools))
                                    return "targetPools: array expected";
                                for (var i = 0; i < message.targetPools.length; ++i)
                                    if (!$util.isString(message.targetPools[i]))
                                        return "targetPools: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagersSetTargetPoolsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest} InstanceGroupManagersSetTargetPoolsRequest
                         */
                        InstanceGroupManagersSetTargetPoolsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest();
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.targetPools) {
                                if (!Array.isArray(object.targetPools))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest.targetPools: array expected");
                                message.targetPools = [];
                                for (var i = 0; i < object.targetPools.length; ++i)
                                    message.targetPools[i] = String(object.targetPools[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagersSetTargetPoolsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest} message InstanceGroupManagersSetTargetPoolsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagersSetTargetPoolsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.targetPools = [];
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.targetPools && message.targetPools.length) {
                                object.targetPools = [];
                                for (var j = 0; j < message.targetPools.length; ++j)
                                    object.targetPools[j] = message.targetPools[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagersSetTargetPoolsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagersSetTargetPoolsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagersSetTargetPoolsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagersSetTargetPoolsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest";
                        };
    
                        return InstanceGroupManagersSetTargetPoolsRequest;
                    })();
    
                    v1.InstanceGroupManagersUpdatePerInstanceConfigsReq = (function() {
    
                        /**
                         * Properties of an InstanceGroupManagersUpdatePerInstanceConfigsReq.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupManagersUpdatePerInstanceConfigsReq
                         * @property {Array.<google.cloud.compute.v1.IPerInstanceConfig>|null} [perInstanceConfigs] InstanceGroupManagersUpdatePerInstanceConfigsReq perInstanceConfigs
                         */
    
                        /**
                         * Constructs a new InstanceGroupManagersUpdatePerInstanceConfigsReq.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagersUpdatePerInstanceConfigsReq.
                         * @implements IInstanceGroupManagersUpdatePerInstanceConfigsReq
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersUpdatePerInstanceConfigsReq=} [properties] Properties to set
                         */
                        function InstanceGroupManagersUpdatePerInstanceConfigsReq(properties) {
                            this.perInstanceConfigs = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupManagersUpdatePerInstanceConfigsReq perInstanceConfigs.
                         * @member {Array.<google.cloud.compute.v1.IPerInstanceConfig>} perInstanceConfigs
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq
                         * @instance
                         */
                        InstanceGroupManagersUpdatePerInstanceConfigsReq.prototype.perInstanceConfigs = $util.emptyArray;
    
                        /**
                         * Creates a new InstanceGroupManagersUpdatePerInstanceConfigsReq instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersUpdatePerInstanceConfigsReq=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq} InstanceGroupManagersUpdatePerInstanceConfigsReq instance
                         */
                        InstanceGroupManagersUpdatePerInstanceConfigsReq.create = function create(properties) {
                            return new InstanceGroupManagersUpdatePerInstanceConfigsReq(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersUpdatePerInstanceConfigsReq message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersUpdatePerInstanceConfigsReq} message InstanceGroupManagersUpdatePerInstanceConfigsReq message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersUpdatePerInstanceConfigsReq.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.perInstanceConfigs != null && message.perInstanceConfigs.length)
                                for (var i = 0; i < message.perInstanceConfigs.length; ++i)
                                    $root.google.cloud.compute.v1.PerInstanceConfig.encode(message.perInstanceConfigs[i], writer.uint32(/* id 526265001, wireType 2 =*/4210120010).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupManagersUpdatePerInstanceConfigsReq message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupManagersUpdatePerInstanceConfigsReq} message InstanceGroupManagersUpdatePerInstanceConfigsReq message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupManagersUpdatePerInstanceConfigsReq.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersUpdatePerInstanceConfigsReq message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq} InstanceGroupManagersUpdatePerInstanceConfigsReq
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersUpdatePerInstanceConfigsReq.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 526265001: {
                                        if (!(message.perInstanceConfigs && message.perInstanceConfigs.length))
                                            message.perInstanceConfigs = [];
                                        message.perInstanceConfigs.push($root.google.cloud.compute.v1.PerInstanceConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupManagersUpdatePerInstanceConfigsReq message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq} InstanceGroupManagersUpdatePerInstanceConfigsReq
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupManagersUpdatePerInstanceConfigsReq.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupManagersUpdatePerInstanceConfigsReq message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupManagersUpdatePerInstanceConfigsReq.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.perInstanceConfigs != null && message.hasOwnProperty("perInstanceConfigs")) {
                                if (!Array.isArray(message.perInstanceConfigs))
                                    return "perInstanceConfigs: array expected";
                                for (var i = 0; i < message.perInstanceConfigs.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PerInstanceConfig.verify(message.perInstanceConfigs[i]);
                                    if (error)
                                        return "perInstanceConfigs." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupManagersUpdatePerInstanceConfigsReq message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq} InstanceGroupManagersUpdatePerInstanceConfigsReq
                         */
                        InstanceGroupManagersUpdatePerInstanceConfigsReq.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq();
                            if (object.perInstanceConfigs) {
                                if (!Array.isArray(object.perInstanceConfigs))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq.perInstanceConfigs: array expected");
                                message.perInstanceConfigs = [];
                                for (var i = 0; i < object.perInstanceConfigs.length; ++i) {
                                    if (typeof object.perInstanceConfigs[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq.perInstanceConfigs: object expected");
                                    message.perInstanceConfigs[i] = $root.google.cloud.compute.v1.PerInstanceConfig.fromObject(object.perInstanceConfigs[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupManagersUpdatePerInstanceConfigsReq message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq} message InstanceGroupManagersUpdatePerInstanceConfigsReq
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupManagersUpdatePerInstanceConfigsReq.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.perInstanceConfigs = [];
                            if (message.perInstanceConfigs && message.perInstanceConfigs.length) {
                                object.perInstanceConfigs = [];
                                for (var j = 0; j < message.perInstanceConfigs.length; ++j)
                                    object.perInstanceConfigs[j] = $root.google.cloud.compute.v1.PerInstanceConfig.toObject(message.perInstanceConfigs[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupManagersUpdatePerInstanceConfigsReq to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupManagersUpdatePerInstanceConfigsReq.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupManagersUpdatePerInstanceConfigsReq
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupManagersUpdatePerInstanceConfigsReq.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq";
                        };
    
                        return InstanceGroupManagersUpdatePerInstanceConfigsReq;
                    })();
    
                    v1.InstanceGroupsAddInstancesRequest = (function() {
    
                        /**
                         * Properties of an InstanceGroupsAddInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupsAddInstancesRequest
                         * @property {Array.<google.cloud.compute.v1.IInstanceReference>|null} [instances] InstanceGroupsAddInstancesRequest instances
                         */
    
                        /**
                         * Constructs a new InstanceGroupsAddInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupsAddInstancesRequest.
                         * @implements IInstanceGroupsAddInstancesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupsAddInstancesRequest=} [properties] Properties to set
                         */
                        function InstanceGroupsAddInstancesRequest(properties) {
                            this.instances = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupsAddInstancesRequest instances.
                         * @member {Array.<google.cloud.compute.v1.IInstanceReference>} instances
                         * @memberof google.cloud.compute.v1.InstanceGroupsAddInstancesRequest
                         * @instance
                         */
                        InstanceGroupsAddInstancesRequest.prototype.instances = $util.emptyArray;
    
                        /**
                         * Creates a new InstanceGroupsAddInstancesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupsAddInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupsAddInstancesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupsAddInstancesRequest} InstanceGroupsAddInstancesRequest instance
                         */
                        InstanceGroupsAddInstancesRequest.create = function create(properties) {
                            return new InstanceGroupsAddInstancesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupsAddInstancesRequest message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupsAddInstancesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupsAddInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupsAddInstancesRequest} message InstanceGroupsAddInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupsAddInstancesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instances != null && message.instances.length)
                                for (var i = 0; i < message.instances.length; ++i)
                                    $root.google.cloud.compute.v1.InstanceReference.encode(message.instances[i], writer.uint32(/* id 29097598, wireType 2 =*/232780786).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupsAddInstancesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupsAddInstancesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupsAddInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupsAddInstancesRequest} message InstanceGroupsAddInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupsAddInstancesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupsAddInstancesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupsAddInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupsAddInstancesRequest} InstanceGroupsAddInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupsAddInstancesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupsAddInstancesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 29097598: {
                                        if (!(message.instances && message.instances.length))
                                            message.instances = [];
                                        message.instances.push($root.google.cloud.compute.v1.InstanceReference.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupsAddInstancesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupsAddInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupsAddInstancesRequest} InstanceGroupsAddInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupsAddInstancesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupsAddInstancesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupsAddInstancesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupsAddInstancesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instances != null && message.hasOwnProperty("instances")) {
                                if (!Array.isArray(message.instances))
                                    return "instances: array expected";
                                for (var i = 0; i < message.instances.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstanceReference.verify(message.instances[i]);
                                    if (error)
                                        return "instances." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupsAddInstancesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupsAddInstancesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupsAddInstancesRequest} InstanceGroupsAddInstancesRequest
                         */
                        InstanceGroupsAddInstancesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupsAddInstancesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupsAddInstancesRequest();
                            if (object.instances) {
                                if (!Array.isArray(object.instances))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupsAddInstancesRequest.instances: array expected");
                                message.instances = [];
                                for (var i = 0; i < object.instances.length; ++i) {
                                    if (typeof object.instances[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceGroupsAddInstancesRequest.instances: object expected");
                                    message.instances[i] = $root.google.cloud.compute.v1.InstanceReference.fromObject(object.instances[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupsAddInstancesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupsAddInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupsAddInstancesRequest} message InstanceGroupsAddInstancesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupsAddInstancesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.instances = [];
                            if (message.instances && message.instances.length) {
                                object.instances = [];
                                for (var j = 0; j < message.instances.length; ++j)
                                    object.instances[j] = $root.google.cloud.compute.v1.InstanceReference.toObject(message.instances[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupsAddInstancesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupsAddInstancesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupsAddInstancesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupsAddInstancesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupsAddInstancesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupsAddInstancesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupsAddInstancesRequest";
                        };
    
                        return InstanceGroupsAddInstancesRequest;
                    })();
    
                    v1.InstanceGroupsListInstances = (function() {
    
                        /**
                         * Properties of an InstanceGroupsListInstances.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupsListInstances
                         * @property {string|null} [id] InstanceGroupsListInstances id
                         * @property {Array.<google.cloud.compute.v1.IInstanceWithNamedPorts>|null} [items] InstanceGroupsListInstances items
                         * @property {string|null} [kind] InstanceGroupsListInstances kind
                         * @property {string|null} [nextPageToken] InstanceGroupsListInstances nextPageToken
                         * @property {string|null} [selfLink] InstanceGroupsListInstances selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] InstanceGroupsListInstances warning
                         */
    
                        /**
                         * Constructs a new InstanceGroupsListInstances.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupsListInstances.
                         * @implements IInstanceGroupsListInstances
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupsListInstances=} [properties] Properties to set
                         */
                        function InstanceGroupsListInstances(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupsListInstances id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @instance
                         */
                        InstanceGroupsListInstances.prototype.id = null;
    
                        /**
                         * InstanceGroupsListInstances items.
                         * @member {Array.<google.cloud.compute.v1.IInstanceWithNamedPorts>} items
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @instance
                         */
                        InstanceGroupsListInstances.prototype.items = $util.emptyArray;
    
                        /**
                         * InstanceGroupsListInstances kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @instance
                         */
                        InstanceGroupsListInstances.prototype.kind = null;
    
                        /**
                         * InstanceGroupsListInstances nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @instance
                         */
                        InstanceGroupsListInstances.prototype.nextPageToken = null;
    
                        /**
                         * InstanceGroupsListInstances selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @instance
                         */
                        InstanceGroupsListInstances.prototype.selfLink = null;
    
                        /**
                         * InstanceGroupsListInstances warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @instance
                         */
                        InstanceGroupsListInstances.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupsListInstances _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupsListInstances.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupsListInstances _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupsListInstances.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupsListInstances _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupsListInstances.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupsListInstances _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupsListInstances.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceGroupsListInstances _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupsListInstances.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupsListInstances instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupsListInstances=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupsListInstances} InstanceGroupsListInstances instance
                         */
                        InstanceGroupsListInstances.create = function create(properties) {
                            return new InstanceGroupsListInstances(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupsListInstances message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupsListInstances.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupsListInstances} message InstanceGroupsListInstances message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupsListInstances.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.InstanceWithNamedPorts.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupsListInstances message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupsListInstances.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupsListInstances} message InstanceGroupsListInstances message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupsListInstances.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupsListInstances message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupsListInstances} InstanceGroupsListInstances
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupsListInstances.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupsListInstances();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.InstanceWithNamedPorts.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupsListInstances message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupsListInstances} InstanceGroupsListInstances
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupsListInstances.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupsListInstances message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupsListInstances.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstanceWithNamedPorts.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupsListInstances message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupsListInstances} InstanceGroupsListInstances
                         */
                        InstanceGroupsListInstances.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupsListInstances)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupsListInstances();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupsListInstances.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceGroupsListInstances.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.InstanceWithNamedPorts.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupsListInstances.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupsListInstances message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupsListInstances} message InstanceGroupsListInstances
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupsListInstances.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.InstanceWithNamedPorts.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupsListInstances to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupsListInstances.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupsListInstances
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstances
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupsListInstances.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupsListInstances";
                        };
    
                        return InstanceGroupsListInstances;
                    })();
    
                    v1.InstanceGroupsListInstancesRequest = (function() {
    
                        /**
                         * Properties of an InstanceGroupsListInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupsListInstancesRequest
                         * @property {string|null} [instanceState] InstanceGroupsListInstancesRequest instanceState
                         */
    
                        /**
                         * Constructs a new InstanceGroupsListInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupsListInstancesRequest.
                         * @implements IInstanceGroupsListInstancesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupsListInstancesRequest=} [properties] Properties to set
                         */
                        function InstanceGroupsListInstancesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupsListInstancesRequest instanceState.
                         * @member {string|null|undefined} instanceState
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstancesRequest
                         * @instance
                         */
                        InstanceGroupsListInstancesRequest.prototype.instanceState = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupsListInstancesRequest _instanceState.
                         * @member {"instanceState"|undefined} _instanceState
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupsListInstancesRequest.prototype, "_instanceState", {
                            get: $util.oneOfGetter($oneOfFields = ["instanceState"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupsListInstancesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupsListInstancesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupsListInstancesRequest} InstanceGroupsListInstancesRequest instance
                         */
                        InstanceGroupsListInstancesRequest.create = function create(properties) {
                            return new InstanceGroupsListInstancesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupsListInstancesRequest message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupsListInstancesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupsListInstancesRequest} message InstanceGroupsListInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupsListInstancesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instanceState != null && Object.hasOwnProperty.call(message, "instanceState"))
                                writer.uint32(/* id 92223591, wireType 2 =*/737788730).string(message.instanceState);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupsListInstancesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupsListInstancesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupsListInstancesRequest} message InstanceGroupsListInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupsListInstancesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupsListInstancesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupsListInstancesRequest} InstanceGroupsListInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupsListInstancesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupsListInstancesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 92223591: {
                                        message.instanceState = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupsListInstancesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupsListInstancesRequest} InstanceGroupsListInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupsListInstancesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupsListInstancesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstancesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupsListInstancesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceState != null && message.hasOwnProperty("instanceState")) {
                                properties._instanceState = 1;
                                if (!$util.isString(message.instanceState))
                                    return "instanceState: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupsListInstancesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstancesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupsListInstancesRequest} InstanceGroupsListInstancesRequest
                         */
                        InstanceGroupsListInstancesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupsListInstancesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupsListInstancesRequest();
                            if (object.instanceState != null)
                                message.instanceState = String(object.instanceState);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupsListInstancesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupsListInstancesRequest} message InstanceGroupsListInstancesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupsListInstancesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.instanceState != null && message.hasOwnProperty("instanceState")) {
                                object.instanceState = message.instanceState;
                                if (options.oneofs)
                                    object._instanceState = "instanceState";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupsListInstancesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstancesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupsListInstancesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupsListInstancesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupsListInstancesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupsListInstancesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupsListInstancesRequest";
                        };
    
                        /**
                         * InstanceState enum.
                         * @name google.cloud.compute.v1.InstanceGroupsListInstancesRequest.InstanceState
                         * @enum {number}
                         * @property {number} UNDEFINED_INSTANCE_STATE=0 UNDEFINED_INSTANCE_STATE value
                         * @property {number} ALL=64897 ALL value
                         * @property {number} RUNNING=121282975 RUNNING value
                         */
                        InstanceGroupsListInstancesRequest.InstanceState = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_INSTANCE_STATE"] = 0;
                            values[valuesById[64897] = "ALL"] = 64897;
                            values[valuesById[121282975] = "RUNNING"] = 121282975;
                            return values;
                        })();
    
                        return InstanceGroupsListInstancesRequest;
                    })();
    
                    v1.InstanceGroupsRemoveInstancesRequest = (function() {
    
                        /**
                         * Properties of an InstanceGroupsRemoveInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupsRemoveInstancesRequest
                         * @property {Array.<google.cloud.compute.v1.IInstanceReference>|null} [instances] InstanceGroupsRemoveInstancesRequest instances
                         */
    
                        /**
                         * Constructs a new InstanceGroupsRemoveInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupsRemoveInstancesRequest.
                         * @implements IInstanceGroupsRemoveInstancesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupsRemoveInstancesRequest=} [properties] Properties to set
                         */
                        function InstanceGroupsRemoveInstancesRequest(properties) {
                            this.instances = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupsRemoveInstancesRequest instances.
                         * @member {Array.<google.cloud.compute.v1.IInstanceReference>} instances
                         * @memberof google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest
                         * @instance
                         */
                        InstanceGroupsRemoveInstancesRequest.prototype.instances = $util.emptyArray;
    
                        /**
                         * Creates a new InstanceGroupsRemoveInstancesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupsRemoveInstancesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest} InstanceGroupsRemoveInstancesRequest instance
                         */
                        InstanceGroupsRemoveInstancesRequest.create = function create(properties) {
                            return new InstanceGroupsRemoveInstancesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupsRemoveInstancesRequest message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupsRemoveInstancesRequest} message InstanceGroupsRemoveInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupsRemoveInstancesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instances != null && message.instances.length)
                                for (var i = 0; i < message.instances.length; ++i)
                                    $root.google.cloud.compute.v1.InstanceReference.encode(message.instances[i], writer.uint32(/* id 29097598, wireType 2 =*/232780786).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupsRemoveInstancesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupsRemoveInstancesRequest} message InstanceGroupsRemoveInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupsRemoveInstancesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupsRemoveInstancesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest} InstanceGroupsRemoveInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupsRemoveInstancesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 29097598: {
                                        if (!(message.instances && message.instances.length))
                                            message.instances = [];
                                        message.instances.push($root.google.cloud.compute.v1.InstanceReference.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupsRemoveInstancesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest} InstanceGroupsRemoveInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupsRemoveInstancesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupsRemoveInstancesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupsRemoveInstancesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instances != null && message.hasOwnProperty("instances")) {
                                if (!Array.isArray(message.instances))
                                    return "instances: array expected";
                                for (var i = 0; i < message.instances.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstanceReference.verify(message.instances[i]);
                                    if (error)
                                        return "instances." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupsRemoveInstancesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest} InstanceGroupsRemoveInstancesRequest
                         */
                        InstanceGroupsRemoveInstancesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest();
                            if (object.instances) {
                                if (!Array.isArray(object.instances))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest.instances: array expected");
                                message.instances = [];
                                for (var i = 0; i < object.instances.length; ++i) {
                                    if (typeof object.instances[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest.instances: object expected");
                                    message.instances[i] = $root.google.cloud.compute.v1.InstanceReference.fromObject(object.instances[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupsRemoveInstancesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest} message InstanceGroupsRemoveInstancesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupsRemoveInstancesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.instances = [];
                            if (message.instances && message.instances.length) {
                                object.instances = [];
                                for (var j = 0; j < message.instances.length; ++j)
                                    object.instances[j] = $root.google.cloud.compute.v1.InstanceReference.toObject(message.instances[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupsRemoveInstancesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupsRemoveInstancesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupsRemoveInstancesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupsRemoveInstancesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest";
                        };
    
                        return InstanceGroupsRemoveInstancesRequest;
                    })();
    
                    v1.InstanceGroupsScopedList = (function() {
    
                        /**
                         * Properties of an InstanceGroupsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupsScopedList
                         * @property {Array.<google.cloud.compute.v1.IInstanceGroup>|null} [instanceGroups] InstanceGroupsScopedList instanceGroups
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] InstanceGroupsScopedList warning
                         */
    
                        /**
                         * Constructs a new InstanceGroupsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupsScopedList.
                         * @implements IInstanceGroupsScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupsScopedList=} [properties] Properties to set
                         */
                        function InstanceGroupsScopedList(properties) {
                            this.instanceGroups = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupsScopedList instanceGroups.
                         * @member {Array.<google.cloud.compute.v1.IInstanceGroup>} instanceGroups
                         * @memberof google.cloud.compute.v1.InstanceGroupsScopedList
                         * @instance
                         */
                        InstanceGroupsScopedList.prototype.instanceGroups = $util.emptyArray;
    
                        /**
                         * InstanceGroupsScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.InstanceGroupsScopedList
                         * @instance
                         */
                        InstanceGroupsScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupsScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.InstanceGroupsScopedList
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupsScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupsScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupsScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupsScopedList} InstanceGroupsScopedList instance
                         */
                        InstanceGroupsScopedList.create = function create(properties) {
                            return new InstanceGroupsScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupsScopedList message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupsScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupsScopedList} message InstanceGroupsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupsScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.instanceGroups != null && message.instanceGroups.length)
                                for (var i = 0; i < message.instanceGroups.length; ++i)
                                    $root.google.cloud.compute.v1.InstanceGroup.encode(message.instanceGroups[i], writer.uint32(/* id 366469310, wireType 2 =*/2931754482).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupsScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupsScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupsScopedList} message InstanceGroupsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupsScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupsScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupsScopedList} InstanceGroupsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupsScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupsScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 366469310: {
                                        if (!(message.instanceGroups && message.instanceGroups.length))
                                            message.instanceGroups = [];
                                        message.instanceGroups.push($root.google.cloud.compute.v1.InstanceGroup.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupsScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupsScopedList} InstanceGroupsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupsScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupsScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupsScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupsScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroups != null && message.hasOwnProperty("instanceGroups")) {
                                if (!Array.isArray(message.instanceGroups))
                                    return "instanceGroups: array expected";
                                for (var i = 0; i < message.instanceGroups.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstanceGroup.verify(message.instanceGroups[i]);
                                    if (error)
                                        return "instanceGroups." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupsScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupsScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupsScopedList} InstanceGroupsScopedList
                         */
                        InstanceGroupsScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupsScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupsScopedList();
                            if (object.instanceGroups) {
                                if (!Array.isArray(object.instanceGroups))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupsScopedList.instanceGroups: array expected");
                                message.instanceGroups = [];
                                for (var i = 0; i < object.instanceGroups.length; ++i) {
                                    if (typeof object.instanceGroups[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceGroupsScopedList.instanceGroups: object expected");
                                    message.instanceGroups[i] = $root.google.cloud.compute.v1.InstanceGroup.fromObject(object.instanceGroups[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupsScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupsScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupsScopedList} message InstanceGroupsScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupsScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.instanceGroups = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.instanceGroups && message.instanceGroups.length) {
                                object.instanceGroups = [];
                                for (var j = 0; j < message.instanceGroups.length; ++j)
                                    object.instanceGroups[j] = $root.google.cloud.compute.v1.InstanceGroup.toObject(message.instanceGroups[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupsScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupsScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupsScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupsScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupsScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupsScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupsScopedList";
                        };
    
                        return InstanceGroupsScopedList;
                    })();
    
                    v1.InstanceGroupsSetNamedPortsRequest = (function() {
    
                        /**
                         * Properties of an InstanceGroupsSetNamedPortsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceGroupsSetNamedPortsRequest
                         * @property {string|null} [fingerprint] InstanceGroupsSetNamedPortsRequest fingerprint
                         * @property {Array.<google.cloud.compute.v1.INamedPort>|null} [namedPorts] InstanceGroupsSetNamedPortsRequest namedPorts
                         */
    
                        /**
                         * Constructs a new InstanceGroupsSetNamedPortsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupsSetNamedPortsRequest.
                         * @implements IInstanceGroupsSetNamedPortsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceGroupsSetNamedPortsRequest=} [properties] Properties to set
                         */
                        function InstanceGroupsSetNamedPortsRequest(properties) {
                            this.namedPorts = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceGroupsSetNamedPortsRequest fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest
                         * @instance
                         */
                        InstanceGroupsSetNamedPortsRequest.prototype.fingerprint = null;
    
                        /**
                         * InstanceGroupsSetNamedPortsRequest namedPorts.
                         * @member {Array.<google.cloud.compute.v1.INamedPort>} namedPorts
                         * @memberof google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest
                         * @instance
                         */
                        InstanceGroupsSetNamedPortsRequest.prototype.namedPorts = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceGroupsSetNamedPortsRequest _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest
                         * @instance
                         */
                        Object.defineProperty(InstanceGroupsSetNamedPortsRequest.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceGroupsSetNamedPortsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupsSetNamedPortsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest} InstanceGroupsSetNamedPortsRequest instance
                         */
                        InstanceGroupsSetNamedPortsRequest.create = function create(properties) {
                            return new InstanceGroupsSetNamedPortsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceGroupsSetNamedPortsRequest message. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupsSetNamedPortsRequest} message InstanceGroupsSetNamedPortsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupsSetNamedPortsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.namedPorts != null && message.namedPorts.length)
                                for (var i = 0; i < message.namedPorts.length; ++i)
                                    $root.google.cloud.compute.v1.NamedPort.encode(message.namedPorts[i], writer.uint32(/* id 427598732, wireType 2 =*/3420789858).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceGroupsSetNamedPortsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceGroupsSetNamedPortsRequest} message InstanceGroupsSetNamedPortsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceGroupsSetNamedPortsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceGroupsSetNamedPortsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest} InstanceGroupsSetNamedPortsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupsSetNamedPortsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 427598732: {
                                        if (!(message.namedPorts && message.namedPorts.length))
                                            message.namedPorts = [];
                                        message.namedPorts.push($root.google.cloud.compute.v1.NamedPort.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceGroupsSetNamedPortsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest} InstanceGroupsSetNamedPortsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceGroupsSetNamedPortsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceGroupsSetNamedPortsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceGroupsSetNamedPortsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.namedPorts != null && message.hasOwnProperty("namedPorts")) {
                                if (!Array.isArray(message.namedPorts))
                                    return "namedPorts: array expected";
                                for (var i = 0; i < message.namedPorts.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NamedPort.verify(message.namedPorts[i]);
                                    if (error)
                                        return "namedPorts." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceGroupsSetNamedPortsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest} InstanceGroupsSetNamedPortsRequest
                         */
                        InstanceGroupsSetNamedPortsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest();
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.namedPorts) {
                                if (!Array.isArray(object.namedPorts))
                                    throw TypeError(".google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest.namedPorts: array expected");
                                message.namedPorts = [];
                                for (var i = 0; i < object.namedPorts.length; ++i) {
                                    if (typeof object.namedPorts[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest.namedPorts: object expected");
                                    message.namedPorts[i] = $root.google.cloud.compute.v1.NamedPort.fromObject(object.namedPorts[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceGroupsSetNamedPortsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest
                         * @static
                         * @param {google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest} message InstanceGroupsSetNamedPortsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceGroupsSetNamedPortsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.namedPorts = [];
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.namedPorts && message.namedPorts.length) {
                                object.namedPorts = [];
                                for (var j = 0; j < message.namedPorts.length; ++j)
                                    object.namedPorts[j] = $root.google.cloud.compute.v1.NamedPort.toObject(message.namedPorts[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceGroupsSetNamedPortsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceGroupsSetNamedPortsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceGroupsSetNamedPortsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceGroupsSetNamedPortsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest";
                        };
    
                        return InstanceGroupsSetNamedPortsRequest;
                    })();
    
                    v1.InstanceList = (function() {
    
                        /**
                         * Properties of an InstanceList.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceList
                         * @property {string|null} [id] InstanceList id
                         * @property {Array.<google.cloud.compute.v1.IInstance>|null} [items] InstanceList items
                         * @property {string|null} [kind] InstanceList kind
                         * @property {string|null} [nextPageToken] InstanceList nextPageToken
                         * @property {string|null} [selfLink] InstanceList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] InstanceList warning
                         */
    
                        /**
                         * Constructs a new InstanceList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceList.
                         * @implements IInstanceList
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceList=} [properties] Properties to set
                         */
                        function InstanceList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @instance
                         */
                        InstanceList.prototype.id = null;
    
                        /**
                         * InstanceList items.
                         * @member {Array.<google.cloud.compute.v1.IInstance>} items
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @instance
                         */
                        InstanceList.prototype.items = $util.emptyArray;
    
                        /**
                         * InstanceList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @instance
                         */
                        InstanceList.prototype.kind = null;
    
                        /**
                         * InstanceList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @instance
                         */
                        InstanceList.prototype.nextPageToken = null;
    
                        /**
                         * InstanceList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @instance
                         */
                        InstanceList.prototype.selfLink = null;
    
                        /**
                         * InstanceList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @instance
                         */
                        InstanceList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @instance
                         */
                        Object.defineProperty(InstanceList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @instance
                         */
                        Object.defineProperty(InstanceList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @instance
                         */
                        Object.defineProperty(InstanceList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @instance
                         */
                        Object.defineProperty(InstanceList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @instance
                         */
                        Object.defineProperty(InstanceList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceList} InstanceList instance
                         */
                        InstanceList.create = function create(properties) {
                            return new InstanceList(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceList message. Does not implicitly {@link google.cloud.compute.v1.InstanceList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceList} message InstanceList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Instance.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceList} message InstanceList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceList} InstanceList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Instance.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceList} InstanceList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Instance.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceList} InstanceList
                         */
                        InstanceList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.InstanceList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Instance.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @static
                         * @param {google.cloud.compute.v1.InstanceList} message InstanceList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Instance.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceList";
                        };
    
                        return InstanceList;
                    })();
    
                    v1.InstanceListReferrers = (function() {
    
                        /**
                         * Properties of an InstanceListReferrers.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceListReferrers
                         * @property {string|null} [id] InstanceListReferrers id
                         * @property {Array.<google.cloud.compute.v1.IReference>|null} [items] InstanceListReferrers items
                         * @property {string|null} [kind] InstanceListReferrers kind
                         * @property {string|null} [nextPageToken] InstanceListReferrers nextPageToken
                         * @property {string|null} [selfLink] InstanceListReferrers selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] InstanceListReferrers warning
                         */
    
                        /**
                         * Constructs a new InstanceListReferrers.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceListReferrers.
                         * @implements IInstanceListReferrers
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceListReferrers=} [properties] Properties to set
                         */
                        function InstanceListReferrers(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceListReferrers id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @instance
                         */
                        InstanceListReferrers.prototype.id = null;
    
                        /**
                         * InstanceListReferrers items.
                         * @member {Array.<google.cloud.compute.v1.IReference>} items
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @instance
                         */
                        InstanceListReferrers.prototype.items = $util.emptyArray;
    
                        /**
                         * InstanceListReferrers kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @instance
                         */
                        InstanceListReferrers.prototype.kind = null;
    
                        /**
                         * InstanceListReferrers nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @instance
                         */
                        InstanceListReferrers.prototype.nextPageToken = null;
    
                        /**
                         * InstanceListReferrers selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @instance
                         */
                        InstanceListReferrers.prototype.selfLink = null;
    
                        /**
                         * InstanceListReferrers warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @instance
                         */
                        InstanceListReferrers.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceListReferrers _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @instance
                         */
                        Object.defineProperty(InstanceListReferrers.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceListReferrers _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @instance
                         */
                        Object.defineProperty(InstanceListReferrers.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceListReferrers _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @instance
                         */
                        Object.defineProperty(InstanceListReferrers.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceListReferrers _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @instance
                         */
                        Object.defineProperty(InstanceListReferrers.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceListReferrers _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @instance
                         */
                        Object.defineProperty(InstanceListReferrers.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceListReferrers instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceListReferrers=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceListReferrers} InstanceListReferrers instance
                         */
                        InstanceListReferrers.create = function create(properties) {
                            return new InstanceListReferrers(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceListReferrers message. Does not implicitly {@link google.cloud.compute.v1.InstanceListReferrers.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceListReferrers} message InstanceListReferrers message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceListReferrers.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Reference.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceListReferrers message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceListReferrers.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceListReferrers} message InstanceListReferrers message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceListReferrers.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceListReferrers message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceListReferrers} InstanceListReferrers
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceListReferrers.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceListReferrers();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Reference.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceListReferrers message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceListReferrers} InstanceListReferrers
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceListReferrers.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceListReferrers message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceListReferrers.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Reference.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceListReferrers message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceListReferrers} InstanceListReferrers
                         */
                        InstanceListReferrers.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceListReferrers)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceListReferrers();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.InstanceListReferrers.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceListReferrers.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Reference.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceListReferrers.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceListReferrers message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @static
                         * @param {google.cloud.compute.v1.InstanceListReferrers} message InstanceListReferrers
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceListReferrers.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Reference.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceListReferrers to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceListReferrers.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceListReferrers
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceListReferrers
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceListReferrers.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceListReferrers";
                        };
    
                        return InstanceListReferrers;
                    })();
    
                    v1.InstanceManagedByIgmError = (function() {
    
                        /**
                         * Properties of an InstanceManagedByIgmError.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceManagedByIgmError
                         * @property {google.cloud.compute.v1.IInstanceManagedByIgmErrorManagedInstanceError|null} [error] InstanceManagedByIgmError error
                         * @property {google.cloud.compute.v1.IInstanceManagedByIgmErrorInstanceActionDetails|null} [instanceActionDetails] InstanceManagedByIgmError instanceActionDetails
                         * @property {string|null} [timestamp] InstanceManagedByIgmError timestamp
                         */
    
                        /**
                         * Constructs a new InstanceManagedByIgmError.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceManagedByIgmError.
                         * @implements IInstanceManagedByIgmError
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceManagedByIgmError=} [properties] Properties to set
                         */
                        function InstanceManagedByIgmError(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceManagedByIgmError error.
                         * @member {google.cloud.compute.v1.IInstanceManagedByIgmErrorManagedInstanceError|null|undefined} error
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmError
                         * @instance
                         */
                        InstanceManagedByIgmError.prototype.error = null;
    
                        /**
                         * InstanceManagedByIgmError instanceActionDetails.
                         * @member {google.cloud.compute.v1.IInstanceManagedByIgmErrorInstanceActionDetails|null|undefined} instanceActionDetails
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmError
                         * @instance
                         */
                        InstanceManagedByIgmError.prototype.instanceActionDetails = null;
    
                        /**
                         * InstanceManagedByIgmError timestamp.
                         * @member {string|null|undefined} timestamp
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmError
                         * @instance
                         */
                        InstanceManagedByIgmError.prototype.timestamp = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceManagedByIgmError _error.
                         * @member {"error"|undefined} _error
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmError
                         * @instance
                         */
                        Object.defineProperty(InstanceManagedByIgmError.prototype, "_error", {
                            get: $util.oneOfGetter($oneOfFields = ["error"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceManagedByIgmError _instanceActionDetails.
                         * @member {"instanceActionDetails"|undefined} _instanceActionDetails
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmError
                         * @instance
                         */
                        Object.defineProperty(InstanceManagedByIgmError.prototype, "_instanceActionDetails", {
                            get: $util.oneOfGetter($oneOfFields = ["instanceActionDetails"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceManagedByIgmError _timestamp.
                         * @member {"timestamp"|undefined} _timestamp
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmError
                         * @instance
                         */
                        Object.defineProperty(InstanceManagedByIgmError.prototype, "_timestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["timestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceManagedByIgmError instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmError
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceManagedByIgmError=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceManagedByIgmError} InstanceManagedByIgmError instance
                         */
                        InstanceManagedByIgmError.create = function create(properties) {
                            return new InstanceManagedByIgmError(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceManagedByIgmError message. Does not implicitly {@link google.cloud.compute.v1.InstanceManagedByIgmError.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmError
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceManagedByIgmError} message InstanceManagedByIgmError message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceManagedByIgmError.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.timestamp != null && Object.hasOwnProperty.call(message, "timestamp"))
                                writer.uint32(/* id 55126294, wireType 2 =*/441010354).string(message.timestamp);
                            if (message.error != null && Object.hasOwnProperty.call(message, "error"))
                                $root.google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError.encode(message.error, writer.uint32(/* id 96784904, wireType 2 =*/774279234).fork()).ldelim();
                            if (message.instanceActionDetails != null && Object.hasOwnProperty.call(message, "instanceActionDetails"))
                                $root.google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails.encode(message.instanceActionDetails, writer.uint32(/* id 292224547, wireType 2 =*/2337796378).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceManagedByIgmError message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceManagedByIgmError.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmError
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceManagedByIgmError} message InstanceManagedByIgmError message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceManagedByIgmError.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceManagedByIgmError message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmError
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceManagedByIgmError} InstanceManagedByIgmError
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceManagedByIgmError.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceManagedByIgmError();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 96784904: {
                                        message.error = $root.google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 292224547: {
                                        message.instanceActionDetails = $root.google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 55126294: {
                                        message.timestamp = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceManagedByIgmError message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmError
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceManagedByIgmError} InstanceManagedByIgmError
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceManagedByIgmError.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceManagedByIgmError message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmError
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceManagedByIgmError.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.error != null && message.hasOwnProperty("error")) {
                                properties._error = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError.verify(message.error);
                                    if (error)
                                        return "error." + error;
                                }
                            }
                            if (message.instanceActionDetails != null && message.hasOwnProperty("instanceActionDetails")) {
                                properties._instanceActionDetails = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails.verify(message.instanceActionDetails);
                                    if (error)
                                        return "instanceActionDetails." + error;
                                }
                            }
                            if (message.timestamp != null && message.hasOwnProperty("timestamp")) {
                                properties._timestamp = 1;
                                if (!$util.isString(message.timestamp))
                                    return "timestamp: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceManagedByIgmError message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmError
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceManagedByIgmError} InstanceManagedByIgmError
                         */
                        InstanceManagedByIgmError.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceManagedByIgmError)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceManagedByIgmError();
                            if (object.error != null) {
                                if (typeof object.error !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceManagedByIgmError.error: object expected");
                                message.error = $root.google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError.fromObject(object.error);
                            }
                            if (object.instanceActionDetails != null) {
                                if (typeof object.instanceActionDetails !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceManagedByIgmError.instanceActionDetails: object expected");
                                message.instanceActionDetails = $root.google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails.fromObject(object.instanceActionDetails);
                            }
                            if (object.timestamp != null)
                                message.timestamp = String(object.timestamp);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceManagedByIgmError message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmError
                         * @static
                         * @param {google.cloud.compute.v1.InstanceManagedByIgmError} message InstanceManagedByIgmError
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceManagedByIgmError.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.timestamp != null && message.hasOwnProperty("timestamp")) {
                                object.timestamp = message.timestamp;
                                if (options.oneofs)
                                    object._timestamp = "timestamp";
                            }
                            if (message.error != null && message.hasOwnProperty("error")) {
                                object.error = $root.google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError.toObject(message.error, options);
                                if (options.oneofs)
                                    object._error = "error";
                            }
                            if (message.instanceActionDetails != null && message.hasOwnProperty("instanceActionDetails")) {
                                object.instanceActionDetails = $root.google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails.toObject(message.instanceActionDetails, options);
                                if (options.oneofs)
                                    object._instanceActionDetails = "instanceActionDetails";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceManagedByIgmError to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmError
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceManagedByIgmError.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceManagedByIgmError
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmError
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceManagedByIgmError.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceManagedByIgmError";
                        };
    
                        return InstanceManagedByIgmError;
                    })();
    
                    v1.InstanceManagedByIgmErrorInstanceActionDetails = (function() {
    
                        /**
                         * Properties of an InstanceManagedByIgmErrorInstanceActionDetails.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceManagedByIgmErrorInstanceActionDetails
                         * @property {string|null} [action] InstanceManagedByIgmErrorInstanceActionDetails action
                         * @property {string|null} [instance] InstanceManagedByIgmErrorInstanceActionDetails instance
                         * @property {google.cloud.compute.v1.IManagedInstanceVersion|null} [version] InstanceManagedByIgmErrorInstanceActionDetails version
                         */
    
                        /**
                         * Constructs a new InstanceManagedByIgmErrorInstanceActionDetails.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceManagedByIgmErrorInstanceActionDetails.
                         * @implements IInstanceManagedByIgmErrorInstanceActionDetails
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceManagedByIgmErrorInstanceActionDetails=} [properties] Properties to set
                         */
                        function InstanceManagedByIgmErrorInstanceActionDetails(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceManagedByIgmErrorInstanceActionDetails action.
                         * @member {string|null|undefined} action
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails
                         * @instance
                         */
                        InstanceManagedByIgmErrorInstanceActionDetails.prototype.action = null;
    
                        /**
                         * InstanceManagedByIgmErrorInstanceActionDetails instance.
                         * @member {string|null|undefined} instance
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails
                         * @instance
                         */
                        InstanceManagedByIgmErrorInstanceActionDetails.prototype.instance = null;
    
                        /**
                         * InstanceManagedByIgmErrorInstanceActionDetails version.
                         * @member {google.cloud.compute.v1.IManagedInstanceVersion|null|undefined} version
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails
                         * @instance
                         */
                        InstanceManagedByIgmErrorInstanceActionDetails.prototype.version = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceManagedByIgmErrorInstanceActionDetails _action.
                         * @member {"action"|undefined} _action
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails
                         * @instance
                         */
                        Object.defineProperty(InstanceManagedByIgmErrorInstanceActionDetails.prototype, "_action", {
                            get: $util.oneOfGetter($oneOfFields = ["action"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceManagedByIgmErrorInstanceActionDetails _instance.
                         * @member {"instance"|undefined} _instance
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails
                         * @instance
                         */
                        Object.defineProperty(InstanceManagedByIgmErrorInstanceActionDetails.prototype, "_instance", {
                            get: $util.oneOfGetter($oneOfFields = ["instance"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceManagedByIgmErrorInstanceActionDetails _version.
                         * @member {"version"|undefined} _version
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails
                         * @instance
                         */
                        Object.defineProperty(InstanceManagedByIgmErrorInstanceActionDetails.prototype, "_version", {
                            get: $util.oneOfGetter($oneOfFields = ["version"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceManagedByIgmErrorInstanceActionDetails instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceManagedByIgmErrorInstanceActionDetails=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails} InstanceManagedByIgmErrorInstanceActionDetails instance
                         */
                        InstanceManagedByIgmErrorInstanceActionDetails.create = function create(properties) {
                            return new InstanceManagedByIgmErrorInstanceActionDetails(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceManagedByIgmErrorInstanceActionDetails message. Does not implicitly {@link google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceManagedByIgmErrorInstanceActionDetails} message InstanceManagedByIgmErrorInstanceActionDetails message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceManagedByIgmErrorInstanceActionDetails.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.action != null && Object.hasOwnProperty.call(message, "action"))
                                writer.uint32(/* id 187661878, wireType 2 =*/1501295026).string(message.action);
                            if (message.version != null && Object.hasOwnProperty.call(message, "version"))
                                $root.google.cloud.compute.v1.ManagedInstanceVersion.encode(message.version, writer.uint32(/* id 351608024, wireType 2 =*/2812864194).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceManagedByIgmErrorInstanceActionDetails message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceManagedByIgmErrorInstanceActionDetails} message InstanceManagedByIgmErrorInstanceActionDetails message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceManagedByIgmErrorInstanceActionDetails.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceManagedByIgmErrorInstanceActionDetails message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails} InstanceManagedByIgmErrorInstanceActionDetails
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceManagedByIgmErrorInstanceActionDetails.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 187661878: {
                                        message.action = reader.string();
                                        break;
                                    }
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 351608024: {
                                        message.version = $root.google.cloud.compute.v1.ManagedInstanceVersion.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceManagedByIgmErrorInstanceActionDetails message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails} InstanceManagedByIgmErrorInstanceActionDetails
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceManagedByIgmErrorInstanceActionDetails.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceManagedByIgmErrorInstanceActionDetails message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceManagedByIgmErrorInstanceActionDetails.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.action != null && message.hasOwnProperty("action")) {
                                properties._action = 1;
                                if (!$util.isString(message.action))
                                    return "action: string expected";
                            }
                            if (message.instance != null && message.hasOwnProperty("instance")) {
                                properties._instance = 1;
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            }
                            if (message.version != null && message.hasOwnProperty("version")) {
                                properties._version = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ManagedInstanceVersion.verify(message.version);
                                    if (error)
                                        return "version." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceManagedByIgmErrorInstanceActionDetails message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails} InstanceManagedByIgmErrorInstanceActionDetails
                         */
                        InstanceManagedByIgmErrorInstanceActionDetails.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails();
                            if (object.action != null)
                                message.action = String(object.action);
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.version != null) {
                                if (typeof object.version !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails.version: object expected");
                                message.version = $root.google.cloud.compute.v1.ManagedInstanceVersion.fromObject(object.version);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceManagedByIgmErrorInstanceActionDetails message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails
                         * @static
                         * @param {google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails} message InstanceManagedByIgmErrorInstanceActionDetails
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceManagedByIgmErrorInstanceActionDetails.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.instance != null && message.hasOwnProperty("instance")) {
                                object.instance = message.instance;
                                if (options.oneofs)
                                    object._instance = "instance";
                            }
                            if (message.action != null && message.hasOwnProperty("action")) {
                                object.action = message.action;
                                if (options.oneofs)
                                    object._action = "action";
                            }
                            if (message.version != null && message.hasOwnProperty("version")) {
                                object.version = $root.google.cloud.compute.v1.ManagedInstanceVersion.toObject(message.version, options);
                                if (options.oneofs)
                                    object._version = "version";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceManagedByIgmErrorInstanceActionDetails to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceManagedByIgmErrorInstanceActionDetails.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceManagedByIgmErrorInstanceActionDetails
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceManagedByIgmErrorInstanceActionDetails.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails";
                        };
    
                        /**
                         * Action enum.
                         * @name google.cloud.compute.v1.InstanceManagedByIgmErrorInstanceActionDetails.Action
                         * @enum {number}
                         * @property {number} UNDEFINED_ACTION=0 UNDEFINED_ACTION value
                         * @property {number} ABANDONING=388244813 ABANDONING value
                         * @property {number} CREATING=455564985 CREATING value
                         * @property {number} CREATING_WITHOUT_RETRIES=428843785 CREATING_WITHOUT_RETRIES value
                         * @property {number} DELETING=528602024 DELETING value
                         * @property {number} NONE=2402104 NONE value
                         * @property {number} RECREATING=287278572 RECREATING value
                         * @property {number} REFRESHING=163266343 REFRESHING value
                         * @property {number} RESTARTING=320534387 RESTARTING value
                         * @property {number} RESUMING=446856618 RESUMING value
                         * @property {number} STARTING=488820800 STARTING value
                         * @property {number} STOPPING=350791796 STOPPING value
                         * @property {number} SUSPENDING=514206246 SUSPENDING value
                         * @property {number} VERIFYING=16982185 VERIFYING value
                         */
                        InstanceManagedByIgmErrorInstanceActionDetails.Action = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ACTION"] = 0;
                            values[valuesById[388244813] = "ABANDONING"] = 388244813;
                            values[valuesById[455564985] = "CREATING"] = 455564985;
                            values[valuesById[428843785] = "CREATING_WITHOUT_RETRIES"] = 428843785;
                            values[valuesById[528602024] = "DELETING"] = 528602024;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            values[valuesById[287278572] = "RECREATING"] = 287278572;
                            values[valuesById[163266343] = "REFRESHING"] = 163266343;
                            values[valuesById[320534387] = "RESTARTING"] = 320534387;
                            values[valuesById[446856618] = "RESUMING"] = 446856618;
                            values[valuesById[488820800] = "STARTING"] = 488820800;
                            values[valuesById[350791796] = "STOPPING"] = 350791796;
                            values[valuesById[514206246] = "SUSPENDING"] = 514206246;
                            values[valuesById[16982185] = "VERIFYING"] = 16982185;
                            return values;
                        })();
    
                        return InstanceManagedByIgmErrorInstanceActionDetails;
                    })();
    
                    v1.InstanceManagedByIgmErrorManagedInstanceError = (function() {
    
                        /**
                         * Properties of an InstanceManagedByIgmErrorManagedInstanceError.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceManagedByIgmErrorManagedInstanceError
                         * @property {string|null} [code] InstanceManagedByIgmErrorManagedInstanceError code
                         * @property {string|null} [message] InstanceManagedByIgmErrorManagedInstanceError message
                         */
    
                        /**
                         * Constructs a new InstanceManagedByIgmErrorManagedInstanceError.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceManagedByIgmErrorManagedInstanceError.
                         * @implements IInstanceManagedByIgmErrorManagedInstanceError
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceManagedByIgmErrorManagedInstanceError=} [properties] Properties to set
                         */
                        function InstanceManagedByIgmErrorManagedInstanceError(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceManagedByIgmErrorManagedInstanceError code.
                         * @member {string|null|undefined} code
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError
                         * @instance
                         */
                        InstanceManagedByIgmErrorManagedInstanceError.prototype.code = null;
    
                        /**
                         * InstanceManagedByIgmErrorManagedInstanceError message.
                         * @member {string|null|undefined} message
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError
                         * @instance
                         */
                        InstanceManagedByIgmErrorManagedInstanceError.prototype.message = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceManagedByIgmErrorManagedInstanceError _code.
                         * @member {"code"|undefined} _code
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError
                         * @instance
                         */
                        Object.defineProperty(InstanceManagedByIgmErrorManagedInstanceError.prototype, "_code", {
                            get: $util.oneOfGetter($oneOfFields = ["code"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceManagedByIgmErrorManagedInstanceError _message.
                         * @member {"message"|undefined} _message
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError
                         * @instance
                         */
                        Object.defineProperty(InstanceManagedByIgmErrorManagedInstanceError.prototype, "_message", {
                            get: $util.oneOfGetter($oneOfFields = ["message"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceManagedByIgmErrorManagedInstanceError instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceManagedByIgmErrorManagedInstanceError=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError} InstanceManagedByIgmErrorManagedInstanceError instance
                         */
                        InstanceManagedByIgmErrorManagedInstanceError.create = function create(properties) {
                            return new InstanceManagedByIgmErrorManagedInstanceError(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceManagedByIgmErrorManagedInstanceError message. Does not implicitly {@link google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceManagedByIgmErrorManagedInstanceError} message InstanceManagedByIgmErrorManagedInstanceError message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceManagedByIgmErrorManagedInstanceError.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.code != null && Object.hasOwnProperty.call(message, "code"))
                                writer.uint32(/* id 3059181, wireType 2 =*/24473450).string(message.code);
                            if (message.message != null && Object.hasOwnProperty.call(message, "message"))
                                writer.uint32(/* id 418054151, wireType 2 =*/3344433210).string(message.message);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceManagedByIgmErrorManagedInstanceError message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceManagedByIgmErrorManagedInstanceError} message InstanceManagedByIgmErrorManagedInstanceError message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceManagedByIgmErrorManagedInstanceError.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceManagedByIgmErrorManagedInstanceError message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError} InstanceManagedByIgmErrorManagedInstanceError
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceManagedByIgmErrorManagedInstanceError.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3059181: {
                                        message.code = reader.string();
                                        break;
                                    }
                                case 418054151: {
                                        message.message = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceManagedByIgmErrorManagedInstanceError message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError} InstanceManagedByIgmErrorManagedInstanceError
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceManagedByIgmErrorManagedInstanceError.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceManagedByIgmErrorManagedInstanceError message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceManagedByIgmErrorManagedInstanceError.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.code != null && message.hasOwnProperty("code")) {
                                properties._code = 1;
                                if (!$util.isString(message.code))
                                    return "code: string expected";
                            }
                            if (message.message != null && message.hasOwnProperty("message")) {
                                properties._message = 1;
                                if (!$util.isString(message.message))
                                    return "message: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceManagedByIgmErrorManagedInstanceError message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError} InstanceManagedByIgmErrorManagedInstanceError
                         */
                        InstanceManagedByIgmErrorManagedInstanceError.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError();
                            if (object.code != null)
                                message.code = String(object.code);
                            if (object.message != null)
                                message.message = String(object.message);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceManagedByIgmErrorManagedInstanceError message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError
                         * @static
                         * @param {google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError} message InstanceManagedByIgmErrorManagedInstanceError
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceManagedByIgmErrorManagedInstanceError.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.code != null && message.hasOwnProperty("code")) {
                                object.code = message.code;
                                if (options.oneofs)
                                    object._code = "code";
                            }
                            if (message.message != null && message.hasOwnProperty("message")) {
                                object.message = message.message;
                                if (options.oneofs)
                                    object._message = "message";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceManagedByIgmErrorManagedInstanceError to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceManagedByIgmErrorManagedInstanceError.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceManagedByIgmErrorManagedInstanceError
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceManagedByIgmErrorManagedInstanceError.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceManagedByIgmErrorManagedInstanceError";
                        };
    
                        return InstanceManagedByIgmErrorManagedInstanceError;
                    })();
    
                    v1.InstanceMoveRequest = (function() {
    
                        /**
                         * Properties of an InstanceMoveRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceMoveRequest
                         * @property {string|null} [destinationZone] InstanceMoveRequest destinationZone
                         * @property {string|null} [targetInstance] InstanceMoveRequest targetInstance
                         */
    
                        /**
                         * Constructs a new InstanceMoveRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceMoveRequest.
                         * @implements IInstanceMoveRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceMoveRequest=} [properties] Properties to set
                         */
                        function InstanceMoveRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceMoveRequest destinationZone.
                         * @member {string|null|undefined} destinationZone
                         * @memberof google.cloud.compute.v1.InstanceMoveRequest
                         * @instance
                         */
                        InstanceMoveRequest.prototype.destinationZone = null;
    
                        /**
                         * InstanceMoveRequest targetInstance.
                         * @member {string|null|undefined} targetInstance
                         * @memberof google.cloud.compute.v1.InstanceMoveRequest
                         * @instance
                         */
                        InstanceMoveRequest.prototype.targetInstance = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceMoveRequest _destinationZone.
                         * @member {"destinationZone"|undefined} _destinationZone
                         * @memberof google.cloud.compute.v1.InstanceMoveRequest
                         * @instance
                         */
                        Object.defineProperty(InstanceMoveRequest.prototype, "_destinationZone", {
                            get: $util.oneOfGetter($oneOfFields = ["destinationZone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceMoveRequest _targetInstance.
                         * @member {"targetInstance"|undefined} _targetInstance
                         * @memberof google.cloud.compute.v1.InstanceMoveRequest
                         * @instance
                         */
                        Object.defineProperty(InstanceMoveRequest.prototype, "_targetInstance", {
                            get: $util.oneOfGetter($oneOfFields = ["targetInstance"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceMoveRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceMoveRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceMoveRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceMoveRequest} InstanceMoveRequest instance
                         */
                        InstanceMoveRequest.create = function create(properties) {
                            return new InstanceMoveRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceMoveRequest message. Does not implicitly {@link google.cloud.compute.v1.InstanceMoveRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceMoveRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceMoveRequest} message InstanceMoveRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceMoveRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.destinationZone != null && Object.hasOwnProperty.call(message, "destinationZone"))
                                writer.uint32(/* id 131854653, wireType 2 =*/1054837226).string(message.destinationZone);
                            if (message.targetInstance != null && Object.hasOwnProperty.call(message, "targetInstance"))
                                writer.uint32(/* id 289769347, wireType 2 =*/2318154778).string(message.targetInstance);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceMoveRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceMoveRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceMoveRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceMoveRequest} message InstanceMoveRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceMoveRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceMoveRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceMoveRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceMoveRequest} InstanceMoveRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceMoveRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceMoveRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 131854653: {
                                        message.destinationZone = reader.string();
                                        break;
                                    }
                                case 289769347: {
                                        message.targetInstance = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceMoveRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceMoveRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceMoveRequest} InstanceMoveRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceMoveRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceMoveRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceMoveRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceMoveRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.destinationZone != null && message.hasOwnProperty("destinationZone")) {
                                properties._destinationZone = 1;
                                if (!$util.isString(message.destinationZone))
                                    return "destinationZone: string expected";
                            }
                            if (message.targetInstance != null && message.hasOwnProperty("targetInstance")) {
                                properties._targetInstance = 1;
                                if (!$util.isString(message.targetInstance))
                                    return "targetInstance: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceMoveRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceMoveRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceMoveRequest} InstanceMoveRequest
                         */
                        InstanceMoveRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceMoveRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceMoveRequest();
                            if (object.destinationZone != null)
                                message.destinationZone = String(object.destinationZone);
                            if (object.targetInstance != null)
                                message.targetInstance = String(object.targetInstance);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceMoveRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceMoveRequest
                         * @static
                         * @param {google.cloud.compute.v1.InstanceMoveRequest} message InstanceMoveRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceMoveRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.destinationZone != null && message.hasOwnProperty("destinationZone")) {
                                object.destinationZone = message.destinationZone;
                                if (options.oneofs)
                                    object._destinationZone = "destinationZone";
                            }
                            if (message.targetInstance != null && message.hasOwnProperty("targetInstance")) {
                                object.targetInstance = message.targetInstance;
                                if (options.oneofs)
                                    object._targetInstance = "targetInstance";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceMoveRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceMoveRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceMoveRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceMoveRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceMoveRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceMoveRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceMoveRequest";
                        };
    
                        return InstanceMoveRequest;
                    })();
    
                    v1.InstanceParams = (function() {
    
                        /**
                         * Properties of an InstanceParams.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceParams
                         * @property {Object.<string,string>|null} [resourceManagerTags] InstanceParams resourceManagerTags
                         */
    
                        /**
                         * Constructs a new InstanceParams.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceParams.
                         * @implements IInstanceParams
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceParams=} [properties] Properties to set
                         */
                        function InstanceParams(properties) {
                            this.resourceManagerTags = {};
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceParams resourceManagerTags.
                         * @member {Object.<string,string>} resourceManagerTags
                         * @memberof google.cloud.compute.v1.InstanceParams
                         * @instance
                         */
                        InstanceParams.prototype.resourceManagerTags = $util.emptyObject;
    
                        /**
                         * Creates a new InstanceParams instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceParams
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceParams=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceParams} InstanceParams instance
                         */
                        InstanceParams.create = function create(properties) {
                            return new InstanceParams(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceParams message. Does not implicitly {@link google.cloud.compute.v1.InstanceParams.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceParams
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceParams} message InstanceParams message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceParams.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourceManagerTags != null && Object.hasOwnProperty.call(message, "resourceManagerTags"))
                                for (var keys = Object.keys(message.resourceManagerTags), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 377671164, wireType 2 =*/3021369314).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.resourceManagerTags[keys[i]]).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceParams message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceParams.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceParams
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceParams} message InstanceParams message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceParams.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceParams message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceParams
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceParams} InstanceParams
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceParams.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceParams(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 377671164: {
                                        if (message.resourceManagerTags === $util.emptyObject)
                                            message.resourceManagerTags = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.resourceManagerTags[key] = value;
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceParams message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceParams
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceParams} InstanceParams
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceParams.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceParams message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceParams
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceParams.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourceManagerTags != null && message.hasOwnProperty("resourceManagerTags")) {
                                if (!$util.isObject(message.resourceManagerTags))
                                    return "resourceManagerTags: object expected";
                                var key = Object.keys(message.resourceManagerTags);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.resourceManagerTags[key[i]]))
                                        return "resourceManagerTags: string{k:string} expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceParams message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceParams
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceParams} InstanceParams
                         */
                        InstanceParams.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceParams)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceParams();
                            if (object.resourceManagerTags) {
                                if (typeof object.resourceManagerTags !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceParams.resourceManagerTags: object expected");
                                message.resourceManagerTags = {};
                                for (var keys = Object.keys(object.resourceManagerTags), i = 0; i < keys.length; ++i)
                                    message.resourceManagerTags[keys[i]] = String(object.resourceManagerTags[keys[i]]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceParams message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceParams
                         * @static
                         * @param {google.cloud.compute.v1.InstanceParams} message InstanceParams
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceParams.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.objects || options.defaults)
                                object.resourceManagerTags = {};
                            var keys2;
                            if (message.resourceManagerTags && (keys2 = Object.keys(message.resourceManagerTags)).length) {
                                object.resourceManagerTags = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.resourceManagerTags[keys2[j]] = message.resourceManagerTags[keys2[j]];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceParams to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceParams
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceParams.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceParams
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceParams
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceParams.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceParams";
                        };
    
                        return InstanceParams;
                    })();
    
                    v1.InstanceProperties = (function() {
    
                        /**
                         * Properties of an InstanceProperties.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceProperties
                         * @property {google.cloud.compute.v1.IAdvancedMachineFeatures|null} [advancedMachineFeatures] InstanceProperties advancedMachineFeatures
                         * @property {boolean|null} [canIpForward] InstanceProperties canIpForward
                         * @property {google.cloud.compute.v1.IConfidentialInstanceConfig|null} [confidentialInstanceConfig] InstanceProperties confidentialInstanceConfig
                         * @property {string|null} [description] InstanceProperties description
                         * @property {Array.<google.cloud.compute.v1.IAttachedDisk>|null} [disks] InstanceProperties disks
                         * @property {Array.<google.cloud.compute.v1.IAcceleratorConfig>|null} [guestAccelerators] InstanceProperties guestAccelerators
                         * @property {string|null} [keyRevocationActionType] InstanceProperties keyRevocationActionType
                         * @property {Object.<string,string>|null} [labels] InstanceProperties labels
                         * @property {string|null} [machineType] InstanceProperties machineType
                         * @property {google.cloud.compute.v1.IMetadata|null} [metadata] InstanceProperties metadata
                         * @property {string|null} [minCpuPlatform] InstanceProperties minCpuPlatform
                         * @property {Array.<google.cloud.compute.v1.INetworkInterface>|null} [networkInterfaces] InstanceProperties networkInterfaces
                         * @property {google.cloud.compute.v1.INetworkPerformanceConfig|null} [networkPerformanceConfig] InstanceProperties networkPerformanceConfig
                         * @property {string|null} [privateIpv6GoogleAccess] InstanceProperties privateIpv6GoogleAccess
                         * @property {google.cloud.compute.v1.IReservationAffinity|null} [reservationAffinity] InstanceProperties reservationAffinity
                         * @property {Object.<string,string>|null} [resourceManagerTags] InstanceProperties resourceManagerTags
                         * @property {Array.<string>|null} [resourcePolicies] InstanceProperties resourcePolicies
                         * @property {google.cloud.compute.v1.IScheduling|null} [scheduling] InstanceProperties scheduling
                         * @property {Array.<google.cloud.compute.v1.IServiceAccount>|null} [serviceAccounts] InstanceProperties serviceAccounts
                         * @property {google.cloud.compute.v1.IShieldedInstanceConfig|null} [shieldedInstanceConfig] InstanceProperties shieldedInstanceConfig
                         * @property {google.cloud.compute.v1.ITags|null} [tags] InstanceProperties tags
                         */
    
                        /**
                         * Constructs a new InstanceProperties.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceProperties.
                         * @implements IInstanceProperties
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceProperties=} [properties] Properties to set
                         */
                        function InstanceProperties(properties) {
                            this.disks = [];
                            this.guestAccelerators = [];
                            this.labels = {};
                            this.networkInterfaces = [];
                            this.resourceManagerTags = {};
                            this.resourcePolicies = [];
                            this.serviceAccounts = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceProperties advancedMachineFeatures.
                         * @member {google.cloud.compute.v1.IAdvancedMachineFeatures|null|undefined} advancedMachineFeatures
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.advancedMachineFeatures = null;
    
                        /**
                         * InstanceProperties canIpForward.
                         * @member {boolean|null|undefined} canIpForward
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.canIpForward = null;
    
                        /**
                         * InstanceProperties confidentialInstanceConfig.
                         * @member {google.cloud.compute.v1.IConfidentialInstanceConfig|null|undefined} confidentialInstanceConfig
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.confidentialInstanceConfig = null;
    
                        /**
                         * InstanceProperties description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.description = null;
    
                        /**
                         * InstanceProperties disks.
                         * @member {Array.<google.cloud.compute.v1.IAttachedDisk>} disks
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.disks = $util.emptyArray;
    
                        /**
                         * InstanceProperties guestAccelerators.
                         * @member {Array.<google.cloud.compute.v1.IAcceleratorConfig>} guestAccelerators
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.guestAccelerators = $util.emptyArray;
    
                        /**
                         * InstanceProperties keyRevocationActionType.
                         * @member {string|null|undefined} keyRevocationActionType
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.keyRevocationActionType = null;
    
                        /**
                         * InstanceProperties labels.
                         * @member {Object.<string,string>} labels
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.labels = $util.emptyObject;
    
                        /**
                         * InstanceProperties machineType.
                         * @member {string|null|undefined} machineType
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.machineType = null;
    
                        /**
                         * InstanceProperties metadata.
                         * @member {google.cloud.compute.v1.IMetadata|null|undefined} metadata
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.metadata = null;
    
                        /**
                         * InstanceProperties minCpuPlatform.
                         * @member {string|null|undefined} minCpuPlatform
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.minCpuPlatform = null;
    
                        /**
                         * InstanceProperties networkInterfaces.
                         * @member {Array.<google.cloud.compute.v1.INetworkInterface>} networkInterfaces
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.networkInterfaces = $util.emptyArray;
    
                        /**
                         * InstanceProperties networkPerformanceConfig.
                         * @member {google.cloud.compute.v1.INetworkPerformanceConfig|null|undefined} networkPerformanceConfig
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.networkPerformanceConfig = null;
    
                        /**
                         * InstanceProperties privateIpv6GoogleAccess.
                         * @member {string|null|undefined} privateIpv6GoogleAccess
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.privateIpv6GoogleAccess = null;
    
                        /**
                         * InstanceProperties reservationAffinity.
                         * @member {google.cloud.compute.v1.IReservationAffinity|null|undefined} reservationAffinity
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.reservationAffinity = null;
    
                        /**
                         * InstanceProperties resourceManagerTags.
                         * @member {Object.<string,string>} resourceManagerTags
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.resourceManagerTags = $util.emptyObject;
    
                        /**
                         * InstanceProperties resourcePolicies.
                         * @member {Array.<string>} resourcePolicies
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.resourcePolicies = $util.emptyArray;
    
                        /**
                         * InstanceProperties scheduling.
                         * @member {google.cloud.compute.v1.IScheduling|null|undefined} scheduling
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.scheduling = null;
    
                        /**
                         * InstanceProperties serviceAccounts.
                         * @member {Array.<google.cloud.compute.v1.IServiceAccount>} serviceAccounts
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.serviceAccounts = $util.emptyArray;
    
                        /**
                         * InstanceProperties shieldedInstanceConfig.
                         * @member {google.cloud.compute.v1.IShieldedInstanceConfig|null|undefined} shieldedInstanceConfig
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.shieldedInstanceConfig = null;
    
                        /**
                         * InstanceProperties tags.
                         * @member {google.cloud.compute.v1.ITags|null|undefined} tags
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        InstanceProperties.prototype.tags = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceProperties _advancedMachineFeatures.
                         * @member {"advancedMachineFeatures"|undefined} _advancedMachineFeatures
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        Object.defineProperty(InstanceProperties.prototype, "_advancedMachineFeatures", {
                            get: $util.oneOfGetter($oneOfFields = ["advancedMachineFeatures"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceProperties _canIpForward.
                         * @member {"canIpForward"|undefined} _canIpForward
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        Object.defineProperty(InstanceProperties.prototype, "_canIpForward", {
                            get: $util.oneOfGetter($oneOfFields = ["canIpForward"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceProperties _confidentialInstanceConfig.
                         * @member {"confidentialInstanceConfig"|undefined} _confidentialInstanceConfig
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        Object.defineProperty(InstanceProperties.prototype, "_confidentialInstanceConfig", {
                            get: $util.oneOfGetter($oneOfFields = ["confidentialInstanceConfig"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceProperties _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        Object.defineProperty(InstanceProperties.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceProperties _keyRevocationActionType.
                         * @member {"keyRevocationActionType"|undefined} _keyRevocationActionType
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        Object.defineProperty(InstanceProperties.prototype, "_keyRevocationActionType", {
                            get: $util.oneOfGetter($oneOfFields = ["keyRevocationActionType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceProperties _machineType.
                         * @member {"machineType"|undefined} _machineType
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        Object.defineProperty(InstanceProperties.prototype, "_machineType", {
                            get: $util.oneOfGetter($oneOfFields = ["machineType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceProperties _metadata.
                         * @member {"metadata"|undefined} _metadata
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        Object.defineProperty(InstanceProperties.prototype, "_metadata", {
                            get: $util.oneOfGetter($oneOfFields = ["metadata"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceProperties _minCpuPlatform.
                         * @member {"minCpuPlatform"|undefined} _minCpuPlatform
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        Object.defineProperty(InstanceProperties.prototype, "_minCpuPlatform", {
                            get: $util.oneOfGetter($oneOfFields = ["minCpuPlatform"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceProperties _networkPerformanceConfig.
                         * @member {"networkPerformanceConfig"|undefined} _networkPerformanceConfig
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        Object.defineProperty(InstanceProperties.prototype, "_networkPerformanceConfig", {
                            get: $util.oneOfGetter($oneOfFields = ["networkPerformanceConfig"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceProperties _privateIpv6GoogleAccess.
                         * @member {"privateIpv6GoogleAccess"|undefined} _privateIpv6GoogleAccess
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        Object.defineProperty(InstanceProperties.prototype, "_privateIpv6GoogleAccess", {
                            get: $util.oneOfGetter($oneOfFields = ["privateIpv6GoogleAccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceProperties _reservationAffinity.
                         * @member {"reservationAffinity"|undefined} _reservationAffinity
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        Object.defineProperty(InstanceProperties.prototype, "_reservationAffinity", {
                            get: $util.oneOfGetter($oneOfFields = ["reservationAffinity"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceProperties _scheduling.
                         * @member {"scheduling"|undefined} _scheduling
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        Object.defineProperty(InstanceProperties.prototype, "_scheduling", {
                            get: $util.oneOfGetter($oneOfFields = ["scheduling"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceProperties _shieldedInstanceConfig.
                         * @member {"shieldedInstanceConfig"|undefined} _shieldedInstanceConfig
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        Object.defineProperty(InstanceProperties.prototype, "_shieldedInstanceConfig", {
                            get: $util.oneOfGetter($oneOfFields = ["shieldedInstanceConfig"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceProperties _tags.
                         * @member {"tags"|undefined} _tags
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         */
                        Object.defineProperty(InstanceProperties.prototype, "_tags", {
                            get: $util.oneOfGetter($oneOfFields = ["tags"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceProperties instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceProperties=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceProperties} InstanceProperties instance
                         */
                        InstanceProperties.create = function create(properties) {
                            return new InstanceProperties(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceProperties message. Does not implicitly {@link google.cloud.compute.v1.InstanceProperties.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceProperties} message InstanceProperties message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceProperties.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.tags != null && Object.hasOwnProperty.call(message, "tags"))
                                $root.google.cloud.compute.v1.Tags.encode(message.tags, writer.uint32(/* id 3552281, wireType 2 =*/28418250).fork()).ldelim();
                            if (message.shieldedInstanceConfig != null && Object.hasOwnProperty.call(message, "shieldedInstanceConfig"))
                                $root.google.cloud.compute.v1.ShieldedInstanceConfig.encode(message.shieldedInstanceConfig, writer.uint32(/* id 12862901, wireType 2 =*/102903210).fork()).ldelim();
                            if (message.resourcePolicies != null && message.resourcePolicies.length)
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    writer.uint32(/* id 22220385, wireType 2 =*/177763082).string(message.resourcePolicies[i]);
                            if (message.privateIpv6GoogleAccess != null && Object.hasOwnProperty.call(message, "privateIpv6GoogleAccess"))
                                writer.uint32(/* id 48277006, wireType 2 =*/386216050).string(message.privateIpv6GoogleAccess);
                            if (message.networkInterfaces != null && message.networkInterfaces.length)
                                for (var i = 0; i < message.networkInterfaces.length; ++i)
                                    $root.google.cloud.compute.v1.NetworkInterface.encode(message.networkInterfaces[i], writer.uint32(/* id 52735243, wireType 2 =*/421881946).fork()).ldelim();
                            if (message.metadata != null && Object.hasOwnProperty.call(message, "metadata"))
                                $root.google.cloud.compute.v1.Metadata.encode(message.metadata, writer.uint32(/* id 86866735, wireType 2 =*/694933882).fork()).ldelim();
                            if (message.disks != null && message.disks.length)
                                for (var i = 0; i < message.disks.length; ++i)
                                    $root.google.cloud.compute.v1.AttachedDisk.encode(message.disks[i], writer.uint32(/* id 95594102, wireType 2 =*/764752818).fork()).ldelim();
                            if (message.reservationAffinity != null && Object.hasOwnProperty.call(message, "reservationAffinity"))
                                $root.google.cloud.compute.v1.ReservationAffinity.encode(message.reservationAffinity, writer.uint32(/* id 157850683, wireType 2 =*/1262805466).fork()).ldelim();
                            if (message.machineType != null && Object.hasOwnProperty.call(message, "machineType"))
                                writer.uint32(/* id 227711026, wireType 2 =*/1821688210).string(message.machineType);
                            if (message.keyRevocationActionType != null && Object.hasOwnProperty.call(message, "keyRevocationActionType"))
                                writer.uint32(/* id 235941474, wireType 2 =*/1887531794).string(message.keyRevocationActionType);
                            if (message.minCpuPlatform != null && Object.hasOwnProperty.call(message, "minCpuPlatform"))
                                writer.uint32(/* id 242912759, wireType 2 =*/1943302074).string(message.minCpuPlatform);
                            if (message.serviceAccounts != null && message.serviceAccounts.length)
                                for (var i = 0; i < message.serviceAccounts.length; ++i)
                                    $root.google.cloud.compute.v1.ServiceAccount.encode(message.serviceAccounts[i], writer.uint32(/* id 277537328, wireType 2 =*/2220298626).fork()).ldelim();
                            if (message.resourceManagerTags != null && Object.hasOwnProperty.call(message, "resourceManagerTags"))
                                for (var keys = Object.keys(message.resourceManagerTags), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 377671164, wireType 2 =*/3021369314).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.resourceManagerTags[keys[i]]).ldelim();
                            if (message.scheduling != null && Object.hasOwnProperty.call(message, "scheduling"))
                                $root.google.cloud.compute.v1.Scheduling.encode(message.scheduling, writer.uint32(/* id 386688404, wireType 2 =*/3093507234).fork()).ldelim();
                            if (message.networkPerformanceConfig != null && Object.hasOwnProperty.call(message, "networkPerformanceConfig"))
                                $root.google.cloud.compute.v1.NetworkPerformanceConfig.encode(message.networkPerformanceConfig, writer.uint32(/* id 398330850, wireType 2 =*/3186646802).fork()).ldelim();
                            if (message.advancedMachineFeatures != null && Object.hasOwnProperty.call(message, "advancedMachineFeatures"))
                                $root.google.cloud.compute.v1.AdvancedMachineFeatures.encode(message.advancedMachineFeatures, writer.uint32(/* id 409646002, wireType 2 =*/3277168018).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.guestAccelerators != null && message.guestAccelerators.length)
                                for (var i = 0; i < message.guestAccelerators.length; ++i)
                                    $root.google.cloud.compute.v1.AcceleratorConfig.encode(message.guestAccelerators[i], writer.uint32(/* id 463595119, wireType 2 =*/3708760954).fork()).ldelim();
                            if (message.canIpForward != null && Object.hasOwnProperty.call(message, "canIpForward"))
                                writer.uint32(/* id 467731324, wireType 0 =*/3741850592).bool(message.canIpForward);
                            if (message.confidentialInstanceConfig != null && Object.hasOwnProperty.call(message, "confidentialInstanceConfig"))
                                $root.google.cloud.compute.v1.ConfidentialInstanceConfig.encode(message.confidentialInstanceConfig, writer.uint32(/* id 490637685, wireType 2 =*/3925101482).fork()).ldelim();
                            if (message.labels != null && Object.hasOwnProperty.call(message, "labels"))
                                for (var keys = Object.keys(message.labels), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 500195327, wireType 2 =*/4001562618).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.labels[keys[i]]).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceProperties message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceProperties.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceProperties} message InstanceProperties message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceProperties.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceProperties message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceProperties} InstanceProperties
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceProperties.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceProperties(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 409646002: {
                                        message.advancedMachineFeatures = $root.google.cloud.compute.v1.AdvancedMachineFeatures.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 467731324: {
                                        message.canIpForward = reader.bool();
                                        break;
                                    }
                                case 490637685: {
                                        message.confidentialInstanceConfig = $root.google.cloud.compute.v1.ConfidentialInstanceConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 95594102: {
                                        if (!(message.disks && message.disks.length))
                                            message.disks = [];
                                        message.disks.push($root.google.cloud.compute.v1.AttachedDisk.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 463595119: {
                                        if (!(message.guestAccelerators && message.guestAccelerators.length))
                                            message.guestAccelerators = [];
                                        message.guestAccelerators.push($root.google.cloud.compute.v1.AcceleratorConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 235941474: {
                                        message.keyRevocationActionType = reader.string();
                                        break;
                                    }
                                case 500195327: {
                                        if (message.labels === $util.emptyObject)
                                            message.labels = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.labels[key] = value;
                                        break;
                                    }
                                case 227711026: {
                                        message.machineType = reader.string();
                                        break;
                                    }
                                case 86866735: {
                                        message.metadata = $root.google.cloud.compute.v1.Metadata.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 242912759: {
                                        message.minCpuPlatform = reader.string();
                                        break;
                                    }
                                case 52735243: {
                                        if (!(message.networkInterfaces && message.networkInterfaces.length))
                                            message.networkInterfaces = [];
                                        message.networkInterfaces.push($root.google.cloud.compute.v1.NetworkInterface.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 398330850: {
                                        message.networkPerformanceConfig = $root.google.cloud.compute.v1.NetworkPerformanceConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 48277006: {
                                        message.privateIpv6GoogleAccess = reader.string();
                                        break;
                                    }
                                case 157850683: {
                                        message.reservationAffinity = $root.google.cloud.compute.v1.ReservationAffinity.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 377671164: {
                                        if (message.resourceManagerTags === $util.emptyObject)
                                            message.resourceManagerTags = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.resourceManagerTags[key] = value;
                                        break;
                                    }
                                case 22220385: {
                                        if (!(message.resourcePolicies && message.resourcePolicies.length))
                                            message.resourcePolicies = [];
                                        message.resourcePolicies.push(reader.string());
                                        break;
                                    }
                                case 386688404: {
                                        message.scheduling = $root.google.cloud.compute.v1.Scheduling.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 277537328: {
                                        if (!(message.serviceAccounts && message.serviceAccounts.length))
                                            message.serviceAccounts = [];
                                        message.serviceAccounts.push($root.google.cloud.compute.v1.ServiceAccount.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 12862901: {
                                        message.shieldedInstanceConfig = $root.google.cloud.compute.v1.ShieldedInstanceConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3552281: {
                                        message.tags = $root.google.cloud.compute.v1.Tags.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceProperties message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceProperties} InstanceProperties
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceProperties.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceProperties message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceProperties.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.advancedMachineFeatures != null && message.hasOwnProperty("advancedMachineFeatures")) {
                                properties._advancedMachineFeatures = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.AdvancedMachineFeatures.verify(message.advancedMachineFeatures);
                                    if (error)
                                        return "advancedMachineFeatures." + error;
                                }
                            }
                            if (message.canIpForward != null && message.hasOwnProperty("canIpForward")) {
                                properties._canIpForward = 1;
                                if (typeof message.canIpForward !== "boolean")
                                    return "canIpForward: boolean expected";
                            }
                            if (message.confidentialInstanceConfig != null && message.hasOwnProperty("confidentialInstanceConfig")) {
                                properties._confidentialInstanceConfig = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ConfidentialInstanceConfig.verify(message.confidentialInstanceConfig);
                                    if (error)
                                        return "confidentialInstanceConfig." + error;
                                }
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.disks != null && message.hasOwnProperty("disks")) {
                                if (!Array.isArray(message.disks))
                                    return "disks: array expected";
                                for (var i = 0; i < message.disks.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AttachedDisk.verify(message.disks[i]);
                                    if (error)
                                        return "disks." + error;
                                }
                            }
                            if (message.guestAccelerators != null && message.hasOwnProperty("guestAccelerators")) {
                                if (!Array.isArray(message.guestAccelerators))
                                    return "guestAccelerators: array expected";
                                for (var i = 0; i < message.guestAccelerators.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AcceleratorConfig.verify(message.guestAccelerators[i]);
                                    if (error)
                                        return "guestAccelerators." + error;
                                }
                            }
                            if (message.keyRevocationActionType != null && message.hasOwnProperty("keyRevocationActionType")) {
                                properties._keyRevocationActionType = 1;
                                if (!$util.isString(message.keyRevocationActionType))
                                    return "keyRevocationActionType: string expected";
                            }
                            if (message.labels != null && message.hasOwnProperty("labels")) {
                                if (!$util.isObject(message.labels))
                                    return "labels: object expected";
                                var key = Object.keys(message.labels);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.labels[key[i]]))
                                        return "labels: string{k:string} expected";
                            }
                            if (message.machineType != null && message.hasOwnProperty("machineType")) {
                                properties._machineType = 1;
                                if (!$util.isString(message.machineType))
                                    return "machineType: string expected";
                            }
                            if (message.metadata != null && message.hasOwnProperty("metadata")) {
                                properties._metadata = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Metadata.verify(message.metadata);
                                    if (error)
                                        return "metadata." + error;
                                }
                            }
                            if (message.minCpuPlatform != null && message.hasOwnProperty("minCpuPlatform")) {
                                properties._minCpuPlatform = 1;
                                if (!$util.isString(message.minCpuPlatform))
                                    return "minCpuPlatform: string expected";
                            }
                            if (message.networkInterfaces != null && message.hasOwnProperty("networkInterfaces")) {
                                if (!Array.isArray(message.networkInterfaces))
                                    return "networkInterfaces: array expected";
                                for (var i = 0; i < message.networkInterfaces.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NetworkInterface.verify(message.networkInterfaces[i]);
                                    if (error)
                                        return "networkInterfaces." + error;
                                }
                            }
                            if (message.networkPerformanceConfig != null && message.hasOwnProperty("networkPerformanceConfig")) {
                                properties._networkPerformanceConfig = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.NetworkPerformanceConfig.verify(message.networkPerformanceConfig);
                                    if (error)
                                        return "networkPerformanceConfig." + error;
                                }
                            }
                            if (message.privateIpv6GoogleAccess != null && message.hasOwnProperty("privateIpv6GoogleAccess")) {
                                properties._privateIpv6GoogleAccess = 1;
                                if (!$util.isString(message.privateIpv6GoogleAccess))
                                    return "privateIpv6GoogleAccess: string expected";
                            }
                            if (message.reservationAffinity != null && message.hasOwnProperty("reservationAffinity")) {
                                properties._reservationAffinity = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ReservationAffinity.verify(message.reservationAffinity);
                                    if (error)
                                        return "reservationAffinity." + error;
                                }
                            }
                            if (message.resourceManagerTags != null && message.hasOwnProperty("resourceManagerTags")) {
                                if (!$util.isObject(message.resourceManagerTags))
                                    return "resourceManagerTags: object expected";
                                var key = Object.keys(message.resourceManagerTags);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.resourceManagerTags[key[i]]))
                                        return "resourceManagerTags: string{k:string} expected";
                            }
                            if (message.resourcePolicies != null && message.hasOwnProperty("resourcePolicies")) {
                                if (!Array.isArray(message.resourcePolicies))
                                    return "resourcePolicies: array expected";
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    if (!$util.isString(message.resourcePolicies[i]))
                                        return "resourcePolicies: string[] expected";
                            }
                            if (message.scheduling != null && message.hasOwnProperty("scheduling")) {
                                properties._scheduling = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Scheduling.verify(message.scheduling);
                                    if (error)
                                        return "scheduling." + error;
                                }
                            }
                            if (message.serviceAccounts != null && message.hasOwnProperty("serviceAccounts")) {
                                if (!Array.isArray(message.serviceAccounts))
                                    return "serviceAccounts: array expected";
                                for (var i = 0; i < message.serviceAccounts.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ServiceAccount.verify(message.serviceAccounts[i]);
                                    if (error)
                                        return "serviceAccounts." + error;
                                }
                            }
                            if (message.shieldedInstanceConfig != null && message.hasOwnProperty("shieldedInstanceConfig")) {
                                properties._shieldedInstanceConfig = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ShieldedInstanceConfig.verify(message.shieldedInstanceConfig);
                                    if (error)
                                        return "shieldedInstanceConfig." + error;
                                }
                            }
                            if (message.tags != null && message.hasOwnProperty("tags")) {
                                properties._tags = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Tags.verify(message.tags);
                                    if (error)
                                        return "tags." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceProperties message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceProperties} InstanceProperties
                         */
                        InstanceProperties.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceProperties)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceProperties();
                            if (object.advancedMachineFeatures != null) {
                                if (typeof object.advancedMachineFeatures !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceProperties.advancedMachineFeatures: object expected");
                                message.advancedMachineFeatures = $root.google.cloud.compute.v1.AdvancedMachineFeatures.fromObject(object.advancedMachineFeatures);
                            }
                            if (object.canIpForward != null)
                                message.canIpForward = Boolean(object.canIpForward);
                            if (object.confidentialInstanceConfig != null) {
                                if (typeof object.confidentialInstanceConfig !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceProperties.confidentialInstanceConfig: object expected");
                                message.confidentialInstanceConfig = $root.google.cloud.compute.v1.ConfidentialInstanceConfig.fromObject(object.confidentialInstanceConfig);
                            }
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.disks) {
                                if (!Array.isArray(object.disks))
                                    throw TypeError(".google.cloud.compute.v1.InstanceProperties.disks: array expected");
                                message.disks = [];
                                for (var i = 0; i < object.disks.length; ++i) {
                                    if (typeof object.disks[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceProperties.disks: object expected");
                                    message.disks[i] = $root.google.cloud.compute.v1.AttachedDisk.fromObject(object.disks[i]);
                                }
                            }
                            if (object.guestAccelerators) {
                                if (!Array.isArray(object.guestAccelerators))
                                    throw TypeError(".google.cloud.compute.v1.InstanceProperties.guestAccelerators: array expected");
                                message.guestAccelerators = [];
                                for (var i = 0; i < object.guestAccelerators.length; ++i) {
                                    if (typeof object.guestAccelerators[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceProperties.guestAccelerators: object expected");
                                    message.guestAccelerators[i] = $root.google.cloud.compute.v1.AcceleratorConfig.fromObject(object.guestAccelerators[i]);
                                }
                            }
                            if (object.keyRevocationActionType != null)
                                message.keyRevocationActionType = String(object.keyRevocationActionType);
                            if (object.labels) {
                                if (typeof object.labels !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceProperties.labels: object expected");
                                message.labels = {};
                                for (var keys = Object.keys(object.labels), i = 0; i < keys.length; ++i)
                                    message.labels[keys[i]] = String(object.labels[keys[i]]);
                            }
                            if (object.machineType != null)
                                message.machineType = String(object.machineType);
                            if (object.metadata != null) {
                                if (typeof object.metadata !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceProperties.metadata: object expected");
                                message.metadata = $root.google.cloud.compute.v1.Metadata.fromObject(object.metadata);
                            }
                            if (object.minCpuPlatform != null)
                                message.minCpuPlatform = String(object.minCpuPlatform);
                            if (object.networkInterfaces) {
                                if (!Array.isArray(object.networkInterfaces))
                                    throw TypeError(".google.cloud.compute.v1.InstanceProperties.networkInterfaces: array expected");
                                message.networkInterfaces = [];
                                for (var i = 0; i < object.networkInterfaces.length; ++i) {
                                    if (typeof object.networkInterfaces[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceProperties.networkInterfaces: object expected");
                                    message.networkInterfaces[i] = $root.google.cloud.compute.v1.NetworkInterface.fromObject(object.networkInterfaces[i]);
                                }
                            }
                            if (object.networkPerformanceConfig != null) {
                                if (typeof object.networkPerformanceConfig !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceProperties.networkPerformanceConfig: object expected");
                                message.networkPerformanceConfig = $root.google.cloud.compute.v1.NetworkPerformanceConfig.fromObject(object.networkPerformanceConfig);
                            }
                            if (object.privateIpv6GoogleAccess != null)
                                message.privateIpv6GoogleAccess = String(object.privateIpv6GoogleAccess);
                            if (object.reservationAffinity != null) {
                                if (typeof object.reservationAffinity !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceProperties.reservationAffinity: object expected");
                                message.reservationAffinity = $root.google.cloud.compute.v1.ReservationAffinity.fromObject(object.reservationAffinity);
                            }
                            if (object.resourceManagerTags) {
                                if (typeof object.resourceManagerTags !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceProperties.resourceManagerTags: object expected");
                                message.resourceManagerTags = {};
                                for (var keys = Object.keys(object.resourceManagerTags), i = 0; i < keys.length; ++i)
                                    message.resourceManagerTags[keys[i]] = String(object.resourceManagerTags[keys[i]]);
                            }
                            if (object.resourcePolicies) {
                                if (!Array.isArray(object.resourcePolicies))
                                    throw TypeError(".google.cloud.compute.v1.InstanceProperties.resourcePolicies: array expected");
                                message.resourcePolicies = [];
                                for (var i = 0; i < object.resourcePolicies.length; ++i)
                                    message.resourcePolicies[i] = String(object.resourcePolicies[i]);
                            }
                            if (object.scheduling != null) {
                                if (typeof object.scheduling !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceProperties.scheduling: object expected");
                                message.scheduling = $root.google.cloud.compute.v1.Scheduling.fromObject(object.scheduling);
                            }
                            if (object.serviceAccounts) {
                                if (!Array.isArray(object.serviceAccounts))
                                    throw TypeError(".google.cloud.compute.v1.InstanceProperties.serviceAccounts: array expected");
                                message.serviceAccounts = [];
                                for (var i = 0; i < object.serviceAccounts.length; ++i) {
                                    if (typeof object.serviceAccounts[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceProperties.serviceAccounts: object expected");
                                    message.serviceAccounts[i] = $root.google.cloud.compute.v1.ServiceAccount.fromObject(object.serviceAccounts[i]);
                                }
                            }
                            if (object.shieldedInstanceConfig != null) {
                                if (typeof object.shieldedInstanceConfig !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceProperties.shieldedInstanceConfig: object expected");
                                message.shieldedInstanceConfig = $root.google.cloud.compute.v1.ShieldedInstanceConfig.fromObject(object.shieldedInstanceConfig);
                            }
                            if (object.tags != null) {
                                if (typeof object.tags !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceProperties.tags: object expected");
                                message.tags = $root.google.cloud.compute.v1.Tags.fromObject(object.tags);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceProperties message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @static
                         * @param {google.cloud.compute.v1.InstanceProperties} message InstanceProperties
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceProperties.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.resourcePolicies = [];
                                object.networkInterfaces = [];
                                object.disks = [];
                                object.serviceAccounts = [];
                                object.guestAccelerators = [];
                            }
                            if (options.objects || options.defaults) {
                                object.resourceManagerTags = {};
                                object.labels = {};
                            }
                            if (message.tags != null && message.hasOwnProperty("tags")) {
                                object.tags = $root.google.cloud.compute.v1.Tags.toObject(message.tags, options);
                                if (options.oneofs)
                                    object._tags = "tags";
                            }
                            if (message.shieldedInstanceConfig != null && message.hasOwnProperty("shieldedInstanceConfig")) {
                                object.shieldedInstanceConfig = $root.google.cloud.compute.v1.ShieldedInstanceConfig.toObject(message.shieldedInstanceConfig, options);
                                if (options.oneofs)
                                    object._shieldedInstanceConfig = "shieldedInstanceConfig";
                            }
                            if (message.resourcePolicies && message.resourcePolicies.length) {
                                object.resourcePolicies = [];
                                for (var j = 0; j < message.resourcePolicies.length; ++j)
                                    object.resourcePolicies[j] = message.resourcePolicies[j];
                            }
                            if (message.privateIpv6GoogleAccess != null && message.hasOwnProperty("privateIpv6GoogleAccess")) {
                                object.privateIpv6GoogleAccess = message.privateIpv6GoogleAccess;
                                if (options.oneofs)
                                    object._privateIpv6GoogleAccess = "privateIpv6GoogleAccess";
                            }
                            if (message.networkInterfaces && message.networkInterfaces.length) {
                                object.networkInterfaces = [];
                                for (var j = 0; j < message.networkInterfaces.length; ++j)
                                    object.networkInterfaces[j] = $root.google.cloud.compute.v1.NetworkInterface.toObject(message.networkInterfaces[j], options);
                            }
                            if (message.metadata != null && message.hasOwnProperty("metadata")) {
                                object.metadata = $root.google.cloud.compute.v1.Metadata.toObject(message.metadata, options);
                                if (options.oneofs)
                                    object._metadata = "metadata";
                            }
                            if (message.disks && message.disks.length) {
                                object.disks = [];
                                for (var j = 0; j < message.disks.length; ++j)
                                    object.disks[j] = $root.google.cloud.compute.v1.AttachedDisk.toObject(message.disks[j], options);
                            }
                            if (message.reservationAffinity != null && message.hasOwnProperty("reservationAffinity")) {
                                object.reservationAffinity = $root.google.cloud.compute.v1.ReservationAffinity.toObject(message.reservationAffinity, options);
                                if (options.oneofs)
                                    object._reservationAffinity = "reservationAffinity";
                            }
                            if (message.machineType != null && message.hasOwnProperty("machineType")) {
                                object.machineType = message.machineType;
                                if (options.oneofs)
                                    object._machineType = "machineType";
                            }
                            if (message.keyRevocationActionType != null && message.hasOwnProperty("keyRevocationActionType")) {
                                object.keyRevocationActionType = message.keyRevocationActionType;
                                if (options.oneofs)
                                    object._keyRevocationActionType = "keyRevocationActionType";
                            }
                            if (message.minCpuPlatform != null && message.hasOwnProperty("minCpuPlatform")) {
                                object.minCpuPlatform = message.minCpuPlatform;
                                if (options.oneofs)
                                    object._minCpuPlatform = "minCpuPlatform";
                            }
                            if (message.serviceAccounts && message.serviceAccounts.length) {
                                object.serviceAccounts = [];
                                for (var j = 0; j < message.serviceAccounts.length; ++j)
                                    object.serviceAccounts[j] = $root.google.cloud.compute.v1.ServiceAccount.toObject(message.serviceAccounts[j], options);
                            }
                            var keys2;
                            if (message.resourceManagerTags && (keys2 = Object.keys(message.resourceManagerTags)).length) {
                                object.resourceManagerTags = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.resourceManagerTags[keys2[j]] = message.resourceManagerTags[keys2[j]];
                            }
                            if (message.scheduling != null && message.hasOwnProperty("scheduling")) {
                                object.scheduling = $root.google.cloud.compute.v1.Scheduling.toObject(message.scheduling, options);
                                if (options.oneofs)
                                    object._scheduling = "scheduling";
                            }
                            if (message.networkPerformanceConfig != null && message.hasOwnProperty("networkPerformanceConfig")) {
                                object.networkPerformanceConfig = $root.google.cloud.compute.v1.NetworkPerformanceConfig.toObject(message.networkPerformanceConfig, options);
                                if (options.oneofs)
                                    object._networkPerformanceConfig = "networkPerformanceConfig";
                            }
                            if (message.advancedMachineFeatures != null && message.hasOwnProperty("advancedMachineFeatures")) {
                                object.advancedMachineFeatures = $root.google.cloud.compute.v1.AdvancedMachineFeatures.toObject(message.advancedMachineFeatures, options);
                                if (options.oneofs)
                                    object._advancedMachineFeatures = "advancedMachineFeatures";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.guestAccelerators && message.guestAccelerators.length) {
                                object.guestAccelerators = [];
                                for (var j = 0; j < message.guestAccelerators.length; ++j)
                                    object.guestAccelerators[j] = $root.google.cloud.compute.v1.AcceleratorConfig.toObject(message.guestAccelerators[j], options);
                            }
                            if (message.canIpForward != null && message.hasOwnProperty("canIpForward")) {
                                object.canIpForward = message.canIpForward;
                                if (options.oneofs)
                                    object._canIpForward = "canIpForward";
                            }
                            if (message.confidentialInstanceConfig != null && message.hasOwnProperty("confidentialInstanceConfig")) {
                                object.confidentialInstanceConfig = $root.google.cloud.compute.v1.ConfidentialInstanceConfig.toObject(message.confidentialInstanceConfig, options);
                                if (options.oneofs)
                                    object._confidentialInstanceConfig = "confidentialInstanceConfig";
                            }
                            if (message.labels && (keys2 = Object.keys(message.labels)).length) {
                                object.labels = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.labels[keys2[j]] = message.labels[keys2[j]];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceProperties to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceProperties.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceProperties
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceProperties
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceProperties.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceProperties";
                        };
    
                        /**
                         * KeyRevocationActionType enum.
                         * @name google.cloud.compute.v1.InstanceProperties.KeyRevocationActionType
                         * @enum {number}
                         * @property {number} UNDEFINED_KEY_REVOCATION_ACTION_TYPE=0 UNDEFINED_KEY_REVOCATION_ACTION_TYPE value
                         * @property {number} KEY_REVOCATION_ACTION_TYPE_UNSPECIFIED=467110106 KEY_REVOCATION_ACTION_TYPE_UNSPECIFIED value
                         * @property {number} NONE=2402104 NONE value
                         * @property {number} STOP=2555906 STOP value
                         */
                        InstanceProperties.KeyRevocationActionType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_KEY_REVOCATION_ACTION_TYPE"] = 0;
                            values[valuesById[467110106] = "KEY_REVOCATION_ACTION_TYPE_UNSPECIFIED"] = 467110106;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            values[valuesById[2555906] = "STOP"] = 2555906;
                            return values;
                        })();
    
                        /**
                         * PrivateIpv6GoogleAccess enum.
                         * @name google.cloud.compute.v1.InstanceProperties.PrivateIpv6GoogleAccess
                         * @enum {number}
                         * @property {number} UNDEFINED_PRIVATE_IPV6_GOOGLE_ACCESS=0 UNDEFINED_PRIVATE_IPV6_GOOGLE_ACCESS value
                         * @property {number} ENABLE_BIDIRECTIONAL_ACCESS_TO_GOOGLE=427975994 ENABLE_BIDIRECTIONAL_ACCESS_TO_GOOGLE value
                         * @property {number} ENABLE_OUTBOUND_VM_ACCESS_TO_GOOGLE=288210263 ENABLE_OUTBOUND_VM_ACCESS_TO_GOOGLE value
                         * @property {number} INHERIT_FROM_SUBNETWORK=530256959 INHERIT_FROM_SUBNETWORK value
                         */
                        InstanceProperties.PrivateIpv6GoogleAccess = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PRIVATE_IPV6_GOOGLE_ACCESS"] = 0;
                            values[valuesById[427975994] = "ENABLE_BIDIRECTIONAL_ACCESS_TO_GOOGLE"] = 427975994;
                            values[valuesById[288210263] = "ENABLE_OUTBOUND_VM_ACCESS_TO_GOOGLE"] = 288210263;
                            values[valuesById[530256959] = "INHERIT_FROM_SUBNETWORK"] = 530256959;
                            return values;
                        })();
    
                        return InstanceProperties;
                    })();
    
                    v1.InstanceReference = (function() {
    
                        /**
                         * Properties of an InstanceReference.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceReference
                         * @property {string|null} [instance] InstanceReference instance
                         */
    
                        /**
                         * Constructs a new InstanceReference.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceReference.
                         * @implements IInstanceReference
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceReference=} [properties] Properties to set
                         */
                        function InstanceReference(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceReference instance.
                         * @member {string|null|undefined} instance
                         * @memberof google.cloud.compute.v1.InstanceReference
                         * @instance
                         */
                        InstanceReference.prototype.instance = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceReference _instance.
                         * @member {"instance"|undefined} _instance
                         * @memberof google.cloud.compute.v1.InstanceReference
                         * @instance
                         */
                        Object.defineProperty(InstanceReference.prototype, "_instance", {
                            get: $util.oneOfGetter($oneOfFields = ["instance"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceReference instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceReference
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceReference=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceReference} InstanceReference instance
                         */
                        InstanceReference.create = function create(properties) {
                            return new InstanceReference(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceReference message. Does not implicitly {@link google.cloud.compute.v1.InstanceReference.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceReference
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceReference} message InstanceReference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceReference.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceReference message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceReference.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceReference
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceReference} message InstanceReference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceReference.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceReference message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceReference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceReference} InstanceReference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceReference.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceReference();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceReference message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceReference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceReference} InstanceReference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceReference.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceReference message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceReference
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceReference.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance")) {
                                properties._instance = 1;
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceReference message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceReference
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceReference} InstanceReference
                         */
                        InstanceReference.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceReference)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceReference();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceReference message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceReference
                         * @static
                         * @param {google.cloud.compute.v1.InstanceReference} message InstanceReference
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceReference.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.instance != null && message.hasOwnProperty("instance")) {
                                object.instance = message.instance;
                                if (options.oneofs)
                                    object._instance = "instance";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceReference to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceReference
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceReference.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceReference
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceReference
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceReference.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceReference";
                        };
    
                        return InstanceReference;
                    })();
    
                    v1.InstanceTemplate = (function() {
    
                        /**
                         * Properties of an InstanceTemplate.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceTemplate
                         * @property {string|null} [creationTimestamp] InstanceTemplate creationTimestamp
                         * @property {string|null} [description] InstanceTemplate description
                         * @property {number|Long|null} [id] InstanceTemplate id
                         * @property {string|null} [kind] InstanceTemplate kind
                         * @property {string|null} [name] InstanceTemplate name
                         * @property {google.cloud.compute.v1.IInstanceProperties|null} [properties] InstanceTemplate properties
                         * @property {string|null} [selfLink] InstanceTemplate selfLink
                         * @property {string|null} [sourceInstance] InstanceTemplate sourceInstance
                         * @property {google.cloud.compute.v1.ISourceInstanceParams|null} [sourceInstanceParams] InstanceTemplate sourceInstanceParams
                         */
    
                        /**
                         * Constructs a new InstanceTemplate.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceTemplate.
                         * @implements IInstanceTemplate
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceTemplate=} [properties] Properties to set
                         */
                        function InstanceTemplate(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceTemplate creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @instance
                         */
                        InstanceTemplate.prototype.creationTimestamp = null;
    
                        /**
                         * InstanceTemplate description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @instance
                         */
                        InstanceTemplate.prototype.description = null;
    
                        /**
                         * InstanceTemplate id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @instance
                         */
                        InstanceTemplate.prototype.id = null;
    
                        /**
                         * InstanceTemplate kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @instance
                         */
                        InstanceTemplate.prototype.kind = null;
    
                        /**
                         * InstanceTemplate name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @instance
                         */
                        InstanceTemplate.prototype.name = null;
    
                        /**
                         * InstanceTemplate properties.
                         * @member {google.cloud.compute.v1.IInstanceProperties|null|undefined} properties
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @instance
                         */
                        InstanceTemplate.prototype.properties = null;
    
                        /**
                         * InstanceTemplate selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @instance
                         */
                        InstanceTemplate.prototype.selfLink = null;
    
                        /**
                         * InstanceTemplate sourceInstance.
                         * @member {string|null|undefined} sourceInstance
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @instance
                         */
                        InstanceTemplate.prototype.sourceInstance = null;
    
                        /**
                         * InstanceTemplate sourceInstanceParams.
                         * @member {google.cloud.compute.v1.ISourceInstanceParams|null|undefined} sourceInstanceParams
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @instance
                         */
                        InstanceTemplate.prototype.sourceInstanceParams = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceTemplate _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @instance
                         */
                        Object.defineProperty(InstanceTemplate.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceTemplate _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @instance
                         */
                        Object.defineProperty(InstanceTemplate.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceTemplate _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @instance
                         */
                        Object.defineProperty(InstanceTemplate.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceTemplate _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @instance
                         */
                        Object.defineProperty(InstanceTemplate.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceTemplate _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @instance
                         */
                        Object.defineProperty(InstanceTemplate.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceTemplate _properties.
                         * @member {"properties"|undefined} _properties
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @instance
                         */
                        Object.defineProperty(InstanceTemplate.prototype, "_properties", {
                            get: $util.oneOfGetter($oneOfFields = ["properties"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceTemplate _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @instance
                         */
                        Object.defineProperty(InstanceTemplate.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceTemplate _sourceInstance.
                         * @member {"sourceInstance"|undefined} _sourceInstance
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @instance
                         */
                        Object.defineProperty(InstanceTemplate.prototype, "_sourceInstance", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceInstance"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceTemplate _sourceInstanceParams.
                         * @member {"sourceInstanceParams"|undefined} _sourceInstanceParams
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @instance
                         */
                        Object.defineProperty(InstanceTemplate.prototype, "_sourceInstanceParams", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceInstanceParams"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceTemplate instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceTemplate=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceTemplate} InstanceTemplate instance
                         */
                        InstanceTemplate.create = function create(properties) {
                            return new InstanceTemplate(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceTemplate message. Does not implicitly {@link google.cloud.compute.v1.InstanceTemplate.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceTemplate} message InstanceTemplate message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceTemplate.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.sourceInstanceParams != null && Object.hasOwnProperty.call(message, "sourceInstanceParams"))
                                $root.google.cloud.compute.v1.SourceInstanceParams.encode(message.sourceInstanceParams, writer.uint32(/* id 135342156, wireType 2 =*/1082737250).fork()).ldelim();
                            if (message.properties != null && Object.hasOwnProperty.call(message, "properties"))
                                $root.google.cloud.compute.v1.InstanceProperties.encode(message.properties, writer.uint32(/* id 147688755, wireType 2 =*/1181510042).fork()).ldelim();
                            if (message.sourceInstance != null && Object.hasOwnProperty.call(message, "sourceInstance"))
                                writer.uint32(/* id 396315705, wireType 2 =*/3170525642).string(message.sourceInstance);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceTemplate message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceTemplate.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceTemplate} message InstanceTemplate message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceTemplate.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceTemplate message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceTemplate} InstanceTemplate
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceTemplate.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceTemplate();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 147688755: {
                                        message.properties = $root.google.cloud.compute.v1.InstanceProperties.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 396315705: {
                                        message.sourceInstance = reader.string();
                                        break;
                                    }
                                case 135342156: {
                                        message.sourceInstanceParams = $root.google.cloud.compute.v1.SourceInstanceParams.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceTemplate message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceTemplate} InstanceTemplate
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceTemplate.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceTemplate message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceTemplate.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.properties != null && message.hasOwnProperty("properties")) {
                                properties._properties = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InstanceProperties.verify(message.properties);
                                    if (error)
                                        return "properties." + error;
                                }
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.sourceInstance != null && message.hasOwnProperty("sourceInstance")) {
                                properties._sourceInstance = 1;
                                if (!$util.isString(message.sourceInstance))
                                    return "sourceInstance: string expected";
                            }
                            if (message.sourceInstanceParams != null && message.hasOwnProperty("sourceInstanceParams")) {
                                properties._sourceInstanceParams = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SourceInstanceParams.verify(message.sourceInstanceParams);
                                    if (error)
                                        return "sourceInstanceParams." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceTemplate message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceTemplate} InstanceTemplate
                         */
                        InstanceTemplate.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceTemplate)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceTemplate();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.properties != null) {
                                if (typeof object.properties !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceTemplate.properties: object expected");
                                message.properties = $root.google.cloud.compute.v1.InstanceProperties.fromObject(object.properties);
                            }
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.sourceInstance != null)
                                message.sourceInstance = String(object.sourceInstance);
                            if (object.sourceInstanceParams != null) {
                                if (typeof object.sourceInstanceParams !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceTemplate.sourceInstanceParams: object expected");
                                message.sourceInstanceParams = $root.google.cloud.compute.v1.SourceInstanceParams.fromObject(object.sourceInstanceParams);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceTemplate message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @static
                         * @param {google.cloud.compute.v1.InstanceTemplate} message InstanceTemplate
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceTemplate.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.sourceInstanceParams != null && message.hasOwnProperty("sourceInstanceParams")) {
                                object.sourceInstanceParams = $root.google.cloud.compute.v1.SourceInstanceParams.toObject(message.sourceInstanceParams, options);
                                if (options.oneofs)
                                    object._sourceInstanceParams = "sourceInstanceParams";
                            }
                            if (message.properties != null && message.hasOwnProperty("properties")) {
                                object.properties = $root.google.cloud.compute.v1.InstanceProperties.toObject(message.properties, options);
                                if (options.oneofs)
                                    object._properties = "properties";
                            }
                            if (message.sourceInstance != null && message.hasOwnProperty("sourceInstance")) {
                                object.sourceInstance = message.sourceInstance;
                                if (options.oneofs)
                                    object._sourceInstance = "sourceInstance";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceTemplate to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceTemplate.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceTemplate
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceTemplate
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceTemplate.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceTemplate";
                        };
    
                        return InstanceTemplate;
                    })();
    
                    v1.InstanceTemplateList = (function() {
    
                        /**
                         * Properties of an InstanceTemplateList.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceTemplateList
                         * @property {string|null} [id] InstanceTemplateList id
                         * @property {Array.<google.cloud.compute.v1.IInstanceTemplate>|null} [items] InstanceTemplateList items
                         * @property {string|null} [kind] InstanceTemplateList kind
                         * @property {string|null} [nextPageToken] InstanceTemplateList nextPageToken
                         * @property {string|null} [selfLink] InstanceTemplateList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] InstanceTemplateList warning
                         */
    
                        /**
                         * Constructs a new InstanceTemplateList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceTemplateList.
                         * @implements IInstanceTemplateList
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceTemplateList=} [properties] Properties to set
                         */
                        function InstanceTemplateList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceTemplateList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @instance
                         */
                        InstanceTemplateList.prototype.id = null;
    
                        /**
                         * InstanceTemplateList items.
                         * @member {Array.<google.cloud.compute.v1.IInstanceTemplate>} items
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @instance
                         */
                        InstanceTemplateList.prototype.items = $util.emptyArray;
    
                        /**
                         * InstanceTemplateList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @instance
                         */
                        InstanceTemplateList.prototype.kind = null;
    
                        /**
                         * InstanceTemplateList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @instance
                         */
                        InstanceTemplateList.prototype.nextPageToken = null;
    
                        /**
                         * InstanceTemplateList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @instance
                         */
                        InstanceTemplateList.prototype.selfLink = null;
    
                        /**
                         * InstanceTemplateList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @instance
                         */
                        InstanceTemplateList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceTemplateList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @instance
                         */
                        Object.defineProperty(InstanceTemplateList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceTemplateList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @instance
                         */
                        Object.defineProperty(InstanceTemplateList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceTemplateList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @instance
                         */
                        Object.defineProperty(InstanceTemplateList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceTemplateList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @instance
                         */
                        Object.defineProperty(InstanceTemplateList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceTemplateList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @instance
                         */
                        Object.defineProperty(InstanceTemplateList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceTemplateList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceTemplateList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceTemplateList} InstanceTemplateList instance
                         */
                        InstanceTemplateList.create = function create(properties) {
                            return new InstanceTemplateList(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceTemplateList message. Does not implicitly {@link google.cloud.compute.v1.InstanceTemplateList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceTemplateList} message InstanceTemplateList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceTemplateList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.InstanceTemplate.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceTemplateList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceTemplateList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceTemplateList} message InstanceTemplateList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceTemplateList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceTemplateList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceTemplateList} InstanceTemplateList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceTemplateList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceTemplateList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.InstanceTemplate.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceTemplateList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceTemplateList} InstanceTemplateList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceTemplateList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceTemplateList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceTemplateList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstanceTemplate.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceTemplateList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceTemplateList} InstanceTemplateList
                         */
                        InstanceTemplateList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceTemplateList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceTemplateList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.InstanceTemplateList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceTemplateList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.InstanceTemplate.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstanceTemplateList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceTemplateList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @static
                         * @param {google.cloud.compute.v1.InstanceTemplateList} message InstanceTemplateList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceTemplateList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.InstanceTemplate.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceTemplateList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceTemplateList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceTemplateList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceTemplateList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceTemplateList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceTemplateList";
                        };
    
                        return InstanceTemplateList;
                    })();
    
                    v1.InstanceWithNamedPorts = (function() {
    
                        /**
                         * Properties of an InstanceWithNamedPorts.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstanceWithNamedPorts
                         * @property {string|null} [instance] InstanceWithNamedPorts instance
                         * @property {Array.<google.cloud.compute.v1.INamedPort>|null} [namedPorts] InstanceWithNamedPorts namedPorts
                         * @property {string|null} [status] InstanceWithNamedPorts status
                         */
    
                        /**
                         * Constructs a new InstanceWithNamedPorts.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceWithNamedPorts.
                         * @implements IInstanceWithNamedPorts
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstanceWithNamedPorts=} [properties] Properties to set
                         */
                        function InstanceWithNamedPorts(properties) {
                            this.namedPorts = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstanceWithNamedPorts instance.
                         * @member {string|null|undefined} instance
                         * @memberof google.cloud.compute.v1.InstanceWithNamedPorts
                         * @instance
                         */
                        InstanceWithNamedPorts.prototype.instance = null;
    
                        /**
                         * InstanceWithNamedPorts namedPorts.
                         * @member {Array.<google.cloud.compute.v1.INamedPort>} namedPorts
                         * @memberof google.cloud.compute.v1.InstanceWithNamedPorts
                         * @instance
                         */
                        InstanceWithNamedPorts.prototype.namedPorts = $util.emptyArray;
    
                        /**
                         * InstanceWithNamedPorts status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.InstanceWithNamedPorts
                         * @instance
                         */
                        InstanceWithNamedPorts.prototype.status = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstanceWithNamedPorts _instance.
                         * @member {"instance"|undefined} _instance
                         * @memberof google.cloud.compute.v1.InstanceWithNamedPorts
                         * @instance
                         */
                        Object.defineProperty(InstanceWithNamedPorts.prototype, "_instance", {
                            get: $util.oneOfGetter($oneOfFields = ["instance"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstanceWithNamedPorts _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.InstanceWithNamedPorts
                         * @instance
                         */
                        Object.defineProperty(InstanceWithNamedPorts.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstanceWithNamedPorts instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceWithNamedPorts
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceWithNamedPorts=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstanceWithNamedPorts} InstanceWithNamedPorts instance
                         */
                        InstanceWithNamedPorts.create = function create(properties) {
                            return new InstanceWithNamedPorts(properties);
                        };
    
                        /**
                         * Encodes the specified InstanceWithNamedPorts message. Does not implicitly {@link google.cloud.compute.v1.InstanceWithNamedPorts.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstanceWithNamedPorts
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceWithNamedPorts} message InstanceWithNamedPorts message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceWithNamedPorts.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.namedPorts != null && message.namedPorts.length)
                                for (var i = 0; i < message.namedPorts.length; ++i)
                                    $root.google.cloud.compute.v1.NamedPort.encode(message.namedPorts[i], writer.uint32(/* id 427598732, wireType 2 =*/3420789858).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstanceWithNamedPorts message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstanceWithNamedPorts.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceWithNamedPorts
                         * @static
                         * @param {google.cloud.compute.v1.IInstanceWithNamedPorts} message InstanceWithNamedPorts message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstanceWithNamedPorts.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstanceWithNamedPorts message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstanceWithNamedPorts
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstanceWithNamedPorts} InstanceWithNamedPorts
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceWithNamedPorts.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstanceWithNamedPorts();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 427598732: {
                                        if (!(message.namedPorts && message.namedPorts.length))
                                            message.namedPorts = [];
                                        message.namedPorts.push($root.google.cloud.compute.v1.NamedPort.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstanceWithNamedPorts message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstanceWithNamedPorts
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstanceWithNamedPorts} InstanceWithNamedPorts
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstanceWithNamedPorts.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstanceWithNamedPorts message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstanceWithNamedPorts
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstanceWithNamedPorts.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance")) {
                                properties._instance = 1;
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            }
                            if (message.namedPorts != null && message.hasOwnProperty("namedPorts")) {
                                if (!Array.isArray(message.namedPorts))
                                    return "namedPorts: array expected";
                                for (var i = 0; i < message.namedPorts.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NamedPort.verify(message.namedPorts[i]);
                                    if (error)
                                        return "namedPorts." + error;
                                }
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstanceWithNamedPorts message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstanceWithNamedPorts
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstanceWithNamedPorts} InstanceWithNamedPorts
                         */
                        InstanceWithNamedPorts.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstanceWithNamedPorts)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstanceWithNamedPorts();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.namedPorts) {
                                if (!Array.isArray(object.namedPorts))
                                    throw TypeError(".google.cloud.compute.v1.InstanceWithNamedPorts.namedPorts: array expected");
                                message.namedPorts = [];
                                for (var i = 0; i < object.namedPorts.length; ++i) {
                                    if (typeof object.namedPorts[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstanceWithNamedPorts.namedPorts: object expected");
                                    message.namedPorts[i] = $root.google.cloud.compute.v1.NamedPort.fromObject(object.namedPorts[i]);
                                }
                            }
                            if (object.status != null)
                                message.status = String(object.status);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstanceWithNamedPorts message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstanceWithNamedPorts
                         * @static
                         * @param {google.cloud.compute.v1.InstanceWithNamedPorts} message InstanceWithNamedPorts
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstanceWithNamedPorts.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.namedPorts = [];
                            if (message.instance != null && message.hasOwnProperty("instance")) {
                                object.instance = message.instance;
                                if (options.oneofs)
                                    object._instance = "instance";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.namedPorts && message.namedPorts.length) {
                                object.namedPorts = [];
                                for (var j = 0; j < message.namedPorts.length; ++j)
                                    object.namedPorts[j] = $root.google.cloud.compute.v1.NamedPort.toObject(message.namedPorts[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstanceWithNamedPorts to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstanceWithNamedPorts
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstanceWithNamedPorts.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstanceWithNamedPorts
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstanceWithNamedPorts
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstanceWithNamedPorts.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstanceWithNamedPorts";
                        };
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.InstanceWithNamedPorts.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} DEPROVISIONING=428935662 DEPROVISIONING value
                         * @property {number} PROVISIONING=290896621 PROVISIONING value
                         * @property {number} REPAIRING=413483285 REPAIRING value
                         * @property {number} RUNNING=121282975 RUNNING value
                         * @property {number} STAGING=431072283 STAGING value
                         * @property {number} STOPPED=444276141 STOPPED value
                         * @property {number} STOPPING=350791796 STOPPING value
                         * @property {number} SUSPENDED=51223995 SUSPENDED value
                         * @property {number} SUSPENDING=514206246 SUSPENDING value
                         * @property {number} TERMINATED=250018339 TERMINATED value
                         */
                        InstanceWithNamedPorts.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[428935662] = "DEPROVISIONING"] = 428935662;
                            values[valuesById[290896621] = "PROVISIONING"] = 290896621;
                            values[valuesById[413483285] = "REPAIRING"] = 413483285;
                            values[valuesById[121282975] = "RUNNING"] = 121282975;
                            values[valuesById[431072283] = "STAGING"] = 431072283;
                            values[valuesById[444276141] = "STOPPED"] = 444276141;
                            values[valuesById[350791796] = "STOPPING"] = 350791796;
                            values[valuesById[51223995] = "SUSPENDED"] = 51223995;
                            values[valuesById[514206246] = "SUSPENDING"] = 514206246;
                            values[valuesById[250018339] = "TERMINATED"] = 250018339;
                            return values;
                        })();
    
                        return InstanceWithNamedPorts;
                    })();
    
                    v1.InstancesAddResourcePoliciesRequest = (function() {
    
                        /**
                         * Properties of an InstancesAddResourcePoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstancesAddResourcePoliciesRequest
                         * @property {Array.<string>|null} [resourcePolicies] InstancesAddResourcePoliciesRequest resourcePolicies
                         */
    
                        /**
                         * Constructs a new InstancesAddResourcePoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstancesAddResourcePoliciesRequest.
                         * @implements IInstancesAddResourcePoliciesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstancesAddResourcePoliciesRequest=} [properties] Properties to set
                         */
                        function InstancesAddResourcePoliciesRequest(properties) {
                            this.resourcePolicies = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstancesAddResourcePoliciesRequest resourcePolicies.
                         * @member {Array.<string>} resourcePolicies
                         * @memberof google.cloud.compute.v1.InstancesAddResourcePoliciesRequest
                         * @instance
                         */
                        InstancesAddResourcePoliciesRequest.prototype.resourcePolicies = $util.emptyArray;
    
                        /**
                         * Creates a new InstancesAddResourcePoliciesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstancesAddResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesAddResourcePoliciesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstancesAddResourcePoliciesRequest} InstancesAddResourcePoliciesRequest instance
                         */
                        InstancesAddResourcePoliciesRequest.create = function create(properties) {
                            return new InstancesAddResourcePoliciesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InstancesAddResourcePoliciesRequest message. Does not implicitly {@link google.cloud.compute.v1.InstancesAddResourcePoliciesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstancesAddResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesAddResourcePoliciesRequest} message InstancesAddResourcePoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesAddResourcePoliciesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourcePolicies != null && message.resourcePolicies.length)
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    writer.uint32(/* id 22220385, wireType 2 =*/177763082).string(message.resourcePolicies[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstancesAddResourcePoliciesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstancesAddResourcePoliciesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesAddResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesAddResourcePoliciesRequest} message InstancesAddResourcePoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesAddResourcePoliciesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstancesAddResourcePoliciesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstancesAddResourcePoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstancesAddResourcePoliciesRequest} InstancesAddResourcePoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesAddResourcePoliciesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstancesAddResourcePoliciesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 22220385: {
                                        if (!(message.resourcePolicies && message.resourcePolicies.length))
                                            message.resourcePolicies = [];
                                        message.resourcePolicies.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstancesAddResourcePoliciesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesAddResourcePoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstancesAddResourcePoliciesRequest} InstancesAddResourcePoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesAddResourcePoliciesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstancesAddResourcePoliciesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstancesAddResourcePoliciesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstancesAddResourcePoliciesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourcePolicies != null && message.hasOwnProperty("resourcePolicies")) {
                                if (!Array.isArray(message.resourcePolicies))
                                    return "resourcePolicies: array expected";
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    if (!$util.isString(message.resourcePolicies[i]))
                                        return "resourcePolicies: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstancesAddResourcePoliciesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstancesAddResourcePoliciesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstancesAddResourcePoliciesRequest} InstancesAddResourcePoliciesRequest
                         */
                        InstancesAddResourcePoliciesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstancesAddResourcePoliciesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstancesAddResourcePoliciesRequest();
                            if (object.resourcePolicies) {
                                if (!Array.isArray(object.resourcePolicies))
                                    throw TypeError(".google.cloud.compute.v1.InstancesAddResourcePoliciesRequest.resourcePolicies: array expected");
                                message.resourcePolicies = [];
                                for (var i = 0; i < object.resourcePolicies.length; ++i)
                                    message.resourcePolicies[i] = String(object.resourcePolicies[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstancesAddResourcePoliciesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstancesAddResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.InstancesAddResourcePoliciesRequest} message InstancesAddResourcePoliciesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstancesAddResourcePoliciesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.resourcePolicies = [];
                            if (message.resourcePolicies && message.resourcePolicies.length) {
                                object.resourcePolicies = [];
                                for (var j = 0; j < message.resourcePolicies.length; ++j)
                                    object.resourcePolicies[j] = message.resourcePolicies[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstancesAddResourcePoliciesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstancesAddResourcePoliciesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstancesAddResourcePoliciesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstancesAddResourcePoliciesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstancesAddResourcePoliciesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstancesAddResourcePoliciesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstancesAddResourcePoliciesRequest";
                        };
    
                        return InstancesAddResourcePoliciesRequest;
                    })();
    
                    v1.InstancesGetEffectiveFirewallsResponse = (function() {
    
                        /**
                         * Properties of an InstancesGetEffectiveFirewallsResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstancesGetEffectiveFirewallsResponse
                         * @property {Array.<google.cloud.compute.v1.IInstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy>|null} [firewallPolicys] InstancesGetEffectiveFirewallsResponse firewallPolicys
                         * @property {Array.<google.cloud.compute.v1.IFirewall>|null} [firewalls] InstancesGetEffectiveFirewallsResponse firewalls
                         */
    
                        /**
                         * Constructs a new InstancesGetEffectiveFirewallsResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstancesGetEffectiveFirewallsResponse.
                         * @implements IInstancesGetEffectiveFirewallsResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstancesGetEffectiveFirewallsResponse=} [properties] Properties to set
                         */
                        function InstancesGetEffectiveFirewallsResponse(properties) {
                            this.firewallPolicys = [];
                            this.firewalls = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstancesGetEffectiveFirewallsResponse firewallPolicys.
                         * @member {Array.<google.cloud.compute.v1.IInstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy>} firewallPolicys
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse
                         * @instance
                         */
                        InstancesGetEffectiveFirewallsResponse.prototype.firewallPolicys = $util.emptyArray;
    
                        /**
                         * InstancesGetEffectiveFirewallsResponse firewalls.
                         * @member {Array.<google.cloud.compute.v1.IFirewall>} firewalls
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse
                         * @instance
                         */
                        InstancesGetEffectiveFirewallsResponse.prototype.firewalls = $util.emptyArray;
    
                        /**
                         * Creates a new InstancesGetEffectiveFirewallsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesGetEffectiveFirewallsResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse} InstancesGetEffectiveFirewallsResponse instance
                         */
                        InstancesGetEffectiveFirewallsResponse.create = function create(properties) {
                            return new InstancesGetEffectiveFirewallsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified InstancesGetEffectiveFirewallsResponse message. Does not implicitly {@link google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesGetEffectiveFirewallsResponse} message InstancesGetEffectiveFirewallsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesGetEffectiveFirewallsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.firewalls != null && message.firewalls.length)
                                for (var i = 0; i < message.firewalls.length; ++i)
                                    $root.google.cloud.compute.v1.Firewall.encode(message.firewalls[i], writer.uint32(/* id 272245619, wireType 2 =*/2177964954).fork()).ldelim();
                            if (message.firewallPolicys != null && message.firewallPolicys.length)
                                for (var i = 0; i < message.firewallPolicys.length; ++i)
                                    $root.google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.encode(message.firewallPolicys[i], writer.uint32(/* id 410985794, wireType 2 =*/3287886354).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstancesGetEffectiveFirewallsResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesGetEffectiveFirewallsResponse} message InstancesGetEffectiveFirewallsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesGetEffectiveFirewallsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstancesGetEffectiveFirewallsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse} InstancesGetEffectiveFirewallsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesGetEffectiveFirewallsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 410985794: {
                                        if (!(message.firewallPolicys && message.firewallPolicys.length))
                                            message.firewallPolicys = [];
                                        message.firewallPolicys.push($root.google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 272245619: {
                                        if (!(message.firewalls && message.firewalls.length))
                                            message.firewalls = [];
                                        message.firewalls.push($root.google.cloud.compute.v1.Firewall.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstancesGetEffectiveFirewallsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse} InstancesGetEffectiveFirewallsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesGetEffectiveFirewallsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstancesGetEffectiveFirewallsResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstancesGetEffectiveFirewallsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.firewallPolicys != null && message.hasOwnProperty("firewallPolicys")) {
                                if (!Array.isArray(message.firewallPolicys))
                                    return "firewallPolicys: array expected";
                                for (var i = 0; i < message.firewallPolicys.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.verify(message.firewallPolicys[i]);
                                    if (error)
                                        return "firewallPolicys." + error;
                                }
                            }
                            if (message.firewalls != null && message.hasOwnProperty("firewalls")) {
                                if (!Array.isArray(message.firewalls))
                                    return "firewalls: array expected";
                                for (var i = 0; i < message.firewalls.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Firewall.verify(message.firewalls[i]);
                                    if (error)
                                        return "firewalls." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstancesGetEffectiveFirewallsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse} InstancesGetEffectiveFirewallsResponse
                         */
                        InstancesGetEffectiveFirewallsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse();
                            if (object.firewallPolicys) {
                                if (!Array.isArray(object.firewallPolicys))
                                    throw TypeError(".google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse.firewallPolicys: array expected");
                                message.firewallPolicys = [];
                                for (var i = 0; i < object.firewallPolicys.length; ++i) {
                                    if (typeof object.firewallPolicys[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse.firewallPolicys: object expected");
                                    message.firewallPolicys[i] = $root.google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.fromObject(object.firewallPolicys[i]);
                                }
                            }
                            if (object.firewalls) {
                                if (!Array.isArray(object.firewalls))
                                    throw TypeError(".google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse.firewalls: array expected");
                                message.firewalls = [];
                                for (var i = 0; i < object.firewalls.length; ++i) {
                                    if (typeof object.firewalls[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse.firewalls: object expected");
                                    message.firewalls[i] = $root.google.cloud.compute.v1.Firewall.fromObject(object.firewalls[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstancesGetEffectiveFirewallsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse
                         * @static
                         * @param {google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse} message InstancesGetEffectiveFirewallsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstancesGetEffectiveFirewallsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.firewalls = [];
                                object.firewallPolicys = [];
                            }
                            if (message.firewalls && message.firewalls.length) {
                                object.firewalls = [];
                                for (var j = 0; j < message.firewalls.length; ++j)
                                    object.firewalls[j] = $root.google.cloud.compute.v1.Firewall.toObject(message.firewalls[j], options);
                            }
                            if (message.firewallPolicys && message.firewallPolicys.length) {
                                object.firewallPolicys = [];
                                for (var j = 0; j < message.firewallPolicys.length; ++j)
                                    object.firewallPolicys[j] = $root.google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.toObject(message.firewallPolicys[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstancesGetEffectiveFirewallsResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstancesGetEffectiveFirewallsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstancesGetEffectiveFirewallsResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstancesGetEffectiveFirewallsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse";
                        };
    
                        return InstancesGetEffectiveFirewallsResponse;
                    })();
    
                    v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy = (function() {
    
                        /**
                         * Properties of an InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @property {string|null} [displayName] InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy displayName
                         * @property {string|null} [name] InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy name
                         * @property {Array.<google.cloud.compute.v1.IFirewallPolicyRule>|null} [rules] InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy rules
                         * @property {string|null} [shortName] InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy shortName
                         * @property {string|null} [type] InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy type
                         */
    
                        /**
                         * Constructs a new InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.
                         * @implements IInstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy=} [properties] Properties to set
                         */
                        function InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy(properties) {
                            this.rules = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy displayName.
                         * @member {string|null|undefined} displayName
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype.displayName = null;
    
                        /**
                         * InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype.name = null;
    
                        /**
                         * InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy rules.
                         * @member {Array.<google.cloud.compute.v1.IFirewallPolicyRule>} rules
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype.rules = $util.emptyArray;
    
                        /**
                         * InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy shortName.
                         * @member {string|null|undefined} shortName
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype.shortName = null;
    
                        /**
                         * InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype.type = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy _displayName.
                         * @member {"displayName"|undefined} _displayName
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype, "_displayName", {
                            get: $util.oneOfGetter($oneOfFields = ["displayName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy _shortName.
                         * @member {"shortName"|undefined} _shortName
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype, "_shortName", {
                            get: $util.oneOfGetter($oneOfFields = ["shortName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy} InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy instance
                         */
                        InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.create = function create(properties) {
                            return new InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy message. Does not implicitly {@link google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy} message InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 4473832, wireType 2 =*/35790658).string(message.displayName);
                            if (message.rules != null && message.rules.length)
                                for (var i = 0; i < message.rules.length; ++i)
                                    $root.google.cloud.compute.v1.FirewallPolicyRule.encode(message.rules[i], writer.uint32(/* id 108873975, wireType 2 =*/870991802).fork()).ldelim();
                            if (message.shortName != null && Object.hasOwnProperty.call(message, "shortName"))
                                writer.uint32(/* id 492051566, wireType 2 =*/3936412530).string(message.shortName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy} message InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy} InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4473832: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 108873975: {
                                        if (!(message.rules && message.rules.length))
                                            message.rules = [];
                                        message.rules.push($root.google.cloud.compute.v1.FirewallPolicyRule.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 492051566: {
                                        message.shortName = reader.string();
                                        break;
                                    }
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy} InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.displayName != null && message.hasOwnProperty("displayName")) {
                                properties._displayName = 1;
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.rules != null && message.hasOwnProperty("rules")) {
                                if (!Array.isArray(message.rules))
                                    return "rules: array expected";
                                for (var i = 0; i < message.rules.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.FirewallPolicyRule.verify(message.rules[i]);
                                    if (error)
                                        return "rules." + error;
                                }
                            }
                            if (message.shortName != null && message.hasOwnProperty("shortName")) {
                                properties._shortName = 1;
                                if (!$util.isString(message.shortName))
                                    return "shortName: string expected";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy} InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         */
                        InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy();
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.rules) {
                                if (!Array.isArray(object.rules))
                                    throw TypeError(".google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.rules: array expected");
                                message.rules = [];
                                for (var i = 0; i < object.rules.length; ++i) {
                                    if (typeof object.rules[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.rules: object expected");
                                    message.rules[i] = $root.google.cloud.compute.v1.FirewallPolicyRule.fromObject(object.rules[i]);
                                }
                            }
                            if (object.shortName != null)
                                message.shortName = String(object.shortName);
                            if (object.type != null)
                                message.type = String(object.type);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy} message InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.rules = [];
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            if (message.displayName != null && message.hasOwnProperty("displayName")) {
                                object.displayName = message.displayName;
                                if (options.oneofs)
                                    object._displayName = "displayName";
                            }
                            if (message.rules && message.rules.length) {
                                object.rules = [];
                                for (var j = 0; j < message.rules.length; ++j)
                                    object.rules[j] = $root.google.cloud.compute.v1.FirewallPolicyRule.toObject(message.rules[j], options);
                            }
                            if (message.shortName != null && message.hasOwnProperty("shortName")) {
                                object.shortName = message.shortName;
                                if (options.oneofs)
                                    object._shortName = "shortName";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy";
                        };
    
                        /**
                         * Type enum.
                         * @name google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type
                         * @enum {number}
                         * @property {number} UNDEFINED_TYPE=0 UNDEFINED_TYPE value
                         * @property {number} HIERARCHY=69902869 HIERARCHY value
                         * @property {number} NETWORK=413984270 NETWORK value
                         * @property {number} NETWORK_REGIONAL=190804272 NETWORK_REGIONAL value
                         * @property {number} UNSPECIFIED=526786327 UNSPECIFIED value
                         */
                        InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TYPE"] = 0;
                            values[valuesById[69902869] = "HIERARCHY"] = 69902869;
                            values[valuesById[413984270] = "NETWORK"] = 413984270;
                            values[valuesById[190804272] = "NETWORK_REGIONAL"] = 190804272;
                            values[valuesById[526786327] = "UNSPECIFIED"] = 526786327;
                            return values;
                        })();
    
                        return InstancesGetEffectiveFirewallsResponseEffectiveFirewallPolicy;
                    })();
    
                    v1.InstancesRemoveResourcePoliciesRequest = (function() {
    
                        /**
                         * Properties of an InstancesRemoveResourcePoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstancesRemoveResourcePoliciesRequest
                         * @property {Array.<string>|null} [resourcePolicies] InstancesRemoveResourcePoliciesRequest resourcePolicies
                         */
    
                        /**
                         * Constructs a new InstancesRemoveResourcePoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstancesRemoveResourcePoliciesRequest.
                         * @implements IInstancesRemoveResourcePoliciesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstancesRemoveResourcePoliciesRequest=} [properties] Properties to set
                         */
                        function InstancesRemoveResourcePoliciesRequest(properties) {
                            this.resourcePolicies = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstancesRemoveResourcePoliciesRequest resourcePolicies.
                         * @member {Array.<string>} resourcePolicies
                         * @memberof google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest
                         * @instance
                         */
                        InstancesRemoveResourcePoliciesRequest.prototype.resourcePolicies = $util.emptyArray;
    
                        /**
                         * Creates a new InstancesRemoveResourcePoliciesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesRemoveResourcePoliciesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest} InstancesRemoveResourcePoliciesRequest instance
                         */
                        InstancesRemoveResourcePoliciesRequest.create = function create(properties) {
                            return new InstancesRemoveResourcePoliciesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InstancesRemoveResourcePoliciesRequest message. Does not implicitly {@link google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesRemoveResourcePoliciesRequest} message InstancesRemoveResourcePoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesRemoveResourcePoliciesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourcePolicies != null && message.resourcePolicies.length)
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    writer.uint32(/* id 22220385, wireType 2 =*/177763082).string(message.resourcePolicies[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstancesRemoveResourcePoliciesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesRemoveResourcePoliciesRequest} message InstancesRemoveResourcePoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesRemoveResourcePoliciesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstancesRemoveResourcePoliciesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest} InstancesRemoveResourcePoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesRemoveResourcePoliciesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 22220385: {
                                        if (!(message.resourcePolicies && message.resourcePolicies.length))
                                            message.resourcePolicies = [];
                                        message.resourcePolicies.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstancesRemoveResourcePoliciesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest} InstancesRemoveResourcePoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesRemoveResourcePoliciesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstancesRemoveResourcePoliciesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstancesRemoveResourcePoliciesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourcePolicies != null && message.hasOwnProperty("resourcePolicies")) {
                                if (!Array.isArray(message.resourcePolicies))
                                    return "resourcePolicies: array expected";
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    if (!$util.isString(message.resourcePolicies[i]))
                                        return "resourcePolicies: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstancesRemoveResourcePoliciesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest} InstancesRemoveResourcePoliciesRequest
                         */
                        InstancesRemoveResourcePoliciesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest();
                            if (object.resourcePolicies) {
                                if (!Array.isArray(object.resourcePolicies))
                                    throw TypeError(".google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest.resourcePolicies: array expected");
                                message.resourcePolicies = [];
                                for (var i = 0; i < object.resourcePolicies.length; ++i)
                                    message.resourcePolicies[i] = String(object.resourcePolicies[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstancesRemoveResourcePoliciesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest} message InstancesRemoveResourcePoliciesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstancesRemoveResourcePoliciesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.resourcePolicies = [];
                            if (message.resourcePolicies && message.resourcePolicies.length) {
                                object.resourcePolicies = [];
                                for (var j = 0; j < message.resourcePolicies.length; ++j)
                                    object.resourcePolicies[j] = message.resourcePolicies[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstancesRemoveResourcePoliciesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstancesRemoveResourcePoliciesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstancesRemoveResourcePoliciesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstancesRemoveResourcePoliciesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest";
                        };
    
                        return InstancesRemoveResourcePoliciesRequest;
                    })();
    
                    v1.InstancesScopedList = (function() {
    
                        /**
                         * Properties of an InstancesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstancesScopedList
                         * @property {Array.<google.cloud.compute.v1.IInstance>|null} [instances] InstancesScopedList instances
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] InstancesScopedList warning
                         */
    
                        /**
                         * Constructs a new InstancesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstancesScopedList.
                         * @implements IInstancesScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstancesScopedList=} [properties] Properties to set
                         */
                        function InstancesScopedList(properties) {
                            this.instances = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstancesScopedList instances.
                         * @member {Array.<google.cloud.compute.v1.IInstance>} instances
                         * @memberof google.cloud.compute.v1.InstancesScopedList
                         * @instance
                         */
                        InstancesScopedList.prototype.instances = $util.emptyArray;
    
                        /**
                         * InstancesScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.InstancesScopedList
                         * @instance
                         */
                        InstancesScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstancesScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.InstancesScopedList
                         * @instance
                         */
                        Object.defineProperty(InstancesScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstancesScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstancesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstancesScopedList} InstancesScopedList instance
                         */
                        InstancesScopedList.create = function create(properties) {
                            return new InstancesScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified InstancesScopedList message. Does not implicitly {@link google.cloud.compute.v1.InstancesScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstancesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesScopedList} message InstancesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instances != null && message.instances.length)
                                for (var i = 0; i < message.instances.length; ++i)
                                    $root.google.cloud.compute.v1.Instance.encode(message.instances[i], writer.uint32(/* id 29097598, wireType 2 =*/232780786).fork()).ldelim();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstancesScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstancesScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesScopedList} message InstancesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstancesScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstancesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstancesScopedList} InstancesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstancesScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 29097598: {
                                        if (!(message.instances && message.instances.length))
                                            message.instances = [];
                                        message.instances.push($root.google.cloud.compute.v1.Instance.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstancesScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstancesScopedList} InstancesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstancesScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstancesScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstancesScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instances != null && message.hasOwnProperty("instances")) {
                                if (!Array.isArray(message.instances))
                                    return "instances: array expected";
                                for (var i = 0; i < message.instances.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Instance.verify(message.instances[i]);
                                    if (error)
                                        return "instances." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstancesScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstancesScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstancesScopedList} InstancesScopedList
                         */
                        InstancesScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstancesScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstancesScopedList();
                            if (object.instances) {
                                if (!Array.isArray(object.instances))
                                    throw TypeError(".google.cloud.compute.v1.InstancesScopedList.instances: array expected");
                                message.instances = [];
                                for (var i = 0; i < object.instances.length; ++i) {
                                    if (typeof object.instances[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstancesScopedList.instances: object expected");
                                    message.instances[i] = $root.google.cloud.compute.v1.Instance.fromObject(object.instances[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstancesScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstancesScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstancesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.InstancesScopedList} message InstancesScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstancesScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.instances = [];
                            if (message.instances && message.instances.length) {
                                object.instances = [];
                                for (var j = 0; j < message.instances.length; ++j)
                                    object.instances[j] = $root.google.cloud.compute.v1.Instance.toObject(message.instances[j], options);
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstancesScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstancesScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstancesScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstancesScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstancesScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstancesScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstancesScopedList";
                        };
    
                        return InstancesScopedList;
                    })();
    
                    v1.InstancesSetLabelsRequest = (function() {
    
                        /**
                         * Properties of an InstancesSetLabelsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstancesSetLabelsRequest
                         * @property {string|null} [labelFingerprint] InstancesSetLabelsRequest labelFingerprint
                         * @property {Object.<string,string>|null} [labels] InstancesSetLabelsRequest labels
                         */
    
                        /**
                         * Constructs a new InstancesSetLabelsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstancesSetLabelsRequest.
                         * @implements IInstancesSetLabelsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstancesSetLabelsRequest=} [properties] Properties to set
                         */
                        function InstancesSetLabelsRequest(properties) {
                            this.labels = {};
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstancesSetLabelsRequest labelFingerprint.
                         * @member {string|null|undefined} labelFingerprint
                         * @memberof google.cloud.compute.v1.InstancesSetLabelsRequest
                         * @instance
                         */
                        InstancesSetLabelsRequest.prototype.labelFingerprint = null;
    
                        /**
                         * InstancesSetLabelsRequest labels.
                         * @member {Object.<string,string>} labels
                         * @memberof google.cloud.compute.v1.InstancesSetLabelsRequest
                         * @instance
                         */
                        InstancesSetLabelsRequest.prototype.labels = $util.emptyObject;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstancesSetLabelsRequest _labelFingerprint.
                         * @member {"labelFingerprint"|undefined} _labelFingerprint
                         * @memberof google.cloud.compute.v1.InstancesSetLabelsRequest
                         * @instance
                         */
                        Object.defineProperty(InstancesSetLabelsRequest.prototype, "_labelFingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["labelFingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstancesSetLabelsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstancesSetLabelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesSetLabelsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstancesSetLabelsRequest} InstancesSetLabelsRequest instance
                         */
                        InstancesSetLabelsRequest.create = function create(properties) {
                            return new InstancesSetLabelsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InstancesSetLabelsRequest message. Does not implicitly {@link google.cloud.compute.v1.InstancesSetLabelsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstancesSetLabelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesSetLabelsRequest} message InstancesSetLabelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesSetLabelsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.labelFingerprint != null && Object.hasOwnProperty.call(message, "labelFingerprint"))
                                writer.uint32(/* id 178124825, wireType 2 =*/1424998602).string(message.labelFingerprint);
                            if (message.labels != null && Object.hasOwnProperty.call(message, "labels"))
                                for (var keys = Object.keys(message.labels), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 500195327, wireType 2 =*/4001562618).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.labels[keys[i]]).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstancesSetLabelsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstancesSetLabelsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesSetLabelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesSetLabelsRequest} message InstancesSetLabelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesSetLabelsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstancesSetLabelsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstancesSetLabelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstancesSetLabelsRequest} InstancesSetLabelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesSetLabelsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstancesSetLabelsRequest(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 178124825: {
                                        message.labelFingerprint = reader.string();
                                        break;
                                    }
                                case 500195327: {
                                        if (message.labels === $util.emptyObject)
                                            message.labels = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.labels[key] = value;
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstancesSetLabelsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesSetLabelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstancesSetLabelsRequest} InstancesSetLabelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesSetLabelsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstancesSetLabelsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstancesSetLabelsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstancesSetLabelsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                properties._labelFingerprint = 1;
                                if (!$util.isString(message.labelFingerprint))
                                    return "labelFingerprint: string expected";
                            }
                            if (message.labels != null && message.hasOwnProperty("labels")) {
                                if (!$util.isObject(message.labels))
                                    return "labels: object expected";
                                var key = Object.keys(message.labels);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.labels[key[i]]))
                                        return "labels: string{k:string} expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstancesSetLabelsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstancesSetLabelsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstancesSetLabelsRequest} InstancesSetLabelsRequest
                         */
                        InstancesSetLabelsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstancesSetLabelsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstancesSetLabelsRequest();
                            if (object.labelFingerprint != null)
                                message.labelFingerprint = String(object.labelFingerprint);
                            if (object.labels) {
                                if (typeof object.labels !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InstancesSetLabelsRequest.labels: object expected");
                                message.labels = {};
                                for (var keys = Object.keys(object.labels), i = 0; i < keys.length; ++i)
                                    message.labels[keys[i]] = String(object.labels[keys[i]]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstancesSetLabelsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstancesSetLabelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.InstancesSetLabelsRequest} message InstancesSetLabelsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstancesSetLabelsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.objects || options.defaults)
                                object.labels = {};
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                object.labelFingerprint = message.labelFingerprint;
                                if (options.oneofs)
                                    object._labelFingerprint = "labelFingerprint";
                            }
                            var keys2;
                            if (message.labels && (keys2 = Object.keys(message.labels)).length) {
                                object.labels = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.labels[keys2[j]] = message.labels[keys2[j]];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstancesSetLabelsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstancesSetLabelsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstancesSetLabelsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstancesSetLabelsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstancesSetLabelsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstancesSetLabelsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstancesSetLabelsRequest";
                        };
    
                        return InstancesSetLabelsRequest;
                    })();
    
                    v1.InstancesSetMachineResourcesRequest = (function() {
    
                        /**
                         * Properties of an InstancesSetMachineResourcesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstancesSetMachineResourcesRequest
                         * @property {Array.<google.cloud.compute.v1.IAcceleratorConfig>|null} [guestAccelerators] InstancesSetMachineResourcesRequest guestAccelerators
                         */
    
                        /**
                         * Constructs a new InstancesSetMachineResourcesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstancesSetMachineResourcesRequest.
                         * @implements IInstancesSetMachineResourcesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstancesSetMachineResourcesRequest=} [properties] Properties to set
                         */
                        function InstancesSetMachineResourcesRequest(properties) {
                            this.guestAccelerators = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstancesSetMachineResourcesRequest guestAccelerators.
                         * @member {Array.<google.cloud.compute.v1.IAcceleratorConfig>} guestAccelerators
                         * @memberof google.cloud.compute.v1.InstancesSetMachineResourcesRequest
                         * @instance
                         */
                        InstancesSetMachineResourcesRequest.prototype.guestAccelerators = $util.emptyArray;
    
                        /**
                         * Creates a new InstancesSetMachineResourcesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstancesSetMachineResourcesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesSetMachineResourcesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstancesSetMachineResourcesRequest} InstancesSetMachineResourcesRequest instance
                         */
                        InstancesSetMachineResourcesRequest.create = function create(properties) {
                            return new InstancesSetMachineResourcesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InstancesSetMachineResourcesRequest message. Does not implicitly {@link google.cloud.compute.v1.InstancesSetMachineResourcesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstancesSetMachineResourcesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesSetMachineResourcesRequest} message InstancesSetMachineResourcesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesSetMachineResourcesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.guestAccelerators != null && message.guestAccelerators.length)
                                for (var i = 0; i < message.guestAccelerators.length; ++i)
                                    $root.google.cloud.compute.v1.AcceleratorConfig.encode(message.guestAccelerators[i], writer.uint32(/* id 463595119, wireType 2 =*/3708760954).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstancesSetMachineResourcesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstancesSetMachineResourcesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesSetMachineResourcesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesSetMachineResourcesRequest} message InstancesSetMachineResourcesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesSetMachineResourcesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstancesSetMachineResourcesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstancesSetMachineResourcesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstancesSetMachineResourcesRequest} InstancesSetMachineResourcesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesSetMachineResourcesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstancesSetMachineResourcesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 463595119: {
                                        if (!(message.guestAccelerators && message.guestAccelerators.length))
                                            message.guestAccelerators = [];
                                        message.guestAccelerators.push($root.google.cloud.compute.v1.AcceleratorConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstancesSetMachineResourcesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesSetMachineResourcesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstancesSetMachineResourcesRequest} InstancesSetMachineResourcesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesSetMachineResourcesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstancesSetMachineResourcesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstancesSetMachineResourcesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstancesSetMachineResourcesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.guestAccelerators != null && message.hasOwnProperty("guestAccelerators")) {
                                if (!Array.isArray(message.guestAccelerators))
                                    return "guestAccelerators: array expected";
                                for (var i = 0; i < message.guestAccelerators.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AcceleratorConfig.verify(message.guestAccelerators[i]);
                                    if (error)
                                        return "guestAccelerators." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstancesSetMachineResourcesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstancesSetMachineResourcesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstancesSetMachineResourcesRequest} InstancesSetMachineResourcesRequest
                         */
                        InstancesSetMachineResourcesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstancesSetMachineResourcesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstancesSetMachineResourcesRequest();
                            if (object.guestAccelerators) {
                                if (!Array.isArray(object.guestAccelerators))
                                    throw TypeError(".google.cloud.compute.v1.InstancesSetMachineResourcesRequest.guestAccelerators: array expected");
                                message.guestAccelerators = [];
                                for (var i = 0; i < object.guestAccelerators.length; ++i) {
                                    if (typeof object.guestAccelerators[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstancesSetMachineResourcesRequest.guestAccelerators: object expected");
                                    message.guestAccelerators[i] = $root.google.cloud.compute.v1.AcceleratorConfig.fromObject(object.guestAccelerators[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstancesSetMachineResourcesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstancesSetMachineResourcesRequest
                         * @static
                         * @param {google.cloud.compute.v1.InstancesSetMachineResourcesRequest} message InstancesSetMachineResourcesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstancesSetMachineResourcesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.guestAccelerators = [];
                            if (message.guestAccelerators && message.guestAccelerators.length) {
                                object.guestAccelerators = [];
                                for (var j = 0; j < message.guestAccelerators.length; ++j)
                                    object.guestAccelerators[j] = $root.google.cloud.compute.v1.AcceleratorConfig.toObject(message.guestAccelerators[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstancesSetMachineResourcesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstancesSetMachineResourcesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstancesSetMachineResourcesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstancesSetMachineResourcesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstancesSetMachineResourcesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstancesSetMachineResourcesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstancesSetMachineResourcesRequest";
                        };
    
                        return InstancesSetMachineResourcesRequest;
                    })();
    
                    v1.InstancesSetMachineTypeRequest = (function() {
    
                        /**
                         * Properties of an InstancesSetMachineTypeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstancesSetMachineTypeRequest
                         * @property {string|null} [machineType] InstancesSetMachineTypeRequest machineType
                         */
    
                        /**
                         * Constructs a new InstancesSetMachineTypeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstancesSetMachineTypeRequest.
                         * @implements IInstancesSetMachineTypeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstancesSetMachineTypeRequest=} [properties] Properties to set
                         */
                        function InstancesSetMachineTypeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstancesSetMachineTypeRequest machineType.
                         * @member {string|null|undefined} machineType
                         * @memberof google.cloud.compute.v1.InstancesSetMachineTypeRequest
                         * @instance
                         */
                        InstancesSetMachineTypeRequest.prototype.machineType = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstancesSetMachineTypeRequest _machineType.
                         * @member {"machineType"|undefined} _machineType
                         * @memberof google.cloud.compute.v1.InstancesSetMachineTypeRequest
                         * @instance
                         */
                        Object.defineProperty(InstancesSetMachineTypeRequest.prototype, "_machineType", {
                            get: $util.oneOfGetter($oneOfFields = ["machineType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstancesSetMachineTypeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstancesSetMachineTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesSetMachineTypeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstancesSetMachineTypeRequest} InstancesSetMachineTypeRequest instance
                         */
                        InstancesSetMachineTypeRequest.create = function create(properties) {
                            return new InstancesSetMachineTypeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InstancesSetMachineTypeRequest message. Does not implicitly {@link google.cloud.compute.v1.InstancesSetMachineTypeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstancesSetMachineTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesSetMachineTypeRequest} message InstancesSetMachineTypeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesSetMachineTypeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.machineType != null && Object.hasOwnProperty.call(message, "machineType"))
                                writer.uint32(/* id 227711026, wireType 2 =*/1821688210).string(message.machineType);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstancesSetMachineTypeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstancesSetMachineTypeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesSetMachineTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesSetMachineTypeRequest} message InstancesSetMachineTypeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesSetMachineTypeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstancesSetMachineTypeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstancesSetMachineTypeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstancesSetMachineTypeRequest} InstancesSetMachineTypeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesSetMachineTypeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstancesSetMachineTypeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227711026: {
                                        message.machineType = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstancesSetMachineTypeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesSetMachineTypeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstancesSetMachineTypeRequest} InstancesSetMachineTypeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesSetMachineTypeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstancesSetMachineTypeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstancesSetMachineTypeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstancesSetMachineTypeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.machineType != null && message.hasOwnProperty("machineType")) {
                                properties._machineType = 1;
                                if (!$util.isString(message.machineType))
                                    return "machineType: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstancesSetMachineTypeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstancesSetMachineTypeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstancesSetMachineTypeRequest} InstancesSetMachineTypeRequest
                         */
                        InstancesSetMachineTypeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstancesSetMachineTypeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstancesSetMachineTypeRequest();
                            if (object.machineType != null)
                                message.machineType = String(object.machineType);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstancesSetMachineTypeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstancesSetMachineTypeRequest
                         * @static
                         * @param {google.cloud.compute.v1.InstancesSetMachineTypeRequest} message InstancesSetMachineTypeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstancesSetMachineTypeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.machineType != null && message.hasOwnProperty("machineType")) {
                                object.machineType = message.machineType;
                                if (options.oneofs)
                                    object._machineType = "machineType";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstancesSetMachineTypeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstancesSetMachineTypeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstancesSetMachineTypeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstancesSetMachineTypeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstancesSetMachineTypeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstancesSetMachineTypeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstancesSetMachineTypeRequest";
                        };
    
                        return InstancesSetMachineTypeRequest;
                    })();
    
                    v1.InstancesSetMinCpuPlatformRequest = (function() {
    
                        /**
                         * Properties of an InstancesSetMinCpuPlatformRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstancesSetMinCpuPlatformRequest
                         * @property {string|null} [minCpuPlatform] InstancesSetMinCpuPlatformRequest minCpuPlatform
                         */
    
                        /**
                         * Constructs a new InstancesSetMinCpuPlatformRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstancesSetMinCpuPlatformRequest.
                         * @implements IInstancesSetMinCpuPlatformRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstancesSetMinCpuPlatformRequest=} [properties] Properties to set
                         */
                        function InstancesSetMinCpuPlatformRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstancesSetMinCpuPlatformRequest minCpuPlatform.
                         * @member {string|null|undefined} minCpuPlatform
                         * @memberof google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest
                         * @instance
                         */
                        InstancesSetMinCpuPlatformRequest.prototype.minCpuPlatform = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstancesSetMinCpuPlatformRequest _minCpuPlatform.
                         * @member {"minCpuPlatform"|undefined} _minCpuPlatform
                         * @memberof google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest
                         * @instance
                         */
                        Object.defineProperty(InstancesSetMinCpuPlatformRequest.prototype, "_minCpuPlatform", {
                            get: $util.oneOfGetter($oneOfFields = ["minCpuPlatform"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstancesSetMinCpuPlatformRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesSetMinCpuPlatformRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest} InstancesSetMinCpuPlatformRequest instance
                         */
                        InstancesSetMinCpuPlatformRequest.create = function create(properties) {
                            return new InstancesSetMinCpuPlatformRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InstancesSetMinCpuPlatformRequest message. Does not implicitly {@link google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesSetMinCpuPlatformRequest} message InstancesSetMinCpuPlatformRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesSetMinCpuPlatformRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.minCpuPlatform != null && Object.hasOwnProperty.call(message, "minCpuPlatform"))
                                writer.uint32(/* id 242912759, wireType 2 =*/1943302074).string(message.minCpuPlatform);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstancesSetMinCpuPlatformRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesSetMinCpuPlatformRequest} message InstancesSetMinCpuPlatformRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesSetMinCpuPlatformRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstancesSetMinCpuPlatformRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest} InstancesSetMinCpuPlatformRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesSetMinCpuPlatformRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 242912759: {
                                        message.minCpuPlatform = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstancesSetMinCpuPlatformRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest} InstancesSetMinCpuPlatformRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesSetMinCpuPlatformRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstancesSetMinCpuPlatformRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstancesSetMinCpuPlatformRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.minCpuPlatform != null && message.hasOwnProperty("minCpuPlatform")) {
                                properties._minCpuPlatform = 1;
                                if (!$util.isString(message.minCpuPlatform))
                                    return "minCpuPlatform: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstancesSetMinCpuPlatformRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest} InstancesSetMinCpuPlatformRequest
                         */
                        InstancesSetMinCpuPlatformRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest();
                            if (object.minCpuPlatform != null)
                                message.minCpuPlatform = String(object.minCpuPlatform);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstancesSetMinCpuPlatformRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest
                         * @static
                         * @param {google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest} message InstancesSetMinCpuPlatformRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstancesSetMinCpuPlatformRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.minCpuPlatform != null && message.hasOwnProperty("minCpuPlatform")) {
                                object.minCpuPlatform = message.minCpuPlatform;
                                if (options.oneofs)
                                    object._minCpuPlatform = "minCpuPlatform";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstancesSetMinCpuPlatformRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstancesSetMinCpuPlatformRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstancesSetMinCpuPlatformRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstancesSetMinCpuPlatformRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest";
                        };
    
                        return InstancesSetMinCpuPlatformRequest;
                    })();
    
                    v1.InstancesSetServiceAccountRequest = (function() {
    
                        /**
                         * Properties of an InstancesSetServiceAccountRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstancesSetServiceAccountRequest
                         * @property {string|null} [email] InstancesSetServiceAccountRequest email
                         * @property {Array.<string>|null} [scopes] InstancesSetServiceAccountRequest scopes
                         */
    
                        /**
                         * Constructs a new InstancesSetServiceAccountRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstancesSetServiceAccountRequest.
                         * @implements IInstancesSetServiceAccountRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstancesSetServiceAccountRequest=} [properties] Properties to set
                         */
                        function InstancesSetServiceAccountRequest(properties) {
                            this.scopes = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstancesSetServiceAccountRequest email.
                         * @member {string|null|undefined} email
                         * @memberof google.cloud.compute.v1.InstancesSetServiceAccountRequest
                         * @instance
                         */
                        InstancesSetServiceAccountRequest.prototype.email = null;
    
                        /**
                         * InstancesSetServiceAccountRequest scopes.
                         * @member {Array.<string>} scopes
                         * @memberof google.cloud.compute.v1.InstancesSetServiceAccountRequest
                         * @instance
                         */
                        InstancesSetServiceAccountRequest.prototype.scopes = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InstancesSetServiceAccountRequest _email.
                         * @member {"email"|undefined} _email
                         * @memberof google.cloud.compute.v1.InstancesSetServiceAccountRequest
                         * @instance
                         */
                        Object.defineProperty(InstancesSetServiceAccountRequest.prototype, "_email", {
                            get: $util.oneOfGetter($oneOfFields = ["email"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InstancesSetServiceAccountRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstancesSetServiceAccountRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesSetServiceAccountRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstancesSetServiceAccountRequest} InstancesSetServiceAccountRequest instance
                         */
                        InstancesSetServiceAccountRequest.create = function create(properties) {
                            return new InstancesSetServiceAccountRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InstancesSetServiceAccountRequest message. Does not implicitly {@link google.cloud.compute.v1.InstancesSetServiceAccountRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstancesSetServiceAccountRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesSetServiceAccountRequest} message InstancesSetServiceAccountRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesSetServiceAccountRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.email != null && Object.hasOwnProperty.call(message, "email"))
                                writer.uint32(/* id 96619420, wireType 2 =*/772955362).string(message.email);
                            if (message.scopes != null && message.scopes.length)
                                for (var i = 0; i < message.scopes.length; ++i)
                                    writer.uint32(/* id 165973151, wireType 2 =*/1327785210).string(message.scopes[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstancesSetServiceAccountRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstancesSetServiceAccountRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesSetServiceAccountRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesSetServiceAccountRequest} message InstancesSetServiceAccountRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesSetServiceAccountRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstancesSetServiceAccountRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstancesSetServiceAccountRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstancesSetServiceAccountRequest} InstancesSetServiceAccountRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesSetServiceAccountRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstancesSetServiceAccountRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 96619420: {
                                        message.email = reader.string();
                                        break;
                                    }
                                case 165973151: {
                                        if (!(message.scopes && message.scopes.length))
                                            message.scopes = [];
                                        message.scopes.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstancesSetServiceAccountRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesSetServiceAccountRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstancesSetServiceAccountRequest} InstancesSetServiceAccountRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesSetServiceAccountRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstancesSetServiceAccountRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstancesSetServiceAccountRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstancesSetServiceAccountRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.email != null && message.hasOwnProperty("email")) {
                                properties._email = 1;
                                if (!$util.isString(message.email))
                                    return "email: string expected";
                            }
                            if (message.scopes != null && message.hasOwnProperty("scopes")) {
                                if (!Array.isArray(message.scopes))
                                    return "scopes: array expected";
                                for (var i = 0; i < message.scopes.length; ++i)
                                    if (!$util.isString(message.scopes[i]))
                                        return "scopes: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstancesSetServiceAccountRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstancesSetServiceAccountRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstancesSetServiceAccountRequest} InstancesSetServiceAccountRequest
                         */
                        InstancesSetServiceAccountRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstancesSetServiceAccountRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstancesSetServiceAccountRequest();
                            if (object.email != null)
                                message.email = String(object.email);
                            if (object.scopes) {
                                if (!Array.isArray(object.scopes))
                                    throw TypeError(".google.cloud.compute.v1.InstancesSetServiceAccountRequest.scopes: array expected");
                                message.scopes = [];
                                for (var i = 0; i < object.scopes.length; ++i)
                                    message.scopes[i] = String(object.scopes[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstancesSetServiceAccountRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstancesSetServiceAccountRequest
                         * @static
                         * @param {google.cloud.compute.v1.InstancesSetServiceAccountRequest} message InstancesSetServiceAccountRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstancesSetServiceAccountRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.scopes = [];
                            if (message.email != null && message.hasOwnProperty("email")) {
                                object.email = message.email;
                                if (options.oneofs)
                                    object._email = "email";
                            }
                            if (message.scopes && message.scopes.length) {
                                object.scopes = [];
                                for (var j = 0; j < message.scopes.length; ++j)
                                    object.scopes[j] = message.scopes[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstancesSetServiceAccountRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstancesSetServiceAccountRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstancesSetServiceAccountRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstancesSetServiceAccountRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstancesSetServiceAccountRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstancesSetServiceAccountRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstancesSetServiceAccountRequest";
                        };
    
                        return InstancesSetServiceAccountRequest;
                    })();
    
                    v1.InstancesStartWithEncryptionKeyRequest = (function() {
    
                        /**
                         * Properties of an InstancesStartWithEncryptionKeyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInstancesStartWithEncryptionKeyRequest
                         * @property {Array.<google.cloud.compute.v1.ICustomerEncryptionKeyProtectedDisk>|null} [disks] InstancesStartWithEncryptionKeyRequest disks
                         */
    
                        /**
                         * Constructs a new InstancesStartWithEncryptionKeyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstancesStartWithEncryptionKeyRequest.
                         * @implements IInstancesStartWithEncryptionKeyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInstancesStartWithEncryptionKeyRequest=} [properties] Properties to set
                         */
                        function InstancesStartWithEncryptionKeyRequest(properties) {
                            this.disks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InstancesStartWithEncryptionKeyRequest disks.
                         * @member {Array.<google.cloud.compute.v1.ICustomerEncryptionKeyProtectedDisk>} disks
                         * @memberof google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest
                         * @instance
                         */
                        InstancesStartWithEncryptionKeyRequest.prototype.disks = $util.emptyArray;
    
                        /**
                         * Creates a new InstancesStartWithEncryptionKeyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesStartWithEncryptionKeyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest} InstancesStartWithEncryptionKeyRequest instance
                         */
                        InstancesStartWithEncryptionKeyRequest.create = function create(properties) {
                            return new InstancesStartWithEncryptionKeyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InstancesStartWithEncryptionKeyRequest message. Does not implicitly {@link google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesStartWithEncryptionKeyRequest} message InstancesStartWithEncryptionKeyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesStartWithEncryptionKeyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.disks != null && message.disks.length)
                                for (var i = 0; i < message.disks.length; ++i)
                                    $root.google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk.encode(message.disks[i], writer.uint32(/* id 95594102, wireType 2 =*/764752818).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InstancesStartWithEncryptionKeyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInstancesStartWithEncryptionKeyRequest} message InstancesStartWithEncryptionKeyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InstancesStartWithEncryptionKeyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InstancesStartWithEncryptionKeyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest} InstancesStartWithEncryptionKeyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesStartWithEncryptionKeyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 95594102: {
                                        if (!(message.disks && message.disks.length))
                                            message.disks = [];
                                        message.disks.push($root.google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InstancesStartWithEncryptionKeyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest} InstancesStartWithEncryptionKeyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InstancesStartWithEncryptionKeyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InstancesStartWithEncryptionKeyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InstancesStartWithEncryptionKeyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.disks != null && message.hasOwnProperty("disks")) {
                                if (!Array.isArray(message.disks))
                                    return "disks: array expected";
                                for (var i = 0; i < message.disks.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk.verify(message.disks[i]);
                                    if (error)
                                        return "disks." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InstancesStartWithEncryptionKeyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest} InstancesStartWithEncryptionKeyRequest
                         */
                        InstancesStartWithEncryptionKeyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest();
                            if (object.disks) {
                                if (!Array.isArray(object.disks))
                                    throw TypeError(".google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest.disks: array expected");
                                message.disks = [];
                                for (var i = 0; i < object.disks.length; ++i) {
                                    if (typeof object.disks[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest.disks: object expected");
                                    message.disks[i] = $root.google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk.fromObject(object.disks[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InstancesStartWithEncryptionKeyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest
                         * @static
                         * @param {google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest} message InstancesStartWithEncryptionKeyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InstancesStartWithEncryptionKeyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.disks = [];
                            if (message.disks && message.disks.length) {
                                object.disks = [];
                                for (var j = 0; j < message.disks.length; ++j)
                                    object.disks[j] = $root.google.cloud.compute.v1.CustomerEncryptionKeyProtectedDisk.toObject(message.disks[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InstancesStartWithEncryptionKeyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InstancesStartWithEncryptionKeyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InstancesStartWithEncryptionKeyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InstancesStartWithEncryptionKeyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest";
                        };
    
                        return InstancesStartWithEncryptionKeyRequest;
                    })();
    
                    v1.Int64RangeMatch = (function() {
    
                        /**
                         * Properties of an Int64RangeMatch.
                         * @memberof google.cloud.compute.v1
                         * @interface IInt64RangeMatch
                         * @property {number|Long|null} [rangeEnd] Int64RangeMatch rangeEnd
                         * @property {number|Long|null} [rangeStart] Int64RangeMatch rangeStart
                         */
    
                        /**
                         * Constructs a new Int64RangeMatch.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an Int64RangeMatch.
                         * @implements IInt64RangeMatch
                         * @constructor
                         * @param {google.cloud.compute.v1.IInt64RangeMatch=} [properties] Properties to set
                         */
                        function Int64RangeMatch(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Int64RangeMatch rangeEnd.
                         * @member {number|Long|null|undefined} rangeEnd
                         * @memberof google.cloud.compute.v1.Int64RangeMatch
                         * @instance
                         */
                        Int64RangeMatch.prototype.rangeEnd = null;
    
                        /**
                         * Int64RangeMatch rangeStart.
                         * @member {number|Long|null|undefined} rangeStart
                         * @memberof google.cloud.compute.v1.Int64RangeMatch
                         * @instance
                         */
                        Int64RangeMatch.prototype.rangeStart = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Int64RangeMatch _rangeEnd.
                         * @member {"rangeEnd"|undefined} _rangeEnd
                         * @memberof google.cloud.compute.v1.Int64RangeMatch
                         * @instance
                         */
                        Object.defineProperty(Int64RangeMatch.prototype, "_rangeEnd", {
                            get: $util.oneOfGetter($oneOfFields = ["rangeEnd"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Int64RangeMatch _rangeStart.
                         * @member {"rangeStart"|undefined} _rangeStart
                         * @memberof google.cloud.compute.v1.Int64RangeMatch
                         * @instance
                         */
                        Object.defineProperty(Int64RangeMatch.prototype, "_rangeStart", {
                            get: $util.oneOfGetter($oneOfFields = ["rangeStart"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Int64RangeMatch instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Int64RangeMatch
                         * @static
                         * @param {google.cloud.compute.v1.IInt64RangeMatch=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Int64RangeMatch} Int64RangeMatch instance
                         */
                        Int64RangeMatch.create = function create(properties) {
                            return new Int64RangeMatch(properties);
                        };
    
                        /**
                         * Encodes the specified Int64RangeMatch message. Does not implicitly {@link google.cloud.compute.v1.Int64RangeMatch.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Int64RangeMatch
                         * @static
                         * @param {google.cloud.compute.v1.IInt64RangeMatch} message Int64RangeMatch message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Int64RangeMatch.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.rangeStart != null && Object.hasOwnProperty.call(message, "rangeStart"))
                                writer.uint32(/* id 103333600, wireType 0 =*/826668800).int64(message.rangeStart);
                            if (message.rangeEnd != null && Object.hasOwnProperty.call(message, "rangeEnd"))
                                writer.uint32(/* id 322439897, wireType 0 =*/2579519176).int64(message.rangeEnd);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Int64RangeMatch message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Int64RangeMatch.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Int64RangeMatch
                         * @static
                         * @param {google.cloud.compute.v1.IInt64RangeMatch} message Int64RangeMatch message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Int64RangeMatch.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Int64RangeMatch message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Int64RangeMatch
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Int64RangeMatch} Int64RangeMatch
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Int64RangeMatch.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Int64RangeMatch();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 322439897: {
                                        message.rangeEnd = reader.int64();
                                        break;
                                    }
                                case 103333600: {
                                        message.rangeStart = reader.int64();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Int64RangeMatch message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Int64RangeMatch
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Int64RangeMatch} Int64RangeMatch
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Int64RangeMatch.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Int64RangeMatch message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Int64RangeMatch
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Int64RangeMatch.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.rangeEnd != null && message.hasOwnProperty("rangeEnd")) {
                                properties._rangeEnd = 1;
                                if (!$util.isInteger(message.rangeEnd) && !(message.rangeEnd && $util.isInteger(message.rangeEnd.low) && $util.isInteger(message.rangeEnd.high)))
                                    return "rangeEnd: integer|Long expected";
                            }
                            if (message.rangeStart != null && message.hasOwnProperty("rangeStart")) {
                                properties._rangeStart = 1;
                                if (!$util.isInteger(message.rangeStart) && !(message.rangeStart && $util.isInteger(message.rangeStart.low) && $util.isInteger(message.rangeStart.high)))
                                    return "rangeStart: integer|Long expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an Int64RangeMatch message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Int64RangeMatch
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Int64RangeMatch} Int64RangeMatch
                         */
                        Int64RangeMatch.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Int64RangeMatch)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Int64RangeMatch();
                            if (object.rangeEnd != null)
                                if ($util.Long)
                                    (message.rangeEnd = $util.Long.fromValue(object.rangeEnd)).unsigned = false;
                                else if (typeof object.rangeEnd === "string")
                                    message.rangeEnd = parseInt(object.rangeEnd, 10);
                                else if (typeof object.rangeEnd === "number")
                                    message.rangeEnd = object.rangeEnd;
                                else if (typeof object.rangeEnd === "object")
                                    message.rangeEnd = new $util.LongBits(object.rangeEnd.low >>> 0, object.rangeEnd.high >>> 0).toNumber();
                            if (object.rangeStart != null)
                                if ($util.Long)
                                    (message.rangeStart = $util.Long.fromValue(object.rangeStart)).unsigned = false;
                                else if (typeof object.rangeStart === "string")
                                    message.rangeStart = parseInt(object.rangeStart, 10);
                                else if (typeof object.rangeStart === "number")
                                    message.rangeStart = object.rangeStart;
                                else if (typeof object.rangeStart === "object")
                                    message.rangeStart = new $util.LongBits(object.rangeStart.low >>> 0, object.rangeStart.high >>> 0).toNumber();
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Int64RangeMatch message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Int64RangeMatch
                         * @static
                         * @param {google.cloud.compute.v1.Int64RangeMatch} message Int64RangeMatch
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Int64RangeMatch.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.rangeStart != null && message.hasOwnProperty("rangeStart")) {
                                if (typeof message.rangeStart === "number")
                                    object.rangeStart = options.longs === String ? String(message.rangeStart) : message.rangeStart;
                                else
                                    object.rangeStart = options.longs === String ? $util.Long.prototype.toString.call(message.rangeStart) : options.longs === Number ? new $util.LongBits(message.rangeStart.low >>> 0, message.rangeStart.high >>> 0).toNumber() : message.rangeStart;
                                if (options.oneofs)
                                    object._rangeStart = "rangeStart";
                            }
                            if (message.rangeEnd != null && message.hasOwnProperty("rangeEnd")) {
                                if (typeof message.rangeEnd === "number")
                                    object.rangeEnd = options.longs === String ? String(message.rangeEnd) : message.rangeEnd;
                                else
                                    object.rangeEnd = options.longs === String ? $util.Long.prototype.toString.call(message.rangeEnd) : options.longs === Number ? new $util.LongBits(message.rangeEnd.low >>> 0, message.rangeEnd.high >>> 0).toNumber() : message.rangeEnd;
                                if (options.oneofs)
                                    object._rangeEnd = "rangeEnd";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Int64RangeMatch to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Int64RangeMatch
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Int64RangeMatch.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Int64RangeMatch
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Int64RangeMatch
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Int64RangeMatch.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Int64RangeMatch";
                        };
    
                        return Int64RangeMatch;
                    })();
    
                    v1.Interconnect = (function() {
    
                        /**
                         * Properties of an Interconnect.
                         * @memberof google.cloud.compute.v1
                         * @interface IInterconnect
                         * @property {boolean|null} [adminEnabled] Interconnect adminEnabled
                         * @property {Array.<google.cloud.compute.v1.IInterconnectCircuitInfo>|null} [circuitInfos] Interconnect circuitInfos
                         * @property {string|null} [creationTimestamp] Interconnect creationTimestamp
                         * @property {string|null} [customerName] Interconnect customerName
                         * @property {string|null} [description] Interconnect description
                         * @property {Array.<google.cloud.compute.v1.IInterconnectOutageNotification>|null} [expectedOutages] Interconnect expectedOutages
                         * @property {string|null} [googleIpAddress] Interconnect googleIpAddress
                         * @property {string|null} [googleReferenceId] Interconnect googleReferenceId
                         * @property {number|Long|null} [id] Interconnect id
                         * @property {Array.<string>|null} [interconnectAttachments] Interconnect interconnectAttachments
                         * @property {string|null} [interconnectType] Interconnect interconnectType
                         * @property {string|null} [kind] Interconnect kind
                         * @property {string|null} [linkType] Interconnect linkType
                         * @property {string|null} [location] Interconnect location
                         * @property {string|null} [name] Interconnect name
                         * @property {string|null} [nocContactEmail] Interconnect nocContactEmail
                         * @property {string|null} [operationalStatus] Interconnect operationalStatus
                         * @property {string|null} [peerIpAddress] Interconnect peerIpAddress
                         * @property {number|null} [provisionedLinkCount] Interconnect provisionedLinkCount
                         * @property {number|null} [requestedLinkCount] Interconnect requestedLinkCount
                         * @property {boolean|null} [satisfiesPzs] Interconnect satisfiesPzs
                         * @property {string|null} [selfLink] Interconnect selfLink
                         * @property {string|null} [state] Interconnect state
                         */
    
                        /**
                         * Constructs a new Interconnect.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an Interconnect.
                         * @implements IInterconnect
                         * @constructor
                         * @param {google.cloud.compute.v1.IInterconnect=} [properties] Properties to set
                         */
                        function Interconnect(properties) {
                            this.circuitInfos = [];
                            this.expectedOutages = [];
                            this.interconnectAttachments = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Interconnect adminEnabled.
                         * @member {boolean|null|undefined} adminEnabled
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.adminEnabled = null;
    
                        /**
                         * Interconnect circuitInfos.
                         * @member {Array.<google.cloud.compute.v1.IInterconnectCircuitInfo>} circuitInfos
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.circuitInfos = $util.emptyArray;
    
                        /**
                         * Interconnect creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.creationTimestamp = null;
    
                        /**
                         * Interconnect customerName.
                         * @member {string|null|undefined} customerName
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.customerName = null;
    
                        /**
                         * Interconnect description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.description = null;
    
                        /**
                         * Interconnect expectedOutages.
                         * @member {Array.<google.cloud.compute.v1.IInterconnectOutageNotification>} expectedOutages
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.expectedOutages = $util.emptyArray;
    
                        /**
                         * Interconnect googleIpAddress.
                         * @member {string|null|undefined} googleIpAddress
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.googleIpAddress = null;
    
                        /**
                         * Interconnect googleReferenceId.
                         * @member {string|null|undefined} googleReferenceId
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.googleReferenceId = null;
    
                        /**
                         * Interconnect id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.id = null;
    
                        /**
                         * Interconnect interconnectAttachments.
                         * @member {Array.<string>} interconnectAttachments
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.interconnectAttachments = $util.emptyArray;
    
                        /**
                         * Interconnect interconnectType.
                         * @member {string|null|undefined} interconnectType
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.interconnectType = null;
    
                        /**
                         * Interconnect kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.kind = null;
    
                        /**
                         * Interconnect linkType.
                         * @member {string|null|undefined} linkType
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.linkType = null;
    
                        /**
                         * Interconnect location.
                         * @member {string|null|undefined} location
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.location = null;
    
                        /**
                         * Interconnect name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.name = null;
    
                        /**
                         * Interconnect nocContactEmail.
                         * @member {string|null|undefined} nocContactEmail
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.nocContactEmail = null;
    
                        /**
                         * Interconnect operationalStatus.
                         * @member {string|null|undefined} operationalStatus
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.operationalStatus = null;
    
                        /**
                         * Interconnect peerIpAddress.
                         * @member {string|null|undefined} peerIpAddress
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.peerIpAddress = null;
    
                        /**
                         * Interconnect provisionedLinkCount.
                         * @member {number|null|undefined} provisionedLinkCount
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.provisionedLinkCount = null;
    
                        /**
                         * Interconnect requestedLinkCount.
                         * @member {number|null|undefined} requestedLinkCount
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.requestedLinkCount = null;
    
                        /**
                         * Interconnect satisfiesPzs.
                         * @member {boolean|null|undefined} satisfiesPzs
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.satisfiesPzs = null;
    
                        /**
                         * Interconnect selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.selfLink = null;
    
                        /**
                         * Interconnect state.
                         * @member {string|null|undefined} state
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Interconnect.prototype.state = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Interconnect _adminEnabled.
                         * @member {"adminEnabled"|undefined} _adminEnabled
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Object.defineProperty(Interconnect.prototype, "_adminEnabled", {
                            get: $util.oneOfGetter($oneOfFields = ["adminEnabled"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Interconnect _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Object.defineProperty(Interconnect.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Interconnect _customerName.
                         * @member {"customerName"|undefined} _customerName
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Object.defineProperty(Interconnect.prototype, "_customerName", {
                            get: $util.oneOfGetter($oneOfFields = ["customerName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Interconnect _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Object.defineProperty(Interconnect.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Interconnect _googleIpAddress.
                         * @member {"googleIpAddress"|undefined} _googleIpAddress
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Object.defineProperty(Interconnect.prototype, "_googleIpAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["googleIpAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Interconnect _googleReferenceId.
                         * @member {"googleReferenceId"|undefined} _googleReferenceId
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Object.defineProperty(Interconnect.prototype, "_googleReferenceId", {
                            get: $util.oneOfGetter($oneOfFields = ["googleReferenceId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Interconnect _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Object.defineProperty(Interconnect.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Interconnect _interconnectType.
                         * @member {"interconnectType"|undefined} _interconnectType
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Object.defineProperty(Interconnect.prototype, "_interconnectType", {
                            get: $util.oneOfGetter($oneOfFields = ["interconnectType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Interconnect _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Object.defineProperty(Interconnect.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Interconnect _linkType.
                         * @member {"linkType"|undefined} _linkType
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Object.defineProperty(Interconnect.prototype, "_linkType", {
                            get: $util.oneOfGetter($oneOfFields = ["linkType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Interconnect _location.
                         * @member {"location"|undefined} _location
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Object.defineProperty(Interconnect.prototype, "_location", {
                            get: $util.oneOfGetter($oneOfFields = ["location"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Interconnect _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Object.defineProperty(Interconnect.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Interconnect _nocContactEmail.
                         * @member {"nocContactEmail"|undefined} _nocContactEmail
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Object.defineProperty(Interconnect.prototype, "_nocContactEmail", {
                            get: $util.oneOfGetter($oneOfFields = ["nocContactEmail"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Interconnect _operationalStatus.
                         * @member {"operationalStatus"|undefined} _operationalStatus
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Object.defineProperty(Interconnect.prototype, "_operationalStatus", {
                            get: $util.oneOfGetter($oneOfFields = ["operationalStatus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Interconnect _peerIpAddress.
                         * @member {"peerIpAddress"|undefined} _peerIpAddress
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Object.defineProperty(Interconnect.prototype, "_peerIpAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["peerIpAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Interconnect _provisionedLinkCount.
                         * @member {"provisionedLinkCount"|undefined} _provisionedLinkCount
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Object.defineProperty(Interconnect.prototype, "_provisionedLinkCount", {
                            get: $util.oneOfGetter($oneOfFields = ["provisionedLinkCount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Interconnect _requestedLinkCount.
                         * @member {"requestedLinkCount"|undefined} _requestedLinkCount
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Object.defineProperty(Interconnect.prototype, "_requestedLinkCount", {
                            get: $util.oneOfGetter($oneOfFields = ["requestedLinkCount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Interconnect _satisfiesPzs.
                         * @member {"satisfiesPzs"|undefined} _satisfiesPzs
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Object.defineProperty(Interconnect.prototype, "_satisfiesPzs", {
                            get: $util.oneOfGetter($oneOfFields = ["satisfiesPzs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Interconnect _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Object.defineProperty(Interconnect.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Interconnect _state.
                         * @member {"state"|undefined} _state
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         */
                        Object.defineProperty(Interconnect.prototype, "_state", {
                            get: $util.oneOfGetter($oneOfFields = ["state"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Interconnect instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnect=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Interconnect} Interconnect instance
                         */
                        Interconnect.create = function create(properties) {
                            return new Interconnect(properties);
                        };
    
                        /**
                         * Encodes the specified Interconnect message. Does not implicitly {@link google.cloud.compute.v1.Interconnect.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnect} message Interconnect message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Interconnect.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.customerName != null && Object.hasOwnProperty.call(message, "customerName"))
                                writer.uint32(/* id 3665484, wireType 2 =*/29323874).string(message.customerName);
                            if (message.nocContactEmail != null && Object.hasOwnProperty.call(message, "nocContactEmail"))
                                writer.uint32(/* id 14072832, wireType 2 =*/112582658).string(message.nocContactEmail);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.requestedLinkCount != null && Object.hasOwnProperty.call(message, "requestedLinkCount"))
                                writer.uint32(/* id 45051387, wireType 0 =*/360411096).int32(message.requestedLinkCount);
                            if (message.state != null && Object.hasOwnProperty.call(message, "state"))
                                writer.uint32(/* id 109757585, wireType 2 =*/878060682).string(message.state);
                            if (message.circuitInfos != null && message.circuitInfos.length)
                                for (var i = 0; i < message.circuitInfos.length; ++i)
                                    $root.google.cloud.compute.v1.InterconnectCircuitInfo.encode(message.circuitInfos[i], writer.uint32(/* id 164839855, wireType 2 =*/1318718842).fork()).ldelim();
                            if (message.operationalStatus != null && Object.hasOwnProperty.call(message, "operationalStatus"))
                                writer.uint32(/* id 201070847, wireType 2 =*/1608566778).string(message.operationalStatus);
                            if (message.peerIpAddress != null && Object.hasOwnProperty.call(message, "peerIpAddress"))
                                writer.uint32(/* id 207735769, wireType 2 =*/1661886154).string(message.peerIpAddress);
                            if (message.expectedOutages != null && message.expectedOutages.length)
                                for (var i = 0; i < message.expectedOutages.length; ++i)
                                    $root.google.cloud.compute.v1.InterconnectOutageNotification.encode(message.expectedOutages[i], writer.uint32(/* id 264484123, wireType 2 =*/2115872986).fork()).ldelim();
                            if (message.location != null && Object.hasOwnProperty.call(message, "location"))
                                writer.uint32(/* id 290430901, wireType 2 =*/2323447210).string(message.location);
                            if (message.provisionedLinkCount != null && Object.hasOwnProperty.call(message, "provisionedLinkCount"))
                                writer.uint32(/* id 410888565, wireType 0 =*/3287108520).int32(message.provisionedLinkCount);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.interconnectAttachments != null && message.interconnectAttachments.length)
                                for (var i = 0; i < message.interconnectAttachments.length; ++i)
                                    writer.uint32(/* id 425388415, wireType 2 =*/3403107322).string(message.interconnectAttachments[i]);
                            if (message.googleIpAddress != null && Object.hasOwnProperty.call(message, "googleIpAddress"))
                                writer.uint32(/* id 443105954, wireType 2 =*/3544847634).string(message.googleIpAddress);
                            if (message.adminEnabled != null && Object.hasOwnProperty.call(message, "adminEnabled"))
                                writer.uint32(/* id 445675089, wireType 0 =*/3565400712).bool(message.adminEnabled);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.satisfiesPzs != null && Object.hasOwnProperty.call(message, "satisfiesPzs"))
                                writer.uint32(/* id 480964267, wireType 0 =*/3847714136).bool(message.satisfiesPzs);
                            if (message.interconnectType != null && Object.hasOwnProperty.call(message, "interconnectType"))
                                writer.uint32(/* id 515165259, wireType 2 =*/4121322074).string(message.interconnectType);
                            if (message.linkType != null && Object.hasOwnProperty.call(message, "linkType"))
                                writer.uint32(/* id 523207775, wireType 2 =*/4185662202).string(message.linkType);
                            if (message.googleReferenceId != null && Object.hasOwnProperty.call(message, "googleReferenceId"))
                                writer.uint32(/* id 534944469, wireType 2 =*/4279555754).string(message.googleReferenceId);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Interconnect message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Interconnect.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnect} message Interconnect message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Interconnect.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Interconnect message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Interconnect} Interconnect
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Interconnect.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Interconnect();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 445675089: {
                                        message.adminEnabled = reader.bool();
                                        break;
                                    }
                                case 164839855: {
                                        if (!(message.circuitInfos && message.circuitInfos.length))
                                            message.circuitInfos = [];
                                        message.circuitInfos.push($root.google.cloud.compute.v1.InterconnectCircuitInfo.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 3665484: {
                                        message.customerName = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 264484123: {
                                        if (!(message.expectedOutages && message.expectedOutages.length))
                                            message.expectedOutages = [];
                                        message.expectedOutages.push($root.google.cloud.compute.v1.InterconnectOutageNotification.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 443105954: {
                                        message.googleIpAddress = reader.string();
                                        break;
                                    }
                                case 534944469: {
                                        message.googleReferenceId = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 425388415: {
                                        if (!(message.interconnectAttachments && message.interconnectAttachments.length))
                                            message.interconnectAttachments = [];
                                        message.interconnectAttachments.push(reader.string());
                                        break;
                                    }
                                case 515165259: {
                                        message.interconnectType = reader.string();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 523207775: {
                                        message.linkType = reader.string();
                                        break;
                                    }
                                case 290430901: {
                                        message.location = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 14072832: {
                                        message.nocContactEmail = reader.string();
                                        break;
                                    }
                                case 201070847: {
                                        message.operationalStatus = reader.string();
                                        break;
                                    }
                                case 207735769: {
                                        message.peerIpAddress = reader.string();
                                        break;
                                    }
                                case 410888565: {
                                        message.provisionedLinkCount = reader.int32();
                                        break;
                                    }
                                case 45051387: {
                                        message.requestedLinkCount = reader.int32();
                                        break;
                                    }
                                case 480964267: {
                                        message.satisfiesPzs = reader.bool();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 109757585: {
                                        message.state = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Interconnect message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Interconnect} Interconnect
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Interconnect.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Interconnect message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Interconnect.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.adminEnabled != null && message.hasOwnProperty("adminEnabled")) {
                                properties._adminEnabled = 1;
                                if (typeof message.adminEnabled !== "boolean")
                                    return "adminEnabled: boolean expected";
                            }
                            if (message.circuitInfos != null && message.hasOwnProperty("circuitInfos")) {
                                if (!Array.isArray(message.circuitInfos))
                                    return "circuitInfos: array expected";
                                for (var i = 0; i < message.circuitInfos.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InterconnectCircuitInfo.verify(message.circuitInfos[i]);
                                    if (error)
                                        return "circuitInfos." + error;
                                }
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.customerName != null && message.hasOwnProperty("customerName")) {
                                properties._customerName = 1;
                                if (!$util.isString(message.customerName))
                                    return "customerName: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.expectedOutages != null && message.hasOwnProperty("expectedOutages")) {
                                if (!Array.isArray(message.expectedOutages))
                                    return "expectedOutages: array expected";
                                for (var i = 0; i < message.expectedOutages.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InterconnectOutageNotification.verify(message.expectedOutages[i]);
                                    if (error)
                                        return "expectedOutages." + error;
                                }
                            }
                            if (message.googleIpAddress != null && message.hasOwnProperty("googleIpAddress")) {
                                properties._googleIpAddress = 1;
                                if (!$util.isString(message.googleIpAddress))
                                    return "googleIpAddress: string expected";
                            }
                            if (message.googleReferenceId != null && message.hasOwnProperty("googleReferenceId")) {
                                properties._googleReferenceId = 1;
                                if (!$util.isString(message.googleReferenceId))
                                    return "googleReferenceId: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.interconnectAttachments != null && message.hasOwnProperty("interconnectAttachments")) {
                                if (!Array.isArray(message.interconnectAttachments))
                                    return "interconnectAttachments: array expected";
                                for (var i = 0; i < message.interconnectAttachments.length; ++i)
                                    if (!$util.isString(message.interconnectAttachments[i]))
                                        return "interconnectAttachments: string[] expected";
                            }
                            if (message.interconnectType != null && message.hasOwnProperty("interconnectType")) {
                                properties._interconnectType = 1;
                                if (!$util.isString(message.interconnectType))
                                    return "interconnectType: string expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.linkType != null && message.hasOwnProperty("linkType")) {
                                properties._linkType = 1;
                                if (!$util.isString(message.linkType))
                                    return "linkType: string expected";
                            }
                            if (message.location != null && message.hasOwnProperty("location")) {
                                properties._location = 1;
                                if (!$util.isString(message.location))
                                    return "location: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.nocContactEmail != null && message.hasOwnProperty("nocContactEmail")) {
                                properties._nocContactEmail = 1;
                                if (!$util.isString(message.nocContactEmail))
                                    return "nocContactEmail: string expected";
                            }
                            if (message.operationalStatus != null && message.hasOwnProperty("operationalStatus")) {
                                properties._operationalStatus = 1;
                                if (!$util.isString(message.operationalStatus))
                                    return "operationalStatus: string expected";
                            }
                            if (message.peerIpAddress != null && message.hasOwnProperty("peerIpAddress")) {
                                properties._peerIpAddress = 1;
                                if (!$util.isString(message.peerIpAddress))
                                    return "peerIpAddress: string expected";
                            }
                            if (message.provisionedLinkCount != null && message.hasOwnProperty("provisionedLinkCount")) {
                                properties._provisionedLinkCount = 1;
                                if (!$util.isInteger(message.provisionedLinkCount))
                                    return "provisionedLinkCount: integer expected";
                            }
                            if (message.requestedLinkCount != null && message.hasOwnProperty("requestedLinkCount")) {
                                properties._requestedLinkCount = 1;
                                if (!$util.isInteger(message.requestedLinkCount))
                                    return "requestedLinkCount: integer expected";
                            }
                            if (message.satisfiesPzs != null && message.hasOwnProperty("satisfiesPzs")) {
                                properties._satisfiesPzs = 1;
                                if (typeof message.satisfiesPzs !== "boolean")
                                    return "satisfiesPzs: boolean expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                properties._state = 1;
                                if (!$util.isString(message.state))
                                    return "state: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an Interconnect message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Interconnect} Interconnect
                         */
                        Interconnect.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Interconnect)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Interconnect();
                            if (object.adminEnabled != null)
                                message.adminEnabled = Boolean(object.adminEnabled);
                            if (object.circuitInfos) {
                                if (!Array.isArray(object.circuitInfos))
                                    throw TypeError(".google.cloud.compute.v1.Interconnect.circuitInfos: array expected");
                                message.circuitInfos = [];
                                for (var i = 0; i < object.circuitInfos.length; ++i) {
                                    if (typeof object.circuitInfos[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Interconnect.circuitInfos: object expected");
                                    message.circuitInfos[i] = $root.google.cloud.compute.v1.InterconnectCircuitInfo.fromObject(object.circuitInfos[i]);
                                }
                            }
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.customerName != null)
                                message.customerName = String(object.customerName);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.expectedOutages) {
                                if (!Array.isArray(object.expectedOutages))
                                    throw TypeError(".google.cloud.compute.v1.Interconnect.expectedOutages: array expected");
                                message.expectedOutages = [];
                                for (var i = 0; i < object.expectedOutages.length; ++i) {
                                    if (typeof object.expectedOutages[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Interconnect.expectedOutages: object expected");
                                    message.expectedOutages[i] = $root.google.cloud.compute.v1.InterconnectOutageNotification.fromObject(object.expectedOutages[i]);
                                }
                            }
                            if (object.googleIpAddress != null)
                                message.googleIpAddress = String(object.googleIpAddress);
                            if (object.googleReferenceId != null)
                                message.googleReferenceId = String(object.googleReferenceId);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.interconnectAttachments) {
                                if (!Array.isArray(object.interconnectAttachments))
                                    throw TypeError(".google.cloud.compute.v1.Interconnect.interconnectAttachments: array expected");
                                message.interconnectAttachments = [];
                                for (var i = 0; i < object.interconnectAttachments.length; ++i)
                                    message.interconnectAttachments[i] = String(object.interconnectAttachments[i]);
                            }
                            if (object.interconnectType != null)
                                message.interconnectType = String(object.interconnectType);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.linkType != null)
                                message.linkType = String(object.linkType);
                            if (object.location != null)
                                message.location = String(object.location);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.nocContactEmail != null)
                                message.nocContactEmail = String(object.nocContactEmail);
                            if (object.operationalStatus != null)
                                message.operationalStatus = String(object.operationalStatus);
                            if (object.peerIpAddress != null)
                                message.peerIpAddress = String(object.peerIpAddress);
                            if (object.provisionedLinkCount != null)
                                message.provisionedLinkCount = object.provisionedLinkCount | 0;
                            if (object.requestedLinkCount != null)
                                message.requestedLinkCount = object.requestedLinkCount | 0;
                            if (object.satisfiesPzs != null)
                                message.satisfiesPzs = Boolean(object.satisfiesPzs);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.state != null)
                                message.state = String(object.state);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Interconnect message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @static
                         * @param {google.cloud.compute.v1.Interconnect} message Interconnect
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Interconnect.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.circuitInfos = [];
                                object.expectedOutages = [];
                                object.interconnectAttachments = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.customerName != null && message.hasOwnProperty("customerName")) {
                                object.customerName = message.customerName;
                                if (options.oneofs)
                                    object._customerName = "customerName";
                            }
                            if (message.nocContactEmail != null && message.hasOwnProperty("nocContactEmail")) {
                                object.nocContactEmail = message.nocContactEmail;
                                if (options.oneofs)
                                    object._nocContactEmail = "nocContactEmail";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.requestedLinkCount != null && message.hasOwnProperty("requestedLinkCount")) {
                                object.requestedLinkCount = message.requestedLinkCount;
                                if (options.oneofs)
                                    object._requestedLinkCount = "requestedLinkCount";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                object.state = message.state;
                                if (options.oneofs)
                                    object._state = "state";
                            }
                            if (message.circuitInfos && message.circuitInfos.length) {
                                object.circuitInfos = [];
                                for (var j = 0; j < message.circuitInfos.length; ++j)
                                    object.circuitInfos[j] = $root.google.cloud.compute.v1.InterconnectCircuitInfo.toObject(message.circuitInfos[j], options);
                            }
                            if (message.operationalStatus != null && message.hasOwnProperty("operationalStatus")) {
                                object.operationalStatus = message.operationalStatus;
                                if (options.oneofs)
                                    object._operationalStatus = "operationalStatus";
                            }
                            if (message.peerIpAddress != null && message.hasOwnProperty("peerIpAddress")) {
                                object.peerIpAddress = message.peerIpAddress;
                                if (options.oneofs)
                                    object._peerIpAddress = "peerIpAddress";
                            }
                            if (message.expectedOutages && message.expectedOutages.length) {
                                object.expectedOutages = [];
                                for (var j = 0; j < message.expectedOutages.length; ++j)
                                    object.expectedOutages[j] = $root.google.cloud.compute.v1.InterconnectOutageNotification.toObject(message.expectedOutages[j], options);
                            }
                            if (message.location != null && message.hasOwnProperty("location")) {
                                object.location = message.location;
                                if (options.oneofs)
                                    object._location = "location";
                            }
                            if (message.provisionedLinkCount != null && message.hasOwnProperty("provisionedLinkCount")) {
                                object.provisionedLinkCount = message.provisionedLinkCount;
                                if (options.oneofs)
                                    object._provisionedLinkCount = "provisionedLinkCount";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.interconnectAttachments && message.interconnectAttachments.length) {
                                object.interconnectAttachments = [];
                                for (var j = 0; j < message.interconnectAttachments.length; ++j)
                                    object.interconnectAttachments[j] = message.interconnectAttachments[j];
                            }
                            if (message.googleIpAddress != null && message.hasOwnProperty("googleIpAddress")) {
                                object.googleIpAddress = message.googleIpAddress;
                                if (options.oneofs)
                                    object._googleIpAddress = "googleIpAddress";
                            }
                            if (message.adminEnabled != null && message.hasOwnProperty("adminEnabled")) {
                                object.adminEnabled = message.adminEnabled;
                                if (options.oneofs)
                                    object._adminEnabled = "adminEnabled";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.satisfiesPzs != null && message.hasOwnProperty("satisfiesPzs")) {
                                object.satisfiesPzs = message.satisfiesPzs;
                                if (options.oneofs)
                                    object._satisfiesPzs = "satisfiesPzs";
                            }
                            if (message.interconnectType != null && message.hasOwnProperty("interconnectType")) {
                                object.interconnectType = message.interconnectType;
                                if (options.oneofs)
                                    object._interconnectType = "interconnectType";
                            }
                            if (message.linkType != null && message.hasOwnProperty("linkType")) {
                                object.linkType = message.linkType;
                                if (options.oneofs)
                                    object._linkType = "linkType";
                            }
                            if (message.googleReferenceId != null && message.hasOwnProperty("googleReferenceId")) {
                                object.googleReferenceId = message.googleReferenceId;
                                if (options.oneofs)
                                    object._googleReferenceId = "googleReferenceId";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Interconnect to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Interconnect.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Interconnect
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Interconnect
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Interconnect.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Interconnect";
                        };
    
                        /**
                         * InterconnectType enum.
                         * @name google.cloud.compute.v1.Interconnect.InterconnectType
                         * @enum {number}
                         * @property {number} UNDEFINED_INTERCONNECT_TYPE=0 UNDEFINED_INTERCONNECT_TYPE value
                         * @property {number} DEDICATED=258411983 DEDICATED value
                         * @property {number} IT_PRIVATE=335677007 IT_PRIVATE value
                         * @property {number} PARTNER=461924520 PARTNER value
                         */
                        Interconnect.InterconnectType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_INTERCONNECT_TYPE"] = 0;
                            values[valuesById[258411983] = "DEDICATED"] = 258411983;
                            values[valuesById[335677007] = "IT_PRIVATE"] = 335677007;
                            values[valuesById[461924520] = "PARTNER"] = 461924520;
                            return values;
                        })();
    
                        /**
                         * LinkType enum.
                         * @name google.cloud.compute.v1.Interconnect.LinkType
                         * @enum {number}
                         * @property {number} UNDEFINED_LINK_TYPE=0 UNDEFINED_LINK_TYPE value
                         * @property {number} LINK_TYPE_ETHERNET_100G_LR=337672551 LINK_TYPE_ETHERNET_100G_LR value
                         * @property {number} LINK_TYPE_ETHERNET_10G_LR=236739749 LINK_TYPE_ETHERNET_10G_LR value
                         */
                        Interconnect.LinkType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_LINK_TYPE"] = 0;
                            values[valuesById[337672551] = "LINK_TYPE_ETHERNET_100G_LR"] = 337672551;
                            values[valuesById[236739749] = "LINK_TYPE_ETHERNET_10G_LR"] = 236739749;
                            return values;
                        })();
    
                        /**
                         * OperationalStatus enum.
                         * @name google.cloud.compute.v1.Interconnect.OperationalStatus
                         * @enum {number}
                         * @property {number} UNDEFINED_OPERATIONAL_STATUS=0 UNDEFINED_OPERATIONAL_STATUS value
                         * @property {number} OS_ACTIVE=55721409 OS_ACTIVE value
                         * @property {number} OS_UNPROVISIONED=239771840 OS_UNPROVISIONED value
                         */
                        Interconnect.OperationalStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_OPERATIONAL_STATUS"] = 0;
                            values[valuesById[55721409] = "OS_ACTIVE"] = 55721409;
                            values[valuesById[239771840] = "OS_UNPROVISIONED"] = 239771840;
                            return values;
                        })();
    
                        /**
                         * State enum.
                         * @name google.cloud.compute.v1.Interconnect.State
                         * @enum {number}
                         * @property {number} UNDEFINED_STATE=0 UNDEFINED_STATE value
                         * @property {number} ACTIVE=314733318 ACTIVE value
                         * @property {number} UNPROVISIONED=517333979 UNPROVISIONED value
                         */
                        Interconnect.State = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATE"] = 0;
                            values[valuesById[314733318] = "ACTIVE"] = 314733318;
                            values[valuesById[517333979] = "UNPROVISIONED"] = 517333979;
                            return values;
                        })();
    
                        return Interconnect;
                    })();
    
                    v1.InterconnectAttachment = (function() {
    
                        /**
                         * Properties of an InterconnectAttachment.
                         * @memberof google.cloud.compute.v1
                         * @interface IInterconnectAttachment
                         * @property {boolean|null} [adminEnabled] InterconnectAttachment adminEnabled
                         * @property {string|null} [bandwidth] InterconnectAttachment bandwidth
                         * @property {Array.<string>|null} [candidateIpv6Subnets] InterconnectAttachment candidateIpv6Subnets
                         * @property {Array.<string>|null} [candidateSubnets] InterconnectAttachment candidateSubnets
                         * @property {string|null} [cloudRouterIpAddress] InterconnectAttachment cloudRouterIpAddress
                         * @property {string|null} [cloudRouterIpv6Address] InterconnectAttachment cloudRouterIpv6Address
                         * @property {string|null} [cloudRouterIpv6InterfaceId] InterconnectAttachment cloudRouterIpv6InterfaceId
                         * @property {string|null} [creationTimestamp] InterconnectAttachment creationTimestamp
                         * @property {string|null} [customerRouterIpAddress] InterconnectAttachment customerRouterIpAddress
                         * @property {string|null} [customerRouterIpv6Address] InterconnectAttachment customerRouterIpv6Address
                         * @property {string|null} [customerRouterIpv6InterfaceId] InterconnectAttachment customerRouterIpv6InterfaceId
                         * @property {number|null} [dataplaneVersion] InterconnectAttachment dataplaneVersion
                         * @property {string|null} [description] InterconnectAttachment description
                         * @property {string|null} [edgeAvailabilityDomain] InterconnectAttachment edgeAvailabilityDomain
                         * @property {string|null} [encryption] InterconnectAttachment encryption
                         * @property {string|null} [googleReferenceId] InterconnectAttachment googleReferenceId
                         * @property {number|Long|null} [id] InterconnectAttachment id
                         * @property {string|null} [interconnect] InterconnectAttachment interconnect
                         * @property {Array.<string>|null} [ipsecInternalAddresses] InterconnectAttachment ipsecInternalAddresses
                         * @property {string|null} [kind] InterconnectAttachment kind
                         * @property {number|null} [mtu] InterconnectAttachment mtu
                         * @property {string|null} [name] InterconnectAttachment name
                         * @property {string|null} [operationalStatus] InterconnectAttachment operationalStatus
                         * @property {string|null} [pairingKey] InterconnectAttachment pairingKey
                         * @property {number|Long|null} [partnerAsn] InterconnectAttachment partnerAsn
                         * @property {google.cloud.compute.v1.IInterconnectAttachmentPartnerMetadata|null} [partnerMetadata] InterconnectAttachment partnerMetadata
                         * @property {google.cloud.compute.v1.IInterconnectAttachmentPrivateInfo|null} [privateInterconnectInfo] InterconnectAttachment privateInterconnectInfo
                         * @property {string|null} [region] InterconnectAttachment region
                         * @property {string|null} [router] InterconnectAttachment router
                         * @property {boolean|null} [satisfiesPzs] InterconnectAttachment satisfiesPzs
                         * @property {string|null} [selfLink] InterconnectAttachment selfLink
                         * @property {string|null} [stackType] InterconnectAttachment stackType
                         * @property {string|null} [state] InterconnectAttachment state
                         * @property {string|null} [type] InterconnectAttachment type
                         * @property {number|null} [vlanTag8021q] InterconnectAttachment vlanTag8021q
                         */
    
                        /**
                         * Constructs a new InterconnectAttachment.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InterconnectAttachment.
                         * @implements IInterconnectAttachment
                         * @constructor
                         * @param {google.cloud.compute.v1.IInterconnectAttachment=} [properties] Properties to set
                         */
                        function InterconnectAttachment(properties) {
                            this.candidateIpv6Subnets = [];
                            this.candidateSubnets = [];
                            this.ipsecInternalAddresses = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InterconnectAttachment adminEnabled.
                         * @member {boolean|null|undefined} adminEnabled
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.adminEnabled = null;
    
                        /**
                         * InterconnectAttachment bandwidth.
                         * @member {string|null|undefined} bandwidth
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.bandwidth = null;
    
                        /**
                         * InterconnectAttachment candidateIpv6Subnets.
                         * @member {Array.<string>} candidateIpv6Subnets
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.candidateIpv6Subnets = $util.emptyArray;
    
                        /**
                         * InterconnectAttachment candidateSubnets.
                         * @member {Array.<string>} candidateSubnets
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.candidateSubnets = $util.emptyArray;
    
                        /**
                         * InterconnectAttachment cloudRouterIpAddress.
                         * @member {string|null|undefined} cloudRouterIpAddress
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.cloudRouterIpAddress = null;
    
                        /**
                         * InterconnectAttachment cloudRouterIpv6Address.
                         * @member {string|null|undefined} cloudRouterIpv6Address
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.cloudRouterIpv6Address = null;
    
                        /**
                         * InterconnectAttachment cloudRouterIpv6InterfaceId.
                         * @member {string|null|undefined} cloudRouterIpv6InterfaceId
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.cloudRouterIpv6InterfaceId = null;
    
                        /**
                         * InterconnectAttachment creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.creationTimestamp = null;
    
                        /**
                         * InterconnectAttachment customerRouterIpAddress.
                         * @member {string|null|undefined} customerRouterIpAddress
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.customerRouterIpAddress = null;
    
                        /**
                         * InterconnectAttachment customerRouterIpv6Address.
                         * @member {string|null|undefined} customerRouterIpv6Address
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.customerRouterIpv6Address = null;
    
                        /**
                         * InterconnectAttachment customerRouterIpv6InterfaceId.
                         * @member {string|null|undefined} customerRouterIpv6InterfaceId
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.customerRouterIpv6InterfaceId = null;
    
                        /**
                         * InterconnectAttachment dataplaneVersion.
                         * @member {number|null|undefined} dataplaneVersion
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.dataplaneVersion = null;
    
                        /**
                         * InterconnectAttachment description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.description = null;
    
                        /**
                         * InterconnectAttachment edgeAvailabilityDomain.
                         * @member {string|null|undefined} edgeAvailabilityDomain
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.edgeAvailabilityDomain = null;
    
                        /**
                         * InterconnectAttachment encryption.
                         * @member {string|null|undefined} encryption
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.encryption = null;
    
                        /**
                         * InterconnectAttachment googleReferenceId.
                         * @member {string|null|undefined} googleReferenceId
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.googleReferenceId = null;
    
                        /**
                         * InterconnectAttachment id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.id = null;
    
                        /**
                         * InterconnectAttachment interconnect.
                         * @member {string|null|undefined} interconnect
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.interconnect = null;
    
                        /**
                         * InterconnectAttachment ipsecInternalAddresses.
                         * @member {Array.<string>} ipsecInternalAddresses
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.ipsecInternalAddresses = $util.emptyArray;
    
                        /**
                         * InterconnectAttachment kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.kind = null;
    
                        /**
                         * InterconnectAttachment mtu.
                         * @member {number|null|undefined} mtu
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.mtu = null;
    
                        /**
                         * InterconnectAttachment name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.name = null;
    
                        /**
                         * InterconnectAttachment operationalStatus.
                         * @member {string|null|undefined} operationalStatus
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.operationalStatus = null;
    
                        /**
                         * InterconnectAttachment pairingKey.
                         * @member {string|null|undefined} pairingKey
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.pairingKey = null;
    
                        /**
                         * InterconnectAttachment partnerAsn.
                         * @member {number|Long|null|undefined} partnerAsn
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.partnerAsn = null;
    
                        /**
                         * InterconnectAttachment partnerMetadata.
                         * @member {google.cloud.compute.v1.IInterconnectAttachmentPartnerMetadata|null|undefined} partnerMetadata
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.partnerMetadata = null;
    
                        /**
                         * InterconnectAttachment privateInterconnectInfo.
                         * @member {google.cloud.compute.v1.IInterconnectAttachmentPrivateInfo|null|undefined} privateInterconnectInfo
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.privateInterconnectInfo = null;
    
                        /**
                         * InterconnectAttachment region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.region = null;
    
                        /**
                         * InterconnectAttachment router.
                         * @member {string|null|undefined} router
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.router = null;
    
                        /**
                         * InterconnectAttachment satisfiesPzs.
                         * @member {boolean|null|undefined} satisfiesPzs
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.satisfiesPzs = null;
    
                        /**
                         * InterconnectAttachment selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.selfLink = null;
    
                        /**
                         * InterconnectAttachment stackType.
                         * @member {string|null|undefined} stackType
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.stackType = null;
    
                        /**
                         * InterconnectAttachment state.
                         * @member {string|null|undefined} state
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.state = null;
    
                        /**
                         * InterconnectAttachment type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.type = null;
    
                        /**
                         * InterconnectAttachment vlanTag8021q.
                         * @member {number|null|undefined} vlanTag8021q
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        InterconnectAttachment.prototype.vlanTag8021q = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InterconnectAttachment _adminEnabled.
                         * @member {"adminEnabled"|undefined} _adminEnabled
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_adminEnabled", {
                            get: $util.oneOfGetter($oneOfFields = ["adminEnabled"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _bandwidth.
                         * @member {"bandwidth"|undefined} _bandwidth
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_bandwidth", {
                            get: $util.oneOfGetter($oneOfFields = ["bandwidth"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _cloudRouterIpAddress.
                         * @member {"cloudRouterIpAddress"|undefined} _cloudRouterIpAddress
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_cloudRouterIpAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["cloudRouterIpAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _cloudRouterIpv6Address.
                         * @member {"cloudRouterIpv6Address"|undefined} _cloudRouterIpv6Address
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_cloudRouterIpv6Address", {
                            get: $util.oneOfGetter($oneOfFields = ["cloudRouterIpv6Address"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _cloudRouterIpv6InterfaceId.
                         * @member {"cloudRouterIpv6InterfaceId"|undefined} _cloudRouterIpv6InterfaceId
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_cloudRouterIpv6InterfaceId", {
                            get: $util.oneOfGetter($oneOfFields = ["cloudRouterIpv6InterfaceId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _customerRouterIpAddress.
                         * @member {"customerRouterIpAddress"|undefined} _customerRouterIpAddress
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_customerRouterIpAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["customerRouterIpAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _customerRouterIpv6Address.
                         * @member {"customerRouterIpv6Address"|undefined} _customerRouterIpv6Address
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_customerRouterIpv6Address", {
                            get: $util.oneOfGetter($oneOfFields = ["customerRouterIpv6Address"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _customerRouterIpv6InterfaceId.
                         * @member {"customerRouterIpv6InterfaceId"|undefined} _customerRouterIpv6InterfaceId
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_customerRouterIpv6InterfaceId", {
                            get: $util.oneOfGetter($oneOfFields = ["customerRouterIpv6InterfaceId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _dataplaneVersion.
                         * @member {"dataplaneVersion"|undefined} _dataplaneVersion
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_dataplaneVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["dataplaneVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _edgeAvailabilityDomain.
                         * @member {"edgeAvailabilityDomain"|undefined} _edgeAvailabilityDomain
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_edgeAvailabilityDomain", {
                            get: $util.oneOfGetter($oneOfFields = ["edgeAvailabilityDomain"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _encryption.
                         * @member {"encryption"|undefined} _encryption
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_encryption", {
                            get: $util.oneOfGetter($oneOfFields = ["encryption"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _googleReferenceId.
                         * @member {"googleReferenceId"|undefined} _googleReferenceId
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_googleReferenceId", {
                            get: $util.oneOfGetter($oneOfFields = ["googleReferenceId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _interconnect.
                         * @member {"interconnect"|undefined} _interconnect
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_interconnect", {
                            get: $util.oneOfGetter($oneOfFields = ["interconnect"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _mtu.
                         * @member {"mtu"|undefined} _mtu
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_mtu", {
                            get: $util.oneOfGetter($oneOfFields = ["mtu"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _operationalStatus.
                         * @member {"operationalStatus"|undefined} _operationalStatus
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_operationalStatus", {
                            get: $util.oneOfGetter($oneOfFields = ["operationalStatus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _pairingKey.
                         * @member {"pairingKey"|undefined} _pairingKey
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_pairingKey", {
                            get: $util.oneOfGetter($oneOfFields = ["pairingKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _partnerAsn.
                         * @member {"partnerAsn"|undefined} _partnerAsn
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_partnerAsn", {
                            get: $util.oneOfGetter($oneOfFields = ["partnerAsn"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _partnerMetadata.
                         * @member {"partnerMetadata"|undefined} _partnerMetadata
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_partnerMetadata", {
                            get: $util.oneOfGetter($oneOfFields = ["partnerMetadata"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _privateInterconnectInfo.
                         * @member {"privateInterconnectInfo"|undefined} _privateInterconnectInfo
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_privateInterconnectInfo", {
                            get: $util.oneOfGetter($oneOfFields = ["privateInterconnectInfo"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _router.
                         * @member {"router"|undefined} _router
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_router", {
                            get: $util.oneOfGetter($oneOfFields = ["router"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _satisfiesPzs.
                         * @member {"satisfiesPzs"|undefined} _satisfiesPzs
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_satisfiesPzs", {
                            get: $util.oneOfGetter($oneOfFields = ["satisfiesPzs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _stackType.
                         * @member {"stackType"|undefined} _stackType
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_stackType", {
                            get: $util.oneOfGetter($oneOfFields = ["stackType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _state.
                         * @member {"state"|undefined} _state
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_state", {
                            get: $util.oneOfGetter($oneOfFields = ["state"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachment _vlanTag8021q.
                         * @member {"vlanTag8021q"|undefined} _vlanTag8021q
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachment.prototype, "_vlanTag8021q", {
                            get: $util.oneOfGetter($oneOfFields = ["vlanTag8021q"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InterconnectAttachment instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectAttachment=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InterconnectAttachment} InterconnectAttachment instance
                         */
                        InterconnectAttachment.create = function create(properties) {
                            return new InterconnectAttachment(properties);
                        };
    
                        /**
                         * Encodes the specified InterconnectAttachment message. Does not implicitly {@link google.cloud.compute.v1.InterconnectAttachment.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectAttachment} message InterconnectAttachment message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectAttachment.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.mtu != null && Object.hasOwnProperty.call(message, "mtu"))
                                writer.uint32(/* id 108462, wireType 0 =*/867696).int32(message.mtu);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.dataplaneVersion != null && Object.hasOwnProperty.call(message, "dataplaneVersion"))
                                writer.uint32(/* id 34920075, wireType 0 =*/279360600).int32(message.dataplaneVersion);
                            if (message.partnerMetadata != null && Object.hasOwnProperty.call(message, "partnerMetadata"))
                                $root.google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata.encode(message.partnerMetadata, writer.uint32(/* id 65908934, wireType 2 =*/527271474).fork()).ldelim();
                            if (message.candidateIpv6Subnets != null && message.candidateIpv6Subnets.length)
                                for (var i = 0; i < message.candidateIpv6Subnets.length; ++i)
                                    writer.uint32(/* id 70682522, wireType 2 =*/565460178).string(message.candidateIpv6Subnets[i]);
                            if (message.edgeAvailabilityDomain != null && Object.hasOwnProperty.call(message, "edgeAvailabilityDomain"))
                                writer.uint32(/* id 71289510, wireType 2 =*/570316082).string(message.edgeAvailabilityDomain);
                            if (message.encryption != null && Object.hasOwnProperty.call(message, "encryption"))
                                writer.uint32(/* id 97980291, wireType 2 =*/783842330).string(message.encryption);
                            if (message.state != null && Object.hasOwnProperty.call(message, "state"))
                                writer.uint32(/* id 109757585, wireType 2 =*/878060682).string(message.state);
                            if (message.vlanTag8021q != null && Object.hasOwnProperty.call(message, "vlanTag8021q"))
                                writer.uint32(/* id 119927836, wireType 0 =*/959422688).int32(message.vlanTag8021q);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.router != null && Object.hasOwnProperty.call(message, "router"))
                                writer.uint32(/* id 148608841, wireType 2 =*/1188870730).string(message.router);
                            if (message.bandwidth != null && Object.hasOwnProperty.call(message, "bandwidth"))
                                writer.uint32(/* id 181715121, wireType 2 =*/1453720970).string(message.bandwidth);
                            if (message.operationalStatus != null && Object.hasOwnProperty.call(message, "operationalStatus"))
                                writer.uint32(/* id 201070847, wireType 2 =*/1608566778).string(message.operationalStatus);
                            if (message.interconnect != null && Object.hasOwnProperty.call(message, "interconnect"))
                                writer.uint32(/* id 224601230, wireType 2 =*/1796809842).string(message.interconnect);
                            if (message.privateInterconnectInfo != null && Object.hasOwnProperty.call(message, "privateInterconnectInfo"))
                                $root.google.cloud.compute.v1.InterconnectAttachmentPrivateInfo.encode(message.privateInterconnectInfo, writer.uint32(/* id 237270531, wireType 2 =*/1898164250).fork()).ldelim();
                            if (message.candidateSubnets != null && message.candidateSubnets.length)
                                for (var i = 0; i < message.candidateSubnets.length; ++i)
                                    writer.uint32(/* id 237842938, wireType 2 =*/1902743506).string(message.candidateSubnets[i]);
                            if (message.cloudRouterIpAddress != null && Object.hasOwnProperty.call(message, "cloudRouterIpAddress"))
                                writer.uint32(/* id 287392776, wireType 2 =*/2299142210).string(message.cloudRouterIpAddress);
                            if (message.customerRouterIpv6Address != null && Object.hasOwnProperty.call(message, "customerRouterIpv6Address"))
                                writer.uint32(/* id 290127089, wireType 2 =*/2321016714).string(message.customerRouterIpv6Address);
                            if (message.customerRouterIpAddress != null && Object.hasOwnProperty.call(message, "customerRouterIpAddress"))
                                writer.uint32(/* id 332475761, wireType 2 =*/2659806090).string(message.customerRouterIpAddress);
                            if (message.customerRouterIpv6InterfaceId != null && Object.hasOwnProperty.call(message, "customerRouterIpv6InterfaceId"))
                                writer.uint32(/* id 380994308, wireType 2 =*/3047954466).string(message.customerRouterIpv6InterfaceId);
                            if (message.ipsecInternalAddresses != null && message.ipsecInternalAddresses.length)
                                for (var i = 0; i < message.ipsecInternalAddresses.length; ++i)
                                    writer.uint32(/* id 407648565, wireType 2 =*/3261188522).string(message.ipsecInternalAddresses[i]);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.stackType != null && Object.hasOwnProperty.call(message, "stackType"))
                                writer.uint32(/* id 425908881, wireType 2 =*/3407271050).string(message.stackType);
                            if (message.partnerAsn != null && Object.hasOwnProperty.call(message, "partnerAsn"))
                                writer.uint32(/* id 438166149, wireType 0 =*/3505329192).int64(message.partnerAsn);
                            if (message.pairingKey != null && Object.hasOwnProperty.call(message, "pairingKey"))
                                writer.uint32(/* id 439695464, wireType 2 =*/3517563714).string(message.pairingKey);
                            if (message.adminEnabled != null && Object.hasOwnProperty.call(message, "adminEnabled"))
                                writer.uint32(/* id 445675089, wireType 0 =*/3565400712).bool(message.adminEnabled);
                            if (message.cloudRouterIpv6Address != null && Object.hasOwnProperty.call(message, "cloudRouterIpv6Address"))
                                writer.uint32(/* id 451922376, wireType 2 =*/3615379010).string(message.cloudRouterIpv6Address);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.satisfiesPzs != null && Object.hasOwnProperty.call(message, "satisfiesPzs"))
                                writer.uint32(/* id 480964267, wireType 0 =*/3847714136).bool(message.satisfiesPzs);
                            if (message.cloudRouterIpv6InterfaceId != null && Object.hasOwnProperty.call(message, "cloudRouterIpv6InterfaceId"))
                                writer.uint32(/* id 521282701, wireType 2 =*/4170261610).string(message.cloudRouterIpv6InterfaceId);
                            if (message.googleReferenceId != null && Object.hasOwnProperty.call(message, "googleReferenceId"))
                                writer.uint32(/* id 534944469, wireType 2 =*/4279555754).string(message.googleReferenceId);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InterconnectAttachment message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InterconnectAttachment.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectAttachment} message InterconnectAttachment message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectAttachment.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InterconnectAttachment message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InterconnectAttachment} InterconnectAttachment
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectAttachment.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InterconnectAttachment();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 445675089: {
                                        message.adminEnabled = reader.bool();
                                        break;
                                    }
                                case 181715121: {
                                        message.bandwidth = reader.string();
                                        break;
                                    }
                                case 70682522: {
                                        if (!(message.candidateIpv6Subnets && message.candidateIpv6Subnets.length))
                                            message.candidateIpv6Subnets = [];
                                        message.candidateIpv6Subnets.push(reader.string());
                                        break;
                                    }
                                case 237842938: {
                                        if (!(message.candidateSubnets && message.candidateSubnets.length))
                                            message.candidateSubnets = [];
                                        message.candidateSubnets.push(reader.string());
                                        break;
                                    }
                                case 287392776: {
                                        message.cloudRouterIpAddress = reader.string();
                                        break;
                                    }
                                case 451922376: {
                                        message.cloudRouterIpv6Address = reader.string();
                                        break;
                                    }
                                case 521282701: {
                                        message.cloudRouterIpv6InterfaceId = reader.string();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 332475761: {
                                        message.customerRouterIpAddress = reader.string();
                                        break;
                                    }
                                case 290127089: {
                                        message.customerRouterIpv6Address = reader.string();
                                        break;
                                    }
                                case 380994308: {
                                        message.customerRouterIpv6InterfaceId = reader.string();
                                        break;
                                    }
                                case 34920075: {
                                        message.dataplaneVersion = reader.int32();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 71289510: {
                                        message.edgeAvailabilityDomain = reader.string();
                                        break;
                                    }
                                case 97980291: {
                                        message.encryption = reader.string();
                                        break;
                                    }
                                case 534944469: {
                                        message.googleReferenceId = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 224601230: {
                                        message.interconnect = reader.string();
                                        break;
                                    }
                                case 407648565: {
                                        if (!(message.ipsecInternalAddresses && message.ipsecInternalAddresses.length))
                                            message.ipsecInternalAddresses = [];
                                        message.ipsecInternalAddresses.push(reader.string());
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 108462: {
                                        message.mtu = reader.int32();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 201070847: {
                                        message.operationalStatus = reader.string();
                                        break;
                                    }
                                case 439695464: {
                                        message.pairingKey = reader.string();
                                        break;
                                    }
                                case 438166149: {
                                        message.partnerAsn = reader.int64();
                                        break;
                                    }
                                case 65908934: {
                                        message.partnerMetadata = $root.google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 237270531: {
                                        message.privateInterconnectInfo = $root.google.cloud.compute.v1.InterconnectAttachmentPrivateInfo.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 148608841: {
                                        message.router = reader.string();
                                        break;
                                    }
                                case 480964267: {
                                        message.satisfiesPzs = reader.bool();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 425908881: {
                                        message.stackType = reader.string();
                                        break;
                                    }
                                case 109757585: {
                                        message.state = reader.string();
                                        break;
                                    }
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                case 119927836: {
                                        message.vlanTag8021q = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InterconnectAttachment message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InterconnectAttachment} InterconnectAttachment
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectAttachment.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InterconnectAttachment message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InterconnectAttachment.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.adminEnabled != null && message.hasOwnProperty("adminEnabled")) {
                                properties._adminEnabled = 1;
                                if (typeof message.adminEnabled !== "boolean")
                                    return "adminEnabled: boolean expected";
                            }
                            if (message.bandwidth != null && message.hasOwnProperty("bandwidth")) {
                                properties._bandwidth = 1;
                                if (!$util.isString(message.bandwidth))
                                    return "bandwidth: string expected";
                            }
                            if (message.candidateIpv6Subnets != null && message.hasOwnProperty("candidateIpv6Subnets")) {
                                if (!Array.isArray(message.candidateIpv6Subnets))
                                    return "candidateIpv6Subnets: array expected";
                                for (var i = 0; i < message.candidateIpv6Subnets.length; ++i)
                                    if (!$util.isString(message.candidateIpv6Subnets[i]))
                                        return "candidateIpv6Subnets: string[] expected";
                            }
                            if (message.candidateSubnets != null && message.hasOwnProperty("candidateSubnets")) {
                                if (!Array.isArray(message.candidateSubnets))
                                    return "candidateSubnets: array expected";
                                for (var i = 0; i < message.candidateSubnets.length; ++i)
                                    if (!$util.isString(message.candidateSubnets[i]))
                                        return "candidateSubnets: string[] expected";
                            }
                            if (message.cloudRouterIpAddress != null && message.hasOwnProperty("cloudRouterIpAddress")) {
                                properties._cloudRouterIpAddress = 1;
                                if (!$util.isString(message.cloudRouterIpAddress))
                                    return "cloudRouterIpAddress: string expected";
                            }
                            if (message.cloudRouterIpv6Address != null && message.hasOwnProperty("cloudRouterIpv6Address")) {
                                properties._cloudRouterIpv6Address = 1;
                                if (!$util.isString(message.cloudRouterIpv6Address))
                                    return "cloudRouterIpv6Address: string expected";
                            }
                            if (message.cloudRouterIpv6InterfaceId != null && message.hasOwnProperty("cloudRouterIpv6InterfaceId")) {
                                properties._cloudRouterIpv6InterfaceId = 1;
                                if (!$util.isString(message.cloudRouterIpv6InterfaceId))
                                    return "cloudRouterIpv6InterfaceId: string expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.customerRouterIpAddress != null && message.hasOwnProperty("customerRouterIpAddress")) {
                                properties._customerRouterIpAddress = 1;
                                if (!$util.isString(message.customerRouterIpAddress))
                                    return "customerRouterIpAddress: string expected";
                            }
                            if (message.customerRouterIpv6Address != null && message.hasOwnProperty("customerRouterIpv6Address")) {
                                properties._customerRouterIpv6Address = 1;
                                if (!$util.isString(message.customerRouterIpv6Address))
                                    return "customerRouterIpv6Address: string expected";
                            }
                            if (message.customerRouterIpv6InterfaceId != null && message.hasOwnProperty("customerRouterIpv6InterfaceId")) {
                                properties._customerRouterIpv6InterfaceId = 1;
                                if (!$util.isString(message.customerRouterIpv6InterfaceId))
                                    return "customerRouterIpv6InterfaceId: string expected";
                            }
                            if (message.dataplaneVersion != null && message.hasOwnProperty("dataplaneVersion")) {
                                properties._dataplaneVersion = 1;
                                if (!$util.isInteger(message.dataplaneVersion))
                                    return "dataplaneVersion: integer expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.edgeAvailabilityDomain != null && message.hasOwnProperty("edgeAvailabilityDomain")) {
                                properties._edgeAvailabilityDomain = 1;
                                if (!$util.isString(message.edgeAvailabilityDomain))
                                    return "edgeAvailabilityDomain: string expected";
                            }
                            if (message.encryption != null && message.hasOwnProperty("encryption")) {
                                properties._encryption = 1;
                                if (!$util.isString(message.encryption))
                                    return "encryption: string expected";
                            }
                            if (message.googleReferenceId != null && message.hasOwnProperty("googleReferenceId")) {
                                properties._googleReferenceId = 1;
                                if (!$util.isString(message.googleReferenceId))
                                    return "googleReferenceId: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.interconnect != null && message.hasOwnProperty("interconnect")) {
                                properties._interconnect = 1;
                                if (!$util.isString(message.interconnect))
                                    return "interconnect: string expected";
                            }
                            if (message.ipsecInternalAddresses != null && message.hasOwnProperty("ipsecInternalAddresses")) {
                                if (!Array.isArray(message.ipsecInternalAddresses))
                                    return "ipsecInternalAddresses: array expected";
                                for (var i = 0; i < message.ipsecInternalAddresses.length; ++i)
                                    if (!$util.isString(message.ipsecInternalAddresses[i]))
                                        return "ipsecInternalAddresses: string[] expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.mtu != null && message.hasOwnProperty("mtu")) {
                                properties._mtu = 1;
                                if (!$util.isInteger(message.mtu))
                                    return "mtu: integer expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.operationalStatus != null && message.hasOwnProperty("operationalStatus")) {
                                properties._operationalStatus = 1;
                                if (!$util.isString(message.operationalStatus))
                                    return "operationalStatus: string expected";
                            }
                            if (message.pairingKey != null && message.hasOwnProperty("pairingKey")) {
                                properties._pairingKey = 1;
                                if (!$util.isString(message.pairingKey))
                                    return "pairingKey: string expected";
                            }
                            if (message.partnerAsn != null && message.hasOwnProperty("partnerAsn")) {
                                properties._partnerAsn = 1;
                                if (!$util.isInteger(message.partnerAsn) && !(message.partnerAsn && $util.isInteger(message.partnerAsn.low) && $util.isInteger(message.partnerAsn.high)))
                                    return "partnerAsn: integer|Long expected";
                            }
                            if (message.partnerMetadata != null && message.hasOwnProperty("partnerMetadata")) {
                                properties._partnerMetadata = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata.verify(message.partnerMetadata);
                                    if (error)
                                        return "partnerMetadata." + error;
                                }
                            }
                            if (message.privateInterconnectInfo != null && message.hasOwnProperty("privateInterconnectInfo")) {
                                properties._privateInterconnectInfo = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InterconnectAttachmentPrivateInfo.verify(message.privateInterconnectInfo);
                                    if (error)
                                        return "privateInterconnectInfo." + error;
                                }
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.router != null && message.hasOwnProperty("router")) {
                                properties._router = 1;
                                if (!$util.isString(message.router))
                                    return "router: string expected";
                            }
                            if (message.satisfiesPzs != null && message.hasOwnProperty("satisfiesPzs")) {
                                properties._satisfiesPzs = 1;
                                if (typeof message.satisfiesPzs !== "boolean")
                                    return "satisfiesPzs: boolean expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.stackType != null && message.hasOwnProperty("stackType")) {
                                properties._stackType = 1;
                                if (!$util.isString(message.stackType))
                                    return "stackType: string expected";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                properties._state = 1;
                                if (!$util.isString(message.state))
                                    return "state: string expected";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            if (message.vlanTag8021q != null && message.hasOwnProperty("vlanTag8021q")) {
                                properties._vlanTag8021q = 1;
                                if (!$util.isInteger(message.vlanTag8021q))
                                    return "vlanTag8021q: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InterconnectAttachment message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InterconnectAttachment} InterconnectAttachment
                         */
                        InterconnectAttachment.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InterconnectAttachment)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InterconnectAttachment();
                            if (object.adminEnabled != null)
                                message.adminEnabled = Boolean(object.adminEnabled);
                            if (object.bandwidth != null)
                                message.bandwidth = String(object.bandwidth);
                            if (object.candidateIpv6Subnets) {
                                if (!Array.isArray(object.candidateIpv6Subnets))
                                    throw TypeError(".google.cloud.compute.v1.InterconnectAttachment.candidateIpv6Subnets: array expected");
                                message.candidateIpv6Subnets = [];
                                for (var i = 0; i < object.candidateIpv6Subnets.length; ++i)
                                    message.candidateIpv6Subnets[i] = String(object.candidateIpv6Subnets[i]);
                            }
                            if (object.candidateSubnets) {
                                if (!Array.isArray(object.candidateSubnets))
                                    throw TypeError(".google.cloud.compute.v1.InterconnectAttachment.candidateSubnets: array expected");
                                message.candidateSubnets = [];
                                for (var i = 0; i < object.candidateSubnets.length; ++i)
                                    message.candidateSubnets[i] = String(object.candidateSubnets[i]);
                            }
                            if (object.cloudRouterIpAddress != null)
                                message.cloudRouterIpAddress = String(object.cloudRouterIpAddress);
                            if (object.cloudRouterIpv6Address != null)
                                message.cloudRouterIpv6Address = String(object.cloudRouterIpv6Address);
                            if (object.cloudRouterIpv6InterfaceId != null)
                                message.cloudRouterIpv6InterfaceId = String(object.cloudRouterIpv6InterfaceId);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.customerRouterIpAddress != null)
                                message.customerRouterIpAddress = String(object.customerRouterIpAddress);
                            if (object.customerRouterIpv6Address != null)
                                message.customerRouterIpv6Address = String(object.customerRouterIpv6Address);
                            if (object.customerRouterIpv6InterfaceId != null)
                                message.customerRouterIpv6InterfaceId = String(object.customerRouterIpv6InterfaceId);
                            if (object.dataplaneVersion != null)
                                message.dataplaneVersion = object.dataplaneVersion | 0;
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.edgeAvailabilityDomain != null)
                                message.edgeAvailabilityDomain = String(object.edgeAvailabilityDomain);
                            if (object.encryption != null)
                                message.encryption = String(object.encryption);
                            if (object.googleReferenceId != null)
                                message.googleReferenceId = String(object.googleReferenceId);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.interconnect != null)
                                message.interconnect = String(object.interconnect);
                            if (object.ipsecInternalAddresses) {
                                if (!Array.isArray(object.ipsecInternalAddresses))
                                    throw TypeError(".google.cloud.compute.v1.InterconnectAttachment.ipsecInternalAddresses: array expected");
                                message.ipsecInternalAddresses = [];
                                for (var i = 0; i < object.ipsecInternalAddresses.length; ++i)
                                    message.ipsecInternalAddresses[i] = String(object.ipsecInternalAddresses[i]);
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.mtu != null)
                                message.mtu = object.mtu | 0;
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.operationalStatus != null)
                                message.operationalStatus = String(object.operationalStatus);
                            if (object.pairingKey != null)
                                message.pairingKey = String(object.pairingKey);
                            if (object.partnerAsn != null)
                                if ($util.Long)
                                    (message.partnerAsn = $util.Long.fromValue(object.partnerAsn)).unsigned = false;
                                else if (typeof object.partnerAsn === "string")
                                    message.partnerAsn = parseInt(object.partnerAsn, 10);
                                else if (typeof object.partnerAsn === "number")
                                    message.partnerAsn = object.partnerAsn;
                                else if (typeof object.partnerAsn === "object")
                                    message.partnerAsn = new $util.LongBits(object.partnerAsn.low >>> 0, object.partnerAsn.high >>> 0).toNumber();
                            if (object.partnerMetadata != null) {
                                if (typeof object.partnerMetadata !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InterconnectAttachment.partnerMetadata: object expected");
                                message.partnerMetadata = $root.google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata.fromObject(object.partnerMetadata);
                            }
                            if (object.privateInterconnectInfo != null) {
                                if (typeof object.privateInterconnectInfo !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InterconnectAttachment.privateInterconnectInfo: object expected");
                                message.privateInterconnectInfo = $root.google.cloud.compute.v1.InterconnectAttachmentPrivateInfo.fromObject(object.privateInterconnectInfo);
                            }
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.router != null)
                                message.router = String(object.router);
                            if (object.satisfiesPzs != null)
                                message.satisfiesPzs = Boolean(object.satisfiesPzs);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.stackType != null)
                                message.stackType = String(object.stackType);
                            if (object.state != null)
                                message.state = String(object.state);
                            if (object.type != null)
                                message.type = String(object.type);
                            if (object.vlanTag8021q != null)
                                message.vlanTag8021q = object.vlanTag8021q | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InterconnectAttachment message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @static
                         * @param {google.cloud.compute.v1.InterconnectAttachment} message InterconnectAttachment
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InterconnectAttachment.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.candidateIpv6Subnets = [];
                                object.candidateSubnets = [];
                                object.ipsecInternalAddresses = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.mtu != null && message.hasOwnProperty("mtu")) {
                                object.mtu = message.mtu;
                                if (options.oneofs)
                                    object._mtu = "mtu";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.dataplaneVersion != null && message.hasOwnProperty("dataplaneVersion")) {
                                object.dataplaneVersion = message.dataplaneVersion;
                                if (options.oneofs)
                                    object._dataplaneVersion = "dataplaneVersion";
                            }
                            if (message.partnerMetadata != null && message.hasOwnProperty("partnerMetadata")) {
                                object.partnerMetadata = $root.google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata.toObject(message.partnerMetadata, options);
                                if (options.oneofs)
                                    object._partnerMetadata = "partnerMetadata";
                            }
                            if (message.candidateIpv6Subnets && message.candidateIpv6Subnets.length) {
                                object.candidateIpv6Subnets = [];
                                for (var j = 0; j < message.candidateIpv6Subnets.length; ++j)
                                    object.candidateIpv6Subnets[j] = message.candidateIpv6Subnets[j];
                            }
                            if (message.edgeAvailabilityDomain != null && message.hasOwnProperty("edgeAvailabilityDomain")) {
                                object.edgeAvailabilityDomain = message.edgeAvailabilityDomain;
                                if (options.oneofs)
                                    object._edgeAvailabilityDomain = "edgeAvailabilityDomain";
                            }
                            if (message.encryption != null && message.hasOwnProperty("encryption")) {
                                object.encryption = message.encryption;
                                if (options.oneofs)
                                    object._encryption = "encryption";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                object.state = message.state;
                                if (options.oneofs)
                                    object._state = "state";
                            }
                            if (message.vlanTag8021q != null && message.hasOwnProperty("vlanTag8021q")) {
                                object.vlanTag8021q = message.vlanTag8021q;
                                if (options.oneofs)
                                    object._vlanTag8021q = "vlanTag8021q";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.router != null && message.hasOwnProperty("router")) {
                                object.router = message.router;
                                if (options.oneofs)
                                    object._router = "router";
                            }
                            if (message.bandwidth != null && message.hasOwnProperty("bandwidth")) {
                                object.bandwidth = message.bandwidth;
                                if (options.oneofs)
                                    object._bandwidth = "bandwidth";
                            }
                            if (message.operationalStatus != null && message.hasOwnProperty("operationalStatus")) {
                                object.operationalStatus = message.operationalStatus;
                                if (options.oneofs)
                                    object._operationalStatus = "operationalStatus";
                            }
                            if (message.interconnect != null && message.hasOwnProperty("interconnect")) {
                                object.interconnect = message.interconnect;
                                if (options.oneofs)
                                    object._interconnect = "interconnect";
                            }
                            if (message.privateInterconnectInfo != null && message.hasOwnProperty("privateInterconnectInfo")) {
                                object.privateInterconnectInfo = $root.google.cloud.compute.v1.InterconnectAttachmentPrivateInfo.toObject(message.privateInterconnectInfo, options);
                                if (options.oneofs)
                                    object._privateInterconnectInfo = "privateInterconnectInfo";
                            }
                            if (message.candidateSubnets && message.candidateSubnets.length) {
                                object.candidateSubnets = [];
                                for (var j = 0; j < message.candidateSubnets.length; ++j)
                                    object.candidateSubnets[j] = message.candidateSubnets[j];
                            }
                            if (message.cloudRouterIpAddress != null && message.hasOwnProperty("cloudRouterIpAddress")) {
                                object.cloudRouterIpAddress = message.cloudRouterIpAddress;
                                if (options.oneofs)
                                    object._cloudRouterIpAddress = "cloudRouterIpAddress";
                            }
                            if (message.customerRouterIpv6Address != null && message.hasOwnProperty("customerRouterIpv6Address")) {
                                object.customerRouterIpv6Address = message.customerRouterIpv6Address;
                                if (options.oneofs)
                                    object._customerRouterIpv6Address = "customerRouterIpv6Address";
                            }
                            if (message.customerRouterIpAddress != null && message.hasOwnProperty("customerRouterIpAddress")) {
                                object.customerRouterIpAddress = message.customerRouterIpAddress;
                                if (options.oneofs)
                                    object._customerRouterIpAddress = "customerRouterIpAddress";
                            }
                            if (message.customerRouterIpv6InterfaceId != null && message.hasOwnProperty("customerRouterIpv6InterfaceId")) {
                                object.customerRouterIpv6InterfaceId = message.customerRouterIpv6InterfaceId;
                                if (options.oneofs)
                                    object._customerRouterIpv6InterfaceId = "customerRouterIpv6InterfaceId";
                            }
                            if (message.ipsecInternalAddresses && message.ipsecInternalAddresses.length) {
                                object.ipsecInternalAddresses = [];
                                for (var j = 0; j < message.ipsecInternalAddresses.length; ++j)
                                    object.ipsecInternalAddresses[j] = message.ipsecInternalAddresses[j];
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.stackType != null && message.hasOwnProperty("stackType")) {
                                object.stackType = message.stackType;
                                if (options.oneofs)
                                    object._stackType = "stackType";
                            }
                            if (message.partnerAsn != null && message.hasOwnProperty("partnerAsn")) {
                                if (typeof message.partnerAsn === "number")
                                    object.partnerAsn = options.longs === String ? String(message.partnerAsn) : message.partnerAsn;
                                else
                                    object.partnerAsn = options.longs === String ? $util.Long.prototype.toString.call(message.partnerAsn) : options.longs === Number ? new $util.LongBits(message.partnerAsn.low >>> 0, message.partnerAsn.high >>> 0).toNumber() : message.partnerAsn;
                                if (options.oneofs)
                                    object._partnerAsn = "partnerAsn";
                            }
                            if (message.pairingKey != null && message.hasOwnProperty("pairingKey")) {
                                object.pairingKey = message.pairingKey;
                                if (options.oneofs)
                                    object._pairingKey = "pairingKey";
                            }
                            if (message.adminEnabled != null && message.hasOwnProperty("adminEnabled")) {
                                object.adminEnabled = message.adminEnabled;
                                if (options.oneofs)
                                    object._adminEnabled = "adminEnabled";
                            }
                            if (message.cloudRouterIpv6Address != null && message.hasOwnProperty("cloudRouterIpv6Address")) {
                                object.cloudRouterIpv6Address = message.cloudRouterIpv6Address;
                                if (options.oneofs)
                                    object._cloudRouterIpv6Address = "cloudRouterIpv6Address";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.satisfiesPzs != null && message.hasOwnProperty("satisfiesPzs")) {
                                object.satisfiesPzs = message.satisfiesPzs;
                                if (options.oneofs)
                                    object._satisfiesPzs = "satisfiesPzs";
                            }
                            if (message.cloudRouterIpv6InterfaceId != null && message.hasOwnProperty("cloudRouterIpv6InterfaceId")) {
                                object.cloudRouterIpv6InterfaceId = message.cloudRouterIpv6InterfaceId;
                                if (options.oneofs)
                                    object._cloudRouterIpv6InterfaceId = "cloudRouterIpv6InterfaceId";
                            }
                            if (message.googleReferenceId != null && message.hasOwnProperty("googleReferenceId")) {
                                object.googleReferenceId = message.googleReferenceId;
                                if (options.oneofs)
                                    object._googleReferenceId = "googleReferenceId";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InterconnectAttachment to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InterconnectAttachment.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InterconnectAttachment
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InterconnectAttachment
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InterconnectAttachment.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InterconnectAttachment";
                        };
    
                        /**
                         * Bandwidth enum.
                         * @name google.cloud.compute.v1.InterconnectAttachment.Bandwidth
                         * @enum {number}
                         * @property {number} UNDEFINED_BANDWIDTH=0 UNDEFINED_BANDWIDTH value
                         * @property {number} BPS_100M=49547958 BPS_100M value
                         * @property {number} BPS_10G=278693006 BPS_10G value
                         * @property {number} BPS_1G=355358448 BPS_1G value
                         * @property {number} BPS_200M=49577749 BPS_200M value
                         * @property {number} BPS_20G=278693967 BPS_20G value
                         * @property {number} BPS_2G=355358479 BPS_2G value
                         * @property {number} BPS_300M=49607540 BPS_300M value
                         * @property {number} BPS_400M=49637331 BPS_400M value
                         * @property {number} BPS_500M=49667122 BPS_500M value
                         * @property {number} BPS_50G=278696850 BPS_50G value
                         * @property {number} BPS_50M=278696856 BPS_50M value
                         * @property {number} BPS_5G=355358572 BPS_5G value
                         */
                        InterconnectAttachment.Bandwidth = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_BANDWIDTH"] = 0;
                            values[valuesById[49547958] = "BPS_100M"] = 49547958;
                            values[valuesById[278693006] = "BPS_10G"] = 278693006;
                            values[valuesById[355358448] = "BPS_1G"] = 355358448;
                            values[valuesById[49577749] = "BPS_200M"] = 49577749;
                            values[valuesById[278693967] = "BPS_20G"] = 278693967;
                            values[valuesById[355358479] = "BPS_2G"] = 355358479;
                            values[valuesById[49607540] = "BPS_300M"] = 49607540;
                            values[valuesById[49637331] = "BPS_400M"] = 49637331;
                            values[valuesById[49667122] = "BPS_500M"] = 49667122;
                            values[valuesById[278696850] = "BPS_50G"] = 278696850;
                            values[valuesById[278696856] = "BPS_50M"] = 278696856;
                            values[valuesById[355358572] = "BPS_5G"] = 355358572;
                            return values;
                        })();
    
                        /**
                         * EdgeAvailabilityDomain enum.
                         * @name google.cloud.compute.v1.InterconnectAttachment.EdgeAvailabilityDomain
                         * @enum {number}
                         * @property {number} UNDEFINED_EDGE_AVAILABILITY_DOMAIN=0 UNDEFINED_EDGE_AVAILABILITY_DOMAIN value
                         * @property {number} AVAILABILITY_DOMAIN_1=349552090 AVAILABILITY_DOMAIN_1 value
                         * @property {number} AVAILABILITY_DOMAIN_2=349552091 AVAILABILITY_DOMAIN_2 value
                         * @property {number} AVAILABILITY_DOMAIN_ANY=375256373 AVAILABILITY_DOMAIN_ANY value
                         */
                        InterconnectAttachment.EdgeAvailabilityDomain = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_EDGE_AVAILABILITY_DOMAIN"] = 0;
                            values[valuesById[349552090] = "AVAILABILITY_DOMAIN_1"] = 349552090;
                            values[valuesById[349552091] = "AVAILABILITY_DOMAIN_2"] = 349552091;
                            values[valuesById[375256373] = "AVAILABILITY_DOMAIN_ANY"] = 375256373;
                            return values;
                        })();
    
                        /**
                         * Encryption enum.
                         * @name google.cloud.compute.v1.InterconnectAttachment.Encryption
                         * @enum {number}
                         * @property {number} UNDEFINED_ENCRYPTION=0 UNDEFINED_ENCRYPTION value
                         * @property {number} IPSEC=69882282 IPSEC value
                         * @property {number} NONE=2402104 NONE value
                         */
                        InterconnectAttachment.Encryption = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ENCRYPTION"] = 0;
                            values[valuesById[69882282] = "IPSEC"] = 69882282;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            return values;
                        })();
    
                        /**
                         * OperationalStatus enum.
                         * @name google.cloud.compute.v1.InterconnectAttachment.OperationalStatus
                         * @enum {number}
                         * @property {number} UNDEFINED_OPERATIONAL_STATUS=0 UNDEFINED_OPERATIONAL_STATUS value
                         * @property {number} OS_ACTIVE=55721409 OS_ACTIVE value
                         * @property {number} OS_UNPROVISIONED=239771840 OS_UNPROVISIONED value
                         */
                        InterconnectAttachment.OperationalStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_OPERATIONAL_STATUS"] = 0;
                            values[valuesById[55721409] = "OS_ACTIVE"] = 55721409;
                            values[valuesById[239771840] = "OS_UNPROVISIONED"] = 239771840;
                            return values;
                        })();
    
                        /**
                         * StackType enum.
                         * @name google.cloud.compute.v1.InterconnectAttachment.StackType
                         * @enum {number}
                         * @property {number} UNDEFINED_STACK_TYPE=0 UNDEFINED_STACK_TYPE value
                         * @property {number} IPV4_IPV6=22197249 IPV4_IPV6 value
                         * @property {number} IPV4_ONLY=22373798 IPV4_ONLY value
                         */
                        InterconnectAttachment.StackType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STACK_TYPE"] = 0;
                            values[valuesById[22197249] = "IPV4_IPV6"] = 22197249;
                            values[valuesById[22373798] = "IPV4_ONLY"] = 22373798;
                            return values;
                        })();
    
                        /**
                         * State enum.
                         * @name google.cloud.compute.v1.InterconnectAttachment.State
                         * @enum {number}
                         * @property {number} UNDEFINED_STATE=0 UNDEFINED_STATE value
                         * @property {number} ACTIVE=314733318 ACTIVE value
                         * @property {number} DEFUNCT=115891759 DEFUNCT value
                         * @property {number} PARTNER_REQUEST_RECEIVED=513587304 PARTNER_REQUEST_RECEIVED value
                         * @property {number} PENDING_CUSTOMER=167494054 PENDING_CUSTOMER value
                         * @property {number} PENDING_PARTNER=387890656 PENDING_PARTNER value
                         * @property {number} STATE_UNSPECIFIED=470755401 STATE_UNSPECIFIED value
                         * @property {number} UNPROVISIONED=517333979 UNPROVISIONED value
                         */
                        InterconnectAttachment.State = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATE"] = 0;
                            values[valuesById[314733318] = "ACTIVE"] = 314733318;
                            values[valuesById[115891759] = "DEFUNCT"] = 115891759;
                            values[valuesById[513587304] = "PARTNER_REQUEST_RECEIVED"] = 513587304;
                            values[valuesById[167494054] = "PENDING_CUSTOMER"] = 167494054;
                            values[valuesById[387890656] = "PENDING_PARTNER"] = 387890656;
                            values[valuesById[470755401] = "STATE_UNSPECIFIED"] = 470755401;
                            values[valuesById[517333979] = "UNPROVISIONED"] = 517333979;
                            return values;
                        })();
    
                        /**
                         * Type enum.
                         * @name google.cloud.compute.v1.InterconnectAttachment.Type
                         * @enum {number}
                         * @property {number} UNDEFINED_TYPE=0 UNDEFINED_TYPE value
                         * @property {number} DEDICATED=258411983 DEDICATED value
                         * @property {number} PARTNER=461924520 PARTNER value
                         * @property {number} PARTNER_PROVIDER=483261352 PARTNER_PROVIDER value
                         */
                        InterconnectAttachment.Type = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TYPE"] = 0;
                            values[valuesById[258411983] = "DEDICATED"] = 258411983;
                            values[valuesById[461924520] = "PARTNER"] = 461924520;
                            values[valuesById[483261352] = "PARTNER_PROVIDER"] = 483261352;
                            return values;
                        })();
    
                        return InterconnectAttachment;
                    })();
    
                    v1.InterconnectAttachmentAggregatedList = (function() {
    
                        /**
                         * Properties of an InterconnectAttachmentAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IInterconnectAttachmentAggregatedList
                         * @property {string|null} [id] InterconnectAttachmentAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IInterconnectAttachmentsScopedList>|null} [items] InterconnectAttachmentAggregatedList items
                         * @property {string|null} [kind] InterconnectAttachmentAggregatedList kind
                         * @property {string|null} [nextPageToken] InterconnectAttachmentAggregatedList nextPageToken
                         * @property {string|null} [selfLink] InterconnectAttachmentAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] InterconnectAttachmentAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] InterconnectAttachmentAggregatedList warning
                         */
    
                        /**
                         * Constructs a new InterconnectAttachmentAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InterconnectAttachmentAggregatedList.
                         * @implements IInterconnectAttachmentAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IInterconnectAttachmentAggregatedList=} [properties] Properties to set
                         */
                        function InterconnectAttachmentAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InterconnectAttachmentAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @instance
                         */
                        InterconnectAttachmentAggregatedList.prototype.id = null;
    
                        /**
                         * InterconnectAttachmentAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IInterconnectAttachmentsScopedList>} items
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @instance
                         */
                        InterconnectAttachmentAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * InterconnectAttachmentAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @instance
                         */
                        InterconnectAttachmentAggregatedList.prototype.kind = null;
    
                        /**
                         * InterconnectAttachmentAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @instance
                         */
                        InterconnectAttachmentAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * InterconnectAttachmentAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @instance
                         */
                        InterconnectAttachmentAggregatedList.prototype.selfLink = null;
    
                        /**
                         * InterconnectAttachmentAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @instance
                         */
                        InterconnectAttachmentAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * InterconnectAttachmentAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @instance
                         */
                        InterconnectAttachmentAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InterconnectAttachmentAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachmentAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachmentAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachmentAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachmentAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachmentAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachmentAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachmentAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachmentAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachmentAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InterconnectAttachmentAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectAttachmentAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InterconnectAttachmentAggregatedList} InterconnectAttachmentAggregatedList instance
                         */
                        InterconnectAttachmentAggregatedList.create = function create(properties) {
                            return new InterconnectAttachmentAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified InterconnectAttachmentAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.InterconnectAttachmentAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectAttachmentAggregatedList} message InterconnectAttachmentAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectAttachmentAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.InterconnectAttachmentsScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InterconnectAttachmentAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InterconnectAttachmentAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectAttachmentAggregatedList} message InterconnectAttachmentAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectAttachmentAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InterconnectAttachmentAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InterconnectAttachmentAggregatedList} InterconnectAttachmentAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectAttachmentAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InterconnectAttachmentAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.InterconnectAttachmentsScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InterconnectAttachmentAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InterconnectAttachmentAggregatedList} InterconnectAttachmentAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectAttachmentAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InterconnectAttachmentAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InterconnectAttachmentAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InterconnectAttachmentsScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InterconnectAttachmentAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InterconnectAttachmentAggregatedList} InterconnectAttachmentAggregatedList
                         */
                        InterconnectAttachmentAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InterconnectAttachmentAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InterconnectAttachmentAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InterconnectAttachmentAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InterconnectAttachmentAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.InterconnectAttachmentsScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.InterconnectAttachmentAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InterconnectAttachmentAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InterconnectAttachmentAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.InterconnectAttachmentAggregatedList} message InterconnectAttachmentAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InterconnectAttachmentAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.InterconnectAttachmentsScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InterconnectAttachmentAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InterconnectAttachmentAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InterconnectAttachmentAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InterconnectAttachmentAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InterconnectAttachmentAggregatedList";
                        };
    
                        return InterconnectAttachmentAggregatedList;
                    })();
    
                    v1.InterconnectAttachmentList = (function() {
    
                        /**
                         * Properties of an InterconnectAttachmentList.
                         * @memberof google.cloud.compute.v1
                         * @interface IInterconnectAttachmentList
                         * @property {string|null} [id] InterconnectAttachmentList id
                         * @property {Array.<google.cloud.compute.v1.IInterconnectAttachment>|null} [items] InterconnectAttachmentList items
                         * @property {string|null} [kind] InterconnectAttachmentList kind
                         * @property {string|null} [nextPageToken] InterconnectAttachmentList nextPageToken
                         * @property {string|null} [selfLink] InterconnectAttachmentList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] InterconnectAttachmentList warning
                         */
    
                        /**
                         * Constructs a new InterconnectAttachmentList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InterconnectAttachmentList.
                         * @implements IInterconnectAttachmentList
                         * @constructor
                         * @param {google.cloud.compute.v1.IInterconnectAttachmentList=} [properties] Properties to set
                         */
                        function InterconnectAttachmentList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InterconnectAttachmentList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @instance
                         */
                        InterconnectAttachmentList.prototype.id = null;
    
                        /**
                         * InterconnectAttachmentList items.
                         * @member {Array.<google.cloud.compute.v1.IInterconnectAttachment>} items
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @instance
                         */
                        InterconnectAttachmentList.prototype.items = $util.emptyArray;
    
                        /**
                         * InterconnectAttachmentList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @instance
                         */
                        InterconnectAttachmentList.prototype.kind = null;
    
                        /**
                         * InterconnectAttachmentList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @instance
                         */
                        InterconnectAttachmentList.prototype.nextPageToken = null;
    
                        /**
                         * InterconnectAttachmentList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @instance
                         */
                        InterconnectAttachmentList.prototype.selfLink = null;
    
                        /**
                         * InterconnectAttachmentList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @instance
                         */
                        InterconnectAttachmentList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InterconnectAttachmentList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachmentList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachmentList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachmentList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachmentList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachmentList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachmentList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachmentList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachmentList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachmentList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InterconnectAttachmentList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectAttachmentList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InterconnectAttachmentList} InterconnectAttachmentList instance
                         */
                        InterconnectAttachmentList.create = function create(properties) {
                            return new InterconnectAttachmentList(properties);
                        };
    
                        /**
                         * Encodes the specified InterconnectAttachmentList message. Does not implicitly {@link google.cloud.compute.v1.InterconnectAttachmentList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectAttachmentList} message InterconnectAttachmentList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectAttachmentList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.InterconnectAttachment.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InterconnectAttachmentList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InterconnectAttachmentList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectAttachmentList} message InterconnectAttachmentList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectAttachmentList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InterconnectAttachmentList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InterconnectAttachmentList} InterconnectAttachmentList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectAttachmentList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InterconnectAttachmentList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.InterconnectAttachment.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InterconnectAttachmentList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InterconnectAttachmentList} InterconnectAttachmentList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectAttachmentList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InterconnectAttachmentList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InterconnectAttachmentList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InterconnectAttachment.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InterconnectAttachmentList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InterconnectAttachmentList} InterconnectAttachmentList
                         */
                        InterconnectAttachmentList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InterconnectAttachmentList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InterconnectAttachmentList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.InterconnectAttachmentList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InterconnectAttachmentList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.InterconnectAttachment.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InterconnectAttachmentList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InterconnectAttachmentList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @static
                         * @param {google.cloud.compute.v1.InterconnectAttachmentList} message InterconnectAttachmentList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InterconnectAttachmentList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.InterconnectAttachment.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InterconnectAttachmentList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InterconnectAttachmentList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InterconnectAttachmentList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InterconnectAttachmentList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InterconnectAttachmentList";
                        };
    
                        return InterconnectAttachmentList;
                    })();
    
                    v1.InterconnectAttachmentPartnerMetadata = (function() {
    
                        /**
                         * Properties of an InterconnectAttachmentPartnerMetadata.
                         * @memberof google.cloud.compute.v1
                         * @interface IInterconnectAttachmentPartnerMetadata
                         * @property {string|null} [interconnectName] InterconnectAttachmentPartnerMetadata interconnectName
                         * @property {string|null} [partnerName] InterconnectAttachmentPartnerMetadata partnerName
                         * @property {string|null} [portalUrl] InterconnectAttachmentPartnerMetadata portalUrl
                         */
    
                        /**
                         * Constructs a new InterconnectAttachmentPartnerMetadata.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InterconnectAttachmentPartnerMetadata.
                         * @implements IInterconnectAttachmentPartnerMetadata
                         * @constructor
                         * @param {google.cloud.compute.v1.IInterconnectAttachmentPartnerMetadata=} [properties] Properties to set
                         */
                        function InterconnectAttachmentPartnerMetadata(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InterconnectAttachmentPartnerMetadata interconnectName.
                         * @member {string|null|undefined} interconnectName
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata
                         * @instance
                         */
                        InterconnectAttachmentPartnerMetadata.prototype.interconnectName = null;
    
                        /**
                         * InterconnectAttachmentPartnerMetadata partnerName.
                         * @member {string|null|undefined} partnerName
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata
                         * @instance
                         */
                        InterconnectAttachmentPartnerMetadata.prototype.partnerName = null;
    
                        /**
                         * InterconnectAttachmentPartnerMetadata portalUrl.
                         * @member {string|null|undefined} portalUrl
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata
                         * @instance
                         */
                        InterconnectAttachmentPartnerMetadata.prototype.portalUrl = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InterconnectAttachmentPartnerMetadata _interconnectName.
                         * @member {"interconnectName"|undefined} _interconnectName
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachmentPartnerMetadata.prototype, "_interconnectName", {
                            get: $util.oneOfGetter($oneOfFields = ["interconnectName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachmentPartnerMetadata _partnerName.
                         * @member {"partnerName"|undefined} _partnerName
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachmentPartnerMetadata.prototype, "_partnerName", {
                            get: $util.oneOfGetter($oneOfFields = ["partnerName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectAttachmentPartnerMetadata _portalUrl.
                         * @member {"portalUrl"|undefined} _portalUrl
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachmentPartnerMetadata.prototype, "_portalUrl", {
                            get: $util.oneOfGetter($oneOfFields = ["portalUrl"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InterconnectAttachmentPartnerMetadata instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectAttachmentPartnerMetadata=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata} InterconnectAttachmentPartnerMetadata instance
                         */
                        InterconnectAttachmentPartnerMetadata.create = function create(properties) {
                            return new InterconnectAttachmentPartnerMetadata(properties);
                        };
    
                        /**
                         * Encodes the specified InterconnectAttachmentPartnerMetadata message. Does not implicitly {@link google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectAttachmentPartnerMetadata} message InterconnectAttachmentPartnerMetadata message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectAttachmentPartnerMetadata.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.partnerName != null && Object.hasOwnProperty.call(message, "partnerName"))
                                writer.uint32(/* id 161747874, wireType 2 =*/1293982994).string(message.partnerName);
                            if (message.portalUrl != null && Object.hasOwnProperty.call(message, "portalUrl"))
                                writer.uint32(/* id 269182748, wireType 2 =*/2153461986).string(message.portalUrl);
                            if (message.interconnectName != null && Object.hasOwnProperty.call(message, "interconnectName"))
                                writer.uint32(/* id 514963356, wireType 2 =*/4119706850).string(message.interconnectName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InterconnectAttachmentPartnerMetadata message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectAttachmentPartnerMetadata} message InterconnectAttachmentPartnerMetadata message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectAttachmentPartnerMetadata.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InterconnectAttachmentPartnerMetadata message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata} InterconnectAttachmentPartnerMetadata
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectAttachmentPartnerMetadata.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 514963356: {
                                        message.interconnectName = reader.string();
                                        break;
                                    }
                                case 161747874: {
                                        message.partnerName = reader.string();
                                        break;
                                    }
                                case 269182748: {
                                        message.portalUrl = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InterconnectAttachmentPartnerMetadata message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata} InterconnectAttachmentPartnerMetadata
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectAttachmentPartnerMetadata.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InterconnectAttachmentPartnerMetadata message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InterconnectAttachmentPartnerMetadata.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.interconnectName != null && message.hasOwnProperty("interconnectName")) {
                                properties._interconnectName = 1;
                                if (!$util.isString(message.interconnectName))
                                    return "interconnectName: string expected";
                            }
                            if (message.partnerName != null && message.hasOwnProperty("partnerName")) {
                                properties._partnerName = 1;
                                if (!$util.isString(message.partnerName))
                                    return "partnerName: string expected";
                            }
                            if (message.portalUrl != null && message.hasOwnProperty("portalUrl")) {
                                properties._portalUrl = 1;
                                if (!$util.isString(message.portalUrl))
                                    return "portalUrl: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InterconnectAttachmentPartnerMetadata message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata} InterconnectAttachmentPartnerMetadata
                         */
                        InterconnectAttachmentPartnerMetadata.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata();
                            if (object.interconnectName != null)
                                message.interconnectName = String(object.interconnectName);
                            if (object.partnerName != null)
                                message.partnerName = String(object.partnerName);
                            if (object.portalUrl != null)
                                message.portalUrl = String(object.portalUrl);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InterconnectAttachmentPartnerMetadata message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata
                         * @static
                         * @param {google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata} message InterconnectAttachmentPartnerMetadata
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InterconnectAttachmentPartnerMetadata.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.partnerName != null && message.hasOwnProperty("partnerName")) {
                                object.partnerName = message.partnerName;
                                if (options.oneofs)
                                    object._partnerName = "partnerName";
                            }
                            if (message.portalUrl != null && message.hasOwnProperty("portalUrl")) {
                                object.portalUrl = message.portalUrl;
                                if (options.oneofs)
                                    object._portalUrl = "portalUrl";
                            }
                            if (message.interconnectName != null && message.hasOwnProperty("interconnectName")) {
                                object.interconnectName = message.interconnectName;
                                if (options.oneofs)
                                    object._interconnectName = "interconnectName";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InterconnectAttachmentPartnerMetadata to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InterconnectAttachmentPartnerMetadata.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InterconnectAttachmentPartnerMetadata
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InterconnectAttachmentPartnerMetadata.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InterconnectAttachmentPartnerMetadata";
                        };
    
                        return InterconnectAttachmentPartnerMetadata;
                    })();
    
                    v1.InterconnectAttachmentPrivateInfo = (function() {
    
                        /**
                         * Properties of an InterconnectAttachmentPrivateInfo.
                         * @memberof google.cloud.compute.v1
                         * @interface IInterconnectAttachmentPrivateInfo
                         * @property {number|null} [tag8021q] InterconnectAttachmentPrivateInfo tag8021q
                         */
    
                        /**
                         * Constructs a new InterconnectAttachmentPrivateInfo.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InterconnectAttachmentPrivateInfo.
                         * @implements IInterconnectAttachmentPrivateInfo
                         * @constructor
                         * @param {google.cloud.compute.v1.IInterconnectAttachmentPrivateInfo=} [properties] Properties to set
                         */
                        function InterconnectAttachmentPrivateInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InterconnectAttachmentPrivateInfo tag8021q.
                         * @member {number|null|undefined} tag8021q
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPrivateInfo
                         * @instance
                         */
                        InterconnectAttachmentPrivateInfo.prototype.tag8021q = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InterconnectAttachmentPrivateInfo _tag8021q.
                         * @member {"tag8021q"|undefined} _tag8021q
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPrivateInfo
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachmentPrivateInfo.prototype, "_tag8021q", {
                            get: $util.oneOfGetter($oneOfFields = ["tag8021q"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InterconnectAttachmentPrivateInfo instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPrivateInfo
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectAttachmentPrivateInfo=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InterconnectAttachmentPrivateInfo} InterconnectAttachmentPrivateInfo instance
                         */
                        InterconnectAttachmentPrivateInfo.create = function create(properties) {
                            return new InterconnectAttachmentPrivateInfo(properties);
                        };
    
                        /**
                         * Encodes the specified InterconnectAttachmentPrivateInfo message. Does not implicitly {@link google.cloud.compute.v1.InterconnectAttachmentPrivateInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPrivateInfo
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectAttachmentPrivateInfo} message InterconnectAttachmentPrivateInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectAttachmentPrivateInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.tag8021q != null && Object.hasOwnProperty.call(message, "tag8021q"))
                                writer.uint32(/* id 271820992, wireType 0 =*/2174567936).uint32(message.tag8021q);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InterconnectAttachmentPrivateInfo message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InterconnectAttachmentPrivateInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPrivateInfo
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectAttachmentPrivateInfo} message InterconnectAttachmentPrivateInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectAttachmentPrivateInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InterconnectAttachmentPrivateInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPrivateInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InterconnectAttachmentPrivateInfo} InterconnectAttachmentPrivateInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectAttachmentPrivateInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InterconnectAttachmentPrivateInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 271820992: {
                                        message.tag8021q = reader.uint32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InterconnectAttachmentPrivateInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPrivateInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InterconnectAttachmentPrivateInfo} InterconnectAttachmentPrivateInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectAttachmentPrivateInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InterconnectAttachmentPrivateInfo message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPrivateInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InterconnectAttachmentPrivateInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.tag8021q != null && message.hasOwnProperty("tag8021q")) {
                                properties._tag8021q = 1;
                                if (!$util.isInteger(message.tag8021q))
                                    return "tag8021q: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InterconnectAttachmentPrivateInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPrivateInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InterconnectAttachmentPrivateInfo} InterconnectAttachmentPrivateInfo
                         */
                        InterconnectAttachmentPrivateInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InterconnectAttachmentPrivateInfo)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InterconnectAttachmentPrivateInfo();
                            if (object.tag8021q != null)
                                message.tag8021q = object.tag8021q >>> 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InterconnectAttachmentPrivateInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPrivateInfo
                         * @static
                         * @param {google.cloud.compute.v1.InterconnectAttachmentPrivateInfo} message InterconnectAttachmentPrivateInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InterconnectAttachmentPrivateInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.tag8021q != null && message.hasOwnProperty("tag8021q")) {
                                object.tag8021q = message.tag8021q;
                                if (options.oneofs)
                                    object._tag8021q = "tag8021q";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InterconnectAttachmentPrivateInfo to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPrivateInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InterconnectAttachmentPrivateInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InterconnectAttachmentPrivateInfo
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentPrivateInfo
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InterconnectAttachmentPrivateInfo.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InterconnectAttachmentPrivateInfo";
                        };
    
                        return InterconnectAttachmentPrivateInfo;
                    })();
    
                    v1.InterconnectAttachmentsScopedList = (function() {
    
                        /**
                         * Properties of an InterconnectAttachmentsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IInterconnectAttachmentsScopedList
                         * @property {Array.<google.cloud.compute.v1.IInterconnectAttachment>|null} [interconnectAttachments] InterconnectAttachmentsScopedList interconnectAttachments
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] InterconnectAttachmentsScopedList warning
                         */
    
                        /**
                         * Constructs a new InterconnectAttachmentsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InterconnectAttachmentsScopedList.
                         * @implements IInterconnectAttachmentsScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IInterconnectAttachmentsScopedList=} [properties] Properties to set
                         */
                        function InterconnectAttachmentsScopedList(properties) {
                            this.interconnectAttachments = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InterconnectAttachmentsScopedList interconnectAttachments.
                         * @member {Array.<google.cloud.compute.v1.IInterconnectAttachment>} interconnectAttachments
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentsScopedList
                         * @instance
                         */
                        InterconnectAttachmentsScopedList.prototype.interconnectAttachments = $util.emptyArray;
    
                        /**
                         * InterconnectAttachmentsScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentsScopedList
                         * @instance
                         */
                        InterconnectAttachmentsScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InterconnectAttachmentsScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentsScopedList
                         * @instance
                         */
                        Object.defineProperty(InterconnectAttachmentsScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InterconnectAttachmentsScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectAttachmentsScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InterconnectAttachmentsScopedList} InterconnectAttachmentsScopedList instance
                         */
                        InterconnectAttachmentsScopedList.create = function create(properties) {
                            return new InterconnectAttachmentsScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified InterconnectAttachmentsScopedList message. Does not implicitly {@link google.cloud.compute.v1.InterconnectAttachmentsScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectAttachmentsScopedList} message InterconnectAttachmentsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectAttachmentsScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.interconnectAttachments != null && message.interconnectAttachments.length)
                                for (var i = 0; i < message.interconnectAttachments.length; ++i)
                                    $root.google.cloud.compute.v1.InterconnectAttachment.encode(message.interconnectAttachments[i], writer.uint32(/* id 425388415, wireType 2 =*/3403107322).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InterconnectAttachmentsScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InterconnectAttachmentsScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectAttachmentsScopedList} message InterconnectAttachmentsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectAttachmentsScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InterconnectAttachmentsScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InterconnectAttachmentsScopedList} InterconnectAttachmentsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectAttachmentsScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InterconnectAttachmentsScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 425388415: {
                                        if (!(message.interconnectAttachments && message.interconnectAttachments.length))
                                            message.interconnectAttachments = [];
                                        message.interconnectAttachments.push($root.google.cloud.compute.v1.InterconnectAttachment.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InterconnectAttachmentsScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InterconnectAttachmentsScopedList} InterconnectAttachmentsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectAttachmentsScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InterconnectAttachmentsScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentsScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InterconnectAttachmentsScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.interconnectAttachments != null && message.hasOwnProperty("interconnectAttachments")) {
                                if (!Array.isArray(message.interconnectAttachments))
                                    return "interconnectAttachments: array expected";
                                for (var i = 0; i < message.interconnectAttachments.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InterconnectAttachment.verify(message.interconnectAttachments[i]);
                                    if (error)
                                        return "interconnectAttachments." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InterconnectAttachmentsScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentsScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InterconnectAttachmentsScopedList} InterconnectAttachmentsScopedList
                         */
                        InterconnectAttachmentsScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InterconnectAttachmentsScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InterconnectAttachmentsScopedList();
                            if (object.interconnectAttachments) {
                                if (!Array.isArray(object.interconnectAttachments))
                                    throw TypeError(".google.cloud.compute.v1.InterconnectAttachmentsScopedList.interconnectAttachments: array expected");
                                message.interconnectAttachments = [];
                                for (var i = 0; i < object.interconnectAttachments.length; ++i) {
                                    if (typeof object.interconnectAttachments[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InterconnectAttachmentsScopedList.interconnectAttachments: object expected");
                                    message.interconnectAttachments[i] = $root.google.cloud.compute.v1.InterconnectAttachment.fromObject(object.interconnectAttachments[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InterconnectAttachmentsScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InterconnectAttachmentsScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.InterconnectAttachmentsScopedList} message InterconnectAttachmentsScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InterconnectAttachmentsScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.interconnectAttachments = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.interconnectAttachments && message.interconnectAttachments.length) {
                                object.interconnectAttachments = [];
                                for (var j = 0; j < message.interconnectAttachments.length; ++j)
                                    object.interconnectAttachments[j] = $root.google.cloud.compute.v1.InterconnectAttachment.toObject(message.interconnectAttachments[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InterconnectAttachmentsScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentsScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InterconnectAttachmentsScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InterconnectAttachmentsScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InterconnectAttachmentsScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InterconnectAttachmentsScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InterconnectAttachmentsScopedList";
                        };
    
                        return InterconnectAttachmentsScopedList;
                    })();
    
                    v1.InterconnectCircuitInfo = (function() {
    
                        /**
                         * Properties of an InterconnectCircuitInfo.
                         * @memberof google.cloud.compute.v1
                         * @interface IInterconnectCircuitInfo
                         * @property {string|null} [customerDemarcId] InterconnectCircuitInfo customerDemarcId
                         * @property {string|null} [googleCircuitId] InterconnectCircuitInfo googleCircuitId
                         * @property {string|null} [googleDemarcId] InterconnectCircuitInfo googleDemarcId
                         */
    
                        /**
                         * Constructs a new InterconnectCircuitInfo.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InterconnectCircuitInfo.
                         * @implements IInterconnectCircuitInfo
                         * @constructor
                         * @param {google.cloud.compute.v1.IInterconnectCircuitInfo=} [properties] Properties to set
                         */
                        function InterconnectCircuitInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InterconnectCircuitInfo customerDemarcId.
                         * @member {string|null|undefined} customerDemarcId
                         * @memberof google.cloud.compute.v1.InterconnectCircuitInfo
                         * @instance
                         */
                        InterconnectCircuitInfo.prototype.customerDemarcId = null;
    
                        /**
                         * InterconnectCircuitInfo googleCircuitId.
                         * @member {string|null|undefined} googleCircuitId
                         * @memberof google.cloud.compute.v1.InterconnectCircuitInfo
                         * @instance
                         */
                        InterconnectCircuitInfo.prototype.googleCircuitId = null;
    
                        /**
                         * InterconnectCircuitInfo googleDemarcId.
                         * @member {string|null|undefined} googleDemarcId
                         * @memberof google.cloud.compute.v1.InterconnectCircuitInfo
                         * @instance
                         */
                        InterconnectCircuitInfo.prototype.googleDemarcId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InterconnectCircuitInfo _customerDemarcId.
                         * @member {"customerDemarcId"|undefined} _customerDemarcId
                         * @memberof google.cloud.compute.v1.InterconnectCircuitInfo
                         * @instance
                         */
                        Object.defineProperty(InterconnectCircuitInfo.prototype, "_customerDemarcId", {
                            get: $util.oneOfGetter($oneOfFields = ["customerDemarcId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectCircuitInfo _googleCircuitId.
                         * @member {"googleCircuitId"|undefined} _googleCircuitId
                         * @memberof google.cloud.compute.v1.InterconnectCircuitInfo
                         * @instance
                         */
                        Object.defineProperty(InterconnectCircuitInfo.prototype, "_googleCircuitId", {
                            get: $util.oneOfGetter($oneOfFields = ["googleCircuitId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectCircuitInfo _googleDemarcId.
                         * @member {"googleDemarcId"|undefined} _googleDemarcId
                         * @memberof google.cloud.compute.v1.InterconnectCircuitInfo
                         * @instance
                         */
                        Object.defineProperty(InterconnectCircuitInfo.prototype, "_googleDemarcId", {
                            get: $util.oneOfGetter($oneOfFields = ["googleDemarcId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InterconnectCircuitInfo instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InterconnectCircuitInfo
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectCircuitInfo=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InterconnectCircuitInfo} InterconnectCircuitInfo instance
                         */
                        InterconnectCircuitInfo.create = function create(properties) {
                            return new InterconnectCircuitInfo(properties);
                        };
    
                        /**
                         * Encodes the specified InterconnectCircuitInfo message. Does not implicitly {@link google.cloud.compute.v1.InterconnectCircuitInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InterconnectCircuitInfo
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectCircuitInfo} message InterconnectCircuitInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectCircuitInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.customerDemarcId != null && Object.hasOwnProperty.call(message, "customerDemarcId"))
                                writer.uint32(/* id 28771859, wireType 2 =*/230174874).string(message.customerDemarcId);
                            if (message.googleCircuitId != null && Object.hasOwnProperty.call(message, "googleCircuitId"))
                                writer.uint32(/* id 262014711, wireType 2 =*/2096117690).string(message.googleCircuitId);
                            if (message.googleDemarcId != null && Object.hasOwnProperty.call(message, "googleDemarcId"))
                                writer.uint32(/* id 448196270, wireType 2 =*/3585570162).string(message.googleDemarcId);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InterconnectCircuitInfo message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InterconnectCircuitInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectCircuitInfo
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectCircuitInfo} message InterconnectCircuitInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectCircuitInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InterconnectCircuitInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InterconnectCircuitInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InterconnectCircuitInfo} InterconnectCircuitInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectCircuitInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InterconnectCircuitInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 28771859: {
                                        message.customerDemarcId = reader.string();
                                        break;
                                    }
                                case 262014711: {
                                        message.googleCircuitId = reader.string();
                                        break;
                                    }
                                case 448196270: {
                                        message.googleDemarcId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InterconnectCircuitInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectCircuitInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InterconnectCircuitInfo} InterconnectCircuitInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectCircuitInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InterconnectCircuitInfo message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InterconnectCircuitInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InterconnectCircuitInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.customerDemarcId != null && message.hasOwnProperty("customerDemarcId")) {
                                properties._customerDemarcId = 1;
                                if (!$util.isString(message.customerDemarcId))
                                    return "customerDemarcId: string expected";
                            }
                            if (message.googleCircuitId != null && message.hasOwnProperty("googleCircuitId")) {
                                properties._googleCircuitId = 1;
                                if (!$util.isString(message.googleCircuitId))
                                    return "googleCircuitId: string expected";
                            }
                            if (message.googleDemarcId != null && message.hasOwnProperty("googleDemarcId")) {
                                properties._googleDemarcId = 1;
                                if (!$util.isString(message.googleDemarcId))
                                    return "googleDemarcId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InterconnectCircuitInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InterconnectCircuitInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InterconnectCircuitInfo} InterconnectCircuitInfo
                         */
                        InterconnectCircuitInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InterconnectCircuitInfo)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InterconnectCircuitInfo();
                            if (object.customerDemarcId != null)
                                message.customerDemarcId = String(object.customerDemarcId);
                            if (object.googleCircuitId != null)
                                message.googleCircuitId = String(object.googleCircuitId);
                            if (object.googleDemarcId != null)
                                message.googleDemarcId = String(object.googleDemarcId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InterconnectCircuitInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InterconnectCircuitInfo
                         * @static
                         * @param {google.cloud.compute.v1.InterconnectCircuitInfo} message InterconnectCircuitInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InterconnectCircuitInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.customerDemarcId != null && message.hasOwnProperty("customerDemarcId")) {
                                object.customerDemarcId = message.customerDemarcId;
                                if (options.oneofs)
                                    object._customerDemarcId = "customerDemarcId";
                            }
                            if (message.googleCircuitId != null && message.hasOwnProperty("googleCircuitId")) {
                                object.googleCircuitId = message.googleCircuitId;
                                if (options.oneofs)
                                    object._googleCircuitId = "googleCircuitId";
                            }
                            if (message.googleDemarcId != null && message.hasOwnProperty("googleDemarcId")) {
                                object.googleDemarcId = message.googleDemarcId;
                                if (options.oneofs)
                                    object._googleDemarcId = "googleDemarcId";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InterconnectCircuitInfo to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InterconnectCircuitInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InterconnectCircuitInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InterconnectCircuitInfo
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InterconnectCircuitInfo
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InterconnectCircuitInfo.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InterconnectCircuitInfo";
                        };
    
                        return InterconnectCircuitInfo;
                    })();
    
                    v1.InterconnectDiagnostics = (function() {
    
                        /**
                         * Properties of an InterconnectDiagnostics.
                         * @memberof google.cloud.compute.v1
                         * @interface IInterconnectDiagnostics
                         * @property {Array.<google.cloud.compute.v1.IInterconnectDiagnosticsARPEntry>|null} [arpCaches] InterconnectDiagnostics arpCaches
                         * @property {Array.<google.cloud.compute.v1.IInterconnectDiagnosticsLinkStatus>|null} [links] InterconnectDiagnostics links
                         * @property {string|null} [macAddress] InterconnectDiagnostics macAddress
                         */
    
                        /**
                         * Constructs a new InterconnectDiagnostics.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InterconnectDiagnostics.
                         * @implements IInterconnectDiagnostics
                         * @constructor
                         * @param {google.cloud.compute.v1.IInterconnectDiagnostics=} [properties] Properties to set
                         */
                        function InterconnectDiagnostics(properties) {
                            this.arpCaches = [];
                            this.links = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InterconnectDiagnostics arpCaches.
                         * @member {Array.<google.cloud.compute.v1.IInterconnectDiagnosticsARPEntry>} arpCaches
                         * @memberof google.cloud.compute.v1.InterconnectDiagnostics
                         * @instance
                         */
                        InterconnectDiagnostics.prototype.arpCaches = $util.emptyArray;
    
                        /**
                         * InterconnectDiagnostics links.
                         * @member {Array.<google.cloud.compute.v1.IInterconnectDiagnosticsLinkStatus>} links
                         * @memberof google.cloud.compute.v1.InterconnectDiagnostics
                         * @instance
                         */
                        InterconnectDiagnostics.prototype.links = $util.emptyArray;
    
                        /**
                         * InterconnectDiagnostics macAddress.
                         * @member {string|null|undefined} macAddress
                         * @memberof google.cloud.compute.v1.InterconnectDiagnostics
                         * @instance
                         */
                        InterconnectDiagnostics.prototype.macAddress = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InterconnectDiagnostics _macAddress.
                         * @member {"macAddress"|undefined} _macAddress
                         * @memberof google.cloud.compute.v1.InterconnectDiagnostics
                         * @instance
                         */
                        Object.defineProperty(InterconnectDiagnostics.prototype, "_macAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["macAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InterconnectDiagnostics instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InterconnectDiagnostics
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectDiagnostics=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InterconnectDiagnostics} InterconnectDiagnostics instance
                         */
                        InterconnectDiagnostics.create = function create(properties) {
                            return new InterconnectDiagnostics(properties);
                        };
    
                        /**
                         * Encodes the specified InterconnectDiagnostics message. Does not implicitly {@link google.cloud.compute.v1.InterconnectDiagnostics.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InterconnectDiagnostics
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectDiagnostics} message InterconnectDiagnostics message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectDiagnostics.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.links != null && message.links.length)
                                for (var i = 0; i < message.links.length; ++i)
                                    $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus.encode(message.links[i], writer.uint32(/* id 102977465, wireType 2 =*/823819722).fork()).ldelim();
                            if (message.macAddress != null && Object.hasOwnProperty.call(message, "macAddress"))
                                writer.uint32(/* id 332540164, wireType 2 =*/2660321314).string(message.macAddress);
                            if (message.arpCaches != null && message.arpCaches.length)
                                for (var i = 0; i < message.arpCaches.length; ++i)
                                    $root.google.cloud.compute.v1.InterconnectDiagnosticsARPEntry.encode(message.arpCaches[i], writer.uint32(/* id 414591761, wireType 2 =*/3316734090).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InterconnectDiagnostics message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InterconnectDiagnostics.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectDiagnostics
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectDiagnostics} message InterconnectDiagnostics message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectDiagnostics.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InterconnectDiagnostics message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InterconnectDiagnostics
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InterconnectDiagnostics} InterconnectDiagnostics
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectDiagnostics.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InterconnectDiagnostics();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 414591761: {
                                        if (!(message.arpCaches && message.arpCaches.length))
                                            message.arpCaches = [];
                                        message.arpCaches.push($root.google.cloud.compute.v1.InterconnectDiagnosticsARPEntry.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 102977465: {
                                        if (!(message.links && message.links.length))
                                            message.links = [];
                                        message.links.push($root.google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 332540164: {
                                        message.macAddress = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InterconnectDiagnostics message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectDiagnostics
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InterconnectDiagnostics} InterconnectDiagnostics
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectDiagnostics.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InterconnectDiagnostics message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InterconnectDiagnostics
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InterconnectDiagnostics.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.arpCaches != null && message.hasOwnProperty("arpCaches")) {
                                if (!Array.isArray(message.arpCaches))
                                    return "arpCaches: array expected";
                                for (var i = 0; i < message.arpCaches.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InterconnectDiagnosticsARPEntry.verify(message.arpCaches[i]);
                                    if (error)
                                        return "arpCaches." + error;
                                }
                            }
                            if (message.links != null && message.hasOwnProperty("links")) {
                                if (!Array.isArray(message.links))
                                    return "links: array expected";
                                for (var i = 0; i < message.links.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus.verify(message.links[i]);
                                    if (error)
                                        return "links." + error;
                                }
                            }
                            if (message.macAddress != null && message.hasOwnProperty("macAddress")) {
                                properties._macAddress = 1;
                                if (!$util.isString(message.macAddress))
                                    return "macAddress: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InterconnectDiagnostics message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InterconnectDiagnostics
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InterconnectDiagnostics} InterconnectDiagnostics
                         */
                        InterconnectDiagnostics.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InterconnectDiagnostics)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InterconnectDiagnostics();
                            if (object.arpCaches) {
                                if (!Array.isArray(object.arpCaches))
                                    throw TypeError(".google.cloud.compute.v1.InterconnectDiagnostics.arpCaches: array expected");
                                message.arpCaches = [];
                                for (var i = 0; i < object.arpCaches.length; ++i) {
                                    if (typeof object.arpCaches[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InterconnectDiagnostics.arpCaches: object expected");
                                    message.arpCaches[i] = $root.google.cloud.compute.v1.InterconnectDiagnosticsARPEntry.fromObject(object.arpCaches[i]);
                                }
                            }
                            if (object.links) {
                                if (!Array.isArray(object.links))
                                    throw TypeError(".google.cloud.compute.v1.InterconnectDiagnostics.links: array expected");
                                message.links = [];
                                for (var i = 0; i < object.links.length; ++i) {
                                    if (typeof object.links[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InterconnectDiagnostics.links: object expected");
                                    message.links[i] = $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus.fromObject(object.links[i]);
                                }
                            }
                            if (object.macAddress != null)
                                message.macAddress = String(object.macAddress);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InterconnectDiagnostics message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InterconnectDiagnostics
                         * @static
                         * @param {google.cloud.compute.v1.InterconnectDiagnostics} message InterconnectDiagnostics
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InterconnectDiagnostics.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.links = [];
                                object.arpCaches = [];
                            }
                            if (message.links && message.links.length) {
                                object.links = [];
                                for (var j = 0; j < message.links.length; ++j)
                                    object.links[j] = $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus.toObject(message.links[j], options);
                            }
                            if (message.macAddress != null && message.hasOwnProperty("macAddress")) {
                                object.macAddress = message.macAddress;
                                if (options.oneofs)
                                    object._macAddress = "macAddress";
                            }
                            if (message.arpCaches && message.arpCaches.length) {
                                object.arpCaches = [];
                                for (var j = 0; j < message.arpCaches.length; ++j)
                                    object.arpCaches[j] = $root.google.cloud.compute.v1.InterconnectDiagnosticsARPEntry.toObject(message.arpCaches[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InterconnectDiagnostics to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InterconnectDiagnostics
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InterconnectDiagnostics.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InterconnectDiagnostics
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InterconnectDiagnostics
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InterconnectDiagnostics.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InterconnectDiagnostics";
                        };
    
                        return InterconnectDiagnostics;
                    })();
    
                    v1.InterconnectDiagnosticsARPEntry = (function() {
    
                        /**
                         * Properties of an InterconnectDiagnosticsARPEntry.
                         * @memberof google.cloud.compute.v1
                         * @interface IInterconnectDiagnosticsARPEntry
                         * @property {string|null} [ipAddress] InterconnectDiagnosticsARPEntry ipAddress
                         * @property {string|null} [macAddress] InterconnectDiagnosticsARPEntry macAddress
                         */
    
                        /**
                         * Constructs a new InterconnectDiagnosticsARPEntry.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InterconnectDiagnosticsARPEntry.
                         * @implements IInterconnectDiagnosticsARPEntry
                         * @constructor
                         * @param {google.cloud.compute.v1.IInterconnectDiagnosticsARPEntry=} [properties] Properties to set
                         */
                        function InterconnectDiagnosticsARPEntry(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InterconnectDiagnosticsARPEntry ipAddress.
                         * @member {string|null|undefined} ipAddress
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsARPEntry
                         * @instance
                         */
                        InterconnectDiagnosticsARPEntry.prototype.ipAddress = null;
    
                        /**
                         * InterconnectDiagnosticsARPEntry macAddress.
                         * @member {string|null|undefined} macAddress
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsARPEntry
                         * @instance
                         */
                        InterconnectDiagnosticsARPEntry.prototype.macAddress = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InterconnectDiagnosticsARPEntry _ipAddress.
                         * @member {"ipAddress"|undefined} _ipAddress
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsARPEntry
                         * @instance
                         */
                        Object.defineProperty(InterconnectDiagnosticsARPEntry.prototype, "_ipAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["ipAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectDiagnosticsARPEntry _macAddress.
                         * @member {"macAddress"|undefined} _macAddress
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsARPEntry
                         * @instance
                         */
                        Object.defineProperty(InterconnectDiagnosticsARPEntry.prototype, "_macAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["macAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InterconnectDiagnosticsARPEntry instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsARPEntry
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectDiagnosticsARPEntry=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InterconnectDiagnosticsARPEntry} InterconnectDiagnosticsARPEntry instance
                         */
                        InterconnectDiagnosticsARPEntry.create = function create(properties) {
                            return new InterconnectDiagnosticsARPEntry(properties);
                        };
    
                        /**
                         * Encodes the specified InterconnectDiagnosticsARPEntry message. Does not implicitly {@link google.cloud.compute.v1.InterconnectDiagnosticsARPEntry.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsARPEntry
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectDiagnosticsARPEntry} message InterconnectDiagnosticsARPEntry message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectDiagnosticsARPEntry.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.macAddress != null && Object.hasOwnProperty.call(message, "macAddress"))
                                writer.uint32(/* id 332540164, wireType 2 =*/2660321314).string(message.macAddress);
                            if (message.ipAddress != null && Object.hasOwnProperty.call(message, "ipAddress"))
                                writer.uint32(/* id 406272220, wireType 2 =*/3250177762).string(message.ipAddress);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InterconnectDiagnosticsARPEntry message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InterconnectDiagnosticsARPEntry.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsARPEntry
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectDiagnosticsARPEntry} message InterconnectDiagnosticsARPEntry message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectDiagnosticsARPEntry.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InterconnectDiagnosticsARPEntry message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsARPEntry
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InterconnectDiagnosticsARPEntry} InterconnectDiagnosticsARPEntry
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectDiagnosticsARPEntry.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InterconnectDiagnosticsARPEntry();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 406272220: {
                                        message.ipAddress = reader.string();
                                        break;
                                    }
                                case 332540164: {
                                        message.macAddress = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InterconnectDiagnosticsARPEntry message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsARPEntry
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InterconnectDiagnosticsARPEntry} InterconnectDiagnosticsARPEntry
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectDiagnosticsARPEntry.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InterconnectDiagnosticsARPEntry message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsARPEntry
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InterconnectDiagnosticsARPEntry.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.ipAddress != null && message.hasOwnProperty("ipAddress")) {
                                properties._ipAddress = 1;
                                if (!$util.isString(message.ipAddress))
                                    return "ipAddress: string expected";
                            }
                            if (message.macAddress != null && message.hasOwnProperty("macAddress")) {
                                properties._macAddress = 1;
                                if (!$util.isString(message.macAddress))
                                    return "macAddress: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InterconnectDiagnosticsARPEntry message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsARPEntry
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InterconnectDiagnosticsARPEntry} InterconnectDiagnosticsARPEntry
                         */
                        InterconnectDiagnosticsARPEntry.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InterconnectDiagnosticsARPEntry)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InterconnectDiagnosticsARPEntry();
                            if (object.ipAddress != null)
                                message.ipAddress = String(object.ipAddress);
                            if (object.macAddress != null)
                                message.macAddress = String(object.macAddress);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InterconnectDiagnosticsARPEntry message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsARPEntry
                         * @static
                         * @param {google.cloud.compute.v1.InterconnectDiagnosticsARPEntry} message InterconnectDiagnosticsARPEntry
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InterconnectDiagnosticsARPEntry.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.macAddress != null && message.hasOwnProperty("macAddress")) {
                                object.macAddress = message.macAddress;
                                if (options.oneofs)
                                    object._macAddress = "macAddress";
                            }
                            if (message.ipAddress != null && message.hasOwnProperty("ipAddress")) {
                                object.ipAddress = message.ipAddress;
                                if (options.oneofs)
                                    object._ipAddress = "ipAddress";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InterconnectDiagnosticsARPEntry to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsARPEntry
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InterconnectDiagnosticsARPEntry.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InterconnectDiagnosticsARPEntry
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsARPEntry
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InterconnectDiagnosticsARPEntry.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InterconnectDiagnosticsARPEntry";
                        };
    
                        return InterconnectDiagnosticsARPEntry;
                    })();
    
                    v1.InterconnectDiagnosticsLinkLACPStatus = (function() {
    
                        /**
                         * Properties of an InterconnectDiagnosticsLinkLACPStatus.
                         * @memberof google.cloud.compute.v1
                         * @interface IInterconnectDiagnosticsLinkLACPStatus
                         * @property {string|null} [googleSystemId] InterconnectDiagnosticsLinkLACPStatus googleSystemId
                         * @property {string|null} [neighborSystemId] InterconnectDiagnosticsLinkLACPStatus neighborSystemId
                         * @property {string|null} [state] InterconnectDiagnosticsLinkLACPStatus state
                         */
    
                        /**
                         * Constructs a new InterconnectDiagnosticsLinkLACPStatus.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InterconnectDiagnosticsLinkLACPStatus.
                         * @implements IInterconnectDiagnosticsLinkLACPStatus
                         * @constructor
                         * @param {google.cloud.compute.v1.IInterconnectDiagnosticsLinkLACPStatus=} [properties] Properties to set
                         */
                        function InterconnectDiagnosticsLinkLACPStatus(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InterconnectDiagnosticsLinkLACPStatus googleSystemId.
                         * @member {string|null|undefined} googleSystemId
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus
                         * @instance
                         */
                        InterconnectDiagnosticsLinkLACPStatus.prototype.googleSystemId = null;
    
                        /**
                         * InterconnectDiagnosticsLinkLACPStatus neighborSystemId.
                         * @member {string|null|undefined} neighborSystemId
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus
                         * @instance
                         */
                        InterconnectDiagnosticsLinkLACPStatus.prototype.neighborSystemId = null;
    
                        /**
                         * InterconnectDiagnosticsLinkLACPStatus state.
                         * @member {string|null|undefined} state
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus
                         * @instance
                         */
                        InterconnectDiagnosticsLinkLACPStatus.prototype.state = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InterconnectDiagnosticsLinkLACPStatus _googleSystemId.
                         * @member {"googleSystemId"|undefined} _googleSystemId
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus
                         * @instance
                         */
                        Object.defineProperty(InterconnectDiagnosticsLinkLACPStatus.prototype, "_googleSystemId", {
                            get: $util.oneOfGetter($oneOfFields = ["googleSystemId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectDiagnosticsLinkLACPStatus _neighborSystemId.
                         * @member {"neighborSystemId"|undefined} _neighborSystemId
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus
                         * @instance
                         */
                        Object.defineProperty(InterconnectDiagnosticsLinkLACPStatus.prototype, "_neighborSystemId", {
                            get: $util.oneOfGetter($oneOfFields = ["neighborSystemId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectDiagnosticsLinkLACPStatus _state.
                         * @member {"state"|undefined} _state
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus
                         * @instance
                         */
                        Object.defineProperty(InterconnectDiagnosticsLinkLACPStatus.prototype, "_state", {
                            get: $util.oneOfGetter($oneOfFields = ["state"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InterconnectDiagnosticsLinkLACPStatus instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectDiagnosticsLinkLACPStatus=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus} InterconnectDiagnosticsLinkLACPStatus instance
                         */
                        InterconnectDiagnosticsLinkLACPStatus.create = function create(properties) {
                            return new InterconnectDiagnosticsLinkLACPStatus(properties);
                        };
    
                        /**
                         * Encodes the specified InterconnectDiagnosticsLinkLACPStatus message. Does not implicitly {@link google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectDiagnosticsLinkLACPStatus} message InterconnectDiagnosticsLinkLACPStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectDiagnosticsLinkLACPStatus.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.googleSystemId != null && Object.hasOwnProperty.call(message, "googleSystemId"))
                                writer.uint32(/* id 91210405, wireType 2 =*/729683242).string(message.googleSystemId);
                            if (message.state != null && Object.hasOwnProperty.call(message, "state"))
                                writer.uint32(/* id 109757585, wireType 2 =*/878060682).string(message.state);
                            if (message.neighborSystemId != null && Object.hasOwnProperty.call(message, "neighborSystemId"))
                                writer.uint32(/* id 343821342, wireType 2 =*/2750570738).string(message.neighborSystemId);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InterconnectDiagnosticsLinkLACPStatus message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectDiagnosticsLinkLACPStatus} message InterconnectDiagnosticsLinkLACPStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectDiagnosticsLinkLACPStatus.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InterconnectDiagnosticsLinkLACPStatus message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus} InterconnectDiagnosticsLinkLACPStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectDiagnosticsLinkLACPStatus.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 91210405: {
                                        message.googleSystemId = reader.string();
                                        break;
                                    }
                                case 343821342: {
                                        message.neighborSystemId = reader.string();
                                        break;
                                    }
                                case 109757585: {
                                        message.state = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InterconnectDiagnosticsLinkLACPStatus message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus} InterconnectDiagnosticsLinkLACPStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectDiagnosticsLinkLACPStatus.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InterconnectDiagnosticsLinkLACPStatus message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InterconnectDiagnosticsLinkLACPStatus.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.googleSystemId != null && message.hasOwnProperty("googleSystemId")) {
                                properties._googleSystemId = 1;
                                if (!$util.isString(message.googleSystemId))
                                    return "googleSystemId: string expected";
                            }
                            if (message.neighborSystemId != null && message.hasOwnProperty("neighborSystemId")) {
                                properties._neighborSystemId = 1;
                                if (!$util.isString(message.neighborSystemId))
                                    return "neighborSystemId: string expected";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                properties._state = 1;
                                if (!$util.isString(message.state))
                                    return "state: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InterconnectDiagnosticsLinkLACPStatus message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus} InterconnectDiagnosticsLinkLACPStatus
                         */
                        InterconnectDiagnosticsLinkLACPStatus.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus();
                            if (object.googleSystemId != null)
                                message.googleSystemId = String(object.googleSystemId);
                            if (object.neighborSystemId != null)
                                message.neighborSystemId = String(object.neighborSystemId);
                            if (object.state != null)
                                message.state = String(object.state);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InterconnectDiagnosticsLinkLACPStatus message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus
                         * @static
                         * @param {google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus} message InterconnectDiagnosticsLinkLACPStatus
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InterconnectDiagnosticsLinkLACPStatus.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.googleSystemId != null && message.hasOwnProperty("googleSystemId")) {
                                object.googleSystemId = message.googleSystemId;
                                if (options.oneofs)
                                    object._googleSystemId = "googleSystemId";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                object.state = message.state;
                                if (options.oneofs)
                                    object._state = "state";
                            }
                            if (message.neighborSystemId != null && message.hasOwnProperty("neighborSystemId")) {
                                object.neighborSystemId = message.neighborSystemId;
                                if (options.oneofs)
                                    object._neighborSystemId = "neighborSystemId";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InterconnectDiagnosticsLinkLACPStatus to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InterconnectDiagnosticsLinkLACPStatus.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InterconnectDiagnosticsLinkLACPStatus
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InterconnectDiagnosticsLinkLACPStatus.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus";
                        };
    
                        /**
                         * State enum.
                         * @name google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus.State
                         * @enum {number}
                         * @property {number} UNDEFINED_STATE=0 UNDEFINED_STATE value
                         * @property {number} ACTIVE=314733318 ACTIVE value
                         * @property {number} DETACHED=216562546 DETACHED value
                         */
                        InterconnectDiagnosticsLinkLACPStatus.State = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATE"] = 0;
                            values[valuesById[314733318] = "ACTIVE"] = 314733318;
                            values[valuesById[216562546] = "DETACHED"] = 216562546;
                            return values;
                        })();
    
                        return InterconnectDiagnosticsLinkLACPStatus;
                    })();
    
                    v1.InterconnectDiagnosticsLinkOpticalPower = (function() {
    
                        /**
                         * Properties of an InterconnectDiagnosticsLinkOpticalPower.
                         * @memberof google.cloud.compute.v1
                         * @interface IInterconnectDiagnosticsLinkOpticalPower
                         * @property {string|null} [state] InterconnectDiagnosticsLinkOpticalPower state
                         * @property {number|null} [value] InterconnectDiagnosticsLinkOpticalPower value
                         */
    
                        /**
                         * Constructs a new InterconnectDiagnosticsLinkOpticalPower.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InterconnectDiagnosticsLinkOpticalPower.
                         * @implements IInterconnectDiagnosticsLinkOpticalPower
                         * @constructor
                         * @param {google.cloud.compute.v1.IInterconnectDiagnosticsLinkOpticalPower=} [properties] Properties to set
                         */
                        function InterconnectDiagnosticsLinkOpticalPower(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InterconnectDiagnosticsLinkOpticalPower state.
                         * @member {string|null|undefined} state
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower
                         * @instance
                         */
                        InterconnectDiagnosticsLinkOpticalPower.prototype.state = null;
    
                        /**
                         * InterconnectDiagnosticsLinkOpticalPower value.
                         * @member {number|null|undefined} value
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower
                         * @instance
                         */
                        InterconnectDiagnosticsLinkOpticalPower.prototype.value = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InterconnectDiagnosticsLinkOpticalPower _state.
                         * @member {"state"|undefined} _state
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower
                         * @instance
                         */
                        Object.defineProperty(InterconnectDiagnosticsLinkOpticalPower.prototype, "_state", {
                            get: $util.oneOfGetter($oneOfFields = ["state"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectDiagnosticsLinkOpticalPower _value.
                         * @member {"value"|undefined} _value
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower
                         * @instance
                         */
                        Object.defineProperty(InterconnectDiagnosticsLinkOpticalPower.prototype, "_value", {
                            get: $util.oneOfGetter($oneOfFields = ["value"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InterconnectDiagnosticsLinkOpticalPower instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectDiagnosticsLinkOpticalPower=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower} InterconnectDiagnosticsLinkOpticalPower instance
                         */
                        InterconnectDiagnosticsLinkOpticalPower.create = function create(properties) {
                            return new InterconnectDiagnosticsLinkOpticalPower(properties);
                        };
    
                        /**
                         * Encodes the specified InterconnectDiagnosticsLinkOpticalPower message. Does not implicitly {@link google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectDiagnosticsLinkOpticalPower} message InterconnectDiagnosticsLinkOpticalPower message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectDiagnosticsLinkOpticalPower.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.state != null && Object.hasOwnProperty.call(message, "state"))
                                writer.uint32(/* id 109757585, wireType 2 =*/878060682).string(message.state);
                            if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                writer.uint32(/* id 111972721, wireType 5 =*/895781773).float(message.value);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InterconnectDiagnosticsLinkOpticalPower message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectDiagnosticsLinkOpticalPower} message InterconnectDiagnosticsLinkOpticalPower message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectDiagnosticsLinkOpticalPower.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InterconnectDiagnosticsLinkOpticalPower message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower} InterconnectDiagnosticsLinkOpticalPower
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectDiagnosticsLinkOpticalPower.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 109757585: {
                                        message.state = reader.string();
                                        break;
                                    }
                                case 111972721: {
                                        message.value = reader.float();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InterconnectDiagnosticsLinkOpticalPower message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower} InterconnectDiagnosticsLinkOpticalPower
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectDiagnosticsLinkOpticalPower.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InterconnectDiagnosticsLinkOpticalPower message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InterconnectDiagnosticsLinkOpticalPower.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.state != null && message.hasOwnProperty("state")) {
                                properties._state = 1;
                                if (!$util.isString(message.state))
                                    return "state: string expected";
                            }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                properties._value = 1;
                                if (typeof message.value !== "number")
                                    return "value: number expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InterconnectDiagnosticsLinkOpticalPower message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower} InterconnectDiagnosticsLinkOpticalPower
                         */
                        InterconnectDiagnosticsLinkOpticalPower.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower();
                            if (object.state != null)
                                message.state = String(object.state);
                            if (object.value != null)
                                message.value = Number(object.value);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InterconnectDiagnosticsLinkOpticalPower message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower
                         * @static
                         * @param {google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower} message InterconnectDiagnosticsLinkOpticalPower
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InterconnectDiagnosticsLinkOpticalPower.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.state != null && message.hasOwnProperty("state")) {
                                object.state = message.state;
                                if (options.oneofs)
                                    object._state = "state";
                            }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                object.value = options.json && !isFinite(message.value) ? String(message.value) : message.value;
                                if (options.oneofs)
                                    object._value = "value";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InterconnectDiagnosticsLinkOpticalPower to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InterconnectDiagnosticsLinkOpticalPower.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InterconnectDiagnosticsLinkOpticalPower
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InterconnectDiagnosticsLinkOpticalPower.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower";
                        };
    
                        /**
                         * State enum.
                         * @name google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower.State
                         * @enum {number}
                         * @property {number} UNDEFINED_STATE=0 UNDEFINED_STATE value
                         * @property {number} HIGH_ALARM=305363284 HIGH_ALARM value
                         * @property {number} HIGH_WARNING=220984799 HIGH_WARNING value
                         * @property {number} LOW_ALARM=316659046 LOW_ALARM value
                         * @property {number} LOW_WARNING=338793841 LOW_WARNING value
                         * @property {number} OK=2524 OK value
                         */
                        InterconnectDiagnosticsLinkOpticalPower.State = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATE"] = 0;
                            values[valuesById[305363284] = "HIGH_ALARM"] = 305363284;
                            values[valuesById[220984799] = "HIGH_WARNING"] = 220984799;
                            values[valuesById[316659046] = "LOW_ALARM"] = 316659046;
                            values[valuesById[338793841] = "LOW_WARNING"] = 338793841;
                            values[valuesById[2524] = "OK"] = 2524;
                            return values;
                        })();
    
                        return InterconnectDiagnosticsLinkOpticalPower;
                    })();
    
                    v1.InterconnectDiagnosticsLinkStatus = (function() {
    
                        /**
                         * Properties of an InterconnectDiagnosticsLinkStatus.
                         * @memberof google.cloud.compute.v1
                         * @interface IInterconnectDiagnosticsLinkStatus
                         * @property {Array.<google.cloud.compute.v1.IInterconnectDiagnosticsARPEntry>|null} [arpCaches] InterconnectDiagnosticsLinkStatus arpCaches
                         * @property {string|null} [circuitId] InterconnectDiagnosticsLinkStatus circuitId
                         * @property {string|null} [googleDemarc] InterconnectDiagnosticsLinkStatus googleDemarc
                         * @property {google.cloud.compute.v1.IInterconnectDiagnosticsLinkLACPStatus|null} [lacpStatus] InterconnectDiagnosticsLinkStatus lacpStatus
                         * @property {google.cloud.compute.v1.IInterconnectDiagnosticsLinkOpticalPower|null} [receivingOpticalPower] InterconnectDiagnosticsLinkStatus receivingOpticalPower
                         * @property {google.cloud.compute.v1.IInterconnectDiagnosticsLinkOpticalPower|null} [transmittingOpticalPower] InterconnectDiagnosticsLinkStatus transmittingOpticalPower
                         */
    
                        /**
                         * Constructs a new InterconnectDiagnosticsLinkStatus.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InterconnectDiagnosticsLinkStatus.
                         * @implements IInterconnectDiagnosticsLinkStatus
                         * @constructor
                         * @param {google.cloud.compute.v1.IInterconnectDiagnosticsLinkStatus=} [properties] Properties to set
                         */
                        function InterconnectDiagnosticsLinkStatus(properties) {
                            this.arpCaches = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InterconnectDiagnosticsLinkStatus arpCaches.
                         * @member {Array.<google.cloud.compute.v1.IInterconnectDiagnosticsARPEntry>} arpCaches
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @instance
                         */
                        InterconnectDiagnosticsLinkStatus.prototype.arpCaches = $util.emptyArray;
    
                        /**
                         * InterconnectDiagnosticsLinkStatus circuitId.
                         * @member {string|null|undefined} circuitId
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @instance
                         */
                        InterconnectDiagnosticsLinkStatus.prototype.circuitId = null;
    
                        /**
                         * InterconnectDiagnosticsLinkStatus googleDemarc.
                         * @member {string|null|undefined} googleDemarc
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @instance
                         */
                        InterconnectDiagnosticsLinkStatus.prototype.googleDemarc = null;
    
                        /**
                         * InterconnectDiagnosticsLinkStatus lacpStatus.
                         * @member {google.cloud.compute.v1.IInterconnectDiagnosticsLinkLACPStatus|null|undefined} lacpStatus
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @instance
                         */
                        InterconnectDiagnosticsLinkStatus.prototype.lacpStatus = null;
    
                        /**
                         * InterconnectDiagnosticsLinkStatus receivingOpticalPower.
                         * @member {google.cloud.compute.v1.IInterconnectDiagnosticsLinkOpticalPower|null|undefined} receivingOpticalPower
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @instance
                         */
                        InterconnectDiagnosticsLinkStatus.prototype.receivingOpticalPower = null;
    
                        /**
                         * InterconnectDiagnosticsLinkStatus transmittingOpticalPower.
                         * @member {google.cloud.compute.v1.IInterconnectDiagnosticsLinkOpticalPower|null|undefined} transmittingOpticalPower
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @instance
                         */
                        InterconnectDiagnosticsLinkStatus.prototype.transmittingOpticalPower = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InterconnectDiagnosticsLinkStatus _circuitId.
                         * @member {"circuitId"|undefined} _circuitId
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @instance
                         */
                        Object.defineProperty(InterconnectDiagnosticsLinkStatus.prototype, "_circuitId", {
                            get: $util.oneOfGetter($oneOfFields = ["circuitId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectDiagnosticsLinkStatus _googleDemarc.
                         * @member {"googleDemarc"|undefined} _googleDemarc
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @instance
                         */
                        Object.defineProperty(InterconnectDiagnosticsLinkStatus.prototype, "_googleDemarc", {
                            get: $util.oneOfGetter($oneOfFields = ["googleDemarc"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectDiagnosticsLinkStatus _lacpStatus.
                         * @member {"lacpStatus"|undefined} _lacpStatus
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @instance
                         */
                        Object.defineProperty(InterconnectDiagnosticsLinkStatus.prototype, "_lacpStatus", {
                            get: $util.oneOfGetter($oneOfFields = ["lacpStatus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectDiagnosticsLinkStatus _receivingOpticalPower.
                         * @member {"receivingOpticalPower"|undefined} _receivingOpticalPower
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @instance
                         */
                        Object.defineProperty(InterconnectDiagnosticsLinkStatus.prototype, "_receivingOpticalPower", {
                            get: $util.oneOfGetter($oneOfFields = ["receivingOpticalPower"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectDiagnosticsLinkStatus _transmittingOpticalPower.
                         * @member {"transmittingOpticalPower"|undefined} _transmittingOpticalPower
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @instance
                         */
                        Object.defineProperty(InterconnectDiagnosticsLinkStatus.prototype, "_transmittingOpticalPower", {
                            get: $util.oneOfGetter($oneOfFields = ["transmittingOpticalPower"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InterconnectDiagnosticsLinkStatus instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectDiagnosticsLinkStatus=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus} InterconnectDiagnosticsLinkStatus instance
                         */
                        InterconnectDiagnosticsLinkStatus.create = function create(properties) {
                            return new InterconnectDiagnosticsLinkStatus(properties);
                        };
    
                        /**
                         * Encodes the specified InterconnectDiagnosticsLinkStatus message. Does not implicitly {@link google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectDiagnosticsLinkStatus} message InterconnectDiagnosticsLinkStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectDiagnosticsLinkStatus.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.googleDemarc != null && Object.hasOwnProperty.call(message, "googleDemarc"))
                                writer.uint32(/* id 51084, wireType 2 =*/408674).string(message.googleDemarc);
                            if (message.circuitId != null && Object.hasOwnProperty.call(message, "circuitId"))
                                writer.uint32(/* id 225180977, wireType 2 =*/1801447818).string(message.circuitId);
                            if (message.receivingOpticalPower != null && Object.hasOwnProperty.call(message, "receivingOpticalPower"))
                                $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower.encode(message.receivingOpticalPower, writer.uint32(/* id 244717279, wireType 2 =*/1957738234).fork()).ldelim();
                            if (message.lacpStatus != null && Object.hasOwnProperty.call(message, "lacpStatus"))
                                $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus.encode(message.lacpStatus, writer.uint32(/* id 361210415, wireType 2 =*/2889683322).fork()).ldelim();
                            if (message.arpCaches != null && message.arpCaches.length)
                                for (var i = 0; i < message.arpCaches.length; ++i)
                                    $root.google.cloud.compute.v1.InterconnectDiagnosticsARPEntry.encode(message.arpCaches[i], writer.uint32(/* id 414591761, wireType 2 =*/3316734090).fork()).ldelim();
                            if (message.transmittingOpticalPower != null && Object.hasOwnProperty.call(message, "transmittingOpticalPower"))
                                $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower.encode(message.transmittingOpticalPower, writer.uint32(/* id 459431197, wireType 2 =*/3675449578).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InterconnectDiagnosticsLinkStatus message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectDiagnosticsLinkStatus} message InterconnectDiagnosticsLinkStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectDiagnosticsLinkStatus.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InterconnectDiagnosticsLinkStatus message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus} InterconnectDiagnosticsLinkStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectDiagnosticsLinkStatus.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 414591761: {
                                        if (!(message.arpCaches && message.arpCaches.length))
                                            message.arpCaches = [];
                                        message.arpCaches.push($root.google.cloud.compute.v1.InterconnectDiagnosticsARPEntry.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 225180977: {
                                        message.circuitId = reader.string();
                                        break;
                                    }
                                case 51084: {
                                        message.googleDemarc = reader.string();
                                        break;
                                    }
                                case 361210415: {
                                        message.lacpStatus = $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 244717279: {
                                        message.receivingOpticalPower = $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 459431197: {
                                        message.transmittingOpticalPower = $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InterconnectDiagnosticsLinkStatus message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus} InterconnectDiagnosticsLinkStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectDiagnosticsLinkStatus.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InterconnectDiagnosticsLinkStatus message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InterconnectDiagnosticsLinkStatus.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.arpCaches != null && message.hasOwnProperty("arpCaches")) {
                                if (!Array.isArray(message.arpCaches))
                                    return "arpCaches: array expected";
                                for (var i = 0; i < message.arpCaches.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InterconnectDiagnosticsARPEntry.verify(message.arpCaches[i]);
                                    if (error)
                                        return "arpCaches." + error;
                                }
                            }
                            if (message.circuitId != null && message.hasOwnProperty("circuitId")) {
                                properties._circuitId = 1;
                                if (!$util.isString(message.circuitId))
                                    return "circuitId: string expected";
                            }
                            if (message.googleDemarc != null && message.hasOwnProperty("googleDemarc")) {
                                properties._googleDemarc = 1;
                                if (!$util.isString(message.googleDemarc))
                                    return "googleDemarc: string expected";
                            }
                            if (message.lacpStatus != null && message.hasOwnProperty("lacpStatus")) {
                                properties._lacpStatus = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus.verify(message.lacpStatus);
                                    if (error)
                                        return "lacpStatus." + error;
                                }
                            }
                            if (message.receivingOpticalPower != null && message.hasOwnProperty("receivingOpticalPower")) {
                                properties._receivingOpticalPower = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower.verify(message.receivingOpticalPower);
                                    if (error)
                                        return "receivingOpticalPower." + error;
                                }
                            }
                            if (message.transmittingOpticalPower != null && message.hasOwnProperty("transmittingOpticalPower")) {
                                properties._transmittingOpticalPower = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower.verify(message.transmittingOpticalPower);
                                    if (error)
                                        return "transmittingOpticalPower." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InterconnectDiagnosticsLinkStatus message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus} InterconnectDiagnosticsLinkStatus
                         */
                        InterconnectDiagnosticsLinkStatus.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus();
                            if (object.arpCaches) {
                                if (!Array.isArray(object.arpCaches))
                                    throw TypeError(".google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus.arpCaches: array expected");
                                message.arpCaches = [];
                                for (var i = 0; i < object.arpCaches.length; ++i) {
                                    if (typeof object.arpCaches[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus.arpCaches: object expected");
                                    message.arpCaches[i] = $root.google.cloud.compute.v1.InterconnectDiagnosticsARPEntry.fromObject(object.arpCaches[i]);
                                }
                            }
                            if (object.circuitId != null)
                                message.circuitId = String(object.circuitId);
                            if (object.googleDemarc != null)
                                message.googleDemarc = String(object.googleDemarc);
                            if (object.lacpStatus != null) {
                                if (typeof object.lacpStatus !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus.lacpStatus: object expected");
                                message.lacpStatus = $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus.fromObject(object.lacpStatus);
                            }
                            if (object.receivingOpticalPower != null) {
                                if (typeof object.receivingOpticalPower !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus.receivingOpticalPower: object expected");
                                message.receivingOpticalPower = $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower.fromObject(object.receivingOpticalPower);
                            }
                            if (object.transmittingOpticalPower != null) {
                                if (typeof object.transmittingOpticalPower !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus.transmittingOpticalPower: object expected");
                                message.transmittingOpticalPower = $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower.fromObject(object.transmittingOpticalPower);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InterconnectDiagnosticsLinkStatus message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @static
                         * @param {google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus} message InterconnectDiagnosticsLinkStatus
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InterconnectDiagnosticsLinkStatus.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.arpCaches = [];
                            if (message.googleDemarc != null && message.hasOwnProperty("googleDemarc")) {
                                object.googleDemarc = message.googleDemarc;
                                if (options.oneofs)
                                    object._googleDemarc = "googleDemarc";
                            }
                            if (message.circuitId != null && message.hasOwnProperty("circuitId")) {
                                object.circuitId = message.circuitId;
                                if (options.oneofs)
                                    object._circuitId = "circuitId";
                            }
                            if (message.receivingOpticalPower != null && message.hasOwnProperty("receivingOpticalPower")) {
                                object.receivingOpticalPower = $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower.toObject(message.receivingOpticalPower, options);
                                if (options.oneofs)
                                    object._receivingOpticalPower = "receivingOpticalPower";
                            }
                            if (message.lacpStatus != null && message.hasOwnProperty("lacpStatus")) {
                                object.lacpStatus = $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkLACPStatus.toObject(message.lacpStatus, options);
                                if (options.oneofs)
                                    object._lacpStatus = "lacpStatus";
                            }
                            if (message.arpCaches && message.arpCaches.length) {
                                object.arpCaches = [];
                                for (var j = 0; j < message.arpCaches.length; ++j)
                                    object.arpCaches[j] = $root.google.cloud.compute.v1.InterconnectDiagnosticsARPEntry.toObject(message.arpCaches[j], options);
                            }
                            if (message.transmittingOpticalPower != null && message.hasOwnProperty("transmittingOpticalPower")) {
                                object.transmittingOpticalPower = $root.google.cloud.compute.v1.InterconnectDiagnosticsLinkOpticalPower.toObject(message.transmittingOpticalPower, options);
                                if (options.oneofs)
                                    object._transmittingOpticalPower = "transmittingOpticalPower";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InterconnectDiagnosticsLinkStatus to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InterconnectDiagnosticsLinkStatus.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InterconnectDiagnosticsLinkStatus
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InterconnectDiagnosticsLinkStatus.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InterconnectDiagnosticsLinkStatus";
                        };
    
                        return InterconnectDiagnosticsLinkStatus;
                    })();
    
                    v1.InterconnectList = (function() {
    
                        /**
                         * Properties of an InterconnectList.
                         * @memberof google.cloud.compute.v1
                         * @interface IInterconnectList
                         * @property {string|null} [id] InterconnectList id
                         * @property {Array.<google.cloud.compute.v1.IInterconnect>|null} [items] InterconnectList items
                         * @property {string|null} [kind] InterconnectList kind
                         * @property {string|null} [nextPageToken] InterconnectList nextPageToken
                         * @property {string|null} [selfLink] InterconnectList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] InterconnectList warning
                         */
    
                        /**
                         * Constructs a new InterconnectList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InterconnectList.
                         * @implements IInterconnectList
                         * @constructor
                         * @param {google.cloud.compute.v1.IInterconnectList=} [properties] Properties to set
                         */
                        function InterconnectList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InterconnectList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @instance
                         */
                        InterconnectList.prototype.id = null;
    
                        /**
                         * InterconnectList items.
                         * @member {Array.<google.cloud.compute.v1.IInterconnect>} items
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @instance
                         */
                        InterconnectList.prototype.items = $util.emptyArray;
    
                        /**
                         * InterconnectList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @instance
                         */
                        InterconnectList.prototype.kind = null;
    
                        /**
                         * InterconnectList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @instance
                         */
                        InterconnectList.prototype.nextPageToken = null;
    
                        /**
                         * InterconnectList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @instance
                         */
                        InterconnectList.prototype.selfLink = null;
    
                        /**
                         * InterconnectList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @instance
                         */
                        InterconnectList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InterconnectList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @instance
                         */
                        Object.defineProperty(InterconnectList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @instance
                         */
                        Object.defineProperty(InterconnectList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @instance
                         */
                        Object.defineProperty(InterconnectList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @instance
                         */
                        Object.defineProperty(InterconnectList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @instance
                         */
                        Object.defineProperty(InterconnectList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InterconnectList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InterconnectList} InterconnectList instance
                         */
                        InterconnectList.create = function create(properties) {
                            return new InterconnectList(properties);
                        };
    
                        /**
                         * Encodes the specified InterconnectList message. Does not implicitly {@link google.cloud.compute.v1.InterconnectList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectList} message InterconnectList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Interconnect.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InterconnectList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InterconnectList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectList} message InterconnectList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InterconnectList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InterconnectList} InterconnectList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InterconnectList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Interconnect.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InterconnectList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InterconnectList} InterconnectList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InterconnectList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InterconnectList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Interconnect.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InterconnectList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InterconnectList} InterconnectList
                         */
                        InterconnectList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InterconnectList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InterconnectList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.InterconnectList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InterconnectList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Interconnect.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InterconnectList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InterconnectList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @static
                         * @param {google.cloud.compute.v1.InterconnectList} message InterconnectList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InterconnectList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Interconnect.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InterconnectList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InterconnectList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InterconnectList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InterconnectList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InterconnectList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InterconnectList";
                        };
    
                        return InterconnectList;
                    })();
    
                    v1.InterconnectLocation = (function() {
    
                        /**
                         * Properties of an InterconnectLocation.
                         * @memberof google.cloud.compute.v1
                         * @interface IInterconnectLocation
                         * @property {string|null} [address] InterconnectLocation address
                         * @property {string|null} [availabilityZone] InterconnectLocation availabilityZone
                         * @property {string|null} [city] InterconnectLocation city
                         * @property {string|null} [continent] InterconnectLocation continent
                         * @property {string|null} [creationTimestamp] InterconnectLocation creationTimestamp
                         * @property {string|null} [description] InterconnectLocation description
                         * @property {string|null} [facilityProvider] InterconnectLocation facilityProvider
                         * @property {string|null} [facilityProviderFacilityId] InterconnectLocation facilityProviderFacilityId
                         * @property {number|Long|null} [id] InterconnectLocation id
                         * @property {string|null} [kind] InterconnectLocation kind
                         * @property {string|null} [name] InterconnectLocation name
                         * @property {string|null} [peeringdbFacilityId] InterconnectLocation peeringdbFacilityId
                         * @property {Array.<google.cloud.compute.v1.IInterconnectLocationRegionInfo>|null} [regionInfos] InterconnectLocation regionInfos
                         * @property {string|null} [selfLink] InterconnectLocation selfLink
                         * @property {string|null} [status] InterconnectLocation status
                         * @property {boolean|null} [supportsPzs] InterconnectLocation supportsPzs
                         */
    
                        /**
                         * Constructs a new InterconnectLocation.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InterconnectLocation.
                         * @implements IInterconnectLocation
                         * @constructor
                         * @param {google.cloud.compute.v1.IInterconnectLocation=} [properties] Properties to set
                         */
                        function InterconnectLocation(properties) {
                            this.regionInfos = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InterconnectLocation address.
                         * @member {string|null|undefined} address
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        InterconnectLocation.prototype.address = null;
    
                        /**
                         * InterconnectLocation availabilityZone.
                         * @member {string|null|undefined} availabilityZone
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        InterconnectLocation.prototype.availabilityZone = null;
    
                        /**
                         * InterconnectLocation city.
                         * @member {string|null|undefined} city
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        InterconnectLocation.prototype.city = null;
    
                        /**
                         * InterconnectLocation continent.
                         * @member {string|null|undefined} continent
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        InterconnectLocation.prototype.continent = null;
    
                        /**
                         * InterconnectLocation creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        InterconnectLocation.prototype.creationTimestamp = null;
    
                        /**
                         * InterconnectLocation description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        InterconnectLocation.prototype.description = null;
    
                        /**
                         * InterconnectLocation facilityProvider.
                         * @member {string|null|undefined} facilityProvider
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        InterconnectLocation.prototype.facilityProvider = null;
    
                        /**
                         * InterconnectLocation facilityProviderFacilityId.
                         * @member {string|null|undefined} facilityProviderFacilityId
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        InterconnectLocation.prototype.facilityProviderFacilityId = null;
    
                        /**
                         * InterconnectLocation id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        InterconnectLocation.prototype.id = null;
    
                        /**
                         * InterconnectLocation kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        InterconnectLocation.prototype.kind = null;
    
                        /**
                         * InterconnectLocation name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        InterconnectLocation.prototype.name = null;
    
                        /**
                         * InterconnectLocation peeringdbFacilityId.
                         * @member {string|null|undefined} peeringdbFacilityId
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        InterconnectLocation.prototype.peeringdbFacilityId = null;
    
                        /**
                         * InterconnectLocation regionInfos.
                         * @member {Array.<google.cloud.compute.v1.IInterconnectLocationRegionInfo>} regionInfos
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        InterconnectLocation.prototype.regionInfos = $util.emptyArray;
    
                        /**
                         * InterconnectLocation selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        InterconnectLocation.prototype.selfLink = null;
    
                        /**
                         * InterconnectLocation status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        InterconnectLocation.prototype.status = null;
    
                        /**
                         * InterconnectLocation supportsPzs.
                         * @member {boolean|null|undefined} supportsPzs
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        InterconnectLocation.prototype.supportsPzs = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InterconnectLocation _address.
                         * @member {"address"|undefined} _address
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocation.prototype, "_address", {
                            get: $util.oneOfGetter($oneOfFields = ["address"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectLocation _availabilityZone.
                         * @member {"availabilityZone"|undefined} _availabilityZone
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocation.prototype, "_availabilityZone", {
                            get: $util.oneOfGetter($oneOfFields = ["availabilityZone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectLocation _city.
                         * @member {"city"|undefined} _city
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocation.prototype, "_city", {
                            get: $util.oneOfGetter($oneOfFields = ["city"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectLocation _continent.
                         * @member {"continent"|undefined} _continent
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocation.prototype, "_continent", {
                            get: $util.oneOfGetter($oneOfFields = ["continent"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectLocation _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocation.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectLocation _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocation.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectLocation _facilityProvider.
                         * @member {"facilityProvider"|undefined} _facilityProvider
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocation.prototype, "_facilityProvider", {
                            get: $util.oneOfGetter($oneOfFields = ["facilityProvider"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectLocation _facilityProviderFacilityId.
                         * @member {"facilityProviderFacilityId"|undefined} _facilityProviderFacilityId
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocation.prototype, "_facilityProviderFacilityId", {
                            get: $util.oneOfGetter($oneOfFields = ["facilityProviderFacilityId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectLocation _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocation.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectLocation _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocation.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectLocation _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocation.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectLocation _peeringdbFacilityId.
                         * @member {"peeringdbFacilityId"|undefined} _peeringdbFacilityId
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocation.prototype, "_peeringdbFacilityId", {
                            get: $util.oneOfGetter($oneOfFields = ["peeringdbFacilityId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectLocation _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocation.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectLocation _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocation.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectLocation _supportsPzs.
                         * @member {"supportsPzs"|undefined} _supportsPzs
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocation.prototype, "_supportsPzs", {
                            get: $util.oneOfGetter($oneOfFields = ["supportsPzs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InterconnectLocation instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectLocation=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InterconnectLocation} InterconnectLocation instance
                         */
                        InterconnectLocation.create = function create(properties) {
                            return new InterconnectLocation(properties);
                        };
    
                        /**
                         * Encodes the specified InterconnectLocation message. Does not implicitly {@link google.cloud.compute.v1.InterconnectLocation.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectLocation} message InterconnectLocation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectLocation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.city != null && Object.hasOwnProperty.call(message, "city"))
                                writer.uint32(/* id 3053931, wireType 2 =*/24431450).string(message.city);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.supportsPzs != null && Object.hasOwnProperty.call(message, "supportsPzs"))
                                writer.uint32(/* id 83983214, wireType 0 =*/671865712).bool(message.supportsPzs);
                            if (message.facilityProviderFacilityId != null && Object.hasOwnProperty.call(message, "facilityProviderFacilityId"))
                                writer.uint32(/* id 87269125, wireType 2 =*/698153002).string(message.facilityProviderFacilityId);
                            if (message.continent != null && Object.hasOwnProperty.call(message, "continent"))
                                writer.uint32(/* id 133442996, wireType 2 =*/1067543970).string(message.continent);
                            if (message.availabilityZone != null && Object.hasOwnProperty.call(message, "availabilityZone"))
                                writer.uint32(/* id 158459920, wireType 2 =*/1267679362).string(message.availabilityZone);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.regionInfos != null && message.regionInfos.length)
                                for (var i = 0; i < message.regionInfos.length; ++i)
                                    $root.google.cloud.compute.v1.InterconnectLocationRegionInfo.encode(message.regionInfos[i], writer.uint32(/* id 312194170, wireType 2 =*/2497553362).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.address != null && Object.hasOwnProperty.call(message, "address"))
                                writer.uint32(/* id 462920692, wireType 2 =*/3703365538).string(message.address);
                            if (message.facilityProvider != null && Object.hasOwnProperty.call(message, "facilityProvider"))
                                writer.uint32(/* id 533303309, wireType 2 =*/4266426474).string(message.facilityProvider);
                            if (message.peeringdbFacilityId != null && Object.hasOwnProperty.call(message, "peeringdbFacilityId"))
                                writer.uint32(/* id 536567094, wireType 2 =*/4292536754).string(message.peeringdbFacilityId);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InterconnectLocation message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InterconnectLocation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectLocation} message InterconnectLocation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectLocation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InterconnectLocation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InterconnectLocation} InterconnectLocation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectLocation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InterconnectLocation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 462920692: {
                                        message.address = reader.string();
                                        break;
                                    }
                                case 158459920: {
                                        message.availabilityZone = reader.string();
                                        break;
                                    }
                                case 3053931: {
                                        message.city = reader.string();
                                        break;
                                    }
                                case 133442996: {
                                        message.continent = reader.string();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 533303309: {
                                        message.facilityProvider = reader.string();
                                        break;
                                    }
                                case 87269125: {
                                        message.facilityProviderFacilityId = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 536567094: {
                                        message.peeringdbFacilityId = reader.string();
                                        break;
                                    }
                                case 312194170: {
                                        if (!(message.regionInfos && message.regionInfos.length))
                                            message.regionInfos = [];
                                        message.regionInfos.push($root.google.cloud.compute.v1.InterconnectLocationRegionInfo.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                case 83983214: {
                                        message.supportsPzs = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InterconnectLocation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InterconnectLocation} InterconnectLocation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectLocation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InterconnectLocation message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InterconnectLocation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.address != null && message.hasOwnProperty("address")) {
                                properties._address = 1;
                                if (!$util.isString(message.address))
                                    return "address: string expected";
                            }
                            if (message.availabilityZone != null && message.hasOwnProperty("availabilityZone")) {
                                properties._availabilityZone = 1;
                                if (!$util.isString(message.availabilityZone))
                                    return "availabilityZone: string expected";
                            }
                            if (message.city != null && message.hasOwnProperty("city")) {
                                properties._city = 1;
                                if (!$util.isString(message.city))
                                    return "city: string expected";
                            }
                            if (message.continent != null && message.hasOwnProperty("continent")) {
                                properties._continent = 1;
                                if (!$util.isString(message.continent))
                                    return "continent: string expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.facilityProvider != null && message.hasOwnProperty("facilityProvider")) {
                                properties._facilityProvider = 1;
                                if (!$util.isString(message.facilityProvider))
                                    return "facilityProvider: string expected";
                            }
                            if (message.facilityProviderFacilityId != null && message.hasOwnProperty("facilityProviderFacilityId")) {
                                properties._facilityProviderFacilityId = 1;
                                if (!$util.isString(message.facilityProviderFacilityId))
                                    return "facilityProviderFacilityId: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.peeringdbFacilityId != null && message.hasOwnProperty("peeringdbFacilityId")) {
                                properties._peeringdbFacilityId = 1;
                                if (!$util.isString(message.peeringdbFacilityId))
                                    return "peeringdbFacilityId: string expected";
                            }
                            if (message.regionInfos != null && message.hasOwnProperty("regionInfos")) {
                                if (!Array.isArray(message.regionInfos))
                                    return "regionInfos: array expected";
                                for (var i = 0; i < message.regionInfos.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InterconnectLocationRegionInfo.verify(message.regionInfos[i]);
                                    if (error)
                                        return "regionInfos." + error;
                                }
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            if (message.supportsPzs != null && message.hasOwnProperty("supportsPzs")) {
                                properties._supportsPzs = 1;
                                if (typeof message.supportsPzs !== "boolean")
                                    return "supportsPzs: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InterconnectLocation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InterconnectLocation} InterconnectLocation
                         */
                        InterconnectLocation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InterconnectLocation)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InterconnectLocation();
                            if (object.address != null)
                                message.address = String(object.address);
                            if (object.availabilityZone != null)
                                message.availabilityZone = String(object.availabilityZone);
                            if (object.city != null)
                                message.city = String(object.city);
                            if (object.continent != null)
                                message.continent = String(object.continent);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.facilityProvider != null)
                                message.facilityProvider = String(object.facilityProvider);
                            if (object.facilityProviderFacilityId != null)
                                message.facilityProviderFacilityId = String(object.facilityProviderFacilityId);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.peeringdbFacilityId != null)
                                message.peeringdbFacilityId = String(object.peeringdbFacilityId);
                            if (object.regionInfos) {
                                if (!Array.isArray(object.regionInfos))
                                    throw TypeError(".google.cloud.compute.v1.InterconnectLocation.regionInfos: array expected");
                                message.regionInfos = [];
                                for (var i = 0; i < object.regionInfos.length; ++i) {
                                    if (typeof object.regionInfos[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InterconnectLocation.regionInfos: object expected");
                                    message.regionInfos[i] = $root.google.cloud.compute.v1.InterconnectLocationRegionInfo.fromObject(object.regionInfos[i]);
                                }
                            }
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.status != null)
                                message.status = String(object.status);
                            if (object.supportsPzs != null)
                                message.supportsPzs = Boolean(object.supportsPzs);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InterconnectLocation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @static
                         * @param {google.cloud.compute.v1.InterconnectLocation} message InterconnectLocation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InterconnectLocation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.regionInfos = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.city != null && message.hasOwnProperty("city")) {
                                object.city = message.city;
                                if (options.oneofs)
                                    object._city = "city";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.supportsPzs != null && message.hasOwnProperty("supportsPzs")) {
                                object.supportsPzs = message.supportsPzs;
                                if (options.oneofs)
                                    object._supportsPzs = "supportsPzs";
                            }
                            if (message.facilityProviderFacilityId != null && message.hasOwnProperty("facilityProviderFacilityId")) {
                                object.facilityProviderFacilityId = message.facilityProviderFacilityId;
                                if (options.oneofs)
                                    object._facilityProviderFacilityId = "facilityProviderFacilityId";
                            }
                            if (message.continent != null && message.hasOwnProperty("continent")) {
                                object.continent = message.continent;
                                if (options.oneofs)
                                    object._continent = "continent";
                            }
                            if (message.availabilityZone != null && message.hasOwnProperty("availabilityZone")) {
                                object.availabilityZone = message.availabilityZone;
                                if (options.oneofs)
                                    object._availabilityZone = "availabilityZone";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.regionInfos && message.regionInfos.length) {
                                object.regionInfos = [];
                                for (var j = 0; j < message.regionInfos.length; ++j)
                                    object.regionInfos[j] = $root.google.cloud.compute.v1.InterconnectLocationRegionInfo.toObject(message.regionInfos[j], options);
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.address != null && message.hasOwnProperty("address")) {
                                object.address = message.address;
                                if (options.oneofs)
                                    object._address = "address";
                            }
                            if (message.facilityProvider != null && message.hasOwnProperty("facilityProvider")) {
                                object.facilityProvider = message.facilityProvider;
                                if (options.oneofs)
                                    object._facilityProvider = "facilityProvider";
                            }
                            if (message.peeringdbFacilityId != null && message.hasOwnProperty("peeringdbFacilityId")) {
                                object.peeringdbFacilityId = message.peeringdbFacilityId;
                                if (options.oneofs)
                                    object._peeringdbFacilityId = "peeringdbFacilityId";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InterconnectLocation to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InterconnectLocation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InterconnectLocation
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InterconnectLocation
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InterconnectLocation.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InterconnectLocation";
                        };
    
                        /**
                         * Continent enum.
                         * @name google.cloud.compute.v1.InterconnectLocation.Continent
                         * @enum {number}
                         * @property {number} UNDEFINED_CONTINENT=0 UNDEFINED_CONTINENT value
                         * @property {number} AFRICA=317443706 AFRICA value
                         * @property {number} ASIA_PAC=119782269 ASIA_PAC value
                         * @property {number} C_AFRICA=71993846 C_AFRICA value
                         * @property {number} C_ASIA_PAC=465668089 C_ASIA_PAC value
                         * @property {number} C_EUROPE=200369438 C_EUROPE value
                         * @property {number} C_NORTH_AMERICA=275697048 C_NORTH_AMERICA value
                         * @property {number} C_SOUTH_AMERICA=397149792 C_SOUTH_AMERICA value
                         * @property {number} EUROPE=445819298 EUROPE value
                         * @property {number} NORTH_AMERICA=448015508 NORTH_AMERICA value
                         * @property {number} SOUTH_AMERICA=32597340 SOUTH_AMERICA value
                         */
                        InterconnectLocation.Continent = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_CONTINENT"] = 0;
                            values[valuesById[317443706] = "AFRICA"] = 317443706;
                            values[valuesById[119782269] = "ASIA_PAC"] = 119782269;
                            values[valuesById[71993846] = "C_AFRICA"] = 71993846;
                            values[valuesById[465668089] = "C_ASIA_PAC"] = 465668089;
                            values[valuesById[200369438] = "C_EUROPE"] = 200369438;
                            values[valuesById[275697048] = "C_NORTH_AMERICA"] = 275697048;
                            values[valuesById[397149792] = "C_SOUTH_AMERICA"] = 397149792;
                            values[valuesById[445819298] = "EUROPE"] = 445819298;
                            values[valuesById[448015508] = "NORTH_AMERICA"] = 448015508;
                            values[valuesById[32597340] = "SOUTH_AMERICA"] = 32597340;
                            return values;
                        })();
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.InterconnectLocation.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} AVAILABLE=442079913 AVAILABLE value
                         * @property {number} CLOSED=380163436 CLOSED value
                         */
                        InterconnectLocation.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[442079913] = "AVAILABLE"] = 442079913;
                            values[valuesById[380163436] = "CLOSED"] = 380163436;
                            return values;
                        })();
    
                        return InterconnectLocation;
                    })();
    
                    v1.InterconnectLocationList = (function() {
    
                        /**
                         * Properties of an InterconnectLocationList.
                         * @memberof google.cloud.compute.v1
                         * @interface IInterconnectLocationList
                         * @property {string|null} [id] InterconnectLocationList id
                         * @property {Array.<google.cloud.compute.v1.IInterconnectLocation>|null} [items] InterconnectLocationList items
                         * @property {string|null} [kind] InterconnectLocationList kind
                         * @property {string|null} [nextPageToken] InterconnectLocationList nextPageToken
                         * @property {string|null} [selfLink] InterconnectLocationList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] InterconnectLocationList warning
                         */
    
                        /**
                         * Constructs a new InterconnectLocationList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InterconnectLocationList.
                         * @implements IInterconnectLocationList
                         * @constructor
                         * @param {google.cloud.compute.v1.IInterconnectLocationList=} [properties] Properties to set
                         */
                        function InterconnectLocationList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InterconnectLocationList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @instance
                         */
                        InterconnectLocationList.prototype.id = null;
    
                        /**
                         * InterconnectLocationList items.
                         * @member {Array.<google.cloud.compute.v1.IInterconnectLocation>} items
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @instance
                         */
                        InterconnectLocationList.prototype.items = $util.emptyArray;
    
                        /**
                         * InterconnectLocationList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @instance
                         */
                        InterconnectLocationList.prototype.kind = null;
    
                        /**
                         * InterconnectLocationList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @instance
                         */
                        InterconnectLocationList.prototype.nextPageToken = null;
    
                        /**
                         * InterconnectLocationList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @instance
                         */
                        InterconnectLocationList.prototype.selfLink = null;
    
                        /**
                         * InterconnectLocationList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @instance
                         */
                        InterconnectLocationList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InterconnectLocationList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocationList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectLocationList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocationList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectLocationList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocationList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectLocationList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocationList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectLocationList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocationList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InterconnectLocationList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectLocationList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InterconnectLocationList} InterconnectLocationList instance
                         */
                        InterconnectLocationList.create = function create(properties) {
                            return new InterconnectLocationList(properties);
                        };
    
                        /**
                         * Encodes the specified InterconnectLocationList message. Does not implicitly {@link google.cloud.compute.v1.InterconnectLocationList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectLocationList} message InterconnectLocationList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectLocationList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.InterconnectLocation.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InterconnectLocationList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InterconnectLocationList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectLocationList} message InterconnectLocationList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectLocationList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InterconnectLocationList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InterconnectLocationList} InterconnectLocationList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectLocationList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InterconnectLocationList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.InterconnectLocation.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InterconnectLocationList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InterconnectLocationList} InterconnectLocationList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectLocationList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InterconnectLocationList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InterconnectLocationList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InterconnectLocation.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InterconnectLocationList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InterconnectLocationList} InterconnectLocationList
                         */
                        InterconnectLocationList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InterconnectLocationList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InterconnectLocationList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.InterconnectLocationList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.InterconnectLocationList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.InterconnectLocation.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InterconnectLocationList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InterconnectLocationList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @static
                         * @param {google.cloud.compute.v1.InterconnectLocationList} message InterconnectLocationList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InterconnectLocationList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.InterconnectLocation.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InterconnectLocationList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InterconnectLocationList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InterconnectLocationList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InterconnectLocationList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InterconnectLocationList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InterconnectLocationList";
                        };
    
                        return InterconnectLocationList;
                    })();
    
                    v1.InterconnectLocationRegionInfo = (function() {
    
                        /**
                         * Properties of an InterconnectLocationRegionInfo.
                         * @memberof google.cloud.compute.v1
                         * @interface IInterconnectLocationRegionInfo
                         * @property {number|Long|null} [expectedRttMs] InterconnectLocationRegionInfo expectedRttMs
                         * @property {string|null} [locationPresence] InterconnectLocationRegionInfo locationPresence
                         * @property {string|null} [region] InterconnectLocationRegionInfo region
                         */
    
                        /**
                         * Constructs a new InterconnectLocationRegionInfo.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InterconnectLocationRegionInfo.
                         * @implements IInterconnectLocationRegionInfo
                         * @constructor
                         * @param {google.cloud.compute.v1.IInterconnectLocationRegionInfo=} [properties] Properties to set
                         */
                        function InterconnectLocationRegionInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InterconnectLocationRegionInfo expectedRttMs.
                         * @member {number|Long|null|undefined} expectedRttMs
                         * @memberof google.cloud.compute.v1.InterconnectLocationRegionInfo
                         * @instance
                         */
                        InterconnectLocationRegionInfo.prototype.expectedRttMs = null;
    
                        /**
                         * InterconnectLocationRegionInfo locationPresence.
                         * @member {string|null|undefined} locationPresence
                         * @memberof google.cloud.compute.v1.InterconnectLocationRegionInfo
                         * @instance
                         */
                        InterconnectLocationRegionInfo.prototype.locationPresence = null;
    
                        /**
                         * InterconnectLocationRegionInfo region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.InterconnectLocationRegionInfo
                         * @instance
                         */
                        InterconnectLocationRegionInfo.prototype.region = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InterconnectLocationRegionInfo _expectedRttMs.
                         * @member {"expectedRttMs"|undefined} _expectedRttMs
                         * @memberof google.cloud.compute.v1.InterconnectLocationRegionInfo
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocationRegionInfo.prototype, "_expectedRttMs", {
                            get: $util.oneOfGetter($oneOfFields = ["expectedRttMs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectLocationRegionInfo _locationPresence.
                         * @member {"locationPresence"|undefined} _locationPresence
                         * @memberof google.cloud.compute.v1.InterconnectLocationRegionInfo
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocationRegionInfo.prototype, "_locationPresence", {
                            get: $util.oneOfGetter($oneOfFields = ["locationPresence"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectLocationRegionInfo _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.InterconnectLocationRegionInfo
                         * @instance
                         */
                        Object.defineProperty(InterconnectLocationRegionInfo.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InterconnectLocationRegionInfo instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InterconnectLocationRegionInfo
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectLocationRegionInfo=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InterconnectLocationRegionInfo} InterconnectLocationRegionInfo instance
                         */
                        InterconnectLocationRegionInfo.create = function create(properties) {
                            return new InterconnectLocationRegionInfo(properties);
                        };
    
                        /**
                         * Encodes the specified InterconnectLocationRegionInfo message. Does not implicitly {@link google.cloud.compute.v1.InterconnectLocationRegionInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InterconnectLocationRegionInfo
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectLocationRegionInfo} message InterconnectLocationRegionInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectLocationRegionInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.locationPresence != null && Object.hasOwnProperty.call(message, "locationPresence"))
                                writer.uint32(/* id 101517893, wireType 2 =*/812143146).string(message.locationPresence);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.expectedRttMs != null && Object.hasOwnProperty.call(message, "expectedRttMs"))
                                writer.uint32(/* id 422543866, wireType 0 =*/3380350928).int64(message.expectedRttMs);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InterconnectLocationRegionInfo message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InterconnectLocationRegionInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectLocationRegionInfo
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectLocationRegionInfo} message InterconnectLocationRegionInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectLocationRegionInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InterconnectLocationRegionInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InterconnectLocationRegionInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InterconnectLocationRegionInfo} InterconnectLocationRegionInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectLocationRegionInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InterconnectLocationRegionInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 422543866: {
                                        message.expectedRttMs = reader.int64();
                                        break;
                                    }
                                case 101517893: {
                                        message.locationPresence = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InterconnectLocationRegionInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectLocationRegionInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InterconnectLocationRegionInfo} InterconnectLocationRegionInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectLocationRegionInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InterconnectLocationRegionInfo message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InterconnectLocationRegionInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InterconnectLocationRegionInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.expectedRttMs != null && message.hasOwnProperty("expectedRttMs")) {
                                properties._expectedRttMs = 1;
                                if (!$util.isInteger(message.expectedRttMs) && !(message.expectedRttMs && $util.isInteger(message.expectedRttMs.low) && $util.isInteger(message.expectedRttMs.high)))
                                    return "expectedRttMs: integer|Long expected";
                            }
                            if (message.locationPresence != null && message.hasOwnProperty("locationPresence")) {
                                properties._locationPresence = 1;
                                if (!$util.isString(message.locationPresence))
                                    return "locationPresence: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InterconnectLocationRegionInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InterconnectLocationRegionInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InterconnectLocationRegionInfo} InterconnectLocationRegionInfo
                         */
                        InterconnectLocationRegionInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InterconnectLocationRegionInfo)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InterconnectLocationRegionInfo();
                            if (object.expectedRttMs != null)
                                if ($util.Long)
                                    (message.expectedRttMs = $util.Long.fromValue(object.expectedRttMs)).unsigned = false;
                                else if (typeof object.expectedRttMs === "string")
                                    message.expectedRttMs = parseInt(object.expectedRttMs, 10);
                                else if (typeof object.expectedRttMs === "number")
                                    message.expectedRttMs = object.expectedRttMs;
                                else if (typeof object.expectedRttMs === "object")
                                    message.expectedRttMs = new $util.LongBits(object.expectedRttMs.low >>> 0, object.expectedRttMs.high >>> 0).toNumber();
                            if (object.locationPresence != null)
                                message.locationPresence = String(object.locationPresence);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InterconnectLocationRegionInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InterconnectLocationRegionInfo
                         * @static
                         * @param {google.cloud.compute.v1.InterconnectLocationRegionInfo} message InterconnectLocationRegionInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InterconnectLocationRegionInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.locationPresence != null && message.hasOwnProperty("locationPresence")) {
                                object.locationPresence = message.locationPresence;
                                if (options.oneofs)
                                    object._locationPresence = "locationPresence";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.expectedRttMs != null && message.hasOwnProperty("expectedRttMs")) {
                                if (typeof message.expectedRttMs === "number")
                                    object.expectedRttMs = options.longs === String ? String(message.expectedRttMs) : message.expectedRttMs;
                                else
                                    object.expectedRttMs = options.longs === String ? $util.Long.prototype.toString.call(message.expectedRttMs) : options.longs === Number ? new $util.LongBits(message.expectedRttMs.low >>> 0, message.expectedRttMs.high >>> 0).toNumber() : message.expectedRttMs;
                                if (options.oneofs)
                                    object._expectedRttMs = "expectedRttMs";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InterconnectLocationRegionInfo to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InterconnectLocationRegionInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InterconnectLocationRegionInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InterconnectLocationRegionInfo
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InterconnectLocationRegionInfo
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InterconnectLocationRegionInfo.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InterconnectLocationRegionInfo";
                        };
    
                        /**
                         * LocationPresence enum.
                         * @name google.cloud.compute.v1.InterconnectLocationRegionInfo.LocationPresence
                         * @enum {number}
                         * @property {number} UNDEFINED_LOCATION_PRESENCE=0 UNDEFINED_LOCATION_PRESENCE value
                         * @property {number} GLOBAL=494663587 GLOBAL value
                         * @property {number} LOCAL_REGION=403535464 LOCAL_REGION value
                         * @property {number} LP_GLOBAL=429584062 LP_GLOBAL value
                         * @property {number} LP_LOCAL_REGION=488598851 LP_LOCAL_REGION value
                         */
                        InterconnectLocationRegionInfo.LocationPresence = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_LOCATION_PRESENCE"] = 0;
                            values[valuesById[494663587] = "GLOBAL"] = 494663587;
                            values[valuesById[403535464] = "LOCAL_REGION"] = 403535464;
                            values[valuesById[429584062] = "LP_GLOBAL"] = 429584062;
                            values[valuesById[488598851] = "LP_LOCAL_REGION"] = 488598851;
                            return values;
                        })();
    
                        return InterconnectLocationRegionInfo;
                    })();
    
                    v1.InterconnectOutageNotification = (function() {
    
                        /**
                         * Properties of an InterconnectOutageNotification.
                         * @memberof google.cloud.compute.v1
                         * @interface IInterconnectOutageNotification
                         * @property {Array.<string>|null} [affectedCircuits] InterconnectOutageNotification affectedCircuits
                         * @property {string|null} [description] InterconnectOutageNotification description
                         * @property {number|Long|null} [endTime] InterconnectOutageNotification endTime
                         * @property {string|null} [issueType] InterconnectOutageNotification issueType
                         * @property {string|null} [name] InterconnectOutageNotification name
                         * @property {string|null} [source] InterconnectOutageNotification source
                         * @property {number|Long|null} [startTime] InterconnectOutageNotification startTime
                         * @property {string|null} [state] InterconnectOutageNotification state
                         */
    
                        /**
                         * Constructs a new InterconnectOutageNotification.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InterconnectOutageNotification.
                         * @implements IInterconnectOutageNotification
                         * @constructor
                         * @param {google.cloud.compute.v1.IInterconnectOutageNotification=} [properties] Properties to set
                         */
                        function InterconnectOutageNotification(properties) {
                            this.affectedCircuits = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InterconnectOutageNotification affectedCircuits.
                         * @member {Array.<string>} affectedCircuits
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @instance
                         */
                        InterconnectOutageNotification.prototype.affectedCircuits = $util.emptyArray;
    
                        /**
                         * InterconnectOutageNotification description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @instance
                         */
                        InterconnectOutageNotification.prototype.description = null;
    
                        /**
                         * InterconnectOutageNotification endTime.
                         * @member {number|Long|null|undefined} endTime
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @instance
                         */
                        InterconnectOutageNotification.prototype.endTime = null;
    
                        /**
                         * InterconnectOutageNotification issueType.
                         * @member {string|null|undefined} issueType
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @instance
                         */
                        InterconnectOutageNotification.prototype.issueType = null;
    
                        /**
                         * InterconnectOutageNotification name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @instance
                         */
                        InterconnectOutageNotification.prototype.name = null;
    
                        /**
                         * InterconnectOutageNotification source.
                         * @member {string|null|undefined} source
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @instance
                         */
                        InterconnectOutageNotification.prototype.source = null;
    
                        /**
                         * InterconnectOutageNotification startTime.
                         * @member {number|Long|null|undefined} startTime
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @instance
                         */
                        InterconnectOutageNotification.prototype.startTime = null;
    
                        /**
                         * InterconnectOutageNotification state.
                         * @member {string|null|undefined} state
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @instance
                         */
                        InterconnectOutageNotification.prototype.state = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InterconnectOutageNotification _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @instance
                         */
                        Object.defineProperty(InterconnectOutageNotification.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectOutageNotification _endTime.
                         * @member {"endTime"|undefined} _endTime
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @instance
                         */
                        Object.defineProperty(InterconnectOutageNotification.prototype, "_endTime", {
                            get: $util.oneOfGetter($oneOfFields = ["endTime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectOutageNotification _issueType.
                         * @member {"issueType"|undefined} _issueType
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @instance
                         */
                        Object.defineProperty(InterconnectOutageNotification.prototype, "_issueType", {
                            get: $util.oneOfGetter($oneOfFields = ["issueType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectOutageNotification _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @instance
                         */
                        Object.defineProperty(InterconnectOutageNotification.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectOutageNotification _source.
                         * @member {"source"|undefined} _source
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @instance
                         */
                        Object.defineProperty(InterconnectOutageNotification.prototype, "_source", {
                            get: $util.oneOfGetter($oneOfFields = ["source"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectOutageNotification _startTime.
                         * @member {"startTime"|undefined} _startTime
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @instance
                         */
                        Object.defineProperty(InterconnectOutageNotification.prototype, "_startTime", {
                            get: $util.oneOfGetter($oneOfFields = ["startTime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * InterconnectOutageNotification _state.
                         * @member {"state"|undefined} _state
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @instance
                         */
                        Object.defineProperty(InterconnectOutageNotification.prototype, "_state", {
                            get: $util.oneOfGetter($oneOfFields = ["state"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InterconnectOutageNotification instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectOutageNotification=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InterconnectOutageNotification} InterconnectOutageNotification instance
                         */
                        InterconnectOutageNotification.create = function create(properties) {
                            return new InterconnectOutageNotification(properties);
                        };
    
                        /**
                         * Encodes the specified InterconnectOutageNotification message. Does not implicitly {@link google.cloud.compute.v1.InterconnectOutageNotification.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectOutageNotification} message InterconnectOutageNotification message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectOutageNotification.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.startTime != null && Object.hasOwnProperty.call(message, "startTime"))
                                writer.uint32(/* id 37467274, wireType 0 =*/299738192).int64(message.startTime);
                            if (message.state != null && Object.hasOwnProperty.call(message, "state"))
                                writer.uint32(/* id 109757585, wireType 2 =*/878060682).string(message.state);
                            if (message.endTime != null && Object.hasOwnProperty.call(message, "endTime"))
                                writer.uint32(/* id 114938801, wireType 0 =*/919510408).int64(message.endTime);
                            if (message.source != null && Object.hasOwnProperty.call(message, "source"))
                                writer.uint32(/* id 177235995, wireType 2 =*/1417887962).string(message.source);
                            if (message.affectedCircuits != null && message.affectedCircuits.length)
                                for (var i = 0; i < message.affectedCircuits.length; ++i)
                                    writer.uint32(/* id 177717013, wireType 2 =*/1421736106).string(message.affectedCircuits[i]);
                            if (message.issueType != null && Object.hasOwnProperty.call(message, "issueType"))
                                writer.uint32(/* id 369639136, wireType 2 =*/2957113090).string(message.issueType);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InterconnectOutageNotification message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InterconnectOutageNotification.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectOutageNotification} message InterconnectOutageNotification message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectOutageNotification.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InterconnectOutageNotification message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InterconnectOutageNotification} InterconnectOutageNotification
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectOutageNotification.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InterconnectOutageNotification();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 177717013: {
                                        if (!(message.affectedCircuits && message.affectedCircuits.length))
                                            message.affectedCircuits = [];
                                        message.affectedCircuits.push(reader.string());
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 114938801: {
                                        message.endTime = reader.int64();
                                        break;
                                    }
                                case 369639136: {
                                        message.issueType = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 177235995: {
                                        message.source = reader.string();
                                        break;
                                    }
                                case 37467274: {
                                        message.startTime = reader.int64();
                                        break;
                                    }
                                case 109757585: {
                                        message.state = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InterconnectOutageNotification message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InterconnectOutageNotification} InterconnectOutageNotification
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectOutageNotification.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InterconnectOutageNotification message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InterconnectOutageNotification.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.affectedCircuits != null && message.hasOwnProperty("affectedCircuits")) {
                                if (!Array.isArray(message.affectedCircuits))
                                    return "affectedCircuits: array expected";
                                for (var i = 0; i < message.affectedCircuits.length; ++i)
                                    if (!$util.isString(message.affectedCircuits[i]))
                                        return "affectedCircuits: string[] expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.endTime != null && message.hasOwnProperty("endTime")) {
                                properties._endTime = 1;
                                if (!$util.isInteger(message.endTime) && !(message.endTime && $util.isInteger(message.endTime.low) && $util.isInteger(message.endTime.high)))
                                    return "endTime: integer|Long expected";
                            }
                            if (message.issueType != null && message.hasOwnProperty("issueType")) {
                                properties._issueType = 1;
                                if (!$util.isString(message.issueType))
                                    return "issueType: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.source != null && message.hasOwnProperty("source")) {
                                properties._source = 1;
                                if (!$util.isString(message.source))
                                    return "source: string expected";
                            }
                            if (message.startTime != null && message.hasOwnProperty("startTime")) {
                                properties._startTime = 1;
                                if (!$util.isInteger(message.startTime) && !(message.startTime && $util.isInteger(message.startTime.low) && $util.isInteger(message.startTime.high)))
                                    return "startTime: integer|Long expected";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                properties._state = 1;
                                if (!$util.isString(message.state))
                                    return "state: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InterconnectOutageNotification message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InterconnectOutageNotification} InterconnectOutageNotification
                         */
                        InterconnectOutageNotification.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InterconnectOutageNotification)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InterconnectOutageNotification();
                            if (object.affectedCircuits) {
                                if (!Array.isArray(object.affectedCircuits))
                                    throw TypeError(".google.cloud.compute.v1.InterconnectOutageNotification.affectedCircuits: array expected");
                                message.affectedCircuits = [];
                                for (var i = 0; i < object.affectedCircuits.length; ++i)
                                    message.affectedCircuits[i] = String(object.affectedCircuits[i]);
                            }
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.endTime != null)
                                if ($util.Long)
                                    (message.endTime = $util.Long.fromValue(object.endTime)).unsigned = false;
                                else if (typeof object.endTime === "string")
                                    message.endTime = parseInt(object.endTime, 10);
                                else if (typeof object.endTime === "number")
                                    message.endTime = object.endTime;
                                else if (typeof object.endTime === "object")
                                    message.endTime = new $util.LongBits(object.endTime.low >>> 0, object.endTime.high >>> 0).toNumber();
                            if (object.issueType != null)
                                message.issueType = String(object.issueType);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.source != null)
                                message.source = String(object.source);
                            if (object.startTime != null)
                                if ($util.Long)
                                    (message.startTime = $util.Long.fromValue(object.startTime)).unsigned = false;
                                else if (typeof object.startTime === "string")
                                    message.startTime = parseInt(object.startTime, 10);
                                else if (typeof object.startTime === "number")
                                    message.startTime = object.startTime;
                                else if (typeof object.startTime === "object")
                                    message.startTime = new $util.LongBits(object.startTime.low >>> 0, object.startTime.high >>> 0).toNumber();
                            if (object.state != null)
                                message.state = String(object.state);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InterconnectOutageNotification message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @static
                         * @param {google.cloud.compute.v1.InterconnectOutageNotification} message InterconnectOutageNotification
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InterconnectOutageNotification.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.affectedCircuits = [];
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.startTime != null && message.hasOwnProperty("startTime")) {
                                if (typeof message.startTime === "number")
                                    object.startTime = options.longs === String ? String(message.startTime) : message.startTime;
                                else
                                    object.startTime = options.longs === String ? $util.Long.prototype.toString.call(message.startTime) : options.longs === Number ? new $util.LongBits(message.startTime.low >>> 0, message.startTime.high >>> 0).toNumber() : message.startTime;
                                if (options.oneofs)
                                    object._startTime = "startTime";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                object.state = message.state;
                                if (options.oneofs)
                                    object._state = "state";
                            }
                            if (message.endTime != null && message.hasOwnProperty("endTime")) {
                                if (typeof message.endTime === "number")
                                    object.endTime = options.longs === String ? String(message.endTime) : message.endTime;
                                else
                                    object.endTime = options.longs === String ? $util.Long.prototype.toString.call(message.endTime) : options.longs === Number ? new $util.LongBits(message.endTime.low >>> 0, message.endTime.high >>> 0).toNumber() : message.endTime;
                                if (options.oneofs)
                                    object._endTime = "endTime";
                            }
                            if (message.source != null && message.hasOwnProperty("source")) {
                                object.source = message.source;
                                if (options.oneofs)
                                    object._source = "source";
                            }
                            if (message.affectedCircuits && message.affectedCircuits.length) {
                                object.affectedCircuits = [];
                                for (var j = 0; j < message.affectedCircuits.length; ++j)
                                    object.affectedCircuits[j] = message.affectedCircuits[j];
                            }
                            if (message.issueType != null && message.hasOwnProperty("issueType")) {
                                object.issueType = message.issueType;
                                if (options.oneofs)
                                    object._issueType = "issueType";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InterconnectOutageNotification to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InterconnectOutageNotification.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InterconnectOutageNotification
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InterconnectOutageNotification
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InterconnectOutageNotification.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InterconnectOutageNotification";
                        };
    
                        /**
                         * IssueType enum.
                         * @name google.cloud.compute.v1.InterconnectOutageNotification.IssueType
                         * @enum {number}
                         * @property {number} UNDEFINED_ISSUE_TYPE=0 UNDEFINED_ISSUE_TYPE value
                         * @property {number} IT_OUTAGE=175779973 IT_OUTAGE value
                         * @property {number} IT_PARTIAL_OUTAGE=92103971 IT_PARTIAL_OUTAGE value
                         * @property {number} OUTAGE=195285745 OUTAGE value
                         * @property {number} PARTIAL_OUTAGE=147053455 PARTIAL_OUTAGE value
                         */
                        InterconnectOutageNotification.IssueType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ISSUE_TYPE"] = 0;
                            values[valuesById[175779973] = "IT_OUTAGE"] = 175779973;
                            values[valuesById[92103971] = "IT_PARTIAL_OUTAGE"] = 92103971;
                            values[valuesById[195285745] = "OUTAGE"] = 195285745;
                            values[valuesById[147053455] = "PARTIAL_OUTAGE"] = 147053455;
                            return values;
                        })();
    
                        /**
                         * Source enum.
                         * @name google.cloud.compute.v1.InterconnectOutageNotification.Source
                         * @enum {number}
                         * @property {number} UNDEFINED_SOURCE=0 UNDEFINED_SOURCE value
                         * @property {number} GOOGLE=497439289 GOOGLE value
                         * @property {number} NSRC_GOOGLE=510574562 NSRC_GOOGLE value
                         */
                        InterconnectOutageNotification.Source = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_SOURCE"] = 0;
                            values[valuesById[497439289] = "GOOGLE"] = 497439289;
                            values[valuesById[510574562] = "NSRC_GOOGLE"] = 510574562;
                            return values;
                        })();
    
                        /**
                         * State enum.
                         * @name google.cloud.compute.v1.InterconnectOutageNotification.State
                         * @enum {number}
                         * @property {number} UNDEFINED_STATE=0 UNDEFINED_STATE value
                         * @property {number} ACTIVE=314733318 ACTIVE value
                         * @property {number} CANCELLED=41957681 CANCELLED value
                         * @property {number} COMPLETED=309921323 COMPLETED value
                         * @property {number} NS_ACTIVE=252563136 NS_ACTIVE value
                         * @property {number} NS_CANCELED=506579411 NS_CANCELED value
                         */
                        InterconnectOutageNotification.State = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATE"] = 0;
                            values[valuesById[314733318] = "ACTIVE"] = 314733318;
                            values[valuesById[41957681] = "CANCELLED"] = 41957681;
                            values[valuesById[309921323] = "COMPLETED"] = 309921323;
                            values[valuesById[252563136] = "NS_ACTIVE"] = 252563136;
                            values[valuesById[506579411] = "NS_CANCELED"] = 506579411;
                            return values;
                        })();
    
                        return InterconnectOutageNotification;
                    })();
    
                    v1.InterconnectsGetDiagnosticsResponse = (function() {
    
                        /**
                         * Properties of an InterconnectsGetDiagnosticsResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface IInterconnectsGetDiagnosticsResponse
                         * @property {google.cloud.compute.v1.IInterconnectDiagnostics|null} [result] InterconnectsGetDiagnosticsResponse result
                         */
    
                        /**
                         * Constructs a new InterconnectsGetDiagnosticsResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InterconnectsGetDiagnosticsResponse.
                         * @implements IInterconnectsGetDiagnosticsResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.IInterconnectsGetDiagnosticsResponse=} [properties] Properties to set
                         */
                        function InterconnectsGetDiagnosticsResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InterconnectsGetDiagnosticsResponse result.
                         * @member {google.cloud.compute.v1.IInterconnectDiagnostics|null|undefined} result
                         * @memberof google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse
                         * @instance
                         */
                        InterconnectsGetDiagnosticsResponse.prototype.result = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InterconnectsGetDiagnosticsResponse _result.
                         * @member {"result"|undefined} _result
                         * @memberof google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse
                         * @instance
                         */
                        Object.defineProperty(InterconnectsGetDiagnosticsResponse.prototype, "_result", {
                            get: $util.oneOfGetter($oneOfFields = ["result"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InterconnectsGetDiagnosticsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectsGetDiagnosticsResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse} InterconnectsGetDiagnosticsResponse instance
                         */
                        InterconnectsGetDiagnosticsResponse.create = function create(properties) {
                            return new InterconnectsGetDiagnosticsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified InterconnectsGetDiagnosticsResponse message. Does not implicitly {@link google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectsGetDiagnosticsResponse} message InterconnectsGetDiagnosticsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectsGetDiagnosticsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.result != null && Object.hasOwnProperty.call(message, "result"))
                                $root.google.cloud.compute.v1.InterconnectDiagnostics.encode(message.result, writer.uint32(/* id 139315229, wireType 2 =*/1114521834).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InterconnectsGetDiagnosticsResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse
                         * @static
                         * @param {google.cloud.compute.v1.IInterconnectsGetDiagnosticsResponse} message InterconnectsGetDiagnosticsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InterconnectsGetDiagnosticsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InterconnectsGetDiagnosticsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse} InterconnectsGetDiagnosticsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectsGetDiagnosticsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 139315229: {
                                        message.result = $root.google.cloud.compute.v1.InterconnectDiagnostics.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InterconnectsGetDiagnosticsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse} InterconnectsGetDiagnosticsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InterconnectsGetDiagnosticsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InterconnectsGetDiagnosticsResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InterconnectsGetDiagnosticsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.result != null && message.hasOwnProperty("result")) {
                                properties._result = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InterconnectDiagnostics.verify(message.result);
                                    if (error)
                                        return "result." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InterconnectsGetDiagnosticsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse} InterconnectsGetDiagnosticsResponse
                         */
                        InterconnectsGetDiagnosticsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse();
                            if (object.result != null) {
                                if (typeof object.result !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse.result: object expected");
                                message.result = $root.google.cloud.compute.v1.InterconnectDiagnostics.fromObject(object.result);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InterconnectsGetDiagnosticsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse
                         * @static
                         * @param {google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse} message InterconnectsGetDiagnosticsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InterconnectsGetDiagnosticsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.result != null && message.hasOwnProperty("result")) {
                                object.result = $root.google.cloud.compute.v1.InterconnectDiagnostics.toObject(message.result, options);
                                if (options.oneofs)
                                    object._result = "result";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this InterconnectsGetDiagnosticsResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InterconnectsGetDiagnosticsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InterconnectsGetDiagnosticsResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InterconnectsGetDiagnosticsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse";
                        };
    
                        return InterconnectsGetDiagnosticsResponse;
                    })();
    
                    v1.InvalidateCacheUrlMapRequest = (function() {
    
                        /**
                         * Properties of an InvalidateCacheUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IInvalidateCacheUrlMapRequest
                         * @property {google.cloud.compute.v1.ICacheInvalidationRule|null} [cacheInvalidationRuleResource] InvalidateCacheUrlMapRequest cacheInvalidationRuleResource
                         * @property {string|null} [project] InvalidateCacheUrlMapRequest project
                         * @property {string|null} [requestId] InvalidateCacheUrlMapRequest requestId
                         * @property {string|null} [urlMap] InvalidateCacheUrlMapRequest urlMap
                         */
    
                        /**
                         * Constructs a new InvalidateCacheUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InvalidateCacheUrlMapRequest.
                         * @implements IInvalidateCacheUrlMapRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IInvalidateCacheUrlMapRequest=} [properties] Properties to set
                         */
                        function InvalidateCacheUrlMapRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InvalidateCacheUrlMapRequest cacheInvalidationRuleResource.
                         * @member {google.cloud.compute.v1.ICacheInvalidationRule|null|undefined} cacheInvalidationRuleResource
                         * @memberof google.cloud.compute.v1.InvalidateCacheUrlMapRequest
                         * @instance
                         */
                        InvalidateCacheUrlMapRequest.prototype.cacheInvalidationRuleResource = null;
    
                        /**
                         * InvalidateCacheUrlMapRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.InvalidateCacheUrlMapRequest
                         * @instance
                         */
                        InvalidateCacheUrlMapRequest.prototype.project = "";
    
                        /**
                         * InvalidateCacheUrlMapRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.InvalidateCacheUrlMapRequest
                         * @instance
                         */
                        InvalidateCacheUrlMapRequest.prototype.requestId = null;
    
                        /**
                         * InvalidateCacheUrlMapRequest urlMap.
                         * @member {string} urlMap
                         * @memberof google.cloud.compute.v1.InvalidateCacheUrlMapRequest
                         * @instance
                         */
                        InvalidateCacheUrlMapRequest.prototype.urlMap = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InvalidateCacheUrlMapRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.InvalidateCacheUrlMapRequest
                         * @instance
                         */
                        Object.defineProperty(InvalidateCacheUrlMapRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InvalidateCacheUrlMapRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.InvalidateCacheUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInvalidateCacheUrlMapRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.InvalidateCacheUrlMapRequest} InvalidateCacheUrlMapRequest instance
                         */
                        InvalidateCacheUrlMapRequest.create = function create(properties) {
                            return new InvalidateCacheUrlMapRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InvalidateCacheUrlMapRequest message. Does not implicitly {@link google.cloud.compute.v1.InvalidateCacheUrlMapRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.InvalidateCacheUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInvalidateCacheUrlMapRequest} message InvalidateCacheUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InvalidateCacheUrlMapRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.cacheInvalidationRuleResource != null && Object.hasOwnProperty.call(message, "cacheInvalidationRuleResource"))
                                $root.google.cloud.compute.v1.CacheInvalidationRule.encode(message.cacheInvalidationRuleResource, writer.uint32(/* id 312795565, wireType 2 =*/2502364522).fork()).ldelim();
                            if (message.urlMap != null && Object.hasOwnProperty.call(message, "urlMap"))
                                writer.uint32(/* id 367020684, wireType 2 =*/2936165474).string(message.urlMap);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InvalidateCacheUrlMapRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.InvalidateCacheUrlMapRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.InvalidateCacheUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IInvalidateCacheUrlMapRequest} message InvalidateCacheUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InvalidateCacheUrlMapRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InvalidateCacheUrlMapRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.InvalidateCacheUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.InvalidateCacheUrlMapRequest} InvalidateCacheUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InvalidateCacheUrlMapRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.InvalidateCacheUrlMapRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 312795565: {
                                        message.cacheInvalidationRuleResource = $root.google.cloud.compute.v1.CacheInvalidationRule.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 367020684: {
                                        message.urlMap = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InvalidateCacheUrlMapRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.InvalidateCacheUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.InvalidateCacheUrlMapRequest} InvalidateCacheUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InvalidateCacheUrlMapRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InvalidateCacheUrlMapRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.InvalidateCacheUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InvalidateCacheUrlMapRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.cacheInvalidationRuleResource != null && message.hasOwnProperty("cacheInvalidationRuleResource")) {
                                var error = $root.google.cloud.compute.v1.CacheInvalidationRule.verify(message.cacheInvalidationRuleResource);
                                if (error)
                                    return "cacheInvalidationRuleResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                if (!$util.isString(message.urlMap))
                                    return "urlMap: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an InvalidateCacheUrlMapRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.InvalidateCacheUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.InvalidateCacheUrlMapRequest} InvalidateCacheUrlMapRequest
                         */
                        InvalidateCacheUrlMapRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.InvalidateCacheUrlMapRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.InvalidateCacheUrlMapRequest();
                            if (object.cacheInvalidationRuleResource != null) {
                                if (typeof object.cacheInvalidationRuleResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.InvalidateCacheUrlMapRequest.cacheInvalidationRuleResource: object expected");
                                message.cacheInvalidationRuleResource = $root.google.cloud.compute.v1.CacheInvalidationRule.fromObject(object.cacheInvalidationRuleResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.urlMap != null)
                                message.urlMap = String(object.urlMap);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InvalidateCacheUrlMapRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.InvalidateCacheUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.InvalidateCacheUrlMapRequest} message InvalidateCacheUrlMapRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InvalidateCacheUrlMapRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.cacheInvalidationRuleResource = null;
                                object.urlMap = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.cacheInvalidationRuleResource != null && message.hasOwnProperty("cacheInvalidationRuleResource"))
                                object.cacheInvalidationRuleResource = $root.google.cloud.compute.v1.CacheInvalidationRule.toObject(message.cacheInvalidationRuleResource, options);
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                object.urlMap = message.urlMap;
                            return object;
                        };
    
                        /**
                         * Converts this InvalidateCacheUrlMapRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.InvalidateCacheUrlMapRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InvalidateCacheUrlMapRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InvalidateCacheUrlMapRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.InvalidateCacheUrlMapRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InvalidateCacheUrlMapRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.InvalidateCacheUrlMapRequest";
                        };
    
                        return InvalidateCacheUrlMapRequest;
                    })();
    
                    v1.Items = (function() {
    
                        /**
                         * Properties of an Items.
                         * @memberof google.cloud.compute.v1
                         * @interface IItems
                         * @property {string|null} [key] Items key
                         * @property {string|null} [value] Items value
                         */
    
                        /**
                         * Constructs a new Items.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an Items.
                         * @implements IItems
                         * @constructor
                         * @param {google.cloud.compute.v1.IItems=} [properties] Properties to set
                         */
                        function Items(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Items key.
                         * @member {string|null|undefined} key
                         * @memberof google.cloud.compute.v1.Items
                         * @instance
                         */
                        Items.prototype.key = null;
    
                        /**
                         * Items value.
                         * @member {string|null|undefined} value
                         * @memberof google.cloud.compute.v1.Items
                         * @instance
                         */
                        Items.prototype.value = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Items _key.
                         * @member {"key"|undefined} _key
                         * @memberof google.cloud.compute.v1.Items
                         * @instance
                         */
                        Object.defineProperty(Items.prototype, "_key", {
                            get: $util.oneOfGetter($oneOfFields = ["key"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Items _value.
                         * @member {"value"|undefined} _value
                         * @memberof google.cloud.compute.v1.Items
                         * @instance
                         */
                        Object.defineProperty(Items.prototype, "_value", {
                            get: $util.oneOfGetter($oneOfFields = ["value"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Items instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Items
                         * @static
                         * @param {google.cloud.compute.v1.IItems=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Items} Items instance
                         */
                        Items.create = function create(properties) {
                            return new Items(properties);
                        };
    
                        /**
                         * Encodes the specified Items message. Does not implicitly {@link google.cloud.compute.v1.Items.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Items
                         * @static
                         * @param {google.cloud.compute.v1.IItems} message Items message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Items.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.key != null && Object.hasOwnProperty.call(message, "key"))
                                writer.uint32(/* id 106079, wireType 2 =*/848634).string(message.key);
                            if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                writer.uint32(/* id 111972721, wireType 2 =*/895781770).string(message.value);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Items message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Items.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Items
                         * @static
                         * @param {google.cloud.compute.v1.IItems} message Items message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Items.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Items message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Items
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Items} Items
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Items.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Items();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 106079: {
                                        message.key = reader.string();
                                        break;
                                    }
                                case 111972721: {
                                        message.value = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Items message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Items
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Items} Items
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Items.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Items message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Items
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Items.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.key != null && message.hasOwnProperty("key")) {
                                properties._key = 1;
                                if (!$util.isString(message.key))
                                    return "key: string expected";
                            }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                properties._value = 1;
                                if (!$util.isString(message.value))
                                    return "value: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an Items message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Items
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Items} Items
                         */
                        Items.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Items)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Items();
                            if (object.key != null)
                                message.key = String(object.key);
                            if (object.value != null)
                                message.value = String(object.value);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Items message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Items
                         * @static
                         * @param {google.cloud.compute.v1.Items} message Items
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Items.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.key != null && message.hasOwnProperty("key")) {
                                object.key = message.key;
                                if (options.oneofs)
                                    object._key = "key";
                            }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                object.value = message.value;
                                if (options.oneofs)
                                    object._value = "value";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Items to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Items
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Items.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Items
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Items
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Items.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Items";
                        };
    
                        return Items;
                    })();
    
                    v1.License = (function() {
    
                        /**
                         * Properties of a License.
                         * @memberof google.cloud.compute.v1
                         * @interface ILicense
                         * @property {boolean|null} [chargesUseFee] License chargesUseFee
                         * @property {string|null} [creationTimestamp] License creationTimestamp
                         * @property {string|null} [description] License description
                         * @property {number|Long|null} [id] License id
                         * @property {string|null} [kind] License kind
                         * @property {number|Long|null} [licenseCode] License licenseCode
                         * @property {string|null} [name] License name
                         * @property {google.cloud.compute.v1.ILicenseResourceRequirements|null} [resourceRequirements] License resourceRequirements
                         * @property {string|null} [selfLink] License selfLink
                         * @property {boolean|null} [transferable] License transferable
                         */
    
                        /**
                         * Constructs a new License.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a License.
                         * @implements ILicense
                         * @constructor
                         * @param {google.cloud.compute.v1.ILicense=} [properties] Properties to set
                         */
                        function License(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * License chargesUseFee.
                         * @member {boolean|null|undefined} chargesUseFee
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         */
                        License.prototype.chargesUseFee = null;
    
                        /**
                         * License creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         */
                        License.prototype.creationTimestamp = null;
    
                        /**
                         * License description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         */
                        License.prototype.description = null;
    
                        /**
                         * License id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         */
                        License.prototype.id = null;
    
                        /**
                         * License kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         */
                        License.prototype.kind = null;
    
                        /**
                         * License licenseCode.
                         * @member {number|Long|null|undefined} licenseCode
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         */
                        License.prototype.licenseCode = null;
    
                        /**
                         * License name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         */
                        License.prototype.name = null;
    
                        /**
                         * License resourceRequirements.
                         * @member {google.cloud.compute.v1.ILicenseResourceRequirements|null|undefined} resourceRequirements
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         */
                        License.prototype.resourceRequirements = null;
    
                        /**
                         * License selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         */
                        License.prototype.selfLink = null;
    
                        /**
                         * License transferable.
                         * @member {boolean|null|undefined} transferable
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         */
                        License.prototype.transferable = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * License _chargesUseFee.
                         * @member {"chargesUseFee"|undefined} _chargesUseFee
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         */
                        Object.defineProperty(License.prototype, "_chargesUseFee", {
                            get: $util.oneOfGetter($oneOfFields = ["chargesUseFee"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * License _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         */
                        Object.defineProperty(License.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * License _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         */
                        Object.defineProperty(License.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * License _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         */
                        Object.defineProperty(License.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * License _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         */
                        Object.defineProperty(License.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * License _licenseCode.
                         * @member {"licenseCode"|undefined} _licenseCode
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         */
                        Object.defineProperty(License.prototype, "_licenseCode", {
                            get: $util.oneOfGetter($oneOfFields = ["licenseCode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * License _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         */
                        Object.defineProperty(License.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * License _resourceRequirements.
                         * @member {"resourceRequirements"|undefined} _resourceRequirements
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         */
                        Object.defineProperty(License.prototype, "_resourceRequirements", {
                            get: $util.oneOfGetter($oneOfFields = ["resourceRequirements"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * License _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         */
                        Object.defineProperty(License.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * License _transferable.
                         * @member {"transferable"|undefined} _transferable
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         */
                        Object.defineProperty(License.prototype, "_transferable", {
                            get: $util.oneOfGetter($oneOfFields = ["transferable"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new License instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.License
                         * @static
                         * @param {google.cloud.compute.v1.ILicense=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.License} License instance
                         */
                        License.create = function create(properties) {
                            return new License(properties);
                        };
    
                        /**
                         * Encodes the specified License message. Does not implicitly {@link google.cloud.compute.v1.License.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.License
                         * @static
                         * @param {google.cloud.compute.v1.ILicense} message License message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        License.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.licenseCode != null && Object.hasOwnProperty.call(message, "licenseCode"))
                                writer.uint32(/* id 1467179, wireType 0 =*/11737432).uint64(message.licenseCode);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.transferable != null && Object.hasOwnProperty.call(message, "transferable"))
                                writer.uint32(/* id 4349893, wireType 0 =*/34799144).bool(message.transferable);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.resourceRequirements != null && Object.hasOwnProperty.call(message, "resourceRequirements"))
                                $root.google.cloud.compute.v1.LicenseResourceRequirements.encode(message.resourceRequirements, writer.uint32(/* id 214292769, wireType 2 =*/1714342154).fork()).ldelim();
                            if (message.chargesUseFee != null && Object.hasOwnProperty.call(message, "chargesUseFee"))
                                writer.uint32(/* id 372412622, wireType 0 =*/2979300976).bool(message.chargesUseFee);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified License message, length delimited. Does not implicitly {@link google.cloud.compute.v1.License.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.License
                         * @static
                         * @param {google.cloud.compute.v1.ILicense} message License message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        License.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a License message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.License
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.License} License
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        License.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.License();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 372412622: {
                                        message.chargesUseFee = reader.bool();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 1467179: {
                                        message.licenseCode = reader.uint64();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 214292769: {
                                        message.resourceRequirements = $root.google.cloud.compute.v1.LicenseResourceRequirements.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 4349893: {
                                        message.transferable = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a License message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.License
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.License} License
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        License.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a License message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.License
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        License.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.chargesUseFee != null && message.hasOwnProperty("chargesUseFee")) {
                                properties._chargesUseFee = 1;
                                if (typeof message.chargesUseFee !== "boolean")
                                    return "chargesUseFee: boolean expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.licenseCode != null && message.hasOwnProperty("licenseCode")) {
                                properties._licenseCode = 1;
                                if (!$util.isInteger(message.licenseCode) && !(message.licenseCode && $util.isInteger(message.licenseCode.low) && $util.isInteger(message.licenseCode.high)))
                                    return "licenseCode: integer|Long expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.resourceRequirements != null && message.hasOwnProperty("resourceRequirements")) {
                                properties._resourceRequirements = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.LicenseResourceRequirements.verify(message.resourceRequirements);
                                    if (error)
                                        return "resourceRequirements." + error;
                                }
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.transferable != null && message.hasOwnProperty("transferable")) {
                                properties._transferable = 1;
                                if (typeof message.transferable !== "boolean")
                                    return "transferable: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a License message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.License
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.License} License
                         */
                        License.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.License)
                                return object;
                            var message = new $root.google.cloud.compute.v1.License();
                            if (object.chargesUseFee != null)
                                message.chargesUseFee = Boolean(object.chargesUseFee);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.licenseCode != null)
                                if ($util.Long)
                                    (message.licenseCode = $util.Long.fromValue(object.licenseCode)).unsigned = true;
                                else if (typeof object.licenseCode === "string")
                                    message.licenseCode = parseInt(object.licenseCode, 10);
                                else if (typeof object.licenseCode === "number")
                                    message.licenseCode = object.licenseCode;
                                else if (typeof object.licenseCode === "object")
                                    message.licenseCode = new $util.LongBits(object.licenseCode.low >>> 0, object.licenseCode.high >>> 0).toNumber(true);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.resourceRequirements != null) {
                                if (typeof object.resourceRequirements !== "object")
                                    throw TypeError(".google.cloud.compute.v1.License.resourceRequirements: object expected");
                                message.resourceRequirements = $root.google.cloud.compute.v1.LicenseResourceRequirements.fromObject(object.resourceRequirements);
                            }
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.transferable != null)
                                message.transferable = Boolean(object.transferable);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a License message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.License
                         * @static
                         * @param {google.cloud.compute.v1.License} message License
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        License.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.licenseCode != null && message.hasOwnProperty("licenseCode")) {
                                if (typeof message.licenseCode === "number")
                                    object.licenseCode = options.longs === String ? String(message.licenseCode) : message.licenseCode;
                                else
                                    object.licenseCode = options.longs === String ? $util.Long.prototype.toString.call(message.licenseCode) : options.longs === Number ? new $util.LongBits(message.licenseCode.low >>> 0, message.licenseCode.high >>> 0).toNumber(true) : message.licenseCode;
                                if (options.oneofs)
                                    object._licenseCode = "licenseCode";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.transferable != null && message.hasOwnProperty("transferable")) {
                                object.transferable = message.transferable;
                                if (options.oneofs)
                                    object._transferable = "transferable";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.resourceRequirements != null && message.hasOwnProperty("resourceRequirements")) {
                                object.resourceRequirements = $root.google.cloud.compute.v1.LicenseResourceRequirements.toObject(message.resourceRequirements, options);
                                if (options.oneofs)
                                    object._resourceRequirements = "resourceRequirements";
                            }
                            if (message.chargesUseFee != null && message.hasOwnProperty("chargesUseFee")) {
                                object.chargesUseFee = message.chargesUseFee;
                                if (options.oneofs)
                                    object._chargesUseFee = "chargesUseFee";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this License to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.License
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        License.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for License
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.License
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        License.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.License";
                        };
    
                        return License;
                    })();
    
                    v1.LicenseCode = (function() {
    
                        /**
                         * Properties of a LicenseCode.
                         * @memberof google.cloud.compute.v1
                         * @interface ILicenseCode
                         * @property {string|null} [creationTimestamp] LicenseCode creationTimestamp
                         * @property {string|null} [description] LicenseCode description
                         * @property {number|Long|null} [id] LicenseCode id
                         * @property {string|null} [kind] LicenseCode kind
                         * @property {Array.<google.cloud.compute.v1.ILicenseCodeLicenseAlias>|null} [licenseAlias] LicenseCode licenseAlias
                         * @property {string|null} [name] LicenseCode name
                         * @property {string|null} [selfLink] LicenseCode selfLink
                         * @property {string|null} [state] LicenseCode state
                         * @property {boolean|null} [transferable] LicenseCode transferable
                         */
    
                        /**
                         * Constructs a new LicenseCode.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a LicenseCode.
                         * @implements ILicenseCode
                         * @constructor
                         * @param {google.cloud.compute.v1.ILicenseCode=} [properties] Properties to set
                         */
                        function LicenseCode(properties) {
                            this.licenseAlias = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * LicenseCode creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @instance
                         */
                        LicenseCode.prototype.creationTimestamp = null;
    
                        /**
                         * LicenseCode description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @instance
                         */
                        LicenseCode.prototype.description = null;
    
                        /**
                         * LicenseCode id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @instance
                         */
                        LicenseCode.prototype.id = null;
    
                        /**
                         * LicenseCode kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @instance
                         */
                        LicenseCode.prototype.kind = null;
    
                        /**
                         * LicenseCode licenseAlias.
                         * @member {Array.<google.cloud.compute.v1.ILicenseCodeLicenseAlias>} licenseAlias
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @instance
                         */
                        LicenseCode.prototype.licenseAlias = $util.emptyArray;
    
                        /**
                         * LicenseCode name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @instance
                         */
                        LicenseCode.prototype.name = null;
    
                        /**
                         * LicenseCode selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @instance
                         */
                        LicenseCode.prototype.selfLink = null;
    
                        /**
                         * LicenseCode state.
                         * @member {string|null|undefined} state
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @instance
                         */
                        LicenseCode.prototype.state = null;
    
                        /**
                         * LicenseCode transferable.
                         * @member {boolean|null|undefined} transferable
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @instance
                         */
                        LicenseCode.prototype.transferable = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * LicenseCode _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @instance
                         */
                        Object.defineProperty(LicenseCode.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LicenseCode _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @instance
                         */
                        Object.defineProperty(LicenseCode.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LicenseCode _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @instance
                         */
                        Object.defineProperty(LicenseCode.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LicenseCode _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @instance
                         */
                        Object.defineProperty(LicenseCode.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LicenseCode _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @instance
                         */
                        Object.defineProperty(LicenseCode.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LicenseCode _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @instance
                         */
                        Object.defineProperty(LicenseCode.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LicenseCode _state.
                         * @member {"state"|undefined} _state
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @instance
                         */
                        Object.defineProperty(LicenseCode.prototype, "_state", {
                            get: $util.oneOfGetter($oneOfFields = ["state"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LicenseCode _transferable.
                         * @member {"transferable"|undefined} _transferable
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @instance
                         */
                        Object.defineProperty(LicenseCode.prototype, "_transferable", {
                            get: $util.oneOfGetter($oneOfFields = ["transferable"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new LicenseCode instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @static
                         * @param {google.cloud.compute.v1.ILicenseCode=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.LicenseCode} LicenseCode instance
                         */
                        LicenseCode.create = function create(properties) {
                            return new LicenseCode(properties);
                        };
    
                        /**
                         * Encodes the specified LicenseCode message. Does not implicitly {@link google.cloud.compute.v1.LicenseCode.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @static
                         * @param {google.cloud.compute.v1.ILicenseCode} message LicenseCode message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LicenseCode.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.transferable != null && Object.hasOwnProperty.call(message, "transferable"))
                                writer.uint32(/* id 4349893, wireType 0 =*/34799144).bool(message.transferable);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.licenseAlias != null && message.licenseAlias.length)
                                for (var i = 0; i < message.licenseAlias.length; ++i)
                                    $root.google.cloud.compute.v1.LicenseCodeLicenseAlias.encode(message.licenseAlias[i], writer.uint32(/* id 43550930, wireType 2 =*/348407442).fork()).ldelim();
                            if (message.state != null && Object.hasOwnProperty.call(message, "state"))
                                writer.uint32(/* id 109757585, wireType 2 =*/878060682).string(message.state);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified LicenseCode message, length delimited. Does not implicitly {@link google.cloud.compute.v1.LicenseCode.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @static
                         * @param {google.cloud.compute.v1.ILicenseCode} message LicenseCode message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LicenseCode.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a LicenseCode message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.LicenseCode} LicenseCode
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LicenseCode.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.LicenseCode();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 43550930: {
                                        if (!(message.licenseAlias && message.licenseAlias.length))
                                            message.licenseAlias = [];
                                        message.licenseAlias.push($root.google.cloud.compute.v1.LicenseCodeLicenseAlias.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 109757585: {
                                        message.state = reader.string();
                                        break;
                                    }
                                case 4349893: {
                                        message.transferable = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a LicenseCode message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.LicenseCode} LicenseCode
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LicenseCode.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a LicenseCode message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LicenseCode.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.licenseAlias != null && message.hasOwnProperty("licenseAlias")) {
                                if (!Array.isArray(message.licenseAlias))
                                    return "licenseAlias: array expected";
                                for (var i = 0; i < message.licenseAlias.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.LicenseCodeLicenseAlias.verify(message.licenseAlias[i]);
                                    if (error)
                                        return "licenseAlias." + error;
                                }
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                properties._state = 1;
                                if (!$util.isString(message.state))
                                    return "state: string expected";
                            }
                            if (message.transferable != null && message.hasOwnProperty("transferable")) {
                                properties._transferable = 1;
                                if (typeof message.transferable !== "boolean")
                                    return "transferable: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a LicenseCode message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.LicenseCode} LicenseCode
                         */
                        LicenseCode.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.LicenseCode)
                                return object;
                            var message = new $root.google.cloud.compute.v1.LicenseCode();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.licenseAlias) {
                                if (!Array.isArray(object.licenseAlias))
                                    throw TypeError(".google.cloud.compute.v1.LicenseCode.licenseAlias: array expected");
                                message.licenseAlias = [];
                                for (var i = 0; i < object.licenseAlias.length; ++i) {
                                    if (typeof object.licenseAlias[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.LicenseCode.licenseAlias: object expected");
                                    message.licenseAlias[i] = $root.google.cloud.compute.v1.LicenseCodeLicenseAlias.fromObject(object.licenseAlias[i]);
                                }
                            }
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.state != null)
                                message.state = String(object.state);
                            if (object.transferable != null)
                                message.transferable = Boolean(object.transferable);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a LicenseCode message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @static
                         * @param {google.cloud.compute.v1.LicenseCode} message LicenseCode
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LicenseCode.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.licenseAlias = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.transferable != null && message.hasOwnProperty("transferable")) {
                                object.transferable = message.transferable;
                                if (options.oneofs)
                                    object._transferable = "transferable";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.licenseAlias && message.licenseAlias.length) {
                                object.licenseAlias = [];
                                for (var j = 0; j < message.licenseAlias.length; ++j)
                                    object.licenseAlias[j] = $root.google.cloud.compute.v1.LicenseCodeLicenseAlias.toObject(message.licenseAlias[j], options);
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                object.state = message.state;
                                if (options.oneofs)
                                    object._state = "state";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this LicenseCode to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LicenseCode.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for LicenseCode
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.LicenseCode
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        LicenseCode.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.LicenseCode";
                        };
    
                        /**
                         * State enum.
                         * @name google.cloud.compute.v1.LicenseCode.State
                         * @enum {number}
                         * @property {number} UNDEFINED_STATE=0 UNDEFINED_STATE value
                         * @property {number} DISABLED=516696700 DISABLED value
                         * @property {number} ENABLED=182130465 ENABLED value
                         * @property {number} RESTRICTED=261551195 RESTRICTED value
                         * @property {number} STATE_UNSPECIFIED=470755401 STATE_UNSPECIFIED value
                         * @property {number} TERMINATED=250018339 TERMINATED value
                         */
                        LicenseCode.State = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATE"] = 0;
                            values[valuesById[516696700] = "DISABLED"] = 516696700;
                            values[valuesById[182130465] = "ENABLED"] = 182130465;
                            values[valuesById[261551195] = "RESTRICTED"] = 261551195;
                            values[valuesById[470755401] = "STATE_UNSPECIFIED"] = 470755401;
                            values[valuesById[250018339] = "TERMINATED"] = 250018339;
                            return values;
                        })();
    
                        return LicenseCode;
                    })();
    
                    v1.LicenseCodeLicenseAlias = (function() {
    
                        /**
                         * Properties of a LicenseCodeLicenseAlias.
                         * @memberof google.cloud.compute.v1
                         * @interface ILicenseCodeLicenseAlias
                         * @property {string|null} [description] LicenseCodeLicenseAlias description
                         * @property {string|null} [selfLink] LicenseCodeLicenseAlias selfLink
                         */
    
                        /**
                         * Constructs a new LicenseCodeLicenseAlias.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a LicenseCodeLicenseAlias.
                         * @implements ILicenseCodeLicenseAlias
                         * @constructor
                         * @param {google.cloud.compute.v1.ILicenseCodeLicenseAlias=} [properties] Properties to set
                         */
                        function LicenseCodeLicenseAlias(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * LicenseCodeLicenseAlias description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.LicenseCodeLicenseAlias
                         * @instance
                         */
                        LicenseCodeLicenseAlias.prototype.description = null;
    
                        /**
                         * LicenseCodeLicenseAlias selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.LicenseCodeLicenseAlias
                         * @instance
                         */
                        LicenseCodeLicenseAlias.prototype.selfLink = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * LicenseCodeLicenseAlias _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.LicenseCodeLicenseAlias
                         * @instance
                         */
                        Object.defineProperty(LicenseCodeLicenseAlias.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LicenseCodeLicenseAlias _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.LicenseCodeLicenseAlias
                         * @instance
                         */
                        Object.defineProperty(LicenseCodeLicenseAlias.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new LicenseCodeLicenseAlias instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.LicenseCodeLicenseAlias
                         * @static
                         * @param {google.cloud.compute.v1.ILicenseCodeLicenseAlias=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.LicenseCodeLicenseAlias} LicenseCodeLicenseAlias instance
                         */
                        LicenseCodeLicenseAlias.create = function create(properties) {
                            return new LicenseCodeLicenseAlias(properties);
                        };
    
                        /**
                         * Encodes the specified LicenseCodeLicenseAlias message. Does not implicitly {@link google.cloud.compute.v1.LicenseCodeLicenseAlias.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.LicenseCodeLicenseAlias
                         * @static
                         * @param {google.cloud.compute.v1.ILicenseCodeLicenseAlias} message LicenseCodeLicenseAlias message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LicenseCodeLicenseAlias.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified LicenseCodeLicenseAlias message, length delimited. Does not implicitly {@link google.cloud.compute.v1.LicenseCodeLicenseAlias.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.LicenseCodeLicenseAlias
                         * @static
                         * @param {google.cloud.compute.v1.ILicenseCodeLicenseAlias} message LicenseCodeLicenseAlias message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LicenseCodeLicenseAlias.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a LicenseCodeLicenseAlias message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.LicenseCodeLicenseAlias
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.LicenseCodeLicenseAlias} LicenseCodeLicenseAlias
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LicenseCodeLicenseAlias.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.LicenseCodeLicenseAlias();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a LicenseCodeLicenseAlias message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.LicenseCodeLicenseAlias
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.LicenseCodeLicenseAlias} LicenseCodeLicenseAlias
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LicenseCodeLicenseAlias.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a LicenseCodeLicenseAlias message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.LicenseCodeLicenseAlias
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LicenseCodeLicenseAlias.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a LicenseCodeLicenseAlias message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.LicenseCodeLicenseAlias
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.LicenseCodeLicenseAlias} LicenseCodeLicenseAlias
                         */
                        LicenseCodeLicenseAlias.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.LicenseCodeLicenseAlias)
                                return object;
                            var message = new $root.google.cloud.compute.v1.LicenseCodeLicenseAlias();
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a LicenseCodeLicenseAlias message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.LicenseCodeLicenseAlias
                         * @static
                         * @param {google.cloud.compute.v1.LicenseCodeLicenseAlias} message LicenseCodeLicenseAlias
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LicenseCodeLicenseAlias.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this LicenseCodeLicenseAlias to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.LicenseCodeLicenseAlias
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LicenseCodeLicenseAlias.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for LicenseCodeLicenseAlias
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.LicenseCodeLicenseAlias
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        LicenseCodeLicenseAlias.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.LicenseCodeLicenseAlias";
                        };
    
                        return LicenseCodeLicenseAlias;
                    })();
    
                    v1.LicenseResourceCommitment = (function() {
    
                        /**
                         * Properties of a LicenseResourceCommitment.
                         * @memberof google.cloud.compute.v1
                         * @interface ILicenseResourceCommitment
                         * @property {number|Long|null} [amount] LicenseResourceCommitment amount
                         * @property {string|null} [coresPerLicense] LicenseResourceCommitment coresPerLicense
                         * @property {string|null} [license] LicenseResourceCommitment license
                         */
    
                        /**
                         * Constructs a new LicenseResourceCommitment.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a LicenseResourceCommitment.
                         * @implements ILicenseResourceCommitment
                         * @constructor
                         * @param {google.cloud.compute.v1.ILicenseResourceCommitment=} [properties] Properties to set
                         */
                        function LicenseResourceCommitment(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * LicenseResourceCommitment amount.
                         * @member {number|Long|null|undefined} amount
                         * @memberof google.cloud.compute.v1.LicenseResourceCommitment
                         * @instance
                         */
                        LicenseResourceCommitment.prototype.amount = null;
    
                        /**
                         * LicenseResourceCommitment coresPerLicense.
                         * @member {string|null|undefined} coresPerLicense
                         * @memberof google.cloud.compute.v1.LicenseResourceCommitment
                         * @instance
                         */
                        LicenseResourceCommitment.prototype.coresPerLicense = null;
    
                        /**
                         * LicenseResourceCommitment license.
                         * @member {string|null|undefined} license
                         * @memberof google.cloud.compute.v1.LicenseResourceCommitment
                         * @instance
                         */
                        LicenseResourceCommitment.prototype.license = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * LicenseResourceCommitment _amount.
                         * @member {"amount"|undefined} _amount
                         * @memberof google.cloud.compute.v1.LicenseResourceCommitment
                         * @instance
                         */
                        Object.defineProperty(LicenseResourceCommitment.prototype, "_amount", {
                            get: $util.oneOfGetter($oneOfFields = ["amount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LicenseResourceCommitment _coresPerLicense.
                         * @member {"coresPerLicense"|undefined} _coresPerLicense
                         * @memberof google.cloud.compute.v1.LicenseResourceCommitment
                         * @instance
                         */
                        Object.defineProperty(LicenseResourceCommitment.prototype, "_coresPerLicense", {
                            get: $util.oneOfGetter($oneOfFields = ["coresPerLicense"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LicenseResourceCommitment _license.
                         * @member {"license"|undefined} _license
                         * @memberof google.cloud.compute.v1.LicenseResourceCommitment
                         * @instance
                         */
                        Object.defineProperty(LicenseResourceCommitment.prototype, "_license", {
                            get: $util.oneOfGetter($oneOfFields = ["license"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new LicenseResourceCommitment instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.LicenseResourceCommitment
                         * @static
                         * @param {google.cloud.compute.v1.ILicenseResourceCommitment=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.LicenseResourceCommitment} LicenseResourceCommitment instance
                         */
                        LicenseResourceCommitment.create = function create(properties) {
                            return new LicenseResourceCommitment(properties);
                        };
    
                        /**
                         * Encodes the specified LicenseResourceCommitment message. Does not implicitly {@link google.cloud.compute.v1.LicenseResourceCommitment.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.LicenseResourceCommitment
                         * @static
                         * @param {google.cloud.compute.v1.ILicenseResourceCommitment} message LicenseResourceCommitment message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LicenseResourceCommitment.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.coresPerLicense != null && Object.hasOwnProperty.call(message, "coresPerLicense"))
                                writer.uint32(/* id 32482324, wireType 2 =*/259858594).string(message.coresPerLicense);
                            if (message.license != null && Object.hasOwnProperty.call(message, "license"))
                                writer.uint32(/* id 166757441, wireType 2 =*/1334059530).string(message.license);
                            if (message.amount != null && Object.hasOwnProperty.call(message, "amount"))
                                writer.uint32(/* id 196759640, wireType 0 =*/1574077120).int64(message.amount);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified LicenseResourceCommitment message, length delimited. Does not implicitly {@link google.cloud.compute.v1.LicenseResourceCommitment.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.LicenseResourceCommitment
                         * @static
                         * @param {google.cloud.compute.v1.ILicenseResourceCommitment} message LicenseResourceCommitment message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LicenseResourceCommitment.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a LicenseResourceCommitment message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.LicenseResourceCommitment
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.LicenseResourceCommitment} LicenseResourceCommitment
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LicenseResourceCommitment.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.LicenseResourceCommitment();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 196759640: {
                                        message.amount = reader.int64();
                                        break;
                                    }
                                case 32482324: {
                                        message.coresPerLicense = reader.string();
                                        break;
                                    }
                                case 166757441: {
                                        message.license = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a LicenseResourceCommitment message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.LicenseResourceCommitment
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.LicenseResourceCommitment} LicenseResourceCommitment
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LicenseResourceCommitment.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a LicenseResourceCommitment message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.LicenseResourceCommitment
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LicenseResourceCommitment.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.amount != null && message.hasOwnProperty("amount")) {
                                properties._amount = 1;
                                if (!$util.isInteger(message.amount) && !(message.amount && $util.isInteger(message.amount.low) && $util.isInteger(message.amount.high)))
                                    return "amount: integer|Long expected";
                            }
                            if (message.coresPerLicense != null && message.hasOwnProperty("coresPerLicense")) {
                                properties._coresPerLicense = 1;
                                if (!$util.isString(message.coresPerLicense))
                                    return "coresPerLicense: string expected";
                            }
                            if (message.license != null && message.hasOwnProperty("license")) {
                                properties._license = 1;
                                if (!$util.isString(message.license))
                                    return "license: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a LicenseResourceCommitment message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.LicenseResourceCommitment
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.LicenseResourceCommitment} LicenseResourceCommitment
                         */
                        LicenseResourceCommitment.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.LicenseResourceCommitment)
                                return object;
                            var message = new $root.google.cloud.compute.v1.LicenseResourceCommitment();
                            if (object.amount != null)
                                if ($util.Long)
                                    (message.amount = $util.Long.fromValue(object.amount)).unsigned = false;
                                else if (typeof object.amount === "string")
                                    message.amount = parseInt(object.amount, 10);
                                else if (typeof object.amount === "number")
                                    message.amount = object.amount;
                                else if (typeof object.amount === "object")
                                    message.amount = new $util.LongBits(object.amount.low >>> 0, object.amount.high >>> 0).toNumber();
                            if (object.coresPerLicense != null)
                                message.coresPerLicense = String(object.coresPerLicense);
                            if (object.license != null)
                                message.license = String(object.license);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a LicenseResourceCommitment message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.LicenseResourceCommitment
                         * @static
                         * @param {google.cloud.compute.v1.LicenseResourceCommitment} message LicenseResourceCommitment
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LicenseResourceCommitment.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.coresPerLicense != null && message.hasOwnProperty("coresPerLicense")) {
                                object.coresPerLicense = message.coresPerLicense;
                                if (options.oneofs)
                                    object._coresPerLicense = "coresPerLicense";
                            }
                            if (message.license != null && message.hasOwnProperty("license")) {
                                object.license = message.license;
                                if (options.oneofs)
                                    object._license = "license";
                            }
                            if (message.amount != null && message.hasOwnProperty("amount")) {
                                if (typeof message.amount === "number")
                                    object.amount = options.longs === String ? String(message.amount) : message.amount;
                                else
                                    object.amount = options.longs === String ? $util.Long.prototype.toString.call(message.amount) : options.longs === Number ? new $util.LongBits(message.amount.low >>> 0, message.amount.high >>> 0).toNumber() : message.amount;
                                if (options.oneofs)
                                    object._amount = "amount";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this LicenseResourceCommitment to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.LicenseResourceCommitment
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LicenseResourceCommitment.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for LicenseResourceCommitment
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.LicenseResourceCommitment
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        LicenseResourceCommitment.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.LicenseResourceCommitment";
                        };
    
                        return LicenseResourceCommitment;
                    })();
    
                    v1.LicenseResourceRequirements = (function() {
    
                        /**
                         * Properties of a LicenseResourceRequirements.
                         * @memberof google.cloud.compute.v1
                         * @interface ILicenseResourceRequirements
                         * @property {number|null} [minGuestCpuCount] LicenseResourceRequirements minGuestCpuCount
                         * @property {number|null} [minMemoryMb] LicenseResourceRequirements minMemoryMb
                         */
    
                        /**
                         * Constructs a new LicenseResourceRequirements.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a LicenseResourceRequirements.
                         * @implements ILicenseResourceRequirements
                         * @constructor
                         * @param {google.cloud.compute.v1.ILicenseResourceRequirements=} [properties] Properties to set
                         */
                        function LicenseResourceRequirements(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * LicenseResourceRequirements minGuestCpuCount.
                         * @member {number|null|undefined} minGuestCpuCount
                         * @memberof google.cloud.compute.v1.LicenseResourceRequirements
                         * @instance
                         */
                        LicenseResourceRequirements.prototype.minGuestCpuCount = null;
    
                        /**
                         * LicenseResourceRequirements minMemoryMb.
                         * @member {number|null|undefined} minMemoryMb
                         * @memberof google.cloud.compute.v1.LicenseResourceRequirements
                         * @instance
                         */
                        LicenseResourceRequirements.prototype.minMemoryMb = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * LicenseResourceRequirements _minGuestCpuCount.
                         * @member {"minGuestCpuCount"|undefined} _minGuestCpuCount
                         * @memberof google.cloud.compute.v1.LicenseResourceRequirements
                         * @instance
                         */
                        Object.defineProperty(LicenseResourceRequirements.prototype, "_minGuestCpuCount", {
                            get: $util.oneOfGetter($oneOfFields = ["minGuestCpuCount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LicenseResourceRequirements _minMemoryMb.
                         * @member {"minMemoryMb"|undefined} _minMemoryMb
                         * @memberof google.cloud.compute.v1.LicenseResourceRequirements
                         * @instance
                         */
                        Object.defineProperty(LicenseResourceRequirements.prototype, "_minMemoryMb", {
                            get: $util.oneOfGetter($oneOfFields = ["minMemoryMb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new LicenseResourceRequirements instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.LicenseResourceRequirements
                         * @static
                         * @param {google.cloud.compute.v1.ILicenseResourceRequirements=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.LicenseResourceRequirements} LicenseResourceRequirements instance
                         */
                        LicenseResourceRequirements.create = function create(properties) {
                            return new LicenseResourceRequirements(properties);
                        };
    
                        /**
                         * Encodes the specified LicenseResourceRequirements message. Does not implicitly {@link google.cloud.compute.v1.LicenseResourceRequirements.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.LicenseResourceRequirements
                         * @static
                         * @param {google.cloud.compute.v1.ILicenseResourceRequirements} message LicenseResourceRequirements message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LicenseResourceRequirements.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.minGuestCpuCount != null && Object.hasOwnProperty.call(message, "minGuestCpuCount"))
                                writer.uint32(/* id 477964836, wireType 0 =*/3823718688).int32(message.minGuestCpuCount);
                            if (message.minMemoryMb != null && Object.hasOwnProperty.call(message, "minMemoryMb"))
                                writer.uint32(/* id 504785894, wireType 0 =*/4038287152).int32(message.minMemoryMb);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified LicenseResourceRequirements message, length delimited. Does not implicitly {@link google.cloud.compute.v1.LicenseResourceRequirements.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.LicenseResourceRequirements
                         * @static
                         * @param {google.cloud.compute.v1.ILicenseResourceRequirements} message LicenseResourceRequirements message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LicenseResourceRequirements.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a LicenseResourceRequirements message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.LicenseResourceRequirements
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.LicenseResourceRequirements} LicenseResourceRequirements
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LicenseResourceRequirements.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.LicenseResourceRequirements();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 477964836: {
                                        message.minGuestCpuCount = reader.int32();
                                        break;
                                    }
                                case 504785894: {
                                        message.minMemoryMb = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a LicenseResourceRequirements message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.LicenseResourceRequirements
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.LicenseResourceRequirements} LicenseResourceRequirements
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LicenseResourceRequirements.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a LicenseResourceRequirements message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.LicenseResourceRequirements
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LicenseResourceRequirements.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.minGuestCpuCount != null && message.hasOwnProperty("minGuestCpuCount")) {
                                properties._minGuestCpuCount = 1;
                                if (!$util.isInteger(message.minGuestCpuCount))
                                    return "minGuestCpuCount: integer expected";
                            }
                            if (message.minMemoryMb != null && message.hasOwnProperty("minMemoryMb")) {
                                properties._minMemoryMb = 1;
                                if (!$util.isInteger(message.minMemoryMb))
                                    return "minMemoryMb: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a LicenseResourceRequirements message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.LicenseResourceRequirements
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.LicenseResourceRequirements} LicenseResourceRequirements
                         */
                        LicenseResourceRequirements.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.LicenseResourceRequirements)
                                return object;
                            var message = new $root.google.cloud.compute.v1.LicenseResourceRequirements();
                            if (object.minGuestCpuCount != null)
                                message.minGuestCpuCount = object.minGuestCpuCount | 0;
                            if (object.minMemoryMb != null)
                                message.minMemoryMb = object.minMemoryMb | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a LicenseResourceRequirements message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.LicenseResourceRequirements
                         * @static
                         * @param {google.cloud.compute.v1.LicenseResourceRequirements} message LicenseResourceRequirements
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LicenseResourceRequirements.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.minGuestCpuCount != null && message.hasOwnProperty("minGuestCpuCount")) {
                                object.minGuestCpuCount = message.minGuestCpuCount;
                                if (options.oneofs)
                                    object._minGuestCpuCount = "minGuestCpuCount";
                            }
                            if (message.minMemoryMb != null && message.hasOwnProperty("minMemoryMb")) {
                                object.minMemoryMb = message.minMemoryMb;
                                if (options.oneofs)
                                    object._minMemoryMb = "minMemoryMb";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this LicenseResourceRequirements to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.LicenseResourceRequirements
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LicenseResourceRequirements.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for LicenseResourceRequirements
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.LicenseResourceRequirements
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        LicenseResourceRequirements.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.LicenseResourceRequirements";
                        };
    
                        return LicenseResourceRequirements;
                    })();
    
                    v1.LicensesListResponse = (function() {
    
                        /**
                         * Properties of a LicensesListResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface ILicensesListResponse
                         * @property {string|null} [id] LicensesListResponse id
                         * @property {Array.<google.cloud.compute.v1.ILicense>|null} [items] LicensesListResponse items
                         * @property {string|null} [nextPageToken] LicensesListResponse nextPageToken
                         * @property {string|null} [selfLink] LicensesListResponse selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] LicensesListResponse warning
                         */
    
                        /**
                         * Constructs a new LicensesListResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a LicensesListResponse.
                         * @implements ILicensesListResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.ILicensesListResponse=} [properties] Properties to set
                         */
                        function LicensesListResponse(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * LicensesListResponse id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.LicensesListResponse
                         * @instance
                         */
                        LicensesListResponse.prototype.id = null;
    
                        /**
                         * LicensesListResponse items.
                         * @member {Array.<google.cloud.compute.v1.ILicense>} items
                         * @memberof google.cloud.compute.v1.LicensesListResponse
                         * @instance
                         */
                        LicensesListResponse.prototype.items = $util.emptyArray;
    
                        /**
                         * LicensesListResponse nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.LicensesListResponse
                         * @instance
                         */
                        LicensesListResponse.prototype.nextPageToken = null;
    
                        /**
                         * LicensesListResponse selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.LicensesListResponse
                         * @instance
                         */
                        LicensesListResponse.prototype.selfLink = null;
    
                        /**
                         * LicensesListResponse warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.LicensesListResponse
                         * @instance
                         */
                        LicensesListResponse.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * LicensesListResponse _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.LicensesListResponse
                         * @instance
                         */
                        Object.defineProperty(LicensesListResponse.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LicensesListResponse _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.LicensesListResponse
                         * @instance
                         */
                        Object.defineProperty(LicensesListResponse.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LicensesListResponse _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.LicensesListResponse
                         * @instance
                         */
                        Object.defineProperty(LicensesListResponse.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LicensesListResponse _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.LicensesListResponse
                         * @instance
                         */
                        Object.defineProperty(LicensesListResponse.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new LicensesListResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.LicensesListResponse
                         * @static
                         * @param {google.cloud.compute.v1.ILicensesListResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.LicensesListResponse} LicensesListResponse instance
                         */
                        LicensesListResponse.create = function create(properties) {
                            return new LicensesListResponse(properties);
                        };
    
                        /**
                         * Encodes the specified LicensesListResponse message. Does not implicitly {@link google.cloud.compute.v1.LicensesListResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.LicensesListResponse
                         * @static
                         * @param {google.cloud.compute.v1.ILicensesListResponse} message LicensesListResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LicensesListResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.License.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified LicensesListResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.LicensesListResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.LicensesListResponse
                         * @static
                         * @param {google.cloud.compute.v1.ILicensesListResponse} message LicensesListResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LicensesListResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a LicensesListResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.LicensesListResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.LicensesListResponse} LicensesListResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LicensesListResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.LicensesListResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.License.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a LicensesListResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.LicensesListResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.LicensesListResponse} LicensesListResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LicensesListResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a LicensesListResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.LicensesListResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LicensesListResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.License.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a LicensesListResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.LicensesListResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.LicensesListResponse} LicensesListResponse
                         */
                        LicensesListResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.LicensesListResponse)
                                return object;
                            var message = new $root.google.cloud.compute.v1.LicensesListResponse();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.LicensesListResponse.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.LicensesListResponse.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.License.fromObject(object.items[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.LicensesListResponse.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a LicensesListResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.LicensesListResponse
                         * @static
                         * @param {google.cloud.compute.v1.LicensesListResponse} message LicensesListResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LicensesListResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.License.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this LicensesListResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.LicensesListResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LicensesListResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for LicensesListResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.LicensesListResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        LicensesListResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.LicensesListResponse";
                        };
    
                        return LicensesListResponse;
                    })();
    
                    v1.ListAcceleratorTypesRequest = (function() {
    
                        /**
                         * Properties of a ListAcceleratorTypesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListAcceleratorTypesRequest
                         * @property {string|null} [filter] ListAcceleratorTypesRequest filter
                         * @property {number|null} [maxResults] ListAcceleratorTypesRequest maxResults
                         * @property {string|null} [orderBy] ListAcceleratorTypesRequest orderBy
                         * @property {string|null} [pageToken] ListAcceleratorTypesRequest pageToken
                         * @property {string|null} [project] ListAcceleratorTypesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListAcceleratorTypesRequest returnPartialSuccess
                         * @property {string|null} [zone] ListAcceleratorTypesRequest zone
                         */
    
                        /**
                         * Constructs a new ListAcceleratorTypesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListAcceleratorTypesRequest.
                         * @implements IListAcceleratorTypesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListAcceleratorTypesRequest=} [properties] Properties to set
                         */
                        function ListAcceleratorTypesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAcceleratorTypesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @instance
                         */
                        ListAcceleratorTypesRequest.prototype.filter = null;
    
                        /**
                         * ListAcceleratorTypesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @instance
                         */
                        ListAcceleratorTypesRequest.prototype.maxResults = null;
    
                        /**
                         * ListAcceleratorTypesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @instance
                         */
                        ListAcceleratorTypesRequest.prototype.orderBy = null;
    
                        /**
                         * ListAcceleratorTypesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @instance
                         */
                        ListAcceleratorTypesRequest.prototype.pageToken = null;
    
                        /**
                         * ListAcceleratorTypesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @instance
                         */
                        ListAcceleratorTypesRequest.prototype.project = "";
    
                        /**
                         * ListAcceleratorTypesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @instance
                         */
                        ListAcceleratorTypesRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListAcceleratorTypesRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @instance
                         */
                        ListAcceleratorTypesRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListAcceleratorTypesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAcceleratorTypesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAcceleratorTypesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAcceleratorTypesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAcceleratorTypesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAcceleratorTypesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAcceleratorTypesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAcceleratorTypesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAcceleratorTypesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAcceleratorTypesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListAcceleratorTypesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListAcceleratorTypesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListAcceleratorTypesRequest} ListAcceleratorTypesRequest instance
                         */
                        ListAcceleratorTypesRequest.create = function create(properties) {
                            return new ListAcceleratorTypesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListAcceleratorTypesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListAcceleratorTypesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListAcceleratorTypesRequest} message ListAcceleratorTypesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAcceleratorTypesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAcceleratorTypesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListAcceleratorTypesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListAcceleratorTypesRequest} message ListAcceleratorTypesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAcceleratorTypesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAcceleratorTypesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListAcceleratorTypesRequest} ListAcceleratorTypesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAcceleratorTypesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListAcceleratorTypesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAcceleratorTypesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListAcceleratorTypesRequest} ListAcceleratorTypesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAcceleratorTypesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAcceleratorTypesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAcceleratorTypesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListAcceleratorTypesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListAcceleratorTypesRequest} ListAcceleratorTypesRequest
                         */
                        ListAcceleratorTypesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListAcceleratorTypesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListAcceleratorTypesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAcceleratorTypesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListAcceleratorTypesRequest} message ListAcceleratorTypesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAcceleratorTypesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListAcceleratorTypesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAcceleratorTypesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAcceleratorTypesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListAcceleratorTypesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAcceleratorTypesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListAcceleratorTypesRequest";
                        };
    
                        return ListAcceleratorTypesRequest;
                    })();
    
                    v1.ListAddressesRequest = (function() {
    
                        /**
                         * Properties of a ListAddressesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListAddressesRequest
                         * @property {string|null} [filter] ListAddressesRequest filter
                         * @property {number|null} [maxResults] ListAddressesRequest maxResults
                         * @property {string|null} [orderBy] ListAddressesRequest orderBy
                         * @property {string|null} [pageToken] ListAddressesRequest pageToken
                         * @property {string|null} [project] ListAddressesRequest project
                         * @property {string|null} [region] ListAddressesRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListAddressesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListAddressesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListAddressesRequest.
                         * @implements IListAddressesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListAddressesRequest=} [properties] Properties to set
                         */
                        function ListAddressesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAddressesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @instance
                         */
                        ListAddressesRequest.prototype.filter = null;
    
                        /**
                         * ListAddressesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @instance
                         */
                        ListAddressesRequest.prototype.maxResults = null;
    
                        /**
                         * ListAddressesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @instance
                         */
                        ListAddressesRequest.prototype.orderBy = null;
    
                        /**
                         * ListAddressesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @instance
                         */
                        ListAddressesRequest.prototype.pageToken = null;
    
                        /**
                         * ListAddressesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @instance
                         */
                        ListAddressesRequest.prototype.project = "";
    
                        /**
                         * ListAddressesRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @instance
                         */
                        ListAddressesRequest.prototype.region = "";
    
                        /**
                         * ListAddressesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @instance
                         */
                        ListAddressesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListAddressesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAddressesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAddressesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAddressesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAddressesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAddressesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAddressesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAddressesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAddressesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAddressesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListAddressesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListAddressesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListAddressesRequest} ListAddressesRequest instance
                         */
                        ListAddressesRequest.create = function create(properties) {
                            return new ListAddressesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListAddressesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListAddressesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListAddressesRequest} message ListAddressesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAddressesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAddressesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListAddressesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListAddressesRequest} message ListAddressesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAddressesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAddressesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListAddressesRequest} ListAddressesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAddressesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListAddressesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAddressesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListAddressesRequest} ListAddressesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAddressesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAddressesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAddressesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListAddressesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListAddressesRequest} ListAddressesRequest
                         */
                        ListAddressesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListAddressesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListAddressesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAddressesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListAddressesRequest} message ListAddressesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAddressesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListAddressesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAddressesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAddressesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListAddressesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAddressesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListAddressesRequest";
                        };
    
                        return ListAddressesRequest;
                    })();
    
                    v1.ListAssociationsFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a ListAssociationsFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListAssociationsFirewallPolicyRequest
                         * @property {string|null} [targetResource] ListAssociationsFirewallPolicyRequest targetResource
                         */
    
                        /**
                         * Constructs a new ListAssociationsFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListAssociationsFirewallPolicyRequest.
                         * @implements IListAssociationsFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListAssociationsFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function ListAssociationsFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAssociationsFirewallPolicyRequest targetResource.
                         * @member {string|null|undefined} targetResource
                         * @memberof google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest
                         * @instance
                         */
                        ListAssociationsFirewallPolicyRequest.prototype.targetResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListAssociationsFirewallPolicyRequest _targetResource.
                         * @member {"targetResource"|undefined} _targetResource
                         * @memberof google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(ListAssociationsFirewallPolicyRequest.prototype, "_targetResource", {
                            get: $util.oneOfGetter($oneOfFields = ["targetResource"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListAssociationsFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListAssociationsFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest} ListAssociationsFirewallPolicyRequest instance
                         */
                        ListAssociationsFirewallPolicyRequest.create = function create(properties) {
                            return new ListAssociationsFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListAssociationsFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListAssociationsFirewallPolicyRequest} message ListAssociationsFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAssociationsFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetResource != null && Object.hasOwnProperty.call(message, "targetResource"))
                                writer.uint32(/* id 467318524, wireType 2 =*/3738548194).string(message.targetResource);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAssociationsFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListAssociationsFirewallPolicyRequest} message ListAssociationsFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAssociationsFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAssociationsFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest} ListAssociationsFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAssociationsFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 467318524: {
                                        message.targetResource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAssociationsFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest} ListAssociationsFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAssociationsFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAssociationsFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAssociationsFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.targetResource != null && message.hasOwnProperty("targetResource")) {
                                properties._targetResource = 1;
                                if (!$util.isString(message.targetResource))
                                    return "targetResource: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListAssociationsFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest} ListAssociationsFirewallPolicyRequest
                         */
                        ListAssociationsFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest();
                            if (object.targetResource != null)
                                message.targetResource = String(object.targetResource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAssociationsFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest} message ListAssociationsFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAssociationsFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.targetResource != null && message.hasOwnProperty("targetResource")) {
                                object.targetResource = message.targetResource;
                                if (options.oneofs)
                                    object._targetResource = "targetResource";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListAssociationsFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAssociationsFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAssociationsFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAssociationsFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest";
                        };
    
                        return ListAssociationsFirewallPolicyRequest;
                    })();
    
                    v1.ListAutoscalersRequest = (function() {
    
                        /**
                         * Properties of a ListAutoscalersRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListAutoscalersRequest
                         * @property {string|null} [filter] ListAutoscalersRequest filter
                         * @property {number|null} [maxResults] ListAutoscalersRequest maxResults
                         * @property {string|null} [orderBy] ListAutoscalersRequest orderBy
                         * @property {string|null} [pageToken] ListAutoscalersRequest pageToken
                         * @property {string|null} [project] ListAutoscalersRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListAutoscalersRequest returnPartialSuccess
                         * @property {string|null} [zone] ListAutoscalersRequest zone
                         */
    
                        /**
                         * Constructs a new ListAutoscalersRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListAutoscalersRequest.
                         * @implements IListAutoscalersRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListAutoscalersRequest=} [properties] Properties to set
                         */
                        function ListAutoscalersRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAutoscalersRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @instance
                         */
                        ListAutoscalersRequest.prototype.filter = null;
    
                        /**
                         * ListAutoscalersRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @instance
                         */
                        ListAutoscalersRequest.prototype.maxResults = null;
    
                        /**
                         * ListAutoscalersRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @instance
                         */
                        ListAutoscalersRequest.prototype.orderBy = null;
    
                        /**
                         * ListAutoscalersRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @instance
                         */
                        ListAutoscalersRequest.prototype.pageToken = null;
    
                        /**
                         * ListAutoscalersRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @instance
                         */
                        ListAutoscalersRequest.prototype.project = "";
    
                        /**
                         * ListAutoscalersRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @instance
                         */
                        ListAutoscalersRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListAutoscalersRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @instance
                         */
                        ListAutoscalersRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListAutoscalersRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @instance
                         */
                        Object.defineProperty(ListAutoscalersRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAutoscalersRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @instance
                         */
                        Object.defineProperty(ListAutoscalersRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAutoscalersRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @instance
                         */
                        Object.defineProperty(ListAutoscalersRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAutoscalersRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @instance
                         */
                        Object.defineProperty(ListAutoscalersRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAutoscalersRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @instance
                         */
                        Object.defineProperty(ListAutoscalersRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListAutoscalersRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListAutoscalersRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListAutoscalersRequest} ListAutoscalersRequest instance
                         */
                        ListAutoscalersRequest.create = function create(properties) {
                            return new ListAutoscalersRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListAutoscalersRequest message. Does not implicitly {@link google.cloud.compute.v1.ListAutoscalersRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListAutoscalersRequest} message ListAutoscalersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAutoscalersRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAutoscalersRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListAutoscalersRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListAutoscalersRequest} message ListAutoscalersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAutoscalersRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAutoscalersRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListAutoscalersRequest} ListAutoscalersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAutoscalersRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListAutoscalersRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAutoscalersRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListAutoscalersRequest} ListAutoscalersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAutoscalersRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAutoscalersRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAutoscalersRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListAutoscalersRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListAutoscalersRequest} ListAutoscalersRequest
                         */
                        ListAutoscalersRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListAutoscalersRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListAutoscalersRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAutoscalersRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListAutoscalersRequest} message ListAutoscalersRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAutoscalersRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListAutoscalersRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAutoscalersRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAutoscalersRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListAutoscalersRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAutoscalersRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListAutoscalersRequest";
                        };
    
                        return ListAutoscalersRequest;
                    })();
    
                    v1.ListAvailableFeaturesRegionSslPoliciesRequest = (function() {
    
                        /**
                         * Properties of a ListAvailableFeaturesRegionSslPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListAvailableFeaturesRegionSslPoliciesRequest
                         * @property {string|null} [filter] ListAvailableFeaturesRegionSslPoliciesRequest filter
                         * @property {number|null} [maxResults] ListAvailableFeaturesRegionSslPoliciesRequest maxResults
                         * @property {string|null} [orderBy] ListAvailableFeaturesRegionSslPoliciesRequest orderBy
                         * @property {string|null} [pageToken] ListAvailableFeaturesRegionSslPoliciesRequest pageToken
                         * @property {string|null} [project] ListAvailableFeaturesRegionSslPoliciesRequest project
                         * @property {string|null} [region] ListAvailableFeaturesRegionSslPoliciesRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListAvailableFeaturesRegionSslPoliciesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListAvailableFeaturesRegionSslPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListAvailableFeaturesRegionSslPoliciesRequest.
                         * @implements IListAvailableFeaturesRegionSslPoliciesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListAvailableFeaturesRegionSslPoliciesRequest=} [properties] Properties to set
                         */
                        function ListAvailableFeaturesRegionSslPoliciesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAvailableFeaturesRegionSslPoliciesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @instance
                         */
                        ListAvailableFeaturesRegionSslPoliciesRequest.prototype.filter = null;
    
                        /**
                         * ListAvailableFeaturesRegionSslPoliciesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @instance
                         */
                        ListAvailableFeaturesRegionSslPoliciesRequest.prototype.maxResults = null;
    
                        /**
                         * ListAvailableFeaturesRegionSslPoliciesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @instance
                         */
                        ListAvailableFeaturesRegionSslPoliciesRequest.prototype.orderBy = null;
    
                        /**
                         * ListAvailableFeaturesRegionSslPoliciesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @instance
                         */
                        ListAvailableFeaturesRegionSslPoliciesRequest.prototype.pageToken = null;
    
                        /**
                         * ListAvailableFeaturesRegionSslPoliciesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @instance
                         */
                        ListAvailableFeaturesRegionSslPoliciesRequest.prototype.project = "";
    
                        /**
                         * ListAvailableFeaturesRegionSslPoliciesRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @instance
                         */
                        ListAvailableFeaturesRegionSslPoliciesRequest.prototype.region = "";
    
                        /**
                         * ListAvailableFeaturesRegionSslPoliciesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @instance
                         */
                        ListAvailableFeaturesRegionSslPoliciesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListAvailableFeaturesRegionSslPoliciesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAvailableFeaturesRegionSslPoliciesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAvailableFeaturesRegionSslPoliciesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAvailableFeaturesRegionSslPoliciesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAvailableFeaturesRegionSslPoliciesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAvailableFeaturesRegionSslPoliciesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAvailableFeaturesRegionSslPoliciesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAvailableFeaturesRegionSslPoliciesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAvailableFeaturesRegionSslPoliciesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAvailableFeaturesRegionSslPoliciesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListAvailableFeaturesRegionSslPoliciesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListAvailableFeaturesRegionSslPoliciesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest} ListAvailableFeaturesRegionSslPoliciesRequest instance
                         */
                        ListAvailableFeaturesRegionSslPoliciesRequest.create = function create(properties) {
                            return new ListAvailableFeaturesRegionSslPoliciesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListAvailableFeaturesRegionSslPoliciesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListAvailableFeaturesRegionSslPoliciesRequest} message ListAvailableFeaturesRegionSslPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAvailableFeaturesRegionSslPoliciesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAvailableFeaturesRegionSslPoliciesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListAvailableFeaturesRegionSslPoliciesRequest} message ListAvailableFeaturesRegionSslPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAvailableFeaturesRegionSslPoliciesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAvailableFeaturesRegionSslPoliciesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest} ListAvailableFeaturesRegionSslPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAvailableFeaturesRegionSslPoliciesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAvailableFeaturesRegionSslPoliciesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest} ListAvailableFeaturesRegionSslPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAvailableFeaturesRegionSslPoliciesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAvailableFeaturesRegionSslPoliciesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAvailableFeaturesRegionSslPoliciesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListAvailableFeaturesRegionSslPoliciesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest} ListAvailableFeaturesRegionSslPoliciesRequest
                         */
                        ListAvailableFeaturesRegionSslPoliciesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAvailableFeaturesRegionSslPoliciesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest} message ListAvailableFeaturesRegionSslPoliciesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAvailableFeaturesRegionSslPoliciesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListAvailableFeaturesRegionSslPoliciesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAvailableFeaturesRegionSslPoliciesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAvailableFeaturesRegionSslPoliciesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAvailableFeaturesRegionSslPoliciesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest";
                        };
    
                        return ListAvailableFeaturesRegionSslPoliciesRequest;
                    })();
    
                    v1.ListAvailableFeaturesSslPoliciesRequest = (function() {
    
                        /**
                         * Properties of a ListAvailableFeaturesSslPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListAvailableFeaturesSslPoliciesRequest
                         * @property {string|null} [filter] ListAvailableFeaturesSslPoliciesRequest filter
                         * @property {number|null} [maxResults] ListAvailableFeaturesSslPoliciesRequest maxResults
                         * @property {string|null} [orderBy] ListAvailableFeaturesSslPoliciesRequest orderBy
                         * @property {string|null} [pageToken] ListAvailableFeaturesSslPoliciesRequest pageToken
                         * @property {string|null} [project] ListAvailableFeaturesSslPoliciesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListAvailableFeaturesSslPoliciesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListAvailableFeaturesSslPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListAvailableFeaturesSslPoliciesRequest.
                         * @implements IListAvailableFeaturesSslPoliciesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListAvailableFeaturesSslPoliciesRequest=} [properties] Properties to set
                         */
                        function ListAvailableFeaturesSslPoliciesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAvailableFeaturesSslPoliciesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @instance
                         */
                        ListAvailableFeaturesSslPoliciesRequest.prototype.filter = null;
    
                        /**
                         * ListAvailableFeaturesSslPoliciesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @instance
                         */
                        ListAvailableFeaturesSslPoliciesRequest.prototype.maxResults = null;
    
                        /**
                         * ListAvailableFeaturesSslPoliciesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @instance
                         */
                        ListAvailableFeaturesSslPoliciesRequest.prototype.orderBy = null;
    
                        /**
                         * ListAvailableFeaturesSslPoliciesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @instance
                         */
                        ListAvailableFeaturesSslPoliciesRequest.prototype.pageToken = null;
    
                        /**
                         * ListAvailableFeaturesSslPoliciesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @instance
                         */
                        ListAvailableFeaturesSslPoliciesRequest.prototype.project = "";
    
                        /**
                         * ListAvailableFeaturesSslPoliciesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @instance
                         */
                        ListAvailableFeaturesSslPoliciesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListAvailableFeaturesSslPoliciesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAvailableFeaturesSslPoliciesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAvailableFeaturesSslPoliciesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAvailableFeaturesSslPoliciesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAvailableFeaturesSslPoliciesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAvailableFeaturesSslPoliciesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAvailableFeaturesSslPoliciesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAvailableFeaturesSslPoliciesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAvailableFeaturesSslPoliciesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAvailableFeaturesSslPoliciesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListAvailableFeaturesSslPoliciesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListAvailableFeaturesSslPoliciesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest} ListAvailableFeaturesSslPoliciesRequest instance
                         */
                        ListAvailableFeaturesSslPoliciesRequest.create = function create(properties) {
                            return new ListAvailableFeaturesSslPoliciesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListAvailableFeaturesSslPoliciesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListAvailableFeaturesSslPoliciesRequest} message ListAvailableFeaturesSslPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAvailableFeaturesSslPoliciesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAvailableFeaturesSslPoliciesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListAvailableFeaturesSslPoliciesRequest} message ListAvailableFeaturesSslPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAvailableFeaturesSslPoliciesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAvailableFeaturesSslPoliciesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest} ListAvailableFeaturesSslPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAvailableFeaturesSslPoliciesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAvailableFeaturesSslPoliciesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest} ListAvailableFeaturesSslPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAvailableFeaturesSslPoliciesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAvailableFeaturesSslPoliciesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAvailableFeaturesSslPoliciesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListAvailableFeaturesSslPoliciesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest} ListAvailableFeaturesSslPoliciesRequest
                         */
                        ListAvailableFeaturesSslPoliciesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAvailableFeaturesSslPoliciesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest} message ListAvailableFeaturesSslPoliciesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAvailableFeaturesSslPoliciesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListAvailableFeaturesSslPoliciesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAvailableFeaturesSslPoliciesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAvailableFeaturesSslPoliciesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAvailableFeaturesSslPoliciesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest";
                        };
    
                        return ListAvailableFeaturesSslPoliciesRequest;
                    })();
    
                    v1.ListBackendBucketsRequest = (function() {
    
                        /**
                         * Properties of a ListBackendBucketsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListBackendBucketsRequest
                         * @property {string|null} [filter] ListBackendBucketsRequest filter
                         * @property {number|null} [maxResults] ListBackendBucketsRequest maxResults
                         * @property {string|null} [orderBy] ListBackendBucketsRequest orderBy
                         * @property {string|null} [pageToken] ListBackendBucketsRequest pageToken
                         * @property {string|null} [project] ListBackendBucketsRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListBackendBucketsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListBackendBucketsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListBackendBucketsRequest.
                         * @implements IListBackendBucketsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListBackendBucketsRequest=} [properties] Properties to set
                         */
                        function ListBackendBucketsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListBackendBucketsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @instance
                         */
                        ListBackendBucketsRequest.prototype.filter = null;
    
                        /**
                         * ListBackendBucketsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @instance
                         */
                        ListBackendBucketsRequest.prototype.maxResults = null;
    
                        /**
                         * ListBackendBucketsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @instance
                         */
                        ListBackendBucketsRequest.prototype.orderBy = null;
    
                        /**
                         * ListBackendBucketsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @instance
                         */
                        ListBackendBucketsRequest.prototype.pageToken = null;
    
                        /**
                         * ListBackendBucketsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @instance
                         */
                        ListBackendBucketsRequest.prototype.project = "";
    
                        /**
                         * ListBackendBucketsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @instance
                         */
                        ListBackendBucketsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListBackendBucketsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @instance
                         */
                        Object.defineProperty(ListBackendBucketsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListBackendBucketsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @instance
                         */
                        Object.defineProperty(ListBackendBucketsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListBackendBucketsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @instance
                         */
                        Object.defineProperty(ListBackendBucketsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListBackendBucketsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @instance
                         */
                        Object.defineProperty(ListBackendBucketsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListBackendBucketsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @instance
                         */
                        Object.defineProperty(ListBackendBucketsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListBackendBucketsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListBackendBucketsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListBackendBucketsRequest} ListBackendBucketsRequest instance
                         */
                        ListBackendBucketsRequest.create = function create(properties) {
                            return new ListBackendBucketsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListBackendBucketsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListBackendBucketsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListBackendBucketsRequest} message ListBackendBucketsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListBackendBucketsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListBackendBucketsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListBackendBucketsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListBackendBucketsRequest} message ListBackendBucketsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListBackendBucketsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListBackendBucketsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListBackendBucketsRequest} ListBackendBucketsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListBackendBucketsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListBackendBucketsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListBackendBucketsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListBackendBucketsRequest} ListBackendBucketsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListBackendBucketsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListBackendBucketsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListBackendBucketsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListBackendBucketsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListBackendBucketsRequest} ListBackendBucketsRequest
                         */
                        ListBackendBucketsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListBackendBucketsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListBackendBucketsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListBackendBucketsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListBackendBucketsRequest} message ListBackendBucketsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListBackendBucketsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListBackendBucketsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListBackendBucketsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListBackendBucketsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListBackendBucketsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListBackendBucketsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListBackendBucketsRequest";
                        };
    
                        return ListBackendBucketsRequest;
                    })();
    
                    v1.ListBackendServicesRequest = (function() {
    
                        /**
                         * Properties of a ListBackendServicesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListBackendServicesRequest
                         * @property {string|null} [filter] ListBackendServicesRequest filter
                         * @property {number|null} [maxResults] ListBackendServicesRequest maxResults
                         * @property {string|null} [orderBy] ListBackendServicesRequest orderBy
                         * @property {string|null} [pageToken] ListBackendServicesRequest pageToken
                         * @property {string|null} [project] ListBackendServicesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListBackendServicesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListBackendServicesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListBackendServicesRequest.
                         * @implements IListBackendServicesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListBackendServicesRequest=} [properties] Properties to set
                         */
                        function ListBackendServicesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListBackendServicesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @instance
                         */
                        ListBackendServicesRequest.prototype.filter = null;
    
                        /**
                         * ListBackendServicesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @instance
                         */
                        ListBackendServicesRequest.prototype.maxResults = null;
    
                        /**
                         * ListBackendServicesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @instance
                         */
                        ListBackendServicesRequest.prototype.orderBy = null;
    
                        /**
                         * ListBackendServicesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @instance
                         */
                        ListBackendServicesRequest.prototype.pageToken = null;
    
                        /**
                         * ListBackendServicesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @instance
                         */
                        ListBackendServicesRequest.prototype.project = "";
    
                        /**
                         * ListBackendServicesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @instance
                         */
                        ListBackendServicesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListBackendServicesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @instance
                         */
                        Object.defineProperty(ListBackendServicesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListBackendServicesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @instance
                         */
                        Object.defineProperty(ListBackendServicesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListBackendServicesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @instance
                         */
                        Object.defineProperty(ListBackendServicesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListBackendServicesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @instance
                         */
                        Object.defineProperty(ListBackendServicesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListBackendServicesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @instance
                         */
                        Object.defineProperty(ListBackendServicesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListBackendServicesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListBackendServicesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListBackendServicesRequest} ListBackendServicesRequest instance
                         */
                        ListBackendServicesRequest.create = function create(properties) {
                            return new ListBackendServicesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListBackendServicesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListBackendServicesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListBackendServicesRequest} message ListBackendServicesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListBackendServicesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListBackendServicesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListBackendServicesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListBackendServicesRequest} message ListBackendServicesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListBackendServicesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListBackendServicesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListBackendServicesRequest} ListBackendServicesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListBackendServicesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListBackendServicesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListBackendServicesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListBackendServicesRequest} ListBackendServicesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListBackendServicesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListBackendServicesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListBackendServicesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListBackendServicesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListBackendServicesRequest} ListBackendServicesRequest
                         */
                        ListBackendServicesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListBackendServicesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListBackendServicesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListBackendServicesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListBackendServicesRequest} message ListBackendServicesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListBackendServicesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListBackendServicesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListBackendServicesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListBackendServicesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListBackendServicesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListBackendServicesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListBackendServicesRequest";
                        };
    
                        return ListBackendServicesRequest;
                    })();
    
                    v1.ListDiskTypesRequest = (function() {
    
                        /**
                         * Properties of a ListDiskTypesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListDiskTypesRequest
                         * @property {string|null} [filter] ListDiskTypesRequest filter
                         * @property {number|null} [maxResults] ListDiskTypesRequest maxResults
                         * @property {string|null} [orderBy] ListDiskTypesRequest orderBy
                         * @property {string|null} [pageToken] ListDiskTypesRequest pageToken
                         * @property {string|null} [project] ListDiskTypesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListDiskTypesRequest returnPartialSuccess
                         * @property {string|null} [zone] ListDiskTypesRequest zone
                         */
    
                        /**
                         * Constructs a new ListDiskTypesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListDiskTypesRequest.
                         * @implements IListDiskTypesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListDiskTypesRequest=} [properties] Properties to set
                         */
                        function ListDiskTypesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListDiskTypesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @instance
                         */
                        ListDiskTypesRequest.prototype.filter = null;
    
                        /**
                         * ListDiskTypesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @instance
                         */
                        ListDiskTypesRequest.prototype.maxResults = null;
    
                        /**
                         * ListDiskTypesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @instance
                         */
                        ListDiskTypesRequest.prototype.orderBy = null;
    
                        /**
                         * ListDiskTypesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @instance
                         */
                        ListDiskTypesRequest.prototype.pageToken = null;
    
                        /**
                         * ListDiskTypesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @instance
                         */
                        ListDiskTypesRequest.prototype.project = "";
    
                        /**
                         * ListDiskTypesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @instance
                         */
                        ListDiskTypesRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListDiskTypesRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @instance
                         */
                        ListDiskTypesRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListDiskTypesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListDiskTypesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListDiskTypesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListDiskTypesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListDiskTypesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListDiskTypesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListDiskTypesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListDiskTypesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListDiskTypesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListDiskTypesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListDiskTypesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListDiskTypesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListDiskTypesRequest} ListDiskTypesRequest instance
                         */
                        ListDiskTypesRequest.create = function create(properties) {
                            return new ListDiskTypesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListDiskTypesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListDiskTypesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListDiskTypesRequest} message ListDiskTypesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListDiskTypesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListDiskTypesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListDiskTypesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListDiskTypesRequest} message ListDiskTypesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListDiskTypesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListDiskTypesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListDiskTypesRequest} ListDiskTypesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListDiskTypesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListDiskTypesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListDiskTypesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListDiskTypesRequest} ListDiskTypesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListDiskTypesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListDiskTypesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListDiskTypesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListDiskTypesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListDiskTypesRequest} ListDiskTypesRequest
                         */
                        ListDiskTypesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListDiskTypesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListDiskTypesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListDiskTypesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListDiskTypesRequest} message ListDiskTypesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListDiskTypesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListDiskTypesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListDiskTypesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListDiskTypesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListDiskTypesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListDiskTypesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListDiskTypesRequest";
                        };
    
                        return ListDiskTypesRequest;
                    })();
    
                    v1.ListDisksRequest = (function() {
    
                        /**
                         * Properties of a ListDisksRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListDisksRequest
                         * @property {string|null} [filter] ListDisksRequest filter
                         * @property {number|null} [maxResults] ListDisksRequest maxResults
                         * @property {string|null} [orderBy] ListDisksRequest orderBy
                         * @property {string|null} [pageToken] ListDisksRequest pageToken
                         * @property {string|null} [project] ListDisksRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListDisksRequest returnPartialSuccess
                         * @property {string|null} [zone] ListDisksRequest zone
                         */
    
                        /**
                         * Constructs a new ListDisksRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListDisksRequest.
                         * @implements IListDisksRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListDisksRequest=} [properties] Properties to set
                         */
                        function ListDisksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListDisksRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @instance
                         */
                        ListDisksRequest.prototype.filter = null;
    
                        /**
                         * ListDisksRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @instance
                         */
                        ListDisksRequest.prototype.maxResults = null;
    
                        /**
                         * ListDisksRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @instance
                         */
                        ListDisksRequest.prototype.orderBy = null;
    
                        /**
                         * ListDisksRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @instance
                         */
                        ListDisksRequest.prototype.pageToken = null;
    
                        /**
                         * ListDisksRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @instance
                         */
                        ListDisksRequest.prototype.project = "";
    
                        /**
                         * ListDisksRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @instance
                         */
                        ListDisksRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListDisksRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @instance
                         */
                        ListDisksRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListDisksRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @instance
                         */
                        Object.defineProperty(ListDisksRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListDisksRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @instance
                         */
                        Object.defineProperty(ListDisksRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListDisksRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @instance
                         */
                        Object.defineProperty(ListDisksRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListDisksRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @instance
                         */
                        Object.defineProperty(ListDisksRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListDisksRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @instance
                         */
                        Object.defineProperty(ListDisksRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListDisksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListDisksRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListDisksRequest} ListDisksRequest instance
                         */
                        ListDisksRequest.create = function create(properties) {
                            return new ListDisksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListDisksRequest message. Does not implicitly {@link google.cloud.compute.v1.ListDisksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListDisksRequest} message ListDisksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListDisksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListDisksRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListDisksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListDisksRequest} message ListDisksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListDisksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListDisksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListDisksRequest} ListDisksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListDisksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListDisksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListDisksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListDisksRequest} ListDisksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListDisksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListDisksRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListDisksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListDisksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListDisksRequest} ListDisksRequest
                         */
                        ListDisksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListDisksRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListDisksRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListDisksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListDisksRequest} message ListDisksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListDisksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListDisksRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListDisksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListDisksRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListDisksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListDisksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListDisksRequest";
                        };
    
                        return ListDisksRequest;
                    })();
    
                    v1.ListErrorsInstanceGroupManagersRequest = (function() {
    
                        /**
                         * Properties of a ListErrorsInstanceGroupManagersRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListErrorsInstanceGroupManagersRequest
                         * @property {string|null} [filter] ListErrorsInstanceGroupManagersRequest filter
                         * @property {string|null} [instanceGroupManager] ListErrorsInstanceGroupManagersRequest instanceGroupManager
                         * @property {number|null} [maxResults] ListErrorsInstanceGroupManagersRequest maxResults
                         * @property {string|null} [orderBy] ListErrorsInstanceGroupManagersRequest orderBy
                         * @property {string|null} [pageToken] ListErrorsInstanceGroupManagersRequest pageToken
                         * @property {string|null} [project] ListErrorsInstanceGroupManagersRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListErrorsInstanceGroupManagersRequest returnPartialSuccess
                         * @property {string|null} [zone] ListErrorsInstanceGroupManagersRequest zone
                         */
    
                        /**
                         * Constructs a new ListErrorsInstanceGroupManagersRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListErrorsInstanceGroupManagersRequest.
                         * @implements IListErrorsInstanceGroupManagersRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListErrorsInstanceGroupManagersRequest=} [properties] Properties to set
                         */
                        function ListErrorsInstanceGroupManagersRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListErrorsInstanceGroupManagersRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @instance
                         */
                        ListErrorsInstanceGroupManagersRequest.prototype.filter = null;
    
                        /**
                         * ListErrorsInstanceGroupManagersRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @instance
                         */
                        ListErrorsInstanceGroupManagersRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * ListErrorsInstanceGroupManagersRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @instance
                         */
                        ListErrorsInstanceGroupManagersRequest.prototype.maxResults = null;
    
                        /**
                         * ListErrorsInstanceGroupManagersRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @instance
                         */
                        ListErrorsInstanceGroupManagersRequest.prototype.orderBy = null;
    
                        /**
                         * ListErrorsInstanceGroupManagersRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @instance
                         */
                        ListErrorsInstanceGroupManagersRequest.prototype.pageToken = null;
    
                        /**
                         * ListErrorsInstanceGroupManagersRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @instance
                         */
                        ListErrorsInstanceGroupManagersRequest.prototype.project = "";
    
                        /**
                         * ListErrorsInstanceGroupManagersRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @instance
                         */
                        ListErrorsInstanceGroupManagersRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListErrorsInstanceGroupManagersRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @instance
                         */
                        ListErrorsInstanceGroupManagersRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListErrorsInstanceGroupManagersRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListErrorsInstanceGroupManagersRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListErrorsInstanceGroupManagersRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListErrorsInstanceGroupManagersRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListErrorsInstanceGroupManagersRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListErrorsInstanceGroupManagersRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListErrorsInstanceGroupManagersRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListErrorsInstanceGroupManagersRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListErrorsInstanceGroupManagersRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListErrorsInstanceGroupManagersRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListErrorsInstanceGroupManagersRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListErrorsInstanceGroupManagersRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest} ListErrorsInstanceGroupManagersRequest instance
                         */
                        ListErrorsInstanceGroupManagersRequest.create = function create(properties) {
                            return new ListErrorsInstanceGroupManagersRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListErrorsInstanceGroupManagersRequest message. Does not implicitly {@link google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListErrorsInstanceGroupManagersRequest} message ListErrorsInstanceGroupManagersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListErrorsInstanceGroupManagersRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListErrorsInstanceGroupManagersRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListErrorsInstanceGroupManagersRequest} message ListErrorsInstanceGroupManagersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListErrorsInstanceGroupManagersRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListErrorsInstanceGroupManagersRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest} ListErrorsInstanceGroupManagersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListErrorsInstanceGroupManagersRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListErrorsInstanceGroupManagersRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest} ListErrorsInstanceGroupManagersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListErrorsInstanceGroupManagersRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListErrorsInstanceGroupManagersRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListErrorsInstanceGroupManagersRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListErrorsInstanceGroupManagersRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest} ListErrorsInstanceGroupManagersRequest
                         */
                        ListErrorsInstanceGroupManagersRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListErrorsInstanceGroupManagersRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest} message ListErrorsInstanceGroupManagersRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListErrorsInstanceGroupManagersRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListErrorsInstanceGroupManagersRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListErrorsInstanceGroupManagersRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListErrorsInstanceGroupManagersRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListErrorsInstanceGroupManagersRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest";
                        };
    
                        return ListErrorsInstanceGroupManagersRequest;
                    })();
    
                    v1.ListErrorsRegionInstanceGroupManagersRequest = (function() {
    
                        /**
                         * Properties of a ListErrorsRegionInstanceGroupManagersRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListErrorsRegionInstanceGroupManagersRequest
                         * @property {string|null} [filter] ListErrorsRegionInstanceGroupManagersRequest filter
                         * @property {string|null} [instanceGroupManager] ListErrorsRegionInstanceGroupManagersRequest instanceGroupManager
                         * @property {number|null} [maxResults] ListErrorsRegionInstanceGroupManagersRequest maxResults
                         * @property {string|null} [orderBy] ListErrorsRegionInstanceGroupManagersRequest orderBy
                         * @property {string|null} [pageToken] ListErrorsRegionInstanceGroupManagersRequest pageToken
                         * @property {string|null} [project] ListErrorsRegionInstanceGroupManagersRequest project
                         * @property {string|null} [region] ListErrorsRegionInstanceGroupManagersRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListErrorsRegionInstanceGroupManagersRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListErrorsRegionInstanceGroupManagersRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListErrorsRegionInstanceGroupManagersRequest.
                         * @implements IListErrorsRegionInstanceGroupManagersRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListErrorsRegionInstanceGroupManagersRequest=} [properties] Properties to set
                         */
                        function ListErrorsRegionInstanceGroupManagersRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListErrorsRegionInstanceGroupManagersRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListErrorsRegionInstanceGroupManagersRequest.prototype.filter = null;
    
                        /**
                         * ListErrorsRegionInstanceGroupManagersRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListErrorsRegionInstanceGroupManagersRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * ListErrorsRegionInstanceGroupManagersRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListErrorsRegionInstanceGroupManagersRequest.prototype.maxResults = null;
    
                        /**
                         * ListErrorsRegionInstanceGroupManagersRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListErrorsRegionInstanceGroupManagersRequest.prototype.orderBy = null;
    
                        /**
                         * ListErrorsRegionInstanceGroupManagersRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListErrorsRegionInstanceGroupManagersRequest.prototype.pageToken = null;
    
                        /**
                         * ListErrorsRegionInstanceGroupManagersRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListErrorsRegionInstanceGroupManagersRequest.prototype.project = "";
    
                        /**
                         * ListErrorsRegionInstanceGroupManagersRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListErrorsRegionInstanceGroupManagersRequest.prototype.region = "";
    
                        /**
                         * ListErrorsRegionInstanceGroupManagersRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListErrorsRegionInstanceGroupManagersRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListErrorsRegionInstanceGroupManagersRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListErrorsRegionInstanceGroupManagersRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListErrorsRegionInstanceGroupManagersRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListErrorsRegionInstanceGroupManagersRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListErrorsRegionInstanceGroupManagersRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListErrorsRegionInstanceGroupManagersRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListErrorsRegionInstanceGroupManagersRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListErrorsRegionInstanceGroupManagersRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListErrorsRegionInstanceGroupManagersRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListErrorsRegionInstanceGroupManagersRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListErrorsRegionInstanceGroupManagersRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListErrorsRegionInstanceGroupManagersRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest} ListErrorsRegionInstanceGroupManagersRequest instance
                         */
                        ListErrorsRegionInstanceGroupManagersRequest.create = function create(properties) {
                            return new ListErrorsRegionInstanceGroupManagersRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListErrorsRegionInstanceGroupManagersRequest message. Does not implicitly {@link google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListErrorsRegionInstanceGroupManagersRequest} message ListErrorsRegionInstanceGroupManagersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListErrorsRegionInstanceGroupManagersRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListErrorsRegionInstanceGroupManagersRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListErrorsRegionInstanceGroupManagersRequest} message ListErrorsRegionInstanceGroupManagersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListErrorsRegionInstanceGroupManagersRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListErrorsRegionInstanceGroupManagersRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest} ListErrorsRegionInstanceGroupManagersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListErrorsRegionInstanceGroupManagersRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListErrorsRegionInstanceGroupManagersRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest} ListErrorsRegionInstanceGroupManagersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListErrorsRegionInstanceGroupManagersRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListErrorsRegionInstanceGroupManagersRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListErrorsRegionInstanceGroupManagersRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListErrorsRegionInstanceGroupManagersRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest} ListErrorsRegionInstanceGroupManagersRequest
                         */
                        ListErrorsRegionInstanceGroupManagersRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListErrorsRegionInstanceGroupManagersRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest} message ListErrorsRegionInstanceGroupManagersRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListErrorsRegionInstanceGroupManagersRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListErrorsRegionInstanceGroupManagersRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListErrorsRegionInstanceGroupManagersRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListErrorsRegionInstanceGroupManagersRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListErrorsRegionInstanceGroupManagersRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest";
                        };
    
                        return ListErrorsRegionInstanceGroupManagersRequest;
                    })();
    
                    v1.ListExternalVpnGatewaysRequest = (function() {
    
                        /**
                         * Properties of a ListExternalVpnGatewaysRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListExternalVpnGatewaysRequest
                         * @property {string|null} [filter] ListExternalVpnGatewaysRequest filter
                         * @property {number|null} [maxResults] ListExternalVpnGatewaysRequest maxResults
                         * @property {string|null} [orderBy] ListExternalVpnGatewaysRequest orderBy
                         * @property {string|null} [pageToken] ListExternalVpnGatewaysRequest pageToken
                         * @property {string|null} [project] ListExternalVpnGatewaysRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListExternalVpnGatewaysRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListExternalVpnGatewaysRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListExternalVpnGatewaysRequest.
                         * @implements IListExternalVpnGatewaysRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListExternalVpnGatewaysRequest=} [properties] Properties to set
                         */
                        function ListExternalVpnGatewaysRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListExternalVpnGatewaysRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @instance
                         */
                        ListExternalVpnGatewaysRequest.prototype.filter = null;
    
                        /**
                         * ListExternalVpnGatewaysRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @instance
                         */
                        ListExternalVpnGatewaysRequest.prototype.maxResults = null;
    
                        /**
                         * ListExternalVpnGatewaysRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @instance
                         */
                        ListExternalVpnGatewaysRequest.prototype.orderBy = null;
    
                        /**
                         * ListExternalVpnGatewaysRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @instance
                         */
                        ListExternalVpnGatewaysRequest.prototype.pageToken = null;
    
                        /**
                         * ListExternalVpnGatewaysRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @instance
                         */
                        ListExternalVpnGatewaysRequest.prototype.project = "";
    
                        /**
                         * ListExternalVpnGatewaysRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @instance
                         */
                        ListExternalVpnGatewaysRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListExternalVpnGatewaysRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(ListExternalVpnGatewaysRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListExternalVpnGatewaysRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(ListExternalVpnGatewaysRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListExternalVpnGatewaysRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(ListExternalVpnGatewaysRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListExternalVpnGatewaysRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(ListExternalVpnGatewaysRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListExternalVpnGatewaysRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(ListExternalVpnGatewaysRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListExternalVpnGatewaysRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListExternalVpnGatewaysRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListExternalVpnGatewaysRequest} ListExternalVpnGatewaysRequest instance
                         */
                        ListExternalVpnGatewaysRequest.create = function create(properties) {
                            return new ListExternalVpnGatewaysRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListExternalVpnGatewaysRequest message. Does not implicitly {@link google.cloud.compute.v1.ListExternalVpnGatewaysRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListExternalVpnGatewaysRequest} message ListExternalVpnGatewaysRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListExternalVpnGatewaysRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListExternalVpnGatewaysRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListExternalVpnGatewaysRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListExternalVpnGatewaysRequest} message ListExternalVpnGatewaysRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListExternalVpnGatewaysRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListExternalVpnGatewaysRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListExternalVpnGatewaysRequest} ListExternalVpnGatewaysRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListExternalVpnGatewaysRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListExternalVpnGatewaysRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListExternalVpnGatewaysRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListExternalVpnGatewaysRequest} ListExternalVpnGatewaysRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListExternalVpnGatewaysRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListExternalVpnGatewaysRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListExternalVpnGatewaysRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListExternalVpnGatewaysRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListExternalVpnGatewaysRequest} ListExternalVpnGatewaysRequest
                         */
                        ListExternalVpnGatewaysRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListExternalVpnGatewaysRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListExternalVpnGatewaysRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListExternalVpnGatewaysRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListExternalVpnGatewaysRequest} message ListExternalVpnGatewaysRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListExternalVpnGatewaysRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListExternalVpnGatewaysRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListExternalVpnGatewaysRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListExternalVpnGatewaysRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListExternalVpnGatewaysRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListExternalVpnGatewaysRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListExternalVpnGatewaysRequest";
                        };
    
                        return ListExternalVpnGatewaysRequest;
                    })();
    
                    v1.ListFirewallPoliciesRequest = (function() {
    
                        /**
                         * Properties of a ListFirewallPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListFirewallPoliciesRequest
                         * @property {string|null} [filter] ListFirewallPoliciesRequest filter
                         * @property {number|null} [maxResults] ListFirewallPoliciesRequest maxResults
                         * @property {string|null} [orderBy] ListFirewallPoliciesRequest orderBy
                         * @property {string|null} [pageToken] ListFirewallPoliciesRequest pageToken
                         * @property {string|null} [parentId] ListFirewallPoliciesRequest parentId
                         * @property {boolean|null} [returnPartialSuccess] ListFirewallPoliciesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListFirewallPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListFirewallPoliciesRequest.
                         * @implements IListFirewallPoliciesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListFirewallPoliciesRequest=} [properties] Properties to set
                         */
                        function ListFirewallPoliciesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListFirewallPoliciesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @instance
                         */
                        ListFirewallPoliciesRequest.prototype.filter = null;
    
                        /**
                         * ListFirewallPoliciesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @instance
                         */
                        ListFirewallPoliciesRequest.prototype.maxResults = null;
    
                        /**
                         * ListFirewallPoliciesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @instance
                         */
                        ListFirewallPoliciesRequest.prototype.orderBy = null;
    
                        /**
                         * ListFirewallPoliciesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @instance
                         */
                        ListFirewallPoliciesRequest.prototype.pageToken = null;
    
                        /**
                         * ListFirewallPoliciesRequest parentId.
                         * @member {string|null|undefined} parentId
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @instance
                         */
                        ListFirewallPoliciesRequest.prototype.parentId = null;
    
                        /**
                         * ListFirewallPoliciesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @instance
                         */
                        ListFirewallPoliciesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListFirewallPoliciesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListFirewallPoliciesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListFirewallPoliciesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListFirewallPoliciesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListFirewallPoliciesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListFirewallPoliciesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListFirewallPoliciesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListFirewallPoliciesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListFirewallPoliciesRequest _parentId.
                         * @member {"parentId"|undefined} _parentId
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListFirewallPoliciesRequest.prototype, "_parentId", {
                            get: $util.oneOfGetter($oneOfFields = ["parentId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListFirewallPoliciesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListFirewallPoliciesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListFirewallPoliciesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListFirewallPoliciesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListFirewallPoliciesRequest} ListFirewallPoliciesRequest instance
                         */
                        ListFirewallPoliciesRequest.create = function create(properties) {
                            return new ListFirewallPoliciesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListFirewallPoliciesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListFirewallPoliciesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListFirewallPoliciesRequest} message ListFirewallPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListFirewallPoliciesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.parentId != null && Object.hasOwnProperty.call(message, "parentId"))
                                writer.uint32(/* id 459714768, wireType 2 =*/3677718146).string(message.parentId);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListFirewallPoliciesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListFirewallPoliciesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListFirewallPoliciesRequest} message ListFirewallPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListFirewallPoliciesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListFirewallPoliciesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListFirewallPoliciesRequest} ListFirewallPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListFirewallPoliciesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListFirewallPoliciesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 459714768: {
                                        message.parentId = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListFirewallPoliciesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListFirewallPoliciesRequest} ListFirewallPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListFirewallPoliciesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListFirewallPoliciesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListFirewallPoliciesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.parentId != null && message.hasOwnProperty("parentId")) {
                                properties._parentId = 1;
                                if (!$util.isString(message.parentId))
                                    return "parentId: string expected";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListFirewallPoliciesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListFirewallPoliciesRequest} ListFirewallPoliciesRequest
                         */
                        ListFirewallPoliciesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListFirewallPoliciesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListFirewallPoliciesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.parentId != null)
                                message.parentId = String(object.parentId);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListFirewallPoliciesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListFirewallPoliciesRequest} message ListFirewallPoliciesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListFirewallPoliciesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.parentId != null && message.hasOwnProperty("parentId")) {
                                object.parentId = message.parentId;
                                if (options.oneofs)
                                    object._parentId = "parentId";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListFirewallPoliciesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListFirewallPoliciesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListFirewallPoliciesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListFirewallPoliciesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListFirewallPoliciesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListFirewallPoliciesRequest";
                        };
    
                        return ListFirewallPoliciesRequest;
                    })();
    
                    v1.ListFirewallsRequest = (function() {
    
                        /**
                         * Properties of a ListFirewallsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListFirewallsRequest
                         * @property {string|null} [filter] ListFirewallsRequest filter
                         * @property {number|null} [maxResults] ListFirewallsRequest maxResults
                         * @property {string|null} [orderBy] ListFirewallsRequest orderBy
                         * @property {string|null} [pageToken] ListFirewallsRequest pageToken
                         * @property {string|null} [project] ListFirewallsRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListFirewallsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListFirewallsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListFirewallsRequest.
                         * @implements IListFirewallsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListFirewallsRequest=} [properties] Properties to set
                         */
                        function ListFirewallsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListFirewallsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @instance
                         */
                        ListFirewallsRequest.prototype.filter = null;
    
                        /**
                         * ListFirewallsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @instance
                         */
                        ListFirewallsRequest.prototype.maxResults = null;
    
                        /**
                         * ListFirewallsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @instance
                         */
                        ListFirewallsRequest.prototype.orderBy = null;
    
                        /**
                         * ListFirewallsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @instance
                         */
                        ListFirewallsRequest.prototype.pageToken = null;
    
                        /**
                         * ListFirewallsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @instance
                         */
                        ListFirewallsRequest.prototype.project = "";
    
                        /**
                         * ListFirewallsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @instance
                         */
                        ListFirewallsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListFirewallsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @instance
                         */
                        Object.defineProperty(ListFirewallsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListFirewallsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @instance
                         */
                        Object.defineProperty(ListFirewallsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListFirewallsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @instance
                         */
                        Object.defineProperty(ListFirewallsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListFirewallsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @instance
                         */
                        Object.defineProperty(ListFirewallsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListFirewallsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @instance
                         */
                        Object.defineProperty(ListFirewallsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListFirewallsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListFirewallsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListFirewallsRequest} ListFirewallsRequest instance
                         */
                        ListFirewallsRequest.create = function create(properties) {
                            return new ListFirewallsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListFirewallsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListFirewallsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListFirewallsRequest} message ListFirewallsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListFirewallsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListFirewallsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListFirewallsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListFirewallsRequest} message ListFirewallsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListFirewallsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListFirewallsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListFirewallsRequest} ListFirewallsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListFirewallsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListFirewallsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListFirewallsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListFirewallsRequest} ListFirewallsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListFirewallsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListFirewallsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListFirewallsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListFirewallsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListFirewallsRequest} ListFirewallsRequest
                         */
                        ListFirewallsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListFirewallsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListFirewallsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListFirewallsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListFirewallsRequest} message ListFirewallsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListFirewallsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListFirewallsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListFirewallsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListFirewallsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListFirewallsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListFirewallsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListFirewallsRequest";
                        };
    
                        return ListFirewallsRequest;
                    })();
    
                    v1.ListForwardingRulesRequest = (function() {
    
                        /**
                         * Properties of a ListForwardingRulesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListForwardingRulesRequest
                         * @property {string|null} [filter] ListForwardingRulesRequest filter
                         * @property {number|null} [maxResults] ListForwardingRulesRequest maxResults
                         * @property {string|null} [orderBy] ListForwardingRulesRequest orderBy
                         * @property {string|null} [pageToken] ListForwardingRulesRequest pageToken
                         * @property {string|null} [project] ListForwardingRulesRequest project
                         * @property {string|null} [region] ListForwardingRulesRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListForwardingRulesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListForwardingRulesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListForwardingRulesRequest.
                         * @implements IListForwardingRulesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListForwardingRulesRequest=} [properties] Properties to set
                         */
                        function ListForwardingRulesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListForwardingRulesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @instance
                         */
                        ListForwardingRulesRequest.prototype.filter = null;
    
                        /**
                         * ListForwardingRulesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @instance
                         */
                        ListForwardingRulesRequest.prototype.maxResults = null;
    
                        /**
                         * ListForwardingRulesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @instance
                         */
                        ListForwardingRulesRequest.prototype.orderBy = null;
    
                        /**
                         * ListForwardingRulesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @instance
                         */
                        ListForwardingRulesRequest.prototype.pageToken = null;
    
                        /**
                         * ListForwardingRulesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @instance
                         */
                        ListForwardingRulesRequest.prototype.project = "";
    
                        /**
                         * ListForwardingRulesRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @instance
                         */
                        ListForwardingRulesRequest.prototype.region = "";
    
                        /**
                         * ListForwardingRulesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @instance
                         */
                        ListForwardingRulesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListForwardingRulesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @instance
                         */
                        Object.defineProperty(ListForwardingRulesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListForwardingRulesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @instance
                         */
                        Object.defineProperty(ListForwardingRulesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListForwardingRulesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @instance
                         */
                        Object.defineProperty(ListForwardingRulesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListForwardingRulesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @instance
                         */
                        Object.defineProperty(ListForwardingRulesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListForwardingRulesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @instance
                         */
                        Object.defineProperty(ListForwardingRulesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListForwardingRulesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListForwardingRulesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListForwardingRulesRequest} ListForwardingRulesRequest instance
                         */
                        ListForwardingRulesRequest.create = function create(properties) {
                            return new ListForwardingRulesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListForwardingRulesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListForwardingRulesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListForwardingRulesRequest} message ListForwardingRulesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListForwardingRulesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListForwardingRulesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListForwardingRulesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListForwardingRulesRequest} message ListForwardingRulesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListForwardingRulesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListForwardingRulesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListForwardingRulesRequest} ListForwardingRulesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListForwardingRulesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListForwardingRulesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListForwardingRulesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListForwardingRulesRequest} ListForwardingRulesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListForwardingRulesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListForwardingRulesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListForwardingRulesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListForwardingRulesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListForwardingRulesRequest} ListForwardingRulesRequest
                         */
                        ListForwardingRulesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListForwardingRulesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListForwardingRulesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListForwardingRulesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListForwardingRulesRequest} message ListForwardingRulesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListForwardingRulesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListForwardingRulesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListForwardingRulesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListForwardingRulesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListForwardingRulesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListForwardingRulesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListForwardingRulesRequest";
                        };
    
                        return ListForwardingRulesRequest;
                    })();
    
                    v1.ListGlobalAddressesRequest = (function() {
    
                        /**
                         * Properties of a ListGlobalAddressesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListGlobalAddressesRequest
                         * @property {string|null} [filter] ListGlobalAddressesRequest filter
                         * @property {number|null} [maxResults] ListGlobalAddressesRequest maxResults
                         * @property {string|null} [orderBy] ListGlobalAddressesRequest orderBy
                         * @property {string|null} [pageToken] ListGlobalAddressesRequest pageToken
                         * @property {string|null} [project] ListGlobalAddressesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListGlobalAddressesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListGlobalAddressesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListGlobalAddressesRequest.
                         * @implements IListGlobalAddressesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListGlobalAddressesRequest=} [properties] Properties to set
                         */
                        function ListGlobalAddressesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListGlobalAddressesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @instance
                         */
                        ListGlobalAddressesRequest.prototype.filter = null;
    
                        /**
                         * ListGlobalAddressesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @instance
                         */
                        ListGlobalAddressesRequest.prototype.maxResults = null;
    
                        /**
                         * ListGlobalAddressesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @instance
                         */
                        ListGlobalAddressesRequest.prototype.orderBy = null;
    
                        /**
                         * ListGlobalAddressesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @instance
                         */
                        ListGlobalAddressesRequest.prototype.pageToken = null;
    
                        /**
                         * ListGlobalAddressesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @instance
                         */
                        ListGlobalAddressesRequest.prototype.project = "";
    
                        /**
                         * ListGlobalAddressesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @instance
                         */
                        ListGlobalAddressesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListGlobalAddressesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalAddressesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalAddressesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalAddressesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalAddressesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalAddressesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalAddressesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalAddressesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalAddressesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalAddressesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListGlobalAddressesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListGlobalAddressesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListGlobalAddressesRequest} ListGlobalAddressesRequest instance
                         */
                        ListGlobalAddressesRequest.create = function create(properties) {
                            return new ListGlobalAddressesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListGlobalAddressesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListGlobalAddressesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListGlobalAddressesRequest} message ListGlobalAddressesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListGlobalAddressesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListGlobalAddressesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListGlobalAddressesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListGlobalAddressesRequest} message ListGlobalAddressesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListGlobalAddressesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListGlobalAddressesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListGlobalAddressesRequest} ListGlobalAddressesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListGlobalAddressesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListGlobalAddressesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListGlobalAddressesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListGlobalAddressesRequest} ListGlobalAddressesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListGlobalAddressesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListGlobalAddressesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListGlobalAddressesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListGlobalAddressesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListGlobalAddressesRequest} ListGlobalAddressesRequest
                         */
                        ListGlobalAddressesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListGlobalAddressesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListGlobalAddressesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListGlobalAddressesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListGlobalAddressesRequest} message ListGlobalAddressesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListGlobalAddressesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListGlobalAddressesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListGlobalAddressesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListGlobalAddressesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListGlobalAddressesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListGlobalAddressesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListGlobalAddressesRequest";
                        };
    
                        return ListGlobalAddressesRequest;
                    })();
    
                    v1.ListGlobalForwardingRulesRequest = (function() {
    
                        /**
                         * Properties of a ListGlobalForwardingRulesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListGlobalForwardingRulesRequest
                         * @property {string|null} [filter] ListGlobalForwardingRulesRequest filter
                         * @property {number|null} [maxResults] ListGlobalForwardingRulesRequest maxResults
                         * @property {string|null} [orderBy] ListGlobalForwardingRulesRequest orderBy
                         * @property {string|null} [pageToken] ListGlobalForwardingRulesRequest pageToken
                         * @property {string|null} [project] ListGlobalForwardingRulesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListGlobalForwardingRulesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListGlobalForwardingRulesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListGlobalForwardingRulesRequest.
                         * @implements IListGlobalForwardingRulesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListGlobalForwardingRulesRequest=} [properties] Properties to set
                         */
                        function ListGlobalForwardingRulesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListGlobalForwardingRulesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @instance
                         */
                        ListGlobalForwardingRulesRequest.prototype.filter = null;
    
                        /**
                         * ListGlobalForwardingRulesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @instance
                         */
                        ListGlobalForwardingRulesRequest.prototype.maxResults = null;
    
                        /**
                         * ListGlobalForwardingRulesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @instance
                         */
                        ListGlobalForwardingRulesRequest.prototype.orderBy = null;
    
                        /**
                         * ListGlobalForwardingRulesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @instance
                         */
                        ListGlobalForwardingRulesRequest.prototype.pageToken = null;
    
                        /**
                         * ListGlobalForwardingRulesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @instance
                         */
                        ListGlobalForwardingRulesRequest.prototype.project = "";
    
                        /**
                         * ListGlobalForwardingRulesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @instance
                         */
                        ListGlobalForwardingRulesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListGlobalForwardingRulesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalForwardingRulesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalForwardingRulesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalForwardingRulesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalForwardingRulesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalForwardingRulesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalForwardingRulesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalForwardingRulesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalForwardingRulesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalForwardingRulesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListGlobalForwardingRulesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListGlobalForwardingRulesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListGlobalForwardingRulesRequest} ListGlobalForwardingRulesRequest instance
                         */
                        ListGlobalForwardingRulesRequest.create = function create(properties) {
                            return new ListGlobalForwardingRulesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListGlobalForwardingRulesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListGlobalForwardingRulesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListGlobalForwardingRulesRequest} message ListGlobalForwardingRulesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListGlobalForwardingRulesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListGlobalForwardingRulesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListGlobalForwardingRulesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListGlobalForwardingRulesRequest} message ListGlobalForwardingRulesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListGlobalForwardingRulesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListGlobalForwardingRulesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListGlobalForwardingRulesRequest} ListGlobalForwardingRulesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListGlobalForwardingRulesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListGlobalForwardingRulesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListGlobalForwardingRulesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListGlobalForwardingRulesRequest} ListGlobalForwardingRulesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListGlobalForwardingRulesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListGlobalForwardingRulesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListGlobalForwardingRulesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListGlobalForwardingRulesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListGlobalForwardingRulesRequest} ListGlobalForwardingRulesRequest
                         */
                        ListGlobalForwardingRulesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListGlobalForwardingRulesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListGlobalForwardingRulesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListGlobalForwardingRulesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListGlobalForwardingRulesRequest} message ListGlobalForwardingRulesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListGlobalForwardingRulesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListGlobalForwardingRulesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListGlobalForwardingRulesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListGlobalForwardingRulesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListGlobalForwardingRulesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListGlobalForwardingRulesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListGlobalForwardingRulesRequest";
                        };
    
                        return ListGlobalForwardingRulesRequest;
                    })();
    
                    v1.ListGlobalNetworkEndpointGroupsRequest = (function() {
    
                        /**
                         * Properties of a ListGlobalNetworkEndpointGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListGlobalNetworkEndpointGroupsRequest
                         * @property {string|null} [filter] ListGlobalNetworkEndpointGroupsRequest filter
                         * @property {number|null} [maxResults] ListGlobalNetworkEndpointGroupsRequest maxResults
                         * @property {string|null} [orderBy] ListGlobalNetworkEndpointGroupsRequest orderBy
                         * @property {string|null} [pageToken] ListGlobalNetworkEndpointGroupsRequest pageToken
                         * @property {string|null} [project] ListGlobalNetworkEndpointGroupsRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListGlobalNetworkEndpointGroupsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListGlobalNetworkEndpointGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListGlobalNetworkEndpointGroupsRequest.
                         * @implements IListGlobalNetworkEndpointGroupsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListGlobalNetworkEndpointGroupsRequest=} [properties] Properties to set
                         */
                        function ListGlobalNetworkEndpointGroupsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListGlobalNetworkEndpointGroupsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListGlobalNetworkEndpointGroupsRequest.prototype.filter = null;
    
                        /**
                         * ListGlobalNetworkEndpointGroupsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListGlobalNetworkEndpointGroupsRequest.prototype.maxResults = null;
    
                        /**
                         * ListGlobalNetworkEndpointGroupsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListGlobalNetworkEndpointGroupsRequest.prototype.orderBy = null;
    
                        /**
                         * ListGlobalNetworkEndpointGroupsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListGlobalNetworkEndpointGroupsRequest.prototype.pageToken = null;
    
                        /**
                         * ListGlobalNetworkEndpointGroupsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListGlobalNetworkEndpointGroupsRequest.prototype.project = "";
    
                        /**
                         * ListGlobalNetworkEndpointGroupsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListGlobalNetworkEndpointGroupsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListGlobalNetworkEndpointGroupsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalNetworkEndpointGroupsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalNetworkEndpointGroupsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalNetworkEndpointGroupsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalNetworkEndpointGroupsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalNetworkEndpointGroupsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalNetworkEndpointGroupsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalNetworkEndpointGroupsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalNetworkEndpointGroupsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalNetworkEndpointGroupsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListGlobalNetworkEndpointGroupsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListGlobalNetworkEndpointGroupsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest} ListGlobalNetworkEndpointGroupsRequest instance
                         */
                        ListGlobalNetworkEndpointGroupsRequest.create = function create(properties) {
                            return new ListGlobalNetworkEndpointGroupsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListGlobalNetworkEndpointGroupsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListGlobalNetworkEndpointGroupsRequest} message ListGlobalNetworkEndpointGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListGlobalNetworkEndpointGroupsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListGlobalNetworkEndpointGroupsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListGlobalNetworkEndpointGroupsRequest} message ListGlobalNetworkEndpointGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListGlobalNetworkEndpointGroupsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListGlobalNetworkEndpointGroupsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest} ListGlobalNetworkEndpointGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListGlobalNetworkEndpointGroupsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListGlobalNetworkEndpointGroupsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest} ListGlobalNetworkEndpointGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListGlobalNetworkEndpointGroupsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListGlobalNetworkEndpointGroupsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListGlobalNetworkEndpointGroupsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListGlobalNetworkEndpointGroupsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest} ListGlobalNetworkEndpointGroupsRequest
                         */
                        ListGlobalNetworkEndpointGroupsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListGlobalNetworkEndpointGroupsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest} message ListGlobalNetworkEndpointGroupsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListGlobalNetworkEndpointGroupsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListGlobalNetworkEndpointGroupsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListGlobalNetworkEndpointGroupsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListGlobalNetworkEndpointGroupsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListGlobalNetworkEndpointGroupsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest";
                        };
    
                        return ListGlobalNetworkEndpointGroupsRequest;
                    })();
    
                    v1.ListGlobalOperationsRequest = (function() {
    
                        /**
                         * Properties of a ListGlobalOperationsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListGlobalOperationsRequest
                         * @property {string|null} [filter] ListGlobalOperationsRequest filter
                         * @property {number|null} [maxResults] ListGlobalOperationsRequest maxResults
                         * @property {string|null} [orderBy] ListGlobalOperationsRequest orderBy
                         * @property {string|null} [pageToken] ListGlobalOperationsRequest pageToken
                         * @property {string|null} [project] ListGlobalOperationsRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListGlobalOperationsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListGlobalOperationsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListGlobalOperationsRequest.
                         * @implements IListGlobalOperationsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListGlobalOperationsRequest=} [properties] Properties to set
                         */
                        function ListGlobalOperationsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListGlobalOperationsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @instance
                         */
                        ListGlobalOperationsRequest.prototype.filter = null;
    
                        /**
                         * ListGlobalOperationsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @instance
                         */
                        ListGlobalOperationsRequest.prototype.maxResults = null;
    
                        /**
                         * ListGlobalOperationsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @instance
                         */
                        ListGlobalOperationsRequest.prototype.orderBy = null;
    
                        /**
                         * ListGlobalOperationsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @instance
                         */
                        ListGlobalOperationsRequest.prototype.pageToken = null;
    
                        /**
                         * ListGlobalOperationsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @instance
                         */
                        ListGlobalOperationsRequest.prototype.project = "";
    
                        /**
                         * ListGlobalOperationsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @instance
                         */
                        ListGlobalOperationsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListGlobalOperationsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalOperationsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalOperationsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalOperationsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalOperationsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalOperationsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalOperationsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalOperationsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalOperationsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalOperationsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListGlobalOperationsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListGlobalOperationsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListGlobalOperationsRequest} ListGlobalOperationsRequest instance
                         */
                        ListGlobalOperationsRequest.create = function create(properties) {
                            return new ListGlobalOperationsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListGlobalOperationsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListGlobalOperationsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListGlobalOperationsRequest} message ListGlobalOperationsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListGlobalOperationsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListGlobalOperationsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListGlobalOperationsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListGlobalOperationsRequest} message ListGlobalOperationsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListGlobalOperationsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListGlobalOperationsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListGlobalOperationsRequest} ListGlobalOperationsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListGlobalOperationsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListGlobalOperationsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListGlobalOperationsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListGlobalOperationsRequest} ListGlobalOperationsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListGlobalOperationsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListGlobalOperationsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListGlobalOperationsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListGlobalOperationsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListGlobalOperationsRequest} ListGlobalOperationsRequest
                         */
                        ListGlobalOperationsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListGlobalOperationsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListGlobalOperationsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListGlobalOperationsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListGlobalOperationsRequest} message ListGlobalOperationsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListGlobalOperationsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListGlobalOperationsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListGlobalOperationsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListGlobalOperationsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListGlobalOperationsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListGlobalOperationsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListGlobalOperationsRequest";
                        };
    
                        return ListGlobalOperationsRequest;
                    })();
    
                    v1.ListGlobalOrganizationOperationsRequest = (function() {
    
                        /**
                         * Properties of a ListGlobalOrganizationOperationsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListGlobalOrganizationOperationsRequest
                         * @property {string|null} [filter] ListGlobalOrganizationOperationsRequest filter
                         * @property {number|null} [maxResults] ListGlobalOrganizationOperationsRequest maxResults
                         * @property {string|null} [orderBy] ListGlobalOrganizationOperationsRequest orderBy
                         * @property {string|null} [pageToken] ListGlobalOrganizationOperationsRequest pageToken
                         * @property {string|null} [parentId] ListGlobalOrganizationOperationsRequest parentId
                         * @property {boolean|null} [returnPartialSuccess] ListGlobalOrganizationOperationsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListGlobalOrganizationOperationsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListGlobalOrganizationOperationsRequest.
                         * @implements IListGlobalOrganizationOperationsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListGlobalOrganizationOperationsRequest=} [properties] Properties to set
                         */
                        function ListGlobalOrganizationOperationsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListGlobalOrganizationOperationsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @instance
                         */
                        ListGlobalOrganizationOperationsRequest.prototype.filter = null;
    
                        /**
                         * ListGlobalOrganizationOperationsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @instance
                         */
                        ListGlobalOrganizationOperationsRequest.prototype.maxResults = null;
    
                        /**
                         * ListGlobalOrganizationOperationsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @instance
                         */
                        ListGlobalOrganizationOperationsRequest.prototype.orderBy = null;
    
                        /**
                         * ListGlobalOrganizationOperationsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @instance
                         */
                        ListGlobalOrganizationOperationsRequest.prototype.pageToken = null;
    
                        /**
                         * ListGlobalOrganizationOperationsRequest parentId.
                         * @member {string|null|undefined} parentId
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @instance
                         */
                        ListGlobalOrganizationOperationsRequest.prototype.parentId = null;
    
                        /**
                         * ListGlobalOrganizationOperationsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @instance
                         */
                        ListGlobalOrganizationOperationsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListGlobalOrganizationOperationsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalOrganizationOperationsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalOrganizationOperationsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalOrganizationOperationsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalOrganizationOperationsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalOrganizationOperationsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalOrganizationOperationsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalOrganizationOperationsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalOrganizationOperationsRequest _parentId.
                         * @member {"parentId"|undefined} _parentId
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalOrganizationOperationsRequest.prototype, "_parentId", {
                            get: $util.oneOfGetter($oneOfFields = ["parentId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalOrganizationOperationsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalOrganizationOperationsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListGlobalOrganizationOperationsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListGlobalOrganizationOperationsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest} ListGlobalOrganizationOperationsRequest instance
                         */
                        ListGlobalOrganizationOperationsRequest.create = function create(properties) {
                            return new ListGlobalOrganizationOperationsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListGlobalOrganizationOperationsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListGlobalOrganizationOperationsRequest} message ListGlobalOrganizationOperationsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListGlobalOrganizationOperationsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.parentId != null && Object.hasOwnProperty.call(message, "parentId"))
                                writer.uint32(/* id 459714768, wireType 2 =*/3677718146).string(message.parentId);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListGlobalOrganizationOperationsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListGlobalOrganizationOperationsRequest} message ListGlobalOrganizationOperationsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListGlobalOrganizationOperationsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListGlobalOrganizationOperationsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest} ListGlobalOrganizationOperationsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListGlobalOrganizationOperationsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 459714768: {
                                        message.parentId = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListGlobalOrganizationOperationsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest} ListGlobalOrganizationOperationsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListGlobalOrganizationOperationsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListGlobalOrganizationOperationsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListGlobalOrganizationOperationsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.parentId != null && message.hasOwnProperty("parentId")) {
                                properties._parentId = 1;
                                if (!$util.isString(message.parentId))
                                    return "parentId: string expected";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListGlobalOrganizationOperationsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest} ListGlobalOrganizationOperationsRequest
                         */
                        ListGlobalOrganizationOperationsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.parentId != null)
                                message.parentId = String(object.parentId);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListGlobalOrganizationOperationsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest} message ListGlobalOrganizationOperationsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListGlobalOrganizationOperationsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.parentId != null && message.hasOwnProperty("parentId")) {
                                object.parentId = message.parentId;
                                if (options.oneofs)
                                    object._parentId = "parentId";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListGlobalOrganizationOperationsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListGlobalOrganizationOperationsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListGlobalOrganizationOperationsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListGlobalOrganizationOperationsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest";
                        };
    
                        return ListGlobalOrganizationOperationsRequest;
                    })();
    
                    v1.ListGlobalPublicDelegatedPrefixesRequest = (function() {
    
                        /**
                         * Properties of a ListGlobalPublicDelegatedPrefixesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListGlobalPublicDelegatedPrefixesRequest
                         * @property {string|null} [filter] ListGlobalPublicDelegatedPrefixesRequest filter
                         * @property {number|null} [maxResults] ListGlobalPublicDelegatedPrefixesRequest maxResults
                         * @property {string|null} [orderBy] ListGlobalPublicDelegatedPrefixesRequest orderBy
                         * @property {string|null} [pageToken] ListGlobalPublicDelegatedPrefixesRequest pageToken
                         * @property {string|null} [project] ListGlobalPublicDelegatedPrefixesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListGlobalPublicDelegatedPrefixesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListGlobalPublicDelegatedPrefixesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListGlobalPublicDelegatedPrefixesRequest.
                         * @implements IListGlobalPublicDelegatedPrefixesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListGlobalPublicDelegatedPrefixesRequest=} [properties] Properties to set
                         */
                        function ListGlobalPublicDelegatedPrefixesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListGlobalPublicDelegatedPrefixesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        ListGlobalPublicDelegatedPrefixesRequest.prototype.filter = null;
    
                        /**
                         * ListGlobalPublicDelegatedPrefixesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        ListGlobalPublicDelegatedPrefixesRequest.prototype.maxResults = null;
    
                        /**
                         * ListGlobalPublicDelegatedPrefixesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        ListGlobalPublicDelegatedPrefixesRequest.prototype.orderBy = null;
    
                        /**
                         * ListGlobalPublicDelegatedPrefixesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        ListGlobalPublicDelegatedPrefixesRequest.prototype.pageToken = null;
    
                        /**
                         * ListGlobalPublicDelegatedPrefixesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        ListGlobalPublicDelegatedPrefixesRequest.prototype.project = "";
    
                        /**
                         * ListGlobalPublicDelegatedPrefixesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        ListGlobalPublicDelegatedPrefixesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListGlobalPublicDelegatedPrefixesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalPublicDelegatedPrefixesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalPublicDelegatedPrefixesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalPublicDelegatedPrefixesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalPublicDelegatedPrefixesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalPublicDelegatedPrefixesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalPublicDelegatedPrefixesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalPublicDelegatedPrefixesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListGlobalPublicDelegatedPrefixesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(ListGlobalPublicDelegatedPrefixesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListGlobalPublicDelegatedPrefixesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListGlobalPublicDelegatedPrefixesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest} ListGlobalPublicDelegatedPrefixesRequest instance
                         */
                        ListGlobalPublicDelegatedPrefixesRequest.create = function create(properties) {
                            return new ListGlobalPublicDelegatedPrefixesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListGlobalPublicDelegatedPrefixesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListGlobalPublicDelegatedPrefixesRequest} message ListGlobalPublicDelegatedPrefixesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListGlobalPublicDelegatedPrefixesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListGlobalPublicDelegatedPrefixesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListGlobalPublicDelegatedPrefixesRequest} message ListGlobalPublicDelegatedPrefixesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListGlobalPublicDelegatedPrefixesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListGlobalPublicDelegatedPrefixesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest} ListGlobalPublicDelegatedPrefixesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListGlobalPublicDelegatedPrefixesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListGlobalPublicDelegatedPrefixesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest} ListGlobalPublicDelegatedPrefixesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListGlobalPublicDelegatedPrefixesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListGlobalPublicDelegatedPrefixesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListGlobalPublicDelegatedPrefixesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListGlobalPublicDelegatedPrefixesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest} ListGlobalPublicDelegatedPrefixesRequest
                         */
                        ListGlobalPublicDelegatedPrefixesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListGlobalPublicDelegatedPrefixesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest} message ListGlobalPublicDelegatedPrefixesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListGlobalPublicDelegatedPrefixesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListGlobalPublicDelegatedPrefixesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListGlobalPublicDelegatedPrefixesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListGlobalPublicDelegatedPrefixesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListGlobalPublicDelegatedPrefixesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest";
                        };
    
                        return ListGlobalPublicDelegatedPrefixesRequest;
                    })();
    
                    v1.ListHealthChecksRequest = (function() {
    
                        /**
                         * Properties of a ListHealthChecksRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListHealthChecksRequest
                         * @property {string|null} [filter] ListHealthChecksRequest filter
                         * @property {number|null} [maxResults] ListHealthChecksRequest maxResults
                         * @property {string|null} [orderBy] ListHealthChecksRequest orderBy
                         * @property {string|null} [pageToken] ListHealthChecksRequest pageToken
                         * @property {string|null} [project] ListHealthChecksRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListHealthChecksRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListHealthChecksRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListHealthChecksRequest.
                         * @implements IListHealthChecksRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListHealthChecksRequest=} [properties] Properties to set
                         */
                        function ListHealthChecksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListHealthChecksRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @instance
                         */
                        ListHealthChecksRequest.prototype.filter = null;
    
                        /**
                         * ListHealthChecksRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @instance
                         */
                        ListHealthChecksRequest.prototype.maxResults = null;
    
                        /**
                         * ListHealthChecksRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @instance
                         */
                        ListHealthChecksRequest.prototype.orderBy = null;
    
                        /**
                         * ListHealthChecksRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @instance
                         */
                        ListHealthChecksRequest.prototype.pageToken = null;
    
                        /**
                         * ListHealthChecksRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @instance
                         */
                        ListHealthChecksRequest.prototype.project = "";
    
                        /**
                         * ListHealthChecksRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @instance
                         */
                        ListHealthChecksRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListHealthChecksRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @instance
                         */
                        Object.defineProperty(ListHealthChecksRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListHealthChecksRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @instance
                         */
                        Object.defineProperty(ListHealthChecksRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListHealthChecksRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @instance
                         */
                        Object.defineProperty(ListHealthChecksRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListHealthChecksRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @instance
                         */
                        Object.defineProperty(ListHealthChecksRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListHealthChecksRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @instance
                         */
                        Object.defineProperty(ListHealthChecksRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListHealthChecksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListHealthChecksRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListHealthChecksRequest} ListHealthChecksRequest instance
                         */
                        ListHealthChecksRequest.create = function create(properties) {
                            return new ListHealthChecksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListHealthChecksRequest message. Does not implicitly {@link google.cloud.compute.v1.ListHealthChecksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListHealthChecksRequest} message ListHealthChecksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListHealthChecksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListHealthChecksRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListHealthChecksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListHealthChecksRequest} message ListHealthChecksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListHealthChecksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListHealthChecksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListHealthChecksRequest} ListHealthChecksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListHealthChecksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListHealthChecksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListHealthChecksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListHealthChecksRequest} ListHealthChecksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListHealthChecksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListHealthChecksRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListHealthChecksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListHealthChecksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListHealthChecksRequest} ListHealthChecksRequest
                         */
                        ListHealthChecksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListHealthChecksRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListHealthChecksRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListHealthChecksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListHealthChecksRequest} message ListHealthChecksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListHealthChecksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListHealthChecksRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListHealthChecksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListHealthChecksRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListHealthChecksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListHealthChecksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListHealthChecksRequest";
                        };
    
                        return ListHealthChecksRequest;
                    })();
    
                    v1.ListImagesRequest = (function() {
    
                        /**
                         * Properties of a ListImagesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListImagesRequest
                         * @property {string|null} [filter] ListImagesRequest filter
                         * @property {number|null} [maxResults] ListImagesRequest maxResults
                         * @property {string|null} [orderBy] ListImagesRequest orderBy
                         * @property {string|null} [pageToken] ListImagesRequest pageToken
                         * @property {string|null} [project] ListImagesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListImagesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListImagesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListImagesRequest.
                         * @implements IListImagesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListImagesRequest=} [properties] Properties to set
                         */
                        function ListImagesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListImagesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @instance
                         */
                        ListImagesRequest.prototype.filter = null;
    
                        /**
                         * ListImagesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @instance
                         */
                        ListImagesRequest.prototype.maxResults = null;
    
                        /**
                         * ListImagesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @instance
                         */
                        ListImagesRequest.prototype.orderBy = null;
    
                        /**
                         * ListImagesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @instance
                         */
                        ListImagesRequest.prototype.pageToken = null;
    
                        /**
                         * ListImagesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @instance
                         */
                        ListImagesRequest.prototype.project = "";
    
                        /**
                         * ListImagesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @instance
                         */
                        ListImagesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListImagesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @instance
                         */
                        Object.defineProperty(ListImagesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListImagesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @instance
                         */
                        Object.defineProperty(ListImagesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListImagesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @instance
                         */
                        Object.defineProperty(ListImagesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListImagesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @instance
                         */
                        Object.defineProperty(ListImagesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListImagesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @instance
                         */
                        Object.defineProperty(ListImagesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListImagesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListImagesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListImagesRequest} ListImagesRequest instance
                         */
                        ListImagesRequest.create = function create(properties) {
                            return new ListImagesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListImagesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListImagesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListImagesRequest} message ListImagesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListImagesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListImagesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListImagesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListImagesRequest} message ListImagesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListImagesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListImagesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListImagesRequest} ListImagesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListImagesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListImagesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListImagesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListImagesRequest} ListImagesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListImagesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListImagesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListImagesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListImagesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListImagesRequest} ListImagesRequest
                         */
                        ListImagesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListImagesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListImagesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListImagesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListImagesRequest} message ListImagesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListImagesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListImagesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListImagesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListImagesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListImagesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListImagesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListImagesRequest";
                        };
    
                        return ListImagesRequest;
                    })();
    
                    v1.ListInstanceGroupManagersRequest = (function() {
    
                        /**
                         * Properties of a ListInstanceGroupManagersRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListInstanceGroupManagersRequest
                         * @property {string|null} [filter] ListInstanceGroupManagersRequest filter
                         * @property {number|null} [maxResults] ListInstanceGroupManagersRequest maxResults
                         * @property {string|null} [orderBy] ListInstanceGroupManagersRequest orderBy
                         * @property {string|null} [pageToken] ListInstanceGroupManagersRequest pageToken
                         * @property {string|null} [project] ListInstanceGroupManagersRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListInstanceGroupManagersRequest returnPartialSuccess
                         * @property {string|null} [zone] ListInstanceGroupManagersRequest zone
                         */
    
                        /**
                         * Constructs a new ListInstanceGroupManagersRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListInstanceGroupManagersRequest.
                         * @implements IListInstanceGroupManagersRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListInstanceGroupManagersRequest=} [properties] Properties to set
                         */
                        function ListInstanceGroupManagersRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListInstanceGroupManagersRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @instance
                         */
                        ListInstanceGroupManagersRequest.prototype.filter = null;
    
                        /**
                         * ListInstanceGroupManagersRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @instance
                         */
                        ListInstanceGroupManagersRequest.prototype.maxResults = null;
    
                        /**
                         * ListInstanceGroupManagersRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @instance
                         */
                        ListInstanceGroupManagersRequest.prototype.orderBy = null;
    
                        /**
                         * ListInstanceGroupManagersRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @instance
                         */
                        ListInstanceGroupManagersRequest.prototype.pageToken = null;
    
                        /**
                         * ListInstanceGroupManagersRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @instance
                         */
                        ListInstanceGroupManagersRequest.prototype.project = "";
    
                        /**
                         * ListInstanceGroupManagersRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @instance
                         */
                        ListInstanceGroupManagersRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListInstanceGroupManagersRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @instance
                         */
                        ListInstanceGroupManagersRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListInstanceGroupManagersRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstanceGroupManagersRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstanceGroupManagersRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstanceGroupManagersRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstanceGroupManagersRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstanceGroupManagersRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstanceGroupManagersRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstanceGroupManagersRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstanceGroupManagersRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstanceGroupManagersRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListInstanceGroupManagersRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInstanceGroupManagersRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListInstanceGroupManagersRequest} ListInstanceGroupManagersRequest instance
                         */
                        ListInstanceGroupManagersRequest.create = function create(properties) {
                            return new ListInstanceGroupManagersRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListInstanceGroupManagersRequest message. Does not implicitly {@link google.cloud.compute.v1.ListInstanceGroupManagersRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInstanceGroupManagersRequest} message ListInstanceGroupManagersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListInstanceGroupManagersRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListInstanceGroupManagersRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListInstanceGroupManagersRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInstanceGroupManagersRequest} message ListInstanceGroupManagersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListInstanceGroupManagersRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListInstanceGroupManagersRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListInstanceGroupManagersRequest} ListInstanceGroupManagersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListInstanceGroupManagersRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListInstanceGroupManagersRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListInstanceGroupManagersRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListInstanceGroupManagersRequest} ListInstanceGroupManagersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListInstanceGroupManagersRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListInstanceGroupManagersRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListInstanceGroupManagersRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListInstanceGroupManagersRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListInstanceGroupManagersRequest} ListInstanceGroupManagersRequest
                         */
                        ListInstanceGroupManagersRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListInstanceGroupManagersRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListInstanceGroupManagersRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListInstanceGroupManagersRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListInstanceGroupManagersRequest} message ListInstanceGroupManagersRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListInstanceGroupManagersRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListInstanceGroupManagersRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListInstanceGroupManagersRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListInstanceGroupManagersRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListInstanceGroupManagersRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListInstanceGroupManagersRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListInstanceGroupManagersRequest";
                        };
    
                        return ListInstanceGroupManagersRequest;
                    })();
    
                    v1.ListInstanceGroupsRequest = (function() {
    
                        /**
                         * Properties of a ListInstanceGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListInstanceGroupsRequest
                         * @property {string|null} [filter] ListInstanceGroupsRequest filter
                         * @property {number|null} [maxResults] ListInstanceGroupsRequest maxResults
                         * @property {string|null} [orderBy] ListInstanceGroupsRequest orderBy
                         * @property {string|null} [pageToken] ListInstanceGroupsRequest pageToken
                         * @property {string|null} [project] ListInstanceGroupsRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListInstanceGroupsRequest returnPartialSuccess
                         * @property {string|null} [zone] ListInstanceGroupsRequest zone
                         */
    
                        /**
                         * Constructs a new ListInstanceGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListInstanceGroupsRequest.
                         * @implements IListInstanceGroupsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListInstanceGroupsRequest=} [properties] Properties to set
                         */
                        function ListInstanceGroupsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListInstanceGroupsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @instance
                         */
                        ListInstanceGroupsRequest.prototype.filter = null;
    
                        /**
                         * ListInstanceGroupsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @instance
                         */
                        ListInstanceGroupsRequest.prototype.maxResults = null;
    
                        /**
                         * ListInstanceGroupsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @instance
                         */
                        ListInstanceGroupsRequest.prototype.orderBy = null;
    
                        /**
                         * ListInstanceGroupsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @instance
                         */
                        ListInstanceGroupsRequest.prototype.pageToken = null;
    
                        /**
                         * ListInstanceGroupsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @instance
                         */
                        ListInstanceGroupsRequest.prototype.project = "";
    
                        /**
                         * ListInstanceGroupsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @instance
                         */
                        ListInstanceGroupsRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListInstanceGroupsRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @instance
                         */
                        ListInstanceGroupsRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListInstanceGroupsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstanceGroupsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstanceGroupsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstanceGroupsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstanceGroupsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstanceGroupsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstanceGroupsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstanceGroupsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstanceGroupsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstanceGroupsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListInstanceGroupsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInstanceGroupsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListInstanceGroupsRequest} ListInstanceGroupsRequest instance
                         */
                        ListInstanceGroupsRequest.create = function create(properties) {
                            return new ListInstanceGroupsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListInstanceGroupsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListInstanceGroupsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInstanceGroupsRequest} message ListInstanceGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListInstanceGroupsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListInstanceGroupsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListInstanceGroupsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInstanceGroupsRequest} message ListInstanceGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListInstanceGroupsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListInstanceGroupsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListInstanceGroupsRequest} ListInstanceGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListInstanceGroupsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListInstanceGroupsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListInstanceGroupsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListInstanceGroupsRequest} ListInstanceGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListInstanceGroupsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListInstanceGroupsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListInstanceGroupsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListInstanceGroupsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListInstanceGroupsRequest} ListInstanceGroupsRequest
                         */
                        ListInstanceGroupsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListInstanceGroupsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListInstanceGroupsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListInstanceGroupsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListInstanceGroupsRequest} message ListInstanceGroupsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListInstanceGroupsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListInstanceGroupsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListInstanceGroupsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListInstanceGroupsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListInstanceGroupsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListInstanceGroupsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListInstanceGroupsRequest";
                        };
    
                        return ListInstanceGroupsRequest;
                    })();
    
                    v1.ListInstanceTemplatesRequest = (function() {
    
                        /**
                         * Properties of a ListInstanceTemplatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListInstanceTemplatesRequest
                         * @property {string|null} [filter] ListInstanceTemplatesRequest filter
                         * @property {number|null} [maxResults] ListInstanceTemplatesRequest maxResults
                         * @property {string|null} [orderBy] ListInstanceTemplatesRequest orderBy
                         * @property {string|null} [pageToken] ListInstanceTemplatesRequest pageToken
                         * @property {string|null} [project] ListInstanceTemplatesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListInstanceTemplatesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListInstanceTemplatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListInstanceTemplatesRequest.
                         * @implements IListInstanceTemplatesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListInstanceTemplatesRequest=} [properties] Properties to set
                         */
                        function ListInstanceTemplatesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListInstanceTemplatesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @instance
                         */
                        ListInstanceTemplatesRequest.prototype.filter = null;
    
                        /**
                         * ListInstanceTemplatesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @instance
                         */
                        ListInstanceTemplatesRequest.prototype.maxResults = null;
    
                        /**
                         * ListInstanceTemplatesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @instance
                         */
                        ListInstanceTemplatesRequest.prototype.orderBy = null;
    
                        /**
                         * ListInstanceTemplatesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @instance
                         */
                        ListInstanceTemplatesRequest.prototype.pageToken = null;
    
                        /**
                         * ListInstanceTemplatesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @instance
                         */
                        ListInstanceTemplatesRequest.prototype.project = "";
    
                        /**
                         * ListInstanceTemplatesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @instance
                         */
                        ListInstanceTemplatesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListInstanceTemplatesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstanceTemplatesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstanceTemplatesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstanceTemplatesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstanceTemplatesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstanceTemplatesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstanceTemplatesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstanceTemplatesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstanceTemplatesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstanceTemplatesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListInstanceTemplatesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInstanceTemplatesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListInstanceTemplatesRequest} ListInstanceTemplatesRequest instance
                         */
                        ListInstanceTemplatesRequest.create = function create(properties) {
                            return new ListInstanceTemplatesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListInstanceTemplatesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListInstanceTemplatesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInstanceTemplatesRequest} message ListInstanceTemplatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListInstanceTemplatesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListInstanceTemplatesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListInstanceTemplatesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInstanceTemplatesRequest} message ListInstanceTemplatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListInstanceTemplatesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListInstanceTemplatesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListInstanceTemplatesRequest} ListInstanceTemplatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListInstanceTemplatesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListInstanceTemplatesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListInstanceTemplatesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListInstanceTemplatesRequest} ListInstanceTemplatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListInstanceTemplatesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListInstanceTemplatesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListInstanceTemplatesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListInstanceTemplatesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListInstanceTemplatesRequest} ListInstanceTemplatesRequest
                         */
                        ListInstanceTemplatesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListInstanceTemplatesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListInstanceTemplatesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListInstanceTemplatesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListInstanceTemplatesRequest} message ListInstanceTemplatesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListInstanceTemplatesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListInstanceTemplatesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListInstanceTemplatesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListInstanceTemplatesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListInstanceTemplatesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListInstanceTemplatesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListInstanceTemplatesRequest";
                        };
    
                        return ListInstanceTemplatesRequest;
                    })();
    
                    v1.ListInstancesInstanceGroupsRequest = (function() {
    
                        /**
                         * Properties of a ListInstancesInstanceGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListInstancesInstanceGroupsRequest
                         * @property {string|null} [filter] ListInstancesInstanceGroupsRequest filter
                         * @property {string|null} [instanceGroup] ListInstancesInstanceGroupsRequest instanceGroup
                         * @property {google.cloud.compute.v1.IInstanceGroupsListInstancesRequest|null} [instanceGroupsListInstancesRequestResource] ListInstancesInstanceGroupsRequest instanceGroupsListInstancesRequestResource
                         * @property {number|null} [maxResults] ListInstancesInstanceGroupsRequest maxResults
                         * @property {string|null} [orderBy] ListInstancesInstanceGroupsRequest orderBy
                         * @property {string|null} [pageToken] ListInstancesInstanceGroupsRequest pageToken
                         * @property {string|null} [project] ListInstancesInstanceGroupsRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListInstancesInstanceGroupsRequest returnPartialSuccess
                         * @property {string|null} [zone] ListInstancesInstanceGroupsRequest zone
                         */
    
                        /**
                         * Constructs a new ListInstancesInstanceGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListInstancesInstanceGroupsRequest.
                         * @implements IListInstancesInstanceGroupsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListInstancesInstanceGroupsRequest=} [properties] Properties to set
                         */
                        function ListInstancesInstanceGroupsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListInstancesInstanceGroupsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @instance
                         */
                        ListInstancesInstanceGroupsRequest.prototype.filter = null;
    
                        /**
                         * ListInstancesInstanceGroupsRequest instanceGroup.
                         * @member {string} instanceGroup
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @instance
                         */
                        ListInstancesInstanceGroupsRequest.prototype.instanceGroup = "";
    
                        /**
                         * ListInstancesInstanceGroupsRequest instanceGroupsListInstancesRequestResource.
                         * @member {google.cloud.compute.v1.IInstanceGroupsListInstancesRequest|null|undefined} instanceGroupsListInstancesRequestResource
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @instance
                         */
                        ListInstancesInstanceGroupsRequest.prototype.instanceGroupsListInstancesRequestResource = null;
    
                        /**
                         * ListInstancesInstanceGroupsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @instance
                         */
                        ListInstancesInstanceGroupsRequest.prototype.maxResults = null;
    
                        /**
                         * ListInstancesInstanceGroupsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @instance
                         */
                        ListInstancesInstanceGroupsRequest.prototype.orderBy = null;
    
                        /**
                         * ListInstancesInstanceGroupsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @instance
                         */
                        ListInstancesInstanceGroupsRequest.prototype.pageToken = null;
    
                        /**
                         * ListInstancesInstanceGroupsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @instance
                         */
                        ListInstancesInstanceGroupsRequest.prototype.project = "";
    
                        /**
                         * ListInstancesInstanceGroupsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @instance
                         */
                        ListInstancesInstanceGroupsRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListInstancesInstanceGroupsRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @instance
                         */
                        ListInstancesInstanceGroupsRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListInstancesInstanceGroupsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstancesInstanceGroupsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstancesInstanceGroupsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstancesInstanceGroupsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstancesInstanceGroupsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstancesInstanceGroupsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstancesInstanceGroupsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstancesInstanceGroupsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstancesInstanceGroupsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstancesInstanceGroupsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListInstancesInstanceGroupsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInstancesInstanceGroupsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListInstancesInstanceGroupsRequest} ListInstancesInstanceGroupsRequest instance
                         */
                        ListInstancesInstanceGroupsRequest.create = function create(properties) {
                            return new ListInstancesInstanceGroupsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListInstancesInstanceGroupsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListInstancesInstanceGroupsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInstancesInstanceGroupsRequest} message ListInstancesInstanceGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListInstancesInstanceGroupsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.instanceGroup != null && Object.hasOwnProperty.call(message, "instanceGroup"))
                                writer.uint32(/* id 81095253, wireType 2 =*/648762026).string(message.instanceGroup);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.instanceGroupsListInstancesRequestResource != null && Object.hasOwnProperty.call(message, "instanceGroupsListInstancesRequestResource"))
                                $root.google.cloud.compute.v1.InstanceGroupsListInstancesRequest.encode(message.instanceGroupsListInstancesRequestResource, writer.uint32(/* id 476255263, wireType 2 =*/3810042106).fork()).ldelim();
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListInstancesInstanceGroupsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListInstancesInstanceGroupsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInstancesInstanceGroupsRequest} message ListInstancesInstanceGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListInstancesInstanceGroupsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListInstancesInstanceGroupsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListInstancesInstanceGroupsRequest} ListInstancesInstanceGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListInstancesInstanceGroupsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListInstancesInstanceGroupsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 81095253: {
                                        message.instanceGroup = reader.string();
                                        break;
                                    }
                                case 476255263: {
                                        message.instanceGroupsListInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupsListInstancesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListInstancesInstanceGroupsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListInstancesInstanceGroupsRequest} ListInstancesInstanceGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListInstancesInstanceGroupsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListInstancesInstanceGroupsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListInstancesInstanceGroupsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.instanceGroup != null && message.hasOwnProperty("instanceGroup"))
                                if (!$util.isString(message.instanceGroup))
                                    return "instanceGroup: string expected";
                            if (message.instanceGroupsListInstancesRequestResource != null && message.hasOwnProperty("instanceGroupsListInstancesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceGroupsListInstancesRequest.verify(message.instanceGroupsListInstancesRequestResource);
                                if (error)
                                    return "instanceGroupsListInstancesRequestResource." + error;
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListInstancesInstanceGroupsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListInstancesInstanceGroupsRequest} ListInstancesInstanceGroupsRequest
                         */
                        ListInstancesInstanceGroupsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListInstancesInstanceGroupsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListInstancesInstanceGroupsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.instanceGroup != null)
                                message.instanceGroup = String(object.instanceGroup);
                            if (object.instanceGroupsListInstancesRequestResource != null) {
                                if (typeof object.instanceGroupsListInstancesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ListInstancesInstanceGroupsRequest.instanceGroupsListInstancesRequestResource: object expected");
                                message.instanceGroupsListInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupsListInstancesRequest.fromObject(object.instanceGroupsListInstancesRequestResource);
                            }
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListInstancesInstanceGroupsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListInstancesInstanceGroupsRequest} message ListInstancesInstanceGroupsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListInstancesInstanceGroupsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instanceGroup = "";
                                object.project = "";
                                object.instanceGroupsListInstancesRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.instanceGroup != null && message.hasOwnProperty("instanceGroup"))
                                object.instanceGroup = message.instanceGroup;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.instanceGroupsListInstancesRequestResource != null && message.hasOwnProperty("instanceGroupsListInstancesRequestResource"))
                                object.instanceGroupsListInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupsListInstancesRequest.toObject(message.instanceGroupsListInstancesRequestResource, options);
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListInstancesInstanceGroupsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListInstancesInstanceGroupsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListInstancesInstanceGroupsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListInstancesInstanceGroupsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListInstancesInstanceGroupsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListInstancesInstanceGroupsRequest";
                        };
    
                        return ListInstancesInstanceGroupsRequest;
                    })();
    
                    v1.ListInstancesRegionInstanceGroupsRequest = (function() {
    
                        /**
                         * Properties of a ListInstancesRegionInstanceGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListInstancesRegionInstanceGroupsRequest
                         * @property {string|null} [filter] ListInstancesRegionInstanceGroupsRequest filter
                         * @property {string|null} [instanceGroup] ListInstancesRegionInstanceGroupsRequest instanceGroup
                         * @property {number|null} [maxResults] ListInstancesRegionInstanceGroupsRequest maxResults
                         * @property {string|null} [orderBy] ListInstancesRegionInstanceGroupsRequest orderBy
                         * @property {string|null} [pageToken] ListInstancesRegionInstanceGroupsRequest pageToken
                         * @property {string|null} [project] ListInstancesRegionInstanceGroupsRequest project
                         * @property {string|null} [region] ListInstancesRegionInstanceGroupsRequest region
                         * @property {google.cloud.compute.v1.IRegionInstanceGroupsListInstancesRequest|null} [regionInstanceGroupsListInstancesRequestResource] ListInstancesRegionInstanceGroupsRequest regionInstanceGroupsListInstancesRequestResource
                         * @property {boolean|null} [returnPartialSuccess] ListInstancesRegionInstanceGroupsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListInstancesRegionInstanceGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListInstancesRegionInstanceGroupsRequest.
                         * @implements IListInstancesRegionInstanceGroupsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListInstancesRegionInstanceGroupsRequest=} [properties] Properties to set
                         */
                        function ListInstancesRegionInstanceGroupsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListInstancesRegionInstanceGroupsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @instance
                         */
                        ListInstancesRegionInstanceGroupsRequest.prototype.filter = null;
    
                        /**
                         * ListInstancesRegionInstanceGroupsRequest instanceGroup.
                         * @member {string} instanceGroup
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @instance
                         */
                        ListInstancesRegionInstanceGroupsRequest.prototype.instanceGroup = "";
    
                        /**
                         * ListInstancesRegionInstanceGroupsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @instance
                         */
                        ListInstancesRegionInstanceGroupsRequest.prototype.maxResults = null;
    
                        /**
                         * ListInstancesRegionInstanceGroupsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @instance
                         */
                        ListInstancesRegionInstanceGroupsRequest.prototype.orderBy = null;
    
                        /**
                         * ListInstancesRegionInstanceGroupsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @instance
                         */
                        ListInstancesRegionInstanceGroupsRequest.prototype.pageToken = null;
    
                        /**
                         * ListInstancesRegionInstanceGroupsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @instance
                         */
                        ListInstancesRegionInstanceGroupsRequest.prototype.project = "";
    
                        /**
                         * ListInstancesRegionInstanceGroupsRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @instance
                         */
                        ListInstancesRegionInstanceGroupsRequest.prototype.region = "";
    
                        /**
                         * ListInstancesRegionInstanceGroupsRequest regionInstanceGroupsListInstancesRequestResource.
                         * @member {google.cloud.compute.v1.IRegionInstanceGroupsListInstancesRequest|null|undefined} regionInstanceGroupsListInstancesRequestResource
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @instance
                         */
                        ListInstancesRegionInstanceGroupsRequest.prototype.regionInstanceGroupsListInstancesRequestResource = null;
    
                        /**
                         * ListInstancesRegionInstanceGroupsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @instance
                         */
                        ListInstancesRegionInstanceGroupsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListInstancesRegionInstanceGroupsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstancesRegionInstanceGroupsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstancesRegionInstanceGroupsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstancesRegionInstanceGroupsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstancesRegionInstanceGroupsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstancesRegionInstanceGroupsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstancesRegionInstanceGroupsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstancesRegionInstanceGroupsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstancesRegionInstanceGroupsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstancesRegionInstanceGroupsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListInstancesRegionInstanceGroupsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInstancesRegionInstanceGroupsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest} ListInstancesRegionInstanceGroupsRequest instance
                         */
                        ListInstancesRegionInstanceGroupsRequest.create = function create(properties) {
                            return new ListInstancesRegionInstanceGroupsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListInstancesRegionInstanceGroupsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInstancesRegionInstanceGroupsRequest} message ListInstancesRegionInstanceGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListInstancesRegionInstanceGroupsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.regionInstanceGroupsListInstancesRequestResource != null && Object.hasOwnProperty.call(message, "regionInstanceGroupsListInstancesRequestResource"))
                                $root.google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest.encode(message.regionInstanceGroupsListInstancesRequestResource, writer.uint32(/* id 48239828, wireType 2 =*/385918626).fork()).ldelim();
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.instanceGroup != null && Object.hasOwnProperty.call(message, "instanceGroup"))
                                writer.uint32(/* id 81095253, wireType 2 =*/648762026).string(message.instanceGroup);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListInstancesRegionInstanceGroupsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInstancesRegionInstanceGroupsRequest} message ListInstancesRegionInstanceGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListInstancesRegionInstanceGroupsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListInstancesRegionInstanceGroupsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest} ListInstancesRegionInstanceGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListInstancesRegionInstanceGroupsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 81095253: {
                                        message.instanceGroup = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 48239828: {
                                        message.regionInstanceGroupsListInstancesRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListInstancesRegionInstanceGroupsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest} ListInstancesRegionInstanceGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListInstancesRegionInstanceGroupsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListInstancesRegionInstanceGroupsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListInstancesRegionInstanceGroupsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.instanceGroup != null && message.hasOwnProperty("instanceGroup"))
                                if (!$util.isString(message.instanceGroup))
                                    return "instanceGroup: string expected";
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionInstanceGroupsListInstancesRequestResource != null && message.hasOwnProperty("regionInstanceGroupsListInstancesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest.verify(message.regionInstanceGroupsListInstancesRequestResource);
                                if (error)
                                    return "regionInstanceGroupsListInstancesRequestResource." + error;
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListInstancesRegionInstanceGroupsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest} ListInstancesRegionInstanceGroupsRequest
                         */
                        ListInstancesRegionInstanceGroupsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.instanceGroup != null)
                                message.instanceGroup = String(object.instanceGroup);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionInstanceGroupsListInstancesRequestResource != null) {
                                if (typeof object.regionInstanceGroupsListInstancesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest.regionInstanceGroupsListInstancesRequestResource: object expected");
                                message.regionInstanceGroupsListInstancesRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest.fromObject(object.regionInstanceGroupsListInstancesRequestResource);
                            }
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListInstancesRegionInstanceGroupsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest} message ListInstancesRegionInstanceGroupsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListInstancesRegionInstanceGroupsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.regionInstanceGroupsListInstancesRequestResource = null;
                                object.instanceGroup = "";
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.regionInstanceGroupsListInstancesRequestResource != null && message.hasOwnProperty("regionInstanceGroupsListInstancesRequestResource"))
                                object.regionInstanceGroupsListInstancesRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest.toObject(message.regionInstanceGroupsListInstancesRequestResource, options);
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.instanceGroup != null && message.hasOwnProperty("instanceGroup"))
                                object.instanceGroup = message.instanceGroup;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListInstancesRegionInstanceGroupsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListInstancesRegionInstanceGroupsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListInstancesRegionInstanceGroupsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListInstancesRegionInstanceGroupsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest";
                        };
    
                        return ListInstancesRegionInstanceGroupsRequest;
                    })();
    
                    v1.ListInstancesRequest = (function() {
    
                        /**
                         * Properties of a ListInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListInstancesRequest
                         * @property {string|null} [filter] ListInstancesRequest filter
                         * @property {number|null} [maxResults] ListInstancesRequest maxResults
                         * @property {string|null} [orderBy] ListInstancesRequest orderBy
                         * @property {string|null} [pageToken] ListInstancesRequest pageToken
                         * @property {string|null} [project] ListInstancesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListInstancesRequest returnPartialSuccess
                         * @property {string|null} [zone] ListInstancesRequest zone
                         */
    
                        /**
                         * Constructs a new ListInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListInstancesRequest.
                         * @implements IListInstancesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListInstancesRequest=} [properties] Properties to set
                         */
                        function ListInstancesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListInstancesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @instance
                         */
                        ListInstancesRequest.prototype.filter = null;
    
                        /**
                         * ListInstancesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @instance
                         */
                        ListInstancesRequest.prototype.maxResults = null;
    
                        /**
                         * ListInstancesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @instance
                         */
                        ListInstancesRequest.prototype.orderBy = null;
    
                        /**
                         * ListInstancesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @instance
                         */
                        ListInstancesRequest.prototype.pageToken = null;
    
                        /**
                         * ListInstancesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @instance
                         */
                        ListInstancesRequest.prototype.project = "";
    
                        /**
                         * ListInstancesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @instance
                         */
                        ListInstancesRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListInstancesRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @instance
                         */
                        ListInstancesRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListInstancesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstancesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstancesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstancesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstancesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstancesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstancesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstancesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInstancesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(ListInstancesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListInstancesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInstancesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListInstancesRequest} ListInstancesRequest instance
                         */
                        ListInstancesRequest.create = function create(properties) {
                            return new ListInstancesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListInstancesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListInstancesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInstancesRequest} message ListInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListInstancesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListInstancesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListInstancesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInstancesRequest} message ListInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListInstancesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListInstancesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListInstancesRequest} ListInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListInstancesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListInstancesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListInstancesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListInstancesRequest} ListInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListInstancesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListInstancesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListInstancesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListInstancesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListInstancesRequest} ListInstancesRequest
                         */
                        ListInstancesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListInstancesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListInstancesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListInstancesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListInstancesRequest} message ListInstancesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListInstancesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListInstancesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListInstancesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListInstancesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListInstancesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListInstancesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListInstancesRequest";
                        };
    
                        return ListInstancesRequest;
                    })();
    
                    v1.ListInterconnectAttachmentsRequest = (function() {
    
                        /**
                         * Properties of a ListInterconnectAttachmentsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListInterconnectAttachmentsRequest
                         * @property {string|null} [filter] ListInterconnectAttachmentsRequest filter
                         * @property {number|null} [maxResults] ListInterconnectAttachmentsRequest maxResults
                         * @property {string|null} [orderBy] ListInterconnectAttachmentsRequest orderBy
                         * @property {string|null} [pageToken] ListInterconnectAttachmentsRequest pageToken
                         * @property {string|null} [project] ListInterconnectAttachmentsRequest project
                         * @property {string|null} [region] ListInterconnectAttachmentsRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListInterconnectAttachmentsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListInterconnectAttachmentsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListInterconnectAttachmentsRequest.
                         * @implements IListInterconnectAttachmentsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListInterconnectAttachmentsRequest=} [properties] Properties to set
                         */
                        function ListInterconnectAttachmentsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListInterconnectAttachmentsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @instance
                         */
                        ListInterconnectAttachmentsRequest.prototype.filter = null;
    
                        /**
                         * ListInterconnectAttachmentsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @instance
                         */
                        ListInterconnectAttachmentsRequest.prototype.maxResults = null;
    
                        /**
                         * ListInterconnectAttachmentsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @instance
                         */
                        ListInterconnectAttachmentsRequest.prototype.orderBy = null;
    
                        /**
                         * ListInterconnectAttachmentsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @instance
                         */
                        ListInterconnectAttachmentsRequest.prototype.pageToken = null;
    
                        /**
                         * ListInterconnectAttachmentsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @instance
                         */
                        ListInterconnectAttachmentsRequest.prototype.project = "";
    
                        /**
                         * ListInterconnectAttachmentsRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @instance
                         */
                        ListInterconnectAttachmentsRequest.prototype.region = "";
    
                        /**
                         * ListInterconnectAttachmentsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @instance
                         */
                        ListInterconnectAttachmentsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListInterconnectAttachmentsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInterconnectAttachmentsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInterconnectAttachmentsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInterconnectAttachmentsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInterconnectAttachmentsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInterconnectAttachmentsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInterconnectAttachmentsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInterconnectAttachmentsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInterconnectAttachmentsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInterconnectAttachmentsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListInterconnectAttachmentsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInterconnectAttachmentsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListInterconnectAttachmentsRequest} ListInterconnectAttachmentsRequest instance
                         */
                        ListInterconnectAttachmentsRequest.create = function create(properties) {
                            return new ListInterconnectAttachmentsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListInterconnectAttachmentsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListInterconnectAttachmentsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInterconnectAttachmentsRequest} message ListInterconnectAttachmentsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListInterconnectAttachmentsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListInterconnectAttachmentsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListInterconnectAttachmentsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInterconnectAttachmentsRequest} message ListInterconnectAttachmentsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListInterconnectAttachmentsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListInterconnectAttachmentsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListInterconnectAttachmentsRequest} ListInterconnectAttachmentsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListInterconnectAttachmentsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListInterconnectAttachmentsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListInterconnectAttachmentsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListInterconnectAttachmentsRequest} ListInterconnectAttachmentsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListInterconnectAttachmentsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListInterconnectAttachmentsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListInterconnectAttachmentsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListInterconnectAttachmentsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListInterconnectAttachmentsRequest} ListInterconnectAttachmentsRequest
                         */
                        ListInterconnectAttachmentsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListInterconnectAttachmentsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListInterconnectAttachmentsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListInterconnectAttachmentsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListInterconnectAttachmentsRequest} message ListInterconnectAttachmentsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListInterconnectAttachmentsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListInterconnectAttachmentsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListInterconnectAttachmentsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListInterconnectAttachmentsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListInterconnectAttachmentsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListInterconnectAttachmentsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListInterconnectAttachmentsRequest";
                        };
    
                        return ListInterconnectAttachmentsRequest;
                    })();
    
                    v1.ListInterconnectLocationsRequest = (function() {
    
                        /**
                         * Properties of a ListInterconnectLocationsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListInterconnectLocationsRequest
                         * @property {string|null} [filter] ListInterconnectLocationsRequest filter
                         * @property {number|null} [maxResults] ListInterconnectLocationsRequest maxResults
                         * @property {string|null} [orderBy] ListInterconnectLocationsRequest orderBy
                         * @property {string|null} [pageToken] ListInterconnectLocationsRequest pageToken
                         * @property {string|null} [project] ListInterconnectLocationsRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListInterconnectLocationsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListInterconnectLocationsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListInterconnectLocationsRequest.
                         * @implements IListInterconnectLocationsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListInterconnectLocationsRequest=} [properties] Properties to set
                         */
                        function ListInterconnectLocationsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListInterconnectLocationsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @instance
                         */
                        ListInterconnectLocationsRequest.prototype.filter = null;
    
                        /**
                         * ListInterconnectLocationsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @instance
                         */
                        ListInterconnectLocationsRequest.prototype.maxResults = null;
    
                        /**
                         * ListInterconnectLocationsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @instance
                         */
                        ListInterconnectLocationsRequest.prototype.orderBy = null;
    
                        /**
                         * ListInterconnectLocationsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @instance
                         */
                        ListInterconnectLocationsRequest.prototype.pageToken = null;
    
                        /**
                         * ListInterconnectLocationsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @instance
                         */
                        ListInterconnectLocationsRequest.prototype.project = "";
    
                        /**
                         * ListInterconnectLocationsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @instance
                         */
                        ListInterconnectLocationsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListInterconnectLocationsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInterconnectLocationsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInterconnectLocationsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInterconnectLocationsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInterconnectLocationsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInterconnectLocationsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInterconnectLocationsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInterconnectLocationsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInterconnectLocationsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInterconnectLocationsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListInterconnectLocationsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInterconnectLocationsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListInterconnectLocationsRequest} ListInterconnectLocationsRequest instance
                         */
                        ListInterconnectLocationsRequest.create = function create(properties) {
                            return new ListInterconnectLocationsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListInterconnectLocationsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListInterconnectLocationsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInterconnectLocationsRequest} message ListInterconnectLocationsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListInterconnectLocationsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListInterconnectLocationsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListInterconnectLocationsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInterconnectLocationsRequest} message ListInterconnectLocationsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListInterconnectLocationsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListInterconnectLocationsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListInterconnectLocationsRequest} ListInterconnectLocationsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListInterconnectLocationsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListInterconnectLocationsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListInterconnectLocationsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListInterconnectLocationsRequest} ListInterconnectLocationsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListInterconnectLocationsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListInterconnectLocationsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListInterconnectLocationsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListInterconnectLocationsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListInterconnectLocationsRequest} ListInterconnectLocationsRequest
                         */
                        ListInterconnectLocationsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListInterconnectLocationsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListInterconnectLocationsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListInterconnectLocationsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListInterconnectLocationsRequest} message ListInterconnectLocationsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListInterconnectLocationsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListInterconnectLocationsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListInterconnectLocationsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListInterconnectLocationsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListInterconnectLocationsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListInterconnectLocationsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListInterconnectLocationsRequest";
                        };
    
                        return ListInterconnectLocationsRequest;
                    })();
    
                    v1.ListInterconnectsRequest = (function() {
    
                        /**
                         * Properties of a ListInterconnectsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListInterconnectsRequest
                         * @property {string|null} [filter] ListInterconnectsRequest filter
                         * @property {number|null} [maxResults] ListInterconnectsRequest maxResults
                         * @property {string|null} [orderBy] ListInterconnectsRequest orderBy
                         * @property {string|null} [pageToken] ListInterconnectsRequest pageToken
                         * @property {string|null} [project] ListInterconnectsRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListInterconnectsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListInterconnectsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListInterconnectsRequest.
                         * @implements IListInterconnectsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListInterconnectsRequest=} [properties] Properties to set
                         */
                        function ListInterconnectsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListInterconnectsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @instance
                         */
                        ListInterconnectsRequest.prototype.filter = null;
    
                        /**
                         * ListInterconnectsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @instance
                         */
                        ListInterconnectsRequest.prototype.maxResults = null;
    
                        /**
                         * ListInterconnectsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @instance
                         */
                        ListInterconnectsRequest.prototype.orderBy = null;
    
                        /**
                         * ListInterconnectsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @instance
                         */
                        ListInterconnectsRequest.prototype.pageToken = null;
    
                        /**
                         * ListInterconnectsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @instance
                         */
                        ListInterconnectsRequest.prototype.project = "";
    
                        /**
                         * ListInterconnectsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @instance
                         */
                        ListInterconnectsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListInterconnectsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInterconnectsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInterconnectsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInterconnectsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInterconnectsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInterconnectsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInterconnectsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInterconnectsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListInterconnectsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @instance
                         */
                        Object.defineProperty(ListInterconnectsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListInterconnectsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInterconnectsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListInterconnectsRequest} ListInterconnectsRequest instance
                         */
                        ListInterconnectsRequest.create = function create(properties) {
                            return new ListInterconnectsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListInterconnectsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListInterconnectsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInterconnectsRequest} message ListInterconnectsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListInterconnectsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListInterconnectsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListInterconnectsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListInterconnectsRequest} message ListInterconnectsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListInterconnectsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListInterconnectsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListInterconnectsRequest} ListInterconnectsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListInterconnectsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListInterconnectsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListInterconnectsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListInterconnectsRequest} ListInterconnectsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListInterconnectsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListInterconnectsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListInterconnectsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListInterconnectsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListInterconnectsRequest} ListInterconnectsRequest
                         */
                        ListInterconnectsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListInterconnectsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListInterconnectsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListInterconnectsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListInterconnectsRequest} message ListInterconnectsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListInterconnectsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListInterconnectsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListInterconnectsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListInterconnectsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListInterconnectsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListInterconnectsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListInterconnectsRequest";
                        };
    
                        return ListInterconnectsRequest;
                    })();
    
                    v1.ListLicensesRequest = (function() {
    
                        /**
                         * Properties of a ListLicensesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListLicensesRequest
                         * @property {string|null} [filter] ListLicensesRequest filter
                         * @property {number|null} [maxResults] ListLicensesRequest maxResults
                         * @property {string|null} [orderBy] ListLicensesRequest orderBy
                         * @property {string|null} [pageToken] ListLicensesRequest pageToken
                         * @property {string|null} [project] ListLicensesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListLicensesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListLicensesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListLicensesRequest.
                         * @implements IListLicensesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListLicensesRequest=} [properties] Properties to set
                         */
                        function ListLicensesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListLicensesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @instance
                         */
                        ListLicensesRequest.prototype.filter = null;
    
                        /**
                         * ListLicensesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @instance
                         */
                        ListLicensesRequest.prototype.maxResults = null;
    
                        /**
                         * ListLicensesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @instance
                         */
                        ListLicensesRequest.prototype.orderBy = null;
    
                        /**
                         * ListLicensesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @instance
                         */
                        ListLicensesRequest.prototype.pageToken = null;
    
                        /**
                         * ListLicensesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @instance
                         */
                        ListLicensesRequest.prototype.project = "";
    
                        /**
                         * ListLicensesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @instance
                         */
                        ListLicensesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListLicensesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @instance
                         */
                        Object.defineProperty(ListLicensesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListLicensesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @instance
                         */
                        Object.defineProperty(ListLicensesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListLicensesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @instance
                         */
                        Object.defineProperty(ListLicensesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListLicensesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @instance
                         */
                        Object.defineProperty(ListLicensesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListLicensesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @instance
                         */
                        Object.defineProperty(ListLicensesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListLicensesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListLicensesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListLicensesRequest} ListLicensesRequest instance
                         */
                        ListLicensesRequest.create = function create(properties) {
                            return new ListLicensesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListLicensesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListLicensesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListLicensesRequest} message ListLicensesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListLicensesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListLicensesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListLicensesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListLicensesRequest} message ListLicensesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListLicensesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListLicensesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListLicensesRequest} ListLicensesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListLicensesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListLicensesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListLicensesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListLicensesRequest} ListLicensesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListLicensesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListLicensesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListLicensesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListLicensesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListLicensesRequest} ListLicensesRequest
                         */
                        ListLicensesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListLicensesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListLicensesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListLicensesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListLicensesRequest} message ListLicensesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListLicensesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListLicensesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListLicensesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListLicensesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListLicensesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListLicensesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListLicensesRequest";
                        };
    
                        return ListLicensesRequest;
                    })();
    
                    v1.ListMachineImagesRequest = (function() {
    
                        /**
                         * Properties of a ListMachineImagesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListMachineImagesRequest
                         * @property {string|null} [filter] ListMachineImagesRequest filter
                         * @property {number|null} [maxResults] ListMachineImagesRequest maxResults
                         * @property {string|null} [orderBy] ListMachineImagesRequest orderBy
                         * @property {string|null} [pageToken] ListMachineImagesRequest pageToken
                         * @property {string|null} [project] ListMachineImagesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListMachineImagesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListMachineImagesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListMachineImagesRequest.
                         * @implements IListMachineImagesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListMachineImagesRequest=} [properties] Properties to set
                         */
                        function ListMachineImagesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListMachineImagesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @instance
                         */
                        ListMachineImagesRequest.prototype.filter = null;
    
                        /**
                         * ListMachineImagesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @instance
                         */
                        ListMachineImagesRequest.prototype.maxResults = null;
    
                        /**
                         * ListMachineImagesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @instance
                         */
                        ListMachineImagesRequest.prototype.orderBy = null;
    
                        /**
                         * ListMachineImagesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @instance
                         */
                        ListMachineImagesRequest.prototype.pageToken = null;
    
                        /**
                         * ListMachineImagesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @instance
                         */
                        ListMachineImagesRequest.prototype.project = "";
    
                        /**
                         * ListMachineImagesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @instance
                         */
                        ListMachineImagesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListMachineImagesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @instance
                         */
                        Object.defineProperty(ListMachineImagesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListMachineImagesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @instance
                         */
                        Object.defineProperty(ListMachineImagesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListMachineImagesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @instance
                         */
                        Object.defineProperty(ListMachineImagesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListMachineImagesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @instance
                         */
                        Object.defineProperty(ListMachineImagesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListMachineImagesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @instance
                         */
                        Object.defineProperty(ListMachineImagesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListMachineImagesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListMachineImagesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListMachineImagesRequest} ListMachineImagesRequest instance
                         */
                        ListMachineImagesRequest.create = function create(properties) {
                            return new ListMachineImagesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListMachineImagesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListMachineImagesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListMachineImagesRequest} message ListMachineImagesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListMachineImagesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListMachineImagesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListMachineImagesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListMachineImagesRequest} message ListMachineImagesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListMachineImagesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListMachineImagesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListMachineImagesRequest} ListMachineImagesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListMachineImagesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListMachineImagesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListMachineImagesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListMachineImagesRequest} ListMachineImagesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListMachineImagesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListMachineImagesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListMachineImagesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListMachineImagesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListMachineImagesRequest} ListMachineImagesRequest
                         */
                        ListMachineImagesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListMachineImagesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListMachineImagesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListMachineImagesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListMachineImagesRequest} message ListMachineImagesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListMachineImagesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListMachineImagesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListMachineImagesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListMachineImagesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListMachineImagesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListMachineImagesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListMachineImagesRequest";
                        };
    
                        return ListMachineImagesRequest;
                    })();
    
                    v1.ListMachineTypesRequest = (function() {
    
                        /**
                         * Properties of a ListMachineTypesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListMachineTypesRequest
                         * @property {string|null} [filter] ListMachineTypesRequest filter
                         * @property {number|null} [maxResults] ListMachineTypesRequest maxResults
                         * @property {string|null} [orderBy] ListMachineTypesRequest orderBy
                         * @property {string|null} [pageToken] ListMachineTypesRequest pageToken
                         * @property {string|null} [project] ListMachineTypesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListMachineTypesRequest returnPartialSuccess
                         * @property {string|null} [zone] ListMachineTypesRequest zone
                         */
    
                        /**
                         * Constructs a new ListMachineTypesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListMachineTypesRequest.
                         * @implements IListMachineTypesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListMachineTypesRequest=} [properties] Properties to set
                         */
                        function ListMachineTypesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListMachineTypesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @instance
                         */
                        ListMachineTypesRequest.prototype.filter = null;
    
                        /**
                         * ListMachineTypesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @instance
                         */
                        ListMachineTypesRequest.prototype.maxResults = null;
    
                        /**
                         * ListMachineTypesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @instance
                         */
                        ListMachineTypesRequest.prototype.orderBy = null;
    
                        /**
                         * ListMachineTypesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @instance
                         */
                        ListMachineTypesRequest.prototype.pageToken = null;
    
                        /**
                         * ListMachineTypesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @instance
                         */
                        ListMachineTypesRequest.prototype.project = "";
    
                        /**
                         * ListMachineTypesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @instance
                         */
                        ListMachineTypesRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListMachineTypesRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @instance
                         */
                        ListMachineTypesRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListMachineTypesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListMachineTypesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListMachineTypesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListMachineTypesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListMachineTypesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListMachineTypesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListMachineTypesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListMachineTypesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListMachineTypesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListMachineTypesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListMachineTypesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListMachineTypesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListMachineTypesRequest} ListMachineTypesRequest instance
                         */
                        ListMachineTypesRequest.create = function create(properties) {
                            return new ListMachineTypesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListMachineTypesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListMachineTypesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListMachineTypesRequest} message ListMachineTypesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListMachineTypesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListMachineTypesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListMachineTypesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListMachineTypesRequest} message ListMachineTypesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListMachineTypesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListMachineTypesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListMachineTypesRequest} ListMachineTypesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListMachineTypesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListMachineTypesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListMachineTypesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListMachineTypesRequest} ListMachineTypesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListMachineTypesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListMachineTypesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListMachineTypesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListMachineTypesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListMachineTypesRequest} ListMachineTypesRequest
                         */
                        ListMachineTypesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListMachineTypesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListMachineTypesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListMachineTypesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListMachineTypesRequest} message ListMachineTypesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListMachineTypesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListMachineTypesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListMachineTypesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListMachineTypesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListMachineTypesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListMachineTypesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListMachineTypesRequest";
                        };
    
                        return ListMachineTypesRequest;
                    })();
    
                    v1.ListManagedInstancesInstanceGroupManagersRequest = (function() {
    
                        /**
                         * Properties of a ListManagedInstancesInstanceGroupManagersRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListManagedInstancesInstanceGroupManagersRequest
                         * @property {string|null} [filter] ListManagedInstancesInstanceGroupManagersRequest filter
                         * @property {string|null} [instanceGroupManager] ListManagedInstancesInstanceGroupManagersRequest instanceGroupManager
                         * @property {number|null} [maxResults] ListManagedInstancesInstanceGroupManagersRequest maxResults
                         * @property {string|null} [orderBy] ListManagedInstancesInstanceGroupManagersRequest orderBy
                         * @property {string|null} [pageToken] ListManagedInstancesInstanceGroupManagersRequest pageToken
                         * @property {string|null} [project] ListManagedInstancesInstanceGroupManagersRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListManagedInstancesInstanceGroupManagersRequest returnPartialSuccess
                         * @property {string|null} [zone] ListManagedInstancesInstanceGroupManagersRequest zone
                         */
    
                        /**
                         * Constructs a new ListManagedInstancesInstanceGroupManagersRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListManagedInstancesInstanceGroupManagersRequest.
                         * @implements IListManagedInstancesInstanceGroupManagersRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListManagedInstancesInstanceGroupManagersRequest=} [properties] Properties to set
                         */
                        function ListManagedInstancesInstanceGroupManagersRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListManagedInstancesInstanceGroupManagersRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @instance
                         */
                        ListManagedInstancesInstanceGroupManagersRequest.prototype.filter = null;
    
                        /**
                         * ListManagedInstancesInstanceGroupManagersRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @instance
                         */
                        ListManagedInstancesInstanceGroupManagersRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * ListManagedInstancesInstanceGroupManagersRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @instance
                         */
                        ListManagedInstancesInstanceGroupManagersRequest.prototype.maxResults = null;
    
                        /**
                         * ListManagedInstancesInstanceGroupManagersRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @instance
                         */
                        ListManagedInstancesInstanceGroupManagersRequest.prototype.orderBy = null;
    
                        /**
                         * ListManagedInstancesInstanceGroupManagersRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @instance
                         */
                        ListManagedInstancesInstanceGroupManagersRequest.prototype.pageToken = null;
    
                        /**
                         * ListManagedInstancesInstanceGroupManagersRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @instance
                         */
                        ListManagedInstancesInstanceGroupManagersRequest.prototype.project = "";
    
                        /**
                         * ListManagedInstancesInstanceGroupManagersRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @instance
                         */
                        ListManagedInstancesInstanceGroupManagersRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListManagedInstancesInstanceGroupManagersRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @instance
                         */
                        ListManagedInstancesInstanceGroupManagersRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListManagedInstancesInstanceGroupManagersRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListManagedInstancesInstanceGroupManagersRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListManagedInstancesInstanceGroupManagersRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListManagedInstancesInstanceGroupManagersRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListManagedInstancesInstanceGroupManagersRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListManagedInstancesInstanceGroupManagersRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListManagedInstancesInstanceGroupManagersRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListManagedInstancesInstanceGroupManagersRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListManagedInstancesInstanceGroupManagersRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListManagedInstancesInstanceGroupManagersRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListManagedInstancesInstanceGroupManagersRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListManagedInstancesInstanceGroupManagersRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest} ListManagedInstancesInstanceGroupManagersRequest instance
                         */
                        ListManagedInstancesInstanceGroupManagersRequest.create = function create(properties) {
                            return new ListManagedInstancesInstanceGroupManagersRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListManagedInstancesInstanceGroupManagersRequest message. Does not implicitly {@link google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListManagedInstancesInstanceGroupManagersRequest} message ListManagedInstancesInstanceGroupManagersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListManagedInstancesInstanceGroupManagersRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListManagedInstancesInstanceGroupManagersRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListManagedInstancesInstanceGroupManagersRequest} message ListManagedInstancesInstanceGroupManagersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListManagedInstancesInstanceGroupManagersRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListManagedInstancesInstanceGroupManagersRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest} ListManagedInstancesInstanceGroupManagersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListManagedInstancesInstanceGroupManagersRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListManagedInstancesInstanceGroupManagersRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest} ListManagedInstancesInstanceGroupManagersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListManagedInstancesInstanceGroupManagersRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListManagedInstancesInstanceGroupManagersRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListManagedInstancesInstanceGroupManagersRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListManagedInstancesInstanceGroupManagersRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest} ListManagedInstancesInstanceGroupManagersRequest
                         */
                        ListManagedInstancesInstanceGroupManagersRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListManagedInstancesInstanceGroupManagersRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest} message ListManagedInstancesInstanceGroupManagersRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListManagedInstancesInstanceGroupManagersRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListManagedInstancesInstanceGroupManagersRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListManagedInstancesInstanceGroupManagersRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListManagedInstancesInstanceGroupManagersRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListManagedInstancesInstanceGroupManagersRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest";
                        };
    
                        return ListManagedInstancesInstanceGroupManagersRequest;
                    })();
    
                    v1.ListManagedInstancesRegionInstanceGroupManagersRequest = (function() {
    
                        /**
                         * Properties of a ListManagedInstancesRegionInstanceGroupManagersRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListManagedInstancesRegionInstanceGroupManagersRequest
                         * @property {string|null} [filter] ListManagedInstancesRegionInstanceGroupManagersRequest filter
                         * @property {string|null} [instanceGroupManager] ListManagedInstancesRegionInstanceGroupManagersRequest instanceGroupManager
                         * @property {number|null} [maxResults] ListManagedInstancesRegionInstanceGroupManagersRequest maxResults
                         * @property {string|null} [orderBy] ListManagedInstancesRegionInstanceGroupManagersRequest orderBy
                         * @property {string|null} [pageToken] ListManagedInstancesRegionInstanceGroupManagersRequest pageToken
                         * @property {string|null} [project] ListManagedInstancesRegionInstanceGroupManagersRequest project
                         * @property {string|null} [region] ListManagedInstancesRegionInstanceGroupManagersRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListManagedInstancesRegionInstanceGroupManagersRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListManagedInstancesRegionInstanceGroupManagersRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListManagedInstancesRegionInstanceGroupManagersRequest.
                         * @implements IListManagedInstancesRegionInstanceGroupManagersRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListManagedInstancesRegionInstanceGroupManagersRequest=} [properties] Properties to set
                         */
                        function ListManagedInstancesRegionInstanceGroupManagersRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListManagedInstancesRegionInstanceGroupManagersRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListManagedInstancesRegionInstanceGroupManagersRequest.prototype.filter = null;
    
                        /**
                         * ListManagedInstancesRegionInstanceGroupManagersRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListManagedInstancesRegionInstanceGroupManagersRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * ListManagedInstancesRegionInstanceGroupManagersRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListManagedInstancesRegionInstanceGroupManagersRequest.prototype.maxResults = null;
    
                        /**
                         * ListManagedInstancesRegionInstanceGroupManagersRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListManagedInstancesRegionInstanceGroupManagersRequest.prototype.orderBy = null;
    
                        /**
                         * ListManagedInstancesRegionInstanceGroupManagersRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListManagedInstancesRegionInstanceGroupManagersRequest.prototype.pageToken = null;
    
                        /**
                         * ListManagedInstancesRegionInstanceGroupManagersRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListManagedInstancesRegionInstanceGroupManagersRequest.prototype.project = "";
    
                        /**
                         * ListManagedInstancesRegionInstanceGroupManagersRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListManagedInstancesRegionInstanceGroupManagersRequest.prototype.region = "";
    
                        /**
                         * ListManagedInstancesRegionInstanceGroupManagersRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListManagedInstancesRegionInstanceGroupManagersRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListManagedInstancesRegionInstanceGroupManagersRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListManagedInstancesRegionInstanceGroupManagersRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListManagedInstancesRegionInstanceGroupManagersRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListManagedInstancesRegionInstanceGroupManagersRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListManagedInstancesRegionInstanceGroupManagersRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListManagedInstancesRegionInstanceGroupManagersRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListManagedInstancesRegionInstanceGroupManagersRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListManagedInstancesRegionInstanceGroupManagersRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListManagedInstancesRegionInstanceGroupManagersRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListManagedInstancesRegionInstanceGroupManagersRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListManagedInstancesRegionInstanceGroupManagersRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListManagedInstancesRegionInstanceGroupManagersRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest} ListManagedInstancesRegionInstanceGroupManagersRequest instance
                         */
                        ListManagedInstancesRegionInstanceGroupManagersRequest.create = function create(properties) {
                            return new ListManagedInstancesRegionInstanceGroupManagersRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListManagedInstancesRegionInstanceGroupManagersRequest message. Does not implicitly {@link google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListManagedInstancesRegionInstanceGroupManagersRequest} message ListManagedInstancesRegionInstanceGroupManagersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListManagedInstancesRegionInstanceGroupManagersRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListManagedInstancesRegionInstanceGroupManagersRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListManagedInstancesRegionInstanceGroupManagersRequest} message ListManagedInstancesRegionInstanceGroupManagersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListManagedInstancesRegionInstanceGroupManagersRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListManagedInstancesRegionInstanceGroupManagersRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest} ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListManagedInstancesRegionInstanceGroupManagersRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListManagedInstancesRegionInstanceGroupManagersRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest} ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListManagedInstancesRegionInstanceGroupManagersRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListManagedInstancesRegionInstanceGroupManagersRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListManagedInstancesRegionInstanceGroupManagersRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListManagedInstancesRegionInstanceGroupManagersRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest} ListManagedInstancesRegionInstanceGroupManagersRequest
                         */
                        ListManagedInstancesRegionInstanceGroupManagersRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListManagedInstancesRegionInstanceGroupManagersRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest} message ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListManagedInstancesRegionInstanceGroupManagersRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListManagedInstancesRegionInstanceGroupManagersRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListManagedInstancesRegionInstanceGroupManagersRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListManagedInstancesRegionInstanceGroupManagersRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest";
                        };
    
                        return ListManagedInstancesRegionInstanceGroupManagersRequest;
                    })();
    
                    v1.ListNetworkEndpointGroupsRequest = (function() {
    
                        /**
                         * Properties of a ListNetworkEndpointGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListNetworkEndpointGroupsRequest
                         * @property {string|null} [filter] ListNetworkEndpointGroupsRequest filter
                         * @property {number|null} [maxResults] ListNetworkEndpointGroupsRequest maxResults
                         * @property {string|null} [orderBy] ListNetworkEndpointGroupsRequest orderBy
                         * @property {string|null} [pageToken] ListNetworkEndpointGroupsRequest pageToken
                         * @property {string|null} [project] ListNetworkEndpointGroupsRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListNetworkEndpointGroupsRequest returnPartialSuccess
                         * @property {string|null} [zone] ListNetworkEndpointGroupsRequest zone
                         */
    
                        /**
                         * Constructs a new ListNetworkEndpointGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListNetworkEndpointGroupsRequest.
                         * @implements IListNetworkEndpointGroupsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListNetworkEndpointGroupsRequest=} [properties] Properties to set
                         */
                        function ListNetworkEndpointGroupsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListNetworkEndpointGroupsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointGroupsRequest.prototype.filter = null;
    
                        /**
                         * ListNetworkEndpointGroupsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointGroupsRequest.prototype.maxResults = null;
    
                        /**
                         * ListNetworkEndpointGroupsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointGroupsRequest.prototype.orderBy = null;
    
                        /**
                         * ListNetworkEndpointGroupsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointGroupsRequest.prototype.pageToken = null;
    
                        /**
                         * ListNetworkEndpointGroupsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointGroupsRequest.prototype.project = "";
    
                        /**
                         * ListNetworkEndpointGroupsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointGroupsRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListNetworkEndpointGroupsRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointGroupsRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListNetworkEndpointGroupsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworkEndpointGroupsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNetworkEndpointGroupsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworkEndpointGroupsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNetworkEndpointGroupsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworkEndpointGroupsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNetworkEndpointGroupsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworkEndpointGroupsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNetworkEndpointGroupsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworkEndpointGroupsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListNetworkEndpointGroupsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNetworkEndpointGroupsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListNetworkEndpointGroupsRequest} ListNetworkEndpointGroupsRequest instance
                         */
                        ListNetworkEndpointGroupsRequest.create = function create(properties) {
                            return new ListNetworkEndpointGroupsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListNetworkEndpointGroupsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListNetworkEndpointGroupsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNetworkEndpointGroupsRequest} message ListNetworkEndpointGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListNetworkEndpointGroupsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListNetworkEndpointGroupsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListNetworkEndpointGroupsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNetworkEndpointGroupsRequest} message ListNetworkEndpointGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListNetworkEndpointGroupsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListNetworkEndpointGroupsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListNetworkEndpointGroupsRequest} ListNetworkEndpointGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListNetworkEndpointGroupsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListNetworkEndpointGroupsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListNetworkEndpointGroupsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListNetworkEndpointGroupsRequest} ListNetworkEndpointGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListNetworkEndpointGroupsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListNetworkEndpointGroupsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListNetworkEndpointGroupsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListNetworkEndpointGroupsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListNetworkEndpointGroupsRequest} ListNetworkEndpointGroupsRequest
                         */
                        ListNetworkEndpointGroupsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListNetworkEndpointGroupsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListNetworkEndpointGroupsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListNetworkEndpointGroupsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListNetworkEndpointGroupsRequest} message ListNetworkEndpointGroupsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListNetworkEndpointGroupsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListNetworkEndpointGroupsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListNetworkEndpointGroupsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListNetworkEndpointGroupsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointGroupsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListNetworkEndpointGroupsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListNetworkEndpointGroupsRequest";
                        };
    
                        return ListNetworkEndpointGroupsRequest;
                    })();
    
                    v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest = (function() {
    
                        /**
                         * Properties of a ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @property {string|null} [filter] ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest filter
                         * @property {number|null} [maxResults] ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest maxResults
                         * @property {string|null} [networkEndpointGroup] ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest networkEndpointGroup
                         * @property {string|null} [orderBy] ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest orderBy
                         * @property {string|null} [pageToken] ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest pageToken
                         * @property {string|null} [project] ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.
                         * @implements IListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListNetworkEndpointsGlobalNetworkEndpointGroupsRequest=} [properties] Properties to set
                         */
                        function ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.prototype.filter = null;
    
                        /**
                         * ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.prototype.maxResults = null;
    
                        /**
                         * ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest networkEndpointGroup.
                         * @member {string} networkEndpointGroup
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.prototype.networkEndpointGroup = "";
    
                        /**
                         * ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.prototype.orderBy = null;
    
                        /**
                         * ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.prototype.pageToken = null;
    
                        /**
                         * ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.prototype.project = "";
    
                        /**
                         * ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNetworkEndpointsGlobalNetworkEndpointGroupsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest} ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest instance
                         */
                        ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.create = function create(properties) {
                            return new ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNetworkEndpointsGlobalNetworkEndpointGroupsRequest} message ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.networkEndpointGroup != null && Object.hasOwnProperty.call(message, "networkEndpointGroup"))
                                writer.uint32(/* id 433907078, wireType 2 =*/3471256626).string(message.networkEndpointGroup);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNetworkEndpointsGlobalNetworkEndpointGroupsRequest} message ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest} ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 433907078: {
                                        message.networkEndpointGroup = reader.string();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest} ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                if (!$util.isString(message.networkEndpointGroup))
                                    return "networkEndpointGroup: string expected";
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest} ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         */
                        ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.networkEndpointGroup != null)
                                message.networkEndpointGroup = String(object.networkEndpointGroup);
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest} message ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.networkEndpointGroup = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                object.networkEndpointGroup = message.networkEndpointGroup;
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest";
                        };
    
                        return ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest;
                    })();
    
                    v1.ListNetworkEndpointsNetworkEndpointGroupsRequest = (function() {
    
                        /**
                         * Properties of a ListNetworkEndpointsNetworkEndpointGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @property {string|null} [filter] ListNetworkEndpointsNetworkEndpointGroupsRequest filter
                         * @property {number|null} [maxResults] ListNetworkEndpointsNetworkEndpointGroupsRequest maxResults
                         * @property {string|null} [networkEndpointGroup] ListNetworkEndpointsNetworkEndpointGroupsRequest networkEndpointGroup
                         * @property {google.cloud.compute.v1.INetworkEndpointGroupsListEndpointsRequest|null} [networkEndpointGroupsListEndpointsRequestResource] ListNetworkEndpointsNetworkEndpointGroupsRequest networkEndpointGroupsListEndpointsRequestResource
                         * @property {string|null} [orderBy] ListNetworkEndpointsNetworkEndpointGroupsRequest orderBy
                         * @property {string|null} [pageToken] ListNetworkEndpointsNetworkEndpointGroupsRequest pageToken
                         * @property {string|null} [project] ListNetworkEndpointsNetworkEndpointGroupsRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListNetworkEndpointsNetworkEndpointGroupsRequest returnPartialSuccess
                         * @property {string|null} [zone] ListNetworkEndpointsNetworkEndpointGroupsRequest zone
                         */
    
                        /**
                         * Constructs a new ListNetworkEndpointsNetworkEndpointGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListNetworkEndpointsNetworkEndpointGroupsRequest.
                         * @implements IListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListNetworkEndpointsNetworkEndpointGroupsRequest=} [properties] Properties to set
                         */
                        function ListNetworkEndpointsNetworkEndpointGroupsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListNetworkEndpointsNetworkEndpointGroupsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointsNetworkEndpointGroupsRequest.prototype.filter = null;
    
                        /**
                         * ListNetworkEndpointsNetworkEndpointGroupsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointsNetworkEndpointGroupsRequest.prototype.maxResults = null;
    
                        /**
                         * ListNetworkEndpointsNetworkEndpointGroupsRequest networkEndpointGroup.
                         * @member {string} networkEndpointGroup
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointsNetworkEndpointGroupsRequest.prototype.networkEndpointGroup = "";
    
                        /**
                         * ListNetworkEndpointsNetworkEndpointGroupsRequest networkEndpointGroupsListEndpointsRequestResource.
                         * @member {google.cloud.compute.v1.INetworkEndpointGroupsListEndpointsRequest|null|undefined} networkEndpointGroupsListEndpointsRequestResource
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointsNetworkEndpointGroupsRequest.prototype.networkEndpointGroupsListEndpointsRequestResource = null;
    
                        /**
                         * ListNetworkEndpointsNetworkEndpointGroupsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointsNetworkEndpointGroupsRequest.prototype.orderBy = null;
    
                        /**
                         * ListNetworkEndpointsNetworkEndpointGroupsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointsNetworkEndpointGroupsRequest.prototype.pageToken = null;
    
                        /**
                         * ListNetworkEndpointsNetworkEndpointGroupsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointsNetworkEndpointGroupsRequest.prototype.project = "";
    
                        /**
                         * ListNetworkEndpointsNetworkEndpointGroupsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointsNetworkEndpointGroupsRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListNetworkEndpointsNetworkEndpointGroupsRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListNetworkEndpointsNetworkEndpointGroupsRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListNetworkEndpointsNetworkEndpointGroupsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworkEndpointsNetworkEndpointGroupsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNetworkEndpointsNetworkEndpointGroupsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworkEndpointsNetworkEndpointGroupsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNetworkEndpointsNetworkEndpointGroupsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworkEndpointsNetworkEndpointGroupsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNetworkEndpointsNetworkEndpointGroupsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworkEndpointsNetworkEndpointGroupsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNetworkEndpointsNetworkEndpointGroupsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworkEndpointsNetworkEndpointGroupsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListNetworkEndpointsNetworkEndpointGroupsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNetworkEndpointsNetworkEndpointGroupsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest} ListNetworkEndpointsNetworkEndpointGroupsRequest instance
                         */
                        ListNetworkEndpointsNetworkEndpointGroupsRequest.create = function create(properties) {
                            return new ListNetworkEndpointsNetworkEndpointGroupsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListNetworkEndpointsNetworkEndpointGroupsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNetworkEndpointsNetworkEndpointGroupsRequest} message ListNetworkEndpointsNetworkEndpointGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListNetworkEndpointsNetworkEndpointGroupsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.networkEndpointGroupsListEndpointsRequestResource != null && Object.hasOwnProperty.call(message, "networkEndpointGroupsListEndpointsRequestResource"))
                                $root.google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest.encode(message.networkEndpointGroupsListEndpointsRequestResource, writer.uint32(/* id 59493390, wireType 2 =*/475947122).fork()).ldelim();
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.networkEndpointGroup != null && Object.hasOwnProperty.call(message, "networkEndpointGroup"))
                                writer.uint32(/* id 433907078, wireType 2 =*/3471256626).string(message.networkEndpointGroup);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListNetworkEndpointsNetworkEndpointGroupsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNetworkEndpointsNetworkEndpointGroupsRequest} message ListNetworkEndpointsNetworkEndpointGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListNetworkEndpointsNetworkEndpointGroupsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListNetworkEndpointsNetworkEndpointGroupsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest} ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListNetworkEndpointsNetworkEndpointGroupsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 433907078: {
                                        message.networkEndpointGroup = reader.string();
                                        break;
                                    }
                                case 59493390: {
                                        message.networkEndpointGroupsListEndpointsRequestResource = $root.google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListNetworkEndpointsNetworkEndpointGroupsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest} ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListNetworkEndpointsNetworkEndpointGroupsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListNetworkEndpointsNetworkEndpointGroupsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListNetworkEndpointsNetworkEndpointGroupsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                if (!$util.isString(message.networkEndpointGroup))
                                    return "networkEndpointGroup: string expected";
                            if (message.networkEndpointGroupsListEndpointsRequestResource != null && message.hasOwnProperty("networkEndpointGroupsListEndpointsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest.verify(message.networkEndpointGroupsListEndpointsRequestResource);
                                if (error)
                                    return "networkEndpointGroupsListEndpointsRequestResource." + error;
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListNetworkEndpointsNetworkEndpointGroupsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest} ListNetworkEndpointsNetworkEndpointGroupsRequest
                         */
                        ListNetworkEndpointsNetworkEndpointGroupsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.networkEndpointGroup != null)
                                message.networkEndpointGroup = String(object.networkEndpointGroup);
                            if (object.networkEndpointGroupsListEndpointsRequestResource != null) {
                                if (typeof object.networkEndpointGroupsListEndpointsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest.networkEndpointGroupsListEndpointsRequestResource: object expected");
                                message.networkEndpointGroupsListEndpointsRequestResource = $root.google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest.fromObject(object.networkEndpointGroupsListEndpointsRequestResource);
                            }
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListNetworkEndpointsNetworkEndpointGroupsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest} message ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListNetworkEndpointsNetworkEndpointGroupsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.networkEndpointGroupsListEndpointsRequestResource = null;
                                object.project = "";
                                object.networkEndpointGroup = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.networkEndpointGroupsListEndpointsRequestResource != null && message.hasOwnProperty("networkEndpointGroupsListEndpointsRequestResource"))
                                object.networkEndpointGroupsListEndpointsRequestResource = $root.google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest.toObject(message.networkEndpointGroupsListEndpointsRequestResource, options);
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.networkEndpointGroup != null && message.hasOwnProperty("networkEndpointGroup"))
                                object.networkEndpointGroup = message.networkEndpointGroup;
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListNetworkEndpointsNetworkEndpointGroupsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListNetworkEndpointsNetworkEndpointGroupsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListNetworkEndpointsNetworkEndpointGroupsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest";
                        };
    
                        return ListNetworkEndpointsNetworkEndpointGroupsRequest;
                    })();
    
                    v1.ListNetworkFirewallPoliciesRequest = (function() {
    
                        /**
                         * Properties of a ListNetworkFirewallPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListNetworkFirewallPoliciesRequest
                         * @property {string|null} [filter] ListNetworkFirewallPoliciesRequest filter
                         * @property {number|null} [maxResults] ListNetworkFirewallPoliciesRequest maxResults
                         * @property {string|null} [orderBy] ListNetworkFirewallPoliciesRequest orderBy
                         * @property {string|null} [pageToken] ListNetworkFirewallPoliciesRequest pageToken
                         * @property {string|null} [project] ListNetworkFirewallPoliciesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListNetworkFirewallPoliciesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListNetworkFirewallPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListNetworkFirewallPoliciesRequest.
                         * @implements IListNetworkFirewallPoliciesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListNetworkFirewallPoliciesRequest=} [properties] Properties to set
                         */
                        function ListNetworkFirewallPoliciesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListNetworkFirewallPoliciesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        ListNetworkFirewallPoliciesRequest.prototype.filter = null;
    
                        /**
                         * ListNetworkFirewallPoliciesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        ListNetworkFirewallPoliciesRequest.prototype.maxResults = null;
    
                        /**
                         * ListNetworkFirewallPoliciesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        ListNetworkFirewallPoliciesRequest.prototype.orderBy = null;
    
                        /**
                         * ListNetworkFirewallPoliciesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        ListNetworkFirewallPoliciesRequest.prototype.pageToken = null;
    
                        /**
                         * ListNetworkFirewallPoliciesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        ListNetworkFirewallPoliciesRequest.prototype.project = "";
    
                        /**
                         * ListNetworkFirewallPoliciesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        ListNetworkFirewallPoliciesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListNetworkFirewallPoliciesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworkFirewallPoliciesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNetworkFirewallPoliciesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworkFirewallPoliciesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNetworkFirewallPoliciesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworkFirewallPoliciesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNetworkFirewallPoliciesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworkFirewallPoliciesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNetworkFirewallPoliciesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworkFirewallPoliciesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListNetworkFirewallPoliciesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNetworkFirewallPoliciesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest} ListNetworkFirewallPoliciesRequest instance
                         */
                        ListNetworkFirewallPoliciesRequest.create = function create(properties) {
                            return new ListNetworkFirewallPoliciesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListNetworkFirewallPoliciesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNetworkFirewallPoliciesRequest} message ListNetworkFirewallPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListNetworkFirewallPoliciesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListNetworkFirewallPoliciesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNetworkFirewallPoliciesRequest} message ListNetworkFirewallPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListNetworkFirewallPoliciesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListNetworkFirewallPoliciesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest} ListNetworkFirewallPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListNetworkFirewallPoliciesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListNetworkFirewallPoliciesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest} ListNetworkFirewallPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListNetworkFirewallPoliciesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListNetworkFirewallPoliciesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListNetworkFirewallPoliciesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListNetworkFirewallPoliciesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest} ListNetworkFirewallPoliciesRequest
                         */
                        ListNetworkFirewallPoliciesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListNetworkFirewallPoliciesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest} message ListNetworkFirewallPoliciesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListNetworkFirewallPoliciesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListNetworkFirewallPoliciesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListNetworkFirewallPoliciesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListNetworkFirewallPoliciesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListNetworkFirewallPoliciesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest";
                        };
    
                        return ListNetworkFirewallPoliciesRequest;
                    })();
    
                    v1.ListNetworksRequest = (function() {
    
                        /**
                         * Properties of a ListNetworksRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListNetworksRequest
                         * @property {string|null} [filter] ListNetworksRequest filter
                         * @property {number|null} [maxResults] ListNetworksRequest maxResults
                         * @property {string|null} [orderBy] ListNetworksRequest orderBy
                         * @property {string|null} [pageToken] ListNetworksRequest pageToken
                         * @property {string|null} [project] ListNetworksRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListNetworksRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListNetworksRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListNetworksRequest.
                         * @implements IListNetworksRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListNetworksRequest=} [properties] Properties to set
                         */
                        function ListNetworksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListNetworksRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @instance
                         */
                        ListNetworksRequest.prototype.filter = null;
    
                        /**
                         * ListNetworksRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @instance
                         */
                        ListNetworksRequest.prototype.maxResults = null;
    
                        /**
                         * ListNetworksRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @instance
                         */
                        ListNetworksRequest.prototype.orderBy = null;
    
                        /**
                         * ListNetworksRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @instance
                         */
                        ListNetworksRequest.prototype.pageToken = null;
    
                        /**
                         * ListNetworksRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @instance
                         */
                        ListNetworksRequest.prototype.project = "";
    
                        /**
                         * ListNetworksRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @instance
                         */
                        ListNetworksRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListNetworksRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworksRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNetworksRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworksRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNetworksRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworksRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNetworksRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworksRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNetworksRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListNetworksRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListNetworksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNetworksRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListNetworksRequest} ListNetworksRequest instance
                         */
                        ListNetworksRequest.create = function create(properties) {
                            return new ListNetworksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListNetworksRequest message. Does not implicitly {@link google.cloud.compute.v1.ListNetworksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNetworksRequest} message ListNetworksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListNetworksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListNetworksRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListNetworksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNetworksRequest} message ListNetworksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListNetworksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListNetworksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListNetworksRequest} ListNetworksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListNetworksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListNetworksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListNetworksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListNetworksRequest} ListNetworksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListNetworksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListNetworksRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListNetworksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListNetworksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListNetworksRequest} ListNetworksRequest
                         */
                        ListNetworksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListNetworksRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListNetworksRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListNetworksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListNetworksRequest} message ListNetworksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListNetworksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListNetworksRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListNetworksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListNetworksRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListNetworksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListNetworksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListNetworksRequest";
                        };
    
                        return ListNetworksRequest;
                    })();
    
                    v1.ListNodeGroupsRequest = (function() {
    
                        /**
                         * Properties of a ListNodeGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListNodeGroupsRequest
                         * @property {string|null} [filter] ListNodeGroupsRequest filter
                         * @property {number|null} [maxResults] ListNodeGroupsRequest maxResults
                         * @property {string|null} [orderBy] ListNodeGroupsRequest orderBy
                         * @property {string|null} [pageToken] ListNodeGroupsRequest pageToken
                         * @property {string|null} [project] ListNodeGroupsRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListNodeGroupsRequest returnPartialSuccess
                         * @property {string|null} [zone] ListNodeGroupsRequest zone
                         */
    
                        /**
                         * Constructs a new ListNodeGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListNodeGroupsRequest.
                         * @implements IListNodeGroupsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListNodeGroupsRequest=} [properties] Properties to set
                         */
                        function ListNodeGroupsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListNodeGroupsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @instance
                         */
                        ListNodeGroupsRequest.prototype.filter = null;
    
                        /**
                         * ListNodeGroupsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @instance
                         */
                        ListNodeGroupsRequest.prototype.maxResults = null;
    
                        /**
                         * ListNodeGroupsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @instance
                         */
                        ListNodeGroupsRequest.prototype.orderBy = null;
    
                        /**
                         * ListNodeGroupsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @instance
                         */
                        ListNodeGroupsRequest.prototype.pageToken = null;
    
                        /**
                         * ListNodeGroupsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @instance
                         */
                        ListNodeGroupsRequest.prototype.project = "";
    
                        /**
                         * ListNodeGroupsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @instance
                         */
                        ListNodeGroupsRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListNodeGroupsRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @instance
                         */
                        ListNodeGroupsRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListNodeGroupsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNodeGroupsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNodeGroupsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNodeGroupsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNodeGroupsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNodeGroupsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNodeGroupsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNodeGroupsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNodeGroupsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNodeGroupsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListNodeGroupsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNodeGroupsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListNodeGroupsRequest} ListNodeGroupsRequest instance
                         */
                        ListNodeGroupsRequest.create = function create(properties) {
                            return new ListNodeGroupsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListNodeGroupsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListNodeGroupsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNodeGroupsRequest} message ListNodeGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListNodeGroupsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListNodeGroupsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListNodeGroupsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNodeGroupsRequest} message ListNodeGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListNodeGroupsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListNodeGroupsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListNodeGroupsRequest} ListNodeGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListNodeGroupsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListNodeGroupsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListNodeGroupsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListNodeGroupsRequest} ListNodeGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListNodeGroupsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListNodeGroupsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListNodeGroupsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListNodeGroupsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListNodeGroupsRequest} ListNodeGroupsRequest
                         */
                        ListNodeGroupsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListNodeGroupsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListNodeGroupsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListNodeGroupsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListNodeGroupsRequest} message ListNodeGroupsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListNodeGroupsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListNodeGroupsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListNodeGroupsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListNodeGroupsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListNodeGroupsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListNodeGroupsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListNodeGroupsRequest";
                        };
    
                        return ListNodeGroupsRequest;
                    })();
    
                    v1.ListNodeTemplatesRequest = (function() {
    
                        /**
                         * Properties of a ListNodeTemplatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListNodeTemplatesRequest
                         * @property {string|null} [filter] ListNodeTemplatesRequest filter
                         * @property {number|null} [maxResults] ListNodeTemplatesRequest maxResults
                         * @property {string|null} [orderBy] ListNodeTemplatesRequest orderBy
                         * @property {string|null} [pageToken] ListNodeTemplatesRequest pageToken
                         * @property {string|null} [project] ListNodeTemplatesRequest project
                         * @property {string|null} [region] ListNodeTemplatesRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListNodeTemplatesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListNodeTemplatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListNodeTemplatesRequest.
                         * @implements IListNodeTemplatesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListNodeTemplatesRequest=} [properties] Properties to set
                         */
                        function ListNodeTemplatesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListNodeTemplatesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @instance
                         */
                        ListNodeTemplatesRequest.prototype.filter = null;
    
                        /**
                         * ListNodeTemplatesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @instance
                         */
                        ListNodeTemplatesRequest.prototype.maxResults = null;
    
                        /**
                         * ListNodeTemplatesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @instance
                         */
                        ListNodeTemplatesRequest.prototype.orderBy = null;
    
                        /**
                         * ListNodeTemplatesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @instance
                         */
                        ListNodeTemplatesRequest.prototype.pageToken = null;
    
                        /**
                         * ListNodeTemplatesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @instance
                         */
                        ListNodeTemplatesRequest.prototype.project = "";
    
                        /**
                         * ListNodeTemplatesRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @instance
                         */
                        ListNodeTemplatesRequest.prototype.region = "";
    
                        /**
                         * ListNodeTemplatesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @instance
                         */
                        ListNodeTemplatesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListNodeTemplatesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @instance
                         */
                        Object.defineProperty(ListNodeTemplatesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNodeTemplatesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @instance
                         */
                        Object.defineProperty(ListNodeTemplatesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNodeTemplatesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @instance
                         */
                        Object.defineProperty(ListNodeTemplatesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNodeTemplatesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @instance
                         */
                        Object.defineProperty(ListNodeTemplatesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNodeTemplatesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @instance
                         */
                        Object.defineProperty(ListNodeTemplatesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListNodeTemplatesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNodeTemplatesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListNodeTemplatesRequest} ListNodeTemplatesRequest instance
                         */
                        ListNodeTemplatesRequest.create = function create(properties) {
                            return new ListNodeTemplatesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListNodeTemplatesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListNodeTemplatesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNodeTemplatesRequest} message ListNodeTemplatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListNodeTemplatesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListNodeTemplatesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListNodeTemplatesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNodeTemplatesRequest} message ListNodeTemplatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListNodeTemplatesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListNodeTemplatesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListNodeTemplatesRequest} ListNodeTemplatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListNodeTemplatesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListNodeTemplatesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListNodeTemplatesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListNodeTemplatesRequest} ListNodeTemplatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListNodeTemplatesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListNodeTemplatesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListNodeTemplatesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListNodeTemplatesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListNodeTemplatesRequest} ListNodeTemplatesRequest
                         */
                        ListNodeTemplatesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListNodeTemplatesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListNodeTemplatesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListNodeTemplatesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListNodeTemplatesRequest} message ListNodeTemplatesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListNodeTemplatesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListNodeTemplatesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListNodeTemplatesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListNodeTemplatesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListNodeTemplatesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListNodeTemplatesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListNodeTemplatesRequest";
                        };
    
                        return ListNodeTemplatesRequest;
                    })();
    
                    v1.ListNodeTypesRequest = (function() {
    
                        /**
                         * Properties of a ListNodeTypesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListNodeTypesRequest
                         * @property {string|null} [filter] ListNodeTypesRequest filter
                         * @property {number|null} [maxResults] ListNodeTypesRequest maxResults
                         * @property {string|null} [orderBy] ListNodeTypesRequest orderBy
                         * @property {string|null} [pageToken] ListNodeTypesRequest pageToken
                         * @property {string|null} [project] ListNodeTypesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListNodeTypesRequest returnPartialSuccess
                         * @property {string|null} [zone] ListNodeTypesRequest zone
                         */
    
                        /**
                         * Constructs a new ListNodeTypesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListNodeTypesRequest.
                         * @implements IListNodeTypesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListNodeTypesRequest=} [properties] Properties to set
                         */
                        function ListNodeTypesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListNodeTypesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @instance
                         */
                        ListNodeTypesRequest.prototype.filter = null;
    
                        /**
                         * ListNodeTypesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @instance
                         */
                        ListNodeTypesRequest.prototype.maxResults = null;
    
                        /**
                         * ListNodeTypesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @instance
                         */
                        ListNodeTypesRequest.prototype.orderBy = null;
    
                        /**
                         * ListNodeTypesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @instance
                         */
                        ListNodeTypesRequest.prototype.pageToken = null;
    
                        /**
                         * ListNodeTypesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @instance
                         */
                        ListNodeTypesRequest.prototype.project = "";
    
                        /**
                         * ListNodeTypesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @instance
                         */
                        ListNodeTypesRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListNodeTypesRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @instance
                         */
                        ListNodeTypesRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListNodeTypesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListNodeTypesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNodeTypesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListNodeTypesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNodeTypesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListNodeTypesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNodeTypesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListNodeTypesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNodeTypesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListNodeTypesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListNodeTypesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNodeTypesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListNodeTypesRequest} ListNodeTypesRequest instance
                         */
                        ListNodeTypesRequest.create = function create(properties) {
                            return new ListNodeTypesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListNodeTypesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListNodeTypesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNodeTypesRequest} message ListNodeTypesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListNodeTypesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListNodeTypesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListNodeTypesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNodeTypesRequest} message ListNodeTypesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListNodeTypesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListNodeTypesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListNodeTypesRequest} ListNodeTypesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListNodeTypesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListNodeTypesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListNodeTypesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListNodeTypesRequest} ListNodeTypesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListNodeTypesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListNodeTypesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListNodeTypesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListNodeTypesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListNodeTypesRequest} ListNodeTypesRequest
                         */
                        ListNodeTypesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListNodeTypesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListNodeTypesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListNodeTypesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListNodeTypesRequest} message ListNodeTypesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListNodeTypesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListNodeTypesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListNodeTypesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListNodeTypesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListNodeTypesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListNodeTypesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListNodeTypesRequest";
                        };
    
                        return ListNodeTypesRequest;
                    })();
    
                    v1.ListNodesNodeGroupsRequest = (function() {
    
                        /**
                         * Properties of a ListNodesNodeGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListNodesNodeGroupsRequest
                         * @property {string|null} [filter] ListNodesNodeGroupsRequest filter
                         * @property {number|null} [maxResults] ListNodesNodeGroupsRequest maxResults
                         * @property {string|null} [nodeGroup] ListNodesNodeGroupsRequest nodeGroup
                         * @property {string|null} [orderBy] ListNodesNodeGroupsRequest orderBy
                         * @property {string|null} [pageToken] ListNodesNodeGroupsRequest pageToken
                         * @property {string|null} [project] ListNodesNodeGroupsRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListNodesNodeGroupsRequest returnPartialSuccess
                         * @property {string|null} [zone] ListNodesNodeGroupsRequest zone
                         */
    
                        /**
                         * Constructs a new ListNodesNodeGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListNodesNodeGroupsRequest.
                         * @implements IListNodesNodeGroupsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListNodesNodeGroupsRequest=} [properties] Properties to set
                         */
                        function ListNodesNodeGroupsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListNodesNodeGroupsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @instance
                         */
                        ListNodesNodeGroupsRequest.prototype.filter = null;
    
                        /**
                         * ListNodesNodeGroupsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @instance
                         */
                        ListNodesNodeGroupsRequest.prototype.maxResults = null;
    
                        /**
                         * ListNodesNodeGroupsRequest nodeGroup.
                         * @member {string} nodeGroup
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @instance
                         */
                        ListNodesNodeGroupsRequest.prototype.nodeGroup = "";
    
                        /**
                         * ListNodesNodeGroupsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @instance
                         */
                        ListNodesNodeGroupsRequest.prototype.orderBy = null;
    
                        /**
                         * ListNodesNodeGroupsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @instance
                         */
                        ListNodesNodeGroupsRequest.prototype.pageToken = null;
    
                        /**
                         * ListNodesNodeGroupsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @instance
                         */
                        ListNodesNodeGroupsRequest.prototype.project = "";
    
                        /**
                         * ListNodesNodeGroupsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @instance
                         */
                        ListNodesNodeGroupsRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListNodesNodeGroupsRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @instance
                         */
                        ListNodesNodeGroupsRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListNodesNodeGroupsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNodesNodeGroupsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNodesNodeGroupsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNodesNodeGroupsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNodesNodeGroupsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNodesNodeGroupsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNodesNodeGroupsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNodesNodeGroupsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListNodesNodeGroupsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListNodesNodeGroupsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListNodesNodeGroupsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNodesNodeGroupsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListNodesNodeGroupsRequest} ListNodesNodeGroupsRequest instance
                         */
                        ListNodesNodeGroupsRequest.create = function create(properties) {
                            return new ListNodesNodeGroupsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListNodesNodeGroupsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListNodesNodeGroupsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNodesNodeGroupsRequest} message ListNodesNodeGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListNodesNodeGroupsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.nodeGroup != null && Object.hasOwnProperty.call(message, "nodeGroup"))
                                writer.uint32(/* id 469958146, wireType 2 =*/3759665170).string(message.nodeGroup);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListNodesNodeGroupsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListNodesNodeGroupsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListNodesNodeGroupsRequest} message ListNodesNodeGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListNodesNodeGroupsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListNodesNodeGroupsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListNodesNodeGroupsRequest} ListNodesNodeGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListNodesNodeGroupsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListNodesNodeGroupsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 469958146: {
                                        message.nodeGroup = reader.string();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListNodesNodeGroupsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListNodesNodeGroupsRequest} ListNodesNodeGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListNodesNodeGroupsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListNodesNodeGroupsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListNodesNodeGroupsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.nodeGroup != null && message.hasOwnProperty("nodeGroup"))
                                if (!$util.isString(message.nodeGroup))
                                    return "nodeGroup: string expected";
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListNodesNodeGroupsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListNodesNodeGroupsRequest} ListNodesNodeGroupsRequest
                         */
                        ListNodesNodeGroupsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListNodesNodeGroupsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListNodesNodeGroupsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.nodeGroup != null)
                                message.nodeGroup = String(object.nodeGroup);
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListNodesNodeGroupsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListNodesNodeGroupsRequest} message ListNodesNodeGroupsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListNodesNodeGroupsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.nodeGroup = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.nodeGroup != null && message.hasOwnProperty("nodeGroup"))
                                object.nodeGroup = message.nodeGroup;
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListNodesNodeGroupsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListNodesNodeGroupsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListNodesNodeGroupsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListNodesNodeGroupsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListNodesNodeGroupsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListNodesNodeGroupsRequest";
                        };
    
                        return ListNodesNodeGroupsRequest;
                    })();
    
                    v1.ListPacketMirroringsRequest = (function() {
    
                        /**
                         * Properties of a ListPacketMirroringsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListPacketMirroringsRequest
                         * @property {string|null} [filter] ListPacketMirroringsRequest filter
                         * @property {number|null} [maxResults] ListPacketMirroringsRequest maxResults
                         * @property {string|null} [orderBy] ListPacketMirroringsRequest orderBy
                         * @property {string|null} [pageToken] ListPacketMirroringsRequest pageToken
                         * @property {string|null} [project] ListPacketMirroringsRequest project
                         * @property {string|null} [region] ListPacketMirroringsRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListPacketMirroringsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListPacketMirroringsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListPacketMirroringsRequest.
                         * @implements IListPacketMirroringsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListPacketMirroringsRequest=} [properties] Properties to set
                         */
                        function ListPacketMirroringsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListPacketMirroringsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @instance
                         */
                        ListPacketMirroringsRequest.prototype.filter = null;
    
                        /**
                         * ListPacketMirroringsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @instance
                         */
                        ListPacketMirroringsRequest.prototype.maxResults = null;
    
                        /**
                         * ListPacketMirroringsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @instance
                         */
                        ListPacketMirroringsRequest.prototype.orderBy = null;
    
                        /**
                         * ListPacketMirroringsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @instance
                         */
                        ListPacketMirroringsRequest.prototype.pageToken = null;
    
                        /**
                         * ListPacketMirroringsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @instance
                         */
                        ListPacketMirroringsRequest.prototype.project = "";
    
                        /**
                         * ListPacketMirroringsRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @instance
                         */
                        ListPacketMirroringsRequest.prototype.region = "";
    
                        /**
                         * ListPacketMirroringsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @instance
                         */
                        ListPacketMirroringsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListPacketMirroringsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @instance
                         */
                        Object.defineProperty(ListPacketMirroringsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPacketMirroringsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @instance
                         */
                        Object.defineProperty(ListPacketMirroringsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPacketMirroringsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @instance
                         */
                        Object.defineProperty(ListPacketMirroringsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPacketMirroringsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @instance
                         */
                        Object.defineProperty(ListPacketMirroringsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPacketMirroringsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @instance
                         */
                        Object.defineProperty(ListPacketMirroringsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListPacketMirroringsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPacketMirroringsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListPacketMirroringsRequest} ListPacketMirroringsRequest instance
                         */
                        ListPacketMirroringsRequest.create = function create(properties) {
                            return new ListPacketMirroringsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListPacketMirroringsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListPacketMirroringsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPacketMirroringsRequest} message ListPacketMirroringsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPacketMirroringsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListPacketMirroringsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListPacketMirroringsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPacketMirroringsRequest} message ListPacketMirroringsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPacketMirroringsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListPacketMirroringsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListPacketMirroringsRequest} ListPacketMirroringsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPacketMirroringsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListPacketMirroringsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListPacketMirroringsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListPacketMirroringsRequest} ListPacketMirroringsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPacketMirroringsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListPacketMirroringsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListPacketMirroringsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListPacketMirroringsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListPacketMirroringsRequest} ListPacketMirroringsRequest
                         */
                        ListPacketMirroringsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListPacketMirroringsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListPacketMirroringsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListPacketMirroringsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListPacketMirroringsRequest} message ListPacketMirroringsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListPacketMirroringsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListPacketMirroringsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListPacketMirroringsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListPacketMirroringsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListPacketMirroringsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListPacketMirroringsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListPacketMirroringsRequest";
                        };
    
                        return ListPacketMirroringsRequest;
                    })();
    
                    v1.ListPeeringRoutesNetworksRequest = (function() {
    
                        /**
                         * Properties of a ListPeeringRoutesNetworksRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListPeeringRoutesNetworksRequest
                         * @property {string|null} [direction] ListPeeringRoutesNetworksRequest direction
                         * @property {string|null} [filter] ListPeeringRoutesNetworksRequest filter
                         * @property {number|null} [maxResults] ListPeeringRoutesNetworksRequest maxResults
                         * @property {string|null} [network] ListPeeringRoutesNetworksRequest network
                         * @property {string|null} [orderBy] ListPeeringRoutesNetworksRequest orderBy
                         * @property {string|null} [pageToken] ListPeeringRoutesNetworksRequest pageToken
                         * @property {string|null} [peeringName] ListPeeringRoutesNetworksRequest peeringName
                         * @property {string|null} [project] ListPeeringRoutesNetworksRequest project
                         * @property {string|null} [region] ListPeeringRoutesNetworksRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListPeeringRoutesNetworksRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListPeeringRoutesNetworksRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListPeeringRoutesNetworksRequest.
                         * @implements IListPeeringRoutesNetworksRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListPeeringRoutesNetworksRequest=} [properties] Properties to set
                         */
                        function ListPeeringRoutesNetworksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListPeeringRoutesNetworksRequest direction.
                         * @member {string|null|undefined} direction
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @instance
                         */
                        ListPeeringRoutesNetworksRequest.prototype.direction = null;
    
                        /**
                         * ListPeeringRoutesNetworksRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @instance
                         */
                        ListPeeringRoutesNetworksRequest.prototype.filter = null;
    
                        /**
                         * ListPeeringRoutesNetworksRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @instance
                         */
                        ListPeeringRoutesNetworksRequest.prototype.maxResults = null;
    
                        /**
                         * ListPeeringRoutesNetworksRequest network.
                         * @member {string} network
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @instance
                         */
                        ListPeeringRoutesNetworksRequest.prototype.network = "";
    
                        /**
                         * ListPeeringRoutesNetworksRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @instance
                         */
                        ListPeeringRoutesNetworksRequest.prototype.orderBy = null;
    
                        /**
                         * ListPeeringRoutesNetworksRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @instance
                         */
                        ListPeeringRoutesNetworksRequest.prototype.pageToken = null;
    
                        /**
                         * ListPeeringRoutesNetworksRequest peeringName.
                         * @member {string|null|undefined} peeringName
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @instance
                         */
                        ListPeeringRoutesNetworksRequest.prototype.peeringName = null;
    
                        /**
                         * ListPeeringRoutesNetworksRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @instance
                         */
                        ListPeeringRoutesNetworksRequest.prototype.project = "";
    
                        /**
                         * ListPeeringRoutesNetworksRequest region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @instance
                         */
                        ListPeeringRoutesNetworksRequest.prototype.region = null;
    
                        /**
                         * ListPeeringRoutesNetworksRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @instance
                         */
                        ListPeeringRoutesNetworksRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListPeeringRoutesNetworksRequest _direction.
                         * @member {"direction"|undefined} _direction
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListPeeringRoutesNetworksRequest.prototype, "_direction", {
                            get: $util.oneOfGetter($oneOfFields = ["direction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPeeringRoutesNetworksRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListPeeringRoutesNetworksRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPeeringRoutesNetworksRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListPeeringRoutesNetworksRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPeeringRoutesNetworksRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListPeeringRoutesNetworksRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPeeringRoutesNetworksRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListPeeringRoutesNetworksRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPeeringRoutesNetworksRequest _peeringName.
                         * @member {"peeringName"|undefined} _peeringName
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListPeeringRoutesNetworksRequest.prototype, "_peeringName", {
                            get: $util.oneOfGetter($oneOfFields = ["peeringName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPeeringRoutesNetworksRequest _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListPeeringRoutesNetworksRequest.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPeeringRoutesNetworksRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListPeeringRoutesNetworksRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListPeeringRoutesNetworksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPeeringRoutesNetworksRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListPeeringRoutesNetworksRequest} ListPeeringRoutesNetworksRequest instance
                         */
                        ListPeeringRoutesNetworksRequest.create = function create(properties) {
                            return new ListPeeringRoutesNetworksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListPeeringRoutesNetworksRequest message. Does not implicitly {@link google.cloud.compute.v1.ListPeeringRoutesNetworksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPeeringRoutesNetworksRequest} message ListPeeringRoutesNetworksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPeeringRoutesNetworksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.direction != null && Object.hasOwnProperty.call(message, "direction"))
                                writer.uint32(/* id 111150975, wireType 2 =*/889207802).string(message.direction);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            if (message.peeringName != null && Object.hasOwnProperty.call(message, "peeringName"))
                                writer.uint32(/* id 249571370, wireType 2 =*/1996570962).string(message.peeringName);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListPeeringRoutesNetworksRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListPeeringRoutesNetworksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPeeringRoutesNetworksRequest} message ListPeeringRoutesNetworksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPeeringRoutesNetworksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListPeeringRoutesNetworksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListPeeringRoutesNetworksRequest} ListPeeringRoutesNetworksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPeeringRoutesNetworksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListPeeringRoutesNetworksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 111150975: {
                                        message.direction = reader.string();
                                        break;
                                    }
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 249571370: {
                                        message.peeringName = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListPeeringRoutesNetworksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListPeeringRoutesNetworksRequest} ListPeeringRoutesNetworksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPeeringRoutesNetworksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListPeeringRoutesNetworksRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListPeeringRoutesNetworksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.direction != null && message.hasOwnProperty("direction")) {
                                properties._direction = 1;
                                if (!$util.isString(message.direction))
                                    return "direction: string expected";
                            }
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.network != null && message.hasOwnProperty("network"))
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.peeringName != null && message.hasOwnProperty("peeringName")) {
                                properties._peeringName = 1;
                                if (!$util.isString(message.peeringName))
                                    return "peeringName: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListPeeringRoutesNetworksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListPeeringRoutesNetworksRequest} ListPeeringRoutesNetworksRequest
                         */
                        ListPeeringRoutesNetworksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListPeeringRoutesNetworksRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListPeeringRoutesNetworksRequest();
                            if (object.direction != null)
                                message.direction = String(object.direction);
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.peeringName != null)
                                message.peeringName = String(object.peeringName);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListPeeringRoutesNetworksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListPeeringRoutesNetworksRequest} message ListPeeringRoutesNetworksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListPeeringRoutesNetworksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.network = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.direction != null && message.hasOwnProperty("direction")) {
                                object.direction = message.direction;
                                if (options.oneofs)
                                    object._direction = "direction";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.network != null && message.hasOwnProperty("network"))
                                object.network = message.network;
                            if (message.peeringName != null && message.hasOwnProperty("peeringName")) {
                                object.peeringName = message.peeringName;
                                if (options.oneofs)
                                    object._peeringName = "peeringName";
                            }
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListPeeringRoutesNetworksRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListPeeringRoutesNetworksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListPeeringRoutesNetworksRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListPeeringRoutesNetworksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListPeeringRoutesNetworksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListPeeringRoutesNetworksRequest";
                        };
    
                        /**
                         * Direction enum.
                         * @name google.cloud.compute.v1.ListPeeringRoutesNetworksRequest.Direction
                         * @enum {number}
                         * @property {number} UNDEFINED_DIRECTION=0 UNDEFINED_DIRECTION value
                         * @property {number} INCOMING=338552870 INCOMING value
                         * @property {number} OUTGOING=307438444 OUTGOING value
                         */
                        ListPeeringRoutesNetworksRequest.Direction = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_DIRECTION"] = 0;
                            values[valuesById[338552870] = "INCOMING"] = 338552870;
                            values[valuesById[307438444] = "OUTGOING"] = 307438444;
                            return values;
                        })();
    
                        return ListPeeringRoutesNetworksRequest;
                    })();
    
                    v1.ListPerInstanceConfigsInstanceGroupManagersRequest = (function() {
    
                        /**
                         * Properties of a ListPerInstanceConfigsInstanceGroupManagersRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListPerInstanceConfigsInstanceGroupManagersRequest
                         * @property {string|null} [filter] ListPerInstanceConfigsInstanceGroupManagersRequest filter
                         * @property {string|null} [instanceGroupManager] ListPerInstanceConfigsInstanceGroupManagersRequest instanceGroupManager
                         * @property {number|null} [maxResults] ListPerInstanceConfigsInstanceGroupManagersRequest maxResults
                         * @property {string|null} [orderBy] ListPerInstanceConfigsInstanceGroupManagersRequest orderBy
                         * @property {string|null} [pageToken] ListPerInstanceConfigsInstanceGroupManagersRequest pageToken
                         * @property {string|null} [project] ListPerInstanceConfigsInstanceGroupManagersRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListPerInstanceConfigsInstanceGroupManagersRequest returnPartialSuccess
                         * @property {string|null} [zone] ListPerInstanceConfigsInstanceGroupManagersRequest zone
                         */
    
                        /**
                         * Constructs a new ListPerInstanceConfigsInstanceGroupManagersRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListPerInstanceConfigsInstanceGroupManagersRequest.
                         * @implements IListPerInstanceConfigsInstanceGroupManagersRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListPerInstanceConfigsInstanceGroupManagersRequest=} [properties] Properties to set
                         */
                        function ListPerInstanceConfigsInstanceGroupManagersRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListPerInstanceConfigsInstanceGroupManagersRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @instance
                         */
                        ListPerInstanceConfigsInstanceGroupManagersRequest.prototype.filter = null;
    
                        /**
                         * ListPerInstanceConfigsInstanceGroupManagersRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @instance
                         */
                        ListPerInstanceConfigsInstanceGroupManagersRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * ListPerInstanceConfigsInstanceGroupManagersRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @instance
                         */
                        ListPerInstanceConfigsInstanceGroupManagersRequest.prototype.maxResults = null;
    
                        /**
                         * ListPerInstanceConfigsInstanceGroupManagersRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @instance
                         */
                        ListPerInstanceConfigsInstanceGroupManagersRequest.prototype.orderBy = null;
    
                        /**
                         * ListPerInstanceConfigsInstanceGroupManagersRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @instance
                         */
                        ListPerInstanceConfigsInstanceGroupManagersRequest.prototype.pageToken = null;
    
                        /**
                         * ListPerInstanceConfigsInstanceGroupManagersRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @instance
                         */
                        ListPerInstanceConfigsInstanceGroupManagersRequest.prototype.project = "";
    
                        /**
                         * ListPerInstanceConfigsInstanceGroupManagersRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @instance
                         */
                        ListPerInstanceConfigsInstanceGroupManagersRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListPerInstanceConfigsInstanceGroupManagersRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @instance
                         */
                        ListPerInstanceConfigsInstanceGroupManagersRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListPerInstanceConfigsInstanceGroupManagersRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListPerInstanceConfigsInstanceGroupManagersRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPerInstanceConfigsInstanceGroupManagersRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListPerInstanceConfigsInstanceGroupManagersRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPerInstanceConfigsInstanceGroupManagersRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListPerInstanceConfigsInstanceGroupManagersRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPerInstanceConfigsInstanceGroupManagersRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListPerInstanceConfigsInstanceGroupManagersRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPerInstanceConfigsInstanceGroupManagersRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListPerInstanceConfigsInstanceGroupManagersRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListPerInstanceConfigsInstanceGroupManagersRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPerInstanceConfigsInstanceGroupManagersRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest} ListPerInstanceConfigsInstanceGroupManagersRequest instance
                         */
                        ListPerInstanceConfigsInstanceGroupManagersRequest.create = function create(properties) {
                            return new ListPerInstanceConfigsInstanceGroupManagersRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListPerInstanceConfigsInstanceGroupManagersRequest message. Does not implicitly {@link google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPerInstanceConfigsInstanceGroupManagersRequest} message ListPerInstanceConfigsInstanceGroupManagersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPerInstanceConfigsInstanceGroupManagersRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListPerInstanceConfigsInstanceGroupManagersRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPerInstanceConfigsInstanceGroupManagersRequest} message ListPerInstanceConfigsInstanceGroupManagersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPerInstanceConfigsInstanceGroupManagersRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListPerInstanceConfigsInstanceGroupManagersRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest} ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPerInstanceConfigsInstanceGroupManagersRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListPerInstanceConfigsInstanceGroupManagersRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest} ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPerInstanceConfigsInstanceGroupManagersRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListPerInstanceConfigsInstanceGroupManagersRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListPerInstanceConfigsInstanceGroupManagersRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListPerInstanceConfigsInstanceGroupManagersRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest} ListPerInstanceConfigsInstanceGroupManagersRequest
                         */
                        ListPerInstanceConfigsInstanceGroupManagersRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListPerInstanceConfigsInstanceGroupManagersRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest} message ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListPerInstanceConfigsInstanceGroupManagersRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListPerInstanceConfigsInstanceGroupManagersRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListPerInstanceConfigsInstanceGroupManagersRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListPerInstanceConfigsInstanceGroupManagersRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest";
                        };
    
                        return ListPerInstanceConfigsInstanceGroupManagersRequest;
                    })();
    
                    v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest = (function() {
    
                        /**
                         * Properties of a ListPerInstanceConfigsRegionInstanceGroupManagersRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @property {string|null} [filter] ListPerInstanceConfigsRegionInstanceGroupManagersRequest filter
                         * @property {string|null} [instanceGroupManager] ListPerInstanceConfigsRegionInstanceGroupManagersRequest instanceGroupManager
                         * @property {number|null} [maxResults] ListPerInstanceConfigsRegionInstanceGroupManagersRequest maxResults
                         * @property {string|null} [orderBy] ListPerInstanceConfigsRegionInstanceGroupManagersRequest orderBy
                         * @property {string|null} [pageToken] ListPerInstanceConfigsRegionInstanceGroupManagersRequest pageToken
                         * @property {string|null} [project] ListPerInstanceConfigsRegionInstanceGroupManagersRequest project
                         * @property {string|null} [region] ListPerInstanceConfigsRegionInstanceGroupManagersRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListPerInstanceConfigsRegionInstanceGroupManagersRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListPerInstanceConfigsRegionInstanceGroupManagersRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListPerInstanceConfigsRegionInstanceGroupManagersRequest.
                         * @implements IListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListPerInstanceConfigsRegionInstanceGroupManagersRequest=} [properties] Properties to set
                         */
                        function ListPerInstanceConfigsRegionInstanceGroupManagersRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListPerInstanceConfigsRegionInstanceGroupManagersRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListPerInstanceConfigsRegionInstanceGroupManagersRequest.prototype.filter = null;
    
                        /**
                         * ListPerInstanceConfigsRegionInstanceGroupManagersRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListPerInstanceConfigsRegionInstanceGroupManagersRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * ListPerInstanceConfigsRegionInstanceGroupManagersRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListPerInstanceConfigsRegionInstanceGroupManagersRequest.prototype.maxResults = null;
    
                        /**
                         * ListPerInstanceConfigsRegionInstanceGroupManagersRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListPerInstanceConfigsRegionInstanceGroupManagersRequest.prototype.orderBy = null;
    
                        /**
                         * ListPerInstanceConfigsRegionInstanceGroupManagersRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListPerInstanceConfigsRegionInstanceGroupManagersRequest.prototype.pageToken = null;
    
                        /**
                         * ListPerInstanceConfigsRegionInstanceGroupManagersRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListPerInstanceConfigsRegionInstanceGroupManagersRequest.prototype.project = "";
    
                        /**
                         * ListPerInstanceConfigsRegionInstanceGroupManagersRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListPerInstanceConfigsRegionInstanceGroupManagersRequest.prototype.region = "";
    
                        /**
                         * ListPerInstanceConfigsRegionInstanceGroupManagersRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListPerInstanceConfigsRegionInstanceGroupManagersRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListPerInstanceConfigsRegionInstanceGroupManagersRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListPerInstanceConfigsRegionInstanceGroupManagersRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPerInstanceConfigsRegionInstanceGroupManagersRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListPerInstanceConfigsRegionInstanceGroupManagersRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPerInstanceConfigsRegionInstanceGroupManagersRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListPerInstanceConfigsRegionInstanceGroupManagersRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPerInstanceConfigsRegionInstanceGroupManagersRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListPerInstanceConfigsRegionInstanceGroupManagersRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPerInstanceConfigsRegionInstanceGroupManagersRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListPerInstanceConfigsRegionInstanceGroupManagersRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListPerInstanceConfigsRegionInstanceGroupManagersRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPerInstanceConfigsRegionInstanceGroupManagersRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest} ListPerInstanceConfigsRegionInstanceGroupManagersRequest instance
                         */
                        ListPerInstanceConfigsRegionInstanceGroupManagersRequest.create = function create(properties) {
                            return new ListPerInstanceConfigsRegionInstanceGroupManagersRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListPerInstanceConfigsRegionInstanceGroupManagersRequest message. Does not implicitly {@link google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPerInstanceConfigsRegionInstanceGroupManagersRequest} message ListPerInstanceConfigsRegionInstanceGroupManagersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPerInstanceConfigsRegionInstanceGroupManagersRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListPerInstanceConfigsRegionInstanceGroupManagersRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPerInstanceConfigsRegionInstanceGroupManagersRequest} message ListPerInstanceConfigsRegionInstanceGroupManagersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPerInstanceConfigsRegionInstanceGroupManagersRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListPerInstanceConfigsRegionInstanceGroupManagersRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest} ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPerInstanceConfigsRegionInstanceGroupManagersRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListPerInstanceConfigsRegionInstanceGroupManagersRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest} ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPerInstanceConfigsRegionInstanceGroupManagersRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListPerInstanceConfigsRegionInstanceGroupManagersRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListPerInstanceConfigsRegionInstanceGroupManagersRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListPerInstanceConfigsRegionInstanceGroupManagersRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest} ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         */
                        ListPerInstanceConfigsRegionInstanceGroupManagersRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListPerInstanceConfigsRegionInstanceGroupManagersRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest} message ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListPerInstanceConfigsRegionInstanceGroupManagersRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListPerInstanceConfigsRegionInstanceGroupManagersRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListPerInstanceConfigsRegionInstanceGroupManagersRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListPerInstanceConfigsRegionInstanceGroupManagersRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest";
                        };
    
                        return ListPerInstanceConfigsRegionInstanceGroupManagersRequest;
                    })();
    
                    v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest = (function() {
    
                        /**
                         * Properties of a ListPreconfiguredExpressionSetsSecurityPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @property {string|null} [filter] ListPreconfiguredExpressionSetsSecurityPoliciesRequest filter
                         * @property {number|null} [maxResults] ListPreconfiguredExpressionSetsSecurityPoliciesRequest maxResults
                         * @property {string|null} [orderBy] ListPreconfiguredExpressionSetsSecurityPoliciesRequest orderBy
                         * @property {string|null} [pageToken] ListPreconfiguredExpressionSetsSecurityPoliciesRequest pageToken
                         * @property {string|null} [project] ListPreconfiguredExpressionSetsSecurityPoliciesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListPreconfiguredExpressionSetsSecurityPoliciesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListPreconfiguredExpressionSetsSecurityPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListPreconfiguredExpressionSetsSecurityPoliciesRequest.
                         * @implements IListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListPreconfiguredExpressionSetsSecurityPoliciesRequest=} [properties] Properties to set
                         */
                        function ListPreconfiguredExpressionSetsSecurityPoliciesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListPreconfiguredExpressionSetsSecurityPoliciesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @instance
                         */
                        ListPreconfiguredExpressionSetsSecurityPoliciesRequest.prototype.filter = null;
    
                        /**
                         * ListPreconfiguredExpressionSetsSecurityPoliciesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @instance
                         */
                        ListPreconfiguredExpressionSetsSecurityPoliciesRequest.prototype.maxResults = null;
    
                        /**
                         * ListPreconfiguredExpressionSetsSecurityPoliciesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @instance
                         */
                        ListPreconfiguredExpressionSetsSecurityPoliciesRequest.prototype.orderBy = null;
    
                        /**
                         * ListPreconfiguredExpressionSetsSecurityPoliciesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @instance
                         */
                        ListPreconfiguredExpressionSetsSecurityPoliciesRequest.prototype.pageToken = null;
    
                        /**
                         * ListPreconfiguredExpressionSetsSecurityPoliciesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @instance
                         */
                        ListPreconfiguredExpressionSetsSecurityPoliciesRequest.prototype.project = "";
    
                        /**
                         * ListPreconfiguredExpressionSetsSecurityPoliciesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @instance
                         */
                        ListPreconfiguredExpressionSetsSecurityPoliciesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListPreconfiguredExpressionSetsSecurityPoliciesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListPreconfiguredExpressionSetsSecurityPoliciesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPreconfiguredExpressionSetsSecurityPoliciesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListPreconfiguredExpressionSetsSecurityPoliciesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPreconfiguredExpressionSetsSecurityPoliciesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListPreconfiguredExpressionSetsSecurityPoliciesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPreconfiguredExpressionSetsSecurityPoliciesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListPreconfiguredExpressionSetsSecurityPoliciesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPreconfiguredExpressionSetsSecurityPoliciesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListPreconfiguredExpressionSetsSecurityPoliciesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListPreconfiguredExpressionSetsSecurityPoliciesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPreconfiguredExpressionSetsSecurityPoliciesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest} ListPreconfiguredExpressionSetsSecurityPoliciesRequest instance
                         */
                        ListPreconfiguredExpressionSetsSecurityPoliciesRequest.create = function create(properties) {
                            return new ListPreconfiguredExpressionSetsSecurityPoliciesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListPreconfiguredExpressionSetsSecurityPoliciesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPreconfiguredExpressionSetsSecurityPoliciesRequest} message ListPreconfiguredExpressionSetsSecurityPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPreconfiguredExpressionSetsSecurityPoliciesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListPreconfiguredExpressionSetsSecurityPoliciesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPreconfiguredExpressionSetsSecurityPoliciesRequest} message ListPreconfiguredExpressionSetsSecurityPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPreconfiguredExpressionSetsSecurityPoliciesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListPreconfiguredExpressionSetsSecurityPoliciesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest} ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPreconfiguredExpressionSetsSecurityPoliciesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListPreconfiguredExpressionSetsSecurityPoliciesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest} ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPreconfiguredExpressionSetsSecurityPoliciesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListPreconfiguredExpressionSetsSecurityPoliciesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListPreconfiguredExpressionSetsSecurityPoliciesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListPreconfiguredExpressionSetsSecurityPoliciesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest} ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         */
                        ListPreconfiguredExpressionSetsSecurityPoliciesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListPreconfiguredExpressionSetsSecurityPoliciesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest} message ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListPreconfiguredExpressionSetsSecurityPoliciesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListPreconfiguredExpressionSetsSecurityPoliciesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListPreconfiguredExpressionSetsSecurityPoliciesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListPreconfiguredExpressionSetsSecurityPoliciesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest";
                        };
    
                        return ListPreconfiguredExpressionSetsSecurityPoliciesRequest;
                    })();
    
                    v1.ListPublicAdvertisedPrefixesRequest = (function() {
    
                        /**
                         * Properties of a ListPublicAdvertisedPrefixesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListPublicAdvertisedPrefixesRequest
                         * @property {string|null} [filter] ListPublicAdvertisedPrefixesRequest filter
                         * @property {number|null} [maxResults] ListPublicAdvertisedPrefixesRequest maxResults
                         * @property {string|null} [orderBy] ListPublicAdvertisedPrefixesRequest orderBy
                         * @property {string|null} [pageToken] ListPublicAdvertisedPrefixesRequest pageToken
                         * @property {string|null} [project] ListPublicAdvertisedPrefixesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListPublicAdvertisedPrefixesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListPublicAdvertisedPrefixesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListPublicAdvertisedPrefixesRequest.
                         * @implements IListPublicAdvertisedPrefixesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListPublicAdvertisedPrefixesRequest=} [properties] Properties to set
                         */
                        function ListPublicAdvertisedPrefixesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListPublicAdvertisedPrefixesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @instance
                         */
                        ListPublicAdvertisedPrefixesRequest.prototype.filter = null;
    
                        /**
                         * ListPublicAdvertisedPrefixesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @instance
                         */
                        ListPublicAdvertisedPrefixesRequest.prototype.maxResults = null;
    
                        /**
                         * ListPublicAdvertisedPrefixesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @instance
                         */
                        ListPublicAdvertisedPrefixesRequest.prototype.orderBy = null;
    
                        /**
                         * ListPublicAdvertisedPrefixesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @instance
                         */
                        ListPublicAdvertisedPrefixesRequest.prototype.pageToken = null;
    
                        /**
                         * ListPublicAdvertisedPrefixesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @instance
                         */
                        ListPublicAdvertisedPrefixesRequest.prototype.project = "";
    
                        /**
                         * ListPublicAdvertisedPrefixesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @instance
                         */
                        ListPublicAdvertisedPrefixesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListPublicAdvertisedPrefixesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(ListPublicAdvertisedPrefixesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPublicAdvertisedPrefixesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(ListPublicAdvertisedPrefixesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPublicAdvertisedPrefixesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(ListPublicAdvertisedPrefixesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPublicAdvertisedPrefixesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(ListPublicAdvertisedPrefixesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPublicAdvertisedPrefixesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(ListPublicAdvertisedPrefixesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListPublicAdvertisedPrefixesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPublicAdvertisedPrefixesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest} ListPublicAdvertisedPrefixesRequest instance
                         */
                        ListPublicAdvertisedPrefixesRequest.create = function create(properties) {
                            return new ListPublicAdvertisedPrefixesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListPublicAdvertisedPrefixesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPublicAdvertisedPrefixesRequest} message ListPublicAdvertisedPrefixesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPublicAdvertisedPrefixesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListPublicAdvertisedPrefixesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPublicAdvertisedPrefixesRequest} message ListPublicAdvertisedPrefixesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPublicAdvertisedPrefixesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListPublicAdvertisedPrefixesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest} ListPublicAdvertisedPrefixesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPublicAdvertisedPrefixesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListPublicAdvertisedPrefixesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest} ListPublicAdvertisedPrefixesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPublicAdvertisedPrefixesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListPublicAdvertisedPrefixesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListPublicAdvertisedPrefixesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListPublicAdvertisedPrefixesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest} ListPublicAdvertisedPrefixesRequest
                         */
                        ListPublicAdvertisedPrefixesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListPublicAdvertisedPrefixesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest} message ListPublicAdvertisedPrefixesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListPublicAdvertisedPrefixesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListPublicAdvertisedPrefixesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListPublicAdvertisedPrefixesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListPublicAdvertisedPrefixesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListPublicAdvertisedPrefixesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest";
                        };
    
                        return ListPublicAdvertisedPrefixesRequest;
                    })();
    
                    v1.ListPublicDelegatedPrefixesRequest = (function() {
    
                        /**
                         * Properties of a ListPublicDelegatedPrefixesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListPublicDelegatedPrefixesRequest
                         * @property {string|null} [filter] ListPublicDelegatedPrefixesRequest filter
                         * @property {number|null} [maxResults] ListPublicDelegatedPrefixesRequest maxResults
                         * @property {string|null} [orderBy] ListPublicDelegatedPrefixesRequest orderBy
                         * @property {string|null} [pageToken] ListPublicDelegatedPrefixesRequest pageToken
                         * @property {string|null} [project] ListPublicDelegatedPrefixesRequest project
                         * @property {string|null} [region] ListPublicDelegatedPrefixesRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListPublicDelegatedPrefixesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListPublicDelegatedPrefixesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListPublicDelegatedPrefixesRequest.
                         * @implements IListPublicDelegatedPrefixesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListPublicDelegatedPrefixesRequest=} [properties] Properties to set
                         */
                        function ListPublicDelegatedPrefixesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListPublicDelegatedPrefixesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        ListPublicDelegatedPrefixesRequest.prototype.filter = null;
    
                        /**
                         * ListPublicDelegatedPrefixesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        ListPublicDelegatedPrefixesRequest.prototype.maxResults = null;
    
                        /**
                         * ListPublicDelegatedPrefixesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        ListPublicDelegatedPrefixesRequest.prototype.orderBy = null;
    
                        /**
                         * ListPublicDelegatedPrefixesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        ListPublicDelegatedPrefixesRequest.prototype.pageToken = null;
    
                        /**
                         * ListPublicDelegatedPrefixesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        ListPublicDelegatedPrefixesRequest.prototype.project = "";
    
                        /**
                         * ListPublicDelegatedPrefixesRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        ListPublicDelegatedPrefixesRequest.prototype.region = "";
    
                        /**
                         * ListPublicDelegatedPrefixesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        ListPublicDelegatedPrefixesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListPublicDelegatedPrefixesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(ListPublicDelegatedPrefixesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPublicDelegatedPrefixesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(ListPublicDelegatedPrefixesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPublicDelegatedPrefixesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(ListPublicDelegatedPrefixesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPublicDelegatedPrefixesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(ListPublicDelegatedPrefixesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListPublicDelegatedPrefixesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @instance
                         */
                        Object.defineProperty(ListPublicDelegatedPrefixesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListPublicDelegatedPrefixesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPublicDelegatedPrefixesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest} ListPublicDelegatedPrefixesRequest instance
                         */
                        ListPublicDelegatedPrefixesRequest.create = function create(properties) {
                            return new ListPublicDelegatedPrefixesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListPublicDelegatedPrefixesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPublicDelegatedPrefixesRequest} message ListPublicDelegatedPrefixesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPublicDelegatedPrefixesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListPublicDelegatedPrefixesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListPublicDelegatedPrefixesRequest} message ListPublicDelegatedPrefixesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListPublicDelegatedPrefixesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListPublicDelegatedPrefixesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest} ListPublicDelegatedPrefixesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPublicDelegatedPrefixesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListPublicDelegatedPrefixesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest} ListPublicDelegatedPrefixesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListPublicDelegatedPrefixesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListPublicDelegatedPrefixesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListPublicDelegatedPrefixesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListPublicDelegatedPrefixesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest} ListPublicDelegatedPrefixesRequest
                         */
                        ListPublicDelegatedPrefixesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListPublicDelegatedPrefixesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest} message ListPublicDelegatedPrefixesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListPublicDelegatedPrefixesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListPublicDelegatedPrefixesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListPublicDelegatedPrefixesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListPublicDelegatedPrefixesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListPublicDelegatedPrefixesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest";
                        };
    
                        return ListPublicDelegatedPrefixesRequest;
                    })();
    
                    v1.ListReferrersInstancesRequest = (function() {
    
                        /**
                         * Properties of a ListReferrersInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListReferrersInstancesRequest
                         * @property {string|null} [filter] ListReferrersInstancesRequest filter
                         * @property {string|null} [instance] ListReferrersInstancesRequest instance
                         * @property {number|null} [maxResults] ListReferrersInstancesRequest maxResults
                         * @property {string|null} [orderBy] ListReferrersInstancesRequest orderBy
                         * @property {string|null} [pageToken] ListReferrersInstancesRequest pageToken
                         * @property {string|null} [project] ListReferrersInstancesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListReferrersInstancesRequest returnPartialSuccess
                         * @property {string|null} [zone] ListReferrersInstancesRequest zone
                         */
    
                        /**
                         * Constructs a new ListReferrersInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListReferrersInstancesRequest.
                         * @implements IListReferrersInstancesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListReferrersInstancesRequest=} [properties] Properties to set
                         */
                        function ListReferrersInstancesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListReferrersInstancesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @instance
                         */
                        ListReferrersInstancesRequest.prototype.filter = null;
    
                        /**
                         * ListReferrersInstancesRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @instance
                         */
                        ListReferrersInstancesRequest.prototype.instance = "";
    
                        /**
                         * ListReferrersInstancesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @instance
                         */
                        ListReferrersInstancesRequest.prototype.maxResults = null;
    
                        /**
                         * ListReferrersInstancesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @instance
                         */
                        ListReferrersInstancesRequest.prototype.orderBy = null;
    
                        /**
                         * ListReferrersInstancesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @instance
                         */
                        ListReferrersInstancesRequest.prototype.pageToken = null;
    
                        /**
                         * ListReferrersInstancesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @instance
                         */
                        ListReferrersInstancesRequest.prototype.project = "";
    
                        /**
                         * ListReferrersInstancesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @instance
                         */
                        ListReferrersInstancesRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListReferrersInstancesRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @instance
                         */
                        ListReferrersInstancesRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListReferrersInstancesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(ListReferrersInstancesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListReferrersInstancesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(ListReferrersInstancesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListReferrersInstancesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(ListReferrersInstancesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListReferrersInstancesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(ListReferrersInstancesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListReferrersInstancesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(ListReferrersInstancesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListReferrersInstancesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListReferrersInstancesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListReferrersInstancesRequest} ListReferrersInstancesRequest instance
                         */
                        ListReferrersInstancesRequest.create = function create(properties) {
                            return new ListReferrersInstancesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListReferrersInstancesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListReferrersInstancesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListReferrersInstancesRequest} message ListReferrersInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListReferrersInstancesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListReferrersInstancesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListReferrersInstancesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListReferrersInstancesRequest} message ListReferrersInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListReferrersInstancesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListReferrersInstancesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListReferrersInstancesRequest} ListReferrersInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListReferrersInstancesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListReferrersInstancesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListReferrersInstancesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListReferrersInstancesRequest} ListReferrersInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListReferrersInstancesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListReferrersInstancesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListReferrersInstancesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListReferrersInstancesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListReferrersInstancesRequest} ListReferrersInstancesRequest
                         */
                        ListReferrersInstancesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListReferrersInstancesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListReferrersInstancesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListReferrersInstancesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListReferrersInstancesRequest} message ListReferrersInstancesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListReferrersInstancesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListReferrersInstancesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListReferrersInstancesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListReferrersInstancesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListReferrersInstancesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListReferrersInstancesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListReferrersInstancesRequest";
                        };
    
                        return ListReferrersInstancesRequest;
                    })();
    
                    v1.ListRegionAutoscalersRequest = (function() {
    
                        /**
                         * Properties of a ListRegionAutoscalersRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionAutoscalersRequest
                         * @property {string|null} [filter] ListRegionAutoscalersRequest filter
                         * @property {number|null} [maxResults] ListRegionAutoscalersRequest maxResults
                         * @property {string|null} [orderBy] ListRegionAutoscalersRequest orderBy
                         * @property {string|null} [pageToken] ListRegionAutoscalersRequest pageToken
                         * @property {string|null} [project] ListRegionAutoscalersRequest project
                         * @property {string|null} [region] ListRegionAutoscalersRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRegionAutoscalersRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionAutoscalersRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionAutoscalersRequest.
                         * @implements IListRegionAutoscalersRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionAutoscalersRequest=} [properties] Properties to set
                         */
                        function ListRegionAutoscalersRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionAutoscalersRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @instance
                         */
                        ListRegionAutoscalersRequest.prototype.filter = null;
    
                        /**
                         * ListRegionAutoscalersRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @instance
                         */
                        ListRegionAutoscalersRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionAutoscalersRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @instance
                         */
                        ListRegionAutoscalersRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionAutoscalersRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @instance
                         */
                        ListRegionAutoscalersRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionAutoscalersRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @instance
                         */
                        ListRegionAutoscalersRequest.prototype.project = "";
    
                        /**
                         * ListRegionAutoscalersRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @instance
                         */
                        ListRegionAutoscalersRequest.prototype.region = "";
    
                        /**
                         * ListRegionAutoscalersRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @instance
                         */
                        ListRegionAutoscalersRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionAutoscalersRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionAutoscalersRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionAutoscalersRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionAutoscalersRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionAutoscalersRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionAutoscalersRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionAutoscalersRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionAutoscalersRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionAutoscalersRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionAutoscalersRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionAutoscalersRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionAutoscalersRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionAutoscalersRequest} ListRegionAutoscalersRequest instance
                         */
                        ListRegionAutoscalersRequest.create = function create(properties) {
                            return new ListRegionAutoscalersRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionAutoscalersRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionAutoscalersRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionAutoscalersRequest} message ListRegionAutoscalersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionAutoscalersRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionAutoscalersRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionAutoscalersRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionAutoscalersRequest} message ListRegionAutoscalersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionAutoscalersRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionAutoscalersRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionAutoscalersRequest} ListRegionAutoscalersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionAutoscalersRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionAutoscalersRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionAutoscalersRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionAutoscalersRequest} ListRegionAutoscalersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionAutoscalersRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionAutoscalersRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionAutoscalersRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionAutoscalersRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionAutoscalersRequest} ListRegionAutoscalersRequest
                         */
                        ListRegionAutoscalersRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionAutoscalersRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionAutoscalersRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionAutoscalersRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionAutoscalersRequest} message ListRegionAutoscalersRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionAutoscalersRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionAutoscalersRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionAutoscalersRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionAutoscalersRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionAutoscalersRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionAutoscalersRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionAutoscalersRequest";
                        };
    
                        return ListRegionAutoscalersRequest;
                    })();
    
                    v1.ListRegionBackendServicesRequest = (function() {
    
                        /**
                         * Properties of a ListRegionBackendServicesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionBackendServicesRequest
                         * @property {string|null} [filter] ListRegionBackendServicesRequest filter
                         * @property {number|null} [maxResults] ListRegionBackendServicesRequest maxResults
                         * @property {string|null} [orderBy] ListRegionBackendServicesRequest orderBy
                         * @property {string|null} [pageToken] ListRegionBackendServicesRequest pageToken
                         * @property {string|null} [project] ListRegionBackendServicesRequest project
                         * @property {string|null} [region] ListRegionBackendServicesRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRegionBackendServicesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionBackendServicesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionBackendServicesRequest.
                         * @implements IListRegionBackendServicesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionBackendServicesRequest=} [properties] Properties to set
                         */
                        function ListRegionBackendServicesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionBackendServicesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @instance
                         */
                        ListRegionBackendServicesRequest.prototype.filter = null;
    
                        /**
                         * ListRegionBackendServicesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @instance
                         */
                        ListRegionBackendServicesRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionBackendServicesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @instance
                         */
                        ListRegionBackendServicesRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionBackendServicesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @instance
                         */
                        ListRegionBackendServicesRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionBackendServicesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @instance
                         */
                        ListRegionBackendServicesRequest.prototype.project = "";
    
                        /**
                         * ListRegionBackendServicesRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @instance
                         */
                        ListRegionBackendServicesRequest.prototype.region = "";
    
                        /**
                         * ListRegionBackendServicesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @instance
                         */
                        ListRegionBackendServicesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionBackendServicesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionBackendServicesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionBackendServicesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionBackendServicesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionBackendServicesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionBackendServicesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionBackendServicesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionBackendServicesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionBackendServicesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionBackendServicesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionBackendServicesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionBackendServicesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionBackendServicesRequest} ListRegionBackendServicesRequest instance
                         */
                        ListRegionBackendServicesRequest.create = function create(properties) {
                            return new ListRegionBackendServicesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionBackendServicesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionBackendServicesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionBackendServicesRequest} message ListRegionBackendServicesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionBackendServicesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionBackendServicesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionBackendServicesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionBackendServicesRequest} message ListRegionBackendServicesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionBackendServicesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionBackendServicesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionBackendServicesRequest} ListRegionBackendServicesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionBackendServicesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionBackendServicesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionBackendServicesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionBackendServicesRequest} ListRegionBackendServicesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionBackendServicesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionBackendServicesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionBackendServicesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionBackendServicesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionBackendServicesRequest} ListRegionBackendServicesRequest
                         */
                        ListRegionBackendServicesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionBackendServicesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionBackendServicesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionBackendServicesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionBackendServicesRequest} message ListRegionBackendServicesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionBackendServicesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionBackendServicesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionBackendServicesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionBackendServicesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionBackendServicesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionBackendServicesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionBackendServicesRequest";
                        };
    
                        return ListRegionBackendServicesRequest;
                    })();
    
                    v1.ListRegionCommitmentsRequest = (function() {
    
                        /**
                         * Properties of a ListRegionCommitmentsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionCommitmentsRequest
                         * @property {string|null} [filter] ListRegionCommitmentsRequest filter
                         * @property {number|null} [maxResults] ListRegionCommitmentsRequest maxResults
                         * @property {string|null} [orderBy] ListRegionCommitmentsRequest orderBy
                         * @property {string|null} [pageToken] ListRegionCommitmentsRequest pageToken
                         * @property {string|null} [project] ListRegionCommitmentsRequest project
                         * @property {string|null} [region] ListRegionCommitmentsRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRegionCommitmentsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionCommitmentsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionCommitmentsRequest.
                         * @implements IListRegionCommitmentsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionCommitmentsRequest=} [properties] Properties to set
                         */
                        function ListRegionCommitmentsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionCommitmentsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @instance
                         */
                        ListRegionCommitmentsRequest.prototype.filter = null;
    
                        /**
                         * ListRegionCommitmentsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @instance
                         */
                        ListRegionCommitmentsRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionCommitmentsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @instance
                         */
                        ListRegionCommitmentsRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionCommitmentsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @instance
                         */
                        ListRegionCommitmentsRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionCommitmentsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @instance
                         */
                        ListRegionCommitmentsRequest.prototype.project = "";
    
                        /**
                         * ListRegionCommitmentsRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @instance
                         */
                        ListRegionCommitmentsRequest.prototype.region = "";
    
                        /**
                         * ListRegionCommitmentsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @instance
                         */
                        ListRegionCommitmentsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionCommitmentsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionCommitmentsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionCommitmentsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionCommitmentsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionCommitmentsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionCommitmentsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionCommitmentsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionCommitmentsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionCommitmentsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionCommitmentsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionCommitmentsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionCommitmentsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionCommitmentsRequest} ListRegionCommitmentsRequest instance
                         */
                        ListRegionCommitmentsRequest.create = function create(properties) {
                            return new ListRegionCommitmentsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionCommitmentsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionCommitmentsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionCommitmentsRequest} message ListRegionCommitmentsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionCommitmentsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionCommitmentsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionCommitmentsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionCommitmentsRequest} message ListRegionCommitmentsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionCommitmentsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionCommitmentsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionCommitmentsRequest} ListRegionCommitmentsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionCommitmentsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionCommitmentsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionCommitmentsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionCommitmentsRequest} ListRegionCommitmentsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionCommitmentsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionCommitmentsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionCommitmentsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionCommitmentsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionCommitmentsRequest} ListRegionCommitmentsRequest
                         */
                        ListRegionCommitmentsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionCommitmentsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionCommitmentsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionCommitmentsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionCommitmentsRequest} message ListRegionCommitmentsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionCommitmentsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionCommitmentsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionCommitmentsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionCommitmentsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionCommitmentsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionCommitmentsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionCommitmentsRequest";
                        };
    
                        return ListRegionCommitmentsRequest;
                    })();
    
                    v1.ListRegionDiskTypesRequest = (function() {
    
                        /**
                         * Properties of a ListRegionDiskTypesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionDiskTypesRequest
                         * @property {string|null} [filter] ListRegionDiskTypesRequest filter
                         * @property {number|null} [maxResults] ListRegionDiskTypesRequest maxResults
                         * @property {string|null} [orderBy] ListRegionDiskTypesRequest orderBy
                         * @property {string|null} [pageToken] ListRegionDiskTypesRequest pageToken
                         * @property {string|null} [project] ListRegionDiskTypesRequest project
                         * @property {string|null} [region] ListRegionDiskTypesRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRegionDiskTypesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionDiskTypesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionDiskTypesRequest.
                         * @implements IListRegionDiskTypesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionDiskTypesRequest=} [properties] Properties to set
                         */
                        function ListRegionDiskTypesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionDiskTypesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @instance
                         */
                        ListRegionDiskTypesRequest.prototype.filter = null;
    
                        /**
                         * ListRegionDiskTypesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @instance
                         */
                        ListRegionDiskTypesRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionDiskTypesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @instance
                         */
                        ListRegionDiskTypesRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionDiskTypesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @instance
                         */
                        ListRegionDiskTypesRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionDiskTypesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @instance
                         */
                        ListRegionDiskTypesRequest.prototype.project = "";
    
                        /**
                         * ListRegionDiskTypesRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @instance
                         */
                        ListRegionDiskTypesRequest.prototype.region = "";
    
                        /**
                         * ListRegionDiskTypesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @instance
                         */
                        ListRegionDiskTypesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionDiskTypesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionDiskTypesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionDiskTypesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionDiskTypesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionDiskTypesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionDiskTypesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionDiskTypesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionDiskTypesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionDiskTypesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionDiskTypesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionDiskTypesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionDiskTypesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionDiskTypesRequest} ListRegionDiskTypesRequest instance
                         */
                        ListRegionDiskTypesRequest.create = function create(properties) {
                            return new ListRegionDiskTypesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionDiskTypesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionDiskTypesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionDiskTypesRequest} message ListRegionDiskTypesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionDiskTypesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionDiskTypesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionDiskTypesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionDiskTypesRequest} message ListRegionDiskTypesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionDiskTypesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionDiskTypesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionDiskTypesRequest} ListRegionDiskTypesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionDiskTypesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionDiskTypesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionDiskTypesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionDiskTypesRequest} ListRegionDiskTypesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionDiskTypesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionDiskTypesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionDiskTypesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionDiskTypesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionDiskTypesRequest} ListRegionDiskTypesRequest
                         */
                        ListRegionDiskTypesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionDiskTypesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionDiskTypesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionDiskTypesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionDiskTypesRequest} message ListRegionDiskTypesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionDiskTypesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionDiskTypesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionDiskTypesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionDiskTypesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionDiskTypesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionDiskTypesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionDiskTypesRequest";
                        };
    
                        return ListRegionDiskTypesRequest;
                    })();
    
                    v1.ListRegionDisksRequest = (function() {
    
                        /**
                         * Properties of a ListRegionDisksRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionDisksRequest
                         * @property {string|null} [filter] ListRegionDisksRequest filter
                         * @property {number|null} [maxResults] ListRegionDisksRequest maxResults
                         * @property {string|null} [orderBy] ListRegionDisksRequest orderBy
                         * @property {string|null} [pageToken] ListRegionDisksRequest pageToken
                         * @property {string|null} [project] ListRegionDisksRequest project
                         * @property {string|null} [region] ListRegionDisksRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRegionDisksRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionDisksRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionDisksRequest.
                         * @implements IListRegionDisksRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionDisksRequest=} [properties] Properties to set
                         */
                        function ListRegionDisksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionDisksRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @instance
                         */
                        ListRegionDisksRequest.prototype.filter = null;
    
                        /**
                         * ListRegionDisksRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @instance
                         */
                        ListRegionDisksRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionDisksRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @instance
                         */
                        ListRegionDisksRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionDisksRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @instance
                         */
                        ListRegionDisksRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionDisksRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @instance
                         */
                        ListRegionDisksRequest.prototype.project = "";
    
                        /**
                         * ListRegionDisksRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @instance
                         */
                        ListRegionDisksRequest.prototype.region = "";
    
                        /**
                         * ListRegionDisksRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @instance
                         */
                        ListRegionDisksRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionDisksRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionDisksRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionDisksRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionDisksRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionDisksRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionDisksRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionDisksRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionDisksRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionDisksRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionDisksRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionDisksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionDisksRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionDisksRequest} ListRegionDisksRequest instance
                         */
                        ListRegionDisksRequest.create = function create(properties) {
                            return new ListRegionDisksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionDisksRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionDisksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionDisksRequest} message ListRegionDisksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionDisksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionDisksRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionDisksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionDisksRequest} message ListRegionDisksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionDisksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionDisksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionDisksRequest} ListRegionDisksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionDisksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionDisksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionDisksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionDisksRequest} ListRegionDisksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionDisksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionDisksRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionDisksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionDisksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionDisksRequest} ListRegionDisksRequest
                         */
                        ListRegionDisksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionDisksRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionDisksRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionDisksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionDisksRequest} message ListRegionDisksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionDisksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionDisksRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionDisksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionDisksRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionDisksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionDisksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionDisksRequest";
                        };
    
                        return ListRegionDisksRequest;
                    })();
    
                    v1.ListRegionHealthCheckServicesRequest = (function() {
    
                        /**
                         * Properties of a ListRegionHealthCheckServicesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionHealthCheckServicesRequest
                         * @property {string|null} [filter] ListRegionHealthCheckServicesRequest filter
                         * @property {number|null} [maxResults] ListRegionHealthCheckServicesRequest maxResults
                         * @property {string|null} [orderBy] ListRegionHealthCheckServicesRequest orderBy
                         * @property {string|null} [pageToken] ListRegionHealthCheckServicesRequest pageToken
                         * @property {string|null} [project] ListRegionHealthCheckServicesRequest project
                         * @property {string|null} [region] ListRegionHealthCheckServicesRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRegionHealthCheckServicesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionHealthCheckServicesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionHealthCheckServicesRequest.
                         * @implements IListRegionHealthCheckServicesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionHealthCheckServicesRequest=} [properties] Properties to set
                         */
                        function ListRegionHealthCheckServicesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionHealthCheckServicesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @instance
                         */
                        ListRegionHealthCheckServicesRequest.prototype.filter = null;
    
                        /**
                         * ListRegionHealthCheckServicesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @instance
                         */
                        ListRegionHealthCheckServicesRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionHealthCheckServicesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @instance
                         */
                        ListRegionHealthCheckServicesRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionHealthCheckServicesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @instance
                         */
                        ListRegionHealthCheckServicesRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionHealthCheckServicesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @instance
                         */
                        ListRegionHealthCheckServicesRequest.prototype.project = "";
    
                        /**
                         * ListRegionHealthCheckServicesRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @instance
                         */
                        ListRegionHealthCheckServicesRequest.prototype.region = "";
    
                        /**
                         * ListRegionHealthCheckServicesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @instance
                         */
                        ListRegionHealthCheckServicesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionHealthCheckServicesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionHealthCheckServicesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionHealthCheckServicesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionHealthCheckServicesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionHealthCheckServicesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionHealthCheckServicesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionHealthCheckServicesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionHealthCheckServicesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionHealthCheckServicesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionHealthCheckServicesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionHealthCheckServicesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionHealthCheckServicesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionHealthCheckServicesRequest} ListRegionHealthCheckServicesRequest instance
                         */
                        ListRegionHealthCheckServicesRequest.create = function create(properties) {
                            return new ListRegionHealthCheckServicesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionHealthCheckServicesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionHealthCheckServicesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionHealthCheckServicesRequest} message ListRegionHealthCheckServicesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionHealthCheckServicesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionHealthCheckServicesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionHealthCheckServicesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionHealthCheckServicesRequest} message ListRegionHealthCheckServicesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionHealthCheckServicesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionHealthCheckServicesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionHealthCheckServicesRequest} ListRegionHealthCheckServicesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionHealthCheckServicesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionHealthCheckServicesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionHealthCheckServicesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionHealthCheckServicesRequest} ListRegionHealthCheckServicesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionHealthCheckServicesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionHealthCheckServicesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionHealthCheckServicesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionHealthCheckServicesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionHealthCheckServicesRequest} ListRegionHealthCheckServicesRequest
                         */
                        ListRegionHealthCheckServicesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionHealthCheckServicesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionHealthCheckServicesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionHealthCheckServicesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionHealthCheckServicesRequest} message ListRegionHealthCheckServicesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionHealthCheckServicesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionHealthCheckServicesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionHealthCheckServicesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionHealthCheckServicesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionHealthCheckServicesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionHealthCheckServicesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionHealthCheckServicesRequest";
                        };
    
                        return ListRegionHealthCheckServicesRequest;
                    })();
    
                    v1.ListRegionHealthChecksRequest = (function() {
    
                        /**
                         * Properties of a ListRegionHealthChecksRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionHealthChecksRequest
                         * @property {string|null} [filter] ListRegionHealthChecksRequest filter
                         * @property {number|null} [maxResults] ListRegionHealthChecksRequest maxResults
                         * @property {string|null} [orderBy] ListRegionHealthChecksRequest orderBy
                         * @property {string|null} [pageToken] ListRegionHealthChecksRequest pageToken
                         * @property {string|null} [project] ListRegionHealthChecksRequest project
                         * @property {string|null} [region] ListRegionHealthChecksRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRegionHealthChecksRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionHealthChecksRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionHealthChecksRequest.
                         * @implements IListRegionHealthChecksRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionHealthChecksRequest=} [properties] Properties to set
                         */
                        function ListRegionHealthChecksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionHealthChecksRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @instance
                         */
                        ListRegionHealthChecksRequest.prototype.filter = null;
    
                        /**
                         * ListRegionHealthChecksRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @instance
                         */
                        ListRegionHealthChecksRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionHealthChecksRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @instance
                         */
                        ListRegionHealthChecksRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionHealthChecksRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @instance
                         */
                        ListRegionHealthChecksRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionHealthChecksRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @instance
                         */
                        ListRegionHealthChecksRequest.prototype.project = "";
    
                        /**
                         * ListRegionHealthChecksRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @instance
                         */
                        ListRegionHealthChecksRequest.prototype.region = "";
    
                        /**
                         * ListRegionHealthChecksRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @instance
                         */
                        ListRegionHealthChecksRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionHealthChecksRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionHealthChecksRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionHealthChecksRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionHealthChecksRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionHealthChecksRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionHealthChecksRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionHealthChecksRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionHealthChecksRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionHealthChecksRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionHealthChecksRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionHealthChecksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionHealthChecksRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionHealthChecksRequest} ListRegionHealthChecksRequest instance
                         */
                        ListRegionHealthChecksRequest.create = function create(properties) {
                            return new ListRegionHealthChecksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionHealthChecksRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionHealthChecksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionHealthChecksRequest} message ListRegionHealthChecksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionHealthChecksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionHealthChecksRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionHealthChecksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionHealthChecksRequest} message ListRegionHealthChecksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionHealthChecksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionHealthChecksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionHealthChecksRequest} ListRegionHealthChecksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionHealthChecksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionHealthChecksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionHealthChecksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionHealthChecksRequest} ListRegionHealthChecksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionHealthChecksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionHealthChecksRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionHealthChecksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionHealthChecksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionHealthChecksRequest} ListRegionHealthChecksRequest
                         */
                        ListRegionHealthChecksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionHealthChecksRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionHealthChecksRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionHealthChecksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionHealthChecksRequest} message ListRegionHealthChecksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionHealthChecksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionHealthChecksRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionHealthChecksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionHealthChecksRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionHealthChecksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionHealthChecksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionHealthChecksRequest";
                        };
    
                        return ListRegionHealthChecksRequest;
                    })();
    
                    v1.ListRegionInstanceGroupManagersRequest = (function() {
    
                        /**
                         * Properties of a ListRegionInstanceGroupManagersRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionInstanceGroupManagersRequest
                         * @property {string|null} [filter] ListRegionInstanceGroupManagersRequest filter
                         * @property {number|null} [maxResults] ListRegionInstanceGroupManagersRequest maxResults
                         * @property {string|null} [orderBy] ListRegionInstanceGroupManagersRequest orderBy
                         * @property {string|null} [pageToken] ListRegionInstanceGroupManagersRequest pageToken
                         * @property {string|null} [project] ListRegionInstanceGroupManagersRequest project
                         * @property {string|null} [region] ListRegionInstanceGroupManagersRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRegionInstanceGroupManagersRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionInstanceGroupManagersRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionInstanceGroupManagersRequest.
                         * @implements IListRegionInstanceGroupManagersRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionInstanceGroupManagersRequest=} [properties] Properties to set
                         */
                        function ListRegionInstanceGroupManagersRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionInstanceGroupManagersRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListRegionInstanceGroupManagersRequest.prototype.filter = null;
    
                        /**
                         * ListRegionInstanceGroupManagersRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListRegionInstanceGroupManagersRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionInstanceGroupManagersRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListRegionInstanceGroupManagersRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionInstanceGroupManagersRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListRegionInstanceGroupManagersRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionInstanceGroupManagersRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListRegionInstanceGroupManagersRequest.prototype.project = "";
    
                        /**
                         * ListRegionInstanceGroupManagersRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListRegionInstanceGroupManagersRequest.prototype.region = "";
    
                        /**
                         * ListRegionInstanceGroupManagersRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        ListRegionInstanceGroupManagersRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionInstanceGroupManagersRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionInstanceGroupManagersRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionInstanceGroupManagersRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionInstanceGroupManagersRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionInstanceGroupManagersRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionInstanceGroupManagersRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionInstanceGroupManagersRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionInstanceGroupManagersRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionInstanceGroupManagersRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionInstanceGroupManagersRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionInstanceGroupManagersRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionInstanceGroupManagersRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest} ListRegionInstanceGroupManagersRequest instance
                         */
                        ListRegionInstanceGroupManagersRequest.create = function create(properties) {
                            return new ListRegionInstanceGroupManagersRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionInstanceGroupManagersRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionInstanceGroupManagersRequest} message ListRegionInstanceGroupManagersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionInstanceGroupManagersRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionInstanceGroupManagersRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionInstanceGroupManagersRequest} message ListRegionInstanceGroupManagersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionInstanceGroupManagersRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionInstanceGroupManagersRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest} ListRegionInstanceGroupManagersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionInstanceGroupManagersRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionInstanceGroupManagersRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest} ListRegionInstanceGroupManagersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionInstanceGroupManagersRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionInstanceGroupManagersRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionInstanceGroupManagersRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionInstanceGroupManagersRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest} ListRegionInstanceGroupManagersRequest
                         */
                        ListRegionInstanceGroupManagersRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionInstanceGroupManagersRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest} message ListRegionInstanceGroupManagersRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionInstanceGroupManagersRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionInstanceGroupManagersRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionInstanceGroupManagersRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionInstanceGroupManagersRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionInstanceGroupManagersRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest";
                        };
    
                        return ListRegionInstanceGroupManagersRequest;
                    })();
    
                    v1.ListRegionInstanceGroupsRequest = (function() {
    
                        /**
                         * Properties of a ListRegionInstanceGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionInstanceGroupsRequest
                         * @property {string|null} [filter] ListRegionInstanceGroupsRequest filter
                         * @property {number|null} [maxResults] ListRegionInstanceGroupsRequest maxResults
                         * @property {string|null} [orderBy] ListRegionInstanceGroupsRequest orderBy
                         * @property {string|null} [pageToken] ListRegionInstanceGroupsRequest pageToken
                         * @property {string|null} [project] ListRegionInstanceGroupsRequest project
                         * @property {string|null} [region] ListRegionInstanceGroupsRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRegionInstanceGroupsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionInstanceGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionInstanceGroupsRequest.
                         * @implements IListRegionInstanceGroupsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionInstanceGroupsRequest=} [properties] Properties to set
                         */
                        function ListRegionInstanceGroupsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionInstanceGroupsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @instance
                         */
                        ListRegionInstanceGroupsRequest.prototype.filter = null;
    
                        /**
                         * ListRegionInstanceGroupsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @instance
                         */
                        ListRegionInstanceGroupsRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionInstanceGroupsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @instance
                         */
                        ListRegionInstanceGroupsRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionInstanceGroupsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @instance
                         */
                        ListRegionInstanceGroupsRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionInstanceGroupsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @instance
                         */
                        ListRegionInstanceGroupsRequest.prototype.project = "";
    
                        /**
                         * ListRegionInstanceGroupsRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @instance
                         */
                        ListRegionInstanceGroupsRequest.prototype.region = "";
    
                        /**
                         * ListRegionInstanceGroupsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @instance
                         */
                        ListRegionInstanceGroupsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionInstanceGroupsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionInstanceGroupsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionInstanceGroupsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionInstanceGroupsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionInstanceGroupsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionInstanceGroupsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionInstanceGroupsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionInstanceGroupsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionInstanceGroupsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionInstanceGroupsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionInstanceGroupsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionInstanceGroupsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionInstanceGroupsRequest} ListRegionInstanceGroupsRequest instance
                         */
                        ListRegionInstanceGroupsRequest.create = function create(properties) {
                            return new ListRegionInstanceGroupsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionInstanceGroupsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionInstanceGroupsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionInstanceGroupsRequest} message ListRegionInstanceGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionInstanceGroupsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionInstanceGroupsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionInstanceGroupsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionInstanceGroupsRequest} message ListRegionInstanceGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionInstanceGroupsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionInstanceGroupsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionInstanceGroupsRequest} ListRegionInstanceGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionInstanceGroupsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionInstanceGroupsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionInstanceGroupsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionInstanceGroupsRequest} ListRegionInstanceGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionInstanceGroupsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionInstanceGroupsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionInstanceGroupsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionInstanceGroupsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionInstanceGroupsRequest} ListRegionInstanceGroupsRequest
                         */
                        ListRegionInstanceGroupsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionInstanceGroupsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionInstanceGroupsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionInstanceGroupsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionInstanceGroupsRequest} message ListRegionInstanceGroupsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionInstanceGroupsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionInstanceGroupsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionInstanceGroupsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionInstanceGroupsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionInstanceGroupsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionInstanceGroupsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionInstanceGroupsRequest";
                        };
    
                        return ListRegionInstanceGroupsRequest;
                    })();
    
                    v1.ListRegionNetworkEndpointGroupsRequest = (function() {
    
                        /**
                         * Properties of a ListRegionNetworkEndpointGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionNetworkEndpointGroupsRequest
                         * @property {string|null} [filter] ListRegionNetworkEndpointGroupsRequest filter
                         * @property {number|null} [maxResults] ListRegionNetworkEndpointGroupsRequest maxResults
                         * @property {string|null} [orderBy] ListRegionNetworkEndpointGroupsRequest orderBy
                         * @property {string|null} [pageToken] ListRegionNetworkEndpointGroupsRequest pageToken
                         * @property {string|null} [project] ListRegionNetworkEndpointGroupsRequest project
                         * @property {string|null} [region] ListRegionNetworkEndpointGroupsRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRegionNetworkEndpointGroupsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionNetworkEndpointGroupsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionNetworkEndpointGroupsRequest.
                         * @implements IListRegionNetworkEndpointGroupsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionNetworkEndpointGroupsRequest=} [properties] Properties to set
                         */
                        function ListRegionNetworkEndpointGroupsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionNetworkEndpointGroupsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListRegionNetworkEndpointGroupsRequest.prototype.filter = null;
    
                        /**
                         * ListRegionNetworkEndpointGroupsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListRegionNetworkEndpointGroupsRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionNetworkEndpointGroupsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListRegionNetworkEndpointGroupsRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionNetworkEndpointGroupsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListRegionNetworkEndpointGroupsRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionNetworkEndpointGroupsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListRegionNetworkEndpointGroupsRequest.prototype.project = "";
    
                        /**
                         * ListRegionNetworkEndpointGroupsRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListRegionNetworkEndpointGroupsRequest.prototype.region = "";
    
                        /**
                         * ListRegionNetworkEndpointGroupsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @instance
                         */
                        ListRegionNetworkEndpointGroupsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionNetworkEndpointGroupsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionNetworkEndpointGroupsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionNetworkEndpointGroupsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionNetworkEndpointGroupsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionNetworkEndpointGroupsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionNetworkEndpointGroupsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionNetworkEndpointGroupsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionNetworkEndpointGroupsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionNetworkEndpointGroupsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionNetworkEndpointGroupsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionNetworkEndpointGroupsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionNetworkEndpointGroupsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest} ListRegionNetworkEndpointGroupsRequest instance
                         */
                        ListRegionNetworkEndpointGroupsRequest.create = function create(properties) {
                            return new ListRegionNetworkEndpointGroupsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionNetworkEndpointGroupsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionNetworkEndpointGroupsRequest} message ListRegionNetworkEndpointGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionNetworkEndpointGroupsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionNetworkEndpointGroupsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionNetworkEndpointGroupsRequest} message ListRegionNetworkEndpointGroupsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionNetworkEndpointGroupsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionNetworkEndpointGroupsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest} ListRegionNetworkEndpointGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionNetworkEndpointGroupsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionNetworkEndpointGroupsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest} ListRegionNetworkEndpointGroupsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionNetworkEndpointGroupsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionNetworkEndpointGroupsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionNetworkEndpointGroupsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionNetworkEndpointGroupsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest} ListRegionNetworkEndpointGroupsRequest
                         */
                        ListRegionNetworkEndpointGroupsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionNetworkEndpointGroupsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest} message ListRegionNetworkEndpointGroupsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionNetworkEndpointGroupsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionNetworkEndpointGroupsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionNetworkEndpointGroupsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionNetworkEndpointGroupsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionNetworkEndpointGroupsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest";
                        };
    
                        return ListRegionNetworkEndpointGroupsRequest;
                    })();
    
                    v1.ListRegionNetworkFirewallPoliciesRequest = (function() {
    
                        /**
                         * Properties of a ListRegionNetworkFirewallPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionNetworkFirewallPoliciesRequest
                         * @property {string|null} [filter] ListRegionNetworkFirewallPoliciesRequest filter
                         * @property {number|null} [maxResults] ListRegionNetworkFirewallPoliciesRequest maxResults
                         * @property {string|null} [orderBy] ListRegionNetworkFirewallPoliciesRequest orderBy
                         * @property {string|null} [pageToken] ListRegionNetworkFirewallPoliciesRequest pageToken
                         * @property {string|null} [project] ListRegionNetworkFirewallPoliciesRequest project
                         * @property {string|null} [region] ListRegionNetworkFirewallPoliciesRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRegionNetworkFirewallPoliciesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionNetworkFirewallPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionNetworkFirewallPoliciesRequest.
                         * @implements IListRegionNetworkFirewallPoliciesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionNetworkFirewallPoliciesRequest=} [properties] Properties to set
                         */
                        function ListRegionNetworkFirewallPoliciesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionNetworkFirewallPoliciesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        ListRegionNetworkFirewallPoliciesRequest.prototype.filter = null;
    
                        /**
                         * ListRegionNetworkFirewallPoliciesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        ListRegionNetworkFirewallPoliciesRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionNetworkFirewallPoliciesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        ListRegionNetworkFirewallPoliciesRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionNetworkFirewallPoliciesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        ListRegionNetworkFirewallPoliciesRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionNetworkFirewallPoliciesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        ListRegionNetworkFirewallPoliciesRequest.prototype.project = "";
    
                        /**
                         * ListRegionNetworkFirewallPoliciesRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        ListRegionNetworkFirewallPoliciesRequest.prototype.region = "";
    
                        /**
                         * ListRegionNetworkFirewallPoliciesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        ListRegionNetworkFirewallPoliciesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionNetworkFirewallPoliciesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionNetworkFirewallPoliciesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionNetworkFirewallPoliciesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionNetworkFirewallPoliciesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionNetworkFirewallPoliciesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionNetworkFirewallPoliciesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionNetworkFirewallPoliciesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionNetworkFirewallPoliciesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionNetworkFirewallPoliciesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionNetworkFirewallPoliciesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionNetworkFirewallPoliciesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionNetworkFirewallPoliciesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest} ListRegionNetworkFirewallPoliciesRequest instance
                         */
                        ListRegionNetworkFirewallPoliciesRequest.create = function create(properties) {
                            return new ListRegionNetworkFirewallPoliciesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionNetworkFirewallPoliciesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionNetworkFirewallPoliciesRequest} message ListRegionNetworkFirewallPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionNetworkFirewallPoliciesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionNetworkFirewallPoliciesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionNetworkFirewallPoliciesRequest} message ListRegionNetworkFirewallPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionNetworkFirewallPoliciesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionNetworkFirewallPoliciesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest} ListRegionNetworkFirewallPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionNetworkFirewallPoliciesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionNetworkFirewallPoliciesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest} ListRegionNetworkFirewallPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionNetworkFirewallPoliciesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionNetworkFirewallPoliciesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionNetworkFirewallPoliciesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionNetworkFirewallPoliciesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest} ListRegionNetworkFirewallPoliciesRequest
                         */
                        ListRegionNetworkFirewallPoliciesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionNetworkFirewallPoliciesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest} message ListRegionNetworkFirewallPoliciesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionNetworkFirewallPoliciesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionNetworkFirewallPoliciesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionNetworkFirewallPoliciesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionNetworkFirewallPoliciesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionNetworkFirewallPoliciesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest";
                        };
    
                        return ListRegionNetworkFirewallPoliciesRequest;
                    })();
    
                    v1.ListRegionNotificationEndpointsRequest = (function() {
    
                        /**
                         * Properties of a ListRegionNotificationEndpointsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionNotificationEndpointsRequest
                         * @property {string|null} [filter] ListRegionNotificationEndpointsRequest filter
                         * @property {number|null} [maxResults] ListRegionNotificationEndpointsRequest maxResults
                         * @property {string|null} [orderBy] ListRegionNotificationEndpointsRequest orderBy
                         * @property {string|null} [pageToken] ListRegionNotificationEndpointsRequest pageToken
                         * @property {string|null} [project] ListRegionNotificationEndpointsRequest project
                         * @property {string|null} [region] ListRegionNotificationEndpointsRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRegionNotificationEndpointsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionNotificationEndpointsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionNotificationEndpointsRequest.
                         * @implements IListRegionNotificationEndpointsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionNotificationEndpointsRequest=} [properties] Properties to set
                         */
                        function ListRegionNotificationEndpointsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionNotificationEndpointsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @instance
                         */
                        ListRegionNotificationEndpointsRequest.prototype.filter = null;
    
                        /**
                         * ListRegionNotificationEndpointsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @instance
                         */
                        ListRegionNotificationEndpointsRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionNotificationEndpointsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @instance
                         */
                        ListRegionNotificationEndpointsRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionNotificationEndpointsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @instance
                         */
                        ListRegionNotificationEndpointsRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionNotificationEndpointsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @instance
                         */
                        ListRegionNotificationEndpointsRequest.prototype.project = "";
    
                        /**
                         * ListRegionNotificationEndpointsRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @instance
                         */
                        ListRegionNotificationEndpointsRequest.prototype.region = "";
    
                        /**
                         * ListRegionNotificationEndpointsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @instance
                         */
                        ListRegionNotificationEndpointsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionNotificationEndpointsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionNotificationEndpointsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionNotificationEndpointsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionNotificationEndpointsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionNotificationEndpointsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionNotificationEndpointsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionNotificationEndpointsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionNotificationEndpointsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionNotificationEndpointsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionNotificationEndpointsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionNotificationEndpointsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionNotificationEndpointsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionNotificationEndpointsRequest} ListRegionNotificationEndpointsRequest instance
                         */
                        ListRegionNotificationEndpointsRequest.create = function create(properties) {
                            return new ListRegionNotificationEndpointsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionNotificationEndpointsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionNotificationEndpointsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionNotificationEndpointsRequest} message ListRegionNotificationEndpointsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionNotificationEndpointsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionNotificationEndpointsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionNotificationEndpointsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionNotificationEndpointsRequest} message ListRegionNotificationEndpointsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionNotificationEndpointsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionNotificationEndpointsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionNotificationEndpointsRequest} ListRegionNotificationEndpointsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionNotificationEndpointsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionNotificationEndpointsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionNotificationEndpointsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionNotificationEndpointsRequest} ListRegionNotificationEndpointsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionNotificationEndpointsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionNotificationEndpointsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionNotificationEndpointsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionNotificationEndpointsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionNotificationEndpointsRequest} ListRegionNotificationEndpointsRequest
                         */
                        ListRegionNotificationEndpointsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionNotificationEndpointsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionNotificationEndpointsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionNotificationEndpointsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionNotificationEndpointsRequest} message ListRegionNotificationEndpointsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionNotificationEndpointsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionNotificationEndpointsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionNotificationEndpointsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionNotificationEndpointsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionNotificationEndpointsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionNotificationEndpointsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionNotificationEndpointsRequest";
                        };
    
                        return ListRegionNotificationEndpointsRequest;
                    })();
    
                    v1.ListRegionOperationsRequest = (function() {
    
                        /**
                         * Properties of a ListRegionOperationsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionOperationsRequest
                         * @property {string|null} [filter] ListRegionOperationsRequest filter
                         * @property {number|null} [maxResults] ListRegionOperationsRequest maxResults
                         * @property {string|null} [orderBy] ListRegionOperationsRequest orderBy
                         * @property {string|null} [pageToken] ListRegionOperationsRequest pageToken
                         * @property {string|null} [project] ListRegionOperationsRequest project
                         * @property {string|null} [region] ListRegionOperationsRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRegionOperationsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionOperationsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionOperationsRequest.
                         * @implements IListRegionOperationsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionOperationsRequest=} [properties] Properties to set
                         */
                        function ListRegionOperationsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionOperationsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @instance
                         */
                        ListRegionOperationsRequest.prototype.filter = null;
    
                        /**
                         * ListRegionOperationsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @instance
                         */
                        ListRegionOperationsRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionOperationsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @instance
                         */
                        ListRegionOperationsRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionOperationsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @instance
                         */
                        ListRegionOperationsRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionOperationsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @instance
                         */
                        ListRegionOperationsRequest.prototype.project = "";
    
                        /**
                         * ListRegionOperationsRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @instance
                         */
                        ListRegionOperationsRequest.prototype.region = "";
    
                        /**
                         * ListRegionOperationsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @instance
                         */
                        ListRegionOperationsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionOperationsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionOperationsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionOperationsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionOperationsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionOperationsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionOperationsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionOperationsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionOperationsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionOperationsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionOperationsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionOperationsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionOperationsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionOperationsRequest} ListRegionOperationsRequest instance
                         */
                        ListRegionOperationsRequest.create = function create(properties) {
                            return new ListRegionOperationsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionOperationsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionOperationsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionOperationsRequest} message ListRegionOperationsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionOperationsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionOperationsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionOperationsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionOperationsRequest} message ListRegionOperationsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionOperationsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionOperationsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionOperationsRequest} ListRegionOperationsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionOperationsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionOperationsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionOperationsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionOperationsRequest} ListRegionOperationsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionOperationsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionOperationsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionOperationsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionOperationsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionOperationsRequest} ListRegionOperationsRequest
                         */
                        ListRegionOperationsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionOperationsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionOperationsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionOperationsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionOperationsRequest} message ListRegionOperationsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionOperationsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionOperationsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionOperationsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionOperationsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionOperationsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionOperationsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionOperationsRequest";
                        };
    
                        return ListRegionOperationsRequest;
                    })();
    
                    v1.ListRegionSecurityPoliciesRequest = (function() {
    
                        /**
                         * Properties of a ListRegionSecurityPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionSecurityPoliciesRequest
                         * @property {string|null} [filter] ListRegionSecurityPoliciesRequest filter
                         * @property {number|null} [maxResults] ListRegionSecurityPoliciesRequest maxResults
                         * @property {string|null} [orderBy] ListRegionSecurityPoliciesRequest orderBy
                         * @property {string|null} [pageToken] ListRegionSecurityPoliciesRequest pageToken
                         * @property {string|null} [project] ListRegionSecurityPoliciesRequest project
                         * @property {string|null} [region] ListRegionSecurityPoliciesRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRegionSecurityPoliciesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionSecurityPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionSecurityPoliciesRequest.
                         * @implements IListRegionSecurityPoliciesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionSecurityPoliciesRequest=} [properties] Properties to set
                         */
                        function ListRegionSecurityPoliciesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionSecurityPoliciesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @instance
                         */
                        ListRegionSecurityPoliciesRequest.prototype.filter = null;
    
                        /**
                         * ListRegionSecurityPoliciesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @instance
                         */
                        ListRegionSecurityPoliciesRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionSecurityPoliciesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @instance
                         */
                        ListRegionSecurityPoliciesRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionSecurityPoliciesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @instance
                         */
                        ListRegionSecurityPoliciesRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionSecurityPoliciesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @instance
                         */
                        ListRegionSecurityPoliciesRequest.prototype.project = "";
    
                        /**
                         * ListRegionSecurityPoliciesRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @instance
                         */
                        ListRegionSecurityPoliciesRequest.prototype.region = "";
    
                        /**
                         * ListRegionSecurityPoliciesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @instance
                         */
                        ListRegionSecurityPoliciesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionSecurityPoliciesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionSecurityPoliciesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionSecurityPoliciesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionSecurityPoliciesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionSecurityPoliciesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionSecurityPoliciesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionSecurityPoliciesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionSecurityPoliciesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionSecurityPoliciesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionSecurityPoliciesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionSecurityPoliciesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionSecurityPoliciesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionSecurityPoliciesRequest} ListRegionSecurityPoliciesRequest instance
                         */
                        ListRegionSecurityPoliciesRequest.create = function create(properties) {
                            return new ListRegionSecurityPoliciesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionSecurityPoliciesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionSecurityPoliciesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionSecurityPoliciesRequest} message ListRegionSecurityPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionSecurityPoliciesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionSecurityPoliciesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionSecurityPoliciesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionSecurityPoliciesRequest} message ListRegionSecurityPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionSecurityPoliciesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionSecurityPoliciesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionSecurityPoliciesRequest} ListRegionSecurityPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionSecurityPoliciesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionSecurityPoliciesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionSecurityPoliciesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionSecurityPoliciesRequest} ListRegionSecurityPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionSecurityPoliciesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionSecurityPoliciesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionSecurityPoliciesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionSecurityPoliciesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionSecurityPoliciesRequest} ListRegionSecurityPoliciesRequest
                         */
                        ListRegionSecurityPoliciesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionSecurityPoliciesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionSecurityPoliciesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionSecurityPoliciesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionSecurityPoliciesRequest} message ListRegionSecurityPoliciesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionSecurityPoliciesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionSecurityPoliciesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionSecurityPoliciesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionSecurityPoliciesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionSecurityPoliciesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionSecurityPoliciesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionSecurityPoliciesRequest";
                        };
    
                        return ListRegionSecurityPoliciesRequest;
                    })();
    
                    v1.ListRegionSslCertificatesRequest = (function() {
    
                        /**
                         * Properties of a ListRegionSslCertificatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionSslCertificatesRequest
                         * @property {string|null} [filter] ListRegionSslCertificatesRequest filter
                         * @property {number|null} [maxResults] ListRegionSslCertificatesRequest maxResults
                         * @property {string|null} [orderBy] ListRegionSslCertificatesRequest orderBy
                         * @property {string|null} [pageToken] ListRegionSslCertificatesRequest pageToken
                         * @property {string|null} [project] ListRegionSslCertificatesRequest project
                         * @property {string|null} [region] ListRegionSslCertificatesRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRegionSslCertificatesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionSslCertificatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionSslCertificatesRequest.
                         * @implements IListRegionSslCertificatesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionSslCertificatesRequest=} [properties] Properties to set
                         */
                        function ListRegionSslCertificatesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionSslCertificatesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @instance
                         */
                        ListRegionSslCertificatesRequest.prototype.filter = null;
    
                        /**
                         * ListRegionSslCertificatesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @instance
                         */
                        ListRegionSslCertificatesRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionSslCertificatesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @instance
                         */
                        ListRegionSslCertificatesRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionSslCertificatesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @instance
                         */
                        ListRegionSslCertificatesRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionSslCertificatesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @instance
                         */
                        ListRegionSslCertificatesRequest.prototype.project = "";
    
                        /**
                         * ListRegionSslCertificatesRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @instance
                         */
                        ListRegionSslCertificatesRequest.prototype.region = "";
    
                        /**
                         * ListRegionSslCertificatesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @instance
                         */
                        ListRegionSslCertificatesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionSslCertificatesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionSslCertificatesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionSslCertificatesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionSslCertificatesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionSslCertificatesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionSslCertificatesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionSslCertificatesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionSslCertificatesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionSslCertificatesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionSslCertificatesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionSslCertificatesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionSslCertificatesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionSslCertificatesRequest} ListRegionSslCertificatesRequest instance
                         */
                        ListRegionSslCertificatesRequest.create = function create(properties) {
                            return new ListRegionSslCertificatesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionSslCertificatesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionSslCertificatesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionSslCertificatesRequest} message ListRegionSslCertificatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionSslCertificatesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionSslCertificatesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionSslCertificatesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionSslCertificatesRequest} message ListRegionSslCertificatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionSslCertificatesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionSslCertificatesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionSslCertificatesRequest} ListRegionSslCertificatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionSslCertificatesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionSslCertificatesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionSslCertificatesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionSslCertificatesRequest} ListRegionSslCertificatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionSslCertificatesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionSslCertificatesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionSslCertificatesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionSslCertificatesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionSslCertificatesRequest} ListRegionSslCertificatesRequest
                         */
                        ListRegionSslCertificatesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionSslCertificatesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionSslCertificatesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionSslCertificatesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionSslCertificatesRequest} message ListRegionSslCertificatesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionSslCertificatesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionSslCertificatesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionSslCertificatesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionSslCertificatesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionSslCertificatesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionSslCertificatesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionSslCertificatesRequest";
                        };
    
                        return ListRegionSslCertificatesRequest;
                    })();
    
                    v1.ListRegionSslPoliciesRequest = (function() {
    
                        /**
                         * Properties of a ListRegionSslPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionSslPoliciesRequest
                         * @property {string|null} [filter] ListRegionSslPoliciesRequest filter
                         * @property {number|null} [maxResults] ListRegionSslPoliciesRequest maxResults
                         * @property {string|null} [orderBy] ListRegionSslPoliciesRequest orderBy
                         * @property {string|null} [pageToken] ListRegionSslPoliciesRequest pageToken
                         * @property {string|null} [project] ListRegionSslPoliciesRequest project
                         * @property {string|null} [region] ListRegionSslPoliciesRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRegionSslPoliciesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionSslPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionSslPoliciesRequest.
                         * @implements IListRegionSslPoliciesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionSslPoliciesRequest=} [properties] Properties to set
                         */
                        function ListRegionSslPoliciesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionSslPoliciesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @instance
                         */
                        ListRegionSslPoliciesRequest.prototype.filter = null;
    
                        /**
                         * ListRegionSslPoliciesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @instance
                         */
                        ListRegionSslPoliciesRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionSslPoliciesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @instance
                         */
                        ListRegionSslPoliciesRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionSslPoliciesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @instance
                         */
                        ListRegionSslPoliciesRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionSslPoliciesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @instance
                         */
                        ListRegionSslPoliciesRequest.prototype.project = "";
    
                        /**
                         * ListRegionSslPoliciesRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @instance
                         */
                        ListRegionSslPoliciesRequest.prototype.region = "";
    
                        /**
                         * ListRegionSslPoliciesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @instance
                         */
                        ListRegionSslPoliciesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionSslPoliciesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionSslPoliciesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionSslPoliciesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionSslPoliciesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionSslPoliciesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionSslPoliciesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionSslPoliciesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionSslPoliciesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionSslPoliciesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionSslPoliciesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionSslPoliciesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionSslPoliciesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionSslPoliciesRequest} ListRegionSslPoliciesRequest instance
                         */
                        ListRegionSslPoliciesRequest.create = function create(properties) {
                            return new ListRegionSslPoliciesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionSslPoliciesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionSslPoliciesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionSslPoliciesRequest} message ListRegionSslPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionSslPoliciesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionSslPoliciesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionSslPoliciesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionSslPoliciesRequest} message ListRegionSslPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionSslPoliciesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionSslPoliciesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionSslPoliciesRequest} ListRegionSslPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionSslPoliciesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionSslPoliciesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionSslPoliciesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionSslPoliciesRequest} ListRegionSslPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionSslPoliciesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionSslPoliciesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionSslPoliciesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionSslPoliciesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionSslPoliciesRequest} ListRegionSslPoliciesRequest
                         */
                        ListRegionSslPoliciesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionSslPoliciesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionSslPoliciesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionSslPoliciesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionSslPoliciesRequest} message ListRegionSslPoliciesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionSslPoliciesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionSslPoliciesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionSslPoliciesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionSslPoliciesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionSslPoliciesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionSslPoliciesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionSslPoliciesRequest";
                        };
    
                        return ListRegionSslPoliciesRequest;
                    })();
    
                    v1.ListRegionTargetHttpProxiesRequest = (function() {
    
                        /**
                         * Properties of a ListRegionTargetHttpProxiesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionTargetHttpProxiesRequest
                         * @property {string|null} [filter] ListRegionTargetHttpProxiesRequest filter
                         * @property {number|null} [maxResults] ListRegionTargetHttpProxiesRequest maxResults
                         * @property {string|null} [orderBy] ListRegionTargetHttpProxiesRequest orderBy
                         * @property {string|null} [pageToken] ListRegionTargetHttpProxiesRequest pageToken
                         * @property {string|null} [project] ListRegionTargetHttpProxiesRequest project
                         * @property {string|null} [region] ListRegionTargetHttpProxiesRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRegionTargetHttpProxiesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionTargetHttpProxiesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionTargetHttpProxiesRequest.
                         * @implements IListRegionTargetHttpProxiesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionTargetHttpProxiesRequest=} [properties] Properties to set
                         */
                        function ListRegionTargetHttpProxiesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionTargetHttpProxiesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @instance
                         */
                        ListRegionTargetHttpProxiesRequest.prototype.filter = null;
    
                        /**
                         * ListRegionTargetHttpProxiesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @instance
                         */
                        ListRegionTargetHttpProxiesRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionTargetHttpProxiesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @instance
                         */
                        ListRegionTargetHttpProxiesRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionTargetHttpProxiesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @instance
                         */
                        ListRegionTargetHttpProxiesRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionTargetHttpProxiesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @instance
                         */
                        ListRegionTargetHttpProxiesRequest.prototype.project = "";
    
                        /**
                         * ListRegionTargetHttpProxiesRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @instance
                         */
                        ListRegionTargetHttpProxiesRequest.prototype.region = "";
    
                        /**
                         * ListRegionTargetHttpProxiesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @instance
                         */
                        ListRegionTargetHttpProxiesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionTargetHttpProxiesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionTargetHttpProxiesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionTargetHttpProxiesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionTargetHttpProxiesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionTargetHttpProxiesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionTargetHttpProxiesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionTargetHttpProxiesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionTargetHttpProxiesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionTargetHttpProxiesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionTargetHttpProxiesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionTargetHttpProxiesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionTargetHttpProxiesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest} ListRegionTargetHttpProxiesRequest instance
                         */
                        ListRegionTargetHttpProxiesRequest.create = function create(properties) {
                            return new ListRegionTargetHttpProxiesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionTargetHttpProxiesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionTargetHttpProxiesRequest} message ListRegionTargetHttpProxiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionTargetHttpProxiesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionTargetHttpProxiesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionTargetHttpProxiesRequest} message ListRegionTargetHttpProxiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionTargetHttpProxiesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionTargetHttpProxiesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest} ListRegionTargetHttpProxiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionTargetHttpProxiesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionTargetHttpProxiesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest} ListRegionTargetHttpProxiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionTargetHttpProxiesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionTargetHttpProxiesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionTargetHttpProxiesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionTargetHttpProxiesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest} ListRegionTargetHttpProxiesRequest
                         */
                        ListRegionTargetHttpProxiesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionTargetHttpProxiesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest} message ListRegionTargetHttpProxiesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionTargetHttpProxiesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionTargetHttpProxiesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionTargetHttpProxiesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionTargetHttpProxiesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionTargetHttpProxiesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest";
                        };
    
                        return ListRegionTargetHttpProxiesRequest;
                    })();
    
                    v1.ListRegionTargetHttpsProxiesRequest = (function() {
    
                        /**
                         * Properties of a ListRegionTargetHttpsProxiesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionTargetHttpsProxiesRequest
                         * @property {string|null} [filter] ListRegionTargetHttpsProxiesRequest filter
                         * @property {number|null} [maxResults] ListRegionTargetHttpsProxiesRequest maxResults
                         * @property {string|null} [orderBy] ListRegionTargetHttpsProxiesRequest orderBy
                         * @property {string|null} [pageToken] ListRegionTargetHttpsProxiesRequest pageToken
                         * @property {string|null} [project] ListRegionTargetHttpsProxiesRequest project
                         * @property {string|null} [region] ListRegionTargetHttpsProxiesRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRegionTargetHttpsProxiesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionTargetHttpsProxiesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionTargetHttpsProxiesRequest.
                         * @implements IListRegionTargetHttpsProxiesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionTargetHttpsProxiesRequest=} [properties] Properties to set
                         */
                        function ListRegionTargetHttpsProxiesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionTargetHttpsProxiesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @instance
                         */
                        ListRegionTargetHttpsProxiesRequest.prototype.filter = null;
    
                        /**
                         * ListRegionTargetHttpsProxiesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @instance
                         */
                        ListRegionTargetHttpsProxiesRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionTargetHttpsProxiesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @instance
                         */
                        ListRegionTargetHttpsProxiesRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionTargetHttpsProxiesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @instance
                         */
                        ListRegionTargetHttpsProxiesRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionTargetHttpsProxiesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @instance
                         */
                        ListRegionTargetHttpsProxiesRequest.prototype.project = "";
    
                        /**
                         * ListRegionTargetHttpsProxiesRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @instance
                         */
                        ListRegionTargetHttpsProxiesRequest.prototype.region = "";
    
                        /**
                         * ListRegionTargetHttpsProxiesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @instance
                         */
                        ListRegionTargetHttpsProxiesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionTargetHttpsProxiesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionTargetHttpsProxiesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionTargetHttpsProxiesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionTargetHttpsProxiesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionTargetHttpsProxiesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionTargetHttpsProxiesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionTargetHttpsProxiesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionTargetHttpsProxiesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionTargetHttpsProxiesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionTargetHttpsProxiesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionTargetHttpsProxiesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionTargetHttpsProxiesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest} ListRegionTargetHttpsProxiesRequest instance
                         */
                        ListRegionTargetHttpsProxiesRequest.create = function create(properties) {
                            return new ListRegionTargetHttpsProxiesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionTargetHttpsProxiesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionTargetHttpsProxiesRequest} message ListRegionTargetHttpsProxiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionTargetHttpsProxiesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionTargetHttpsProxiesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionTargetHttpsProxiesRequest} message ListRegionTargetHttpsProxiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionTargetHttpsProxiesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionTargetHttpsProxiesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest} ListRegionTargetHttpsProxiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionTargetHttpsProxiesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionTargetHttpsProxiesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest} ListRegionTargetHttpsProxiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionTargetHttpsProxiesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionTargetHttpsProxiesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionTargetHttpsProxiesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionTargetHttpsProxiesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest} ListRegionTargetHttpsProxiesRequest
                         */
                        ListRegionTargetHttpsProxiesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionTargetHttpsProxiesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest} message ListRegionTargetHttpsProxiesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionTargetHttpsProxiesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionTargetHttpsProxiesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionTargetHttpsProxiesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionTargetHttpsProxiesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionTargetHttpsProxiesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest";
                        };
    
                        return ListRegionTargetHttpsProxiesRequest;
                    })();
    
                    v1.ListRegionTargetTcpProxiesRequest = (function() {
    
                        /**
                         * Properties of a ListRegionTargetTcpProxiesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionTargetTcpProxiesRequest
                         * @property {string|null} [filter] ListRegionTargetTcpProxiesRequest filter
                         * @property {number|null} [maxResults] ListRegionTargetTcpProxiesRequest maxResults
                         * @property {string|null} [orderBy] ListRegionTargetTcpProxiesRequest orderBy
                         * @property {string|null} [pageToken] ListRegionTargetTcpProxiesRequest pageToken
                         * @property {string|null} [project] ListRegionTargetTcpProxiesRequest project
                         * @property {string|null} [region] ListRegionTargetTcpProxiesRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRegionTargetTcpProxiesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionTargetTcpProxiesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionTargetTcpProxiesRequest.
                         * @implements IListRegionTargetTcpProxiesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionTargetTcpProxiesRequest=} [properties] Properties to set
                         */
                        function ListRegionTargetTcpProxiesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionTargetTcpProxiesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @instance
                         */
                        ListRegionTargetTcpProxiesRequest.prototype.filter = null;
    
                        /**
                         * ListRegionTargetTcpProxiesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @instance
                         */
                        ListRegionTargetTcpProxiesRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionTargetTcpProxiesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @instance
                         */
                        ListRegionTargetTcpProxiesRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionTargetTcpProxiesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @instance
                         */
                        ListRegionTargetTcpProxiesRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionTargetTcpProxiesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @instance
                         */
                        ListRegionTargetTcpProxiesRequest.prototype.project = "";
    
                        /**
                         * ListRegionTargetTcpProxiesRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @instance
                         */
                        ListRegionTargetTcpProxiesRequest.prototype.region = "";
    
                        /**
                         * ListRegionTargetTcpProxiesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @instance
                         */
                        ListRegionTargetTcpProxiesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionTargetTcpProxiesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionTargetTcpProxiesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionTargetTcpProxiesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionTargetTcpProxiesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionTargetTcpProxiesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionTargetTcpProxiesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionTargetTcpProxiesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionTargetTcpProxiesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionTargetTcpProxiesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionTargetTcpProxiesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionTargetTcpProxiesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionTargetTcpProxiesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest} ListRegionTargetTcpProxiesRequest instance
                         */
                        ListRegionTargetTcpProxiesRequest.create = function create(properties) {
                            return new ListRegionTargetTcpProxiesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionTargetTcpProxiesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionTargetTcpProxiesRequest} message ListRegionTargetTcpProxiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionTargetTcpProxiesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionTargetTcpProxiesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionTargetTcpProxiesRequest} message ListRegionTargetTcpProxiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionTargetTcpProxiesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionTargetTcpProxiesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest} ListRegionTargetTcpProxiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionTargetTcpProxiesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionTargetTcpProxiesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest} ListRegionTargetTcpProxiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionTargetTcpProxiesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionTargetTcpProxiesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionTargetTcpProxiesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionTargetTcpProxiesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest} ListRegionTargetTcpProxiesRequest
                         */
                        ListRegionTargetTcpProxiesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionTargetTcpProxiesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest} message ListRegionTargetTcpProxiesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionTargetTcpProxiesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionTargetTcpProxiesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionTargetTcpProxiesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionTargetTcpProxiesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionTargetTcpProxiesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest";
                        };
    
                        return ListRegionTargetTcpProxiesRequest;
                    })();
    
                    v1.ListRegionUrlMapsRequest = (function() {
    
                        /**
                         * Properties of a ListRegionUrlMapsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionUrlMapsRequest
                         * @property {string|null} [filter] ListRegionUrlMapsRequest filter
                         * @property {number|null} [maxResults] ListRegionUrlMapsRequest maxResults
                         * @property {string|null} [orderBy] ListRegionUrlMapsRequest orderBy
                         * @property {string|null} [pageToken] ListRegionUrlMapsRequest pageToken
                         * @property {string|null} [project] ListRegionUrlMapsRequest project
                         * @property {string|null} [region] ListRegionUrlMapsRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRegionUrlMapsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionUrlMapsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionUrlMapsRequest.
                         * @implements IListRegionUrlMapsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionUrlMapsRequest=} [properties] Properties to set
                         */
                        function ListRegionUrlMapsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionUrlMapsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @instance
                         */
                        ListRegionUrlMapsRequest.prototype.filter = null;
    
                        /**
                         * ListRegionUrlMapsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @instance
                         */
                        ListRegionUrlMapsRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionUrlMapsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @instance
                         */
                        ListRegionUrlMapsRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionUrlMapsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @instance
                         */
                        ListRegionUrlMapsRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionUrlMapsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @instance
                         */
                        ListRegionUrlMapsRequest.prototype.project = "";
    
                        /**
                         * ListRegionUrlMapsRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @instance
                         */
                        ListRegionUrlMapsRequest.prototype.region = "";
    
                        /**
                         * ListRegionUrlMapsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @instance
                         */
                        ListRegionUrlMapsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionUrlMapsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionUrlMapsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionUrlMapsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionUrlMapsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionUrlMapsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionUrlMapsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionUrlMapsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionUrlMapsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionUrlMapsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionUrlMapsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionUrlMapsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionUrlMapsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionUrlMapsRequest} ListRegionUrlMapsRequest instance
                         */
                        ListRegionUrlMapsRequest.create = function create(properties) {
                            return new ListRegionUrlMapsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionUrlMapsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionUrlMapsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionUrlMapsRequest} message ListRegionUrlMapsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionUrlMapsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionUrlMapsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionUrlMapsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionUrlMapsRequest} message ListRegionUrlMapsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionUrlMapsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionUrlMapsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionUrlMapsRequest} ListRegionUrlMapsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionUrlMapsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionUrlMapsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionUrlMapsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionUrlMapsRequest} ListRegionUrlMapsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionUrlMapsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionUrlMapsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionUrlMapsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionUrlMapsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionUrlMapsRequest} ListRegionUrlMapsRequest
                         */
                        ListRegionUrlMapsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionUrlMapsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionUrlMapsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionUrlMapsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionUrlMapsRequest} message ListRegionUrlMapsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionUrlMapsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionUrlMapsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionUrlMapsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionUrlMapsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionUrlMapsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionUrlMapsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionUrlMapsRequest";
                        };
    
                        return ListRegionUrlMapsRequest;
                    })();
    
                    v1.ListRegionsRequest = (function() {
    
                        /**
                         * Properties of a ListRegionsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRegionsRequest
                         * @property {string|null} [filter] ListRegionsRequest filter
                         * @property {number|null} [maxResults] ListRegionsRequest maxResults
                         * @property {string|null} [orderBy] ListRegionsRequest orderBy
                         * @property {string|null} [pageToken] ListRegionsRequest pageToken
                         * @property {string|null} [project] ListRegionsRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListRegionsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRegionsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRegionsRequest.
                         * @implements IListRegionsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRegionsRequest=} [properties] Properties to set
                         */
                        function ListRegionsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRegionsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @instance
                         */
                        ListRegionsRequest.prototype.filter = null;
    
                        /**
                         * ListRegionsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @instance
                         */
                        ListRegionsRequest.prototype.maxResults = null;
    
                        /**
                         * ListRegionsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @instance
                         */
                        ListRegionsRequest.prototype.orderBy = null;
    
                        /**
                         * ListRegionsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @instance
                         */
                        ListRegionsRequest.prototype.pageToken = null;
    
                        /**
                         * ListRegionsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @instance
                         */
                        ListRegionsRequest.prototype.project = "";
    
                        /**
                         * ListRegionsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @instance
                         */
                        ListRegionsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRegionsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRegionsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @instance
                         */
                        Object.defineProperty(ListRegionsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRegionsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRegionsRequest} ListRegionsRequest instance
                         */
                        ListRegionsRequest.create = function create(properties) {
                            return new ListRegionsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRegionsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRegionsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionsRequest} message ListRegionsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRegionsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRegionsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRegionsRequest} message ListRegionsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRegionsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRegionsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRegionsRequest} ListRegionsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRegionsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRegionsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRegionsRequest} ListRegionsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRegionsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRegionsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRegionsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRegionsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRegionsRequest} ListRegionsRequest
                         */
                        ListRegionsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRegionsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRegionsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRegionsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRegionsRequest} message ListRegionsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRegionsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRegionsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRegionsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRegionsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRegionsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRegionsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRegionsRequest";
                        };
    
                        return ListRegionsRequest;
                    })();
    
                    v1.ListReservationsRequest = (function() {
    
                        /**
                         * Properties of a ListReservationsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListReservationsRequest
                         * @property {string|null} [filter] ListReservationsRequest filter
                         * @property {number|null} [maxResults] ListReservationsRequest maxResults
                         * @property {string|null} [orderBy] ListReservationsRequest orderBy
                         * @property {string|null} [pageToken] ListReservationsRequest pageToken
                         * @property {string|null} [project] ListReservationsRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListReservationsRequest returnPartialSuccess
                         * @property {string|null} [zone] ListReservationsRequest zone
                         */
    
                        /**
                         * Constructs a new ListReservationsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListReservationsRequest.
                         * @implements IListReservationsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListReservationsRequest=} [properties] Properties to set
                         */
                        function ListReservationsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListReservationsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @instance
                         */
                        ListReservationsRequest.prototype.filter = null;
    
                        /**
                         * ListReservationsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @instance
                         */
                        ListReservationsRequest.prototype.maxResults = null;
    
                        /**
                         * ListReservationsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @instance
                         */
                        ListReservationsRequest.prototype.orderBy = null;
    
                        /**
                         * ListReservationsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @instance
                         */
                        ListReservationsRequest.prototype.pageToken = null;
    
                        /**
                         * ListReservationsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @instance
                         */
                        ListReservationsRequest.prototype.project = "";
    
                        /**
                         * ListReservationsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @instance
                         */
                        ListReservationsRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListReservationsRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @instance
                         */
                        ListReservationsRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListReservationsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListReservationsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListReservationsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListReservationsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListReservationsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListReservationsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListReservationsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListReservationsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListReservationsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListReservationsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListReservationsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListReservationsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListReservationsRequest} ListReservationsRequest instance
                         */
                        ListReservationsRequest.create = function create(properties) {
                            return new ListReservationsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListReservationsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListReservationsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListReservationsRequest} message ListReservationsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListReservationsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListReservationsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListReservationsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListReservationsRequest} message ListReservationsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListReservationsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListReservationsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListReservationsRequest} ListReservationsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListReservationsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListReservationsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListReservationsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListReservationsRequest} ListReservationsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListReservationsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListReservationsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListReservationsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListReservationsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListReservationsRequest} ListReservationsRequest
                         */
                        ListReservationsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListReservationsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListReservationsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListReservationsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListReservationsRequest} message ListReservationsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListReservationsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListReservationsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListReservationsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListReservationsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListReservationsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListReservationsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListReservationsRequest";
                        };
    
                        return ListReservationsRequest;
                    })();
    
                    v1.ListResourcePoliciesRequest = (function() {
    
                        /**
                         * Properties of a ListResourcePoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListResourcePoliciesRequest
                         * @property {string|null} [filter] ListResourcePoliciesRequest filter
                         * @property {number|null} [maxResults] ListResourcePoliciesRequest maxResults
                         * @property {string|null} [orderBy] ListResourcePoliciesRequest orderBy
                         * @property {string|null} [pageToken] ListResourcePoliciesRequest pageToken
                         * @property {string|null} [project] ListResourcePoliciesRequest project
                         * @property {string|null} [region] ListResourcePoliciesRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListResourcePoliciesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListResourcePoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListResourcePoliciesRequest.
                         * @implements IListResourcePoliciesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListResourcePoliciesRequest=} [properties] Properties to set
                         */
                        function ListResourcePoliciesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListResourcePoliciesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @instance
                         */
                        ListResourcePoliciesRequest.prototype.filter = null;
    
                        /**
                         * ListResourcePoliciesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @instance
                         */
                        ListResourcePoliciesRequest.prototype.maxResults = null;
    
                        /**
                         * ListResourcePoliciesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @instance
                         */
                        ListResourcePoliciesRequest.prototype.orderBy = null;
    
                        /**
                         * ListResourcePoliciesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @instance
                         */
                        ListResourcePoliciesRequest.prototype.pageToken = null;
    
                        /**
                         * ListResourcePoliciesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @instance
                         */
                        ListResourcePoliciesRequest.prototype.project = "";
    
                        /**
                         * ListResourcePoliciesRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @instance
                         */
                        ListResourcePoliciesRequest.prototype.region = "";
    
                        /**
                         * ListResourcePoliciesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @instance
                         */
                        ListResourcePoliciesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListResourcePoliciesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListResourcePoliciesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListResourcePoliciesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListResourcePoliciesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListResourcePoliciesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListResourcePoliciesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListResourcePoliciesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListResourcePoliciesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListResourcePoliciesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListResourcePoliciesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListResourcePoliciesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListResourcePoliciesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListResourcePoliciesRequest} ListResourcePoliciesRequest instance
                         */
                        ListResourcePoliciesRequest.create = function create(properties) {
                            return new ListResourcePoliciesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListResourcePoliciesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListResourcePoliciesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListResourcePoliciesRequest} message ListResourcePoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListResourcePoliciesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListResourcePoliciesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListResourcePoliciesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListResourcePoliciesRequest} message ListResourcePoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListResourcePoliciesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListResourcePoliciesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListResourcePoliciesRequest} ListResourcePoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListResourcePoliciesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListResourcePoliciesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListResourcePoliciesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListResourcePoliciesRequest} ListResourcePoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListResourcePoliciesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListResourcePoliciesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListResourcePoliciesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListResourcePoliciesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListResourcePoliciesRequest} ListResourcePoliciesRequest
                         */
                        ListResourcePoliciesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListResourcePoliciesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListResourcePoliciesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListResourcePoliciesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListResourcePoliciesRequest} message ListResourcePoliciesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListResourcePoliciesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListResourcePoliciesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListResourcePoliciesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListResourcePoliciesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListResourcePoliciesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListResourcePoliciesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListResourcePoliciesRequest";
                        };
    
                        return ListResourcePoliciesRequest;
                    })();
    
                    v1.ListRoutersRequest = (function() {
    
                        /**
                         * Properties of a ListRoutersRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRoutersRequest
                         * @property {string|null} [filter] ListRoutersRequest filter
                         * @property {number|null} [maxResults] ListRoutersRequest maxResults
                         * @property {string|null} [orderBy] ListRoutersRequest orderBy
                         * @property {string|null} [pageToken] ListRoutersRequest pageToken
                         * @property {string|null} [project] ListRoutersRequest project
                         * @property {string|null} [region] ListRoutersRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListRoutersRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRoutersRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRoutersRequest.
                         * @implements IListRoutersRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRoutersRequest=} [properties] Properties to set
                         */
                        function ListRoutersRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRoutersRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @instance
                         */
                        ListRoutersRequest.prototype.filter = null;
    
                        /**
                         * ListRoutersRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @instance
                         */
                        ListRoutersRequest.prototype.maxResults = null;
    
                        /**
                         * ListRoutersRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @instance
                         */
                        ListRoutersRequest.prototype.orderBy = null;
    
                        /**
                         * ListRoutersRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @instance
                         */
                        ListRoutersRequest.prototype.pageToken = null;
    
                        /**
                         * ListRoutersRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @instance
                         */
                        ListRoutersRequest.prototype.project = "";
    
                        /**
                         * ListRoutersRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @instance
                         */
                        ListRoutersRequest.prototype.region = "";
    
                        /**
                         * ListRoutersRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @instance
                         */
                        ListRoutersRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRoutersRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @instance
                         */
                        Object.defineProperty(ListRoutersRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRoutersRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @instance
                         */
                        Object.defineProperty(ListRoutersRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRoutersRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @instance
                         */
                        Object.defineProperty(ListRoutersRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRoutersRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @instance
                         */
                        Object.defineProperty(ListRoutersRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRoutersRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @instance
                         */
                        Object.defineProperty(ListRoutersRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRoutersRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRoutersRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRoutersRequest} ListRoutersRequest instance
                         */
                        ListRoutersRequest.create = function create(properties) {
                            return new ListRoutersRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRoutersRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRoutersRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRoutersRequest} message ListRoutersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRoutersRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRoutersRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRoutersRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRoutersRequest} message ListRoutersRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRoutersRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRoutersRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRoutersRequest} ListRoutersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRoutersRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRoutersRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRoutersRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRoutersRequest} ListRoutersRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRoutersRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRoutersRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRoutersRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRoutersRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRoutersRequest} ListRoutersRequest
                         */
                        ListRoutersRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRoutersRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRoutersRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRoutersRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRoutersRequest} message ListRoutersRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRoutersRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRoutersRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRoutersRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRoutersRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRoutersRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRoutersRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRoutersRequest";
                        };
    
                        return ListRoutersRequest;
                    })();
    
                    v1.ListRoutesRequest = (function() {
    
                        /**
                         * Properties of a ListRoutesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListRoutesRequest
                         * @property {string|null} [filter] ListRoutesRequest filter
                         * @property {number|null} [maxResults] ListRoutesRequest maxResults
                         * @property {string|null} [orderBy] ListRoutesRequest orderBy
                         * @property {string|null} [pageToken] ListRoutesRequest pageToken
                         * @property {string|null} [project] ListRoutesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListRoutesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListRoutesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListRoutesRequest.
                         * @implements IListRoutesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListRoutesRequest=} [properties] Properties to set
                         */
                        function ListRoutesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListRoutesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @instance
                         */
                        ListRoutesRequest.prototype.filter = null;
    
                        /**
                         * ListRoutesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @instance
                         */
                        ListRoutesRequest.prototype.maxResults = null;
    
                        /**
                         * ListRoutesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @instance
                         */
                        ListRoutesRequest.prototype.orderBy = null;
    
                        /**
                         * ListRoutesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @instance
                         */
                        ListRoutesRequest.prototype.pageToken = null;
    
                        /**
                         * ListRoutesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @instance
                         */
                        ListRoutesRequest.prototype.project = "";
    
                        /**
                         * ListRoutesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @instance
                         */
                        ListRoutesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListRoutesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRoutesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRoutesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRoutesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRoutesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRoutesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRoutesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRoutesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListRoutesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @instance
                         */
                        Object.defineProperty(ListRoutesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListRoutesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRoutesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListRoutesRequest} ListRoutesRequest instance
                         */
                        ListRoutesRequest.create = function create(properties) {
                            return new ListRoutesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListRoutesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListRoutesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRoutesRequest} message ListRoutesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRoutesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListRoutesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListRoutesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListRoutesRequest} message ListRoutesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListRoutesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListRoutesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListRoutesRequest} ListRoutesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRoutesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListRoutesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListRoutesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListRoutesRequest} ListRoutesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListRoutesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListRoutesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListRoutesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListRoutesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListRoutesRequest} ListRoutesRequest
                         */
                        ListRoutesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListRoutesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListRoutesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListRoutesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListRoutesRequest} message ListRoutesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListRoutesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListRoutesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListRoutesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListRoutesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListRoutesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListRoutesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListRoutesRequest";
                        };
    
                        return ListRoutesRequest;
                    })();
    
                    v1.ListSecurityPoliciesRequest = (function() {
    
                        /**
                         * Properties of a ListSecurityPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListSecurityPoliciesRequest
                         * @property {string|null} [filter] ListSecurityPoliciesRequest filter
                         * @property {number|null} [maxResults] ListSecurityPoliciesRequest maxResults
                         * @property {string|null} [orderBy] ListSecurityPoliciesRequest orderBy
                         * @property {string|null} [pageToken] ListSecurityPoliciesRequest pageToken
                         * @property {string|null} [project] ListSecurityPoliciesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListSecurityPoliciesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListSecurityPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListSecurityPoliciesRequest.
                         * @implements IListSecurityPoliciesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListSecurityPoliciesRequest=} [properties] Properties to set
                         */
                        function ListSecurityPoliciesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListSecurityPoliciesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @instance
                         */
                        ListSecurityPoliciesRequest.prototype.filter = null;
    
                        /**
                         * ListSecurityPoliciesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @instance
                         */
                        ListSecurityPoliciesRequest.prototype.maxResults = null;
    
                        /**
                         * ListSecurityPoliciesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @instance
                         */
                        ListSecurityPoliciesRequest.prototype.orderBy = null;
    
                        /**
                         * ListSecurityPoliciesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @instance
                         */
                        ListSecurityPoliciesRequest.prototype.pageToken = null;
    
                        /**
                         * ListSecurityPoliciesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @instance
                         */
                        ListSecurityPoliciesRequest.prototype.project = "";
    
                        /**
                         * ListSecurityPoliciesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @instance
                         */
                        ListSecurityPoliciesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListSecurityPoliciesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListSecurityPoliciesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListSecurityPoliciesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListSecurityPoliciesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListSecurityPoliciesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListSecurityPoliciesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListSecurityPoliciesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListSecurityPoliciesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListSecurityPoliciesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListSecurityPoliciesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListSecurityPoliciesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListSecurityPoliciesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListSecurityPoliciesRequest} ListSecurityPoliciesRequest instance
                         */
                        ListSecurityPoliciesRequest.create = function create(properties) {
                            return new ListSecurityPoliciesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListSecurityPoliciesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListSecurityPoliciesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListSecurityPoliciesRequest} message ListSecurityPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListSecurityPoliciesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListSecurityPoliciesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListSecurityPoliciesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListSecurityPoliciesRequest} message ListSecurityPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListSecurityPoliciesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListSecurityPoliciesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListSecurityPoliciesRequest} ListSecurityPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListSecurityPoliciesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListSecurityPoliciesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListSecurityPoliciesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListSecurityPoliciesRequest} ListSecurityPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListSecurityPoliciesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListSecurityPoliciesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListSecurityPoliciesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListSecurityPoliciesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListSecurityPoliciesRequest} ListSecurityPoliciesRequest
                         */
                        ListSecurityPoliciesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListSecurityPoliciesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListSecurityPoliciesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListSecurityPoliciesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListSecurityPoliciesRequest} message ListSecurityPoliciesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListSecurityPoliciesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListSecurityPoliciesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListSecurityPoliciesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListSecurityPoliciesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListSecurityPoliciesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListSecurityPoliciesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListSecurityPoliciesRequest";
                        };
    
                        return ListSecurityPoliciesRequest;
                    })();
    
                    v1.ListServiceAttachmentsRequest = (function() {
    
                        /**
                         * Properties of a ListServiceAttachmentsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListServiceAttachmentsRequest
                         * @property {string|null} [filter] ListServiceAttachmentsRequest filter
                         * @property {number|null} [maxResults] ListServiceAttachmentsRequest maxResults
                         * @property {string|null} [orderBy] ListServiceAttachmentsRequest orderBy
                         * @property {string|null} [pageToken] ListServiceAttachmentsRequest pageToken
                         * @property {string|null} [project] ListServiceAttachmentsRequest project
                         * @property {string|null} [region] ListServiceAttachmentsRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListServiceAttachmentsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListServiceAttachmentsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListServiceAttachmentsRequest.
                         * @implements IListServiceAttachmentsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListServiceAttachmentsRequest=} [properties] Properties to set
                         */
                        function ListServiceAttachmentsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListServiceAttachmentsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @instance
                         */
                        ListServiceAttachmentsRequest.prototype.filter = null;
    
                        /**
                         * ListServiceAttachmentsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @instance
                         */
                        ListServiceAttachmentsRequest.prototype.maxResults = null;
    
                        /**
                         * ListServiceAttachmentsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @instance
                         */
                        ListServiceAttachmentsRequest.prototype.orderBy = null;
    
                        /**
                         * ListServiceAttachmentsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @instance
                         */
                        ListServiceAttachmentsRequest.prototype.pageToken = null;
    
                        /**
                         * ListServiceAttachmentsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @instance
                         */
                        ListServiceAttachmentsRequest.prototype.project = "";
    
                        /**
                         * ListServiceAttachmentsRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @instance
                         */
                        ListServiceAttachmentsRequest.prototype.region = "";
    
                        /**
                         * ListServiceAttachmentsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @instance
                         */
                        ListServiceAttachmentsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListServiceAttachmentsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(ListServiceAttachmentsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListServiceAttachmentsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(ListServiceAttachmentsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListServiceAttachmentsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(ListServiceAttachmentsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListServiceAttachmentsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(ListServiceAttachmentsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListServiceAttachmentsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @instance
                         */
                        Object.defineProperty(ListServiceAttachmentsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListServiceAttachmentsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListServiceAttachmentsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListServiceAttachmentsRequest} ListServiceAttachmentsRequest instance
                         */
                        ListServiceAttachmentsRequest.create = function create(properties) {
                            return new ListServiceAttachmentsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListServiceAttachmentsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListServiceAttachmentsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListServiceAttachmentsRequest} message ListServiceAttachmentsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListServiceAttachmentsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListServiceAttachmentsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListServiceAttachmentsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListServiceAttachmentsRequest} message ListServiceAttachmentsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListServiceAttachmentsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListServiceAttachmentsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListServiceAttachmentsRequest} ListServiceAttachmentsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListServiceAttachmentsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListServiceAttachmentsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListServiceAttachmentsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListServiceAttachmentsRequest} ListServiceAttachmentsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListServiceAttachmentsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListServiceAttachmentsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListServiceAttachmentsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListServiceAttachmentsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListServiceAttachmentsRequest} ListServiceAttachmentsRequest
                         */
                        ListServiceAttachmentsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListServiceAttachmentsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListServiceAttachmentsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListServiceAttachmentsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListServiceAttachmentsRequest} message ListServiceAttachmentsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListServiceAttachmentsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListServiceAttachmentsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListServiceAttachmentsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListServiceAttachmentsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListServiceAttachmentsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListServiceAttachmentsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListServiceAttachmentsRequest";
                        };
    
                        return ListServiceAttachmentsRequest;
                    })();
    
                    v1.ListSnapshotsRequest = (function() {
    
                        /**
                         * Properties of a ListSnapshotsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListSnapshotsRequest
                         * @property {string|null} [filter] ListSnapshotsRequest filter
                         * @property {number|null} [maxResults] ListSnapshotsRequest maxResults
                         * @property {string|null} [orderBy] ListSnapshotsRequest orderBy
                         * @property {string|null} [pageToken] ListSnapshotsRequest pageToken
                         * @property {string|null} [project] ListSnapshotsRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListSnapshotsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListSnapshotsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListSnapshotsRequest.
                         * @implements IListSnapshotsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListSnapshotsRequest=} [properties] Properties to set
                         */
                        function ListSnapshotsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListSnapshotsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @instance
                         */
                        ListSnapshotsRequest.prototype.filter = null;
    
                        /**
                         * ListSnapshotsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @instance
                         */
                        ListSnapshotsRequest.prototype.maxResults = null;
    
                        /**
                         * ListSnapshotsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @instance
                         */
                        ListSnapshotsRequest.prototype.orderBy = null;
    
                        /**
                         * ListSnapshotsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @instance
                         */
                        ListSnapshotsRequest.prototype.pageToken = null;
    
                        /**
                         * ListSnapshotsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @instance
                         */
                        ListSnapshotsRequest.prototype.project = "";
    
                        /**
                         * ListSnapshotsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @instance
                         */
                        ListSnapshotsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListSnapshotsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @instance
                         */
                        Object.defineProperty(ListSnapshotsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListSnapshotsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @instance
                         */
                        Object.defineProperty(ListSnapshotsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListSnapshotsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @instance
                         */
                        Object.defineProperty(ListSnapshotsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListSnapshotsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @instance
                         */
                        Object.defineProperty(ListSnapshotsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListSnapshotsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @instance
                         */
                        Object.defineProperty(ListSnapshotsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListSnapshotsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListSnapshotsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListSnapshotsRequest} ListSnapshotsRequest instance
                         */
                        ListSnapshotsRequest.create = function create(properties) {
                            return new ListSnapshotsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListSnapshotsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListSnapshotsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListSnapshotsRequest} message ListSnapshotsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListSnapshotsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListSnapshotsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListSnapshotsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListSnapshotsRequest} message ListSnapshotsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListSnapshotsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListSnapshotsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListSnapshotsRequest} ListSnapshotsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListSnapshotsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListSnapshotsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListSnapshotsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListSnapshotsRequest} ListSnapshotsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListSnapshotsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListSnapshotsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListSnapshotsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListSnapshotsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListSnapshotsRequest} ListSnapshotsRequest
                         */
                        ListSnapshotsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListSnapshotsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListSnapshotsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListSnapshotsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListSnapshotsRequest} message ListSnapshotsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListSnapshotsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListSnapshotsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListSnapshotsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListSnapshotsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListSnapshotsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListSnapshotsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListSnapshotsRequest";
                        };
    
                        return ListSnapshotsRequest;
                    })();
    
                    v1.ListSslCertificatesRequest = (function() {
    
                        /**
                         * Properties of a ListSslCertificatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListSslCertificatesRequest
                         * @property {string|null} [filter] ListSslCertificatesRequest filter
                         * @property {number|null} [maxResults] ListSslCertificatesRequest maxResults
                         * @property {string|null} [orderBy] ListSslCertificatesRequest orderBy
                         * @property {string|null} [pageToken] ListSslCertificatesRequest pageToken
                         * @property {string|null} [project] ListSslCertificatesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListSslCertificatesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListSslCertificatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListSslCertificatesRequest.
                         * @implements IListSslCertificatesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListSslCertificatesRequest=} [properties] Properties to set
                         */
                        function ListSslCertificatesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListSslCertificatesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @instance
                         */
                        ListSslCertificatesRequest.prototype.filter = null;
    
                        /**
                         * ListSslCertificatesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @instance
                         */
                        ListSslCertificatesRequest.prototype.maxResults = null;
    
                        /**
                         * ListSslCertificatesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @instance
                         */
                        ListSslCertificatesRequest.prototype.orderBy = null;
    
                        /**
                         * ListSslCertificatesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @instance
                         */
                        ListSslCertificatesRequest.prototype.pageToken = null;
    
                        /**
                         * ListSslCertificatesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @instance
                         */
                        ListSslCertificatesRequest.prototype.project = "";
    
                        /**
                         * ListSslCertificatesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @instance
                         */
                        ListSslCertificatesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListSslCertificatesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @instance
                         */
                        Object.defineProperty(ListSslCertificatesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListSslCertificatesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @instance
                         */
                        Object.defineProperty(ListSslCertificatesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListSslCertificatesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @instance
                         */
                        Object.defineProperty(ListSslCertificatesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListSslCertificatesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @instance
                         */
                        Object.defineProperty(ListSslCertificatesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListSslCertificatesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @instance
                         */
                        Object.defineProperty(ListSslCertificatesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListSslCertificatesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListSslCertificatesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListSslCertificatesRequest} ListSslCertificatesRequest instance
                         */
                        ListSslCertificatesRequest.create = function create(properties) {
                            return new ListSslCertificatesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListSslCertificatesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListSslCertificatesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListSslCertificatesRequest} message ListSslCertificatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListSslCertificatesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListSslCertificatesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListSslCertificatesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListSslCertificatesRequest} message ListSslCertificatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListSslCertificatesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListSslCertificatesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListSslCertificatesRequest} ListSslCertificatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListSslCertificatesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListSslCertificatesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListSslCertificatesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListSslCertificatesRequest} ListSslCertificatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListSslCertificatesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListSslCertificatesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListSslCertificatesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListSslCertificatesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListSslCertificatesRequest} ListSslCertificatesRequest
                         */
                        ListSslCertificatesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListSslCertificatesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListSslCertificatesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListSslCertificatesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListSslCertificatesRequest} message ListSslCertificatesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListSslCertificatesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListSslCertificatesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListSslCertificatesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListSslCertificatesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListSslCertificatesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListSslCertificatesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListSslCertificatesRequest";
                        };
    
                        return ListSslCertificatesRequest;
                    })();
    
                    v1.ListSslPoliciesRequest = (function() {
    
                        /**
                         * Properties of a ListSslPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListSslPoliciesRequest
                         * @property {string|null} [filter] ListSslPoliciesRequest filter
                         * @property {number|null} [maxResults] ListSslPoliciesRequest maxResults
                         * @property {string|null} [orderBy] ListSslPoliciesRequest orderBy
                         * @property {string|null} [pageToken] ListSslPoliciesRequest pageToken
                         * @property {string|null} [project] ListSslPoliciesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListSslPoliciesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListSslPoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListSslPoliciesRequest.
                         * @implements IListSslPoliciesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListSslPoliciesRequest=} [properties] Properties to set
                         */
                        function ListSslPoliciesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListSslPoliciesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @instance
                         */
                        ListSslPoliciesRequest.prototype.filter = null;
    
                        /**
                         * ListSslPoliciesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @instance
                         */
                        ListSslPoliciesRequest.prototype.maxResults = null;
    
                        /**
                         * ListSslPoliciesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @instance
                         */
                        ListSslPoliciesRequest.prototype.orderBy = null;
    
                        /**
                         * ListSslPoliciesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @instance
                         */
                        ListSslPoliciesRequest.prototype.pageToken = null;
    
                        /**
                         * ListSslPoliciesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @instance
                         */
                        ListSslPoliciesRequest.prototype.project = "";
    
                        /**
                         * ListSslPoliciesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @instance
                         */
                        ListSslPoliciesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListSslPoliciesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListSslPoliciesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListSslPoliciesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListSslPoliciesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListSslPoliciesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListSslPoliciesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListSslPoliciesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListSslPoliciesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListSslPoliciesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @instance
                         */
                        Object.defineProperty(ListSslPoliciesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListSslPoliciesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListSslPoliciesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListSslPoliciesRequest} ListSslPoliciesRequest instance
                         */
                        ListSslPoliciesRequest.create = function create(properties) {
                            return new ListSslPoliciesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListSslPoliciesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListSslPoliciesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListSslPoliciesRequest} message ListSslPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListSslPoliciesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListSslPoliciesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListSslPoliciesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListSslPoliciesRequest} message ListSslPoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListSslPoliciesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListSslPoliciesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListSslPoliciesRequest} ListSslPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListSslPoliciesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListSslPoliciesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListSslPoliciesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListSslPoliciesRequest} ListSslPoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListSslPoliciesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListSslPoliciesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListSslPoliciesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListSslPoliciesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListSslPoliciesRequest} ListSslPoliciesRequest
                         */
                        ListSslPoliciesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListSslPoliciesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListSslPoliciesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListSslPoliciesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListSslPoliciesRequest} message ListSslPoliciesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListSslPoliciesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListSslPoliciesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListSslPoliciesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListSslPoliciesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListSslPoliciesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListSslPoliciesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListSslPoliciesRequest";
                        };
    
                        return ListSslPoliciesRequest;
                    })();
    
                    v1.ListSubnetworksRequest = (function() {
    
                        /**
                         * Properties of a ListSubnetworksRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListSubnetworksRequest
                         * @property {string|null} [filter] ListSubnetworksRequest filter
                         * @property {number|null} [maxResults] ListSubnetworksRequest maxResults
                         * @property {string|null} [orderBy] ListSubnetworksRequest orderBy
                         * @property {string|null} [pageToken] ListSubnetworksRequest pageToken
                         * @property {string|null} [project] ListSubnetworksRequest project
                         * @property {string|null} [region] ListSubnetworksRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListSubnetworksRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListSubnetworksRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListSubnetworksRequest.
                         * @implements IListSubnetworksRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListSubnetworksRequest=} [properties] Properties to set
                         */
                        function ListSubnetworksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListSubnetworksRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @instance
                         */
                        ListSubnetworksRequest.prototype.filter = null;
    
                        /**
                         * ListSubnetworksRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @instance
                         */
                        ListSubnetworksRequest.prototype.maxResults = null;
    
                        /**
                         * ListSubnetworksRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @instance
                         */
                        ListSubnetworksRequest.prototype.orderBy = null;
    
                        /**
                         * ListSubnetworksRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @instance
                         */
                        ListSubnetworksRequest.prototype.pageToken = null;
    
                        /**
                         * ListSubnetworksRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @instance
                         */
                        ListSubnetworksRequest.prototype.project = "";
    
                        /**
                         * ListSubnetworksRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @instance
                         */
                        ListSubnetworksRequest.prototype.region = "";
    
                        /**
                         * ListSubnetworksRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @instance
                         */
                        ListSubnetworksRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListSubnetworksRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListSubnetworksRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListSubnetworksRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListSubnetworksRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListSubnetworksRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListSubnetworksRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListSubnetworksRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListSubnetworksRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListSubnetworksRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListSubnetworksRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListSubnetworksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListSubnetworksRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListSubnetworksRequest} ListSubnetworksRequest instance
                         */
                        ListSubnetworksRequest.create = function create(properties) {
                            return new ListSubnetworksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListSubnetworksRequest message. Does not implicitly {@link google.cloud.compute.v1.ListSubnetworksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListSubnetworksRequest} message ListSubnetworksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListSubnetworksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListSubnetworksRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListSubnetworksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListSubnetworksRequest} message ListSubnetworksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListSubnetworksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListSubnetworksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListSubnetworksRequest} ListSubnetworksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListSubnetworksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListSubnetworksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListSubnetworksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListSubnetworksRequest} ListSubnetworksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListSubnetworksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListSubnetworksRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListSubnetworksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListSubnetworksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListSubnetworksRequest} ListSubnetworksRequest
                         */
                        ListSubnetworksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListSubnetworksRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListSubnetworksRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListSubnetworksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListSubnetworksRequest} message ListSubnetworksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListSubnetworksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListSubnetworksRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListSubnetworksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListSubnetworksRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListSubnetworksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListSubnetworksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListSubnetworksRequest";
                        };
    
                        return ListSubnetworksRequest;
                    })();
    
                    v1.ListTargetGrpcProxiesRequest = (function() {
    
                        /**
                         * Properties of a ListTargetGrpcProxiesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListTargetGrpcProxiesRequest
                         * @property {string|null} [filter] ListTargetGrpcProxiesRequest filter
                         * @property {number|null} [maxResults] ListTargetGrpcProxiesRequest maxResults
                         * @property {string|null} [orderBy] ListTargetGrpcProxiesRequest orderBy
                         * @property {string|null} [pageToken] ListTargetGrpcProxiesRequest pageToken
                         * @property {string|null} [project] ListTargetGrpcProxiesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListTargetGrpcProxiesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListTargetGrpcProxiesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListTargetGrpcProxiesRequest.
                         * @implements IListTargetGrpcProxiesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListTargetGrpcProxiesRequest=} [properties] Properties to set
                         */
                        function ListTargetGrpcProxiesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListTargetGrpcProxiesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @instance
                         */
                        ListTargetGrpcProxiesRequest.prototype.filter = null;
    
                        /**
                         * ListTargetGrpcProxiesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @instance
                         */
                        ListTargetGrpcProxiesRequest.prototype.maxResults = null;
    
                        /**
                         * ListTargetGrpcProxiesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @instance
                         */
                        ListTargetGrpcProxiesRequest.prototype.orderBy = null;
    
                        /**
                         * ListTargetGrpcProxiesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @instance
                         */
                        ListTargetGrpcProxiesRequest.prototype.pageToken = null;
    
                        /**
                         * ListTargetGrpcProxiesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @instance
                         */
                        ListTargetGrpcProxiesRequest.prototype.project = "";
    
                        /**
                         * ListTargetGrpcProxiesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @instance
                         */
                        ListTargetGrpcProxiesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListTargetGrpcProxiesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetGrpcProxiesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetGrpcProxiesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetGrpcProxiesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetGrpcProxiesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetGrpcProxiesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetGrpcProxiesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetGrpcProxiesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetGrpcProxiesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetGrpcProxiesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListTargetGrpcProxiesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetGrpcProxiesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListTargetGrpcProxiesRequest} ListTargetGrpcProxiesRequest instance
                         */
                        ListTargetGrpcProxiesRequest.create = function create(properties) {
                            return new ListTargetGrpcProxiesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListTargetGrpcProxiesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListTargetGrpcProxiesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetGrpcProxiesRequest} message ListTargetGrpcProxiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListTargetGrpcProxiesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListTargetGrpcProxiesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListTargetGrpcProxiesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetGrpcProxiesRequest} message ListTargetGrpcProxiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListTargetGrpcProxiesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListTargetGrpcProxiesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListTargetGrpcProxiesRequest} ListTargetGrpcProxiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListTargetGrpcProxiesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListTargetGrpcProxiesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListTargetGrpcProxiesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListTargetGrpcProxiesRequest} ListTargetGrpcProxiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListTargetGrpcProxiesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListTargetGrpcProxiesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListTargetGrpcProxiesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListTargetGrpcProxiesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListTargetGrpcProxiesRequest} ListTargetGrpcProxiesRequest
                         */
                        ListTargetGrpcProxiesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListTargetGrpcProxiesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListTargetGrpcProxiesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListTargetGrpcProxiesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListTargetGrpcProxiesRequest} message ListTargetGrpcProxiesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListTargetGrpcProxiesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListTargetGrpcProxiesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListTargetGrpcProxiesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListTargetGrpcProxiesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListTargetGrpcProxiesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListTargetGrpcProxiesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListTargetGrpcProxiesRequest";
                        };
    
                        return ListTargetGrpcProxiesRequest;
                    })();
    
                    v1.ListTargetHttpProxiesRequest = (function() {
    
                        /**
                         * Properties of a ListTargetHttpProxiesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListTargetHttpProxiesRequest
                         * @property {string|null} [filter] ListTargetHttpProxiesRequest filter
                         * @property {number|null} [maxResults] ListTargetHttpProxiesRequest maxResults
                         * @property {string|null} [orderBy] ListTargetHttpProxiesRequest orderBy
                         * @property {string|null} [pageToken] ListTargetHttpProxiesRequest pageToken
                         * @property {string|null} [project] ListTargetHttpProxiesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListTargetHttpProxiesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListTargetHttpProxiesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListTargetHttpProxiesRequest.
                         * @implements IListTargetHttpProxiesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListTargetHttpProxiesRequest=} [properties] Properties to set
                         */
                        function ListTargetHttpProxiesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListTargetHttpProxiesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @instance
                         */
                        ListTargetHttpProxiesRequest.prototype.filter = null;
    
                        /**
                         * ListTargetHttpProxiesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @instance
                         */
                        ListTargetHttpProxiesRequest.prototype.maxResults = null;
    
                        /**
                         * ListTargetHttpProxiesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @instance
                         */
                        ListTargetHttpProxiesRequest.prototype.orderBy = null;
    
                        /**
                         * ListTargetHttpProxiesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @instance
                         */
                        ListTargetHttpProxiesRequest.prototype.pageToken = null;
    
                        /**
                         * ListTargetHttpProxiesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @instance
                         */
                        ListTargetHttpProxiesRequest.prototype.project = "";
    
                        /**
                         * ListTargetHttpProxiesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @instance
                         */
                        ListTargetHttpProxiesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListTargetHttpProxiesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetHttpProxiesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetHttpProxiesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetHttpProxiesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetHttpProxiesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetHttpProxiesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetHttpProxiesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetHttpProxiesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetHttpProxiesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetHttpProxiesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListTargetHttpProxiesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetHttpProxiesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListTargetHttpProxiesRequest} ListTargetHttpProxiesRequest instance
                         */
                        ListTargetHttpProxiesRequest.create = function create(properties) {
                            return new ListTargetHttpProxiesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListTargetHttpProxiesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListTargetHttpProxiesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetHttpProxiesRequest} message ListTargetHttpProxiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListTargetHttpProxiesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListTargetHttpProxiesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListTargetHttpProxiesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetHttpProxiesRequest} message ListTargetHttpProxiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListTargetHttpProxiesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListTargetHttpProxiesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListTargetHttpProxiesRequest} ListTargetHttpProxiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListTargetHttpProxiesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListTargetHttpProxiesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListTargetHttpProxiesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListTargetHttpProxiesRequest} ListTargetHttpProxiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListTargetHttpProxiesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListTargetHttpProxiesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListTargetHttpProxiesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListTargetHttpProxiesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListTargetHttpProxiesRequest} ListTargetHttpProxiesRequest
                         */
                        ListTargetHttpProxiesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListTargetHttpProxiesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListTargetHttpProxiesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListTargetHttpProxiesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListTargetHttpProxiesRequest} message ListTargetHttpProxiesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListTargetHttpProxiesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListTargetHttpProxiesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListTargetHttpProxiesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListTargetHttpProxiesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListTargetHttpProxiesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListTargetHttpProxiesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListTargetHttpProxiesRequest";
                        };
    
                        return ListTargetHttpProxiesRequest;
                    })();
    
                    v1.ListTargetHttpsProxiesRequest = (function() {
    
                        /**
                         * Properties of a ListTargetHttpsProxiesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListTargetHttpsProxiesRequest
                         * @property {string|null} [filter] ListTargetHttpsProxiesRequest filter
                         * @property {number|null} [maxResults] ListTargetHttpsProxiesRequest maxResults
                         * @property {string|null} [orderBy] ListTargetHttpsProxiesRequest orderBy
                         * @property {string|null} [pageToken] ListTargetHttpsProxiesRequest pageToken
                         * @property {string|null} [project] ListTargetHttpsProxiesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListTargetHttpsProxiesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListTargetHttpsProxiesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListTargetHttpsProxiesRequest.
                         * @implements IListTargetHttpsProxiesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListTargetHttpsProxiesRequest=} [properties] Properties to set
                         */
                        function ListTargetHttpsProxiesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListTargetHttpsProxiesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @instance
                         */
                        ListTargetHttpsProxiesRequest.prototype.filter = null;
    
                        /**
                         * ListTargetHttpsProxiesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @instance
                         */
                        ListTargetHttpsProxiesRequest.prototype.maxResults = null;
    
                        /**
                         * ListTargetHttpsProxiesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @instance
                         */
                        ListTargetHttpsProxiesRequest.prototype.orderBy = null;
    
                        /**
                         * ListTargetHttpsProxiesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @instance
                         */
                        ListTargetHttpsProxiesRequest.prototype.pageToken = null;
    
                        /**
                         * ListTargetHttpsProxiesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @instance
                         */
                        ListTargetHttpsProxiesRequest.prototype.project = "";
    
                        /**
                         * ListTargetHttpsProxiesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @instance
                         */
                        ListTargetHttpsProxiesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListTargetHttpsProxiesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetHttpsProxiesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetHttpsProxiesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetHttpsProxiesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetHttpsProxiesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetHttpsProxiesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetHttpsProxiesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetHttpsProxiesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetHttpsProxiesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetHttpsProxiesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListTargetHttpsProxiesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetHttpsProxiesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListTargetHttpsProxiesRequest} ListTargetHttpsProxiesRequest instance
                         */
                        ListTargetHttpsProxiesRequest.create = function create(properties) {
                            return new ListTargetHttpsProxiesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListTargetHttpsProxiesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListTargetHttpsProxiesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetHttpsProxiesRequest} message ListTargetHttpsProxiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListTargetHttpsProxiesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListTargetHttpsProxiesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListTargetHttpsProxiesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetHttpsProxiesRequest} message ListTargetHttpsProxiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListTargetHttpsProxiesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListTargetHttpsProxiesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListTargetHttpsProxiesRequest} ListTargetHttpsProxiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListTargetHttpsProxiesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListTargetHttpsProxiesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListTargetHttpsProxiesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListTargetHttpsProxiesRequest} ListTargetHttpsProxiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListTargetHttpsProxiesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListTargetHttpsProxiesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListTargetHttpsProxiesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListTargetHttpsProxiesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListTargetHttpsProxiesRequest} ListTargetHttpsProxiesRequest
                         */
                        ListTargetHttpsProxiesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListTargetHttpsProxiesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListTargetHttpsProxiesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListTargetHttpsProxiesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListTargetHttpsProxiesRequest} message ListTargetHttpsProxiesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListTargetHttpsProxiesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListTargetHttpsProxiesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListTargetHttpsProxiesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListTargetHttpsProxiesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListTargetHttpsProxiesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListTargetHttpsProxiesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListTargetHttpsProxiesRequest";
                        };
    
                        return ListTargetHttpsProxiesRequest;
                    })();
    
                    v1.ListTargetInstancesRequest = (function() {
    
                        /**
                         * Properties of a ListTargetInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListTargetInstancesRequest
                         * @property {string|null} [filter] ListTargetInstancesRequest filter
                         * @property {number|null} [maxResults] ListTargetInstancesRequest maxResults
                         * @property {string|null} [orderBy] ListTargetInstancesRequest orderBy
                         * @property {string|null} [pageToken] ListTargetInstancesRequest pageToken
                         * @property {string|null} [project] ListTargetInstancesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListTargetInstancesRequest returnPartialSuccess
                         * @property {string|null} [zone] ListTargetInstancesRequest zone
                         */
    
                        /**
                         * Constructs a new ListTargetInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListTargetInstancesRequest.
                         * @implements IListTargetInstancesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListTargetInstancesRequest=} [properties] Properties to set
                         */
                        function ListTargetInstancesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListTargetInstancesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @instance
                         */
                        ListTargetInstancesRequest.prototype.filter = null;
    
                        /**
                         * ListTargetInstancesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @instance
                         */
                        ListTargetInstancesRequest.prototype.maxResults = null;
    
                        /**
                         * ListTargetInstancesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @instance
                         */
                        ListTargetInstancesRequest.prototype.orderBy = null;
    
                        /**
                         * ListTargetInstancesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @instance
                         */
                        ListTargetInstancesRequest.prototype.pageToken = null;
    
                        /**
                         * ListTargetInstancesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @instance
                         */
                        ListTargetInstancesRequest.prototype.project = "";
    
                        /**
                         * ListTargetInstancesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @instance
                         */
                        ListTargetInstancesRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListTargetInstancesRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @instance
                         */
                        ListTargetInstancesRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListTargetInstancesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetInstancesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetInstancesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetInstancesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetInstancesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetInstancesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetInstancesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetInstancesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetInstancesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetInstancesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListTargetInstancesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetInstancesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListTargetInstancesRequest} ListTargetInstancesRequest instance
                         */
                        ListTargetInstancesRequest.create = function create(properties) {
                            return new ListTargetInstancesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListTargetInstancesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListTargetInstancesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetInstancesRequest} message ListTargetInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListTargetInstancesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListTargetInstancesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListTargetInstancesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetInstancesRequest} message ListTargetInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListTargetInstancesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListTargetInstancesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListTargetInstancesRequest} ListTargetInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListTargetInstancesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListTargetInstancesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListTargetInstancesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListTargetInstancesRequest} ListTargetInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListTargetInstancesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListTargetInstancesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListTargetInstancesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListTargetInstancesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListTargetInstancesRequest} ListTargetInstancesRequest
                         */
                        ListTargetInstancesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListTargetInstancesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListTargetInstancesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListTargetInstancesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListTargetInstancesRequest} message ListTargetInstancesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListTargetInstancesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListTargetInstancesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListTargetInstancesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListTargetInstancesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListTargetInstancesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListTargetInstancesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListTargetInstancesRequest";
                        };
    
                        return ListTargetInstancesRequest;
                    })();
    
                    v1.ListTargetPoolsRequest = (function() {
    
                        /**
                         * Properties of a ListTargetPoolsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListTargetPoolsRequest
                         * @property {string|null} [filter] ListTargetPoolsRequest filter
                         * @property {number|null} [maxResults] ListTargetPoolsRequest maxResults
                         * @property {string|null} [orderBy] ListTargetPoolsRequest orderBy
                         * @property {string|null} [pageToken] ListTargetPoolsRequest pageToken
                         * @property {string|null} [project] ListTargetPoolsRequest project
                         * @property {string|null} [region] ListTargetPoolsRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListTargetPoolsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListTargetPoolsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListTargetPoolsRequest.
                         * @implements IListTargetPoolsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListTargetPoolsRequest=} [properties] Properties to set
                         */
                        function ListTargetPoolsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListTargetPoolsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @instance
                         */
                        ListTargetPoolsRequest.prototype.filter = null;
    
                        /**
                         * ListTargetPoolsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @instance
                         */
                        ListTargetPoolsRequest.prototype.maxResults = null;
    
                        /**
                         * ListTargetPoolsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @instance
                         */
                        ListTargetPoolsRequest.prototype.orderBy = null;
    
                        /**
                         * ListTargetPoolsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @instance
                         */
                        ListTargetPoolsRequest.prototype.pageToken = null;
    
                        /**
                         * ListTargetPoolsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @instance
                         */
                        ListTargetPoolsRequest.prototype.project = "";
    
                        /**
                         * ListTargetPoolsRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @instance
                         */
                        ListTargetPoolsRequest.prototype.region = "";
    
                        /**
                         * ListTargetPoolsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @instance
                         */
                        ListTargetPoolsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListTargetPoolsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetPoolsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetPoolsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetPoolsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetPoolsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetPoolsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetPoolsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetPoolsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetPoolsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetPoolsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListTargetPoolsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetPoolsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListTargetPoolsRequest} ListTargetPoolsRequest instance
                         */
                        ListTargetPoolsRequest.create = function create(properties) {
                            return new ListTargetPoolsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListTargetPoolsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListTargetPoolsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetPoolsRequest} message ListTargetPoolsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListTargetPoolsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListTargetPoolsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListTargetPoolsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetPoolsRequest} message ListTargetPoolsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListTargetPoolsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListTargetPoolsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListTargetPoolsRequest} ListTargetPoolsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListTargetPoolsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListTargetPoolsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListTargetPoolsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListTargetPoolsRequest} ListTargetPoolsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListTargetPoolsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListTargetPoolsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListTargetPoolsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListTargetPoolsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListTargetPoolsRequest} ListTargetPoolsRequest
                         */
                        ListTargetPoolsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListTargetPoolsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListTargetPoolsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListTargetPoolsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListTargetPoolsRequest} message ListTargetPoolsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListTargetPoolsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListTargetPoolsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListTargetPoolsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListTargetPoolsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListTargetPoolsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListTargetPoolsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListTargetPoolsRequest";
                        };
    
                        return ListTargetPoolsRequest;
                    })();
    
                    v1.ListTargetSslProxiesRequest = (function() {
    
                        /**
                         * Properties of a ListTargetSslProxiesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListTargetSslProxiesRequest
                         * @property {string|null} [filter] ListTargetSslProxiesRequest filter
                         * @property {number|null} [maxResults] ListTargetSslProxiesRequest maxResults
                         * @property {string|null} [orderBy] ListTargetSslProxiesRequest orderBy
                         * @property {string|null} [pageToken] ListTargetSslProxiesRequest pageToken
                         * @property {string|null} [project] ListTargetSslProxiesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListTargetSslProxiesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListTargetSslProxiesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListTargetSslProxiesRequest.
                         * @implements IListTargetSslProxiesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListTargetSslProxiesRequest=} [properties] Properties to set
                         */
                        function ListTargetSslProxiesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListTargetSslProxiesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @instance
                         */
                        ListTargetSslProxiesRequest.prototype.filter = null;
    
                        /**
                         * ListTargetSslProxiesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @instance
                         */
                        ListTargetSslProxiesRequest.prototype.maxResults = null;
    
                        /**
                         * ListTargetSslProxiesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @instance
                         */
                        ListTargetSslProxiesRequest.prototype.orderBy = null;
    
                        /**
                         * ListTargetSslProxiesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @instance
                         */
                        ListTargetSslProxiesRequest.prototype.pageToken = null;
    
                        /**
                         * ListTargetSslProxiesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @instance
                         */
                        ListTargetSslProxiesRequest.prototype.project = "";
    
                        /**
                         * ListTargetSslProxiesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @instance
                         */
                        ListTargetSslProxiesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListTargetSslProxiesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetSslProxiesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetSslProxiesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetSslProxiesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetSslProxiesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetSslProxiesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetSslProxiesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetSslProxiesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetSslProxiesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetSslProxiesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListTargetSslProxiesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetSslProxiesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListTargetSslProxiesRequest} ListTargetSslProxiesRequest instance
                         */
                        ListTargetSslProxiesRequest.create = function create(properties) {
                            return new ListTargetSslProxiesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListTargetSslProxiesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListTargetSslProxiesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetSslProxiesRequest} message ListTargetSslProxiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListTargetSslProxiesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListTargetSslProxiesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListTargetSslProxiesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetSslProxiesRequest} message ListTargetSslProxiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListTargetSslProxiesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListTargetSslProxiesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListTargetSslProxiesRequest} ListTargetSslProxiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListTargetSslProxiesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListTargetSslProxiesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListTargetSslProxiesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListTargetSslProxiesRequest} ListTargetSslProxiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListTargetSslProxiesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListTargetSslProxiesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListTargetSslProxiesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListTargetSslProxiesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListTargetSslProxiesRequest} ListTargetSslProxiesRequest
                         */
                        ListTargetSslProxiesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListTargetSslProxiesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListTargetSslProxiesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListTargetSslProxiesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListTargetSslProxiesRequest} message ListTargetSslProxiesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListTargetSslProxiesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListTargetSslProxiesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListTargetSslProxiesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListTargetSslProxiesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListTargetSslProxiesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListTargetSslProxiesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListTargetSslProxiesRequest";
                        };
    
                        return ListTargetSslProxiesRequest;
                    })();
    
                    v1.ListTargetTcpProxiesRequest = (function() {
    
                        /**
                         * Properties of a ListTargetTcpProxiesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListTargetTcpProxiesRequest
                         * @property {string|null} [filter] ListTargetTcpProxiesRequest filter
                         * @property {number|null} [maxResults] ListTargetTcpProxiesRequest maxResults
                         * @property {string|null} [orderBy] ListTargetTcpProxiesRequest orderBy
                         * @property {string|null} [pageToken] ListTargetTcpProxiesRequest pageToken
                         * @property {string|null} [project] ListTargetTcpProxiesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListTargetTcpProxiesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListTargetTcpProxiesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListTargetTcpProxiesRequest.
                         * @implements IListTargetTcpProxiesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListTargetTcpProxiesRequest=} [properties] Properties to set
                         */
                        function ListTargetTcpProxiesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListTargetTcpProxiesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @instance
                         */
                        ListTargetTcpProxiesRequest.prototype.filter = null;
    
                        /**
                         * ListTargetTcpProxiesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @instance
                         */
                        ListTargetTcpProxiesRequest.prototype.maxResults = null;
    
                        /**
                         * ListTargetTcpProxiesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @instance
                         */
                        ListTargetTcpProxiesRequest.prototype.orderBy = null;
    
                        /**
                         * ListTargetTcpProxiesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @instance
                         */
                        ListTargetTcpProxiesRequest.prototype.pageToken = null;
    
                        /**
                         * ListTargetTcpProxiesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @instance
                         */
                        ListTargetTcpProxiesRequest.prototype.project = "";
    
                        /**
                         * ListTargetTcpProxiesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @instance
                         */
                        ListTargetTcpProxiesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListTargetTcpProxiesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetTcpProxiesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetTcpProxiesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetTcpProxiesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetTcpProxiesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetTcpProxiesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetTcpProxiesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetTcpProxiesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetTcpProxiesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetTcpProxiesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListTargetTcpProxiesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetTcpProxiesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListTargetTcpProxiesRequest} ListTargetTcpProxiesRequest instance
                         */
                        ListTargetTcpProxiesRequest.create = function create(properties) {
                            return new ListTargetTcpProxiesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListTargetTcpProxiesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListTargetTcpProxiesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetTcpProxiesRequest} message ListTargetTcpProxiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListTargetTcpProxiesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListTargetTcpProxiesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListTargetTcpProxiesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetTcpProxiesRequest} message ListTargetTcpProxiesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListTargetTcpProxiesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListTargetTcpProxiesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListTargetTcpProxiesRequest} ListTargetTcpProxiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListTargetTcpProxiesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListTargetTcpProxiesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListTargetTcpProxiesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListTargetTcpProxiesRequest} ListTargetTcpProxiesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListTargetTcpProxiesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListTargetTcpProxiesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListTargetTcpProxiesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListTargetTcpProxiesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListTargetTcpProxiesRequest} ListTargetTcpProxiesRequest
                         */
                        ListTargetTcpProxiesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListTargetTcpProxiesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListTargetTcpProxiesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListTargetTcpProxiesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListTargetTcpProxiesRequest} message ListTargetTcpProxiesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListTargetTcpProxiesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListTargetTcpProxiesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListTargetTcpProxiesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListTargetTcpProxiesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListTargetTcpProxiesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListTargetTcpProxiesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListTargetTcpProxiesRequest";
                        };
    
                        return ListTargetTcpProxiesRequest;
                    })();
    
                    v1.ListTargetVpnGatewaysRequest = (function() {
    
                        /**
                         * Properties of a ListTargetVpnGatewaysRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListTargetVpnGatewaysRequest
                         * @property {string|null} [filter] ListTargetVpnGatewaysRequest filter
                         * @property {number|null} [maxResults] ListTargetVpnGatewaysRequest maxResults
                         * @property {string|null} [orderBy] ListTargetVpnGatewaysRequest orderBy
                         * @property {string|null} [pageToken] ListTargetVpnGatewaysRequest pageToken
                         * @property {string|null} [project] ListTargetVpnGatewaysRequest project
                         * @property {string|null} [region] ListTargetVpnGatewaysRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListTargetVpnGatewaysRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListTargetVpnGatewaysRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListTargetVpnGatewaysRequest.
                         * @implements IListTargetVpnGatewaysRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListTargetVpnGatewaysRequest=} [properties] Properties to set
                         */
                        function ListTargetVpnGatewaysRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListTargetVpnGatewaysRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @instance
                         */
                        ListTargetVpnGatewaysRequest.prototype.filter = null;
    
                        /**
                         * ListTargetVpnGatewaysRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @instance
                         */
                        ListTargetVpnGatewaysRequest.prototype.maxResults = null;
    
                        /**
                         * ListTargetVpnGatewaysRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @instance
                         */
                        ListTargetVpnGatewaysRequest.prototype.orderBy = null;
    
                        /**
                         * ListTargetVpnGatewaysRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @instance
                         */
                        ListTargetVpnGatewaysRequest.prototype.pageToken = null;
    
                        /**
                         * ListTargetVpnGatewaysRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @instance
                         */
                        ListTargetVpnGatewaysRequest.prototype.project = "";
    
                        /**
                         * ListTargetVpnGatewaysRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @instance
                         */
                        ListTargetVpnGatewaysRequest.prototype.region = "";
    
                        /**
                         * ListTargetVpnGatewaysRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @instance
                         */
                        ListTargetVpnGatewaysRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListTargetVpnGatewaysRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetVpnGatewaysRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetVpnGatewaysRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetVpnGatewaysRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetVpnGatewaysRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetVpnGatewaysRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetVpnGatewaysRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetVpnGatewaysRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListTargetVpnGatewaysRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(ListTargetVpnGatewaysRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListTargetVpnGatewaysRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetVpnGatewaysRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListTargetVpnGatewaysRequest} ListTargetVpnGatewaysRequest instance
                         */
                        ListTargetVpnGatewaysRequest.create = function create(properties) {
                            return new ListTargetVpnGatewaysRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListTargetVpnGatewaysRequest message. Does not implicitly {@link google.cloud.compute.v1.ListTargetVpnGatewaysRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetVpnGatewaysRequest} message ListTargetVpnGatewaysRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListTargetVpnGatewaysRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListTargetVpnGatewaysRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListTargetVpnGatewaysRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListTargetVpnGatewaysRequest} message ListTargetVpnGatewaysRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListTargetVpnGatewaysRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListTargetVpnGatewaysRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListTargetVpnGatewaysRequest} ListTargetVpnGatewaysRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListTargetVpnGatewaysRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListTargetVpnGatewaysRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListTargetVpnGatewaysRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListTargetVpnGatewaysRequest} ListTargetVpnGatewaysRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListTargetVpnGatewaysRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListTargetVpnGatewaysRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListTargetVpnGatewaysRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListTargetVpnGatewaysRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListTargetVpnGatewaysRequest} ListTargetVpnGatewaysRequest
                         */
                        ListTargetVpnGatewaysRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListTargetVpnGatewaysRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListTargetVpnGatewaysRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListTargetVpnGatewaysRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListTargetVpnGatewaysRequest} message ListTargetVpnGatewaysRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListTargetVpnGatewaysRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListTargetVpnGatewaysRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListTargetVpnGatewaysRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListTargetVpnGatewaysRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListTargetVpnGatewaysRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListTargetVpnGatewaysRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListTargetVpnGatewaysRequest";
                        };
    
                        return ListTargetVpnGatewaysRequest;
                    })();
    
                    v1.ListUrlMapsRequest = (function() {
    
                        /**
                         * Properties of a ListUrlMapsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListUrlMapsRequest
                         * @property {string|null} [filter] ListUrlMapsRequest filter
                         * @property {number|null} [maxResults] ListUrlMapsRequest maxResults
                         * @property {string|null} [orderBy] ListUrlMapsRequest orderBy
                         * @property {string|null} [pageToken] ListUrlMapsRequest pageToken
                         * @property {string|null} [project] ListUrlMapsRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListUrlMapsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListUrlMapsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListUrlMapsRequest.
                         * @implements IListUrlMapsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListUrlMapsRequest=} [properties] Properties to set
                         */
                        function ListUrlMapsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListUrlMapsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @instance
                         */
                        ListUrlMapsRequest.prototype.filter = null;
    
                        /**
                         * ListUrlMapsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @instance
                         */
                        ListUrlMapsRequest.prototype.maxResults = null;
    
                        /**
                         * ListUrlMapsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @instance
                         */
                        ListUrlMapsRequest.prototype.orderBy = null;
    
                        /**
                         * ListUrlMapsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @instance
                         */
                        ListUrlMapsRequest.prototype.pageToken = null;
    
                        /**
                         * ListUrlMapsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @instance
                         */
                        ListUrlMapsRequest.prototype.project = "";
    
                        /**
                         * ListUrlMapsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @instance
                         */
                        ListUrlMapsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListUrlMapsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @instance
                         */
                        Object.defineProperty(ListUrlMapsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListUrlMapsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @instance
                         */
                        Object.defineProperty(ListUrlMapsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListUrlMapsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @instance
                         */
                        Object.defineProperty(ListUrlMapsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListUrlMapsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @instance
                         */
                        Object.defineProperty(ListUrlMapsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListUrlMapsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @instance
                         */
                        Object.defineProperty(ListUrlMapsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListUrlMapsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListUrlMapsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListUrlMapsRequest} ListUrlMapsRequest instance
                         */
                        ListUrlMapsRequest.create = function create(properties) {
                            return new ListUrlMapsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListUrlMapsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListUrlMapsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListUrlMapsRequest} message ListUrlMapsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListUrlMapsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListUrlMapsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListUrlMapsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListUrlMapsRequest} message ListUrlMapsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListUrlMapsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListUrlMapsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListUrlMapsRequest} ListUrlMapsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListUrlMapsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListUrlMapsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListUrlMapsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListUrlMapsRequest} ListUrlMapsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListUrlMapsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListUrlMapsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListUrlMapsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListUrlMapsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListUrlMapsRequest} ListUrlMapsRequest
                         */
                        ListUrlMapsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListUrlMapsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListUrlMapsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListUrlMapsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListUrlMapsRequest} message ListUrlMapsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListUrlMapsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListUrlMapsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListUrlMapsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListUrlMapsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListUrlMapsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListUrlMapsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListUrlMapsRequest";
                        };
    
                        return ListUrlMapsRequest;
                    })();
    
                    v1.ListUsableSubnetworksRequest = (function() {
    
                        /**
                         * Properties of a ListUsableSubnetworksRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListUsableSubnetworksRequest
                         * @property {string|null} [filter] ListUsableSubnetworksRequest filter
                         * @property {number|null} [maxResults] ListUsableSubnetworksRequest maxResults
                         * @property {string|null} [orderBy] ListUsableSubnetworksRequest orderBy
                         * @property {string|null} [pageToken] ListUsableSubnetworksRequest pageToken
                         * @property {string|null} [project] ListUsableSubnetworksRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListUsableSubnetworksRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListUsableSubnetworksRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListUsableSubnetworksRequest.
                         * @implements IListUsableSubnetworksRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListUsableSubnetworksRequest=} [properties] Properties to set
                         */
                        function ListUsableSubnetworksRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListUsableSubnetworksRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @instance
                         */
                        ListUsableSubnetworksRequest.prototype.filter = null;
    
                        /**
                         * ListUsableSubnetworksRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @instance
                         */
                        ListUsableSubnetworksRequest.prototype.maxResults = null;
    
                        /**
                         * ListUsableSubnetworksRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @instance
                         */
                        ListUsableSubnetworksRequest.prototype.orderBy = null;
    
                        /**
                         * ListUsableSubnetworksRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @instance
                         */
                        ListUsableSubnetworksRequest.prototype.pageToken = null;
    
                        /**
                         * ListUsableSubnetworksRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @instance
                         */
                        ListUsableSubnetworksRequest.prototype.project = "";
    
                        /**
                         * ListUsableSubnetworksRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @instance
                         */
                        ListUsableSubnetworksRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListUsableSubnetworksRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListUsableSubnetworksRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListUsableSubnetworksRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListUsableSubnetworksRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListUsableSubnetworksRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListUsableSubnetworksRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListUsableSubnetworksRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListUsableSubnetworksRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListUsableSubnetworksRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @instance
                         */
                        Object.defineProperty(ListUsableSubnetworksRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListUsableSubnetworksRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListUsableSubnetworksRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListUsableSubnetworksRequest} ListUsableSubnetworksRequest instance
                         */
                        ListUsableSubnetworksRequest.create = function create(properties) {
                            return new ListUsableSubnetworksRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListUsableSubnetworksRequest message. Does not implicitly {@link google.cloud.compute.v1.ListUsableSubnetworksRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListUsableSubnetworksRequest} message ListUsableSubnetworksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListUsableSubnetworksRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListUsableSubnetworksRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListUsableSubnetworksRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListUsableSubnetworksRequest} message ListUsableSubnetworksRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListUsableSubnetworksRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListUsableSubnetworksRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListUsableSubnetworksRequest} ListUsableSubnetworksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListUsableSubnetworksRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListUsableSubnetworksRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListUsableSubnetworksRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListUsableSubnetworksRequest} ListUsableSubnetworksRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListUsableSubnetworksRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListUsableSubnetworksRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListUsableSubnetworksRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListUsableSubnetworksRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListUsableSubnetworksRequest} ListUsableSubnetworksRequest
                         */
                        ListUsableSubnetworksRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListUsableSubnetworksRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListUsableSubnetworksRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListUsableSubnetworksRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListUsableSubnetworksRequest} message ListUsableSubnetworksRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListUsableSubnetworksRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListUsableSubnetworksRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListUsableSubnetworksRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListUsableSubnetworksRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListUsableSubnetworksRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListUsableSubnetworksRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListUsableSubnetworksRequest";
                        };
    
                        return ListUsableSubnetworksRequest;
                    })();
    
                    v1.ListVpnGatewaysRequest = (function() {
    
                        /**
                         * Properties of a ListVpnGatewaysRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListVpnGatewaysRequest
                         * @property {string|null} [filter] ListVpnGatewaysRequest filter
                         * @property {number|null} [maxResults] ListVpnGatewaysRequest maxResults
                         * @property {string|null} [orderBy] ListVpnGatewaysRequest orderBy
                         * @property {string|null} [pageToken] ListVpnGatewaysRequest pageToken
                         * @property {string|null} [project] ListVpnGatewaysRequest project
                         * @property {string|null} [region] ListVpnGatewaysRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListVpnGatewaysRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListVpnGatewaysRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListVpnGatewaysRequest.
                         * @implements IListVpnGatewaysRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListVpnGatewaysRequest=} [properties] Properties to set
                         */
                        function ListVpnGatewaysRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListVpnGatewaysRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @instance
                         */
                        ListVpnGatewaysRequest.prototype.filter = null;
    
                        /**
                         * ListVpnGatewaysRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @instance
                         */
                        ListVpnGatewaysRequest.prototype.maxResults = null;
    
                        /**
                         * ListVpnGatewaysRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @instance
                         */
                        ListVpnGatewaysRequest.prototype.orderBy = null;
    
                        /**
                         * ListVpnGatewaysRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @instance
                         */
                        ListVpnGatewaysRequest.prototype.pageToken = null;
    
                        /**
                         * ListVpnGatewaysRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @instance
                         */
                        ListVpnGatewaysRequest.prototype.project = "";
    
                        /**
                         * ListVpnGatewaysRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @instance
                         */
                        ListVpnGatewaysRequest.prototype.region = "";
    
                        /**
                         * ListVpnGatewaysRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @instance
                         */
                        ListVpnGatewaysRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListVpnGatewaysRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(ListVpnGatewaysRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListVpnGatewaysRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(ListVpnGatewaysRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListVpnGatewaysRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(ListVpnGatewaysRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListVpnGatewaysRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(ListVpnGatewaysRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListVpnGatewaysRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @instance
                         */
                        Object.defineProperty(ListVpnGatewaysRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListVpnGatewaysRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListVpnGatewaysRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListVpnGatewaysRequest} ListVpnGatewaysRequest instance
                         */
                        ListVpnGatewaysRequest.create = function create(properties) {
                            return new ListVpnGatewaysRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListVpnGatewaysRequest message. Does not implicitly {@link google.cloud.compute.v1.ListVpnGatewaysRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListVpnGatewaysRequest} message ListVpnGatewaysRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListVpnGatewaysRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListVpnGatewaysRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListVpnGatewaysRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListVpnGatewaysRequest} message ListVpnGatewaysRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListVpnGatewaysRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListVpnGatewaysRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListVpnGatewaysRequest} ListVpnGatewaysRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListVpnGatewaysRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListVpnGatewaysRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListVpnGatewaysRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListVpnGatewaysRequest} ListVpnGatewaysRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListVpnGatewaysRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListVpnGatewaysRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListVpnGatewaysRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListVpnGatewaysRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListVpnGatewaysRequest} ListVpnGatewaysRequest
                         */
                        ListVpnGatewaysRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListVpnGatewaysRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListVpnGatewaysRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListVpnGatewaysRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListVpnGatewaysRequest} message ListVpnGatewaysRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListVpnGatewaysRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListVpnGatewaysRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListVpnGatewaysRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListVpnGatewaysRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListVpnGatewaysRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListVpnGatewaysRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListVpnGatewaysRequest";
                        };
    
                        return ListVpnGatewaysRequest;
                    })();
    
                    v1.ListVpnTunnelsRequest = (function() {
    
                        /**
                         * Properties of a ListVpnTunnelsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListVpnTunnelsRequest
                         * @property {string|null} [filter] ListVpnTunnelsRequest filter
                         * @property {number|null} [maxResults] ListVpnTunnelsRequest maxResults
                         * @property {string|null} [orderBy] ListVpnTunnelsRequest orderBy
                         * @property {string|null} [pageToken] ListVpnTunnelsRequest pageToken
                         * @property {string|null} [project] ListVpnTunnelsRequest project
                         * @property {string|null} [region] ListVpnTunnelsRequest region
                         * @property {boolean|null} [returnPartialSuccess] ListVpnTunnelsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListVpnTunnelsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListVpnTunnelsRequest.
                         * @implements IListVpnTunnelsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListVpnTunnelsRequest=} [properties] Properties to set
                         */
                        function ListVpnTunnelsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListVpnTunnelsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @instance
                         */
                        ListVpnTunnelsRequest.prototype.filter = null;
    
                        /**
                         * ListVpnTunnelsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @instance
                         */
                        ListVpnTunnelsRequest.prototype.maxResults = null;
    
                        /**
                         * ListVpnTunnelsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @instance
                         */
                        ListVpnTunnelsRequest.prototype.orderBy = null;
    
                        /**
                         * ListVpnTunnelsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @instance
                         */
                        ListVpnTunnelsRequest.prototype.pageToken = null;
    
                        /**
                         * ListVpnTunnelsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @instance
                         */
                        ListVpnTunnelsRequest.prototype.project = "";
    
                        /**
                         * ListVpnTunnelsRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @instance
                         */
                        ListVpnTunnelsRequest.prototype.region = "";
    
                        /**
                         * ListVpnTunnelsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @instance
                         */
                        ListVpnTunnelsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListVpnTunnelsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @instance
                         */
                        Object.defineProperty(ListVpnTunnelsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListVpnTunnelsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @instance
                         */
                        Object.defineProperty(ListVpnTunnelsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListVpnTunnelsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @instance
                         */
                        Object.defineProperty(ListVpnTunnelsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListVpnTunnelsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @instance
                         */
                        Object.defineProperty(ListVpnTunnelsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListVpnTunnelsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @instance
                         */
                        Object.defineProperty(ListVpnTunnelsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListVpnTunnelsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListVpnTunnelsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListVpnTunnelsRequest} ListVpnTunnelsRequest instance
                         */
                        ListVpnTunnelsRequest.create = function create(properties) {
                            return new ListVpnTunnelsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListVpnTunnelsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListVpnTunnelsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListVpnTunnelsRequest} message ListVpnTunnelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListVpnTunnelsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListVpnTunnelsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListVpnTunnelsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListVpnTunnelsRequest} message ListVpnTunnelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListVpnTunnelsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListVpnTunnelsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListVpnTunnelsRequest} ListVpnTunnelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListVpnTunnelsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListVpnTunnelsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListVpnTunnelsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListVpnTunnelsRequest} ListVpnTunnelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListVpnTunnelsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListVpnTunnelsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListVpnTunnelsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListVpnTunnelsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListVpnTunnelsRequest} ListVpnTunnelsRequest
                         */
                        ListVpnTunnelsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListVpnTunnelsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListVpnTunnelsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListVpnTunnelsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListVpnTunnelsRequest} message ListVpnTunnelsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListVpnTunnelsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListVpnTunnelsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListVpnTunnelsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListVpnTunnelsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListVpnTunnelsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListVpnTunnelsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListVpnTunnelsRequest";
                        };
    
                        return ListVpnTunnelsRequest;
                    })();
    
                    v1.ListXpnHostsProjectsRequest = (function() {
    
                        /**
                         * Properties of a ListXpnHostsProjectsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListXpnHostsProjectsRequest
                         * @property {string|null} [filter] ListXpnHostsProjectsRequest filter
                         * @property {number|null} [maxResults] ListXpnHostsProjectsRequest maxResults
                         * @property {string|null} [orderBy] ListXpnHostsProjectsRequest orderBy
                         * @property {string|null} [pageToken] ListXpnHostsProjectsRequest pageToken
                         * @property {string|null} [project] ListXpnHostsProjectsRequest project
                         * @property {google.cloud.compute.v1.IProjectsListXpnHostsRequest|null} [projectsListXpnHostsRequestResource] ListXpnHostsProjectsRequest projectsListXpnHostsRequestResource
                         * @property {boolean|null} [returnPartialSuccess] ListXpnHostsProjectsRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListXpnHostsProjectsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListXpnHostsProjectsRequest.
                         * @implements IListXpnHostsProjectsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListXpnHostsProjectsRequest=} [properties] Properties to set
                         */
                        function ListXpnHostsProjectsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListXpnHostsProjectsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @instance
                         */
                        ListXpnHostsProjectsRequest.prototype.filter = null;
    
                        /**
                         * ListXpnHostsProjectsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @instance
                         */
                        ListXpnHostsProjectsRequest.prototype.maxResults = null;
    
                        /**
                         * ListXpnHostsProjectsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @instance
                         */
                        ListXpnHostsProjectsRequest.prototype.orderBy = null;
    
                        /**
                         * ListXpnHostsProjectsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @instance
                         */
                        ListXpnHostsProjectsRequest.prototype.pageToken = null;
    
                        /**
                         * ListXpnHostsProjectsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @instance
                         */
                        ListXpnHostsProjectsRequest.prototype.project = "";
    
                        /**
                         * ListXpnHostsProjectsRequest projectsListXpnHostsRequestResource.
                         * @member {google.cloud.compute.v1.IProjectsListXpnHostsRequest|null|undefined} projectsListXpnHostsRequestResource
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @instance
                         */
                        ListXpnHostsProjectsRequest.prototype.projectsListXpnHostsRequestResource = null;
    
                        /**
                         * ListXpnHostsProjectsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @instance
                         */
                        ListXpnHostsProjectsRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListXpnHostsProjectsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @instance
                         */
                        Object.defineProperty(ListXpnHostsProjectsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListXpnHostsProjectsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @instance
                         */
                        Object.defineProperty(ListXpnHostsProjectsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListXpnHostsProjectsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @instance
                         */
                        Object.defineProperty(ListXpnHostsProjectsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListXpnHostsProjectsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @instance
                         */
                        Object.defineProperty(ListXpnHostsProjectsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListXpnHostsProjectsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @instance
                         */
                        Object.defineProperty(ListXpnHostsProjectsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListXpnHostsProjectsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListXpnHostsProjectsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListXpnHostsProjectsRequest} ListXpnHostsProjectsRequest instance
                         */
                        ListXpnHostsProjectsRequest.create = function create(properties) {
                            return new ListXpnHostsProjectsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListXpnHostsProjectsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListXpnHostsProjectsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListXpnHostsProjectsRequest} message ListXpnHostsProjectsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListXpnHostsProjectsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.projectsListXpnHostsRequestResource != null && Object.hasOwnProperty.call(message, "projectsListXpnHostsRequestResource"))
                                $root.google.cloud.compute.v1.ProjectsListXpnHostsRequest.encode(message.projectsListXpnHostsRequestResource, writer.uint32(/* id 238266391, wireType 2 =*/1906131130).fork()).ldelim();
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListXpnHostsProjectsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListXpnHostsProjectsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListXpnHostsProjectsRequest} message ListXpnHostsProjectsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListXpnHostsProjectsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListXpnHostsProjectsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListXpnHostsProjectsRequest} ListXpnHostsProjectsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListXpnHostsProjectsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListXpnHostsProjectsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 238266391: {
                                        message.projectsListXpnHostsRequestResource = $root.google.cloud.compute.v1.ProjectsListXpnHostsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListXpnHostsProjectsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListXpnHostsProjectsRequest} ListXpnHostsProjectsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListXpnHostsProjectsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListXpnHostsProjectsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListXpnHostsProjectsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.projectsListXpnHostsRequestResource != null && message.hasOwnProperty("projectsListXpnHostsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.ProjectsListXpnHostsRequest.verify(message.projectsListXpnHostsRequestResource);
                                if (error)
                                    return "projectsListXpnHostsRequestResource." + error;
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListXpnHostsProjectsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListXpnHostsProjectsRequest} ListXpnHostsProjectsRequest
                         */
                        ListXpnHostsProjectsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListXpnHostsProjectsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListXpnHostsProjectsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.projectsListXpnHostsRequestResource != null) {
                                if (typeof object.projectsListXpnHostsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ListXpnHostsProjectsRequest.projectsListXpnHostsRequestResource: object expected");
                                message.projectsListXpnHostsRequestResource = $root.google.cloud.compute.v1.ProjectsListXpnHostsRequest.fromObject(object.projectsListXpnHostsRequestResource);
                            }
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListXpnHostsProjectsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListXpnHostsProjectsRequest} message ListXpnHostsProjectsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListXpnHostsProjectsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.projectsListXpnHostsRequestResource = null;
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.projectsListXpnHostsRequestResource != null && message.hasOwnProperty("projectsListXpnHostsRequestResource"))
                                object.projectsListXpnHostsRequestResource = $root.google.cloud.compute.v1.ProjectsListXpnHostsRequest.toObject(message.projectsListXpnHostsRequestResource, options);
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListXpnHostsProjectsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListXpnHostsProjectsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListXpnHostsProjectsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListXpnHostsProjectsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListXpnHostsProjectsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListXpnHostsProjectsRequest";
                        };
    
                        return ListXpnHostsProjectsRequest;
                    })();
    
                    v1.ListZoneOperationsRequest = (function() {
    
                        /**
                         * Properties of a ListZoneOperationsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListZoneOperationsRequest
                         * @property {string|null} [filter] ListZoneOperationsRequest filter
                         * @property {number|null} [maxResults] ListZoneOperationsRequest maxResults
                         * @property {string|null} [orderBy] ListZoneOperationsRequest orderBy
                         * @property {string|null} [pageToken] ListZoneOperationsRequest pageToken
                         * @property {string|null} [project] ListZoneOperationsRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListZoneOperationsRequest returnPartialSuccess
                         * @property {string|null} [zone] ListZoneOperationsRequest zone
                         */
    
                        /**
                         * Constructs a new ListZoneOperationsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListZoneOperationsRequest.
                         * @implements IListZoneOperationsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListZoneOperationsRequest=} [properties] Properties to set
                         */
                        function ListZoneOperationsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListZoneOperationsRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @instance
                         */
                        ListZoneOperationsRequest.prototype.filter = null;
    
                        /**
                         * ListZoneOperationsRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @instance
                         */
                        ListZoneOperationsRequest.prototype.maxResults = null;
    
                        /**
                         * ListZoneOperationsRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @instance
                         */
                        ListZoneOperationsRequest.prototype.orderBy = null;
    
                        /**
                         * ListZoneOperationsRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @instance
                         */
                        ListZoneOperationsRequest.prototype.pageToken = null;
    
                        /**
                         * ListZoneOperationsRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @instance
                         */
                        ListZoneOperationsRequest.prototype.project = "";
    
                        /**
                         * ListZoneOperationsRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @instance
                         */
                        ListZoneOperationsRequest.prototype.returnPartialSuccess = null;
    
                        /**
                         * ListZoneOperationsRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @instance
                         */
                        ListZoneOperationsRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListZoneOperationsRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListZoneOperationsRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListZoneOperationsRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListZoneOperationsRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListZoneOperationsRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListZoneOperationsRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListZoneOperationsRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListZoneOperationsRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListZoneOperationsRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @instance
                         */
                        Object.defineProperty(ListZoneOperationsRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListZoneOperationsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListZoneOperationsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListZoneOperationsRequest} ListZoneOperationsRequest instance
                         */
                        ListZoneOperationsRequest.create = function create(properties) {
                            return new ListZoneOperationsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListZoneOperationsRequest message. Does not implicitly {@link google.cloud.compute.v1.ListZoneOperationsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListZoneOperationsRequest} message ListZoneOperationsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListZoneOperationsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListZoneOperationsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListZoneOperationsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListZoneOperationsRequest} message ListZoneOperationsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListZoneOperationsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListZoneOperationsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListZoneOperationsRequest} ListZoneOperationsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListZoneOperationsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListZoneOperationsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListZoneOperationsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListZoneOperationsRequest} ListZoneOperationsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListZoneOperationsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListZoneOperationsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListZoneOperationsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListZoneOperationsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListZoneOperationsRequest} ListZoneOperationsRequest
                         */
                        ListZoneOperationsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListZoneOperationsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListZoneOperationsRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListZoneOperationsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListZoneOperationsRequest} message ListZoneOperationsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListZoneOperationsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListZoneOperationsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListZoneOperationsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListZoneOperationsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListZoneOperationsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListZoneOperationsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListZoneOperationsRequest";
                        };
    
                        return ListZoneOperationsRequest;
                    })();
    
                    v1.ListZonesRequest = (function() {
    
                        /**
                         * Properties of a ListZonesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IListZonesRequest
                         * @property {string|null} [filter] ListZonesRequest filter
                         * @property {number|null} [maxResults] ListZonesRequest maxResults
                         * @property {string|null} [orderBy] ListZonesRequest orderBy
                         * @property {string|null} [pageToken] ListZonesRequest pageToken
                         * @property {string|null} [project] ListZonesRequest project
                         * @property {boolean|null} [returnPartialSuccess] ListZonesRequest returnPartialSuccess
                         */
    
                        /**
                         * Constructs a new ListZonesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ListZonesRequest.
                         * @implements IListZonesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IListZonesRequest=} [properties] Properties to set
                         */
                        function ListZonesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListZonesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @instance
                         */
                        ListZonesRequest.prototype.filter = null;
    
                        /**
                         * ListZonesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @instance
                         */
                        ListZonesRequest.prototype.maxResults = null;
    
                        /**
                         * ListZonesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @instance
                         */
                        ListZonesRequest.prototype.orderBy = null;
    
                        /**
                         * ListZonesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @instance
                         */
                        ListZonesRequest.prototype.pageToken = null;
    
                        /**
                         * ListZonesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @instance
                         */
                        ListZonesRequest.prototype.project = "";
    
                        /**
                         * ListZonesRequest returnPartialSuccess.
                         * @member {boolean|null|undefined} returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @instance
                         */
                        ListZonesRequest.prototype.returnPartialSuccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListZonesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @instance
                         */
                        Object.defineProperty(ListZonesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListZonesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @instance
                         */
                        Object.defineProperty(ListZonesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListZonesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @instance
                         */
                        Object.defineProperty(ListZonesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListZonesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @instance
                         */
                        Object.defineProperty(ListZonesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListZonesRequest _returnPartialSuccess.
                         * @member {"returnPartialSuccess"|undefined} _returnPartialSuccess
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @instance
                         */
                        Object.defineProperty(ListZonesRequest.prototype, "_returnPartialSuccess", {
                            get: $util.oneOfGetter($oneOfFields = ["returnPartialSuccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListZonesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListZonesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ListZonesRequest} ListZonesRequest instance
                         */
                        ListZonesRequest.create = function create(properties) {
                            return new ListZonesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListZonesRequest message. Does not implicitly {@link google.cloud.compute.v1.ListZonesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListZonesRequest} message ListZonesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListZonesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.returnPartialSuccess != null && Object.hasOwnProperty.call(message, "returnPartialSuccess"))
                                writer.uint32(/* id 517198390, wireType 0 =*/4137587120).bool(message.returnPartialSuccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListZonesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ListZonesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IListZonesRequest} message ListZonesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListZonesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListZonesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ListZonesRequest} ListZonesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListZonesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ListZonesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 517198390: {
                                        message.returnPartialSuccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListZonesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ListZonesRequest} ListZonesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListZonesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListZonesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListZonesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                properties._returnPartialSuccess = 1;
                                if (typeof message.returnPartialSuccess !== "boolean")
                                    return "returnPartialSuccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ListZonesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ListZonesRequest} ListZonesRequest
                         */
                        ListZonesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ListZonesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ListZonesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.returnPartialSuccess != null)
                                message.returnPartialSuccess = Boolean(object.returnPartialSuccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListZonesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ListZonesRequest} message ListZonesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListZonesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.returnPartialSuccess != null && message.hasOwnProperty("returnPartialSuccess")) {
                                object.returnPartialSuccess = message.returnPartialSuccess;
                                if (options.oneofs)
                                    object._returnPartialSuccess = "returnPartialSuccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListZonesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListZonesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListZonesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ListZonesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListZonesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ListZonesRequest";
                        };
    
                        return ListZonesRequest;
                    })();
    
                    v1.LocalDisk = (function() {
    
                        /**
                         * Properties of a LocalDisk.
                         * @memberof google.cloud.compute.v1
                         * @interface ILocalDisk
                         * @property {number|null} [diskCount] LocalDisk diskCount
                         * @property {number|null} [diskSizeGb] LocalDisk diskSizeGb
                         * @property {string|null} [diskType] LocalDisk diskType
                         */
    
                        /**
                         * Constructs a new LocalDisk.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a LocalDisk.
                         * @implements ILocalDisk
                         * @constructor
                         * @param {google.cloud.compute.v1.ILocalDisk=} [properties] Properties to set
                         */
                        function LocalDisk(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * LocalDisk diskCount.
                         * @member {number|null|undefined} diskCount
                         * @memberof google.cloud.compute.v1.LocalDisk
                         * @instance
                         */
                        LocalDisk.prototype.diskCount = null;
    
                        /**
                         * LocalDisk diskSizeGb.
                         * @member {number|null|undefined} diskSizeGb
                         * @memberof google.cloud.compute.v1.LocalDisk
                         * @instance
                         */
                        LocalDisk.prototype.diskSizeGb = null;
    
                        /**
                         * LocalDisk diskType.
                         * @member {string|null|undefined} diskType
                         * @memberof google.cloud.compute.v1.LocalDisk
                         * @instance
                         */
                        LocalDisk.prototype.diskType = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * LocalDisk _diskCount.
                         * @member {"diskCount"|undefined} _diskCount
                         * @memberof google.cloud.compute.v1.LocalDisk
                         * @instance
                         */
                        Object.defineProperty(LocalDisk.prototype, "_diskCount", {
                            get: $util.oneOfGetter($oneOfFields = ["diskCount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LocalDisk _diskSizeGb.
                         * @member {"diskSizeGb"|undefined} _diskSizeGb
                         * @memberof google.cloud.compute.v1.LocalDisk
                         * @instance
                         */
                        Object.defineProperty(LocalDisk.prototype, "_diskSizeGb", {
                            get: $util.oneOfGetter($oneOfFields = ["diskSizeGb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LocalDisk _diskType.
                         * @member {"diskType"|undefined} _diskType
                         * @memberof google.cloud.compute.v1.LocalDisk
                         * @instance
                         */
                        Object.defineProperty(LocalDisk.prototype, "_diskType", {
                            get: $util.oneOfGetter($oneOfFields = ["diskType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new LocalDisk instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.LocalDisk
                         * @static
                         * @param {google.cloud.compute.v1.ILocalDisk=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.LocalDisk} LocalDisk instance
                         */
                        LocalDisk.create = function create(properties) {
                            return new LocalDisk(properties);
                        };
    
                        /**
                         * Encodes the specified LocalDisk message. Does not implicitly {@link google.cloud.compute.v1.LocalDisk.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.LocalDisk
                         * @static
                         * @param {google.cloud.compute.v1.ILocalDisk} message LocalDisk message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocalDisk.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.diskType != null && Object.hasOwnProperty.call(message, "diskType"))
                                writer.uint32(/* id 93009052, wireType 2 =*/744072418).string(message.diskType);
                            if (message.diskCount != null && Object.hasOwnProperty.call(message, "diskCount"))
                                writer.uint32(/* id 182933485, wireType 0 =*/1463467880).int32(message.diskCount);
                            if (message.diskSizeGb != null && Object.hasOwnProperty.call(message, "diskSizeGb"))
                                writer.uint32(/* id 316263735, wireType 0 =*/2530109880).int32(message.diskSizeGb);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified LocalDisk message, length delimited. Does not implicitly {@link google.cloud.compute.v1.LocalDisk.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.LocalDisk
                         * @static
                         * @param {google.cloud.compute.v1.ILocalDisk} message LocalDisk message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocalDisk.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a LocalDisk message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.LocalDisk
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.LocalDisk} LocalDisk
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocalDisk.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.LocalDisk();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 182933485: {
                                        message.diskCount = reader.int32();
                                        break;
                                    }
                                case 316263735: {
                                        message.diskSizeGb = reader.int32();
                                        break;
                                    }
                                case 93009052: {
                                        message.diskType = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a LocalDisk message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.LocalDisk
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.LocalDisk} LocalDisk
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocalDisk.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a LocalDisk message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.LocalDisk
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LocalDisk.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.diskCount != null && message.hasOwnProperty("diskCount")) {
                                properties._diskCount = 1;
                                if (!$util.isInteger(message.diskCount))
                                    return "diskCount: integer expected";
                            }
                            if (message.diskSizeGb != null && message.hasOwnProperty("diskSizeGb")) {
                                properties._diskSizeGb = 1;
                                if (!$util.isInteger(message.diskSizeGb))
                                    return "diskSizeGb: integer expected";
                            }
                            if (message.diskType != null && message.hasOwnProperty("diskType")) {
                                properties._diskType = 1;
                                if (!$util.isString(message.diskType))
                                    return "diskType: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a LocalDisk message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.LocalDisk
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.LocalDisk} LocalDisk
                         */
                        LocalDisk.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.LocalDisk)
                                return object;
                            var message = new $root.google.cloud.compute.v1.LocalDisk();
                            if (object.diskCount != null)
                                message.diskCount = object.diskCount | 0;
                            if (object.diskSizeGb != null)
                                message.diskSizeGb = object.diskSizeGb | 0;
                            if (object.diskType != null)
                                message.diskType = String(object.diskType);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a LocalDisk message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.LocalDisk
                         * @static
                         * @param {google.cloud.compute.v1.LocalDisk} message LocalDisk
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LocalDisk.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.diskType != null && message.hasOwnProperty("diskType")) {
                                object.diskType = message.diskType;
                                if (options.oneofs)
                                    object._diskType = "diskType";
                            }
                            if (message.diskCount != null && message.hasOwnProperty("diskCount")) {
                                object.diskCount = message.diskCount;
                                if (options.oneofs)
                                    object._diskCount = "diskCount";
                            }
                            if (message.diskSizeGb != null && message.hasOwnProperty("diskSizeGb")) {
                                object.diskSizeGb = message.diskSizeGb;
                                if (options.oneofs)
                                    object._diskSizeGb = "diskSizeGb";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this LocalDisk to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.LocalDisk
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LocalDisk.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for LocalDisk
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.LocalDisk
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        LocalDisk.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.LocalDisk";
                        };
    
                        return LocalDisk;
                    })();
    
                    v1.LocalizedMessage = (function() {
    
                        /**
                         * Properties of a LocalizedMessage.
                         * @memberof google.cloud.compute.v1
                         * @interface ILocalizedMessage
                         * @property {string|null} [locale] LocalizedMessage locale
                         * @property {string|null} [message] LocalizedMessage message
                         */
    
                        /**
                         * Constructs a new LocalizedMessage.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a LocalizedMessage.
                         * @implements ILocalizedMessage
                         * @constructor
                         * @param {google.cloud.compute.v1.ILocalizedMessage=} [properties] Properties to set
                         */
                        function LocalizedMessage(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * LocalizedMessage locale.
                         * @member {string|null|undefined} locale
                         * @memberof google.cloud.compute.v1.LocalizedMessage
                         * @instance
                         */
                        LocalizedMessage.prototype.locale = null;
    
                        /**
                         * LocalizedMessage message.
                         * @member {string|null|undefined} message
                         * @memberof google.cloud.compute.v1.LocalizedMessage
                         * @instance
                         */
                        LocalizedMessage.prototype.message = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * LocalizedMessage _locale.
                         * @member {"locale"|undefined} _locale
                         * @memberof google.cloud.compute.v1.LocalizedMessage
                         * @instance
                         */
                        Object.defineProperty(LocalizedMessage.prototype, "_locale", {
                            get: $util.oneOfGetter($oneOfFields = ["locale"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LocalizedMessage _message.
                         * @member {"message"|undefined} _message
                         * @memberof google.cloud.compute.v1.LocalizedMessage
                         * @instance
                         */
                        Object.defineProperty(LocalizedMessage.prototype, "_message", {
                            get: $util.oneOfGetter($oneOfFields = ["message"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new LocalizedMessage instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.LocalizedMessage
                         * @static
                         * @param {google.cloud.compute.v1.ILocalizedMessage=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.LocalizedMessage} LocalizedMessage instance
                         */
                        LocalizedMessage.create = function create(properties) {
                            return new LocalizedMessage(properties);
                        };
    
                        /**
                         * Encodes the specified LocalizedMessage message. Does not implicitly {@link google.cloud.compute.v1.LocalizedMessage.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.LocalizedMessage
                         * @static
                         * @param {google.cloud.compute.v1.ILocalizedMessage} message LocalizedMessage message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocalizedMessage.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.message != null && Object.hasOwnProperty.call(message, "message"))
                                writer.uint32(/* id 418054151, wireType 2 =*/3344433210).string(message.message);
                            if (message.locale != null && Object.hasOwnProperty.call(message, "locale"))
                                writer.uint32(/* id 513150554, wireType 2 =*/4105204434).string(message.locale);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified LocalizedMessage message, length delimited. Does not implicitly {@link google.cloud.compute.v1.LocalizedMessage.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.LocalizedMessage
                         * @static
                         * @param {google.cloud.compute.v1.ILocalizedMessage} message LocalizedMessage message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocalizedMessage.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a LocalizedMessage message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.LocalizedMessage
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.LocalizedMessage} LocalizedMessage
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocalizedMessage.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.LocalizedMessage();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 513150554: {
                                        message.locale = reader.string();
                                        break;
                                    }
                                case 418054151: {
                                        message.message = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a LocalizedMessage message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.LocalizedMessage
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.LocalizedMessage} LocalizedMessage
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocalizedMessage.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a LocalizedMessage message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.LocalizedMessage
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LocalizedMessage.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.locale != null && message.hasOwnProperty("locale")) {
                                properties._locale = 1;
                                if (!$util.isString(message.locale))
                                    return "locale: string expected";
                            }
                            if (message.message != null && message.hasOwnProperty("message")) {
                                properties._message = 1;
                                if (!$util.isString(message.message))
                                    return "message: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a LocalizedMessage message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.LocalizedMessage
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.LocalizedMessage} LocalizedMessage
                         */
                        LocalizedMessage.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.LocalizedMessage)
                                return object;
                            var message = new $root.google.cloud.compute.v1.LocalizedMessage();
                            if (object.locale != null)
                                message.locale = String(object.locale);
                            if (object.message != null)
                                message.message = String(object.message);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a LocalizedMessage message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.LocalizedMessage
                         * @static
                         * @param {google.cloud.compute.v1.LocalizedMessage} message LocalizedMessage
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LocalizedMessage.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.message != null && message.hasOwnProperty("message")) {
                                object.message = message.message;
                                if (options.oneofs)
                                    object._message = "message";
                            }
                            if (message.locale != null && message.hasOwnProperty("locale")) {
                                object.locale = message.locale;
                                if (options.oneofs)
                                    object._locale = "locale";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this LocalizedMessage to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.LocalizedMessage
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LocalizedMessage.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for LocalizedMessage
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.LocalizedMessage
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        LocalizedMessage.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.LocalizedMessage";
                        };
    
                        return LocalizedMessage;
                    })();
    
                    v1.LocationPolicy = (function() {
    
                        /**
                         * Properties of a LocationPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface ILocationPolicy
                         * @property {Object.<string,google.cloud.compute.v1.ILocationPolicyLocation>|null} [locations] LocationPolicy locations
                         * @property {string|null} [targetShape] LocationPolicy targetShape
                         */
    
                        /**
                         * Constructs a new LocationPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a LocationPolicy.
                         * @implements ILocationPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.ILocationPolicy=} [properties] Properties to set
                         */
                        function LocationPolicy(properties) {
                            this.locations = {};
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * LocationPolicy locations.
                         * @member {Object.<string,google.cloud.compute.v1.ILocationPolicyLocation>} locations
                         * @memberof google.cloud.compute.v1.LocationPolicy
                         * @instance
                         */
                        LocationPolicy.prototype.locations = $util.emptyObject;
    
                        /**
                         * LocationPolicy targetShape.
                         * @member {string|null|undefined} targetShape
                         * @memberof google.cloud.compute.v1.LocationPolicy
                         * @instance
                         */
                        LocationPolicy.prototype.targetShape = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * LocationPolicy _targetShape.
                         * @member {"targetShape"|undefined} _targetShape
                         * @memberof google.cloud.compute.v1.LocationPolicy
                         * @instance
                         */
                        Object.defineProperty(LocationPolicy.prototype, "_targetShape", {
                            get: $util.oneOfGetter($oneOfFields = ["targetShape"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new LocationPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.LocationPolicy
                         * @static
                         * @param {google.cloud.compute.v1.ILocationPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.LocationPolicy} LocationPolicy instance
                         */
                        LocationPolicy.create = function create(properties) {
                            return new LocationPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified LocationPolicy message. Does not implicitly {@link google.cloud.compute.v1.LocationPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.LocationPolicy
                         * @static
                         * @param {google.cloud.compute.v1.ILocationPolicy} message LocationPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocationPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetShape != null && Object.hasOwnProperty.call(message, "targetShape"))
                                writer.uint32(/* id 338621299, wireType 2 =*/2708970394).string(message.targetShape);
                            if (message.locations != null && Object.hasOwnProperty.call(message, "locations"))
                                for (var keys = Object.keys(message.locations), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 413423454, wireType 2 =*/3307387634).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.LocationPolicyLocation.encode(message.locations[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            return writer;
                        };
    
                        /**
                         * Encodes the specified LocationPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.LocationPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.LocationPolicy
                         * @static
                         * @param {google.cloud.compute.v1.ILocationPolicy} message LocationPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocationPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a LocationPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.LocationPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.LocationPolicy} LocationPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocationPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.LocationPolicy(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 413423454: {
                                        if (message.locations === $util.emptyObject)
                                            message.locations = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.LocationPolicyLocation.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.locations[key] = value;
                                        break;
                                    }
                                case 338621299: {
                                        message.targetShape = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a LocationPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.LocationPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.LocationPolicy} LocationPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocationPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a LocationPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.LocationPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LocationPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.locations != null && message.hasOwnProperty("locations")) {
                                if (!$util.isObject(message.locations))
                                    return "locations: object expected";
                                var key = Object.keys(message.locations);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.LocationPolicyLocation.verify(message.locations[key[i]]);
                                    if (error)
                                        return "locations." + error;
                                }
                            }
                            if (message.targetShape != null && message.hasOwnProperty("targetShape")) {
                                properties._targetShape = 1;
                                if (!$util.isString(message.targetShape))
                                    return "targetShape: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a LocationPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.LocationPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.LocationPolicy} LocationPolicy
                         */
                        LocationPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.LocationPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.LocationPolicy();
                            if (object.locations) {
                                if (typeof object.locations !== "object")
                                    throw TypeError(".google.cloud.compute.v1.LocationPolicy.locations: object expected");
                                message.locations = {};
                                for (var keys = Object.keys(object.locations), i = 0; i < keys.length; ++i) {
                                    if (typeof object.locations[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.LocationPolicy.locations: object expected");
                                    message.locations[keys[i]] = $root.google.cloud.compute.v1.LocationPolicyLocation.fromObject(object.locations[keys[i]]);
                                }
                            }
                            if (object.targetShape != null)
                                message.targetShape = String(object.targetShape);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a LocationPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.LocationPolicy
                         * @static
                         * @param {google.cloud.compute.v1.LocationPolicy} message LocationPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LocationPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.objects || options.defaults)
                                object.locations = {};
                            if (message.targetShape != null && message.hasOwnProperty("targetShape")) {
                                object.targetShape = message.targetShape;
                                if (options.oneofs)
                                    object._targetShape = "targetShape";
                            }
                            var keys2;
                            if (message.locations && (keys2 = Object.keys(message.locations)).length) {
                                object.locations = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.locations[keys2[j]] = $root.google.cloud.compute.v1.LocationPolicyLocation.toObject(message.locations[keys2[j]], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this LocationPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.LocationPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LocationPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for LocationPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.LocationPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        LocationPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.LocationPolicy";
                        };
    
                        /**
                         * TargetShape enum.
                         * @name google.cloud.compute.v1.LocationPolicy.TargetShape
                         * @enum {number}
                         * @property {number} UNDEFINED_TARGET_SHAPE=0 UNDEFINED_TARGET_SHAPE value
                         * @property {number} ANY=64972 ANY value
                         * @property {number} ANY_SINGLE_ZONE=61100880 ANY_SINGLE_ZONE value
                         * @property {number} BALANCED=468409608 BALANCED value
                         */
                        LocationPolicy.TargetShape = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TARGET_SHAPE"] = 0;
                            values[valuesById[64972] = "ANY"] = 64972;
                            values[valuesById[61100880] = "ANY_SINGLE_ZONE"] = 61100880;
                            values[valuesById[468409608] = "BALANCED"] = 468409608;
                            return values;
                        })();
    
                        return LocationPolicy;
                    })();
    
                    v1.LocationPolicyLocation = (function() {
    
                        /**
                         * Properties of a LocationPolicyLocation.
                         * @memberof google.cloud.compute.v1
                         * @interface ILocationPolicyLocation
                         * @property {google.cloud.compute.v1.ILocationPolicyLocationConstraints|null} [constraints] LocationPolicyLocation constraints
                         * @property {string|null} [preference] LocationPolicyLocation preference
                         */
    
                        /**
                         * Constructs a new LocationPolicyLocation.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a LocationPolicyLocation.
                         * @implements ILocationPolicyLocation
                         * @constructor
                         * @param {google.cloud.compute.v1.ILocationPolicyLocation=} [properties] Properties to set
                         */
                        function LocationPolicyLocation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * LocationPolicyLocation constraints.
                         * @member {google.cloud.compute.v1.ILocationPolicyLocationConstraints|null|undefined} constraints
                         * @memberof google.cloud.compute.v1.LocationPolicyLocation
                         * @instance
                         */
                        LocationPolicyLocation.prototype.constraints = null;
    
                        /**
                         * LocationPolicyLocation preference.
                         * @member {string|null|undefined} preference
                         * @memberof google.cloud.compute.v1.LocationPolicyLocation
                         * @instance
                         */
                        LocationPolicyLocation.prototype.preference = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * LocationPolicyLocation _constraints.
                         * @member {"constraints"|undefined} _constraints
                         * @memberof google.cloud.compute.v1.LocationPolicyLocation
                         * @instance
                         */
                        Object.defineProperty(LocationPolicyLocation.prototype, "_constraints", {
                            get: $util.oneOfGetter($oneOfFields = ["constraints"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LocationPolicyLocation _preference.
                         * @member {"preference"|undefined} _preference
                         * @memberof google.cloud.compute.v1.LocationPolicyLocation
                         * @instance
                         */
                        Object.defineProperty(LocationPolicyLocation.prototype, "_preference", {
                            get: $util.oneOfGetter($oneOfFields = ["preference"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new LocationPolicyLocation instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.LocationPolicyLocation
                         * @static
                         * @param {google.cloud.compute.v1.ILocationPolicyLocation=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.LocationPolicyLocation} LocationPolicyLocation instance
                         */
                        LocationPolicyLocation.create = function create(properties) {
                            return new LocationPolicyLocation(properties);
                        };
    
                        /**
                         * Encodes the specified LocationPolicyLocation message. Does not implicitly {@link google.cloud.compute.v1.LocationPolicyLocation.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.LocationPolicyLocation
                         * @static
                         * @param {google.cloud.compute.v1.ILocationPolicyLocation} message LocationPolicyLocation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocationPolicyLocation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.constraints != null && Object.hasOwnProperty.call(message, "constraints"))
                                $root.google.cloud.compute.v1.LocationPolicyLocationConstraints.encode(message.constraints, writer.uint32(/* id 3909174, wireType 2 =*/31273394).fork()).ldelim();
                            if (message.preference != null && Object.hasOwnProperty.call(message, "preference"))
                                writer.uint32(/* id 150781147, wireType 2 =*/1206249178).string(message.preference);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified LocationPolicyLocation message, length delimited. Does not implicitly {@link google.cloud.compute.v1.LocationPolicyLocation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.LocationPolicyLocation
                         * @static
                         * @param {google.cloud.compute.v1.ILocationPolicyLocation} message LocationPolicyLocation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocationPolicyLocation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a LocationPolicyLocation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.LocationPolicyLocation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.LocationPolicyLocation} LocationPolicyLocation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocationPolicyLocation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.LocationPolicyLocation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3909174: {
                                        message.constraints = $root.google.cloud.compute.v1.LocationPolicyLocationConstraints.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 150781147: {
                                        message.preference = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a LocationPolicyLocation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.LocationPolicyLocation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.LocationPolicyLocation} LocationPolicyLocation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocationPolicyLocation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a LocationPolicyLocation message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.LocationPolicyLocation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LocationPolicyLocation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.constraints != null && message.hasOwnProperty("constraints")) {
                                properties._constraints = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.LocationPolicyLocationConstraints.verify(message.constraints);
                                    if (error)
                                        return "constraints." + error;
                                }
                            }
                            if (message.preference != null && message.hasOwnProperty("preference")) {
                                properties._preference = 1;
                                if (!$util.isString(message.preference))
                                    return "preference: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a LocationPolicyLocation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.LocationPolicyLocation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.LocationPolicyLocation} LocationPolicyLocation
                         */
                        LocationPolicyLocation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.LocationPolicyLocation)
                                return object;
                            var message = new $root.google.cloud.compute.v1.LocationPolicyLocation();
                            if (object.constraints != null) {
                                if (typeof object.constraints !== "object")
                                    throw TypeError(".google.cloud.compute.v1.LocationPolicyLocation.constraints: object expected");
                                message.constraints = $root.google.cloud.compute.v1.LocationPolicyLocationConstraints.fromObject(object.constraints);
                            }
                            if (object.preference != null)
                                message.preference = String(object.preference);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a LocationPolicyLocation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.LocationPolicyLocation
                         * @static
                         * @param {google.cloud.compute.v1.LocationPolicyLocation} message LocationPolicyLocation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LocationPolicyLocation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.constraints != null && message.hasOwnProperty("constraints")) {
                                object.constraints = $root.google.cloud.compute.v1.LocationPolicyLocationConstraints.toObject(message.constraints, options);
                                if (options.oneofs)
                                    object._constraints = "constraints";
                            }
                            if (message.preference != null && message.hasOwnProperty("preference")) {
                                object.preference = message.preference;
                                if (options.oneofs)
                                    object._preference = "preference";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this LocationPolicyLocation to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.LocationPolicyLocation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LocationPolicyLocation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for LocationPolicyLocation
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.LocationPolicyLocation
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        LocationPolicyLocation.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.LocationPolicyLocation";
                        };
    
                        /**
                         * Preference enum.
                         * @name google.cloud.compute.v1.LocationPolicyLocation.Preference
                         * @enum {number}
                         * @property {number} UNDEFINED_PREFERENCE=0 UNDEFINED_PREFERENCE value
                         * @property {number} ALLOW=62368553 ALLOW value
                         * @property {number} DENY=2094604 DENY value
                         * @property {number} PREFERENCE_UNSPECIFIED=496219571 PREFERENCE_UNSPECIFIED value
                         */
                        LocationPolicyLocation.Preference = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PREFERENCE"] = 0;
                            values[valuesById[62368553] = "ALLOW"] = 62368553;
                            values[valuesById[2094604] = "DENY"] = 2094604;
                            values[valuesById[496219571] = "PREFERENCE_UNSPECIFIED"] = 496219571;
                            return values;
                        })();
    
                        return LocationPolicyLocation;
                    })();
    
                    v1.LocationPolicyLocationConstraints = (function() {
    
                        /**
                         * Properties of a LocationPolicyLocationConstraints.
                         * @memberof google.cloud.compute.v1
                         * @interface ILocationPolicyLocationConstraints
                         * @property {number|null} [maxCount] LocationPolicyLocationConstraints maxCount
                         */
    
                        /**
                         * Constructs a new LocationPolicyLocationConstraints.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a LocationPolicyLocationConstraints.
                         * @implements ILocationPolicyLocationConstraints
                         * @constructor
                         * @param {google.cloud.compute.v1.ILocationPolicyLocationConstraints=} [properties] Properties to set
                         */
                        function LocationPolicyLocationConstraints(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * LocationPolicyLocationConstraints maxCount.
                         * @member {number|null|undefined} maxCount
                         * @memberof google.cloud.compute.v1.LocationPolicyLocationConstraints
                         * @instance
                         */
                        LocationPolicyLocationConstraints.prototype.maxCount = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * LocationPolicyLocationConstraints _maxCount.
                         * @member {"maxCount"|undefined} _maxCount
                         * @memberof google.cloud.compute.v1.LocationPolicyLocationConstraints
                         * @instance
                         */
                        Object.defineProperty(LocationPolicyLocationConstraints.prototype, "_maxCount", {
                            get: $util.oneOfGetter($oneOfFields = ["maxCount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new LocationPolicyLocationConstraints instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.LocationPolicyLocationConstraints
                         * @static
                         * @param {google.cloud.compute.v1.ILocationPolicyLocationConstraints=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.LocationPolicyLocationConstraints} LocationPolicyLocationConstraints instance
                         */
                        LocationPolicyLocationConstraints.create = function create(properties) {
                            return new LocationPolicyLocationConstraints(properties);
                        };
    
                        /**
                         * Encodes the specified LocationPolicyLocationConstraints message. Does not implicitly {@link google.cloud.compute.v1.LocationPolicyLocationConstraints.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.LocationPolicyLocationConstraints
                         * @static
                         * @param {google.cloud.compute.v1.ILocationPolicyLocationConstraints} message LocationPolicyLocationConstraints message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocationPolicyLocationConstraints.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.maxCount != null && Object.hasOwnProperty.call(message, "maxCount"))
                                writer.uint32(/* id 287620724, wireType 0 =*/2300965792).int32(message.maxCount);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified LocationPolicyLocationConstraints message, length delimited. Does not implicitly {@link google.cloud.compute.v1.LocationPolicyLocationConstraints.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.LocationPolicyLocationConstraints
                         * @static
                         * @param {google.cloud.compute.v1.ILocationPolicyLocationConstraints} message LocationPolicyLocationConstraints message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LocationPolicyLocationConstraints.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a LocationPolicyLocationConstraints message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.LocationPolicyLocationConstraints
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.LocationPolicyLocationConstraints} LocationPolicyLocationConstraints
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocationPolicyLocationConstraints.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.LocationPolicyLocationConstraints();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 287620724: {
                                        message.maxCount = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a LocationPolicyLocationConstraints message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.LocationPolicyLocationConstraints
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.LocationPolicyLocationConstraints} LocationPolicyLocationConstraints
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LocationPolicyLocationConstraints.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a LocationPolicyLocationConstraints message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.LocationPolicyLocationConstraints
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LocationPolicyLocationConstraints.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.maxCount != null && message.hasOwnProperty("maxCount")) {
                                properties._maxCount = 1;
                                if (!$util.isInteger(message.maxCount))
                                    return "maxCount: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a LocationPolicyLocationConstraints message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.LocationPolicyLocationConstraints
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.LocationPolicyLocationConstraints} LocationPolicyLocationConstraints
                         */
                        LocationPolicyLocationConstraints.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.LocationPolicyLocationConstraints)
                                return object;
                            var message = new $root.google.cloud.compute.v1.LocationPolicyLocationConstraints();
                            if (object.maxCount != null)
                                message.maxCount = object.maxCount | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a LocationPolicyLocationConstraints message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.LocationPolicyLocationConstraints
                         * @static
                         * @param {google.cloud.compute.v1.LocationPolicyLocationConstraints} message LocationPolicyLocationConstraints
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LocationPolicyLocationConstraints.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.maxCount != null && message.hasOwnProperty("maxCount")) {
                                object.maxCount = message.maxCount;
                                if (options.oneofs)
                                    object._maxCount = "maxCount";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this LocationPolicyLocationConstraints to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.LocationPolicyLocationConstraints
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LocationPolicyLocationConstraints.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for LocationPolicyLocationConstraints
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.LocationPolicyLocationConstraints
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        LocationPolicyLocationConstraints.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.LocationPolicyLocationConstraints";
                        };
    
                        return LocationPolicyLocationConstraints;
                    })();
    
                    v1.LogConfig = (function() {
    
                        /**
                         * Properties of a LogConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface ILogConfig
                         * @property {google.cloud.compute.v1.ILogConfigCloudAuditOptions|null} [cloudAudit] LogConfig cloudAudit
                         * @property {google.cloud.compute.v1.ILogConfigCounterOptions|null} [counter] LogConfig counter
                         * @property {google.cloud.compute.v1.ILogConfigDataAccessOptions|null} [dataAccess] LogConfig dataAccess
                         */
    
                        /**
                         * Constructs a new LogConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a LogConfig.
                         * @implements ILogConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.ILogConfig=} [properties] Properties to set
                         */
                        function LogConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * LogConfig cloudAudit.
                         * @member {google.cloud.compute.v1.ILogConfigCloudAuditOptions|null|undefined} cloudAudit
                         * @memberof google.cloud.compute.v1.LogConfig
                         * @instance
                         */
                        LogConfig.prototype.cloudAudit = null;
    
                        /**
                         * LogConfig counter.
                         * @member {google.cloud.compute.v1.ILogConfigCounterOptions|null|undefined} counter
                         * @memberof google.cloud.compute.v1.LogConfig
                         * @instance
                         */
                        LogConfig.prototype.counter = null;
    
                        /**
                         * LogConfig dataAccess.
                         * @member {google.cloud.compute.v1.ILogConfigDataAccessOptions|null|undefined} dataAccess
                         * @memberof google.cloud.compute.v1.LogConfig
                         * @instance
                         */
                        LogConfig.prototype.dataAccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * LogConfig _cloudAudit.
                         * @member {"cloudAudit"|undefined} _cloudAudit
                         * @memberof google.cloud.compute.v1.LogConfig
                         * @instance
                         */
                        Object.defineProperty(LogConfig.prototype, "_cloudAudit", {
                            get: $util.oneOfGetter($oneOfFields = ["cloudAudit"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LogConfig _counter.
                         * @member {"counter"|undefined} _counter
                         * @memberof google.cloud.compute.v1.LogConfig
                         * @instance
                         */
                        Object.defineProperty(LogConfig.prototype, "_counter", {
                            get: $util.oneOfGetter($oneOfFields = ["counter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LogConfig _dataAccess.
                         * @member {"dataAccess"|undefined} _dataAccess
                         * @memberof google.cloud.compute.v1.LogConfig
                         * @instance
                         */
                        Object.defineProperty(LogConfig.prototype, "_dataAccess", {
                            get: $util.oneOfGetter($oneOfFields = ["dataAccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new LogConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.LogConfig
                         * @static
                         * @param {google.cloud.compute.v1.ILogConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.LogConfig} LogConfig instance
                         */
                        LogConfig.create = function create(properties) {
                            return new LogConfig(properties);
                        };
    
                        /**
                         * Encodes the specified LogConfig message. Does not implicitly {@link google.cloud.compute.v1.LogConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.LogConfig
                         * @static
                         * @param {google.cloud.compute.v1.ILogConfig} message LogConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LogConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.dataAccess != null && Object.hasOwnProperty.call(message, "dataAccess"))
                                $root.google.cloud.compute.v1.LogConfigDataAccessOptions.encode(message.dataAccess, writer.uint32(/* id 286633881, wireType 2 =*/2293071050).fork()).ldelim();
                            if (message.cloudAudit != null && Object.hasOwnProperty.call(message, "cloudAudit"))
                                $root.google.cloud.compute.v1.LogConfigCloudAuditOptions.encode(message.cloudAudit, writer.uint32(/* id 412852561, wireType 2 =*/3302820490).fork()).ldelim();
                            if (message.counter != null && Object.hasOwnProperty.call(message, "counter"))
                                $root.google.cloud.compute.v1.LogConfigCounterOptions.encode(message.counter, writer.uint32(/* id 420959740, wireType 2 =*/3367677922).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified LogConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.LogConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.LogConfig
                         * @static
                         * @param {google.cloud.compute.v1.ILogConfig} message LogConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LogConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a LogConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.LogConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.LogConfig} LogConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LogConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.LogConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 412852561: {
                                        message.cloudAudit = $root.google.cloud.compute.v1.LogConfigCloudAuditOptions.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 420959740: {
                                        message.counter = $root.google.cloud.compute.v1.LogConfigCounterOptions.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 286633881: {
                                        message.dataAccess = $root.google.cloud.compute.v1.LogConfigDataAccessOptions.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a LogConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.LogConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.LogConfig} LogConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LogConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a LogConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.LogConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LogConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.cloudAudit != null && message.hasOwnProperty("cloudAudit")) {
                                properties._cloudAudit = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.LogConfigCloudAuditOptions.verify(message.cloudAudit);
                                    if (error)
                                        return "cloudAudit." + error;
                                }
                            }
                            if (message.counter != null && message.hasOwnProperty("counter")) {
                                properties._counter = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.LogConfigCounterOptions.verify(message.counter);
                                    if (error)
                                        return "counter." + error;
                                }
                            }
                            if (message.dataAccess != null && message.hasOwnProperty("dataAccess")) {
                                properties._dataAccess = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.LogConfigDataAccessOptions.verify(message.dataAccess);
                                    if (error)
                                        return "dataAccess." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a LogConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.LogConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.LogConfig} LogConfig
                         */
                        LogConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.LogConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.LogConfig();
                            if (object.cloudAudit != null) {
                                if (typeof object.cloudAudit !== "object")
                                    throw TypeError(".google.cloud.compute.v1.LogConfig.cloudAudit: object expected");
                                message.cloudAudit = $root.google.cloud.compute.v1.LogConfigCloudAuditOptions.fromObject(object.cloudAudit);
                            }
                            if (object.counter != null) {
                                if (typeof object.counter !== "object")
                                    throw TypeError(".google.cloud.compute.v1.LogConfig.counter: object expected");
                                message.counter = $root.google.cloud.compute.v1.LogConfigCounterOptions.fromObject(object.counter);
                            }
                            if (object.dataAccess != null) {
                                if (typeof object.dataAccess !== "object")
                                    throw TypeError(".google.cloud.compute.v1.LogConfig.dataAccess: object expected");
                                message.dataAccess = $root.google.cloud.compute.v1.LogConfigDataAccessOptions.fromObject(object.dataAccess);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a LogConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.LogConfig
                         * @static
                         * @param {google.cloud.compute.v1.LogConfig} message LogConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LogConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.dataAccess != null && message.hasOwnProperty("dataAccess")) {
                                object.dataAccess = $root.google.cloud.compute.v1.LogConfigDataAccessOptions.toObject(message.dataAccess, options);
                                if (options.oneofs)
                                    object._dataAccess = "dataAccess";
                            }
                            if (message.cloudAudit != null && message.hasOwnProperty("cloudAudit")) {
                                object.cloudAudit = $root.google.cloud.compute.v1.LogConfigCloudAuditOptions.toObject(message.cloudAudit, options);
                                if (options.oneofs)
                                    object._cloudAudit = "cloudAudit";
                            }
                            if (message.counter != null && message.hasOwnProperty("counter")) {
                                object.counter = $root.google.cloud.compute.v1.LogConfigCounterOptions.toObject(message.counter, options);
                                if (options.oneofs)
                                    object._counter = "counter";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this LogConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.LogConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LogConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for LogConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.LogConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        LogConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.LogConfig";
                        };
    
                        return LogConfig;
                    })();
    
                    v1.LogConfigCloudAuditOptions = (function() {
    
                        /**
                         * Properties of a LogConfigCloudAuditOptions.
                         * @memberof google.cloud.compute.v1
                         * @interface ILogConfigCloudAuditOptions
                         * @property {google.cloud.compute.v1.IAuthorizationLoggingOptions|null} [authorizationLoggingOptions] LogConfigCloudAuditOptions authorizationLoggingOptions
                         * @property {string|null} [logName] LogConfigCloudAuditOptions logName
                         */
    
                        /**
                         * Constructs a new LogConfigCloudAuditOptions.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a LogConfigCloudAuditOptions.
                         * @implements ILogConfigCloudAuditOptions
                         * @constructor
                         * @param {google.cloud.compute.v1.ILogConfigCloudAuditOptions=} [properties] Properties to set
                         */
                        function LogConfigCloudAuditOptions(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * LogConfigCloudAuditOptions authorizationLoggingOptions.
                         * @member {google.cloud.compute.v1.IAuthorizationLoggingOptions|null|undefined} authorizationLoggingOptions
                         * @memberof google.cloud.compute.v1.LogConfigCloudAuditOptions
                         * @instance
                         */
                        LogConfigCloudAuditOptions.prototype.authorizationLoggingOptions = null;
    
                        /**
                         * LogConfigCloudAuditOptions logName.
                         * @member {string|null|undefined} logName
                         * @memberof google.cloud.compute.v1.LogConfigCloudAuditOptions
                         * @instance
                         */
                        LogConfigCloudAuditOptions.prototype.logName = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * LogConfigCloudAuditOptions _authorizationLoggingOptions.
                         * @member {"authorizationLoggingOptions"|undefined} _authorizationLoggingOptions
                         * @memberof google.cloud.compute.v1.LogConfigCloudAuditOptions
                         * @instance
                         */
                        Object.defineProperty(LogConfigCloudAuditOptions.prototype, "_authorizationLoggingOptions", {
                            get: $util.oneOfGetter($oneOfFields = ["authorizationLoggingOptions"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LogConfigCloudAuditOptions _logName.
                         * @member {"logName"|undefined} _logName
                         * @memberof google.cloud.compute.v1.LogConfigCloudAuditOptions
                         * @instance
                         */
                        Object.defineProperty(LogConfigCloudAuditOptions.prototype, "_logName", {
                            get: $util.oneOfGetter($oneOfFields = ["logName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new LogConfigCloudAuditOptions instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.LogConfigCloudAuditOptions
                         * @static
                         * @param {google.cloud.compute.v1.ILogConfigCloudAuditOptions=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.LogConfigCloudAuditOptions} LogConfigCloudAuditOptions instance
                         */
                        LogConfigCloudAuditOptions.create = function create(properties) {
                            return new LogConfigCloudAuditOptions(properties);
                        };
    
                        /**
                         * Encodes the specified LogConfigCloudAuditOptions message. Does not implicitly {@link google.cloud.compute.v1.LogConfigCloudAuditOptions.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.LogConfigCloudAuditOptions
                         * @static
                         * @param {google.cloud.compute.v1.ILogConfigCloudAuditOptions} message LogConfigCloudAuditOptions message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LogConfigCloudAuditOptions.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.authorizationLoggingOptions != null && Object.hasOwnProperty.call(message, "authorizationLoggingOptions"))
                                $root.google.cloud.compute.v1.AuthorizationLoggingOptions.encode(message.authorizationLoggingOptions, writer.uint32(/* id 217861624, wireType 2 =*/1742892994).fork()).ldelim();
                            if (message.logName != null && Object.hasOwnProperty.call(message, "logName"))
                                writer.uint32(/* id 402913958, wireType 2 =*/3223311666).string(message.logName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified LogConfigCloudAuditOptions message, length delimited. Does not implicitly {@link google.cloud.compute.v1.LogConfigCloudAuditOptions.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.LogConfigCloudAuditOptions
                         * @static
                         * @param {google.cloud.compute.v1.ILogConfigCloudAuditOptions} message LogConfigCloudAuditOptions message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LogConfigCloudAuditOptions.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a LogConfigCloudAuditOptions message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.LogConfigCloudAuditOptions
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.LogConfigCloudAuditOptions} LogConfigCloudAuditOptions
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LogConfigCloudAuditOptions.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.LogConfigCloudAuditOptions();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 217861624: {
                                        message.authorizationLoggingOptions = $root.google.cloud.compute.v1.AuthorizationLoggingOptions.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 402913958: {
                                        message.logName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a LogConfigCloudAuditOptions message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.LogConfigCloudAuditOptions
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.LogConfigCloudAuditOptions} LogConfigCloudAuditOptions
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LogConfigCloudAuditOptions.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a LogConfigCloudAuditOptions message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.LogConfigCloudAuditOptions
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LogConfigCloudAuditOptions.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.authorizationLoggingOptions != null && message.hasOwnProperty("authorizationLoggingOptions")) {
                                properties._authorizationLoggingOptions = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.AuthorizationLoggingOptions.verify(message.authorizationLoggingOptions);
                                    if (error)
                                        return "authorizationLoggingOptions." + error;
                                }
                            }
                            if (message.logName != null && message.hasOwnProperty("logName")) {
                                properties._logName = 1;
                                if (!$util.isString(message.logName))
                                    return "logName: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a LogConfigCloudAuditOptions message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.LogConfigCloudAuditOptions
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.LogConfigCloudAuditOptions} LogConfigCloudAuditOptions
                         */
                        LogConfigCloudAuditOptions.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.LogConfigCloudAuditOptions)
                                return object;
                            var message = new $root.google.cloud.compute.v1.LogConfigCloudAuditOptions();
                            if (object.authorizationLoggingOptions != null) {
                                if (typeof object.authorizationLoggingOptions !== "object")
                                    throw TypeError(".google.cloud.compute.v1.LogConfigCloudAuditOptions.authorizationLoggingOptions: object expected");
                                message.authorizationLoggingOptions = $root.google.cloud.compute.v1.AuthorizationLoggingOptions.fromObject(object.authorizationLoggingOptions);
                            }
                            if (object.logName != null)
                                message.logName = String(object.logName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a LogConfigCloudAuditOptions message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.LogConfigCloudAuditOptions
                         * @static
                         * @param {google.cloud.compute.v1.LogConfigCloudAuditOptions} message LogConfigCloudAuditOptions
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LogConfigCloudAuditOptions.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.authorizationLoggingOptions != null && message.hasOwnProperty("authorizationLoggingOptions")) {
                                object.authorizationLoggingOptions = $root.google.cloud.compute.v1.AuthorizationLoggingOptions.toObject(message.authorizationLoggingOptions, options);
                                if (options.oneofs)
                                    object._authorizationLoggingOptions = "authorizationLoggingOptions";
                            }
                            if (message.logName != null && message.hasOwnProperty("logName")) {
                                object.logName = message.logName;
                                if (options.oneofs)
                                    object._logName = "logName";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this LogConfigCloudAuditOptions to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.LogConfigCloudAuditOptions
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LogConfigCloudAuditOptions.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for LogConfigCloudAuditOptions
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.LogConfigCloudAuditOptions
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        LogConfigCloudAuditOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.LogConfigCloudAuditOptions";
                        };
    
                        /**
                         * LogName enum.
                         * @name google.cloud.compute.v1.LogConfigCloudAuditOptions.LogName
                         * @enum {number}
                         * @property {number} UNDEFINED_LOG_NAME=0 UNDEFINED_LOG_NAME value
                         * @property {number} ADMIN_ACTIVITY=427503135 ADMIN_ACTIVITY value
                         * @property {number} DATA_ACCESS=238070681 DATA_ACCESS value
                         * @property {number} UNSPECIFIED_LOG_NAME=410515182 UNSPECIFIED_LOG_NAME value
                         */
                        LogConfigCloudAuditOptions.LogName = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_LOG_NAME"] = 0;
                            values[valuesById[427503135] = "ADMIN_ACTIVITY"] = 427503135;
                            values[valuesById[238070681] = "DATA_ACCESS"] = 238070681;
                            values[valuesById[410515182] = "UNSPECIFIED_LOG_NAME"] = 410515182;
                            return values;
                        })();
    
                        return LogConfigCloudAuditOptions;
                    })();
    
                    v1.LogConfigCounterOptions = (function() {
    
                        /**
                         * Properties of a LogConfigCounterOptions.
                         * @memberof google.cloud.compute.v1
                         * @interface ILogConfigCounterOptions
                         * @property {Array.<google.cloud.compute.v1.ILogConfigCounterOptionsCustomField>|null} [customFields] LogConfigCounterOptions customFields
                         * @property {string|null} [field] LogConfigCounterOptions field
                         * @property {string|null} [metric] LogConfigCounterOptions metric
                         */
    
                        /**
                         * Constructs a new LogConfigCounterOptions.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a LogConfigCounterOptions.
                         * @implements ILogConfigCounterOptions
                         * @constructor
                         * @param {google.cloud.compute.v1.ILogConfigCounterOptions=} [properties] Properties to set
                         */
                        function LogConfigCounterOptions(properties) {
                            this.customFields = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * LogConfigCounterOptions customFields.
                         * @member {Array.<google.cloud.compute.v1.ILogConfigCounterOptionsCustomField>} customFields
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptions
                         * @instance
                         */
                        LogConfigCounterOptions.prototype.customFields = $util.emptyArray;
    
                        /**
                         * LogConfigCounterOptions field.
                         * @member {string|null|undefined} field
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptions
                         * @instance
                         */
                        LogConfigCounterOptions.prototype.field = null;
    
                        /**
                         * LogConfigCounterOptions metric.
                         * @member {string|null|undefined} metric
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptions
                         * @instance
                         */
                        LogConfigCounterOptions.prototype.metric = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * LogConfigCounterOptions _field.
                         * @member {"field"|undefined} _field
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptions
                         * @instance
                         */
                        Object.defineProperty(LogConfigCounterOptions.prototype, "_field", {
                            get: $util.oneOfGetter($oneOfFields = ["field"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LogConfigCounterOptions _metric.
                         * @member {"metric"|undefined} _metric
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptions
                         * @instance
                         */
                        Object.defineProperty(LogConfigCounterOptions.prototype, "_metric", {
                            get: $util.oneOfGetter($oneOfFields = ["metric"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new LogConfigCounterOptions instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptions
                         * @static
                         * @param {google.cloud.compute.v1.ILogConfigCounterOptions=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.LogConfigCounterOptions} LogConfigCounterOptions instance
                         */
                        LogConfigCounterOptions.create = function create(properties) {
                            return new LogConfigCounterOptions(properties);
                        };
    
                        /**
                         * Encodes the specified LogConfigCounterOptions message. Does not implicitly {@link google.cloud.compute.v1.LogConfigCounterOptions.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptions
                         * @static
                         * @param {google.cloud.compute.v1.ILogConfigCounterOptions} message LogConfigCounterOptions message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LogConfigCounterOptions.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.field != null && Object.hasOwnProperty.call(message, "field"))
                                writer.uint32(/* id 97427706, wireType 2 =*/779421650).string(message.field);
                            if (message.customFields != null && message.customFields.length)
                                for (var i = 0; i < message.customFields.length; ++i)
                                    $root.google.cloud.compute.v1.LogConfigCounterOptionsCustomField.encode(message.customFields[i], writer.uint32(/* id 249651015, wireType 2 =*/1997208122).fork()).ldelim();
                            if (message.metric != null && Object.hasOwnProperty.call(message, "metric"))
                                writer.uint32(/* id 533067184, wireType 2 =*/4264537474).string(message.metric);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified LogConfigCounterOptions message, length delimited. Does not implicitly {@link google.cloud.compute.v1.LogConfigCounterOptions.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptions
                         * @static
                         * @param {google.cloud.compute.v1.ILogConfigCounterOptions} message LogConfigCounterOptions message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LogConfigCounterOptions.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a LogConfigCounterOptions message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptions
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.LogConfigCounterOptions} LogConfigCounterOptions
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LogConfigCounterOptions.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.LogConfigCounterOptions();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249651015: {
                                        if (!(message.customFields && message.customFields.length))
                                            message.customFields = [];
                                        message.customFields.push($root.google.cloud.compute.v1.LogConfigCounterOptionsCustomField.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 97427706: {
                                        message.field = reader.string();
                                        break;
                                    }
                                case 533067184: {
                                        message.metric = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a LogConfigCounterOptions message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptions
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.LogConfigCounterOptions} LogConfigCounterOptions
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LogConfigCounterOptions.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a LogConfigCounterOptions message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptions
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LogConfigCounterOptions.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.customFields != null && message.hasOwnProperty("customFields")) {
                                if (!Array.isArray(message.customFields))
                                    return "customFields: array expected";
                                for (var i = 0; i < message.customFields.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.LogConfigCounterOptionsCustomField.verify(message.customFields[i]);
                                    if (error)
                                        return "customFields." + error;
                                }
                            }
                            if (message.field != null && message.hasOwnProperty("field")) {
                                properties._field = 1;
                                if (!$util.isString(message.field))
                                    return "field: string expected";
                            }
                            if (message.metric != null && message.hasOwnProperty("metric")) {
                                properties._metric = 1;
                                if (!$util.isString(message.metric))
                                    return "metric: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a LogConfigCounterOptions message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptions
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.LogConfigCounterOptions} LogConfigCounterOptions
                         */
                        LogConfigCounterOptions.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.LogConfigCounterOptions)
                                return object;
                            var message = new $root.google.cloud.compute.v1.LogConfigCounterOptions();
                            if (object.customFields) {
                                if (!Array.isArray(object.customFields))
                                    throw TypeError(".google.cloud.compute.v1.LogConfigCounterOptions.customFields: array expected");
                                message.customFields = [];
                                for (var i = 0; i < object.customFields.length; ++i) {
                                    if (typeof object.customFields[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.LogConfigCounterOptions.customFields: object expected");
                                    message.customFields[i] = $root.google.cloud.compute.v1.LogConfigCounterOptionsCustomField.fromObject(object.customFields[i]);
                                }
                            }
                            if (object.field != null)
                                message.field = String(object.field);
                            if (object.metric != null)
                                message.metric = String(object.metric);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a LogConfigCounterOptions message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptions
                         * @static
                         * @param {google.cloud.compute.v1.LogConfigCounterOptions} message LogConfigCounterOptions
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LogConfigCounterOptions.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.customFields = [];
                            if (message.field != null && message.hasOwnProperty("field")) {
                                object.field = message.field;
                                if (options.oneofs)
                                    object._field = "field";
                            }
                            if (message.customFields && message.customFields.length) {
                                object.customFields = [];
                                for (var j = 0; j < message.customFields.length; ++j)
                                    object.customFields[j] = $root.google.cloud.compute.v1.LogConfigCounterOptionsCustomField.toObject(message.customFields[j], options);
                            }
                            if (message.metric != null && message.hasOwnProperty("metric")) {
                                object.metric = message.metric;
                                if (options.oneofs)
                                    object._metric = "metric";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this LogConfigCounterOptions to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptions
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LogConfigCounterOptions.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for LogConfigCounterOptions
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptions
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        LogConfigCounterOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.LogConfigCounterOptions";
                        };
    
                        return LogConfigCounterOptions;
                    })();
    
                    v1.LogConfigCounterOptionsCustomField = (function() {
    
                        /**
                         * Properties of a LogConfigCounterOptionsCustomField.
                         * @memberof google.cloud.compute.v1
                         * @interface ILogConfigCounterOptionsCustomField
                         * @property {string|null} [name] LogConfigCounterOptionsCustomField name
                         * @property {string|null} [value] LogConfigCounterOptionsCustomField value
                         */
    
                        /**
                         * Constructs a new LogConfigCounterOptionsCustomField.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a LogConfigCounterOptionsCustomField.
                         * @implements ILogConfigCounterOptionsCustomField
                         * @constructor
                         * @param {google.cloud.compute.v1.ILogConfigCounterOptionsCustomField=} [properties] Properties to set
                         */
                        function LogConfigCounterOptionsCustomField(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * LogConfigCounterOptionsCustomField name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptionsCustomField
                         * @instance
                         */
                        LogConfigCounterOptionsCustomField.prototype.name = null;
    
                        /**
                         * LogConfigCounterOptionsCustomField value.
                         * @member {string|null|undefined} value
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptionsCustomField
                         * @instance
                         */
                        LogConfigCounterOptionsCustomField.prototype.value = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * LogConfigCounterOptionsCustomField _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptionsCustomField
                         * @instance
                         */
                        Object.defineProperty(LogConfigCounterOptionsCustomField.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * LogConfigCounterOptionsCustomField _value.
                         * @member {"value"|undefined} _value
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptionsCustomField
                         * @instance
                         */
                        Object.defineProperty(LogConfigCounterOptionsCustomField.prototype, "_value", {
                            get: $util.oneOfGetter($oneOfFields = ["value"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new LogConfigCounterOptionsCustomField instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptionsCustomField
                         * @static
                         * @param {google.cloud.compute.v1.ILogConfigCounterOptionsCustomField=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.LogConfigCounterOptionsCustomField} LogConfigCounterOptionsCustomField instance
                         */
                        LogConfigCounterOptionsCustomField.create = function create(properties) {
                            return new LogConfigCounterOptionsCustomField(properties);
                        };
    
                        /**
                         * Encodes the specified LogConfigCounterOptionsCustomField message. Does not implicitly {@link google.cloud.compute.v1.LogConfigCounterOptionsCustomField.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptionsCustomField
                         * @static
                         * @param {google.cloud.compute.v1.ILogConfigCounterOptionsCustomField} message LogConfigCounterOptionsCustomField message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LogConfigCounterOptionsCustomField.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                writer.uint32(/* id 111972721, wireType 2 =*/895781770).string(message.value);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified LogConfigCounterOptionsCustomField message, length delimited. Does not implicitly {@link google.cloud.compute.v1.LogConfigCounterOptionsCustomField.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptionsCustomField
                         * @static
                         * @param {google.cloud.compute.v1.ILogConfigCounterOptionsCustomField} message LogConfigCounterOptionsCustomField message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LogConfigCounterOptionsCustomField.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a LogConfigCounterOptionsCustomField message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptionsCustomField
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.LogConfigCounterOptionsCustomField} LogConfigCounterOptionsCustomField
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LogConfigCounterOptionsCustomField.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.LogConfigCounterOptionsCustomField();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 111972721: {
                                        message.value = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a LogConfigCounterOptionsCustomField message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptionsCustomField
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.LogConfigCounterOptionsCustomField} LogConfigCounterOptionsCustomField
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LogConfigCounterOptionsCustomField.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a LogConfigCounterOptionsCustomField message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptionsCustomField
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LogConfigCounterOptionsCustomField.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                properties._value = 1;
                                if (!$util.isString(message.value))
                                    return "value: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a LogConfigCounterOptionsCustomField message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptionsCustomField
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.LogConfigCounterOptionsCustomField} LogConfigCounterOptionsCustomField
                         */
                        LogConfigCounterOptionsCustomField.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.LogConfigCounterOptionsCustomField)
                                return object;
                            var message = new $root.google.cloud.compute.v1.LogConfigCounterOptionsCustomField();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.value != null)
                                message.value = String(object.value);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a LogConfigCounterOptionsCustomField message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptionsCustomField
                         * @static
                         * @param {google.cloud.compute.v1.LogConfigCounterOptionsCustomField} message LogConfigCounterOptionsCustomField
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LogConfigCounterOptionsCustomField.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                object.value = message.value;
                                if (options.oneofs)
                                    object._value = "value";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this LogConfigCounterOptionsCustomField to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptionsCustomField
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LogConfigCounterOptionsCustomField.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for LogConfigCounterOptionsCustomField
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.LogConfigCounterOptionsCustomField
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        LogConfigCounterOptionsCustomField.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.LogConfigCounterOptionsCustomField";
                        };
    
                        return LogConfigCounterOptionsCustomField;
                    })();
    
                    v1.LogConfigDataAccessOptions = (function() {
    
                        /**
                         * Properties of a LogConfigDataAccessOptions.
                         * @memberof google.cloud.compute.v1
                         * @interface ILogConfigDataAccessOptions
                         * @property {string|null} [logMode] LogConfigDataAccessOptions logMode
                         */
    
                        /**
                         * Constructs a new LogConfigDataAccessOptions.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a LogConfigDataAccessOptions.
                         * @implements ILogConfigDataAccessOptions
                         * @constructor
                         * @param {google.cloud.compute.v1.ILogConfigDataAccessOptions=} [properties] Properties to set
                         */
                        function LogConfigDataAccessOptions(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * LogConfigDataAccessOptions logMode.
                         * @member {string|null|undefined} logMode
                         * @memberof google.cloud.compute.v1.LogConfigDataAccessOptions
                         * @instance
                         */
                        LogConfigDataAccessOptions.prototype.logMode = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * LogConfigDataAccessOptions _logMode.
                         * @member {"logMode"|undefined} _logMode
                         * @memberof google.cloud.compute.v1.LogConfigDataAccessOptions
                         * @instance
                         */
                        Object.defineProperty(LogConfigDataAccessOptions.prototype, "_logMode", {
                            get: $util.oneOfGetter($oneOfFields = ["logMode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new LogConfigDataAccessOptions instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.LogConfigDataAccessOptions
                         * @static
                         * @param {google.cloud.compute.v1.ILogConfigDataAccessOptions=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.LogConfigDataAccessOptions} LogConfigDataAccessOptions instance
                         */
                        LogConfigDataAccessOptions.create = function create(properties) {
                            return new LogConfigDataAccessOptions(properties);
                        };
    
                        /**
                         * Encodes the specified LogConfigDataAccessOptions message. Does not implicitly {@link google.cloud.compute.v1.LogConfigDataAccessOptions.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.LogConfigDataAccessOptions
                         * @static
                         * @param {google.cloud.compute.v1.ILogConfigDataAccessOptions} message LogConfigDataAccessOptions message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LogConfigDataAccessOptions.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.logMode != null && Object.hasOwnProperty.call(message, "logMode"))
                                writer.uint32(/* id 402897342, wireType 2 =*/3223178738).string(message.logMode);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified LogConfigDataAccessOptions message, length delimited. Does not implicitly {@link google.cloud.compute.v1.LogConfigDataAccessOptions.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.LogConfigDataAccessOptions
                         * @static
                         * @param {google.cloud.compute.v1.ILogConfigDataAccessOptions} message LogConfigDataAccessOptions message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        LogConfigDataAccessOptions.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a LogConfigDataAccessOptions message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.LogConfigDataAccessOptions
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.LogConfigDataAccessOptions} LogConfigDataAccessOptions
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LogConfigDataAccessOptions.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.LogConfigDataAccessOptions();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 402897342: {
                                        message.logMode = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a LogConfigDataAccessOptions message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.LogConfigDataAccessOptions
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.LogConfigDataAccessOptions} LogConfigDataAccessOptions
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        LogConfigDataAccessOptions.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a LogConfigDataAccessOptions message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.LogConfigDataAccessOptions
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        LogConfigDataAccessOptions.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.logMode != null && message.hasOwnProperty("logMode")) {
                                properties._logMode = 1;
                                if (!$util.isString(message.logMode))
                                    return "logMode: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a LogConfigDataAccessOptions message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.LogConfigDataAccessOptions
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.LogConfigDataAccessOptions} LogConfigDataAccessOptions
                         */
                        LogConfigDataAccessOptions.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.LogConfigDataAccessOptions)
                                return object;
                            var message = new $root.google.cloud.compute.v1.LogConfigDataAccessOptions();
                            if (object.logMode != null)
                                message.logMode = String(object.logMode);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a LogConfigDataAccessOptions message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.LogConfigDataAccessOptions
                         * @static
                         * @param {google.cloud.compute.v1.LogConfigDataAccessOptions} message LogConfigDataAccessOptions
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        LogConfigDataAccessOptions.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.logMode != null && message.hasOwnProperty("logMode")) {
                                object.logMode = message.logMode;
                                if (options.oneofs)
                                    object._logMode = "logMode";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this LogConfigDataAccessOptions to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.LogConfigDataAccessOptions
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        LogConfigDataAccessOptions.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for LogConfigDataAccessOptions
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.LogConfigDataAccessOptions
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        LogConfigDataAccessOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.LogConfigDataAccessOptions";
                        };
    
                        /**
                         * LogMode enum.
                         * @name google.cloud.compute.v1.LogConfigDataAccessOptions.LogMode
                         * @enum {number}
                         * @property {number} UNDEFINED_LOG_MODE=0 UNDEFINED_LOG_MODE value
                         * @property {number} LOG_FAIL_CLOSED=360469778 LOG_FAIL_CLOSED value
                         * @property {number} LOG_MODE_UNSPECIFIED=88160822 LOG_MODE_UNSPECIFIED value
                         */
                        LogConfigDataAccessOptions.LogMode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_LOG_MODE"] = 0;
                            values[valuesById[360469778] = "LOG_FAIL_CLOSED"] = 360469778;
                            values[valuesById[88160822] = "LOG_MODE_UNSPECIFIED"] = 88160822;
                            return values;
                        })();
    
                        return LogConfigDataAccessOptions;
                    })();
    
                    v1.MachineImage = (function() {
    
                        /**
                         * Properties of a MachineImage.
                         * @memberof google.cloud.compute.v1
                         * @interface IMachineImage
                         * @property {string|null} [creationTimestamp] MachineImage creationTimestamp
                         * @property {string|null} [description] MachineImage description
                         * @property {boolean|null} [guestFlush] MachineImage guestFlush
                         * @property {number|Long|null} [id] MachineImage id
                         * @property {google.cloud.compute.v1.IInstanceProperties|null} [instanceProperties] MachineImage instanceProperties
                         * @property {string|null} [kind] MachineImage kind
                         * @property {google.cloud.compute.v1.ICustomerEncryptionKey|null} [machineImageEncryptionKey] MachineImage machineImageEncryptionKey
                         * @property {string|null} [name] MachineImage name
                         * @property {boolean|null} [satisfiesPzs] MachineImage satisfiesPzs
                         * @property {Array.<google.cloud.compute.v1.ISavedDisk>|null} [savedDisks] MachineImage savedDisks
                         * @property {string|null} [selfLink] MachineImage selfLink
                         * @property {Array.<google.cloud.compute.v1.ISourceDiskEncryptionKey>|null} [sourceDiskEncryptionKeys] MachineImage sourceDiskEncryptionKeys
                         * @property {string|null} [sourceInstance] MachineImage sourceInstance
                         * @property {google.cloud.compute.v1.ISourceInstanceProperties|null} [sourceInstanceProperties] MachineImage sourceInstanceProperties
                         * @property {string|null} [status] MachineImage status
                         * @property {Array.<string>|null} [storageLocations] MachineImage storageLocations
                         * @property {number|Long|null} [totalStorageBytes] MachineImage totalStorageBytes
                         */
    
                        /**
                         * Constructs a new MachineImage.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a MachineImage.
                         * @implements IMachineImage
                         * @constructor
                         * @param {google.cloud.compute.v1.IMachineImage=} [properties] Properties to set
                         */
                        function MachineImage(properties) {
                            this.savedDisks = [];
                            this.sourceDiskEncryptionKeys = [];
                            this.storageLocations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * MachineImage creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        MachineImage.prototype.creationTimestamp = null;
    
                        /**
                         * MachineImage description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        MachineImage.prototype.description = null;
    
                        /**
                         * MachineImage guestFlush.
                         * @member {boolean|null|undefined} guestFlush
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        MachineImage.prototype.guestFlush = null;
    
                        /**
                         * MachineImage id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        MachineImage.prototype.id = null;
    
                        /**
                         * MachineImage instanceProperties.
                         * @member {google.cloud.compute.v1.IInstanceProperties|null|undefined} instanceProperties
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        MachineImage.prototype.instanceProperties = null;
    
                        /**
                         * MachineImage kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        MachineImage.prototype.kind = null;
    
                        /**
                         * MachineImage machineImageEncryptionKey.
                         * @member {google.cloud.compute.v1.ICustomerEncryptionKey|null|undefined} machineImageEncryptionKey
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        MachineImage.prototype.machineImageEncryptionKey = null;
    
                        /**
                         * MachineImage name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        MachineImage.prototype.name = null;
    
                        /**
                         * MachineImage satisfiesPzs.
                         * @member {boolean|null|undefined} satisfiesPzs
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        MachineImage.prototype.satisfiesPzs = null;
    
                        /**
                         * MachineImage savedDisks.
                         * @member {Array.<google.cloud.compute.v1.ISavedDisk>} savedDisks
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        MachineImage.prototype.savedDisks = $util.emptyArray;
    
                        /**
                         * MachineImage selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        MachineImage.prototype.selfLink = null;
    
                        /**
                         * MachineImage sourceDiskEncryptionKeys.
                         * @member {Array.<google.cloud.compute.v1.ISourceDiskEncryptionKey>} sourceDiskEncryptionKeys
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        MachineImage.prototype.sourceDiskEncryptionKeys = $util.emptyArray;
    
                        /**
                         * MachineImage sourceInstance.
                         * @member {string|null|undefined} sourceInstance
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        MachineImage.prototype.sourceInstance = null;
    
                        /**
                         * MachineImage sourceInstanceProperties.
                         * @member {google.cloud.compute.v1.ISourceInstanceProperties|null|undefined} sourceInstanceProperties
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        MachineImage.prototype.sourceInstanceProperties = null;
    
                        /**
                         * MachineImage status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        MachineImage.prototype.status = null;
    
                        /**
                         * MachineImage storageLocations.
                         * @member {Array.<string>} storageLocations
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        MachineImage.prototype.storageLocations = $util.emptyArray;
    
                        /**
                         * MachineImage totalStorageBytes.
                         * @member {number|Long|null|undefined} totalStorageBytes
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        MachineImage.prototype.totalStorageBytes = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * MachineImage _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        Object.defineProperty(MachineImage.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineImage _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        Object.defineProperty(MachineImage.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineImage _guestFlush.
                         * @member {"guestFlush"|undefined} _guestFlush
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        Object.defineProperty(MachineImage.prototype, "_guestFlush", {
                            get: $util.oneOfGetter($oneOfFields = ["guestFlush"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineImage _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        Object.defineProperty(MachineImage.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineImage _instanceProperties.
                         * @member {"instanceProperties"|undefined} _instanceProperties
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        Object.defineProperty(MachineImage.prototype, "_instanceProperties", {
                            get: $util.oneOfGetter($oneOfFields = ["instanceProperties"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineImage _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        Object.defineProperty(MachineImage.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineImage _machineImageEncryptionKey.
                         * @member {"machineImageEncryptionKey"|undefined} _machineImageEncryptionKey
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        Object.defineProperty(MachineImage.prototype, "_machineImageEncryptionKey", {
                            get: $util.oneOfGetter($oneOfFields = ["machineImageEncryptionKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineImage _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        Object.defineProperty(MachineImage.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineImage _satisfiesPzs.
                         * @member {"satisfiesPzs"|undefined} _satisfiesPzs
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        Object.defineProperty(MachineImage.prototype, "_satisfiesPzs", {
                            get: $util.oneOfGetter($oneOfFields = ["satisfiesPzs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineImage _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        Object.defineProperty(MachineImage.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineImage _sourceInstance.
                         * @member {"sourceInstance"|undefined} _sourceInstance
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        Object.defineProperty(MachineImage.prototype, "_sourceInstance", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceInstance"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineImage _sourceInstanceProperties.
                         * @member {"sourceInstanceProperties"|undefined} _sourceInstanceProperties
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        Object.defineProperty(MachineImage.prototype, "_sourceInstanceProperties", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceInstanceProperties"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineImage _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        Object.defineProperty(MachineImage.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineImage _totalStorageBytes.
                         * @member {"totalStorageBytes"|undefined} _totalStorageBytes
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         */
                        Object.defineProperty(MachineImage.prototype, "_totalStorageBytes", {
                            get: $util.oneOfGetter($oneOfFields = ["totalStorageBytes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new MachineImage instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @static
                         * @param {google.cloud.compute.v1.IMachineImage=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.MachineImage} MachineImage instance
                         */
                        MachineImage.create = function create(properties) {
                            return new MachineImage(properties);
                        };
    
                        /**
                         * Encodes the specified MachineImage message. Does not implicitly {@link google.cloud.compute.v1.MachineImage.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @static
                         * @param {google.cloud.compute.v1.IMachineImage} message MachineImage message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MachineImage.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.totalStorageBytes != null && Object.hasOwnProperty.call(message, "totalStorageBytes"))
                                writer.uint32(/* id 81855468, wireType 0 =*/654843744).int64(message.totalStorageBytes);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.instanceProperties != null && Object.hasOwnProperty.call(message, "instanceProperties"))
                                $root.google.cloud.compute.v1.InstanceProperties.encode(message.instanceProperties, writer.uint32(/* id 215355165, wireType 2 =*/1722841322).fork()).ldelim();
                            if (message.storageLocations != null && message.storageLocations.length)
                                for (var i = 0; i < message.storageLocations.length; ++i)
                                    writer.uint32(/* id 328005274, wireType 2 =*/2624042194).string(message.storageLocations[i]);
                            if (message.sourceDiskEncryptionKeys != null && message.sourceDiskEncryptionKeys.length)
                                for (var i = 0; i < message.sourceDiskEncryptionKeys.length; ++i)
                                    $root.google.cloud.compute.v1.SourceDiskEncryptionKey.encode(message.sourceDiskEncryptionKeys[i], writer.uint32(/* id 370408498, wireType 2 =*/2963267986).fork()).ldelim();
                            if (message.guestFlush != null && Object.hasOwnProperty.call(message, "guestFlush"))
                                writer.uint32(/* id 385550813, wireType 0 =*/3084406504).bool(message.guestFlush);
                            if (message.sourceInstance != null && Object.hasOwnProperty.call(message, "sourceInstance"))
                                writer.uint32(/* id 396315705, wireType 2 =*/3170525642).string(message.sourceInstance);
                            if (message.savedDisks != null && message.savedDisks.length)
                                for (var i = 0; i < message.savedDisks.length; ++i)
                                    $root.google.cloud.compute.v1.SavedDisk.encode(message.savedDisks[i], writer.uint32(/* id 397424318, wireType 2 =*/3179394546).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.sourceInstanceProperties != null && Object.hasOwnProperty.call(message, "sourceInstanceProperties"))
                                $root.google.cloud.compute.v1.SourceInstanceProperties.encode(message.sourceInstanceProperties, writer.uint32(/* id 475195641, wireType 2 =*/3801565130).fork()).ldelim();
                            if (message.satisfiesPzs != null && Object.hasOwnProperty.call(message, "satisfiesPzs"))
                                writer.uint32(/* id 480964267, wireType 0 =*/3847714136).bool(message.satisfiesPzs);
                            if (message.machineImageEncryptionKey != null && Object.hasOwnProperty.call(message, "machineImageEncryptionKey"))
                                $root.google.cloud.compute.v1.CustomerEncryptionKey.encode(message.machineImageEncryptionKey, writer.uint32(/* id 528089087, wireType 2 =*/4224712698).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified MachineImage message, length delimited. Does not implicitly {@link google.cloud.compute.v1.MachineImage.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @static
                         * @param {google.cloud.compute.v1.IMachineImage} message MachineImage message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MachineImage.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a MachineImage message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.MachineImage} MachineImage
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MachineImage.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.MachineImage();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 385550813: {
                                        message.guestFlush = reader.bool();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 215355165: {
                                        message.instanceProperties = $root.google.cloud.compute.v1.InstanceProperties.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 528089087: {
                                        message.machineImageEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 480964267: {
                                        message.satisfiesPzs = reader.bool();
                                        break;
                                    }
                                case 397424318: {
                                        if (!(message.savedDisks && message.savedDisks.length))
                                            message.savedDisks = [];
                                        message.savedDisks.push($root.google.cloud.compute.v1.SavedDisk.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 370408498: {
                                        if (!(message.sourceDiskEncryptionKeys && message.sourceDiskEncryptionKeys.length))
                                            message.sourceDiskEncryptionKeys = [];
                                        message.sourceDiskEncryptionKeys.push($root.google.cloud.compute.v1.SourceDiskEncryptionKey.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 396315705: {
                                        message.sourceInstance = reader.string();
                                        break;
                                    }
                                case 475195641: {
                                        message.sourceInstanceProperties = $root.google.cloud.compute.v1.SourceInstanceProperties.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                case 328005274: {
                                        if (!(message.storageLocations && message.storageLocations.length))
                                            message.storageLocations = [];
                                        message.storageLocations.push(reader.string());
                                        break;
                                    }
                                case 81855468: {
                                        message.totalStorageBytes = reader.int64();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a MachineImage message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.MachineImage} MachineImage
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MachineImage.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a MachineImage message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MachineImage.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.guestFlush != null && message.hasOwnProperty("guestFlush")) {
                                properties._guestFlush = 1;
                                if (typeof message.guestFlush !== "boolean")
                                    return "guestFlush: boolean expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.instanceProperties != null && message.hasOwnProperty("instanceProperties")) {
                                properties._instanceProperties = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InstanceProperties.verify(message.instanceProperties);
                                    if (error)
                                        return "instanceProperties." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.machineImageEncryptionKey != null && message.hasOwnProperty("machineImageEncryptionKey")) {
                                properties._machineImageEncryptionKey = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.CustomerEncryptionKey.verify(message.machineImageEncryptionKey);
                                    if (error)
                                        return "machineImageEncryptionKey." + error;
                                }
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.satisfiesPzs != null && message.hasOwnProperty("satisfiesPzs")) {
                                properties._satisfiesPzs = 1;
                                if (typeof message.satisfiesPzs !== "boolean")
                                    return "satisfiesPzs: boolean expected";
                            }
                            if (message.savedDisks != null && message.hasOwnProperty("savedDisks")) {
                                if (!Array.isArray(message.savedDisks))
                                    return "savedDisks: array expected";
                                for (var i = 0; i < message.savedDisks.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.SavedDisk.verify(message.savedDisks[i]);
                                    if (error)
                                        return "savedDisks." + error;
                                }
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.sourceDiskEncryptionKeys != null && message.hasOwnProperty("sourceDiskEncryptionKeys")) {
                                if (!Array.isArray(message.sourceDiskEncryptionKeys))
                                    return "sourceDiskEncryptionKeys: array expected";
                                for (var i = 0; i < message.sourceDiskEncryptionKeys.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.SourceDiskEncryptionKey.verify(message.sourceDiskEncryptionKeys[i]);
                                    if (error)
                                        return "sourceDiskEncryptionKeys." + error;
                                }
                            }
                            if (message.sourceInstance != null && message.hasOwnProperty("sourceInstance")) {
                                properties._sourceInstance = 1;
                                if (!$util.isString(message.sourceInstance))
                                    return "sourceInstance: string expected";
                            }
                            if (message.sourceInstanceProperties != null && message.hasOwnProperty("sourceInstanceProperties")) {
                                properties._sourceInstanceProperties = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SourceInstanceProperties.verify(message.sourceInstanceProperties);
                                    if (error)
                                        return "sourceInstanceProperties." + error;
                                }
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            if (message.storageLocations != null && message.hasOwnProperty("storageLocations")) {
                                if (!Array.isArray(message.storageLocations))
                                    return "storageLocations: array expected";
                                for (var i = 0; i < message.storageLocations.length; ++i)
                                    if (!$util.isString(message.storageLocations[i]))
                                        return "storageLocations: string[] expected";
                            }
                            if (message.totalStorageBytes != null && message.hasOwnProperty("totalStorageBytes")) {
                                properties._totalStorageBytes = 1;
                                if (!$util.isInteger(message.totalStorageBytes) && !(message.totalStorageBytes && $util.isInteger(message.totalStorageBytes.low) && $util.isInteger(message.totalStorageBytes.high)))
                                    return "totalStorageBytes: integer|Long expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a MachineImage message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.MachineImage} MachineImage
                         */
                        MachineImage.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.MachineImage)
                                return object;
                            var message = new $root.google.cloud.compute.v1.MachineImage();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.guestFlush != null)
                                message.guestFlush = Boolean(object.guestFlush);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.instanceProperties != null) {
                                if (typeof object.instanceProperties !== "object")
                                    throw TypeError(".google.cloud.compute.v1.MachineImage.instanceProperties: object expected");
                                message.instanceProperties = $root.google.cloud.compute.v1.InstanceProperties.fromObject(object.instanceProperties);
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.machineImageEncryptionKey != null) {
                                if (typeof object.machineImageEncryptionKey !== "object")
                                    throw TypeError(".google.cloud.compute.v1.MachineImage.machineImageEncryptionKey: object expected");
                                message.machineImageEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.fromObject(object.machineImageEncryptionKey);
                            }
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.satisfiesPzs != null)
                                message.satisfiesPzs = Boolean(object.satisfiesPzs);
                            if (object.savedDisks) {
                                if (!Array.isArray(object.savedDisks))
                                    throw TypeError(".google.cloud.compute.v1.MachineImage.savedDisks: array expected");
                                message.savedDisks = [];
                                for (var i = 0; i < object.savedDisks.length; ++i) {
                                    if (typeof object.savedDisks[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.MachineImage.savedDisks: object expected");
                                    message.savedDisks[i] = $root.google.cloud.compute.v1.SavedDisk.fromObject(object.savedDisks[i]);
                                }
                            }
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.sourceDiskEncryptionKeys) {
                                if (!Array.isArray(object.sourceDiskEncryptionKeys))
                                    throw TypeError(".google.cloud.compute.v1.MachineImage.sourceDiskEncryptionKeys: array expected");
                                message.sourceDiskEncryptionKeys = [];
                                for (var i = 0; i < object.sourceDiskEncryptionKeys.length; ++i) {
                                    if (typeof object.sourceDiskEncryptionKeys[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.MachineImage.sourceDiskEncryptionKeys: object expected");
                                    message.sourceDiskEncryptionKeys[i] = $root.google.cloud.compute.v1.SourceDiskEncryptionKey.fromObject(object.sourceDiskEncryptionKeys[i]);
                                }
                            }
                            if (object.sourceInstance != null)
                                message.sourceInstance = String(object.sourceInstance);
                            if (object.sourceInstanceProperties != null) {
                                if (typeof object.sourceInstanceProperties !== "object")
                                    throw TypeError(".google.cloud.compute.v1.MachineImage.sourceInstanceProperties: object expected");
                                message.sourceInstanceProperties = $root.google.cloud.compute.v1.SourceInstanceProperties.fromObject(object.sourceInstanceProperties);
                            }
                            if (object.status != null)
                                message.status = String(object.status);
                            if (object.storageLocations) {
                                if (!Array.isArray(object.storageLocations))
                                    throw TypeError(".google.cloud.compute.v1.MachineImage.storageLocations: array expected");
                                message.storageLocations = [];
                                for (var i = 0; i < object.storageLocations.length; ++i)
                                    message.storageLocations[i] = String(object.storageLocations[i]);
                            }
                            if (object.totalStorageBytes != null)
                                if ($util.Long)
                                    (message.totalStorageBytes = $util.Long.fromValue(object.totalStorageBytes)).unsigned = false;
                                else if (typeof object.totalStorageBytes === "string")
                                    message.totalStorageBytes = parseInt(object.totalStorageBytes, 10);
                                else if (typeof object.totalStorageBytes === "number")
                                    message.totalStorageBytes = object.totalStorageBytes;
                                else if (typeof object.totalStorageBytes === "object")
                                    message.totalStorageBytes = new $util.LongBits(object.totalStorageBytes.low >>> 0, object.totalStorageBytes.high >>> 0).toNumber();
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a MachineImage message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @static
                         * @param {google.cloud.compute.v1.MachineImage} message MachineImage
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MachineImage.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.storageLocations = [];
                                object.sourceDiskEncryptionKeys = [];
                                object.savedDisks = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.totalStorageBytes != null && message.hasOwnProperty("totalStorageBytes")) {
                                if (typeof message.totalStorageBytes === "number")
                                    object.totalStorageBytes = options.longs === String ? String(message.totalStorageBytes) : message.totalStorageBytes;
                                else
                                    object.totalStorageBytes = options.longs === String ? $util.Long.prototype.toString.call(message.totalStorageBytes) : options.longs === Number ? new $util.LongBits(message.totalStorageBytes.low >>> 0, message.totalStorageBytes.high >>> 0).toNumber() : message.totalStorageBytes;
                                if (options.oneofs)
                                    object._totalStorageBytes = "totalStorageBytes";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.instanceProperties != null && message.hasOwnProperty("instanceProperties")) {
                                object.instanceProperties = $root.google.cloud.compute.v1.InstanceProperties.toObject(message.instanceProperties, options);
                                if (options.oneofs)
                                    object._instanceProperties = "instanceProperties";
                            }
                            if (message.storageLocations && message.storageLocations.length) {
                                object.storageLocations = [];
                                for (var j = 0; j < message.storageLocations.length; ++j)
                                    object.storageLocations[j] = message.storageLocations[j];
                            }
                            if (message.sourceDiskEncryptionKeys && message.sourceDiskEncryptionKeys.length) {
                                object.sourceDiskEncryptionKeys = [];
                                for (var j = 0; j < message.sourceDiskEncryptionKeys.length; ++j)
                                    object.sourceDiskEncryptionKeys[j] = $root.google.cloud.compute.v1.SourceDiskEncryptionKey.toObject(message.sourceDiskEncryptionKeys[j], options);
                            }
                            if (message.guestFlush != null && message.hasOwnProperty("guestFlush")) {
                                object.guestFlush = message.guestFlush;
                                if (options.oneofs)
                                    object._guestFlush = "guestFlush";
                            }
                            if (message.sourceInstance != null && message.hasOwnProperty("sourceInstance")) {
                                object.sourceInstance = message.sourceInstance;
                                if (options.oneofs)
                                    object._sourceInstance = "sourceInstance";
                            }
                            if (message.savedDisks && message.savedDisks.length) {
                                object.savedDisks = [];
                                for (var j = 0; j < message.savedDisks.length; ++j)
                                    object.savedDisks[j] = $root.google.cloud.compute.v1.SavedDisk.toObject(message.savedDisks[j], options);
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.sourceInstanceProperties != null && message.hasOwnProperty("sourceInstanceProperties")) {
                                object.sourceInstanceProperties = $root.google.cloud.compute.v1.SourceInstanceProperties.toObject(message.sourceInstanceProperties, options);
                                if (options.oneofs)
                                    object._sourceInstanceProperties = "sourceInstanceProperties";
                            }
                            if (message.satisfiesPzs != null && message.hasOwnProperty("satisfiesPzs")) {
                                object.satisfiesPzs = message.satisfiesPzs;
                                if (options.oneofs)
                                    object._satisfiesPzs = "satisfiesPzs";
                            }
                            if (message.machineImageEncryptionKey != null && message.hasOwnProperty("machineImageEncryptionKey")) {
                                object.machineImageEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.toObject(message.machineImageEncryptionKey, options);
                                if (options.oneofs)
                                    object._machineImageEncryptionKey = "machineImageEncryptionKey";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this MachineImage to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MachineImage.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for MachineImage
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.MachineImage
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        MachineImage.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.MachineImage";
                        };
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.MachineImage.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} CREATING=455564985 CREATING value
                         * @property {number} DELETING=528602024 DELETING value
                         * @property {number} INVALID=530283991 INVALID value
                         * @property {number} READY=77848963 READY value
                         * @property {number} UPLOADING=267603489 UPLOADING value
                         */
                        MachineImage.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[455564985] = "CREATING"] = 455564985;
                            values[valuesById[528602024] = "DELETING"] = 528602024;
                            values[valuesById[530283991] = "INVALID"] = 530283991;
                            values[valuesById[77848963] = "READY"] = 77848963;
                            values[valuesById[267603489] = "UPLOADING"] = 267603489;
                            return values;
                        })();
    
                        return MachineImage;
                    })();
    
                    v1.MachineImageList = (function() {
    
                        /**
                         * Properties of a MachineImageList.
                         * @memberof google.cloud.compute.v1
                         * @interface IMachineImageList
                         * @property {string|null} [id] MachineImageList id
                         * @property {Array.<google.cloud.compute.v1.IMachineImage>|null} [items] MachineImageList items
                         * @property {string|null} [kind] MachineImageList kind
                         * @property {string|null} [nextPageToken] MachineImageList nextPageToken
                         * @property {string|null} [selfLink] MachineImageList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] MachineImageList warning
                         */
    
                        /**
                         * Constructs a new MachineImageList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a MachineImageList.
                         * @implements IMachineImageList
                         * @constructor
                         * @param {google.cloud.compute.v1.IMachineImageList=} [properties] Properties to set
                         */
                        function MachineImageList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * MachineImageList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @instance
                         */
                        MachineImageList.prototype.id = null;
    
                        /**
                         * MachineImageList items.
                         * @member {Array.<google.cloud.compute.v1.IMachineImage>} items
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @instance
                         */
                        MachineImageList.prototype.items = $util.emptyArray;
    
                        /**
                         * MachineImageList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @instance
                         */
                        MachineImageList.prototype.kind = null;
    
                        /**
                         * MachineImageList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @instance
                         */
                        MachineImageList.prototype.nextPageToken = null;
    
                        /**
                         * MachineImageList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @instance
                         */
                        MachineImageList.prototype.selfLink = null;
    
                        /**
                         * MachineImageList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @instance
                         */
                        MachineImageList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * MachineImageList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @instance
                         */
                        Object.defineProperty(MachineImageList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineImageList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @instance
                         */
                        Object.defineProperty(MachineImageList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineImageList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @instance
                         */
                        Object.defineProperty(MachineImageList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineImageList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @instance
                         */
                        Object.defineProperty(MachineImageList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineImageList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @instance
                         */
                        Object.defineProperty(MachineImageList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new MachineImageList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @static
                         * @param {google.cloud.compute.v1.IMachineImageList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.MachineImageList} MachineImageList instance
                         */
                        MachineImageList.create = function create(properties) {
                            return new MachineImageList(properties);
                        };
    
                        /**
                         * Encodes the specified MachineImageList message. Does not implicitly {@link google.cloud.compute.v1.MachineImageList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @static
                         * @param {google.cloud.compute.v1.IMachineImageList} message MachineImageList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MachineImageList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.MachineImage.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified MachineImageList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.MachineImageList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @static
                         * @param {google.cloud.compute.v1.IMachineImageList} message MachineImageList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MachineImageList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a MachineImageList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.MachineImageList} MachineImageList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MachineImageList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.MachineImageList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.MachineImage.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a MachineImageList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.MachineImageList} MachineImageList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MachineImageList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a MachineImageList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MachineImageList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.MachineImage.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a MachineImageList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.MachineImageList} MachineImageList
                         */
                        MachineImageList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.MachineImageList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.MachineImageList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.MachineImageList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.MachineImageList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.MachineImage.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.MachineImageList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a MachineImageList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @static
                         * @param {google.cloud.compute.v1.MachineImageList} message MachineImageList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MachineImageList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.MachineImage.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this MachineImageList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MachineImageList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for MachineImageList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.MachineImageList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        MachineImageList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.MachineImageList";
                        };
    
                        return MachineImageList;
                    })();
    
                    v1.MachineType = (function() {
    
                        /**
                         * Properties of a MachineType.
                         * @memberof google.cloud.compute.v1
                         * @interface IMachineType
                         * @property {Array.<google.cloud.compute.v1.IAccelerators>|null} [accelerators] MachineType accelerators
                         * @property {string|null} [creationTimestamp] MachineType creationTimestamp
                         * @property {google.cloud.compute.v1.IDeprecationStatus|null} [deprecated] MachineType deprecated
                         * @property {string|null} [description] MachineType description
                         * @property {number|null} [guestCpus] MachineType guestCpus
                         * @property {number|Long|null} [id] MachineType id
                         * @property {number|null} [imageSpaceGb] MachineType imageSpaceGb
                         * @property {boolean|null} [isSharedCpu] MachineType isSharedCpu
                         * @property {string|null} [kind] MachineType kind
                         * @property {number|null} [maximumPersistentDisks] MachineType maximumPersistentDisks
                         * @property {number|Long|null} [maximumPersistentDisksSizeGb] MachineType maximumPersistentDisksSizeGb
                         * @property {number|null} [memoryMb] MachineType memoryMb
                         * @property {string|null} [name] MachineType name
                         * @property {Array.<google.cloud.compute.v1.IScratchDisks>|null} [scratchDisks] MachineType scratchDisks
                         * @property {string|null} [selfLink] MachineType selfLink
                         * @property {string|null} [zone] MachineType zone
                         */
    
                        /**
                         * Constructs a new MachineType.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a MachineType.
                         * @implements IMachineType
                         * @constructor
                         * @param {google.cloud.compute.v1.IMachineType=} [properties] Properties to set
                         */
                        function MachineType(properties) {
                            this.accelerators = [];
                            this.scratchDisks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * MachineType accelerators.
                         * @member {Array.<google.cloud.compute.v1.IAccelerators>} accelerators
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        MachineType.prototype.accelerators = $util.emptyArray;
    
                        /**
                         * MachineType creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        MachineType.prototype.creationTimestamp = null;
    
                        /**
                         * MachineType deprecated.
                         * @member {google.cloud.compute.v1.IDeprecationStatus|null|undefined} deprecated
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        MachineType.prototype.deprecated = null;
    
                        /**
                         * MachineType description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        MachineType.prototype.description = null;
    
                        /**
                         * MachineType guestCpus.
                         * @member {number|null|undefined} guestCpus
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        MachineType.prototype.guestCpus = null;
    
                        /**
                         * MachineType id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        MachineType.prototype.id = null;
    
                        /**
                         * MachineType imageSpaceGb.
                         * @member {number|null|undefined} imageSpaceGb
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        MachineType.prototype.imageSpaceGb = null;
    
                        /**
                         * MachineType isSharedCpu.
                         * @member {boolean|null|undefined} isSharedCpu
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        MachineType.prototype.isSharedCpu = null;
    
                        /**
                         * MachineType kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        MachineType.prototype.kind = null;
    
                        /**
                         * MachineType maximumPersistentDisks.
                         * @member {number|null|undefined} maximumPersistentDisks
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        MachineType.prototype.maximumPersistentDisks = null;
    
                        /**
                         * MachineType maximumPersistentDisksSizeGb.
                         * @member {number|Long|null|undefined} maximumPersistentDisksSizeGb
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        MachineType.prototype.maximumPersistentDisksSizeGb = null;
    
                        /**
                         * MachineType memoryMb.
                         * @member {number|null|undefined} memoryMb
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        MachineType.prototype.memoryMb = null;
    
                        /**
                         * MachineType name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        MachineType.prototype.name = null;
    
                        /**
                         * MachineType scratchDisks.
                         * @member {Array.<google.cloud.compute.v1.IScratchDisks>} scratchDisks
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        MachineType.prototype.scratchDisks = $util.emptyArray;
    
                        /**
                         * MachineType selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        MachineType.prototype.selfLink = null;
    
                        /**
                         * MachineType zone.
                         * @member {string|null|undefined} zone
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        MachineType.prototype.zone = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * MachineType _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        Object.defineProperty(MachineType.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineType _deprecated.
                         * @member {"deprecated"|undefined} _deprecated
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        Object.defineProperty(MachineType.prototype, "_deprecated", {
                            get: $util.oneOfGetter($oneOfFields = ["deprecated"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineType _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        Object.defineProperty(MachineType.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineType _guestCpus.
                         * @member {"guestCpus"|undefined} _guestCpus
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        Object.defineProperty(MachineType.prototype, "_guestCpus", {
                            get: $util.oneOfGetter($oneOfFields = ["guestCpus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineType _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        Object.defineProperty(MachineType.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineType _imageSpaceGb.
                         * @member {"imageSpaceGb"|undefined} _imageSpaceGb
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        Object.defineProperty(MachineType.prototype, "_imageSpaceGb", {
                            get: $util.oneOfGetter($oneOfFields = ["imageSpaceGb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineType _isSharedCpu.
                         * @member {"isSharedCpu"|undefined} _isSharedCpu
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        Object.defineProperty(MachineType.prototype, "_isSharedCpu", {
                            get: $util.oneOfGetter($oneOfFields = ["isSharedCpu"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineType _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        Object.defineProperty(MachineType.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineType _maximumPersistentDisks.
                         * @member {"maximumPersistentDisks"|undefined} _maximumPersistentDisks
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        Object.defineProperty(MachineType.prototype, "_maximumPersistentDisks", {
                            get: $util.oneOfGetter($oneOfFields = ["maximumPersistentDisks"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineType _maximumPersistentDisksSizeGb.
                         * @member {"maximumPersistentDisksSizeGb"|undefined} _maximumPersistentDisksSizeGb
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        Object.defineProperty(MachineType.prototype, "_maximumPersistentDisksSizeGb", {
                            get: $util.oneOfGetter($oneOfFields = ["maximumPersistentDisksSizeGb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineType _memoryMb.
                         * @member {"memoryMb"|undefined} _memoryMb
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        Object.defineProperty(MachineType.prototype, "_memoryMb", {
                            get: $util.oneOfGetter($oneOfFields = ["memoryMb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineType _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        Object.defineProperty(MachineType.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineType _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        Object.defineProperty(MachineType.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineType _zone.
                         * @member {"zone"|undefined} _zone
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         */
                        Object.defineProperty(MachineType.prototype, "_zone", {
                            get: $util.oneOfGetter($oneOfFields = ["zone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new MachineType instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.MachineType
                         * @static
                         * @param {google.cloud.compute.v1.IMachineType=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.MachineType} MachineType instance
                         */
                        MachineType.create = function create(properties) {
                            return new MachineType(properties);
                        };
    
                        /**
                         * Encodes the specified MachineType message. Does not implicitly {@link google.cloud.compute.v1.MachineType.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.MachineType
                         * @static
                         * @param {google.cloud.compute.v1.IMachineType} message MachineType message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MachineType.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.imageSpaceGb != null && Object.hasOwnProperty.call(message, "imageSpaceGb"))
                                writer.uint32(/* id 75331864, wireType 0 =*/602654912).int32(message.imageSpaceGb);
                            if (message.memoryMb != null && Object.hasOwnProperty.call(message, "memoryMb"))
                                writer.uint32(/* id 116001171, wireType 0 =*/928009368).int32(message.memoryMb);
                            if (message.maximumPersistentDisksSizeGb != null && Object.hasOwnProperty.call(message, "maximumPersistentDisksSizeGb"))
                                writer.uint32(/* id 154274471, wireType 0 =*/1234195768).int64(message.maximumPersistentDisksSizeGb);
                            if (message.accelerators != null && message.accelerators.length)
                                for (var i = 0; i < message.accelerators.length; ++i)
                                    $root.google.cloud.compute.v1.Accelerators.encode(message.accelerators[i], writer.uint32(/* id 269577064, wireType 2 =*/2156616514).fork()).ldelim();
                            if (message.guestCpus != null && Object.hasOwnProperty.call(message, "guestCpus"))
                                writer.uint32(/* id 393356754, wireType 0 =*/3146854032).int32(message.guestCpus);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.scratchDisks != null && message.scratchDisks.length)
                                for (var i = 0; i < message.scratchDisks.length; ++i)
                                    $root.google.cloud.compute.v1.ScratchDisks.encode(message.scratchDisks[i], writer.uint32(/* id 480778481, wireType 2 =*/3846227850).fork()).ldelim();
                            if (message.maximumPersistentDisks != null && Object.hasOwnProperty.call(message, "maximumPersistentDisks"))
                                writer.uint32(/* id 496220941, wireType 0 =*/3969767528).int32(message.maximumPersistentDisks);
                            if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                                $root.google.cloud.compute.v1.DeprecationStatus.encode(message.deprecated, writer.uint32(/* id 515138995, wireType 2 =*/4121111962).fork()).ldelim();
                            if (message.isSharedCpu != null && Object.hasOwnProperty.call(message, "isSharedCpu"))
                                writer.uint32(/* id 521399555, wireType 0 =*/4171196440).bool(message.isSharedCpu);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified MachineType message, length delimited. Does not implicitly {@link google.cloud.compute.v1.MachineType.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.MachineType
                         * @static
                         * @param {google.cloud.compute.v1.IMachineType} message MachineType message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MachineType.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a MachineType message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.MachineType
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.MachineType} MachineType
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MachineType.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.MachineType();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 269577064: {
                                        if (!(message.accelerators && message.accelerators.length))
                                            message.accelerators = [];
                                        message.accelerators.push($root.google.cloud.compute.v1.Accelerators.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 515138995: {
                                        message.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 393356754: {
                                        message.guestCpus = reader.int32();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 75331864: {
                                        message.imageSpaceGb = reader.int32();
                                        break;
                                    }
                                case 521399555: {
                                        message.isSharedCpu = reader.bool();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 496220941: {
                                        message.maximumPersistentDisks = reader.int32();
                                        break;
                                    }
                                case 154274471: {
                                        message.maximumPersistentDisksSizeGb = reader.int64();
                                        break;
                                    }
                                case 116001171: {
                                        message.memoryMb = reader.int32();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 480778481: {
                                        if (!(message.scratchDisks && message.scratchDisks.length))
                                            message.scratchDisks = [];
                                        message.scratchDisks.push($root.google.cloud.compute.v1.ScratchDisks.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a MachineType message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.MachineType
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.MachineType} MachineType
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MachineType.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a MachineType message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.MachineType
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MachineType.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.accelerators != null && message.hasOwnProperty("accelerators")) {
                                if (!Array.isArray(message.accelerators))
                                    return "accelerators: array expected";
                                for (var i = 0; i < message.accelerators.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Accelerators.verify(message.accelerators[i]);
                                    if (error)
                                        return "accelerators." + error;
                                }
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.deprecated != null && message.hasOwnProperty("deprecated")) {
                                properties._deprecated = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.DeprecationStatus.verify(message.deprecated);
                                    if (error)
                                        return "deprecated." + error;
                                }
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.guestCpus != null && message.hasOwnProperty("guestCpus")) {
                                properties._guestCpus = 1;
                                if (!$util.isInteger(message.guestCpus))
                                    return "guestCpus: integer expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.imageSpaceGb != null && message.hasOwnProperty("imageSpaceGb")) {
                                properties._imageSpaceGb = 1;
                                if (!$util.isInteger(message.imageSpaceGb))
                                    return "imageSpaceGb: integer expected";
                            }
                            if (message.isSharedCpu != null && message.hasOwnProperty("isSharedCpu")) {
                                properties._isSharedCpu = 1;
                                if (typeof message.isSharedCpu !== "boolean")
                                    return "isSharedCpu: boolean expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.maximumPersistentDisks != null && message.hasOwnProperty("maximumPersistentDisks")) {
                                properties._maximumPersistentDisks = 1;
                                if (!$util.isInteger(message.maximumPersistentDisks))
                                    return "maximumPersistentDisks: integer expected";
                            }
                            if (message.maximumPersistentDisksSizeGb != null && message.hasOwnProperty("maximumPersistentDisksSizeGb")) {
                                properties._maximumPersistentDisksSizeGb = 1;
                                if (!$util.isInteger(message.maximumPersistentDisksSizeGb) && !(message.maximumPersistentDisksSizeGb && $util.isInteger(message.maximumPersistentDisksSizeGb.low) && $util.isInteger(message.maximumPersistentDisksSizeGb.high)))
                                    return "maximumPersistentDisksSizeGb: integer|Long expected";
                            }
                            if (message.memoryMb != null && message.hasOwnProperty("memoryMb")) {
                                properties._memoryMb = 1;
                                if (!$util.isInteger(message.memoryMb))
                                    return "memoryMb: integer expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.scratchDisks != null && message.hasOwnProperty("scratchDisks")) {
                                if (!Array.isArray(message.scratchDisks))
                                    return "scratchDisks: array expected";
                                for (var i = 0; i < message.scratchDisks.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ScratchDisks.verify(message.scratchDisks[i]);
                                    if (error)
                                        return "scratchDisks." + error;
                                }
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                properties._zone = 1;
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a MachineType message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.MachineType
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.MachineType} MachineType
                         */
                        MachineType.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.MachineType)
                                return object;
                            var message = new $root.google.cloud.compute.v1.MachineType();
                            if (object.accelerators) {
                                if (!Array.isArray(object.accelerators))
                                    throw TypeError(".google.cloud.compute.v1.MachineType.accelerators: array expected");
                                message.accelerators = [];
                                for (var i = 0; i < object.accelerators.length; ++i) {
                                    if (typeof object.accelerators[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.MachineType.accelerators: object expected");
                                    message.accelerators[i] = $root.google.cloud.compute.v1.Accelerators.fromObject(object.accelerators[i]);
                                }
                            }
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.deprecated != null) {
                                if (typeof object.deprecated !== "object")
                                    throw TypeError(".google.cloud.compute.v1.MachineType.deprecated: object expected");
                                message.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.fromObject(object.deprecated);
                            }
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.guestCpus != null)
                                message.guestCpus = object.guestCpus | 0;
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.imageSpaceGb != null)
                                message.imageSpaceGb = object.imageSpaceGb | 0;
                            if (object.isSharedCpu != null)
                                message.isSharedCpu = Boolean(object.isSharedCpu);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.maximumPersistentDisks != null)
                                message.maximumPersistentDisks = object.maximumPersistentDisks | 0;
                            if (object.maximumPersistentDisksSizeGb != null)
                                if ($util.Long)
                                    (message.maximumPersistentDisksSizeGb = $util.Long.fromValue(object.maximumPersistentDisksSizeGb)).unsigned = false;
                                else if (typeof object.maximumPersistentDisksSizeGb === "string")
                                    message.maximumPersistentDisksSizeGb = parseInt(object.maximumPersistentDisksSizeGb, 10);
                                else if (typeof object.maximumPersistentDisksSizeGb === "number")
                                    message.maximumPersistentDisksSizeGb = object.maximumPersistentDisksSizeGb;
                                else if (typeof object.maximumPersistentDisksSizeGb === "object")
                                    message.maximumPersistentDisksSizeGb = new $util.LongBits(object.maximumPersistentDisksSizeGb.low >>> 0, object.maximumPersistentDisksSizeGb.high >>> 0).toNumber();
                            if (object.memoryMb != null)
                                message.memoryMb = object.memoryMb | 0;
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.scratchDisks) {
                                if (!Array.isArray(object.scratchDisks))
                                    throw TypeError(".google.cloud.compute.v1.MachineType.scratchDisks: array expected");
                                message.scratchDisks = [];
                                for (var i = 0; i < object.scratchDisks.length; ++i) {
                                    if (typeof object.scratchDisks[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.MachineType.scratchDisks: object expected");
                                    message.scratchDisks[i] = $root.google.cloud.compute.v1.ScratchDisks.fromObject(object.scratchDisks[i]);
                                }
                            }
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a MachineType message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.MachineType
                         * @static
                         * @param {google.cloud.compute.v1.MachineType} message MachineType
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MachineType.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.accelerators = [];
                                object.scratchDisks = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                object.zone = message.zone;
                                if (options.oneofs)
                                    object._zone = "zone";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.imageSpaceGb != null && message.hasOwnProperty("imageSpaceGb")) {
                                object.imageSpaceGb = message.imageSpaceGb;
                                if (options.oneofs)
                                    object._imageSpaceGb = "imageSpaceGb";
                            }
                            if (message.memoryMb != null && message.hasOwnProperty("memoryMb")) {
                                object.memoryMb = message.memoryMb;
                                if (options.oneofs)
                                    object._memoryMb = "memoryMb";
                            }
                            if (message.maximumPersistentDisksSizeGb != null && message.hasOwnProperty("maximumPersistentDisksSizeGb")) {
                                if (typeof message.maximumPersistentDisksSizeGb === "number")
                                    object.maximumPersistentDisksSizeGb = options.longs === String ? String(message.maximumPersistentDisksSizeGb) : message.maximumPersistentDisksSizeGb;
                                else
                                    object.maximumPersistentDisksSizeGb = options.longs === String ? $util.Long.prototype.toString.call(message.maximumPersistentDisksSizeGb) : options.longs === Number ? new $util.LongBits(message.maximumPersistentDisksSizeGb.low >>> 0, message.maximumPersistentDisksSizeGb.high >>> 0).toNumber() : message.maximumPersistentDisksSizeGb;
                                if (options.oneofs)
                                    object._maximumPersistentDisksSizeGb = "maximumPersistentDisksSizeGb";
                            }
                            if (message.accelerators && message.accelerators.length) {
                                object.accelerators = [];
                                for (var j = 0; j < message.accelerators.length; ++j)
                                    object.accelerators[j] = $root.google.cloud.compute.v1.Accelerators.toObject(message.accelerators[j], options);
                            }
                            if (message.guestCpus != null && message.hasOwnProperty("guestCpus")) {
                                object.guestCpus = message.guestCpus;
                                if (options.oneofs)
                                    object._guestCpus = "guestCpus";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.scratchDisks && message.scratchDisks.length) {
                                object.scratchDisks = [];
                                for (var j = 0; j < message.scratchDisks.length; ++j)
                                    object.scratchDisks[j] = $root.google.cloud.compute.v1.ScratchDisks.toObject(message.scratchDisks[j], options);
                            }
                            if (message.maximumPersistentDisks != null && message.hasOwnProperty("maximumPersistentDisks")) {
                                object.maximumPersistentDisks = message.maximumPersistentDisks;
                                if (options.oneofs)
                                    object._maximumPersistentDisks = "maximumPersistentDisks";
                            }
                            if (message.deprecated != null && message.hasOwnProperty("deprecated")) {
                                object.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.toObject(message.deprecated, options);
                                if (options.oneofs)
                                    object._deprecated = "deprecated";
                            }
                            if (message.isSharedCpu != null && message.hasOwnProperty("isSharedCpu")) {
                                object.isSharedCpu = message.isSharedCpu;
                                if (options.oneofs)
                                    object._isSharedCpu = "isSharedCpu";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this MachineType to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.MachineType
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MachineType.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for MachineType
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.MachineType
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        MachineType.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.MachineType";
                        };
    
                        return MachineType;
                    })();
    
                    v1.MachineTypeAggregatedList = (function() {
    
                        /**
                         * Properties of a MachineTypeAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IMachineTypeAggregatedList
                         * @property {string|null} [id] MachineTypeAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IMachineTypesScopedList>|null} [items] MachineTypeAggregatedList items
                         * @property {string|null} [kind] MachineTypeAggregatedList kind
                         * @property {string|null} [nextPageToken] MachineTypeAggregatedList nextPageToken
                         * @property {string|null} [selfLink] MachineTypeAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] MachineTypeAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] MachineTypeAggregatedList warning
                         */
    
                        /**
                         * Constructs a new MachineTypeAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a MachineTypeAggregatedList.
                         * @implements IMachineTypeAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IMachineTypeAggregatedList=} [properties] Properties to set
                         */
                        function MachineTypeAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * MachineTypeAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @instance
                         */
                        MachineTypeAggregatedList.prototype.id = null;
    
                        /**
                         * MachineTypeAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IMachineTypesScopedList>} items
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @instance
                         */
                        MachineTypeAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * MachineTypeAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @instance
                         */
                        MachineTypeAggregatedList.prototype.kind = null;
    
                        /**
                         * MachineTypeAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @instance
                         */
                        MachineTypeAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * MachineTypeAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @instance
                         */
                        MachineTypeAggregatedList.prototype.selfLink = null;
    
                        /**
                         * MachineTypeAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @instance
                         */
                        MachineTypeAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * MachineTypeAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @instance
                         */
                        MachineTypeAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * MachineTypeAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @instance
                         */
                        Object.defineProperty(MachineTypeAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineTypeAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @instance
                         */
                        Object.defineProperty(MachineTypeAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineTypeAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @instance
                         */
                        Object.defineProperty(MachineTypeAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineTypeAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @instance
                         */
                        Object.defineProperty(MachineTypeAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineTypeAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @instance
                         */
                        Object.defineProperty(MachineTypeAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new MachineTypeAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IMachineTypeAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.MachineTypeAggregatedList} MachineTypeAggregatedList instance
                         */
                        MachineTypeAggregatedList.create = function create(properties) {
                            return new MachineTypeAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified MachineTypeAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.MachineTypeAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IMachineTypeAggregatedList} message MachineTypeAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MachineTypeAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.MachineTypesScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified MachineTypeAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.MachineTypeAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IMachineTypeAggregatedList} message MachineTypeAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MachineTypeAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a MachineTypeAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.MachineTypeAggregatedList} MachineTypeAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MachineTypeAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.MachineTypeAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.MachineTypesScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a MachineTypeAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.MachineTypeAggregatedList} MachineTypeAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MachineTypeAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a MachineTypeAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MachineTypeAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.MachineTypesScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a MachineTypeAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.MachineTypeAggregatedList} MachineTypeAggregatedList
                         */
                        MachineTypeAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.MachineTypeAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.MachineTypeAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.MachineTypeAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.MachineTypeAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.MachineTypesScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.MachineTypeAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.MachineTypeAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a MachineTypeAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.MachineTypeAggregatedList} message MachineTypeAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MachineTypeAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.MachineTypesScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this MachineTypeAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MachineTypeAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for MachineTypeAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.MachineTypeAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        MachineTypeAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.MachineTypeAggregatedList";
                        };
    
                        return MachineTypeAggregatedList;
                    })();
    
                    v1.MachineTypeList = (function() {
    
                        /**
                         * Properties of a MachineTypeList.
                         * @memberof google.cloud.compute.v1
                         * @interface IMachineTypeList
                         * @property {string|null} [id] MachineTypeList id
                         * @property {Array.<google.cloud.compute.v1.IMachineType>|null} [items] MachineTypeList items
                         * @property {string|null} [kind] MachineTypeList kind
                         * @property {string|null} [nextPageToken] MachineTypeList nextPageToken
                         * @property {string|null} [selfLink] MachineTypeList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] MachineTypeList warning
                         */
    
                        /**
                         * Constructs a new MachineTypeList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a MachineTypeList.
                         * @implements IMachineTypeList
                         * @constructor
                         * @param {google.cloud.compute.v1.IMachineTypeList=} [properties] Properties to set
                         */
                        function MachineTypeList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * MachineTypeList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @instance
                         */
                        MachineTypeList.prototype.id = null;
    
                        /**
                         * MachineTypeList items.
                         * @member {Array.<google.cloud.compute.v1.IMachineType>} items
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @instance
                         */
                        MachineTypeList.prototype.items = $util.emptyArray;
    
                        /**
                         * MachineTypeList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @instance
                         */
                        MachineTypeList.prototype.kind = null;
    
                        /**
                         * MachineTypeList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @instance
                         */
                        MachineTypeList.prototype.nextPageToken = null;
    
                        /**
                         * MachineTypeList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @instance
                         */
                        MachineTypeList.prototype.selfLink = null;
    
                        /**
                         * MachineTypeList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @instance
                         */
                        MachineTypeList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * MachineTypeList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @instance
                         */
                        Object.defineProperty(MachineTypeList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineTypeList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @instance
                         */
                        Object.defineProperty(MachineTypeList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineTypeList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @instance
                         */
                        Object.defineProperty(MachineTypeList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineTypeList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @instance
                         */
                        Object.defineProperty(MachineTypeList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MachineTypeList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @instance
                         */
                        Object.defineProperty(MachineTypeList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new MachineTypeList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @static
                         * @param {google.cloud.compute.v1.IMachineTypeList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.MachineTypeList} MachineTypeList instance
                         */
                        MachineTypeList.create = function create(properties) {
                            return new MachineTypeList(properties);
                        };
    
                        /**
                         * Encodes the specified MachineTypeList message. Does not implicitly {@link google.cloud.compute.v1.MachineTypeList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @static
                         * @param {google.cloud.compute.v1.IMachineTypeList} message MachineTypeList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MachineTypeList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.MachineType.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified MachineTypeList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.MachineTypeList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @static
                         * @param {google.cloud.compute.v1.IMachineTypeList} message MachineTypeList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MachineTypeList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a MachineTypeList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.MachineTypeList} MachineTypeList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MachineTypeList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.MachineTypeList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.MachineType.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a MachineTypeList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.MachineTypeList} MachineTypeList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MachineTypeList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a MachineTypeList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MachineTypeList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.MachineType.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a MachineTypeList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.MachineTypeList} MachineTypeList
                         */
                        MachineTypeList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.MachineTypeList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.MachineTypeList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.MachineTypeList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.MachineTypeList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.MachineType.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.MachineTypeList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a MachineTypeList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @static
                         * @param {google.cloud.compute.v1.MachineTypeList} message MachineTypeList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MachineTypeList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.MachineType.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this MachineTypeList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MachineTypeList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for MachineTypeList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.MachineTypeList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        MachineTypeList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.MachineTypeList";
                        };
    
                        return MachineTypeList;
                    })();
    
                    v1.MachineTypesScopedList = (function() {
    
                        /**
                         * Properties of a MachineTypesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IMachineTypesScopedList
                         * @property {Array.<google.cloud.compute.v1.IMachineType>|null} [machineTypes] MachineTypesScopedList machineTypes
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] MachineTypesScopedList warning
                         */
    
                        /**
                         * Constructs a new MachineTypesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a MachineTypesScopedList.
                         * @implements IMachineTypesScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IMachineTypesScopedList=} [properties] Properties to set
                         */
                        function MachineTypesScopedList(properties) {
                            this.machineTypes = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * MachineTypesScopedList machineTypes.
                         * @member {Array.<google.cloud.compute.v1.IMachineType>} machineTypes
                         * @memberof google.cloud.compute.v1.MachineTypesScopedList
                         * @instance
                         */
                        MachineTypesScopedList.prototype.machineTypes = $util.emptyArray;
    
                        /**
                         * MachineTypesScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.MachineTypesScopedList
                         * @instance
                         */
                        MachineTypesScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * MachineTypesScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.MachineTypesScopedList
                         * @instance
                         */
                        Object.defineProperty(MachineTypesScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new MachineTypesScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.MachineTypesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IMachineTypesScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.MachineTypesScopedList} MachineTypesScopedList instance
                         */
                        MachineTypesScopedList.create = function create(properties) {
                            return new MachineTypesScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified MachineTypesScopedList message. Does not implicitly {@link google.cloud.compute.v1.MachineTypesScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.MachineTypesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IMachineTypesScopedList} message MachineTypesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MachineTypesScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.machineTypes != null && message.machineTypes.length)
                                for (var i = 0; i < message.machineTypes.length; ++i)
                                    $root.google.cloud.compute.v1.MachineType.encode(message.machineTypes[i], writer.uint32(/* id 79720065, wireType 2 =*/637760522).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified MachineTypesScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.MachineTypesScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.MachineTypesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IMachineTypesScopedList} message MachineTypesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MachineTypesScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a MachineTypesScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.MachineTypesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.MachineTypesScopedList} MachineTypesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MachineTypesScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.MachineTypesScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 79720065: {
                                        if (!(message.machineTypes && message.machineTypes.length))
                                            message.machineTypes = [];
                                        message.machineTypes.push($root.google.cloud.compute.v1.MachineType.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a MachineTypesScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.MachineTypesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.MachineTypesScopedList} MachineTypesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MachineTypesScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a MachineTypesScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.MachineTypesScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MachineTypesScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.machineTypes != null && message.hasOwnProperty("machineTypes")) {
                                if (!Array.isArray(message.machineTypes))
                                    return "machineTypes: array expected";
                                for (var i = 0; i < message.machineTypes.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.MachineType.verify(message.machineTypes[i]);
                                    if (error)
                                        return "machineTypes." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a MachineTypesScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.MachineTypesScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.MachineTypesScopedList} MachineTypesScopedList
                         */
                        MachineTypesScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.MachineTypesScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.MachineTypesScopedList();
                            if (object.machineTypes) {
                                if (!Array.isArray(object.machineTypes))
                                    throw TypeError(".google.cloud.compute.v1.MachineTypesScopedList.machineTypes: array expected");
                                message.machineTypes = [];
                                for (var i = 0; i < object.machineTypes.length; ++i) {
                                    if (typeof object.machineTypes[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.MachineTypesScopedList.machineTypes: object expected");
                                    message.machineTypes[i] = $root.google.cloud.compute.v1.MachineType.fromObject(object.machineTypes[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.MachineTypesScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a MachineTypesScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.MachineTypesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.MachineTypesScopedList} message MachineTypesScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MachineTypesScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.machineTypes = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.machineTypes && message.machineTypes.length) {
                                object.machineTypes = [];
                                for (var j = 0; j < message.machineTypes.length; ++j)
                                    object.machineTypes[j] = $root.google.cloud.compute.v1.MachineType.toObject(message.machineTypes[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this MachineTypesScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.MachineTypesScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MachineTypesScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for MachineTypesScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.MachineTypesScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        MachineTypesScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.MachineTypesScopedList";
                        };
    
                        return MachineTypesScopedList;
                    })();
    
                    v1.ManagedInstance = (function() {
    
                        /**
                         * Properties of a ManagedInstance.
                         * @memberof google.cloud.compute.v1
                         * @interface IManagedInstance
                         * @property {string|null} [currentAction] ManagedInstance currentAction
                         * @property {number|Long|null} [id] ManagedInstance id
                         * @property {string|null} [instance] ManagedInstance instance
                         * @property {Array.<google.cloud.compute.v1.IManagedInstanceInstanceHealth>|null} [instanceHealth] ManagedInstance instanceHealth
                         * @property {string|null} [instanceStatus] ManagedInstance instanceStatus
                         * @property {google.cloud.compute.v1.IManagedInstanceLastAttempt|null} [lastAttempt] ManagedInstance lastAttempt
                         * @property {google.cloud.compute.v1.IPreservedState|null} [preservedStateFromConfig] ManagedInstance preservedStateFromConfig
                         * @property {google.cloud.compute.v1.IPreservedState|null} [preservedStateFromPolicy] ManagedInstance preservedStateFromPolicy
                         * @property {google.cloud.compute.v1.IManagedInstanceVersion|null} [version] ManagedInstance version
                         */
    
                        /**
                         * Constructs a new ManagedInstance.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ManagedInstance.
                         * @implements IManagedInstance
                         * @constructor
                         * @param {google.cloud.compute.v1.IManagedInstance=} [properties] Properties to set
                         */
                        function ManagedInstance(properties) {
                            this.instanceHealth = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ManagedInstance currentAction.
                         * @member {string|null|undefined} currentAction
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @instance
                         */
                        ManagedInstance.prototype.currentAction = null;
    
                        /**
                         * ManagedInstance id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @instance
                         */
                        ManagedInstance.prototype.id = null;
    
                        /**
                         * ManagedInstance instance.
                         * @member {string|null|undefined} instance
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @instance
                         */
                        ManagedInstance.prototype.instance = null;
    
                        /**
                         * ManagedInstance instanceHealth.
                         * @member {Array.<google.cloud.compute.v1.IManagedInstanceInstanceHealth>} instanceHealth
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @instance
                         */
                        ManagedInstance.prototype.instanceHealth = $util.emptyArray;
    
                        /**
                         * ManagedInstance instanceStatus.
                         * @member {string|null|undefined} instanceStatus
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @instance
                         */
                        ManagedInstance.prototype.instanceStatus = null;
    
                        /**
                         * ManagedInstance lastAttempt.
                         * @member {google.cloud.compute.v1.IManagedInstanceLastAttempt|null|undefined} lastAttempt
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @instance
                         */
                        ManagedInstance.prototype.lastAttempt = null;
    
                        /**
                         * ManagedInstance preservedStateFromConfig.
                         * @member {google.cloud.compute.v1.IPreservedState|null|undefined} preservedStateFromConfig
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @instance
                         */
                        ManagedInstance.prototype.preservedStateFromConfig = null;
    
                        /**
                         * ManagedInstance preservedStateFromPolicy.
                         * @member {google.cloud.compute.v1.IPreservedState|null|undefined} preservedStateFromPolicy
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @instance
                         */
                        ManagedInstance.prototype.preservedStateFromPolicy = null;
    
                        /**
                         * ManagedInstance version.
                         * @member {google.cloud.compute.v1.IManagedInstanceVersion|null|undefined} version
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @instance
                         */
                        ManagedInstance.prototype.version = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ManagedInstance _currentAction.
                         * @member {"currentAction"|undefined} _currentAction
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @instance
                         */
                        Object.defineProperty(ManagedInstance.prototype, "_currentAction", {
                            get: $util.oneOfGetter($oneOfFields = ["currentAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ManagedInstance _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @instance
                         */
                        Object.defineProperty(ManagedInstance.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ManagedInstance _instance.
                         * @member {"instance"|undefined} _instance
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @instance
                         */
                        Object.defineProperty(ManagedInstance.prototype, "_instance", {
                            get: $util.oneOfGetter($oneOfFields = ["instance"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ManagedInstance _instanceStatus.
                         * @member {"instanceStatus"|undefined} _instanceStatus
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @instance
                         */
                        Object.defineProperty(ManagedInstance.prototype, "_instanceStatus", {
                            get: $util.oneOfGetter($oneOfFields = ["instanceStatus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ManagedInstance _lastAttempt.
                         * @member {"lastAttempt"|undefined} _lastAttempt
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @instance
                         */
                        Object.defineProperty(ManagedInstance.prototype, "_lastAttempt", {
                            get: $util.oneOfGetter($oneOfFields = ["lastAttempt"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ManagedInstance _preservedStateFromConfig.
                         * @member {"preservedStateFromConfig"|undefined} _preservedStateFromConfig
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @instance
                         */
                        Object.defineProperty(ManagedInstance.prototype, "_preservedStateFromConfig", {
                            get: $util.oneOfGetter($oneOfFields = ["preservedStateFromConfig"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ManagedInstance _preservedStateFromPolicy.
                         * @member {"preservedStateFromPolicy"|undefined} _preservedStateFromPolicy
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @instance
                         */
                        Object.defineProperty(ManagedInstance.prototype, "_preservedStateFromPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["preservedStateFromPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ManagedInstance _version.
                         * @member {"version"|undefined} _version
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @instance
                         */
                        Object.defineProperty(ManagedInstance.prototype, "_version", {
                            get: $util.oneOfGetter($oneOfFields = ["version"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ManagedInstance instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @static
                         * @param {google.cloud.compute.v1.IManagedInstance=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ManagedInstance} ManagedInstance instance
                         */
                        ManagedInstance.create = function create(properties) {
                            return new ManagedInstance(properties);
                        };
    
                        /**
                         * Encodes the specified ManagedInstance message. Does not implicitly {@link google.cloud.compute.v1.ManagedInstance.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @static
                         * @param {google.cloud.compute.v1.IManagedInstance} message ManagedInstance message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ManagedInstance.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.preservedStateFromConfig != null && Object.hasOwnProperty.call(message, "preservedStateFromConfig"))
                                $root.google.cloud.compute.v1.PreservedState.encode(message.preservedStateFromConfig, writer.uint32(/* id 98661858, wireType 2 =*/789294866).fork()).ldelim();
                            if (message.instanceStatus != null && Object.hasOwnProperty.call(message, "instanceStatus"))
                                writer.uint32(/* id 174577372, wireType 2 =*/1396618978).string(message.instanceStatus);
                            if (message.currentAction != null && Object.hasOwnProperty.call(message, "currentAction"))
                                writer.uint32(/* id 178475964, wireType 2 =*/1427807714).string(message.currentAction);
                            if (message.version != null && Object.hasOwnProperty.call(message, "version"))
                                $root.google.cloud.compute.v1.ManagedInstanceVersion.encode(message.version, writer.uint32(/* id 351608024, wireType 2 =*/2812864194).fork()).ldelim();
                            if (message.instanceHealth != null && message.instanceHealth.length)
                                for (var i = 0; i < message.instanceHealth.length; ++i)
                                    $root.google.cloud.compute.v1.ManagedInstanceInstanceHealth.encode(message.instanceHealth[i], writer.uint32(/* id 382667078, wireType 2 =*/3061336626).fork()).ldelim();
                            if (message.lastAttempt != null && Object.hasOwnProperty.call(message, "lastAttempt"))
                                $root.google.cloud.compute.v1.ManagedInstanceLastAttempt.encode(message.lastAttempt, writer.uint32(/* id 434771492, wireType 2 =*/3478171938).fork()).ldelim();
                            if (message.preservedStateFromPolicy != null && Object.hasOwnProperty.call(message, "preservedStateFromPolicy"))
                                $root.google.cloud.compute.v1.PreservedState.encode(message.preservedStateFromPolicy, writer.uint32(/* id 470783954, wireType 2 =*/3766271634).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ManagedInstance message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ManagedInstance.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @static
                         * @param {google.cloud.compute.v1.IManagedInstance} message ManagedInstance message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ManagedInstance.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ManagedInstance message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ManagedInstance} ManagedInstance
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ManagedInstance.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ManagedInstance();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 178475964: {
                                        message.currentAction = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 382667078: {
                                        if (!(message.instanceHealth && message.instanceHealth.length))
                                            message.instanceHealth = [];
                                        message.instanceHealth.push($root.google.cloud.compute.v1.ManagedInstanceInstanceHealth.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 174577372: {
                                        message.instanceStatus = reader.string();
                                        break;
                                    }
                                case 434771492: {
                                        message.lastAttempt = $root.google.cloud.compute.v1.ManagedInstanceLastAttempt.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 98661858: {
                                        message.preservedStateFromConfig = $root.google.cloud.compute.v1.PreservedState.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 470783954: {
                                        message.preservedStateFromPolicy = $root.google.cloud.compute.v1.PreservedState.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 351608024: {
                                        message.version = $root.google.cloud.compute.v1.ManagedInstanceVersion.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ManagedInstance message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ManagedInstance} ManagedInstance
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ManagedInstance.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ManagedInstance message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ManagedInstance.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.currentAction != null && message.hasOwnProperty("currentAction")) {
                                properties._currentAction = 1;
                                if (!$util.isString(message.currentAction))
                                    return "currentAction: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.instance != null && message.hasOwnProperty("instance")) {
                                properties._instance = 1;
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            }
                            if (message.instanceHealth != null && message.hasOwnProperty("instanceHealth")) {
                                if (!Array.isArray(message.instanceHealth))
                                    return "instanceHealth: array expected";
                                for (var i = 0; i < message.instanceHealth.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ManagedInstanceInstanceHealth.verify(message.instanceHealth[i]);
                                    if (error)
                                        return "instanceHealth." + error;
                                }
                            }
                            if (message.instanceStatus != null && message.hasOwnProperty("instanceStatus")) {
                                properties._instanceStatus = 1;
                                if (!$util.isString(message.instanceStatus))
                                    return "instanceStatus: string expected";
                            }
                            if (message.lastAttempt != null && message.hasOwnProperty("lastAttempt")) {
                                properties._lastAttempt = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ManagedInstanceLastAttempt.verify(message.lastAttempt);
                                    if (error)
                                        return "lastAttempt." + error;
                                }
                            }
                            if (message.preservedStateFromConfig != null && message.hasOwnProperty("preservedStateFromConfig")) {
                                properties._preservedStateFromConfig = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.PreservedState.verify(message.preservedStateFromConfig);
                                    if (error)
                                        return "preservedStateFromConfig." + error;
                                }
                            }
                            if (message.preservedStateFromPolicy != null && message.hasOwnProperty("preservedStateFromPolicy")) {
                                properties._preservedStateFromPolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.PreservedState.verify(message.preservedStateFromPolicy);
                                    if (error)
                                        return "preservedStateFromPolicy." + error;
                                }
                            }
                            if (message.version != null && message.hasOwnProperty("version")) {
                                properties._version = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ManagedInstanceVersion.verify(message.version);
                                    if (error)
                                        return "version." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ManagedInstance message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ManagedInstance} ManagedInstance
                         */
                        ManagedInstance.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ManagedInstance)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ManagedInstance();
                            if (object.currentAction != null)
                                message.currentAction = String(object.currentAction);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.instanceHealth) {
                                if (!Array.isArray(object.instanceHealth))
                                    throw TypeError(".google.cloud.compute.v1.ManagedInstance.instanceHealth: array expected");
                                message.instanceHealth = [];
                                for (var i = 0; i < object.instanceHealth.length; ++i) {
                                    if (typeof object.instanceHealth[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ManagedInstance.instanceHealth: object expected");
                                    message.instanceHealth[i] = $root.google.cloud.compute.v1.ManagedInstanceInstanceHealth.fromObject(object.instanceHealth[i]);
                                }
                            }
                            if (object.instanceStatus != null)
                                message.instanceStatus = String(object.instanceStatus);
                            if (object.lastAttempt != null) {
                                if (typeof object.lastAttempt !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ManagedInstance.lastAttempt: object expected");
                                message.lastAttempt = $root.google.cloud.compute.v1.ManagedInstanceLastAttempt.fromObject(object.lastAttempt);
                            }
                            if (object.preservedStateFromConfig != null) {
                                if (typeof object.preservedStateFromConfig !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ManagedInstance.preservedStateFromConfig: object expected");
                                message.preservedStateFromConfig = $root.google.cloud.compute.v1.PreservedState.fromObject(object.preservedStateFromConfig);
                            }
                            if (object.preservedStateFromPolicy != null) {
                                if (typeof object.preservedStateFromPolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ManagedInstance.preservedStateFromPolicy: object expected");
                                message.preservedStateFromPolicy = $root.google.cloud.compute.v1.PreservedState.fromObject(object.preservedStateFromPolicy);
                            }
                            if (object.version != null) {
                                if (typeof object.version !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ManagedInstance.version: object expected");
                                message.version = $root.google.cloud.compute.v1.ManagedInstanceVersion.fromObject(object.version);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ManagedInstance message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @static
                         * @param {google.cloud.compute.v1.ManagedInstance} message ManagedInstance
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ManagedInstance.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.instanceHealth = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.instance != null && message.hasOwnProperty("instance")) {
                                object.instance = message.instance;
                                if (options.oneofs)
                                    object._instance = "instance";
                            }
                            if (message.preservedStateFromConfig != null && message.hasOwnProperty("preservedStateFromConfig")) {
                                object.preservedStateFromConfig = $root.google.cloud.compute.v1.PreservedState.toObject(message.preservedStateFromConfig, options);
                                if (options.oneofs)
                                    object._preservedStateFromConfig = "preservedStateFromConfig";
                            }
                            if (message.instanceStatus != null && message.hasOwnProperty("instanceStatus")) {
                                object.instanceStatus = message.instanceStatus;
                                if (options.oneofs)
                                    object._instanceStatus = "instanceStatus";
                            }
                            if (message.currentAction != null && message.hasOwnProperty("currentAction")) {
                                object.currentAction = message.currentAction;
                                if (options.oneofs)
                                    object._currentAction = "currentAction";
                            }
                            if (message.version != null && message.hasOwnProperty("version")) {
                                object.version = $root.google.cloud.compute.v1.ManagedInstanceVersion.toObject(message.version, options);
                                if (options.oneofs)
                                    object._version = "version";
                            }
                            if (message.instanceHealth && message.instanceHealth.length) {
                                object.instanceHealth = [];
                                for (var j = 0; j < message.instanceHealth.length; ++j)
                                    object.instanceHealth[j] = $root.google.cloud.compute.v1.ManagedInstanceInstanceHealth.toObject(message.instanceHealth[j], options);
                            }
                            if (message.lastAttempt != null && message.hasOwnProperty("lastAttempt")) {
                                object.lastAttempt = $root.google.cloud.compute.v1.ManagedInstanceLastAttempt.toObject(message.lastAttempt, options);
                                if (options.oneofs)
                                    object._lastAttempt = "lastAttempt";
                            }
                            if (message.preservedStateFromPolicy != null && message.hasOwnProperty("preservedStateFromPolicy")) {
                                object.preservedStateFromPolicy = $root.google.cloud.compute.v1.PreservedState.toObject(message.preservedStateFromPolicy, options);
                                if (options.oneofs)
                                    object._preservedStateFromPolicy = "preservedStateFromPolicy";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ManagedInstance to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ManagedInstance.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ManagedInstance
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ManagedInstance
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ManagedInstance.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ManagedInstance";
                        };
    
                        /**
                         * CurrentAction enum.
                         * @name google.cloud.compute.v1.ManagedInstance.CurrentAction
                         * @enum {number}
                         * @property {number} UNDEFINED_CURRENT_ACTION=0 UNDEFINED_CURRENT_ACTION value
                         * @property {number} ABANDONING=388244813 ABANDONING value
                         * @property {number} CREATING=455564985 CREATING value
                         * @property {number} CREATING_WITHOUT_RETRIES=428843785 CREATING_WITHOUT_RETRIES value
                         * @property {number} DELETING=528602024 DELETING value
                         * @property {number} NONE=2402104 NONE value
                         * @property {number} RECREATING=287278572 RECREATING value
                         * @property {number} REFRESHING=163266343 REFRESHING value
                         * @property {number} RESTARTING=320534387 RESTARTING value
                         * @property {number} RESUMING=446856618 RESUMING value
                         * @property {number} STARTING=488820800 STARTING value
                         * @property {number} VERIFYING=16982185 VERIFYING value
                         */
                        ManagedInstance.CurrentAction = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_CURRENT_ACTION"] = 0;
                            values[valuesById[388244813] = "ABANDONING"] = 388244813;
                            values[valuesById[455564985] = "CREATING"] = 455564985;
                            values[valuesById[428843785] = "CREATING_WITHOUT_RETRIES"] = 428843785;
                            values[valuesById[528602024] = "DELETING"] = 528602024;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            values[valuesById[287278572] = "RECREATING"] = 287278572;
                            values[valuesById[163266343] = "REFRESHING"] = 163266343;
                            values[valuesById[320534387] = "RESTARTING"] = 320534387;
                            values[valuesById[446856618] = "RESUMING"] = 446856618;
                            values[valuesById[488820800] = "STARTING"] = 488820800;
                            values[valuesById[16982185] = "VERIFYING"] = 16982185;
                            return values;
                        })();
    
                        /**
                         * InstanceStatus enum.
                         * @name google.cloud.compute.v1.ManagedInstance.InstanceStatus
                         * @enum {number}
                         * @property {number} UNDEFINED_INSTANCE_STATUS=0 UNDEFINED_INSTANCE_STATUS value
                         * @property {number} DEPROVISIONING=428935662 DEPROVISIONING value
                         * @property {number} PROVISIONING=290896621 PROVISIONING value
                         * @property {number} REPAIRING=413483285 REPAIRING value
                         * @property {number} RUNNING=121282975 RUNNING value
                         * @property {number} STAGING=431072283 STAGING value
                         * @property {number} STOPPED=444276141 STOPPED value
                         * @property {number} STOPPING=350791796 STOPPING value
                         * @property {number} SUSPENDED=51223995 SUSPENDED value
                         * @property {number} SUSPENDING=514206246 SUSPENDING value
                         * @property {number} TERMINATED=250018339 TERMINATED value
                         */
                        ManagedInstance.InstanceStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_INSTANCE_STATUS"] = 0;
                            values[valuesById[428935662] = "DEPROVISIONING"] = 428935662;
                            values[valuesById[290896621] = "PROVISIONING"] = 290896621;
                            values[valuesById[413483285] = "REPAIRING"] = 413483285;
                            values[valuesById[121282975] = "RUNNING"] = 121282975;
                            values[valuesById[431072283] = "STAGING"] = 431072283;
                            values[valuesById[444276141] = "STOPPED"] = 444276141;
                            values[valuesById[350791796] = "STOPPING"] = 350791796;
                            values[valuesById[51223995] = "SUSPENDED"] = 51223995;
                            values[valuesById[514206246] = "SUSPENDING"] = 514206246;
                            values[valuesById[250018339] = "TERMINATED"] = 250018339;
                            return values;
                        })();
    
                        return ManagedInstance;
                    })();
    
                    v1.ManagedInstanceInstanceHealth = (function() {
    
                        /**
                         * Properties of a ManagedInstanceInstanceHealth.
                         * @memberof google.cloud.compute.v1
                         * @interface IManagedInstanceInstanceHealth
                         * @property {string|null} [detailedHealthState] ManagedInstanceInstanceHealth detailedHealthState
                         * @property {string|null} [healthCheck] ManagedInstanceInstanceHealth healthCheck
                         */
    
                        /**
                         * Constructs a new ManagedInstanceInstanceHealth.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ManagedInstanceInstanceHealth.
                         * @implements IManagedInstanceInstanceHealth
                         * @constructor
                         * @param {google.cloud.compute.v1.IManagedInstanceInstanceHealth=} [properties] Properties to set
                         */
                        function ManagedInstanceInstanceHealth(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ManagedInstanceInstanceHealth detailedHealthState.
                         * @member {string|null|undefined} detailedHealthState
                         * @memberof google.cloud.compute.v1.ManagedInstanceInstanceHealth
                         * @instance
                         */
                        ManagedInstanceInstanceHealth.prototype.detailedHealthState = null;
    
                        /**
                         * ManagedInstanceInstanceHealth healthCheck.
                         * @member {string|null|undefined} healthCheck
                         * @memberof google.cloud.compute.v1.ManagedInstanceInstanceHealth
                         * @instance
                         */
                        ManagedInstanceInstanceHealth.prototype.healthCheck = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ManagedInstanceInstanceHealth _detailedHealthState.
                         * @member {"detailedHealthState"|undefined} _detailedHealthState
                         * @memberof google.cloud.compute.v1.ManagedInstanceInstanceHealth
                         * @instance
                         */
                        Object.defineProperty(ManagedInstanceInstanceHealth.prototype, "_detailedHealthState", {
                            get: $util.oneOfGetter($oneOfFields = ["detailedHealthState"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ManagedInstanceInstanceHealth _healthCheck.
                         * @member {"healthCheck"|undefined} _healthCheck
                         * @memberof google.cloud.compute.v1.ManagedInstanceInstanceHealth
                         * @instance
                         */
                        Object.defineProperty(ManagedInstanceInstanceHealth.prototype, "_healthCheck", {
                            get: $util.oneOfGetter($oneOfFields = ["healthCheck"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ManagedInstanceInstanceHealth instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ManagedInstanceInstanceHealth
                         * @static
                         * @param {google.cloud.compute.v1.IManagedInstanceInstanceHealth=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ManagedInstanceInstanceHealth} ManagedInstanceInstanceHealth instance
                         */
                        ManagedInstanceInstanceHealth.create = function create(properties) {
                            return new ManagedInstanceInstanceHealth(properties);
                        };
    
                        /**
                         * Encodes the specified ManagedInstanceInstanceHealth message. Does not implicitly {@link google.cloud.compute.v1.ManagedInstanceInstanceHealth.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ManagedInstanceInstanceHealth
                         * @static
                         * @param {google.cloud.compute.v1.IManagedInstanceInstanceHealth} message ManagedInstanceInstanceHealth message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ManagedInstanceInstanceHealth.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.healthCheck != null && Object.hasOwnProperty.call(message, "healthCheck"))
                                writer.uint32(/* id 308876645, wireType 2 =*/2471013162).string(message.healthCheck);
                            if (message.detailedHealthState != null && Object.hasOwnProperty.call(message, "detailedHealthState"))
                                writer.uint32(/* id 510470173, wireType 2 =*/4083761386).string(message.detailedHealthState);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ManagedInstanceInstanceHealth message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ManagedInstanceInstanceHealth.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ManagedInstanceInstanceHealth
                         * @static
                         * @param {google.cloud.compute.v1.IManagedInstanceInstanceHealth} message ManagedInstanceInstanceHealth message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ManagedInstanceInstanceHealth.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ManagedInstanceInstanceHealth message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ManagedInstanceInstanceHealth
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ManagedInstanceInstanceHealth} ManagedInstanceInstanceHealth
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ManagedInstanceInstanceHealth.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ManagedInstanceInstanceHealth();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 510470173: {
                                        message.detailedHealthState = reader.string();
                                        break;
                                    }
                                case 308876645: {
                                        message.healthCheck = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ManagedInstanceInstanceHealth message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ManagedInstanceInstanceHealth
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ManagedInstanceInstanceHealth} ManagedInstanceInstanceHealth
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ManagedInstanceInstanceHealth.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ManagedInstanceInstanceHealth message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ManagedInstanceInstanceHealth
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ManagedInstanceInstanceHealth.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.detailedHealthState != null && message.hasOwnProperty("detailedHealthState")) {
                                properties._detailedHealthState = 1;
                                if (!$util.isString(message.detailedHealthState))
                                    return "detailedHealthState: string expected";
                            }
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck")) {
                                properties._healthCheck = 1;
                                if (!$util.isString(message.healthCheck))
                                    return "healthCheck: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ManagedInstanceInstanceHealth message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ManagedInstanceInstanceHealth
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ManagedInstanceInstanceHealth} ManagedInstanceInstanceHealth
                         */
                        ManagedInstanceInstanceHealth.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ManagedInstanceInstanceHealth)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ManagedInstanceInstanceHealth();
                            if (object.detailedHealthState != null)
                                message.detailedHealthState = String(object.detailedHealthState);
                            if (object.healthCheck != null)
                                message.healthCheck = String(object.healthCheck);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ManagedInstanceInstanceHealth message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ManagedInstanceInstanceHealth
                         * @static
                         * @param {google.cloud.compute.v1.ManagedInstanceInstanceHealth} message ManagedInstanceInstanceHealth
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ManagedInstanceInstanceHealth.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck")) {
                                object.healthCheck = message.healthCheck;
                                if (options.oneofs)
                                    object._healthCheck = "healthCheck";
                            }
                            if (message.detailedHealthState != null && message.hasOwnProperty("detailedHealthState")) {
                                object.detailedHealthState = message.detailedHealthState;
                                if (options.oneofs)
                                    object._detailedHealthState = "detailedHealthState";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ManagedInstanceInstanceHealth to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ManagedInstanceInstanceHealth
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ManagedInstanceInstanceHealth.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ManagedInstanceInstanceHealth
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ManagedInstanceInstanceHealth
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ManagedInstanceInstanceHealth.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ManagedInstanceInstanceHealth";
                        };
    
                        /**
                         * DetailedHealthState enum.
                         * @name google.cloud.compute.v1.ManagedInstanceInstanceHealth.DetailedHealthState
                         * @enum {number}
                         * @property {number} UNDEFINED_DETAILED_HEALTH_STATE=0 UNDEFINED_DETAILED_HEALTH_STATE value
                         * @property {number} DRAINING=480455402 DRAINING value
                         * @property {number} HEALTHY=439801213 HEALTHY value
                         * @property {number} TIMEOUT=477813057 TIMEOUT value
                         * @property {number} UNHEALTHY=462118084 UNHEALTHY value
                         * @property {number} UNKNOWN=433141802 UNKNOWN value
                         */
                        ManagedInstanceInstanceHealth.DetailedHealthState = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_DETAILED_HEALTH_STATE"] = 0;
                            values[valuesById[480455402] = "DRAINING"] = 480455402;
                            values[valuesById[439801213] = "HEALTHY"] = 439801213;
                            values[valuesById[477813057] = "TIMEOUT"] = 477813057;
                            values[valuesById[462118084] = "UNHEALTHY"] = 462118084;
                            values[valuesById[433141802] = "UNKNOWN"] = 433141802;
                            return values;
                        })();
    
                        return ManagedInstanceInstanceHealth;
                    })();
    
                    v1.ManagedInstanceLastAttempt = (function() {
    
                        /**
                         * Properties of a ManagedInstanceLastAttempt.
                         * @memberof google.cloud.compute.v1
                         * @interface IManagedInstanceLastAttempt
                         * @property {google.cloud.compute.v1.IErrors|null} [errors] ManagedInstanceLastAttempt errors
                         */
    
                        /**
                         * Constructs a new ManagedInstanceLastAttempt.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ManagedInstanceLastAttempt.
                         * @implements IManagedInstanceLastAttempt
                         * @constructor
                         * @param {google.cloud.compute.v1.IManagedInstanceLastAttempt=} [properties] Properties to set
                         */
                        function ManagedInstanceLastAttempt(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ManagedInstanceLastAttempt errors.
                         * @member {google.cloud.compute.v1.IErrors|null|undefined} errors
                         * @memberof google.cloud.compute.v1.ManagedInstanceLastAttempt
                         * @instance
                         */
                        ManagedInstanceLastAttempt.prototype.errors = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ManagedInstanceLastAttempt _errors.
                         * @member {"errors"|undefined} _errors
                         * @memberof google.cloud.compute.v1.ManagedInstanceLastAttempt
                         * @instance
                         */
                        Object.defineProperty(ManagedInstanceLastAttempt.prototype, "_errors", {
                            get: $util.oneOfGetter($oneOfFields = ["errors"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ManagedInstanceLastAttempt instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ManagedInstanceLastAttempt
                         * @static
                         * @param {google.cloud.compute.v1.IManagedInstanceLastAttempt=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ManagedInstanceLastAttempt} ManagedInstanceLastAttempt instance
                         */
                        ManagedInstanceLastAttempt.create = function create(properties) {
                            return new ManagedInstanceLastAttempt(properties);
                        };
    
                        /**
                         * Encodes the specified ManagedInstanceLastAttempt message. Does not implicitly {@link google.cloud.compute.v1.ManagedInstanceLastAttempt.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ManagedInstanceLastAttempt
                         * @static
                         * @param {google.cloud.compute.v1.IManagedInstanceLastAttempt} message ManagedInstanceLastAttempt message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ManagedInstanceLastAttempt.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.errors != null && Object.hasOwnProperty.call(message, "errors"))
                                $root.google.cloud.compute.v1.Errors.encode(message.errors, writer.uint32(/* id 315977579, wireType 2 =*/2527820634).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ManagedInstanceLastAttempt message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ManagedInstanceLastAttempt.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ManagedInstanceLastAttempt
                         * @static
                         * @param {google.cloud.compute.v1.IManagedInstanceLastAttempt} message ManagedInstanceLastAttempt message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ManagedInstanceLastAttempt.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ManagedInstanceLastAttempt message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ManagedInstanceLastAttempt
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ManagedInstanceLastAttempt} ManagedInstanceLastAttempt
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ManagedInstanceLastAttempt.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ManagedInstanceLastAttempt();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 315977579: {
                                        message.errors = $root.google.cloud.compute.v1.Errors.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ManagedInstanceLastAttempt message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ManagedInstanceLastAttempt
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ManagedInstanceLastAttempt} ManagedInstanceLastAttempt
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ManagedInstanceLastAttempt.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ManagedInstanceLastAttempt message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ManagedInstanceLastAttempt
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ManagedInstanceLastAttempt.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.errors != null && message.hasOwnProperty("errors")) {
                                properties._errors = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Errors.verify(message.errors);
                                    if (error)
                                        return "errors." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ManagedInstanceLastAttempt message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ManagedInstanceLastAttempt
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ManagedInstanceLastAttempt} ManagedInstanceLastAttempt
                         */
                        ManagedInstanceLastAttempt.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ManagedInstanceLastAttempt)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ManagedInstanceLastAttempt();
                            if (object.errors != null) {
                                if (typeof object.errors !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ManagedInstanceLastAttempt.errors: object expected");
                                message.errors = $root.google.cloud.compute.v1.Errors.fromObject(object.errors);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ManagedInstanceLastAttempt message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ManagedInstanceLastAttempt
                         * @static
                         * @param {google.cloud.compute.v1.ManagedInstanceLastAttempt} message ManagedInstanceLastAttempt
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ManagedInstanceLastAttempt.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.errors != null && message.hasOwnProperty("errors")) {
                                object.errors = $root.google.cloud.compute.v1.Errors.toObject(message.errors, options);
                                if (options.oneofs)
                                    object._errors = "errors";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ManagedInstanceLastAttempt to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ManagedInstanceLastAttempt
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ManagedInstanceLastAttempt.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ManagedInstanceLastAttempt
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ManagedInstanceLastAttempt
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ManagedInstanceLastAttempt.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ManagedInstanceLastAttempt";
                        };
    
                        return ManagedInstanceLastAttempt;
                    })();
    
                    v1.ManagedInstanceVersion = (function() {
    
                        /**
                         * Properties of a ManagedInstanceVersion.
                         * @memberof google.cloud.compute.v1
                         * @interface IManagedInstanceVersion
                         * @property {string|null} [instanceTemplate] ManagedInstanceVersion instanceTemplate
                         * @property {string|null} [name] ManagedInstanceVersion name
                         */
    
                        /**
                         * Constructs a new ManagedInstanceVersion.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ManagedInstanceVersion.
                         * @implements IManagedInstanceVersion
                         * @constructor
                         * @param {google.cloud.compute.v1.IManagedInstanceVersion=} [properties] Properties to set
                         */
                        function ManagedInstanceVersion(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ManagedInstanceVersion instanceTemplate.
                         * @member {string|null|undefined} instanceTemplate
                         * @memberof google.cloud.compute.v1.ManagedInstanceVersion
                         * @instance
                         */
                        ManagedInstanceVersion.prototype.instanceTemplate = null;
    
                        /**
                         * ManagedInstanceVersion name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.ManagedInstanceVersion
                         * @instance
                         */
                        ManagedInstanceVersion.prototype.name = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ManagedInstanceVersion _instanceTemplate.
                         * @member {"instanceTemplate"|undefined} _instanceTemplate
                         * @memberof google.cloud.compute.v1.ManagedInstanceVersion
                         * @instance
                         */
                        Object.defineProperty(ManagedInstanceVersion.prototype, "_instanceTemplate", {
                            get: $util.oneOfGetter($oneOfFields = ["instanceTemplate"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ManagedInstanceVersion _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.ManagedInstanceVersion
                         * @instance
                         */
                        Object.defineProperty(ManagedInstanceVersion.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ManagedInstanceVersion instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ManagedInstanceVersion
                         * @static
                         * @param {google.cloud.compute.v1.IManagedInstanceVersion=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ManagedInstanceVersion} ManagedInstanceVersion instance
                         */
                        ManagedInstanceVersion.create = function create(properties) {
                            return new ManagedInstanceVersion(properties);
                        };
    
                        /**
                         * Encodes the specified ManagedInstanceVersion message. Does not implicitly {@link google.cloud.compute.v1.ManagedInstanceVersion.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ManagedInstanceVersion
                         * @static
                         * @param {google.cloud.compute.v1.IManagedInstanceVersion} message ManagedInstanceVersion message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ManagedInstanceVersion.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.instanceTemplate != null && Object.hasOwnProperty.call(message, "instanceTemplate"))
                                writer.uint32(/* id 309248228, wireType 2 =*/2473985826).string(message.instanceTemplate);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ManagedInstanceVersion message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ManagedInstanceVersion.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ManagedInstanceVersion
                         * @static
                         * @param {google.cloud.compute.v1.IManagedInstanceVersion} message ManagedInstanceVersion message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ManagedInstanceVersion.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ManagedInstanceVersion message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ManagedInstanceVersion
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ManagedInstanceVersion} ManagedInstanceVersion
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ManagedInstanceVersion.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ManagedInstanceVersion();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 309248228: {
                                        message.instanceTemplate = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ManagedInstanceVersion message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ManagedInstanceVersion
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ManagedInstanceVersion} ManagedInstanceVersion
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ManagedInstanceVersion.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ManagedInstanceVersion message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ManagedInstanceVersion
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ManagedInstanceVersion.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceTemplate != null && message.hasOwnProperty("instanceTemplate")) {
                                properties._instanceTemplate = 1;
                                if (!$util.isString(message.instanceTemplate))
                                    return "instanceTemplate: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ManagedInstanceVersion message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ManagedInstanceVersion
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ManagedInstanceVersion} ManagedInstanceVersion
                         */
                        ManagedInstanceVersion.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ManagedInstanceVersion)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ManagedInstanceVersion();
                            if (object.instanceTemplate != null)
                                message.instanceTemplate = String(object.instanceTemplate);
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ManagedInstanceVersion message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ManagedInstanceVersion
                         * @static
                         * @param {google.cloud.compute.v1.ManagedInstanceVersion} message ManagedInstanceVersion
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ManagedInstanceVersion.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.instanceTemplate != null && message.hasOwnProperty("instanceTemplate")) {
                                object.instanceTemplate = message.instanceTemplate;
                                if (options.oneofs)
                                    object._instanceTemplate = "instanceTemplate";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ManagedInstanceVersion to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ManagedInstanceVersion
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ManagedInstanceVersion.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ManagedInstanceVersion
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ManagedInstanceVersion
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ManagedInstanceVersion.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ManagedInstanceVersion";
                        };
    
                        return ManagedInstanceVersion;
                    })();
    
                    v1.Metadata = (function() {
    
                        /**
                         * Properties of a Metadata.
                         * @memberof google.cloud.compute.v1
                         * @interface IMetadata
                         * @property {string|null} [fingerprint] Metadata fingerprint
                         * @property {Array.<google.cloud.compute.v1.IItems>|null} [items] Metadata items
                         * @property {string|null} [kind] Metadata kind
                         */
    
                        /**
                         * Constructs a new Metadata.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Metadata.
                         * @implements IMetadata
                         * @constructor
                         * @param {google.cloud.compute.v1.IMetadata=} [properties] Properties to set
                         */
                        function Metadata(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Metadata fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.Metadata
                         * @instance
                         */
                        Metadata.prototype.fingerprint = null;
    
                        /**
                         * Metadata items.
                         * @member {Array.<google.cloud.compute.v1.IItems>} items
                         * @memberof google.cloud.compute.v1.Metadata
                         * @instance
                         */
                        Metadata.prototype.items = $util.emptyArray;
    
                        /**
                         * Metadata kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Metadata
                         * @instance
                         */
                        Metadata.prototype.kind = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Metadata _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.Metadata
                         * @instance
                         */
                        Object.defineProperty(Metadata.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Metadata _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Metadata
                         * @instance
                         */
                        Object.defineProperty(Metadata.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Metadata instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Metadata
                         * @static
                         * @param {google.cloud.compute.v1.IMetadata=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Metadata} Metadata instance
                         */
                        Metadata.create = function create(properties) {
                            return new Metadata(properties);
                        };
    
                        /**
                         * Encodes the specified Metadata message. Does not implicitly {@link google.cloud.compute.v1.Metadata.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Metadata
                         * @static
                         * @param {google.cloud.compute.v1.IMetadata} message Metadata message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Metadata.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Items.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Metadata message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Metadata.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Metadata
                         * @static
                         * @param {google.cloud.compute.v1.IMetadata} message Metadata message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Metadata.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Metadata message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Metadata
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Metadata} Metadata
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Metadata.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Metadata();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Items.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Metadata message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Metadata
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Metadata} Metadata
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Metadata.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Metadata message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Metadata
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Metadata.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Items.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Metadata message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Metadata
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Metadata} Metadata
                         */
                        Metadata.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Metadata)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Metadata();
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.Metadata.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Metadata.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Items.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Metadata message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Metadata
                         * @static
                         * @param {google.cloud.compute.v1.Metadata} message Metadata
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Metadata.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Items.toObject(message.items[j], options);
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Metadata to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Metadata
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Metadata.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Metadata
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Metadata
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Metadata.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Metadata";
                        };
    
                        return Metadata;
                    })();
    
                    v1.MetadataFilter = (function() {
    
                        /**
                         * Properties of a MetadataFilter.
                         * @memberof google.cloud.compute.v1
                         * @interface IMetadataFilter
                         * @property {Array.<google.cloud.compute.v1.IMetadataFilterLabelMatch>|null} [filterLabels] MetadataFilter filterLabels
                         * @property {string|null} [filterMatchCriteria] MetadataFilter filterMatchCriteria
                         */
    
                        /**
                         * Constructs a new MetadataFilter.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a MetadataFilter.
                         * @implements IMetadataFilter
                         * @constructor
                         * @param {google.cloud.compute.v1.IMetadataFilter=} [properties] Properties to set
                         */
                        function MetadataFilter(properties) {
                            this.filterLabels = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * MetadataFilter filterLabels.
                         * @member {Array.<google.cloud.compute.v1.IMetadataFilterLabelMatch>} filterLabels
                         * @memberof google.cloud.compute.v1.MetadataFilter
                         * @instance
                         */
                        MetadataFilter.prototype.filterLabels = $util.emptyArray;
    
                        /**
                         * MetadataFilter filterMatchCriteria.
                         * @member {string|null|undefined} filterMatchCriteria
                         * @memberof google.cloud.compute.v1.MetadataFilter
                         * @instance
                         */
                        MetadataFilter.prototype.filterMatchCriteria = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * MetadataFilter _filterMatchCriteria.
                         * @member {"filterMatchCriteria"|undefined} _filterMatchCriteria
                         * @memberof google.cloud.compute.v1.MetadataFilter
                         * @instance
                         */
                        Object.defineProperty(MetadataFilter.prototype, "_filterMatchCriteria", {
                            get: $util.oneOfGetter($oneOfFields = ["filterMatchCriteria"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new MetadataFilter instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.MetadataFilter
                         * @static
                         * @param {google.cloud.compute.v1.IMetadataFilter=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.MetadataFilter} MetadataFilter instance
                         */
                        MetadataFilter.create = function create(properties) {
                            return new MetadataFilter(properties);
                        };
    
                        /**
                         * Encodes the specified MetadataFilter message. Does not implicitly {@link google.cloud.compute.v1.MetadataFilter.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.MetadataFilter
                         * @static
                         * @param {google.cloud.compute.v1.IMetadataFilter} message MetadataFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MetadataFilter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.filterMatchCriteria != null && Object.hasOwnProperty.call(message, "filterMatchCriteria"))
                                writer.uint32(/* id 239970368, wireType 2 =*/1919762946).string(message.filterMatchCriteria);
                            if (message.filterLabels != null && message.filterLabels.length)
                                for (var i = 0; i < message.filterLabels.length; ++i)
                                    $root.google.cloud.compute.v1.MetadataFilterLabelMatch.encode(message.filterLabels[i], writer.uint32(/* id 307903142, wireType 2 =*/2463225138).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified MetadataFilter message, length delimited. Does not implicitly {@link google.cloud.compute.v1.MetadataFilter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.MetadataFilter
                         * @static
                         * @param {google.cloud.compute.v1.IMetadataFilter} message MetadataFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MetadataFilter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a MetadataFilter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.MetadataFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.MetadataFilter} MetadataFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MetadataFilter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.MetadataFilter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 307903142: {
                                        if (!(message.filterLabels && message.filterLabels.length))
                                            message.filterLabels = [];
                                        message.filterLabels.push($root.google.cloud.compute.v1.MetadataFilterLabelMatch.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 239970368: {
                                        message.filterMatchCriteria = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a MetadataFilter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.MetadataFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.MetadataFilter} MetadataFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MetadataFilter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a MetadataFilter message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.MetadataFilter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MetadataFilter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filterLabels != null && message.hasOwnProperty("filterLabels")) {
                                if (!Array.isArray(message.filterLabels))
                                    return "filterLabels: array expected";
                                for (var i = 0; i < message.filterLabels.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.MetadataFilterLabelMatch.verify(message.filterLabels[i]);
                                    if (error)
                                        return "filterLabels." + error;
                                }
                            }
                            if (message.filterMatchCriteria != null && message.hasOwnProperty("filterMatchCriteria")) {
                                properties._filterMatchCriteria = 1;
                                if (!$util.isString(message.filterMatchCriteria))
                                    return "filterMatchCriteria: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a MetadataFilter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.MetadataFilter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.MetadataFilter} MetadataFilter
                         */
                        MetadataFilter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.MetadataFilter)
                                return object;
                            var message = new $root.google.cloud.compute.v1.MetadataFilter();
                            if (object.filterLabels) {
                                if (!Array.isArray(object.filterLabels))
                                    throw TypeError(".google.cloud.compute.v1.MetadataFilter.filterLabels: array expected");
                                message.filterLabels = [];
                                for (var i = 0; i < object.filterLabels.length; ++i) {
                                    if (typeof object.filterLabels[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.MetadataFilter.filterLabels: object expected");
                                    message.filterLabels[i] = $root.google.cloud.compute.v1.MetadataFilterLabelMatch.fromObject(object.filterLabels[i]);
                                }
                            }
                            if (object.filterMatchCriteria != null)
                                message.filterMatchCriteria = String(object.filterMatchCriteria);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a MetadataFilter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.MetadataFilter
                         * @static
                         * @param {google.cloud.compute.v1.MetadataFilter} message MetadataFilter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MetadataFilter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.filterLabels = [];
                            if (message.filterMatchCriteria != null && message.hasOwnProperty("filterMatchCriteria")) {
                                object.filterMatchCriteria = message.filterMatchCriteria;
                                if (options.oneofs)
                                    object._filterMatchCriteria = "filterMatchCriteria";
                            }
                            if (message.filterLabels && message.filterLabels.length) {
                                object.filterLabels = [];
                                for (var j = 0; j < message.filterLabels.length; ++j)
                                    object.filterLabels[j] = $root.google.cloud.compute.v1.MetadataFilterLabelMatch.toObject(message.filterLabels[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this MetadataFilter to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.MetadataFilter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MetadataFilter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for MetadataFilter
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.MetadataFilter
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        MetadataFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.MetadataFilter";
                        };
    
                        /**
                         * FilterMatchCriteria enum.
                         * @name google.cloud.compute.v1.MetadataFilter.FilterMatchCriteria
                         * @enum {number}
                         * @property {number} UNDEFINED_FILTER_MATCH_CRITERIA=0 UNDEFINED_FILTER_MATCH_CRITERIA value
                         * @property {number} MATCH_ALL=180663271 MATCH_ALL value
                         * @property {number} MATCH_ANY=180663346 MATCH_ANY value
                         * @property {number} NOT_SET=163646646 NOT_SET value
                         */
                        MetadataFilter.FilterMatchCriteria = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_FILTER_MATCH_CRITERIA"] = 0;
                            values[valuesById[180663271] = "MATCH_ALL"] = 180663271;
                            values[valuesById[180663346] = "MATCH_ANY"] = 180663346;
                            values[valuesById[163646646] = "NOT_SET"] = 163646646;
                            return values;
                        })();
    
                        return MetadataFilter;
                    })();
    
                    v1.MetadataFilterLabelMatch = (function() {
    
                        /**
                         * Properties of a MetadataFilterLabelMatch.
                         * @memberof google.cloud.compute.v1
                         * @interface IMetadataFilterLabelMatch
                         * @property {string|null} [name] MetadataFilterLabelMatch name
                         * @property {string|null} [value] MetadataFilterLabelMatch value
                         */
    
                        /**
                         * Constructs a new MetadataFilterLabelMatch.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a MetadataFilterLabelMatch.
                         * @implements IMetadataFilterLabelMatch
                         * @constructor
                         * @param {google.cloud.compute.v1.IMetadataFilterLabelMatch=} [properties] Properties to set
                         */
                        function MetadataFilterLabelMatch(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * MetadataFilterLabelMatch name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.MetadataFilterLabelMatch
                         * @instance
                         */
                        MetadataFilterLabelMatch.prototype.name = null;
    
                        /**
                         * MetadataFilterLabelMatch value.
                         * @member {string|null|undefined} value
                         * @memberof google.cloud.compute.v1.MetadataFilterLabelMatch
                         * @instance
                         */
                        MetadataFilterLabelMatch.prototype.value = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * MetadataFilterLabelMatch _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.MetadataFilterLabelMatch
                         * @instance
                         */
                        Object.defineProperty(MetadataFilterLabelMatch.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * MetadataFilterLabelMatch _value.
                         * @member {"value"|undefined} _value
                         * @memberof google.cloud.compute.v1.MetadataFilterLabelMatch
                         * @instance
                         */
                        Object.defineProperty(MetadataFilterLabelMatch.prototype, "_value", {
                            get: $util.oneOfGetter($oneOfFields = ["value"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new MetadataFilterLabelMatch instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.MetadataFilterLabelMatch
                         * @static
                         * @param {google.cloud.compute.v1.IMetadataFilterLabelMatch=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.MetadataFilterLabelMatch} MetadataFilterLabelMatch instance
                         */
                        MetadataFilterLabelMatch.create = function create(properties) {
                            return new MetadataFilterLabelMatch(properties);
                        };
    
                        /**
                         * Encodes the specified MetadataFilterLabelMatch message. Does not implicitly {@link google.cloud.compute.v1.MetadataFilterLabelMatch.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.MetadataFilterLabelMatch
                         * @static
                         * @param {google.cloud.compute.v1.IMetadataFilterLabelMatch} message MetadataFilterLabelMatch message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MetadataFilterLabelMatch.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                writer.uint32(/* id 111972721, wireType 2 =*/895781770).string(message.value);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified MetadataFilterLabelMatch message, length delimited. Does not implicitly {@link google.cloud.compute.v1.MetadataFilterLabelMatch.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.MetadataFilterLabelMatch
                         * @static
                         * @param {google.cloud.compute.v1.IMetadataFilterLabelMatch} message MetadataFilterLabelMatch message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MetadataFilterLabelMatch.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a MetadataFilterLabelMatch message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.MetadataFilterLabelMatch
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.MetadataFilterLabelMatch} MetadataFilterLabelMatch
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MetadataFilterLabelMatch.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.MetadataFilterLabelMatch();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 111972721: {
                                        message.value = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a MetadataFilterLabelMatch message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.MetadataFilterLabelMatch
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.MetadataFilterLabelMatch} MetadataFilterLabelMatch
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MetadataFilterLabelMatch.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a MetadataFilterLabelMatch message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.MetadataFilterLabelMatch
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MetadataFilterLabelMatch.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                properties._value = 1;
                                if (!$util.isString(message.value))
                                    return "value: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a MetadataFilterLabelMatch message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.MetadataFilterLabelMatch
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.MetadataFilterLabelMatch} MetadataFilterLabelMatch
                         */
                        MetadataFilterLabelMatch.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.MetadataFilterLabelMatch)
                                return object;
                            var message = new $root.google.cloud.compute.v1.MetadataFilterLabelMatch();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.value != null)
                                message.value = String(object.value);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a MetadataFilterLabelMatch message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.MetadataFilterLabelMatch
                         * @static
                         * @param {google.cloud.compute.v1.MetadataFilterLabelMatch} message MetadataFilterLabelMatch
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MetadataFilterLabelMatch.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                object.value = message.value;
                                if (options.oneofs)
                                    object._value = "value";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this MetadataFilterLabelMatch to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.MetadataFilterLabelMatch
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MetadataFilterLabelMatch.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for MetadataFilterLabelMatch
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.MetadataFilterLabelMatch
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        MetadataFilterLabelMatch.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.MetadataFilterLabelMatch";
                        };
    
                        return MetadataFilterLabelMatch;
                    })();
    
                    v1.MoveDiskProjectRequest = (function() {
    
                        /**
                         * Properties of a MoveDiskProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IMoveDiskProjectRequest
                         * @property {google.cloud.compute.v1.IDiskMoveRequest|null} [diskMoveRequestResource] MoveDiskProjectRequest diskMoveRequestResource
                         * @property {string|null} [project] MoveDiskProjectRequest project
                         * @property {string|null} [requestId] MoveDiskProjectRequest requestId
                         */
    
                        /**
                         * Constructs a new MoveDiskProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a MoveDiskProjectRequest.
                         * @implements IMoveDiskProjectRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IMoveDiskProjectRequest=} [properties] Properties to set
                         */
                        function MoveDiskProjectRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * MoveDiskProjectRequest diskMoveRequestResource.
                         * @member {google.cloud.compute.v1.IDiskMoveRequest|null|undefined} diskMoveRequestResource
                         * @memberof google.cloud.compute.v1.MoveDiskProjectRequest
                         * @instance
                         */
                        MoveDiskProjectRequest.prototype.diskMoveRequestResource = null;
    
                        /**
                         * MoveDiskProjectRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.MoveDiskProjectRequest
                         * @instance
                         */
                        MoveDiskProjectRequest.prototype.project = "";
    
                        /**
                         * MoveDiskProjectRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.MoveDiskProjectRequest
                         * @instance
                         */
                        MoveDiskProjectRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * MoveDiskProjectRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.MoveDiskProjectRequest
                         * @instance
                         */
                        Object.defineProperty(MoveDiskProjectRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new MoveDiskProjectRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.MoveDiskProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IMoveDiskProjectRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.MoveDiskProjectRequest} MoveDiskProjectRequest instance
                         */
                        MoveDiskProjectRequest.create = function create(properties) {
                            return new MoveDiskProjectRequest(properties);
                        };
    
                        /**
                         * Encodes the specified MoveDiskProjectRequest message. Does not implicitly {@link google.cloud.compute.v1.MoveDiskProjectRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.MoveDiskProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IMoveDiskProjectRequest} message MoveDiskProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MoveDiskProjectRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.diskMoveRequestResource != null && Object.hasOwnProperty.call(message, "diskMoveRequestResource"))
                                $root.google.cloud.compute.v1.DiskMoveRequest.encode(message.diskMoveRequestResource, writer.uint32(/* id 313008458, wireType 2 =*/2504067666).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified MoveDiskProjectRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.MoveDiskProjectRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.MoveDiskProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IMoveDiskProjectRequest} message MoveDiskProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MoveDiskProjectRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a MoveDiskProjectRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.MoveDiskProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.MoveDiskProjectRequest} MoveDiskProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MoveDiskProjectRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.MoveDiskProjectRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 313008458: {
                                        message.diskMoveRequestResource = $root.google.cloud.compute.v1.DiskMoveRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a MoveDiskProjectRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.MoveDiskProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.MoveDiskProjectRequest} MoveDiskProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MoveDiskProjectRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a MoveDiskProjectRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.MoveDiskProjectRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MoveDiskProjectRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.diskMoveRequestResource != null && message.hasOwnProperty("diskMoveRequestResource")) {
                                var error = $root.google.cloud.compute.v1.DiskMoveRequest.verify(message.diskMoveRequestResource);
                                if (error)
                                    return "diskMoveRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a MoveDiskProjectRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.MoveDiskProjectRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.MoveDiskProjectRequest} MoveDiskProjectRequest
                         */
                        MoveDiskProjectRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.MoveDiskProjectRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.MoveDiskProjectRequest();
                            if (object.diskMoveRequestResource != null) {
                                if (typeof object.diskMoveRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.MoveDiskProjectRequest.diskMoveRequestResource: object expected");
                                message.diskMoveRequestResource = $root.google.cloud.compute.v1.DiskMoveRequest.fromObject(object.diskMoveRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a MoveDiskProjectRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.MoveDiskProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.MoveDiskProjectRequest} message MoveDiskProjectRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MoveDiskProjectRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.diskMoveRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.diskMoveRequestResource != null && message.hasOwnProperty("diskMoveRequestResource"))
                                object.diskMoveRequestResource = $root.google.cloud.compute.v1.DiskMoveRequest.toObject(message.diskMoveRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this MoveDiskProjectRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.MoveDiskProjectRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MoveDiskProjectRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for MoveDiskProjectRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.MoveDiskProjectRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        MoveDiskProjectRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.MoveDiskProjectRequest";
                        };
    
                        return MoveDiskProjectRequest;
                    })();
    
                    v1.MoveFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a MoveFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IMoveFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] MoveFirewallPolicyRequest firewallPolicy
                         * @property {string|null} [parentId] MoveFirewallPolicyRequest parentId
                         * @property {string|null} [requestId] MoveFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new MoveFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a MoveFirewallPolicyRequest.
                         * @implements IMoveFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IMoveFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function MoveFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * MoveFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.MoveFirewallPolicyRequest
                         * @instance
                         */
                        MoveFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * MoveFirewallPolicyRequest parentId.
                         * @member {string} parentId
                         * @memberof google.cloud.compute.v1.MoveFirewallPolicyRequest
                         * @instance
                         */
                        MoveFirewallPolicyRequest.prototype.parentId = "";
    
                        /**
                         * MoveFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.MoveFirewallPolicyRequest
                         * @instance
                         */
                        MoveFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * MoveFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.MoveFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(MoveFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new MoveFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.MoveFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IMoveFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.MoveFirewallPolicyRequest} MoveFirewallPolicyRequest instance
                         */
                        MoveFirewallPolicyRequest.create = function create(properties) {
                            return new MoveFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified MoveFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.MoveFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.MoveFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IMoveFirewallPolicyRequest} message MoveFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MoveFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.parentId != null && Object.hasOwnProperty.call(message, "parentId"))
                                writer.uint32(/* id 459714768, wireType 2 =*/3677718146).string(message.parentId);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified MoveFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.MoveFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.MoveFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IMoveFirewallPolicyRequest} message MoveFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MoveFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a MoveFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.MoveFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.MoveFirewallPolicyRequest} MoveFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MoveFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.MoveFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 459714768: {
                                        message.parentId = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a MoveFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.MoveFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.MoveFirewallPolicyRequest} MoveFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MoveFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a MoveFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.MoveFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MoveFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.parentId != null && message.hasOwnProperty("parentId"))
                                if (!$util.isString(message.parentId))
                                    return "parentId: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a MoveFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.MoveFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.MoveFirewallPolicyRequest} MoveFirewallPolicyRequest
                         */
                        MoveFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.MoveFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.MoveFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.parentId != null)
                                message.parentId = String(object.parentId);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a MoveFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.MoveFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.MoveFirewallPolicyRequest} message MoveFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MoveFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.parentId = "";
                                object.firewallPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.parentId != null && message.hasOwnProperty("parentId"))
                                object.parentId = message.parentId;
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this MoveFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.MoveFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MoveFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for MoveFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.MoveFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        MoveFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.MoveFirewallPolicyRequest";
                        };
    
                        return MoveFirewallPolicyRequest;
                    })();
    
                    v1.MoveInstanceProjectRequest = (function() {
    
                        /**
                         * Properties of a MoveInstanceProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IMoveInstanceProjectRequest
                         * @property {google.cloud.compute.v1.IInstanceMoveRequest|null} [instanceMoveRequestResource] MoveInstanceProjectRequest instanceMoveRequestResource
                         * @property {string|null} [project] MoveInstanceProjectRequest project
                         * @property {string|null} [requestId] MoveInstanceProjectRequest requestId
                         */
    
                        /**
                         * Constructs a new MoveInstanceProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a MoveInstanceProjectRequest.
                         * @implements IMoveInstanceProjectRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IMoveInstanceProjectRequest=} [properties] Properties to set
                         */
                        function MoveInstanceProjectRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * MoveInstanceProjectRequest instanceMoveRequestResource.
                         * @member {google.cloud.compute.v1.IInstanceMoveRequest|null|undefined} instanceMoveRequestResource
                         * @memberof google.cloud.compute.v1.MoveInstanceProjectRequest
                         * @instance
                         */
                        MoveInstanceProjectRequest.prototype.instanceMoveRequestResource = null;
    
                        /**
                         * MoveInstanceProjectRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.MoveInstanceProjectRequest
                         * @instance
                         */
                        MoveInstanceProjectRequest.prototype.project = "";
    
                        /**
                         * MoveInstanceProjectRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.MoveInstanceProjectRequest
                         * @instance
                         */
                        MoveInstanceProjectRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * MoveInstanceProjectRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.MoveInstanceProjectRequest
                         * @instance
                         */
                        Object.defineProperty(MoveInstanceProjectRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new MoveInstanceProjectRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.MoveInstanceProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IMoveInstanceProjectRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.MoveInstanceProjectRequest} MoveInstanceProjectRequest instance
                         */
                        MoveInstanceProjectRequest.create = function create(properties) {
                            return new MoveInstanceProjectRequest(properties);
                        };
    
                        /**
                         * Encodes the specified MoveInstanceProjectRequest message. Does not implicitly {@link google.cloud.compute.v1.MoveInstanceProjectRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.MoveInstanceProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IMoveInstanceProjectRequest} message MoveInstanceProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MoveInstanceProjectRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceMoveRequestResource != null && Object.hasOwnProperty.call(message, "instanceMoveRequestResource"))
                                $root.google.cloud.compute.v1.InstanceMoveRequest.encode(message.instanceMoveRequestResource, writer.uint32(/* id 311664194, wireType 2 =*/2493313554).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified MoveInstanceProjectRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.MoveInstanceProjectRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.MoveInstanceProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IMoveInstanceProjectRequest} message MoveInstanceProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        MoveInstanceProjectRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a MoveInstanceProjectRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.MoveInstanceProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.MoveInstanceProjectRequest} MoveInstanceProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MoveInstanceProjectRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.MoveInstanceProjectRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 311664194: {
                                        message.instanceMoveRequestResource = $root.google.cloud.compute.v1.InstanceMoveRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a MoveInstanceProjectRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.MoveInstanceProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.MoveInstanceProjectRequest} MoveInstanceProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        MoveInstanceProjectRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a MoveInstanceProjectRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.MoveInstanceProjectRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        MoveInstanceProjectRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceMoveRequestResource != null && message.hasOwnProperty("instanceMoveRequestResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceMoveRequest.verify(message.instanceMoveRequestResource);
                                if (error)
                                    return "instanceMoveRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a MoveInstanceProjectRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.MoveInstanceProjectRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.MoveInstanceProjectRequest} MoveInstanceProjectRequest
                         */
                        MoveInstanceProjectRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.MoveInstanceProjectRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.MoveInstanceProjectRequest();
                            if (object.instanceMoveRequestResource != null) {
                                if (typeof object.instanceMoveRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.MoveInstanceProjectRequest.instanceMoveRequestResource: object expected");
                                message.instanceMoveRequestResource = $root.google.cloud.compute.v1.InstanceMoveRequest.fromObject(object.instanceMoveRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a MoveInstanceProjectRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.MoveInstanceProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.MoveInstanceProjectRequest} message MoveInstanceProjectRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        MoveInstanceProjectRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.instanceMoveRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceMoveRequestResource != null && message.hasOwnProperty("instanceMoveRequestResource"))
                                object.instanceMoveRequestResource = $root.google.cloud.compute.v1.InstanceMoveRequest.toObject(message.instanceMoveRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this MoveInstanceProjectRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.MoveInstanceProjectRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        MoveInstanceProjectRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for MoveInstanceProjectRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.MoveInstanceProjectRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        MoveInstanceProjectRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.MoveInstanceProjectRequest";
                        };
    
                        return MoveInstanceProjectRequest;
                    })();
    
                    v1.NamedPort = (function() {
    
                        /**
                         * Properties of a NamedPort.
                         * @memberof google.cloud.compute.v1
                         * @interface INamedPort
                         * @property {string|null} [name] NamedPort name
                         * @property {number|null} [port] NamedPort port
                         */
    
                        /**
                         * Constructs a new NamedPort.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NamedPort.
                         * @implements INamedPort
                         * @constructor
                         * @param {google.cloud.compute.v1.INamedPort=} [properties] Properties to set
                         */
                        function NamedPort(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NamedPort name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.NamedPort
                         * @instance
                         */
                        NamedPort.prototype.name = null;
    
                        /**
                         * NamedPort port.
                         * @member {number|null|undefined} port
                         * @memberof google.cloud.compute.v1.NamedPort
                         * @instance
                         */
                        NamedPort.prototype.port = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NamedPort _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.NamedPort
                         * @instance
                         */
                        Object.defineProperty(NamedPort.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NamedPort _port.
                         * @member {"port"|undefined} _port
                         * @memberof google.cloud.compute.v1.NamedPort
                         * @instance
                         */
                        Object.defineProperty(NamedPort.prototype, "_port", {
                            get: $util.oneOfGetter($oneOfFields = ["port"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NamedPort instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NamedPort
                         * @static
                         * @param {google.cloud.compute.v1.INamedPort=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NamedPort} NamedPort instance
                         */
                        NamedPort.create = function create(properties) {
                            return new NamedPort(properties);
                        };
    
                        /**
                         * Encodes the specified NamedPort message. Does not implicitly {@link google.cloud.compute.v1.NamedPort.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NamedPort
                         * @static
                         * @param {google.cloud.compute.v1.INamedPort} message NamedPort message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NamedPort.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.port != null && Object.hasOwnProperty.call(message, "port"))
                                writer.uint32(/* id 3446913, wireType 0 =*/27575304).int32(message.port);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NamedPort message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NamedPort.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NamedPort
                         * @static
                         * @param {google.cloud.compute.v1.INamedPort} message NamedPort message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NamedPort.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NamedPort message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NamedPort
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NamedPort} NamedPort
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NamedPort.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NamedPort();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 3446913: {
                                        message.port = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NamedPort message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NamedPort
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NamedPort} NamedPort
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NamedPort.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NamedPort message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NamedPort
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NamedPort.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.port != null && message.hasOwnProperty("port")) {
                                properties._port = 1;
                                if (!$util.isInteger(message.port))
                                    return "port: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NamedPort message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NamedPort
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NamedPort} NamedPort
                         */
                        NamedPort.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NamedPort)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NamedPort();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.port != null)
                                message.port = object.port | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NamedPort message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NamedPort
                         * @static
                         * @param {google.cloud.compute.v1.NamedPort} message NamedPort
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NamedPort.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.port != null && message.hasOwnProperty("port")) {
                                object.port = message.port;
                                if (options.oneofs)
                                    object._port = "port";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NamedPort to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NamedPort
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NamedPort.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NamedPort
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NamedPort
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NamedPort.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NamedPort";
                        };
    
                        return NamedPort;
                    })();
    
                    v1.Network = (function() {
    
                        /**
                         * Properties of a Network.
                         * @memberof google.cloud.compute.v1
                         * @interface INetwork
                         * @property {string|null} [IPv4Range] Network IPv4Range
                         * @property {boolean|null} [autoCreateSubnetworks] Network autoCreateSubnetworks
                         * @property {string|null} [creationTimestamp] Network creationTimestamp
                         * @property {string|null} [description] Network description
                         * @property {boolean|null} [enableUlaInternalIpv6] Network enableUlaInternalIpv6
                         * @property {string|null} [firewallPolicy] Network firewallPolicy
                         * @property {string|null} [gatewayIPv4] Network gatewayIPv4
                         * @property {number|Long|null} [id] Network id
                         * @property {string|null} [internalIpv6Range] Network internalIpv6Range
                         * @property {string|null} [kind] Network kind
                         * @property {number|null} [mtu] Network mtu
                         * @property {string|null} [name] Network name
                         * @property {string|null} [networkFirewallPolicyEnforcementOrder] Network networkFirewallPolicyEnforcementOrder
                         * @property {Array.<google.cloud.compute.v1.INetworkPeering>|null} [peerings] Network peerings
                         * @property {google.cloud.compute.v1.INetworkRoutingConfig|null} [routingConfig] Network routingConfig
                         * @property {string|null} [selfLink] Network selfLink
                         * @property {string|null} [selfLinkWithId] Network selfLinkWithId
                         * @property {Array.<string>|null} [subnetworks] Network subnetworks
                         */
    
                        /**
                         * Constructs a new Network.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Network.
                         * @implements INetwork
                         * @constructor
                         * @param {google.cloud.compute.v1.INetwork=} [properties] Properties to set
                         */
                        function Network(properties) {
                            this.peerings = [];
                            this.subnetworks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Network IPv4Range.
                         * @member {string|null|undefined} IPv4Range
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Network.prototype.IPv4Range = null;
    
                        /**
                         * Network autoCreateSubnetworks.
                         * @member {boolean|null|undefined} autoCreateSubnetworks
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Network.prototype.autoCreateSubnetworks = null;
    
                        /**
                         * Network creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Network.prototype.creationTimestamp = null;
    
                        /**
                         * Network description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Network.prototype.description = null;
    
                        /**
                         * Network enableUlaInternalIpv6.
                         * @member {boolean|null|undefined} enableUlaInternalIpv6
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Network.prototype.enableUlaInternalIpv6 = null;
    
                        /**
                         * Network firewallPolicy.
                         * @member {string|null|undefined} firewallPolicy
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Network.prototype.firewallPolicy = null;
    
                        /**
                         * Network gatewayIPv4.
                         * @member {string|null|undefined} gatewayIPv4
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Network.prototype.gatewayIPv4 = null;
    
                        /**
                         * Network id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Network.prototype.id = null;
    
                        /**
                         * Network internalIpv6Range.
                         * @member {string|null|undefined} internalIpv6Range
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Network.prototype.internalIpv6Range = null;
    
                        /**
                         * Network kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Network.prototype.kind = null;
    
                        /**
                         * Network mtu.
                         * @member {number|null|undefined} mtu
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Network.prototype.mtu = null;
    
                        /**
                         * Network name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Network.prototype.name = null;
    
                        /**
                         * Network networkFirewallPolicyEnforcementOrder.
                         * @member {string|null|undefined} networkFirewallPolicyEnforcementOrder
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Network.prototype.networkFirewallPolicyEnforcementOrder = null;
    
                        /**
                         * Network peerings.
                         * @member {Array.<google.cloud.compute.v1.INetworkPeering>} peerings
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Network.prototype.peerings = $util.emptyArray;
    
                        /**
                         * Network routingConfig.
                         * @member {google.cloud.compute.v1.INetworkRoutingConfig|null|undefined} routingConfig
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Network.prototype.routingConfig = null;
    
                        /**
                         * Network selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Network.prototype.selfLink = null;
    
                        /**
                         * Network selfLinkWithId.
                         * @member {string|null|undefined} selfLinkWithId
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Network.prototype.selfLinkWithId = null;
    
                        /**
                         * Network subnetworks.
                         * @member {Array.<string>} subnetworks
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Network.prototype.subnetworks = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Network _IPv4Range.
                         * @member {"IPv4Range"|undefined} _IPv4Range
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Object.defineProperty(Network.prototype, "_IPv4Range", {
                            get: $util.oneOfGetter($oneOfFields = ["IPv4Range"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Network _autoCreateSubnetworks.
                         * @member {"autoCreateSubnetworks"|undefined} _autoCreateSubnetworks
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Object.defineProperty(Network.prototype, "_autoCreateSubnetworks", {
                            get: $util.oneOfGetter($oneOfFields = ["autoCreateSubnetworks"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Network _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Object.defineProperty(Network.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Network _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Object.defineProperty(Network.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Network _enableUlaInternalIpv6.
                         * @member {"enableUlaInternalIpv6"|undefined} _enableUlaInternalIpv6
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Object.defineProperty(Network.prototype, "_enableUlaInternalIpv6", {
                            get: $util.oneOfGetter($oneOfFields = ["enableUlaInternalIpv6"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Network _firewallPolicy.
                         * @member {"firewallPolicy"|undefined} _firewallPolicy
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Object.defineProperty(Network.prototype, "_firewallPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["firewallPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Network _gatewayIPv4.
                         * @member {"gatewayIPv4"|undefined} _gatewayIPv4
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Object.defineProperty(Network.prototype, "_gatewayIPv4", {
                            get: $util.oneOfGetter($oneOfFields = ["gatewayIPv4"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Network _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Object.defineProperty(Network.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Network _internalIpv6Range.
                         * @member {"internalIpv6Range"|undefined} _internalIpv6Range
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Object.defineProperty(Network.prototype, "_internalIpv6Range", {
                            get: $util.oneOfGetter($oneOfFields = ["internalIpv6Range"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Network _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Object.defineProperty(Network.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Network _mtu.
                         * @member {"mtu"|undefined} _mtu
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Object.defineProperty(Network.prototype, "_mtu", {
                            get: $util.oneOfGetter($oneOfFields = ["mtu"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Network _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Object.defineProperty(Network.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Network _networkFirewallPolicyEnforcementOrder.
                         * @member {"networkFirewallPolicyEnforcementOrder"|undefined} _networkFirewallPolicyEnforcementOrder
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Object.defineProperty(Network.prototype, "_networkFirewallPolicyEnforcementOrder", {
                            get: $util.oneOfGetter($oneOfFields = ["networkFirewallPolicyEnforcementOrder"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Network _routingConfig.
                         * @member {"routingConfig"|undefined} _routingConfig
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Object.defineProperty(Network.prototype, "_routingConfig", {
                            get: $util.oneOfGetter($oneOfFields = ["routingConfig"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Network _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Object.defineProperty(Network.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Network _selfLinkWithId.
                         * @member {"selfLinkWithId"|undefined} _selfLinkWithId
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         */
                        Object.defineProperty(Network.prototype, "_selfLinkWithId", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLinkWithId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Network instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Network
                         * @static
                         * @param {google.cloud.compute.v1.INetwork=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Network} Network instance
                         */
                        Network.create = function create(properties) {
                            return new Network(properties);
                        };
    
                        /**
                         * Encodes the specified Network message. Does not implicitly {@link google.cloud.compute.v1.Network.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Network
                         * @static
                         * @param {google.cloud.compute.v1.INetwork} message Network message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Network.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.mtu != null && Object.hasOwnProperty.call(message, "mtu"))
                                writer.uint32(/* id 108462, wireType 0 =*/867696).int32(message.mtu);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.networkFirewallPolicyEnforcementOrder != null && Object.hasOwnProperty.call(message, "networkFirewallPolicyEnforcementOrder"))
                                writer.uint32(/* id 6504784, wireType 2 =*/52038274).string(message.networkFirewallPolicyEnforcementOrder);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.selfLinkWithId != null && Object.hasOwnProperty.call(message, "selfLinkWithId"))
                                writer.uint32(/* id 44520962, wireType 2 =*/356167698).string(message.selfLinkWithId);
                            if (message.IPv4Range != null && Object.hasOwnProperty.call(message, "IPv4Range"))
                                writer.uint32(/* id 59234358, wireType 2 =*/473874866).string(message.IPv4Range);
                            if (message.peerings != null && message.peerings.length)
                                for (var i = 0; i < message.peerings.length; ++i)
                                    $root.google.cloud.compute.v1.NetworkPeering.encode(message.peerings[i], writer.uint32(/* id 69883187, wireType 2 =*/559065498).fork()).ldelim();
                            if (message.gatewayIPv4 != null && Object.hasOwnProperty.call(message, "gatewayIPv4"))
                                writer.uint32(/* id 178678877, wireType 2 =*/1429431018).string(message.gatewayIPv4);
                            if (message.autoCreateSubnetworks != null && Object.hasOwnProperty.call(message, "autoCreateSubnetworks"))
                                writer.uint32(/* id 256156690, wireType 0 =*/2049253520).bool(message.autoCreateSubnetworks);
                            if (message.internalIpv6Range != null && Object.hasOwnProperty.call(message, "internalIpv6Range"))
                                writer.uint32(/* id 277456807, wireType 2 =*/2219654458).string(message.internalIpv6Range);
                            if (message.subnetworks != null && message.subnetworks.length)
                                for (var i = 0; i < message.subnetworks.length; ++i)
                                    writer.uint32(/* id 415853125, wireType 2 =*/3326825002).string(message.subnetworks[i]);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.enableUlaInternalIpv6 != null && Object.hasOwnProperty.call(message, "enableUlaInternalIpv6"))
                                writer.uint32(/* id 423757720, wireType 0 =*/3390061760).bool(message.enableUlaInternalIpv6);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            if (message.routingConfig != null && Object.hasOwnProperty.call(message, "routingConfig"))
                                $root.google.cloud.compute.v1.NetworkRoutingConfig.encode(message.routingConfig, writer.uint32(/* id 523556059, wireType 2 =*/4188448474).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Network message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Network.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Network
                         * @static
                         * @param {google.cloud.compute.v1.INetwork} message Network message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Network.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Network message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Network
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Network} Network
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Network.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Network();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 59234358: {
                                        message.IPv4Range = reader.string();
                                        break;
                                    }
                                case 256156690: {
                                        message.autoCreateSubnetworks = reader.bool();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 423757720: {
                                        message.enableUlaInternalIpv6 = reader.bool();
                                        break;
                                    }
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 178678877: {
                                        message.gatewayIPv4 = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 277456807: {
                                        message.internalIpv6Range = reader.string();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 108462: {
                                        message.mtu = reader.int32();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 6504784: {
                                        message.networkFirewallPolicyEnforcementOrder = reader.string();
                                        break;
                                    }
                                case 69883187: {
                                        if (!(message.peerings && message.peerings.length))
                                            message.peerings = [];
                                        message.peerings.push($root.google.cloud.compute.v1.NetworkPeering.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 523556059: {
                                        message.routingConfig = $root.google.cloud.compute.v1.NetworkRoutingConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 44520962: {
                                        message.selfLinkWithId = reader.string();
                                        break;
                                    }
                                case 415853125: {
                                        if (!(message.subnetworks && message.subnetworks.length))
                                            message.subnetworks = [];
                                        message.subnetworks.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Network message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Network
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Network} Network
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Network.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Network message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Network
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Network.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.IPv4Range != null && message.hasOwnProperty("IPv4Range")) {
                                properties._IPv4Range = 1;
                                if (!$util.isString(message.IPv4Range))
                                    return "IPv4Range: string expected";
                            }
                            if (message.autoCreateSubnetworks != null && message.hasOwnProperty("autoCreateSubnetworks")) {
                                properties._autoCreateSubnetworks = 1;
                                if (typeof message.autoCreateSubnetworks !== "boolean")
                                    return "autoCreateSubnetworks: boolean expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.enableUlaInternalIpv6 != null && message.hasOwnProperty("enableUlaInternalIpv6")) {
                                properties._enableUlaInternalIpv6 = 1;
                                if (typeof message.enableUlaInternalIpv6 !== "boolean")
                                    return "enableUlaInternalIpv6: boolean expected";
                            }
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy")) {
                                properties._firewallPolicy = 1;
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            }
                            if (message.gatewayIPv4 != null && message.hasOwnProperty("gatewayIPv4")) {
                                properties._gatewayIPv4 = 1;
                                if (!$util.isString(message.gatewayIPv4))
                                    return "gatewayIPv4: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.internalIpv6Range != null && message.hasOwnProperty("internalIpv6Range")) {
                                properties._internalIpv6Range = 1;
                                if (!$util.isString(message.internalIpv6Range))
                                    return "internalIpv6Range: string expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.mtu != null && message.hasOwnProperty("mtu")) {
                                properties._mtu = 1;
                                if (!$util.isInteger(message.mtu))
                                    return "mtu: integer expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.networkFirewallPolicyEnforcementOrder != null && message.hasOwnProperty("networkFirewallPolicyEnforcementOrder")) {
                                properties._networkFirewallPolicyEnforcementOrder = 1;
                                if (!$util.isString(message.networkFirewallPolicyEnforcementOrder))
                                    return "networkFirewallPolicyEnforcementOrder: string expected";
                            }
                            if (message.peerings != null && message.hasOwnProperty("peerings")) {
                                if (!Array.isArray(message.peerings))
                                    return "peerings: array expected";
                                for (var i = 0; i < message.peerings.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NetworkPeering.verify(message.peerings[i]);
                                    if (error)
                                        return "peerings." + error;
                                }
                            }
                            if (message.routingConfig != null && message.hasOwnProperty("routingConfig")) {
                                properties._routingConfig = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.NetworkRoutingConfig.verify(message.routingConfig);
                                    if (error)
                                        return "routingConfig." + error;
                                }
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.selfLinkWithId != null && message.hasOwnProperty("selfLinkWithId")) {
                                properties._selfLinkWithId = 1;
                                if (!$util.isString(message.selfLinkWithId))
                                    return "selfLinkWithId: string expected";
                            }
                            if (message.subnetworks != null && message.hasOwnProperty("subnetworks")) {
                                if (!Array.isArray(message.subnetworks))
                                    return "subnetworks: array expected";
                                for (var i = 0; i < message.subnetworks.length; ++i)
                                    if (!$util.isString(message.subnetworks[i]))
                                        return "subnetworks: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Network message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Network
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Network} Network
                         */
                        Network.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Network)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Network();
                            if (object.IPv4Range != null)
                                message.IPv4Range = String(object.IPv4Range);
                            if (object.autoCreateSubnetworks != null)
                                message.autoCreateSubnetworks = Boolean(object.autoCreateSubnetworks);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.enableUlaInternalIpv6 != null)
                                message.enableUlaInternalIpv6 = Boolean(object.enableUlaInternalIpv6);
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.gatewayIPv4 != null)
                                message.gatewayIPv4 = String(object.gatewayIPv4);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.internalIpv6Range != null)
                                message.internalIpv6Range = String(object.internalIpv6Range);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.mtu != null)
                                message.mtu = object.mtu | 0;
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.networkFirewallPolicyEnforcementOrder != null)
                                message.networkFirewallPolicyEnforcementOrder = String(object.networkFirewallPolicyEnforcementOrder);
                            if (object.peerings) {
                                if (!Array.isArray(object.peerings))
                                    throw TypeError(".google.cloud.compute.v1.Network.peerings: array expected");
                                message.peerings = [];
                                for (var i = 0; i < object.peerings.length; ++i) {
                                    if (typeof object.peerings[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Network.peerings: object expected");
                                    message.peerings[i] = $root.google.cloud.compute.v1.NetworkPeering.fromObject(object.peerings[i]);
                                }
                            }
                            if (object.routingConfig != null) {
                                if (typeof object.routingConfig !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Network.routingConfig: object expected");
                                message.routingConfig = $root.google.cloud.compute.v1.NetworkRoutingConfig.fromObject(object.routingConfig);
                            }
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.selfLinkWithId != null)
                                message.selfLinkWithId = String(object.selfLinkWithId);
                            if (object.subnetworks) {
                                if (!Array.isArray(object.subnetworks))
                                    throw TypeError(".google.cloud.compute.v1.Network.subnetworks: array expected");
                                message.subnetworks = [];
                                for (var i = 0; i < object.subnetworks.length; ++i)
                                    message.subnetworks[i] = String(object.subnetworks[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Network message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Network
                         * @static
                         * @param {google.cloud.compute.v1.Network} message Network
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Network.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.peerings = [];
                                object.subnetworks = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.mtu != null && message.hasOwnProperty("mtu")) {
                                object.mtu = message.mtu;
                                if (options.oneofs)
                                    object._mtu = "mtu";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.networkFirewallPolicyEnforcementOrder != null && message.hasOwnProperty("networkFirewallPolicyEnforcementOrder")) {
                                object.networkFirewallPolicyEnforcementOrder = message.networkFirewallPolicyEnforcementOrder;
                                if (options.oneofs)
                                    object._networkFirewallPolicyEnforcementOrder = "networkFirewallPolicyEnforcementOrder";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.selfLinkWithId != null && message.hasOwnProperty("selfLinkWithId")) {
                                object.selfLinkWithId = message.selfLinkWithId;
                                if (options.oneofs)
                                    object._selfLinkWithId = "selfLinkWithId";
                            }
                            if (message.IPv4Range != null && message.hasOwnProperty("IPv4Range")) {
                                object.IPv4Range = message.IPv4Range;
                                if (options.oneofs)
                                    object._IPv4Range = "IPv4Range";
                            }
                            if (message.peerings && message.peerings.length) {
                                object.peerings = [];
                                for (var j = 0; j < message.peerings.length; ++j)
                                    object.peerings[j] = $root.google.cloud.compute.v1.NetworkPeering.toObject(message.peerings[j], options);
                            }
                            if (message.gatewayIPv4 != null && message.hasOwnProperty("gatewayIPv4")) {
                                object.gatewayIPv4 = message.gatewayIPv4;
                                if (options.oneofs)
                                    object._gatewayIPv4 = "gatewayIPv4";
                            }
                            if (message.autoCreateSubnetworks != null && message.hasOwnProperty("autoCreateSubnetworks")) {
                                object.autoCreateSubnetworks = message.autoCreateSubnetworks;
                                if (options.oneofs)
                                    object._autoCreateSubnetworks = "autoCreateSubnetworks";
                            }
                            if (message.internalIpv6Range != null && message.hasOwnProperty("internalIpv6Range")) {
                                object.internalIpv6Range = message.internalIpv6Range;
                                if (options.oneofs)
                                    object._internalIpv6Range = "internalIpv6Range";
                            }
                            if (message.subnetworks && message.subnetworks.length) {
                                object.subnetworks = [];
                                for (var j = 0; j < message.subnetworks.length; ++j)
                                    object.subnetworks[j] = message.subnetworks[j];
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.enableUlaInternalIpv6 != null && message.hasOwnProperty("enableUlaInternalIpv6")) {
                                object.enableUlaInternalIpv6 = message.enableUlaInternalIpv6;
                                if (options.oneofs)
                                    object._enableUlaInternalIpv6 = "enableUlaInternalIpv6";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy")) {
                                object.firewallPolicy = message.firewallPolicy;
                                if (options.oneofs)
                                    object._firewallPolicy = "firewallPolicy";
                            }
                            if (message.routingConfig != null && message.hasOwnProperty("routingConfig")) {
                                object.routingConfig = $root.google.cloud.compute.v1.NetworkRoutingConfig.toObject(message.routingConfig, options);
                                if (options.oneofs)
                                    object._routingConfig = "routingConfig";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Network to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Network
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Network.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Network
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Network
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Network.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Network";
                        };
    
                        /**
                         * NetworkFirewallPolicyEnforcementOrder enum.
                         * @name google.cloud.compute.v1.Network.NetworkFirewallPolicyEnforcementOrder
                         * @enum {number}
                         * @property {number} UNDEFINED_NETWORK_FIREWALL_POLICY_ENFORCEMENT_ORDER=0 UNDEFINED_NETWORK_FIREWALL_POLICY_ENFORCEMENT_ORDER value
                         * @property {number} AFTER_CLASSIC_FIREWALL=154582608 AFTER_CLASSIC_FIREWALL value
                         * @property {number} BEFORE_CLASSIC_FIREWALL=338458349 BEFORE_CLASSIC_FIREWALL value
                         */
                        Network.NetworkFirewallPolicyEnforcementOrder = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_NETWORK_FIREWALL_POLICY_ENFORCEMENT_ORDER"] = 0;
                            values[valuesById[154582608] = "AFTER_CLASSIC_FIREWALL"] = 154582608;
                            values[valuesById[338458349] = "BEFORE_CLASSIC_FIREWALL"] = 338458349;
                            return values;
                        })();
    
                        return Network;
                    })();
    
                    v1.NetworkEdgeSecurityService = (function() {
    
                        /**
                         * Properties of a NetworkEdgeSecurityService.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkEdgeSecurityService
                         * @property {string|null} [creationTimestamp] NetworkEdgeSecurityService creationTimestamp
                         * @property {string|null} [description] NetworkEdgeSecurityService description
                         * @property {string|null} [fingerprint] NetworkEdgeSecurityService fingerprint
                         * @property {number|Long|null} [id] NetworkEdgeSecurityService id
                         * @property {string|null} [kind] NetworkEdgeSecurityService kind
                         * @property {string|null} [name] NetworkEdgeSecurityService name
                         * @property {string|null} [region] NetworkEdgeSecurityService region
                         * @property {string|null} [securityPolicy] NetworkEdgeSecurityService securityPolicy
                         * @property {string|null} [selfLink] NetworkEdgeSecurityService selfLink
                         * @property {string|null} [selfLinkWithId] NetworkEdgeSecurityService selfLinkWithId
                         */
    
                        /**
                         * Constructs a new NetworkEdgeSecurityService.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkEdgeSecurityService.
                         * @implements INetworkEdgeSecurityService
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkEdgeSecurityService=} [properties] Properties to set
                         */
                        function NetworkEdgeSecurityService(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkEdgeSecurityService creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         */
                        NetworkEdgeSecurityService.prototype.creationTimestamp = null;
    
                        /**
                         * NetworkEdgeSecurityService description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         */
                        NetworkEdgeSecurityService.prototype.description = null;
    
                        /**
                         * NetworkEdgeSecurityService fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         */
                        NetworkEdgeSecurityService.prototype.fingerprint = null;
    
                        /**
                         * NetworkEdgeSecurityService id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         */
                        NetworkEdgeSecurityService.prototype.id = null;
    
                        /**
                         * NetworkEdgeSecurityService kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         */
                        NetworkEdgeSecurityService.prototype.kind = null;
    
                        /**
                         * NetworkEdgeSecurityService name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         */
                        NetworkEdgeSecurityService.prototype.name = null;
    
                        /**
                         * NetworkEdgeSecurityService region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         */
                        NetworkEdgeSecurityService.prototype.region = null;
    
                        /**
                         * NetworkEdgeSecurityService securityPolicy.
                         * @member {string|null|undefined} securityPolicy
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         */
                        NetworkEdgeSecurityService.prototype.securityPolicy = null;
    
                        /**
                         * NetworkEdgeSecurityService selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         */
                        NetworkEdgeSecurityService.prototype.selfLink = null;
    
                        /**
                         * NetworkEdgeSecurityService selfLinkWithId.
                         * @member {string|null|undefined} selfLinkWithId
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         */
                        NetworkEdgeSecurityService.prototype.selfLinkWithId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworkEdgeSecurityService _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         */
                        Object.defineProperty(NetworkEdgeSecurityService.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEdgeSecurityService _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         */
                        Object.defineProperty(NetworkEdgeSecurityService.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEdgeSecurityService _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         */
                        Object.defineProperty(NetworkEdgeSecurityService.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEdgeSecurityService _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         */
                        Object.defineProperty(NetworkEdgeSecurityService.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEdgeSecurityService _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         */
                        Object.defineProperty(NetworkEdgeSecurityService.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEdgeSecurityService _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         */
                        Object.defineProperty(NetworkEdgeSecurityService.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEdgeSecurityService _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         */
                        Object.defineProperty(NetworkEdgeSecurityService.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEdgeSecurityService _securityPolicy.
                         * @member {"securityPolicy"|undefined} _securityPolicy
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         */
                        Object.defineProperty(NetworkEdgeSecurityService.prototype, "_securityPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["securityPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEdgeSecurityService _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         */
                        Object.defineProperty(NetworkEdgeSecurityService.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEdgeSecurityService _selfLinkWithId.
                         * @member {"selfLinkWithId"|undefined} _selfLinkWithId
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         */
                        Object.defineProperty(NetworkEdgeSecurityService.prototype, "_selfLinkWithId", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLinkWithId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworkEdgeSecurityService instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEdgeSecurityService=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkEdgeSecurityService} NetworkEdgeSecurityService instance
                         */
                        NetworkEdgeSecurityService.create = function create(properties) {
                            return new NetworkEdgeSecurityService(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkEdgeSecurityService message. Does not implicitly {@link google.cloud.compute.v1.NetworkEdgeSecurityService.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEdgeSecurityService} message NetworkEdgeSecurityService message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEdgeSecurityService.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.selfLinkWithId != null && Object.hasOwnProperty.call(message, "selfLinkWithId"))
                                writer.uint32(/* id 44520962, wireType 2 =*/356167698).string(message.selfLinkWithId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.securityPolicy != null && Object.hasOwnProperty.call(message, "securityPolicy"))
                                writer.uint32(/* id 171082513, wireType 2 =*/1368660106).string(message.securityPolicy);
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkEdgeSecurityService message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkEdgeSecurityService.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEdgeSecurityService} message NetworkEdgeSecurityService message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEdgeSecurityService.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkEdgeSecurityService message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkEdgeSecurityService} NetworkEdgeSecurityService
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEdgeSecurityService.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkEdgeSecurityService();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 171082513: {
                                        message.securityPolicy = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 44520962: {
                                        message.selfLinkWithId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkEdgeSecurityService message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkEdgeSecurityService} NetworkEdgeSecurityService
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEdgeSecurityService.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkEdgeSecurityService message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkEdgeSecurityService.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy")) {
                                properties._securityPolicy = 1;
                                if (!$util.isString(message.securityPolicy))
                                    return "securityPolicy: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.selfLinkWithId != null && message.hasOwnProperty("selfLinkWithId")) {
                                properties._selfLinkWithId = 1;
                                if (!$util.isString(message.selfLinkWithId))
                                    return "selfLinkWithId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkEdgeSecurityService message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkEdgeSecurityService} NetworkEdgeSecurityService
                         */
                        NetworkEdgeSecurityService.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkEdgeSecurityService)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkEdgeSecurityService();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.securityPolicy != null)
                                message.securityPolicy = String(object.securityPolicy);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.selfLinkWithId != null)
                                message.selfLinkWithId = String(object.selfLinkWithId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkEdgeSecurityService message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @static
                         * @param {google.cloud.compute.v1.NetworkEdgeSecurityService} message NetworkEdgeSecurityService
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkEdgeSecurityService.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.selfLinkWithId != null && message.hasOwnProperty("selfLinkWithId")) {
                                object.selfLinkWithId = message.selfLinkWithId;
                                if (options.oneofs)
                                    object._selfLinkWithId = "selfLinkWithId";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy")) {
                                object.securityPolicy = message.securityPolicy;
                                if (options.oneofs)
                                    object._securityPolicy = "securityPolicy";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkEdgeSecurityService to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkEdgeSecurityService.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkEdgeSecurityService
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityService
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkEdgeSecurityService.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkEdgeSecurityService";
                        };
    
                        return NetworkEdgeSecurityService;
                    })();
    
                    v1.NetworkEdgeSecurityServiceAggregatedList = (function() {
    
                        /**
                         * Properties of a NetworkEdgeSecurityServiceAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkEdgeSecurityServiceAggregatedList
                         * @property {string|null} [etag] NetworkEdgeSecurityServiceAggregatedList etag
                         * @property {string|null} [id] NetworkEdgeSecurityServiceAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.INetworkEdgeSecurityServicesScopedList>|null} [items] NetworkEdgeSecurityServiceAggregatedList items
                         * @property {string|null} [kind] NetworkEdgeSecurityServiceAggregatedList kind
                         * @property {string|null} [nextPageToken] NetworkEdgeSecurityServiceAggregatedList nextPageToken
                         * @property {string|null} [selfLink] NetworkEdgeSecurityServiceAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] NetworkEdgeSecurityServiceAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] NetworkEdgeSecurityServiceAggregatedList warning
                         */
    
                        /**
                         * Constructs a new NetworkEdgeSecurityServiceAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkEdgeSecurityServiceAggregatedList.
                         * @implements INetworkEdgeSecurityServiceAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkEdgeSecurityServiceAggregatedList=} [properties] Properties to set
                         */
                        function NetworkEdgeSecurityServiceAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkEdgeSecurityServiceAggregatedList etag.
                         * @member {string|null|undefined} etag
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @instance
                         */
                        NetworkEdgeSecurityServiceAggregatedList.prototype.etag = null;
    
                        /**
                         * NetworkEdgeSecurityServiceAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @instance
                         */
                        NetworkEdgeSecurityServiceAggregatedList.prototype.id = null;
    
                        /**
                         * NetworkEdgeSecurityServiceAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.INetworkEdgeSecurityServicesScopedList>} items
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @instance
                         */
                        NetworkEdgeSecurityServiceAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * NetworkEdgeSecurityServiceAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @instance
                         */
                        NetworkEdgeSecurityServiceAggregatedList.prototype.kind = null;
    
                        /**
                         * NetworkEdgeSecurityServiceAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @instance
                         */
                        NetworkEdgeSecurityServiceAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * NetworkEdgeSecurityServiceAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @instance
                         */
                        NetworkEdgeSecurityServiceAggregatedList.prototype.selfLink = null;
    
                        /**
                         * NetworkEdgeSecurityServiceAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @instance
                         */
                        NetworkEdgeSecurityServiceAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * NetworkEdgeSecurityServiceAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @instance
                         */
                        NetworkEdgeSecurityServiceAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworkEdgeSecurityServiceAggregatedList _etag.
                         * @member {"etag"|undefined} _etag
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NetworkEdgeSecurityServiceAggregatedList.prototype, "_etag", {
                            get: $util.oneOfGetter($oneOfFields = ["etag"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEdgeSecurityServiceAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NetworkEdgeSecurityServiceAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEdgeSecurityServiceAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NetworkEdgeSecurityServiceAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEdgeSecurityServiceAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NetworkEdgeSecurityServiceAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEdgeSecurityServiceAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NetworkEdgeSecurityServiceAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEdgeSecurityServiceAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NetworkEdgeSecurityServiceAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworkEdgeSecurityServiceAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEdgeSecurityServiceAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList} NetworkEdgeSecurityServiceAggregatedList instance
                         */
                        NetworkEdgeSecurityServiceAggregatedList.create = function create(properties) {
                            return new NetworkEdgeSecurityServiceAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkEdgeSecurityServiceAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEdgeSecurityServiceAggregatedList} message NetworkEdgeSecurityServiceAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEdgeSecurityServiceAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.etag != null && Object.hasOwnProperty.call(message, "etag"))
                                writer.uint32(/* id 3123477, wireType 2 =*/24987818).string(message.etag);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkEdgeSecurityServiceAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEdgeSecurityServiceAggregatedList} message NetworkEdgeSecurityServiceAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEdgeSecurityServiceAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkEdgeSecurityServiceAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList} NetworkEdgeSecurityServiceAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEdgeSecurityServiceAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3123477: {
                                        message.etag = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkEdgeSecurityServiceAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList} NetworkEdgeSecurityServiceAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEdgeSecurityServiceAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkEdgeSecurityServiceAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkEdgeSecurityServiceAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                properties._etag = 1;
                                if (!$util.isString(message.etag))
                                    return "etag: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkEdgeSecurityServiceAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList} NetworkEdgeSecurityServiceAggregatedList
                         */
                        NetworkEdgeSecurityServiceAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList();
                            if (object.etag != null)
                                message.etag = String(object.etag);
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkEdgeSecurityServiceAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList} message NetworkEdgeSecurityServiceAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkEdgeSecurityServiceAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                object.etag = message.etag;
                                if (options.oneofs)
                                    object._etag = "etag";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkEdgeSecurityServiceAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkEdgeSecurityServiceAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkEdgeSecurityServiceAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkEdgeSecurityServiceAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList";
                        };
    
                        return NetworkEdgeSecurityServiceAggregatedList;
                    })();
    
                    v1.NetworkEdgeSecurityServicesScopedList = (function() {
    
                        /**
                         * Properties of a NetworkEdgeSecurityServicesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkEdgeSecurityServicesScopedList
                         * @property {Array.<google.cloud.compute.v1.INetworkEdgeSecurityService>|null} [networkEdgeSecurityServices] NetworkEdgeSecurityServicesScopedList networkEdgeSecurityServices
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] NetworkEdgeSecurityServicesScopedList warning
                         */
    
                        /**
                         * Constructs a new NetworkEdgeSecurityServicesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkEdgeSecurityServicesScopedList.
                         * @implements INetworkEdgeSecurityServicesScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkEdgeSecurityServicesScopedList=} [properties] Properties to set
                         */
                        function NetworkEdgeSecurityServicesScopedList(properties) {
                            this.networkEdgeSecurityServices = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkEdgeSecurityServicesScopedList networkEdgeSecurityServices.
                         * @member {Array.<google.cloud.compute.v1.INetworkEdgeSecurityService>} networkEdgeSecurityServices
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList
                         * @instance
                         */
                        NetworkEdgeSecurityServicesScopedList.prototype.networkEdgeSecurityServices = $util.emptyArray;
    
                        /**
                         * NetworkEdgeSecurityServicesScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList
                         * @instance
                         */
                        NetworkEdgeSecurityServicesScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworkEdgeSecurityServicesScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList
                         * @instance
                         */
                        Object.defineProperty(NetworkEdgeSecurityServicesScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworkEdgeSecurityServicesScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEdgeSecurityServicesScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList} NetworkEdgeSecurityServicesScopedList instance
                         */
                        NetworkEdgeSecurityServicesScopedList.create = function create(properties) {
                            return new NetworkEdgeSecurityServicesScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkEdgeSecurityServicesScopedList message. Does not implicitly {@link google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEdgeSecurityServicesScopedList} message NetworkEdgeSecurityServicesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEdgeSecurityServicesScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.networkEdgeSecurityServices != null && message.networkEdgeSecurityServices.length)
                                for (var i = 0; i < message.networkEdgeSecurityServices.length; ++i)
                                    $root.google.cloud.compute.v1.NetworkEdgeSecurityService.encode(message.networkEdgeSecurityServices[i], writer.uint32(/* id 35530156, wireType 2 =*/284241250).fork()).ldelim();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkEdgeSecurityServicesScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEdgeSecurityServicesScopedList} message NetworkEdgeSecurityServicesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEdgeSecurityServicesScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkEdgeSecurityServicesScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList} NetworkEdgeSecurityServicesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEdgeSecurityServicesScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 35530156: {
                                        if (!(message.networkEdgeSecurityServices && message.networkEdgeSecurityServices.length))
                                            message.networkEdgeSecurityServices = [];
                                        message.networkEdgeSecurityServices.push($root.google.cloud.compute.v1.NetworkEdgeSecurityService.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkEdgeSecurityServicesScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList} NetworkEdgeSecurityServicesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEdgeSecurityServicesScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkEdgeSecurityServicesScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkEdgeSecurityServicesScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.networkEdgeSecurityServices != null && message.hasOwnProperty("networkEdgeSecurityServices")) {
                                if (!Array.isArray(message.networkEdgeSecurityServices))
                                    return "networkEdgeSecurityServices: array expected";
                                for (var i = 0; i < message.networkEdgeSecurityServices.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NetworkEdgeSecurityService.verify(message.networkEdgeSecurityServices[i]);
                                    if (error)
                                        return "networkEdgeSecurityServices." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkEdgeSecurityServicesScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList} NetworkEdgeSecurityServicesScopedList
                         */
                        NetworkEdgeSecurityServicesScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList();
                            if (object.networkEdgeSecurityServices) {
                                if (!Array.isArray(object.networkEdgeSecurityServices))
                                    throw TypeError(".google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList.networkEdgeSecurityServices: array expected");
                                message.networkEdgeSecurityServices = [];
                                for (var i = 0; i < object.networkEdgeSecurityServices.length; ++i) {
                                    if (typeof object.networkEdgeSecurityServices[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList.networkEdgeSecurityServices: object expected");
                                    message.networkEdgeSecurityServices[i] = $root.google.cloud.compute.v1.NetworkEdgeSecurityService.fromObject(object.networkEdgeSecurityServices[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkEdgeSecurityServicesScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList} message NetworkEdgeSecurityServicesScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkEdgeSecurityServicesScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.networkEdgeSecurityServices = [];
                            if (message.networkEdgeSecurityServices && message.networkEdgeSecurityServices.length) {
                                object.networkEdgeSecurityServices = [];
                                for (var j = 0; j < message.networkEdgeSecurityServices.length; ++j)
                                    object.networkEdgeSecurityServices[j] = $root.google.cloud.compute.v1.NetworkEdgeSecurityService.toObject(message.networkEdgeSecurityServices[j], options);
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkEdgeSecurityServicesScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkEdgeSecurityServicesScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkEdgeSecurityServicesScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkEdgeSecurityServicesScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkEdgeSecurityServicesScopedList";
                        };
    
                        return NetworkEdgeSecurityServicesScopedList;
                    })();
    
                    v1.NetworkEndpoint = (function() {
    
                        /**
                         * Properties of a NetworkEndpoint.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkEndpoint
                         * @property {Object.<string,string>|null} [annotations] NetworkEndpoint annotations
                         * @property {string|null} [fqdn] NetworkEndpoint fqdn
                         * @property {string|null} [instance] NetworkEndpoint instance
                         * @property {string|null} [ipAddress] NetworkEndpoint ipAddress
                         * @property {number|null} [port] NetworkEndpoint port
                         */
    
                        /**
                         * Constructs a new NetworkEndpoint.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkEndpoint.
                         * @implements INetworkEndpoint
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkEndpoint=} [properties] Properties to set
                         */
                        function NetworkEndpoint(properties) {
                            this.annotations = {};
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkEndpoint annotations.
                         * @member {Object.<string,string>} annotations
                         * @memberof google.cloud.compute.v1.NetworkEndpoint
                         * @instance
                         */
                        NetworkEndpoint.prototype.annotations = $util.emptyObject;
    
                        /**
                         * NetworkEndpoint fqdn.
                         * @member {string|null|undefined} fqdn
                         * @memberof google.cloud.compute.v1.NetworkEndpoint
                         * @instance
                         */
                        NetworkEndpoint.prototype.fqdn = null;
    
                        /**
                         * NetworkEndpoint instance.
                         * @member {string|null|undefined} instance
                         * @memberof google.cloud.compute.v1.NetworkEndpoint
                         * @instance
                         */
                        NetworkEndpoint.prototype.instance = null;
    
                        /**
                         * NetworkEndpoint ipAddress.
                         * @member {string|null|undefined} ipAddress
                         * @memberof google.cloud.compute.v1.NetworkEndpoint
                         * @instance
                         */
                        NetworkEndpoint.prototype.ipAddress = null;
    
                        /**
                         * NetworkEndpoint port.
                         * @member {number|null|undefined} port
                         * @memberof google.cloud.compute.v1.NetworkEndpoint
                         * @instance
                         */
                        NetworkEndpoint.prototype.port = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworkEndpoint _fqdn.
                         * @member {"fqdn"|undefined} _fqdn
                         * @memberof google.cloud.compute.v1.NetworkEndpoint
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpoint.prototype, "_fqdn", {
                            get: $util.oneOfGetter($oneOfFields = ["fqdn"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpoint _instance.
                         * @member {"instance"|undefined} _instance
                         * @memberof google.cloud.compute.v1.NetworkEndpoint
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpoint.prototype, "_instance", {
                            get: $util.oneOfGetter($oneOfFields = ["instance"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpoint _ipAddress.
                         * @member {"ipAddress"|undefined} _ipAddress
                         * @memberof google.cloud.compute.v1.NetworkEndpoint
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpoint.prototype, "_ipAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["ipAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpoint _port.
                         * @member {"port"|undefined} _port
                         * @memberof google.cloud.compute.v1.NetworkEndpoint
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpoint.prototype, "_port", {
                            get: $util.oneOfGetter($oneOfFields = ["port"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworkEndpoint instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkEndpoint
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpoint=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkEndpoint} NetworkEndpoint instance
                         */
                        NetworkEndpoint.create = function create(properties) {
                            return new NetworkEndpoint(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkEndpoint message. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpoint.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkEndpoint
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpoint} message NetworkEndpoint message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpoint.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.fqdn != null && Object.hasOwnProperty.call(message, "fqdn"))
                                writer.uint32(/* id 3150485, wireType 2 =*/25203882).string(message.fqdn);
                            if (message.port != null && Object.hasOwnProperty.call(message, "port"))
                                writer.uint32(/* id 3446913, wireType 0 =*/27575304).int32(message.port);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.annotations != null && Object.hasOwnProperty.call(message, "annotations"))
                                for (var keys = Object.keys(message.annotations), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 112032548, wireType 2 =*/896260386).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.annotations[keys[i]]).ldelim();
                            if (message.ipAddress != null && Object.hasOwnProperty.call(message, "ipAddress"))
                                writer.uint32(/* id 406272220, wireType 2 =*/3250177762).string(message.ipAddress);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkEndpoint message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpoint.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpoint
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpoint} message NetworkEndpoint message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpoint.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkEndpoint message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkEndpoint
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkEndpoint} NetworkEndpoint
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpoint.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkEndpoint(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 112032548: {
                                        if (message.annotations === $util.emptyObject)
                                            message.annotations = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.annotations[key] = value;
                                        break;
                                    }
                                case 3150485: {
                                        message.fqdn = reader.string();
                                        break;
                                    }
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 406272220: {
                                        message.ipAddress = reader.string();
                                        break;
                                    }
                                case 3446913: {
                                        message.port = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkEndpoint message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpoint
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkEndpoint} NetworkEndpoint
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpoint.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkEndpoint message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkEndpoint
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkEndpoint.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.annotations != null && message.hasOwnProperty("annotations")) {
                                if (!$util.isObject(message.annotations))
                                    return "annotations: object expected";
                                var key = Object.keys(message.annotations);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.annotations[key[i]]))
                                        return "annotations: string{k:string} expected";
                            }
                            if (message.fqdn != null && message.hasOwnProperty("fqdn")) {
                                properties._fqdn = 1;
                                if (!$util.isString(message.fqdn))
                                    return "fqdn: string expected";
                            }
                            if (message.instance != null && message.hasOwnProperty("instance")) {
                                properties._instance = 1;
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            }
                            if (message.ipAddress != null && message.hasOwnProperty("ipAddress")) {
                                properties._ipAddress = 1;
                                if (!$util.isString(message.ipAddress))
                                    return "ipAddress: string expected";
                            }
                            if (message.port != null && message.hasOwnProperty("port")) {
                                properties._port = 1;
                                if (!$util.isInteger(message.port))
                                    return "port: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkEndpoint message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkEndpoint
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkEndpoint} NetworkEndpoint
                         */
                        NetworkEndpoint.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkEndpoint)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkEndpoint();
                            if (object.annotations) {
                                if (typeof object.annotations !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NetworkEndpoint.annotations: object expected");
                                message.annotations = {};
                                for (var keys = Object.keys(object.annotations), i = 0; i < keys.length; ++i)
                                    message.annotations[keys[i]] = String(object.annotations[keys[i]]);
                            }
                            if (object.fqdn != null)
                                message.fqdn = String(object.fqdn);
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.ipAddress != null)
                                message.ipAddress = String(object.ipAddress);
                            if (object.port != null)
                                message.port = object.port | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkEndpoint message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkEndpoint
                         * @static
                         * @param {google.cloud.compute.v1.NetworkEndpoint} message NetworkEndpoint
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkEndpoint.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.objects || options.defaults)
                                object.annotations = {};
                            if (message.fqdn != null && message.hasOwnProperty("fqdn")) {
                                object.fqdn = message.fqdn;
                                if (options.oneofs)
                                    object._fqdn = "fqdn";
                            }
                            if (message.port != null && message.hasOwnProperty("port")) {
                                object.port = message.port;
                                if (options.oneofs)
                                    object._port = "port";
                            }
                            if (message.instance != null && message.hasOwnProperty("instance")) {
                                object.instance = message.instance;
                                if (options.oneofs)
                                    object._instance = "instance";
                            }
                            var keys2;
                            if (message.annotations && (keys2 = Object.keys(message.annotations)).length) {
                                object.annotations = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.annotations[keys2[j]] = message.annotations[keys2[j]];
                            }
                            if (message.ipAddress != null && message.hasOwnProperty("ipAddress")) {
                                object.ipAddress = message.ipAddress;
                                if (options.oneofs)
                                    object._ipAddress = "ipAddress";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkEndpoint to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkEndpoint
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkEndpoint.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkEndpoint
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkEndpoint
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkEndpoint.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkEndpoint";
                        };
    
                        return NetworkEndpoint;
                    })();
    
                    v1.NetworkEndpointGroup = (function() {
    
                        /**
                         * Properties of a NetworkEndpointGroup.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkEndpointGroup
                         * @property {Object.<string,string>|null} [annotations] NetworkEndpointGroup annotations
                         * @property {google.cloud.compute.v1.INetworkEndpointGroupAppEngine|null} [appEngine] NetworkEndpointGroup appEngine
                         * @property {google.cloud.compute.v1.INetworkEndpointGroupCloudFunction|null} [cloudFunction] NetworkEndpointGroup cloudFunction
                         * @property {google.cloud.compute.v1.INetworkEndpointGroupCloudRun|null} [cloudRun] NetworkEndpointGroup cloudRun
                         * @property {string|null} [creationTimestamp] NetworkEndpointGroup creationTimestamp
                         * @property {number|null} [defaultPort] NetworkEndpointGroup defaultPort
                         * @property {string|null} [description] NetworkEndpointGroup description
                         * @property {number|Long|null} [id] NetworkEndpointGroup id
                         * @property {string|null} [kind] NetworkEndpointGroup kind
                         * @property {string|null} [name] NetworkEndpointGroup name
                         * @property {string|null} [network] NetworkEndpointGroup network
                         * @property {string|null} [networkEndpointType] NetworkEndpointGroup networkEndpointType
                         * @property {google.cloud.compute.v1.INetworkEndpointGroupPscData|null} [pscData] NetworkEndpointGroup pscData
                         * @property {string|null} [pscTargetService] NetworkEndpointGroup pscTargetService
                         * @property {string|null} [region] NetworkEndpointGroup region
                         * @property {string|null} [selfLink] NetworkEndpointGroup selfLink
                         * @property {number|null} [size] NetworkEndpointGroup size
                         * @property {string|null} [subnetwork] NetworkEndpointGroup subnetwork
                         * @property {string|null} [zone] NetworkEndpointGroup zone
                         */
    
                        /**
                         * Constructs a new NetworkEndpointGroup.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkEndpointGroup.
                         * @implements INetworkEndpointGroup
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkEndpointGroup=} [properties] Properties to set
                         */
                        function NetworkEndpointGroup(properties) {
                            this.annotations = {};
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkEndpointGroup annotations.
                         * @member {Object.<string,string>} annotations
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        NetworkEndpointGroup.prototype.annotations = $util.emptyObject;
    
                        /**
                         * NetworkEndpointGroup appEngine.
                         * @member {google.cloud.compute.v1.INetworkEndpointGroupAppEngine|null|undefined} appEngine
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        NetworkEndpointGroup.prototype.appEngine = null;
    
                        /**
                         * NetworkEndpointGroup cloudFunction.
                         * @member {google.cloud.compute.v1.INetworkEndpointGroupCloudFunction|null|undefined} cloudFunction
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        NetworkEndpointGroup.prototype.cloudFunction = null;
    
                        /**
                         * NetworkEndpointGroup cloudRun.
                         * @member {google.cloud.compute.v1.INetworkEndpointGroupCloudRun|null|undefined} cloudRun
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        NetworkEndpointGroup.prototype.cloudRun = null;
    
                        /**
                         * NetworkEndpointGroup creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        NetworkEndpointGroup.prototype.creationTimestamp = null;
    
                        /**
                         * NetworkEndpointGroup defaultPort.
                         * @member {number|null|undefined} defaultPort
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        NetworkEndpointGroup.prototype.defaultPort = null;
    
                        /**
                         * NetworkEndpointGroup description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        NetworkEndpointGroup.prototype.description = null;
    
                        /**
                         * NetworkEndpointGroup id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        NetworkEndpointGroup.prototype.id = null;
    
                        /**
                         * NetworkEndpointGroup kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        NetworkEndpointGroup.prototype.kind = null;
    
                        /**
                         * NetworkEndpointGroup name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        NetworkEndpointGroup.prototype.name = null;
    
                        /**
                         * NetworkEndpointGroup network.
                         * @member {string|null|undefined} network
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        NetworkEndpointGroup.prototype.network = null;
    
                        /**
                         * NetworkEndpointGroup networkEndpointType.
                         * @member {string|null|undefined} networkEndpointType
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        NetworkEndpointGroup.prototype.networkEndpointType = null;
    
                        /**
                         * NetworkEndpointGroup pscData.
                         * @member {google.cloud.compute.v1.INetworkEndpointGroupPscData|null|undefined} pscData
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        NetworkEndpointGroup.prototype.pscData = null;
    
                        /**
                         * NetworkEndpointGroup pscTargetService.
                         * @member {string|null|undefined} pscTargetService
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        NetworkEndpointGroup.prototype.pscTargetService = null;
    
                        /**
                         * NetworkEndpointGroup region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        NetworkEndpointGroup.prototype.region = null;
    
                        /**
                         * NetworkEndpointGroup selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        NetworkEndpointGroup.prototype.selfLink = null;
    
                        /**
                         * NetworkEndpointGroup size.
                         * @member {number|null|undefined} size
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        NetworkEndpointGroup.prototype.size = null;
    
                        /**
                         * NetworkEndpointGroup subnetwork.
                         * @member {string|null|undefined} subnetwork
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        NetworkEndpointGroup.prototype.subnetwork = null;
    
                        /**
                         * NetworkEndpointGroup zone.
                         * @member {string|null|undefined} zone
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        NetworkEndpointGroup.prototype.zone = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworkEndpointGroup _appEngine.
                         * @member {"appEngine"|undefined} _appEngine
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroup.prototype, "_appEngine", {
                            get: $util.oneOfGetter($oneOfFields = ["appEngine"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroup _cloudFunction.
                         * @member {"cloudFunction"|undefined} _cloudFunction
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroup.prototype, "_cloudFunction", {
                            get: $util.oneOfGetter($oneOfFields = ["cloudFunction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroup _cloudRun.
                         * @member {"cloudRun"|undefined} _cloudRun
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroup.prototype, "_cloudRun", {
                            get: $util.oneOfGetter($oneOfFields = ["cloudRun"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroup _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroup.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroup _defaultPort.
                         * @member {"defaultPort"|undefined} _defaultPort
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroup.prototype, "_defaultPort", {
                            get: $util.oneOfGetter($oneOfFields = ["defaultPort"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroup _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroup.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroup _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroup.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroup _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroup.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroup _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroup.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroup _network.
                         * @member {"network"|undefined} _network
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroup.prototype, "_network", {
                            get: $util.oneOfGetter($oneOfFields = ["network"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroup _networkEndpointType.
                         * @member {"networkEndpointType"|undefined} _networkEndpointType
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroup.prototype, "_networkEndpointType", {
                            get: $util.oneOfGetter($oneOfFields = ["networkEndpointType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroup _pscData.
                         * @member {"pscData"|undefined} _pscData
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroup.prototype, "_pscData", {
                            get: $util.oneOfGetter($oneOfFields = ["pscData"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroup _pscTargetService.
                         * @member {"pscTargetService"|undefined} _pscTargetService
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroup.prototype, "_pscTargetService", {
                            get: $util.oneOfGetter($oneOfFields = ["pscTargetService"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroup _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroup.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroup _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroup.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroup _size.
                         * @member {"size"|undefined} _size
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroup.prototype, "_size", {
                            get: $util.oneOfGetter($oneOfFields = ["size"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroup _subnetwork.
                         * @member {"subnetwork"|undefined} _subnetwork
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroup.prototype, "_subnetwork", {
                            get: $util.oneOfGetter($oneOfFields = ["subnetwork"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroup _zone.
                         * @member {"zone"|undefined} _zone
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroup.prototype, "_zone", {
                            get: $util.oneOfGetter($oneOfFields = ["zone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworkEndpointGroup instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroup=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroup} NetworkEndpointGroup instance
                         */
                        NetworkEndpointGroup.create = function create(properties) {
                            return new NetworkEndpointGroup(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroup message. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroup.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroup} message NetworkEndpointGroup message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroup.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.size != null && Object.hasOwnProperty.call(message, "size"))
                                writer.uint32(/* id 3530753, wireType 0 =*/28246024).int32(message.size);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.pscData != null && Object.hasOwnProperty.call(message, "pscData"))
                                $root.google.cloud.compute.v1.NetworkEndpointGroupPscData.encode(message.pscData, writer.uint32(/* id 71937481, wireType 2 =*/575499850).fork()).ldelim();
                            if (message.cloudRun != null && Object.hasOwnProperty.call(message, "cloudRun"))
                                $root.google.cloud.compute.v1.NetworkEndpointGroupCloudRun.encode(message.cloudRun, writer.uint32(/* id 111060353, wireType 2 =*/888482826).fork()).ldelim();
                            if (message.annotations != null && Object.hasOwnProperty.call(message, "annotations"))
                                for (var keys = Object.keys(message.annotations), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 112032548, wireType 2 =*/896260386).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.annotations[keys[i]]).ldelim();
                            if (message.networkEndpointType != null && Object.hasOwnProperty.call(message, "networkEndpointType"))
                                writer.uint32(/* id 118301523, wireType 2 =*/946412186).string(message.networkEndpointType);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            if (message.pscTargetService != null && Object.hasOwnProperty.call(message, "pscTargetService"))
                                writer.uint32(/* id 269132134, wireType 2 =*/2153057074).string(message.pscTargetService);
                            if (message.subnetwork != null && Object.hasOwnProperty.call(message, "subnetwork"))
                                writer.uint32(/* id 307827694, wireType 2 =*/2462621554).string(message.subnetwork);
                            if (message.appEngine != null && Object.hasOwnProperty.call(message, "appEngine"))
                                $root.google.cloud.compute.v1.NetworkEndpointGroupAppEngine.encode(message.appEngine, writer.uint32(/* id 340788768, wireType 2 =*/2726310146).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.defaultPort != null && Object.hasOwnProperty.call(message, "defaultPort"))
                                writer.uint32(/* id 423377855, wireType 0 =*/3387022840).int32(message.defaultPort);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.cloudFunction != null && Object.hasOwnProperty.call(message, "cloudFunction"))
                                $root.google.cloud.compute.v1.NetworkEndpointGroupCloudFunction.encode(message.cloudFunction, writer.uint32(/* id 519893666, wireType 2 =*/4159149330).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroup message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroup.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroup} message NetworkEndpointGroup message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroup.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroup message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroup} NetworkEndpointGroup
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroup.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkEndpointGroup(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 112032548: {
                                        if (message.annotations === $util.emptyObject)
                                            message.annotations = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.annotations[key] = value;
                                        break;
                                    }
                                case 340788768: {
                                        message.appEngine = $root.google.cloud.compute.v1.NetworkEndpointGroupAppEngine.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 519893666: {
                                        message.cloudFunction = $root.google.cloud.compute.v1.NetworkEndpointGroupCloudFunction.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 111060353: {
                                        message.cloudRun = $root.google.cloud.compute.v1.NetworkEndpointGroupCloudRun.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 423377855: {
                                        message.defaultPort = reader.int32();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 118301523: {
                                        message.networkEndpointType = reader.string();
                                        break;
                                    }
                                case 71937481: {
                                        message.pscData = $root.google.cloud.compute.v1.NetworkEndpointGroupPscData.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 269132134: {
                                        message.pscTargetService = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 3530753: {
                                        message.size = reader.int32();
                                        break;
                                    }
                                case 307827694: {
                                        message.subnetwork = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroup message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroup} NetworkEndpointGroup
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroup.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkEndpointGroup message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkEndpointGroup.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.annotations != null && message.hasOwnProperty("annotations")) {
                                if (!$util.isObject(message.annotations))
                                    return "annotations: object expected";
                                var key = Object.keys(message.annotations);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.annotations[key[i]]))
                                        return "annotations: string{k:string} expected";
                            }
                            if (message.appEngine != null && message.hasOwnProperty("appEngine")) {
                                properties._appEngine = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.NetworkEndpointGroupAppEngine.verify(message.appEngine);
                                    if (error)
                                        return "appEngine." + error;
                                }
                            }
                            if (message.cloudFunction != null && message.hasOwnProperty("cloudFunction")) {
                                properties._cloudFunction = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.NetworkEndpointGroupCloudFunction.verify(message.cloudFunction);
                                    if (error)
                                        return "cloudFunction." + error;
                                }
                            }
                            if (message.cloudRun != null && message.hasOwnProperty("cloudRun")) {
                                properties._cloudRun = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.NetworkEndpointGroupCloudRun.verify(message.cloudRun);
                                    if (error)
                                        return "cloudRun." + error;
                                }
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.defaultPort != null && message.hasOwnProperty("defaultPort")) {
                                properties._defaultPort = 1;
                                if (!$util.isInteger(message.defaultPort))
                                    return "defaultPort: integer expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                properties._network = 1;
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            }
                            if (message.networkEndpointType != null && message.hasOwnProperty("networkEndpointType")) {
                                properties._networkEndpointType = 1;
                                if (!$util.isString(message.networkEndpointType))
                                    return "networkEndpointType: string expected";
                            }
                            if (message.pscData != null && message.hasOwnProperty("pscData")) {
                                properties._pscData = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.NetworkEndpointGroupPscData.verify(message.pscData);
                                    if (error)
                                        return "pscData." + error;
                                }
                            }
                            if (message.pscTargetService != null && message.hasOwnProperty("pscTargetService")) {
                                properties._pscTargetService = 1;
                                if (!$util.isString(message.pscTargetService))
                                    return "pscTargetService: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.size != null && message.hasOwnProperty("size")) {
                                properties._size = 1;
                                if (!$util.isInteger(message.size))
                                    return "size: integer expected";
                            }
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork")) {
                                properties._subnetwork = 1;
                                if (!$util.isString(message.subnetwork))
                                    return "subnetwork: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                properties._zone = 1;
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkEndpointGroup message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroup} NetworkEndpointGroup
                         */
                        NetworkEndpointGroup.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkEndpointGroup)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkEndpointGroup();
                            if (object.annotations) {
                                if (typeof object.annotations !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroup.annotations: object expected");
                                message.annotations = {};
                                for (var keys = Object.keys(object.annotations), i = 0; i < keys.length; ++i)
                                    message.annotations[keys[i]] = String(object.annotations[keys[i]]);
                            }
                            if (object.appEngine != null) {
                                if (typeof object.appEngine !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroup.appEngine: object expected");
                                message.appEngine = $root.google.cloud.compute.v1.NetworkEndpointGroupAppEngine.fromObject(object.appEngine);
                            }
                            if (object.cloudFunction != null) {
                                if (typeof object.cloudFunction !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroup.cloudFunction: object expected");
                                message.cloudFunction = $root.google.cloud.compute.v1.NetworkEndpointGroupCloudFunction.fromObject(object.cloudFunction);
                            }
                            if (object.cloudRun != null) {
                                if (typeof object.cloudRun !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroup.cloudRun: object expected");
                                message.cloudRun = $root.google.cloud.compute.v1.NetworkEndpointGroupCloudRun.fromObject(object.cloudRun);
                            }
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.defaultPort != null)
                                message.defaultPort = object.defaultPort | 0;
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.networkEndpointType != null)
                                message.networkEndpointType = String(object.networkEndpointType);
                            if (object.pscData != null) {
                                if (typeof object.pscData !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroup.pscData: object expected");
                                message.pscData = $root.google.cloud.compute.v1.NetworkEndpointGroupPscData.fromObject(object.pscData);
                            }
                            if (object.pscTargetService != null)
                                message.pscTargetService = String(object.pscTargetService);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.size != null)
                                message.size = object.size | 0;
                            if (object.subnetwork != null)
                                message.subnetwork = String(object.subnetwork);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkEndpointGroup message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @static
                         * @param {google.cloud.compute.v1.NetworkEndpointGroup} message NetworkEndpointGroup
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkEndpointGroup.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.objects || options.defaults)
                                object.annotations = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.size != null && message.hasOwnProperty("size")) {
                                object.size = message.size;
                                if (options.oneofs)
                                    object._size = "size";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                object.zone = message.zone;
                                if (options.oneofs)
                                    object._zone = "zone";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.pscData != null && message.hasOwnProperty("pscData")) {
                                object.pscData = $root.google.cloud.compute.v1.NetworkEndpointGroupPscData.toObject(message.pscData, options);
                                if (options.oneofs)
                                    object._pscData = "pscData";
                            }
                            if (message.cloudRun != null && message.hasOwnProperty("cloudRun")) {
                                object.cloudRun = $root.google.cloud.compute.v1.NetworkEndpointGroupCloudRun.toObject(message.cloudRun, options);
                                if (options.oneofs)
                                    object._cloudRun = "cloudRun";
                            }
                            var keys2;
                            if (message.annotations && (keys2 = Object.keys(message.annotations)).length) {
                                object.annotations = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.annotations[keys2[j]] = message.annotations[keys2[j]];
                            }
                            if (message.networkEndpointType != null && message.hasOwnProperty("networkEndpointType")) {
                                object.networkEndpointType = message.networkEndpointType;
                                if (options.oneofs)
                                    object._networkEndpointType = "networkEndpointType";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                object.network = message.network;
                                if (options.oneofs)
                                    object._network = "network";
                            }
                            if (message.pscTargetService != null && message.hasOwnProperty("pscTargetService")) {
                                object.pscTargetService = message.pscTargetService;
                                if (options.oneofs)
                                    object._pscTargetService = "pscTargetService";
                            }
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork")) {
                                object.subnetwork = message.subnetwork;
                                if (options.oneofs)
                                    object._subnetwork = "subnetwork";
                            }
                            if (message.appEngine != null && message.hasOwnProperty("appEngine")) {
                                object.appEngine = $root.google.cloud.compute.v1.NetworkEndpointGroupAppEngine.toObject(message.appEngine, options);
                                if (options.oneofs)
                                    object._appEngine = "appEngine";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.defaultPort != null && message.hasOwnProperty("defaultPort")) {
                                object.defaultPort = message.defaultPort;
                                if (options.oneofs)
                                    object._defaultPort = "defaultPort";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.cloudFunction != null && message.hasOwnProperty("cloudFunction")) {
                                object.cloudFunction = $root.google.cloud.compute.v1.NetworkEndpointGroupCloudFunction.toObject(message.cloudFunction, options);
                                if (options.oneofs)
                                    object._cloudFunction = "cloudFunction";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkEndpointGroup to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkEndpointGroup.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkEndpointGroup
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroup
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkEndpointGroup.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkEndpointGroup";
                        };
    
                        /**
                         * NetworkEndpointType enum.
                         * @name google.cloud.compute.v1.NetworkEndpointGroup.NetworkEndpointType
                         * @enum {number}
                         * @property {number} UNDEFINED_NETWORK_ENDPOINT_TYPE=0 UNDEFINED_NETWORK_ENDPOINT_TYPE value
                         * @property {number} GCE_VM_IP=401880793 GCE_VM_IP value
                         * @property {number} GCE_VM_IP_PORT=501838375 GCE_VM_IP_PORT value
                         * @property {number} INTERNET_FQDN_PORT=404154477 INTERNET_FQDN_PORT value
                         * @property {number} INTERNET_IP_PORT=477719963 INTERNET_IP_PORT value
                         * @property {number} NON_GCP_PRIVATE_IP_PORT=336447968 NON_GCP_PRIVATE_IP_PORT value
                         * @property {number} PRIVATE_SERVICE_CONNECT=48134724 PRIVATE_SERVICE_CONNECT value
                         * @property {number} SERVERLESS=270492508 SERVERLESS value
                         */
                        NetworkEndpointGroup.NetworkEndpointType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_NETWORK_ENDPOINT_TYPE"] = 0;
                            values[valuesById[401880793] = "GCE_VM_IP"] = 401880793;
                            values[valuesById[501838375] = "GCE_VM_IP_PORT"] = 501838375;
                            values[valuesById[404154477] = "INTERNET_FQDN_PORT"] = 404154477;
                            values[valuesById[477719963] = "INTERNET_IP_PORT"] = 477719963;
                            values[valuesById[336447968] = "NON_GCP_PRIVATE_IP_PORT"] = 336447968;
                            values[valuesById[48134724] = "PRIVATE_SERVICE_CONNECT"] = 48134724;
                            values[valuesById[270492508] = "SERVERLESS"] = 270492508;
                            return values;
                        })();
    
                        return NetworkEndpointGroup;
                    })();
    
                    v1.NetworkEndpointGroupAggregatedList = (function() {
    
                        /**
                         * Properties of a NetworkEndpointGroupAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkEndpointGroupAggregatedList
                         * @property {string|null} [id] NetworkEndpointGroupAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.INetworkEndpointGroupsScopedList>|null} [items] NetworkEndpointGroupAggregatedList items
                         * @property {string|null} [kind] NetworkEndpointGroupAggregatedList kind
                         * @property {string|null} [nextPageToken] NetworkEndpointGroupAggregatedList nextPageToken
                         * @property {string|null} [selfLink] NetworkEndpointGroupAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] NetworkEndpointGroupAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] NetworkEndpointGroupAggregatedList warning
                         */
    
                        /**
                         * Constructs a new NetworkEndpointGroupAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkEndpointGroupAggregatedList.
                         * @implements INetworkEndpointGroupAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupAggregatedList=} [properties] Properties to set
                         */
                        function NetworkEndpointGroupAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkEndpointGroupAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @instance
                         */
                        NetworkEndpointGroupAggregatedList.prototype.id = null;
    
                        /**
                         * NetworkEndpointGroupAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.INetworkEndpointGroupsScopedList>} items
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @instance
                         */
                        NetworkEndpointGroupAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * NetworkEndpointGroupAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @instance
                         */
                        NetworkEndpointGroupAggregatedList.prototype.kind = null;
    
                        /**
                         * NetworkEndpointGroupAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @instance
                         */
                        NetworkEndpointGroupAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * NetworkEndpointGroupAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @instance
                         */
                        NetworkEndpointGroupAggregatedList.prototype.selfLink = null;
    
                        /**
                         * NetworkEndpointGroupAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @instance
                         */
                        NetworkEndpointGroupAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * NetworkEndpointGroupAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @instance
                         */
                        NetworkEndpointGroupAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworkEndpointGroupAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroupAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroupAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroupAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroupAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworkEndpointGroupAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupAggregatedList} NetworkEndpointGroupAggregatedList instance
                         */
                        NetworkEndpointGroupAggregatedList.create = function create(properties) {
                            return new NetworkEndpointGroupAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupAggregatedList} message NetworkEndpointGroupAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.NetworkEndpointGroupsScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupAggregatedList} message NetworkEndpointGroupAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupAggregatedList} NetworkEndpointGroupAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkEndpointGroupAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.NetworkEndpointGroupsScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupAggregatedList} NetworkEndpointGroupAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkEndpointGroupAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkEndpointGroupAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NetworkEndpointGroupsScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkEndpointGroupAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupAggregatedList} NetworkEndpointGroupAggregatedList
                         */
                        NetworkEndpointGroupAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkEndpointGroupAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkEndpointGroupAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroupAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroupAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.NetworkEndpointGroupsScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroupAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroupAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkEndpointGroupAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.NetworkEndpointGroupAggregatedList} message NetworkEndpointGroupAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkEndpointGroupAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.NetworkEndpointGroupsScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkEndpointGroupAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkEndpointGroupAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkEndpointGroupAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkEndpointGroupAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkEndpointGroupAggregatedList";
                        };
    
                        return NetworkEndpointGroupAggregatedList;
                    })();
    
                    v1.NetworkEndpointGroupAppEngine = (function() {
    
                        /**
                         * Properties of a NetworkEndpointGroupAppEngine.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkEndpointGroupAppEngine
                         * @property {string|null} [service] NetworkEndpointGroupAppEngine service
                         * @property {string|null} [urlMask] NetworkEndpointGroupAppEngine urlMask
                         * @property {string|null} [version] NetworkEndpointGroupAppEngine version
                         */
    
                        /**
                         * Constructs a new NetworkEndpointGroupAppEngine.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkEndpointGroupAppEngine.
                         * @implements INetworkEndpointGroupAppEngine
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupAppEngine=} [properties] Properties to set
                         */
                        function NetworkEndpointGroupAppEngine(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkEndpointGroupAppEngine service.
                         * @member {string|null|undefined} service
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAppEngine
                         * @instance
                         */
                        NetworkEndpointGroupAppEngine.prototype.service = null;
    
                        /**
                         * NetworkEndpointGroupAppEngine urlMask.
                         * @member {string|null|undefined} urlMask
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAppEngine
                         * @instance
                         */
                        NetworkEndpointGroupAppEngine.prototype.urlMask = null;
    
                        /**
                         * NetworkEndpointGroupAppEngine version.
                         * @member {string|null|undefined} version
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAppEngine
                         * @instance
                         */
                        NetworkEndpointGroupAppEngine.prototype.version = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworkEndpointGroupAppEngine _service.
                         * @member {"service"|undefined} _service
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAppEngine
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupAppEngine.prototype, "_service", {
                            get: $util.oneOfGetter($oneOfFields = ["service"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroupAppEngine _urlMask.
                         * @member {"urlMask"|undefined} _urlMask
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAppEngine
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupAppEngine.prototype, "_urlMask", {
                            get: $util.oneOfGetter($oneOfFields = ["urlMask"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroupAppEngine _version.
                         * @member {"version"|undefined} _version
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAppEngine
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupAppEngine.prototype, "_version", {
                            get: $util.oneOfGetter($oneOfFields = ["version"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworkEndpointGroupAppEngine instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAppEngine
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupAppEngine=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupAppEngine} NetworkEndpointGroupAppEngine instance
                         */
                        NetworkEndpointGroupAppEngine.create = function create(properties) {
                            return new NetworkEndpointGroupAppEngine(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupAppEngine message. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupAppEngine.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAppEngine
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupAppEngine} message NetworkEndpointGroupAppEngine message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupAppEngine.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.urlMask != null && Object.hasOwnProperty.call(message, "urlMask"))
                                writer.uint32(/* id 103352252, wireType 2 =*/826818018).string(message.urlMask);
                            if (message.version != null && Object.hasOwnProperty.call(message, "version"))
                                writer.uint32(/* id 351608024, wireType 2 =*/2812864194).string(message.version);
                            if (message.service != null && Object.hasOwnProperty.call(message, "service"))
                                writer.uint32(/* id 373540533, wireType 2 =*/2988324266).string(message.service);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupAppEngine message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupAppEngine.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAppEngine
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupAppEngine} message NetworkEndpointGroupAppEngine message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupAppEngine.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupAppEngine message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAppEngine
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupAppEngine} NetworkEndpointGroupAppEngine
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupAppEngine.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkEndpointGroupAppEngine();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 373540533: {
                                        message.service = reader.string();
                                        break;
                                    }
                                case 103352252: {
                                        message.urlMask = reader.string();
                                        break;
                                    }
                                case 351608024: {
                                        message.version = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupAppEngine message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAppEngine
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupAppEngine} NetworkEndpointGroupAppEngine
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupAppEngine.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkEndpointGroupAppEngine message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAppEngine
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkEndpointGroupAppEngine.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.service != null && message.hasOwnProperty("service")) {
                                properties._service = 1;
                                if (!$util.isString(message.service))
                                    return "service: string expected";
                            }
                            if (message.urlMask != null && message.hasOwnProperty("urlMask")) {
                                properties._urlMask = 1;
                                if (!$util.isString(message.urlMask))
                                    return "urlMask: string expected";
                            }
                            if (message.version != null && message.hasOwnProperty("version")) {
                                properties._version = 1;
                                if (!$util.isString(message.version))
                                    return "version: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkEndpointGroupAppEngine message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAppEngine
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupAppEngine} NetworkEndpointGroupAppEngine
                         */
                        NetworkEndpointGroupAppEngine.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkEndpointGroupAppEngine)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkEndpointGroupAppEngine();
                            if (object.service != null)
                                message.service = String(object.service);
                            if (object.urlMask != null)
                                message.urlMask = String(object.urlMask);
                            if (object.version != null)
                                message.version = String(object.version);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkEndpointGroupAppEngine message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAppEngine
                         * @static
                         * @param {google.cloud.compute.v1.NetworkEndpointGroupAppEngine} message NetworkEndpointGroupAppEngine
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkEndpointGroupAppEngine.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.urlMask != null && message.hasOwnProperty("urlMask")) {
                                object.urlMask = message.urlMask;
                                if (options.oneofs)
                                    object._urlMask = "urlMask";
                            }
                            if (message.version != null && message.hasOwnProperty("version")) {
                                object.version = message.version;
                                if (options.oneofs)
                                    object._version = "version";
                            }
                            if (message.service != null && message.hasOwnProperty("service")) {
                                object.service = message.service;
                                if (options.oneofs)
                                    object._service = "service";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkEndpointGroupAppEngine to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAppEngine
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkEndpointGroupAppEngine.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkEndpointGroupAppEngine
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupAppEngine
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkEndpointGroupAppEngine.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkEndpointGroupAppEngine";
                        };
    
                        return NetworkEndpointGroupAppEngine;
                    })();
    
                    v1.NetworkEndpointGroupCloudFunction = (function() {
    
                        /**
                         * Properties of a NetworkEndpointGroupCloudFunction.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkEndpointGroupCloudFunction
                         * @property {string|null} ["function"] NetworkEndpointGroupCloudFunction function
                         * @property {string|null} [urlMask] NetworkEndpointGroupCloudFunction urlMask
                         */
    
                        /**
                         * Constructs a new NetworkEndpointGroupCloudFunction.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkEndpointGroupCloudFunction.
                         * @implements INetworkEndpointGroupCloudFunction
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupCloudFunction=} [properties] Properties to set
                         */
                        function NetworkEndpointGroupCloudFunction(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkEndpointGroupCloudFunction function.
                         * @member {string|null|undefined} function
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudFunction
                         * @instance
                         */
                        NetworkEndpointGroupCloudFunction.prototype["function"] = null;
    
                        /**
                         * NetworkEndpointGroupCloudFunction urlMask.
                         * @member {string|null|undefined} urlMask
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudFunction
                         * @instance
                         */
                        NetworkEndpointGroupCloudFunction.prototype.urlMask = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworkEndpointGroupCloudFunction _function.
                         * @member {"function"|undefined} _function
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudFunction
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupCloudFunction.prototype, "_function", {
                            get: $util.oneOfGetter($oneOfFields = ["function"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroupCloudFunction _urlMask.
                         * @member {"urlMask"|undefined} _urlMask
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudFunction
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupCloudFunction.prototype, "_urlMask", {
                            get: $util.oneOfGetter($oneOfFields = ["urlMask"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworkEndpointGroupCloudFunction instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudFunction
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupCloudFunction=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupCloudFunction} NetworkEndpointGroupCloudFunction instance
                         */
                        NetworkEndpointGroupCloudFunction.create = function create(properties) {
                            return new NetworkEndpointGroupCloudFunction(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupCloudFunction message. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupCloudFunction.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudFunction
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupCloudFunction} message NetworkEndpointGroupCloudFunction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupCloudFunction.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.urlMask != null && Object.hasOwnProperty.call(message, "urlMask"))
                                writer.uint32(/* id 103352252, wireType 2 =*/826818018).string(message.urlMask);
                            if (message["function"] != null && Object.hasOwnProperty.call(message, "function"))
                                writer.uint32(/* id 307196888, wireType 2 =*/2457575106).string(message["function"]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupCloudFunction message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupCloudFunction.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudFunction
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupCloudFunction} message NetworkEndpointGroupCloudFunction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupCloudFunction.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupCloudFunction message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudFunction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupCloudFunction} NetworkEndpointGroupCloudFunction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupCloudFunction.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkEndpointGroupCloudFunction();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 307196888: {
                                        message["function"] = reader.string();
                                        break;
                                    }
                                case 103352252: {
                                        message.urlMask = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupCloudFunction message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudFunction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupCloudFunction} NetworkEndpointGroupCloudFunction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupCloudFunction.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkEndpointGroupCloudFunction message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudFunction
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkEndpointGroupCloudFunction.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message["function"] != null && message.hasOwnProperty("function")) {
                                properties._function = 1;
                                if (!$util.isString(message["function"]))
                                    return "function: string expected";
                            }
                            if (message.urlMask != null && message.hasOwnProperty("urlMask")) {
                                properties._urlMask = 1;
                                if (!$util.isString(message.urlMask))
                                    return "urlMask: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkEndpointGroupCloudFunction message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudFunction
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupCloudFunction} NetworkEndpointGroupCloudFunction
                         */
                        NetworkEndpointGroupCloudFunction.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkEndpointGroupCloudFunction)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkEndpointGroupCloudFunction();
                            if (object["function"] != null)
                                message["function"] = String(object["function"]);
                            if (object.urlMask != null)
                                message.urlMask = String(object.urlMask);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkEndpointGroupCloudFunction message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudFunction
                         * @static
                         * @param {google.cloud.compute.v1.NetworkEndpointGroupCloudFunction} message NetworkEndpointGroupCloudFunction
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkEndpointGroupCloudFunction.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.urlMask != null && message.hasOwnProperty("urlMask")) {
                                object.urlMask = message.urlMask;
                                if (options.oneofs)
                                    object._urlMask = "urlMask";
                            }
                            if (message["function"] != null && message.hasOwnProperty("function")) {
                                object["function"] = message["function"];
                                if (options.oneofs)
                                    object._function = "function";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkEndpointGroupCloudFunction to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudFunction
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkEndpointGroupCloudFunction.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkEndpointGroupCloudFunction
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudFunction
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkEndpointGroupCloudFunction.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkEndpointGroupCloudFunction";
                        };
    
                        return NetworkEndpointGroupCloudFunction;
                    })();
    
                    v1.NetworkEndpointGroupCloudRun = (function() {
    
                        /**
                         * Properties of a NetworkEndpointGroupCloudRun.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkEndpointGroupCloudRun
                         * @property {string|null} [service] NetworkEndpointGroupCloudRun service
                         * @property {string|null} [tag] NetworkEndpointGroupCloudRun tag
                         * @property {string|null} [urlMask] NetworkEndpointGroupCloudRun urlMask
                         */
    
                        /**
                         * Constructs a new NetworkEndpointGroupCloudRun.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkEndpointGroupCloudRun.
                         * @implements INetworkEndpointGroupCloudRun
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupCloudRun=} [properties] Properties to set
                         */
                        function NetworkEndpointGroupCloudRun(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkEndpointGroupCloudRun service.
                         * @member {string|null|undefined} service
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudRun
                         * @instance
                         */
                        NetworkEndpointGroupCloudRun.prototype.service = null;
    
                        /**
                         * NetworkEndpointGroupCloudRun tag.
                         * @member {string|null|undefined} tag
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudRun
                         * @instance
                         */
                        NetworkEndpointGroupCloudRun.prototype.tag = null;
    
                        /**
                         * NetworkEndpointGroupCloudRun urlMask.
                         * @member {string|null|undefined} urlMask
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudRun
                         * @instance
                         */
                        NetworkEndpointGroupCloudRun.prototype.urlMask = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworkEndpointGroupCloudRun _service.
                         * @member {"service"|undefined} _service
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudRun
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupCloudRun.prototype, "_service", {
                            get: $util.oneOfGetter($oneOfFields = ["service"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroupCloudRun _tag.
                         * @member {"tag"|undefined} _tag
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudRun
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupCloudRun.prototype, "_tag", {
                            get: $util.oneOfGetter($oneOfFields = ["tag"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroupCloudRun _urlMask.
                         * @member {"urlMask"|undefined} _urlMask
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudRun
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupCloudRun.prototype, "_urlMask", {
                            get: $util.oneOfGetter($oneOfFields = ["urlMask"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworkEndpointGroupCloudRun instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudRun
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupCloudRun=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupCloudRun} NetworkEndpointGroupCloudRun instance
                         */
                        NetworkEndpointGroupCloudRun.create = function create(properties) {
                            return new NetworkEndpointGroupCloudRun(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupCloudRun message. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupCloudRun.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudRun
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupCloudRun} message NetworkEndpointGroupCloudRun message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupCloudRun.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.tag != null && Object.hasOwnProperty.call(message, "tag"))
                                writer.uint32(/* id 114586, wireType 2 =*/916690).string(message.tag);
                            if (message.urlMask != null && Object.hasOwnProperty.call(message, "urlMask"))
                                writer.uint32(/* id 103352252, wireType 2 =*/826818018).string(message.urlMask);
                            if (message.service != null && Object.hasOwnProperty.call(message, "service"))
                                writer.uint32(/* id 373540533, wireType 2 =*/2988324266).string(message.service);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupCloudRun message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupCloudRun.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudRun
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupCloudRun} message NetworkEndpointGroupCloudRun message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupCloudRun.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupCloudRun message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudRun
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupCloudRun} NetworkEndpointGroupCloudRun
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupCloudRun.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkEndpointGroupCloudRun();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 373540533: {
                                        message.service = reader.string();
                                        break;
                                    }
                                case 114586: {
                                        message.tag = reader.string();
                                        break;
                                    }
                                case 103352252: {
                                        message.urlMask = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupCloudRun message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudRun
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupCloudRun} NetworkEndpointGroupCloudRun
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupCloudRun.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkEndpointGroupCloudRun message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudRun
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkEndpointGroupCloudRun.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.service != null && message.hasOwnProperty("service")) {
                                properties._service = 1;
                                if (!$util.isString(message.service))
                                    return "service: string expected";
                            }
                            if (message.tag != null && message.hasOwnProperty("tag")) {
                                properties._tag = 1;
                                if (!$util.isString(message.tag))
                                    return "tag: string expected";
                            }
                            if (message.urlMask != null && message.hasOwnProperty("urlMask")) {
                                properties._urlMask = 1;
                                if (!$util.isString(message.urlMask))
                                    return "urlMask: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkEndpointGroupCloudRun message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudRun
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupCloudRun} NetworkEndpointGroupCloudRun
                         */
                        NetworkEndpointGroupCloudRun.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkEndpointGroupCloudRun)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkEndpointGroupCloudRun();
                            if (object.service != null)
                                message.service = String(object.service);
                            if (object.tag != null)
                                message.tag = String(object.tag);
                            if (object.urlMask != null)
                                message.urlMask = String(object.urlMask);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkEndpointGroupCloudRun message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudRun
                         * @static
                         * @param {google.cloud.compute.v1.NetworkEndpointGroupCloudRun} message NetworkEndpointGroupCloudRun
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkEndpointGroupCloudRun.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.tag != null && message.hasOwnProperty("tag")) {
                                object.tag = message.tag;
                                if (options.oneofs)
                                    object._tag = "tag";
                            }
                            if (message.urlMask != null && message.hasOwnProperty("urlMask")) {
                                object.urlMask = message.urlMask;
                                if (options.oneofs)
                                    object._urlMask = "urlMask";
                            }
                            if (message.service != null && message.hasOwnProperty("service")) {
                                object.service = message.service;
                                if (options.oneofs)
                                    object._service = "service";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkEndpointGroupCloudRun to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudRun
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkEndpointGroupCloudRun.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkEndpointGroupCloudRun
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupCloudRun
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkEndpointGroupCloudRun.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkEndpointGroupCloudRun";
                        };
    
                        return NetworkEndpointGroupCloudRun;
                    })();
    
                    v1.NetworkEndpointGroupList = (function() {
    
                        /**
                         * Properties of a NetworkEndpointGroupList.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkEndpointGroupList
                         * @property {string|null} [id] NetworkEndpointGroupList id
                         * @property {Array.<google.cloud.compute.v1.INetworkEndpointGroup>|null} [items] NetworkEndpointGroupList items
                         * @property {string|null} [kind] NetworkEndpointGroupList kind
                         * @property {string|null} [nextPageToken] NetworkEndpointGroupList nextPageToken
                         * @property {string|null} [selfLink] NetworkEndpointGroupList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] NetworkEndpointGroupList warning
                         */
    
                        /**
                         * Constructs a new NetworkEndpointGroupList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkEndpointGroupList.
                         * @implements INetworkEndpointGroupList
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupList=} [properties] Properties to set
                         */
                        function NetworkEndpointGroupList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkEndpointGroupList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @instance
                         */
                        NetworkEndpointGroupList.prototype.id = null;
    
                        /**
                         * NetworkEndpointGroupList items.
                         * @member {Array.<google.cloud.compute.v1.INetworkEndpointGroup>} items
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @instance
                         */
                        NetworkEndpointGroupList.prototype.items = $util.emptyArray;
    
                        /**
                         * NetworkEndpointGroupList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @instance
                         */
                        NetworkEndpointGroupList.prototype.kind = null;
    
                        /**
                         * NetworkEndpointGroupList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @instance
                         */
                        NetworkEndpointGroupList.prototype.nextPageToken = null;
    
                        /**
                         * NetworkEndpointGroupList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @instance
                         */
                        NetworkEndpointGroupList.prototype.selfLink = null;
    
                        /**
                         * NetworkEndpointGroupList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @instance
                         */
                        NetworkEndpointGroupList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworkEndpointGroupList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroupList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroupList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroupList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroupList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworkEndpointGroupList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupList} NetworkEndpointGroupList instance
                         */
                        NetworkEndpointGroupList.create = function create(properties) {
                            return new NetworkEndpointGroupList(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupList message. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupList} message NetworkEndpointGroupList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.NetworkEndpointGroup.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupList} message NetworkEndpointGroupList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupList} NetworkEndpointGroupList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkEndpointGroupList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.NetworkEndpointGroup.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupList} NetworkEndpointGroupList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkEndpointGroupList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkEndpointGroupList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NetworkEndpointGroup.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkEndpointGroupList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupList} NetworkEndpointGroupList
                         */
                        NetworkEndpointGroupList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkEndpointGroupList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkEndpointGroupList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroupList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroupList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.NetworkEndpointGroup.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroupList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkEndpointGroupList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @static
                         * @param {google.cloud.compute.v1.NetworkEndpointGroupList} message NetworkEndpointGroupList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkEndpointGroupList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.NetworkEndpointGroup.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkEndpointGroupList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkEndpointGroupList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkEndpointGroupList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkEndpointGroupList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkEndpointGroupList";
                        };
    
                        return NetworkEndpointGroupList;
                    })();
    
                    v1.NetworkEndpointGroupPscData = (function() {
    
                        /**
                         * Properties of a NetworkEndpointGroupPscData.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkEndpointGroupPscData
                         * @property {string|null} [consumerPscAddress] NetworkEndpointGroupPscData consumerPscAddress
                         * @property {number|Long|null} [pscConnectionId] NetworkEndpointGroupPscData pscConnectionId
                         * @property {string|null} [pscConnectionStatus] NetworkEndpointGroupPscData pscConnectionStatus
                         */
    
                        /**
                         * Constructs a new NetworkEndpointGroupPscData.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkEndpointGroupPscData.
                         * @implements INetworkEndpointGroupPscData
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupPscData=} [properties] Properties to set
                         */
                        function NetworkEndpointGroupPscData(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkEndpointGroupPscData consumerPscAddress.
                         * @member {string|null|undefined} consumerPscAddress
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupPscData
                         * @instance
                         */
                        NetworkEndpointGroupPscData.prototype.consumerPscAddress = null;
    
                        /**
                         * NetworkEndpointGroupPscData pscConnectionId.
                         * @member {number|Long|null|undefined} pscConnectionId
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupPscData
                         * @instance
                         */
                        NetworkEndpointGroupPscData.prototype.pscConnectionId = null;
    
                        /**
                         * NetworkEndpointGroupPscData pscConnectionStatus.
                         * @member {string|null|undefined} pscConnectionStatus
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupPscData
                         * @instance
                         */
                        NetworkEndpointGroupPscData.prototype.pscConnectionStatus = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworkEndpointGroupPscData _consumerPscAddress.
                         * @member {"consumerPscAddress"|undefined} _consumerPscAddress
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupPscData
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupPscData.prototype, "_consumerPscAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["consumerPscAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroupPscData _pscConnectionId.
                         * @member {"pscConnectionId"|undefined} _pscConnectionId
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupPscData
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupPscData.prototype, "_pscConnectionId", {
                            get: $util.oneOfGetter($oneOfFields = ["pscConnectionId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroupPscData _pscConnectionStatus.
                         * @member {"pscConnectionStatus"|undefined} _pscConnectionStatus
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupPscData
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupPscData.prototype, "_pscConnectionStatus", {
                            get: $util.oneOfGetter($oneOfFields = ["pscConnectionStatus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworkEndpointGroupPscData instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupPscData
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupPscData=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupPscData} NetworkEndpointGroupPscData instance
                         */
                        NetworkEndpointGroupPscData.create = function create(properties) {
                            return new NetworkEndpointGroupPscData(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupPscData message. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupPscData.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupPscData
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupPscData} message NetworkEndpointGroupPscData message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupPscData.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pscConnectionStatus != null && Object.hasOwnProperty.call(message, "pscConnectionStatus"))
                                writer.uint32(/* id 184149172, wireType 2 =*/1473193378).string(message.pscConnectionStatus);
                            if (message.pscConnectionId != null && Object.hasOwnProperty.call(message, "pscConnectionId"))
                                writer.uint32(/* id 292082397, wireType 0 =*/2336659176).uint64(message.pscConnectionId);
                            if (message.consumerPscAddress != null && Object.hasOwnProperty.call(message, "consumerPscAddress"))
                                writer.uint32(/* id 452646572, wireType 2 =*/3621172578).string(message.consumerPscAddress);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupPscData message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupPscData.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupPscData
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupPscData} message NetworkEndpointGroupPscData message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupPscData.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupPscData message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupPscData
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupPscData} NetworkEndpointGroupPscData
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupPscData.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkEndpointGroupPscData();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 452646572: {
                                        message.consumerPscAddress = reader.string();
                                        break;
                                    }
                                case 292082397: {
                                        message.pscConnectionId = reader.uint64();
                                        break;
                                    }
                                case 184149172: {
                                        message.pscConnectionStatus = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupPscData message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupPscData
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupPscData} NetworkEndpointGroupPscData
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupPscData.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkEndpointGroupPscData message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupPscData
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkEndpointGroupPscData.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.consumerPscAddress != null && message.hasOwnProperty("consumerPscAddress")) {
                                properties._consumerPscAddress = 1;
                                if (!$util.isString(message.consumerPscAddress))
                                    return "consumerPscAddress: string expected";
                            }
                            if (message.pscConnectionId != null && message.hasOwnProperty("pscConnectionId")) {
                                properties._pscConnectionId = 1;
                                if (!$util.isInteger(message.pscConnectionId) && !(message.pscConnectionId && $util.isInteger(message.pscConnectionId.low) && $util.isInteger(message.pscConnectionId.high)))
                                    return "pscConnectionId: integer|Long expected";
                            }
                            if (message.pscConnectionStatus != null && message.hasOwnProperty("pscConnectionStatus")) {
                                properties._pscConnectionStatus = 1;
                                if (!$util.isString(message.pscConnectionStatus))
                                    return "pscConnectionStatus: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkEndpointGroupPscData message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupPscData
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupPscData} NetworkEndpointGroupPscData
                         */
                        NetworkEndpointGroupPscData.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkEndpointGroupPscData)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkEndpointGroupPscData();
                            if (object.consumerPscAddress != null)
                                message.consumerPscAddress = String(object.consumerPscAddress);
                            if (object.pscConnectionId != null)
                                if ($util.Long)
                                    (message.pscConnectionId = $util.Long.fromValue(object.pscConnectionId)).unsigned = true;
                                else if (typeof object.pscConnectionId === "string")
                                    message.pscConnectionId = parseInt(object.pscConnectionId, 10);
                                else if (typeof object.pscConnectionId === "number")
                                    message.pscConnectionId = object.pscConnectionId;
                                else if (typeof object.pscConnectionId === "object")
                                    message.pscConnectionId = new $util.LongBits(object.pscConnectionId.low >>> 0, object.pscConnectionId.high >>> 0).toNumber(true);
                            if (object.pscConnectionStatus != null)
                                message.pscConnectionStatus = String(object.pscConnectionStatus);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkEndpointGroupPscData message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupPscData
                         * @static
                         * @param {google.cloud.compute.v1.NetworkEndpointGroupPscData} message NetworkEndpointGroupPscData
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkEndpointGroupPscData.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.pscConnectionStatus != null && message.hasOwnProperty("pscConnectionStatus")) {
                                object.pscConnectionStatus = message.pscConnectionStatus;
                                if (options.oneofs)
                                    object._pscConnectionStatus = "pscConnectionStatus";
                            }
                            if (message.pscConnectionId != null && message.hasOwnProperty("pscConnectionId")) {
                                if (typeof message.pscConnectionId === "number")
                                    object.pscConnectionId = options.longs === String ? String(message.pscConnectionId) : message.pscConnectionId;
                                else
                                    object.pscConnectionId = options.longs === String ? $util.Long.prototype.toString.call(message.pscConnectionId) : options.longs === Number ? new $util.LongBits(message.pscConnectionId.low >>> 0, message.pscConnectionId.high >>> 0).toNumber(true) : message.pscConnectionId;
                                if (options.oneofs)
                                    object._pscConnectionId = "pscConnectionId";
                            }
                            if (message.consumerPscAddress != null && message.hasOwnProperty("consumerPscAddress")) {
                                object.consumerPscAddress = message.consumerPscAddress;
                                if (options.oneofs)
                                    object._consumerPscAddress = "consumerPscAddress";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkEndpointGroupPscData to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupPscData
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkEndpointGroupPscData.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkEndpointGroupPscData
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupPscData
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkEndpointGroupPscData.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkEndpointGroupPscData";
                        };
    
                        /**
                         * PscConnectionStatus enum.
                         * @name google.cloud.compute.v1.NetworkEndpointGroupPscData.PscConnectionStatus
                         * @enum {number}
                         * @property {number} UNDEFINED_PSC_CONNECTION_STATUS=0 UNDEFINED_PSC_CONNECTION_STATUS value
                         * @property {number} ACCEPTED=246714279 ACCEPTED value
                         * @property {number} CLOSED=380163436 CLOSED value
                         * @property {number} NEEDS_ATTENTION=344491452 NEEDS_ATTENTION value
                         * @property {number} PENDING=35394935 PENDING value
                         * @property {number} REJECTED=174130302 REJECTED value
                         * @property {number} STATUS_UNSPECIFIED=42133066 STATUS_UNSPECIFIED value
                         */
                        NetworkEndpointGroupPscData.PscConnectionStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PSC_CONNECTION_STATUS"] = 0;
                            values[valuesById[246714279] = "ACCEPTED"] = 246714279;
                            values[valuesById[380163436] = "CLOSED"] = 380163436;
                            values[valuesById[344491452] = "NEEDS_ATTENTION"] = 344491452;
                            values[valuesById[35394935] = "PENDING"] = 35394935;
                            values[valuesById[174130302] = "REJECTED"] = 174130302;
                            values[valuesById[42133066] = "STATUS_UNSPECIFIED"] = 42133066;
                            return values;
                        })();
    
                        return NetworkEndpointGroupPscData;
                    })();
    
                    v1.NetworkEndpointGroupsAttachEndpointsRequest = (function() {
    
                        /**
                         * Properties of a NetworkEndpointGroupsAttachEndpointsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkEndpointGroupsAttachEndpointsRequest
                         * @property {Array.<google.cloud.compute.v1.INetworkEndpoint>|null} [networkEndpoints] NetworkEndpointGroupsAttachEndpointsRequest networkEndpoints
                         */
    
                        /**
                         * Constructs a new NetworkEndpointGroupsAttachEndpointsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkEndpointGroupsAttachEndpointsRequest.
                         * @implements INetworkEndpointGroupsAttachEndpointsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupsAttachEndpointsRequest=} [properties] Properties to set
                         */
                        function NetworkEndpointGroupsAttachEndpointsRequest(properties) {
                            this.networkEndpoints = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkEndpointGroupsAttachEndpointsRequest networkEndpoints.
                         * @member {Array.<google.cloud.compute.v1.INetworkEndpoint>} networkEndpoints
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest
                         * @instance
                         */
                        NetworkEndpointGroupsAttachEndpointsRequest.prototype.networkEndpoints = $util.emptyArray;
    
                        /**
                         * Creates a new NetworkEndpointGroupsAttachEndpointsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupsAttachEndpointsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest} NetworkEndpointGroupsAttachEndpointsRequest instance
                         */
                        NetworkEndpointGroupsAttachEndpointsRequest.create = function create(properties) {
                            return new NetworkEndpointGroupsAttachEndpointsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupsAttachEndpointsRequest message. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupsAttachEndpointsRequest} message NetworkEndpointGroupsAttachEndpointsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupsAttachEndpointsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.networkEndpoints != null && message.networkEndpoints.length)
                                for (var i = 0; i < message.networkEndpoints.length; ++i)
                                    $root.google.cloud.compute.v1.NetworkEndpoint.encode(message.networkEndpoints[i], writer.uint32(/* id 149850285, wireType 2 =*/1198802282).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupsAttachEndpointsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupsAttachEndpointsRequest} message NetworkEndpointGroupsAttachEndpointsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupsAttachEndpointsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupsAttachEndpointsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest} NetworkEndpointGroupsAttachEndpointsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupsAttachEndpointsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 149850285: {
                                        if (!(message.networkEndpoints && message.networkEndpoints.length))
                                            message.networkEndpoints = [];
                                        message.networkEndpoints.push($root.google.cloud.compute.v1.NetworkEndpoint.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupsAttachEndpointsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest} NetworkEndpointGroupsAttachEndpointsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupsAttachEndpointsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkEndpointGroupsAttachEndpointsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkEndpointGroupsAttachEndpointsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.networkEndpoints != null && message.hasOwnProperty("networkEndpoints")) {
                                if (!Array.isArray(message.networkEndpoints))
                                    return "networkEndpoints: array expected";
                                for (var i = 0; i < message.networkEndpoints.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NetworkEndpoint.verify(message.networkEndpoints[i]);
                                    if (error)
                                        return "networkEndpoints." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkEndpointGroupsAttachEndpointsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest} NetworkEndpointGroupsAttachEndpointsRequest
                         */
                        NetworkEndpointGroupsAttachEndpointsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest();
                            if (object.networkEndpoints) {
                                if (!Array.isArray(object.networkEndpoints))
                                    throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest.networkEndpoints: array expected");
                                message.networkEndpoints = [];
                                for (var i = 0; i < object.networkEndpoints.length; ++i) {
                                    if (typeof object.networkEndpoints[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest.networkEndpoints: object expected");
                                    message.networkEndpoints[i] = $root.google.cloud.compute.v1.NetworkEndpoint.fromObject(object.networkEndpoints[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkEndpointGroupsAttachEndpointsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest} message NetworkEndpointGroupsAttachEndpointsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkEndpointGroupsAttachEndpointsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.networkEndpoints = [];
                            if (message.networkEndpoints && message.networkEndpoints.length) {
                                object.networkEndpoints = [];
                                for (var j = 0; j < message.networkEndpoints.length; ++j)
                                    object.networkEndpoints[j] = $root.google.cloud.compute.v1.NetworkEndpoint.toObject(message.networkEndpoints[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkEndpointGroupsAttachEndpointsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkEndpointGroupsAttachEndpointsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkEndpointGroupsAttachEndpointsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkEndpointGroupsAttachEndpointsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkEndpointGroupsAttachEndpointsRequest";
                        };
    
                        return NetworkEndpointGroupsAttachEndpointsRequest;
                    })();
    
                    v1.NetworkEndpointGroupsDetachEndpointsRequest = (function() {
    
                        /**
                         * Properties of a NetworkEndpointGroupsDetachEndpointsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkEndpointGroupsDetachEndpointsRequest
                         * @property {Array.<google.cloud.compute.v1.INetworkEndpoint>|null} [networkEndpoints] NetworkEndpointGroupsDetachEndpointsRequest networkEndpoints
                         */
    
                        /**
                         * Constructs a new NetworkEndpointGroupsDetachEndpointsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkEndpointGroupsDetachEndpointsRequest.
                         * @implements INetworkEndpointGroupsDetachEndpointsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupsDetachEndpointsRequest=} [properties] Properties to set
                         */
                        function NetworkEndpointGroupsDetachEndpointsRequest(properties) {
                            this.networkEndpoints = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkEndpointGroupsDetachEndpointsRequest networkEndpoints.
                         * @member {Array.<google.cloud.compute.v1.INetworkEndpoint>} networkEndpoints
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest
                         * @instance
                         */
                        NetworkEndpointGroupsDetachEndpointsRequest.prototype.networkEndpoints = $util.emptyArray;
    
                        /**
                         * Creates a new NetworkEndpointGroupsDetachEndpointsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupsDetachEndpointsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest} NetworkEndpointGroupsDetachEndpointsRequest instance
                         */
                        NetworkEndpointGroupsDetachEndpointsRequest.create = function create(properties) {
                            return new NetworkEndpointGroupsDetachEndpointsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupsDetachEndpointsRequest message. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupsDetachEndpointsRequest} message NetworkEndpointGroupsDetachEndpointsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupsDetachEndpointsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.networkEndpoints != null && message.networkEndpoints.length)
                                for (var i = 0; i < message.networkEndpoints.length; ++i)
                                    $root.google.cloud.compute.v1.NetworkEndpoint.encode(message.networkEndpoints[i], writer.uint32(/* id 149850285, wireType 2 =*/1198802282).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupsDetachEndpointsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupsDetachEndpointsRequest} message NetworkEndpointGroupsDetachEndpointsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupsDetachEndpointsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupsDetachEndpointsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest} NetworkEndpointGroupsDetachEndpointsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupsDetachEndpointsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 149850285: {
                                        if (!(message.networkEndpoints && message.networkEndpoints.length))
                                            message.networkEndpoints = [];
                                        message.networkEndpoints.push($root.google.cloud.compute.v1.NetworkEndpoint.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupsDetachEndpointsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest} NetworkEndpointGroupsDetachEndpointsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupsDetachEndpointsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkEndpointGroupsDetachEndpointsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkEndpointGroupsDetachEndpointsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.networkEndpoints != null && message.hasOwnProperty("networkEndpoints")) {
                                if (!Array.isArray(message.networkEndpoints))
                                    return "networkEndpoints: array expected";
                                for (var i = 0; i < message.networkEndpoints.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NetworkEndpoint.verify(message.networkEndpoints[i]);
                                    if (error)
                                        return "networkEndpoints." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkEndpointGroupsDetachEndpointsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest} NetworkEndpointGroupsDetachEndpointsRequest
                         */
                        NetworkEndpointGroupsDetachEndpointsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest();
                            if (object.networkEndpoints) {
                                if (!Array.isArray(object.networkEndpoints))
                                    throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest.networkEndpoints: array expected");
                                message.networkEndpoints = [];
                                for (var i = 0; i < object.networkEndpoints.length; ++i) {
                                    if (typeof object.networkEndpoints[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest.networkEndpoints: object expected");
                                    message.networkEndpoints[i] = $root.google.cloud.compute.v1.NetworkEndpoint.fromObject(object.networkEndpoints[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkEndpointGroupsDetachEndpointsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest} message NetworkEndpointGroupsDetachEndpointsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkEndpointGroupsDetachEndpointsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.networkEndpoints = [];
                            if (message.networkEndpoints && message.networkEndpoints.length) {
                                object.networkEndpoints = [];
                                for (var j = 0; j < message.networkEndpoints.length; ++j)
                                    object.networkEndpoints[j] = $root.google.cloud.compute.v1.NetworkEndpoint.toObject(message.networkEndpoints[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkEndpointGroupsDetachEndpointsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkEndpointGroupsDetachEndpointsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkEndpointGroupsDetachEndpointsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkEndpointGroupsDetachEndpointsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkEndpointGroupsDetachEndpointsRequest";
                        };
    
                        return NetworkEndpointGroupsDetachEndpointsRequest;
                    })();
    
                    v1.NetworkEndpointGroupsListEndpointsRequest = (function() {
    
                        /**
                         * Properties of a NetworkEndpointGroupsListEndpointsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkEndpointGroupsListEndpointsRequest
                         * @property {string|null} [healthStatus] NetworkEndpointGroupsListEndpointsRequest healthStatus
                         */
    
                        /**
                         * Constructs a new NetworkEndpointGroupsListEndpointsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkEndpointGroupsListEndpointsRequest.
                         * @implements INetworkEndpointGroupsListEndpointsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupsListEndpointsRequest=} [properties] Properties to set
                         */
                        function NetworkEndpointGroupsListEndpointsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkEndpointGroupsListEndpointsRequest healthStatus.
                         * @member {string|null|undefined} healthStatus
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest
                         * @instance
                         */
                        NetworkEndpointGroupsListEndpointsRequest.prototype.healthStatus = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworkEndpointGroupsListEndpointsRequest _healthStatus.
                         * @member {"healthStatus"|undefined} _healthStatus
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupsListEndpointsRequest.prototype, "_healthStatus", {
                            get: $util.oneOfGetter($oneOfFields = ["healthStatus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworkEndpointGroupsListEndpointsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupsListEndpointsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest} NetworkEndpointGroupsListEndpointsRequest instance
                         */
                        NetworkEndpointGroupsListEndpointsRequest.create = function create(properties) {
                            return new NetworkEndpointGroupsListEndpointsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupsListEndpointsRequest message. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupsListEndpointsRequest} message NetworkEndpointGroupsListEndpointsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupsListEndpointsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.healthStatus != null && Object.hasOwnProperty.call(message, "healthStatus"))
                                writer.uint32(/* id 380545845, wireType 2 =*/3044366762).string(message.healthStatus);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupsListEndpointsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupsListEndpointsRequest} message NetworkEndpointGroupsListEndpointsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupsListEndpointsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupsListEndpointsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest} NetworkEndpointGroupsListEndpointsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupsListEndpointsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 380545845: {
                                        message.healthStatus = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupsListEndpointsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest} NetworkEndpointGroupsListEndpointsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupsListEndpointsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkEndpointGroupsListEndpointsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkEndpointGroupsListEndpointsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.healthStatus != null && message.hasOwnProperty("healthStatus")) {
                                properties._healthStatus = 1;
                                if (!$util.isString(message.healthStatus))
                                    return "healthStatus: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkEndpointGroupsListEndpointsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest} NetworkEndpointGroupsListEndpointsRequest
                         */
                        NetworkEndpointGroupsListEndpointsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest();
                            if (object.healthStatus != null)
                                message.healthStatus = String(object.healthStatus);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkEndpointGroupsListEndpointsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest
                         * @static
                         * @param {google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest} message NetworkEndpointGroupsListEndpointsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkEndpointGroupsListEndpointsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.healthStatus != null && message.hasOwnProperty("healthStatus")) {
                                object.healthStatus = message.healthStatus;
                                if (options.oneofs)
                                    object._healthStatus = "healthStatus";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkEndpointGroupsListEndpointsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkEndpointGroupsListEndpointsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkEndpointGroupsListEndpointsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkEndpointGroupsListEndpointsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest";
                        };
    
                        /**
                         * HealthStatus enum.
                         * @name google.cloud.compute.v1.NetworkEndpointGroupsListEndpointsRequest.HealthStatus
                         * @enum {number}
                         * @property {number} UNDEFINED_HEALTH_STATUS=0 UNDEFINED_HEALTH_STATUS value
                         * @property {number} SHOW=2544381 SHOW value
                         * @property {number} SKIP=2547071 SKIP value
                         */
                        NetworkEndpointGroupsListEndpointsRequest.HealthStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_HEALTH_STATUS"] = 0;
                            values[valuesById[2544381] = "SHOW"] = 2544381;
                            values[valuesById[2547071] = "SKIP"] = 2547071;
                            return values;
                        })();
    
                        return NetworkEndpointGroupsListEndpointsRequest;
                    })();
    
                    v1.NetworkEndpointGroupsListNetworkEndpoints = (function() {
    
                        /**
                         * Properties of a NetworkEndpointGroupsListNetworkEndpoints.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkEndpointGroupsListNetworkEndpoints
                         * @property {string|null} [id] NetworkEndpointGroupsListNetworkEndpoints id
                         * @property {Array.<google.cloud.compute.v1.INetworkEndpointWithHealthStatus>|null} [items] NetworkEndpointGroupsListNetworkEndpoints items
                         * @property {string|null} [kind] NetworkEndpointGroupsListNetworkEndpoints kind
                         * @property {string|null} [nextPageToken] NetworkEndpointGroupsListNetworkEndpoints nextPageToken
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] NetworkEndpointGroupsListNetworkEndpoints warning
                         */
    
                        /**
                         * Constructs a new NetworkEndpointGroupsListNetworkEndpoints.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkEndpointGroupsListNetworkEndpoints.
                         * @implements INetworkEndpointGroupsListNetworkEndpoints
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupsListNetworkEndpoints=} [properties] Properties to set
                         */
                        function NetworkEndpointGroupsListNetworkEndpoints(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkEndpointGroupsListNetworkEndpoints id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints
                         * @instance
                         */
                        NetworkEndpointGroupsListNetworkEndpoints.prototype.id = null;
    
                        /**
                         * NetworkEndpointGroupsListNetworkEndpoints items.
                         * @member {Array.<google.cloud.compute.v1.INetworkEndpointWithHealthStatus>} items
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints
                         * @instance
                         */
                        NetworkEndpointGroupsListNetworkEndpoints.prototype.items = $util.emptyArray;
    
                        /**
                         * NetworkEndpointGroupsListNetworkEndpoints kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints
                         * @instance
                         */
                        NetworkEndpointGroupsListNetworkEndpoints.prototype.kind = null;
    
                        /**
                         * NetworkEndpointGroupsListNetworkEndpoints nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints
                         * @instance
                         */
                        NetworkEndpointGroupsListNetworkEndpoints.prototype.nextPageToken = null;
    
                        /**
                         * NetworkEndpointGroupsListNetworkEndpoints warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints
                         * @instance
                         */
                        NetworkEndpointGroupsListNetworkEndpoints.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworkEndpointGroupsListNetworkEndpoints _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupsListNetworkEndpoints.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroupsListNetworkEndpoints _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupsListNetworkEndpoints.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroupsListNetworkEndpoints _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupsListNetworkEndpoints.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkEndpointGroupsListNetworkEndpoints _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupsListNetworkEndpoints.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworkEndpointGroupsListNetworkEndpoints instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupsListNetworkEndpoints=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints} NetworkEndpointGroupsListNetworkEndpoints instance
                         */
                        NetworkEndpointGroupsListNetworkEndpoints.create = function create(properties) {
                            return new NetworkEndpointGroupsListNetworkEndpoints(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupsListNetworkEndpoints message. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupsListNetworkEndpoints} message NetworkEndpointGroupsListNetworkEndpoints message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupsListNetworkEndpoints.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.NetworkEndpointWithHealthStatus.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupsListNetworkEndpoints message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupsListNetworkEndpoints} message NetworkEndpointGroupsListNetworkEndpoints message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupsListNetworkEndpoints.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupsListNetworkEndpoints message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints} NetworkEndpointGroupsListNetworkEndpoints
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupsListNetworkEndpoints.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.NetworkEndpointWithHealthStatus.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupsListNetworkEndpoints message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints} NetworkEndpointGroupsListNetworkEndpoints
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupsListNetworkEndpoints.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkEndpointGroupsListNetworkEndpoints message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkEndpointGroupsListNetworkEndpoints.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NetworkEndpointWithHealthStatus.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkEndpointGroupsListNetworkEndpoints message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints} NetworkEndpointGroupsListNetworkEndpoints
                         */
                        NetworkEndpointGroupsListNetworkEndpoints.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.NetworkEndpointWithHealthStatus.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkEndpointGroupsListNetworkEndpoints message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints
                         * @static
                         * @param {google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints} message NetworkEndpointGroupsListNetworkEndpoints
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkEndpointGroupsListNetworkEndpoints.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.NetworkEndpointWithHealthStatus.toObject(message.items[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkEndpointGroupsListNetworkEndpoints to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkEndpointGroupsListNetworkEndpoints.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkEndpointGroupsListNetworkEndpoints
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkEndpointGroupsListNetworkEndpoints.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints";
                        };
    
                        return NetworkEndpointGroupsListNetworkEndpoints;
                    })();
    
                    v1.NetworkEndpointGroupsScopedList = (function() {
    
                        /**
                         * Properties of a NetworkEndpointGroupsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkEndpointGroupsScopedList
                         * @property {Array.<google.cloud.compute.v1.INetworkEndpointGroup>|null} [networkEndpointGroups] NetworkEndpointGroupsScopedList networkEndpointGroups
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] NetworkEndpointGroupsScopedList warning
                         */
    
                        /**
                         * Constructs a new NetworkEndpointGroupsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkEndpointGroupsScopedList.
                         * @implements INetworkEndpointGroupsScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupsScopedList=} [properties] Properties to set
                         */
                        function NetworkEndpointGroupsScopedList(properties) {
                            this.networkEndpointGroups = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkEndpointGroupsScopedList networkEndpointGroups.
                         * @member {Array.<google.cloud.compute.v1.INetworkEndpointGroup>} networkEndpointGroups
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsScopedList
                         * @instance
                         */
                        NetworkEndpointGroupsScopedList.prototype.networkEndpointGroups = $util.emptyArray;
    
                        /**
                         * NetworkEndpointGroupsScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsScopedList
                         * @instance
                         */
                        NetworkEndpointGroupsScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworkEndpointGroupsScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsScopedList
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointGroupsScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworkEndpointGroupsScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupsScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupsScopedList} NetworkEndpointGroupsScopedList instance
                         */
                        NetworkEndpointGroupsScopedList.create = function create(properties) {
                            return new NetworkEndpointGroupsScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupsScopedList message. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupsScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupsScopedList} message NetworkEndpointGroupsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupsScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.networkEndpointGroups != null && message.networkEndpointGroups.length)
                                for (var i = 0; i < message.networkEndpointGroups.length; ++i)
                                    $root.google.cloud.compute.v1.NetworkEndpointGroup.encode(message.networkEndpointGroups[i], writer.uint32(/* id 29346733, wireType 2 =*/234773866).fork()).ldelim();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointGroupsScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointGroupsScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointGroupsScopedList} message NetworkEndpointGroupsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointGroupsScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupsScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupsScopedList} NetworkEndpointGroupsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupsScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkEndpointGroupsScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 29346733: {
                                        if (!(message.networkEndpointGroups && message.networkEndpointGroups.length))
                                            message.networkEndpointGroups = [];
                                        message.networkEndpointGroups.push($root.google.cloud.compute.v1.NetworkEndpointGroup.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkEndpointGroupsScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupsScopedList} NetworkEndpointGroupsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointGroupsScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkEndpointGroupsScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkEndpointGroupsScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.networkEndpointGroups != null && message.hasOwnProperty("networkEndpointGroups")) {
                                if (!Array.isArray(message.networkEndpointGroups))
                                    return "networkEndpointGroups: array expected";
                                for (var i = 0; i < message.networkEndpointGroups.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NetworkEndpointGroup.verify(message.networkEndpointGroups[i]);
                                    if (error)
                                        return "networkEndpointGroups." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkEndpointGroupsScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkEndpointGroupsScopedList} NetworkEndpointGroupsScopedList
                         */
                        NetworkEndpointGroupsScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkEndpointGroupsScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkEndpointGroupsScopedList();
                            if (object.networkEndpointGroups) {
                                if (!Array.isArray(object.networkEndpointGroups))
                                    throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroupsScopedList.networkEndpointGroups: array expected");
                                message.networkEndpointGroups = [];
                                for (var i = 0; i < object.networkEndpointGroups.length; ++i) {
                                    if (typeof object.networkEndpointGroups[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroupsScopedList.networkEndpointGroups: object expected");
                                    message.networkEndpointGroups[i] = $root.google.cloud.compute.v1.NetworkEndpointGroup.fromObject(object.networkEndpointGroups[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NetworkEndpointGroupsScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkEndpointGroupsScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.NetworkEndpointGroupsScopedList} message NetworkEndpointGroupsScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkEndpointGroupsScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.networkEndpointGroups = [];
                            if (message.networkEndpointGroups && message.networkEndpointGroups.length) {
                                object.networkEndpointGroups = [];
                                for (var j = 0; j < message.networkEndpointGroups.length; ++j)
                                    object.networkEndpointGroups[j] = $root.google.cloud.compute.v1.NetworkEndpointGroup.toObject(message.networkEndpointGroups[j], options);
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkEndpointGroupsScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkEndpointGroupsScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkEndpointGroupsScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroupsScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkEndpointGroupsScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkEndpointGroupsScopedList";
                        };
    
                        return NetworkEndpointGroupsScopedList;
                    })();
    
                    v1.NetworkEndpointWithHealthStatus = (function() {
    
                        /**
                         * Properties of a NetworkEndpointWithHealthStatus.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkEndpointWithHealthStatus
                         * @property {Array.<google.cloud.compute.v1.IHealthStatusForNetworkEndpoint>|null} [healths] NetworkEndpointWithHealthStatus healths
                         * @property {google.cloud.compute.v1.INetworkEndpoint|null} [networkEndpoint] NetworkEndpointWithHealthStatus networkEndpoint
                         */
    
                        /**
                         * Constructs a new NetworkEndpointWithHealthStatus.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkEndpointWithHealthStatus.
                         * @implements INetworkEndpointWithHealthStatus
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkEndpointWithHealthStatus=} [properties] Properties to set
                         */
                        function NetworkEndpointWithHealthStatus(properties) {
                            this.healths = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkEndpointWithHealthStatus healths.
                         * @member {Array.<google.cloud.compute.v1.IHealthStatusForNetworkEndpoint>} healths
                         * @memberof google.cloud.compute.v1.NetworkEndpointWithHealthStatus
                         * @instance
                         */
                        NetworkEndpointWithHealthStatus.prototype.healths = $util.emptyArray;
    
                        /**
                         * NetworkEndpointWithHealthStatus networkEndpoint.
                         * @member {google.cloud.compute.v1.INetworkEndpoint|null|undefined} networkEndpoint
                         * @memberof google.cloud.compute.v1.NetworkEndpointWithHealthStatus
                         * @instance
                         */
                        NetworkEndpointWithHealthStatus.prototype.networkEndpoint = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworkEndpointWithHealthStatus _networkEndpoint.
                         * @member {"networkEndpoint"|undefined} _networkEndpoint
                         * @memberof google.cloud.compute.v1.NetworkEndpointWithHealthStatus
                         * @instance
                         */
                        Object.defineProperty(NetworkEndpointWithHealthStatus.prototype, "_networkEndpoint", {
                            get: $util.oneOfGetter($oneOfFields = ["networkEndpoint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworkEndpointWithHealthStatus instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkEndpointWithHealthStatus
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointWithHealthStatus=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkEndpointWithHealthStatus} NetworkEndpointWithHealthStatus instance
                         */
                        NetworkEndpointWithHealthStatus.create = function create(properties) {
                            return new NetworkEndpointWithHealthStatus(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointWithHealthStatus message. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointWithHealthStatus.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkEndpointWithHealthStatus
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointWithHealthStatus} message NetworkEndpointWithHealthStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointWithHealthStatus.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.networkEndpoint != null && Object.hasOwnProperty.call(message, "networkEndpoint"))
                                $root.google.cloud.compute.v1.NetworkEndpoint.encode(message.networkEndpoint, writer.uint32(/* id 56789126, wireType 2 =*/454313010).fork()).ldelim();
                            if (message.healths != null && message.healths.length)
                                for (var i = 0; i < message.healths.length; ++i)
                                    $root.google.cloud.compute.v1.HealthStatusForNetworkEndpoint.encode(message.healths[i], writer.uint32(/* id 258689431, wireType 2 =*/2069515450).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkEndpointWithHealthStatus message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkEndpointWithHealthStatus.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointWithHealthStatus
                         * @static
                         * @param {google.cloud.compute.v1.INetworkEndpointWithHealthStatus} message NetworkEndpointWithHealthStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkEndpointWithHealthStatus.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkEndpointWithHealthStatus message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkEndpointWithHealthStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkEndpointWithHealthStatus} NetworkEndpointWithHealthStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointWithHealthStatus.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkEndpointWithHealthStatus();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 258689431: {
                                        if (!(message.healths && message.healths.length))
                                            message.healths = [];
                                        message.healths.push($root.google.cloud.compute.v1.HealthStatusForNetworkEndpoint.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 56789126: {
                                        message.networkEndpoint = $root.google.cloud.compute.v1.NetworkEndpoint.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkEndpointWithHealthStatus message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkEndpointWithHealthStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkEndpointWithHealthStatus} NetworkEndpointWithHealthStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkEndpointWithHealthStatus.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkEndpointWithHealthStatus message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkEndpointWithHealthStatus
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkEndpointWithHealthStatus.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.healths != null && message.hasOwnProperty("healths")) {
                                if (!Array.isArray(message.healths))
                                    return "healths: array expected";
                                for (var i = 0; i < message.healths.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.HealthStatusForNetworkEndpoint.verify(message.healths[i]);
                                    if (error)
                                        return "healths." + error;
                                }
                            }
                            if (message.networkEndpoint != null && message.hasOwnProperty("networkEndpoint")) {
                                properties._networkEndpoint = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.NetworkEndpoint.verify(message.networkEndpoint);
                                    if (error)
                                        return "networkEndpoint." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkEndpointWithHealthStatus message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointWithHealthStatus
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkEndpointWithHealthStatus} NetworkEndpointWithHealthStatus
                         */
                        NetworkEndpointWithHealthStatus.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkEndpointWithHealthStatus)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkEndpointWithHealthStatus();
                            if (object.healths) {
                                if (!Array.isArray(object.healths))
                                    throw TypeError(".google.cloud.compute.v1.NetworkEndpointWithHealthStatus.healths: array expected");
                                message.healths = [];
                                for (var i = 0; i < object.healths.length; ++i) {
                                    if (typeof object.healths[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NetworkEndpointWithHealthStatus.healths: object expected");
                                    message.healths[i] = $root.google.cloud.compute.v1.HealthStatusForNetworkEndpoint.fromObject(object.healths[i]);
                                }
                            }
                            if (object.networkEndpoint != null) {
                                if (typeof object.networkEndpoint !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NetworkEndpointWithHealthStatus.networkEndpoint: object expected");
                                message.networkEndpoint = $root.google.cloud.compute.v1.NetworkEndpoint.fromObject(object.networkEndpoint);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkEndpointWithHealthStatus message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkEndpointWithHealthStatus
                         * @static
                         * @param {google.cloud.compute.v1.NetworkEndpointWithHealthStatus} message NetworkEndpointWithHealthStatus
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkEndpointWithHealthStatus.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.healths = [];
                            if (message.networkEndpoint != null && message.hasOwnProperty("networkEndpoint")) {
                                object.networkEndpoint = $root.google.cloud.compute.v1.NetworkEndpoint.toObject(message.networkEndpoint, options);
                                if (options.oneofs)
                                    object._networkEndpoint = "networkEndpoint";
                            }
                            if (message.healths && message.healths.length) {
                                object.healths = [];
                                for (var j = 0; j < message.healths.length; ++j)
                                    object.healths[j] = $root.google.cloud.compute.v1.HealthStatusForNetworkEndpoint.toObject(message.healths[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkEndpointWithHealthStatus to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkEndpointWithHealthStatus
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkEndpointWithHealthStatus.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkEndpointWithHealthStatus
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkEndpointWithHealthStatus
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkEndpointWithHealthStatus.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkEndpointWithHealthStatus";
                        };
    
                        return NetworkEndpointWithHealthStatus;
                    })();
    
                    v1.NetworkInterface = (function() {
    
                        /**
                         * Properties of a NetworkInterface.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkInterface
                         * @property {Array.<google.cloud.compute.v1.IAccessConfig>|null} [accessConfigs] NetworkInterface accessConfigs
                         * @property {Array.<google.cloud.compute.v1.IAliasIpRange>|null} [aliasIpRanges] NetworkInterface aliasIpRanges
                         * @property {string|null} [fingerprint] NetworkInterface fingerprint
                         * @property {number|null} [internalIpv6PrefixLength] NetworkInterface internalIpv6PrefixLength
                         * @property {Array.<google.cloud.compute.v1.IAccessConfig>|null} [ipv6AccessConfigs] NetworkInterface ipv6AccessConfigs
                         * @property {string|null} [ipv6AccessType] NetworkInterface ipv6AccessType
                         * @property {string|null} [ipv6Address] NetworkInterface ipv6Address
                         * @property {string|null} [kind] NetworkInterface kind
                         * @property {string|null} [name] NetworkInterface name
                         * @property {string|null} [network] NetworkInterface network
                         * @property {string|null} [networkIP] NetworkInterface networkIP
                         * @property {string|null} [nicType] NetworkInterface nicType
                         * @property {number|null} [queueCount] NetworkInterface queueCount
                         * @property {string|null} [stackType] NetworkInterface stackType
                         * @property {string|null} [subnetwork] NetworkInterface subnetwork
                         */
    
                        /**
                         * Constructs a new NetworkInterface.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkInterface.
                         * @implements INetworkInterface
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkInterface=} [properties] Properties to set
                         */
                        function NetworkInterface(properties) {
                            this.accessConfigs = [];
                            this.aliasIpRanges = [];
                            this.ipv6AccessConfigs = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkInterface accessConfigs.
                         * @member {Array.<google.cloud.compute.v1.IAccessConfig>} accessConfigs
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        NetworkInterface.prototype.accessConfigs = $util.emptyArray;
    
                        /**
                         * NetworkInterface aliasIpRanges.
                         * @member {Array.<google.cloud.compute.v1.IAliasIpRange>} aliasIpRanges
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        NetworkInterface.prototype.aliasIpRanges = $util.emptyArray;
    
                        /**
                         * NetworkInterface fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        NetworkInterface.prototype.fingerprint = null;
    
                        /**
                         * NetworkInterface internalIpv6PrefixLength.
                         * @member {number|null|undefined} internalIpv6PrefixLength
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        NetworkInterface.prototype.internalIpv6PrefixLength = null;
    
                        /**
                         * NetworkInterface ipv6AccessConfigs.
                         * @member {Array.<google.cloud.compute.v1.IAccessConfig>} ipv6AccessConfigs
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        NetworkInterface.prototype.ipv6AccessConfigs = $util.emptyArray;
    
                        /**
                         * NetworkInterface ipv6AccessType.
                         * @member {string|null|undefined} ipv6AccessType
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        NetworkInterface.prototype.ipv6AccessType = null;
    
                        /**
                         * NetworkInterface ipv6Address.
                         * @member {string|null|undefined} ipv6Address
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        NetworkInterface.prototype.ipv6Address = null;
    
                        /**
                         * NetworkInterface kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        NetworkInterface.prototype.kind = null;
    
                        /**
                         * NetworkInterface name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        NetworkInterface.prototype.name = null;
    
                        /**
                         * NetworkInterface network.
                         * @member {string|null|undefined} network
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        NetworkInterface.prototype.network = null;
    
                        /**
                         * NetworkInterface networkIP.
                         * @member {string|null|undefined} networkIP
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        NetworkInterface.prototype.networkIP = null;
    
                        /**
                         * NetworkInterface nicType.
                         * @member {string|null|undefined} nicType
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        NetworkInterface.prototype.nicType = null;
    
                        /**
                         * NetworkInterface queueCount.
                         * @member {number|null|undefined} queueCount
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        NetworkInterface.prototype.queueCount = null;
    
                        /**
                         * NetworkInterface stackType.
                         * @member {string|null|undefined} stackType
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        NetworkInterface.prototype.stackType = null;
    
                        /**
                         * NetworkInterface subnetwork.
                         * @member {string|null|undefined} subnetwork
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        NetworkInterface.prototype.subnetwork = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworkInterface _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        Object.defineProperty(NetworkInterface.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkInterface _internalIpv6PrefixLength.
                         * @member {"internalIpv6PrefixLength"|undefined} _internalIpv6PrefixLength
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        Object.defineProperty(NetworkInterface.prototype, "_internalIpv6PrefixLength", {
                            get: $util.oneOfGetter($oneOfFields = ["internalIpv6PrefixLength"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkInterface _ipv6AccessType.
                         * @member {"ipv6AccessType"|undefined} _ipv6AccessType
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        Object.defineProperty(NetworkInterface.prototype, "_ipv6AccessType", {
                            get: $util.oneOfGetter($oneOfFields = ["ipv6AccessType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkInterface _ipv6Address.
                         * @member {"ipv6Address"|undefined} _ipv6Address
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        Object.defineProperty(NetworkInterface.prototype, "_ipv6Address", {
                            get: $util.oneOfGetter($oneOfFields = ["ipv6Address"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkInterface _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        Object.defineProperty(NetworkInterface.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkInterface _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        Object.defineProperty(NetworkInterface.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkInterface _network.
                         * @member {"network"|undefined} _network
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        Object.defineProperty(NetworkInterface.prototype, "_network", {
                            get: $util.oneOfGetter($oneOfFields = ["network"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkInterface _networkIP.
                         * @member {"networkIP"|undefined} _networkIP
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        Object.defineProperty(NetworkInterface.prototype, "_networkIP", {
                            get: $util.oneOfGetter($oneOfFields = ["networkIP"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkInterface _nicType.
                         * @member {"nicType"|undefined} _nicType
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        Object.defineProperty(NetworkInterface.prototype, "_nicType", {
                            get: $util.oneOfGetter($oneOfFields = ["nicType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkInterface _queueCount.
                         * @member {"queueCount"|undefined} _queueCount
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        Object.defineProperty(NetworkInterface.prototype, "_queueCount", {
                            get: $util.oneOfGetter($oneOfFields = ["queueCount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkInterface _stackType.
                         * @member {"stackType"|undefined} _stackType
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        Object.defineProperty(NetworkInterface.prototype, "_stackType", {
                            get: $util.oneOfGetter($oneOfFields = ["stackType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkInterface _subnetwork.
                         * @member {"subnetwork"|undefined} _subnetwork
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         */
                        Object.defineProperty(NetworkInterface.prototype, "_subnetwork", {
                            get: $util.oneOfGetter($oneOfFields = ["subnetwork"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworkInterface instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @static
                         * @param {google.cloud.compute.v1.INetworkInterface=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkInterface} NetworkInterface instance
                         */
                        NetworkInterface.create = function create(properties) {
                            return new NetworkInterface(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkInterface message. Does not implicitly {@link google.cloud.compute.v1.NetworkInterface.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @static
                         * @param {google.cloud.compute.v1.INetworkInterface} message NetworkInterface message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkInterface.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.nicType != null && Object.hasOwnProperty.call(message, "nicType"))
                                writer.uint32(/* id 59810577, wireType 2 =*/478484618).string(message.nicType);
                            if (message.accessConfigs != null && message.accessConfigs.length)
                                for (var i = 0; i < message.accessConfigs.length; ++i)
                                    $root.google.cloud.compute.v1.AccessConfig.encode(message.accessConfigs[i], writer.uint32(/* id 111058326, wireType 2 =*/888466610).fork()).ldelim();
                            if (message.aliasIpRanges != null && message.aliasIpRanges.length)
                                for (var i = 0; i < message.aliasIpRanges.length; ++i)
                                    $root.google.cloud.compute.v1.AliasIpRange.encode(message.aliasIpRanges[i], writer.uint32(/* id 165085631, wireType 2 =*/1320685050).fork()).ldelim();
                            if (message.internalIpv6PrefixLength != null && Object.hasOwnProperty.call(message, "internalIpv6PrefixLength"))
                                writer.uint32(/* id 203833757, wireType 0 =*/1630670056).int32(message.internalIpv6PrefixLength);
                            if (message.networkIP != null && Object.hasOwnProperty.call(message, "networkIP"))
                                writer.uint32(/* id 207181961, wireType 2 =*/1657455690).string(message.networkIP);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.subnetwork != null && Object.hasOwnProperty.call(message, "subnetwork"))
                                writer.uint32(/* id 307827694, wireType 2 =*/2462621554).string(message.subnetwork);
                            if (message.ipv6Address != null && Object.hasOwnProperty.call(message, "ipv6Address"))
                                writer.uint32(/* id 341563804, wireType 2 =*/2732510434).string(message.ipv6Address);
                            if (message.stackType != null && Object.hasOwnProperty.call(message, "stackType"))
                                writer.uint32(/* id 425908881, wireType 2 =*/3407271050).string(message.stackType);
                            if (message.ipv6AccessConfigs != null && message.ipv6AccessConfigs.length)
                                for (var i = 0; i < message.ipv6AccessConfigs.length; ++i)
                                    $root.google.cloud.compute.v1.AccessConfig.encode(message.ipv6AccessConfigs[i], writer.uint32(/* id 483472110, wireType 2 =*/3867776882).fork()).ldelim();
                            if (message.queueCount != null && Object.hasOwnProperty.call(message, "queueCount"))
                                writer.uint32(/* id 503708769, wireType 0 =*/4029670152).int32(message.queueCount);
                            if (message.ipv6AccessType != null && Object.hasOwnProperty.call(message, "ipv6AccessType"))
                                writer.uint32(/* id 504658653, wireType 2 =*/4037269226).string(message.ipv6AccessType);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkInterface message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkInterface.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @static
                         * @param {google.cloud.compute.v1.INetworkInterface} message NetworkInterface message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkInterface.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkInterface message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkInterface} NetworkInterface
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkInterface.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkInterface();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 111058326: {
                                        if (!(message.accessConfigs && message.accessConfigs.length))
                                            message.accessConfigs = [];
                                        message.accessConfigs.push($root.google.cloud.compute.v1.AccessConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 165085631: {
                                        if (!(message.aliasIpRanges && message.aliasIpRanges.length))
                                            message.aliasIpRanges = [];
                                        message.aliasIpRanges.push($root.google.cloud.compute.v1.AliasIpRange.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 203833757: {
                                        message.internalIpv6PrefixLength = reader.int32();
                                        break;
                                    }
                                case 483472110: {
                                        if (!(message.ipv6AccessConfigs && message.ipv6AccessConfigs.length))
                                            message.ipv6AccessConfigs = [];
                                        message.ipv6AccessConfigs.push($root.google.cloud.compute.v1.AccessConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 504658653: {
                                        message.ipv6AccessType = reader.string();
                                        break;
                                    }
                                case 341563804: {
                                        message.ipv6Address = reader.string();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 207181961: {
                                        message.networkIP = reader.string();
                                        break;
                                    }
                                case 59810577: {
                                        message.nicType = reader.string();
                                        break;
                                    }
                                case 503708769: {
                                        message.queueCount = reader.int32();
                                        break;
                                    }
                                case 425908881: {
                                        message.stackType = reader.string();
                                        break;
                                    }
                                case 307827694: {
                                        message.subnetwork = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkInterface message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkInterface} NetworkInterface
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkInterface.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkInterface message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkInterface.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.accessConfigs != null && message.hasOwnProperty("accessConfigs")) {
                                if (!Array.isArray(message.accessConfigs))
                                    return "accessConfigs: array expected";
                                for (var i = 0; i < message.accessConfigs.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AccessConfig.verify(message.accessConfigs[i]);
                                    if (error)
                                        return "accessConfigs." + error;
                                }
                            }
                            if (message.aliasIpRanges != null && message.hasOwnProperty("aliasIpRanges")) {
                                if (!Array.isArray(message.aliasIpRanges))
                                    return "aliasIpRanges: array expected";
                                for (var i = 0; i < message.aliasIpRanges.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AliasIpRange.verify(message.aliasIpRanges[i]);
                                    if (error)
                                        return "aliasIpRanges." + error;
                                }
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.internalIpv6PrefixLength != null && message.hasOwnProperty("internalIpv6PrefixLength")) {
                                properties._internalIpv6PrefixLength = 1;
                                if (!$util.isInteger(message.internalIpv6PrefixLength))
                                    return "internalIpv6PrefixLength: integer expected";
                            }
                            if (message.ipv6AccessConfigs != null && message.hasOwnProperty("ipv6AccessConfigs")) {
                                if (!Array.isArray(message.ipv6AccessConfigs))
                                    return "ipv6AccessConfigs: array expected";
                                for (var i = 0; i < message.ipv6AccessConfigs.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AccessConfig.verify(message.ipv6AccessConfigs[i]);
                                    if (error)
                                        return "ipv6AccessConfigs." + error;
                                }
                            }
                            if (message.ipv6AccessType != null && message.hasOwnProperty("ipv6AccessType")) {
                                properties._ipv6AccessType = 1;
                                if (!$util.isString(message.ipv6AccessType))
                                    return "ipv6AccessType: string expected";
                            }
                            if (message.ipv6Address != null && message.hasOwnProperty("ipv6Address")) {
                                properties._ipv6Address = 1;
                                if (!$util.isString(message.ipv6Address))
                                    return "ipv6Address: string expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                properties._network = 1;
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            }
                            if (message.networkIP != null && message.hasOwnProperty("networkIP")) {
                                properties._networkIP = 1;
                                if (!$util.isString(message.networkIP))
                                    return "networkIP: string expected";
                            }
                            if (message.nicType != null && message.hasOwnProperty("nicType")) {
                                properties._nicType = 1;
                                if (!$util.isString(message.nicType))
                                    return "nicType: string expected";
                            }
                            if (message.queueCount != null && message.hasOwnProperty("queueCount")) {
                                properties._queueCount = 1;
                                if (!$util.isInteger(message.queueCount))
                                    return "queueCount: integer expected";
                            }
                            if (message.stackType != null && message.hasOwnProperty("stackType")) {
                                properties._stackType = 1;
                                if (!$util.isString(message.stackType))
                                    return "stackType: string expected";
                            }
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork")) {
                                properties._subnetwork = 1;
                                if (!$util.isString(message.subnetwork))
                                    return "subnetwork: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkInterface message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkInterface} NetworkInterface
                         */
                        NetworkInterface.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkInterface)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkInterface();
                            if (object.accessConfigs) {
                                if (!Array.isArray(object.accessConfigs))
                                    throw TypeError(".google.cloud.compute.v1.NetworkInterface.accessConfigs: array expected");
                                message.accessConfigs = [];
                                for (var i = 0; i < object.accessConfigs.length; ++i) {
                                    if (typeof object.accessConfigs[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NetworkInterface.accessConfigs: object expected");
                                    message.accessConfigs[i] = $root.google.cloud.compute.v1.AccessConfig.fromObject(object.accessConfigs[i]);
                                }
                            }
                            if (object.aliasIpRanges) {
                                if (!Array.isArray(object.aliasIpRanges))
                                    throw TypeError(".google.cloud.compute.v1.NetworkInterface.aliasIpRanges: array expected");
                                message.aliasIpRanges = [];
                                for (var i = 0; i < object.aliasIpRanges.length; ++i) {
                                    if (typeof object.aliasIpRanges[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NetworkInterface.aliasIpRanges: object expected");
                                    message.aliasIpRanges[i] = $root.google.cloud.compute.v1.AliasIpRange.fromObject(object.aliasIpRanges[i]);
                                }
                            }
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.internalIpv6PrefixLength != null)
                                message.internalIpv6PrefixLength = object.internalIpv6PrefixLength | 0;
                            if (object.ipv6AccessConfigs) {
                                if (!Array.isArray(object.ipv6AccessConfigs))
                                    throw TypeError(".google.cloud.compute.v1.NetworkInterface.ipv6AccessConfigs: array expected");
                                message.ipv6AccessConfigs = [];
                                for (var i = 0; i < object.ipv6AccessConfigs.length; ++i) {
                                    if (typeof object.ipv6AccessConfigs[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NetworkInterface.ipv6AccessConfigs: object expected");
                                    message.ipv6AccessConfigs[i] = $root.google.cloud.compute.v1.AccessConfig.fromObject(object.ipv6AccessConfigs[i]);
                                }
                            }
                            if (object.ipv6AccessType != null)
                                message.ipv6AccessType = String(object.ipv6AccessType);
                            if (object.ipv6Address != null)
                                message.ipv6Address = String(object.ipv6Address);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.networkIP != null)
                                message.networkIP = String(object.networkIP);
                            if (object.nicType != null)
                                message.nicType = String(object.nicType);
                            if (object.queueCount != null)
                                message.queueCount = object.queueCount | 0;
                            if (object.stackType != null)
                                message.stackType = String(object.stackType);
                            if (object.subnetwork != null)
                                message.subnetwork = String(object.subnetwork);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkInterface message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @static
                         * @param {google.cloud.compute.v1.NetworkInterface} message NetworkInterface
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkInterface.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.accessConfigs = [];
                                object.aliasIpRanges = [];
                                object.ipv6AccessConfigs = [];
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.nicType != null && message.hasOwnProperty("nicType")) {
                                object.nicType = message.nicType;
                                if (options.oneofs)
                                    object._nicType = "nicType";
                            }
                            if (message.accessConfigs && message.accessConfigs.length) {
                                object.accessConfigs = [];
                                for (var j = 0; j < message.accessConfigs.length; ++j)
                                    object.accessConfigs[j] = $root.google.cloud.compute.v1.AccessConfig.toObject(message.accessConfigs[j], options);
                            }
                            if (message.aliasIpRanges && message.aliasIpRanges.length) {
                                object.aliasIpRanges = [];
                                for (var j = 0; j < message.aliasIpRanges.length; ++j)
                                    object.aliasIpRanges[j] = $root.google.cloud.compute.v1.AliasIpRange.toObject(message.aliasIpRanges[j], options);
                            }
                            if (message.internalIpv6PrefixLength != null && message.hasOwnProperty("internalIpv6PrefixLength")) {
                                object.internalIpv6PrefixLength = message.internalIpv6PrefixLength;
                                if (options.oneofs)
                                    object._internalIpv6PrefixLength = "internalIpv6PrefixLength";
                            }
                            if (message.networkIP != null && message.hasOwnProperty("networkIP")) {
                                object.networkIP = message.networkIP;
                                if (options.oneofs)
                                    object._networkIP = "networkIP";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                object.network = message.network;
                                if (options.oneofs)
                                    object._network = "network";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork")) {
                                object.subnetwork = message.subnetwork;
                                if (options.oneofs)
                                    object._subnetwork = "subnetwork";
                            }
                            if (message.ipv6Address != null && message.hasOwnProperty("ipv6Address")) {
                                object.ipv6Address = message.ipv6Address;
                                if (options.oneofs)
                                    object._ipv6Address = "ipv6Address";
                            }
                            if (message.stackType != null && message.hasOwnProperty("stackType")) {
                                object.stackType = message.stackType;
                                if (options.oneofs)
                                    object._stackType = "stackType";
                            }
                            if (message.ipv6AccessConfigs && message.ipv6AccessConfigs.length) {
                                object.ipv6AccessConfigs = [];
                                for (var j = 0; j < message.ipv6AccessConfigs.length; ++j)
                                    object.ipv6AccessConfigs[j] = $root.google.cloud.compute.v1.AccessConfig.toObject(message.ipv6AccessConfigs[j], options);
                            }
                            if (message.queueCount != null && message.hasOwnProperty("queueCount")) {
                                object.queueCount = message.queueCount;
                                if (options.oneofs)
                                    object._queueCount = "queueCount";
                            }
                            if (message.ipv6AccessType != null && message.hasOwnProperty("ipv6AccessType")) {
                                object.ipv6AccessType = message.ipv6AccessType;
                                if (options.oneofs)
                                    object._ipv6AccessType = "ipv6AccessType";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkInterface to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkInterface.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkInterface
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkInterface
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkInterface.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkInterface";
                        };
    
                        /**
                         * Ipv6AccessType enum.
                         * @name google.cloud.compute.v1.NetworkInterface.Ipv6AccessType
                         * @enum {number}
                         * @property {number} UNDEFINED_IPV6_ACCESS_TYPE=0 UNDEFINED_IPV6_ACCESS_TYPE value
                         * @property {number} EXTERNAL=35607499 EXTERNAL value
                         * @property {number} INTERNAL=279295677 INTERNAL value
                         * @property {number} UNSPECIFIED_IPV6_ACCESS_TYPE=313080613 UNSPECIFIED_IPV6_ACCESS_TYPE value
                         */
                        NetworkInterface.Ipv6AccessType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_IPV6_ACCESS_TYPE"] = 0;
                            values[valuesById[35607499] = "EXTERNAL"] = 35607499;
                            values[valuesById[279295677] = "INTERNAL"] = 279295677;
                            values[valuesById[313080613] = "UNSPECIFIED_IPV6_ACCESS_TYPE"] = 313080613;
                            return values;
                        })();
    
                        /**
                         * NicType enum.
                         * @name google.cloud.compute.v1.NetworkInterface.NicType
                         * @enum {number}
                         * @property {number} UNDEFINED_NIC_TYPE=0 UNDEFINED_NIC_TYPE value
                         * @property {number} GVNIC=68209305 GVNIC value
                         * @property {number} UNSPECIFIED_NIC_TYPE=67411801 UNSPECIFIED_NIC_TYPE value
                         * @property {number} VIRTIO_NET=452123481 VIRTIO_NET value
                         */
                        NetworkInterface.NicType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_NIC_TYPE"] = 0;
                            values[valuesById[68209305] = "GVNIC"] = 68209305;
                            values[valuesById[67411801] = "UNSPECIFIED_NIC_TYPE"] = 67411801;
                            values[valuesById[452123481] = "VIRTIO_NET"] = 452123481;
                            return values;
                        })();
    
                        /**
                         * StackType enum.
                         * @name google.cloud.compute.v1.NetworkInterface.StackType
                         * @enum {number}
                         * @property {number} UNDEFINED_STACK_TYPE=0 UNDEFINED_STACK_TYPE value
                         * @property {number} IPV4_IPV6=22197249 IPV4_IPV6 value
                         * @property {number} IPV4_ONLY=22373798 IPV4_ONLY value
                         * @property {number} UNSPECIFIED_STACK_TYPE=298084569 UNSPECIFIED_STACK_TYPE value
                         */
                        NetworkInterface.StackType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STACK_TYPE"] = 0;
                            values[valuesById[22197249] = "IPV4_IPV6"] = 22197249;
                            values[valuesById[22373798] = "IPV4_ONLY"] = 22373798;
                            values[valuesById[298084569] = "UNSPECIFIED_STACK_TYPE"] = 298084569;
                            return values;
                        })();
    
                        return NetworkInterface;
                    })();
    
                    v1.NetworkList = (function() {
    
                        /**
                         * Properties of a NetworkList.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkList
                         * @property {string|null} [id] NetworkList id
                         * @property {Array.<google.cloud.compute.v1.INetwork>|null} [items] NetworkList items
                         * @property {string|null} [kind] NetworkList kind
                         * @property {string|null} [nextPageToken] NetworkList nextPageToken
                         * @property {string|null} [selfLink] NetworkList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] NetworkList warning
                         */
    
                        /**
                         * Constructs a new NetworkList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkList.
                         * @implements INetworkList
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkList=} [properties] Properties to set
                         */
                        function NetworkList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @instance
                         */
                        NetworkList.prototype.id = null;
    
                        /**
                         * NetworkList items.
                         * @member {Array.<google.cloud.compute.v1.INetwork>} items
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @instance
                         */
                        NetworkList.prototype.items = $util.emptyArray;
    
                        /**
                         * NetworkList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @instance
                         */
                        NetworkList.prototype.kind = null;
    
                        /**
                         * NetworkList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @instance
                         */
                        NetworkList.prototype.nextPageToken = null;
    
                        /**
                         * NetworkList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @instance
                         */
                        NetworkList.prototype.selfLink = null;
    
                        /**
                         * NetworkList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @instance
                         */
                        NetworkList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworkList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @instance
                         */
                        Object.defineProperty(NetworkList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @instance
                         */
                        Object.defineProperty(NetworkList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @instance
                         */
                        Object.defineProperty(NetworkList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @instance
                         */
                        Object.defineProperty(NetworkList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @instance
                         */
                        Object.defineProperty(NetworkList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworkList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @static
                         * @param {google.cloud.compute.v1.INetworkList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkList} NetworkList instance
                         */
                        NetworkList.create = function create(properties) {
                            return new NetworkList(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkList message. Does not implicitly {@link google.cloud.compute.v1.NetworkList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @static
                         * @param {google.cloud.compute.v1.INetworkList} message NetworkList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Network.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @static
                         * @param {google.cloud.compute.v1.INetworkList} message NetworkList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkList} NetworkList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Network.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkList} NetworkList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Network.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkList} NetworkList
                         */
                        NetworkList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.NetworkList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NetworkList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Network.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NetworkList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @static
                         * @param {google.cloud.compute.v1.NetworkList} message NetworkList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Network.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkList";
                        };
    
                        return NetworkList;
                    })();
    
                    v1.NetworkPeering = (function() {
    
                        /**
                         * Properties of a NetworkPeering.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkPeering
                         * @property {boolean|null} [autoCreateRoutes] NetworkPeering autoCreateRoutes
                         * @property {boolean|null} [exchangeSubnetRoutes] NetworkPeering exchangeSubnetRoutes
                         * @property {boolean|null} [exportCustomRoutes] NetworkPeering exportCustomRoutes
                         * @property {boolean|null} [exportSubnetRoutesWithPublicIp] NetworkPeering exportSubnetRoutesWithPublicIp
                         * @property {boolean|null} [importCustomRoutes] NetworkPeering importCustomRoutes
                         * @property {boolean|null} [importSubnetRoutesWithPublicIp] NetworkPeering importSubnetRoutesWithPublicIp
                         * @property {string|null} [name] NetworkPeering name
                         * @property {string|null} [network] NetworkPeering network
                         * @property {number|null} [peerMtu] NetworkPeering peerMtu
                         * @property {string|null} [stackType] NetworkPeering stackType
                         * @property {string|null} [state] NetworkPeering state
                         * @property {string|null} [stateDetails] NetworkPeering stateDetails
                         */
    
                        /**
                         * Constructs a new NetworkPeering.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkPeering.
                         * @implements INetworkPeering
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkPeering=} [properties] Properties to set
                         */
                        function NetworkPeering(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkPeering autoCreateRoutes.
                         * @member {boolean|null|undefined} autoCreateRoutes
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        NetworkPeering.prototype.autoCreateRoutes = null;
    
                        /**
                         * NetworkPeering exchangeSubnetRoutes.
                         * @member {boolean|null|undefined} exchangeSubnetRoutes
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        NetworkPeering.prototype.exchangeSubnetRoutes = null;
    
                        /**
                         * NetworkPeering exportCustomRoutes.
                         * @member {boolean|null|undefined} exportCustomRoutes
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        NetworkPeering.prototype.exportCustomRoutes = null;
    
                        /**
                         * NetworkPeering exportSubnetRoutesWithPublicIp.
                         * @member {boolean|null|undefined} exportSubnetRoutesWithPublicIp
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        NetworkPeering.prototype.exportSubnetRoutesWithPublicIp = null;
    
                        /**
                         * NetworkPeering importCustomRoutes.
                         * @member {boolean|null|undefined} importCustomRoutes
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        NetworkPeering.prototype.importCustomRoutes = null;
    
                        /**
                         * NetworkPeering importSubnetRoutesWithPublicIp.
                         * @member {boolean|null|undefined} importSubnetRoutesWithPublicIp
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        NetworkPeering.prototype.importSubnetRoutesWithPublicIp = null;
    
                        /**
                         * NetworkPeering name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        NetworkPeering.prototype.name = null;
    
                        /**
                         * NetworkPeering network.
                         * @member {string|null|undefined} network
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        NetworkPeering.prototype.network = null;
    
                        /**
                         * NetworkPeering peerMtu.
                         * @member {number|null|undefined} peerMtu
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        NetworkPeering.prototype.peerMtu = null;
    
                        /**
                         * NetworkPeering stackType.
                         * @member {string|null|undefined} stackType
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        NetworkPeering.prototype.stackType = null;
    
                        /**
                         * NetworkPeering state.
                         * @member {string|null|undefined} state
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        NetworkPeering.prototype.state = null;
    
                        /**
                         * NetworkPeering stateDetails.
                         * @member {string|null|undefined} stateDetails
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        NetworkPeering.prototype.stateDetails = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworkPeering _autoCreateRoutes.
                         * @member {"autoCreateRoutes"|undefined} _autoCreateRoutes
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        Object.defineProperty(NetworkPeering.prototype, "_autoCreateRoutes", {
                            get: $util.oneOfGetter($oneOfFields = ["autoCreateRoutes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkPeering _exchangeSubnetRoutes.
                         * @member {"exchangeSubnetRoutes"|undefined} _exchangeSubnetRoutes
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        Object.defineProperty(NetworkPeering.prototype, "_exchangeSubnetRoutes", {
                            get: $util.oneOfGetter($oneOfFields = ["exchangeSubnetRoutes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkPeering _exportCustomRoutes.
                         * @member {"exportCustomRoutes"|undefined} _exportCustomRoutes
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        Object.defineProperty(NetworkPeering.prototype, "_exportCustomRoutes", {
                            get: $util.oneOfGetter($oneOfFields = ["exportCustomRoutes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkPeering _exportSubnetRoutesWithPublicIp.
                         * @member {"exportSubnetRoutesWithPublicIp"|undefined} _exportSubnetRoutesWithPublicIp
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        Object.defineProperty(NetworkPeering.prototype, "_exportSubnetRoutesWithPublicIp", {
                            get: $util.oneOfGetter($oneOfFields = ["exportSubnetRoutesWithPublicIp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkPeering _importCustomRoutes.
                         * @member {"importCustomRoutes"|undefined} _importCustomRoutes
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        Object.defineProperty(NetworkPeering.prototype, "_importCustomRoutes", {
                            get: $util.oneOfGetter($oneOfFields = ["importCustomRoutes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkPeering _importSubnetRoutesWithPublicIp.
                         * @member {"importSubnetRoutesWithPublicIp"|undefined} _importSubnetRoutesWithPublicIp
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        Object.defineProperty(NetworkPeering.prototype, "_importSubnetRoutesWithPublicIp", {
                            get: $util.oneOfGetter($oneOfFields = ["importSubnetRoutesWithPublicIp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkPeering _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        Object.defineProperty(NetworkPeering.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkPeering _network.
                         * @member {"network"|undefined} _network
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        Object.defineProperty(NetworkPeering.prototype, "_network", {
                            get: $util.oneOfGetter($oneOfFields = ["network"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkPeering _peerMtu.
                         * @member {"peerMtu"|undefined} _peerMtu
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        Object.defineProperty(NetworkPeering.prototype, "_peerMtu", {
                            get: $util.oneOfGetter($oneOfFields = ["peerMtu"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkPeering _stackType.
                         * @member {"stackType"|undefined} _stackType
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        Object.defineProperty(NetworkPeering.prototype, "_stackType", {
                            get: $util.oneOfGetter($oneOfFields = ["stackType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkPeering _state.
                         * @member {"state"|undefined} _state
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        Object.defineProperty(NetworkPeering.prototype, "_state", {
                            get: $util.oneOfGetter($oneOfFields = ["state"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworkPeering _stateDetails.
                         * @member {"stateDetails"|undefined} _stateDetails
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         */
                        Object.defineProperty(NetworkPeering.prototype, "_stateDetails", {
                            get: $util.oneOfGetter($oneOfFields = ["stateDetails"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworkPeering instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @static
                         * @param {google.cloud.compute.v1.INetworkPeering=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkPeering} NetworkPeering instance
                         */
                        NetworkPeering.create = function create(properties) {
                            return new NetworkPeering(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkPeering message. Does not implicitly {@link google.cloud.compute.v1.NetworkPeering.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @static
                         * @param {google.cloud.compute.v1.INetworkPeering} message NetworkPeering message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkPeering.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.importSubnetRoutesWithPublicIp != null && Object.hasOwnProperty.call(message, "importSubnetRoutesWithPublicIp"))
                                writer.uint32(/* id 14419729, wireType 0 =*/115357832).bool(message.importSubnetRoutesWithPublicIp);
                            if (message.exchangeSubnetRoutes != null && Object.hasOwnProperty.call(message, "exchangeSubnetRoutes"))
                                writer.uint32(/* id 26322256, wireType 0 =*/210578048).bool(message.exchangeSubnetRoutes);
                            if (message.autoCreateRoutes != null && Object.hasOwnProperty.call(message, "autoCreateRoutes"))
                                writer.uint32(/* id 57454941, wireType 0 =*/459639528).bool(message.autoCreateRoutes);
                            if (message.exportCustomRoutes != null && Object.hasOwnProperty.call(message, "exportCustomRoutes"))
                                writer.uint32(/* id 60281485, wireType 0 =*/482251880).bool(message.exportCustomRoutes);
                            if (message.peerMtu != null && Object.hasOwnProperty.call(message, "peerMtu"))
                                writer.uint32(/* id 69584721, wireType 0 =*/556677768).int32(message.peerMtu);
                            if (message.stateDetails != null && Object.hasOwnProperty.call(message, "stateDetails"))
                                writer.uint32(/* id 95566996, wireType 2 =*/764535970).string(message.stateDetails);
                            if (message.exportSubnetRoutesWithPublicIp != null && Object.hasOwnProperty.call(message, "exportSubnetRoutesWithPublicIp"))
                                writer.uint32(/* id 97940834, wireType 0 =*/783526672).bool(message.exportSubnetRoutesWithPublicIp);
                            if (message.state != null && Object.hasOwnProperty.call(message, "state"))
                                writer.uint32(/* id 109757585, wireType 2 =*/878060682).string(message.state);
                            if (message.importCustomRoutes != null && Object.hasOwnProperty.call(message, "importCustomRoutes"))
                                writer.uint32(/* id 197982398, wireType 0 =*/1583859184).bool(message.importCustomRoutes);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            if (message.stackType != null && Object.hasOwnProperty.call(message, "stackType"))
                                writer.uint32(/* id 425908881, wireType 2 =*/3407271050).string(message.stackType);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkPeering message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkPeering.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @static
                         * @param {google.cloud.compute.v1.INetworkPeering} message NetworkPeering message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkPeering.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkPeering message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkPeering} NetworkPeering
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkPeering.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkPeering();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 57454941: {
                                        message.autoCreateRoutes = reader.bool();
                                        break;
                                    }
                                case 26322256: {
                                        message.exchangeSubnetRoutes = reader.bool();
                                        break;
                                    }
                                case 60281485: {
                                        message.exportCustomRoutes = reader.bool();
                                        break;
                                    }
                                case 97940834: {
                                        message.exportSubnetRoutesWithPublicIp = reader.bool();
                                        break;
                                    }
                                case 197982398: {
                                        message.importCustomRoutes = reader.bool();
                                        break;
                                    }
                                case 14419729: {
                                        message.importSubnetRoutesWithPublicIp = reader.bool();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 69584721: {
                                        message.peerMtu = reader.int32();
                                        break;
                                    }
                                case 425908881: {
                                        message.stackType = reader.string();
                                        break;
                                    }
                                case 109757585: {
                                        message.state = reader.string();
                                        break;
                                    }
                                case 95566996: {
                                        message.stateDetails = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkPeering message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkPeering} NetworkPeering
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkPeering.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkPeering message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkPeering.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoCreateRoutes != null && message.hasOwnProperty("autoCreateRoutes")) {
                                properties._autoCreateRoutes = 1;
                                if (typeof message.autoCreateRoutes !== "boolean")
                                    return "autoCreateRoutes: boolean expected";
                            }
                            if (message.exchangeSubnetRoutes != null && message.hasOwnProperty("exchangeSubnetRoutes")) {
                                properties._exchangeSubnetRoutes = 1;
                                if (typeof message.exchangeSubnetRoutes !== "boolean")
                                    return "exchangeSubnetRoutes: boolean expected";
                            }
                            if (message.exportCustomRoutes != null && message.hasOwnProperty("exportCustomRoutes")) {
                                properties._exportCustomRoutes = 1;
                                if (typeof message.exportCustomRoutes !== "boolean")
                                    return "exportCustomRoutes: boolean expected";
                            }
                            if (message.exportSubnetRoutesWithPublicIp != null && message.hasOwnProperty("exportSubnetRoutesWithPublicIp")) {
                                properties._exportSubnetRoutesWithPublicIp = 1;
                                if (typeof message.exportSubnetRoutesWithPublicIp !== "boolean")
                                    return "exportSubnetRoutesWithPublicIp: boolean expected";
                            }
                            if (message.importCustomRoutes != null && message.hasOwnProperty("importCustomRoutes")) {
                                properties._importCustomRoutes = 1;
                                if (typeof message.importCustomRoutes !== "boolean")
                                    return "importCustomRoutes: boolean expected";
                            }
                            if (message.importSubnetRoutesWithPublicIp != null && message.hasOwnProperty("importSubnetRoutesWithPublicIp")) {
                                properties._importSubnetRoutesWithPublicIp = 1;
                                if (typeof message.importSubnetRoutesWithPublicIp !== "boolean")
                                    return "importSubnetRoutesWithPublicIp: boolean expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                properties._network = 1;
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            }
                            if (message.peerMtu != null && message.hasOwnProperty("peerMtu")) {
                                properties._peerMtu = 1;
                                if (!$util.isInteger(message.peerMtu))
                                    return "peerMtu: integer expected";
                            }
                            if (message.stackType != null && message.hasOwnProperty("stackType")) {
                                properties._stackType = 1;
                                if (!$util.isString(message.stackType))
                                    return "stackType: string expected";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                properties._state = 1;
                                if (!$util.isString(message.state))
                                    return "state: string expected";
                            }
                            if (message.stateDetails != null && message.hasOwnProperty("stateDetails")) {
                                properties._stateDetails = 1;
                                if (!$util.isString(message.stateDetails))
                                    return "stateDetails: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkPeering message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkPeering} NetworkPeering
                         */
                        NetworkPeering.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkPeering)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkPeering();
                            if (object.autoCreateRoutes != null)
                                message.autoCreateRoutes = Boolean(object.autoCreateRoutes);
                            if (object.exchangeSubnetRoutes != null)
                                message.exchangeSubnetRoutes = Boolean(object.exchangeSubnetRoutes);
                            if (object.exportCustomRoutes != null)
                                message.exportCustomRoutes = Boolean(object.exportCustomRoutes);
                            if (object.exportSubnetRoutesWithPublicIp != null)
                                message.exportSubnetRoutesWithPublicIp = Boolean(object.exportSubnetRoutesWithPublicIp);
                            if (object.importCustomRoutes != null)
                                message.importCustomRoutes = Boolean(object.importCustomRoutes);
                            if (object.importSubnetRoutesWithPublicIp != null)
                                message.importSubnetRoutesWithPublicIp = Boolean(object.importSubnetRoutesWithPublicIp);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.peerMtu != null)
                                message.peerMtu = object.peerMtu | 0;
                            if (object.stackType != null)
                                message.stackType = String(object.stackType);
                            if (object.state != null)
                                message.state = String(object.state);
                            if (object.stateDetails != null)
                                message.stateDetails = String(object.stateDetails);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkPeering message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @static
                         * @param {google.cloud.compute.v1.NetworkPeering} message NetworkPeering
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkPeering.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.importSubnetRoutesWithPublicIp != null && message.hasOwnProperty("importSubnetRoutesWithPublicIp")) {
                                object.importSubnetRoutesWithPublicIp = message.importSubnetRoutesWithPublicIp;
                                if (options.oneofs)
                                    object._importSubnetRoutesWithPublicIp = "importSubnetRoutesWithPublicIp";
                            }
                            if (message.exchangeSubnetRoutes != null && message.hasOwnProperty("exchangeSubnetRoutes")) {
                                object.exchangeSubnetRoutes = message.exchangeSubnetRoutes;
                                if (options.oneofs)
                                    object._exchangeSubnetRoutes = "exchangeSubnetRoutes";
                            }
                            if (message.autoCreateRoutes != null && message.hasOwnProperty("autoCreateRoutes")) {
                                object.autoCreateRoutes = message.autoCreateRoutes;
                                if (options.oneofs)
                                    object._autoCreateRoutes = "autoCreateRoutes";
                            }
                            if (message.exportCustomRoutes != null && message.hasOwnProperty("exportCustomRoutes")) {
                                object.exportCustomRoutes = message.exportCustomRoutes;
                                if (options.oneofs)
                                    object._exportCustomRoutes = "exportCustomRoutes";
                            }
                            if (message.peerMtu != null && message.hasOwnProperty("peerMtu")) {
                                object.peerMtu = message.peerMtu;
                                if (options.oneofs)
                                    object._peerMtu = "peerMtu";
                            }
                            if (message.stateDetails != null && message.hasOwnProperty("stateDetails")) {
                                object.stateDetails = message.stateDetails;
                                if (options.oneofs)
                                    object._stateDetails = "stateDetails";
                            }
                            if (message.exportSubnetRoutesWithPublicIp != null && message.hasOwnProperty("exportSubnetRoutesWithPublicIp")) {
                                object.exportSubnetRoutesWithPublicIp = message.exportSubnetRoutesWithPublicIp;
                                if (options.oneofs)
                                    object._exportSubnetRoutesWithPublicIp = "exportSubnetRoutesWithPublicIp";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                object.state = message.state;
                                if (options.oneofs)
                                    object._state = "state";
                            }
                            if (message.importCustomRoutes != null && message.hasOwnProperty("importCustomRoutes")) {
                                object.importCustomRoutes = message.importCustomRoutes;
                                if (options.oneofs)
                                    object._importCustomRoutes = "importCustomRoutes";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                object.network = message.network;
                                if (options.oneofs)
                                    object._network = "network";
                            }
                            if (message.stackType != null && message.hasOwnProperty("stackType")) {
                                object.stackType = message.stackType;
                                if (options.oneofs)
                                    object._stackType = "stackType";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkPeering to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkPeering.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkPeering
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkPeering
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkPeering.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkPeering";
                        };
    
                        /**
                         * StackType enum.
                         * @name google.cloud.compute.v1.NetworkPeering.StackType
                         * @enum {number}
                         * @property {number} UNDEFINED_STACK_TYPE=0 UNDEFINED_STACK_TYPE value
                         * @property {number} IPV4_IPV6=22197249 IPV4_IPV6 value
                         * @property {number} IPV4_ONLY=22373798 IPV4_ONLY value
                         */
                        NetworkPeering.StackType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STACK_TYPE"] = 0;
                            values[valuesById[22197249] = "IPV4_IPV6"] = 22197249;
                            values[valuesById[22373798] = "IPV4_ONLY"] = 22373798;
                            return values;
                        })();
    
                        /**
                         * State enum.
                         * @name google.cloud.compute.v1.NetworkPeering.State
                         * @enum {number}
                         * @property {number} UNDEFINED_STATE=0 UNDEFINED_STATE value
                         * @property {number} ACTIVE=314733318 ACTIVE value
                         * @property {number} INACTIVE=270421099 INACTIVE value
                         */
                        NetworkPeering.State = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATE"] = 0;
                            values[valuesById[314733318] = "ACTIVE"] = 314733318;
                            values[valuesById[270421099] = "INACTIVE"] = 270421099;
                            return values;
                        })();
    
                        return NetworkPeering;
                    })();
    
                    v1.NetworkPerformanceConfig = (function() {
    
                        /**
                         * Properties of a NetworkPerformanceConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkPerformanceConfig
                         * @property {string|null} [totalEgressBandwidthTier] NetworkPerformanceConfig totalEgressBandwidthTier
                         */
    
                        /**
                         * Constructs a new NetworkPerformanceConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkPerformanceConfig.
                         * @implements INetworkPerformanceConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkPerformanceConfig=} [properties] Properties to set
                         */
                        function NetworkPerformanceConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkPerformanceConfig totalEgressBandwidthTier.
                         * @member {string|null|undefined} totalEgressBandwidthTier
                         * @memberof google.cloud.compute.v1.NetworkPerformanceConfig
                         * @instance
                         */
                        NetworkPerformanceConfig.prototype.totalEgressBandwidthTier = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworkPerformanceConfig _totalEgressBandwidthTier.
                         * @member {"totalEgressBandwidthTier"|undefined} _totalEgressBandwidthTier
                         * @memberof google.cloud.compute.v1.NetworkPerformanceConfig
                         * @instance
                         */
                        Object.defineProperty(NetworkPerformanceConfig.prototype, "_totalEgressBandwidthTier", {
                            get: $util.oneOfGetter($oneOfFields = ["totalEgressBandwidthTier"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworkPerformanceConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkPerformanceConfig
                         * @static
                         * @param {google.cloud.compute.v1.INetworkPerformanceConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkPerformanceConfig} NetworkPerformanceConfig instance
                         */
                        NetworkPerformanceConfig.create = function create(properties) {
                            return new NetworkPerformanceConfig(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkPerformanceConfig message. Does not implicitly {@link google.cloud.compute.v1.NetworkPerformanceConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkPerformanceConfig
                         * @static
                         * @param {google.cloud.compute.v1.INetworkPerformanceConfig} message NetworkPerformanceConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkPerformanceConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.totalEgressBandwidthTier != null && Object.hasOwnProperty.call(message, "totalEgressBandwidthTier"))
                                writer.uint32(/* id 130109439, wireType 2 =*/1040875514).string(message.totalEgressBandwidthTier);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkPerformanceConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkPerformanceConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkPerformanceConfig
                         * @static
                         * @param {google.cloud.compute.v1.INetworkPerformanceConfig} message NetworkPerformanceConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkPerformanceConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkPerformanceConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkPerformanceConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkPerformanceConfig} NetworkPerformanceConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkPerformanceConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkPerformanceConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 130109439: {
                                        message.totalEgressBandwidthTier = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkPerformanceConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkPerformanceConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkPerformanceConfig} NetworkPerformanceConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkPerformanceConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkPerformanceConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkPerformanceConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkPerformanceConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.totalEgressBandwidthTier != null && message.hasOwnProperty("totalEgressBandwidthTier")) {
                                properties._totalEgressBandwidthTier = 1;
                                if (!$util.isString(message.totalEgressBandwidthTier))
                                    return "totalEgressBandwidthTier: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkPerformanceConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkPerformanceConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkPerformanceConfig} NetworkPerformanceConfig
                         */
                        NetworkPerformanceConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkPerformanceConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkPerformanceConfig();
                            if (object.totalEgressBandwidthTier != null)
                                message.totalEgressBandwidthTier = String(object.totalEgressBandwidthTier);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkPerformanceConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkPerformanceConfig
                         * @static
                         * @param {google.cloud.compute.v1.NetworkPerformanceConfig} message NetworkPerformanceConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkPerformanceConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.totalEgressBandwidthTier != null && message.hasOwnProperty("totalEgressBandwidthTier")) {
                                object.totalEgressBandwidthTier = message.totalEgressBandwidthTier;
                                if (options.oneofs)
                                    object._totalEgressBandwidthTier = "totalEgressBandwidthTier";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkPerformanceConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkPerformanceConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkPerformanceConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkPerformanceConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkPerformanceConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkPerformanceConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkPerformanceConfig";
                        };
    
                        /**
                         * TotalEgressBandwidthTier enum.
                         * @name google.cloud.compute.v1.NetworkPerformanceConfig.TotalEgressBandwidthTier
                         * @enum {number}
                         * @property {number} UNDEFINED_TOTAL_EGRESS_BANDWIDTH_TIER=0 UNDEFINED_TOTAL_EGRESS_BANDWIDTH_TIER value
                         * @property {number} DEFAULT=115302945 DEFAULT value
                         * @property {number} TIER_1=326919444 TIER_1 value
                         */
                        NetworkPerformanceConfig.TotalEgressBandwidthTier = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TOTAL_EGRESS_BANDWIDTH_TIER"] = 0;
                            values[valuesById[115302945] = "DEFAULT"] = 115302945;
                            values[valuesById[326919444] = "TIER_1"] = 326919444;
                            return values;
                        })();
    
                        return NetworkPerformanceConfig;
                    })();
    
                    v1.NetworkRoutingConfig = (function() {
    
                        /**
                         * Properties of a NetworkRoutingConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworkRoutingConfig
                         * @property {string|null} [routingMode] NetworkRoutingConfig routingMode
                         */
    
                        /**
                         * Constructs a new NetworkRoutingConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkRoutingConfig.
                         * @implements INetworkRoutingConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworkRoutingConfig=} [properties] Properties to set
                         */
                        function NetworkRoutingConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworkRoutingConfig routingMode.
                         * @member {string|null|undefined} routingMode
                         * @memberof google.cloud.compute.v1.NetworkRoutingConfig
                         * @instance
                         */
                        NetworkRoutingConfig.prototype.routingMode = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworkRoutingConfig _routingMode.
                         * @member {"routingMode"|undefined} _routingMode
                         * @memberof google.cloud.compute.v1.NetworkRoutingConfig
                         * @instance
                         */
                        Object.defineProperty(NetworkRoutingConfig.prototype, "_routingMode", {
                            get: $util.oneOfGetter($oneOfFields = ["routingMode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworkRoutingConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkRoutingConfig
                         * @static
                         * @param {google.cloud.compute.v1.INetworkRoutingConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworkRoutingConfig} NetworkRoutingConfig instance
                         */
                        NetworkRoutingConfig.create = function create(properties) {
                            return new NetworkRoutingConfig(properties);
                        };
    
                        /**
                         * Encodes the specified NetworkRoutingConfig message. Does not implicitly {@link google.cloud.compute.v1.NetworkRoutingConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworkRoutingConfig
                         * @static
                         * @param {google.cloud.compute.v1.INetworkRoutingConfig} message NetworkRoutingConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkRoutingConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.routingMode != null && Object.hasOwnProperty.call(message, "routingMode"))
                                writer.uint32(/* id 475143548, wireType 2 =*/3801148386).string(message.routingMode);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworkRoutingConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworkRoutingConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkRoutingConfig
                         * @static
                         * @param {google.cloud.compute.v1.INetworkRoutingConfig} message NetworkRoutingConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworkRoutingConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworkRoutingConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworkRoutingConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworkRoutingConfig} NetworkRoutingConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkRoutingConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworkRoutingConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 475143548: {
                                        message.routingMode = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworkRoutingConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworkRoutingConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworkRoutingConfig} NetworkRoutingConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworkRoutingConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworkRoutingConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworkRoutingConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworkRoutingConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.routingMode != null && message.hasOwnProperty("routingMode")) {
                                properties._routingMode = 1;
                                if (!$util.isString(message.routingMode))
                                    return "routingMode: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworkRoutingConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworkRoutingConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworkRoutingConfig} NetworkRoutingConfig
                         */
                        NetworkRoutingConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworkRoutingConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworkRoutingConfig();
                            if (object.routingMode != null)
                                message.routingMode = String(object.routingMode);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworkRoutingConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworkRoutingConfig
                         * @static
                         * @param {google.cloud.compute.v1.NetworkRoutingConfig} message NetworkRoutingConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworkRoutingConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.routingMode != null && message.hasOwnProperty("routingMode")) {
                                object.routingMode = message.routingMode;
                                if (options.oneofs)
                                    object._routingMode = "routingMode";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworkRoutingConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworkRoutingConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworkRoutingConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworkRoutingConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworkRoutingConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworkRoutingConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworkRoutingConfig";
                        };
    
                        /**
                         * RoutingMode enum.
                         * @name google.cloud.compute.v1.NetworkRoutingConfig.RoutingMode
                         * @enum {number}
                         * @property {number} UNDEFINED_ROUTING_MODE=0 UNDEFINED_ROUTING_MODE value
                         * @property {number} GLOBAL=494663587 GLOBAL value
                         * @property {number} REGIONAL=92288543 REGIONAL value
                         */
                        NetworkRoutingConfig.RoutingMode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ROUTING_MODE"] = 0;
                            values[valuesById[494663587] = "GLOBAL"] = 494663587;
                            values[valuesById[92288543] = "REGIONAL"] = 92288543;
                            return values;
                        })();
    
                        return NetworkRoutingConfig;
                    })();
    
                    v1.NetworksAddPeeringRequest = (function() {
    
                        /**
                         * Properties of a NetworksAddPeeringRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworksAddPeeringRequest
                         * @property {boolean|null} [autoCreateRoutes] NetworksAddPeeringRequest autoCreateRoutes
                         * @property {string|null} [name] NetworksAddPeeringRequest name
                         * @property {google.cloud.compute.v1.INetworkPeering|null} [networkPeering] NetworksAddPeeringRequest networkPeering
                         * @property {string|null} [peerNetwork] NetworksAddPeeringRequest peerNetwork
                         */
    
                        /**
                         * Constructs a new NetworksAddPeeringRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworksAddPeeringRequest.
                         * @implements INetworksAddPeeringRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworksAddPeeringRequest=} [properties] Properties to set
                         */
                        function NetworksAddPeeringRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworksAddPeeringRequest autoCreateRoutes.
                         * @member {boolean|null|undefined} autoCreateRoutes
                         * @memberof google.cloud.compute.v1.NetworksAddPeeringRequest
                         * @instance
                         */
                        NetworksAddPeeringRequest.prototype.autoCreateRoutes = null;
    
                        /**
                         * NetworksAddPeeringRequest name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.NetworksAddPeeringRequest
                         * @instance
                         */
                        NetworksAddPeeringRequest.prototype.name = null;
    
                        /**
                         * NetworksAddPeeringRequest networkPeering.
                         * @member {google.cloud.compute.v1.INetworkPeering|null|undefined} networkPeering
                         * @memberof google.cloud.compute.v1.NetworksAddPeeringRequest
                         * @instance
                         */
                        NetworksAddPeeringRequest.prototype.networkPeering = null;
    
                        /**
                         * NetworksAddPeeringRequest peerNetwork.
                         * @member {string|null|undefined} peerNetwork
                         * @memberof google.cloud.compute.v1.NetworksAddPeeringRequest
                         * @instance
                         */
                        NetworksAddPeeringRequest.prototype.peerNetwork = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworksAddPeeringRequest _autoCreateRoutes.
                         * @member {"autoCreateRoutes"|undefined} _autoCreateRoutes
                         * @memberof google.cloud.compute.v1.NetworksAddPeeringRequest
                         * @instance
                         */
                        Object.defineProperty(NetworksAddPeeringRequest.prototype, "_autoCreateRoutes", {
                            get: $util.oneOfGetter($oneOfFields = ["autoCreateRoutes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworksAddPeeringRequest _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.NetworksAddPeeringRequest
                         * @instance
                         */
                        Object.defineProperty(NetworksAddPeeringRequest.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworksAddPeeringRequest _networkPeering.
                         * @member {"networkPeering"|undefined} _networkPeering
                         * @memberof google.cloud.compute.v1.NetworksAddPeeringRequest
                         * @instance
                         */
                        Object.defineProperty(NetworksAddPeeringRequest.prototype, "_networkPeering", {
                            get: $util.oneOfGetter($oneOfFields = ["networkPeering"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworksAddPeeringRequest _peerNetwork.
                         * @member {"peerNetwork"|undefined} _peerNetwork
                         * @memberof google.cloud.compute.v1.NetworksAddPeeringRequest
                         * @instance
                         */
                        Object.defineProperty(NetworksAddPeeringRequest.prototype, "_peerNetwork", {
                            get: $util.oneOfGetter($oneOfFields = ["peerNetwork"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworksAddPeeringRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworksAddPeeringRequest
                         * @static
                         * @param {google.cloud.compute.v1.INetworksAddPeeringRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworksAddPeeringRequest} NetworksAddPeeringRequest instance
                         */
                        NetworksAddPeeringRequest.create = function create(properties) {
                            return new NetworksAddPeeringRequest(properties);
                        };
    
                        /**
                         * Encodes the specified NetworksAddPeeringRequest message. Does not implicitly {@link google.cloud.compute.v1.NetworksAddPeeringRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworksAddPeeringRequest
                         * @static
                         * @param {google.cloud.compute.v1.INetworksAddPeeringRequest} message NetworksAddPeeringRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworksAddPeeringRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.autoCreateRoutes != null && Object.hasOwnProperty.call(message, "autoCreateRoutes"))
                                writer.uint32(/* id 57454941, wireType 0 =*/459639528).bool(message.autoCreateRoutes);
                            if (message.networkPeering != null && Object.hasOwnProperty.call(message, "networkPeering"))
                                $root.google.cloud.compute.v1.NetworkPeering.encode(message.networkPeering, writer.uint32(/* id 328926767, wireType 2 =*/2631414138).fork()).ldelim();
                            if (message.peerNetwork != null && Object.hasOwnProperty.call(message, "peerNetwork"))
                                writer.uint32(/* id 500625489, wireType 2 =*/4005003914).string(message.peerNetwork);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworksAddPeeringRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworksAddPeeringRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworksAddPeeringRequest
                         * @static
                         * @param {google.cloud.compute.v1.INetworksAddPeeringRequest} message NetworksAddPeeringRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworksAddPeeringRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworksAddPeeringRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworksAddPeeringRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworksAddPeeringRequest} NetworksAddPeeringRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworksAddPeeringRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworksAddPeeringRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 57454941: {
                                        message.autoCreateRoutes = reader.bool();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 328926767: {
                                        message.networkPeering = $root.google.cloud.compute.v1.NetworkPeering.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 500625489: {
                                        message.peerNetwork = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworksAddPeeringRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworksAddPeeringRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworksAddPeeringRequest} NetworksAddPeeringRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworksAddPeeringRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworksAddPeeringRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworksAddPeeringRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworksAddPeeringRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoCreateRoutes != null && message.hasOwnProperty("autoCreateRoutes")) {
                                properties._autoCreateRoutes = 1;
                                if (typeof message.autoCreateRoutes !== "boolean")
                                    return "autoCreateRoutes: boolean expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.networkPeering != null && message.hasOwnProperty("networkPeering")) {
                                properties._networkPeering = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.NetworkPeering.verify(message.networkPeering);
                                    if (error)
                                        return "networkPeering." + error;
                                }
                            }
                            if (message.peerNetwork != null && message.hasOwnProperty("peerNetwork")) {
                                properties._peerNetwork = 1;
                                if (!$util.isString(message.peerNetwork))
                                    return "peerNetwork: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworksAddPeeringRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworksAddPeeringRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworksAddPeeringRequest} NetworksAddPeeringRequest
                         */
                        NetworksAddPeeringRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworksAddPeeringRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworksAddPeeringRequest();
                            if (object.autoCreateRoutes != null)
                                message.autoCreateRoutes = Boolean(object.autoCreateRoutes);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.networkPeering != null) {
                                if (typeof object.networkPeering !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NetworksAddPeeringRequest.networkPeering: object expected");
                                message.networkPeering = $root.google.cloud.compute.v1.NetworkPeering.fromObject(object.networkPeering);
                            }
                            if (object.peerNetwork != null)
                                message.peerNetwork = String(object.peerNetwork);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworksAddPeeringRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworksAddPeeringRequest
                         * @static
                         * @param {google.cloud.compute.v1.NetworksAddPeeringRequest} message NetworksAddPeeringRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworksAddPeeringRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.autoCreateRoutes != null && message.hasOwnProperty("autoCreateRoutes")) {
                                object.autoCreateRoutes = message.autoCreateRoutes;
                                if (options.oneofs)
                                    object._autoCreateRoutes = "autoCreateRoutes";
                            }
                            if (message.networkPeering != null && message.hasOwnProperty("networkPeering")) {
                                object.networkPeering = $root.google.cloud.compute.v1.NetworkPeering.toObject(message.networkPeering, options);
                                if (options.oneofs)
                                    object._networkPeering = "networkPeering";
                            }
                            if (message.peerNetwork != null && message.hasOwnProperty("peerNetwork")) {
                                object.peerNetwork = message.peerNetwork;
                                if (options.oneofs)
                                    object._peerNetwork = "peerNetwork";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworksAddPeeringRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworksAddPeeringRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworksAddPeeringRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworksAddPeeringRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworksAddPeeringRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworksAddPeeringRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworksAddPeeringRequest";
                        };
    
                        return NetworksAddPeeringRequest;
                    })();
    
                    v1.NetworksGetEffectiveFirewallsResponse = (function() {
    
                        /**
                         * Properties of a NetworksGetEffectiveFirewallsResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworksGetEffectiveFirewallsResponse
                         * @property {Array.<google.cloud.compute.v1.INetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy>|null} [firewallPolicys] NetworksGetEffectiveFirewallsResponse firewallPolicys
                         * @property {Array.<google.cloud.compute.v1.IFirewall>|null} [firewalls] NetworksGetEffectiveFirewallsResponse firewalls
                         */
    
                        /**
                         * Constructs a new NetworksGetEffectiveFirewallsResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworksGetEffectiveFirewallsResponse.
                         * @implements INetworksGetEffectiveFirewallsResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworksGetEffectiveFirewallsResponse=} [properties] Properties to set
                         */
                        function NetworksGetEffectiveFirewallsResponse(properties) {
                            this.firewallPolicys = [];
                            this.firewalls = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworksGetEffectiveFirewallsResponse firewallPolicys.
                         * @member {Array.<google.cloud.compute.v1.INetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy>} firewallPolicys
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse
                         * @instance
                         */
                        NetworksGetEffectiveFirewallsResponse.prototype.firewallPolicys = $util.emptyArray;
    
                        /**
                         * NetworksGetEffectiveFirewallsResponse firewalls.
                         * @member {Array.<google.cloud.compute.v1.IFirewall>} firewalls
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse
                         * @instance
                         */
                        NetworksGetEffectiveFirewallsResponse.prototype.firewalls = $util.emptyArray;
    
                        /**
                         * Creates a new NetworksGetEffectiveFirewallsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse
                         * @static
                         * @param {google.cloud.compute.v1.INetworksGetEffectiveFirewallsResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse} NetworksGetEffectiveFirewallsResponse instance
                         */
                        NetworksGetEffectiveFirewallsResponse.create = function create(properties) {
                            return new NetworksGetEffectiveFirewallsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified NetworksGetEffectiveFirewallsResponse message. Does not implicitly {@link google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse
                         * @static
                         * @param {google.cloud.compute.v1.INetworksGetEffectiveFirewallsResponse} message NetworksGetEffectiveFirewallsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworksGetEffectiveFirewallsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.firewalls != null && message.firewalls.length)
                                for (var i = 0; i < message.firewalls.length; ++i)
                                    $root.google.cloud.compute.v1.Firewall.encode(message.firewalls[i], writer.uint32(/* id 272245619, wireType 2 =*/2177964954).fork()).ldelim();
                            if (message.firewallPolicys != null && message.firewallPolicys.length)
                                for (var i = 0; i < message.firewallPolicys.length; ++i)
                                    $root.google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.encode(message.firewallPolicys[i], writer.uint32(/* id 410985794, wireType 2 =*/3287886354).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworksGetEffectiveFirewallsResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse
                         * @static
                         * @param {google.cloud.compute.v1.INetworksGetEffectiveFirewallsResponse} message NetworksGetEffectiveFirewallsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworksGetEffectiveFirewallsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworksGetEffectiveFirewallsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse} NetworksGetEffectiveFirewallsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworksGetEffectiveFirewallsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 410985794: {
                                        if (!(message.firewallPolicys && message.firewallPolicys.length))
                                            message.firewallPolicys = [];
                                        message.firewallPolicys.push($root.google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 272245619: {
                                        if (!(message.firewalls && message.firewalls.length))
                                            message.firewalls = [];
                                        message.firewalls.push($root.google.cloud.compute.v1.Firewall.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworksGetEffectiveFirewallsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse} NetworksGetEffectiveFirewallsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworksGetEffectiveFirewallsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworksGetEffectiveFirewallsResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworksGetEffectiveFirewallsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.firewallPolicys != null && message.hasOwnProperty("firewallPolicys")) {
                                if (!Array.isArray(message.firewallPolicys))
                                    return "firewallPolicys: array expected";
                                for (var i = 0; i < message.firewallPolicys.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.verify(message.firewallPolicys[i]);
                                    if (error)
                                        return "firewallPolicys." + error;
                                }
                            }
                            if (message.firewalls != null && message.hasOwnProperty("firewalls")) {
                                if (!Array.isArray(message.firewalls))
                                    return "firewalls: array expected";
                                for (var i = 0; i < message.firewalls.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Firewall.verify(message.firewalls[i]);
                                    if (error)
                                        return "firewalls." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworksGetEffectiveFirewallsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse} NetworksGetEffectiveFirewallsResponse
                         */
                        NetworksGetEffectiveFirewallsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse();
                            if (object.firewallPolicys) {
                                if (!Array.isArray(object.firewallPolicys))
                                    throw TypeError(".google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse.firewallPolicys: array expected");
                                message.firewallPolicys = [];
                                for (var i = 0; i < object.firewallPolicys.length; ++i) {
                                    if (typeof object.firewallPolicys[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse.firewallPolicys: object expected");
                                    message.firewallPolicys[i] = $root.google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.fromObject(object.firewallPolicys[i]);
                                }
                            }
                            if (object.firewalls) {
                                if (!Array.isArray(object.firewalls))
                                    throw TypeError(".google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse.firewalls: array expected");
                                message.firewalls = [];
                                for (var i = 0; i < object.firewalls.length; ++i) {
                                    if (typeof object.firewalls[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse.firewalls: object expected");
                                    message.firewalls[i] = $root.google.cloud.compute.v1.Firewall.fromObject(object.firewalls[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworksGetEffectiveFirewallsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse
                         * @static
                         * @param {google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse} message NetworksGetEffectiveFirewallsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworksGetEffectiveFirewallsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.firewalls = [];
                                object.firewallPolicys = [];
                            }
                            if (message.firewalls && message.firewalls.length) {
                                object.firewalls = [];
                                for (var j = 0; j < message.firewalls.length; ++j)
                                    object.firewalls[j] = $root.google.cloud.compute.v1.Firewall.toObject(message.firewalls[j], options);
                            }
                            if (message.firewallPolicys && message.firewallPolicys.length) {
                                object.firewallPolicys = [];
                                for (var j = 0; j < message.firewallPolicys.length; ++j)
                                    object.firewallPolicys[j] = $root.google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.toObject(message.firewallPolicys[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworksGetEffectiveFirewallsResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworksGetEffectiveFirewallsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworksGetEffectiveFirewallsResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworksGetEffectiveFirewallsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse";
                        };
    
                        return NetworksGetEffectiveFirewallsResponse;
                    })();
    
                    v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy = (function() {
    
                        /**
                         * Properties of a NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @property {string|null} [displayName] NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy displayName
                         * @property {string|null} [name] NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy name
                         * @property {Array.<google.cloud.compute.v1.IFirewallPolicyRule>|null} [rules] NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy rules
                         * @property {string|null} [shortName] NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy shortName
                         * @property {string|null} [type] NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy type
                         */
    
                        /**
                         * Constructs a new NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.
                         * @implements INetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy=} [properties] Properties to set
                         */
                        function NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy(properties) {
                            this.rules = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy displayName.
                         * @member {string|null|undefined} displayName
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype.displayName = null;
    
                        /**
                         * NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype.name = null;
    
                        /**
                         * NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy rules.
                         * @member {Array.<google.cloud.compute.v1.IFirewallPolicyRule>} rules
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype.rules = $util.emptyArray;
    
                        /**
                         * NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy shortName.
                         * @member {string|null|undefined} shortName
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype.shortName = null;
    
                        /**
                         * NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype.type = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy _displayName.
                         * @member {"displayName"|undefined} _displayName
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype, "_displayName", {
                            get: $util.oneOfGetter($oneOfFields = ["displayName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy _shortName.
                         * @member {"shortName"|undefined} _shortName
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype, "_shortName", {
                            get: $util.oneOfGetter($oneOfFields = ["shortName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {google.cloud.compute.v1.INetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy} NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy instance
                         */
                        NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.create = function create(properties) {
                            return new NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy message. Does not implicitly {@link google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {google.cloud.compute.v1.INetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy} message NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 4473832, wireType 2 =*/35790658).string(message.displayName);
                            if (message.rules != null && message.rules.length)
                                for (var i = 0; i < message.rules.length; ++i)
                                    $root.google.cloud.compute.v1.FirewallPolicyRule.encode(message.rules[i], writer.uint32(/* id 108873975, wireType 2 =*/870991802).fork()).ldelim();
                            if (message.shortName != null && Object.hasOwnProperty.call(message, "shortName"))
                                writer.uint32(/* id 492051566, wireType 2 =*/3936412530).string(message.shortName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {google.cloud.compute.v1.INetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy} message NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy} NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4473832: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 108873975: {
                                        if (!(message.rules && message.rules.length))
                                            message.rules = [];
                                        message.rules.push($root.google.cloud.compute.v1.FirewallPolicyRule.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 492051566: {
                                        message.shortName = reader.string();
                                        break;
                                    }
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy} NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.displayName != null && message.hasOwnProperty("displayName")) {
                                properties._displayName = 1;
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.rules != null && message.hasOwnProperty("rules")) {
                                if (!Array.isArray(message.rules))
                                    return "rules: array expected";
                                for (var i = 0; i < message.rules.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.FirewallPolicyRule.verify(message.rules[i]);
                                    if (error)
                                        return "rules." + error;
                                }
                            }
                            if (message.shortName != null && message.hasOwnProperty("shortName")) {
                                properties._shortName = 1;
                                if (!$util.isString(message.shortName))
                                    return "shortName: string expected";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy} NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         */
                        NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy();
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.rules) {
                                if (!Array.isArray(object.rules))
                                    throw TypeError(".google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.rules: array expected");
                                message.rules = [];
                                for (var i = 0; i < object.rules.length; ++i) {
                                    if (typeof object.rules[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.rules: object expected");
                                    message.rules[i] = $root.google.cloud.compute.v1.FirewallPolicyRule.fromObject(object.rules[i]);
                                }
                            }
                            if (object.shortName != null)
                                message.shortName = String(object.shortName);
                            if (object.type != null)
                                message.type = String(object.type);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy} message NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.rules = [];
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            if (message.displayName != null && message.hasOwnProperty("displayName")) {
                                object.displayName = message.displayName;
                                if (options.oneofs)
                                    object._displayName = "displayName";
                            }
                            if (message.rules && message.rules.length) {
                                object.rules = [];
                                for (var j = 0; j < message.rules.length; ++j)
                                    object.rules[j] = $root.google.cloud.compute.v1.FirewallPolicyRule.toObject(message.rules[j], options);
                            }
                            if (message.shortName != null && message.hasOwnProperty("shortName")) {
                                object.shortName = message.shortName;
                                if (options.oneofs)
                                    object._shortName = "shortName";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy";
                        };
    
                        /**
                         * Type enum.
                         * @name google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type
                         * @enum {number}
                         * @property {number} UNDEFINED_TYPE=0 UNDEFINED_TYPE value
                         * @property {number} HIERARCHY=69902869 HIERARCHY value
                         * @property {number} NETWORK=413984270 NETWORK value
                         * @property {number} UNSPECIFIED=526786327 UNSPECIFIED value
                         */
                        NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TYPE"] = 0;
                            values[valuesById[69902869] = "HIERARCHY"] = 69902869;
                            values[valuesById[413984270] = "NETWORK"] = 413984270;
                            values[valuesById[526786327] = "UNSPECIFIED"] = 526786327;
                            return values;
                        })();
    
                        return NetworksGetEffectiveFirewallsResponseEffectiveFirewallPolicy;
                    })();
    
                    v1.NetworksRemovePeeringRequest = (function() {
    
                        /**
                         * Properties of a NetworksRemovePeeringRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworksRemovePeeringRequest
                         * @property {string|null} [name] NetworksRemovePeeringRequest name
                         */
    
                        /**
                         * Constructs a new NetworksRemovePeeringRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworksRemovePeeringRequest.
                         * @implements INetworksRemovePeeringRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworksRemovePeeringRequest=} [properties] Properties to set
                         */
                        function NetworksRemovePeeringRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworksRemovePeeringRequest name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.NetworksRemovePeeringRequest
                         * @instance
                         */
                        NetworksRemovePeeringRequest.prototype.name = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworksRemovePeeringRequest _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.NetworksRemovePeeringRequest
                         * @instance
                         */
                        Object.defineProperty(NetworksRemovePeeringRequest.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworksRemovePeeringRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworksRemovePeeringRequest
                         * @static
                         * @param {google.cloud.compute.v1.INetworksRemovePeeringRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworksRemovePeeringRequest} NetworksRemovePeeringRequest instance
                         */
                        NetworksRemovePeeringRequest.create = function create(properties) {
                            return new NetworksRemovePeeringRequest(properties);
                        };
    
                        /**
                         * Encodes the specified NetworksRemovePeeringRequest message. Does not implicitly {@link google.cloud.compute.v1.NetworksRemovePeeringRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworksRemovePeeringRequest
                         * @static
                         * @param {google.cloud.compute.v1.INetworksRemovePeeringRequest} message NetworksRemovePeeringRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworksRemovePeeringRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworksRemovePeeringRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworksRemovePeeringRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworksRemovePeeringRequest
                         * @static
                         * @param {google.cloud.compute.v1.INetworksRemovePeeringRequest} message NetworksRemovePeeringRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworksRemovePeeringRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworksRemovePeeringRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworksRemovePeeringRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworksRemovePeeringRequest} NetworksRemovePeeringRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworksRemovePeeringRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworksRemovePeeringRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworksRemovePeeringRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworksRemovePeeringRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworksRemovePeeringRequest} NetworksRemovePeeringRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworksRemovePeeringRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworksRemovePeeringRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworksRemovePeeringRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworksRemovePeeringRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworksRemovePeeringRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworksRemovePeeringRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworksRemovePeeringRequest} NetworksRemovePeeringRequest
                         */
                        NetworksRemovePeeringRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworksRemovePeeringRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworksRemovePeeringRequest();
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworksRemovePeeringRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworksRemovePeeringRequest
                         * @static
                         * @param {google.cloud.compute.v1.NetworksRemovePeeringRequest} message NetworksRemovePeeringRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworksRemovePeeringRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworksRemovePeeringRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworksRemovePeeringRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworksRemovePeeringRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworksRemovePeeringRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworksRemovePeeringRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworksRemovePeeringRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworksRemovePeeringRequest";
                        };
    
                        return NetworksRemovePeeringRequest;
                    })();
    
                    v1.NetworksUpdatePeeringRequest = (function() {
    
                        /**
                         * Properties of a NetworksUpdatePeeringRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface INetworksUpdatePeeringRequest
                         * @property {google.cloud.compute.v1.INetworkPeering|null} [networkPeering] NetworksUpdatePeeringRequest networkPeering
                         */
    
                        /**
                         * Constructs a new NetworksUpdatePeeringRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworksUpdatePeeringRequest.
                         * @implements INetworksUpdatePeeringRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.INetworksUpdatePeeringRequest=} [properties] Properties to set
                         */
                        function NetworksUpdatePeeringRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NetworksUpdatePeeringRequest networkPeering.
                         * @member {google.cloud.compute.v1.INetworkPeering|null|undefined} networkPeering
                         * @memberof google.cloud.compute.v1.NetworksUpdatePeeringRequest
                         * @instance
                         */
                        NetworksUpdatePeeringRequest.prototype.networkPeering = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NetworksUpdatePeeringRequest _networkPeering.
                         * @member {"networkPeering"|undefined} _networkPeering
                         * @memberof google.cloud.compute.v1.NetworksUpdatePeeringRequest
                         * @instance
                         */
                        Object.defineProperty(NetworksUpdatePeeringRequest.prototype, "_networkPeering", {
                            get: $util.oneOfGetter($oneOfFields = ["networkPeering"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NetworksUpdatePeeringRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworksUpdatePeeringRequest
                         * @static
                         * @param {google.cloud.compute.v1.INetworksUpdatePeeringRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NetworksUpdatePeeringRequest} NetworksUpdatePeeringRequest instance
                         */
                        NetworksUpdatePeeringRequest.create = function create(properties) {
                            return new NetworksUpdatePeeringRequest(properties);
                        };
    
                        /**
                         * Encodes the specified NetworksUpdatePeeringRequest message. Does not implicitly {@link google.cloud.compute.v1.NetworksUpdatePeeringRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NetworksUpdatePeeringRequest
                         * @static
                         * @param {google.cloud.compute.v1.INetworksUpdatePeeringRequest} message NetworksUpdatePeeringRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworksUpdatePeeringRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.networkPeering != null && Object.hasOwnProperty.call(message, "networkPeering"))
                                $root.google.cloud.compute.v1.NetworkPeering.encode(message.networkPeering, writer.uint32(/* id 328926767, wireType 2 =*/2631414138).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NetworksUpdatePeeringRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NetworksUpdatePeeringRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NetworksUpdatePeeringRequest
                         * @static
                         * @param {google.cloud.compute.v1.INetworksUpdatePeeringRequest} message NetworksUpdatePeeringRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NetworksUpdatePeeringRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NetworksUpdatePeeringRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NetworksUpdatePeeringRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NetworksUpdatePeeringRequest} NetworksUpdatePeeringRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworksUpdatePeeringRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NetworksUpdatePeeringRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 328926767: {
                                        message.networkPeering = $root.google.cloud.compute.v1.NetworkPeering.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NetworksUpdatePeeringRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NetworksUpdatePeeringRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NetworksUpdatePeeringRequest} NetworksUpdatePeeringRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NetworksUpdatePeeringRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NetworksUpdatePeeringRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NetworksUpdatePeeringRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NetworksUpdatePeeringRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.networkPeering != null && message.hasOwnProperty("networkPeering")) {
                                properties._networkPeering = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.NetworkPeering.verify(message.networkPeering);
                                    if (error)
                                        return "networkPeering." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NetworksUpdatePeeringRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NetworksUpdatePeeringRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NetworksUpdatePeeringRequest} NetworksUpdatePeeringRequest
                         */
                        NetworksUpdatePeeringRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NetworksUpdatePeeringRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NetworksUpdatePeeringRequest();
                            if (object.networkPeering != null) {
                                if (typeof object.networkPeering !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NetworksUpdatePeeringRequest.networkPeering: object expected");
                                message.networkPeering = $root.google.cloud.compute.v1.NetworkPeering.fromObject(object.networkPeering);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NetworksUpdatePeeringRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NetworksUpdatePeeringRequest
                         * @static
                         * @param {google.cloud.compute.v1.NetworksUpdatePeeringRequest} message NetworksUpdatePeeringRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NetworksUpdatePeeringRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.networkPeering != null && message.hasOwnProperty("networkPeering")) {
                                object.networkPeering = $root.google.cloud.compute.v1.NetworkPeering.toObject(message.networkPeering, options);
                                if (options.oneofs)
                                    object._networkPeering = "networkPeering";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NetworksUpdatePeeringRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NetworksUpdatePeeringRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NetworksUpdatePeeringRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NetworksUpdatePeeringRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NetworksUpdatePeeringRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NetworksUpdatePeeringRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NetworksUpdatePeeringRequest";
                        };
    
                        return NetworksUpdatePeeringRequest;
                    })();
    
                    v1.NodeGroup = (function() {
    
                        /**
                         * Properties of a NodeGroup.
                         * @memberof google.cloud.compute.v1
                         * @interface INodeGroup
                         * @property {google.cloud.compute.v1.INodeGroupAutoscalingPolicy|null} [autoscalingPolicy] NodeGroup autoscalingPolicy
                         * @property {string|null} [creationTimestamp] NodeGroup creationTimestamp
                         * @property {string|null} [description] NodeGroup description
                         * @property {string|null} [fingerprint] NodeGroup fingerprint
                         * @property {number|Long|null} [id] NodeGroup id
                         * @property {string|null} [kind] NodeGroup kind
                         * @property {string|null} [locationHint] NodeGroup locationHint
                         * @property {string|null} [maintenancePolicy] NodeGroup maintenancePolicy
                         * @property {google.cloud.compute.v1.INodeGroupMaintenanceWindow|null} [maintenanceWindow] NodeGroup maintenanceWindow
                         * @property {string|null} [name] NodeGroup name
                         * @property {string|null} [nodeTemplate] NodeGroup nodeTemplate
                         * @property {string|null} [selfLink] NodeGroup selfLink
                         * @property {google.cloud.compute.v1.IShareSettings|null} [shareSettings] NodeGroup shareSettings
                         * @property {number|null} [size] NodeGroup size
                         * @property {string|null} [status] NodeGroup status
                         * @property {string|null} [zone] NodeGroup zone
                         */
    
                        /**
                         * Constructs a new NodeGroup.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeGroup.
                         * @implements INodeGroup
                         * @constructor
                         * @param {google.cloud.compute.v1.INodeGroup=} [properties] Properties to set
                         */
                        function NodeGroup(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NodeGroup autoscalingPolicy.
                         * @member {google.cloud.compute.v1.INodeGroupAutoscalingPolicy|null|undefined} autoscalingPolicy
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        NodeGroup.prototype.autoscalingPolicy = null;
    
                        /**
                         * NodeGroup creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        NodeGroup.prototype.creationTimestamp = null;
    
                        /**
                         * NodeGroup description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        NodeGroup.prototype.description = null;
    
                        /**
                         * NodeGroup fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        NodeGroup.prototype.fingerprint = null;
    
                        /**
                         * NodeGroup id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        NodeGroup.prototype.id = null;
    
                        /**
                         * NodeGroup kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        NodeGroup.prototype.kind = null;
    
                        /**
                         * NodeGroup locationHint.
                         * @member {string|null|undefined} locationHint
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        NodeGroup.prototype.locationHint = null;
    
                        /**
                         * NodeGroup maintenancePolicy.
                         * @member {string|null|undefined} maintenancePolicy
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        NodeGroup.prototype.maintenancePolicy = null;
    
                        /**
                         * NodeGroup maintenanceWindow.
                         * @member {google.cloud.compute.v1.INodeGroupMaintenanceWindow|null|undefined} maintenanceWindow
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        NodeGroup.prototype.maintenanceWindow = null;
    
                        /**
                         * NodeGroup name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        NodeGroup.prototype.name = null;
    
                        /**
                         * NodeGroup nodeTemplate.
                         * @member {string|null|undefined} nodeTemplate
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        NodeGroup.prototype.nodeTemplate = null;
    
                        /**
                         * NodeGroup selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        NodeGroup.prototype.selfLink = null;
    
                        /**
                         * NodeGroup shareSettings.
                         * @member {google.cloud.compute.v1.IShareSettings|null|undefined} shareSettings
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        NodeGroup.prototype.shareSettings = null;
    
                        /**
                         * NodeGroup size.
                         * @member {number|null|undefined} size
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        NodeGroup.prototype.size = null;
    
                        /**
                         * NodeGroup status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        NodeGroup.prototype.status = null;
    
                        /**
                         * NodeGroup zone.
                         * @member {string|null|undefined} zone
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        NodeGroup.prototype.zone = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NodeGroup _autoscalingPolicy.
                         * @member {"autoscalingPolicy"|undefined} _autoscalingPolicy
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        Object.defineProperty(NodeGroup.prototype, "_autoscalingPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["autoscalingPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroup _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        Object.defineProperty(NodeGroup.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroup _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        Object.defineProperty(NodeGroup.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroup _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        Object.defineProperty(NodeGroup.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroup _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        Object.defineProperty(NodeGroup.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroup _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        Object.defineProperty(NodeGroup.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroup _locationHint.
                         * @member {"locationHint"|undefined} _locationHint
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        Object.defineProperty(NodeGroup.prototype, "_locationHint", {
                            get: $util.oneOfGetter($oneOfFields = ["locationHint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroup _maintenancePolicy.
                         * @member {"maintenancePolicy"|undefined} _maintenancePolicy
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        Object.defineProperty(NodeGroup.prototype, "_maintenancePolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["maintenancePolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroup _maintenanceWindow.
                         * @member {"maintenanceWindow"|undefined} _maintenanceWindow
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        Object.defineProperty(NodeGroup.prototype, "_maintenanceWindow", {
                            get: $util.oneOfGetter($oneOfFields = ["maintenanceWindow"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroup _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        Object.defineProperty(NodeGroup.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroup _nodeTemplate.
                         * @member {"nodeTemplate"|undefined} _nodeTemplate
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        Object.defineProperty(NodeGroup.prototype, "_nodeTemplate", {
                            get: $util.oneOfGetter($oneOfFields = ["nodeTemplate"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroup _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        Object.defineProperty(NodeGroup.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroup _shareSettings.
                         * @member {"shareSettings"|undefined} _shareSettings
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        Object.defineProperty(NodeGroup.prototype, "_shareSettings", {
                            get: $util.oneOfGetter($oneOfFields = ["shareSettings"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroup _size.
                         * @member {"size"|undefined} _size
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        Object.defineProperty(NodeGroup.prototype, "_size", {
                            get: $util.oneOfGetter($oneOfFields = ["size"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroup _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        Object.defineProperty(NodeGroup.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroup _zone.
                         * @member {"zone"|undefined} _zone
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         */
                        Object.defineProperty(NodeGroup.prototype, "_zone", {
                            get: $util.oneOfGetter($oneOfFields = ["zone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NodeGroup instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroup=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NodeGroup} NodeGroup instance
                         */
                        NodeGroup.create = function create(properties) {
                            return new NodeGroup(properties);
                        };
    
                        /**
                         * Encodes the specified NodeGroup message. Does not implicitly {@link google.cloud.compute.v1.NodeGroup.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroup} message NodeGroup message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroup.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.size != null && Object.hasOwnProperty.call(message, "size"))
                                writer.uint32(/* id 3530753, wireType 0 =*/28246024).int32(message.size);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.maintenanceWindow != null && Object.hasOwnProperty.call(message, "maintenanceWindow"))
                                $root.google.cloud.compute.v1.NodeGroupMaintenanceWindow.encode(message.maintenanceWindow, writer.uint32(/* id 186374812, wireType 2 =*/1490998498).fork()).ldelim();
                            if (message.autoscalingPolicy != null && Object.hasOwnProperty.call(message, "autoscalingPolicy"))
                                $root.google.cloud.compute.v1.NodeGroupAutoscalingPolicy.encode(message.autoscalingPolicy, writer.uint32(/* id 221950041, wireType 2 =*/1775600330).fork()).ldelim();
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.shareSettings != null && Object.hasOwnProperty.call(message, "shareSettings"))
                                $root.google.cloud.compute.v1.ShareSettings.encode(message.shareSettings, writer.uint32(/* id 266668163, wireType 2 =*/2133345306).fork()).ldelim();
                            if (message.nodeTemplate != null && Object.hasOwnProperty.call(message, "nodeTemplate"))
                                writer.uint32(/* id 323154455, wireType 2 =*/2585235642).string(message.nodeTemplate);
                            if (message.locationHint != null && Object.hasOwnProperty.call(message, "locationHint"))
                                writer.uint32(/* id 350519505, wireType 2 =*/2804156042).string(message.locationHint);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.maintenancePolicy != null && Object.hasOwnProperty.call(message, "maintenancePolicy"))
                                writer.uint32(/* id 528327646, wireType 2 =*/4226621170).string(message.maintenancePolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NodeGroup message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NodeGroup.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroup} message NodeGroup message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroup.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NodeGroup message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NodeGroup} NodeGroup
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroup.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NodeGroup();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 221950041: {
                                        message.autoscalingPolicy = $root.google.cloud.compute.v1.NodeGroupAutoscalingPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 350519505: {
                                        message.locationHint = reader.string();
                                        break;
                                    }
                                case 528327646: {
                                        message.maintenancePolicy = reader.string();
                                        break;
                                    }
                                case 186374812: {
                                        message.maintenanceWindow = $root.google.cloud.compute.v1.NodeGroupMaintenanceWindow.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 323154455: {
                                        message.nodeTemplate = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 266668163: {
                                        message.shareSettings = $root.google.cloud.compute.v1.ShareSettings.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3530753: {
                                        message.size = reader.int32();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NodeGroup message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NodeGroup} NodeGroup
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroup.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NodeGroup message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NodeGroup.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoscalingPolicy != null && message.hasOwnProperty("autoscalingPolicy")) {
                                properties._autoscalingPolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.NodeGroupAutoscalingPolicy.verify(message.autoscalingPolicy);
                                    if (error)
                                        return "autoscalingPolicy." + error;
                                }
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.locationHint != null && message.hasOwnProperty("locationHint")) {
                                properties._locationHint = 1;
                                if (!$util.isString(message.locationHint))
                                    return "locationHint: string expected";
                            }
                            if (message.maintenancePolicy != null && message.hasOwnProperty("maintenancePolicy")) {
                                properties._maintenancePolicy = 1;
                                if (!$util.isString(message.maintenancePolicy))
                                    return "maintenancePolicy: string expected";
                            }
                            if (message.maintenanceWindow != null && message.hasOwnProperty("maintenanceWindow")) {
                                properties._maintenanceWindow = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.NodeGroupMaintenanceWindow.verify(message.maintenanceWindow);
                                    if (error)
                                        return "maintenanceWindow." + error;
                                }
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.nodeTemplate != null && message.hasOwnProperty("nodeTemplate")) {
                                properties._nodeTemplate = 1;
                                if (!$util.isString(message.nodeTemplate))
                                    return "nodeTemplate: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.shareSettings != null && message.hasOwnProperty("shareSettings")) {
                                properties._shareSettings = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ShareSettings.verify(message.shareSettings);
                                    if (error)
                                        return "shareSettings." + error;
                                }
                            }
                            if (message.size != null && message.hasOwnProperty("size")) {
                                properties._size = 1;
                                if (!$util.isInteger(message.size))
                                    return "size: integer expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                properties._zone = 1;
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NodeGroup message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NodeGroup} NodeGroup
                         */
                        NodeGroup.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NodeGroup)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NodeGroup();
                            if (object.autoscalingPolicy != null) {
                                if (typeof object.autoscalingPolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeGroup.autoscalingPolicy: object expected");
                                message.autoscalingPolicy = $root.google.cloud.compute.v1.NodeGroupAutoscalingPolicy.fromObject(object.autoscalingPolicy);
                            }
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.locationHint != null)
                                message.locationHint = String(object.locationHint);
                            if (object.maintenancePolicy != null)
                                message.maintenancePolicy = String(object.maintenancePolicy);
                            if (object.maintenanceWindow != null) {
                                if (typeof object.maintenanceWindow !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeGroup.maintenanceWindow: object expected");
                                message.maintenanceWindow = $root.google.cloud.compute.v1.NodeGroupMaintenanceWindow.fromObject(object.maintenanceWindow);
                            }
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.nodeTemplate != null)
                                message.nodeTemplate = String(object.nodeTemplate);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.shareSettings != null) {
                                if (typeof object.shareSettings !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeGroup.shareSettings: object expected");
                                message.shareSettings = $root.google.cloud.compute.v1.ShareSettings.fromObject(object.shareSettings);
                            }
                            if (object.size != null)
                                message.size = object.size | 0;
                            if (object.status != null)
                                message.status = String(object.status);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NodeGroup message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @static
                         * @param {google.cloud.compute.v1.NodeGroup} message NodeGroup
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NodeGroup.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.size != null && message.hasOwnProperty("size")) {
                                object.size = message.size;
                                if (options.oneofs)
                                    object._size = "size";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                object.zone = message.zone;
                                if (options.oneofs)
                                    object._zone = "zone";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.maintenanceWindow != null && message.hasOwnProperty("maintenanceWindow")) {
                                object.maintenanceWindow = $root.google.cloud.compute.v1.NodeGroupMaintenanceWindow.toObject(message.maintenanceWindow, options);
                                if (options.oneofs)
                                    object._maintenanceWindow = "maintenanceWindow";
                            }
                            if (message.autoscalingPolicy != null && message.hasOwnProperty("autoscalingPolicy")) {
                                object.autoscalingPolicy = $root.google.cloud.compute.v1.NodeGroupAutoscalingPolicy.toObject(message.autoscalingPolicy, options);
                                if (options.oneofs)
                                    object._autoscalingPolicy = "autoscalingPolicy";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.shareSettings != null && message.hasOwnProperty("shareSettings")) {
                                object.shareSettings = $root.google.cloud.compute.v1.ShareSettings.toObject(message.shareSettings, options);
                                if (options.oneofs)
                                    object._shareSettings = "shareSettings";
                            }
                            if (message.nodeTemplate != null && message.hasOwnProperty("nodeTemplate")) {
                                object.nodeTemplate = message.nodeTemplate;
                                if (options.oneofs)
                                    object._nodeTemplate = "nodeTemplate";
                            }
                            if (message.locationHint != null && message.hasOwnProperty("locationHint")) {
                                object.locationHint = message.locationHint;
                                if (options.oneofs)
                                    object._locationHint = "locationHint";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.maintenancePolicy != null && message.hasOwnProperty("maintenancePolicy")) {
                                object.maintenancePolicy = message.maintenancePolicy;
                                if (options.oneofs)
                                    object._maintenancePolicy = "maintenancePolicy";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NodeGroup to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NodeGroup.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NodeGroup
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NodeGroup
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NodeGroup.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NodeGroup";
                        };
    
                        /**
                         * MaintenancePolicy enum.
                         * @name google.cloud.compute.v1.NodeGroup.MaintenancePolicy
                         * @enum {number}
                         * @property {number} UNDEFINED_MAINTENANCE_POLICY=0 UNDEFINED_MAINTENANCE_POLICY value
                         * @property {number} DEFAULT=115302945 DEFAULT value
                         * @property {number} MAINTENANCE_POLICY_UNSPECIFIED=72964182 MAINTENANCE_POLICY_UNSPECIFIED value
                         * @property {number} MIGRATE_WITHIN_NODE_GROUP=153483394 MIGRATE_WITHIN_NODE_GROUP value
                         * @property {number} RESTART_IN_PLACE=228647325 RESTART_IN_PLACE value
                         */
                        NodeGroup.MaintenancePolicy = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_MAINTENANCE_POLICY"] = 0;
                            values[valuesById[115302945] = "DEFAULT"] = 115302945;
                            values[valuesById[72964182] = "MAINTENANCE_POLICY_UNSPECIFIED"] = 72964182;
                            values[valuesById[153483394] = "MIGRATE_WITHIN_NODE_GROUP"] = 153483394;
                            values[valuesById[228647325] = "RESTART_IN_PLACE"] = 228647325;
                            return values;
                        })();
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.NodeGroup.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} CREATING=455564985 CREATING value
                         * @property {number} DELETING=528602024 DELETING value
                         * @property {number} INVALID=530283991 INVALID value
                         * @property {number} READY=77848963 READY value
                         */
                        NodeGroup.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[455564985] = "CREATING"] = 455564985;
                            values[valuesById[528602024] = "DELETING"] = 528602024;
                            values[valuesById[530283991] = "INVALID"] = 530283991;
                            values[valuesById[77848963] = "READY"] = 77848963;
                            return values;
                        })();
    
                        return NodeGroup;
                    })();
    
                    v1.NodeGroupAggregatedList = (function() {
    
                        /**
                         * Properties of a NodeGroupAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface INodeGroupAggregatedList
                         * @property {string|null} [id] NodeGroupAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.INodeGroupsScopedList>|null} [items] NodeGroupAggregatedList items
                         * @property {string|null} [kind] NodeGroupAggregatedList kind
                         * @property {string|null} [nextPageToken] NodeGroupAggregatedList nextPageToken
                         * @property {string|null} [selfLink] NodeGroupAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] NodeGroupAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] NodeGroupAggregatedList warning
                         */
    
                        /**
                         * Constructs a new NodeGroupAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeGroupAggregatedList.
                         * @implements INodeGroupAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.INodeGroupAggregatedList=} [properties] Properties to set
                         */
                        function NodeGroupAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NodeGroupAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @instance
                         */
                        NodeGroupAggregatedList.prototype.id = null;
    
                        /**
                         * NodeGroupAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.INodeGroupsScopedList>} items
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @instance
                         */
                        NodeGroupAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * NodeGroupAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @instance
                         */
                        NodeGroupAggregatedList.prototype.kind = null;
    
                        /**
                         * NodeGroupAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @instance
                         */
                        NodeGroupAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * NodeGroupAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @instance
                         */
                        NodeGroupAggregatedList.prototype.selfLink = null;
    
                        /**
                         * NodeGroupAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @instance
                         */
                        NodeGroupAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * NodeGroupAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @instance
                         */
                        NodeGroupAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NodeGroupAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NodeGroupAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NodeGroupAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NodeGroupAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NodeGroupAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NodeGroupAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NodeGroupAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NodeGroupAggregatedList} NodeGroupAggregatedList instance
                         */
                        NodeGroupAggregatedList.create = function create(properties) {
                            return new NodeGroupAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified NodeGroupAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.NodeGroupAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupAggregatedList} message NodeGroupAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroupAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.NodeGroupsScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NodeGroupAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NodeGroupAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupAggregatedList} message NodeGroupAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroupAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NodeGroupAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NodeGroupAggregatedList} NodeGroupAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroupAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NodeGroupAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.NodeGroupsScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NodeGroupAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NodeGroupAggregatedList} NodeGroupAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroupAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NodeGroupAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NodeGroupAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NodeGroupsScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NodeGroupAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NodeGroupAggregatedList} NodeGroupAggregatedList
                         */
                        NodeGroupAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NodeGroupAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NodeGroupAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeGroupAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NodeGroupAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.NodeGroupsScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.NodeGroupAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeGroupAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NodeGroupAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.NodeGroupAggregatedList} message NodeGroupAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NodeGroupAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.NodeGroupsScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NodeGroupAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NodeGroupAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NodeGroupAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NodeGroupAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NodeGroupAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NodeGroupAggregatedList";
                        };
    
                        return NodeGroupAggregatedList;
                    })();
    
                    v1.NodeGroupAutoscalingPolicy = (function() {
    
                        /**
                         * Properties of a NodeGroupAutoscalingPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface INodeGroupAutoscalingPolicy
                         * @property {number|null} [maxNodes] NodeGroupAutoscalingPolicy maxNodes
                         * @property {number|null} [minNodes] NodeGroupAutoscalingPolicy minNodes
                         * @property {string|null} [mode] NodeGroupAutoscalingPolicy mode
                         */
    
                        /**
                         * Constructs a new NodeGroupAutoscalingPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeGroupAutoscalingPolicy.
                         * @implements INodeGroupAutoscalingPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.INodeGroupAutoscalingPolicy=} [properties] Properties to set
                         */
                        function NodeGroupAutoscalingPolicy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NodeGroupAutoscalingPolicy maxNodes.
                         * @member {number|null|undefined} maxNodes
                         * @memberof google.cloud.compute.v1.NodeGroupAutoscalingPolicy
                         * @instance
                         */
                        NodeGroupAutoscalingPolicy.prototype.maxNodes = null;
    
                        /**
                         * NodeGroupAutoscalingPolicy minNodes.
                         * @member {number|null|undefined} minNodes
                         * @memberof google.cloud.compute.v1.NodeGroupAutoscalingPolicy
                         * @instance
                         */
                        NodeGroupAutoscalingPolicy.prototype.minNodes = null;
    
                        /**
                         * NodeGroupAutoscalingPolicy mode.
                         * @member {string|null|undefined} mode
                         * @memberof google.cloud.compute.v1.NodeGroupAutoscalingPolicy
                         * @instance
                         */
                        NodeGroupAutoscalingPolicy.prototype.mode = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NodeGroupAutoscalingPolicy _maxNodes.
                         * @member {"maxNodes"|undefined} _maxNodes
                         * @memberof google.cloud.compute.v1.NodeGroupAutoscalingPolicy
                         * @instance
                         */
                        Object.defineProperty(NodeGroupAutoscalingPolicy.prototype, "_maxNodes", {
                            get: $util.oneOfGetter($oneOfFields = ["maxNodes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupAutoscalingPolicy _minNodes.
                         * @member {"minNodes"|undefined} _minNodes
                         * @memberof google.cloud.compute.v1.NodeGroupAutoscalingPolicy
                         * @instance
                         */
                        Object.defineProperty(NodeGroupAutoscalingPolicy.prototype, "_minNodes", {
                            get: $util.oneOfGetter($oneOfFields = ["minNodes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupAutoscalingPolicy _mode.
                         * @member {"mode"|undefined} _mode
                         * @memberof google.cloud.compute.v1.NodeGroupAutoscalingPolicy
                         * @instance
                         */
                        Object.defineProperty(NodeGroupAutoscalingPolicy.prototype, "_mode", {
                            get: $util.oneOfGetter($oneOfFields = ["mode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NodeGroupAutoscalingPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeGroupAutoscalingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupAutoscalingPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NodeGroupAutoscalingPolicy} NodeGroupAutoscalingPolicy instance
                         */
                        NodeGroupAutoscalingPolicy.create = function create(properties) {
                            return new NodeGroupAutoscalingPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified NodeGroupAutoscalingPolicy message. Does not implicitly {@link google.cloud.compute.v1.NodeGroupAutoscalingPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NodeGroupAutoscalingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupAutoscalingPolicy} message NodeGroupAutoscalingPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroupAutoscalingPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.mode != null && Object.hasOwnProperty.call(message, "mode"))
                                writer.uint32(/* id 3357091, wireType 2 =*/26856730).string(message.mode);
                            if (message.maxNodes != null && Object.hasOwnProperty.call(message, "maxNodes"))
                                writer.uint32(/* id 297762838, wireType 0 =*/2382102704).int32(message.maxNodes);
                            if (message.minNodes != null && Object.hasOwnProperty.call(message, "minNodes"))
                                writer.uint32(/* id 533370500, wireType 0 =*/4266964000).int32(message.minNodes);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NodeGroupAutoscalingPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NodeGroupAutoscalingPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroupAutoscalingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupAutoscalingPolicy} message NodeGroupAutoscalingPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroupAutoscalingPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NodeGroupAutoscalingPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NodeGroupAutoscalingPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NodeGroupAutoscalingPolicy} NodeGroupAutoscalingPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroupAutoscalingPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NodeGroupAutoscalingPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 297762838: {
                                        message.maxNodes = reader.int32();
                                        break;
                                    }
                                case 533370500: {
                                        message.minNodes = reader.int32();
                                        break;
                                    }
                                case 3357091: {
                                        message.mode = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NodeGroupAutoscalingPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroupAutoscalingPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NodeGroupAutoscalingPolicy} NodeGroupAutoscalingPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroupAutoscalingPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NodeGroupAutoscalingPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NodeGroupAutoscalingPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NodeGroupAutoscalingPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.maxNodes != null && message.hasOwnProperty("maxNodes")) {
                                properties._maxNodes = 1;
                                if (!$util.isInteger(message.maxNodes))
                                    return "maxNodes: integer expected";
                            }
                            if (message.minNodes != null && message.hasOwnProperty("minNodes")) {
                                properties._minNodes = 1;
                                if (!$util.isInteger(message.minNodes))
                                    return "minNodes: integer expected";
                            }
                            if (message.mode != null && message.hasOwnProperty("mode")) {
                                properties._mode = 1;
                                if (!$util.isString(message.mode))
                                    return "mode: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NodeGroupAutoscalingPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NodeGroupAutoscalingPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NodeGroupAutoscalingPolicy} NodeGroupAutoscalingPolicy
                         */
                        NodeGroupAutoscalingPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NodeGroupAutoscalingPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NodeGroupAutoscalingPolicy();
                            if (object.maxNodes != null)
                                message.maxNodes = object.maxNodes | 0;
                            if (object.minNodes != null)
                                message.minNodes = object.minNodes | 0;
                            if (object.mode != null)
                                message.mode = String(object.mode);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NodeGroupAutoscalingPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NodeGroupAutoscalingPolicy
                         * @static
                         * @param {google.cloud.compute.v1.NodeGroupAutoscalingPolicy} message NodeGroupAutoscalingPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NodeGroupAutoscalingPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.mode != null && message.hasOwnProperty("mode")) {
                                object.mode = message.mode;
                                if (options.oneofs)
                                    object._mode = "mode";
                            }
                            if (message.maxNodes != null && message.hasOwnProperty("maxNodes")) {
                                object.maxNodes = message.maxNodes;
                                if (options.oneofs)
                                    object._maxNodes = "maxNodes";
                            }
                            if (message.minNodes != null && message.hasOwnProperty("minNodes")) {
                                object.minNodes = message.minNodes;
                                if (options.oneofs)
                                    object._minNodes = "minNodes";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NodeGroupAutoscalingPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NodeGroupAutoscalingPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NodeGroupAutoscalingPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NodeGroupAutoscalingPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NodeGroupAutoscalingPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NodeGroupAutoscalingPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NodeGroupAutoscalingPolicy";
                        };
    
                        /**
                         * Mode enum.
                         * @name google.cloud.compute.v1.NodeGroupAutoscalingPolicy.Mode
                         * @enum {number}
                         * @property {number} UNDEFINED_MODE=0 UNDEFINED_MODE value
                         * @property {number} MODE_UNSPECIFIED=371348091 MODE_UNSPECIFIED value
                         * @property {number} OFF=78159 OFF value
                         * @property {number} ON=2527 ON value
                         * @property {number} ONLY_SCALE_OUT=152713670 ONLY_SCALE_OUT value
                         */
                        NodeGroupAutoscalingPolicy.Mode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_MODE"] = 0;
                            values[valuesById[371348091] = "MODE_UNSPECIFIED"] = 371348091;
                            values[valuesById[78159] = "OFF"] = 78159;
                            values[valuesById[2527] = "ON"] = 2527;
                            values[valuesById[152713670] = "ONLY_SCALE_OUT"] = 152713670;
                            return values;
                        })();
    
                        return NodeGroupAutoscalingPolicy;
                    })();
    
                    v1.NodeGroupList = (function() {
    
                        /**
                         * Properties of a NodeGroupList.
                         * @memberof google.cloud.compute.v1
                         * @interface INodeGroupList
                         * @property {string|null} [id] NodeGroupList id
                         * @property {Array.<google.cloud.compute.v1.INodeGroup>|null} [items] NodeGroupList items
                         * @property {string|null} [kind] NodeGroupList kind
                         * @property {string|null} [nextPageToken] NodeGroupList nextPageToken
                         * @property {string|null} [selfLink] NodeGroupList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] NodeGroupList warning
                         */
    
                        /**
                         * Constructs a new NodeGroupList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeGroupList.
                         * @implements INodeGroupList
                         * @constructor
                         * @param {google.cloud.compute.v1.INodeGroupList=} [properties] Properties to set
                         */
                        function NodeGroupList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NodeGroupList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @instance
                         */
                        NodeGroupList.prototype.id = null;
    
                        /**
                         * NodeGroupList items.
                         * @member {Array.<google.cloud.compute.v1.INodeGroup>} items
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @instance
                         */
                        NodeGroupList.prototype.items = $util.emptyArray;
    
                        /**
                         * NodeGroupList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @instance
                         */
                        NodeGroupList.prototype.kind = null;
    
                        /**
                         * NodeGroupList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @instance
                         */
                        NodeGroupList.prototype.nextPageToken = null;
    
                        /**
                         * NodeGroupList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @instance
                         */
                        NodeGroupList.prototype.selfLink = null;
    
                        /**
                         * NodeGroupList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @instance
                         */
                        NodeGroupList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NodeGroupList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @instance
                         */
                        Object.defineProperty(NodeGroupList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @instance
                         */
                        Object.defineProperty(NodeGroupList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @instance
                         */
                        Object.defineProperty(NodeGroupList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @instance
                         */
                        Object.defineProperty(NodeGroupList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @instance
                         */
                        Object.defineProperty(NodeGroupList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NodeGroupList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NodeGroupList} NodeGroupList instance
                         */
                        NodeGroupList.create = function create(properties) {
                            return new NodeGroupList(properties);
                        };
    
                        /**
                         * Encodes the specified NodeGroupList message. Does not implicitly {@link google.cloud.compute.v1.NodeGroupList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupList} message NodeGroupList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroupList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.NodeGroup.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NodeGroupList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NodeGroupList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupList} message NodeGroupList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroupList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NodeGroupList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NodeGroupList} NodeGroupList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroupList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NodeGroupList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.NodeGroup.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NodeGroupList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NodeGroupList} NodeGroupList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroupList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NodeGroupList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NodeGroupList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NodeGroup.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NodeGroupList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NodeGroupList} NodeGroupList
                         */
                        NodeGroupList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NodeGroupList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NodeGroupList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.NodeGroupList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NodeGroupList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.NodeGroup.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeGroupList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NodeGroupList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @static
                         * @param {google.cloud.compute.v1.NodeGroupList} message NodeGroupList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NodeGroupList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.NodeGroup.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NodeGroupList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NodeGroupList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NodeGroupList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NodeGroupList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NodeGroupList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NodeGroupList";
                        };
    
                        return NodeGroupList;
                    })();
    
                    v1.NodeGroupMaintenanceWindow = (function() {
    
                        /**
                         * Properties of a NodeGroupMaintenanceWindow.
                         * @memberof google.cloud.compute.v1
                         * @interface INodeGroupMaintenanceWindow
                         * @property {google.cloud.compute.v1.IDuration|null} [maintenanceDuration] NodeGroupMaintenanceWindow maintenanceDuration
                         * @property {string|null} [startTime] NodeGroupMaintenanceWindow startTime
                         */
    
                        /**
                         * Constructs a new NodeGroupMaintenanceWindow.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeGroupMaintenanceWindow.
                         * @implements INodeGroupMaintenanceWindow
                         * @constructor
                         * @param {google.cloud.compute.v1.INodeGroupMaintenanceWindow=} [properties] Properties to set
                         */
                        function NodeGroupMaintenanceWindow(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NodeGroupMaintenanceWindow maintenanceDuration.
                         * @member {google.cloud.compute.v1.IDuration|null|undefined} maintenanceDuration
                         * @memberof google.cloud.compute.v1.NodeGroupMaintenanceWindow
                         * @instance
                         */
                        NodeGroupMaintenanceWindow.prototype.maintenanceDuration = null;
    
                        /**
                         * NodeGroupMaintenanceWindow startTime.
                         * @member {string|null|undefined} startTime
                         * @memberof google.cloud.compute.v1.NodeGroupMaintenanceWindow
                         * @instance
                         */
                        NodeGroupMaintenanceWindow.prototype.startTime = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NodeGroupMaintenanceWindow _maintenanceDuration.
                         * @member {"maintenanceDuration"|undefined} _maintenanceDuration
                         * @memberof google.cloud.compute.v1.NodeGroupMaintenanceWindow
                         * @instance
                         */
                        Object.defineProperty(NodeGroupMaintenanceWindow.prototype, "_maintenanceDuration", {
                            get: $util.oneOfGetter($oneOfFields = ["maintenanceDuration"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupMaintenanceWindow _startTime.
                         * @member {"startTime"|undefined} _startTime
                         * @memberof google.cloud.compute.v1.NodeGroupMaintenanceWindow
                         * @instance
                         */
                        Object.defineProperty(NodeGroupMaintenanceWindow.prototype, "_startTime", {
                            get: $util.oneOfGetter($oneOfFields = ["startTime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NodeGroupMaintenanceWindow instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeGroupMaintenanceWindow
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupMaintenanceWindow=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NodeGroupMaintenanceWindow} NodeGroupMaintenanceWindow instance
                         */
                        NodeGroupMaintenanceWindow.create = function create(properties) {
                            return new NodeGroupMaintenanceWindow(properties);
                        };
    
                        /**
                         * Encodes the specified NodeGroupMaintenanceWindow message. Does not implicitly {@link google.cloud.compute.v1.NodeGroupMaintenanceWindow.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NodeGroupMaintenanceWindow
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupMaintenanceWindow} message NodeGroupMaintenanceWindow message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroupMaintenanceWindow.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.startTime != null && Object.hasOwnProperty.call(message, "startTime"))
                                writer.uint32(/* id 37467274, wireType 2 =*/299738194).string(message.startTime);
                            if (message.maintenanceDuration != null && Object.hasOwnProperty.call(message, "maintenanceDuration"))
                                $root.google.cloud.compute.v1.Duration.encode(message.maintenanceDuration, writer.uint32(/* id 525291840, wireType 2 =*/4202334722).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NodeGroupMaintenanceWindow message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NodeGroupMaintenanceWindow.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroupMaintenanceWindow
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupMaintenanceWindow} message NodeGroupMaintenanceWindow message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroupMaintenanceWindow.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NodeGroupMaintenanceWindow message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NodeGroupMaintenanceWindow
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NodeGroupMaintenanceWindow} NodeGroupMaintenanceWindow
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroupMaintenanceWindow.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NodeGroupMaintenanceWindow();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 525291840: {
                                        message.maintenanceDuration = $root.google.cloud.compute.v1.Duration.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37467274: {
                                        message.startTime = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NodeGroupMaintenanceWindow message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroupMaintenanceWindow
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NodeGroupMaintenanceWindow} NodeGroupMaintenanceWindow
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroupMaintenanceWindow.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NodeGroupMaintenanceWindow message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NodeGroupMaintenanceWindow
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NodeGroupMaintenanceWindow.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.maintenanceDuration != null && message.hasOwnProperty("maintenanceDuration")) {
                                properties._maintenanceDuration = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Duration.verify(message.maintenanceDuration);
                                    if (error)
                                        return "maintenanceDuration." + error;
                                }
                            }
                            if (message.startTime != null && message.hasOwnProperty("startTime")) {
                                properties._startTime = 1;
                                if (!$util.isString(message.startTime))
                                    return "startTime: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NodeGroupMaintenanceWindow message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NodeGroupMaintenanceWindow
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NodeGroupMaintenanceWindow} NodeGroupMaintenanceWindow
                         */
                        NodeGroupMaintenanceWindow.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NodeGroupMaintenanceWindow)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NodeGroupMaintenanceWindow();
                            if (object.maintenanceDuration != null) {
                                if (typeof object.maintenanceDuration !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeGroupMaintenanceWindow.maintenanceDuration: object expected");
                                message.maintenanceDuration = $root.google.cloud.compute.v1.Duration.fromObject(object.maintenanceDuration);
                            }
                            if (object.startTime != null)
                                message.startTime = String(object.startTime);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NodeGroupMaintenanceWindow message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NodeGroupMaintenanceWindow
                         * @static
                         * @param {google.cloud.compute.v1.NodeGroupMaintenanceWindow} message NodeGroupMaintenanceWindow
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NodeGroupMaintenanceWindow.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.startTime != null && message.hasOwnProperty("startTime")) {
                                object.startTime = message.startTime;
                                if (options.oneofs)
                                    object._startTime = "startTime";
                            }
                            if (message.maintenanceDuration != null && message.hasOwnProperty("maintenanceDuration")) {
                                object.maintenanceDuration = $root.google.cloud.compute.v1.Duration.toObject(message.maintenanceDuration, options);
                                if (options.oneofs)
                                    object._maintenanceDuration = "maintenanceDuration";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NodeGroupMaintenanceWindow to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NodeGroupMaintenanceWindow
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NodeGroupMaintenanceWindow.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NodeGroupMaintenanceWindow
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NodeGroupMaintenanceWindow
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NodeGroupMaintenanceWindow.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NodeGroupMaintenanceWindow";
                        };
    
                        return NodeGroupMaintenanceWindow;
                    })();
    
                    v1.NodeGroupNode = (function() {
    
                        /**
                         * Properties of a NodeGroupNode.
                         * @memberof google.cloud.compute.v1
                         * @interface INodeGroupNode
                         * @property {Array.<google.cloud.compute.v1.IAcceleratorConfig>|null} [accelerators] NodeGroupNode accelerators
                         * @property {google.cloud.compute.v1.IInstanceConsumptionInfo|null} [consumedResources] NodeGroupNode consumedResources
                         * @property {string|null} [cpuOvercommitType] NodeGroupNode cpuOvercommitType
                         * @property {Array.<google.cloud.compute.v1.ILocalDisk>|null} [disks] NodeGroupNode disks
                         * @property {Array.<google.cloud.compute.v1.IInstanceConsumptionData>|null} [instanceConsumptionData] NodeGroupNode instanceConsumptionData
                         * @property {Array.<string>|null} [instances] NodeGroupNode instances
                         * @property {string|null} [name] NodeGroupNode name
                         * @property {string|null} [nodeType] NodeGroupNode nodeType
                         * @property {boolean|null} [satisfiesPzs] NodeGroupNode satisfiesPzs
                         * @property {google.cloud.compute.v1.IServerBinding|null} [serverBinding] NodeGroupNode serverBinding
                         * @property {string|null} [serverId] NodeGroupNode serverId
                         * @property {string|null} [status] NodeGroupNode status
                         * @property {google.cloud.compute.v1.IInstanceConsumptionInfo|null} [totalResources] NodeGroupNode totalResources
                         */
    
                        /**
                         * Constructs a new NodeGroupNode.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeGroupNode.
                         * @implements INodeGroupNode
                         * @constructor
                         * @param {google.cloud.compute.v1.INodeGroupNode=} [properties] Properties to set
                         */
                        function NodeGroupNode(properties) {
                            this.accelerators = [];
                            this.disks = [];
                            this.instanceConsumptionData = [];
                            this.instances = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NodeGroupNode accelerators.
                         * @member {Array.<google.cloud.compute.v1.IAcceleratorConfig>} accelerators
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        NodeGroupNode.prototype.accelerators = $util.emptyArray;
    
                        /**
                         * NodeGroupNode consumedResources.
                         * @member {google.cloud.compute.v1.IInstanceConsumptionInfo|null|undefined} consumedResources
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        NodeGroupNode.prototype.consumedResources = null;
    
                        /**
                         * NodeGroupNode cpuOvercommitType.
                         * @member {string|null|undefined} cpuOvercommitType
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        NodeGroupNode.prototype.cpuOvercommitType = null;
    
                        /**
                         * NodeGroupNode disks.
                         * @member {Array.<google.cloud.compute.v1.ILocalDisk>} disks
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        NodeGroupNode.prototype.disks = $util.emptyArray;
    
                        /**
                         * NodeGroupNode instanceConsumptionData.
                         * @member {Array.<google.cloud.compute.v1.IInstanceConsumptionData>} instanceConsumptionData
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        NodeGroupNode.prototype.instanceConsumptionData = $util.emptyArray;
    
                        /**
                         * NodeGroupNode instances.
                         * @member {Array.<string>} instances
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        NodeGroupNode.prototype.instances = $util.emptyArray;
    
                        /**
                         * NodeGroupNode name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        NodeGroupNode.prototype.name = null;
    
                        /**
                         * NodeGroupNode nodeType.
                         * @member {string|null|undefined} nodeType
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        NodeGroupNode.prototype.nodeType = null;
    
                        /**
                         * NodeGroupNode satisfiesPzs.
                         * @member {boolean|null|undefined} satisfiesPzs
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        NodeGroupNode.prototype.satisfiesPzs = null;
    
                        /**
                         * NodeGroupNode serverBinding.
                         * @member {google.cloud.compute.v1.IServerBinding|null|undefined} serverBinding
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        NodeGroupNode.prototype.serverBinding = null;
    
                        /**
                         * NodeGroupNode serverId.
                         * @member {string|null|undefined} serverId
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        NodeGroupNode.prototype.serverId = null;
    
                        /**
                         * NodeGroupNode status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        NodeGroupNode.prototype.status = null;
    
                        /**
                         * NodeGroupNode totalResources.
                         * @member {google.cloud.compute.v1.IInstanceConsumptionInfo|null|undefined} totalResources
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        NodeGroupNode.prototype.totalResources = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NodeGroupNode _consumedResources.
                         * @member {"consumedResources"|undefined} _consumedResources
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        Object.defineProperty(NodeGroupNode.prototype, "_consumedResources", {
                            get: $util.oneOfGetter($oneOfFields = ["consumedResources"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupNode _cpuOvercommitType.
                         * @member {"cpuOvercommitType"|undefined} _cpuOvercommitType
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        Object.defineProperty(NodeGroupNode.prototype, "_cpuOvercommitType", {
                            get: $util.oneOfGetter($oneOfFields = ["cpuOvercommitType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupNode _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        Object.defineProperty(NodeGroupNode.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupNode _nodeType.
                         * @member {"nodeType"|undefined} _nodeType
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        Object.defineProperty(NodeGroupNode.prototype, "_nodeType", {
                            get: $util.oneOfGetter($oneOfFields = ["nodeType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupNode _satisfiesPzs.
                         * @member {"satisfiesPzs"|undefined} _satisfiesPzs
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        Object.defineProperty(NodeGroupNode.prototype, "_satisfiesPzs", {
                            get: $util.oneOfGetter($oneOfFields = ["satisfiesPzs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupNode _serverBinding.
                         * @member {"serverBinding"|undefined} _serverBinding
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        Object.defineProperty(NodeGroupNode.prototype, "_serverBinding", {
                            get: $util.oneOfGetter($oneOfFields = ["serverBinding"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupNode _serverId.
                         * @member {"serverId"|undefined} _serverId
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        Object.defineProperty(NodeGroupNode.prototype, "_serverId", {
                            get: $util.oneOfGetter($oneOfFields = ["serverId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupNode _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        Object.defineProperty(NodeGroupNode.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupNode _totalResources.
                         * @member {"totalResources"|undefined} _totalResources
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         */
                        Object.defineProperty(NodeGroupNode.prototype, "_totalResources", {
                            get: $util.oneOfGetter($oneOfFields = ["totalResources"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NodeGroupNode instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupNode=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NodeGroupNode} NodeGroupNode instance
                         */
                        NodeGroupNode.create = function create(properties) {
                            return new NodeGroupNode(properties);
                        };
    
                        /**
                         * Encodes the specified NodeGroupNode message. Does not implicitly {@link google.cloud.compute.v1.NodeGroupNode.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupNode} message NodeGroupNode message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroupNode.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.instances != null && message.instances.length)
                                for (var i = 0; i < message.instances.length; ++i)
                                    writer.uint32(/* id 29097598, wireType 2 =*/232780786).string(message.instances[i]);
                            if (message.instanceConsumptionData != null && message.instanceConsumptionData.length)
                                for (var i = 0; i < message.instanceConsumptionData.length; ++i)
                                    $root.google.cloud.compute.v1.InstanceConsumptionData.encode(message.instanceConsumptionData[i], writer.uint32(/* id 84715576, wireType 2 =*/677724610).fork()).ldelim();
                            if (message.disks != null && message.disks.length)
                                for (var i = 0; i < message.disks.length; ++i)
                                    $root.google.cloud.compute.v1.LocalDisk.encode(message.disks[i], writer.uint32(/* id 95594102, wireType 2 =*/764752818).fork()).ldelim();
                            if (message.totalResources != null && Object.hasOwnProperty.call(message, "totalResources"))
                                $root.google.cloud.compute.v1.InstanceConsumptionInfo.encode(message.totalResources, writer.uint32(/* id 97406698, wireType 2 =*/779253586).fork()).ldelim();
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.serverBinding != null && Object.hasOwnProperty.call(message, "serverBinding"))
                                $root.google.cloud.compute.v1.ServerBinding.encode(message.serverBinding, writer.uint32(/* id 208179593, wireType 2 =*/1665436746).fork()).ldelim();
                            if (message.cpuOvercommitType != null && Object.hasOwnProperty.call(message, "cpuOvercommitType"))
                                writer.uint32(/* id 247727959, wireType 2 =*/1981823674).string(message.cpuOvercommitType);
                            if (message.accelerators != null && message.accelerators.length)
                                for (var i = 0; i < message.accelerators.length; ++i)
                                    $root.google.cloud.compute.v1.AcceleratorConfig.encode(message.accelerators[i], writer.uint32(/* id 269577064, wireType 2 =*/2156616514).fork()).ldelim();
                            if (message.consumedResources != null && Object.hasOwnProperty.call(message, "consumedResources"))
                                $root.google.cloud.compute.v1.InstanceConsumptionInfo.encode(message.consumedResources, writer.uint32(/* id 334527118, wireType 2 =*/2676216946).fork()).ldelim();
                            if (message.serverId != null && Object.hasOwnProperty.call(message, "serverId"))
                                writer.uint32(/* id 339433367, wireType 2 =*/2715466938).string(message.serverId);
                            if (message.nodeType != null && Object.hasOwnProperty.call(message, "nodeType"))
                                writer.uint32(/* id 465832791, wireType 2 =*/3726662330).string(message.nodeType);
                            if (message.satisfiesPzs != null && Object.hasOwnProperty.call(message, "satisfiesPzs"))
                                writer.uint32(/* id 480964267, wireType 0 =*/3847714136).bool(message.satisfiesPzs);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NodeGroupNode message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NodeGroupNode.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupNode} message NodeGroupNode message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroupNode.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NodeGroupNode message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NodeGroupNode} NodeGroupNode
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroupNode.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NodeGroupNode();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 269577064: {
                                        if (!(message.accelerators && message.accelerators.length))
                                            message.accelerators = [];
                                        message.accelerators.push($root.google.cloud.compute.v1.AcceleratorConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 334527118: {
                                        message.consumedResources = $root.google.cloud.compute.v1.InstanceConsumptionInfo.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 247727959: {
                                        message.cpuOvercommitType = reader.string();
                                        break;
                                    }
                                case 95594102: {
                                        if (!(message.disks && message.disks.length))
                                            message.disks = [];
                                        message.disks.push($root.google.cloud.compute.v1.LocalDisk.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 84715576: {
                                        if (!(message.instanceConsumptionData && message.instanceConsumptionData.length))
                                            message.instanceConsumptionData = [];
                                        message.instanceConsumptionData.push($root.google.cloud.compute.v1.InstanceConsumptionData.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 29097598: {
                                        if (!(message.instances && message.instances.length))
                                            message.instances = [];
                                        message.instances.push(reader.string());
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 465832791: {
                                        message.nodeType = reader.string();
                                        break;
                                    }
                                case 480964267: {
                                        message.satisfiesPzs = reader.bool();
                                        break;
                                    }
                                case 208179593: {
                                        message.serverBinding = $root.google.cloud.compute.v1.ServerBinding.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 339433367: {
                                        message.serverId = reader.string();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                case 97406698: {
                                        message.totalResources = $root.google.cloud.compute.v1.InstanceConsumptionInfo.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NodeGroupNode message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NodeGroupNode} NodeGroupNode
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroupNode.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NodeGroupNode message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NodeGroupNode.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.accelerators != null && message.hasOwnProperty("accelerators")) {
                                if (!Array.isArray(message.accelerators))
                                    return "accelerators: array expected";
                                for (var i = 0; i < message.accelerators.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AcceleratorConfig.verify(message.accelerators[i]);
                                    if (error)
                                        return "accelerators." + error;
                                }
                            }
                            if (message.consumedResources != null && message.hasOwnProperty("consumedResources")) {
                                properties._consumedResources = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InstanceConsumptionInfo.verify(message.consumedResources);
                                    if (error)
                                        return "consumedResources." + error;
                                }
                            }
                            if (message.cpuOvercommitType != null && message.hasOwnProperty("cpuOvercommitType")) {
                                properties._cpuOvercommitType = 1;
                                if (!$util.isString(message.cpuOvercommitType))
                                    return "cpuOvercommitType: string expected";
                            }
                            if (message.disks != null && message.hasOwnProperty("disks")) {
                                if (!Array.isArray(message.disks))
                                    return "disks: array expected";
                                for (var i = 0; i < message.disks.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.LocalDisk.verify(message.disks[i]);
                                    if (error)
                                        return "disks." + error;
                                }
                            }
                            if (message.instanceConsumptionData != null && message.hasOwnProperty("instanceConsumptionData")) {
                                if (!Array.isArray(message.instanceConsumptionData))
                                    return "instanceConsumptionData: array expected";
                                for (var i = 0; i < message.instanceConsumptionData.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstanceConsumptionData.verify(message.instanceConsumptionData[i]);
                                    if (error)
                                        return "instanceConsumptionData." + error;
                                }
                            }
                            if (message.instances != null && message.hasOwnProperty("instances")) {
                                if (!Array.isArray(message.instances))
                                    return "instances: array expected";
                                for (var i = 0; i < message.instances.length; ++i)
                                    if (!$util.isString(message.instances[i]))
                                        return "instances: string[] expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.nodeType != null && message.hasOwnProperty("nodeType")) {
                                properties._nodeType = 1;
                                if (!$util.isString(message.nodeType))
                                    return "nodeType: string expected";
                            }
                            if (message.satisfiesPzs != null && message.hasOwnProperty("satisfiesPzs")) {
                                properties._satisfiesPzs = 1;
                                if (typeof message.satisfiesPzs !== "boolean")
                                    return "satisfiesPzs: boolean expected";
                            }
                            if (message.serverBinding != null && message.hasOwnProperty("serverBinding")) {
                                properties._serverBinding = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ServerBinding.verify(message.serverBinding);
                                    if (error)
                                        return "serverBinding." + error;
                                }
                            }
                            if (message.serverId != null && message.hasOwnProperty("serverId")) {
                                properties._serverId = 1;
                                if (!$util.isString(message.serverId))
                                    return "serverId: string expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            if (message.totalResources != null && message.hasOwnProperty("totalResources")) {
                                properties._totalResources = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.InstanceConsumptionInfo.verify(message.totalResources);
                                    if (error)
                                        return "totalResources." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NodeGroupNode message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NodeGroupNode} NodeGroupNode
                         */
                        NodeGroupNode.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NodeGroupNode)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NodeGroupNode();
                            if (object.accelerators) {
                                if (!Array.isArray(object.accelerators))
                                    throw TypeError(".google.cloud.compute.v1.NodeGroupNode.accelerators: array expected");
                                message.accelerators = [];
                                for (var i = 0; i < object.accelerators.length; ++i) {
                                    if (typeof object.accelerators[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NodeGroupNode.accelerators: object expected");
                                    message.accelerators[i] = $root.google.cloud.compute.v1.AcceleratorConfig.fromObject(object.accelerators[i]);
                                }
                            }
                            if (object.consumedResources != null) {
                                if (typeof object.consumedResources !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeGroupNode.consumedResources: object expected");
                                message.consumedResources = $root.google.cloud.compute.v1.InstanceConsumptionInfo.fromObject(object.consumedResources);
                            }
                            if (object.cpuOvercommitType != null)
                                message.cpuOvercommitType = String(object.cpuOvercommitType);
                            if (object.disks) {
                                if (!Array.isArray(object.disks))
                                    throw TypeError(".google.cloud.compute.v1.NodeGroupNode.disks: array expected");
                                message.disks = [];
                                for (var i = 0; i < object.disks.length; ++i) {
                                    if (typeof object.disks[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NodeGroupNode.disks: object expected");
                                    message.disks[i] = $root.google.cloud.compute.v1.LocalDisk.fromObject(object.disks[i]);
                                }
                            }
                            if (object.instanceConsumptionData) {
                                if (!Array.isArray(object.instanceConsumptionData))
                                    throw TypeError(".google.cloud.compute.v1.NodeGroupNode.instanceConsumptionData: array expected");
                                message.instanceConsumptionData = [];
                                for (var i = 0; i < object.instanceConsumptionData.length; ++i) {
                                    if (typeof object.instanceConsumptionData[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NodeGroupNode.instanceConsumptionData: object expected");
                                    message.instanceConsumptionData[i] = $root.google.cloud.compute.v1.InstanceConsumptionData.fromObject(object.instanceConsumptionData[i]);
                                }
                            }
                            if (object.instances) {
                                if (!Array.isArray(object.instances))
                                    throw TypeError(".google.cloud.compute.v1.NodeGroupNode.instances: array expected");
                                message.instances = [];
                                for (var i = 0; i < object.instances.length; ++i)
                                    message.instances[i] = String(object.instances[i]);
                            }
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.nodeType != null)
                                message.nodeType = String(object.nodeType);
                            if (object.satisfiesPzs != null)
                                message.satisfiesPzs = Boolean(object.satisfiesPzs);
                            if (object.serverBinding != null) {
                                if (typeof object.serverBinding !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeGroupNode.serverBinding: object expected");
                                message.serverBinding = $root.google.cloud.compute.v1.ServerBinding.fromObject(object.serverBinding);
                            }
                            if (object.serverId != null)
                                message.serverId = String(object.serverId);
                            if (object.status != null)
                                message.status = String(object.status);
                            if (object.totalResources != null) {
                                if (typeof object.totalResources !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeGroupNode.totalResources: object expected");
                                message.totalResources = $root.google.cloud.compute.v1.InstanceConsumptionInfo.fromObject(object.totalResources);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NodeGroupNode message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @static
                         * @param {google.cloud.compute.v1.NodeGroupNode} message NodeGroupNode
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NodeGroupNode.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.instances = [];
                                object.instanceConsumptionData = [];
                                object.disks = [];
                                object.accelerators = [];
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.instances && message.instances.length) {
                                object.instances = [];
                                for (var j = 0; j < message.instances.length; ++j)
                                    object.instances[j] = message.instances[j];
                            }
                            if (message.instanceConsumptionData && message.instanceConsumptionData.length) {
                                object.instanceConsumptionData = [];
                                for (var j = 0; j < message.instanceConsumptionData.length; ++j)
                                    object.instanceConsumptionData[j] = $root.google.cloud.compute.v1.InstanceConsumptionData.toObject(message.instanceConsumptionData[j], options);
                            }
                            if (message.disks && message.disks.length) {
                                object.disks = [];
                                for (var j = 0; j < message.disks.length; ++j)
                                    object.disks[j] = $root.google.cloud.compute.v1.LocalDisk.toObject(message.disks[j], options);
                            }
                            if (message.totalResources != null && message.hasOwnProperty("totalResources")) {
                                object.totalResources = $root.google.cloud.compute.v1.InstanceConsumptionInfo.toObject(message.totalResources, options);
                                if (options.oneofs)
                                    object._totalResources = "totalResources";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.serverBinding != null && message.hasOwnProperty("serverBinding")) {
                                object.serverBinding = $root.google.cloud.compute.v1.ServerBinding.toObject(message.serverBinding, options);
                                if (options.oneofs)
                                    object._serverBinding = "serverBinding";
                            }
                            if (message.cpuOvercommitType != null && message.hasOwnProperty("cpuOvercommitType")) {
                                object.cpuOvercommitType = message.cpuOvercommitType;
                                if (options.oneofs)
                                    object._cpuOvercommitType = "cpuOvercommitType";
                            }
                            if (message.accelerators && message.accelerators.length) {
                                object.accelerators = [];
                                for (var j = 0; j < message.accelerators.length; ++j)
                                    object.accelerators[j] = $root.google.cloud.compute.v1.AcceleratorConfig.toObject(message.accelerators[j], options);
                            }
                            if (message.consumedResources != null && message.hasOwnProperty("consumedResources")) {
                                object.consumedResources = $root.google.cloud.compute.v1.InstanceConsumptionInfo.toObject(message.consumedResources, options);
                                if (options.oneofs)
                                    object._consumedResources = "consumedResources";
                            }
                            if (message.serverId != null && message.hasOwnProperty("serverId")) {
                                object.serverId = message.serverId;
                                if (options.oneofs)
                                    object._serverId = "serverId";
                            }
                            if (message.nodeType != null && message.hasOwnProperty("nodeType")) {
                                object.nodeType = message.nodeType;
                                if (options.oneofs)
                                    object._nodeType = "nodeType";
                            }
                            if (message.satisfiesPzs != null && message.hasOwnProperty("satisfiesPzs")) {
                                object.satisfiesPzs = message.satisfiesPzs;
                                if (options.oneofs)
                                    object._satisfiesPzs = "satisfiesPzs";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NodeGroupNode to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NodeGroupNode.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NodeGroupNode
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NodeGroupNode
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NodeGroupNode.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NodeGroupNode";
                        };
    
                        /**
                         * CpuOvercommitType enum.
                         * @name google.cloud.compute.v1.NodeGroupNode.CpuOvercommitType
                         * @enum {number}
                         * @property {number} UNDEFINED_CPU_OVERCOMMIT_TYPE=0 UNDEFINED_CPU_OVERCOMMIT_TYPE value
                         * @property {number} CPU_OVERCOMMIT_TYPE_UNSPECIFIED=520665615 CPU_OVERCOMMIT_TYPE_UNSPECIFIED value
                         * @property {number} ENABLED=182130465 ENABLED value
                         * @property {number} NONE=2402104 NONE value
                         */
                        NodeGroupNode.CpuOvercommitType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_CPU_OVERCOMMIT_TYPE"] = 0;
                            values[valuesById[520665615] = "CPU_OVERCOMMIT_TYPE_UNSPECIFIED"] = 520665615;
                            values[valuesById[182130465] = "ENABLED"] = 182130465;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            return values;
                        })();
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.NodeGroupNode.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} CREATING=455564985 CREATING value
                         * @property {number} DELETING=528602024 DELETING value
                         * @property {number} INVALID=530283991 INVALID value
                         * @property {number} READY=77848963 READY value
                         * @property {number} REPAIRING=413483285 REPAIRING value
                         */
                        NodeGroupNode.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[455564985] = "CREATING"] = 455564985;
                            values[valuesById[528602024] = "DELETING"] = 528602024;
                            values[valuesById[530283991] = "INVALID"] = 530283991;
                            values[valuesById[77848963] = "READY"] = 77848963;
                            values[valuesById[413483285] = "REPAIRING"] = 413483285;
                            return values;
                        })();
    
                        return NodeGroupNode;
                    })();
    
                    v1.NodeGroupsAddNodesRequest = (function() {
    
                        /**
                         * Properties of a NodeGroupsAddNodesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface INodeGroupsAddNodesRequest
                         * @property {number|null} [additionalNodeCount] NodeGroupsAddNodesRequest additionalNodeCount
                         */
    
                        /**
                         * Constructs a new NodeGroupsAddNodesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeGroupsAddNodesRequest.
                         * @implements INodeGroupsAddNodesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.INodeGroupsAddNodesRequest=} [properties] Properties to set
                         */
                        function NodeGroupsAddNodesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NodeGroupsAddNodesRequest additionalNodeCount.
                         * @member {number|null|undefined} additionalNodeCount
                         * @memberof google.cloud.compute.v1.NodeGroupsAddNodesRequest
                         * @instance
                         */
                        NodeGroupsAddNodesRequest.prototype.additionalNodeCount = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NodeGroupsAddNodesRequest _additionalNodeCount.
                         * @member {"additionalNodeCount"|undefined} _additionalNodeCount
                         * @memberof google.cloud.compute.v1.NodeGroupsAddNodesRequest
                         * @instance
                         */
                        Object.defineProperty(NodeGroupsAddNodesRequest.prototype, "_additionalNodeCount", {
                            get: $util.oneOfGetter($oneOfFields = ["additionalNodeCount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NodeGroupsAddNodesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeGroupsAddNodesRequest
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupsAddNodesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NodeGroupsAddNodesRequest} NodeGroupsAddNodesRequest instance
                         */
                        NodeGroupsAddNodesRequest.create = function create(properties) {
                            return new NodeGroupsAddNodesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified NodeGroupsAddNodesRequest message. Does not implicitly {@link google.cloud.compute.v1.NodeGroupsAddNodesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NodeGroupsAddNodesRequest
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupsAddNodesRequest} message NodeGroupsAddNodesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroupsAddNodesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.additionalNodeCount != null && Object.hasOwnProperty.call(message, "additionalNodeCount"))
                                writer.uint32(/* id 134997930, wireType 0 =*/1079983440).int32(message.additionalNodeCount);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NodeGroupsAddNodesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NodeGroupsAddNodesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroupsAddNodesRequest
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupsAddNodesRequest} message NodeGroupsAddNodesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroupsAddNodesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NodeGroupsAddNodesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NodeGroupsAddNodesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NodeGroupsAddNodesRequest} NodeGroupsAddNodesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroupsAddNodesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NodeGroupsAddNodesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 134997930: {
                                        message.additionalNodeCount = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NodeGroupsAddNodesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroupsAddNodesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NodeGroupsAddNodesRequest} NodeGroupsAddNodesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroupsAddNodesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NodeGroupsAddNodesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NodeGroupsAddNodesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NodeGroupsAddNodesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.additionalNodeCount != null && message.hasOwnProperty("additionalNodeCount")) {
                                properties._additionalNodeCount = 1;
                                if (!$util.isInteger(message.additionalNodeCount))
                                    return "additionalNodeCount: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NodeGroupsAddNodesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NodeGroupsAddNodesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NodeGroupsAddNodesRequest} NodeGroupsAddNodesRequest
                         */
                        NodeGroupsAddNodesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NodeGroupsAddNodesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NodeGroupsAddNodesRequest();
                            if (object.additionalNodeCount != null)
                                message.additionalNodeCount = object.additionalNodeCount | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NodeGroupsAddNodesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NodeGroupsAddNodesRequest
                         * @static
                         * @param {google.cloud.compute.v1.NodeGroupsAddNodesRequest} message NodeGroupsAddNodesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NodeGroupsAddNodesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.additionalNodeCount != null && message.hasOwnProperty("additionalNodeCount")) {
                                object.additionalNodeCount = message.additionalNodeCount;
                                if (options.oneofs)
                                    object._additionalNodeCount = "additionalNodeCount";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NodeGroupsAddNodesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NodeGroupsAddNodesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NodeGroupsAddNodesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NodeGroupsAddNodesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NodeGroupsAddNodesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NodeGroupsAddNodesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NodeGroupsAddNodesRequest";
                        };
    
                        return NodeGroupsAddNodesRequest;
                    })();
    
                    v1.NodeGroupsDeleteNodesRequest = (function() {
    
                        /**
                         * Properties of a NodeGroupsDeleteNodesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface INodeGroupsDeleteNodesRequest
                         * @property {Array.<string>|null} [nodes] NodeGroupsDeleteNodesRequest nodes
                         */
    
                        /**
                         * Constructs a new NodeGroupsDeleteNodesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeGroupsDeleteNodesRequest.
                         * @implements INodeGroupsDeleteNodesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.INodeGroupsDeleteNodesRequest=} [properties] Properties to set
                         */
                        function NodeGroupsDeleteNodesRequest(properties) {
                            this.nodes = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NodeGroupsDeleteNodesRequest nodes.
                         * @member {Array.<string>} nodes
                         * @memberof google.cloud.compute.v1.NodeGroupsDeleteNodesRequest
                         * @instance
                         */
                        NodeGroupsDeleteNodesRequest.prototype.nodes = $util.emptyArray;
    
                        /**
                         * Creates a new NodeGroupsDeleteNodesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeGroupsDeleteNodesRequest
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupsDeleteNodesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NodeGroupsDeleteNodesRequest} NodeGroupsDeleteNodesRequest instance
                         */
                        NodeGroupsDeleteNodesRequest.create = function create(properties) {
                            return new NodeGroupsDeleteNodesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified NodeGroupsDeleteNodesRequest message. Does not implicitly {@link google.cloud.compute.v1.NodeGroupsDeleteNodesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NodeGroupsDeleteNodesRequest
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupsDeleteNodesRequest} message NodeGroupsDeleteNodesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroupsDeleteNodesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.nodes != null && message.nodes.length)
                                for (var i = 0; i < message.nodes.length; ++i)
                                    writer.uint32(/* id 104993457, wireType 2 =*/839947658).string(message.nodes[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NodeGroupsDeleteNodesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NodeGroupsDeleteNodesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroupsDeleteNodesRequest
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupsDeleteNodesRequest} message NodeGroupsDeleteNodesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroupsDeleteNodesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NodeGroupsDeleteNodesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NodeGroupsDeleteNodesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NodeGroupsDeleteNodesRequest} NodeGroupsDeleteNodesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroupsDeleteNodesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NodeGroupsDeleteNodesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 104993457: {
                                        if (!(message.nodes && message.nodes.length))
                                            message.nodes = [];
                                        message.nodes.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NodeGroupsDeleteNodesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroupsDeleteNodesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NodeGroupsDeleteNodesRequest} NodeGroupsDeleteNodesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroupsDeleteNodesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NodeGroupsDeleteNodesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NodeGroupsDeleteNodesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NodeGroupsDeleteNodesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.nodes != null && message.hasOwnProperty("nodes")) {
                                if (!Array.isArray(message.nodes))
                                    return "nodes: array expected";
                                for (var i = 0; i < message.nodes.length; ++i)
                                    if (!$util.isString(message.nodes[i]))
                                        return "nodes: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NodeGroupsDeleteNodesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NodeGroupsDeleteNodesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NodeGroupsDeleteNodesRequest} NodeGroupsDeleteNodesRequest
                         */
                        NodeGroupsDeleteNodesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NodeGroupsDeleteNodesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NodeGroupsDeleteNodesRequest();
                            if (object.nodes) {
                                if (!Array.isArray(object.nodes))
                                    throw TypeError(".google.cloud.compute.v1.NodeGroupsDeleteNodesRequest.nodes: array expected");
                                message.nodes = [];
                                for (var i = 0; i < object.nodes.length; ++i)
                                    message.nodes[i] = String(object.nodes[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NodeGroupsDeleteNodesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NodeGroupsDeleteNodesRequest
                         * @static
                         * @param {google.cloud.compute.v1.NodeGroupsDeleteNodesRequest} message NodeGroupsDeleteNodesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NodeGroupsDeleteNodesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.nodes = [];
                            if (message.nodes && message.nodes.length) {
                                object.nodes = [];
                                for (var j = 0; j < message.nodes.length; ++j)
                                    object.nodes[j] = message.nodes[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NodeGroupsDeleteNodesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NodeGroupsDeleteNodesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NodeGroupsDeleteNodesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NodeGroupsDeleteNodesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NodeGroupsDeleteNodesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NodeGroupsDeleteNodesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NodeGroupsDeleteNodesRequest";
                        };
    
                        return NodeGroupsDeleteNodesRequest;
                    })();
    
                    v1.NodeGroupsListNodes = (function() {
    
                        /**
                         * Properties of a NodeGroupsListNodes.
                         * @memberof google.cloud.compute.v1
                         * @interface INodeGroupsListNodes
                         * @property {string|null} [id] NodeGroupsListNodes id
                         * @property {Array.<google.cloud.compute.v1.INodeGroupNode>|null} [items] NodeGroupsListNodes items
                         * @property {string|null} [kind] NodeGroupsListNodes kind
                         * @property {string|null} [nextPageToken] NodeGroupsListNodes nextPageToken
                         * @property {string|null} [selfLink] NodeGroupsListNodes selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] NodeGroupsListNodes warning
                         */
    
                        /**
                         * Constructs a new NodeGroupsListNodes.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeGroupsListNodes.
                         * @implements INodeGroupsListNodes
                         * @constructor
                         * @param {google.cloud.compute.v1.INodeGroupsListNodes=} [properties] Properties to set
                         */
                        function NodeGroupsListNodes(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NodeGroupsListNodes id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @instance
                         */
                        NodeGroupsListNodes.prototype.id = null;
    
                        /**
                         * NodeGroupsListNodes items.
                         * @member {Array.<google.cloud.compute.v1.INodeGroupNode>} items
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @instance
                         */
                        NodeGroupsListNodes.prototype.items = $util.emptyArray;
    
                        /**
                         * NodeGroupsListNodes kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @instance
                         */
                        NodeGroupsListNodes.prototype.kind = null;
    
                        /**
                         * NodeGroupsListNodes nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @instance
                         */
                        NodeGroupsListNodes.prototype.nextPageToken = null;
    
                        /**
                         * NodeGroupsListNodes selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @instance
                         */
                        NodeGroupsListNodes.prototype.selfLink = null;
    
                        /**
                         * NodeGroupsListNodes warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @instance
                         */
                        NodeGroupsListNodes.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NodeGroupsListNodes _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @instance
                         */
                        Object.defineProperty(NodeGroupsListNodes.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupsListNodes _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @instance
                         */
                        Object.defineProperty(NodeGroupsListNodes.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupsListNodes _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @instance
                         */
                        Object.defineProperty(NodeGroupsListNodes.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupsListNodes _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @instance
                         */
                        Object.defineProperty(NodeGroupsListNodes.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeGroupsListNodes _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @instance
                         */
                        Object.defineProperty(NodeGroupsListNodes.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NodeGroupsListNodes instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupsListNodes=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NodeGroupsListNodes} NodeGroupsListNodes instance
                         */
                        NodeGroupsListNodes.create = function create(properties) {
                            return new NodeGroupsListNodes(properties);
                        };
    
                        /**
                         * Encodes the specified NodeGroupsListNodes message. Does not implicitly {@link google.cloud.compute.v1.NodeGroupsListNodes.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupsListNodes} message NodeGroupsListNodes message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroupsListNodes.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.NodeGroupNode.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NodeGroupsListNodes message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NodeGroupsListNodes.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupsListNodes} message NodeGroupsListNodes message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroupsListNodes.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NodeGroupsListNodes message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NodeGroupsListNodes} NodeGroupsListNodes
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroupsListNodes.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NodeGroupsListNodes();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.NodeGroupNode.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NodeGroupsListNodes message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NodeGroupsListNodes} NodeGroupsListNodes
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroupsListNodes.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NodeGroupsListNodes message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NodeGroupsListNodes.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NodeGroupNode.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NodeGroupsListNodes message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NodeGroupsListNodes} NodeGroupsListNodes
                         */
                        NodeGroupsListNodes.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NodeGroupsListNodes)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NodeGroupsListNodes();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.NodeGroupsListNodes.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NodeGroupsListNodes.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.NodeGroupNode.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeGroupsListNodes.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NodeGroupsListNodes message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @static
                         * @param {google.cloud.compute.v1.NodeGroupsListNodes} message NodeGroupsListNodes
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NodeGroupsListNodes.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.NodeGroupNode.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NodeGroupsListNodes to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NodeGroupsListNodes.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NodeGroupsListNodes
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NodeGroupsListNodes
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NodeGroupsListNodes.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NodeGroupsListNodes";
                        };
    
                        return NodeGroupsListNodes;
                    })();
    
                    v1.NodeGroupsScopedList = (function() {
    
                        /**
                         * Properties of a NodeGroupsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface INodeGroupsScopedList
                         * @property {Array.<google.cloud.compute.v1.INodeGroup>|null} [nodeGroups] NodeGroupsScopedList nodeGroups
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] NodeGroupsScopedList warning
                         */
    
                        /**
                         * Constructs a new NodeGroupsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeGroupsScopedList.
                         * @implements INodeGroupsScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.INodeGroupsScopedList=} [properties] Properties to set
                         */
                        function NodeGroupsScopedList(properties) {
                            this.nodeGroups = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NodeGroupsScopedList nodeGroups.
                         * @member {Array.<google.cloud.compute.v1.INodeGroup>} nodeGroups
                         * @memberof google.cloud.compute.v1.NodeGroupsScopedList
                         * @instance
                         */
                        NodeGroupsScopedList.prototype.nodeGroups = $util.emptyArray;
    
                        /**
                         * NodeGroupsScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.NodeGroupsScopedList
                         * @instance
                         */
                        NodeGroupsScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NodeGroupsScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.NodeGroupsScopedList
                         * @instance
                         */
                        Object.defineProperty(NodeGroupsScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NodeGroupsScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeGroupsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupsScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NodeGroupsScopedList} NodeGroupsScopedList instance
                         */
                        NodeGroupsScopedList.create = function create(properties) {
                            return new NodeGroupsScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified NodeGroupsScopedList message. Does not implicitly {@link google.cloud.compute.v1.NodeGroupsScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NodeGroupsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupsScopedList} message NodeGroupsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroupsScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nodeGroups != null && message.nodeGroups.length)
                                for (var i = 0; i < message.nodeGroups.length; ++i)
                                    $root.google.cloud.compute.v1.NodeGroup.encode(message.nodeGroups[i], writer.uint32(/* id 73188017, wireType 2 =*/585504138).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NodeGroupsScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NodeGroupsScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroupsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupsScopedList} message NodeGroupsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroupsScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NodeGroupsScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NodeGroupsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NodeGroupsScopedList} NodeGroupsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroupsScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NodeGroupsScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 73188017: {
                                        if (!(message.nodeGroups && message.nodeGroups.length))
                                            message.nodeGroups = [];
                                        message.nodeGroups.push($root.google.cloud.compute.v1.NodeGroup.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NodeGroupsScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroupsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NodeGroupsScopedList} NodeGroupsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroupsScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NodeGroupsScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NodeGroupsScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NodeGroupsScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.nodeGroups != null && message.hasOwnProperty("nodeGroups")) {
                                if (!Array.isArray(message.nodeGroups))
                                    return "nodeGroups: array expected";
                                for (var i = 0; i < message.nodeGroups.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NodeGroup.verify(message.nodeGroups[i]);
                                    if (error)
                                        return "nodeGroups." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NodeGroupsScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NodeGroupsScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NodeGroupsScopedList} NodeGroupsScopedList
                         */
                        NodeGroupsScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NodeGroupsScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NodeGroupsScopedList();
                            if (object.nodeGroups) {
                                if (!Array.isArray(object.nodeGroups))
                                    throw TypeError(".google.cloud.compute.v1.NodeGroupsScopedList.nodeGroups: array expected");
                                message.nodeGroups = [];
                                for (var i = 0; i < object.nodeGroups.length; ++i) {
                                    if (typeof object.nodeGroups[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NodeGroupsScopedList.nodeGroups: object expected");
                                    message.nodeGroups[i] = $root.google.cloud.compute.v1.NodeGroup.fromObject(object.nodeGroups[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeGroupsScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NodeGroupsScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NodeGroupsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.NodeGroupsScopedList} message NodeGroupsScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NodeGroupsScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.nodeGroups = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nodeGroups && message.nodeGroups.length) {
                                object.nodeGroups = [];
                                for (var j = 0; j < message.nodeGroups.length; ++j)
                                    object.nodeGroups[j] = $root.google.cloud.compute.v1.NodeGroup.toObject(message.nodeGroups[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NodeGroupsScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NodeGroupsScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NodeGroupsScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NodeGroupsScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NodeGroupsScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NodeGroupsScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NodeGroupsScopedList";
                        };
    
                        return NodeGroupsScopedList;
                    })();
    
                    v1.NodeGroupsSetNodeTemplateRequest = (function() {
    
                        /**
                         * Properties of a NodeGroupsSetNodeTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface INodeGroupsSetNodeTemplateRequest
                         * @property {string|null} [nodeTemplate] NodeGroupsSetNodeTemplateRequest nodeTemplate
                         */
    
                        /**
                         * Constructs a new NodeGroupsSetNodeTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeGroupsSetNodeTemplateRequest.
                         * @implements INodeGroupsSetNodeTemplateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.INodeGroupsSetNodeTemplateRequest=} [properties] Properties to set
                         */
                        function NodeGroupsSetNodeTemplateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NodeGroupsSetNodeTemplateRequest nodeTemplate.
                         * @member {string|null|undefined} nodeTemplate
                         * @memberof google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest
                         * @instance
                         */
                        NodeGroupsSetNodeTemplateRequest.prototype.nodeTemplate = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NodeGroupsSetNodeTemplateRequest _nodeTemplate.
                         * @member {"nodeTemplate"|undefined} _nodeTemplate
                         * @memberof google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest
                         * @instance
                         */
                        Object.defineProperty(NodeGroupsSetNodeTemplateRequest.prototype, "_nodeTemplate", {
                            get: $util.oneOfGetter($oneOfFields = ["nodeTemplate"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NodeGroupsSetNodeTemplateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupsSetNodeTemplateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest} NodeGroupsSetNodeTemplateRequest instance
                         */
                        NodeGroupsSetNodeTemplateRequest.create = function create(properties) {
                            return new NodeGroupsSetNodeTemplateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified NodeGroupsSetNodeTemplateRequest message. Does not implicitly {@link google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupsSetNodeTemplateRequest} message NodeGroupsSetNodeTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroupsSetNodeTemplateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.nodeTemplate != null && Object.hasOwnProperty.call(message, "nodeTemplate"))
                                writer.uint32(/* id 323154455, wireType 2 =*/2585235642).string(message.nodeTemplate);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NodeGroupsSetNodeTemplateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.INodeGroupsSetNodeTemplateRequest} message NodeGroupsSetNodeTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeGroupsSetNodeTemplateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NodeGroupsSetNodeTemplateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest} NodeGroupsSetNodeTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroupsSetNodeTemplateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 323154455: {
                                        message.nodeTemplate = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NodeGroupsSetNodeTemplateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest} NodeGroupsSetNodeTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeGroupsSetNodeTemplateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NodeGroupsSetNodeTemplateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NodeGroupsSetNodeTemplateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.nodeTemplate != null && message.hasOwnProperty("nodeTemplate")) {
                                properties._nodeTemplate = 1;
                                if (!$util.isString(message.nodeTemplate))
                                    return "nodeTemplate: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NodeGroupsSetNodeTemplateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest} NodeGroupsSetNodeTemplateRequest
                         */
                        NodeGroupsSetNodeTemplateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest();
                            if (object.nodeTemplate != null)
                                message.nodeTemplate = String(object.nodeTemplate);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NodeGroupsSetNodeTemplateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest} message NodeGroupsSetNodeTemplateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NodeGroupsSetNodeTemplateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.nodeTemplate != null && message.hasOwnProperty("nodeTemplate")) {
                                object.nodeTemplate = message.nodeTemplate;
                                if (options.oneofs)
                                    object._nodeTemplate = "nodeTemplate";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NodeGroupsSetNodeTemplateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NodeGroupsSetNodeTemplateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NodeGroupsSetNodeTemplateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NodeGroupsSetNodeTemplateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest";
                        };
    
                        return NodeGroupsSetNodeTemplateRequest;
                    })();
    
                    v1.NodeTemplate = (function() {
    
                        /**
                         * Properties of a NodeTemplate.
                         * @memberof google.cloud.compute.v1
                         * @interface INodeTemplate
                         * @property {Array.<google.cloud.compute.v1.IAcceleratorConfig>|null} [accelerators] NodeTemplate accelerators
                         * @property {string|null} [cpuOvercommitType] NodeTemplate cpuOvercommitType
                         * @property {string|null} [creationTimestamp] NodeTemplate creationTimestamp
                         * @property {string|null} [description] NodeTemplate description
                         * @property {Array.<google.cloud.compute.v1.ILocalDisk>|null} [disks] NodeTemplate disks
                         * @property {number|Long|null} [id] NodeTemplate id
                         * @property {string|null} [kind] NodeTemplate kind
                         * @property {string|null} [name] NodeTemplate name
                         * @property {Object.<string,string>|null} [nodeAffinityLabels] NodeTemplate nodeAffinityLabels
                         * @property {string|null} [nodeType] NodeTemplate nodeType
                         * @property {google.cloud.compute.v1.INodeTemplateNodeTypeFlexibility|null} [nodeTypeFlexibility] NodeTemplate nodeTypeFlexibility
                         * @property {string|null} [region] NodeTemplate region
                         * @property {string|null} [selfLink] NodeTemplate selfLink
                         * @property {google.cloud.compute.v1.IServerBinding|null} [serverBinding] NodeTemplate serverBinding
                         * @property {string|null} [status] NodeTemplate status
                         * @property {string|null} [statusMessage] NodeTemplate statusMessage
                         */
    
                        /**
                         * Constructs a new NodeTemplate.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeTemplate.
                         * @implements INodeTemplate
                         * @constructor
                         * @param {google.cloud.compute.v1.INodeTemplate=} [properties] Properties to set
                         */
                        function NodeTemplate(properties) {
                            this.accelerators = [];
                            this.disks = [];
                            this.nodeAffinityLabels = {};
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NodeTemplate accelerators.
                         * @member {Array.<google.cloud.compute.v1.IAcceleratorConfig>} accelerators
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        NodeTemplate.prototype.accelerators = $util.emptyArray;
    
                        /**
                         * NodeTemplate cpuOvercommitType.
                         * @member {string|null|undefined} cpuOvercommitType
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        NodeTemplate.prototype.cpuOvercommitType = null;
    
                        /**
                         * NodeTemplate creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        NodeTemplate.prototype.creationTimestamp = null;
    
                        /**
                         * NodeTemplate description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        NodeTemplate.prototype.description = null;
    
                        /**
                         * NodeTemplate disks.
                         * @member {Array.<google.cloud.compute.v1.ILocalDisk>} disks
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        NodeTemplate.prototype.disks = $util.emptyArray;
    
                        /**
                         * NodeTemplate id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        NodeTemplate.prototype.id = null;
    
                        /**
                         * NodeTemplate kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        NodeTemplate.prototype.kind = null;
    
                        /**
                         * NodeTemplate name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        NodeTemplate.prototype.name = null;
    
                        /**
                         * NodeTemplate nodeAffinityLabels.
                         * @member {Object.<string,string>} nodeAffinityLabels
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        NodeTemplate.prototype.nodeAffinityLabels = $util.emptyObject;
    
                        /**
                         * NodeTemplate nodeType.
                         * @member {string|null|undefined} nodeType
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        NodeTemplate.prototype.nodeType = null;
    
                        /**
                         * NodeTemplate nodeTypeFlexibility.
                         * @member {google.cloud.compute.v1.INodeTemplateNodeTypeFlexibility|null|undefined} nodeTypeFlexibility
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        NodeTemplate.prototype.nodeTypeFlexibility = null;
    
                        /**
                         * NodeTemplate region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        NodeTemplate.prototype.region = null;
    
                        /**
                         * NodeTemplate selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        NodeTemplate.prototype.selfLink = null;
    
                        /**
                         * NodeTemplate serverBinding.
                         * @member {google.cloud.compute.v1.IServerBinding|null|undefined} serverBinding
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        NodeTemplate.prototype.serverBinding = null;
    
                        /**
                         * NodeTemplate status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        NodeTemplate.prototype.status = null;
    
                        /**
                         * NodeTemplate statusMessage.
                         * @member {string|null|undefined} statusMessage
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        NodeTemplate.prototype.statusMessage = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NodeTemplate _cpuOvercommitType.
                         * @member {"cpuOvercommitType"|undefined} _cpuOvercommitType
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        Object.defineProperty(NodeTemplate.prototype, "_cpuOvercommitType", {
                            get: $util.oneOfGetter($oneOfFields = ["cpuOvercommitType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplate _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        Object.defineProperty(NodeTemplate.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplate _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        Object.defineProperty(NodeTemplate.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplate _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        Object.defineProperty(NodeTemplate.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplate _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        Object.defineProperty(NodeTemplate.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplate _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        Object.defineProperty(NodeTemplate.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplate _nodeType.
                         * @member {"nodeType"|undefined} _nodeType
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        Object.defineProperty(NodeTemplate.prototype, "_nodeType", {
                            get: $util.oneOfGetter($oneOfFields = ["nodeType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplate _nodeTypeFlexibility.
                         * @member {"nodeTypeFlexibility"|undefined} _nodeTypeFlexibility
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        Object.defineProperty(NodeTemplate.prototype, "_nodeTypeFlexibility", {
                            get: $util.oneOfGetter($oneOfFields = ["nodeTypeFlexibility"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplate _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        Object.defineProperty(NodeTemplate.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplate _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        Object.defineProperty(NodeTemplate.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplate _serverBinding.
                         * @member {"serverBinding"|undefined} _serverBinding
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        Object.defineProperty(NodeTemplate.prototype, "_serverBinding", {
                            get: $util.oneOfGetter($oneOfFields = ["serverBinding"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplate _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        Object.defineProperty(NodeTemplate.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplate _statusMessage.
                         * @member {"statusMessage"|undefined} _statusMessage
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         */
                        Object.defineProperty(NodeTemplate.prototype, "_statusMessage", {
                            get: $util.oneOfGetter($oneOfFields = ["statusMessage"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NodeTemplate instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @static
                         * @param {google.cloud.compute.v1.INodeTemplate=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NodeTemplate} NodeTemplate instance
                         */
                        NodeTemplate.create = function create(properties) {
                            return new NodeTemplate(properties);
                        };
    
                        /**
                         * Encodes the specified NodeTemplate message. Does not implicitly {@link google.cloud.compute.v1.NodeTemplate.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @static
                         * @param {google.cloud.compute.v1.INodeTemplate} message NodeTemplate message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeTemplate.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.disks != null && message.disks.length)
                                for (var i = 0; i < message.disks.length; ++i)
                                    $root.google.cloud.compute.v1.LocalDisk.encode(message.disks[i], writer.uint32(/* id 95594102, wireType 2 =*/764752818).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.serverBinding != null && Object.hasOwnProperty.call(message, "serverBinding"))
                                $root.google.cloud.compute.v1.ServerBinding.encode(message.serverBinding, writer.uint32(/* id 208179593, wireType 2 =*/1665436746).fork()).ldelim();
                            if (message.cpuOvercommitType != null && Object.hasOwnProperty.call(message, "cpuOvercommitType"))
                                writer.uint32(/* id 247727959, wireType 2 =*/1981823674).string(message.cpuOvercommitType);
                            if (message.accelerators != null && message.accelerators.length)
                                for (var i = 0; i < message.accelerators.length; ++i)
                                    $root.google.cloud.compute.v1.AcceleratorConfig.encode(message.accelerators[i], writer.uint32(/* id 269577064, wireType 2 =*/2156616514).fork()).ldelim();
                            if (message.statusMessage != null && Object.hasOwnProperty.call(message, "statusMessage"))
                                writer.uint32(/* id 297428154, wireType 2 =*/2379425234).string(message.statusMessage);
                            if (message.nodeTypeFlexibility != null && Object.hasOwnProperty.call(message, "nodeTypeFlexibility"))
                                $root.google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility.encode(message.nodeTypeFlexibility, writer.uint32(/* id 315257905, wireType 2 =*/2522063242).fork()).ldelim();
                            if (message.nodeAffinityLabels != null && Object.hasOwnProperty.call(message, "nodeAffinityLabels"))
                                for (var keys = Object.keys(message.nodeAffinityLabels), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 339007161, wireType 2 =*/2712057290).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.nodeAffinityLabels[keys[i]]).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.nodeType != null && Object.hasOwnProperty.call(message, "nodeType"))
                                writer.uint32(/* id 465832791, wireType 2 =*/3726662330).string(message.nodeType);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NodeTemplate message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NodeTemplate.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @static
                         * @param {google.cloud.compute.v1.INodeTemplate} message NodeTemplate message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeTemplate.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NodeTemplate message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NodeTemplate} NodeTemplate
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeTemplate.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NodeTemplate(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 269577064: {
                                        if (!(message.accelerators && message.accelerators.length))
                                            message.accelerators = [];
                                        message.accelerators.push($root.google.cloud.compute.v1.AcceleratorConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 247727959: {
                                        message.cpuOvercommitType = reader.string();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 95594102: {
                                        if (!(message.disks && message.disks.length))
                                            message.disks = [];
                                        message.disks.push($root.google.cloud.compute.v1.LocalDisk.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 339007161: {
                                        if (message.nodeAffinityLabels === $util.emptyObject)
                                            message.nodeAffinityLabels = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.nodeAffinityLabels[key] = value;
                                        break;
                                    }
                                case 465832791: {
                                        message.nodeType = reader.string();
                                        break;
                                    }
                                case 315257905: {
                                        message.nodeTypeFlexibility = $root.google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 208179593: {
                                        message.serverBinding = $root.google.cloud.compute.v1.ServerBinding.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                case 297428154: {
                                        message.statusMessage = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NodeTemplate message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NodeTemplate} NodeTemplate
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeTemplate.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NodeTemplate message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NodeTemplate.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.accelerators != null && message.hasOwnProperty("accelerators")) {
                                if (!Array.isArray(message.accelerators))
                                    return "accelerators: array expected";
                                for (var i = 0; i < message.accelerators.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AcceleratorConfig.verify(message.accelerators[i]);
                                    if (error)
                                        return "accelerators." + error;
                                }
                            }
                            if (message.cpuOvercommitType != null && message.hasOwnProperty("cpuOvercommitType")) {
                                properties._cpuOvercommitType = 1;
                                if (!$util.isString(message.cpuOvercommitType))
                                    return "cpuOvercommitType: string expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.disks != null && message.hasOwnProperty("disks")) {
                                if (!Array.isArray(message.disks))
                                    return "disks: array expected";
                                for (var i = 0; i < message.disks.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.LocalDisk.verify(message.disks[i]);
                                    if (error)
                                        return "disks." + error;
                                }
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.nodeAffinityLabels != null && message.hasOwnProperty("nodeAffinityLabels")) {
                                if (!$util.isObject(message.nodeAffinityLabels))
                                    return "nodeAffinityLabels: object expected";
                                var key = Object.keys(message.nodeAffinityLabels);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.nodeAffinityLabels[key[i]]))
                                        return "nodeAffinityLabels: string{k:string} expected";
                            }
                            if (message.nodeType != null && message.hasOwnProperty("nodeType")) {
                                properties._nodeType = 1;
                                if (!$util.isString(message.nodeType))
                                    return "nodeType: string expected";
                            }
                            if (message.nodeTypeFlexibility != null && message.hasOwnProperty("nodeTypeFlexibility")) {
                                properties._nodeTypeFlexibility = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility.verify(message.nodeTypeFlexibility);
                                    if (error)
                                        return "nodeTypeFlexibility." + error;
                                }
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.serverBinding != null && message.hasOwnProperty("serverBinding")) {
                                properties._serverBinding = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ServerBinding.verify(message.serverBinding);
                                    if (error)
                                        return "serverBinding." + error;
                                }
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            if (message.statusMessage != null && message.hasOwnProperty("statusMessage")) {
                                properties._statusMessage = 1;
                                if (!$util.isString(message.statusMessage))
                                    return "statusMessage: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NodeTemplate message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NodeTemplate} NodeTemplate
                         */
                        NodeTemplate.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NodeTemplate)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NodeTemplate();
                            if (object.accelerators) {
                                if (!Array.isArray(object.accelerators))
                                    throw TypeError(".google.cloud.compute.v1.NodeTemplate.accelerators: array expected");
                                message.accelerators = [];
                                for (var i = 0; i < object.accelerators.length; ++i) {
                                    if (typeof object.accelerators[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NodeTemplate.accelerators: object expected");
                                    message.accelerators[i] = $root.google.cloud.compute.v1.AcceleratorConfig.fromObject(object.accelerators[i]);
                                }
                            }
                            if (object.cpuOvercommitType != null)
                                message.cpuOvercommitType = String(object.cpuOvercommitType);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.disks) {
                                if (!Array.isArray(object.disks))
                                    throw TypeError(".google.cloud.compute.v1.NodeTemplate.disks: array expected");
                                message.disks = [];
                                for (var i = 0; i < object.disks.length; ++i) {
                                    if (typeof object.disks[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NodeTemplate.disks: object expected");
                                    message.disks[i] = $root.google.cloud.compute.v1.LocalDisk.fromObject(object.disks[i]);
                                }
                            }
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.nodeAffinityLabels) {
                                if (typeof object.nodeAffinityLabels !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeTemplate.nodeAffinityLabels: object expected");
                                message.nodeAffinityLabels = {};
                                for (var keys = Object.keys(object.nodeAffinityLabels), i = 0; i < keys.length; ++i)
                                    message.nodeAffinityLabels[keys[i]] = String(object.nodeAffinityLabels[keys[i]]);
                            }
                            if (object.nodeType != null)
                                message.nodeType = String(object.nodeType);
                            if (object.nodeTypeFlexibility != null) {
                                if (typeof object.nodeTypeFlexibility !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeTemplate.nodeTypeFlexibility: object expected");
                                message.nodeTypeFlexibility = $root.google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility.fromObject(object.nodeTypeFlexibility);
                            }
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.serverBinding != null) {
                                if (typeof object.serverBinding !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeTemplate.serverBinding: object expected");
                                message.serverBinding = $root.google.cloud.compute.v1.ServerBinding.fromObject(object.serverBinding);
                            }
                            if (object.status != null)
                                message.status = String(object.status);
                            if (object.statusMessage != null)
                                message.statusMessage = String(object.statusMessage);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NodeTemplate message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @static
                         * @param {google.cloud.compute.v1.NodeTemplate} message NodeTemplate
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NodeTemplate.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.disks = [];
                                object.accelerators = [];
                            }
                            if (options.objects || options.defaults)
                                object.nodeAffinityLabels = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.disks && message.disks.length) {
                                object.disks = [];
                                for (var j = 0; j < message.disks.length; ++j)
                                    object.disks[j] = $root.google.cloud.compute.v1.LocalDisk.toObject(message.disks[j], options);
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.serverBinding != null && message.hasOwnProperty("serverBinding")) {
                                object.serverBinding = $root.google.cloud.compute.v1.ServerBinding.toObject(message.serverBinding, options);
                                if (options.oneofs)
                                    object._serverBinding = "serverBinding";
                            }
                            if (message.cpuOvercommitType != null && message.hasOwnProperty("cpuOvercommitType")) {
                                object.cpuOvercommitType = message.cpuOvercommitType;
                                if (options.oneofs)
                                    object._cpuOvercommitType = "cpuOvercommitType";
                            }
                            if (message.accelerators && message.accelerators.length) {
                                object.accelerators = [];
                                for (var j = 0; j < message.accelerators.length; ++j)
                                    object.accelerators[j] = $root.google.cloud.compute.v1.AcceleratorConfig.toObject(message.accelerators[j], options);
                            }
                            if (message.statusMessage != null && message.hasOwnProperty("statusMessage")) {
                                object.statusMessage = message.statusMessage;
                                if (options.oneofs)
                                    object._statusMessage = "statusMessage";
                            }
                            if (message.nodeTypeFlexibility != null && message.hasOwnProperty("nodeTypeFlexibility")) {
                                object.nodeTypeFlexibility = $root.google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility.toObject(message.nodeTypeFlexibility, options);
                                if (options.oneofs)
                                    object._nodeTypeFlexibility = "nodeTypeFlexibility";
                            }
                            var keys2;
                            if (message.nodeAffinityLabels && (keys2 = Object.keys(message.nodeAffinityLabels)).length) {
                                object.nodeAffinityLabels = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.nodeAffinityLabels[keys2[j]] = message.nodeAffinityLabels[keys2[j]];
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.nodeType != null && message.hasOwnProperty("nodeType")) {
                                object.nodeType = message.nodeType;
                                if (options.oneofs)
                                    object._nodeType = "nodeType";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NodeTemplate to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NodeTemplate.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NodeTemplate
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NodeTemplate
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NodeTemplate.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NodeTemplate";
                        };
    
                        /**
                         * CpuOvercommitType enum.
                         * @name google.cloud.compute.v1.NodeTemplate.CpuOvercommitType
                         * @enum {number}
                         * @property {number} UNDEFINED_CPU_OVERCOMMIT_TYPE=0 UNDEFINED_CPU_OVERCOMMIT_TYPE value
                         * @property {number} CPU_OVERCOMMIT_TYPE_UNSPECIFIED=520665615 CPU_OVERCOMMIT_TYPE_UNSPECIFIED value
                         * @property {number} ENABLED=182130465 ENABLED value
                         * @property {number} NONE=2402104 NONE value
                         */
                        NodeTemplate.CpuOvercommitType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_CPU_OVERCOMMIT_TYPE"] = 0;
                            values[valuesById[520665615] = "CPU_OVERCOMMIT_TYPE_UNSPECIFIED"] = 520665615;
                            values[valuesById[182130465] = "ENABLED"] = 182130465;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            return values;
                        })();
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.NodeTemplate.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} CREATING=455564985 CREATING value
                         * @property {number} DELETING=528602024 DELETING value
                         * @property {number} INVALID=530283991 INVALID value
                         * @property {number} READY=77848963 READY value
                         */
                        NodeTemplate.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[455564985] = "CREATING"] = 455564985;
                            values[valuesById[528602024] = "DELETING"] = 528602024;
                            values[valuesById[530283991] = "INVALID"] = 530283991;
                            values[valuesById[77848963] = "READY"] = 77848963;
                            return values;
                        })();
    
                        return NodeTemplate;
                    })();
    
                    v1.NodeTemplateAggregatedList = (function() {
    
                        /**
                         * Properties of a NodeTemplateAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface INodeTemplateAggregatedList
                         * @property {string|null} [id] NodeTemplateAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.INodeTemplatesScopedList>|null} [items] NodeTemplateAggregatedList items
                         * @property {string|null} [kind] NodeTemplateAggregatedList kind
                         * @property {string|null} [nextPageToken] NodeTemplateAggregatedList nextPageToken
                         * @property {string|null} [selfLink] NodeTemplateAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] NodeTemplateAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] NodeTemplateAggregatedList warning
                         */
    
                        /**
                         * Constructs a new NodeTemplateAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeTemplateAggregatedList.
                         * @implements INodeTemplateAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.INodeTemplateAggregatedList=} [properties] Properties to set
                         */
                        function NodeTemplateAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NodeTemplateAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @instance
                         */
                        NodeTemplateAggregatedList.prototype.id = null;
    
                        /**
                         * NodeTemplateAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.INodeTemplatesScopedList>} items
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @instance
                         */
                        NodeTemplateAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * NodeTemplateAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @instance
                         */
                        NodeTemplateAggregatedList.prototype.kind = null;
    
                        /**
                         * NodeTemplateAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @instance
                         */
                        NodeTemplateAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * NodeTemplateAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @instance
                         */
                        NodeTemplateAggregatedList.prototype.selfLink = null;
    
                        /**
                         * NodeTemplateAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @instance
                         */
                        NodeTemplateAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * NodeTemplateAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @instance
                         */
                        NodeTemplateAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NodeTemplateAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NodeTemplateAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplateAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NodeTemplateAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplateAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NodeTemplateAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplateAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NodeTemplateAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplateAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NodeTemplateAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NodeTemplateAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.INodeTemplateAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NodeTemplateAggregatedList} NodeTemplateAggregatedList instance
                         */
                        NodeTemplateAggregatedList.create = function create(properties) {
                            return new NodeTemplateAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified NodeTemplateAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.NodeTemplateAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.INodeTemplateAggregatedList} message NodeTemplateAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeTemplateAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.NodeTemplatesScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NodeTemplateAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NodeTemplateAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.INodeTemplateAggregatedList} message NodeTemplateAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeTemplateAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NodeTemplateAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NodeTemplateAggregatedList} NodeTemplateAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeTemplateAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NodeTemplateAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.NodeTemplatesScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NodeTemplateAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NodeTemplateAggregatedList} NodeTemplateAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeTemplateAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NodeTemplateAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NodeTemplateAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NodeTemplatesScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NodeTemplateAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NodeTemplateAggregatedList} NodeTemplateAggregatedList
                         */
                        NodeTemplateAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NodeTemplateAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NodeTemplateAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeTemplateAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NodeTemplateAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.NodeTemplatesScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.NodeTemplateAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeTemplateAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NodeTemplateAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.NodeTemplateAggregatedList} message NodeTemplateAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NodeTemplateAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.NodeTemplatesScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NodeTemplateAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NodeTemplateAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NodeTemplateAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NodeTemplateAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NodeTemplateAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NodeTemplateAggregatedList";
                        };
    
                        return NodeTemplateAggregatedList;
                    })();
    
                    v1.NodeTemplateList = (function() {
    
                        /**
                         * Properties of a NodeTemplateList.
                         * @memberof google.cloud.compute.v1
                         * @interface INodeTemplateList
                         * @property {string|null} [id] NodeTemplateList id
                         * @property {Array.<google.cloud.compute.v1.INodeTemplate>|null} [items] NodeTemplateList items
                         * @property {string|null} [kind] NodeTemplateList kind
                         * @property {string|null} [nextPageToken] NodeTemplateList nextPageToken
                         * @property {string|null} [selfLink] NodeTemplateList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] NodeTemplateList warning
                         */
    
                        /**
                         * Constructs a new NodeTemplateList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeTemplateList.
                         * @implements INodeTemplateList
                         * @constructor
                         * @param {google.cloud.compute.v1.INodeTemplateList=} [properties] Properties to set
                         */
                        function NodeTemplateList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NodeTemplateList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @instance
                         */
                        NodeTemplateList.prototype.id = null;
    
                        /**
                         * NodeTemplateList items.
                         * @member {Array.<google.cloud.compute.v1.INodeTemplate>} items
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @instance
                         */
                        NodeTemplateList.prototype.items = $util.emptyArray;
    
                        /**
                         * NodeTemplateList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @instance
                         */
                        NodeTemplateList.prototype.kind = null;
    
                        /**
                         * NodeTemplateList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @instance
                         */
                        NodeTemplateList.prototype.nextPageToken = null;
    
                        /**
                         * NodeTemplateList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @instance
                         */
                        NodeTemplateList.prototype.selfLink = null;
    
                        /**
                         * NodeTemplateList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @instance
                         */
                        NodeTemplateList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NodeTemplateList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @instance
                         */
                        Object.defineProperty(NodeTemplateList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplateList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @instance
                         */
                        Object.defineProperty(NodeTemplateList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplateList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @instance
                         */
                        Object.defineProperty(NodeTemplateList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplateList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @instance
                         */
                        Object.defineProperty(NodeTemplateList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplateList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @instance
                         */
                        Object.defineProperty(NodeTemplateList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NodeTemplateList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @static
                         * @param {google.cloud.compute.v1.INodeTemplateList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NodeTemplateList} NodeTemplateList instance
                         */
                        NodeTemplateList.create = function create(properties) {
                            return new NodeTemplateList(properties);
                        };
    
                        /**
                         * Encodes the specified NodeTemplateList message. Does not implicitly {@link google.cloud.compute.v1.NodeTemplateList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @static
                         * @param {google.cloud.compute.v1.INodeTemplateList} message NodeTemplateList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeTemplateList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.NodeTemplate.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NodeTemplateList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NodeTemplateList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @static
                         * @param {google.cloud.compute.v1.INodeTemplateList} message NodeTemplateList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeTemplateList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NodeTemplateList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NodeTemplateList} NodeTemplateList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeTemplateList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NodeTemplateList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.NodeTemplate.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NodeTemplateList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NodeTemplateList} NodeTemplateList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeTemplateList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NodeTemplateList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NodeTemplateList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NodeTemplate.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NodeTemplateList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NodeTemplateList} NodeTemplateList
                         */
                        NodeTemplateList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NodeTemplateList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NodeTemplateList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.NodeTemplateList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NodeTemplateList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.NodeTemplate.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeTemplateList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NodeTemplateList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @static
                         * @param {google.cloud.compute.v1.NodeTemplateList} message NodeTemplateList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NodeTemplateList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.NodeTemplate.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NodeTemplateList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NodeTemplateList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NodeTemplateList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NodeTemplateList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NodeTemplateList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NodeTemplateList";
                        };
    
                        return NodeTemplateList;
                    })();
    
                    v1.NodeTemplateNodeTypeFlexibility = (function() {
    
                        /**
                         * Properties of a NodeTemplateNodeTypeFlexibility.
                         * @memberof google.cloud.compute.v1
                         * @interface INodeTemplateNodeTypeFlexibility
                         * @property {string|null} [cpus] NodeTemplateNodeTypeFlexibility cpus
                         * @property {string|null} [localSsd] NodeTemplateNodeTypeFlexibility localSsd
                         * @property {string|null} [memory] NodeTemplateNodeTypeFlexibility memory
                         */
    
                        /**
                         * Constructs a new NodeTemplateNodeTypeFlexibility.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeTemplateNodeTypeFlexibility.
                         * @implements INodeTemplateNodeTypeFlexibility
                         * @constructor
                         * @param {google.cloud.compute.v1.INodeTemplateNodeTypeFlexibility=} [properties] Properties to set
                         */
                        function NodeTemplateNodeTypeFlexibility(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NodeTemplateNodeTypeFlexibility cpus.
                         * @member {string|null|undefined} cpus
                         * @memberof google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility
                         * @instance
                         */
                        NodeTemplateNodeTypeFlexibility.prototype.cpus = null;
    
                        /**
                         * NodeTemplateNodeTypeFlexibility localSsd.
                         * @member {string|null|undefined} localSsd
                         * @memberof google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility
                         * @instance
                         */
                        NodeTemplateNodeTypeFlexibility.prototype.localSsd = null;
    
                        /**
                         * NodeTemplateNodeTypeFlexibility memory.
                         * @member {string|null|undefined} memory
                         * @memberof google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility
                         * @instance
                         */
                        NodeTemplateNodeTypeFlexibility.prototype.memory = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NodeTemplateNodeTypeFlexibility _cpus.
                         * @member {"cpus"|undefined} _cpus
                         * @memberof google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility
                         * @instance
                         */
                        Object.defineProperty(NodeTemplateNodeTypeFlexibility.prototype, "_cpus", {
                            get: $util.oneOfGetter($oneOfFields = ["cpus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplateNodeTypeFlexibility _localSsd.
                         * @member {"localSsd"|undefined} _localSsd
                         * @memberof google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility
                         * @instance
                         */
                        Object.defineProperty(NodeTemplateNodeTypeFlexibility.prototype, "_localSsd", {
                            get: $util.oneOfGetter($oneOfFields = ["localSsd"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTemplateNodeTypeFlexibility _memory.
                         * @member {"memory"|undefined} _memory
                         * @memberof google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility
                         * @instance
                         */
                        Object.defineProperty(NodeTemplateNodeTypeFlexibility.prototype, "_memory", {
                            get: $util.oneOfGetter($oneOfFields = ["memory"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NodeTemplateNodeTypeFlexibility instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility
                         * @static
                         * @param {google.cloud.compute.v1.INodeTemplateNodeTypeFlexibility=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility} NodeTemplateNodeTypeFlexibility instance
                         */
                        NodeTemplateNodeTypeFlexibility.create = function create(properties) {
                            return new NodeTemplateNodeTypeFlexibility(properties);
                        };
    
                        /**
                         * Encodes the specified NodeTemplateNodeTypeFlexibility message. Does not implicitly {@link google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility
                         * @static
                         * @param {google.cloud.compute.v1.INodeTemplateNodeTypeFlexibility} message NodeTemplateNodeTypeFlexibility message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeTemplateNodeTypeFlexibility.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.cpus != null && Object.hasOwnProperty.call(message, "cpus"))
                                writer.uint32(/* id 3060683, wireType 2 =*/24485466).string(message.cpus);
                            if (message.localSsd != null && Object.hasOwnProperty.call(message, "localSsd"))
                                writer.uint32(/* id 405741360, wireType 2 =*/3245930882).string(message.localSsd);
                            if (message.memory != null && Object.hasOwnProperty.call(message, "memory"))
                                writer.uint32(/* id 532856065, wireType 2 =*/4262848522).string(message.memory);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NodeTemplateNodeTypeFlexibility message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility
                         * @static
                         * @param {google.cloud.compute.v1.INodeTemplateNodeTypeFlexibility} message NodeTemplateNodeTypeFlexibility message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeTemplateNodeTypeFlexibility.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NodeTemplateNodeTypeFlexibility message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility} NodeTemplateNodeTypeFlexibility
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeTemplateNodeTypeFlexibility.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3060683: {
                                        message.cpus = reader.string();
                                        break;
                                    }
                                case 405741360: {
                                        message.localSsd = reader.string();
                                        break;
                                    }
                                case 532856065: {
                                        message.memory = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NodeTemplateNodeTypeFlexibility message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility} NodeTemplateNodeTypeFlexibility
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeTemplateNodeTypeFlexibility.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NodeTemplateNodeTypeFlexibility message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NodeTemplateNodeTypeFlexibility.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.cpus != null && message.hasOwnProperty("cpus")) {
                                properties._cpus = 1;
                                if (!$util.isString(message.cpus))
                                    return "cpus: string expected";
                            }
                            if (message.localSsd != null && message.hasOwnProperty("localSsd")) {
                                properties._localSsd = 1;
                                if (!$util.isString(message.localSsd))
                                    return "localSsd: string expected";
                            }
                            if (message.memory != null && message.hasOwnProperty("memory")) {
                                properties._memory = 1;
                                if (!$util.isString(message.memory))
                                    return "memory: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NodeTemplateNodeTypeFlexibility message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility} NodeTemplateNodeTypeFlexibility
                         */
                        NodeTemplateNodeTypeFlexibility.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility();
                            if (object.cpus != null)
                                message.cpus = String(object.cpus);
                            if (object.localSsd != null)
                                message.localSsd = String(object.localSsd);
                            if (object.memory != null)
                                message.memory = String(object.memory);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NodeTemplateNodeTypeFlexibility message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility
                         * @static
                         * @param {google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility} message NodeTemplateNodeTypeFlexibility
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NodeTemplateNodeTypeFlexibility.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.cpus != null && message.hasOwnProperty("cpus")) {
                                object.cpus = message.cpus;
                                if (options.oneofs)
                                    object._cpus = "cpus";
                            }
                            if (message.localSsd != null && message.hasOwnProperty("localSsd")) {
                                object.localSsd = message.localSsd;
                                if (options.oneofs)
                                    object._localSsd = "localSsd";
                            }
                            if (message.memory != null && message.hasOwnProperty("memory")) {
                                object.memory = message.memory;
                                if (options.oneofs)
                                    object._memory = "memory";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NodeTemplateNodeTypeFlexibility to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NodeTemplateNodeTypeFlexibility.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NodeTemplateNodeTypeFlexibility
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NodeTemplateNodeTypeFlexibility.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NodeTemplateNodeTypeFlexibility";
                        };
    
                        return NodeTemplateNodeTypeFlexibility;
                    })();
    
                    v1.NodeTemplatesScopedList = (function() {
    
                        /**
                         * Properties of a NodeTemplatesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface INodeTemplatesScopedList
                         * @property {Array.<google.cloud.compute.v1.INodeTemplate>|null} [nodeTemplates] NodeTemplatesScopedList nodeTemplates
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] NodeTemplatesScopedList warning
                         */
    
                        /**
                         * Constructs a new NodeTemplatesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeTemplatesScopedList.
                         * @implements INodeTemplatesScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.INodeTemplatesScopedList=} [properties] Properties to set
                         */
                        function NodeTemplatesScopedList(properties) {
                            this.nodeTemplates = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NodeTemplatesScopedList nodeTemplates.
                         * @member {Array.<google.cloud.compute.v1.INodeTemplate>} nodeTemplates
                         * @memberof google.cloud.compute.v1.NodeTemplatesScopedList
                         * @instance
                         */
                        NodeTemplatesScopedList.prototype.nodeTemplates = $util.emptyArray;
    
                        /**
                         * NodeTemplatesScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.NodeTemplatesScopedList
                         * @instance
                         */
                        NodeTemplatesScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NodeTemplatesScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.NodeTemplatesScopedList
                         * @instance
                         */
                        Object.defineProperty(NodeTemplatesScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NodeTemplatesScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeTemplatesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.INodeTemplatesScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NodeTemplatesScopedList} NodeTemplatesScopedList instance
                         */
                        NodeTemplatesScopedList.create = function create(properties) {
                            return new NodeTemplatesScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified NodeTemplatesScopedList message. Does not implicitly {@link google.cloud.compute.v1.NodeTemplatesScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NodeTemplatesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.INodeTemplatesScopedList} message NodeTemplatesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeTemplatesScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nodeTemplates != null && message.nodeTemplates.length)
                                for (var i = 0; i < message.nodeTemplates.length; ++i)
                                    $root.google.cloud.compute.v1.NodeTemplate.encode(message.nodeTemplates[i], writer.uint32(/* id 354111804, wireType 2 =*/2832894434).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NodeTemplatesScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NodeTemplatesScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NodeTemplatesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.INodeTemplatesScopedList} message NodeTemplatesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeTemplatesScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NodeTemplatesScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NodeTemplatesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NodeTemplatesScopedList} NodeTemplatesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeTemplatesScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NodeTemplatesScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 354111804: {
                                        if (!(message.nodeTemplates && message.nodeTemplates.length))
                                            message.nodeTemplates = [];
                                        message.nodeTemplates.push($root.google.cloud.compute.v1.NodeTemplate.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NodeTemplatesScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NodeTemplatesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NodeTemplatesScopedList} NodeTemplatesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeTemplatesScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NodeTemplatesScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NodeTemplatesScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NodeTemplatesScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.nodeTemplates != null && message.hasOwnProperty("nodeTemplates")) {
                                if (!Array.isArray(message.nodeTemplates))
                                    return "nodeTemplates: array expected";
                                for (var i = 0; i < message.nodeTemplates.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NodeTemplate.verify(message.nodeTemplates[i]);
                                    if (error)
                                        return "nodeTemplates." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NodeTemplatesScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NodeTemplatesScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NodeTemplatesScopedList} NodeTemplatesScopedList
                         */
                        NodeTemplatesScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NodeTemplatesScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NodeTemplatesScopedList();
                            if (object.nodeTemplates) {
                                if (!Array.isArray(object.nodeTemplates))
                                    throw TypeError(".google.cloud.compute.v1.NodeTemplatesScopedList.nodeTemplates: array expected");
                                message.nodeTemplates = [];
                                for (var i = 0; i < object.nodeTemplates.length; ++i) {
                                    if (typeof object.nodeTemplates[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NodeTemplatesScopedList.nodeTemplates: object expected");
                                    message.nodeTemplates[i] = $root.google.cloud.compute.v1.NodeTemplate.fromObject(object.nodeTemplates[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeTemplatesScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NodeTemplatesScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NodeTemplatesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.NodeTemplatesScopedList} message NodeTemplatesScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NodeTemplatesScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.nodeTemplates = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nodeTemplates && message.nodeTemplates.length) {
                                object.nodeTemplates = [];
                                for (var j = 0; j < message.nodeTemplates.length; ++j)
                                    object.nodeTemplates[j] = $root.google.cloud.compute.v1.NodeTemplate.toObject(message.nodeTemplates[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NodeTemplatesScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NodeTemplatesScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NodeTemplatesScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NodeTemplatesScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NodeTemplatesScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NodeTemplatesScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NodeTemplatesScopedList";
                        };
    
                        return NodeTemplatesScopedList;
                    })();
    
                    v1.NodeType = (function() {
    
                        /**
                         * Properties of a NodeType.
                         * @memberof google.cloud.compute.v1
                         * @interface INodeType
                         * @property {string|null} [cpuPlatform] NodeType cpuPlatform
                         * @property {string|null} [creationTimestamp] NodeType creationTimestamp
                         * @property {google.cloud.compute.v1.IDeprecationStatus|null} [deprecated] NodeType deprecated
                         * @property {string|null} [description] NodeType description
                         * @property {number|null} [guestCpus] NodeType guestCpus
                         * @property {number|Long|null} [id] NodeType id
                         * @property {string|null} [kind] NodeType kind
                         * @property {number|null} [localSsdGb] NodeType localSsdGb
                         * @property {number|null} [memoryMb] NodeType memoryMb
                         * @property {string|null} [name] NodeType name
                         * @property {string|null} [selfLink] NodeType selfLink
                         * @property {string|null} [zone] NodeType zone
                         */
    
                        /**
                         * Constructs a new NodeType.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeType.
                         * @implements INodeType
                         * @constructor
                         * @param {google.cloud.compute.v1.INodeType=} [properties] Properties to set
                         */
                        function NodeType(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NodeType cpuPlatform.
                         * @member {string|null|undefined} cpuPlatform
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        NodeType.prototype.cpuPlatform = null;
    
                        /**
                         * NodeType creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        NodeType.prototype.creationTimestamp = null;
    
                        /**
                         * NodeType deprecated.
                         * @member {google.cloud.compute.v1.IDeprecationStatus|null|undefined} deprecated
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        NodeType.prototype.deprecated = null;
    
                        /**
                         * NodeType description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        NodeType.prototype.description = null;
    
                        /**
                         * NodeType guestCpus.
                         * @member {number|null|undefined} guestCpus
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        NodeType.prototype.guestCpus = null;
    
                        /**
                         * NodeType id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        NodeType.prototype.id = null;
    
                        /**
                         * NodeType kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        NodeType.prototype.kind = null;
    
                        /**
                         * NodeType localSsdGb.
                         * @member {number|null|undefined} localSsdGb
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        NodeType.prototype.localSsdGb = null;
    
                        /**
                         * NodeType memoryMb.
                         * @member {number|null|undefined} memoryMb
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        NodeType.prototype.memoryMb = null;
    
                        /**
                         * NodeType name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        NodeType.prototype.name = null;
    
                        /**
                         * NodeType selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        NodeType.prototype.selfLink = null;
    
                        /**
                         * NodeType zone.
                         * @member {string|null|undefined} zone
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        NodeType.prototype.zone = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NodeType _cpuPlatform.
                         * @member {"cpuPlatform"|undefined} _cpuPlatform
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        Object.defineProperty(NodeType.prototype, "_cpuPlatform", {
                            get: $util.oneOfGetter($oneOfFields = ["cpuPlatform"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeType _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        Object.defineProperty(NodeType.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeType _deprecated.
                         * @member {"deprecated"|undefined} _deprecated
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        Object.defineProperty(NodeType.prototype, "_deprecated", {
                            get: $util.oneOfGetter($oneOfFields = ["deprecated"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeType _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        Object.defineProperty(NodeType.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeType _guestCpus.
                         * @member {"guestCpus"|undefined} _guestCpus
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        Object.defineProperty(NodeType.prototype, "_guestCpus", {
                            get: $util.oneOfGetter($oneOfFields = ["guestCpus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeType _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        Object.defineProperty(NodeType.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeType _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        Object.defineProperty(NodeType.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeType _localSsdGb.
                         * @member {"localSsdGb"|undefined} _localSsdGb
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        Object.defineProperty(NodeType.prototype, "_localSsdGb", {
                            get: $util.oneOfGetter($oneOfFields = ["localSsdGb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeType _memoryMb.
                         * @member {"memoryMb"|undefined} _memoryMb
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        Object.defineProperty(NodeType.prototype, "_memoryMb", {
                            get: $util.oneOfGetter($oneOfFields = ["memoryMb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeType _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        Object.defineProperty(NodeType.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeType _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        Object.defineProperty(NodeType.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeType _zone.
                         * @member {"zone"|undefined} _zone
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         */
                        Object.defineProperty(NodeType.prototype, "_zone", {
                            get: $util.oneOfGetter($oneOfFields = ["zone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NodeType instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeType
                         * @static
                         * @param {google.cloud.compute.v1.INodeType=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NodeType} NodeType instance
                         */
                        NodeType.create = function create(properties) {
                            return new NodeType(properties);
                        };
    
                        /**
                         * Encodes the specified NodeType message. Does not implicitly {@link google.cloud.compute.v1.NodeType.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NodeType
                         * @static
                         * @param {google.cloud.compute.v1.INodeType} message NodeType message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeType.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.memoryMb != null && Object.hasOwnProperty.call(message, "memoryMb"))
                                writer.uint32(/* id 116001171, wireType 0 =*/928009368).int32(message.memoryMb);
                            if (message.localSsdGb != null && Object.hasOwnProperty.call(message, "localSsdGb"))
                                writer.uint32(/* id 329237578, wireType 0 =*/2633900624).int32(message.localSsdGb);
                            if (message.guestCpus != null && Object.hasOwnProperty.call(message, "guestCpus"))
                                writer.uint32(/* id 393356754, wireType 0 =*/3146854032).int32(message.guestCpus);
                            if (message.cpuPlatform != null && Object.hasOwnProperty.call(message, "cpuPlatform"))
                                writer.uint32(/* id 410285354, wireType 2 =*/3282282834).string(message.cpuPlatform);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                                $root.google.cloud.compute.v1.DeprecationStatus.encode(message.deprecated, writer.uint32(/* id 515138995, wireType 2 =*/4121111962).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NodeType message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NodeType.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NodeType
                         * @static
                         * @param {google.cloud.compute.v1.INodeType} message NodeType message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeType.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NodeType message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NodeType
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NodeType} NodeType
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeType.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NodeType();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 410285354: {
                                        message.cpuPlatform = reader.string();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 515138995: {
                                        message.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 393356754: {
                                        message.guestCpus = reader.int32();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 329237578: {
                                        message.localSsdGb = reader.int32();
                                        break;
                                    }
                                case 116001171: {
                                        message.memoryMb = reader.int32();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NodeType message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NodeType
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NodeType} NodeType
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeType.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NodeType message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NodeType
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NodeType.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.cpuPlatform != null && message.hasOwnProperty("cpuPlatform")) {
                                properties._cpuPlatform = 1;
                                if (!$util.isString(message.cpuPlatform))
                                    return "cpuPlatform: string expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.deprecated != null && message.hasOwnProperty("deprecated")) {
                                properties._deprecated = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.DeprecationStatus.verify(message.deprecated);
                                    if (error)
                                        return "deprecated." + error;
                                }
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.guestCpus != null && message.hasOwnProperty("guestCpus")) {
                                properties._guestCpus = 1;
                                if (!$util.isInteger(message.guestCpus))
                                    return "guestCpus: integer expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.localSsdGb != null && message.hasOwnProperty("localSsdGb")) {
                                properties._localSsdGb = 1;
                                if (!$util.isInteger(message.localSsdGb))
                                    return "localSsdGb: integer expected";
                            }
                            if (message.memoryMb != null && message.hasOwnProperty("memoryMb")) {
                                properties._memoryMb = 1;
                                if (!$util.isInteger(message.memoryMb))
                                    return "memoryMb: integer expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                properties._zone = 1;
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NodeType message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NodeType
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NodeType} NodeType
                         */
                        NodeType.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NodeType)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NodeType();
                            if (object.cpuPlatform != null)
                                message.cpuPlatform = String(object.cpuPlatform);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.deprecated != null) {
                                if (typeof object.deprecated !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeType.deprecated: object expected");
                                message.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.fromObject(object.deprecated);
                            }
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.guestCpus != null)
                                message.guestCpus = object.guestCpus | 0;
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.localSsdGb != null)
                                message.localSsdGb = object.localSsdGb | 0;
                            if (object.memoryMb != null)
                                message.memoryMb = object.memoryMb | 0;
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NodeType message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NodeType
                         * @static
                         * @param {google.cloud.compute.v1.NodeType} message NodeType
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NodeType.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                object.zone = message.zone;
                                if (options.oneofs)
                                    object._zone = "zone";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.memoryMb != null && message.hasOwnProperty("memoryMb")) {
                                object.memoryMb = message.memoryMb;
                                if (options.oneofs)
                                    object._memoryMb = "memoryMb";
                            }
                            if (message.localSsdGb != null && message.hasOwnProperty("localSsdGb")) {
                                object.localSsdGb = message.localSsdGb;
                                if (options.oneofs)
                                    object._localSsdGb = "localSsdGb";
                            }
                            if (message.guestCpus != null && message.hasOwnProperty("guestCpus")) {
                                object.guestCpus = message.guestCpus;
                                if (options.oneofs)
                                    object._guestCpus = "guestCpus";
                            }
                            if (message.cpuPlatform != null && message.hasOwnProperty("cpuPlatform")) {
                                object.cpuPlatform = message.cpuPlatform;
                                if (options.oneofs)
                                    object._cpuPlatform = "cpuPlatform";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.deprecated != null && message.hasOwnProperty("deprecated")) {
                                object.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.toObject(message.deprecated, options);
                                if (options.oneofs)
                                    object._deprecated = "deprecated";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NodeType to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NodeType
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NodeType.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NodeType
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NodeType
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NodeType.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NodeType";
                        };
    
                        return NodeType;
                    })();
    
                    v1.NodeTypeAggregatedList = (function() {
    
                        /**
                         * Properties of a NodeTypeAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface INodeTypeAggregatedList
                         * @property {string|null} [id] NodeTypeAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.INodeTypesScopedList>|null} [items] NodeTypeAggregatedList items
                         * @property {string|null} [kind] NodeTypeAggregatedList kind
                         * @property {string|null} [nextPageToken] NodeTypeAggregatedList nextPageToken
                         * @property {string|null} [selfLink] NodeTypeAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] NodeTypeAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] NodeTypeAggregatedList warning
                         */
    
                        /**
                         * Constructs a new NodeTypeAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeTypeAggregatedList.
                         * @implements INodeTypeAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.INodeTypeAggregatedList=} [properties] Properties to set
                         */
                        function NodeTypeAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NodeTypeAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @instance
                         */
                        NodeTypeAggregatedList.prototype.id = null;
    
                        /**
                         * NodeTypeAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.INodeTypesScopedList>} items
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @instance
                         */
                        NodeTypeAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * NodeTypeAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @instance
                         */
                        NodeTypeAggregatedList.prototype.kind = null;
    
                        /**
                         * NodeTypeAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @instance
                         */
                        NodeTypeAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * NodeTypeAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @instance
                         */
                        NodeTypeAggregatedList.prototype.selfLink = null;
    
                        /**
                         * NodeTypeAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @instance
                         */
                        NodeTypeAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * NodeTypeAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @instance
                         */
                        NodeTypeAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NodeTypeAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NodeTypeAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTypeAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NodeTypeAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTypeAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NodeTypeAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTypeAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NodeTypeAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTypeAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @instance
                         */
                        Object.defineProperty(NodeTypeAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NodeTypeAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.INodeTypeAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NodeTypeAggregatedList} NodeTypeAggregatedList instance
                         */
                        NodeTypeAggregatedList.create = function create(properties) {
                            return new NodeTypeAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified NodeTypeAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.NodeTypeAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.INodeTypeAggregatedList} message NodeTypeAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeTypeAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.NodeTypesScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NodeTypeAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NodeTypeAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.INodeTypeAggregatedList} message NodeTypeAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeTypeAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NodeTypeAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NodeTypeAggregatedList} NodeTypeAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeTypeAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NodeTypeAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.NodeTypesScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NodeTypeAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NodeTypeAggregatedList} NodeTypeAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeTypeAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NodeTypeAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NodeTypeAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NodeTypesScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NodeTypeAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NodeTypeAggregatedList} NodeTypeAggregatedList
                         */
                        NodeTypeAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NodeTypeAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NodeTypeAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeTypeAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NodeTypeAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.NodeTypesScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.NodeTypeAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeTypeAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NodeTypeAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.NodeTypeAggregatedList} message NodeTypeAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NodeTypeAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.NodeTypesScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NodeTypeAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NodeTypeAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NodeTypeAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NodeTypeAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NodeTypeAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NodeTypeAggregatedList";
                        };
    
                        return NodeTypeAggregatedList;
                    })();
    
                    v1.NodeTypeList = (function() {
    
                        /**
                         * Properties of a NodeTypeList.
                         * @memberof google.cloud.compute.v1
                         * @interface INodeTypeList
                         * @property {string|null} [id] NodeTypeList id
                         * @property {Array.<google.cloud.compute.v1.INodeType>|null} [items] NodeTypeList items
                         * @property {string|null} [kind] NodeTypeList kind
                         * @property {string|null} [nextPageToken] NodeTypeList nextPageToken
                         * @property {string|null} [selfLink] NodeTypeList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] NodeTypeList warning
                         */
    
                        /**
                         * Constructs a new NodeTypeList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeTypeList.
                         * @implements INodeTypeList
                         * @constructor
                         * @param {google.cloud.compute.v1.INodeTypeList=} [properties] Properties to set
                         */
                        function NodeTypeList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NodeTypeList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @instance
                         */
                        NodeTypeList.prototype.id = null;
    
                        /**
                         * NodeTypeList items.
                         * @member {Array.<google.cloud.compute.v1.INodeType>} items
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @instance
                         */
                        NodeTypeList.prototype.items = $util.emptyArray;
    
                        /**
                         * NodeTypeList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @instance
                         */
                        NodeTypeList.prototype.kind = null;
    
                        /**
                         * NodeTypeList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @instance
                         */
                        NodeTypeList.prototype.nextPageToken = null;
    
                        /**
                         * NodeTypeList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @instance
                         */
                        NodeTypeList.prototype.selfLink = null;
    
                        /**
                         * NodeTypeList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @instance
                         */
                        NodeTypeList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NodeTypeList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @instance
                         */
                        Object.defineProperty(NodeTypeList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTypeList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @instance
                         */
                        Object.defineProperty(NodeTypeList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTypeList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @instance
                         */
                        Object.defineProperty(NodeTypeList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTypeList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @instance
                         */
                        Object.defineProperty(NodeTypeList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NodeTypeList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @instance
                         */
                        Object.defineProperty(NodeTypeList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NodeTypeList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @static
                         * @param {google.cloud.compute.v1.INodeTypeList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NodeTypeList} NodeTypeList instance
                         */
                        NodeTypeList.create = function create(properties) {
                            return new NodeTypeList(properties);
                        };
    
                        /**
                         * Encodes the specified NodeTypeList message. Does not implicitly {@link google.cloud.compute.v1.NodeTypeList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @static
                         * @param {google.cloud.compute.v1.INodeTypeList} message NodeTypeList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeTypeList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.NodeType.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NodeTypeList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NodeTypeList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @static
                         * @param {google.cloud.compute.v1.INodeTypeList} message NodeTypeList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeTypeList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NodeTypeList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NodeTypeList} NodeTypeList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeTypeList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NodeTypeList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.NodeType.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NodeTypeList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NodeTypeList} NodeTypeList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeTypeList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NodeTypeList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NodeTypeList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NodeType.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NodeTypeList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NodeTypeList} NodeTypeList
                         */
                        NodeTypeList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NodeTypeList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NodeTypeList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.NodeTypeList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NodeTypeList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.NodeType.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeTypeList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NodeTypeList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @static
                         * @param {google.cloud.compute.v1.NodeTypeList} message NodeTypeList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NodeTypeList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.NodeType.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NodeTypeList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NodeTypeList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NodeTypeList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NodeTypeList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NodeTypeList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NodeTypeList";
                        };
    
                        return NodeTypeList;
                    })();
    
                    v1.NodeTypesScopedList = (function() {
    
                        /**
                         * Properties of a NodeTypesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface INodeTypesScopedList
                         * @property {Array.<google.cloud.compute.v1.INodeType>|null} [nodeTypes] NodeTypesScopedList nodeTypes
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] NodeTypesScopedList warning
                         */
    
                        /**
                         * Constructs a new NodeTypesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeTypesScopedList.
                         * @implements INodeTypesScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.INodeTypesScopedList=} [properties] Properties to set
                         */
                        function NodeTypesScopedList(properties) {
                            this.nodeTypes = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NodeTypesScopedList nodeTypes.
                         * @member {Array.<google.cloud.compute.v1.INodeType>} nodeTypes
                         * @memberof google.cloud.compute.v1.NodeTypesScopedList
                         * @instance
                         */
                        NodeTypesScopedList.prototype.nodeTypes = $util.emptyArray;
    
                        /**
                         * NodeTypesScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.NodeTypesScopedList
                         * @instance
                         */
                        NodeTypesScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NodeTypesScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.NodeTypesScopedList
                         * @instance
                         */
                        Object.defineProperty(NodeTypesScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NodeTypesScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeTypesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.INodeTypesScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NodeTypesScopedList} NodeTypesScopedList instance
                         */
                        NodeTypesScopedList.create = function create(properties) {
                            return new NodeTypesScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified NodeTypesScopedList message. Does not implicitly {@link google.cloud.compute.v1.NodeTypesScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NodeTypesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.INodeTypesScopedList} message NodeTypesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeTypesScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nodeTypes != null && message.nodeTypes.length)
                                for (var i = 0; i < message.nodeTypes.length; ++i)
                                    $root.google.cloud.compute.v1.NodeType.encode(message.nodeTypes[i], writer.uint32(/* id 482172924, wireType 2 =*/3857383394).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NodeTypesScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NodeTypesScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NodeTypesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.INodeTypesScopedList} message NodeTypesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NodeTypesScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NodeTypesScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NodeTypesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NodeTypesScopedList} NodeTypesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeTypesScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NodeTypesScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 482172924: {
                                        if (!(message.nodeTypes && message.nodeTypes.length))
                                            message.nodeTypes = [];
                                        message.nodeTypes.push($root.google.cloud.compute.v1.NodeType.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NodeTypesScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NodeTypesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NodeTypesScopedList} NodeTypesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NodeTypesScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NodeTypesScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NodeTypesScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NodeTypesScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.nodeTypes != null && message.hasOwnProperty("nodeTypes")) {
                                if (!Array.isArray(message.nodeTypes))
                                    return "nodeTypes: array expected";
                                for (var i = 0; i < message.nodeTypes.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NodeType.verify(message.nodeTypes[i]);
                                    if (error)
                                        return "nodeTypes." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NodeTypesScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NodeTypesScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NodeTypesScopedList} NodeTypesScopedList
                         */
                        NodeTypesScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NodeTypesScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NodeTypesScopedList();
                            if (object.nodeTypes) {
                                if (!Array.isArray(object.nodeTypes))
                                    throw TypeError(".google.cloud.compute.v1.NodeTypesScopedList.nodeTypes: array expected");
                                message.nodeTypes = [];
                                for (var i = 0; i < object.nodeTypes.length; ++i) {
                                    if (typeof object.nodeTypes[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NodeTypesScopedList.nodeTypes: object expected");
                                    message.nodeTypes[i] = $root.google.cloud.compute.v1.NodeType.fromObject(object.nodeTypes[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NodeTypesScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NodeTypesScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NodeTypesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.NodeTypesScopedList} message NodeTypesScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NodeTypesScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.nodeTypes = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nodeTypes && message.nodeTypes.length) {
                                object.nodeTypes = [];
                                for (var j = 0; j < message.nodeTypes.length; ++j)
                                    object.nodeTypes[j] = $root.google.cloud.compute.v1.NodeType.toObject(message.nodeTypes[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NodeTypesScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NodeTypesScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NodeTypesScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NodeTypesScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NodeTypesScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NodeTypesScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NodeTypesScopedList";
                        };
    
                        return NodeTypesScopedList;
                    })();
    
                    v1.NotificationEndpoint = (function() {
    
                        /**
                         * Properties of a NotificationEndpoint.
                         * @memberof google.cloud.compute.v1
                         * @interface INotificationEndpoint
                         * @property {string|null} [creationTimestamp] NotificationEndpoint creationTimestamp
                         * @property {string|null} [description] NotificationEndpoint description
                         * @property {google.cloud.compute.v1.INotificationEndpointGrpcSettings|null} [grpcSettings] NotificationEndpoint grpcSettings
                         * @property {number|Long|null} [id] NotificationEndpoint id
                         * @property {string|null} [kind] NotificationEndpoint kind
                         * @property {string|null} [name] NotificationEndpoint name
                         * @property {string|null} [region] NotificationEndpoint region
                         * @property {string|null} [selfLink] NotificationEndpoint selfLink
                         */
    
                        /**
                         * Constructs a new NotificationEndpoint.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NotificationEndpoint.
                         * @implements INotificationEndpoint
                         * @constructor
                         * @param {google.cloud.compute.v1.INotificationEndpoint=} [properties] Properties to set
                         */
                        function NotificationEndpoint(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NotificationEndpoint creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @instance
                         */
                        NotificationEndpoint.prototype.creationTimestamp = null;
    
                        /**
                         * NotificationEndpoint description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @instance
                         */
                        NotificationEndpoint.prototype.description = null;
    
                        /**
                         * NotificationEndpoint grpcSettings.
                         * @member {google.cloud.compute.v1.INotificationEndpointGrpcSettings|null|undefined} grpcSettings
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @instance
                         */
                        NotificationEndpoint.prototype.grpcSettings = null;
    
                        /**
                         * NotificationEndpoint id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @instance
                         */
                        NotificationEndpoint.prototype.id = null;
    
                        /**
                         * NotificationEndpoint kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @instance
                         */
                        NotificationEndpoint.prototype.kind = null;
    
                        /**
                         * NotificationEndpoint name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @instance
                         */
                        NotificationEndpoint.prototype.name = null;
    
                        /**
                         * NotificationEndpoint region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @instance
                         */
                        NotificationEndpoint.prototype.region = null;
    
                        /**
                         * NotificationEndpoint selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @instance
                         */
                        NotificationEndpoint.prototype.selfLink = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NotificationEndpoint _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @instance
                         */
                        Object.defineProperty(NotificationEndpoint.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NotificationEndpoint _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @instance
                         */
                        Object.defineProperty(NotificationEndpoint.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NotificationEndpoint _grpcSettings.
                         * @member {"grpcSettings"|undefined} _grpcSettings
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @instance
                         */
                        Object.defineProperty(NotificationEndpoint.prototype, "_grpcSettings", {
                            get: $util.oneOfGetter($oneOfFields = ["grpcSettings"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NotificationEndpoint _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @instance
                         */
                        Object.defineProperty(NotificationEndpoint.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NotificationEndpoint _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @instance
                         */
                        Object.defineProperty(NotificationEndpoint.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NotificationEndpoint _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @instance
                         */
                        Object.defineProperty(NotificationEndpoint.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NotificationEndpoint _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @instance
                         */
                        Object.defineProperty(NotificationEndpoint.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NotificationEndpoint _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @instance
                         */
                        Object.defineProperty(NotificationEndpoint.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NotificationEndpoint instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @static
                         * @param {google.cloud.compute.v1.INotificationEndpoint=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NotificationEndpoint} NotificationEndpoint instance
                         */
                        NotificationEndpoint.create = function create(properties) {
                            return new NotificationEndpoint(properties);
                        };
    
                        /**
                         * Encodes the specified NotificationEndpoint message. Does not implicitly {@link google.cloud.compute.v1.NotificationEndpoint.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @static
                         * @param {google.cloud.compute.v1.INotificationEndpoint} message NotificationEndpoint message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NotificationEndpoint.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.grpcSettings != null && Object.hasOwnProperty.call(message, "grpcSettings"))
                                $root.google.cloud.compute.v1.NotificationEndpointGrpcSettings.encode(message.grpcSettings, writer.uint32(/* id 456139556, wireType 2 =*/3649116450).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NotificationEndpoint message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NotificationEndpoint.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @static
                         * @param {google.cloud.compute.v1.INotificationEndpoint} message NotificationEndpoint message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NotificationEndpoint.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NotificationEndpoint message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NotificationEndpoint} NotificationEndpoint
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NotificationEndpoint.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NotificationEndpoint();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 456139556: {
                                        message.grpcSettings = $root.google.cloud.compute.v1.NotificationEndpointGrpcSettings.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NotificationEndpoint message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NotificationEndpoint} NotificationEndpoint
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NotificationEndpoint.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NotificationEndpoint message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NotificationEndpoint.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.grpcSettings != null && message.hasOwnProperty("grpcSettings")) {
                                properties._grpcSettings = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.NotificationEndpointGrpcSettings.verify(message.grpcSettings);
                                    if (error)
                                        return "grpcSettings." + error;
                                }
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NotificationEndpoint message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NotificationEndpoint} NotificationEndpoint
                         */
                        NotificationEndpoint.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NotificationEndpoint)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NotificationEndpoint();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.grpcSettings != null) {
                                if (typeof object.grpcSettings !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NotificationEndpoint.grpcSettings: object expected");
                                message.grpcSettings = $root.google.cloud.compute.v1.NotificationEndpointGrpcSettings.fromObject(object.grpcSettings);
                            }
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NotificationEndpoint message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @static
                         * @param {google.cloud.compute.v1.NotificationEndpoint} message NotificationEndpoint
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NotificationEndpoint.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.grpcSettings != null && message.hasOwnProperty("grpcSettings")) {
                                object.grpcSettings = $root.google.cloud.compute.v1.NotificationEndpointGrpcSettings.toObject(message.grpcSettings, options);
                                if (options.oneofs)
                                    object._grpcSettings = "grpcSettings";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NotificationEndpoint to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NotificationEndpoint.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NotificationEndpoint
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NotificationEndpoint
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NotificationEndpoint.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NotificationEndpoint";
                        };
    
                        return NotificationEndpoint;
                    })();
    
                    v1.NotificationEndpointGrpcSettings = (function() {
    
                        /**
                         * Properties of a NotificationEndpointGrpcSettings.
                         * @memberof google.cloud.compute.v1
                         * @interface INotificationEndpointGrpcSettings
                         * @property {string|null} [authority] NotificationEndpointGrpcSettings authority
                         * @property {string|null} [endpoint] NotificationEndpointGrpcSettings endpoint
                         * @property {string|null} [payloadName] NotificationEndpointGrpcSettings payloadName
                         * @property {google.cloud.compute.v1.IDuration|null} [resendInterval] NotificationEndpointGrpcSettings resendInterval
                         * @property {number|null} [retryDurationSec] NotificationEndpointGrpcSettings retryDurationSec
                         */
    
                        /**
                         * Constructs a new NotificationEndpointGrpcSettings.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NotificationEndpointGrpcSettings.
                         * @implements INotificationEndpointGrpcSettings
                         * @constructor
                         * @param {google.cloud.compute.v1.INotificationEndpointGrpcSettings=} [properties] Properties to set
                         */
                        function NotificationEndpointGrpcSettings(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NotificationEndpointGrpcSettings authority.
                         * @member {string|null|undefined} authority
                         * @memberof google.cloud.compute.v1.NotificationEndpointGrpcSettings
                         * @instance
                         */
                        NotificationEndpointGrpcSettings.prototype.authority = null;
    
                        /**
                         * NotificationEndpointGrpcSettings endpoint.
                         * @member {string|null|undefined} endpoint
                         * @memberof google.cloud.compute.v1.NotificationEndpointGrpcSettings
                         * @instance
                         */
                        NotificationEndpointGrpcSettings.prototype.endpoint = null;
    
                        /**
                         * NotificationEndpointGrpcSettings payloadName.
                         * @member {string|null|undefined} payloadName
                         * @memberof google.cloud.compute.v1.NotificationEndpointGrpcSettings
                         * @instance
                         */
                        NotificationEndpointGrpcSettings.prototype.payloadName = null;
    
                        /**
                         * NotificationEndpointGrpcSettings resendInterval.
                         * @member {google.cloud.compute.v1.IDuration|null|undefined} resendInterval
                         * @memberof google.cloud.compute.v1.NotificationEndpointGrpcSettings
                         * @instance
                         */
                        NotificationEndpointGrpcSettings.prototype.resendInterval = null;
    
                        /**
                         * NotificationEndpointGrpcSettings retryDurationSec.
                         * @member {number|null|undefined} retryDurationSec
                         * @memberof google.cloud.compute.v1.NotificationEndpointGrpcSettings
                         * @instance
                         */
                        NotificationEndpointGrpcSettings.prototype.retryDurationSec = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NotificationEndpointGrpcSettings _authority.
                         * @member {"authority"|undefined} _authority
                         * @memberof google.cloud.compute.v1.NotificationEndpointGrpcSettings
                         * @instance
                         */
                        Object.defineProperty(NotificationEndpointGrpcSettings.prototype, "_authority", {
                            get: $util.oneOfGetter($oneOfFields = ["authority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NotificationEndpointGrpcSettings _endpoint.
                         * @member {"endpoint"|undefined} _endpoint
                         * @memberof google.cloud.compute.v1.NotificationEndpointGrpcSettings
                         * @instance
                         */
                        Object.defineProperty(NotificationEndpointGrpcSettings.prototype, "_endpoint", {
                            get: $util.oneOfGetter($oneOfFields = ["endpoint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NotificationEndpointGrpcSettings _payloadName.
                         * @member {"payloadName"|undefined} _payloadName
                         * @memberof google.cloud.compute.v1.NotificationEndpointGrpcSettings
                         * @instance
                         */
                        Object.defineProperty(NotificationEndpointGrpcSettings.prototype, "_payloadName", {
                            get: $util.oneOfGetter($oneOfFields = ["payloadName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NotificationEndpointGrpcSettings _resendInterval.
                         * @member {"resendInterval"|undefined} _resendInterval
                         * @memberof google.cloud.compute.v1.NotificationEndpointGrpcSettings
                         * @instance
                         */
                        Object.defineProperty(NotificationEndpointGrpcSettings.prototype, "_resendInterval", {
                            get: $util.oneOfGetter($oneOfFields = ["resendInterval"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NotificationEndpointGrpcSettings _retryDurationSec.
                         * @member {"retryDurationSec"|undefined} _retryDurationSec
                         * @memberof google.cloud.compute.v1.NotificationEndpointGrpcSettings
                         * @instance
                         */
                        Object.defineProperty(NotificationEndpointGrpcSettings.prototype, "_retryDurationSec", {
                            get: $util.oneOfGetter($oneOfFields = ["retryDurationSec"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NotificationEndpointGrpcSettings instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NotificationEndpointGrpcSettings
                         * @static
                         * @param {google.cloud.compute.v1.INotificationEndpointGrpcSettings=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NotificationEndpointGrpcSettings} NotificationEndpointGrpcSettings instance
                         */
                        NotificationEndpointGrpcSettings.create = function create(properties) {
                            return new NotificationEndpointGrpcSettings(properties);
                        };
    
                        /**
                         * Encodes the specified NotificationEndpointGrpcSettings message. Does not implicitly {@link google.cloud.compute.v1.NotificationEndpointGrpcSettings.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NotificationEndpointGrpcSettings
                         * @static
                         * @param {google.cloud.compute.v1.INotificationEndpointGrpcSettings} message NotificationEndpointGrpcSettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NotificationEndpointGrpcSettings.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.retryDurationSec != null && Object.hasOwnProperty.call(message, "retryDurationSec"))
                                writer.uint32(/* id 115681117, wireType 0 =*/925448936).uint32(message.retryDurationSec);
                            if (message.endpoint != null && Object.hasOwnProperty.call(message, "endpoint"))
                                writer.uint32(/* id 130489749, wireType 2 =*/1043917994).string(message.endpoint);
                            if (message.payloadName != null && Object.hasOwnProperty.call(message, "payloadName"))
                                writer.uint32(/* id 300358300, wireType 2 =*/2402866402).string(message.payloadName);
                            if (message.authority != null && Object.hasOwnProperty.call(message, "authority"))
                                writer.uint32(/* id 401868611, wireType 2 =*/3214948890).string(message.authority);
                            if (message.resendInterval != null && Object.hasOwnProperty.call(message, "resendInterval"))
                                $root.google.cloud.compute.v1.Duration.encode(message.resendInterval, writer.uint32(/* id 478288969, wireType 2 =*/3826311754).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NotificationEndpointGrpcSettings message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NotificationEndpointGrpcSettings.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NotificationEndpointGrpcSettings
                         * @static
                         * @param {google.cloud.compute.v1.INotificationEndpointGrpcSettings} message NotificationEndpointGrpcSettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NotificationEndpointGrpcSettings.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NotificationEndpointGrpcSettings message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NotificationEndpointGrpcSettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NotificationEndpointGrpcSettings} NotificationEndpointGrpcSettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NotificationEndpointGrpcSettings.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NotificationEndpointGrpcSettings();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 401868611: {
                                        message.authority = reader.string();
                                        break;
                                    }
                                case 130489749: {
                                        message.endpoint = reader.string();
                                        break;
                                    }
                                case 300358300: {
                                        message.payloadName = reader.string();
                                        break;
                                    }
                                case 478288969: {
                                        message.resendInterval = $root.google.cloud.compute.v1.Duration.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 115681117: {
                                        message.retryDurationSec = reader.uint32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NotificationEndpointGrpcSettings message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NotificationEndpointGrpcSettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NotificationEndpointGrpcSettings} NotificationEndpointGrpcSettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NotificationEndpointGrpcSettings.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NotificationEndpointGrpcSettings message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NotificationEndpointGrpcSettings
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NotificationEndpointGrpcSettings.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.authority != null && message.hasOwnProperty("authority")) {
                                properties._authority = 1;
                                if (!$util.isString(message.authority))
                                    return "authority: string expected";
                            }
                            if (message.endpoint != null && message.hasOwnProperty("endpoint")) {
                                properties._endpoint = 1;
                                if (!$util.isString(message.endpoint))
                                    return "endpoint: string expected";
                            }
                            if (message.payloadName != null && message.hasOwnProperty("payloadName")) {
                                properties._payloadName = 1;
                                if (!$util.isString(message.payloadName))
                                    return "payloadName: string expected";
                            }
                            if (message.resendInterval != null && message.hasOwnProperty("resendInterval")) {
                                properties._resendInterval = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Duration.verify(message.resendInterval);
                                    if (error)
                                        return "resendInterval." + error;
                                }
                            }
                            if (message.retryDurationSec != null && message.hasOwnProperty("retryDurationSec")) {
                                properties._retryDurationSec = 1;
                                if (!$util.isInteger(message.retryDurationSec))
                                    return "retryDurationSec: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NotificationEndpointGrpcSettings message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NotificationEndpointGrpcSettings
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NotificationEndpointGrpcSettings} NotificationEndpointGrpcSettings
                         */
                        NotificationEndpointGrpcSettings.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NotificationEndpointGrpcSettings)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NotificationEndpointGrpcSettings();
                            if (object.authority != null)
                                message.authority = String(object.authority);
                            if (object.endpoint != null)
                                message.endpoint = String(object.endpoint);
                            if (object.payloadName != null)
                                message.payloadName = String(object.payloadName);
                            if (object.resendInterval != null) {
                                if (typeof object.resendInterval !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NotificationEndpointGrpcSettings.resendInterval: object expected");
                                message.resendInterval = $root.google.cloud.compute.v1.Duration.fromObject(object.resendInterval);
                            }
                            if (object.retryDurationSec != null)
                                message.retryDurationSec = object.retryDurationSec >>> 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NotificationEndpointGrpcSettings message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NotificationEndpointGrpcSettings
                         * @static
                         * @param {google.cloud.compute.v1.NotificationEndpointGrpcSettings} message NotificationEndpointGrpcSettings
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NotificationEndpointGrpcSettings.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.retryDurationSec != null && message.hasOwnProperty("retryDurationSec")) {
                                object.retryDurationSec = message.retryDurationSec;
                                if (options.oneofs)
                                    object._retryDurationSec = "retryDurationSec";
                            }
                            if (message.endpoint != null && message.hasOwnProperty("endpoint")) {
                                object.endpoint = message.endpoint;
                                if (options.oneofs)
                                    object._endpoint = "endpoint";
                            }
                            if (message.payloadName != null && message.hasOwnProperty("payloadName")) {
                                object.payloadName = message.payloadName;
                                if (options.oneofs)
                                    object._payloadName = "payloadName";
                            }
                            if (message.authority != null && message.hasOwnProperty("authority")) {
                                object.authority = message.authority;
                                if (options.oneofs)
                                    object._authority = "authority";
                            }
                            if (message.resendInterval != null && message.hasOwnProperty("resendInterval")) {
                                object.resendInterval = $root.google.cloud.compute.v1.Duration.toObject(message.resendInterval, options);
                                if (options.oneofs)
                                    object._resendInterval = "resendInterval";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NotificationEndpointGrpcSettings to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NotificationEndpointGrpcSettings
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NotificationEndpointGrpcSettings.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NotificationEndpointGrpcSettings
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NotificationEndpointGrpcSettings
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NotificationEndpointGrpcSettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NotificationEndpointGrpcSettings";
                        };
    
                        return NotificationEndpointGrpcSettings;
                    })();
    
                    v1.NotificationEndpointList = (function() {
    
                        /**
                         * Properties of a NotificationEndpointList.
                         * @memberof google.cloud.compute.v1
                         * @interface INotificationEndpointList
                         * @property {string|null} [id] NotificationEndpointList id
                         * @property {Array.<google.cloud.compute.v1.INotificationEndpoint>|null} [items] NotificationEndpointList items
                         * @property {string|null} [kind] NotificationEndpointList kind
                         * @property {string|null} [nextPageToken] NotificationEndpointList nextPageToken
                         * @property {string|null} [selfLink] NotificationEndpointList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] NotificationEndpointList warning
                         */
    
                        /**
                         * Constructs a new NotificationEndpointList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NotificationEndpointList.
                         * @implements INotificationEndpointList
                         * @constructor
                         * @param {google.cloud.compute.v1.INotificationEndpointList=} [properties] Properties to set
                         */
                        function NotificationEndpointList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * NotificationEndpointList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @instance
                         */
                        NotificationEndpointList.prototype.id = null;
    
                        /**
                         * NotificationEndpointList items.
                         * @member {Array.<google.cloud.compute.v1.INotificationEndpoint>} items
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @instance
                         */
                        NotificationEndpointList.prototype.items = $util.emptyArray;
    
                        /**
                         * NotificationEndpointList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @instance
                         */
                        NotificationEndpointList.prototype.kind = null;
    
                        /**
                         * NotificationEndpointList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @instance
                         */
                        NotificationEndpointList.prototype.nextPageToken = null;
    
                        /**
                         * NotificationEndpointList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @instance
                         */
                        NotificationEndpointList.prototype.selfLink = null;
    
                        /**
                         * NotificationEndpointList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @instance
                         */
                        NotificationEndpointList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * NotificationEndpointList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @instance
                         */
                        Object.defineProperty(NotificationEndpointList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NotificationEndpointList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @instance
                         */
                        Object.defineProperty(NotificationEndpointList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NotificationEndpointList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @instance
                         */
                        Object.defineProperty(NotificationEndpointList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NotificationEndpointList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @instance
                         */
                        Object.defineProperty(NotificationEndpointList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * NotificationEndpointList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @instance
                         */
                        Object.defineProperty(NotificationEndpointList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new NotificationEndpointList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @static
                         * @param {google.cloud.compute.v1.INotificationEndpointList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.NotificationEndpointList} NotificationEndpointList instance
                         */
                        NotificationEndpointList.create = function create(properties) {
                            return new NotificationEndpointList(properties);
                        };
    
                        /**
                         * Encodes the specified NotificationEndpointList message. Does not implicitly {@link google.cloud.compute.v1.NotificationEndpointList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @static
                         * @param {google.cloud.compute.v1.INotificationEndpointList} message NotificationEndpointList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NotificationEndpointList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.NotificationEndpoint.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified NotificationEndpointList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.NotificationEndpointList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @static
                         * @param {google.cloud.compute.v1.INotificationEndpointList} message NotificationEndpointList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        NotificationEndpointList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a NotificationEndpointList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.NotificationEndpointList} NotificationEndpointList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NotificationEndpointList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.NotificationEndpointList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.NotificationEndpoint.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a NotificationEndpointList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.NotificationEndpointList} NotificationEndpointList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        NotificationEndpointList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a NotificationEndpointList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        NotificationEndpointList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NotificationEndpoint.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a NotificationEndpointList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.NotificationEndpointList} NotificationEndpointList
                         */
                        NotificationEndpointList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.NotificationEndpointList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.NotificationEndpointList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.NotificationEndpointList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.NotificationEndpointList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.NotificationEndpoint.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.NotificationEndpointList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a NotificationEndpointList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @static
                         * @param {google.cloud.compute.v1.NotificationEndpointList} message NotificationEndpointList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        NotificationEndpointList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.NotificationEndpoint.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this NotificationEndpointList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        NotificationEndpointList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for NotificationEndpointList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.NotificationEndpointList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        NotificationEndpointList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.NotificationEndpointList";
                        };
    
                        return NotificationEndpointList;
                    })();
    
                    v1.Operation = (function() {
    
                        /**
                         * Properties of an Operation.
                         * @memberof google.cloud.compute.v1
                         * @interface IOperation
                         * @property {string|null} [clientOperationId] Operation clientOperationId
                         * @property {string|null} [creationTimestamp] Operation creationTimestamp
                         * @property {string|null} [description] Operation description
                         * @property {string|null} [endTime] Operation endTime
                         * @property {google.cloud.compute.v1.IError|null} [error] Operation error
                         * @property {string|null} [httpErrorMessage] Operation httpErrorMessage
                         * @property {number|null} [httpErrorStatusCode] Operation httpErrorStatusCode
                         * @property {number|Long|null} [id] Operation id
                         * @property {string|null} [insertTime] Operation insertTime
                         * @property {string|null} [kind] Operation kind
                         * @property {string|null} [name] Operation name
                         * @property {string|null} [operationGroupId] Operation operationGroupId
                         * @property {string|null} [operationType] Operation operationType
                         * @property {number|null} [progress] Operation progress
                         * @property {string|null} [region] Operation region
                         * @property {string|null} [selfLink] Operation selfLink
                         * @property {string|null} [startTime] Operation startTime
                         * @property {google.cloud.compute.v1.Operation.Status|null} [status] Operation status
                         * @property {string|null} [statusMessage] Operation statusMessage
                         * @property {number|Long|null} [targetId] Operation targetId
                         * @property {string|null} [targetLink] Operation targetLink
                         * @property {string|null} [user] Operation user
                         * @property {Array.<google.cloud.compute.v1.IWarnings>|null} [warnings] Operation warnings
                         * @property {string|null} [zone] Operation zone
                         */
    
                        /**
                         * Constructs a new Operation.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an Operation.
                         * @implements IOperation
                         * @constructor
                         * @param {google.cloud.compute.v1.IOperation=} [properties] Properties to set
                         */
                        function Operation(properties) {
                            this.warnings = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Operation clientOperationId.
                         * @member {string|null|undefined} clientOperationId
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.clientOperationId = null;
    
                        /**
                         * Operation creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.creationTimestamp = null;
    
                        /**
                         * Operation description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.description = null;
    
                        /**
                         * Operation endTime.
                         * @member {string|null|undefined} endTime
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.endTime = null;
    
                        /**
                         * Operation error.
                         * @member {google.cloud.compute.v1.IError|null|undefined} error
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.error = null;
    
                        /**
                         * Operation httpErrorMessage.
                         * @member {string|null|undefined} httpErrorMessage
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.httpErrorMessage = null;
    
                        /**
                         * Operation httpErrorStatusCode.
                         * @member {number|null|undefined} httpErrorStatusCode
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.httpErrorStatusCode = null;
    
                        /**
                         * Operation id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.id = null;
    
                        /**
                         * Operation insertTime.
                         * @member {string|null|undefined} insertTime
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.insertTime = null;
    
                        /**
                         * Operation kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.kind = null;
    
                        /**
                         * Operation name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.name = null;
    
                        /**
                         * Operation operationGroupId.
                         * @member {string|null|undefined} operationGroupId
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.operationGroupId = null;
    
                        /**
                         * Operation operationType.
                         * @member {string|null|undefined} operationType
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.operationType = null;
    
                        /**
                         * Operation progress.
                         * @member {number|null|undefined} progress
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.progress = null;
    
                        /**
                         * Operation region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.region = null;
    
                        /**
                         * Operation selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.selfLink = null;
    
                        /**
                         * Operation startTime.
                         * @member {string|null|undefined} startTime
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.startTime = null;
    
                        /**
                         * Operation status.
                         * @member {google.cloud.compute.v1.Operation.Status|null|undefined} status
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.status = null;
    
                        /**
                         * Operation statusMessage.
                         * @member {string|null|undefined} statusMessage
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.statusMessage = null;
    
                        /**
                         * Operation targetId.
                         * @member {number|Long|null|undefined} targetId
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.targetId = null;
    
                        /**
                         * Operation targetLink.
                         * @member {string|null|undefined} targetLink
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.targetLink = null;
    
                        /**
                         * Operation user.
                         * @member {string|null|undefined} user
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.user = null;
    
                        /**
                         * Operation warnings.
                         * @member {Array.<google.cloud.compute.v1.IWarnings>} warnings
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.warnings = $util.emptyArray;
    
                        /**
                         * Operation zone.
                         * @member {string|null|undefined} zone
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Operation.prototype.zone = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Operation _clientOperationId.
                         * @member {"clientOperationId"|undefined} _clientOperationId
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_clientOperationId", {
                            get: $util.oneOfGetter($oneOfFields = ["clientOperationId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _endTime.
                         * @member {"endTime"|undefined} _endTime
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_endTime", {
                            get: $util.oneOfGetter($oneOfFields = ["endTime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _error.
                         * @member {"error"|undefined} _error
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_error", {
                            get: $util.oneOfGetter($oneOfFields = ["error"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _httpErrorMessage.
                         * @member {"httpErrorMessage"|undefined} _httpErrorMessage
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_httpErrorMessage", {
                            get: $util.oneOfGetter($oneOfFields = ["httpErrorMessage"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _httpErrorStatusCode.
                         * @member {"httpErrorStatusCode"|undefined} _httpErrorStatusCode
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_httpErrorStatusCode", {
                            get: $util.oneOfGetter($oneOfFields = ["httpErrorStatusCode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _insertTime.
                         * @member {"insertTime"|undefined} _insertTime
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_insertTime", {
                            get: $util.oneOfGetter($oneOfFields = ["insertTime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _operationGroupId.
                         * @member {"operationGroupId"|undefined} _operationGroupId
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_operationGroupId", {
                            get: $util.oneOfGetter($oneOfFields = ["operationGroupId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _operationType.
                         * @member {"operationType"|undefined} _operationType
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_operationType", {
                            get: $util.oneOfGetter($oneOfFields = ["operationType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _progress.
                         * @member {"progress"|undefined} _progress
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_progress", {
                            get: $util.oneOfGetter($oneOfFields = ["progress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _startTime.
                         * @member {"startTime"|undefined} _startTime
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_startTime", {
                            get: $util.oneOfGetter($oneOfFields = ["startTime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _statusMessage.
                         * @member {"statusMessage"|undefined} _statusMessage
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_statusMessage", {
                            get: $util.oneOfGetter($oneOfFields = ["statusMessage"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _targetId.
                         * @member {"targetId"|undefined} _targetId
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_targetId", {
                            get: $util.oneOfGetter($oneOfFields = ["targetId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _targetLink.
                         * @member {"targetLink"|undefined} _targetLink
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_targetLink", {
                            get: $util.oneOfGetter($oneOfFields = ["targetLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _user.
                         * @member {"user"|undefined} _user
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_user", {
                            get: $util.oneOfGetter($oneOfFields = ["user"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _zone.
                         * @member {"zone"|undefined} _zone
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_zone", {
                            get: $util.oneOfGetter($oneOfFields = ["zone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Operation instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Operation
                         * @static
                         * @param {google.cloud.compute.v1.IOperation=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Operation} Operation instance
                         */
                        Operation.create = function create(properties) {
                            return new Operation(properties);
                        };
    
                        /**
                         * Encodes the specified Operation message. Does not implicitly {@link google.cloud.compute.v1.Operation.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Operation
                         * @static
                         * @param {google.cloud.compute.v1.IOperation} message Operation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Operation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.user != null && Object.hasOwnProperty.call(message, "user"))
                                writer.uint32(/* id 3599307, wireType 2 =*/28794458).string(message.user);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.startTime != null && Object.hasOwnProperty.call(message, "startTime"))
                                writer.uint32(/* id 37467274, wireType 2 =*/299738194).string(message.startTime);
                            if (message.operationGroupId != null && Object.hasOwnProperty.call(message, "operationGroupId"))
                                writer.uint32(/* id 40171187, wireType 2 =*/321369498).string(message.operationGroupId);
                            if (message.targetLink != null && Object.hasOwnProperty.call(message, "targetLink"))
                                writer.uint32(/* id 62671336, wireType 2 =*/501370690).string(message.targetLink);
                            if (message.progress != null && Object.hasOwnProperty.call(message, "progress"))
                                writer.uint32(/* id 72663597, wireType 0 =*/581308776).int32(message.progress);
                            if (message.error != null && Object.hasOwnProperty.call(message, "error"))
                                $root.google.cloud.compute.v1.Error.encode(message.error, writer.uint32(/* id 96784904, wireType 2 =*/774279234).fork()).ldelim();
                            if (message.endTime != null && Object.hasOwnProperty.call(message, "endTime"))
                                writer.uint32(/* id 114938801, wireType 2 =*/919510410).string(message.endTime);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.operationType != null && Object.hasOwnProperty.call(message, "operationType"))
                                writer.uint32(/* id 177650450, wireType 2 =*/1421203602).string(message.operationType);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 0 =*/1450082192).int32(message.status);
                            if (message.httpErrorMessage != null && Object.hasOwnProperty.call(message, "httpErrorMessage"))
                                writer.uint32(/* id 202521945, wireType 2 =*/1620175562).string(message.httpErrorMessage);
                            if (message.targetId != null && Object.hasOwnProperty.call(message, "targetId"))
                                writer.uint32(/* id 258165385, wireType 0 =*/2065323080).uint64(message.targetId);
                            if (message.clientOperationId != null && Object.hasOwnProperty.call(message, "clientOperationId"))
                                writer.uint32(/* id 297240295, wireType 2 =*/2377922362).string(message.clientOperationId);
                            if (message.statusMessage != null && Object.hasOwnProperty.call(message, "statusMessage"))
                                writer.uint32(/* id 297428154, wireType 2 =*/2379425234).string(message.statusMessage);
                            if (message.httpErrorStatusCode != null && Object.hasOwnProperty.call(message, "httpErrorStatusCode"))
                                writer.uint32(/* id 312345196, wireType 0 =*/2498761568).int32(message.httpErrorStatusCode);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.insertTime != null && Object.hasOwnProperty.call(message, "insertTime"))
                                writer.uint32(/* id 433722515, wireType 2 =*/3469780122).string(message.insertTime);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.warnings != null && message.warnings.length)
                                for (var i = 0; i < message.warnings.length; ++i)
                                    $root.google.cloud.compute.v1.Warnings.encode(message.warnings[i], writer.uint32(/* id 498091095, wireType 2 =*/3984728762).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Operation message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Operation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Operation
                         * @static
                         * @param {google.cloud.compute.v1.IOperation} message Operation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Operation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Operation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Operation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Operation} Operation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Operation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Operation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 297240295: {
                                        message.clientOperationId = reader.string();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 114938801: {
                                        message.endTime = reader.string();
                                        break;
                                    }
                                case 96784904: {
                                        message.error = $root.google.cloud.compute.v1.Error.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 202521945: {
                                        message.httpErrorMessage = reader.string();
                                        break;
                                    }
                                case 312345196: {
                                        message.httpErrorStatusCode = reader.int32();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 433722515: {
                                        message.insertTime = reader.string();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 40171187: {
                                        message.operationGroupId = reader.string();
                                        break;
                                    }
                                case 177650450: {
                                        message.operationType = reader.string();
                                        break;
                                    }
                                case 72663597: {
                                        message.progress = reader.int32();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 37467274: {
                                        message.startTime = reader.string();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.int32();
                                        break;
                                    }
                                case 297428154: {
                                        message.statusMessage = reader.string();
                                        break;
                                    }
                                case 258165385: {
                                        message.targetId = reader.uint64();
                                        break;
                                    }
                                case 62671336: {
                                        message.targetLink = reader.string();
                                        break;
                                    }
                                case 3599307: {
                                        message.user = reader.string();
                                        break;
                                    }
                                case 498091095: {
                                        if (!(message.warnings && message.warnings.length))
                                            message.warnings = [];
                                        message.warnings.push($root.google.cloud.compute.v1.Warnings.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Operation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Operation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Operation} Operation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Operation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Operation message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Operation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Operation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.clientOperationId != null && message.hasOwnProperty("clientOperationId")) {
                                properties._clientOperationId = 1;
                                if (!$util.isString(message.clientOperationId))
                                    return "clientOperationId: string expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.endTime != null && message.hasOwnProperty("endTime")) {
                                properties._endTime = 1;
                                if (!$util.isString(message.endTime))
                                    return "endTime: string expected";
                            }
                            if (message.error != null && message.hasOwnProperty("error")) {
                                properties._error = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Error.verify(message.error);
                                    if (error)
                                        return "error." + error;
                                }
                            }
                            if (message.httpErrorMessage != null && message.hasOwnProperty("httpErrorMessage")) {
                                properties._httpErrorMessage = 1;
                                if (!$util.isString(message.httpErrorMessage))
                                    return "httpErrorMessage: string expected";
                            }
                            if (message.httpErrorStatusCode != null && message.hasOwnProperty("httpErrorStatusCode")) {
                                properties._httpErrorStatusCode = 1;
                                if (!$util.isInteger(message.httpErrorStatusCode))
                                    return "httpErrorStatusCode: integer expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.insertTime != null && message.hasOwnProperty("insertTime")) {
                                properties._insertTime = 1;
                                if (!$util.isString(message.insertTime))
                                    return "insertTime: string expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.operationGroupId != null && message.hasOwnProperty("operationGroupId")) {
                                properties._operationGroupId = 1;
                                if (!$util.isString(message.operationGroupId))
                                    return "operationGroupId: string expected";
                            }
                            if (message.operationType != null && message.hasOwnProperty("operationType")) {
                                properties._operationType = 1;
                                if (!$util.isString(message.operationType))
                                    return "operationType: string expected";
                            }
                            if (message.progress != null && message.hasOwnProperty("progress")) {
                                properties._progress = 1;
                                if (!$util.isInteger(message.progress))
                                    return "progress: integer expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.startTime != null && message.hasOwnProperty("startTime")) {
                                properties._startTime = 1;
                                if (!$util.isString(message.startTime))
                                    return "startTime: string expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 2104194:
                                case 35394935:
                                case 121282975:
                                    break;
                                }
                            }
                            if (message.statusMessage != null && message.hasOwnProperty("statusMessage")) {
                                properties._statusMessage = 1;
                                if (!$util.isString(message.statusMessage))
                                    return "statusMessage: string expected";
                            }
                            if (message.targetId != null && message.hasOwnProperty("targetId")) {
                                properties._targetId = 1;
                                if (!$util.isInteger(message.targetId) && !(message.targetId && $util.isInteger(message.targetId.low) && $util.isInteger(message.targetId.high)))
                                    return "targetId: integer|Long expected";
                            }
                            if (message.targetLink != null && message.hasOwnProperty("targetLink")) {
                                properties._targetLink = 1;
                                if (!$util.isString(message.targetLink))
                                    return "targetLink: string expected";
                            }
                            if (message.user != null && message.hasOwnProperty("user")) {
                                properties._user = 1;
                                if (!$util.isString(message.user))
                                    return "user: string expected";
                            }
                            if (message.warnings != null && message.hasOwnProperty("warnings")) {
                                if (!Array.isArray(message.warnings))
                                    return "warnings: array expected";
                                for (var i = 0; i < message.warnings.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Warnings.verify(message.warnings[i]);
                                    if (error)
                                        return "warnings." + error;
                                }
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                properties._zone = 1;
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an Operation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Operation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Operation} Operation
                         */
                        Operation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Operation)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Operation();
                            if (object.clientOperationId != null)
                                message.clientOperationId = String(object.clientOperationId);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.endTime != null)
                                message.endTime = String(object.endTime);
                            if (object.error != null) {
                                if (typeof object.error !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Operation.error: object expected");
                                message.error = $root.google.cloud.compute.v1.Error.fromObject(object.error);
                            }
                            if (object.httpErrorMessage != null)
                                message.httpErrorMessage = String(object.httpErrorMessage);
                            if (object.httpErrorStatusCode != null)
                                message.httpErrorStatusCode = object.httpErrorStatusCode | 0;
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.insertTime != null)
                                message.insertTime = String(object.insertTime);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.operationGroupId != null)
                                message.operationGroupId = String(object.operationGroupId);
                            if (object.operationType != null)
                                message.operationType = String(object.operationType);
                            if (object.progress != null)
                                message.progress = object.progress | 0;
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.startTime != null)
                                message.startTime = String(object.startTime);
                            switch (object.status) {
                            default:
                                if (typeof object.status === "number") {
                                    message.status = object.status;
                                    break;
                                }
                                break;
                            case "UNDEFINED_STATUS":
                            case 0:
                                message.status = 0;
                                break;
                            case "DONE":
                            case 2104194:
                                message.status = 2104194;
                                break;
                            case "PENDING":
                            case 35394935:
                                message.status = 35394935;
                                break;
                            case "RUNNING":
                            case 121282975:
                                message.status = 121282975;
                                break;
                            }
                            if (object.statusMessage != null)
                                message.statusMessage = String(object.statusMessage);
                            if (object.targetId != null)
                                if ($util.Long)
                                    (message.targetId = $util.Long.fromValue(object.targetId)).unsigned = true;
                                else if (typeof object.targetId === "string")
                                    message.targetId = parseInt(object.targetId, 10);
                                else if (typeof object.targetId === "number")
                                    message.targetId = object.targetId;
                                else if (typeof object.targetId === "object")
                                    message.targetId = new $util.LongBits(object.targetId.low >>> 0, object.targetId.high >>> 0).toNumber(true);
                            if (object.targetLink != null)
                                message.targetLink = String(object.targetLink);
                            if (object.user != null)
                                message.user = String(object.user);
                            if (object.warnings) {
                                if (!Array.isArray(object.warnings))
                                    throw TypeError(".google.cloud.compute.v1.Operation.warnings: array expected");
                                message.warnings = [];
                                for (var i = 0; i < object.warnings.length; ++i) {
                                    if (typeof object.warnings[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Operation.warnings: object expected");
                                    message.warnings[i] = $root.google.cloud.compute.v1.Warnings.fromObject(object.warnings[i]);
                                }
                            }
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Operation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Operation
                         * @static
                         * @param {google.cloud.compute.v1.Operation} message Operation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Operation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.warnings = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.user != null && message.hasOwnProperty("user")) {
                                object.user = message.user;
                                if (options.oneofs)
                                    object._user = "user";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                object.zone = message.zone;
                                if (options.oneofs)
                                    object._zone = "zone";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.startTime != null && message.hasOwnProperty("startTime")) {
                                object.startTime = message.startTime;
                                if (options.oneofs)
                                    object._startTime = "startTime";
                            }
                            if (message.operationGroupId != null && message.hasOwnProperty("operationGroupId")) {
                                object.operationGroupId = message.operationGroupId;
                                if (options.oneofs)
                                    object._operationGroupId = "operationGroupId";
                            }
                            if (message.targetLink != null && message.hasOwnProperty("targetLink")) {
                                object.targetLink = message.targetLink;
                                if (options.oneofs)
                                    object._targetLink = "targetLink";
                            }
                            if (message.progress != null && message.hasOwnProperty("progress")) {
                                object.progress = message.progress;
                                if (options.oneofs)
                                    object._progress = "progress";
                            }
                            if (message.error != null && message.hasOwnProperty("error")) {
                                object.error = $root.google.cloud.compute.v1.Error.toObject(message.error, options);
                                if (options.oneofs)
                                    object._error = "error";
                            }
                            if (message.endTime != null && message.hasOwnProperty("endTime")) {
                                object.endTime = message.endTime;
                                if (options.oneofs)
                                    object._endTime = "endTime";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.operationType != null && message.hasOwnProperty("operationType")) {
                                object.operationType = message.operationType;
                                if (options.oneofs)
                                    object._operationType = "operationType";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = options.enums === String ? $root.google.cloud.compute.v1.Operation.Status[message.status] === undefined ? message.status : $root.google.cloud.compute.v1.Operation.Status[message.status] : message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.httpErrorMessage != null && message.hasOwnProperty("httpErrorMessage")) {
                                object.httpErrorMessage = message.httpErrorMessage;
                                if (options.oneofs)
                                    object._httpErrorMessage = "httpErrorMessage";
                            }
                            if (message.targetId != null && message.hasOwnProperty("targetId")) {
                                if (typeof message.targetId === "number")
                                    object.targetId = options.longs === String ? String(message.targetId) : message.targetId;
                                else
                                    object.targetId = options.longs === String ? $util.Long.prototype.toString.call(message.targetId) : options.longs === Number ? new $util.LongBits(message.targetId.low >>> 0, message.targetId.high >>> 0).toNumber(true) : message.targetId;
                                if (options.oneofs)
                                    object._targetId = "targetId";
                            }
                            if (message.clientOperationId != null && message.hasOwnProperty("clientOperationId")) {
                                object.clientOperationId = message.clientOperationId;
                                if (options.oneofs)
                                    object._clientOperationId = "clientOperationId";
                            }
                            if (message.statusMessage != null && message.hasOwnProperty("statusMessage")) {
                                object.statusMessage = message.statusMessage;
                                if (options.oneofs)
                                    object._statusMessage = "statusMessage";
                            }
                            if (message.httpErrorStatusCode != null && message.hasOwnProperty("httpErrorStatusCode")) {
                                object.httpErrorStatusCode = message.httpErrorStatusCode;
                                if (options.oneofs)
                                    object._httpErrorStatusCode = "httpErrorStatusCode";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.insertTime != null && message.hasOwnProperty("insertTime")) {
                                object.insertTime = message.insertTime;
                                if (options.oneofs)
                                    object._insertTime = "insertTime";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.warnings && message.warnings.length) {
                                object.warnings = [];
                                for (var j = 0; j < message.warnings.length; ++j)
                                    object.warnings[j] = $root.google.cloud.compute.v1.Warnings.toObject(message.warnings[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Operation to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Operation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Operation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Operation
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Operation
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Operation.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Operation";
                        };
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.Operation.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} DONE=2104194 DONE value
                         * @property {number} PENDING=35394935 PENDING value
                         * @property {number} RUNNING=121282975 RUNNING value
                         */
                        Operation.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[2104194] = "DONE"] = 2104194;
                            values[valuesById[35394935] = "PENDING"] = 35394935;
                            values[valuesById[121282975] = "RUNNING"] = 121282975;
                            return values;
                        })();
    
                        return Operation;
                    })();
    
                    v1.OperationAggregatedList = (function() {
    
                        /**
                         * Properties of an OperationAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IOperationAggregatedList
                         * @property {string|null} [id] OperationAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IOperationsScopedList>|null} [items] OperationAggregatedList items
                         * @property {string|null} [kind] OperationAggregatedList kind
                         * @property {string|null} [nextPageToken] OperationAggregatedList nextPageToken
                         * @property {string|null} [selfLink] OperationAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] OperationAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] OperationAggregatedList warning
                         */
    
                        /**
                         * Constructs a new OperationAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an OperationAggregatedList.
                         * @implements IOperationAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IOperationAggregatedList=} [properties] Properties to set
                         */
                        function OperationAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * OperationAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @instance
                         */
                        OperationAggregatedList.prototype.id = null;
    
                        /**
                         * OperationAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IOperationsScopedList>} items
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @instance
                         */
                        OperationAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * OperationAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @instance
                         */
                        OperationAggregatedList.prototype.kind = null;
    
                        /**
                         * OperationAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @instance
                         */
                        OperationAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * OperationAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @instance
                         */
                        OperationAggregatedList.prototype.selfLink = null;
    
                        /**
                         * OperationAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @instance
                         */
                        OperationAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * OperationAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @instance
                         */
                        OperationAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * OperationAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @instance
                         */
                        Object.defineProperty(OperationAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * OperationAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @instance
                         */
                        Object.defineProperty(OperationAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * OperationAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @instance
                         */
                        Object.defineProperty(OperationAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * OperationAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @instance
                         */
                        Object.defineProperty(OperationAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * OperationAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @instance
                         */
                        Object.defineProperty(OperationAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new OperationAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IOperationAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.OperationAggregatedList} OperationAggregatedList instance
                         */
                        OperationAggregatedList.create = function create(properties) {
                            return new OperationAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified OperationAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.OperationAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IOperationAggregatedList} message OperationAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        OperationAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.OperationsScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified OperationAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.OperationAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IOperationAggregatedList} message OperationAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        OperationAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an OperationAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.OperationAggregatedList} OperationAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        OperationAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.OperationAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.OperationsScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an OperationAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.OperationAggregatedList} OperationAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        OperationAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an OperationAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        OperationAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.OperationsScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an OperationAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.OperationAggregatedList} OperationAggregatedList
                         */
                        OperationAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.OperationAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.OperationAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.OperationAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.OperationAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.OperationsScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.OperationAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.OperationAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an OperationAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.OperationAggregatedList} message OperationAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        OperationAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.OperationsScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this OperationAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        OperationAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for OperationAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.OperationAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        OperationAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.OperationAggregatedList";
                        };
    
                        return OperationAggregatedList;
                    })();
    
                    v1.OperationList = (function() {
    
                        /**
                         * Properties of an OperationList.
                         * @memberof google.cloud.compute.v1
                         * @interface IOperationList
                         * @property {string|null} [id] OperationList id
                         * @property {Array.<google.cloud.compute.v1.IOperation>|null} [items] OperationList items
                         * @property {string|null} [kind] OperationList kind
                         * @property {string|null} [nextPageToken] OperationList nextPageToken
                         * @property {string|null} [selfLink] OperationList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] OperationList warning
                         */
    
                        /**
                         * Constructs a new OperationList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an OperationList.
                         * @implements IOperationList
                         * @constructor
                         * @param {google.cloud.compute.v1.IOperationList=} [properties] Properties to set
                         */
                        function OperationList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * OperationList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.OperationList
                         * @instance
                         */
                        OperationList.prototype.id = null;
    
                        /**
                         * OperationList items.
                         * @member {Array.<google.cloud.compute.v1.IOperation>} items
                         * @memberof google.cloud.compute.v1.OperationList
                         * @instance
                         */
                        OperationList.prototype.items = $util.emptyArray;
    
                        /**
                         * OperationList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.OperationList
                         * @instance
                         */
                        OperationList.prototype.kind = null;
    
                        /**
                         * OperationList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.OperationList
                         * @instance
                         */
                        OperationList.prototype.nextPageToken = null;
    
                        /**
                         * OperationList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.OperationList
                         * @instance
                         */
                        OperationList.prototype.selfLink = null;
    
                        /**
                         * OperationList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.OperationList
                         * @instance
                         */
                        OperationList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * OperationList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.OperationList
                         * @instance
                         */
                        Object.defineProperty(OperationList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * OperationList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.OperationList
                         * @instance
                         */
                        Object.defineProperty(OperationList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * OperationList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.OperationList
                         * @instance
                         */
                        Object.defineProperty(OperationList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * OperationList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.OperationList
                         * @instance
                         */
                        Object.defineProperty(OperationList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * OperationList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.OperationList
                         * @instance
                         */
                        Object.defineProperty(OperationList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new OperationList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.OperationList
                         * @static
                         * @param {google.cloud.compute.v1.IOperationList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.OperationList} OperationList instance
                         */
                        OperationList.create = function create(properties) {
                            return new OperationList(properties);
                        };
    
                        /**
                         * Encodes the specified OperationList message. Does not implicitly {@link google.cloud.compute.v1.OperationList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.OperationList
                         * @static
                         * @param {google.cloud.compute.v1.IOperationList} message OperationList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        OperationList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Operation.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified OperationList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.OperationList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.OperationList
                         * @static
                         * @param {google.cloud.compute.v1.IOperationList} message OperationList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        OperationList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an OperationList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.OperationList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.OperationList} OperationList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        OperationList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.OperationList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Operation.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an OperationList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.OperationList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.OperationList} OperationList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        OperationList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an OperationList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.OperationList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        OperationList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Operation.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an OperationList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.OperationList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.OperationList} OperationList
                         */
                        OperationList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.OperationList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.OperationList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.OperationList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.OperationList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Operation.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.OperationList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an OperationList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.OperationList
                         * @static
                         * @param {google.cloud.compute.v1.OperationList} message OperationList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        OperationList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Operation.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this OperationList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.OperationList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        OperationList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for OperationList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.OperationList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        OperationList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.OperationList";
                        };
    
                        return OperationList;
                    })();
    
                    v1.OperationsScopedList = (function() {
    
                        /**
                         * Properties of an OperationsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IOperationsScopedList
                         * @property {Array.<google.cloud.compute.v1.IOperation>|null} [operations] OperationsScopedList operations
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] OperationsScopedList warning
                         */
    
                        /**
                         * Constructs a new OperationsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an OperationsScopedList.
                         * @implements IOperationsScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IOperationsScopedList=} [properties] Properties to set
                         */
                        function OperationsScopedList(properties) {
                            this.operations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * OperationsScopedList operations.
                         * @member {Array.<google.cloud.compute.v1.IOperation>} operations
                         * @memberof google.cloud.compute.v1.OperationsScopedList
                         * @instance
                         */
                        OperationsScopedList.prototype.operations = $util.emptyArray;
    
                        /**
                         * OperationsScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.OperationsScopedList
                         * @instance
                         */
                        OperationsScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * OperationsScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.OperationsScopedList
                         * @instance
                         */
                        Object.defineProperty(OperationsScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new OperationsScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.OperationsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IOperationsScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.OperationsScopedList} OperationsScopedList instance
                         */
                        OperationsScopedList.create = function create(properties) {
                            return new OperationsScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified OperationsScopedList message. Does not implicitly {@link google.cloud.compute.v1.OperationsScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.OperationsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IOperationsScopedList} message OperationsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        OperationsScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operations != null && message.operations.length)
                                for (var i = 0; i < message.operations.length; ++i)
                                    $root.google.cloud.compute.v1.Operation.encode(message.operations[i], writer.uint32(/* id 4184044, wireType 2 =*/33472354).fork()).ldelim();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified OperationsScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.OperationsScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.OperationsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IOperationsScopedList} message OperationsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        OperationsScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an OperationsScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.OperationsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.OperationsScopedList} OperationsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        OperationsScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.OperationsScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4184044: {
                                        if (!(message.operations && message.operations.length))
                                            message.operations = [];
                                        message.operations.push($root.google.cloud.compute.v1.Operation.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an OperationsScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.OperationsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.OperationsScopedList} OperationsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        OperationsScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an OperationsScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.OperationsScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        OperationsScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.operations != null && message.hasOwnProperty("operations")) {
                                if (!Array.isArray(message.operations))
                                    return "operations: array expected";
                                for (var i = 0; i < message.operations.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Operation.verify(message.operations[i]);
                                    if (error)
                                        return "operations." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an OperationsScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.OperationsScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.OperationsScopedList} OperationsScopedList
                         */
                        OperationsScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.OperationsScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.OperationsScopedList();
                            if (object.operations) {
                                if (!Array.isArray(object.operations))
                                    throw TypeError(".google.cloud.compute.v1.OperationsScopedList.operations: array expected");
                                message.operations = [];
                                for (var i = 0; i < object.operations.length; ++i) {
                                    if (typeof object.operations[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.OperationsScopedList.operations: object expected");
                                    message.operations[i] = $root.google.cloud.compute.v1.Operation.fromObject(object.operations[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.OperationsScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an OperationsScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.OperationsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.OperationsScopedList} message OperationsScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        OperationsScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.operations = [];
                            if (message.operations && message.operations.length) {
                                object.operations = [];
                                for (var j = 0; j < message.operations.length; ++j)
                                    object.operations[j] = $root.google.cloud.compute.v1.Operation.toObject(message.operations[j], options);
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this OperationsScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.OperationsScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        OperationsScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for OperationsScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.OperationsScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        OperationsScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.OperationsScopedList";
                        };
    
                        return OperationsScopedList;
                    })();
    
                    v1.OutlierDetection = (function() {
    
                        /**
                         * Properties of an OutlierDetection.
                         * @memberof google.cloud.compute.v1
                         * @interface IOutlierDetection
                         * @property {google.cloud.compute.v1.IDuration|null} [baseEjectionTime] OutlierDetection baseEjectionTime
                         * @property {number|null} [consecutiveErrors] OutlierDetection consecutiveErrors
                         * @property {number|null} [consecutiveGatewayFailure] OutlierDetection consecutiveGatewayFailure
                         * @property {number|null} [enforcingConsecutiveErrors] OutlierDetection enforcingConsecutiveErrors
                         * @property {number|null} [enforcingConsecutiveGatewayFailure] OutlierDetection enforcingConsecutiveGatewayFailure
                         * @property {number|null} [enforcingSuccessRate] OutlierDetection enforcingSuccessRate
                         * @property {google.cloud.compute.v1.IDuration|null} [interval] OutlierDetection interval
                         * @property {number|null} [maxEjectionPercent] OutlierDetection maxEjectionPercent
                         * @property {number|null} [successRateMinimumHosts] OutlierDetection successRateMinimumHosts
                         * @property {number|null} [successRateRequestVolume] OutlierDetection successRateRequestVolume
                         * @property {number|null} [successRateStdevFactor] OutlierDetection successRateStdevFactor
                         */
    
                        /**
                         * Constructs a new OutlierDetection.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an OutlierDetection.
                         * @implements IOutlierDetection
                         * @constructor
                         * @param {google.cloud.compute.v1.IOutlierDetection=} [properties] Properties to set
                         */
                        function OutlierDetection(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * OutlierDetection baseEjectionTime.
                         * @member {google.cloud.compute.v1.IDuration|null|undefined} baseEjectionTime
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        OutlierDetection.prototype.baseEjectionTime = null;
    
                        /**
                         * OutlierDetection consecutiveErrors.
                         * @member {number|null|undefined} consecutiveErrors
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        OutlierDetection.prototype.consecutiveErrors = null;
    
                        /**
                         * OutlierDetection consecutiveGatewayFailure.
                         * @member {number|null|undefined} consecutiveGatewayFailure
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        OutlierDetection.prototype.consecutiveGatewayFailure = null;
    
                        /**
                         * OutlierDetection enforcingConsecutiveErrors.
                         * @member {number|null|undefined} enforcingConsecutiveErrors
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        OutlierDetection.prototype.enforcingConsecutiveErrors = null;
    
                        /**
                         * OutlierDetection enforcingConsecutiveGatewayFailure.
                         * @member {number|null|undefined} enforcingConsecutiveGatewayFailure
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        OutlierDetection.prototype.enforcingConsecutiveGatewayFailure = null;
    
                        /**
                         * OutlierDetection enforcingSuccessRate.
                         * @member {number|null|undefined} enforcingSuccessRate
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        OutlierDetection.prototype.enforcingSuccessRate = null;
    
                        /**
                         * OutlierDetection interval.
                         * @member {google.cloud.compute.v1.IDuration|null|undefined} interval
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        OutlierDetection.prototype.interval = null;
    
                        /**
                         * OutlierDetection maxEjectionPercent.
                         * @member {number|null|undefined} maxEjectionPercent
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        OutlierDetection.prototype.maxEjectionPercent = null;
    
                        /**
                         * OutlierDetection successRateMinimumHosts.
                         * @member {number|null|undefined} successRateMinimumHosts
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        OutlierDetection.prototype.successRateMinimumHosts = null;
    
                        /**
                         * OutlierDetection successRateRequestVolume.
                         * @member {number|null|undefined} successRateRequestVolume
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        OutlierDetection.prototype.successRateRequestVolume = null;
    
                        /**
                         * OutlierDetection successRateStdevFactor.
                         * @member {number|null|undefined} successRateStdevFactor
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        OutlierDetection.prototype.successRateStdevFactor = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * OutlierDetection _baseEjectionTime.
                         * @member {"baseEjectionTime"|undefined} _baseEjectionTime
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        Object.defineProperty(OutlierDetection.prototype, "_baseEjectionTime", {
                            get: $util.oneOfGetter($oneOfFields = ["baseEjectionTime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * OutlierDetection _consecutiveErrors.
                         * @member {"consecutiveErrors"|undefined} _consecutiveErrors
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        Object.defineProperty(OutlierDetection.prototype, "_consecutiveErrors", {
                            get: $util.oneOfGetter($oneOfFields = ["consecutiveErrors"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * OutlierDetection _consecutiveGatewayFailure.
                         * @member {"consecutiveGatewayFailure"|undefined} _consecutiveGatewayFailure
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        Object.defineProperty(OutlierDetection.prototype, "_consecutiveGatewayFailure", {
                            get: $util.oneOfGetter($oneOfFields = ["consecutiveGatewayFailure"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * OutlierDetection _enforcingConsecutiveErrors.
                         * @member {"enforcingConsecutiveErrors"|undefined} _enforcingConsecutiveErrors
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        Object.defineProperty(OutlierDetection.prototype, "_enforcingConsecutiveErrors", {
                            get: $util.oneOfGetter($oneOfFields = ["enforcingConsecutiveErrors"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * OutlierDetection _enforcingConsecutiveGatewayFailure.
                         * @member {"enforcingConsecutiveGatewayFailure"|undefined} _enforcingConsecutiveGatewayFailure
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        Object.defineProperty(OutlierDetection.prototype, "_enforcingConsecutiveGatewayFailure", {
                            get: $util.oneOfGetter($oneOfFields = ["enforcingConsecutiveGatewayFailure"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * OutlierDetection _enforcingSuccessRate.
                         * @member {"enforcingSuccessRate"|undefined} _enforcingSuccessRate
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        Object.defineProperty(OutlierDetection.prototype, "_enforcingSuccessRate", {
                            get: $util.oneOfGetter($oneOfFields = ["enforcingSuccessRate"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * OutlierDetection _interval.
                         * @member {"interval"|undefined} _interval
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        Object.defineProperty(OutlierDetection.prototype, "_interval", {
                            get: $util.oneOfGetter($oneOfFields = ["interval"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * OutlierDetection _maxEjectionPercent.
                         * @member {"maxEjectionPercent"|undefined} _maxEjectionPercent
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        Object.defineProperty(OutlierDetection.prototype, "_maxEjectionPercent", {
                            get: $util.oneOfGetter($oneOfFields = ["maxEjectionPercent"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * OutlierDetection _successRateMinimumHosts.
                         * @member {"successRateMinimumHosts"|undefined} _successRateMinimumHosts
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        Object.defineProperty(OutlierDetection.prototype, "_successRateMinimumHosts", {
                            get: $util.oneOfGetter($oneOfFields = ["successRateMinimumHosts"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * OutlierDetection _successRateRequestVolume.
                         * @member {"successRateRequestVolume"|undefined} _successRateRequestVolume
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        Object.defineProperty(OutlierDetection.prototype, "_successRateRequestVolume", {
                            get: $util.oneOfGetter($oneOfFields = ["successRateRequestVolume"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * OutlierDetection _successRateStdevFactor.
                         * @member {"successRateStdevFactor"|undefined} _successRateStdevFactor
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         */
                        Object.defineProperty(OutlierDetection.prototype, "_successRateStdevFactor", {
                            get: $util.oneOfGetter($oneOfFields = ["successRateStdevFactor"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new OutlierDetection instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @static
                         * @param {google.cloud.compute.v1.IOutlierDetection=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.OutlierDetection} OutlierDetection instance
                         */
                        OutlierDetection.create = function create(properties) {
                            return new OutlierDetection(properties);
                        };
    
                        /**
                         * Encodes the specified OutlierDetection message. Does not implicitly {@link google.cloud.compute.v1.OutlierDetection.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @static
                         * @param {google.cloud.compute.v1.IOutlierDetection} message OutlierDetection message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        OutlierDetection.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.maxEjectionPercent != null && Object.hasOwnProperty.call(message, "maxEjectionPercent"))
                                writer.uint32(/* id 18436888, wireType 0 =*/147495104).int32(message.maxEjectionPercent);
                            if (message.interval != null && Object.hasOwnProperty.call(message, "interval"))
                                $root.google.cloud.compute.v1.Duration.encode(message.interval, writer.uint32(/* id 33547461, wireType 2 =*/268379690).fork()).ldelim();
                            if (message.baseEjectionTime != null && Object.hasOwnProperty.call(message, "baseEjectionTime"))
                                $root.google.cloud.compute.v1.Duration.encode(message.baseEjectionTime, writer.uint32(/* id 80997255, wireType 2 =*/647978042).fork()).ldelim();
                            if (message.successRateStdevFactor != null && Object.hasOwnProperty.call(message, "successRateStdevFactor"))
                                writer.uint32(/* id 174735773, wireType 0 =*/1397886184).int32(message.successRateStdevFactor);
                            if (message.enforcingSuccessRate != null && Object.hasOwnProperty.call(message, "enforcingSuccessRate"))
                                writer.uint32(/* id 194508732, wireType 0 =*/1556069856).int32(message.enforcingSuccessRate);
                            if (message.enforcingConsecutiveErrors != null && Object.hasOwnProperty.call(message, "enforcingConsecutiveErrors"))
                                writer.uint32(/* id 213133760, wireType 0 =*/1705070080).int32(message.enforcingConsecutiveErrors);
                            if (message.successRateRequestVolume != null && Object.hasOwnProperty.call(message, "successRateRequestVolume"))
                                writer.uint32(/* id 281425357, wireType 0 =*/2251402856).int32(message.successRateRequestVolume);
                            if (message.consecutiveErrors != null && Object.hasOwnProperty.call(message, "consecutiveErrors"))
                                writer.uint32(/* id 387193248, wireType 0 =*/3097545984).int32(message.consecutiveErrors);
                            if (message.enforcingConsecutiveGatewayFailure != null && Object.hasOwnProperty.call(message, "enforcingConsecutiveGatewayFailure"))
                                writer.uint32(/* id 394440666, wireType 0 =*/3155525328).int32(message.enforcingConsecutiveGatewayFailure);
                            if (message.consecutiveGatewayFailure != null && Object.hasOwnProperty.call(message, "consecutiveGatewayFailure"))
                                writer.uint32(/* id 417504250, wireType 0 =*/3340034000).int32(message.consecutiveGatewayFailure);
                            if (message.successRateMinimumHosts != null && Object.hasOwnProperty.call(message, "successRateMinimumHosts"))
                                writer.uint32(/* id 525766903, wireType 0 =*/4206135224).int32(message.successRateMinimumHosts);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified OutlierDetection message, length delimited. Does not implicitly {@link google.cloud.compute.v1.OutlierDetection.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @static
                         * @param {google.cloud.compute.v1.IOutlierDetection} message OutlierDetection message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        OutlierDetection.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an OutlierDetection message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.OutlierDetection} OutlierDetection
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        OutlierDetection.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.OutlierDetection();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 80997255: {
                                        message.baseEjectionTime = $root.google.cloud.compute.v1.Duration.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 387193248: {
                                        message.consecutiveErrors = reader.int32();
                                        break;
                                    }
                                case 417504250: {
                                        message.consecutiveGatewayFailure = reader.int32();
                                        break;
                                    }
                                case 213133760: {
                                        message.enforcingConsecutiveErrors = reader.int32();
                                        break;
                                    }
                                case 394440666: {
                                        message.enforcingConsecutiveGatewayFailure = reader.int32();
                                        break;
                                    }
                                case 194508732: {
                                        message.enforcingSuccessRate = reader.int32();
                                        break;
                                    }
                                case 33547461: {
                                        message.interval = $root.google.cloud.compute.v1.Duration.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 18436888: {
                                        message.maxEjectionPercent = reader.int32();
                                        break;
                                    }
                                case 525766903: {
                                        message.successRateMinimumHosts = reader.int32();
                                        break;
                                    }
                                case 281425357: {
                                        message.successRateRequestVolume = reader.int32();
                                        break;
                                    }
                                case 174735773: {
                                        message.successRateStdevFactor = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an OutlierDetection message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.OutlierDetection} OutlierDetection
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        OutlierDetection.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an OutlierDetection message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        OutlierDetection.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.baseEjectionTime != null && message.hasOwnProperty("baseEjectionTime")) {
                                properties._baseEjectionTime = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Duration.verify(message.baseEjectionTime);
                                    if (error)
                                        return "baseEjectionTime." + error;
                                }
                            }
                            if (message.consecutiveErrors != null && message.hasOwnProperty("consecutiveErrors")) {
                                properties._consecutiveErrors = 1;
                                if (!$util.isInteger(message.consecutiveErrors))
                                    return "consecutiveErrors: integer expected";
                            }
                            if (message.consecutiveGatewayFailure != null && message.hasOwnProperty("consecutiveGatewayFailure")) {
                                properties._consecutiveGatewayFailure = 1;
                                if (!$util.isInteger(message.consecutiveGatewayFailure))
                                    return "consecutiveGatewayFailure: integer expected";
                            }
                            if (message.enforcingConsecutiveErrors != null && message.hasOwnProperty("enforcingConsecutiveErrors")) {
                                properties._enforcingConsecutiveErrors = 1;
                                if (!$util.isInteger(message.enforcingConsecutiveErrors))
                                    return "enforcingConsecutiveErrors: integer expected";
                            }
                            if (message.enforcingConsecutiveGatewayFailure != null && message.hasOwnProperty("enforcingConsecutiveGatewayFailure")) {
                                properties._enforcingConsecutiveGatewayFailure = 1;
                                if (!$util.isInteger(message.enforcingConsecutiveGatewayFailure))
                                    return "enforcingConsecutiveGatewayFailure: integer expected";
                            }
                            if (message.enforcingSuccessRate != null && message.hasOwnProperty("enforcingSuccessRate")) {
                                properties._enforcingSuccessRate = 1;
                                if (!$util.isInteger(message.enforcingSuccessRate))
                                    return "enforcingSuccessRate: integer expected";
                            }
                            if (message.interval != null && message.hasOwnProperty("interval")) {
                                properties._interval = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Duration.verify(message.interval);
                                    if (error)
                                        return "interval." + error;
                                }
                            }
                            if (message.maxEjectionPercent != null && message.hasOwnProperty("maxEjectionPercent")) {
                                properties._maxEjectionPercent = 1;
                                if (!$util.isInteger(message.maxEjectionPercent))
                                    return "maxEjectionPercent: integer expected";
                            }
                            if (message.successRateMinimumHosts != null && message.hasOwnProperty("successRateMinimumHosts")) {
                                properties._successRateMinimumHosts = 1;
                                if (!$util.isInteger(message.successRateMinimumHosts))
                                    return "successRateMinimumHosts: integer expected";
                            }
                            if (message.successRateRequestVolume != null && message.hasOwnProperty("successRateRequestVolume")) {
                                properties._successRateRequestVolume = 1;
                                if (!$util.isInteger(message.successRateRequestVolume))
                                    return "successRateRequestVolume: integer expected";
                            }
                            if (message.successRateStdevFactor != null && message.hasOwnProperty("successRateStdevFactor")) {
                                properties._successRateStdevFactor = 1;
                                if (!$util.isInteger(message.successRateStdevFactor))
                                    return "successRateStdevFactor: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an OutlierDetection message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.OutlierDetection} OutlierDetection
                         */
                        OutlierDetection.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.OutlierDetection)
                                return object;
                            var message = new $root.google.cloud.compute.v1.OutlierDetection();
                            if (object.baseEjectionTime != null) {
                                if (typeof object.baseEjectionTime !== "object")
                                    throw TypeError(".google.cloud.compute.v1.OutlierDetection.baseEjectionTime: object expected");
                                message.baseEjectionTime = $root.google.cloud.compute.v1.Duration.fromObject(object.baseEjectionTime);
                            }
                            if (object.consecutiveErrors != null)
                                message.consecutiveErrors = object.consecutiveErrors | 0;
                            if (object.consecutiveGatewayFailure != null)
                                message.consecutiveGatewayFailure = object.consecutiveGatewayFailure | 0;
                            if (object.enforcingConsecutiveErrors != null)
                                message.enforcingConsecutiveErrors = object.enforcingConsecutiveErrors | 0;
                            if (object.enforcingConsecutiveGatewayFailure != null)
                                message.enforcingConsecutiveGatewayFailure = object.enforcingConsecutiveGatewayFailure | 0;
                            if (object.enforcingSuccessRate != null)
                                message.enforcingSuccessRate = object.enforcingSuccessRate | 0;
                            if (object.interval != null) {
                                if (typeof object.interval !== "object")
                                    throw TypeError(".google.cloud.compute.v1.OutlierDetection.interval: object expected");
                                message.interval = $root.google.cloud.compute.v1.Duration.fromObject(object.interval);
                            }
                            if (object.maxEjectionPercent != null)
                                message.maxEjectionPercent = object.maxEjectionPercent | 0;
                            if (object.successRateMinimumHosts != null)
                                message.successRateMinimumHosts = object.successRateMinimumHosts | 0;
                            if (object.successRateRequestVolume != null)
                                message.successRateRequestVolume = object.successRateRequestVolume | 0;
                            if (object.successRateStdevFactor != null)
                                message.successRateStdevFactor = object.successRateStdevFactor | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an OutlierDetection message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @static
                         * @param {google.cloud.compute.v1.OutlierDetection} message OutlierDetection
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        OutlierDetection.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.maxEjectionPercent != null && message.hasOwnProperty("maxEjectionPercent")) {
                                object.maxEjectionPercent = message.maxEjectionPercent;
                                if (options.oneofs)
                                    object._maxEjectionPercent = "maxEjectionPercent";
                            }
                            if (message.interval != null && message.hasOwnProperty("interval")) {
                                object.interval = $root.google.cloud.compute.v1.Duration.toObject(message.interval, options);
                                if (options.oneofs)
                                    object._interval = "interval";
                            }
                            if (message.baseEjectionTime != null && message.hasOwnProperty("baseEjectionTime")) {
                                object.baseEjectionTime = $root.google.cloud.compute.v1.Duration.toObject(message.baseEjectionTime, options);
                                if (options.oneofs)
                                    object._baseEjectionTime = "baseEjectionTime";
                            }
                            if (message.successRateStdevFactor != null && message.hasOwnProperty("successRateStdevFactor")) {
                                object.successRateStdevFactor = message.successRateStdevFactor;
                                if (options.oneofs)
                                    object._successRateStdevFactor = "successRateStdevFactor";
                            }
                            if (message.enforcingSuccessRate != null && message.hasOwnProperty("enforcingSuccessRate")) {
                                object.enforcingSuccessRate = message.enforcingSuccessRate;
                                if (options.oneofs)
                                    object._enforcingSuccessRate = "enforcingSuccessRate";
                            }
                            if (message.enforcingConsecutiveErrors != null && message.hasOwnProperty("enforcingConsecutiveErrors")) {
                                object.enforcingConsecutiveErrors = message.enforcingConsecutiveErrors;
                                if (options.oneofs)
                                    object._enforcingConsecutiveErrors = "enforcingConsecutiveErrors";
                            }
                            if (message.successRateRequestVolume != null && message.hasOwnProperty("successRateRequestVolume")) {
                                object.successRateRequestVolume = message.successRateRequestVolume;
                                if (options.oneofs)
                                    object._successRateRequestVolume = "successRateRequestVolume";
                            }
                            if (message.consecutiveErrors != null && message.hasOwnProperty("consecutiveErrors")) {
                                object.consecutiveErrors = message.consecutiveErrors;
                                if (options.oneofs)
                                    object._consecutiveErrors = "consecutiveErrors";
                            }
                            if (message.enforcingConsecutiveGatewayFailure != null && message.hasOwnProperty("enforcingConsecutiveGatewayFailure")) {
                                object.enforcingConsecutiveGatewayFailure = message.enforcingConsecutiveGatewayFailure;
                                if (options.oneofs)
                                    object._enforcingConsecutiveGatewayFailure = "enforcingConsecutiveGatewayFailure";
                            }
                            if (message.consecutiveGatewayFailure != null && message.hasOwnProperty("consecutiveGatewayFailure")) {
                                object.consecutiveGatewayFailure = message.consecutiveGatewayFailure;
                                if (options.oneofs)
                                    object._consecutiveGatewayFailure = "consecutiveGatewayFailure";
                            }
                            if (message.successRateMinimumHosts != null && message.hasOwnProperty("successRateMinimumHosts")) {
                                object.successRateMinimumHosts = message.successRateMinimumHosts;
                                if (options.oneofs)
                                    object._successRateMinimumHosts = "successRateMinimumHosts";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this OutlierDetection to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        OutlierDetection.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for OutlierDetection
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.OutlierDetection
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        OutlierDetection.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.OutlierDetection";
                        };
    
                        return OutlierDetection;
                    })();
    
                    v1.PacketIntervals = (function() {
    
                        /**
                         * Properties of a PacketIntervals.
                         * @memberof google.cloud.compute.v1
                         * @interface IPacketIntervals
                         * @property {number|Long|null} [avgMs] PacketIntervals avgMs
                         * @property {string|null} [duration] PacketIntervals duration
                         * @property {number|Long|null} [maxMs] PacketIntervals maxMs
                         * @property {number|Long|null} [minMs] PacketIntervals minMs
                         * @property {number|Long|null} [numIntervals] PacketIntervals numIntervals
                         * @property {string|null} [type] PacketIntervals type
                         */
    
                        /**
                         * Constructs a new PacketIntervals.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PacketIntervals.
                         * @implements IPacketIntervals
                         * @constructor
                         * @param {google.cloud.compute.v1.IPacketIntervals=} [properties] Properties to set
                         */
                        function PacketIntervals(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PacketIntervals avgMs.
                         * @member {number|Long|null|undefined} avgMs
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @instance
                         */
                        PacketIntervals.prototype.avgMs = null;
    
                        /**
                         * PacketIntervals duration.
                         * @member {string|null|undefined} duration
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @instance
                         */
                        PacketIntervals.prototype.duration = null;
    
                        /**
                         * PacketIntervals maxMs.
                         * @member {number|Long|null|undefined} maxMs
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @instance
                         */
                        PacketIntervals.prototype.maxMs = null;
    
                        /**
                         * PacketIntervals minMs.
                         * @member {number|Long|null|undefined} minMs
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @instance
                         */
                        PacketIntervals.prototype.minMs = null;
    
                        /**
                         * PacketIntervals numIntervals.
                         * @member {number|Long|null|undefined} numIntervals
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @instance
                         */
                        PacketIntervals.prototype.numIntervals = null;
    
                        /**
                         * PacketIntervals type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @instance
                         */
                        PacketIntervals.prototype.type = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PacketIntervals _avgMs.
                         * @member {"avgMs"|undefined} _avgMs
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @instance
                         */
                        Object.defineProperty(PacketIntervals.prototype, "_avgMs", {
                            get: $util.oneOfGetter($oneOfFields = ["avgMs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketIntervals _duration.
                         * @member {"duration"|undefined} _duration
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @instance
                         */
                        Object.defineProperty(PacketIntervals.prototype, "_duration", {
                            get: $util.oneOfGetter($oneOfFields = ["duration"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketIntervals _maxMs.
                         * @member {"maxMs"|undefined} _maxMs
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @instance
                         */
                        Object.defineProperty(PacketIntervals.prototype, "_maxMs", {
                            get: $util.oneOfGetter($oneOfFields = ["maxMs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketIntervals _minMs.
                         * @member {"minMs"|undefined} _minMs
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @instance
                         */
                        Object.defineProperty(PacketIntervals.prototype, "_minMs", {
                            get: $util.oneOfGetter($oneOfFields = ["minMs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketIntervals _numIntervals.
                         * @member {"numIntervals"|undefined} _numIntervals
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @instance
                         */
                        Object.defineProperty(PacketIntervals.prototype, "_numIntervals", {
                            get: $util.oneOfGetter($oneOfFields = ["numIntervals"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketIntervals _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @instance
                         */
                        Object.defineProperty(PacketIntervals.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PacketIntervals instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @static
                         * @param {google.cloud.compute.v1.IPacketIntervals=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PacketIntervals} PacketIntervals instance
                         */
                        PacketIntervals.create = function create(properties) {
                            return new PacketIntervals(properties);
                        };
    
                        /**
                         * Encodes the specified PacketIntervals message. Does not implicitly {@link google.cloud.compute.v1.PacketIntervals.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @static
                         * @param {google.cloud.compute.v1.IPacketIntervals} message PacketIntervals message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketIntervals.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            if (message.duration != null && Object.hasOwnProperty.call(message, "duration"))
                                writer.uint32(/* id 155471252, wireType 2 =*/1243770018).string(message.duration);
                            if (message.numIntervals != null && Object.hasOwnProperty.call(message, "numIntervals"))
                                writer.uint32(/* id 186329813, wireType 0 =*/1490638504).int64(message.numIntervals);
                            if (message.avgMs != null && Object.hasOwnProperty.call(message, "avgMs"))
                                writer.uint32(/* id 204811827, wireType 0 =*/1638494616).int64(message.avgMs);
                            if (message.maxMs != null && Object.hasOwnProperty.call(message, "maxMs"))
                                writer.uint32(/* id 529474145, wireType 0 =*/4235793160).int64(message.maxMs);
                            if (message.minMs != null && Object.hasOwnProperty.call(message, "minMs"))
                                writer.uint32(/* id 536564403, wireType 0 =*/4292515224).int64(message.minMs);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PacketIntervals message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PacketIntervals.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @static
                         * @param {google.cloud.compute.v1.IPacketIntervals} message PacketIntervals message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketIntervals.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PacketIntervals message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PacketIntervals} PacketIntervals
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketIntervals.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PacketIntervals();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 204811827: {
                                        message.avgMs = reader.int64();
                                        break;
                                    }
                                case 155471252: {
                                        message.duration = reader.string();
                                        break;
                                    }
                                case 529474145: {
                                        message.maxMs = reader.int64();
                                        break;
                                    }
                                case 536564403: {
                                        message.minMs = reader.int64();
                                        break;
                                    }
                                case 186329813: {
                                        message.numIntervals = reader.int64();
                                        break;
                                    }
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PacketIntervals message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PacketIntervals} PacketIntervals
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketIntervals.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PacketIntervals message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PacketIntervals.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.avgMs != null && message.hasOwnProperty("avgMs")) {
                                properties._avgMs = 1;
                                if (!$util.isInteger(message.avgMs) && !(message.avgMs && $util.isInteger(message.avgMs.low) && $util.isInteger(message.avgMs.high)))
                                    return "avgMs: integer|Long expected";
                            }
                            if (message.duration != null && message.hasOwnProperty("duration")) {
                                properties._duration = 1;
                                if (!$util.isString(message.duration))
                                    return "duration: string expected";
                            }
                            if (message.maxMs != null && message.hasOwnProperty("maxMs")) {
                                properties._maxMs = 1;
                                if (!$util.isInteger(message.maxMs) && !(message.maxMs && $util.isInteger(message.maxMs.low) && $util.isInteger(message.maxMs.high)))
                                    return "maxMs: integer|Long expected";
                            }
                            if (message.minMs != null && message.hasOwnProperty("minMs")) {
                                properties._minMs = 1;
                                if (!$util.isInteger(message.minMs) && !(message.minMs && $util.isInteger(message.minMs.low) && $util.isInteger(message.minMs.high)))
                                    return "minMs: integer|Long expected";
                            }
                            if (message.numIntervals != null && message.hasOwnProperty("numIntervals")) {
                                properties._numIntervals = 1;
                                if (!$util.isInteger(message.numIntervals) && !(message.numIntervals && $util.isInteger(message.numIntervals.low) && $util.isInteger(message.numIntervals.high)))
                                    return "numIntervals: integer|Long expected";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PacketIntervals message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PacketIntervals} PacketIntervals
                         */
                        PacketIntervals.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PacketIntervals)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PacketIntervals();
                            if (object.avgMs != null)
                                if ($util.Long)
                                    (message.avgMs = $util.Long.fromValue(object.avgMs)).unsigned = false;
                                else if (typeof object.avgMs === "string")
                                    message.avgMs = parseInt(object.avgMs, 10);
                                else if (typeof object.avgMs === "number")
                                    message.avgMs = object.avgMs;
                                else if (typeof object.avgMs === "object")
                                    message.avgMs = new $util.LongBits(object.avgMs.low >>> 0, object.avgMs.high >>> 0).toNumber();
                            if (object.duration != null)
                                message.duration = String(object.duration);
                            if (object.maxMs != null)
                                if ($util.Long)
                                    (message.maxMs = $util.Long.fromValue(object.maxMs)).unsigned = false;
                                else if (typeof object.maxMs === "string")
                                    message.maxMs = parseInt(object.maxMs, 10);
                                else if (typeof object.maxMs === "number")
                                    message.maxMs = object.maxMs;
                                else if (typeof object.maxMs === "object")
                                    message.maxMs = new $util.LongBits(object.maxMs.low >>> 0, object.maxMs.high >>> 0).toNumber();
                            if (object.minMs != null)
                                if ($util.Long)
                                    (message.minMs = $util.Long.fromValue(object.minMs)).unsigned = false;
                                else if (typeof object.minMs === "string")
                                    message.minMs = parseInt(object.minMs, 10);
                                else if (typeof object.minMs === "number")
                                    message.minMs = object.minMs;
                                else if (typeof object.minMs === "object")
                                    message.minMs = new $util.LongBits(object.minMs.low >>> 0, object.minMs.high >>> 0).toNumber();
                            if (object.numIntervals != null)
                                if ($util.Long)
                                    (message.numIntervals = $util.Long.fromValue(object.numIntervals)).unsigned = false;
                                else if (typeof object.numIntervals === "string")
                                    message.numIntervals = parseInt(object.numIntervals, 10);
                                else if (typeof object.numIntervals === "number")
                                    message.numIntervals = object.numIntervals;
                                else if (typeof object.numIntervals === "object")
                                    message.numIntervals = new $util.LongBits(object.numIntervals.low >>> 0, object.numIntervals.high >>> 0).toNumber();
                            if (object.type != null)
                                message.type = String(object.type);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PacketIntervals message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @static
                         * @param {google.cloud.compute.v1.PacketIntervals} message PacketIntervals
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PacketIntervals.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            if (message.duration != null && message.hasOwnProperty("duration")) {
                                object.duration = message.duration;
                                if (options.oneofs)
                                    object._duration = "duration";
                            }
                            if (message.numIntervals != null && message.hasOwnProperty("numIntervals")) {
                                if (typeof message.numIntervals === "number")
                                    object.numIntervals = options.longs === String ? String(message.numIntervals) : message.numIntervals;
                                else
                                    object.numIntervals = options.longs === String ? $util.Long.prototype.toString.call(message.numIntervals) : options.longs === Number ? new $util.LongBits(message.numIntervals.low >>> 0, message.numIntervals.high >>> 0).toNumber() : message.numIntervals;
                                if (options.oneofs)
                                    object._numIntervals = "numIntervals";
                            }
                            if (message.avgMs != null && message.hasOwnProperty("avgMs")) {
                                if (typeof message.avgMs === "number")
                                    object.avgMs = options.longs === String ? String(message.avgMs) : message.avgMs;
                                else
                                    object.avgMs = options.longs === String ? $util.Long.prototype.toString.call(message.avgMs) : options.longs === Number ? new $util.LongBits(message.avgMs.low >>> 0, message.avgMs.high >>> 0).toNumber() : message.avgMs;
                                if (options.oneofs)
                                    object._avgMs = "avgMs";
                            }
                            if (message.maxMs != null && message.hasOwnProperty("maxMs")) {
                                if (typeof message.maxMs === "number")
                                    object.maxMs = options.longs === String ? String(message.maxMs) : message.maxMs;
                                else
                                    object.maxMs = options.longs === String ? $util.Long.prototype.toString.call(message.maxMs) : options.longs === Number ? new $util.LongBits(message.maxMs.low >>> 0, message.maxMs.high >>> 0).toNumber() : message.maxMs;
                                if (options.oneofs)
                                    object._maxMs = "maxMs";
                            }
                            if (message.minMs != null && message.hasOwnProperty("minMs")) {
                                if (typeof message.minMs === "number")
                                    object.minMs = options.longs === String ? String(message.minMs) : message.minMs;
                                else
                                    object.minMs = options.longs === String ? $util.Long.prototype.toString.call(message.minMs) : options.longs === Number ? new $util.LongBits(message.minMs.low >>> 0, message.minMs.high >>> 0).toNumber() : message.minMs;
                                if (options.oneofs)
                                    object._minMs = "minMs";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PacketIntervals to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PacketIntervals.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PacketIntervals
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PacketIntervals
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PacketIntervals.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PacketIntervals";
                        };
    
                        /**
                         * Duration enum.
                         * @name google.cloud.compute.v1.PacketIntervals.Duration
                         * @enum {number}
                         * @property {number} UNDEFINED_DURATION=0 UNDEFINED_DURATION value
                         * @property {number} DURATION_UNSPECIFIED=529071340 DURATION_UNSPECIFIED value
                         * @property {number} HOUR=2223588 HOUR value
                         * @property {number} MAX=76100 MAX value
                         * @property {number} MINUTE=126786068 MINUTE value
                         */
                        PacketIntervals.Duration = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_DURATION"] = 0;
                            values[valuesById[529071340] = "DURATION_UNSPECIFIED"] = 529071340;
                            values[valuesById[2223588] = "HOUR"] = 2223588;
                            values[valuesById[76100] = "MAX"] = 76100;
                            values[valuesById[126786068] = "MINUTE"] = 126786068;
                            return values;
                        })();
    
                        /**
                         * Type enum.
                         * @name google.cloud.compute.v1.PacketIntervals.Type
                         * @enum {number}
                         * @property {number} UNDEFINED_TYPE=0 UNDEFINED_TYPE value
                         * @property {number} LOOPBACK=356174219 LOOPBACK value
                         * @property {number} RECEIVE=189660867 RECEIVE value
                         * @property {number} TRANSMIT=452903600 TRANSMIT value
                         * @property {number} TYPE_UNSPECIFIED=437714322 TYPE_UNSPECIFIED value
                         */
                        PacketIntervals.Type = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TYPE"] = 0;
                            values[valuesById[356174219] = "LOOPBACK"] = 356174219;
                            values[valuesById[189660867] = "RECEIVE"] = 189660867;
                            values[valuesById[452903600] = "TRANSMIT"] = 452903600;
                            values[valuesById[437714322] = "TYPE_UNSPECIFIED"] = 437714322;
                            return values;
                        })();
    
                        return PacketIntervals;
                    })();
    
                    v1.PacketMirroring = (function() {
    
                        /**
                         * Properties of a PacketMirroring.
                         * @memberof google.cloud.compute.v1
                         * @interface IPacketMirroring
                         * @property {google.cloud.compute.v1.IPacketMirroringForwardingRuleInfo|null} [collectorIlb] PacketMirroring collectorIlb
                         * @property {string|null} [creationTimestamp] PacketMirroring creationTimestamp
                         * @property {string|null} [description] PacketMirroring description
                         * @property {string|null} [enable] PacketMirroring enable
                         * @property {google.cloud.compute.v1.IPacketMirroringFilter|null} [filter] PacketMirroring filter
                         * @property {number|Long|null} [id] PacketMirroring id
                         * @property {string|null} [kind] PacketMirroring kind
                         * @property {google.cloud.compute.v1.IPacketMirroringMirroredResourceInfo|null} [mirroredResources] PacketMirroring mirroredResources
                         * @property {string|null} [name] PacketMirroring name
                         * @property {google.cloud.compute.v1.IPacketMirroringNetworkInfo|null} [network] PacketMirroring network
                         * @property {number|null} [priority] PacketMirroring priority
                         * @property {string|null} [region] PacketMirroring region
                         * @property {string|null} [selfLink] PacketMirroring selfLink
                         */
    
                        /**
                         * Constructs a new PacketMirroring.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PacketMirroring.
                         * @implements IPacketMirroring
                         * @constructor
                         * @param {google.cloud.compute.v1.IPacketMirroring=} [properties] Properties to set
                         */
                        function PacketMirroring(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PacketMirroring collectorIlb.
                         * @member {google.cloud.compute.v1.IPacketMirroringForwardingRuleInfo|null|undefined} collectorIlb
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        PacketMirroring.prototype.collectorIlb = null;
    
                        /**
                         * PacketMirroring creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        PacketMirroring.prototype.creationTimestamp = null;
    
                        /**
                         * PacketMirroring description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        PacketMirroring.prototype.description = null;
    
                        /**
                         * PacketMirroring enable.
                         * @member {string|null|undefined} enable
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        PacketMirroring.prototype.enable = null;
    
                        /**
                         * PacketMirroring filter.
                         * @member {google.cloud.compute.v1.IPacketMirroringFilter|null|undefined} filter
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        PacketMirroring.prototype.filter = null;
    
                        /**
                         * PacketMirroring id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        PacketMirroring.prototype.id = null;
    
                        /**
                         * PacketMirroring kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        PacketMirroring.prototype.kind = null;
    
                        /**
                         * PacketMirroring mirroredResources.
                         * @member {google.cloud.compute.v1.IPacketMirroringMirroredResourceInfo|null|undefined} mirroredResources
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        PacketMirroring.prototype.mirroredResources = null;
    
                        /**
                         * PacketMirroring name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        PacketMirroring.prototype.name = null;
    
                        /**
                         * PacketMirroring network.
                         * @member {google.cloud.compute.v1.IPacketMirroringNetworkInfo|null|undefined} network
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        PacketMirroring.prototype.network = null;
    
                        /**
                         * PacketMirroring priority.
                         * @member {number|null|undefined} priority
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        PacketMirroring.prototype.priority = null;
    
                        /**
                         * PacketMirroring region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        PacketMirroring.prototype.region = null;
    
                        /**
                         * PacketMirroring selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        PacketMirroring.prototype.selfLink = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PacketMirroring _collectorIlb.
                         * @member {"collectorIlb"|undefined} _collectorIlb
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        Object.defineProperty(PacketMirroring.prototype, "_collectorIlb", {
                            get: $util.oneOfGetter($oneOfFields = ["collectorIlb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroring _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        Object.defineProperty(PacketMirroring.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroring _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        Object.defineProperty(PacketMirroring.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroring _enable.
                         * @member {"enable"|undefined} _enable
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        Object.defineProperty(PacketMirroring.prototype, "_enable", {
                            get: $util.oneOfGetter($oneOfFields = ["enable"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroring _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        Object.defineProperty(PacketMirroring.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroring _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        Object.defineProperty(PacketMirroring.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroring _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        Object.defineProperty(PacketMirroring.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroring _mirroredResources.
                         * @member {"mirroredResources"|undefined} _mirroredResources
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        Object.defineProperty(PacketMirroring.prototype, "_mirroredResources", {
                            get: $util.oneOfGetter($oneOfFields = ["mirroredResources"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroring _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        Object.defineProperty(PacketMirroring.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroring _network.
                         * @member {"network"|undefined} _network
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        Object.defineProperty(PacketMirroring.prototype, "_network", {
                            get: $util.oneOfGetter($oneOfFields = ["network"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroring _priority.
                         * @member {"priority"|undefined} _priority
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        Object.defineProperty(PacketMirroring.prototype, "_priority", {
                            get: $util.oneOfGetter($oneOfFields = ["priority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroring _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        Object.defineProperty(PacketMirroring.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroring _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         */
                        Object.defineProperty(PacketMirroring.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PacketMirroring instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroring=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PacketMirroring} PacketMirroring instance
                         */
                        PacketMirroring.create = function create(properties) {
                            return new PacketMirroring(properties);
                        };
    
                        /**
                         * Encodes the specified PacketMirroring message. Does not implicitly {@link google.cloud.compute.v1.PacketMirroring.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroring} message PacketMirroring message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketMirroring.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.mirroredResources != null && Object.hasOwnProperty.call(message, "mirroredResources"))
                                $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfo.encode(message.mirroredResources, writer.uint32(/* id 124817348, wireType 2 =*/998538786).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                $root.google.cloud.compute.v1.PacketMirroringNetworkInfo.encode(message.network, writer.uint32(/* id 232872494, wireType 2 =*/1862979954).fork()).ldelim();
                            if (message.enable != null && Object.hasOwnProperty.call(message, "enable"))
                                writer.uint32(/* id 311764355, wireType 2 =*/2494114842).string(message.enable);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                $root.google.cloud.compute.v1.PacketMirroringFilter.encode(message.filter, writer.uint32(/* id 336120696, wireType 2 =*/2688965570).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.collectorIlb != null && Object.hasOwnProperty.call(message, "collectorIlb"))
                                $root.google.cloud.compute.v1.PacketMirroringForwardingRuleInfo.encode(message.collectorIlb, writer.uint32(/* id 426607853, wireType 2 =*/3412862826).fork()).ldelim();
                            if (message.priority != null && Object.hasOwnProperty.call(message, "priority"))
                                writer.uint32(/* id 445151652, wireType 0 =*/3561213216).uint32(message.priority);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PacketMirroring message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PacketMirroring.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroring} message PacketMirroring message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketMirroring.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PacketMirroring message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PacketMirroring} PacketMirroring
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketMirroring.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PacketMirroring();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 426607853: {
                                        message.collectorIlb = $root.google.cloud.compute.v1.PacketMirroringForwardingRuleInfo.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 311764355: {
                                        message.enable = reader.string();
                                        break;
                                    }
                                case 336120696: {
                                        message.filter = $root.google.cloud.compute.v1.PacketMirroringFilter.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 124817348: {
                                        message.mirroredResources = $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfo.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 232872494: {
                                        message.network = $root.google.cloud.compute.v1.PacketMirroringNetworkInfo.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 445151652: {
                                        message.priority = reader.uint32();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PacketMirroring message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PacketMirroring} PacketMirroring
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketMirroring.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PacketMirroring message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PacketMirroring.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.collectorIlb != null && message.hasOwnProperty("collectorIlb")) {
                                properties._collectorIlb = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.PacketMirroringForwardingRuleInfo.verify(message.collectorIlb);
                                    if (error)
                                        return "collectorIlb." + error;
                                }
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.enable != null && message.hasOwnProperty("enable")) {
                                properties._enable = 1;
                                if (!$util.isString(message.enable))
                                    return "enable: string expected";
                            }
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.PacketMirroringFilter.verify(message.filter);
                                    if (error)
                                        return "filter." + error;
                                }
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.mirroredResources != null && message.hasOwnProperty("mirroredResources")) {
                                properties._mirroredResources = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfo.verify(message.mirroredResources);
                                    if (error)
                                        return "mirroredResources." + error;
                                }
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                properties._network = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.PacketMirroringNetworkInfo.verify(message.network);
                                    if (error)
                                        return "network." + error;
                                }
                            }
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                properties._priority = 1;
                                if (!$util.isInteger(message.priority))
                                    return "priority: integer expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PacketMirroring message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PacketMirroring} PacketMirroring
                         */
                        PacketMirroring.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PacketMirroring)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PacketMirroring();
                            if (object.collectorIlb != null) {
                                if (typeof object.collectorIlb !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PacketMirroring.collectorIlb: object expected");
                                message.collectorIlb = $root.google.cloud.compute.v1.PacketMirroringForwardingRuleInfo.fromObject(object.collectorIlb);
                            }
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.enable != null)
                                message.enable = String(object.enable);
                            if (object.filter != null) {
                                if (typeof object.filter !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PacketMirroring.filter: object expected");
                                message.filter = $root.google.cloud.compute.v1.PacketMirroringFilter.fromObject(object.filter);
                            }
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.mirroredResources != null) {
                                if (typeof object.mirroredResources !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PacketMirroring.mirroredResources: object expected");
                                message.mirroredResources = $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfo.fromObject(object.mirroredResources);
                            }
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.network != null) {
                                if (typeof object.network !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PacketMirroring.network: object expected");
                                message.network = $root.google.cloud.compute.v1.PacketMirroringNetworkInfo.fromObject(object.network);
                            }
                            if (object.priority != null)
                                message.priority = object.priority >>> 0;
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PacketMirroring message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @static
                         * @param {google.cloud.compute.v1.PacketMirroring} message PacketMirroring
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PacketMirroring.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.mirroredResources != null && message.hasOwnProperty("mirroredResources")) {
                                object.mirroredResources = $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfo.toObject(message.mirroredResources, options);
                                if (options.oneofs)
                                    object._mirroredResources = "mirroredResources";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                object.network = $root.google.cloud.compute.v1.PacketMirroringNetworkInfo.toObject(message.network, options);
                                if (options.oneofs)
                                    object._network = "network";
                            }
                            if (message.enable != null && message.hasOwnProperty("enable")) {
                                object.enable = message.enable;
                                if (options.oneofs)
                                    object._enable = "enable";
                            }
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = $root.google.cloud.compute.v1.PacketMirroringFilter.toObject(message.filter, options);
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.collectorIlb != null && message.hasOwnProperty("collectorIlb")) {
                                object.collectorIlb = $root.google.cloud.compute.v1.PacketMirroringForwardingRuleInfo.toObject(message.collectorIlb, options);
                                if (options.oneofs)
                                    object._collectorIlb = "collectorIlb";
                            }
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                object.priority = message.priority;
                                if (options.oneofs)
                                    object._priority = "priority";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PacketMirroring to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PacketMirroring.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PacketMirroring
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PacketMirroring
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PacketMirroring.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PacketMirroring";
                        };
    
                        /**
                         * Enable enum.
                         * @name google.cloud.compute.v1.PacketMirroring.Enable
                         * @enum {number}
                         * @property {number} UNDEFINED_ENABLE=0 UNDEFINED_ENABLE value
                         * @property {number} FALSE=66658563 FALSE value
                         * @property {number} TRUE=2583950 TRUE value
                         */
                        PacketMirroring.Enable = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ENABLE"] = 0;
                            values[valuesById[66658563] = "FALSE"] = 66658563;
                            values[valuesById[2583950] = "TRUE"] = 2583950;
                            return values;
                        })();
    
                        return PacketMirroring;
                    })();
    
                    v1.PacketMirroringAggregatedList = (function() {
    
                        /**
                         * Properties of a PacketMirroringAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IPacketMirroringAggregatedList
                         * @property {string|null} [id] PacketMirroringAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IPacketMirroringsScopedList>|null} [items] PacketMirroringAggregatedList items
                         * @property {string|null} [kind] PacketMirroringAggregatedList kind
                         * @property {string|null} [nextPageToken] PacketMirroringAggregatedList nextPageToken
                         * @property {string|null} [selfLink] PacketMirroringAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] PacketMirroringAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] PacketMirroringAggregatedList warning
                         */
    
                        /**
                         * Constructs a new PacketMirroringAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PacketMirroringAggregatedList.
                         * @implements IPacketMirroringAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IPacketMirroringAggregatedList=} [properties] Properties to set
                         */
                        function PacketMirroringAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PacketMirroringAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @instance
                         */
                        PacketMirroringAggregatedList.prototype.id = null;
    
                        /**
                         * PacketMirroringAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IPacketMirroringsScopedList>} items
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @instance
                         */
                        PacketMirroringAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * PacketMirroringAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @instance
                         */
                        PacketMirroringAggregatedList.prototype.kind = null;
    
                        /**
                         * PacketMirroringAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @instance
                         */
                        PacketMirroringAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * PacketMirroringAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @instance
                         */
                        PacketMirroringAggregatedList.prototype.selfLink = null;
    
                        /**
                         * PacketMirroringAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @instance
                         */
                        PacketMirroringAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * PacketMirroringAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @instance
                         */
                        PacketMirroringAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PacketMirroringAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @instance
                         */
                        Object.defineProperty(PacketMirroringAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroringAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @instance
                         */
                        Object.defineProperty(PacketMirroringAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroringAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @instance
                         */
                        Object.defineProperty(PacketMirroringAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroringAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @instance
                         */
                        Object.defineProperty(PacketMirroringAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroringAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @instance
                         */
                        Object.defineProperty(PacketMirroringAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PacketMirroringAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PacketMirroringAggregatedList} PacketMirroringAggregatedList instance
                         */
                        PacketMirroringAggregatedList.create = function create(properties) {
                            return new PacketMirroringAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified PacketMirroringAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.PacketMirroringAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringAggregatedList} message PacketMirroringAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketMirroringAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.PacketMirroringsScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PacketMirroringAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PacketMirroringAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringAggregatedList} message PacketMirroringAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketMirroringAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PacketMirroringAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PacketMirroringAggregatedList} PacketMirroringAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketMirroringAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PacketMirroringAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.PacketMirroringsScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PacketMirroringAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PacketMirroringAggregatedList} PacketMirroringAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketMirroringAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PacketMirroringAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PacketMirroringAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PacketMirroringsScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PacketMirroringAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PacketMirroringAggregatedList} PacketMirroringAggregatedList
                         */
                        PacketMirroringAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PacketMirroringAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PacketMirroringAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PacketMirroringAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.PacketMirroringAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.PacketMirroringsScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.PacketMirroringAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PacketMirroringAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PacketMirroringAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.PacketMirroringAggregatedList} message PacketMirroringAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PacketMirroringAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.PacketMirroringsScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PacketMirroringAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PacketMirroringAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PacketMirroringAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PacketMirroringAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PacketMirroringAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PacketMirroringAggregatedList";
                        };
    
                        return PacketMirroringAggregatedList;
                    })();
    
                    v1.PacketMirroringFilter = (function() {
    
                        /**
                         * Properties of a PacketMirroringFilter.
                         * @memberof google.cloud.compute.v1
                         * @interface IPacketMirroringFilter
                         * @property {Array.<string>|null} [IPProtocols] PacketMirroringFilter IPProtocols
                         * @property {Array.<string>|null} [cidrRanges] PacketMirroringFilter cidrRanges
                         * @property {string|null} [direction] PacketMirroringFilter direction
                         */
    
                        /**
                         * Constructs a new PacketMirroringFilter.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PacketMirroringFilter.
                         * @implements IPacketMirroringFilter
                         * @constructor
                         * @param {google.cloud.compute.v1.IPacketMirroringFilter=} [properties] Properties to set
                         */
                        function PacketMirroringFilter(properties) {
                            this.IPProtocols = [];
                            this.cidrRanges = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PacketMirroringFilter IPProtocols.
                         * @member {Array.<string>} IPProtocols
                         * @memberof google.cloud.compute.v1.PacketMirroringFilter
                         * @instance
                         */
                        PacketMirroringFilter.prototype.IPProtocols = $util.emptyArray;
    
                        /**
                         * PacketMirroringFilter cidrRanges.
                         * @member {Array.<string>} cidrRanges
                         * @memberof google.cloud.compute.v1.PacketMirroringFilter
                         * @instance
                         */
                        PacketMirroringFilter.prototype.cidrRanges = $util.emptyArray;
    
                        /**
                         * PacketMirroringFilter direction.
                         * @member {string|null|undefined} direction
                         * @memberof google.cloud.compute.v1.PacketMirroringFilter
                         * @instance
                         */
                        PacketMirroringFilter.prototype.direction = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PacketMirroringFilter _direction.
                         * @member {"direction"|undefined} _direction
                         * @memberof google.cloud.compute.v1.PacketMirroringFilter
                         * @instance
                         */
                        Object.defineProperty(PacketMirroringFilter.prototype, "_direction", {
                            get: $util.oneOfGetter($oneOfFields = ["direction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PacketMirroringFilter instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PacketMirroringFilter
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringFilter=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PacketMirroringFilter} PacketMirroringFilter instance
                         */
                        PacketMirroringFilter.create = function create(properties) {
                            return new PacketMirroringFilter(properties);
                        };
    
                        /**
                         * Encodes the specified PacketMirroringFilter message. Does not implicitly {@link google.cloud.compute.v1.PacketMirroringFilter.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PacketMirroringFilter
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringFilter} message PacketMirroringFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketMirroringFilter.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.IPProtocols != null && message.IPProtocols.length)
                                for (var i = 0; i < message.IPProtocols.length; ++i)
                                    writer.uint32(/* id 98544854, wireType 2 =*/788358834).string(message.IPProtocols[i]);
                            if (message.direction != null && Object.hasOwnProperty.call(message, "direction"))
                                writer.uint32(/* id 111150975, wireType 2 =*/889207802).string(message.direction);
                            if (message.cidrRanges != null && message.cidrRanges.length)
                                for (var i = 0; i < message.cidrRanges.length; ++i)
                                    writer.uint32(/* id 487901697, wireType 2 =*/3903213578).string(message.cidrRanges[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PacketMirroringFilter message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PacketMirroringFilter.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PacketMirroringFilter
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringFilter} message PacketMirroringFilter message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketMirroringFilter.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PacketMirroringFilter message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PacketMirroringFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PacketMirroringFilter} PacketMirroringFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketMirroringFilter.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PacketMirroringFilter();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 98544854: {
                                        if (!(message.IPProtocols && message.IPProtocols.length))
                                            message.IPProtocols = [];
                                        message.IPProtocols.push(reader.string());
                                        break;
                                    }
                                case 487901697: {
                                        if (!(message.cidrRanges && message.cidrRanges.length))
                                            message.cidrRanges = [];
                                        message.cidrRanges.push(reader.string());
                                        break;
                                    }
                                case 111150975: {
                                        message.direction = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PacketMirroringFilter message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PacketMirroringFilter
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PacketMirroringFilter} PacketMirroringFilter
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketMirroringFilter.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PacketMirroringFilter message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PacketMirroringFilter
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PacketMirroringFilter.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.IPProtocols != null && message.hasOwnProperty("IPProtocols")) {
                                if (!Array.isArray(message.IPProtocols))
                                    return "IPProtocols: array expected";
                                for (var i = 0; i < message.IPProtocols.length; ++i)
                                    if (!$util.isString(message.IPProtocols[i]))
                                        return "IPProtocols: string[] expected";
                            }
                            if (message.cidrRanges != null && message.hasOwnProperty("cidrRanges")) {
                                if (!Array.isArray(message.cidrRanges))
                                    return "cidrRanges: array expected";
                                for (var i = 0; i < message.cidrRanges.length; ++i)
                                    if (!$util.isString(message.cidrRanges[i]))
                                        return "cidrRanges: string[] expected";
                            }
                            if (message.direction != null && message.hasOwnProperty("direction")) {
                                properties._direction = 1;
                                if (!$util.isString(message.direction))
                                    return "direction: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PacketMirroringFilter message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PacketMirroringFilter
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PacketMirroringFilter} PacketMirroringFilter
                         */
                        PacketMirroringFilter.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PacketMirroringFilter)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PacketMirroringFilter();
                            if (object.IPProtocols) {
                                if (!Array.isArray(object.IPProtocols))
                                    throw TypeError(".google.cloud.compute.v1.PacketMirroringFilter.IPProtocols: array expected");
                                message.IPProtocols = [];
                                for (var i = 0; i < object.IPProtocols.length; ++i)
                                    message.IPProtocols[i] = String(object.IPProtocols[i]);
                            }
                            if (object.cidrRanges) {
                                if (!Array.isArray(object.cidrRanges))
                                    throw TypeError(".google.cloud.compute.v1.PacketMirroringFilter.cidrRanges: array expected");
                                message.cidrRanges = [];
                                for (var i = 0; i < object.cidrRanges.length; ++i)
                                    message.cidrRanges[i] = String(object.cidrRanges[i]);
                            }
                            if (object.direction != null)
                                message.direction = String(object.direction);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PacketMirroringFilter message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PacketMirroringFilter
                         * @static
                         * @param {google.cloud.compute.v1.PacketMirroringFilter} message PacketMirroringFilter
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PacketMirroringFilter.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.IPProtocols = [];
                                object.cidrRanges = [];
                            }
                            if (message.IPProtocols && message.IPProtocols.length) {
                                object.IPProtocols = [];
                                for (var j = 0; j < message.IPProtocols.length; ++j)
                                    object.IPProtocols[j] = message.IPProtocols[j];
                            }
                            if (message.direction != null && message.hasOwnProperty("direction")) {
                                object.direction = message.direction;
                                if (options.oneofs)
                                    object._direction = "direction";
                            }
                            if (message.cidrRanges && message.cidrRanges.length) {
                                object.cidrRanges = [];
                                for (var j = 0; j < message.cidrRanges.length; ++j)
                                    object.cidrRanges[j] = message.cidrRanges[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PacketMirroringFilter to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PacketMirroringFilter
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PacketMirroringFilter.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PacketMirroringFilter
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PacketMirroringFilter
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PacketMirroringFilter.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PacketMirroringFilter";
                        };
    
                        /**
                         * Direction enum.
                         * @name google.cloud.compute.v1.PacketMirroringFilter.Direction
                         * @enum {number}
                         * @property {number} UNDEFINED_DIRECTION=0 UNDEFINED_DIRECTION value
                         * @property {number} BOTH=2044801 BOTH value
                         * @property {number} EGRESS=432880501 EGRESS value
                         * @property {number} INGRESS=516931221 INGRESS value
                         */
                        PacketMirroringFilter.Direction = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_DIRECTION"] = 0;
                            values[valuesById[2044801] = "BOTH"] = 2044801;
                            values[valuesById[432880501] = "EGRESS"] = 432880501;
                            values[valuesById[516931221] = "INGRESS"] = 516931221;
                            return values;
                        })();
    
                        return PacketMirroringFilter;
                    })();
    
                    v1.PacketMirroringForwardingRuleInfo = (function() {
    
                        /**
                         * Properties of a PacketMirroringForwardingRuleInfo.
                         * @memberof google.cloud.compute.v1
                         * @interface IPacketMirroringForwardingRuleInfo
                         * @property {string|null} [canonicalUrl] PacketMirroringForwardingRuleInfo canonicalUrl
                         * @property {string|null} [url] PacketMirroringForwardingRuleInfo url
                         */
    
                        /**
                         * Constructs a new PacketMirroringForwardingRuleInfo.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PacketMirroringForwardingRuleInfo.
                         * @implements IPacketMirroringForwardingRuleInfo
                         * @constructor
                         * @param {google.cloud.compute.v1.IPacketMirroringForwardingRuleInfo=} [properties] Properties to set
                         */
                        function PacketMirroringForwardingRuleInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PacketMirroringForwardingRuleInfo canonicalUrl.
                         * @member {string|null|undefined} canonicalUrl
                         * @memberof google.cloud.compute.v1.PacketMirroringForwardingRuleInfo
                         * @instance
                         */
                        PacketMirroringForwardingRuleInfo.prototype.canonicalUrl = null;
    
                        /**
                         * PacketMirroringForwardingRuleInfo url.
                         * @member {string|null|undefined} url
                         * @memberof google.cloud.compute.v1.PacketMirroringForwardingRuleInfo
                         * @instance
                         */
                        PacketMirroringForwardingRuleInfo.prototype.url = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PacketMirroringForwardingRuleInfo _canonicalUrl.
                         * @member {"canonicalUrl"|undefined} _canonicalUrl
                         * @memberof google.cloud.compute.v1.PacketMirroringForwardingRuleInfo
                         * @instance
                         */
                        Object.defineProperty(PacketMirroringForwardingRuleInfo.prototype, "_canonicalUrl", {
                            get: $util.oneOfGetter($oneOfFields = ["canonicalUrl"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroringForwardingRuleInfo _url.
                         * @member {"url"|undefined} _url
                         * @memberof google.cloud.compute.v1.PacketMirroringForwardingRuleInfo
                         * @instance
                         */
                        Object.defineProperty(PacketMirroringForwardingRuleInfo.prototype, "_url", {
                            get: $util.oneOfGetter($oneOfFields = ["url"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PacketMirroringForwardingRuleInfo instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PacketMirroringForwardingRuleInfo
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringForwardingRuleInfo=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PacketMirroringForwardingRuleInfo} PacketMirroringForwardingRuleInfo instance
                         */
                        PacketMirroringForwardingRuleInfo.create = function create(properties) {
                            return new PacketMirroringForwardingRuleInfo(properties);
                        };
    
                        /**
                         * Encodes the specified PacketMirroringForwardingRuleInfo message. Does not implicitly {@link google.cloud.compute.v1.PacketMirroringForwardingRuleInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PacketMirroringForwardingRuleInfo
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringForwardingRuleInfo} message PacketMirroringForwardingRuleInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketMirroringForwardingRuleInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.url != null && Object.hasOwnProperty.call(message, "url"))
                                writer.uint32(/* id 116079, wireType 2 =*/928634).string(message.url);
                            if (message.canonicalUrl != null && Object.hasOwnProperty.call(message, "canonicalUrl"))
                                writer.uint32(/* id 512294820, wireType 2 =*/4098358562).string(message.canonicalUrl);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PacketMirroringForwardingRuleInfo message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PacketMirroringForwardingRuleInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PacketMirroringForwardingRuleInfo
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringForwardingRuleInfo} message PacketMirroringForwardingRuleInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketMirroringForwardingRuleInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PacketMirroringForwardingRuleInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PacketMirroringForwardingRuleInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PacketMirroringForwardingRuleInfo} PacketMirroringForwardingRuleInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketMirroringForwardingRuleInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PacketMirroringForwardingRuleInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 512294820: {
                                        message.canonicalUrl = reader.string();
                                        break;
                                    }
                                case 116079: {
                                        message.url = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PacketMirroringForwardingRuleInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PacketMirroringForwardingRuleInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PacketMirroringForwardingRuleInfo} PacketMirroringForwardingRuleInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketMirroringForwardingRuleInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PacketMirroringForwardingRuleInfo message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PacketMirroringForwardingRuleInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PacketMirroringForwardingRuleInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.canonicalUrl != null && message.hasOwnProperty("canonicalUrl")) {
                                properties._canonicalUrl = 1;
                                if (!$util.isString(message.canonicalUrl))
                                    return "canonicalUrl: string expected";
                            }
                            if (message.url != null && message.hasOwnProperty("url")) {
                                properties._url = 1;
                                if (!$util.isString(message.url))
                                    return "url: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PacketMirroringForwardingRuleInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PacketMirroringForwardingRuleInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PacketMirroringForwardingRuleInfo} PacketMirroringForwardingRuleInfo
                         */
                        PacketMirroringForwardingRuleInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PacketMirroringForwardingRuleInfo)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PacketMirroringForwardingRuleInfo();
                            if (object.canonicalUrl != null)
                                message.canonicalUrl = String(object.canonicalUrl);
                            if (object.url != null)
                                message.url = String(object.url);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PacketMirroringForwardingRuleInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PacketMirroringForwardingRuleInfo
                         * @static
                         * @param {google.cloud.compute.v1.PacketMirroringForwardingRuleInfo} message PacketMirroringForwardingRuleInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PacketMirroringForwardingRuleInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.url != null && message.hasOwnProperty("url")) {
                                object.url = message.url;
                                if (options.oneofs)
                                    object._url = "url";
                            }
                            if (message.canonicalUrl != null && message.hasOwnProperty("canonicalUrl")) {
                                object.canonicalUrl = message.canonicalUrl;
                                if (options.oneofs)
                                    object._canonicalUrl = "canonicalUrl";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PacketMirroringForwardingRuleInfo to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PacketMirroringForwardingRuleInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PacketMirroringForwardingRuleInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PacketMirroringForwardingRuleInfo
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PacketMirroringForwardingRuleInfo
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PacketMirroringForwardingRuleInfo.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PacketMirroringForwardingRuleInfo";
                        };
    
                        return PacketMirroringForwardingRuleInfo;
                    })();
    
                    v1.PacketMirroringList = (function() {
    
                        /**
                         * Properties of a PacketMirroringList.
                         * @memberof google.cloud.compute.v1
                         * @interface IPacketMirroringList
                         * @property {string|null} [id] PacketMirroringList id
                         * @property {Array.<google.cloud.compute.v1.IPacketMirroring>|null} [items] PacketMirroringList items
                         * @property {string|null} [kind] PacketMirroringList kind
                         * @property {string|null} [nextPageToken] PacketMirroringList nextPageToken
                         * @property {string|null} [selfLink] PacketMirroringList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] PacketMirroringList warning
                         */
    
                        /**
                         * Constructs a new PacketMirroringList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PacketMirroringList.
                         * @implements IPacketMirroringList
                         * @constructor
                         * @param {google.cloud.compute.v1.IPacketMirroringList=} [properties] Properties to set
                         */
                        function PacketMirroringList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PacketMirroringList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @instance
                         */
                        PacketMirroringList.prototype.id = null;
    
                        /**
                         * PacketMirroringList items.
                         * @member {Array.<google.cloud.compute.v1.IPacketMirroring>} items
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @instance
                         */
                        PacketMirroringList.prototype.items = $util.emptyArray;
    
                        /**
                         * PacketMirroringList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @instance
                         */
                        PacketMirroringList.prototype.kind = null;
    
                        /**
                         * PacketMirroringList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @instance
                         */
                        PacketMirroringList.prototype.nextPageToken = null;
    
                        /**
                         * PacketMirroringList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @instance
                         */
                        PacketMirroringList.prototype.selfLink = null;
    
                        /**
                         * PacketMirroringList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @instance
                         */
                        PacketMirroringList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PacketMirroringList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @instance
                         */
                        Object.defineProperty(PacketMirroringList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroringList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @instance
                         */
                        Object.defineProperty(PacketMirroringList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroringList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @instance
                         */
                        Object.defineProperty(PacketMirroringList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroringList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @instance
                         */
                        Object.defineProperty(PacketMirroringList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroringList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @instance
                         */
                        Object.defineProperty(PacketMirroringList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PacketMirroringList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PacketMirroringList} PacketMirroringList instance
                         */
                        PacketMirroringList.create = function create(properties) {
                            return new PacketMirroringList(properties);
                        };
    
                        /**
                         * Encodes the specified PacketMirroringList message. Does not implicitly {@link google.cloud.compute.v1.PacketMirroringList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringList} message PacketMirroringList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketMirroringList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.PacketMirroring.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PacketMirroringList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PacketMirroringList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringList} message PacketMirroringList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketMirroringList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PacketMirroringList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PacketMirroringList} PacketMirroringList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketMirroringList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PacketMirroringList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.PacketMirroring.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PacketMirroringList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PacketMirroringList} PacketMirroringList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketMirroringList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PacketMirroringList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PacketMirroringList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PacketMirroring.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PacketMirroringList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PacketMirroringList} PacketMirroringList
                         */
                        PacketMirroringList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PacketMirroringList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PacketMirroringList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.PacketMirroringList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.PacketMirroringList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.PacketMirroring.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PacketMirroringList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PacketMirroringList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @static
                         * @param {google.cloud.compute.v1.PacketMirroringList} message PacketMirroringList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PacketMirroringList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.PacketMirroring.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PacketMirroringList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PacketMirroringList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PacketMirroringList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PacketMirroringList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PacketMirroringList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PacketMirroringList";
                        };
    
                        return PacketMirroringList;
                    })();
    
                    v1.PacketMirroringMirroredResourceInfo = (function() {
    
                        /**
                         * Properties of a PacketMirroringMirroredResourceInfo.
                         * @memberof google.cloud.compute.v1
                         * @interface IPacketMirroringMirroredResourceInfo
                         * @property {Array.<google.cloud.compute.v1.IPacketMirroringMirroredResourceInfoInstanceInfo>|null} [instances] PacketMirroringMirroredResourceInfo instances
                         * @property {Array.<google.cloud.compute.v1.IPacketMirroringMirroredResourceInfoSubnetInfo>|null} [subnetworks] PacketMirroringMirroredResourceInfo subnetworks
                         * @property {Array.<string>|null} [tags] PacketMirroringMirroredResourceInfo tags
                         */
    
                        /**
                         * Constructs a new PacketMirroringMirroredResourceInfo.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PacketMirroringMirroredResourceInfo.
                         * @implements IPacketMirroringMirroredResourceInfo
                         * @constructor
                         * @param {google.cloud.compute.v1.IPacketMirroringMirroredResourceInfo=} [properties] Properties to set
                         */
                        function PacketMirroringMirroredResourceInfo(properties) {
                            this.instances = [];
                            this.subnetworks = [];
                            this.tags = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PacketMirroringMirroredResourceInfo instances.
                         * @member {Array.<google.cloud.compute.v1.IPacketMirroringMirroredResourceInfoInstanceInfo>} instances
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfo
                         * @instance
                         */
                        PacketMirroringMirroredResourceInfo.prototype.instances = $util.emptyArray;
    
                        /**
                         * PacketMirroringMirroredResourceInfo subnetworks.
                         * @member {Array.<google.cloud.compute.v1.IPacketMirroringMirroredResourceInfoSubnetInfo>} subnetworks
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfo
                         * @instance
                         */
                        PacketMirroringMirroredResourceInfo.prototype.subnetworks = $util.emptyArray;
    
                        /**
                         * PacketMirroringMirroredResourceInfo tags.
                         * @member {Array.<string>} tags
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfo
                         * @instance
                         */
                        PacketMirroringMirroredResourceInfo.prototype.tags = $util.emptyArray;
    
                        /**
                         * Creates a new PacketMirroringMirroredResourceInfo instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfo
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringMirroredResourceInfo=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PacketMirroringMirroredResourceInfo} PacketMirroringMirroredResourceInfo instance
                         */
                        PacketMirroringMirroredResourceInfo.create = function create(properties) {
                            return new PacketMirroringMirroredResourceInfo(properties);
                        };
    
                        /**
                         * Encodes the specified PacketMirroringMirroredResourceInfo message. Does not implicitly {@link google.cloud.compute.v1.PacketMirroringMirroredResourceInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfo
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringMirroredResourceInfo} message PacketMirroringMirroredResourceInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketMirroringMirroredResourceInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.tags != null && message.tags.length)
                                for (var i = 0; i < message.tags.length; ++i)
                                    writer.uint32(/* id 3552281, wireType 2 =*/28418250).string(message.tags[i]);
                            if (message.instances != null && message.instances.length)
                                for (var i = 0; i < message.instances.length; ++i)
                                    $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo.encode(message.instances[i], writer.uint32(/* id 29097598, wireType 2 =*/232780786).fork()).ldelim();
                            if (message.subnetworks != null && message.subnetworks.length)
                                for (var i = 0; i < message.subnetworks.length; ++i)
                                    $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo.encode(message.subnetworks[i], writer.uint32(/* id 415853125, wireType 2 =*/3326825002).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PacketMirroringMirroredResourceInfo message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PacketMirroringMirroredResourceInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfo
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringMirroredResourceInfo} message PacketMirroringMirroredResourceInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketMirroringMirroredResourceInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PacketMirroringMirroredResourceInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PacketMirroringMirroredResourceInfo} PacketMirroringMirroredResourceInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketMirroringMirroredResourceInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 29097598: {
                                        if (!(message.instances && message.instances.length))
                                            message.instances = [];
                                        message.instances.push($root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 415853125: {
                                        if (!(message.subnetworks && message.subnetworks.length))
                                            message.subnetworks = [];
                                        message.subnetworks.push($root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3552281: {
                                        if (!(message.tags && message.tags.length))
                                            message.tags = [];
                                        message.tags.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PacketMirroringMirroredResourceInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PacketMirroringMirroredResourceInfo} PacketMirroringMirroredResourceInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketMirroringMirroredResourceInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PacketMirroringMirroredResourceInfo message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PacketMirroringMirroredResourceInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instances != null && message.hasOwnProperty("instances")) {
                                if (!Array.isArray(message.instances))
                                    return "instances: array expected";
                                for (var i = 0; i < message.instances.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo.verify(message.instances[i]);
                                    if (error)
                                        return "instances." + error;
                                }
                            }
                            if (message.subnetworks != null && message.hasOwnProperty("subnetworks")) {
                                if (!Array.isArray(message.subnetworks))
                                    return "subnetworks: array expected";
                                for (var i = 0; i < message.subnetworks.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo.verify(message.subnetworks[i]);
                                    if (error)
                                        return "subnetworks." + error;
                                }
                            }
                            if (message.tags != null && message.hasOwnProperty("tags")) {
                                if (!Array.isArray(message.tags))
                                    return "tags: array expected";
                                for (var i = 0; i < message.tags.length; ++i)
                                    if (!$util.isString(message.tags[i]))
                                        return "tags: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PacketMirroringMirroredResourceInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PacketMirroringMirroredResourceInfo} PacketMirroringMirroredResourceInfo
                         */
                        PacketMirroringMirroredResourceInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfo)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfo();
                            if (object.instances) {
                                if (!Array.isArray(object.instances))
                                    throw TypeError(".google.cloud.compute.v1.PacketMirroringMirroredResourceInfo.instances: array expected");
                                message.instances = [];
                                for (var i = 0; i < object.instances.length; ++i) {
                                    if (typeof object.instances[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.PacketMirroringMirroredResourceInfo.instances: object expected");
                                    message.instances[i] = $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo.fromObject(object.instances[i]);
                                }
                            }
                            if (object.subnetworks) {
                                if (!Array.isArray(object.subnetworks))
                                    throw TypeError(".google.cloud.compute.v1.PacketMirroringMirroredResourceInfo.subnetworks: array expected");
                                message.subnetworks = [];
                                for (var i = 0; i < object.subnetworks.length; ++i) {
                                    if (typeof object.subnetworks[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.PacketMirroringMirroredResourceInfo.subnetworks: object expected");
                                    message.subnetworks[i] = $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo.fromObject(object.subnetworks[i]);
                                }
                            }
                            if (object.tags) {
                                if (!Array.isArray(object.tags))
                                    throw TypeError(".google.cloud.compute.v1.PacketMirroringMirroredResourceInfo.tags: array expected");
                                message.tags = [];
                                for (var i = 0; i < object.tags.length; ++i)
                                    message.tags[i] = String(object.tags[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PacketMirroringMirroredResourceInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfo
                         * @static
                         * @param {google.cloud.compute.v1.PacketMirroringMirroredResourceInfo} message PacketMirroringMirroredResourceInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PacketMirroringMirroredResourceInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.tags = [];
                                object.instances = [];
                                object.subnetworks = [];
                            }
                            if (message.tags && message.tags.length) {
                                object.tags = [];
                                for (var j = 0; j < message.tags.length; ++j)
                                    object.tags[j] = message.tags[j];
                            }
                            if (message.instances && message.instances.length) {
                                object.instances = [];
                                for (var j = 0; j < message.instances.length; ++j)
                                    object.instances[j] = $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo.toObject(message.instances[j], options);
                            }
                            if (message.subnetworks && message.subnetworks.length) {
                                object.subnetworks = [];
                                for (var j = 0; j < message.subnetworks.length; ++j)
                                    object.subnetworks[j] = $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo.toObject(message.subnetworks[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PacketMirroringMirroredResourceInfo to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PacketMirroringMirroredResourceInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PacketMirroringMirroredResourceInfo
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfo
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PacketMirroringMirroredResourceInfo.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PacketMirroringMirroredResourceInfo";
                        };
    
                        return PacketMirroringMirroredResourceInfo;
                    })();
    
                    v1.PacketMirroringMirroredResourceInfoInstanceInfo = (function() {
    
                        /**
                         * Properties of a PacketMirroringMirroredResourceInfoInstanceInfo.
                         * @memberof google.cloud.compute.v1
                         * @interface IPacketMirroringMirroredResourceInfoInstanceInfo
                         * @property {string|null} [canonicalUrl] PacketMirroringMirroredResourceInfoInstanceInfo canonicalUrl
                         * @property {string|null} [url] PacketMirroringMirroredResourceInfoInstanceInfo url
                         */
    
                        /**
                         * Constructs a new PacketMirroringMirroredResourceInfoInstanceInfo.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PacketMirroringMirroredResourceInfoInstanceInfo.
                         * @implements IPacketMirroringMirroredResourceInfoInstanceInfo
                         * @constructor
                         * @param {google.cloud.compute.v1.IPacketMirroringMirroredResourceInfoInstanceInfo=} [properties] Properties to set
                         */
                        function PacketMirroringMirroredResourceInfoInstanceInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PacketMirroringMirroredResourceInfoInstanceInfo canonicalUrl.
                         * @member {string|null|undefined} canonicalUrl
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo
                         * @instance
                         */
                        PacketMirroringMirroredResourceInfoInstanceInfo.prototype.canonicalUrl = null;
    
                        /**
                         * PacketMirroringMirroredResourceInfoInstanceInfo url.
                         * @member {string|null|undefined} url
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo
                         * @instance
                         */
                        PacketMirroringMirroredResourceInfoInstanceInfo.prototype.url = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PacketMirroringMirroredResourceInfoInstanceInfo _canonicalUrl.
                         * @member {"canonicalUrl"|undefined} _canonicalUrl
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo
                         * @instance
                         */
                        Object.defineProperty(PacketMirroringMirroredResourceInfoInstanceInfo.prototype, "_canonicalUrl", {
                            get: $util.oneOfGetter($oneOfFields = ["canonicalUrl"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroringMirroredResourceInfoInstanceInfo _url.
                         * @member {"url"|undefined} _url
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo
                         * @instance
                         */
                        Object.defineProperty(PacketMirroringMirroredResourceInfoInstanceInfo.prototype, "_url", {
                            get: $util.oneOfGetter($oneOfFields = ["url"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PacketMirroringMirroredResourceInfoInstanceInfo instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringMirroredResourceInfoInstanceInfo=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo} PacketMirroringMirroredResourceInfoInstanceInfo instance
                         */
                        PacketMirroringMirroredResourceInfoInstanceInfo.create = function create(properties) {
                            return new PacketMirroringMirroredResourceInfoInstanceInfo(properties);
                        };
    
                        /**
                         * Encodes the specified PacketMirroringMirroredResourceInfoInstanceInfo message. Does not implicitly {@link google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringMirroredResourceInfoInstanceInfo} message PacketMirroringMirroredResourceInfoInstanceInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketMirroringMirroredResourceInfoInstanceInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.url != null && Object.hasOwnProperty.call(message, "url"))
                                writer.uint32(/* id 116079, wireType 2 =*/928634).string(message.url);
                            if (message.canonicalUrl != null && Object.hasOwnProperty.call(message, "canonicalUrl"))
                                writer.uint32(/* id 512294820, wireType 2 =*/4098358562).string(message.canonicalUrl);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PacketMirroringMirroredResourceInfoInstanceInfo message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringMirroredResourceInfoInstanceInfo} message PacketMirroringMirroredResourceInfoInstanceInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketMirroringMirroredResourceInfoInstanceInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PacketMirroringMirroredResourceInfoInstanceInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo} PacketMirroringMirroredResourceInfoInstanceInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketMirroringMirroredResourceInfoInstanceInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 512294820: {
                                        message.canonicalUrl = reader.string();
                                        break;
                                    }
                                case 116079: {
                                        message.url = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PacketMirroringMirroredResourceInfoInstanceInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo} PacketMirroringMirroredResourceInfoInstanceInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketMirroringMirroredResourceInfoInstanceInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PacketMirroringMirroredResourceInfoInstanceInfo message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PacketMirroringMirroredResourceInfoInstanceInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.canonicalUrl != null && message.hasOwnProperty("canonicalUrl")) {
                                properties._canonicalUrl = 1;
                                if (!$util.isString(message.canonicalUrl))
                                    return "canonicalUrl: string expected";
                            }
                            if (message.url != null && message.hasOwnProperty("url")) {
                                properties._url = 1;
                                if (!$util.isString(message.url))
                                    return "url: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PacketMirroringMirroredResourceInfoInstanceInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo} PacketMirroringMirroredResourceInfoInstanceInfo
                         */
                        PacketMirroringMirroredResourceInfoInstanceInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo();
                            if (object.canonicalUrl != null)
                                message.canonicalUrl = String(object.canonicalUrl);
                            if (object.url != null)
                                message.url = String(object.url);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PacketMirroringMirroredResourceInfoInstanceInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo
                         * @static
                         * @param {google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo} message PacketMirroringMirroredResourceInfoInstanceInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PacketMirroringMirroredResourceInfoInstanceInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.url != null && message.hasOwnProperty("url")) {
                                object.url = message.url;
                                if (options.oneofs)
                                    object._url = "url";
                            }
                            if (message.canonicalUrl != null && message.hasOwnProperty("canonicalUrl")) {
                                object.canonicalUrl = message.canonicalUrl;
                                if (options.oneofs)
                                    object._canonicalUrl = "canonicalUrl";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PacketMirroringMirroredResourceInfoInstanceInfo to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PacketMirroringMirroredResourceInfoInstanceInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PacketMirroringMirroredResourceInfoInstanceInfo
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PacketMirroringMirroredResourceInfoInstanceInfo.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PacketMirroringMirroredResourceInfoInstanceInfo";
                        };
    
                        return PacketMirroringMirroredResourceInfoInstanceInfo;
                    })();
    
                    v1.PacketMirroringMirroredResourceInfoSubnetInfo = (function() {
    
                        /**
                         * Properties of a PacketMirroringMirroredResourceInfoSubnetInfo.
                         * @memberof google.cloud.compute.v1
                         * @interface IPacketMirroringMirroredResourceInfoSubnetInfo
                         * @property {string|null} [canonicalUrl] PacketMirroringMirroredResourceInfoSubnetInfo canonicalUrl
                         * @property {string|null} [url] PacketMirroringMirroredResourceInfoSubnetInfo url
                         */
    
                        /**
                         * Constructs a new PacketMirroringMirroredResourceInfoSubnetInfo.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PacketMirroringMirroredResourceInfoSubnetInfo.
                         * @implements IPacketMirroringMirroredResourceInfoSubnetInfo
                         * @constructor
                         * @param {google.cloud.compute.v1.IPacketMirroringMirroredResourceInfoSubnetInfo=} [properties] Properties to set
                         */
                        function PacketMirroringMirroredResourceInfoSubnetInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PacketMirroringMirroredResourceInfoSubnetInfo canonicalUrl.
                         * @member {string|null|undefined} canonicalUrl
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo
                         * @instance
                         */
                        PacketMirroringMirroredResourceInfoSubnetInfo.prototype.canonicalUrl = null;
    
                        /**
                         * PacketMirroringMirroredResourceInfoSubnetInfo url.
                         * @member {string|null|undefined} url
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo
                         * @instance
                         */
                        PacketMirroringMirroredResourceInfoSubnetInfo.prototype.url = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PacketMirroringMirroredResourceInfoSubnetInfo _canonicalUrl.
                         * @member {"canonicalUrl"|undefined} _canonicalUrl
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo
                         * @instance
                         */
                        Object.defineProperty(PacketMirroringMirroredResourceInfoSubnetInfo.prototype, "_canonicalUrl", {
                            get: $util.oneOfGetter($oneOfFields = ["canonicalUrl"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroringMirroredResourceInfoSubnetInfo _url.
                         * @member {"url"|undefined} _url
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo
                         * @instance
                         */
                        Object.defineProperty(PacketMirroringMirroredResourceInfoSubnetInfo.prototype, "_url", {
                            get: $util.oneOfGetter($oneOfFields = ["url"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PacketMirroringMirroredResourceInfoSubnetInfo instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringMirroredResourceInfoSubnetInfo=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo} PacketMirroringMirroredResourceInfoSubnetInfo instance
                         */
                        PacketMirroringMirroredResourceInfoSubnetInfo.create = function create(properties) {
                            return new PacketMirroringMirroredResourceInfoSubnetInfo(properties);
                        };
    
                        /**
                         * Encodes the specified PacketMirroringMirroredResourceInfoSubnetInfo message. Does not implicitly {@link google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringMirroredResourceInfoSubnetInfo} message PacketMirroringMirroredResourceInfoSubnetInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketMirroringMirroredResourceInfoSubnetInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.url != null && Object.hasOwnProperty.call(message, "url"))
                                writer.uint32(/* id 116079, wireType 2 =*/928634).string(message.url);
                            if (message.canonicalUrl != null && Object.hasOwnProperty.call(message, "canonicalUrl"))
                                writer.uint32(/* id 512294820, wireType 2 =*/4098358562).string(message.canonicalUrl);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PacketMirroringMirroredResourceInfoSubnetInfo message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringMirroredResourceInfoSubnetInfo} message PacketMirroringMirroredResourceInfoSubnetInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketMirroringMirroredResourceInfoSubnetInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PacketMirroringMirroredResourceInfoSubnetInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo} PacketMirroringMirroredResourceInfoSubnetInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketMirroringMirroredResourceInfoSubnetInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 512294820: {
                                        message.canonicalUrl = reader.string();
                                        break;
                                    }
                                case 116079: {
                                        message.url = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PacketMirroringMirroredResourceInfoSubnetInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo} PacketMirroringMirroredResourceInfoSubnetInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketMirroringMirroredResourceInfoSubnetInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PacketMirroringMirroredResourceInfoSubnetInfo message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PacketMirroringMirroredResourceInfoSubnetInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.canonicalUrl != null && message.hasOwnProperty("canonicalUrl")) {
                                properties._canonicalUrl = 1;
                                if (!$util.isString(message.canonicalUrl))
                                    return "canonicalUrl: string expected";
                            }
                            if (message.url != null && message.hasOwnProperty("url")) {
                                properties._url = 1;
                                if (!$util.isString(message.url))
                                    return "url: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PacketMirroringMirroredResourceInfoSubnetInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo} PacketMirroringMirroredResourceInfoSubnetInfo
                         */
                        PacketMirroringMirroredResourceInfoSubnetInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo();
                            if (object.canonicalUrl != null)
                                message.canonicalUrl = String(object.canonicalUrl);
                            if (object.url != null)
                                message.url = String(object.url);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PacketMirroringMirroredResourceInfoSubnetInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo
                         * @static
                         * @param {google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo} message PacketMirroringMirroredResourceInfoSubnetInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PacketMirroringMirroredResourceInfoSubnetInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.url != null && message.hasOwnProperty("url")) {
                                object.url = message.url;
                                if (options.oneofs)
                                    object._url = "url";
                            }
                            if (message.canonicalUrl != null && message.hasOwnProperty("canonicalUrl")) {
                                object.canonicalUrl = message.canonicalUrl;
                                if (options.oneofs)
                                    object._canonicalUrl = "canonicalUrl";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PacketMirroringMirroredResourceInfoSubnetInfo to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PacketMirroringMirroredResourceInfoSubnetInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PacketMirroringMirroredResourceInfoSubnetInfo
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PacketMirroringMirroredResourceInfoSubnetInfo.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PacketMirroringMirroredResourceInfoSubnetInfo";
                        };
    
                        return PacketMirroringMirroredResourceInfoSubnetInfo;
                    })();
    
                    v1.PacketMirroringNetworkInfo = (function() {
    
                        /**
                         * Properties of a PacketMirroringNetworkInfo.
                         * @memberof google.cloud.compute.v1
                         * @interface IPacketMirroringNetworkInfo
                         * @property {string|null} [canonicalUrl] PacketMirroringNetworkInfo canonicalUrl
                         * @property {string|null} [url] PacketMirroringNetworkInfo url
                         */
    
                        /**
                         * Constructs a new PacketMirroringNetworkInfo.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PacketMirroringNetworkInfo.
                         * @implements IPacketMirroringNetworkInfo
                         * @constructor
                         * @param {google.cloud.compute.v1.IPacketMirroringNetworkInfo=} [properties] Properties to set
                         */
                        function PacketMirroringNetworkInfo(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PacketMirroringNetworkInfo canonicalUrl.
                         * @member {string|null|undefined} canonicalUrl
                         * @memberof google.cloud.compute.v1.PacketMirroringNetworkInfo
                         * @instance
                         */
                        PacketMirroringNetworkInfo.prototype.canonicalUrl = null;
    
                        /**
                         * PacketMirroringNetworkInfo url.
                         * @member {string|null|undefined} url
                         * @memberof google.cloud.compute.v1.PacketMirroringNetworkInfo
                         * @instance
                         */
                        PacketMirroringNetworkInfo.prototype.url = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PacketMirroringNetworkInfo _canonicalUrl.
                         * @member {"canonicalUrl"|undefined} _canonicalUrl
                         * @memberof google.cloud.compute.v1.PacketMirroringNetworkInfo
                         * @instance
                         */
                        Object.defineProperty(PacketMirroringNetworkInfo.prototype, "_canonicalUrl", {
                            get: $util.oneOfGetter($oneOfFields = ["canonicalUrl"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PacketMirroringNetworkInfo _url.
                         * @member {"url"|undefined} _url
                         * @memberof google.cloud.compute.v1.PacketMirroringNetworkInfo
                         * @instance
                         */
                        Object.defineProperty(PacketMirroringNetworkInfo.prototype, "_url", {
                            get: $util.oneOfGetter($oneOfFields = ["url"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PacketMirroringNetworkInfo instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PacketMirroringNetworkInfo
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringNetworkInfo=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PacketMirroringNetworkInfo} PacketMirroringNetworkInfo instance
                         */
                        PacketMirroringNetworkInfo.create = function create(properties) {
                            return new PacketMirroringNetworkInfo(properties);
                        };
    
                        /**
                         * Encodes the specified PacketMirroringNetworkInfo message. Does not implicitly {@link google.cloud.compute.v1.PacketMirroringNetworkInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PacketMirroringNetworkInfo
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringNetworkInfo} message PacketMirroringNetworkInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketMirroringNetworkInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.url != null && Object.hasOwnProperty.call(message, "url"))
                                writer.uint32(/* id 116079, wireType 2 =*/928634).string(message.url);
                            if (message.canonicalUrl != null && Object.hasOwnProperty.call(message, "canonicalUrl"))
                                writer.uint32(/* id 512294820, wireType 2 =*/4098358562).string(message.canonicalUrl);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PacketMirroringNetworkInfo message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PacketMirroringNetworkInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PacketMirroringNetworkInfo
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringNetworkInfo} message PacketMirroringNetworkInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketMirroringNetworkInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PacketMirroringNetworkInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PacketMirroringNetworkInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PacketMirroringNetworkInfo} PacketMirroringNetworkInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketMirroringNetworkInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PacketMirroringNetworkInfo();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 512294820: {
                                        message.canonicalUrl = reader.string();
                                        break;
                                    }
                                case 116079: {
                                        message.url = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PacketMirroringNetworkInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PacketMirroringNetworkInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PacketMirroringNetworkInfo} PacketMirroringNetworkInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketMirroringNetworkInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PacketMirroringNetworkInfo message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PacketMirroringNetworkInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PacketMirroringNetworkInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.canonicalUrl != null && message.hasOwnProperty("canonicalUrl")) {
                                properties._canonicalUrl = 1;
                                if (!$util.isString(message.canonicalUrl))
                                    return "canonicalUrl: string expected";
                            }
                            if (message.url != null && message.hasOwnProperty("url")) {
                                properties._url = 1;
                                if (!$util.isString(message.url))
                                    return "url: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PacketMirroringNetworkInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PacketMirroringNetworkInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PacketMirroringNetworkInfo} PacketMirroringNetworkInfo
                         */
                        PacketMirroringNetworkInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PacketMirroringNetworkInfo)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PacketMirroringNetworkInfo();
                            if (object.canonicalUrl != null)
                                message.canonicalUrl = String(object.canonicalUrl);
                            if (object.url != null)
                                message.url = String(object.url);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PacketMirroringNetworkInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PacketMirroringNetworkInfo
                         * @static
                         * @param {google.cloud.compute.v1.PacketMirroringNetworkInfo} message PacketMirroringNetworkInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PacketMirroringNetworkInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.url != null && message.hasOwnProperty("url")) {
                                object.url = message.url;
                                if (options.oneofs)
                                    object._url = "url";
                            }
                            if (message.canonicalUrl != null && message.hasOwnProperty("canonicalUrl")) {
                                object.canonicalUrl = message.canonicalUrl;
                                if (options.oneofs)
                                    object._canonicalUrl = "canonicalUrl";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PacketMirroringNetworkInfo to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PacketMirroringNetworkInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PacketMirroringNetworkInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PacketMirroringNetworkInfo
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PacketMirroringNetworkInfo
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PacketMirroringNetworkInfo.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PacketMirroringNetworkInfo";
                        };
    
                        return PacketMirroringNetworkInfo;
                    })();
    
                    v1.PacketMirroringsScopedList = (function() {
    
                        /**
                         * Properties of a PacketMirroringsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IPacketMirroringsScopedList
                         * @property {Array.<google.cloud.compute.v1.IPacketMirroring>|null} [packetMirrorings] PacketMirroringsScopedList packetMirrorings
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] PacketMirroringsScopedList warning
                         */
    
                        /**
                         * Constructs a new PacketMirroringsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PacketMirroringsScopedList.
                         * @implements IPacketMirroringsScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IPacketMirroringsScopedList=} [properties] Properties to set
                         */
                        function PacketMirroringsScopedList(properties) {
                            this.packetMirrorings = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PacketMirroringsScopedList packetMirrorings.
                         * @member {Array.<google.cloud.compute.v1.IPacketMirroring>} packetMirrorings
                         * @memberof google.cloud.compute.v1.PacketMirroringsScopedList
                         * @instance
                         */
                        PacketMirroringsScopedList.prototype.packetMirrorings = $util.emptyArray;
    
                        /**
                         * PacketMirroringsScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.PacketMirroringsScopedList
                         * @instance
                         */
                        PacketMirroringsScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PacketMirroringsScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.PacketMirroringsScopedList
                         * @instance
                         */
                        Object.defineProperty(PacketMirroringsScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PacketMirroringsScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PacketMirroringsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringsScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PacketMirroringsScopedList} PacketMirroringsScopedList instance
                         */
                        PacketMirroringsScopedList.create = function create(properties) {
                            return new PacketMirroringsScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified PacketMirroringsScopedList message. Does not implicitly {@link google.cloud.compute.v1.PacketMirroringsScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PacketMirroringsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringsScopedList} message PacketMirroringsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketMirroringsScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.packetMirrorings != null && message.packetMirrorings.length)
                                for (var i = 0; i < message.packetMirrorings.length; ++i)
                                    $root.google.cloud.compute.v1.PacketMirroring.encode(message.packetMirrorings[i], writer.uint32(/* id 154615079, wireType 2 =*/1236920634).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PacketMirroringsScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PacketMirroringsScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PacketMirroringsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IPacketMirroringsScopedList} message PacketMirroringsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PacketMirroringsScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PacketMirroringsScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PacketMirroringsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PacketMirroringsScopedList} PacketMirroringsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketMirroringsScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PacketMirroringsScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 154615079: {
                                        if (!(message.packetMirrorings && message.packetMirrorings.length))
                                            message.packetMirrorings = [];
                                        message.packetMirrorings.push($root.google.cloud.compute.v1.PacketMirroring.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PacketMirroringsScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PacketMirroringsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PacketMirroringsScopedList} PacketMirroringsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PacketMirroringsScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PacketMirroringsScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PacketMirroringsScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PacketMirroringsScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.packetMirrorings != null && message.hasOwnProperty("packetMirrorings")) {
                                if (!Array.isArray(message.packetMirrorings))
                                    return "packetMirrorings: array expected";
                                for (var i = 0; i < message.packetMirrorings.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PacketMirroring.verify(message.packetMirrorings[i]);
                                    if (error)
                                        return "packetMirrorings." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PacketMirroringsScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PacketMirroringsScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PacketMirroringsScopedList} PacketMirroringsScopedList
                         */
                        PacketMirroringsScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PacketMirroringsScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PacketMirroringsScopedList();
                            if (object.packetMirrorings) {
                                if (!Array.isArray(object.packetMirrorings))
                                    throw TypeError(".google.cloud.compute.v1.PacketMirroringsScopedList.packetMirrorings: array expected");
                                message.packetMirrorings = [];
                                for (var i = 0; i < object.packetMirrorings.length; ++i) {
                                    if (typeof object.packetMirrorings[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.PacketMirroringsScopedList.packetMirrorings: object expected");
                                    message.packetMirrorings[i] = $root.google.cloud.compute.v1.PacketMirroring.fromObject(object.packetMirrorings[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PacketMirroringsScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PacketMirroringsScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PacketMirroringsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.PacketMirroringsScopedList} message PacketMirroringsScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PacketMirroringsScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.packetMirrorings = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.packetMirrorings && message.packetMirrorings.length) {
                                object.packetMirrorings = [];
                                for (var j = 0; j < message.packetMirrorings.length; ++j)
                                    object.packetMirrorings[j] = $root.google.cloud.compute.v1.PacketMirroring.toObject(message.packetMirrorings[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PacketMirroringsScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PacketMirroringsScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PacketMirroringsScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PacketMirroringsScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PacketMirroringsScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PacketMirroringsScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PacketMirroringsScopedList";
                        };
    
                        return PacketMirroringsScopedList;
                    })();
    
                    v1.PatchAutoscalerRequest = (function() {
    
                        /**
                         * Properties of a PatchAutoscalerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchAutoscalerRequest
                         * @property {string|null} [autoscaler] PatchAutoscalerRequest autoscaler
                         * @property {google.cloud.compute.v1.IAutoscaler|null} [autoscalerResource] PatchAutoscalerRequest autoscalerResource
                         * @property {string|null} [project] PatchAutoscalerRequest project
                         * @property {string|null} [requestId] PatchAutoscalerRequest requestId
                         * @property {string|null} [zone] PatchAutoscalerRequest zone
                         */
    
                        /**
                         * Constructs a new PatchAutoscalerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchAutoscalerRequest.
                         * @implements IPatchAutoscalerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchAutoscalerRequest=} [properties] Properties to set
                         */
                        function PatchAutoscalerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchAutoscalerRequest autoscaler.
                         * @member {string|null|undefined} autoscaler
                         * @memberof google.cloud.compute.v1.PatchAutoscalerRequest
                         * @instance
                         */
                        PatchAutoscalerRequest.prototype.autoscaler = null;
    
                        /**
                         * PatchAutoscalerRequest autoscalerResource.
                         * @member {google.cloud.compute.v1.IAutoscaler|null|undefined} autoscalerResource
                         * @memberof google.cloud.compute.v1.PatchAutoscalerRequest
                         * @instance
                         */
                        PatchAutoscalerRequest.prototype.autoscalerResource = null;
    
                        /**
                         * PatchAutoscalerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchAutoscalerRequest
                         * @instance
                         */
                        PatchAutoscalerRequest.prototype.project = "";
    
                        /**
                         * PatchAutoscalerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchAutoscalerRequest
                         * @instance
                         */
                        PatchAutoscalerRequest.prototype.requestId = null;
    
                        /**
                         * PatchAutoscalerRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.PatchAutoscalerRequest
                         * @instance
                         */
                        PatchAutoscalerRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchAutoscalerRequest _autoscaler.
                         * @member {"autoscaler"|undefined} _autoscaler
                         * @memberof google.cloud.compute.v1.PatchAutoscalerRequest
                         * @instance
                         */
                        Object.defineProperty(PatchAutoscalerRequest.prototype, "_autoscaler", {
                            get: $util.oneOfGetter($oneOfFields = ["autoscaler"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PatchAutoscalerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchAutoscalerRequest
                         * @instance
                         */
                        Object.defineProperty(PatchAutoscalerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchAutoscalerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchAutoscalerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchAutoscalerRequest} PatchAutoscalerRequest instance
                         */
                        PatchAutoscalerRequest.create = function create(properties) {
                            return new PatchAutoscalerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchAutoscalerRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchAutoscalerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchAutoscalerRequest} message PatchAutoscalerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchAutoscalerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.autoscalerResource != null && Object.hasOwnProperty.call(message, "autoscalerResource"))
                                $root.google.cloud.compute.v1.Autoscaler.encode(message.autoscalerResource, writer.uint32(/* id 207616118, wireType 2 =*/1660928946).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.autoscaler != null && Object.hasOwnProperty.call(message, "autoscaler"))
                                writer.uint32(/* id 517258967, wireType 2 =*/4138071738).string(message.autoscaler);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchAutoscalerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchAutoscalerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchAutoscalerRequest} message PatchAutoscalerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchAutoscalerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchAutoscalerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchAutoscalerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchAutoscalerRequest} PatchAutoscalerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchAutoscalerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchAutoscalerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 517258967: {
                                        message.autoscaler = reader.string();
                                        break;
                                    }
                                case 207616118: {
                                        message.autoscalerResource = $root.google.cloud.compute.v1.Autoscaler.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchAutoscalerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchAutoscalerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchAutoscalerRequest} PatchAutoscalerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchAutoscalerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchAutoscalerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchAutoscalerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchAutoscalerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoscaler != null && message.hasOwnProperty("autoscaler")) {
                                properties._autoscaler = 1;
                                if (!$util.isString(message.autoscaler))
                                    return "autoscaler: string expected";
                            }
                            if (message.autoscalerResource != null && message.hasOwnProperty("autoscalerResource")) {
                                var error = $root.google.cloud.compute.v1.Autoscaler.verify(message.autoscalerResource);
                                if (error)
                                    return "autoscalerResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a PatchAutoscalerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchAutoscalerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchAutoscalerRequest} PatchAutoscalerRequest
                         */
                        PatchAutoscalerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchAutoscalerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchAutoscalerRequest();
                            if (object.autoscaler != null)
                                message.autoscaler = String(object.autoscaler);
                            if (object.autoscalerResource != null) {
                                if (typeof object.autoscalerResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchAutoscalerRequest.autoscalerResource: object expected");
                                message.autoscalerResource = $root.google.cloud.compute.v1.Autoscaler.fromObject(object.autoscalerResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchAutoscalerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchAutoscalerRequest} message PatchAutoscalerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchAutoscalerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.autoscalerResource = null;
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.autoscalerResource != null && message.hasOwnProperty("autoscalerResource"))
                                object.autoscalerResource = $root.google.cloud.compute.v1.Autoscaler.toObject(message.autoscalerResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.autoscaler != null && message.hasOwnProperty("autoscaler")) {
                                object.autoscaler = message.autoscaler;
                                if (options.oneofs)
                                    object._autoscaler = "autoscaler";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PatchAutoscalerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchAutoscalerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchAutoscalerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchAutoscalerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchAutoscalerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchAutoscalerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchAutoscalerRequest";
                        };
    
                        return PatchAutoscalerRequest;
                    })();
    
                    v1.PatchBackendBucketRequest = (function() {
    
                        /**
                         * Properties of a PatchBackendBucketRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchBackendBucketRequest
                         * @property {string|null} [backendBucket] PatchBackendBucketRequest backendBucket
                         * @property {google.cloud.compute.v1.IBackendBucket|null} [backendBucketResource] PatchBackendBucketRequest backendBucketResource
                         * @property {string|null} [project] PatchBackendBucketRequest project
                         * @property {string|null} [requestId] PatchBackendBucketRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchBackendBucketRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchBackendBucketRequest.
                         * @implements IPatchBackendBucketRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchBackendBucketRequest=} [properties] Properties to set
                         */
                        function PatchBackendBucketRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchBackendBucketRequest backendBucket.
                         * @member {string} backendBucket
                         * @memberof google.cloud.compute.v1.PatchBackendBucketRequest
                         * @instance
                         */
                        PatchBackendBucketRequest.prototype.backendBucket = "";
    
                        /**
                         * PatchBackendBucketRequest backendBucketResource.
                         * @member {google.cloud.compute.v1.IBackendBucket|null|undefined} backendBucketResource
                         * @memberof google.cloud.compute.v1.PatchBackendBucketRequest
                         * @instance
                         */
                        PatchBackendBucketRequest.prototype.backendBucketResource = null;
    
                        /**
                         * PatchBackendBucketRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchBackendBucketRequest
                         * @instance
                         */
                        PatchBackendBucketRequest.prototype.project = "";
    
                        /**
                         * PatchBackendBucketRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchBackendBucketRequest
                         * @instance
                         */
                        PatchBackendBucketRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchBackendBucketRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchBackendBucketRequest
                         * @instance
                         */
                        Object.defineProperty(PatchBackendBucketRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchBackendBucketRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchBackendBucketRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchBackendBucketRequest} PatchBackendBucketRequest instance
                         */
                        PatchBackendBucketRequest.create = function create(properties) {
                            return new PatchBackendBucketRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchBackendBucketRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchBackendBucketRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchBackendBucketRequest} message PatchBackendBucketRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchBackendBucketRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.backendBucket != null && Object.hasOwnProperty.call(message, "backendBucket"))
                                writer.uint32(/* id 91714037, wireType 2 =*/733712298).string(message.backendBucket);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.backendBucketResource != null && Object.hasOwnProperty.call(message, "backendBucketResource"))
                                $root.google.cloud.compute.v1.BackendBucket.encode(message.backendBucketResource, writer.uint32(/* id 380757784, wireType 2 =*/3046062274).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchBackendBucketRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchBackendBucketRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchBackendBucketRequest} message PatchBackendBucketRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchBackendBucketRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchBackendBucketRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchBackendBucketRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchBackendBucketRequest} PatchBackendBucketRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchBackendBucketRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchBackendBucketRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 91714037: {
                                        message.backendBucket = reader.string();
                                        break;
                                    }
                                case 380757784: {
                                        message.backendBucketResource = $root.google.cloud.compute.v1.BackendBucket.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchBackendBucketRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchBackendBucketRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchBackendBucketRequest} PatchBackendBucketRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchBackendBucketRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchBackendBucketRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchBackendBucketRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchBackendBucketRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendBucket != null && message.hasOwnProperty("backendBucket"))
                                if (!$util.isString(message.backendBucket))
                                    return "backendBucket: string expected";
                            if (message.backendBucketResource != null && message.hasOwnProperty("backendBucketResource")) {
                                var error = $root.google.cloud.compute.v1.BackendBucket.verify(message.backendBucketResource);
                                if (error)
                                    return "backendBucketResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchBackendBucketRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchBackendBucketRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchBackendBucketRequest} PatchBackendBucketRequest
                         */
                        PatchBackendBucketRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchBackendBucketRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchBackendBucketRequest();
                            if (object.backendBucket != null)
                                message.backendBucket = String(object.backendBucket);
                            if (object.backendBucketResource != null) {
                                if (typeof object.backendBucketResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchBackendBucketRequest.backendBucketResource: object expected");
                                message.backendBucketResource = $root.google.cloud.compute.v1.BackendBucket.fromObject(object.backendBucketResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchBackendBucketRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchBackendBucketRequest} message PatchBackendBucketRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchBackendBucketRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.backendBucket = "";
                                object.project = "";
                                object.backendBucketResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.backendBucket != null && message.hasOwnProperty("backendBucket"))
                                object.backendBucket = message.backendBucket;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.backendBucketResource != null && message.hasOwnProperty("backendBucketResource"))
                                object.backendBucketResource = $root.google.cloud.compute.v1.BackendBucket.toObject(message.backendBucketResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this PatchBackendBucketRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchBackendBucketRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchBackendBucketRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchBackendBucketRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchBackendBucketRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchBackendBucketRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchBackendBucketRequest";
                        };
    
                        return PatchBackendBucketRequest;
                    })();
    
                    v1.PatchBackendServiceRequest = (function() {
    
                        /**
                         * Properties of a PatchBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchBackendServiceRequest
                         * @property {string|null} [backendService] PatchBackendServiceRequest backendService
                         * @property {google.cloud.compute.v1.IBackendService|null} [backendServiceResource] PatchBackendServiceRequest backendServiceResource
                         * @property {string|null} [project] PatchBackendServiceRequest project
                         * @property {string|null} [requestId] PatchBackendServiceRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchBackendServiceRequest.
                         * @implements IPatchBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchBackendServiceRequest=} [properties] Properties to set
                         */
                        function PatchBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchBackendServiceRequest backendService.
                         * @member {string} backendService
                         * @memberof google.cloud.compute.v1.PatchBackendServiceRequest
                         * @instance
                         */
                        PatchBackendServiceRequest.prototype.backendService = "";
    
                        /**
                         * PatchBackendServiceRequest backendServiceResource.
                         * @member {google.cloud.compute.v1.IBackendService|null|undefined} backendServiceResource
                         * @memberof google.cloud.compute.v1.PatchBackendServiceRequest
                         * @instance
                         */
                        PatchBackendServiceRequest.prototype.backendServiceResource = null;
    
                        /**
                         * PatchBackendServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchBackendServiceRequest
                         * @instance
                         */
                        PatchBackendServiceRequest.prototype.project = "";
    
                        /**
                         * PatchBackendServiceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchBackendServiceRequest
                         * @instance
                         */
                        PatchBackendServiceRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchBackendServiceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchBackendServiceRequest
                         * @instance
                         */
                        Object.defineProperty(PatchBackendServiceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchBackendServiceRequest} PatchBackendServiceRequest instance
                         */
                        PatchBackendServiceRequest.create = function create(properties) {
                            return new PatchBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchBackendServiceRequest} message PatchBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.backendService != null && Object.hasOwnProperty.call(message, "backendService"))
                                writer.uint32(/* id 306946058, wireType 2 =*/2455568466).string(message.backendService);
                            if (message.backendServiceResource != null && Object.hasOwnProperty.call(message, "backendServiceResource"))
                                $root.google.cloud.compute.v1.BackendService.encode(message.backendServiceResource, writer.uint32(/* id 347586723, wireType 2 =*/2780693786).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchBackendServiceRequest} message PatchBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchBackendServiceRequest} PatchBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 306946058: {
                                        message.backendService = reader.string();
                                        break;
                                    }
                                case 347586723: {
                                        message.backendServiceResource = $root.google.cloud.compute.v1.BackendService.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchBackendServiceRequest} PatchBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                if (!$util.isString(message.backendService))
                                    return "backendService: string expected";
                            if (message.backendServiceResource != null && message.hasOwnProperty("backendServiceResource")) {
                                var error = $root.google.cloud.compute.v1.BackendService.verify(message.backendServiceResource);
                                if (error)
                                    return "backendServiceResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchBackendServiceRequest} PatchBackendServiceRequest
                         */
                        PatchBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchBackendServiceRequest();
                            if (object.backendService != null)
                                message.backendService = String(object.backendService);
                            if (object.backendServiceResource != null) {
                                if (typeof object.backendServiceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchBackendServiceRequest.backendServiceResource: object expected");
                                message.backendServiceResource = $root.google.cloud.compute.v1.BackendService.fromObject(object.backendServiceResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchBackendServiceRequest} message PatchBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.backendService = "";
                                object.backendServiceResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                object.backendService = message.backendService;
                            if (message.backendServiceResource != null && message.hasOwnProperty("backendServiceResource"))
                                object.backendServiceResource = $root.google.cloud.compute.v1.BackendService.toObject(message.backendServiceResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this PatchBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchBackendServiceRequest";
                        };
    
                        return PatchBackendServiceRequest;
                    })();
    
                    v1.PatchFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a PatchFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] PatchFirewallPolicyRequest firewallPolicy
                         * @property {google.cloud.compute.v1.IFirewallPolicy|null} [firewallPolicyResource] PatchFirewallPolicyRequest firewallPolicyResource
                         * @property {string|null} [requestId] PatchFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchFirewallPolicyRequest.
                         * @implements IPatchFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function PatchFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.PatchFirewallPolicyRequest
                         * @instance
                         */
                        PatchFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * PatchFirewallPolicyRequest firewallPolicyResource.
                         * @member {google.cloud.compute.v1.IFirewallPolicy|null|undefined} firewallPolicyResource
                         * @memberof google.cloud.compute.v1.PatchFirewallPolicyRequest
                         * @instance
                         */
                        PatchFirewallPolicyRequest.prototype.firewallPolicyResource = null;
    
                        /**
                         * PatchFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchFirewallPolicyRequest
                         * @instance
                         */
                        PatchFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(PatchFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchFirewallPolicyRequest} PatchFirewallPolicyRequest instance
                         */
                        PatchFirewallPolicyRequest.create = function create(properties) {
                            return new PatchFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchFirewallPolicyRequest} message PatchFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.firewallPolicyResource != null && Object.hasOwnProperty.call(message, "firewallPolicyResource"))
                                $root.google.cloud.compute.v1.FirewallPolicy.encode(message.firewallPolicyResource, writer.uint32(/* id 495049532, wireType 2 =*/3960396258).fork()).ldelim();
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchFirewallPolicyRequest} message PatchFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchFirewallPolicyRequest} PatchFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 495049532: {
                                        message.firewallPolicyResource = $root.google.cloud.compute.v1.FirewallPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchFirewallPolicyRequest} PatchFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.firewallPolicyResource != null && message.hasOwnProperty("firewallPolicyResource")) {
                                var error = $root.google.cloud.compute.v1.FirewallPolicy.verify(message.firewallPolicyResource);
                                if (error)
                                    return "firewallPolicyResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchFirewallPolicyRequest} PatchFirewallPolicyRequest
                         */
                        PatchFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.firewallPolicyResource != null) {
                                if (typeof object.firewallPolicyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchFirewallPolicyRequest.firewallPolicyResource: object expected");
                                message.firewallPolicyResource = $root.google.cloud.compute.v1.FirewallPolicy.fromObject(object.firewallPolicyResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchFirewallPolicyRequest} message PatchFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.firewallPolicyResource = null;
                                object.firewallPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.firewallPolicyResource != null && message.hasOwnProperty("firewallPolicyResource"))
                                object.firewallPolicyResource = $root.google.cloud.compute.v1.FirewallPolicy.toObject(message.firewallPolicyResource, options);
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this PatchFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchFirewallPolicyRequest";
                        };
    
                        return PatchFirewallPolicyRequest;
                    })();
    
                    v1.PatchFirewallRequest = (function() {
    
                        /**
                         * Properties of a PatchFirewallRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchFirewallRequest
                         * @property {string|null} [firewall] PatchFirewallRequest firewall
                         * @property {google.cloud.compute.v1.IFirewall|null} [firewallResource] PatchFirewallRequest firewallResource
                         * @property {string|null} [project] PatchFirewallRequest project
                         * @property {string|null} [requestId] PatchFirewallRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchFirewallRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchFirewallRequest.
                         * @implements IPatchFirewallRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchFirewallRequest=} [properties] Properties to set
                         */
                        function PatchFirewallRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchFirewallRequest firewall.
                         * @member {string} firewall
                         * @memberof google.cloud.compute.v1.PatchFirewallRequest
                         * @instance
                         */
                        PatchFirewallRequest.prototype.firewall = "";
    
                        /**
                         * PatchFirewallRequest firewallResource.
                         * @member {google.cloud.compute.v1.IFirewall|null|undefined} firewallResource
                         * @memberof google.cloud.compute.v1.PatchFirewallRequest
                         * @instance
                         */
                        PatchFirewallRequest.prototype.firewallResource = null;
    
                        /**
                         * PatchFirewallRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchFirewallRequest
                         * @instance
                         */
                        PatchFirewallRequest.prototype.project = "";
    
                        /**
                         * PatchFirewallRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchFirewallRequest
                         * @instance
                         */
                        PatchFirewallRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchFirewallRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchFirewallRequest
                         * @instance
                         */
                        Object.defineProperty(PatchFirewallRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchFirewallRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchFirewallRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchFirewallRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchFirewallRequest} PatchFirewallRequest instance
                         */
                        PatchFirewallRequest.create = function create(properties) {
                            return new PatchFirewallRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchFirewallRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchFirewallRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchFirewallRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchFirewallRequest} message PatchFirewallRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchFirewallRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.firewallResource != null && Object.hasOwnProperty.call(message, "firewallResource"))
                                $root.google.cloud.compute.v1.Firewall.encode(message.firewallResource, writer.uint32(/* id 41425005, wireType 2 =*/331400042).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewall != null && Object.hasOwnProperty.call(message, "firewall"))
                                writer.uint32(/* id 511016192, wireType 2 =*/4088129538).string(message.firewall);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchFirewallRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchFirewallRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchFirewallRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchFirewallRequest} message PatchFirewallRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchFirewallRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchFirewallRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchFirewallRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchFirewallRequest} PatchFirewallRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchFirewallRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchFirewallRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 511016192: {
                                        message.firewall = reader.string();
                                        break;
                                    }
                                case 41425005: {
                                        message.firewallResource = $root.google.cloud.compute.v1.Firewall.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchFirewallRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchFirewallRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchFirewallRequest} PatchFirewallRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchFirewallRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchFirewallRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchFirewallRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchFirewallRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewall != null && message.hasOwnProperty("firewall"))
                                if (!$util.isString(message.firewall))
                                    return "firewall: string expected";
                            if (message.firewallResource != null && message.hasOwnProperty("firewallResource")) {
                                var error = $root.google.cloud.compute.v1.Firewall.verify(message.firewallResource);
                                if (error)
                                    return "firewallResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchFirewallRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchFirewallRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchFirewallRequest} PatchFirewallRequest
                         */
                        PatchFirewallRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchFirewallRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchFirewallRequest();
                            if (object.firewall != null)
                                message.firewall = String(object.firewall);
                            if (object.firewallResource != null) {
                                if (typeof object.firewallResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchFirewallRequest.firewallResource: object expected");
                                message.firewallResource = $root.google.cloud.compute.v1.Firewall.fromObject(object.firewallResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchFirewallRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchFirewallRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchFirewallRequest} message PatchFirewallRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchFirewallRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.firewallResource = null;
                                object.project = "";
                                object.firewall = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.firewallResource != null && message.hasOwnProperty("firewallResource"))
                                object.firewallResource = $root.google.cloud.compute.v1.Firewall.toObject(message.firewallResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewall != null && message.hasOwnProperty("firewall"))
                                object.firewall = message.firewall;
                            return object;
                        };
    
                        /**
                         * Converts this PatchFirewallRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchFirewallRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchFirewallRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchFirewallRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchFirewallRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchFirewallRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchFirewallRequest";
                        };
    
                        return PatchFirewallRequest;
                    })();
    
                    v1.PatchForwardingRuleRequest = (function() {
    
                        /**
                         * Properties of a PatchForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchForwardingRuleRequest
                         * @property {string|null} [forwardingRule] PatchForwardingRuleRequest forwardingRule
                         * @property {google.cloud.compute.v1.IForwardingRule|null} [forwardingRuleResource] PatchForwardingRuleRequest forwardingRuleResource
                         * @property {string|null} [project] PatchForwardingRuleRequest project
                         * @property {string|null} [region] PatchForwardingRuleRequest region
                         * @property {string|null} [requestId] PatchForwardingRuleRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchForwardingRuleRequest.
                         * @implements IPatchForwardingRuleRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchForwardingRuleRequest=} [properties] Properties to set
                         */
                        function PatchForwardingRuleRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchForwardingRuleRequest forwardingRule.
                         * @member {string} forwardingRule
                         * @memberof google.cloud.compute.v1.PatchForwardingRuleRequest
                         * @instance
                         */
                        PatchForwardingRuleRequest.prototype.forwardingRule = "";
    
                        /**
                         * PatchForwardingRuleRequest forwardingRuleResource.
                         * @member {google.cloud.compute.v1.IForwardingRule|null|undefined} forwardingRuleResource
                         * @memberof google.cloud.compute.v1.PatchForwardingRuleRequest
                         * @instance
                         */
                        PatchForwardingRuleRequest.prototype.forwardingRuleResource = null;
    
                        /**
                         * PatchForwardingRuleRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchForwardingRuleRequest
                         * @instance
                         */
                        PatchForwardingRuleRequest.prototype.project = "";
    
                        /**
                         * PatchForwardingRuleRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PatchForwardingRuleRequest
                         * @instance
                         */
                        PatchForwardingRuleRequest.prototype.region = "";
    
                        /**
                         * PatchForwardingRuleRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchForwardingRuleRequest
                         * @instance
                         */
                        PatchForwardingRuleRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchForwardingRuleRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchForwardingRuleRequest
                         * @instance
                         */
                        Object.defineProperty(PatchForwardingRuleRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchForwardingRuleRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchForwardingRuleRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchForwardingRuleRequest} PatchForwardingRuleRequest instance
                         */
                        PatchForwardingRuleRequest.create = function create(properties) {
                            return new PatchForwardingRuleRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchForwardingRuleRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchForwardingRuleRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchForwardingRuleRequest} message PatchForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchForwardingRuleRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.forwardingRule != null && Object.hasOwnProperty.call(message, "forwardingRule"))
                                writer.uint32(/* id 269964030, wireType 2 =*/2159712242).string(message.forwardingRule);
                            if (message.forwardingRuleResource != null && Object.hasOwnProperty.call(message, "forwardingRuleResource"))
                                $root.google.cloud.compute.v1.ForwardingRule.encode(message.forwardingRuleResource, writer.uint32(/* id 301211695, wireType 2 =*/2409693562).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchForwardingRuleRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchForwardingRuleRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchForwardingRuleRequest} message PatchForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchForwardingRuleRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchForwardingRuleRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchForwardingRuleRequest} PatchForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchForwardingRuleRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchForwardingRuleRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 269964030: {
                                        message.forwardingRule = reader.string();
                                        break;
                                    }
                                case 301211695: {
                                        message.forwardingRuleResource = $root.google.cloud.compute.v1.ForwardingRule.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchForwardingRuleRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchForwardingRuleRequest} PatchForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchForwardingRuleRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchForwardingRuleRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchForwardingRuleRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule"))
                                if (!$util.isString(message.forwardingRule))
                                    return "forwardingRule: string expected";
                            if (message.forwardingRuleResource != null && message.hasOwnProperty("forwardingRuleResource")) {
                                var error = $root.google.cloud.compute.v1.ForwardingRule.verify(message.forwardingRuleResource);
                                if (error)
                                    return "forwardingRuleResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchForwardingRuleRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchForwardingRuleRequest} PatchForwardingRuleRequest
                         */
                        PatchForwardingRuleRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchForwardingRuleRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchForwardingRuleRequest();
                            if (object.forwardingRule != null)
                                message.forwardingRule = String(object.forwardingRule);
                            if (object.forwardingRuleResource != null) {
                                if (typeof object.forwardingRuleResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchForwardingRuleRequest.forwardingRuleResource: object expected");
                                message.forwardingRuleResource = $root.google.cloud.compute.v1.ForwardingRule.fromObject(object.forwardingRuleResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchForwardingRuleRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchForwardingRuleRequest} message PatchForwardingRuleRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchForwardingRuleRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.forwardingRule = "";
                                object.forwardingRuleResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule"))
                                object.forwardingRule = message.forwardingRule;
                            if (message.forwardingRuleResource != null && message.hasOwnProperty("forwardingRuleResource"))
                                object.forwardingRuleResource = $root.google.cloud.compute.v1.ForwardingRule.toObject(message.forwardingRuleResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this PatchForwardingRuleRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchForwardingRuleRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchForwardingRuleRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchForwardingRuleRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchForwardingRuleRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchForwardingRuleRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchForwardingRuleRequest";
                        };
    
                        return PatchForwardingRuleRequest;
                    })();
    
                    v1.PatchGlobalForwardingRuleRequest = (function() {
    
                        /**
                         * Properties of a PatchGlobalForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchGlobalForwardingRuleRequest
                         * @property {string|null} [forwardingRule] PatchGlobalForwardingRuleRequest forwardingRule
                         * @property {google.cloud.compute.v1.IForwardingRule|null} [forwardingRuleResource] PatchGlobalForwardingRuleRequest forwardingRuleResource
                         * @property {string|null} [project] PatchGlobalForwardingRuleRequest project
                         * @property {string|null} [requestId] PatchGlobalForwardingRuleRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchGlobalForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchGlobalForwardingRuleRequest.
                         * @implements IPatchGlobalForwardingRuleRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchGlobalForwardingRuleRequest=} [properties] Properties to set
                         */
                        function PatchGlobalForwardingRuleRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchGlobalForwardingRuleRequest forwardingRule.
                         * @member {string} forwardingRule
                         * @memberof google.cloud.compute.v1.PatchGlobalForwardingRuleRequest
                         * @instance
                         */
                        PatchGlobalForwardingRuleRequest.prototype.forwardingRule = "";
    
                        /**
                         * PatchGlobalForwardingRuleRequest forwardingRuleResource.
                         * @member {google.cloud.compute.v1.IForwardingRule|null|undefined} forwardingRuleResource
                         * @memberof google.cloud.compute.v1.PatchGlobalForwardingRuleRequest
                         * @instance
                         */
                        PatchGlobalForwardingRuleRequest.prototype.forwardingRuleResource = null;
    
                        /**
                         * PatchGlobalForwardingRuleRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchGlobalForwardingRuleRequest
                         * @instance
                         */
                        PatchGlobalForwardingRuleRequest.prototype.project = "";
    
                        /**
                         * PatchGlobalForwardingRuleRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchGlobalForwardingRuleRequest
                         * @instance
                         */
                        PatchGlobalForwardingRuleRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchGlobalForwardingRuleRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchGlobalForwardingRuleRequest
                         * @instance
                         */
                        Object.defineProperty(PatchGlobalForwardingRuleRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchGlobalForwardingRuleRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchGlobalForwardingRuleRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchGlobalForwardingRuleRequest} PatchGlobalForwardingRuleRequest instance
                         */
                        PatchGlobalForwardingRuleRequest.create = function create(properties) {
                            return new PatchGlobalForwardingRuleRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchGlobalForwardingRuleRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchGlobalForwardingRuleRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchGlobalForwardingRuleRequest} message PatchGlobalForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchGlobalForwardingRuleRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.forwardingRule != null && Object.hasOwnProperty.call(message, "forwardingRule"))
                                writer.uint32(/* id 269964030, wireType 2 =*/2159712242).string(message.forwardingRule);
                            if (message.forwardingRuleResource != null && Object.hasOwnProperty.call(message, "forwardingRuleResource"))
                                $root.google.cloud.compute.v1.ForwardingRule.encode(message.forwardingRuleResource, writer.uint32(/* id 301211695, wireType 2 =*/2409693562).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchGlobalForwardingRuleRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchGlobalForwardingRuleRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchGlobalForwardingRuleRequest} message PatchGlobalForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchGlobalForwardingRuleRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchGlobalForwardingRuleRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchGlobalForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchGlobalForwardingRuleRequest} PatchGlobalForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchGlobalForwardingRuleRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchGlobalForwardingRuleRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 269964030: {
                                        message.forwardingRule = reader.string();
                                        break;
                                    }
                                case 301211695: {
                                        message.forwardingRuleResource = $root.google.cloud.compute.v1.ForwardingRule.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchGlobalForwardingRuleRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchGlobalForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchGlobalForwardingRuleRequest} PatchGlobalForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchGlobalForwardingRuleRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchGlobalForwardingRuleRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchGlobalForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchGlobalForwardingRuleRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule"))
                                if (!$util.isString(message.forwardingRule))
                                    return "forwardingRule: string expected";
                            if (message.forwardingRuleResource != null && message.hasOwnProperty("forwardingRuleResource")) {
                                var error = $root.google.cloud.compute.v1.ForwardingRule.verify(message.forwardingRuleResource);
                                if (error)
                                    return "forwardingRuleResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchGlobalForwardingRuleRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchGlobalForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchGlobalForwardingRuleRequest} PatchGlobalForwardingRuleRequest
                         */
                        PatchGlobalForwardingRuleRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchGlobalForwardingRuleRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchGlobalForwardingRuleRequest();
                            if (object.forwardingRule != null)
                                message.forwardingRule = String(object.forwardingRule);
                            if (object.forwardingRuleResource != null) {
                                if (typeof object.forwardingRuleResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchGlobalForwardingRuleRequest.forwardingRuleResource: object expected");
                                message.forwardingRuleResource = $root.google.cloud.compute.v1.ForwardingRule.fromObject(object.forwardingRuleResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchGlobalForwardingRuleRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchGlobalForwardingRuleRequest} message PatchGlobalForwardingRuleRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchGlobalForwardingRuleRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.forwardingRule = "";
                                object.forwardingRuleResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule"))
                                object.forwardingRule = message.forwardingRule;
                            if (message.forwardingRuleResource != null && message.hasOwnProperty("forwardingRuleResource"))
                                object.forwardingRuleResource = $root.google.cloud.compute.v1.ForwardingRule.toObject(message.forwardingRuleResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this PatchGlobalForwardingRuleRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchGlobalForwardingRuleRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchGlobalForwardingRuleRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchGlobalForwardingRuleRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchGlobalForwardingRuleRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchGlobalForwardingRuleRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchGlobalForwardingRuleRequest";
                        };
    
                        return PatchGlobalForwardingRuleRequest;
                    })();
    
                    v1.PatchGlobalPublicDelegatedPrefixeRequest = (function() {
    
                        /**
                         * Properties of a PatchGlobalPublicDelegatedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchGlobalPublicDelegatedPrefixeRequest
                         * @property {string|null} [project] PatchGlobalPublicDelegatedPrefixeRequest project
                         * @property {string|null} [publicDelegatedPrefix] PatchGlobalPublicDelegatedPrefixeRequest publicDelegatedPrefix
                         * @property {google.cloud.compute.v1.IPublicDelegatedPrefix|null} [publicDelegatedPrefixResource] PatchGlobalPublicDelegatedPrefixeRequest publicDelegatedPrefixResource
                         * @property {string|null} [requestId] PatchGlobalPublicDelegatedPrefixeRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchGlobalPublicDelegatedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchGlobalPublicDelegatedPrefixeRequest.
                         * @implements IPatchGlobalPublicDelegatedPrefixeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchGlobalPublicDelegatedPrefixeRequest=} [properties] Properties to set
                         */
                        function PatchGlobalPublicDelegatedPrefixeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchGlobalPublicDelegatedPrefixeRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        PatchGlobalPublicDelegatedPrefixeRequest.prototype.project = "";
    
                        /**
                         * PatchGlobalPublicDelegatedPrefixeRequest publicDelegatedPrefix.
                         * @member {string} publicDelegatedPrefix
                         * @memberof google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        PatchGlobalPublicDelegatedPrefixeRequest.prototype.publicDelegatedPrefix = "";
    
                        /**
                         * PatchGlobalPublicDelegatedPrefixeRequest publicDelegatedPrefixResource.
                         * @member {google.cloud.compute.v1.IPublicDelegatedPrefix|null|undefined} publicDelegatedPrefixResource
                         * @memberof google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        PatchGlobalPublicDelegatedPrefixeRequest.prototype.publicDelegatedPrefixResource = null;
    
                        /**
                         * PatchGlobalPublicDelegatedPrefixeRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        PatchGlobalPublicDelegatedPrefixeRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchGlobalPublicDelegatedPrefixeRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        Object.defineProperty(PatchGlobalPublicDelegatedPrefixeRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchGlobalPublicDelegatedPrefixeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchGlobalPublicDelegatedPrefixeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest} PatchGlobalPublicDelegatedPrefixeRequest instance
                         */
                        PatchGlobalPublicDelegatedPrefixeRequest.create = function create(properties) {
                            return new PatchGlobalPublicDelegatedPrefixeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchGlobalPublicDelegatedPrefixeRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchGlobalPublicDelegatedPrefixeRequest} message PatchGlobalPublicDelegatedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchGlobalPublicDelegatedPrefixeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.publicDelegatedPrefixResource != null && Object.hasOwnProperty.call(message, "publicDelegatedPrefixResource"))
                                $root.google.cloud.compute.v1.PublicDelegatedPrefix.encode(message.publicDelegatedPrefixResource, writer.uint32(/* id 47594501, wireType 2 =*/380756010).fork()).ldelim();
                            if (message.publicDelegatedPrefix != null && Object.hasOwnProperty.call(message, "publicDelegatedPrefix"))
                                writer.uint32(/* id 204238440, wireType 2 =*/1633907522).string(message.publicDelegatedPrefix);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchGlobalPublicDelegatedPrefixeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchGlobalPublicDelegatedPrefixeRequest} message PatchGlobalPublicDelegatedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchGlobalPublicDelegatedPrefixeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchGlobalPublicDelegatedPrefixeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest} PatchGlobalPublicDelegatedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchGlobalPublicDelegatedPrefixeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 204238440: {
                                        message.publicDelegatedPrefix = reader.string();
                                        break;
                                    }
                                case 47594501: {
                                        message.publicDelegatedPrefixResource = $root.google.cloud.compute.v1.PublicDelegatedPrefix.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchGlobalPublicDelegatedPrefixeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest} PatchGlobalPublicDelegatedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchGlobalPublicDelegatedPrefixeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchGlobalPublicDelegatedPrefixeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchGlobalPublicDelegatedPrefixeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.publicDelegatedPrefix != null && message.hasOwnProperty("publicDelegatedPrefix"))
                                if (!$util.isString(message.publicDelegatedPrefix))
                                    return "publicDelegatedPrefix: string expected";
                            if (message.publicDelegatedPrefixResource != null && message.hasOwnProperty("publicDelegatedPrefixResource")) {
                                var error = $root.google.cloud.compute.v1.PublicDelegatedPrefix.verify(message.publicDelegatedPrefixResource);
                                if (error)
                                    return "publicDelegatedPrefixResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchGlobalPublicDelegatedPrefixeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest} PatchGlobalPublicDelegatedPrefixeRequest
                         */
                        PatchGlobalPublicDelegatedPrefixeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.publicDelegatedPrefix != null)
                                message.publicDelegatedPrefix = String(object.publicDelegatedPrefix);
                            if (object.publicDelegatedPrefixResource != null) {
                                if (typeof object.publicDelegatedPrefixResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest.publicDelegatedPrefixResource: object expected");
                                message.publicDelegatedPrefixResource = $root.google.cloud.compute.v1.PublicDelegatedPrefix.fromObject(object.publicDelegatedPrefixResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchGlobalPublicDelegatedPrefixeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest} message PatchGlobalPublicDelegatedPrefixeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchGlobalPublicDelegatedPrefixeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.publicDelegatedPrefixResource = null;
                                object.publicDelegatedPrefix = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.publicDelegatedPrefixResource != null && message.hasOwnProperty("publicDelegatedPrefixResource"))
                                object.publicDelegatedPrefixResource = $root.google.cloud.compute.v1.PublicDelegatedPrefix.toObject(message.publicDelegatedPrefixResource, options);
                            if (message.publicDelegatedPrefix != null && message.hasOwnProperty("publicDelegatedPrefix"))
                                object.publicDelegatedPrefix = message.publicDelegatedPrefix;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this PatchGlobalPublicDelegatedPrefixeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchGlobalPublicDelegatedPrefixeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchGlobalPublicDelegatedPrefixeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchGlobalPublicDelegatedPrefixeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest";
                        };
    
                        return PatchGlobalPublicDelegatedPrefixeRequest;
                    })();
    
                    v1.PatchHealthCheckRequest = (function() {
    
                        /**
                         * Properties of a PatchHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchHealthCheckRequest
                         * @property {string|null} [healthCheck] PatchHealthCheckRequest healthCheck
                         * @property {google.cloud.compute.v1.IHealthCheck|null} [healthCheckResource] PatchHealthCheckRequest healthCheckResource
                         * @property {string|null} [project] PatchHealthCheckRequest project
                         * @property {string|null} [requestId] PatchHealthCheckRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchHealthCheckRequest.
                         * @implements IPatchHealthCheckRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchHealthCheckRequest=} [properties] Properties to set
                         */
                        function PatchHealthCheckRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchHealthCheckRequest healthCheck.
                         * @member {string} healthCheck
                         * @memberof google.cloud.compute.v1.PatchHealthCheckRequest
                         * @instance
                         */
                        PatchHealthCheckRequest.prototype.healthCheck = "";
    
                        /**
                         * PatchHealthCheckRequest healthCheckResource.
                         * @member {google.cloud.compute.v1.IHealthCheck|null|undefined} healthCheckResource
                         * @memberof google.cloud.compute.v1.PatchHealthCheckRequest
                         * @instance
                         */
                        PatchHealthCheckRequest.prototype.healthCheckResource = null;
    
                        /**
                         * PatchHealthCheckRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchHealthCheckRequest
                         * @instance
                         */
                        PatchHealthCheckRequest.prototype.project = "";
    
                        /**
                         * PatchHealthCheckRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchHealthCheckRequest
                         * @instance
                         */
                        PatchHealthCheckRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchHealthCheckRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchHealthCheckRequest
                         * @instance
                         */
                        Object.defineProperty(PatchHealthCheckRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchHealthCheckRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchHealthCheckRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchHealthCheckRequest} PatchHealthCheckRequest instance
                         */
                        PatchHealthCheckRequest.create = function create(properties) {
                            return new PatchHealthCheckRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchHealthCheckRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchHealthCheckRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchHealthCheckRequest} message PatchHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchHealthCheckRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.healthCheckResource != null && Object.hasOwnProperty.call(message, "healthCheckResource"))
                                $root.google.cloud.compute.v1.HealthCheck.encode(message.healthCheckResource, writer.uint32(/* id 201925032, wireType 2 =*/1615400258).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.healthCheck != null && Object.hasOwnProperty.call(message, "healthCheck"))
                                writer.uint32(/* id 308876645, wireType 2 =*/2471013162).string(message.healthCheck);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchHealthCheckRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchHealthCheckRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchHealthCheckRequest} message PatchHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchHealthCheckRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchHealthCheckRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchHealthCheckRequest} PatchHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchHealthCheckRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchHealthCheckRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 308876645: {
                                        message.healthCheck = reader.string();
                                        break;
                                    }
                                case 201925032: {
                                        message.healthCheckResource = $root.google.cloud.compute.v1.HealthCheck.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchHealthCheckRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchHealthCheckRequest} PatchHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchHealthCheckRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchHealthCheckRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchHealthCheckRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck"))
                                if (!$util.isString(message.healthCheck))
                                    return "healthCheck: string expected";
                            if (message.healthCheckResource != null && message.hasOwnProperty("healthCheckResource")) {
                                var error = $root.google.cloud.compute.v1.HealthCheck.verify(message.healthCheckResource);
                                if (error)
                                    return "healthCheckResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchHealthCheckRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchHealthCheckRequest} PatchHealthCheckRequest
                         */
                        PatchHealthCheckRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchHealthCheckRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchHealthCheckRequest();
                            if (object.healthCheck != null)
                                message.healthCheck = String(object.healthCheck);
                            if (object.healthCheckResource != null) {
                                if (typeof object.healthCheckResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchHealthCheckRequest.healthCheckResource: object expected");
                                message.healthCheckResource = $root.google.cloud.compute.v1.HealthCheck.fromObject(object.healthCheckResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchHealthCheckRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchHealthCheckRequest} message PatchHealthCheckRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchHealthCheckRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.healthCheckResource = null;
                                object.project = "";
                                object.healthCheck = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.healthCheckResource != null && message.hasOwnProperty("healthCheckResource"))
                                object.healthCheckResource = $root.google.cloud.compute.v1.HealthCheck.toObject(message.healthCheckResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck"))
                                object.healthCheck = message.healthCheck;
                            return object;
                        };
    
                        /**
                         * Converts this PatchHealthCheckRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchHealthCheckRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchHealthCheckRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchHealthCheckRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchHealthCheckRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchHealthCheckRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchHealthCheckRequest";
                        };
    
                        return PatchHealthCheckRequest;
                    })();
    
                    v1.PatchImageRequest = (function() {
    
                        /**
                         * Properties of a PatchImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchImageRequest
                         * @property {string|null} [image] PatchImageRequest image
                         * @property {google.cloud.compute.v1.IImage|null} [imageResource] PatchImageRequest imageResource
                         * @property {string|null} [project] PatchImageRequest project
                         * @property {string|null} [requestId] PatchImageRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchImageRequest.
                         * @implements IPatchImageRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchImageRequest=} [properties] Properties to set
                         */
                        function PatchImageRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchImageRequest image.
                         * @member {string} image
                         * @memberof google.cloud.compute.v1.PatchImageRequest
                         * @instance
                         */
                        PatchImageRequest.prototype.image = "";
    
                        /**
                         * PatchImageRequest imageResource.
                         * @member {google.cloud.compute.v1.IImage|null|undefined} imageResource
                         * @memberof google.cloud.compute.v1.PatchImageRequest
                         * @instance
                         */
                        PatchImageRequest.prototype.imageResource = null;
    
                        /**
                         * PatchImageRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchImageRequest
                         * @instance
                         */
                        PatchImageRequest.prototype.project = "";
    
                        /**
                         * PatchImageRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchImageRequest
                         * @instance
                         */
                        PatchImageRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchImageRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchImageRequest
                         * @instance
                         */
                        Object.defineProperty(PatchImageRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchImageRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchImageRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchImageRequest} PatchImageRequest instance
                         */
                        PatchImageRequest.create = function create(properties) {
                            return new PatchImageRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchImageRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchImageRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchImageRequest} message PatchImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchImageRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.image != null && Object.hasOwnProperty.call(message, "image"))
                                writer.uint32(/* id 100313435, wireType 2 =*/802507482).string(message.image);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.imageResource != null && Object.hasOwnProperty.call(message, "imageResource"))
                                $root.google.cloud.compute.v1.Image.encode(message.imageResource, writer.uint32(/* id 371171954, wireType 2 =*/2969375634).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchImageRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchImageRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchImageRequest} message PatchImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchImageRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchImageRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchImageRequest} PatchImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchImageRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchImageRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 100313435: {
                                        message.image = reader.string();
                                        break;
                                    }
                                case 371171954: {
                                        message.imageResource = $root.google.cloud.compute.v1.Image.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchImageRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchImageRequest} PatchImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchImageRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchImageRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchImageRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchImageRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.image != null && message.hasOwnProperty("image"))
                                if (!$util.isString(message.image))
                                    return "image: string expected";
                            if (message.imageResource != null && message.hasOwnProperty("imageResource")) {
                                var error = $root.google.cloud.compute.v1.Image.verify(message.imageResource);
                                if (error)
                                    return "imageResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchImageRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchImageRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchImageRequest} PatchImageRequest
                         */
                        PatchImageRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchImageRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchImageRequest();
                            if (object.image != null)
                                message.image = String(object.image);
                            if (object.imageResource != null) {
                                if (typeof object.imageResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchImageRequest.imageResource: object expected");
                                message.imageResource = $root.google.cloud.compute.v1.Image.fromObject(object.imageResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchImageRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchImageRequest} message PatchImageRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchImageRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.image = "";
                                object.project = "";
                                object.imageResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.image != null && message.hasOwnProperty("image"))
                                object.image = message.image;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.imageResource != null && message.hasOwnProperty("imageResource"))
                                object.imageResource = $root.google.cloud.compute.v1.Image.toObject(message.imageResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this PatchImageRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchImageRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchImageRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchImageRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchImageRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchImageRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchImageRequest";
                        };
    
                        return PatchImageRequest;
                    })();
    
                    v1.PatchInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a PatchInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] PatchInstanceGroupManagerRequest instanceGroupManager
                         * @property {google.cloud.compute.v1.IInstanceGroupManager|null} [instanceGroupManagerResource] PatchInstanceGroupManagerRequest instanceGroupManagerResource
                         * @property {string|null} [project] PatchInstanceGroupManagerRequest project
                         * @property {string|null} [requestId] PatchInstanceGroupManagerRequest requestId
                         * @property {string|null} [zone] PatchInstanceGroupManagerRequest zone
                         */
    
                        /**
                         * Constructs a new PatchInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchInstanceGroupManagerRequest.
                         * @implements IPatchInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function PatchInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.PatchInstanceGroupManagerRequest
                         * @instance
                         */
                        PatchInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * PatchInstanceGroupManagerRequest instanceGroupManagerResource.
                         * @member {google.cloud.compute.v1.IInstanceGroupManager|null|undefined} instanceGroupManagerResource
                         * @memberof google.cloud.compute.v1.PatchInstanceGroupManagerRequest
                         * @instance
                         */
                        PatchInstanceGroupManagerRequest.prototype.instanceGroupManagerResource = null;
    
                        /**
                         * PatchInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchInstanceGroupManagerRequest
                         * @instance
                         */
                        PatchInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * PatchInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchInstanceGroupManagerRequest
                         * @instance
                         */
                        PatchInstanceGroupManagerRequest.prototype.requestId = null;
    
                        /**
                         * PatchInstanceGroupManagerRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.PatchInstanceGroupManagerRequest
                         * @instance
                         */
                        PatchInstanceGroupManagerRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(PatchInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchInstanceGroupManagerRequest} PatchInstanceGroupManagerRequest instance
                         */
                        PatchInstanceGroupManagerRequest.create = function create(properties) {
                            return new PatchInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchInstanceGroupManagerRequest} message PatchInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            if (message.instanceGroupManagerResource != null && Object.hasOwnProperty.call(message, "instanceGroupManagerResource"))
                                $root.google.cloud.compute.v1.InstanceGroupManager.encode(message.instanceGroupManagerResource, writer.uint32(/* id 261063946, wireType 2 =*/2088511570).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchInstanceGroupManagerRequest} message PatchInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchInstanceGroupManagerRequest} PatchInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 261063946: {
                                        message.instanceGroupManagerResource = $root.google.cloud.compute.v1.InstanceGroupManager.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchInstanceGroupManagerRequest} PatchInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.instanceGroupManagerResource != null && message.hasOwnProperty("instanceGroupManagerResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceGroupManager.verify(message.instanceGroupManagerResource);
                                if (error)
                                    return "instanceGroupManagerResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a PatchInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchInstanceGroupManagerRequest} PatchInstanceGroupManagerRequest
                         */
                        PatchInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.instanceGroupManagerResource != null) {
                                if (typeof object.instanceGroupManagerResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchInstanceGroupManagerRequest.instanceGroupManagerResource: object expected");
                                message.instanceGroupManagerResource = $root.google.cloud.compute.v1.InstanceGroupManager.fromObject(object.instanceGroupManagerResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchInstanceGroupManagerRequest} message PatchInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                                object.instanceGroupManagerResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            if (message.instanceGroupManagerResource != null && message.hasOwnProperty("instanceGroupManagerResource"))
                                object.instanceGroupManagerResource = $root.google.cloud.compute.v1.InstanceGroupManager.toObject(message.instanceGroupManagerResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this PatchInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchInstanceGroupManagerRequest";
                        };
    
                        return PatchInstanceGroupManagerRequest;
                    })();
    
                    v1.PatchInterconnectAttachmentRequest = (function() {
    
                        /**
                         * Properties of a PatchInterconnectAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchInterconnectAttachmentRequest
                         * @property {string|null} [interconnectAttachment] PatchInterconnectAttachmentRequest interconnectAttachment
                         * @property {google.cloud.compute.v1.IInterconnectAttachment|null} [interconnectAttachmentResource] PatchInterconnectAttachmentRequest interconnectAttachmentResource
                         * @property {string|null} [project] PatchInterconnectAttachmentRequest project
                         * @property {string|null} [region] PatchInterconnectAttachmentRequest region
                         * @property {string|null} [requestId] PatchInterconnectAttachmentRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchInterconnectAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchInterconnectAttachmentRequest.
                         * @implements IPatchInterconnectAttachmentRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchInterconnectAttachmentRequest=} [properties] Properties to set
                         */
                        function PatchInterconnectAttachmentRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchInterconnectAttachmentRequest interconnectAttachment.
                         * @member {string} interconnectAttachment
                         * @memberof google.cloud.compute.v1.PatchInterconnectAttachmentRequest
                         * @instance
                         */
                        PatchInterconnectAttachmentRequest.prototype.interconnectAttachment = "";
    
                        /**
                         * PatchInterconnectAttachmentRequest interconnectAttachmentResource.
                         * @member {google.cloud.compute.v1.IInterconnectAttachment|null|undefined} interconnectAttachmentResource
                         * @memberof google.cloud.compute.v1.PatchInterconnectAttachmentRequest
                         * @instance
                         */
                        PatchInterconnectAttachmentRequest.prototype.interconnectAttachmentResource = null;
    
                        /**
                         * PatchInterconnectAttachmentRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchInterconnectAttachmentRequest
                         * @instance
                         */
                        PatchInterconnectAttachmentRequest.prototype.project = "";
    
                        /**
                         * PatchInterconnectAttachmentRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PatchInterconnectAttachmentRequest
                         * @instance
                         */
                        PatchInterconnectAttachmentRequest.prototype.region = "";
    
                        /**
                         * PatchInterconnectAttachmentRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchInterconnectAttachmentRequest
                         * @instance
                         */
                        PatchInterconnectAttachmentRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchInterconnectAttachmentRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchInterconnectAttachmentRequest
                         * @instance
                         */
                        Object.defineProperty(PatchInterconnectAttachmentRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchInterconnectAttachmentRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchInterconnectAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchInterconnectAttachmentRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchInterconnectAttachmentRequest} PatchInterconnectAttachmentRequest instance
                         */
                        PatchInterconnectAttachmentRequest.create = function create(properties) {
                            return new PatchInterconnectAttachmentRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchInterconnectAttachmentRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchInterconnectAttachmentRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchInterconnectAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchInterconnectAttachmentRequest} message PatchInterconnectAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchInterconnectAttachmentRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.interconnectAttachmentResource != null && Object.hasOwnProperty.call(message, "interconnectAttachmentResource"))
                                $root.google.cloud.compute.v1.InterconnectAttachment.encode(message.interconnectAttachmentResource, writer.uint32(/* id 212341369, wireType 2 =*/1698730954).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.interconnectAttachment != null && Object.hasOwnProperty.call(message, "interconnectAttachment"))
                                writer.uint32(/* id 308135284, wireType 2 =*/2465082274).string(message.interconnectAttachment);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchInterconnectAttachmentRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchInterconnectAttachmentRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchInterconnectAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchInterconnectAttachmentRequest} message PatchInterconnectAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchInterconnectAttachmentRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchInterconnectAttachmentRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchInterconnectAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchInterconnectAttachmentRequest} PatchInterconnectAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchInterconnectAttachmentRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchInterconnectAttachmentRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 308135284: {
                                        message.interconnectAttachment = reader.string();
                                        break;
                                    }
                                case 212341369: {
                                        message.interconnectAttachmentResource = $root.google.cloud.compute.v1.InterconnectAttachment.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchInterconnectAttachmentRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchInterconnectAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchInterconnectAttachmentRequest} PatchInterconnectAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchInterconnectAttachmentRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchInterconnectAttachmentRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchInterconnectAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchInterconnectAttachmentRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.interconnectAttachment != null && message.hasOwnProperty("interconnectAttachment"))
                                if (!$util.isString(message.interconnectAttachment))
                                    return "interconnectAttachment: string expected";
                            if (message.interconnectAttachmentResource != null && message.hasOwnProperty("interconnectAttachmentResource")) {
                                var error = $root.google.cloud.compute.v1.InterconnectAttachment.verify(message.interconnectAttachmentResource);
                                if (error)
                                    return "interconnectAttachmentResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchInterconnectAttachmentRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchInterconnectAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchInterconnectAttachmentRequest} PatchInterconnectAttachmentRequest
                         */
                        PatchInterconnectAttachmentRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchInterconnectAttachmentRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchInterconnectAttachmentRequest();
                            if (object.interconnectAttachment != null)
                                message.interconnectAttachment = String(object.interconnectAttachment);
                            if (object.interconnectAttachmentResource != null) {
                                if (typeof object.interconnectAttachmentResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchInterconnectAttachmentRequest.interconnectAttachmentResource: object expected");
                                message.interconnectAttachmentResource = $root.google.cloud.compute.v1.InterconnectAttachment.fromObject(object.interconnectAttachmentResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchInterconnectAttachmentRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchInterconnectAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchInterconnectAttachmentRequest} message PatchInterconnectAttachmentRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchInterconnectAttachmentRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.interconnectAttachmentResource = null;
                                object.project = "";
                                object.interconnectAttachment = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.interconnectAttachmentResource != null && message.hasOwnProperty("interconnectAttachmentResource"))
                                object.interconnectAttachmentResource = $root.google.cloud.compute.v1.InterconnectAttachment.toObject(message.interconnectAttachmentResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.interconnectAttachment != null && message.hasOwnProperty("interconnectAttachment"))
                                object.interconnectAttachment = message.interconnectAttachment;
                            return object;
                        };
    
                        /**
                         * Converts this PatchInterconnectAttachmentRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchInterconnectAttachmentRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchInterconnectAttachmentRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchInterconnectAttachmentRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchInterconnectAttachmentRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchInterconnectAttachmentRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchInterconnectAttachmentRequest";
                        };
    
                        return PatchInterconnectAttachmentRequest;
                    })();
    
                    v1.PatchInterconnectRequest = (function() {
    
                        /**
                         * Properties of a PatchInterconnectRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchInterconnectRequest
                         * @property {string|null} [interconnect] PatchInterconnectRequest interconnect
                         * @property {google.cloud.compute.v1.IInterconnect|null} [interconnectResource] PatchInterconnectRequest interconnectResource
                         * @property {string|null} [project] PatchInterconnectRequest project
                         * @property {string|null} [requestId] PatchInterconnectRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchInterconnectRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchInterconnectRequest.
                         * @implements IPatchInterconnectRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchInterconnectRequest=} [properties] Properties to set
                         */
                        function PatchInterconnectRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchInterconnectRequest interconnect.
                         * @member {string} interconnect
                         * @memberof google.cloud.compute.v1.PatchInterconnectRequest
                         * @instance
                         */
                        PatchInterconnectRequest.prototype.interconnect = "";
    
                        /**
                         * PatchInterconnectRequest interconnectResource.
                         * @member {google.cloud.compute.v1.IInterconnect|null|undefined} interconnectResource
                         * @memberof google.cloud.compute.v1.PatchInterconnectRequest
                         * @instance
                         */
                        PatchInterconnectRequest.prototype.interconnectResource = null;
    
                        /**
                         * PatchInterconnectRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchInterconnectRequest
                         * @instance
                         */
                        PatchInterconnectRequest.prototype.project = "";
    
                        /**
                         * PatchInterconnectRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchInterconnectRequest
                         * @instance
                         */
                        PatchInterconnectRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchInterconnectRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchInterconnectRequest
                         * @instance
                         */
                        Object.defineProperty(PatchInterconnectRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchInterconnectRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchInterconnectRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchInterconnectRequest} PatchInterconnectRequest instance
                         */
                        PatchInterconnectRequest.create = function create(properties) {
                            return new PatchInterconnectRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchInterconnectRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchInterconnectRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchInterconnectRequest} message PatchInterconnectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchInterconnectRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.interconnect != null && Object.hasOwnProperty.call(message, "interconnect"))
                                writer.uint32(/* id 224601230, wireType 2 =*/1796809842).string(message.interconnect);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.interconnectResource != null && Object.hasOwnProperty.call(message, "interconnectResource"))
                                $root.google.cloud.compute.v1.Interconnect.encode(message.interconnectResource, writer.uint32(/* id 397611167, wireType 2 =*/3180889338).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchInterconnectRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchInterconnectRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchInterconnectRequest} message PatchInterconnectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchInterconnectRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchInterconnectRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchInterconnectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchInterconnectRequest} PatchInterconnectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchInterconnectRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchInterconnectRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 224601230: {
                                        message.interconnect = reader.string();
                                        break;
                                    }
                                case 397611167: {
                                        message.interconnectResource = $root.google.cloud.compute.v1.Interconnect.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchInterconnectRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchInterconnectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchInterconnectRequest} PatchInterconnectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchInterconnectRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchInterconnectRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchInterconnectRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchInterconnectRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.interconnect != null && message.hasOwnProperty("interconnect"))
                                if (!$util.isString(message.interconnect))
                                    return "interconnect: string expected";
                            if (message.interconnectResource != null && message.hasOwnProperty("interconnectResource")) {
                                var error = $root.google.cloud.compute.v1.Interconnect.verify(message.interconnectResource);
                                if (error)
                                    return "interconnectResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchInterconnectRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchInterconnectRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchInterconnectRequest} PatchInterconnectRequest
                         */
                        PatchInterconnectRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchInterconnectRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchInterconnectRequest();
                            if (object.interconnect != null)
                                message.interconnect = String(object.interconnect);
                            if (object.interconnectResource != null) {
                                if (typeof object.interconnectResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchInterconnectRequest.interconnectResource: object expected");
                                message.interconnectResource = $root.google.cloud.compute.v1.Interconnect.fromObject(object.interconnectResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchInterconnectRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchInterconnectRequest} message PatchInterconnectRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchInterconnectRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.interconnect = "";
                                object.project = "";
                                object.interconnectResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.interconnect != null && message.hasOwnProperty("interconnect"))
                                object.interconnect = message.interconnect;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.interconnectResource != null && message.hasOwnProperty("interconnectResource"))
                                object.interconnectResource = $root.google.cloud.compute.v1.Interconnect.toObject(message.interconnectResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this PatchInterconnectRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchInterconnectRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchInterconnectRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchInterconnectRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchInterconnectRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchInterconnectRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchInterconnectRequest";
                        };
    
                        return PatchInterconnectRequest;
                    })();
    
                    v1.PatchNetworkEdgeSecurityServiceRequest = (function() {
    
                        /**
                         * Properties of a PatchNetworkEdgeSecurityServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchNetworkEdgeSecurityServiceRequest
                         * @property {string|null} [networkEdgeSecurityService] PatchNetworkEdgeSecurityServiceRequest networkEdgeSecurityService
                         * @property {google.cloud.compute.v1.INetworkEdgeSecurityService|null} [networkEdgeSecurityServiceResource] PatchNetworkEdgeSecurityServiceRequest networkEdgeSecurityServiceResource
                         * @property {string|null} [paths] PatchNetworkEdgeSecurityServiceRequest paths
                         * @property {string|null} [project] PatchNetworkEdgeSecurityServiceRequest project
                         * @property {string|null} [region] PatchNetworkEdgeSecurityServiceRequest region
                         * @property {string|null} [requestId] PatchNetworkEdgeSecurityServiceRequest requestId
                         * @property {string|null} [updateMask] PatchNetworkEdgeSecurityServiceRequest updateMask
                         */
    
                        /**
                         * Constructs a new PatchNetworkEdgeSecurityServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchNetworkEdgeSecurityServiceRequest.
                         * @implements IPatchNetworkEdgeSecurityServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchNetworkEdgeSecurityServiceRequest=} [properties] Properties to set
                         */
                        function PatchNetworkEdgeSecurityServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchNetworkEdgeSecurityServiceRequest networkEdgeSecurityService.
                         * @member {string} networkEdgeSecurityService
                         * @memberof google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        PatchNetworkEdgeSecurityServiceRequest.prototype.networkEdgeSecurityService = "";
    
                        /**
                         * PatchNetworkEdgeSecurityServiceRequest networkEdgeSecurityServiceResource.
                         * @member {google.cloud.compute.v1.INetworkEdgeSecurityService|null|undefined} networkEdgeSecurityServiceResource
                         * @memberof google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        PatchNetworkEdgeSecurityServiceRequest.prototype.networkEdgeSecurityServiceResource = null;
    
                        /**
                         * PatchNetworkEdgeSecurityServiceRequest paths.
                         * @member {string|null|undefined} paths
                         * @memberof google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        PatchNetworkEdgeSecurityServiceRequest.prototype.paths = null;
    
                        /**
                         * PatchNetworkEdgeSecurityServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        PatchNetworkEdgeSecurityServiceRequest.prototype.project = "";
    
                        /**
                         * PatchNetworkEdgeSecurityServiceRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        PatchNetworkEdgeSecurityServiceRequest.prototype.region = "";
    
                        /**
                         * PatchNetworkEdgeSecurityServiceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        PatchNetworkEdgeSecurityServiceRequest.prototype.requestId = null;
    
                        /**
                         * PatchNetworkEdgeSecurityServiceRequest updateMask.
                         * @member {string|null|undefined} updateMask
                         * @memberof google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        PatchNetworkEdgeSecurityServiceRequest.prototype.updateMask = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchNetworkEdgeSecurityServiceRequest _paths.
                         * @member {"paths"|undefined} _paths
                         * @memberof google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        Object.defineProperty(PatchNetworkEdgeSecurityServiceRequest.prototype, "_paths", {
                            get: $util.oneOfGetter($oneOfFields = ["paths"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PatchNetworkEdgeSecurityServiceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        Object.defineProperty(PatchNetworkEdgeSecurityServiceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PatchNetworkEdgeSecurityServiceRequest _updateMask.
                         * @member {"updateMask"|undefined} _updateMask
                         * @memberof google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest
                         * @instance
                         */
                        Object.defineProperty(PatchNetworkEdgeSecurityServiceRequest.prototype, "_updateMask", {
                            get: $util.oneOfGetter($oneOfFields = ["updateMask"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchNetworkEdgeSecurityServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchNetworkEdgeSecurityServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest} PatchNetworkEdgeSecurityServiceRequest instance
                         */
                        PatchNetworkEdgeSecurityServiceRequest.create = function create(properties) {
                            return new PatchNetworkEdgeSecurityServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchNetworkEdgeSecurityServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchNetworkEdgeSecurityServiceRequest} message PatchNetworkEdgeSecurityServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchNetworkEdgeSecurityServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.paths != null && Object.hasOwnProperty.call(message, "paths"))
                                writer.uint32(/* id 106438894, wireType 2 =*/851511154).string(message.paths);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.networkEdgeSecurityService != null && Object.hasOwnProperty.call(message, "networkEdgeSecurityService"))
                                writer.uint32(/* id 157011879, wireType 2 =*/1256095034).string(message.networkEdgeSecurityService);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.networkEdgeSecurityServiceResource != null && Object.hasOwnProperty.call(message, "networkEdgeSecurityServiceResource"))
                                $root.google.cloud.compute.v1.NetworkEdgeSecurityService.encode(message.networkEdgeSecurityServiceResource, writer.uint32(/* id 477548966, wireType 2 =*/3820391730).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                writer.uint32(/* id 500079778, wireType 2 =*/4000638226).string(message.updateMask);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchNetworkEdgeSecurityServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchNetworkEdgeSecurityServiceRequest} message PatchNetworkEdgeSecurityServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchNetworkEdgeSecurityServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchNetworkEdgeSecurityServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest} PatchNetworkEdgeSecurityServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchNetworkEdgeSecurityServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 157011879: {
                                        message.networkEdgeSecurityService = reader.string();
                                        break;
                                    }
                                case 477548966: {
                                        message.networkEdgeSecurityServiceResource = $root.google.cloud.compute.v1.NetworkEdgeSecurityService.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 106438894: {
                                        message.paths = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 500079778: {
                                        message.updateMask = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchNetworkEdgeSecurityServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest} PatchNetworkEdgeSecurityServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchNetworkEdgeSecurityServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchNetworkEdgeSecurityServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchNetworkEdgeSecurityServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.networkEdgeSecurityService != null && message.hasOwnProperty("networkEdgeSecurityService"))
                                if (!$util.isString(message.networkEdgeSecurityService))
                                    return "networkEdgeSecurityService: string expected";
                            if (message.networkEdgeSecurityServiceResource != null && message.hasOwnProperty("networkEdgeSecurityServiceResource")) {
                                var error = $root.google.cloud.compute.v1.NetworkEdgeSecurityService.verify(message.networkEdgeSecurityServiceResource);
                                if (error)
                                    return "networkEdgeSecurityServiceResource." + error;
                            }
                            if (message.paths != null && message.hasOwnProperty("paths")) {
                                properties._paths = 1;
                                if (!$util.isString(message.paths))
                                    return "paths: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                properties._updateMask = 1;
                                if (!$util.isString(message.updateMask))
                                    return "updateMask: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchNetworkEdgeSecurityServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest} PatchNetworkEdgeSecurityServiceRequest
                         */
                        PatchNetworkEdgeSecurityServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest();
                            if (object.networkEdgeSecurityService != null)
                                message.networkEdgeSecurityService = String(object.networkEdgeSecurityService);
                            if (object.networkEdgeSecurityServiceResource != null) {
                                if (typeof object.networkEdgeSecurityServiceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest.networkEdgeSecurityServiceResource: object expected");
                                message.networkEdgeSecurityServiceResource = $root.google.cloud.compute.v1.NetworkEdgeSecurityService.fromObject(object.networkEdgeSecurityServiceResource);
                            }
                            if (object.paths != null)
                                message.paths = String(object.paths);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.updateMask != null)
                                message.updateMask = String(object.updateMask);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchNetworkEdgeSecurityServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest} message PatchNetworkEdgeSecurityServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchNetworkEdgeSecurityServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.networkEdgeSecurityService = "";
                                object.project = "";
                                object.networkEdgeSecurityServiceResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.paths != null && message.hasOwnProperty("paths")) {
                                object.paths = message.paths;
                                if (options.oneofs)
                                    object._paths = "paths";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.networkEdgeSecurityService != null && message.hasOwnProperty("networkEdgeSecurityService"))
                                object.networkEdgeSecurityService = message.networkEdgeSecurityService;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.networkEdgeSecurityServiceResource != null && message.hasOwnProperty("networkEdgeSecurityServiceResource"))
                                object.networkEdgeSecurityServiceResource = $root.google.cloud.compute.v1.NetworkEdgeSecurityService.toObject(message.networkEdgeSecurityServiceResource, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                object.updateMask = message.updateMask;
                                if (options.oneofs)
                                    object._updateMask = "updateMask";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PatchNetworkEdgeSecurityServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchNetworkEdgeSecurityServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchNetworkEdgeSecurityServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchNetworkEdgeSecurityServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest";
                        };
    
                        return PatchNetworkEdgeSecurityServiceRequest;
                    })();
    
                    v1.PatchNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a PatchNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] PatchNetworkFirewallPolicyRequest firewallPolicy
                         * @property {google.cloud.compute.v1.IFirewallPolicy|null} [firewallPolicyResource] PatchNetworkFirewallPolicyRequest firewallPolicyResource
                         * @property {string|null} [project] PatchNetworkFirewallPolicyRequest project
                         * @property {string|null} [requestId] PatchNetworkFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchNetworkFirewallPolicyRequest.
                         * @implements IPatchNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function PatchNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest
                         * @instance
                         */
                        PatchNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * PatchNetworkFirewallPolicyRequest firewallPolicyResource.
                         * @member {google.cloud.compute.v1.IFirewallPolicy|null|undefined} firewallPolicyResource
                         * @memberof google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest
                         * @instance
                         */
                        PatchNetworkFirewallPolicyRequest.prototype.firewallPolicyResource = null;
    
                        /**
                         * PatchNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest
                         * @instance
                         */
                        PatchNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * PatchNetworkFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest
                         * @instance
                         */
                        PatchNetworkFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchNetworkFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(PatchNetworkFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest} PatchNetworkFirewallPolicyRequest instance
                         */
                        PatchNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new PatchNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchNetworkFirewallPolicyRequest} message PatchNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewallPolicyResource != null && Object.hasOwnProperty.call(message, "firewallPolicyResource"))
                                $root.google.cloud.compute.v1.FirewallPolicy.encode(message.firewallPolicyResource, writer.uint32(/* id 495049532, wireType 2 =*/3960396258).fork()).ldelim();
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchNetworkFirewallPolicyRequest} message PatchNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest} PatchNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 495049532: {
                                        message.firewallPolicyResource = $root.google.cloud.compute.v1.FirewallPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest} PatchNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.firewallPolicyResource != null && message.hasOwnProperty("firewallPolicyResource")) {
                                var error = $root.google.cloud.compute.v1.FirewallPolicy.verify(message.firewallPolicyResource);
                                if (error)
                                    return "firewallPolicyResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest} PatchNetworkFirewallPolicyRequest
                         */
                        PatchNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.firewallPolicyResource != null) {
                                if (typeof object.firewallPolicyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest.firewallPolicyResource: object expected");
                                message.firewallPolicyResource = $root.google.cloud.compute.v1.FirewallPolicy.fromObject(object.firewallPolicyResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest} message PatchNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.firewallPolicyResource = null;
                                object.firewallPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewallPolicyResource != null && message.hasOwnProperty("firewallPolicyResource"))
                                object.firewallPolicyResource = $root.google.cloud.compute.v1.FirewallPolicy.toObject(message.firewallPolicyResource, options);
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this PatchNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest";
                        };
    
                        return PatchNetworkFirewallPolicyRequest;
                    })();
    
                    v1.PatchNetworkRequest = (function() {
    
                        /**
                         * Properties of a PatchNetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchNetworkRequest
                         * @property {string|null} [network] PatchNetworkRequest network
                         * @property {google.cloud.compute.v1.INetwork|null} [networkResource] PatchNetworkRequest networkResource
                         * @property {string|null} [project] PatchNetworkRequest project
                         * @property {string|null} [requestId] PatchNetworkRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchNetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchNetworkRequest.
                         * @implements IPatchNetworkRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchNetworkRequest=} [properties] Properties to set
                         */
                        function PatchNetworkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchNetworkRequest network.
                         * @member {string} network
                         * @memberof google.cloud.compute.v1.PatchNetworkRequest
                         * @instance
                         */
                        PatchNetworkRequest.prototype.network = "";
    
                        /**
                         * PatchNetworkRequest networkResource.
                         * @member {google.cloud.compute.v1.INetwork|null|undefined} networkResource
                         * @memberof google.cloud.compute.v1.PatchNetworkRequest
                         * @instance
                         */
                        PatchNetworkRequest.prototype.networkResource = null;
    
                        /**
                         * PatchNetworkRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchNetworkRequest
                         * @instance
                         */
                        PatchNetworkRequest.prototype.project = "";
    
                        /**
                         * PatchNetworkRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchNetworkRequest
                         * @instance
                         */
                        PatchNetworkRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchNetworkRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchNetworkRequest
                         * @instance
                         */
                        Object.defineProperty(PatchNetworkRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchNetworkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchNetworkRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchNetworkRequest} PatchNetworkRequest instance
                         */
                        PatchNetworkRequest.create = function create(properties) {
                            return new PatchNetworkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchNetworkRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchNetworkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchNetworkRequest} message PatchNetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchNetworkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.networkResource != null && Object.hasOwnProperty.call(message, "networkResource"))
                                $root.google.cloud.compute.v1.Network.encode(message.networkResource, writer.uint32(/* id 122105599, wireType 2 =*/976844794).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchNetworkRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchNetworkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchNetworkRequest} message PatchNetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchNetworkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchNetworkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchNetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchNetworkRequest} PatchNetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchNetworkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchNetworkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 122105599: {
                                        message.networkResource = $root.google.cloud.compute.v1.Network.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchNetworkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchNetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchNetworkRequest} PatchNetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchNetworkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchNetworkRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchNetworkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchNetworkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.network != null && message.hasOwnProperty("network"))
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            if (message.networkResource != null && message.hasOwnProperty("networkResource")) {
                                var error = $root.google.cloud.compute.v1.Network.verify(message.networkResource);
                                if (error)
                                    return "networkResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchNetworkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchNetworkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchNetworkRequest} PatchNetworkRequest
                         */
                        PatchNetworkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchNetworkRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchNetworkRequest();
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.networkResource != null) {
                                if (typeof object.networkResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchNetworkRequest.networkResource: object expected");
                                message.networkResource = $root.google.cloud.compute.v1.Network.fromObject(object.networkResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchNetworkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchNetworkRequest} message PatchNetworkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchNetworkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.networkResource = null;
                                object.project = "";
                                object.network = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.networkResource != null && message.hasOwnProperty("networkResource"))
                                object.networkResource = $root.google.cloud.compute.v1.Network.toObject(message.networkResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.network != null && message.hasOwnProperty("network"))
                                object.network = message.network;
                            return object;
                        };
    
                        /**
                         * Converts this PatchNetworkRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchNetworkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchNetworkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchNetworkRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchNetworkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchNetworkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchNetworkRequest";
                        };
    
                        return PatchNetworkRequest;
                    })();
    
                    v1.PatchNodeGroupRequest = (function() {
    
                        /**
                         * Properties of a PatchNodeGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchNodeGroupRequest
                         * @property {string|null} [nodeGroup] PatchNodeGroupRequest nodeGroup
                         * @property {google.cloud.compute.v1.INodeGroup|null} [nodeGroupResource] PatchNodeGroupRequest nodeGroupResource
                         * @property {string|null} [project] PatchNodeGroupRequest project
                         * @property {string|null} [requestId] PatchNodeGroupRequest requestId
                         * @property {string|null} [zone] PatchNodeGroupRequest zone
                         */
    
                        /**
                         * Constructs a new PatchNodeGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchNodeGroupRequest.
                         * @implements IPatchNodeGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchNodeGroupRequest=} [properties] Properties to set
                         */
                        function PatchNodeGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchNodeGroupRequest nodeGroup.
                         * @member {string} nodeGroup
                         * @memberof google.cloud.compute.v1.PatchNodeGroupRequest
                         * @instance
                         */
                        PatchNodeGroupRequest.prototype.nodeGroup = "";
    
                        /**
                         * PatchNodeGroupRequest nodeGroupResource.
                         * @member {google.cloud.compute.v1.INodeGroup|null|undefined} nodeGroupResource
                         * @memberof google.cloud.compute.v1.PatchNodeGroupRequest
                         * @instance
                         */
                        PatchNodeGroupRequest.prototype.nodeGroupResource = null;
    
                        /**
                         * PatchNodeGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchNodeGroupRequest
                         * @instance
                         */
                        PatchNodeGroupRequest.prototype.project = "";
    
                        /**
                         * PatchNodeGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchNodeGroupRequest
                         * @instance
                         */
                        PatchNodeGroupRequest.prototype.requestId = null;
    
                        /**
                         * PatchNodeGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.PatchNodeGroupRequest
                         * @instance
                         */
                        PatchNodeGroupRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchNodeGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchNodeGroupRequest
                         * @instance
                         */
                        Object.defineProperty(PatchNodeGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchNodeGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchNodeGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchNodeGroupRequest} PatchNodeGroupRequest instance
                         */
                        PatchNodeGroupRequest.create = function create(properties) {
                            return new PatchNodeGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchNodeGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchNodeGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchNodeGroupRequest} message PatchNodeGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchNodeGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.nodeGroup != null && Object.hasOwnProperty.call(message, "nodeGroup"))
                                writer.uint32(/* id 469958146, wireType 2 =*/3759665170).string(message.nodeGroup);
                            if (message.nodeGroupResource != null && Object.hasOwnProperty.call(message, "nodeGroupResource"))
                                $root.google.cloud.compute.v1.NodeGroup.encode(message.nodeGroupResource, writer.uint32(/* id 505321899, wireType 2 =*/4042575194).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchNodeGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchNodeGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchNodeGroupRequest} message PatchNodeGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchNodeGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchNodeGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchNodeGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchNodeGroupRequest} PatchNodeGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchNodeGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchNodeGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 469958146: {
                                        message.nodeGroup = reader.string();
                                        break;
                                    }
                                case 505321899: {
                                        message.nodeGroupResource = $root.google.cloud.compute.v1.NodeGroup.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchNodeGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchNodeGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchNodeGroupRequest} PatchNodeGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchNodeGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchNodeGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchNodeGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchNodeGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.nodeGroup != null && message.hasOwnProperty("nodeGroup"))
                                if (!$util.isString(message.nodeGroup))
                                    return "nodeGroup: string expected";
                            if (message.nodeGroupResource != null && message.hasOwnProperty("nodeGroupResource")) {
                                var error = $root.google.cloud.compute.v1.NodeGroup.verify(message.nodeGroupResource);
                                if (error)
                                    return "nodeGroupResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a PatchNodeGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchNodeGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchNodeGroupRequest} PatchNodeGroupRequest
                         */
                        PatchNodeGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchNodeGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchNodeGroupRequest();
                            if (object.nodeGroup != null)
                                message.nodeGroup = String(object.nodeGroup);
                            if (object.nodeGroupResource != null) {
                                if (typeof object.nodeGroupResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchNodeGroupRequest.nodeGroupResource: object expected");
                                message.nodeGroupResource = $root.google.cloud.compute.v1.NodeGroup.fromObject(object.nodeGroupResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchNodeGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchNodeGroupRequest} message PatchNodeGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchNodeGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.nodeGroup = "";
                                object.nodeGroupResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.nodeGroup != null && message.hasOwnProperty("nodeGroup"))
                                object.nodeGroup = message.nodeGroup;
                            if (message.nodeGroupResource != null && message.hasOwnProperty("nodeGroupResource"))
                                object.nodeGroupResource = $root.google.cloud.compute.v1.NodeGroup.toObject(message.nodeGroupResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this PatchNodeGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchNodeGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchNodeGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchNodeGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchNodeGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchNodeGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchNodeGroupRequest";
                        };
    
                        return PatchNodeGroupRequest;
                    })();
    
                    v1.PatchPacketMirroringRequest = (function() {
    
                        /**
                         * Properties of a PatchPacketMirroringRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchPacketMirroringRequest
                         * @property {string|null} [packetMirroring] PatchPacketMirroringRequest packetMirroring
                         * @property {google.cloud.compute.v1.IPacketMirroring|null} [packetMirroringResource] PatchPacketMirroringRequest packetMirroringResource
                         * @property {string|null} [project] PatchPacketMirroringRequest project
                         * @property {string|null} [region] PatchPacketMirroringRequest region
                         * @property {string|null} [requestId] PatchPacketMirroringRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchPacketMirroringRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchPacketMirroringRequest.
                         * @implements IPatchPacketMirroringRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchPacketMirroringRequest=} [properties] Properties to set
                         */
                        function PatchPacketMirroringRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchPacketMirroringRequest packetMirroring.
                         * @member {string} packetMirroring
                         * @memberof google.cloud.compute.v1.PatchPacketMirroringRequest
                         * @instance
                         */
                        PatchPacketMirroringRequest.prototype.packetMirroring = "";
    
                        /**
                         * PatchPacketMirroringRequest packetMirroringResource.
                         * @member {google.cloud.compute.v1.IPacketMirroring|null|undefined} packetMirroringResource
                         * @memberof google.cloud.compute.v1.PatchPacketMirroringRequest
                         * @instance
                         */
                        PatchPacketMirroringRequest.prototype.packetMirroringResource = null;
    
                        /**
                         * PatchPacketMirroringRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchPacketMirroringRequest
                         * @instance
                         */
                        PatchPacketMirroringRequest.prototype.project = "";
    
                        /**
                         * PatchPacketMirroringRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PatchPacketMirroringRequest
                         * @instance
                         */
                        PatchPacketMirroringRequest.prototype.region = "";
    
                        /**
                         * PatchPacketMirroringRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchPacketMirroringRequest
                         * @instance
                         */
                        PatchPacketMirroringRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchPacketMirroringRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchPacketMirroringRequest
                         * @instance
                         */
                        Object.defineProperty(PatchPacketMirroringRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchPacketMirroringRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchPacketMirroringRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchPacketMirroringRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchPacketMirroringRequest} PatchPacketMirroringRequest instance
                         */
                        PatchPacketMirroringRequest.create = function create(properties) {
                            return new PatchPacketMirroringRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchPacketMirroringRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchPacketMirroringRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchPacketMirroringRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchPacketMirroringRequest} message PatchPacketMirroringRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchPacketMirroringRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.packetMirroring != null && Object.hasOwnProperty.call(message, "packetMirroring"))
                                writer.uint32(/* id 22305996, wireType 2 =*/178447970).string(message.packetMirroring);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.packetMirroringResource != null && Object.hasOwnProperty.call(message, "packetMirroringResource"))
                                $root.google.cloud.compute.v1.PacketMirroring.encode(message.packetMirroringResource, writer.uint32(/* id 493501985, wireType 2 =*/3948015882).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchPacketMirroringRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchPacketMirroringRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchPacketMirroringRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchPacketMirroringRequest} message PatchPacketMirroringRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchPacketMirroringRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchPacketMirroringRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchPacketMirroringRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchPacketMirroringRequest} PatchPacketMirroringRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchPacketMirroringRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchPacketMirroringRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 22305996: {
                                        message.packetMirroring = reader.string();
                                        break;
                                    }
                                case 493501985: {
                                        message.packetMirroringResource = $root.google.cloud.compute.v1.PacketMirroring.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchPacketMirroringRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchPacketMirroringRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchPacketMirroringRequest} PatchPacketMirroringRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchPacketMirroringRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchPacketMirroringRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchPacketMirroringRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchPacketMirroringRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.packetMirroring != null && message.hasOwnProperty("packetMirroring"))
                                if (!$util.isString(message.packetMirroring))
                                    return "packetMirroring: string expected";
                            if (message.packetMirroringResource != null && message.hasOwnProperty("packetMirroringResource")) {
                                var error = $root.google.cloud.compute.v1.PacketMirroring.verify(message.packetMirroringResource);
                                if (error)
                                    return "packetMirroringResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchPacketMirroringRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchPacketMirroringRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchPacketMirroringRequest} PatchPacketMirroringRequest
                         */
                        PatchPacketMirroringRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchPacketMirroringRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchPacketMirroringRequest();
                            if (object.packetMirroring != null)
                                message.packetMirroring = String(object.packetMirroring);
                            if (object.packetMirroringResource != null) {
                                if (typeof object.packetMirroringResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchPacketMirroringRequest.packetMirroringResource: object expected");
                                message.packetMirroringResource = $root.google.cloud.compute.v1.PacketMirroring.fromObject(object.packetMirroringResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchPacketMirroringRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchPacketMirroringRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchPacketMirroringRequest} message PatchPacketMirroringRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchPacketMirroringRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.packetMirroring = "";
                                object.region = "";
                                object.project = "";
                                object.packetMirroringResource = null;
                            }
                            if (message.packetMirroring != null && message.hasOwnProperty("packetMirroring"))
                                object.packetMirroring = message.packetMirroring;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.packetMirroringResource != null && message.hasOwnProperty("packetMirroringResource"))
                                object.packetMirroringResource = $root.google.cloud.compute.v1.PacketMirroring.toObject(message.packetMirroringResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this PatchPacketMirroringRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchPacketMirroringRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchPacketMirroringRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchPacketMirroringRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchPacketMirroringRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchPacketMirroringRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchPacketMirroringRequest";
                        };
    
                        return PatchPacketMirroringRequest;
                    })();
    
                    v1.PatchPerInstanceConfigsInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a PatchPerInstanceConfigsInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] PatchPerInstanceConfigsInstanceGroupManagerRequest instanceGroupManager
                         * @property {google.cloud.compute.v1.IInstanceGroupManagersPatchPerInstanceConfigsReq|null} [instanceGroupManagersPatchPerInstanceConfigsReqResource] PatchPerInstanceConfigsInstanceGroupManagerRequest instanceGroupManagersPatchPerInstanceConfigsReqResource
                         * @property {string|null} [project] PatchPerInstanceConfigsInstanceGroupManagerRequest project
                         * @property {string|null} [requestId] PatchPerInstanceConfigsInstanceGroupManagerRequest requestId
                         * @property {string|null} [zone] PatchPerInstanceConfigsInstanceGroupManagerRequest zone
                         */
    
                        /**
                         * Constructs a new PatchPerInstanceConfigsInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchPerInstanceConfigsInstanceGroupManagerRequest.
                         * @implements IPatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchPerInstanceConfigsInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function PatchPerInstanceConfigsInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchPerInstanceConfigsInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @instance
                         */
                        PatchPerInstanceConfigsInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * PatchPerInstanceConfigsInstanceGroupManagerRequest instanceGroupManagersPatchPerInstanceConfigsReqResource.
                         * @member {google.cloud.compute.v1.IInstanceGroupManagersPatchPerInstanceConfigsReq|null|undefined} instanceGroupManagersPatchPerInstanceConfigsReqResource
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @instance
                         */
                        PatchPerInstanceConfigsInstanceGroupManagerRequest.prototype.instanceGroupManagersPatchPerInstanceConfigsReqResource = null;
    
                        /**
                         * PatchPerInstanceConfigsInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @instance
                         */
                        PatchPerInstanceConfigsInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * PatchPerInstanceConfigsInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @instance
                         */
                        PatchPerInstanceConfigsInstanceGroupManagerRequest.prototype.requestId = null;
    
                        /**
                         * PatchPerInstanceConfigsInstanceGroupManagerRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @instance
                         */
                        PatchPerInstanceConfigsInstanceGroupManagerRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchPerInstanceConfigsInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(PatchPerInstanceConfigsInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchPerInstanceConfigsInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchPerInstanceConfigsInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest} PatchPerInstanceConfigsInstanceGroupManagerRequest instance
                         */
                        PatchPerInstanceConfigsInstanceGroupManagerRequest.create = function create(properties) {
                            return new PatchPerInstanceConfigsInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchPerInstanceConfigsInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchPerInstanceConfigsInstanceGroupManagerRequest} message PatchPerInstanceConfigsInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchPerInstanceConfigsInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            if (message.instanceGroupManagersPatchPerInstanceConfigsReqResource != null && Object.hasOwnProperty.call(message, "instanceGroupManagersPatchPerInstanceConfigsReqResource"))
                                $root.google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq.encode(message.instanceGroupManagersPatchPerInstanceConfigsReqResource, writer.uint32(/* id 356650495, wireType 2 =*/2853203962).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchPerInstanceConfigsInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchPerInstanceConfigsInstanceGroupManagerRequest} message PatchPerInstanceConfigsInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchPerInstanceConfigsInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchPerInstanceConfigsInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest} PatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchPerInstanceConfigsInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 356650495: {
                                        message.instanceGroupManagersPatchPerInstanceConfigsReqResource = $root.google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchPerInstanceConfigsInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest} PatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchPerInstanceConfigsInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchPerInstanceConfigsInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchPerInstanceConfigsInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.instanceGroupManagersPatchPerInstanceConfigsReqResource != null && message.hasOwnProperty("instanceGroupManagersPatchPerInstanceConfigsReqResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq.verify(message.instanceGroupManagersPatchPerInstanceConfigsReqResource);
                                if (error)
                                    return "instanceGroupManagersPatchPerInstanceConfigsReqResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a PatchPerInstanceConfigsInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest} PatchPerInstanceConfigsInstanceGroupManagerRequest
                         */
                        PatchPerInstanceConfigsInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.instanceGroupManagersPatchPerInstanceConfigsReqResource != null) {
                                if (typeof object.instanceGroupManagersPatchPerInstanceConfigsReqResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest.instanceGroupManagersPatchPerInstanceConfigsReqResource: object expected");
                                message.instanceGroupManagersPatchPerInstanceConfigsReqResource = $root.google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq.fromObject(object.instanceGroupManagersPatchPerInstanceConfigsReqResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchPerInstanceConfigsInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest} message PatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchPerInstanceConfigsInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                                object.instanceGroupManagersPatchPerInstanceConfigsReqResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            if (message.instanceGroupManagersPatchPerInstanceConfigsReqResource != null && message.hasOwnProperty("instanceGroupManagersPatchPerInstanceConfigsReqResource"))
                                object.instanceGroupManagersPatchPerInstanceConfigsReqResource = $root.google.cloud.compute.v1.InstanceGroupManagersPatchPerInstanceConfigsReq.toObject(message.instanceGroupManagersPatchPerInstanceConfigsReqResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this PatchPerInstanceConfigsInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchPerInstanceConfigsInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchPerInstanceConfigsInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest";
                        };
    
                        return PatchPerInstanceConfigsInstanceGroupManagerRequest;
                    })();
    
                    v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] PatchPerInstanceConfigsRegionInstanceGroupManagerRequest instanceGroupManager
                         * @property {string|null} [project] PatchPerInstanceConfigsRegionInstanceGroupManagerRequest project
                         * @property {string|null} [region] PatchPerInstanceConfigsRegionInstanceGroupManagerRequest region
                         * @property {google.cloud.compute.v1.IRegionInstanceGroupManagerPatchInstanceConfigReq|null} [regionInstanceGroupManagerPatchInstanceConfigReqResource] PatchPerInstanceConfigsRegionInstanceGroupManagerRequest regionInstanceGroupManagerPatchInstanceConfigReqResource
                         * @property {string|null} [requestId] PatchPerInstanceConfigsRegionInstanceGroupManagerRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.
                         * @implements IPatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchPerInstanceConfigsRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function PatchPerInstanceConfigsRegionInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchPerInstanceConfigsRegionInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * PatchPerInstanceConfigsRegionInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * PatchPerInstanceConfigsRegionInstanceGroupManagerRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.prototype.region = "";
    
                        /**
                         * PatchPerInstanceConfigsRegionInstanceGroupManagerRequest regionInstanceGroupManagerPatchInstanceConfigReqResource.
                         * @member {google.cloud.compute.v1.IRegionInstanceGroupManagerPatchInstanceConfigReq|null|undefined} regionInstanceGroupManagerPatchInstanceConfigReqResource
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.prototype.regionInstanceGroupManagerPatchInstanceConfigReqResource = null;
    
                        /**
                         * PatchPerInstanceConfigsRegionInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchPerInstanceConfigsRegionInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchPerInstanceConfigsRegionInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchPerInstanceConfigsRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest} PatchPerInstanceConfigsRegionInstanceGroupManagerRequest instance
                         */
                        PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.create = function create(properties) {
                            return new PatchPerInstanceConfigsRegionInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchPerInstanceConfigsRegionInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchPerInstanceConfigsRegionInstanceGroupManagerRequest} message PatchPerInstanceConfigsRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.regionInstanceGroupManagerPatchInstanceConfigReqResource != null && Object.hasOwnProperty.call(message, "regionInstanceGroupManagerPatchInstanceConfigReqResource"))
                                $root.google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq.encode(message.regionInstanceGroupManagerPatchInstanceConfigReqResource, writer.uint32(/* id 197682890, wireType 2 =*/1581463122).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchPerInstanceConfigsRegionInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchPerInstanceConfigsRegionInstanceGroupManagerRequest} message PatchPerInstanceConfigsRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchPerInstanceConfigsRegionInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest} PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 197682890: {
                                        message.regionInstanceGroupManagerPatchInstanceConfigReqResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchPerInstanceConfigsRegionInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest} PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchPerInstanceConfigsRegionInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionInstanceGroupManagerPatchInstanceConfigReqResource != null && message.hasOwnProperty("regionInstanceGroupManagerPatchInstanceConfigReqResource")) {
                                var error = $root.google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq.verify(message.regionInstanceGroupManagerPatchInstanceConfigReqResource);
                                if (error)
                                    return "regionInstanceGroupManagerPatchInstanceConfigReqResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchPerInstanceConfigsRegionInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest} PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         */
                        PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionInstanceGroupManagerPatchInstanceConfigReqResource != null) {
                                if (typeof object.regionInstanceGroupManagerPatchInstanceConfigReqResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.regionInstanceGroupManagerPatchInstanceConfigReqResource: object expected");
                                message.regionInstanceGroupManagerPatchInstanceConfigReqResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq.fromObject(object.regionInstanceGroupManagerPatchInstanceConfigReqResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchPerInstanceConfigsRegionInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest} message PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.regionInstanceGroupManagerPatchInstanceConfigReqResource = null;
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.regionInstanceGroupManagerPatchInstanceConfigReqResource != null && message.hasOwnProperty("regionInstanceGroupManagerPatchInstanceConfigReqResource"))
                                object.regionInstanceGroupManagerPatchInstanceConfigReqResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq.toObject(message.regionInstanceGroupManagerPatchInstanceConfigReqResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            return object;
                        };
    
                        /**
                         * Converts this PatchPerInstanceConfigsRegionInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchPerInstanceConfigsRegionInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest";
                        };
    
                        return PatchPerInstanceConfigsRegionInstanceGroupManagerRequest;
                    })();
    
                    v1.PatchPublicAdvertisedPrefixeRequest = (function() {
    
                        /**
                         * Properties of a PatchPublicAdvertisedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchPublicAdvertisedPrefixeRequest
                         * @property {string|null} [project] PatchPublicAdvertisedPrefixeRequest project
                         * @property {string|null} [publicAdvertisedPrefix] PatchPublicAdvertisedPrefixeRequest publicAdvertisedPrefix
                         * @property {google.cloud.compute.v1.IPublicAdvertisedPrefix|null} [publicAdvertisedPrefixResource] PatchPublicAdvertisedPrefixeRequest publicAdvertisedPrefixResource
                         * @property {string|null} [requestId] PatchPublicAdvertisedPrefixeRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchPublicAdvertisedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchPublicAdvertisedPrefixeRequest.
                         * @implements IPatchPublicAdvertisedPrefixeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchPublicAdvertisedPrefixeRequest=} [properties] Properties to set
                         */
                        function PatchPublicAdvertisedPrefixeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchPublicAdvertisedPrefixeRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest
                         * @instance
                         */
                        PatchPublicAdvertisedPrefixeRequest.prototype.project = "";
    
                        /**
                         * PatchPublicAdvertisedPrefixeRequest publicAdvertisedPrefix.
                         * @member {string} publicAdvertisedPrefix
                         * @memberof google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest
                         * @instance
                         */
                        PatchPublicAdvertisedPrefixeRequest.prototype.publicAdvertisedPrefix = "";
    
                        /**
                         * PatchPublicAdvertisedPrefixeRequest publicAdvertisedPrefixResource.
                         * @member {google.cloud.compute.v1.IPublicAdvertisedPrefix|null|undefined} publicAdvertisedPrefixResource
                         * @memberof google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest
                         * @instance
                         */
                        PatchPublicAdvertisedPrefixeRequest.prototype.publicAdvertisedPrefixResource = null;
    
                        /**
                         * PatchPublicAdvertisedPrefixeRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest
                         * @instance
                         */
                        PatchPublicAdvertisedPrefixeRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchPublicAdvertisedPrefixeRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest
                         * @instance
                         */
                        Object.defineProperty(PatchPublicAdvertisedPrefixeRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchPublicAdvertisedPrefixeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchPublicAdvertisedPrefixeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest} PatchPublicAdvertisedPrefixeRequest instance
                         */
                        PatchPublicAdvertisedPrefixeRequest.create = function create(properties) {
                            return new PatchPublicAdvertisedPrefixeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchPublicAdvertisedPrefixeRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchPublicAdvertisedPrefixeRequest} message PatchPublicAdvertisedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchPublicAdvertisedPrefixeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.publicAdvertisedPrefix != null && Object.hasOwnProperty.call(message, "publicAdvertisedPrefix"))
                                writer.uint32(/* id 101874590, wireType 2 =*/814996722).string(message.publicAdvertisedPrefix);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.publicAdvertisedPrefixResource != null && Object.hasOwnProperty.call(message, "publicAdvertisedPrefixResource"))
                                $root.google.cloud.compute.v1.PublicAdvertisedPrefix.encode(message.publicAdvertisedPrefixResource, writer.uint32(/* id 233614223, wireType 2 =*/1868913786).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchPublicAdvertisedPrefixeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchPublicAdvertisedPrefixeRequest} message PatchPublicAdvertisedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchPublicAdvertisedPrefixeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchPublicAdvertisedPrefixeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest} PatchPublicAdvertisedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchPublicAdvertisedPrefixeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 101874590: {
                                        message.publicAdvertisedPrefix = reader.string();
                                        break;
                                    }
                                case 233614223: {
                                        message.publicAdvertisedPrefixResource = $root.google.cloud.compute.v1.PublicAdvertisedPrefix.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchPublicAdvertisedPrefixeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest} PatchPublicAdvertisedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchPublicAdvertisedPrefixeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchPublicAdvertisedPrefixeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchPublicAdvertisedPrefixeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.publicAdvertisedPrefix != null && message.hasOwnProperty("publicAdvertisedPrefix"))
                                if (!$util.isString(message.publicAdvertisedPrefix))
                                    return "publicAdvertisedPrefix: string expected";
                            if (message.publicAdvertisedPrefixResource != null && message.hasOwnProperty("publicAdvertisedPrefixResource")) {
                                var error = $root.google.cloud.compute.v1.PublicAdvertisedPrefix.verify(message.publicAdvertisedPrefixResource);
                                if (error)
                                    return "publicAdvertisedPrefixResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchPublicAdvertisedPrefixeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest} PatchPublicAdvertisedPrefixeRequest
                         */
                        PatchPublicAdvertisedPrefixeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.publicAdvertisedPrefix != null)
                                message.publicAdvertisedPrefix = String(object.publicAdvertisedPrefix);
                            if (object.publicAdvertisedPrefixResource != null) {
                                if (typeof object.publicAdvertisedPrefixResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest.publicAdvertisedPrefixResource: object expected");
                                message.publicAdvertisedPrefixResource = $root.google.cloud.compute.v1.PublicAdvertisedPrefix.fromObject(object.publicAdvertisedPrefixResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchPublicAdvertisedPrefixeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest} message PatchPublicAdvertisedPrefixeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchPublicAdvertisedPrefixeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.publicAdvertisedPrefix = "";
                                object.project = "";
                                object.publicAdvertisedPrefixResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.publicAdvertisedPrefix != null && message.hasOwnProperty("publicAdvertisedPrefix"))
                                object.publicAdvertisedPrefix = message.publicAdvertisedPrefix;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.publicAdvertisedPrefixResource != null && message.hasOwnProperty("publicAdvertisedPrefixResource"))
                                object.publicAdvertisedPrefixResource = $root.google.cloud.compute.v1.PublicAdvertisedPrefix.toObject(message.publicAdvertisedPrefixResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this PatchPublicAdvertisedPrefixeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchPublicAdvertisedPrefixeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchPublicAdvertisedPrefixeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchPublicAdvertisedPrefixeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest";
                        };
    
                        return PatchPublicAdvertisedPrefixeRequest;
                    })();
    
                    v1.PatchPublicDelegatedPrefixeRequest = (function() {
    
                        /**
                         * Properties of a PatchPublicDelegatedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchPublicDelegatedPrefixeRequest
                         * @property {string|null} [project] PatchPublicDelegatedPrefixeRequest project
                         * @property {string|null} [publicDelegatedPrefix] PatchPublicDelegatedPrefixeRequest publicDelegatedPrefix
                         * @property {google.cloud.compute.v1.IPublicDelegatedPrefix|null} [publicDelegatedPrefixResource] PatchPublicDelegatedPrefixeRequest publicDelegatedPrefixResource
                         * @property {string|null} [region] PatchPublicDelegatedPrefixeRequest region
                         * @property {string|null} [requestId] PatchPublicDelegatedPrefixeRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchPublicDelegatedPrefixeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchPublicDelegatedPrefixeRequest.
                         * @implements IPatchPublicDelegatedPrefixeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchPublicDelegatedPrefixeRequest=} [properties] Properties to set
                         */
                        function PatchPublicDelegatedPrefixeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchPublicDelegatedPrefixeRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        PatchPublicDelegatedPrefixeRequest.prototype.project = "";
    
                        /**
                         * PatchPublicDelegatedPrefixeRequest publicDelegatedPrefix.
                         * @member {string} publicDelegatedPrefix
                         * @memberof google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        PatchPublicDelegatedPrefixeRequest.prototype.publicDelegatedPrefix = "";
    
                        /**
                         * PatchPublicDelegatedPrefixeRequest publicDelegatedPrefixResource.
                         * @member {google.cloud.compute.v1.IPublicDelegatedPrefix|null|undefined} publicDelegatedPrefixResource
                         * @memberof google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        PatchPublicDelegatedPrefixeRequest.prototype.publicDelegatedPrefixResource = null;
    
                        /**
                         * PatchPublicDelegatedPrefixeRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        PatchPublicDelegatedPrefixeRequest.prototype.region = "";
    
                        /**
                         * PatchPublicDelegatedPrefixeRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        PatchPublicDelegatedPrefixeRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchPublicDelegatedPrefixeRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest
                         * @instance
                         */
                        Object.defineProperty(PatchPublicDelegatedPrefixeRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchPublicDelegatedPrefixeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchPublicDelegatedPrefixeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest} PatchPublicDelegatedPrefixeRequest instance
                         */
                        PatchPublicDelegatedPrefixeRequest.create = function create(properties) {
                            return new PatchPublicDelegatedPrefixeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchPublicDelegatedPrefixeRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchPublicDelegatedPrefixeRequest} message PatchPublicDelegatedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchPublicDelegatedPrefixeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.publicDelegatedPrefixResource != null && Object.hasOwnProperty.call(message, "publicDelegatedPrefixResource"))
                                $root.google.cloud.compute.v1.PublicDelegatedPrefix.encode(message.publicDelegatedPrefixResource, writer.uint32(/* id 47594501, wireType 2 =*/380756010).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.publicDelegatedPrefix != null && Object.hasOwnProperty.call(message, "publicDelegatedPrefix"))
                                writer.uint32(/* id 204238440, wireType 2 =*/1633907522).string(message.publicDelegatedPrefix);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchPublicDelegatedPrefixeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchPublicDelegatedPrefixeRequest} message PatchPublicDelegatedPrefixeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchPublicDelegatedPrefixeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchPublicDelegatedPrefixeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest} PatchPublicDelegatedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchPublicDelegatedPrefixeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 204238440: {
                                        message.publicDelegatedPrefix = reader.string();
                                        break;
                                    }
                                case 47594501: {
                                        message.publicDelegatedPrefixResource = $root.google.cloud.compute.v1.PublicDelegatedPrefix.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchPublicDelegatedPrefixeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest} PatchPublicDelegatedPrefixeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchPublicDelegatedPrefixeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchPublicDelegatedPrefixeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchPublicDelegatedPrefixeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.publicDelegatedPrefix != null && message.hasOwnProperty("publicDelegatedPrefix"))
                                if (!$util.isString(message.publicDelegatedPrefix))
                                    return "publicDelegatedPrefix: string expected";
                            if (message.publicDelegatedPrefixResource != null && message.hasOwnProperty("publicDelegatedPrefixResource")) {
                                var error = $root.google.cloud.compute.v1.PublicDelegatedPrefix.verify(message.publicDelegatedPrefixResource);
                                if (error)
                                    return "publicDelegatedPrefixResource." + error;
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchPublicDelegatedPrefixeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest} PatchPublicDelegatedPrefixeRequest
                         */
                        PatchPublicDelegatedPrefixeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.publicDelegatedPrefix != null)
                                message.publicDelegatedPrefix = String(object.publicDelegatedPrefix);
                            if (object.publicDelegatedPrefixResource != null) {
                                if (typeof object.publicDelegatedPrefixResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest.publicDelegatedPrefixResource: object expected");
                                message.publicDelegatedPrefixResource = $root.google.cloud.compute.v1.PublicDelegatedPrefix.fromObject(object.publicDelegatedPrefixResource);
                            }
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchPublicDelegatedPrefixeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest} message PatchPublicDelegatedPrefixeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchPublicDelegatedPrefixeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.publicDelegatedPrefixResource = null;
                                object.region = "";
                                object.publicDelegatedPrefix = "";
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.publicDelegatedPrefixResource != null && message.hasOwnProperty("publicDelegatedPrefixResource"))
                                object.publicDelegatedPrefixResource = $root.google.cloud.compute.v1.PublicDelegatedPrefix.toObject(message.publicDelegatedPrefixResource, options);
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.publicDelegatedPrefix != null && message.hasOwnProperty("publicDelegatedPrefix"))
                                object.publicDelegatedPrefix = message.publicDelegatedPrefix;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this PatchPublicDelegatedPrefixeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchPublicDelegatedPrefixeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchPublicDelegatedPrefixeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchPublicDelegatedPrefixeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest";
                        };
    
                        return PatchPublicDelegatedPrefixeRequest;
                    })();
    
                    v1.PatchRegionAutoscalerRequest = (function() {
    
                        /**
                         * Properties of a PatchRegionAutoscalerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchRegionAutoscalerRequest
                         * @property {string|null} [autoscaler] PatchRegionAutoscalerRequest autoscaler
                         * @property {google.cloud.compute.v1.IAutoscaler|null} [autoscalerResource] PatchRegionAutoscalerRequest autoscalerResource
                         * @property {string|null} [project] PatchRegionAutoscalerRequest project
                         * @property {string|null} [region] PatchRegionAutoscalerRequest region
                         * @property {string|null} [requestId] PatchRegionAutoscalerRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchRegionAutoscalerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchRegionAutoscalerRequest.
                         * @implements IPatchRegionAutoscalerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchRegionAutoscalerRequest=} [properties] Properties to set
                         */
                        function PatchRegionAutoscalerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchRegionAutoscalerRequest autoscaler.
                         * @member {string|null|undefined} autoscaler
                         * @memberof google.cloud.compute.v1.PatchRegionAutoscalerRequest
                         * @instance
                         */
                        PatchRegionAutoscalerRequest.prototype.autoscaler = null;
    
                        /**
                         * PatchRegionAutoscalerRequest autoscalerResource.
                         * @member {google.cloud.compute.v1.IAutoscaler|null|undefined} autoscalerResource
                         * @memberof google.cloud.compute.v1.PatchRegionAutoscalerRequest
                         * @instance
                         */
                        PatchRegionAutoscalerRequest.prototype.autoscalerResource = null;
    
                        /**
                         * PatchRegionAutoscalerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchRegionAutoscalerRequest
                         * @instance
                         */
                        PatchRegionAutoscalerRequest.prototype.project = "";
    
                        /**
                         * PatchRegionAutoscalerRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PatchRegionAutoscalerRequest
                         * @instance
                         */
                        PatchRegionAutoscalerRequest.prototype.region = "";
    
                        /**
                         * PatchRegionAutoscalerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchRegionAutoscalerRequest
                         * @instance
                         */
                        PatchRegionAutoscalerRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchRegionAutoscalerRequest _autoscaler.
                         * @member {"autoscaler"|undefined} _autoscaler
                         * @memberof google.cloud.compute.v1.PatchRegionAutoscalerRequest
                         * @instance
                         */
                        Object.defineProperty(PatchRegionAutoscalerRequest.prototype, "_autoscaler", {
                            get: $util.oneOfGetter($oneOfFields = ["autoscaler"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PatchRegionAutoscalerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchRegionAutoscalerRequest
                         * @instance
                         */
                        Object.defineProperty(PatchRegionAutoscalerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchRegionAutoscalerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchRegionAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionAutoscalerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchRegionAutoscalerRequest} PatchRegionAutoscalerRequest instance
                         */
                        PatchRegionAutoscalerRequest.create = function create(properties) {
                            return new PatchRegionAutoscalerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchRegionAutoscalerRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchRegionAutoscalerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchRegionAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionAutoscalerRequest} message PatchRegionAutoscalerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRegionAutoscalerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.autoscalerResource != null && Object.hasOwnProperty.call(message, "autoscalerResource"))
                                $root.google.cloud.compute.v1.Autoscaler.encode(message.autoscalerResource, writer.uint32(/* id 207616118, wireType 2 =*/1660928946).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.autoscaler != null && Object.hasOwnProperty.call(message, "autoscaler"))
                                writer.uint32(/* id 517258967, wireType 2 =*/4138071738).string(message.autoscaler);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchRegionAutoscalerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchRegionAutoscalerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRegionAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionAutoscalerRequest} message PatchRegionAutoscalerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRegionAutoscalerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchRegionAutoscalerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchRegionAutoscalerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchRegionAutoscalerRequest} PatchRegionAutoscalerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRegionAutoscalerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchRegionAutoscalerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 517258967: {
                                        message.autoscaler = reader.string();
                                        break;
                                    }
                                case 207616118: {
                                        message.autoscalerResource = $root.google.cloud.compute.v1.Autoscaler.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchRegionAutoscalerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRegionAutoscalerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchRegionAutoscalerRequest} PatchRegionAutoscalerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRegionAutoscalerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchRegionAutoscalerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchRegionAutoscalerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchRegionAutoscalerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoscaler != null && message.hasOwnProperty("autoscaler")) {
                                properties._autoscaler = 1;
                                if (!$util.isString(message.autoscaler))
                                    return "autoscaler: string expected";
                            }
                            if (message.autoscalerResource != null && message.hasOwnProperty("autoscalerResource")) {
                                var error = $root.google.cloud.compute.v1.Autoscaler.verify(message.autoscalerResource);
                                if (error)
                                    return "autoscalerResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchRegionAutoscalerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchRegionAutoscalerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchRegionAutoscalerRequest} PatchRegionAutoscalerRequest
                         */
                        PatchRegionAutoscalerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchRegionAutoscalerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchRegionAutoscalerRequest();
                            if (object.autoscaler != null)
                                message.autoscaler = String(object.autoscaler);
                            if (object.autoscalerResource != null) {
                                if (typeof object.autoscalerResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchRegionAutoscalerRequest.autoscalerResource: object expected");
                                message.autoscalerResource = $root.google.cloud.compute.v1.Autoscaler.fromObject(object.autoscalerResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchRegionAutoscalerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchRegionAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchRegionAutoscalerRequest} message PatchRegionAutoscalerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchRegionAutoscalerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.autoscalerResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.autoscalerResource != null && message.hasOwnProperty("autoscalerResource"))
                                object.autoscalerResource = $root.google.cloud.compute.v1.Autoscaler.toObject(message.autoscalerResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.autoscaler != null && message.hasOwnProperty("autoscaler")) {
                                object.autoscaler = message.autoscaler;
                                if (options.oneofs)
                                    object._autoscaler = "autoscaler";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PatchRegionAutoscalerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchRegionAutoscalerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchRegionAutoscalerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchRegionAutoscalerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchRegionAutoscalerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchRegionAutoscalerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchRegionAutoscalerRequest";
                        };
    
                        return PatchRegionAutoscalerRequest;
                    })();
    
                    v1.PatchRegionBackendServiceRequest = (function() {
    
                        /**
                         * Properties of a PatchRegionBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchRegionBackendServiceRequest
                         * @property {string|null} [backendService] PatchRegionBackendServiceRequest backendService
                         * @property {google.cloud.compute.v1.IBackendService|null} [backendServiceResource] PatchRegionBackendServiceRequest backendServiceResource
                         * @property {string|null} [project] PatchRegionBackendServiceRequest project
                         * @property {string|null} [region] PatchRegionBackendServiceRequest region
                         * @property {string|null} [requestId] PatchRegionBackendServiceRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchRegionBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchRegionBackendServiceRequest.
                         * @implements IPatchRegionBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchRegionBackendServiceRequest=} [properties] Properties to set
                         */
                        function PatchRegionBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchRegionBackendServiceRequest backendService.
                         * @member {string} backendService
                         * @memberof google.cloud.compute.v1.PatchRegionBackendServiceRequest
                         * @instance
                         */
                        PatchRegionBackendServiceRequest.prototype.backendService = "";
    
                        /**
                         * PatchRegionBackendServiceRequest backendServiceResource.
                         * @member {google.cloud.compute.v1.IBackendService|null|undefined} backendServiceResource
                         * @memberof google.cloud.compute.v1.PatchRegionBackendServiceRequest
                         * @instance
                         */
                        PatchRegionBackendServiceRequest.prototype.backendServiceResource = null;
    
                        /**
                         * PatchRegionBackendServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchRegionBackendServiceRequest
                         * @instance
                         */
                        PatchRegionBackendServiceRequest.prototype.project = "";
    
                        /**
                         * PatchRegionBackendServiceRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PatchRegionBackendServiceRequest
                         * @instance
                         */
                        PatchRegionBackendServiceRequest.prototype.region = "";
    
                        /**
                         * PatchRegionBackendServiceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchRegionBackendServiceRequest
                         * @instance
                         */
                        PatchRegionBackendServiceRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchRegionBackendServiceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchRegionBackendServiceRequest
                         * @instance
                         */
                        Object.defineProperty(PatchRegionBackendServiceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchRegionBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchRegionBackendServiceRequest} PatchRegionBackendServiceRequest instance
                         */
                        PatchRegionBackendServiceRequest.create = function create(properties) {
                            return new PatchRegionBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchRegionBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchRegionBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionBackendServiceRequest} message PatchRegionBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRegionBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.backendService != null && Object.hasOwnProperty.call(message, "backendService"))
                                writer.uint32(/* id 306946058, wireType 2 =*/2455568466).string(message.backendService);
                            if (message.backendServiceResource != null && Object.hasOwnProperty.call(message, "backendServiceResource"))
                                $root.google.cloud.compute.v1.BackendService.encode(message.backendServiceResource, writer.uint32(/* id 347586723, wireType 2 =*/2780693786).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchRegionBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchRegionBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionBackendServiceRequest} message PatchRegionBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRegionBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchRegionBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchRegionBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchRegionBackendServiceRequest} PatchRegionBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRegionBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchRegionBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 306946058: {
                                        message.backendService = reader.string();
                                        break;
                                    }
                                case 347586723: {
                                        message.backendServiceResource = $root.google.cloud.compute.v1.BackendService.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchRegionBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRegionBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchRegionBackendServiceRequest} PatchRegionBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRegionBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchRegionBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchRegionBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchRegionBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                if (!$util.isString(message.backendService))
                                    return "backendService: string expected";
                            if (message.backendServiceResource != null && message.hasOwnProperty("backendServiceResource")) {
                                var error = $root.google.cloud.compute.v1.BackendService.verify(message.backendServiceResource);
                                if (error)
                                    return "backendServiceResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchRegionBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchRegionBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchRegionBackendServiceRequest} PatchRegionBackendServiceRequest
                         */
                        PatchRegionBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchRegionBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchRegionBackendServiceRequest();
                            if (object.backendService != null)
                                message.backendService = String(object.backendService);
                            if (object.backendServiceResource != null) {
                                if (typeof object.backendServiceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchRegionBackendServiceRequest.backendServiceResource: object expected");
                                message.backendServiceResource = $root.google.cloud.compute.v1.BackendService.fromObject(object.backendServiceResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchRegionBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchRegionBackendServiceRequest} message PatchRegionBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchRegionBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.backendService = "";
                                object.backendServiceResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                object.backendService = message.backendService;
                            if (message.backendServiceResource != null && message.hasOwnProperty("backendServiceResource"))
                                object.backendServiceResource = $root.google.cloud.compute.v1.BackendService.toObject(message.backendServiceResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this PatchRegionBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchRegionBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchRegionBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchRegionBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchRegionBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchRegionBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchRegionBackendServiceRequest";
                        };
    
                        return PatchRegionBackendServiceRequest;
                    })();
    
                    v1.PatchRegionHealthCheckRequest = (function() {
    
                        /**
                         * Properties of a PatchRegionHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchRegionHealthCheckRequest
                         * @property {string|null} [healthCheck] PatchRegionHealthCheckRequest healthCheck
                         * @property {google.cloud.compute.v1.IHealthCheck|null} [healthCheckResource] PatchRegionHealthCheckRequest healthCheckResource
                         * @property {string|null} [project] PatchRegionHealthCheckRequest project
                         * @property {string|null} [region] PatchRegionHealthCheckRequest region
                         * @property {string|null} [requestId] PatchRegionHealthCheckRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchRegionHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchRegionHealthCheckRequest.
                         * @implements IPatchRegionHealthCheckRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchRegionHealthCheckRequest=} [properties] Properties to set
                         */
                        function PatchRegionHealthCheckRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchRegionHealthCheckRequest healthCheck.
                         * @member {string} healthCheck
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckRequest
                         * @instance
                         */
                        PatchRegionHealthCheckRequest.prototype.healthCheck = "";
    
                        /**
                         * PatchRegionHealthCheckRequest healthCheckResource.
                         * @member {google.cloud.compute.v1.IHealthCheck|null|undefined} healthCheckResource
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckRequest
                         * @instance
                         */
                        PatchRegionHealthCheckRequest.prototype.healthCheckResource = null;
    
                        /**
                         * PatchRegionHealthCheckRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckRequest
                         * @instance
                         */
                        PatchRegionHealthCheckRequest.prototype.project = "";
    
                        /**
                         * PatchRegionHealthCheckRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckRequest
                         * @instance
                         */
                        PatchRegionHealthCheckRequest.prototype.region = "";
    
                        /**
                         * PatchRegionHealthCheckRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckRequest
                         * @instance
                         */
                        PatchRegionHealthCheckRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchRegionHealthCheckRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckRequest
                         * @instance
                         */
                        Object.defineProperty(PatchRegionHealthCheckRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchRegionHealthCheckRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionHealthCheckRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchRegionHealthCheckRequest} PatchRegionHealthCheckRequest instance
                         */
                        PatchRegionHealthCheckRequest.create = function create(properties) {
                            return new PatchRegionHealthCheckRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchRegionHealthCheckRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchRegionHealthCheckRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionHealthCheckRequest} message PatchRegionHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRegionHealthCheckRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.healthCheckResource != null && Object.hasOwnProperty.call(message, "healthCheckResource"))
                                $root.google.cloud.compute.v1.HealthCheck.encode(message.healthCheckResource, writer.uint32(/* id 201925032, wireType 2 =*/1615400258).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.healthCheck != null && Object.hasOwnProperty.call(message, "healthCheck"))
                                writer.uint32(/* id 308876645, wireType 2 =*/2471013162).string(message.healthCheck);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchRegionHealthCheckRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchRegionHealthCheckRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionHealthCheckRequest} message PatchRegionHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRegionHealthCheckRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchRegionHealthCheckRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchRegionHealthCheckRequest} PatchRegionHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRegionHealthCheckRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchRegionHealthCheckRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 308876645: {
                                        message.healthCheck = reader.string();
                                        break;
                                    }
                                case 201925032: {
                                        message.healthCheckResource = $root.google.cloud.compute.v1.HealthCheck.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchRegionHealthCheckRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchRegionHealthCheckRequest} PatchRegionHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRegionHealthCheckRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchRegionHealthCheckRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchRegionHealthCheckRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck"))
                                if (!$util.isString(message.healthCheck))
                                    return "healthCheck: string expected";
                            if (message.healthCheckResource != null && message.hasOwnProperty("healthCheckResource")) {
                                var error = $root.google.cloud.compute.v1.HealthCheck.verify(message.healthCheckResource);
                                if (error)
                                    return "healthCheckResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchRegionHealthCheckRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchRegionHealthCheckRequest} PatchRegionHealthCheckRequest
                         */
                        PatchRegionHealthCheckRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchRegionHealthCheckRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchRegionHealthCheckRequest();
                            if (object.healthCheck != null)
                                message.healthCheck = String(object.healthCheck);
                            if (object.healthCheckResource != null) {
                                if (typeof object.healthCheckResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchRegionHealthCheckRequest.healthCheckResource: object expected");
                                message.healthCheckResource = $root.google.cloud.compute.v1.HealthCheck.fromObject(object.healthCheckResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchRegionHealthCheckRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchRegionHealthCheckRequest} message PatchRegionHealthCheckRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchRegionHealthCheckRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.healthCheckResource = null;
                                object.project = "";
                                object.healthCheck = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.healthCheckResource != null && message.hasOwnProperty("healthCheckResource"))
                                object.healthCheckResource = $root.google.cloud.compute.v1.HealthCheck.toObject(message.healthCheckResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck"))
                                object.healthCheck = message.healthCheck;
                            return object;
                        };
    
                        /**
                         * Converts this PatchRegionHealthCheckRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchRegionHealthCheckRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchRegionHealthCheckRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchRegionHealthCheckRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchRegionHealthCheckRequest";
                        };
    
                        return PatchRegionHealthCheckRequest;
                    })();
    
                    v1.PatchRegionHealthCheckServiceRequest = (function() {
    
                        /**
                         * Properties of a PatchRegionHealthCheckServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchRegionHealthCheckServiceRequest
                         * @property {string|null} [healthCheckService] PatchRegionHealthCheckServiceRequest healthCheckService
                         * @property {google.cloud.compute.v1.IHealthCheckService|null} [healthCheckServiceResource] PatchRegionHealthCheckServiceRequest healthCheckServiceResource
                         * @property {string|null} [project] PatchRegionHealthCheckServiceRequest project
                         * @property {string|null} [region] PatchRegionHealthCheckServiceRequest region
                         * @property {string|null} [requestId] PatchRegionHealthCheckServiceRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchRegionHealthCheckServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchRegionHealthCheckServiceRequest.
                         * @implements IPatchRegionHealthCheckServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchRegionHealthCheckServiceRequest=} [properties] Properties to set
                         */
                        function PatchRegionHealthCheckServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchRegionHealthCheckServiceRequest healthCheckService.
                         * @member {string} healthCheckService
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest
                         * @instance
                         */
                        PatchRegionHealthCheckServiceRequest.prototype.healthCheckService = "";
    
                        /**
                         * PatchRegionHealthCheckServiceRequest healthCheckServiceResource.
                         * @member {google.cloud.compute.v1.IHealthCheckService|null|undefined} healthCheckServiceResource
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest
                         * @instance
                         */
                        PatchRegionHealthCheckServiceRequest.prototype.healthCheckServiceResource = null;
    
                        /**
                         * PatchRegionHealthCheckServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest
                         * @instance
                         */
                        PatchRegionHealthCheckServiceRequest.prototype.project = "";
    
                        /**
                         * PatchRegionHealthCheckServiceRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest
                         * @instance
                         */
                        PatchRegionHealthCheckServiceRequest.prototype.region = "";
    
                        /**
                         * PatchRegionHealthCheckServiceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest
                         * @instance
                         */
                        PatchRegionHealthCheckServiceRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchRegionHealthCheckServiceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest
                         * @instance
                         */
                        Object.defineProperty(PatchRegionHealthCheckServiceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchRegionHealthCheckServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionHealthCheckServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest} PatchRegionHealthCheckServiceRequest instance
                         */
                        PatchRegionHealthCheckServiceRequest.create = function create(properties) {
                            return new PatchRegionHealthCheckServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchRegionHealthCheckServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionHealthCheckServiceRequest} message PatchRegionHealthCheckServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRegionHealthCheckServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.healthCheckService != null && Object.hasOwnProperty.call(message, "healthCheckService"))
                                writer.uint32(/* id 408374747, wireType 2 =*/3266997978).string(message.healthCheckService);
                            if (message.healthCheckServiceResource != null && Object.hasOwnProperty.call(message, "healthCheckServiceResource"))
                                $root.google.cloud.compute.v1.HealthCheckService.encode(message.healthCheckServiceResource, writer.uint32(/* id 477367794, wireType 2 =*/3818942354).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchRegionHealthCheckServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionHealthCheckServiceRequest} message PatchRegionHealthCheckServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRegionHealthCheckServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchRegionHealthCheckServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest} PatchRegionHealthCheckServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRegionHealthCheckServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 408374747: {
                                        message.healthCheckService = reader.string();
                                        break;
                                    }
                                case 477367794: {
                                        message.healthCheckServiceResource = $root.google.cloud.compute.v1.HealthCheckService.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchRegionHealthCheckServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest} PatchRegionHealthCheckServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRegionHealthCheckServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchRegionHealthCheckServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchRegionHealthCheckServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.healthCheckService != null && message.hasOwnProperty("healthCheckService"))
                                if (!$util.isString(message.healthCheckService))
                                    return "healthCheckService: string expected";
                            if (message.healthCheckServiceResource != null && message.hasOwnProperty("healthCheckServiceResource")) {
                                var error = $root.google.cloud.compute.v1.HealthCheckService.verify(message.healthCheckServiceResource);
                                if (error)
                                    return "healthCheckServiceResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchRegionHealthCheckServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest} PatchRegionHealthCheckServiceRequest
                         */
                        PatchRegionHealthCheckServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest();
                            if (object.healthCheckService != null)
                                message.healthCheckService = String(object.healthCheckService);
                            if (object.healthCheckServiceResource != null) {
                                if (typeof object.healthCheckServiceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest.healthCheckServiceResource: object expected");
                                message.healthCheckServiceResource = $root.google.cloud.compute.v1.HealthCheckService.fromObject(object.healthCheckServiceResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchRegionHealthCheckServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest} message PatchRegionHealthCheckServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchRegionHealthCheckServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.healthCheckService = "";
                                object.healthCheckServiceResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.healthCheckService != null && message.hasOwnProperty("healthCheckService"))
                                object.healthCheckService = message.healthCheckService;
                            if (message.healthCheckServiceResource != null && message.hasOwnProperty("healthCheckServiceResource"))
                                object.healthCheckServiceResource = $root.google.cloud.compute.v1.HealthCheckService.toObject(message.healthCheckServiceResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this PatchRegionHealthCheckServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchRegionHealthCheckServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchRegionHealthCheckServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchRegionHealthCheckServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest";
                        };
    
                        return PatchRegionHealthCheckServiceRequest;
                    })();
    
                    v1.PatchRegionInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a PatchRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchRegionInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] PatchRegionInstanceGroupManagerRequest instanceGroupManager
                         * @property {google.cloud.compute.v1.IInstanceGroupManager|null} [instanceGroupManagerResource] PatchRegionInstanceGroupManagerRequest instanceGroupManagerResource
                         * @property {string|null} [project] PatchRegionInstanceGroupManagerRequest project
                         * @property {string|null} [region] PatchRegionInstanceGroupManagerRequest region
                         * @property {string|null} [requestId] PatchRegionInstanceGroupManagerRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchRegionInstanceGroupManagerRequest.
                         * @implements IPatchRegionInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function PatchRegionInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchRegionInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        PatchRegionInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * PatchRegionInstanceGroupManagerRequest instanceGroupManagerResource.
                         * @member {google.cloud.compute.v1.IInstanceGroupManager|null|undefined} instanceGroupManagerResource
                         * @memberof google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        PatchRegionInstanceGroupManagerRequest.prototype.instanceGroupManagerResource = null;
    
                        /**
                         * PatchRegionInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        PatchRegionInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * PatchRegionInstanceGroupManagerRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        PatchRegionInstanceGroupManagerRequest.prototype.region = "";
    
                        /**
                         * PatchRegionInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        PatchRegionInstanceGroupManagerRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchRegionInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(PatchRegionInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchRegionInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest} PatchRegionInstanceGroupManagerRequest instance
                         */
                        PatchRegionInstanceGroupManagerRequest.create = function create(properties) {
                            return new PatchRegionInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchRegionInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionInstanceGroupManagerRequest} message PatchRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRegionInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            if (message.instanceGroupManagerResource != null && Object.hasOwnProperty.call(message, "instanceGroupManagerResource"))
                                $root.google.cloud.compute.v1.InstanceGroupManager.encode(message.instanceGroupManagerResource, writer.uint32(/* id 261063946, wireType 2 =*/2088511570).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchRegionInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionInstanceGroupManagerRequest} message PatchRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRegionInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchRegionInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest} PatchRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRegionInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 261063946: {
                                        message.instanceGroupManagerResource = $root.google.cloud.compute.v1.InstanceGroupManager.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchRegionInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest} PatchRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRegionInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchRegionInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchRegionInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.instanceGroupManagerResource != null && message.hasOwnProperty("instanceGroupManagerResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceGroupManager.verify(message.instanceGroupManagerResource);
                                if (error)
                                    return "instanceGroupManagerResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchRegionInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest} PatchRegionInstanceGroupManagerRequest
                         */
                        PatchRegionInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.instanceGroupManagerResource != null) {
                                if (typeof object.instanceGroupManagerResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest.instanceGroupManagerResource: object expected");
                                message.instanceGroupManagerResource = $root.google.cloud.compute.v1.InstanceGroupManager.fromObject(object.instanceGroupManagerResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchRegionInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest} message PatchRegionInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchRegionInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                                object.instanceGroupManagerResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            if (message.instanceGroupManagerResource != null && message.hasOwnProperty("instanceGroupManagerResource"))
                                object.instanceGroupManagerResource = $root.google.cloud.compute.v1.InstanceGroupManager.toObject(message.instanceGroupManagerResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this PatchRegionInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchRegionInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchRegionInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchRegionInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest";
                        };
    
                        return PatchRegionInstanceGroupManagerRequest;
                    })();
    
                    v1.PatchRegionNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a PatchRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchRegionNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] PatchRegionNetworkFirewallPolicyRequest firewallPolicy
                         * @property {google.cloud.compute.v1.IFirewallPolicy|null} [firewallPolicyResource] PatchRegionNetworkFirewallPolicyRequest firewallPolicyResource
                         * @property {string|null} [project] PatchRegionNetworkFirewallPolicyRequest project
                         * @property {string|null} [region] PatchRegionNetworkFirewallPolicyRequest region
                         * @property {string|null} [requestId] PatchRegionNetworkFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchRegionNetworkFirewallPolicyRequest.
                         * @implements IPatchRegionNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function PatchRegionNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchRegionNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        PatchRegionNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * PatchRegionNetworkFirewallPolicyRequest firewallPolicyResource.
                         * @member {google.cloud.compute.v1.IFirewallPolicy|null|undefined} firewallPolicyResource
                         * @memberof google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        PatchRegionNetworkFirewallPolicyRequest.prototype.firewallPolicyResource = null;
    
                        /**
                         * PatchRegionNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        PatchRegionNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * PatchRegionNetworkFirewallPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        PatchRegionNetworkFirewallPolicyRequest.prototype.region = "";
    
                        /**
                         * PatchRegionNetworkFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        PatchRegionNetworkFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchRegionNetworkFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(PatchRegionNetworkFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchRegionNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest} PatchRegionNetworkFirewallPolicyRequest instance
                         */
                        PatchRegionNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new PatchRegionNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchRegionNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionNetworkFirewallPolicyRequest} message PatchRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRegionNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewallPolicyResource != null && Object.hasOwnProperty.call(message, "firewallPolicyResource"))
                                $root.google.cloud.compute.v1.FirewallPolicy.encode(message.firewallPolicyResource, writer.uint32(/* id 495049532, wireType 2 =*/3960396258).fork()).ldelim();
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchRegionNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionNetworkFirewallPolicyRequest} message PatchRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRegionNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchRegionNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest} PatchRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRegionNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 495049532: {
                                        message.firewallPolicyResource = $root.google.cloud.compute.v1.FirewallPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchRegionNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest} PatchRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRegionNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchRegionNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchRegionNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.firewallPolicyResource != null && message.hasOwnProperty("firewallPolicyResource")) {
                                var error = $root.google.cloud.compute.v1.FirewallPolicy.verify(message.firewallPolicyResource);
                                if (error)
                                    return "firewallPolicyResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchRegionNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest} PatchRegionNetworkFirewallPolicyRequest
                         */
                        PatchRegionNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.firewallPolicyResource != null) {
                                if (typeof object.firewallPolicyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest.firewallPolicyResource: object expected");
                                message.firewallPolicyResource = $root.google.cloud.compute.v1.FirewallPolicy.fromObject(object.firewallPolicyResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchRegionNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest} message PatchRegionNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchRegionNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.firewallPolicyResource = null;
                                object.firewallPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewallPolicyResource != null && message.hasOwnProperty("firewallPolicyResource"))
                                object.firewallPolicyResource = $root.google.cloud.compute.v1.FirewallPolicy.toObject(message.firewallPolicyResource, options);
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this PatchRegionNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchRegionNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchRegionNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchRegionNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest";
                        };
    
                        return PatchRegionNetworkFirewallPolicyRequest;
                    })();
    
                    v1.PatchRegionSecurityPolicyRequest = (function() {
    
                        /**
                         * Properties of a PatchRegionSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchRegionSecurityPolicyRequest
                         * @property {string|null} [project] PatchRegionSecurityPolicyRequest project
                         * @property {string|null} [region] PatchRegionSecurityPolicyRequest region
                         * @property {string|null} [requestId] PatchRegionSecurityPolicyRequest requestId
                         * @property {string|null} [securityPolicy] PatchRegionSecurityPolicyRequest securityPolicy
                         * @property {google.cloud.compute.v1.ISecurityPolicy|null} [securityPolicyResource] PatchRegionSecurityPolicyRequest securityPolicyResource
                         */
    
                        /**
                         * Constructs a new PatchRegionSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchRegionSecurityPolicyRequest.
                         * @implements IPatchRegionSecurityPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchRegionSecurityPolicyRequest=} [properties] Properties to set
                         */
                        function PatchRegionSecurityPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchRegionSecurityPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchRegionSecurityPolicyRequest
                         * @instance
                         */
                        PatchRegionSecurityPolicyRequest.prototype.project = "";
    
                        /**
                         * PatchRegionSecurityPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PatchRegionSecurityPolicyRequest
                         * @instance
                         */
                        PatchRegionSecurityPolicyRequest.prototype.region = "";
    
                        /**
                         * PatchRegionSecurityPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchRegionSecurityPolicyRequest
                         * @instance
                         */
                        PatchRegionSecurityPolicyRequest.prototype.requestId = null;
    
                        /**
                         * PatchRegionSecurityPolicyRequest securityPolicy.
                         * @member {string} securityPolicy
                         * @memberof google.cloud.compute.v1.PatchRegionSecurityPolicyRequest
                         * @instance
                         */
                        PatchRegionSecurityPolicyRequest.prototype.securityPolicy = "";
    
                        /**
                         * PatchRegionSecurityPolicyRequest securityPolicyResource.
                         * @member {google.cloud.compute.v1.ISecurityPolicy|null|undefined} securityPolicyResource
                         * @memberof google.cloud.compute.v1.PatchRegionSecurityPolicyRequest
                         * @instance
                         */
                        PatchRegionSecurityPolicyRequest.prototype.securityPolicyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchRegionSecurityPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchRegionSecurityPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(PatchRegionSecurityPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchRegionSecurityPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchRegionSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionSecurityPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchRegionSecurityPolicyRequest} PatchRegionSecurityPolicyRequest instance
                         */
                        PatchRegionSecurityPolicyRequest.create = function create(properties) {
                            return new PatchRegionSecurityPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchRegionSecurityPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchRegionSecurityPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchRegionSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionSecurityPolicyRequest} message PatchRegionSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRegionSecurityPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.securityPolicy != null && Object.hasOwnProperty.call(message, "securityPolicy"))
                                writer.uint32(/* id 171082513, wireType 2 =*/1368660106).string(message.securityPolicy);
                            if (message.securityPolicyResource != null && Object.hasOwnProperty.call(message, "securityPolicyResource"))
                                $root.google.cloud.compute.v1.SecurityPolicy.encode(message.securityPolicyResource, writer.uint32(/* id 216159612, wireType 2 =*/1729276898).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchRegionSecurityPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchRegionSecurityPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRegionSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionSecurityPolicyRequest} message PatchRegionSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRegionSecurityPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchRegionSecurityPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchRegionSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchRegionSecurityPolicyRequest} PatchRegionSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRegionSecurityPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchRegionSecurityPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 171082513: {
                                        message.securityPolicy = reader.string();
                                        break;
                                    }
                                case 216159612: {
                                        message.securityPolicyResource = $root.google.cloud.compute.v1.SecurityPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchRegionSecurityPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRegionSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchRegionSecurityPolicyRequest} PatchRegionSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRegionSecurityPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchRegionSecurityPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchRegionSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchRegionSecurityPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy"))
                                if (!$util.isString(message.securityPolicy))
                                    return "securityPolicy: string expected";
                            if (message.securityPolicyResource != null && message.hasOwnProperty("securityPolicyResource")) {
                                var error = $root.google.cloud.compute.v1.SecurityPolicy.verify(message.securityPolicyResource);
                                if (error)
                                    return "securityPolicyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchRegionSecurityPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchRegionSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchRegionSecurityPolicyRequest} PatchRegionSecurityPolicyRequest
                         */
                        PatchRegionSecurityPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchRegionSecurityPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchRegionSecurityPolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.securityPolicy != null)
                                message.securityPolicy = String(object.securityPolicy);
                            if (object.securityPolicyResource != null) {
                                if (typeof object.securityPolicyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchRegionSecurityPolicyRequest.securityPolicyResource: object expected");
                                message.securityPolicyResource = $root.google.cloud.compute.v1.SecurityPolicy.fromObject(object.securityPolicyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchRegionSecurityPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchRegionSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchRegionSecurityPolicyRequest} message PatchRegionSecurityPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchRegionSecurityPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.securityPolicy = "";
                                object.securityPolicyResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy"))
                                object.securityPolicy = message.securityPolicy;
                            if (message.securityPolicyResource != null && message.hasOwnProperty("securityPolicyResource"))
                                object.securityPolicyResource = $root.google.cloud.compute.v1.SecurityPolicy.toObject(message.securityPolicyResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this PatchRegionSecurityPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchRegionSecurityPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchRegionSecurityPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchRegionSecurityPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchRegionSecurityPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchRegionSecurityPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchRegionSecurityPolicyRequest";
                        };
    
                        return PatchRegionSecurityPolicyRequest;
                    })();
    
                    v1.PatchRegionSslPolicyRequest = (function() {
    
                        /**
                         * Properties of a PatchRegionSslPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchRegionSslPolicyRequest
                         * @property {string|null} [project] PatchRegionSslPolicyRequest project
                         * @property {string|null} [region] PatchRegionSslPolicyRequest region
                         * @property {string|null} [requestId] PatchRegionSslPolicyRequest requestId
                         * @property {string|null} [sslPolicy] PatchRegionSslPolicyRequest sslPolicy
                         * @property {google.cloud.compute.v1.ISslPolicy|null} [sslPolicyResource] PatchRegionSslPolicyRequest sslPolicyResource
                         */
    
                        /**
                         * Constructs a new PatchRegionSslPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchRegionSslPolicyRequest.
                         * @implements IPatchRegionSslPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchRegionSslPolicyRequest=} [properties] Properties to set
                         */
                        function PatchRegionSslPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchRegionSslPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchRegionSslPolicyRequest
                         * @instance
                         */
                        PatchRegionSslPolicyRequest.prototype.project = "";
    
                        /**
                         * PatchRegionSslPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PatchRegionSslPolicyRequest
                         * @instance
                         */
                        PatchRegionSslPolicyRequest.prototype.region = "";
    
                        /**
                         * PatchRegionSslPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchRegionSslPolicyRequest
                         * @instance
                         */
                        PatchRegionSslPolicyRequest.prototype.requestId = null;
    
                        /**
                         * PatchRegionSslPolicyRequest sslPolicy.
                         * @member {string} sslPolicy
                         * @memberof google.cloud.compute.v1.PatchRegionSslPolicyRequest
                         * @instance
                         */
                        PatchRegionSslPolicyRequest.prototype.sslPolicy = "";
    
                        /**
                         * PatchRegionSslPolicyRequest sslPolicyResource.
                         * @member {google.cloud.compute.v1.ISslPolicy|null|undefined} sslPolicyResource
                         * @memberof google.cloud.compute.v1.PatchRegionSslPolicyRequest
                         * @instance
                         */
                        PatchRegionSslPolicyRequest.prototype.sslPolicyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchRegionSslPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchRegionSslPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(PatchRegionSslPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchRegionSslPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchRegionSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionSslPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchRegionSslPolicyRequest} PatchRegionSslPolicyRequest instance
                         */
                        PatchRegionSslPolicyRequest.create = function create(properties) {
                            return new PatchRegionSslPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchRegionSslPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchRegionSslPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchRegionSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionSslPolicyRequest} message PatchRegionSslPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRegionSslPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.sslPolicyResource != null && Object.hasOwnProperty.call(message, "sslPolicyResource"))
                                $root.google.cloud.compute.v1.SslPolicy.encode(message.sslPolicyResource, writer.uint32(/* id 274891848, wireType 2 =*/2199134786).fork()).ldelim();
                            if (message.sslPolicy != null && Object.hasOwnProperty.call(message, "sslPolicy"))
                                writer.uint32(/* id 295190213, wireType 2 =*/2361521706).string(message.sslPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchRegionSslPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchRegionSslPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRegionSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionSslPolicyRequest} message PatchRegionSslPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRegionSslPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchRegionSslPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchRegionSslPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchRegionSslPolicyRequest} PatchRegionSslPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRegionSslPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchRegionSslPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 295190213: {
                                        message.sslPolicy = reader.string();
                                        break;
                                    }
                                case 274891848: {
                                        message.sslPolicyResource = $root.google.cloud.compute.v1.SslPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchRegionSslPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRegionSslPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchRegionSslPolicyRequest} PatchRegionSslPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRegionSslPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchRegionSslPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchRegionSslPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchRegionSslPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.sslPolicy != null && message.hasOwnProperty("sslPolicy"))
                                if (!$util.isString(message.sslPolicy))
                                    return "sslPolicy: string expected";
                            if (message.sslPolicyResource != null && message.hasOwnProperty("sslPolicyResource")) {
                                var error = $root.google.cloud.compute.v1.SslPolicy.verify(message.sslPolicyResource);
                                if (error)
                                    return "sslPolicyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchRegionSslPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchRegionSslPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchRegionSslPolicyRequest} PatchRegionSslPolicyRequest
                         */
                        PatchRegionSslPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchRegionSslPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchRegionSslPolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.sslPolicy != null)
                                message.sslPolicy = String(object.sslPolicy);
                            if (object.sslPolicyResource != null) {
                                if (typeof object.sslPolicyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchRegionSslPolicyRequest.sslPolicyResource: object expected");
                                message.sslPolicyResource = $root.google.cloud.compute.v1.SslPolicy.fromObject(object.sslPolicyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchRegionSslPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchRegionSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchRegionSslPolicyRequest} message PatchRegionSslPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchRegionSslPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.sslPolicyResource = null;
                                object.sslPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.sslPolicyResource != null && message.hasOwnProperty("sslPolicyResource"))
                                object.sslPolicyResource = $root.google.cloud.compute.v1.SslPolicy.toObject(message.sslPolicyResource, options);
                            if (message.sslPolicy != null && message.hasOwnProperty("sslPolicy"))
                                object.sslPolicy = message.sslPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this PatchRegionSslPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchRegionSslPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchRegionSslPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchRegionSslPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchRegionSslPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchRegionSslPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchRegionSslPolicyRequest";
                        };
    
                        return PatchRegionSslPolicyRequest;
                    })();
    
                    v1.PatchRegionTargetHttpsProxyRequest = (function() {
    
                        /**
                         * Properties of a PatchRegionTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchRegionTargetHttpsProxyRequest
                         * @property {string|null} [project] PatchRegionTargetHttpsProxyRequest project
                         * @property {string|null} [region] PatchRegionTargetHttpsProxyRequest region
                         * @property {string|null} [requestId] PatchRegionTargetHttpsProxyRequest requestId
                         * @property {string|null} [targetHttpsProxy] PatchRegionTargetHttpsProxyRequest targetHttpsProxy
                         * @property {google.cloud.compute.v1.ITargetHttpsProxy|null} [targetHttpsProxyResource] PatchRegionTargetHttpsProxyRequest targetHttpsProxyResource
                         */
    
                        /**
                         * Constructs a new PatchRegionTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchRegionTargetHttpsProxyRequest.
                         * @implements IPatchRegionTargetHttpsProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchRegionTargetHttpsProxyRequest=} [properties] Properties to set
                         */
                        function PatchRegionTargetHttpsProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchRegionTargetHttpsProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        PatchRegionTargetHttpsProxyRequest.prototype.project = "";
    
                        /**
                         * PatchRegionTargetHttpsProxyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        PatchRegionTargetHttpsProxyRequest.prototype.region = "";
    
                        /**
                         * PatchRegionTargetHttpsProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        PatchRegionTargetHttpsProxyRequest.prototype.requestId = null;
    
                        /**
                         * PatchRegionTargetHttpsProxyRequest targetHttpsProxy.
                         * @member {string} targetHttpsProxy
                         * @memberof google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        PatchRegionTargetHttpsProxyRequest.prototype.targetHttpsProxy = "";
    
                        /**
                         * PatchRegionTargetHttpsProxyRequest targetHttpsProxyResource.
                         * @member {google.cloud.compute.v1.ITargetHttpsProxy|null|undefined} targetHttpsProxyResource
                         * @memberof google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        PatchRegionTargetHttpsProxyRequest.prototype.targetHttpsProxyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchRegionTargetHttpsProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        Object.defineProperty(PatchRegionTargetHttpsProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchRegionTargetHttpsProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionTargetHttpsProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest} PatchRegionTargetHttpsProxyRequest instance
                         */
                        PatchRegionTargetHttpsProxyRequest.create = function create(properties) {
                            return new PatchRegionTargetHttpsProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchRegionTargetHttpsProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionTargetHttpsProxyRequest} message PatchRegionTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRegionTargetHttpsProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetHttpsProxy != null && Object.hasOwnProperty.call(message, "targetHttpsProxy"))
                                writer.uint32(/* id 52336748, wireType 2 =*/418693986).string(message.targetHttpsProxy);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetHttpsProxyResource != null && Object.hasOwnProperty.call(message, "targetHttpsProxyResource"))
                                $root.google.cloud.compute.v1.TargetHttpsProxy.encode(message.targetHttpsProxyResource, writer.uint32(/* id 433657473, wireType 2 =*/3469259786).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchRegionTargetHttpsProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionTargetHttpsProxyRequest} message PatchRegionTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRegionTargetHttpsProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchRegionTargetHttpsProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest} PatchRegionTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRegionTargetHttpsProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 52336748: {
                                        message.targetHttpsProxy = reader.string();
                                        break;
                                    }
                                case 433657473: {
                                        message.targetHttpsProxyResource = $root.google.cloud.compute.v1.TargetHttpsProxy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchRegionTargetHttpsProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest} PatchRegionTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRegionTargetHttpsProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchRegionTargetHttpsProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchRegionTargetHttpsProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                if (!$util.isString(message.targetHttpsProxy))
                                    return "targetHttpsProxy: string expected";
                            if (message.targetHttpsProxyResource != null && message.hasOwnProperty("targetHttpsProxyResource")) {
                                var error = $root.google.cloud.compute.v1.TargetHttpsProxy.verify(message.targetHttpsProxyResource);
                                if (error)
                                    return "targetHttpsProxyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchRegionTargetHttpsProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest} PatchRegionTargetHttpsProxyRequest
                         */
                        PatchRegionTargetHttpsProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetHttpsProxy != null)
                                message.targetHttpsProxy = String(object.targetHttpsProxy);
                            if (object.targetHttpsProxyResource != null) {
                                if (typeof object.targetHttpsProxyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest.targetHttpsProxyResource: object expected");
                                message.targetHttpsProxyResource = $root.google.cloud.compute.v1.TargetHttpsProxy.fromObject(object.targetHttpsProxyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchRegionTargetHttpsProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest} message PatchRegionTargetHttpsProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchRegionTargetHttpsProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetHttpsProxy = "";
                                object.region = "";
                                object.project = "";
                                object.targetHttpsProxyResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                object.targetHttpsProxy = message.targetHttpsProxy;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetHttpsProxyResource != null && message.hasOwnProperty("targetHttpsProxyResource"))
                                object.targetHttpsProxyResource = $root.google.cloud.compute.v1.TargetHttpsProxy.toObject(message.targetHttpsProxyResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this PatchRegionTargetHttpsProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchRegionTargetHttpsProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchRegionTargetHttpsProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchRegionTargetHttpsProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest";
                        };
    
                        return PatchRegionTargetHttpsProxyRequest;
                    })();
    
                    v1.PatchRegionUrlMapRequest = (function() {
    
                        /**
                         * Properties of a PatchRegionUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchRegionUrlMapRequest
                         * @property {string|null} [project] PatchRegionUrlMapRequest project
                         * @property {string|null} [region] PatchRegionUrlMapRequest region
                         * @property {string|null} [requestId] PatchRegionUrlMapRequest requestId
                         * @property {string|null} [urlMap] PatchRegionUrlMapRequest urlMap
                         * @property {google.cloud.compute.v1.IUrlMap|null} [urlMapResource] PatchRegionUrlMapRequest urlMapResource
                         */
    
                        /**
                         * Constructs a new PatchRegionUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchRegionUrlMapRequest.
                         * @implements IPatchRegionUrlMapRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchRegionUrlMapRequest=} [properties] Properties to set
                         */
                        function PatchRegionUrlMapRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchRegionUrlMapRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchRegionUrlMapRequest
                         * @instance
                         */
                        PatchRegionUrlMapRequest.prototype.project = "";
    
                        /**
                         * PatchRegionUrlMapRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PatchRegionUrlMapRequest
                         * @instance
                         */
                        PatchRegionUrlMapRequest.prototype.region = "";
    
                        /**
                         * PatchRegionUrlMapRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchRegionUrlMapRequest
                         * @instance
                         */
                        PatchRegionUrlMapRequest.prototype.requestId = null;
    
                        /**
                         * PatchRegionUrlMapRequest urlMap.
                         * @member {string} urlMap
                         * @memberof google.cloud.compute.v1.PatchRegionUrlMapRequest
                         * @instance
                         */
                        PatchRegionUrlMapRequest.prototype.urlMap = "";
    
                        /**
                         * PatchRegionUrlMapRequest urlMapResource.
                         * @member {google.cloud.compute.v1.IUrlMap|null|undefined} urlMapResource
                         * @memberof google.cloud.compute.v1.PatchRegionUrlMapRequest
                         * @instance
                         */
                        PatchRegionUrlMapRequest.prototype.urlMapResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchRegionUrlMapRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchRegionUrlMapRequest
                         * @instance
                         */
                        Object.defineProperty(PatchRegionUrlMapRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchRegionUrlMapRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionUrlMapRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchRegionUrlMapRequest} PatchRegionUrlMapRequest instance
                         */
                        PatchRegionUrlMapRequest.create = function create(properties) {
                            return new PatchRegionUrlMapRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchRegionUrlMapRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchRegionUrlMapRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionUrlMapRequest} message PatchRegionUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRegionUrlMapRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.urlMapResource != null && Object.hasOwnProperty.call(message, "urlMapResource"))
                                $root.google.cloud.compute.v1.UrlMap.encode(message.urlMapResource, writer.uint32(/* id 168675425, wireType 2 =*/1349403402).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.urlMap != null && Object.hasOwnProperty.call(message, "urlMap"))
                                writer.uint32(/* id 367020684, wireType 2 =*/2936165474).string(message.urlMap);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchRegionUrlMapRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchRegionUrlMapRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRegionUrlMapRequest} message PatchRegionUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRegionUrlMapRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchRegionUrlMapRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchRegionUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchRegionUrlMapRequest} PatchRegionUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRegionUrlMapRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchRegionUrlMapRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 367020684: {
                                        message.urlMap = reader.string();
                                        break;
                                    }
                                case 168675425: {
                                        message.urlMapResource = $root.google.cloud.compute.v1.UrlMap.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchRegionUrlMapRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRegionUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchRegionUrlMapRequest} PatchRegionUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRegionUrlMapRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchRegionUrlMapRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchRegionUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchRegionUrlMapRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                if (!$util.isString(message.urlMap))
                                    return "urlMap: string expected";
                            if (message.urlMapResource != null && message.hasOwnProperty("urlMapResource")) {
                                var error = $root.google.cloud.compute.v1.UrlMap.verify(message.urlMapResource);
                                if (error)
                                    return "urlMapResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchRegionUrlMapRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchRegionUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchRegionUrlMapRequest} PatchRegionUrlMapRequest
                         */
                        PatchRegionUrlMapRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchRegionUrlMapRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchRegionUrlMapRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.urlMap != null)
                                message.urlMap = String(object.urlMap);
                            if (object.urlMapResource != null) {
                                if (typeof object.urlMapResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchRegionUrlMapRequest.urlMapResource: object expected");
                                message.urlMapResource = $root.google.cloud.compute.v1.UrlMap.fromObject(object.urlMapResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchRegionUrlMapRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchRegionUrlMapRequest} message PatchRegionUrlMapRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchRegionUrlMapRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.urlMapResource = null;
                                object.project = "";
                                object.urlMap = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.urlMapResource != null && message.hasOwnProperty("urlMapResource"))
                                object.urlMapResource = $root.google.cloud.compute.v1.UrlMap.toObject(message.urlMapResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                object.urlMap = message.urlMap;
                            return object;
                        };
    
                        /**
                         * Converts this PatchRegionUrlMapRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchRegionUrlMapRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchRegionUrlMapRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchRegionUrlMapRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchRegionUrlMapRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchRegionUrlMapRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchRegionUrlMapRequest";
                        };
    
                        return PatchRegionUrlMapRequest;
                    })();
    
                    v1.PatchRouterRequest = (function() {
    
                        /**
                         * Properties of a PatchRouterRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchRouterRequest
                         * @property {string|null} [project] PatchRouterRequest project
                         * @property {string|null} [region] PatchRouterRequest region
                         * @property {string|null} [requestId] PatchRouterRequest requestId
                         * @property {string|null} [router] PatchRouterRequest router
                         * @property {google.cloud.compute.v1.IRouter|null} [routerResource] PatchRouterRequest routerResource
                         */
    
                        /**
                         * Constructs a new PatchRouterRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchRouterRequest.
                         * @implements IPatchRouterRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchRouterRequest=} [properties] Properties to set
                         */
                        function PatchRouterRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchRouterRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchRouterRequest
                         * @instance
                         */
                        PatchRouterRequest.prototype.project = "";
    
                        /**
                         * PatchRouterRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PatchRouterRequest
                         * @instance
                         */
                        PatchRouterRequest.prototype.region = "";
    
                        /**
                         * PatchRouterRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchRouterRequest
                         * @instance
                         */
                        PatchRouterRequest.prototype.requestId = null;
    
                        /**
                         * PatchRouterRequest router.
                         * @member {string} router
                         * @memberof google.cloud.compute.v1.PatchRouterRequest
                         * @instance
                         */
                        PatchRouterRequest.prototype.router = "";
    
                        /**
                         * PatchRouterRequest routerResource.
                         * @member {google.cloud.compute.v1.IRouter|null|undefined} routerResource
                         * @memberof google.cloud.compute.v1.PatchRouterRequest
                         * @instance
                         */
                        PatchRouterRequest.prototype.routerResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchRouterRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchRouterRequest
                         * @instance
                         */
                        Object.defineProperty(PatchRouterRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchRouterRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRouterRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchRouterRequest} PatchRouterRequest instance
                         */
                        PatchRouterRequest.create = function create(properties) {
                            return new PatchRouterRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchRouterRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchRouterRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRouterRequest} message PatchRouterRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRouterRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.router != null && Object.hasOwnProperty.call(message, "router"))
                                writer.uint32(/* id 148608841, wireType 2 =*/1188870730).string(message.router);
                            if (message.routerResource != null && Object.hasOwnProperty.call(message, "routerResource"))
                                $root.google.cloud.compute.v1.Router.encode(message.routerResource, writer.uint32(/* id 155222084, wireType 2 =*/1241776674).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchRouterRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchRouterRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRouterRequest} message PatchRouterRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRouterRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchRouterRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchRouterRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchRouterRequest} PatchRouterRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRouterRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchRouterRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 148608841: {
                                        message.router = reader.string();
                                        break;
                                    }
                                case 155222084: {
                                        message.routerResource = $root.google.cloud.compute.v1.Router.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchRouterRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRouterRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchRouterRequest} PatchRouterRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRouterRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchRouterRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchRouterRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchRouterRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.router != null && message.hasOwnProperty("router"))
                                if (!$util.isString(message.router))
                                    return "router: string expected";
                            if (message.routerResource != null && message.hasOwnProperty("routerResource")) {
                                var error = $root.google.cloud.compute.v1.Router.verify(message.routerResource);
                                if (error)
                                    return "routerResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchRouterRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchRouterRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchRouterRequest} PatchRouterRequest
                         */
                        PatchRouterRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchRouterRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchRouterRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.router != null)
                                message.router = String(object.router);
                            if (object.routerResource != null) {
                                if (typeof object.routerResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchRouterRequest.routerResource: object expected");
                                message.routerResource = $root.google.cloud.compute.v1.Router.fromObject(object.routerResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchRouterRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchRouterRequest} message PatchRouterRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchRouterRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.router = "";
                                object.routerResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.router != null && message.hasOwnProperty("router"))
                                object.router = message.router;
                            if (message.routerResource != null && message.hasOwnProperty("routerResource"))
                                object.routerResource = $root.google.cloud.compute.v1.Router.toObject(message.routerResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this PatchRouterRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchRouterRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchRouterRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchRouterRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchRouterRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchRouterRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchRouterRequest";
                        };
    
                        return PatchRouterRequest;
                    })();
    
                    v1.PatchRuleFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a PatchRuleFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchRuleFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] PatchRuleFirewallPolicyRequest firewallPolicy
                         * @property {google.cloud.compute.v1.IFirewallPolicyRule|null} [firewallPolicyRuleResource] PatchRuleFirewallPolicyRequest firewallPolicyRuleResource
                         * @property {number|null} [priority] PatchRuleFirewallPolicyRequest priority
                         * @property {string|null} [requestId] PatchRuleFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchRuleFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchRuleFirewallPolicyRequest.
                         * @implements IPatchRuleFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchRuleFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function PatchRuleFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchRuleFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.PatchRuleFirewallPolicyRequest
                         * @instance
                         */
                        PatchRuleFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * PatchRuleFirewallPolicyRequest firewallPolicyRuleResource.
                         * @member {google.cloud.compute.v1.IFirewallPolicyRule|null|undefined} firewallPolicyRuleResource
                         * @memberof google.cloud.compute.v1.PatchRuleFirewallPolicyRequest
                         * @instance
                         */
                        PatchRuleFirewallPolicyRequest.prototype.firewallPolicyRuleResource = null;
    
                        /**
                         * PatchRuleFirewallPolicyRequest priority.
                         * @member {number|null|undefined} priority
                         * @memberof google.cloud.compute.v1.PatchRuleFirewallPolicyRequest
                         * @instance
                         */
                        PatchRuleFirewallPolicyRequest.prototype.priority = null;
    
                        /**
                         * PatchRuleFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchRuleFirewallPolicyRequest
                         * @instance
                         */
                        PatchRuleFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchRuleFirewallPolicyRequest _priority.
                         * @member {"priority"|undefined} _priority
                         * @memberof google.cloud.compute.v1.PatchRuleFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(PatchRuleFirewallPolicyRequest.prototype, "_priority", {
                            get: $util.oneOfGetter($oneOfFields = ["priority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PatchRuleFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchRuleFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(PatchRuleFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchRuleFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchRuleFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRuleFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchRuleFirewallPolicyRequest} PatchRuleFirewallPolicyRequest instance
                         */
                        PatchRuleFirewallPolicyRequest.create = function create(properties) {
                            return new PatchRuleFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchRuleFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchRuleFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchRuleFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRuleFirewallPolicyRequest} message PatchRuleFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRuleFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.firewallPolicyRuleResource != null && Object.hasOwnProperty.call(message, "firewallPolicyRuleResource"))
                                $root.google.cloud.compute.v1.FirewallPolicyRule.encode(message.firewallPolicyRuleResource, writer.uint32(/* id 250523523, wireType 2 =*/2004188186).fork()).ldelim();
                            if (message.priority != null && Object.hasOwnProperty.call(message, "priority"))
                                writer.uint32(/* id 445151652, wireType 0 =*/3561213216).int32(message.priority);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchRuleFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchRuleFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRuleFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRuleFirewallPolicyRequest} message PatchRuleFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRuleFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchRuleFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchRuleFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchRuleFirewallPolicyRequest} PatchRuleFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRuleFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchRuleFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 250523523: {
                                        message.firewallPolicyRuleResource = $root.google.cloud.compute.v1.FirewallPolicyRule.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 445151652: {
                                        message.priority = reader.int32();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchRuleFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRuleFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchRuleFirewallPolicyRequest} PatchRuleFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRuleFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchRuleFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchRuleFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchRuleFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.firewallPolicyRuleResource != null && message.hasOwnProperty("firewallPolicyRuleResource")) {
                                var error = $root.google.cloud.compute.v1.FirewallPolicyRule.verify(message.firewallPolicyRuleResource);
                                if (error)
                                    return "firewallPolicyRuleResource." + error;
                            }
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                properties._priority = 1;
                                if (!$util.isInteger(message.priority))
                                    return "priority: integer expected";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchRuleFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchRuleFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchRuleFirewallPolicyRequest} PatchRuleFirewallPolicyRequest
                         */
                        PatchRuleFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchRuleFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchRuleFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.firewallPolicyRuleResource != null) {
                                if (typeof object.firewallPolicyRuleResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchRuleFirewallPolicyRequest.firewallPolicyRuleResource: object expected");
                                message.firewallPolicyRuleResource = $root.google.cloud.compute.v1.FirewallPolicyRule.fromObject(object.firewallPolicyRuleResource);
                            }
                            if (object.priority != null)
                                message.priority = object.priority | 0;
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchRuleFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchRuleFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchRuleFirewallPolicyRequest} message PatchRuleFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchRuleFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.firewallPolicyRuleResource = null;
                                object.firewallPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.firewallPolicyRuleResource != null && message.hasOwnProperty("firewallPolicyRuleResource"))
                                object.firewallPolicyRuleResource = $root.google.cloud.compute.v1.FirewallPolicyRule.toObject(message.firewallPolicyRuleResource, options);
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                object.priority = message.priority;
                                if (options.oneofs)
                                    object._priority = "priority";
                            }
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this PatchRuleFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchRuleFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchRuleFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchRuleFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchRuleFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchRuleFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchRuleFirewallPolicyRequest";
                        };
    
                        return PatchRuleFirewallPolicyRequest;
                    })();
    
                    v1.PatchRuleNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a PatchRuleNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchRuleNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] PatchRuleNetworkFirewallPolicyRequest firewallPolicy
                         * @property {google.cloud.compute.v1.IFirewallPolicyRule|null} [firewallPolicyRuleResource] PatchRuleNetworkFirewallPolicyRequest firewallPolicyRuleResource
                         * @property {number|null} [priority] PatchRuleNetworkFirewallPolicyRequest priority
                         * @property {string|null} [project] PatchRuleNetworkFirewallPolicyRequest project
                         * @property {string|null} [requestId] PatchRuleNetworkFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchRuleNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchRuleNetworkFirewallPolicyRequest.
                         * @implements IPatchRuleNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchRuleNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function PatchRuleNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchRuleNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        PatchRuleNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * PatchRuleNetworkFirewallPolicyRequest firewallPolicyRuleResource.
                         * @member {google.cloud.compute.v1.IFirewallPolicyRule|null|undefined} firewallPolicyRuleResource
                         * @memberof google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        PatchRuleNetworkFirewallPolicyRequest.prototype.firewallPolicyRuleResource = null;
    
                        /**
                         * PatchRuleNetworkFirewallPolicyRequest priority.
                         * @member {number|null|undefined} priority
                         * @memberof google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        PatchRuleNetworkFirewallPolicyRequest.prototype.priority = null;
    
                        /**
                         * PatchRuleNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        PatchRuleNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * PatchRuleNetworkFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        PatchRuleNetworkFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchRuleNetworkFirewallPolicyRequest _priority.
                         * @member {"priority"|undefined} _priority
                         * @memberof google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(PatchRuleNetworkFirewallPolicyRequest.prototype, "_priority", {
                            get: $util.oneOfGetter($oneOfFields = ["priority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PatchRuleNetworkFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(PatchRuleNetworkFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchRuleNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRuleNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest} PatchRuleNetworkFirewallPolicyRequest instance
                         */
                        PatchRuleNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new PatchRuleNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchRuleNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRuleNetworkFirewallPolicyRequest} message PatchRuleNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRuleNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewallPolicyRuleResource != null && Object.hasOwnProperty.call(message, "firewallPolicyRuleResource"))
                                $root.google.cloud.compute.v1.FirewallPolicyRule.encode(message.firewallPolicyRuleResource, writer.uint32(/* id 250523523, wireType 2 =*/2004188186).fork()).ldelim();
                            if (message.priority != null && Object.hasOwnProperty.call(message, "priority"))
                                writer.uint32(/* id 445151652, wireType 0 =*/3561213216).int32(message.priority);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchRuleNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRuleNetworkFirewallPolicyRequest} message PatchRuleNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRuleNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchRuleNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest} PatchRuleNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRuleNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 250523523: {
                                        message.firewallPolicyRuleResource = $root.google.cloud.compute.v1.FirewallPolicyRule.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 445151652: {
                                        message.priority = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchRuleNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest} PatchRuleNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRuleNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchRuleNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchRuleNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.firewallPolicyRuleResource != null && message.hasOwnProperty("firewallPolicyRuleResource")) {
                                var error = $root.google.cloud.compute.v1.FirewallPolicyRule.verify(message.firewallPolicyRuleResource);
                                if (error)
                                    return "firewallPolicyRuleResource." + error;
                            }
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                properties._priority = 1;
                                if (!$util.isInteger(message.priority))
                                    return "priority: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchRuleNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest} PatchRuleNetworkFirewallPolicyRequest
                         */
                        PatchRuleNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.firewallPolicyRuleResource != null) {
                                if (typeof object.firewallPolicyRuleResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest.firewallPolicyRuleResource: object expected");
                                message.firewallPolicyRuleResource = $root.google.cloud.compute.v1.FirewallPolicyRule.fromObject(object.firewallPolicyRuleResource);
                            }
                            if (object.priority != null)
                                message.priority = object.priority | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchRuleNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest} message PatchRuleNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchRuleNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.firewallPolicyRuleResource = null;
                                object.firewallPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewallPolicyRuleResource != null && message.hasOwnProperty("firewallPolicyRuleResource"))
                                object.firewallPolicyRuleResource = $root.google.cloud.compute.v1.FirewallPolicyRule.toObject(message.firewallPolicyRuleResource, options);
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                object.priority = message.priority;
                                if (options.oneofs)
                                    object._priority = "priority";
                            }
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this PatchRuleNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchRuleNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchRuleNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchRuleNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest";
                        };
    
                        return PatchRuleNetworkFirewallPolicyRequest;
                    })();
    
                    v1.PatchRuleRegionNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a PatchRuleRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchRuleRegionNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] PatchRuleRegionNetworkFirewallPolicyRequest firewallPolicy
                         * @property {google.cloud.compute.v1.IFirewallPolicyRule|null} [firewallPolicyRuleResource] PatchRuleRegionNetworkFirewallPolicyRequest firewallPolicyRuleResource
                         * @property {number|null} [priority] PatchRuleRegionNetworkFirewallPolicyRequest priority
                         * @property {string|null} [project] PatchRuleRegionNetworkFirewallPolicyRequest project
                         * @property {string|null} [region] PatchRuleRegionNetworkFirewallPolicyRequest region
                         * @property {string|null} [requestId] PatchRuleRegionNetworkFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new PatchRuleRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchRuleRegionNetworkFirewallPolicyRequest.
                         * @implements IPatchRuleRegionNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchRuleRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function PatchRuleRegionNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchRuleRegionNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        PatchRuleRegionNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * PatchRuleRegionNetworkFirewallPolicyRequest firewallPolicyRuleResource.
                         * @member {google.cloud.compute.v1.IFirewallPolicyRule|null|undefined} firewallPolicyRuleResource
                         * @memberof google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        PatchRuleRegionNetworkFirewallPolicyRequest.prototype.firewallPolicyRuleResource = null;
    
                        /**
                         * PatchRuleRegionNetworkFirewallPolicyRequest priority.
                         * @member {number|null|undefined} priority
                         * @memberof google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        PatchRuleRegionNetworkFirewallPolicyRequest.prototype.priority = null;
    
                        /**
                         * PatchRuleRegionNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        PatchRuleRegionNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * PatchRuleRegionNetworkFirewallPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        PatchRuleRegionNetworkFirewallPolicyRequest.prototype.region = "";
    
                        /**
                         * PatchRuleRegionNetworkFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        PatchRuleRegionNetworkFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchRuleRegionNetworkFirewallPolicyRequest _priority.
                         * @member {"priority"|undefined} _priority
                         * @memberof google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(PatchRuleRegionNetworkFirewallPolicyRequest.prototype, "_priority", {
                            get: $util.oneOfGetter($oneOfFields = ["priority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PatchRuleRegionNetworkFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(PatchRuleRegionNetworkFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchRuleRegionNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRuleRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest} PatchRuleRegionNetworkFirewallPolicyRequest instance
                         */
                        PatchRuleRegionNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new PatchRuleRegionNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchRuleRegionNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRuleRegionNetworkFirewallPolicyRequest} message PatchRuleRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRuleRegionNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewallPolicyRuleResource != null && Object.hasOwnProperty.call(message, "firewallPolicyRuleResource"))
                                $root.google.cloud.compute.v1.FirewallPolicyRule.encode(message.firewallPolicyRuleResource, writer.uint32(/* id 250523523, wireType 2 =*/2004188186).fork()).ldelim();
                            if (message.priority != null && Object.hasOwnProperty.call(message, "priority"))
                                writer.uint32(/* id 445151652, wireType 0 =*/3561213216).int32(message.priority);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchRuleRegionNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRuleRegionNetworkFirewallPolicyRequest} message PatchRuleRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRuleRegionNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchRuleRegionNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest} PatchRuleRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRuleRegionNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 250523523: {
                                        message.firewallPolicyRuleResource = $root.google.cloud.compute.v1.FirewallPolicyRule.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 445151652: {
                                        message.priority = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchRuleRegionNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest} PatchRuleRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRuleRegionNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchRuleRegionNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchRuleRegionNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.firewallPolicyRuleResource != null && message.hasOwnProperty("firewallPolicyRuleResource")) {
                                var error = $root.google.cloud.compute.v1.FirewallPolicyRule.verify(message.firewallPolicyRuleResource);
                                if (error)
                                    return "firewallPolicyRuleResource." + error;
                            }
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                properties._priority = 1;
                                if (!$util.isInteger(message.priority))
                                    return "priority: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchRuleRegionNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest} PatchRuleRegionNetworkFirewallPolicyRequest
                         */
                        PatchRuleRegionNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.firewallPolicyRuleResource != null) {
                                if (typeof object.firewallPolicyRuleResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest.firewallPolicyRuleResource: object expected");
                                message.firewallPolicyRuleResource = $root.google.cloud.compute.v1.FirewallPolicyRule.fromObject(object.firewallPolicyRuleResource);
                            }
                            if (object.priority != null)
                                message.priority = object.priority | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchRuleRegionNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest} message PatchRuleRegionNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchRuleRegionNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.firewallPolicyRuleResource = null;
                                object.firewallPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewallPolicyRuleResource != null && message.hasOwnProperty("firewallPolicyRuleResource"))
                                object.firewallPolicyRuleResource = $root.google.cloud.compute.v1.FirewallPolicyRule.toObject(message.firewallPolicyRuleResource, options);
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                object.priority = message.priority;
                                if (options.oneofs)
                                    object._priority = "priority";
                            }
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this PatchRuleRegionNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchRuleRegionNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchRuleRegionNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchRuleRegionNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest";
                        };
    
                        return PatchRuleRegionNetworkFirewallPolicyRequest;
                    })();
    
                    v1.PatchRuleSecurityPolicyRequest = (function() {
    
                        /**
                         * Properties of a PatchRuleSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchRuleSecurityPolicyRequest
                         * @property {number|null} [priority] PatchRuleSecurityPolicyRequest priority
                         * @property {string|null} [project] PatchRuleSecurityPolicyRequest project
                         * @property {string|null} [securityPolicy] PatchRuleSecurityPolicyRequest securityPolicy
                         * @property {google.cloud.compute.v1.ISecurityPolicyRule|null} [securityPolicyRuleResource] PatchRuleSecurityPolicyRequest securityPolicyRuleResource
                         * @property {boolean|null} [validateOnly] PatchRuleSecurityPolicyRequest validateOnly
                         */
    
                        /**
                         * Constructs a new PatchRuleSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchRuleSecurityPolicyRequest.
                         * @implements IPatchRuleSecurityPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchRuleSecurityPolicyRequest=} [properties] Properties to set
                         */
                        function PatchRuleSecurityPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchRuleSecurityPolicyRequest priority.
                         * @member {number|null|undefined} priority
                         * @memberof google.cloud.compute.v1.PatchRuleSecurityPolicyRequest
                         * @instance
                         */
                        PatchRuleSecurityPolicyRequest.prototype.priority = null;
    
                        /**
                         * PatchRuleSecurityPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchRuleSecurityPolicyRequest
                         * @instance
                         */
                        PatchRuleSecurityPolicyRequest.prototype.project = "";
    
                        /**
                         * PatchRuleSecurityPolicyRequest securityPolicy.
                         * @member {string} securityPolicy
                         * @memberof google.cloud.compute.v1.PatchRuleSecurityPolicyRequest
                         * @instance
                         */
                        PatchRuleSecurityPolicyRequest.prototype.securityPolicy = "";
    
                        /**
                         * PatchRuleSecurityPolicyRequest securityPolicyRuleResource.
                         * @member {google.cloud.compute.v1.ISecurityPolicyRule|null|undefined} securityPolicyRuleResource
                         * @memberof google.cloud.compute.v1.PatchRuleSecurityPolicyRequest
                         * @instance
                         */
                        PatchRuleSecurityPolicyRequest.prototype.securityPolicyRuleResource = null;
    
                        /**
                         * PatchRuleSecurityPolicyRequest validateOnly.
                         * @member {boolean|null|undefined} validateOnly
                         * @memberof google.cloud.compute.v1.PatchRuleSecurityPolicyRequest
                         * @instance
                         */
                        PatchRuleSecurityPolicyRequest.prototype.validateOnly = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchRuleSecurityPolicyRequest _priority.
                         * @member {"priority"|undefined} _priority
                         * @memberof google.cloud.compute.v1.PatchRuleSecurityPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(PatchRuleSecurityPolicyRequest.prototype, "_priority", {
                            get: $util.oneOfGetter($oneOfFields = ["priority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PatchRuleSecurityPolicyRequest _validateOnly.
                         * @member {"validateOnly"|undefined} _validateOnly
                         * @memberof google.cloud.compute.v1.PatchRuleSecurityPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(PatchRuleSecurityPolicyRequest.prototype, "_validateOnly", {
                            get: $util.oneOfGetter($oneOfFields = ["validateOnly"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchRuleSecurityPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchRuleSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRuleSecurityPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchRuleSecurityPolicyRequest} PatchRuleSecurityPolicyRequest instance
                         */
                        PatchRuleSecurityPolicyRequest.create = function create(properties) {
                            return new PatchRuleSecurityPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchRuleSecurityPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchRuleSecurityPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchRuleSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRuleSecurityPolicyRequest} message PatchRuleSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRuleSecurityPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.securityPolicy != null && Object.hasOwnProperty.call(message, "securityPolicy"))
                                writer.uint32(/* id 171082513, wireType 2 =*/1368660106).string(message.securityPolicy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.validateOnly != null && Object.hasOwnProperty.call(message, "validateOnly"))
                                writer.uint32(/* id 242744629, wireType 0 =*/1941957032).bool(message.validateOnly);
                            if (message.securityPolicyRuleResource != null && Object.hasOwnProperty.call(message, "securityPolicyRuleResource"))
                                $root.google.cloud.compute.v1.SecurityPolicyRule.encode(message.securityPolicyRuleResource, writer.uint32(/* id 402693443, wireType 2 =*/3221547546).fork()).ldelim();
                            if (message.priority != null && Object.hasOwnProperty.call(message, "priority"))
                                writer.uint32(/* id 445151652, wireType 0 =*/3561213216).int32(message.priority);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchRuleSecurityPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchRuleSecurityPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRuleSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchRuleSecurityPolicyRequest} message PatchRuleSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchRuleSecurityPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchRuleSecurityPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchRuleSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchRuleSecurityPolicyRequest} PatchRuleSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRuleSecurityPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchRuleSecurityPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 445151652: {
                                        message.priority = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 171082513: {
                                        message.securityPolicy = reader.string();
                                        break;
                                    }
                                case 402693443: {
                                        message.securityPolicyRuleResource = $root.google.cloud.compute.v1.SecurityPolicyRule.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 242744629: {
                                        message.validateOnly = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchRuleSecurityPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchRuleSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchRuleSecurityPolicyRequest} PatchRuleSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchRuleSecurityPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchRuleSecurityPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchRuleSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchRuleSecurityPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                properties._priority = 1;
                                if (!$util.isInteger(message.priority))
                                    return "priority: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy"))
                                if (!$util.isString(message.securityPolicy))
                                    return "securityPolicy: string expected";
                            if (message.securityPolicyRuleResource != null && message.hasOwnProperty("securityPolicyRuleResource")) {
                                var error = $root.google.cloud.compute.v1.SecurityPolicyRule.verify(message.securityPolicyRuleResource);
                                if (error)
                                    return "securityPolicyRuleResource." + error;
                            }
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly")) {
                                properties._validateOnly = 1;
                                if (typeof message.validateOnly !== "boolean")
                                    return "validateOnly: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchRuleSecurityPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchRuleSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchRuleSecurityPolicyRequest} PatchRuleSecurityPolicyRequest
                         */
                        PatchRuleSecurityPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchRuleSecurityPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchRuleSecurityPolicyRequest();
                            if (object.priority != null)
                                message.priority = object.priority | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.securityPolicy != null)
                                message.securityPolicy = String(object.securityPolicy);
                            if (object.securityPolicyRuleResource != null) {
                                if (typeof object.securityPolicyRuleResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchRuleSecurityPolicyRequest.securityPolicyRuleResource: object expected");
                                message.securityPolicyRuleResource = $root.google.cloud.compute.v1.SecurityPolicyRule.fromObject(object.securityPolicyRuleResource);
                            }
                            if (object.validateOnly != null)
                                message.validateOnly = Boolean(object.validateOnly);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchRuleSecurityPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchRuleSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchRuleSecurityPolicyRequest} message PatchRuleSecurityPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchRuleSecurityPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.securityPolicy = "";
                                object.project = "";
                                object.securityPolicyRuleResource = null;
                            }
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy"))
                                object.securityPolicy = message.securityPolicy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.validateOnly != null && message.hasOwnProperty("validateOnly")) {
                                object.validateOnly = message.validateOnly;
                                if (options.oneofs)
                                    object._validateOnly = "validateOnly";
                            }
                            if (message.securityPolicyRuleResource != null && message.hasOwnProperty("securityPolicyRuleResource"))
                                object.securityPolicyRuleResource = $root.google.cloud.compute.v1.SecurityPolicyRule.toObject(message.securityPolicyRuleResource, options);
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                object.priority = message.priority;
                                if (options.oneofs)
                                    object._priority = "priority";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PatchRuleSecurityPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchRuleSecurityPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchRuleSecurityPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchRuleSecurityPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchRuleSecurityPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchRuleSecurityPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchRuleSecurityPolicyRequest";
                        };
    
                        return PatchRuleSecurityPolicyRequest;
                    })();
    
                    v1.PatchSecurityPolicyRequest = (function() {
    
                        /**
                         * Properties of a PatchSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchSecurityPolicyRequest
                         * @property {string|null} [project] PatchSecurityPolicyRequest project
                         * @property {string|null} [requestId] PatchSecurityPolicyRequest requestId
                         * @property {string|null} [securityPolicy] PatchSecurityPolicyRequest securityPolicy
                         * @property {google.cloud.compute.v1.ISecurityPolicy|null} [securityPolicyResource] PatchSecurityPolicyRequest securityPolicyResource
                         */
    
                        /**
                         * Constructs a new PatchSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchSecurityPolicyRequest.
                         * @implements IPatchSecurityPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchSecurityPolicyRequest=} [properties] Properties to set
                         */
                        function PatchSecurityPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchSecurityPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchSecurityPolicyRequest
                         * @instance
                         */
                        PatchSecurityPolicyRequest.prototype.project = "";
    
                        /**
                         * PatchSecurityPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchSecurityPolicyRequest
                         * @instance
                         */
                        PatchSecurityPolicyRequest.prototype.requestId = null;
    
                        /**
                         * PatchSecurityPolicyRequest securityPolicy.
                         * @member {string} securityPolicy
                         * @memberof google.cloud.compute.v1.PatchSecurityPolicyRequest
                         * @instance
                         */
                        PatchSecurityPolicyRequest.prototype.securityPolicy = "";
    
                        /**
                         * PatchSecurityPolicyRequest securityPolicyResource.
                         * @member {google.cloud.compute.v1.ISecurityPolicy|null|undefined} securityPolicyResource
                         * @memberof google.cloud.compute.v1.PatchSecurityPolicyRequest
                         * @instance
                         */
                        PatchSecurityPolicyRequest.prototype.securityPolicyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchSecurityPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchSecurityPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(PatchSecurityPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchSecurityPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchSecurityPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchSecurityPolicyRequest} PatchSecurityPolicyRequest instance
                         */
                        PatchSecurityPolicyRequest.create = function create(properties) {
                            return new PatchSecurityPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchSecurityPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchSecurityPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchSecurityPolicyRequest} message PatchSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchSecurityPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.securityPolicy != null && Object.hasOwnProperty.call(message, "securityPolicy"))
                                writer.uint32(/* id 171082513, wireType 2 =*/1368660106).string(message.securityPolicy);
                            if (message.securityPolicyResource != null && Object.hasOwnProperty.call(message, "securityPolicyResource"))
                                $root.google.cloud.compute.v1.SecurityPolicy.encode(message.securityPolicyResource, writer.uint32(/* id 216159612, wireType 2 =*/1729276898).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchSecurityPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchSecurityPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchSecurityPolicyRequest} message PatchSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchSecurityPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchSecurityPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchSecurityPolicyRequest} PatchSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchSecurityPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchSecurityPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 171082513: {
                                        message.securityPolicy = reader.string();
                                        break;
                                    }
                                case 216159612: {
                                        message.securityPolicyResource = $root.google.cloud.compute.v1.SecurityPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchSecurityPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchSecurityPolicyRequest} PatchSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchSecurityPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchSecurityPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchSecurityPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy"))
                                if (!$util.isString(message.securityPolicy))
                                    return "securityPolicy: string expected";
                            if (message.securityPolicyResource != null && message.hasOwnProperty("securityPolicyResource")) {
                                var error = $root.google.cloud.compute.v1.SecurityPolicy.verify(message.securityPolicyResource);
                                if (error)
                                    return "securityPolicyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchSecurityPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchSecurityPolicyRequest} PatchSecurityPolicyRequest
                         */
                        PatchSecurityPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchSecurityPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchSecurityPolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.securityPolicy != null)
                                message.securityPolicy = String(object.securityPolicy);
                            if (object.securityPolicyResource != null) {
                                if (typeof object.securityPolicyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchSecurityPolicyRequest.securityPolicyResource: object expected");
                                message.securityPolicyResource = $root.google.cloud.compute.v1.SecurityPolicy.fromObject(object.securityPolicyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchSecurityPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchSecurityPolicyRequest} message PatchSecurityPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchSecurityPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.securityPolicy = "";
                                object.securityPolicyResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy"))
                                object.securityPolicy = message.securityPolicy;
                            if (message.securityPolicyResource != null && message.hasOwnProperty("securityPolicyResource"))
                                object.securityPolicyResource = $root.google.cloud.compute.v1.SecurityPolicy.toObject(message.securityPolicyResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this PatchSecurityPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchSecurityPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchSecurityPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchSecurityPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchSecurityPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchSecurityPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchSecurityPolicyRequest";
                        };
    
                        return PatchSecurityPolicyRequest;
                    })();
    
                    v1.PatchServiceAttachmentRequest = (function() {
    
                        /**
                         * Properties of a PatchServiceAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchServiceAttachmentRequest
                         * @property {string|null} [project] PatchServiceAttachmentRequest project
                         * @property {string|null} [region] PatchServiceAttachmentRequest region
                         * @property {string|null} [requestId] PatchServiceAttachmentRequest requestId
                         * @property {string|null} [serviceAttachment] PatchServiceAttachmentRequest serviceAttachment
                         * @property {google.cloud.compute.v1.IServiceAttachment|null} [serviceAttachmentResource] PatchServiceAttachmentRequest serviceAttachmentResource
                         */
    
                        /**
                         * Constructs a new PatchServiceAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchServiceAttachmentRequest.
                         * @implements IPatchServiceAttachmentRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchServiceAttachmentRequest=} [properties] Properties to set
                         */
                        function PatchServiceAttachmentRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchServiceAttachmentRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchServiceAttachmentRequest
                         * @instance
                         */
                        PatchServiceAttachmentRequest.prototype.project = "";
    
                        /**
                         * PatchServiceAttachmentRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PatchServiceAttachmentRequest
                         * @instance
                         */
                        PatchServiceAttachmentRequest.prototype.region = "";
    
                        /**
                         * PatchServiceAttachmentRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchServiceAttachmentRequest
                         * @instance
                         */
                        PatchServiceAttachmentRequest.prototype.requestId = null;
    
                        /**
                         * PatchServiceAttachmentRequest serviceAttachment.
                         * @member {string} serviceAttachment
                         * @memberof google.cloud.compute.v1.PatchServiceAttachmentRequest
                         * @instance
                         */
                        PatchServiceAttachmentRequest.prototype.serviceAttachment = "";
    
                        /**
                         * PatchServiceAttachmentRequest serviceAttachmentResource.
                         * @member {google.cloud.compute.v1.IServiceAttachment|null|undefined} serviceAttachmentResource
                         * @memberof google.cloud.compute.v1.PatchServiceAttachmentRequest
                         * @instance
                         */
                        PatchServiceAttachmentRequest.prototype.serviceAttachmentResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchServiceAttachmentRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchServiceAttachmentRequest
                         * @instance
                         */
                        Object.defineProperty(PatchServiceAttachmentRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchServiceAttachmentRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchServiceAttachmentRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchServiceAttachmentRequest} PatchServiceAttachmentRequest instance
                         */
                        PatchServiceAttachmentRequest.create = function create(properties) {
                            return new PatchServiceAttachmentRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchServiceAttachmentRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchServiceAttachmentRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchServiceAttachmentRequest} message PatchServiceAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchServiceAttachmentRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.serviceAttachment != null && Object.hasOwnProperty.call(message, "serviceAttachment"))
                                writer.uint32(/* id 338957549, wireType 2 =*/2711660394).string(message.serviceAttachment);
                            if (message.serviceAttachmentResource != null && Object.hasOwnProperty.call(message, "serviceAttachmentResource"))
                                $root.google.cloud.compute.v1.ServiceAttachment.encode(message.serviceAttachmentResource, writer.uint32(/* id 472980256, wireType 2 =*/3783842050).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchServiceAttachmentRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchServiceAttachmentRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchServiceAttachmentRequest} message PatchServiceAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchServiceAttachmentRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchServiceAttachmentRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchServiceAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchServiceAttachmentRequest} PatchServiceAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchServiceAttachmentRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchServiceAttachmentRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 338957549: {
                                        message.serviceAttachment = reader.string();
                                        break;
                                    }
                                case 472980256: {
                                        message.serviceAttachmentResource = $root.google.cloud.compute.v1.ServiceAttachment.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchServiceAttachmentRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchServiceAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchServiceAttachmentRequest} PatchServiceAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchServiceAttachmentRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchServiceAttachmentRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchServiceAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchServiceAttachmentRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.serviceAttachment != null && message.hasOwnProperty("serviceAttachment"))
                                if (!$util.isString(message.serviceAttachment))
                                    return "serviceAttachment: string expected";
                            if (message.serviceAttachmentResource != null && message.hasOwnProperty("serviceAttachmentResource")) {
                                var error = $root.google.cloud.compute.v1.ServiceAttachment.verify(message.serviceAttachmentResource);
                                if (error)
                                    return "serviceAttachmentResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchServiceAttachmentRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchServiceAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchServiceAttachmentRequest} PatchServiceAttachmentRequest
                         */
                        PatchServiceAttachmentRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchServiceAttachmentRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchServiceAttachmentRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.serviceAttachment != null)
                                message.serviceAttachment = String(object.serviceAttachment);
                            if (object.serviceAttachmentResource != null) {
                                if (typeof object.serviceAttachmentResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchServiceAttachmentRequest.serviceAttachmentResource: object expected");
                                message.serviceAttachmentResource = $root.google.cloud.compute.v1.ServiceAttachment.fromObject(object.serviceAttachmentResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchServiceAttachmentRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchServiceAttachmentRequest} message PatchServiceAttachmentRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchServiceAttachmentRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.serviceAttachment = "";
                                object.serviceAttachmentResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.serviceAttachment != null && message.hasOwnProperty("serviceAttachment"))
                                object.serviceAttachment = message.serviceAttachment;
                            if (message.serviceAttachmentResource != null && message.hasOwnProperty("serviceAttachmentResource"))
                                object.serviceAttachmentResource = $root.google.cloud.compute.v1.ServiceAttachment.toObject(message.serviceAttachmentResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this PatchServiceAttachmentRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchServiceAttachmentRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchServiceAttachmentRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchServiceAttachmentRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchServiceAttachmentRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchServiceAttachmentRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchServiceAttachmentRequest";
                        };
    
                        return PatchServiceAttachmentRequest;
                    })();
    
                    v1.PatchSslPolicyRequest = (function() {
    
                        /**
                         * Properties of a PatchSslPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchSslPolicyRequest
                         * @property {string|null} [project] PatchSslPolicyRequest project
                         * @property {string|null} [requestId] PatchSslPolicyRequest requestId
                         * @property {string|null} [sslPolicy] PatchSslPolicyRequest sslPolicy
                         * @property {google.cloud.compute.v1.ISslPolicy|null} [sslPolicyResource] PatchSslPolicyRequest sslPolicyResource
                         */
    
                        /**
                         * Constructs a new PatchSslPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchSslPolicyRequest.
                         * @implements IPatchSslPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchSslPolicyRequest=} [properties] Properties to set
                         */
                        function PatchSslPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchSslPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchSslPolicyRequest
                         * @instance
                         */
                        PatchSslPolicyRequest.prototype.project = "";
    
                        /**
                         * PatchSslPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchSslPolicyRequest
                         * @instance
                         */
                        PatchSslPolicyRequest.prototype.requestId = null;
    
                        /**
                         * PatchSslPolicyRequest sslPolicy.
                         * @member {string} sslPolicy
                         * @memberof google.cloud.compute.v1.PatchSslPolicyRequest
                         * @instance
                         */
                        PatchSslPolicyRequest.prototype.sslPolicy = "";
    
                        /**
                         * PatchSslPolicyRequest sslPolicyResource.
                         * @member {google.cloud.compute.v1.ISslPolicy|null|undefined} sslPolicyResource
                         * @memberof google.cloud.compute.v1.PatchSslPolicyRequest
                         * @instance
                         */
                        PatchSslPolicyRequest.prototype.sslPolicyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchSslPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchSslPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(PatchSslPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchSslPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchSslPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchSslPolicyRequest} PatchSslPolicyRequest instance
                         */
                        PatchSslPolicyRequest.create = function create(properties) {
                            return new PatchSslPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchSslPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchSslPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchSslPolicyRequest} message PatchSslPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchSslPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.sslPolicyResource != null && Object.hasOwnProperty.call(message, "sslPolicyResource"))
                                $root.google.cloud.compute.v1.SslPolicy.encode(message.sslPolicyResource, writer.uint32(/* id 274891848, wireType 2 =*/2199134786).fork()).ldelim();
                            if (message.sslPolicy != null && Object.hasOwnProperty.call(message, "sslPolicy"))
                                writer.uint32(/* id 295190213, wireType 2 =*/2361521706).string(message.sslPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchSslPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchSslPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchSslPolicyRequest} message PatchSslPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchSslPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchSslPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchSslPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchSslPolicyRequest} PatchSslPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchSslPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchSslPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 295190213: {
                                        message.sslPolicy = reader.string();
                                        break;
                                    }
                                case 274891848: {
                                        message.sslPolicyResource = $root.google.cloud.compute.v1.SslPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchSslPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchSslPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchSslPolicyRequest} PatchSslPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchSslPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchSslPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchSslPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchSslPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.sslPolicy != null && message.hasOwnProperty("sslPolicy"))
                                if (!$util.isString(message.sslPolicy))
                                    return "sslPolicy: string expected";
                            if (message.sslPolicyResource != null && message.hasOwnProperty("sslPolicyResource")) {
                                var error = $root.google.cloud.compute.v1.SslPolicy.verify(message.sslPolicyResource);
                                if (error)
                                    return "sslPolicyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchSslPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchSslPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchSslPolicyRequest} PatchSslPolicyRequest
                         */
                        PatchSslPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchSslPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchSslPolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.sslPolicy != null)
                                message.sslPolicy = String(object.sslPolicy);
                            if (object.sslPolicyResource != null) {
                                if (typeof object.sslPolicyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchSslPolicyRequest.sslPolicyResource: object expected");
                                message.sslPolicyResource = $root.google.cloud.compute.v1.SslPolicy.fromObject(object.sslPolicyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchSslPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchSslPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchSslPolicyRequest} message PatchSslPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchSslPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.sslPolicyResource = null;
                                object.sslPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.sslPolicyResource != null && message.hasOwnProperty("sslPolicyResource"))
                                object.sslPolicyResource = $root.google.cloud.compute.v1.SslPolicy.toObject(message.sslPolicyResource, options);
                            if (message.sslPolicy != null && message.hasOwnProperty("sslPolicy"))
                                object.sslPolicy = message.sslPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this PatchSslPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchSslPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchSslPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchSslPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchSslPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchSslPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchSslPolicyRequest";
                        };
    
                        return PatchSslPolicyRequest;
                    })();
    
                    v1.PatchSubnetworkRequest = (function() {
    
                        /**
                         * Properties of a PatchSubnetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchSubnetworkRequest
                         * @property {number|null} [drainTimeoutSeconds] PatchSubnetworkRequest drainTimeoutSeconds
                         * @property {string|null} [project] PatchSubnetworkRequest project
                         * @property {string|null} [region] PatchSubnetworkRequest region
                         * @property {string|null} [requestId] PatchSubnetworkRequest requestId
                         * @property {string|null} [subnetwork] PatchSubnetworkRequest subnetwork
                         * @property {google.cloud.compute.v1.ISubnetwork|null} [subnetworkResource] PatchSubnetworkRequest subnetworkResource
                         */
    
                        /**
                         * Constructs a new PatchSubnetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchSubnetworkRequest.
                         * @implements IPatchSubnetworkRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchSubnetworkRequest=} [properties] Properties to set
                         */
                        function PatchSubnetworkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchSubnetworkRequest drainTimeoutSeconds.
                         * @member {number|null|undefined} drainTimeoutSeconds
                         * @memberof google.cloud.compute.v1.PatchSubnetworkRequest
                         * @instance
                         */
                        PatchSubnetworkRequest.prototype.drainTimeoutSeconds = null;
    
                        /**
                         * PatchSubnetworkRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchSubnetworkRequest
                         * @instance
                         */
                        PatchSubnetworkRequest.prototype.project = "";
    
                        /**
                         * PatchSubnetworkRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PatchSubnetworkRequest
                         * @instance
                         */
                        PatchSubnetworkRequest.prototype.region = "";
    
                        /**
                         * PatchSubnetworkRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchSubnetworkRequest
                         * @instance
                         */
                        PatchSubnetworkRequest.prototype.requestId = null;
    
                        /**
                         * PatchSubnetworkRequest subnetwork.
                         * @member {string} subnetwork
                         * @memberof google.cloud.compute.v1.PatchSubnetworkRequest
                         * @instance
                         */
                        PatchSubnetworkRequest.prototype.subnetwork = "";
    
                        /**
                         * PatchSubnetworkRequest subnetworkResource.
                         * @member {google.cloud.compute.v1.ISubnetwork|null|undefined} subnetworkResource
                         * @memberof google.cloud.compute.v1.PatchSubnetworkRequest
                         * @instance
                         */
                        PatchSubnetworkRequest.prototype.subnetworkResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchSubnetworkRequest _drainTimeoutSeconds.
                         * @member {"drainTimeoutSeconds"|undefined} _drainTimeoutSeconds
                         * @memberof google.cloud.compute.v1.PatchSubnetworkRequest
                         * @instance
                         */
                        Object.defineProperty(PatchSubnetworkRequest.prototype, "_drainTimeoutSeconds", {
                            get: $util.oneOfGetter($oneOfFields = ["drainTimeoutSeconds"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PatchSubnetworkRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchSubnetworkRequest
                         * @instance
                         */
                        Object.defineProperty(PatchSubnetworkRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchSubnetworkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchSubnetworkRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchSubnetworkRequest} PatchSubnetworkRequest instance
                         */
                        PatchSubnetworkRequest.create = function create(properties) {
                            return new PatchSubnetworkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchSubnetworkRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchSubnetworkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchSubnetworkRequest} message PatchSubnetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchSubnetworkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.subnetworkResource != null && Object.hasOwnProperty.call(message, "subnetworkResource"))
                                $root.google.cloud.compute.v1.Subnetwork.encode(message.subnetworkResource, writer.uint32(/* id 42233151, wireType 2 =*/337865210).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.subnetwork != null && Object.hasOwnProperty.call(message, "subnetwork"))
                                writer.uint32(/* id 307827694, wireType 2 =*/2462621554).string(message.subnetwork);
                            if (message.drainTimeoutSeconds != null && Object.hasOwnProperty.call(message, "drainTimeoutSeconds"))
                                writer.uint32(/* id 357707098, wireType 0 =*/2861656784).int32(message.drainTimeoutSeconds);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchSubnetworkRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchSubnetworkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchSubnetworkRequest} message PatchSubnetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchSubnetworkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchSubnetworkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchSubnetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchSubnetworkRequest} PatchSubnetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchSubnetworkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchSubnetworkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 357707098: {
                                        message.drainTimeoutSeconds = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 307827694: {
                                        message.subnetwork = reader.string();
                                        break;
                                    }
                                case 42233151: {
                                        message.subnetworkResource = $root.google.cloud.compute.v1.Subnetwork.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchSubnetworkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchSubnetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchSubnetworkRequest} PatchSubnetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchSubnetworkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchSubnetworkRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchSubnetworkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchSubnetworkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.drainTimeoutSeconds != null && message.hasOwnProperty("drainTimeoutSeconds")) {
                                properties._drainTimeoutSeconds = 1;
                                if (!$util.isInteger(message.drainTimeoutSeconds))
                                    return "drainTimeoutSeconds: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork"))
                                if (!$util.isString(message.subnetwork))
                                    return "subnetwork: string expected";
                            if (message.subnetworkResource != null && message.hasOwnProperty("subnetworkResource")) {
                                var error = $root.google.cloud.compute.v1.Subnetwork.verify(message.subnetworkResource);
                                if (error)
                                    return "subnetworkResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchSubnetworkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchSubnetworkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchSubnetworkRequest} PatchSubnetworkRequest
                         */
                        PatchSubnetworkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchSubnetworkRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchSubnetworkRequest();
                            if (object.drainTimeoutSeconds != null)
                                message.drainTimeoutSeconds = object.drainTimeoutSeconds | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.subnetwork != null)
                                message.subnetwork = String(object.subnetwork);
                            if (object.subnetworkResource != null) {
                                if (typeof object.subnetworkResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchSubnetworkRequest.subnetworkResource: object expected");
                                message.subnetworkResource = $root.google.cloud.compute.v1.Subnetwork.fromObject(object.subnetworkResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchSubnetworkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchSubnetworkRequest} message PatchSubnetworkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchSubnetworkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.subnetworkResource = null;
                                object.region = "";
                                object.project = "";
                                object.subnetwork = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.subnetworkResource != null && message.hasOwnProperty("subnetworkResource"))
                                object.subnetworkResource = $root.google.cloud.compute.v1.Subnetwork.toObject(message.subnetworkResource, options);
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork"))
                                object.subnetwork = message.subnetwork;
                            if (message.drainTimeoutSeconds != null && message.hasOwnProperty("drainTimeoutSeconds")) {
                                object.drainTimeoutSeconds = message.drainTimeoutSeconds;
                                if (options.oneofs)
                                    object._drainTimeoutSeconds = "drainTimeoutSeconds";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PatchSubnetworkRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchSubnetworkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchSubnetworkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchSubnetworkRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchSubnetworkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchSubnetworkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchSubnetworkRequest";
                        };
    
                        return PatchSubnetworkRequest;
                    })();
    
                    v1.PatchTargetGrpcProxyRequest = (function() {
    
                        /**
                         * Properties of a PatchTargetGrpcProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchTargetGrpcProxyRequest
                         * @property {string|null} [project] PatchTargetGrpcProxyRequest project
                         * @property {string|null} [requestId] PatchTargetGrpcProxyRequest requestId
                         * @property {string|null} [targetGrpcProxy] PatchTargetGrpcProxyRequest targetGrpcProxy
                         * @property {google.cloud.compute.v1.ITargetGrpcProxy|null} [targetGrpcProxyResource] PatchTargetGrpcProxyRequest targetGrpcProxyResource
                         */
    
                        /**
                         * Constructs a new PatchTargetGrpcProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchTargetGrpcProxyRequest.
                         * @implements IPatchTargetGrpcProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchTargetGrpcProxyRequest=} [properties] Properties to set
                         */
                        function PatchTargetGrpcProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchTargetGrpcProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchTargetGrpcProxyRequest
                         * @instance
                         */
                        PatchTargetGrpcProxyRequest.prototype.project = "";
    
                        /**
                         * PatchTargetGrpcProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchTargetGrpcProxyRequest
                         * @instance
                         */
                        PatchTargetGrpcProxyRequest.prototype.requestId = null;
    
                        /**
                         * PatchTargetGrpcProxyRequest targetGrpcProxy.
                         * @member {string} targetGrpcProxy
                         * @memberof google.cloud.compute.v1.PatchTargetGrpcProxyRequest
                         * @instance
                         */
                        PatchTargetGrpcProxyRequest.prototype.targetGrpcProxy = "";
    
                        /**
                         * PatchTargetGrpcProxyRequest targetGrpcProxyResource.
                         * @member {google.cloud.compute.v1.ITargetGrpcProxy|null|undefined} targetGrpcProxyResource
                         * @memberof google.cloud.compute.v1.PatchTargetGrpcProxyRequest
                         * @instance
                         */
                        PatchTargetGrpcProxyRequest.prototype.targetGrpcProxyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchTargetGrpcProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchTargetGrpcProxyRequest
                         * @instance
                         */
                        Object.defineProperty(PatchTargetGrpcProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchTargetGrpcProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchTargetGrpcProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchTargetGrpcProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchTargetGrpcProxyRequest} PatchTargetGrpcProxyRequest instance
                         */
                        PatchTargetGrpcProxyRequest.create = function create(properties) {
                            return new PatchTargetGrpcProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchTargetGrpcProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchTargetGrpcProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchTargetGrpcProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchTargetGrpcProxyRequest} message PatchTargetGrpcProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchTargetGrpcProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetGrpcProxy != null && Object.hasOwnProperty.call(message, "targetGrpcProxy"))
                                writer.uint32(/* id 5020283, wireType 2 =*/40162266).string(message.targetGrpcProxy);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetGrpcProxyResource != null && Object.hasOwnProperty.call(message, "targetGrpcProxyResource"))
                                $root.google.cloud.compute.v1.TargetGrpcProxy.encode(message.targetGrpcProxyResource, writer.uint32(/* id 328922450, wireType 2 =*/2631379602).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchTargetGrpcProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchTargetGrpcProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchTargetGrpcProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchTargetGrpcProxyRequest} message PatchTargetGrpcProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchTargetGrpcProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchTargetGrpcProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchTargetGrpcProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchTargetGrpcProxyRequest} PatchTargetGrpcProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchTargetGrpcProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchTargetGrpcProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 5020283: {
                                        message.targetGrpcProxy = reader.string();
                                        break;
                                    }
                                case 328922450: {
                                        message.targetGrpcProxyResource = $root.google.cloud.compute.v1.TargetGrpcProxy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchTargetGrpcProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchTargetGrpcProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchTargetGrpcProxyRequest} PatchTargetGrpcProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchTargetGrpcProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchTargetGrpcProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchTargetGrpcProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchTargetGrpcProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetGrpcProxy != null && message.hasOwnProperty("targetGrpcProxy"))
                                if (!$util.isString(message.targetGrpcProxy))
                                    return "targetGrpcProxy: string expected";
                            if (message.targetGrpcProxyResource != null && message.hasOwnProperty("targetGrpcProxyResource")) {
                                var error = $root.google.cloud.compute.v1.TargetGrpcProxy.verify(message.targetGrpcProxyResource);
                                if (error)
                                    return "targetGrpcProxyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchTargetGrpcProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchTargetGrpcProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchTargetGrpcProxyRequest} PatchTargetGrpcProxyRequest
                         */
                        PatchTargetGrpcProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchTargetGrpcProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchTargetGrpcProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetGrpcProxy != null)
                                message.targetGrpcProxy = String(object.targetGrpcProxy);
                            if (object.targetGrpcProxyResource != null) {
                                if (typeof object.targetGrpcProxyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchTargetGrpcProxyRequest.targetGrpcProxyResource: object expected");
                                message.targetGrpcProxyResource = $root.google.cloud.compute.v1.TargetGrpcProxy.fromObject(object.targetGrpcProxyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchTargetGrpcProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchTargetGrpcProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchTargetGrpcProxyRequest} message PatchTargetGrpcProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchTargetGrpcProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetGrpcProxy = "";
                                object.project = "";
                                object.targetGrpcProxyResource = null;
                            }
                            if (message.targetGrpcProxy != null && message.hasOwnProperty("targetGrpcProxy"))
                                object.targetGrpcProxy = message.targetGrpcProxy;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetGrpcProxyResource != null && message.hasOwnProperty("targetGrpcProxyResource"))
                                object.targetGrpcProxyResource = $root.google.cloud.compute.v1.TargetGrpcProxy.toObject(message.targetGrpcProxyResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this PatchTargetGrpcProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchTargetGrpcProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchTargetGrpcProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchTargetGrpcProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchTargetGrpcProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchTargetGrpcProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchTargetGrpcProxyRequest";
                        };
    
                        return PatchTargetGrpcProxyRequest;
                    })();
    
                    v1.PatchTargetHttpProxyRequest = (function() {
    
                        /**
                         * Properties of a PatchTargetHttpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchTargetHttpProxyRequest
                         * @property {string|null} [project] PatchTargetHttpProxyRequest project
                         * @property {string|null} [requestId] PatchTargetHttpProxyRequest requestId
                         * @property {string|null} [targetHttpProxy] PatchTargetHttpProxyRequest targetHttpProxy
                         * @property {google.cloud.compute.v1.ITargetHttpProxy|null} [targetHttpProxyResource] PatchTargetHttpProxyRequest targetHttpProxyResource
                         */
    
                        /**
                         * Constructs a new PatchTargetHttpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchTargetHttpProxyRequest.
                         * @implements IPatchTargetHttpProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchTargetHttpProxyRequest=} [properties] Properties to set
                         */
                        function PatchTargetHttpProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchTargetHttpProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchTargetHttpProxyRequest
                         * @instance
                         */
                        PatchTargetHttpProxyRequest.prototype.project = "";
    
                        /**
                         * PatchTargetHttpProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchTargetHttpProxyRequest
                         * @instance
                         */
                        PatchTargetHttpProxyRequest.prototype.requestId = null;
    
                        /**
                         * PatchTargetHttpProxyRequest targetHttpProxy.
                         * @member {string} targetHttpProxy
                         * @memberof google.cloud.compute.v1.PatchTargetHttpProxyRequest
                         * @instance
                         */
                        PatchTargetHttpProxyRequest.prototype.targetHttpProxy = "";
    
                        /**
                         * PatchTargetHttpProxyRequest targetHttpProxyResource.
                         * @member {google.cloud.compute.v1.ITargetHttpProxy|null|undefined} targetHttpProxyResource
                         * @memberof google.cloud.compute.v1.PatchTargetHttpProxyRequest
                         * @instance
                         */
                        PatchTargetHttpProxyRequest.prototype.targetHttpProxyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchTargetHttpProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchTargetHttpProxyRequest
                         * @instance
                         */
                        Object.defineProperty(PatchTargetHttpProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchTargetHttpProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchTargetHttpProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchTargetHttpProxyRequest} PatchTargetHttpProxyRequest instance
                         */
                        PatchTargetHttpProxyRequest.create = function create(properties) {
                            return new PatchTargetHttpProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchTargetHttpProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchTargetHttpProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchTargetHttpProxyRequest} message PatchTargetHttpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchTargetHttpProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetHttpProxyResource != null && Object.hasOwnProperty.call(message, "targetHttpProxyResource"))
                                $root.google.cloud.compute.v1.TargetHttpProxy.encode(message.targetHttpProxyResource, writer.uint32(/* id 24696744, wireType 2 =*/197573954).fork()).ldelim();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetHttpProxy != null && Object.hasOwnProperty.call(message, "targetHttpProxy"))
                                writer.uint32(/* id 206872421, wireType 2 =*/1654979370).string(message.targetHttpProxy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchTargetHttpProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchTargetHttpProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchTargetHttpProxyRequest} message PatchTargetHttpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchTargetHttpProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchTargetHttpProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchTargetHttpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchTargetHttpProxyRequest} PatchTargetHttpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchTargetHttpProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchTargetHttpProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 206872421: {
                                        message.targetHttpProxy = reader.string();
                                        break;
                                    }
                                case 24696744: {
                                        message.targetHttpProxyResource = $root.google.cloud.compute.v1.TargetHttpProxy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchTargetHttpProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchTargetHttpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchTargetHttpProxyRequest} PatchTargetHttpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchTargetHttpProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchTargetHttpProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchTargetHttpProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchTargetHttpProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetHttpProxy != null && message.hasOwnProperty("targetHttpProxy"))
                                if (!$util.isString(message.targetHttpProxy))
                                    return "targetHttpProxy: string expected";
                            if (message.targetHttpProxyResource != null && message.hasOwnProperty("targetHttpProxyResource")) {
                                var error = $root.google.cloud.compute.v1.TargetHttpProxy.verify(message.targetHttpProxyResource);
                                if (error)
                                    return "targetHttpProxyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchTargetHttpProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchTargetHttpProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchTargetHttpProxyRequest} PatchTargetHttpProxyRequest
                         */
                        PatchTargetHttpProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchTargetHttpProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchTargetHttpProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetHttpProxy != null)
                                message.targetHttpProxy = String(object.targetHttpProxy);
                            if (object.targetHttpProxyResource != null) {
                                if (typeof object.targetHttpProxyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchTargetHttpProxyRequest.targetHttpProxyResource: object expected");
                                message.targetHttpProxyResource = $root.google.cloud.compute.v1.TargetHttpProxy.fromObject(object.targetHttpProxyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchTargetHttpProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchTargetHttpProxyRequest} message PatchTargetHttpProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchTargetHttpProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetHttpProxyResource = null;
                                object.targetHttpProxy = "";
                                object.project = "";
                            }
                            if (message.targetHttpProxyResource != null && message.hasOwnProperty("targetHttpProxyResource"))
                                object.targetHttpProxyResource = $root.google.cloud.compute.v1.TargetHttpProxy.toObject(message.targetHttpProxyResource, options);
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetHttpProxy != null && message.hasOwnProperty("targetHttpProxy"))
                                object.targetHttpProxy = message.targetHttpProxy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this PatchTargetHttpProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchTargetHttpProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchTargetHttpProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchTargetHttpProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchTargetHttpProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchTargetHttpProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchTargetHttpProxyRequest";
                        };
    
                        return PatchTargetHttpProxyRequest;
                    })();
    
                    v1.PatchTargetHttpsProxyRequest = (function() {
    
                        /**
                         * Properties of a PatchTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchTargetHttpsProxyRequest
                         * @property {string|null} [project] PatchTargetHttpsProxyRequest project
                         * @property {string|null} [requestId] PatchTargetHttpsProxyRequest requestId
                         * @property {string|null} [targetHttpsProxy] PatchTargetHttpsProxyRequest targetHttpsProxy
                         * @property {google.cloud.compute.v1.ITargetHttpsProxy|null} [targetHttpsProxyResource] PatchTargetHttpsProxyRequest targetHttpsProxyResource
                         */
    
                        /**
                         * Constructs a new PatchTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchTargetHttpsProxyRequest.
                         * @implements IPatchTargetHttpsProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchTargetHttpsProxyRequest=} [properties] Properties to set
                         */
                        function PatchTargetHttpsProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchTargetHttpsProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchTargetHttpsProxyRequest
                         * @instance
                         */
                        PatchTargetHttpsProxyRequest.prototype.project = "";
    
                        /**
                         * PatchTargetHttpsProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchTargetHttpsProxyRequest
                         * @instance
                         */
                        PatchTargetHttpsProxyRequest.prototype.requestId = null;
    
                        /**
                         * PatchTargetHttpsProxyRequest targetHttpsProxy.
                         * @member {string} targetHttpsProxy
                         * @memberof google.cloud.compute.v1.PatchTargetHttpsProxyRequest
                         * @instance
                         */
                        PatchTargetHttpsProxyRequest.prototype.targetHttpsProxy = "";
    
                        /**
                         * PatchTargetHttpsProxyRequest targetHttpsProxyResource.
                         * @member {google.cloud.compute.v1.ITargetHttpsProxy|null|undefined} targetHttpsProxyResource
                         * @memberof google.cloud.compute.v1.PatchTargetHttpsProxyRequest
                         * @instance
                         */
                        PatchTargetHttpsProxyRequest.prototype.targetHttpsProxyResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchTargetHttpsProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchTargetHttpsProxyRequest
                         * @instance
                         */
                        Object.defineProperty(PatchTargetHttpsProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchTargetHttpsProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchTargetHttpsProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchTargetHttpsProxyRequest} PatchTargetHttpsProxyRequest instance
                         */
                        PatchTargetHttpsProxyRequest.create = function create(properties) {
                            return new PatchTargetHttpsProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchTargetHttpsProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchTargetHttpsProxyRequest} message PatchTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchTargetHttpsProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetHttpsProxy != null && Object.hasOwnProperty.call(message, "targetHttpsProxy"))
                                writer.uint32(/* id 52336748, wireType 2 =*/418693986).string(message.targetHttpsProxy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetHttpsProxyResource != null && Object.hasOwnProperty.call(message, "targetHttpsProxyResource"))
                                $root.google.cloud.compute.v1.TargetHttpsProxy.encode(message.targetHttpsProxyResource, writer.uint32(/* id 433657473, wireType 2 =*/3469259786).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchTargetHttpsProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchTargetHttpsProxyRequest} message PatchTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchTargetHttpsProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchTargetHttpsProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchTargetHttpsProxyRequest} PatchTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchTargetHttpsProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchTargetHttpsProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 52336748: {
                                        message.targetHttpsProxy = reader.string();
                                        break;
                                    }
                                case 433657473: {
                                        message.targetHttpsProxyResource = $root.google.cloud.compute.v1.TargetHttpsProxy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchTargetHttpsProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchTargetHttpsProxyRequest} PatchTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchTargetHttpsProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchTargetHttpsProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchTargetHttpsProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                if (!$util.isString(message.targetHttpsProxy))
                                    return "targetHttpsProxy: string expected";
                            if (message.targetHttpsProxyResource != null && message.hasOwnProperty("targetHttpsProxyResource")) {
                                var error = $root.google.cloud.compute.v1.TargetHttpsProxy.verify(message.targetHttpsProxyResource);
                                if (error)
                                    return "targetHttpsProxyResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchTargetHttpsProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchTargetHttpsProxyRequest} PatchTargetHttpsProxyRequest
                         */
                        PatchTargetHttpsProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchTargetHttpsProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchTargetHttpsProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetHttpsProxy != null)
                                message.targetHttpsProxy = String(object.targetHttpsProxy);
                            if (object.targetHttpsProxyResource != null) {
                                if (typeof object.targetHttpsProxyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchTargetHttpsProxyRequest.targetHttpsProxyResource: object expected");
                                message.targetHttpsProxyResource = $root.google.cloud.compute.v1.TargetHttpsProxy.fromObject(object.targetHttpsProxyResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchTargetHttpsProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchTargetHttpsProxyRequest} message PatchTargetHttpsProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchTargetHttpsProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetHttpsProxy = "";
                                object.project = "";
                                object.targetHttpsProxyResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                object.targetHttpsProxy = message.targetHttpsProxy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetHttpsProxyResource != null && message.hasOwnProperty("targetHttpsProxyResource"))
                                object.targetHttpsProxyResource = $root.google.cloud.compute.v1.TargetHttpsProxy.toObject(message.targetHttpsProxyResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this PatchTargetHttpsProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchTargetHttpsProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchTargetHttpsProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchTargetHttpsProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchTargetHttpsProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchTargetHttpsProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchTargetHttpsProxyRequest";
                        };
    
                        return PatchTargetHttpsProxyRequest;
                    })();
    
                    v1.PatchUrlMapRequest = (function() {
    
                        /**
                         * Properties of a PatchUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPatchUrlMapRequest
                         * @property {string|null} [project] PatchUrlMapRequest project
                         * @property {string|null} [requestId] PatchUrlMapRequest requestId
                         * @property {string|null} [urlMap] PatchUrlMapRequest urlMap
                         * @property {google.cloud.compute.v1.IUrlMap|null} [urlMapResource] PatchUrlMapRequest urlMapResource
                         */
    
                        /**
                         * Constructs a new PatchUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PatchUrlMapRequest.
                         * @implements IPatchUrlMapRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPatchUrlMapRequest=} [properties] Properties to set
                         */
                        function PatchUrlMapRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PatchUrlMapRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PatchUrlMapRequest
                         * @instance
                         */
                        PatchUrlMapRequest.prototype.project = "";
    
                        /**
                         * PatchUrlMapRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.PatchUrlMapRequest
                         * @instance
                         */
                        PatchUrlMapRequest.prototype.requestId = null;
    
                        /**
                         * PatchUrlMapRequest urlMap.
                         * @member {string} urlMap
                         * @memberof google.cloud.compute.v1.PatchUrlMapRequest
                         * @instance
                         */
                        PatchUrlMapRequest.prototype.urlMap = "";
    
                        /**
                         * PatchUrlMapRequest urlMapResource.
                         * @member {google.cloud.compute.v1.IUrlMap|null|undefined} urlMapResource
                         * @memberof google.cloud.compute.v1.PatchUrlMapRequest
                         * @instance
                         */
                        PatchUrlMapRequest.prototype.urlMapResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PatchUrlMapRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.PatchUrlMapRequest
                         * @instance
                         */
                        Object.defineProperty(PatchUrlMapRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PatchUrlMapRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PatchUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchUrlMapRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PatchUrlMapRequest} PatchUrlMapRequest instance
                         */
                        PatchUrlMapRequest.create = function create(properties) {
                            return new PatchUrlMapRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PatchUrlMapRequest message. Does not implicitly {@link google.cloud.compute.v1.PatchUrlMapRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PatchUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchUrlMapRequest} message PatchUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchUrlMapRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.urlMapResource != null && Object.hasOwnProperty.call(message, "urlMapResource"))
                                $root.google.cloud.compute.v1.UrlMap.encode(message.urlMapResource, writer.uint32(/* id 168675425, wireType 2 =*/1349403402).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.urlMap != null && Object.hasOwnProperty.call(message, "urlMap"))
                                writer.uint32(/* id 367020684, wireType 2 =*/2936165474).string(message.urlMap);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PatchUrlMapRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PatchUrlMapRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PatchUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPatchUrlMapRequest} message PatchUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PatchUrlMapRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PatchUrlMapRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PatchUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PatchUrlMapRequest} PatchUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchUrlMapRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PatchUrlMapRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 367020684: {
                                        message.urlMap = reader.string();
                                        break;
                                    }
                                case 168675425: {
                                        message.urlMapResource = $root.google.cloud.compute.v1.UrlMap.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PatchUrlMapRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PatchUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PatchUrlMapRequest} PatchUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PatchUrlMapRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PatchUrlMapRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PatchUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PatchUrlMapRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                if (!$util.isString(message.urlMap))
                                    return "urlMap: string expected";
                            if (message.urlMapResource != null && message.hasOwnProperty("urlMapResource")) {
                                var error = $root.google.cloud.compute.v1.UrlMap.verify(message.urlMapResource);
                                if (error)
                                    return "urlMapResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PatchUrlMapRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PatchUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PatchUrlMapRequest} PatchUrlMapRequest
                         */
                        PatchUrlMapRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PatchUrlMapRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PatchUrlMapRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.urlMap != null)
                                message.urlMap = String(object.urlMap);
                            if (object.urlMapResource != null) {
                                if (typeof object.urlMapResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PatchUrlMapRequest.urlMapResource: object expected");
                                message.urlMapResource = $root.google.cloud.compute.v1.UrlMap.fromObject(object.urlMapResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PatchUrlMapRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PatchUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.PatchUrlMapRequest} message PatchUrlMapRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PatchUrlMapRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.urlMapResource = null;
                                object.project = "";
                                object.urlMap = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.urlMapResource != null && message.hasOwnProperty("urlMapResource"))
                                object.urlMapResource = $root.google.cloud.compute.v1.UrlMap.toObject(message.urlMapResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                object.urlMap = message.urlMap;
                            return object;
                        };
    
                        /**
                         * Converts this PatchUrlMapRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PatchUrlMapRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PatchUrlMapRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PatchUrlMapRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PatchUrlMapRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PatchUrlMapRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PatchUrlMapRequest";
                        };
    
                        return PatchUrlMapRequest;
                    })();
    
                    v1.PathMatcher = (function() {
    
                        /**
                         * Properties of a PathMatcher.
                         * @memberof google.cloud.compute.v1
                         * @interface IPathMatcher
                         * @property {google.cloud.compute.v1.IHttpRouteAction|null} [defaultRouteAction] PathMatcher defaultRouteAction
                         * @property {string|null} [defaultService] PathMatcher defaultService
                         * @property {google.cloud.compute.v1.IHttpRedirectAction|null} [defaultUrlRedirect] PathMatcher defaultUrlRedirect
                         * @property {string|null} [description] PathMatcher description
                         * @property {google.cloud.compute.v1.IHttpHeaderAction|null} [headerAction] PathMatcher headerAction
                         * @property {string|null} [name] PathMatcher name
                         * @property {Array.<google.cloud.compute.v1.IPathRule>|null} [pathRules] PathMatcher pathRules
                         * @property {Array.<google.cloud.compute.v1.IHttpRouteRule>|null} [routeRules] PathMatcher routeRules
                         */
    
                        /**
                         * Constructs a new PathMatcher.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PathMatcher.
                         * @implements IPathMatcher
                         * @constructor
                         * @param {google.cloud.compute.v1.IPathMatcher=} [properties] Properties to set
                         */
                        function PathMatcher(properties) {
                            this.pathRules = [];
                            this.routeRules = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PathMatcher defaultRouteAction.
                         * @member {google.cloud.compute.v1.IHttpRouteAction|null|undefined} defaultRouteAction
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @instance
                         */
                        PathMatcher.prototype.defaultRouteAction = null;
    
                        /**
                         * PathMatcher defaultService.
                         * @member {string|null|undefined} defaultService
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @instance
                         */
                        PathMatcher.prototype.defaultService = null;
    
                        /**
                         * PathMatcher defaultUrlRedirect.
                         * @member {google.cloud.compute.v1.IHttpRedirectAction|null|undefined} defaultUrlRedirect
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @instance
                         */
                        PathMatcher.prototype.defaultUrlRedirect = null;
    
                        /**
                         * PathMatcher description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @instance
                         */
                        PathMatcher.prototype.description = null;
    
                        /**
                         * PathMatcher headerAction.
                         * @member {google.cloud.compute.v1.IHttpHeaderAction|null|undefined} headerAction
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @instance
                         */
                        PathMatcher.prototype.headerAction = null;
    
                        /**
                         * PathMatcher name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @instance
                         */
                        PathMatcher.prototype.name = null;
    
                        /**
                         * PathMatcher pathRules.
                         * @member {Array.<google.cloud.compute.v1.IPathRule>} pathRules
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @instance
                         */
                        PathMatcher.prototype.pathRules = $util.emptyArray;
    
                        /**
                         * PathMatcher routeRules.
                         * @member {Array.<google.cloud.compute.v1.IHttpRouteRule>} routeRules
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @instance
                         */
                        PathMatcher.prototype.routeRules = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PathMatcher _defaultRouteAction.
                         * @member {"defaultRouteAction"|undefined} _defaultRouteAction
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @instance
                         */
                        Object.defineProperty(PathMatcher.prototype, "_defaultRouteAction", {
                            get: $util.oneOfGetter($oneOfFields = ["defaultRouteAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PathMatcher _defaultService.
                         * @member {"defaultService"|undefined} _defaultService
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @instance
                         */
                        Object.defineProperty(PathMatcher.prototype, "_defaultService", {
                            get: $util.oneOfGetter($oneOfFields = ["defaultService"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PathMatcher _defaultUrlRedirect.
                         * @member {"defaultUrlRedirect"|undefined} _defaultUrlRedirect
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @instance
                         */
                        Object.defineProperty(PathMatcher.prototype, "_defaultUrlRedirect", {
                            get: $util.oneOfGetter($oneOfFields = ["defaultUrlRedirect"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PathMatcher _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @instance
                         */
                        Object.defineProperty(PathMatcher.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PathMatcher _headerAction.
                         * @member {"headerAction"|undefined} _headerAction
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @instance
                         */
                        Object.defineProperty(PathMatcher.prototype, "_headerAction", {
                            get: $util.oneOfGetter($oneOfFields = ["headerAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PathMatcher _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @instance
                         */
                        Object.defineProperty(PathMatcher.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PathMatcher instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @static
                         * @param {google.cloud.compute.v1.IPathMatcher=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PathMatcher} PathMatcher instance
                         */
                        PathMatcher.create = function create(properties) {
                            return new PathMatcher(properties);
                        };
    
                        /**
                         * Encodes the specified PathMatcher message. Does not implicitly {@link google.cloud.compute.v1.PathMatcher.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @static
                         * @param {google.cloud.compute.v1.IPathMatcher} message PathMatcher message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PathMatcher.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.pathRules != null && message.pathRules.length)
                                for (var i = 0; i < message.pathRules.length; ++i)
                                    $root.google.cloud.compute.v1.PathRule.encode(message.pathRules[i], writer.uint32(/* id 104439901, wireType 2 =*/835519210).fork()).ldelim();
                            if (message.headerAction != null && Object.hasOwnProperty.call(message, "headerAction"))
                                $root.google.cloud.compute.v1.HttpHeaderAction.encode(message.headerAction, writer.uint32(/* id 328077352, wireType 2 =*/2624618818).fork()).ldelim();
                            if (message.defaultUrlRedirect != null && Object.hasOwnProperty.call(message, "defaultUrlRedirect"))
                                $root.google.cloud.compute.v1.HttpRedirectAction.encode(message.defaultUrlRedirect, writer.uint32(/* id 359503338, wireType 2 =*/2876026706).fork()).ldelim();
                            if (message.defaultService != null && Object.hasOwnProperty.call(message, "defaultService"))
                                writer.uint32(/* id 370242231, wireType 2 =*/2961937850).string(message.defaultService);
                            if (message.routeRules != null && message.routeRules.length)
                                for (var i = 0; i < message.routeRules.length; ++i)
                                    $root.google.cloud.compute.v1.HttpRouteRule.encode(message.routeRules[i], writer.uint32(/* id 376292225, wireType 2 =*/3010337802).fork()).ldelim();
                            if (message.defaultRouteAction != null && Object.hasOwnProperty.call(message, "defaultRouteAction"))
                                $root.google.cloud.compute.v1.HttpRouteAction.encode(message.defaultRouteAction, writer.uint32(/* id 378919466, wireType 2 =*/3031355730).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PathMatcher message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PathMatcher.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @static
                         * @param {google.cloud.compute.v1.IPathMatcher} message PathMatcher message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PathMatcher.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PathMatcher message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PathMatcher} PathMatcher
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PathMatcher.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PathMatcher();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 378919466: {
                                        message.defaultRouteAction = $root.google.cloud.compute.v1.HttpRouteAction.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 370242231: {
                                        message.defaultService = reader.string();
                                        break;
                                    }
                                case 359503338: {
                                        message.defaultUrlRedirect = $root.google.cloud.compute.v1.HttpRedirectAction.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 328077352: {
                                        message.headerAction = $root.google.cloud.compute.v1.HttpHeaderAction.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 104439901: {
                                        if (!(message.pathRules && message.pathRules.length))
                                            message.pathRules = [];
                                        message.pathRules.push($root.google.cloud.compute.v1.PathRule.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 376292225: {
                                        if (!(message.routeRules && message.routeRules.length))
                                            message.routeRules = [];
                                        message.routeRules.push($root.google.cloud.compute.v1.HttpRouteRule.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PathMatcher message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PathMatcher} PathMatcher
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PathMatcher.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PathMatcher message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PathMatcher.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.defaultRouteAction != null && message.hasOwnProperty("defaultRouteAction")) {
                                properties._defaultRouteAction = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HttpRouteAction.verify(message.defaultRouteAction);
                                    if (error)
                                        return "defaultRouteAction." + error;
                                }
                            }
                            if (message.defaultService != null && message.hasOwnProperty("defaultService")) {
                                properties._defaultService = 1;
                                if (!$util.isString(message.defaultService))
                                    return "defaultService: string expected";
                            }
                            if (message.defaultUrlRedirect != null && message.hasOwnProperty("defaultUrlRedirect")) {
                                properties._defaultUrlRedirect = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HttpRedirectAction.verify(message.defaultUrlRedirect);
                                    if (error)
                                        return "defaultUrlRedirect." + error;
                                }
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.headerAction != null && message.hasOwnProperty("headerAction")) {
                                properties._headerAction = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HttpHeaderAction.verify(message.headerAction);
                                    if (error)
                                        return "headerAction." + error;
                                }
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.pathRules != null && message.hasOwnProperty("pathRules")) {
                                if (!Array.isArray(message.pathRules))
                                    return "pathRules: array expected";
                                for (var i = 0; i < message.pathRules.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PathRule.verify(message.pathRules[i]);
                                    if (error)
                                        return "pathRules." + error;
                                }
                            }
                            if (message.routeRules != null && message.hasOwnProperty("routeRules")) {
                                if (!Array.isArray(message.routeRules))
                                    return "routeRules: array expected";
                                for (var i = 0; i < message.routeRules.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.HttpRouteRule.verify(message.routeRules[i]);
                                    if (error)
                                        return "routeRules." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PathMatcher message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PathMatcher} PathMatcher
                         */
                        PathMatcher.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PathMatcher)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PathMatcher();
                            if (object.defaultRouteAction != null) {
                                if (typeof object.defaultRouteAction !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PathMatcher.defaultRouteAction: object expected");
                                message.defaultRouteAction = $root.google.cloud.compute.v1.HttpRouteAction.fromObject(object.defaultRouteAction);
                            }
                            if (object.defaultService != null)
                                message.defaultService = String(object.defaultService);
                            if (object.defaultUrlRedirect != null) {
                                if (typeof object.defaultUrlRedirect !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PathMatcher.defaultUrlRedirect: object expected");
                                message.defaultUrlRedirect = $root.google.cloud.compute.v1.HttpRedirectAction.fromObject(object.defaultUrlRedirect);
                            }
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.headerAction != null) {
                                if (typeof object.headerAction !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PathMatcher.headerAction: object expected");
                                message.headerAction = $root.google.cloud.compute.v1.HttpHeaderAction.fromObject(object.headerAction);
                            }
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.pathRules) {
                                if (!Array.isArray(object.pathRules))
                                    throw TypeError(".google.cloud.compute.v1.PathMatcher.pathRules: array expected");
                                message.pathRules = [];
                                for (var i = 0; i < object.pathRules.length; ++i) {
                                    if (typeof object.pathRules[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.PathMatcher.pathRules: object expected");
                                    message.pathRules[i] = $root.google.cloud.compute.v1.PathRule.fromObject(object.pathRules[i]);
                                }
                            }
                            if (object.routeRules) {
                                if (!Array.isArray(object.routeRules))
                                    throw TypeError(".google.cloud.compute.v1.PathMatcher.routeRules: array expected");
                                message.routeRules = [];
                                for (var i = 0; i < object.routeRules.length; ++i) {
                                    if (typeof object.routeRules[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.PathMatcher.routeRules: object expected");
                                    message.routeRules[i] = $root.google.cloud.compute.v1.HttpRouteRule.fromObject(object.routeRules[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PathMatcher message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @static
                         * @param {google.cloud.compute.v1.PathMatcher} message PathMatcher
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PathMatcher.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.pathRules = [];
                                object.routeRules = [];
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.pathRules && message.pathRules.length) {
                                object.pathRules = [];
                                for (var j = 0; j < message.pathRules.length; ++j)
                                    object.pathRules[j] = $root.google.cloud.compute.v1.PathRule.toObject(message.pathRules[j], options);
                            }
                            if (message.headerAction != null && message.hasOwnProperty("headerAction")) {
                                object.headerAction = $root.google.cloud.compute.v1.HttpHeaderAction.toObject(message.headerAction, options);
                                if (options.oneofs)
                                    object._headerAction = "headerAction";
                            }
                            if (message.defaultUrlRedirect != null && message.hasOwnProperty("defaultUrlRedirect")) {
                                object.defaultUrlRedirect = $root.google.cloud.compute.v1.HttpRedirectAction.toObject(message.defaultUrlRedirect, options);
                                if (options.oneofs)
                                    object._defaultUrlRedirect = "defaultUrlRedirect";
                            }
                            if (message.defaultService != null && message.hasOwnProperty("defaultService")) {
                                object.defaultService = message.defaultService;
                                if (options.oneofs)
                                    object._defaultService = "defaultService";
                            }
                            if (message.routeRules && message.routeRules.length) {
                                object.routeRules = [];
                                for (var j = 0; j < message.routeRules.length; ++j)
                                    object.routeRules[j] = $root.google.cloud.compute.v1.HttpRouteRule.toObject(message.routeRules[j], options);
                            }
                            if (message.defaultRouteAction != null && message.hasOwnProperty("defaultRouteAction")) {
                                object.defaultRouteAction = $root.google.cloud.compute.v1.HttpRouteAction.toObject(message.defaultRouteAction, options);
                                if (options.oneofs)
                                    object._defaultRouteAction = "defaultRouteAction";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PathMatcher to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PathMatcher.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PathMatcher
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PathMatcher
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PathMatcher.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PathMatcher";
                        };
    
                        return PathMatcher;
                    })();
    
                    v1.PathRule = (function() {
    
                        /**
                         * Properties of a PathRule.
                         * @memberof google.cloud.compute.v1
                         * @interface IPathRule
                         * @property {Array.<string>|null} [paths] PathRule paths
                         * @property {google.cloud.compute.v1.IHttpRouteAction|null} [routeAction] PathRule routeAction
                         * @property {string|null} [service] PathRule service
                         * @property {google.cloud.compute.v1.IHttpRedirectAction|null} [urlRedirect] PathRule urlRedirect
                         */
    
                        /**
                         * Constructs a new PathRule.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PathRule.
                         * @implements IPathRule
                         * @constructor
                         * @param {google.cloud.compute.v1.IPathRule=} [properties] Properties to set
                         */
                        function PathRule(properties) {
                            this.paths = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PathRule paths.
                         * @member {Array.<string>} paths
                         * @memberof google.cloud.compute.v1.PathRule
                         * @instance
                         */
                        PathRule.prototype.paths = $util.emptyArray;
    
                        /**
                         * PathRule routeAction.
                         * @member {google.cloud.compute.v1.IHttpRouteAction|null|undefined} routeAction
                         * @memberof google.cloud.compute.v1.PathRule
                         * @instance
                         */
                        PathRule.prototype.routeAction = null;
    
                        /**
                         * PathRule service.
                         * @member {string|null|undefined} service
                         * @memberof google.cloud.compute.v1.PathRule
                         * @instance
                         */
                        PathRule.prototype.service = null;
    
                        /**
                         * PathRule urlRedirect.
                         * @member {google.cloud.compute.v1.IHttpRedirectAction|null|undefined} urlRedirect
                         * @memberof google.cloud.compute.v1.PathRule
                         * @instance
                         */
                        PathRule.prototype.urlRedirect = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PathRule _routeAction.
                         * @member {"routeAction"|undefined} _routeAction
                         * @memberof google.cloud.compute.v1.PathRule
                         * @instance
                         */
                        Object.defineProperty(PathRule.prototype, "_routeAction", {
                            get: $util.oneOfGetter($oneOfFields = ["routeAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PathRule _service.
                         * @member {"service"|undefined} _service
                         * @memberof google.cloud.compute.v1.PathRule
                         * @instance
                         */
                        Object.defineProperty(PathRule.prototype, "_service", {
                            get: $util.oneOfGetter($oneOfFields = ["service"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PathRule _urlRedirect.
                         * @member {"urlRedirect"|undefined} _urlRedirect
                         * @memberof google.cloud.compute.v1.PathRule
                         * @instance
                         */
                        Object.defineProperty(PathRule.prototype, "_urlRedirect", {
                            get: $util.oneOfGetter($oneOfFields = ["urlRedirect"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PathRule instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PathRule
                         * @static
                         * @param {google.cloud.compute.v1.IPathRule=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PathRule} PathRule instance
                         */
                        PathRule.create = function create(properties) {
                            return new PathRule(properties);
                        };
    
                        /**
                         * Encodes the specified PathRule message. Does not implicitly {@link google.cloud.compute.v1.PathRule.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PathRule
                         * @static
                         * @param {google.cloud.compute.v1.IPathRule} message PathRule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PathRule.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.paths != null && message.paths.length)
                                for (var i = 0; i < message.paths.length; ++i)
                                    writer.uint32(/* id 106438894, wireType 2 =*/851511154).string(message.paths[i]);
                            if (message.service != null && Object.hasOwnProperty.call(message, "service"))
                                writer.uint32(/* id 373540533, wireType 2 =*/2988324266).string(message.service);
                            if (message.urlRedirect != null && Object.hasOwnProperty.call(message, "urlRedirect"))
                                $root.google.cloud.compute.v1.HttpRedirectAction.encode(message.urlRedirect, writer.uint32(/* id 405147820, wireType 2 =*/3241182562).fork()).ldelim();
                            if (message.routeAction != null && Object.hasOwnProperty.call(message, "routeAction"))
                                $root.google.cloud.compute.v1.HttpRouteAction.encode(message.routeAction, writer.uint32(/* id 424563948, wireType 2 =*/3396511586).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PathRule message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PathRule.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PathRule
                         * @static
                         * @param {google.cloud.compute.v1.IPathRule} message PathRule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PathRule.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PathRule message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PathRule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PathRule} PathRule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PathRule.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PathRule();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 106438894: {
                                        if (!(message.paths && message.paths.length))
                                            message.paths = [];
                                        message.paths.push(reader.string());
                                        break;
                                    }
                                case 424563948: {
                                        message.routeAction = $root.google.cloud.compute.v1.HttpRouteAction.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 373540533: {
                                        message.service = reader.string();
                                        break;
                                    }
                                case 405147820: {
                                        message.urlRedirect = $root.google.cloud.compute.v1.HttpRedirectAction.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PathRule message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PathRule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PathRule} PathRule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PathRule.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PathRule message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PathRule
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PathRule.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.paths != null && message.hasOwnProperty("paths")) {
                                if (!Array.isArray(message.paths))
                                    return "paths: array expected";
                                for (var i = 0; i < message.paths.length; ++i)
                                    if (!$util.isString(message.paths[i]))
                                        return "paths: string[] expected";
                            }
                            if (message.routeAction != null && message.hasOwnProperty("routeAction")) {
                                properties._routeAction = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HttpRouteAction.verify(message.routeAction);
                                    if (error)
                                        return "routeAction." + error;
                                }
                            }
                            if (message.service != null && message.hasOwnProperty("service")) {
                                properties._service = 1;
                                if (!$util.isString(message.service))
                                    return "service: string expected";
                            }
                            if (message.urlRedirect != null && message.hasOwnProperty("urlRedirect")) {
                                properties._urlRedirect = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HttpRedirectAction.verify(message.urlRedirect);
                                    if (error)
                                        return "urlRedirect." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PathRule message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PathRule
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PathRule} PathRule
                         */
                        PathRule.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PathRule)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PathRule();
                            if (object.paths) {
                                if (!Array.isArray(object.paths))
                                    throw TypeError(".google.cloud.compute.v1.PathRule.paths: array expected");
                                message.paths = [];
                                for (var i = 0; i < object.paths.length; ++i)
                                    message.paths[i] = String(object.paths[i]);
                            }
                            if (object.routeAction != null) {
                                if (typeof object.routeAction !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PathRule.routeAction: object expected");
                                message.routeAction = $root.google.cloud.compute.v1.HttpRouteAction.fromObject(object.routeAction);
                            }
                            if (object.service != null)
                                message.service = String(object.service);
                            if (object.urlRedirect != null) {
                                if (typeof object.urlRedirect !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PathRule.urlRedirect: object expected");
                                message.urlRedirect = $root.google.cloud.compute.v1.HttpRedirectAction.fromObject(object.urlRedirect);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PathRule message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PathRule
                         * @static
                         * @param {google.cloud.compute.v1.PathRule} message PathRule
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PathRule.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.paths = [];
                            if (message.paths && message.paths.length) {
                                object.paths = [];
                                for (var j = 0; j < message.paths.length; ++j)
                                    object.paths[j] = message.paths[j];
                            }
                            if (message.service != null && message.hasOwnProperty("service")) {
                                object.service = message.service;
                                if (options.oneofs)
                                    object._service = "service";
                            }
                            if (message.urlRedirect != null && message.hasOwnProperty("urlRedirect")) {
                                object.urlRedirect = $root.google.cloud.compute.v1.HttpRedirectAction.toObject(message.urlRedirect, options);
                                if (options.oneofs)
                                    object._urlRedirect = "urlRedirect";
                            }
                            if (message.routeAction != null && message.hasOwnProperty("routeAction")) {
                                object.routeAction = $root.google.cloud.compute.v1.HttpRouteAction.toObject(message.routeAction, options);
                                if (options.oneofs)
                                    object._routeAction = "routeAction";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PathRule to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PathRule
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PathRule.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PathRule
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PathRule
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PathRule.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PathRule";
                        };
    
                        return PathRule;
                    })();
    
                    v1.PerInstanceConfig = (function() {
    
                        /**
                         * Properties of a PerInstanceConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface IPerInstanceConfig
                         * @property {string|null} [fingerprint] PerInstanceConfig fingerprint
                         * @property {string|null} [name] PerInstanceConfig name
                         * @property {google.cloud.compute.v1.IPreservedState|null} [preservedState] PerInstanceConfig preservedState
                         * @property {string|null} [status] PerInstanceConfig status
                         */
    
                        /**
                         * Constructs a new PerInstanceConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PerInstanceConfig.
                         * @implements IPerInstanceConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.IPerInstanceConfig=} [properties] Properties to set
                         */
                        function PerInstanceConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PerInstanceConfig fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.PerInstanceConfig
                         * @instance
                         */
                        PerInstanceConfig.prototype.fingerprint = null;
    
                        /**
                         * PerInstanceConfig name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.PerInstanceConfig
                         * @instance
                         */
                        PerInstanceConfig.prototype.name = null;
    
                        /**
                         * PerInstanceConfig preservedState.
                         * @member {google.cloud.compute.v1.IPreservedState|null|undefined} preservedState
                         * @memberof google.cloud.compute.v1.PerInstanceConfig
                         * @instance
                         */
                        PerInstanceConfig.prototype.preservedState = null;
    
                        /**
                         * PerInstanceConfig status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.PerInstanceConfig
                         * @instance
                         */
                        PerInstanceConfig.prototype.status = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PerInstanceConfig _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.PerInstanceConfig
                         * @instance
                         */
                        Object.defineProperty(PerInstanceConfig.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PerInstanceConfig _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.PerInstanceConfig
                         * @instance
                         */
                        Object.defineProperty(PerInstanceConfig.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PerInstanceConfig _preservedState.
                         * @member {"preservedState"|undefined} _preservedState
                         * @memberof google.cloud.compute.v1.PerInstanceConfig
                         * @instance
                         */
                        Object.defineProperty(PerInstanceConfig.prototype, "_preservedState", {
                            get: $util.oneOfGetter($oneOfFields = ["preservedState"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PerInstanceConfig _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.PerInstanceConfig
                         * @instance
                         */
                        Object.defineProperty(PerInstanceConfig.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PerInstanceConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PerInstanceConfig
                         * @static
                         * @param {google.cloud.compute.v1.IPerInstanceConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PerInstanceConfig} PerInstanceConfig instance
                         */
                        PerInstanceConfig.create = function create(properties) {
                            return new PerInstanceConfig(properties);
                        };
    
                        /**
                         * Encodes the specified PerInstanceConfig message. Does not implicitly {@link google.cloud.compute.v1.PerInstanceConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PerInstanceConfig
                         * @static
                         * @param {google.cloud.compute.v1.IPerInstanceConfig} message PerInstanceConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PerInstanceConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.preservedState != null && Object.hasOwnProperty.call(message, "preservedState"))
                                $root.google.cloud.compute.v1.PreservedState.encode(message.preservedState, writer.uint32(/* id 2634026, wireType 2 =*/21072210).fork()).ldelim();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PerInstanceConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PerInstanceConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PerInstanceConfig
                         * @static
                         * @param {google.cloud.compute.v1.IPerInstanceConfig} message PerInstanceConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PerInstanceConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PerInstanceConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PerInstanceConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PerInstanceConfig} PerInstanceConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PerInstanceConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PerInstanceConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 2634026: {
                                        message.preservedState = $root.google.cloud.compute.v1.PreservedState.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PerInstanceConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PerInstanceConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PerInstanceConfig} PerInstanceConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PerInstanceConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PerInstanceConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PerInstanceConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PerInstanceConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.preservedState != null && message.hasOwnProperty("preservedState")) {
                                properties._preservedState = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.PreservedState.verify(message.preservedState);
                                    if (error)
                                        return "preservedState." + error;
                                }
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PerInstanceConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PerInstanceConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PerInstanceConfig} PerInstanceConfig
                         */
                        PerInstanceConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PerInstanceConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PerInstanceConfig();
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.preservedState != null) {
                                if (typeof object.preservedState !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PerInstanceConfig.preservedState: object expected");
                                message.preservedState = $root.google.cloud.compute.v1.PreservedState.fromObject(object.preservedState);
                            }
                            if (object.status != null)
                                message.status = String(object.status);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PerInstanceConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PerInstanceConfig
                         * @static
                         * @param {google.cloud.compute.v1.PerInstanceConfig} message PerInstanceConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PerInstanceConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.preservedState != null && message.hasOwnProperty("preservedState")) {
                                object.preservedState = $root.google.cloud.compute.v1.PreservedState.toObject(message.preservedState, options);
                                if (options.oneofs)
                                    object._preservedState = "preservedState";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PerInstanceConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PerInstanceConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PerInstanceConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PerInstanceConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PerInstanceConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PerInstanceConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PerInstanceConfig";
                        };
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.PerInstanceConfig.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} APPLYING=352003508 APPLYING value
                         * @property {number} DELETING=528602024 DELETING value
                         * @property {number} EFFECTIVE=244201863 EFFECTIVE value
                         * @property {number} NONE=2402104 NONE value
                         * @property {number} UNAPPLIED=483935140 UNAPPLIED value
                         * @property {number} UNAPPLIED_DELETION=313956873 UNAPPLIED_DELETION value
                         */
                        PerInstanceConfig.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[352003508] = "APPLYING"] = 352003508;
                            values[valuesById[528602024] = "DELETING"] = 528602024;
                            values[valuesById[244201863] = "EFFECTIVE"] = 244201863;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            values[valuesById[483935140] = "UNAPPLIED"] = 483935140;
                            values[valuesById[313956873] = "UNAPPLIED_DELETION"] = 313956873;
                            return values;
                        })();
    
                        return PerInstanceConfig;
                    })();
    
                    v1.Policy = (function() {
    
                        /**
                         * Properties of a Policy.
                         * @memberof google.cloud.compute.v1
                         * @interface IPolicy
                         * @property {Array.<google.cloud.compute.v1.IAuditConfig>|null} [auditConfigs] Policy auditConfigs
                         * @property {Array.<google.cloud.compute.v1.IBinding>|null} [bindings] Policy bindings
                         * @property {string|null} [etag] Policy etag
                         * @property {boolean|null} [iamOwned] Policy iamOwned
                         * @property {Array.<google.cloud.compute.v1.IRule>|null} [rules] Policy rules
                         * @property {number|null} [version] Policy version
                         */
    
                        /**
                         * Constructs a new Policy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Policy.
                         * @implements IPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IPolicy=} [properties] Properties to set
                         */
                        function Policy(properties) {
                            this.auditConfigs = [];
                            this.bindings = [];
                            this.rules = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Policy auditConfigs.
                         * @member {Array.<google.cloud.compute.v1.IAuditConfig>} auditConfigs
                         * @memberof google.cloud.compute.v1.Policy
                         * @instance
                         */
                        Policy.prototype.auditConfigs = $util.emptyArray;
    
                        /**
                         * Policy bindings.
                         * @member {Array.<google.cloud.compute.v1.IBinding>} bindings
                         * @memberof google.cloud.compute.v1.Policy
                         * @instance
                         */
                        Policy.prototype.bindings = $util.emptyArray;
    
                        /**
                         * Policy etag.
                         * @member {string|null|undefined} etag
                         * @memberof google.cloud.compute.v1.Policy
                         * @instance
                         */
                        Policy.prototype.etag = null;
    
                        /**
                         * Policy iamOwned.
                         * @member {boolean|null|undefined} iamOwned
                         * @memberof google.cloud.compute.v1.Policy
                         * @instance
                         */
                        Policy.prototype.iamOwned = null;
    
                        /**
                         * Policy rules.
                         * @member {Array.<google.cloud.compute.v1.IRule>} rules
                         * @memberof google.cloud.compute.v1.Policy
                         * @instance
                         */
                        Policy.prototype.rules = $util.emptyArray;
    
                        /**
                         * Policy version.
                         * @member {number|null|undefined} version
                         * @memberof google.cloud.compute.v1.Policy
                         * @instance
                         */
                        Policy.prototype.version = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Policy _etag.
                         * @member {"etag"|undefined} _etag
                         * @memberof google.cloud.compute.v1.Policy
                         * @instance
                         */
                        Object.defineProperty(Policy.prototype, "_etag", {
                            get: $util.oneOfGetter($oneOfFields = ["etag"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Policy _iamOwned.
                         * @member {"iamOwned"|undefined} _iamOwned
                         * @memberof google.cloud.compute.v1.Policy
                         * @instance
                         */
                        Object.defineProperty(Policy.prototype, "_iamOwned", {
                            get: $util.oneOfGetter($oneOfFields = ["iamOwned"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Policy _version.
                         * @member {"version"|undefined} _version
                         * @memberof google.cloud.compute.v1.Policy
                         * @instance
                         */
                        Object.defineProperty(Policy.prototype, "_version", {
                            get: $util.oneOfGetter($oneOfFields = ["version"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Policy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Policy
                         * @static
                         * @param {google.cloud.compute.v1.IPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Policy} Policy instance
                         */
                        Policy.create = function create(properties) {
                            return new Policy(properties);
                        };
    
                        /**
                         * Encodes the specified Policy message. Does not implicitly {@link google.cloud.compute.v1.Policy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Policy
                         * @static
                         * @param {google.cloud.compute.v1.IPolicy} message Policy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Policy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.etag != null && Object.hasOwnProperty.call(message, "etag"))
                                writer.uint32(/* id 3123477, wireType 2 =*/24987818).string(message.etag);
                            if (message.rules != null && message.rules.length)
                                for (var i = 0; i < message.rules.length; ++i)
                                    $root.google.cloud.compute.v1.Rule.encode(message.rules[i], writer.uint32(/* id 108873975, wireType 2 =*/870991802).fork()).ldelim();
                            if (message.auditConfigs != null && message.auditConfigs.length)
                                for (var i = 0; i < message.auditConfigs.length; ++i)
                                    $root.google.cloud.compute.v1.AuditConfig.encode(message.auditConfigs[i], writer.uint32(/* id 328080653, wireType 2 =*/2624645226).fork()).ldelim();
                            if (message.version != null && Object.hasOwnProperty.call(message, "version"))
                                writer.uint32(/* id 351608024, wireType 0 =*/2812864192).int32(message.version);
                            if (message.bindings != null && message.bindings.length)
                                for (var i = 0; i < message.bindings.length; ++i)
                                    $root.google.cloud.compute.v1.Binding.encode(message.bindings[i], writer.uint32(/* id 403251854, wireType 2 =*/3226014834).fork()).ldelim();
                            if (message.iamOwned != null && Object.hasOwnProperty.call(message, "iamOwned"))
                                writer.uint32(/* id 450566203, wireType 0 =*/3604529624).bool(message.iamOwned);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Policy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Policy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Policy
                         * @static
                         * @param {google.cloud.compute.v1.IPolicy} message Policy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Policy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Policy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Policy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Policy} Policy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Policy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Policy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 328080653: {
                                        if (!(message.auditConfigs && message.auditConfigs.length))
                                            message.auditConfigs = [];
                                        message.auditConfigs.push($root.google.cloud.compute.v1.AuditConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 403251854: {
                                        if (!(message.bindings && message.bindings.length))
                                            message.bindings = [];
                                        message.bindings.push($root.google.cloud.compute.v1.Binding.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3123477: {
                                        message.etag = reader.string();
                                        break;
                                    }
                                case 450566203: {
                                        message.iamOwned = reader.bool();
                                        break;
                                    }
                                case 108873975: {
                                        if (!(message.rules && message.rules.length))
                                            message.rules = [];
                                        message.rules.push($root.google.cloud.compute.v1.Rule.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 351608024: {
                                        message.version = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Policy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Policy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Policy} Policy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Policy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Policy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Policy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Policy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.auditConfigs != null && message.hasOwnProperty("auditConfigs")) {
                                if (!Array.isArray(message.auditConfigs))
                                    return "auditConfigs: array expected";
                                for (var i = 0; i < message.auditConfigs.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AuditConfig.verify(message.auditConfigs[i]);
                                    if (error)
                                        return "auditConfigs." + error;
                                }
                            }
                            if (message.bindings != null && message.hasOwnProperty("bindings")) {
                                if (!Array.isArray(message.bindings))
                                    return "bindings: array expected";
                                for (var i = 0; i < message.bindings.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Binding.verify(message.bindings[i]);
                                    if (error)
                                        return "bindings." + error;
                                }
                            }
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                properties._etag = 1;
                                if (!$util.isString(message.etag))
                                    return "etag: string expected";
                            }
                            if (message.iamOwned != null && message.hasOwnProperty("iamOwned")) {
                                properties._iamOwned = 1;
                                if (typeof message.iamOwned !== "boolean")
                                    return "iamOwned: boolean expected";
                            }
                            if (message.rules != null && message.hasOwnProperty("rules")) {
                                if (!Array.isArray(message.rules))
                                    return "rules: array expected";
                                for (var i = 0; i < message.rules.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Rule.verify(message.rules[i]);
                                    if (error)
                                        return "rules." + error;
                                }
                            }
                            if (message.version != null && message.hasOwnProperty("version")) {
                                properties._version = 1;
                                if (!$util.isInteger(message.version))
                                    return "version: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Policy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Policy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Policy} Policy
                         */
                        Policy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Policy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Policy();
                            if (object.auditConfigs) {
                                if (!Array.isArray(object.auditConfigs))
                                    throw TypeError(".google.cloud.compute.v1.Policy.auditConfigs: array expected");
                                message.auditConfigs = [];
                                for (var i = 0; i < object.auditConfigs.length; ++i) {
                                    if (typeof object.auditConfigs[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Policy.auditConfigs: object expected");
                                    message.auditConfigs[i] = $root.google.cloud.compute.v1.AuditConfig.fromObject(object.auditConfigs[i]);
                                }
                            }
                            if (object.bindings) {
                                if (!Array.isArray(object.bindings))
                                    throw TypeError(".google.cloud.compute.v1.Policy.bindings: array expected");
                                message.bindings = [];
                                for (var i = 0; i < object.bindings.length; ++i) {
                                    if (typeof object.bindings[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Policy.bindings: object expected");
                                    message.bindings[i] = $root.google.cloud.compute.v1.Binding.fromObject(object.bindings[i]);
                                }
                            }
                            if (object.etag != null)
                                message.etag = String(object.etag);
                            if (object.iamOwned != null)
                                message.iamOwned = Boolean(object.iamOwned);
                            if (object.rules) {
                                if (!Array.isArray(object.rules))
                                    throw TypeError(".google.cloud.compute.v1.Policy.rules: array expected");
                                message.rules = [];
                                for (var i = 0; i < object.rules.length; ++i) {
                                    if (typeof object.rules[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Policy.rules: object expected");
                                    message.rules[i] = $root.google.cloud.compute.v1.Rule.fromObject(object.rules[i]);
                                }
                            }
                            if (object.version != null)
                                message.version = object.version | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Policy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Policy
                         * @static
                         * @param {google.cloud.compute.v1.Policy} message Policy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Policy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.rules = [];
                                object.auditConfigs = [];
                                object.bindings = [];
                            }
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                object.etag = message.etag;
                                if (options.oneofs)
                                    object._etag = "etag";
                            }
                            if (message.rules && message.rules.length) {
                                object.rules = [];
                                for (var j = 0; j < message.rules.length; ++j)
                                    object.rules[j] = $root.google.cloud.compute.v1.Rule.toObject(message.rules[j], options);
                            }
                            if (message.auditConfigs && message.auditConfigs.length) {
                                object.auditConfigs = [];
                                for (var j = 0; j < message.auditConfigs.length; ++j)
                                    object.auditConfigs[j] = $root.google.cloud.compute.v1.AuditConfig.toObject(message.auditConfigs[j], options);
                            }
                            if (message.version != null && message.hasOwnProperty("version")) {
                                object.version = message.version;
                                if (options.oneofs)
                                    object._version = "version";
                            }
                            if (message.bindings && message.bindings.length) {
                                object.bindings = [];
                                for (var j = 0; j < message.bindings.length; ++j)
                                    object.bindings[j] = $root.google.cloud.compute.v1.Binding.toObject(message.bindings[j], options);
                            }
                            if (message.iamOwned != null && message.hasOwnProperty("iamOwned")) {
                                object.iamOwned = message.iamOwned;
                                if (options.oneofs)
                                    object._iamOwned = "iamOwned";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Policy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Policy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Policy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Policy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Policy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Policy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Policy";
                        };
    
                        return Policy;
                    })();
    
                    v1.PreconfiguredWafSet = (function() {
    
                        /**
                         * Properties of a PreconfiguredWafSet.
                         * @memberof google.cloud.compute.v1
                         * @interface IPreconfiguredWafSet
                         * @property {Array.<google.cloud.compute.v1.IWafExpressionSet>|null} [expressionSets] PreconfiguredWafSet expressionSets
                         */
    
                        /**
                         * Constructs a new PreconfiguredWafSet.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PreconfiguredWafSet.
                         * @implements IPreconfiguredWafSet
                         * @constructor
                         * @param {google.cloud.compute.v1.IPreconfiguredWafSet=} [properties] Properties to set
                         */
                        function PreconfiguredWafSet(properties) {
                            this.expressionSets = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PreconfiguredWafSet expressionSets.
                         * @member {Array.<google.cloud.compute.v1.IWafExpressionSet>} expressionSets
                         * @memberof google.cloud.compute.v1.PreconfiguredWafSet
                         * @instance
                         */
                        PreconfiguredWafSet.prototype.expressionSets = $util.emptyArray;
    
                        /**
                         * Creates a new PreconfiguredWafSet instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PreconfiguredWafSet
                         * @static
                         * @param {google.cloud.compute.v1.IPreconfiguredWafSet=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PreconfiguredWafSet} PreconfiguredWafSet instance
                         */
                        PreconfiguredWafSet.create = function create(properties) {
                            return new PreconfiguredWafSet(properties);
                        };
    
                        /**
                         * Encodes the specified PreconfiguredWafSet message. Does not implicitly {@link google.cloud.compute.v1.PreconfiguredWafSet.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PreconfiguredWafSet
                         * @static
                         * @param {google.cloud.compute.v1.IPreconfiguredWafSet} message PreconfiguredWafSet message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PreconfiguredWafSet.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.expressionSets != null && message.expressionSets.length)
                                for (var i = 0; i < message.expressionSets.length; ++i)
                                    $root.google.cloud.compute.v1.WafExpressionSet.encode(message.expressionSets[i], writer.uint32(/* id 474011032, wireType 2 =*/3792088258).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PreconfiguredWafSet message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PreconfiguredWafSet.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PreconfiguredWafSet
                         * @static
                         * @param {google.cloud.compute.v1.IPreconfiguredWafSet} message PreconfiguredWafSet message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PreconfiguredWafSet.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PreconfiguredWafSet message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PreconfiguredWafSet
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PreconfiguredWafSet} PreconfiguredWafSet
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PreconfiguredWafSet.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PreconfiguredWafSet();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 474011032: {
                                        if (!(message.expressionSets && message.expressionSets.length))
                                            message.expressionSets = [];
                                        message.expressionSets.push($root.google.cloud.compute.v1.WafExpressionSet.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PreconfiguredWafSet message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PreconfiguredWafSet
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PreconfiguredWafSet} PreconfiguredWafSet
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PreconfiguredWafSet.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PreconfiguredWafSet message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PreconfiguredWafSet
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PreconfiguredWafSet.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.expressionSets != null && message.hasOwnProperty("expressionSets")) {
                                if (!Array.isArray(message.expressionSets))
                                    return "expressionSets: array expected";
                                for (var i = 0; i < message.expressionSets.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.WafExpressionSet.verify(message.expressionSets[i]);
                                    if (error)
                                        return "expressionSets." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PreconfiguredWafSet message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PreconfiguredWafSet
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PreconfiguredWafSet} PreconfiguredWafSet
                         */
                        PreconfiguredWafSet.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PreconfiguredWafSet)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PreconfiguredWafSet();
                            if (object.expressionSets) {
                                if (!Array.isArray(object.expressionSets))
                                    throw TypeError(".google.cloud.compute.v1.PreconfiguredWafSet.expressionSets: array expected");
                                message.expressionSets = [];
                                for (var i = 0; i < object.expressionSets.length; ++i) {
                                    if (typeof object.expressionSets[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.PreconfiguredWafSet.expressionSets: object expected");
                                    message.expressionSets[i] = $root.google.cloud.compute.v1.WafExpressionSet.fromObject(object.expressionSets[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PreconfiguredWafSet message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PreconfiguredWafSet
                         * @static
                         * @param {google.cloud.compute.v1.PreconfiguredWafSet} message PreconfiguredWafSet
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PreconfiguredWafSet.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.expressionSets = [];
                            if (message.expressionSets && message.expressionSets.length) {
                                object.expressionSets = [];
                                for (var j = 0; j < message.expressionSets.length; ++j)
                                    object.expressionSets[j] = $root.google.cloud.compute.v1.WafExpressionSet.toObject(message.expressionSets[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PreconfiguredWafSet to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PreconfiguredWafSet
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PreconfiguredWafSet.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PreconfiguredWafSet
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PreconfiguredWafSet
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PreconfiguredWafSet.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PreconfiguredWafSet";
                        };
    
                        return PreconfiguredWafSet;
                    })();
    
                    v1.PreservedState = (function() {
    
                        /**
                         * Properties of a PreservedState.
                         * @memberof google.cloud.compute.v1
                         * @interface IPreservedState
                         * @property {Object.<string,google.cloud.compute.v1.IPreservedStatePreservedDisk>|null} [disks] PreservedState disks
                         * @property {Object.<string,string>|null} [metadata] PreservedState metadata
                         */
    
                        /**
                         * Constructs a new PreservedState.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PreservedState.
                         * @implements IPreservedState
                         * @constructor
                         * @param {google.cloud.compute.v1.IPreservedState=} [properties] Properties to set
                         */
                        function PreservedState(properties) {
                            this.disks = {};
                            this.metadata = {};
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PreservedState disks.
                         * @member {Object.<string,google.cloud.compute.v1.IPreservedStatePreservedDisk>} disks
                         * @memberof google.cloud.compute.v1.PreservedState
                         * @instance
                         */
                        PreservedState.prototype.disks = $util.emptyObject;
    
                        /**
                         * PreservedState metadata.
                         * @member {Object.<string,string>} metadata
                         * @memberof google.cloud.compute.v1.PreservedState
                         * @instance
                         */
                        PreservedState.prototype.metadata = $util.emptyObject;
    
                        /**
                         * Creates a new PreservedState instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PreservedState
                         * @static
                         * @param {google.cloud.compute.v1.IPreservedState=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PreservedState} PreservedState instance
                         */
                        PreservedState.create = function create(properties) {
                            return new PreservedState(properties);
                        };
    
                        /**
                         * Encodes the specified PreservedState message. Does not implicitly {@link google.cloud.compute.v1.PreservedState.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PreservedState
                         * @static
                         * @param {google.cloud.compute.v1.IPreservedState} message PreservedState message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PreservedState.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.metadata != null && Object.hasOwnProperty.call(message, "metadata"))
                                for (var keys = Object.keys(message.metadata), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 86866735, wireType 2 =*/694933882).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.metadata[keys[i]]).ldelim();
                            if (message.disks != null && Object.hasOwnProperty.call(message, "disks"))
                                for (var keys = Object.keys(message.disks), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 95594102, wireType 2 =*/764752818).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.PreservedStatePreservedDisk.encode(message.disks[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PreservedState message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PreservedState.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PreservedState
                         * @static
                         * @param {google.cloud.compute.v1.IPreservedState} message PreservedState message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PreservedState.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PreservedState message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PreservedState
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PreservedState} PreservedState
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PreservedState.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PreservedState(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 95594102: {
                                        if (message.disks === $util.emptyObject)
                                            message.disks = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.PreservedStatePreservedDisk.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.disks[key] = value;
                                        break;
                                    }
                                case 86866735: {
                                        if (message.metadata === $util.emptyObject)
                                            message.metadata = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.metadata[key] = value;
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PreservedState message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PreservedState
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PreservedState} PreservedState
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PreservedState.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PreservedState message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PreservedState
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PreservedState.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.disks != null && message.hasOwnProperty("disks")) {
                                if (!$util.isObject(message.disks))
                                    return "disks: object expected";
                                var key = Object.keys(message.disks);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PreservedStatePreservedDisk.verify(message.disks[key[i]]);
                                    if (error)
                                        return "disks." + error;
                                }
                            }
                            if (message.metadata != null && message.hasOwnProperty("metadata")) {
                                if (!$util.isObject(message.metadata))
                                    return "metadata: object expected";
                                var key = Object.keys(message.metadata);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.metadata[key[i]]))
                                        return "metadata: string{k:string} expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PreservedState message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PreservedState
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PreservedState} PreservedState
                         */
                        PreservedState.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PreservedState)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PreservedState();
                            if (object.disks) {
                                if (typeof object.disks !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PreservedState.disks: object expected");
                                message.disks = {};
                                for (var keys = Object.keys(object.disks), i = 0; i < keys.length; ++i) {
                                    if (typeof object.disks[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.PreservedState.disks: object expected");
                                    message.disks[keys[i]] = $root.google.cloud.compute.v1.PreservedStatePreservedDisk.fromObject(object.disks[keys[i]]);
                                }
                            }
                            if (object.metadata) {
                                if (typeof object.metadata !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PreservedState.metadata: object expected");
                                message.metadata = {};
                                for (var keys = Object.keys(object.metadata), i = 0; i < keys.length; ++i)
                                    message.metadata[keys[i]] = String(object.metadata[keys[i]]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PreservedState message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PreservedState
                         * @static
                         * @param {google.cloud.compute.v1.PreservedState} message PreservedState
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PreservedState.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.objects || options.defaults) {
                                object.metadata = {};
                                object.disks = {};
                            }
                            var keys2;
                            if (message.metadata && (keys2 = Object.keys(message.metadata)).length) {
                                object.metadata = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.metadata[keys2[j]] = message.metadata[keys2[j]];
                            }
                            if (message.disks && (keys2 = Object.keys(message.disks)).length) {
                                object.disks = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.disks[keys2[j]] = $root.google.cloud.compute.v1.PreservedStatePreservedDisk.toObject(message.disks[keys2[j]], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PreservedState to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PreservedState
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PreservedState.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PreservedState
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PreservedState
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PreservedState.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PreservedState";
                        };
    
                        return PreservedState;
                    })();
    
                    v1.PreservedStatePreservedDisk = (function() {
    
                        /**
                         * Properties of a PreservedStatePreservedDisk.
                         * @memberof google.cloud.compute.v1
                         * @interface IPreservedStatePreservedDisk
                         * @property {string|null} [autoDelete] PreservedStatePreservedDisk autoDelete
                         * @property {string|null} [mode] PreservedStatePreservedDisk mode
                         * @property {string|null} [source] PreservedStatePreservedDisk source
                         */
    
                        /**
                         * Constructs a new PreservedStatePreservedDisk.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PreservedStatePreservedDisk.
                         * @implements IPreservedStatePreservedDisk
                         * @constructor
                         * @param {google.cloud.compute.v1.IPreservedStatePreservedDisk=} [properties] Properties to set
                         */
                        function PreservedStatePreservedDisk(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PreservedStatePreservedDisk autoDelete.
                         * @member {string|null|undefined} autoDelete
                         * @memberof google.cloud.compute.v1.PreservedStatePreservedDisk
                         * @instance
                         */
                        PreservedStatePreservedDisk.prototype.autoDelete = null;
    
                        /**
                         * PreservedStatePreservedDisk mode.
                         * @member {string|null|undefined} mode
                         * @memberof google.cloud.compute.v1.PreservedStatePreservedDisk
                         * @instance
                         */
                        PreservedStatePreservedDisk.prototype.mode = null;
    
                        /**
                         * PreservedStatePreservedDisk source.
                         * @member {string|null|undefined} source
                         * @memberof google.cloud.compute.v1.PreservedStatePreservedDisk
                         * @instance
                         */
                        PreservedStatePreservedDisk.prototype.source = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PreservedStatePreservedDisk _autoDelete.
                         * @member {"autoDelete"|undefined} _autoDelete
                         * @memberof google.cloud.compute.v1.PreservedStatePreservedDisk
                         * @instance
                         */
                        Object.defineProperty(PreservedStatePreservedDisk.prototype, "_autoDelete", {
                            get: $util.oneOfGetter($oneOfFields = ["autoDelete"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PreservedStatePreservedDisk _mode.
                         * @member {"mode"|undefined} _mode
                         * @memberof google.cloud.compute.v1.PreservedStatePreservedDisk
                         * @instance
                         */
                        Object.defineProperty(PreservedStatePreservedDisk.prototype, "_mode", {
                            get: $util.oneOfGetter($oneOfFields = ["mode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PreservedStatePreservedDisk _source.
                         * @member {"source"|undefined} _source
                         * @memberof google.cloud.compute.v1.PreservedStatePreservedDisk
                         * @instance
                         */
                        Object.defineProperty(PreservedStatePreservedDisk.prototype, "_source", {
                            get: $util.oneOfGetter($oneOfFields = ["source"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PreservedStatePreservedDisk instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PreservedStatePreservedDisk
                         * @static
                         * @param {google.cloud.compute.v1.IPreservedStatePreservedDisk=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PreservedStatePreservedDisk} PreservedStatePreservedDisk instance
                         */
                        PreservedStatePreservedDisk.create = function create(properties) {
                            return new PreservedStatePreservedDisk(properties);
                        };
    
                        /**
                         * Encodes the specified PreservedStatePreservedDisk message. Does not implicitly {@link google.cloud.compute.v1.PreservedStatePreservedDisk.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PreservedStatePreservedDisk
                         * @static
                         * @param {google.cloud.compute.v1.IPreservedStatePreservedDisk} message PreservedStatePreservedDisk message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PreservedStatePreservedDisk.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.mode != null && Object.hasOwnProperty.call(message, "mode"))
                                writer.uint32(/* id 3357091, wireType 2 =*/26856730).string(message.mode);
                            if (message.source != null && Object.hasOwnProperty.call(message, "source"))
                                writer.uint32(/* id 177235995, wireType 2 =*/1417887962).string(message.source);
                            if (message.autoDelete != null && Object.hasOwnProperty.call(message, "autoDelete"))
                                writer.uint32(/* id 464761403, wireType 2 =*/3718091226).string(message.autoDelete);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PreservedStatePreservedDisk message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PreservedStatePreservedDisk.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PreservedStatePreservedDisk
                         * @static
                         * @param {google.cloud.compute.v1.IPreservedStatePreservedDisk} message PreservedStatePreservedDisk message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PreservedStatePreservedDisk.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PreservedStatePreservedDisk message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PreservedStatePreservedDisk
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PreservedStatePreservedDisk} PreservedStatePreservedDisk
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PreservedStatePreservedDisk.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PreservedStatePreservedDisk();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 464761403: {
                                        message.autoDelete = reader.string();
                                        break;
                                    }
                                case 3357091: {
                                        message.mode = reader.string();
                                        break;
                                    }
                                case 177235995: {
                                        message.source = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PreservedStatePreservedDisk message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PreservedStatePreservedDisk
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PreservedStatePreservedDisk} PreservedStatePreservedDisk
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PreservedStatePreservedDisk.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PreservedStatePreservedDisk message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PreservedStatePreservedDisk
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PreservedStatePreservedDisk.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoDelete != null && message.hasOwnProperty("autoDelete")) {
                                properties._autoDelete = 1;
                                if (!$util.isString(message.autoDelete))
                                    return "autoDelete: string expected";
                            }
                            if (message.mode != null && message.hasOwnProperty("mode")) {
                                properties._mode = 1;
                                if (!$util.isString(message.mode))
                                    return "mode: string expected";
                            }
                            if (message.source != null && message.hasOwnProperty("source")) {
                                properties._source = 1;
                                if (!$util.isString(message.source))
                                    return "source: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PreservedStatePreservedDisk message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PreservedStatePreservedDisk
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PreservedStatePreservedDisk} PreservedStatePreservedDisk
                         */
                        PreservedStatePreservedDisk.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PreservedStatePreservedDisk)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PreservedStatePreservedDisk();
                            if (object.autoDelete != null)
                                message.autoDelete = String(object.autoDelete);
                            if (object.mode != null)
                                message.mode = String(object.mode);
                            if (object.source != null)
                                message.source = String(object.source);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PreservedStatePreservedDisk message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PreservedStatePreservedDisk
                         * @static
                         * @param {google.cloud.compute.v1.PreservedStatePreservedDisk} message PreservedStatePreservedDisk
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PreservedStatePreservedDisk.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.mode != null && message.hasOwnProperty("mode")) {
                                object.mode = message.mode;
                                if (options.oneofs)
                                    object._mode = "mode";
                            }
                            if (message.source != null && message.hasOwnProperty("source")) {
                                object.source = message.source;
                                if (options.oneofs)
                                    object._source = "source";
                            }
                            if (message.autoDelete != null && message.hasOwnProperty("autoDelete")) {
                                object.autoDelete = message.autoDelete;
                                if (options.oneofs)
                                    object._autoDelete = "autoDelete";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PreservedStatePreservedDisk to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PreservedStatePreservedDisk
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PreservedStatePreservedDisk.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PreservedStatePreservedDisk
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PreservedStatePreservedDisk
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PreservedStatePreservedDisk.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PreservedStatePreservedDisk";
                        };
    
                        /**
                         * AutoDelete enum.
                         * @name google.cloud.compute.v1.PreservedStatePreservedDisk.AutoDelete
                         * @enum {number}
                         * @property {number} UNDEFINED_AUTO_DELETE=0 UNDEFINED_AUTO_DELETE value
                         * @property {number} NEVER=74175084 NEVER value
                         * @property {number} ON_PERMANENT_INSTANCE_DELETION=95727719 ON_PERMANENT_INSTANCE_DELETION value
                         */
                        PreservedStatePreservedDisk.AutoDelete = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_AUTO_DELETE"] = 0;
                            values[valuesById[74175084] = "NEVER"] = 74175084;
                            values[valuesById[95727719] = "ON_PERMANENT_INSTANCE_DELETION"] = 95727719;
                            return values;
                        })();
    
                        /**
                         * Mode enum.
                         * @name google.cloud.compute.v1.PreservedStatePreservedDisk.Mode
                         * @enum {number}
                         * @property {number} UNDEFINED_MODE=0 UNDEFINED_MODE value
                         * @property {number} READ_ONLY=91950261 READ_ONLY value
                         * @property {number} READ_WRITE=173607894 READ_WRITE value
                         */
                        PreservedStatePreservedDisk.Mode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_MODE"] = 0;
                            values[valuesById[91950261] = "READ_ONLY"] = 91950261;
                            values[valuesById[173607894] = "READ_WRITE"] = 173607894;
                            return values;
                        })();
    
                        return PreservedStatePreservedDisk;
                    })();
    
                    v1.PreviewRouterRequest = (function() {
    
                        /**
                         * Properties of a PreviewRouterRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IPreviewRouterRequest
                         * @property {string|null} [project] PreviewRouterRequest project
                         * @property {string|null} [region] PreviewRouterRequest region
                         * @property {string|null} [router] PreviewRouterRequest router
                         * @property {google.cloud.compute.v1.IRouter|null} [routerResource] PreviewRouterRequest routerResource
                         */
    
                        /**
                         * Constructs a new PreviewRouterRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PreviewRouterRequest.
                         * @implements IPreviewRouterRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IPreviewRouterRequest=} [properties] Properties to set
                         */
                        function PreviewRouterRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PreviewRouterRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.PreviewRouterRequest
                         * @instance
                         */
                        PreviewRouterRequest.prototype.project = "";
    
                        /**
                         * PreviewRouterRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.PreviewRouterRequest
                         * @instance
                         */
                        PreviewRouterRequest.prototype.region = "";
    
                        /**
                         * PreviewRouterRequest router.
                         * @member {string} router
                         * @memberof google.cloud.compute.v1.PreviewRouterRequest
                         * @instance
                         */
                        PreviewRouterRequest.prototype.router = "";
    
                        /**
                         * PreviewRouterRequest routerResource.
                         * @member {google.cloud.compute.v1.IRouter|null|undefined} routerResource
                         * @memberof google.cloud.compute.v1.PreviewRouterRequest
                         * @instance
                         */
                        PreviewRouterRequest.prototype.routerResource = null;
    
                        /**
                         * Creates a new PreviewRouterRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PreviewRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPreviewRouterRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PreviewRouterRequest} PreviewRouterRequest instance
                         */
                        PreviewRouterRequest.create = function create(properties) {
                            return new PreviewRouterRequest(properties);
                        };
    
                        /**
                         * Encodes the specified PreviewRouterRequest message. Does not implicitly {@link google.cloud.compute.v1.PreviewRouterRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PreviewRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPreviewRouterRequest} message PreviewRouterRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PreviewRouterRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.router != null && Object.hasOwnProperty.call(message, "router"))
                                writer.uint32(/* id 148608841, wireType 2 =*/1188870730).string(message.router);
                            if (message.routerResource != null && Object.hasOwnProperty.call(message, "routerResource"))
                                $root.google.cloud.compute.v1.Router.encode(message.routerResource, writer.uint32(/* id 155222084, wireType 2 =*/1241776674).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PreviewRouterRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PreviewRouterRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PreviewRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IPreviewRouterRequest} message PreviewRouterRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PreviewRouterRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PreviewRouterRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PreviewRouterRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PreviewRouterRequest} PreviewRouterRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PreviewRouterRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PreviewRouterRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 148608841: {
                                        message.router = reader.string();
                                        break;
                                    }
                                case 155222084: {
                                        message.routerResource = $root.google.cloud.compute.v1.Router.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PreviewRouterRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PreviewRouterRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PreviewRouterRequest} PreviewRouterRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PreviewRouterRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PreviewRouterRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PreviewRouterRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PreviewRouterRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.router != null && message.hasOwnProperty("router"))
                                if (!$util.isString(message.router))
                                    return "router: string expected";
                            if (message.routerResource != null && message.hasOwnProperty("routerResource")) {
                                var error = $root.google.cloud.compute.v1.Router.verify(message.routerResource);
                                if (error)
                                    return "routerResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PreviewRouterRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PreviewRouterRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PreviewRouterRequest} PreviewRouterRequest
                         */
                        PreviewRouterRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PreviewRouterRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PreviewRouterRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.router != null)
                                message.router = String(object.router);
                            if (object.routerResource != null) {
                                if (typeof object.routerResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PreviewRouterRequest.routerResource: object expected");
                                message.routerResource = $root.google.cloud.compute.v1.Router.fromObject(object.routerResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PreviewRouterRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PreviewRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.PreviewRouterRequest} message PreviewRouterRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PreviewRouterRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.router = "";
                                object.routerResource = null;
                                object.project = "";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.router != null && message.hasOwnProperty("router"))
                                object.router = message.router;
                            if (message.routerResource != null && message.hasOwnProperty("routerResource"))
                                object.routerResource = $root.google.cloud.compute.v1.Router.toObject(message.routerResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this PreviewRouterRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PreviewRouterRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PreviewRouterRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PreviewRouterRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PreviewRouterRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PreviewRouterRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PreviewRouterRequest";
                        };
    
                        return PreviewRouterRequest;
                    })();
    
                    v1.Project = (function() {
    
                        /**
                         * Properties of a Project.
                         * @memberof google.cloud.compute.v1
                         * @interface IProject
                         * @property {google.cloud.compute.v1.IMetadata|null} [commonInstanceMetadata] Project commonInstanceMetadata
                         * @property {string|null} [creationTimestamp] Project creationTimestamp
                         * @property {string|null} [defaultNetworkTier] Project defaultNetworkTier
                         * @property {string|null} [defaultServiceAccount] Project defaultServiceAccount
                         * @property {string|null} [description] Project description
                         * @property {Array.<string>|null} [enabledFeatures] Project enabledFeatures
                         * @property {number|Long|null} [id] Project id
                         * @property {string|null} [kind] Project kind
                         * @property {string|null} [name] Project name
                         * @property {Array.<google.cloud.compute.v1.IQuota>|null} [quotas] Project quotas
                         * @property {string|null} [selfLink] Project selfLink
                         * @property {google.cloud.compute.v1.IUsageExportLocation|null} [usageExportLocation] Project usageExportLocation
                         * @property {string|null} [xpnProjectStatus] Project xpnProjectStatus
                         */
    
                        /**
                         * Constructs a new Project.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Project.
                         * @implements IProject
                         * @constructor
                         * @param {google.cloud.compute.v1.IProject=} [properties] Properties to set
                         */
                        function Project(properties) {
                            this.enabledFeatures = [];
                            this.quotas = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Project commonInstanceMetadata.
                         * @member {google.cloud.compute.v1.IMetadata|null|undefined} commonInstanceMetadata
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Project.prototype.commonInstanceMetadata = null;
    
                        /**
                         * Project creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Project.prototype.creationTimestamp = null;
    
                        /**
                         * Project defaultNetworkTier.
                         * @member {string|null|undefined} defaultNetworkTier
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Project.prototype.defaultNetworkTier = null;
    
                        /**
                         * Project defaultServiceAccount.
                         * @member {string|null|undefined} defaultServiceAccount
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Project.prototype.defaultServiceAccount = null;
    
                        /**
                         * Project description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Project.prototype.description = null;
    
                        /**
                         * Project enabledFeatures.
                         * @member {Array.<string>} enabledFeatures
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Project.prototype.enabledFeatures = $util.emptyArray;
    
                        /**
                         * Project id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Project.prototype.id = null;
    
                        /**
                         * Project kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Project.prototype.kind = null;
    
                        /**
                         * Project name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Project.prototype.name = null;
    
                        /**
                         * Project quotas.
                         * @member {Array.<google.cloud.compute.v1.IQuota>} quotas
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Project.prototype.quotas = $util.emptyArray;
    
                        /**
                         * Project selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Project.prototype.selfLink = null;
    
                        /**
                         * Project usageExportLocation.
                         * @member {google.cloud.compute.v1.IUsageExportLocation|null|undefined} usageExportLocation
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Project.prototype.usageExportLocation = null;
    
                        /**
                         * Project xpnProjectStatus.
                         * @member {string|null|undefined} xpnProjectStatus
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Project.prototype.xpnProjectStatus = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Project _commonInstanceMetadata.
                         * @member {"commonInstanceMetadata"|undefined} _commonInstanceMetadata
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Object.defineProperty(Project.prototype, "_commonInstanceMetadata", {
                            get: $util.oneOfGetter($oneOfFields = ["commonInstanceMetadata"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Project _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Object.defineProperty(Project.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Project _defaultNetworkTier.
                         * @member {"defaultNetworkTier"|undefined} _defaultNetworkTier
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Object.defineProperty(Project.prototype, "_defaultNetworkTier", {
                            get: $util.oneOfGetter($oneOfFields = ["defaultNetworkTier"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Project _defaultServiceAccount.
                         * @member {"defaultServiceAccount"|undefined} _defaultServiceAccount
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Object.defineProperty(Project.prototype, "_defaultServiceAccount", {
                            get: $util.oneOfGetter($oneOfFields = ["defaultServiceAccount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Project _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Object.defineProperty(Project.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Project _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Object.defineProperty(Project.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Project _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Object.defineProperty(Project.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Project _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Object.defineProperty(Project.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Project _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Object.defineProperty(Project.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Project _usageExportLocation.
                         * @member {"usageExportLocation"|undefined} _usageExportLocation
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Object.defineProperty(Project.prototype, "_usageExportLocation", {
                            get: $util.oneOfGetter($oneOfFields = ["usageExportLocation"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Project _xpnProjectStatus.
                         * @member {"xpnProjectStatus"|undefined} _xpnProjectStatus
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         */
                        Object.defineProperty(Project.prototype, "_xpnProjectStatus", {
                            get: $util.oneOfGetter($oneOfFields = ["xpnProjectStatus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Project instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Project
                         * @static
                         * @param {google.cloud.compute.v1.IProject=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Project} Project instance
                         */
                        Project.create = function create(properties) {
                            return new Project(properties);
                        };
    
                        /**
                         * Encodes the specified Project message. Does not implicitly {@link google.cloud.compute.v1.Project.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Project
                         * @static
                         * @param {google.cloud.compute.v1.IProject} message Project message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Project.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.quotas != null && message.quotas.length)
                                for (var i = 0; i < message.quotas.length; ++i)
                                    $root.google.cloud.compute.v1.Quota.encode(message.quotas[i], writer.uint32(/* id 125341947, wireType 2 =*/1002735578).fork()).ldelim();
                            if (message.commonInstanceMetadata != null && Object.hasOwnProperty.call(message, "commonInstanceMetadata"))
                                $root.google.cloud.compute.v1.Metadata.encode(message.commonInstanceMetadata, writer.uint32(/* id 185794117, wireType 2 =*/1486352938).fork()).ldelim();
                            if (message.xpnProjectStatus != null && Object.hasOwnProperty.call(message, "xpnProjectStatus"))
                                writer.uint32(/* id 228419265, wireType 2 =*/1827354122).string(message.xpnProjectStatus);
                            if (message.defaultServiceAccount != null && Object.hasOwnProperty.call(message, "defaultServiceAccount"))
                                writer.uint32(/* id 298712229, wireType 2 =*/2389697834).string(message.defaultServiceAccount);
                            if (message.usageExportLocation != null && Object.hasOwnProperty.call(message, "usageExportLocation"))
                                $root.google.cloud.compute.v1.UsageExportLocation.encode(message.usageExportLocation, writer.uint32(/* id 347543874, wireType 2 =*/2780350994).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.enabledFeatures != null && message.enabledFeatures.length)
                                for (var i = 0; i < message.enabledFeatures.length; ++i)
                                    writer.uint32(/* id 469017467, wireType 2 =*/3752139738).string(message.enabledFeatures[i]);
                            if (message.defaultNetworkTier != null && Object.hasOwnProperty.call(message, "defaultNetworkTier"))
                                writer.uint32(/* id 471753361, wireType 2 =*/3774026890).string(message.defaultNetworkTier);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Project message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Project.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Project
                         * @static
                         * @param {google.cloud.compute.v1.IProject} message Project message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Project.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Project message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Project
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Project} Project
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Project.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Project();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 185794117: {
                                        message.commonInstanceMetadata = $root.google.cloud.compute.v1.Metadata.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 471753361: {
                                        message.defaultNetworkTier = reader.string();
                                        break;
                                    }
                                case 298712229: {
                                        message.defaultServiceAccount = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 469017467: {
                                        if (!(message.enabledFeatures && message.enabledFeatures.length))
                                            message.enabledFeatures = [];
                                        message.enabledFeatures.push(reader.string());
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 125341947: {
                                        if (!(message.quotas && message.quotas.length))
                                            message.quotas = [];
                                        message.quotas.push($root.google.cloud.compute.v1.Quota.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 347543874: {
                                        message.usageExportLocation = $root.google.cloud.compute.v1.UsageExportLocation.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 228419265: {
                                        message.xpnProjectStatus = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Project message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Project
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Project} Project
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Project.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Project message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Project
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Project.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.commonInstanceMetadata != null && message.hasOwnProperty("commonInstanceMetadata")) {
                                properties._commonInstanceMetadata = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Metadata.verify(message.commonInstanceMetadata);
                                    if (error)
                                        return "commonInstanceMetadata." + error;
                                }
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.defaultNetworkTier != null && message.hasOwnProperty("defaultNetworkTier")) {
                                properties._defaultNetworkTier = 1;
                                if (!$util.isString(message.defaultNetworkTier))
                                    return "defaultNetworkTier: string expected";
                            }
                            if (message.defaultServiceAccount != null && message.hasOwnProperty("defaultServiceAccount")) {
                                properties._defaultServiceAccount = 1;
                                if (!$util.isString(message.defaultServiceAccount))
                                    return "defaultServiceAccount: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.enabledFeatures != null && message.hasOwnProperty("enabledFeatures")) {
                                if (!Array.isArray(message.enabledFeatures))
                                    return "enabledFeatures: array expected";
                                for (var i = 0; i < message.enabledFeatures.length; ++i)
                                    if (!$util.isString(message.enabledFeatures[i]))
                                        return "enabledFeatures: string[] expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.quotas != null && message.hasOwnProperty("quotas")) {
                                if (!Array.isArray(message.quotas))
                                    return "quotas: array expected";
                                for (var i = 0; i < message.quotas.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Quota.verify(message.quotas[i]);
                                    if (error)
                                        return "quotas." + error;
                                }
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.usageExportLocation != null && message.hasOwnProperty("usageExportLocation")) {
                                properties._usageExportLocation = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.UsageExportLocation.verify(message.usageExportLocation);
                                    if (error)
                                        return "usageExportLocation." + error;
                                }
                            }
                            if (message.xpnProjectStatus != null && message.hasOwnProperty("xpnProjectStatus")) {
                                properties._xpnProjectStatus = 1;
                                if (!$util.isString(message.xpnProjectStatus))
                                    return "xpnProjectStatus: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Project message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Project
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Project} Project
                         */
                        Project.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Project)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Project();
                            if (object.commonInstanceMetadata != null) {
                                if (typeof object.commonInstanceMetadata !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Project.commonInstanceMetadata: object expected");
                                message.commonInstanceMetadata = $root.google.cloud.compute.v1.Metadata.fromObject(object.commonInstanceMetadata);
                            }
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.defaultNetworkTier != null)
                                message.defaultNetworkTier = String(object.defaultNetworkTier);
                            if (object.defaultServiceAccount != null)
                                message.defaultServiceAccount = String(object.defaultServiceAccount);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.enabledFeatures) {
                                if (!Array.isArray(object.enabledFeatures))
                                    throw TypeError(".google.cloud.compute.v1.Project.enabledFeatures: array expected");
                                message.enabledFeatures = [];
                                for (var i = 0; i < object.enabledFeatures.length; ++i)
                                    message.enabledFeatures[i] = String(object.enabledFeatures[i]);
                            }
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.quotas) {
                                if (!Array.isArray(object.quotas))
                                    throw TypeError(".google.cloud.compute.v1.Project.quotas: array expected");
                                message.quotas = [];
                                for (var i = 0; i < object.quotas.length; ++i) {
                                    if (typeof object.quotas[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Project.quotas: object expected");
                                    message.quotas[i] = $root.google.cloud.compute.v1.Quota.fromObject(object.quotas[i]);
                                }
                            }
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.usageExportLocation != null) {
                                if (typeof object.usageExportLocation !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Project.usageExportLocation: object expected");
                                message.usageExportLocation = $root.google.cloud.compute.v1.UsageExportLocation.fromObject(object.usageExportLocation);
                            }
                            if (object.xpnProjectStatus != null)
                                message.xpnProjectStatus = String(object.xpnProjectStatus);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Project message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Project
                         * @static
                         * @param {google.cloud.compute.v1.Project} message Project
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Project.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.quotas = [];
                                object.enabledFeatures = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.quotas && message.quotas.length) {
                                object.quotas = [];
                                for (var j = 0; j < message.quotas.length; ++j)
                                    object.quotas[j] = $root.google.cloud.compute.v1.Quota.toObject(message.quotas[j], options);
                            }
                            if (message.commonInstanceMetadata != null && message.hasOwnProperty("commonInstanceMetadata")) {
                                object.commonInstanceMetadata = $root.google.cloud.compute.v1.Metadata.toObject(message.commonInstanceMetadata, options);
                                if (options.oneofs)
                                    object._commonInstanceMetadata = "commonInstanceMetadata";
                            }
                            if (message.xpnProjectStatus != null && message.hasOwnProperty("xpnProjectStatus")) {
                                object.xpnProjectStatus = message.xpnProjectStatus;
                                if (options.oneofs)
                                    object._xpnProjectStatus = "xpnProjectStatus";
                            }
                            if (message.defaultServiceAccount != null && message.hasOwnProperty("defaultServiceAccount")) {
                                object.defaultServiceAccount = message.defaultServiceAccount;
                                if (options.oneofs)
                                    object._defaultServiceAccount = "defaultServiceAccount";
                            }
                            if (message.usageExportLocation != null && message.hasOwnProperty("usageExportLocation")) {
                                object.usageExportLocation = $root.google.cloud.compute.v1.UsageExportLocation.toObject(message.usageExportLocation, options);
                                if (options.oneofs)
                                    object._usageExportLocation = "usageExportLocation";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.enabledFeatures && message.enabledFeatures.length) {
                                object.enabledFeatures = [];
                                for (var j = 0; j < message.enabledFeatures.length; ++j)
                                    object.enabledFeatures[j] = message.enabledFeatures[j];
                            }
                            if (message.defaultNetworkTier != null && message.hasOwnProperty("defaultNetworkTier")) {
                                object.defaultNetworkTier = message.defaultNetworkTier;
                                if (options.oneofs)
                                    object._defaultNetworkTier = "defaultNetworkTier";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Project to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Project
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Project.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Project
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Project
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Project.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Project";
                        };
    
                        /**
                         * DefaultNetworkTier enum.
                         * @name google.cloud.compute.v1.Project.DefaultNetworkTier
                         * @enum {number}
                         * @property {number} UNDEFINED_DEFAULT_NETWORK_TIER=0 UNDEFINED_DEFAULT_NETWORK_TIER value
                         * @property {number} FIXED_STANDARD=310464328 FIXED_STANDARD value
                         * @property {number} PREMIUM=399530551 PREMIUM value
                         * @property {number} STANDARD=484642493 STANDARD value
                         * @property {number} STANDARD_OVERRIDES_FIXED_STANDARD=465847234 STANDARD_OVERRIDES_FIXED_STANDARD value
                         */
                        Project.DefaultNetworkTier = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_DEFAULT_NETWORK_TIER"] = 0;
                            values[valuesById[310464328] = "FIXED_STANDARD"] = 310464328;
                            values[valuesById[399530551] = "PREMIUM"] = 399530551;
                            values[valuesById[484642493] = "STANDARD"] = 484642493;
                            values[valuesById[465847234] = "STANDARD_OVERRIDES_FIXED_STANDARD"] = 465847234;
                            return values;
                        })();
    
                        /**
                         * XpnProjectStatus enum.
                         * @name google.cloud.compute.v1.Project.XpnProjectStatus
                         * @enum {number}
                         * @property {number} UNDEFINED_XPN_PROJECT_STATUS=0 UNDEFINED_XPN_PROJECT_STATUS value
                         * @property {number} HOST=2223528 HOST value
                         * @property {number} UNSPECIFIED_XPN_PROJECT_STATUS=340393257 UNSPECIFIED_XPN_PROJECT_STATUS value
                         */
                        Project.XpnProjectStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_XPN_PROJECT_STATUS"] = 0;
                            values[valuesById[2223528] = "HOST"] = 2223528;
                            values[valuesById[340393257] = "UNSPECIFIED_XPN_PROJECT_STATUS"] = 340393257;
                            return values;
                        })();
    
                        return Project;
                    })();
    
                    v1.ProjectsDisableXpnResourceRequest = (function() {
    
                        /**
                         * Properties of a ProjectsDisableXpnResourceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IProjectsDisableXpnResourceRequest
                         * @property {google.cloud.compute.v1.IXpnResourceId|null} [xpnResource] ProjectsDisableXpnResourceRequest xpnResource
                         */
    
                        /**
                         * Constructs a new ProjectsDisableXpnResourceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ProjectsDisableXpnResourceRequest.
                         * @implements IProjectsDisableXpnResourceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IProjectsDisableXpnResourceRequest=} [properties] Properties to set
                         */
                        function ProjectsDisableXpnResourceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ProjectsDisableXpnResourceRequest xpnResource.
                         * @member {google.cloud.compute.v1.IXpnResourceId|null|undefined} xpnResource
                         * @memberof google.cloud.compute.v1.ProjectsDisableXpnResourceRequest
                         * @instance
                         */
                        ProjectsDisableXpnResourceRequest.prototype.xpnResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ProjectsDisableXpnResourceRequest _xpnResource.
                         * @member {"xpnResource"|undefined} _xpnResource
                         * @memberof google.cloud.compute.v1.ProjectsDisableXpnResourceRequest
                         * @instance
                         */
                        Object.defineProperty(ProjectsDisableXpnResourceRequest.prototype, "_xpnResource", {
                            get: $util.oneOfGetter($oneOfFields = ["xpnResource"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ProjectsDisableXpnResourceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ProjectsDisableXpnResourceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IProjectsDisableXpnResourceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ProjectsDisableXpnResourceRequest} ProjectsDisableXpnResourceRequest instance
                         */
                        ProjectsDisableXpnResourceRequest.create = function create(properties) {
                            return new ProjectsDisableXpnResourceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ProjectsDisableXpnResourceRequest message. Does not implicitly {@link google.cloud.compute.v1.ProjectsDisableXpnResourceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ProjectsDisableXpnResourceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IProjectsDisableXpnResourceRequest} message ProjectsDisableXpnResourceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProjectsDisableXpnResourceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.xpnResource != null && Object.hasOwnProperty.call(message, "xpnResource"))
                                $root.google.cloud.compute.v1.XpnResourceId.encode(message.xpnResource, writer.uint32(/* id 133384631, wireType 2 =*/1067077050).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ProjectsDisableXpnResourceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ProjectsDisableXpnResourceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ProjectsDisableXpnResourceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IProjectsDisableXpnResourceRequest} message ProjectsDisableXpnResourceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProjectsDisableXpnResourceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ProjectsDisableXpnResourceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ProjectsDisableXpnResourceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ProjectsDisableXpnResourceRequest} ProjectsDisableXpnResourceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProjectsDisableXpnResourceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ProjectsDisableXpnResourceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 133384631: {
                                        message.xpnResource = $root.google.cloud.compute.v1.XpnResourceId.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ProjectsDisableXpnResourceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ProjectsDisableXpnResourceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ProjectsDisableXpnResourceRequest} ProjectsDisableXpnResourceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProjectsDisableXpnResourceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ProjectsDisableXpnResourceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ProjectsDisableXpnResourceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProjectsDisableXpnResourceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.xpnResource != null && message.hasOwnProperty("xpnResource")) {
                                properties._xpnResource = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.XpnResourceId.verify(message.xpnResource);
                                    if (error)
                                        return "xpnResource." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ProjectsDisableXpnResourceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ProjectsDisableXpnResourceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ProjectsDisableXpnResourceRequest} ProjectsDisableXpnResourceRequest
                         */
                        ProjectsDisableXpnResourceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ProjectsDisableXpnResourceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ProjectsDisableXpnResourceRequest();
                            if (object.xpnResource != null) {
                                if (typeof object.xpnResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ProjectsDisableXpnResourceRequest.xpnResource: object expected");
                                message.xpnResource = $root.google.cloud.compute.v1.XpnResourceId.fromObject(object.xpnResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ProjectsDisableXpnResourceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ProjectsDisableXpnResourceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ProjectsDisableXpnResourceRequest} message ProjectsDisableXpnResourceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProjectsDisableXpnResourceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.xpnResource != null && message.hasOwnProperty("xpnResource")) {
                                object.xpnResource = $root.google.cloud.compute.v1.XpnResourceId.toObject(message.xpnResource, options);
                                if (options.oneofs)
                                    object._xpnResource = "xpnResource";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ProjectsDisableXpnResourceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ProjectsDisableXpnResourceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProjectsDisableXpnResourceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ProjectsDisableXpnResourceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ProjectsDisableXpnResourceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ProjectsDisableXpnResourceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ProjectsDisableXpnResourceRequest";
                        };
    
                        return ProjectsDisableXpnResourceRequest;
                    })();
    
                    v1.ProjectsEnableXpnResourceRequest = (function() {
    
                        /**
                         * Properties of a ProjectsEnableXpnResourceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IProjectsEnableXpnResourceRequest
                         * @property {google.cloud.compute.v1.IXpnResourceId|null} [xpnResource] ProjectsEnableXpnResourceRequest xpnResource
                         */
    
                        /**
                         * Constructs a new ProjectsEnableXpnResourceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ProjectsEnableXpnResourceRequest.
                         * @implements IProjectsEnableXpnResourceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IProjectsEnableXpnResourceRequest=} [properties] Properties to set
                         */
                        function ProjectsEnableXpnResourceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ProjectsEnableXpnResourceRequest xpnResource.
                         * @member {google.cloud.compute.v1.IXpnResourceId|null|undefined} xpnResource
                         * @memberof google.cloud.compute.v1.ProjectsEnableXpnResourceRequest
                         * @instance
                         */
                        ProjectsEnableXpnResourceRequest.prototype.xpnResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ProjectsEnableXpnResourceRequest _xpnResource.
                         * @member {"xpnResource"|undefined} _xpnResource
                         * @memberof google.cloud.compute.v1.ProjectsEnableXpnResourceRequest
                         * @instance
                         */
                        Object.defineProperty(ProjectsEnableXpnResourceRequest.prototype, "_xpnResource", {
                            get: $util.oneOfGetter($oneOfFields = ["xpnResource"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ProjectsEnableXpnResourceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ProjectsEnableXpnResourceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IProjectsEnableXpnResourceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ProjectsEnableXpnResourceRequest} ProjectsEnableXpnResourceRequest instance
                         */
                        ProjectsEnableXpnResourceRequest.create = function create(properties) {
                            return new ProjectsEnableXpnResourceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ProjectsEnableXpnResourceRequest message. Does not implicitly {@link google.cloud.compute.v1.ProjectsEnableXpnResourceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ProjectsEnableXpnResourceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IProjectsEnableXpnResourceRequest} message ProjectsEnableXpnResourceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProjectsEnableXpnResourceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.xpnResource != null && Object.hasOwnProperty.call(message, "xpnResource"))
                                $root.google.cloud.compute.v1.XpnResourceId.encode(message.xpnResource, writer.uint32(/* id 133384631, wireType 2 =*/1067077050).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ProjectsEnableXpnResourceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ProjectsEnableXpnResourceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ProjectsEnableXpnResourceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IProjectsEnableXpnResourceRequest} message ProjectsEnableXpnResourceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProjectsEnableXpnResourceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ProjectsEnableXpnResourceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ProjectsEnableXpnResourceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ProjectsEnableXpnResourceRequest} ProjectsEnableXpnResourceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProjectsEnableXpnResourceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ProjectsEnableXpnResourceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 133384631: {
                                        message.xpnResource = $root.google.cloud.compute.v1.XpnResourceId.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ProjectsEnableXpnResourceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ProjectsEnableXpnResourceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ProjectsEnableXpnResourceRequest} ProjectsEnableXpnResourceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProjectsEnableXpnResourceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ProjectsEnableXpnResourceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ProjectsEnableXpnResourceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProjectsEnableXpnResourceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.xpnResource != null && message.hasOwnProperty("xpnResource")) {
                                properties._xpnResource = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.XpnResourceId.verify(message.xpnResource);
                                    if (error)
                                        return "xpnResource." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ProjectsEnableXpnResourceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ProjectsEnableXpnResourceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ProjectsEnableXpnResourceRequest} ProjectsEnableXpnResourceRequest
                         */
                        ProjectsEnableXpnResourceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ProjectsEnableXpnResourceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ProjectsEnableXpnResourceRequest();
                            if (object.xpnResource != null) {
                                if (typeof object.xpnResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ProjectsEnableXpnResourceRequest.xpnResource: object expected");
                                message.xpnResource = $root.google.cloud.compute.v1.XpnResourceId.fromObject(object.xpnResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ProjectsEnableXpnResourceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ProjectsEnableXpnResourceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ProjectsEnableXpnResourceRequest} message ProjectsEnableXpnResourceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProjectsEnableXpnResourceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.xpnResource != null && message.hasOwnProperty("xpnResource")) {
                                object.xpnResource = $root.google.cloud.compute.v1.XpnResourceId.toObject(message.xpnResource, options);
                                if (options.oneofs)
                                    object._xpnResource = "xpnResource";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ProjectsEnableXpnResourceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ProjectsEnableXpnResourceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProjectsEnableXpnResourceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ProjectsEnableXpnResourceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ProjectsEnableXpnResourceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ProjectsEnableXpnResourceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ProjectsEnableXpnResourceRequest";
                        };
    
                        return ProjectsEnableXpnResourceRequest;
                    })();
    
                    v1.ProjectsGetXpnResources = (function() {
    
                        /**
                         * Properties of a ProjectsGetXpnResources.
                         * @memberof google.cloud.compute.v1
                         * @interface IProjectsGetXpnResources
                         * @property {string|null} [kind] ProjectsGetXpnResources kind
                         * @property {string|null} [nextPageToken] ProjectsGetXpnResources nextPageToken
                         * @property {Array.<google.cloud.compute.v1.IXpnResourceId>|null} [resources] ProjectsGetXpnResources resources
                         */
    
                        /**
                         * Constructs a new ProjectsGetXpnResources.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ProjectsGetXpnResources.
                         * @implements IProjectsGetXpnResources
                         * @constructor
                         * @param {google.cloud.compute.v1.IProjectsGetXpnResources=} [properties] Properties to set
                         */
                        function ProjectsGetXpnResources(properties) {
                            this.resources = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ProjectsGetXpnResources kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.ProjectsGetXpnResources
                         * @instance
                         */
                        ProjectsGetXpnResources.prototype.kind = null;
    
                        /**
                         * ProjectsGetXpnResources nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.ProjectsGetXpnResources
                         * @instance
                         */
                        ProjectsGetXpnResources.prototype.nextPageToken = null;
    
                        /**
                         * ProjectsGetXpnResources resources.
                         * @member {Array.<google.cloud.compute.v1.IXpnResourceId>} resources
                         * @memberof google.cloud.compute.v1.ProjectsGetXpnResources
                         * @instance
                         */
                        ProjectsGetXpnResources.prototype.resources = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ProjectsGetXpnResources _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.ProjectsGetXpnResources
                         * @instance
                         */
                        Object.defineProperty(ProjectsGetXpnResources.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ProjectsGetXpnResources _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.ProjectsGetXpnResources
                         * @instance
                         */
                        Object.defineProperty(ProjectsGetXpnResources.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ProjectsGetXpnResources instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ProjectsGetXpnResources
                         * @static
                         * @param {google.cloud.compute.v1.IProjectsGetXpnResources=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ProjectsGetXpnResources} ProjectsGetXpnResources instance
                         */
                        ProjectsGetXpnResources.create = function create(properties) {
                            return new ProjectsGetXpnResources(properties);
                        };
    
                        /**
                         * Encodes the specified ProjectsGetXpnResources message. Does not implicitly {@link google.cloud.compute.v1.ProjectsGetXpnResources.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ProjectsGetXpnResources
                         * @static
                         * @param {google.cloud.compute.v1.IProjectsGetXpnResources} message ProjectsGetXpnResources message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProjectsGetXpnResources.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.resources != null && message.resources.length)
                                for (var i = 0; i < message.resources.length; ++i)
                                    $root.google.cloud.compute.v1.XpnResourceId.encode(message.resources[i], writer.uint32(/* id 164412965, wireType 2 =*/1315303722).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ProjectsGetXpnResources message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ProjectsGetXpnResources.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ProjectsGetXpnResources
                         * @static
                         * @param {google.cloud.compute.v1.IProjectsGetXpnResources} message ProjectsGetXpnResources message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProjectsGetXpnResources.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ProjectsGetXpnResources message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ProjectsGetXpnResources
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ProjectsGetXpnResources} ProjectsGetXpnResources
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProjectsGetXpnResources.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ProjectsGetXpnResources();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 164412965: {
                                        if (!(message.resources && message.resources.length))
                                            message.resources = [];
                                        message.resources.push($root.google.cloud.compute.v1.XpnResourceId.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ProjectsGetXpnResources message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ProjectsGetXpnResources
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ProjectsGetXpnResources} ProjectsGetXpnResources
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProjectsGetXpnResources.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ProjectsGetXpnResources message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ProjectsGetXpnResources
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProjectsGetXpnResources.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.resources != null && message.hasOwnProperty("resources")) {
                                if (!Array.isArray(message.resources))
                                    return "resources: array expected";
                                for (var i = 0; i < message.resources.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.XpnResourceId.verify(message.resources[i]);
                                    if (error)
                                        return "resources." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ProjectsGetXpnResources message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ProjectsGetXpnResources
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ProjectsGetXpnResources} ProjectsGetXpnResources
                         */
                        ProjectsGetXpnResources.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ProjectsGetXpnResources)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ProjectsGetXpnResources();
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.resources) {
                                if (!Array.isArray(object.resources))
                                    throw TypeError(".google.cloud.compute.v1.ProjectsGetXpnResources.resources: array expected");
                                message.resources = [];
                                for (var i = 0; i < object.resources.length; ++i) {
                                    if (typeof object.resources[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ProjectsGetXpnResources.resources: object expected");
                                    message.resources[i] = $root.google.cloud.compute.v1.XpnResourceId.fromObject(object.resources[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ProjectsGetXpnResources message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ProjectsGetXpnResources
                         * @static
                         * @param {google.cloud.compute.v1.ProjectsGetXpnResources} message ProjectsGetXpnResources
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProjectsGetXpnResources.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.resources = [];
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.resources && message.resources.length) {
                                object.resources = [];
                                for (var j = 0; j < message.resources.length; ++j)
                                    object.resources[j] = $root.google.cloud.compute.v1.XpnResourceId.toObject(message.resources[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ProjectsGetXpnResources to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ProjectsGetXpnResources
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProjectsGetXpnResources.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ProjectsGetXpnResources
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ProjectsGetXpnResources
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ProjectsGetXpnResources.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ProjectsGetXpnResources";
                        };
    
                        return ProjectsGetXpnResources;
                    })();
    
                    v1.ProjectsListXpnHostsRequest = (function() {
    
                        /**
                         * Properties of a ProjectsListXpnHostsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IProjectsListXpnHostsRequest
                         * @property {string|null} [organization] ProjectsListXpnHostsRequest organization
                         */
    
                        /**
                         * Constructs a new ProjectsListXpnHostsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ProjectsListXpnHostsRequest.
                         * @implements IProjectsListXpnHostsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IProjectsListXpnHostsRequest=} [properties] Properties to set
                         */
                        function ProjectsListXpnHostsRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ProjectsListXpnHostsRequest organization.
                         * @member {string|null|undefined} organization
                         * @memberof google.cloud.compute.v1.ProjectsListXpnHostsRequest
                         * @instance
                         */
                        ProjectsListXpnHostsRequest.prototype.organization = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ProjectsListXpnHostsRequest _organization.
                         * @member {"organization"|undefined} _organization
                         * @memberof google.cloud.compute.v1.ProjectsListXpnHostsRequest
                         * @instance
                         */
                        Object.defineProperty(ProjectsListXpnHostsRequest.prototype, "_organization", {
                            get: $util.oneOfGetter($oneOfFields = ["organization"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ProjectsListXpnHostsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ProjectsListXpnHostsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IProjectsListXpnHostsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ProjectsListXpnHostsRequest} ProjectsListXpnHostsRequest instance
                         */
                        ProjectsListXpnHostsRequest.create = function create(properties) {
                            return new ProjectsListXpnHostsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ProjectsListXpnHostsRequest message. Does not implicitly {@link google.cloud.compute.v1.ProjectsListXpnHostsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ProjectsListXpnHostsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IProjectsListXpnHostsRequest} message ProjectsListXpnHostsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProjectsListXpnHostsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.organization != null && Object.hasOwnProperty.call(message, "organization"))
                                writer.uint32(/* id 105180467, wireType 2 =*/841443738).string(message.organization);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ProjectsListXpnHostsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ProjectsListXpnHostsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ProjectsListXpnHostsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IProjectsListXpnHostsRequest} message ProjectsListXpnHostsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProjectsListXpnHostsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ProjectsListXpnHostsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ProjectsListXpnHostsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ProjectsListXpnHostsRequest} ProjectsListXpnHostsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProjectsListXpnHostsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ProjectsListXpnHostsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 105180467: {
                                        message.organization = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ProjectsListXpnHostsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ProjectsListXpnHostsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ProjectsListXpnHostsRequest} ProjectsListXpnHostsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProjectsListXpnHostsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ProjectsListXpnHostsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ProjectsListXpnHostsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProjectsListXpnHostsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.organization != null && message.hasOwnProperty("organization")) {
                                properties._organization = 1;
                                if (!$util.isString(message.organization))
                                    return "organization: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ProjectsListXpnHostsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ProjectsListXpnHostsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ProjectsListXpnHostsRequest} ProjectsListXpnHostsRequest
                         */
                        ProjectsListXpnHostsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ProjectsListXpnHostsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ProjectsListXpnHostsRequest();
                            if (object.organization != null)
                                message.organization = String(object.organization);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ProjectsListXpnHostsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ProjectsListXpnHostsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ProjectsListXpnHostsRequest} message ProjectsListXpnHostsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProjectsListXpnHostsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.organization != null && message.hasOwnProperty("organization")) {
                                object.organization = message.organization;
                                if (options.oneofs)
                                    object._organization = "organization";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ProjectsListXpnHostsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ProjectsListXpnHostsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProjectsListXpnHostsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ProjectsListXpnHostsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ProjectsListXpnHostsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ProjectsListXpnHostsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ProjectsListXpnHostsRequest";
                        };
    
                        return ProjectsListXpnHostsRequest;
                    })();
    
                    v1.ProjectsSetDefaultNetworkTierRequest = (function() {
    
                        /**
                         * Properties of a ProjectsSetDefaultNetworkTierRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IProjectsSetDefaultNetworkTierRequest
                         * @property {string|null} [networkTier] ProjectsSetDefaultNetworkTierRequest networkTier
                         */
    
                        /**
                         * Constructs a new ProjectsSetDefaultNetworkTierRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ProjectsSetDefaultNetworkTierRequest.
                         * @implements IProjectsSetDefaultNetworkTierRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IProjectsSetDefaultNetworkTierRequest=} [properties] Properties to set
                         */
                        function ProjectsSetDefaultNetworkTierRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ProjectsSetDefaultNetworkTierRequest networkTier.
                         * @member {string|null|undefined} networkTier
                         * @memberof google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest
                         * @instance
                         */
                        ProjectsSetDefaultNetworkTierRequest.prototype.networkTier = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ProjectsSetDefaultNetworkTierRequest _networkTier.
                         * @member {"networkTier"|undefined} _networkTier
                         * @memberof google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest
                         * @instance
                         */
                        Object.defineProperty(ProjectsSetDefaultNetworkTierRequest.prototype, "_networkTier", {
                            get: $util.oneOfGetter($oneOfFields = ["networkTier"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ProjectsSetDefaultNetworkTierRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest
                         * @static
                         * @param {google.cloud.compute.v1.IProjectsSetDefaultNetworkTierRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest} ProjectsSetDefaultNetworkTierRequest instance
                         */
                        ProjectsSetDefaultNetworkTierRequest.create = function create(properties) {
                            return new ProjectsSetDefaultNetworkTierRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ProjectsSetDefaultNetworkTierRequest message. Does not implicitly {@link google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest
                         * @static
                         * @param {google.cloud.compute.v1.IProjectsSetDefaultNetworkTierRequest} message ProjectsSetDefaultNetworkTierRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProjectsSetDefaultNetworkTierRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.networkTier != null && Object.hasOwnProperty.call(message, "networkTier"))
                                writer.uint32(/* id 517397843, wireType 2 =*/4139182746).string(message.networkTier);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ProjectsSetDefaultNetworkTierRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest
                         * @static
                         * @param {google.cloud.compute.v1.IProjectsSetDefaultNetworkTierRequest} message ProjectsSetDefaultNetworkTierRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ProjectsSetDefaultNetworkTierRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ProjectsSetDefaultNetworkTierRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest} ProjectsSetDefaultNetworkTierRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProjectsSetDefaultNetworkTierRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 517397843: {
                                        message.networkTier = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ProjectsSetDefaultNetworkTierRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest} ProjectsSetDefaultNetworkTierRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ProjectsSetDefaultNetworkTierRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ProjectsSetDefaultNetworkTierRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ProjectsSetDefaultNetworkTierRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.networkTier != null && message.hasOwnProperty("networkTier")) {
                                properties._networkTier = 1;
                                if (!$util.isString(message.networkTier))
                                    return "networkTier: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ProjectsSetDefaultNetworkTierRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest} ProjectsSetDefaultNetworkTierRequest
                         */
                        ProjectsSetDefaultNetworkTierRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest();
                            if (object.networkTier != null)
                                message.networkTier = String(object.networkTier);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ProjectsSetDefaultNetworkTierRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest
                         * @static
                         * @param {google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest} message ProjectsSetDefaultNetworkTierRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ProjectsSetDefaultNetworkTierRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.networkTier != null && message.hasOwnProperty("networkTier")) {
                                object.networkTier = message.networkTier;
                                if (options.oneofs)
                                    object._networkTier = "networkTier";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ProjectsSetDefaultNetworkTierRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ProjectsSetDefaultNetworkTierRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ProjectsSetDefaultNetworkTierRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ProjectsSetDefaultNetworkTierRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest";
                        };
    
                        /**
                         * NetworkTier enum.
                         * @name google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest.NetworkTier
                         * @enum {number}
                         * @property {number} UNDEFINED_NETWORK_TIER=0 UNDEFINED_NETWORK_TIER value
                         * @property {number} FIXED_STANDARD=310464328 FIXED_STANDARD value
                         * @property {number} PREMIUM=399530551 PREMIUM value
                         * @property {number} STANDARD=484642493 STANDARD value
                         * @property {number} STANDARD_OVERRIDES_FIXED_STANDARD=465847234 STANDARD_OVERRIDES_FIXED_STANDARD value
                         */
                        ProjectsSetDefaultNetworkTierRequest.NetworkTier = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_NETWORK_TIER"] = 0;
                            values[valuesById[310464328] = "FIXED_STANDARD"] = 310464328;
                            values[valuesById[399530551] = "PREMIUM"] = 399530551;
                            values[valuesById[484642493] = "STANDARD"] = 484642493;
                            values[valuesById[465847234] = "STANDARD_OVERRIDES_FIXED_STANDARD"] = 465847234;
                            return values;
                        })();
    
                        return ProjectsSetDefaultNetworkTierRequest;
                    })();
    
                    v1.PublicAdvertisedPrefix = (function() {
    
                        /**
                         * Properties of a PublicAdvertisedPrefix.
                         * @memberof google.cloud.compute.v1
                         * @interface IPublicAdvertisedPrefix
                         * @property {string|null} [creationTimestamp] PublicAdvertisedPrefix creationTimestamp
                         * @property {string|null} [description] PublicAdvertisedPrefix description
                         * @property {string|null} [dnsVerificationIp] PublicAdvertisedPrefix dnsVerificationIp
                         * @property {string|null} [fingerprint] PublicAdvertisedPrefix fingerprint
                         * @property {number|Long|null} [id] PublicAdvertisedPrefix id
                         * @property {string|null} [ipCidrRange] PublicAdvertisedPrefix ipCidrRange
                         * @property {string|null} [kind] PublicAdvertisedPrefix kind
                         * @property {string|null} [name] PublicAdvertisedPrefix name
                         * @property {Array.<google.cloud.compute.v1.IPublicAdvertisedPrefixPublicDelegatedPrefix>|null} [publicDelegatedPrefixs] PublicAdvertisedPrefix publicDelegatedPrefixs
                         * @property {string|null} [selfLink] PublicAdvertisedPrefix selfLink
                         * @property {string|null} [sharedSecret] PublicAdvertisedPrefix sharedSecret
                         * @property {string|null} [status] PublicAdvertisedPrefix status
                         */
    
                        /**
                         * Constructs a new PublicAdvertisedPrefix.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PublicAdvertisedPrefix.
                         * @implements IPublicAdvertisedPrefix
                         * @constructor
                         * @param {google.cloud.compute.v1.IPublicAdvertisedPrefix=} [properties] Properties to set
                         */
                        function PublicAdvertisedPrefix(properties) {
                            this.publicDelegatedPrefixs = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PublicAdvertisedPrefix creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        PublicAdvertisedPrefix.prototype.creationTimestamp = null;
    
                        /**
                         * PublicAdvertisedPrefix description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        PublicAdvertisedPrefix.prototype.description = null;
    
                        /**
                         * PublicAdvertisedPrefix dnsVerificationIp.
                         * @member {string|null|undefined} dnsVerificationIp
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        PublicAdvertisedPrefix.prototype.dnsVerificationIp = null;
    
                        /**
                         * PublicAdvertisedPrefix fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        PublicAdvertisedPrefix.prototype.fingerprint = null;
    
                        /**
                         * PublicAdvertisedPrefix id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        PublicAdvertisedPrefix.prototype.id = null;
    
                        /**
                         * PublicAdvertisedPrefix ipCidrRange.
                         * @member {string|null|undefined} ipCidrRange
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        PublicAdvertisedPrefix.prototype.ipCidrRange = null;
    
                        /**
                         * PublicAdvertisedPrefix kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        PublicAdvertisedPrefix.prototype.kind = null;
    
                        /**
                         * PublicAdvertisedPrefix name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        PublicAdvertisedPrefix.prototype.name = null;
    
                        /**
                         * PublicAdvertisedPrefix publicDelegatedPrefixs.
                         * @member {Array.<google.cloud.compute.v1.IPublicAdvertisedPrefixPublicDelegatedPrefix>} publicDelegatedPrefixs
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        PublicAdvertisedPrefix.prototype.publicDelegatedPrefixs = $util.emptyArray;
    
                        /**
                         * PublicAdvertisedPrefix selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        PublicAdvertisedPrefix.prototype.selfLink = null;
    
                        /**
                         * PublicAdvertisedPrefix sharedSecret.
                         * @member {string|null|undefined} sharedSecret
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        PublicAdvertisedPrefix.prototype.sharedSecret = null;
    
                        /**
                         * PublicAdvertisedPrefix status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        PublicAdvertisedPrefix.prototype.status = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PublicAdvertisedPrefix _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefix.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicAdvertisedPrefix _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefix.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicAdvertisedPrefix _dnsVerificationIp.
                         * @member {"dnsVerificationIp"|undefined} _dnsVerificationIp
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefix.prototype, "_dnsVerificationIp", {
                            get: $util.oneOfGetter($oneOfFields = ["dnsVerificationIp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicAdvertisedPrefix _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefix.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicAdvertisedPrefix _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefix.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicAdvertisedPrefix _ipCidrRange.
                         * @member {"ipCidrRange"|undefined} _ipCidrRange
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefix.prototype, "_ipCidrRange", {
                            get: $util.oneOfGetter($oneOfFields = ["ipCidrRange"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicAdvertisedPrefix _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefix.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicAdvertisedPrefix _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefix.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicAdvertisedPrefix _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefix.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicAdvertisedPrefix _sharedSecret.
                         * @member {"sharedSecret"|undefined} _sharedSecret
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefix.prototype, "_sharedSecret", {
                            get: $util.oneOfGetter($oneOfFields = ["sharedSecret"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicAdvertisedPrefix _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefix.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PublicAdvertisedPrefix instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @static
                         * @param {google.cloud.compute.v1.IPublicAdvertisedPrefix=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PublicAdvertisedPrefix} PublicAdvertisedPrefix instance
                         */
                        PublicAdvertisedPrefix.create = function create(properties) {
                            return new PublicAdvertisedPrefix(properties);
                        };
    
                        /**
                         * Encodes the specified PublicAdvertisedPrefix message. Does not implicitly {@link google.cloud.compute.v1.PublicAdvertisedPrefix.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @static
                         * @param {google.cloud.compute.v1.IPublicAdvertisedPrefix} message PublicAdvertisedPrefix message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PublicAdvertisedPrefix.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.ipCidrRange != null && Object.hasOwnProperty.call(message, "ipCidrRange"))
                                writer.uint32(/* id 98117322, wireType 2 =*/784938578).string(message.ipCidrRange);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.dnsVerificationIp != null && Object.hasOwnProperty.call(message, "dnsVerificationIp"))
                                writer.uint32(/* id 241011381, wireType 2 =*/1928091050).string(message.dnsVerificationIp);
                            if (message.sharedSecret != null && Object.hasOwnProperty.call(message, "sharedSecret"))
                                writer.uint32(/* id 381932490, wireType 2 =*/3055459922).string(message.sharedSecret);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.publicDelegatedPrefixs != null && message.publicDelegatedPrefixs.length)
                                for (var i = 0; i < message.publicDelegatedPrefixs.length; ++i)
                                    $root.google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix.encode(message.publicDelegatedPrefixs[i], writer.uint32(/* id 425811723, wireType 2 =*/3406493786).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PublicAdvertisedPrefix message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PublicAdvertisedPrefix.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @static
                         * @param {google.cloud.compute.v1.IPublicAdvertisedPrefix} message PublicAdvertisedPrefix message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PublicAdvertisedPrefix.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PublicAdvertisedPrefix message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PublicAdvertisedPrefix} PublicAdvertisedPrefix
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PublicAdvertisedPrefix.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PublicAdvertisedPrefix();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 241011381: {
                                        message.dnsVerificationIp = reader.string();
                                        break;
                                    }
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 98117322: {
                                        message.ipCidrRange = reader.string();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 425811723: {
                                        if (!(message.publicDelegatedPrefixs && message.publicDelegatedPrefixs.length))
                                            message.publicDelegatedPrefixs = [];
                                        message.publicDelegatedPrefixs.push($root.google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 381932490: {
                                        message.sharedSecret = reader.string();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PublicAdvertisedPrefix message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PublicAdvertisedPrefix} PublicAdvertisedPrefix
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PublicAdvertisedPrefix.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PublicAdvertisedPrefix message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PublicAdvertisedPrefix.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.dnsVerificationIp != null && message.hasOwnProperty("dnsVerificationIp")) {
                                properties._dnsVerificationIp = 1;
                                if (!$util.isString(message.dnsVerificationIp))
                                    return "dnsVerificationIp: string expected";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.ipCidrRange != null && message.hasOwnProperty("ipCidrRange")) {
                                properties._ipCidrRange = 1;
                                if (!$util.isString(message.ipCidrRange))
                                    return "ipCidrRange: string expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.publicDelegatedPrefixs != null && message.hasOwnProperty("publicDelegatedPrefixs")) {
                                if (!Array.isArray(message.publicDelegatedPrefixs))
                                    return "publicDelegatedPrefixs: array expected";
                                for (var i = 0; i < message.publicDelegatedPrefixs.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix.verify(message.publicDelegatedPrefixs[i]);
                                    if (error)
                                        return "publicDelegatedPrefixs." + error;
                                }
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.sharedSecret != null && message.hasOwnProperty("sharedSecret")) {
                                properties._sharedSecret = 1;
                                if (!$util.isString(message.sharedSecret))
                                    return "sharedSecret: string expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PublicAdvertisedPrefix message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PublicAdvertisedPrefix} PublicAdvertisedPrefix
                         */
                        PublicAdvertisedPrefix.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PublicAdvertisedPrefix)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PublicAdvertisedPrefix();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.dnsVerificationIp != null)
                                message.dnsVerificationIp = String(object.dnsVerificationIp);
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.ipCidrRange != null)
                                message.ipCidrRange = String(object.ipCidrRange);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.publicDelegatedPrefixs) {
                                if (!Array.isArray(object.publicDelegatedPrefixs))
                                    throw TypeError(".google.cloud.compute.v1.PublicAdvertisedPrefix.publicDelegatedPrefixs: array expected");
                                message.publicDelegatedPrefixs = [];
                                for (var i = 0; i < object.publicDelegatedPrefixs.length; ++i) {
                                    if (typeof object.publicDelegatedPrefixs[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.PublicAdvertisedPrefix.publicDelegatedPrefixs: object expected");
                                    message.publicDelegatedPrefixs[i] = $root.google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix.fromObject(object.publicDelegatedPrefixs[i]);
                                }
                            }
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.sharedSecret != null)
                                message.sharedSecret = String(object.sharedSecret);
                            if (object.status != null)
                                message.status = String(object.status);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PublicAdvertisedPrefix message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @static
                         * @param {google.cloud.compute.v1.PublicAdvertisedPrefix} message PublicAdvertisedPrefix
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PublicAdvertisedPrefix.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.publicDelegatedPrefixs = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.ipCidrRange != null && message.hasOwnProperty("ipCidrRange")) {
                                object.ipCidrRange = message.ipCidrRange;
                                if (options.oneofs)
                                    object._ipCidrRange = "ipCidrRange";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.dnsVerificationIp != null && message.hasOwnProperty("dnsVerificationIp")) {
                                object.dnsVerificationIp = message.dnsVerificationIp;
                                if (options.oneofs)
                                    object._dnsVerificationIp = "dnsVerificationIp";
                            }
                            if (message.sharedSecret != null && message.hasOwnProperty("sharedSecret")) {
                                object.sharedSecret = message.sharedSecret;
                                if (options.oneofs)
                                    object._sharedSecret = "sharedSecret";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.publicDelegatedPrefixs && message.publicDelegatedPrefixs.length) {
                                object.publicDelegatedPrefixs = [];
                                for (var j = 0; j < message.publicDelegatedPrefixs.length; ++j)
                                    object.publicDelegatedPrefixs[j] = $root.google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix.toObject(message.publicDelegatedPrefixs[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PublicAdvertisedPrefix to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PublicAdvertisedPrefix.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PublicAdvertisedPrefix
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefix
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PublicAdvertisedPrefix.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PublicAdvertisedPrefix";
                        };
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.PublicAdvertisedPrefix.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} INITIAL=518841124 INITIAL value
                         * @property {number} PREFIX_CONFIGURATION_COMPLETE=480889551 PREFIX_CONFIGURATION_COMPLETE value
                         * @property {number} PREFIX_CONFIGURATION_IN_PROGRESS=378550961 PREFIX_CONFIGURATION_IN_PROGRESS value
                         * @property {number} PREFIX_REMOVAL_IN_PROGRESS=284375783 PREFIX_REMOVAL_IN_PROGRESS value
                         * @property {number} PTR_CONFIGURED=513497167 PTR_CONFIGURED value
                         * @property {number} REVERSE_DNS_LOOKUP_FAILED=295755183 REVERSE_DNS_LOOKUP_FAILED value
                         * @property {number} VALIDATED=66197998 VALIDATED value
                         */
                        PublicAdvertisedPrefix.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[518841124] = "INITIAL"] = 518841124;
                            values[valuesById[480889551] = "PREFIX_CONFIGURATION_COMPLETE"] = 480889551;
                            values[valuesById[378550961] = "PREFIX_CONFIGURATION_IN_PROGRESS"] = 378550961;
                            values[valuesById[284375783] = "PREFIX_REMOVAL_IN_PROGRESS"] = 284375783;
                            values[valuesById[513497167] = "PTR_CONFIGURED"] = 513497167;
                            values[valuesById[295755183] = "REVERSE_DNS_LOOKUP_FAILED"] = 295755183;
                            values[valuesById[66197998] = "VALIDATED"] = 66197998;
                            return values;
                        })();
    
                        return PublicAdvertisedPrefix;
                    })();
    
                    v1.PublicAdvertisedPrefixList = (function() {
    
                        /**
                         * Properties of a PublicAdvertisedPrefixList.
                         * @memberof google.cloud.compute.v1
                         * @interface IPublicAdvertisedPrefixList
                         * @property {string|null} [id] PublicAdvertisedPrefixList id
                         * @property {Array.<google.cloud.compute.v1.IPublicAdvertisedPrefix>|null} [items] PublicAdvertisedPrefixList items
                         * @property {string|null} [kind] PublicAdvertisedPrefixList kind
                         * @property {string|null} [nextPageToken] PublicAdvertisedPrefixList nextPageToken
                         * @property {string|null} [selfLink] PublicAdvertisedPrefixList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] PublicAdvertisedPrefixList warning
                         */
    
                        /**
                         * Constructs a new PublicAdvertisedPrefixList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PublicAdvertisedPrefixList.
                         * @implements IPublicAdvertisedPrefixList
                         * @constructor
                         * @param {google.cloud.compute.v1.IPublicAdvertisedPrefixList=} [properties] Properties to set
                         */
                        function PublicAdvertisedPrefixList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PublicAdvertisedPrefixList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @instance
                         */
                        PublicAdvertisedPrefixList.prototype.id = null;
    
                        /**
                         * PublicAdvertisedPrefixList items.
                         * @member {Array.<google.cloud.compute.v1.IPublicAdvertisedPrefix>} items
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @instance
                         */
                        PublicAdvertisedPrefixList.prototype.items = $util.emptyArray;
    
                        /**
                         * PublicAdvertisedPrefixList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @instance
                         */
                        PublicAdvertisedPrefixList.prototype.kind = null;
    
                        /**
                         * PublicAdvertisedPrefixList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @instance
                         */
                        PublicAdvertisedPrefixList.prototype.nextPageToken = null;
    
                        /**
                         * PublicAdvertisedPrefixList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @instance
                         */
                        PublicAdvertisedPrefixList.prototype.selfLink = null;
    
                        /**
                         * PublicAdvertisedPrefixList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @instance
                         */
                        PublicAdvertisedPrefixList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PublicAdvertisedPrefixList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefixList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicAdvertisedPrefixList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefixList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicAdvertisedPrefixList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefixList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicAdvertisedPrefixList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefixList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicAdvertisedPrefixList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefixList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PublicAdvertisedPrefixList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @static
                         * @param {google.cloud.compute.v1.IPublicAdvertisedPrefixList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PublicAdvertisedPrefixList} PublicAdvertisedPrefixList instance
                         */
                        PublicAdvertisedPrefixList.create = function create(properties) {
                            return new PublicAdvertisedPrefixList(properties);
                        };
    
                        /**
                         * Encodes the specified PublicAdvertisedPrefixList message. Does not implicitly {@link google.cloud.compute.v1.PublicAdvertisedPrefixList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @static
                         * @param {google.cloud.compute.v1.IPublicAdvertisedPrefixList} message PublicAdvertisedPrefixList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PublicAdvertisedPrefixList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.PublicAdvertisedPrefix.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PublicAdvertisedPrefixList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PublicAdvertisedPrefixList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @static
                         * @param {google.cloud.compute.v1.IPublicAdvertisedPrefixList} message PublicAdvertisedPrefixList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PublicAdvertisedPrefixList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PublicAdvertisedPrefixList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PublicAdvertisedPrefixList} PublicAdvertisedPrefixList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PublicAdvertisedPrefixList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PublicAdvertisedPrefixList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.PublicAdvertisedPrefix.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PublicAdvertisedPrefixList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PublicAdvertisedPrefixList} PublicAdvertisedPrefixList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PublicAdvertisedPrefixList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PublicAdvertisedPrefixList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PublicAdvertisedPrefixList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PublicAdvertisedPrefix.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PublicAdvertisedPrefixList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PublicAdvertisedPrefixList} PublicAdvertisedPrefixList
                         */
                        PublicAdvertisedPrefixList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PublicAdvertisedPrefixList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PublicAdvertisedPrefixList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.PublicAdvertisedPrefixList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.PublicAdvertisedPrefixList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.PublicAdvertisedPrefix.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PublicAdvertisedPrefixList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PublicAdvertisedPrefixList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @static
                         * @param {google.cloud.compute.v1.PublicAdvertisedPrefixList} message PublicAdvertisedPrefixList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PublicAdvertisedPrefixList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.PublicAdvertisedPrefix.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PublicAdvertisedPrefixList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PublicAdvertisedPrefixList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PublicAdvertisedPrefixList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PublicAdvertisedPrefixList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PublicAdvertisedPrefixList";
                        };
    
                        return PublicAdvertisedPrefixList;
                    })();
    
                    v1.PublicAdvertisedPrefixPublicDelegatedPrefix = (function() {
    
                        /**
                         * Properties of a PublicAdvertisedPrefixPublicDelegatedPrefix.
                         * @memberof google.cloud.compute.v1
                         * @interface IPublicAdvertisedPrefixPublicDelegatedPrefix
                         * @property {string|null} [ipRange] PublicAdvertisedPrefixPublicDelegatedPrefix ipRange
                         * @property {string|null} [name] PublicAdvertisedPrefixPublicDelegatedPrefix name
                         * @property {string|null} [project] PublicAdvertisedPrefixPublicDelegatedPrefix project
                         * @property {string|null} [region] PublicAdvertisedPrefixPublicDelegatedPrefix region
                         * @property {string|null} [status] PublicAdvertisedPrefixPublicDelegatedPrefix status
                         */
    
                        /**
                         * Constructs a new PublicAdvertisedPrefixPublicDelegatedPrefix.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PublicAdvertisedPrefixPublicDelegatedPrefix.
                         * @implements IPublicAdvertisedPrefixPublicDelegatedPrefix
                         * @constructor
                         * @param {google.cloud.compute.v1.IPublicAdvertisedPrefixPublicDelegatedPrefix=} [properties] Properties to set
                         */
                        function PublicAdvertisedPrefixPublicDelegatedPrefix(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PublicAdvertisedPrefixPublicDelegatedPrefix ipRange.
                         * @member {string|null|undefined} ipRange
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @instance
                         */
                        PublicAdvertisedPrefixPublicDelegatedPrefix.prototype.ipRange = null;
    
                        /**
                         * PublicAdvertisedPrefixPublicDelegatedPrefix name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @instance
                         */
                        PublicAdvertisedPrefixPublicDelegatedPrefix.prototype.name = null;
    
                        /**
                         * PublicAdvertisedPrefixPublicDelegatedPrefix project.
                         * @member {string|null|undefined} project
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @instance
                         */
                        PublicAdvertisedPrefixPublicDelegatedPrefix.prototype.project = null;
    
                        /**
                         * PublicAdvertisedPrefixPublicDelegatedPrefix region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @instance
                         */
                        PublicAdvertisedPrefixPublicDelegatedPrefix.prototype.region = null;
    
                        /**
                         * PublicAdvertisedPrefixPublicDelegatedPrefix status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @instance
                         */
                        PublicAdvertisedPrefixPublicDelegatedPrefix.prototype.status = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PublicAdvertisedPrefixPublicDelegatedPrefix _ipRange.
                         * @member {"ipRange"|undefined} _ipRange
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefixPublicDelegatedPrefix.prototype, "_ipRange", {
                            get: $util.oneOfGetter($oneOfFields = ["ipRange"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicAdvertisedPrefixPublicDelegatedPrefix _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefixPublicDelegatedPrefix.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicAdvertisedPrefixPublicDelegatedPrefix _project.
                         * @member {"project"|undefined} _project
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefixPublicDelegatedPrefix.prototype, "_project", {
                            get: $util.oneOfGetter($oneOfFields = ["project"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicAdvertisedPrefixPublicDelegatedPrefix _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefixPublicDelegatedPrefix.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicAdvertisedPrefixPublicDelegatedPrefix _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicAdvertisedPrefixPublicDelegatedPrefix.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PublicAdvertisedPrefixPublicDelegatedPrefix instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @static
                         * @param {google.cloud.compute.v1.IPublicAdvertisedPrefixPublicDelegatedPrefix=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix} PublicAdvertisedPrefixPublicDelegatedPrefix instance
                         */
                        PublicAdvertisedPrefixPublicDelegatedPrefix.create = function create(properties) {
                            return new PublicAdvertisedPrefixPublicDelegatedPrefix(properties);
                        };
    
                        /**
                         * Encodes the specified PublicAdvertisedPrefixPublicDelegatedPrefix message. Does not implicitly {@link google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @static
                         * @param {google.cloud.compute.v1.IPublicAdvertisedPrefixPublicDelegatedPrefix} message PublicAdvertisedPrefixPublicDelegatedPrefix message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PublicAdvertisedPrefixPublicDelegatedPrefix.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.ipRange != null && Object.hasOwnProperty.call(message, "ipRange"))
                                writer.uint32(/* id 145092645, wireType 2 =*/1160741162).string(message.ipRange);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PublicAdvertisedPrefixPublicDelegatedPrefix message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @static
                         * @param {google.cloud.compute.v1.IPublicAdvertisedPrefixPublicDelegatedPrefix} message PublicAdvertisedPrefixPublicDelegatedPrefix message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PublicAdvertisedPrefixPublicDelegatedPrefix.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PublicAdvertisedPrefixPublicDelegatedPrefix message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix} PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PublicAdvertisedPrefixPublicDelegatedPrefix.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 145092645: {
                                        message.ipRange = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PublicAdvertisedPrefixPublicDelegatedPrefix message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix} PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PublicAdvertisedPrefixPublicDelegatedPrefix.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PublicAdvertisedPrefixPublicDelegatedPrefix message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PublicAdvertisedPrefixPublicDelegatedPrefix.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.ipRange != null && message.hasOwnProperty("ipRange")) {
                                properties._ipRange = 1;
                                if (!$util.isString(message.ipRange))
                                    return "ipRange: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project")) {
                                properties._project = 1;
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PublicAdvertisedPrefixPublicDelegatedPrefix message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix} PublicAdvertisedPrefixPublicDelegatedPrefix
                         */
                        PublicAdvertisedPrefixPublicDelegatedPrefix.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix();
                            if (object.ipRange != null)
                                message.ipRange = String(object.ipRange);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.status != null)
                                message.status = String(object.status);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PublicAdvertisedPrefixPublicDelegatedPrefix message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @static
                         * @param {google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix} message PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PublicAdvertisedPrefixPublicDelegatedPrefix.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.ipRange != null && message.hasOwnProperty("ipRange")) {
                                object.ipRange = message.ipRange;
                                if (options.oneofs)
                                    object._ipRange = "ipRange";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.project != null && message.hasOwnProperty("project")) {
                                object.project = message.project;
                                if (options.oneofs)
                                    object._project = "project";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PublicAdvertisedPrefixPublicDelegatedPrefix to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PublicAdvertisedPrefixPublicDelegatedPrefix.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PublicAdvertisedPrefixPublicDelegatedPrefix.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PublicAdvertisedPrefixPublicDelegatedPrefix";
                        };
    
                        return PublicAdvertisedPrefixPublicDelegatedPrefix;
                    })();
    
                    v1.PublicDelegatedPrefix = (function() {
    
                        /**
                         * Properties of a PublicDelegatedPrefix.
                         * @memberof google.cloud.compute.v1
                         * @interface IPublicDelegatedPrefix
                         * @property {string|null} [creationTimestamp] PublicDelegatedPrefix creationTimestamp
                         * @property {string|null} [description] PublicDelegatedPrefix description
                         * @property {string|null} [fingerprint] PublicDelegatedPrefix fingerprint
                         * @property {number|Long|null} [id] PublicDelegatedPrefix id
                         * @property {string|null} [ipCidrRange] PublicDelegatedPrefix ipCidrRange
                         * @property {boolean|null} [isLiveMigration] PublicDelegatedPrefix isLiveMigration
                         * @property {string|null} [kind] PublicDelegatedPrefix kind
                         * @property {string|null} [name] PublicDelegatedPrefix name
                         * @property {string|null} [parentPrefix] PublicDelegatedPrefix parentPrefix
                         * @property {Array.<google.cloud.compute.v1.IPublicDelegatedPrefixPublicDelegatedSubPrefix>|null} [publicDelegatedSubPrefixs] PublicDelegatedPrefix publicDelegatedSubPrefixs
                         * @property {string|null} [region] PublicDelegatedPrefix region
                         * @property {string|null} [selfLink] PublicDelegatedPrefix selfLink
                         * @property {string|null} [status] PublicDelegatedPrefix status
                         */
    
                        /**
                         * Constructs a new PublicDelegatedPrefix.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PublicDelegatedPrefix.
                         * @implements IPublicDelegatedPrefix
                         * @constructor
                         * @param {google.cloud.compute.v1.IPublicDelegatedPrefix=} [properties] Properties to set
                         */
                        function PublicDelegatedPrefix(properties) {
                            this.publicDelegatedSubPrefixs = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PublicDelegatedPrefix creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        PublicDelegatedPrefix.prototype.creationTimestamp = null;
    
                        /**
                         * PublicDelegatedPrefix description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        PublicDelegatedPrefix.prototype.description = null;
    
                        /**
                         * PublicDelegatedPrefix fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        PublicDelegatedPrefix.prototype.fingerprint = null;
    
                        /**
                         * PublicDelegatedPrefix id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        PublicDelegatedPrefix.prototype.id = null;
    
                        /**
                         * PublicDelegatedPrefix ipCidrRange.
                         * @member {string|null|undefined} ipCidrRange
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        PublicDelegatedPrefix.prototype.ipCidrRange = null;
    
                        /**
                         * PublicDelegatedPrefix isLiveMigration.
                         * @member {boolean|null|undefined} isLiveMigration
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        PublicDelegatedPrefix.prototype.isLiveMigration = null;
    
                        /**
                         * PublicDelegatedPrefix kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        PublicDelegatedPrefix.prototype.kind = null;
    
                        /**
                         * PublicDelegatedPrefix name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        PublicDelegatedPrefix.prototype.name = null;
    
                        /**
                         * PublicDelegatedPrefix parentPrefix.
                         * @member {string|null|undefined} parentPrefix
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        PublicDelegatedPrefix.prototype.parentPrefix = null;
    
                        /**
                         * PublicDelegatedPrefix publicDelegatedSubPrefixs.
                         * @member {Array.<google.cloud.compute.v1.IPublicDelegatedPrefixPublicDelegatedSubPrefix>} publicDelegatedSubPrefixs
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        PublicDelegatedPrefix.prototype.publicDelegatedSubPrefixs = $util.emptyArray;
    
                        /**
                         * PublicDelegatedPrefix region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        PublicDelegatedPrefix.prototype.region = null;
    
                        /**
                         * PublicDelegatedPrefix selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        PublicDelegatedPrefix.prototype.selfLink = null;
    
                        /**
                         * PublicDelegatedPrefix status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        PublicDelegatedPrefix.prototype.status = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PublicDelegatedPrefix _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefix.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefix _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefix.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefix _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefix.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefix _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefix.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefix _ipCidrRange.
                         * @member {"ipCidrRange"|undefined} _ipCidrRange
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefix.prototype, "_ipCidrRange", {
                            get: $util.oneOfGetter($oneOfFields = ["ipCidrRange"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefix _isLiveMigration.
                         * @member {"isLiveMigration"|undefined} _isLiveMigration
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefix.prototype, "_isLiveMigration", {
                            get: $util.oneOfGetter($oneOfFields = ["isLiveMigration"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefix _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefix.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefix _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefix.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefix _parentPrefix.
                         * @member {"parentPrefix"|undefined} _parentPrefix
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefix.prototype, "_parentPrefix", {
                            get: $util.oneOfGetter($oneOfFields = ["parentPrefix"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefix _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefix.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefix _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefix.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefix _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefix.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PublicDelegatedPrefix instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @static
                         * @param {google.cloud.compute.v1.IPublicDelegatedPrefix=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PublicDelegatedPrefix} PublicDelegatedPrefix instance
                         */
                        PublicDelegatedPrefix.create = function create(properties) {
                            return new PublicDelegatedPrefix(properties);
                        };
    
                        /**
                         * Encodes the specified PublicDelegatedPrefix message. Does not implicitly {@link google.cloud.compute.v1.PublicDelegatedPrefix.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @static
                         * @param {google.cloud.compute.v1.IPublicDelegatedPrefix} message PublicDelegatedPrefix message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PublicDelegatedPrefix.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.parentPrefix != null && Object.hasOwnProperty.call(message, "parentPrefix"))
                                writer.uint32(/* id 15233991, wireType 2 =*/121871930).string(message.parentPrefix);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.ipCidrRange != null && Object.hasOwnProperty.call(message, "ipCidrRange"))
                                writer.uint32(/* id 98117322, wireType 2 =*/784938578).string(message.ipCidrRange);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.publicDelegatedSubPrefixs != null && message.publicDelegatedSubPrefixs.length)
                                for (var i = 0; i < message.publicDelegatedSubPrefixs.length; ++i)
                                    $root.google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix.encode(message.publicDelegatedSubPrefixs[i], writer.uint32(/* id 188940044, wireType 2 =*/1511520354).fork()).ldelim();
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.isLiveMigration != null && Object.hasOwnProperty.call(message, "isLiveMigration"))
                                writer.uint32(/* id 511823856, wireType 0 =*/4094590848).bool(message.isLiveMigration);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PublicDelegatedPrefix message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PublicDelegatedPrefix.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @static
                         * @param {google.cloud.compute.v1.IPublicDelegatedPrefix} message PublicDelegatedPrefix message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PublicDelegatedPrefix.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PublicDelegatedPrefix message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PublicDelegatedPrefix} PublicDelegatedPrefix
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PublicDelegatedPrefix.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PublicDelegatedPrefix();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 98117322: {
                                        message.ipCidrRange = reader.string();
                                        break;
                                    }
                                case 511823856: {
                                        message.isLiveMigration = reader.bool();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 15233991: {
                                        message.parentPrefix = reader.string();
                                        break;
                                    }
                                case 188940044: {
                                        if (!(message.publicDelegatedSubPrefixs && message.publicDelegatedSubPrefixs.length))
                                            message.publicDelegatedSubPrefixs = [];
                                        message.publicDelegatedSubPrefixs.push($root.google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PublicDelegatedPrefix message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PublicDelegatedPrefix} PublicDelegatedPrefix
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PublicDelegatedPrefix.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PublicDelegatedPrefix message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PublicDelegatedPrefix.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.ipCidrRange != null && message.hasOwnProperty("ipCidrRange")) {
                                properties._ipCidrRange = 1;
                                if (!$util.isString(message.ipCidrRange))
                                    return "ipCidrRange: string expected";
                            }
                            if (message.isLiveMigration != null && message.hasOwnProperty("isLiveMigration")) {
                                properties._isLiveMigration = 1;
                                if (typeof message.isLiveMigration !== "boolean")
                                    return "isLiveMigration: boolean expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.parentPrefix != null && message.hasOwnProperty("parentPrefix")) {
                                properties._parentPrefix = 1;
                                if (!$util.isString(message.parentPrefix))
                                    return "parentPrefix: string expected";
                            }
                            if (message.publicDelegatedSubPrefixs != null && message.hasOwnProperty("publicDelegatedSubPrefixs")) {
                                if (!Array.isArray(message.publicDelegatedSubPrefixs))
                                    return "publicDelegatedSubPrefixs: array expected";
                                for (var i = 0; i < message.publicDelegatedSubPrefixs.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix.verify(message.publicDelegatedSubPrefixs[i]);
                                    if (error)
                                        return "publicDelegatedSubPrefixs." + error;
                                }
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PublicDelegatedPrefix message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PublicDelegatedPrefix} PublicDelegatedPrefix
                         */
                        PublicDelegatedPrefix.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PublicDelegatedPrefix)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PublicDelegatedPrefix();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.ipCidrRange != null)
                                message.ipCidrRange = String(object.ipCidrRange);
                            if (object.isLiveMigration != null)
                                message.isLiveMigration = Boolean(object.isLiveMigration);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.parentPrefix != null)
                                message.parentPrefix = String(object.parentPrefix);
                            if (object.publicDelegatedSubPrefixs) {
                                if (!Array.isArray(object.publicDelegatedSubPrefixs))
                                    throw TypeError(".google.cloud.compute.v1.PublicDelegatedPrefix.publicDelegatedSubPrefixs: array expected");
                                message.publicDelegatedSubPrefixs = [];
                                for (var i = 0; i < object.publicDelegatedSubPrefixs.length; ++i) {
                                    if (typeof object.publicDelegatedSubPrefixs[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.PublicDelegatedPrefix.publicDelegatedSubPrefixs: object expected");
                                    message.publicDelegatedSubPrefixs[i] = $root.google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix.fromObject(object.publicDelegatedSubPrefixs[i]);
                                }
                            }
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.status != null)
                                message.status = String(object.status);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PublicDelegatedPrefix message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @static
                         * @param {google.cloud.compute.v1.PublicDelegatedPrefix} message PublicDelegatedPrefix
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PublicDelegatedPrefix.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.publicDelegatedSubPrefixs = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.parentPrefix != null && message.hasOwnProperty("parentPrefix")) {
                                object.parentPrefix = message.parentPrefix;
                                if (options.oneofs)
                                    object._parentPrefix = "parentPrefix";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.ipCidrRange != null && message.hasOwnProperty("ipCidrRange")) {
                                object.ipCidrRange = message.ipCidrRange;
                                if (options.oneofs)
                                    object._ipCidrRange = "ipCidrRange";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.publicDelegatedSubPrefixs && message.publicDelegatedSubPrefixs.length) {
                                object.publicDelegatedSubPrefixs = [];
                                for (var j = 0; j < message.publicDelegatedSubPrefixs.length; ++j)
                                    object.publicDelegatedSubPrefixs[j] = $root.google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix.toObject(message.publicDelegatedSubPrefixs[j], options);
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.isLiveMigration != null && message.hasOwnProperty("isLiveMigration")) {
                                object.isLiveMigration = message.isLiveMigration;
                                if (options.oneofs)
                                    object._isLiveMigration = "isLiveMigration";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PublicDelegatedPrefix to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PublicDelegatedPrefix.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PublicDelegatedPrefix
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefix
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PublicDelegatedPrefix.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PublicDelegatedPrefix";
                        };
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.PublicDelegatedPrefix.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} ANNOUNCED=365103355 ANNOUNCED value
                         * @property {number} DELETING=528602024 DELETING value
                         * @property {number} INITIALIZING=306588749 INITIALIZING value
                         * @property {number} READY_TO_ANNOUNCE=64641265 READY_TO_ANNOUNCE value
                         */
                        PublicDelegatedPrefix.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[365103355] = "ANNOUNCED"] = 365103355;
                            values[valuesById[528602024] = "DELETING"] = 528602024;
                            values[valuesById[306588749] = "INITIALIZING"] = 306588749;
                            values[valuesById[64641265] = "READY_TO_ANNOUNCE"] = 64641265;
                            return values;
                        })();
    
                        return PublicDelegatedPrefix;
                    })();
    
                    v1.PublicDelegatedPrefixAggregatedList = (function() {
    
                        /**
                         * Properties of a PublicDelegatedPrefixAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IPublicDelegatedPrefixAggregatedList
                         * @property {string|null} [id] PublicDelegatedPrefixAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IPublicDelegatedPrefixesScopedList>|null} [items] PublicDelegatedPrefixAggregatedList items
                         * @property {string|null} [kind] PublicDelegatedPrefixAggregatedList kind
                         * @property {string|null} [nextPageToken] PublicDelegatedPrefixAggregatedList nextPageToken
                         * @property {string|null} [selfLink] PublicDelegatedPrefixAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] PublicDelegatedPrefixAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] PublicDelegatedPrefixAggregatedList warning
                         */
    
                        /**
                         * Constructs a new PublicDelegatedPrefixAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PublicDelegatedPrefixAggregatedList.
                         * @implements IPublicDelegatedPrefixAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IPublicDelegatedPrefixAggregatedList=} [properties] Properties to set
                         */
                        function PublicDelegatedPrefixAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PublicDelegatedPrefixAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @instance
                         */
                        PublicDelegatedPrefixAggregatedList.prototype.id = null;
    
                        /**
                         * PublicDelegatedPrefixAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IPublicDelegatedPrefixesScopedList>} items
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @instance
                         */
                        PublicDelegatedPrefixAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * PublicDelegatedPrefixAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @instance
                         */
                        PublicDelegatedPrefixAggregatedList.prototype.kind = null;
    
                        /**
                         * PublicDelegatedPrefixAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @instance
                         */
                        PublicDelegatedPrefixAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * PublicDelegatedPrefixAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @instance
                         */
                        PublicDelegatedPrefixAggregatedList.prototype.selfLink = null;
    
                        /**
                         * PublicDelegatedPrefixAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @instance
                         */
                        PublicDelegatedPrefixAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * PublicDelegatedPrefixAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @instance
                         */
                        PublicDelegatedPrefixAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PublicDelegatedPrefixAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefixAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefixAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefixAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefixAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefixAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefixAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefixAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefixAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefixAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PublicDelegatedPrefixAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IPublicDelegatedPrefixAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList} PublicDelegatedPrefixAggregatedList instance
                         */
                        PublicDelegatedPrefixAggregatedList.create = function create(properties) {
                            return new PublicDelegatedPrefixAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified PublicDelegatedPrefixAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IPublicDelegatedPrefixAggregatedList} message PublicDelegatedPrefixAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PublicDelegatedPrefixAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.PublicDelegatedPrefixesScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PublicDelegatedPrefixAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IPublicDelegatedPrefixAggregatedList} message PublicDelegatedPrefixAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PublicDelegatedPrefixAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PublicDelegatedPrefixAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList} PublicDelegatedPrefixAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PublicDelegatedPrefixAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.PublicDelegatedPrefixesScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PublicDelegatedPrefixAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList} PublicDelegatedPrefixAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PublicDelegatedPrefixAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PublicDelegatedPrefixAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PublicDelegatedPrefixAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PublicDelegatedPrefixesScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PublicDelegatedPrefixAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList} PublicDelegatedPrefixAggregatedList
                         */
                        PublicDelegatedPrefixAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.PublicDelegatedPrefixesScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PublicDelegatedPrefixAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList} message PublicDelegatedPrefixAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PublicDelegatedPrefixAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.PublicDelegatedPrefixesScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PublicDelegatedPrefixAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PublicDelegatedPrefixAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PublicDelegatedPrefixAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PublicDelegatedPrefixAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList";
                        };
    
                        return PublicDelegatedPrefixAggregatedList;
                    })();
    
                    v1.PublicDelegatedPrefixList = (function() {
    
                        /**
                         * Properties of a PublicDelegatedPrefixList.
                         * @memberof google.cloud.compute.v1
                         * @interface IPublicDelegatedPrefixList
                         * @property {string|null} [id] PublicDelegatedPrefixList id
                         * @property {Array.<google.cloud.compute.v1.IPublicDelegatedPrefix>|null} [items] PublicDelegatedPrefixList items
                         * @property {string|null} [kind] PublicDelegatedPrefixList kind
                         * @property {string|null} [nextPageToken] PublicDelegatedPrefixList nextPageToken
                         * @property {string|null} [selfLink] PublicDelegatedPrefixList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] PublicDelegatedPrefixList warning
                         */
    
                        /**
                         * Constructs a new PublicDelegatedPrefixList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PublicDelegatedPrefixList.
                         * @implements IPublicDelegatedPrefixList
                         * @constructor
                         * @param {google.cloud.compute.v1.IPublicDelegatedPrefixList=} [properties] Properties to set
                         */
                        function PublicDelegatedPrefixList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PublicDelegatedPrefixList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @instance
                         */
                        PublicDelegatedPrefixList.prototype.id = null;
    
                        /**
                         * PublicDelegatedPrefixList items.
                         * @member {Array.<google.cloud.compute.v1.IPublicDelegatedPrefix>} items
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @instance
                         */
                        PublicDelegatedPrefixList.prototype.items = $util.emptyArray;
    
                        /**
                         * PublicDelegatedPrefixList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @instance
                         */
                        PublicDelegatedPrefixList.prototype.kind = null;
    
                        /**
                         * PublicDelegatedPrefixList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @instance
                         */
                        PublicDelegatedPrefixList.prototype.nextPageToken = null;
    
                        /**
                         * PublicDelegatedPrefixList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @instance
                         */
                        PublicDelegatedPrefixList.prototype.selfLink = null;
    
                        /**
                         * PublicDelegatedPrefixList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @instance
                         */
                        PublicDelegatedPrefixList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PublicDelegatedPrefixList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefixList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefixList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefixList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefixList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefixList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefixList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefixList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefixList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefixList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PublicDelegatedPrefixList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @static
                         * @param {google.cloud.compute.v1.IPublicDelegatedPrefixList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PublicDelegatedPrefixList} PublicDelegatedPrefixList instance
                         */
                        PublicDelegatedPrefixList.create = function create(properties) {
                            return new PublicDelegatedPrefixList(properties);
                        };
    
                        /**
                         * Encodes the specified PublicDelegatedPrefixList message. Does not implicitly {@link google.cloud.compute.v1.PublicDelegatedPrefixList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @static
                         * @param {google.cloud.compute.v1.IPublicDelegatedPrefixList} message PublicDelegatedPrefixList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PublicDelegatedPrefixList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.PublicDelegatedPrefix.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PublicDelegatedPrefixList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PublicDelegatedPrefixList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @static
                         * @param {google.cloud.compute.v1.IPublicDelegatedPrefixList} message PublicDelegatedPrefixList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PublicDelegatedPrefixList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PublicDelegatedPrefixList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PublicDelegatedPrefixList} PublicDelegatedPrefixList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PublicDelegatedPrefixList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PublicDelegatedPrefixList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.PublicDelegatedPrefix.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PublicDelegatedPrefixList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PublicDelegatedPrefixList} PublicDelegatedPrefixList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PublicDelegatedPrefixList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PublicDelegatedPrefixList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PublicDelegatedPrefixList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PublicDelegatedPrefix.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PublicDelegatedPrefixList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PublicDelegatedPrefixList} PublicDelegatedPrefixList
                         */
                        PublicDelegatedPrefixList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PublicDelegatedPrefixList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PublicDelegatedPrefixList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.PublicDelegatedPrefixList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.PublicDelegatedPrefixList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.PublicDelegatedPrefix.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PublicDelegatedPrefixList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PublicDelegatedPrefixList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @static
                         * @param {google.cloud.compute.v1.PublicDelegatedPrefixList} message PublicDelegatedPrefixList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PublicDelegatedPrefixList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.PublicDelegatedPrefix.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PublicDelegatedPrefixList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PublicDelegatedPrefixList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PublicDelegatedPrefixList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PublicDelegatedPrefixList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PublicDelegatedPrefixList";
                        };
    
                        return PublicDelegatedPrefixList;
                    })();
    
                    v1.PublicDelegatedPrefixPublicDelegatedSubPrefix = (function() {
    
                        /**
                         * Properties of a PublicDelegatedPrefixPublicDelegatedSubPrefix.
                         * @memberof google.cloud.compute.v1
                         * @interface IPublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @property {string|null} [delegateeProject] PublicDelegatedPrefixPublicDelegatedSubPrefix delegateeProject
                         * @property {string|null} [description] PublicDelegatedPrefixPublicDelegatedSubPrefix description
                         * @property {string|null} [ipCidrRange] PublicDelegatedPrefixPublicDelegatedSubPrefix ipCidrRange
                         * @property {boolean|null} [isAddress] PublicDelegatedPrefixPublicDelegatedSubPrefix isAddress
                         * @property {string|null} [name] PublicDelegatedPrefixPublicDelegatedSubPrefix name
                         * @property {string|null} [region] PublicDelegatedPrefixPublicDelegatedSubPrefix region
                         * @property {string|null} [status] PublicDelegatedPrefixPublicDelegatedSubPrefix status
                         */
    
                        /**
                         * Constructs a new PublicDelegatedPrefixPublicDelegatedSubPrefix.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PublicDelegatedPrefixPublicDelegatedSubPrefix.
                         * @implements IPublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @constructor
                         * @param {google.cloud.compute.v1.IPublicDelegatedPrefixPublicDelegatedSubPrefix=} [properties] Properties to set
                         */
                        function PublicDelegatedPrefixPublicDelegatedSubPrefix(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PublicDelegatedPrefixPublicDelegatedSubPrefix delegateeProject.
                         * @member {string|null|undefined} delegateeProject
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @instance
                         */
                        PublicDelegatedPrefixPublicDelegatedSubPrefix.prototype.delegateeProject = null;
    
                        /**
                         * PublicDelegatedPrefixPublicDelegatedSubPrefix description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @instance
                         */
                        PublicDelegatedPrefixPublicDelegatedSubPrefix.prototype.description = null;
    
                        /**
                         * PublicDelegatedPrefixPublicDelegatedSubPrefix ipCidrRange.
                         * @member {string|null|undefined} ipCidrRange
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @instance
                         */
                        PublicDelegatedPrefixPublicDelegatedSubPrefix.prototype.ipCidrRange = null;
    
                        /**
                         * PublicDelegatedPrefixPublicDelegatedSubPrefix isAddress.
                         * @member {boolean|null|undefined} isAddress
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @instance
                         */
                        PublicDelegatedPrefixPublicDelegatedSubPrefix.prototype.isAddress = null;
    
                        /**
                         * PublicDelegatedPrefixPublicDelegatedSubPrefix name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @instance
                         */
                        PublicDelegatedPrefixPublicDelegatedSubPrefix.prototype.name = null;
    
                        /**
                         * PublicDelegatedPrefixPublicDelegatedSubPrefix region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @instance
                         */
                        PublicDelegatedPrefixPublicDelegatedSubPrefix.prototype.region = null;
    
                        /**
                         * PublicDelegatedPrefixPublicDelegatedSubPrefix status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @instance
                         */
                        PublicDelegatedPrefixPublicDelegatedSubPrefix.prototype.status = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PublicDelegatedPrefixPublicDelegatedSubPrefix _delegateeProject.
                         * @member {"delegateeProject"|undefined} _delegateeProject
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefixPublicDelegatedSubPrefix.prototype, "_delegateeProject", {
                            get: $util.oneOfGetter($oneOfFields = ["delegateeProject"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefixPublicDelegatedSubPrefix _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefixPublicDelegatedSubPrefix.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefixPublicDelegatedSubPrefix _ipCidrRange.
                         * @member {"ipCidrRange"|undefined} _ipCidrRange
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefixPublicDelegatedSubPrefix.prototype, "_ipCidrRange", {
                            get: $util.oneOfGetter($oneOfFields = ["ipCidrRange"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefixPublicDelegatedSubPrefix _isAddress.
                         * @member {"isAddress"|undefined} _isAddress
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefixPublicDelegatedSubPrefix.prototype, "_isAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["isAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefixPublicDelegatedSubPrefix _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefixPublicDelegatedSubPrefix.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefixPublicDelegatedSubPrefix _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefixPublicDelegatedSubPrefix.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * PublicDelegatedPrefixPublicDelegatedSubPrefix _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefixPublicDelegatedSubPrefix.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PublicDelegatedPrefixPublicDelegatedSubPrefix instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @static
                         * @param {google.cloud.compute.v1.IPublicDelegatedPrefixPublicDelegatedSubPrefix=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix} PublicDelegatedPrefixPublicDelegatedSubPrefix instance
                         */
                        PublicDelegatedPrefixPublicDelegatedSubPrefix.create = function create(properties) {
                            return new PublicDelegatedPrefixPublicDelegatedSubPrefix(properties);
                        };
    
                        /**
                         * Encodes the specified PublicDelegatedPrefixPublicDelegatedSubPrefix message. Does not implicitly {@link google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @static
                         * @param {google.cloud.compute.v1.IPublicDelegatedPrefixPublicDelegatedSubPrefix} message PublicDelegatedPrefixPublicDelegatedSubPrefix message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PublicDelegatedPrefixPublicDelegatedSubPrefix.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.ipCidrRange != null && Object.hasOwnProperty.call(message, "ipCidrRange"))
                                writer.uint32(/* id 98117322, wireType 2 =*/784938578).string(message.ipCidrRange);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.isAddress != null && Object.hasOwnProperty.call(message, "isAddress"))
                                writer.uint32(/* id 352617951, wireType 0 =*/2820943608).bool(message.isAddress);
                            if (message.delegateeProject != null && Object.hasOwnProperty.call(message, "delegateeProject"))
                                writer.uint32(/* id 414860634, wireType 2 =*/3318885074).string(message.delegateeProject);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PublicDelegatedPrefixPublicDelegatedSubPrefix message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @static
                         * @param {google.cloud.compute.v1.IPublicDelegatedPrefixPublicDelegatedSubPrefix} message PublicDelegatedPrefixPublicDelegatedSubPrefix message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PublicDelegatedPrefixPublicDelegatedSubPrefix.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PublicDelegatedPrefixPublicDelegatedSubPrefix message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix} PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PublicDelegatedPrefixPublicDelegatedSubPrefix.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 414860634: {
                                        message.delegateeProject = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 98117322: {
                                        message.ipCidrRange = reader.string();
                                        break;
                                    }
                                case 352617951: {
                                        message.isAddress = reader.bool();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PublicDelegatedPrefixPublicDelegatedSubPrefix message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix} PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PublicDelegatedPrefixPublicDelegatedSubPrefix.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PublicDelegatedPrefixPublicDelegatedSubPrefix message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PublicDelegatedPrefixPublicDelegatedSubPrefix.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.delegateeProject != null && message.hasOwnProperty("delegateeProject")) {
                                properties._delegateeProject = 1;
                                if (!$util.isString(message.delegateeProject))
                                    return "delegateeProject: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.ipCidrRange != null && message.hasOwnProperty("ipCidrRange")) {
                                properties._ipCidrRange = 1;
                                if (!$util.isString(message.ipCidrRange))
                                    return "ipCidrRange: string expected";
                            }
                            if (message.isAddress != null && message.hasOwnProperty("isAddress")) {
                                properties._isAddress = 1;
                                if (typeof message.isAddress !== "boolean")
                                    return "isAddress: boolean expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PublicDelegatedPrefixPublicDelegatedSubPrefix message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix} PublicDelegatedPrefixPublicDelegatedSubPrefix
                         */
                        PublicDelegatedPrefixPublicDelegatedSubPrefix.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix();
                            if (object.delegateeProject != null)
                                message.delegateeProject = String(object.delegateeProject);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.ipCidrRange != null)
                                message.ipCidrRange = String(object.ipCidrRange);
                            if (object.isAddress != null)
                                message.isAddress = Boolean(object.isAddress);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.status != null)
                                message.status = String(object.status);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PublicDelegatedPrefixPublicDelegatedSubPrefix message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @static
                         * @param {google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix} message PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PublicDelegatedPrefixPublicDelegatedSubPrefix.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.ipCidrRange != null && message.hasOwnProperty("ipCidrRange")) {
                                object.ipCidrRange = message.ipCidrRange;
                                if (options.oneofs)
                                    object._ipCidrRange = "ipCidrRange";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.isAddress != null && message.hasOwnProperty("isAddress")) {
                                object.isAddress = message.isAddress;
                                if (options.oneofs)
                                    object._isAddress = "isAddress";
                            }
                            if (message.delegateeProject != null && message.hasOwnProperty("delegateeProject")) {
                                object.delegateeProject = message.delegateeProject;
                                if (options.oneofs)
                                    object._delegateeProject = "delegateeProject";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PublicDelegatedPrefixPublicDelegatedSubPrefix to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PublicDelegatedPrefixPublicDelegatedSubPrefix.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PublicDelegatedPrefixPublicDelegatedSubPrefix.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix";
                        };
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.PublicDelegatedPrefixPublicDelegatedSubPrefix.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} ACTIVE=314733318 ACTIVE value
                         * @property {number} INACTIVE=270421099 INACTIVE value
                         */
                        PublicDelegatedPrefixPublicDelegatedSubPrefix.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[314733318] = "ACTIVE"] = 314733318;
                            values[valuesById[270421099] = "INACTIVE"] = 270421099;
                            return values;
                        })();
    
                        return PublicDelegatedPrefixPublicDelegatedSubPrefix;
                    })();
    
                    v1.PublicDelegatedPrefixesScopedList = (function() {
    
                        /**
                         * Properties of a PublicDelegatedPrefixesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IPublicDelegatedPrefixesScopedList
                         * @property {Array.<google.cloud.compute.v1.IPublicDelegatedPrefix>|null} [publicDelegatedPrefixes] PublicDelegatedPrefixesScopedList publicDelegatedPrefixes
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] PublicDelegatedPrefixesScopedList warning
                         */
    
                        /**
                         * Constructs a new PublicDelegatedPrefixesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PublicDelegatedPrefixesScopedList.
                         * @implements IPublicDelegatedPrefixesScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IPublicDelegatedPrefixesScopedList=} [properties] Properties to set
                         */
                        function PublicDelegatedPrefixesScopedList(properties) {
                            this.publicDelegatedPrefixes = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * PublicDelegatedPrefixesScopedList publicDelegatedPrefixes.
                         * @member {Array.<google.cloud.compute.v1.IPublicDelegatedPrefix>} publicDelegatedPrefixes
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixesScopedList
                         * @instance
                         */
                        PublicDelegatedPrefixesScopedList.prototype.publicDelegatedPrefixes = $util.emptyArray;
    
                        /**
                         * PublicDelegatedPrefixesScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixesScopedList
                         * @instance
                         */
                        PublicDelegatedPrefixesScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * PublicDelegatedPrefixesScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixesScopedList
                         * @instance
                         */
                        Object.defineProperty(PublicDelegatedPrefixesScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new PublicDelegatedPrefixesScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IPublicDelegatedPrefixesScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.PublicDelegatedPrefixesScopedList} PublicDelegatedPrefixesScopedList instance
                         */
                        PublicDelegatedPrefixesScopedList.create = function create(properties) {
                            return new PublicDelegatedPrefixesScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified PublicDelegatedPrefixesScopedList message. Does not implicitly {@link google.cloud.compute.v1.PublicDelegatedPrefixesScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IPublicDelegatedPrefixesScopedList} message PublicDelegatedPrefixesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PublicDelegatedPrefixesScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.publicDelegatedPrefixes != null && message.publicDelegatedPrefixes.length)
                                for (var i = 0; i < message.publicDelegatedPrefixes.length; ++i)
                                    $root.google.cloud.compute.v1.PublicDelegatedPrefix.encode(message.publicDelegatedPrefixes[i], writer.uint32(/* id 315261206, wireType 2 =*/2522089650).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified PublicDelegatedPrefixesScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.PublicDelegatedPrefixesScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IPublicDelegatedPrefixesScopedList} message PublicDelegatedPrefixesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        PublicDelegatedPrefixesScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a PublicDelegatedPrefixesScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.PublicDelegatedPrefixesScopedList} PublicDelegatedPrefixesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PublicDelegatedPrefixesScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.PublicDelegatedPrefixesScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 315261206: {
                                        if (!(message.publicDelegatedPrefixes && message.publicDelegatedPrefixes.length))
                                            message.publicDelegatedPrefixes = [];
                                        message.publicDelegatedPrefixes.push($root.google.cloud.compute.v1.PublicDelegatedPrefix.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a PublicDelegatedPrefixesScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.PublicDelegatedPrefixesScopedList} PublicDelegatedPrefixesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        PublicDelegatedPrefixesScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a PublicDelegatedPrefixesScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixesScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        PublicDelegatedPrefixesScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.publicDelegatedPrefixes != null && message.hasOwnProperty("publicDelegatedPrefixes")) {
                                if (!Array.isArray(message.publicDelegatedPrefixes))
                                    return "publicDelegatedPrefixes: array expected";
                                for (var i = 0; i < message.publicDelegatedPrefixes.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PublicDelegatedPrefix.verify(message.publicDelegatedPrefixes[i]);
                                    if (error)
                                        return "publicDelegatedPrefixes." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a PublicDelegatedPrefixesScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixesScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.PublicDelegatedPrefixesScopedList} PublicDelegatedPrefixesScopedList
                         */
                        PublicDelegatedPrefixesScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.PublicDelegatedPrefixesScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.PublicDelegatedPrefixesScopedList();
                            if (object.publicDelegatedPrefixes) {
                                if (!Array.isArray(object.publicDelegatedPrefixes))
                                    throw TypeError(".google.cloud.compute.v1.PublicDelegatedPrefixesScopedList.publicDelegatedPrefixes: array expected");
                                message.publicDelegatedPrefixes = [];
                                for (var i = 0; i < object.publicDelegatedPrefixes.length; ++i) {
                                    if (typeof object.publicDelegatedPrefixes[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.PublicDelegatedPrefixesScopedList.publicDelegatedPrefixes: object expected");
                                    message.publicDelegatedPrefixes[i] = $root.google.cloud.compute.v1.PublicDelegatedPrefix.fromObject(object.publicDelegatedPrefixes[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.PublicDelegatedPrefixesScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a PublicDelegatedPrefixesScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.PublicDelegatedPrefixesScopedList} message PublicDelegatedPrefixesScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        PublicDelegatedPrefixesScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.publicDelegatedPrefixes = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.publicDelegatedPrefixes && message.publicDelegatedPrefixes.length) {
                                object.publicDelegatedPrefixes = [];
                                for (var j = 0; j < message.publicDelegatedPrefixes.length; ++j)
                                    object.publicDelegatedPrefixes[j] = $root.google.cloud.compute.v1.PublicDelegatedPrefix.toObject(message.publicDelegatedPrefixes[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this PublicDelegatedPrefixesScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixesScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        PublicDelegatedPrefixesScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for PublicDelegatedPrefixesScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixesScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        PublicDelegatedPrefixesScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.PublicDelegatedPrefixesScopedList";
                        };
    
                        return PublicDelegatedPrefixesScopedList;
                    })();
    
                    v1.Quota = (function() {
    
                        /**
                         * Properties of a Quota.
                         * @memberof google.cloud.compute.v1
                         * @interface IQuota
                         * @property {number|null} [limit] Quota limit
                         * @property {string|null} [metric] Quota metric
                         * @property {string|null} [owner] Quota owner
                         * @property {number|null} [usage] Quota usage
                         */
    
                        /**
                         * Constructs a new Quota.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Quota.
                         * @implements IQuota
                         * @constructor
                         * @param {google.cloud.compute.v1.IQuota=} [properties] Properties to set
                         */
                        function Quota(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Quota limit.
                         * @member {number|null|undefined} limit
                         * @memberof google.cloud.compute.v1.Quota
                         * @instance
                         */
                        Quota.prototype.limit = null;
    
                        /**
                         * Quota metric.
                         * @member {string|null|undefined} metric
                         * @memberof google.cloud.compute.v1.Quota
                         * @instance
                         */
                        Quota.prototype.metric = null;
    
                        /**
                         * Quota owner.
                         * @member {string|null|undefined} owner
                         * @memberof google.cloud.compute.v1.Quota
                         * @instance
                         */
                        Quota.prototype.owner = null;
    
                        /**
                         * Quota usage.
                         * @member {number|null|undefined} usage
                         * @memberof google.cloud.compute.v1.Quota
                         * @instance
                         */
                        Quota.prototype.usage = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Quota _limit.
                         * @member {"limit"|undefined} _limit
                         * @memberof google.cloud.compute.v1.Quota
                         * @instance
                         */
                        Object.defineProperty(Quota.prototype, "_limit", {
                            get: $util.oneOfGetter($oneOfFields = ["limit"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Quota _metric.
                         * @member {"metric"|undefined} _metric
                         * @memberof google.cloud.compute.v1.Quota
                         * @instance
                         */
                        Object.defineProperty(Quota.prototype, "_metric", {
                            get: $util.oneOfGetter($oneOfFields = ["metric"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Quota _owner.
                         * @member {"owner"|undefined} _owner
                         * @memberof google.cloud.compute.v1.Quota
                         * @instance
                         */
                        Object.defineProperty(Quota.prototype, "_owner", {
                            get: $util.oneOfGetter($oneOfFields = ["owner"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Quota _usage.
                         * @member {"usage"|undefined} _usage
                         * @memberof google.cloud.compute.v1.Quota
                         * @instance
                         */
                        Object.defineProperty(Quota.prototype, "_usage", {
                            get: $util.oneOfGetter($oneOfFields = ["usage"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Quota instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Quota
                         * @static
                         * @param {google.cloud.compute.v1.IQuota=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Quota} Quota instance
                         */
                        Quota.create = function create(properties) {
                            return new Quota(properties);
                        };
    
                        /**
                         * Encodes the specified Quota message. Does not implicitly {@link google.cloud.compute.v1.Quota.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Quota
                         * @static
                         * @param {google.cloud.compute.v1.IQuota} message Quota message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Quota.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.limit != null && Object.hasOwnProperty.call(message, "limit"))
                                writer.uint32(/* id 102976443, wireType 1 =*/823811545).double(message.limit);
                            if (message.owner != null && Object.hasOwnProperty.call(message, "owner"))
                                writer.uint32(/* id 106164915, wireType 2 =*/849319322).string(message.owner);
                            if (message.usage != null && Object.hasOwnProperty.call(message, "usage"))
                                writer.uint32(/* id 111574433, wireType 1 =*/892595465).double(message.usage);
                            if (message.metric != null && Object.hasOwnProperty.call(message, "metric"))
                                writer.uint32(/* id 533067184, wireType 2 =*/4264537474).string(message.metric);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Quota message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Quota.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Quota
                         * @static
                         * @param {google.cloud.compute.v1.IQuota} message Quota message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Quota.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Quota message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Quota
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Quota} Quota
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Quota.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Quota();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 102976443: {
                                        message.limit = reader.double();
                                        break;
                                    }
                                case 533067184: {
                                        message.metric = reader.string();
                                        break;
                                    }
                                case 106164915: {
                                        message.owner = reader.string();
                                        break;
                                    }
                                case 111574433: {
                                        message.usage = reader.double();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Quota message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Quota
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Quota} Quota
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Quota.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Quota message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Quota
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Quota.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.limit != null && message.hasOwnProperty("limit")) {
                                properties._limit = 1;
                                if (typeof message.limit !== "number")
                                    return "limit: number expected";
                            }
                            if (message.metric != null && message.hasOwnProperty("metric")) {
                                properties._metric = 1;
                                if (!$util.isString(message.metric))
                                    return "metric: string expected";
                            }
                            if (message.owner != null && message.hasOwnProperty("owner")) {
                                properties._owner = 1;
                                if (!$util.isString(message.owner))
                                    return "owner: string expected";
                            }
                            if (message.usage != null && message.hasOwnProperty("usage")) {
                                properties._usage = 1;
                                if (typeof message.usage !== "number")
                                    return "usage: number expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Quota message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Quota
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Quota} Quota
                         */
                        Quota.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Quota)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Quota();
                            if (object.limit != null)
                                message.limit = Number(object.limit);
                            if (object.metric != null)
                                message.metric = String(object.metric);
                            if (object.owner != null)
                                message.owner = String(object.owner);
                            if (object.usage != null)
                                message.usage = Number(object.usage);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Quota message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Quota
                         * @static
                         * @param {google.cloud.compute.v1.Quota} message Quota
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Quota.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.limit != null && message.hasOwnProperty("limit")) {
                                object.limit = options.json && !isFinite(message.limit) ? String(message.limit) : message.limit;
                                if (options.oneofs)
                                    object._limit = "limit";
                            }
                            if (message.owner != null && message.hasOwnProperty("owner")) {
                                object.owner = message.owner;
                                if (options.oneofs)
                                    object._owner = "owner";
                            }
                            if (message.usage != null && message.hasOwnProperty("usage")) {
                                object.usage = options.json && !isFinite(message.usage) ? String(message.usage) : message.usage;
                                if (options.oneofs)
                                    object._usage = "usage";
                            }
                            if (message.metric != null && message.hasOwnProperty("metric")) {
                                object.metric = message.metric;
                                if (options.oneofs)
                                    object._metric = "metric";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Quota to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Quota
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Quota.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Quota
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Quota
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Quota.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Quota";
                        };
    
                        /**
                         * Metric enum.
                         * @name google.cloud.compute.v1.Quota.Metric
                         * @enum {number}
                         * @property {number} UNDEFINED_METRIC=0 UNDEFINED_METRIC value
                         * @property {number} A2_CPUS=153206585 A2_CPUS value
                         * @property {number} AFFINITY_GROUPS=108303563 AFFINITY_GROUPS value
                         * @property {number} AUTOSCALERS=471248988 AUTOSCALERS value
                         * @property {number} BACKEND_BUCKETS=137626846 BACKEND_BUCKETS value
                         * @property {number} BACKEND_SERVICES=269623753 BACKEND_SERVICES value
                         * @property {number} C2D_CPUS=508182517 C2D_CPUS value
                         * @property {number} C2_CPUS=317601211 C2_CPUS value
                         * @property {number} C3_CPUS=346230362 C3_CPUS value
                         * @property {number} COMMITMENTS=456141790 COMMITMENTS value
                         * @property {number} COMMITTED_A2_CPUS=59330902 COMMITTED_A2_CPUS value
                         * @property {number} COMMITTED_C2D_CPUS=282390904 COMMITTED_C2D_CPUS value
                         * @property {number} COMMITTED_C2_CPUS=223725528 COMMITTED_C2_CPUS value
                         * @property {number} COMMITTED_C3_CPUS=252354679 COMMITTED_C3_CPUS value
                         * @property {number} COMMITTED_CPUS=292394702 COMMITTED_CPUS value
                         * @property {number} COMMITTED_E2_CPUS=388120154 COMMITTED_E2_CPUS value
                         * @property {number} COMMITTED_LICENSES=357606869 COMMITTED_LICENSES value
                         * @property {number} COMMITTED_LOCAL_SSD_TOTAL_GB=308393480 COMMITTED_LOCAL_SSD_TOTAL_GB value
                         * @property {number} COMMITTED_M3_CPUS=585985 COMMITTED_M3_CPUS value
                         * @property {number} COMMITTED_MEMORY_OPTIMIZED_CPUS=489057886 COMMITTED_MEMORY_OPTIMIZED_CPUS value
                         * @property {number} COMMITTED_N2A_CPUS=40064304 COMMITTED_N2A_CPUS value
                         * @property {number} COMMITTED_N2D_CPUS=125951757 COMMITTED_N2D_CPUS value
                         * @property {number} COMMITTED_N2_CPUS=322589603 COMMITTED_N2_CPUS value
                         * @property {number} COMMITTED_NVIDIA_A100_80GB_GPUS=464326565 COMMITTED_NVIDIA_A100_80GB_GPUS value
                         * @property {number} COMMITTED_NVIDIA_A100_GPUS=375799445 COMMITTED_NVIDIA_A100_GPUS value
                         * @property {number} COMMITTED_NVIDIA_K80_GPUS=3857188 COMMITTED_NVIDIA_K80_GPUS value
                         * @property {number} COMMITTED_NVIDIA_P100_GPUS=107528100 COMMITTED_NVIDIA_P100_GPUS value
                         * @property {number} COMMITTED_NVIDIA_P4_GPUS=347952897 COMMITTED_NVIDIA_P4_GPUS value
                         * @property {number} COMMITTED_NVIDIA_T4_GPUS=139871237 COMMITTED_NVIDIA_T4_GPUS value
                         * @property {number} COMMITTED_NVIDIA_V100_GPUS=219562 COMMITTED_NVIDIA_V100_GPUS value
                         * @property {number} COMMITTED_T2A_CPUS=296378986 COMMITTED_T2A_CPUS value
                         * @property {number} COMMITTED_T2D_CPUS=382266439 COMMITTED_T2D_CPUS value
                         * @property {number} CPUS=2075595 CPUS value
                         * @property {number} CPUS_ALL_REGIONS=470911149 CPUS_ALL_REGIONS value
                         * @property {number} DISKS_TOTAL_GB=353520543 DISKS_TOTAL_GB value
                         * @property {number} E2_CPUS=481995837 E2_CPUS value
                         * @property {number} EXTERNAL_MANAGED_FORWARDING_RULES=150790089 EXTERNAL_MANAGED_FORWARDING_RULES value
                         * @property {number} EXTERNAL_NETWORK_LB_FORWARDING_RULES=374298265 EXTERNAL_NETWORK_LB_FORWARDING_RULES value
                         * @property {number} EXTERNAL_PROTOCOL_FORWARDING_RULES=63478888 EXTERNAL_PROTOCOL_FORWARDING_RULES value
                         * @property {number} EXTERNAL_VPN_GATEWAYS=272457134 EXTERNAL_VPN_GATEWAYS value
                         * @property {number} FIREWALLS=374485843 FIREWALLS value
                         * @property {number} FORWARDING_RULES=432668949 FORWARDING_RULES value
                         * @property {number} GLOBAL_EXTERNAL_MANAGED_FORWARDING_RULES=327611949 GLOBAL_EXTERNAL_MANAGED_FORWARDING_RULES value
                         * @property {number} GLOBAL_INTERNAL_ADDRESSES=42738332 GLOBAL_INTERNAL_ADDRESSES value
                         * @property {number} GPUS_ALL_REGIONS=39387177 GPUS_ALL_REGIONS value
                         * @property {number} HEALTH_CHECKS=289347502 HEALTH_CHECKS value
                         * @property {number} IMAGES=15562360 IMAGES value
                         * @property {number} INSTANCES=131337822 INSTANCES value
                         * @property {number} INSTANCE_GROUPS=355919038 INSTANCE_GROUPS value
                         * @property {number} INSTANCE_GROUP_MANAGERS=101798192 INSTANCE_GROUP_MANAGERS value
                         * @property {number} INSTANCE_TEMPLATES=226188271 INSTANCE_TEMPLATES value
                         * @property {number} INTERCONNECTS=415204741 INTERCONNECTS value
                         * @property {number} INTERCONNECT_ATTACHMENTS_PER_REGION=159968086 INTERCONNECT_ATTACHMENTS_PER_REGION value
                         * @property {number} INTERCONNECT_ATTACHMENTS_TOTAL_MBPS=425090419 INTERCONNECT_ATTACHMENTS_TOTAL_MBPS value
                         * @property {number} INTERCONNECT_TOTAL_GBPS=285341866 INTERCONNECT_TOTAL_GBPS value
                         * @property {number} INTERNAL_ADDRESSES=197899392 INTERNAL_ADDRESSES value
                         * @property {number} INTERNAL_TRAFFIC_DIRECTOR_FORWARDING_RULES=266433668 INTERNAL_TRAFFIC_DIRECTOR_FORWARDING_RULES value
                         * @property {number} IN_PLACE_SNAPSHOTS=151359133 IN_PLACE_SNAPSHOTS value
                         * @property {number} IN_USE_ADDRESSES=402125072 IN_USE_ADDRESSES value
                         * @property {number} IN_USE_BACKUP_SCHEDULES=32786705 IN_USE_BACKUP_SCHEDULES value
                         * @property {number} IN_USE_SNAPSHOT_SCHEDULES=462104083 IN_USE_SNAPSHOT_SCHEDULES value
                         * @property {number} LOCAL_SSD_TOTAL_GB=330878021 LOCAL_SSD_TOTAL_GB value
                         * @property {number} M1_CPUS=37203366 M1_CPUS value
                         * @property {number} M2_CPUS=65832517 M2_CPUS value
                         * @property {number} M3_CPUS=94461668 M3_CPUS value
                         * @property {number} MACHINE_IMAGES=446986640 MACHINE_IMAGES value
                         * @property {number} N2A_CPUS=265855917 N2A_CPUS value
                         * @property {number} N2D_CPUS=351743370 N2D_CPUS value
                         * @property {number} N2_CPUS=416465286 N2_CPUS value
                         * @property {number} NETWORKS=485481477 NETWORKS value
                         * @property {number} NETWORK_ENDPOINT_GROUPS=102144909 NETWORK_ENDPOINT_GROUPS value
                         * @property {number} NETWORK_FIREWALL_POLICIES=101117374 NETWORK_FIREWALL_POLICIES value
                         * @property {number} NODE_GROUPS=24624817 NODE_GROUPS value
                         * @property {number} NODE_TEMPLATES=474896668 NODE_TEMPLATES value
                         * @property {number} NVIDIA_A100_80GB_GPUS=286389320 NVIDIA_A100_80GB_GPUS value
                         * @property {number} NVIDIA_A100_GPUS=504872978 NVIDIA_A100_GPUS value
                         * @property {number} NVIDIA_K80_GPUS=163886599 NVIDIA_K80_GPUS value
                         * @property {number} NVIDIA_P100_GPUS=236601633 NVIDIA_P100_GPUS value
                         * @property {number} NVIDIA_P100_VWS_GPUS=213970574 NVIDIA_P100_VWS_GPUS value
                         * @property {number} NVIDIA_P4_GPUS=283841470 NVIDIA_P4_GPUS value
                         * @property {number} NVIDIA_P4_VWS_GPUS=528296619 NVIDIA_P4_VWS_GPUS value
                         * @property {number} NVIDIA_T4_GPUS=75759810 NVIDIA_T4_GPUS value
                         * @property {number} NVIDIA_T4_VWS_GPUS=319813039 NVIDIA_T4_VWS_GPUS value
                         * @property {number} NVIDIA_V100_GPUS=129293095 NVIDIA_V100_GPUS value
                         * @property {number} PACKET_MIRRORINGS=15578407 PACKET_MIRRORINGS value
                         * @property {number} PD_EXTREME_TOTAL_PROVISIONED_IOPS=69593965 PD_EXTREME_TOTAL_PROVISIONED_IOPS value
                         * @property {number} PREEMPTIBLE_CPUS=251184841 PREEMPTIBLE_CPUS value
                         * @property {number} PREEMPTIBLE_LOCAL_SSD_GB=260819336 PREEMPTIBLE_LOCAL_SSD_GB value
                         * @property {number} PREEMPTIBLE_NVIDIA_A100_80GB_GPUS=151942410 PREEMPTIBLE_NVIDIA_A100_80GB_GPUS value
                         * @property {number} PREEMPTIBLE_NVIDIA_A100_GPUS=68832784 PREEMPTIBLE_NVIDIA_A100_GPUS value
                         * @property {number} PREEMPTIBLE_NVIDIA_K80_GPUS=374960201 PREEMPTIBLE_NVIDIA_K80_GPUS value
                         * @property {number} PREEMPTIBLE_NVIDIA_P100_GPUS=337432351 PREEMPTIBLE_NVIDIA_P100_GPUS value
                         * @property {number} PREEMPTIBLE_NVIDIA_P100_VWS_GPUS=313544076 PREEMPTIBLE_NVIDIA_P100_VWS_GPUS value
                         * @property {number} PREEMPTIBLE_NVIDIA_P4_GPUS=429197628 PREEMPTIBLE_NVIDIA_P4_GPUS value
                         * @property {number} PREEMPTIBLE_NVIDIA_P4_VWS_GPUS=252981545 PREEMPTIBLE_NVIDIA_P4_VWS_GPUS value
                         * @property {number} PREEMPTIBLE_NVIDIA_T4_GPUS=221115968 PREEMPTIBLE_NVIDIA_T4_GPUS value
                         * @property {number} PREEMPTIBLE_NVIDIA_T4_VWS_GPUS=44497965 PREEMPTIBLE_NVIDIA_T4_VWS_GPUS value
                         * @property {number} PREEMPTIBLE_NVIDIA_V100_GPUS=230123813 PREEMPTIBLE_NVIDIA_V100_GPUS value
                         * @property {number} PSC_ILB_CONSUMER_FORWARDING_RULES_PER_PRODUCER_NETWORK=231164291 PSC_ILB_CONSUMER_FORWARDING_RULES_PER_PRODUCER_NETWORK value
                         * @property {number} PSC_INTERNAL_LB_FORWARDING_RULES=169005435 PSC_INTERNAL_LB_FORWARDING_RULES value
                         * @property {number} PUBLIC_ADVERTISED_PREFIXES=471371980 PUBLIC_ADVERTISED_PREFIXES value
                         * @property {number} PUBLIC_DELEGATED_PREFIXES=532465974 PUBLIC_DELEGATED_PREFIXES value
                         * @property {number} REGIONAL_AUTOSCALERS=29363772 REGIONAL_AUTOSCALERS value
                         * @property {number} REGIONAL_INSTANCE_GROUP_MANAGERS=37543696 REGIONAL_INSTANCE_GROUP_MANAGERS value
                         * @property {number} RESERVATIONS=32644647 RESERVATIONS value
                         * @property {number} RESOURCE_POLICIES=83955297 RESOURCE_POLICIES value
                         * @property {number} ROUTERS=493018666 ROUTERS value
                         * @property {number} ROUTES=275680074 ROUTES value
                         * @property {number} SECURITY_POLICIES=189518703 SECURITY_POLICIES value
                         * @property {number} SECURITY_POLICIES_PER_REGION=249041734 SECURITY_POLICIES_PER_REGION value
                         * @property {number} SECURITY_POLICY_CEVAL_RULES=470815689 SECURITY_POLICY_CEVAL_RULES value
                         * @property {number} SECURITY_POLICY_RULES=203549225 SECURITY_POLICY_RULES value
                         * @property {number} SECURITY_POLICY_RULES_PER_REGION=126510156 SECURITY_POLICY_RULES_PER_REGION value
                         * @property {number} SERVICE_ATTACHMENTS=471521510 SERVICE_ATTACHMENTS value
                         * @property {number} SNAPSHOTS=343405327 SNAPSHOTS value
                         * @property {number} SSD_TOTAL_GB=161732561 SSD_TOTAL_GB value
                         * @property {number} SSL_CERTIFICATES=378372399 SSL_CERTIFICATES value
                         * @property {number} STATIC_ADDRESSES=93624049 STATIC_ADDRESSES value
                         * @property {number} STATIC_BYOIP_ADDRESSES=275809649 STATIC_BYOIP_ADDRESSES value
                         * @property {number} STATIC_EXTERNAL_IPV6_ADDRESS_RANGES=472346774 STATIC_EXTERNAL_IPV6_ADDRESS_RANGES value
                         * @property {number} SUBNETWORKS=421330469 SUBNETWORKS value
                         * @property {number} T2A_CPUS=522170599 T2A_CPUS value
                         * @property {number} T2D_CPUS=71187140 T2D_CPUS value
                         * @property {number} TARGET_HTTPS_PROXIES=219522506 TARGET_HTTPS_PROXIES value
                         * @property {number} TARGET_HTTP_PROXIES=164117155 TARGET_HTTP_PROXIES value
                         * @property {number} TARGET_INSTANCES=284519728 TARGET_INSTANCES value
                         * @property {number} TARGET_POOLS=348261257 TARGET_POOLS value
                         * @property {number} TARGET_SSL_PROXIES=159216235 TARGET_SSL_PROXIES value
                         * @property {number} TARGET_TCP_PROXIES=182243136 TARGET_TCP_PROXIES value
                         * @property {number} TARGET_VPN_GATEWAYS=75029928 TARGET_VPN_GATEWAYS value
                         * @property {number} URL_MAPS=378660743 URL_MAPS value
                         * @property {number} VPN_GATEWAYS=35620282 VPN_GATEWAYS value
                         * @property {number} VPN_TUNNELS=104327296 VPN_TUNNELS value
                         * @property {number} XPN_SERVICE_PROJECTS=95191981 XPN_SERVICE_PROJECTS value
                         */
                        Quota.Metric = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_METRIC"] = 0;
                            values[valuesById[153206585] = "A2_CPUS"] = 153206585;
                            values[valuesById[108303563] = "AFFINITY_GROUPS"] = 108303563;
                            values[valuesById[471248988] = "AUTOSCALERS"] = 471248988;
                            values[valuesById[137626846] = "BACKEND_BUCKETS"] = 137626846;
                            values[valuesById[269623753] = "BACKEND_SERVICES"] = 269623753;
                            values[valuesById[508182517] = "C2D_CPUS"] = 508182517;
                            values[valuesById[317601211] = "C2_CPUS"] = 317601211;
                            values[valuesById[346230362] = "C3_CPUS"] = 346230362;
                            values[valuesById[456141790] = "COMMITMENTS"] = 456141790;
                            values[valuesById[59330902] = "COMMITTED_A2_CPUS"] = 59330902;
                            values[valuesById[282390904] = "COMMITTED_C2D_CPUS"] = 282390904;
                            values[valuesById[223725528] = "COMMITTED_C2_CPUS"] = 223725528;
                            values[valuesById[252354679] = "COMMITTED_C3_CPUS"] = 252354679;
                            values[valuesById[292394702] = "COMMITTED_CPUS"] = 292394702;
                            values[valuesById[388120154] = "COMMITTED_E2_CPUS"] = 388120154;
                            values[valuesById[357606869] = "COMMITTED_LICENSES"] = 357606869;
                            values[valuesById[308393480] = "COMMITTED_LOCAL_SSD_TOTAL_GB"] = 308393480;
                            values[valuesById[585985] = "COMMITTED_M3_CPUS"] = 585985;
                            values[valuesById[489057886] = "COMMITTED_MEMORY_OPTIMIZED_CPUS"] = 489057886;
                            values[valuesById[40064304] = "COMMITTED_N2A_CPUS"] = 40064304;
                            values[valuesById[125951757] = "COMMITTED_N2D_CPUS"] = 125951757;
                            values[valuesById[322589603] = "COMMITTED_N2_CPUS"] = 322589603;
                            values[valuesById[464326565] = "COMMITTED_NVIDIA_A100_80GB_GPUS"] = 464326565;
                            values[valuesById[375799445] = "COMMITTED_NVIDIA_A100_GPUS"] = 375799445;
                            values[valuesById[3857188] = "COMMITTED_NVIDIA_K80_GPUS"] = 3857188;
                            values[valuesById[107528100] = "COMMITTED_NVIDIA_P100_GPUS"] = 107528100;
                            values[valuesById[347952897] = "COMMITTED_NVIDIA_P4_GPUS"] = 347952897;
                            values[valuesById[139871237] = "COMMITTED_NVIDIA_T4_GPUS"] = 139871237;
                            values[valuesById[219562] = "COMMITTED_NVIDIA_V100_GPUS"] = 219562;
                            values[valuesById[296378986] = "COMMITTED_T2A_CPUS"] = 296378986;
                            values[valuesById[382266439] = "COMMITTED_T2D_CPUS"] = 382266439;
                            values[valuesById[2075595] = "CPUS"] = 2075595;
                            values[valuesById[470911149] = "CPUS_ALL_REGIONS"] = 470911149;
                            values[valuesById[353520543] = "DISKS_TOTAL_GB"] = 353520543;
                            values[valuesById[481995837] = "E2_CPUS"] = 481995837;
                            values[valuesById[150790089] = "EXTERNAL_MANAGED_FORWARDING_RULES"] = 150790089;
                            values[valuesById[374298265] = "EXTERNAL_NETWORK_LB_FORWARDING_RULES"] = 374298265;
                            values[valuesById[63478888] = "EXTERNAL_PROTOCOL_FORWARDING_RULES"] = 63478888;
                            values[valuesById[272457134] = "EXTERNAL_VPN_GATEWAYS"] = 272457134;
                            values[valuesById[374485843] = "FIREWALLS"] = 374485843;
                            values[valuesById[432668949] = "FORWARDING_RULES"] = 432668949;
                            values[valuesById[327611949] = "GLOBAL_EXTERNAL_MANAGED_FORWARDING_RULES"] = 327611949;
                            values[valuesById[42738332] = "GLOBAL_INTERNAL_ADDRESSES"] = 42738332;
                            values[valuesById[39387177] = "GPUS_ALL_REGIONS"] = 39387177;
                            values[valuesById[289347502] = "HEALTH_CHECKS"] = 289347502;
                            values[valuesById[15562360] = "IMAGES"] = 15562360;
                            values[valuesById[131337822] = "INSTANCES"] = 131337822;
                            values[valuesById[355919038] = "INSTANCE_GROUPS"] = 355919038;
                            values[valuesById[101798192] = "INSTANCE_GROUP_MANAGERS"] = 101798192;
                            values[valuesById[226188271] = "INSTANCE_TEMPLATES"] = 226188271;
                            values[valuesById[415204741] = "INTERCONNECTS"] = 415204741;
                            values[valuesById[159968086] = "INTERCONNECT_ATTACHMENTS_PER_REGION"] = 159968086;
                            values[valuesById[425090419] = "INTERCONNECT_ATTACHMENTS_TOTAL_MBPS"] = 425090419;
                            values[valuesById[285341866] = "INTERCONNECT_TOTAL_GBPS"] = 285341866;
                            values[valuesById[197899392] = "INTERNAL_ADDRESSES"] = 197899392;
                            values[valuesById[266433668] = "INTERNAL_TRAFFIC_DIRECTOR_FORWARDING_RULES"] = 266433668;
                            values[valuesById[151359133] = "IN_PLACE_SNAPSHOTS"] = 151359133;
                            values[valuesById[402125072] = "IN_USE_ADDRESSES"] = 402125072;
                            values[valuesById[32786705] = "IN_USE_BACKUP_SCHEDULES"] = 32786705;
                            values[valuesById[462104083] = "IN_USE_SNAPSHOT_SCHEDULES"] = 462104083;
                            values[valuesById[330878021] = "LOCAL_SSD_TOTAL_GB"] = 330878021;
                            values[valuesById[37203366] = "M1_CPUS"] = 37203366;
                            values[valuesById[65832517] = "M2_CPUS"] = 65832517;
                            values[valuesById[94461668] = "M3_CPUS"] = 94461668;
                            values[valuesById[446986640] = "MACHINE_IMAGES"] = 446986640;
                            values[valuesById[265855917] = "N2A_CPUS"] = 265855917;
                            values[valuesById[351743370] = "N2D_CPUS"] = 351743370;
                            values[valuesById[416465286] = "N2_CPUS"] = 416465286;
                            values[valuesById[485481477] = "NETWORKS"] = 485481477;
                            values[valuesById[102144909] = "NETWORK_ENDPOINT_GROUPS"] = 102144909;
                            values[valuesById[101117374] = "NETWORK_FIREWALL_POLICIES"] = 101117374;
                            values[valuesById[24624817] = "NODE_GROUPS"] = 24624817;
                            values[valuesById[474896668] = "NODE_TEMPLATES"] = 474896668;
                            values[valuesById[286389320] = "NVIDIA_A100_80GB_GPUS"] = 286389320;
                            values[valuesById[504872978] = "NVIDIA_A100_GPUS"] = 504872978;
                            values[valuesById[163886599] = "NVIDIA_K80_GPUS"] = 163886599;
                            values[valuesById[236601633] = "NVIDIA_P100_GPUS"] = 236601633;
                            values[valuesById[213970574] = "NVIDIA_P100_VWS_GPUS"] = 213970574;
                            values[valuesById[283841470] = "NVIDIA_P4_GPUS"] = 283841470;
                            values[valuesById[528296619] = "NVIDIA_P4_VWS_GPUS"] = 528296619;
                            values[valuesById[75759810] = "NVIDIA_T4_GPUS"] = 75759810;
                            values[valuesById[319813039] = "NVIDIA_T4_VWS_GPUS"] = 319813039;
                            values[valuesById[129293095] = "NVIDIA_V100_GPUS"] = 129293095;
                            values[valuesById[15578407] = "PACKET_MIRRORINGS"] = 15578407;
                            values[valuesById[69593965] = "PD_EXTREME_TOTAL_PROVISIONED_IOPS"] = 69593965;
                            values[valuesById[251184841] = "PREEMPTIBLE_CPUS"] = 251184841;
                            values[valuesById[260819336] = "PREEMPTIBLE_LOCAL_SSD_GB"] = 260819336;
                            values[valuesById[151942410] = "PREEMPTIBLE_NVIDIA_A100_80GB_GPUS"] = 151942410;
                            values[valuesById[68832784] = "PREEMPTIBLE_NVIDIA_A100_GPUS"] = 68832784;
                            values[valuesById[374960201] = "PREEMPTIBLE_NVIDIA_K80_GPUS"] = 374960201;
                            values[valuesById[337432351] = "PREEMPTIBLE_NVIDIA_P100_GPUS"] = 337432351;
                            values[valuesById[313544076] = "PREEMPTIBLE_NVIDIA_P100_VWS_GPUS"] = 313544076;
                            values[valuesById[429197628] = "PREEMPTIBLE_NVIDIA_P4_GPUS"] = 429197628;
                            values[valuesById[252981545] = "PREEMPTIBLE_NVIDIA_P4_VWS_GPUS"] = 252981545;
                            values[valuesById[221115968] = "PREEMPTIBLE_NVIDIA_T4_GPUS"] = 221115968;
                            values[valuesById[44497965] = "PREEMPTIBLE_NVIDIA_T4_VWS_GPUS"] = 44497965;
                            values[valuesById[230123813] = "PREEMPTIBLE_NVIDIA_V100_GPUS"] = 230123813;
                            values[valuesById[231164291] = "PSC_ILB_CONSUMER_FORWARDING_RULES_PER_PRODUCER_NETWORK"] = 231164291;
                            values[valuesById[169005435] = "PSC_INTERNAL_LB_FORWARDING_RULES"] = 169005435;
                            values[valuesById[471371980] = "PUBLIC_ADVERTISED_PREFIXES"] = 471371980;
                            values[valuesById[532465974] = "PUBLIC_DELEGATED_PREFIXES"] = 532465974;
                            values[valuesById[29363772] = "REGIONAL_AUTOSCALERS"] = 29363772;
                            values[valuesById[37543696] = "REGIONAL_INSTANCE_GROUP_MANAGERS"] = 37543696;
                            values[valuesById[32644647] = "RESERVATIONS"] = 32644647;
                            values[valuesById[83955297] = "RESOURCE_POLICIES"] = 83955297;
                            values[valuesById[493018666] = "ROUTERS"] = 493018666;
                            values[valuesById[275680074] = "ROUTES"] = 275680074;
                            values[valuesById[189518703] = "SECURITY_POLICIES"] = 189518703;
                            values[valuesById[249041734] = "SECURITY_POLICIES_PER_REGION"] = 249041734;
                            values[valuesById[470815689] = "SECURITY_POLICY_CEVAL_RULES"] = 470815689;
                            values[valuesById[203549225] = "SECURITY_POLICY_RULES"] = 203549225;
                            values[valuesById[126510156] = "SECURITY_POLICY_RULES_PER_REGION"] = 126510156;
                            values[valuesById[471521510] = "SERVICE_ATTACHMENTS"] = 471521510;
                            values[valuesById[343405327] = "SNAPSHOTS"] = 343405327;
                            values[valuesById[161732561] = "SSD_TOTAL_GB"] = 161732561;
                            values[valuesById[378372399] = "SSL_CERTIFICATES"] = 378372399;
                            values[valuesById[93624049] = "STATIC_ADDRESSES"] = 93624049;
                            values[valuesById[275809649] = "STATIC_BYOIP_ADDRESSES"] = 275809649;
                            values[valuesById[472346774] = "STATIC_EXTERNAL_IPV6_ADDRESS_RANGES"] = 472346774;
                            values[valuesById[421330469] = "SUBNETWORKS"] = 421330469;
                            values[valuesById[522170599] = "T2A_CPUS"] = 522170599;
                            values[valuesById[71187140] = "T2D_CPUS"] = 71187140;
                            values[valuesById[219522506] = "TARGET_HTTPS_PROXIES"] = 219522506;
                            values[valuesById[164117155] = "TARGET_HTTP_PROXIES"] = 164117155;
                            values[valuesById[284519728] = "TARGET_INSTANCES"] = 284519728;
                            values[valuesById[348261257] = "TARGET_POOLS"] = 348261257;
                            values[valuesById[159216235] = "TARGET_SSL_PROXIES"] = 159216235;
                            values[valuesById[182243136] = "TARGET_TCP_PROXIES"] = 182243136;
                            values[valuesById[75029928] = "TARGET_VPN_GATEWAYS"] = 75029928;
                            values[valuesById[378660743] = "URL_MAPS"] = 378660743;
                            values[valuesById[35620282] = "VPN_GATEWAYS"] = 35620282;
                            values[valuesById[104327296] = "VPN_TUNNELS"] = 104327296;
                            values[valuesById[95191981] = "XPN_SERVICE_PROJECTS"] = 95191981;
                            return values;
                        })();
    
                        return Quota;
                    })();
    
                    v1.QuotaExceededInfo = (function() {
    
                        /**
                         * Properties of a QuotaExceededInfo.
                         * @memberof google.cloud.compute.v1
                         * @interface IQuotaExceededInfo
                         * @property {Object.<string,string>|null} [dimensions] QuotaExceededInfo dimensions
                         * @property {number|null} [limit] QuotaExceededInfo limit
                         * @property {string|null} [limitName] QuotaExceededInfo limitName
                         * @property {string|null} [metricName] QuotaExceededInfo metricName
                         */
    
                        /**
                         * Constructs a new QuotaExceededInfo.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a QuotaExceededInfo.
                         * @implements IQuotaExceededInfo
                         * @constructor
                         * @param {google.cloud.compute.v1.IQuotaExceededInfo=} [properties] Properties to set
                         */
                        function QuotaExceededInfo(properties) {
                            this.dimensions = {};
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * QuotaExceededInfo dimensions.
                         * @member {Object.<string,string>} dimensions
                         * @memberof google.cloud.compute.v1.QuotaExceededInfo
                         * @instance
                         */
                        QuotaExceededInfo.prototype.dimensions = $util.emptyObject;
    
                        /**
                         * QuotaExceededInfo limit.
                         * @member {number|null|undefined} limit
                         * @memberof google.cloud.compute.v1.QuotaExceededInfo
                         * @instance
                         */
                        QuotaExceededInfo.prototype.limit = null;
    
                        /**
                         * QuotaExceededInfo limitName.
                         * @member {string|null|undefined} limitName
                         * @memberof google.cloud.compute.v1.QuotaExceededInfo
                         * @instance
                         */
                        QuotaExceededInfo.prototype.limitName = null;
    
                        /**
                         * QuotaExceededInfo metricName.
                         * @member {string|null|undefined} metricName
                         * @memberof google.cloud.compute.v1.QuotaExceededInfo
                         * @instance
                         */
                        QuotaExceededInfo.prototype.metricName = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * QuotaExceededInfo _limit.
                         * @member {"limit"|undefined} _limit
                         * @memberof google.cloud.compute.v1.QuotaExceededInfo
                         * @instance
                         */
                        Object.defineProperty(QuotaExceededInfo.prototype, "_limit", {
                            get: $util.oneOfGetter($oneOfFields = ["limit"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * QuotaExceededInfo _limitName.
                         * @member {"limitName"|undefined} _limitName
                         * @memberof google.cloud.compute.v1.QuotaExceededInfo
                         * @instance
                         */
                        Object.defineProperty(QuotaExceededInfo.prototype, "_limitName", {
                            get: $util.oneOfGetter($oneOfFields = ["limitName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * QuotaExceededInfo _metricName.
                         * @member {"metricName"|undefined} _metricName
                         * @memberof google.cloud.compute.v1.QuotaExceededInfo
                         * @instance
                         */
                        Object.defineProperty(QuotaExceededInfo.prototype, "_metricName", {
                            get: $util.oneOfGetter($oneOfFields = ["metricName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new QuotaExceededInfo instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.QuotaExceededInfo
                         * @static
                         * @param {google.cloud.compute.v1.IQuotaExceededInfo=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.QuotaExceededInfo} QuotaExceededInfo instance
                         */
                        QuotaExceededInfo.create = function create(properties) {
                            return new QuotaExceededInfo(properties);
                        };
    
                        /**
                         * Encodes the specified QuotaExceededInfo message. Does not implicitly {@link google.cloud.compute.v1.QuotaExceededInfo.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.QuotaExceededInfo
                         * @static
                         * @param {google.cloud.compute.v1.IQuotaExceededInfo} message QuotaExceededInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        QuotaExceededInfo.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.limit != null && Object.hasOwnProperty.call(message, "limit"))
                                writer.uint32(/* id 102976443, wireType 1 =*/823811545).double(message.limit);
                            if (message.limitName != null && Object.hasOwnProperty.call(message, "limitName"))
                                writer.uint32(/* id 398197903, wireType 2 =*/3185583226).string(message.limitName);
                            if (message.metricName != null && Object.hasOwnProperty.call(message, "metricName"))
                                writer.uint32(/* id 409881530, wireType 2 =*/3279052242).string(message.metricName);
                            if (message.dimensions != null && Object.hasOwnProperty.call(message, "dimensions"))
                                for (var keys = Object.keys(message.dimensions), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 414334925, wireType 2 =*/3314679402).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.dimensions[keys[i]]).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified QuotaExceededInfo message, length delimited. Does not implicitly {@link google.cloud.compute.v1.QuotaExceededInfo.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.QuotaExceededInfo
                         * @static
                         * @param {google.cloud.compute.v1.IQuotaExceededInfo} message QuotaExceededInfo message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        QuotaExceededInfo.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a QuotaExceededInfo message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.QuotaExceededInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.QuotaExceededInfo} QuotaExceededInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        QuotaExceededInfo.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.QuotaExceededInfo(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 414334925: {
                                        if (message.dimensions === $util.emptyObject)
                                            message.dimensions = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.dimensions[key] = value;
                                        break;
                                    }
                                case 102976443: {
                                        message.limit = reader.double();
                                        break;
                                    }
                                case 398197903: {
                                        message.limitName = reader.string();
                                        break;
                                    }
                                case 409881530: {
                                        message.metricName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a QuotaExceededInfo message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.QuotaExceededInfo
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.QuotaExceededInfo} QuotaExceededInfo
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        QuotaExceededInfo.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a QuotaExceededInfo message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.QuotaExceededInfo
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        QuotaExceededInfo.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.dimensions != null && message.hasOwnProperty("dimensions")) {
                                if (!$util.isObject(message.dimensions))
                                    return "dimensions: object expected";
                                var key = Object.keys(message.dimensions);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.dimensions[key[i]]))
                                        return "dimensions: string{k:string} expected";
                            }
                            if (message.limit != null && message.hasOwnProperty("limit")) {
                                properties._limit = 1;
                                if (typeof message.limit !== "number")
                                    return "limit: number expected";
                            }
                            if (message.limitName != null && message.hasOwnProperty("limitName")) {
                                properties._limitName = 1;
                                if (!$util.isString(message.limitName))
                                    return "limitName: string expected";
                            }
                            if (message.metricName != null && message.hasOwnProperty("metricName")) {
                                properties._metricName = 1;
                                if (!$util.isString(message.metricName))
                                    return "metricName: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a QuotaExceededInfo message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.QuotaExceededInfo
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.QuotaExceededInfo} QuotaExceededInfo
                         */
                        QuotaExceededInfo.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.QuotaExceededInfo)
                                return object;
                            var message = new $root.google.cloud.compute.v1.QuotaExceededInfo();
                            if (object.dimensions) {
                                if (typeof object.dimensions !== "object")
                                    throw TypeError(".google.cloud.compute.v1.QuotaExceededInfo.dimensions: object expected");
                                message.dimensions = {};
                                for (var keys = Object.keys(object.dimensions), i = 0; i < keys.length; ++i)
                                    message.dimensions[keys[i]] = String(object.dimensions[keys[i]]);
                            }
                            if (object.limit != null)
                                message.limit = Number(object.limit);
                            if (object.limitName != null)
                                message.limitName = String(object.limitName);
                            if (object.metricName != null)
                                message.metricName = String(object.metricName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a QuotaExceededInfo message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.QuotaExceededInfo
                         * @static
                         * @param {google.cloud.compute.v1.QuotaExceededInfo} message QuotaExceededInfo
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        QuotaExceededInfo.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.objects || options.defaults)
                                object.dimensions = {};
                            if (message.limit != null && message.hasOwnProperty("limit")) {
                                object.limit = options.json && !isFinite(message.limit) ? String(message.limit) : message.limit;
                                if (options.oneofs)
                                    object._limit = "limit";
                            }
                            if (message.limitName != null && message.hasOwnProperty("limitName")) {
                                object.limitName = message.limitName;
                                if (options.oneofs)
                                    object._limitName = "limitName";
                            }
                            if (message.metricName != null && message.hasOwnProperty("metricName")) {
                                object.metricName = message.metricName;
                                if (options.oneofs)
                                    object._metricName = "metricName";
                            }
                            var keys2;
                            if (message.dimensions && (keys2 = Object.keys(message.dimensions)).length) {
                                object.dimensions = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.dimensions[keys2[j]] = message.dimensions[keys2[j]];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this QuotaExceededInfo to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.QuotaExceededInfo
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        QuotaExceededInfo.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for QuotaExceededInfo
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.QuotaExceededInfo
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        QuotaExceededInfo.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.QuotaExceededInfo";
                        };
    
                        return QuotaExceededInfo;
                    })();
    
                    v1.RawDisk = (function() {
    
                        /**
                         * Properties of a RawDisk.
                         * @memberof google.cloud.compute.v1
                         * @interface IRawDisk
                         * @property {string|null} [containerType] RawDisk containerType
                         * @property {string|null} [sha1Checksum] RawDisk sha1Checksum
                         * @property {string|null} [source] RawDisk source
                         */
    
                        /**
                         * Constructs a new RawDisk.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RawDisk.
                         * @implements IRawDisk
                         * @constructor
                         * @param {google.cloud.compute.v1.IRawDisk=} [properties] Properties to set
                         */
                        function RawDisk(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RawDisk containerType.
                         * @member {string|null|undefined} containerType
                         * @memberof google.cloud.compute.v1.RawDisk
                         * @instance
                         */
                        RawDisk.prototype.containerType = null;
    
                        /**
                         * RawDisk sha1Checksum.
                         * @member {string|null|undefined} sha1Checksum
                         * @memberof google.cloud.compute.v1.RawDisk
                         * @instance
                         */
                        RawDisk.prototype.sha1Checksum = null;
    
                        /**
                         * RawDisk source.
                         * @member {string|null|undefined} source
                         * @memberof google.cloud.compute.v1.RawDisk
                         * @instance
                         */
                        RawDisk.prototype.source = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RawDisk _containerType.
                         * @member {"containerType"|undefined} _containerType
                         * @memberof google.cloud.compute.v1.RawDisk
                         * @instance
                         */
                        Object.defineProperty(RawDisk.prototype, "_containerType", {
                            get: $util.oneOfGetter($oneOfFields = ["containerType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RawDisk _sha1Checksum.
                         * @member {"sha1Checksum"|undefined} _sha1Checksum
                         * @memberof google.cloud.compute.v1.RawDisk
                         * @instance
                         */
                        Object.defineProperty(RawDisk.prototype, "_sha1Checksum", {
                            get: $util.oneOfGetter($oneOfFields = ["sha1Checksum"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RawDisk _source.
                         * @member {"source"|undefined} _source
                         * @memberof google.cloud.compute.v1.RawDisk
                         * @instance
                         */
                        Object.defineProperty(RawDisk.prototype, "_source", {
                            get: $util.oneOfGetter($oneOfFields = ["source"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RawDisk instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RawDisk
                         * @static
                         * @param {google.cloud.compute.v1.IRawDisk=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RawDisk} RawDisk instance
                         */
                        RawDisk.create = function create(properties) {
                            return new RawDisk(properties);
                        };
    
                        /**
                         * Encodes the specified RawDisk message. Does not implicitly {@link google.cloud.compute.v1.RawDisk.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RawDisk
                         * @static
                         * @param {google.cloud.compute.v1.IRawDisk} message RawDisk message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RawDisk.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.source != null && Object.hasOwnProperty.call(message, "source"))
                                writer.uint32(/* id 177235995, wireType 2 =*/1417887962).string(message.source);
                            if (message.sha1Checksum != null && Object.hasOwnProperty.call(message, "sha1Checksum"))
                                writer.uint32(/* id 314444349, wireType 2 =*/2515554794).string(message.sha1Checksum);
                            if (message.containerType != null && Object.hasOwnProperty.call(message, "containerType"))
                                writer.uint32(/* id 318809144, wireType 2 =*/2550473154).string(message.containerType);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RawDisk message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RawDisk.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RawDisk
                         * @static
                         * @param {google.cloud.compute.v1.IRawDisk} message RawDisk message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RawDisk.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RawDisk message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RawDisk
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RawDisk} RawDisk
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RawDisk.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RawDisk();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 318809144: {
                                        message.containerType = reader.string();
                                        break;
                                    }
                                case 314444349: {
                                        message.sha1Checksum = reader.string();
                                        break;
                                    }
                                case 177235995: {
                                        message.source = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RawDisk message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RawDisk
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RawDisk} RawDisk
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RawDisk.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RawDisk message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RawDisk
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RawDisk.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.containerType != null && message.hasOwnProperty("containerType")) {
                                properties._containerType = 1;
                                if (!$util.isString(message.containerType))
                                    return "containerType: string expected";
                            }
                            if (message.sha1Checksum != null && message.hasOwnProperty("sha1Checksum")) {
                                properties._sha1Checksum = 1;
                                if (!$util.isString(message.sha1Checksum))
                                    return "sha1Checksum: string expected";
                            }
                            if (message.source != null && message.hasOwnProperty("source")) {
                                properties._source = 1;
                                if (!$util.isString(message.source))
                                    return "source: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RawDisk message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RawDisk
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RawDisk} RawDisk
                         */
                        RawDisk.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RawDisk)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RawDisk();
                            if (object.containerType != null)
                                message.containerType = String(object.containerType);
                            if (object.sha1Checksum != null)
                                message.sha1Checksum = String(object.sha1Checksum);
                            if (object.source != null)
                                message.source = String(object.source);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RawDisk message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RawDisk
                         * @static
                         * @param {google.cloud.compute.v1.RawDisk} message RawDisk
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RawDisk.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.source != null && message.hasOwnProperty("source")) {
                                object.source = message.source;
                                if (options.oneofs)
                                    object._source = "source";
                            }
                            if (message.sha1Checksum != null && message.hasOwnProperty("sha1Checksum")) {
                                object.sha1Checksum = message.sha1Checksum;
                                if (options.oneofs)
                                    object._sha1Checksum = "sha1Checksum";
                            }
                            if (message.containerType != null && message.hasOwnProperty("containerType")) {
                                object.containerType = message.containerType;
                                if (options.oneofs)
                                    object._containerType = "containerType";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RawDisk to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RawDisk
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RawDisk.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RawDisk
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RawDisk
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RawDisk.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RawDisk";
                        };
    
                        /**
                         * ContainerType enum.
                         * @name google.cloud.compute.v1.RawDisk.ContainerType
                         * @enum {number}
                         * @property {number} UNDEFINED_CONTAINER_TYPE=0 UNDEFINED_CONTAINER_TYPE value
                         * @property {number} TAR=82821 TAR value
                         */
                        RawDisk.ContainerType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_CONTAINER_TYPE"] = 0;
                            values[valuesById[82821] = "TAR"] = 82821;
                            return values;
                        })();
    
                        return RawDisk;
                    })();
    
                    v1.RecreateInstancesInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a RecreateInstancesInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRecreateInstancesInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] RecreateInstancesInstanceGroupManagerRequest instanceGroupManager
                         * @property {google.cloud.compute.v1.IInstanceGroupManagersRecreateInstancesRequest|null} [instanceGroupManagersRecreateInstancesRequestResource] RecreateInstancesInstanceGroupManagerRequest instanceGroupManagersRecreateInstancesRequestResource
                         * @property {string|null} [project] RecreateInstancesInstanceGroupManagerRequest project
                         * @property {string|null} [requestId] RecreateInstancesInstanceGroupManagerRequest requestId
                         * @property {string|null} [zone] RecreateInstancesInstanceGroupManagerRequest zone
                         */
    
                        /**
                         * Constructs a new RecreateInstancesInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RecreateInstancesInstanceGroupManagerRequest.
                         * @implements IRecreateInstancesInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRecreateInstancesInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function RecreateInstancesInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RecreateInstancesInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        RecreateInstancesInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * RecreateInstancesInstanceGroupManagerRequest instanceGroupManagersRecreateInstancesRequestResource.
                         * @member {google.cloud.compute.v1.IInstanceGroupManagersRecreateInstancesRequest|null|undefined} instanceGroupManagersRecreateInstancesRequestResource
                         * @memberof google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        RecreateInstancesInstanceGroupManagerRequest.prototype.instanceGroupManagersRecreateInstancesRequestResource = null;
    
                        /**
                         * RecreateInstancesInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        RecreateInstancesInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * RecreateInstancesInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        RecreateInstancesInstanceGroupManagerRequest.prototype.requestId = null;
    
                        /**
                         * RecreateInstancesInstanceGroupManagerRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        RecreateInstancesInstanceGroupManagerRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RecreateInstancesInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(RecreateInstancesInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RecreateInstancesInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRecreateInstancesInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest} RecreateInstancesInstanceGroupManagerRequest instance
                         */
                        RecreateInstancesInstanceGroupManagerRequest.create = function create(properties) {
                            return new RecreateInstancesInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RecreateInstancesInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRecreateInstancesInstanceGroupManagerRequest} message RecreateInstancesInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RecreateInstancesInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instanceGroupManagersRecreateInstancesRequestResource != null && Object.hasOwnProperty.call(message, "instanceGroupManagersRecreateInstancesRequestResource"))
                                $root.google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest.encode(message.instanceGroupManagersRecreateInstancesRequestResource, writer.uint32(/* id 21405952, wireType 2 =*/171247618).fork()).ldelim();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RecreateInstancesInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRecreateInstancesInstanceGroupManagerRequest} message RecreateInstancesInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RecreateInstancesInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RecreateInstancesInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest} RecreateInstancesInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RecreateInstancesInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 21405952: {
                                        message.instanceGroupManagersRecreateInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RecreateInstancesInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest} RecreateInstancesInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RecreateInstancesInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RecreateInstancesInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RecreateInstancesInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.instanceGroupManagersRecreateInstancesRequestResource != null && message.hasOwnProperty("instanceGroupManagersRecreateInstancesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest.verify(message.instanceGroupManagersRecreateInstancesRequestResource);
                                if (error)
                                    return "instanceGroupManagersRecreateInstancesRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a RecreateInstancesInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest} RecreateInstancesInstanceGroupManagerRequest
                         */
                        RecreateInstancesInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.instanceGroupManagersRecreateInstancesRequestResource != null) {
                                if (typeof object.instanceGroupManagersRecreateInstancesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest.instanceGroupManagersRecreateInstancesRequestResource: object expected");
                                message.instanceGroupManagersRecreateInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest.fromObject(object.instanceGroupManagersRecreateInstancesRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RecreateInstancesInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest} message RecreateInstancesInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RecreateInstancesInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instanceGroupManagersRecreateInstancesRequestResource = null;
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instanceGroupManagersRecreateInstancesRequestResource != null && message.hasOwnProperty("instanceGroupManagersRecreateInstancesRequestResource"))
                                object.instanceGroupManagersRecreateInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersRecreateInstancesRequest.toObject(message.instanceGroupManagersRecreateInstancesRequestResource, options);
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            return object;
                        };
    
                        /**
                         * Converts this RecreateInstancesInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RecreateInstancesInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RecreateInstancesInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RecreateInstancesInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest";
                        };
    
                        return RecreateInstancesInstanceGroupManagerRequest;
                    })();
    
                    v1.RecreateInstancesRegionInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a RecreateInstancesRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRecreateInstancesRegionInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] RecreateInstancesRegionInstanceGroupManagerRequest instanceGroupManager
                         * @property {string|null} [project] RecreateInstancesRegionInstanceGroupManagerRequest project
                         * @property {string|null} [region] RecreateInstancesRegionInstanceGroupManagerRequest region
                         * @property {google.cloud.compute.v1.IRegionInstanceGroupManagersRecreateRequest|null} [regionInstanceGroupManagersRecreateRequestResource] RecreateInstancesRegionInstanceGroupManagerRequest regionInstanceGroupManagersRecreateRequestResource
                         * @property {string|null} [requestId] RecreateInstancesRegionInstanceGroupManagerRequest requestId
                         */
    
                        /**
                         * Constructs a new RecreateInstancesRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RecreateInstancesRegionInstanceGroupManagerRequest.
                         * @implements IRecreateInstancesRegionInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRecreateInstancesRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function RecreateInstancesRegionInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RecreateInstancesRegionInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        RecreateInstancesRegionInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * RecreateInstancesRegionInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        RecreateInstancesRegionInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * RecreateInstancesRegionInstanceGroupManagerRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        RecreateInstancesRegionInstanceGroupManagerRequest.prototype.region = "";
    
                        /**
                         * RecreateInstancesRegionInstanceGroupManagerRequest regionInstanceGroupManagersRecreateRequestResource.
                         * @member {google.cloud.compute.v1.IRegionInstanceGroupManagersRecreateRequest|null|undefined} regionInstanceGroupManagersRecreateRequestResource
                         * @memberof google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        RecreateInstancesRegionInstanceGroupManagerRequest.prototype.regionInstanceGroupManagersRecreateRequestResource = null;
    
                        /**
                         * RecreateInstancesRegionInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        RecreateInstancesRegionInstanceGroupManagerRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RecreateInstancesRegionInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(RecreateInstancesRegionInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RecreateInstancesRegionInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRecreateInstancesRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest} RecreateInstancesRegionInstanceGroupManagerRequest instance
                         */
                        RecreateInstancesRegionInstanceGroupManagerRequest.create = function create(properties) {
                            return new RecreateInstancesRegionInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RecreateInstancesRegionInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRecreateInstancesRegionInstanceGroupManagerRequest} message RecreateInstancesRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RecreateInstancesRegionInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.regionInstanceGroupManagersRecreateRequestResource != null && Object.hasOwnProperty.call(message, "regionInstanceGroupManagersRecreateRequestResource"))
                                $root.google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest.encode(message.regionInstanceGroupManagersRecreateRequestResource, writer.uint32(/* id 170999316, wireType 2 =*/1367994530).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RecreateInstancesRegionInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRecreateInstancesRegionInstanceGroupManagerRequest} message RecreateInstancesRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RecreateInstancesRegionInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RecreateInstancesRegionInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest} RecreateInstancesRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RecreateInstancesRegionInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 170999316: {
                                        message.regionInstanceGroupManagersRecreateRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RecreateInstancesRegionInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest} RecreateInstancesRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RecreateInstancesRegionInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RecreateInstancesRegionInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RecreateInstancesRegionInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionInstanceGroupManagersRecreateRequestResource != null && message.hasOwnProperty("regionInstanceGroupManagersRecreateRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest.verify(message.regionInstanceGroupManagersRecreateRequestResource);
                                if (error)
                                    return "regionInstanceGroupManagersRecreateRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RecreateInstancesRegionInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest} RecreateInstancesRegionInstanceGroupManagerRequest
                         */
                        RecreateInstancesRegionInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionInstanceGroupManagersRecreateRequestResource != null) {
                                if (typeof object.regionInstanceGroupManagersRecreateRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest.regionInstanceGroupManagersRecreateRequestResource: object expected");
                                message.regionInstanceGroupManagersRecreateRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest.fromObject(object.regionInstanceGroupManagersRecreateRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RecreateInstancesRegionInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest} message RecreateInstancesRegionInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RecreateInstancesRegionInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.regionInstanceGroupManagersRecreateRequestResource = null;
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.regionInstanceGroupManagersRecreateRequestResource != null && message.hasOwnProperty("regionInstanceGroupManagersRecreateRequestResource"))
                                object.regionInstanceGroupManagersRecreateRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest.toObject(message.regionInstanceGroupManagersRecreateRequestResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            return object;
                        };
    
                        /**
                         * Converts this RecreateInstancesRegionInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RecreateInstancesRegionInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RecreateInstancesRegionInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RecreateInstancesRegionInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest";
                        };
    
                        return RecreateInstancesRegionInstanceGroupManagerRequest;
                    })();
    
                    v1.Reference = (function() {
    
                        /**
                         * Properties of a Reference.
                         * @memberof google.cloud.compute.v1
                         * @interface IReference
                         * @property {string|null} [kind] Reference kind
                         * @property {string|null} [referenceType] Reference referenceType
                         * @property {string|null} [referrer] Reference referrer
                         * @property {string|null} [target] Reference target
                         */
    
                        /**
                         * Constructs a new Reference.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Reference.
                         * @implements IReference
                         * @constructor
                         * @param {google.cloud.compute.v1.IReference=} [properties] Properties to set
                         */
                        function Reference(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Reference kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Reference
                         * @instance
                         */
                        Reference.prototype.kind = null;
    
                        /**
                         * Reference referenceType.
                         * @member {string|null|undefined} referenceType
                         * @memberof google.cloud.compute.v1.Reference
                         * @instance
                         */
                        Reference.prototype.referenceType = null;
    
                        /**
                         * Reference referrer.
                         * @member {string|null|undefined} referrer
                         * @memberof google.cloud.compute.v1.Reference
                         * @instance
                         */
                        Reference.prototype.referrer = null;
    
                        /**
                         * Reference target.
                         * @member {string|null|undefined} target
                         * @memberof google.cloud.compute.v1.Reference
                         * @instance
                         */
                        Reference.prototype.target = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Reference _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Reference
                         * @instance
                         */
                        Object.defineProperty(Reference.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Reference _referenceType.
                         * @member {"referenceType"|undefined} _referenceType
                         * @memberof google.cloud.compute.v1.Reference
                         * @instance
                         */
                        Object.defineProperty(Reference.prototype, "_referenceType", {
                            get: $util.oneOfGetter($oneOfFields = ["referenceType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Reference _referrer.
                         * @member {"referrer"|undefined} _referrer
                         * @memberof google.cloud.compute.v1.Reference
                         * @instance
                         */
                        Object.defineProperty(Reference.prototype, "_referrer", {
                            get: $util.oneOfGetter($oneOfFields = ["referrer"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Reference _target.
                         * @member {"target"|undefined} _target
                         * @memberof google.cloud.compute.v1.Reference
                         * @instance
                         */
                        Object.defineProperty(Reference.prototype, "_target", {
                            get: $util.oneOfGetter($oneOfFields = ["target"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Reference instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Reference
                         * @static
                         * @param {google.cloud.compute.v1.IReference=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Reference} Reference instance
                         */
                        Reference.create = function create(properties) {
                            return new Reference(properties);
                        };
    
                        /**
                         * Encodes the specified Reference message. Does not implicitly {@link google.cloud.compute.v1.Reference.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Reference
                         * @static
                         * @param {google.cloud.compute.v1.IReference} message Reference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Reference.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.target != null && Object.hasOwnProperty.call(message, "target"))
                                writer.uint32(/* id 192835985, wireType 2 =*/1542687882).string(message.target);
                            if (message.referenceType != null && Object.hasOwnProperty.call(message, "referenceType"))
                                writer.uint32(/* id 247521198, wireType 2 =*/1980169586).string(message.referenceType);
                            if (message.referrer != null && Object.hasOwnProperty.call(message, "referrer"))
                                writer.uint32(/* id 351173663, wireType 2 =*/2809389306).string(message.referrer);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Reference message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Reference.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Reference
                         * @static
                         * @param {google.cloud.compute.v1.IReference} message Reference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Reference.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Reference message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Reference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Reference} Reference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Reference.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Reference();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 247521198: {
                                        message.referenceType = reader.string();
                                        break;
                                    }
                                case 351173663: {
                                        message.referrer = reader.string();
                                        break;
                                    }
                                case 192835985: {
                                        message.target = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Reference message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Reference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Reference} Reference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Reference.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Reference message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Reference
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Reference.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.referenceType != null && message.hasOwnProperty("referenceType")) {
                                properties._referenceType = 1;
                                if (!$util.isString(message.referenceType))
                                    return "referenceType: string expected";
                            }
                            if (message.referrer != null && message.hasOwnProperty("referrer")) {
                                properties._referrer = 1;
                                if (!$util.isString(message.referrer))
                                    return "referrer: string expected";
                            }
                            if (message.target != null && message.hasOwnProperty("target")) {
                                properties._target = 1;
                                if (!$util.isString(message.target))
                                    return "target: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Reference message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Reference
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Reference} Reference
                         */
                        Reference.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Reference)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Reference();
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.referenceType != null)
                                message.referenceType = String(object.referenceType);
                            if (object.referrer != null)
                                message.referrer = String(object.referrer);
                            if (object.target != null)
                                message.target = String(object.target);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Reference message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Reference
                         * @static
                         * @param {google.cloud.compute.v1.Reference} message Reference
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Reference.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.target != null && message.hasOwnProperty("target")) {
                                object.target = message.target;
                                if (options.oneofs)
                                    object._target = "target";
                            }
                            if (message.referenceType != null && message.hasOwnProperty("referenceType")) {
                                object.referenceType = message.referenceType;
                                if (options.oneofs)
                                    object._referenceType = "referenceType";
                            }
                            if (message.referrer != null && message.hasOwnProperty("referrer")) {
                                object.referrer = message.referrer;
                                if (options.oneofs)
                                    object._referrer = "referrer";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Reference to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Reference
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Reference.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Reference
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Reference
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Reference.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Reference";
                        };
    
                        return Reference;
                    })();
    
                    v1.Region = (function() {
    
                        /**
                         * Properties of a Region.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegion
                         * @property {string|null} [creationTimestamp] Region creationTimestamp
                         * @property {google.cloud.compute.v1.IDeprecationStatus|null} [deprecated] Region deprecated
                         * @property {string|null} [description] Region description
                         * @property {number|Long|null} [id] Region id
                         * @property {string|null} [kind] Region kind
                         * @property {string|null} [name] Region name
                         * @property {Array.<google.cloud.compute.v1.IQuota>|null} [quotas] Region quotas
                         * @property {string|null} [selfLink] Region selfLink
                         * @property {string|null} [status] Region status
                         * @property {boolean|null} [supportsPzs] Region supportsPzs
                         * @property {Array.<string>|null} [zones] Region zones
                         */
    
                        /**
                         * Constructs a new Region.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Region.
                         * @implements IRegion
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegion=} [properties] Properties to set
                         */
                        function Region(properties) {
                            this.quotas = [];
                            this.zones = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Region creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         */
                        Region.prototype.creationTimestamp = null;
    
                        /**
                         * Region deprecated.
                         * @member {google.cloud.compute.v1.IDeprecationStatus|null|undefined} deprecated
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         */
                        Region.prototype.deprecated = null;
    
                        /**
                         * Region description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         */
                        Region.prototype.description = null;
    
                        /**
                         * Region id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         */
                        Region.prototype.id = null;
    
                        /**
                         * Region kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         */
                        Region.prototype.kind = null;
    
                        /**
                         * Region name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         */
                        Region.prototype.name = null;
    
                        /**
                         * Region quotas.
                         * @member {Array.<google.cloud.compute.v1.IQuota>} quotas
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         */
                        Region.prototype.quotas = $util.emptyArray;
    
                        /**
                         * Region selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         */
                        Region.prototype.selfLink = null;
    
                        /**
                         * Region status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         */
                        Region.prototype.status = null;
    
                        /**
                         * Region supportsPzs.
                         * @member {boolean|null|undefined} supportsPzs
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         */
                        Region.prototype.supportsPzs = null;
    
                        /**
                         * Region zones.
                         * @member {Array.<string>} zones
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         */
                        Region.prototype.zones = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Region _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         */
                        Object.defineProperty(Region.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Region _deprecated.
                         * @member {"deprecated"|undefined} _deprecated
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         */
                        Object.defineProperty(Region.prototype, "_deprecated", {
                            get: $util.oneOfGetter($oneOfFields = ["deprecated"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Region _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         */
                        Object.defineProperty(Region.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Region _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         */
                        Object.defineProperty(Region.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Region _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         */
                        Object.defineProperty(Region.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Region _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         */
                        Object.defineProperty(Region.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Region _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         */
                        Object.defineProperty(Region.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Region _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         */
                        Object.defineProperty(Region.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Region _supportsPzs.
                         * @member {"supportsPzs"|undefined} _supportsPzs
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         */
                        Object.defineProperty(Region.prototype, "_supportsPzs", {
                            get: $util.oneOfGetter($oneOfFields = ["supportsPzs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Region instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Region
                         * @static
                         * @param {google.cloud.compute.v1.IRegion=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Region} Region instance
                         */
                        Region.create = function create(properties) {
                            return new Region(properties);
                        };
    
                        /**
                         * Encodes the specified Region message. Does not implicitly {@link google.cloud.compute.v1.Region.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Region
                         * @static
                         * @param {google.cloud.compute.v1.IRegion} message Region message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Region.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.supportsPzs != null && Object.hasOwnProperty.call(message, "supportsPzs"))
                                writer.uint32(/* id 83983214, wireType 0 =*/671865712).bool(message.supportsPzs);
                            if (message.zones != null && message.zones.length)
                                for (var i = 0; i < message.zones.length; ++i)
                                    writer.uint32(/* id 116085319, wireType 2 =*/928682554).string(message.zones[i]);
                            if (message.quotas != null && message.quotas.length)
                                for (var i = 0; i < message.quotas.length; ++i)
                                    $root.google.cloud.compute.v1.Quota.encode(message.quotas[i], writer.uint32(/* id 125341947, wireType 2 =*/1002735578).fork()).ldelim();
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                                $root.google.cloud.compute.v1.DeprecationStatus.encode(message.deprecated, writer.uint32(/* id 515138995, wireType 2 =*/4121111962).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Region message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Region.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Region
                         * @static
                         * @param {google.cloud.compute.v1.IRegion} message Region message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Region.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Region message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Region
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Region} Region
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Region.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Region();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 515138995: {
                                        message.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 125341947: {
                                        if (!(message.quotas && message.quotas.length))
                                            message.quotas = [];
                                        message.quotas.push($root.google.cloud.compute.v1.Quota.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                case 83983214: {
                                        message.supportsPzs = reader.bool();
                                        break;
                                    }
                                case 116085319: {
                                        if (!(message.zones && message.zones.length))
                                            message.zones = [];
                                        message.zones.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Region message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Region
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Region} Region
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Region.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Region message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Region
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Region.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.deprecated != null && message.hasOwnProperty("deprecated")) {
                                properties._deprecated = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.DeprecationStatus.verify(message.deprecated);
                                    if (error)
                                        return "deprecated." + error;
                                }
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.quotas != null && message.hasOwnProperty("quotas")) {
                                if (!Array.isArray(message.quotas))
                                    return "quotas: array expected";
                                for (var i = 0; i < message.quotas.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Quota.verify(message.quotas[i]);
                                    if (error)
                                        return "quotas." + error;
                                }
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            if (message.supportsPzs != null && message.hasOwnProperty("supportsPzs")) {
                                properties._supportsPzs = 1;
                                if (typeof message.supportsPzs !== "boolean")
                                    return "supportsPzs: boolean expected";
                            }
                            if (message.zones != null && message.hasOwnProperty("zones")) {
                                if (!Array.isArray(message.zones))
                                    return "zones: array expected";
                                for (var i = 0; i < message.zones.length; ++i)
                                    if (!$util.isString(message.zones[i]))
                                        return "zones: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Region message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Region
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Region} Region
                         */
                        Region.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Region)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Region();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.deprecated != null) {
                                if (typeof object.deprecated !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Region.deprecated: object expected");
                                message.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.fromObject(object.deprecated);
                            }
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.quotas) {
                                if (!Array.isArray(object.quotas))
                                    throw TypeError(".google.cloud.compute.v1.Region.quotas: array expected");
                                message.quotas = [];
                                for (var i = 0; i < object.quotas.length; ++i) {
                                    if (typeof object.quotas[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Region.quotas: object expected");
                                    message.quotas[i] = $root.google.cloud.compute.v1.Quota.fromObject(object.quotas[i]);
                                }
                            }
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.status != null)
                                message.status = String(object.status);
                            if (object.supportsPzs != null)
                                message.supportsPzs = Boolean(object.supportsPzs);
                            if (object.zones) {
                                if (!Array.isArray(object.zones))
                                    throw TypeError(".google.cloud.compute.v1.Region.zones: array expected");
                                message.zones = [];
                                for (var i = 0; i < object.zones.length; ++i)
                                    message.zones[i] = String(object.zones[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Region message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Region
                         * @static
                         * @param {google.cloud.compute.v1.Region} message Region
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Region.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.zones = [];
                                object.quotas = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.supportsPzs != null && message.hasOwnProperty("supportsPzs")) {
                                object.supportsPzs = message.supportsPzs;
                                if (options.oneofs)
                                    object._supportsPzs = "supportsPzs";
                            }
                            if (message.zones && message.zones.length) {
                                object.zones = [];
                                for (var j = 0; j < message.zones.length; ++j)
                                    object.zones[j] = message.zones[j];
                            }
                            if (message.quotas && message.quotas.length) {
                                object.quotas = [];
                                for (var j = 0; j < message.quotas.length; ++j)
                                    object.quotas[j] = $root.google.cloud.compute.v1.Quota.toObject(message.quotas[j], options);
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.deprecated != null && message.hasOwnProperty("deprecated")) {
                                object.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.toObject(message.deprecated, options);
                                if (options.oneofs)
                                    object._deprecated = "deprecated";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Region to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Region
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Region.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Region
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Region
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Region.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Region";
                        };
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.Region.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} DOWN=2104482 DOWN value
                         * @property {number} UP=2715 UP value
                         */
                        Region.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[2104482] = "DOWN"] = 2104482;
                            values[valuesById[2715] = "UP"] = 2715;
                            return values;
                        })();
    
                        return Region;
                    })();
    
                    v1.RegionAutoscalerList = (function() {
    
                        /**
                         * Properties of a RegionAutoscalerList.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionAutoscalerList
                         * @property {string|null} [id] RegionAutoscalerList id
                         * @property {Array.<google.cloud.compute.v1.IAutoscaler>|null} [items] RegionAutoscalerList items
                         * @property {string|null} [kind] RegionAutoscalerList kind
                         * @property {string|null} [nextPageToken] RegionAutoscalerList nextPageToken
                         * @property {string|null} [selfLink] RegionAutoscalerList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] RegionAutoscalerList warning
                         */
    
                        /**
                         * Constructs a new RegionAutoscalerList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionAutoscalerList.
                         * @implements IRegionAutoscalerList
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionAutoscalerList=} [properties] Properties to set
                         */
                        function RegionAutoscalerList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionAutoscalerList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @instance
                         */
                        RegionAutoscalerList.prototype.id = null;
    
                        /**
                         * RegionAutoscalerList items.
                         * @member {Array.<google.cloud.compute.v1.IAutoscaler>} items
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @instance
                         */
                        RegionAutoscalerList.prototype.items = $util.emptyArray;
    
                        /**
                         * RegionAutoscalerList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @instance
                         */
                        RegionAutoscalerList.prototype.kind = null;
    
                        /**
                         * RegionAutoscalerList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @instance
                         */
                        RegionAutoscalerList.prototype.nextPageToken = null;
    
                        /**
                         * RegionAutoscalerList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @instance
                         */
                        RegionAutoscalerList.prototype.selfLink = null;
    
                        /**
                         * RegionAutoscalerList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @instance
                         */
                        RegionAutoscalerList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RegionAutoscalerList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @instance
                         */
                        Object.defineProperty(RegionAutoscalerList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionAutoscalerList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @instance
                         */
                        Object.defineProperty(RegionAutoscalerList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionAutoscalerList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @instance
                         */
                        Object.defineProperty(RegionAutoscalerList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionAutoscalerList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @instance
                         */
                        Object.defineProperty(RegionAutoscalerList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionAutoscalerList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @instance
                         */
                        Object.defineProperty(RegionAutoscalerList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RegionAutoscalerList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @static
                         * @param {google.cloud.compute.v1.IRegionAutoscalerList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionAutoscalerList} RegionAutoscalerList instance
                         */
                        RegionAutoscalerList.create = function create(properties) {
                            return new RegionAutoscalerList(properties);
                        };
    
                        /**
                         * Encodes the specified RegionAutoscalerList message. Does not implicitly {@link google.cloud.compute.v1.RegionAutoscalerList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @static
                         * @param {google.cloud.compute.v1.IRegionAutoscalerList} message RegionAutoscalerList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionAutoscalerList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Autoscaler.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionAutoscalerList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionAutoscalerList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @static
                         * @param {google.cloud.compute.v1.IRegionAutoscalerList} message RegionAutoscalerList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionAutoscalerList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionAutoscalerList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionAutoscalerList} RegionAutoscalerList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionAutoscalerList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionAutoscalerList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Autoscaler.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionAutoscalerList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionAutoscalerList} RegionAutoscalerList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionAutoscalerList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionAutoscalerList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionAutoscalerList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Autoscaler.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionAutoscalerList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionAutoscalerList} RegionAutoscalerList
                         */
                        RegionAutoscalerList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionAutoscalerList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionAutoscalerList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.RegionAutoscalerList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RegionAutoscalerList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Autoscaler.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RegionAutoscalerList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionAutoscalerList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @static
                         * @param {google.cloud.compute.v1.RegionAutoscalerList} message RegionAutoscalerList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionAutoscalerList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Autoscaler.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionAutoscalerList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionAutoscalerList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionAutoscalerList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionAutoscalerList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionAutoscalerList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionAutoscalerList";
                        };
    
                        return RegionAutoscalerList;
                    })();
    
                    v1.RegionDiskTypeList = (function() {
    
                        /**
                         * Properties of a RegionDiskTypeList.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionDiskTypeList
                         * @property {string|null} [id] RegionDiskTypeList id
                         * @property {Array.<google.cloud.compute.v1.IDiskType>|null} [items] RegionDiskTypeList items
                         * @property {string|null} [kind] RegionDiskTypeList kind
                         * @property {string|null} [nextPageToken] RegionDiskTypeList nextPageToken
                         * @property {string|null} [selfLink] RegionDiskTypeList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] RegionDiskTypeList warning
                         */
    
                        /**
                         * Constructs a new RegionDiskTypeList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionDiskTypeList.
                         * @implements IRegionDiskTypeList
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionDiskTypeList=} [properties] Properties to set
                         */
                        function RegionDiskTypeList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionDiskTypeList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @instance
                         */
                        RegionDiskTypeList.prototype.id = null;
    
                        /**
                         * RegionDiskTypeList items.
                         * @member {Array.<google.cloud.compute.v1.IDiskType>} items
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @instance
                         */
                        RegionDiskTypeList.prototype.items = $util.emptyArray;
    
                        /**
                         * RegionDiskTypeList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @instance
                         */
                        RegionDiskTypeList.prototype.kind = null;
    
                        /**
                         * RegionDiskTypeList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @instance
                         */
                        RegionDiskTypeList.prototype.nextPageToken = null;
    
                        /**
                         * RegionDiskTypeList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @instance
                         */
                        RegionDiskTypeList.prototype.selfLink = null;
    
                        /**
                         * RegionDiskTypeList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @instance
                         */
                        RegionDiskTypeList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RegionDiskTypeList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @instance
                         */
                        Object.defineProperty(RegionDiskTypeList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionDiskTypeList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @instance
                         */
                        Object.defineProperty(RegionDiskTypeList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionDiskTypeList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @instance
                         */
                        Object.defineProperty(RegionDiskTypeList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionDiskTypeList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @instance
                         */
                        Object.defineProperty(RegionDiskTypeList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionDiskTypeList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @instance
                         */
                        Object.defineProperty(RegionDiskTypeList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RegionDiskTypeList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @static
                         * @param {google.cloud.compute.v1.IRegionDiskTypeList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionDiskTypeList} RegionDiskTypeList instance
                         */
                        RegionDiskTypeList.create = function create(properties) {
                            return new RegionDiskTypeList(properties);
                        };
    
                        /**
                         * Encodes the specified RegionDiskTypeList message. Does not implicitly {@link google.cloud.compute.v1.RegionDiskTypeList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @static
                         * @param {google.cloud.compute.v1.IRegionDiskTypeList} message RegionDiskTypeList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionDiskTypeList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.DiskType.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionDiskTypeList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionDiskTypeList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @static
                         * @param {google.cloud.compute.v1.IRegionDiskTypeList} message RegionDiskTypeList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionDiskTypeList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionDiskTypeList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionDiskTypeList} RegionDiskTypeList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionDiskTypeList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionDiskTypeList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.DiskType.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionDiskTypeList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionDiskTypeList} RegionDiskTypeList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionDiskTypeList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionDiskTypeList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionDiskTypeList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.DiskType.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionDiskTypeList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionDiskTypeList} RegionDiskTypeList
                         */
                        RegionDiskTypeList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionDiskTypeList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionDiskTypeList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.RegionDiskTypeList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RegionDiskTypeList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.DiskType.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RegionDiskTypeList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionDiskTypeList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @static
                         * @param {google.cloud.compute.v1.RegionDiskTypeList} message RegionDiskTypeList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionDiskTypeList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.DiskType.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionDiskTypeList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionDiskTypeList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionDiskTypeList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionDiskTypeList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionDiskTypeList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionDiskTypeList";
                        };
    
                        return RegionDiskTypeList;
                    })();
    
                    v1.RegionDisksAddResourcePoliciesRequest = (function() {
    
                        /**
                         * Properties of a RegionDisksAddResourcePoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionDisksAddResourcePoliciesRequest
                         * @property {Array.<string>|null} [resourcePolicies] RegionDisksAddResourcePoliciesRequest resourcePolicies
                         */
    
                        /**
                         * Constructs a new RegionDisksAddResourcePoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionDisksAddResourcePoliciesRequest.
                         * @implements IRegionDisksAddResourcePoliciesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionDisksAddResourcePoliciesRequest=} [properties] Properties to set
                         */
                        function RegionDisksAddResourcePoliciesRequest(properties) {
                            this.resourcePolicies = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionDisksAddResourcePoliciesRequest resourcePolicies.
                         * @member {Array.<string>} resourcePolicies
                         * @memberof google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest
                         * @instance
                         */
                        RegionDisksAddResourcePoliciesRequest.prototype.resourcePolicies = $util.emptyArray;
    
                        /**
                         * Creates a new RegionDisksAddResourcePoliciesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionDisksAddResourcePoliciesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest} RegionDisksAddResourcePoliciesRequest instance
                         */
                        RegionDisksAddResourcePoliciesRequest.create = function create(properties) {
                            return new RegionDisksAddResourcePoliciesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RegionDisksAddResourcePoliciesRequest message. Does not implicitly {@link google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionDisksAddResourcePoliciesRequest} message RegionDisksAddResourcePoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionDisksAddResourcePoliciesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourcePolicies != null && message.resourcePolicies.length)
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    writer.uint32(/* id 22220385, wireType 2 =*/177763082).string(message.resourcePolicies[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionDisksAddResourcePoliciesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionDisksAddResourcePoliciesRequest} message RegionDisksAddResourcePoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionDisksAddResourcePoliciesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionDisksAddResourcePoliciesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest} RegionDisksAddResourcePoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionDisksAddResourcePoliciesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 22220385: {
                                        if (!(message.resourcePolicies && message.resourcePolicies.length))
                                            message.resourcePolicies = [];
                                        message.resourcePolicies.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionDisksAddResourcePoliciesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest} RegionDisksAddResourcePoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionDisksAddResourcePoliciesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionDisksAddResourcePoliciesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionDisksAddResourcePoliciesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourcePolicies != null && message.hasOwnProperty("resourcePolicies")) {
                                if (!Array.isArray(message.resourcePolicies))
                                    return "resourcePolicies: array expected";
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    if (!$util.isString(message.resourcePolicies[i]))
                                        return "resourcePolicies: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionDisksAddResourcePoliciesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest} RegionDisksAddResourcePoliciesRequest
                         */
                        RegionDisksAddResourcePoliciesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest();
                            if (object.resourcePolicies) {
                                if (!Array.isArray(object.resourcePolicies))
                                    throw TypeError(".google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest.resourcePolicies: array expected");
                                message.resourcePolicies = [];
                                for (var i = 0; i < object.resourcePolicies.length; ++i)
                                    message.resourcePolicies[i] = String(object.resourcePolicies[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionDisksAddResourcePoliciesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest} message RegionDisksAddResourcePoliciesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionDisksAddResourcePoliciesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.resourcePolicies = [];
                            if (message.resourcePolicies && message.resourcePolicies.length) {
                                object.resourcePolicies = [];
                                for (var j = 0; j < message.resourcePolicies.length; ++j)
                                    object.resourcePolicies[j] = message.resourcePolicies[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionDisksAddResourcePoliciesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionDisksAddResourcePoliciesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionDisksAddResourcePoliciesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionDisksAddResourcePoliciesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionDisksAddResourcePoliciesRequest";
                        };
    
                        return RegionDisksAddResourcePoliciesRequest;
                    })();
    
                    v1.RegionDisksRemoveResourcePoliciesRequest = (function() {
    
                        /**
                         * Properties of a RegionDisksRemoveResourcePoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionDisksRemoveResourcePoliciesRequest
                         * @property {Array.<string>|null} [resourcePolicies] RegionDisksRemoveResourcePoliciesRequest resourcePolicies
                         */
    
                        /**
                         * Constructs a new RegionDisksRemoveResourcePoliciesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionDisksRemoveResourcePoliciesRequest.
                         * @implements IRegionDisksRemoveResourcePoliciesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionDisksRemoveResourcePoliciesRequest=} [properties] Properties to set
                         */
                        function RegionDisksRemoveResourcePoliciesRequest(properties) {
                            this.resourcePolicies = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionDisksRemoveResourcePoliciesRequest resourcePolicies.
                         * @member {Array.<string>} resourcePolicies
                         * @memberof google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest
                         * @instance
                         */
                        RegionDisksRemoveResourcePoliciesRequest.prototype.resourcePolicies = $util.emptyArray;
    
                        /**
                         * Creates a new RegionDisksRemoveResourcePoliciesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionDisksRemoveResourcePoliciesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest} RegionDisksRemoveResourcePoliciesRequest instance
                         */
                        RegionDisksRemoveResourcePoliciesRequest.create = function create(properties) {
                            return new RegionDisksRemoveResourcePoliciesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RegionDisksRemoveResourcePoliciesRequest message. Does not implicitly {@link google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionDisksRemoveResourcePoliciesRequest} message RegionDisksRemoveResourcePoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionDisksRemoveResourcePoliciesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourcePolicies != null && message.resourcePolicies.length)
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    writer.uint32(/* id 22220385, wireType 2 =*/177763082).string(message.resourcePolicies[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionDisksRemoveResourcePoliciesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionDisksRemoveResourcePoliciesRequest} message RegionDisksRemoveResourcePoliciesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionDisksRemoveResourcePoliciesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionDisksRemoveResourcePoliciesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest} RegionDisksRemoveResourcePoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionDisksRemoveResourcePoliciesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 22220385: {
                                        if (!(message.resourcePolicies && message.resourcePolicies.length))
                                            message.resourcePolicies = [];
                                        message.resourcePolicies.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionDisksRemoveResourcePoliciesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest} RegionDisksRemoveResourcePoliciesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionDisksRemoveResourcePoliciesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionDisksRemoveResourcePoliciesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionDisksRemoveResourcePoliciesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resourcePolicies != null && message.hasOwnProperty("resourcePolicies")) {
                                if (!Array.isArray(message.resourcePolicies))
                                    return "resourcePolicies: array expected";
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    if (!$util.isString(message.resourcePolicies[i]))
                                        return "resourcePolicies: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionDisksRemoveResourcePoliciesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest} RegionDisksRemoveResourcePoliciesRequest
                         */
                        RegionDisksRemoveResourcePoliciesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest();
                            if (object.resourcePolicies) {
                                if (!Array.isArray(object.resourcePolicies))
                                    throw TypeError(".google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest.resourcePolicies: array expected");
                                message.resourcePolicies = [];
                                for (var i = 0; i < object.resourcePolicies.length; ++i)
                                    message.resourcePolicies[i] = String(object.resourcePolicies[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionDisksRemoveResourcePoliciesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest
                         * @static
                         * @param {google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest} message RegionDisksRemoveResourcePoliciesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionDisksRemoveResourcePoliciesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.resourcePolicies = [];
                            if (message.resourcePolicies && message.resourcePolicies.length) {
                                object.resourcePolicies = [];
                                for (var j = 0; j < message.resourcePolicies.length; ++j)
                                    object.resourcePolicies[j] = message.resourcePolicies[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionDisksRemoveResourcePoliciesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionDisksRemoveResourcePoliciesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionDisksRemoveResourcePoliciesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionDisksRemoveResourcePoliciesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest";
                        };
    
                        return RegionDisksRemoveResourcePoliciesRequest;
                    })();
    
                    v1.RegionDisksResizeRequest = (function() {
    
                        /**
                         * Properties of a RegionDisksResizeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionDisksResizeRequest
                         * @property {number|Long|null} [sizeGb] RegionDisksResizeRequest sizeGb
                         */
    
                        /**
                         * Constructs a new RegionDisksResizeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionDisksResizeRequest.
                         * @implements IRegionDisksResizeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionDisksResizeRequest=} [properties] Properties to set
                         */
                        function RegionDisksResizeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionDisksResizeRequest sizeGb.
                         * @member {number|Long|null|undefined} sizeGb
                         * @memberof google.cloud.compute.v1.RegionDisksResizeRequest
                         * @instance
                         */
                        RegionDisksResizeRequest.prototype.sizeGb = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RegionDisksResizeRequest _sizeGb.
                         * @member {"sizeGb"|undefined} _sizeGb
                         * @memberof google.cloud.compute.v1.RegionDisksResizeRequest
                         * @instance
                         */
                        Object.defineProperty(RegionDisksResizeRequest.prototype, "_sizeGb", {
                            get: $util.oneOfGetter($oneOfFields = ["sizeGb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RegionDisksResizeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionDisksResizeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionDisksResizeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionDisksResizeRequest} RegionDisksResizeRequest instance
                         */
                        RegionDisksResizeRequest.create = function create(properties) {
                            return new RegionDisksResizeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RegionDisksResizeRequest message. Does not implicitly {@link google.cloud.compute.v1.RegionDisksResizeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionDisksResizeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionDisksResizeRequest} message RegionDisksResizeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionDisksResizeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.sizeGb != null && Object.hasOwnProperty.call(message, "sizeGb"))
                                writer.uint32(/* id 494929369, wireType 0 =*/3959434952).int64(message.sizeGb);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionDisksResizeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionDisksResizeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionDisksResizeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionDisksResizeRequest} message RegionDisksResizeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionDisksResizeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionDisksResizeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionDisksResizeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionDisksResizeRequest} RegionDisksResizeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionDisksResizeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionDisksResizeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 494929369: {
                                        message.sizeGb = reader.int64();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionDisksResizeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionDisksResizeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionDisksResizeRequest} RegionDisksResizeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionDisksResizeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionDisksResizeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionDisksResizeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionDisksResizeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.sizeGb != null && message.hasOwnProperty("sizeGb")) {
                                properties._sizeGb = 1;
                                if (!$util.isInteger(message.sizeGb) && !(message.sizeGb && $util.isInteger(message.sizeGb.low) && $util.isInteger(message.sizeGb.high)))
                                    return "sizeGb: integer|Long expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionDisksResizeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionDisksResizeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionDisksResizeRequest} RegionDisksResizeRequest
                         */
                        RegionDisksResizeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionDisksResizeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionDisksResizeRequest();
                            if (object.sizeGb != null)
                                if ($util.Long)
                                    (message.sizeGb = $util.Long.fromValue(object.sizeGb)).unsigned = false;
                                else if (typeof object.sizeGb === "string")
                                    message.sizeGb = parseInt(object.sizeGb, 10);
                                else if (typeof object.sizeGb === "number")
                                    message.sizeGb = object.sizeGb;
                                else if (typeof object.sizeGb === "object")
                                    message.sizeGb = new $util.LongBits(object.sizeGb.low >>> 0, object.sizeGb.high >>> 0).toNumber();
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionDisksResizeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionDisksResizeRequest
                         * @static
                         * @param {google.cloud.compute.v1.RegionDisksResizeRequest} message RegionDisksResizeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionDisksResizeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.sizeGb != null && message.hasOwnProperty("sizeGb")) {
                                if (typeof message.sizeGb === "number")
                                    object.sizeGb = options.longs === String ? String(message.sizeGb) : message.sizeGb;
                                else
                                    object.sizeGb = options.longs === String ? $util.Long.prototype.toString.call(message.sizeGb) : options.longs === Number ? new $util.LongBits(message.sizeGb.low >>> 0, message.sizeGb.high >>> 0).toNumber() : message.sizeGb;
                                if (options.oneofs)
                                    object._sizeGb = "sizeGb";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionDisksResizeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionDisksResizeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionDisksResizeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionDisksResizeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionDisksResizeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionDisksResizeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionDisksResizeRequest";
                        };
    
                        return RegionDisksResizeRequest;
                    })();
    
                    v1.RegionInstanceGroupList = (function() {
    
                        /**
                         * Properties of a RegionInstanceGroupList.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionInstanceGroupList
                         * @property {string|null} [id] RegionInstanceGroupList id
                         * @property {Array.<google.cloud.compute.v1.IInstanceGroup>|null} [items] RegionInstanceGroupList items
                         * @property {string|null} [kind] RegionInstanceGroupList kind
                         * @property {string|null} [nextPageToken] RegionInstanceGroupList nextPageToken
                         * @property {string|null} [selfLink] RegionInstanceGroupList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] RegionInstanceGroupList warning
                         */
    
                        /**
                         * Constructs a new RegionInstanceGroupList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstanceGroupList.
                         * @implements IRegionInstanceGroupList
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupList=} [properties] Properties to set
                         */
                        function RegionInstanceGroupList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionInstanceGroupList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @instance
                         */
                        RegionInstanceGroupList.prototype.id = null;
    
                        /**
                         * RegionInstanceGroupList items.
                         * @member {Array.<google.cloud.compute.v1.IInstanceGroup>} items
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @instance
                         */
                        RegionInstanceGroupList.prototype.items = $util.emptyArray;
    
                        /**
                         * RegionInstanceGroupList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @instance
                         */
                        RegionInstanceGroupList.prototype.kind = null;
    
                        /**
                         * RegionInstanceGroupList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @instance
                         */
                        RegionInstanceGroupList.prototype.nextPageToken = null;
    
                        /**
                         * RegionInstanceGroupList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @instance
                         */
                        RegionInstanceGroupList.prototype.selfLink = null;
    
                        /**
                         * RegionInstanceGroupList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @instance
                         */
                        RegionInstanceGroupList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RegionInstanceGroupList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionInstanceGroupList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionInstanceGroupList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionInstanceGroupList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionInstanceGroupList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RegionInstanceGroupList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupList} RegionInstanceGroupList instance
                         */
                        RegionInstanceGroupList.create = function create(properties) {
                            return new RegionInstanceGroupList(properties);
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupList message. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupList} message RegionInstanceGroupList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.InstanceGroup.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupList} message RegionInstanceGroupList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupList} RegionInstanceGroupList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionInstanceGroupList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.InstanceGroup.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupList} RegionInstanceGroupList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionInstanceGroupList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionInstanceGroupList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstanceGroup.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionInstanceGroupList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupList} RegionInstanceGroupList
                         */
                        RegionInstanceGroupList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionInstanceGroupList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionInstanceGroupList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.InstanceGroup.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionInstanceGroupList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @static
                         * @param {google.cloud.compute.v1.RegionInstanceGroupList} message RegionInstanceGroupList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionInstanceGroupList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.InstanceGroup.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionInstanceGroupList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionInstanceGroupList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionInstanceGroupList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionInstanceGroupList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionInstanceGroupList";
                        };
    
                        return RegionInstanceGroupList;
                    })();
    
                    v1.RegionInstanceGroupManagerDeleteInstanceConfigReq = (function() {
    
                        /**
                         * Properties of a RegionInstanceGroupManagerDeleteInstanceConfigReq.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionInstanceGroupManagerDeleteInstanceConfigReq
                         * @property {Array.<string>|null} [names] RegionInstanceGroupManagerDeleteInstanceConfigReq names
                         */
    
                        /**
                         * Constructs a new RegionInstanceGroupManagerDeleteInstanceConfigReq.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstanceGroupManagerDeleteInstanceConfigReq.
                         * @implements IRegionInstanceGroupManagerDeleteInstanceConfigReq
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagerDeleteInstanceConfigReq=} [properties] Properties to set
                         */
                        function RegionInstanceGroupManagerDeleteInstanceConfigReq(properties) {
                            this.names = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionInstanceGroupManagerDeleteInstanceConfigReq names.
                         * @member {Array.<string>} names
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq
                         * @instance
                         */
                        RegionInstanceGroupManagerDeleteInstanceConfigReq.prototype.names = $util.emptyArray;
    
                        /**
                         * Creates a new RegionInstanceGroupManagerDeleteInstanceConfigReq instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagerDeleteInstanceConfigReq=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq} RegionInstanceGroupManagerDeleteInstanceConfigReq instance
                         */
                        RegionInstanceGroupManagerDeleteInstanceConfigReq.create = function create(properties) {
                            return new RegionInstanceGroupManagerDeleteInstanceConfigReq(properties);
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagerDeleteInstanceConfigReq message. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagerDeleteInstanceConfigReq} message RegionInstanceGroupManagerDeleteInstanceConfigReq message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagerDeleteInstanceConfigReq.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.names != null && message.names.length)
                                for (var i = 0; i < message.names.length; ++i)
                                    writer.uint32(/* id 104585032, wireType 2 =*/836680258).string(message.names[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagerDeleteInstanceConfigReq message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagerDeleteInstanceConfigReq} message RegionInstanceGroupManagerDeleteInstanceConfigReq message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagerDeleteInstanceConfigReq.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagerDeleteInstanceConfigReq message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq} RegionInstanceGroupManagerDeleteInstanceConfigReq
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagerDeleteInstanceConfigReq.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 104585032: {
                                        if (!(message.names && message.names.length))
                                            message.names = [];
                                        message.names.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagerDeleteInstanceConfigReq message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq} RegionInstanceGroupManagerDeleteInstanceConfigReq
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagerDeleteInstanceConfigReq.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionInstanceGroupManagerDeleteInstanceConfigReq message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionInstanceGroupManagerDeleteInstanceConfigReq.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.names != null && message.hasOwnProperty("names")) {
                                if (!Array.isArray(message.names))
                                    return "names: array expected";
                                for (var i = 0; i < message.names.length; ++i)
                                    if (!$util.isString(message.names[i]))
                                        return "names: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionInstanceGroupManagerDeleteInstanceConfigReq message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq} RegionInstanceGroupManagerDeleteInstanceConfigReq
                         */
                        RegionInstanceGroupManagerDeleteInstanceConfigReq.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq();
                            if (object.names) {
                                if (!Array.isArray(object.names))
                                    throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq.names: array expected");
                                message.names = [];
                                for (var i = 0; i < object.names.length; ++i)
                                    message.names[i] = String(object.names[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionInstanceGroupManagerDeleteInstanceConfigReq message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq
                         * @static
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq} message RegionInstanceGroupManagerDeleteInstanceConfigReq
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionInstanceGroupManagerDeleteInstanceConfigReq.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.names = [];
                            if (message.names && message.names.length) {
                                object.names = [];
                                for (var j = 0; j < message.names.length; ++j)
                                    object.names[j] = message.names[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionInstanceGroupManagerDeleteInstanceConfigReq to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionInstanceGroupManagerDeleteInstanceConfigReq.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionInstanceGroupManagerDeleteInstanceConfigReq
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionInstanceGroupManagerDeleteInstanceConfigReq.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionInstanceGroupManagerDeleteInstanceConfigReq";
                        };
    
                        return RegionInstanceGroupManagerDeleteInstanceConfigReq;
                    })();
    
                    v1.RegionInstanceGroupManagerList = (function() {
    
                        /**
                         * Properties of a RegionInstanceGroupManagerList.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionInstanceGroupManagerList
                         * @property {string|null} [id] RegionInstanceGroupManagerList id
                         * @property {Array.<google.cloud.compute.v1.IInstanceGroupManager>|null} [items] RegionInstanceGroupManagerList items
                         * @property {string|null} [kind] RegionInstanceGroupManagerList kind
                         * @property {string|null} [nextPageToken] RegionInstanceGroupManagerList nextPageToken
                         * @property {string|null} [selfLink] RegionInstanceGroupManagerList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] RegionInstanceGroupManagerList warning
                         */
    
                        /**
                         * Constructs a new RegionInstanceGroupManagerList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstanceGroupManagerList.
                         * @implements IRegionInstanceGroupManagerList
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagerList=} [properties] Properties to set
                         */
                        function RegionInstanceGroupManagerList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionInstanceGroupManagerList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @instance
                         */
                        RegionInstanceGroupManagerList.prototype.id = null;
    
                        /**
                         * RegionInstanceGroupManagerList items.
                         * @member {Array.<google.cloud.compute.v1.IInstanceGroupManager>} items
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @instance
                         */
                        RegionInstanceGroupManagerList.prototype.items = $util.emptyArray;
    
                        /**
                         * RegionInstanceGroupManagerList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @instance
                         */
                        RegionInstanceGroupManagerList.prototype.kind = null;
    
                        /**
                         * RegionInstanceGroupManagerList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @instance
                         */
                        RegionInstanceGroupManagerList.prototype.nextPageToken = null;
    
                        /**
                         * RegionInstanceGroupManagerList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @instance
                         */
                        RegionInstanceGroupManagerList.prototype.selfLink = null;
    
                        /**
                         * RegionInstanceGroupManagerList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @instance
                         */
                        RegionInstanceGroupManagerList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RegionInstanceGroupManagerList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupManagerList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionInstanceGroupManagerList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupManagerList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionInstanceGroupManagerList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupManagerList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionInstanceGroupManagerList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupManagerList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionInstanceGroupManagerList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupManagerList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RegionInstanceGroupManagerList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagerList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagerList} RegionInstanceGroupManagerList instance
                         */
                        RegionInstanceGroupManagerList.create = function create(properties) {
                            return new RegionInstanceGroupManagerList(properties);
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagerList message. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagerList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagerList} message RegionInstanceGroupManagerList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagerList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.InstanceGroupManager.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagerList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagerList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagerList} message RegionInstanceGroupManagerList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagerList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagerList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagerList} RegionInstanceGroupManagerList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagerList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagerList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.InstanceGroupManager.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagerList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagerList} RegionInstanceGroupManagerList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagerList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionInstanceGroupManagerList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionInstanceGroupManagerList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstanceGroupManager.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionInstanceGroupManagerList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagerList} RegionInstanceGroupManagerList
                         */
                        RegionInstanceGroupManagerList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionInstanceGroupManagerList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagerList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagerList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagerList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.InstanceGroupManager.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagerList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionInstanceGroupManagerList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @static
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagerList} message RegionInstanceGroupManagerList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionInstanceGroupManagerList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.InstanceGroupManager.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionInstanceGroupManagerList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionInstanceGroupManagerList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionInstanceGroupManagerList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionInstanceGroupManagerList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionInstanceGroupManagerList";
                        };
    
                        return RegionInstanceGroupManagerList;
                    })();
    
                    v1.RegionInstanceGroupManagerPatchInstanceConfigReq = (function() {
    
                        /**
                         * Properties of a RegionInstanceGroupManagerPatchInstanceConfigReq.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionInstanceGroupManagerPatchInstanceConfigReq
                         * @property {Array.<google.cloud.compute.v1.IPerInstanceConfig>|null} [perInstanceConfigs] RegionInstanceGroupManagerPatchInstanceConfigReq perInstanceConfigs
                         */
    
                        /**
                         * Constructs a new RegionInstanceGroupManagerPatchInstanceConfigReq.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstanceGroupManagerPatchInstanceConfigReq.
                         * @implements IRegionInstanceGroupManagerPatchInstanceConfigReq
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagerPatchInstanceConfigReq=} [properties] Properties to set
                         */
                        function RegionInstanceGroupManagerPatchInstanceConfigReq(properties) {
                            this.perInstanceConfigs = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionInstanceGroupManagerPatchInstanceConfigReq perInstanceConfigs.
                         * @member {Array.<google.cloud.compute.v1.IPerInstanceConfig>} perInstanceConfigs
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq
                         * @instance
                         */
                        RegionInstanceGroupManagerPatchInstanceConfigReq.prototype.perInstanceConfigs = $util.emptyArray;
    
                        /**
                         * Creates a new RegionInstanceGroupManagerPatchInstanceConfigReq instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagerPatchInstanceConfigReq=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq} RegionInstanceGroupManagerPatchInstanceConfigReq instance
                         */
                        RegionInstanceGroupManagerPatchInstanceConfigReq.create = function create(properties) {
                            return new RegionInstanceGroupManagerPatchInstanceConfigReq(properties);
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagerPatchInstanceConfigReq message. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagerPatchInstanceConfigReq} message RegionInstanceGroupManagerPatchInstanceConfigReq message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagerPatchInstanceConfigReq.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.perInstanceConfigs != null && message.perInstanceConfigs.length)
                                for (var i = 0; i < message.perInstanceConfigs.length; ++i)
                                    $root.google.cloud.compute.v1.PerInstanceConfig.encode(message.perInstanceConfigs[i], writer.uint32(/* id 526265001, wireType 2 =*/4210120010).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagerPatchInstanceConfigReq message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagerPatchInstanceConfigReq} message RegionInstanceGroupManagerPatchInstanceConfigReq message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagerPatchInstanceConfigReq.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagerPatchInstanceConfigReq message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq} RegionInstanceGroupManagerPatchInstanceConfigReq
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagerPatchInstanceConfigReq.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 526265001: {
                                        if (!(message.perInstanceConfigs && message.perInstanceConfigs.length))
                                            message.perInstanceConfigs = [];
                                        message.perInstanceConfigs.push($root.google.cloud.compute.v1.PerInstanceConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagerPatchInstanceConfigReq message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq} RegionInstanceGroupManagerPatchInstanceConfigReq
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagerPatchInstanceConfigReq.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionInstanceGroupManagerPatchInstanceConfigReq message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionInstanceGroupManagerPatchInstanceConfigReq.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.perInstanceConfigs != null && message.hasOwnProperty("perInstanceConfigs")) {
                                if (!Array.isArray(message.perInstanceConfigs))
                                    return "perInstanceConfigs: array expected";
                                for (var i = 0; i < message.perInstanceConfigs.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PerInstanceConfig.verify(message.perInstanceConfigs[i]);
                                    if (error)
                                        return "perInstanceConfigs." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionInstanceGroupManagerPatchInstanceConfigReq message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq} RegionInstanceGroupManagerPatchInstanceConfigReq
                         */
                        RegionInstanceGroupManagerPatchInstanceConfigReq.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq();
                            if (object.perInstanceConfigs) {
                                if (!Array.isArray(object.perInstanceConfigs))
                                    throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq.perInstanceConfigs: array expected");
                                message.perInstanceConfigs = [];
                                for (var i = 0; i < object.perInstanceConfigs.length; ++i) {
                                    if (typeof object.perInstanceConfigs[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq.perInstanceConfigs: object expected");
                                    message.perInstanceConfigs[i] = $root.google.cloud.compute.v1.PerInstanceConfig.fromObject(object.perInstanceConfigs[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionInstanceGroupManagerPatchInstanceConfigReq message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq
                         * @static
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq} message RegionInstanceGroupManagerPatchInstanceConfigReq
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionInstanceGroupManagerPatchInstanceConfigReq.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.perInstanceConfigs = [];
                            if (message.perInstanceConfigs && message.perInstanceConfigs.length) {
                                object.perInstanceConfigs = [];
                                for (var j = 0; j < message.perInstanceConfigs.length; ++j)
                                    object.perInstanceConfigs[j] = $root.google.cloud.compute.v1.PerInstanceConfig.toObject(message.perInstanceConfigs[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionInstanceGroupManagerPatchInstanceConfigReq to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionInstanceGroupManagerPatchInstanceConfigReq.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionInstanceGroupManagerPatchInstanceConfigReq
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionInstanceGroupManagerPatchInstanceConfigReq.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionInstanceGroupManagerPatchInstanceConfigReq";
                        };
    
                        return RegionInstanceGroupManagerPatchInstanceConfigReq;
                    })();
    
                    v1.RegionInstanceGroupManagerUpdateInstanceConfigReq = (function() {
    
                        /**
                         * Properties of a RegionInstanceGroupManagerUpdateInstanceConfigReq.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionInstanceGroupManagerUpdateInstanceConfigReq
                         * @property {Array.<google.cloud.compute.v1.IPerInstanceConfig>|null} [perInstanceConfigs] RegionInstanceGroupManagerUpdateInstanceConfigReq perInstanceConfigs
                         */
    
                        /**
                         * Constructs a new RegionInstanceGroupManagerUpdateInstanceConfigReq.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstanceGroupManagerUpdateInstanceConfigReq.
                         * @implements IRegionInstanceGroupManagerUpdateInstanceConfigReq
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagerUpdateInstanceConfigReq=} [properties] Properties to set
                         */
                        function RegionInstanceGroupManagerUpdateInstanceConfigReq(properties) {
                            this.perInstanceConfigs = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionInstanceGroupManagerUpdateInstanceConfigReq perInstanceConfigs.
                         * @member {Array.<google.cloud.compute.v1.IPerInstanceConfig>} perInstanceConfigs
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq
                         * @instance
                         */
                        RegionInstanceGroupManagerUpdateInstanceConfigReq.prototype.perInstanceConfigs = $util.emptyArray;
    
                        /**
                         * Creates a new RegionInstanceGroupManagerUpdateInstanceConfigReq instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagerUpdateInstanceConfigReq=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq} RegionInstanceGroupManagerUpdateInstanceConfigReq instance
                         */
                        RegionInstanceGroupManagerUpdateInstanceConfigReq.create = function create(properties) {
                            return new RegionInstanceGroupManagerUpdateInstanceConfigReq(properties);
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagerUpdateInstanceConfigReq message. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagerUpdateInstanceConfigReq} message RegionInstanceGroupManagerUpdateInstanceConfigReq message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagerUpdateInstanceConfigReq.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.perInstanceConfigs != null && message.perInstanceConfigs.length)
                                for (var i = 0; i < message.perInstanceConfigs.length; ++i)
                                    $root.google.cloud.compute.v1.PerInstanceConfig.encode(message.perInstanceConfigs[i], writer.uint32(/* id 526265001, wireType 2 =*/4210120010).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagerUpdateInstanceConfigReq message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagerUpdateInstanceConfigReq} message RegionInstanceGroupManagerUpdateInstanceConfigReq message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagerUpdateInstanceConfigReq.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagerUpdateInstanceConfigReq message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq} RegionInstanceGroupManagerUpdateInstanceConfigReq
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagerUpdateInstanceConfigReq.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 526265001: {
                                        if (!(message.perInstanceConfigs && message.perInstanceConfigs.length))
                                            message.perInstanceConfigs = [];
                                        message.perInstanceConfigs.push($root.google.cloud.compute.v1.PerInstanceConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagerUpdateInstanceConfigReq message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq} RegionInstanceGroupManagerUpdateInstanceConfigReq
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagerUpdateInstanceConfigReq.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionInstanceGroupManagerUpdateInstanceConfigReq message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionInstanceGroupManagerUpdateInstanceConfigReq.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.perInstanceConfigs != null && message.hasOwnProperty("perInstanceConfigs")) {
                                if (!Array.isArray(message.perInstanceConfigs))
                                    return "perInstanceConfigs: array expected";
                                for (var i = 0; i < message.perInstanceConfigs.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PerInstanceConfig.verify(message.perInstanceConfigs[i]);
                                    if (error)
                                        return "perInstanceConfigs." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionInstanceGroupManagerUpdateInstanceConfigReq message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq} RegionInstanceGroupManagerUpdateInstanceConfigReq
                         */
                        RegionInstanceGroupManagerUpdateInstanceConfigReq.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq();
                            if (object.perInstanceConfigs) {
                                if (!Array.isArray(object.perInstanceConfigs))
                                    throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq.perInstanceConfigs: array expected");
                                message.perInstanceConfigs = [];
                                for (var i = 0; i < object.perInstanceConfigs.length; ++i) {
                                    if (typeof object.perInstanceConfigs[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq.perInstanceConfigs: object expected");
                                    message.perInstanceConfigs[i] = $root.google.cloud.compute.v1.PerInstanceConfig.fromObject(object.perInstanceConfigs[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionInstanceGroupManagerUpdateInstanceConfigReq message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq
                         * @static
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq} message RegionInstanceGroupManagerUpdateInstanceConfigReq
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionInstanceGroupManagerUpdateInstanceConfigReq.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.perInstanceConfigs = [];
                            if (message.perInstanceConfigs && message.perInstanceConfigs.length) {
                                object.perInstanceConfigs = [];
                                for (var j = 0; j < message.perInstanceConfigs.length; ++j)
                                    object.perInstanceConfigs[j] = $root.google.cloud.compute.v1.PerInstanceConfig.toObject(message.perInstanceConfigs[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionInstanceGroupManagerUpdateInstanceConfigReq to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionInstanceGroupManagerUpdateInstanceConfigReq.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionInstanceGroupManagerUpdateInstanceConfigReq
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionInstanceGroupManagerUpdateInstanceConfigReq.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq";
                        };
    
                        return RegionInstanceGroupManagerUpdateInstanceConfigReq;
                    })();
    
                    v1.RegionInstanceGroupManagersAbandonInstancesRequest = (function() {
    
                        /**
                         * Properties of a RegionInstanceGroupManagersAbandonInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionInstanceGroupManagersAbandonInstancesRequest
                         * @property {Array.<string>|null} [instances] RegionInstanceGroupManagersAbandonInstancesRequest instances
                         */
    
                        /**
                         * Constructs a new RegionInstanceGroupManagersAbandonInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstanceGroupManagersAbandonInstancesRequest.
                         * @implements IRegionInstanceGroupManagersAbandonInstancesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersAbandonInstancesRequest=} [properties] Properties to set
                         */
                        function RegionInstanceGroupManagersAbandonInstancesRequest(properties) {
                            this.instances = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionInstanceGroupManagersAbandonInstancesRequest instances.
                         * @member {Array.<string>} instances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest
                         * @instance
                         */
                        RegionInstanceGroupManagersAbandonInstancesRequest.prototype.instances = $util.emptyArray;
    
                        /**
                         * Creates a new RegionInstanceGroupManagersAbandonInstancesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersAbandonInstancesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest} RegionInstanceGroupManagersAbandonInstancesRequest instance
                         */
                        RegionInstanceGroupManagersAbandonInstancesRequest.create = function create(properties) {
                            return new RegionInstanceGroupManagersAbandonInstancesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagersAbandonInstancesRequest message. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersAbandonInstancesRequest} message RegionInstanceGroupManagersAbandonInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagersAbandonInstancesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instances != null && message.instances.length)
                                for (var i = 0; i < message.instances.length; ++i)
                                    writer.uint32(/* id 29097598, wireType 2 =*/232780786).string(message.instances[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagersAbandonInstancesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersAbandonInstancesRequest} message RegionInstanceGroupManagersAbandonInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagersAbandonInstancesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagersAbandonInstancesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest} RegionInstanceGroupManagersAbandonInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagersAbandonInstancesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 29097598: {
                                        if (!(message.instances && message.instances.length))
                                            message.instances = [];
                                        message.instances.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagersAbandonInstancesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest} RegionInstanceGroupManagersAbandonInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagersAbandonInstancesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionInstanceGroupManagersAbandonInstancesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionInstanceGroupManagersAbandonInstancesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instances != null && message.hasOwnProperty("instances")) {
                                if (!Array.isArray(message.instances))
                                    return "instances: array expected";
                                for (var i = 0; i < message.instances.length; ++i)
                                    if (!$util.isString(message.instances[i]))
                                        return "instances: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionInstanceGroupManagersAbandonInstancesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest} RegionInstanceGroupManagersAbandonInstancesRequest
                         */
                        RegionInstanceGroupManagersAbandonInstancesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest();
                            if (object.instances) {
                                if (!Array.isArray(object.instances))
                                    throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest.instances: array expected");
                                message.instances = [];
                                for (var i = 0; i < object.instances.length; ++i)
                                    message.instances[i] = String(object.instances[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionInstanceGroupManagersAbandonInstancesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest} message RegionInstanceGroupManagersAbandonInstancesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionInstanceGroupManagersAbandonInstancesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.instances = [];
                            if (message.instances && message.instances.length) {
                                object.instances = [];
                                for (var j = 0; j < message.instances.length; ++j)
                                    object.instances[j] = message.instances[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionInstanceGroupManagersAbandonInstancesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionInstanceGroupManagersAbandonInstancesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionInstanceGroupManagersAbandonInstancesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionInstanceGroupManagersAbandonInstancesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionInstanceGroupManagersAbandonInstancesRequest";
                        };
    
                        return RegionInstanceGroupManagersAbandonInstancesRequest;
                    })();
    
                    v1.RegionInstanceGroupManagersApplyUpdatesRequest = (function() {
    
                        /**
                         * Properties of a RegionInstanceGroupManagersApplyUpdatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionInstanceGroupManagersApplyUpdatesRequest
                         * @property {boolean|null} [allInstances] RegionInstanceGroupManagersApplyUpdatesRequest allInstances
                         * @property {Array.<string>|null} [instances] RegionInstanceGroupManagersApplyUpdatesRequest instances
                         * @property {string|null} [minimalAction] RegionInstanceGroupManagersApplyUpdatesRequest minimalAction
                         * @property {string|null} [mostDisruptiveAllowedAction] RegionInstanceGroupManagersApplyUpdatesRequest mostDisruptiveAllowedAction
                         */
    
                        /**
                         * Constructs a new RegionInstanceGroupManagersApplyUpdatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstanceGroupManagersApplyUpdatesRequest.
                         * @implements IRegionInstanceGroupManagersApplyUpdatesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersApplyUpdatesRequest=} [properties] Properties to set
                         */
                        function RegionInstanceGroupManagersApplyUpdatesRequest(properties) {
                            this.instances = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionInstanceGroupManagersApplyUpdatesRequest allInstances.
                         * @member {boolean|null|undefined} allInstances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest
                         * @instance
                         */
                        RegionInstanceGroupManagersApplyUpdatesRequest.prototype.allInstances = null;
    
                        /**
                         * RegionInstanceGroupManagersApplyUpdatesRequest instances.
                         * @member {Array.<string>} instances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest
                         * @instance
                         */
                        RegionInstanceGroupManagersApplyUpdatesRequest.prototype.instances = $util.emptyArray;
    
                        /**
                         * RegionInstanceGroupManagersApplyUpdatesRequest minimalAction.
                         * @member {string|null|undefined} minimalAction
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest
                         * @instance
                         */
                        RegionInstanceGroupManagersApplyUpdatesRequest.prototype.minimalAction = null;
    
                        /**
                         * RegionInstanceGroupManagersApplyUpdatesRequest mostDisruptiveAllowedAction.
                         * @member {string|null|undefined} mostDisruptiveAllowedAction
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest
                         * @instance
                         */
                        RegionInstanceGroupManagersApplyUpdatesRequest.prototype.mostDisruptiveAllowedAction = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RegionInstanceGroupManagersApplyUpdatesRequest _allInstances.
                         * @member {"allInstances"|undefined} _allInstances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupManagersApplyUpdatesRequest.prototype, "_allInstances", {
                            get: $util.oneOfGetter($oneOfFields = ["allInstances"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionInstanceGroupManagersApplyUpdatesRequest _minimalAction.
                         * @member {"minimalAction"|undefined} _minimalAction
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupManagersApplyUpdatesRequest.prototype, "_minimalAction", {
                            get: $util.oneOfGetter($oneOfFields = ["minimalAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionInstanceGroupManagersApplyUpdatesRequest _mostDisruptiveAllowedAction.
                         * @member {"mostDisruptiveAllowedAction"|undefined} _mostDisruptiveAllowedAction
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupManagersApplyUpdatesRequest.prototype, "_mostDisruptiveAllowedAction", {
                            get: $util.oneOfGetter($oneOfFields = ["mostDisruptiveAllowedAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RegionInstanceGroupManagersApplyUpdatesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersApplyUpdatesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest} RegionInstanceGroupManagersApplyUpdatesRequest instance
                         */
                        RegionInstanceGroupManagersApplyUpdatesRequest.create = function create(properties) {
                            return new RegionInstanceGroupManagersApplyUpdatesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagersApplyUpdatesRequest message. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersApplyUpdatesRequest} message RegionInstanceGroupManagersApplyUpdatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagersApplyUpdatesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instances != null && message.instances.length)
                                for (var i = 0; i < message.instances.length; ++i)
                                    writer.uint32(/* id 29097598, wireType 2 =*/232780786).string(message.instances[i]);
                            if (message.mostDisruptiveAllowedAction != null && Object.hasOwnProperty.call(message, "mostDisruptiveAllowedAction"))
                                writer.uint32(/* id 66103053, wireType 2 =*/528824426).string(message.mostDisruptiveAllowedAction);
                            if (message.minimalAction != null && Object.hasOwnProperty.call(message, "minimalAction"))
                                writer.uint32(/* id 270567060, wireType 2 =*/2164536482).string(message.minimalAction);
                            if (message.allInstances != null && Object.hasOwnProperty.call(message, "allInstances"))
                                writer.uint32(/* id 403676512, wireType 0 =*/3229412096).bool(message.allInstances);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagersApplyUpdatesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersApplyUpdatesRequest} message RegionInstanceGroupManagersApplyUpdatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagersApplyUpdatesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagersApplyUpdatesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest} RegionInstanceGroupManagersApplyUpdatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagersApplyUpdatesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 403676512: {
                                        message.allInstances = reader.bool();
                                        break;
                                    }
                                case 29097598: {
                                        if (!(message.instances && message.instances.length))
                                            message.instances = [];
                                        message.instances.push(reader.string());
                                        break;
                                    }
                                case 270567060: {
                                        message.minimalAction = reader.string();
                                        break;
                                    }
                                case 66103053: {
                                        message.mostDisruptiveAllowedAction = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagersApplyUpdatesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest} RegionInstanceGroupManagersApplyUpdatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagersApplyUpdatesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionInstanceGroupManagersApplyUpdatesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionInstanceGroupManagersApplyUpdatesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.allInstances != null && message.hasOwnProperty("allInstances")) {
                                properties._allInstances = 1;
                                if (typeof message.allInstances !== "boolean")
                                    return "allInstances: boolean expected";
                            }
                            if (message.instances != null && message.hasOwnProperty("instances")) {
                                if (!Array.isArray(message.instances))
                                    return "instances: array expected";
                                for (var i = 0; i < message.instances.length; ++i)
                                    if (!$util.isString(message.instances[i]))
                                        return "instances: string[] expected";
                            }
                            if (message.minimalAction != null && message.hasOwnProperty("minimalAction")) {
                                properties._minimalAction = 1;
                                if (!$util.isString(message.minimalAction))
                                    return "minimalAction: string expected";
                            }
                            if (message.mostDisruptiveAllowedAction != null && message.hasOwnProperty("mostDisruptiveAllowedAction")) {
                                properties._mostDisruptiveAllowedAction = 1;
                                if (!$util.isString(message.mostDisruptiveAllowedAction))
                                    return "mostDisruptiveAllowedAction: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionInstanceGroupManagersApplyUpdatesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest} RegionInstanceGroupManagersApplyUpdatesRequest
                         */
                        RegionInstanceGroupManagersApplyUpdatesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest();
                            if (object.allInstances != null)
                                message.allInstances = Boolean(object.allInstances);
                            if (object.instances) {
                                if (!Array.isArray(object.instances))
                                    throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest.instances: array expected");
                                message.instances = [];
                                for (var i = 0; i < object.instances.length; ++i)
                                    message.instances[i] = String(object.instances[i]);
                            }
                            if (object.minimalAction != null)
                                message.minimalAction = String(object.minimalAction);
                            if (object.mostDisruptiveAllowedAction != null)
                                message.mostDisruptiveAllowedAction = String(object.mostDisruptiveAllowedAction);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionInstanceGroupManagersApplyUpdatesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest} message RegionInstanceGroupManagersApplyUpdatesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionInstanceGroupManagersApplyUpdatesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.instances = [];
                            if (message.instances && message.instances.length) {
                                object.instances = [];
                                for (var j = 0; j < message.instances.length; ++j)
                                    object.instances[j] = message.instances[j];
                            }
                            if (message.mostDisruptiveAllowedAction != null && message.hasOwnProperty("mostDisruptiveAllowedAction")) {
                                object.mostDisruptiveAllowedAction = message.mostDisruptiveAllowedAction;
                                if (options.oneofs)
                                    object._mostDisruptiveAllowedAction = "mostDisruptiveAllowedAction";
                            }
                            if (message.minimalAction != null && message.hasOwnProperty("minimalAction")) {
                                object.minimalAction = message.minimalAction;
                                if (options.oneofs)
                                    object._minimalAction = "minimalAction";
                            }
                            if (message.allInstances != null && message.hasOwnProperty("allInstances")) {
                                object.allInstances = message.allInstances;
                                if (options.oneofs)
                                    object._allInstances = "allInstances";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionInstanceGroupManagersApplyUpdatesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionInstanceGroupManagersApplyUpdatesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionInstanceGroupManagersApplyUpdatesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionInstanceGroupManagersApplyUpdatesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest";
                        };
    
                        /**
                         * MinimalAction enum.
                         * @name google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest.MinimalAction
                         * @enum {number}
                         * @property {number} UNDEFINED_MINIMAL_ACTION=0 UNDEFINED_MINIMAL_ACTION value
                         */
                        RegionInstanceGroupManagersApplyUpdatesRequest.MinimalAction = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_MINIMAL_ACTION"] = 0;
                            return values;
                        })();
    
                        /**
                         * MostDisruptiveAllowedAction enum.
                         * @name google.cloud.compute.v1.RegionInstanceGroupManagersApplyUpdatesRequest.MostDisruptiveAllowedAction
                         * @enum {number}
                         * @property {number} UNDEFINED_MOST_DISRUPTIVE_ALLOWED_ACTION=0 UNDEFINED_MOST_DISRUPTIVE_ALLOWED_ACTION value
                         */
                        RegionInstanceGroupManagersApplyUpdatesRequest.MostDisruptiveAllowedAction = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_MOST_DISRUPTIVE_ALLOWED_ACTION"] = 0;
                            return values;
                        })();
    
                        return RegionInstanceGroupManagersApplyUpdatesRequest;
                    })();
    
                    v1.RegionInstanceGroupManagersCreateInstancesRequest = (function() {
    
                        /**
                         * Properties of a RegionInstanceGroupManagersCreateInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionInstanceGroupManagersCreateInstancesRequest
                         * @property {Array.<google.cloud.compute.v1.IPerInstanceConfig>|null} [instances] RegionInstanceGroupManagersCreateInstancesRequest instances
                         */
    
                        /**
                         * Constructs a new RegionInstanceGroupManagersCreateInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstanceGroupManagersCreateInstancesRequest.
                         * @implements IRegionInstanceGroupManagersCreateInstancesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersCreateInstancesRequest=} [properties] Properties to set
                         */
                        function RegionInstanceGroupManagersCreateInstancesRequest(properties) {
                            this.instances = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionInstanceGroupManagersCreateInstancesRequest instances.
                         * @member {Array.<google.cloud.compute.v1.IPerInstanceConfig>} instances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest
                         * @instance
                         */
                        RegionInstanceGroupManagersCreateInstancesRequest.prototype.instances = $util.emptyArray;
    
                        /**
                         * Creates a new RegionInstanceGroupManagersCreateInstancesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersCreateInstancesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest} RegionInstanceGroupManagersCreateInstancesRequest instance
                         */
                        RegionInstanceGroupManagersCreateInstancesRequest.create = function create(properties) {
                            return new RegionInstanceGroupManagersCreateInstancesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagersCreateInstancesRequest message. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersCreateInstancesRequest} message RegionInstanceGroupManagersCreateInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagersCreateInstancesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instances != null && message.instances.length)
                                for (var i = 0; i < message.instances.length; ++i)
                                    $root.google.cloud.compute.v1.PerInstanceConfig.encode(message.instances[i], writer.uint32(/* id 29097598, wireType 2 =*/232780786).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagersCreateInstancesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersCreateInstancesRequest} message RegionInstanceGroupManagersCreateInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagersCreateInstancesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagersCreateInstancesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest} RegionInstanceGroupManagersCreateInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagersCreateInstancesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 29097598: {
                                        if (!(message.instances && message.instances.length))
                                            message.instances = [];
                                        message.instances.push($root.google.cloud.compute.v1.PerInstanceConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagersCreateInstancesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest} RegionInstanceGroupManagersCreateInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagersCreateInstancesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionInstanceGroupManagersCreateInstancesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionInstanceGroupManagersCreateInstancesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instances != null && message.hasOwnProperty("instances")) {
                                if (!Array.isArray(message.instances))
                                    return "instances: array expected";
                                for (var i = 0; i < message.instances.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PerInstanceConfig.verify(message.instances[i]);
                                    if (error)
                                        return "instances." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionInstanceGroupManagersCreateInstancesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest} RegionInstanceGroupManagersCreateInstancesRequest
                         */
                        RegionInstanceGroupManagersCreateInstancesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest();
                            if (object.instances) {
                                if (!Array.isArray(object.instances))
                                    throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest.instances: array expected");
                                message.instances = [];
                                for (var i = 0; i < object.instances.length; ++i) {
                                    if (typeof object.instances[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest.instances: object expected");
                                    message.instances[i] = $root.google.cloud.compute.v1.PerInstanceConfig.fromObject(object.instances[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionInstanceGroupManagersCreateInstancesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest} message RegionInstanceGroupManagersCreateInstancesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionInstanceGroupManagersCreateInstancesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.instances = [];
                            if (message.instances && message.instances.length) {
                                object.instances = [];
                                for (var j = 0; j < message.instances.length; ++j)
                                    object.instances[j] = $root.google.cloud.compute.v1.PerInstanceConfig.toObject(message.instances[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionInstanceGroupManagersCreateInstancesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionInstanceGroupManagersCreateInstancesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionInstanceGroupManagersCreateInstancesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionInstanceGroupManagersCreateInstancesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionInstanceGroupManagersCreateInstancesRequest";
                        };
    
                        return RegionInstanceGroupManagersCreateInstancesRequest;
                    })();
    
                    v1.RegionInstanceGroupManagersDeleteInstancesRequest = (function() {
    
                        /**
                         * Properties of a RegionInstanceGroupManagersDeleteInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionInstanceGroupManagersDeleteInstancesRequest
                         * @property {Array.<string>|null} [instances] RegionInstanceGroupManagersDeleteInstancesRequest instances
                         * @property {boolean|null} [skipInstancesOnValidationError] RegionInstanceGroupManagersDeleteInstancesRequest skipInstancesOnValidationError
                         */
    
                        /**
                         * Constructs a new RegionInstanceGroupManagersDeleteInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstanceGroupManagersDeleteInstancesRequest.
                         * @implements IRegionInstanceGroupManagersDeleteInstancesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersDeleteInstancesRequest=} [properties] Properties to set
                         */
                        function RegionInstanceGroupManagersDeleteInstancesRequest(properties) {
                            this.instances = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionInstanceGroupManagersDeleteInstancesRequest instances.
                         * @member {Array.<string>} instances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest
                         * @instance
                         */
                        RegionInstanceGroupManagersDeleteInstancesRequest.prototype.instances = $util.emptyArray;
    
                        /**
                         * RegionInstanceGroupManagersDeleteInstancesRequest skipInstancesOnValidationError.
                         * @member {boolean|null|undefined} skipInstancesOnValidationError
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest
                         * @instance
                         */
                        RegionInstanceGroupManagersDeleteInstancesRequest.prototype.skipInstancesOnValidationError = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RegionInstanceGroupManagersDeleteInstancesRequest _skipInstancesOnValidationError.
                         * @member {"skipInstancesOnValidationError"|undefined} _skipInstancesOnValidationError
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupManagersDeleteInstancesRequest.prototype, "_skipInstancesOnValidationError", {
                            get: $util.oneOfGetter($oneOfFields = ["skipInstancesOnValidationError"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RegionInstanceGroupManagersDeleteInstancesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersDeleteInstancesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest} RegionInstanceGroupManagersDeleteInstancesRequest instance
                         */
                        RegionInstanceGroupManagersDeleteInstancesRequest.create = function create(properties) {
                            return new RegionInstanceGroupManagersDeleteInstancesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagersDeleteInstancesRequest message. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersDeleteInstancesRequest} message RegionInstanceGroupManagersDeleteInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagersDeleteInstancesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instances != null && message.instances.length)
                                for (var i = 0; i < message.instances.length; ++i)
                                    writer.uint32(/* id 29097598, wireType 2 =*/232780786).string(message.instances[i]);
                            if (message.skipInstancesOnValidationError != null && Object.hasOwnProperty.call(message, "skipInstancesOnValidationError"))
                                writer.uint32(/* id 40631073, wireType 0 =*/325048584).bool(message.skipInstancesOnValidationError);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagersDeleteInstancesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersDeleteInstancesRequest} message RegionInstanceGroupManagersDeleteInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagersDeleteInstancesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagersDeleteInstancesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest} RegionInstanceGroupManagersDeleteInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagersDeleteInstancesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 29097598: {
                                        if (!(message.instances && message.instances.length))
                                            message.instances = [];
                                        message.instances.push(reader.string());
                                        break;
                                    }
                                case 40631073: {
                                        message.skipInstancesOnValidationError = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagersDeleteInstancesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest} RegionInstanceGroupManagersDeleteInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagersDeleteInstancesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionInstanceGroupManagersDeleteInstancesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionInstanceGroupManagersDeleteInstancesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instances != null && message.hasOwnProperty("instances")) {
                                if (!Array.isArray(message.instances))
                                    return "instances: array expected";
                                for (var i = 0; i < message.instances.length; ++i)
                                    if (!$util.isString(message.instances[i]))
                                        return "instances: string[] expected";
                            }
                            if (message.skipInstancesOnValidationError != null && message.hasOwnProperty("skipInstancesOnValidationError")) {
                                properties._skipInstancesOnValidationError = 1;
                                if (typeof message.skipInstancesOnValidationError !== "boolean")
                                    return "skipInstancesOnValidationError: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionInstanceGroupManagersDeleteInstancesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest} RegionInstanceGroupManagersDeleteInstancesRequest
                         */
                        RegionInstanceGroupManagersDeleteInstancesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest();
                            if (object.instances) {
                                if (!Array.isArray(object.instances))
                                    throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest.instances: array expected");
                                message.instances = [];
                                for (var i = 0; i < object.instances.length; ++i)
                                    message.instances[i] = String(object.instances[i]);
                            }
                            if (object.skipInstancesOnValidationError != null)
                                message.skipInstancesOnValidationError = Boolean(object.skipInstancesOnValidationError);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionInstanceGroupManagersDeleteInstancesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest} message RegionInstanceGroupManagersDeleteInstancesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionInstanceGroupManagersDeleteInstancesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.instances = [];
                            if (message.instances && message.instances.length) {
                                object.instances = [];
                                for (var j = 0; j < message.instances.length; ++j)
                                    object.instances[j] = message.instances[j];
                            }
                            if (message.skipInstancesOnValidationError != null && message.hasOwnProperty("skipInstancesOnValidationError")) {
                                object.skipInstancesOnValidationError = message.skipInstancesOnValidationError;
                                if (options.oneofs)
                                    object._skipInstancesOnValidationError = "skipInstancesOnValidationError";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionInstanceGroupManagersDeleteInstancesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionInstanceGroupManagersDeleteInstancesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionInstanceGroupManagersDeleteInstancesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionInstanceGroupManagersDeleteInstancesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionInstanceGroupManagersDeleteInstancesRequest";
                        };
    
                        return RegionInstanceGroupManagersDeleteInstancesRequest;
                    })();
    
                    v1.RegionInstanceGroupManagersListErrorsResponse = (function() {
    
                        /**
                         * Properties of a RegionInstanceGroupManagersListErrorsResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionInstanceGroupManagersListErrorsResponse
                         * @property {Array.<google.cloud.compute.v1.IInstanceManagedByIgmError>|null} [items] RegionInstanceGroupManagersListErrorsResponse items
                         * @property {string|null} [nextPageToken] RegionInstanceGroupManagersListErrorsResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new RegionInstanceGroupManagersListErrorsResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstanceGroupManagersListErrorsResponse.
                         * @implements IRegionInstanceGroupManagersListErrorsResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersListErrorsResponse=} [properties] Properties to set
                         */
                        function RegionInstanceGroupManagersListErrorsResponse(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionInstanceGroupManagersListErrorsResponse items.
                         * @member {Array.<google.cloud.compute.v1.IInstanceManagedByIgmError>} items
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse
                         * @instance
                         */
                        RegionInstanceGroupManagersListErrorsResponse.prototype.items = $util.emptyArray;
    
                        /**
                         * RegionInstanceGroupManagersListErrorsResponse nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse
                         * @instance
                         */
                        RegionInstanceGroupManagersListErrorsResponse.prototype.nextPageToken = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RegionInstanceGroupManagersListErrorsResponse _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupManagersListErrorsResponse.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RegionInstanceGroupManagersListErrorsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersListErrorsResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse} RegionInstanceGroupManagersListErrorsResponse instance
                         */
                        RegionInstanceGroupManagersListErrorsResponse.create = function create(properties) {
                            return new RegionInstanceGroupManagersListErrorsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagersListErrorsResponse message. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersListErrorsResponse} message RegionInstanceGroupManagersListErrorsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagersListErrorsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.InstanceManagedByIgmError.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagersListErrorsResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersListErrorsResponse} message RegionInstanceGroupManagersListErrorsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagersListErrorsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagersListErrorsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse} RegionInstanceGroupManagersListErrorsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagersListErrorsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.InstanceManagedByIgmError.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagersListErrorsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse} RegionInstanceGroupManagersListErrorsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagersListErrorsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionInstanceGroupManagersListErrorsResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionInstanceGroupManagersListErrorsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstanceManagedByIgmError.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionInstanceGroupManagersListErrorsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse} RegionInstanceGroupManagersListErrorsResponse
                         */
                        RegionInstanceGroupManagersListErrorsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse();
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.InstanceManagedByIgmError.fromObject(object.items[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionInstanceGroupManagersListErrorsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse
                         * @static
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse} message RegionInstanceGroupManagersListErrorsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionInstanceGroupManagersListErrorsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.InstanceManagedByIgmError.toObject(message.items[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionInstanceGroupManagersListErrorsResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionInstanceGroupManagersListErrorsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionInstanceGroupManagersListErrorsResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionInstanceGroupManagersListErrorsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse";
                        };
    
                        return RegionInstanceGroupManagersListErrorsResponse;
                    })();
    
                    v1.RegionInstanceGroupManagersListInstanceConfigsResp = (function() {
    
                        /**
                         * Properties of a RegionInstanceGroupManagersListInstanceConfigsResp.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionInstanceGroupManagersListInstanceConfigsResp
                         * @property {Array.<google.cloud.compute.v1.IPerInstanceConfig>|null} [items] RegionInstanceGroupManagersListInstanceConfigsResp items
                         * @property {string|null} [nextPageToken] RegionInstanceGroupManagersListInstanceConfigsResp nextPageToken
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] RegionInstanceGroupManagersListInstanceConfigsResp warning
                         */
    
                        /**
                         * Constructs a new RegionInstanceGroupManagersListInstanceConfigsResp.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstanceGroupManagersListInstanceConfigsResp.
                         * @implements IRegionInstanceGroupManagersListInstanceConfigsResp
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersListInstanceConfigsResp=} [properties] Properties to set
                         */
                        function RegionInstanceGroupManagersListInstanceConfigsResp(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionInstanceGroupManagersListInstanceConfigsResp items.
                         * @member {Array.<google.cloud.compute.v1.IPerInstanceConfig>} items
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp
                         * @instance
                         */
                        RegionInstanceGroupManagersListInstanceConfigsResp.prototype.items = $util.emptyArray;
    
                        /**
                         * RegionInstanceGroupManagersListInstanceConfigsResp nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp
                         * @instance
                         */
                        RegionInstanceGroupManagersListInstanceConfigsResp.prototype.nextPageToken = null;
    
                        /**
                         * RegionInstanceGroupManagersListInstanceConfigsResp warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp
                         * @instance
                         */
                        RegionInstanceGroupManagersListInstanceConfigsResp.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RegionInstanceGroupManagersListInstanceConfigsResp _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupManagersListInstanceConfigsResp.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionInstanceGroupManagersListInstanceConfigsResp _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupManagersListInstanceConfigsResp.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RegionInstanceGroupManagersListInstanceConfigsResp instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersListInstanceConfigsResp=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp} RegionInstanceGroupManagersListInstanceConfigsResp instance
                         */
                        RegionInstanceGroupManagersListInstanceConfigsResp.create = function create(properties) {
                            return new RegionInstanceGroupManagersListInstanceConfigsResp(properties);
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagersListInstanceConfigsResp message. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersListInstanceConfigsResp} message RegionInstanceGroupManagersListInstanceConfigsResp message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagersListInstanceConfigsResp.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.PerInstanceConfig.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagersListInstanceConfigsResp message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersListInstanceConfigsResp} message RegionInstanceGroupManagersListInstanceConfigsResp message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagersListInstanceConfigsResp.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagersListInstanceConfigsResp message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp} RegionInstanceGroupManagersListInstanceConfigsResp
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagersListInstanceConfigsResp.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.PerInstanceConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagersListInstanceConfigsResp message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp} RegionInstanceGroupManagersListInstanceConfigsResp
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagersListInstanceConfigsResp.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionInstanceGroupManagersListInstanceConfigsResp message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionInstanceGroupManagersListInstanceConfigsResp.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PerInstanceConfig.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionInstanceGroupManagersListInstanceConfigsResp message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp} RegionInstanceGroupManagersListInstanceConfigsResp
                         */
                        RegionInstanceGroupManagersListInstanceConfigsResp.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp();
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.PerInstanceConfig.fromObject(object.items[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionInstanceGroupManagersListInstanceConfigsResp message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp
                         * @static
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp} message RegionInstanceGroupManagersListInstanceConfigsResp
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionInstanceGroupManagersListInstanceConfigsResp.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.PerInstanceConfig.toObject(message.items[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionInstanceGroupManagersListInstanceConfigsResp to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionInstanceGroupManagersListInstanceConfigsResp.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionInstanceGroupManagersListInstanceConfigsResp
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionInstanceGroupManagersListInstanceConfigsResp.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp";
                        };
    
                        return RegionInstanceGroupManagersListInstanceConfigsResp;
                    })();
    
                    v1.RegionInstanceGroupManagersListInstancesResponse = (function() {
    
                        /**
                         * Properties of a RegionInstanceGroupManagersListInstancesResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionInstanceGroupManagersListInstancesResponse
                         * @property {Array.<google.cloud.compute.v1.IManagedInstance>|null} [managedInstances] RegionInstanceGroupManagersListInstancesResponse managedInstances
                         * @property {string|null} [nextPageToken] RegionInstanceGroupManagersListInstancesResponse nextPageToken
                         */
    
                        /**
                         * Constructs a new RegionInstanceGroupManagersListInstancesResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstanceGroupManagersListInstancesResponse.
                         * @implements IRegionInstanceGroupManagersListInstancesResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersListInstancesResponse=} [properties] Properties to set
                         */
                        function RegionInstanceGroupManagersListInstancesResponse(properties) {
                            this.managedInstances = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionInstanceGroupManagersListInstancesResponse managedInstances.
                         * @member {Array.<google.cloud.compute.v1.IManagedInstance>} managedInstances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse
                         * @instance
                         */
                        RegionInstanceGroupManagersListInstancesResponse.prototype.managedInstances = $util.emptyArray;
    
                        /**
                         * RegionInstanceGroupManagersListInstancesResponse nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse
                         * @instance
                         */
                        RegionInstanceGroupManagersListInstancesResponse.prototype.nextPageToken = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RegionInstanceGroupManagersListInstancesResponse _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupManagersListInstancesResponse.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RegionInstanceGroupManagersListInstancesResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersListInstancesResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse} RegionInstanceGroupManagersListInstancesResponse instance
                         */
                        RegionInstanceGroupManagersListInstancesResponse.create = function create(properties) {
                            return new RegionInstanceGroupManagersListInstancesResponse(properties);
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagersListInstancesResponse message. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersListInstancesResponse} message RegionInstanceGroupManagersListInstancesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagersListInstancesResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.managedInstances != null && message.managedInstances.length)
                                for (var i = 0; i < message.managedInstances.length; ++i)
                                    $root.google.cloud.compute.v1.ManagedInstance.encode(message.managedInstances[i], writer.uint32(/* id 336219614, wireType 2 =*/2689756914).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagersListInstancesResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersListInstancesResponse} message RegionInstanceGroupManagersListInstancesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagersListInstancesResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagersListInstancesResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse} RegionInstanceGroupManagersListInstancesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagersListInstancesResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336219614: {
                                        if (!(message.managedInstances && message.managedInstances.length))
                                            message.managedInstances = [];
                                        message.managedInstances.push($root.google.cloud.compute.v1.ManagedInstance.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagersListInstancesResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse} RegionInstanceGroupManagersListInstancesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagersListInstancesResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionInstanceGroupManagersListInstancesResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionInstanceGroupManagersListInstancesResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.managedInstances != null && message.hasOwnProperty("managedInstances")) {
                                if (!Array.isArray(message.managedInstances))
                                    return "managedInstances: array expected";
                                for (var i = 0; i < message.managedInstances.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ManagedInstance.verify(message.managedInstances[i]);
                                    if (error)
                                        return "managedInstances." + error;
                                }
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionInstanceGroupManagersListInstancesResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse} RegionInstanceGroupManagersListInstancesResponse
                         */
                        RegionInstanceGroupManagersListInstancesResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse();
                            if (object.managedInstances) {
                                if (!Array.isArray(object.managedInstances))
                                    throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse.managedInstances: array expected");
                                message.managedInstances = [];
                                for (var i = 0; i < object.managedInstances.length; ++i) {
                                    if (typeof object.managedInstances[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse.managedInstances: object expected");
                                    message.managedInstances[i] = $root.google.cloud.compute.v1.ManagedInstance.fromObject(object.managedInstances[i]);
                                }
                            }
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionInstanceGroupManagersListInstancesResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse
                         * @static
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse} message RegionInstanceGroupManagersListInstancesResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionInstanceGroupManagersListInstancesResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.managedInstances = [];
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.managedInstances && message.managedInstances.length) {
                                object.managedInstances = [];
                                for (var j = 0; j < message.managedInstances.length; ++j)
                                    object.managedInstances[j] = $root.google.cloud.compute.v1.ManagedInstance.toObject(message.managedInstances[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionInstanceGroupManagersListInstancesResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionInstanceGroupManagersListInstancesResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionInstanceGroupManagersListInstancesResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionInstanceGroupManagersListInstancesResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse";
                        };
    
                        return RegionInstanceGroupManagersListInstancesResponse;
                    })();
    
                    v1.RegionInstanceGroupManagersRecreateRequest = (function() {
    
                        /**
                         * Properties of a RegionInstanceGroupManagersRecreateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionInstanceGroupManagersRecreateRequest
                         * @property {Array.<string>|null} [instances] RegionInstanceGroupManagersRecreateRequest instances
                         */
    
                        /**
                         * Constructs a new RegionInstanceGroupManagersRecreateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstanceGroupManagersRecreateRequest.
                         * @implements IRegionInstanceGroupManagersRecreateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersRecreateRequest=} [properties] Properties to set
                         */
                        function RegionInstanceGroupManagersRecreateRequest(properties) {
                            this.instances = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionInstanceGroupManagersRecreateRequest instances.
                         * @member {Array.<string>} instances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest
                         * @instance
                         */
                        RegionInstanceGroupManagersRecreateRequest.prototype.instances = $util.emptyArray;
    
                        /**
                         * Creates a new RegionInstanceGroupManagersRecreateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersRecreateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest} RegionInstanceGroupManagersRecreateRequest instance
                         */
                        RegionInstanceGroupManagersRecreateRequest.create = function create(properties) {
                            return new RegionInstanceGroupManagersRecreateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagersRecreateRequest message. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersRecreateRequest} message RegionInstanceGroupManagersRecreateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagersRecreateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instances != null && message.instances.length)
                                for (var i = 0; i < message.instances.length; ++i)
                                    writer.uint32(/* id 29097598, wireType 2 =*/232780786).string(message.instances[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagersRecreateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersRecreateRequest} message RegionInstanceGroupManagersRecreateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagersRecreateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagersRecreateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest} RegionInstanceGroupManagersRecreateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagersRecreateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 29097598: {
                                        if (!(message.instances && message.instances.length))
                                            message.instances = [];
                                        message.instances.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagersRecreateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest} RegionInstanceGroupManagersRecreateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagersRecreateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionInstanceGroupManagersRecreateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionInstanceGroupManagersRecreateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instances != null && message.hasOwnProperty("instances")) {
                                if (!Array.isArray(message.instances))
                                    return "instances: array expected";
                                for (var i = 0; i < message.instances.length; ++i)
                                    if (!$util.isString(message.instances[i]))
                                        return "instances: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionInstanceGroupManagersRecreateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest} RegionInstanceGroupManagersRecreateRequest
                         */
                        RegionInstanceGroupManagersRecreateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest();
                            if (object.instances) {
                                if (!Array.isArray(object.instances))
                                    throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest.instances: array expected");
                                message.instances = [];
                                for (var i = 0; i < object.instances.length; ++i)
                                    message.instances[i] = String(object.instances[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionInstanceGroupManagersRecreateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest
                         * @static
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest} message RegionInstanceGroupManagersRecreateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionInstanceGroupManagersRecreateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.instances = [];
                            if (message.instances && message.instances.length) {
                                object.instances = [];
                                for (var j = 0; j < message.instances.length; ++j)
                                    object.instances[j] = message.instances[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionInstanceGroupManagersRecreateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionInstanceGroupManagersRecreateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionInstanceGroupManagersRecreateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionInstanceGroupManagersRecreateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionInstanceGroupManagersRecreateRequest";
                        };
    
                        return RegionInstanceGroupManagersRecreateRequest;
                    })();
    
                    v1.RegionInstanceGroupManagersSetTargetPoolsRequest = (function() {
    
                        /**
                         * Properties of a RegionInstanceGroupManagersSetTargetPoolsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionInstanceGroupManagersSetTargetPoolsRequest
                         * @property {string|null} [fingerprint] RegionInstanceGroupManagersSetTargetPoolsRequest fingerprint
                         * @property {Array.<string>|null} [targetPools] RegionInstanceGroupManagersSetTargetPoolsRequest targetPools
                         */
    
                        /**
                         * Constructs a new RegionInstanceGroupManagersSetTargetPoolsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstanceGroupManagersSetTargetPoolsRequest.
                         * @implements IRegionInstanceGroupManagersSetTargetPoolsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersSetTargetPoolsRequest=} [properties] Properties to set
                         */
                        function RegionInstanceGroupManagersSetTargetPoolsRequest(properties) {
                            this.targetPools = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionInstanceGroupManagersSetTargetPoolsRequest fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest
                         * @instance
                         */
                        RegionInstanceGroupManagersSetTargetPoolsRequest.prototype.fingerprint = null;
    
                        /**
                         * RegionInstanceGroupManagersSetTargetPoolsRequest targetPools.
                         * @member {Array.<string>} targetPools
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest
                         * @instance
                         */
                        RegionInstanceGroupManagersSetTargetPoolsRequest.prototype.targetPools = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RegionInstanceGroupManagersSetTargetPoolsRequest _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupManagersSetTargetPoolsRequest.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RegionInstanceGroupManagersSetTargetPoolsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersSetTargetPoolsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest} RegionInstanceGroupManagersSetTargetPoolsRequest instance
                         */
                        RegionInstanceGroupManagersSetTargetPoolsRequest.create = function create(properties) {
                            return new RegionInstanceGroupManagersSetTargetPoolsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagersSetTargetPoolsRequest message. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersSetTargetPoolsRequest} message RegionInstanceGroupManagersSetTargetPoolsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagersSetTargetPoolsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.targetPools != null && message.targetPools.length)
                                for (var i = 0; i < message.targetPools.length; ++i)
                                    writer.uint32(/* id 336072617, wireType 2 =*/2688580938).string(message.targetPools[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagersSetTargetPoolsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersSetTargetPoolsRequest} message RegionInstanceGroupManagersSetTargetPoolsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagersSetTargetPoolsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagersSetTargetPoolsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest} RegionInstanceGroupManagersSetTargetPoolsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagersSetTargetPoolsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 336072617: {
                                        if (!(message.targetPools && message.targetPools.length))
                                            message.targetPools = [];
                                        message.targetPools.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagersSetTargetPoolsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest} RegionInstanceGroupManagersSetTargetPoolsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagersSetTargetPoolsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionInstanceGroupManagersSetTargetPoolsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionInstanceGroupManagersSetTargetPoolsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.targetPools != null && message.hasOwnProperty("targetPools")) {
                                if (!Array.isArray(message.targetPools))
                                    return "targetPools: array expected";
                                for (var i = 0; i < message.targetPools.length; ++i)
                                    if (!$util.isString(message.targetPools[i]))
                                        return "targetPools: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionInstanceGroupManagersSetTargetPoolsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest} RegionInstanceGroupManagersSetTargetPoolsRequest
                         */
                        RegionInstanceGroupManagersSetTargetPoolsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest();
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.targetPools) {
                                if (!Array.isArray(object.targetPools))
                                    throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest.targetPools: array expected");
                                message.targetPools = [];
                                for (var i = 0; i < object.targetPools.length; ++i)
                                    message.targetPools[i] = String(object.targetPools[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionInstanceGroupManagersSetTargetPoolsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest
                         * @static
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest} message RegionInstanceGroupManagersSetTargetPoolsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionInstanceGroupManagersSetTargetPoolsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.targetPools = [];
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.targetPools && message.targetPools.length) {
                                object.targetPools = [];
                                for (var j = 0; j < message.targetPools.length; ++j)
                                    object.targetPools[j] = message.targetPools[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionInstanceGroupManagersSetTargetPoolsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionInstanceGroupManagersSetTargetPoolsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionInstanceGroupManagersSetTargetPoolsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionInstanceGroupManagersSetTargetPoolsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest";
                        };
    
                        return RegionInstanceGroupManagersSetTargetPoolsRequest;
                    })();
    
                    v1.RegionInstanceGroupManagersSetTemplateRequest = (function() {
    
                        /**
                         * Properties of a RegionInstanceGroupManagersSetTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionInstanceGroupManagersSetTemplateRequest
                         * @property {string|null} [instanceTemplate] RegionInstanceGroupManagersSetTemplateRequest instanceTemplate
                         */
    
                        /**
                         * Constructs a new RegionInstanceGroupManagersSetTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstanceGroupManagersSetTemplateRequest.
                         * @implements IRegionInstanceGroupManagersSetTemplateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersSetTemplateRequest=} [properties] Properties to set
                         */
                        function RegionInstanceGroupManagersSetTemplateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionInstanceGroupManagersSetTemplateRequest instanceTemplate.
                         * @member {string|null|undefined} instanceTemplate
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest
                         * @instance
                         */
                        RegionInstanceGroupManagersSetTemplateRequest.prototype.instanceTemplate = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RegionInstanceGroupManagersSetTemplateRequest _instanceTemplate.
                         * @member {"instanceTemplate"|undefined} _instanceTemplate
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupManagersSetTemplateRequest.prototype, "_instanceTemplate", {
                            get: $util.oneOfGetter($oneOfFields = ["instanceTemplate"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RegionInstanceGroupManagersSetTemplateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersSetTemplateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest} RegionInstanceGroupManagersSetTemplateRequest instance
                         */
                        RegionInstanceGroupManagersSetTemplateRequest.create = function create(properties) {
                            return new RegionInstanceGroupManagersSetTemplateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagersSetTemplateRequest message. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersSetTemplateRequest} message RegionInstanceGroupManagersSetTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagersSetTemplateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instanceTemplate != null && Object.hasOwnProperty.call(message, "instanceTemplate"))
                                writer.uint32(/* id 309248228, wireType 2 =*/2473985826).string(message.instanceTemplate);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupManagersSetTemplateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupManagersSetTemplateRequest} message RegionInstanceGroupManagersSetTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupManagersSetTemplateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagersSetTemplateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest} RegionInstanceGroupManagersSetTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagersSetTemplateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 309248228: {
                                        message.instanceTemplate = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupManagersSetTemplateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest} RegionInstanceGroupManagersSetTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupManagersSetTemplateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionInstanceGroupManagersSetTemplateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionInstanceGroupManagersSetTemplateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceTemplate != null && message.hasOwnProperty("instanceTemplate")) {
                                properties._instanceTemplate = 1;
                                if (!$util.isString(message.instanceTemplate))
                                    return "instanceTemplate: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionInstanceGroupManagersSetTemplateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest} RegionInstanceGroupManagersSetTemplateRequest
                         */
                        RegionInstanceGroupManagersSetTemplateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest();
                            if (object.instanceTemplate != null)
                                message.instanceTemplate = String(object.instanceTemplate);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionInstanceGroupManagersSetTemplateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest} message RegionInstanceGroupManagersSetTemplateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionInstanceGroupManagersSetTemplateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.instanceTemplate != null && message.hasOwnProperty("instanceTemplate")) {
                                object.instanceTemplate = message.instanceTemplate;
                                if (options.oneofs)
                                    object._instanceTemplate = "instanceTemplate";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionInstanceGroupManagersSetTemplateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionInstanceGroupManagersSetTemplateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionInstanceGroupManagersSetTemplateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionInstanceGroupManagersSetTemplateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest";
                        };
    
                        return RegionInstanceGroupManagersSetTemplateRequest;
                    })();
    
                    v1.RegionInstanceGroupsListInstances = (function() {
    
                        /**
                         * Properties of a RegionInstanceGroupsListInstances.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionInstanceGroupsListInstances
                         * @property {string|null} [id] RegionInstanceGroupsListInstances id
                         * @property {Array.<google.cloud.compute.v1.IInstanceWithNamedPorts>|null} [items] RegionInstanceGroupsListInstances items
                         * @property {string|null} [kind] RegionInstanceGroupsListInstances kind
                         * @property {string|null} [nextPageToken] RegionInstanceGroupsListInstances nextPageToken
                         * @property {string|null} [selfLink] RegionInstanceGroupsListInstances selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] RegionInstanceGroupsListInstances warning
                         */
    
                        /**
                         * Constructs a new RegionInstanceGroupsListInstances.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstanceGroupsListInstances.
                         * @implements IRegionInstanceGroupsListInstances
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupsListInstances=} [properties] Properties to set
                         */
                        function RegionInstanceGroupsListInstances(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionInstanceGroupsListInstances id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @instance
                         */
                        RegionInstanceGroupsListInstances.prototype.id = null;
    
                        /**
                         * RegionInstanceGroupsListInstances items.
                         * @member {Array.<google.cloud.compute.v1.IInstanceWithNamedPorts>} items
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @instance
                         */
                        RegionInstanceGroupsListInstances.prototype.items = $util.emptyArray;
    
                        /**
                         * RegionInstanceGroupsListInstances kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @instance
                         */
                        RegionInstanceGroupsListInstances.prototype.kind = null;
    
                        /**
                         * RegionInstanceGroupsListInstances nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @instance
                         */
                        RegionInstanceGroupsListInstances.prototype.nextPageToken = null;
    
                        /**
                         * RegionInstanceGroupsListInstances selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @instance
                         */
                        RegionInstanceGroupsListInstances.prototype.selfLink = null;
    
                        /**
                         * RegionInstanceGroupsListInstances warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @instance
                         */
                        RegionInstanceGroupsListInstances.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RegionInstanceGroupsListInstances _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupsListInstances.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionInstanceGroupsListInstances _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupsListInstances.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionInstanceGroupsListInstances _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupsListInstances.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionInstanceGroupsListInstances _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupsListInstances.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionInstanceGroupsListInstances _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupsListInstances.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RegionInstanceGroupsListInstances instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupsListInstances=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupsListInstances} RegionInstanceGroupsListInstances instance
                         */
                        RegionInstanceGroupsListInstances.create = function create(properties) {
                            return new RegionInstanceGroupsListInstances(properties);
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupsListInstances message. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupsListInstances.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupsListInstances} message RegionInstanceGroupsListInstances message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupsListInstances.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.InstanceWithNamedPorts.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupsListInstances message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupsListInstances.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupsListInstances} message RegionInstanceGroupsListInstances message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupsListInstances.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupsListInstances message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupsListInstances} RegionInstanceGroupsListInstances
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupsListInstances.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionInstanceGroupsListInstances();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.InstanceWithNamedPorts.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupsListInstances message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupsListInstances} RegionInstanceGroupsListInstances
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupsListInstances.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionInstanceGroupsListInstances message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionInstanceGroupsListInstances.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstanceWithNamedPorts.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionInstanceGroupsListInstances message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupsListInstances} RegionInstanceGroupsListInstances
                         */
                        RegionInstanceGroupsListInstances.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionInstanceGroupsListInstances)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionInstanceGroupsListInstances();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupsListInstances.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupsListInstances.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.InstanceWithNamedPorts.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupsListInstances.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionInstanceGroupsListInstances message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @static
                         * @param {google.cloud.compute.v1.RegionInstanceGroupsListInstances} message RegionInstanceGroupsListInstances
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionInstanceGroupsListInstances.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.InstanceWithNamedPorts.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionInstanceGroupsListInstances to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionInstanceGroupsListInstances.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionInstanceGroupsListInstances
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstances
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionInstanceGroupsListInstances.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionInstanceGroupsListInstances";
                        };
    
                        return RegionInstanceGroupsListInstances;
                    })();
    
                    v1.RegionInstanceGroupsListInstancesRequest = (function() {
    
                        /**
                         * Properties of a RegionInstanceGroupsListInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionInstanceGroupsListInstancesRequest
                         * @property {string|null} [instanceState] RegionInstanceGroupsListInstancesRequest instanceState
                         * @property {string|null} [portName] RegionInstanceGroupsListInstancesRequest portName
                         */
    
                        /**
                         * Constructs a new RegionInstanceGroupsListInstancesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstanceGroupsListInstancesRequest.
                         * @implements IRegionInstanceGroupsListInstancesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupsListInstancesRequest=} [properties] Properties to set
                         */
                        function RegionInstanceGroupsListInstancesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionInstanceGroupsListInstancesRequest instanceState.
                         * @member {string|null|undefined} instanceState
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest
                         * @instance
                         */
                        RegionInstanceGroupsListInstancesRequest.prototype.instanceState = null;
    
                        /**
                         * RegionInstanceGroupsListInstancesRequest portName.
                         * @member {string|null|undefined} portName
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest
                         * @instance
                         */
                        RegionInstanceGroupsListInstancesRequest.prototype.portName = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RegionInstanceGroupsListInstancesRequest _instanceState.
                         * @member {"instanceState"|undefined} _instanceState
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupsListInstancesRequest.prototype, "_instanceState", {
                            get: $util.oneOfGetter($oneOfFields = ["instanceState"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionInstanceGroupsListInstancesRequest _portName.
                         * @member {"portName"|undefined} _portName
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupsListInstancesRequest.prototype, "_portName", {
                            get: $util.oneOfGetter($oneOfFields = ["portName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RegionInstanceGroupsListInstancesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupsListInstancesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest} RegionInstanceGroupsListInstancesRequest instance
                         */
                        RegionInstanceGroupsListInstancesRequest.create = function create(properties) {
                            return new RegionInstanceGroupsListInstancesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupsListInstancesRequest message. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupsListInstancesRequest} message RegionInstanceGroupsListInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupsListInstancesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.portName != null && Object.hasOwnProperty.call(message, "portName"))
                                writer.uint32(/* id 41534345, wireType 2 =*/332274762).string(message.portName);
                            if (message.instanceState != null && Object.hasOwnProperty.call(message, "instanceState"))
                                writer.uint32(/* id 92223591, wireType 2 =*/737788730).string(message.instanceState);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupsListInstancesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupsListInstancesRequest} message RegionInstanceGroupsListInstancesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupsListInstancesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupsListInstancesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest} RegionInstanceGroupsListInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupsListInstancesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 92223591: {
                                        message.instanceState = reader.string();
                                        break;
                                    }
                                case 41534345: {
                                        message.portName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupsListInstancesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest} RegionInstanceGroupsListInstancesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupsListInstancesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionInstanceGroupsListInstancesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionInstanceGroupsListInstancesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceState != null && message.hasOwnProperty("instanceState")) {
                                properties._instanceState = 1;
                                if (!$util.isString(message.instanceState))
                                    return "instanceState: string expected";
                            }
                            if (message.portName != null && message.hasOwnProperty("portName")) {
                                properties._portName = 1;
                                if (!$util.isString(message.portName))
                                    return "portName: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionInstanceGroupsListInstancesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest} RegionInstanceGroupsListInstancesRequest
                         */
                        RegionInstanceGroupsListInstancesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest();
                            if (object.instanceState != null)
                                message.instanceState = String(object.instanceState);
                            if (object.portName != null)
                                message.portName = String(object.portName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionInstanceGroupsListInstancesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest
                         * @static
                         * @param {google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest} message RegionInstanceGroupsListInstancesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionInstanceGroupsListInstancesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.portName != null && message.hasOwnProperty("portName")) {
                                object.portName = message.portName;
                                if (options.oneofs)
                                    object._portName = "portName";
                            }
                            if (message.instanceState != null && message.hasOwnProperty("instanceState")) {
                                object.instanceState = message.instanceState;
                                if (options.oneofs)
                                    object._instanceState = "instanceState";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionInstanceGroupsListInstancesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionInstanceGroupsListInstancesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionInstanceGroupsListInstancesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionInstanceGroupsListInstancesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest";
                        };
    
                        /**
                         * InstanceState enum.
                         * @name google.cloud.compute.v1.RegionInstanceGroupsListInstancesRequest.InstanceState
                         * @enum {number}
                         * @property {number} UNDEFINED_INSTANCE_STATE=0 UNDEFINED_INSTANCE_STATE value
                         * @property {number} ALL=64897 ALL value
                         * @property {number} RUNNING=121282975 RUNNING value
                         */
                        RegionInstanceGroupsListInstancesRequest.InstanceState = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_INSTANCE_STATE"] = 0;
                            values[valuesById[64897] = "ALL"] = 64897;
                            values[valuesById[121282975] = "RUNNING"] = 121282975;
                            return values;
                        })();
    
                        return RegionInstanceGroupsListInstancesRequest;
                    })();
    
                    v1.RegionInstanceGroupsSetNamedPortsRequest = (function() {
    
                        /**
                         * Properties of a RegionInstanceGroupsSetNamedPortsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionInstanceGroupsSetNamedPortsRequest
                         * @property {string|null} [fingerprint] RegionInstanceGroupsSetNamedPortsRequest fingerprint
                         * @property {Array.<google.cloud.compute.v1.INamedPort>|null} [namedPorts] RegionInstanceGroupsSetNamedPortsRequest namedPorts
                         */
    
                        /**
                         * Constructs a new RegionInstanceGroupsSetNamedPortsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstanceGroupsSetNamedPortsRequest.
                         * @implements IRegionInstanceGroupsSetNamedPortsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupsSetNamedPortsRequest=} [properties] Properties to set
                         */
                        function RegionInstanceGroupsSetNamedPortsRequest(properties) {
                            this.namedPorts = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionInstanceGroupsSetNamedPortsRequest fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest
                         * @instance
                         */
                        RegionInstanceGroupsSetNamedPortsRequest.prototype.fingerprint = null;
    
                        /**
                         * RegionInstanceGroupsSetNamedPortsRequest namedPorts.
                         * @member {Array.<google.cloud.compute.v1.INamedPort>} namedPorts
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest
                         * @instance
                         */
                        RegionInstanceGroupsSetNamedPortsRequest.prototype.namedPorts = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RegionInstanceGroupsSetNamedPortsRequest _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest
                         * @instance
                         */
                        Object.defineProperty(RegionInstanceGroupsSetNamedPortsRequest.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RegionInstanceGroupsSetNamedPortsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupsSetNamedPortsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest} RegionInstanceGroupsSetNamedPortsRequest instance
                         */
                        RegionInstanceGroupsSetNamedPortsRequest.create = function create(properties) {
                            return new RegionInstanceGroupsSetNamedPortsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupsSetNamedPortsRequest message. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupsSetNamedPortsRequest} message RegionInstanceGroupsSetNamedPortsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupsSetNamedPortsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.namedPorts != null && message.namedPorts.length)
                                for (var i = 0; i < message.namedPorts.length; ++i)
                                    $root.google.cloud.compute.v1.NamedPort.encode(message.namedPorts[i], writer.uint32(/* id 427598732, wireType 2 =*/3420789858).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionInstanceGroupsSetNamedPortsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionInstanceGroupsSetNamedPortsRequest} message RegionInstanceGroupsSetNamedPortsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionInstanceGroupsSetNamedPortsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupsSetNamedPortsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest} RegionInstanceGroupsSetNamedPortsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupsSetNamedPortsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 427598732: {
                                        if (!(message.namedPorts && message.namedPorts.length))
                                            message.namedPorts = [];
                                        message.namedPorts.push($root.google.cloud.compute.v1.NamedPort.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionInstanceGroupsSetNamedPortsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest} RegionInstanceGroupsSetNamedPortsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionInstanceGroupsSetNamedPortsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionInstanceGroupsSetNamedPortsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionInstanceGroupsSetNamedPortsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.namedPorts != null && message.hasOwnProperty("namedPorts")) {
                                if (!Array.isArray(message.namedPorts))
                                    return "namedPorts: array expected";
                                for (var i = 0; i < message.namedPorts.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NamedPort.verify(message.namedPorts[i]);
                                    if (error)
                                        return "namedPorts." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionInstanceGroupsSetNamedPortsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest} RegionInstanceGroupsSetNamedPortsRequest
                         */
                        RegionInstanceGroupsSetNamedPortsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest();
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.namedPorts) {
                                if (!Array.isArray(object.namedPorts))
                                    throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest.namedPorts: array expected");
                                message.namedPorts = [];
                                for (var i = 0; i < object.namedPorts.length; ++i) {
                                    if (typeof object.namedPorts[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest.namedPorts: object expected");
                                    message.namedPorts[i] = $root.google.cloud.compute.v1.NamedPort.fromObject(object.namedPorts[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionInstanceGroupsSetNamedPortsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest
                         * @static
                         * @param {google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest} message RegionInstanceGroupsSetNamedPortsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionInstanceGroupsSetNamedPortsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.namedPorts = [];
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.namedPorts && message.namedPorts.length) {
                                object.namedPorts = [];
                                for (var j = 0; j < message.namedPorts.length; ++j)
                                    object.namedPorts[j] = $root.google.cloud.compute.v1.NamedPort.toObject(message.namedPorts[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionInstanceGroupsSetNamedPortsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionInstanceGroupsSetNamedPortsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionInstanceGroupsSetNamedPortsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionInstanceGroupsSetNamedPortsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest";
                        };
    
                        return RegionInstanceGroupsSetNamedPortsRequest;
                    })();
    
                    v1.RegionList = (function() {
    
                        /**
                         * Properties of a RegionList.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionList
                         * @property {string|null} [id] RegionList id
                         * @property {Array.<google.cloud.compute.v1.IRegion>|null} [items] RegionList items
                         * @property {string|null} [kind] RegionList kind
                         * @property {string|null} [nextPageToken] RegionList nextPageToken
                         * @property {string|null} [selfLink] RegionList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] RegionList warning
                         */
    
                        /**
                         * Constructs a new RegionList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionList.
                         * @implements IRegionList
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionList=} [properties] Properties to set
                         */
                        function RegionList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.RegionList
                         * @instance
                         */
                        RegionList.prototype.id = null;
    
                        /**
                         * RegionList items.
                         * @member {Array.<google.cloud.compute.v1.IRegion>} items
                         * @memberof google.cloud.compute.v1.RegionList
                         * @instance
                         */
                        RegionList.prototype.items = $util.emptyArray;
    
                        /**
                         * RegionList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.RegionList
                         * @instance
                         */
                        RegionList.prototype.kind = null;
    
                        /**
                         * RegionList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.RegionList
                         * @instance
                         */
                        RegionList.prototype.nextPageToken = null;
    
                        /**
                         * RegionList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.RegionList
                         * @instance
                         */
                        RegionList.prototype.selfLink = null;
    
                        /**
                         * RegionList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.RegionList
                         * @instance
                         */
                        RegionList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RegionList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.RegionList
                         * @instance
                         */
                        Object.defineProperty(RegionList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.RegionList
                         * @instance
                         */
                        Object.defineProperty(RegionList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.RegionList
                         * @instance
                         */
                        Object.defineProperty(RegionList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.RegionList
                         * @instance
                         */
                        Object.defineProperty(RegionList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.RegionList
                         * @instance
                         */
                        Object.defineProperty(RegionList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RegionList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionList
                         * @static
                         * @param {google.cloud.compute.v1.IRegionList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionList} RegionList instance
                         */
                        RegionList.create = function create(properties) {
                            return new RegionList(properties);
                        };
    
                        /**
                         * Encodes the specified RegionList message. Does not implicitly {@link google.cloud.compute.v1.RegionList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionList
                         * @static
                         * @param {google.cloud.compute.v1.IRegionList} message RegionList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Region.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionList
                         * @static
                         * @param {google.cloud.compute.v1.IRegionList} message RegionList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionList} RegionList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Region.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionList} RegionList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Region.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionList} RegionList
                         */
                        RegionList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.RegionList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RegionList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Region.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RegionList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionList
                         * @static
                         * @param {google.cloud.compute.v1.RegionList} message RegionList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Region.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionList";
                        };
    
                        return RegionList;
                    })();
    
                    v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse = (function() {
    
                        /**
                         * Properties of a RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         * @property {Array.<google.cloud.compute.v1.IRegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy>|null} [firewallPolicys] RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse firewallPolicys
                         * @property {Array.<google.cloud.compute.v1.IFirewall>|null} [firewalls] RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse firewalls
                         */
    
                        /**
                         * Constructs a new RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.
                         * @implements IRegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse=} [properties] Properties to set
                         */
                        function RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse(properties) {
                            this.firewallPolicys = [];
                            this.firewalls = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse firewallPolicys.
                         * @member {Array.<google.cloud.compute.v1.IRegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy>} firewallPolicys
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         * @instance
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.prototype.firewallPolicys = $util.emptyArray;
    
                        /**
                         * RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse firewalls.
                         * @member {Array.<google.cloud.compute.v1.IFirewall>} firewalls
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         * @instance
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.prototype.firewalls = $util.emptyArray;
    
                        /**
                         * Creates a new RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         * @static
                         * @param {google.cloud.compute.v1.IRegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse} RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse instance
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.create = function create(properties) {
                            return new RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse message. Does not implicitly {@link google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         * @static
                         * @param {google.cloud.compute.v1.IRegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse} message RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.firewalls != null && message.firewalls.length)
                                for (var i = 0; i < message.firewalls.length; ++i)
                                    $root.google.cloud.compute.v1.Firewall.encode(message.firewalls[i], writer.uint32(/* id 272245619, wireType 2 =*/2177964954).fork()).ldelim();
                            if (message.firewallPolicys != null && message.firewallPolicys.length)
                                for (var i = 0; i < message.firewallPolicys.length; ++i)
                                    $root.google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.encode(message.firewallPolicys[i], writer.uint32(/* id 410985794, wireType 2 =*/3287886354).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         * @static
                         * @param {google.cloud.compute.v1.IRegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse} message RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse} RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 410985794: {
                                        if (!(message.firewallPolicys && message.firewallPolicys.length))
                                            message.firewallPolicys = [];
                                        message.firewallPolicys.push($root.google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 272245619: {
                                        if (!(message.firewalls && message.firewalls.length))
                                            message.firewalls = [];
                                        message.firewalls.push($root.google.cloud.compute.v1.Firewall.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse} RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.firewallPolicys != null && message.hasOwnProperty("firewallPolicys")) {
                                if (!Array.isArray(message.firewallPolicys))
                                    return "firewallPolicys: array expected";
                                for (var i = 0; i < message.firewallPolicys.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.verify(message.firewallPolicys[i]);
                                    if (error)
                                        return "firewallPolicys." + error;
                                }
                            }
                            if (message.firewalls != null && message.hasOwnProperty("firewalls")) {
                                if (!Array.isArray(message.firewalls))
                                    return "firewalls: array expected";
                                for (var i = 0; i < message.firewalls.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Firewall.verify(message.firewalls[i]);
                                    if (error)
                                        return "firewalls." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse} RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse();
                            if (object.firewallPolicys) {
                                if (!Array.isArray(object.firewallPolicys))
                                    throw TypeError(".google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.firewallPolicys: array expected");
                                message.firewallPolicys = [];
                                for (var i = 0; i < object.firewallPolicys.length; ++i) {
                                    if (typeof object.firewallPolicys[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.firewallPolicys: object expected");
                                    message.firewallPolicys[i] = $root.google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.fromObject(object.firewallPolicys[i]);
                                }
                            }
                            if (object.firewalls) {
                                if (!Array.isArray(object.firewalls))
                                    throw TypeError(".google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.firewalls: array expected");
                                message.firewalls = [];
                                for (var i = 0; i < object.firewalls.length; ++i) {
                                    if (typeof object.firewalls[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.firewalls: object expected");
                                    message.firewalls[i] = $root.google.cloud.compute.v1.Firewall.fromObject(object.firewalls[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         * @static
                         * @param {google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse} message RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.firewalls = [];
                                object.firewallPolicys = [];
                            }
                            if (message.firewalls && message.firewalls.length) {
                                object.firewalls = [];
                                for (var j = 0; j < message.firewalls.length; ++j)
                                    object.firewalls[j] = $root.google.cloud.compute.v1.Firewall.toObject(message.firewalls[j], options);
                            }
                            if (message.firewallPolicys && message.firewallPolicys.length) {
                                object.firewallPolicys = [];
                                for (var j = 0; j < message.firewallPolicys.length; ++j)
                                    object.firewallPolicys[j] = $root.google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.toObject(message.firewallPolicys[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse";
                        };
    
                        return RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse;
                    })();
    
                    v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy = (function() {
    
                        /**
                         * Properties of a RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @property {string|null} [displayName] RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy displayName
                         * @property {string|null} [name] RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy name
                         * @property {Array.<google.cloud.compute.v1.IFirewallPolicyRule>|null} [rules] RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy rules
                         * @property {string|null} [type] RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy type
                         */
    
                        /**
                         * Constructs a new RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.
                         * @implements IRegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy=} [properties] Properties to set
                         */
                        function RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy(properties) {
                            this.rules = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy displayName.
                         * @member {string|null|undefined} displayName
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype.displayName = null;
    
                        /**
                         * RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype.name = null;
    
                        /**
                         * RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy rules.
                         * @member {Array.<google.cloud.compute.v1.IFirewallPolicyRule>} rules
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype.rules = $util.emptyArray;
    
                        /**
                         * RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype.type = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy _displayName.
                         * @member {"displayName"|undefined} _displayName
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype, "_displayName", {
                            get: $util.oneOfGetter($oneOfFields = ["displayName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         */
                        Object.defineProperty(RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IRegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy} RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy instance
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.create = function create(properties) {
                            return new RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy message. Does not implicitly {@link google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IRegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy} message RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            if (message.displayName != null && Object.hasOwnProperty.call(message, "displayName"))
                                writer.uint32(/* id 4473832, wireType 2 =*/35790658).string(message.displayName);
                            if (message.rules != null && message.rules.length)
                                for (var i = 0; i < message.rules.length; ++i)
                                    $root.google.cloud.compute.v1.FirewallPolicyRule.encode(message.rules[i], writer.uint32(/* id 108873975, wireType 2 =*/870991802).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IRegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy} message RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy} RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 4473832: {
                                        message.displayName = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 108873975: {
                                        if (!(message.rules && message.rules.length))
                                            message.rules = [];
                                        message.rules.push($root.google.cloud.compute.v1.FirewallPolicyRule.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy} RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.displayName != null && message.hasOwnProperty("displayName")) {
                                properties._displayName = 1;
                                if (!$util.isString(message.displayName))
                                    return "displayName: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.rules != null && message.hasOwnProperty("rules")) {
                                if (!Array.isArray(message.rules))
                                    return "rules: array expected";
                                for (var i = 0; i < message.rules.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.FirewallPolicyRule.verify(message.rules[i]);
                                    if (error)
                                        return "rules." + error;
                                }
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy} RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy();
                            if (object.displayName != null)
                                message.displayName = String(object.displayName);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.rules) {
                                if (!Array.isArray(object.rules))
                                    throw TypeError(".google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.rules: array expected");
                                message.rules = [];
                                for (var i = 0; i < object.rules.length; ++i) {
                                    if (typeof object.rules[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.rules: object expected");
                                    message.rules[i] = $root.google.cloud.compute.v1.FirewallPolicyRule.fromObject(object.rules[i]);
                                }
                            }
                            if (object.type != null)
                                message.type = String(object.type);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy} message RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.rules = [];
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            if (message.displayName != null && message.hasOwnProperty("displayName")) {
                                object.displayName = message.displayName;
                                if (options.oneofs)
                                    object._displayName = "displayName";
                            }
                            if (message.rules && message.rules.length) {
                                object.rules = [];
                                for (var j = 0; j < message.rules.length; ++j)
                                    object.rules[j] = $root.google.cloud.compute.v1.FirewallPolicyRule.toObject(message.rules[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy";
                        };
    
                        /**
                         * Type enum.
                         * @name google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type
                         * @enum {number}
                         * @property {number} UNDEFINED_TYPE=0 UNDEFINED_TYPE value
                         * @property {number} HIERARCHY=69902869 HIERARCHY value
                         * @property {number} NETWORK=413984270 NETWORK value
                         * @property {number} NETWORK_REGIONAL=190804272 NETWORK_REGIONAL value
                         * @property {number} UNSPECIFIED=526786327 UNSPECIFIED value
                         */
                        RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy.Type = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TYPE"] = 0;
                            values[valuesById[69902869] = "HIERARCHY"] = 69902869;
                            values[valuesById[413984270] = "NETWORK"] = 413984270;
                            values[valuesById[190804272] = "NETWORK_REGIONAL"] = 190804272;
                            values[valuesById[526786327] = "UNSPECIFIED"] = 526786327;
                            return values;
                        })();
    
                        return RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponseEffectiveFirewallPolicy;
                    })();
    
                    v1.RegionSetLabelsRequest = (function() {
    
                        /**
                         * Properties of a RegionSetLabelsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionSetLabelsRequest
                         * @property {string|null} [labelFingerprint] RegionSetLabelsRequest labelFingerprint
                         * @property {Object.<string,string>|null} [labels] RegionSetLabelsRequest labels
                         */
    
                        /**
                         * Constructs a new RegionSetLabelsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionSetLabelsRequest.
                         * @implements IRegionSetLabelsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionSetLabelsRequest=} [properties] Properties to set
                         */
                        function RegionSetLabelsRequest(properties) {
                            this.labels = {};
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionSetLabelsRequest labelFingerprint.
                         * @member {string|null|undefined} labelFingerprint
                         * @memberof google.cloud.compute.v1.RegionSetLabelsRequest
                         * @instance
                         */
                        RegionSetLabelsRequest.prototype.labelFingerprint = null;
    
                        /**
                         * RegionSetLabelsRequest labels.
                         * @member {Object.<string,string>} labels
                         * @memberof google.cloud.compute.v1.RegionSetLabelsRequest
                         * @instance
                         */
                        RegionSetLabelsRequest.prototype.labels = $util.emptyObject;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RegionSetLabelsRequest _labelFingerprint.
                         * @member {"labelFingerprint"|undefined} _labelFingerprint
                         * @memberof google.cloud.compute.v1.RegionSetLabelsRequest
                         * @instance
                         */
                        Object.defineProperty(RegionSetLabelsRequest.prototype, "_labelFingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["labelFingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RegionSetLabelsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionSetLabelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionSetLabelsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionSetLabelsRequest} RegionSetLabelsRequest instance
                         */
                        RegionSetLabelsRequest.create = function create(properties) {
                            return new RegionSetLabelsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RegionSetLabelsRequest message. Does not implicitly {@link google.cloud.compute.v1.RegionSetLabelsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionSetLabelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionSetLabelsRequest} message RegionSetLabelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionSetLabelsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.labelFingerprint != null && Object.hasOwnProperty.call(message, "labelFingerprint"))
                                writer.uint32(/* id 178124825, wireType 2 =*/1424998602).string(message.labelFingerprint);
                            if (message.labels != null && Object.hasOwnProperty.call(message, "labels"))
                                for (var keys = Object.keys(message.labels), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 500195327, wireType 2 =*/4001562618).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.labels[keys[i]]).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionSetLabelsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionSetLabelsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionSetLabelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionSetLabelsRequest} message RegionSetLabelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionSetLabelsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionSetLabelsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionSetLabelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionSetLabelsRequest} RegionSetLabelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionSetLabelsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionSetLabelsRequest(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 178124825: {
                                        message.labelFingerprint = reader.string();
                                        break;
                                    }
                                case 500195327: {
                                        if (message.labels === $util.emptyObject)
                                            message.labels = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.labels[key] = value;
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionSetLabelsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionSetLabelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionSetLabelsRequest} RegionSetLabelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionSetLabelsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionSetLabelsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionSetLabelsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionSetLabelsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                properties._labelFingerprint = 1;
                                if (!$util.isString(message.labelFingerprint))
                                    return "labelFingerprint: string expected";
                            }
                            if (message.labels != null && message.hasOwnProperty("labels")) {
                                if (!$util.isObject(message.labels))
                                    return "labels: object expected";
                                var key = Object.keys(message.labels);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.labels[key[i]]))
                                        return "labels: string{k:string} expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionSetLabelsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionSetLabelsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionSetLabelsRequest} RegionSetLabelsRequest
                         */
                        RegionSetLabelsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionSetLabelsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionSetLabelsRequest();
                            if (object.labelFingerprint != null)
                                message.labelFingerprint = String(object.labelFingerprint);
                            if (object.labels) {
                                if (typeof object.labels !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RegionSetLabelsRequest.labels: object expected");
                                message.labels = {};
                                for (var keys = Object.keys(object.labels), i = 0; i < keys.length; ++i)
                                    message.labels[keys[i]] = String(object.labels[keys[i]]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionSetLabelsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionSetLabelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.RegionSetLabelsRequest} message RegionSetLabelsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionSetLabelsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.objects || options.defaults)
                                object.labels = {};
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                object.labelFingerprint = message.labelFingerprint;
                                if (options.oneofs)
                                    object._labelFingerprint = "labelFingerprint";
                            }
                            var keys2;
                            if (message.labels && (keys2 = Object.keys(message.labels)).length) {
                                object.labels = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.labels[keys2[j]] = message.labels[keys2[j]];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionSetLabelsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionSetLabelsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionSetLabelsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionSetLabelsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionSetLabelsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionSetLabelsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionSetLabelsRequest";
                        };
    
                        return RegionSetLabelsRequest;
                    })();
    
                    v1.RegionSetPolicyRequest = (function() {
    
                        /**
                         * Properties of a RegionSetPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionSetPolicyRequest
                         * @property {Array.<google.cloud.compute.v1.IBinding>|null} [bindings] RegionSetPolicyRequest bindings
                         * @property {string|null} [etag] RegionSetPolicyRequest etag
                         * @property {google.cloud.compute.v1.IPolicy|null} [policy] RegionSetPolicyRequest policy
                         */
    
                        /**
                         * Constructs a new RegionSetPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionSetPolicyRequest.
                         * @implements IRegionSetPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionSetPolicyRequest=} [properties] Properties to set
                         */
                        function RegionSetPolicyRequest(properties) {
                            this.bindings = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionSetPolicyRequest bindings.
                         * @member {Array.<google.cloud.compute.v1.IBinding>} bindings
                         * @memberof google.cloud.compute.v1.RegionSetPolicyRequest
                         * @instance
                         */
                        RegionSetPolicyRequest.prototype.bindings = $util.emptyArray;
    
                        /**
                         * RegionSetPolicyRequest etag.
                         * @member {string|null|undefined} etag
                         * @memberof google.cloud.compute.v1.RegionSetPolicyRequest
                         * @instance
                         */
                        RegionSetPolicyRequest.prototype.etag = null;
    
                        /**
                         * RegionSetPolicyRequest policy.
                         * @member {google.cloud.compute.v1.IPolicy|null|undefined} policy
                         * @memberof google.cloud.compute.v1.RegionSetPolicyRequest
                         * @instance
                         */
                        RegionSetPolicyRequest.prototype.policy = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RegionSetPolicyRequest _etag.
                         * @member {"etag"|undefined} _etag
                         * @memberof google.cloud.compute.v1.RegionSetPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(RegionSetPolicyRequest.prototype, "_etag", {
                            get: $util.oneOfGetter($oneOfFields = ["etag"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RegionSetPolicyRequest _policy.
                         * @member {"policy"|undefined} _policy
                         * @memberof google.cloud.compute.v1.RegionSetPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(RegionSetPolicyRequest.prototype, "_policy", {
                            get: $util.oneOfGetter($oneOfFields = ["policy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RegionSetPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionSetPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionSetPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionSetPolicyRequest} RegionSetPolicyRequest instance
                         */
                        RegionSetPolicyRequest.create = function create(properties) {
                            return new RegionSetPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RegionSetPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.RegionSetPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionSetPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionSetPolicyRequest} message RegionSetPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionSetPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.etag != null && Object.hasOwnProperty.call(message, "etag"))
                                writer.uint32(/* id 3123477, wireType 2 =*/24987818).string(message.etag);
                            if (message.policy != null && Object.hasOwnProperty.call(message, "policy"))
                                $root.google.cloud.compute.v1.Policy.encode(message.policy, writer.uint32(/* id 91071794, wireType 2 =*/728574354).fork()).ldelim();
                            if (message.bindings != null && message.bindings.length)
                                for (var i = 0; i < message.bindings.length; ++i)
                                    $root.google.cloud.compute.v1.Binding.encode(message.bindings[i], writer.uint32(/* id 403251854, wireType 2 =*/3226014834).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionSetPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionSetPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionSetPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionSetPolicyRequest} message RegionSetPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionSetPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionSetPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionSetPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionSetPolicyRequest} RegionSetPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionSetPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionSetPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 403251854: {
                                        if (!(message.bindings && message.bindings.length))
                                            message.bindings = [];
                                        message.bindings.push($root.google.cloud.compute.v1.Binding.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3123477: {
                                        message.etag = reader.string();
                                        break;
                                    }
                                case 91071794: {
                                        message.policy = $root.google.cloud.compute.v1.Policy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionSetPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionSetPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionSetPolicyRequest} RegionSetPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionSetPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionSetPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionSetPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionSetPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.bindings != null && message.hasOwnProperty("bindings")) {
                                if (!Array.isArray(message.bindings))
                                    return "bindings: array expected";
                                for (var i = 0; i < message.bindings.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Binding.verify(message.bindings[i]);
                                    if (error)
                                        return "bindings." + error;
                                }
                            }
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                properties._etag = 1;
                                if (!$util.isString(message.etag))
                                    return "etag: string expected";
                            }
                            if (message.policy != null && message.hasOwnProperty("policy")) {
                                properties._policy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Policy.verify(message.policy);
                                    if (error)
                                        return "policy." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionSetPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionSetPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionSetPolicyRequest} RegionSetPolicyRequest
                         */
                        RegionSetPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionSetPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionSetPolicyRequest();
                            if (object.bindings) {
                                if (!Array.isArray(object.bindings))
                                    throw TypeError(".google.cloud.compute.v1.RegionSetPolicyRequest.bindings: array expected");
                                message.bindings = [];
                                for (var i = 0; i < object.bindings.length; ++i) {
                                    if (typeof object.bindings[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RegionSetPolicyRequest.bindings: object expected");
                                    message.bindings[i] = $root.google.cloud.compute.v1.Binding.fromObject(object.bindings[i]);
                                }
                            }
                            if (object.etag != null)
                                message.etag = String(object.etag);
                            if (object.policy != null) {
                                if (typeof object.policy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RegionSetPolicyRequest.policy: object expected");
                                message.policy = $root.google.cloud.compute.v1.Policy.fromObject(object.policy);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionSetPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionSetPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.RegionSetPolicyRequest} message RegionSetPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionSetPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.bindings = [];
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                object.etag = message.etag;
                                if (options.oneofs)
                                    object._etag = "etag";
                            }
                            if (message.policy != null && message.hasOwnProperty("policy")) {
                                object.policy = $root.google.cloud.compute.v1.Policy.toObject(message.policy, options);
                                if (options.oneofs)
                                    object._policy = "policy";
                            }
                            if (message.bindings && message.bindings.length) {
                                object.bindings = [];
                                for (var j = 0; j < message.bindings.length; ++j)
                                    object.bindings[j] = $root.google.cloud.compute.v1.Binding.toObject(message.bindings[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionSetPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionSetPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionSetPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionSetPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionSetPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionSetPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionSetPolicyRequest";
                        };
    
                        return RegionSetPolicyRequest;
                    })();
    
                    v1.RegionTargetHttpsProxiesSetSslCertificatesRequest = (function() {
    
                        /**
                         * Properties of a RegionTargetHttpsProxiesSetSslCertificatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionTargetHttpsProxiesSetSslCertificatesRequest
                         * @property {Array.<string>|null} [sslCertificates] RegionTargetHttpsProxiesSetSslCertificatesRequest sslCertificates
                         */
    
                        /**
                         * Constructs a new RegionTargetHttpsProxiesSetSslCertificatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionTargetHttpsProxiesSetSslCertificatesRequest.
                         * @implements IRegionTargetHttpsProxiesSetSslCertificatesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionTargetHttpsProxiesSetSslCertificatesRequest=} [properties] Properties to set
                         */
                        function RegionTargetHttpsProxiesSetSslCertificatesRequest(properties) {
                            this.sslCertificates = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionTargetHttpsProxiesSetSslCertificatesRequest sslCertificates.
                         * @member {Array.<string>} sslCertificates
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest
                         * @instance
                         */
                        RegionTargetHttpsProxiesSetSslCertificatesRequest.prototype.sslCertificates = $util.emptyArray;
    
                        /**
                         * Creates a new RegionTargetHttpsProxiesSetSslCertificatesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionTargetHttpsProxiesSetSslCertificatesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest} RegionTargetHttpsProxiesSetSslCertificatesRequest instance
                         */
                        RegionTargetHttpsProxiesSetSslCertificatesRequest.create = function create(properties) {
                            return new RegionTargetHttpsProxiesSetSslCertificatesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RegionTargetHttpsProxiesSetSslCertificatesRequest message. Does not implicitly {@link google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionTargetHttpsProxiesSetSslCertificatesRequest} message RegionTargetHttpsProxiesSetSslCertificatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionTargetHttpsProxiesSetSslCertificatesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.sslCertificates != null && message.sslCertificates.length)
                                for (var i = 0; i < message.sslCertificates.length; ++i)
                                    writer.uint32(/* id 366006543, wireType 2 =*/2928052346).string(message.sslCertificates[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionTargetHttpsProxiesSetSslCertificatesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionTargetHttpsProxiesSetSslCertificatesRequest} message RegionTargetHttpsProxiesSetSslCertificatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionTargetHttpsProxiesSetSslCertificatesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionTargetHttpsProxiesSetSslCertificatesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest} RegionTargetHttpsProxiesSetSslCertificatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionTargetHttpsProxiesSetSslCertificatesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 366006543: {
                                        if (!(message.sslCertificates && message.sslCertificates.length))
                                            message.sslCertificates = [];
                                        message.sslCertificates.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionTargetHttpsProxiesSetSslCertificatesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest} RegionTargetHttpsProxiesSetSslCertificatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionTargetHttpsProxiesSetSslCertificatesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionTargetHttpsProxiesSetSslCertificatesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionTargetHttpsProxiesSetSslCertificatesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.sslCertificates != null && message.hasOwnProperty("sslCertificates")) {
                                if (!Array.isArray(message.sslCertificates))
                                    return "sslCertificates: array expected";
                                for (var i = 0; i < message.sslCertificates.length; ++i)
                                    if (!$util.isString(message.sslCertificates[i]))
                                        return "sslCertificates: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionTargetHttpsProxiesSetSslCertificatesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest} RegionTargetHttpsProxiesSetSslCertificatesRequest
                         */
                        RegionTargetHttpsProxiesSetSslCertificatesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest();
                            if (object.sslCertificates) {
                                if (!Array.isArray(object.sslCertificates))
                                    throw TypeError(".google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest.sslCertificates: array expected");
                                message.sslCertificates = [];
                                for (var i = 0; i < object.sslCertificates.length; ++i)
                                    message.sslCertificates[i] = String(object.sslCertificates[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionTargetHttpsProxiesSetSslCertificatesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest} message RegionTargetHttpsProxiesSetSslCertificatesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionTargetHttpsProxiesSetSslCertificatesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.sslCertificates = [];
                            if (message.sslCertificates && message.sslCertificates.length) {
                                object.sslCertificates = [];
                                for (var j = 0; j < message.sslCertificates.length; ++j)
                                    object.sslCertificates[j] = message.sslCertificates[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionTargetHttpsProxiesSetSslCertificatesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionTargetHttpsProxiesSetSslCertificatesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionTargetHttpsProxiesSetSslCertificatesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionTargetHttpsProxiesSetSslCertificatesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest";
                        };
    
                        return RegionTargetHttpsProxiesSetSslCertificatesRequest;
                    })();
    
                    v1.RegionUrlMapsValidateRequest = (function() {
    
                        /**
                         * Properties of a RegionUrlMapsValidateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRegionUrlMapsValidateRequest
                         * @property {google.cloud.compute.v1.IUrlMap|null} [resource] RegionUrlMapsValidateRequest resource
                         */
    
                        /**
                         * Constructs a new RegionUrlMapsValidateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionUrlMapsValidateRequest.
                         * @implements IRegionUrlMapsValidateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRegionUrlMapsValidateRequest=} [properties] Properties to set
                         */
                        function RegionUrlMapsValidateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RegionUrlMapsValidateRequest resource.
                         * @member {google.cloud.compute.v1.IUrlMap|null|undefined} resource
                         * @memberof google.cloud.compute.v1.RegionUrlMapsValidateRequest
                         * @instance
                         */
                        RegionUrlMapsValidateRequest.prototype.resource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RegionUrlMapsValidateRequest _resource.
                         * @member {"resource"|undefined} _resource
                         * @memberof google.cloud.compute.v1.RegionUrlMapsValidateRequest
                         * @instance
                         */
                        Object.defineProperty(RegionUrlMapsValidateRequest.prototype, "_resource", {
                            get: $util.oneOfGetter($oneOfFields = ["resource"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RegionUrlMapsValidateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionUrlMapsValidateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionUrlMapsValidateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RegionUrlMapsValidateRequest} RegionUrlMapsValidateRequest instance
                         */
                        RegionUrlMapsValidateRequest.create = function create(properties) {
                            return new RegionUrlMapsValidateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RegionUrlMapsValidateRequest message. Does not implicitly {@link google.cloud.compute.v1.RegionUrlMapsValidateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RegionUrlMapsValidateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionUrlMapsValidateRequest} message RegionUrlMapsValidateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionUrlMapsValidateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                $root.google.cloud.compute.v1.UrlMap.encode(message.resource, writer.uint32(/* id 195806222, wireType 2 =*/1566449778).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RegionUrlMapsValidateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RegionUrlMapsValidateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RegionUrlMapsValidateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRegionUrlMapsValidateRequest} message RegionUrlMapsValidateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RegionUrlMapsValidateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RegionUrlMapsValidateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RegionUrlMapsValidateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RegionUrlMapsValidateRequest} RegionUrlMapsValidateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionUrlMapsValidateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RegionUrlMapsValidateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 195806222: {
                                        message.resource = $root.google.cloud.compute.v1.UrlMap.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RegionUrlMapsValidateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RegionUrlMapsValidateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RegionUrlMapsValidateRequest} RegionUrlMapsValidateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RegionUrlMapsValidateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RegionUrlMapsValidateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RegionUrlMapsValidateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RegionUrlMapsValidateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resource != null && message.hasOwnProperty("resource")) {
                                properties._resource = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.UrlMap.verify(message.resource);
                                    if (error)
                                        return "resource." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RegionUrlMapsValidateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RegionUrlMapsValidateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RegionUrlMapsValidateRequest} RegionUrlMapsValidateRequest
                         */
                        RegionUrlMapsValidateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RegionUrlMapsValidateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RegionUrlMapsValidateRequest();
                            if (object.resource != null) {
                                if (typeof object.resource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RegionUrlMapsValidateRequest.resource: object expected");
                                message.resource = $root.google.cloud.compute.v1.UrlMap.fromObject(object.resource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RegionUrlMapsValidateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RegionUrlMapsValidateRequest
                         * @static
                         * @param {google.cloud.compute.v1.RegionUrlMapsValidateRequest} message RegionUrlMapsValidateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RegionUrlMapsValidateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.resource != null && message.hasOwnProperty("resource")) {
                                object.resource = $root.google.cloud.compute.v1.UrlMap.toObject(message.resource, options);
                                if (options.oneofs)
                                    object._resource = "resource";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RegionUrlMapsValidateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RegionUrlMapsValidateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RegionUrlMapsValidateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RegionUrlMapsValidateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RegionUrlMapsValidateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RegionUrlMapsValidateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RegionUrlMapsValidateRequest";
                        };
    
                        return RegionUrlMapsValidateRequest;
                    })();
    
                    v1.RemoveAssociationFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a RemoveAssociationFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRemoveAssociationFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] RemoveAssociationFirewallPolicyRequest firewallPolicy
                         * @property {string|null} [name] RemoveAssociationFirewallPolicyRequest name
                         * @property {string|null} [requestId] RemoveAssociationFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new RemoveAssociationFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RemoveAssociationFirewallPolicyRequest.
                         * @implements IRemoveAssociationFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRemoveAssociationFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function RemoveAssociationFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RemoveAssociationFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest
                         * @instance
                         */
                        RemoveAssociationFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * RemoveAssociationFirewallPolicyRequest name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest
                         * @instance
                         */
                        RemoveAssociationFirewallPolicyRequest.prototype.name = null;
    
                        /**
                         * RemoveAssociationFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest
                         * @instance
                         */
                        RemoveAssociationFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RemoveAssociationFirewallPolicyRequest _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(RemoveAssociationFirewallPolicyRequest.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RemoveAssociationFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(RemoveAssociationFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RemoveAssociationFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveAssociationFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest} RemoveAssociationFirewallPolicyRequest instance
                         */
                        RemoveAssociationFirewallPolicyRequest.create = function create(properties) {
                            return new RemoveAssociationFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RemoveAssociationFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveAssociationFirewallPolicyRequest} message RemoveAssociationFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveAssociationFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RemoveAssociationFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveAssociationFirewallPolicyRequest} message RemoveAssociationFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveAssociationFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RemoveAssociationFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest} RemoveAssociationFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveAssociationFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RemoveAssociationFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest} RemoveAssociationFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveAssociationFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RemoveAssociationFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RemoveAssociationFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RemoveAssociationFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest} RemoveAssociationFirewallPolicyRequest
                         */
                        RemoveAssociationFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RemoveAssociationFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest} message RemoveAssociationFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RemoveAssociationFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.firewallPolicy = "";
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this RemoveAssociationFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RemoveAssociationFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RemoveAssociationFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RemoveAssociationFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest";
                        };
    
                        return RemoveAssociationFirewallPolicyRequest;
                    })();
    
                    v1.RemoveAssociationNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a RemoveAssociationNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRemoveAssociationNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] RemoveAssociationNetworkFirewallPolicyRequest firewallPolicy
                         * @property {string|null} [name] RemoveAssociationNetworkFirewallPolicyRequest name
                         * @property {string|null} [project] RemoveAssociationNetworkFirewallPolicyRequest project
                         * @property {string|null} [requestId] RemoveAssociationNetworkFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new RemoveAssociationNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RemoveAssociationNetworkFirewallPolicyRequest.
                         * @implements IRemoveAssociationNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRemoveAssociationNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function RemoveAssociationNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RemoveAssociationNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest
                         * @instance
                         */
                        RemoveAssociationNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * RemoveAssociationNetworkFirewallPolicyRequest name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest
                         * @instance
                         */
                        RemoveAssociationNetworkFirewallPolicyRequest.prototype.name = null;
    
                        /**
                         * RemoveAssociationNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest
                         * @instance
                         */
                        RemoveAssociationNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * RemoveAssociationNetworkFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest
                         * @instance
                         */
                        RemoveAssociationNetworkFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RemoveAssociationNetworkFirewallPolicyRequest _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(RemoveAssociationNetworkFirewallPolicyRequest.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RemoveAssociationNetworkFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(RemoveAssociationNetworkFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RemoveAssociationNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveAssociationNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest} RemoveAssociationNetworkFirewallPolicyRequest instance
                         */
                        RemoveAssociationNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new RemoveAssociationNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RemoveAssociationNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveAssociationNetworkFirewallPolicyRequest} message RemoveAssociationNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveAssociationNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RemoveAssociationNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveAssociationNetworkFirewallPolicyRequest} message RemoveAssociationNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveAssociationNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RemoveAssociationNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest} RemoveAssociationNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveAssociationNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RemoveAssociationNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest} RemoveAssociationNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveAssociationNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RemoveAssociationNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RemoveAssociationNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RemoveAssociationNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest} RemoveAssociationNetworkFirewallPolicyRequest
                         */
                        RemoveAssociationNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RemoveAssociationNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest} message RemoveAssociationNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RemoveAssociationNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.firewallPolicy = "";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this RemoveAssociationNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RemoveAssociationNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RemoveAssociationNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RemoveAssociationNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest";
                        };
    
                        return RemoveAssociationNetworkFirewallPolicyRequest;
                    })();
    
                    v1.RemoveAssociationRegionNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a RemoveAssociationRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] RemoveAssociationRegionNetworkFirewallPolicyRequest firewallPolicy
                         * @property {string|null} [name] RemoveAssociationRegionNetworkFirewallPolicyRequest name
                         * @property {string|null} [project] RemoveAssociationRegionNetworkFirewallPolicyRequest project
                         * @property {string|null} [region] RemoveAssociationRegionNetworkFirewallPolicyRequest region
                         * @property {string|null} [requestId] RemoveAssociationRegionNetworkFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new RemoveAssociationRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RemoveAssociationRegionNetworkFirewallPolicyRequest.
                         * @implements IRemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRemoveAssociationRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function RemoveAssociationRegionNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RemoveAssociationRegionNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        RemoveAssociationRegionNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * RemoveAssociationRegionNetworkFirewallPolicyRequest name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        RemoveAssociationRegionNetworkFirewallPolicyRequest.prototype.name = null;
    
                        /**
                         * RemoveAssociationRegionNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        RemoveAssociationRegionNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * RemoveAssociationRegionNetworkFirewallPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        RemoveAssociationRegionNetworkFirewallPolicyRequest.prototype.region = "";
    
                        /**
                         * RemoveAssociationRegionNetworkFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        RemoveAssociationRegionNetworkFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RemoveAssociationRegionNetworkFirewallPolicyRequest _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(RemoveAssociationRegionNetworkFirewallPolicyRequest.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RemoveAssociationRegionNetworkFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(RemoveAssociationRegionNetworkFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RemoveAssociationRegionNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveAssociationRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest} RemoveAssociationRegionNetworkFirewallPolicyRequest instance
                         */
                        RemoveAssociationRegionNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new RemoveAssociationRegionNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RemoveAssociationRegionNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveAssociationRegionNetworkFirewallPolicyRequest} message RemoveAssociationRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveAssociationRegionNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RemoveAssociationRegionNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveAssociationRegionNetworkFirewallPolicyRequest} message RemoveAssociationRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveAssociationRegionNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RemoveAssociationRegionNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest} RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveAssociationRegionNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RemoveAssociationRegionNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest} RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveAssociationRegionNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RemoveAssociationRegionNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RemoveAssociationRegionNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RemoveAssociationRegionNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest} RemoveAssociationRegionNetworkFirewallPolicyRequest
                         */
                        RemoveAssociationRegionNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RemoveAssociationRegionNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest} message RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RemoveAssociationRegionNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.firewallPolicy = "";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this RemoveAssociationRegionNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RemoveAssociationRegionNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RemoveAssociationRegionNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest";
                        };
    
                        return RemoveAssociationRegionNetworkFirewallPolicyRequest;
                    })();
    
                    v1.RemoveHealthCheckTargetPoolRequest = (function() {
    
                        /**
                         * Properties of a RemoveHealthCheckTargetPoolRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRemoveHealthCheckTargetPoolRequest
                         * @property {string|null} [project] RemoveHealthCheckTargetPoolRequest project
                         * @property {string|null} [region] RemoveHealthCheckTargetPoolRequest region
                         * @property {string|null} [requestId] RemoveHealthCheckTargetPoolRequest requestId
                         * @property {string|null} [targetPool] RemoveHealthCheckTargetPoolRequest targetPool
                         * @property {google.cloud.compute.v1.ITargetPoolsRemoveHealthCheckRequest|null} [targetPoolsRemoveHealthCheckRequestResource] RemoveHealthCheckTargetPoolRequest targetPoolsRemoveHealthCheckRequestResource
                         */
    
                        /**
                         * Constructs a new RemoveHealthCheckTargetPoolRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RemoveHealthCheckTargetPoolRequest.
                         * @implements IRemoveHealthCheckTargetPoolRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRemoveHealthCheckTargetPoolRequest=} [properties] Properties to set
                         */
                        function RemoveHealthCheckTargetPoolRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RemoveHealthCheckTargetPoolRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest
                         * @instance
                         */
                        RemoveHealthCheckTargetPoolRequest.prototype.project = "";
    
                        /**
                         * RemoveHealthCheckTargetPoolRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest
                         * @instance
                         */
                        RemoveHealthCheckTargetPoolRequest.prototype.region = "";
    
                        /**
                         * RemoveHealthCheckTargetPoolRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest
                         * @instance
                         */
                        RemoveHealthCheckTargetPoolRequest.prototype.requestId = null;
    
                        /**
                         * RemoveHealthCheckTargetPoolRequest targetPool.
                         * @member {string} targetPool
                         * @memberof google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest
                         * @instance
                         */
                        RemoveHealthCheckTargetPoolRequest.prototype.targetPool = "";
    
                        /**
                         * RemoveHealthCheckTargetPoolRequest targetPoolsRemoveHealthCheckRequestResource.
                         * @member {google.cloud.compute.v1.ITargetPoolsRemoveHealthCheckRequest|null|undefined} targetPoolsRemoveHealthCheckRequestResource
                         * @memberof google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest
                         * @instance
                         */
                        RemoveHealthCheckTargetPoolRequest.prototype.targetPoolsRemoveHealthCheckRequestResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RemoveHealthCheckTargetPoolRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest
                         * @instance
                         */
                        Object.defineProperty(RemoveHealthCheckTargetPoolRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RemoveHealthCheckTargetPoolRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveHealthCheckTargetPoolRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest} RemoveHealthCheckTargetPoolRequest instance
                         */
                        RemoveHealthCheckTargetPoolRequest.create = function create(properties) {
                            return new RemoveHealthCheckTargetPoolRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RemoveHealthCheckTargetPoolRequest message. Does not implicitly {@link google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveHealthCheckTargetPoolRequest} message RemoveHealthCheckTargetPoolRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveHealthCheckTargetPoolRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetPool != null && Object.hasOwnProperty.call(message, "targetPool"))
                                writer.uint32(/* id 62796298, wireType 2 =*/502370386).string(message.targetPool);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetPoolsRemoveHealthCheckRequestResource != null && Object.hasOwnProperty.call(message, "targetPoolsRemoveHealthCheckRequestResource"))
                                $root.google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest.encode(message.targetPoolsRemoveHealthCheckRequestResource, writer.uint32(/* id 304985011, wireType 2 =*/2439880090).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RemoveHealthCheckTargetPoolRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveHealthCheckTargetPoolRequest} message RemoveHealthCheckTargetPoolRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveHealthCheckTargetPoolRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RemoveHealthCheckTargetPoolRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest} RemoveHealthCheckTargetPoolRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveHealthCheckTargetPoolRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 62796298: {
                                        message.targetPool = reader.string();
                                        break;
                                    }
                                case 304985011: {
                                        message.targetPoolsRemoveHealthCheckRequestResource = $root.google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RemoveHealthCheckTargetPoolRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest} RemoveHealthCheckTargetPoolRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveHealthCheckTargetPoolRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RemoveHealthCheckTargetPoolRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RemoveHealthCheckTargetPoolRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetPool != null && message.hasOwnProperty("targetPool"))
                                if (!$util.isString(message.targetPool))
                                    return "targetPool: string expected";
                            if (message.targetPoolsRemoveHealthCheckRequestResource != null && message.hasOwnProperty("targetPoolsRemoveHealthCheckRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest.verify(message.targetPoolsRemoveHealthCheckRequestResource);
                                if (error)
                                    return "targetPoolsRemoveHealthCheckRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RemoveHealthCheckTargetPoolRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest} RemoveHealthCheckTargetPoolRequest
                         */
                        RemoveHealthCheckTargetPoolRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetPool != null)
                                message.targetPool = String(object.targetPool);
                            if (object.targetPoolsRemoveHealthCheckRequestResource != null) {
                                if (typeof object.targetPoolsRemoveHealthCheckRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest.targetPoolsRemoveHealthCheckRequestResource: object expected");
                                message.targetPoolsRemoveHealthCheckRequestResource = $root.google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest.fromObject(object.targetPoolsRemoveHealthCheckRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RemoveHealthCheckTargetPoolRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest} message RemoveHealthCheckTargetPoolRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RemoveHealthCheckTargetPoolRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetPool = "";
                                object.region = "";
                                object.project = "";
                                object.targetPoolsRemoveHealthCheckRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetPool != null && message.hasOwnProperty("targetPool"))
                                object.targetPool = message.targetPool;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetPoolsRemoveHealthCheckRequestResource != null && message.hasOwnProperty("targetPoolsRemoveHealthCheckRequestResource"))
                                object.targetPoolsRemoveHealthCheckRequestResource = $root.google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest.toObject(message.targetPoolsRemoveHealthCheckRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this RemoveHealthCheckTargetPoolRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RemoveHealthCheckTargetPoolRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RemoveHealthCheckTargetPoolRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RemoveHealthCheckTargetPoolRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest";
                        };
    
                        return RemoveHealthCheckTargetPoolRequest;
                    })();
    
                    v1.RemoveInstanceTargetPoolRequest = (function() {
    
                        /**
                         * Properties of a RemoveInstanceTargetPoolRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRemoveInstanceTargetPoolRequest
                         * @property {string|null} [project] RemoveInstanceTargetPoolRequest project
                         * @property {string|null} [region] RemoveInstanceTargetPoolRequest region
                         * @property {string|null} [requestId] RemoveInstanceTargetPoolRequest requestId
                         * @property {string|null} [targetPool] RemoveInstanceTargetPoolRequest targetPool
                         * @property {google.cloud.compute.v1.ITargetPoolsRemoveInstanceRequest|null} [targetPoolsRemoveInstanceRequestResource] RemoveInstanceTargetPoolRequest targetPoolsRemoveInstanceRequestResource
                         */
    
                        /**
                         * Constructs a new RemoveInstanceTargetPoolRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RemoveInstanceTargetPoolRequest.
                         * @implements IRemoveInstanceTargetPoolRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRemoveInstanceTargetPoolRequest=} [properties] Properties to set
                         */
                        function RemoveInstanceTargetPoolRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RemoveInstanceTargetPoolRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.RemoveInstanceTargetPoolRequest
                         * @instance
                         */
                        RemoveInstanceTargetPoolRequest.prototype.project = "";
    
                        /**
                         * RemoveInstanceTargetPoolRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.RemoveInstanceTargetPoolRequest
                         * @instance
                         */
                        RemoveInstanceTargetPoolRequest.prototype.region = "";
    
                        /**
                         * RemoveInstanceTargetPoolRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.RemoveInstanceTargetPoolRequest
                         * @instance
                         */
                        RemoveInstanceTargetPoolRequest.prototype.requestId = null;
    
                        /**
                         * RemoveInstanceTargetPoolRequest targetPool.
                         * @member {string} targetPool
                         * @memberof google.cloud.compute.v1.RemoveInstanceTargetPoolRequest
                         * @instance
                         */
                        RemoveInstanceTargetPoolRequest.prototype.targetPool = "";
    
                        /**
                         * RemoveInstanceTargetPoolRequest targetPoolsRemoveInstanceRequestResource.
                         * @member {google.cloud.compute.v1.ITargetPoolsRemoveInstanceRequest|null|undefined} targetPoolsRemoveInstanceRequestResource
                         * @memberof google.cloud.compute.v1.RemoveInstanceTargetPoolRequest
                         * @instance
                         */
                        RemoveInstanceTargetPoolRequest.prototype.targetPoolsRemoveInstanceRequestResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RemoveInstanceTargetPoolRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.RemoveInstanceTargetPoolRequest
                         * @instance
                         */
                        Object.defineProperty(RemoveInstanceTargetPoolRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RemoveInstanceTargetPoolRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RemoveInstanceTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveInstanceTargetPoolRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RemoveInstanceTargetPoolRequest} RemoveInstanceTargetPoolRequest instance
                         */
                        RemoveInstanceTargetPoolRequest.create = function create(properties) {
                            return new RemoveInstanceTargetPoolRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RemoveInstanceTargetPoolRequest message. Does not implicitly {@link google.cloud.compute.v1.RemoveInstanceTargetPoolRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RemoveInstanceTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveInstanceTargetPoolRequest} message RemoveInstanceTargetPoolRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveInstanceTargetPoolRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.targetPoolsRemoveInstanceRequestResource != null && Object.hasOwnProperty.call(message, "targetPoolsRemoveInstanceRequestResource"))
                                $root.google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest.encode(message.targetPoolsRemoveInstanceRequestResource, writer.uint32(/* id 29548547, wireType 2 =*/236388378).fork()).ldelim();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetPool != null && Object.hasOwnProperty.call(message, "targetPool"))
                                writer.uint32(/* id 62796298, wireType 2 =*/502370386).string(message.targetPool);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RemoveInstanceTargetPoolRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RemoveInstanceTargetPoolRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveInstanceTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveInstanceTargetPoolRequest} message RemoveInstanceTargetPoolRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveInstanceTargetPoolRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RemoveInstanceTargetPoolRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RemoveInstanceTargetPoolRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RemoveInstanceTargetPoolRequest} RemoveInstanceTargetPoolRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveInstanceTargetPoolRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RemoveInstanceTargetPoolRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 62796298: {
                                        message.targetPool = reader.string();
                                        break;
                                    }
                                case 29548547: {
                                        message.targetPoolsRemoveInstanceRequestResource = $root.google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RemoveInstanceTargetPoolRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveInstanceTargetPoolRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RemoveInstanceTargetPoolRequest} RemoveInstanceTargetPoolRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveInstanceTargetPoolRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RemoveInstanceTargetPoolRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RemoveInstanceTargetPoolRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RemoveInstanceTargetPoolRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetPool != null && message.hasOwnProperty("targetPool"))
                                if (!$util.isString(message.targetPool))
                                    return "targetPool: string expected";
                            if (message.targetPoolsRemoveInstanceRequestResource != null && message.hasOwnProperty("targetPoolsRemoveInstanceRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest.verify(message.targetPoolsRemoveInstanceRequestResource);
                                if (error)
                                    return "targetPoolsRemoveInstanceRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RemoveInstanceTargetPoolRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RemoveInstanceTargetPoolRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RemoveInstanceTargetPoolRequest} RemoveInstanceTargetPoolRequest
                         */
                        RemoveInstanceTargetPoolRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RemoveInstanceTargetPoolRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RemoveInstanceTargetPoolRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetPool != null)
                                message.targetPool = String(object.targetPool);
                            if (object.targetPoolsRemoveInstanceRequestResource != null) {
                                if (typeof object.targetPoolsRemoveInstanceRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RemoveInstanceTargetPoolRequest.targetPoolsRemoveInstanceRequestResource: object expected");
                                message.targetPoolsRemoveInstanceRequestResource = $root.google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest.fromObject(object.targetPoolsRemoveInstanceRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RemoveInstanceTargetPoolRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RemoveInstanceTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.RemoveInstanceTargetPoolRequest} message RemoveInstanceTargetPoolRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RemoveInstanceTargetPoolRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetPoolsRemoveInstanceRequestResource = null;
                                object.targetPool = "";
                                object.region = "";
                                object.project = "";
                            }
                            if (message.targetPoolsRemoveInstanceRequestResource != null && message.hasOwnProperty("targetPoolsRemoveInstanceRequestResource"))
                                object.targetPoolsRemoveInstanceRequestResource = $root.google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest.toObject(message.targetPoolsRemoveInstanceRequestResource, options);
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetPool != null && message.hasOwnProperty("targetPool"))
                                object.targetPool = message.targetPool;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this RemoveInstanceTargetPoolRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RemoveInstanceTargetPoolRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RemoveInstanceTargetPoolRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RemoveInstanceTargetPoolRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RemoveInstanceTargetPoolRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RemoveInstanceTargetPoolRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RemoveInstanceTargetPoolRequest";
                        };
    
                        return RemoveInstanceTargetPoolRequest;
                    })();
    
                    v1.RemoveInstancesInstanceGroupRequest = (function() {
    
                        /**
                         * Properties of a RemoveInstancesInstanceGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRemoveInstancesInstanceGroupRequest
                         * @property {string|null} [instanceGroup] RemoveInstancesInstanceGroupRequest instanceGroup
                         * @property {google.cloud.compute.v1.IInstanceGroupsRemoveInstancesRequest|null} [instanceGroupsRemoveInstancesRequestResource] RemoveInstancesInstanceGroupRequest instanceGroupsRemoveInstancesRequestResource
                         * @property {string|null} [project] RemoveInstancesInstanceGroupRequest project
                         * @property {string|null} [requestId] RemoveInstancesInstanceGroupRequest requestId
                         * @property {string|null} [zone] RemoveInstancesInstanceGroupRequest zone
                         */
    
                        /**
                         * Constructs a new RemoveInstancesInstanceGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RemoveInstancesInstanceGroupRequest.
                         * @implements IRemoveInstancesInstanceGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRemoveInstancesInstanceGroupRequest=} [properties] Properties to set
                         */
                        function RemoveInstancesInstanceGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RemoveInstancesInstanceGroupRequest instanceGroup.
                         * @member {string} instanceGroup
                         * @memberof google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest
                         * @instance
                         */
                        RemoveInstancesInstanceGroupRequest.prototype.instanceGroup = "";
    
                        /**
                         * RemoveInstancesInstanceGroupRequest instanceGroupsRemoveInstancesRequestResource.
                         * @member {google.cloud.compute.v1.IInstanceGroupsRemoveInstancesRequest|null|undefined} instanceGroupsRemoveInstancesRequestResource
                         * @memberof google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest
                         * @instance
                         */
                        RemoveInstancesInstanceGroupRequest.prototype.instanceGroupsRemoveInstancesRequestResource = null;
    
                        /**
                         * RemoveInstancesInstanceGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest
                         * @instance
                         */
                        RemoveInstancesInstanceGroupRequest.prototype.project = "";
    
                        /**
                         * RemoveInstancesInstanceGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest
                         * @instance
                         */
                        RemoveInstancesInstanceGroupRequest.prototype.requestId = null;
    
                        /**
                         * RemoveInstancesInstanceGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest
                         * @instance
                         */
                        RemoveInstancesInstanceGroupRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RemoveInstancesInstanceGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest
                         * @instance
                         */
                        Object.defineProperty(RemoveInstancesInstanceGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RemoveInstancesInstanceGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveInstancesInstanceGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest} RemoveInstancesInstanceGroupRequest instance
                         */
                        RemoveInstancesInstanceGroupRequest.create = function create(properties) {
                            return new RemoveInstancesInstanceGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RemoveInstancesInstanceGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveInstancesInstanceGroupRequest} message RemoveInstancesInstanceGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveInstancesInstanceGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.instanceGroup != null && Object.hasOwnProperty.call(message, "instanceGroup"))
                                writer.uint32(/* id 81095253, wireType 2 =*/648762026).string(message.instanceGroup);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupsRemoveInstancesRequestResource != null && Object.hasOwnProperty.call(message, "instanceGroupsRemoveInstancesRequestResource"))
                                $root.google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest.encode(message.instanceGroupsRemoveInstancesRequestResource, writer.uint32(/* id 390981817, wireType 2 =*/3127854538).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RemoveInstancesInstanceGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveInstancesInstanceGroupRequest} message RemoveInstancesInstanceGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveInstancesInstanceGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RemoveInstancesInstanceGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest} RemoveInstancesInstanceGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveInstancesInstanceGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 81095253: {
                                        message.instanceGroup = reader.string();
                                        break;
                                    }
                                case 390981817: {
                                        message.instanceGroupsRemoveInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RemoveInstancesInstanceGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest} RemoveInstancesInstanceGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveInstancesInstanceGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RemoveInstancesInstanceGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RemoveInstancesInstanceGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroup != null && message.hasOwnProperty("instanceGroup"))
                                if (!$util.isString(message.instanceGroup))
                                    return "instanceGroup: string expected";
                            if (message.instanceGroupsRemoveInstancesRequestResource != null && message.hasOwnProperty("instanceGroupsRemoveInstancesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest.verify(message.instanceGroupsRemoveInstancesRequestResource);
                                if (error)
                                    return "instanceGroupsRemoveInstancesRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a RemoveInstancesInstanceGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest} RemoveInstancesInstanceGroupRequest
                         */
                        RemoveInstancesInstanceGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest();
                            if (object.instanceGroup != null)
                                message.instanceGroup = String(object.instanceGroup);
                            if (object.instanceGroupsRemoveInstancesRequestResource != null) {
                                if (typeof object.instanceGroupsRemoveInstancesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest.instanceGroupsRemoveInstancesRequestResource: object expected");
                                message.instanceGroupsRemoveInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest.fromObject(object.instanceGroupsRemoveInstancesRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RemoveInstancesInstanceGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest} message RemoveInstancesInstanceGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RemoveInstancesInstanceGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instanceGroup = "";
                                object.project = "";
                                object.instanceGroupsRemoveInstancesRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.instanceGroup != null && message.hasOwnProperty("instanceGroup"))
                                object.instanceGroup = message.instanceGroup;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupsRemoveInstancesRequestResource != null && message.hasOwnProperty("instanceGroupsRemoveInstancesRequestResource"))
                                object.instanceGroupsRemoveInstancesRequestResource = $root.google.cloud.compute.v1.InstanceGroupsRemoveInstancesRequest.toObject(message.instanceGroupsRemoveInstancesRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this RemoveInstancesInstanceGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RemoveInstancesInstanceGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RemoveInstancesInstanceGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RemoveInstancesInstanceGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest";
                        };
    
                        return RemoveInstancesInstanceGroupRequest;
                    })();
    
                    v1.RemovePeeringNetworkRequest = (function() {
    
                        /**
                         * Properties of a RemovePeeringNetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRemovePeeringNetworkRequest
                         * @property {string|null} [network] RemovePeeringNetworkRequest network
                         * @property {google.cloud.compute.v1.INetworksRemovePeeringRequest|null} [networksRemovePeeringRequestResource] RemovePeeringNetworkRequest networksRemovePeeringRequestResource
                         * @property {string|null} [project] RemovePeeringNetworkRequest project
                         * @property {string|null} [requestId] RemovePeeringNetworkRequest requestId
                         */
    
                        /**
                         * Constructs a new RemovePeeringNetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RemovePeeringNetworkRequest.
                         * @implements IRemovePeeringNetworkRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRemovePeeringNetworkRequest=} [properties] Properties to set
                         */
                        function RemovePeeringNetworkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RemovePeeringNetworkRequest network.
                         * @member {string} network
                         * @memberof google.cloud.compute.v1.RemovePeeringNetworkRequest
                         * @instance
                         */
                        RemovePeeringNetworkRequest.prototype.network = "";
    
                        /**
                         * RemovePeeringNetworkRequest networksRemovePeeringRequestResource.
                         * @member {google.cloud.compute.v1.INetworksRemovePeeringRequest|null|undefined} networksRemovePeeringRequestResource
                         * @memberof google.cloud.compute.v1.RemovePeeringNetworkRequest
                         * @instance
                         */
                        RemovePeeringNetworkRequest.prototype.networksRemovePeeringRequestResource = null;
    
                        /**
                         * RemovePeeringNetworkRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.RemovePeeringNetworkRequest
                         * @instance
                         */
                        RemovePeeringNetworkRequest.prototype.project = "";
    
                        /**
                         * RemovePeeringNetworkRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.RemovePeeringNetworkRequest
                         * @instance
                         */
                        RemovePeeringNetworkRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RemovePeeringNetworkRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.RemovePeeringNetworkRequest
                         * @instance
                         */
                        Object.defineProperty(RemovePeeringNetworkRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RemovePeeringNetworkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RemovePeeringNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemovePeeringNetworkRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RemovePeeringNetworkRequest} RemovePeeringNetworkRequest instance
                         */
                        RemovePeeringNetworkRequest.create = function create(properties) {
                            return new RemovePeeringNetworkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RemovePeeringNetworkRequest message. Does not implicitly {@link google.cloud.compute.v1.RemovePeeringNetworkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RemovePeeringNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemovePeeringNetworkRequest} message RemovePeeringNetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemovePeeringNetworkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            if (message.networksRemovePeeringRequestResource != null && Object.hasOwnProperty.call(message, "networksRemovePeeringRequestResource"))
                                $root.google.cloud.compute.v1.NetworksRemovePeeringRequest.encode(message.networksRemovePeeringRequestResource, writer.uint32(/* id 421162494, wireType 2 =*/3369299954).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RemovePeeringNetworkRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RemovePeeringNetworkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RemovePeeringNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemovePeeringNetworkRequest} message RemovePeeringNetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemovePeeringNetworkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RemovePeeringNetworkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RemovePeeringNetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RemovePeeringNetworkRequest} RemovePeeringNetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemovePeeringNetworkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RemovePeeringNetworkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 421162494: {
                                        message.networksRemovePeeringRequestResource = $root.google.cloud.compute.v1.NetworksRemovePeeringRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RemovePeeringNetworkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RemovePeeringNetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RemovePeeringNetworkRequest} RemovePeeringNetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemovePeeringNetworkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RemovePeeringNetworkRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RemovePeeringNetworkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RemovePeeringNetworkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.network != null && message.hasOwnProperty("network"))
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            if (message.networksRemovePeeringRequestResource != null && message.hasOwnProperty("networksRemovePeeringRequestResource")) {
                                var error = $root.google.cloud.compute.v1.NetworksRemovePeeringRequest.verify(message.networksRemovePeeringRequestResource);
                                if (error)
                                    return "networksRemovePeeringRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RemovePeeringNetworkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RemovePeeringNetworkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RemovePeeringNetworkRequest} RemovePeeringNetworkRequest
                         */
                        RemovePeeringNetworkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RemovePeeringNetworkRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RemovePeeringNetworkRequest();
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.networksRemovePeeringRequestResource != null) {
                                if (typeof object.networksRemovePeeringRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RemovePeeringNetworkRequest.networksRemovePeeringRequestResource: object expected");
                                message.networksRemovePeeringRequestResource = $root.google.cloud.compute.v1.NetworksRemovePeeringRequest.fromObject(object.networksRemovePeeringRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RemovePeeringNetworkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RemovePeeringNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.RemovePeeringNetworkRequest} message RemovePeeringNetworkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RemovePeeringNetworkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.network = "";
                                object.networksRemovePeeringRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.network != null && message.hasOwnProperty("network"))
                                object.network = message.network;
                            if (message.networksRemovePeeringRequestResource != null && message.hasOwnProperty("networksRemovePeeringRequestResource"))
                                object.networksRemovePeeringRequestResource = $root.google.cloud.compute.v1.NetworksRemovePeeringRequest.toObject(message.networksRemovePeeringRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this RemovePeeringNetworkRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RemovePeeringNetworkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RemovePeeringNetworkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RemovePeeringNetworkRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RemovePeeringNetworkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RemovePeeringNetworkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RemovePeeringNetworkRequest";
                        };
    
                        return RemovePeeringNetworkRequest;
                    })();
    
                    v1.RemoveResourcePoliciesDiskRequest = (function() {
    
                        /**
                         * Properties of a RemoveResourcePoliciesDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRemoveResourcePoliciesDiskRequest
                         * @property {string|null} [disk] RemoveResourcePoliciesDiskRequest disk
                         * @property {google.cloud.compute.v1.IDisksRemoveResourcePoliciesRequest|null} [disksRemoveResourcePoliciesRequestResource] RemoveResourcePoliciesDiskRequest disksRemoveResourcePoliciesRequestResource
                         * @property {string|null} [project] RemoveResourcePoliciesDiskRequest project
                         * @property {string|null} [requestId] RemoveResourcePoliciesDiskRequest requestId
                         * @property {string|null} [zone] RemoveResourcePoliciesDiskRequest zone
                         */
    
                        /**
                         * Constructs a new RemoveResourcePoliciesDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RemoveResourcePoliciesDiskRequest.
                         * @implements IRemoveResourcePoliciesDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRemoveResourcePoliciesDiskRequest=} [properties] Properties to set
                         */
                        function RemoveResourcePoliciesDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RemoveResourcePoliciesDiskRequest disk.
                         * @member {string} disk
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest
                         * @instance
                         */
                        RemoveResourcePoliciesDiskRequest.prototype.disk = "";
    
                        /**
                         * RemoveResourcePoliciesDiskRequest disksRemoveResourcePoliciesRequestResource.
                         * @member {google.cloud.compute.v1.IDisksRemoveResourcePoliciesRequest|null|undefined} disksRemoveResourcePoliciesRequestResource
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest
                         * @instance
                         */
                        RemoveResourcePoliciesDiskRequest.prototype.disksRemoveResourcePoliciesRequestResource = null;
    
                        /**
                         * RemoveResourcePoliciesDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest
                         * @instance
                         */
                        RemoveResourcePoliciesDiskRequest.prototype.project = "";
    
                        /**
                         * RemoveResourcePoliciesDiskRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest
                         * @instance
                         */
                        RemoveResourcePoliciesDiskRequest.prototype.requestId = null;
    
                        /**
                         * RemoveResourcePoliciesDiskRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest
                         * @instance
                         */
                        RemoveResourcePoliciesDiskRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RemoveResourcePoliciesDiskRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest
                         * @instance
                         */
                        Object.defineProperty(RemoveResourcePoliciesDiskRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RemoveResourcePoliciesDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveResourcePoliciesDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest} RemoveResourcePoliciesDiskRequest instance
                         */
                        RemoveResourcePoliciesDiskRequest.create = function create(properties) {
                            return new RemoveResourcePoliciesDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RemoveResourcePoliciesDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveResourcePoliciesDiskRequest} message RemoveResourcePoliciesDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveResourcePoliciesDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.disk != null && Object.hasOwnProperty.call(message, "disk"))
                                writer.uint32(/* id 3083677, wireType 2 =*/24669418).string(message.disk);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.disksRemoveResourcePoliciesRequestResource != null && Object.hasOwnProperty.call(message, "disksRemoveResourcePoliciesRequestResource"))
                                $root.google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest.encode(message.disksRemoveResourcePoliciesRequestResource, writer.uint32(/* id 436756718, wireType 2 =*/3494053746).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RemoveResourcePoliciesDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveResourcePoliciesDiskRequest} message RemoveResourcePoliciesDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveResourcePoliciesDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RemoveResourcePoliciesDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest} RemoveResourcePoliciesDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveResourcePoliciesDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3083677: {
                                        message.disk = reader.string();
                                        break;
                                    }
                                case 436756718: {
                                        message.disksRemoveResourcePoliciesRequestResource = $root.google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RemoveResourcePoliciesDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest} RemoveResourcePoliciesDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveResourcePoliciesDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RemoveResourcePoliciesDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RemoveResourcePoliciesDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                if (!$util.isString(message.disk))
                                    return "disk: string expected";
                            if (message.disksRemoveResourcePoliciesRequestResource != null && message.hasOwnProperty("disksRemoveResourcePoliciesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest.verify(message.disksRemoveResourcePoliciesRequestResource);
                                if (error)
                                    return "disksRemoveResourcePoliciesRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a RemoveResourcePoliciesDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest} RemoveResourcePoliciesDiskRequest
                         */
                        RemoveResourcePoliciesDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest();
                            if (object.disk != null)
                                message.disk = String(object.disk);
                            if (object.disksRemoveResourcePoliciesRequestResource != null) {
                                if (typeof object.disksRemoveResourcePoliciesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest.disksRemoveResourcePoliciesRequestResource: object expected");
                                message.disksRemoveResourcePoliciesRequestResource = $root.google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest.fromObject(object.disksRemoveResourcePoliciesRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RemoveResourcePoliciesDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest} message RemoveResourcePoliciesDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RemoveResourcePoliciesDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.disk = "";
                                object.zone = "";
                                object.project = "";
                                object.disksRemoveResourcePoliciesRequestResource = null;
                            }
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                object.disk = message.disk;
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.disksRemoveResourcePoliciesRequestResource != null && message.hasOwnProperty("disksRemoveResourcePoliciesRequestResource"))
                                object.disksRemoveResourcePoliciesRequestResource = $root.google.cloud.compute.v1.DisksRemoveResourcePoliciesRequest.toObject(message.disksRemoveResourcePoliciesRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this RemoveResourcePoliciesDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RemoveResourcePoliciesDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RemoveResourcePoliciesDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RemoveResourcePoliciesDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest";
                        };
    
                        return RemoveResourcePoliciesDiskRequest;
                    })();
    
                    v1.RemoveResourcePoliciesInstanceRequest = (function() {
    
                        /**
                         * Properties of a RemoveResourcePoliciesInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRemoveResourcePoliciesInstanceRequest
                         * @property {string|null} [instance] RemoveResourcePoliciesInstanceRequest instance
                         * @property {google.cloud.compute.v1.IInstancesRemoveResourcePoliciesRequest|null} [instancesRemoveResourcePoliciesRequestResource] RemoveResourcePoliciesInstanceRequest instancesRemoveResourcePoliciesRequestResource
                         * @property {string|null} [project] RemoveResourcePoliciesInstanceRequest project
                         * @property {string|null} [requestId] RemoveResourcePoliciesInstanceRequest requestId
                         * @property {string|null} [zone] RemoveResourcePoliciesInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new RemoveResourcePoliciesInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RemoveResourcePoliciesInstanceRequest.
                         * @implements IRemoveResourcePoliciesInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRemoveResourcePoliciesInstanceRequest=} [properties] Properties to set
                         */
                        function RemoveResourcePoliciesInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RemoveResourcePoliciesInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest
                         * @instance
                         */
                        RemoveResourcePoliciesInstanceRequest.prototype.instance = "";
    
                        /**
                         * RemoveResourcePoliciesInstanceRequest instancesRemoveResourcePoliciesRequestResource.
                         * @member {google.cloud.compute.v1.IInstancesRemoveResourcePoliciesRequest|null|undefined} instancesRemoveResourcePoliciesRequestResource
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest
                         * @instance
                         */
                        RemoveResourcePoliciesInstanceRequest.prototype.instancesRemoveResourcePoliciesRequestResource = null;
    
                        /**
                         * RemoveResourcePoliciesInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest
                         * @instance
                         */
                        RemoveResourcePoliciesInstanceRequest.prototype.project = "";
    
                        /**
                         * RemoveResourcePoliciesInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest
                         * @instance
                         */
                        RemoveResourcePoliciesInstanceRequest.prototype.requestId = null;
    
                        /**
                         * RemoveResourcePoliciesInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest
                         * @instance
                         */
                        RemoveResourcePoliciesInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RemoveResourcePoliciesInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(RemoveResourcePoliciesInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RemoveResourcePoliciesInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveResourcePoliciesInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest} RemoveResourcePoliciesInstanceRequest instance
                         */
                        RemoveResourcePoliciesInstanceRequest.create = function create(properties) {
                            return new RemoveResourcePoliciesInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RemoveResourcePoliciesInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveResourcePoliciesInstanceRequest} message RemoveResourcePoliciesInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveResourcePoliciesInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.instancesRemoveResourcePoliciesRequestResource != null && Object.hasOwnProperty.call(message, "instancesRemoveResourcePoliciesRequestResource"))
                                $root.google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest.encode(message.instancesRemoveResourcePoliciesRequestResource, writer.uint32(/* id 49229558, wireType 2 =*/393836466).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RemoveResourcePoliciesInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveResourcePoliciesInstanceRequest} message RemoveResourcePoliciesInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveResourcePoliciesInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RemoveResourcePoliciesInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest} RemoveResourcePoliciesInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveResourcePoliciesInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 49229558: {
                                        message.instancesRemoveResourcePoliciesRequestResource = $root.google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RemoveResourcePoliciesInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest} RemoveResourcePoliciesInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveResourcePoliciesInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RemoveResourcePoliciesInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RemoveResourcePoliciesInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.instancesRemoveResourcePoliciesRequestResource != null && message.hasOwnProperty("instancesRemoveResourcePoliciesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest.verify(message.instancesRemoveResourcePoliciesRequestResource);
                                if (error)
                                    return "instancesRemoveResourcePoliciesRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a RemoveResourcePoliciesInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest} RemoveResourcePoliciesInstanceRequest
                         */
                        RemoveResourcePoliciesInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.instancesRemoveResourcePoliciesRequestResource != null) {
                                if (typeof object.instancesRemoveResourcePoliciesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest.instancesRemoveResourcePoliciesRequestResource: object expected");
                                message.instancesRemoveResourcePoliciesRequestResource = $root.google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest.fromObject(object.instancesRemoveResourcePoliciesRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RemoveResourcePoliciesInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest} message RemoveResourcePoliciesInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RemoveResourcePoliciesInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.instancesRemoveResourcePoliciesRequestResource = null;
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.instancesRemoveResourcePoliciesRequestResource != null && message.hasOwnProperty("instancesRemoveResourcePoliciesRequestResource"))
                                object.instancesRemoveResourcePoliciesRequestResource = $root.google.cloud.compute.v1.InstancesRemoveResourcePoliciesRequest.toObject(message.instancesRemoveResourcePoliciesRequestResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this RemoveResourcePoliciesInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RemoveResourcePoliciesInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RemoveResourcePoliciesInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RemoveResourcePoliciesInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest";
                        };
    
                        return RemoveResourcePoliciesInstanceRequest;
                    })();
    
                    v1.RemoveResourcePoliciesRegionDiskRequest = (function() {
    
                        /**
                         * Properties of a RemoveResourcePoliciesRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRemoveResourcePoliciesRegionDiskRequest
                         * @property {string|null} [disk] RemoveResourcePoliciesRegionDiskRequest disk
                         * @property {string|null} [project] RemoveResourcePoliciesRegionDiskRequest project
                         * @property {string|null} [region] RemoveResourcePoliciesRegionDiskRequest region
                         * @property {google.cloud.compute.v1.IRegionDisksRemoveResourcePoliciesRequest|null} [regionDisksRemoveResourcePoliciesRequestResource] RemoveResourcePoliciesRegionDiskRequest regionDisksRemoveResourcePoliciesRequestResource
                         * @property {string|null} [requestId] RemoveResourcePoliciesRegionDiskRequest requestId
                         */
    
                        /**
                         * Constructs a new RemoveResourcePoliciesRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RemoveResourcePoliciesRegionDiskRequest.
                         * @implements IRemoveResourcePoliciesRegionDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRemoveResourcePoliciesRegionDiskRequest=} [properties] Properties to set
                         */
                        function RemoveResourcePoliciesRegionDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RemoveResourcePoliciesRegionDiskRequest disk.
                         * @member {string} disk
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest
                         * @instance
                         */
                        RemoveResourcePoliciesRegionDiskRequest.prototype.disk = "";
    
                        /**
                         * RemoveResourcePoliciesRegionDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest
                         * @instance
                         */
                        RemoveResourcePoliciesRegionDiskRequest.prototype.project = "";
    
                        /**
                         * RemoveResourcePoliciesRegionDiskRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest
                         * @instance
                         */
                        RemoveResourcePoliciesRegionDiskRequest.prototype.region = "";
    
                        /**
                         * RemoveResourcePoliciesRegionDiskRequest regionDisksRemoveResourcePoliciesRequestResource.
                         * @member {google.cloud.compute.v1.IRegionDisksRemoveResourcePoliciesRequest|null|undefined} regionDisksRemoveResourcePoliciesRequestResource
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest
                         * @instance
                         */
                        RemoveResourcePoliciesRegionDiskRequest.prototype.regionDisksRemoveResourcePoliciesRequestResource = null;
    
                        /**
                         * RemoveResourcePoliciesRegionDiskRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest
                         * @instance
                         */
                        RemoveResourcePoliciesRegionDiskRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RemoveResourcePoliciesRegionDiskRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest
                         * @instance
                         */
                        Object.defineProperty(RemoveResourcePoliciesRegionDiskRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RemoveResourcePoliciesRegionDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveResourcePoliciesRegionDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest} RemoveResourcePoliciesRegionDiskRequest instance
                         */
                        RemoveResourcePoliciesRegionDiskRequest.create = function create(properties) {
                            return new RemoveResourcePoliciesRegionDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RemoveResourcePoliciesRegionDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveResourcePoliciesRegionDiskRequest} message RemoveResourcePoliciesRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveResourcePoliciesRegionDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.disk != null && Object.hasOwnProperty.call(message, "disk"))
                                writer.uint32(/* id 3083677, wireType 2 =*/24669418).string(message.disk);
                            if (message.regionDisksRemoveResourcePoliciesRequestResource != null && Object.hasOwnProperty.call(message, "regionDisksRemoveResourcePoliciesRequestResource"))
                                $root.google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest.encode(message.regionDisksRemoveResourcePoliciesRequestResource, writer.uint32(/* id 8741283, wireType 2 =*/69930266).fork()).ldelim();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RemoveResourcePoliciesRegionDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveResourcePoliciesRegionDiskRequest} message RemoveResourcePoliciesRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveResourcePoliciesRegionDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RemoveResourcePoliciesRegionDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest} RemoveResourcePoliciesRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveResourcePoliciesRegionDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3083677: {
                                        message.disk = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 8741283: {
                                        message.regionDisksRemoveResourcePoliciesRequestResource = $root.google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RemoveResourcePoliciesRegionDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest} RemoveResourcePoliciesRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveResourcePoliciesRegionDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RemoveResourcePoliciesRegionDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RemoveResourcePoliciesRegionDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                if (!$util.isString(message.disk))
                                    return "disk: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionDisksRemoveResourcePoliciesRequestResource != null && message.hasOwnProperty("regionDisksRemoveResourcePoliciesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest.verify(message.regionDisksRemoveResourcePoliciesRequestResource);
                                if (error)
                                    return "regionDisksRemoveResourcePoliciesRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RemoveResourcePoliciesRegionDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest} RemoveResourcePoliciesRegionDiskRequest
                         */
                        RemoveResourcePoliciesRegionDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest();
                            if (object.disk != null)
                                message.disk = String(object.disk);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionDisksRemoveResourcePoliciesRequestResource != null) {
                                if (typeof object.regionDisksRemoveResourcePoliciesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest.regionDisksRemoveResourcePoliciesRequestResource: object expected");
                                message.regionDisksRemoveResourcePoliciesRequestResource = $root.google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest.fromObject(object.regionDisksRemoveResourcePoliciesRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RemoveResourcePoliciesRegionDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest} message RemoveResourcePoliciesRegionDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RemoveResourcePoliciesRegionDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.disk = "";
                                object.regionDisksRemoveResourcePoliciesRequestResource = null;
                                object.region = "";
                                object.project = "";
                            }
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                object.disk = message.disk;
                            if (message.regionDisksRemoveResourcePoliciesRequestResource != null && message.hasOwnProperty("regionDisksRemoveResourcePoliciesRequestResource"))
                                object.regionDisksRemoveResourcePoliciesRequestResource = $root.google.cloud.compute.v1.RegionDisksRemoveResourcePoliciesRequest.toObject(message.regionDisksRemoveResourcePoliciesRequestResource, options);
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this RemoveResourcePoliciesRegionDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RemoveResourcePoliciesRegionDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RemoveResourcePoliciesRegionDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RemoveResourcePoliciesRegionDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest";
                        };
    
                        return RemoveResourcePoliciesRegionDiskRequest;
                    })();
    
                    v1.RemoveRuleFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a RemoveRuleFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRemoveRuleFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] RemoveRuleFirewallPolicyRequest firewallPolicy
                         * @property {number|null} [priority] RemoveRuleFirewallPolicyRequest priority
                         * @property {string|null} [requestId] RemoveRuleFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new RemoveRuleFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RemoveRuleFirewallPolicyRequest.
                         * @implements IRemoveRuleFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRemoveRuleFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function RemoveRuleFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RemoveRuleFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest
                         * @instance
                         */
                        RemoveRuleFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * RemoveRuleFirewallPolicyRequest priority.
                         * @member {number|null|undefined} priority
                         * @memberof google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest
                         * @instance
                         */
                        RemoveRuleFirewallPolicyRequest.prototype.priority = null;
    
                        /**
                         * RemoveRuleFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest
                         * @instance
                         */
                        RemoveRuleFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RemoveRuleFirewallPolicyRequest _priority.
                         * @member {"priority"|undefined} _priority
                         * @memberof google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(RemoveRuleFirewallPolicyRequest.prototype, "_priority", {
                            get: $util.oneOfGetter($oneOfFields = ["priority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RemoveRuleFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(RemoveRuleFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RemoveRuleFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveRuleFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest} RemoveRuleFirewallPolicyRequest instance
                         */
                        RemoveRuleFirewallPolicyRequest.create = function create(properties) {
                            return new RemoveRuleFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RemoveRuleFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveRuleFirewallPolicyRequest} message RemoveRuleFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveRuleFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.priority != null && Object.hasOwnProperty.call(message, "priority"))
                                writer.uint32(/* id 445151652, wireType 0 =*/3561213216).int32(message.priority);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RemoveRuleFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveRuleFirewallPolicyRequest} message RemoveRuleFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveRuleFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RemoveRuleFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest} RemoveRuleFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveRuleFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 445151652: {
                                        message.priority = reader.int32();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RemoveRuleFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest} RemoveRuleFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveRuleFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RemoveRuleFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RemoveRuleFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                properties._priority = 1;
                                if (!$util.isInteger(message.priority))
                                    return "priority: integer expected";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RemoveRuleFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest} RemoveRuleFirewallPolicyRequest
                         */
                        RemoveRuleFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.priority != null)
                                message.priority = object.priority | 0;
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RemoveRuleFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest} message RemoveRuleFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RemoveRuleFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.firewallPolicy = "";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                object.priority = message.priority;
                                if (options.oneofs)
                                    object._priority = "priority";
                            }
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this RemoveRuleFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RemoveRuleFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RemoveRuleFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RemoveRuleFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest";
                        };
    
                        return RemoveRuleFirewallPolicyRequest;
                    })();
    
                    v1.RemoveRuleNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a RemoveRuleNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRemoveRuleNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] RemoveRuleNetworkFirewallPolicyRequest firewallPolicy
                         * @property {number|null} [priority] RemoveRuleNetworkFirewallPolicyRequest priority
                         * @property {string|null} [project] RemoveRuleNetworkFirewallPolicyRequest project
                         * @property {string|null} [requestId] RemoveRuleNetworkFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new RemoveRuleNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RemoveRuleNetworkFirewallPolicyRequest.
                         * @implements IRemoveRuleNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRemoveRuleNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function RemoveRuleNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RemoveRuleNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        RemoveRuleNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * RemoveRuleNetworkFirewallPolicyRequest priority.
                         * @member {number|null|undefined} priority
                         * @memberof google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        RemoveRuleNetworkFirewallPolicyRequest.prototype.priority = null;
    
                        /**
                         * RemoveRuleNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        RemoveRuleNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * RemoveRuleNetworkFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        RemoveRuleNetworkFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RemoveRuleNetworkFirewallPolicyRequest _priority.
                         * @member {"priority"|undefined} _priority
                         * @memberof google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(RemoveRuleNetworkFirewallPolicyRequest.prototype, "_priority", {
                            get: $util.oneOfGetter($oneOfFields = ["priority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RemoveRuleNetworkFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(RemoveRuleNetworkFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RemoveRuleNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveRuleNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest} RemoveRuleNetworkFirewallPolicyRequest instance
                         */
                        RemoveRuleNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new RemoveRuleNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RemoveRuleNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveRuleNetworkFirewallPolicyRequest} message RemoveRuleNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveRuleNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.priority != null && Object.hasOwnProperty.call(message, "priority"))
                                writer.uint32(/* id 445151652, wireType 0 =*/3561213216).int32(message.priority);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RemoveRuleNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveRuleNetworkFirewallPolicyRequest} message RemoveRuleNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveRuleNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RemoveRuleNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest} RemoveRuleNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveRuleNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 445151652: {
                                        message.priority = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RemoveRuleNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest} RemoveRuleNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveRuleNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RemoveRuleNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RemoveRuleNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                properties._priority = 1;
                                if (!$util.isInteger(message.priority))
                                    return "priority: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RemoveRuleNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest} RemoveRuleNetworkFirewallPolicyRequest
                         */
                        RemoveRuleNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.priority != null)
                                message.priority = object.priority | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RemoveRuleNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest} message RemoveRuleNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RemoveRuleNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.firewallPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                object.priority = message.priority;
                                if (options.oneofs)
                                    object._priority = "priority";
                            }
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this RemoveRuleNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RemoveRuleNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RemoveRuleNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RemoveRuleNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest";
                        };
    
                        return RemoveRuleNetworkFirewallPolicyRequest;
                    })();
    
                    v1.RemoveRuleRegionNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a RemoveRuleRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRemoveRuleRegionNetworkFirewallPolicyRequest
                         * @property {string|null} [firewallPolicy] RemoveRuleRegionNetworkFirewallPolicyRequest firewallPolicy
                         * @property {number|null} [priority] RemoveRuleRegionNetworkFirewallPolicyRequest priority
                         * @property {string|null} [project] RemoveRuleRegionNetworkFirewallPolicyRequest project
                         * @property {string|null} [region] RemoveRuleRegionNetworkFirewallPolicyRequest region
                         * @property {string|null} [requestId] RemoveRuleRegionNetworkFirewallPolicyRequest requestId
                         */
    
                        /**
                         * Constructs a new RemoveRuleRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RemoveRuleRegionNetworkFirewallPolicyRequest.
                         * @implements IRemoveRuleRegionNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRemoveRuleRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function RemoveRuleRegionNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RemoveRuleRegionNetworkFirewallPolicyRequest firewallPolicy.
                         * @member {string} firewallPolicy
                         * @memberof google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        RemoveRuleRegionNetworkFirewallPolicyRequest.prototype.firewallPolicy = "";
    
                        /**
                         * RemoveRuleRegionNetworkFirewallPolicyRequest priority.
                         * @member {number|null|undefined} priority
                         * @memberof google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        RemoveRuleRegionNetworkFirewallPolicyRequest.prototype.priority = null;
    
                        /**
                         * RemoveRuleRegionNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        RemoveRuleRegionNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * RemoveRuleRegionNetworkFirewallPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        RemoveRuleRegionNetworkFirewallPolicyRequest.prototype.region = "";
    
                        /**
                         * RemoveRuleRegionNetworkFirewallPolicyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        RemoveRuleRegionNetworkFirewallPolicyRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RemoveRuleRegionNetworkFirewallPolicyRequest _priority.
                         * @member {"priority"|undefined} _priority
                         * @memberof google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(RemoveRuleRegionNetworkFirewallPolicyRequest.prototype, "_priority", {
                            get: $util.oneOfGetter($oneOfFields = ["priority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RemoveRuleRegionNetworkFirewallPolicyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(RemoveRuleRegionNetworkFirewallPolicyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RemoveRuleRegionNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveRuleRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest} RemoveRuleRegionNetworkFirewallPolicyRequest instance
                         */
                        RemoveRuleRegionNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new RemoveRuleRegionNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RemoveRuleRegionNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveRuleRegionNetworkFirewallPolicyRequest} message RemoveRuleRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveRuleRegionNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.priority != null && Object.hasOwnProperty.call(message, "priority"))
                                writer.uint32(/* id 445151652, wireType 0 =*/3561213216).int32(message.priority);
                            if (message.firewallPolicy != null && Object.hasOwnProperty.call(message, "firewallPolicy"))
                                writer.uint32(/* id 498173265, wireType 2 =*/3985386122).string(message.firewallPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RemoveRuleRegionNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveRuleRegionNetworkFirewallPolicyRequest} message RemoveRuleRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveRuleRegionNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RemoveRuleRegionNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest} RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveRuleRegionNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 498173265: {
                                        message.firewallPolicy = reader.string();
                                        break;
                                    }
                                case 445151652: {
                                        message.priority = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RemoveRuleRegionNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest} RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveRuleRegionNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RemoveRuleRegionNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RemoveRuleRegionNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                if (!$util.isString(message.firewallPolicy))
                                    return "firewallPolicy: string expected";
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                properties._priority = 1;
                                if (!$util.isInteger(message.priority))
                                    return "priority: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RemoveRuleRegionNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest} RemoveRuleRegionNetworkFirewallPolicyRequest
                         */
                        RemoveRuleRegionNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest();
                            if (object.firewallPolicy != null)
                                message.firewallPolicy = String(object.firewallPolicy);
                            if (object.priority != null)
                                message.priority = object.priority | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RemoveRuleRegionNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest} message RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RemoveRuleRegionNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.firewallPolicy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                object.priority = message.priority;
                                if (options.oneofs)
                                    object._priority = "priority";
                            }
                            if (message.firewallPolicy != null && message.hasOwnProperty("firewallPolicy"))
                                object.firewallPolicy = message.firewallPolicy;
                            return object;
                        };
    
                        /**
                         * Converts this RemoveRuleRegionNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RemoveRuleRegionNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RemoveRuleRegionNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest";
                        };
    
                        return RemoveRuleRegionNetworkFirewallPolicyRequest;
                    })();
    
                    v1.RemoveRuleSecurityPolicyRequest = (function() {
    
                        /**
                         * Properties of a RemoveRuleSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IRemoveRuleSecurityPolicyRequest
                         * @property {number|null} [priority] RemoveRuleSecurityPolicyRequest priority
                         * @property {string|null} [project] RemoveRuleSecurityPolicyRequest project
                         * @property {string|null} [securityPolicy] RemoveRuleSecurityPolicyRequest securityPolicy
                         */
    
                        /**
                         * Constructs a new RemoveRuleSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RemoveRuleSecurityPolicyRequest.
                         * @implements IRemoveRuleSecurityPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IRemoveRuleSecurityPolicyRequest=} [properties] Properties to set
                         */
                        function RemoveRuleSecurityPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RemoveRuleSecurityPolicyRequest priority.
                         * @member {number|null|undefined} priority
                         * @memberof google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest
                         * @instance
                         */
                        RemoveRuleSecurityPolicyRequest.prototype.priority = null;
    
                        /**
                         * RemoveRuleSecurityPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest
                         * @instance
                         */
                        RemoveRuleSecurityPolicyRequest.prototype.project = "";
    
                        /**
                         * RemoveRuleSecurityPolicyRequest securityPolicy.
                         * @member {string} securityPolicy
                         * @memberof google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest
                         * @instance
                         */
                        RemoveRuleSecurityPolicyRequest.prototype.securityPolicy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RemoveRuleSecurityPolicyRequest _priority.
                         * @member {"priority"|undefined} _priority
                         * @memberof google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(RemoveRuleSecurityPolicyRequest.prototype, "_priority", {
                            get: $util.oneOfGetter($oneOfFields = ["priority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RemoveRuleSecurityPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveRuleSecurityPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest} RemoveRuleSecurityPolicyRequest instance
                         */
                        RemoveRuleSecurityPolicyRequest.create = function create(properties) {
                            return new RemoveRuleSecurityPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified RemoveRuleSecurityPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveRuleSecurityPolicyRequest} message RemoveRuleSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveRuleSecurityPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.securityPolicy != null && Object.hasOwnProperty.call(message, "securityPolicy"))
                                writer.uint32(/* id 171082513, wireType 2 =*/1368660106).string(message.securityPolicy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.priority != null && Object.hasOwnProperty.call(message, "priority"))
                                writer.uint32(/* id 445151652, wireType 0 =*/3561213216).int32(message.priority);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RemoveRuleSecurityPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IRemoveRuleSecurityPolicyRequest} message RemoveRuleSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RemoveRuleSecurityPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RemoveRuleSecurityPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest} RemoveRuleSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveRuleSecurityPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 445151652: {
                                        message.priority = reader.int32();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 171082513: {
                                        message.securityPolicy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RemoveRuleSecurityPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest} RemoveRuleSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RemoveRuleSecurityPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RemoveRuleSecurityPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RemoveRuleSecurityPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                properties._priority = 1;
                                if (!$util.isInteger(message.priority))
                                    return "priority: integer expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy"))
                                if (!$util.isString(message.securityPolicy))
                                    return "securityPolicy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a RemoveRuleSecurityPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest} RemoveRuleSecurityPolicyRequest
                         */
                        RemoveRuleSecurityPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest();
                            if (object.priority != null)
                                message.priority = object.priority | 0;
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.securityPolicy != null)
                                message.securityPolicy = String(object.securityPolicy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RemoveRuleSecurityPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest} message RemoveRuleSecurityPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RemoveRuleSecurityPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.securityPolicy = "";
                                object.project = "";
                            }
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy"))
                                object.securityPolicy = message.securityPolicy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                object.priority = message.priority;
                                if (options.oneofs)
                                    object._priority = "priority";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RemoveRuleSecurityPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RemoveRuleSecurityPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RemoveRuleSecurityPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RemoveRuleSecurityPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest";
                        };
    
                        return RemoveRuleSecurityPolicyRequest;
                    })();
    
                    v1.RequestMirrorPolicy = (function() {
    
                        /**
                         * Properties of a RequestMirrorPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IRequestMirrorPolicy
                         * @property {string|null} [backendService] RequestMirrorPolicy backendService
                         */
    
                        /**
                         * Constructs a new RequestMirrorPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RequestMirrorPolicy.
                         * @implements IRequestMirrorPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IRequestMirrorPolicy=} [properties] Properties to set
                         */
                        function RequestMirrorPolicy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RequestMirrorPolicy backendService.
                         * @member {string|null|undefined} backendService
                         * @memberof google.cloud.compute.v1.RequestMirrorPolicy
                         * @instance
                         */
                        RequestMirrorPolicy.prototype.backendService = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RequestMirrorPolicy _backendService.
                         * @member {"backendService"|undefined} _backendService
                         * @memberof google.cloud.compute.v1.RequestMirrorPolicy
                         * @instance
                         */
                        Object.defineProperty(RequestMirrorPolicy.prototype, "_backendService", {
                            get: $util.oneOfGetter($oneOfFields = ["backendService"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RequestMirrorPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RequestMirrorPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IRequestMirrorPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RequestMirrorPolicy} RequestMirrorPolicy instance
                         */
                        RequestMirrorPolicy.create = function create(properties) {
                            return new RequestMirrorPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified RequestMirrorPolicy message. Does not implicitly {@link google.cloud.compute.v1.RequestMirrorPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RequestMirrorPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IRequestMirrorPolicy} message RequestMirrorPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RequestMirrorPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.backendService != null && Object.hasOwnProperty.call(message, "backendService"))
                                writer.uint32(/* id 306946058, wireType 2 =*/2455568466).string(message.backendService);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RequestMirrorPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RequestMirrorPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RequestMirrorPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IRequestMirrorPolicy} message RequestMirrorPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RequestMirrorPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RequestMirrorPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RequestMirrorPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RequestMirrorPolicy} RequestMirrorPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RequestMirrorPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RequestMirrorPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 306946058: {
                                        message.backendService = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RequestMirrorPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RequestMirrorPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RequestMirrorPolicy} RequestMirrorPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RequestMirrorPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RequestMirrorPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RequestMirrorPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RequestMirrorPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendService != null && message.hasOwnProperty("backendService")) {
                                properties._backendService = 1;
                                if (!$util.isString(message.backendService))
                                    return "backendService: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RequestMirrorPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RequestMirrorPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RequestMirrorPolicy} RequestMirrorPolicy
                         */
                        RequestMirrorPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RequestMirrorPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RequestMirrorPolicy();
                            if (object.backendService != null)
                                message.backendService = String(object.backendService);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RequestMirrorPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RequestMirrorPolicy
                         * @static
                         * @param {google.cloud.compute.v1.RequestMirrorPolicy} message RequestMirrorPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RequestMirrorPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.backendService != null && message.hasOwnProperty("backendService")) {
                                object.backendService = message.backendService;
                                if (options.oneofs)
                                    object._backendService = "backendService";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RequestMirrorPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RequestMirrorPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RequestMirrorPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RequestMirrorPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RequestMirrorPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RequestMirrorPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RequestMirrorPolicy";
                        };
    
                        return RequestMirrorPolicy;
                    })();
    
                    v1.Reservation = (function() {
    
                        /**
                         * Properties of a Reservation.
                         * @memberof google.cloud.compute.v1
                         * @interface IReservation
                         * @property {string|null} [commitment] Reservation commitment
                         * @property {string|null} [creationTimestamp] Reservation creationTimestamp
                         * @property {string|null} [description] Reservation description
                         * @property {number|Long|null} [id] Reservation id
                         * @property {string|null} [kind] Reservation kind
                         * @property {string|null} [name] Reservation name
                         * @property {boolean|null} [satisfiesPzs] Reservation satisfiesPzs
                         * @property {string|null} [selfLink] Reservation selfLink
                         * @property {google.cloud.compute.v1.IShareSettings|null} [shareSettings] Reservation shareSettings
                         * @property {google.cloud.compute.v1.IAllocationSpecificSKUReservation|null} [specificReservation] Reservation specificReservation
                         * @property {boolean|null} [specificReservationRequired] Reservation specificReservationRequired
                         * @property {string|null} [status] Reservation status
                         * @property {string|null} [zone] Reservation zone
                         */
    
                        /**
                         * Constructs a new Reservation.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Reservation.
                         * @implements IReservation
                         * @constructor
                         * @param {google.cloud.compute.v1.IReservation=} [properties] Properties to set
                         */
                        function Reservation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Reservation commitment.
                         * @member {string|null|undefined} commitment
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Reservation.prototype.commitment = null;
    
                        /**
                         * Reservation creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Reservation.prototype.creationTimestamp = null;
    
                        /**
                         * Reservation description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Reservation.prototype.description = null;
    
                        /**
                         * Reservation id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Reservation.prototype.id = null;
    
                        /**
                         * Reservation kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Reservation.prototype.kind = null;
    
                        /**
                         * Reservation name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Reservation.prototype.name = null;
    
                        /**
                         * Reservation satisfiesPzs.
                         * @member {boolean|null|undefined} satisfiesPzs
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Reservation.prototype.satisfiesPzs = null;
    
                        /**
                         * Reservation selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Reservation.prototype.selfLink = null;
    
                        /**
                         * Reservation shareSettings.
                         * @member {google.cloud.compute.v1.IShareSettings|null|undefined} shareSettings
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Reservation.prototype.shareSettings = null;
    
                        /**
                         * Reservation specificReservation.
                         * @member {google.cloud.compute.v1.IAllocationSpecificSKUReservation|null|undefined} specificReservation
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Reservation.prototype.specificReservation = null;
    
                        /**
                         * Reservation specificReservationRequired.
                         * @member {boolean|null|undefined} specificReservationRequired
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Reservation.prototype.specificReservationRequired = null;
    
                        /**
                         * Reservation status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Reservation.prototype.status = null;
    
                        /**
                         * Reservation zone.
                         * @member {string|null|undefined} zone
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Reservation.prototype.zone = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Reservation _commitment.
                         * @member {"commitment"|undefined} _commitment
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Object.defineProperty(Reservation.prototype, "_commitment", {
                            get: $util.oneOfGetter($oneOfFields = ["commitment"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Reservation _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Object.defineProperty(Reservation.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Reservation _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Object.defineProperty(Reservation.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Reservation _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Object.defineProperty(Reservation.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Reservation _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Object.defineProperty(Reservation.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Reservation _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Object.defineProperty(Reservation.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Reservation _satisfiesPzs.
                         * @member {"satisfiesPzs"|undefined} _satisfiesPzs
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Object.defineProperty(Reservation.prototype, "_satisfiesPzs", {
                            get: $util.oneOfGetter($oneOfFields = ["satisfiesPzs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Reservation _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Object.defineProperty(Reservation.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Reservation _shareSettings.
                         * @member {"shareSettings"|undefined} _shareSettings
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Object.defineProperty(Reservation.prototype, "_shareSettings", {
                            get: $util.oneOfGetter($oneOfFields = ["shareSettings"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Reservation _specificReservation.
                         * @member {"specificReservation"|undefined} _specificReservation
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Object.defineProperty(Reservation.prototype, "_specificReservation", {
                            get: $util.oneOfGetter($oneOfFields = ["specificReservation"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Reservation _specificReservationRequired.
                         * @member {"specificReservationRequired"|undefined} _specificReservationRequired
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Object.defineProperty(Reservation.prototype, "_specificReservationRequired", {
                            get: $util.oneOfGetter($oneOfFields = ["specificReservationRequired"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Reservation _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Object.defineProperty(Reservation.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Reservation _zone.
                         * @member {"zone"|undefined} _zone
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         */
                        Object.defineProperty(Reservation.prototype, "_zone", {
                            get: $util.oneOfGetter($oneOfFields = ["zone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Reservation instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Reservation
                         * @static
                         * @param {google.cloud.compute.v1.IReservation=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Reservation} Reservation instance
                         */
                        Reservation.create = function create(properties) {
                            return new Reservation(properties);
                        };
    
                        /**
                         * Encodes the specified Reservation message. Does not implicitly {@link google.cloud.compute.v1.Reservation.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Reservation
                         * @static
                         * @param {google.cloud.compute.v1.IReservation} message Reservation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Reservation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.specificReservationRequired != null && Object.hasOwnProperty.call(message, "specificReservationRequired"))
                                writer.uint32(/* id 226550687, wireType 0 =*/1812405496).bool(message.specificReservationRequired);
                            if (message.shareSettings != null && Object.hasOwnProperty.call(message, "shareSettings"))
                                $root.google.cloud.compute.v1.ShareSettings.encode(message.shareSettings, writer.uint32(/* id 266668163, wireType 2 =*/2133345306).fork()).ldelim();
                            if (message.specificReservation != null && Object.hasOwnProperty.call(message, "specificReservation"))
                                $root.google.cloud.compute.v1.AllocationSpecificSKUReservation.encode(message.specificReservation, writer.uint32(/* id 404901951, wireType 2 =*/3239215610).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.satisfiesPzs != null && Object.hasOwnProperty.call(message, "satisfiesPzs"))
                                writer.uint32(/* id 480964267, wireType 0 =*/3847714136).bool(message.satisfiesPzs);
                            if (message.commitment != null && Object.hasOwnProperty.call(message, "commitment"))
                                writer.uint32(/* id 482134805, wireType 2 =*/3857078442).string(message.commitment);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Reservation message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Reservation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Reservation
                         * @static
                         * @param {google.cloud.compute.v1.IReservation} message Reservation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Reservation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Reservation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Reservation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Reservation} Reservation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Reservation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Reservation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 482134805: {
                                        message.commitment = reader.string();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 480964267: {
                                        message.satisfiesPzs = reader.bool();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 266668163: {
                                        message.shareSettings = $root.google.cloud.compute.v1.ShareSettings.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 404901951: {
                                        message.specificReservation = $root.google.cloud.compute.v1.AllocationSpecificSKUReservation.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 226550687: {
                                        message.specificReservationRequired = reader.bool();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Reservation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Reservation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Reservation} Reservation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Reservation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Reservation message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Reservation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Reservation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.commitment != null && message.hasOwnProperty("commitment")) {
                                properties._commitment = 1;
                                if (!$util.isString(message.commitment))
                                    return "commitment: string expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.satisfiesPzs != null && message.hasOwnProperty("satisfiesPzs")) {
                                properties._satisfiesPzs = 1;
                                if (typeof message.satisfiesPzs !== "boolean")
                                    return "satisfiesPzs: boolean expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.shareSettings != null && message.hasOwnProperty("shareSettings")) {
                                properties._shareSettings = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ShareSettings.verify(message.shareSettings);
                                    if (error)
                                        return "shareSettings." + error;
                                }
                            }
                            if (message.specificReservation != null && message.hasOwnProperty("specificReservation")) {
                                properties._specificReservation = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.AllocationSpecificSKUReservation.verify(message.specificReservation);
                                    if (error)
                                        return "specificReservation." + error;
                                }
                            }
                            if (message.specificReservationRequired != null && message.hasOwnProperty("specificReservationRequired")) {
                                properties._specificReservationRequired = 1;
                                if (typeof message.specificReservationRequired !== "boolean")
                                    return "specificReservationRequired: boolean expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                properties._zone = 1;
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Reservation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Reservation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Reservation} Reservation
                         */
                        Reservation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Reservation)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Reservation();
                            if (object.commitment != null)
                                message.commitment = String(object.commitment);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.satisfiesPzs != null)
                                message.satisfiesPzs = Boolean(object.satisfiesPzs);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.shareSettings != null) {
                                if (typeof object.shareSettings !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Reservation.shareSettings: object expected");
                                message.shareSettings = $root.google.cloud.compute.v1.ShareSettings.fromObject(object.shareSettings);
                            }
                            if (object.specificReservation != null) {
                                if (typeof object.specificReservation !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Reservation.specificReservation: object expected");
                                message.specificReservation = $root.google.cloud.compute.v1.AllocationSpecificSKUReservation.fromObject(object.specificReservation);
                            }
                            if (object.specificReservationRequired != null)
                                message.specificReservationRequired = Boolean(object.specificReservationRequired);
                            if (object.status != null)
                                message.status = String(object.status);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Reservation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Reservation
                         * @static
                         * @param {google.cloud.compute.v1.Reservation} message Reservation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Reservation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                object.zone = message.zone;
                                if (options.oneofs)
                                    object._zone = "zone";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.specificReservationRequired != null && message.hasOwnProperty("specificReservationRequired")) {
                                object.specificReservationRequired = message.specificReservationRequired;
                                if (options.oneofs)
                                    object._specificReservationRequired = "specificReservationRequired";
                            }
                            if (message.shareSettings != null && message.hasOwnProperty("shareSettings")) {
                                object.shareSettings = $root.google.cloud.compute.v1.ShareSettings.toObject(message.shareSettings, options);
                                if (options.oneofs)
                                    object._shareSettings = "shareSettings";
                            }
                            if (message.specificReservation != null && message.hasOwnProperty("specificReservation")) {
                                object.specificReservation = $root.google.cloud.compute.v1.AllocationSpecificSKUReservation.toObject(message.specificReservation, options);
                                if (options.oneofs)
                                    object._specificReservation = "specificReservation";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.satisfiesPzs != null && message.hasOwnProperty("satisfiesPzs")) {
                                object.satisfiesPzs = message.satisfiesPzs;
                                if (options.oneofs)
                                    object._satisfiesPzs = "satisfiesPzs";
                            }
                            if (message.commitment != null && message.hasOwnProperty("commitment")) {
                                object.commitment = message.commitment;
                                if (options.oneofs)
                                    object._commitment = "commitment";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Reservation to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Reservation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Reservation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Reservation
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Reservation
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Reservation.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Reservation";
                        };
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.Reservation.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} CREATING=455564985 CREATING value
                         * @property {number} DELETING=528602024 DELETING value
                         * @property {number} INVALID=530283991 INVALID value
                         * @property {number} READY=77848963 READY value
                         * @property {number} UPDATING=494614342 UPDATING value
                         */
                        Reservation.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[455564985] = "CREATING"] = 455564985;
                            values[valuesById[528602024] = "DELETING"] = 528602024;
                            values[valuesById[530283991] = "INVALID"] = 530283991;
                            values[valuesById[77848963] = "READY"] = 77848963;
                            values[valuesById[494614342] = "UPDATING"] = 494614342;
                            return values;
                        })();
    
                        return Reservation;
                    })();
    
                    v1.ReservationAffinity = (function() {
    
                        /**
                         * Properties of a ReservationAffinity.
                         * @memberof google.cloud.compute.v1
                         * @interface IReservationAffinity
                         * @property {string|null} [consumeReservationType] ReservationAffinity consumeReservationType
                         * @property {string|null} [key] ReservationAffinity key
                         * @property {Array.<string>|null} [values] ReservationAffinity values
                         */
    
                        /**
                         * Constructs a new ReservationAffinity.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ReservationAffinity.
                         * @implements IReservationAffinity
                         * @constructor
                         * @param {google.cloud.compute.v1.IReservationAffinity=} [properties] Properties to set
                         */
                        function ReservationAffinity(properties) {
                            this.values = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ReservationAffinity consumeReservationType.
                         * @member {string|null|undefined} consumeReservationType
                         * @memberof google.cloud.compute.v1.ReservationAffinity
                         * @instance
                         */
                        ReservationAffinity.prototype.consumeReservationType = null;
    
                        /**
                         * ReservationAffinity key.
                         * @member {string|null|undefined} key
                         * @memberof google.cloud.compute.v1.ReservationAffinity
                         * @instance
                         */
                        ReservationAffinity.prototype.key = null;
    
                        /**
                         * ReservationAffinity values.
                         * @member {Array.<string>} values
                         * @memberof google.cloud.compute.v1.ReservationAffinity
                         * @instance
                         */
                        ReservationAffinity.prototype.values = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ReservationAffinity _consumeReservationType.
                         * @member {"consumeReservationType"|undefined} _consumeReservationType
                         * @memberof google.cloud.compute.v1.ReservationAffinity
                         * @instance
                         */
                        Object.defineProperty(ReservationAffinity.prototype, "_consumeReservationType", {
                            get: $util.oneOfGetter($oneOfFields = ["consumeReservationType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ReservationAffinity _key.
                         * @member {"key"|undefined} _key
                         * @memberof google.cloud.compute.v1.ReservationAffinity
                         * @instance
                         */
                        Object.defineProperty(ReservationAffinity.prototype, "_key", {
                            get: $util.oneOfGetter($oneOfFields = ["key"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ReservationAffinity instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ReservationAffinity
                         * @static
                         * @param {google.cloud.compute.v1.IReservationAffinity=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ReservationAffinity} ReservationAffinity instance
                         */
                        ReservationAffinity.create = function create(properties) {
                            return new ReservationAffinity(properties);
                        };
    
                        /**
                         * Encodes the specified ReservationAffinity message. Does not implicitly {@link google.cloud.compute.v1.ReservationAffinity.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ReservationAffinity
                         * @static
                         * @param {google.cloud.compute.v1.IReservationAffinity} message ReservationAffinity message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ReservationAffinity.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.key != null && Object.hasOwnProperty.call(message, "key"))
                                writer.uint32(/* id 106079, wireType 2 =*/848634).string(message.key);
                            if (message.values != null && message.values.length)
                                for (var i = 0; i < message.values.length; ++i)
                                    writer.uint32(/* id 249928994, wireType 2 =*/1999431954).string(message.values[i]);
                            if (message.consumeReservationType != null && Object.hasOwnProperty.call(message, "consumeReservationType"))
                                writer.uint32(/* id 300736944, wireType 2 =*/2405895554).string(message.consumeReservationType);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ReservationAffinity message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ReservationAffinity.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ReservationAffinity
                         * @static
                         * @param {google.cloud.compute.v1.IReservationAffinity} message ReservationAffinity message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ReservationAffinity.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ReservationAffinity message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ReservationAffinity
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ReservationAffinity} ReservationAffinity
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ReservationAffinity.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ReservationAffinity();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 300736944: {
                                        message.consumeReservationType = reader.string();
                                        break;
                                    }
                                case 106079: {
                                        message.key = reader.string();
                                        break;
                                    }
                                case 249928994: {
                                        if (!(message.values && message.values.length))
                                            message.values = [];
                                        message.values.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ReservationAffinity message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ReservationAffinity
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ReservationAffinity} ReservationAffinity
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ReservationAffinity.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ReservationAffinity message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ReservationAffinity
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ReservationAffinity.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.consumeReservationType != null && message.hasOwnProperty("consumeReservationType")) {
                                properties._consumeReservationType = 1;
                                if (!$util.isString(message.consumeReservationType))
                                    return "consumeReservationType: string expected";
                            }
                            if (message.key != null && message.hasOwnProperty("key")) {
                                properties._key = 1;
                                if (!$util.isString(message.key))
                                    return "key: string expected";
                            }
                            if (message.values != null && message.hasOwnProperty("values")) {
                                if (!Array.isArray(message.values))
                                    return "values: array expected";
                                for (var i = 0; i < message.values.length; ++i)
                                    if (!$util.isString(message.values[i]))
                                        return "values: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ReservationAffinity message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ReservationAffinity
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ReservationAffinity} ReservationAffinity
                         */
                        ReservationAffinity.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ReservationAffinity)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ReservationAffinity();
                            if (object.consumeReservationType != null)
                                message.consumeReservationType = String(object.consumeReservationType);
                            if (object.key != null)
                                message.key = String(object.key);
                            if (object.values) {
                                if (!Array.isArray(object.values))
                                    throw TypeError(".google.cloud.compute.v1.ReservationAffinity.values: array expected");
                                message.values = [];
                                for (var i = 0; i < object.values.length; ++i)
                                    message.values[i] = String(object.values[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ReservationAffinity message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ReservationAffinity
                         * @static
                         * @param {google.cloud.compute.v1.ReservationAffinity} message ReservationAffinity
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ReservationAffinity.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.values = [];
                            if (message.key != null && message.hasOwnProperty("key")) {
                                object.key = message.key;
                                if (options.oneofs)
                                    object._key = "key";
                            }
                            if (message.values && message.values.length) {
                                object.values = [];
                                for (var j = 0; j < message.values.length; ++j)
                                    object.values[j] = message.values[j];
                            }
                            if (message.consumeReservationType != null && message.hasOwnProperty("consumeReservationType")) {
                                object.consumeReservationType = message.consumeReservationType;
                                if (options.oneofs)
                                    object._consumeReservationType = "consumeReservationType";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ReservationAffinity to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ReservationAffinity
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ReservationAffinity.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ReservationAffinity
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ReservationAffinity
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ReservationAffinity.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ReservationAffinity";
                        };
    
                        /**
                         * ConsumeReservationType enum.
                         * @name google.cloud.compute.v1.ReservationAffinity.ConsumeReservationType
                         * @enum {number}
                         * @property {number} UNDEFINED_CONSUME_RESERVATION_TYPE=0 UNDEFINED_CONSUME_RESERVATION_TYPE value
                         * @property {number} ANY_RESERVATION=200008121 ANY_RESERVATION value
                         * @property {number} NO_RESERVATION=169322030 NO_RESERVATION value
                         * @property {number} SPECIFIC_RESERVATION=229889055 SPECIFIC_RESERVATION value
                         * @property {number} UNSPECIFIED=526786327 UNSPECIFIED value
                         */
                        ReservationAffinity.ConsumeReservationType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_CONSUME_RESERVATION_TYPE"] = 0;
                            values[valuesById[200008121] = "ANY_RESERVATION"] = 200008121;
                            values[valuesById[169322030] = "NO_RESERVATION"] = 169322030;
                            values[valuesById[229889055] = "SPECIFIC_RESERVATION"] = 229889055;
                            values[valuesById[526786327] = "UNSPECIFIED"] = 526786327;
                            return values;
                        })();
    
                        return ReservationAffinity;
                    })();
    
                    v1.ReservationAggregatedList = (function() {
    
                        /**
                         * Properties of a ReservationAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IReservationAggregatedList
                         * @property {string|null} [id] ReservationAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IReservationsScopedList>|null} [items] ReservationAggregatedList items
                         * @property {string|null} [kind] ReservationAggregatedList kind
                         * @property {string|null} [nextPageToken] ReservationAggregatedList nextPageToken
                         * @property {string|null} [selfLink] ReservationAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] ReservationAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] ReservationAggregatedList warning
                         */
    
                        /**
                         * Constructs a new ReservationAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ReservationAggregatedList.
                         * @implements IReservationAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IReservationAggregatedList=} [properties] Properties to set
                         */
                        function ReservationAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ReservationAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @instance
                         */
                        ReservationAggregatedList.prototype.id = null;
    
                        /**
                         * ReservationAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IReservationsScopedList>} items
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @instance
                         */
                        ReservationAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * ReservationAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @instance
                         */
                        ReservationAggregatedList.prototype.kind = null;
    
                        /**
                         * ReservationAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @instance
                         */
                        ReservationAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * ReservationAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @instance
                         */
                        ReservationAggregatedList.prototype.selfLink = null;
    
                        /**
                         * ReservationAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @instance
                         */
                        ReservationAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * ReservationAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @instance
                         */
                        ReservationAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ReservationAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ReservationAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ReservationAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ReservationAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ReservationAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ReservationAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ReservationAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ReservationAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ReservationAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ReservationAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ReservationAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IReservationAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ReservationAggregatedList} ReservationAggregatedList instance
                         */
                        ReservationAggregatedList.create = function create(properties) {
                            return new ReservationAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified ReservationAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.ReservationAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IReservationAggregatedList} message ReservationAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ReservationAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.ReservationsScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ReservationAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ReservationAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IReservationAggregatedList} message ReservationAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ReservationAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ReservationAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ReservationAggregatedList} ReservationAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ReservationAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ReservationAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.ReservationsScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ReservationAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ReservationAggregatedList} ReservationAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ReservationAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ReservationAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ReservationAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ReservationsScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ReservationAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ReservationAggregatedList} ReservationAggregatedList
                         */
                        ReservationAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ReservationAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ReservationAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ReservationAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ReservationAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.ReservationsScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.ReservationAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ReservationAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ReservationAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ReservationAggregatedList} message ReservationAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ReservationAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.ReservationsScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ReservationAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ReservationAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ReservationAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ReservationAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ReservationAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ReservationAggregatedList";
                        };
    
                        return ReservationAggregatedList;
                    })();
    
                    v1.ReservationList = (function() {
    
                        /**
                         * Properties of a ReservationList.
                         * @memberof google.cloud.compute.v1
                         * @interface IReservationList
                         * @property {string|null} [id] ReservationList id
                         * @property {Array.<google.cloud.compute.v1.IReservation>|null} [items] ReservationList items
                         * @property {string|null} [kind] ReservationList kind
                         * @property {string|null} [nextPageToken] ReservationList nextPageToken
                         * @property {string|null} [selfLink] ReservationList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] ReservationList warning
                         */
    
                        /**
                         * Constructs a new ReservationList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ReservationList.
                         * @implements IReservationList
                         * @constructor
                         * @param {google.cloud.compute.v1.IReservationList=} [properties] Properties to set
                         */
                        function ReservationList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ReservationList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @instance
                         */
                        ReservationList.prototype.id = null;
    
                        /**
                         * ReservationList items.
                         * @member {Array.<google.cloud.compute.v1.IReservation>} items
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @instance
                         */
                        ReservationList.prototype.items = $util.emptyArray;
    
                        /**
                         * ReservationList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @instance
                         */
                        ReservationList.prototype.kind = null;
    
                        /**
                         * ReservationList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @instance
                         */
                        ReservationList.prototype.nextPageToken = null;
    
                        /**
                         * ReservationList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @instance
                         */
                        ReservationList.prototype.selfLink = null;
    
                        /**
                         * ReservationList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @instance
                         */
                        ReservationList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ReservationList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @instance
                         */
                        Object.defineProperty(ReservationList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ReservationList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @instance
                         */
                        Object.defineProperty(ReservationList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ReservationList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @instance
                         */
                        Object.defineProperty(ReservationList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ReservationList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @instance
                         */
                        Object.defineProperty(ReservationList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ReservationList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @instance
                         */
                        Object.defineProperty(ReservationList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ReservationList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @static
                         * @param {google.cloud.compute.v1.IReservationList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ReservationList} ReservationList instance
                         */
                        ReservationList.create = function create(properties) {
                            return new ReservationList(properties);
                        };
    
                        /**
                         * Encodes the specified ReservationList message. Does not implicitly {@link google.cloud.compute.v1.ReservationList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @static
                         * @param {google.cloud.compute.v1.IReservationList} message ReservationList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ReservationList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Reservation.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ReservationList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ReservationList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @static
                         * @param {google.cloud.compute.v1.IReservationList} message ReservationList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ReservationList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ReservationList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ReservationList} ReservationList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ReservationList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ReservationList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Reservation.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ReservationList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ReservationList} ReservationList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ReservationList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ReservationList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ReservationList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Reservation.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ReservationList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ReservationList} ReservationList
                         */
                        ReservationList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ReservationList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ReservationList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.ReservationList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ReservationList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Reservation.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ReservationList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ReservationList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @static
                         * @param {google.cloud.compute.v1.ReservationList} message ReservationList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ReservationList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Reservation.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ReservationList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ReservationList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ReservationList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ReservationList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ReservationList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ReservationList";
                        };
    
                        return ReservationList;
                    })();
    
                    v1.ReservationsResizeRequest = (function() {
    
                        /**
                         * Properties of a ReservationsResizeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IReservationsResizeRequest
                         * @property {number|Long|null} [specificSkuCount] ReservationsResizeRequest specificSkuCount
                         */
    
                        /**
                         * Constructs a new ReservationsResizeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ReservationsResizeRequest.
                         * @implements IReservationsResizeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IReservationsResizeRequest=} [properties] Properties to set
                         */
                        function ReservationsResizeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ReservationsResizeRequest specificSkuCount.
                         * @member {number|Long|null|undefined} specificSkuCount
                         * @memberof google.cloud.compute.v1.ReservationsResizeRequest
                         * @instance
                         */
                        ReservationsResizeRequest.prototype.specificSkuCount = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ReservationsResizeRequest _specificSkuCount.
                         * @member {"specificSkuCount"|undefined} _specificSkuCount
                         * @memberof google.cloud.compute.v1.ReservationsResizeRequest
                         * @instance
                         */
                        Object.defineProperty(ReservationsResizeRequest.prototype, "_specificSkuCount", {
                            get: $util.oneOfGetter($oneOfFields = ["specificSkuCount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ReservationsResizeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ReservationsResizeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IReservationsResizeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ReservationsResizeRequest} ReservationsResizeRequest instance
                         */
                        ReservationsResizeRequest.create = function create(properties) {
                            return new ReservationsResizeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ReservationsResizeRequest message. Does not implicitly {@link google.cloud.compute.v1.ReservationsResizeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ReservationsResizeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IReservationsResizeRequest} message ReservationsResizeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ReservationsResizeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.specificSkuCount != null && Object.hasOwnProperty.call(message, "specificSkuCount"))
                                writer.uint32(/* id 13890720, wireType 0 =*/111125760).int64(message.specificSkuCount);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ReservationsResizeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ReservationsResizeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ReservationsResizeRequest
                         * @static
                         * @param {google.cloud.compute.v1.IReservationsResizeRequest} message ReservationsResizeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ReservationsResizeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ReservationsResizeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ReservationsResizeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ReservationsResizeRequest} ReservationsResizeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ReservationsResizeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ReservationsResizeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 13890720: {
                                        message.specificSkuCount = reader.int64();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ReservationsResizeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ReservationsResizeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ReservationsResizeRequest} ReservationsResizeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ReservationsResizeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ReservationsResizeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ReservationsResizeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ReservationsResizeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.specificSkuCount != null && message.hasOwnProperty("specificSkuCount")) {
                                properties._specificSkuCount = 1;
                                if (!$util.isInteger(message.specificSkuCount) && !(message.specificSkuCount && $util.isInteger(message.specificSkuCount.low) && $util.isInteger(message.specificSkuCount.high)))
                                    return "specificSkuCount: integer|Long expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ReservationsResizeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ReservationsResizeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ReservationsResizeRequest} ReservationsResizeRequest
                         */
                        ReservationsResizeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ReservationsResizeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ReservationsResizeRequest();
                            if (object.specificSkuCount != null)
                                if ($util.Long)
                                    (message.specificSkuCount = $util.Long.fromValue(object.specificSkuCount)).unsigned = false;
                                else if (typeof object.specificSkuCount === "string")
                                    message.specificSkuCount = parseInt(object.specificSkuCount, 10);
                                else if (typeof object.specificSkuCount === "number")
                                    message.specificSkuCount = object.specificSkuCount;
                                else if (typeof object.specificSkuCount === "object")
                                    message.specificSkuCount = new $util.LongBits(object.specificSkuCount.low >>> 0, object.specificSkuCount.high >>> 0).toNumber();
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ReservationsResizeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ReservationsResizeRequest
                         * @static
                         * @param {google.cloud.compute.v1.ReservationsResizeRequest} message ReservationsResizeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ReservationsResizeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.specificSkuCount != null && message.hasOwnProperty("specificSkuCount")) {
                                if (typeof message.specificSkuCount === "number")
                                    object.specificSkuCount = options.longs === String ? String(message.specificSkuCount) : message.specificSkuCount;
                                else
                                    object.specificSkuCount = options.longs === String ? $util.Long.prototype.toString.call(message.specificSkuCount) : options.longs === Number ? new $util.LongBits(message.specificSkuCount.low >>> 0, message.specificSkuCount.high >>> 0).toNumber() : message.specificSkuCount;
                                if (options.oneofs)
                                    object._specificSkuCount = "specificSkuCount";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ReservationsResizeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ReservationsResizeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ReservationsResizeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ReservationsResizeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ReservationsResizeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ReservationsResizeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ReservationsResizeRequest";
                        };
    
                        return ReservationsResizeRequest;
                    })();
    
                    v1.ReservationsScopedList = (function() {
    
                        /**
                         * Properties of a ReservationsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IReservationsScopedList
                         * @property {Array.<google.cloud.compute.v1.IReservation>|null} [reservations] ReservationsScopedList reservations
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] ReservationsScopedList warning
                         */
    
                        /**
                         * Constructs a new ReservationsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ReservationsScopedList.
                         * @implements IReservationsScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IReservationsScopedList=} [properties] Properties to set
                         */
                        function ReservationsScopedList(properties) {
                            this.reservations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ReservationsScopedList reservations.
                         * @member {Array.<google.cloud.compute.v1.IReservation>} reservations
                         * @memberof google.cloud.compute.v1.ReservationsScopedList
                         * @instance
                         */
                        ReservationsScopedList.prototype.reservations = $util.emptyArray;
    
                        /**
                         * ReservationsScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.ReservationsScopedList
                         * @instance
                         */
                        ReservationsScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ReservationsScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.ReservationsScopedList
                         * @instance
                         */
                        Object.defineProperty(ReservationsScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ReservationsScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ReservationsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IReservationsScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ReservationsScopedList} ReservationsScopedList instance
                         */
                        ReservationsScopedList.create = function create(properties) {
                            return new ReservationsScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified ReservationsScopedList message. Does not implicitly {@link google.cloud.compute.v1.ReservationsScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ReservationsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IReservationsScopedList} message ReservationsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ReservationsScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.reservations != null && message.reservations.length)
                                for (var i = 0; i < message.reservations.length; ++i)
                                    $root.google.cloud.compute.v1.Reservation.encode(message.reservations[i], writer.uint32(/* id 399717927, wireType 2 =*/3197743418).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ReservationsScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ReservationsScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ReservationsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IReservationsScopedList} message ReservationsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ReservationsScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ReservationsScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ReservationsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ReservationsScopedList} ReservationsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ReservationsScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ReservationsScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 399717927: {
                                        if (!(message.reservations && message.reservations.length))
                                            message.reservations = [];
                                        message.reservations.push($root.google.cloud.compute.v1.Reservation.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ReservationsScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ReservationsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ReservationsScopedList} ReservationsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ReservationsScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ReservationsScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ReservationsScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ReservationsScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.reservations != null && message.hasOwnProperty("reservations")) {
                                if (!Array.isArray(message.reservations))
                                    return "reservations: array expected";
                                for (var i = 0; i < message.reservations.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Reservation.verify(message.reservations[i]);
                                    if (error)
                                        return "reservations." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ReservationsScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ReservationsScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ReservationsScopedList} ReservationsScopedList
                         */
                        ReservationsScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ReservationsScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ReservationsScopedList();
                            if (object.reservations) {
                                if (!Array.isArray(object.reservations))
                                    throw TypeError(".google.cloud.compute.v1.ReservationsScopedList.reservations: array expected");
                                message.reservations = [];
                                for (var i = 0; i < object.reservations.length; ++i) {
                                    if (typeof object.reservations[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ReservationsScopedList.reservations: object expected");
                                    message.reservations[i] = $root.google.cloud.compute.v1.Reservation.fromObject(object.reservations[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ReservationsScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ReservationsScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ReservationsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ReservationsScopedList} message ReservationsScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ReservationsScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.reservations = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.reservations && message.reservations.length) {
                                object.reservations = [];
                                for (var j = 0; j < message.reservations.length; ++j)
                                    object.reservations[j] = $root.google.cloud.compute.v1.Reservation.toObject(message.reservations[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ReservationsScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ReservationsScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ReservationsScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ReservationsScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ReservationsScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ReservationsScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ReservationsScopedList";
                        };
    
                        return ReservationsScopedList;
                    })();
    
                    v1.ResetInstanceRequest = (function() {
    
                        /**
                         * Properties of a ResetInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IResetInstanceRequest
                         * @property {string|null} [instance] ResetInstanceRequest instance
                         * @property {string|null} [project] ResetInstanceRequest project
                         * @property {string|null} [requestId] ResetInstanceRequest requestId
                         * @property {string|null} [zone] ResetInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new ResetInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResetInstanceRequest.
                         * @implements IResetInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IResetInstanceRequest=} [properties] Properties to set
                         */
                        function ResetInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResetInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.ResetInstanceRequest
                         * @instance
                         */
                        ResetInstanceRequest.prototype.instance = "";
    
                        /**
                         * ResetInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ResetInstanceRequest
                         * @instance
                         */
                        ResetInstanceRequest.prototype.project = "";
    
                        /**
                         * ResetInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.ResetInstanceRequest
                         * @instance
                         */
                        ResetInstanceRequest.prototype.requestId = null;
    
                        /**
                         * ResetInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ResetInstanceRequest
                         * @instance
                         */
                        ResetInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResetInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.ResetInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(ResetInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResetInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResetInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResetInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResetInstanceRequest} ResetInstanceRequest instance
                         */
                        ResetInstanceRequest.create = function create(properties) {
                            return new ResetInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ResetInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.ResetInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResetInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResetInstanceRequest} message ResetInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResetInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResetInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResetInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResetInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResetInstanceRequest} message ResetInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResetInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResetInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResetInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResetInstanceRequest} ResetInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResetInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResetInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResetInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResetInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResetInstanceRequest} ResetInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResetInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResetInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResetInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResetInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ResetInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResetInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResetInstanceRequest} ResetInstanceRequest
                         */
                        ResetInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResetInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResetInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResetInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResetInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ResetInstanceRequest} message ResetInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResetInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this ResetInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResetInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResetInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResetInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResetInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResetInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResetInstanceRequest";
                        };
    
                        return ResetInstanceRequest;
                    })();
    
                    v1.ResizeDiskRequest = (function() {
    
                        /**
                         * Properties of a ResizeDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IResizeDiskRequest
                         * @property {string|null} [disk] ResizeDiskRequest disk
                         * @property {google.cloud.compute.v1.IDisksResizeRequest|null} [disksResizeRequestResource] ResizeDiskRequest disksResizeRequestResource
                         * @property {string|null} [project] ResizeDiskRequest project
                         * @property {string|null} [requestId] ResizeDiskRequest requestId
                         * @property {string|null} [zone] ResizeDiskRequest zone
                         */
    
                        /**
                         * Constructs a new ResizeDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResizeDiskRequest.
                         * @implements IResizeDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IResizeDiskRequest=} [properties] Properties to set
                         */
                        function ResizeDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResizeDiskRequest disk.
                         * @member {string} disk
                         * @memberof google.cloud.compute.v1.ResizeDiskRequest
                         * @instance
                         */
                        ResizeDiskRequest.prototype.disk = "";
    
                        /**
                         * ResizeDiskRequest disksResizeRequestResource.
                         * @member {google.cloud.compute.v1.IDisksResizeRequest|null|undefined} disksResizeRequestResource
                         * @memberof google.cloud.compute.v1.ResizeDiskRequest
                         * @instance
                         */
                        ResizeDiskRequest.prototype.disksResizeRequestResource = null;
    
                        /**
                         * ResizeDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ResizeDiskRequest
                         * @instance
                         */
                        ResizeDiskRequest.prototype.project = "";
    
                        /**
                         * ResizeDiskRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.ResizeDiskRequest
                         * @instance
                         */
                        ResizeDiskRequest.prototype.requestId = null;
    
                        /**
                         * ResizeDiskRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ResizeDiskRequest
                         * @instance
                         */
                        ResizeDiskRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResizeDiskRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.ResizeDiskRequest
                         * @instance
                         */
                        Object.defineProperty(ResizeDiskRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResizeDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResizeDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResizeDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResizeDiskRequest} ResizeDiskRequest instance
                         */
                        ResizeDiskRequest.create = function create(properties) {
                            return new ResizeDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ResizeDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.ResizeDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResizeDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResizeDiskRequest} message ResizeDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResizeDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.disk != null && Object.hasOwnProperty.call(message, "disk"))
                                writer.uint32(/* id 3083677, wireType 2 =*/24669418).string(message.disk);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.disksResizeRequestResource != null && Object.hasOwnProperty.call(message, "disksResizeRequestResource"))
                                $root.google.cloud.compute.v1.DisksResizeRequest.encode(message.disksResizeRequestResource, writer.uint32(/* id 78307616, wireType 2 =*/626460930).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResizeDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResizeDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResizeDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResizeDiskRequest} message ResizeDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResizeDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResizeDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResizeDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResizeDiskRequest} ResizeDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResizeDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResizeDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3083677: {
                                        message.disk = reader.string();
                                        break;
                                    }
                                case 78307616: {
                                        message.disksResizeRequestResource = $root.google.cloud.compute.v1.DisksResizeRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResizeDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResizeDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResizeDiskRequest} ResizeDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResizeDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResizeDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResizeDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResizeDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                if (!$util.isString(message.disk))
                                    return "disk: string expected";
                            if (message.disksResizeRequestResource != null && message.hasOwnProperty("disksResizeRequestResource")) {
                                var error = $root.google.cloud.compute.v1.DisksResizeRequest.verify(message.disksResizeRequestResource);
                                if (error)
                                    return "disksResizeRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ResizeDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResizeDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResizeDiskRequest} ResizeDiskRequest
                         */
                        ResizeDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResizeDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResizeDiskRequest();
                            if (object.disk != null)
                                message.disk = String(object.disk);
                            if (object.disksResizeRequestResource != null) {
                                if (typeof object.disksResizeRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResizeDiskRequest.disksResizeRequestResource: object expected");
                                message.disksResizeRequestResource = $root.google.cloud.compute.v1.DisksResizeRequest.fromObject(object.disksResizeRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResizeDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResizeDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ResizeDiskRequest} message ResizeDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResizeDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.disk = "";
                                object.zone = "";
                                object.disksResizeRequestResource = null;
                                object.project = "";
                            }
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                object.disk = message.disk;
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.disksResizeRequestResource != null && message.hasOwnProperty("disksResizeRequestResource"))
                                object.disksResizeRequestResource = $root.google.cloud.compute.v1.DisksResizeRequest.toObject(message.disksResizeRequestResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this ResizeDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResizeDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResizeDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResizeDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResizeDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResizeDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResizeDiskRequest";
                        };
    
                        return ResizeDiskRequest;
                    })();
    
                    v1.ResizeInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a ResizeInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IResizeInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] ResizeInstanceGroupManagerRequest instanceGroupManager
                         * @property {string|null} [project] ResizeInstanceGroupManagerRequest project
                         * @property {string|null} [requestId] ResizeInstanceGroupManagerRequest requestId
                         * @property {number|null} [size] ResizeInstanceGroupManagerRequest size
                         * @property {string|null} [zone] ResizeInstanceGroupManagerRequest zone
                         */
    
                        /**
                         * Constructs a new ResizeInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResizeInstanceGroupManagerRequest.
                         * @implements IResizeInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IResizeInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function ResizeInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResizeInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.ResizeInstanceGroupManagerRequest
                         * @instance
                         */
                        ResizeInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * ResizeInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ResizeInstanceGroupManagerRequest
                         * @instance
                         */
                        ResizeInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * ResizeInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.ResizeInstanceGroupManagerRequest
                         * @instance
                         */
                        ResizeInstanceGroupManagerRequest.prototype.requestId = null;
    
                        /**
                         * ResizeInstanceGroupManagerRequest size.
                         * @member {number} size
                         * @memberof google.cloud.compute.v1.ResizeInstanceGroupManagerRequest
                         * @instance
                         */
                        ResizeInstanceGroupManagerRequest.prototype.size = 0;
    
                        /**
                         * ResizeInstanceGroupManagerRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ResizeInstanceGroupManagerRequest
                         * @instance
                         */
                        ResizeInstanceGroupManagerRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResizeInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.ResizeInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(ResizeInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResizeInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResizeInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResizeInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResizeInstanceGroupManagerRequest} ResizeInstanceGroupManagerRequest instance
                         */
                        ResizeInstanceGroupManagerRequest.create = function create(properties) {
                            return new ResizeInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ResizeInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.ResizeInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResizeInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResizeInstanceGroupManagerRequest} message ResizeInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResizeInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.size != null && Object.hasOwnProperty.call(message, "size"))
                                writer.uint32(/* id 3530753, wireType 0 =*/28246024).int32(message.size);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResizeInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResizeInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResizeInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResizeInstanceGroupManagerRequest} message ResizeInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResizeInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResizeInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResizeInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResizeInstanceGroupManagerRequest} ResizeInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResizeInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResizeInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3530753: {
                                        message.size = reader.int32();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResizeInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResizeInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResizeInstanceGroupManagerRequest} ResizeInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResizeInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResizeInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResizeInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResizeInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.size != null && message.hasOwnProperty("size"))
                                if (!$util.isInteger(message.size))
                                    return "size: integer expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ResizeInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResizeInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResizeInstanceGroupManagerRequest} ResizeInstanceGroupManagerRequest
                         */
                        ResizeInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResizeInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResizeInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.size != null)
                                message.size = object.size | 0;
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResizeInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResizeInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ResizeInstanceGroupManagerRequest} message ResizeInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResizeInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.size = 0;
                                object.zone = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.size != null && message.hasOwnProperty("size"))
                                object.size = message.size;
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            return object;
                        };
    
                        /**
                         * Converts this ResizeInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResizeInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResizeInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResizeInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResizeInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResizeInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResizeInstanceGroupManagerRequest";
                        };
    
                        return ResizeInstanceGroupManagerRequest;
                    })();
    
                    v1.ResizeRegionDiskRequest = (function() {
    
                        /**
                         * Properties of a ResizeRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IResizeRegionDiskRequest
                         * @property {string|null} [disk] ResizeRegionDiskRequest disk
                         * @property {string|null} [project] ResizeRegionDiskRequest project
                         * @property {string|null} [region] ResizeRegionDiskRequest region
                         * @property {google.cloud.compute.v1.IRegionDisksResizeRequest|null} [regionDisksResizeRequestResource] ResizeRegionDiskRequest regionDisksResizeRequestResource
                         * @property {string|null} [requestId] ResizeRegionDiskRequest requestId
                         */
    
                        /**
                         * Constructs a new ResizeRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResizeRegionDiskRequest.
                         * @implements IResizeRegionDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IResizeRegionDiskRequest=} [properties] Properties to set
                         */
                        function ResizeRegionDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResizeRegionDiskRequest disk.
                         * @member {string} disk
                         * @memberof google.cloud.compute.v1.ResizeRegionDiskRequest
                         * @instance
                         */
                        ResizeRegionDiskRequest.prototype.disk = "";
    
                        /**
                         * ResizeRegionDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ResizeRegionDiskRequest
                         * @instance
                         */
                        ResizeRegionDiskRequest.prototype.project = "";
    
                        /**
                         * ResizeRegionDiskRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ResizeRegionDiskRequest
                         * @instance
                         */
                        ResizeRegionDiskRequest.prototype.region = "";
    
                        /**
                         * ResizeRegionDiskRequest regionDisksResizeRequestResource.
                         * @member {google.cloud.compute.v1.IRegionDisksResizeRequest|null|undefined} regionDisksResizeRequestResource
                         * @memberof google.cloud.compute.v1.ResizeRegionDiskRequest
                         * @instance
                         */
                        ResizeRegionDiskRequest.prototype.regionDisksResizeRequestResource = null;
    
                        /**
                         * ResizeRegionDiskRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.ResizeRegionDiskRequest
                         * @instance
                         */
                        ResizeRegionDiskRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResizeRegionDiskRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.ResizeRegionDiskRequest
                         * @instance
                         */
                        Object.defineProperty(ResizeRegionDiskRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResizeRegionDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResizeRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResizeRegionDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResizeRegionDiskRequest} ResizeRegionDiskRequest instance
                         */
                        ResizeRegionDiskRequest.create = function create(properties) {
                            return new ResizeRegionDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ResizeRegionDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.ResizeRegionDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResizeRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResizeRegionDiskRequest} message ResizeRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResizeRegionDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.disk != null && Object.hasOwnProperty.call(message, "disk"))
                                writer.uint32(/* id 3083677, wireType 2 =*/24669418).string(message.disk);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.regionDisksResizeRequestResource != null && Object.hasOwnProperty.call(message, "regionDisksResizeRequestResource"))
                                $root.google.cloud.compute.v1.RegionDisksResizeRequest.encode(message.regionDisksResizeRequestResource, writer.uint32(/* id 446633237, wireType 2 =*/3573065898).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResizeRegionDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResizeRegionDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResizeRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResizeRegionDiskRequest} message ResizeRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResizeRegionDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResizeRegionDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResizeRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResizeRegionDiskRequest} ResizeRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResizeRegionDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResizeRegionDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3083677: {
                                        message.disk = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 446633237: {
                                        message.regionDisksResizeRequestResource = $root.google.cloud.compute.v1.RegionDisksResizeRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResizeRegionDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResizeRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResizeRegionDiskRequest} ResizeRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResizeRegionDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResizeRegionDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResizeRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResizeRegionDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                if (!$util.isString(message.disk))
                                    return "disk: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionDisksResizeRequestResource != null && message.hasOwnProperty("regionDisksResizeRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionDisksResizeRequest.verify(message.regionDisksResizeRequestResource);
                                if (error)
                                    return "regionDisksResizeRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResizeRegionDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResizeRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResizeRegionDiskRequest} ResizeRegionDiskRequest
                         */
                        ResizeRegionDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResizeRegionDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResizeRegionDiskRequest();
                            if (object.disk != null)
                                message.disk = String(object.disk);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionDisksResizeRequestResource != null) {
                                if (typeof object.regionDisksResizeRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResizeRegionDiskRequest.regionDisksResizeRequestResource: object expected");
                                message.regionDisksResizeRequestResource = $root.google.cloud.compute.v1.RegionDisksResizeRequest.fromObject(object.regionDisksResizeRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResizeRegionDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResizeRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ResizeRegionDiskRequest} message ResizeRegionDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResizeRegionDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.disk = "";
                                object.region = "";
                                object.project = "";
                                object.regionDisksResizeRequestResource = null;
                            }
                            if (message.disk != null && message.hasOwnProperty("disk"))
                                object.disk = message.disk;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.regionDisksResizeRequestResource != null && message.hasOwnProperty("regionDisksResizeRequestResource"))
                                object.regionDisksResizeRequestResource = $root.google.cloud.compute.v1.RegionDisksResizeRequest.toObject(message.regionDisksResizeRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this ResizeRegionDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResizeRegionDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResizeRegionDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResizeRegionDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResizeRegionDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResizeRegionDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResizeRegionDiskRequest";
                        };
    
                        return ResizeRegionDiskRequest;
                    })();
    
                    v1.ResizeRegionInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a ResizeRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IResizeRegionInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] ResizeRegionInstanceGroupManagerRequest instanceGroupManager
                         * @property {string|null} [project] ResizeRegionInstanceGroupManagerRequest project
                         * @property {string|null} [region] ResizeRegionInstanceGroupManagerRequest region
                         * @property {string|null} [requestId] ResizeRegionInstanceGroupManagerRequest requestId
                         * @property {number|null} [size] ResizeRegionInstanceGroupManagerRequest size
                         */
    
                        /**
                         * Constructs a new ResizeRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResizeRegionInstanceGroupManagerRequest.
                         * @implements IResizeRegionInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IResizeRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function ResizeRegionInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResizeRegionInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        ResizeRegionInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * ResizeRegionInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        ResizeRegionInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * ResizeRegionInstanceGroupManagerRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        ResizeRegionInstanceGroupManagerRequest.prototype.region = "";
    
                        /**
                         * ResizeRegionInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        ResizeRegionInstanceGroupManagerRequest.prototype.requestId = null;
    
                        /**
                         * ResizeRegionInstanceGroupManagerRequest size.
                         * @member {number} size
                         * @memberof google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        ResizeRegionInstanceGroupManagerRequest.prototype.size = 0;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResizeRegionInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(ResizeRegionInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResizeRegionInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResizeRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest} ResizeRegionInstanceGroupManagerRequest instance
                         */
                        ResizeRegionInstanceGroupManagerRequest.create = function create(properties) {
                            return new ResizeRegionInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ResizeRegionInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResizeRegionInstanceGroupManagerRequest} message ResizeRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResizeRegionInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.size != null && Object.hasOwnProperty.call(message, "size"))
                                writer.uint32(/* id 3530753, wireType 0 =*/28246024).int32(message.size);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResizeRegionInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResizeRegionInstanceGroupManagerRequest} message ResizeRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResizeRegionInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResizeRegionInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest} ResizeRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResizeRegionInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3530753: {
                                        message.size = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResizeRegionInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest} ResizeRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResizeRegionInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResizeRegionInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResizeRegionInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.size != null && message.hasOwnProperty("size"))
                                if (!$util.isInteger(message.size))
                                    return "size: integer expected";
                            return null;
                        };
    
                        /**
                         * Creates a ResizeRegionInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest} ResizeRegionInstanceGroupManagerRequest
                         */
                        ResizeRegionInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.size != null)
                                message.size = object.size | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResizeRegionInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest} message ResizeRegionInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResizeRegionInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.size = 0;
                                object.region = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.size != null && message.hasOwnProperty("size"))
                                object.size = message.size;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            return object;
                        };
    
                        /**
                         * Converts this ResizeRegionInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResizeRegionInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResizeRegionInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResizeRegionInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest";
                        };
    
                        return ResizeRegionInstanceGroupManagerRequest;
                    })();
    
                    v1.ResizeReservationRequest = (function() {
    
                        /**
                         * Properties of a ResizeReservationRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IResizeReservationRequest
                         * @property {string|null} [project] ResizeReservationRequest project
                         * @property {string|null} [requestId] ResizeReservationRequest requestId
                         * @property {string|null} [reservation] ResizeReservationRequest reservation
                         * @property {google.cloud.compute.v1.IReservationsResizeRequest|null} [reservationsResizeRequestResource] ResizeReservationRequest reservationsResizeRequestResource
                         * @property {string|null} [zone] ResizeReservationRequest zone
                         */
    
                        /**
                         * Constructs a new ResizeReservationRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResizeReservationRequest.
                         * @implements IResizeReservationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IResizeReservationRequest=} [properties] Properties to set
                         */
                        function ResizeReservationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResizeReservationRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ResizeReservationRequest
                         * @instance
                         */
                        ResizeReservationRequest.prototype.project = "";
    
                        /**
                         * ResizeReservationRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.ResizeReservationRequest
                         * @instance
                         */
                        ResizeReservationRequest.prototype.requestId = null;
    
                        /**
                         * ResizeReservationRequest reservation.
                         * @member {string} reservation
                         * @memberof google.cloud.compute.v1.ResizeReservationRequest
                         * @instance
                         */
                        ResizeReservationRequest.prototype.reservation = "";
    
                        /**
                         * ResizeReservationRequest reservationsResizeRequestResource.
                         * @member {google.cloud.compute.v1.IReservationsResizeRequest|null|undefined} reservationsResizeRequestResource
                         * @memberof google.cloud.compute.v1.ResizeReservationRequest
                         * @instance
                         */
                        ResizeReservationRequest.prototype.reservationsResizeRequestResource = null;
    
                        /**
                         * ResizeReservationRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ResizeReservationRequest
                         * @instance
                         */
                        ResizeReservationRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResizeReservationRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.ResizeReservationRequest
                         * @instance
                         */
                        Object.defineProperty(ResizeReservationRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResizeReservationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResizeReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResizeReservationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResizeReservationRequest} ResizeReservationRequest instance
                         */
                        ResizeReservationRequest.create = function create(properties) {
                            return new ResizeReservationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ResizeReservationRequest message. Does not implicitly {@link google.cloud.compute.v1.ResizeReservationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResizeReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResizeReservationRequest} message ResizeReservationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResizeReservationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.reservation != null && Object.hasOwnProperty.call(message, "reservation"))
                                writer.uint32(/* id 47530956, wireType 2 =*/380247650).string(message.reservation);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.reservationsResizeRequestResource != null && Object.hasOwnProperty.call(message, "reservationsResizeRequestResource"))
                                $root.google.cloud.compute.v1.ReservationsResizeRequest.encode(message.reservationsResizeRequestResource, writer.uint32(/* id 389262801, wireType 2 =*/3114102410).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResizeReservationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResizeReservationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResizeReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResizeReservationRequest} message ResizeReservationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResizeReservationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResizeReservationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResizeReservationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResizeReservationRequest} ResizeReservationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResizeReservationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResizeReservationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 47530956: {
                                        message.reservation = reader.string();
                                        break;
                                    }
                                case 389262801: {
                                        message.reservationsResizeRequestResource = $root.google.cloud.compute.v1.ReservationsResizeRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResizeReservationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResizeReservationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResizeReservationRequest} ResizeReservationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResizeReservationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResizeReservationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResizeReservationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResizeReservationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.reservation != null && message.hasOwnProperty("reservation"))
                                if (!$util.isString(message.reservation))
                                    return "reservation: string expected";
                            if (message.reservationsResizeRequestResource != null && message.hasOwnProperty("reservationsResizeRequestResource")) {
                                var error = $root.google.cloud.compute.v1.ReservationsResizeRequest.verify(message.reservationsResizeRequestResource);
                                if (error)
                                    return "reservationsResizeRequestResource." + error;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ResizeReservationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResizeReservationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResizeReservationRequest} ResizeReservationRequest
                         */
                        ResizeReservationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResizeReservationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResizeReservationRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.reservation != null)
                                message.reservation = String(object.reservation);
                            if (object.reservationsResizeRequestResource != null) {
                                if (typeof object.reservationsResizeRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResizeReservationRequest.reservationsResizeRequestResource: object expected");
                                message.reservationsResizeRequestResource = $root.google.cloud.compute.v1.ReservationsResizeRequest.fromObject(object.reservationsResizeRequestResource);
                            }
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResizeReservationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResizeReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.ResizeReservationRequest} message ResizeReservationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResizeReservationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.reservation = "";
                                object.project = "";
                                object.reservationsResizeRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.reservation != null && message.hasOwnProperty("reservation"))
                                object.reservation = message.reservation;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.reservationsResizeRequestResource != null && message.hasOwnProperty("reservationsResizeRequestResource"))
                                object.reservationsResizeRequestResource = $root.google.cloud.compute.v1.ReservationsResizeRequest.toObject(message.reservationsResizeRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this ResizeReservationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResizeReservationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResizeReservationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResizeReservationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResizeReservationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResizeReservationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResizeReservationRequest";
                        };
    
                        return ResizeReservationRequest;
                    })();
    
                    v1.ResourceCommitment = (function() {
    
                        /**
                         * Properties of a ResourceCommitment.
                         * @memberof google.cloud.compute.v1
                         * @interface IResourceCommitment
                         * @property {string|null} [acceleratorType] ResourceCommitment acceleratorType
                         * @property {number|Long|null} [amount] ResourceCommitment amount
                         * @property {string|null} [type] ResourceCommitment type
                         */
    
                        /**
                         * Constructs a new ResourceCommitment.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourceCommitment.
                         * @implements IResourceCommitment
                         * @constructor
                         * @param {google.cloud.compute.v1.IResourceCommitment=} [properties] Properties to set
                         */
                        function ResourceCommitment(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResourceCommitment acceleratorType.
                         * @member {string|null|undefined} acceleratorType
                         * @memberof google.cloud.compute.v1.ResourceCommitment
                         * @instance
                         */
                        ResourceCommitment.prototype.acceleratorType = null;
    
                        /**
                         * ResourceCommitment amount.
                         * @member {number|Long|null|undefined} amount
                         * @memberof google.cloud.compute.v1.ResourceCommitment
                         * @instance
                         */
                        ResourceCommitment.prototype.amount = null;
    
                        /**
                         * ResourceCommitment type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.ResourceCommitment
                         * @instance
                         */
                        ResourceCommitment.prototype.type = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResourceCommitment _acceleratorType.
                         * @member {"acceleratorType"|undefined} _acceleratorType
                         * @memberof google.cloud.compute.v1.ResourceCommitment
                         * @instance
                         */
                        Object.defineProperty(ResourceCommitment.prototype, "_acceleratorType", {
                            get: $util.oneOfGetter($oneOfFields = ["acceleratorType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourceCommitment _amount.
                         * @member {"amount"|undefined} _amount
                         * @memberof google.cloud.compute.v1.ResourceCommitment
                         * @instance
                         */
                        Object.defineProperty(ResourceCommitment.prototype, "_amount", {
                            get: $util.oneOfGetter($oneOfFields = ["amount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourceCommitment _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.ResourceCommitment
                         * @instance
                         */
                        Object.defineProperty(ResourceCommitment.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResourceCommitment instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourceCommitment
                         * @static
                         * @param {google.cloud.compute.v1.IResourceCommitment=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResourceCommitment} ResourceCommitment instance
                         */
                        ResourceCommitment.create = function create(properties) {
                            return new ResourceCommitment(properties);
                        };
    
                        /**
                         * Encodes the specified ResourceCommitment message. Does not implicitly {@link google.cloud.compute.v1.ResourceCommitment.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResourceCommitment
                         * @static
                         * @param {google.cloud.compute.v1.IResourceCommitment} message ResourceCommitment message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourceCommitment.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            if (message.acceleratorType != null && Object.hasOwnProperty.call(message, "acceleratorType"))
                                writer.uint32(/* id 138031246, wireType 2 =*/1104249970).string(message.acceleratorType);
                            if (message.amount != null && Object.hasOwnProperty.call(message, "amount"))
                                writer.uint32(/* id 196759640, wireType 0 =*/1574077120).int64(message.amount);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResourceCommitment message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResourceCommitment.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResourceCommitment
                         * @static
                         * @param {google.cloud.compute.v1.IResourceCommitment} message ResourceCommitment message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourceCommitment.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResourceCommitment message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResourceCommitment
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResourceCommitment} ResourceCommitment
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourceCommitment.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResourceCommitment();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 138031246: {
                                        message.acceleratorType = reader.string();
                                        break;
                                    }
                                case 196759640: {
                                        message.amount = reader.int64();
                                        break;
                                    }
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResourceCommitment message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResourceCommitment
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResourceCommitment} ResourceCommitment
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourceCommitment.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResourceCommitment message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResourceCommitment
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourceCommitment.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.acceleratorType != null && message.hasOwnProperty("acceleratorType")) {
                                properties._acceleratorType = 1;
                                if (!$util.isString(message.acceleratorType))
                                    return "acceleratorType: string expected";
                            }
                            if (message.amount != null && message.hasOwnProperty("amount")) {
                                properties._amount = 1;
                                if (!$util.isInteger(message.amount) && !(message.amount && $util.isInteger(message.amount.low) && $util.isInteger(message.amount.high)))
                                    return "amount: integer|Long expected";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResourceCommitment message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResourceCommitment
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResourceCommitment} ResourceCommitment
                         */
                        ResourceCommitment.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResourceCommitment)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResourceCommitment();
                            if (object.acceleratorType != null)
                                message.acceleratorType = String(object.acceleratorType);
                            if (object.amount != null)
                                if ($util.Long)
                                    (message.amount = $util.Long.fromValue(object.amount)).unsigned = false;
                                else if (typeof object.amount === "string")
                                    message.amount = parseInt(object.amount, 10);
                                else if (typeof object.amount === "number")
                                    message.amount = object.amount;
                                else if (typeof object.amount === "object")
                                    message.amount = new $util.LongBits(object.amount.low >>> 0, object.amount.high >>> 0).toNumber();
                            if (object.type != null)
                                message.type = String(object.type);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResourceCommitment message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResourceCommitment
                         * @static
                         * @param {google.cloud.compute.v1.ResourceCommitment} message ResourceCommitment
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourceCommitment.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            if (message.acceleratorType != null && message.hasOwnProperty("acceleratorType")) {
                                object.acceleratorType = message.acceleratorType;
                                if (options.oneofs)
                                    object._acceleratorType = "acceleratorType";
                            }
                            if (message.amount != null && message.hasOwnProperty("amount")) {
                                if (typeof message.amount === "number")
                                    object.amount = options.longs === String ? String(message.amount) : message.amount;
                                else
                                    object.amount = options.longs === String ? $util.Long.prototype.toString.call(message.amount) : options.longs === Number ? new $util.LongBits(message.amount.low >>> 0, message.amount.high >>> 0).toNumber() : message.amount;
                                if (options.oneofs)
                                    object._amount = "amount";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ResourceCommitment to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResourceCommitment
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourceCommitment.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResourceCommitment
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResourceCommitment
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResourceCommitment.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResourceCommitment";
                        };
    
                        /**
                         * Type enum.
                         * @name google.cloud.compute.v1.ResourceCommitment.Type
                         * @enum {number}
                         * @property {number} UNDEFINED_TYPE=0 UNDEFINED_TYPE value
                         * @property {number} ACCELERATOR=429815371 ACCELERATOR value
                         * @property {number} LOCAL_SSD=508934896 LOCAL_SSD value
                         * @property {number} MEMORY=123056385 MEMORY value
                         * @property {number} UNSPECIFIED=526786327 UNSPECIFIED value
                         * @property {number} VCPU=2628978 VCPU value
                         */
                        ResourceCommitment.Type = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TYPE"] = 0;
                            values[valuesById[429815371] = "ACCELERATOR"] = 429815371;
                            values[valuesById[508934896] = "LOCAL_SSD"] = 508934896;
                            values[valuesById[123056385] = "MEMORY"] = 123056385;
                            values[valuesById[526786327] = "UNSPECIFIED"] = 526786327;
                            values[valuesById[2628978] = "VCPU"] = 2628978;
                            return values;
                        })();
    
                        return ResourceCommitment;
                    })();
    
                    v1.ResourceGroupReference = (function() {
    
                        /**
                         * Properties of a ResourceGroupReference.
                         * @memberof google.cloud.compute.v1
                         * @interface IResourceGroupReference
                         * @property {string|null} [group] ResourceGroupReference group
                         */
    
                        /**
                         * Constructs a new ResourceGroupReference.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourceGroupReference.
                         * @implements IResourceGroupReference
                         * @constructor
                         * @param {google.cloud.compute.v1.IResourceGroupReference=} [properties] Properties to set
                         */
                        function ResourceGroupReference(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResourceGroupReference group.
                         * @member {string|null|undefined} group
                         * @memberof google.cloud.compute.v1.ResourceGroupReference
                         * @instance
                         */
                        ResourceGroupReference.prototype.group = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResourceGroupReference _group.
                         * @member {"group"|undefined} _group
                         * @memberof google.cloud.compute.v1.ResourceGroupReference
                         * @instance
                         */
                        Object.defineProperty(ResourceGroupReference.prototype, "_group", {
                            get: $util.oneOfGetter($oneOfFields = ["group"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResourceGroupReference instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourceGroupReference
                         * @static
                         * @param {google.cloud.compute.v1.IResourceGroupReference=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResourceGroupReference} ResourceGroupReference instance
                         */
                        ResourceGroupReference.create = function create(properties) {
                            return new ResourceGroupReference(properties);
                        };
    
                        /**
                         * Encodes the specified ResourceGroupReference message. Does not implicitly {@link google.cloud.compute.v1.ResourceGroupReference.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResourceGroupReference
                         * @static
                         * @param {google.cloud.compute.v1.IResourceGroupReference} message ResourceGroupReference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourceGroupReference.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.group != null && Object.hasOwnProperty.call(message, "group"))
                                writer.uint32(/* id 98629247, wireType 2 =*/789033978).string(message.group);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResourceGroupReference message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResourceGroupReference.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResourceGroupReference
                         * @static
                         * @param {google.cloud.compute.v1.IResourceGroupReference} message ResourceGroupReference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourceGroupReference.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResourceGroupReference message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResourceGroupReference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResourceGroupReference} ResourceGroupReference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourceGroupReference.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResourceGroupReference();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 98629247: {
                                        message.group = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResourceGroupReference message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResourceGroupReference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResourceGroupReference} ResourceGroupReference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourceGroupReference.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResourceGroupReference message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResourceGroupReference
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourceGroupReference.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.group != null && message.hasOwnProperty("group")) {
                                properties._group = 1;
                                if (!$util.isString(message.group))
                                    return "group: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResourceGroupReference message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResourceGroupReference
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResourceGroupReference} ResourceGroupReference
                         */
                        ResourceGroupReference.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResourceGroupReference)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResourceGroupReference();
                            if (object.group != null)
                                message.group = String(object.group);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResourceGroupReference message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResourceGroupReference
                         * @static
                         * @param {google.cloud.compute.v1.ResourceGroupReference} message ResourceGroupReference
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourceGroupReference.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.group != null && message.hasOwnProperty("group")) {
                                object.group = message.group;
                                if (options.oneofs)
                                    object._group = "group";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ResourceGroupReference to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResourceGroupReference
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourceGroupReference.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResourceGroupReference
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResourceGroupReference
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResourceGroupReference.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResourceGroupReference";
                        };
    
                        return ResourceGroupReference;
                    })();
    
                    v1.ResourcePoliciesScopedList = (function() {
    
                        /**
                         * Properties of a ResourcePoliciesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IResourcePoliciesScopedList
                         * @property {Array.<google.cloud.compute.v1.IResourcePolicy>|null} [resourcePolicies] ResourcePoliciesScopedList resourcePolicies
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] ResourcePoliciesScopedList warning
                         */
    
                        /**
                         * Constructs a new ResourcePoliciesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourcePoliciesScopedList.
                         * @implements IResourcePoliciesScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IResourcePoliciesScopedList=} [properties] Properties to set
                         */
                        function ResourcePoliciesScopedList(properties) {
                            this.resourcePolicies = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResourcePoliciesScopedList resourcePolicies.
                         * @member {Array.<google.cloud.compute.v1.IResourcePolicy>} resourcePolicies
                         * @memberof google.cloud.compute.v1.ResourcePoliciesScopedList
                         * @instance
                         */
                        ResourcePoliciesScopedList.prototype.resourcePolicies = $util.emptyArray;
    
                        /**
                         * ResourcePoliciesScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.ResourcePoliciesScopedList
                         * @instance
                         */
                        ResourcePoliciesScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResourcePoliciesScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.ResourcePoliciesScopedList
                         * @instance
                         */
                        Object.defineProperty(ResourcePoliciesScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResourcePoliciesScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourcePoliciesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePoliciesScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResourcePoliciesScopedList} ResourcePoliciesScopedList instance
                         */
                        ResourcePoliciesScopedList.create = function create(properties) {
                            return new ResourcePoliciesScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified ResourcePoliciesScopedList message. Does not implicitly {@link google.cloud.compute.v1.ResourcePoliciesScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResourcePoliciesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePoliciesScopedList} message ResourcePoliciesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePoliciesScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resourcePolicies != null && message.resourcePolicies.length)
                                for (var i = 0; i < message.resourcePolicies.length; ++i)
                                    $root.google.cloud.compute.v1.ResourcePolicy.encode(message.resourcePolicies[i], writer.uint32(/* id 22220385, wireType 2 =*/177763082).fork()).ldelim();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResourcePoliciesScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResourcePoliciesScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePoliciesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePoliciesScopedList} message ResourcePoliciesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePoliciesScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResourcePoliciesScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResourcePoliciesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResourcePoliciesScopedList} ResourcePoliciesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePoliciesScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResourcePoliciesScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 22220385: {
                                        if (!(message.resourcePolicies && message.resourcePolicies.length))
                                            message.resourcePolicies = [];
                                        message.resourcePolicies.push($root.google.cloud.compute.v1.ResourcePolicy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResourcePoliciesScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePoliciesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResourcePoliciesScopedList} ResourcePoliciesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePoliciesScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResourcePoliciesScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResourcePoliciesScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourcePoliciesScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resourcePolicies != null && message.hasOwnProperty("resourcePolicies")) {
                                if (!Array.isArray(message.resourcePolicies))
                                    return "resourcePolicies: array expected";
                                for (var i = 0; i < message.resourcePolicies.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ResourcePolicy.verify(message.resourcePolicies[i]);
                                    if (error)
                                        return "resourcePolicies." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResourcePoliciesScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResourcePoliciesScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResourcePoliciesScopedList} ResourcePoliciesScopedList
                         */
                        ResourcePoliciesScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResourcePoliciesScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResourcePoliciesScopedList();
                            if (object.resourcePolicies) {
                                if (!Array.isArray(object.resourcePolicies))
                                    throw TypeError(".google.cloud.compute.v1.ResourcePoliciesScopedList.resourcePolicies: array expected");
                                message.resourcePolicies = [];
                                for (var i = 0; i < object.resourcePolicies.length; ++i) {
                                    if (typeof object.resourcePolicies[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ResourcePoliciesScopedList.resourcePolicies: object expected");
                                    message.resourcePolicies[i] = $root.google.cloud.compute.v1.ResourcePolicy.fromObject(object.resourcePolicies[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResourcePoliciesScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResourcePoliciesScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResourcePoliciesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ResourcePoliciesScopedList} message ResourcePoliciesScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourcePoliciesScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.resourcePolicies = [];
                            if (message.resourcePolicies && message.resourcePolicies.length) {
                                object.resourcePolicies = [];
                                for (var j = 0; j < message.resourcePolicies.length; ++j)
                                    object.resourcePolicies[j] = $root.google.cloud.compute.v1.ResourcePolicy.toObject(message.resourcePolicies[j], options);
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ResourcePoliciesScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResourcePoliciesScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourcePoliciesScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResourcePoliciesScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResourcePoliciesScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResourcePoliciesScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResourcePoliciesScopedList";
                        };
    
                        return ResourcePoliciesScopedList;
                    })();
    
                    v1.ResourcePolicy = (function() {
    
                        /**
                         * Properties of a ResourcePolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IResourcePolicy
                         * @property {string|null} [creationTimestamp] ResourcePolicy creationTimestamp
                         * @property {string|null} [description] ResourcePolicy description
                         * @property {google.cloud.compute.v1.IResourcePolicyGroupPlacementPolicy|null} [groupPlacementPolicy] ResourcePolicy groupPlacementPolicy
                         * @property {number|Long|null} [id] ResourcePolicy id
                         * @property {google.cloud.compute.v1.IResourcePolicyInstanceSchedulePolicy|null} [instanceSchedulePolicy] ResourcePolicy instanceSchedulePolicy
                         * @property {string|null} [kind] ResourcePolicy kind
                         * @property {string|null} [name] ResourcePolicy name
                         * @property {string|null} [region] ResourcePolicy region
                         * @property {google.cloud.compute.v1.IResourcePolicyResourceStatus|null} [resourceStatus] ResourcePolicy resourceStatus
                         * @property {string|null} [selfLink] ResourcePolicy selfLink
                         * @property {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicy|null} [snapshotSchedulePolicy] ResourcePolicy snapshotSchedulePolicy
                         * @property {string|null} [status] ResourcePolicy status
                         */
    
                        /**
                         * Constructs a new ResourcePolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourcePolicy.
                         * @implements IResourcePolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IResourcePolicy=} [properties] Properties to set
                         */
                        function ResourcePolicy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResourcePolicy creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        ResourcePolicy.prototype.creationTimestamp = null;
    
                        /**
                         * ResourcePolicy description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        ResourcePolicy.prototype.description = null;
    
                        /**
                         * ResourcePolicy groupPlacementPolicy.
                         * @member {google.cloud.compute.v1.IResourcePolicyGroupPlacementPolicy|null|undefined} groupPlacementPolicy
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        ResourcePolicy.prototype.groupPlacementPolicy = null;
    
                        /**
                         * ResourcePolicy id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        ResourcePolicy.prototype.id = null;
    
                        /**
                         * ResourcePolicy instanceSchedulePolicy.
                         * @member {google.cloud.compute.v1.IResourcePolicyInstanceSchedulePolicy|null|undefined} instanceSchedulePolicy
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        ResourcePolicy.prototype.instanceSchedulePolicy = null;
    
                        /**
                         * ResourcePolicy kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        ResourcePolicy.prototype.kind = null;
    
                        /**
                         * ResourcePolicy name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        ResourcePolicy.prototype.name = null;
    
                        /**
                         * ResourcePolicy region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        ResourcePolicy.prototype.region = null;
    
                        /**
                         * ResourcePolicy resourceStatus.
                         * @member {google.cloud.compute.v1.IResourcePolicyResourceStatus|null|undefined} resourceStatus
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        ResourcePolicy.prototype.resourceStatus = null;
    
                        /**
                         * ResourcePolicy selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        ResourcePolicy.prototype.selfLink = null;
    
                        /**
                         * ResourcePolicy snapshotSchedulePolicy.
                         * @member {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicy|null|undefined} snapshotSchedulePolicy
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        ResourcePolicy.prototype.snapshotSchedulePolicy = null;
    
                        /**
                         * ResourcePolicy status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        ResourcePolicy.prototype.status = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResourcePolicy _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicy.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicy _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicy.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicy _groupPlacementPolicy.
                         * @member {"groupPlacementPolicy"|undefined} _groupPlacementPolicy
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicy.prototype, "_groupPlacementPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["groupPlacementPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicy _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicy.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicy _instanceSchedulePolicy.
                         * @member {"instanceSchedulePolicy"|undefined} _instanceSchedulePolicy
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicy.prototype, "_instanceSchedulePolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["instanceSchedulePolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicy _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicy.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicy _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicy.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicy _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicy.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicy _resourceStatus.
                         * @member {"resourceStatus"|undefined} _resourceStatus
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicy.prototype, "_resourceStatus", {
                            get: $util.oneOfGetter($oneOfFields = ["resourceStatus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicy _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicy.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicy _snapshotSchedulePolicy.
                         * @member {"snapshotSchedulePolicy"|undefined} _snapshotSchedulePolicy
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicy.prototype, "_snapshotSchedulePolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["snapshotSchedulePolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicy _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicy.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResourcePolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResourcePolicy} ResourcePolicy instance
                         */
                        ResourcePolicy.create = function create(properties) {
                            return new ResourcePolicy(properties);
                        };
    
                        /**
                         * Encodes the specified ResourcePolicy message. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicy} message ResourcePolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.groupPlacementPolicy != null && Object.hasOwnProperty.call(message, "groupPlacementPolicy"))
                                $root.google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy.encode(message.groupPlacementPolicy, writer.uint32(/* id 10931596, wireType 2 =*/87452770).fork()).ldelim();
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.snapshotSchedulePolicy != null && Object.hasOwnProperty.call(message, "snapshotSchedulePolicy"))
                                $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy.encode(message.snapshotSchedulePolicy, writer.uint32(/* id 218131295, wireType 2 =*/1745050362).fork()).ldelim();
                            if (message.resourceStatus != null && Object.hasOwnProperty.call(message, "resourceStatus"))
                                $root.google.cloud.compute.v1.ResourcePolicyResourceStatus.encode(message.resourceStatus, writer.uint32(/* id 249429315, wireType 2 =*/1995434522).fork()).ldelim();
                            if (message.instanceSchedulePolicy != null && Object.hasOwnProperty.call(message, "instanceSchedulePolicy"))
                                $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy.encode(message.instanceSchedulePolicy, writer.uint32(/* id 344877104, wireType 2 =*/2759016834).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResourcePolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicy} message ResourcePolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResourcePolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResourcePolicy} ResourcePolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResourcePolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 10931596: {
                                        message.groupPlacementPolicy = $root.google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 344877104: {
                                        message.instanceSchedulePolicy = $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 249429315: {
                                        message.resourceStatus = $root.google.cloud.compute.v1.ResourcePolicyResourceStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 218131295: {
                                        message.snapshotSchedulePolicy = $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResourcePolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResourcePolicy} ResourcePolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResourcePolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourcePolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.groupPlacementPolicy != null && message.hasOwnProperty("groupPlacementPolicy")) {
                                properties._groupPlacementPolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy.verify(message.groupPlacementPolicy);
                                    if (error)
                                        return "groupPlacementPolicy." + error;
                                }
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.instanceSchedulePolicy != null && message.hasOwnProperty("instanceSchedulePolicy")) {
                                properties._instanceSchedulePolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy.verify(message.instanceSchedulePolicy);
                                    if (error)
                                        return "instanceSchedulePolicy." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.resourceStatus != null && message.hasOwnProperty("resourceStatus")) {
                                properties._resourceStatus = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ResourcePolicyResourceStatus.verify(message.resourceStatus);
                                    if (error)
                                        return "resourceStatus." + error;
                                }
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.snapshotSchedulePolicy != null && message.hasOwnProperty("snapshotSchedulePolicy")) {
                                properties._snapshotSchedulePolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy.verify(message.snapshotSchedulePolicy);
                                    if (error)
                                        return "snapshotSchedulePolicy." + error;
                                }
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResourcePolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResourcePolicy} ResourcePolicy
                         */
                        ResourcePolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResourcePolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResourcePolicy();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.groupPlacementPolicy != null) {
                                if (typeof object.groupPlacementPolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicy.groupPlacementPolicy: object expected");
                                message.groupPlacementPolicy = $root.google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy.fromObject(object.groupPlacementPolicy);
                            }
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.instanceSchedulePolicy != null) {
                                if (typeof object.instanceSchedulePolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicy.instanceSchedulePolicy: object expected");
                                message.instanceSchedulePolicy = $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy.fromObject(object.instanceSchedulePolicy);
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.resourceStatus != null) {
                                if (typeof object.resourceStatus !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicy.resourceStatus: object expected");
                                message.resourceStatus = $root.google.cloud.compute.v1.ResourcePolicyResourceStatus.fromObject(object.resourceStatus);
                            }
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.snapshotSchedulePolicy != null) {
                                if (typeof object.snapshotSchedulePolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicy.snapshotSchedulePolicy: object expected");
                                message.snapshotSchedulePolicy = $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy.fromObject(object.snapshotSchedulePolicy);
                            }
                            if (object.status != null)
                                message.status = String(object.status);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResourcePolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @static
                         * @param {google.cloud.compute.v1.ResourcePolicy} message ResourcePolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourcePolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.groupPlacementPolicy != null && message.hasOwnProperty("groupPlacementPolicy")) {
                                object.groupPlacementPolicy = $root.google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy.toObject(message.groupPlacementPolicy, options);
                                if (options.oneofs)
                                    object._groupPlacementPolicy = "groupPlacementPolicy";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.snapshotSchedulePolicy != null && message.hasOwnProperty("snapshotSchedulePolicy")) {
                                object.snapshotSchedulePolicy = $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy.toObject(message.snapshotSchedulePolicy, options);
                                if (options.oneofs)
                                    object._snapshotSchedulePolicy = "snapshotSchedulePolicy";
                            }
                            if (message.resourceStatus != null && message.hasOwnProperty("resourceStatus")) {
                                object.resourceStatus = $root.google.cloud.compute.v1.ResourcePolicyResourceStatus.toObject(message.resourceStatus, options);
                                if (options.oneofs)
                                    object._resourceStatus = "resourceStatus";
                            }
                            if (message.instanceSchedulePolicy != null && message.hasOwnProperty("instanceSchedulePolicy")) {
                                object.instanceSchedulePolicy = $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy.toObject(message.instanceSchedulePolicy, options);
                                if (options.oneofs)
                                    object._instanceSchedulePolicy = "instanceSchedulePolicy";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ResourcePolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourcePolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResourcePolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResourcePolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResourcePolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResourcePolicy";
                        };
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.ResourcePolicy.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} CREATING=455564985 CREATING value
                         * @property {number} DELETING=528602024 DELETING value
                         * @property {number} EXPIRED=482489093 EXPIRED value
                         * @property {number} INVALID=530283991 INVALID value
                         * @property {number} READY=77848963 READY value
                         */
                        ResourcePolicy.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[455564985] = "CREATING"] = 455564985;
                            values[valuesById[528602024] = "DELETING"] = 528602024;
                            values[valuesById[482489093] = "EXPIRED"] = 482489093;
                            values[valuesById[530283991] = "INVALID"] = 530283991;
                            values[valuesById[77848963] = "READY"] = 77848963;
                            return values;
                        })();
    
                        return ResourcePolicy;
                    })();
    
                    v1.ResourcePolicyAggregatedList = (function() {
    
                        /**
                         * Properties of a ResourcePolicyAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IResourcePolicyAggregatedList
                         * @property {string|null} [etag] ResourcePolicyAggregatedList etag
                         * @property {string|null} [id] ResourcePolicyAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IResourcePoliciesScopedList>|null} [items] ResourcePolicyAggregatedList items
                         * @property {string|null} [kind] ResourcePolicyAggregatedList kind
                         * @property {string|null} [nextPageToken] ResourcePolicyAggregatedList nextPageToken
                         * @property {string|null} [selfLink] ResourcePolicyAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] ResourcePolicyAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] ResourcePolicyAggregatedList warning
                         */
    
                        /**
                         * Constructs a new ResourcePolicyAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourcePolicyAggregatedList.
                         * @implements IResourcePolicyAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IResourcePolicyAggregatedList=} [properties] Properties to set
                         */
                        function ResourcePolicyAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResourcePolicyAggregatedList etag.
                         * @member {string|null|undefined} etag
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @instance
                         */
                        ResourcePolicyAggregatedList.prototype.etag = null;
    
                        /**
                         * ResourcePolicyAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @instance
                         */
                        ResourcePolicyAggregatedList.prototype.id = null;
    
                        /**
                         * ResourcePolicyAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IResourcePoliciesScopedList>} items
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @instance
                         */
                        ResourcePolicyAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * ResourcePolicyAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @instance
                         */
                        ResourcePolicyAggregatedList.prototype.kind = null;
    
                        /**
                         * ResourcePolicyAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @instance
                         */
                        ResourcePolicyAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * ResourcePolicyAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @instance
                         */
                        ResourcePolicyAggregatedList.prototype.selfLink = null;
    
                        /**
                         * ResourcePolicyAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @instance
                         */
                        ResourcePolicyAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * ResourcePolicyAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @instance
                         */
                        ResourcePolicyAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResourcePolicyAggregatedList _etag.
                         * @member {"etag"|undefined} _etag
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyAggregatedList.prototype, "_etag", {
                            get: $util.oneOfGetter($oneOfFields = ["etag"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResourcePolicyAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResourcePolicyAggregatedList} ResourcePolicyAggregatedList instance
                         */
                        ResourcePolicyAggregatedList.create = function create(properties) {
                            return new ResourcePolicyAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyAggregatedList} message ResourcePolicyAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.etag != null && Object.hasOwnProperty.call(message, "etag"))
                                writer.uint32(/* id 3123477, wireType 2 =*/24987818).string(message.etag);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.ResourcePoliciesScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyAggregatedList} message ResourcePolicyAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResourcePolicyAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResourcePolicyAggregatedList} ResourcePolicyAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResourcePolicyAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3123477: {
                                        message.etag = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.ResourcePoliciesScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResourcePolicyAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResourcePolicyAggregatedList} ResourcePolicyAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResourcePolicyAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourcePolicyAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                properties._etag = 1;
                                if (!$util.isString(message.etag))
                                    return "etag: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ResourcePoliciesScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResourcePolicyAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResourcePolicyAggregatedList} ResourcePolicyAggregatedList
                         */
                        ResourcePolicyAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResourcePolicyAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResourcePolicyAggregatedList();
                            if (object.etag != null)
                                message.etag = String(object.etag);
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicyAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ResourcePolicyAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.ResourcePoliciesScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicyAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicyAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResourcePolicyAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ResourcePolicyAggregatedList} message ResourcePolicyAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourcePolicyAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                object.etag = message.etag;
                                if (options.oneofs)
                                    object._etag = "etag";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.ResourcePoliciesScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ResourcePolicyAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourcePolicyAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResourcePolicyAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResourcePolicyAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResourcePolicyAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResourcePolicyAggregatedList";
                        };
    
                        return ResourcePolicyAggregatedList;
                    })();
    
                    v1.ResourcePolicyDailyCycle = (function() {
    
                        /**
                         * Properties of a ResourcePolicyDailyCycle.
                         * @memberof google.cloud.compute.v1
                         * @interface IResourcePolicyDailyCycle
                         * @property {number|null} [daysInCycle] ResourcePolicyDailyCycle daysInCycle
                         * @property {string|null} [duration] ResourcePolicyDailyCycle duration
                         * @property {string|null} [startTime] ResourcePolicyDailyCycle startTime
                         */
    
                        /**
                         * Constructs a new ResourcePolicyDailyCycle.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourcePolicyDailyCycle.
                         * @implements IResourcePolicyDailyCycle
                         * @constructor
                         * @param {google.cloud.compute.v1.IResourcePolicyDailyCycle=} [properties] Properties to set
                         */
                        function ResourcePolicyDailyCycle(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResourcePolicyDailyCycle daysInCycle.
                         * @member {number|null|undefined} daysInCycle
                         * @memberof google.cloud.compute.v1.ResourcePolicyDailyCycle
                         * @instance
                         */
                        ResourcePolicyDailyCycle.prototype.daysInCycle = null;
    
                        /**
                         * ResourcePolicyDailyCycle duration.
                         * @member {string|null|undefined} duration
                         * @memberof google.cloud.compute.v1.ResourcePolicyDailyCycle
                         * @instance
                         */
                        ResourcePolicyDailyCycle.prototype.duration = null;
    
                        /**
                         * ResourcePolicyDailyCycle startTime.
                         * @member {string|null|undefined} startTime
                         * @memberof google.cloud.compute.v1.ResourcePolicyDailyCycle
                         * @instance
                         */
                        ResourcePolicyDailyCycle.prototype.startTime = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResourcePolicyDailyCycle _daysInCycle.
                         * @member {"daysInCycle"|undefined} _daysInCycle
                         * @memberof google.cloud.compute.v1.ResourcePolicyDailyCycle
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyDailyCycle.prototype, "_daysInCycle", {
                            get: $util.oneOfGetter($oneOfFields = ["daysInCycle"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyDailyCycle _duration.
                         * @member {"duration"|undefined} _duration
                         * @memberof google.cloud.compute.v1.ResourcePolicyDailyCycle
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyDailyCycle.prototype, "_duration", {
                            get: $util.oneOfGetter($oneOfFields = ["duration"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyDailyCycle _startTime.
                         * @member {"startTime"|undefined} _startTime
                         * @memberof google.cloud.compute.v1.ResourcePolicyDailyCycle
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyDailyCycle.prototype, "_startTime", {
                            get: $util.oneOfGetter($oneOfFields = ["startTime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResourcePolicyDailyCycle instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourcePolicyDailyCycle
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyDailyCycle=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResourcePolicyDailyCycle} ResourcePolicyDailyCycle instance
                         */
                        ResourcePolicyDailyCycle.create = function create(properties) {
                            return new ResourcePolicyDailyCycle(properties);
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyDailyCycle message. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyDailyCycle.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResourcePolicyDailyCycle
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyDailyCycle} message ResourcePolicyDailyCycle message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyDailyCycle.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.startTime != null && Object.hasOwnProperty.call(message, "startTime"))
                                writer.uint32(/* id 37467274, wireType 2 =*/299738194).string(message.startTime);
                            if (message.duration != null && Object.hasOwnProperty.call(message, "duration"))
                                writer.uint32(/* id 155471252, wireType 2 =*/1243770018).string(message.duration);
                            if (message.daysInCycle != null && Object.hasOwnProperty.call(message, "daysInCycle"))
                                writer.uint32(/* id 369790004, wireType 0 =*/2958320032).int32(message.daysInCycle);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyDailyCycle message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyDailyCycle.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyDailyCycle
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyDailyCycle} message ResourcePolicyDailyCycle message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyDailyCycle.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResourcePolicyDailyCycle message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResourcePolicyDailyCycle
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResourcePolicyDailyCycle} ResourcePolicyDailyCycle
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyDailyCycle.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResourcePolicyDailyCycle();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 369790004: {
                                        message.daysInCycle = reader.int32();
                                        break;
                                    }
                                case 155471252: {
                                        message.duration = reader.string();
                                        break;
                                    }
                                case 37467274: {
                                        message.startTime = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResourcePolicyDailyCycle message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyDailyCycle
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResourcePolicyDailyCycle} ResourcePolicyDailyCycle
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyDailyCycle.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResourcePolicyDailyCycle message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResourcePolicyDailyCycle
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourcePolicyDailyCycle.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.daysInCycle != null && message.hasOwnProperty("daysInCycle")) {
                                properties._daysInCycle = 1;
                                if (!$util.isInteger(message.daysInCycle))
                                    return "daysInCycle: integer expected";
                            }
                            if (message.duration != null && message.hasOwnProperty("duration")) {
                                properties._duration = 1;
                                if (!$util.isString(message.duration))
                                    return "duration: string expected";
                            }
                            if (message.startTime != null && message.hasOwnProperty("startTime")) {
                                properties._startTime = 1;
                                if (!$util.isString(message.startTime))
                                    return "startTime: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResourcePolicyDailyCycle message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyDailyCycle
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResourcePolicyDailyCycle} ResourcePolicyDailyCycle
                         */
                        ResourcePolicyDailyCycle.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResourcePolicyDailyCycle)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResourcePolicyDailyCycle();
                            if (object.daysInCycle != null)
                                message.daysInCycle = object.daysInCycle | 0;
                            if (object.duration != null)
                                message.duration = String(object.duration);
                            if (object.startTime != null)
                                message.startTime = String(object.startTime);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResourcePolicyDailyCycle message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyDailyCycle
                         * @static
                         * @param {google.cloud.compute.v1.ResourcePolicyDailyCycle} message ResourcePolicyDailyCycle
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourcePolicyDailyCycle.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.startTime != null && message.hasOwnProperty("startTime")) {
                                object.startTime = message.startTime;
                                if (options.oneofs)
                                    object._startTime = "startTime";
                            }
                            if (message.duration != null && message.hasOwnProperty("duration")) {
                                object.duration = message.duration;
                                if (options.oneofs)
                                    object._duration = "duration";
                            }
                            if (message.daysInCycle != null && message.hasOwnProperty("daysInCycle")) {
                                object.daysInCycle = message.daysInCycle;
                                if (options.oneofs)
                                    object._daysInCycle = "daysInCycle";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ResourcePolicyDailyCycle to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResourcePolicyDailyCycle
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourcePolicyDailyCycle.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResourcePolicyDailyCycle
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResourcePolicyDailyCycle
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResourcePolicyDailyCycle.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResourcePolicyDailyCycle";
                        };
    
                        return ResourcePolicyDailyCycle;
                    })();
    
                    v1.ResourcePolicyGroupPlacementPolicy = (function() {
    
                        /**
                         * Properties of a ResourcePolicyGroupPlacementPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IResourcePolicyGroupPlacementPolicy
                         * @property {number|null} [availabilityDomainCount] ResourcePolicyGroupPlacementPolicy availabilityDomainCount
                         * @property {string|null} [collocation] ResourcePolicyGroupPlacementPolicy collocation
                         * @property {number|null} [vmCount] ResourcePolicyGroupPlacementPolicy vmCount
                         */
    
                        /**
                         * Constructs a new ResourcePolicyGroupPlacementPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourcePolicyGroupPlacementPolicy.
                         * @implements IResourcePolicyGroupPlacementPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IResourcePolicyGroupPlacementPolicy=} [properties] Properties to set
                         */
                        function ResourcePolicyGroupPlacementPolicy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResourcePolicyGroupPlacementPolicy availabilityDomainCount.
                         * @member {number|null|undefined} availabilityDomainCount
                         * @memberof google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy
                         * @instance
                         */
                        ResourcePolicyGroupPlacementPolicy.prototype.availabilityDomainCount = null;
    
                        /**
                         * ResourcePolicyGroupPlacementPolicy collocation.
                         * @member {string|null|undefined} collocation
                         * @memberof google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy
                         * @instance
                         */
                        ResourcePolicyGroupPlacementPolicy.prototype.collocation = null;
    
                        /**
                         * ResourcePolicyGroupPlacementPolicy vmCount.
                         * @member {number|null|undefined} vmCount
                         * @memberof google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy
                         * @instance
                         */
                        ResourcePolicyGroupPlacementPolicy.prototype.vmCount = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResourcePolicyGroupPlacementPolicy _availabilityDomainCount.
                         * @member {"availabilityDomainCount"|undefined} _availabilityDomainCount
                         * @memberof google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyGroupPlacementPolicy.prototype, "_availabilityDomainCount", {
                            get: $util.oneOfGetter($oneOfFields = ["availabilityDomainCount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyGroupPlacementPolicy _collocation.
                         * @member {"collocation"|undefined} _collocation
                         * @memberof google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyGroupPlacementPolicy.prototype, "_collocation", {
                            get: $util.oneOfGetter($oneOfFields = ["collocation"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyGroupPlacementPolicy _vmCount.
                         * @member {"vmCount"|undefined} _vmCount
                         * @memberof google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyGroupPlacementPolicy.prototype, "_vmCount", {
                            get: $util.oneOfGetter($oneOfFields = ["vmCount"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResourcePolicyGroupPlacementPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyGroupPlacementPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy} ResourcePolicyGroupPlacementPolicy instance
                         */
                        ResourcePolicyGroupPlacementPolicy.create = function create(properties) {
                            return new ResourcePolicyGroupPlacementPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyGroupPlacementPolicy message. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyGroupPlacementPolicy} message ResourcePolicyGroupPlacementPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyGroupPlacementPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.availabilityDomainCount != null && Object.hasOwnProperty.call(message, "availabilityDomainCount"))
                                writer.uint32(/* id 12453432, wireType 0 =*/99627456).int32(message.availabilityDomainCount);
                            if (message.vmCount != null && Object.hasOwnProperty.call(message, "vmCount"))
                                writer.uint32(/* id 261463431, wireType 0 =*/2091707448).int32(message.vmCount);
                            if (message.collocation != null && Object.hasOwnProperty.call(message, "collocation"))
                                writer.uint32(/* id 511156533, wireType 2 =*/4089252266).string(message.collocation);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyGroupPlacementPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyGroupPlacementPolicy} message ResourcePolicyGroupPlacementPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyGroupPlacementPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResourcePolicyGroupPlacementPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy} ResourcePolicyGroupPlacementPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyGroupPlacementPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 12453432: {
                                        message.availabilityDomainCount = reader.int32();
                                        break;
                                    }
                                case 511156533: {
                                        message.collocation = reader.string();
                                        break;
                                    }
                                case 261463431: {
                                        message.vmCount = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResourcePolicyGroupPlacementPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy} ResourcePolicyGroupPlacementPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyGroupPlacementPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResourcePolicyGroupPlacementPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourcePolicyGroupPlacementPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.availabilityDomainCount != null && message.hasOwnProperty("availabilityDomainCount")) {
                                properties._availabilityDomainCount = 1;
                                if (!$util.isInteger(message.availabilityDomainCount))
                                    return "availabilityDomainCount: integer expected";
                            }
                            if (message.collocation != null && message.hasOwnProperty("collocation")) {
                                properties._collocation = 1;
                                if (!$util.isString(message.collocation))
                                    return "collocation: string expected";
                            }
                            if (message.vmCount != null && message.hasOwnProperty("vmCount")) {
                                properties._vmCount = 1;
                                if (!$util.isInteger(message.vmCount))
                                    return "vmCount: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResourcePolicyGroupPlacementPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy} ResourcePolicyGroupPlacementPolicy
                         */
                        ResourcePolicyGroupPlacementPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy();
                            if (object.availabilityDomainCount != null)
                                message.availabilityDomainCount = object.availabilityDomainCount | 0;
                            if (object.collocation != null)
                                message.collocation = String(object.collocation);
                            if (object.vmCount != null)
                                message.vmCount = object.vmCount | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResourcePolicyGroupPlacementPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy
                         * @static
                         * @param {google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy} message ResourcePolicyGroupPlacementPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourcePolicyGroupPlacementPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.availabilityDomainCount != null && message.hasOwnProperty("availabilityDomainCount")) {
                                object.availabilityDomainCount = message.availabilityDomainCount;
                                if (options.oneofs)
                                    object._availabilityDomainCount = "availabilityDomainCount";
                            }
                            if (message.vmCount != null && message.hasOwnProperty("vmCount")) {
                                object.vmCount = message.vmCount;
                                if (options.oneofs)
                                    object._vmCount = "vmCount";
                            }
                            if (message.collocation != null && message.hasOwnProperty("collocation")) {
                                object.collocation = message.collocation;
                                if (options.oneofs)
                                    object._collocation = "collocation";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ResourcePolicyGroupPlacementPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourcePolicyGroupPlacementPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResourcePolicyGroupPlacementPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResourcePolicyGroupPlacementPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy";
                        };
    
                        /**
                         * Collocation enum.
                         * @name google.cloud.compute.v1.ResourcePolicyGroupPlacementPolicy.Collocation
                         * @enum {number}
                         * @property {number} UNDEFINED_COLLOCATION=0 UNDEFINED_COLLOCATION value
                         * @property {number} COLLOCATED=103257554 COLLOCATED value
                         * @property {number} UNSPECIFIED_COLLOCATION=464308205 UNSPECIFIED_COLLOCATION value
                         */
                        ResourcePolicyGroupPlacementPolicy.Collocation = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_COLLOCATION"] = 0;
                            values[valuesById[103257554] = "COLLOCATED"] = 103257554;
                            values[valuesById[464308205] = "UNSPECIFIED_COLLOCATION"] = 464308205;
                            return values;
                        })();
    
                        return ResourcePolicyGroupPlacementPolicy;
                    })();
    
                    v1.ResourcePolicyHourlyCycle = (function() {
    
                        /**
                         * Properties of a ResourcePolicyHourlyCycle.
                         * @memberof google.cloud.compute.v1
                         * @interface IResourcePolicyHourlyCycle
                         * @property {string|null} [duration] ResourcePolicyHourlyCycle duration
                         * @property {number|null} [hoursInCycle] ResourcePolicyHourlyCycle hoursInCycle
                         * @property {string|null} [startTime] ResourcePolicyHourlyCycle startTime
                         */
    
                        /**
                         * Constructs a new ResourcePolicyHourlyCycle.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourcePolicyHourlyCycle.
                         * @implements IResourcePolicyHourlyCycle
                         * @constructor
                         * @param {google.cloud.compute.v1.IResourcePolicyHourlyCycle=} [properties] Properties to set
                         */
                        function ResourcePolicyHourlyCycle(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResourcePolicyHourlyCycle duration.
                         * @member {string|null|undefined} duration
                         * @memberof google.cloud.compute.v1.ResourcePolicyHourlyCycle
                         * @instance
                         */
                        ResourcePolicyHourlyCycle.prototype.duration = null;
    
                        /**
                         * ResourcePolicyHourlyCycle hoursInCycle.
                         * @member {number|null|undefined} hoursInCycle
                         * @memberof google.cloud.compute.v1.ResourcePolicyHourlyCycle
                         * @instance
                         */
                        ResourcePolicyHourlyCycle.prototype.hoursInCycle = null;
    
                        /**
                         * ResourcePolicyHourlyCycle startTime.
                         * @member {string|null|undefined} startTime
                         * @memberof google.cloud.compute.v1.ResourcePolicyHourlyCycle
                         * @instance
                         */
                        ResourcePolicyHourlyCycle.prototype.startTime = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResourcePolicyHourlyCycle _duration.
                         * @member {"duration"|undefined} _duration
                         * @memberof google.cloud.compute.v1.ResourcePolicyHourlyCycle
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyHourlyCycle.prototype, "_duration", {
                            get: $util.oneOfGetter($oneOfFields = ["duration"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyHourlyCycle _hoursInCycle.
                         * @member {"hoursInCycle"|undefined} _hoursInCycle
                         * @memberof google.cloud.compute.v1.ResourcePolicyHourlyCycle
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyHourlyCycle.prototype, "_hoursInCycle", {
                            get: $util.oneOfGetter($oneOfFields = ["hoursInCycle"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyHourlyCycle _startTime.
                         * @member {"startTime"|undefined} _startTime
                         * @memberof google.cloud.compute.v1.ResourcePolicyHourlyCycle
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyHourlyCycle.prototype, "_startTime", {
                            get: $util.oneOfGetter($oneOfFields = ["startTime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResourcePolicyHourlyCycle instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourcePolicyHourlyCycle
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyHourlyCycle=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResourcePolicyHourlyCycle} ResourcePolicyHourlyCycle instance
                         */
                        ResourcePolicyHourlyCycle.create = function create(properties) {
                            return new ResourcePolicyHourlyCycle(properties);
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyHourlyCycle message. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyHourlyCycle.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResourcePolicyHourlyCycle
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyHourlyCycle} message ResourcePolicyHourlyCycle message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyHourlyCycle.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.startTime != null && Object.hasOwnProperty.call(message, "startTime"))
                                writer.uint32(/* id 37467274, wireType 2 =*/299738194).string(message.startTime);
                            if (message.duration != null && Object.hasOwnProperty.call(message, "duration"))
                                writer.uint32(/* id 155471252, wireType 2 =*/1243770018).string(message.duration);
                            if (message.hoursInCycle != null && Object.hasOwnProperty.call(message, "hoursInCycle"))
                                writer.uint32(/* id 526763132, wireType 0 =*/4214105056).int32(message.hoursInCycle);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyHourlyCycle message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyHourlyCycle.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyHourlyCycle
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyHourlyCycle} message ResourcePolicyHourlyCycle message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyHourlyCycle.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResourcePolicyHourlyCycle message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResourcePolicyHourlyCycle
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResourcePolicyHourlyCycle} ResourcePolicyHourlyCycle
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyHourlyCycle.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResourcePolicyHourlyCycle();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 155471252: {
                                        message.duration = reader.string();
                                        break;
                                    }
                                case 526763132: {
                                        message.hoursInCycle = reader.int32();
                                        break;
                                    }
                                case 37467274: {
                                        message.startTime = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResourcePolicyHourlyCycle message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyHourlyCycle
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResourcePolicyHourlyCycle} ResourcePolicyHourlyCycle
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyHourlyCycle.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResourcePolicyHourlyCycle message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResourcePolicyHourlyCycle
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourcePolicyHourlyCycle.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.duration != null && message.hasOwnProperty("duration")) {
                                properties._duration = 1;
                                if (!$util.isString(message.duration))
                                    return "duration: string expected";
                            }
                            if (message.hoursInCycle != null && message.hasOwnProperty("hoursInCycle")) {
                                properties._hoursInCycle = 1;
                                if (!$util.isInteger(message.hoursInCycle))
                                    return "hoursInCycle: integer expected";
                            }
                            if (message.startTime != null && message.hasOwnProperty("startTime")) {
                                properties._startTime = 1;
                                if (!$util.isString(message.startTime))
                                    return "startTime: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResourcePolicyHourlyCycle message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyHourlyCycle
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResourcePolicyHourlyCycle} ResourcePolicyHourlyCycle
                         */
                        ResourcePolicyHourlyCycle.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResourcePolicyHourlyCycle)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResourcePolicyHourlyCycle();
                            if (object.duration != null)
                                message.duration = String(object.duration);
                            if (object.hoursInCycle != null)
                                message.hoursInCycle = object.hoursInCycle | 0;
                            if (object.startTime != null)
                                message.startTime = String(object.startTime);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResourcePolicyHourlyCycle message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyHourlyCycle
                         * @static
                         * @param {google.cloud.compute.v1.ResourcePolicyHourlyCycle} message ResourcePolicyHourlyCycle
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourcePolicyHourlyCycle.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.startTime != null && message.hasOwnProperty("startTime")) {
                                object.startTime = message.startTime;
                                if (options.oneofs)
                                    object._startTime = "startTime";
                            }
                            if (message.duration != null && message.hasOwnProperty("duration")) {
                                object.duration = message.duration;
                                if (options.oneofs)
                                    object._duration = "duration";
                            }
                            if (message.hoursInCycle != null && message.hasOwnProperty("hoursInCycle")) {
                                object.hoursInCycle = message.hoursInCycle;
                                if (options.oneofs)
                                    object._hoursInCycle = "hoursInCycle";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ResourcePolicyHourlyCycle to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResourcePolicyHourlyCycle
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourcePolicyHourlyCycle.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResourcePolicyHourlyCycle
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResourcePolicyHourlyCycle
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResourcePolicyHourlyCycle.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResourcePolicyHourlyCycle";
                        };
    
                        return ResourcePolicyHourlyCycle;
                    })();
    
                    v1.ResourcePolicyInstanceSchedulePolicy = (function() {
    
                        /**
                         * Properties of a ResourcePolicyInstanceSchedulePolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IResourcePolicyInstanceSchedulePolicy
                         * @property {string|null} [expirationTime] ResourcePolicyInstanceSchedulePolicy expirationTime
                         * @property {string|null} [startTime] ResourcePolicyInstanceSchedulePolicy startTime
                         * @property {string|null} [timeZone] ResourcePolicyInstanceSchedulePolicy timeZone
                         * @property {google.cloud.compute.v1.IResourcePolicyInstanceSchedulePolicySchedule|null} [vmStartSchedule] ResourcePolicyInstanceSchedulePolicy vmStartSchedule
                         * @property {google.cloud.compute.v1.IResourcePolicyInstanceSchedulePolicySchedule|null} [vmStopSchedule] ResourcePolicyInstanceSchedulePolicy vmStopSchedule
                         */
    
                        /**
                         * Constructs a new ResourcePolicyInstanceSchedulePolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourcePolicyInstanceSchedulePolicy.
                         * @implements IResourcePolicyInstanceSchedulePolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IResourcePolicyInstanceSchedulePolicy=} [properties] Properties to set
                         */
                        function ResourcePolicyInstanceSchedulePolicy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResourcePolicyInstanceSchedulePolicy expirationTime.
                         * @member {string|null|undefined} expirationTime
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy
                         * @instance
                         */
                        ResourcePolicyInstanceSchedulePolicy.prototype.expirationTime = null;
    
                        /**
                         * ResourcePolicyInstanceSchedulePolicy startTime.
                         * @member {string|null|undefined} startTime
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy
                         * @instance
                         */
                        ResourcePolicyInstanceSchedulePolicy.prototype.startTime = null;
    
                        /**
                         * ResourcePolicyInstanceSchedulePolicy timeZone.
                         * @member {string|null|undefined} timeZone
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy
                         * @instance
                         */
                        ResourcePolicyInstanceSchedulePolicy.prototype.timeZone = null;
    
                        /**
                         * ResourcePolicyInstanceSchedulePolicy vmStartSchedule.
                         * @member {google.cloud.compute.v1.IResourcePolicyInstanceSchedulePolicySchedule|null|undefined} vmStartSchedule
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy
                         * @instance
                         */
                        ResourcePolicyInstanceSchedulePolicy.prototype.vmStartSchedule = null;
    
                        /**
                         * ResourcePolicyInstanceSchedulePolicy vmStopSchedule.
                         * @member {google.cloud.compute.v1.IResourcePolicyInstanceSchedulePolicySchedule|null|undefined} vmStopSchedule
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy
                         * @instance
                         */
                        ResourcePolicyInstanceSchedulePolicy.prototype.vmStopSchedule = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResourcePolicyInstanceSchedulePolicy _expirationTime.
                         * @member {"expirationTime"|undefined} _expirationTime
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyInstanceSchedulePolicy.prototype, "_expirationTime", {
                            get: $util.oneOfGetter($oneOfFields = ["expirationTime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyInstanceSchedulePolicy _startTime.
                         * @member {"startTime"|undefined} _startTime
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyInstanceSchedulePolicy.prototype, "_startTime", {
                            get: $util.oneOfGetter($oneOfFields = ["startTime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyInstanceSchedulePolicy _timeZone.
                         * @member {"timeZone"|undefined} _timeZone
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyInstanceSchedulePolicy.prototype, "_timeZone", {
                            get: $util.oneOfGetter($oneOfFields = ["timeZone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyInstanceSchedulePolicy _vmStartSchedule.
                         * @member {"vmStartSchedule"|undefined} _vmStartSchedule
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyInstanceSchedulePolicy.prototype, "_vmStartSchedule", {
                            get: $util.oneOfGetter($oneOfFields = ["vmStartSchedule"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyInstanceSchedulePolicy _vmStopSchedule.
                         * @member {"vmStopSchedule"|undefined} _vmStopSchedule
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyInstanceSchedulePolicy.prototype, "_vmStopSchedule", {
                            get: $util.oneOfGetter($oneOfFields = ["vmStopSchedule"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResourcePolicyInstanceSchedulePolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyInstanceSchedulePolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy} ResourcePolicyInstanceSchedulePolicy instance
                         */
                        ResourcePolicyInstanceSchedulePolicy.create = function create(properties) {
                            return new ResourcePolicyInstanceSchedulePolicy(properties);
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyInstanceSchedulePolicy message. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyInstanceSchedulePolicy} message ResourcePolicyInstanceSchedulePolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyInstanceSchedulePolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.vmStartSchedule != null && Object.hasOwnProperty.call(message, "vmStartSchedule"))
                                $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule.encode(message.vmStartSchedule, writer.uint32(/* id 17762396, wireType 2 =*/142099170).fork()).ldelim();
                            if (message.timeZone != null && Object.hasOwnProperty.call(message, "timeZone"))
                                writer.uint32(/* id 36848094, wireType 2 =*/294784754).string(message.timeZone);
                            if (message.startTime != null && Object.hasOwnProperty.call(message, "startTime"))
                                writer.uint32(/* id 37467274, wireType 2 =*/299738194).string(message.startTime);
                            if (message.expirationTime != null && Object.hasOwnProperty.call(message, "expirationTime"))
                                writer.uint32(/* id 230299229, wireType 2 =*/1842393834).string(message.expirationTime);
                            if (message.vmStopSchedule != null && Object.hasOwnProperty.call(message, "vmStopSchedule"))
                                $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule.encode(message.vmStopSchedule, writer.uint32(/* id 426242732, wireType 2 =*/3409941858).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyInstanceSchedulePolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyInstanceSchedulePolicy} message ResourcePolicyInstanceSchedulePolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyInstanceSchedulePolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResourcePolicyInstanceSchedulePolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy} ResourcePolicyInstanceSchedulePolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyInstanceSchedulePolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 230299229: {
                                        message.expirationTime = reader.string();
                                        break;
                                    }
                                case 37467274: {
                                        message.startTime = reader.string();
                                        break;
                                    }
                                case 36848094: {
                                        message.timeZone = reader.string();
                                        break;
                                    }
                                case 17762396: {
                                        message.vmStartSchedule = $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 426242732: {
                                        message.vmStopSchedule = $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResourcePolicyInstanceSchedulePolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy} ResourcePolicyInstanceSchedulePolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyInstanceSchedulePolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResourcePolicyInstanceSchedulePolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourcePolicyInstanceSchedulePolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.expirationTime != null && message.hasOwnProperty("expirationTime")) {
                                properties._expirationTime = 1;
                                if (!$util.isString(message.expirationTime))
                                    return "expirationTime: string expected";
                            }
                            if (message.startTime != null && message.hasOwnProperty("startTime")) {
                                properties._startTime = 1;
                                if (!$util.isString(message.startTime))
                                    return "startTime: string expected";
                            }
                            if (message.timeZone != null && message.hasOwnProperty("timeZone")) {
                                properties._timeZone = 1;
                                if (!$util.isString(message.timeZone))
                                    return "timeZone: string expected";
                            }
                            if (message.vmStartSchedule != null && message.hasOwnProperty("vmStartSchedule")) {
                                properties._vmStartSchedule = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule.verify(message.vmStartSchedule);
                                    if (error)
                                        return "vmStartSchedule." + error;
                                }
                            }
                            if (message.vmStopSchedule != null && message.hasOwnProperty("vmStopSchedule")) {
                                properties._vmStopSchedule = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule.verify(message.vmStopSchedule);
                                    if (error)
                                        return "vmStopSchedule." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResourcePolicyInstanceSchedulePolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy} ResourcePolicyInstanceSchedulePolicy
                         */
                        ResourcePolicyInstanceSchedulePolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy();
                            if (object.expirationTime != null)
                                message.expirationTime = String(object.expirationTime);
                            if (object.startTime != null)
                                message.startTime = String(object.startTime);
                            if (object.timeZone != null)
                                message.timeZone = String(object.timeZone);
                            if (object.vmStartSchedule != null) {
                                if (typeof object.vmStartSchedule !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy.vmStartSchedule: object expected");
                                message.vmStartSchedule = $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule.fromObject(object.vmStartSchedule);
                            }
                            if (object.vmStopSchedule != null) {
                                if (typeof object.vmStopSchedule !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy.vmStopSchedule: object expected");
                                message.vmStopSchedule = $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule.fromObject(object.vmStopSchedule);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResourcePolicyInstanceSchedulePolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy
                         * @static
                         * @param {google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy} message ResourcePolicyInstanceSchedulePolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourcePolicyInstanceSchedulePolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.vmStartSchedule != null && message.hasOwnProperty("vmStartSchedule")) {
                                object.vmStartSchedule = $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule.toObject(message.vmStartSchedule, options);
                                if (options.oneofs)
                                    object._vmStartSchedule = "vmStartSchedule";
                            }
                            if (message.timeZone != null && message.hasOwnProperty("timeZone")) {
                                object.timeZone = message.timeZone;
                                if (options.oneofs)
                                    object._timeZone = "timeZone";
                            }
                            if (message.startTime != null && message.hasOwnProperty("startTime")) {
                                object.startTime = message.startTime;
                                if (options.oneofs)
                                    object._startTime = "startTime";
                            }
                            if (message.expirationTime != null && message.hasOwnProperty("expirationTime")) {
                                object.expirationTime = message.expirationTime;
                                if (options.oneofs)
                                    object._expirationTime = "expirationTime";
                            }
                            if (message.vmStopSchedule != null && message.hasOwnProperty("vmStopSchedule")) {
                                object.vmStopSchedule = $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule.toObject(message.vmStopSchedule, options);
                                if (options.oneofs)
                                    object._vmStopSchedule = "vmStopSchedule";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ResourcePolicyInstanceSchedulePolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourcePolicyInstanceSchedulePolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResourcePolicyInstanceSchedulePolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResourcePolicyInstanceSchedulePolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicy";
                        };
    
                        return ResourcePolicyInstanceSchedulePolicy;
                    })();
    
                    v1.ResourcePolicyInstanceSchedulePolicySchedule = (function() {
    
                        /**
                         * Properties of a ResourcePolicyInstanceSchedulePolicySchedule.
                         * @memberof google.cloud.compute.v1
                         * @interface IResourcePolicyInstanceSchedulePolicySchedule
                         * @property {string|null} [schedule] ResourcePolicyInstanceSchedulePolicySchedule schedule
                         */
    
                        /**
                         * Constructs a new ResourcePolicyInstanceSchedulePolicySchedule.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourcePolicyInstanceSchedulePolicySchedule.
                         * @implements IResourcePolicyInstanceSchedulePolicySchedule
                         * @constructor
                         * @param {google.cloud.compute.v1.IResourcePolicyInstanceSchedulePolicySchedule=} [properties] Properties to set
                         */
                        function ResourcePolicyInstanceSchedulePolicySchedule(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResourcePolicyInstanceSchedulePolicySchedule schedule.
                         * @member {string|null|undefined} schedule
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule
                         * @instance
                         */
                        ResourcePolicyInstanceSchedulePolicySchedule.prototype.schedule = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResourcePolicyInstanceSchedulePolicySchedule _schedule.
                         * @member {"schedule"|undefined} _schedule
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyInstanceSchedulePolicySchedule.prototype, "_schedule", {
                            get: $util.oneOfGetter($oneOfFields = ["schedule"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResourcePolicyInstanceSchedulePolicySchedule instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyInstanceSchedulePolicySchedule=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule} ResourcePolicyInstanceSchedulePolicySchedule instance
                         */
                        ResourcePolicyInstanceSchedulePolicySchedule.create = function create(properties) {
                            return new ResourcePolicyInstanceSchedulePolicySchedule(properties);
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyInstanceSchedulePolicySchedule message. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyInstanceSchedulePolicySchedule} message ResourcePolicyInstanceSchedulePolicySchedule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyInstanceSchedulePolicySchedule.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.schedule != null && Object.hasOwnProperty.call(message, "schedule"))
                                writer.uint32(/* id 375820951, wireType 2 =*/3006567610).string(message.schedule);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyInstanceSchedulePolicySchedule message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyInstanceSchedulePolicySchedule} message ResourcePolicyInstanceSchedulePolicySchedule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyInstanceSchedulePolicySchedule.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResourcePolicyInstanceSchedulePolicySchedule message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule} ResourcePolicyInstanceSchedulePolicySchedule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyInstanceSchedulePolicySchedule.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 375820951: {
                                        message.schedule = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResourcePolicyInstanceSchedulePolicySchedule message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule} ResourcePolicyInstanceSchedulePolicySchedule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyInstanceSchedulePolicySchedule.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResourcePolicyInstanceSchedulePolicySchedule message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourcePolicyInstanceSchedulePolicySchedule.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.schedule != null && message.hasOwnProperty("schedule")) {
                                properties._schedule = 1;
                                if (!$util.isString(message.schedule))
                                    return "schedule: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResourcePolicyInstanceSchedulePolicySchedule message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule} ResourcePolicyInstanceSchedulePolicySchedule
                         */
                        ResourcePolicyInstanceSchedulePolicySchedule.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule();
                            if (object.schedule != null)
                                message.schedule = String(object.schedule);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResourcePolicyInstanceSchedulePolicySchedule message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule
                         * @static
                         * @param {google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule} message ResourcePolicyInstanceSchedulePolicySchedule
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourcePolicyInstanceSchedulePolicySchedule.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.schedule != null && message.hasOwnProperty("schedule")) {
                                object.schedule = message.schedule;
                                if (options.oneofs)
                                    object._schedule = "schedule";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ResourcePolicyInstanceSchedulePolicySchedule to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourcePolicyInstanceSchedulePolicySchedule.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResourcePolicyInstanceSchedulePolicySchedule
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResourcePolicyInstanceSchedulePolicySchedule.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResourcePolicyInstanceSchedulePolicySchedule";
                        };
    
                        return ResourcePolicyInstanceSchedulePolicySchedule;
                    })();
    
                    v1.ResourcePolicyList = (function() {
    
                        /**
                         * Properties of a ResourcePolicyList.
                         * @memberof google.cloud.compute.v1
                         * @interface IResourcePolicyList
                         * @property {string|null} [etag] ResourcePolicyList etag
                         * @property {string|null} [id] ResourcePolicyList id
                         * @property {Array.<google.cloud.compute.v1.IResourcePolicy>|null} [items] ResourcePolicyList items
                         * @property {string|null} [kind] ResourcePolicyList kind
                         * @property {string|null} [nextPageToken] ResourcePolicyList nextPageToken
                         * @property {string|null} [selfLink] ResourcePolicyList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] ResourcePolicyList warning
                         */
    
                        /**
                         * Constructs a new ResourcePolicyList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourcePolicyList.
                         * @implements IResourcePolicyList
                         * @constructor
                         * @param {google.cloud.compute.v1.IResourcePolicyList=} [properties] Properties to set
                         */
                        function ResourcePolicyList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResourcePolicyList etag.
                         * @member {string|null|undefined} etag
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @instance
                         */
                        ResourcePolicyList.prototype.etag = null;
    
                        /**
                         * ResourcePolicyList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @instance
                         */
                        ResourcePolicyList.prototype.id = null;
    
                        /**
                         * ResourcePolicyList items.
                         * @member {Array.<google.cloud.compute.v1.IResourcePolicy>} items
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @instance
                         */
                        ResourcePolicyList.prototype.items = $util.emptyArray;
    
                        /**
                         * ResourcePolicyList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @instance
                         */
                        ResourcePolicyList.prototype.kind = null;
    
                        /**
                         * ResourcePolicyList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @instance
                         */
                        ResourcePolicyList.prototype.nextPageToken = null;
    
                        /**
                         * ResourcePolicyList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @instance
                         */
                        ResourcePolicyList.prototype.selfLink = null;
    
                        /**
                         * ResourcePolicyList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @instance
                         */
                        ResourcePolicyList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResourcePolicyList _etag.
                         * @member {"etag"|undefined} _etag
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyList.prototype, "_etag", {
                            get: $util.oneOfGetter($oneOfFields = ["etag"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResourcePolicyList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResourcePolicyList} ResourcePolicyList instance
                         */
                        ResourcePolicyList.create = function create(properties) {
                            return new ResourcePolicyList(properties);
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyList message. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyList} message ResourcePolicyList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.etag != null && Object.hasOwnProperty.call(message, "etag"))
                                writer.uint32(/* id 3123477, wireType 2 =*/24987818).string(message.etag);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.ResourcePolicy.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyList} message ResourcePolicyList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResourcePolicyList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResourcePolicyList} ResourcePolicyList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResourcePolicyList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3123477: {
                                        message.etag = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.ResourcePolicy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResourcePolicyList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResourcePolicyList} ResourcePolicyList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResourcePolicyList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourcePolicyList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                properties._etag = 1;
                                if (!$util.isString(message.etag))
                                    return "etag: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ResourcePolicy.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResourcePolicyList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResourcePolicyList} ResourcePolicyList
                         */
                        ResourcePolicyList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResourcePolicyList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResourcePolicyList();
                            if (object.etag != null)
                                message.etag = String(object.etag);
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicyList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ResourcePolicyList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.ResourcePolicy.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicyList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResourcePolicyList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @static
                         * @param {google.cloud.compute.v1.ResourcePolicyList} message ResourcePolicyList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourcePolicyList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                object.etag = message.etag;
                                if (options.oneofs)
                                    object._etag = "etag";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.ResourcePolicy.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ResourcePolicyList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourcePolicyList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResourcePolicyList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResourcePolicyList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResourcePolicyList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResourcePolicyList";
                        };
    
                        return ResourcePolicyList;
                    })();
    
                    v1.ResourcePolicyResourceStatus = (function() {
    
                        /**
                         * Properties of a ResourcePolicyResourceStatus.
                         * @memberof google.cloud.compute.v1
                         * @interface IResourcePolicyResourceStatus
                         * @property {google.cloud.compute.v1.IResourcePolicyResourceStatusInstanceSchedulePolicyStatus|null} [instanceSchedulePolicy] ResourcePolicyResourceStatus instanceSchedulePolicy
                         */
    
                        /**
                         * Constructs a new ResourcePolicyResourceStatus.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourcePolicyResourceStatus.
                         * @implements IResourcePolicyResourceStatus
                         * @constructor
                         * @param {google.cloud.compute.v1.IResourcePolicyResourceStatus=} [properties] Properties to set
                         */
                        function ResourcePolicyResourceStatus(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResourcePolicyResourceStatus instanceSchedulePolicy.
                         * @member {google.cloud.compute.v1.IResourcePolicyResourceStatusInstanceSchedulePolicyStatus|null|undefined} instanceSchedulePolicy
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatus
                         * @instance
                         */
                        ResourcePolicyResourceStatus.prototype.instanceSchedulePolicy = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResourcePolicyResourceStatus _instanceSchedulePolicy.
                         * @member {"instanceSchedulePolicy"|undefined} _instanceSchedulePolicy
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatus
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyResourceStatus.prototype, "_instanceSchedulePolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["instanceSchedulePolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResourcePolicyResourceStatus instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatus
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyResourceStatus=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResourcePolicyResourceStatus} ResourcePolicyResourceStatus instance
                         */
                        ResourcePolicyResourceStatus.create = function create(properties) {
                            return new ResourcePolicyResourceStatus(properties);
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyResourceStatus message. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyResourceStatus.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatus
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyResourceStatus} message ResourcePolicyResourceStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyResourceStatus.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instanceSchedulePolicy != null && Object.hasOwnProperty.call(message, "instanceSchedulePolicy"))
                                $root.google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.encode(message.instanceSchedulePolicy, writer.uint32(/* id 344877104, wireType 2 =*/2759016834).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyResourceStatus message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyResourceStatus.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatus
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyResourceStatus} message ResourcePolicyResourceStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyResourceStatus.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResourcePolicyResourceStatus message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResourcePolicyResourceStatus} ResourcePolicyResourceStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyResourceStatus.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResourcePolicyResourceStatus();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 344877104: {
                                        message.instanceSchedulePolicy = $root.google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResourcePolicyResourceStatus message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResourcePolicyResourceStatus} ResourcePolicyResourceStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyResourceStatus.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResourcePolicyResourceStatus message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatus
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourcePolicyResourceStatus.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceSchedulePolicy != null && message.hasOwnProperty("instanceSchedulePolicy")) {
                                properties._instanceSchedulePolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.verify(message.instanceSchedulePolicy);
                                    if (error)
                                        return "instanceSchedulePolicy." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResourcePolicyResourceStatus message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatus
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResourcePolicyResourceStatus} ResourcePolicyResourceStatus
                         */
                        ResourcePolicyResourceStatus.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResourcePolicyResourceStatus)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResourcePolicyResourceStatus();
                            if (object.instanceSchedulePolicy != null) {
                                if (typeof object.instanceSchedulePolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicyResourceStatus.instanceSchedulePolicy: object expected");
                                message.instanceSchedulePolicy = $root.google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.fromObject(object.instanceSchedulePolicy);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResourcePolicyResourceStatus message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatus
                         * @static
                         * @param {google.cloud.compute.v1.ResourcePolicyResourceStatus} message ResourcePolicyResourceStatus
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourcePolicyResourceStatus.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.instanceSchedulePolicy != null && message.hasOwnProperty("instanceSchedulePolicy")) {
                                object.instanceSchedulePolicy = $root.google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.toObject(message.instanceSchedulePolicy, options);
                                if (options.oneofs)
                                    object._instanceSchedulePolicy = "instanceSchedulePolicy";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ResourcePolicyResourceStatus to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatus
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourcePolicyResourceStatus.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResourcePolicyResourceStatus
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatus
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResourcePolicyResourceStatus.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResourcePolicyResourceStatus";
                        };
    
                        return ResourcePolicyResourceStatus;
                    })();
    
                    v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus = (function() {
    
                        /**
                         * Properties of a ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.
                         * @memberof google.cloud.compute.v1
                         * @interface IResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         * @property {string|null} [lastRunStartTime] ResourcePolicyResourceStatusInstanceSchedulePolicyStatus lastRunStartTime
                         * @property {string|null} [nextRunStartTime] ResourcePolicyResourceStatusInstanceSchedulePolicyStatus nextRunStartTime
                         */
    
                        /**
                         * Constructs a new ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.
                         * @implements IResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         * @constructor
                         * @param {google.cloud.compute.v1.IResourcePolicyResourceStatusInstanceSchedulePolicyStatus=} [properties] Properties to set
                         */
                        function ResourcePolicyResourceStatusInstanceSchedulePolicyStatus(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResourcePolicyResourceStatusInstanceSchedulePolicyStatus lastRunStartTime.
                         * @member {string|null|undefined} lastRunStartTime
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         * @instance
                         */
                        ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.prototype.lastRunStartTime = null;
    
                        /**
                         * ResourcePolicyResourceStatusInstanceSchedulePolicyStatus nextRunStartTime.
                         * @member {string|null|undefined} nextRunStartTime
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         * @instance
                         */
                        ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.prototype.nextRunStartTime = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResourcePolicyResourceStatusInstanceSchedulePolicyStatus _lastRunStartTime.
                         * @member {"lastRunStartTime"|undefined} _lastRunStartTime
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.prototype, "_lastRunStartTime", {
                            get: $util.oneOfGetter($oneOfFields = ["lastRunStartTime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyResourceStatusInstanceSchedulePolicyStatus _nextRunStartTime.
                         * @member {"nextRunStartTime"|undefined} _nextRunStartTime
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.prototype, "_nextRunStartTime", {
                            get: $util.oneOfGetter($oneOfFields = ["nextRunStartTime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResourcePolicyResourceStatusInstanceSchedulePolicyStatus instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyResourceStatusInstanceSchedulePolicyStatus=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus} ResourcePolicyResourceStatusInstanceSchedulePolicyStatus instance
                         */
                        ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.create = function create(properties) {
                            return new ResourcePolicyResourceStatusInstanceSchedulePolicyStatus(properties);
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyResourceStatusInstanceSchedulePolicyStatus message. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyResourceStatusInstanceSchedulePolicyStatus} message ResourcePolicyResourceStatusInstanceSchedulePolicyStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.lastRunStartTime != null && Object.hasOwnProperty.call(message, "lastRunStartTime"))
                                writer.uint32(/* id 303069063, wireType 2 =*/2424552506).string(message.lastRunStartTime);
                            if (message.nextRunStartTime != null && Object.hasOwnProperty.call(message, "nextRunStartTime"))
                                writer.uint32(/* id 318642570, wireType 2 =*/2549140562).string(message.nextRunStartTime);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyResourceStatusInstanceSchedulePolicyStatus message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyResourceStatusInstanceSchedulePolicyStatus} message ResourcePolicyResourceStatusInstanceSchedulePolicyStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResourcePolicyResourceStatusInstanceSchedulePolicyStatus message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus} ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 303069063: {
                                        message.lastRunStartTime = reader.string();
                                        break;
                                    }
                                case 318642570: {
                                        message.nextRunStartTime = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResourcePolicyResourceStatusInstanceSchedulePolicyStatus message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus} ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResourcePolicyResourceStatusInstanceSchedulePolicyStatus message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.lastRunStartTime != null && message.hasOwnProperty("lastRunStartTime")) {
                                properties._lastRunStartTime = 1;
                                if (!$util.isString(message.lastRunStartTime))
                                    return "lastRunStartTime: string expected";
                            }
                            if (message.nextRunStartTime != null && message.hasOwnProperty("nextRunStartTime")) {
                                properties._nextRunStartTime = 1;
                                if (!$util.isString(message.nextRunStartTime))
                                    return "nextRunStartTime: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResourcePolicyResourceStatusInstanceSchedulePolicyStatus message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus} ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         */
                        ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus();
                            if (object.lastRunStartTime != null)
                                message.lastRunStartTime = String(object.lastRunStartTime);
                            if (object.nextRunStartTime != null)
                                message.nextRunStartTime = String(object.nextRunStartTime);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResourcePolicyResourceStatusInstanceSchedulePolicyStatus message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         * @static
                         * @param {google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus} message ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.lastRunStartTime != null && message.hasOwnProperty("lastRunStartTime")) {
                                object.lastRunStartTime = message.lastRunStartTime;
                                if (options.oneofs)
                                    object._lastRunStartTime = "lastRunStartTime";
                            }
                            if (message.nextRunStartTime != null && message.hasOwnProperty("nextRunStartTime")) {
                                object.nextRunStartTime = message.nextRunStartTime;
                                if (options.oneofs)
                                    object._nextRunStartTime = "nextRunStartTime";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ResourcePolicyResourceStatusInstanceSchedulePolicyStatus to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResourcePolicyResourceStatusInstanceSchedulePolicyStatus.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResourcePolicyResourceStatusInstanceSchedulePolicyStatus";
                        };
    
                        return ResourcePolicyResourceStatusInstanceSchedulePolicyStatus;
                    })();
    
                    v1.ResourcePolicySnapshotSchedulePolicy = (function() {
    
                        /**
                         * Properties of a ResourcePolicySnapshotSchedulePolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IResourcePolicySnapshotSchedulePolicy
                         * @property {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicyRetentionPolicy|null} [retentionPolicy] ResourcePolicySnapshotSchedulePolicy retentionPolicy
                         * @property {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicySchedule|null} [schedule] ResourcePolicySnapshotSchedulePolicy schedule
                         * @property {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicySnapshotProperties|null} [snapshotProperties] ResourcePolicySnapshotSchedulePolicy snapshotProperties
                         */
    
                        /**
                         * Constructs a new ResourcePolicySnapshotSchedulePolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourcePolicySnapshotSchedulePolicy.
                         * @implements IResourcePolicySnapshotSchedulePolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicy=} [properties] Properties to set
                         */
                        function ResourcePolicySnapshotSchedulePolicy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicy retentionPolicy.
                         * @member {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicyRetentionPolicy|null|undefined} retentionPolicy
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy
                         * @instance
                         */
                        ResourcePolicySnapshotSchedulePolicy.prototype.retentionPolicy = null;
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicy schedule.
                         * @member {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicySchedule|null|undefined} schedule
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy
                         * @instance
                         */
                        ResourcePolicySnapshotSchedulePolicy.prototype.schedule = null;
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicy snapshotProperties.
                         * @member {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicySnapshotProperties|null|undefined} snapshotProperties
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy
                         * @instance
                         */
                        ResourcePolicySnapshotSchedulePolicy.prototype.snapshotProperties = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicy _retentionPolicy.
                         * @member {"retentionPolicy"|undefined} _retentionPolicy
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicySnapshotSchedulePolicy.prototype, "_retentionPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["retentionPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicy _schedule.
                         * @member {"schedule"|undefined} _schedule
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicySnapshotSchedulePolicy.prototype, "_schedule", {
                            get: $util.oneOfGetter($oneOfFields = ["schedule"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicy _snapshotProperties.
                         * @member {"snapshotProperties"|undefined} _snapshotProperties
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicySnapshotSchedulePolicy.prototype, "_snapshotProperties", {
                            get: $util.oneOfGetter($oneOfFields = ["snapshotProperties"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResourcePolicySnapshotSchedulePolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy} ResourcePolicySnapshotSchedulePolicy instance
                         */
                        ResourcePolicySnapshotSchedulePolicy.create = function create(properties) {
                            return new ResourcePolicySnapshotSchedulePolicy(properties);
                        };
    
                        /**
                         * Encodes the specified ResourcePolicySnapshotSchedulePolicy message. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicy} message ResourcePolicySnapshotSchedulePolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicySnapshotSchedulePolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.retentionPolicy != null && Object.hasOwnProperty.call(message, "retentionPolicy"))
                                $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy.encode(message.retentionPolicy, writer.uint32(/* id 68625779, wireType 2 =*/549006234).fork()).ldelim();
                            if (message.snapshotProperties != null && Object.hasOwnProperty.call(message, "snapshotProperties"))
                                $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties.encode(message.snapshotProperties, writer.uint32(/* id 185371278, wireType 2 =*/1482970226).fork()).ldelim();
                            if (message.schedule != null && Object.hasOwnProperty.call(message, "schedule"))
                                $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule.encode(message.schedule, writer.uint32(/* id 375820951, wireType 2 =*/3006567610).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResourcePolicySnapshotSchedulePolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicy} message ResourcePolicySnapshotSchedulePolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicySnapshotSchedulePolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResourcePolicySnapshotSchedulePolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy} ResourcePolicySnapshotSchedulePolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicySnapshotSchedulePolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 68625779: {
                                        message.retentionPolicy = $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 375820951: {
                                        message.schedule = $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 185371278: {
                                        message.snapshotProperties = $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResourcePolicySnapshotSchedulePolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy} ResourcePolicySnapshotSchedulePolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicySnapshotSchedulePolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResourcePolicySnapshotSchedulePolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourcePolicySnapshotSchedulePolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.retentionPolicy != null && message.hasOwnProperty("retentionPolicy")) {
                                properties._retentionPolicy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy.verify(message.retentionPolicy);
                                    if (error)
                                        return "retentionPolicy." + error;
                                }
                            }
                            if (message.schedule != null && message.hasOwnProperty("schedule")) {
                                properties._schedule = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule.verify(message.schedule);
                                    if (error)
                                        return "schedule." + error;
                                }
                            }
                            if (message.snapshotProperties != null && message.hasOwnProperty("snapshotProperties")) {
                                properties._snapshotProperties = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties.verify(message.snapshotProperties);
                                    if (error)
                                        return "snapshotProperties." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResourcePolicySnapshotSchedulePolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy} ResourcePolicySnapshotSchedulePolicy
                         */
                        ResourcePolicySnapshotSchedulePolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy();
                            if (object.retentionPolicy != null) {
                                if (typeof object.retentionPolicy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy.retentionPolicy: object expected");
                                message.retentionPolicy = $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy.fromObject(object.retentionPolicy);
                            }
                            if (object.schedule != null) {
                                if (typeof object.schedule !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy.schedule: object expected");
                                message.schedule = $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule.fromObject(object.schedule);
                            }
                            if (object.snapshotProperties != null) {
                                if (typeof object.snapshotProperties !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy.snapshotProperties: object expected");
                                message.snapshotProperties = $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties.fromObject(object.snapshotProperties);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResourcePolicySnapshotSchedulePolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy
                         * @static
                         * @param {google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy} message ResourcePolicySnapshotSchedulePolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourcePolicySnapshotSchedulePolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.retentionPolicy != null && message.hasOwnProperty("retentionPolicy")) {
                                object.retentionPolicy = $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy.toObject(message.retentionPolicy, options);
                                if (options.oneofs)
                                    object._retentionPolicy = "retentionPolicy";
                            }
                            if (message.snapshotProperties != null && message.hasOwnProperty("snapshotProperties")) {
                                object.snapshotProperties = $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties.toObject(message.snapshotProperties, options);
                                if (options.oneofs)
                                    object._snapshotProperties = "snapshotProperties";
                            }
                            if (message.schedule != null && message.hasOwnProperty("schedule")) {
                                object.schedule = $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule.toObject(message.schedule, options);
                                if (options.oneofs)
                                    object._schedule = "schedule";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ResourcePolicySnapshotSchedulePolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourcePolicySnapshotSchedulePolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResourcePolicySnapshotSchedulePolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResourcePolicySnapshotSchedulePolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicy";
                        };
    
                        return ResourcePolicySnapshotSchedulePolicy;
                    })();
    
                    v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy = (function() {
    
                        /**
                         * Properties of a ResourcePolicySnapshotSchedulePolicyRetentionPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         * @property {number|null} [maxRetentionDays] ResourcePolicySnapshotSchedulePolicyRetentionPolicy maxRetentionDays
                         * @property {string|null} [onSourceDiskDelete] ResourcePolicySnapshotSchedulePolicyRetentionPolicy onSourceDiskDelete
                         */
    
                        /**
                         * Constructs a new ResourcePolicySnapshotSchedulePolicyRetentionPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourcePolicySnapshotSchedulePolicyRetentionPolicy.
                         * @implements IResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicyRetentionPolicy=} [properties] Properties to set
                         */
                        function ResourcePolicySnapshotSchedulePolicyRetentionPolicy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicyRetentionPolicy maxRetentionDays.
                         * @member {number|null|undefined} maxRetentionDays
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         * @instance
                         */
                        ResourcePolicySnapshotSchedulePolicyRetentionPolicy.prototype.maxRetentionDays = null;
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicyRetentionPolicy onSourceDiskDelete.
                         * @member {string|null|undefined} onSourceDiskDelete
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         * @instance
                         */
                        ResourcePolicySnapshotSchedulePolicyRetentionPolicy.prototype.onSourceDiskDelete = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicyRetentionPolicy _maxRetentionDays.
                         * @member {"maxRetentionDays"|undefined} _maxRetentionDays
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicySnapshotSchedulePolicyRetentionPolicy.prototype, "_maxRetentionDays", {
                            get: $util.oneOfGetter($oneOfFields = ["maxRetentionDays"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicyRetentionPolicy _onSourceDiskDelete.
                         * @member {"onSourceDiskDelete"|undefined} _onSourceDiskDelete
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicySnapshotSchedulePolicyRetentionPolicy.prototype, "_onSourceDiskDelete", {
                            get: $util.oneOfGetter($oneOfFields = ["onSourceDiskDelete"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResourcePolicySnapshotSchedulePolicyRetentionPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicyRetentionPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy} ResourcePolicySnapshotSchedulePolicyRetentionPolicy instance
                         */
                        ResourcePolicySnapshotSchedulePolicyRetentionPolicy.create = function create(properties) {
                            return new ResourcePolicySnapshotSchedulePolicyRetentionPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified ResourcePolicySnapshotSchedulePolicyRetentionPolicy message. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicyRetentionPolicy} message ResourcePolicySnapshotSchedulePolicyRetentionPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicySnapshotSchedulePolicyRetentionPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.onSourceDiskDelete != null && Object.hasOwnProperty.call(message, "onSourceDiskDelete"))
                                writer.uint32(/* id 321955529, wireType 2 =*/2575644234).string(message.onSourceDiskDelete);
                            if (message.maxRetentionDays != null && Object.hasOwnProperty.call(message, "maxRetentionDays"))
                                writer.uint32(/* id 324296979, wireType 0 =*/2594375832).int32(message.maxRetentionDays);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResourcePolicySnapshotSchedulePolicyRetentionPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicyRetentionPolicy} message ResourcePolicySnapshotSchedulePolicyRetentionPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicySnapshotSchedulePolicyRetentionPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResourcePolicySnapshotSchedulePolicyRetentionPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy} ResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicySnapshotSchedulePolicyRetentionPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 324296979: {
                                        message.maxRetentionDays = reader.int32();
                                        break;
                                    }
                                case 321955529: {
                                        message.onSourceDiskDelete = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResourcePolicySnapshotSchedulePolicyRetentionPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy} ResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicySnapshotSchedulePolicyRetentionPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResourcePolicySnapshotSchedulePolicyRetentionPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourcePolicySnapshotSchedulePolicyRetentionPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.maxRetentionDays != null && message.hasOwnProperty("maxRetentionDays")) {
                                properties._maxRetentionDays = 1;
                                if (!$util.isInteger(message.maxRetentionDays))
                                    return "maxRetentionDays: integer expected";
                            }
                            if (message.onSourceDiskDelete != null && message.hasOwnProperty("onSourceDiskDelete")) {
                                properties._onSourceDiskDelete = 1;
                                if (!$util.isString(message.onSourceDiskDelete))
                                    return "onSourceDiskDelete: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResourcePolicySnapshotSchedulePolicyRetentionPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy} ResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         */
                        ResourcePolicySnapshotSchedulePolicyRetentionPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy();
                            if (object.maxRetentionDays != null)
                                message.maxRetentionDays = object.maxRetentionDays | 0;
                            if (object.onSourceDiskDelete != null)
                                message.onSourceDiskDelete = String(object.onSourceDiskDelete);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResourcePolicySnapshotSchedulePolicyRetentionPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         * @static
                         * @param {google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy} message ResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourcePolicySnapshotSchedulePolicyRetentionPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.onSourceDiskDelete != null && message.hasOwnProperty("onSourceDiskDelete")) {
                                object.onSourceDiskDelete = message.onSourceDiskDelete;
                                if (options.oneofs)
                                    object._onSourceDiskDelete = "onSourceDiskDelete";
                            }
                            if (message.maxRetentionDays != null && message.hasOwnProperty("maxRetentionDays")) {
                                object.maxRetentionDays = message.maxRetentionDays;
                                if (options.oneofs)
                                    object._maxRetentionDays = "maxRetentionDays";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ResourcePolicySnapshotSchedulePolicyRetentionPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourcePolicySnapshotSchedulePolicyRetentionPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResourcePolicySnapshotSchedulePolicyRetentionPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy";
                        };
    
                        /**
                         * OnSourceDiskDelete enum.
                         * @name google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicyRetentionPolicy.OnSourceDiskDelete
                         * @enum {number}
                         * @property {number} UNDEFINED_ON_SOURCE_DISK_DELETE=0 UNDEFINED_ON_SOURCE_DISK_DELETE value
                         * @property {number} APPLY_RETENTION_POLICY=535071332 APPLY_RETENTION_POLICY value
                         * @property {number} KEEP_AUTO_SNAPSHOTS=258925689 KEEP_AUTO_SNAPSHOTS value
                         * @property {number} UNSPECIFIED_ON_SOURCE_DISK_DELETE=239140769 UNSPECIFIED_ON_SOURCE_DISK_DELETE value
                         */
                        ResourcePolicySnapshotSchedulePolicyRetentionPolicy.OnSourceDiskDelete = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ON_SOURCE_DISK_DELETE"] = 0;
                            values[valuesById[535071332] = "APPLY_RETENTION_POLICY"] = 535071332;
                            values[valuesById[258925689] = "KEEP_AUTO_SNAPSHOTS"] = 258925689;
                            values[valuesById[239140769] = "UNSPECIFIED_ON_SOURCE_DISK_DELETE"] = 239140769;
                            return values;
                        })();
    
                        return ResourcePolicySnapshotSchedulePolicyRetentionPolicy;
                    })();
    
                    v1.ResourcePolicySnapshotSchedulePolicySchedule = (function() {
    
                        /**
                         * Properties of a ResourcePolicySnapshotSchedulePolicySchedule.
                         * @memberof google.cloud.compute.v1
                         * @interface IResourcePolicySnapshotSchedulePolicySchedule
                         * @property {google.cloud.compute.v1.IResourcePolicyDailyCycle|null} [dailySchedule] ResourcePolicySnapshotSchedulePolicySchedule dailySchedule
                         * @property {google.cloud.compute.v1.IResourcePolicyHourlyCycle|null} [hourlySchedule] ResourcePolicySnapshotSchedulePolicySchedule hourlySchedule
                         * @property {google.cloud.compute.v1.IResourcePolicyWeeklyCycle|null} [weeklySchedule] ResourcePolicySnapshotSchedulePolicySchedule weeklySchedule
                         */
    
                        /**
                         * Constructs a new ResourcePolicySnapshotSchedulePolicySchedule.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourcePolicySnapshotSchedulePolicySchedule.
                         * @implements IResourcePolicySnapshotSchedulePolicySchedule
                         * @constructor
                         * @param {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicySchedule=} [properties] Properties to set
                         */
                        function ResourcePolicySnapshotSchedulePolicySchedule(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicySchedule dailySchedule.
                         * @member {google.cloud.compute.v1.IResourcePolicyDailyCycle|null|undefined} dailySchedule
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule
                         * @instance
                         */
                        ResourcePolicySnapshotSchedulePolicySchedule.prototype.dailySchedule = null;
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicySchedule hourlySchedule.
                         * @member {google.cloud.compute.v1.IResourcePolicyHourlyCycle|null|undefined} hourlySchedule
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule
                         * @instance
                         */
                        ResourcePolicySnapshotSchedulePolicySchedule.prototype.hourlySchedule = null;
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicySchedule weeklySchedule.
                         * @member {google.cloud.compute.v1.IResourcePolicyWeeklyCycle|null|undefined} weeklySchedule
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule
                         * @instance
                         */
                        ResourcePolicySnapshotSchedulePolicySchedule.prototype.weeklySchedule = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicySchedule _dailySchedule.
                         * @member {"dailySchedule"|undefined} _dailySchedule
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicySnapshotSchedulePolicySchedule.prototype, "_dailySchedule", {
                            get: $util.oneOfGetter($oneOfFields = ["dailySchedule"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicySchedule _hourlySchedule.
                         * @member {"hourlySchedule"|undefined} _hourlySchedule
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicySnapshotSchedulePolicySchedule.prototype, "_hourlySchedule", {
                            get: $util.oneOfGetter($oneOfFields = ["hourlySchedule"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicySchedule _weeklySchedule.
                         * @member {"weeklySchedule"|undefined} _weeklySchedule
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicySnapshotSchedulePolicySchedule.prototype, "_weeklySchedule", {
                            get: $util.oneOfGetter($oneOfFields = ["weeklySchedule"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResourcePolicySnapshotSchedulePolicySchedule instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicySchedule=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule} ResourcePolicySnapshotSchedulePolicySchedule instance
                         */
                        ResourcePolicySnapshotSchedulePolicySchedule.create = function create(properties) {
                            return new ResourcePolicySnapshotSchedulePolicySchedule(properties);
                        };
    
                        /**
                         * Encodes the specified ResourcePolicySnapshotSchedulePolicySchedule message. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicySchedule} message ResourcePolicySnapshotSchedulePolicySchedule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicySnapshotSchedulePolicySchedule.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.hourlySchedule != null && Object.hasOwnProperty.call(message, "hourlySchedule"))
                                $root.google.cloud.compute.v1.ResourcePolicyHourlyCycle.encode(message.hourlySchedule, writer.uint32(/* id 38328485, wireType 2 =*/306627882).fork()).ldelim();
                            if (message.dailySchedule != null && Object.hasOwnProperty.call(message, "dailySchedule"))
                                $root.google.cloud.compute.v1.ResourcePolicyDailyCycle.encode(message.dailySchedule, writer.uint32(/* id 86159869, wireType 2 =*/689278954).fork()).ldelim();
                            if (message.weeklySchedule != null && Object.hasOwnProperty.call(message, "weeklySchedule"))
                                $root.google.cloud.compute.v1.ResourcePolicyWeeklyCycle.encode(message.weeklySchedule, writer.uint32(/* id 359548053, wireType 2 =*/2876384426).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResourcePolicySnapshotSchedulePolicySchedule message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicySchedule} message ResourcePolicySnapshotSchedulePolicySchedule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicySnapshotSchedulePolicySchedule.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResourcePolicySnapshotSchedulePolicySchedule message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule} ResourcePolicySnapshotSchedulePolicySchedule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicySnapshotSchedulePolicySchedule.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 86159869: {
                                        message.dailySchedule = $root.google.cloud.compute.v1.ResourcePolicyDailyCycle.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 38328485: {
                                        message.hourlySchedule = $root.google.cloud.compute.v1.ResourcePolicyHourlyCycle.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 359548053: {
                                        message.weeklySchedule = $root.google.cloud.compute.v1.ResourcePolicyWeeklyCycle.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResourcePolicySnapshotSchedulePolicySchedule message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule} ResourcePolicySnapshotSchedulePolicySchedule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicySnapshotSchedulePolicySchedule.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResourcePolicySnapshotSchedulePolicySchedule message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourcePolicySnapshotSchedulePolicySchedule.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.dailySchedule != null && message.hasOwnProperty("dailySchedule")) {
                                properties._dailySchedule = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ResourcePolicyDailyCycle.verify(message.dailySchedule);
                                    if (error)
                                        return "dailySchedule." + error;
                                }
                            }
                            if (message.hourlySchedule != null && message.hasOwnProperty("hourlySchedule")) {
                                properties._hourlySchedule = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ResourcePolicyHourlyCycle.verify(message.hourlySchedule);
                                    if (error)
                                        return "hourlySchedule." + error;
                                }
                            }
                            if (message.weeklySchedule != null && message.hasOwnProperty("weeklySchedule")) {
                                properties._weeklySchedule = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ResourcePolicyWeeklyCycle.verify(message.weeklySchedule);
                                    if (error)
                                        return "weeklySchedule." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResourcePolicySnapshotSchedulePolicySchedule message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule} ResourcePolicySnapshotSchedulePolicySchedule
                         */
                        ResourcePolicySnapshotSchedulePolicySchedule.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule();
                            if (object.dailySchedule != null) {
                                if (typeof object.dailySchedule !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule.dailySchedule: object expected");
                                message.dailySchedule = $root.google.cloud.compute.v1.ResourcePolicyDailyCycle.fromObject(object.dailySchedule);
                            }
                            if (object.hourlySchedule != null) {
                                if (typeof object.hourlySchedule !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule.hourlySchedule: object expected");
                                message.hourlySchedule = $root.google.cloud.compute.v1.ResourcePolicyHourlyCycle.fromObject(object.hourlySchedule);
                            }
                            if (object.weeklySchedule != null) {
                                if (typeof object.weeklySchedule !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule.weeklySchedule: object expected");
                                message.weeklySchedule = $root.google.cloud.compute.v1.ResourcePolicyWeeklyCycle.fromObject(object.weeklySchedule);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResourcePolicySnapshotSchedulePolicySchedule message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule
                         * @static
                         * @param {google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule} message ResourcePolicySnapshotSchedulePolicySchedule
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourcePolicySnapshotSchedulePolicySchedule.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.hourlySchedule != null && message.hasOwnProperty("hourlySchedule")) {
                                object.hourlySchedule = $root.google.cloud.compute.v1.ResourcePolicyHourlyCycle.toObject(message.hourlySchedule, options);
                                if (options.oneofs)
                                    object._hourlySchedule = "hourlySchedule";
                            }
                            if (message.dailySchedule != null && message.hasOwnProperty("dailySchedule")) {
                                object.dailySchedule = $root.google.cloud.compute.v1.ResourcePolicyDailyCycle.toObject(message.dailySchedule, options);
                                if (options.oneofs)
                                    object._dailySchedule = "dailySchedule";
                            }
                            if (message.weeklySchedule != null && message.hasOwnProperty("weeklySchedule")) {
                                object.weeklySchedule = $root.google.cloud.compute.v1.ResourcePolicyWeeklyCycle.toObject(message.weeklySchedule, options);
                                if (options.oneofs)
                                    object._weeklySchedule = "weeklySchedule";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ResourcePolicySnapshotSchedulePolicySchedule to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourcePolicySnapshotSchedulePolicySchedule.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResourcePolicySnapshotSchedulePolicySchedule
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResourcePolicySnapshotSchedulePolicySchedule.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySchedule";
                        };
    
                        return ResourcePolicySnapshotSchedulePolicySchedule;
                    })();
    
                    v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties = (function() {
    
                        /**
                         * Properties of a ResourcePolicySnapshotSchedulePolicySnapshotProperties.
                         * @memberof google.cloud.compute.v1
                         * @interface IResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @property {string|null} [chainName] ResourcePolicySnapshotSchedulePolicySnapshotProperties chainName
                         * @property {boolean|null} [guestFlush] ResourcePolicySnapshotSchedulePolicySnapshotProperties guestFlush
                         * @property {Object.<string,string>|null} [labels] ResourcePolicySnapshotSchedulePolicySnapshotProperties labels
                         * @property {Array.<string>|null} [storageLocations] ResourcePolicySnapshotSchedulePolicySnapshotProperties storageLocations
                         */
    
                        /**
                         * Constructs a new ResourcePolicySnapshotSchedulePolicySnapshotProperties.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourcePolicySnapshotSchedulePolicySnapshotProperties.
                         * @implements IResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @constructor
                         * @param {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicySnapshotProperties=} [properties] Properties to set
                         */
                        function ResourcePolicySnapshotSchedulePolicySnapshotProperties(properties) {
                            this.labels = {};
                            this.storageLocations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicySnapshotProperties chainName.
                         * @member {string|null|undefined} chainName
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @instance
                         */
                        ResourcePolicySnapshotSchedulePolicySnapshotProperties.prototype.chainName = null;
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicySnapshotProperties guestFlush.
                         * @member {boolean|null|undefined} guestFlush
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @instance
                         */
                        ResourcePolicySnapshotSchedulePolicySnapshotProperties.prototype.guestFlush = null;
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicySnapshotProperties labels.
                         * @member {Object.<string,string>} labels
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @instance
                         */
                        ResourcePolicySnapshotSchedulePolicySnapshotProperties.prototype.labels = $util.emptyObject;
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicySnapshotProperties storageLocations.
                         * @member {Array.<string>} storageLocations
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @instance
                         */
                        ResourcePolicySnapshotSchedulePolicySnapshotProperties.prototype.storageLocations = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicySnapshotProperties _chainName.
                         * @member {"chainName"|undefined} _chainName
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicySnapshotSchedulePolicySnapshotProperties.prototype, "_chainName", {
                            get: $util.oneOfGetter($oneOfFields = ["chainName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicySnapshotSchedulePolicySnapshotProperties _guestFlush.
                         * @member {"guestFlush"|undefined} _guestFlush
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicySnapshotSchedulePolicySnapshotProperties.prototype, "_guestFlush", {
                            get: $util.oneOfGetter($oneOfFields = ["guestFlush"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResourcePolicySnapshotSchedulePolicySnapshotProperties instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicySnapshotProperties=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties} ResourcePolicySnapshotSchedulePolicySnapshotProperties instance
                         */
                        ResourcePolicySnapshotSchedulePolicySnapshotProperties.create = function create(properties) {
                            return new ResourcePolicySnapshotSchedulePolicySnapshotProperties(properties);
                        };
    
                        /**
                         * Encodes the specified ResourcePolicySnapshotSchedulePolicySnapshotProperties message. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicySnapshotProperties} message ResourcePolicySnapshotSchedulePolicySnapshotProperties message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicySnapshotSchedulePolicySnapshotProperties.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.chainName != null && Object.hasOwnProperty.call(message, "chainName"))
                                writer.uint32(/* id 68644169, wireType 2 =*/549153354).string(message.chainName);
                            if (message.storageLocations != null && message.storageLocations.length)
                                for (var i = 0; i < message.storageLocations.length; ++i)
                                    writer.uint32(/* id 328005274, wireType 2 =*/2624042194).string(message.storageLocations[i]);
                            if (message.guestFlush != null && Object.hasOwnProperty.call(message, "guestFlush"))
                                writer.uint32(/* id 385550813, wireType 0 =*/3084406504).bool(message.guestFlush);
                            if (message.labels != null && Object.hasOwnProperty.call(message, "labels"))
                                for (var keys = Object.keys(message.labels), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 500195327, wireType 2 =*/4001562618).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.labels[keys[i]]).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResourcePolicySnapshotSchedulePolicySnapshotProperties message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicySnapshotSchedulePolicySnapshotProperties} message ResourcePolicySnapshotSchedulePolicySnapshotProperties message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicySnapshotSchedulePolicySnapshotProperties.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResourcePolicySnapshotSchedulePolicySnapshotProperties message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties} ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicySnapshotSchedulePolicySnapshotProperties.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 68644169: {
                                        message.chainName = reader.string();
                                        break;
                                    }
                                case 385550813: {
                                        message.guestFlush = reader.bool();
                                        break;
                                    }
                                case 500195327: {
                                        if (message.labels === $util.emptyObject)
                                            message.labels = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.labels[key] = value;
                                        break;
                                    }
                                case 328005274: {
                                        if (!(message.storageLocations && message.storageLocations.length))
                                            message.storageLocations = [];
                                        message.storageLocations.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResourcePolicySnapshotSchedulePolicySnapshotProperties message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties} ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicySnapshotSchedulePolicySnapshotProperties.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResourcePolicySnapshotSchedulePolicySnapshotProperties message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourcePolicySnapshotSchedulePolicySnapshotProperties.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.chainName != null && message.hasOwnProperty("chainName")) {
                                properties._chainName = 1;
                                if (!$util.isString(message.chainName))
                                    return "chainName: string expected";
                            }
                            if (message.guestFlush != null && message.hasOwnProperty("guestFlush")) {
                                properties._guestFlush = 1;
                                if (typeof message.guestFlush !== "boolean")
                                    return "guestFlush: boolean expected";
                            }
                            if (message.labels != null && message.hasOwnProperty("labels")) {
                                if (!$util.isObject(message.labels))
                                    return "labels: object expected";
                                var key = Object.keys(message.labels);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.labels[key[i]]))
                                        return "labels: string{k:string} expected";
                            }
                            if (message.storageLocations != null && message.hasOwnProperty("storageLocations")) {
                                if (!Array.isArray(message.storageLocations))
                                    return "storageLocations: array expected";
                                for (var i = 0; i < message.storageLocations.length; ++i)
                                    if (!$util.isString(message.storageLocations[i]))
                                        return "storageLocations: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResourcePolicySnapshotSchedulePolicySnapshotProperties message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties} ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         */
                        ResourcePolicySnapshotSchedulePolicySnapshotProperties.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties();
                            if (object.chainName != null)
                                message.chainName = String(object.chainName);
                            if (object.guestFlush != null)
                                message.guestFlush = Boolean(object.guestFlush);
                            if (object.labels) {
                                if (typeof object.labels !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties.labels: object expected");
                                message.labels = {};
                                for (var keys = Object.keys(object.labels), i = 0; i < keys.length; ++i)
                                    message.labels[keys[i]] = String(object.labels[keys[i]]);
                            }
                            if (object.storageLocations) {
                                if (!Array.isArray(object.storageLocations))
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties.storageLocations: array expected");
                                message.storageLocations = [];
                                for (var i = 0; i < object.storageLocations.length; ++i)
                                    message.storageLocations[i] = String(object.storageLocations[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResourcePolicySnapshotSchedulePolicySnapshotProperties message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @static
                         * @param {google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties} message ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourcePolicySnapshotSchedulePolicySnapshotProperties.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.storageLocations = [];
                            if (options.objects || options.defaults)
                                object.labels = {};
                            if (message.chainName != null && message.hasOwnProperty("chainName")) {
                                object.chainName = message.chainName;
                                if (options.oneofs)
                                    object._chainName = "chainName";
                            }
                            if (message.storageLocations && message.storageLocations.length) {
                                object.storageLocations = [];
                                for (var j = 0; j < message.storageLocations.length; ++j)
                                    object.storageLocations[j] = message.storageLocations[j];
                            }
                            if (message.guestFlush != null && message.hasOwnProperty("guestFlush")) {
                                object.guestFlush = message.guestFlush;
                                if (options.oneofs)
                                    object._guestFlush = "guestFlush";
                            }
                            var keys2;
                            if (message.labels && (keys2 = Object.keys(message.labels)).length) {
                                object.labels = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.labels[keys2[j]] = message.labels[keys2[j]];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ResourcePolicySnapshotSchedulePolicySnapshotProperties to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourcePolicySnapshotSchedulePolicySnapshotProperties.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResourcePolicySnapshotSchedulePolicySnapshotProperties.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResourcePolicySnapshotSchedulePolicySnapshotProperties";
                        };
    
                        return ResourcePolicySnapshotSchedulePolicySnapshotProperties;
                    })();
    
                    v1.ResourcePolicyWeeklyCycle = (function() {
    
                        /**
                         * Properties of a ResourcePolicyWeeklyCycle.
                         * @memberof google.cloud.compute.v1
                         * @interface IResourcePolicyWeeklyCycle
                         * @property {Array.<google.cloud.compute.v1.IResourcePolicyWeeklyCycleDayOfWeek>|null} [dayOfWeeks] ResourcePolicyWeeklyCycle dayOfWeeks
                         */
    
                        /**
                         * Constructs a new ResourcePolicyWeeklyCycle.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourcePolicyWeeklyCycle.
                         * @implements IResourcePolicyWeeklyCycle
                         * @constructor
                         * @param {google.cloud.compute.v1.IResourcePolicyWeeklyCycle=} [properties] Properties to set
                         */
                        function ResourcePolicyWeeklyCycle(properties) {
                            this.dayOfWeeks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResourcePolicyWeeklyCycle dayOfWeeks.
                         * @member {Array.<google.cloud.compute.v1.IResourcePolicyWeeklyCycleDayOfWeek>} dayOfWeeks
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycle
                         * @instance
                         */
                        ResourcePolicyWeeklyCycle.prototype.dayOfWeeks = $util.emptyArray;
    
                        /**
                         * Creates a new ResourcePolicyWeeklyCycle instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycle
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyWeeklyCycle=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResourcePolicyWeeklyCycle} ResourcePolicyWeeklyCycle instance
                         */
                        ResourcePolicyWeeklyCycle.create = function create(properties) {
                            return new ResourcePolicyWeeklyCycle(properties);
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyWeeklyCycle message. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyWeeklyCycle.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycle
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyWeeklyCycle} message ResourcePolicyWeeklyCycle message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyWeeklyCycle.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.dayOfWeeks != null && message.dayOfWeeks.length)
                                for (var i = 0; i < message.dayOfWeeks.length; ++i)
                                    $root.google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek.encode(message.dayOfWeeks[i], writer.uint32(/* id 257871834, wireType 2 =*/2062974674).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyWeeklyCycle message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyWeeklyCycle.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycle
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyWeeklyCycle} message ResourcePolicyWeeklyCycle message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyWeeklyCycle.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResourcePolicyWeeklyCycle message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycle
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResourcePolicyWeeklyCycle} ResourcePolicyWeeklyCycle
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyWeeklyCycle.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResourcePolicyWeeklyCycle();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 257871834: {
                                        if (!(message.dayOfWeeks && message.dayOfWeeks.length))
                                            message.dayOfWeeks = [];
                                        message.dayOfWeeks.push($root.google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResourcePolicyWeeklyCycle message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycle
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResourcePolicyWeeklyCycle} ResourcePolicyWeeklyCycle
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyWeeklyCycle.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResourcePolicyWeeklyCycle message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycle
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourcePolicyWeeklyCycle.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.dayOfWeeks != null && message.hasOwnProperty("dayOfWeeks")) {
                                if (!Array.isArray(message.dayOfWeeks))
                                    return "dayOfWeeks: array expected";
                                for (var i = 0; i < message.dayOfWeeks.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek.verify(message.dayOfWeeks[i]);
                                    if (error)
                                        return "dayOfWeeks." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResourcePolicyWeeklyCycle message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycle
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResourcePolicyWeeklyCycle} ResourcePolicyWeeklyCycle
                         */
                        ResourcePolicyWeeklyCycle.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResourcePolicyWeeklyCycle)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResourcePolicyWeeklyCycle();
                            if (object.dayOfWeeks) {
                                if (!Array.isArray(object.dayOfWeeks))
                                    throw TypeError(".google.cloud.compute.v1.ResourcePolicyWeeklyCycle.dayOfWeeks: array expected");
                                message.dayOfWeeks = [];
                                for (var i = 0; i < object.dayOfWeeks.length; ++i) {
                                    if (typeof object.dayOfWeeks[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ResourcePolicyWeeklyCycle.dayOfWeeks: object expected");
                                    message.dayOfWeeks[i] = $root.google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek.fromObject(object.dayOfWeeks[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResourcePolicyWeeklyCycle message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycle
                         * @static
                         * @param {google.cloud.compute.v1.ResourcePolicyWeeklyCycle} message ResourcePolicyWeeklyCycle
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourcePolicyWeeklyCycle.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.dayOfWeeks = [];
                            if (message.dayOfWeeks && message.dayOfWeeks.length) {
                                object.dayOfWeeks = [];
                                for (var j = 0; j < message.dayOfWeeks.length; ++j)
                                    object.dayOfWeeks[j] = $root.google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek.toObject(message.dayOfWeeks[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ResourcePolicyWeeklyCycle to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycle
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourcePolicyWeeklyCycle.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResourcePolicyWeeklyCycle
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycle
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResourcePolicyWeeklyCycle.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResourcePolicyWeeklyCycle";
                        };
    
                        return ResourcePolicyWeeklyCycle;
                    })();
    
                    v1.ResourcePolicyWeeklyCycleDayOfWeek = (function() {
    
                        /**
                         * Properties of a ResourcePolicyWeeklyCycleDayOfWeek.
                         * @memberof google.cloud.compute.v1
                         * @interface IResourcePolicyWeeklyCycleDayOfWeek
                         * @property {string|null} [day] ResourcePolicyWeeklyCycleDayOfWeek day
                         * @property {string|null} [duration] ResourcePolicyWeeklyCycleDayOfWeek duration
                         * @property {string|null} [startTime] ResourcePolicyWeeklyCycleDayOfWeek startTime
                         */
    
                        /**
                         * Constructs a new ResourcePolicyWeeklyCycleDayOfWeek.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourcePolicyWeeklyCycleDayOfWeek.
                         * @implements IResourcePolicyWeeklyCycleDayOfWeek
                         * @constructor
                         * @param {google.cloud.compute.v1.IResourcePolicyWeeklyCycleDayOfWeek=} [properties] Properties to set
                         */
                        function ResourcePolicyWeeklyCycleDayOfWeek(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResourcePolicyWeeklyCycleDayOfWeek day.
                         * @member {string|null|undefined} day
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek
                         * @instance
                         */
                        ResourcePolicyWeeklyCycleDayOfWeek.prototype.day = null;
    
                        /**
                         * ResourcePolicyWeeklyCycleDayOfWeek duration.
                         * @member {string|null|undefined} duration
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek
                         * @instance
                         */
                        ResourcePolicyWeeklyCycleDayOfWeek.prototype.duration = null;
    
                        /**
                         * ResourcePolicyWeeklyCycleDayOfWeek startTime.
                         * @member {string|null|undefined} startTime
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek
                         * @instance
                         */
                        ResourcePolicyWeeklyCycleDayOfWeek.prototype.startTime = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResourcePolicyWeeklyCycleDayOfWeek _day.
                         * @member {"day"|undefined} _day
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyWeeklyCycleDayOfWeek.prototype, "_day", {
                            get: $util.oneOfGetter($oneOfFields = ["day"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyWeeklyCycleDayOfWeek _duration.
                         * @member {"duration"|undefined} _duration
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyWeeklyCycleDayOfWeek.prototype, "_duration", {
                            get: $util.oneOfGetter($oneOfFields = ["duration"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ResourcePolicyWeeklyCycleDayOfWeek _startTime.
                         * @member {"startTime"|undefined} _startTime
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek
                         * @instance
                         */
                        Object.defineProperty(ResourcePolicyWeeklyCycleDayOfWeek.prototype, "_startTime", {
                            get: $util.oneOfGetter($oneOfFields = ["startTime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResourcePolicyWeeklyCycleDayOfWeek instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyWeeklyCycleDayOfWeek=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek} ResourcePolicyWeeklyCycleDayOfWeek instance
                         */
                        ResourcePolicyWeeklyCycleDayOfWeek.create = function create(properties) {
                            return new ResourcePolicyWeeklyCycleDayOfWeek(properties);
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyWeeklyCycleDayOfWeek message. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyWeeklyCycleDayOfWeek} message ResourcePolicyWeeklyCycleDayOfWeek message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyWeeklyCycleDayOfWeek.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.day != null && Object.hasOwnProperty.call(message, "day"))
                                writer.uint32(/* id 99228, wireType 2 =*/793826).string(message.day);
                            if (message.startTime != null && Object.hasOwnProperty.call(message, "startTime"))
                                writer.uint32(/* id 37467274, wireType 2 =*/299738194).string(message.startTime);
                            if (message.duration != null && Object.hasOwnProperty.call(message, "duration"))
                                writer.uint32(/* id 155471252, wireType 2 =*/1243770018).string(message.duration);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResourcePolicyWeeklyCycleDayOfWeek message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek
                         * @static
                         * @param {google.cloud.compute.v1.IResourcePolicyWeeklyCycleDayOfWeek} message ResourcePolicyWeeklyCycleDayOfWeek message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourcePolicyWeeklyCycleDayOfWeek.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResourcePolicyWeeklyCycleDayOfWeek message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek} ResourcePolicyWeeklyCycleDayOfWeek
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyWeeklyCycleDayOfWeek.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 99228: {
                                        message.day = reader.string();
                                        break;
                                    }
                                case 155471252: {
                                        message.duration = reader.string();
                                        break;
                                    }
                                case 37467274: {
                                        message.startTime = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResourcePolicyWeeklyCycleDayOfWeek message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek} ResourcePolicyWeeklyCycleDayOfWeek
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourcePolicyWeeklyCycleDayOfWeek.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResourcePolicyWeeklyCycleDayOfWeek message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourcePolicyWeeklyCycleDayOfWeek.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.day != null && message.hasOwnProperty("day")) {
                                properties._day = 1;
                                if (!$util.isString(message.day))
                                    return "day: string expected";
                            }
                            if (message.duration != null && message.hasOwnProperty("duration")) {
                                properties._duration = 1;
                                if (!$util.isString(message.duration))
                                    return "duration: string expected";
                            }
                            if (message.startTime != null && message.hasOwnProperty("startTime")) {
                                properties._startTime = 1;
                                if (!$util.isString(message.startTime))
                                    return "startTime: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResourcePolicyWeeklyCycleDayOfWeek message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek} ResourcePolicyWeeklyCycleDayOfWeek
                         */
                        ResourcePolicyWeeklyCycleDayOfWeek.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek();
                            if (object.day != null)
                                message.day = String(object.day);
                            if (object.duration != null)
                                message.duration = String(object.duration);
                            if (object.startTime != null)
                                message.startTime = String(object.startTime);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResourcePolicyWeeklyCycleDayOfWeek message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek
                         * @static
                         * @param {google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek} message ResourcePolicyWeeklyCycleDayOfWeek
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourcePolicyWeeklyCycleDayOfWeek.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.day != null && message.hasOwnProperty("day")) {
                                object.day = message.day;
                                if (options.oneofs)
                                    object._day = "day";
                            }
                            if (message.startTime != null && message.hasOwnProperty("startTime")) {
                                object.startTime = message.startTime;
                                if (options.oneofs)
                                    object._startTime = "startTime";
                            }
                            if (message.duration != null && message.hasOwnProperty("duration")) {
                                object.duration = message.duration;
                                if (options.oneofs)
                                    object._duration = "duration";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ResourcePolicyWeeklyCycleDayOfWeek to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourcePolicyWeeklyCycleDayOfWeek.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResourcePolicyWeeklyCycleDayOfWeek
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResourcePolicyWeeklyCycleDayOfWeek.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek";
                        };
    
                        /**
                         * Day enum.
                         * @name google.cloud.compute.v1.ResourcePolicyWeeklyCycleDayOfWeek.Day
                         * @enum {number}
                         * @property {number} UNDEFINED_DAY=0 UNDEFINED_DAY value
                         * @property {number} FRIDAY=471398751 FRIDAY value
                         * @property {number} INVALID=530283991 INVALID value
                         * @property {number} MONDAY=132310288 MONDAY value
                         * @property {number} SATURDAY=279037881 SATURDAY value
                         * @property {number} SUNDAY=309626320 SUNDAY value
                         * @property {number} THURSDAY=207198682 THURSDAY value
                         * @property {number} TUESDAY=277509677 TUESDAY value
                         * @property {number} WEDNESDAY=422029110 WEDNESDAY value
                         */
                        ResourcePolicyWeeklyCycleDayOfWeek.Day = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_DAY"] = 0;
                            values[valuesById[471398751] = "FRIDAY"] = 471398751;
                            values[valuesById[530283991] = "INVALID"] = 530283991;
                            values[valuesById[132310288] = "MONDAY"] = 132310288;
                            values[valuesById[279037881] = "SATURDAY"] = 279037881;
                            values[valuesById[309626320] = "SUNDAY"] = 309626320;
                            values[valuesById[207198682] = "THURSDAY"] = 207198682;
                            values[valuesById[277509677] = "TUESDAY"] = 277509677;
                            values[valuesById[422029110] = "WEDNESDAY"] = 422029110;
                            return values;
                        })();
    
                        return ResourcePolicyWeeklyCycleDayOfWeek;
                    })();
    
                    v1.ResourceStatus = (function() {
    
                        /**
                         * Properties of a ResourceStatus.
                         * @memberof google.cloud.compute.v1
                         * @interface IResourceStatus
                         * @property {string|null} [physicalHost] ResourceStatus physicalHost
                         */
    
                        /**
                         * Constructs a new ResourceStatus.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourceStatus.
                         * @implements IResourceStatus
                         * @constructor
                         * @param {google.cloud.compute.v1.IResourceStatus=} [properties] Properties to set
                         */
                        function ResourceStatus(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResourceStatus physicalHost.
                         * @member {string|null|undefined} physicalHost
                         * @memberof google.cloud.compute.v1.ResourceStatus
                         * @instance
                         */
                        ResourceStatus.prototype.physicalHost = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResourceStatus _physicalHost.
                         * @member {"physicalHost"|undefined} _physicalHost
                         * @memberof google.cloud.compute.v1.ResourceStatus
                         * @instance
                         */
                        Object.defineProperty(ResourceStatus.prototype, "_physicalHost", {
                            get: $util.oneOfGetter($oneOfFields = ["physicalHost"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResourceStatus instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourceStatus
                         * @static
                         * @param {google.cloud.compute.v1.IResourceStatus=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResourceStatus} ResourceStatus instance
                         */
                        ResourceStatus.create = function create(properties) {
                            return new ResourceStatus(properties);
                        };
    
                        /**
                         * Encodes the specified ResourceStatus message. Does not implicitly {@link google.cloud.compute.v1.ResourceStatus.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResourceStatus
                         * @static
                         * @param {google.cloud.compute.v1.IResourceStatus} message ResourceStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourceStatus.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.physicalHost != null && Object.hasOwnProperty.call(message, "physicalHost"))
                                writer.uint32(/* id 464370704, wireType 2 =*/3714965634).string(message.physicalHost);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResourceStatus message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResourceStatus.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResourceStatus
                         * @static
                         * @param {google.cloud.compute.v1.IResourceStatus} message ResourceStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResourceStatus.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResourceStatus message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResourceStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResourceStatus} ResourceStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourceStatus.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResourceStatus();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 464370704: {
                                        message.physicalHost = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResourceStatus message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResourceStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResourceStatus} ResourceStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResourceStatus.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResourceStatus message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResourceStatus
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResourceStatus.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.physicalHost != null && message.hasOwnProperty("physicalHost")) {
                                properties._physicalHost = 1;
                                if (!$util.isString(message.physicalHost))
                                    return "physicalHost: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ResourceStatus message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResourceStatus
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResourceStatus} ResourceStatus
                         */
                        ResourceStatus.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResourceStatus)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResourceStatus();
                            if (object.physicalHost != null)
                                message.physicalHost = String(object.physicalHost);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResourceStatus message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResourceStatus
                         * @static
                         * @param {google.cloud.compute.v1.ResourceStatus} message ResourceStatus
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResourceStatus.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.physicalHost != null && message.hasOwnProperty("physicalHost")) {
                                object.physicalHost = message.physicalHost;
                                if (options.oneofs)
                                    object._physicalHost = "physicalHost";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ResourceStatus to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResourceStatus
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResourceStatus.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResourceStatus
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResourceStatus
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResourceStatus.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResourceStatus";
                        };
    
                        return ResourceStatus;
                    })();
    
                    v1.ResumeInstanceRequest = (function() {
    
                        /**
                         * Properties of a ResumeInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IResumeInstanceRequest
                         * @property {string|null} [instance] ResumeInstanceRequest instance
                         * @property {string|null} [project] ResumeInstanceRequest project
                         * @property {string|null} [requestId] ResumeInstanceRequest requestId
                         * @property {string|null} [zone] ResumeInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new ResumeInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResumeInstanceRequest.
                         * @implements IResumeInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IResumeInstanceRequest=} [properties] Properties to set
                         */
                        function ResumeInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ResumeInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.ResumeInstanceRequest
                         * @instance
                         */
                        ResumeInstanceRequest.prototype.instance = "";
    
                        /**
                         * ResumeInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ResumeInstanceRequest
                         * @instance
                         */
                        ResumeInstanceRequest.prototype.project = "";
    
                        /**
                         * ResumeInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.ResumeInstanceRequest
                         * @instance
                         */
                        ResumeInstanceRequest.prototype.requestId = null;
    
                        /**
                         * ResumeInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.ResumeInstanceRequest
                         * @instance
                         */
                        ResumeInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ResumeInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.ResumeInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(ResumeInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ResumeInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResumeInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResumeInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ResumeInstanceRequest} ResumeInstanceRequest instance
                         */
                        ResumeInstanceRequest.create = function create(properties) {
                            return new ResumeInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ResumeInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.ResumeInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ResumeInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResumeInstanceRequest} message ResumeInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResumeInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ResumeInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ResumeInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ResumeInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IResumeInstanceRequest} message ResumeInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ResumeInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ResumeInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ResumeInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ResumeInstanceRequest} ResumeInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResumeInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ResumeInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ResumeInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ResumeInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ResumeInstanceRequest} ResumeInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ResumeInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ResumeInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ResumeInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ResumeInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ResumeInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ResumeInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ResumeInstanceRequest} ResumeInstanceRequest
                         */
                        ResumeInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ResumeInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ResumeInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ResumeInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ResumeInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ResumeInstanceRequest} message ResumeInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ResumeInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this ResumeInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ResumeInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ResumeInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ResumeInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ResumeInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ResumeInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ResumeInstanceRequest";
                        };
    
                        return ResumeInstanceRequest;
                    })();
    
                    v1.Route = (function() {
    
                        /**
                         * Properties of a Route.
                         * @memberof google.cloud.compute.v1
                         * @interface IRoute
                         * @property {Array.<google.cloud.compute.v1.IRouteAsPath>|null} [asPaths] Route asPaths
                         * @property {string|null} [creationTimestamp] Route creationTimestamp
                         * @property {string|null} [description] Route description
                         * @property {string|null} [destRange] Route destRange
                         * @property {number|Long|null} [id] Route id
                         * @property {string|null} [kind] Route kind
                         * @property {string|null} [name] Route name
                         * @property {string|null} [network] Route network
                         * @property {string|null} [nextHopGateway] Route nextHopGateway
                         * @property {string|null} [nextHopIlb] Route nextHopIlb
                         * @property {string|null} [nextHopInstance] Route nextHopInstance
                         * @property {string|null} [nextHopIp] Route nextHopIp
                         * @property {string|null} [nextHopNetwork] Route nextHopNetwork
                         * @property {string|null} [nextHopPeering] Route nextHopPeering
                         * @property {string|null} [nextHopVpnTunnel] Route nextHopVpnTunnel
                         * @property {number|null} [priority] Route priority
                         * @property {string|null} [routeStatus] Route routeStatus
                         * @property {string|null} [routeType] Route routeType
                         * @property {string|null} [selfLink] Route selfLink
                         * @property {Array.<string>|null} [tags] Route tags
                         * @property {Array.<google.cloud.compute.v1.IWarnings>|null} [warnings] Route warnings
                         */
    
                        /**
                         * Constructs a new Route.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Route.
                         * @implements IRoute
                         * @constructor
                         * @param {google.cloud.compute.v1.IRoute=} [properties] Properties to set
                         */
                        function Route(properties) {
                            this.asPaths = [];
                            this.tags = [];
                            this.warnings = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Route asPaths.
                         * @member {Array.<google.cloud.compute.v1.IRouteAsPath>} asPaths
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.asPaths = $util.emptyArray;
    
                        /**
                         * Route creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.creationTimestamp = null;
    
                        /**
                         * Route description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.description = null;
    
                        /**
                         * Route destRange.
                         * @member {string|null|undefined} destRange
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.destRange = null;
    
                        /**
                         * Route id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.id = null;
    
                        /**
                         * Route kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.kind = null;
    
                        /**
                         * Route name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.name = null;
    
                        /**
                         * Route network.
                         * @member {string|null|undefined} network
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.network = null;
    
                        /**
                         * Route nextHopGateway.
                         * @member {string|null|undefined} nextHopGateway
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.nextHopGateway = null;
    
                        /**
                         * Route nextHopIlb.
                         * @member {string|null|undefined} nextHopIlb
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.nextHopIlb = null;
    
                        /**
                         * Route nextHopInstance.
                         * @member {string|null|undefined} nextHopInstance
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.nextHopInstance = null;
    
                        /**
                         * Route nextHopIp.
                         * @member {string|null|undefined} nextHopIp
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.nextHopIp = null;
    
                        /**
                         * Route nextHopNetwork.
                         * @member {string|null|undefined} nextHopNetwork
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.nextHopNetwork = null;
    
                        /**
                         * Route nextHopPeering.
                         * @member {string|null|undefined} nextHopPeering
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.nextHopPeering = null;
    
                        /**
                         * Route nextHopVpnTunnel.
                         * @member {string|null|undefined} nextHopVpnTunnel
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.nextHopVpnTunnel = null;
    
                        /**
                         * Route priority.
                         * @member {number|null|undefined} priority
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.priority = null;
    
                        /**
                         * Route routeStatus.
                         * @member {string|null|undefined} routeStatus
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.routeStatus = null;
    
                        /**
                         * Route routeType.
                         * @member {string|null|undefined} routeType
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.routeType = null;
    
                        /**
                         * Route selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.selfLink = null;
    
                        /**
                         * Route tags.
                         * @member {Array.<string>} tags
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.tags = $util.emptyArray;
    
                        /**
                         * Route warnings.
                         * @member {Array.<google.cloud.compute.v1.IWarnings>} warnings
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Route.prototype.warnings = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Route _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Object.defineProperty(Route.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Route _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Object.defineProperty(Route.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Route _destRange.
                         * @member {"destRange"|undefined} _destRange
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Object.defineProperty(Route.prototype, "_destRange", {
                            get: $util.oneOfGetter($oneOfFields = ["destRange"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Route _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Object.defineProperty(Route.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Route _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Object.defineProperty(Route.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Route _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Object.defineProperty(Route.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Route _network.
                         * @member {"network"|undefined} _network
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Object.defineProperty(Route.prototype, "_network", {
                            get: $util.oneOfGetter($oneOfFields = ["network"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Route _nextHopGateway.
                         * @member {"nextHopGateway"|undefined} _nextHopGateway
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Object.defineProperty(Route.prototype, "_nextHopGateway", {
                            get: $util.oneOfGetter($oneOfFields = ["nextHopGateway"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Route _nextHopIlb.
                         * @member {"nextHopIlb"|undefined} _nextHopIlb
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Object.defineProperty(Route.prototype, "_nextHopIlb", {
                            get: $util.oneOfGetter($oneOfFields = ["nextHopIlb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Route _nextHopInstance.
                         * @member {"nextHopInstance"|undefined} _nextHopInstance
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Object.defineProperty(Route.prototype, "_nextHopInstance", {
                            get: $util.oneOfGetter($oneOfFields = ["nextHopInstance"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Route _nextHopIp.
                         * @member {"nextHopIp"|undefined} _nextHopIp
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Object.defineProperty(Route.prototype, "_nextHopIp", {
                            get: $util.oneOfGetter($oneOfFields = ["nextHopIp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Route _nextHopNetwork.
                         * @member {"nextHopNetwork"|undefined} _nextHopNetwork
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Object.defineProperty(Route.prototype, "_nextHopNetwork", {
                            get: $util.oneOfGetter($oneOfFields = ["nextHopNetwork"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Route _nextHopPeering.
                         * @member {"nextHopPeering"|undefined} _nextHopPeering
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Object.defineProperty(Route.prototype, "_nextHopPeering", {
                            get: $util.oneOfGetter($oneOfFields = ["nextHopPeering"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Route _nextHopVpnTunnel.
                         * @member {"nextHopVpnTunnel"|undefined} _nextHopVpnTunnel
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Object.defineProperty(Route.prototype, "_nextHopVpnTunnel", {
                            get: $util.oneOfGetter($oneOfFields = ["nextHopVpnTunnel"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Route _priority.
                         * @member {"priority"|undefined} _priority
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Object.defineProperty(Route.prototype, "_priority", {
                            get: $util.oneOfGetter($oneOfFields = ["priority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Route _routeStatus.
                         * @member {"routeStatus"|undefined} _routeStatus
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Object.defineProperty(Route.prototype, "_routeStatus", {
                            get: $util.oneOfGetter($oneOfFields = ["routeStatus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Route _routeType.
                         * @member {"routeType"|undefined} _routeType
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Object.defineProperty(Route.prototype, "_routeType", {
                            get: $util.oneOfGetter($oneOfFields = ["routeType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Route _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         */
                        Object.defineProperty(Route.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Route instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Route
                         * @static
                         * @param {google.cloud.compute.v1.IRoute=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Route} Route instance
                         */
                        Route.create = function create(properties) {
                            return new Route(properties);
                        };
    
                        /**
                         * Encodes the specified Route message. Does not implicitly {@link google.cloud.compute.v1.Route.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Route
                         * @static
                         * @param {google.cloud.compute.v1.IRoute} message Route message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Route.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.tags != null && message.tags.length)
                                for (var i = 0; i < message.tags.length; ++i)
                                    writer.uint32(/* id 3552281, wireType 2 =*/28418250).string(message.tags[i]);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.nextHopIp != null && Object.hasOwnProperty.call(message, "nextHopIp"))
                                writer.uint32(/* id 110319529, wireType 2 =*/882556234).string(message.nextHopIp);
                            if (message.asPaths != null && message.asPaths.length)
                                for (var i = 0; i < message.asPaths.length; ++i)
                                    $root.google.cloud.compute.v1.RouteAsPath.encode(message.asPaths[i], writer.uint32(/* id 137568929, wireType 2 =*/1100551434).fork()).ldelim();
                            if (message.nextHopIlb != null && Object.hasOwnProperty.call(message, "nextHopIlb"))
                                writer.uint32(/* id 198679901, wireType 2 =*/1589439210).string(message.nextHopIlb);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            if (message.nextHopNetwork != null && Object.hasOwnProperty.call(message, "nextHopNetwork"))
                                writer.uint32(/* id 262295788, wireType 2 =*/2098366306).string(message.nextHopNetwork);
                            if (message.routeType != null && Object.hasOwnProperty.call(message, "routeType"))
                                writer.uint32(/* id 375888752, wireType 2 =*/3007110018).string(message.routeType);
                            if (message.nextHopGateway != null && Object.hasOwnProperty.call(message, "nextHopGateway"))
                                writer.uint32(/* id 377175298, wireType 2 =*/3017402386).string(message.nextHopGateway);
                            if (message.destRange != null && Object.hasOwnProperty.call(message, "destRange"))
                                writer.uint32(/* id 381327712, wireType 2 =*/3050621698).string(message.destRange);
                            if (message.nextHopInstance != null && Object.hasOwnProperty.call(message, "nextHopInstance"))
                                writer.uint32(/* id 393508247, wireType 2 =*/3148065978).string(message.nextHopInstance);
                            if (message.nextHopPeering != null && Object.hasOwnProperty.call(message, "nextHopPeering"))
                                writer.uint32(/* id 412682750, wireType 2 =*/3301462002).string(message.nextHopPeering);
                            if (message.routeStatus != null && Object.hasOwnProperty.call(message, "routeStatus"))
                                writer.uint32(/* id 418162344, wireType 2 =*/3345298754).string(message.routeStatus);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.priority != null && Object.hasOwnProperty.call(message, "priority"))
                                writer.uint32(/* id 445151652, wireType 0 =*/3561213216).uint32(message.priority);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.warnings != null && message.warnings.length)
                                for (var i = 0; i < message.warnings.length; ++i)
                                    $root.google.cloud.compute.v1.Warnings.encode(message.warnings[i], writer.uint32(/* id 498091095, wireType 2 =*/3984728762).fork()).ldelim();
                            if (message.nextHopVpnTunnel != null && Object.hasOwnProperty.call(message, "nextHopVpnTunnel"))
                                writer.uint32(/* id 519844501, wireType 2 =*/4158756010).string(message.nextHopVpnTunnel);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Route message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Route.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Route
                         * @static
                         * @param {google.cloud.compute.v1.IRoute} message Route message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Route.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Route message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Route
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Route} Route
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Route.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Route();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 137568929: {
                                        if (!(message.asPaths && message.asPaths.length))
                                            message.asPaths = [];
                                        message.asPaths.push($root.google.cloud.compute.v1.RouteAsPath.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 381327712: {
                                        message.destRange = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 377175298: {
                                        message.nextHopGateway = reader.string();
                                        break;
                                    }
                                case 198679901: {
                                        message.nextHopIlb = reader.string();
                                        break;
                                    }
                                case 393508247: {
                                        message.nextHopInstance = reader.string();
                                        break;
                                    }
                                case 110319529: {
                                        message.nextHopIp = reader.string();
                                        break;
                                    }
                                case 262295788: {
                                        message.nextHopNetwork = reader.string();
                                        break;
                                    }
                                case 412682750: {
                                        message.nextHopPeering = reader.string();
                                        break;
                                    }
                                case 519844501: {
                                        message.nextHopVpnTunnel = reader.string();
                                        break;
                                    }
                                case 445151652: {
                                        message.priority = reader.uint32();
                                        break;
                                    }
                                case 418162344: {
                                        message.routeStatus = reader.string();
                                        break;
                                    }
                                case 375888752: {
                                        message.routeType = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 3552281: {
                                        if (!(message.tags && message.tags.length))
                                            message.tags = [];
                                        message.tags.push(reader.string());
                                        break;
                                    }
                                case 498091095: {
                                        if (!(message.warnings && message.warnings.length))
                                            message.warnings = [];
                                        message.warnings.push($root.google.cloud.compute.v1.Warnings.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Route message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Route
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Route} Route
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Route.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Route message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Route
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Route.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.asPaths != null && message.hasOwnProperty("asPaths")) {
                                if (!Array.isArray(message.asPaths))
                                    return "asPaths: array expected";
                                for (var i = 0; i < message.asPaths.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.RouteAsPath.verify(message.asPaths[i]);
                                    if (error)
                                        return "asPaths." + error;
                                }
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.destRange != null && message.hasOwnProperty("destRange")) {
                                properties._destRange = 1;
                                if (!$util.isString(message.destRange))
                                    return "destRange: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                properties._network = 1;
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            }
                            if (message.nextHopGateway != null && message.hasOwnProperty("nextHopGateway")) {
                                properties._nextHopGateway = 1;
                                if (!$util.isString(message.nextHopGateway))
                                    return "nextHopGateway: string expected";
                            }
                            if (message.nextHopIlb != null && message.hasOwnProperty("nextHopIlb")) {
                                properties._nextHopIlb = 1;
                                if (!$util.isString(message.nextHopIlb))
                                    return "nextHopIlb: string expected";
                            }
                            if (message.nextHopInstance != null && message.hasOwnProperty("nextHopInstance")) {
                                properties._nextHopInstance = 1;
                                if (!$util.isString(message.nextHopInstance))
                                    return "nextHopInstance: string expected";
                            }
                            if (message.nextHopIp != null && message.hasOwnProperty("nextHopIp")) {
                                properties._nextHopIp = 1;
                                if (!$util.isString(message.nextHopIp))
                                    return "nextHopIp: string expected";
                            }
                            if (message.nextHopNetwork != null && message.hasOwnProperty("nextHopNetwork")) {
                                properties._nextHopNetwork = 1;
                                if (!$util.isString(message.nextHopNetwork))
                                    return "nextHopNetwork: string expected";
                            }
                            if (message.nextHopPeering != null && message.hasOwnProperty("nextHopPeering")) {
                                properties._nextHopPeering = 1;
                                if (!$util.isString(message.nextHopPeering))
                                    return "nextHopPeering: string expected";
                            }
                            if (message.nextHopVpnTunnel != null && message.hasOwnProperty("nextHopVpnTunnel")) {
                                properties._nextHopVpnTunnel = 1;
                                if (!$util.isString(message.nextHopVpnTunnel))
                                    return "nextHopVpnTunnel: string expected";
                            }
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                properties._priority = 1;
                                if (!$util.isInteger(message.priority))
                                    return "priority: integer expected";
                            }
                            if (message.routeStatus != null && message.hasOwnProperty("routeStatus")) {
                                properties._routeStatus = 1;
                                if (!$util.isString(message.routeStatus))
                                    return "routeStatus: string expected";
                            }
                            if (message.routeType != null && message.hasOwnProperty("routeType")) {
                                properties._routeType = 1;
                                if (!$util.isString(message.routeType))
                                    return "routeType: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.tags != null && message.hasOwnProperty("tags")) {
                                if (!Array.isArray(message.tags))
                                    return "tags: array expected";
                                for (var i = 0; i < message.tags.length; ++i)
                                    if (!$util.isString(message.tags[i]))
                                        return "tags: string[] expected";
                            }
                            if (message.warnings != null && message.hasOwnProperty("warnings")) {
                                if (!Array.isArray(message.warnings))
                                    return "warnings: array expected";
                                for (var i = 0; i < message.warnings.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Warnings.verify(message.warnings[i]);
                                    if (error)
                                        return "warnings." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Route message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Route
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Route} Route
                         */
                        Route.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Route)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Route();
                            if (object.asPaths) {
                                if (!Array.isArray(object.asPaths))
                                    throw TypeError(".google.cloud.compute.v1.Route.asPaths: array expected");
                                message.asPaths = [];
                                for (var i = 0; i < object.asPaths.length; ++i) {
                                    if (typeof object.asPaths[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Route.asPaths: object expected");
                                    message.asPaths[i] = $root.google.cloud.compute.v1.RouteAsPath.fromObject(object.asPaths[i]);
                                }
                            }
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.destRange != null)
                                message.destRange = String(object.destRange);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.nextHopGateway != null)
                                message.nextHopGateway = String(object.nextHopGateway);
                            if (object.nextHopIlb != null)
                                message.nextHopIlb = String(object.nextHopIlb);
                            if (object.nextHopInstance != null)
                                message.nextHopInstance = String(object.nextHopInstance);
                            if (object.nextHopIp != null)
                                message.nextHopIp = String(object.nextHopIp);
                            if (object.nextHopNetwork != null)
                                message.nextHopNetwork = String(object.nextHopNetwork);
                            if (object.nextHopPeering != null)
                                message.nextHopPeering = String(object.nextHopPeering);
                            if (object.nextHopVpnTunnel != null)
                                message.nextHopVpnTunnel = String(object.nextHopVpnTunnel);
                            if (object.priority != null)
                                message.priority = object.priority >>> 0;
                            if (object.routeStatus != null)
                                message.routeStatus = String(object.routeStatus);
                            if (object.routeType != null)
                                message.routeType = String(object.routeType);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.tags) {
                                if (!Array.isArray(object.tags))
                                    throw TypeError(".google.cloud.compute.v1.Route.tags: array expected");
                                message.tags = [];
                                for (var i = 0; i < object.tags.length; ++i)
                                    message.tags[i] = String(object.tags[i]);
                            }
                            if (object.warnings) {
                                if (!Array.isArray(object.warnings))
                                    throw TypeError(".google.cloud.compute.v1.Route.warnings: array expected");
                                message.warnings = [];
                                for (var i = 0; i < object.warnings.length; ++i) {
                                    if (typeof object.warnings[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Route.warnings: object expected");
                                    message.warnings[i] = $root.google.cloud.compute.v1.Warnings.fromObject(object.warnings[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Route message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Route
                         * @static
                         * @param {google.cloud.compute.v1.Route} message Route
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Route.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.tags = [];
                                object.asPaths = [];
                                object.warnings = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.tags && message.tags.length) {
                                object.tags = [];
                                for (var j = 0; j < message.tags.length; ++j)
                                    object.tags[j] = message.tags[j];
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.nextHopIp != null && message.hasOwnProperty("nextHopIp")) {
                                object.nextHopIp = message.nextHopIp;
                                if (options.oneofs)
                                    object._nextHopIp = "nextHopIp";
                            }
                            if (message.asPaths && message.asPaths.length) {
                                object.asPaths = [];
                                for (var j = 0; j < message.asPaths.length; ++j)
                                    object.asPaths[j] = $root.google.cloud.compute.v1.RouteAsPath.toObject(message.asPaths[j], options);
                            }
                            if (message.nextHopIlb != null && message.hasOwnProperty("nextHopIlb")) {
                                object.nextHopIlb = message.nextHopIlb;
                                if (options.oneofs)
                                    object._nextHopIlb = "nextHopIlb";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                object.network = message.network;
                                if (options.oneofs)
                                    object._network = "network";
                            }
                            if (message.nextHopNetwork != null && message.hasOwnProperty("nextHopNetwork")) {
                                object.nextHopNetwork = message.nextHopNetwork;
                                if (options.oneofs)
                                    object._nextHopNetwork = "nextHopNetwork";
                            }
                            if (message.routeType != null && message.hasOwnProperty("routeType")) {
                                object.routeType = message.routeType;
                                if (options.oneofs)
                                    object._routeType = "routeType";
                            }
                            if (message.nextHopGateway != null && message.hasOwnProperty("nextHopGateway")) {
                                object.nextHopGateway = message.nextHopGateway;
                                if (options.oneofs)
                                    object._nextHopGateway = "nextHopGateway";
                            }
                            if (message.destRange != null && message.hasOwnProperty("destRange")) {
                                object.destRange = message.destRange;
                                if (options.oneofs)
                                    object._destRange = "destRange";
                            }
                            if (message.nextHopInstance != null && message.hasOwnProperty("nextHopInstance")) {
                                object.nextHopInstance = message.nextHopInstance;
                                if (options.oneofs)
                                    object._nextHopInstance = "nextHopInstance";
                            }
                            if (message.nextHopPeering != null && message.hasOwnProperty("nextHopPeering")) {
                                object.nextHopPeering = message.nextHopPeering;
                                if (options.oneofs)
                                    object._nextHopPeering = "nextHopPeering";
                            }
                            if (message.routeStatus != null && message.hasOwnProperty("routeStatus")) {
                                object.routeStatus = message.routeStatus;
                                if (options.oneofs)
                                    object._routeStatus = "routeStatus";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                object.priority = message.priority;
                                if (options.oneofs)
                                    object._priority = "priority";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.warnings && message.warnings.length) {
                                object.warnings = [];
                                for (var j = 0; j < message.warnings.length; ++j)
                                    object.warnings[j] = $root.google.cloud.compute.v1.Warnings.toObject(message.warnings[j], options);
                            }
                            if (message.nextHopVpnTunnel != null && message.hasOwnProperty("nextHopVpnTunnel")) {
                                object.nextHopVpnTunnel = message.nextHopVpnTunnel;
                                if (options.oneofs)
                                    object._nextHopVpnTunnel = "nextHopVpnTunnel";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Route to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Route
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Route.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Route
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Route
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Route.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Route";
                        };
    
                        /**
                         * RouteStatus enum.
                         * @name google.cloud.compute.v1.Route.RouteStatus
                         * @enum {number}
                         * @property {number} UNDEFINED_ROUTE_STATUS=0 UNDEFINED_ROUTE_STATUS value
                         * @property {number} ACTIVE=314733318 ACTIVE value
                         * @property {number} DROPPED=496235424 DROPPED value
                         * @property {number} INACTIVE=270421099 INACTIVE value
                         * @property {number} PENDING=35394935 PENDING value
                         */
                        Route.RouteStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ROUTE_STATUS"] = 0;
                            values[valuesById[314733318] = "ACTIVE"] = 314733318;
                            values[valuesById[496235424] = "DROPPED"] = 496235424;
                            values[valuesById[270421099] = "INACTIVE"] = 270421099;
                            values[valuesById[35394935] = "PENDING"] = 35394935;
                            return values;
                        })();
    
                        /**
                         * RouteType enum.
                         * @name google.cloud.compute.v1.Route.RouteType
                         * @enum {number}
                         * @property {number} UNDEFINED_ROUTE_TYPE=0 UNDEFINED_ROUTE_TYPE value
                         * @property {number} BGP=65707 BGP value
                         * @property {number} STATIC=308331118 STATIC value
                         * @property {number} SUBNET=309278557 SUBNET value
                         * @property {number} TRANSIT=187793843 TRANSIT value
                         */
                        Route.RouteType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ROUTE_TYPE"] = 0;
                            values[valuesById[65707] = "BGP"] = 65707;
                            values[valuesById[308331118] = "STATIC"] = 308331118;
                            values[valuesById[309278557] = "SUBNET"] = 309278557;
                            values[valuesById[187793843] = "TRANSIT"] = 187793843;
                            return values;
                        })();
    
                        return Route;
                    })();
    
                    v1.RouteAsPath = (function() {
    
                        /**
                         * Properties of a RouteAsPath.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouteAsPath
                         * @property {Array.<number>|null} [asLists] RouteAsPath asLists
                         * @property {string|null} [pathSegmentType] RouteAsPath pathSegmentType
                         */
    
                        /**
                         * Constructs a new RouteAsPath.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RouteAsPath.
                         * @implements IRouteAsPath
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouteAsPath=} [properties] Properties to set
                         */
                        function RouteAsPath(properties) {
                            this.asLists = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RouteAsPath asLists.
                         * @member {Array.<number>} asLists
                         * @memberof google.cloud.compute.v1.RouteAsPath
                         * @instance
                         */
                        RouteAsPath.prototype.asLists = $util.emptyArray;
    
                        /**
                         * RouteAsPath pathSegmentType.
                         * @member {string|null|undefined} pathSegmentType
                         * @memberof google.cloud.compute.v1.RouteAsPath
                         * @instance
                         */
                        RouteAsPath.prototype.pathSegmentType = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RouteAsPath _pathSegmentType.
                         * @member {"pathSegmentType"|undefined} _pathSegmentType
                         * @memberof google.cloud.compute.v1.RouteAsPath
                         * @instance
                         */
                        Object.defineProperty(RouteAsPath.prototype, "_pathSegmentType", {
                            get: $util.oneOfGetter($oneOfFields = ["pathSegmentType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RouteAsPath instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RouteAsPath
                         * @static
                         * @param {google.cloud.compute.v1.IRouteAsPath=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RouteAsPath} RouteAsPath instance
                         */
                        RouteAsPath.create = function create(properties) {
                            return new RouteAsPath(properties);
                        };
    
                        /**
                         * Encodes the specified RouteAsPath message. Does not implicitly {@link google.cloud.compute.v1.RouteAsPath.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RouteAsPath
                         * @static
                         * @param {google.cloud.compute.v1.IRouteAsPath} message RouteAsPath message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouteAsPath.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.asLists != null && message.asLists.length) {
                                writer.uint32(/* id 134112584, wireType 2 =*/1072900674).fork();
                                for (var i = 0; i < message.asLists.length; ++i)
                                    writer.uint32(message.asLists[i]);
                                writer.ldelim();
                            }
                            if (message.pathSegmentType != null && Object.hasOwnProperty.call(message, "pathSegmentType"))
                                writer.uint32(/* id 513464992, wireType 2 =*/4107719938).string(message.pathSegmentType);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RouteAsPath message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RouteAsPath.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RouteAsPath
                         * @static
                         * @param {google.cloud.compute.v1.IRouteAsPath} message RouteAsPath message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouteAsPath.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RouteAsPath message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RouteAsPath
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RouteAsPath} RouteAsPath
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouteAsPath.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RouteAsPath();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 134112584: {
                                        if (!(message.asLists && message.asLists.length))
                                            message.asLists = [];
                                        if ((tag & 7) === 2) {
                                            var end2 = reader.uint32() + reader.pos;
                                            while (reader.pos < end2)
                                                message.asLists.push(reader.uint32());
                                        } else
                                            message.asLists.push(reader.uint32());
                                        break;
                                    }
                                case 513464992: {
                                        message.pathSegmentType = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RouteAsPath message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RouteAsPath
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RouteAsPath} RouteAsPath
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouteAsPath.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RouteAsPath message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RouteAsPath
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RouteAsPath.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.asLists != null && message.hasOwnProperty("asLists")) {
                                if (!Array.isArray(message.asLists))
                                    return "asLists: array expected";
                                for (var i = 0; i < message.asLists.length; ++i)
                                    if (!$util.isInteger(message.asLists[i]))
                                        return "asLists: integer[] expected";
                            }
                            if (message.pathSegmentType != null && message.hasOwnProperty("pathSegmentType")) {
                                properties._pathSegmentType = 1;
                                if (!$util.isString(message.pathSegmentType))
                                    return "pathSegmentType: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RouteAsPath message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RouteAsPath
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RouteAsPath} RouteAsPath
                         */
                        RouteAsPath.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RouteAsPath)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RouteAsPath();
                            if (object.asLists) {
                                if (!Array.isArray(object.asLists))
                                    throw TypeError(".google.cloud.compute.v1.RouteAsPath.asLists: array expected");
                                message.asLists = [];
                                for (var i = 0; i < object.asLists.length; ++i)
                                    message.asLists[i] = object.asLists[i] >>> 0;
                            }
                            if (object.pathSegmentType != null)
                                message.pathSegmentType = String(object.pathSegmentType);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RouteAsPath message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RouteAsPath
                         * @static
                         * @param {google.cloud.compute.v1.RouteAsPath} message RouteAsPath
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RouteAsPath.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.asLists = [];
                            if (message.asLists && message.asLists.length) {
                                object.asLists = [];
                                for (var j = 0; j < message.asLists.length; ++j)
                                    object.asLists[j] = message.asLists[j];
                            }
                            if (message.pathSegmentType != null && message.hasOwnProperty("pathSegmentType")) {
                                object.pathSegmentType = message.pathSegmentType;
                                if (options.oneofs)
                                    object._pathSegmentType = "pathSegmentType";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RouteAsPath to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RouteAsPath
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RouteAsPath.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RouteAsPath
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RouteAsPath
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RouteAsPath.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RouteAsPath";
                        };
    
                        /**
                         * PathSegmentType enum.
                         * @name google.cloud.compute.v1.RouteAsPath.PathSegmentType
                         * @enum {number}
                         * @property {number} UNDEFINED_PATH_SEGMENT_TYPE=0 UNDEFINED_PATH_SEGMENT_TYPE value
                         * @property {number} AS_CONFED_SEQUENCE=222152624 AS_CONFED_SEQUENCE value
                         * @property {number} AS_CONFED_SET=374040307 AS_CONFED_SET value
                         * @property {number} AS_SEQUENCE=106735918 AS_SEQUENCE value
                         * @property {number} AS_SET=329846453 AS_SET value
                         */
                        RouteAsPath.PathSegmentType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PATH_SEGMENT_TYPE"] = 0;
                            values[valuesById[222152624] = "AS_CONFED_SEQUENCE"] = 222152624;
                            values[valuesById[374040307] = "AS_CONFED_SET"] = 374040307;
                            values[valuesById[106735918] = "AS_SEQUENCE"] = 106735918;
                            values[valuesById[329846453] = "AS_SET"] = 329846453;
                            return values;
                        })();
    
                        return RouteAsPath;
                    })();
    
                    v1.RouteList = (function() {
    
                        /**
                         * Properties of a RouteList.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouteList
                         * @property {string|null} [id] RouteList id
                         * @property {Array.<google.cloud.compute.v1.IRoute>|null} [items] RouteList items
                         * @property {string|null} [kind] RouteList kind
                         * @property {string|null} [nextPageToken] RouteList nextPageToken
                         * @property {string|null} [selfLink] RouteList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] RouteList warning
                         */
    
                        /**
                         * Constructs a new RouteList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RouteList.
                         * @implements IRouteList
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouteList=} [properties] Properties to set
                         */
                        function RouteList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RouteList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.RouteList
                         * @instance
                         */
                        RouteList.prototype.id = null;
    
                        /**
                         * RouteList items.
                         * @member {Array.<google.cloud.compute.v1.IRoute>} items
                         * @memberof google.cloud.compute.v1.RouteList
                         * @instance
                         */
                        RouteList.prototype.items = $util.emptyArray;
    
                        /**
                         * RouteList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.RouteList
                         * @instance
                         */
                        RouteList.prototype.kind = null;
    
                        /**
                         * RouteList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.RouteList
                         * @instance
                         */
                        RouteList.prototype.nextPageToken = null;
    
                        /**
                         * RouteList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.RouteList
                         * @instance
                         */
                        RouteList.prototype.selfLink = null;
    
                        /**
                         * RouteList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.RouteList
                         * @instance
                         */
                        RouteList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RouteList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.RouteList
                         * @instance
                         */
                        Object.defineProperty(RouteList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouteList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.RouteList
                         * @instance
                         */
                        Object.defineProperty(RouteList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouteList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.RouteList
                         * @instance
                         */
                        Object.defineProperty(RouteList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouteList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.RouteList
                         * @instance
                         */
                        Object.defineProperty(RouteList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouteList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.RouteList
                         * @instance
                         */
                        Object.defineProperty(RouteList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RouteList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RouteList
                         * @static
                         * @param {google.cloud.compute.v1.IRouteList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RouteList} RouteList instance
                         */
                        RouteList.create = function create(properties) {
                            return new RouteList(properties);
                        };
    
                        /**
                         * Encodes the specified RouteList message. Does not implicitly {@link google.cloud.compute.v1.RouteList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RouteList
                         * @static
                         * @param {google.cloud.compute.v1.IRouteList} message RouteList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouteList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Route.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RouteList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RouteList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RouteList
                         * @static
                         * @param {google.cloud.compute.v1.IRouteList} message RouteList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouteList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RouteList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RouteList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RouteList} RouteList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouteList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RouteList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Route.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RouteList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RouteList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RouteList} RouteList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouteList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RouteList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RouteList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RouteList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Route.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RouteList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RouteList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RouteList} RouteList
                         */
                        RouteList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RouteList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RouteList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.RouteList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RouteList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Route.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RouteList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RouteList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RouteList
                         * @static
                         * @param {google.cloud.compute.v1.RouteList} message RouteList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RouteList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Route.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RouteList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RouteList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RouteList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RouteList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RouteList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RouteList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RouteList";
                        };
    
                        return RouteList;
                    })();
    
                    v1.Router = (function() {
    
                        /**
                         * Properties of a Router.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouter
                         * @property {google.cloud.compute.v1.IRouterBgp|null} [bgp] Router bgp
                         * @property {Array.<google.cloud.compute.v1.IRouterBgpPeer>|null} [bgpPeers] Router bgpPeers
                         * @property {string|null} [creationTimestamp] Router creationTimestamp
                         * @property {string|null} [description] Router description
                         * @property {boolean|null} [encryptedInterconnectRouter] Router encryptedInterconnectRouter
                         * @property {number|Long|null} [id] Router id
                         * @property {Array.<google.cloud.compute.v1.IRouterInterface>|null} [interfaces] Router interfaces
                         * @property {string|null} [kind] Router kind
                         * @property {Array.<google.cloud.compute.v1.IRouterMd5AuthenticationKey>|null} [md5AuthenticationKeys] Router md5AuthenticationKeys
                         * @property {string|null} [name] Router name
                         * @property {Array.<google.cloud.compute.v1.IRouterNat>|null} [nats] Router nats
                         * @property {string|null} [network] Router network
                         * @property {string|null} [region] Router region
                         * @property {string|null} [selfLink] Router selfLink
                         */
    
                        /**
                         * Constructs a new Router.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Router.
                         * @implements IRouter
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouter=} [properties] Properties to set
                         */
                        function Router(properties) {
                            this.bgpPeers = [];
                            this.interfaces = [];
                            this.md5AuthenticationKeys = [];
                            this.nats = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Router bgp.
                         * @member {google.cloud.compute.v1.IRouterBgp|null|undefined} bgp
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Router.prototype.bgp = null;
    
                        /**
                         * Router bgpPeers.
                         * @member {Array.<google.cloud.compute.v1.IRouterBgpPeer>} bgpPeers
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Router.prototype.bgpPeers = $util.emptyArray;
    
                        /**
                         * Router creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Router.prototype.creationTimestamp = null;
    
                        /**
                         * Router description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Router.prototype.description = null;
    
                        /**
                         * Router encryptedInterconnectRouter.
                         * @member {boolean|null|undefined} encryptedInterconnectRouter
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Router.prototype.encryptedInterconnectRouter = null;
    
                        /**
                         * Router id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Router.prototype.id = null;
    
                        /**
                         * Router interfaces.
                         * @member {Array.<google.cloud.compute.v1.IRouterInterface>} interfaces
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Router.prototype.interfaces = $util.emptyArray;
    
                        /**
                         * Router kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Router.prototype.kind = null;
    
                        /**
                         * Router md5AuthenticationKeys.
                         * @member {Array.<google.cloud.compute.v1.IRouterMd5AuthenticationKey>} md5AuthenticationKeys
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Router.prototype.md5AuthenticationKeys = $util.emptyArray;
    
                        /**
                         * Router name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Router.prototype.name = null;
    
                        /**
                         * Router nats.
                         * @member {Array.<google.cloud.compute.v1.IRouterNat>} nats
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Router.prototype.nats = $util.emptyArray;
    
                        /**
                         * Router network.
                         * @member {string|null|undefined} network
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Router.prototype.network = null;
    
                        /**
                         * Router region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Router.prototype.region = null;
    
                        /**
                         * Router selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Router.prototype.selfLink = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Router _bgp.
                         * @member {"bgp"|undefined} _bgp
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Object.defineProperty(Router.prototype, "_bgp", {
                            get: $util.oneOfGetter($oneOfFields = ["bgp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Router _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Object.defineProperty(Router.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Router _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Object.defineProperty(Router.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Router _encryptedInterconnectRouter.
                         * @member {"encryptedInterconnectRouter"|undefined} _encryptedInterconnectRouter
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Object.defineProperty(Router.prototype, "_encryptedInterconnectRouter", {
                            get: $util.oneOfGetter($oneOfFields = ["encryptedInterconnectRouter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Router _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Object.defineProperty(Router.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Router _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Object.defineProperty(Router.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Router _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Object.defineProperty(Router.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Router _network.
                         * @member {"network"|undefined} _network
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Object.defineProperty(Router.prototype, "_network", {
                            get: $util.oneOfGetter($oneOfFields = ["network"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Router _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Object.defineProperty(Router.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Router _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         */
                        Object.defineProperty(Router.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Router instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Router
                         * @static
                         * @param {google.cloud.compute.v1.IRouter=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Router} Router instance
                         */
                        Router.create = function create(properties) {
                            return new Router(properties);
                        };
    
                        /**
                         * Encodes the specified Router message. Does not implicitly {@link google.cloud.compute.v1.Router.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Router
                         * @static
                         * @param {google.cloud.compute.v1.IRouter} message Router message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Router.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.bgp != null && Object.hasOwnProperty.call(message, "bgp"))
                                $root.google.cloud.compute.v1.RouterBgp.encode(message.bgp, writer.uint32(/* id 97483, wireType 2 =*/779866).fork()).ldelim();
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.nats != null && message.nats.length)
                                for (var i = 0; i < message.nats.length; ++i)
                                    $root.google.cloud.compute.v1.RouterNat.encode(message.nats[i], writer.uint32(/* id 3373938, wireType 2 =*/26991506).fork()).ldelim();
                            if (message.interfaces != null && message.interfaces.length)
                                for (var i = 0; i < message.interfaces.length; ++i)
                                    $root.google.cloud.compute.v1.RouterInterface.encode(message.interfaces[i], writer.uint32(/* id 12073562, wireType 2 =*/96588498).fork()).ldelim();
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.md5AuthenticationKeys != null && message.md5AuthenticationKeys.length)
                                for (var i = 0; i < message.md5AuthenticationKeys.length; ++i)
                                    $root.google.cloud.compute.v1.RouterMd5AuthenticationKey.encode(message.md5AuthenticationKeys[i], writer.uint32(/* id 71063322, wireType 2 =*/568506578).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            if (message.encryptedInterconnectRouter != null && Object.hasOwnProperty.call(message, "encryptedInterconnectRouter"))
                                writer.uint32(/* id 297996575, wireType 0 =*/2383972600).bool(message.encryptedInterconnectRouter);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.bgpPeers != null && message.bgpPeers.length)
                                for (var i = 0; i < message.bgpPeers.length; ++i)
                                    $root.google.cloud.compute.v1.RouterBgpPeer.encode(message.bgpPeers[i], writer.uint32(/* id 452695773, wireType 2 =*/3621566186).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Router message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Router.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Router
                         * @static
                         * @param {google.cloud.compute.v1.IRouter} message Router message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Router.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Router message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Router
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Router} Router
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Router.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Router();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 97483: {
                                        message.bgp = $root.google.cloud.compute.v1.RouterBgp.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 452695773: {
                                        if (!(message.bgpPeers && message.bgpPeers.length))
                                            message.bgpPeers = [];
                                        message.bgpPeers.push($root.google.cloud.compute.v1.RouterBgpPeer.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 297996575: {
                                        message.encryptedInterconnectRouter = reader.bool();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 12073562: {
                                        if (!(message.interfaces && message.interfaces.length))
                                            message.interfaces = [];
                                        message.interfaces.push($root.google.cloud.compute.v1.RouterInterface.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 71063322: {
                                        if (!(message.md5AuthenticationKeys && message.md5AuthenticationKeys.length))
                                            message.md5AuthenticationKeys = [];
                                        message.md5AuthenticationKeys.push($root.google.cloud.compute.v1.RouterMd5AuthenticationKey.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 3373938: {
                                        if (!(message.nats && message.nats.length))
                                            message.nats = [];
                                        message.nats.push($root.google.cloud.compute.v1.RouterNat.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Router message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Router
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Router} Router
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Router.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Router message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Router
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Router.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.bgp != null && message.hasOwnProperty("bgp")) {
                                properties._bgp = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.RouterBgp.verify(message.bgp);
                                    if (error)
                                        return "bgp." + error;
                                }
                            }
                            if (message.bgpPeers != null && message.hasOwnProperty("bgpPeers")) {
                                if (!Array.isArray(message.bgpPeers))
                                    return "bgpPeers: array expected";
                                for (var i = 0; i < message.bgpPeers.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.RouterBgpPeer.verify(message.bgpPeers[i]);
                                    if (error)
                                        return "bgpPeers." + error;
                                }
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.encryptedInterconnectRouter != null && message.hasOwnProperty("encryptedInterconnectRouter")) {
                                properties._encryptedInterconnectRouter = 1;
                                if (typeof message.encryptedInterconnectRouter !== "boolean")
                                    return "encryptedInterconnectRouter: boolean expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.interfaces != null && message.hasOwnProperty("interfaces")) {
                                if (!Array.isArray(message.interfaces))
                                    return "interfaces: array expected";
                                for (var i = 0; i < message.interfaces.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.RouterInterface.verify(message.interfaces[i]);
                                    if (error)
                                        return "interfaces." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.md5AuthenticationKeys != null && message.hasOwnProperty("md5AuthenticationKeys")) {
                                if (!Array.isArray(message.md5AuthenticationKeys))
                                    return "md5AuthenticationKeys: array expected";
                                for (var i = 0; i < message.md5AuthenticationKeys.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.RouterMd5AuthenticationKey.verify(message.md5AuthenticationKeys[i]);
                                    if (error)
                                        return "md5AuthenticationKeys." + error;
                                }
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.nats != null && message.hasOwnProperty("nats")) {
                                if (!Array.isArray(message.nats))
                                    return "nats: array expected";
                                for (var i = 0; i < message.nats.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.RouterNat.verify(message.nats[i]);
                                    if (error)
                                        return "nats." + error;
                                }
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                properties._network = 1;
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Router message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Router
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Router} Router
                         */
                        Router.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Router)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Router();
                            if (object.bgp != null) {
                                if (typeof object.bgp !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Router.bgp: object expected");
                                message.bgp = $root.google.cloud.compute.v1.RouterBgp.fromObject(object.bgp);
                            }
                            if (object.bgpPeers) {
                                if (!Array.isArray(object.bgpPeers))
                                    throw TypeError(".google.cloud.compute.v1.Router.bgpPeers: array expected");
                                message.bgpPeers = [];
                                for (var i = 0; i < object.bgpPeers.length; ++i) {
                                    if (typeof object.bgpPeers[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Router.bgpPeers: object expected");
                                    message.bgpPeers[i] = $root.google.cloud.compute.v1.RouterBgpPeer.fromObject(object.bgpPeers[i]);
                                }
                            }
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.encryptedInterconnectRouter != null)
                                message.encryptedInterconnectRouter = Boolean(object.encryptedInterconnectRouter);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.interfaces) {
                                if (!Array.isArray(object.interfaces))
                                    throw TypeError(".google.cloud.compute.v1.Router.interfaces: array expected");
                                message.interfaces = [];
                                for (var i = 0; i < object.interfaces.length; ++i) {
                                    if (typeof object.interfaces[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Router.interfaces: object expected");
                                    message.interfaces[i] = $root.google.cloud.compute.v1.RouterInterface.fromObject(object.interfaces[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.md5AuthenticationKeys) {
                                if (!Array.isArray(object.md5AuthenticationKeys))
                                    throw TypeError(".google.cloud.compute.v1.Router.md5AuthenticationKeys: array expected");
                                message.md5AuthenticationKeys = [];
                                for (var i = 0; i < object.md5AuthenticationKeys.length; ++i) {
                                    if (typeof object.md5AuthenticationKeys[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Router.md5AuthenticationKeys: object expected");
                                    message.md5AuthenticationKeys[i] = $root.google.cloud.compute.v1.RouterMd5AuthenticationKey.fromObject(object.md5AuthenticationKeys[i]);
                                }
                            }
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.nats) {
                                if (!Array.isArray(object.nats))
                                    throw TypeError(".google.cloud.compute.v1.Router.nats: array expected");
                                message.nats = [];
                                for (var i = 0; i < object.nats.length; ++i) {
                                    if (typeof object.nats[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Router.nats: object expected");
                                    message.nats[i] = $root.google.cloud.compute.v1.RouterNat.fromObject(object.nats[i]);
                                }
                            }
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Router message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Router
                         * @static
                         * @param {google.cloud.compute.v1.Router} message Router
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Router.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.nats = [];
                                object.interfaces = [];
                                object.md5AuthenticationKeys = [];
                                object.bgpPeers = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.bgp != null && message.hasOwnProperty("bgp")) {
                                object.bgp = $root.google.cloud.compute.v1.RouterBgp.toObject(message.bgp, options);
                                if (options.oneofs)
                                    object._bgp = "bgp";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.nats && message.nats.length) {
                                object.nats = [];
                                for (var j = 0; j < message.nats.length; ++j)
                                    object.nats[j] = $root.google.cloud.compute.v1.RouterNat.toObject(message.nats[j], options);
                            }
                            if (message.interfaces && message.interfaces.length) {
                                object.interfaces = [];
                                for (var j = 0; j < message.interfaces.length; ++j)
                                    object.interfaces[j] = $root.google.cloud.compute.v1.RouterInterface.toObject(message.interfaces[j], options);
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.md5AuthenticationKeys && message.md5AuthenticationKeys.length) {
                                object.md5AuthenticationKeys = [];
                                for (var j = 0; j < message.md5AuthenticationKeys.length; ++j)
                                    object.md5AuthenticationKeys[j] = $root.google.cloud.compute.v1.RouterMd5AuthenticationKey.toObject(message.md5AuthenticationKeys[j], options);
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                object.network = message.network;
                                if (options.oneofs)
                                    object._network = "network";
                            }
                            if (message.encryptedInterconnectRouter != null && message.hasOwnProperty("encryptedInterconnectRouter")) {
                                object.encryptedInterconnectRouter = message.encryptedInterconnectRouter;
                                if (options.oneofs)
                                    object._encryptedInterconnectRouter = "encryptedInterconnectRouter";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.bgpPeers && message.bgpPeers.length) {
                                object.bgpPeers = [];
                                for (var j = 0; j < message.bgpPeers.length; ++j)
                                    object.bgpPeers[j] = $root.google.cloud.compute.v1.RouterBgpPeer.toObject(message.bgpPeers[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Router to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Router
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Router.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Router
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Router
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Router.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Router";
                        };
    
                        return Router;
                    })();
    
                    v1.RouterAdvertisedIpRange = (function() {
    
                        /**
                         * Properties of a RouterAdvertisedIpRange.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouterAdvertisedIpRange
                         * @property {string|null} [description] RouterAdvertisedIpRange description
                         * @property {string|null} [range] RouterAdvertisedIpRange range
                         */
    
                        /**
                         * Constructs a new RouterAdvertisedIpRange.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RouterAdvertisedIpRange.
                         * @implements IRouterAdvertisedIpRange
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouterAdvertisedIpRange=} [properties] Properties to set
                         */
                        function RouterAdvertisedIpRange(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RouterAdvertisedIpRange description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.RouterAdvertisedIpRange
                         * @instance
                         */
                        RouterAdvertisedIpRange.prototype.description = null;
    
                        /**
                         * RouterAdvertisedIpRange range.
                         * @member {string|null|undefined} range
                         * @memberof google.cloud.compute.v1.RouterAdvertisedIpRange
                         * @instance
                         */
                        RouterAdvertisedIpRange.prototype.range = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RouterAdvertisedIpRange _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.RouterAdvertisedIpRange
                         * @instance
                         */
                        Object.defineProperty(RouterAdvertisedIpRange.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterAdvertisedIpRange _range.
                         * @member {"range"|undefined} _range
                         * @memberof google.cloud.compute.v1.RouterAdvertisedIpRange
                         * @instance
                         */
                        Object.defineProperty(RouterAdvertisedIpRange.prototype, "_range", {
                            get: $util.oneOfGetter($oneOfFields = ["range"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RouterAdvertisedIpRange instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RouterAdvertisedIpRange
                         * @static
                         * @param {google.cloud.compute.v1.IRouterAdvertisedIpRange=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RouterAdvertisedIpRange} RouterAdvertisedIpRange instance
                         */
                        RouterAdvertisedIpRange.create = function create(properties) {
                            return new RouterAdvertisedIpRange(properties);
                        };
    
                        /**
                         * Encodes the specified RouterAdvertisedIpRange message. Does not implicitly {@link google.cloud.compute.v1.RouterAdvertisedIpRange.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RouterAdvertisedIpRange
                         * @static
                         * @param {google.cloud.compute.v1.IRouterAdvertisedIpRange} message RouterAdvertisedIpRange message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterAdvertisedIpRange.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.range != null && Object.hasOwnProperty.call(message, "range"))
                                writer.uint32(/* id 108280125, wireType 2 =*/866241002).string(message.range);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RouterAdvertisedIpRange message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RouterAdvertisedIpRange.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RouterAdvertisedIpRange
                         * @static
                         * @param {google.cloud.compute.v1.IRouterAdvertisedIpRange} message RouterAdvertisedIpRange message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterAdvertisedIpRange.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RouterAdvertisedIpRange message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RouterAdvertisedIpRange
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RouterAdvertisedIpRange} RouterAdvertisedIpRange
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterAdvertisedIpRange.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RouterAdvertisedIpRange();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 108280125: {
                                        message.range = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RouterAdvertisedIpRange message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RouterAdvertisedIpRange
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RouterAdvertisedIpRange} RouterAdvertisedIpRange
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterAdvertisedIpRange.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RouterAdvertisedIpRange message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RouterAdvertisedIpRange
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RouterAdvertisedIpRange.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.range != null && message.hasOwnProperty("range")) {
                                properties._range = 1;
                                if (!$util.isString(message.range))
                                    return "range: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RouterAdvertisedIpRange message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RouterAdvertisedIpRange
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RouterAdvertisedIpRange} RouterAdvertisedIpRange
                         */
                        RouterAdvertisedIpRange.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RouterAdvertisedIpRange)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RouterAdvertisedIpRange();
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.range != null)
                                message.range = String(object.range);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RouterAdvertisedIpRange message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RouterAdvertisedIpRange
                         * @static
                         * @param {google.cloud.compute.v1.RouterAdvertisedIpRange} message RouterAdvertisedIpRange
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RouterAdvertisedIpRange.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.range != null && message.hasOwnProperty("range")) {
                                object.range = message.range;
                                if (options.oneofs)
                                    object._range = "range";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RouterAdvertisedIpRange to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RouterAdvertisedIpRange
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RouterAdvertisedIpRange.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RouterAdvertisedIpRange
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RouterAdvertisedIpRange
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RouterAdvertisedIpRange.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RouterAdvertisedIpRange";
                        };
    
                        return RouterAdvertisedIpRange;
                    })();
    
                    v1.RouterAggregatedList = (function() {
    
                        /**
                         * Properties of a RouterAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouterAggregatedList
                         * @property {string|null} [id] RouterAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IRoutersScopedList>|null} [items] RouterAggregatedList items
                         * @property {string|null} [kind] RouterAggregatedList kind
                         * @property {string|null} [nextPageToken] RouterAggregatedList nextPageToken
                         * @property {string|null} [selfLink] RouterAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] RouterAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] RouterAggregatedList warning
                         */
    
                        /**
                         * Constructs a new RouterAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RouterAggregatedList.
                         * @implements IRouterAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouterAggregatedList=} [properties] Properties to set
                         */
                        function RouterAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RouterAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @instance
                         */
                        RouterAggregatedList.prototype.id = null;
    
                        /**
                         * RouterAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IRoutersScopedList>} items
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @instance
                         */
                        RouterAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * RouterAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @instance
                         */
                        RouterAggregatedList.prototype.kind = null;
    
                        /**
                         * RouterAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @instance
                         */
                        RouterAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * RouterAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @instance
                         */
                        RouterAggregatedList.prototype.selfLink = null;
    
                        /**
                         * RouterAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @instance
                         */
                        RouterAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * RouterAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @instance
                         */
                        RouterAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RouterAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @instance
                         */
                        Object.defineProperty(RouterAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @instance
                         */
                        Object.defineProperty(RouterAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @instance
                         */
                        Object.defineProperty(RouterAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @instance
                         */
                        Object.defineProperty(RouterAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @instance
                         */
                        Object.defineProperty(RouterAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RouterAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IRouterAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RouterAggregatedList} RouterAggregatedList instance
                         */
                        RouterAggregatedList.create = function create(properties) {
                            return new RouterAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified RouterAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.RouterAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IRouterAggregatedList} message RouterAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.RoutersScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RouterAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RouterAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IRouterAggregatedList} message RouterAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RouterAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RouterAggregatedList} RouterAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RouterAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.RoutersScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RouterAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RouterAggregatedList} RouterAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RouterAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RouterAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.RoutersScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RouterAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RouterAggregatedList} RouterAggregatedList
                         */
                        RouterAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RouterAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RouterAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RouterAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RouterAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.RoutersScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.RouterAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RouterAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RouterAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.RouterAggregatedList} message RouterAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RouterAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.RoutersScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RouterAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RouterAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RouterAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RouterAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RouterAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RouterAggregatedList";
                        };
    
                        return RouterAggregatedList;
                    })();
    
                    v1.RouterBgp = (function() {
    
                        /**
                         * Properties of a RouterBgp.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouterBgp
                         * @property {string|null} [advertiseMode] RouterBgp advertiseMode
                         * @property {Array.<string>|null} [advertisedGroups] RouterBgp advertisedGroups
                         * @property {Array.<google.cloud.compute.v1.IRouterAdvertisedIpRange>|null} [advertisedIpRanges] RouterBgp advertisedIpRanges
                         * @property {number|null} [asn] RouterBgp asn
                         * @property {number|null} [keepaliveInterval] RouterBgp keepaliveInterval
                         */
    
                        /**
                         * Constructs a new RouterBgp.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RouterBgp.
                         * @implements IRouterBgp
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouterBgp=} [properties] Properties to set
                         */
                        function RouterBgp(properties) {
                            this.advertisedGroups = [];
                            this.advertisedIpRanges = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RouterBgp advertiseMode.
                         * @member {string|null|undefined} advertiseMode
                         * @memberof google.cloud.compute.v1.RouterBgp
                         * @instance
                         */
                        RouterBgp.prototype.advertiseMode = null;
    
                        /**
                         * RouterBgp advertisedGroups.
                         * @member {Array.<string>} advertisedGroups
                         * @memberof google.cloud.compute.v1.RouterBgp
                         * @instance
                         */
                        RouterBgp.prototype.advertisedGroups = $util.emptyArray;
    
                        /**
                         * RouterBgp advertisedIpRanges.
                         * @member {Array.<google.cloud.compute.v1.IRouterAdvertisedIpRange>} advertisedIpRanges
                         * @memberof google.cloud.compute.v1.RouterBgp
                         * @instance
                         */
                        RouterBgp.prototype.advertisedIpRanges = $util.emptyArray;
    
                        /**
                         * RouterBgp asn.
                         * @member {number|null|undefined} asn
                         * @memberof google.cloud.compute.v1.RouterBgp
                         * @instance
                         */
                        RouterBgp.prototype.asn = null;
    
                        /**
                         * RouterBgp keepaliveInterval.
                         * @member {number|null|undefined} keepaliveInterval
                         * @memberof google.cloud.compute.v1.RouterBgp
                         * @instance
                         */
                        RouterBgp.prototype.keepaliveInterval = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RouterBgp _advertiseMode.
                         * @member {"advertiseMode"|undefined} _advertiseMode
                         * @memberof google.cloud.compute.v1.RouterBgp
                         * @instance
                         */
                        Object.defineProperty(RouterBgp.prototype, "_advertiseMode", {
                            get: $util.oneOfGetter($oneOfFields = ["advertiseMode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterBgp _asn.
                         * @member {"asn"|undefined} _asn
                         * @memberof google.cloud.compute.v1.RouterBgp
                         * @instance
                         */
                        Object.defineProperty(RouterBgp.prototype, "_asn", {
                            get: $util.oneOfGetter($oneOfFields = ["asn"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterBgp _keepaliveInterval.
                         * @member {"keepaliveInterval"|undefined} _keepaliveInterval
                         * @memberof google.cloud.compute.v1.RouterBgp
                         * @instance
                         */
                        Object.defineProperty(RouterBgp.prototype, "_keepaliveInterval", {
                            get: $util.oneOfGetter($oneOfFields = ["keepaliveInterval"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RouterBgp instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RouterBgp
                         * @static
                         * @param {google.cloud.compute.v1.IRouterBgp=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RouterBgp} RouterBgp instance
                         */
                        RouterBgp.create = function create(properties) {
                            return new RouterBgp(properties);
                        };
    
                        /**
                         * Encodes the specified RouterBgp message. Does not implicitly {@link google.cloud.compute.v1.RouterBgp.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RouterBgp
                         * @static
                         * @param {google.cloud.compute.v1.IRouterBgp} message RouterBgp message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterBgp.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.asn != null && Object.hasOwnProperty.call(message, "asn"))
                                writer.uint32(/* id 96892, wireType 0 =*/775136).uint32(message.asn);
                            if (message.advertisedGroups != null && message.advertisedGroups.length)
                                for (var i = 0; i < message.advertisedGroups.length; ++i)
                                    writer.uint32(/* id 21065526, wireType 2 =*/168524210).string(message.advertisedGroups[i]);
                            if (message.advertisedIpRanges != null && message.advertisedIpRanges.length)
                                for (var i = 0; i < message.advertisedIpRanges.length; ++i)
                                    $root.google.cloud.compute.v1.RouterAdvertisedIpRange.encode(message.advertisedIpRanges[i], writer.uint32(/* id 35449932, wireType 2 =*/283599458).fork()).ldelim();
                            if (message.keepaliveInterval != null && Object.hasOwnProperty.call(message, "keepaliveInterval"))
                                writer.uint32(/* id 276771516, wireType 0 =*/2214172128).uint32(message.keepaliveInterval);
                            if (message.advertiseMode != null && Object.hasOwnProperty.call(message, "advertiseMode"))
                                writer.uint32(/* id 312134331, wireType 2 =*/2497074650).string(message.advertiseMode);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RouterBgp message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RouterBgp.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RouterBgp
                         * @static
                         * @param {google.cloud.compute.v1.IRouterBgp} message RouterBgp message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterBgp.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RouterBgp message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RouterBgp
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RouterBgp} RouterBgp
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterBgp.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RouterBgp();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 312134331: {
                                        message.advertiseMode = reader.string();
                                        break;
                                    }
                                case 21065526: {
                                        if (!(message.advertisedGroups && message.advertisedGroups.length))
                                            message.advertisedGroups = [];
                                        message.advertisedGroups.push(reader.string());
                                        break;
                                    }
                                case 35449932: {
                                        if (!(message.advertisedIpRanges && message.advertisedIpRanges.length))
                                            message.advertisedIpRanges = [];
                                        message.advertisedIpRanges.push($root.google.cloud.compute.v1.RouterAdvertisedIpRange.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 96892: {
                                        message.asn = reader.uint32();
                                        break;
                                    }
                                case 276771516: {
                                        message.keepaliveInterval = reader.uint32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RouterBgp message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RouterBgp
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RouterBgp} RouterBgp
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterBgp.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RouterBgp message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RouterBgp
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RouterBgp.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.advertiseMode != null && message.hasOwnProperty("advertiseMode")) {
                                properties._advertiseMode = 1;
                                if (!$util.isString(message.advertiseMode))
                                    return "advertiseMode: string expected";
                            }
                            if (message.advertisedGroups != null && message.hasOwnProperty("advertisedGroups")) {
                                if (!Array.isArray(message.advertisedGroups))
                                    return "advertisedGroups: array expected";
                                for (var i = 0; i < message.advertisedGroups.length; ++i)
                                    if (!$util.isString(message.advertisedGroups[i]))
                                        return "advertisedGroups: string[] expected";
                            }
                            if (message.advertisedIpRanges != null && message.hasOwnProperty("advertisedIpRanges")) {
                                if (!Array.isArray(message.advertisedIpRanges))
                                    return "advertisedIpRanges: array expected";
                                for (var i = 0; i < message.advertisedIpRanges.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.RouterAdvertisedIpRange.verify(message.advertisedIpRanges[i]);
                                    if (error)
                                        return "advertisedIpRanges." + error;
                                }
                            }
                            if (message.asn != null && message.hasOwnProperty("asn")) {
                                properties._asn = 1;
                                if (!$util.isInteger(message.asn))
                                    return "asn: integer expected";
                            }
                            if (message.keepaliveInterval != null && message.hasOwnProperty("keepaliveInterval")) {
                                properties._keepaliveInterval = 1;
                                if (!$util.isInteger(message.keepaliveInterval))
                                    return "keepaliveInterval: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RouterBgp message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RouterBgp
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RouterBgp} RouterBgp
                         */
                        RouterBgp.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RouterBgp)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RouterBgp();
                            if (object.advertiseMode != null)
                                message.advertiseMode = String(object.advertiseMode);
                            if (object.advertisedGroups) {
                                if (!Array.isArray(object.advertisedGroups))
                                    throw TypeError(".google.cloud.compute.v1.RouterBgp.advertisedGroups: array expected");
                                message.advertisedGroups = [];
                                for (var i = 0; i < object.advertisedGroups.length; ++i)
                                    message.advertisedGroups[i] = String(object.advertisedGroups[i]);
                            }
                            if (object.advertisedIpRanges) {
                                if (!Array.isArray(object.advertisedIpRanges))
                                    throw TypeError(".google.cloud.compute.v1.RouterBgp.advertisedIpRanges: array expected");
                                message.advertisedIpRanges = [];
                                for (var i = 0; i < object.advertisedIpRanges.length; ++i) {
                                    if (typeof object.advertisedIpRanges[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RouterBgp.advertisedIpRanges: object expected");
                                    message.advertisedIpRanges[i] = $root.google.cloud.compute.v1.RouterAdvertisedIpRange.fromObject(object.advertisedIpRanges[i]);
                                }
                            }
                            if (object.asn != null)
                                message.asn = object.asn >>> 0;
                            if (object.keepaliveInterval != null)
                                message.keepaliveInterval = object.keepaliveInterval >>> 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RouterBgp message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RouterBgp
                         * @static
                         * @param {google.cloud.compute.v1.RouterBgp} message RouterBgp
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RouterBgp.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.advertisedGroups = [];
                                object.advertisedIpRanges = [];
                            }
                            if (message.asn != null && message.hasOwnProperty("asn")) {
                                object.asn = message.asn;
                                if (options.oneofs)
                                    object._asn = "asn";
                            }
                            if (message.advertisedGroups && message.advertisedGroups.length) {
                                object.advertisedGroups = [];
                                for (var j = 0; j < message.advertisedGroups.length; ++j)
                                    object.advertisedGroups[j] = message.advertisedGroups[j];
                            }
                            if (message.advertisedIpRanges && message.advertisedIpRanges.length) {
                                object.advertisedIpRanges = [];
                                for (var j = 0; j < message.advertisedIpRanges.length; ++j)
                                    object.advertisedIpRanges[j] = $root.google.cloud.compute.v1.RouterAdvertisedIpRange.toObject(message.advertisedIpRanges[j], options);
                            }
                            if (message.keepaliveInterval != null && message.hasOwnProperty("keepaliveInterval")) {
                                object.keepaliveInterval = message.keepaliveInterval;
                                if (options.oneofs)
                                    object._keepaliveInterval = "keepaliveInterval";
                            }
                            if (message.advertiseMode != null && message.hasOwnProperty("advertiseMode")) {
                                object.advertiseMode = message.advertiseMode;
                                if (options.oneofs)
                                    object._advertiseMode = "advertiseMode";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RouterBgp to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RouterBgp
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RouterBgp.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RouterBgp
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RouterBgp
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RouterBgp.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RouterBgp";
                        };
    
                        /**
                         * AdvertiseMode enum.
                         * @name google.cloud.compute.v1.RouterBgp.AdvertiseMode
                         * @enum {number}
                         * @property {number} UNDEFINED_ADVERTISE_MODE=0 UNDEFINED_ADVERTISE_MODE value
                         * @property {number} CUSTOM=388595569 CUSTOM value
                         * @property {number} DEFAULT=115302945 DEFAULT value
                         */
                        RouterBgp.AdvertiseMode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ADVERTISE_MODE"] = 0;
                            values[valuesById[388595569] = "CUSTOM"] = 388595569;
                            values[valuesById[115302945] = "DEFAULT"] = 115302945;
                            return values;
                        })();
    
                        /**
                         * AdvertisedGroups enum.
                         * @name google.cloud.compute.v1.RouterBgp.AdvertisedGroups
                         * @enum {number}
                         * @property {number} UNDEFINED_ADVERTISED_GROUPS=0 UNDEFINED_ADVERTISED_GROUPS value
                         * @property {number} ALL_SUBNETS=3622872 ALL_SUBNETS value
                         */
                        RouterBgp.AdvertisedGroups = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ADVERTISED_GROUPS"] = 0;
                            values[valuesById[3622872] = "ALL_SUBNETS"] = 3622872;
                            return values;
                        })();
    
                        return RouterBgp;
                    })();
    
                    v1.RouterBgpPeer = (function() {
    
                        /**
                         * Properties of a RouterBgpPeer.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouterBgpPeer
                         * @property {string|null} [advertiseMode] RouterBgpPeer advertiseMode
                         * @property {Array.<string>|null} [advertisedGroups] RouterBgpPeer advertisedGroups
                         * @property {Array.<google.cloud.compute.v1.IRouterAdvertisedIpRange>|null} [advertisedIpRanges] RouterBgpPeer advertisedIpRanges
                         * @property {number|null} [advertisedRoutePriority] RouterBgpPeer advertisedRoutePriority
                         * @property {google.cloud.compute.v1.IRouterBgpPeerBfd|null} [bfd] RouterBgpPeer bfd
                         * @property {string|null} [enable] RouterBgpPeer enable
                         * @property {boolean|null} [enableIpv6] RouterBgpPeer enableIpv6
                         * @property {string|null} [interfaceName] RouterBgpPeer interfaceName
                         * @property {string|null} [ipAddress] RouterBgpPeer ipAddress
                         * @property {string|null} [ipv6NexthopAddress] RouterBgpPeer ipv6NexthopAddress
                         * @property {string|null} [managementType] RouterBgpPeer managementType
                         * @property {string|null} [md5AuthenticationKeyName] RouterBgpPeer md5AuthenticationKeyName
                         * @property {string|null} [name] RouterBgpPeer name
                         * @property {number|null} [peerAsn] RouterBgpPeer peerAsn
                         * @property {string|null} [peerIpAddress] RouterBgpPeer peerIpAddress
                         * @property {string|null} [peerIpv6NexthopAddress] RouterBgpPeer peerIpv6NexthopAddress
                         * @property {string|null} [routerApplianceInstance] RouterBgpPeer routerApplianceInstance
                         */
    
                        /**
                         * Constructs a new RouterBgpPeer.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RouterBgpPeer.
                         * @implements IRouterBgpPeer
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouterBgpPeer=} [properties] Properties to set
                         */
                        function RouterBgpPeer(properties) {
                            this.advertisedGroups = [];
                            this.advertisedIpRanges = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RouterBgpPeer advertiseMode.
                         * @member {string|null|undefined} advertiseMode
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        RouterBgpPeer.prototype.advertiseMode = null;
    
                        /**
                         * RouterBgpPeer advertisedGroups.
                         * @member {Array.<string>} advertisedGroups
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        RouterBgpPeer.prototype.advertisedGroups = $util.emptyArray;
    
                        /**
                         * RouterBgpPeer advertisedIpRanges.
                         * @member {Array.<google.cloud.compute.v1.IRouterAdvertisedIpRange>} advertisedIpRanges
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        RouterBgpPeer.prototype.advertisedIpRanges = $util.emptyArray;
    
                        /**
                         * RouterBgpPeer advertisedRoutePriority.
                         * @member {number|null|undefined} advertisedRoutePriority
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        RouterBgpPeer.prototype.advertisedRoutePriority = null;
    
                        /**
                         * RouterBgpPeer bfd.
                         * @member {google.cloud.compute.v1.IRouterBgpPeerBfd|null|undefined} bfd
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        RouterBgpPeer.prototype.bfd = null;
    
                        /**
                         * RouterBgpPeer enable.
                         * @member {string|null|undefined} enable
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        RouterBgpPeer.prototype.enable = null;
    
                        /**
                         * RouterBgpPeer enableIpv6.
                         * @member {boolean|null|undefined} enableIpv6
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        RouterBgpPeer.prototype.enableIpv6 = null;
    
                        /**
                         * RouterBgpPeer interfaceName.
                         * @member {string|null|undefined} interfaceName
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        RouterBgpPeer.prototype.interfaceName = null;
    
                        /**
                         * RouterBgpPeer ipAddress.
                         * @member {string|null|undefined} ipAddress
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        RouterBgpPeer.prototype.ipAddress = null;
    
                        /**
                         * RouterBgpPeer ipv6NexthopAddress.
                         * @member {string|null|undefined} ipv6NexthopAddress
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        RouterBgpPeer.prototype.ipv6NexthopAddress = null;
    
                        /**
                         * RouterBgpPeer managementType.
                         * @member {string|null|undefined} managementType
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        RouterBgpPeer.prototype.managementType = null;
    
                        /**
                         * RouterBgpPeer md5AuthenticationKeyName.
                         * @member {string|null|undefined} md5AuthenticationKeyName
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        RouterBgpPeer.prototype.md5AuthenticationKeyName = null;
    
                        /**
                         * RouterBgpPeer name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        RouterBgpPeer.prototype.name = null;
    
                        /**
                         * RouterBgpPeer peerAsn.
                         * @member {number|null|undefined} peerAsn
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        RouterBgpPeer.prototype.peerAsn = null;
    
                        /**
                         * RouterBgpPeer peerIpAddress.
                         * @member {string|null|undefined} peerIpAddress
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        RouterBgpPeer.prototype.peerIpAddress = null;
    
                        /**
                         * RouterBgpPeer peerIpv6NexthopAddress.
                         * @member {string|null|undefined} peerIpv6NexthopAddress
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        RouterBgpPeer.prototype.peerIpv6NexthopAddress = null;
    
                        /**
                         * RouterBgpPeer routerApplianceInstance.
                         * @member {string|null|undefined} routerApplianceInstance
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        RouterBgpPeer.prototype.routerApplianceInstance = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RouterBgpPeer _advertiseMode.
                         * @member {"advertiseMode"|undefined} _advertiseMode
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        Object.defineProperty(RouterBgpPeer.prototype, "_advertiseMode", {
                            get: $util.oneOfGetter($oneOfFields = ["advertiseMode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterBgpPeer _advertisedRoutePriority.
                         * @member {"advertisedRoutePriority"|undefined} _advertisedRoutePriority
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        Object.defineProperty(RouterBgpPeer.prototype, "_advertisedRoutePriority", {
                            get: $util.oneOfGetter($oneOfFields = ["advertisedRoutePriority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterBgpPeer _bfd.
                         * @member {"bfd"|undefined} _bfd
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        Object.defineProperty(RouterBgpPeer.prototype, "_bfd", {
                            get: $util.oneOfGetter($oneOfFields = ["bfd"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterBgpPeer _enable.
                         * @member {"enable"|undefined} _enable
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        Object.defineProperty(RouterBgpPeer.prototype, "_enable", {
                            get: $util.oneOfGetter($oneOfFields = ["enable"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterBgpPeer _enableIpv6.
                         * @member {"enableIpv6"|undefined} _enableIpv6
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        Object.defineProperty(RouterBgpPeer.prototype, "_enableIpv6", {
                            get: $util.oneOfGetter($oneOfFields = ["enableIpv6"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterBgpPeer _interfaceName.
                         * @member {"interfaceName"|undefined} _interfaceName
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        Object.defineProperty(RouterBgpPeer.prototype, "_interfaceName", {
                            get: $util.oneOfGetter($oneOfFields = ["interfaceName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterBgpPeer _ipAddress.
                         * @member {"ipAddress"|undefined} _ipAddress
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        Object.defineProperty(RouterBgpPeer.prototype, "_ipAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["ipAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterBgpPeer _ipv6NexthopAddress.
                         * @member {"ipv6NexthopAddress"|undefined} _ipv6NexthopAddress
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        Object.defineProperty(RouterBgpPeer.prototype, "_ipv6NexthopAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["ipv6NexthopAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterBgpPeer _managementType.
                         * @member {"managementType"|undefined} _managementType
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        Object.defineProperty(RouterBgpPeer.prototype, "_managementType", {
                            get: $util.oneOfGetter($oneOfFields = ["managementType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterBgpPeer _md5AuthenticationKeyName.
                         * @member {"md5AuthenticationKeyName"|undefined} _md5AuthenticationKeyName
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        Object.defineProperty(RouterBgpPeer.prototype, "_md5AuthenticationKeyName", {
                            get: $util.oneOfGetter($oneOfFields = ["md5AuthenticationKeyName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterBgpPeer _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        Object.defineProperty(RouterBgpPeer.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterBgpPeer _peerAsn.
                         * @member {"peerAsn"|undefined} _peerAsn
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        Object.defineProperty(RouterBgpPeer.prototype, "_peerAsn", {
                            get: $util.oneOfGetter($oneOfFields = ["peerAsn"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterBgpPeer _peerIpAddress.
                         * @member {"peerIpAddress"|undefined} _peerIpAddress
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        Object.defineProperty(RouterBgpPeer.prototype, "_peerIpAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["peerIpAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterBgpPeer _peerIpv6NexthopAddress.
                         * @member {"peerIpv6NexthopAddress"|undefined} _peerIpv6NexthopAddress
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        Object.defineProperty(RouterBgpPeer.prototype, "_peerIpv6NexthopAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["peerIpv6NexthopAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterBgpPeer _routerApplianceInstance.
                         * @member {"routerApplianceInstance"|undefined} _routerApplianceInstance
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         */
                        Object.defineProperty(RouterBgpPeer.prototype, "_routerApplianceInstance", {
                            get: $util.oneOfGetter($oneOfFields = ["routerApplianceInstance"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RouterBgpPeer instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @static
                         * @param {google.cloud.compute.v1.IRouterBgpPeer=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RouterBgpPeer} RouterBgpPeer instance
                         */
                        RouterBgpPeer.create = function create(properties) {
                            return new RouterBgpPeer(properties);
                        };
    
                        /**
                         * Encodes the specified RouterBgpPeer message. Does not implicitly {@link google.cloud.compute.v1.RouterBgpPeer.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @static
                         * @param {google.cloud.compute.v1.IRouterBgpPeer} message RouterBgpPeer message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterBgpPeer.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.bfd != null && Object.hasOwnProperty.call(message, "bfd"))
                                $root.google.cloud.compute.v1.RouterBgpPeerBfd.encode(message.bfd, writer.uint32(/* id 97440, wireType 2 =*/779522).fork()).ldelim();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.advertisedGroups != null && message.advertisedGroups.length)
                                for (var i = 0; i < message.advertisedGroups.length; ++i)
                                    writer.uint32(/* id 21065526, wireType 2 =*/168524210).string(message.advertisedGroups[i]);
                            if (message.ipv6NexthopAddress != null && Object.hasOwnProperty.call(message, "ipv6NexthopAddress"))
                                writer.uint32(/* id 27968211, wireType 2 =*/223745690).string(message.ipv6NexthopAddress);
                            if (message.advertisedIpRanges != null && message.advertisedIpRanges.length)
                                for (var i = 0; i < message.advertisedIpRanges.length; ++i)
                                    $root.google.cloud.compute.v1.RouterAdvertisedIpRange.encode(message.advertisedIpRanges[i], writer.uint32(/* id 35449932, wireType 2 =*/283599458).fork()).ldelim();
                            if (message.peerAsn != null && Object.hasOwnProperty.call(message, "peerAsn"))
                                writer.uint32(/* id 69573151, wireType 0 =*/556585208).uint32(message.peerAsn);
                            if (message.managementType != null && Object.hasOwnProperty.call(message, "managementType"))
                                writer.uint32(/* id 173703606, wireType 2 =*/1389628850).string(message.managementType);
                            if (message.enableIpv6 != null && Object.hasOwnProperty.call(message, "enableIpv6"))
                                writer.uint32(/* id 181467939, wireType 0 =*/1451743512).bool(message.enableIpv6);
                            if (message.advertisedRoutePriority != null && Object.hasOwnProperty.call(message, "advertisedRoutePriority"))
                                writer.uint32(/* id 186486332, wireType 0 =*/1491890656).uint32(message.advertisedRoutePriority);
                            if (message.peerIpAddress != null && Object.hasOwnProperty.call(message, "peerIpAddress"))
                                writer.uint32(/* id 207735769, wireType 2 =*/1661886154).string(message.peerIpAddress);
                            if (message.md5AuthenticationKeyName != null && Object.hasOwnProperty.call(message, "md5AuthenticationKeyName"))
                                writer.uint32(/* id 281075345, wireType 2 =*/2248602762).string(message.md5AuthenticationKeyName);
                            if (message.enable != null && Object.hasOwnProperty.call(message, "enable"))
                                writer.uint32(/* id 311764355, wireType 2 =*/2494114842).string(message.enable);
                            if (message.advertiseMode != null && Object.hasOwnProperty.call(message, "advertiseMode"))
                                writer.uint32(/* id 312134331, wireType 2 =*/2497074650).string(message.advertiseMode);
                            if (message.ipAddress != null && Object.hasOwnProperty.call(message, "ipAddress"))
                                writer.uint32(/* id 406272220, wireType 2 =*/3250177762).string(message.ipAddress);
                            if (message.interfaceName != null && Object.hasOwnProperty.call(message, "interfaceName"))
                                writer.uint32(/* id 437854673, wireType 2 =*/3502837386).string(message.interfaceName);
                            if (message.routerApplianceInstance != null && Object.hasOwnProperty.call(message, "routerApplianceInstance"))
                                writer.uint32(/* id 468312989, wireType 2 =*/3746503914).string(message.routerApplianceInstance);
                            if (message.peerIpv6NexthopAddress != null && Object.hasOwnProperty.call(message, "peerIpv6NexthopAddress"))
                                writer.uint32(/* id 491486608, wireType 2 =*/3931892866).string(message.peerIpv6NexthopAddress);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RouterBgpPeer message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RouterBgpPeer.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @static
                         * @param {google.cloud.compute.v1.IRouterBgpPeer} message RouterBgpPeer message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterBgpPeer.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RouterBgpPeer message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RouterBgpPeer} RouterBgpPeer
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterBgpPeer.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RouterBgpPeer();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 312134331: {
                                        message.advertiseMode = reader.string();
                                        break;
                                    }
                                case 21065526: {
                                        if (!(message.advertisedGroups && message.advertisedGroups.length))
                                            message.advertisedGroups = [];
                                        message.advertisedGroups.push(reader.string());
                                        break;
                                    }
                                case 35449932: {
                                        if (!(message.advertisedIpRanges && message.advertisedIpRanges.length))
                                            message.advertisedIpRanges = [];
                                        message.advertisedIpRanges.push($root.google.cloud.compute.v1.RouterAdvertisedIpRange.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 186486332: {
                                        message.advertisedRoutePriority = reader.uint32();
                                        break;
                                    }
                                case 97440: {
                                        message.bfd = $root.google.cloud.compute.v1.RouterBgpPeerBfd.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 311764355: {
                                        message.enable = reader.string();
                                        break;
                                    }
                                case 181467939: {
                                        message.enableIpv6 = reader.bool();
                                        break;
                                    }
                                case 437854673: {
                                        message.interfaceName = reader.string();
                                        break;
                                    }
                                case 406272220: {
                                        message.ipAddress = reader.string();
                                        break;
                                    }
                                case 27968211: {
                                        message.ipv6NexthopAddress = reader.string();
                                        break;
                                    }
                                case 173703606: {
                                        message.managementType = reader.string();
                                        break;
                                    }
                                case 281075345: {
                                        message.md5AuthenticationKeyName = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 69573151: {
                                        message.peerAsn = reader.uint32();
                                        break;
                                    }
                                case 207735769: {
                                        message.peerIpAddress = reader.string();
                                        break;
                                    }
                                case 491486608: {
                                        message.peerIpv6NexthopAddress = reader.string();
                                        break;
                                    }
                                case 468312989: {
                                        message.routerApplianceInstance = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RouterBgpPeer message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RouterBgpPeer} RouterBgpPeer
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterBgpPeer.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RouterBgpPeer message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RouterBgpPeer.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.advertiseMode != null && message.hasOwnProperty("advertiseMode")) {
                                properties._advertiseMode = 1;
                                if (!$util.isString(message.advertiseMode))
                                    return "advertiseMode: string expected";
                            }
                            if (message.advertisedGroups != null && message.hasOwnProperty("advertisedGroups")) {
                                if (!Array.isArray(message.advertisedGroups))
                                    return "advertisedGroups: array expected";
                                for (var i = 0; i < message.advertisedGroups.length; ++i)
                                    if (!$util.isString(message.advertisedGroups[i]))
                                        return "advertisedGroups: string[] expected";
                            }
                            if (message.advertisedIpRanges != null && message.hasOwnProperty("advertisedIpRanges")) {
                                if (!Array.isArray(message.advertisedIpRanges))
                                    return "advertisedIpRanges: array expected";
                                for (var i = 0; i < message.advertisedIpRanges.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.RouterAdvertisedIpRange.verify(message.advertisedIpRanges[i]);
                                    if (error)
                                        return "advertisedIpRanges." + error;
                                }
                            }
                            if (message.advertisedRoutePriority != null && message.hasOwnProperty("advertisedRoutePriority")) {
                                properties._advertisedRoutePriority = 1;
                                if (!$util.isInteger(message.advertisedRoutePriority))
                                    return "advertisedRoutePriority: integer expected";
                            }
                            if (message.bfd != null && message.hasOwnProperty("bfd")) {
                                properties._bfd = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.RouterBgpPeerBfd.verify(message.bfd);
                                    if (error)
                                        return "bfd." + error;
                                }
                            }
                            if (message.enable != null && message.hasOwnProperty("enable")) {
                                properties._enable = 1;
                                if (!$util.isString(message.enable))
                                    return "enable: string expected";
                            }
                            if (message.enableIpv6 != null && message.hasOwnProperty("enableIpv6")) {
                                properties._enableIpv6 = 1;
                                if (typeof message.enableIpv6 !== "boolean")
                                    return "enableIpv6: boolean expected";
                            }
                            if (message.interfaceName != null && message.hasOwnProperty("interfaceName")) {
                                properties._interfaceName = 1;
                                if (!$util.isString(message.interfaceName))
                                    return "interfaceName: string expected";
                            }
                            if (message.ipAddress != null && message.hasOwnProperty("ipAddress")) {
                                properties._ipAddress = 1;
                                if (!$util.isString(message.ipAddress))
                                    return "ipAddress: string expected";
                            }
                            if (message.ipv6NexthopAddress != null && message.hasOwnProperty("ipv6NexthopAddress")) {
                                properties._ipv6NexthopAddress = 1;
                                if (!$util.isString(message.ipv6NexthopAddress))
                                    return "ipv6NexthopAddress: string expected";
                            }
                            if (message.managementType != null && message.hasOwnProperty("managementType")) {
                                properties._managementType = 1;
                                if (!$util.isString(message.managementType))
                                    return "managementType: string expected";
                            }
                            if (message.md5AuthenticationKeyName != null && message.hasOwnProperty("md5AuthenticationKeyName")) {
                                properties._md5AuthenticationKeyName = 1;
                                if (!$util.isString(message.md5AuthenticationKeyName))
                                    return "md5AuthenticationKeyName: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.peerAsn != null && message.hasOwnProperty("peerAsn")) {
                                properties._peerAsn = 1;
                                if (!$util.isInteger(message.peerAsn))
                                    return "peerAsn: integer expected";
                            }
                            if (message.peerIpAddress != null && message.hasOwnProperty("peerIpAddress")) {
                                properties._peerIpAddress = 1;
                                if (!$util.isString(message.peerIpAddress))
                                    return "peerIpAddress: string expected";
                            }
                            if (message.peerIpv6NexthopAddress != null && message.hasOwnProperty("peerIpv6NexthopAddress")) {
                                properties._peerIpv6NexthopAddress = 1;
                                if (!$util.isString(message.peerIpv6NexthopAddress))
                                    return "peerIpv6NexthopAddress: string expected";
                            }
                            if (message.routerApplianceInstance != null && message.hasOwnProperty("routerApplianceInstance")) {
                                properties._routerApplianceInstance = 1;
                                if (!$util.isString(message.routerApplianceInstance))
                                    return "routerApplianceInstance: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RouterBgpPeer message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RouterBgpPeer} RouterBgpPeer
                         */
                        RouterBgpPeer.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RouterBgpPeer)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RouterBgpPeer();
                            if (object.advertiseMode != null)
                                message.advertiseMode = String(object.advertiseMode);
                            if (object.advertisedGroups) {
                                if (!Array.isArray(object.advertisedGroups))
                                    throw TypeError(".google.cloud.compute.v1.RouterBgpPeer.advertisedGroups: array expected");
                                message.advertisedGroups = [];
                                for (var i = 0; i < object.advertisedGroups.length; ++i)
                                    message.advertisedGroups[i] = String(object.advertisedGroups[i]);
                            }
                            if (object.advertisedIpRanges) {
                                if (!Array.isArray(object.advertisedIpRanges))
                                    throw TypeError(".google.cloud.compute.v1.RouterBgpPeer.advertisedIpRanges: array expected");
                                message.advertisedIpRanges = [];
                                for (var i = 0; i < object.advertisedIpRanges.length; ++i) {
                                    if (typeof object.advertisedIpRanges[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RouterBgpPeer.advertisedIpRanges: object expected");
                                    message.advertisedIpRanges[i] = $root.google.cloud.compute.v1.RouterAdvertisedIpRange.fromObject(object.advertisedIpRanges[i]);
                                }
                            }
                            if (object.advertisedRoutePriority != null)
                                message.advertisedRoutePriority = object.advertisedRoutePriority >>> 0;
                            if (object.bfd != null) {
                                if (typeof object.bfd !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RouterBgpPeer.bfd: object expected");
                                message.bfd = $root.google.cloud.compute.v1.RouterBgpPeerBfd.fromObject(object.bfd);
                            }
                            if (object.enable != null)
                                message.enable = String(object.enable);
                            if (object.enableIpv6 != null)
                                message.enableIpv6 = Boolean(object.enableIpv6);
                            if (object.interfaceName != null)
                                message.interfaceName = String(object.interfaceName);
                            if (object.ipAddress != null)
                                message.ipAddress = String(object.ipAddress);
                            if (object.ipv6NexthopAddress != null)
                                message.ipv6NexthopAddress = String(object.ipv6NexthopAddress);
                            if (object.managementType != null)
                                message.managementType = String(object.managementType);
                            if (object.md5AuthenticationKeyName != null)
                                message.md5AuthenticationKeyName = String(object.md5AuthenticationKeyName);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.peerAsn != null)
                                message.peerAsn = object.peerAsn >>> 0;
                            if (object.peerIpAddress != null)
                                message.peerIpAddress = String(object.peerIpAddress);
                            if (object.peerIpv6NexthopAddress != null)
                                message.peerIpv6NexthopAddress = String(object.peerIpv6NexthopAddress);
                            if (object.routerApplianceInstance != null)
                                message.routerApplianceInstance = String(object.routerApplianceInstance);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RouterBgpPeer message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @static
                         * @param {google.cloud.compute.v1.RouterBgpPeer} message RouterBgpPeer
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RouterBgpPeer.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.advertisedGroups = [];
                                object.advertisedIpRanges = [];
                            }
                            if (message.bfd != null && message.hasOwnProperty("bfd")) {
                                object.bfd = $root.google.cloud.compute.v1.RouterBgpPeerBfd.toObject(message.bfd, options);
                                if (options.oneofs)
                                    object._bfd = "bfd";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.advertisedGroups && message.advertisedGroups.length) {
                                object.advertisedGroups = [];
                                for (var j = 0; j < message.advertisedGroups.length; ++j)
                                    object.advertisedGroups[j] = message.advertisedGroups[j];
                            }
                            if (message.ipv6NexthopAddress != null && message.hasOwnProperty("ipv6NexthopAddress")) {
                                object.ipv6NexthopAddress = message.ipv6NexthopAddress;
                                if (options.oneofs)
                                    object._ipv6NexthopAddress = "ipv6NexthopAddress";
                            }
                            if (message.advertisedIpRanges && message.advertisedIpRanges.length) {
                                object.advertisedIpRanges = [];
                                for (var j = 0; j < message.advertisedIpRanges.length; ++j)
                                    object.advertisedIpRanges[j] = $root.google.cloud.compute.v1.RouterAdvertisedIpRange.toObject(message.advertisedIpRanges[j], options);
                            }
                            if (message.peerAsn != null && message.hasOwnProperty("peerAsn")) {
                                object.peerAsn = message.peerAsn;
                                if (options.oneofs)
                                    object._peerAsn = "peerAsn";
                            }
                            if (message.managementType != null && message.hasOwnProperty("managementType")) {
                                object.managementType = message.managementType;
                                if (options.oneofs)
                                    object._managementType = "managementType";
                            }
                            if (message.enableIpv6 != null && message.hasOwnProperty("enableIpv6")) {
                                object.enableIpv6 = message.enableIpv6;
                                if (options.oneofs)
                                    object._enableIpv6 = "enableIpv6";
                            }
                            if (message.advertisedRoutePriority != null && message.hasOwnProperty("advertisedRoutePriority")) {
                                object.advertisedRoutePriority = message.advertisedRoutePriority;
                                if (options.oneofs)
                                    object._advertisedRoutePriority = "advertisedRoutePriority";
                            }
                            if (message.peerIpAddress != null && message.hasOwnProperty("peerIpAddress")) {
                                object.peerIpAddress = message.peerIpAddress;
                                if (options.oneofs)
                                    object._peerIpAddress = "peerIpAddress";
                            }
                            if (message.md5AuthenticationKeyName != null && message.hasOwnProperty("md5AuthenticationKeyName")) {
                                object.md5AuthenticationKeyName = message.md5AuthenticationKeyName;
                                if (options.oneofs)
                                    object._md5AuthenticationKeyName = "md5AuthenticationKeyName";
                            }
                            if (message.enable != null && message.hasOwnProperty("enable")) {
                                object.enable = message.enable;
                                if (options.oneofs)
                                    object._enable = "enable";
                            }
                            if (message.advertiseMode != null && message.hasOwnProperty("advertiseMode")) {
                                object.advertiseMode = message.advertiseMode;
                                if (options.oneofs)
                                    object._advertiseMode = "advertiseMode";
                            }
                            if (message.ipAddress != null && message.hasOwnProperty("ipAddress")) {
                                object.ipAddress = message.ipAddress;
                                if (options.oneofs)
                                    object._ipAddress = "ipAddress";
                            }
                            if (message.interfaceName != null && message.hasOwnProperty("interfaceName")) {
                                object.interfaceName = message.interfaceName;
                                if (options.oneofs)
                                    object._interfaceName = "interfaceName";
                            }
                            if (message.routerApplianceInstance != null && message.hasOwnProperty("routerApplianceInstance")) {
                                object.routerApplianceInstance = message.routerApplianceInstance;
                                if (options.oneofs)
                                    object._routerApplianceInstance = "routerApplianceInstance";
                            }
                            if (message.peerIpv6NexthopAddress != null && message.hasOwnProperty("peerIpv6NexthopAddress")) {
                                object.peerIpv6NexthopAddress = message.peerIpv6NexthopAddress;
                                if (options.oneofs)
                                    object._peerIpv6NexthopAddress = "peerIpv6NexthopAddress";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RouterBgpPeer to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RouterBgpPeer.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RouterBgpPeer
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RouterBgpPeer
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RouterBgpPeer.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RouterBgpPeer";
                        };
    
                        /**
                         * AdvertiseMode enum.
                         * @name google.cloud.compute.v1.RouterBgpPeer.AdvertiseMode
                         * @enum {number}
                         * @property {number} UNDEFINED_ADVERTISE_MODE=0 UNDEFINED_ADVERTISE_MODE value
                         * @property {number} CUSTOM=388595569 CUSTOM value
                         * @property {number} DEFAULT=115302945 DEFAULT value
                         */
                        RouterBgpPeer.AdvertiseMode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ADVERTISE_MODE"] = 0;
                            values[valuesById[388595569] = "CUSTOM"] = 388595569;
                            values[valuesById[115302945] = "DEFAULT"] = 115302945;
                            return values;
                        })();
    
                        /**
                         * AdvertisedGroups enum.
                         * @name google.cloud.compute.v1.RouterBgpPeer.AdvertisedGroups
                         * @enum {number}
                         * @property {number} UNDEFINED_ADVERTISED_GROUPS=0 UNDEFINED_ADVERTISED_GROUPS value
                         * @property {number} ALL_SUBNETS=3622872 ALL_SUBNETS value
                         */
                        RouterBgpPeer.AdvertisedGroups = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ADVERTISED_GROUPS"] = 0;
                            values[valuesById[3622872] = "ALL_SUBNETS"] = 3622872;
                            return values;
                        })();
    
                        /**
                         * Enable enum.
                         * @name google.cloud.compute.v1.RouterBgpPeer.Enable
                         * @enum {number}
                         * @property {number} UNDEFINED_ENABLE=0 UNDEFINED_ENABLE value
                         * @property {number} FALSE=66658563 FALSE value
                         * @property {number} TRUE=2583950 TRUE value
                         */
                        RouterBgpPeer.Enable = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ENABLE"] = 0;
                            values[valuesById[66658563] = "FALSE"] = 66658563;
                            values[valuesById[2583950] = "TRUE"] = 2583950;
                            return values;
                        })();
    
                        /**
                         * ManagementType enum.
                         * @name google.cloud.compute.v1.RouterBgpPeer.ManagementType
                         * @enum {number}
                         * @property {number} UNDEFINED_MANAGEMENT_TYPE=0 UNDEFINED_MANAGEMENT_TYPE value
                         * @property {number} MANAGED_BY_ATTACHMENT=458926411 MANAGED_BY_ATTACHMENT value
                         * @property {number} MANAGED_BY_USER=317294067 MANAGED_BY_USER value
                         */
                        RouterBgpPeer.ManagementType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_MANAGEMENT_TYPE"] = 0;
                            values[valuesById[458926411] = "MANAGED_BY_ATTACHMENT"] = 458926411;
                            values[valuesById[317294067] = "MANAGED_BY_USER"] = 317294067;
                            return values;
                        })();
    
                        return RouterBgpPeer;
                    })();
    
                    v1.RouterBgpPeerBfd = (function() {
    
                        /**
                         * Properties of a RouterBgpPeerBfd.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouterBgpPeerBfd
                         * @property {number|null} [minReceiveInterval] RouterBgpPeerBfd minReceiveInterval
                         * @property {number|null} [minTransmitInterval] RouterBgpPeerBfd minTransmitInterval
                         * @property {number|null} [multiplier] RouterBgpPeerBfd multiplier
                         * @property {string|null} [sessionInitializationMode] RouterBgpPeerBfd sessionInitializationMode
                         */
    
                        /**
                         * Constructs a new RouterBgpPeerBfd.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RouterBgpPeerBfd.
                         * @implements IRouterBgpPeerBfd
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouterBgpPeerBfd=} [properties] Properties to set
                         */
                        function RouterBgpPeerBfd(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RouterBgpPeerBfd minReceiveInterval.
                         * @member {number|null|undefined} minReceiveInterval
                         * @memberof google.cloud.compute.v1.RouterBgpPeerBfd
                         * @instance
                         */
                        RouterBgpPeerBfd.prototype.minReceiveInterval = null;
    
                        /**
                         * RouterBgpPeerBfd minTransmitInterval.
                         * @member {number|null|undefined} minTransmitInterval
                         * @memberof google.cloud.compute.v1.RouterBgpPeerBfd
                         * @instance
                         */
                        RouterBgpPeerBfd.prototype.minTransmitInterval = null;
    
                        /**
                         * RouterBgpPeerBfd multiplier.
                         * @member {number|null|undefined} multiplier
                         * @memberof google.cloud.compute.v1.RouterBgpPeerBfd
                         * @instance
                         */
                        RouterBgpPeerBfd.prototype.multiplier = null;
    
                        /**
                         * RouterBgpPeerBfd sessionInitializationMode.
                         * @member {string|null|undefined} sessionInitializationMode
                         * @memberof google.cloud.compute.v1.RouterBgpPeerBfd
                         * @instance
                         */
                        RouterBgpPeerBfd.prototype.sessionInitializationMode = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RouterBgpPeerBfd _minReceiveInterval.
                         * @member {"minReceiveInterval"|undefined} _minReceiveInterval
                         * @memberof google.cloud.compute.v1.RouterBgpPeerBfd
                         * @instance
                         */
                        Object.defineProperty(RouterBgpPeerBfd.prototype, "_minReceiveInterval", {
                            get: $util.oneOfGetter($oneOfFields = ["minReceiveInterval"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterBgpPeerBfd _minTransmitInterval.
                         * @member {"minTransmitInterval"|undefined} _minTransmitInterval
                         * @memberof google.cloud.compute.v1.RouterBgpPeerBfd
                         * @instance
                         */
                        Object.defineProperty(RouterBgpPeerBfd.prototype, "_minTransmitInterval", {
                            get: $util.oneOfGetter($oneOfFields = ["minTransmitInterval"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterBgpPeerBfd _multiplier.
                         * @member {"multiplier"|undefined} _multiplier
                         * @memberof google.cloud.compute.v1.RouterBgpPeerBfd
                         * @instance
                         */
                        Object.defineProperty(RouterBgpPeerBfd.prototype, "_multiplier", {
                            get: $util.oneOfGetter($oneOfFields = ["multiplier"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterBgpPeerBfd _sessionInitializationMode.
                         * @member {"sessionInitializationMode"|undefined} _sessionInitializationMode
                         * @memberof google.cloud.compute.v1.RouterBgpPeerBfd
                         * @instance
                         */
                        Object.defineProperty(RouterBgpPeerBfd.prototype, "_sessionInitializationMode", {
                            get: $util.oneOfGetter($oneOfFields = ["sessionInitializationMode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RouterBgpPeerBfd instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RouterBgpPeerBfd
                         * @static
                         * @param {google.cloud.compute.v1.IRouterBgpPeerBfd=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RouterBgpPeerBfd} RouterBgpPeerBfd instance
                         */
                        RouterBgpPeerBfd.create = function create(properties) {
                            return new RouterBgpPeerBfd(properties);
                        };
    
                        /**
                         * Encodes the specified RouterBgpPeerBfd message. Does not implicitly {@link google.cloud.compute.v1.RouterBgpPeerBfd.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RouterBgpPeerBfd
                         * @static
                         * @param {google.cloud.compute.v1.IRouterBgpPeerBfd} message RouterBgpPeerBfd message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterBgpPeerBfd.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.sessionInitializationMode != null && Object.hasOwnProperty.call(message, "sessionInitializationMode"))
                                writer.uint32(/* id 105957049, wireType 2 =*/847656394).string(message.sessionInitializationMode);
                            if (message.minReceiveInterval != null && Object.hasOwnProperty.call(message, "minReceiveInterval"))
                                writer.uint32(/* id 186981614, wireType 0 =*/1495852912).uint32(message.minReceiveInterval);
                            if (message.multiplier != null && Object.hasOwnProperty.call(message, "multiplier"))
                                writer.uint32(/* id 191331777, wireType 0 =*/1530654216).uint32(message.multiplier);
                            if (message.minTransmitInterval != null && Object.hasOwnProperty.call(message, "minTransmitInterval"))
                                writer.uint32(/* id 523282631, wireType 0 =*/4186261048).uint32(message.minTransmitInterval);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RouterBgpPeerBfd message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RouterBgpPeerBfd.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RouterBgpPeerBfd
                         * @static
                         * @param {google.cloud.compute.v1.IRouterBgpPeerBfd} message RouterBgpPeerBfd message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterBgpPeerBfd.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RouterBgpPeerBfd message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RouterBgpPeerBfd
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RouterBgpPeerBfd} RouterBgpPeerBfd
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterBgpPeerBfd.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RouterBgpPeerBfd();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 186981614: {
                                        message.minReceiveInterval = reader.uint32();
                                        break;
                                    }
                                case 523282631: {
                                        message.minTransmitInterval = reader.uint32();
                                        break;
                                    }
                                case 191331777: {
                                        message.multiplier = reader.uint32();
                                        break;
                                    }
                                case 105957049: {
                                        message.sessionInitializationMode = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RouterBgpPeerBfd message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RouterBgpPeerBfd
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RouterBgpPeerBfd} RouterBgpPeerBfd
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterBgpPeerBfd.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RouterBgpPeerBfd message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RouterBgpPeerBfd
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RouterBgpPeerBfd.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.minReceiveInterval != null && message.hasOwnProperty("minReceiveInterval")) {
                                properties._minReceiveInterval = 1;
                                if (!$util.isInteger(message.minReceiveInterval))
                                    return "minReceiveInterval: integer expected";
                            }
                            if (message.minTransmitInterval != null && message.hasOwnProperty("minTransmitInterval")) {
                                properties._minTransmitInterval = 1;
                                if (!$util.isInteger(message.minTransmitInterval))
                                    return "minTransmitInterval: integer expected";
                            }
                            if (message.multiplier != null && message.hasOwnProperty("multiplier")) {
                                properties._multiplier = 1;
                                if (!$util.isInteger(message.multiplier))
                                    return "multiplier: integer expected";
                            }
                            if (message.sessionInitializationMode != null && message.hasOwnProperty("sessionInitializationMode")) {
                                properties._sessionInitializationMode = 1;
                                if (!$util.isString(message.sessionInitializationMode))
                                    return "sessionInitializationMode: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RouterBgpPeerBfd message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RouterBgpPeerBfd
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RouterBgpPeerBfd} RouterBgpPeerBfd
                         */
                        RouterBgpPeerBfd.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RouterBgpPeerBfd)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RouterBgpPeerBfd();
                            if (object.minReceiveInterval != null)
                                message.minReceiveInterval = object.minReceiveInterval >>> 0;
                            if (object.minTransmitInterval != null)
                                message.minTransmitInterval = object.minTransmitInterval >>> 0;
                            if (object.multiplier != null)
                                message.multiplier = object.multiplier >>> 0;
                            if (object.sessionInitializationMode != null)
                                message.sessionInitializationMode = String(object.sessionInitializationMode);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RouterBgpPeerBfd message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RouterBgpPeerBfd
                         * @static
                         * @param {google.cloud.compute.v1.RouterBgpPeerBfd} message RouterBgpPeerBfd
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RouterBgpPeerBfd.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.sessionInitializationMode != null && message.hasOwnProperty("sessionInitializationMode")) {
                                object.sessionInitializationMode = message.sessionInitializationMode;
                                if (options.oneofs)
                                    object._sessionInitializationMode = "sessionInitializationMode";
                            }
                            if (message.minReceiveInterval != null && message.hasOwnProperty("minReceiveInterval")) {
                                object.minReceiveInterval = message.minReceiveInterval;
                                if (options.oneofs)
                                    object._minReceiveInterval = "minReceiveInterval";
                            }
                            if (message.multiplier != null && message.hasOwnProperty("multiplier")) {
                                object.multiplier = message.multiplier;
                                if (options.oneofs)
                                    object._multiplier = "multiplier";
                            }
                            if (message.minTransmitInterval != null && message.hasOwnProperty("minTransmitInterval")) {
                                object.minTransmitInterval = message.minTransmitInterval;
                                if (options.oneofs)
                                    object._minTransmitInterval = "minTransmitInterval";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RouterBgpPeerBfd to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RouterBgpPeerBfd
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RouterBgpPeerBfd.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RouterBgpPeerBfd
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RouterBgpPeerBfd
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RouterBgpPeerBfd.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RouterBgpPeerBfd";
                        };
    
                        /**
                         * SessionInitializationMode enum.
                         * @name google.cloud.compute.v1.RouterBgpPeerBfd.SessionInitializationMode
                         * @enum {number}
                         * @property {number} UNDEFINED_SESSION_INITIALIZATION_MODE=0 UNDEFINED_SESSION_INITIALIZATION_MODE value
                         * @property {number} ACTIVE=314733318 ACTIVE value
                         * @property {number} DISABLED=516696700 DISABLED value
                         * @property {number} PASSIVE=462813959 PASSIVE value
                         */
                        RouterBgpPeerBfd.SessionInitializationMode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_SESSION_INITIALIZATION_MODE"] = 0;
                            values[valuesById[314733318] = "ACTIVE"] = 314733318;
                            values[valuesById[516696700] = "DISABLED"] = 516696700;
                            values[valuesById[462813959] = "PASSIVE"] = 462813959;
                            return values;
                        })();
    
                        return RouterBgpPeerBfd;
                    })();
    
                    v1.RouterInterface = (function() {
    
                        /**
                         * Properties of a RouterInterface.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouterInterface
                         * @property {string|null} [ipRange] RouterInterface ipRange
                         * @property {string|null} [linkedInterconnectAttachment] RouterInterface linkedInterconnectAttachment
                         * @property {string|null} [linkedVpnTunnel] RouterInterface linkedVpnTunnel
                         * @property {string|null} [managementType] RouterInterface managementType
                         * @property {string|null} [name] RouterInterface name
                         * @property {string|null} [privateIpAddress] RouterInterface privateIpAddress
                         * @property {string|null} [redundantInterface] RouterInterface redundantInterface
                         * @property {string|null} [subnetwork] RouterInterface subnetwork
                         */
    
                        /**
                         * Constructs a new RouterInterface.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RouterInterface.
                         * @implements IRouterInterface
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouterInterface=} [properties] Properties to set
                         */
                        function RouterInterface(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RouterInterface ipRange.
                         * @member {string|null|undefined} ipRange
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @instance
                         */
                        RouterInterface.prototype.ipRange = null;
    
                        /**
                         * RouterInterface linkedInterconnectAttachment.
                         * @member {string|null|undefined} linkedInterconnectAttachment
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @instance
                         */
                        RouterInterface.prototype.linkedInterconnectAttachment = null;
    
                        /**
                         * RouterInterface linkedVpnTunnel.
                         * @member {string|null|undefined} linkedVpnTunnel
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @instance
                         */
                        RouterInterface.prototype.linkedVpnTunnel = null;
    
                        /**
                         * RouterInterface managementType.
                         * @member {string|null|undefined} managementType
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @instance
                         */
                        RouterInterface.prototype.managementType = null;
    
                        /**
                         * RouterInterface name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @instance
                         */
                        RouterInterface.prototype.name = null;
    
                        /**
                         * RouterInterface privateIpAddress.
                         * @member {string|null|undefined} privateIpAddress
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @instance
                         */
                        RouterInterface.prototype.privateIpAddress = null;
    
                        /**
                         * RouterInterface redundantInterface.
                         * @member {string|null|undefined} redundantInterface
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @instance
                         */
                        RouterInterface.prototype.redundantInterface = null;
    
                        /**
                         * RouterInterface subnetwork.
                         * @member {string|null|undefined} subnetwork
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @instance
                         */
                        RouterInterface.prototype.subnetwork = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RouterInterface _ipRange.
                         * @member {"ipRange"|undefined} _ipRange
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @instance
                         */
                        Object.defineProperty(RouterInterface.prototype, "_ipRange", {
                            get: $util.oneOfGetter($oneOfFields = ["ipRange"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterInterface _linkedInterconnectAttachment.
                         * @member {"linkedInterconnectAttachment"|undefined} _linkedInterconnectAttachment
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @instance
                         */
                        Object.defineProperty(RouterInterface.prototype, "_linkedInterconnectAttachment", {
                            get: $util.oneOfGetter($oneOfFields = ["linkedInterconnectAttachment"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterInterface _linkedVpnTunnel.
                         * @member {"linkedVpnTunnel"|undefined} _linkedVpnTunnel
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @instance
                         */
                        Object.defineProperty(RouterInterface.prototype, "_linkedVpnTunnel", {
                            get: $util.oneOfGetter($oneOfFields = ["linkedVpnTunnel"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterInterface _managementType.
                         * @member {"managementType"|undefined} _managementType
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @instance
                         */
                        Object.defineProperty(RouterInterface.prototype, "_managementType", {
                            get: $util.oneOfGetter($oneOfFields = ["managementType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterInterface _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @instance
                         */
                        Object.defineProperty(RouterInterface.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterInterface _privateIpAddress.
                         * @member {"privateIpAddress"|undefined} _privateIpAddress
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @instance
                         */
                        Object.defineProperty(RouterInterface.prototype, "_privateIpAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["privateIpAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterInterface _redundantInterface.
                         * @member {"redundantInterface"|undefined} _redundantInterface
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @instance
                         */
                        Object.defineProperty(RouterInterface.prototype, "_redundantInterface", {
                            get: $util.oneOfGetter($oneOfFields = ["redundantInterface"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterInterface _subnetwork.
                         * @member {"subnetwork"|undefined} _subnetwork
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @instance
                         */
                        Object.defineProperty(RouterInterface.prototype, "_subnetwork", {
                            get: $util.oneOfGetter($oneOfFields = ["subnetwork"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RouterInterface instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @static
                         * @param {google.cloud.compute.v1.IRouterInterface=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RouterInterface} RouterInterface instance
                         */
                        RouterInterface.create = function create(properties) {
                            return new RouterInterface(properties);
                        };
    
                        /**
                         * Encodes the specified RouterInterface message. Does not implicitly {@link google.cloud.compute.v1.RouterInterface.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @static
                         * @param {google.cloud.compute.v1.IRouterInterface} message RouterInterface message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterInterface.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.privateIpAddress != null && Object.hasOwnProperty.call(message, "privateIpAddress"))
                                writer.uint32(/* id 100854040, wireType 2 =*/806832322).string(message.privateIpAddress);
                            if (message.ipRange != null && Object.hasOwnProperty.call(message, "ipRange"))
                                writer.uint32(/* id 145092645, wireType 2 =*/1160741162).string(message.ipRange);
                            if (message.managementType != null && Object.hasOwnProperty.call(message, "managementType"))
                                writer.uint32(/* id 173703606, wireType 2 =*/1389628850).string(message.managementType);
                            if (message.subnetwork != null && Object.hasOwnProperty.call(message, "subnetwork"))
                                writer.uint32(/* id 307827694, wireType 2 =*/2462621554).string(message.subnetwork);
                            if (message.linkedVpnTunnel != null && Object.hasOwnProperty.call(message, "linkedVpnTunnel"))
                                writer.uint32(/* id 352296953, wireType 2 =*/2818375626).string(message.linkedVpnTunnel);
                            if (message.linkedInterconnectAttachment != null && Object.hasOwnProperty.call(message, "linkedInterconnectAttachment"))
                                writer.uint32(/* id 501085518, wireType 2 =*/4008684146).string(message.linkedInterconnectAttachment);
                            if (message.redundantInterface != null && Object.hasOwnProperty.call(message, "redundantInterface"))
                                writer.uint32(/* id 523187303, wireType 2 =*/4185498426).string(message.redundantInterface);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RouterInterface message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RouterInterface.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @static
                         * @param {google.cloud.compute.v1.IRouterInterface} message RouterInterface message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterInterface.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RouterInterface message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RouterInterface} RouterInterface
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterInterface.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RouterInterface();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 145092645: {
                                        message.ipRange = reader.string();
                                        break;
                                    }
                                case 501085518: {
                                        message.linkedInterconnectAttachment = reader.string();
                                        break;
                                    }
                                case 352296953: {
                                        message.linkedVpnTunnel = reader.string();
                                        break;
                                    }
                                case 173703606: {
                                        message.managementType = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 100854040: {
                                        message.privateIpAddress = reader.string();
                                        break;
                                    }
                                case 523187303: {
                                        message.redundantInterface = reader.string();
                                        break;
                                    }
                                case 307827694: {
                                        message.subnetwork = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RouterInterface message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RouterInterface} RouterInterface
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterInterface.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RouterInterface message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RouterInterface.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.ipRange != null && message.hasOwnProperty("ipRange")) {
                                properties._ipRange = 1;
                                if (!$util.isString(message.ipRange))
                                    return "ipRange: string expected";
                            }
                            if (message.linkedInterconnectAttachment != null && message.hasOwnProperty("linkedInterconnectAttachment")) {
                                properties._linkedInterconnectAttachment = 1;
                                if (!$util.isString(message.linkedInterconnectAttachment))
                                    return "linkedInterconnectAttachment: string expected";
                            }
                            if (message.linkedVpnTunnel != null && message.hasOwnProperty("linkedVpnTunnel")) {
                                properties._linkedVpnTunnel = 1;
                                if (!$util.isString(message.linkedVpnTunnel))
                                    return "linkedVpnTunnel: string expected";
                            }
                            if (message.managementType != null && message.hasOwnProperty("managementType")) {
                                properties._managementType = 1;
                                if (!$util.isString(message.managementType))
                                    return "managementType: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.privateIpAddress != null && message.hasOwnProperty("privateIpAddress")) {
                                properties._privateIpAddress = 1;
                                if (!$util.isString(message.privateIpAddress))
                                    return "privateIpAddress: string expected";
                            }
                            if (message.redundantInterface != null && message.hasOwnProperty("redundantInterface")) {
                                properties._redundantInterface = 1;
                                if (!$util.isString(message.redundantInterface))
                                    return "redundantInterface: string expected";
                            }
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork")) {
                                properties._subnetwork = 1;
                                if (!$util.isString(message.subnetwork))
                                    return "subnetwork: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RouterInterface message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RouterInterface} RouterInterface
                         */
                        RouterInterface.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RouterInterface)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RouterInterface();
                            if (object.ipRange != null)
                                message.ipRange = String(object.ipRange);
                            if (object.linkedInterconnectAttachment != null)
                                message.linkedInterconnectAttachment = String(object.linkedInterconnectAttachment);
                            if (object.linkedVpnTunnel != null)
                                message.linkedVpnTunnel = String(object.linkedVpnTunnel);
                            if (object.managementType != null)
                                message.managementType = String(object.managementType);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.privateIpAddress != null)
                                message.privateIpAddress = String(object.privateIpAddress);
                            if (object.redundantInterface != null)
                                message.redundantInterface = String(object.redundantInterface);
                            if (object.subnetwork != null)
                                message.subnetwork = String(object.subnetwork);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RouterInterface message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @static
                         * @param {google.cloud.compute.v1.RouterInterface} message RouterInterface
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RouterInterface.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.privateIpAddress != null && message.hasOwnProperty("privateIpAddress")) {
                                object.privateIpAddress = message.privateIpAddress;
                                if (options.oneofs)
                                    object._privateIpAddress = "privateIpAddress";
                            }
                            if (message.ipRange != null && message.hasOwnProperty("ipRange")) {
                                object.ipRange = message.ipRange;
                                if (options.oneofs)
                                    object._ipRange = "ipRange";
                            }
                            if (message.managementType != null && message.hasOwnProperty("managementType")) {
                                object.managementType = message.managementType;
                                if (options.oneofs)
                                    object._managementType = "managementType";
                            }
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork")) {
                                object.subnetwork = message.subnetwork;
                                if (options.oneofs)
                                    object._subnetwork = "subnetwork";
                            }
                            if (message.linkedVpnTunnel != null && message.hasOwnProperty("linkedVpnTunnel")) {
                                object.linkedVpnTunnel = message.linkedVpnTunnel;
                                if (options.oneofs)
                                    object._linkedVpnTunnel = "linkedVpnTunnel";
                            }
                            if (message.linkedInterconnectAttachment != null && message.hasOwnProperty("linkedInterconnectAttachment")) {
                                object.linkedInterconnectAttachment = message.linkedInterconnectAttachment;
                                if (options.oneofs)
                                    object._linkedInterconnectAttachment = "linkedInterconnectAttachment";
                            }
                            if (message.redundantInterface != null && message.hasOwnProperty("redundantInterface")) {
                                object.redundantInterface = message.redundantInterface;
                                if (options.oneofs)
                                    object._redundantInterface = "redundantInterface";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RouterInterface to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RouterInterface.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RouterInterface
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RouterInterface
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RouterInterface.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RouterInterface";
                        };
    
                        /**
                         * ManagementType enum.
                         * @name google.cloud.compute.v1.RouterInterface.ManagementType
                         * @enum {number}
                         * @property {number} UNDEFINED_MANAGEMENT_TYPE=0 UNDEFINED_MANAGEMENT_TYPE value
                         * @property {number} MANAGED_BY_ATTACHMENT=458926411 MANAGED_BY_ATTACHMENT value
                         * @property {number} MANAGED_BY_USER=317294067 MANAGED_BY_USER value
                         */
                        RouterInterface.ManagementType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_MANAGEMENT_TYPE"] = 0;
                            values[valuesById[458926411] = "MANAGED_BY_ATTACHMENT"] = 458926411;
                            values[valuesById[317294067] = "MANAGED_BY_USER"] = 317294067;
                            return values;
                        })();
    
                        return RouterInterface;
                    })();
    
                    v1.RouterList = (function() {
    
                        /**
                         * Properties of a RouterList.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouterList
                         * @property {string|null} [id] RouterList id
                         * @property {Array.<google.cloud.compute.v1.IRouter>|null} [items] RouterList items
                         * @property {string|null} [kind] RouterList kind
                         * @property {string|null} [nextPageToken] RouterList nextPageToken
                         * @property {string|null} [selfLink] RouterList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] RouterList warning
                         */
    
                        /**
                         * Constructs a new RouterList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RouterList.
                         * @implements IRouterList
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouterList=} [properties] Properties to set
                         */
                        function RouterList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RouterList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.RouterList
                         * @instance
                         */
                        RouterList.prototype.id = null;
    
                        /**
                         * RouterList items.
                         * @member {Array.<google.cloud.compute.v1.IRouter>} items
                         * @memberof google.cloud.compute.v1.RouterList
                         * @instance
                         */
                        RouterList.prototype.items = $util.emptyArray;
    
                        /**
                         * RouterList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.RouterList
                         * @instance
                         */
                        RouterList.prototype.kind = null;
    
                        /**
                         * RouterList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.RouterList
                         * @instance
                         */
                        RouterList.prototype.nextPageToken = null;
    
                        /**
                         * RouterList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.RouterList
                         * @instance
                         */
                        RouterList.prototype.selfLink = null;
    
                        /**
                         * RouterList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.RouterList
                         * @instance
                         */
                        RouterList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RouterList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.RouterList
                         * @instance
                         */
                        Object.defineProperty(RouterList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.RouterList
                         * @instance
                         */
                        Object.defineProperty(RouterList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.RouterList
                         * @instance
                         */
                        Object.defineProperty(RouterList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.RouterList
                         * @instance
                         */
                        Object.defineProperty(RouterList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.RouterList
                         * @instance
                         */
                        Object.defineProperty(RouterList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RouterList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RouterList
                         * @static
                         * @param {google.cloud.compute.v1.IRouterList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RouterList} RouterList instance
                         */
                        RouterList.create = function create(properties) {
                            return new RouterList(properties);
                        };
    
                        /**
                         * Encodes the specified RouterList message. Does not implicitly {@link google.cloud.compute.v1.RouterList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RouterList
                         * @static
                         * @param {google.cloud.compute.v1.IRouterList} message RouterList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Router.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RouterList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RouterList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RouterList
                         * @static
                         * @param {google.cloud.compute.v1.IRouterList} message RouterList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RouterList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RouterList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RouterList} RouterList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RouterList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Router.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RouterList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RouterList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RouterList} RouterList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RouterList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RouterList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RouterList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Router.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RouterList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RouterList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RouterList} RouterList
                         */
                        RouterList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RouterList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RouterList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.RouterList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RouterList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Router.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RouterList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RouterList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RouterList
                         * @static
                         * @param {google.cloud.compute.v1.RouterList} message RouterList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RouterList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Router.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RouterList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RouterList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RouterList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RouterList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RouterList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RouterList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RouterList";
                        };
    
                        return RouterList;
                    })();
    
                    v1.RouterMd5AuthenticationKey = (function() {
    
                        /**
                         * Properties of a RouterMd5AuthenticationKey.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouterMd5AuthenticationKey
                         * @property {string|null} [key] RouterMd5AuthenticationKey key
                         * @property {string|null} [name] RouterMd5AuthenticationKey name
                         */
    
                        /**
                         * Constructs a new RouterMd5AuthenticationKey.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RouterMd5AuthenticationKey.
                         * @implements IRouterMd5AuthenticationKey
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouterMd5AuthenticationKey=} [properties] Properties to set
                         */
                        function RouterMd5AuthenticationKey(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RouterMd5AuthenticationKey key.
                         * @member {string|null|undefined} key
                         * @memberof google.cloud.compute.v1.RouterMd5AuthenticationKey
                         * @instance
                         */
                        RouterMd5AuthenticationKey.prototype.key = null;
    
                        /**
                         * RouterMd5AuthenticationKey name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.RouterMd5AuthenticationKey
                         * @instance
                         */
                        RouterMd5AuthenticationKey.prototype.name = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RouterMd5AuthenticationKey _key.
                         * @member {"key"|undefined} _key
                         * @memberof google.cloud.compute.v1.RouterMd5AuthenticationKey
                         * @instance
                         */
                        Object.defineProperty(RouterMd5AuthenticationKey.prototype, "_key", {
                            get: $util.oneOfGetter($oneOfFields = ["key"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterMd5AuthenticationKey _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.RouterMd5AuthenticationKey
                         * @instance
                         */
                        Object.defineProperty(RouterMd5AuthenticationKey.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RouterMd5AuthenticationKey instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RouterMd5AuthenticationKey
                         * @static
                         * @param {google.cloud.compute.v1.IRouterMd5AuthenticationKey=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RouterMd5AuthenticationKey} RouterMd5AuthenticationKey instance
                         */
                        RouterMd5AuthenticationKey.create = function create(properties) {
                            return new RouterMd5AuthenticationKey(properties);
                        };
    
                        /**
                         * Encodes the specified RouterMd5AuthenticationKey message. Does not implicitly {@link google.cloud.compute.v1.RouterMd5AuthenticationKey.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RouterMd5AuthenticationKey
                         * @static
                         * @param {google.cloud.compute.v1.IRouterMd5AuthenticationKey} message RouterMd5AuthenticationKey message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterMd5AuthenticationKey.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.key != null && Object.hasOwnProperty.call(message, "key"))
                                writer.uint32(/* id 106079, wireType 2 =*/848634).string(message.key);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RouterMd5AuthenticationKey message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RouterMd5AuthenticationKey.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RouterMd5AuthenticationKey
                         * @static
                         * @param {google.cloud.compute.v1.IRouterMd5AuthenticationKey} message RouterMd5AuthenticationKey message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterMd5AuthenticationKey.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RouterMd5AuthenticationKey message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RouterMd5AuthenticationKey
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RouterMd5AuthenticationKey} RouterMd5AuthenticationKey
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterMd5AuthenticationKey.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RouterMd5AuthenticationKey();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 106079: {
                                        message.key = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RouterMd5AuthenticationKey message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RouterMd5AuthenticationKey
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RouterMd5AuthenticationKey} RouterMd5AuthenticationKey
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterMd5AuthenticationKey.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RouterMd5AuthenticationKey message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RouterMd5AuthenticationKey
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RouterMd5AuthenticationKey.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.key != null && message.hasOwnProperty("key")) {
                                properties._key = 1;
                                if (!$util.isString(message.key))
                                    return "key: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RouterMd5AuthenticationKey message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RouterMd5AuthenticationKey
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RouterMd5AuthenticationKey} RouterMd5AuthenticationKey
                         */
                        RouterMd5AuthenticationKey.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RouterMd5AuthenticationKey)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RouterMd5AuthenticationKey();
                            if (object.key != null)
                                message.key = String(object.key);
                            if (object.name != null)
                                message.name = String(object.name);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RouterMd5AuthenticationKey message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RouterMd5AuthenticationKey
                         * @static
                         * @param {google.cloud.compute.v1.RouterMd5AuthenticationKey} message RouterMd5AuthenticationKey
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RouterMd5AuthenticationKey.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.key != null && message.hasOwnProperty("key")) {
                                object.key = message.key;
                                if (options.oneofs)
                                    object._key = "key";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RouterMd5AuthenticationKey to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RouterMd5AuthenticationKey
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RouterMd5AuthenticationKey.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RouterMd5AuthenticationKey
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RouterMd5AuthenticationKey
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RouterMd5AuthenticationKey.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RouterMd5AuthenticationKey";
                        };
    
                        return RouterMd5AuthenticationKey;
                    })();
    
                    v1.RouterNat = (function() {
    
                        /**
                         * Properties of a RouterNat.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouterNat
                         * @property {Array.<string>|null} [drainNatIps] RouterNat drainNatIps
                         * @property {boolean|null} [enableDynamicPortAllocation] RouterNat enableDynamicPortAllocation
                         * @property {boolean|null} [enableEndpointIndependentMapping] RouterNat enableEndpointIndependentMapping
                         * @property {Array.<string>|null} [endpointTypes] RouterNat endpointTypes
                         * @property {number|null} [icmpIdleTimeoutSec] RouterNat icmpIdleTimeoutSec
                         * @property {google.cloud.compute.v1.IRouterNatLogConfig|null} [logConfig] RouterNat logConfig
                         * @property {number|null} [maxPortsPerVm] RouterNat maxPortsPerVm
                         * @property {number|null} [minPortsPerVm] RouterNat minPortsPerVm
                         * @property {string|null} [name] RouterNat name
                         * @property {string|null} [natIpAllocateOption] RouterNat natIpAllocateOption
                         * @property {Array.<string>|null} [natIps] RouterNat natIps
                         * @property {Array.<google.cloud.compute.v1.IRouterNatRule>|null} [rules] RouterNat rules
                         * @property {string|null} [sourceSubnetworkIpRangesToNat] RouterNat sourceSubnetworkIpRangesToNat
                         * @property {Array.<google.cloud.compute.v1.IRouterNatSubnetworkToNat>|null} [subnetworks] RouterNat subnetworks
                         * @property {number|null} [tcpEstablishedIdleTimeoutSec] RouterNat tcpEstablishedIdleTimeoutSec
                         * @property {number|null} [tcpTimeWaitTimeoutSec] RouterNat tcpTimeWaitTimeoutSec
                         * @property {number|null} [tcpTransitoryIdleTimeoutSec] RouterNat tcpTransitoryIdleTimeoutSec
                         * @property {number|null} [udpIdleTimeoutSec] RouterNat udpIdleTimeoutSec
                         */
    
                        /**
                         * Constructs a new RouterNat.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RouterNat.
                         * @implements IRouterNat
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouterNat=} [properties] Properties to set
                         */
                        function RouterNat(properties) {
                            this.drainNatIps = [];
                            this.endpointTypes = [];
                            this.natIps = [];
                            this.rules = [];
                            this.subnetworks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RouterNat drainNatIps.
                         * @member {Array.<string>} drainNatIps
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        RouterNat.prototype.drainNatIps = $util.emptyArray;
    
                        /**
                         * RouterNat enableDynamicPortAllocation.
                         * @member {boolean|null|undefined} enableDynamicPortAllocation
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        RouterNat.prototype.enableDynamicPortAllocation = null;
    
                        /**
                         * RouterNat enableEndpointIndependentMapping.
                         * @member {boolean|null|undefined} enableEndpointIndependentMapping
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        RouterNat.prototype.enableEndpointIndependentMapping = null;
    
                        /**
                         * RouterNat endpointTypes.
                         * @member {Array.<string>} endpointTypes
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        RouterNat.prototype.endpointTypes = $util.emptyArray;
    
                        /**
                         * RouterNat icmpIdleTimeoutSec.
                         * @member {number|null|undefined} icmpIdleTimeoutSec
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        RouterNat.prototype.icmpIdleTimeoutSec = null;
    
                        /**
                         * RouterNat logConfig.
                         * @member {google.cloud.compute.v1.IRouterNatLogConfig|null|undefined} logConfig
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        RouterNat.prototype.logConfig = null;
    
                        /**
                         * RouterNat maxPortsPerVm.
                         * @member {number|null|undefined} maxPortsPerVm
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        RouterNat.prototype.maxPortsPerVm = null;
    
                        /**
                         * RouterNat minPortsPerVm.
                         * @member {number|null|undefined} minPortsPerVm
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        RouterNat.prototype.minPortsPerVm = null;
    
                        /**
                         * RouterNat name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        RouterNat.prototype.name = null;
    
                        /**
                         * RouterNat natIpAllocateOption.
                         * @member {string|null|undefined} natIpAllocateOption
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        RouterNat.prototype.natIpAllocateOption = null;
    
                        /**
                         * RouterNat natIps.
                         * @member {Array.<string>} natIps
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        RouterNat.prototype.natIps = $util.emptyArray;
    
                        /**
                         * RouterNat rules.
                         * @member {Array.<google.cloud.compute.v1.IRouterNatRule>} rules
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        RouterNat.prototype.rules = $util.emptyArray;
    
                        /**
                         * RouterNat sourceSubnetworkIpRangesToNat.
                         * @member {string|null|undefined} sourceSubnetworkIpRangesToNat
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        RouterNat.prototype.sourceSubnetworkIpRangesToNat = null;
    
                        /**
                         * RouterNat subnetworks.
                         * @member {Array.<google.cloud.compute.v1.IRouterNatSubnetworkToNat>} subnetworks
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        RouterNat.prototype.subnetworks = $util.emptyArray;
    
                        /**
                         * RouterNat tcpEstablishedIdleTimeoutSec.
                         * @member {number|null|undefined} tcpEstablishedIdleTimeoutSec
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        RouterNat.prototype.tcpEstablishedIdleTimeoutSec = null;
    
                        /**
                         * RouterNat tcpTimeWaitTimeoutSec.
                         * @member {number|null|undefined} tcpTimeWaitTimeoutSec
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        RouterNat.prototype.tcpTimeWaitTimeoutSec = null;
    
                        /**
                         * RouterNat tcpTransitoryIdleTimeoutSec.
                         * @member {number|null|undefined} tcpTransitoryIdleTimeoutSec
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        RouterNat.prototype.tcpTransitoryIdleTimeoutSec = null;
    
                        /**
                         * RouterNat udpIdleTimeoutSec.
                         * @member {number|null|undefined} udpIdleTimeoutSec
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        RouterNat.prototype.udpIdleTimeoutSec = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RouterNat _enableDynamicPortAllocation.
                         * @member {"enableDynamicPortAllocation"|undefined} _enableDynamicPortAllocation
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        Object.defineProperty(RouterNat.prototype, "_enableDynamicPortAllocation", {
                            get: $util.oneOfGetter($oneOfFields = ["enableDynamicPortAllocation"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterNat _enableEndpointIndependentMapping.
                         * @member {"enableEndpointIndependentMapping"|undefined} _enableEndpointIndependentMapping
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        Object.defineProperty(RouterNat.prototype, "_enableEndpointIndependentMapping", {
                            get: $util.oneOfGetter($oneOfFields = ["enableEndpointIndependentMapping"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterNat _icmpIdleTimeoutSec.
                         * @member {"icmpIdleTimeoutSec"|undefined} _icmpIdleTimeoutSec
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        Object.defineProperty(RouterNat.prototype, "_icmpIdleTimeoutSec", {
                            get: $util.oneOfGetter($oneOfFields = ["icmpIdleTimeoutSec"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterNat _logConfig.
                         * @member {"logConfig"|undefined} _logConfig
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        Object.defineProperty(RouterNat.prototype, "_logConfig", {
                            get: $util.oneOfGetter($oneOfFields = ["logConfig"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterNat _maxPortsPerVm.
                         * @member {"maxPortsPerVm"|undefined} _maxPortsPerVm
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        Object.defineProperty(RouterNat.prototype, "_maxPortsPerVm", {
                            get: $util.oneOfGetter($oneOfFields = ["maxPortsPerVm"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterNat _minPortsPerVm.
                         * @member {"minPortsPerVm"|undefined} _minPortsPerVm
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        Object.defineProperty(RouterNat.prototype, "_minPortsPerVm", {
                            get: $util.oneOfGetter($oneOfFields = ["minPortsPerVm"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterNat _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        Object.defineProperty(RouterNat.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterNat _natIpAllocateOption.
                         * @member {"natIpAllocateOption"|undefined} _natIpAllocateOption
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        Object.defineProperty(RouterNat.prototype, "_natIpAllocateOption", {
                            get: $util.oneOfGetter($oneOfFields = ["natIpAllocateOption"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterNat _sourceSubnetworkIpRangesToNat.
                         * @member {"sourceSubnetworkIpRangesToNat"|undefined} _sourceSubnetworkIpRangesToNat
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        Object.defineProperty(RouterNat.prototype, "_sourceSubnetworkIpRangesToNat", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceSubnetworkIpRangesToNat"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterNat _tcpEstablishedIdleTimeoutSec.
                         * @member {"tcpEstablishedIdleTimeoutSec"|undefined} _tcpEstablishedIdleTimeoutSec
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        Object.defineProperty(RouterNat.prototype, "_tcpEstablishedIdleTimeoutSec", {
                            get: $util.oneOfGetter($oneOfFields = ["tcpEstablishedIdleTimeoutSec"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterNat _tcpTimeWaitTimeoutSec.
                         * @member {"tcpTimeWaitTimeoutSec"|undefined} _tcpTimeWaitTimeoutSec
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        Object.defineProperty(RouterNat.prototype, "_tcpTimeWaitTimeoutSec", {
                            get: $util.oneOfGetter($oneOfFields = ["tcpTimeWaitTimeoutSec"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterNat _tcpTransitoryIdleTimeoutSec.
                         * @member {"tcpTransitoryIdleTimeoutSec"|undefined} _tcpTransitoryIdleTimeoutSec
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        Object.defineProperty(RouterNat.prototype, "_tcpTransitoryIdleTimeoutSec", {
                            get: $util.oneOfGetter($oneOfFields = ["tcpTransitoryIdleTimeoutSec"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterNat _udpIdleTimeoutSec.
                         * @member {"udpIdleTimeoutSec"|undefined} _udpIdleTimeoutSec
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         */
                        Object.defineProperty(RouterNat.prototype, "_udpIdleTimeoutSec", {
                            get: $util.oneOfGetter($oneOfFields = ["udpIdleTimeoutSec"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RouterNat instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @static
                         * @param {google.cloud.compute.v1.IRouterNat=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RouterNat} RouterNat instance
                         */
                        RouterNat.create = function create(properties) {
                            return new RouterNat(properties);
                        };
    
                        /**
                         * Encodes the specified RouterNat message. Does not implicitly {@link google.cloud.compute.v1.RouterNat.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @static
                         * @param {google.cloud.compute.v1.IRouterNat} message RouterNat message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterNat.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.icmpIdleTimeoutSec != null && Object.hasOwnProperty.call(message, "icmpIdleTimeoutSec"))
                                writer.uint32(/* id 3647562, wireType 0 =*/29180496).int32(message.icmpIdleTimeoutSec);
                            if (message.udpIdleTimeoutSec != null && Object.hasOwnProperty.call(message, "udpIdleTimeoutSec"))
                                writer.uint32(/* id 64919878, wireType 0 =*/519359024).int32(message.udpIdleTimeoutSec);
                            if (message.rules != null && message.rules.length)
                                for (var i = 0; i < message.rules.length; ++i)
                                    $root.google.cloud.compute.v1.RouterNatRule.encode(message.rules[i], writer.uint32(/* id 108873975, wireType 2 =*/870991802).fork()).ldelim();
                            if (message.natIps != null && message.natIps.length)
                                for (var i = 0; i < message.natIps.length; ++i)
                                    writer.uint32(/* id 117635086, wireType 2 =*/941080690).string(message.natIps[i]);
                            if (message.minPortsPerVm != null && Object.hasOwnProperty.call(message, "minPortsPerVm"))
                                writer.uint32(/* id 186193587, wireType 0 =*/1489548696).int32(message.minPortsPerVm);
                            if (message.tcpTransitoryIdleTimeoutSec != null && Object.hasOwnProperty.call(message, "tcpTransitoryIdleTimeoutSec"))
                                writer.uint32(/* id 205028774, wireType 0 =*/1640230192).int32(message.tcpTransitoryIdleTimeoutSec);
                            if (message.tcpEstablishedIdleTimeoutSec != null && Object.hasOwnProperty.call(message, "tcpEstablishedIdleTimeoutSec"))
                                writer.uint32(/* id 223098349, wireType 0 =*/1784786792).int32(message.tcpEstablishedIdleTimeoutSec);
                            if (message.maxPortsPerVm != null && Object.hasOwnProperty.call(message, "maxPortsPerVm"))
                                writer.uint32(/* id 250062049, wireType 0 =*/2000496392).int32(message.maxPortsPerVm);
                            if (message.sourceSubnetworkIpRangesToNat != null && Object.hasOwnProperty.call(message, "sourceSubnetworkIpRangesToNat"))
                                writer.uint32(/* id 252213211, wireType 2 =*/2017705690).string(message.sourceSubnetworkIpRangesToNat);
                            if (message.enableEndpointIndependentMapping != null && Object.hasOwnProperty.call(message, "enableEndpointIndependentMapping"))
                                writer.uint32(/* id 259441819, wireType 0 =*/2075534552).bool(message.enableEndpointIndependentMapping);
                            if (message.logConfig != null && Object.hasOwnProperty.call(message, "logConfig"))
                                $root.google.cloud.compute.v1.RouterNatLogConfig.encode(message.logConfig, writer.uint32(/* id 351299741, wireType 2 =*/2810397930).fork()).ldelim();
                            if (message.subnetworks != null && message.subnetworks.length)
                                for (var i = 0; i < message.subnetworks.length; ++i)
                                    $root.google.cloud.compute.v1.RouterNatSubnetworkToNat.encode(message.subnetworks[i], writer.uint32(/* id 415853125, wireType 2 =*/3326825002).fork()).ldelim();
                            if (message.natIpAllocateOption != null && Object.hasOwnProperty.call(message, "natIpAllocateOption"))
                                writer.uint32(/* id 429726845, wireType 2 =*/3437814762).string(message.natIpAllocateOption);
                            if (message.endpointTypes != null && message.endpointTypes.length)
                                for (var i = 0; i < message.endpointTypes.length; ++i)
                                    writer.uint32(/* id 502633807, wireType 2 =*/4021070458).string(message.endpointTypes[i]);
                            if (message.drainNatIps != null && message.drainNatIps.length)
                                for (var i = 0; i < message.drainNatIps.length; ++i)
                                    writer.uint32(/* id 504078535, wireType 2 =*/4032628282).string(message.drainNatIps[i]);
                            if (message.tcpTimeWaitTimeoutSec != null && Object.hasOwnProperty.call(message, "tcpTimeWaitTimeoutSec"))
                                writer.uint32(/* id 513596925, wireType 0 =*/4108775400).int32(message.tcpTimeWaitTimeoutSec);
                            if (message.enableDynamicPortAllocation != null && Object.hasOwnProperty.call(message, "enableDynamicPortAllocation"))
                                writer.uint32(/* id 532106402, wireType 0 =*/4256851216).bool(message.enableDynamicPortAllocation);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RouterNat message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RouterNat.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @static
                         * @param {google.cloud.compute.v1.IRouterNat} message RouterNat message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterNat.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RouterNat message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RouterNat} RouterNat
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterNat.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RouterNat();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 504078535: {
                                        if (!(message.drainNatIps && message.drainNatIps.length))
                                            message.drainNatIps = [];
                                        message.drainNatIps.push(reader.string());
                                        break;
                                    }
                                case 532106402: {
                                        message.enableDynamicPortAllocation = reader.bool();
                                        break;
                                    }
                                case 259441819: {
                                        message.enableEndpointIndependentMapping = reader.bool();
                                        break;
                                    }
                                case 502633807: {
                                        if (!(message.endpointTypes && message.endpointTypes.length))
                                            message.endpointTypes = [];
                                        message.endpointTypes.push(reader.string());
                                        break;
                                    }
                                case 3647562: {
                                        message.icmpIdleTimeoutSec = reader.int32();
                                        break;
                                    }
                                case 351299741: {
                                        message.logConfig = $root.google.cloud.compute.v1.RouterNatLogConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 250062049: {
                                        message.maxPortsPerVm = reader.int32();
                                        break;
                                    }
                                case 186193587: {
                                        message.minPortsPerVm = reader.int32();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 429726845: {
                                        message.natIpAllocateOption = reader.string();
                                        break;
                                    }
                                case 117635086: {
                                        if (!(message.natIps && message.natIps.length))
                                            message.natIps = [];
                                        message.natIps.push(reader.string());
                                        break;
                                    }
                                case 108873975: {
                                        if (!(message.rules && message.rules.length))
                                            message.rules = [];
                                        message.rules.push($root.google.cloud.compute.v1.RouterNatRule.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 252213211: {
                                        message.sourceSubnetworkIpRangesToNat = reader.string();
                                        break;
                                    }
                                case 415853125: {
                                        if (!(message.subnetworks && message.subnetworks.length))
                                            message.subnetworks = [];
                                        message.subnetworks.push($root.google.cloud.compute.v1.RouterNatSubnetworkToNat.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 223098349: {
                                        message.tcpEstablishedIdleTimeoutSec = reader.int32();
                                        break;
                                    }
                                case 513596925: {
                                        message.tcpTimeWaitTimeoutSec = reader.int32();
                                        break;
                                    }
                                case 205028774: {
                                        message.tcpTransitoryIdleTimeoutSec = reader.int32();
                                        break;
                                    }
                                case 64919878: {
                                        message.udpIdleTimeoutSec = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RouterNat message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RouterNat} RouterNat
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterNat.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RouterNat message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RouterNat.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.drainNatIps != null && message.hasOwnProperty("drainNatIps")) {
                                if (!Array.isArray(message.drainNatIps))
                                    return "drainNatIps: array expected";
                                for (var i = 0; i < message.drainNatIps.length; ++i)
                                    if (!$util.isString(message.drainNatIps[i]))
                                        return "drainNatIps: string[] expected";
                            }
                            if (message.enableDynamicPortAllocation != null && message.hasOwnProperty("enableDynamicPortAllocation")) {
                                properties._enableDynamicPortAllocation = 1;
                                if (typeof message.enableDynamicPortAllocation !== "boolean")
                                    return "enableDynamicPortAllocation: boolean expected";
                            }
                            if (message.enableEndpointIndependentMapping != null && message.hasOwnProperty("enableEndpointIndependentMapping")) {
                                properties._enableEndpointIndependentMapping = 1;
                                if (typeof message.enableEndpointIndependentMapping !== "boolean")
                                    return "enableEndpointIndependentMapping: boolean expected";
                            }
                            if (message.endpointTypes != null && message.hasOwnProperty("endpointTypes")) {
                                if (!Array.isArray(message.endpointTypes))
                                    return "endpointTypes: array expected";
                                for (var i = 0; i < message.endpointTypes.length; ++i)
                                    if (!$util.isString(message.endpointTypes[i]))
                                        return "endpointTypes: string[] expected";
                            }
                            if (message.icmpIdleTimeoutSec != null && message.hasOwnProperty("icmpIdleTimeoutSec")) {
                                properties._icmpIdleTimeoutSec = 1;
                                if (!$util.isInteger(message.icmpIdleTimeoutSec))
                                    return "icmpIdleTimeoutSec: integer expected";
                            }
                            if (message.logConfig != null && message.hasOwnProperty("logConfig")) {
                                properties._logConfig = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.RouterNatLogConfig.verify(message.logConfig);
                                    if (error)
                                        return "logConfig." + error;
                                }
                            }
                            if (message.maxPortsPerVm != null && message.hasOwnProperty("maxPortsPerVm")) {
                                properties._maxPortsPerVm = 1;
                                if (!$util.isInteger(message.maxPortsPerVm))
                                    return "maxPortsPerVm: integer expected";
                            }
                            if (message.minPortsPerVm != null && message.hasOwnProperty("minPortsPerVm")) {
                                properties._minPortsPerVm = 1;
                                if (!$util.isInteger(message.minPortsPerVm))
                                    return "minPortsPerVm: integer expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.natIpAllocateOption != null && message.hasOwnProperty("natIpAllocateOption")) {
                                properties._natIpAllocateOption = 1;
                                if (!$util.isString(message.natIpAllocateOption))
                                    return "natIpAllocateOption: string expected";
                            }
                            if (message.natIps != null && message.hasOwnProperty("natIps")) {
                                if (!Array.isArray(message.natIps))
                                    return "natIps: array expected";
                                for (var i = 0; i < message.natIps.length; ++i)
                                    if (!$util.isString(message.natIps[i]))
                                        return "natIps: string[] expected";
                            }
                            if (message.rules != null && message.hasOwnProperty("rules")) {
                                if (!Array.isArray(message.rules))
                                    return "rules: array expected";
                                for (var i = 0; i < message.rules.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.RouterNatRule.verify(message.rules[i]);
                                    if (error)
                                        return "rules." + error;
                                }
                            }
                            if (message.sourceSubnetworkIpRangesToNat != null && message.hasOwnProperty("sourceSubnetworkIpRangesToNat")) {
                                properties._sourceSubnetworkIpRangesToNat = 1;
                                if (!$util.isString(message.sourceSubnetworkIpRangesToNat))
                                    return "sourceSubnetworkIpRangesToNat: string expected";
                            }
                            if (message.subnetworks != null && message.hasOwnProperty("subnetworks")) {
                                if (!Array.isArray(message.subnetworks))
                                    return "subnetworks: array expected";
                                for (var i = 0; i < message.subnetworks.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.RouterNatSubnetworkToNat.verify(message.subnetworks[i]);
                                    if (error)
                                        return "subnetworks." + error;
                                }
                            }
                            if (message.tcpEstablishedIdleTimeoutSec != null && message.hasOwnProperty("tcpEstablishedIdleTimeoutSec")) {
                                properties._tcpEstablishedIdleTimeoutSec = 1;
                                if (!$util.isInteger(message.tcpEstablishedIdleTimeoutSec))
                                    return "tcpEstablishedIdleTimeoutSec: integer expected";
                            }
                            if (message.tcpTimeWaitTimeoutSec != null && message.hasOwnProperty("tcpTimeWaitTimeoutSec")) {
                                properties._tcpTimeWaitTimeoutSec = 1;
                                if (!$util.isInteger(message.tcpTimeWaitTimeoutSec))
                                    return "tcpTimeWaitTimeoutSec: integer expected";
                            }
                            if (message.tcpTransitoryIdleTimeoutSec != null && message.hasOwnProperty("tcpTransitoryIdleTimeoutSec")) {
                                properties._tcpTransitoryIdleTimeoutSec = 1;
                                if (!$util.isInteger(message.tcpTransitoryIdleTimeoutSec))
                                    return "tcpTransitoryIdleTimeoutSec: integer expected";
                            }
                            if (message.udpIdleTimeoutSec != null && message.hasOwnProperty("udpIdleTimeoutSec")) {
                                properties._udpIdleTimeoutSec = 1;
                                if (!$util.isInteger(message.udpIdleTimeoutSec))
                                    return "udpIdleTimeoutSec: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RouterNat message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RouterNat} RouterNat
                         */
                        RouterNat.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RouterNat)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RouterNat();
                            if (object.drainNatIps) {
                                if (!Array.isArray(object.drainNatIps))
                                    throw TypeError(".google.cloud.compute.v1.RouterNat.drainNatIps: array expected");
                                message.drainNatIps = [];
                                for (var i = 0; i < object.drainNatIps.length; ++i)
                                    message.drainNatIps[i] = String(object.drainNatIps[i]);
                            }
                            if (object.enableDynamicPortAllocation != null)
                                message.enableDynamicPortAllocation = Boolean(object.enableDynamicPortAllocation);
                            if (object.enableEndpointIndependentMapping != null)
                                message.enableEndpointIndependentMapping = Boolean(object.enableEndpointIndependentMapping);
                            if (object.endpointTypes) {
                                if (!Array.isArray(object.endpointTypes))
                                    throw TypeError(".google.cloud.compute.v1.RouterNat.endpointTypes: array expected");
                                message.endpointTypes = [];
                                for (var i = 0; i < object.endpointTypes.length; ++i)
                                    message.endpointTypes[i] = String(object.endpointTypes[i]);
                            }
                            if (object.icmpIdleTimeoutSec != null)
                                message.icmpIdleTimeoutSec = object.icmpIdleTimeoutSec | 0;
                            if (object.logConfig != null) {
                                if (typeof object.logConfig !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RouterNat.logConfig: object expected");
                                message.logConfig = $root.google.cloud.compute.v1.RouterNatLogConfig.fromObject(object.logConfig);
                            }
                            if (object.maxPortsPerVm != null)
                                message.maxPortsPerVm = object.maxPortsPerVm | 0;
                            if (object.minPortsPerVm != null)
                                message.minPortsPerVm = object.minPortsPerVm | 0;
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.natIpAllocateOption != null)
                                message.natIpAllocateOption = String(object.natIpAllocateOption);
                            if (object.natIps) {
                                if (!Array.isArray(object.natIps))
                                    throw TypeError(".google.cloud.compute.v1.RouterNat.natIps: array expected");
                                message.natIps = [];
                                for (var i = 0; i < object.natIps.length; ++i)
                                    message.natIps[i] = String(object.natIps[i]);
                            }
                            if (object.rules) {
                                if (!Array.isArray(object.rules))
                                    throw TypeError(".google.cloud.compute.v1.RouterNat.rules: array expected");
                                message.rules = [];
                                for (var i = 0; i < object.rules.length; ++i) {
                                    if (typeof object.rules[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RouterNat.rules: object expected");
                                    message.rules[i] = $root.google.cloud.compute.v1.RouterNatRule.fromObject(object.rules[i]);
                                }
                            }
                            if (object.sourceSubnetworkIpRangesToNat != null)
                                message.sourceSubnetworkIpRangesToNat = String(object.sourceSubnetworkIpRangesToNat);
                            if (object.subnetworks) {
                                if (!Array.isArray(object.subnetworks))
                                    throw TypeError(".google.cloud.compute.v1.RouterNat.subnetworks: array expected");
                                message.subnetworks = [];
                                for (var i = 0; i < object.subnetworks.length; ++i) {
                                    if (typeof object.subnetworks[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RouterNat.subnetworks: object expected");
                                    message.subnetworks[i] = $root.google.cloud.compute.v1.RouterNatSubnetworkToNat.fromObject(object.subnetworks[i]);
                                }
                            }
                            if (object.tcpEstablishedIdleTimeoutSec != null)
                                message.tcpEstablishedIdleTimeoutSec = object.tcpEstablishedIdleTimeoutSec | 0;
                            if (object.tcpTimeWaitTimeoutSec != null)
                                message.tcpTimeWaitTimeoutSec = object.tcpTimeWaitTimeoutSec | 0;
                            if (object.tcpTransitoryIdleTimeoutSec != null)
                                message.tcpTransitoryIdleTimeoutSec = object.tcpTransitoryIdleTimeoutSec | 0;
                            if (object.udpIdleTimeoutSec != null)
                                message.udpIdleTimeoutSec = object.udpIdleTimeoutSec | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RouterNat message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @static
                         * @param {google.cloud.compute.v1.RouterNat} message RouterNat
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RouterNat.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.rules = [];
                                object.natIps = [];
                                object.subnetworks = [];
                                object.endpointTypes = [];
                                object.drainNatIps = [];
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.icmpIdleTimeoutSec != null && message.hasOwnProperty("icmpIdleTimeoutSec")) {
                                object.icmpIdleTimeoutSec = message.icmpIdleTimeoutSec;
                                if (options.oneofs)
                                    object._icmpIdleTimeoutSec = "icmpIdleTimeoutSec";
                            }
                            if (message.udpIdleTimeoutSec != null && message.hasOwnProperty("udpIdleTimeoutSec")) {
                                object.udpIdleTimeoutSec = message.udpIdleTimeoutSec;
                                if (options.oneofs)
                                    object._udpIdleTimeoutSec = "udpIdleTimeoutSec";
                            }
                            if (message.rules && message.rules.length) {
                                object.rules = [];
                                for (var j = 0; j < message.rules.length; ++j)
                                    object.rules[j] = $root.google.cloud.compute.v1.RouterNatRule.toObject(message.rules[j], options);
                            }
                            if (message.natIps && message.natIps.length) {
                                object.natIps = [];
                                for (var j = 0; j < message.natIps.length; ++j)
                                    object.natIps[j] = message.natIps[j];
                            }
                            if (message.minPortsPerVm != null && message.hasOwnProperty("minPortsPerVm")) {
                                object.minPortsPerVm = message.minPortsPerVm;
                                if (options.oneofs)
                                    object._minPortsPerVm = "minPortsPerVm";
                            }
                            if (message.tcpTransitoryIdleTimeoutSec != null && message.hasOwnProperty("tcpTransitoryIdleTimeoutSec")) {
                                object.tcpTransitoryIdleTimeoutSec = message.tcpTransitoryIdleTimeoutSec;
                                if (options.oneofs)
                                    object._tcpTransitoryIdleTimeoutSec = "tcpTransitoryIdleTimeoutSec";
                            }
                            if (message.tcpEstablishedIdleTimeoutSec != null && message.hasOwnProperty("tcpEstablishedIdleTimeoutSec")) {
                                object.tcpEstablishedIdleTimeoutSec = message.tcpEstablishedIdleTimeoutSec;
                                if (options.oneofs)
                                    object._tcpEstablishedIdleTimeoutSec = "tcpEstablishedIdleTimeoutSec";
                            }
                            if (message.maxPortsPerVm != null && message.hasOwnProperty("maxPortsPerVm")) {
                                object.maxPortsPerVm = message.maxPortsPerVm;
                                if (options.oneofs)
                                    object._maxPortsPerVm = "maxPortsPerVm";
                            }
                            if (message.sourceSubnetworkIpRangesToNat != null && message.hasOwnProperty("sourceSubnetworkIpRangesToNat")) {
                                object.sourceSubnetworkIpRangesToNat = message.sourceSubnetworkIpRangesToNat;
                                if (options.oneofs)
                                    object._sourceSubnetworkIpRangesToNat = "sourceSubnetworkIpRangesToNat";
                            }
                            if (message.enableEndpointIndependentMapping != null && message.hasOwnProperty("enableEndpointIndependentMapping")) {
                                object.enableEndpointIndependentMapping = message.enableEndpointIndependentMapping;
                                if (options.oneofs)
                                    object._enableEndpointIndependentMapping = "enableEndpointIndependentMapping";
                            }
                            if (message.logConfig != null && message.hasOwnProperty("logConfig")) {
                                object.logConfig = $root.google.cloud.compute.v1.RouterNatLogConfig.toObject(message.logConfig, options);
                                if (options.oneofs)
                                    object._logConfig = "logConfig";
                            }
                            if (message.subnetworks && message.subnetworks.length) {
                                object.subnetworks = [];
                                for (var j = 0; j < message.subnetworks.length; ++j)
                                    object.subnetworks[j] = $root.google.cloud.compute.v1.RouterNatSubnetworkToNat.toObject(message.subnetworks[j], options);
                            }
                            if (message.natIpAllocateOption != null && message.hasOwnProperty("natIpAllocateOption")) {
                                object.natIpAllocateOption = message.natIpAllocateOption;
                                if (options.oneofs)
                                    object._natIpAllocateOption = "natIpAllocateOption";
                            }
                            if (message.endpointTypes && message.endpointTypes.length) {
                                object.endpointTypes = [];
                                for (var j = 0; j < message.endpointTypes.length; ++j)
                                    object.endpointTypes[j] = message.endpointTypes[j];
                            }
                            if (message.drainNatIps && message.drainNatIps.length) {
                                object.drainNatIps = [];
                                for (var j = 0; j < message.drainNatIps.length; ++j)
                                    object.drainNatIps[j] = message.drainNatIps[j];
                            }
                            if (message.tcpTimeWaitTimeoutSec != null && message.hasOwnProperty("tcpTimeWaitTimeoutSec")) {
                                object.tcpTimeWaitTimeoutSec = message.tcpTimeWaitTimeoutSec;
                                if (options.oneofs)
                                    object._tcpTimeWaitTimeoutSec = "tcpTimeWaitTimeoutSec";
                            }
                            if (message.enableDynamicPortAllocation != null && message.hasOwnProperty("enableDynamicPortAllocation")) {
                                object.enableDynamicPortAllocation = message.enableDynamicPortAllocation;
                                if (options.oneofs)
                                    object._enableDynamicPortAllocation = "enableDynamicPortAllocation";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RouterNat to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RouterNat.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RouterNat
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RouterNat
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RouterNat.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RouterNat";
                        };
    
                        /**
                         * EndpointTypes enum.
                         * @name google.cloud.compute.v1.RouterNat.EndpointTypes
                         * @enum {number}
                         * @property {number} UNDEFINED_ENDPOINT_TYPES=0 UNDEFINED_ENDPOINT_TYPES value
                         * @property {number} ENDPOINT_TYPE_SWG=159344456 ENDPOINT_TYPE_SWG value
                         * @property {number} ENDPOINT_TYPE_VM=57095474 ENDPOINT_TYPE_VM value
                         */
                        RouterNat.EndpointTypes = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ENDPOINT_TYPES"] = 0;
                            values[valuesById[159344456] = "ENDPOINT_TYPE_SWG"] = 159344456;
                            values[valuesById[57095474] = "ENDPOINT_TYPE_VM"] = 57095474;
                            return values;
                        })();
    
                        /**
                         * NatIpAllocateOption enum.
                         * @name google.cloud.compute.v1.RouterNat.NatIpAllocateOption
                         * @enum {number}
                         * @property {number} UNDEFINED_NAT_IP_ALLOCATE_OPTION=0 UNDEFINED_NAT_IP_ALLOCATE_OPTION value
                         * @property {number} AUTO_ONLY=182333500 AUTO_ONLY value
                         * @property {number} MANUAL_ONLY=261251205 MANUAL_ONLY value
                         */
                        RouterNat.NatIpAllocateOption = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_NAT_IP_ALLOCATE_OPTION"] = 0;
                            values[valuesById[182333500] = "AUTO_ONLY"] = 182333500;
                            values[valuesById[261251205] = "MANUAL_ONLY"] = 261251205;
                            return values;
                        })();
    
                        /**
                         * SourceSubnetworkIpRangesToNat enum.
                         * @name google.cloud.compute.v1.RouterNat.SourceSubnetworkIpRangesToNat
                         * @enum {number}
                         * @property {number} UNDEFINED_SOURCE_SUBNETWORK_IP_RANGES_TO_NAT=0 UNDEFINED_SOURCE_SUBNETWORK_IP_RANGES_TO_NAT value
                         * @property {number} ALL_SUBNETWORKS_ALL_IP_RANGES=179964376 ALL_SUBNETWORKS_ALL_IP_RANGES value
                         * @property {number} ALL_SUBNETWORKS_ALL_PRIMARY_IP_RANGES=185573819 ALL_SUBNETWORKS_ALL_PRIMARY_IP_RANGES value
                         * @property {number} LIST_OF_SUBNETWORKS=517542270 LIST_OF_SUBNETWORKS value
                         */
                        RouterNat.SourceSubnetworkIpRangesToNat = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_SOURCE_SUBNETWORK_IP_RANGES_TO_NAT"] = 0;
                            values[valuesById[179964376] = "ALL_SUBNETWORKS_ALL_IP_RANGES"] = 179964376;
                            values[valuesById[185573819] = "ALL_SUBNETWORKS_ALL_PRIMARY_IP_RANGES"] = 185573819;
                            values[valuesById[517542270] = "LIST_OF_SUBNETWORKS"] = 517542270;
                            return values;
                        })();
    
                        return RouterNat;
                    })();
    
                    v1.RouterNatLogConfig = (function() {
    
                        /**
                         * Properties of a RouterNatLogConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouterNatLogConfig
                         * @property {boolean|null} [enable] RouterNatLogConfig enable
                         * @property {string|null} [filter] RouterNatLogConfig filter
                         */
    
                        /**
                         * Constructs a new RouterNatLogConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RouterNatLogConfig.
                         * @implements IRouterNatLogConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouterNatLogConfig=} [properties] Properties to set
                         */
                        function RouterNatLogConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RouterNatLogConfig enable.
                         * @member {boolean|null|undefined} enable
                         * @memberof google.cloud.compute.v1.RouterNatLogConfig
                         * @instance
                         */
                        RouterNatLogConfig.prototype.enable = null;
    
                        /**
                         * RouterNatLogConfig filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1.RouterNatLogConfig
                         * @instance
                         */
                        RouterNatLogConfig.prototype.filter = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RouterNatLogConfig _enable.
                         * @member {"enable"|undefined} _enable
                         * @memberof google.cloud.compute.v1.RouterNatLogConfig
                         * @instance
                         */
                        Object.defineProperty(RouterNatLogConfig.prototype, "_enable", {
                            get: $util.oneOfGetter($oneOfFields = ["enable"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterNatLogConfig _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1.RouterNatLogConfig
                         * @instance
                         */
                        Object.defineProperty(RouterNatLogConfig.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RouterNatLogConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RouterNatLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.IRouterNatLogConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RouterNatLogConfig} RouterNatLogConfig instance
                         */
                        RouterNatLogConfig.create = function create(properties) {
                            return new RouterNatLogConfig(properties);
                        };
    
                        /**
                         * Encodes the specified RouterNatLogConfig message. Does not implicitly {@link google.cloud.compute.v1.RouterNatLogConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RouterNatLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.IRouterNatLogConfig} message RouterNatLogConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterNatLogConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.enable != null && Object.hasOwnProperty.call(message, "enable"))
                                writer.uint32(/* id 311764355, wireType 0 =*/2494114840).bool(message.enable);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RouterNatLogConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RouterNatLogConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RouterNatLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.IRouterNatLogConfig} message RouterNatLogConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterNatLogConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RouterNatLogConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RouterNatLogConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RouterNatLogConfig} RouterNatLogConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterNatLogConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RouterNatLogConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 311764355: {
                                        message.enable = reader.bool();
                                        break;
                                    }
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RouterNatLogConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RouterNatLogConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RouterNatLogConfig} RouterNatLogConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterNatLogConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RouterNatLogConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RouterNatLogConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RouterNatLogConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.enable != null && message.hasOwnProperty("enable")) {
                                properties._enable = 1;
                                if (typeof message.enable !== "boolean")
                                    return "enable: boolean expected";
                            }
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RouterNatLogConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RouterNatLogConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RouterNatLogConfig} RouterNatLogConfig
                         */
                        RouterNatLogConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RouterNatLogConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RouterNatLogConfig();
                            if (object.enable != null)
                                message.enable = Boolean(object.enable);
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RouterNatLogConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RouterNatLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.RouterNatLogConfig} message RouterNatLogConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RouterNatLogConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.enable != null && message.hasOwnProperty("enable")) {
                                object.enable = message.enable;
                                if (options.oneofs)
                                    object._enable = "enable";
                            }
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RouterNatLogConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RouterNatLogConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RouterNatLogConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RouterNatLogConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RouterNatLogConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RouterNatLogConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RouterNatLogConfig";
                        };
    
                        /**
                         * Filter enum.
                         * @name google.cloud.compute.v1.RouterNatLogConfig.Filter
                         * @enum {number}
                         * @property {number} UNDEFINED_FILTER=0 UNDEFINED_FILTER value
                         * @property {number} ALL=64897 ALL value
                         * @property {number} ERRORS_ONLY=307484672 ERRORS_ONLY value
                         * @property {number} TRANSLATIONS_ONLY=357212649 TRANSLATIONS_ONLY value
                         */
                        RouterNatLogConfig.Filter = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_FILTER"] = 0;
                            values[valuesById[64897] = "ALL"] = 64897;
                            values[valuesById[307484672] = "ERRORS_ONLY"] = 307484672;
                            values[valuesById[357212649] = "TRANSLATIONS_ONLY"] = 357212649;
                            return values;
                        })();
    
                        return RouterNatLogConfig;
                    })();
    
                    v1.RouterNatRule = (function() {
    
                        /**
                         * Properties of a RouterNatRule.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouterNatRule
                         * @property {google.cloud.compute.v1.IRouterNatRuleAction|null} [action] RouterNatRule action
                         * @property {string|null} [description] RouterNatRule description
                         * @property {string|null} [match] RouterNatRule match
                         * @property {number|null} [ruleNumber] RouterNatRule ruleNumber
                         */
    
                        /**
                         * Constructs a new RouterNatRule.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RouterNatRule.
                         * @implements IRouterNatRule
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouterNatRule=} [properties] Properties to set
                         */
                        function RouterNatRule(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RouterNatRule action.
                         * @member {google.cloud.compute.v1.IRouterNatRuleAction|null|undefined} action
                         * @memberof google.cloud.compute.v1.RouterNatRule
                         * @instance
                         */
                        RouterNatRule.prototype.action = null;
    
                        /**
                         * RouterNatRule description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.RouterNatRule
                         * @instance
                         */
                        RouterNatRule.prototype.description = null;
    
                        /**
                         * RouterNatRule match.
                         * @member {string|null|undefined} match
                         * @memberof google.cloud.compute.v1.RouterNatRule
                         * @instance
                         */
                        RouterNatRule.prototype.match = null;
    
                        /**
                         * RouterNatRule ruleNumber.
                         * @member {number|null|undefined} ruleNumber
                         * @memberof google.cloud.compute.v1.RouterNatRule
                         * @instance
                         */
                        RouterNatRule.prototype.ruleNumber = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RouterNatRule _action.
                         * @member {"action"|undefined} _action
                         * @memberof google.cloud.compute.v1.RouterNatRule
                         * @instance
                         */
                        Object.defineProperty(RouterNatRule.prototype, "_action", {
                            get: $util.oneOfGetter($oneOfFields = ["action"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterNatRule _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.RouterNatRule
                         * @instance
                         */
                        Object.defineProperty(RouterNatRule.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterNatRule _match.
                         * @member {"match"|undefined} _match
                         * @memberof google.cloud.compute.v1.RouterNatRule
                         * @instance
                         */
                        Object.defineProperty(RouterNatRule.prototype, "_match", {
                            get: $util.oneOfGetter($oneOfFields = ["match"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterNatRule _ruleNumber.
                         * @member {"ruleNumber"|undefined} _ruleNumber
                         * @memberof google.cloud.compute.v1.RouterNatRule
                         * @instance
                         */
                        Object.defineProperty(RouterNatRule.prototype, "_ruleNumber", {
                            get: $util.oneOfGetter($oneOfFields = ["ruleNumber"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RouterNatRule instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RouterNatRule
                         * @static
                         * @param {google.cloud.compute.v1.IRouterNatRule=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RouterNatRule} RouterNatRule instance
                         */
                        RouterNatRule.create = function create(properties) {
                            return new RouterNatRule(properties);
                        };
    
                        /**
                         * Encodes the specified RouterNatRule message. Does not implicitly {@link google.cloud.compute.v1.RouterNatRule.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RouterNatRule
                         * @static
                         * @param {google.cloud.compute.v1.IRouterNatRule} message RouterNatRule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterNatRule.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.match != null && Object.hasOwnProperty.call(message, "match"))
                                writer.uint32(/* id 103668165, wireType 2 =*/829345322).string(message.match);
                            if (message.action != null && Object.hasOwnProperty.call(message, "action"))
                                $root.google.cloud.compute.v1.RouterNatRuleAction.encode(message.action, writer.uint32(/* id 187661878, wireType 2 =*/1501295026).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.ruleNumber != null && Object.hasOwnProperty.call(message, "ruleNumber"))
                                writer.uint32(/* id 535211500, wireType 0 =*/4281692000).uint32(message.ruleNumber);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RouterNatRule message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RouterNatRule.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RouterNatRule
                         * @static
                         * @param {google.cloud.compute.v1.IRouterNatRule} message RouterNatRule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterNatRule.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RouterNatRule message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RouterNatRule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RouterNatRule} RouterNatRule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterNatRule.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RouterNatRule();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 187661878: {
                                        message.action = $root.google.cloud.compute.v1.RouterNatRuleAction.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 103668165: {
                                        message.match = reader.string();
                                        break;
                                    }
                                case 535211500: {
                                        message.ruleNumber = reader.uint32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RouterNatRule message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RouterNatRule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RouterNatRule} RouterNatRule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterNatRule.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RouterNatRule message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RouterNatRule
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RouterNatRule.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.action != null && message.hasOwnProperty("action")) {
                                properties._action = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.RouterNatRuleAction.verify(message.action);
                                    if (error)
                                        return "action." + error;
                                }
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.match != null && message.hasOwnProperty("match")) {
                                properties._match = 1;
                                if (!$util.isString(message.match))
                                    return "match: string expected";
                            }
                            if (message.ruleNumber != null && message.hasOwnProperty("ruleNumber")) {
                                properties._ruleNumber = 1;
                                if (!$util.isInteger(message.ruleNumber))
                                    return "ruleNumber: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RouterNatRule message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RouterNatRule
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RouterNatRule} RouterNatRule
                         */
                        RouterNatRule.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RouterNatRule)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RouterNatRule();
                            if (object.action != null) {
                                if (typeof object.action !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RouterNatRule.action: object expected");
                                message.action = $root.google.cloud.compute.v1.RouterNatRuleAction.fromObject(object.action);
                            }
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.match != null)
                                message.match = String(object.match);
                            if (object.ruleNumber != null)
                                message.ruleNumber = object.ruleNumber >>> 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RouterNatRule message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RouterNatRule
                         * @static
                         * @param {google.cloud.compute.v1.RouterNatRule} message RouterNatRule
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RouterNatRule.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.match != null && message.hasOwnProperty("match")) {
                                object.match = message.match;
                                if (options.oneofs)
                                    object._match = "match";
                            }
                            if (message.action != null && message.hasOwnProperty("action")) {
                                object.action = $root.google.cloud.compute.v1.RouterNatRuleAction.toObject(message.action, options);
                                if (options.oneofs)
                                    object._action = "action";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.ruleNumber != null && message.hasOwnProperty("ruleNumber")) {
                                object.ruleNumber = message.ruleNumber;
                                if (options.oneofs)
                                    object._ruleNumber = "ruleNumber";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RouterNatRule to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RouterNatRule
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RouterNatRule.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RouterNatRule
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RouterNatRule
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RouterNatRule.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RouterNatRule";
                        };
    
                        return RouterNatRule;
                    })();
    
                    v1.RouterNatRuleAction = (function() {
    
                        /**
                         * Properties of a RouterNatRuleAction.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouterNatRuleAction
                         * @property {Array.<string>|null} [sourceNatActiveIps] RouterNatRuleAction sourceNatActiveIps
                         * @property {Array.<string>|null} [sourceNatDrainIps] RouterNatRuleAction sourceNatDrainIps
                         */
    
                        /**
                         * Constructs a new RouterNatRuleAction.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RouterNatRuleAction.
                         * @implements IRouterNatRuleAction
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouterNatRuleAction=} [properties] Properties to set
                         */
                        function RouterNatRuleAction(properties) {
                            this.sourceNatActiveIps = [];
                            this.sourceNatDrainIps = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RouterNatRuleAction sourceNatActiveIps.
                         * @member {Array.<string>} sourceNatActiveIps
                         * @memberof google.cloud.compute.v1.RouterNatRuleAction
                         * @instance
                         */
                        RouterNatRuleAction.prototype.sourceNatActiveIps = $util.emptyArray;
    
                        /**
                         * RouterNatRuleAction sourceNatDrainIps.
                         * @member {Array.<string>} sourceNatDrainIps
                         * @memberof google.cloud.compute.v1.RouterNatRuleAction
                         * @instance
                         */
                        RouterNatRuleAction.prototype.sourceNatDrainIps = $util.emptyArray;
    
                        /**
                         * Creates a new RouterNatRuleAction instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RouterNatRuleAction
                         * @static
                         * @param {google.cloud.compute.v1.IRouterNatRuleAction=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RouterNatRuleAction} RouterNatRuleAction instance
                         */
                        RouterNatRuleAction.create = function create(properties) {
                            return new RouterNatRuleAction(properties);
                        };
    
                        /**
                         * Encodes the specified RouterNatRuleAction message. Does not implicitly {@link google.cloud.compute.v1.RouterNatRuleAction.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RouterNatRuleAction
                         * @static
                         * @param {google.cloud.compute.v1.IRouterNatRuleAction} message RouterNatRuleAction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterNatRuleAction.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.sourceNatActiveIps != null && message.sourceNatActiveIps.length)
                                for (var i = 0; i < message.sourceNatActiveIps.length; ++i)
                                    writer.uint32(/* id 210378229, wireType 2 =*/1683025834).string(message.sourceNatActiveIps[i]);
                            if (message.sourceNatDrainIps != null && message.sourceNatDrainIps.length)
                                for (var i = 0; i < message.sourceNatDrainIps.length; ++i)
                                    writer.uint32(/* id 340812451, wireType 2 =*/2726499610).string(message.sourceNatDrainIps[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RouterNatRuleAction message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RouterNatRuleAction.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RouterNatRuleAction
                         * @static
                         * @param {google.cloud.compute.v1.IRouterNatRuleAction} message RouterNatRuleAction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterNatRuleAction.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RouterNatRuleAction message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RouterNatRuleAction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RouterNatRuleAction} RouterNatRuleAction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterNatRuleAction.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RouterNatRuleAction();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 210378229: {
                                        if (!(message.sourceNatActiveIps && message.sourceNatActiveIps.length))
                                            message.sourceNatActiveIps = [];
                                        message.sourceNatActiveIps.push(reader.string());
                                        break;
                                    }
                                case 340812451: {
                                        if (!(message.sourceNatDrainIps && message.sourceNatDrainIps.length))
                                            message.sourceNatDrainIps = [];
                                        message.sourceNatDrainIps.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RouterNatRuleAction message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RouterNatRuleAction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RouterNatRuleAction} RouterNatRuleAction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterNatRuleAction.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RouterNatRuleAction message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RouterNatRuleAction
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RouterNatRuleAction.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.sourceNatActiveIps != null && message.hasOwnProperty("sourceNatActiveIps")) {
                                if (!Array.isArray(message.sourceNatActiveIps))
                                    return "sourceNatActiveIps: array expected";
                                for (var i = 0; i < message.sourceNatActiveIps.length; ++i)
                                    if (!$util.isString(message.sourceNatActiveIps[i]))
                                        return "sourceNatActiveIps: string[] expected";
                            }
                            if (message.sourceNatDrainIps != null && message.hasOwnProperty("sourceNatDrainIps")) {
                                if (!Array.isArray(message.sourceNatDrainIps))
                                    return "sourceNatDrainIps: array expected";
                                for (var i = 0; i < message.sourceNatDrainIps.length; ++i)
                                    if (!$util.isString(message.sourceNatDrainIps[i]))
                                        return "sourceNatDrainIps: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RouterNatRuleAction message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RouterNatRuleAction
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RouterNatRuleAction} RouterNatRuleAction
                         */
                        RouterNatRuleAction.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RouterNatRuleAction)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RouterNatRuleAction();
                            if (object.sourceNatActiveIps) {
                                if (!Array.isArray(object.sourceNatActiveIps))
                                    throw TypeError(".google.cloud.compute.v1.RouterNatRuleAction.sourceNatActiveIps: array expected");
                                message.sourceNatActiveIps = [];
                                for (var i = 0; i < object.sourceNatActiveIps.length; ++i)
                                    message.sourceNatActiveIps[i] = String(object.sourceNatActiveIps[i]);
                            }
                            if (object.sourceNatDrainIps) {
                                if (!Array.isArray(object.sourceNatDrainIps))
                                    throw TypeError(".google.cloud.compute.v1.RouterNatRuleAction.sourceNatDrainIps: array expected");
                                message.sourceNatDrainIps = [];
                                for (var i = 0; i < object.sourceNatDrainIps.length; ++i)
                                    message.sourceNatDrainIps[i] = String(object.sourceNatDrainIps[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RouterNatRuleAction message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RouterNatRuleAction
                         * @static
                         * @param {google.cloud.compute.v1.RouterNatRuleAction} message RouterNatRuleAction
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RouterNatRuleAction.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.sourceNatActiveIps = [];
                                object.sourceNatDrainIps = [];
                            }
                            if (message.sourceNatActiveIps && message.sourceNatActiveIps.length) {
                                object.sourceNatActiveIps = [];
                                for (var j = 0; j < message.sourceNatActiveIps.length; ++j)
                                    object.sourceNatActiveIps[j] = message.sourceNatActiveIps[j];
                            }
                            if (message.sourceNatDrainIps && message.sourceNatDrainIps.length) {
                                object.sourceNatDrainIps = [];
                                for (var j = 0; j < message.sourceNatDrainIps.length; ++j)
                                    object.sourceNatDrainIps[j] = message.sourceNatDrainIps[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RouterNatRuleAction to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RouterNatRuleAction
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RouterNatRuleAction.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RouterNatRuleAction
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RouterNatRuleAction
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RouterNatRuleAction.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RouterNatRuleAction";
                        };
    
                        return RouterNatRuleAction;
                    })();
    
                    v1.RouterNatSubnetworkToNat = (function() {
    
                        /**
                         * Properties of a RouterNatSubnetworkToNat.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouterNatSubnetworkToNat
                         * @property {string|null} [name] RouterNatSubnetworkToNat name
                         * @property {Array.<string>|null} [secondaryIpRangeNames] RouterNatSubnetworkToNat secondaryIpRangeNames
                         * @property {Array.<string>|null} [sourceIpRangesToNat] RouterNatSubnetworkToNat sourceIpRangesToNat
                         */
    
                        /**
                         * Constructs a new RouterNatSubnetworkToNat.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RouterNatSubnetworkToNat.
                         * @implements IRouterNatSubnetworkToNat
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouterNatSubnetworkToNat=} [properties] Properties to set
                         */
                        function RouterNatSubnetworkToNat(properties) {
                            this.secondaryIpRangeNames = [];
                            this.sourceIpRangesToNat = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RouterNatSubnetworkToNat name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.RouterNatSubnetworkToNat
                         * @instance
                         */
                        RouterNatSubnetworkToNat.prototype.name = null;
    
                        /**
                         * RouterNatSubnetworkToNat secondaryIpRangeNames.
                         * @member {Array.<string>} secondaryIpRangeNames
                         * @memberof google.cloud.compute.v1.RouterNatSubnetworkToNat
                         * @instance
                         */
                        RouterNatSubnetworkToNat.prototype.secondaryIpRangeNames = $util.emptyArray;
    
                        /**
                         * RouterNatSubnetworkToNat sourceIpRangesToNat.
                         * @member {Array.<string>} sourceIpRangesToNat
                         * @memberof google.cloud.compute.v1.RouterNatSubnetworkToNat
                         * @instance
                         */
                        RouterNatSubnetworkToNat.prototype.sourceIpRangesToNat = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RouterNatSubnetworkToNat _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.RouterNatSubnetworkToNat
                         * @instance
                         */
                        Object.defineProperty(RouterNatSubnetworkToNat.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RouterNatSubnetworkToNat instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RouterNatSubnetworkToNat
                         * @static
                         * @param {google.cloud.compute.v1.IRouterNatSubnetworkToNat=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RouterNatSubnetworkToNat} RouterNatSubnetworkToNat instance
                         */
                        RouterNatSubnetworkToNat.create = function create(properties) {
                            return new RouterNatSubnetworkToNat(properties);
                        };
    
                        /**
                         * Encodes the specified RouterNatSubnetworkToNat message. Does not implicitly {@link google.cloud.compute.v1.RouterNatSubnetworkToNat.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RouterNatSubnetworkToNat
                         * @static
                         * @param {google.cloud.compute.v1.IRouterNatSubnetworkToNat} message RouterNatSubnetworkToNat message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterNatSubnetworkToNat.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.secondaryIpRangeNames != null && message.secondaryIpRangeNames.length)
                                for (var i = 0; i < message.secondaryIpRangeNames.length; ++i)
                                    writer.uint32(/* id 264315097, wireType 2 =*/2114520778).string(message.secondaryIpRangeNames[i]);
                            if (message.sourceIpRangesToNat != null && message.sourceIpRangesToNat.length)
                                for (var i = 0; i < message.sourceIpRangesToNat.length; ++i)
                                    writer.uint32(/* id 388310386, wireType 2 =*/3106483090).string(message.sourceIpRangesToNat[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RouterNatSubnetworkToNat message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RouterNatSubnetworkToNat.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RouterNatSubnetworkToNat
                         * @static
                         * @param {google.cloud.compute.v1.IRouterNatSubnetworkToNat} message RouterNatSubnetworkToNat message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterNatSubnetworkToNat.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RouterNatSubnetworkToNat message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RouterNatSubnetworkToNat
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RouterNatSubnetworkToNat} RouterNatSubnetworkToNat
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterNatSubnetworkToNat.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RouterNatSubnetworkToNat();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 264315097: {
                                        if (!(message.secondaryIpRangeNames && message.secondaryIpRangeNames.length))
                                            message.secondaryIpRangeNames = [];
                                        message.secondaryIpRangeNames.push(reader.string());
                                        break;
                                    }
                                case 388310386: {
                                        if (!(message.sourceIpRangesToNat && message.sourceIpRangesToNat.length))
                                            message.sourceIpRangesToNat = [];
                                        message.sourceIpRangesToNat.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RouterNatSubnetworkToNat message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RouterNatSubnetworkToNat
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RouterNatSubnetworkToNat} RouterNatSubnetworkToNat
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterNatSubnetworkToNat.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RouterNatSubnetworkToNat message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RouterNatSubnetworkToNat
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RouterNatSubnetworkToNat.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.secondaryIpRangeNames != null && message.hasOwnProperty("secondaryIpRangeNames")) {
                                if (!Array.isArray(message.secondaryIpRangeNames))
                                    return "secondaryIpRangeNames: array expected";
                                for (var i = 0; i < message.secondaryIpRangeNames.length; ++i)
                                    if (!$util.isString(message.secondaryIpRangeNames[i]))
                                        return "secondaryIpRangeNames: string[] expected";
                            }
                            if (message.sourceIpRangesToNat != null && message.hasOwnProperty("sourceIpRangesToNat")) {
                                if (!Array.isArray(message.sourceIpRangesToNat))
                                    return "sourceIpRangesToNat: array expected";
                                for (var i = 0; i < message.sourceIpRangesToNat.length; ++i)
                                    if (!$util.isString(message.sourceIpRangesToNat[i]))
                                        return "sourceIpRangesToNat: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RouterNatSubnetworkToNat message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RouterNatSubnetworkToNat
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RouterNatSubnetworkToNat} RouterNatSubnetworkToNat
                         */
                        RouterNatSubnetworkToNat.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RouterNatSubnetworkToNat)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RouterNatSubnetworkToNat();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.secondaryIpRangeNames) {
                                if (!Array.isArray(object.secondaryIpRangeNames))
                                    throw TypeError(".google.cloud.compute.v1.RouterNatSubnetworkToNat.secondaryIpRangeNames: array expected");
                                message.secondaryIpRangeNames = [];
                                for (var i = 0; i < object.secondaryIpRangeNames.length; ++i)
                                    message.secondaryIpRangeNames[i] = String(object.secondaryIpRangeNames[i]);
                            }
                            if (object.sourceIpRangesToNat) {
                                if (!Array.isArray(object.sourceIpRangesToNat))
                                    throw TypeError(".google.cloud.compute.v1.RouterNatSubnetworkToNat.sourceIpRangesToNat: array expected");
                                message.sourceIpRangesToNat = [];
                                for (var i = 0; i < object.sourceIpRangesToNat.length; ++i)
                                    message.sourceIpRangesToNat[i] = String(object.sourceIpRangesToNat[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RouterNatSubnetworkToNat message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RouterNatSubnetworkToNat
                         * @static
                         * @param {google.cloud.compute.v1.RouterNatSubnetworkToNat} message RouterNatSubnetworkToNat
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RouterNatSubnetworkToNat.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.secondaryIpRangeNames = [];
                                object.sourceIpRangesToNat = [];
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.secondaryIpRangeNames && message.secondaryIpRangeNames.length) {
                                object.secondaryIpRangeNames = [];
                                for (var j = 0; j < message.secondaryIpRangeNames.length; ++j)
                                    object.secondaryIpRangeNames[j] = message.secondaryIpRangeNames[j];
                            }
                            if (message.sourceIpRangesToNat && message.sourceIpRangesToNat.length) {
                                object.sourceIpRangesToNat = [];
                                for (var j = 0; j < message.sourceIpRangesToNat.length; ++j)
                                    object.sourceIpRangesToNat[j] = message.sourceIpRangesToNat[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RouterNatSubnetworkToNat to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RouterNatSubnetworkToNat
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RouterNatSubnetworkToNat.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RouterNatSubnetworkToNat
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RouterNatSubnetworkToNat
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RouterNatSubnetworkToNat.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RouterNatSubnetworkToNat";
                        };
    
                        /**
                         * SourceIpRangesToNat enum.
                         * @name google.cloud.compute.v1.RouterNatSubnetworkToNat.SourceIpRangesToNat
                         * @enum {number}
                         * @property {number} UNDEFINED_SOURCE_IP_RANGES_TO_NAT=0 UNDEFINED_SOURCE_IP_RANGES_TO_NAT value
                         * @property {number} ALL_IP_RANGES=35608496 ALL_IP_RANGES value
                         * @property {number} LIST_OF_SECONDARY_IP_RANGES=192289308 LIST_OF_SECONDARY_IP_RANGES value
                         * @property {number} PRIMARY_IP_RANGE=297109954 PRIMARY_IP_RANGE value
                         */
                        RouterNatSubnetworkToNat.SourceIpRangesToNat = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_SOURCE_IP_RANGES_TO_NAT"] = 0;
                            values[valuesById[35608496] = "ALL_IP_RANGES"] = 35608496;
                            values[valuesById[192289308] = "LIST_OF_SECONDARY_IP_RANGES"] = 192289308;
                            values[valuesById[297109954] = "PRIMARY_IP_RANGE"] = 297109954;
                            return values;
                        })();
    
                        return RouterNatSubnetworkToNat;
                    })();
    
                    v1.RouterStatus = (function() {
    
                        /**
                         * Properties of a RouterStatus.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouterStatus
                         * @property {Array.<google.cloud.compute.v1.IRoute>|null} [bestRoutes] RouterStatus bestRoutes
                         * @property {Array.<google.cloud.compute.v1.IRoute>|null} [bestRoutesForRouter] RouterStatus bestRoutesForRouter
                         * @property {Array.<google.cloud.compute.v1.IRouterStatusBgpPeerStatus>|null} [bgpPeerStatus] RouterStatus bgpPeerStatus
                         * @property {Array.<google.cloud.compute.v1.IRouterStatusNatStatus>|null} [natStatus] RouterStatus natStatus
                         * @property {string|null} [network] RouterStatus network
                         */
    
                        /**
                         * Constructs a new RouterStatus.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RouterStatus.
                         * @implements IRouterStatus
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouterStatus=} [properties] Properties to set
                         */
                        function RouterStatus(properties) {
                            this.bestRoutes = [];
                            this.bestRoutesForRouter = [];
                            this.bgpPeerStatus = [];
                            this.natStatus = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RouterStatus bestRoutes.
                         * @member {Array.<google.cloud.compute.v1.IRoute>} bestRoutes
                         * @memberof google.cloud.compute.v1.RouterStatus
                         * @instance
                         */
                        RouterStatus.prototype.bestRoutes = $util.emptyArray;
    
                        /**
                         * RouterStatus bestRoutesForRouter.
                         * @member {Array.<google.cloud.compute.v1.IRoute>} bestRoutesForRouter
                         * @memberof google.cloud.compute.v1.RouterStatus
                         * @instance
                         */
                        RouterStatus.prototype.bestRoutesForRouter = $util.emptyArray;
    
                        /**
                         * RouterStatus bgpPeerStatus.
                         * @member {Array.<google.cloud.compute.v1.IRouterStatusBgpPeerStatus>} bgpPeerStatus
                         * @memberof google.cloud.compute.v1.RouterStatus
                         * @instance
                         */
                        RouterStatus.prototype.bgpPeerStatus = $util.emptyArray;
    
                        /**
                         * RouterStatus natStatus.
                         * @member {Array.<google.cloud.compute.v1.IRouterStatusNatStatus>} natStatus
                         * @memberof google.cloud.compute.v1.RouterStatus
                         * @instance
                         */
                        RouterStatus.prototype.natStatus = $util.emptyArray;
    
                        /**
                         * RouterStatus network.
                         * @member {string|null|undefined} network
                         * @memberof google.cloud.compute.v1.RouterStatus
                         * @instance
                         */
                        RouterStatus.prototype.network = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RouterStatus _network.
                         * @member {"network"|undefined} _network
                         * @memberof google.cloud.compute.v1.RouterStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatus.prototype, "_network", {
                            get: $util.oneOfGetter($oneOfFields = ["network"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RouterStatus instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RouterStatus
                         * @static
                         * @param {google.cloud.compute.v1.IRouterStatus=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RouterStatus} RouterStatus instance
                         */
                        RouterStatus.create = function create(properties) {
                            return new RouterStatus(properties);
                        };
    
                        /**
                         * Encodes the specified RouterStatus message. Does not implicitly {@link google.cloud.compute.v1.RouterStatus.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RouterStatus
                         * @static
                         * @param {google.cloud.compute.v1.IRouterStatus} message RouterStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterStatus.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.natStatus != null && message.natStatus.length)
                                for (var i = 0; i < message.natStatus.length; ++i)
                                    $root.google.cloud.compute.v1.RouterStatusNatStatus.encode(message.natStatus[i], writer.uint32(/* id 63098064, wireType 2 =*/504784514).fork()).ldelim();
                            if (message.bestRoutesForRouter != null && message.bestRoutesForRouter.length)
                                for (var i = 0; i < message.bestRoutesForRouter.length; ++i)
                                    $root.google.cloud.compute.v1.Route.encode(message.bestRoutesForRouter[i], writer.uint32(/* id 119389689, wireType 2 =*/955117514).fork()).ldelim();
                            if (message.bgpPeerStatus != null && message.bgpPeerStatus.length)
                                for (var i = 0; i < message.bgpPeerStatus.length; ++i)
                                    $root.google.cloud.compute.v1.RouterStatusBgpPeerStatus.encode(message.bgpPeerStatus[i], writer.uint32(/* id 218459131, wireType 2 =*/1747673050).fork()).ldelim();
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            if (message.bestRoutes != null && message.bestRoutes.length)
                                for (var i = 0; i < message.bestRoutes.length; ++i)
                                    $root.google.cloud.compute.v1.Route.encode(message.bestRoutes[i], writer.uint32(/* id 395826693, wireType 2 =*/3166613546).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RouterStatus message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RouterStatus.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RouterStatus
                         * @static
                         * @param {google.cloud.compute.v1.IRouterStatus} message RouterStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterStatus.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RouterStatus message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RouterStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RouterStatus} RouterStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterStatus.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RouterStatus();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 395826693: {
                                        if (!(message.bestRoutes && message.bestRoutes.length))
                                            message.bestRoutes = [];
                                        message.bestRoutes.push($root.google.cloud.compute.v1.Route.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 119389689: {
                                        if (!(message.bestRoutesForRouter && message.bestRoutesForRouter.length))
                                            message.bestRoutesForRouter = [];
                                        message.bestRoutesForRouter.push($root.google.cloud.compute.v1.Route.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 218459131: {
                                        if (!(message.bgpPeerStatus && message.bgpPeerStatus.length))
                                            message.bgpPeerStatus = [];
                                        message.bgpPeerStatus.push($root.google.cloud.compute.v1.RouterStatusBgpPeerStatus.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 63098064: {
                                        if (!(message.natStatus && message.natStatus.length))
                                            message.natStatus = [];
                                        message.natStatus.push($root.google.cloud.compute.v1.RouterStatusNatStatus.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RouterStatus message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RouterStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RouterStatus} RouterStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterStatus.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RouterStatus message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RouterStatus
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RouterStatus.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.bestRoutes != null && message.hasOwnProperty("bestRoutes")) {
                                if (!Array.isArray(message.bestRoutes))
                                    return "bestRoutes: array expected";
                                for (var i = 0; i < message.bestRoutes.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Route.verify(message.bestRoutes[i]);
                                    if (error)
                                        return "bestRoutes." + error;
                                }
                            }
                            if (message.bestRoutesForRouter != null && message.hasOwnProperty("bestRoutesForRouter")) {
                                if (!Array.isArray(message.bestRoutesForRouter))
                                    return "bestRoutesForRouter: array expected";
                                for (var i = 0; i < message.bestRoutesForRouter.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Route.verify(message.bestRoutesForRouter[i]);
                                    if (error)
                                        return "bestRoutesForRouter." + error;
                                }
                            }
                            if (message.bgpPeerStatus != null && message.hasOwnProperty("bgpPeerStatus")) {
                                if (!Array.isArray(message.bgpPeerStatus))
                                    return "bgpPeerStatus: array expected";
                                for (var i = 0; i < message.bgpPeerStatus.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.RouterStatusBgpPeerStatus.verify(message.bgpPeerStatus[i]);
                                    if (error)
                                        return "bgpPeerStatus." + error;
                                }
                            }
                            if (message.natStatus != null && message.hasOwnProperty("natStatus")) {
                                if (!Array.isArray(message.natStatus))
                                    return "natStatus: array expected";
                                for (var i = 0; i < message.natStatus.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.RouterStatusNatStatus.verify(message.natStatus[i]);
                                    if (error)
                                        return "natStatus." + error;
                                }
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                properties._network = 1;
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RouterStatus message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RouterStatus
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RouterStatus} RouterStatus
                         */
                        RouterStatus.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RouterStatus)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RouterStatus();
                            if (object.bestRoutes) {
                                if (!Array.isArray(object.bestRoutes))
                                    throw TypeError(".google.cloud.compute.v1.RouterStatus.bestRoutes: array expected");
                                message.bestRoutes = [];
                                for (var i = 0; i < object.bestRoutes.length; ++i) {
                                    if (typeof object.bestRoutes[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RouterStatus.bestRoutes: object expected");
                                    message.bestRoutes[i] = $root.google.cloud.compute.v1.Route.fromObject(object.bestRoutes[i]);
                                }
                            }
                            if (object.bestRoutesForRouter) {
                                if (!Array.isArray(object.bestRoutesForRouter))
                                    throw TypeError(".google.cloud.compute.v1.RouterStatus.bestRoutesForRouter: array expected");
                                message.bestRoutesForRouter = [];
                                for (var i = 0; i < object.bestRoutesForRouter.length; ++i) {
                                    if (typeof object.bestRoutesForRouter[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RouterStatus.bestRoutesForRouter: object expected");
                                    message.bestRoutesForRouter[i] = $root.google.cloud.compute.v1.Route.fromObject(object.bestRoutesForRouter[i]);
                                }
                            }
                            if (object.bgpPeerStatus) {
                                if (!Array.isArray(object.bgpPeerStatus))
                                    throw TypeError(".google.cloud.compute.v1.RouterStatus.bgpPeerStatus: array expected");
                                message.bgpPeerStatus = [];
                                for (var i = 0; i < object.bgpPeerStatus.length; ++i) {
                                    if (typeof object.bgpPeerStatus[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RouterStatus.bgpPeerStatus: object expected");
                                    message.bgpPeerStatus[i] = $root.google.cloud.compute.v1.RouterStatusBgpPeerStatus.fromObject(object.bgpPeerStatus[i]);
                                }
                            }
                            if (object.natStatus) {
                                if (!Array.isArray(object.natStatus))
                                    throw TypeError(".google.cloud.compute.v1.RouterStatus.natStatus: array expected");
                                message.natStatus = [];
                                for (var i = 0; i < object.natStatus.length; ++i) {
                                    if (typeof object.natStatus[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RouterStatus.natStatus: object expected");
                                    message.natStatus[i] = $root.google.cloud.compute.v1.RouterStatusNatStatus.fromObject(object.natStatus[i]);
                                }
                            }
                            if (object.network != null)
                                message.network = String(object.network);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RouterStatus message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RouterStatus
                         * @static
                         * @param {google.cloud.compute.v1.RouterStatus} message RouterStatus
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RouterStatus.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.natStatus = [];
                                object.bestRoutesForRouter = [];
                                object.bgpPeerStatus = [];
                                object.bestRoutes = [];
                            }
                            if (message.natStatus && message.natStatus.length) {
                                object.natStatus = [];
                                for (var j = 0; j < message.natStatus.length; ++j)
                                    object.natStatus[j] = $root.google.cloud.compute.v1.RouterStatusNatStatus.toObject(message.natStatus[j], options);
                            }
                            if (message.bestRoutesForRouter && message.bestRoutesForRouter.length) {
                                object.bestRoutesForRouter = [];
                                for (var j = 0; j < message.bestRoutesForRouter.length; ++j)
                                    object.bestRoutesForRouter[j] = $root.google.cloud.compute.v1.Route.toObject(message.bestRoutesForRouter[j], options);
                            }
                            if (message.bgpPeerStatus && message.bgpPeerStatus.length) {
                                object.bgpPeerStatus = [];
                                for (var j = 0; j < message.bgpPeerStatus.length; ++j)
                                    object.bgpPeerStatus[j] = $root.google.cloud.compute.v1.RouterStatusBgpPeerStatus.toObject(message.bgpPeerStatus[j], options);
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                object.network = message.network;
                                if (options.oneofs)
                                    object._network = "network";
                            }
                            if (message.bestRoutes && message.bestRoutes.length) {
                                object.bestRoutes = [];
                                for (var j = 0; j < message.bestRoutes.length; ++j)
                                    object.bestRoutes[j] = $root.google.cloud.compute.v1.Route.toObject(message.bestRoutes[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RouterStatus to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RouterStatus
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RouterStatus.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RouterStatus
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RouterStatus
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RouterStatus.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RouterStatus";
                        };
    
                        return RouterStatus;
                    })();
    
                    v1.RouterStatusBgpPeerStatus = (function() {
    
                        /**
                         * Properties of a RouterStatusBgpPeerStatus.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouterStatusBgpPeerStatus
                         * @property {Array.<google.cloud.compute.v1.IRoute>|null} [advertisedRoutes] RouterStatusBgpPeerStatus advertisedRoutes
                         * @property {google.cloud.compute.v1.IBfdStatus|null} [bfdStatus] RouterStatusBgpPeerStatus bfdStatus
                         * @property {boolean|null} [enableIpv6] RouterStatusBgpPeerStatus enableIpv6
                         * @property {string|null} [ipAddress] RouterStatusBgpPeerStatus ipAddress
                         * @property {string|null} [ipv6NexthopAddress] RouterStatusBgpPeerStatus ipv6NexthopAddress
                         * @property {string|null} [linkedVpnTunnel] RouterStatusBgpPeerStatus linkedVpnTunnel
                         * @property {boolean|null} [md5AuthEnabled] RouterStatusBgpPeerStatus md5AuthEnabled
                         * @property {string|null} [name] RouterStatusBgpPeerStatus name
                         * @property {number|null} [numLearnedRoutes] RouterStatusBgpPeerStatus numLearnedRoutes
                         * @property {string|null} [peerIpAddress] RouterStatusBgpPeerStatus peerIpAddress
                         * @property {string|null} [peerIpv6NexthopAddress] RouterStatusBgpPeerStatus peerIpv6NexthopAddress
                         * @property {string|null} [routerApplianceInstance] RouterStatusBgpPeerStatus routerApplianceInstance
                         * @property {string|null} [state] RouterStatusBgpPeerStatus state
                         * @property {string|null} [status] RouterStatusBgpPeerStatus status
                         * @property {string|null} [statusReason] RouterStatusBgpPeerStatus statusReason
                         * @property {string|null} [uptime] RouterStatusBgpPeerStatus uptime
                         * @property {string|null} [uptimeSeconds] RouterStatusBgpPeerStatus uptimeSeconds
                         */
    
                        /**
                         * Constructs a new RouterStatusBgpPeerStatus.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RouterStatusBgpPeerStatus.
                         * @implements IRouterStatusBgpPeerStatus
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouterStatusBgpPeerStatus=} [properties] Properties to set
                         */
                        function RouterStatusBgpPeerStatus(properties) {
                            this.advertisedRoutes = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RouterStatusBgpPeerStatus advertisedRoutes.
                         * @member {Array.<google.cloud.compute.v1.IRoute>} advertisedRoutes
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        RouterStatusBgpPeerStatus.prototype.advertisedRoutes = $util.emptyArray;
    
                        /**
                         * RouterStatusBgpPeerStatus bfdStatus.
                         * @member {google.cloud.compute.v1.IBfdStatus|null|undefined} bfdStatus
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        RouterStatusBgpPeerStatus.prototype.bfdStatus = null;
    
                        /**
                         * RouterStatusBgpPeerStatus enableIpv6.
                         * @member {boolean|null|undefined} enableIpv6
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        RouterStatusBgpPeerStatus.prototype.enableIpv6 = null;
    
                        /**
                         * RouterStatusBgpPeerStatus ipAddress.
                         * @member {string|null|undefined} ipAddress
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        RouterStatusBgpPeerStatus.prototype.ipAddress = null;
    
                        /**
                         * RouterStatusBgpPeerStatus ipv6NexthopAddress.
                         * @member {string|null|undefined} ipv6NexthopAddress
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        RouterStatusBgpPeerStatus.prototype.ipv6NexthopAddress = null;
    
                        /**
                         * RouterStatusBgpPeerStatus linkedVpnTunnel.
                         * @member {string|null|undefined} linkedVpnTunnel
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        RouterStatusBgpPeerStatus.prototype.linkedVpnTunnel = null;
    
                        /**
                         * RouterStatusBgpPeerStatus md5AuthEnabled.
                         * @member {boolean|null|undefined} md5AuthEnabled
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        RouterStatusBgpPeerStatus.prototype.md5AuthEnabled = null;
    
                        /**
                         * RouterStatusBgpPeerStatus name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        RouterStatusBgpPeerStatus.prototype.name = null;
    
                        /**
                         * RouterStatusBgpPeerStatus numLearnedRoutes.
                         * @member {number|null|undefined} numLearnedRoutes
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        RouterStatusBgpPeerStatus.prototype.numLearnedRoutes = null;
    
                        /**
                         * RouterStatusBgpPeerStatus peerIpAddress.
                         * @member {string|null|undefined} peerIpAddress
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        RouterStatusBgpPeerStatus.prototype.peerIpAddress = null;
    
                        /**
                         * RouterStatusBgpPeerStatus peerIpv6NexthopAddress.
                         * @member {string|null|undefined} peerIpv6NexthopAddress
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        RouterStatusBgpPeerStatus.prototype.peerIpv6NexthopAddress = null;
    
                        /**
                         * RouterStatusBgpPeerStatus routerApplianceInstance.
                         * @member {string|null|undefined} routerApplianceInstance
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        RouterStatusBgpPeerStatus.prototype.routerApplianceInstance = null;
    
                        /**
                         * RouterStatusBgpPeerStatus state.
                         * @member {string|null|undefined} state
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        RouterStatusBgpPeerStatus.prototype.state = null;
    
                        /**
                         * RouterStatusBgpPeerStatus status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        RouterStatusBgpPeerStatus.prototype.status = null;
    
                        /**
                         * RouterStatusBgpPeerStatus statusReason.
                         * @member {string|null|undefined} statusReason
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        RouterStatusBgpPeerStatus.prototype.statusReason = null;
    
                        /**
                         * RouterStatusBgpPeerStatus uptime.
                         * @member {string|null|undefined} uptime
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        RouterStatusBgpPeerStatus.prototype.uptime = null;
    
                        /**
                         * RouterStatusBgpPeerStatus uptimeSeconds.
                         * @member {string|null|undefined} uptimeSeconds
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        RouterStatusBgpPeerStatus.prototype.uptimeSeconds = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RouterStatusBgpPeerStatus _bfdStatus.
                         * @member {"bfdStatus"|undefined} _bfdStatus
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusBgpPeerStatus.prototype, "_bfdStatus", {
                            get: $util.oneOfGetter($oneOfFields = ["bfdStatus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterStatusBgpPeerStatus _enableIpv6.
                         * @member {"enableIpv6"|undefined} _enableIpv6
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusBgpPeerStatus.prototype, "_enableIpv6", {
                            get: $util.oneOfGetter($oneOfFields = ["enableIpv6"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterStatusBgpPeerStatus _ipAddress.
                         * @member {"ipAddress"|undefined} _ipAddress
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusBgpPeerStatus.prototype, "_ipAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["ipAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterStatusBgpPeerStatus _ipv6NexthopAddress.
                         * @member {"ipv6NexthopAddress"|undefined} _ipv6NexthopAddress
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusBgpPeerStatus.prototype, "_ipv6NexthopAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["ipv6NexthopAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterStatusBgpPeerStatus _linkedVpnTunnel.
                         * @member {"linkedVpnTunnel"|undefined} _linkedVpnTunnel
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusBgpPeerStatus.prototype, "_linkedVpnTunnel", {
                            get: $util.oneOfGetter($oneOfFields = ["linkedVpnTunnel"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterStatusBgpPeerStatus _md5AuthEnabled.
                         * @member {"md5AuthEnabled"|undefined} _md5AuthEnabled
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusBgpPeerStatus.prototype, "_md5AuthEnabled", {
                            get: $util.oneOfGetter($oneOfFields = ["md5AuthEnabled"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterStatusBgpPeerStatus _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusBgpPeerStatus.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterStatusBgpPeerStatus _numLearnedRoutes.
                         * @member {"numLearnedRoutes"|undefined} _numLearnedRoutes
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusBgpPeerStatus.prototype, "_numLearnedRoutes", {
                            get: $util.oneOfGetter($oneOfFields = ["numLearnedRoutes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterStatusBgpPeerStatus _peerIpAddress.
                         * @member {"peerIpAddress"|undefined} _peerIpAddress
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusBgpPeerStatus.prototype, "_peerIpAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["peerIpAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterStatusBgpPeerStatus _peerIpv6NexthopAddress.
                         * @member {"peerIpv6NexthopAddress"|undefined} _peerIpv6NexthopAddress
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusBgpPeerStatus.prototype, "_peerIpv6NexthopAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["peerIpv6NexthopAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterStatusBgpPeerStatus _routerApplianceInstance.
                         * @member {"routerApplianceInstance"|undefined} _routerApplianceInstance
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusBgpPeerStatus.prototype, "_routerApplianceInstance", {
                            get: $util.oneOfGetter($oneOfFields = ["routerApplianceInstance"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterStatusBgpPeerStatus _state.
                         * @member {"state"|undefined} _state
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusBgpPeerStatus.prototype, "_state", {
                            get: $util.oneOfGetter($oneOfFields = ["state"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterStatusBgpPeerStatus _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusBgpPeerStatus.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterStatusBgpPeerStatus _statusReason.
                         * @member {"statusReason"|undefined} _statusReason
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusBgpPeerStatus.prototype, "_statusReason", {
                            get: $util.oneOfGetter($oneOfFields = ["statusReason"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterStatusBgpPeerStatus _uptime.
                         * @member {"uptime"|undefined} _uptime
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusBgpPeerStatus.prototype, "_uptime", {
                            get: $util.oneOfGetter($oneOfFields = ["uptime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterStatusBgpPeerStatus _uptimeSeconds.
                         * @member {"uptimeSeconds"|undefined} _uptimeSeconds
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusBgpPeerStatus.prototype, "_uptimeSeconds", {
                            get: $util.oneOfGetter($oneOfFields = ["uptimeSeconds"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RouterStatusBgpPeerStatus instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @static
                         * @param {google.cloud.compute.v1.IRouterStatusBgpPeerStatus=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RouterStatusBgpPeerStatus} RouterStatusBgpPeerStatus instance
                         */
                        RouterStatusBgpPeerStatus.create = function create(properties) {
                            return new RouterStatusBgpPeerStatus(properties);
                        };
    
                        /**
                         * Encodes the specified RouterStatusBgpPeerStatus message. Does not implicitly {@link google.cloud.compute.v1.RouterStatusBgpPeerStatus.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @static
                         * @param {google.cloud.compute.v1.IRouterStatusBgpPeerStatus} message RouterStatusBgpPeerStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterStatusBgpPeerStatus.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.ipv6NexthopAddress != null && Object.hasOwnProperty.call(message, "ipv6NexthopAddress"))
                                writer.uint32(/* id 27968211, wireType 2 =*/223745690).string(message.ipv6NexthopAddress);
                            if (message.uptimeSeconds != null && Object.hasOwnProperty.call(message, "uptimeSeconds"))
                                writer.uint32(/* id 104736040, wireType 2 =*/837888322).string(message.uptimeSeconds);
                            if (message.state != null && Object.hasOwnProperty.call(message, "state"))
                                writer.uint32(/* id 109757585, wireType 2 =*/878060682).string(message.state);
                            if (message.numLearnedRoutes != null && Object.hasOwnProperty.call(message, "numLearnedRoutes"))
                                writer.uint32(/* id 135457535, wireType 0 =*/1083660280).uint32(message.numLearnedRoutes);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.enableIpv6 != null && Object.hasOwnProperty.call(message, "enableIpv6"))
                                writer.uint32(/* id 181467939, wireType 0 =*/1451743512).bool(message.enableIpv6);
                            if (message.peerIpAddress != null && Object.hasOwnProperty.call(message, "peerIpAddress"))
                                writer.uint32(/* id 207735769, wireType 2 =*/1661886154).string(message.peerIpAddress);
                            if (message.uptime != null && Object.hasOwnProperty.call(message, "uptime"))
                                writer.uint32(/* id 235379688, wireType 2 =*/1883037506).string(message.uptime);
                            if (message.advertisedRoutes != null && message.advertisedRoutes.length)
                                for (var i = 0; i < message.advertisedRoutes.length; ++i)
                                    $root.google.cloud.compute.v1.Route.encode(message.advertisedRoutes[i], writer.uint32(/* id 333393068, wireType 2 =*/2667144546).fork()).ldelim();
                            if (message.statusReason != null && Object.hasOwnProperty.call(message, "statusReason"))
                                writer.uint32(/* id 342706993, wireType 2 =*/2741655946).string(message.statusReason);
                            if (message.linkedVpnTunnel != null && Object.hasOwnProperty.call(message, "linkedVpnTunnel"))
                                writer.uint32(/* id 352296953, wireType 2 =*/2818375626).string(message.linkedVpnTunnel);
                            if (message.bfdStatus != null && Object.hasOwnProperty.call(message, "bfdStatus"))
                                $root.google.cloud.compute.v1.BfdStatus.encode(message.bfdStatus, writer.uint32(/* id 395631729, wireType 2 =*/3165053834).fork()).ldelim();
                            if (message.ipAddress != null && Object.hasOwnProperty.call(message, "ipAddress"))
                                writer.uint32(/* id 406272220, wireType 2 =*/3250177762).string(message.ipAddress);
                            if (message.md5AuthEnabled != null && Object.hasOwnProperty.call(message, "md5AuthEnabled"))
                                writer.uint32(/* id 451152075, wireType 0 =*/3609216600).bool(message.md5AuthEnabled);
                            if (message.routerApplianceInstance != null && Object.hasOwnProperty.call(message, "routerApplianceInstance"))
                                writer.uint32(/* id 468312989, wireType 2 =*/3746503914).string(message.routerApplianceInstance);
                            if (message.peerIpv6NexthopAddress != null && Object.hasOwnProperty.call(message, "peerIpv6NexthopAddress"))
                                writer.uint32(/* id 491486608, wireType 2 =*/3931892866).string(message.peerIpv6NexthopAddress);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RouterStatusBgpPeerStatus message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RouterStatusBgpPeerStatus.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @static
                         * @param {google.cloud.compute.v1.IRouterStatusBgpPeerStatus} message RouterStatusBgpPeerStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterStatusBgpPeerStatus.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RouterStatusBgpPeerStatus message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RouterStatusBgpPeerStatus} RouterStatusBgpPeerStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterStatusBgpPeerStatus.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RouterStatusBgpPeerStatus();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 333393068: {
                                        if (!(message.advertisedRoutes && message.advertisedRoutes.length))
                                            message.advertisedRoutes = [];
                                        message.advertisedRoutes.push($root.google.cloud.compute.v1.Route.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 395631729: {
                                        message.bfdStatus = $root.google.cloud.compute.v1.BfdStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 181467939: {
                                        message.enableIpv6 = reader.bool();
                                        break;
                                    }
                                case 406272220: {
                                        message.ipAddress = reader.string();
                                        break;
                                    }
                                case 27968211: {
                                        message.ipv6NexthopAddress = reader.string();
                                        break;
                                    }
                                case 352296953: {
                                        message.linkedVpnTunnel = reader.string();
                                        break;
                                    }
                                case 451152075: {
                                        message.md5AuthEnabled = reader.bool();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 135457535: {
                                        message.numLearnedRoutes = reader.uint32();
                                        break;
                                    }
                                case 207735769: {
                                        message.peerIpAddress = reader.string();
                                        break;
                                    }
                                case 491486608: {
                                        message.peerIpv6NexthopAddress = reader.string();
                                        break;
                                    }
                                case 468312989: {
                                        message.routerApplianceInstance = reader.string();
                                        break;
                                    }
                                case 109757585: {
                                        message.state = reader.string();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                case 342706993: {
                                        message.statusReason = reader.string();
                                        break;
                                    }
                                case 235379688: {
                                        message.uptime = reader.string();
                                        break;
                                    }
                                case 104736040: {
                                        message.uptimeSeconds = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RouterStatusBgpPeerStatus message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RouterStatusBgpPeerStatus} RouterStatusBgpPeerStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterStatusBgpPeerStatus.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RouterStatusBgpPeerStatus message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RouterStatusBgpPeerStatus.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.advertisedRoutes != null && message.hasOwnProperty("advertisedRoutes")) {
                                if (!Array.isArray(message.advertisedRoutes))
                                    return "advertisedRoutes: array expected";
                                for (var i = 0; i < message.advertisedRoutes.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Route.verify(message.advertisedRoutes[i]);
                                    if (error)
                                        return "advertisedRoutes." + error;
                                }
                            }
                            if (message.bfdStatus != null && message.hasOwnProperty("bfdStatus")) {
                                properties._bfdStatus = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.BfdStatus.verify(message.bfdStatus);
                                    if (error)
                                        return "bfdStatus." + error;
                                }
                            }
                            if (message.enableIpv6 != null && message.hasOwnProperty("enableIpv6")) {
                                properties._enableIpv6 = 1;
                                if (typeof message.enableIpv6 !== "boolean")
                                    return "enableIpv6: boolean expected";
                            }
                            if (message.ipAddress != null && message.hasOwnProperty("ipAddress")) {
                                properties._ipAddress = 1;
                                if (!$util.isString(message.ipAddress))
                                    return "ipAddress: string expected";
                            }
                            if (message.ipv6NexthopAddress != null && message.hasOwnProperty("ipv6NexthopAddress")) {
                                properties._ipv6NexthopAddress = 1;
                                if (!$util.isString(message.ipv6NexthopAddress))
                                    return "ipv6NexthopAddress: string expected";
                            }
                            if (message.linkedVpnTunnel != null && message.hasOwnProperty("linkedVpnTunnel")) {
                                properties._linkedVpnTunnel = 1;
                                if (!$util.isString(message.linkedVpnTunnel))
                                    return "linkedVpnTunnel: string expected";
                            }
                            if (message.md5AuthEnabled != null && message.hasOwnProperty("md5AuthEnabled")) {
                                properties._md5AuthEnabled = 1;
                                if (typeof message.md5AuthEnabled !== "boolean")
                                    return "md5AuthEnabled: boolean expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.numLearnedRoutes != null && message.hasOwnProperty("numLearnedRoutes")) {
                                properties._numLearnedRoutes = 1;
                                if (!$util.isInteger(message.numLearnedRoutes))
                                    return "numLearnedRoutes: integer expected";
                            }
                            if (message.peerIpAddress != null && message.hasOwnProperty("peerIpAddress")) {
                                properties._peerIpAddress = 1;
                                if (!$util.isString(message.peerIpAddress))
                                    return "peerIpAddress: string expected";
                            }
                            if (message.peerIpv6NexthopAddress != null && message.hasOwnProperty("peerIpv6NexthopAddress")) {
                                properties._peerIpv6NexthopAddress = 1;
                                if (!$util.isString(message.peerIpv6NexthopAddress))
                                    return "peerIpv6NexthopAddress: string expected";
                            }
                            if (message.routerApplianceInstance != null && message.hasOwnProperty("routerApplianceInstance")) {
                                properties._routerApplianceInstance = 1;
                                if (!$util.isString(message.routerApplianceInstance))
                                    return "routerApplianceInstance: string expected";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                properties._state = 1;
                                if (!$util.isString(message.state))
                                    return "state: string expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            if (message.statusReason != null && message.hasOwnProperty("statusReason")) {
                                properties._statusReason = 1;
                                if (!$util.isString(message.statusReason))
                                    return "statusReason: string expected";
                            }
                            if (message.uptime != null && message.hasOwnProperty("uptime")) {
                                properties._uptime = 1;
                                if (!$util.isString(message.uptime))
                                    return "uptime: string expected";
                            }
                            if (message.uptimeSeconds != null && message.hasOwnProperty("uptimeSeconds")) {
                                properties._uptimeSeconds = 1;
                                if (!$util.isString(message.uptimeSeconds))
                                    return "uptimeSeconds: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RouterStatusBgpPeerStatus message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RouterStatusBgpPeerStatus} RouterStatusBgpPeerStatus
                         */
                        RouterStatusBgpPeerStatus.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RouterStatusBgpPeerStatus)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RouterStatusBgpPeerStatus();
                            if (object.advertisedRoutes) {
                                if (!Array.isArray(object.advertisedRoutes))
                                    throw TypeError(".google.cloud.compute.v1.RouterStatusBgpPeerStatus.advertisedRoutes: array expected");
                                message.advertisedRoutes = [];
                                for (var i = 0; i < object.advertisedRoutes.length; ++i) {
                                    if (typeof object.advertisedRoutes[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RouterStatusBgpPeerStatus.advertisedRoutes: object expected");
                                    message.advertisedRoutes[i] = $root.google.cloud.compute.v1.Route.fromObject(object.advertisedRoutes[i]);
                                }
                            }
                            if (object.bfdStatus != null) {
                                if (typeof object.bfdStatus !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RouterStatusBgpPeerStatus.bfdStatus: object expected");
                                message.bfdStatus = $root.google.cloud.compute.v1.BfdStatus.fromObject(object.bfdStatus);
                            }
                            if (object.enableIpv6 != null)
                                message.enableIpv6 = Boolean(object.enableIpv6);
                            if (object.ipAddress != null)
                                message.ipAddress = String(object.ipAddress);
                            if (object.ipv6NexthopAddress != null)
                                message.ipv6NexthopAddress = String(object.ipv6NexthopAddress);
                            if (object.linkedVpnTunnel != null)
                                message.linkedVpnTunnel = String(object.linkedVpnTunnel);
                            if (object.md5AuthEnabled != null)
                                message.md5AuthEnabled = Boolean(object.md5AuthEnabled);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.numLearnedRoutes != null)
                                message.numLearnedRoutes = object.numLearnedRoutes >>> 0;
                            if (object.peerIpAddress != null)
                                message.peerIpAddress = String(object.peerIpAddress);
                            if (object.peerIpv6NexthopAddress != null)
                                message.peerIpv6NexthopAddress = String(object.peerIpv6NexthopAddress);
                            if (object.routerApplianceInstance != null)
                                message.routerApplianceInstance = String(object.routerApplianceInstance);
                            if (object.state != null)
                                message.state = String(object.state);
                            if (object.status != null)
                                message.status = String(object.status);
                            if (object.statusReason != null)
                                message.statusReason = String(object.statusReason);
                            if (object.uptime != null)
                                message.uptime = String(object.uptime);
                            if (object.uptimeSeconds != null)
                                message.uptimeSeconds = String(object.uptimeSeconds);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RouterStatusBgpPeerStatus message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @static
                         * @param {google.cloud.compute.v1.RouterStatusBgpPeerStatus} message RouterStatusBgpPeerStatus
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RouterStatusBgpPeerStatus.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.advertisedRoutes = [];
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.ipv6NexthopAddress != null && message.hasOwnProperty("ipv6NexthopAddress")) {
                                object.ipv6NexthopAddress = message.ipv6NexthopAddress;
                                if (options.oneofs)
                                    object._ipv6NexthopAddress = "ipv6NexthopAddress";
                            }
                            if (message.uptimeSeconds != null && message.hasOwnProperty("uptimeSeconds")) {
                                object.uptimeSeconds = message.uptimeSeconds;
                                if (options.oneofs)
                                    object._uptimeSeconds = "uptimeSeconds";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                object.state = message.state;
                                if (options.oneofs)
                                    object._state = "state";
                            }
                            if (message.numLearnedRoutes != null && message.hasOwnProperty("numLearnedRoutes")) {
                                object.numLearnedRoutes = message.numLearnedRoutes;
                                if (options.oneofs)
                                    object._numLearnedRoutes = "numLearnedRoutes";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.enableIpv6 != null && message.hasOwnProperty("enableIpv6")) {
                                object.enableIpv6 = message.enableIpv6;
                                if (options.oneofs)
                                    object._enableIpv6 = "enableIpv6";
                            }
                            if (message.peerIpAddress != null && message.hasOwnProperty("peerIpAddress")) {
                                object.peerIpAddress = message.peerIpAddress;
                                if (options.oneofs)
                                    object._peerIpAddress = "peerIpAddress";
                            }
                            if (message.uptime != null && message.hasOwnProperty("uptime")) {
                                object.uptime = message.uptime;
                                if (options.oneofs)
                                    object._uptime = "uptime";
                            }
                            if (message.advertisedRoutes && message.advertisedRoutes.length) {
                                object.advertisedRoutes = [];
                                for (var j = 0; j < message.advertisedRoutes.length; ++j)
                                    object.advertisedRoutes[j] = $root.google.cloud.compute.v1.Route.toObject(message.advertisedRoutes[j], options);
                            }
                            if (message.statusReason != null && message.hasOwnProperty("statusReason")) {
                                object.statusReason = message.statusReason;
                                if (options.oneofs)
                                    object._statusReason = "statusReason";
                            }
                            if (message.linkedVpnTunnel != null && message.hasOwnProperty("linkedVpnTunnel")) {
                                object.linkedVpnTunnel = message.linkedVpnTunnel;
                                if (options.oneofs)
                                    object._linkedVpnTunnel = "linkedVpnTunnel";
                            }
                            if (message.bfdStatus != null && message.hasOwnProperty("bfdStatus")) {
                                object.bfdStatus = $root.google.cloud.compute.v1.BfdStatus.toObject(message.bfdStatus, options);
                                if (options.oneofs)
                                    object._bfdStatus = "bfdStatus";
                            }
                            if (message.ipAddress != null && message.hasOwnProperty("ipAddress")) {
                                object.ipAddress = message.ipAddress;
                                if (options.oneofs)
                                    object._ipAddress = "ipAddress";
                            }
                            if (message.md5AuthEnabled != null && message.hasOwnProperty("md5AuthEnabled")) {
                                object.md5AuthEnabled = message.md5AuthEnabled;
                                if (options.oneofs)
                                    object._md5AuthEnabled = "md5AuthEnabled";
                            }
                            if (message.routerApplianceInstance != null && message.hasOwnProperty("routerApplianceInstance")) {
                                object.routerApplianceInstance = message.routerApplianceInstance;
                                if (options.oneofs)
                                    object._routerApplianceInstance = "routerApplianceInstance";
                            }
                            if (message.peerIpv6NexthopAddress != null && message.hasOwnProperty("peerIpv6NexthopAddress")) {
                                object.peerIpv6NexthopAddress = message.peerIpv6NexthopAddress;
                                if (options.oneofs)
                                    object._peerIpv6NexthopAddress = "peerIpv6NexthopAddress";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RouterStatusBgpPeerStatus to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RouterStatusBgpPeerStatus.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RouterStatusBgpPeerStatus
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RouterStatusBgpPeerStatus
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RouterStatusBgpPeerStatus.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RouterStatusBgpPeerStatus";
                        };
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.RouterStatusBgpPeerStatus.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} DOWN=2104482 DOWN value
                         * @property {number} UNKNOWN=433141802 UNKNOWN value
                         * @property {number} UP=2715 UP value
                         */
                        RouterStatusBgpPeerStatus.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[2104482] = "DOWN"] = 2104482;
                            values[valuesById[433141802] = "UNKNOWN"] = 433141802;
                            values[valuesById[2715] = "UP"] = 2715;
                            return values;
                        })();
    
                        /**
                         * StatusReason enum.
                         * @name google.cloud.compute.v1.RouterStatusBgpPeerStatus.StatusReason
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS_REASON=0 UNDEFINED_STATUS_REASON value
                         * @property {number} MD5_AUTH_INTERNAL_PROBLEM=140462259 MD5_AUTH_INTERNAL_PROBLEM value
                         * @property {number} STATUS_REASON_UNSPECIFIED=394331913 STATUS_REASON_UNSPECIFIED value
                         */
                        RouterStatusBgpPeerStatus.StatusReason = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS_REASON"] = 0;
                            values[valuesById[140462259] = "MD5_AUTH_INTERNAL_PROBLEM"] = 140462259;
                            values[valuesById[394331913] = "STATUS_REASON_UNSPECIFIED"] = 394331913;
                            return values;
                        })();
    
                        return RouterStatusBgpPeerStatus;
                    })();
    
                    v1.RouterStatusNatStatus = (function() {
    
                        /**
                         * Properties of a RouterStatusNatStatus.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouterStatusNatStatus
                         * @property {Array.<string>|null} [autoAllocatedNatIps] RouterStatusNatStatus autoAllocatedNatIps
                         * @property {Array.<string>|null} [drainAutoAllocatedNatIps] RouterStatusNatStatus drainAutoAllocatedNatIps
                         * @property {Array.<string>|null} [drainUserAllocatedNatIps] RouterStatusNatStatus drainUserAllocatedNatIps
                         * @property {number|null} [minExtraNatIpsNeeded] RouterStatusNatStatus minExtraNatIpsNeeded
                         * @property {string|null} [name] RouterStatusNatStatus name
                         * @property {number|null} [numVmEndpointsWithNatMappings] RouterStatusNatStatus numVmEndpointsWithNatMappings
                         * @property {Array.<google.cloud.compute.v1.IRouterStatusNatStatusNatRuleStatus>|null} [ruleStatus] RouterStatusNatStatus ruleStatus
                         * @property {Array.<string>|null} [userAllocatedNatIpResources] RouterStatusNatStatus userAllocatedNatIpResources
                         * @property {Array.<string>|null} [userAllocatedNatIps] RouterStatusNatStatus userAllocatedNatIps
                         */
    
                        /**
                         * Constructs a new RouterStatusNatStatus.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RouterStatusNatStatus.
                         * @implements IRouterStatusNatStatus
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouterStatusNatStatus=} [properties] Properties to set
                         */
                        function RouterStatusNatStatus(properties) {
                            this.autoAllocatedNatIps = [];
                            this.drainAutoAllocatedNatIps = [];
                            this.drainUserAllocatedNatIps = [];
                            this.ruleStatus = [];
                            this.userAllocatedNatIpResources = [];
                            this.userAllocatedNatIps = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RouterStatusNatStatus autoAllocatedNatIps.
                         * @member {Array.<string>} autoAllocatedNatIps
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @instance
                         */
                        RouterStatusNatStatus.prototype.autoAllocatedNatIps = $util.emptyArray;
    
                        /**
                         * RouterStatusNatStatus drainAutoAllocatedNatIps.
                         * @member {Array.<string>} drainAutoAllocatedNatIps
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @instance
                         */
                        RouterStatusNatStatus.prototype.drainAutoAllocatedNatIps = $util.emptyArray;
    
                        /**
                         * RouterStatusNatStatus drainUserAllocatedNatIps.
                         * @member {Array.<string>} drainUserAllocatedNatIps
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @instance
                         */
                        RouterStatusNatStatus.prototype.drainUserAllocatedNatIps = $util.emptyArray;
    
                        /**
                         * RouterStatusNatStatus minExtraNatIpsNeeded.
                         * @member {number|null|undefined} minExtraNatIpsNeeded
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @instance
                         */
                        RouterStatusNatStatus.prototype.minExtraNatIpsNeeded = null;
    
                        /**
                         * RouterStatusNatStatus name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @instance
                         */
                        RouterStatusNatStatus.prototype.name = null;
    
                        /**
                         * RouterStatusNatStatus numVmEndpointsWithNatMappings.
                         * @member {number|null|undefined} numVmEndpointsWithNatMappings
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @instance
                         */
                        RouterStatusNatStatus.prototype.numVmEndpointsWithNatMappings = null;
    
                        /**
                         * RouterStatusNatStatus ruleStatus.
                         * @member {Array.<google.cloud.compute.v1.IRouterStatusNatStatusNatRuleStatus>} ruleStatus
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @instance
                         */
                        RouterStatusNatStatus.prototype.ruleStatus = $util.emptyArray;
    
                        /**
                         * RouterStatusNatStatus userAllocatedNatIpResources.
                         * @member {Array.<string>} userAllocatedNatIpResources
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @instance
                         */
                        RouterStatusNatStatus.prototype.userAllocatedNatIpResources = $util.emptyArray;
    
                        /**
                         * RouterStatusNatStatus userAllocatedNatIps.
                         * @member {Array.<string>} userAllocatedNatIps
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @instance
                         */
                        RouterStatusNatStatus.prototype.userAllocatedNatIps = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RouterStatusNatStatus _minExtraNatIpsNeeded.
                         * @member {"minExtraNatIpsNeeded"|undefined} _minExtraNatIpsNeeded
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusNatStatus.prototype, "_minExtraNatIpsNeeded", {
                            get: $util.oneOfGetter($oneOfFields = ["minExtraNatIpsNeeded"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterStatusNatStatus _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusNatStatus.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterStatusNatStatus _numVmEndpointsWithNatMappings.
                         * @member {"numVmEndpointsWithNatMappings"|undefined} _numVmEndpointsWithNatMappings
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusNatStatus.prototype, "_numVmEndpointsWithNatMappings", {
                            get: $util.oneOfGetter($oneOfFields = ["numVmEndpointsWithNatMappings"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RouterStatusNatStatus instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @static
                         * @param {google.cloud.compute.v1.IRouterStatusNatStatus=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RouterStatusNatStatus} RouterStatusNatStatus instance
                         */
                        RouterStatusNatStatus.create = function create(properties) {
                            return new RouterStatusNatStatus(properties);
                        };
    
                        /**
                         * Encodes the specified RouterStatusNatStatus message. Does not implicitly {@link google.cloud.compute.v1.RouterStatusNatStatus.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @static
                         * @param {google.cloud.compute.v1.IRouterStatusNatStatus} message RouterStatusNatStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterStatusNatStatus.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.ruleStatus != null && message.ruleStatus.length)
                                for (var i = 0; i < message.ruleStatus.length; ++i)
                                    $root.google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus.encode(message.ruleStatus[i], writer.uint32(/* id 140223125, wireType 2 =*/1121785002).fork()).ldelim();
                            if (message.userAllocatedNatIpResources != null && message.userAllocatedNatIpResources.length)
                                for (var i = 0; i < message.userAllocatedNatIpResources.length; ++i)
                                    writer.uint32(/* id 212776151, wireType 2 =*/1702209210).string(message.userAllocatedNatIpResources[i]);
                            if (message.drainUserAllocatedNatIps != null && message.drainUserAllocatedNatIps.length)
                                for (var i = 0; i < message.drainUserAllocatedNatIps.length; ++i)
                                    writer.uint32(/* id 305268553, wireType 2 =*/2442148426).string(message.drainUserAllocatedNatIps[i]);
                            if (message.drainAutoAllocatedNatIps != null && message.drainAutoAllocatedNatIps.length)
                                for (var i = 0; i < message.drainAutoAllocatedNatIps.length; ++i)
                                    writer.uint32(/* id 309184557, wireType 2 =*/2473476458).string(message.drainAutoAllocatedNatIps[i]);
                            if (message.minExtraNatIpsNeeded != null && Object.hasOwnProperty.call(message, "minExtraNatIpsNeeded"))
                                writer.uint32(/* id 365786338, wireType 0 =*/2926290704).int32(message.minExtraNatIpsNeeded);
                            if (message.userAllocatedNatIps != null && message.userAllocatedNatIps.length)
                                for (var i = 0; i < message.userAllocatedNatIps.length; ++i)
                                    writer.uint32(/* id 506878242, wireType 2 =*/4055025938).string(message.userAllocatedNatIps[i]);
                            if (message.autoAllocatedNatIps != null && message.autoAllocatedNatIps.length)
                                for (var i = 0; i < message.autoAllocatedNatIps.length; ++i)
                                    writer.uint32(/* id 510794246, wireType 2 =*/4086353970).string(message.autoAllocatedNatIps[i]);
                            if (message.numVmEndpointsWithNatMappings != null && Object.hasOwnProperty.call(message, "numVmEndpointsWithNatMappings"))
                                writer.uint32(/* id 512367468, wireType 0 =*/4098939744).int32(message.numVmEndpointsWithNatMappings);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RouterStatusNatStatus message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RouterStatusNatStatus.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @static
                         * @param {google.cloud.compute.v1.IRouterStatusNatStatus} message RouterStatusNatStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterStatusNatStatus.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RouterStatusNatStatus message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RouterStatusNatStatus} RouterStatusNatStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterStatusNatStatus.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RouterStatusNatStatus();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 510794246: {
                                        if (!(message.autoAllocatedNatIps && message.autoAllocatedNatIps.length))
                                            message.autoAllocatedNatIps = [];
                                        message.autoAllocatedNatIps.push(reader.string());
                                        break;
                                    }
                                case 309184557: {
                                        if (!(message.drainAutoAllocatedNatIps && message.drainAutoAllocatedNatIps.length))
                                            message.drainAutoAllocatedNatIps = [];
                                        message.drainAutoAllocatedNatIps.push(reader.string());
                                        break;
                                    }
                                case 305268553: {
                                        if (!(message.drainUserAllocatedNatIps && message.drainUserAllocatedNatIps.length))
                                            message.drainUserAllocatedNatIps = [];
                                        message.drainUserAllocatedNatIps.push(reader.string());
                                        break;
                                    }
                                case 365786338: {
                                        message.minExtraNatIpsNeeded = reader.int32();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 512367468: {
                                        message.numVmEndpointsWithNatMappings = reader.int32();
                                        break;
                                    }
                                case 140223125: {
                                        if (!(message.ruleStatus && message.ruleStatus.length))
                                            message.ruleStatus = [];
                                        message.ruleStatus.push($root.google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 212776151: {
                                        if (!(message.userAllocatedNatIpResources && message.userAllocatedNatIpResources.length))
                                            message.userAllocatedNatIpResources = [];
                                        message.userAllocatedNatIpResources.push(reader.string());
                                        break;
                                    }
                                case 506878242: {
                                        if (!(message.userAllocatedNatIps && message.userAllocatedNatIps.length))
                                            message.userAllocatedNatIps = [];
                                        message.userAllocatedNatIps.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RouterStatusNatStatus message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RouterStatusNatStatus} RouterStatusNatStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterStatusNatStatus.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RouterStatusNatStatus message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RouterStatusNatStatus.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoAllocatedNatIps != null && message.hasOwnProperty("autoAllocatedNatIps")) {
                                if (!Array.isArray(message.autoAllocatedNatIps))
                                    return "autoAllocatedNatIps: array expected";
                                for (var i = 0; i < message.autoAllocatedNatIps.length; ++i)
                                    if (!$util.isString(message.autoAllocatedNatIps[i]))
                                        return "autoAllocatedNatIps: string[] expected";
                            }
                            if (message.drainAutoAllocatedNatIps != null && message.hasOwnProperty("drainAutoAllocatedNatIps")) {
                                if (!Array.isArray(message.drainAutoAllocatedNatIps))
                                    return "drainAutoAllocatedNatIps: array expected";
                                for (var i = 0; i < message.drainAutoAllocatedNatIps.length; ++i)
                                    if (!$util.isString(message.drainAutoAllocatedNatIps[i]))
                                        return "drainAutoAllocatedNatIps: string[] expected";
                            }
                            if (message.drainUserAllocatedNatIps != null && message.hasOwnProperty("drainUserAllocatedNatIps")) {
                                if (!Array.isArray(message.drainUserAllocatedNatIps))
                                    return "drainUserAllocatedNatIps: array expected";
                                for (var i = 0; i < message.drainUserAllocatedNatIps.length; ++i)
                                    if (!$util.isString(message.drainUserAllocatedNatIps[i]))
                                        return "drainUserAllocatedNatIps: string[] expected";
                            }
                            if (message.minExtraNatIpsNeeded != null && message.hasOwnProperty("minExtraNatIpsNeeded")) {
                                properties._minExtraNatIpsNeeded = 1;
                                if (!$util.isInteger(message.minExtraNatIpsNeeded))
                                    return "minExtraNatIpsNeeded: integer expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.numVmEndpointsWithNatMappings != null && message.hasOwnProperty("numVmEndpointsWithNatMappings")) {
                                properties._numVmEndpointsWithNatMappings = 1;
                                if (!$util.isInteger(message.numVmEndpointsWithNatMappings))
                                    return "numVmEndpointsWithNatMappings: integer expected";
                            }
                            if (message.ruleStatus != null && message.hasOwnProperty("ruleStatus")) {
                                if (!Array.isArray(message.ruleStatus))
                                    return "ruleStatus: array expected";
                                for (var i = 0; i < message.ruleStatus.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus.verify(message.ruleStatus[i]);
                                    if (error)
                                        return "ruleStatus." + error;
                                }
                            }
                            if (message.userAllocatedNatIpResources != null && message.hasOwnProperty("userAllocatedNatIpResources")) {
                                if (!Array.isArray(message.userAllocatedNatIpResources))
                                    return "userAllocatedNatIpResources: array expected";
                                for (var i = 0; i < message.userAllocatedNatIpResources.length; ++i)
                                    if (!$util.isString(message.userAllocatedNatIpResources[i]))
                                        return "userAllocatedNatIpResources: string[] expected";
                            }
                            if (message.userAllocatedNatIps != null && message.hasOwnProperty("userAllocatedNatIps")) {
                                if (!Array.isArray(message.userAllocatedNatIps))
                                    return "userAllocatedNatIps: array expected";
                                for (var i = 0; i < message.userAllocatedNatIps.length; ++i)
                                    if (!$util.isString(message.userAllocatedNatIps[i]))
                                        return "userAllocatedNatIps: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RouterStatusNatStatus message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RouterStatusNatStatus} RouterStatusNatStatus
                         */
                        RouterStatusNatStatus.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RouterStatusNatStatus)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RouterStatusNatStatus();
                            if (object.autoAllocatedNatIps) {
                                if (!Array.isArray(object.autoAllocatedNatIps))
                                    throw TypeError(".google.cloud.compute.v1.RouterStatusNatStatus.autoAllocatedNatIps: array expected");
                                message.autoAllocatedNatIps = [];
                                for (var i = 0; i < object.autoAllocatedNatIps.length; ++i)
                                    message.autoAllocatedNatIps[i] = String(object.autoAllocatedNatIps[i]);
                            }
                            if (object.drainAutoAllocatedNatIps) {
                                if (!Array.isArray(object.drainAutoAllocatedNatIps))
                                    throw TypeError(".google.cloud.compute.v1.RouterStatusNatStatus.drainAutoAllocatedNatIps: array expected");
                                message.drainAutoAllocatedNatIps = [];
                                for (var i = 0; i < object.drainAutoAllocatedNatIps.length; ++i)
                                    message.drainAutoAllocatedNatIps[i] = String(object.drainAutoAllocatedNatIps[i]);
                            }
                            if (object.drainUserAllocatedNatIps) {
                                if (!Array.isArray(object.drainUserAllocatedNatIps))
                                    throw TypeError(".google.cloud.compute.v1.RouterStatusNatStatus.drainUserAllocatedNatIps: array expected");
                                message.drainUserAllocatedNatIps = [];
                                for (var i = 0; i < object.drainUserAllocatedNatIps.length; ++i)
                                    message.drainUserAllocatedNatIps[i] = String(object.drainUserAllocatedNatIps[i]);
                            }
                            if (object.minExtraNatIpsNeeded != null)
                                message.minExtraNatIpsNeeded = object.minExtraNatIpsNeeded | 0;
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.numVmEndpointsWithNatMappings != null)
                                message.numVmEndpointsWithNatMappings = object.numVmEndpointsWithNatMappings | 0;
                            if (object.ruleStatus) {
                                if (!Array.isArray(object.ruleStatus))
                                    throw TypeError(".google.cloud.compute.v1.RouterStatusNatStatus.ruleStatus: array expected");
                                message.ruleStatus = [];
                                for (var i = 0; i < object.ruleStatus.length; ++i) {
                                    if (typeof object.ruleStatus[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RouterStatusNatStatus.ruleStatus: object expected");
                                    message.ruleStatus[i] = $root.google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus.fromObject(object.ruleStatus[i]);
                                }
                            }
                            if (object.userAllocatedNatIpResources) {
                                if (!Array.isArray(object.userAllocatedNatIpResources))
                                    throw TypeError(".google.cloud.compute.v1.RouterStatusNatStatus.userAllocatedNatIpResources: array expected");
                                message.userAllocatedNatIpResources = [];
                                for (var i = 0; i < object.userAllocatedNatIpResources.length; ++i)
                                    message.userAllocatedNatIpResources[i] = String(object.userAllocatedNatIpResources[i]);
                            }
                            if (object.userAllocatedNatIps) {
                                if (!Array.isArray(object.userAllocatedNatIps))
                                    throw TypeError(".google.cloud.compute.v1.RouterStatusNatStatus.userAllocatedNatIps: array expected");
                                message.userAllocatedNatIps = [];
                                for (var i = 0; i < object.userAllocatedNatIps.length; ++i)
                                    message.userAllocatedNatIps[i] = String(object.userAllocatedNatIps[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RouterStatusNatStatus message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @static
                         * @param {google.cloud.compute.v1.RouterStatusNatStatus} message RouterStatusNatStatus
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RouterStatusNatStatus.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.ruleStatus = [];
                                object.userAllocatedNatIpResources = [];
                                object.drainUserAllocatedNatIps = [];
                                object.drainAutoAllocatedNatIps = [];
                                object.userAllocatedNatIps = [];
                                object.autoAllocatedNatIps = [];
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.ruleStatus && message.ruleStatus.length) {
                                object.ruleStatus = [];
                                for (var j = 0; j < message.ruleStatus.length; ++j)
                                    object.ruleStatus[j] = $root.google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus.toObject(message.ruleStatus[j], options);
                            }
                            if (message.userAllocatedNatIpResources && message.userAllocatedNatIpResources.length) {
                                object.userAllocatedNatIpResources = [];
                                for (var j = 0; j < message.userAllocatedNatIpResources.length; ++j)
                                    object.userAllocatedNatIpResources[j] = message.userAllocatedNatIpResources[j];
                            }
                            if (message.drainUserAllocatedNatIps && message.drainUserAllocatedNatIps.length) {
                                object.drainUserAllocatedNatIps = [];
                                for (var j = 0; j < message.drainUserAllocatedNatIps.length; ++j)
                                    object.drainUserAllocatedNatIps[j] = message.drainUserAllocatedNatIps[j];
                            }
                            if (message.drainAutoAllocatedNatIps && message.drainAutoAllocatedNatIps.length) {
                                object.drainAutoAllocatedNatIps = [];
                                for (var j = 0; j < message.drainAutoAllocatedNatIps.length; ++j)
                                    object.drainAutoAllocatedNatIps[j] = message.drainAutoAllocatedNatIps[j];
                            }
                            if (message.minExtraNatIpsNeeded != null && message.hasOwnProperty("minExtraNatIpsNeeded")) {
                                object.minExtraNatIpsNeeded = message.minExtraNatIpsNeeded;
                                if (options.oneofs)
                                    object._minExtraNatIpsNeeded = "minExtraNatIpsNeeded";
                            }
                            if (message.userAllocatedNatIps && message.userAllocatedNatIps.length) {
                                object.userAllocatedNatIps = [];
                                for (var j = 0; j < message.userAllocatedNatIps.length; ++j)
                                    object.userAllocatedNatIps[j] = message.userAllocatedNatIps[j];
                            }
                            if (message.autoAllocatedNatIps && message.autoAllocatedNatIps.length) {
                                object.autoAllocatedNatIps = [];
                                for (var j = 0; j < message.autoAllocatedNatIps.length; ++j)
                                    object.autoAllocatedNatIps[j] = message.autoAllocatedNatIps[j];
                            }
                            if (message.numVmEndpointsWithNatMappings != null && message.hasOwnProperty("numVmEndpointsWithNatMappings")) {
                                object.numVmEndpointsWithNatMappings = message.numVmEndpointsWithNatMappings;
                                if (options.oneofs)
                                    object._numVmEndpointsWithNatMappings = "numVmEndpointsWithNatMappings";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RouterStatusNatStatus to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RouterStatusNatStatus.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RouterStatusNatStatus
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatus
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RouterStatusNatStatus.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RouterStatusNatStatus";
                        };
    
                        return RouterStatusNatStatus;
                    })();
    
                    v1.RouterStatusNatStatusNatRuleStatus = (function() {
    
                        /**
                         * Properties of a RouterStatusNatStatusNatRuleStatus.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouterStatusNatStatusNatRuleStatus
                         * @property {Array.<string>|null} [activeNatIps] RouterStatusNatStatusNatRuleStatus activeNatIps
                         * @property {Array.<string>|null} [drainNatIps] RouterStatusNatStatusNatRuleStatus drainNatIps
                         * @property {number|null} [minExtraIpsNeeded] RouterStatusNatStatusNatRuleStatus minExtraIpsNeeded
                         * @property {number|null} [numVmEndpointsWithNatMappings] RouterStatusNatStatusNatRuleStatus numVmEndpointsWithNatMappings
                         * @property {number|null} [ruleNumber] RouterStatusNatStatusNatRuleStatus ruleNumber
                         */
    
                        /**
                         * Constructs a new RouterStatusNatStatusNatRuleStatus.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RouterStatusNatStatusNatRuleStatus.
                         * @implements IRouterStatusNatStatusNatRuleStatus
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouterStatusNatStatusNatRuleStatus=} [properties] Properties to set
                         */
                        function RouterStatusNatStatusNatRuleStatus(properties) {
                            this.activeNatIps = [];
                            this.drainNatIps = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RouterStatusNatStatusNatRuleStatus activeNatIps.
                         * @member {Array.<string>} activeNatIps
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus
                         * @instance
                         */
                        RouterStatusNatStatusNatRuleStatus.prototype.activeNatIps = $util.emptyArray;
    
                        /**
                         * RouterStatusNatStatusNatRuleStatus drainNatIps.
                         * @member {Array.<string>} drainNatIps
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus
                         * @instance
                         */
                        RouterStatusNatStatusNatRuleStatus.prototype.drainNatIps = $util.emptyArray;
    
                        /**
                         * RouterStatusNatStatusNatRuleStatus minExtraIpsNeeded.
                         * @member {number|null|undefined} minExtraIpsNeeded
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus
                         * @instance
                         */
                        RouterStatusNatStatusNatRuleStatus.prototype.minExtraIpsNeeded = null;
    
                        /**
                         * RouterStatusNatStatusNatRuleStatus numVmEndpointsWithNatMappings.
                         * @member {number|null|undefined} numVmEndpointsWithNatMappings
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus
                         * @instance
                         */
                        RouterStatusNatStatusNatRuleStatus.prototype.numVmEndpointsWithNatMappings = null;
    
                        /**
                         * RouterStatusNatStatusNatRuleStatus ruleNumber.
                         * @member {number|null|undefined} ruleNumber
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus
                         * @instance
                         */
                        RouterStatusNatStatusNatRuleStatus.prototype.ruleNumber = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RouterStatusNatStatusNatRuleStatus _minExtraIpsNeeded.
                         * @member {"minExtraIpsNeeded"|undefined} _minExtraIpsNeeded
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusNatStatusNatRuleStatus.prototype, "_minExtraIpsNeeded", {
                            get: $util.oneOfGetter($oneOfFields = ["minExtraIpsNeeded"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterStatusNatStatusNatRuleStatus _numVmEndpointsWithNatMappings.
                         * @member {"numVmEndpointsWithNatMappings"|undefined} _numVmEndpointsWithNatMappings
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusNatStatusNatRuleStatus.prototype, "_numVmEndpointsWithNatMappings", {
                            get: $util.oneOfGetter($oneOfFields = ["numVmEndpointsWithNatMappings"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterStatusNatStatusNatRuleStatus _ruleNumber.
                         * @member {"ruleNumber"|undefined} _ruleNumber
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus
                         * @instance
                         */
                        Object.defineProperty(RouterStatusNatStatusNatRuleStatus.prototype, "_ruleNumber", {
                            get: $util.oneOfGetter($oneOfFields = ["ruleNumber"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RouterStatusNatStatusNatRuleStatus instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus
                         * @static
                         * @param {google.cloud.compute.v1.IRouterStatusNatStatusNatRuleStatus=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus} RouterStatusNatStatusNatRuleStatus instance
                         */
                        RouterStatusNatStatusNatRuleStatus.create = function create(properties) {
                            return new RouterStatusNatStatusNatRuleStatus(properties);
                        };
    
                        /**
                         * Encodes the specified RouterStatusNatStatusNatRuleStatus message. Does not implicitly {@link google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus
                         * @static
                         * @param {google.cloud.compute.v1.IRouterStatusNatStatusNatRuleStatus} message RouterStatusNatStatusNatRuleStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterStatusNatStatusNatRuleStatus.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.activeNatIps != null && message.activeNatIps.length)
                                for (var i = 0; i < message.activeNatIps.length; ++i)
                                    writer.uint32(/* id 208517077, wireType 2 =*/1668136618).string(message.activeNatIps[i]);
                            if (message.minExtraIpsNeeded != null && Object.hasOwnProperty.call(message, "minExtraIpsNeeded"))
                                writer.uint32(/* id 353002756, wireType 0 =*/2824022048).int32(message.minExtraIpsNeeded);
                            if (message.drainNatIps != null && message.drainNatIps.length)
                                for (var i = 0; i < message.drainNatIps.length; ++i)
                                    writer.uint32(/* id 504078535, wireType 2 =*/4032628282).string(message.drainNatIps[i]);
                            if (message.numVmEndpointsWithNatMappings != null && Object.hasOwnProperty.call(message, "numVmEndpointsWithNatMappings"))
                                writer.uint32(/* id 512367468, wireType 0 =*/4098939744).int32(message.numVmEndpointsWithNatMappings);
                            if (message.ruleNumber != null && Object.hasOwnProperty.call(message, "ruleNumber"))
                                writer.uint32(/* id 535211500, wireType 0 =*/4281692000).int32(message.ruleNumber);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RouterStatusNatStatusNatRuleStatus message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus
                         * @static
                         * @param {google.cloud.compute.v1.IRouterStatusNatStatusNatRuleStatus} message RouterStatusNatStatusNatRuleStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterStatusNatStatusNatRuleStatus.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RouterStatusNatStatusNatRuleStatus message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus} RouterStatusNatStatusNatRuleStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterStatusNatStatusNatRuleStatus.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 208517077: {
                                        if (!(message.activeNatIps && message.activeNatIps.length))
                                            message.activeNatIps = [];
                                        message.activeNatIps.push(reader.string());
                                        break;
                                    }
                                case 504078535: {
                                        if (!(message.drainNatIps && message.drainNatIps.length))
                                            message.drainNatIps = [];
                                        message.drainNatIps.push(reader.string());
                                        break;
                                    }
                                case 353002756: {
                                        message.minExtraIpsNeeded = reader.int32();
                                        break;
                                    }
                                case 512367468: {
                                        message.numVmEndpointsWithNatMappings = reader.int32();
                                        break;
                                    }
                                case 535211500: {
                                        message.ruleNumber = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RouterStatusNatStatusNatRuleStatus message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus} RouterStatusNatStatusNatRuleStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterStatusNatStatusNatRuleStatus.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RouterStatusNatStatusNatRuleStatus message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RouterStatusNatStatusNatRuleStatus.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.activeNatIps != null && message.hasOwnProperty("activeNatIps")) {
                                if (!Array.isArray(message.activeNatIps))
                                    return "activeNatIps: array expected";
                                for (var i = 0; i < message.activeNatIps.length; ++i)
                                    if (!$util.isString(message.activeNatIps[i]))
                                        return "activeNatIps: string[] expected";
                            }
                            if (message.drainNatIps != null && message.hasOwnProperty("drainNatIps")) {
                                if (!Array.isArray(message.drainNatIps))
                                    return "drainNatIps: array expected";
                                for (var i = 0; i < message.drainNatIps.length; ++i)
                                    if (!$util.isString(message.drainNatIps[i]))
                                        return "drainNatIps: string[] expected";
                            }
                            if (message.minExtraIpsNeeded != null && message.hasOwnProperty("minExtraIpsNeeded")) {
                                properties._minExtraIpsNeeded = 1;
                                if (!$util.isInteger(message.minExtraIpsNeeded))
                                    return "minExtraIpsNeeded: integer expected";
                            }
                            if (message.numVmEndpointsWithNatMappings != null && message.hasOwnProperty("numVmEndpointsWithNatMappings")) {
                                properties._numVmEndpointsWithNatMappings = 1;
                                if (!$util.isInteger(message.numVmEndpointsWithNatMappings))
                                    return "numVmEndpointsWithNatMappings: integer expected";
                            }
                            if (message.ruleNumber != null && message.hasOwnProperty("ruleNumber")) {
                                properties._ruleNumber = 1;
                                if (!$util.isInteger(message.ruleNumber))
                                    return "ruleNumber: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RouterStatusNatStatusNatRuleStatus message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus} RouterStatusNatStatusNatRuleStatus
                         */
                        RouterStatusNatStatusNatRuleStatus.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus();
                            if (object.activeNatIps) {
                                if (!Array.isArray(object.activeNatIps))
                                    throw TypeError(".google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus.activeNatIps: array expected");
                                message.activeNatIps = [];
                                for (var i = 0; i < object.activeNatIps.length; ++i)
                                    message.activeNatIps[i] = String(object.activeNatIps[i]);
                            }
                            if (object.drainNatIps) {
                                if (!Array.isArray(object.drainNatIps))
                                    throw TypeError(".google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus.drainNatIps: array expected");
                                message.drainNatIps = [];
                                for (var i = 0; i < object.drainNatIps.length; ++i)
                                    message.drainNatIps[i] = String(object.drainNatIps[i]);
                            }
                            if (object.minExtraIpsNeeded != null)
                                message.minExtraIpsNeeded = object.minExtraIpsNeeded | 0;
                            if (object.numVmEndpointsWithNatMappings != null)
                                message.numVmEndpointsWithNatMappings = object.numVmEndpointsWithNatMappings | 0;
                            if (object.ruleNumber != null)
                                message.ruleNumber = object.ruleNumber | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RouterStatusNatStatusNatRuleStatus message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus
                         * @static
                         * @param {google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus} message RouterStatusNatStatusNatRuleStatus
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RouterStatusNatStatusNatRuleStatus.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.activeNatIps = [];
                                object.drainNatIps = [];
                            }
                            if (message.activeNatIps && message.activeNatIps.length) {
                                object.activeNatIps = [];
                                for (var j = 0; j < message.activeNatIps.length; ++j)
                                    object.activeNatIps[j] = message.activeNatIps[j];
                            }
                            if (message.minExtraIpsNeeded != null && message.hasOwnProperty("minExtraIpsNeeded")) {
                                object.minExtraIpsNeeded = message.minExtraIpsNeeded;
                                if (options.oneofs)
                                    object._minExtraIpsNeeded = "minExtraIpsNeeded";
                            }
                            if (message.drainNatIps && message.drainNatIps.length) {
                                object.drainNatIps = [];
                                for (var j = 0; j < message.drainNatIps.length; ++j)
                                    object.drainNatIps[j] = message.drainNatIps[j];
                            }
                            if (message.numVmEndpointsWithNatMappings != null && message.hasOwnProperty("numVmEndpointsWithNatMappings")) {
                                object.numVmEndpointsWithNatMappings = message.numVmEndpointsWithNatMappings;
                                if (options.oneofs)
                                    object._numVmEndpointsWithNatMappings = "numVmEndpointsWithNatMappings";
                            }
                            if (message.ruleNumber != null && message.hasOwnProperty("ruleNumber")) {
                                object.ruleNumber = message.ruleNumber;
                                if (options.oneofs)
                                    object._ruleNumber = "ruleNumber";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RouterStatusNatStatusNatRuleStatus to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RouterStatusNatStatusNatRuleStatus.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RouterStatusNatStatusNatRuleStatus
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RouterStatusNatStatusNatRuleStatus.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RouterStatusNatStatusNatRuleStatus";
                        };
    
                        return RouterStatusNatStatusNatRuleStatus;
                    })();
    
                    v1.RouterStatusResponse = (function() {
    
                        /**
                         * Properties of a RouterStatusResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface IRouterStatusResponse
                         * @property {string|null} [kind] RouterStatusResponse kind
                         * @property {google.cloud.compute.v1.IRouterStatus|null} [result] RouterStatusResponse result
                         */
    
                        /**
                         * Constructs a new RouterStatusResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RouterStatusResponse.
                         * @implements IRouterStatusResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.IRouterStatusResponse=} [properties] Properties to set
                         */
                        function RouterStatusResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RouterStatusResponse kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.RouterStatusResponse
                         * @instance
                         */
                        RouterStatusResponse.prototype.kind = null;
    
                        /**
                         * RouterStatusResponse result.
                         * @member {google.cloud.compute.v1.IRouterStatus|null|undefined} result
                         * @memberof google.cloud.compute.v1.RouterStatusResponse
                         * @instance
                         */
                        RouterStatusResponse.prototype.result = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RouterStatusResponse _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.RouterStatusResponse
                         * @instance
                         */
                        Object.defineProperty(RouterStatusResponse.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * RouterStatusResponse _result.
                         * @member {"result"|undefined} _result
                         * @memberof google.cloud.compute.v1.RouterStatusResponse
                         * @instance
                         */
                        Object.defineProperty(RouterStatusResponse.prototype, "_result", {
                            get: $util.oneOfGetter($oneOfFields = ["result"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RouterStatusResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RouterStatusResponse
                         * @static
                         * @param {google.cloud.compute.v1.IRouterStatusResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RouterStatusResponse} RouterStatusResponse instance
                         */
                        RouterStatusResponse.create = function create(properties) {
                            return new RouterStatusResponse(properties);
                        };
    
                        /**
                         * Encodes the specified RouterStatusResponse message. Does not implicitly {@link google.cloud.compute.v1.RouterStatusResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RouterStatusResponse
                         * @static
                         * @param {google.cloud.compute.v1.IRouterStatusResponse} message RouterStatusResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterStatusResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.result != null && Object.hasOwnProperty.call(message, "result"))
                                $root.google.cloud.compute.v1.RouterStatus.encode(message.result, writer.uint32(/* id 139315229, wireType 2 =*/1114521834).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RouterStatusResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RouterStatusResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RouterStatusResponse
                         * @static
                         * @param {google.cloud.compute.v1.IRouterStatusResponse} message RouterStatusResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RouterStatusResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RouterStatusResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RouterStatusResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RouterStatusResponse} RouterStatusResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterStatusResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RouterStatusResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 139315229: {
                                        message.result = $root.google.cloud.compute.v1.RouterStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RouterStatusResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RouterStatusResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RouterStatusResponse} RouterStatusResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RouterStatusResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RouterStatusResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RouterStatusResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RouterStatusResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.result != null && message.hasOwnProperty("result")) {
                                properties._result = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.RouterStatus.verify(message.result);
                                    if (error)
                                        return "result." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RouterStatusResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RouterStatusResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RouterStatusResponse} RouterStatusResponse
                         */
                        RouterStatusResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RouterStatusResponse)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RouterStatusResponse();
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.result != null) {
                                if (typeof object.result !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RouterStatusResponse.result: object expected");
                                message.result = $root.google.cloud.compute.v1.RouterStatus.fromObject(object.result);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RouterStatusResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RouterStatusResponse
                         * @static
                         * @param {google.cloud.compute.v1.RouterStatusResponse} message RouterStatusResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RouterStatusResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.result != null && message.hasOwnProperty("result")) {
                                object.result = $root.google.cloud.compute.v1.RouterStatus.toObject(message.result, options);
                                if (options.oneofs)
                                    object._result = "result";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RouterStatusResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RouterStatusResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RouterStatusResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RouterStatusResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RouterStatusResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RouterStatusResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RouterStatusResponse";
                        };
    
                        return RouterStatusResponse;
                    })();
    
                    v1.RoutersPreviewResponse = (function() {
    
                        /**
                         * Properties of a RoutersPreviewResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface IRoutersPreviewResponse
                         * @property {google.cloud.compute.v1.IRouter|null} [resource] RoutersPreviewResponse resource
                         */
    
                        /**
                         * Constructs a new RoutersPreviewResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RoutersPreviewResponse.
                         * @implements IRoutersPreviewResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.IRoutersPreviewResponse=} [properties] Properties to set
                         */
                        function RoutersPreviewResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RoutersPreviewResponse resource.
                         * @member {google.cloud.compute.v1.IRouter|null|undefined} resource
                         * @memberof google.cloud.compute.v1.RoutersPreviewResponse
                         * @instance
                         */
                        RoutersPreviewResponse.prototype.resource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RoutersPreviewResponse _resource.
                         * @member {"resource"|undefined} _resource
                         * @memberof google.cloud.compute.v1.RoutersPreviewResponse
                         * @instance
                         */
                        Object.defineProperty(RoutersPreviewResponse.prototype, "_resource", {
                            get: $util.oneOfGetter($oneOfFields = ["resource"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RoutersPreviewResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RoutersPreviewResponse
                         * @static
                         * @param {google.cloud.compute.v1.IRoutersPreviewResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RoutersPreviewResponse} RoutersPreviewResponse instance
                         */
                        RoutersPreviewResponse.create = function create(properties) {
                            return new RoutersPreviewResponse(properties);
                        };
    
                        /**
                         * Encodes the specified RoutersPreviewResponse message. Does not implicitly {@link google.cloud.compute.v1.RoutersPreviewResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RoutersPreviewResponse
                         * @static
                         * @param {google.cloud.compute.v1.IRoutersPreviewResponse} message RoutersPreviewResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RoutersPreviewResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                $root.google.cloud.compute.v1.Router.encode(message.resource, writer.uint32(/* id 195806222, wireType 2 =*/1566449778).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RoutersPreviewResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RoutersPreviewResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RoutersPreviewResponse
                         * @static
                         * @param {google.cloud.compute.v1.IRoutersPreviewResponse} message RoutersPreviewResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RoutersPreviewResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RoutersPreviewResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RoutersPreviewResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RoutersPreviewResponse} RoutersPreviewResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RoutersPreviewResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RoutersPreviewResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 195806222: {
                                        message.resource = $root.google.cloud.compute.v1.Router.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RoutersPreviewResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RoutersPreviewResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RoutersPreviewResponse} RoutersPreviewResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RoutersPreviewResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RoutersPreviewResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RoutersPreviewResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RoutersPreviewResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.resource != null && message.hasOwnProperty("resource")) {
                                properties._resource = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Router.verify(message.resource);
                                    if (error)
                                        return "resource." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RoutersPreviewResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RoutersPreviewResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RoutersPreviewResponse} RoutersPreviewResponse
                         */
                        RoutersPreviewResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RoutersPreviewResponse)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RoutersPreviewResponse();
                            if (object.resource != null) {
                                if (typeof object.resource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RoutersPreviewResponse.resource: object expected");
                                message.resource = $root.google.cloud.compute.v1.Router.fromObject(object.resource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RoutersPreviewResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RoutersPreviewResponse
                         * @static
                         * @param {google.cloud.compute.v1.RoutersPreviewResponse} message RoutersPreviewResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RoutersPreviewResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.resource != null && message.hasOwnProperty("resource")) {
                                object.resource = $root.google.cloud.compute.v1.Router.toObject(message.resource, options);
                                if (options.oneofs)
                                    object._resource = "resource";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RoutersPreviewResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RoutersPreviewResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RoutersPreviewResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RoutersPreviewResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RoutersPreviewResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RoutersPreviewResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RoutersPreviewResponse";
                        };
    
                        return RoutersPreviewResponse;
                    })();
    
                    v1.RoutersScopedList = (function() {
    
                        /**
                         * Properties of a RoutersScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IRoutersScopedList
                         * @property {Array.<google.cloud.compute.v1.IRouter>|null} [routers] RoutersScopedList routers
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] RoutersScopedList warning
                         */
    
                        /**
                         * Constructs a new RoutersScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RoutersScopedList.
                         * @implements IRoutersScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IRoutersScopedList=} [properties] Properties to set
                         */
                        function RoutersScopedList(properties) {
                            this.routers = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * RoutersScopedList routers.
                         * @member {Array.<google.cloud.compute.v1.IRouter>} routers
                         * @memberof google.cloud.compute.v1.RoutersScopedList
                         * @instance
                         */
                        RoutersScopedList.prototype.routers = $util.emptyArray;
    
                        /**
                         * RoutersScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.RoutersScopedList
                         * @instance
                         */
                        RoutersScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * RoutersScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.RoutersScopedList
                         * @instance
                         */
                        Object.defineProperty(RoutersScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new RoutersScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.RoutersScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IRoutersScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.RoutersScopedList} RoutersScopedList instance
                         */
                        RoutersScopedList.create = function create(properties) {
                            return new RoutersScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified RoutersScopedList message. Does not implicitly {@link google.cloud.compute.v1.RoutersScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.RoutersScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IRoutersScopedList} message RoutersScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RoutersScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.routers != null && message.routers.length)
                                for (var i = 0; i < message.routers.length; ++i)
                                    $root.google.cloud.compute.v1.Router.encode(message.routers[i], writer.uint32(/* id 311906890, wireType 2 =*/2495255122).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified RoutersScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.RoutersScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.RoutersScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IRoutersScopedList} message RoutersScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        RoutersScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a RoutersScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.RoutersScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.RoutersScopedList} RoutersScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RoutersScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.RoutersScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 311906890: {
                                        if (!(message.routers && message.routers.length))
                                            message.routers = [];
                                        message.routers.push($root.google.cloud.compute.v1.Router.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a RoutersScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.RoutersScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.RoutersScopedList} RoutersScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        RoutersScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a RoutersScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.RoutersScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        RoutersScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.routers != null && message.hasOwnProperty("routers")) {
                                if (!Array.isArray(message.routers))
                                    return "routers: array expected";
                                for (var i = 0; i < message.routers.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Router.verify(message.routers[i]);
                                    if (error)
                                        return "routers." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a RoutersScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.RoutersScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.RoutersScopedList} RoutersScopedList
                         */
                        RoutersScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.RoutersScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.RoutersScopedList();
                            if (object.routers) {
                                if (!Array.isArray(object.routers))
                                    throw TypeError(".google.cloud.compute.v1.RoutersScopedList.routers: array expected");
                                message.routers = [];
                                for (var i = 0; i < object.routers.length; ++i) {
                                    if (typeof object.routers[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.RoutersScopedList.routers: object expected");
                                    message.routers[i] = $root.google.cloud.compute.v1.Router.fromObject(object.routers[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.RoutersScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a RoutersScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.RoutersScopedList
                         * @static
                         * @param {google.cloud.compute.v1.RoutersScopedList} message RoutersScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        RoutersScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.routers = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.routers && message.routers.length) {
                                object.routers = [];
                                for (var j = 0; j < message.routers.length; ++j)
                                    object.routers[j] = $root.google.cloud.compute.v1.Router.toObject(message.routers[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this RoutersScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.RoutersScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        RoutersScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for RoutersScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.RoutersScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        RoutersScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.RoutersScopedList";
                        };
    
                        return RoutersScopedList;
                    })();
    
                    v1.Rule = (function() {
    
                        /**
                         * Properties of a Rule.
                         * @memberof google.cloud.compute.v1
                         * @interface IRule
                         * @property {string|null} [action] Rule action
                         * @property {Array.<google.cloud.compute.v1.ICondition>|null} [conditions] Rule conditions
                         * @property {string|null} [description] Rule description
                         * @property {Array.<string>|null} [ins] Rule ins
                         * @property {Array.<google.cloud.compute.v1.ILogConfig>|null} [logConfigs] Rule logConfigs
                         * @property {Array.<string>|null} [notIns] Rule notIns
                         * @property {Array.<string>|null} [permissions] Rule permissions
                         */
    
                        /**
                         * Constructs a new Rule.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Rule.
                         * @implements IRule
                         * @constructor
                         * @param {google.cloud.compute.v1.IRule=} [properties] Properties to set
                         */
                        function Rule(properties) {
                            this.conditions = [];
                            this.ins = [];
                            this.logConfigs = [];
                            this.notIns = [];
                            this.permissions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Rule action.
                         * @member {string|null|undefined} action
                         * @memberof google.cloud.compute.v1.Rule
                         * @instance
                         */
                        Rule.prototype.action = null;
    
                        /**
                         * Rule conditions.
                         * @member {Array.<google.cloud.compute.v1.ICondition>} conditions
                         * @memberof google.cloud.compute.v1.Rule
                         * @instance
                         */
                        Rule.prototype.conditions = $util.emptyArray;
    
                        /**
                         * Rule description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Rule
                         * @instance
                         */
                        Rule.prototype.description = null;
    
                        /**
                         * Rule ins.
                         * @member {Array.<string>} ins
                         * @memberof google.cloud.compute.v1.Rule
                         * @instance
                         */
                        Rule.prototype.ins = $util.emptyArray;
    
                        /**
                         * Rule logConfigs.
                         * @member {Array.<google.cloud.compute.v1.ILogConfig>} logConfigs
                         * @memberof google.cloud.compute.v1.Rule
                         * @instance
                         */
                        Rule.prototype.logConfigs = $util.emptyArray;
    
                        /**
                         * Rule notIns.
                         * @member {Array.<string>} notIns
                         * @memberof google.cloud.compute.v1.Rule
                         * @instance
                         */
                        Rule.prototype.notIns = $util.emptyArray;
    
                        /**
                         * Rule permissions.
                         * @member {Array.<string>} permissions
                         * @memberof google.cloud.compute.v1.Rule
                         * @instance
                         */
                        Rule.prototype.permissions = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Rule _action.
                         * @member {"action"|undefined} _action
                         * @memberof google.cloud.compute.v1.Rule
                         * @instance
                         */
                        Object.defineProperty(Rule.prototype, "_action", {
                            get: $util.oneOfGetter($oneOfFields = ["action"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Rule _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Rule
                         * @instance
                         */
                        Object.defineProperty(Rule.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Rule instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Rule
                         * @static
                         * @param {google.cloud.compute.v1.IRule=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Rule} Rule instance
                         */
                        Rule.create = function create(properties) {
                            return new Rule(properties);
                        };
    
                        /**
                         * Encodes the specified Rule message. Does not implicitly {@link google.cloud.compute.v1.Rule.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Rule
                         * @static
                         * @param {google.cloud.compute.v1.IRule} message Rule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Rule.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.ins != null && message.ins.length)
                                for (var i = 0; i < message.ins.length; ++i)
                                    writer.uint32(/* id 104430, wireType 2 =*/835442).string(message.ins[i]);
                            if (message.permissions != null && message.permissions.length)
                                for (var i = 0; i < message.permissions.length; ++i)
                                    writer.uint32(/* id 59962500, wireType 2 =*/479700002).string(message.permissions[i]);
                            if (message.conditions != null && message.conditions.length)
                                for (var i = 0; i < message.conditions.length; ++i)
                                    $root.google.cloud.compute.v1.Condition.encode(message.conditions[i], writer.uint32(/* id 142882488, wireType 2 =*/1143059906).fork()).ldelim();
                            if (message.logConfigs != null && message.logConfigs.length)
                                for (var i = 0; i < message.logConfigs.length; ++i)
                                    $root.google.cloud.compute.v1.LogConfig.encode(message.logConfigs[i], writer.uint32(/* id 152873846, wireType 2 =*/1222990770).fork()).ldelim();
                            if (message.action != null && Object.hasOwnProperty.call(message, "action"))
                                writer.uint32(/* id 187661878, wireType 2 =*/1501295026).string(message.action);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.notIns != null && message.notIns.length)
                                for (var i = 0; i < message.notIns.length; ++i)
                                    writer.uint32(/* id 518443138, wireType 2 =*/4147545106).string(message.notIns[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Rule message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Rule.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Rule
                         * @static
                         * @param {google.cloud.compute.v1.IRule} message Rule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Rule.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Rule message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Rule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Rule} Rule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Rule.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Rule();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 187661878: {
                                        message.action = reader.string();
                                        break;
                                    }
                                case 142882488: {
                                        if (!(message.conditions && message.conditions.length))
                                            message.conditions = [];
                                        message.conditions.push($root.google.cloud.compute.v1.Condition.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 104430: {
                                        if (!(message.ins && message.ins.length))
                                            message.ins = [];
                                        message.ins.push(reader.string());
                                        break;
                                    }
                                case 152873846: {
                                        if (!(message.logConfigs && message.logConfigs.length))
                                            message.logConfigs = [];
                                        message.logConfigs.push($root.google.cloud.compute.v1.LogConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 518443138: {
                                        if (!(message.notIns && message.notIns.length))
                                            message.notIns = [];
                                        message.notIns.push(reader.string());
                                        break;
                                    }
                                case 59962500: {
                                        if (!(message.permissions && message.permissions.length))
                                            message.permissions = [];
                                        message.permissions.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Rule message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Rule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Rule} Rule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Rule.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Rule message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Rule
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Rule.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.action != null && message.hasOwnProperty("action")) {
                                properties._action = 1;
                                if (!$util.isString(message.action))
                                    return "action: string expected";
                            }
                            if (message.conditions != null && message.hasOwnProperty("conditions")) {
                                if (!Array.isArray(message.conditions))
                                    return "conditions: array expected";
                                for (var i = 0; i < message.conditions.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Condition.verify(message.conditions[i]);
                                    if (error)
                                        return "conditions." + error;
                                }
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.ins != null && message.hasOwnProperty("ins")) {
                                if (!Array.isArray(message.ins))
                                    return "ins: array expected";
                                for (var i = 0; i < message.ins.length; ++i)
                                    if (!$util.isString(message.ins[i]))
                                        return "ins: string[] expected";
                            }
                            if (message.logConfigs != null && message.hasOwnProperty("logConfigs")) {
                                if (!Array.isArray(message.logConfigs))
                                    return "logConfigs: array expected";
                                for (var i = 0; i < message.logConfigs.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.LogConfig.verify(message.logConfigs[i]);
                                    if (error)
                                        return "logConfigs." + error;
                                }
                            }
                            if (message.notIns != null && message.hasOwnProperty("notIns")) {
                                if (!Array.isArray(message.notIns))
                                    return "notIns: array expected";
                                for (var i = 0; i < message.notIns.length; ++i)
                                    if (!$util.isString(message.notIns[i]))
                                        return "notIns: string[] expected";
                            }
                            if (message.permissions != null && message.hasOwnProperty("permissions")) {
                                if (!Array.isArray(message.permissions))
                                    return "permissions: array expected";
                                for (var i = 0; i < message.permissions.length; ++i)
                                    if (!$util.isString(message.permissions[i]))
                                        return "permissions: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Rule message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Rule
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Rule} Rule
                         */
                        Rule.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Rule)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Rule();
                            if (object.action != null)
                                message.action = String(object.action);
                            if (object.conditions) {
                                if (!Array.isArray(object.conditions))
                                    throw TypeError(".google.cloud.compute.v1.Rule.conditions: array expected");
                                message.conditions = [];
                                for (var i = 0; i < object.conditions.length; ++i) {
                                    if (typeof object.conditions[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Rule.conditions: object expected");
                                    message.conditions[i] = $root.google.cloud.compute.v1.Condition.fromObject(object.conditions[i]);
                                }
                            }
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.ins) {
                                if (!Array.isArray(object.ins))
                                    throw TypeError(".google.cloud.compute.v1.Rule.ins: array expected");
                                message.ins = [];
                                for (var i = 0; i < object.ins.length; ++i)
                                    message.ins[i] = String(object.ins[i]);
                            }
                            if (object.logConfigs) {
                                if (!Array.isArray(object.logConfigs))
                                    throw TypeError(".google.cloud.compute.v1.Rule.logConfigs: array expected");
                                message.logConfigs = [];
                                for (var i = 0; i < object.logConfigs.length; ++i) {
                                    if (typeof object.logConfigs[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Rule.logConfigs: object expected");
                                    message.logConfigs[i] = $root.google.cloud.compute.v1.LogConfig.fromObject(object.logConfigs[i]);
                                }
                            }
                            if (object.notIns) {
                                if (!Array.isArray(object.notIns))
                                    throw TypeError(".google.cloud.compute.v1.Rule.notIns: array expected");
                                message.notIns = [];
                                for (var i = 0; i < object.notIns.length; ++i)
                                    message.notIns[i] = String(object.notIns[i]);
                            }
                            if (object.permissions) {
                                if (!Array.isArray(object.permissions))
                                    throw TypeError(".google.cloud.compute.v1.Rule.permissions: array expected");
                                message.permissions = [];
                                for (var i = 0; i < object.permissions.length; ++i)
                                    message.permissions[i] = String(object.permissions[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Rule message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Rule
                         * @static
                         * @param {google.cloud.compute.v1.Rule} message Rule
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Rule.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.ins = [];
                                object.permissions = [];
                                object.conditions = [];
                                object.logConfigs = [];
                                object.notIns = [];
                            }
                            if (message.ins && message.ins.length) {
                                object.ins = [];
                                for (var j = 0; j < message.ins.length; ++j)
                                    object.ins[j] = message.ins[j];
                            }
                            if (message.permissions && message.permissions.length) {
                                object.permissions = [];
                                for (var j = 0; j < message.permissions.length; ++j)
                                    object.permissions[j] = message.permissions[j];
                            }
                            if (message.conditions && message.conditions.length) {
                                object.conditions = [];
                                for (var j = 0; j < message.conditions.length; ++j)
                                    object.conditions[j] = $root.google.cloud.compute.v1.Condition.toObject(message.conditions[j], options);
                            }
                            if (message.logConfigs && message.logConfigs.length) {
                                object.logConfigs = [];
                                for (var j = 0; j < message.logConfigs.length; ++j)
                                    object.logConfigs[j] = $root.google.cloud.compute.v1.LogConfig.toObject(message.logConfigs[j], options);
                            }
                            if (message.action != null && message.hasOwnProperty("action")) {
                                object.action = message.action;
                                if (options.oneofs)
                                    object._action = "action";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.notIns && message.notIns.length) {
                                object.notIns = [];
                                for (var j = 0; j < message.notIns.length; ++j)
                                    object.notIns[j] = message.notIns[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Rule to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Rule
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Rule.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Rule
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Rule
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Rule.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Rule";
                        };
    
                        /**
                         * Action enum.
                         * @name google.cloud.compute.v1.Rule.Action
                         * @enum {number}
                         * @property {number} UNDEFINED_ACTION=0 UNDEFINED_ACTION value
                         * @property {number} ALLOW=62368553 ALLOW value
                         * @property {number} ALLOW_WITH_LOG=76034177 ALLOW_WITH_LOG value
                         * @property {number} DENY=2094604 DENY value
                         * @property {number} DENY_WITH_LOG=351433982 DENY_WITH_LOG value
                         * @property {number} LOG=75556 LOG value
                         * @property {number} NO_ACTION=260643444 NO_ACTION value
                         */
                        Rule.Action = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ACTION"] = 0;
                            values[valuesById[62368553] = "ALLOW"] = 62368553;
                            values[valuesById[76034177] = "ALLOW_WITH_LOG"] = 76034177;
                            values[valuesById[2094604] = "DENY"] = 2094604;
                            values[valuesById[351433982] = "DENY_WITH_LOG"] = 351433982;
                            values[valuesById[75556] = "LOG"] = 75556;
                            values[valuesById[260643444] = "NO_ACTION"] = 260643444;
                            return values;
                        })();
    
                        return Rule;
                    })();
    
                    v1.SSLHealthCheck = (function() {
    
                        /**
                         * Properties of a SSLHealthCheck.
                         * @memberof google.cloud.compute.v1
                         * @interface ISSLHealthCheck
                         * @property {number|null} [port] SSLHealthCheck port
                         * @property {string|null} [portName] SSLHealthCheck portName
                         * @property {string|null} [portSpecification] SSLHealthCheck portSpecification
                         * @property {string|null} [proxyHeader] SSLHealthCheck proxyHeader
                         * @property {string|null} [request] SSLHealthCheck request
                         * @property {string|null} [response] SSLHealthCheck response
                         */
    
                        /**
                         * Constructs a new SSLHealthCheck.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SSLHealthCheck.
                         * @implements ISSLHealthCheck
                         * @constructor
                         * @param {google.cloud.compute.v1.ISSLHealthCheck=} [properties] Properties to set
                         */
                        function SSLHealthCheck(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SSLHealthCheck port.
                         * @member {number|null|undefined} port
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @instance
                         */
                        SSLHealthCheck.prototype.port = null;
    
                        /**
                         * SSLHealthCheck portName.
                         * @member {string|null|undefined} portName
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @instance
                         */
                        SSLHealthCheck.prototype.portName = null;
    
                        /**
                         * SSLHealthCheck portSpecification.
                         * @member {string|null|undefined} portSpecification
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @instance
                         */
                        SSLHealthCheck.prototype.portSpecification = null;
    
                        /**
                         * SSLHealthCheck proxyHeader.
                         * @member {string|null|undefined} proxyHeader
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @instance
                         */
                        SSLHealthCheck.prototype.proxyHeader = null;
    
                        /**
                         * SSLHealthCheck request.
                         * @member {string|null|undefined} request
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @instance
                         */
                        SSLHealthCheck.prototype.request = null;
    
                        /**
                         * SSLHealthCheck response.
                         * @member {string|null|undefined} response
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @instance
                         */
                        SSLHealthCheck.prototype.response = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SSLHealthCheck _port.
                         * @member {"port"|undefined} _port
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @instance
                         */
                        Object.defineProperty(SSLHealthCheck.prototype, "_port", {
                            get: $util.oneOfGetter($oneOfFields = ["port"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SSLHealthCheck _portName.
                         * @member {"portName"|undefined} _portName
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @instance
                         */
                        Object.defineProperty(SSLHealthCheck.prototype, "_portName", {
                            get: $util.oneOfGetter($oneOfFields = ["portName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SSLHealthCheck _portSpecification.
                         * @member {"portSpecification"|undefined} _portSpecification
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @instance
                         */
                        Object.defineProperty(SSLHealthCheck.prototype, "_portSpecification", {
                            get: $util.oneOfGetter($oneOfFields = ["portSpecification"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SSLHealthCheck _proxyHeader.
                         * @member {"proxyHeader"|undefined} _proxyHeader
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @instance
                         */
                        Object.defineProperty(SSLHealthCheck.prototype, "_proxyHeader", {
                            get: $util.oneOfGetter($oneOfFields = ["proxyHeader"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SSLHealthCheck _request.
                         * @member {"request"|undefined} _request
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @instance
                         */
                        Object.defineProperty(SSLHealthCheck.prototype, "_request", {
                            get: $util.oneOfGetter($oneOfFields = ["request"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SSLHealthCheck _response.
                         * @member {"response"|undefined} _response
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @instance
                         */
                        Object.defineProperty(SSLHealthCheck.prototype, "_response", {
                            get: $util.oneOfGetter($oneOfFields = ["response"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SSLHealthCheck instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.ISSLHealthCheck=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SSLHealthCheck} SSLHealthCheck instance
                         */
                        SSLHealthCheck.create = function create(properties) {
                            return new SSLHealthCheck(properties);
                        };
    
                        /**
                         * Encodes the specified SSLHealthCheck message. Does not implicitly {@link google.cloud.compute.v1.SSLHealthCheck.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.ISSLHealthCheck} message SSLHealthCheck message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SSLHealthCheck.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.port != null && Object.hasOwnProperty.call(message, "port"))
                                writer.uint32(/* id 3446913, wireType 0 =*/27575304).int32(message.port);
                            if (message.request != null && Object.hasOwnProperty.call(message, "request"))
                                writer.uint32(/* id 21951119, wireType 2 =*/175608954).string(message.request);
                            if (message.portName != null && Object.hasOwnProperty.call(message, "portName"))
                                writer.uint32(/* id 41534345, wireType 2 =*/332274762).string(message.portName);
                            if (message.portSpecification != null && Object.hasOwnProperty.call(message, "portSpecification"))
                                writer.uint32(/* id 51590597, wireType 2 =*/412724778).string(message.portSpecification);
                            if (message.proxyHeader != null && Object.hasOwnProperty.call(message, "proxyHeader"))
                                writer.uint32(/* id 160374142, wireType 2 =*/1282993138).string(message.proxyHeader);
                            if (message.response != null && Object.hasOwnProperty.call(message, "response"))
                                writer.uint32(/* id 196547649, wireType 2 =*/1572381194).string(message.response);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SSLHealthCheck message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SSLHealthCheck.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.ISSLHealthCheck} message SSLHealthCheck message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SSLHealthCheck.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SSLHealthCheck message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SSLHealthCheck} SSLHealthCheck
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SSLHealthCheck.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SSLHealthCheck();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3446913: {
                                        message.port = reader.int32();
                                        break;
                                    }
                                case 41534345: {
                                        message.portName = reader.string();
                                        break;
                                    }
                                case 51590597: {
                                        message.portSpecification = reader.string();
                                        break;
                                    }
                                case 160374142: {
                                        message.proxyHeader = reader.string();
                                        break;
                                    }
                                case 21951119: {
                                        message.request = reader.string();
                                        break;
                                    }
                                case 196547649: {
                                        message.response = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SSLHealthCheck message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SSLHealthCheck} SSLHealthCheck
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SSLHealthCheck.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SSLHealthCheck message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SSLHealthCheck.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.port != null && message.hasOwnProperty("port")) {
                                properties._port = 1;
                                if (!$util.isInteger(message.port))
                                    return "port: integer expected";
                            }
                            if (message.portName != null && message.hasOwnProperty("portName")) {
                                properties._portName = 1;
                                if (!$util.isString(message.portName))
                                    return "portName: string expected";
                            }
                            if (message.portSpecification != null && message.hasOwnProperty("portSpecification")) {
                                properties._portSpecification = 1;
                                if (!$util.isString(message.portSpecification))
                                    return "portSpecification: string expected";
                            }
                            if (message.proxyHeader != null && message.hasOwnProperty("proxyHeader")) {
                                properties._proxyHeader = 1;
                                if (!$util.isString(message.proxyHeader))
                                    return "proxyHeader: string expected";
                            }
                            if (message.request != null && message.hasOwnProperty("request")) {
                                properties._request = 1;
                                if (!$util.isString(message.request))
                                    return "request: string expected";
                            }
                            if (message.response != null && message.hasOwnProperty("response")) {
                                properties._response = 1;
                                if (!$util.isString(message.response))
                                    return "response: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SSLHealthCheck message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SSLHealthCheck} SSLHealthCheck
                         */
                        SSLHealthCheck.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SSLHealthCheck)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SSLHealthCheck();
                            if (object.port != null)
                                message.port = object.port | 0;
                            if (object.portName != null)
                                message.portName = String(object.portName);
                            if (object.portSpecification != null)
                                message.portSpecification = String(object.portSpecification);
                            if (object.proxyHeader != null)
                                message.proxyHeader = String(object.proxyHeader);
                            if (object.request != null)
                                message.request = String(object.request);
                            if (object.response != null)
                                message.response = String(object.response);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SSLHealthCheck message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.SSLHealthCheck} message SSLHealthCheck
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SSLHealthCheck.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.port != null && message.hasOwnProperty("port")) {
                                object.port = message.port;
                                if (options.oneofs)
                                    object._port = "port";
                            }
                            if (message.request != null && message.hasOwnProperty("request")) {
                                object.request = message.request;
                                if (options.oneofs)
                                    object._request = "request";
                            }
                            if (message.portName != null && message.hasOwnProperty("portName")) {
                                object.portName = message.portName;
                                if (options.oneofs)
                                    object._portName = "portName";
                            }
                            if (message.portSpecification != null && message.hasOwnProperty("portSpecification")) {
                                object.portSpecification = message.portSpecification;
                                if (options.oneofs)
                                    object._portSpecification = "portSpecification";
                            }
                            if (message.proxyHeader != null && message.hasOwnProperty("proxyHeader")) {
                                object.proxyHeader = message.proxyHeader;
                                if (options.oneofs)
                                    object._proxyHeader = "proxyHeader";
                            }
                            if (message.response != null && message.hasOwnProperty("response")) {
                                object.response = message.response;
                                if (options.oneofs)
                                    object._response = "response";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SSLHealthCheck to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SSLHealthCheck.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SSLHealthCheck
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SSLHealthCheck
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SSLHealthCheck.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SSLHealthCheck";
                        };
    
                        /**
                         * PortSpecification enum.
                         * @name google.cloud.compute.v1.SSLHealthCheck.PortSpecification
                         * @enum {number}
                         * @property {number} UNDEFINED_PORT_SPECIFICATION=0 UNDEFINED_PORT_SPECIFICATION value
                         * @property {number} USE_FIXED_PORT=190235748 USE_FIXED_PORT value
                         * @property {number} USE_NAMED_PORT=349300671 USE_NAMED_PORT value
                         * @property {number} USE_SERVING_PORT=362637516 USE_SERVING_PORT value
                         */
                        SSLHealthCheck.PortSpecification = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PORT_SPECIFICATION"] = 0;
                            values[valuesById[190235748] = "USE_FIXED_PORT"] = 190235748;
                            values[valuesById[349300671] = "USE_NAMED_PORT"] = 349300671;
                            values[valuesById[362637516] = "USE_SERVING_PORT"] = 362637516;
                            return values;
                        })();
    
                        /**
                         * ProxyHeader enum.
                         * @name google.cloud.compute.v1.SSLHealthCheck.ProxyHeader
                         * @enum {number}
                         * @property {number} UNDEFINED_PROXY_HEADER=0 UNDEFINED_PROXY_HEADER value
                         * @property {number} NONE=2402104 NONE value
                         * @property {number} PROXY_V1=334352940 PROXY_V1 value
                         */
                        SSLHealthCheck.ProxyHeader = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PROXY_HEADER"] = 0;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            values[valuesById[334352940] = "PROXY_V1"] = 334352940;
                            return values;
                        })();
    
                        return SSLHealthCheck;
                    })();
    
                    v1.SavedAttachedDisk = (function() {
    
                        /**
                         * Properties of a SavedAttachedDisk.
                         * @memberof google.cloud.compute.v1
                         * @interface ISavedAttachedDisk
                         * @property {boolean|null} [autoDelete] SavedAttachedDisk autoDelete
                         * @property {boolean|null} [boot] SavedAttachedDisk boot
                         * @property {string|null} [deviceName] SavedAttachedDisk deviceName
                         * @property {google.cloud.compute.v1.ICustomerEncryptionKey|null} [diskEncryptionKey] SavedAttachedDisk diskEncryptionKey
                         * @property {number|Long|null} [diskSizeGb] SavedAttachedDisk diskSizeGb
                         * @property {string|null} [diskType] SavedAttachedDisk diskType
                         * @property {Array.<google.cloud.compute.v1.IGuestOsFeature>|null} [guestOsFeatures] SavedAttachedDisk guestOsFeatures
                         * @property {number|null} [index] SavedAttachedDisk index
                         * @property {string|null} ["interface"] SavedAttachedDisk interface
                         * @property {string|null} [kind] SavedAttachedDisk kind
                         * @property {Array.<string>|null} [licenses] SavedAttachedDisk licenses
                         * @property {string|null} [mode] SavedAttachedDisk mode
                         * @property {string|null} [source] SavedAttachedDisk source
                         * @property {number|Long|null} [storageBytes] SavedAttachedDisk storageBytes
                         * @property {string|null} [storageBytesStatus] SavedAttachedDisk storageBytesStatus
                         * @property {string|null} [type] SavedAttachedDisk type
                         */
    
                        /**
                         * Constructs a new SavedAttachedDisk.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SavedAttachedDisk.
                         * @implements ISavedAttachedDisk
                         * @constructor
                         * @param {google.cloud.compute.v1.ISavedAttachedDisk=} [properties] Properties to set
                         */
                        function SavedAttachedDisk(properties) {
                            this.guestOsFeatures = [];
                            this.licenses = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SavedAttachedDisk autoDelete.
                         * @member {boolean|null|undefined} autoDelete
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        SavedAttachedDisk.prototype.autoDelete = null;
    
                        /**
                         * SavedAttachedDisk boot.
                         * @member {boolean|null|undefined} boot
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        SavedAttachedDisk.prototype.boot = null;
    
                        /**
                         * SavedAttachedDisk deviceName.
                         * @member {string|null|undefined} deviceName
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        SavedAttachedDisk.prototype.deviceName = null;
    
                        /**
                         * SavedAttachedDisk diskEncryptionKey.
                         * @member {google.cloud.compute.v1.ICustomerEncryptionKey|null|undefined} diskEncryptionKey
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        SavedAttachedDisk.prototype.diskEncryptionKey = null;
    
                        /**
                         * SavedAttachedDisk diskSizeGb.
                         * @member {number|Long|null|undefined} diskSizeGb
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        SavedAttachedDisk.prototype.diskSizeGb = null;
    
                        /**
                         * SavedAttachedDisk diskType.
                         * @member {string|null|undefined} diskType
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        SavedAttachedDisk.prototype.diskType = null;
    
                        /**
                         * SavedAttachedDisk guestOsFeatures.
                         * @member {Array.<google.cloud.compute.v1.IGuestOsFeature>} guestOsFeatures
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        SavedAttachedDisk.prototype.guestOsFeatures = $util.emptyArray;
    
                        /**
                         * SavedAttachedDisk index.
                         * @member {number|null|undefined} index
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        SavedAttachedDisk.prototype.index = null;
    
                        /**
                         * SavedAttachedDisk interface.
                         * @member {string|null|undefined} interface
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        SavedAttachedDisk.prototype["interface"] = null;
    
                        /**
                         * SavedAttachedDisk kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        SavedAttachedDisk.prototype.kind = null;
    
                        /**
                         * SavedAttachedDisk licenses.
                         * @member {Array.<string>} licenses
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        SavedAttachedDisk.prototype.licenses = $util.emptyArray;
    
                        /**
                         * SavedAttachedDisk mode.
                         * @member {string|null|undefined} mode
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        SavedAttachedDisk.prototype.mode = null;
    
                        /**
                         * SavedAttachedDisk source.
                         * @member {string|null|undefined} source
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        SavedAttachedDisk.prototype.source = null;
    
                        /**
                         * SavedAttachedDisk storageBytes.
                         * @member {number|Long|null|undefined} storageBytes
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        SavedAttachedDisk.prototype.storageBytes = null;
    
                        /**
                         * SavedAttachedDisk storageBytesStatus.
                         * @member {string|null|undefined} storageBytesStatus
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        SavedAttachedDisk.prototype.storageBytesStatus = null;
    
                        /**
                         * SavedAttachedDisk type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        SavedAttachedDisk.prototype.type = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SavedAttachedDisk _autoDelete.
                         * @member {"autoDelete"|undefined} _autoDelete
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        Object.defineProperty(SavedAttachedDisk.prototype, "_autoDelete", {
                            get: $util.oneOfGetter($oneOfFields = ["autoDelete"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SavedAttachedDisk _boot.
                         * @member {"boot"|undefined} _boot
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        Object.defineProperty(SavedAttachedDisk.prototype, "_boot", {
                            get: $util.oneOfGetter($oneOfFields = ["boot"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SavedAttachedDisk _deviceName.
                         * @member {"deviceName"|undefined} _deviceName
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        Object.defineProperty(SavedAttachedDisk.prototype, "_deviceName", {
                            get: $util.oneOfGetter($oneOfFields = ["deviceName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SavedAttachedDisk _diskEncryptionKey.
                         * @member {"diskEncryptionKey"|undefined} _diskEncryptionKey
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        Object.defineProperty(SavedAttachedDisk.prototype, "_diskEncryptionKey", {
                            get: $util.oneOfGetter($oneOfFields = ["diskEncryptionKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SavedAttachedDisk _diskSizeGb.
                         * @member {"diskSizeGb"|undefined} _diskSizeGb
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        Object.defineProperty(SavedAttachedDisk.prototype, "_diskSizeGb", {
                            get: $util.oneOfGetter($oneOfFields = ["diskSizeGb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SavedAttachedDisk _diskType.
                         * @member {"diskType"|undefined} _diskType
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        Object.defineProperty(SavedAttachedDisk.prototype, "_diskType", {
                            get: $util.oneOfGetter($oneOfFields = ["diskType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SavedAttachedDisk _index.
                         * @member {"index"|undefined} _index
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        Object.defineProperty(SavedAttachedDisk.prototype, "_index", {
                            get: $util.oneOfGetter($oneOfFields = ["index"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SavedAttachedDisk _interface.
                         * @member {"interface"|undefined} _interface
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        Object.defineProperty(SavedAttachedDisk.prototype, "_interface", {
                            get: $util.oneOfGetter($oneOfFields = ["interface"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SavedAttachedDisk _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        Object.defineProperty(SavedAttachedDisk.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SavedAttachedDisk _mode.
                         * @member {"mode"|undefined} _mode
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        Object.defineProperty(SavedAttachedDisk.prototype, "_mode", {
                            get: $util.oneOfGetter($oneOfFields = ["mode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SavedAttachedDisk _source.
                         * @member {"source"|undefined} _source
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        Object.defineProperty(SavedAttachedDisk.prototype, "_source", {
                            get: $util.oneOfGetter($oneOfFields = ["source"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SavedAttachedDisk _storageBytes.
                         * @member {"storageBytes"|undefined} _storageBytes
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        Object.defineProperty(SavedAttachedDisk.prototype, "_storageBytes", {
                            get: $util.oneOfGetter($oneOfFields = ["storageBytes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SavedAttachedDisk _storageBytesStatus.
                         * @member {"storageBytesStatus"|undefined} _storageBytesStatus
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        Object.defineProperty(SavedAttachedDisk.prototype, "_storageBytesStatus", {
                            get: $util.oneOfGetter($oneOfFields = ["storageBytesStatus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SavedAttachedDisk _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         */
                        Object.defineProperty(SavedAttachedDisk.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SavedAttachedDisk instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @static
                         * @param {google.cloud.compute.v1.ISavedAttachedDisk=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SavedAttachedDisk} SavedAttachedDisk instance
                         */
                        SavedAttachedDisk.create = function create(properties) {
                            return new SavedAttachedDisk(properties);
                        };
    
                        /**
                         * Encodes the specified SavedAttachedDisk message. Does not implicitly {@link google.cloud.compute.v1.SavedAttachedDisk.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @static
                         * @param {google.cloud.compute.v1.ISavedAttachedDisk} message SavedAttachedDisk message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SavedAttachedDisk.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.boot != null && Object.hasOwnProperty.call(message, "boot"))
                                writer.uint32(/* id 3029746, wireType 0 =*/24237968).bool(message.boot);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.mode != null && Object.hasOwnProperty.call(message, "mode"))
                                writer.uint32(/* id 3357091, wireType 2 =*/26856730).string(message.mode);
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            if (message.deviceName != null && Object.hasOwnProperty.call(message, "deviceName"))
                                writer.uint32(/* id 67541716, wireType 2 =*/540333730).string(message.deviceName);
                            if (message.guestOsFeatures != null && message.guestOsFeatures.length)
                                for (var i = 0; i < message.guestOsFeatures.length; ++i)
                                    $root.google.cloud.compute.v1.GuestOsFeature.encode(message.guestOsFeatures[i], writer.uint32(/* id 79294545, wireType 2 =*/634356362).fork()).ldelim();
                            if (message.diskType != null && Object.hasOwnProperty.call(message, "diskType"))
                                writer.uint32(/* id 93009052, wireType 2 =*/744072418).string(message.diskType);
                            if (message.index != null && Object.hasOwnProperty.call(message, "index"))
                                writer.uint32(/* id 100346066, wireType 0 =*/802768528).int32(message.index);
                            if (message.source != null && Object.hasOwnProperty.call(message, "source"))
                                writer.uint32(/* id 177235995, wireType 2 =*/1417887962).string(message.source);
                            if (message.diskEncryptionKey != null && Object.hasOwnProperty.call(message, "diskEncryptionKey"))
                                $root.google.cloud.compute.v1.CustomerEncryptionKey.encode(message.diskEncryptionKey, writer.uint32(/* id 271660677, wireType 2 =*/2173285418).fork()).ldelim();
                            if (message.diskSizeGb != null && Object.hasOwnProperty.call(message, "diskSizeGb"))
                                writer.uint32(/* id 316263735, wireType 0 =*/2530109880).int64(message.diskSizeGb);
                            if (message.licenses != null && message.licenses.length)
                                for (var i = 0; i < message.licenses.length; ++i)
                                    writer.uint32(/* id 337642578, wireType 2 =*/2701140626).string(message.licenses[i]);
                            if (message.storageBytes != null && Object.hasOwnProperty.call(message, "storageBytes"))
                                writer.uint32(/* id 424631719, wireType 0 =*/3397053752).int64(message.storageBytes);
                            if (message.autoDelete != null && Object.hasOwnProperty.call(message, "autoDelete"))
                                writer.uint32(/* id 464761403, wireType 0 =*/3718091224).bool(message.autoDelete);
                            if (message.storageBytesStatus != null && Object.hasOwnProperty.call(message, "storageBytesStatus"))
                                writer.uint32(/* id 490739082, wireType 2 =*/3925912658).string(message.storageBytesStatus);
                            if (message["interface"] != null && Object.hasOwnProperty.call(message, "interface"))
                                writer.uint32(/* id 502623545, wireType 2 =*/4020988362).string(message["interface"]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SavedAttachedDisk message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SavedAttachedDisk.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @static
                         * @param {google.cloud.compute.v1.ISavedAttachedDisk} message SavedAttachedDisk message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SavedAttachedDisk.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SavedAttachedDisk message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SavedAttachedDisk} SavedAttachedDisk
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SavedAttachedDisk.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SavedAttachedDisk();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 464761403: {
                                        message.autoDelete = reader.bool();
                                        break;
                                    }
                                case 3029746: {
                                        message.boot = reader.bool();
                                        break;
                                    }
                                case 67541716: {
                                        message.deviceName = reader.string();
                                        break;
                                    }
                                case 271660677: {
                                        message.diskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 316263735: {
                                        message.diskSizeGb = reader.int64();
                                        break;
                                    }
                                case 93009052: {
                                        message.diskType = reader.string();
                                        break;
                                    }
                                case 79294545: {
                                        if (!(message.guestOsFeatures && message.guestOsFeatures.length))
                                            message.guestOsFeatures = [];
                                        message.guestOsFeatures.push($root.google.cloud.compute.v1.GuestOsFeature.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 100346066: {
                                        message.index = reader.int32();
                                        break;
                                    }
                                case 502623545: {
                                        message["interface"] = reader.string();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 337642578: {
                                        if (!(message.licenses && message.licenses.length))
                                            message.licenses = [];
                                        message.licenses.push(reader.string());
                                        break;
                                    }
                                case 3357091: {
                                        message.mode = reader.string();
                                        break;
                                    }
                                case 177235995: {
                                        message.source = reader.string();
                                        break;
                                    }
                                case 424631719: {
                                        message.storageBytes = reader.int64();
                                        break;
                                    }
                                case 490739082: {
                                        message.storageBytesStatus = reader.string();
                                        break;
                                    }
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SavedAttachedDisk message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SavedAttachedDisk} SavedAttachedDisk
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SavedAttachedDisk.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SavedAttachedDisk message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SavedAttachedDisk.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoDelete != null && message.hasOwnProperty("autoDelete")) {
                                properties._autoDelete = 1;
                                if (typeof message.autoDelete !== "boolean")
                                    return "autoDelete: boolean expected";
                            }
                            if (message.boot != null && message.hasOwnProperty("boot")) {
                                properties._boot = 1;
                                if (typeof message.boot !== "boolean")
                                    return "boot: boolean expected";
                            }
                            if (message.deviceName != null && message.hasOwnProperty("deviceName")) {
                                properties._deviceName = 1;
                                if (!$util.isString(message.deviceName))
                                    return "deviceName: string expected";
                            }
                            if (message.diskEncryptionKey != null && message.hasOwnProperty("diskEncryptionKey")) {
                                properties._diskEncryptionKey = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.CustomerEncryptionKey.verify(message.diskEncryptionKey);
                                    if (error)
                                        return "diskEncryptionKey." + error;
                                }
                            }
                            if (message.diskSizeGb != null && message.hasOwnProperty("diskSizeGb")) {
                                properties._diskSizeGb = 1;
                                if (!$util.isInteger(message.diskSizeGb) && !(message.diskSizeGb && $util.isInteger(message.diskSizeGb.low) && $util.isInteger(message.diskSizeGb.high)))
                                    return "diskSizeGb: integer|Long expected";
                            }
                            if (message.diskType != null && message.hasOwnProperty("diskType")) {
                                properties._diskType = 1;
                                if (!$util.isString(message.diskType))
                                    return "diskType: string expected";
                            }
                            if (message.guestOsFeatures != null && message.hasOwnProperty("guestOsFeatures")) {
                                if (!Array.isArray(message.guestOsFeatures))
                                    return "guestOsFeatures: array expected";
                                for (var i = 0; i < message.guestOsFeatures.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.GuestOsFeature.verify(message.guestOsFeatures[i]);
                                    if (error)
                                        return "guestOsFeatures." + error;
                                }
                            }
                            if (message.index != null && message.hasOwnProperty("index")) {
                                properties._index = 1;
                                if (!$util.isInteger(message.index))
                                    return "index: integer expected";
                            }
                            if (message["interface"] != null && message.hasOwnProperty("interface")) {
                                properties._interface = 1;
                                if (!$util.isString(message["interface"]))
                                    return "interface: string expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.licenses != null && message.hasOwnProperty("licenses")) {
                                if (!Array.isArray(message.licenses))
                                    return "licenses: array expected";
                                for (var i = 0; i < message.licenses.length; ++i)
                                    if (!$util.isString(message.licenses[i]))
                                        return "licenses: string[] expected";
                            }
                            if (message.mode != null && message.hasOwnProperty("mode")) {
                                properties._mode = 1;
                                if (!$util.isString(message.mode))
                                    return "mode: string expected";
                            }
                            if (message.source != null && message.hasOwnProperty("source")) {
                                properties._source = 1;
                                if (!$util.isString(message.source))
                                    return "source: string expected";
                            }
                            if (message.storageBytes != null && message.hasOwnProperty("storageBytes")) {
                                properties._storageBytes = 1;
                                if (!$util.isInteger(message.storageBytes) && !(message.storageBytes && $util.isInteger(message.storageBytes.low) && $util.isInteger(message.storageBytes.high)))
                                    return "storageBytes: integer|Long expected";
                            }
                            if (message.storageBytesStatus != null && message.hasOwnProperty("storageBytesStatus")) {
                                properties._storageBytesStatus = 1;
                                if (!$util.isString(message.storageBytesStatus))
                                    return "storageBytesStatus: string expected";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SavedAttachedDisk message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SavedAttachedDisk} SavedAttachedDisk
                         */
                        SavedAttachedDisk.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SavedAttachedDisk)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SavedAttachedDisk();
                            if (object.autoDelete != null)
                                message.autoDelete = Boolean(object.autoDelete);
                            if (object.boot != null)
                                message.boot = Boolean(object.boot);
                            if (object.deviceName != null)
                                message.deviceName = String(object.deviceName);
                            if (object.diskEncryptionKey != null) {
                                if (typeof object.diskEncryptionKey !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SavedAttachedDisk.diskEncryptionKey: object expected");
                                message.diskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.fromObject(object.diskEncryptionKey);
                            }
                            if (object.diskSizeGb != null)
                                if ($util.Long)
                                    (message.diskSizeGb = $util.Long.fromValue(object.diskSizeGb)).unsigned = false;
                                else if (typeof object.diskSizeGb === "string")
                                    message.diskSizeGb = parseInt(object.diskSizeGb, 10);
                                else if (typeof object.diskSizeGb === "number")
                                    message.diskSizeGb = object.diskSizeGb;
                                else if (typeof object.diskSizeGb === "object")
                                    message.diskSizeGb = new $util.LongBits(object.diskSizeGb.low >>> 0, object.diskSizeGb.high >>> 0).toNumber();
                            if (object.diskType != null)
                                message.diskType = String(object.diskType);
                            if (object.guestOsFeatures) {
                                if (!Array.isArray(object.guestOsFeatures))
                                    throw TypeError(".google.cloud.compute.v1.SavedAttachedDisk.guestOsFeatures: array expected");
                                message.guestOsFeatures = [];
                                for (var i = 0; i < object.guestOsFeatures.length; ++i) {
                                    if (typeof object.guestOsFeatures[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SavedAttachedDisk.guestOsFeatures: object expected");
                                    message.guestOsFeatures[i] = $root.google.cloud.compute.v1.GuestOsFeature.fromObject(object.guestOsFeatures[i]);
                                }
                            }
                            if (object.index != null)
                                message.index = object.index | 0;
                            if (object["interface"] != null)
                                message["interface"] = String(object["interface"]);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.licenses) {
                                if (!Array.isArray(object.licenses))
                                    throw TypeError(".google.cloud.compute.v1.SavedAttachedDisk.licenses: array expected");
                                message.licenses = [];
                                for (var i = 0; i < object.licenses.length; ++i)
                                    message.licenses[i] = String(object.licenses[i]);
                            }
                            if (object.mode != null)
                                message.mode = String(object.mode);
                            if (object.source != null)
                                message.source = String(object.source);
                            if (object.storageBytes != null)
                                if ($util.Long)
                                    (message.storageBytes = $util.Long.fromValue(object.storageBytes)).unsigned = false;
                                else if (typeof object.storageBytes === "string")
                                    message.storageBytes = parseInt(object.storageBytes, 10);
                                else if (typeof object.storageBytes === "number")
                                    message.storageBytes = object.storageBytes;
                                else if (typeof object.storageBytes === "object")
                                    message.storageBytes = new $util.LongBits(object.storageBytes.low >>> 0, object.storageBytes.high >>> 0).toNumber();
                            if (object.storageBytesStatus != null)
                                message.storageBytesStatus = String(object.storageBytesStatus);
                            if (object.type != null)
                                message.type = String(object.type);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SavedAttachedDisk message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @static
                         * @param {google.cloud.compute.v1.SavedAttachedDisk} message SavedAttachedDisk
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SavedAttachedDisk.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.guestOsFeatures = [];
                                object.licenses = [];
                            }
                            if (message.boot != null && message.hasOwnProperty("boot")) {
                                object.boot = message.boot;
                                if (options.oneofs)
                                    object._boot = "boot";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.mode != null && message.hasOwnProperty("mode")) {
                                object.mode = message.mode;
                                if (options.oneofs)
                                    object._mode = "mode";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            if (message.deviceName != null && message.hasOwnProperty("deviceName")) {
                                object.deviceName = message.deviceName;
                                if (options.oneofs)
                                    object._deviceName = "deviceName";
                            }
                            if (message.guestOsFeatures && message.guestOsFeatures.length) {
                                object.guestOsFeatures = [];
                                for (var j = 0; j < message.guestOsFeatures.length; ++j)
                                    object.guestOsFeatures[j] = $root.google.cloud.compute.v1.GuestOsFeature.toObject(message.guestOsFeatures[j], options);
                            }
                            if (message.diskType != null && message.hasOwnProperty("diskType")) {
                                object.diskType = message.diskType;
                                if (options.oneofs)
                                    object._diskType = "diskType";
                            }
                            if (message.index != null && message.hasOwnProperty("index")) {
                                object.index = message.index;
                                if (options.oneofs)
                                    object._index = "index";
                            }
                            if (message.source != null && message.hasOwnProperty("source")) {
                                object.source = message.source;
                                if (options.oneofs)
                                    object._source = "source";
                            }
                            if (message.diskEncryptionKey != null && message.hasOwnProperty("diskEncryptionKey")) {
                                object.diskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.toObject(message.diskEncryptionKey, options);
                                if (options.oneofs)
                                    object._diskEncryptionKey = "diskEncryptionKey";
                            }
                            if (message.diskSizeGb != null && message.hasOwnProperty("diskSizeGb")) {
                                if (typeof message.diskSizeGb === "number")
                                    object.diskSizeGb = options.longs === String ? String(message.diskSizeGb) : message.diskSizeGb;
                                else
                                    object.diskSizeGb = options.longs === String ? $util.Long.prototype.toString.call(message.diskSizeGb) : options.longs === Number ? new $util.LongBits(message.diskSizeGb.low >>> 0, message.diskSizeGb.high >>> 0).toNumber() : message.diskSizeGb;
                                if (options.oneofs)
                                    object._diskSizeGb = "diskSizeGb";
                            }
                            if (message.licenses && message.licenses.length) {
                                object.licenses = [];
                                for (var j = 0; j < message.licenses.length; ++j)
                                    object.licenses[j] = message.licenses[j];
                            }
                            if (message.storageBytes != null && message.hasOwnProperty("storageBytes")) {
                                if (typeof message.storageBytes === "number")
                                    object.storageBytes = options.longs === String ? String(message.storageBytes) : message.storageBytes;
                                else
                                    object.storageBytes = options.longs === String ? $util.Long.prototype.toString.call(message.storageBytes) : options.longs === Number ? new $util.LongBits(message.storageBytes.low >>> 0, message.storageBytes.high >>> 0).toNumber() : message.storageBytes;
                                if (options.oneofs)
                                    object._storageBytes = "storageBytes";
                            }
                            if (message.autoDelete != null && message.hasOwnProperty("autoDelete")) {
                                object.autoDelete = message.autoDelete;
                                if (options.oneofs)
                                    object._autoDelete = "autoDelete";
                            }
                            if (message.storageBytesStatus != null && message.hasOwnProperty("storageBytesStatus")) {
                                object.storageBytesStatus = message.storageBytesStatus;
                                if (options.oneofs)
                                    object._storageBytesStatus = "storageBytesStatus";
                            }
                            if (message["interface"] != null && message.hasOwnProperty("interface")) {
                                object["interface"] = message["interface"];
                                if (options.oneofs)
                                    object._interface = "interface";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SavedAttachedDisk to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SavedAttachedDisk.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SavedAttachedDisk
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SavedAttachedDisk
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SavedAttachedDisk.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SavedAttachedDisk";
                        };
    
                        /**
                         * Interface enum.
                         * @name google.cloud.compute.v1.SavedAttachedDisk.Interface
                         * @enum {number}
                         * @property {number} UNDEFINED_INTERFACE=0 UNDEFINED_INTERFACE value
                         * @property {number} NVME=2408800 NVME value
                         * @property {number} SCSI=2539686 SCSI value
                         */
                        SavedAttachedDisk.Interface = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_INTERFACE"] = 0;
                            values[valuesById[2408800] = "NVME"] = 2408800;
                            values[valuesById[2539686] = "SCSI"] = 2539686;
                            return values;
                        })();
    
                        /**
                         * Mode enum.
                         * @name google.cloud.compute.v1.SavedAttachedDisk.Mode
                         * @enum {number}
                         * @property {number} UNDEFINED_MODE=0 UNDEFINED_MODE value
                         * @property {number} READ_ONLY=91950261 READ_ONLY value
                         * @property {number} READ_WRITE=173607894 READ_WRITE value
                         */
                        SavedAttachedDisk.Mode = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_MODE"] = 0;
                            values[valuesById[91950261] = "READ_ONLY"] = 91950261;
                            values[valuesById[173607894] = "READ_WRITE"] = 173607894;
                            return values;
                        })();
    
                        /**
                         * StorageBytesStatus enum.
                         * @name google.cloud.compute.v1.SavedAttachedDisk.StorageBytesStatus
                         * @enum {number}
                         * @property {number} UNDEFINED_STORAGE_BYTES_STATUS=0 UNDEFINED_STORAGE_BYTES_STATUS value
                         * @property {number} UPDATING=494614342 UPDATING value
                         * @property {number} UP_TO_DATE=101306702 UP_TO_DATE value
                         */
                        SavedAttachedDisk.StorageBytesStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STORAGE_BYTES_STATUS"] = 0;
                            values[valuesById[494614342] = "UPDATING"] = 494614342;
                            values[valuesById[101306702] = "UP_TO_DATE"] = 101306702;
                            return values;
                        })();
    
                        /**
                         * Type enum.
                         * @name google.cloud.compute.v1.SavedAttachedDisk.Type
                         * @enum {number}
                         * @property {number} UNDEFINED_TYPE=0 UNDEFINED_TYPE value
                         * @property {number} PERSISTENT=460683927 PERSISTENT value
                         * @property {number} SCRATCH=496778970 SCRATCH value
                         */
                        SavedAttachedDisk.Type = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TYPE"] = 0;
                            values[valuesById[460683927] = "PERSISTENT"] = 460683927;
                            values[valuesById[496778970] = "SCRATCH"] = 496778970;
                            return values;
                        })();
    
                        return SavedAttachedDisk;
                    })();
    
                    v1.SavedDisk = (function() {
    
                        /**
                         * Properties of a SavedDisk.
                         * @memberof google.cloud.compute.v1
                         * @interface ISavedDisk
                         * @property {string|null} [architecture] SavedDisk architecture
                         * @property {string|null} [kind] SavedDisk kind
                         * @property {string|null} [sourceDisk] SavedDisk sourceDisk
                         * @property {number|Long|null} [storageBytes] SavedDisk storageBytes
                         * @property {string|null} [storageBytesStatus] SavedDisk storageBytesStatus
                         */
    
                        /**
                         * Constructs a new SavedDisk.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SavedDisk.
                         * @implements ISavedDisk
                         * @constructor
                         * @param {google.cloud.compute.v1.ISavedDisk=} [properties] Properties to set
                         */
                        function SavedDisk(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SavedDisk architecture.
                         * @member {string|null|undefined} architecture
                         * @memberof google.cloud.compute.v1.SavedDisk
                         * @instance
                         */
                        SavedDisk.prototype.architecture = null;
    
                        /**
                         * SavedDisk kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.SavedDisk
                         * @instance
                         */
                        SavedDisk.prototype.kind = null;
    
                        /**
                         * SavedDisk sourceDisk.
                         * @member {string|null|undefined} sourceDisk
                         * @memberof google.cloud.compute.v1.SavedDisk
                         * @instance
                         */
                        SavedDisk.prototype.sourceDisk = null;
    
                        /**
                         * SavedDisk storageBytes.
                         * @member {number|Long|null|undefined} storageBytes
                         * @memberof google.cloud.compute.v1.SavedDisk
                         * @instance
                         */
                        SavedDisk.prototype.storageBytes = null;
    
                        /**
                         * SavedDisk storageBytesStatus.
                         * @member {string|null|undefined} storageBytesStatus
                         * @memberof google.cloud.compute.v1.SavedDisk
                         * @instance
                         */
                        SavedDisk.prototype.storageBytesStatus = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SavedDisk _architecture.
                         * @member {"architecture"|undefined} _architecture
                         * @memberof google.cloud.compute.v1.SavedDisk
                         * @instance
                         */
                        Object.defineProperty(SavedDisk.prototype, "_architecture", {
                            get: $util.oneOfGetter($oneOfFields = ["architecture"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SavedDisk _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.SavedDisk
                         * @instance
                         */
                        Object.defineProperty(SavedDisk.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SavedDisk _sourceDisk.
                         * @member {"sourceDisk"|undefined} _sourceDisk
                         * @memberof google.cloud.compute.v1.SavedDisk
                         * @instance
                         */
                        Object.defineProperty(SavedDisk.prototype, "_sourceDisk", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceDisk"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SavedDisk _storageBytes.
                         * @member {"storageBytes"|undefined} _storageBytes
                         * @memberof google.cloud.compute.v1.SavedDisk
                         * @instance
                         */
                        Object.defineProperty(SavedDisk.prototype, "_storageBytes", {
                            get: $util.oneOfGetter($oneOfFields = ["storageBytes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SavedDisk _storageBytesStatus.
                         * @member {"storageBytesStatus"|undefined} _storageBytesStatus
                         * @memberof google.cloud.compute.v1.SavedDisk
                         * @instance
                         */
                        Object.defineProperty(SavedDisk.prototype, "_storageBytesStatus", {
                            get: $util.oneOfGetter($oneOfFields = ["storageBytesStatus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SavedDisk instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SavedDisk
                         * @static
                         * @param {google.cloud.compute.v1.ISavedDisk=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SavedDisk} SavedDisk instance
                         */
                        SavedDisk.create = function create(properties) {
                            return new SavedDisk(properties);
                        };
    
                        /**
                         * Encodes the specified SavedDisk message. Does not implicitly {@link google.cloud.compute.v1.SavedDisk.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SavedDisk
                         * @static
                         * @param {google.cloud.compute.v1.ISavedDisk} message SavedDisk message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SavedDisk.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.architecture != null && Object.hasOwnProperty.call(message, "architecture"))
                                writer.uint32(/* id 302803283, wireType 2 =*/2422426266).string(message.architecture);
                            if (message.storageBytes != null && Object.hasOwnProperty.call(message, "storageBytes"))
                                writer.uint32(/* id 424631719, wireType 0 =*/3397053752).int64(message.storageBytes);
                            if (message.sourceDisk != null && Object.hasOwnProperty.call(message, "sourceDisk"))
                                writer.uint32(/* id 451753793, wireType 2 =*/3614030346).string(message.sourceDisk);
                            if (message.storageBytesStatus != null && Object.hasOwnProperty.call(message, "storageBytesStatus"))
                                writer.uint32(/* id 490739082, wireType 2 =*/3925912658).string(message.storageBytesStatus);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SavedDisk message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SavedDisk.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SavedDisk
                         * @static
                         * @param {google.cloud.compute.v1.ISavedDisk} message SavedDisk message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SavedDisk.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SavedDisk message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SavedDisk
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SavedDisk} SavedDisk
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SavedDisk.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SavedDisk();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 302803283: {
                                        message.architecture = reader.string();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 451753793: {
                                        message.sourceDisk = reader.string();
                                        break;
                                    }
                                case 424631719: {
                                        message.storageBytes = reader.int64();
                                        break;
                                    }
                                case 490739082: {
                                        message.storageBytesStatus = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SavedDisk message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SavedDisk
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SavedDisk} SavedDisk
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SavedDisk.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SavedDisk message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SavedDisk
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SavedDisk.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.architecture != null && message.hasOwnProperty("architecture")) {
                                properties._architecture = 1;
                                if (!$util.isString(message.architecture))
                                    return "architecture: string expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.sourceDisk != null && message.hasOwnProperty("sourceDisk")) {
                                properties._sourceDisk = 1;
                                if (!$util.isString(message.sourceDisk))
                                    return "sourceDisk: string expected";
                            }
                            if (message.storageBytes != null && message.hasOwnProperty("storageBytes")) {
                                properties._storageBytes = 1;
                                if (!$util.isInteger(message.storageBytes) && !(message.storageBytes && $util.isInteger(message.storageBytes.low) && $util.isInteger(message.storageBytes.high)))
                                    return "storageBytes: integer|Long expected";
                            }
                            if (message.storageBytesStatus != null && message.hasOwnProperty("storageBytesStatus")) {
                                properties._storageBytesStatus = 1;
                                if (!$util.isString(message.storageBytesStatus))
                                    return "storageBytesStatus: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SavedDisk message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SavedDisk
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SavedDisk} SavedDisk
                         */
                        SavedDisk.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SavedDisk)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SavedDisk();
                            if (object.architecture != null)
                                message.architecture = String(object.architecture);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.sourceDisk != null)
                                message.sourceDisk = String(object.sourceDisk);
                            if (object.storageBytes != null)
                                if ($util.Long)
                                    (message.storageBytes = $util.Long.fromValue(object.storageBytes)).unsigned = false;
                                else if (typeof object.storageBytes === "string")
                                    message.storageBytes = parseInt(object.storageBytes, 10);
                                else if (typeof object.storageBytes === "number")
                                    message.storageBytes = object.storageBytes;
                                else if (typeof object.storageBytes === "object")
                                    message.storageBytes = new $util.LongBits(object.storageBytes.low >>> 0, object.storageBytes.high >>> 0).toNumber();
                            if (object.storageBytesStatus != null)
                                message.storageBytesStatus = String(object.storageBytesStatus);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SavedDisk message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SavedDisk
                         * @static
                         * @param {google.cloud.compute.v1.SavedDisk} message SavedDisk
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SavedDisk.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.architecture != null && message.hasOwnProperty("architecture")) {
                                object.architecture = message.architecture;
                                if (options.oneofs)
                                    object._architecture = "architecture";
                            }
                            if (message.storageBytes != null && message.hasOwnProperty("storageBytes")) {
                                if (typeof message.storageBytes === "number")
                                    object.storageBytes = options.longs === String ? String(message.storageBytes) : message.storageBytes;
                                else
                                    object.storageBytes = options.longs === String ? $util.Long.prototype.toString.call(message.storageBytes) : options.longs === Number ? new $util.LongBits(message.storageBytes.low >>> 0, message.storageBytes.high >>> 0).toNumber() : message.storageBytes;
                                if (options.oneofs)
                                    object._storageBytes = "storageBytes";
                            }
                            if (message.sourceDisk != null && message.hasOwnProperty("sourceDisk")) {
                                object.sourceDisk = message.sourceDisk;
                                if (options.oneofs)
                                    object._sourceDisk = "sourceDisk";
                            }
                            if (message.storageBytesStatus != null && message.hasOwnProperty("storageBytesStatus")) {
                                object.storageBytesStatus = message.storageBytesStatus;
                                if (options.oneofs)
                                    object._storageBytesStatus = "storageBytesStatus";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SavedDisk to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SavedDisk
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SavedDisk.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SavedDisk
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SavedDisk
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SavedDisk.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SavedDisk";
                        };
    
                        /**
                         * Architecture enum.
                         * @name google.cloud.compute.v1.SavedDisk.Architecture
                         * @enum {number}
                         * @property {number} UNDEFINED_ARCHITECTURE=0 UNDEFINED_ARCHITECTURE value
                         * @property {number} ARCHITECTURE_UNSPECIFIED=394750507 ARCHITECTURE_UNSPECIFIED value
                         * @property {number} ARM64=62547450 ARM64 value
                         * @property {number} X86_64=425300551 X86_64 value
                         */
                        SavedDisk.Architecture = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ARCHITECTURE"] = 0;
                            values[valuesById[394750507] = "ARCHITECTURE_UNSPECIFIED"] = 394750507;
                            values[valuesById[62547450] = "ARM64"] = 62547450;
                            values[valuesById[425300551] = "X86_64"] = 425300551;
                            return values;
                        })();
    
                        /**
                         * StorageBytesStatus enum.
                         * @name google.cloud.compute.v1.SavedDisk.StorageBytesStatus
                         * @enum {number}
                         * @property {number} UNDEFINED_STORAGE_BYTES_STATUS=0 UNDEFINED_STORAGE_BYTES_STATUS value
                         * @property {number} UPDATING=494614342 UPDATING value
                         * @property {number} UP_TO_DATE=101306702 UP_TO_DATE value
                         */
                        SavedDisk.StorageBytesStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STORAGE_BYTES_STATUS"] = 0;
                            values[valuesById[494614342] = "UPDATING"] = 494614342;
                            values[valuesById[101306702] = "UP_TO_DATE"] = 101306702;
                            return values;
                        })();
    
                        return SavedDisk;
                    })();
    
                    v1.ScalingScheduleStatus = (function() {
    
                        /**
                         * Properties of a ScalingScheduleStatus.
                         * @memberof google.cloud.compute.v1
                         * @interface IScalingScheduleStatus
                         * @property {string|null} [lastStartTime] ScalingScheduleStatus lastStartTime
                         * @property {string|null} [nextStartTime] ScalingScheduleStatus nextStartTime
                         * @property {string|null} [state] ScalingScheduleStatus state
                         */
    
                        /**
                         * Constructs a new ScalingScheduleStatus.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ScalingScheduleStatus.
                         * @implements IScalingScheduleStatus
                         * @constructor
                         * @param {google.cloud.compute.v1.IScalingScheduleStatus=} [properties] Properties to set
                         */
                        function ScalingScheduleStatus(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ScalingScheduleStatus lastStartTime.
                         * @member {string|null|undefined} lastStartTime
                         * @memberof google.cloud.compute.v1.ScalingScheduleStatus
                         * @instance
                         */
                        ScalingScheduleStatus.prototype.lastStartTime = null;
    
                        /**
                         * ScalingScheduleStatus nextStartTime.
                         * @member {string|null|undefined} nextStartTime
                         * @memberof google.cloud.compute.v1.ScalingScheduleStatus
                         * @instance
                         */
                        ScalingScheduleStatus.prototype.nextStartTime = null;
    
                        /**
                         * ScalingScheduleStatus state.
                         * @member {string|null|undefined} state
                         * @memberof google.cloud.compute.v1.ScalingScheduleStatus
                         * @instance
                         */
                        ScalingScheduleStatus.prototype.state = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ScalingScheduleStatus _lastStartTime.
                         * @member {"lastStartTime"|undefined} _lastStartTime
                         * @memberof google.cloud.compute.v1.ScalingScheduleStatus
                         * @instance
                         */
                        Object.defineProperty(ScalingScheduleStatus.prototype, "_lastStartTime", {
                            get: $util.oneOfGetter($oneOfFields = ["lastStartTime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ScalingScheduleStatus _nextStartTime.
                         * @member {"nextStartTime"|undefined} _nextStartTime
                         * @memberof google.cloud.compute.v1.ScalingScheduleStatus
                         * @instance
                         */
                        Object.defineProperty(ScalingScheduleStatus.prototype, "_nextStartTime", {
                            get: $util.oneOfGetter($oneOfFields = ["nextStartTime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ScalingScheduleStatus _state.
                         * @member {"state"|undefined} _state
                         * @memberof google.cloud.compute.v1.ScalingScheduleStatus
                         * @instance
                         */
                        Object.defineProperty(ScalingScheduleStatus.prototype, "_state", {
                            get: $util.oneOfGetter($oneOfFields = ["state"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ScalingScheduleStatus instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ScalingScheduleStatus
                         * @static
                         * @param {google.cloud.compute.v1.IScalingScheduleStatus=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ScalingScheduleStatus} ScalingScheduleStatus instance
                         */
                        ScalingScheduleStatus.create = function create(properties) {
                            return new ScalingScheduleStatus(properties);
                        };
    
                        /**
                         * Encodes the specified ScalingScheduleStatus message. Does not implicitly {@link google.cloud.compute.v1.ScalingScheduleStatus.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ScalingScheduleStatus
                         * @static
                         * @param {google.cloud.compute.v1.IScalingScheduleStatus} message ScalingScheduleStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ScalingScheduleStatus.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.lastStartTime != null && Object.hasOwnProperty.call(message, "lastStartTime"))
                                writer.uint32(/* id 34545107, wireType 2 =*/276360858).string(message.lastStartTime);
                            if (message.nextStartTime != null && Object.hasOwnProperty.call(message, "nextStartTime"))
                                writer.uint32(/* id 97270102, wireType 2 =*/778160818).string(message.nextStartTime);
                            if (message.state != null && Object.hasOwnProperty.call(message, "state"))
                                writer.uint32(/* id 109757585, wireType 2 =*/878060682).string(message.state);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ScalingScheduleStatus message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ScalingScheduleStatus.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ScalingScheduleStatus
                         * @static
                         * @param {google.cloud.compute.v1.IScalingScheduleStatus} message ScalingScheduleStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ScalingScheduleStatus.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ScalingScheduleStatus message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ScalingScheduleStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ScalingScheduleStatus} ScalingScheduleStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ScalingScheduleStatus.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ScalingScheduleStatus();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 34545107: {
                                        message.lastStartTime = reader.string();
                                        break;
                                    }
                                case 97270102: {
                                        message.nextStartTime = reader.string();
                                        break;
                                    }
                                case 109757585: {
                                        message.state = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ScalingScheduleStatus message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ScalingScheduleStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ScalingScheduleStatus} ScalingScheduleStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ScalingScheduleStatus.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ScalingScheduleStatus message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ScalingScheduleStatus
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ScalingScheduleStatus.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.lastStartTime != null && message.hasOwnProperty("lastStartTime")) {
                                properties._lastStartTime = 1;
                                if (!$util.isString(message.lastStartTime))
                                    return "lastStartTime: string expected";
                            }
                            if (message.nextStartTime != null && message.hasOwnProperty("nextStartTime")) {
                                properties._nextStartTime = 1;
                                if (!$util.isString(message.nextStartTime))
                                    return "nextStartTime: string expected";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                properties._state = 1;
                                if (!$util.isString(message.state))
                                    return "state: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ScalingScheduleStatus message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ScalingScheduleStatus
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ScalingScheduleStatus} ScalingScheduleStatus
                         */
                        ScalingScheduleStatus.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ScalingScheduleStatus)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ScalingScheduleStatus();
                            if (object.lastStartTime != null)
                                message.lastStartTime = String(object.lastStartTime);
                            if (object.nextStartTime != null)
                                message.nextStartTime = String(object.nextStartTime);
                            if (object.state != null)
                                message.state = String(object.state);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ScalingScheduleStatus message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ScalingScheduleStatus
                         * @static
                         * @param {google.cloud.compute.v1.ScalingScheduleStatus} message ScalingScheduleStatus
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ScalingScheduleStatus.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.lastStartTime != null && message.hasOwnProperty("lastStartTime")) {
                                object.lastStartTime = message.lastStartTime;
                                if (options.oneofs)
                                    object._lastStartTime = "lastStartTime";
                            }
                            if (message.nextStartTime != null && message.hasOwnProperty("nextStartTime")) {
                                object.nextStartTime = message.nextStartTime;
                                if (options.oneofs)
                                    object._nextStartTime = "nextStartTime";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                object.state = message.state;
                                if (options.oneofs)
                                    object._state = "state";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ScalingScheduleStatus to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ScalingScheduleStatus
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ScalingScheduleStatus.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ScalingScheduleStatus
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ScalingScheduleStatus
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ScalingScheduleStatus.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ScalingScheduleStatus";
                        };
    
                        /**
                         * State enum.
                         * @name google.cloud.compute.v1.ScalingScheduleStatus.State
                         * @enum {number}
                         * @property {number} UNDEFINED_STATE=0 UNDEFINED_STATE value
                         * @property {number} ACTIVE=314733318 ACTIVE value
                         * @property {number} DISABLED=516696700 DISABLED value
                         * @property {number} OBSOLETE=66532761 OBSOLETE value
                         * @property {number} READY=77848963 READY value
                         */
                        ScalingScheduleStatus.State = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATE"] = 0;
                            values[valuesById[314733318] = "ACTIVE"] = 314733318;
                            values[valuesById[516696700] = "DISABLED"] = 516696700;
                            values[valuesById[66532761] = "OBSOLETE"] = 66532761;
                            values[valuesById[77848963] = "READY"] = 77848963;
                            return values;
                        })();
    
                        return ScalingScheduleStatus;
                    })();
    
                    v1.Scheduling = (function() {
    
                        /**
                         * Properties of a Scheduling.
                         * @memberof google.cloud.compute.v1
                         * @interface IScheduling
                         * @property {boolean|null} [automaticRestart] Scheduling automaticRestart
                         * @property {string|null} [instanceTerminationAction] Scheduling instanceTerminationAction
                         * @property {string|null} [locationHint] Scheduling locationHint
                         * @property {number|null} [minNodeCpus] Scheduling minNodeCpus
                         * @property {Array.<google.cloud.compute.v1.ISchedulingNodeAffinity>|null} [nodeAffinities] Scheduling nodeAffinities
                         * @property {string|null} [onHostMaintenance] Scheduling onHostMaintenance
                         * @property {boolean|null} [preemptible] Scheduling preemptible
                         * @property {string|null} [provisioningModel] Scheduling provisioningModel
                         */
    
                        /**
                         * Constructs a new Scheduling.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Scheduling.
                         * @implements IScheduling
                         * @constructor
                         * @param {google.cloud.compute.v1.IScheduling=} [properties] Properties to set
                         */
                        function Scheduling(properties) {
                            this.nodeAffinities = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Scheduling automaticRestart.
                         * @member {boolean|null|undefined} automaticRestart
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @instance
                         */
                        Scheduling.prototype.automaticRestart = null;
    
                        /**
                         * Scheduling instanceTerminationAction.
                         * @member {string|null|undefined} instanceTerminationAction
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @instance
                         */
                        Scheduling.prototype.instanceTerminationAction = null;
    
                        /**
                         * Scheduling locationHint.
                         * @member {string|null|undefined} locationHint
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @instance
                         */
                        Scheduling.prototype.locationHint = null;
    
                        /**
                         * Scheduling minNodeCpus.
                         * @member {number|null|undefined} minNodeCpus
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @instance
                         */
                        Scheduling.prototype.minNodeCpus = null;
    
                        /**
                         * Scheduling nodeAffinities.
                         * @member {Array.<google.cloud.compute.v1.ISchedulingNodeAffinity>} nodeAffinities
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @instance
                         */
                        Scheduling.prototype.nodeAffinities = $util.emptyArray;
    
                        /**
                         * Scheduling onHostMaintenance.
                         * @member {string|null|undefined} onHostMaintenance
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @instance
                         */
                        Scheduling.prototype.onHostMaintenance = null;
    
                        /**
                         * Scheduling preemptible.
                         * @member {boolean|null|undefined} preemptible
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @instance
                         */
                        Scheduling.prototype.preemptible = null;
    
                        /**
                         * Scheduling provisioningModel.
                         * @member {string|null|undefined} provisioningModel
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @instance
                         */
                        Scheduling.prototype.provisioningModel = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Scheduling _automaticRestart.
                         * @member {"automaticRestart"|undefined} _automaticRestart
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @instance
                         */
                        Object.defineProperty(Scheduling.prototype, "_automaticRestart", {
                            get: $util.oneOfGetter($oneOfFields = ["automaticRestart"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Scheduling _instanceTerminationAction.
                         * @member {"instanceTerminationAction"|undefined} _instanceTerminationAction
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @instance
                         */
                        Object.defineProperty(Scheduling.prototype, "_instanceTerminationAction", {
                            get: $util.oneOfGetter($oneOfFields = ["instanceTerminationAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Scheduling _locationHint.
                         * @member {"locationHint"|undefined} _locationHint
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @instance
                         */
                        Object.defineProperty(Scheduling.prototype, "_locationHint", {
                            get: $util.oneOfGetter($oneOfFields = ["locationHint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Scheduling _minNodeCpus.
                         * @member {"minNodeCpus"|undefined} _minNodeCpus
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @instance
                         */
                        Object.defineProperty(Scheduling.prototype, "_minNodeCpus", {
                            get: $util.oneOfGetter($oneOfFields = ["minNodeCpus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Scheduling _onHostMaintenance.
                         * @member {"onHostMaintenance"|undefined} _onHostMaintenance
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @instance
                         */
                        Object.defineProperty(Scheduling.prototype, "_onHostMaintenance", {
                            get: $util.oneOfGetter($oneOfFields = ["onHostMaintenance"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Scheduling _preemptible.
                         * @member {"preemptible"|undefined} _preemptible
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @instance
                         */
                        Object.defineProperty(Scheduling.prototype, "_preemptible", {
                            get: $util.oneOfGetter($oneOfFields = ["preemptible"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Scheduling _provisioningModel.
                         * @member {"provisioningModel"|undefined} _provisioningModel
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @instance
                         */
                        Object.defineProperty(Scheduling.prototype, "_provisioningModel", {
                            get: $util.oneOfGetter($oneOfFields = ["provisioningModel"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Scheduling instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @static
                         * @param {google.cloud.compute.v1.IScheduling=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Scheduling} Scheduling instance
                         */
                        Scheduling.create = function create(properties) {
                            return new Scheduling(properties);
                        };
    
                        /**
                         * Encodes the specified Scheduling message. Does not implicitly {@link google.cloud.compute.v1.Scheduling.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @static
                         * @param {google.cloud.compute.v1.IScheduling} message Scheduling message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Scheduling.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.provisioningModel != null && Object.hasOwnProperty.call(message, "provisioningModel"))
                                writer.uint32(/* id 494423, wireType 2 =*/3955386).string(message.provisioningModel);
                            if (message.onHostMaintenance != null && Object.hasOwnProperty.call(message, "onHostMaintenance"))
                                writer.uint32(/* id 64616796, wireType 2 =*/516934370).string(message.onHostMaintenance);
                            if (message.instanceTerminationAction != null && Object.hasOwnProperty.call(message, "instanceTerminationAction"))
                                writer.uint32(/* id 107380667, wireType 2 =*/859045338).string(message.instanceTerminationAction);
                            if (message.minNodeCpus != null && Object.hasOwnProperty.call(message, "minNodeCpus"))
                                writer.uint32(/* id 317231675, wireType 0 =*/2537853400).int32(message.minNodeCpus);
                            if (message.preemptible != null && Object.hasOwnProperty.call(message, "preemptible"))
                                writer.uint32(/* id 324203169, wireType 0 =*/2593625352).bool(message.preemptible);
                            if (message.locationHint != null && Object.hasOwnProperty.call(message, "locationHint"))
                                writer.uint32(/* id 350519505, wireType 2 =*/2804156042).string(message.locationHint);
                            if (message.automaticRestart != null && Object.hasOwnProperty.call(message, "automaticRestart"))
                                writer.uint32(/* id 350821371, wireType 0 =*/2806570968).bool(message.automaticRestart);
                            if (message.nodeAffinities != null && message.nodeAffinities.length)
                                for (var i = 0; i < message.nodeAffinities.length; ++i)
                                    $root.google.cloud.compute.v1.SchedulingNodeAffinity.encode(message.nodeAffinities[i], writer.uint32(/* id 461799971, wireType 2 =*/3694399770).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Scheduling message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Scheduling.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @static
                         * @param {google.cloud.compute.v1.IScheduling} message Scheduling message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Scheduling.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Scheduling message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Scheduling} Scheduling
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Scheduling.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Scheduling();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 350821371: {
                                        message.automaticRestart = reader.bool();
                                        break;
                                    }
                                case 107380667: {
                                        message.instanceTerminationAction = reader.string();
                                        break;
                                    }
                                case 350519505: {
                                        message.locationHint = reader.string();
                                        break;
                                    }
                                case 317231675: {
                                        message.minNodeCpus = reader.int32();
                                        break;
                                    }
                                case 461799971: {
                                        if (!(message.nodeAffinities && message.nodeAffinities.length))
                                            message.nodeAffinities = [];
                                        message.nodeAffinities.push($root.google.cloud.compute.v1.SchedulingNodeAffinity.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 64616796: {
                                        message.onHostMaintenance = reader.string();
                                        break;
                                    }
                                case 324203169: {
                                        message.preemptible = reader.bool();
                                        break;
                                    }
                                case 494423: {
                                        message.provisioningModel = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Scheduling message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Scheduling} Scheduling
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Scheduling.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Scheduling message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Scheduling.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.automaticRestart != null && message.hasOwnProperty("automaticRestart")) {
                                properties._automaticRestart = 1;
                                if (typeof message.automaticRestart !== "boolean")
                                    return "automaticRestart: boolean expected";
                            }
                            if (message.instanceTerminationAction != null && message.hasOwnProperty("instanceTerminationAction")) {
                                properties._instanceTerminationAction = 1;
                                if (!$util.isString(message.instanceTerminationAction))
                                    return "instanceTerminationAction: string expected";
                            }
                            if (message.locationHint != null && message.hasOwnProperty("locationHint")) {
                                properties._locationHint = 1;
                                if (!$util.isString(message.locationHint))
                                    return "locationHint: string expected";
                            }
                            if (message.minNodeCpus != null && message.hasOwnProperty("minNodeCpus")) {
                                properties._minNodeCpus = 1;
                                if (!$util.isInteger(message.minNodeCpus))
                                    return "minNodeCpus: integer expected";
                            }
                            if (message.nodeAffinities != null && message.hasOwnProperty("nodeAffinities")) {
                                if (!Array.isArray(message.nodeAffinities))
                                    return "nodeAffinities: array expected";
                                for (var i = 0; i < message.nodeAffinities.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.SchedulingNodeAffinity.verify(message.nodeAffinities[i]);
                                    if (error)
                                        return "nodeAffinities." + error;
                                }
                            }
                            if (message.onHostMaintenance != null && message.hasOwnProperty("onHostMaintenance")) {
                                properties._onHostMaintenance = 1;
                                if (!$util.isString(message.onHostMaintenance))
                                    return "onHostMaintenance: string expected";
                            }
                            if (message.preemptible != null && message.hasOwnProperty("preemptible")) {
                                properties._preemptible = 1;
                                if (typeof message.preemptible !== "boolean")
                                    return "preemptible: boolean expected";
                            }
                            if (message.provisioningModel != null && message.hasOwnProperty("provisioningModel")) {
                                properties._provisioningModel = 1;
                                if (!$util.isString(message.provisioningModel))
                                    return "provisioningModel: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Scheduling message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Scheduling} Scheduling
                         */
                        Scheduling.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Scheduling)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Scheduling();
                            if (object.automaticRestart != null)
                                message.automaticRestart = Boolean(object.automaticRestart);
                            if (object.instanceTerminationAction != null)
                                message.instanceTerminationAction = String(object.instanceTerminationAction);
                            if (object.locationHint != null)
                                message.locationHint = String(object.locationHint);
                            if (object.minNodeCpus != null)
                                message.minNodeCpus = object.minNodeCpus | 0;
                            if (object.nodeAffinities) {
                                if (!Array.isArray(object.nodeAffinities))
                                    throw TypeError(".google.cloud.compute.v1.Scheduling.nodeAffinities: array expected");
                                message.nodeAffinities = [];
                                for (var i = 0; i < object.nodeAffinities.length; ++i) {
                                    if (typeof object.nodeAffinities[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Scheduling.nodeAffinities: object expected");
                                    message.nodeAffinities[i] = $root.google.cloud.compute.v1.SchedulingNodeAffinity.fromObject(object.nodeAffinities[i]);
                                }
                            }
                            if (object.onHostMaintenance != null)
                                message.onHostMaintenance = String(object.onHostMaintenance);
                            if (object.preemptible != null)
                                message.preemptible = Boolean(object.preemptible);
                            if (object.provisioningModel != null)
                                message.provisioningModel = String(object.provisioningModel);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Scheduling message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @static
                         * @param {google.cloud.compute.v1.Scheduling} message Scheduling
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Scheduling.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.nodeAffinities = [];
                            if (message.provisioningModel != null && message.hasOwnProperty("provisioningModel")) {
                                object.provisioningModel = message.provisioningModel;
                                if (options.oneofs)
                                    object._provisioningModel = "provisioningModel";
                            }
                            if (message.onHostMaintenance != null && message.hasOwnProperty("onHostMaintenance")) {
                                object.onHostMaintenance = message.onHostMaintenance;
                                if (options.oneofs)
                                    object._onHostMaintenance = "onHostMaintenance";
                            }
                            if (message.instanceTerminationAction != null && message.hasOwnProperty("instanceTerminationAction")) {
                                object.instanceTerminationAction = message.instanceTerminationAction;
                                if (options.oneofs)
                                    object._instanceTerminationAction = "instanceTerminationAction";
                            }
                            if (message.minNodeCpus != null && message.hasOwnProperty("minNodeCpus")) {
                                object.minNodeCpus = message.minNodeCpus;
                                if (options.oneofs)
                                    object._minNodeCpus = "minNodeCpus";
                            }
                            if (message.preemptible != null && message.hasOwnProperty("preemptible")) {
                                object.preemptible = message.preemptible;
                                if (options.oneofs)
                                    object._preemptible = "preemptible";
                            }
                            if (message.locationHint != null && message.hasOwnProperty("locationHint")) {
                                object.locationHint = message.locationHint;
                                if (options.oneofs)
                                    object._locationHint = "locationHint";
                            }
                            if (message.automaticRestart != null && message.hasOwnProperty("automaticRestart")) {
                                object.automaticRestart = message.automaticRestart;
                                if (options.oneofs)
                                    object._automaticRestart = "automaticRestart";
                            }
                            if (message.nodeAffinities && message.nodeAffinities.length) {
                                object.nodeAffinities = [];
                                for (var j = 0; j < message.nodeAffinities.length; ++j)
                                    object.nodeAffinities[j] = $root.google.cloud.compute.v1.SchedulingNodeAffinity.toObject(message.nodeAffinities[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Scheduling to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Scheduling.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Scheduling
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Scheduling
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Scheduling.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Scheduling";
                        };
    
                        /**
                         * InstanceTerminationAction enum.
                         * @name google.cloud.compute.v1.Scheduling.InstanceTerminationAction
                         * @enum {number}
                         * @property {number} UNDEFINED_INSTANCE_TERMINATION_ACTION=0 UNDEFINED_INSTANCE_TERMINATION_ACTION value
                         * @property {number} DELETE=402225579 DELETE value
                         * @property {number} INSTANCE_TERMINATION_ACTION_UNSPECIFIED=92954803 INSTANCE_TERMINATION_ACTION_UNSPECIFIED value
                         * @property {number} STOP=2555906 STOP value
                         */
                        Scheduling.InstanceTerminationAction = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_INSTANCE_TERMINATION_ACTION"] = 0;
                            values[valuesById[402225579] = "DELETE"] = 402225579;
                            values[valuesById[92954803] = "INSTANCE_TERMINATION_ACTION_UNSPECIFIED"] = 92954803;
                            values[valuesById[2555906] = "STOP"] = 2555906;
                            return values;
                        })();
    
                        /**
                         * OnHostMaintenance enum.
                         * @name google.cloud.compute.v1.Scheduling.OnHostMaintenance
                         * @enum {number}
                         * @property {number} UNDEFINED_ON_HOST_MAINTENANCE=0 UNDEFINED_ON_HOST_MAINTENANCE value
                         * @property {number} MIGRATE=165699979 MIGRATE value
                         * @property {number} TERMINATE=527617601 TERMINATE value
                         */
                        Scheduling.OnHostMaintenance = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ON_HOST_MAINTENANCE"] = 0;
                            values[valuesById[165699979] = "MIGRATE"] = 165699979;
                            values[valuesById[527617601] = "TERMINATE"] = 527617601;
                            return values;
                        })();
    
                        /**
                         * ProvisioningModel enum.
                         * @name google.cloud.compute.v1.Scheduling.ProvisioningModel
                         * @enum {number}
                         * @property {number} UNDEFINED_PROVISIONING_MODEL=0 UNDEFINED_PROVISIONING_MODEL value
                         * @property {number} SPOT=2552066 SPOT value
                         * @property {number} STANDARD=484642493 STANDARD value
                         */
                        Scheduling.ProvisioningModel = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PROVISIONING_MODEL"] = 0;
                            values[valuesById[2552066] = "SPOT"] = 2552066;
                            values[valuesById[484642493] = "STANDARD"] = 484642493;
                            return values;
                        })();
    
                        return Scheduling;
                    })();
    
                    v1.SchedulingNodeAffinity = (function() {
    
                        /**
                         * Properties of a SchedulingNodeAffinity.
                         * @memberof google.cloud.compute.v1
                         * @interface ISchedulingNodeAffinity
                         * @property {string|null} [key] SchedulingNodeAffinity key
                         * @property {string|null} [operator] SchedulingNodeAffinity operator
                         * @property {Array.<string>|null} [values] SchedulingNodeAffinity values
                         */
    
                        /**
                         * Constructs a new SchedulingNodeAffinity.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SchedulingNodeAffinity.
                         * @implements ISchedulingNodeAffinity
                         * @constructor
                         * @param {google.cloud.compute.v1.ISchedulingNodeAffinity=} [properties] Properties to set
                         */
                        function SchedulingNodeAffinity(properties) {
                            this.values = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SchedulingNodeAffinity key.
                         * @member {string|null|undefined} key
                         * @memberof google.cloud.compute.v1.SchedulingNodeAffinity
                         * @instance
                         */
                        SchedulingNodeAffinity.prototype.key = null;
    
                        /**
                         * SchedulingNodeAffinity operator.
                         * @member {string|null|undefined} operator
                         * @memberof google.cloud.compute.v1.SchedulingNodeAffinity
                         * @instance
                         */
                        SchedulingNodeAffinity.prototype.operator = null;
    
                        /**
                         * SchedulingNodeAffinity values.
                         * @member {Array.<string>} values
                         * @memberof google.cloud.compute.v1.SchedulingNodeAffinity
                         * @instance
                         */
                        SchedulingNodeAffinity.prototype.values = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SchedulingNodeAffinity _key.
                         * @member {"key"|undefined} _key
                         * @memberof google.cloud.compute.v1.SchedulingNodeAffinity
                         * @instance
                         */
                        Object.defineProperty(SchedulingNodeAffinity.prototype, "_key", {
                            get: $util.oneOfGetter($oneOfFields = ["key"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SchedulingNodeAffinity _operator.
                         * @member {"operator"|undefined} _operator
                         * @memberof google.cloud.compute.v1.SchedulingNodeAffinity
                         * @instance
                         */
                        Object.defineProperty(SchedulingNodeAffinity.prototype, "_operator", {
                            get: $util.oneOfGetter($oneOfFields = ["operator"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SchedulingNodeAffinity instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SchedulingNodeAffinity
                         * @static
                         * @param {google.cloud.compute.v1.ISchedulingNodeAffinity=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SchedulingNodeAffinity} SchedulingNodeAffinity instance
                         */
                        SchedulingNodeAffinity.create = function create(properties) {
                            return new SchedulingNodeAffinity(properties);
                        };
    
                        /**
                         * Encodes the specified SchedulingNodeAffinity message. Does not implicitly {@link google.cloud.compute.v1.SchedulingNodeAffinity.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SchedulingNodeAffinity
                         * @static
                         * @param {google.cloud.compute.v1.ISchedulingNodeAffinity} message SchedulingNodeAffinity message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SchedulingNodeAffinity.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.key != null && Object.hasOwnProperty.call(message, "key"))
                                writer.uint32(/* id 106079, wireType 2 =*/848634).string(message.key);
                            if (message.operator != null && Object.hasOwnProperty.call(message, "operator"))
                                writer.uint32(/* id 36317348, wireType 2 =*/290538786).string(message.operator);
                            if (message.values != null && message.values.length)
                                for (var i = 0; i < message.values.length; ++i)
                                    writer.uint32(/* id 249928994, wireType 2 =*/1999431954).string(message.values[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SchedulingNodeAffinity message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SchedulingNodeAffinity.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SchedulingNodeAffinity
                         * @static
                         * @param {google.cloud.compute.v1.ISchedulingNodeAffinity} message SchedulingNodeAffinity message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SchedulingNodeAffinity.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SchedulingNodeAffinity message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SchedulingNodeAffinity
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SchedulingNodeAffinity} SchedulingNodeAffinity
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SchedulingNodeAffinity.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SchedulingNodeAffinity();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 106079: {
                                        message.key = reader.string();
                                        break;
                                    }
                                case 36317348: {
                                        message.operator = reader.string();
                                        break;
                                    }
                                case 249928994: {
                                        if (!(message.values && message.values.length))
                                            message.values = [];
                                        message.values.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SchedulingNodeAffinity message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SchedulingNodeAffinity
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SchedulingNodeAffinity} SchedulingNodeAffinity
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SchedulingNodeAffinity.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SchedulingNodeAffinity message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SchedulingNodeAffinity
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SchedulingNodeAffinity.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.key != null && message.hasOwnProperty("key")) {
                                properties._key = 1;
                                if (!$util.isString(message.key))
                                    return "key: string expected";
                            }
                            if (message.operator != null && message.hasOwnProperty("operator")) {
                                properties._operator = 1;
                                if (!$util.isString(message.operator))
                                    return "operator: string expected";
                            }
                            if (message.values != null && message.hasOwnProperty("values")) {
                                if (!Array.isArray(message.values))
                                    return "values: array expected";
                                for (var i = 0; i < message.values.length; ++i)
                                    if (!$util.isString(message.values[i]))
                                        return "values: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SchedulingNodeAffinity message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SchedulingNodeAffinity
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SchedulingNodeAffinity} SchedulingNodeAffinity
                         */
                        SchedulingNodeAffinity.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SchedulingNodeAffinity)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SchedulingNodeAffinity();
                            if (object.key != null)
                                message.key = String(object.key);
                            if (object.operator != null)
                                message.operator = String(object.operator);
                            if (object.values) {
                                if (!Array.isArray(object.values))
                                    throw TypeError(".google.cloud.compute.v1.SchedulingNodeAffinity.values: array expected");
                                message.values = [];
                                for (var i = 0; i < object.values.length; ++i)
                                    message.values[i] = String(object.values[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SchedulingNodeAffinity message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SchedulingNodeAffinity
                         * @static
                         * @param {google.cloud.compute.v1.SchedulingNodeAffinity} message SchedulingNodeAffinity
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SchedulingNodeAffinity.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.values = [];
                            if (message.key != null && message.hasOwnProperty("key")) {
                                object.key = message.key;
                                if (options.oneofs)
                                    object._key = "key";
                            }
                            if (message.operator != null && message.hasOwnProperty("operator")) {
                                object.operator = message.operator;
                                if (options.oneofs)
                                    object._operator = "operator";
                            }
                            if (message.values && message.values.length) {
                                object.values = [];
                                for (var j = 0; j < message.values.length; ++j)
                                    object.values[j] = message.values[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SchedulingNodeAffinity to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SchedulingNodeAffinity
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SchedulingNodeAffinity.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SchedulingNodeAffinity
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SchedulingNodeAffinity
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SchedulingNodeAffinity.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SchedulingNodeAffinity";
                        };
    
                        /**
                         * Operator enum.
                         * @name google.cloud.compute.v1.SchedulingNodeAffinity.Operator
                         * @enum {number}
                         * @property {number} UNDEFINED_OPERATOR=0 UNDEFINED_OPERATOR value
                         * @property {number} IN=2341 IN value
                         * @property {number} NOT_IN=161144369 NOT_IN value
                         * @property {number} OPERATOR_UNSPECIFIED=128892924 OPERATOR_UNSPECIFIED value
                         */
                        SchedulingNodeAffinity.Operator = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_OPERATOR"] = 0;
                            values[valuesById[2341] = "IN"] = 2341;
                            values[valuesById[161144369] = "NOT_IN"] = 161144369;
                            values[valuesById[128892924] = "OPERATOR_UNSPECIFIED"] = 128892924;
                            return values;
                        })();
    
                        return SchedulingNodeAffinity;
                    })();
    
                    v1.ScratchDisks = (function() {
    
                        /**
                         * Properties of a ScratchDisks.
                         * @memberof google.cloud.compute.v1
                         * @interface IScratchDisks
                         * @property {number|null} [diskGb] ScratchDisks diskGb
                         */
    
                        /**
                         * Constructs a new ScratchDisks.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ScratchDisks.
                         * @implements IScratchDisks
                         * @constructor
                         * @param {google.cloud.compute.v1.IScratchDisks=} [properties] Properties to set
                         */
                        function ScratchDisks(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ScratchDisks diskGb.
                         * @member {number|null|undefined} diskGb
                         * @memberof google.cloud.compute.v1.ScratchDisks
                         * @instance
                         */
                        ScratchDisks.prototype.diskGb = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ScratchDisks _diskGb.
                         * @member {"diskGb"|undefined} _diskGb
                         * @memberof google.cloud.compute.v1.ScratchDisks
                         * @instance
                         */
                        Object.defineProperty(ScratchDisks.prototype, "_diskGb", {
                            get: $util.oneOfGetter($oneOfFields = ["diskGb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ScratchDisks instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ScratchDisks
                         * @static
                         * @param {google.cloud.compute.v1.IScratchDisks=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ScratchDisks} ScratchDisks instance
                         */
                        ScratchDisks.create = function create(properties) {
                            return new ScratchDisks(properties);
                        };
    
                        /**
                         * Encodes the specified ScratchDisks message. Does not implicitly {@link google.cloud.compute.v1.ScratchDisks.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ScratchDisks
                         * @static
                         * @param {google.cloud.compute.v1.IScratchDisks} message ScratchDisks message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ScratchDisks.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.diskGb != null && Object.hasOwnProperty.call(message, "diskGb"))
                                writer.uint32(/* id 60990141, wireType 0 =*/487921128).int32(message.diskGb);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ScratchDisks message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ScratchDisks.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ScratchDisks
                         * @static
                         * @param {google.cloud.compute.v1.IScratchDisks} message ScratchDisks message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ScratchDisks.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ScratchDisks message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ScratchDisks
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ScratchDisks} ScratchDisks
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ScratchDisks.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ScratchDisks();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 60990141: {
                                        message.diskGb = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ScratchDisks message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ScratchDisks
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ScratchDisks} ScratchDisks
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ScratchDisks.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ScratchDisks message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ScratchDisks
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ScratchDisks.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.diskGb != null && message.hasOwnProperty("diskGb")) {
                                properties._diskGb = 1;
                                if (!$util.isInteger(message.diskGb))
                                    return "diskGb: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ScratchDisks message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ScratchDisks
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ScratchDisks} ScratchDisks
                         */
                        ScratchDisks.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ScratchDisks)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ScratchDisks();
                            if (object.diskGb != null)
                                message.diskGb = object.diskGb | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ScratchDisks message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ScratchDisks
                         * @static
                         * @param {google.cloud.compute.v1.ScratchDisks} message ScratchDisks
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ScratchDisks.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.diskGb != null && message.hasOwnProperty("diskGb")) {
                                object.diskGb = message.diskGb;
                                if (options.oneofs)
                                    object._diskGb = "diskGb";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ScratchDisks to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ScratchDisks
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ScratchDisks.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ScratchDisks
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ScratchDisks
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ScratchDisks.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ScratchDisks";
                        };
    
                        return ScratchDisks;
                    })();
    
                    v1.Screenshot = (function() {
    
                        /**
                         * Properties of a Screenshot.
                         * @memberof google.cloud.compute.v1
                         * @interface IScreenshot
                         * @property {string|null} [contents] Screenshot contents
                         * @property {string|null} [kind] Screenshot kind
                         */
    
                        /**
                         * Constructs a new Screenshot.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Screenshot.
                         * @implements IScreenshot
                         * @constructor
                         * @param {google.cloud.compute.v1.IScreenshot=} [properties] Properties to set
                         */
                        function Screenshot(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Screenshot contents.
                         * @member {string|null|undefined} contents
                         * @memberof google.cloud.compute.v1.Screenshot
                         * @instance
                         */
                        Screenshot.prototype.contents = null;
    
                        /**
                         * Screenshot kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Screenshot
                         * @instance
                         */
                        Screenshot.prototype.kind = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Screenshot _contents.
                         * @member {"contents"|undefined} _contents
                         * @memberof google.cloud.compute.v1.Screenshot
                         * @instance
                         */
                        Object.defineProperty(Screenshot.prototype, "_contents", {
                            get: $util.oneOfGetter($oneOfFields = ["contents"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Screenshot _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Screenshot
                         * @instance
                         */
                        Object.defineProperty(Screenshot.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Screenshot instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Screenshot
                         * @static
                         * @param {google.cloud.compute.v1.IScreenshot=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Screenshot} Screenshot instance
                         */
                        Screenshot.create = function create(properties) {
                            return new Screenshot(properties);
                        };
    
                        /**
                         * Encodes the specified Screenshot message. Does not implicitly {@link google.cloud.compute.v1.Screenshot.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Screenshot
                         * @static
                         * @param {google.cloud.compute.v1.IScreenshot} message Screenshot message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Screenshot.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.contents != null && Object.hasOwnProperty.call(message, "contents"))
                                writer.uint32(/* id 506419994, wireType 2 =*/4051359954).string(message.contents);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Screenshot message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Screenshot.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Screenshot
                         * @static
                         * @param {google.cloud.compute.v1.IScreenshot} message Screenshot message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Screenshot.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Screenshot message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Screenshot
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Screenshot} Screenshot
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Screenshot.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Screenshot();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 506419994: {
                                        message.contents = reader.string();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Screenshot message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Screenshot
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Screenshot} Screenshot
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Screenshot.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Screenshot message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Screenshot
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Screenshot.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.contents != null && message.hasOwnProperty("contents")) {
                                properties._contents = 1;
                                if (!$util.isString(message.contents))
                                    return "contents: string expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Screenshot message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Screenshot
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Screenshot} Screenshot
                         */
                        Screenshot.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Screenshot)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Screenshot();
                            if (object.contents != null)
                                message.contents = String(object.contents);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Screenshot message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Screenshot
                         * @static
                         * @param {google.cloud.compute.v1.Screenshot} message Screenshot
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Screenshot.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.contents != null && message.hasOwnProperty("contents")) {
                                object.contents = message.contents;
                                if (options.oneofs)
                                    object._contents = "contents";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Screenshot to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Screenshot
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Screenshot.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Screenshot
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Screenshot
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Screenshot.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Screenshot";
                        };
    
                        return Screenshot;
                    })();
    
                    v1.SecurityPoliciesAggregatedList = (function() {
    
                        /**
                         * Properties of a SecurityPoliciesAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPoliciesAggregatedList
                         * @property {string|null} [etag] SecurityPoliciesAggregatedList etag
                         * @property {string|null} [id] SecurityPoliciesAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.ISecurityPoliciesScopedList>|null} [items] SecurityPoliciesAggregatedList items
                         * @property {string|null} [kind] SecurityPoliciesAggregatedList kind
                         * @property {string|null} [nextPageToken] SecurityPoliciesAggregatedList nextPageToken
                         * @property {string|null} [selfLink] SecurityPoliciesAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] SecurityPoliciesAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] SecurityPoliciesAggregatedList warning
                         */
    
                        /**
                         * Constructs a new SecurityPoliciesAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPoliciesAggregatedList.
                         * @implements ISecurityPoliciesAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPoliciesAggregatedList=} [properties] Properties to set
                         */
                        function SecurityPoliciesAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPoliciesAggregatedList etag.
                         * @member {string|null|undefined} etag
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @instance
                         */
                        SecurityPoliciesAggregatedList.prototype.etag = null;
    
                        /**
                         * SecurityPoliciesAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @instance
                         */
                        SecurityPoliciesAggregatedList.prototype.id = null;
    
                        /**
                         * SecurityPoliciesAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.ISecurityPoliciesScopedList>} items
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @instance
                         */
                        SecurityPoliciesAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * SecurityPoliciesAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @instance
                         */
                        SecurityPoliciesAggregatedList.prototype.kind = null;
    
                        /**
                         * SecurityPoliciesAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @instance
                         */
                        SecurityPoliciesAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * SecurityPoliciesAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @instance
                         */
                        SecurityPoliciesAggregatedList.prototype.selfLink = null;
    
                        /**
                         * SecurityPoliciesAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @instance
                         */
                        SecurityPoliciesAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * SecurityPoliciesAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @instance
                         */
                        SecurityPoliciesAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SecurityPoliciesAggregatedList _etag.
                         * @member {"etag"|undefined} _etag
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SecurityPoliciesAggregatedList.prototype, "_etag", {
                            get: $util.oneOfGetter($oneOfFields = ["etag"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPoliciesAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SecurityPoliciesAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPoliciesAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SecurityPoliciesAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPoliciesAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SecurityPoliciesAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPoliciesAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SecurityPoliciesAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPoliciesAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SecurityPoliciesAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SecurityPoliciesAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPoliciesAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPoliciesAggregatedList} SecurityPoliciesAggregatedList instance
                         */
                        SecurityPoliciesAggregatedList.create = function create(properties) {
                            return new SecurityPoliciesAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPoliciesAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.SecurityPoliciesAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPoliciesAggregatedList} message SecurityPoliciesAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPoliciesAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.etag != null && Object.hasOwnProperty.call(message, "etag"))
                                writer.uint32(/* id 3123477, wireType 2 =*/24987818).string(message.etag);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.SecurityPoliciesScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPoliciesAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPoliciesAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPoliciesAggregatedList} message SecurityPoliciesAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPoliciesAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPoliciesAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPoliciesAggregatedList} SecurityPoliciesAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPoliciesAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPoliciesAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3123477: {
                                        message.etag = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.SecurityPoliciesScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPoliciesAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPoliciesAggregatedList} SecurityPoliciesAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPoliciesAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPoliciesAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPoliciesAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                properties._etag = 1;
                                if (!$util.isString(message.etag))
                                    return "etag: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.SecurityPoliciesScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPoliciesAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPoliciesAggregatedList} SecurityPoliciesAggregatedList
                         */
                        SecurityPoliciesAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPoliciesAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPoliciesAggregatedList();
                            if (object.etag != null)
                                message.etag = String(object.etag);
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPoliciesAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SecurityPoliciesAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.SecurityPoliciesScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.SecurityPoliciesAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPoliciesAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPoliciesAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPoliciesAggregatedList} message SecurityPoliciesAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPoliciesAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                object.etag = message.etag;
                                if (options.oneofs)
                                    object._etag = "etag";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.SecurityPoliciesScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPoliciesAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPoliciesAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPoliciesAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPoliciesAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPoliciesAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPoliciesAggregatedList";
                        };
    
                        return SecurityPoliciesAggregatedList;
                    })();
    
                    v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse = (function() {
    
                        /**
                         * Properties of a SecurityPoliciesListPreconfiguredExpressionSetsResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPoliciesListPreconfiguredExpressionSetsResponse
                         * @property {google.cloud.compute.v1.ISecurityPoliciesWafConfig|null} [preconfiguredExpressionSets] SecurityPoliciesListPreconfiguredExpressionSetsResponse preconfiguredExpressionSets
                         */
    
                        /**
                         * Constructs a new SecurityPoliciesListPreconfiguredExpressionSetsResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPoliciesListPreconfiguredExpressionSetsResponse.
                         * @implements ISecurityPoliciesListPreconfiguredExpressionSetsResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPoliciesListPreconfiguredExpressionSetsResponse=} [properties] Properties to set
                         */
                        function SecurityPoliciesListPreconfiguredExpressionSetsResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPoliciesListPreconfiguredExpressionSetsResponse preconfiguredExpressionSets.
                         * @member {google.cloud.compute.v1.ISecurityPoliciesWafConfig|null|undefined} preconfiguredExpressionSets
                         * @memberof google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse
                         * @instance
                         */
                        SecurityPoliciesListPreconfiguredExpressionSetsResponse.prototype.preconfiguredExpressionSets = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SecurityPoliciesListPreconfiguredExpressionSetsResponse _preconfiguredExpressionSets.
                         * @member {"preconfiguredExpressionSets"|undefined} _preconfiguredExpressionSets
                         * @memberof google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse
                         * @instance
                         */
                        Object.defineProperty(SecurityPoliciesListPreconfiguredExpressionSetsResponse.prototype, "_preconfiguredExpressionSets", {
                            get: $util.oneOfGetter($oneOfFields = ["preconfiguredExpressionSets"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SecurityPoliciesListPreconfiguredExpressionSetsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPoliciesListPreconfiguredExpressionSetsResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse} SecurityPoliciesListPreconfiguredExpressionSetsResponse instance
                         */
                        SecurityPoliciesListPreconfiguredExpressionSetsResponse.create = function create(properties) {
                            return new SecurityPoliciesListPreconfiguredExpressionSetsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPoliciesListPreconfiguredExpressionSetsResponse message. Does not implicitly {@link google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPoliciesListPreconfiguredExpressionSetsResponse} message SecurityPoliciesListPreconfiguredExpressionSetsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPoliciesListPreconfiguredExpressionSetsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.preconfiguredExpressionSets != null && Object.hasOwnProperty.call(message, "preconfiguredExpressionSets"))
                                $root.google.cloud.compute.v1.SecurityPoliciesWafConfig.encode(message.preconfiguredExpressionSets, writer.uint32(/* id 536200826, wireType 2 =*/4289606610).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPoliciesListPreconfiguredExpressionSetsResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPoliciesListPreconfiguredExpressionSetsResponse} message SecurityPoliciesListPreconfiguredExpressionSetsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPoliciesListPreconfiguredExpressionSetsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPoliciesListPreconfiguredExpressionSetsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse} SecurityPoliciesListPreconfiguredExpressionSetsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPoliciesListPreconfiguredExpressionSetsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 536200826: {
                                        message.preconfiguredExpressionSets = $root.google.cloud.compute.v1.SecurityPoliciesWafConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPoliciesListPreconfiguredExpressionSetsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse} SecurityPoliciesListPreconfiguredExpressionSetsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPoliciesListPreconfiguredExpressionSetsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPoliciesListPreconfiguredExpressionSetsResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPoliciesListPreconfiguredExpressionSetsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.preconfiguredExpressionSets != null && message.hasOwnProperty("preconfiguredExpressionSets")) {
                                properties._preconfiguredExpressionSets = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SecurityPoliciesWafConfig.verify(message.preconfiguredExpressionSets);
                                    if (error)
                                        return "preconfiguredExpressionSets." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPoliciesListPreconfiguredExpressionSetsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse} SecurityPoliciesListPreconfiguredExpressionSetsResponse
                         */
                        SecurityPoliciesListPreconfiguredExpressionSetsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse();
                            if (object.preconfiguredExpressionSets != null) {
                                if (typeof object.preconfiguredExpressionSets !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse.preconfiguredExpressionSets: object expected");
                                message.preconfiguredExpressionSets = $root.google.cloud.compute.v1.SecurityPoliciesWafConfig.fromObject(object.preconfiguredExpressionSets);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPoliciesListPreconfiguredExpressionSetsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse} message SecurityPoliciesListPreconfiguredExpressionSetsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPoliciesListPreconfiguredExpressionSetsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.preconfiguredExpressionSets != null && message.hasOwnProperty("preconfiguredExpressionSets")) {
                                object.preconfiguredExpressionSets = $root.google.cloud.compute.v1.SecurityPoliciesWafConfig.toObject(message.preconfiguredExpressionSets, options);
                                if (options.oneofs)
                                    object._preconfiguredExpressionSets = "preconfiguredExpressionSets";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPoliciesListPreconfiguredExpressionSetsResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPoliciesListPreconfiguredExpressionSetsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPoliciesListPreconfiguredExpressionSetsResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPoliciesListPreconfiguredExpressionSetsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse";
                        };
    
                        return SecurityPoliciesListPreconfiguredExpressionSetsResponse;
                    })();
    
                    v1.SecurityPoliciesScopedList = (function() {
    
                        /**
                         * Properties of a SecurityPoliciesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPoliciesScopedList
                         * @property {Array.<google.cloud.compute.v1.ISecurityPolicy>|null} [securityPolicies] SecurityPoliciesScopedList securityPolicies
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] SecurityPoliciesScopedList warning
                         */
    
                        /**
                         * Constructs a new SecurityPoliciesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPoliciesScopedList.
                         * @implements ISecurityPoliciesScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPoliciesScopedList=} [properties] Properties to set
                         */
                        function SecurityPoliciesScopedList(properties) {
                            this.securityPolicies = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPoliciesScopedList securityPolicies.
                         * @member {Array.<google.cloud.compute.v1.ISecurityPolicy>} securityPolicies
                         * @memberof google.cloud.compute.v1.SecurityPoliciesScopedList
                         * @instance
                         */
                        SecurityPoliciesScopedList.prototype.securityPolicies = $util.emptyArray;
    
                        /**
                         * SecurityPoliciesScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.SecurityPoliciesScopedList
                         * @instance
                         */
                        SecurityPoliciesScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SecurityPoliciesScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.SecurityPoliciesScopedList
                         * @instance
                         */
                        Object.defineProperty(SecurityPoliciesScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SecurityPoliciesScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPoliciesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPoliciesScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPoliciesScopedList} SecurityPoliciesScopedList instance
                         */
                        SecurityPoliciesScopedList.create = function create(properties) {
                            return new SecurityPoliciesScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPoliciesScopedList message. Does not implicitly {@link google.cloud.compute.v1.SecurityPoliciesScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPoliciesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPoliciesScopedList} message SecurityPoliciesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPoliciesScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.securityPolicies != null && message.securityPolicies.length)
                                for (var i = 0; i < message.securityPolicies.length; ++i)
                                    $root.google.cloud.compute.v1.SecurityPolicy.encode(message.securityPolicies[i], writer.uint32(/* id 127783791, wireType 2 =*/1022270330).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPoliciesScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPoliciesScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPoliciesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPoliciesScopedList} message SecurityPoliciesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPoliciesScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPoliciesScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPoliciesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPoliciesScopedList} SecurityPoliciesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPoliciesScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPoliciesScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 127783791: {
                                        if (!(message.securityPolicies && message.securityPolicies.length))
                                            message.securityPolicies = [];
                                        message.securityPolicies.push($root.google.cloud.compute.v1.SecurityPolicy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPoliciesScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPoliciesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPoliciesScopedList} SecurityPoliciesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPoliciesScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPoliciesScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPoliciesScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPoliciesScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.securityPolicies != null && message.hasOwnProperty("securityPolicies")) {
                                if (!Array.isArray(message.securityPolicies))
                                    return "securityPolicies: array expected";
                                for (var i = 0; i < message.securityPolicies.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.SecurityPolicy.verify(message.securityPolicies[i]);
                                    if (error)
                                        return "securityPolicies." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPoliciesScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPoliciesScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPoliciesScopedList} SecurityPoliciesScopedList
                         */
                        SecurityPoliciesScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPoliciesScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPoliciesScopedList();
                            if (object.securityPolicies) {
                                if (!Array.isArray(object.securityPolicies))
                                    throw TypeError(".google.cloud.compute.v1.SecurityPoliciesScopedList.securityPolicies: array expected");
                                message.securityPolicies = [];
                                for (var i = 0; i < object.securityPolicies.length; ++i) {
                                    if (typeof object.securityPolicies[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SecurityPoliciesScopedList.securityPolicies: object expected");
                                    message.securityPolicies[i] = $root.google.cloud.compute.v1.SecurityPolicy.fromObject(object.securityPolicies[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPoliciesScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPoliciesScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPoliciesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPoliciesScopedList} message SecurityPoliciesScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPoliciesScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.securityPolicies = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.securityPolicies && message.securityPolicies.length) {
                                object.securityPolicies = [];
                                for (var j = 0; j < message.securityPolicies.length; ++j)
                                    object.securityPolicies[j] = $root.google.cloud.compute.v1.SecurityPolicy.toObject(message.securityPolicies[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPoliciesScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPoliciesScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPoliciesScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPoliciesScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPoliciesScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPoliciesScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPoliciesScopedList";
                        };
    
                        return SecurityPoliciesScopedList;
                    })();
    
                    v1.SecurityPoliciesWafConfig = (function() {
    
                        /**
                         * Properties of a SecurityPoliciesWafConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPoliciesWafConfig
                         * @property {google.cloud.compute.v1.IPreconfiguredWafSet|null} [wafRules] SecurityPoliciesWafConfig wafRules
                         */
    
                        /**
                         * Constructs a new SecurityPoliciesWafConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPoliciesWafConfig.
                         * @implements ISecurityPoliciesWafConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPoliciesWafConfig=} [properties] Properties to set
                         */
                        function SecurityPoliciesWafConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPoliciesWafConfig wafRules.
                         * @member {google.cloud.compute.v1.IPreconfiguredWafSet|null|undefined} wafRules
                         * @memberof google.cloud.compute.v1.SecurityPoliciesWafConfig
                         * @instance
                         */
                        SecurityPoliciesWafConfig.prototype.wafRules = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SecurityPoliciesWafConfig _wafRules.
                         * @member {"wafRules"|undefined} _wafRules
                         * @memberof google.cloud.compute.v1.SecurityPoliciesWafConfig
                         * @instance
                         */
                        Object.defineProperty(SecurityPoliciesWafConfig.prototype, "_wafRules", {
                            get: $util.oneOfGetter($oneOfFields = ["wafRules"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SecurityPoliciesWafConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPoliciesWafConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPoliciesWafConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPoliciesWafConfig} SecurityPoliciesWafConfig instance
                         */
                        SecurityPoliciesWafConfig.create = function create(properties) {
                            return new SecurityPoliciesWafConfig(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPoliciesWafConfig message. Does not implicitly {@link google.cloud.compute.v1.SecurityPoliciesWafConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPoliciesWafConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPoliciesWafConfig} message SecurityPoliciesWafConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPoliciesWafConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.wafRules != null && Object.hasOwnProperty.call(message, "wafRules"))
                                $root.google.cloud.compute.v1.PreconfiguredWafSet.encode(message.wafRules, writer.uint32(/* id 74899924, wireType 2 =*/599199394).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPoliciesWafConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPoliciesWafConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPoliciesWafConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPoliciesWafConfig} message SecurityPoliciesWafConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPoliciesWafConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPoliciesWafConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPoliciesWafConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPoliciesWafConfig} SecurityPoliciesWafConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPoliciesWafConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPoliciesWafConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 74899924: {
                                        message.wafRules = $root.google.cloud.compute.v1.PreconfiguredWafSet.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPoliciesWafConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPoliciesWafConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPoliciesWafConfig} SecurityPoliciesWafConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPoliciesWafConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPoliciesWafConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPoliciesWafConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPoliciesWafConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.wafRules != null && message.hasOwnProperty("wafRules")) {
                                properties._wafRules = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.PreconfiguredWafSet.verify(message.wafRules);
                                    if (error)
                                        return "wafRules." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPoliciesWafConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPoliciesWafConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPoliciesWafConfig} SecurityPoliciesWafConfig
                         */
                        SecurityPoliciesWafConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPoliciesWafConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPoliciesWafConfig();
                            if (object.wafRules != null) {
                                if (typeof object.wafRules !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPoliciesWafConfig.wafRules: object expected");
                                message.wafRules = $root.google.cloud.compute.v1.PreconfiguredWafSet.fromObject(object.wafRules);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPoliciesWafConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPoliciesWafConfig
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPoliciesWafConfig} message SecurityPoliciesWafConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPoliciesWafConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.wafRules != null && message.hasOwnProperty("wafRules")) {
                                object.wafRules = $root.google.cloud.compute.v1.PreconfiguredWafSet.toObject(message.wafRules, options);
                                if (options.oneofs)
                                    object._wafRules = "wafRules";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPoliciesWafConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPoliciesWafConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPoliciesWafConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPoliciesWafConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPoliciesWafConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPoliciesWafConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPoliciesWafConfig";
                        };
    
                        return SecurityPoliciesWafConfig;
                    })();
    
                    v1.SecurityPolicy = (function() {
    
                        /**
                         * Properties of a SecurityPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPolicy
                         * @property {google.cloud.compute.v1.ISecurityPolicyAdaptiveProtectionConfig|null} [adaptiveProtectionConfig] SecurityPolicy adaptiveProtectionConfig
                         * @property {google.cloud.compute.v1.ISecurityPolicyAdvancedOptionsConfig|null} [advancedOptionsConfig] SecurityPolicy advancedOptionsConfig
                         * @property {string|null} [creationTimestamp] SecurityPolicy creationTimestamp
                         * @property {google.cloud.compute.v1.ISecurityPolicyDdosProtectionConfig|null} [ddosProtectionConfig] SecurityPolicy ddosProtectionConfig
                         * @property {string|null} [description] SecurityPolicy description
                         * @property {string|null} [fingerprint] SecurityPolicy fingerprint
                         * @property {number|Long|null} [id] SecurityPolicy id
                         * @property {string|null} [kind] SecurityPolicy kind
                         * @property {string|null} [name] SecurityPolicy name
                         * @property {google.cloud.compute.v1.ISecurityPolicyRecaptchaOptionsConfig|null} [recaptchaOptionsConfig] SecurityPolicy recaptchaOptionsConfig
                         * @property {string|null} [region] SecurityPolicy region
                         * @property {Array.<google.cloud.compute.v1.ISecurityPolicyRule>|null} [rules] SecurityPolicy rules
                         * @property {string|null} [selfLink] SecurityPolicy selfLink
                         * @property {string|null} [type] SecurityPolicy type
                         */
    
                        /**
                         * Constructs a new SecurityPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPolicy.
                         * @implements ISecurityPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPolicy=} [properties] Properties to set
                         */
                        function SecurityPolicy(properties) {
                            this.rules = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPolicy adaptiveProtectionConfig.
                         * @member {google.cloud.compute.v1.ISecurityPolicyAdaptiveProtectionConfig|null|undefined} adaptiveProtectionConfig
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        SecurityPolicy.prototype.adaptiveProtectionConfig = null;
    
                        /**
                         * SecurityPolicy advancedOptionsConfig.
                         * @member {google.cloud.compute.v1.ISecurityPolicyAdvancedOptionsConfig|null|undefined} advancedOptionsConfig
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        SecurityPolicy.prototype.advancedOptionsConfig = null;
    
                        /**
                         * SecurityPolicy creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        SecurityPolicy.prototype.creationTimestamp = null;
    
                        /**
                         * SecurityPolicy ddosProtectionConfig.
                         * @member {google.cloud.compute.v1.ISecurityPolicyDdosProtectionConfig|null|undefined} ddosProtectionConfig
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        SecurityPolicy.prototype.ddosProtectionConfig = null;
    
                        /**
                         * SecurityPolicy description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        SecurityPolicy.prototype.description = null;
    
                        /**
                         * SecurityPolicy fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        SecurityPolicy.prototype.fingerprint = null;
    
                        /**
                         * SecurityPolicy id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        SecurityPolicy.prototype.id = null;
    
                        /**
                         * SecurityPolicy kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        SecurityPolicy.prototype.kind = null;
    
                        /**
                         * SecurityPolicy name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        SecurityPolicy.prototype.name = null;
    
                        /**
                         * SecurityPolicy recaptchaOptionsConfig.
                         * @member {google.cloud.compute.v1.ISecurityPolicyRecaptchaOptionsConfig|null|undefined} recaptchaOptionsConfig
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        SecurityPolicy.prototype.recaptchaOptionsConfig = null;
    
                        /**
                         * SecurityPolicy region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        SecurityPolicy.prototype.region = null;
    
                        /**
                         * SecurityPolicy rules.
                         * @member {Array.<google.cloud.compute.v1.ISecurityPolicyRule>} rules
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        SecurityPolicy.prototype.rules = $util.emptyArray;
    
                        /**
                         * SecurityPolicy selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        SecurityPolicy.prototype.selfLink = null;
    
                        /**
                         * SecurityPolicy type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        SecurityPolicy.prototype.type = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SecurityPolicy _adaptiveProtectionConfig.
                         * @member {"adaptiveProtectionConfig"|undefined} _adaptiveProtectionConfig
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicy.prototype, "_adaptiveProtectionConfig", {
                            get: $util.oneOfGetter($oneOfFields = ["adaptiveProtectionConfig"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicy _advancedOptionsConfig.
                         * @member {"advancedOptionsConfig"|undefined} _advancedOptionsConfig
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicy.prototype, "_advancedOptionsConfig", {
                            get: $util.oneOfGetter($oneOfFields = ["advancedOptionsConfig"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicy _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicy.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicy _ddosProtectionConfig.
                         * @member {"ddosProtectionConfig"|undefined} _ddosProtectionConfig
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicy.prototype, "_ddosProtectionConfig", {
                            get: $util.oneOfGetter($oneOfFields = ["ddosProtectionConfig"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicy _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicy.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicy _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicy.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicy _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicy.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicy _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicy.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicy _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicy.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicy _recaptchaOptionsConfig.
                         * @member {"recaptchaOptionsConfig"|undefined} _recaptchaOptionsConfig
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicy.prototype, "_recaptchaOptionsConfig", {
                            get: $util.oneOfGetter($oneOfFields = ["recaptchaOptionsConfig"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicy _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicy.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicy _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicy.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicy _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicy.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SecurityPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPolicy} SecurityPolicy instance
                         */
                        SecurityPolicy.create = function create(properties) {
                            return new SecurityPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPolicy message. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicy} message SecurityPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.ddosProtectionConfig != null && Object.hasOwnProperty.call(message, "ddosProtectionConfig"))
                                $root.google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig.encode(message.ddosProtectionConfig, writer.uint32(/* id 50315853, wireType 2 =*/402526826).fork()).ldelim();
                            if (message.rules != null && message.rules.length)
                                for (var i = 0; i < message.rules.length; ++i)
                                    $root.google.cloud.compute.v1.SecurityPolicyRule.encode(message.rules[i], writer.uint32(/* id 108873975, wireType 2 =*/870991802).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.adaptiveProtectionConfig != null && Object.hasOwnProperty.call(message, "adaptiveProtectionConfig"))
                                $root.google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig.encode(message.adaptiveProtectionConfig, writer.uint32(/* id 150240735, wireType 2 =*/1201925882).fork()).ldelim();
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.advancedOptionsConfig != null && Object.hasOwnProperty.call(message, "advancedOptionsConfig"))
                                $root.google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig.encode(message.advancedOptionsConfig, writer.uint32(/* id 449276352, wireType 2 =*/3594210818).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.recaptchaOptionsConfig != null && Object.hasOwnProperty.call(message, "recaptchaOptionsConfig"))
                                $root.google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig.encode(message.recaptchaOptionsConfig, writer.uint32(/* id 519006811, wireType 2 =*/4152054490).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicy} message SecurityPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPolicy} SecurityPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 150240735: {
                                        message.adaptiveProtectionConfig = $root.google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 449276352: {
                                        message.advancedOptionsConfig = $root.google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 50315853: {
                                        message.ddosProtectionConfig = $root.google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 519006811: {
                                        message.recaptchaOptionsConfig = $root.google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 108873975: {
                                        if (!(message.rules && message.rules.length))
                                            message.rules = [];
                                        message.rules.push($root.google.cloud.compute.v1.SecurityPolicyRule.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPolicy} SecurityPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.adaptiveProtectionConfig != null && message.hasOwnProperty("adaptiveProtectionConfig")) {
                                properties._adaptiveProtectionConfig = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig.verify(message.adaptiveProtectionConfig);
                                    if (error)
                                        return "adaptiveProtectionConfig." + error;
                                }
                            }
                            if (message.advancedOptionsConfig != null && message.hasOwnProperty("advancedOptionsConfig")) {
                                properties._advancedOptionsConfig = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig.verify(message.advancedOptionsConfig);
                                    if (error)
                                        return "advancedOptionsConfig." + error;
                                }
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.ddosProtectionConfig != null && message.hasOwnProperty("ddosProtectionConfig")) {
                                properties._ddosProtectionConfig = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig.verify(message.ddosProtectionConfig);
                                    if (error)
                                        return "ddosProtectionConfig." + error;
                                }
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.recaptchaOptionsConfig != null && message.hasOwnProperty("recaptchaOptionsConfig")) {
                                properties._recaptchaOptionsConfig = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig.verify(message.recaptchaOptionsConfig);
                                    if (error)
                                        return "recaptchaOptionsConfig." + error;
                                }
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.rules != null && message.hasOwnProperty("rules")) {
                                if (!Array.isArray(message.rules))
                                    return "rules: array expected";
                                for (var i = 0; i < message.rules.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.SecurityPolicyRule.verify(message.rules[i]);
                                    if (error)
                                        return "rules." + error;
                                }
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPolicy} SecurityPolicy
                         */
                        SecurityPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPolicy();
                            if (object.adaptiveProtectionConfig != null) {
                                if (typeof object.adaptiveProtectionConfig !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicy.adaptiveProtectionConfig: object expected");
                                message.adaptiveProtectionConfig = $root.google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig.fromObject(object.adaptiveProtectionConfig);
                            }
                            if (object.advancedOptionsConfig != null) {
                                if (typeof object.advancedOptionsConfig !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicy.advancedOptionsConfig: object expected");
                                message.advancedOptionsConfig = $root.google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig.fromObject(object.advancedOptionsConfig);
                            }
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.ddosProtectionConfig != null) {
                                if (typeof object.ddosProtectionConfig !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicy.ddosProtectionConfig: object expected");
                                message.ddosProtectionConfig = $root.google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig.fromObject(object.ddosProtectionConfig);
                            }
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.recaptchaOptionsConfig != null) {
                                if (typeof object.recaptchaOptionsConfig !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicy.recaptchaOptionsConfig: object expected");
                                message.recaptchaOptionsConfig = $root.google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig.fromObject(object.recaptchaOptionsConfig);
                            }
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.rules) {
                                if (!Array.isArray(object.rules))
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicy.rules: array expected");
                                message.rules = [];
                                for (var i = 0; i < object.rules.length; ++i) {
                                    if (typeof object.rules[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SecurityPolicy.rules: object expected");
                                    message.rules[i] = $root.google.cloud.compute.v1.SecurityPolicyRule.fromObject(object.rules[i]);
                                }
                            }
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.type != null)
                                message.type = String(object.type);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPolicy} message SecurityPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.rules = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.ddosProtectionConfig != null && message.hasOwnProperty("ddosProtectionConfig")) {
                                object.ddosProtectionConfig = $root.google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig.toObject(message.ddosProtectionConfig, options);
                                if (options.oneofs)
                                    object._ddosProtectionConfig = "ddosProtectionConfig";
                            }
                            if (message.rules && message.rules.length) {
                                object.rules = [];
                                for (var j = 0; j < message.rules.length; ++j)
                                    object.rules[j] = $root.google.cloud.compute.v1.SecurityPolicyRule.toObject(message.rules[j], options);
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.adaptiveProtectionConfig != null && message.hasOwnProperty("adaptiveProtectionConfig")) {
                                object.adaptiveProtectionConfig = $root.google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig.toObject(message.adaptiveProtectionConfig, options);
                                if (options.oneofs)
                                    object._adaptiveProtectionConfig = "adaptiveProtectionConfig";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.advancedOptionsConfig != null && message.hasOwnProperty("advancedOptionsConfig")) {
                                object.advancedOptionsConfig = $root.google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig.toObject(message.advancedOptionsConfig, options);
                                if (options.oneofs)
                                    object._advancedOptionsConfig = "advancedOptionsConfig";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.recaptchaOptionsConfig != null && message.hasOwnProperty("recaptchaOptionsConfig")) {
                                object.recaptchaOptionsConfig = $root.google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig.toObject(message.recaptchaOptionsConfig, options);
                                if (options.oneofs)
                                    object._recaptchaOptionsConfig = "recaptchaOptionsConfig";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPolicy";
                        };
    
                        /**
                         * Type enum.
                         * @name google.cloud.compute.v1.SecurityPolicy.Type
                         * @enum {number}
                         * @property {number} UNDEFINED_TYPE=0 UNDEFINED_TYPE value
                         * @property {number} CLOUD_ARMOR=260640373 CLOUD_ARMOR value
                         * @property {number} CLOUD_ARMOR_EDGE=250728775 CLOUD_ARMOR_EDGE value
                         * @property {number} CLOUD_ARMOR_NETWORK=488527428 CLOUD_ARMOR_NETWORK value
                         */
                        SecurityPolicy.Type = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TYPE"] = 0;
                            values[valuesById[260640373] = "CLOUD_ARMOR"] = 260640373;
                            values[valuesById[250728775] = "CLOUD_ARMOR_EDGE"] = 250728775;
                            values[valuesById[488527428] = "CLOUD_ARMOR_NETWORK"] = 488527428;
                            return values;
                        })();
    
                        return SecurityPolicy;
                    })();
    
                    v1.SecurityPolicyAdaptiveProtectionConfig = (function() {
    
                        /**
                         * Properties of a SecurityPolicyAdaptiveProtectionConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPolicyAdaptiveProtectionConfig
                         * @property {google.cloud.compute.v1.ISecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig|null} [layer7DdosDefenseConfig] SecurityPolicyAdaptiveProtectionConfig layer7DdosDefenseConfig
                         */
    
                        /**
                         * Constructs a new SecurityPolicyAdaptiveProtectionConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPolicyAdaptiveProtectionConfig.
                         * @implements ISecurityPolicyAdaptiveProtectionConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPolicyAdaptiveProtectionConfig=} [properties] Properties to set
                         */
                        function SecurityPolicyAdaptiveProtectionConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPolicyAdaptiveProtectionConfig layer7DdosDefenseConfig.
                         * @member {google.cloud.compute.v1.ISecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig|null|undefined} layer7DdosDefenseConfig
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig
                         * @instance
                         */
                        SecurityPolicyAdaptiveProtectionConfig.prototype.layer7DdosDefenseConfig = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SecurityPolicyAdaptiveProtectionConfig _layer7DdosDefenseConfig.
                         * @member {"layer7DdosDefenseConfig"|undefined} _layer7DdosDefenseConfig
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyAdaptiveProtectionConfig.prototype, "_layer7DdosDefenseConfig", {
                            get: $util.oneOfGetter($oneOfFields = ["layer7DdosDefenseConfig"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SecurityPolicyAdaptiveProtectionConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyAdaptiveProtectionConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig} SecurityPolicyAdaptiveProtectionConfig instance
                         */
                        SecurityPolicyAdaptiveProtectionConfig.create = function create(properties) {
                            return new SecurityPolicyAdaptiveProtectionConfig(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyAdaptiveProtectionConfig message. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyAdaptiveProtectionConfig} message SecurityPolicyAdaptiveProtectionConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyAdaptiveProtectionConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.layer7DdosDefenseConfig != null && Object.hasOwnProperty.call(message, "layer7DdosDefenseConfig"))
                                $root.google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.encode(message.layer7DdosDefenseConfig, writer.uint32(/* id 437316771, wireType 2 =*/3498534170).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyAdaptiveProtectionConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyAdaptiveProtectionConfig} message SecurityPolicyAdaptiveProtectionConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyAdaptiveProtectionConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPolicyAdaptiveProtectionConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig} SecurityPolicyAdaptiveProtectionConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyAdaptiveProtectionConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 437316771: {
                                        message.layer7DdosDefenseConfig = $root.google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPolicyAdaptiveProtectionConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig} SecurityPolicyAdaptiveProtectionConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyAdaptiveProtectionConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPolicyAdaptiveProtectionConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPolicyAdaptiveProtectionConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.layer7DdosDefenseConfig != null && message.hasOwnProperty("layer7DdosDefenseConfig")) {
                                properties._layer7DdosDefenseConfig = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.verify(message.layer7DdosDefenseConfig);
                                    if (error)
                                        return "layer7DdosDefenseConfig." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPolicyAdaptiveProtectionConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig} SecurityPolicyAdaptiveProtectionConfig
                         */
                        SecurityPolicyAdaptiveProtectionConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig();
                            if (object.layer7DdosDefenseConfig != null) {
                                if (typeof object.layer7DdosDefenseConfig !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig.layer7DdosDefenseConfig: object expected");
                                message.layer7DdosDefenseConfig = $root.google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.fromObject(object.layer7DdosDefenseConfig);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPolicyAdaptiveProtectionConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig} message SecurityPolicyAdaptiveProtectionConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPolicyAdaptiveProtectionConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.layer7DdosDefenseConfig != null && message.hasOwnProperty("layer7DdosDefenseConfig")) {
                                object.layer7DdosDefenseConfig = $root.google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.toObject(message.layer7DdosDefenseConfig, options);
                                if (options.oneofs)
                                    object._layer7DdosDefenseConfig = "layer7DdosDefenseConfig";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPolicyAdaptiveProtectionConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPolicyAdaptiveProtectionConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPolicyAdaptiveProtectionConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPolicyAdaptiveProtectionConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfig";
                        };
    
                        return SecurityPolicyAdaptiveProtectionConfig;
                    })();
    
                    v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig = (function() {
    
                        /**
                         * Properties of a SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         * @property {boolean|null} [enable] SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig enable
                         * @property {string|null} [ruleVisibility] SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig ruleVisibility
                         */
    
                        /**
                         * Constructs a new SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.
                         * @implements ISecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig=} [properties] Properties to set
                         */
                        function SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig enable.
                         * @member {boolean|null|undefined} enable
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         * @instance
                         */
                        SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.prototype.enable = null;
    
                        /**
                         * SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig ruleVisibility.
                         * @member {string|null|undefined} ruleVisibility
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         * @instance
                         */
                        SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.prototype.ruleVisibility = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig _enable.
                         * @member {"enable"|undefined} _enable
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.prototype, "_enable", {
                            get: $util.oneOfGetter($oneOfFields = ["enable"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig _ruleVisibility.
                         * @member {"ruleVisibility"|undefined} _ruleVisibility
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.prototype, "_ruleVisibility", {
                            get: $util.oneOfGetter($oneOfFields = ["ruleVisibility"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig} SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig instance
                         */
                        SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.create = function create(properties) {
                            return new SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig message. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig} message SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.enable != null && Object.hasOwnProperty.call(message, "enable"))
                                writer.uint32(/* id 311764355, wireType 0 =*/2494114840).bool(message.enable);
                            if (message.ruleVisibility != null && Object.hasOwnProperty.call(message, "ruleVisibility"))
                                writer.uint32(/* id 453258293, wireType 2 =*/3626066346).string(message.ruleVisibility);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig} message SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig} SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 311764355: {
                                        message.enable = reader.bool();
                                        break;
                                    }
                                case 453258293: {
                                        message.ruleVisibility = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig} SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.enable != null && message.hasOwnProperty("enable")) {
                                properties._enable = 1;
                                if (typeof message.enable !== "boolean")
                                    return "enable: boolean expected";
                            }
                            if (message.ruleVisibility != null && message.hasOwnProperty("ruleVisibility")) {
                                properties._ruleVisibility = 1;
                                if (!$util.isString(message.ruleVisibility))
                                    return "ruleVisibility: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig} SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         */
                        SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig();
                            if (object.enable != null)
                                message.enable = Boolean(object.enable);
                            if (object.ruleVisibility != null)
                                message.ruleVisibility = String(object.ruleVisibility);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig} message SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.enable != null && message.hasOwnProperty("enable")) {
                                object.enable = message.enable;
                                if (options.oneofs)
                                    object._enable = "enable";
                            }
                            if (message.ruleVisibility != null && message.hasOwnProperty("ruleVisibility")) {
                                object.ruleVisibility = message.ruleVisibility;
                                if (options.oneofs)
                                    object._ruleVisibility = "ruleVisibility";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig";
                        };
    
                        /**
                         * RuleVisibility enum.
                         * @name google.cloud.compute.v1.SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.RuleVisibility
                         * @enum {number}
                         * @property {number} UNDEFINED_RULE_VISIBILITY=0 UNDEFINED_RULE_VISIBILITY value
                         * @property {number} PREMIUM=399530551 PREMIUM value
                         * @property {number} STANDARD=484642493 STANDARD value
                         */
                        SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig.RuleVisibility = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_RULE_VISIBILITY"] = 0;
                            values[valuesById[399530551] = "PREMIUM"] = 399530551;
                            values[valuesById[484642493] = "STANDARD"] = 484642493;
                            return values;
                        })();
    
                        return SecurityPolicyAdaptiveProtectionConfigLayer7DdosDefenseConfig;
                    })();
    
                    v1.SecurityPolicyAdvancedOptionsConfig = (function() {
    
                        /**
                         * Properties of a SecurityPolicyAdvancedOptionsConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPolicyAdvancedOptionsConfig
                         * @property {google.cloud.compute.v1.ISecurityPolicyAdvancedOptionsConfigJsonCustomConfig|null} [jsonCustomConfig] SecurityPolicyAdvancedOptionsConfig jsonCustomConfig
                         * @property {string|null} [jsonParsing] SecurityPolicyAdvancedOptionsConfig jsonParsing
                         * @property {string|null} [logLevel] SecurityPolicyAdvancedOptionsConfig logLevel
                         */
    
                        /**
                         * Constructs a new SecurityPolicyAdvancedOptionsConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPolicyAdvancedOptionsConfig.
                         * @implements ISecurityPolicyAdvancedOptionsConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPolicyAdvancedOptionsConfig=} [properties] Properties to set
                         */
                        function SecurityPolicyAdvancedOptionsConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPolicyAdvancedOptionsConfig jsonCustomConfig.
                         * @member {google.cloud.compute.v1.ISecurityPolicyAdvancedOptionsConfigJsonCustomConfig|null|undefined} jsonCustomConfig
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig
                         * @instance
                         */
                        SecurityPolicyAdvancedOptionsConfig.prototype.jsonCustomConfig = null;
    
                        /**
                         * SecurityPolicyAdvancedOptionsConfig jsonParsing.
                         * @member {string|null|undefined} jsonParsing
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig
                         * @instance
                         */
                        SecurityPolicyAdvancedOptionsConfig.prototype.jsonParsing = null;
    
                        /**
                         * SecurityPolicyAdvancedOptionsConfig logLevel.
                         * @member {string|null|undefined} logLevel
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig
                         * @instance
                         */
                        SecurityPolicyAdvancedOptionsConfig.prototype.logLevel = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SecurityPolicyAdvancedOptionsConfig _jsonCustomConfig.
                         * @member {"jsonCustomConfig"|undefined} _jsonCustomConfig
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyAdvancedOptionsConfig.prototype, "_jsonCustomConfig", {
                            get: $util.oneOfGetter($oneOfFields = ["jsonCustomConfig"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyAdvancedOptionsConfig _jsonParsing.
                         * @member {"jsonParsing"|undefined} _jsonParsing
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyAdvancedOptionsConfig.prototype, "_jsonParsing", {
                            get: $util.oneOfGetter($oneOfFields = ["jsonParsing"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyAdvancedOptionsConfig _logLevel.
                         * @member {"logLevel"|undefined} _logLevel
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyAdvancedOptionsConfig.prototype, "_logLevel", {
                            get: $util.oneOfGetter($oneOfFields = ["logLevel"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SecurityPolicyAdvancedOptionsConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyAdvancedOptionsConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig} SecurityPolicyAdvancedOptionsConfig instance
                         */
                        SecurityPolicyAdvancedOptionsConfig.create = function create(properties) {
                            return new SecurityPolicyAdvancedOptionsConfig(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyAdvancedOptionsConfig message. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyAdvancedOptionsConfig} message SecurityPolicyAdvancedOptionsConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyAdvancedOptionsConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.jsonCustomConfig != null && Object.hasOwnProperty.call(message, "jsonCustomConfig"))
                                $root.google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.encode(message.jsonCustomConfig, writer.uint32(/* id 111570105, wireType 2 =*/892560842).fork()).ldelim();
                            if (message.logLevel != null && Object.hasOwnProperty.call(message, "logLevel"))
                                writer.uint32(/* id 140582601, wireType 2 =*/1124660810).string(message.logLevel);
                            if (message.jsonParsing != null && Object.hasOwnProperty.call(message, "jsonParsing"))
                                writer.uint32(/* id 282493529, wireType 2 =*/2259948234).string(message.jsonParsing);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyAdvancedOptionsConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyAdvancedOptionsConfig} message SecurityPolicyAdvancedOptionsConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyAdvancedOptionsConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPolicyAdvancedOptionsConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig} SecurityPolicyAdvancedOptionsConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyAdvancedOptionsConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 111570105: {
                                        message.jsonCustomConfig = $root.google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 282493529: {
                                        message.jsonParsing = reader.string();
                                        break;
                                    }
                                case 140582601: {
                                        message.logLevel = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPolicyAdvancedOptionsConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig} SecurityPolicyAdvancedOptionsConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyAdvancedOptionsConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPolicyAdvancedOptionsConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPolicyAdvancedOptionsConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.jsonCustomConfig != null && message.hasOwnProperty("jsonCustomConfig")) {
                                properties._jsonCustomConfig = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.verify(message.jsonCustomConfig);
                                    if (error)
                                        return "jsonCustomConfig." + error;
                                }
                            }
                            if (message.jsonParsing != null && message.hasOwnProperty("jsonParsing")) {
                                properties._jsonParsing = 1;
                                if (!$util.isString(message.jsonParsing))
                                    return "jsonParsing: string expected";
                            }
                            if (message.logLevel != null && message.hasOwnProperty("logLevel")) {
                                properties._logLevel = 1;
                                if (!$util.isString(message.logLevel))
                                    return "logLevel: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPolicyAdvancedOptionsConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig} SecurityPolicyAdvancedOptionsConfig
                         */
                        SecurityPolicyAdvancedOptionsConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig();
                            if (object.jsonCustomConfig != null) {
                                if (typeof object.jsonCustomConfig !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig.jsonCustomConfig: object expected");
                                message.jsonCustomConfig = $root.google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.fromObject(object.jsonCustomConfig);
                            }
                            if (object.jsonParsing != null)
                                message.jsonParsing = String(object.jsonParsing);
                            if (object.logLevel != null)
                                message.logLevel = String(object.logLevel);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPolicyAdvancedOptionsConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig} message SecurityPolicyAdvancedOptionsConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPolicyAdvancedOptionsConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.jsonCustomConfig != null && message.hasOwnProperty("jsonCustomConfig")) {
                                object.jsonCustomConfig = $root.google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.toObject(message.jsonCustomConfig, options);
                                if (options.oneofs)
                                    object._jsonCustomConfig = "jsonCustomConfig";
                            }
                            if (message.logLevel != null && message.hasOwnProperty("logLevel")) {
                                object.logLevel = message.logLevel;
                                if (options.oneofs)
                                    object._logLevel = "logLevel";
                            }
                            if (message.jsonParsing != null && message.hasOwnProperty("jsonParsing")) {
                                object.jsonParsing = message.jsonParsing;
                                if (options.oneofs)
                                    object._jsonParsing = "jsonParsing";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPolicyAdvancedOptionsConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPolicyAdvancedOptionsConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPolicyAdvancedOptionsConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPolicyAdvancedOptionsConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig";
                        };
    
                        /**
                         * JsonParsing enum.
                         * @name google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig.JsonParsing
                         * @enum {number}
                         * @property {number} UNDEFINED_JSON_PARSING=0 UNDEFINED_JSON_PARSING value
                         * @property {number} DISABLED=516696700 DISABLED value
                         * @property {number} STANDARD=484642493 STANDARD value
                         */
                        SecurityPolicyAdvancedOptionsConfig.JsonParsing = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_JSON_PARSING"] = 0;
                            values[valuesById[516696700] = "DISABLED"] = 516696700;
                            values[valuesById[484642493] = "STANDARD"] = 484642493;
                            return values;
                        })();
    
                        /**
                         * LogLevel enum.
                         * @name google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfig.LogLevel
                         * @enum {number}
                         * @property {number} UNDEFINED_LOG_LEVEL=0 UNDEFINED_LOG_LEVEL value
                         * @property {number} NORMAL=161067239 NORMAL value
                         * @property {number} VERBOSE=532219234 VERBOSE value
                         */
                        SecurityPolicyAdvancedOptionsConfig.LogLevel = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_LOG_LEVEL"] = 0;
                            values[valuesById[161067239] = "NORMAL"] = 161067239;
                            values[valuesById[532219234] = "VERBOSE"] = 532219234;
                            return values;
                        })();
    
                        return SecurityPolicyAdvancedOptionsConfig;
                    })();
    
                    v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig = (function() {
    
                        /**
                         * Properties of a SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPolicyAdvancedOptionsConfigJsonCustomConfig
                         * @property {Array.<string>|null} [contentTypes] SecurityPolicyAdvancedOptionsConfigJsonCustomConfig contentTypes
                         */
    
                        /**
                         * Constructs a new SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.
                         * @implements ISecurityPolicyAdvancedOptionsConfigJsonCustomConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPolicyAdvancedOptionsConfigJsonCustomConfig=} [properties] Properties to set
                         */
                        function SecurityPolicyAdvancedOptionsConfigJsonCustomConfig(properties) {
                            this.contentTypes = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPolicyAdvancedOptionsConfigJsonCustomConfig contentTypes.
                         * @member {Array.<string>} contentTypes
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig
                         * @instance
                         */
                        SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.prototype.contentTypes = $util.emptyArray;
    
                        /**
                         * Creates a new SecurityPolicyAdvancedOptionsConfigJsonCustomConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyAdvancedOptionsConfigJsonCustomConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig} SecurityPolicyAdvancedOptionsConfigJsonCustomConfig instance
                         */
                        SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.create = function create(properties) {
                            return new SecurityPolicyAdvancedOptionsConfigJsonCustomConfig(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyAdvancedOptionsConfigJsonCustomConfig message. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyAdvancedOptionsConfigJsonCustomConfig} message SecurityPolicyAdvancedOptionsConfigJsonCustomConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.contentTypes != null && message.contentTypes.length)
                                for (var i = 0; i < message.contentTypes.length; ++i)
                                    writer.uint32(/* id 17428787, wireType 2 =*/139430298).string(message.contentTypes[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyAdvancedOptionsConfigJsonCustomConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyAdvancedOptionsConfigJsonCustomConfig} message SecurityPolicyAdvancedOptionsConfigJsonCustomConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPolicyAdvancedOptionsConfigJsonCustomConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig} SecurityPolicyAdvancedOptionsConfigJsonCustomConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 17428787: {
                                        if (!(message.contentTypes && message.contentTypes.length))
                                            message.contentTypes = [];
                                        message.contentTypes.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPolicyAdvancedOptionsConfigJsonCustomConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig} SecurityPolicyAdvancedOptionsConfigJsonCustomConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPolicyAdvancedOptionsConfigJsonCustomConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.contentTypes != null && message.hasOwnProperty("contentTypes")) {
                                if (!Array.isArray(message.contentTypes))
                                    return "contentTypes: array expected";
                                for (var i = 0; i < message.contentTypes.length; ++i)
                                    if (!$util.isString(message.contentTypes[i]))
                                        return "contentTypes: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPolicyAdvancedOptionsConfigJsonCustomConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig} SecurityPolicyAdvancedOptionsConfigJsonCustomConfig
                         */
                        SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig();
                            if (object.contentTypes) {
                                if (!Array.isArray(object.contentTypes))
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.contentTypes: array expected");
                                message.contentTypes = [];
                                for (var i = 0; i < object.contentTypes.length; ++i)
                                    message.contentTypes[i] = String(object.contentTypes[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPolicyAdvancedOptionsConfigJsonCustomConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig} message SecurityPolicyAdvancedOptionsConfigJsonCustomConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.contentTypes = [];
                            if (message.contentTypes && message.contentTypes.length) {
                                object.contentTypes = [];
                                for (var j = 0; j < message.contentTypes.length; ++j)
                                    object.contentTypes[j] = message.contentTypes[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPolicyAdvancedOptionsConfigJsonCustomConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPolicyAdvancedOptionsConfigJsonCustomConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPolicyAdvancedOptionsConfigJsonCustomConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPolicyAdvancedOptionsConfigJsonCustomConfig";
                        };
    
                        return SecurityPolicyAdvancedOptionsConfigJsonCustomConfig;
                    })();
    
                    v1.SecurityPolicyDdosProtectionConfig = (function() {
    
                        /**
                         * Properties of a SecurityPolicyDdosProtectionConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPolicyDdosProtectionConfig
                         * @property {string|null} [ddosProtection] SecurityPolicyDdosProtectionConfig ddosProtection
                         */
    
                        /**
                         * Constructs a new SecurityPolicyDdosProtectionConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPolicyDdosProtectionConfig.
                         * @implements ISecurityPolicyDdosProtectionConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPolicyDdosProtectionConfig=} [properties] Properties to set
                         */
                        function SecurityPolicyDdosProtectionConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPolicyDdosProtectionConfig ddosProtection.
                         * @member {string|null|undefined} ddosProtection
                         * @memberof google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig
                         * @instance
                         */
                        SecurityPolicyDdosProtectionConfig.prototype.ddosProtection = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SecurityPolicyDdosProtectionConfig _ddosProtection.
                         * @member {"ddosProtection"|undefined} _ddosProtection
                         * @memberof google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyDdosProtectionConfig.prototype, "_ddosProtection", {
                            get: $util.oneOfGetter($oneOfFields = ["ddosProtection"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SecurityPolicyDdosProtectionConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyDdosProtectionConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig} SecurityPolicyDdosProtectionConfig instance
                         */
                        SecurityPolicyDdosProtectionConfig.create = function create(properties) {
                            return new SecurityPolicyDdosProtectionConfig(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyDdosProtectionConfig message. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyDdosProtectionConfig} message SecurityPolicyDdosProtectionConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyDdosProtectionConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.ddosProtection != null && Object.hasOwnProperty.call(message, "ddosProtection"))
                                writer.uint32(/* id 275173268, wireType 2 =*/2201386146).string(message.ddosProtection);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyDdosProtectionConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyDdosProtectionConfig} message SecurityPolicyDdosProtectionConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyDdosProtectionConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPolicyDdosProtectionConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig} SecurityPolicyDdosProtectionConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyDdosProtectionConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 275173268: {
                                        message.ddosProtection = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPolicyDdosProtectionConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig} SecurityPolicyDdosProtectionConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyDdosProtectionConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPolicyDdosProtectionConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPolicyDdosProtectionConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.ddosProtection != null && message.hasOwnProperty("ddosProtection")) {
                                properties._ddosProtection = 1;
                                if (!$util.isString(message.ddosProtection))
                                    return "ddosProtection: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPolicyDdosProtectionConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig} SecurityPolicyDdosProtectionConfig
                         */
                        SecurityPolicyDdosProtectionConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig();
                            if (object.ddosProtection != null)
                                message.ddosProtection = String(object.ddosProtection);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPolicyDdosProtectionConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig} message SecurityPolicyDdosProtectionConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPolicyDdosProtectionConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.ddosProtection != null && message.hasOwnProperty("ddosProtection")) {
                                object.ddosProtection = message.ddosProtection;
                                if (options.oneofs)
                                    object._ddosProtection = "ddosProtection";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPolicyDdosProtectionConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPolicyDdosProtectionConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPolicyDdosProtectionConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPolicyDdosProtectionConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig";
                        };
    
                        /**
                         * DdosProtection enum.
                         * @name google.cloud.compute.v1.SecurityPolicyDdosProtectionConfig.DdosProtection
                         * @enum {number}
                         * @property {number} UNDEFINED_DDOS_PROTECTION=0 UNDEFINED_DDOS_PROTECTION value
                         * @property {number} ADVANCED=63789090 ADVANCED value
                         * @property {number} STANDARD=484642493 STANDARD value
                         */
                        SecurityPolicyDdosProtectionConfig.DdosProtection = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_DDOS_PROTECTION"] = 0;
                            values[valuesById[63789090] = "ADVANCED"] = 63789090;
                            values[valuesById[484642493] = "STANDARD"] = 484642493;
                            return values;
                        })();
    
                        return SecurityPolicyDdosProtectionConfig;
                    })();
    
                    v1.SecurityPolicyList = (function() {
    
                        /**
                         * Properties of a SecurityPolicyList.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPolicyList
                         * @property {string|null} [id] SecurityPolicyList id
                         * @property {Array.<google.cloud.compute.v1.ISecurityPolicy>|null} [items] SecurityPolicyList items
                         * @property {string|null} [kind] SecurityPolicyList kind
                         * @property {string|null} [nextPageToken] SecurityPolicyList nextPageToken
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] SecurityPolicyList warning
                         */
    
                        /**
                         * Constructs a new SecurityPolicyList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPolicyList.
                         * @implements ISecurityPolicyList
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPolicyList=} [properties] Properties to set
                         */
                        function SecurityPolicyList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPolicyList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.SecurityPolicyList
                         * @instance
                         */
                        SecurityPolicyList.prototype.id = null;
    
                        /**
                         * SecurityPolicyList items.
                         * @member {Array.<google.cloud.compute.v1.ISecurityPolicy>} items
                         * @memberof google.cloud.compute.v1.SecurityPolicyList
                         * @instance
                         */
                        SecurityPolicyList.prototype.items = $util.emptyArray;
    
                        /**
                         * SecurityPolicyList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.SecurityPolicyList
                         * @instance
                         */
                        SecurityPolicyList.prototype.kind = null;
    
                        /**
                         * SecurityPolicyList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.SecurityPolicyList
                         * @instance
                         */
                        SecurityPolicyList.prototype.nextPageToken = null;
    
                        /**
                         * SecurityPolicyList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.SecurityPolicyList
                         * @instance
                         */
                        SecurityPolicyList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SecurityPolicyList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.SecurityPolicyList
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.SecurityPolicyList
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.SecurityPolicyList
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.SecurityPolicyList
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SecurityPolicyList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPolicyList
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPolicyList} SecurityPolicyList instance
                         */
                        SecurityPolicyList.create = function create(properties) {
                            return new SecurityPolicyList(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyList message. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPolicyList
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyList} message SecurityPolicyList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.SecurityPolicy.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyList
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyList} message SecurityPolicyList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPolicyList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPolicyList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPolicyList} SecurityPolicyList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPolicyList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.SecurityPolicy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPolicyList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPolicyList} SecurityPolicyList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPolicyList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPolicyList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPolicyList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.SecurityPolicy.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPolicyList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPolicyList} SecurityPolicyList
                         */
                        SecurityPolicyList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPolicyList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPolicyList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicyList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SecurityPolicyList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.SecurityPolicy.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicyList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPolicyList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyList
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPolicyList} message SecurityPolicyList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPolicyList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.SecurityPolicy.toObject(message.items[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPolicyList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPolicyList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPolicyList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPolicyList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPolicyList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPolicyList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPolicyList";
                        };
    
                        return SecurityPolicyList;
                    })();
    
                    v1.SecurityPolicyRecaptchaOptionsConfig = (function() {
    
                        /**
                         * Properties of a SecurityPolicyRecaptchaOptionsConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPolicyRecaptchaOptionsConfig
                         * @property {string|null} [redirectSiteKey] SecurityPolicyRecaptchaOptionsConfig redirectSiteKey
                         */
    
                        /**
                         * Constructs a new SecurityPolicyRecaptchaOptionsConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPolicyRecaptchaOptionsConfig.
                         * @implements ISecurityPolicyRecaptchaOptionsConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPolicyRecaptchaOptionsConfig=} [properties] Properties to set
                         */
                        function SecurityPolicyRecaptchaOptionsConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPolicyRecaptchaOptionsConfig redirectSiteKey.
                         * @member {string|null|undefined} redirectSiteKey
                         * @memberof google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig
                         * @instance
                         */
                        SecurityPolicyRecaptchaOptionsConfig.prototype.redirectSiteKey = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SecurityPolicyRecaptchaOptionsConfig _redirectSiteKey.
                         * @member {"redirectSiteKey"|undefined} _redirectSiteKey
                         * @memberof google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRecaptchaOptionsConfig.prototype, "_redirectSiteKey", {
                            get: $util.oneOfGetter($oneOfFields = ["redirectSiteKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SecurityPolicyRecaptchaOptionsConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRecaptchaOptionsConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig} SecurityPolicyRecaptchaOptionsConfig instance
                         */
                        SecurityPolicyRecaptchaOptionsConfig.create = function create(properties) {
                            return new SecurityPolicyRecaptchaOptionsConfig(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyRecaptchaOptionsConfig message. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRecaptchaOptionsConfig} message SecurityPolicyRecaptchaOptionsConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyRecaptchaOptionsConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.redirectSiteKey != null && Object.hasOwnProperty.call(message, "redirectSiteKey"))
                                writer.uint32(/* id 447677034, wireType 2 =*/3581416274).string(message.redirectSiteKey);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyRecaptchaOptionsConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRecaptchaOptionsConfig} message SecurityPolicyRecaptchaOptionsConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyRecaptchaOptionsConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPolicyRecaptchaOptionsConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig} SecurityPolicyRecaptchaOptionsConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyRecaptchaOptionsConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 447677034: {
                                        message.redirectSiteKey = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPolicyRecaptchaOptionsConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig} SecurityPolicyRecaptchaOptionsConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyRecaptchaOptionsConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPolicyRecaptchaOptionsConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPolicyRecaptchaOptionsConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.redirectSiteKey != null && message.hasOwnProperty("redirectSiteKey")) {
                                properties._redirectSiteKey = 1;
                                if (!$util.isString(message.redirectSiteKey))
                                    return "redirectSiteKey: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPolicyRecaptchaOptionsConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig} SecurityPolicyRecaptchaOptionsConfig
                         */
                        SecurityPolicyRecaptchaOptionsConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig();
                            if (object.redirectSiteKey != null)
                                message.redirectSiteKey = String(object.redirectSiteKey);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPolicyRecaptchaOptionsConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig} message SecurityPolicyRecaptchaOptionsConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPolicyRecaptchaOptionsConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.redirectSiteKey != null && message.hasOwnProperty("redirectSiteKey")) {
                                object.redirectSiteKey = message.redirectSiteKey;
                                if (options.oneofs)
                                    object._redirectSiteKey = "redirectSiteKey";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPolicyRecaptchaOptionsConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPolicyRecaptchaOptionsConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPolicyRecaptchaOptionsConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPolicyRecaptchaOptionsConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPolicyRecaptchaOptionsConfig";
                        };
    
                        return SecurityPolicyRecaptchaOptionsConfig;
                    })();
    
                    v1.SecurityPolicyReference = (function() {
    
                        /**
                         * Properties of a SecurityPolicyReference.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPolicyReference
                         * @property {string|null} [securityPolicy] SecurityPolicyReference securityPolicy
                         */
    
                        /**
                         * Constructs a new SecurityPolicyReference.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPolicyReference.
                         * @implements ISecurityPolicyReference
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPolicyReference=} [properties] Properties to set
                         */
                        function SecurityPolicyReference(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPolicyReference securityPolicy.
                         * @member {string|null|undefined} securityPolicy
                         * @memberof google.cloud.compute.v1.SecurityPolicyReference
                         * @instance
                         */
                        SecurityPolicyReference.prototype.securityPolicy = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SecurityPolicyReference _securityPolicy.
                         * @member {"securityPolicy"|undefined} _securityPolicy
                         * @memberof google.cloud.compute.v1.SecurityPolicyReference
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyReference.prototype, "_securityPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["securityPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SecurityPolicyReference instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPolicyReference
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyReference=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPolicyReference} SecurityPolicyReference instance
                         */
                        SecurityPolicyReference.create = function create(properties) {
                            return new SecurityPolicyReference(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyReference message. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyReference.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPolicyReference
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyReference} message SecurityPolicyReference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyReference.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.securityPolicy != null && Object.hasOwnProperty.call(message, "securityPolicy"))
                                writer.uint32(/* id 171082513, wireType 2 =*/1368660106).string(message.securityPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyReference message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyReference.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyReference
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyReference} message SecurityPolicyReference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyReference.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPolicyReference message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPolicyReference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPolicyReference} SecurityPolicyReference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyReference.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPolicyReference();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 171082513: {
                                        message.securityPolicy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPolicyReference message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyReference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPolicyReference} SecurityPolicyReference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyReference.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPolicyReference message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPolicyReference
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPolicyReference.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy")) {
                                properties._securityPolicy = 1;
                                if (!$util.isString(message.securityPolicy))
                                    return "securityPolicy: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPolicyReference message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyReference
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPolicyReference} SecurityPolicyReference
                         */
                        SecurityPolicyReference.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPolicyReference)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPolicyReference();
                            if (object.securityPolicy != null)
                                message.securityPolicy = String(object.securityPolicy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPolicyReference message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyReference
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPolicyReference} message SecurityPolicyReference
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPolicyReference.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.securityPolicy != null && message.hasOwnProperty("securityPolicy")) {
                                object.securityPolicy = message.securityPolicy;
                                if (options.oneofs)
                                    object._securityPolicy = "securityPolicy";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPolicyReference to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPolicyReference
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPolicyReference.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPolicyReference
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPolicyReference
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPolicyReference.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPolicyReference";
                        };
    
                        return SecurityPolicyReference;
                    })();
    
                    v1.SecurityPolicyRule = (function() {
    
                        /**
                         * Properties of a SecurityPolicyRule.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPolicyRule
                         * @property {string|null} [action] SecurityPolicyRule action
                         * @property {string|null} [description] SecurityPolicyRule description
                         * @property {google.cloud.compute.v1.ISecurityPolicyRuleHttpHeaderAction|null} [headerAction] SecurityPolicyRule headerAction
                         * @property {string|null} [kind] SecurityPolicyRule kind
                         * @property {google.cloud.compute.v1.ISecurityPolicyRuleMatcher|null} [match] SecurityPolicyRule match
                         * @property {boolean|null} [preview] SecurityPolicyRule preview
                         * @property {number|null} [priority] SecurityPolicyRule priority
                         * @property {google.cloud.compute.v1.ISecurityPolicyRuleRateLimitOptions|null} [rateLimitOptions] SecurityPolicyRule rateLimitOptions
                         * @property {google.cloud.compute.v1.ISecurityPolicyRuleRedirectOptions|null} [redirectOptions] SecurityPolicyRule redirectOptions
                         */
    
                        /**
                         * Constructs a new SecurityPolicyRule.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPolicyRule.
                         * @implements ISecurityPolicyRule
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPolicyRule=} [properties] Properties to set
                         */
                        function SecurityPolicyRule(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPolicyRule action.
                         * @member {string|null|undefined} action
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @instance
                         */
                        SecurityPolicyRule.prototype.action = null;
    
                        /**
                         * SecurityPolicyRule description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @instance
                         */
                        SecurityPolicyRule.prototype.description = null;
    
                        /**
                         * SecurityPolicyRule headerAction.
                         * @member {google.cloud.compute.v1.ISecurityPolicyRuleHttpHeaderAction|null|undefined} headerAction
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @instance
                         */
                        SecurityPolicyRule.prototype.headerAction = null;
    
                        /**
                         * SecurityPolicyRule kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @instance
                         */
                        SecurityPolicyRule.prototype.kind = null;
    
                        /**
                         * SecurityPolicyRule match.
                         * @member {google.cloud.compute.v1.ISecurityPolicyRuleMatcher|null|undefined} match
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @instance
                         */
                        SecurityPolicyRule.prototype.match = null;
    
                        /**
                         * SecurityPolicyRule preview.
                         * @member {boolean|null|undefined} preview
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @instance
                         */
                        SecurityPolicyRule.prototype.preview = null;
    
                        /**
                         * SecurityPolicyRule priority.
                         * @member {number|null|undefined} priority
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @instance
                         */
                        SecurityPolicyRule.prototype.priority = null;
    
                        /**
                         * SecurityPolicyRule rateLimitOptions.
                         * @member {google.cloud.compute.v1.ISecurityPolicyRuleRateLimitOptions|null|undefined} rateLimitOptions
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @instance
                         */
                        SecurityPolicyRule.prototype.rateLimitOptions = null;
    
                        /**
                         * SecurityPolicyRule redirectOptions.
                         * @member {google.cloud.compute.v1.ISecurityPolicyRuleRedirectOptions|null|undefined} redirectOptions
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @instance
                         */
                        SecurityPolicyRule.prototype.redirectOptions = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SecurityPolicyRule _action.
                         * @member {"action"|undefined} _action
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRule.prototype, "_action", {
                            get: $util.oneOfGetter($oneOfFields = ["action"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyRule _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRule.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyRule _headerAction.
                         * @member {"headerAction"|undefined} _headerAction
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRule.prototype, "_headerAction", {
                            get: $util.oneOfGetter($oneOfFields = ["headerAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyRule _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRule.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyRule _match.
                         * @member {"match"|undefined} _match
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRule.prototype, "_match", {
                            get: $util.oneOfGetter($oneOfFields = ["match"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyRule _preview.
                         * @member {"preview"|undefined} _preview
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRule.prototype, "_preview", {
                            get: $util.oneOfGetter($oneOfFields = ["preview"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyRule _priority.
                         * @member {"priority"|undefined} _priority
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRule.prototype, "_priority", {
                            get: $util.oneOfGetter($oneOfFields = ["priority"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyRule _rateLimitOptions.
                         * @member {"rateLimitOptions"|undefined} _rateLimitOptions
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRule.prototype, "_rateLimitOptions", {
                            get: $util.oneOfGetter($oneOfFields = ["rateLimitOptions"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyRule _redirectOptions.
                         * @member {"redirectOptions"|undefined} _redirectOptions
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRule.prototype, "_redirectOptions", {
                            get: $util.oneOfGetter($oneOfFields = ["redirectOptions"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SecurityPolicyRule instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRule=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPolicyRule} SecurityPolicyRule instance
                         */
                        SecurityPolicyRule.create = function create(properties) {
                            return new SecurityPolicyRule(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyRule message. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyRule.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRule} message SecurityPolicyRule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyRule.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.rateLimitOptions != null && Object.hasOwnProperty.call(message, "rateLimitOptions"))
                                $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions.encode(message.rateLimitOptions, writer.uint32(/* id 67544315, wireType 2 =*/540354522).fork()).ldelim();
                            if (message.match != null && Object.hasOwnProperty.call(message, "match"))
                                $root.google.cloud.compute.v1.SecurityPolicyRuleMatcher.encode(message.match, writer.uint32(/* id 103668165, wireType 2 =*/829345322).fork()).ldelim();
                            if (message.redirectOptions != null && Object.hasOwnProperty.call(message, "redirectOptions"))
                                $root.google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions.encode(message.redirectOptions, writer.uint32(/* id 163285307, wireType 2 =*/1306282458).fork()).ldelim();
                            if (message.action != null && Object.hasOwnProperty.call(message, "action"))
                                writer.uint32(/* id 187661878, wireType 2 =*/1501295026).string(message.action);
                            if (message.preview != null && Object.hasOwnProperty.call(message, "preview"))
                                writer.uint32(/* id 218686408, wireType 0 =*/1749491264).bool(message.preview);
                            if (message.headerAction != null && Object.hasOwnProperty.call(message, "headerAction"))
                                $root.google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction.encode(message.headerAction, writer.uint32(/* id 328077352, wireType 2 =*/2624618818).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.priority != null && Object.hasOwnProperty.call(message, "priority"))
                                writer.uint32(/* id 445151652, wireType 0 =*/3561213216).int32(message.priority);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyRule message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyRule.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRule} message SecurityPolicyRule message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyRule.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPolicyRule message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPolicyRule} SecurityPolicyRule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyRule.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPolicyRule();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 187661878: {
                                        message.action = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 328077352: {
                                        message.headerAction = $root.google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 103668165: {
                                        message.match = $root.google.cloud.compute.v1.SecurityPolicyRuleMatcher.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 218686408: {
                                        message.preview = reader.bool();
                                        break;
                                    }
                                case 445151652: {
                                        message.priority = reader.int32();
                                        break;
                                    }
                                case 67544315: {
                                        message.rateLimitOptions = $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 163285307: {
                                        message.redirectOptions = $root.google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPolicyRule message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPolicyRule} SecurityPolicyRule
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyRule.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPolicyRule message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPolicyRule.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.action != null && message.hasOwnProperty("action")) {
                                properties._action = 1;
                                if (!$util.isString(message.action))
                                    return "action: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.headerAction != null && message.hasOwnProperty("headerAction")) {
                                properties._headerAction = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction.verify(message.headerAction);
                                    if (error)
                                        return "headerAction." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.match != null && message.hasOwnProperty("match")) {
                                properties._match = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SecurityPolicyRuleMatcher.verify(message.match);
                                    if (error)
                                        return "match." + error;
                                }
                            }
                            if (message.preview != null && message.hasOwnProperty("preview")) {
                                properties._preview = 1;
                                if (typeof message.preview !== "boolean")
                                    return "preview: boolean expected";
                            }
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                properties._priority = 1;
                                if (!$util.isInteger(message.priority))
                                    return "priority: integer expected";
                            }
                            if (message.rateLimitOptions != null && message.hasOwnProperty("rateLimitOptions")) {
                                properties._rateLimitOptions = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions.verify(message.rateLimitOptions);
                                    if (error)
                                        return "rateLimitOptions." + error;
                                }
                            }
                            if (message.redirectOptions != null && message.hasOwnProperty("redirectOptions")) {
                                properties._redirectOptions = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions.verify(message.redirectOptions);
                                    if (error)
                                        return "redirectOptions." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPolicyRule message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPolicyRule} SecurityPolicyRule
                         */
                        SecurityPolicyRule.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPolicyRule)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPolicyRule();
                            if (object.action != null)
                                message.action = String(object.action);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.headerAction != null) {
                                if (typeof object.headerAction !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicyRule.headerAction: object expected");
                                message.headerAction = $root.google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction.fromObject(object.headerAction);
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.match != null) {
                                if (typeof object.match !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicyRule.match: object expected");
                                message.match = $root.google.cloud.compute.v1.SecurityPolicyRuleMatcher.fromObject(object.match);
                            }
                            if (object.preview != null)
                                message.preview = Boolean(object.preview);
                            if (object.priority != null)
                                message.priority = object.priority | 0;
                            if (object.rateLimitOptions != null) {
                                if (typeof object.rateLimitOptions !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicyRule.rateLimitOptions: object expected");
                                message.rateLimitOptions = $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions.fromObject(object.rateLimitOptions);
                            }
                            if (object.redirectOptions != null) {
                                if (typeof object.redirectOptions !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicyRule.redirectOptions: object expected");
                                message.redirectOptions = $root.google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions.fromObject(object.redirectOptions);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPolicyRule message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPolicyRule} message SecurityPolicyRule
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPolicyRule.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.rateLimitOptions != null && message.hasOwnProperty("rateLimitOptions")) {
                                object.rateLimitOptions = $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions.toObject(message.rateLimitOptions, options);
                                if (options.oneofs)
                                    object._rateLimitOptions = "rateLimitOptions";
                            }
                            if (message.match != null && message.hasOwnProperty("match")) {
                                object.match = $root.google.cloud.compute.v1.SecurityPolicyRuleMatcher.toObject(message.match, options);
                                if (options.oneofs)
                                    object._match = "match";
                            }
                            if (message.redirectOptions != null && message.hasOwnProperty("redirectOptions")) {
                                object.redirectOptions = $root.google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions.toObject(message.redirectOptions, options);
                                if (options.oneofs)
                                    object._redirectOptions = "redirectOptions";
                            }
                            if (message.action != null && message.hasOwnProperty("action")) {
                                object.action = message.action;
                                if (options.oneofs)
                                    object._action = "action";
                            }
                            if (message.preview != null && message.hasOwnProperty("preview")) {
                                object.preview = message.preview;
                                if (options.oneofs)
                                    object._preview = "preview";
                            }
                            if (message.headerAction != null && message.hasOwnProperty("headerAction")) {
                                object.headerAction = $root.google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction.toObject(message.headerAction, options);
                                if (options.oneofs)
                                    object._headerAction = "headerAction";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.priority != null && message.hasOwnProperty("priority")) {
                                object.priority = message.priority;
                                if (options.oneofs)
                                    object._priority = "priority";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPolicyRule to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPolicyRule.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPolicyRule
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPolicyRule
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPolicyRule.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPolicyRule";
                        };
    
                        return SecurityPolicyRule;
                    })();
    
                    v1.SecurityPolicyRuleHttpHeaderAction = (function() {
    
                        /**
                         * Properties of a SecurityPolicyRuleHttpHeaderAction.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPolicyRuleHttpHeaderAction
                         * @property {Array.<google.cloud.compute.v1.ISecurityPolicyRuleHttpHeaderActionHttpHeaderOption>|null} [requestHeadersToAdds] SecurityPolicyRuleHttpHeaderAction requestHeadersToAdds
                         */
    
                        /**
                         * Constructs a new SecurityPolicyRuleHttpHeaderAction.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPolicyRuleHttpHeaderAction.
                         * @implements ISecurityPolicyRuleHttpHeaderAction
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleHttpHeaderAction=} [properties] Properties to set
                         */
                        function SecurityPolicyRuleHttpHeaderAction(properties) {
                            this.requestHeadersToAdds = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPolicyRuleHttpHeaderAction requestHeadersToAdds.
                         * @member {Array.<google.cloud.compute.v1.ISecurityPolicyRuleHttpHeaderActionHttpHeaderOption>} requestHeadersToAdds
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction
                         * @instance
                         */
                        SecurityPolicyRuleHttpHeaderAction.prototype.requestHeadersToAdds = $util.emptyArray;
    
                        /**
                         * Creates a new SecurityPolicyRuleHttpHeaderAction instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleHttpHeaderAction=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction} SecurityPolicyRuleHttpHeaderAction instance
                         */
                        SecurityPolicyRuleHttpHeaderAction.create = function create(properties) {
                            return new SecurityPolicyRuleHttpHeaderAction(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyRuleHttpHeaderAction message. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleHttpHeaderAction} message SecurityPolicyRuleHttpHeaderAction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyRuleHttpHeaderAction.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestHeadersToAdds != null && message.requestHeadersToAdds.length)
                                for (var i = 0; i < message.requestHeadersToAdds.length; ++i)
                                    $root.google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.encode(message.requestHeadersToAdds[i], writer.uint32(/* id 87987661, wireType 2 =*/703901290).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyRuleHttpHeaderAction message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleHttpHeaderAction} message SecurityPolicyRuleHttpHeaderAction message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyRuleHttpHeaderAction.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPolicyRuleHttpHeaderAction message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction} SecurityPolicyRuleHttpHeaderAction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyRuleHttpHeaderAction.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 87987661: {
                                        if (!(message.requestHeadersToAdds && message.requestHeadersToAdds.length))
                                            message.requestHeadersToAdds = [];
                                        message.requestHeadersToAdds.push($root.google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPolicyRuleHttpHeaderAction message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction} SecurityPolicyRuleHttpHeaderAction
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyRuleHttpHeaderAction.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPolicyRuleHttpHeaderAction message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPolicyRuleHttpHeaderAction.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.requestHeadersToAdds != null && message.hasOwnProperty("requestHeadersToAdds")) {
                                if (!Array.isArray(message.requestHeadersToAdds))
                                    return "requestHeadersToAdds: array expected";
                                for (var i = 0; i < message.requestHeadersToAdds.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.verify(message.requestHeadersToAdds[i]);
                                    if (error)
                                        return "requestHeadersToAdds." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPolicyRuleHttpHeaderAction message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction} SecurityPolicyRuleHttpHeaderAction
                         */
                        SecurityPolicyRuleHttpHeaderAction.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction();
                            if (object.requestHeadersToAdds) {
                                if (!Array.isArray(object.requestHeadersToAdds))
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction.requestHeadersToAdds: array expected");
                                message.requestHeadersToAdds = [];
                                for (var i = 0; i < object.requestHeadersToAdds.length; ++i) {
                                    if (typeof object.requestHeadersToAdds[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction.requestHeadersToAdds: object expected");
                                    message.requestHeadersToAdds[i] = $root.google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.fromObject(object.requestHeadersToAdds[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPolicyRuleHttpHeaderAction message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction} message SecurityPolicyRuleHttpHeaderAction
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPolicyRuleHttpHeaderAction.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.requestHeadersToAdds = [];
                            if (message.requestHeadersToAdds && message.requestHeadersToAdds.length) {
                                object.requestHeadersToAdds = [];
                                for (var j = 0; j < message.requestHeadersToAdds.length; ++j)
                                    object.requestHeadersToAdds[j] = $root.google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.toObject(message.requestHeadersToAdds[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPolicyRuleHttpHeaderAction to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPolicyRuleHttpHeaderAction.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPolicyRuleHttpHeaderAction
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPolicyRuleHttpHeaderAction.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderAction";
                        };
    
                        return SecurityPolicyRuleHttpHeaderAction;
                    })();
    
                    v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption = (function() {
    
                        /**
                         * Properties of a SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         * @property {string|null} [headerName] SecurityPolicyRuleHttpHeaderActionHttpHeaderOption headerName
                         * @property {string|null} [headerValue] SecurityPolicyRuleHttpHeaderActionHttpHeaderOption headerValue
                         */
    
                        /**
                         * Constructs a new SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.
                         * @implements ISecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleHttpHeaderActionHttpHeaderOption=} [properties] Properties to set
                         */
                        function SecurityPolicyRuleHttpHeaderActionHttpHeaderOption(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPolicyRuleHttpHeaderActionHttpHeaderOption headerName.
                         * @member {string|null|undefined} headerName
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         * @instance
                         */
                        SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.prototype.headerName = null;
    
                        /**
                         * SecurityPolicyRuleHttpHeaderActionHttpHeaderOption headerValue.
                         * @member {string|null|undefined} headerValue
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         * @instance
                         */
                        SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.prototype.headerValue = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SecurityPolicyRuleHttpHeaderActionHttpHeaderOption _headerName.
                         * @member {"headerName"|undefined} _headerName
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.prototype, "_headerName", {
                            get: $util.oneOfGetter($oneOfFields = ["headerName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyRuleHttpHeaderActionHttpHeaderOption _headerValue.
                         * @member {"headerValue"|undefined} _headerValue
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.prototype, "_headerValue", {
                            get: $util.oneOfGetter($oneOfFields = ["headerValue"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SecurityPolicyRuleHttpHeaderActionHttpHeaderOption instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleHttpHeaderActionHttpHeaderOption=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption} SecurityPolicyRuleHttpHeaderActionHttpHeaderOption instance
                         */
                        SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.create = function create(properties) {
                            return new SecurityPolicyRuleHttpHeaderActionHttpHeaderOption(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyRuleHttpHeaderActionHttpHeaderOption message. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleHttpHeaderActionHttpHeaderOption} message SecurityPolicyRuleHttpHeaderActionHttpHeaderOption message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.headerName != null && Object.hasOwnProperty.call(message, "headerName"))
                                writer.uint32(/* id 110223613, wireType 2 =*/881788906).string(message.headerName);
                            if (message.headerValue != null && Object.hasOwnProperty.call(message, "headerValue"))
                                writer.uint32(/* id 203094335, wireType 2 =*/1624754682).string(message.headerValue);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyRuleHttpHeaderActionHttpHeaderOption message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleHttpHeaderActionHttpHeaderOption} message SecurityPolicyRuleHttpHeaderActionHttpHeaderOption message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPolicyRuleHttpHeaderActionHttpHeaderOption message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption} SecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 110223613: {
                                        message.headerName = reader.string();
                                        break;
                                    }
                                case 203094335: {
                                        message.headerValue = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPolicyRuleHttpHeaderActionHttpHeaderOption message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption} SecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPolicyRuleHttpHeaderActionHttpHeaderOption message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.headerName != null && message.hasOwnProperty("headerName")) {
                                properties._headerName = 1;
                                if (!$util.isString(message.headerName))
                                    return "headerName: string expected";
                            }
                            if (message.headerValue != null && message.hasOwnProperty("headerValue")) {
                                properties._headerValue = 1;
                                if (!$util.isString(message.headerValue))
                                    return "headerValue: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPolicyRuleHttpHeaderActionHttpHeaderOption message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption} SecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         */
                        SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption();
                            if (object.headerName != null)
                                message.headerName = String(object.headerName);
                            if (object.headerValue != null)
                                message.headerValue = String(object.headerValue);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPolicyRuleHttpHeaderActionHttpHeaderOption message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption} message SecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.headerName != null && message.hasOwnProperty("headerName")) {
                                object.headerName = message.headerName;
                                if (options.oneofs)
                                    object._headerName = "headerName";
                            }
                            if (message.headerValue != null && message.hasOwnProperty("headerValue")) {
                                object.headerValue = message.headerValue;
                                if (options.oneofs)
                                    object._headerValue = "headerValue";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPolicyRuleHttpHeaderActionHttpHeaderOption to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPolicyRuleHttpHeaderActionHttpHeaderOption.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPolicyRuleHttpHeaderActionHttpHeaderOption";
                        };
    
                        return SecurityPolicyRuleHttpHeaderActionHttpHeaderOption;
                    })();
    
                    v1.SecurityPolicyRuleMatcher = (function() {
    
                        /**
                         * Properties of a SecurityPolicyRuleMatcher.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPolicyRuleMatcher
                         * @property {google.cloud.compute.v1.ISecurityPolicyRuleMatcherConfig|null} [config] SecurityPolicyRuleMatcher config
                         * @property {google.cloud.compute.v1.IExpr|null} [expr] SecurityPolicyRuleMatcher expr
                         * @property {string|null} [versionedExpr] SecurityPolicyRuleMatcher versionedExpr
                         */
    
                        /**
                         * Constructs a new SecurityPolicyRuleMatcher.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPolicyRuleMatcher.
                         * @implements ISecurityPolicyRuleMatcher
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleMatcher=} [properties] Properties to set
                         */
                        function SecurityPolicyRuleMatcher(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPolicyRuleMatcher config.
                         * @member {google.cloud.compute.v1.ISecurityPolicyRuleMatcherConfig|null|undefined} config
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcher
                         * @instance
                         */
                        SecurityPolicyRuleMatcher.prototype.config = null;
    
                        /**
                         * SecurityPolicyRuleMatcher expr.
                         * @member {google.cloud.compute.v1.IExpr|null|undefined} expr
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcher
                         * @instance
                         */
                        SecurityPolicyRuleMatcher.prototype.expr = null;
    
                        /**
                         * SecurityPolicyRuleMatcher versionedExpr.
                         * @member {string|null|undefined} versionedExpr
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcher
                         * @instance
                         */
                        SecurityPolicyRuleMatcher.prototype.versionedExpr = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SecurityPolicyRuleMatcher _config.
                         * @member {"config"|undefined} _config
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcher
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRuleMatcher.prototype, "_config", {
                            get: $util.oneOfGetter($oneOfFields = ["config"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyRuleMatcher _expr.
                         * @member {"expr"|undefined} _expr
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcher
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRuleMatcher.prototype, "_expr", {
                            get: $util.oneOfGetter($oneOfFields = ["expr"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyRuleMatcher _versionedExpr.
                         * @member {"versionedExpr"|undefined} _versionedExpr
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcher
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRuleMatcher.prototype, "_versionedExpr", {
                            get: $util.oneOfGetter($oneOfFields = ["versionedExpr"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SecurityPolicyRuleMatcher instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcher
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleMatcher=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleMatcher} SecurityPolicyRuleMatcher instance
                         */
                        SecurityPolicyRuleMatcher.create = function create(properties) {
                            return new SecurityPolicyRuleMatcher(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyRuleMatcher message. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyRuleMatcher.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcher
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleMatcher} message SecurityPolicyRuleMatcher message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyRuleMatcher.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.expr != null && Object.hasOwnProperty.call(message, "expr"))
                                $root.google.cloud.compute.v1.Expr.encode(message.expr, writer.uint32(/* id 3127797, wireType 2 =*/25022378).fork()).ldelim();
                            if (message.config != null && Object.hasOwnProperty.call(message, "config"))
                                $root.google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig.encode(message.config, writer.uint32(/* id 255820610, wireType 2 =*/2046564882).fork()).ldelim();
                            if (message.versionedExpr != null && Object.hasOwnProperty.call(message, "versionedExpr"))
                                writer.uint32(/* id 322286013, wireType 2 =*/2578288106).string(message.versionedExpr);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyRuleMatcher message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyRuleMatcher.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcher
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleMatcher} message SecurityPolicyRuleMatcher message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyRuleMatcher.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPolicyRuleMatcher message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcher
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleMatcher} SecurityPolicyRuleMatcher
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyRuleMatcher.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPolicyRuleMatcher();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 255820610: {
                                        message.config = $root.google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3127797: {
                                        message.expr = $root.google.cloud.compute.v1.Expr.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 322286013: {
                                        message.versionedExpr = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPolicyRuleMatcher message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcher
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleMatcher} SecurityPolicyRuleMatcher
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyRuleMatcher.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPolicyRuleMatcher message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcher
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPolicyRuleMatcher.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.config != null && message.hasOwnProperty("config")) {
                                properties._config = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig.verify(message.config);
                                    if (error)
                                        return "config." + error;
                                }
                            }
                            if (message.expr != null && message.hasOwnProperty("expr")) {
                                properties._expr = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Expr.verify(message.expr);
                                    if (error)
                                        return "expr." + error;
                                }
                            }
                            if (message.versionedExpr != null && message.hasOwnProperty("versionedExpr")) {
                                properties._versionedExpr = 1;
                                if (!$util.isString(message.versionedExpr))
                                    return "versionedExpr: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPolicyRuleMatcher message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcher
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleMatcher} SecurityPolicyRuleMatcher
                         */
                        SecurityPolicyRuleMatcher.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPolicyRuleMatcher)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPolicyRuleMatcher();
                            if (object.config != null) {
                                if (typeof object.config !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicyRuleMatcher.config: object expected");
                                message.config = $root.google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig.fromObject(object.config);
                            }
                            if (object.expr != null) {
                                if (typeof object.expr !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicyRuleMatcher.expr: object expected");
                                message.expr = $root.google.cloud.compute.v1.Expr.fromObject(object.expr);
                            }
                            if (object.versionedExpr != null)
                                message.versionedExpr = String(object.versionedExpr);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPolicyRuleMatcher message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcher
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPolicyRuleMatcher} message SecurityPolicyRuleMatcher
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPolicyRuleMatcher.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.expr != null && message.hasOwnProperty("expr")) {
                                object.expr = $root.google.cloud.compute.v1.Expr.toObject(message.expr, options);
                                if (options.oneofs)
                                    object._expr = "expr";
                            }
                            if (message.config != null && message.hasOwnProperty("config")) {
                                object.config = $root.google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig.toObject(message.config, options);
                                if (options.oneofs)
                                    object._config = "config";
                            }
                            if (message.versionedExpr != null && message.hasOwnProperty("versionedExpr")) {
                                object.versionedExpr = message.versionedExpr;
                                if (options.oneofs)
                                    object._versionedExpr = "versionedExpr";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPolicyRuleMatcher to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcher
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPolicyRuleMatcher.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPolicyRuleMatcher
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcher
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPolicyRuleMatcher.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPolicyRuleMatcher";
                        };
    
                        /**
                         * VersionedExpr enum.
                         * @name google.cloud.compute.v1.SecurityPolicyRuleMatcher.VersionedExpr
                         * @enum {number}
                         * @property {number} UNDEFINED_VERSIONED_EXPR=0 UNDEFINED_VERSIONED_EXPR value
                         * @property {number} SRC_IPS_V1=70925961 SRC_IPS_V1 value
                         */
                        SecurityPolicyRuleMatcher.VersionedExpr = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_VERSIONED_EXPR"] = 0;
                            values[valuesById[70925961] = "SRC_IPS_V1"] = 70925961;
                            return values;
                        })();
    
                        return SecurityPolicyRuleMatcher;
                    })();
    
                    v1.SecurityPolicyRuleMatcherConfig = (function() {
    
                        /**
                         * Properties of a SecurityPolicyRuleMatcherConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPolicyRuleMatcherConfig
                         * @property {Array.<string>|null} [srcIpRanges] SecurityPolicyRuleMatcherConfig srcIpRanges
                         */
    
                        /**
                         * Constructs a new SecurityPolicyRuleMatcherConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPolicyRuleMatcherConfig.
                         * @implements ISecurityPolicyRuleMatcherConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleMatcherConfig=} [properties] Properties to set
                         */
                        function SecurityPolicyRuleMatcherConfig(properties) {
                            this.srcIpRanges = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPolicyRuleMatcherConfig srcIpRanges.
                         * @member {Array.<string>} srcIpRanges
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig
                         * @instance
                         */
                        SecurityPolicyRuleMatcherConfig.prototype.srcIpRanges = $util.emptyArray;
    
                        /**
                         * Creates a new SecurityPolicyRuleMatcherConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleMatcherConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig} SecurityPolicyRuleMatcherConfig instance
                         */
                        SecurityPolicyRuleMatcherConfig.create = function create(properties) {
                            return new SecurityPolicyRuleMatcherConfig(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyRuleMatcherConfig message. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleMatcherConfig} message SecurityPolicyRuleMatcherConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyRuleMatcherConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.srcIpRanges != null && message.srcIpRanges.length)
                                for (var i = 0; i < message.srcIpRanges.length; ++i)
                                    writer.uint32(/* id 432128083, wireType 2 =*/3457024666).string(message.srcIpRanges[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyRuleMatcherConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleMatcherConfig} message SecurityPolicyRuleMatcherConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyRuleMatcherConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPolicyRuleMatcherConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig} SecurityPolicyRuleMatcherConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyRuleMatcherConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 432128083: {
                                        if (!(message.srcIpRanges && message.srcIpRanges.length))
                                            message.srcIpRanges = [];
                                        message.srcIpRanges.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPolicyRuleMatcherConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig} SecurityPolicyRuleMatcherConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyRuleMatcherConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPolicyRuleMatcherConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPolicyRuleMatcherConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.srcIpRanges != null && message.hasOwnProperty("srcIpRanges")) {
                                if (!Array.isArray(message.srcIpRanges))
                                    return "srcIpRanges: array expected";
                                for (var i = 0; i < message.srcIpRanges.length; ++i)
                                    if (!$util.isString(message.srcIpRanges[i]))
                                        return "srcIpRanges: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPolicyRuleMatcherConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig} SecurityPolicyRuleMatcherConfig
                         */
                        SecurityPolicyRuleMatcherConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig();
                            if (object.srcIpRanges) {
                                if (!Array.isArray(object.srcIpRanges))
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig.srcIpRanges: array expected");
                                message.srcIpRanges = [];
                                for (var i = 0; i < object.srcIpRanges.length; ++i)
                                    message.srcIpRanges[i] = String(object.srcIpRanges[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPolicyRuleMatcherConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig} message SecurityPolicyRuleMatcherConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPolicyRuleMatcherConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.srcIpRanges = [];
                            if (message.srcIpRanges && message.srcIpRanges.length) {
                                object.srcIpRanges = [];
                                for (var j = 0; j < message.srcIpRanges.length; ++j)
                                    object.srcIpRanges[j] = message.srcIpRanges[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPolicyRuleMatcherConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPolicyRuleMatcherConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPolicyRuleMatcherConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPolicyRuleMatcherConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPolicyRuleMatcherConfig";
                        };
    
                        return SecurityPolicyRuleMatcherConfig;
                    })();
    
                    v1.SecurityPolicyRuleRateLimitOptions = (function() {
    
                        /**
                         * Properties of a SecurityPolicyRuleRateLimitOptions.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPolicyRuleRateLimitOptions
                         * @property {number|null} [banDurationSec] SecurityPolicyRuleRateLimitOptions banDurationSec
                         * @property {google.cloud.compute.v1.ISecurityPolicyRuleRateLimitOptionsThreshold|null} [banThreshold] SecurityPolicyRuleRateLimitOptions banThreshold
                         * @property {string|null} [conformAction] SecurityPolicyRuleRateLimitOptions conformAction
                         * @property {string|null} [enforceOnKey] SecurityPolicyRuleRateLimitOptions enforceOnKey
                         * @property {string|null} [enforceOnKeyName] SecurityPolicyRuleRateLimitOptions enforceOnKeyName
                         * @property {string|null} [exceedAction] SecurityPolicyRuleRateLimitOptions exceedAction
                         * @property {google.cloud.compute.v1.ISecurityPolicyRuleRedirectOptions|null} [exceedRedirectOptions] SecurityPolicyRuleRateLimitOptions exceedRedirectOptions
                         * @property {google.cloud.compute.v1.ISecurityPolicyRuleRateLimitOptionsThreshold|null} [rateLimitThreshold] SecurityPolicyRuleRateLimitOptions rateLimitThreshold
                         */
    
                        /**
                         * Constructs a new SecurityPolicyRuleRateLimitOptions.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPolicyRuleRateLimitOptions.
                         * @implements ISecurityPolicyRuleRateLimitOptions
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleRateLimitOptions=} [properties] Properties to set
                         */
                        function SecurityPolicyRuleRateLimitOptions(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPolicyRuleRateLimitOptions banDurationSec.
                         * @member {number|null|undefined} banDurationSec
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @instance
                         */
                        SecurityPolicyRuleRateLimitOptions.prototype.banDurationSec = null;
    
                        /**
                         * SecurityPolicyRuleRateLimitOptions banThreshold.
                         * @member {google.cloud.compute.v1.ISecurityPolicyRuleRateLimitOptionsThreshold|null|undefined} banThreshold
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @instance
                         */
                        SecurityPolicyRuleRateLimitOptions.prototype.banThreshold = null;
    
                        /**
                         * SecurityPolicyRuleRateLimitOptions conformAction.
                         * @member {string|null|undefined} conformAction
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @instance
                         */
                        SecurityPolicyRuleRateLimitOptions.prototype.conformAction = null;
    
                        /**
                         * SecurityPolicyRuleRateLimitOptions enforceOnKey.
                         * @member {string|null|undefined} enforceOnKey
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @instance
                         */
                        SecurityPolicyRuleRateLimitOptions.prototype.enforceOnKey = null;
    
                        /**
                         * SecurityPolicyRuleRateLimitOptions enforceOnKeyName.
                         * @member {string|null|undefined} enforceOnKeyName
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @instance
                         */
                        SecurityPolicyRuleRateLimitOptions.prototype.enforceOnKeyName = null;
    
                        /**
                         * SecurityPolicyRuleRateLimitOptions exceedAction.
                         * @member {string|null|undefined} exceedAction
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @instance
                         */
                        SecurityPolicyRuleRateLimitOptions.prototype.exceedAction = null;
    
                        /**
                         * SecurityPolicyRuleRateLimitOptions exceedRedirectOptions.
                         * @member {google.cloud.compute.v1.ISecurityPolicyRuleRedirectOptions|null|undefined} exceedRedirectOptions
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @instance
                         */
                        SecurityPolicyRuleRateLimitOptions.prototype.exceedRedirectOptions = null;
    
                        /**
                         * SecurityPolicyRuleRateLimitOptions rateLimitThreshold.
                         * @member {google.cloud.compute.v1.ISecurityPolicyRuleRateLimitOptionsThreshold|null|undefined} rateLimitThreshold
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @instance
                         */
                        SecurityPolicyRuleRateLimitOptions.prototype.rateLimitThreshold = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SecurityPolicyRuleRateLimitOptions _banDurationSec.
                         * @member {"banDurationSec"|undefined} _banDurationSec
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRuleRateLimitOptions.prototype, "_banDurationSec", {
                            get: $util.oneOfGetter($oneOfFields = ["banDurationSec"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyRuleRateLimitOptions _banThreshold.
                         * @member {"banThreshold"|undefined} _banThreshold
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRuleRateLimitOptions.prototype, "_banThreshold", {
                            get: $util.oneOfGetter($oneOfFields = ["banThreshold"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyRuleRateLimitOptions _conformAction.
                         * @member {"conformAction"|undefined} _conformAction
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRuleRateLimitOptions.prototype, "_conformAction", {
                            get: $util.oneOfGetter($oneOfFields = ["conformAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyRuleRateLimitOptions _enforceOnKey.
                         * @member {"enforceOnKey"|undefined} _enforceOnKey
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRuleRateLimitOptions.prototype, "_enforceOnKey", {
                            get: $util.oneOfGetter($oneOfFields = ["enforceOnKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyRuleRateLimitOptions _enforceOnKeyName.
                         * @member {"enforceOnKeyName"|undefined} _enforceOnKeyName
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRuleRateLimitOptions.prototype, "_enforceOnKeyName", {
                            get: $util.oneOfGetter($oneOfFields = ["enforceOnKeyName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyRuleRateLimitOptions _exceedAction.
                         * @member {"exceedAction"|undefined} _exceedAction
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRuleRateLimitOptions.prototype, "_exceedAction", {
                            get: $util.oneOfGetter($oneOfFields = ["exceedAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyRuleRateLimitOptions _exceedRedirectOptions.
                         * @member {"exceedRedirectOptions"|undefined} _exceedRedirectOptions
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRuleRateLimitOptions.prototype, "_exceedRedirectOptions", {
                            get: $util.oneOfGetter($oneOfFields = ["exceedRedirectOptions"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyRuleRateLimitOptions _rateLimitThreshold.
                         * @member {"rateLimitThreshold"|undefined} _rateLimitThreshold
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRuleRateLimitOptions.prototype, "_rateLimitThreshold", {
                            get: $util.oneOfGetter($oneOfFields = ["rateLimitThreshold"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SecurityPolicyRuleRateLimitOptions instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleRateLimitOptions=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions} SecurityPolicyRuleRateLimitOptions instance
                         */
                        SecurityPolicyRuleRateLimitOptions.create = function create(properties) {
                            return new SecurityPolicyRuleRateLimitOptions(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyRuleRateLimitOptions message. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleRateLimitOptions} message SecurityPolicyRuleRateLimitOptions message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyRuleRateLimitOptions.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.banDurationSec != null && Object.hasOwnProperty.call(message, "banDurationSec"))
                                writer.uint32(/* id 42896726, wireType 0 =*/343173808).int32(message.banDurationSec);
                            if (message.enforceOnKeyName != null && Object.hasOwnProperty.call(message, "enforceOnKeyName"))
                                writer.uint32(/* id 132555246, wireType 2 =*/1060441970).string(message.enforceOnKeyName);
                            if (message.exceedAction != null && Object.hasOwnProperty.call(message, "exceedAction"))
                                writer.uint32(/* id 167159073, wireType 2 =*/1337272586).string(message.exceedAction);
                            if (message.rateLimitThreshold != null && Object.hasOwnProperty.call(message, "rateLimitThreshold"))
                                $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold.encode(message.rateLimitThreshold, writer.uint32(/* id 315875208, wireType 2 =*/2527001666).fork()).ldelim();
                            if (message.enforceOnKey != null && Object.hasOwnProperty.call(message, "enforceOnKey"))
                                writer.uint32(/* id 416648956, wireType 2 =*/3333191650).string(message.enforceOnKey);
                            if (message.exceedRedirectOptions != null && Object.hasOwnProperty.call(message, "exceedRedirectOptions"))
                                $root.google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions.encode(message.exceedRedirectOptions, writer.uint32(/* id 473646694, wireType 2 =*/3789173554).fork()).ldelim();
                            if (message.banThreshold != null && Object.hasOwnProperty.call(message, "banThreshold"))
                                $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold.encode(message.banThreshold, writer.uint32(/* id 501208123, wireType 2 =*/4009664986).fork()).ldelim();
                            if (message.conformAction != null && Object.hasOwnProperty.call(message, "conformAction"))
                                writer.uint32(/* id 517612367, wireType 2 =*/4140898938).string(message.conformAction);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyRuleRateLimitOptions message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleRateLimitOptions} message SecurityPolicyRuleRateLimitOptions message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyRuleRateLimitOptions.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPolicyRuleRateLimitOptions message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions} SecurityPolicyRuleRateLimitOptions
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyRuleRateLimitOptions.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 42896726: {
                                        message.banDurationSec = reader.int32();
                                        break;
                                    }
                                case 501208123: {
                                        message.banThreshold = $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 517612367: {
                                        message.conformAction = reader.string();
                                        break;
                                    }
                                case 416648956: {
                                        message.enforceOnKey = reader.string();
                                        break;
                                    }
                                case 132555246: {
                                        message.enforceOnKeyName = reader.string();
                                        break;
                                    }
                                case 167159073: {
                                        message.exceedAction = reader.string();
                                        break;
                                    }
                                case 473646694: {
                                        message.exceedRedirectOptions = $root.google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 315875208: {
                                        message.rateLimitThreshold = $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPolicyRuleRateLimitOptions message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions} SecurityPolicyRuleRateLimitOptions
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyRuleRateLimitOptions.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPolicyRuleRateLimitOptions message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPolicyRuleRateLimitOptions.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.banDurationSec != null && message.hasOwnProperty("banDurationSec")) {
                                properties._banDurationSec = 1;
                                if (!$util.isInteger(message.banDurationSec))
                                    return "banDurationSec: integer expected";
                            }
                            if (message.banThreshold != null && message.hasOwnProperty("banThreshold")) {
                                properties._banThreshold = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold.verify(message.banThreshold);
                                    if (error)
                                        return "banThreshold." + error;
                                }
                            }
                            if (message.conformAction != null && message.hasOwnProperty("conformAction")) {
                                properties._conformAction = 1;
                                if (!$util.isString(message.conformAction))
                                    return "conformAction: string expected";
                            }
                            if (message.enforceOnKey != null && message.hasOwnProperty("enforceOnKey")) {
                                properties._enforceOnKey = 1;
                                if (!$util.isString(message.enforceOnKey))
                                    return "enforceOnKey: string expected";
                            }
                            if (message.enforceOnKeyName != null && message.hasOwnProperty("enforceOnKeyName")) {
                                properties._enforceOnKeyName = 1;
                                if (!$util.isString(message.enforceOnKeyName))
                                    return "enforceOnKeyName: string expected";
                            }
                            if (message.exceedAction != null && message.hasOwnProperty("exceedAction")) {
                                properties._exceedAction = 1;
                                if (!$util.isString(message.exceedAction))
                                    return "exceedAction: string expected";
                            }
                            if (message.exceedRedirectOptions != null && message.hasOwnProperty("exceedRedirectOptions")) {
                                properties._exceedRedirectOptions = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions.verify(message.exceedRedirectOptions);
                                    if (error)
                                        return "exceedRedirectOptions." + error;
                                }
                            }
                            if (message.rateLimitThreshold != null && message.hasOwnProperty("rateLimitThreshold")) {
                                properties._rateLimitThreshold = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold.verify(message.rateLimitThreshold);
                                    if (error)
                                        return "rateLimitThreshold." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPolicyRuleRateLimitOptions message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions} SecurityPolicyRuleRateLimitOptions
                         */
                        SecurityPolicyRuleRateLimitOptions.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions();
                            if (object.banDurationSec != null)
                                message.banDurationSec = object.banDurationSec | 0;
                            if (object.banThreshold != null) {
                                if (typeof object.banThreshold !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions.banThreshold: object expected");
                                message.banThreshold = $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold.fromObject(object.banThreshold);
                            }
                            if (object.conformAction != null)
                                message.conformAction = String(object.conformAction);
                            if (object.enforceOnKey != null)
                                message.enforceOnKey = String(object.enforceOnKey);
                            if (object.enforceOnKeyName != null)
                                message.enforceOnKeyName = String(object.enforceOnKeyName);
                            if (object.exceedAction != null)
                                message.exceedAction = String(object.exceedAction);
                            if (object.exceedRedirectOptions != null) {
                                if (typeof object.exceedRedirectOptions !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions.exceedRedirectOptions: object expected");
                                message.exceedRedirectOptions = $root.google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions.fromObject(object.exceedRedirectOptions);
                            }
                            if (object.rateLimitThreshold != null) {
                                if (typeof object.rateLimitThreshold !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions.rateLimitThreshold: object expected");
                                message.rateLimitThreshold = $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold.fromObject(object.rateLimitThreshold);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPolicyRuleRateLimitOptions message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions} message SecurityPolicyRuleRateLimitOptions
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPolicyRuleRateLimitOptions.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.banDurationSec != null && message.hasOwnProperty("banDurationSec")) {
                                object.banDurationSec = message.banDurationSec;
                                if (options.oneofs)
                                    object._banDurationSec = "banDurationSec";
                            }
                            if (message.enforceOnKeyName != null && message.hasOwnProperty("enforceOnKeyName")) {
                                object.enforceOnKeyName = message.enforceOnKeyName;
                                if (options.oneofs)
                                    object._enforceOnKeyName = "enforceOnKeyName";
                            }
                            if (message.exceedAction != null && message.hasOwnProperty("exceedAction")) {
                                object.exceedAction = message.exceedAction;
                                if (options.oneofs)
                                    object._exceedAction = "exceedAction";
                            }
                            if (message.rateLimitThreshold != null && message.hasOwnProperty("rateLimitThreshold")) {
                                object.rateLimitThreshold = $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold.toObject(message.rateLimitThreshold, options);
                                if (options.oneofs)
                                    object._rateLimitThreshold = "rateLimitThreshold";
                            }
                            if (message.enforceOnKey != null && message.hasOwnProperty("enforceOnKey")) {
                                object.enforceOnKey = message.enforceOnKey;
                                if (options.oneofs)
                                    object._enforceOnKey = "enforceOnKey";
                            }
                            if (message.exceedRedirectOptions != null && message.hasOwnProperty("exceedRedirectOptions")) {
                                object.exceedRedirectOptions = $root.google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions.toObject(message.exceedRedirectOptions, options);
                                if (options.oneofs)
                                    object._exceedRedirectOptions = "exceedRedirectOptions";
                            }
                            if (message.banThreshold != null && message.hasOwnProperty("banThreshold")) {
                                object.banThreshold = $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold.toObject(message.banThreshold, options);
                                if (options.oneofs)
                                    object._banThreshold = "banThreshold";
                            }
                            if (message.conformAction != null && message.hasOwnProperty("conformAction")) {
                                object.conformAction = message.conformAction;
                                if (options.oneofs)
                                    object._conformAction = "conformAction";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPolicyRuleRateLimitOptions to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPolicyRuleRateLimitOptions.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPolicyRuleRateLimitOptions
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPolicyRuleRateLimitOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions";
                        };
    
                        /**
                         * EnforceOnKey enum.
                         * @name google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptions.EnforceOnKey
                         * @enum {number}
                         * @property {number} UNDEFINED_ENFORCE_ON_KEY=0 UNDEFINED_ENFORCE_ON_KEY value
                         * @property {number} ALL=64897 ALL value
                         * @property {number} HTTP_COOKIE=494981627 HTTP_COOKIE value
                         * @property {number} HTTP_HEADER=91597348 HTTP_HEADER value
                         * @property {number} HTTP_PATH=311503228 HTTP_PATH value
                         * @property {number} IP=2343 IP value
                         * @property {number} REGION_CODE=79559768 REGION_CODE value
                         * @property {number} SNI=82254 SNI value
                         * @property {number} XFF_IP=438707118 XFF_IP value
                         */
                        SecurityPolicyRuleRateLimitOptions.EnforceOnKey = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ENFORCE_ON_KEY"] = 0;
                            values[valuesById[64897] = "ALL"] = 64897;
                            values[valuesById[494981627] = "HTTP_COOKIE"] = 494981627;
                            values[valuesById[91597348] = "HTTP_HEADER"] = 91597348;
                            values[valuesById[311503228] = "HTTP_PATH"] = 311503228;
                            values[valuesById[2343] = "IP"] = 2343;
                            values[valuesById[79559768] = "REGION_CODE"] = 79559768;
                            values[valuesById[82254] = "SNI"] = 82254;
                            values[valuesById[438707118] = "XFF_IP"] = 438707118;
                            return values;
                        })();
    
                        return SecurityPolicyRuleRateLimitOptions;
                    })();
    
                    v1.SecurityPolicyRuleRateLimitOptionsThreshold = (function() {
    
                        /**
                         * Properties of a SecurityPolicyRuleRateLimitOptionsThreshold.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPolicyRuleRateLimitOptionsThreshold
                         * @property {number|null} [count] SecurityPolicyRuleRateLimitOptionsThreshold count
                         * @property {number|null} [intervalSec] SecurityPolicyRuleRateLimitOptionsThreshold intervalSec
                         */
    
                        /**
                         * Constructs a new SecurityPolicyRuleRateLimitOptionsThreshold.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPolicyRuleRateLimitOptionsThreshold.
                         * @implements ISecurityPolicyRuleRateLimitOptionsThreshold
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleRateLimitOptionsThreshold=} [properties] Properties to set
                         */
                        function SecurityPolicyRuleRateLimitOptionsThreshold(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPolicyRuleRateLimitOptionsThreshold count.
                         * @member {number|null|undefined} count
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold
                         * @instance
                         */
                        SecurityPolicyRuleRateLimitOptionsThreshold.prototype.count = null;
    
                        /**
                         * SecurityPolicyRuleRateLimitOptionsThreshold intervalSec.
                         * @member {number|null|undefined} intervalSec
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold
                         * @instance
                         */
                        SecurityPolicyRuleRateLimitOptionsThreshold.prototype.intervalSec = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SecurityPolicyRuleRateLimitOptionsThreshold _count.
                         * @member {"count"|undefined} _count
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRuleRateLimitOptionsThreshold.prototype, "_count", {
                            get: $util.oneOfGetter($oneOfFields = ["count"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyRuleRateLimitOptionsThreshold _intervalSec.
                         * @member {"intervalSec"|undefined} _intervalSec
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRuleRateLimitOptionsThreshold.prototype, "_intervalSec", {
                            get: $util.oneOfGetter($oneOfFields = ["intervalSec"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SecurityPolicyRuleRateLimitOptionsThreshold instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleRateLimitOptionsThreshold=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold} SecurityPolicyRuleRateLimitOptionsThreshold instance
                         */
                        SecurityPolicyRuleRateLimitOptionsThreshold.create = function create(properties) {
                            return new SecurityPolicyRuleRateLimitOptionsThreshold(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyRuleRateLimitOptionsThreshold message. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleRateLimitOptionsThreshold} message SecurityPolicyRuleRateLimitOptionsThreshold message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyRuleRateLimitOptionsThreshold.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.intervalSec != null && Object.hasOwnProperty.call(message, "intervalSec"))
                                writer.uint32(/* id 41084375, wireType 0 =*/328675000).int32(message.intervalSec);
                            if (message.count != null && Object.hasOwnProperty.call(message, "count"))
                                writer.uint32(/* id 94851343, wireType 0 =*/758810744).int32(message.count);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyRuleRateLimitOptionsThreshold message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleRateLimitOptionsThreshold} message SecurityPolicyRuleRateLimitOptionsThreshold message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyRuleRateLimitOptionsThreshold.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPolicyRuleRateLimitOptionsThreshold message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold} SecurityPolicyRuleRateLimitOptionsThreshold
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyRuleRateLimitOptionsThreshold.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 94851343: {
                                        message.count = reader.int32();
                                        break;
                                    }
                                case 41084375: {
                                        message.intervalSec = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPolicyRuleRateLimitOptionsThreshold message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold} SecurityPolicyRuleRateLimitOptionsThreshold
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyRuleRateLimitOptionsThreshold.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPolicyRuleRateLimitOptionsThreshold message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPolicyRuleRateLimitOptionsThreshold.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.count != null && message.hasOwnProperty("count")) {
                                properties._count = 1;
                                if (!$util.isInteger(message.count))
                                    return "count: integer expected";
                            }
                            if (message.intervalSec != null && message.hasOwnProperty("intervalSec")) {
                                properties._intervalSec = 1;
                                if (!$util.isInteger(message.intervalSec))
                                    return "intervalSec: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPolicyRuleRateLimitOptionsThreshold message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold} SecurityPolicyRuleRateLimitOptionsThreshold
                         */
                        SecurityPolicyRuleRateLimitOptionsThreshold.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold();
                            if (object.count != null)
                                message.count = object.count | 0;
                            if (object.intervalSec != null)
                                message.intervalSec = object.intervalSec | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPolicyRuleRateLimitOptionsThreshold message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold} message SecurityPolicyRuleRateLimitOptionsThreshold
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPolicyRuleRateLimitOptionsThreshold.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.intervalSec != null && message.hasOwnProperty("intervalSec")) {
                                object.intervalSec = message.intervalSec;
                                if (options.oneofs)
                                    object._intervalSec = "intervalSec";
                            }
                            if (message.count != null && message.hasOwnProperty("count")) {
                                object.count = message.count;
                                if (options.oneofs)
                                    object._count = "count";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPolicyRuleRateLimitOptionsThreshold to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPolicyRuleRateLimitOptionsThreshold.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPolicyRuleRateLimitOptionsThreshold
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPolicyRuleRateLimitOptionsThreshold.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPolicyRuleRateLimitOptionsThreshold";
                        };
    
                        return SecurityPolicyRuleRateLimitOptionsThreshold;
                    })();
    
                    v1.SecurityPolicyRuleRedirectOptions = (function() {
    
                        /**
                         * Properties of a SecurityPolicyRuleRedirectOptions.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecurityPolicyRuleRedirectOptions
                         * @property {string|null} [target] SecurityPolicyRuleRedirectOptions target
                         * @property {string|null} [type] SecurityPolicyRuleRedirectOptions type
                         */
    
                        /**
                         * Constructs a new SecurityPolicyRuleRedirectOptions.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPolicyRuleRedirectOptions.
                         * @implements ISecurityPolicyRuleRedirectOptions
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleRedirectOptions=} [properties] Properties to set
                         */
                        function SecurityPolicyRuleRedirectOptions(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecurityPolicyRuleRedirectOptions target.
                         * @member {string|null|undefined} target
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions
                         * @instance
                         */
                        SecurityPolicyRuleRedirectOptions.prototype.target = null;
    
                        /**
                         * SecurityPolicyRuleRedirectOptions type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions
                         * @instance
                         */
                        SecurityPolicyRuleRedirectOptions.prototype.type = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SecurityPolicyRuleRedirectOptions _target.
                         * @member {"target"|undefined} _target
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRuleRedirectOptions.prototype, "_target", {
                            get: $util.oneOfGetter($oneOfFields = ["target"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SecurityPolicyRuleRedirectOptions _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions
                         * @instance
                         */
                        Object.defineProperty(SecurityPolicyRuleRedirectOptions.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SecurityPolicyRuleRedirectOptions instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleRedirectOptions=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions} SecurityPolicyRuleRedirectOptions instance
                         */
                        SecurityPolicyRuleRedirectOptions.create = function create(properties) {
                            return new SecurityPolicyRuleRedirectOptions(properties);
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyRuleRedirectOptions message. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleRedirectOptions} message SecurityPolicyRuleRedirectOptions message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyRuleRedirectOptions.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            if (message.target != null && Object.hasOwnProperty.call(message, "target"))
                                writer.uint32(/* id 192835985, wireType 2 =*/1542687882).string(message.target);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecurityPolicyRuleRedirectOptions message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions
                         * @static
                         * @param {google.cloud.compute.v1.ISecurityPolicyRuleRedirectOptions} message SecurityPolicyRuleRedirectOptions message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecurityPolicyRuleRedirectOptions.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecurityPolicyRuleRedirectOptions message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions} SecurityPolicyRuleRedirectOptions
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyRuleRedirectOptions.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 192835985: {
                                        message.target = reader.string();
                                        break;
                                    }
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecurityPolicyRuleRedirectOptions message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions} SecurityPolicyRuleRedirectOptions
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecurityPolicyRuleRedirectOptions.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecurityPolicyRuleRedirectOptions message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecurityPolicyRuleRedirectOptions.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.target != null && message.hasOwnProperty("target")) {
                                properties._target = 1;
                                if (!$util.isString(message.target))
                                    return "target: string expected";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecurityPolicyRuleRedirectOptions message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions} SecurityPolicyRuleRedirectOptions
                         */
                        SecurityPolicyRuleRedirectOptions.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions();
                            if (object.target != null)
                                message.target = String(object.target);
                            if (object.type != null)
                                message.type = String(object.type);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecurityPolicyRuleRedirectOptions message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions
                         * @static
                         * @param {google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions} message SecurityPolicyRuleRedirectOptions
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecurityPolicyRuleRedirectOptions.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            if (message.target != null && message.hasOwnProperty("target")) {
                                object.target = message.target;
                                if (options.oneofs)
                                    object._target = "target";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecurityPolicyRuleRedirectOptions to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecurityPolicyRuleRedirectOptions.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecurityPolicyRuleRedirectOptions
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecurityPolicyRuleRedirectOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions";
                        };
    
                        /**
                         * Type enum.
                         * @name google.cloud.compute.v1.SecurityPolicyRuleRedirectOptions.Type
                         * @enum {number}
                         * @property {number} UNDEFINED_TYPE=0 UNDEFINED_TYPE value
                         * @property {number} EXTERNAL_302=395733761 EXTERNAL_302 value
                         * @property {number} GOOGLE_RECAPTCHA=518803009 GOOGLE_RECAPTCHA value
                         */
                        SecurityPolicyRuleRedirectOptions.Type = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TYPE"] = 0;
                            values[valuesById[395733761] = "EXTERNAL_302"] = 395733761;
                            values[valuesById[518803009] = "GOOGLE_RECAPTCHA"] = 518803009;
                            return values;
                        })();
    
                        return SecurityPolicyRuleRedirectOptions;
                    })();
    
                    v1.SecuritySettings = (function() {
    
                        /**
                         * Properties of a SecuritySettings.
                         * @memberof google.cloud.compute.v1
                         * @interface ISecuritySettings
                         * @property {string|null} [clientTlsPolicy] SecuritySettings clientTlsPolicy
                         * @property {Array.<string>|null} [subjectAltNames] SecuritySettings subjectAltNames
                         */
    
                        /**
                         * Constructs a new SecuritySettings.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecuritySettings.
                         * @implements ISecuritySettings
                         * @constructor
                         * @param {google.cloud.compute.v1.ISecuritySettings=} [properties] Properties to set
                         */
                        function SecuritySettings(properties) {
                            this.subjectAltNames = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SecuritySettings clientTlsPolicy.
                         * @member {string|null|undefined} clientTlsPolicy
                         * @memberof google.cloud.compute.v1.SecuritySettings
                         * @instance
                         */
                        SecuritySettings.prototype.clientTlsPolicy = null;
    
                        /**
                         * SecuritySettings subjectAltNames.
                         * @member {Array.<string>} subjectAltNames
                         * @memberof google.cloud.compute.v1.SecuritySettings
                         * @instance
                         */
                        SecuritySettings.prototype.subjectAltNames = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SecuritySettings _clientTlsPolicy.
                         * @member {"clientTlsPolicy"|undefined} _clientTlsPolicy
                         * @memberof google.cloud.compute.v1.SecuritySettings
                         * @instance
                         */
                        Object.defineProperty(SecuritySettings.prototype, "_clientTlsPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["clientTlsPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SecuritySettings instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecuritySettings
                         * @static
                         * @param {google.cloud.compute.v1.ISecuritySettings=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SecuritySettings} SecuritySettings instance
                         */
                        SecuritySettings.create = function create(properties) {
                            return new SecuritySettings(properties);
                        };
    
                        /**
                         * Encodes the specified SecuritySettings message. Does not implicitly {@link google.cloud.compute.v1.SecuritySettings.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SecuritySettings
                         * @static
                         * @param {google.cloud.compute.v1.ISecuritySettings} message SecuritySettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecuritySettings.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.subjectAltNames != null && message.subjectAltNames.length)
                                for (var i = 0; i < message.subjectAltNames.length; ++i)
                                    writer.uint32(/* id 330029535, wireType 2 =*/2640236282).string(message.subjectAltNames[i]);
                            if (message.clientTlsPolicy != null && Object.hasOwnProperty.call(message, "clientTlsPolicy"))
                                writer.uint32(/* id 462325226, wireType 2 =*/3698601810).string(message.clientTlsPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SecuritySettings message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SecuritySettings.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SecuritySettings
                         * @static
                         * @param {google.cloud.compute.v1.ISecuritySettings} message SecuritySettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SecuritySettings.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SecuritySettings message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SecuritySettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SecuritySettings} SecuritySettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecuritySettings.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SecuritySettings();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 462325226: {
                                        message.clientTlsPolicy = reader.string();
                                        break;
                                    }
                                case 330029535: {
                                        if (!(message.subjectAltNames && message.subjectAltNames.length))
                                            message.subjectAltNames = [];
                                        message.subjectAltNames.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SecuritySettings message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SecuritySettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SecuritySettings} SecuritySettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SecuritySettings.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SecuritySettings message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SecuritySettings
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SecuritySettings.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.clientTlsPolicy != null && message.hasOwnProperty("clientTlsPolicy")) {
                                properties._clientTlsPolicy = 1;
                                if (!$util.isString(message.clientTlsPolicy))
                                    return "clientTlsPolicy: string expected";
                            }
                            if (message.subjectAltNames != null && message.hasOwnProperty("subjectAltNames")) {
                                if (!Array.isArray(message.subjectAltNames))
                                    return "subjectAltNames: array expected";
                                for (var i = 0; i < message.subjectAltNames.length; ++i)
                                    if (!$util.isString(message.subjectAltNames[i]))
                                        return "subjectAltNames: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SecuritySettings message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SecuritySettings
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SecuritySettings} SecuritySettings
                         */
                        SecuritySettings.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SecuritySettings)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SecuritySettings();
                            if (object.clientTlsPolicy != null)
                                message.clientTlsPolicy = String(object.clientTlsPolicy);
                            if (object.subjectAltNames) {
                                if (!Array.isArray(object.subjectAltNames))
                                    throw TypeError(".google.cloud.compute.v1.SecuritySettings.subjectAltNames: array expected");
                                message.subjectAltNames = [];
                                for (var i = 0; i < object.subjectAltNames.length; ++i)
                                    message.subjectAltNames[i] = String(object.subjectAltNames[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SecuritySettings message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SecuritySettings
                         * @static
                         * @param {google.cloud.compute.v1.SecuritySettings} message SecuritySettings
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SecuritySettings.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.subjectAltNames = [];
                            if (message.subjectAltNames && message.subjectAltNames.length) {
                                object.subjectAltNames = [];
                                for (var j = 0; j < message.subjectAltNames.length; ++j)
                                    object.subjectAltNames[j] = message.subjectAltNames[j];
                            }
                            if (message.clientTlsPolicy != null && message.hasOwnProperty("clientTlsPolicy")) {
                                object.clientTlsPolicy = message.clientTlsPolicy;
                                if (options.oneofs)
                                    object._clientTlsPolicy = "clientTlsPolicy";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SecuritySettings to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SecuritySettings
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SecuritySettings.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SecuritySettings
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SecuritySettings
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SecuritySettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SecuritySettings";
                        };
    
                        return SecuritySettings;
                    })();
    
                    v1.SendDiagnosticInterruptInstanceRequest = (function() {
    
                        /**
                         * Properties of a SendDiagnosticInterruptInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISendDiagnosticInterruptInstanceRequest
                         * @property {string|null} [instance] SendDiagnosticInterruptInstanceRequest instance
                         * @property {string|null} [project] SendDiagnosticInterruptInstanceRequest project
                         * @property {string|null} [zone] SendDiagnosticInterruptInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new SendDiagnosticInterruptInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SendDiagnosticInterruptInstanceRequest.
                         * @implements ISendDiagnosticInterruptInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISendDiagnosticInterruptInstanceRequest=} [properties] Properties to set
                         */
                        function SendDiagnosticInterruptInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SendDiagnosticInterruptInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest
                         * @instance
                         */
                        SendDiagnosticInterruptInstanceRequest.prototype.instance = "";
    
                        /**
                         * SendDiagnosticInterruptInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest
                         * @instance
                         */
                        SendDiagnosticInterruptInstanceRequest.prototype.project = "";
    
                        /**
                         * SendDiagnosticInterruptInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest
                         * @instance
                         */
                        SendDiagnosticInterruptInstanceRequest.prototype.zone = "";
    
                        /**
                         * Creates a new SendDiagnosticInterruptInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISendDiagnosticInterruptInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest} SendDiagnosticInterruptInstanceRequest instance
                         */
                        SendDiagnosticInterruptInstanceRequest.create = function create(properties) {
                            return new SendDiagnosticInterruptInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SendDiagnosticInterruptInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISendDiagnosticInterruptInstanceRequest} message SendDiagnosticInterruptInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SendDiagnosticInterruptInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SendDiagnosticInterruptInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISendDiagnosticInterruptInstanceRequest} message SendDiagnosticInterruptInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SendDiagnosticInterruptInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SendDiagnosticInterruptInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest} SendDiagnosticInterruptInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SendDiagnosticInterruptInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SendDiagnosticInterruptInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest} SendDiagnosticInterruptInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SendDiagnosticInterruptInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SendDiagnosticInterruptInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SendDiagnosticInterruptInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SendDiagnosticInterruptInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest} SendDiagnosticInterruptInstanceRequest
                         */
                        SendDiagnosticInterruptInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SendDiagnosticInterruptInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest} message SendDiagnosticInterruptInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SendDiagnosticInterruptInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this SendDiagnosticInterruptInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SendDiagnosticInterruptInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SendDiagnosticInterruptInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SendDiagnosticInterruptInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest";
                        };
    
                        return SendDiagnosticInterruptInstanceRequest;
                    })();
    
                    v1.SendDiagnosticInterruptInstanceResponse = (function() {
    
                        /**
                         * Properties of a SendDiagnosticInterruptInstanceResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface ISendDiagnosticInterruptInstanceResponse
                         */
    
                        /**
                         * Constructs a new SendDiagnosticInterruptInstanceResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SendDiagnosticInterruptInstanceResponse.
                         * @implements ISendDiagnosticInterruptInstanceResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.ISendDiagnosticInterruptInstanceResponse=} [properties] Properties to set
                         */
                        function SendDiagnosticInterruptInstanceResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Creates a new SendDiagnosticInterruptInstanceResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse
                         * @static
                         * @param {google.cloud.compute.v1.ISendDiagnosticInterruptInstanceResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse} SendDiagnosticInterruptInstanceResponse instance
                         */
                        SendDiagnosticInterruptInstanceResponse.create = function create(properties) {
                            return new SendDiagnosticInterruptInstanceResponse(properties);
                        };
    
                        /**
                         * Encodes the specified SendDiagnosticInterruptInstanceResponse message. Does not implicitly {@link google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse
                         * @static
                         * @param {google.cloud.compute.v1.ISendDiagnosticInterruptInstanceResponse} message SendDiagnosticInterruptInstanceResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SendDiagnosticInterruptInstanceResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SendDiagnosticInterruptInstanceResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse
                         * @static
                         * @param {google.cloud.compute.v1.ISendDiagnosticInterruptInstanceResponse} message SendDiagnosticInterruptInstanceResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SendDiagnosticInterruptInstanceResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SendDiagnosticInterruptInstanceResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse} SendDiagnosticInterruptInstanceResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SendDiagnosticInterruptInstanceResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SendDiagnosticInterruptInstanceResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse} SendDiagnosticInterruptInstanceResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SendDiagnosticInterruptInstanceResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SendDiagnosticInterruptInstanceResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SendDiagnosticInterruptInstanceResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            return null;
                        };
    
                        /**
                         * Creates a SendDiagnosticInterruptInstanceResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse} SendDiagnosticInterruptInstanceResponse
                         */
                        SendDiagnosticInterruptInstanceResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse)
                                return object;
                            return new $root.google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse();
                        };
    
                        /**
                         * Creates a plain object from a SendDiagnosticInterruptInstanceResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse
                         * @static
                         * @param {google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse} message SendDiagnosticInterruptInstanceResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SendDiagnosticInterruptInstanceResponse.toObject = function toObject() {
                            return {};
                        };
    
                        /**
                         * Converts this SendDiagnosticInterruptInstanceResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SendDiagnosticInterruptInstanceResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SendDiagnosticInterruptInstanceResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SendDiagnosticInterruptInstanceResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse";
                        };
    
                        return SendDiagnosticInterruptInstanceResponse;
                    })();
    
                    v1.SerialPortOutput = (function() {
    
                        /**
                         * Properties of a SerialPortOutput.
                         * @memberof google.cloud.compute.v1
                         * @interface ISerialPortOutput
                         * @property {string|null} [contents] SerialPortOutput contents
                         * @property {string|null} [kind] SerialPortOutput kind
                         * @property {number|Long|null} [next] SerialPortOutput next
                         * @property {string|null} [selfLink] SerialPortOutput selfLink
                         * @property {number|Long|null} [start] SerialPortOutput start
                         */
    
                        /**
                         * Constructs a new SerialPortOutput.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SerialPortOutput.
                         * @implements ISerialPortOutput
                         * @constructor
                         * @param {google.cloud.compute.v1.ISerialPortOutput=} [properties] Properties to set
                         */
                        function SerialPortOutput(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SerialPortOutput contents.
                         * @member {string|null|undefined} contents
                         * @memberof google.cloud.compute.v1.SerialPortOutput
                         * @instance
                         */
                        SerialPortOutput.prototype.contents = null;
    
                        /**
                         * SerialPortOutput kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.SerialPortOutput
                         * @instance
                         */
                        SerialPortOutput.prototype.kind = null;
    
                        /**
                         * SerialPortOutput next.
                         * @member {number|Long|null|undefined} next
                         * @memberof google.cloud.compute.v1.SerialPortOutput
                         * @instance
                         */
                        SerialPortOutput.prototype.next = null;
    
                        /**
                         * SerialPortOutput selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.SerialPortOutput
                         * @instance
                         */
                        SerialPortOutput.prototype.selfLink = null;
    
                        /**
                         * SerialPortOutput start.
                         * @member {number|Long|null|undefined} start
                         * @memberof google.cloud.compute.v1.SerialPortOutput
                         * @instance
                         */
                        SerialPortOutput.prototype.start = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SerialPortOutput _contents.
                         * @member {"contents"|undefined} _contents
                         * @memberof google.cloud.compute.v1.SerialPortOutput
                         * @instance
                         */
                        Object.defineProperty(SerialPortOutput.prototype, "_contents", {
                            get: $util.oneOfGetter($oneOfFields = ["contents"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SerialPortOutput _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.SerialPortOutput
                         * @instance
                         */
                        Object.defineProperty(SerialPortOutput.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SerialPortOutput _next.
                         * @member {"next"|undefined} _next
                         * @memberof google.cloud.compute.v1.SerialPortOutput
                         * @instance
                         */
                        Object.defineProperty(SerialPortOutput.prototype, "_next", {
                            get: $util.oneOfGetter($oneOfFields = ["next"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SerialPortOutput _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.SerialPortOutput
                         * @instance
                         */
                        Object.defineProperty(SerialPortOutput.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SerialPortOutput _start.
                         * @member {"start"|undefined} _start
                         * @memberof google.cloud.compute.v1.SerialPortOutput
                         * @instance
                         */
                        Object.defineProperty(SerialPortOutput.prototype, "_start", {
                            get: $util.oneOfGetter($oneOfFields = ["start"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SerialPortOutput instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SerialPortOutput
                         * @static
                         * @param {google.cloud.compute.v1.ISerialPortOutput=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SerialPortOutput} SerialPortOutput instance
                         */
                        SerialPortOutput.create = function create(properties) {
                            return new SerialPortOutput(properties);
                        };
    
                        /**
                         * Encodes the specified SerialPortOutput message. Does not implicitly {@link google.cloud.compute.v1.SerialPortOutput.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SerialPortOutput
                         * @static
                         * @param {google.cloud.compute.v1.ISerialPortOutput} message SerialPortOutput message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SerialPortOutput.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.next != null && Object.hasOwnProperty.call(message, "next"))
                                writer.uint32(/* id 3377907, wireType 0 =*/27023256).int64(message.next);
                            if (message.start != null && Object.hasOwnProperty.call(message, "start"))
                                writer.uint32(/* id 109757538, wireType 0 =*/878060304).int64(message.start);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.contents != null && Object.hasOwnProperty.call(message, "contents"))
                                writer.uint32(/* id 506419994, wireType 2 =*/4051359954).string(message.contents);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SerialPortOutput message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SerialPortOutput.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SerialPortOutput
                         * @static
                         * @param {google.cloud.compute.v1.ISerialPortOutput} message SerialPortOutput message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SerialPortOutput.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SerialPortOutput message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SerialPortOutput
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SerialPortOutput} SerialPortOutput
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SerialPortOutput.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SerialPortOutput();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 506419994: {
                                        message.contents = reader.string();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3377907: {
                                        message.next = reader.int64();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 109757538: {
                                        message.start = reader.int64();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SerialPortOutput message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SerialPortOutput
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SerialPortOutput} SerialPortOutput
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SerialPortOutput.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SerialPortOutput message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SerialPortOutput
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SerialPortOutput.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.contents != null && message.hasOwnProperty("contents")) {
                                properties._contents = 1;
                                if (!$util.isString(message.contents))
                                    return "contents: string expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.next != null && message.hasOwnProperty("next")) {
                                properties._next = 1;
                                if (!$util.isInteger(message.next) && !(message.next && $util.isInteger(message.next.low) && $util.isInteger(message.next.high)))
                                    return "next: integer|Long expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.start != null && message.hasOwnProperty("start")) {
                                properties._start = 1;
                                if (!$util.isInteger(message.start) && !(message.start && $util.isInteger(message.start.low) && $util.isInteger(message.start.high)))
                                    return "start: integer|Long expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SerialPortOutput message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SerialPortOutput
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SerialPortOutput} SerialPortOutput
                         */
                        SerialPortOutput.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SerialPortOutput)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SerialPortOutput();
                            if (object.contents != null)
                                message.contents = String(object.contents);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.next != null)
                                if ($util.Long)
                                    (message.next = $util.Long.fromValue(object.next)).unsigned = false;
                                else if (typeof object.next === "string")
                                    message.next = parseInt(object.next, 10);
                                else if (typeof object.next === "number")
                                    message.next = object.next;
                                else if (typeof object.next === "object")
                                    message.next = new $util.LongBits(object.next.low >>> 0, object.next.high >>> 0).toNumber();
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.start != null)
                                if ($util.Long)
                                    (message.start = $util.Long.fromValue(object.start)).unsigned = false;
                                else if (typeof object.start === "string")
                                    message.start = parseInt(object.start, 10);
                                else if (typeof object.start === "number")
                                    message.start = object.start;
                                else if (typeof object.start === "object")
                                    message.start = new $util.LongBits(object.start.low >>> 0, object.start.high >>> 0).toNumber();
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SerialPortOutput message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SerialPortOutput
                         * @static
                         * @param {google.cloud.compute.v1.SerialPortOutput} message SerialPortOutput
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SerialPortOutput.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.next != null && message.hasOwnProperty("next")) {
                                if (typeof message.next === "number")
                                    object.next = options.longs === String ? String(message.next) : message.next;
                                else
                                    object.next = options.longs === String ? $util.Long.prototype.toString.call(message.next) : options.longs === Number ? new $util.LongBits(message.next.low >>> 0, message.next.high >>> 0).toNumber() : message.next;
                                if (options.oneofs)
                                    object._next = "next";
                            }
                            if (message.start != null && message.hasOwnProperty("start")) {
                                if (typeof message.start === "number")
                                    object.start = options.longs === String ? String(message.start) : message.start;
                                else
                                    object.start = options.longs === String ? $util.Long.prototype.toString.call(message.start) : options.longs === Number ? new $util.LongBits(message.start.low >>> 0, message.start.high >>> 0).toNumber() : message.start;
                                if (options.oneofs)
                                    object._start = "start";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.contents != null && message.hasOwnProperty("contents")) {
                                object.contents = message.contents;
                                if (options.oneofs)
                                    object._contents = "contents";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SerialPortOutput to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SerialPortOutput
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SerialPortOutput.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SerialPortOutput
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SerialPortOutput
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SerialPortOutput.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SerialPortOutput";
                        };
    
                        return SerialPortOutput;
                    })();
    
                    v1.ServerBinding = (function() {
    
                        /**
                         * Properties of a ServerBinding.
                         * @memberof google.cloud.compute.v1
                         * @interface IServerBinding
                         * @property {string|null} [type] ServerBinding type
                         */
    
                        /**
                         * Constructs a new ServerBinding.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ServerBinding.
                         * @implements IServerBinding
                         * @constructor
                         * @param {google.cloud.compute.v1.IServerBinding=} [properties] Properties to set
                         */
                        function ServerBinding(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ServerBinding type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.ServerBinding
                         * @instance
                         */
                        ServerBinding.prototype.type = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ServerBinding _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.ServerBinding
                         * @instance
                         */
                        Object.defineProperty(ServerBinding.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ServerBinding instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ServerBinding
                         * @static
                         * @param {google.cloud.compute.v1.IServerBinding=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ServerBinding} ServerBinding instance
                         */
                        ServerBinding.create = function create(properties) {
                            return new ServerBinding(properties);
                        };
    
                        /**
                         * Encodes the specified ServerBinding message. Does not implicitly {@link google.cloud.compute.v1.ServerBinding.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ServerBinding
                         * @static
                         * @param {google.cloud.compute.v1.IServerBinding} message ServerBinding message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ServerBinding.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ServerBinding message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ServerBinding.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ServerBinding
                         * @static
                         * @param {google.cloud.compute.v1.IServerBinding} message ServerBinding message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ServerBinding.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ServerBinding message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ServerBinding
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ServerBinding} ServerBinding
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ServerBinding.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ServerBinding();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ServerBinding message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ServerBinding
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ServerBinding} ServerBinding
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ServerBinding.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ServerBinding message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ServerBinding
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ServerBinding.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ServerBinding message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ServerBinding
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ServerBinding} ServerBinding
                         */
                        ServerBinding.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ServerBinding)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ServerBinding();
                            if (object.type != null)
                                message.type = String(object.type);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ServerBinding message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ServerBinding
                         * @static
                         * @param {google.cloud.compute.v1.ServerBinding} message ServerBinding
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ServerBinding.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ServerBinding to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ServerBinding
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ServerBinding.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ServerBinding
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ServerBinding
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ServerBinding.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ServerBinding";
                        };
    
                        /**
                         * Type enum.
                         * @name google.cloud.compute.v1.ServerBinding.Type
                         * @enum {number}
                         * @property {number} UNDEFINED_TYPE=0 UNDEFINED_TYPE value
                         * @property {number} RESTART_NODE_ON_ANY_SERVER=502950985 RESTART_NODE_ON_ANY_SERVER value
                         * @property {number} RESTART_NODE_ON_MINIMAL_SERVERS=204166495 RESTART_NODE_ON_MINIMAL_SERVERS value
                         * @property {number} SERVER_BINDING_TYPE_UNSPECIFIED=180825512 SERVER_BINDING_TYPE_UNSPECIFIED value
                         */
                        ServerBinding.Type = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TYPE"] = 0;
                            values[valuesById[502950985] = "RESTART_NODE_ON_ANY_SERVER"] = 502950985;
                            values[valuesById[204166495] = "RESTART_NODE_ON_MINIMAL_SERVERS"] = 204166495;
                            values[valuesById[180825512] = "SERVER_BINDING_TYPE_UNSPECIFIED"] = 180825512;
                            return values;
                        })();
    
                        return ServerBinding;
                    })();
    
                    v1.ServiceAccount = (function() {
    
                        /**
                         * Properties of a ServiceAccount.
                         * @memberof google.cloud.compute.v1
                         * @interface IServiceAccount
                         * @property {string|null} [email] ServiceAccount email
                         * @property {Array.<string>|null} [scopes] ServiceAccount scopes
                         */
    
                        /**
                         * Constructs a new ServiceAccount.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ServiceAccount.
                         * @implements IServiceAccount
                         * @constructor
                         * @param {google.cloud.compute.v1.IServiceAccount=} [properties] Properties to set
                         */
                        function ServiceAccount(properties) {
                            this.scopes = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ServiceAccount email.
                         * @member {string|null|undefined} email
                         * @memberof google.cloud.compute.v1.ServiceAccount
                         * @instance
                         */
                        ServiceAccount.prototype.email = null;
    
                        /**
                         * ServiceAccount scopes.
                         * @member {Array.<string>} scopes
                         * @memberof google.cloud.compute.v1.ServiceAccount
                         * @instance
                         */
                        ServiceAccount.prototype.scopes = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ServiceAccount _email.
                         * @member {"email"|undefined} _email
                         * @memberof google.cloud.compute.v1.ServiceAccount
                         * @instance
                         */
                        Object.defineProperty(ServiceAccount.prototype, "_email", {
                            get: $util.oneOfGetter($oneOfFields = ["email"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ServiceAccount instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ServiceAccount
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAccount=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ServiceAccount} ServiceAccount instance
                         */
                        ServiceAccount.create = function create(properties) {
                            return new ServiceAccount(properties);
                        };
    
                        /**
                         * Encodes the specified ServiceAccount message. Does not implicitly {@link google.cloud.compute.v1.ServiceAccount.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ServiceAccount
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAccount} message ServiceAccount message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ServiceAccount.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.email != null && Object.hasOwnProperty.call(message, "email"))
                                writer.uint32(/* id 96619420, wireType 2 =*/772955362).string(message.email);
                            if (message.scopes != null && message.scopes.length)
                                for (var i = 0; i < message.scopes.length; ++i)
                                    writer.uint32(/* id 165973151, wireType 2 =*/1327785210).string(message.scopes[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ServiceAccount message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ServiceAccount.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ServiceAccount
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAccount} message ServiceAccount message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ServiceAccount.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ServiceAccount message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ServiceAccount
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ServiceAccount} ServiceAccount
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ServiceAccount.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ServiceAccount();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 96619420: {
                                        message.email = reader.string();
                                        break;
                                    }
                                case 165973151: {
                                        if (!(message.scopes && message.scopes.length))
                                            message.scopes = [];
                                        message.scopes.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ServiceAccount message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ServiceAccount
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ServiceAccount} ServiceAccount
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ServiceAccount.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ServiceAccount message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ServiceAccount
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ServiceAccount.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.email != null && message.hasOwnProperty("email")) {
                                properties._email = 1;
                                if (!$util.isString(message.email))
                                    return "email: string expected";
                            }
                            if (message.scopes != null && message.hasOwnProperty("scopes")) {
                                if (!Array.isArray(message.scopes))
                                    return "scopes: array expected";
                                for (var i = 0; i < message.scopes.length; ++i)
                                    if (!$util.isString(message.scopes[i]))
                                        return "scopes: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ServiceAccount message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ServiceAccount
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ServiceAccount} ServiceAccount
                         */
                        ServiceAccount.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ServiceAccount)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ServiceAccount();
                            if (object.email != null)
                                message.email = String(object.email);
                            if (object.scopes) {
                                if (!Array.isArray(object.scopes))
                                    throw TypeError(".google.cloud.compute.v1.ServiceAccount.scopes: array expected");
                                message.scopes = [];
                                for (var i = 0; i < object.scopes.length; ++i)
                                    message.scopes[i] = String(object.scopes[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ServiceAccount message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ServiceAccount
                         * @static
                         * @param {google.cloud.compute.v1.ServiceAccount} message ServiceAccount
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ServiceAccount.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.scopes = [];
                            if (message.email != null && message.hasOwnProperty("email")) {
                                object.email = message.email;
                                if (options.oneofs)
                                    object._email = "email";
                            }
                            if (message.scopes && message.scopes.length) {
                                object.scopes = [];
                                for (var j = 0; j < message.scopes.length; ++j)
                                    object.scopes[j] = message.scopes[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ServiceAccount to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ServiceAccount
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ServiceAccount.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ServiceAccount
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ServiceAccount
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ServiceAccount.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ServiceAccount";
                        };
    
                        return ServiceAccount;
                    })();
    
                    v1.ServiceAttachment = (function() {
    
                        /**
                         * Properties of a ServiceAttachment.
                         * @memberof google.cloud.compute.v1
                         * @interface IServiceAttachment
                         * @property {Array.<google.cloud.compute.v1.IServiceAttachmentConnectedEndpoint>|null} [connectedEndpoints] ServiceAttachment connectedEndpoints
                         * @property {string|null} [connectionPreference] ServiceAttachment connectionPreference
                         * @property {Array.<google.cloud.compute.v1.IServiceAttachmentConsumerProjectLimit>|null} [consumerAcceptLists] ServiceAttachment consumerAcceptLists
                         * @property {Array.<string>|null} [consumerRejectLists] ServiceAttachment consumerRejectLists
                         * @property {string|null} [creationTimestamp] ServiceAttachment creationTimestamp
                         * @property {string|null} [description] ServiceAttachment description
                         * @property {Array.<string>|null} [domainNames] ServiceAttachment domainNames
                         * @property {boolean|null} [enableProxyProtocol] ServiceAttachment enableProxyProtocol
                         * @property {string|null} [fingerprint] ServiceAttachment fingerprint
                         * @property {number|Long|null} [id] ServiceAttachment id
                         * @property {string|null} [kind] ServiceAttachment kind
                         * @property {string|null} [name] ServiceAttachment name
                         * @property {Array.<string>|null} [natSubnets] ServiceAttachment natSubnets
                         * @property {string|null} [producerForwardingRule] ServiceAttachment producerForwardingRule
                         * @property {google.cloud.compute.v1.IUint128|null} [pscServiceAttachmentId] ServiceAttachment pscServiceAttachmentId
                         * @property {string|null} [region] ServiceAttachment region
                         * @property {string|null} [selfLink] ServiceAttachment selfLink
                         * @property {string|null} [targetService] ServiceAttachment targetService
                         */
    
                        /**
                         * Constructs a new ServiceAttachment.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ServiceAttachment.
                         * @implements IServiceAttachment
                         * @constructor
                         * @param {google.cloud.compute.v1.IServiceAttachment=} [properties] Properties to set
                         */
                        function ServiceAttachment(properties) {
                            this.connectedEndpoints = [];
                            this.consumerAcceptLists = [];
                            this.consumerRejectLists = [];
                            this.domainNames = [];
                            this.natSubnets = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ServiceAttachment connectedEndpoints.
                         * @member {Array.<google.cloud.compute.v1.IServiceAttachmentConnectedEndpoint>} connectedEndpoints
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        ServiceAttachment.prototype.connectedEndpoints = $util.emptyArray;
    
                        /**
                         * ServiceAttachment connectionPreference.
                         * @member {string|null|undefined} connectionPreference
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        ServiceAttachment.prototype.connectionPreference = null;
    
                        /**
                         * ServiceAttachment consumerAcceptLists.
                         * @member {Array.<google.cloud.compute.v1.IServiceAttachmentConsumerProjectLimit>} consumerAcceptLists
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        ServiceAttachment.prototype.consumerAcceptLists = $util.emptyArray;
    
                        /**
                         * ServiceAttachment consumerRejectLists.
                         * @member {Array.<string>} consumerRejectLists
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        ServiceAttachment.prototype.consumerRejectLists = $util.emptyArray;
    
                        /**
                         * ServiceAttachment creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        ServiceAttachment.prototype.creationTimestamp = null;
    
                        /**
                         * ServiceAttachment description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        ServiceAttachment.prototype.description = null;
    
                        /**
                         * ServiceAttachment domainNames.
                         * @member {Array.<string>} domainNames
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        ServiceAttachment.prototype.domainNames = $util.emptyArray;
    
                        /**
                         * ServiceAttachment enableProxyProtocol.
                         * @member {boolean|null|undefined} enableProxyProtocol
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        ServiceAttachment.prototype.enableProxyProtocol = null;
    
                        /**
                         * ServiceAttachment fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        ServiceAttachment.prototype.fingerprint = null;
    
                        /**
                         * ServiceAttachment id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        ServiceAttachment.prototype.id = null;
    
                        /**
                         * ServiceAttachment kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        ServiceAttachment.prototype.kind = null;
    
                        /**
                         * ServiceAttachment name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        ServiceAttachment.prototype.name = null;
    
                        /**
                         * ServiceAttachment natSubnets.
                         * @member {Array.<string>} natSubnets
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        ServiceAttachment.prototype.natSubnets = $util.emptyArray;
    
                        /**
                         * ServiceAttachment producerForwardingRule.
                         * @member {string|null|undefined} producerForwardingRule
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        ServiceAttachment.prototype.producerForwardingRule = null;
    
                        /**
                         * ServiceAttachment pscServiceAttachmentId.
                         * @member {google.cloud.compute.v1.IUint128|null|undefined} pscServiceAttachmentId
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        ServiceAttachment.prototype.pscServiceAttachmentId = null;
    
                        /**
                         * ServiceAttachment region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        ServiceAttachment.prototype.region = null;
    
                        /**
                         * ServiceAttachment selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        ServiceAttachment.prototype.selfLink = null;
    
                        /**
                         * ServiceAttachment targetService.
                         * @member {string|null|undefined} targetService
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        ServiceAttachment.prototype.targetService = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ServiceAttachment _connectionPreference.
                         * @member {"connectionPreference"|undefined} _connectionPreference
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachment.prototype, "_connectionPreference", {
                            get: $util.oneOfGetter($oneOfFields = ["connectionPreference"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachment _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachment.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachment _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachment.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachment _enableProxyProtocol.
                         * @member {"enableProxyProtocol"|undefined} _enableProxyProtocol
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachment.prototype, "_enableProxyProtocol", {
                            get: $util.oneOfGetter($oneOfFields = ["enableProxyProtocol"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachment _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachment.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachment _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachment.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachment _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachment.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachment _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachment.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachment _producerForwardingRule.
                         * @member {"producerForwardingRule"|undefined} _producerForwardingRule
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachment.prototype, "_producerForwardingRule", {
                            get: $util.oneOfGetter($oneOfFields = ["producerForwardingRule"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachment _pscServiceAttachmentId.
                         * @member {"pscServiceAttachmentId"|undefined} _pscServiceAttachmentId
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachment.prototype, "_pscServiceAttachmentId", {
                            get: $util.oneOfGetter($oneOfFields = ["pscServiceAttachmentId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachment _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachment.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachment _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachment.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachment _targetService.
                         * @member {"targetService"|undefined} _targetService
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachment.prototype, "_targetService", {
                            get: $util.oneOfGetter($oneOfFields = ["targetService"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ServiceAttachment instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAttachment=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ServiceAttachment} ServiceAttachment instance
                         */
                        ServiceAttachment.create = function create(properties) {
                            return new ServiceAttachment(properties);
                        };
    
                        /**
                         * Encodes the specified ServiceAttachment message. Does not implicitly {@link google.cloud.compute.v1.ServiceAttachment.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAttachment} message ServiceAttachment message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ServiceAttachment.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.targetService != null && Object.hasOwnProperty.call(message, "targetService"))
                                writer.uint32(/* id 1293831, wireType 2 =*/10350650).string(message.targetService);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.domainNames != null && message.domainNames.length)
                                for (var i = 0; i < message.domainNames.length; ++i)
                                    writer.uint32(/* id 6450189, wireType 2 =*/51601514).string(message.domainNames[i]);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.connectedEndpoints != null && message.connectedEndpoints.length)
                                for (var i = 0; i < message.connectedEndpoints.length; ++i)
                                    $root.google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint.encode(message.connectedEndpoints[i], writer.uint32(/* id 72223688, wireType 2 =*/577789506).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.consumerRejectLists != null && message.consumerRejectLists.length)
                                for (var i = 0; i < message.consumerRejectLists.length; ++i)
                                    writer.uint32(/* id 204033182, wireType 2 =*/1632265458).string(message.consumerRejectLists[i]);
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.producerForwardingRule != null && Object.hasOwnProperty.call(message, "producerForwardingRule"))
                                writer.uint32(/* id 247927889, wireType 2 =*/1983423114).string(message.producerForwardingRule);
                            if (message.connectionPreference != null && Object.hasOwnProperty.call(message, "connectionPreference"))
                                writer.uint32(/* id 285818076, wireType 2 =*/2286544610).string(message.connectionPreference);
                            if (message.enableProxyProtocol != null && Object.hasOwnProperty.call(message, "enableProxyProtocol"))
                                writer.uint32(/* id 363791237, wireType 0 =*/2910329896).bool(message.enableProxyProtocol);
                            if (message.natSubnets != null && message.natSubnets.length)
                                for (var i = 0; i < message.natSubnets.length; ++i)
                                    writer.uint32(/* id 374785944, wireType 2 =*/2998287554).string(message.natSubnets[i]);
                            if (message.consumerAcceptLists != null && message.consumerAcceptLists.length)
                                for (var i = 0; i < message.consumerAcceptLists.length; ++i)
                                    $root.google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit.encode(message.consumerAcceptLists[i], writer.uint32(/* id 402725703, wireType 2 =*/3221805626).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.pscServiceAttachmentId != null && Object.hasOwnProperty.call(message, "pscServiceAttachmentId"))
                                $root.google.cloud.compute.v1.Uint128.encode(message.pscServiceAttachmentId, writer.uint32(/* id 527695214, wireType 2 =*/4221561714).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ServiceAttachment message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ServiceAttachment.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAttachment} message ServiceAttachment message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ServiceAttachment.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ServiceAttachment message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ServiceAttachment} ServiceAttachment
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ServiceAttachment.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ServiceAttachment();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 72223688: {
                                        if (!(message.connectedEndpoints && message.connectedEndpoints.length))
                                            message.connectedEndpoints = [];
                                        message.connectedEndpoints.push($root.google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 285818076: {
                                        message.connectionPreference = reader.string();
                                        break;
                                    }
                                case 402725703: {
                                        if (!(message.consumerAcceptLists && message.consumerAcceptLists.length))
                                            message.consumerAcceptLists = [];
                                        message.consumerAcceptLists.push($root.google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 204033182: {
                                        if (!(message.consumerRejectLists && message.consumerRejectLists.length))
                                            message.consumerRejectLists = [];
                                        message.consumerRejectLists.push(reader.string());
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 6450189: {
                                        if (!(message.domainNames && message.domainNames.length))
                                            message.domainNames = [];
                                        message.domainNames.push(reader.string());
                                        break;
                                    }
                                case 363791237: {
                                        message.enableProxyProtocol = reader.bool();
                                        break;
                                    }
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 374785944: {
                                        if (!(message.natSubnets && message.natSubnets.length))
                                            message.natSubnets = [];
                                        message.natSubnets.push(reader.string());
                                        break;
                                    }
                                case 247927889: {
                                        message.producerForwardingRule = reader.string();
                                        break;
                                    }
                                case 527695214: {
                                        message.pscServiceAttachmentId = $root.google.cloud.compute.v1.Uint128.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 1293831: {
                                        message.targetService = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ServiceAttachment message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ServiceAttachment} ServiceAttachment
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ServiceAttachment.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ServiceAttachment message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ServiceAttachment.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.connectedEndpoints != null && message.hasOwnProperty("connectedEndpoints")) {
                                if (!Array.isArray(message.connectedEndpoints))
                                    return "connectedEndpoints: array expected";
                                for (var i = 0; i < message.connectedEndpoints.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint.verify(message.connectedEndpoints[i]);
                                    if (error)
                                        return "connectedEndpoints." + error;
                                }
                            }
                            if (message.connectionPreference != null && message.hasOwnProperty("connectionPreference")) {
                                properties._connectionPreference = 1;
                                if (!$util.isString(message.connectionPreference))
                                    return "connectionPreference: string expected";
                            }
                            if (message.consumerAcceptLists != null && message.hasOwnProperty("consumerAcceptLists")) {
                                if (!Array.isArray(message.consumerAcceptLists))
                                    return "consumerAcceptLists: array expected";
                                for (var i = 0; i < message.consumerAcceptLists.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit.verify(message.consumerAcceptLists[i]);
                                    if (error)
                                        return "consumerAcceptLists." + error;
                                }
                            }
                            if (message.consumerRejectLists != null && message.hasOwnProperty("consumerRejectLists")) {
                                if (!Array.isArray(message.consumerRejectLists))
                                    return "consumerRejectLists: array expected";
                                for (var i = 0; i < message.consumerRejectLists.length; ++i)
                                    if (!$util.isString(message.consumerRejectLists[i]))
                                        return "consumerRejectLists: string[] expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.domainNames != null && message.hasOwnProperty("domainNames")) {
                                if (!Array.isArray(message.domainNames))
                                    return "domainNames: array expected";
                                for (var i = 0; i < message.domainNames.length; ++i)
                                    if (!$util.isString(message.domainNames[i]))
                                        return "domainNames: string[] expected";
                            }
                            if (message.enableProxyProtocol != null && message.hasOwnProperty("enableProxyProtocol")) {
                                properties._enableProxyProtocol = 1;
                                if (typeof message.enableProxyProtocol !== "boolean")
                                    return "enableProxyProtocol: boolean expected";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.natSubnets != null && message.hasOwnProperty("natSubnets")) {
                                if (!Array.isArray(message.natSubnets))
                                    return "natSubnets: array expected";
                                for (var i = 0; i < message.natSubnets.length; ++i)
                                    if (!$util.isString(message.natSubnets[i]))
                                        return "natSubnets: string[] expected";
                            }
                            if (message.producerForwardingRule != null && message.hasOwnProperty("producerForwardingRule")) {
                                properties._producerForwardingRule = 1;
                                if (!$util.isString(message.producerForwardingRule))
                                    return "producerForwardingRule: string expected";
                            }
                            if (message.pscServiceAttachmentId != null && message.hasOwnProperty("pscServiceAttachmentId")) {
                                properties._pscServiceAttachmentId = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Uint128.verify(message.pscServiceAttachmentId);
                                    if (error)
                                        return "pscServiceAttachmentId." + error;
                                }
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.targetService != null && message.hasOwnProperty("targetService")) {
                                properties._targetService = 1;
                                if (!$util.isString(message.targetService))
                                    return "targetService: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ServiceAttachment message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ServiceAttachment} ServiceAttachment
                         */
                        ServiceAttachment.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ServiceAttachment)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ServiceAttachment();
                            if (object.connectedEndpoints) {
                                if (!Array.isArray(object.connectedEndpoints))
                                    throw TypeError(".google.cloud.compute.v1.ServiceAttachment.connectedEndpoints: array expected");
                                message.connectedEndpoints = [];
                                for (var i = 0; i < object.connectedEndpoints.length; ++i) {
                                    if (typeof object.connectedEndpoints[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ServiceAttachment.connectedEndpoints: object expected");
                                    message.connectedEndpoints[i] = $root.google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint.fromObject(object.connectedEndpoints[i]);
                                }
                            }
                            if (object.connectionPreference != null)
                                message.connectionPreference = String(object.connectionPreference);
                            if (object.consumerAcceptLists) {
                                if (!Array.isArray(object.consumerAcceptLists))
                                    throw TypeError(".google.cloud.compute.v1.ServiceAttachment.consumerAcceptLists: array expected");
                                message.consumerAcceptLists = [];
                                for (var i = 0; i < object.consumerAcceptLists.length; ++i) {
                                    if (typeof object.consumerAcceptLists[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ServiceAttachment.consumerAcceptLists: object expected");
                                    message.consumerAcceptLists[i] = $root.google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit.fromObject(object.consumerAcceptLists[i]);
                                }
                            }
                            if (object.consumerRejectLists) {
                                if (!Array.isArray(object.consumerRejectLists))
                                    throw TypeError(".google.cloud.compute.v1.ServiceAttachment.consumerRejectLists: array expected");
                                message.consumerRejectLists = [];
                                for (var i = 0; i < object.consumerRejectLists.length; ++i)
                                    message.consumerRejectLists[i] = String(object.consumerRejectLists[i]);
                            }
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.domainNames) {
                                if (!Array.isArray(object.domainNames))
                                    throw TypeError(".google.cloud.compute.v1.ServiceAttachment.domainNames: array expected");
                                message.domainNames = [];
                                for (var i = 0; i < object.domainNames.length; ++i)
                                    message.domainNames[i] = String(object.domainNames[i]);
                            }
                            if (object.enableProxyProtocol != null)
                                message.enableProxyProtocol = Boolean(object.enableProxyProtocol);
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.natSubnets) {
                                if (!Array.isArray(object.natSubnets))
                                    throw TypeError(".google.cloud.compute.v1.ServiceAttachment.natSubnets: array expected");
                                message.natSubnets = [];
                                for (var i = 0; i < object.natSubnets.length; ++i)
                                    message.natSubnets[i] = String(object.natSubnets[i]);
                            }
                            if (object.producerForwardingRule != null)
                                message.producerForwardingRule = String(object.producerForwardingRule);
                            if (object.pscServiceAttachmentId != null) {
                                if (typeof object.pscServiceAttachmentId !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ServiceAttachment.pscServiceAttachmentId: object expected");
                                message.pscServiceAttachmentId = $root.google.cloud.compute.v1.Uint128.fromObject(object.pscServiceAttachmentId);
                            }
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.targetService != null)
                                message.targetService = String(object.targetService);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ServiceAttachment message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @static
                         * @param {google.cloud.compute.v1.ServiceAttachment} message ServiceAttachment
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ServiceAttachment.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.domainNames = [];
                                object.connectedEndpoints = [];
                                object.consumerRejectLists = [];
                                object.natSubnets = [];
                                object.consumerAcceptLists = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.targetService != null && message.hasOwnProperty("targetService")) {
                                object.targetService = message.targetService;
                                if (options.oneofs)
                                    object._targetService = "targetService";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.domainNames && message.domainNames.length) {
                                object.domainNames = [];
                                for (var j = 0; j < message.domainNames.length; ++j)
                                    object.domainNames[j] = message.domainNames[j];
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.connectedEndpoints && message.connectedEndpoints.length) {
                                object.connectedEndpoints = [];
                                for (var j = 0; j < message.connectedEndpoints.length; ++j)
                                    object.connectedEndpoints[j] = $root.google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint.toObject(message.connectedEndpoints[j], options);
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.consumerRejectLists && message.consumerRejectLists.length) {
                                object.consumerRejectLists = [];
                                for (var j = 0; j < message.consumerRejectLists.length; ++j)
                                    object.consumerRejectLists[j] = message.consumerRejectLists[j];
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.producerForwardingRule != null && message.hasOwnProperty("producerForwardingRule")) {
                                object.producerForwardingRule = message.producerForwardingRule;
                                if (options.oneofs)
                                    object._producerForwardingRule = "producerForwardingRule";
                            }
                            if (message.connectionPreference != null && message.hasOwnProperty("connectionPreference")) {
                                object.connectionPreference = message.connectionPreference;
                                if (options.oneofs)
                                    object._connectionPreference = "connectionPreference";
                            }
                            if (message.enableProxyProtocol != null && message.hasOwnProperty("enableProxyProtocol")) {
                                object.enableProxyProtocol = message.enableProxyProtocol;
                                if (options.oneofs)
                                    object._enableProxyProtocol = "enableProxyProtocol";
                            }
                            if (message.natSubnets && message.natSubnets.length) {
                                object.natSubnets = [];
                                for (var j = 0; j < message.natSubnets.length; ++j)
                                    object.natSubnets[j] = message.natSubnets[j];
                            }
                            if (message.consumerAcceptLists && message.consumerAcceptLists.length) {
                                object.consumerAcceptLists = [];
                                for (var j = 0; j < message.consumerAcceptLists.length; ++j)
                                    object.consumerAcceptLists[j] = $root.google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit.toObject(message.consumerAcceptLists[j], options);
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.pscServiceAttachmentId != null && message.hasOwnProperty("pscServiceAttachmentId")) {
                                object.pscServiceAttachmentId = $root.google.cloud.compute.v1.Uint128.toObject(message.pscServiceAttachmentId, options);
                                if (options.oneofs)
                                    object._pscServiceAttachmentId = "pscServiceAttachmentId";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ServiceAttachment to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ServiceAttachment.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ServiceAttachment
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ServiceAttachment
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ServiceAttachment.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ServiceAttachment";
                        };
    
                        /**
                         * ConnectionPreference enum.
                         * @name google.cloud.compute.v1.ServiceAttachment.ConnectionPreference
                         * @enum {number}
                         * @property {number} UNDEFINED_CONNECTION_PREFERENCE=0 UNDEFINED_CONNECTION_PREFERENCE value
                         * @property {number} ACCEPT_AUTOMATIC=75250580 ACCEPT_AUTOMATIC value
                         * @property {number} ACCEPT_MANUAL=373061341 ACCEPT_MANUAL value
                         * @property {number} CONNECTION_PREFERENCE_UNSPECIFIED=34590772 CONNECTION_PREFERENCE_UNSPECIFIED value
                         */
                        ServiceAttachment.ConnectionPreference = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_CONNECTION_PREFERENCE"] = 0;
                            values[valuesById[75250580] = "ACCEPT_AUTOMATIC"] = 75250580;
                            values[valuesById[373061341] = "ACCEPT_MANUAL"] = 373061341;
                            values[valuesById[34590772] = "CONNECTION_PREFERENCE_UNSPECIFIED"] = 34590772;
                            return values;
                        })();
    
                        return ServiceAttachment;
                    })();
    
                    v1.ServiceAttachmentAggregatedList = (function() {
    
                        /**
                         * Properties of a ServiceAttachmentAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IServiceAttachmentAggregatedList
                         * @property {string|null} [id] ServiceAttachmentAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IServiceAttachmentsScopedList>|null} [items] ServiceAttachmentAggregatedList items
                         * @property {string|null} [kind] ServiceAttachmentAggregatedList kind
                         * @property {string|null} [nextPageToken] ServiceAttachmentAggregatedList nextPageToken
                         * @property {string|null} [selfLink] ServiceAttachmentAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] ServiceAttachmentAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] ServiceAttachmentAggregatedList warning
                         */
    
                        /**
                         * Constructs a new ServiceAttachmentAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ServiceAttachmentAggregatedList.
                         * @implements IServiceAttachmentAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IServiceAttachmentAggregatedList=} [properties] Properties to set
                         */
                        function ServiceAttachmentAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ServiceAttachmentAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @instance
                         */
                        ServiceAttachmentAggregatedList.prototype.id = null;
    
                        /**
                         * ServiceAttachmentAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IServiceAttachmentsScopedList>} items
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @instance
                         */
                        ServiceAttachmentAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * ServiceAttachmentAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @instance
                         */
                        ServiceAttachmentAggregatedList.prototype.kind = null;
    
                        /**
                         * ServiceAttachmentAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @instance
                         */
                        ServiceAttachmentAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * ServiceAttachmentAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @instance
                         */
                        ServiceAttachmentAggregatedList.prototype.selfLink = null;
    
                        /**
                         * ServiceAttachmentAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @instance
                         */
                        ServiceAttachmentAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * ServiceAttachmentAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @instance
                         */
                        ServiceAttachmentAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ServiceAttachmentAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachmentAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachmentAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachmentAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachmentAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachmentAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachmentAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachmentAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachmentAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachmentAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ServiceAttachmentAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAttachmentAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ServiceAttachmentAggregatedList} ServiceAttachmentAggregatedList instance
                         */
                        ServiceAttachmentAggregatedList.create = function create(properties) {
                            return new ServiceAttachmentAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified ServiceAttachmentAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.ServiceAttachmentAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAttachmentAggregatedList} message ServiceAttachmentAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ServiceAttachmentAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.ServiceAttachmentsScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ServiceAttachmentAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ServiceAttachmentAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAttachmentAggregatedList} message ServiceAttachmentAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ServiceAttachmentAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ServiceAttachmentAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ServiceAttachmentAggregatedList} ServiceAttachmentAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ServiceAttachmentAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ServiceAttachmentAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.ServiceAttachmentsScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ServiceAttachmentAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ServiceAttachmentAggregatedList} ServiceAttachmentAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ServiceAttachmentAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ServiceAttachmentAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ServiceAttachmentAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ServiceAttachmentsScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ServiceAttachmentAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ServiceAttachmentAggregatedList} ServiceAttachmentAggregatedList
                         */
                        ServiceAttachmentAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ServiceAttachmentAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ServiceAttachmentAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ServiceAttachmentAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ServiceAttachmentAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.ServiceAttachmentsScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.ServiceAttachmentAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ServiceAttachmentAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ServiceAttachmentAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ServiceAttachmentAggregatedList} message ServiceAttachmentAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ServiceAttachmentAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.ServiceAttachmentsScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ServiceAttachmentAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ServiceAttachmentAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ServiceAttachmentAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ServiceAttachmentAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ServiceAttachmentAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ServiceAttachmentAggregatedList";
                        };
    
                        return ServiceAttachmentAggregatedList;
                    })();
    
                    v1.ServiceAttachmentConnectedEndpoint = (function() {
    
                        /**
                         * Properties of a ServiceAttachmentConnectedEndpoint.
                         * @memberof google.cloud.compute.v1
                         * @interface IServiceAttachmentConnectedEndpoint
                         * @property {string|null} [endpoint] ServiceAttachmentConnectedEndpoint endpoint
                         * @property {number|Long|null} [pscConnectionId] ServiceAttachmentConnectedEndpoint pscConnectionId
                         * @property {string|null} [status] ServiceAttachmentConnectedEndpoint status
                         */
    
                        /**
                         * Constructs a new ServiceAttachmentConnectedEndpoint.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ServiceAttachmentConnectedEndpoint.
                         * @implements IServiceAttachmentConnectedEndpoint
                         * @constructor
                         * @param {google.cloud.compute.v1.IServiceAttachmentConnectedEndpoint=} [properties] Properties to set
                         */
                        function ServiceAttachmentConnectedEndpoint(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ServiceAttachmentConnectedEndpoint endpoint.
                         * @member {string|null|undefined} endpoint
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint
                         * @instance
                         */
                        ServiceAttachmentConnectedEndpoint.prototype.endpoint = null;
    
                        /**
                         * ServiceAttachmentConnectedEndpoint pscConnectionId.
                         * @member {number|Long|null|undefined} pscConnectionId
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint
                         * @instance
                         */
                        ServiceAttachmentConnectedEndpoint.prototype.pscConnectionId = null;
    
                        /**
                         * ServiceAttachmentConnectedEndpoint status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint
                         * @instance
                         */
                        ServiceAttachmentConnectedEndpoint.prototype.status = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ServiceAttachmentConnectedEndpoint _endpoint.
                         * @member {"endpoint"|undefined} _endpoint
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachmentConnectedEndpoint.prototype, "_endpoint", {
                            get: $util.oneOfGetter($oneOfFields = ["endpoint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachmentConnectedEndpoint _pscConnectionId.
                         * @member {"pscConnectionId"|undefined} _pscConnectionId
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachmentConnectedEndpoint.prototype, "_pscConnectionId", {
                            get: $util.oneOfGetter($oneOfFields = ["pscConnectionId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachmentConnectedEndpoint _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachmentConnectedEndpoint.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ServiceAttachmentConnectedEndpoint instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAttachmentConnectedEndpoint=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint} ServiceAttachmentConnectedEndpoint instance
                         */
                        ServiceAttachmentConnectedEndpoint.create = function create(properties) {
                            return new ServiceAttachmentConnectedEndpoint(properties);
                        };
    
                        /**
                         * Encodes the specified ServiceAttachmentConnectedEndpoint message. Does not implicitly {@link google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAttachmentConnectedEndpoint} message ServiceAttachmentConnectedEndpoint message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ServiceAttachmentConnectedEndpoint.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.endpoint != null && Object.hasOwnProperty.call(message, "endpoint"))
                                writer.uint32(/* id 130489749, wireType 2 =*/1043917994).string(message.endpoint);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.pscConnectionId != null && Object.hasOwnProperty.call(message, "pscConnectionId"))
                                writer.uint32(/* id 292082397, wireType 0 =*/2336659176).uint64(message.pscConnectionId);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ServiceAttachmentConnectedEndpoint message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAttachmentConnectedEndpoint} message ServiceAttachmentConnectedEndpoint message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ServiceAttachmentConnectedEndpoint.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ServiceAttachmentConnectedEndpoint message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint} ServiceAttachmentConnectedEndpoint
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ServiceAttachmentConnectedEndpoint.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 130489749: {
                                        message.endpoint = reader.string();
                                        break;
                                    }
                                case 292082397: {
                                        message.pscConnectionId = reader.uint64();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ServiceAttachmentConnectedEndpoint message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint} ServiceAttachmentConnectedEndpoint
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ServiceAttachmentConnectedEndpoint.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ServiceAttachmentConnectedEndpoint message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ServiceAttachmentConnectedEndpoint.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.endpoint != null && message.hasOwnProperty("endpoint")) {
                                properties._endpoint = 1;
                                if (!$util.isString(message.endpoint))
                                    return "endpoint: string expected";
                            }
                            if (message.pscConnectionId != null && message.hasOwnProperty("pscConnectionId")) {
                                properties._pscConnectionId = 1;
                                if (!$util.isInteger(message.pscConnectionId) && !(message.pscConnectionId && $util.isInteger(message.pscConnectionId.low) && $util.isInteger(message.pscConnectionId.high)))
                                    return "pscConnectionId: integer|Long expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ServiceAttachmentConnectedEndpoint message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint} ServiceAttachmentConnectedEndpoint
                         */
                        ServiceAttachmentConnectedEndpoint.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint();
                            if (object.endpoint != null)
                                message.endpoint = String(object.endpoint);
                            if (object.pscConnectionId != null)
                                if ($util.Long)
                                    (message.pscConnectionId = $util.Long.fromValue(object.pscConnectionId)).unsigned = true;
                                else if (typeof object.pscConnectionId === "string")
                                    message.pscConnectionId = parseInt(object.pscConnectionId, 10);
                                else if (typeof object.pscConnectionId === "number")
                                    message.pscConnectionId = object.pscConnectionId;
                                else if (typeof object.pscConnectionId === "object")
                                    message.pscConnectionId = new $util.LongBits(object.pscConnectionId.low >>> 0, object.pscConnectionId.high >>> 0).toNumber(true);
                            if (object.status != null)
                                message.status = String(object.status);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ServiceAttachmentConnectedEndpoint message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint
                         * @static
                         * @param {google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint} message ServiceAttachmentConnectedEndpoint
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ServiceAttachmentConnectedEndpoint.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.endpoint != null && message.hasOwnProperty("endpoint")) {
                                object.endpoint = message.endpoint;
                                if (options.oneofs)
                                    object._endpoint = "endpoint";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.pscConnectionId != null && message.hasOwnProperty("pscConnectionId")) {
                                if (typeof message.pscConnectionId === "number")
                                    object.pscConnectionId = options.longs === String ? String(message.pscConnectionId) : message.pscConnectionId;
                                else
                                    object.pscConnectionId = options.longs === String ? $util.Long.prototype.toString.call(message.pscConnectionId) : options.longs === Number ? new $util.LongBits(message.pscConnectionId.low >>> 0, message.pscConnectionId.high >>> 0).toNumber(true) : message.pscConnectionId;
                                if (options.oneofs)
                                    object._pscConnectionId = "pscConnectionId";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ServiceAttachmentConnectedEndpoint to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ServiceAttachmentConnectedEndpoint.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ServiceAttachmentConnectedEndpoint
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ServiceAttachmentConnectedEndpoint.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint";
                        };
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.ServiceAttachmentConnectedEndpoint.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} ACCEPTED=246714279 ACCEPTED value
                         * @property {number} CLOSED=380163436 CLOSED value
                         * @property {number} NEEDS_ATTENTION=344491452 NEEDS_ATTENTION value
                         * @property {number} PENDING=35394935 PENDING value
                         * @property {number} REJECTED=174130302 REJECTED value
                         * @property {number} STATUS_UNSPECIFIED=42133066 STATUS_UNSPECIFIED value
                         */
                        ServiceAttachmentConnectedEndpoint.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[246714279] = "ACCEPTED"] = 246714279;
                            values[valuesById[380163436] = "CLOSED"] = 380163436;
                            values[valuesById[344491452] = "NEEDS_ATTENTION"] = 344491452;
                            values[valuesById[35394935] = "PENDING"] = 35394935;
                            values[valuesById[174130302] = "REJECTED"] = 174130302;
                            values[valuesById[42133066] = "STATUS_UNSPECIFIED"] = 42133066;
                            return values;
                        })();
    
                        return ServiceAttachmentConnectedEndpoint;
                    })();
    
                    v1.ServiceAttachmentConsumerProjectLimit = (function() {
    
                        /**
                         * Properties of a ServiceAttachmentConsumerProjectLimit.
                         * @memberof google.cloud.compute.v1
                         * @interface IServiceAttachmentConsumerProjectLimit
                         * @property {number|null} [connectionLimit] ServiceAttachmentConsumerProjectLimit connectionLimit
                         * @property {string|null} [projectIdOrNum] ServiceAttachmentConsumerProjectLimit projectIdOrNum
                         */
    
                        /**
                         * Constructs a new ServiceAttachmentConsumerProjectLimit.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ServiceAttachmentConsumerProjectLimit.
                         * @implements IServiceAttachmentConsumerProjectLimit
                         * @constructor
                         * @param {google.cloud.compute.v1.IServiceAttachmentConsumerProjectLimit=} [properties] Properties to set
                         */
                        function ServiceAttachmentConsumerProjectLimit(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ServiceAttachmentConsumerProjectLimit connectionLimit.
                         * @member {number|null|undefined} connectionLimit
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit
                         * @instance
                         */
                        ServiceAttachmentConsumerProjectLimit.prototype.connectionLimit = null;
    
                        /**
                         * ServiceAttachmentConsumerProjectLimit projectIdOrNum.
                         * @member {string|null|undefined} projectIdOrNum
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit
                         * @instance
                         */
                        ServiceAttachmentConsumerProjectLimit.prototype.projectIdOrNum = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ServiceAttachmentConsumerProjectLimit _connectionLimit.
                         * @member {"connectionLimit"|undefined} _connectionLimit
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachmentConsumerProjectLimit.prototype, "_connectionLimit", {
                            get: $util.oneOfGetter($oneOfFields = ["connectionLimit"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachmentConsumerProjectLimit _projectIdOrNum.
                         * @member {"projectIdOrNum"|undefined} _projectIdOrNum
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachmentConsumerProjectLimit.prototype, "_projectIdOrNum", {
                            get: $util.oneOfGetter($oneOfFields = ["projectIdOrNum"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ServiceAttachmentConsumerProjectLimit instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAttachmentConsumerProjectLimit=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit} ServiceAttachmentConsumerProjectLimit instance
                         */
                        ServiceAttachmentConsumerProjectLimit.create = function create(properties) {
                            return new ServiceAttachmentConsumerProjectLimit(properties);
                        };
    
                        /**
                         * Encodes the specified ServiceAttachmentConsumerProjectLimit message. Does not implicitly {@link google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAttachmentConsumerProjectLimit} message ServiceAttachmentConsumerProjectLimit message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ServiceAttachmentConsumerProjectLimit.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.connectionLimit != null && Object.hasOwnProperty.call(message, "connectionLimit"))
                                writer.uint32(/* id 131403546, wireType 0 =*/1051228368).uint32(message.connectionLimit);
                            if (message.projectIdOrNum != null && Object.hasOwnProperty.call(message, "projectIdOrNum"))
                                writer.uint32(/* id 349783336, wireType 2 =*/2798266690).string(message.projectIdOrNum);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ServiceAttachmentConsumerProjectLimit message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAttachmentConsumerProjectLimit} message ServiceAttachmentConsumerProjectLimit message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ServiceAttachmentConsumerProjectLimit.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ServiceAttachmentConsumerProjectLimit message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit} ServiceAttachmentConsumerProjectLimit
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ServiceAttachmentConsumerProjectLimit.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 131403546: {
                                        message.connectionLimit = reader.uint32();
                                        break;
                                    }
                                case 349783336: {
                                        message.projectIdOrNum = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ServiceAttachmentConsumerProjectLimit message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit} ServiceAttachmentConsumerProjectLimit
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ServiceAttachmentConsumerProjectLimit.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ServiceAttachmentConsumerProjectLimit message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ServiceAttachmentConsumerProjectLimit.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.connectionLimit != null && message.hasOwnProperty("connectionLimit")) {
                                properties._connectionLimit = 1;
                                if (!$util.isInteger(message.connectionLimit))
                                    return "connectionLimit: integer expected";
                            }
                            if (message.projectIdOrNum != null && message.hasOwnProperty("projectIdOrNum")) {
                                properties._projectIdOrNum = 1;
                                if (!$util.isString(message.projectIdOrNum))
                                    return "projectIdOrNum: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ServiceAttachmentConsumerProjectLimit message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit} ServiceAttachmentConsumerProjectLimit
                         */
                        ServiceAttachmentConsumerProjectLimit.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit();
                            if (object.connectionLimit != null)
                                message.connectionLimit = object.connectionLimit >>> 0;
                            if (object.projectIdOrNum != null)
                                message.projectIdOrNum = String(object.projectIdOrNum);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ServiceAttachmentConsumerProjectLimit message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit
                         * @static
                         * @param {google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit} message ServiceAttachmentConsumerProjectLimit
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ServiceAttachmentConsumerProjectLimit.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.connectionLimit != null && message.hasOwnProperty("connectionLimit")) {
                                object.connectionLimit = message.connectionLimit;
                                if (options.oneofs)
                                    object._connectionLimit = "connectionLimit";
                            }
                            if (message.projectIdOrNum != null && message.hasOwnProperty("projectIdOrNum")) {
                                object.projectIdOrNum = message.projectIdOrNum;
                                if (options.oneofs)
                                    object._projectIdOrNum = "projectIdOrNum";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ServiceAttachmentConsumerProjectLimit to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ServiceAttachmentConsumerProjectLimit.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ServiceAttachmentConsumerProjectLimit
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ServiceAttachmentConsumerProjectLimit.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ServiceAttachmentConsumerProjectLimit";
                        };
    
                        return ServiceAttachmentConsumerProjectLimit;
                    })();
    
                    v1.ServiceAttachmentList = (function() {
    
                        /**
                         * Properties of a ServiceAttachmentList.
                         * @memberof google.cloud.compute.v1
                         * @interface IServiceAttachmentList
                         * @property {string|null} [id] ServiceAttachmentList id
                         * @property {Array.<google.cloud.compute.v1.IServiceAttachment>|null} [items] ServiceAttachmentList items
                         * @property {string|null} [kind] ServiceAttachmentList kind
                         * @property {string|null} [nextPageToken] ServiceAttachmentList nextPageToken
                         * @property {string|null} [selfLink] ServiceAttachmentList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] ServiceAttachmentList warning
                         */
    
                        /**
                         * Constructs a new ServiceAttachmentList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ServiceAttachmentList.
                         * @implements IServiceAttachmentList
                         * @constructor
                         * @param {google.cloud.compute.v1.IServiceAttachmentList=} [properties] Properties to set
                         */
                        function ServiceAttachmentList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ServiceAttachmentList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @instance
                         */
                        ServiceAttachmentList.prototype.id = null;
    
                        /**
                         * ServiceAttachmentList items.
                         * @member {Array.<google.cloud.compute.v1.IServiceAttachment>} items
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @instance
                         */
                        ServiceAttachmentList.prototype.items = $util.emptyArray;
    
                        /**
                         * ServiceAttachmentList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @instance
                         */
                        ServiceAttachmentList.prototype.kind = null;
    
                        /**
                         * ServiceAttachmentList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @instance
                         */
                        ServiceAttachmentList.prototype.nextPageToken = null;
    
                        /**
                         * ServiceAttachmentList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @instance
                         */
                        ServiceAttachmentList.prototype.selfLink = null;
    
                        /**
                         * ServiceAttachmentList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @instance
                         */
                        ServiceAttachmentList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ServiceAttachmentList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachmentList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachmentList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachmentList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachmentList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachmentList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachmentList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachmentList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ServiceAttachmentList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachmentList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ServiceAttachmentList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAttachmentList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ServiceAttachmentList} ServiceAttachmentList instance
                         */
                        ServiceAttachmentList.create = function create(properties) {
                            return new ServiceAttachmentList(properties);
                        };
    
                        /**
                         * Encodes the specified ServiceAttachmentList message. Does not implicitly {@link google.cloud.compute.v1.ServiceAttachmentList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAttachmentList} message ServiceAttachmentList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ServiceAttachmentList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.ServiceAttachment.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ServiceAttachmentList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ServiceAttachmentList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAttachmentList} message ServiceAttachmentList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ServiceAttachmentList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ServiceAttachmentList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ServiceAttachmentList} ServiceAttachmentList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ServiceAttachmentList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ServiceAttachmentList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.ServiceAttachment.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ServiceAttachmentList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ServiceAttachmentList} ServiceAttachmentList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ServiceAttachmentList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ServiceAttachmentList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ServiceAttachmentList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ServiceAttachment.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ServiceAttachmentList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ServiceAttachmentList} ServiceAttachmentList
                         */
                        ServiceAttachmentList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ServiceAttachmentList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ServiceAttachmentList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.ServiceAttachmentList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ServiceAttachmentList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.ServiceAttachment.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ServiceAttachmentList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ServiceAttachmentList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @static
                         * @param {google.cloud.compute.v1.ServiceAttachmentList} message ServiceAttachmentList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ServiceAttachmentList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.ServiceAttachment.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ServiceAttachmentList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ServiceAttachmentList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ServiceAttachmentList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ServiceAttachmentList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ServiceAttachmentList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ServiceAttachmentList";
                        };
    
                        return ServiceAttachmentList;
                    })();
    
                    v1.ServiceAttachmentsScopedList = (function() {
    
                        /**
                         * Properties of a ServiceAttachmentsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IServiceAttachmentsScopedList
                         * @property {Array.<google.cloud.compute.v1.IServiceAttachment>|null} [serviceAttachments] ServiceAttachmentsScopedList serviceAttachments
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] ServiceAttachmentsScopedList warning
                         */
    
                        /**
                         * Constructs a new ServiceAttachmentsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ServiceAttachmentsScopedList.
                         * @implements IServiceAttachmentsScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IServiceAttachmentsScopedList=} [properties] Properties to set
                         */
                        function ServiceAttachmentsScopedList(properties) {
                            this.serviceAttachments = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ServiceAttachmentsScopedList serviceAttachments.
                         * @member {Array.<google.cloud.compute.v1.IServiceAttachment>} serviceAttachments
                         * @memberof google.cloud.compute.v1.ServiceAttachmentsScopedList
                         * @instance
                         */
                        ServiceAttachmentsScopedList.prototype.serviceAttachments = $util.emptyArray;
    
                        /**
                         * ServiceAttachmentsScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.ServiceAttachmentsScopedList
                         * @instance
                         */
                        ServiceAttachmentsScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ServiceAttachmentsScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.ServiceAttachmentsScopedList
                         * @instance
                         */
                        Object.defineProperty(ServiceAttachmentsScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ServiceAttachmentsScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ServiceAttachmentsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAttachmentsScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ServiceAttachmentsScopedList} ServiceAttachmentsScopedList instance
                         */
                        ServiceAttachmentsScopedList.create = function create(properties) {
                            return new ServiceAttachmentsScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified ServiceAttachmentsScopedList message. Does not implicitly {@link google.cloud.compute.v1.ServiceAttachmentsScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ServiceAttachmentsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAttachmentsScopedList} message ServiceAttachmentsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ServiceAttachmentsScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.serviceAttachments != null && message.serviceAttachments.length)
                                for (var i = 0; i < message.serviceAttachments.length; ++i)
                                    $root.google.cloud.compute.v1.ServiceAttachment.encode(message.serviceAttachments[i], writer.uint32(/* id 307136806, wireType 2 =*/2457094450).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ServiceAttachmentsScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ServiceAttachmentsScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ServiceAttachmentsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IServiceAttachmentsScopedList} message ServiceAttachmentsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ServiceAttachmentsScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ServiceAttachmentsScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ServiceAttachmentsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ServiceAttachmentsScopedList} ServiceAttachmentsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ServiceAttachmentsScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ServiceAttachmentsScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 307136806: {
                                        if (!(message.serviceAttachments && message.serviceAttachments.length))
                                            message.serviceAttachments = [];
                                        message.serviceAttachments.push($root.google.cloud.compute.v1.ServiceAttachment.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ServiceAttachmentsScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ServiceAttachmentsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ServiceAttachmentsScopedList} ServiceAttachmentsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ServiceAttachmentsScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ServiceAttachmentsScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ServiceAttachmentsScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ServiceAttachmentsScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.serviceAttachments != null && message.hasOwnProperty("serviceAttachments")) {
                                if (!Array.isArray(message.serviceAttachments))
                                    return "serviceAttachments: array expected";
                                for (var i = 0; i < message.serviceAttachments.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ServiceAttachment.verify(message.serviceAttachments[i]);
                                    if (error)
                                        return "serviceAttachments." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ServiceAttachmentsScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ServiceAttachmentsScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ServiceAttachmentsScopedList} ServiceAttachmentsScopedList
                         */
                        ServiceAttachmentsScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ServiceAttachmentsScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ServiceAttachmentsScopedList();
                            if (object.serviceAttachments) {
                                if (!Array.isArray(object.serviceAttachments))
                                    throw TypeError(".google.cloud.compute.v1.ServiceAttachmentsScopedList.serviceAttachments: array expected");
                                message.serviceAttachments = [];
                                for (var i = 0; i < object.serviceAttachments.length; ++i) {
                                    if (typeof object.serviceAttachments[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ServiceAttachmentsScopedList.serviceAttachments: object expected");
                                    message.serviceAttachments[i] = $root.google.cloud.compute.v1.ServiceAttachment.fromObject(object.serviceAttachments[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ServiceAttachmentsScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ServiceAttachmentsScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ServiceAttachmentsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ServiceAttachmentsScopedList} message ServiceAttachmentsScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ServiceAttachmentsScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.serviceAttachments = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.serviceAttachments && message.serviceAttachments.length) {
                                object.serviceAttachments = [];
                                for (var j = 0; j < message.serviceAttachments.length; ++j)
                                    object.serviceAttachments[j] = $root.google.cloud.compute.v1.ServiceAttachment.toObject(message.serviceAttachments[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ServiceAttachmentsScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ServiceAttachmentsScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ServiceAttachmentsScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ServiceAttachmentsScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ServiceAttachmentsScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ServiceAttachmentsScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ServiceAttachmentsScopedList";
                        };
    
                        return ServiceAttachmentsScopedList;
                    })();
    
                    v1.SetBackendServiceTargetSslProxyRequest = (function() {
    
                        /**
                         * Properties of a SetBackendServiceTargetSslProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetBackendServiceTargetSslProxyRequest
                         * @property {string|null} [project] SetBackendServiceTargetSslProxyRequest project
                         * @property {string|null} [requestId] SetBackendServiceTargetSslProxyRequest requestId
                         * @property {google.cloud.compute.v1.ITargetSslProxiesSetBackendServiceRequest|null} [targetSslProxiesSetBackendServiceRequestResource] SetBackendServiceTargetSslProxyRequest targetSslProxiesSetBackendServiceRequestResource
                         * @property {string|null} [targetSslProxy] SetBackendServiceTargetSslProxyRequest targetSslProxy
                         */
    
                        /**
                         * Constructs a new SetBackendServiceTargetSslProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetBackendServiceTargetSslProxyRequest.
                         * @implements ISetBackendServiceTargetSslProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetBackendServiceTargetSslProxyRequest=} [properties] Properties to set
                         */
                        function SetBackendServiceTargetSslProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetBackendServiceTargetSslProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest
                         * @instance
                         */
                        SetBackendServiceTargetSslProxyRequest.prototype.project = "";
    
                        /**
                         * SetBackendServiceTargetSslProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest
                         * @instance
                         */
                        SetBackendServiceTargetSslProxyRequest.prototype.requestId = null;
    
                        /**
                         * SetBackendServiceTargetSslProxyRequest targetSslProxiesSetBackendServiceRequestResource.
                         * @member {google.cloud.compute.v1.ITargetSslProxiesSetBackendServiceRequest|null|undefined} targetSslProxiesSetBackendServiceRequestResource
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest
                         * @instance
                         */
                        SetBackendServiceTargetSslProxyRequest.prototype.targetSslProxiesSetBackendServiceRequestResource = null;
    
                        /**
                         * SetBackendServiceTargetSslProxyRequest targetSslProxy.
                         * @member {string} targetSslProxy
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest
                         * @instance
                         */
                        SetBackendServiceTargetSslProxyRequest.prototype.targetSslProxy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetBackendServiceTargetSslProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest
                         * @instance
                         */
                        Object.defineProperty(SetBackendServiceTargetSslProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetBackendServiceTargetSslProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetBackendServiceTargetSslProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest} SetBackendServiceTargetSslProxyRequest instance
                         */
                        SetBackendServiceTargetSslProxyRequest.create = function create(properties) {
                            return new SetBackendServiceTargetSslProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetBackendServiceTargetSslProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetBackendServiceTargetSslProxyRequest} message SetBackendServiceTargetSslProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetBackendServiceTargetSslProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetSslProxiesSetBackendServiceRequestResource != null && Object.hasOwnProperty.call(message, "targetSslProxiesSetBackendServiceRequestResource"))
                                $root.google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest.encode(message.targetSslProxiesSetBackendServiceRequestResource, writer.uint32(/* id 139080868, wireType 2 =*/1112646946).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetSslProxy != null && Object.hasOwnProperty.call(message, "targetSslProxy"))
                                writer.uint32(/* id 338795853, wireType 2 =*/2710366826).string(message.targetSslProxy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetBackendServiceTargetSslProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetBackendServiceTargetSslProxyRequest} message SetBackendServiceTargetSslProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetBackendServiceTargetSslProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetBackendServiceTargetSslProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest} SetBackendServiceTargetSslProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetBackendServiceTargetSslProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 139080868: {
                                        message.targetSslProxiesSetBackendServiceRequestResource = $root.google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 338795853: {
                                        message.targetSslProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetBackendServiceTargetSslProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest} SetBackendServiceTargetSslProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetBackendServiceTargetSslProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetBackendServiceTargetSslProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetBackendServiceTargetSslProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetSslProxiesSetBackendServiceRequestResource != null && message.hasOwnProperty("targetSslProxiesSetBackendServiceRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest.verify(message.targetSslProxiesSetBackendServiceRequestResource);
                                if (error)
                                    return "targetSslProxiesSetBackendServiceRequestResource." + error;
                            }
                            if (message.targetSslProxy != null && message.hasOwnProperty("targetSslProxy"))
                                if (!$util.isString(message.targetSslProxy))
                                    return "targetSslProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetBackendServiceTargetSslProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest} SetBackendServiceTargetSslProxyRequest
                         */
                        SetBackendServiceTargetSslProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetSslProxiesSetBackendServiceRequestResource != null) {
                                if (typeof object.targetSslProxiesSetBackendServiceRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest.targetSslProxiesSetBackendServiceRequestResource: object expected");
                                message.targetSslProxiesSetBackendServiceRequestResource = $root.google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest.fromObject(object.targetSslProxiesSetBackendServiceRequestResource);
                            }
                            if (object.targetSslProxy != null)
                                message.targetSslProxy = String(object.targetSslProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetBackendServiceTargetSslProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest} message SetBackendServiceTargetSslProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetBackendServiceTargetSslProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetSslProxiesSetBackendServiceRequestResource = null;
                                object.project = "";
                                object.targetSslProxy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetSslProxiesSetBackendServiceRequestResource != null && message.hasOwnProperty("targetSslProxiesSetBackendServiceRequestResource"))
                                object.targetSslProxiesSetBackendServiceRequestResource = $root.google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest.toObject(message.targetSslProxiesSetBackendServiceRequestResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetSslProxy != null && message.hasOwnProperty("targetSslProxy"))
                                object.targetSslProxy = message.targetSslProxy;
                            return object;
                        };
    
                        /**
                         * Converts this SetBackendServiceTargetSslProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetBackendServiceTargetSslProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetBackendServiceTargetSslProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetBackendServiceTargetSslProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest";
                        };
    
                        return SetBackendServiceTargetSslProxyRequest;
                    })();
    
                    v1.SetBackendServiceTargetTcpProxyRequest = (function() {
    
                        /**
                         * Properties of a SetBackendServiceTargetTcpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetBackendServiceTargetTcpProxyRequest
                         * @property {string|null} [project] SetBackendServiceTargetTcpProxyRequest project
                         * @property {string|null} [requestId] SetBackendServiceTargetTcpProxyRequest requestId
                         * @property {google.cloud.compute.v1.ITargetTcpProxiesSetBackendServiceRequest|null} [targetTcpProxiesSetBackendServiceRequestResource] SetBackendServiceTargetTcpProxyRequest targetTcpProxiesSetBackendServiceRequestResource
                         * @property {string|null} [targetTcpProxy] SetBackendServiceTargetTcpProxyRequest targetTcpProxy
                         */
    
                        /**
                         * Constructs a new SetBackendServiceTargetTcpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetBackendServiceTargetTcpProxyRequest.
                         * @implements ISetBackendServiceTargetTcpProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetBackendServiceTargetTcpProxyRequest=} [properties] Properties to set
                         */
                        function SetBackendServiceTargetTcpProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetBackendServiceTargetTcpProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest
                         * @instance
                         */
                        SetBackendServiceTargetTcpProxyRequest.prototype.project = "";
    
                        /**
                         * SetBackendServiceTargetTcpProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest
                         * @instance
                         */
                        SetBackendServiceTargetTcpProxyRequest.prototype.requestId = null;
    
                        /**
                         * SetBackendServiceTargetTcpProxyRequest targetTcpProxiesSetBackendServiceRequestResource.
                         * @member {google.cloud.compute.v1.ITargetTcpProxiesSetBackendServiceRequest|null|undefined} targetTcpProxiesSetBackendServiceRequestResource
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest
                         * @instance
                         */
                        SetBackendServiceTargetTcpProxyRequest.prototype.targetTcpProxiesSetBackendServiceRequestResource = null;
    
                        /**
                         * SetBackendServiceTargetTcpProxyRequest targetTcpProxy.
                         * @member {string} targetTcpProxy
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest
                         * @instance
                         */
                        SetBackendServiceTargetTcpProxyRequest.prototype.targetTcpProxy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetBackendServiceTargetTcpProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest
                         * @instance
                         */
                        Object.defineProperty(SetBackendServiceTargetTcpProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetBackendServiceTargetTcpProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetBackendServiceTargetTcpProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest} SetBackendServiceTargetTcpProxyRequest instance
                         */
                        SetBackendServiceTargetTcpProxyRequest.create = function create(properties) {
                            return new SetBackendServiceTargetTcpProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetBackendServiceTargetTcpProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetBackendServiceTargetTcpProxyRequest} message SetBackendServiceTargetTcpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetBackendServiceTargetTcpProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetTcpProxiesSetBackendServiceRequestResource != null && Object.hasOwnProperty.call(message, "targetTcpProxiesSetBackendServiceRequestResource"))
                                $root.google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest.encode(message.targetTcpProxiesSetBackendServiceRequestResource, writer.uint32(/* id 273721583, wireType 2 =*/2189772666).fork()).ldelim();
                            if (message.targetTcpProxy != null && Object.hasOwnProperty.call(message, "targetTcpProxy"))
                                writer.uint32(/* id 503065442, wireType 2 =*/4024523538).string(message.targetTcpProxy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetBackendServiceTargetTcpProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetBackendServiceTargetTcpProxyRequest} message SetBackendServiceTargetTcpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetBackendServiceTargetTcpProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetBackendServiceTargetTcpProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest} SetBackendServiceTargetTcpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetBackendServiceTargetTcpProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 273721583: {
                                        message.targetTcpProxiesSetBackendServiceRequestResource = $root.google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 503065442: {
                                        message.targetTcpProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetBackendServiceTargetTcpProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest} SetBackendServiceTargetTcpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetBackendServiceTargetTcpProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetBackendServiceTargetTcpProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetBackendServiceTargetTcpProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetTcpProxiesSetBackendServiceRequestResource != null && message.hasOwnProperty("targetTcpProxiesSetBackendServiceRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest.verify(message.targetTcpProxiesSetBackendServiceRequestResource);
                                if (error)
                                    return "targetTcpProxiesSetBackendServiceRequestResource." + error;
                            }
                            if (message.targetTcpProxy != null && message.hasOwnProperty("targetTcpProxy"))
                                if (!$util.isString(message.targetTcpProxy))
                                    return "targetTcpProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetBackendServiceTargetTcpProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest} SetBackendServiceTargetTcpProxyRequest
                         */
                        SetBackendServiceTargetTcpProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetTcpProxiesSetBackendServiceRequestResource != null) {
                                if (typeof object.targetTcpProxiesSetBackendServiceRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest.targetTcpProxiesSetBackendServiceRequestResource: object expected");
                                message.targetTcpProxiesSetBackendServiceRequestResource = $root.google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest.fromObject(object.targetTcpProxiesSetBackendServiceRequestResource);
                            }
                            if (object.targetTcpProxy != null)
                                message.targetTcpProxy = String(object.targetTcpProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetBackendServiceTargetTcpProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest} message SetBackendServiceTargetTcpProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetBackendServiceTargetTcpProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.targetTcpProxiesSetBackendServiceRequestResource = null;
                                object.targetTcpProxy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetTcpProxiesSetBackendServiceRequestResource != null && message.hasOwnProperty("targetTcpProxiesSetBackendServiceRequestResource"))
                                object.targetTcpProxiesSetBackendServiceRequestResource = $root.google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest.toObject(message.targetTcpProxiesSetBackendServiceRequestResource, options);
                            if (message.targetTcpProxy != null && message.hasOwnProperty("targetTcpProxy"))
                                object.targetTcpProxy = message.targetTcpProxy;
                            return object;
                        };
    
                        /**
                         * Converts this SetBackendServiceTargetTcpProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetBackendServiceTargetTcpProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetBackendServiceTargetTcpProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetBackendServiceTargetTcpProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest";
                        };
    
                        return SetBackendServiceTargetTcpProxyRequest;
                    })();
    
                    v1.SetBackupTargetPoolRequest = (function() {
    
                        /**
                         * Properties of a SetBackupTargetPoolRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetBackupTargetPoolRequest
                         * @property {number|null} [failoverRatio] SetBackupTargetPoolRequest failoverRatio
                         * @property {string|null} [project] SetBackupTargetPoolRequest project
                         * @property {string|null} [region] SetBackupTargetPoolRequest region
                         * @property {string|null} [requestId] SetBackupTargetPoolRequest requestId
                         * @property {string|null} [targetPool] SetBackupTargetPoolRequest targetPool
                         * @property {google.cloud.compute.v1.ITargetReference|null} [targetReferenceResource] SetBackupTargetPoolRequest targetReferenceResource
                         */
    
                        /**
                         * Constructs a new SetBackupTargetPoolRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetBackupTargetPoolRequest.
                         * @implements ISetBackupTargetPoolRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetBackupTargetPoolRequest=} [properties] Properties to set
                         */
                        function SetBackupTargetPoolRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetBackupTargetPoolRequest failoverRatio.
                         * @member {number|null|undefined} failoverRatio
                         * @memberof google.cloud.compute.v1.SetBackupTargetPoolRequest
                         * @instance
                         */
                        SetBackupTargetPoolRequest.prototype.failoverRatio = null;
    
                        /**
                         * SetBackupTargetPoolRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetBackupTargetPoolRequest
                         * @instance
                         */
                        SetBackupTargetPoolRequest.prototype.project = "";
    
                        /**
                         * SetBackupTargetPoolRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetBackupTargetPoolRequest
                         * @instance
                         */
                        SetBackupTargetPoolRequest.prototype.region = "";
    
                        /**
                         * SetBackupTargetPoolRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetBackupTargetPoolRequest
                         * @instance
                         */
                        SetBackupTargetPoolRequest.prototype.requestId = null;
    
                        /**
                         * SetBackupTargetPoolRequest targetPool.
                         * @member {string} targetPool
                         * @memberof google.cloud.compute.v1.SetBackupTargetPoolRequest
                         * @instance
                         */
                        SetBackupTargetPoolRequest.prototype.targetPool = "";
    
                        /**
                         * SetBackupTargetPoolRequest targetReferenceResource.
                         * @member {google.cloud.compute.v1.ITargetReference|null|undefined} targetReferenceResource
                         * @memberof google.cloud.compute.v1.SetBackupTargetPoolRequest
                         * @instance
                         */
                        SetBackupTargetPoolRequest.prototype.targetReferenceResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetBackupTargetPoolRequest _failoverRatio.
                         * @member {"failoverRatio"|undefined} _failoverRatio
                         * @memberof google.cloud.compute.v1.SetBackupTargetPoolRequest
                         * @instance
                         */
                        Object.defineProperty(SetBackupTargetPoolRequest.prototype, "_failoverRatio", {
                            get: $util.oneOfGetter($oneOfFields = ["failoverRatio"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SetBackupTargetPoolRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetBackupTargetPoolRequest
                         * @instance
                         */
                        Object.defineProperty(SetBackupTargetPoolRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetBackupTargetPoolRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetBackupTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetBackupTargetPoolRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetBackupTargetPoolRequest} SetBackupTargetPoolRequest instance
                         */
                        SetBackupTargetPoolRequest.create = function create(properties) {
                            return new SetBackupTargetPoolRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetBackupTargetPoolRequest message. Does not implicitly {@link google.cloud.compute.v1.SetBackupTargetPoolRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetBackupTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetBackupTargetPoolRequest} message SetBackupTargetPoolRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetBackupTargetPoolRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetPool != null && Object.hasOwnProperty.call(message, "targetPool"))
                                writer.uint32(/* id 62796298, wireType 2 =*/502370386).string(message.targetPool);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.failoverRatio != null && Object.hasOwnProperty.call(message, "failoverRatio"))
                                writer.uint32(/* id 212667006, wireType 5 =*/1701336053).float(message.failoverRatio);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetReferenceResource != null && Object.hasOwnProperty.call(message, "targetReferenceResource"))
                                $root.google.cloud.compute.v1.TargetReference.encode(message.targetReferenceResource, writer.uint32(/* id 523721712, wireType 2 =*/4189773698).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetBackupTargetPoolRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetBackupTargetPoolRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetBackupTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetBackupTargetPoolRequest} message SetBackupTargetPoolRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetBackupTargetPoolRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetBackupTargetPoolRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetBackupTargetPoolRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetBackupTargetPoolRequest} SetBackupTargetPoolRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetBackupTargetPoolRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetBackupTargetPoolRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 212667006: {
                                        message.failoverRatio = reader.float();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 62796298: {
                                        message.targetPool = reader.string();
                                        break;
                                    }
                                case 523721712: {
                                        message.targetReferenceResource = $root.google.cloud.compute.v1.TargetReference.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetBackupTargetPoolRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetBackupTargetPoolRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetBackupTargetPoolRequest} SetBackupTargetPoolRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetBackupTargetPoolRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetBackupTargetPoolRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetBackupTargetPoolRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetBackupTargetPoolRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.failoverRatio != null && message.hasOwnProperty("failoverRatio")) {
                                properties._failoverRatio = 1;
                                if (typeof message.failoverRatio !== "number")
                                    return "failoverRatio: number expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetPool != null && message.hasOwnProperty("targetPool"))
                                if (!$util.isString(message.targetPool))
                                    return "targetPool: string expected";
                            if (message.targetReferenceResource != null && message.hasOwnProperty("targetReferenceResource")) {
                                var error = $root.google.cloud.compute.v1.TargetReference.verify(message.targetReferenceResource);
                                if (error)
                                    return "targetReferenceResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetBackupTargetPoolRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetBackupTargetPoolRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetBackupTargetPoolRequest} SetBackupTargetPoolRequest
                         */
                        SetBackupTargetPoolRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetBackupTargetPoolRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetBackupTargetPoolRequest();
                            if (object.failoverRatio != null)
                                message.failoverRatio = Number(object.failoverRatio);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetPool != null)
                                message.targetPool = String(object.targetPool);
                            if (object.targetReferenceResource != null) {
                                if (typeof object.targetReferenceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetBackupTargetPoolRequest.targetReferenceResource: object expected");
                                message.targetReferenceResource = $root.google.cloud.compute.v1.TargetReference.fromObject(object.targetReferenceResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetBackupTargetPoolRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetBackupTargetPoolRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetBackupTargetPoolRequest} message SetBackupTargetPoolRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetBackupTargetPoolRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetPool = "";
                                object.region = "";
                                object.project = "";
                                object.targetReferenceResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetPool != null && message.hasOwnProperty("targetPool"))
                                object.targetPool = message.targetPool;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.failoverRatio != null && message.hasOwnProperty("failoverRatio")) {
                                object.failoverRatio = options.json && !isFinite(message.failoverRatio) ? String(message.failoverRatio) : message.failoverRatio;
                                if (options.oneofs)
                                    object._failoverRatio = "failoverRatio";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetReferenceResource != null && message.hasOwnProperty("targetReferenceResource"))
                                object.targetReferenceResource = $root.google.cloud.compute.v1.TargetReference.toObject(message.targetReferenceResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetBackupTargetPoolRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetBackupTargetPoolRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetBackupTargetPoolRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetBackupTargetPoolRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetBackupTargetPoolRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetBackupTargetPoolRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetBackupTargetPoolRequest";
                        };
    
                        return SetBackupTargetPoolRequest;
                    })();
    
                    v1.SetCertificateMapTargetHttpsProxyRequest = (function() {
    
                        /**
                         * Properties of a SetCertificateMapTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetCertificateMapTargetHttpsProxyRequest
                         * @property {string|null} [project] SetCertificateMapTargetHttpsProxyRequest project
                         * @property {string|null} [requestId] SetCertificateMapTargetHttpsProxyRequest requestId
                         * @property {google.cloud.compute.v1.ITargetHttpsProxiesSetCertificateMapRequest|null} [targetHttpsProxiesSetCertificateMapRequestResource] SetCertificateMapTargetHttpsProxyRequest targetHttpsProxiesSetCertificateMapRequestResource
                         * @property {string|null} [targetHttpsProxy] SetCertificateMapTargetHttpsProxyRequest targetHttpsProxy
                         */
    
                        /**
                         * Constructs a new SetCertificateMapTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetCertificateMapTargetHttpsProxyRequest.
                         * @implements ISetCertificateMapTargetHttpsProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetCertificateMapTargetHttpsProxyRequest=} [properties] Properties to set
                         */
                        function SetCertificateMapTargetHttpsProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetCertificateMapTargetHttpsProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest
                         * @instance
                         */
                        SetCertificateMapTargetHttpsProxyRequest.prototype.project = "";
    
                        /**
                         * SetCertificateMapTargetHttpsProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest
                         * @instance
                         */
                        SetCertificateMapTargetHttpsProxyRequest.prototype.requestId = null;
    
                        /**
                         * SetCertificateMapTargetHttpsProxyRequest targetHttpsProxiesSetCertificateMapRequestResource.
                         * @member {google.cloud.compute.v1.ITargetHttpsProxiesSetCertificateMapRequest|null|undefined} targetHttpsProxiesSetCertificateMapRequestResource
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest
                         * @instance
                         */
                        SetCertificateMapTargetHttpsProxyRequest.prototype.targetHttpsProxiesSetCertificateMapRequestResource = null;
    
                        /**
                         * SetCertificateMapTargetHttpsProxyRequest targetHttpsProxy.
                         * @member {string} targetHttpsProxy
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest
                         * @instance
                         */
                        SetCertificateMapTargetHttpsProxyRequest.prototype.targetHttpsProxy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetCertificateMapTargetHttpsProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest
                         * @instance
                         */
                        Object.defineProperty(SetCertificateMapTargetHttpsProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetCertificateMapTargetHttpsProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetCertificateMapTargetHttpsProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest} SetCertificateMapTargetHttpsProxyRequest instance
                         */
                        SetCertificateMapTargetHttpsProxyRequest.create = function create(properties) {
                            return new SetCertificateMapTargetHttpsProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetCertificateMapTargetHttpsProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetCertificateMapTargetHttpsProxyRequest} message SetCertificateMapTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetCertificateMapTargetHttpsProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetHttpsProxy != null && Object.hasOwnProperty.call(message, "targetHttpsProxy"))
                                writer.uint32(/* id 52336748, wireType 2 =*/418693986).string(message.targetHttpsProxy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetHttpsProxiesSetCertificateMapRequestResource != null && Object.hasOwnProperty.call(message, "targetHttpsProxiesSetCertificateMapRequestResource"))
                                $root.google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest.encode(message.targetHttpsProxiesSetCertificateMapRequestResource, writer.uint32(/* id 467639099, wireType 2 =*/3741112794).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetCertificateMapTargetHttpsProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetCertificateMapTargetHttpsProxyRequest} message SetCertificateMapTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetCertificateMapTargetHttpsProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetCertificateMapTargetHttpsProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest} SetCertificateMapTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetCertificateMapTargetHttpsProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 467639099: {
                                        message.targetHttpsProxiesSetCertificateMapRequestResource = $root.google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 52336748: {
                                        message.targetHttpsProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetCertificateMapTargetHttpsProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest} SetCertificateMapTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetCertificateMapTargetHttpsProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetCertificateMapTargetHttpsProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetCertificateMapTargetHttpsProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetHttpsProxiesSetCertificateMapRequestResource != null && message.hasOwnProperty("targetHttpsProxiesSetCertificateMapRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest.verify(message.targetHttpsProxiesSetCertificateMapRequestResource);
                                if (error)
                                    return "targetHttpsProxiesSetCertificateMapRequestResource." + error;
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                if (!$util.isString(message.targetHttpsProxy))
                                    return "targetHttpsProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetCertificateMapTargetHttpsProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest} SetCertificateMapTargetHttpsProxyRequest
                         */
                        SetCertificateMapTargetHttpsProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetHttpsProxiesSetCertificateMapRequestResource != null) {
                                if (typeof object.targetHttpsProxiesSetCertificateMapRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest.targetHttpsProxiesSetCertificateMapRequestResource: object expected");
                                message.targetHttpsProxiesSetCertificateMapRequestResource = $root.google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest.fromObject(object.targetHttpsProxiesSetCertificateMapRequestResource);
                            }
                            if (object.targetHttpsProxy != null)
                                message.targetHttpsProxy = String(object.targetHttpsProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetCertificateMapTargetHttpsProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest} message SetCertificateMapTargetHttpsProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetCertificateMapTargetHttpsProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetHttpsProxy = "";
                                object.project = "";
                                object.targetHttpsProxiesSetCertificateMapRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                object.targetHttpsProxy = message.targetHttpsProxy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetHttpsProxiesSetCertificateMapRequestResource != null && message.hasOwnProperty("targetHttpsProxiesSetCertificateMapRequestResource"))
                                object.targetHttpsProxiesSetCertificateMapRequestResource = $root.google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest.toObject(message.targetHttpsProxiesSetCertificateMapRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetCertificateMapTargetHttpsProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetCertificateMapTargetHttpsProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetCertificateMapTargetHttpsProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetCertificateMapTargetHttpsProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest";
                        };
    
                        return SetCertificateMapTargetHttpsProxyRequest;
                    })();
    
                    v1.SetCertificateMapTargetSslProxyRequest = (function() {
    
                        /**
                         * Properties of a SetCertificateMapTargetSslProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetCertificateMapTargetSslProxyRequest
                         * @property {string|null} [project] SetCertificateMapTargetSslProxyRequest project
                         * @property {string|null} [requestId] SetCertificateMapTargetSslProxyRequest requestId
                         * @property {google.cloud.compute.v1.ITargetSslProxiesSetCertificateMapRequest|null} [targetSslProxiesSetCertificateMapRequestResource] SetCertificateMapTargetSslProxyRequest targetSslProxiesSetCertificateMapRequestResource
                         * @property {string|null} [targetSslProxy] SetCertificateMapTargetSslProxyRequest targetSslProxy
                         */
    
                        /**
                         * Constructs a new SetCertificateMapTargetSslProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetCertificateMapTargetSslProxyRequest.
                         * @implements ISetCertificateMapTargetSslProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetCertificateMapTargetSslProxyRequest=} [properties] Properties to set
                         */
                        function SetCertificateMapTargetSslProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetCertificateMapTargetSslProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest
                         * @instance
                         */
                        SetCertificateMapTargetSslProxyRequest.prototype.project = "";
    
                        /**
                         * SetCertificateMapTargetSslProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest
                         * @instance
                         */
                        SetCertificateMapTargetSslProxyRequest.prototype.requestId = null;
    
                        /**
                         * SetCertificateMapTargetSslProxyRequest targetSslProxiesSetCertificateMapRequestResource.
                         * @member {google.cloud.compute.v1.ITargetSslProxiesSetCertificateMapRequest|null|undefined} targetSslProxiesSetCertificateMapRequestResource
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest
                         * @instance
                         */
                        SetCertificateMapTargetSslProxyRequest.prototype.targetSslProxiesSetCertificateMapRequestResource = null;
    
                        /**
                         * SetCertificateMapTargetSslProxyRequest targetSslProxy.
                         * @member {string} targetSslProxy
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest
                         * @instance
                         */
                        SetCertificateMapTargetSslProxyRequest.prototype.targetSslProxy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetCertificateMapTargetSslProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest
                         * @instance
                         */
                        Object.defineProperty(SetCertificateMapTargetSslProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetCertificateMapTargetSslProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetCertificateMapTargetSslProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest} SetCertificateMapTargetSslProxyRequest instance
                         */
                        SetCertificateMapTargetSslProxyRequest.create = function create(properties) {
                            return new SetCertificateMapTargetSslProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetCertificateMapTargetSslProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetCertificateMapTargetSslProxyRequest} message SetCertificateMapTargetSslProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetCertificateMapTargetSslProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetSslProxy != null && Object.hasOwnProperty.call(message, "targetSslProxy"))
                                writer.uint32(/* id 338795853, wireType 2 =*/2710366826).string(message.targetSslProxy);
                            if (message.targetSslProxiesSetCertificateMapRequestResource != null && Object.hasOwnProperty.call(message, "targetSslProxiesSetCertificateMapRequestResource"))
                                $root.google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest.encode(message.targetSslProxiesSetCertificateMapRequestResource, writer.uint32(/* id 343984954, wireType 2 =*/2751879634).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetCertificateMapTargetSslProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetCertificateMapTargetSslProxyRequest} message SetCertificateMapTargetSslProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetCertificateMapTargetSslProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetCertificateMapTargetSslProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest} SetCertificateMapTargetSslProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetCertificateMapTargetSslProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 343984954: {
                                        message.targetSslProxiesSetCertificateMapRequestResource = $root.google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 338795853: {
                                        message.targetSslProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetCertificateMapTargetSslProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest} SetCertificateMapTargetSslProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetCertificateMapTargetSslProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetCertificateMapTargetSslProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetCertificateMapTargetSslProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetSslProxiesSetCertificateMapRequestResource != null && message.hasOwnProperty("targetSslProxiesSetCertificateMapRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest.verify(message.targetSslProxiesSetCertificateMapRequestResource);
                                if (error)
                                    return "targetSslProxiesSetCertificateMapRequestResource." + error;
                            }
                            if (message.targetSslProxy != null && message.hasOwnProperty("targetSslProxy"))
                                if (!$util.isString(message.targetSslProxy))
                                    return "targetSslProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetCertificateMapTargetSslProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest} SetCertificateMapTargetSslProxyRequest
                         */
                        SetCertificateMapTargetSslProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetSslProxiesSetCertificateMapRequestResource != null) {
                                if (typeof object.targetSslProxiesSetCertificateMapRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest.targetSslProxiesSetCertificateMapRequestResource: object expected");
                                message.targetSslProxiesSetCertificateMapRequestResource = $root.google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest.fromObject(object.targetSslProxiesSetCertificateMapRequestResource);
                            }
                            if (object.targetSslProxy != null)
                                message.targetSslProxy = String(object.targetSslProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetCertificateMapTargetSslProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest} message SetCertificateMapTargetSslProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetCertificateMapTargetSslProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.targetSslProxy = "";
                                object.targetSslProxiesSetCertificateMapRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetSslProxy != null && message.hasOwnProperty("targetSslProxy"))
                                object.targetSslProxy = message.targetSslProxy;
                            if (message.targetSslProxiesSetCertificateMapRequestResource != null && message.hasOwnProperty("targetSslProxiesSetCertificateMapRequestResource"))
                                object.targetSslProxiesSetCertificateMapRequestResource = $root.google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest.toObject(message.targetSslProxiesSetCertificateMapRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetCertificateMapTargetSslProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetCertificateMapTargetSslProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetCertificateMapTargetSslProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetCertificateMapTargetSslProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest";
                        };
    
                        return SetCertificateMapTargetSslProxyRequest;
                    })();
    
                    v1.SetCommonInstanceMetadataProjectRequest = (function() {
    
                        /**
                         * Properties of a SetCommonInstanceMetadataProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetCommonInstanceMetadataProjectRequest
                         * @property {google.cloud.compute.v1.IMetadata|null} [metadataResource] SetCommonInstanceMetadataProjectRequest metadataResource
                         * @property {string|null} [project] SetCommonInstanceMetadataProjectRequest project
                         * @property {string|null} [requestId] SetCommonInstanceMetadataProjectRequest requestId
                         */
    
                        /**
                         * Constructs a new SetCommonInstanceMetadataProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetCommonInstanceMetadataProjectRequest.
                         * @implements ISetCommonInstanceMetadataProjectRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetCommonInstanceMetadataProjectRequest=} [properties] Properties to set
                         */
                        function SetCommonInstanceMetadataProjectRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetCommonInstanceMetadataProjectRequest metadataResource.
                         * @member {google.cloud.compute.v1.IMetadata|null|undefined} metadataResource
                         * @memberof google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest
                         * @instance
                         */
                        SetCommonInstanceMetadataProjectRequest.prototype.metadataResource = null;
    
                        /**
                         * SetCommonInstanceMetadataProjectRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest
                         * @instance
                         */
                        SetCommonInstanceMetadataProjectRequest.prototype.project = "";
    
                        /**
                         * SetCommonInstanceMetadataProjectRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest
                         * @instance
                         */
                        SetCommonInstanceMetadataProjectRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetCommonInstanceMetadataProjectRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest
                         * @instance
                         */
                        Object.defineProperty(SetCommonInstanceMetadataProjectRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetCommonInstanceMetadataProjectRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetCommonInstanceMetadataProjectRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest} SetCommonInstanceMetadataProjectRequest instance
                         */
                        SetCommonInstanceMetadataProjectRequest.create = function create(properties) {
                            return new SetCommonInstanceMetadataProjectRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetCommonInstanceMetadataProjectRequest message. Does not implicitly {@link google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetCommonInstanceMetadataProjectRequest} message SetCommonInstanceMetadataProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetCommonInstanceMetadataProjectRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.metadataResource != null && Object.hasOwnProperty.call(message, "metadataResource"))
                                $root.google.cloud.compute.v1.Metadata.encode(message.metadataResource, writer.uint32(/* id 291086110, wireType 2 =*/2328688882).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetCommonInstanceMetadataProjectRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetCommonInstanceMetadataProjectRequest} message SetCommonInstanceMetadataProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetCommonInstanceMetadataProjectRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetCommonInstanceMetadataProjectRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest} SetCommonInstanceMetadataProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetCommonInstanceMetadataProjectRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 291086110: {
                                        message.metadataResource = $root.google.cloud.compute.v1.Metadata.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetCommonInstanceMetadataProjectRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest} SetCommonInstanceMetadataProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetCommonInstanceMetadataProjectRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetCommonInstanceMetadataProjectRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetCommonInstanceMetadataProjectRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.metadataResource != null && message.hasOwnProperty("metadataResource")) {
                                var error = $root.google.cloud.compute.v1.Metadata.verify(message.metadataResource);
                                if (error)
                                    return "metadataResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetCommonInstanceMetadataProjectRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest} SetCommonInstanceMetadataProjectRequest
                         */
                        SetCommonInstanceMetadataProjectRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest();
                            if (object.metadataResource != null) {
                                if (typeof object.metadataResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest.metadataResource: object expected");
                                message.metadataResource = $root.google.cloud.compute.v1.Metadata.fromObject(object.metadataResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetCommonInstanceMetadataProjectRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest} message SetCommonInstanceMetadataProjectRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetCommonInstanceMetadataProjectRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.metadataResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.metadataResource != null && message.hasOwnProperty("metadataResource"))
                                object.metadataResource = $root.google.cloud.compute.v1.Metadata.toObject(message.metadataResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetCommonInstanceMetadataProjectRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetCommonInstanceMetadataProjectRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetCommonInstanceMetadataProjectRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetCommonInstanceMetadataProjectRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest";
                        };
    
                        return SetCommonInstanceMetadataProjectRequest;
                    })();
    
                    v1.SetDefaultNetworkTierProjectRequest = (function() {
    
                        /**
                         * Properties of a SetDefaultNetworkTierProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetDefaultNetworkTierProjectRequest
                         * @property {string|null} [project] SetDefaultNetworkTierProjectRequest project
                         * @property {google.cloud.compute.v1.IProjectsSetDefaultNetworkTierRequest|null} [projectsSetDefaultNetworkTierRequestResource] SetDefaultNetworkTierProjectRequest projectsSetDefaultNetworkTierRequestResource
                         * @property {string|null} [requestId] SetDefaultNetworkTierProjectRequest requestId
                         */
    
                        /**
                         * Constructs a new SetDefaultNetworkTierProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetDefaultNetworkTierProjectRequest.
                         * @implements ISetDefaultNetworkTierProjectRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetDefaultNetworkTierProjectRequest=} [properties] Properties to set
                         */
                        function SetDefaultNetworkTierProjectRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetDefaultNetworkTierProjectRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest
                         * @instance
                         */
                        SetDefaultNetworkTierProjectRequest.prototype.project = "";
    
                        /**
                         * SetDefaultNetworkTierProjectRequest projectsSetDefaultNetworkTierRequestResource.
                         * @member {google.cloud.compute.v1.IProjectsSetDefaultNetworkTierRequest|null|undefined} projectsSetDefaultNetworkTierRequestResource
                         * @memberof google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest
                         * @instance
                         */
                        SetDefaultNetworkTierProjectRequest.prototype.projectsSetDefaultNetworkTierRequestResource = null;
    
                        /**
                         * SetDefaultNetworkTierProjectRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest
                         * @instance
                         */
                        SetDefaultNetworkTierProjectRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetDefaultNetworkTierProjectRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest
                         * @instance
                         */
                        Object.defineProperty(SetDefaultNetworkTierProjectRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetDefaultNetworkTierProjectRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetDefaultNetworkTierProjectRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest} SetDefaultNetworkTierProjectRequest instance
                         */
                        SetDefaultNetworkTierProjectRequest.create = function create(properties) {
                            return new SetDefaultNetworkTierProjectRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetDefaultNetworkTierProjectRequest message. Does not implicitly {@link google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetDefaultNetworkTierProjectRequest} message SetDefaultNetworkTierProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetDefaultNetworkTierProjectRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.projectsSetDefaultNetworkTierRequestResource != null && Object.hasOwnProperty.call(message, "projectsSetDefaultNetworkTierRequestResource"))
                                $root.google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest.encode(message.projectsSetDefaultNetworkTierRequestResource, writer.uint32(/* id 126410762, wireType 2 =*/1011286098).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetDefaultNetworkTierProjectRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetDefaultNetworkTierProjectRequest} message SetDefaultNetworkTierProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetDefaultNetworkTierProjectRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetDefaultNetworkTierProjectRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest} SetDefaultNetworkTierProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetDefaultNetworkTierProjectRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 126410762: {
                                        message.projectsSetDefaultNetworkTierRequestResource = $root.google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetDefaultNetworkTierProjectRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest} SetDefaultNetworkTierProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetDefaultNetworkTierProjectRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetDefaultNetworkTierProjectRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetDefaultNetworkTierProjectRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.projectsSetDefaultNetworkTierRequestResource != null && message.hasOwnProperty("projectsSetDefaultNetworkTierRequestResource")) {
                                var error = $root.google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest.verify(message.projectsSetDefaultNetworkTierRequestResource);
                                if (error)
                                    return "projectsSetDefaultNetworkTierRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetDefaultNetworkTierProjectRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest} SetDefaultNetworkTierProjectRequest
                         */
                        SetDefaultNetworkTierProjectRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.projectsSetDefaultNetworkTierRequestResource != null) {
                                if (typeof object.projectsSetDefaultNetworkTierRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest.projectsSetDefaultNetworkTierRequestResource: object expected");
                                message.projectsSetDefaultNetworkTierRequestResource = $root.google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest.fromObject(object.projectsSetDefaultNetworkTierRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetDefaultNetworkTierProjectRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest} message SetDefaultNetworkTierProjectRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetDefaultNetworkTierProjectRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.projectsSetDefaultNetworkTierRequestResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.projectsSetDefaultNetworkTierRequestResource != null && message.hasOwnProperty("projectsSetDefaultNetworkTierRequestResource"))
                                object.projectsSetDefaultNetworkTierRequestResource = $root.google.cloud.compute.v1.ProjectsSetDefaultNetworkTierRequest.toObject(message.projectsSetDefaultNetworkTierRequestResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this SetDefaultNetworkTierProjectRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetDefaultNetworkTierProjectRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetDefaultNetworkTierProjectRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetDefaultNetworkTierProjectRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest";
                        };
    
                        return SetDefaultNetworkTierProjectRequest;
                    })();
    
                    v1.SetDeletionProtectionInstanceRequest = (function() {
    
                        /**
                         * Properties of a SetDeletionProtectionInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetDeletionProtectionInstanceRequest
                         * @property {boolean|null} [deletionProtection] SetDeletionProtectionInstanceRequest deletionProtection
                         * @property {string|null} [project] SetDeletionProtectionInstanceRequest project
                         * @property {string|null} [requestId] SetDeletionProtectionInstanceRequest requestId
                         * @property {string|null} [resource] SetDeletionProtectionInstanceRequest resource
                         * @property {string|null} [zone] SetDeletionProtectionInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new SetDeletionProtectionInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetDeletionProtectionInstanceRequest.
                         * @implements ISetDeletionProtectionInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetDeletionProtectionInstanceRequest=} [properties] Properties to set
                         */
                        function SetDeletionProtectionInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetDeletionProtectionInstanceRequest deletionProtection.
                         * @member {boolean|null|undefined} deletionProtection
                         * @memberof google.cloud.compute.v1.SetDeletionProtectionInstanceRequest
                         * @instance
                         */
                        SetDeletionProtectionInstanceRequest.prototype.deletionProtection = null;
    
                        /**
                         * SetDeletionProtectionInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetDeletionProtectionInstanceRequest
                         * @instance
                         */
                        SetDeletionProtectionInstanceRequest.prototype.project = "";
    
                        /**
                         * SetDeletionProtectionInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetDeletionProtectionInstanceRequest
                         * @instance
                         */
                        SetDeletionProtectionInstanceRequest.prototype.requestId = null;
    
                        /**
                         * SetDeletionProtectionInstanceRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetDeletionProtectionInstanceRequest
                         * @instance
                         */
                        SetDeletionProtectionInstanceRequest.prototype.resource = "";
    
                        /**
                         * SetDeletionProtectionInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SetDeletionProtectionInstanceRequest
                         * @instance
                         */
                        SetDeletionProtectionInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetDeletionProtectionInstanceRequest _deletionProtection.
                         * @member {"deletionProtection"|undefined} _deletionProtection
                         * @memberof google.cloud.compute.v1.SetDeletionProtectionInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(SetDeletionProtectionInstanceRequest.prototype, "_deletionProtection", {
                            get: $util.oneOfGetter($oneOfFields = ["deletionProtection"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SetDeletionProtectionInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetDeletionProtectionInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(SetDeletionProtectionInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetDeletionProtectionInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetDeletionProtectionInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetDeletionProtectionInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetDeletionProtectionInstanceRequest} SetDeletionProtectionInstanceRequest instance
                         */
                        SetDeletionProtectionInstanceRequest.create = function create(properties) {
                            return new SetDeletionProtectionInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetDeletionProtectionInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.SetDeletionProtectionInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetDeletionProtectionInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetDeletionProtectionInstanceRequest} message SetDeletionProtectionInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetDeletionProtectionInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.deletionProtection != null && Object.hasOwnProperty.call(message, "deletionProtection"))
                                writer.uint32(/* id 458014698, wireType 0 =*/3664117584).bool(message.deletionProtection);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetDeletionProtectionInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetDeletionProtectionInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetDeletionProtectionInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetDeletionProtectionInstanceRequest} message SetDeletionProtectionInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetDeletionProtectionInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetDeletionProtectionInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetDeletionProtectionInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetDeletionProtectionInstanceRequest} SetDeletionProtectionInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetDeletionProtectionInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetDeletionProtectionInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 458014698: {
                                        message.deletionProtection = reader.bool();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetDeletionProtectionInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetDeletionProtectionInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetDeletionProtectionInstanceRequest} SetDeletionProtectionInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetDeletionProtectionInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetDeletionProtectionInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetDeletionProtectionInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetDeletionProtectionInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.deletionProtection != null && message.hasOwnProperty("deletionProtection")) {
                                properties._deletionProtection = 1;
                                if (typeof message.deletionProtection !== "boolean")
                                    return "deletionProtection: boolean expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetDeletionProtectionInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetDeletionProtectionInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetDeletionProtectionInstanceRequest} SetDeletionProtectionInstanceRequest
                         */
                        SetDeletionProtectionInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetDeletionProtectionInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetDeletionProtectionInstanceRequest();
                            if (object.deletionProtection != null)
                                message.deletionProtection = Boolean(object.deletionProtection);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetDeletionProtectionInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetDeletionProtectionInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetDeletionProtectionInstanceRequest} message SetDeletionProtectionInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetDeletionProtectionInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.resource = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.deletionProtection != null && message.hasOwnProperty("deletionProtection")) {
                                object.deletionProtection = message.deletionProtection;
                                if (options.oneofs)
                                    object._deletionProtection = "deletionProtection";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SetDeletionProtectionInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetDeletionProtectionInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetDeletionProtectionInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetDeletionProtectionInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetDeletionProtectionInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetDeletionProtectionInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetDeletionProtectionInstanceRequest";
                        };
    
                        return SetDeletionProtectionInstanceRequest;
                    })();
    
                    v1.SetDiskAutoDeleteInstanceRequest = (function() {
    
                        /**
                         * Properties of a SetDiskAutoDeleteInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetDiskAutoDeleteInstanceRequest
                         * @property {boolean|null} [autoDelete] SetDiskAutoDeleteInstanceRequest autoDelete
                         * @property {string|null} [deviceName] SetDiskAutoDeleteInstanceRequest deviceName
                         * @property {string|null} [instance] SetDiskAutoDeleteInstanceRequest instance
                         * @property {string|null} [project] SetDiskAutoDeleteInstanceRequest project
                         * @property {string|null} [requestId] SetDiskAutoDeleteInstanceRequest requestId
                         * @property {string|null} [zone] SetDiskAutoDeleteInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new SetDiskAutoDeleteInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetDiskAutoDeleteInstanceRequest.
                         * @implements ISetDiskAutoDeleteInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetDiskAutoDeleteInstanceRequest=} [properties] Properties to set
                         */
                        function SetDiskAutoDeleteInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetDiskAutoDeleteInstanceRequest autoDelete.
                         * @member {boolean} autoDelete
                         * @memberof google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest
                         * @instance
                         */
                        SetDiskAutoDeleteInstanceRequest.prototype.autoDelete = false;
    
                        /**
                         * SetDiskAutoDeleteInstanceRequest deviceName.
                         * @member {string} deviceName
                         * @memberof google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest
                         * @instance
                         */
                        SetDiskAutoDeleteInstanceRequest.prototype.deviceName = "";
    
                        /**
                         * SetDiskAutoDeleteInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest
                         * @instance
                         */
                        SetDiskAutoDeleteInstanceRequest.prototype.instance = "";
    
                        /**
                         * SetDiskAutoDeleteInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest
                         * @instance
                         */
                        SetDiskAutoDeleteInstanceRequest.prototype.project = "";
    
                        /**
                         * SetDiskAutoDeleteInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest
                         * @instance
                         */
                        SetDiskAutoDeleteInstanceRequest.prototype.requestId = null;
    
                        /**
                         * SetDiskAutoDeleteInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest
                         * @instance
                         */
                        SetDiskAutoDeleteInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetDiskAutoDeleteInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(SetDiskAutoDeleteInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetDiskAutoDeleteInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetDiskAutoDeleteInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest} SetDiskAutoDeleteInstanceRequest instance
                         */
                        SetDiskAutoDeleteInstanceRequest.create = function create(properties) {
                            return new SetDiskAutoDeleteInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetDiskAutoDeleteInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetDiskAutoDeleteInstanceRequest} message SetDiskAutoDeleteInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetDiskAutoDeleteInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.deviceName != null && Object.hasOwnProperty.call(message, "deviceName"))
                                writer.uint32(/* id 67541716, wireType 2 =*/540333730).string(message.deviceName);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.autoDelete != null && Object.hasOwnProperty.call(message, "autoDelete"))
                                writer.uint32(/* id 464761403, wireType 0 =*/3718091224).bool(message.autoDelete);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetDiskAutoDeleteInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetDiskAutoDeleteInstanceRequest} message SetDiskAutoDeleteInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetDiskAutoDeleteInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetDiskAutoDeleteInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest} SetDiskAutoDeleteInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetDiskAutoDeleteInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 464761403: {
                                        message.autoDelete = reader.bool();
                                        break;
                                    }
                                case 67541716: {
                                        message.deviceName = reader.string();
                                        break;
                                    }
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetDiskAutoDeleteInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest} SetDiskAutoDeleteInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetDiskAutoDeleteInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetDiskAutoDeleteInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetDiskAutoDeleteInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoDelete != null && message.hasOwnProperty("autoDelete"))
                                if (typeof message.autoDelete !== "boolean")
                                    return "autoDelete: boolean expected";
                            if (message.deviceName != null && message.hasOwnProperty("deviceName"))
                                if (!$util.isString(message.deviceName))
                                    return "deviceName: string expected";
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetDiskAutoDeleteInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest} SetDiskAutoDeleteInstanceRequest
                         */
                        SetDiskAutoDeleteInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest();
                            if (object.autoDelete != null)
                                message.autoDelete = Boolean(object.autoDelete);
                            if (object.deviceName != null)
                                message.deviceName = String(object.deviceName);
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetDiskAutoDeleteInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest} message SetDiskAutoDeleteInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetDiskAutoDeleteInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.deviceName = "";
                                object.project = "";
                                object.autoDelete = false;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.deviceName != null && message.hasOwnProperty("deviceName"))
                                object.deviceName = message.deviceName;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.autoDelete != null && message.hasOwnProperty("autoDelete"))
                                object.autoDelete = message.autoDelete;
                            return object;
                        };
    
                        /**
                         * Converts this SetDiskAutoDeleteInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetDiskAutoDeleteInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetDiskAutoDeleteInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetDiskAutoDeleteInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest";
                        };
    
                        return SetDiskAutoDeleteInstanceRequest;
                    })();
    
                    v1.SetEdgeSecurityPolicyBackendBucketRequest = (function() {
    
                        /**
                         * Properties of a SetEdgeSecurityPolicyBackendBucketRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetEdgeSecurityPolicyBackendBucketRequest
                         * @property {string|null} [backendBucket] SetEdgeSecurityPolicyBackendBucketRequest backendBucket
                         * @property {string|null} [project] SetEdgeSecurityPolicyBackendBucketRequest project
                         * @property {string|null} [requestId] SetEdgeSecurityPolicyBackendBucketRequest requestId
                         * @property {google.cloud.compute.v1.ISecurityPolicyReference|null} [securityPolicyReferenceResource] SetEdgeSecurityPolicyBackendBucketRequest securityPolicyReferenceResource
                         */
    
                        /**
                         * Constructs a new SetEdgeSecurityPolicyBackendBucketRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetEdgeSecurityPolicyBackendBucketRequest.
                         * @implements ISetEdgeSecurityPolicyBackendBucketRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetEdgeSecurityPolicyBackendBucketRequest=} [properties] Properties to set
                         */
                        function SetEdgeSecurityPolicyBackendBucketRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetEdgeSecurityPolicyBackendBucketRequest backendBucket.
                         * @member {string} backendBucket
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest
                         * @instance
                         */
                        SetEdgeSecurityPolicyBackendBucketRequest.prototype.backendBucket = "";
    
                        /**
                         * SetEdgeSecurityPolicyBackendBucketRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest
                         * @instance
                         */
                        SetEdgeSecurityPolicyBackendBucketRequest.prototype.project = "";
    
                        /**
                         * SetEdgeSecurityPolicyBackendBucketRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest
                         * @instance
                         */
                        SetEdgeSecurityPolicyBackendBucketRequest.prototype.requestId = null;
    
                        /**
                         * SetEdgeSecurityPolicyBackendBucketRequest securityPolicyReferenceResource.
                         * @member {google.cloud.compute.v1.ISecurityPolicyReference|null|undefined} securityPolicyReferenceResource
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest
                         * @instance
                         */
                        SetEdgeSecurityPolicyBackendBucketRequest.prototype.securityPolicyReferenceResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetEdgeSecurityPolicyBackendBucketRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest
                         * @instance
                         */
                        Object.defineProperty(SetEdgeSecurityPolicyBackendBucketRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetEdgeSecurityPolicyBackendBucketRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetEdgeSecurityPolicyBackendBucketRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest} SetEdgeSecurityPolicyBackendBucketRequest instance
                         */
                        SetEdgeSecurityPolicyBackendBucketRequest.create = function create(properties) {
                            return new SetEdgeSecurityPolicyBackendBucketRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetEdgeSecurityPolicyBackendBucketRequest message. Does not implicitly {@link google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetEdgeSecurityPolicyBackendBucketRequest} message SetEdgeSecurityPolicyBackendBucketRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetEdgeSecurityPolicyBackendBucketRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.backendBucket != null && Object.hasOwnProperty.call(message, "backendBucket"))
                                writer.uint32(/* id 91714037, wireType 2 =*/733712298).string(message.backendBucket);
                            if (message.securityPolicyReferenceResource != null && Object.hasOwnProperty.call(message, "securityPolicyReferenceResource"))
                                $root.google.cloud.compute.v1.SecurityPolicyReference.encode(message.securityPolicyReferenceResource, writer.uint32(/* id 204135024, wireType 2 =*/1633080194).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetEdgeSecurityPolicyBackendBucketRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetEdgeSecurityPolicyBackendBucketRequest} message SetEdgeSecurityPolicyBackendBucketRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetEdgeSecurityPolicyBackendBucketRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetEdgeSecurityPolicyBackendBucketRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest} SetEdgeSecurityPolicyBackendBucketRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetEdgeSecurityPolicyBackendBucketRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 91714037: {
                                        message.backendBucket = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 204135024: {
                                        message.securityPolicyReferenceResource = $root.google.cloud.compute.v1.SecurityPolicyReference.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetEdgeSecurityPolicyBackendBucketRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest} SetEdgeSecurityPolicyBackendBucketRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetEdgeSecurityPolicyBackendBucketRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetEdgeSecurityPolicyBackendBucketRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetEdgeSecurityPolicyBackendBucketRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendBucket != null && message.hasOwnProperty("backendBucket"))
                                if (!$util.isString(message.backendBucket))
                                    return "backendBucket: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.securityPolicyReferenceResource != null && message.hasOwnProperty("securityPolicyReferenceResource")) {
                                var error = $root.google.cloud.compute.v1.SecurityPolicyReference.verify(message.securityPolicyReferenceResource);
                                if (error)
                                    return "securityPolicyReferenceResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetEdgeSecurityPolicyBackendBucketRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest} SetEdgeSecurityPolicyBackendBucketRequest
                         */
                        SetEdgeSecurityPolicyBackendBucketRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest();
                            if (object.backendBucket != null)
                                message.backendBucket = String(object.backendBucket);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.securityPolicyReferenceResource != null) {
                                if (typeof object.securityPolicyReferenceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest.securityPolicyReferenceResource: object expected");
                                message.securityPolicyReferenceResource = $root.google.cloud.compute.v1.SecurityPolicyReference.fromObject(object.securityPolicyReferenceResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetEdgeSecurityPolicyBackendBucketRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest} message SetEdgeSecurityPolicyBackendBucketRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetEdgeSecurityPolicyBackendBucketRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.backendBucket = "";
                                object.securityPolicyReferenceResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.backendBucket != null && message.hasOwnProperty("backendBucket"))
                                object.backendBucket = message.backendBucket;
                            if (message.securityPolicyReferenceResource != null && message.hasOwnProperty("securityPolicyReferenceResource"))
                                object.securityPolicyReferenceResource = $root.google.cloud.compute.v1.SecurityPolicyReference.toObject(message.securityPolicyReferenceResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this SetEdgeSecurityPolicyBackendBucketRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetEdgeSecurityPolicyBackendBucketRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetEdgeSecurityPolicyBackendBucketRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetEdgeSecurityPolicyBackendBucketRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest";
                        };
    
                        return SetEdgeSecurityPolicyBackendBucketRequest;
                    })();
    
                    v1.SetEdgeSecurityPolicyBackendServiceRequest = (function() {
    
                        /**
                         * Properties of a SetEdgeSecurityPolicyBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetEdgeSecurityPolicyBackendServiceRequest
                         * @property {string|null} [backendService] SetEdgeSecurityPolicyBackendServiceRequest backendService
                         * @property {string|null} [project] SetEdgeSecurityPolicyBackendServiceRequest project
                         * @property {string|null} [requestId] SetEdgeSecurityPolicyBackendServiceRequest requestId
                         * @property {google.cloud.compute.v1.ISecurityPolicyReference|null} [securityPolicyReferenceResource] SetEdgeSecurityPolicyBackendServiceRequest securityPolicyReferenceResource
                         */
    
                        /**
                         * Constructs a new SetEdgeSecurityPolicyBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetEdgeSecurityPolicyBackendServiceRequest.
                         * @implements ISetEdgeSecurityPolicyBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetEdgeSecurityPolicyBackendServiceRequest=} [properties] Properties to set
                         */
                        function SetEdgeSecurityPolicyBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetEdgeSecurityPolicyBackendServiceRequest backendService.
                         * @member {string} backendService
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest
                         * @instance
                         */
                        SetEdgeSecurityPolicyBackendServiceRequest.prototype.backendService = "";
    
                        /**
                         * SetEdgeSecurityPolicyBackendServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest
                         * @instance
                         */
                        SetEdgeSecurityPolicyBackendServiceRequest.prototype.project = "";
    
                        /**
                         * SetEdgeSecurityPolicyBackendServiceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest
                         * @instance
                         */
                        SetEdgeSecurityPolicyBackendServiceRequest.prototype.requestId = null;
    
                        /**
                         * SetEdgeSecurityPolicyBackendServiceRequest securityPolicyReferenceResource.
                         * @member {google.cloud.compute.v1.ISecurityPolicyReference|null|undefined} securityPolicyReferenceResource
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest
                         * @instance
                         */
                        SetEdgeSecurityPolicyBackendServiceRequest.prototype.securityPolicyReferenceResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetEdgeSecurityPolicyBackendServiceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest
                         * @instance
                         */
                        Object.defineProperty(SetEdgeSecurityPolicyBackendServiceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetEdgeSecurityPolicyBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetEdgeSecurityPolicyBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest} SetEdgeSecurityPolicyBackendServiceRequest instance
                         */
                        SetEdgeSecurityPolicyBackendServiceRequest.create = function create(properties) {
                            return new SetEdgeSecurityPolicyBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetEdgeSecurityPolicyBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetEdgeSecurityPolicyBackendServiceRequest} message SetEdgeSecurityPolicyBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetEdgeSecurityPolicyBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.securityPolicyReferenceResource != null && Object.hasOwnProperty.call(message, "securityPolicyReferenceResource"))
                                $root.google.cloud.compute.v1.SecurityPolicyReference.encode(message.securityPolicyReferenceResource, writer.uint32(/* id 204135024, wireType 2 =*/1633080194).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.backendService != null && Object.hasOwnProperty.call(message, "backendService"))
                                writer.uint32(/* id 306946058, wireType 2 =*/2455568466).string(message.backendService);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetEdgeSecurityPolicyBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetEdgeSecurityPolicyBackendServiceRequest} message SetEdgeSecurityPolicyBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetEdgeSecurityPolicyBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetEdgeSecurityPolicyBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest} SetEdgeSecurityPolicyBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetEdgeSecurityPolicyBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 306946058: {
                                        message.backendService = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 204135024: {
                                        message.securityPolicyReferenceResource = $root.google.cloud.compute.v1.SecurityPolicyReference.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetEdgeSecurityPolicyBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest} SetEdgeSecurityPolicyBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetEdgeSecurityPolicyBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetEdgeSecurityPolicyBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetEdgeSecurityPolicyBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                if (!$util.isString(message.backendService))
                                    return "backendService: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.securityPolicyReferenceResource != null && message.hasOwnProperty("securityPolicyReferenceResource")) {
                                var error = $root.google.cloud.compute.v1.SecurityPolicyReference.verify(message.securityPolicyReferenceResource);
                                if (error)
                                    return "securityPolicyReferenceResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetEdgeSecurityPolicyBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest} SetEdgeSecurityPolicyBackendServiceRequest
                         */
                        SetEdgeSecurityPolicyBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest();
                            if (object.backendService != null)
                                message.backendService = String(object.backendService);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.securityPolicyReferenceResource != null) {
                                if (typeof object.securityPolicyReferenceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest.securityPolicyReferenceResource: object expected");
                                message.securityPolicyReferenceResource = $root.google.cloud.compute.v1.SecurityPolicyReference.fromObject(object.securityPolicyReferenceResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetEdgeSecurityPolicyBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest} message SetEdgeSecurityPolicyBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetEdgeSecurityPolicyBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.securityPolicyReferenceResource = null;
                                object.project = "";
                                object.backendService = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.securityPolicyReferenceResource != null && message.hasOwnProperty("securityPolicyReferenceResource"))
                                object.securityPolicyReferenceResource = $root.google.cloud.compute.v1.SecurityPolicyReference.toObject(message.securityPolicyReferenceResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                object.backendService = message.backendService;
                            return object;
                        };
    
                        /**
                         * Converts this SetEdgeSecurityPolicyBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetEdgeSecurityPolicyBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetEdgeSecurityPolicyBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetEdgeSecurityPolicyBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest";
                        };
    
                        return SetEdgeSecurityPolicyBackendServiceRequest;
                    })();
    
                    v1.SetIamPolicyBackendServiceRequest = (function() {
    
                        /**
                         * Properties of a SetIamPolicyBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetIamPolicyBackendServiceRequest
                         * @property {google.cloud.compute.v1.IGlobalSetPolicyRequest|null} [globalSetPolicyRequestResource] SetIamPolicyBackendServiceRequest globalSetPolicyRequestResource
                         * @property {string|null} [project] SetIamPolicyBackendServiceRequest project
                         * @property {string|null} [resource] SetIamPolicyBackendServiceRequest resource
                         */
    
                        /**
                         * Constructs a new SetIamPolicyBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetIamPolicyBackendServiceRequest.
                         * @implements ISetIamPolicyBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetIamPolicyBackendServiceRequest=} [properties] Properties to set
                         */
                        function SetIamPolicyBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetIamPolicyBackendServiceRequest globalSetPolicyRequestResource.
                         * @member {google.cloud.compute.v1.IGlobalSetPolicyRequest|null|undefined} globalSetPolicyRequestResource
                         * @memberof google.cloud.compute.v1.SetIamPolicyBackendServiceRequest
                         * @instance
                         */
                        SetIamPolicyBackendServiceRequest.prototype.globalSetPolicyRequestResource = null;
    
                        /**
                         * SetIamPolicyBackendServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetIamPolicyBackendServiceRequest
                         * @instance
                         */
                        SetIamPolicyBackendServiceRequest.prototype.project = "";
    
                        /**
                         * SetIamPolicyBackendServiceRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetIamPolicyBackendServiceRequest
                         * @instance
                         */
                        SetIamPolicyBackendServiceRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetIamPolicyBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetIamPolicyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetIamPolicyBackendServiceRequest} SetIamPolicyBackendServiceRequest instance
                         */
                        SetIamPolicyBackendServiceRequest.create = function create(properties) {
                            return new SetIamPolicyBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetIamPolicyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyBackendServiceRequest} message SetIamPolicyBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.globalSetPolicyRequestResource != null && Object.hasOwnProperty.call(message, "globalSetPolicyRequestResource"))
                                $root.google.cloud.compute.v1.GlobalSetPolicyRequest.encode(message.globalSetPolicyRequestResource, writer.uint32(/* id 337048498, wireType 2 =*/2696387986).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyBackendServiceRequest} message SetIamPolicyBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetIamPolicyBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetIamPolicyBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetIamPolicyBackendServiceRequest} SetIamPolicyBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetIamPolicyBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 337048498: {
                                        message.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetIamPolicyBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetIamPolicyBackendServiceRequest} SetIamPolicyBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetIamPolicyBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetIamPolicyBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetIamPolicyBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.globalSetPolicyRequestResource != null && message.hasOwnProperty("globalSetPolicyRequestResource")) {
                                var error = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.verify(message.globalSetPolicyRequestResource);
                                if (error)
                                    return "globalSetPolicyRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetIamPolicyBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetIamPolicyBackendServiceRequest} SetIamPolicyBackendServiceRequest
                         */
                        SetIamPolicyBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetIamPolicyBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetIamPolicyBackendServiceRequest();
                            if (object.globalSetPolicyRequestResource != null) {
                                if (typeof object.globalSetPolicyRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetIamPolicyBackendServiceRequest.globalSetPolicyRequestResource: object expected");
                                message.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.fromObject(object.globalSetPolicyRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetIamPolicyBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetIamPolicyBackendServiceRequest} message SetIamPolicyBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetIamPolicyBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.globalSetPolicyRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.globalSetPolicyRequestResource != null && message.hasOwnProperty("globalSetPolicyRequestResource"))
                                object.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.toObject(message.globalSetPolicyRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetIamPolicyBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetIamPolicyBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetIamPolicyBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetIamPolicyBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetIamPolicyBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetIamPolicyBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetIamPolicyBackendServiceRequest";
                        };
    
                        return SetIamPolicyBackendServiceRequest;
                    })();
    
                    v1.SetIamPolicyDiskRequest = (function() {
    
                        /**
                         * Properties of a SetIamPolicyDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetIamPolicyDiskRequest
                         * @property {string|null} [project] SetIamPolicyDiskRequest project
                         * @property {string|null} [resource] SetIamPolicyDiskRequest resource
                         * @property {string|null} [zone] SetIamPolicyDiskRequest zone
                         * @property {google.cloud.compute.v1.IZoneSetPolicyRequest|null} [zoneSetPolicyRequestResource] SetIamPolicyDiskRequest zoneSetPolicyRequestResource
                         */
    
                        /**
                         * Constructs a new SetIamPolicyDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetIamPolicyDiskRequest.
                         * @implements ISetIamPolicyDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetIamPolicyDiskRequest=} [properties] Properties to set
                         */
                        function SetIamPolicyDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetIamPolicyDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetIamPolicyDiskRequest
                         * @instance
                         */
                        SetIamPolicyDiskRequest.prototype.project = "";
    
                        /**
                         * SetIamPolicyDiskRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetIamPolicyDiskRequest
                         * @instance
                         */
                        SetIamPolicyDiskRequest.prototype.resource = "";
    
                        /**
                         * SetIamPolicyDiskRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SetIamPolicyDiskRequest
                         * @instance
                         */
                        SetIamPolicyDiskRequest.prototype.zone = "";
    
                        /**
                         * SetIamPolicyDiskRequest zoneSetPolicyRequestResource.
                         * @member {google.cloud.compute.v1.IZoneSetPolicyRequest|null|undefined} zoneSetPolicyRequestResource
                         * @memberof google.cloud.compute.v1.SetIamPolicyDiskRequest
                         * @instance
                         */
                        SetIamPolicyDiskRequest.prototype.zoneSetPolicyRequestResource = null;
    
                        /**
                         * Creates a new SetIamPolicyDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetIamPolicyDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetIamPolicyDiskRequest} SetIamPolicyDiskRequest instance
                         */
                        SetIamPolicyDiskRequest.create = function create(properties) {
                            return new SetIamPolicyDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetIamPolicyDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyDiskRequest} message SetIamPolicyDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.zoneSetPolicyRequestResource != null && Object.hasOwnProperty.call(message, "zoneSetPolicyRequestResource"))
                                $root.google.cloud.compute.v1.ZoneSetPolicyRequest.encode(message.zoneSetPolicyRequestResource, writer.uint32(/* id 382082107, wireType 2 =*/3056656858).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyDiskRequest} message SetIamPolicyDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetIamPolicyDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetIamPolicyDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetIamPolicyDiskRequest} SetIamPolicyDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetIamPolicyDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                case 382082107: {
                                        message.zoneSetPolicyRequestResource = $root.google.cloud.compute.v1.ZoneSetPolicyRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetIamPolicyDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetIamPolicyDiskRequest} SetIamPolicyDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetIamPolicyDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetIamPolicyDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetIamPolicyDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            if (message.zoneSetPolicyRequestResource != null && message.hasOwnProperty("zoneSetPolicyRequestResource")) {
                                var error = $root.google.cloud.compute.v1.ZoneSetPolicyRequest.verify(message.zoneSetPolicyRequestResource);
                                if (error)
                                    return "zoneSetPolicyRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetIamPolicyDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetIamPolicyDiskRequest} SetIamPolicyDiskRequest
                         */
                        SetIamPolicyDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetIamPolicyDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetIamPolicyDiskRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            if (object.zoneSetPolicyRequestResource != null) {
                                if (typeof object.zoneSetPolicyRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetIamPolicyDiskRequest.zoneSetPolicyRequestResource: object expected");
                                message.zoneSetPolicyRequestResource = $root.google.cloud.compute.v1.ZoneSetPolicyRequest.fromObject(object.zoneSetPolicyRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetIamPolicyDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetIamPolicyDiskRequest} message SetIamPolicyDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetIamPolicyDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.resource = "";
                                object.project = "";
                                object.zoneSetPolicyRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.zoneSetPolicyRequestResource != null && message.hasOwnProperty("zoneSetPolicyRequestResource"))
                                object.zoneSetPolicyRequestResource = $root.google.cloud.compute.v1.ZoneSetPolicyRequest.toObject(message.zoneSetPolicyRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetIamPolicyDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetIamPolicyDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetIamPolicyDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetIamPolicyDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetIamPolicyDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetIamPolicyDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetIamPolicyDiskRequest";
                        };
    
                        return SetIamPolicyDiskRequest;
                    })();
    
                    v1.SetIamPolicyFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a SetIamPolicyFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetIamPolicyFirewallPolicyRequest
                         * @property {google.cloud.compute.v1.IGlobalOrganizationSetPolicyRequest|null} [globalOrganizationSetPolicyRequestResource] SetIamPolicyFirewallPolicyRequest globalOrganizationSetPolicyRequestResource
                         * @property {string|null} [resource] SetIamPolicyFirewallPolicyRequest resource
                         */
    
                        /**
                         * Constructs a new SetIamPolicyFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetIamPolicyFirewallPolicyRequest.
                         * @implements ISetIamPolicyFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetIamPolicyFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function SetIamPolicyFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetIamPolicyFirewallPolicyRequest globalOrganizationSetPolicyRequestResource.
                         * @member {google.cloud.compute.v1.IGlobalOrganizationSetPolicyRequest|null|undefined} globalOrganizationSetPolicyRequestResource
                         * @memberof google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest
                         * @instance
                         */
                        SetIamPolicyFirewallPolicyRequest.prototype.globalOrganizationSetPolicyRequestResource = null;
    
                        /**
                         * SetIamPolicyFirewallPolicyRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest
                         * @instance
                         */
                        SetIamPolicyFirewallPolicyRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetIamPolicyFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest} SetIamPolicyFirewallPolicyRequest instance
                         */
                        SetIamPolicyFirewallPolicyRequest.create = function create(properties) {
                            return new SetIamPolicyFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyFirewallPolicyRequest} message SetIamPolicyFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.globalOrganizationSetPolicyRequestResource != null && Object.hasOwnProperty.call(message, "globalOrganizationSetPolicyRequestResource"))
                                $root.google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest.encode(message.globalOrganizationSetPolicyRequestResource, writer.uint32(/* id 177408606, wireType 2 =*/1419268850).fork()).ldelim();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyFirewallPolicyRequest} message SetIamPolicyFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetIamPolicyFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest} SetIamPolicyFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 177408606: {
                                        message.globalOrganizationSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetIamPolicyFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest} SetIamPolicyFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetIamPolicyFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetIamPolicyFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.globalOrganizationSetPolicyRequestResource != null && message.hasOwnProperty("globalOrganizationSetPolicyRequestResource")) {
                                var error = $root.google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest.verify(message.globalOrganizationSetPolicyRequestResource);
                                if (error)
                                    return "globalOrganizationSetPolicyRequestResource." + error;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetIamPolicyFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest} SetIamPolicyFirewallPolicyRequest
                         */
                        SetIamPolicyFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest();
                            if (object.globalOrganizationSetPolicyRequestResource != null) {
                                if (typeof object.globalOrganizationSetPolicyRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest.globalOrganizationSetPolicyRequestResource: object expected");
                                message.globalOrganizationSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest.fromObject(object.globalOrganizationSetPolicyRequestResource);
                            }
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetIamPolicyFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest} message SetIamPolicyFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetIamPolicyFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.globalOrganizationSetPolicyRequestResource = null;
                                object.resource = "";
                            }
                            if (message.globalOrganizationSetPolicyRequestResource != null && message.hasOwnProperty("globalOrganizationSetPolicyRequestResource"))
                                object.globalOrganizationSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalOrganizationSetPolicyRequest.toObject(message.globalOrganizationSetPolicyRequestResource, options);
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            return object;
                        };
    
                        /**
                         * Converts this SetIamPolicyFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetIamPolicyFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetIamPolicyFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetIamPolicyFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest";
                        };
    
                        return SetIamPolicyFirewallPolicyRequest;
                    })();
    
                    v1.SetIamPolicyImageRequest = (function() {
    
                        /**
                         * Properties of a SetIamPolicyImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetIamPolicyImageRequest
                         * @property {google.cloud.compute.v1.IGlobalSetPolicyRequest|null} [globalSetPolicyRequestResource] SetIamPolicyImageRequest globalSetPolicyRequestResource
                         * @property {string|null} [project] SetIamPolicyImageRequest project
                         * @property {string|null} [resource] SetIamPolicyImageRequest resource
                         */
    
                        /**
                         * Constructs a new SetIamPolicyImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetIamPolicyImageRequest.
                         * @implements ISetIamPolicyImageRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetIamPolicyImageRequest=} [properties] Properties to set
                         */
                        function SetIamPolicyImageRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetIamPolicyImageRequest globalSetPolicyRequestResource.
                         * @member {google.cloud.compute.v1.IGlobalSetPolicyRequest|null|undefined} globalSetPolicyRequestResource
                         * @memberof google.cloud.compute.v1.SetIamPolicyImageRequest
                         * @instance
                         */
                        SetIamPolicyImageRequest.prototype.globalSetPolicyRequestResource = null;
    
                        /**
                         * SetIamPolicyImageRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetIamPolicyImageRequest
                         * @instance
                         */
                        SetIamPolicyImageRequest.prototype.project = "";
    
                        /**
                         * SetIamPolicyImageRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetIamPolicyImageRequest
                         * @instance
                         */
                        SetIamPolicyImageRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetIamPolicyImageRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetIamPolicyImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyImageRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetIamPolicyImageRequest} SetIamPolicyImageRequest instance
                         */
                        SetIamPolicyImageRequest.create = function create(properties) {
                            return new SetIamPolicyImageRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyImageRequest message. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyImageRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetIamPolicyImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyImageRequest} message SetIamPolicyImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyImageRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.globalSetPolicyRequestResource != null && Object.hasOwnProperty.call(message, "globalSetPolicyRequestResource"))
                                $root.google.cloud.compute.v1.GlobalSetPolicyRequest.encode(message.globalSetPolicyRequestResource, writer.uint32(/* id 337048498, wireType 2 =*/2696387986).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyImageRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyImageRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyImageRequest} message SetIamPolicyImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyImageRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetIamPolicyImageRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetIamPolicyImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetIamPolicyImageRequest} SetIamPolicyImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyImageRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetIamPolicyImageRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 337048498: {
                                        message.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetIamPolicyImageRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetIamPolicyImageRequest} SetIamPolicyImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyImageRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetIamPolicyImageRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetIamPolicyImageRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetIamPolicyImageRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.globalSetPolicyRequestResource != null && message.hasOwnProperty("globalSetPolicyRequestResource")) {
                                var error = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.verify(message.globalSetPolicyRequestResource);
                                if (error)
                                    return "globalSetPolicyRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetIamPolicyImageRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyImageRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetIamPolicyImageRequest} SetIamPolicyImageRequest
                         */
                        SetIamPolicyImageRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetIamPolicyImageRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetIamPolicyImageRequest();
                            if (object.globalSetPolicyRequestResource != null) {
                                if (typeof object.globalSetPolicyRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetIamPolicyImageRequest.globalSetPolicyRequestResource: object expected");
                                message.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.fromObject(object.globalSetPolicyRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetIamPolicyImageRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetIamPolicyImageRequest} message SetIamPolicyImageRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetIamPolicyImageRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.globalSetPolicyRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.globalSetPolicyRequestResource != null && message.hasOwnProperty("globalSetPolicyRequestResource"))
                                object.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.toObject(message.globalSetPolicyRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetIamPolicyImageRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetIamPolicyImageRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetIamPolicyImageRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetIamPolicyImageRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetIamPolicyImageRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetIamPolicyImageRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetIamPolicyImageRequest";
                        };
    
                        return SetIamPolicyImageRequest;
                    })();
    
                    v1.SetIamPolicyInstanceRequest = (function() {
    
                        /**
                         * Properties of a SetIamPolicyInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetIamPolicyInstanceRequest
                         * @property {string|null} [project] SetIamPolicyInstanceRequest project
                         * @property {string|null} [resource] SetIamPolicyInstanceRequest resource
                         * @property {string|null} [zone] SetIamPolicyInstanceRequest zone
                         * @property {google.cloud.compute.v1.IZoneSetPolicyRequest|null} [zoneSetPolicyRequestResource] SetIamPolicyInstanceRequest zoneSetPolicyRequestResource
                         */
    
                        /**
                         * Constructs a new SetIamPolicyInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetIamPolicyInstanceRequest.
                         * @implements ISetIamPolicyInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetIamPolicyInstanceRequest=} [properties] Properties to set
                         */
                        function SetIamPolicyInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetIamPolicyInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceRequest
                         * @instance
                         */
                        SetIamPolicyInstanceRequest.prototype.project = "";
    
                        /**
                         * SetIamPolicyInstanceRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceRequest
                         * @instance
                         */
                        SetIamPolicyInstanceRequest.prototype.resource = "";
    
                        /**
                         * SetIamPolicyInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceRequest
                         * @instance
                         */
                        SetIamPolicyInstanceRequest.prototype.zone = "";
    
                        /**
                         * SetIamPolicyInstanceRequest zoneSetPolicyRequestResource.
                         * @member {google.cloud.compute.v1.IZoneSetPolicyRequest|null|undefined} zoneSetPolicyRequestResource
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceRequest
                         * @instance
                         */
                        SetIamPolicyInstanceRequest.prototype.zoneSetPolicyRequestResource = null;
    
                        /**
                         * Creates a new SetIamPolicyInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetIamPolicyInstanceRequest} SetIamPolicyInstanceRequest instance
                         */
                        SetIamPolicyInstanceRequest.create = function create(properties) {
                            return new SetIamPolicyInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyInstanceRequest} message SetIamPolicyInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.zoneSetPolicyRequestResource != null && Object.hasOwnProperty.call(message, "zoneSetPolicyRequestResource"))
                                $root.google.cloud.compute.v1.ZoneSetPolicyRequest.encode(message.zoneSetPolicyRequestResource, writer.uint32(/* id 382082107, wireType 2 =*/3056656858).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyInstanceRequest} message SetIamPolicyInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetIamPolicyInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetIamPolicyInstanceRequest} SetIamPolicyInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetIamPolicyInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                case 382082107: {
                                        message.zoneSetPolicyRequestResource = $root.google.cloud.compute.v1.ZoneSetPolicyRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetIamPolicyInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetIamPolicyInstanceRequest} SetIamPolicyInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetIamPolicyInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetIamPolicyInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            if (message.zoneSetPolicyRequestResource != null && message.hasOwnProperty("zoneSetPolicyRequestResource")) {
                                var error = $root.google.cloud.compute.v1.ZoneSetPolicyRequest.verify(message.zoneSetPolicyRequestResource);
                                if (error)
                                    return "zoneSetPolicyRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetIamPolicyInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetIamPolicyInstanceRequest} SetIamPolicyInstanceRequest
                         */
                        SetIamPolicyInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetIamPolicyInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetIamPolicyInstanceRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            if (object.zoneSetPolicyRequestResource != null) {
                                if (typeof object.zoneSetPolicyRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetIamPolicyInstanceRequest.zoneSetPolicyRequestResource: object expected");
                                message.zoneSetPolicyRequestResource = $root.google.cloud.compute.v1.ZoneSetPolicyRequest.fromObject(object.zoneSetPolicyRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetIamPolicyInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetIamPolicyInstanceRequest} message SetIamPolicyInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetIamPolicyInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.resource = "";
                                object.project = "";
                                object.zoneSetPolicyRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.zoneSetPolicyRequestResource != null && message.hasOwnProperty("zoneSetPolicyRequestResource"))
                                object.zoneSetPolicyRequestResource = $root.google.cloud.compute.v1.ZoneSetPolicyRequest.toObject(message.zoneSetPolicyRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetIamPolicyInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetIamPolicyInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetIamPolicyInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetIamPolicyInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetIamPolicyInstanceRequest";
                        };
    
                        return SetIamPolicyInstanceRequest;
                    })();
    
                    v1.SetIamPolicyInstanceTemplateRequest = (function() {
    
                        /**
                         * Properties of a SetIamPolicyInstanceTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetIamPolicyInstanceTemplateRequest
                         * @property {google.cloud.compute.v1.IGlobalSetPolicyRequest|null} [globalSetPolicyRequestResource] SetIamPolicyInstanceTemplateRequest globalSetPolicyRequestResource
                         * @property {string|null} [project] SetIamPolicyInstanceTemplateRequest project
                         * @property {string|null} [resource] SetIamPolicyInstanceTemplateRequest resource
                         */
    
                        /**
                         * Constructs a new SetIamPolicyInstanceTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetIamPolicyInstanceTemplateRequest.
                         * @implements ISetIamPolicyInstanceTemplateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetIamPolicyInstanceTemplateRequest=} [properties] Properties to set
                         */
                        function SetIamPolicyInstanceTemplateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetIamPolicyInstanceTemplateRequest globalSetPolicyRequestResource.
                         * @member {google.cloud.compute.v1.IGlobalSetPolicyRequest|null|undefined} globalSetPolicyRequestResource
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest
                         * @instance
                         */
                        SetIamPolicyInstanceTemplateRequest.prototype.globalSetPolicyRequestResource = null;
    
                        /**
                         * SetIamPolicyInstanceTemplateRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest
                         * @instance
                         */
                        SetIamPolicyInstanceTemplateRequest.prototype.project = "";
    
                        /**
                         * SetIamPolicyInstanceTemplateRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest
                         * @instance
                         */
                        SetIamPolicyInstanceTemplateRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetIamPolicyInstanceTemplateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyInstanceTemplateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest} SetIamPolicyInstanceTemplateRequest instance
                         */
                        SetIamPolicyInstanceTemplateRequest.create = function create(properties) {
                            return new SetIamPolicyInstanceTemplateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyInstanceTemplateRequest message. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyInstanceTemplateRequest} message SetIamPolicyInstanceTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyInstanceTemplateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.globalSetPolicyRequestResource != null && Object.hasOwnProperty.call(message, "globalSetPolicyRequestResource"))
                                $root.google.cloud.compute.v1.GlobalSetPolicyRequest.encode(message.globalSetPolicyRequestResource, writer.uint32(/* id 337048498, wireType 2 =*/2696387986).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyInstanceTemplateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyInstanceTemplateRequest} message SetIamPolicyInstanceTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyInstanceTemplateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetIamPolicyInstanceTemplateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest} SetIamPolicyInstanceTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyInstanceTemplateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 337048498: {
                                        message.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetIamPolicyInstanceTemplateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest} SetIamPolicyInstanceTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyInstanceTemplateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetIamPolicyInstanceTemplateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetIamPolicyInstanceTemplateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.globalSetPolicyRequestResource != null && message.hasOwnProperty("globalSetPolicyRequestResource")) {
                                var error = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.verify(message.globalSetPolicyRequestResource);
                                if (error)
                                    return "globalSetPolicyRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetIamPolicyInstanceTemplateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest} SetIamPolicyInstanceTemplateRequest
                         */
                        SetIamPolicyInstanceTemplateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest();
                            if (object.globalSetPolicyRequestResource != null) {
                                if (typeof object.globalSetPolicyRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest.globalSetPolicyRequestResource: object expected");
                                message.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.fromObject(object.globalSetPolicyRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetIamPolicyInstanceTemplateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest} message SetIamPolicyInstanceTemplateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetIamPolicyInstanceTemplateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.globalSetPolicyRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.globalSetPolicyRequestResource != null && message.hasOwnProperty("globalSetPolicyRequestResource"))
                                object.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.toObject(message.globalSetPolicyRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetIamPolicyInstanceTemplateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetIamPolicyInstanceTemplateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetIamPolicyInstanceTemplateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetIamPolicyInstanceTemplateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest";
                        };
    
                        return SetIamPolicyInstanceTemplateRequest;
                    })();
    
                    v1.SetIamPolicyLicenseRequest = (function() {
    
                        /**
                         * Properties of a SetIamPolicyLicenseRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetIamPolicyLicenseRequest
                         * @property {google.cloud.compute.v1.IGlobalSetPolicyRequest|null} [globalSetPolicyRequestResource] SetIamPolicyLicenseRequest globalSetPolicyRequestResource
                         * @property {string|null} [project] SetIamPolicyLicenseRequest project
                         * @property {string|null} [resource] SetIamPolicyLicenseRequest resource
                         */
    
                        /**
                         * Constructs a new SetIamPolicyLicenseRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetIamPolicyLicenseRequest.
                         * @implements ISetIamPolicyLicenseRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetIamPolicyLicenseRequest=} [properties] Properties to set
                         */
                        function SetIamPolicyLicenseRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetIamPolicyLicenseRequest globalSetPolicyRequestResource.
                         * @member {google.cloud.compute.v1.IGlobalSetPolicyRequest|null|undefined} globalSetPolicyRequestResource
                         * @memberof google.cloud.compute.v1.SetIamPolicyLicenseRequest
                         * @instance
                         */
                        SetIamPolicyLicenseRequest.prototype.globalSetPolicyRequestResource = null;
    
                        /**
                         * SetIamPolicyLicenseRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetIamPolicyLicenseRequest
                         * @instance
                         */
                        SetIamPolicyLicenseRequest.prototype.project = "";
    
                        /**
                         * SetIamPolicyLicenseRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetIamPolicyLicenseRequest
                         * @instance
                         */
                        SetIamPolicyLicenseRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetIamPolicyLicenseRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetIamPolicyLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyLicenseRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetIamPolicyLicenseRequest} SetIamPolicyLicenseRequest instance
                         */
                        SetIamPolicyLicenseRequest.create = function create(properties) {
                            return new SetIamPolicyLicenseRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyLicenseRequest message. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyLicenseRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetIamPolicyLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyLicenseRequest} message SetIamPolicyLicenseRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyLicenseRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.globalSetPolicyRequestResource != null && Object.hasOwnProperty.call(message, "globalSetPolicyRequestResource"))
                                $root.google.cloud.compute.v1.GlobalSetPolicyRequest.encode(message.globalSetPolicyRequestResource, writer.uint32(/* id 337048498, wireType 2 =*/2696387986).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyLicenseRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyLicenseRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyLicenseRequest} message SetIamPolicyLicenseRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyLicenseRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetIamPolicyLicenseRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetIamPolicyLicenseRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetIamPolicyLicenseRequest} SetIamPolicyLicenseRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyLicenseRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetIamPolicyLicenseRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 337048498: {
                                        message.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetIamPolicyLicenseRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyLicenseRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetIamPolicyLicenseRequest} SetIamPolicyLicenseRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyLicenseRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetIamPolicyLicenseRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetIamPolicyLicenseRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetIamPolicyLicenseRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.globalSetPolicyRequestResource != null && message.hasOwnProperty("globalSetPolicyRequestResource")) {
                                var error = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.verify(message.globalSetPolicyRequestResource);
                                if (error)
                                    return "globalSetPolicyRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetIamPolicyLicenseRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyLicenseRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetIamPolicyLicenseRequest} SetIamPolicyLicenseRequest
                         */
                        SetIamPolicyLicenseRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetIamPolicyLicenseRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetIamPolicyLicenseRequest();
                            if (object.globalSetPolicyRequestResource != null) {
                                if (typeof object.globalSetPolicyRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetIamPolicyLicenseRequest.globalSetPolicyRequestResource: object expected");
                                message.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.fromObject(object.globalSetPolicyRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetIamPolicyLicenseRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetIamPolicyLicenseRequest} message SetIamPolicyLicenseRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetIamPolicyLicenseRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.globalSetPolicyRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.globalSetPolicyRequestResource != null && message.hasOwnProperty("globalSetPolicyRequestResource"))
                                object.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.toObject(message.globalSetPolicyRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetIamPolicyLicenseRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetIamPolicyLicenseRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetIamPolicyLicenseRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetIamPolicyLicenseRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetIamPolicyLicenseRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetIamPolicyLicenseRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetIamPolicyLicenseRequest";
                        };
    
                        return SetIamPolicyLicenseRequest;
                    })();
    
                    v1.SetIamPolicyMachineImageRequest = (function() {
    
                        /**
                         * Properties of a SetIamPolicyMachineImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetIamPolicyMachineImageRequest
                         * @property {google.cloud.compute.v1.IGlobalSetPolicyRequest|null} [globalSetPolicyRequestResource] SetIamPolicyMachineImageRequest globalSetPolicyRequestResource
                         * @property {string|null} [project] SetIamPolicyMachineImageRequest project
                         * @property {string|null} [resource] SetIamPolicyMachineImageRequest resource
                         */
    
                        /**
                         * Constructs a new SetIamPolicyMachineImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetIamPolicyMachineImageRequest.
                         * @implements ISetIamPolicyMachineImageRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetIamPolicyMachineImageRequest=} [properties] Properties to set
                         */
                        function SetIamPolicyMachineImageRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetIamPolicyMachineImageRequest globalSetPolicyRequestResource.
                         * @member {google.cloud.compute.v1.IGlobalSetPolicyRequest|null|undefined} globalSetPolicyRequestResource
                         * @memberof google.cloud.compute.v1.SetIamPolicyMachineImageRequest
                         * @instance
                         */
                        SetIamPolicyMachineImageRequest.prototype.globalSetPolicyRequestResource = null;
    
                        /**
                         * SetIamPolicyMachineImageRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetIamPolicyMachineImageRequest
                         * @instance
                         */
                        SetIamPolicyMachineImageRequest.prototype.project = "";
    
                        /**
                         * SetIamPolicyMachineImageRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetIamPolicyMachineImageRequest
                         * @instance
                         */
                        SetIamPolicyMachineImageRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetIamPolicyMachineImageRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetIamPolicyMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyMachineImageRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetIamPolicyMachineImageRequest} SetIamPolicyMachineImageRequest instance
                         */
                        SetIamPolicyMachineImageRequest.create = function create(properties) {
                            return new SetIamPolicyMachineImageRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyMachineImageRequest message. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyMachineImageRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetIamPolicyMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyMachineImageRequest} message SetIamPolicyMachineImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyMachineImageRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.globalSetPolicyRequestResource != null && Object.hasOwnProperty.call(message, "globalSetPolicyRequestResource"))
                                $root.google.cloud.compute.v1.GlobalSetPolicyRequest.encode(message.globalSetPolicyRequestResource, writer.uint32(/* id 337048498, wireType 2 =*/2696387986).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyMachineImageRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyMachineImageRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyMachineImageRequest} message SetIamPolicyMachineImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyMachineImageRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetIamPolicyMachineImageRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetIamPolicyMachineImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetIamPolicyMachineImageRequest} SetIamPolicyMachineImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyMachineImageRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetIamPolicyMachineImageRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 337048498: {
                                        message.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetIamPolicyMachineImageRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyMachineImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetIamPolicyMachineImageRequest} SetIamPolicyMachineImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyMachineImageRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetIamPolicyMachineImageRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetIamPolicyMachineImageRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetIamPolicyMachineImageRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.globalSetPolicyRequestResource != null && message.hasOwnProperty("globalSetPolicyRequestResource")) {
                                var error = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.verify(message.globalSetPolicyRequestResource);
                                if (error)
                                    return "globalSetPolicyRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetIamPolicyMachineImageRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyMachineImageRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetIamPolicyMachineImageRequest} SetIamPolicyMachineImageRequest
                         */
                        SetIamPolicyMachineImageRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetIamPolicyMachineImageRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetIamPolicyMachineImageRequest();
                            if (object.globalSetPolicyRequestResource != null) {
                                if (typeof object.globalSetPolicyRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetIamPolicyMachineImageRequest.globalSetPolicyRequestResource: object expected");
                                message.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.fromObject(object.globalSetPolicyRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetIamPolicyMachineImageRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetIamPolicyMachineImageRequest} message SetIamPolicyMachineImageRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetIamPolicyMachineImageRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.globalSetPolicyRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.globalSetPolicyRequestResource != null && message.hasOwnProperty("globalSetPolicyRequestResource"))
                                object.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.toObject(message.globalSetPolicyRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetIamPolicyMachineImageRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetIamPolicyMachineImageRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetIamPolicyMachineImageRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetIamPolicyMachineImageRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetIamPolicyMachineImageRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetIamPolicyMachineImageRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetIamPolicyMachineImageRequest";
                        };
    
                        return SetIamPolicyMachineImageRequest;
                    })();
    
                    v1.SetIamPolicyNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a SetIamPolicyNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetIamPolicyNetworkFirewallPolicyRequest
                         * @property {google.cloud.compute.v1.IGlobalSetPolicyRequest|null} [globalSetPolicyRequestResource] SetIamPolicyNetworkFirewallPolicyRequest globalSetPolicyRequestResource
                         * @property {string|null} [project] SetIamPolicyNetworkFirewallPolicyRequest project
                         * @property {string|null} [resource] SetIamPolicyNetworkFirewallPolicyRequest resource
                         */
    
                        /**
                         * Constructs a new SetIamPolicyNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetIamPolicyNetworkFirewallPolicyRequest.
                         * @implements ISetIamPolicyNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetIamPolicyNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function SetIamPolicyNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetIamPolicyNetworkFirewallPolicyRequest globalSetPolicyRequestResource.
                         * @member {google.cloud.compute.v1.IGlobalSetPolicyRequest|null|undefined} globalSetPolicyRequestResource
                         * @memberof google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest
                         * @instance
                         */
                        SetIamPolicyNetworkFirewallPolicyRequest.prototype.globalSetPolicyRequestResource = null;
    
                        /**
                         * SetIamPolicyNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest
                         * @instance
                         */
                        SetIamPolicyNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * SetIamPolicyNetworkFirewallPolicyRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest
                         * @instance
                         */
                        SetIamPolicyNetworkFirewallPolicyRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetIamPolicyNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest} SetIamPolicyNetworkFirewallPolicyRequest instance
                         */
                        SetIamPolicyNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new SetIamPolicyNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyNetworkFirewallPolicyRequest} message SetIamPolicyNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.globalSetPolicyRequestResource != null && Object.hasOwnProperty.call(message, "globalSetPolicyRequestResource"))
                                $root.google.cloud.compute.v1.GlobalSetPolicyRequest.encode(message.globalSetPolicyRequestResource, writer.uint32(/* id 337048498, wireType 2 =*/2696387986).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyNetworkFirewallPolicyRequest} message SetIamPolicyNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetIamPolicyNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest} SetIamPolicyNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 337048498: {
                                        message.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetIamPolicyNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest} SetIamPolicyNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetIamPolicyNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetIamPolicyNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.globalSetPolicyRequestResource != null && message.hasOwnProperty("globalSetPolicyRequestResource")) {
                                var error = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.verify(message.globalSetPolicyRequestResource);
                                if (error)
                                    return "globalSetPolicyRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetIamPolicyNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest} SetIamPolicyNetworkFirewallPolicyRequest
                         */
                        SetIamPolicyNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest();
                            if (object.globalSetPolicyRequestResource != null) {
                                if (typeof object.globalSetPolicyRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest.globalSetPolicyRequestResource: object expected");
                                message.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.fromObject(object.globalSetPolicyRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetIamPolicyNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest} message SetIamPolicyNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetIamPolicyNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.globalSetPolicyRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.globalSetPolicyRequestResource != null && message.hasOwnProperty("globalSetPolicyRequestResource"))
                                object.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.toObject(message.globalSetPolicyRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetIamPolicyNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetIamPolicyNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetIamPolicyNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetIamPolicyNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest";
                        };
    
                        return SetIamPolicyNetworkFirewallPolicyRequest;
                    })();
    
                    v1.SetIamPolicyNodeGroupRequest = (function() {
    
                        /**
                         * Properties of a SetIamPolicyNodeGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetIamPolicyNodeGroupRequest
                         * @property {string|null} [project] SetIamPolicyNodeGroupRequest project
                         * @property {string|null} [resource] SetIamPolicyNodeGroupRequest resource
                         * @property {string|null} [zone] SetIamPolicyNodeGroupRequest zone
                         * @property {google.cloud.compute.v1.IZoneSetPolicyRequest|null} [zoneSetPolicyRequestResource] SetIamPolicyNodeGroupRequest zoneSetPolicyRequestResource
                         */
    
                        /**
                         * Constructs a new SetIamPolicyNodeGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetIamPolicyNodeGroupRequest.
                         * @implements ISetIamPolicyNodeGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetIamPolicyNodeGroupRequest=} [properties] Properties to set
                         */
                        function SetIamPolicyNodeGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetIamPolicyNodeGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeGroupRequest
                         * @instance
                         */
                        SetIamPolicyNodeGroupRequest.prototype.project = "";
    
                        /**
                         * SetIamPolicyNodeGroupRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeGroupRequest
                         * @instance
                         */
                        SetIamPolicyNodeGroupRequest.prototype.resource = "";
    
                        /**
                         * SetIamPolicyNodeGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeGroupRequest
                         * @instance
                         */
                        SetIamPolicyNodeGroupRequest.prototype.zone = "";
    
                        /**
                         * SetIamPolicyNodeGroupRequest zoneSetPolicyRequestResource.
                         * @member {google.cloud.compute.v1.IZoneSetPolicyRequest|null|undefined} zoneSetPolicyRequestResource
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeGroupRequest
                         * @instance
                         */
                        SetIamPolicyNodeGroupRequest.prototype.zoneSetPolicyRequestResource = null;
    
                        /**
                         * Creates a new SetIamPolicyNodeGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyNodeGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetIamPolicyNodeGroupRequest} SetIamPolicyNodeGroupRequest instance
                         */
                        SetIamPolicyNodeGroupRequest.create = function create(properties) {
                            return new SetIamPolicyNodeGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyNodeGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyNodeGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyNodeGroupRequest} message SetIamPolicyNodeGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyNodeGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.zoneSetPolicyRequestResource != null && Object.hasOwnProperty.call(message, "zoneSetPolicyRequestResource"))
                                $root.google.cloud.compute.v1.ZoneSetPolicyRequest.encode(message.zoneSetPolicyRequestResource, writer.uint32(/* id 382082107, wireType 2 =*/3056656858).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyNodeGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyNodeGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyNodeGroupRequest} message SetIamPolicyNodeGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyNodeGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetIamPolicyNodeGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetIamPolicyNodeGroupRequest} SetIamPolicyNodeGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyNodeGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetIamPolicyNodeGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                case 382082107: {
                                        message.zoneSetPolicyRequestResource = $root.google.cloud.compute.v1.ZoneSetPolicyRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetIamPolicyNodeGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetIamPolicyNodeGroupRequest} SetIamPolicyNodeGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyNodeGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetIamPolicyNodeGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetIamPolicyNodeGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            if (message.zoneSetPolicyRequestResource != null && message.hasOwnProperty("zoneSetPolicyRequestResource")) {
                                var error = $root.google.cloud.compute.v1.ZoneSetPolicyRequest.verify(message.zoneSetPolicyRequestResource);
                                if (error)
                                    return "zoneSetPolicyRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetIamPolicyNodeGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetIamPolicyNodeGroupRequest} SetIamPolicyNodeGroupRequest
                         */
                        SetIamPolicyNodeGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetIamPolicyNodeGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetIamPolicyNodeGroupRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            if (object.zoneSetPolicyRequestResource != null) {
                                if (typeof object.zoneSetPolicyRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetIamPolicyNodeGroupRequest.zoneSetPolicyRequestResource: object expected");
                                message.zoneSetPolicyRequestResource = $root.google.cloud.compute.v1.ZoneSetPolicyRequest.fromObject(object.zoneSetPolicyRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetIamPolicyNodeGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetIamPolicyNodeGroupRequest} message SetIamPolicyNodeGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetIamPolicyNodeGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.resource = "";
                                object.project = "";
                                object.zoneSetPolicyRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.zoneSetPolicyRequestResource != null && message.hasOwnProperty("zoneSetPolicyRequestResource"))
                                object.zoneSetPolicyRequestResource = $root.google.cloud.compute.v1.ZoneSetPolicyRequest.toObject(message.zoneSetPolicyRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetIamPolicyNodeGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetIamPolicyNodeGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetIamPolicyNodeGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetIamPolicyNodeGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetIamPolicyNodeGroupRequest";
                        };
    
                        return SetIamPolicyNodeGroupRequest;
                    })();
    
                    v1.SetIamPolicyNodeTemplateRequest = (function() {
    
                        /**
                         * Properties of a SetIamPolicyNodeTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetIamPolicyNodeTemplateRequest
                         * @property {string|null} [project] SetIamPolicyNodeTemplateRequest project
                         * @property {string|null} [region] SetIamPolicyNodeTemplateRequest region
                         * @property {google.cloud.compute.v1.IRegionSetPolicyRequest|null} [regionSetPolicyRequestResource] SetIamPolicyNodeTemplateRequest regionSetPolicyRequestResource
                         * @property {string|null} [resource] SetIamPolicyNodeTemplateRequest resource
                         */
    
                        /**
                         * Constructs a new SetIamPolicyNodeTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetIamPolicyNodeTemplateRequest.
                         * @implements ISetIamPolicyNodeTemplateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetIamPolicyNodeTemplateRequest=} [properties] Properties to set
                         */
                        function SetIamPolicyNodeTemplateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetIamPolicyNodeTemplateRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest
                         * @instance
                         */
                        SetIamPolicyNodeTemplateRequest.prototype.project = "";
    
                        /**
                         * SetIamPolicyNodeTemplateRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest
                         * @instance
                         */
                        SetIamPolicyNodeTemplateRequest.prototype.region = "";
    
                        /**
                         * SetIamPolicyNodeTemplateRequest regionSetPolicyRequestResource.
                         * @member {google.cloud.compute.v1.IRegionSetPolicyRequest|null|undefined} regionSetPolicyRequestResource
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest
                         * @instance
                         */
                        SetIamPolicyNodeTemplateRequest.prototype.regionSetPolicyRequestResource = null;
    
                        /**
                         * SetIamPolicyNodeTemplateRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest
                         * @instance
                         */
                        SetIamPolicyNodeTemplateRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetIamPolicyNodeTemplateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyNodeTemplateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest} SetIamPolicyNodeTemplateRequest instance
                         */
                        SetIamPolicyNodeTemplateRequest.create = function create(properties) {
                            return new SetIamPolicyNodeTemplateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyNodeTemplateRequest message. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyNodeTemplateRequest} message SetIamPolicyNodeTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyNodeTemplateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.regionSetPolicyRequestResource != null && Object.hasOwnProperty.call(message, "regionSetPolicyRequestResource"))
                                $root.google.cloud.compute.v1.RegionSetPolicyRequest.encode(message.regionSetPolicyRequestResource, writer.uint32(/* id 276489091, wireType 2 =*/2211912730).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyNodeTemplateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyNodeTemplateRequest} message SetIamPolicyNodeTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyNodeTemplateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetIamPolicyNodeTemplateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest} SetIamPolicyNodeTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyNodeTemplateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 276489091: {
                                        message.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetIamPolicyNodeTemplateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest} SetIamPolicyNodeTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyNodeTemplateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetIamPolicyNodeTemplateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetIamPolicyNodeTemplateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionSetPolicyRequestResource != null && message.hasOwnProperty("regionSetPolicyRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionSetPolicyRequest.verify(message.regionSetPolicyRequestResource);
                                if (error)
                                    return "regionSetPolicyRequestResource." + error;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetIamPolicyNodeTemplateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest} SetIamPolicyNodeTemplateRequest
                         */
                        SetIamPolicyNodeTemplateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionSetPolicyRequestResource != null) {
                                if (typeof object.regionSetPolicyRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest.regionSetPolicyRequestResource: object expected");
                                message.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.fromObject(object.regionSetPolicyRequestResource);
                            }
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetIamPolicyNodeTemplateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest} message SetIamPolicyNodeTemplateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetIamPolicyNodeTemplateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.regionSetPolicyRequestResource = null;
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.regionSetPolicyRequestResource != null && message.hasOwnProperty("regionSetPolicyRequestResource"))
                                object.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.toObject(message.regionSetPolicyRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetIamPolicyNodeTemplateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetIamPolicyNodeTemplateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetIamPolicyNodeTemplateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetIamPolicyNodeTemplateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest";
                        };
    
                        return SetIamPolicyNodeTemplateRequest;
                    })();
    
                    v1.SetIamPolicyRegionBackendServiceRequest = (function() {
    
                        /**
                         * Properties of a SetIamPolicyRegionBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetIamPolicyRegionBackendServiceRequest
                         * @property {string|null} [project] SetIamPolicyRegionBackendServiceRequest project
                         * @property {string|null} [region] SetIamPolicyRegionBackendServiceRequest region
                         * @property {google.cloud.compute.v1.IRegionSetPolicyRequest|null} [regionSetPolicyRequestResource] SetIamPolicyRegionBackendServiceRequest regionSetPolicyRequestResource
                         * @property {string|null} [resource] SetIamPolicyRegionBackendServiceRequest resource
                         */
    
                        /**
                         * Constructs a new SetIamPolicyRegionBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetIamPolicyRegionBackendServiceRequest.
                         * @implements ISetIamPolicyRegionBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetIamPolicyRegionBackendServiceRequest=} [properties] Properties to set
                         */
                        function SetIamPolicyRegionBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetIamPolicyRegionBackendServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest
                         * @instance
                         */
                        SetIamPolicyRegionBackendServiceRequest.prototype.project = "";
    
                        /**
                         * SetIamPolicyRegionBackendServiceRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest
                         * @instance
                         */
                        SetIamPolicyRegionBackendServiceRequest.prototype.region = "";
    
                        /**
                         * SetIamPolicyRegionBackendServiceRequest regionSetPolicyRequestResource.
                         * @member {google.cloud.compute.v1.IRegionSetPolicyRequest|null|undefined} regionSetPolicyRequestResource
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest
                         * @instance
                         */
                        SetIamPolicyRegionBackendServiceRequest.prototype.regionSetPolicyRequestResource = null;
    
                        /**
                         * SetIamPolicyRegionBackendServiceRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest
                         * @instance
                         */
                        SetIamPolicyRegionBackendServiceRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetIamPolicyRegionBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyRegionBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest} SetIamPolicyRegionBackendServiceRequest instance
                         */
                        SetIamPolicyRegionBackendServiceRequest.create = function create(properties) {
                            return new SetIamPolicyRegionBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyRegionBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyRegionBackendServiceRequest} message SetIamPolicyRegionBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyRegionBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.regionSetPolicyRequestResource != null && Object.hasOwnProperty.call(message, "regionSetPolicyRequestResource"))
                                $root.google.cloud.compute.v1.RegionSetPolicyRequest.encode(message.regionSetPolicyRequestResource, writer.uint32(/* id 276489091, wireType 2 =*/2211912730).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyRegionBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyRegionBackendServiceRequest} message SetIamPolicyRegionBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyRegionBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetIamPolicyRegionBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest} SetIamPolicyRegionBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyRegionBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 276489091: {
                                        message.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetIamPolicyRegionBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest} SetIamPolicyRegionBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyRegionBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetIamPolicyRegionBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetIamPolicyRegionBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionSetPolicyRequestResource != null && message.hasOwnProperty("regionSetPolicyRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionSetPolicyRequest.verify(message.regionSetPolicyRequestResource);
                                if (error)
                                    return "regionSetPolicyRequestResource." + error;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetIamPolicyRegionBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest} SetIamPolicyRegionBackendServiceRequest
                         */
                        SetIamPolicyRegionBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionSetPolicyRequestResource != null) {
                                if (typeof object.regionSetPolicyRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest.regionSetPolicyRequestResource: object expected");
                                message.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.fromObject(object.regionSetPolicyRequestResource);
                            }
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetIamPolicyRegionBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest} message SetIamPolicyRegionBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetIamPolicyRegionBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.regionSetPolicyRequestResource = null;
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.regionSetPolicyRequestResource != null && message.hasOwnProperty("regionSetPolicyRequestResource"))
                                object.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.toObject(message.regionSetPolicyRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetIamPolicyRegionBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetIamPolicyRegionBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetIamPolicyRegionBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetIamPolicyRegionBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest";
                        };
    
                        return SetIamPolicyRegionBackendServiceRequest;
                    })();
    
                    v1.SetIamPolicyRegionDiskRequest = (function() {
    
                        /**
                         * Properties of a SetIamPolicyRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetIamPolicyRegionDiskRequest
                         * @property {string|null} [project] SetIamPolicyRegionDiskRequest project
                         * @property {string|null} [region] SetIamPolicyRegionDiskRequest region
                         * @property {google.cloud.compute.v1.IRegionSetPolicyRequest|null} [regionSetPolicyRequestResource] SetIamPolicyRegionDiskRequest regionSetPolicyRequestResource
                         * @property {string|null} [resource] SetIamPolicyRegionDiskRequest resource
                         */
    
                        /**
                         * Constructs a new SetIamPolicyRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetIamPolicyRegionDiskRequest.
                         * @implements ISetIamPolicyRegionDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetIamPolicyRegionDiskRequest=} [properties] Properties to set
                         */
                        function SetIamPolicyRegionDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetIamPolicyRegionDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionDiskRequest
                         * @instance
                         */
                        SetIamPolicyRegionDiskRequest.prototype.project = "";
    
                        /**
                         * SetIamPolicyRegionDiskRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionDiskRequest
                         * @instance
                         */
                        SetIamPolicyRegionDiskRequest.prototype.region = "";
    
                        /**
                         * SetIamPolicyRegionDiskRequest regionSetPolicyRequestResource.
                         * @member {google.cloud.compute.v1.IRegionSetPolicyRequest|null|undefined} regionSetPolicyRequestResource
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionDiskRequest
                         * @instance
                         */
                        SetIamPolicyRegionDiskRequest.prototype.regionSetPolicyRequestResource = null;
    
                        /**
                         * SetIamPolicyRegionDiskRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionDiskRequest
                         * @instance
                         */
                        SetIamPolicyRegionDiskRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetIamPolicyRegionDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyRegionDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetIamPolicyRegionDiskRequest} SetIamPolicyRegionDiskRequest instance
                         */
                        SetIamPolicyRegionDiskRequest.create = function create(properties) {
                            return new SetIamPolicyRegionDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyRegionDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyRegionDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyRegionDiskRequest} message SetIamPolicyRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyRegionDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.regionSetPolicyRequestResource != null && Object.hasOwnProperty.call(message, "regionSetPolicyRequestResource"))
                                $root.google.cloud.compute.v1.RegionSetPolicyRequest.encode(message.regionSetPolicyRequestResource, writer.uint32(/* id 276489091, wireType 2 =*/2211912730).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyRegionDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyRegionDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyRegionDiskRequest} message SetIamPolicyRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyRegionDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetIamPolicyRegionDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetIamPolicyRegionDiskRequest} SetIamPolicyRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyRegionDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetIamPolicyRegionDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 276489091: {
                                        message.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetIamPolicyRegionDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetIamPolicyRegionDiskRequest} SetIamPolicyRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyRegionDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetIamPolicyRegionDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetIamPolicyRegionDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionSetPolicyRequestResource != null && message.hasOwnProperty("regionSetPolicyRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionSetPolicyRequest.verify(message.regionSetPolicyRequestResource);
                                if (error)
                                    return "regionSetPolicyRequestResource." + error;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetIamPolicyRegionDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetIamPolicyRegionDiskRequest} SetIamPolicyRegionDiskRequest
                         */
                        SetIamPolicyRegionDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetIamPolicyRegionDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetIamPolicyRegionDiskRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionSetPolicyRequestResource != null) {
                                if (typeof object.regionSetPolicyRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetIamPolicyRegionDiskRequest.regionSetPolicyRequestResource: object expected");
                                message.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.fromObject(object.regionSetPolicyRequestResource);
                            }
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetIamPolicyRegionDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetIamPolicyRegionDiskRequest} message SetIamPolicyRegionDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetIamPolicyRegionDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.regionSetPolicyRequestResource = null;
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.regionSetPolicyRequestResource != null && message.hasOwnProperty("regionSetPolicyRequestResource"))
                                object.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.toObject(message.regionSetPolicyRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetIamPolicyRegionDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetIamPolicyRegionDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetIamPolicyRegionDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetIamPolicyRegionDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetIamPolicyRegionDiskRequest";
                        };
    
                        return SetIamPolicyRegionDiskRequest;
                    })();
    
                    v1.SetIamPolicyRegionNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a SetIamPolicyRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @property {string|null} [project] SetIamPolicyRegionNetworkFirewallPolicyRequest project
                         * @property {string|null} [region] SetIamPolicyRegionNetworkFirewallPolicyRequest region
                         * @property {google.cloud.compute.v1.IRegionSetPolicyRequest|null} [regionSetPolicyRequestResource] SetIamPolicyRegionNetworkFirewallPolicyRequest regionSetPolicyRequestResource
                         * @property {string|null} [resource] SetIamPolicyRegionNetworkFirewallPolicyRequest resource
                         */
    
                        /**
                         * Constructs a new SetIamPolicyRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetIamPolicyRegionNetworkFirewallPolicyRequest.
                         * @implements ISetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetIamPolicyRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function SetIamPolicyRegionNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetIamPolicyRegionNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        SetIamPolicyRegionNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * SetIamPolicyRegionNetworkFirewallPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        SetIamPolicyRegionNetworkFirewallPolicyRequest.prototype.region = "";
    
                        /**
                         * SetIamPolicyRegionNetworkFirewallPolicyRequest regionSetPolicyRequestResource.
                         * @member {google.cloud.compute.v1.IRegionSetPolicyRequest|null|undefined} regionSetPolicyRequestResource
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        SetIamPolicyRegionNetworkFirewallPolicyRequest.prototype.regionSetPolicyRequestResource = null;
    
                        /**
                         * SetIamPolicyRegionNetworkFirewallPolicyRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        SetIamPolicyRegionNetworkFirewallPolicyRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetIamPolicyRegionNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest} SetIamPolicyRegionNetworkFirewallPolicyRequest instance
                         */
                        SetIamPolicyRegionNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new SetIamPolicyRegionNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyRegionNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyRegionNetworkFirewallPolicyRequest} message SetIamPolicyRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyRegionNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.regionSetPolicyRequestResource != null && Object.hasOwnProperty.call(message, "regionSetPolicyRequestResource"))
                                $root.google.cloud.compute.v1.RegionSetPolicyRequest.encode(message.regionSetPolicyRequestResource, writer.uint32(/* id 276489091, wireType 2 =*/2211912730).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyRegionNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyRegionNetworkFirewallPolicyRequest} message SetIamPolicyRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyRegionNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetIamPolicyRegionNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest} SetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyRegionNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 276489091: {
                                        message.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetIamPolicyRegionNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest} SetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyRegionNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetIamPolicyRegionNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetIamPolicyRegionNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionSetPolicyRequestResource != null && message.hasOwnProperty("regionSetPolicyRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionSetPolicyRequest.verify(message.regionSetPolicyRequestResource);
                                if (error)
                                    return "regionSetPolicyRequestResource." + error;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetIamPolicyRegionNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest} SetIamPolicyRegionNetworkFirewallPolicyRequest
                         */
                        SetIamPolicyRegionNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionSetPolicyRequestResource != null) {
                                if (typeof object.regionSetPolicyRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest.regionSetPolicyRequestResource: object expected");
                                message.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.fromObject(object.regionSetPolicyRequestResource);
                            }
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetIamPolicyRegionNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest} message SetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetIamPolicyRegionNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.regionSetPolicyRequestResource = null;
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.regionSetPolicyRequestResource != null && message.hasOwnProperty("regionSetPolicyRequestResource"))
                                object.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.toObject(message.regionSetPolicyRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetIamPolicyRegionNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetIamPolicyRegionNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetIamPolicyRegionNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest";
                        };
    
                        return SetIamPolicyRegionNetworkFirewallPolicyRequest;
                    })();
    
                    v1.SetIamPolicyReservationRequest = (function() {
    
                        /**
                         * Properties of a SetIamPolicyReservationRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetIamPolicyReservationRequest
                         * @property {string|null} [project] SetIamPolicyReservationRequest project
                         * @property {string|null} [resource] SetIamPolicyReservationRequest resource
                         * @property {string|null} [zone] SetIamPolicyReservationRequest zone
                         * @property {google.cloud.compute.v1.IZoneSetPolicyRequest|null} [zoneSetPolicyRequestResource] SetIamPolicyReservationRequest zoneSetPolicyRequestResource
                         */
    
                        /**
                         * Constructs a new SetIamPolicyReservationRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetIamPolicyReservationRequest.
                         * @implements ISetIamPolicyReservationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetIamPolicyReservationRequest=} [properties] Properties to set
                         */
                        function SetIamPolicyReservationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetIamPolicyReservationRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetIamPolicyReservationRequest
                         * @instance
                         */
                        SetIamPolicyReservationRequest.prototype.project = "";
    
                        /**
                         * SetIamPolicyReservationRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetIamPolicyReservationRequest
                         * @instance
                         */
                        SetIamPolicyReservationRequest.prototype.resource = "";
    
                        /**
                         * SetIamPolicyReservationRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SetIamPolicyReservationRequest
                         * @instance
                         */
                        SetIamPolicyReservationRequest.prototype.zone = "";
    
                        /**
                         * SetIamPolicyReservationRequest zoneSetPolicyRequestResource.
                         * @member {google.cloud.compute.v1.IZoneSetPolicyRequest|null|undefined} zoneSetPolicyRequestResource
                         * @memberof google.cloud.compute.v1.SetIamPolicyReservationRequest
                         * @instance
                         */
                        SetIamPolicyReservationRequest.prototype.zoneSetPolicyRequestResource = null;
    
                        /**
                         * Creates a new SetIamPolicyReservationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetIamPolicyReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyReservationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetIamPolicyReservationRequest} SetIamPolicyReservationRequest instance
                         */
                        SetIamPolicyReservationRequest.create = function create(properties) {
                            return new SetIamPolicyReservationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyReservationRequest message. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyReservationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetIamPolicyReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyReservationRequest} message SetIamPolicyReservationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyReservationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.zoneSetPolicyRequestResource != null && Object.hasOwnProperty.call(message, "zoneSetPolicyRequestResource"))
                                $root.google.cloud.compute.v1.ZoneSetPolicyRequest.encode(message.zoneSetPolicyRequestResource, writer.uint32(/* id 382082107, wireType 2 =*/3056656858).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyReservationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyReservationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyReservationRequest} message SetIamPolicyReservationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyReservationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetIamPolicyReservationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetIamPolicyReservationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetIamPolicyReservationRequest} SetIamPolicyReservationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyReservationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetIamPolicyReservationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                case 382082107: {
                                        message.zoneSetPolicyRequestResource = $root.google.cloud.compute.v1.ZoneSetPolicyRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetIamPolicyReservationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyReservationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetIamPolicyReservationRequest} SetIamPolicyReservationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyReservationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetIamPolicyReservationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetIamPolicyReservationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetIamPolicyReservationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            if (message.zoneSetPolicyRequestResource != null && message.hasOwnProperty("zoneSetPolicyRequestResource")) {
                                var error = $root.google.cloud.compute.v1.ZoneSetPolicyRequest.verify(message.zoneSetPolicyRequestResource);
                                if (error)
                                    return "zoneSetPolicyRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetIamPolicyReservationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyReservationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetIamPolicyReservationRequest} SetIamPolicyReservationRequest
                         */
                        SetIamPolicyReservationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetIamPolicyReservationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetIamPolicyReservationRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            if (object.zoneSetPolicyRequestResource != null) {
                                if (typeof object.zoneSetPolicyRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetIamPolicyReservationRequest.zoneSetPolicyRequestResource: object expected");
                                message.zoneSetPolicyRequestResource = $root.google.cloud.compute.v1.ZoneSetPolicyRequest.fromObject(object.zoneSetPolicyRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetIamPolicyReservationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetIamPolicyReservationRequest} message SetIamPolicyReservationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetIamPolicyReservationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.resource = "";
                                object.project = "";
                                object.zoneSetPolicyRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.zoneSetPolicyRequestResource != null && message.hasOwnProperty("zoneSetPolicyRequestResource"))
                                object.zoneSetPolicyRequestResource = $root.google.cloud.compute.v1.ZoneSetPolicyRequest.toObject(message.zoneSetPolicyRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetIamPolicyReservationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetIamPolicyReservationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetIamPolicyReservationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetIamPolicyReservationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetIamPolicyReservationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetIamPolicyReservationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetIamPolicyReservationRequest";
                        };
    
                        return SetIamPolicyReservationRequest;
                    })();
    
                    v1.SetIamPolicyResourcePolicyRequest = (function() {
    
                        /**
                         * Properties of a SetIamPolicyResourcePolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetIamPolicyResourcePolicyRequest
                         * @property {string|null} [project] SetIamPolicyResourcePolicyRequest project
                         * @property {string|null} [region] SetIamPolicyResourcePolicyRequest region
                         * @property {google.cloud.compute.v1.IRegionSetPolicyRequest|null} [regionSetPolicyRequestResource] SetIamPolicyResourcePolicyRequest regionSetPolicyRequestResource
                         * @property {string|null} [resource] SetIamPolicyResourcePolicyRequest resource
                         */
    
                        /**
                         * Constructs a new SetIamPolicyResourcePolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetIamPolicyResourcePolicyRequest.
                         * @implements ISetIamPolicyResourcePolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetIamPolicyResourcePolicyRequest=} [properties] Properties to set
                         */
                        function SetIamPolicyResourcePolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetIamPolicyResourcePolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest
                         * @instance
                         */
                        SetIamPolicyResourcePolicyRequest.prototype.project = "";
    
                        /**
                         * SetIamPolicyResourcePolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest
                         * @instance
                         */
                        SetIamPolicyResourcePolicyRequest.prototype.region = "";
    
                        /**
                         * SetIamPolicyResourcePolicyRequest regionSetPolicyRequestResource.
                         * @member {google.cloud.compute.v1.IRegionSetPolicyRequest|null|undefined} regionSetPolicyRequestResource
                         * @memberof google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest
                         * @instance
                         */
                        SetIamPolicyResourcePolicyRequest.prototype.regionSetPolicyRequestResource = null;
    
                        /**
                         * SetIamPolicyResourcePolicyRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest
                         * @instance
                         */
                        SetIamPolicyResourcePolicyRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetIamPolicyResourcePolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyResourcePolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest} SetIamPolicyResourcePolicyRequest instance
                         */
                        SetIamPolicyResourcePolicyRequest.create = function create(properties) {
                            return new SetIamPolicyResourcePolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyResourcePolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyResourcePolicyRequest} message SetIamPolicyResourcePolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyResourcePolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.regionSetPolicyRequestResource != null && Object.hasOwnProperty.call(message, "regionSetPolicyRequestResource"))
                                $root.google.cloud.compute.v1.RegionSetPolicyRequest.encode(message.regionSetPolicyRequestResource, writer.uint32(/* id 276489091, wireType 2 =*/2211912730).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyResourcePolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyResourcePolicyRequest} message SetIamPolicyResourcePolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyResourcePolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetIamPolicyResourcePolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest} SetIamPolicyResourcePolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyResourcePolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 276489091: {
                                        message.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetIamPolicyResourcePolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest} SetIamPolicyResourcePolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyResourcePolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetIamPolicyResourcePolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetIamPolicyResourcePolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionSetPolicyRequestResource != null && message.hasOwnProperty("regionSetPolicyRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionSetPolicyRequest.verify(message.regionSetPolicyRequestResource);
                                if (error)
                                    return "regionSetPolicyRequestResource." + error;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetIamPolicyResourcePolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest} SetIamPolicyResourcePolicyRequest
                         */
                        SetIamPolicyResourcePolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionSetPolicyRequestResource != null) {
                                if (typeof object.regionSetPolicyRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest.regionSetPolicyRequestResource: object expected");
                                message.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.fromObject(object.regionSetPolicyRequestResource);
                            }
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetIamPolicyResourcePolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest} message SetIamPolicyResourcePolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetIamPolicyResourcePolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.regionSetPolicyRequestResource = null;
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.regionSetPolicyRequestResource != null && message.hasOwnProperty("regionSetPolicyRequestResource"))
                                object.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.toObject(message.regionSetPolicyRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetIamPolicyResourcePolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetIamPolicyResourcePolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetIamPolicyResourcePolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetIamPolicyResourcePolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest";
                        };
    
                        return SetIamPolicyResourcePolicyRequest;
                    })();
    
                    v1.SetIamPolicyServiceAttachmentRequest = (function() {
    
                        /**
                         * Properties of a SetIamPolicyServiceAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetIamPolicyServiceAttachmentRequest
                         * @property {string|null} [project] SetIamPolicyServiceAttachmentRequest project
                         * @property {string|null} [region] SetIamPolicyServiceAttachmentRequest region
                         * @property {google.cloud.compute.v1.IRegionSetPolicyRequest|null} [regionSetPolicyRequestResource] SetIamPolicyServiceAttachmentRequest regionSetPolicyRequestResource
                         * @property {string|null} [resource] SetIamPolicyServiceAttachmentRequest resource
                         */
    
                        /**
                         * Constructs a new SetIamPolicyServiceAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetIamPolicyServiceAttachmentRequest.
                         * @implements ISetIamPolicyServiceAttachmentRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetIamPolicyServiceAttachmentRequest=} [properties] Properties to set
                         */
                        function SetIamPolicyServiceAttachmentRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetIamPolicyServiceAttachmentRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest
                         * @instance
                         */
                        SetIamPolicyServiceAttachmentRequest.prototype.project = "";
    
                        /**
                         * SetIamPolicyServiceAttachmentRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest
                         * @instance
                         */
                        SetIamPolicyServiceAttachmentRequest.prototype.region = "";
    
                        /**
                         * SetIamPolicyServiceAttachmentRequest regionSetPolicyRequestResource.
                         * @member {google.cloud.compute.v1.IRegionSetPolicyRequest|null|undefined} regionSetPolicyRequestResource
                         * @memberof google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest
                         * @instance
                         */
                        SetIamPolicyServiceAttachmentRequest.prototype.regionSetPolicyRequestResource = null;
    
                        /**
                         * SetIamPolicyServiceAttachmentRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest
                         * @instance
                         */
                        SetIamPolicyServiceAttachmentRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetIamPolicyServiceAttachmentRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyServiceAttachmentRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest} SetIamPolicyServiceAttachmentRequest instance
                         */
                        SetIamPolicyServiceAttachmentRequest.create = function create(properties) {
                            return new SetIamPolicyServiceAttachmentRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyServiceAttachmentRequest message. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyServiceAttachmentRequest} message SetIamPolicyServiceAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyServiceAttachmentRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.regionSetPolicyRequestResource != null && Object.hasOwnProperty.call(message, "regionSetPolicyRequestResource"))
                                $root.google.cloud.compute.v1.RegionSetPolicyRequest.encode(message.regionSetPolicyRequestResource, writer.uint32(/* id 276489091, wireType 2 =*/2211912730).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetIamPolicyServiceAttachmentRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicyServiceAttachmentRequest} message SetIamPolicyServiceAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicyServiceAttachmentRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetIamPolicyServiceAttachmentRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest} SetIamPolicyServiceAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyServiceAttachmentRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 276489091: {
                                        message.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetIamPolicyServiceAttachmentRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest} SetIamPolicyServiceAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicyServiceAttachmentRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetIamPolicyServiceAttachmentRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetIamPolicyServiceAttachmentRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionSetPolicyRequestResource != null && message.hasOwnProperty("regionSetPolicyRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionSetPolicyRequest.verify(message.regionSetPolicyRequestResource);
                                if (error)
                                    return "regionSetPolicyRequestResource." + error;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetIamPolicyServiceAttachmentRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest} SetIamPolicyServiceAttachmentRequest
                         */
                        SetIamPolicyServiceAttachmentRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionSetPolicyRequestResource != null) {
                                if (typeof object.regionSetPolicyRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest.regionSetPolicyRequestResource: object expected");
                                message.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.fromObject(object.regionSetPolicyRequestResource);
                            }
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetIamPolicyServiceAttachmentRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest} message SetIamPolicyServiceAttachmentRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetIamPolicyServiceAttachmentRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.regionSetPolicyRequestResource = null;
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.regionSetPolicyRequestResource != null && message.hasOwnProperty("regionSetPolicyRequestResource"))
                                object.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.toObject(message.regionSetPolicyRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetIamPolicyServiceAttachmentRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetIamPolicyServiceAttachmentRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetIamPolicyServiceAttachmentRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetIamPolicyServiceAttachmentRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest";
                        };
    
                        return SetIamPolicyServiceAttachmentRequest;
                    })();
    
                    v1.SetIamPolicySnapshotRequest = (function() {
    
                        /**
                         * Properties of a SetIamPolicySnapshotRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetIamPolicySnapshotRequest
                         * @property {google.cloud.compute.v1.IGlobalSetPolicyRequest|null} [globalSetPolicyRequestResource] SetIamPolicySnapshotRequest globalSetPolicyRequestResource
                         * @property {string|null} [project] SetIamPolicySnapshotRequest project
                         * @property {string|null} [resource] SetIamPolicySnapshotRequest resource
                         */
    
                        /**
                         * Constructs a new SetIamPolicySnapshotRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetIamPolicySnapshotRequest.
                         * @implements ISetIamPolicySnapshotRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetIamPolicySnapshotRequest=} [properties] Properties to set
                         */
                        function SetIamPolicySnapshotRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetIamPolicySnapshotRequest globalSetPolicyRequestResource.
                         * @member {google.cloud.compute.v1.IGlobalSetPolicyRequest|null|undefined} globalSetPolicyRequestResource
                         * @memberof google.cloud.compute.v1.SetIamPolicySnapshotRequest
                         * @instance
                         */
                        SetIamPolicySnapshotRequest.prototype.globalSetPolicyRequestResource = null;
    
                        /**
                         * SetIamPolicySnapshotRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetIamPolicySnapshotRequest
                         * @instance
                         */
                        SetIamPolicySnapshotRequest.prototype.project = "";
    
                        /**
                         * SetIamPolicySnapshotRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetIamPolicySnapshotRequest
                         * @instance
                         */
                        SetIamPolicySnapshotRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetIamPolicySnapshotRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetIamPolicySnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicySnapshotRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetIamPolicySnapshotRequest} SetIamPolicySnapshotRequest instance
                         */
                        SetIamPolicySnapshotRequest.create = function create(properties) {
                            return new SetIamPolicySnapshotRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetIamPolicySnapshotRequest message. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicySnapshotRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetIamPolicySnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicySnapshotRequest} message SetIamPolicySnapshotRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicySnapshotRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.globalSetPolicyRequestResource != null && Object.hasOwnProperty.call(message, "globalSetPolicyRequestResource"))
                                $root.google.cloud.compute.v1.GlobalSetPolicyRequest.encode(message.globalSetPolicyRequestResource, writer.uint32(/* id 337048498, wireType 2 =*/2696387986).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetIamPolicySnapshotRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicySnapshotRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicySnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicySnapshotRequest} message SetIamPolicySnapshotRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicySnapshotRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetIamPolicySnapshotRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetIamPolicySnapshotRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetIamPolicySnapshotRequest} SetIamPolicySnapshotRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicySnapshotRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetIamPolicySnapshotRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 337048498: {
                                        message.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetIamPolicySnapshotRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicySnapshotRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetIamPolicySnapshotRequest} SetIamPolicySnapshotRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicySnapshotRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetIamPolicySnapshotRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetIamPolicySnapshotRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetIamPolicySnapshotRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.globalSetPolicyRequestResource != null && message.hasOwnProperty("globalSetPolicyRequestResource")) {
                                var error = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.verify(message.globalSetPolicyRequestResource);
                                if (error)
                                    return "globalSetPolicyRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetIamPolicySnapshotRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetIamPolicySnapshotRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetIamPolicySnapshotRequest} SetIamPolicySnapshotRequest
                         */
                        SetIamPolicySnapshotRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetIamPolicySnapshotRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetIamPolicySnapshotRequest();
                            if (object.globalSetPolicyRequestResource != null) {
                                if (typeof object.globalSetPolicyRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetIamPolicySnapshotRequest.globalSetPolicyRequestResource: object expected");
                                message.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.fromObject(object.globalSetPolicyRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetIamPolicySnapshotRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetIamPolicySnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetIamPolicySnapshotRequest} message SetIamPolicySnapshotRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetIamPolicySnapshotRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.globalSetPolicyRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.globalSetPolicyRequestResource != null && message.hasOwnProperty("globalSetPolicyRequestResource"))
                                object.globalSetPolicyRequestResource = $root.google.cloud.compute.v1.GlobalSetPolicyRequest.toObject(message.globalSetPolicyRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetIamPolicySnapshotRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetIamPolicySnapshotRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetIamPolicySnapshotRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetIamPolicySnapshotRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetIamPolicySnapshotRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetIamPolicySnapshotRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetIamPolicySnapshotRequest";
                        };
    
                        return SetIamPolicySnapshotRequest;
                    })();
    
                    v1.SetIamPolicySubnetworkRequest = (function() {
    
                        /**
                         * Properties of a SetIamPolicySubnetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetIamPolicySubnetworkRequest
                         * @property {string|null} [project] SetIamPolicySubnetworkRequest project
                         * @property {string|null} [region] SetIamPolicySubnetworkRequest region
                         * @property {google.cloud.compute.v1.IRegionSetPolicyRequest|null} [regionSetPolicyRequestResource] SetIamPolicySubnetworkRequest regionSetPolicyRequestResource
                         * @property {string|null} [resource] SetIamPolicySubnetworkRequest resource
                         */
    
                        /**
                         * Constructs a new SetIamPolicySubnetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetIamPolicySubnetworkRequest.
                         * @implements ISetIamPolicySubnetworkRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetIamPolicySubnetworkRequest=} [properties] Properties to set
                         */
                        function SetIamPolicySubnetworkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetIamPolicySubnetworkRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetIamPolicySubnetworkRequest
                         * @instance
                         */
                        SetIamPolicySubnetworkRequest.prototype.project = "";
    
                        /**
                         * SetIamPolicySubnetworkRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetIamPolicySubnetworkRequest
                         * @instance
                         */
                        SetIamPolicySubnetworkRequest.prototype.region = "";
    
                        /**
                         * SetIamPolicySubnetworkRequest regionSetPolicyRequestResource.
                         * @member {google.cloud.compute.v1.IRegionSetPolicyRequest|null|undefined} regionSetPolicyRequestResource
                         * @memberof google.cloud.compute.v1.SetIamPolicySubnetworkRequest
                         * @instance
                         */
                        SetIamPolicySubnetworkRequest.prototype.regionSetPolicyRequestResource = null;
    
                        /**
                         * SetIamPolicySubnetworkRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetIamPolicySubnetworkRequest
                         * @instance
                         */
                        SetIamPolicySubnetworkRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetIamPolicySubnetworkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetIamPolicySubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicySubnetworkRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetIamPolicySubnetworkRequest} SetIamPolicySubnetworkRequest instance
                         */
                        SetIamPolicySubnetworkRequest.create = function create(properties) {
                            return new SetIamPolicySubnetworkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetIamPolicySubnetworkRequest message. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicySubnetworkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetIamPolicySubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicySubnetworkRequest} message SetIamPolicySubnetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicySubnetworkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.regionSetPolicyRequestResource != null && Object.hasOwnProperty.call(message, "regionSetPolicyRequestResource"))
                                $root.google.cloud.compute.v1.RegionSetPolicyRequest.encode(message.regionSetPolicyRequestResource, writer.uint32(/* id 276489091, wireType 2 =*/2211912730).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetIamPolicySubnetworkRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetIamPolicySubnetworkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicySubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetIamPolicySubnetworkRequest} message SetIamPolicySubnetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetIamPolicySubnetworkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetIamPolicySubnetworkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetIamPolicySubnetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetIamPolicySubnetworkRequest} SetIamPolicySubnetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicySubnetworkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetIamPolicySubnetworkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 276489091: {
                                        message.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetIamPolicySubnetworkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetIamPolicySubnetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetIamPolicySubnetworkRequest} SetIamPolicySubnetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetIamPolicySubnetworkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetIamPolicySubnetworkRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetIamPolicySubnetworkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetIamPolicySubnetworkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionSetPolicyRequestResource != null && message.hasOwnProperty("regionSetPolicyRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionSetPolicyRequest.verify(message.regionSetPolicyRequestResource);
                                if (error)
                                    return "regionSetPolicyRequestResource." + error;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetIamPolicySubnetworkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetIamPolicySubnetworkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetIamPolicySubnetworkRequest} SetIamPolicySubnetworkRequest
                         */
                        SetIamPolicySubnetworkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetIamPolicySubnetworkRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetIamPolicySubnetworkRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionSetPolicyRequestResource != null) {
                                if (typeof object.regionSetPolicyRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetIamPolicySubnetworkRequest.regionSetPolicyRequestResource: object expected");
                                message.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.fromObject(object.regionSetPolicyRequestResource);
                            }
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetIamPolicySubnetworkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetIamPolicySubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetIamPolicySubnetworkRequest} message SetIamPolicySubnetworkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetIamPolicySubnetworkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.regionSetPolicyRequestResource = null;
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.regionSetPolicyRequestResource != null && message.hasOwnProperty("regionSetPolicyRequestResource"))
                                object.regionSetPolicyRequestResource = $root.google.cloud.compute.v1.RegionSetPolicyRequest.toObject(message.regionSetPolicyRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetIamPolicySubnetworkRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetIamPolicySubnetworkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetIamPolicySubnetworkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetIamPolicySubnetworkRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetIamPolicySubnetworkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetIamPolicySubnetworkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetIamPolicySubnetworkRequest";
                        };
    
                        return SetIamPolicySubnetworkRequest;
                    })();
    
                    v1.SetInstanceTemplateInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a SetInstanceTemplateInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetInstanceTemplateInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] SetInstanceTemplateInstanceGroupManagerRequest instanceGroupManager
                         * @property {google.cloud.compute.v1.IInstanceGroupManagersSetInstanceTemplateRequest|null} [instanceGroupManagersSetInstanceTemplateRequestResource] SetInstanceTemplateInstanceGroupManagerRequest instanceGroupManagersSetInstanceTemplateRequestResource
                         * @property {string|null} [project] SetInstanceTemplateInstanceGroupManagerRequest project
                         * @property {string|null} [requestId] SetInstanceTemplateInstanceGroupManagerRequest requestId
                         * @property {string|null} [zone] SetInstanceTemplateInstanceGroupManagerRequest zone
                         */
    
                        /**
                         * Constructs a new SetInstanceTemplateInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetInstanceTemplateInstanceGroupManagerRequest.
                         * @implements ISetInstanceTemplateInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetInstanceTemplateInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function SetInstanceTemplateInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetInstanceTemplateInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest
                         * @instance
                         */
                        SetInstanceTemplateInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * SetInstanceTemplateInstanceGroupManagerRequest instanceGroupManagersSetInstanceTemplateRequestResource.
                         * @member {google.cloud.compute.v1.IInstanceGroupManagersSetInstanceTemplateRequest|null|undefined} instanceGroupManagersSetInstanceTemplateRequestResource
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest
                         * @instance
                         */
                        SetInstanceTemplateInstanceGroupManagerRequest.prototype.instanceGroupManagersSetInstanceTemplateRequestResource = null;
    
                        /**
                         * SetInstanceTemplateInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest
                         * @instance
                         */
                        SetInstanceTemplateInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * SetInstanceTemplateInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest
                         * @instance
                         */
                        SetInstanceTemplateInstanceGroupManagerRequest.prototype.requestId = null;
    
                        /**
                         * SetInstanceTemplateInstanceGroupManagerRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest
                         * @instance
                         */
                        SetInstanceTemplateInstanceGroupManagerRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetInstanceTemplateInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(SetInstanceTemplateInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetInstanceTemplateInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetInstanceTemplateInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest} SetInstanceTemplateInstanceGroupManagerRequest instance
                         */
                        SetInstanceTemplateInstanceGroupManagerRequest.create = function create(properties) {
                            return new SetInstanceTemplateInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetInstanceTemplateInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetInstanceTemplateInstanceGroupManagerRequest} message SetInstanceTemplateInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetInstanceTemplateInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instanceGroupManagersSetInstanceTemplateRequestResource != null && Object.hasOwnProperty.call(message, "instanceGroupManagersSetInstanceTemplateRequestResource"))
                                $root.google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest.encode(message.instanceGroupManagersSetInstanceTemplateRequestResource, writer.uint32(/* id 9809093, wireType 2 =*/78472746).fork()).ldelim();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetInstanceTemplateInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetInstanceTemplateInstanceGroupManagerRequest} message SetInstanceTemplateInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetInstanceTemplateInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetInstanceTemplateInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest} SetInstanceTemplateInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetInstanceTemplateInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 9809093: {
                                        message.instanceGroupManagersSetInstanceTemplateRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetInstanceTemplateInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest} SetInstanceTemplateInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetInstanceTemplateInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetInstanceTemplateInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetInstanceTemplateInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.instanceGroupManagersSetInstanceTemplateRequestResource != null && message.hasOwnProperty("instanceGroupManagersSetInstanceTemplateRequestResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest.verify(message.instanceGroupManagersSetInstanceTemplateRequestResource);
                                if (error)
                                    return "instanceGroupManagersSetInstanceTemplateRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetInstanceTemplateInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest} SetInstanceTemplateInstanceGroupManagerRequest
                         */
                        SetInstanceTemplateInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.instanceGroupManagersSetInstanceTemplateRequestResource != null) {
                                if (typeof object.instanceGroupManagersSetInstanceTemplateRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest.instanceGroupManagersSetInstanceTemplateRequestResource: object expected");
                                message.instanceGroupManagersSetInstanceTemplateRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest.fromObject(object.instanceGroupManagersSetInstanceTemplateRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetInstanceTemplateInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest} message SetInstanceTemplateInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetInstanceTemplateInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instanceGroupManagersSetInstanceTemplateRequestResource = null;
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instanceGroupManagersSetInstanceTemplateRequestResource != null && message.hasOwnProperty("instanceGroupManagersSetInstanceTemplateRequestResource"))
                                object.instanceGroupManagersSetInstanceTemplateRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersSetInstanceTemplateRequest.toObject(message.instanceGroupManagersSetInstanceTemplateRequestResource, options);
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            return object;
                        };
    
                        /**
                         * Converts this SetInstanceTemplateInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetInstanceTemplateInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetInstanceTemplateInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetInstanceTemplateInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest";
                        };
    
                        return SetInstanceTemplateInstanceGroupManagerRequest;
                    })();
    
                    v1.SetInstanceTemplateRegionInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a SetInstanceTemplateRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] SetInstanceTemplateRegionInstanceGroupManagerRequest instanceGroupManager
                         * @property {string|null} [project] SetInstanceTemplateRegionInstanceGroupManagerRequest project
                         * @property {string|null} [region] SetInstanceTemplateRegionInstanceGroupManagerRequest region
                         * @property {google.cloud.compute.v1.IRegionInstanceGroupManagersSetTemplateRequest|null} [regionInstanceGroupManagersSetTemplateRequestResource] SetInstanceTemplateRegionInstanceGroupManagerRequest regionInstanceGroupManagersSetTemplateRequestResource
                         * @property {string|null} [requestId] SetInstanceTemplateRegionInstanceGroupManagerRequest requestId
                         */
    
                        /**
                         * Constructs a new SetInstanceTemplateRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetInstanceTemplateRegionInstanceGroupManagerRequest.
                         * @implements ISetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetInstanceTemplateRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function SetInstanceTemplateRegionInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetInstanceTemplateRegionInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        SetInstanceTemplateRegionInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * SetInstanceTemplateRegionInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        SetInstanceTemplateRegionInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * SetInstanceTemplateRegionInstanceGroupManagerRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        SetInstanceTemplateRegionInstanceGroupManagerRequest.prototype.region = "";
    
                        /**
                         * SetInstanceTemplateRegionInstanceGroupManagerRequest regionInstanceGroupManagersSetTemplateRequestResource.
                         * @member {google.cloud.compute.v1.IRegionInstanceGroupManagersSetTemplateRequest|null|undefined} regionInstanceGroupManagersSetTemplateRequestResource
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        SetInstanceTemplateRegionInstanceGroupManagerRequest.prototype.regionInstanceGroupManagersSetTemplateRequestResource = null;
    
                        /**
                         * SetInstanceTemplateRegionInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        SetInstanceTemplateRegionInstanceGroupManagerRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetInstanceTemplateRegionInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(SetInstanceTemplateRegionInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetInstanceTemplateRegionInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetInstanceTemplateRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest} SetInstanceTemplateRegionInstanceGroupManagerRequest instance
                         */
                        SetInstanceTemplateRegionInstanceGroupManagerRequest.create = function create(properties) {
                            return new SetInstanceTemplateRegionInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetInstanceTemplateRegionInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetInstanceTemplateRegionInstanceGroupManagerRequest} message SetInstanceTemplateRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetInstanceTemplateRegionInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.regionInstanceGroupManagersSetTemplateRequestResource != null && Object.hasOwnProperty.call(message, "regionInstanceGroupManagersSetTemplateRequestResource"))
                                $root.google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest.encode(message.regionInstanceGroupManagersSetTemplateRequestResource, writer.uint32(/* id 187310412, wireType 2 =*/1498483298).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetInstanceTemplateRegionInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetInstanceTemplateRegionInstanceGroupManagerRequest} message SetInstanceTemplateRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetInstanceTemplateRegionInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetInstanceTemplateRegionInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest} SetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetInstanceTemplateRegionInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 187310412: {
                                        message.regionInstanceGroupManagersSetTemplateRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetInstanceTemplateRegionInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest} SetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetInstanceTemplateRegionInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetInstanceTemplateRegionInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetInstanceTemplateRegionInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionInstanceGroupManagersSetTemplateRequestResource != null && message.hasOwnProperty("regionInstanceGroupManagersSetTemplateRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest.verify(message.regionInstanceGroupManagersSetTemplateRequestResource);
                                if (error)
                                    return "regionInstanceGroupManagersSetTemplateRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetInstanceTemplateRegionInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest} SetInstanceTemplateRegionInstanceGroupManagerRequest
                         */
                        SetInstanceTemplateRegionInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionInstanceGroupManagersSetTemplateRequestResource != null) {
                                if (typeof object.regionInstanceGroupManagersSetTemplateRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest.regionInstanceGroupManagersSetTemplateRequestResource: object expected");
                                message.regionInstanceGroupManagersSetTemplateRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest.fromObject(object.regionInstanceGroupManagersSetTemplateRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetInstanceTemplateRegionInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest} message SetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetInstanceTemplateRegionInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.regionInstanceGroupManagersSetTemplateRequestResource = null;
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.regionInstanceGroupManagersSetTemplateRequestResource != null && message.hasOwnProperty("regionInstanceGroupManagersSetTemplateRequestResource"))
                                object.regionInstanceGroupManagersSetTemplateRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersSetTemplateRequest.toObject(message.regionInstanceGroupManagersSetTemplateRequestResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            return object;
                        };
    
                        /**
                         * Converts this SetInstanceTemplateRegionInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetInstanceTemplateRegionInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetInstanceTemplateRegionInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest";
                        };
    
                        return SetInstanceTemplateRegionInstanceGroupManagerRequest;
                    })();
    
                    v1.SetLabelsAddressRequest = (function() {
    
                        /**
                         * Properties of a SetLabelsAddressRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetLabelsAddressRequest
                         * @property {string|null} [project] SetLabelsAddressRequest project
                         * @property {string|null} [region] SetLabelsAddressRequest region
                         * @property {google.cloud.compute.v1.IRegionSetLabelsRequest|null} [regionSetLabelsRequestResource] SetLabelsAddressRequest regionSetLabelsRequestResource
                         * @property {string|null} [requestId] SetLabelsAddressRequest requestId
                         * @property {string|null} [resource] SetLabelsAddressRequest resource
                         */
    
                        /**
                         * Constructs a new SetLabelsAddressRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetLabelsAddressRequest.
                         * @implements ISetLabelsAddressRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetLabelsAddressRequest=} [properties] Properties to set
                         */
                        function SetLabelsAddressRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetLabelsAddressRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetLabelsAddressRequest
                         * @instance
                         */
                        SetLabelsAddressRequest.prototype.project = "";
    
                        /**
                         * SetLabelsAddressRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetLabelsAddressRequest
                         * @instance
                         */
                        SetLabelsAddressRequest.prototype.region = "";
    
                        /**
                         * SetLabelsAddressRequest regionSetLabelsRequestResource.
                         * @member {google.cloud.compute.v1.IRegionSetLabelsRequest|null|undefined} regionSetLabelsRequestResource
                         * @memberof google.cloud.compute.v1.SetLabelsAddressRequest
                         * @instance
                         */
                        SetLabelsAddressRequest.prototype.regionSetLabelsRequestResource = null;
    
                        /**
                         * SetLabelsAddressRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetLabelsAddressRequest
                         * @instance
                         */
                        SetLabelsAddressRequest.prototype.requestId = null;
    
                        /**
                         * SetLabelsAddressRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetLabelsAddressRequest
                         * @instance
                         */
                        SetLabelsAddressRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetLabelsAddressRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetLabelsAddressRequest
                         * @instance
                         */
                        Object.defineProperty(SetLabelsAddressRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetLabelsAddressRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetLabelsAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsAddressRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetLabelsAddressRequest} SetLabelsAddressRequest instance
                         */
                        SetLabelsAddressRequest.create = function create(properties) {
                            return new SetLabelsAddressRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetLabelsAddressRequest message. Does not implicitly {@link google.cloud.compute.v1.SetLabelsAddressRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetLabelsAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsAddressRequest} message SetLabelsAddressRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsAddressRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.regionSetLabelsRequestResource != null && Object.hasOwnProperty.call(message, "regionSetLabelsRequestResource"))
                                $root.google.cloud.compute.v1.RegionSetLabelsRequest.encode(message.regionSetLabelsRequestResource, writer.uint32(/* id 259357782, wireType 2 =*/2074862258).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetLabelsAddressRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetLabelsAddressRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsAddressRequest} message SetLabelsAddressRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsAddressRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetLabelsAddressRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetLabelsAddressRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetLabelsAddressRequest} SetLabelsAddressRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsAddressRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetLabelsAddressRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 259357782: {
                                        message.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetLabelsAddressRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsAddressRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetLabelsAddressRequest} SetLabelsAddressRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsAddressRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetLabelsAddressRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetLabelsAddressRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetLabelsAddressRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionSetLabelsRequestResource != null && message.hasOwnProperty("regionSetLabelsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionSetLabelsRequest.verify(message.regionSetLabelsRequestResource);
                                if (error)
                                    return "regionSetLabelsRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetLabelsAddressRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetLabelsAddressRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetLabelsAddressRequest} SetLabelsAddressRequest
                         */
                        SetLabelsAddressRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetLabelsAddressRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetLabelsAddressRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionSetLabelsRequestResource != null) {
                                if (typeof object.regionSetLabelsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetLabelsAddressRequest.regionSetLabelsRequestResource: object expected");
                                message.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.fromObject(object.regionSetLabelsRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetLabelsAddressRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetLabelsAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetLabelsAddressRequest} message SetLabelsAddressRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetLabelsAddressRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.regionSetLabelsRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.regionSetLabelsRequestResource != null && message.hasOwnProperty("regionSetLabelsRequestResource"))
                                object.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.toObject(message.regionSetLabelsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetLabelsAddressRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetLabelsAddressRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetLabelsAddressRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetLabelsAddressRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetLabelsAddressRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetLabelsAddressRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetLabelsAddressRequest";
                        };
    
                        return SetLabelsAddressRequest;
                    })();
    
                    v1.SetLabelsDiskRequest = (function() {
    
                        /**
                         * Properties of a SetLabelsDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetLabelsDiskRequest
                         * @property {string|null} [project] SetLabelsDiskRequest project
                         * @property {string|null} [requestId] SetLabelsDiskRequest requestId
                         * @property {string|null} [resource] SetLabelsDiskRequest resource
                         * @property {string|null} [zone] SetLabelsDiskRequest zone
                         * @property {google.cloud.compute.v1.IZoneSetLabelsRequest|null} [zoneSetLabelsRequestResource] SetLabelsDiskRequest zoneSetLabelsRequestResource
                         */
    
                        /**
                         * Constructs a new SetLabelsDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetLabelsDiskRequest.
                         * @implements ISetLabelsDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetLabelsDiskRequest=} [properties] Properties to set
                         */
                        function SetLabelsDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetLabelsDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetLabelsDiskRequest
                         * @instance
                         */
                        SetLabelsDiskRequest.prototype.project = "";
    
                        /**
                         * SetLabelsDiskRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetLabelsDiskRequest
                         * @instance
                         */
                        SetLabelsDiskRequest.prototype.requestId = null;
    
                        /**
                         * SetLabelsDiskRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetLabelsDiskRequest
                         * @instance
                         */
                        SetLabelsDiskRequest.prototype.resource = "";
    
                        /**
                         * SetLabelsDiskRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SetLabelsDiskRequest
                         * @instance
                         */
                        SetLabelsDiskRequest.prototype.zone = "";
    
                        /**
                         * SetLabelsDiskRequest zoneSetLabelsRequestResource.
                         * @member {google.cloud.compute.v1.IZoneSetLabelsRequest|null|undefined} zoneSetLabelsRequestResource
                         * @memberof google.cloud.compute.v1.SetLabelsDiskRequest
                         * @instance
                         */
                        SetLabelsDiskRequest.prototype.zoneSetLabelsRequestResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetLabelsDiskRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetLabelsDiskRequest
                         * @instance
                         */
                        Object.defineProperty(SetLabelsDiskRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetLabelsDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetLabelsDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetLabelsDiskRequest} SetLabelsDiskRequest instance
                         */
                        SetLabelsDiskRequest.create = function create(properties) {
                            return new SetLabelsDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetLabelsDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.SetLabelsDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetLabelsDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsDiskRequest} message SetLabelsDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.zoneSetLabelsRequestResource != null && Object.hasOwnProperty.call(message, "zoneSetLabelsRequestResource"))
                                $root.google.cloud.compute.v1.ZoneSetLabelsRequest.encode(message.zoneSetLabelsRequestResource, writer.uint32(/* id 364950798, wireType 2 =*/2919606386).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetLabelsDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetLabelsDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsDiskRequest} message SetLabelsDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetLabelsDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetLabelsDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetLabelsDiskRequest} SetLabelsDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetLabelsDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                case 364950798: {
                                        message.zoneSetLabelsRequestResource = $root.google.cloud.compute.v1.ZoneSetLabelsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetLabelsDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetLabelsDiskRequest} SetLabelsDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetLabelsDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetLabelsDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetLabelsDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            if (message.zoneSetLabelsRequestResource != null && message.hasOwnProperty("zoneSetLabelsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.ZoneSetLabelsRequest.verify(message.zoneSetLabelsRequestResource);
                                if (error)
                                    return "zoneSetLabelsRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetLabelsDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetLabelsDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetLabelsDiskRequest} SetLabelsDiskRequest
                         */
                        SetLabelsDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetLabelsDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetLabelsDiskRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            if (object.zoneSetLabelsRequestResource != null) {
                                if (typeof object.zoneSetLabelsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetLabelsDiskRequest.zoneSetLabelsRequestResource: object expected");
                                message.zoneSetLabelsRequestResource = $root.google.cloud.compute.v1.ZoneSetLabelsRequest.fromObject(object.zoneSetLabelsRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetLabelsDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetLabelsDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetLabelsDiskRequest} message SetLabelsDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetLabelsDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.resource = "";
                                object.project = "";
                                object.zoneSetLabelsRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.zoneSetLabelsRequestResource != null && message.hasOwnProperty("zoneSetLabelsRequestResource"))
                                object.zoneSetLabelsRequestResource = $root.google.cloud.compute.v1.ZoneSetLabelsRequest.toObject(message.zoneSetLabelsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetLabelsDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetLabelsDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetLabelsDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetLabelsDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetLabelsDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetLabelsDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetLabelsDiskRequest";
                        };
    
                        return SetLabelsDiskRequest;
                    })();
    
                    v1.SetLabelsExternalVpnGatewayRequest = (function() {
    
                        /**
                         * Properties of a SetLabelsExternalVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetLabelsExternalVpnGatewayRequest
                         * @property {google.cloud.compute.v1.IGlobalSetLabelsRequest|null} [globalSetLabelsRequestResource] SetLabelsExternalVpnGatewayRequest globalSetLabelsRequestResource
                         * @property {string|null} [project] SetLabelsExternalVpnGatewayRequest project
                         * @property {string|null} [resource] SetLabelsExternalVpnGatewayRequest resource
                         */
    
                        /**
                         * Constructs a new SetLabelsExternalVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetLabelsExternalVpnGatewayRequest.
                         * @implements ISetLabelsExternalVpnGatewayRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetLabelsExternalVpnGatewayRequest=} [properties] Properties to set
                         */
                        function SetLabelsExternalVpnGatewayRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetLabelsExternalVpnGatewayRequest globalSetLabelsRequestResource.
                         * @member {google.cloud.compute.v1.IGlobalSetLabelsRequest|null|undefined} globalSetLabelsRequestResource
                         * @memberof google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest
                         * @instance
                         */
                        SetLabelsExternalVpnGatewayRequest.prototype.globalSetLabelsRequestResource = null;
    
                        /**
                         * SetLabelsExternalVpnGatewayRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest
                         * @instance
                         */
                        SetLabelsExternalVpnGatewayRequest.prototype.project = "";
    
                        /**
                         * SetLabelsExternalVpnGatewayRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest
                         * @instance
                         */
                        SetLabelsExternalVpnGatewayRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetLabelsExternalVpnGatewayRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsExternalVpnGatewayRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest} SetLabelsExternalVpnGatewayRequest instance
                         */
                        SetLabelsExternalVpnGatewayRequest.create = function create(properties) {
                            return new SetLabelsExternalVpnGatewayRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetLabelsExternalVpnGatewayRequest message. Does not implicitly {@link google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsExternalVpnGatewayRequest} message SetLabelsExternalVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsExternalVpnGatewayRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.globalSetLabelsRequestResource != null && Object.hasOwnProperty.call(message, "globalSetLabelsRequestResource"))
                                $root.google.cloud.compute.v1.GlobalSetLabelsRequest.encode(message.globalSetLabelsRequestResource, writer.uint32(/* id 319917189, wireType 2 =*/2559337514).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetLabelsExternalVpnGatewayRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsExternalVpnGatewayRequest} message SetLabelsExternalVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsExternalVpnGatewayRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetLabelsExternalVpnGatewayRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest} SetLabelsExternalVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsExternalVpnGatewayRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 319917189: {
                                        message.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetLabelsExternalVpnGatewayRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest} SetLabelsExternalVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsExternalVpnGatewayRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetLabelsExternalVpnGatewayRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetLabelsExternalVpnGatewayRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.globalSetLabelsRequestResource != null && message.hasOwnProperty("globalSetLabelsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.verify(message.globalSetLabelsRequestResource);
                                if (error)
                                    return "globalSetLabelsRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetLabelsExternalVpnGatewayRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest} SetLabelsExternalVpnGatewayRequest
                         */
                        SetLabelsExternalVpnGatewayRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest();
                            if (object.globalSetLabelsRequestResource != null) {
                                if (typeof object.globalSetLabelsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest.globalSetLabelsRequestResource: object expected");
                                message.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.fromObject(object.globalSetLabelsRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetLabelsExternalVpnGatewayRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest} message SetLabelsExternalVpnGatewayRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetLabelsExternalVpnGatewayRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.globalSetLabelsRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.globalSetLabelsRequestResource != null && message.hasOwnProperty("globalSetLabelsRequestResource"))
                                object.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.toObject(message.globalSetLabelsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetLabelsExternalVpnGatewayRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetLabelsExternalVpnGatewayRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetLabelsExternalVpnGatewayRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetLabelsExternalVpnGatewayRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest";
                        };
    
                        return SetLabelsExternalVpnGatewayRequest;
                    })();
    
                    v1.SetLabelsForwardingRuleRequest = (function() {
    
                        /**
                         * Properties of a SetLabelsForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetLabelsForwardingRuleRequest
                         * @property {string|null} [project] SetLabelsForwardingRuleRequest project
                         * @property {string|null} [region] SetLabelsForwardingRuleRequest region
                         * @property {google.cloud.compute.v1.IRegionSetLabelsRequest|null} [regionSetLabelsRequestResource] SetLabelsForwardingRuleRequest regionSetLabelsRequestResource
                         * @property {string|null} [requestId] SetLabelsForwardingRuleRequest requestId
                         * @property {string|null} [resource] SetLabelsForwardingRuleRequest resource
                         */
    
                        /**
                         * Constructs a new SetLabelsForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetLabelsForwardingRuleRequest.
                         * @implements ISetLabelsForwardingRuleRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetLabelsForwardingRuleRequest=} [properties] Properties to set
                         */
                        function SetLabelsForwardingRuleRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetLabelsForwardingRuleRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetLabelsForwardingRuleRequest
                         * @instance
                         */
                        SetLabelsForwardingRuleRequest.prototype.project = "";
    
                        /**
                         * SetLabelsForwardingRuleRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetLabelsForwardingRuleRequest
                         * @instance
                         */
                        SetLabelsForwardingRuleRequest.prototype.region = "";
    
                        /**
                         * SetLabelsForwardingRuleRequest regionSetLabelsRequestResource.
                         * @member {google.cloud.compute.v1.IRegionSetLabelsRequest|null|undefined} regionSetLabelsRequestResource
                         * @memberof google.cloud.compute.v1.SetLabelsForwardingRuleRequest
                         * @instance
                         */
                        SetLabelsForwardingRuleRequest.prototype.regionSetLabelsRequestResource = null;
    
                        /**
                         * SetLabelsForwardingRuleRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetLabelsForwardingRuleRequest
                         * @instance
                         */
                        SetLabelsForwardingRuleRequest.prototype.requestId = null;
    
                        /**
                         * SetLabelsForwardingRuleRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetLabelsForwardingRuleRequest
                         * @instance
                         */
                        SetLabelsForwardingRuleRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetLabelsForwardingRuleRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetLabelsForwardingRuleRequest
                         * @instance
                         */
                        Object.defineProperty(SetLabelsForwardingRuleRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetLabelsForwardingRuleRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetLabelsForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsForwardingRuleRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetLabelsForwardingRuleRequest} SetLabelsForwardingRuleRequest instance
                         */
                        SetLabelsForwardingRuleRequest.create = function create(properties) {
                            return new SetLabelsForwardingRuleRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetLabelsForwardingRuleRequest message. Does not implicitly {@link google.cloud.compute.v1.SetLabelsForwardingRuleRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetLabelsForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsForwardingRuleRequest} message SetLabelsForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsForwardingRuleRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.regionSetLabelsRequestResource != null && Object.hasOwnProperty.call(message, "regionSetLabelsRequestResource"))
                                $root.google.cloud.compute.v1.RegionSetLabelsRequest.encode(message.regionSetLabelsRequestResource, writer.uint32(/* id 259357782, wireType 2 =*/2074862258).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetLabelsForwardingRuleRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetLabelsForwardingRuleRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsForwardingRuleRequest} message SetLabelsForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsForwardingRuleRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetLabelsForwardingRuleRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetLabelsForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetLabelsForwardingRuleRequest} SetLabelsForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsForwardingRuleRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetLabelsForwardingRuleRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 259357782: {
                                        message.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetLabelsForwardingRuleRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetLabelsForwardingRuleRequest} SetLabelsForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsForwardingRuleRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetLabelsForwardingRuleRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetLabelsForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetLabelsForwardingRuleRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionSetLabelsRequestResource != null && message.hasOwnProperty("regionSetLabelsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionSetLabelsRequest.verify(message.regionSetLabelsRequestResource);
                                if (error)
                                    return "regionSetLabelsRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetLabelsForwardingRuleRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetLabelsForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetLabelsForwardingRuleRequest} SetLabelsForwardingRuleRequest
                         */
                        SetLabelsForwardingRuleRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetLabelsForwardingRuleRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetLabelsForwardingRuleRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionSetLabelsRequestResource != null) {
                                if (typeof object.regionSetLabelsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetLabelsForwardingRuleRequest.regionSetLabelsRequestResource: object expected");
                                message.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.fromObject(object.regionSetLabelsRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetLabelsForwardingRuleRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetLabelsForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetLabelsForwardingRuleRequest} message SetLabelsForwardingRuleRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetLabelsForwardingRuleRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.regionSetLabelsRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.regionSetLabelsRequestResource != null && message.hasOwnProperty("regionSetLabelsRequestResource"))
                                object.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.toObject(message.regionSetLabelsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetLabelsForwardingRuleRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetLabelsForwardingRuleRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetLabelsForwardingRuleRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetLabelsForwardingRuleRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetLabelsForwardingRuleRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetLabelsForwardingRuleRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetLabelsForwardingRuleRequest";
                        };
    
                        return SetLabelsForwardingRuleRequest;
                    })();
    
                    v1.SetLabelsGlobalAddressRequest = (function() {
    
                        /**
                         * Properties of a SetLabelsGlobalAddressRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetLabelsGlobalAddressRequest
                         * @property {google.cloud.compute.v1.IGlobalSetLabelsRequest|null} [globalSetLabelsRequestResource] SetLabelsGlobalAddressRequest globalSetLabelsRequestResource
                         * @property {string|null} [project] SetLabelsGlobalAddressRequest project
                         * @property {string|null} [resource] SetLabelsGlobalAddressRequest resource
                         */
    
                        /**
                         * Constructs a new SetLabelsGlobalAddressRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetLabelsGlobalAddressRequest.
                         * @implements ISetLabelsGlobalAddressRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetLabelsGlobalAddressRequest=} [properties] Properties to set
                         */
                        function SetLabelsGlobalAddressRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetLabelsGlobalAddressRequest globalSetLabelsRequestResource.
                         * @member {google.cloud.compute.v1.IGlobalSetLabelsRequest|null|undefined} globalSetLabelsRequestResource
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalAddressRequest
                         * @instance
                         */
                        SetLabelsGlobalAddressRequest.prototype.globalSetLabelsRequestResource = null;
    
                        /**
                         * SetLabelsGlobalAddressRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalAddressRequest
                         * @instance
                         */
                        SetLabelsGlobalAddressRequest.prototype.project = "";
    
                        /**
                         * SetLabelsGlobalAddressRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalAddressRequest
                         * @instance
                         */
                        SetLabelsGlobalAddressRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetLabelsGlobalAddressRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsGlobalAddressRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetLabelsGlobalAddressRequest} SetLabelsGlobalAddressRequest instance
                         */
                        SetLabelsGlobalAddressRequest.create = function create(properties) {
                            return new SetLabelsGlobalAddressRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetLabelsGlobalAddressRequest message. Does not implicitly {@link google.cloud.compute.v1.SetLabelsGlobalAddressRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsGlobalAddressRequest} message SetLabelsGlobalAddressRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsGlobalAddressRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.globalSetLabelsRequestResource != null && Object.hasOwnProperty.call(message, "globalSetLabelsRequestResource"))
                                $root.google.cloud.compute.v1.GlobalSetLabelsRequest.encode(message.globalSetLabelsRequestResource, writer.uint32(/* id 319917189, wireType 2 =*/2559337514).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetLabelsGlobalAddressRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetLabelsGlobalAddressRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsGlobalAddressRequest} message SetLabelsGlobalAddressRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsGlobalAddressRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetLabelsGlobalAddressRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalAddressRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetLabelsGlobalAddressRequest} SetLabelsGlobalAddressRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsGlobalAddressRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetLabelsGlobalAddressRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 319917189: {
                                        message.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetLabelsGlobalAddressRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalAddressRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetLabelsGlobalAddressRequest} SetLabelsGlobalAddressRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsGlobalAddressRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetLabelsGlobalAddressRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalAddressRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetLabelsGlobalAddressRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.globalSetLabelsRequestResource != null && message.hasOwnProperty("globalSetLabelsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.verify(message.globalSetLabelsRequestResource);
                                if (error)
                                    return "globalSetLabelsRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetLabelsGlobalAddressRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalAddressRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetLabelsGlobalAddressRequest} SetLabelsGlobalAddressRequest
                         */
                        SetLabelsGlobalAddressRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetLabelsGlobalAddressRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetLabelsGlobalAddressRequest();
                            if (object.globalSetLabelsRequestResource != null) {
                                if (typeof object.globalSetLabelsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetLabelsGlobalAddressRequest.globalSetLabelsRequestResource: object expected");
                                message.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.fromObject(object.globalSetLabelsRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetLabelsGlobalAddressRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetLabelsGlobalAddressRequest} message SetLabelsGlobalAddressRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetLabelsGlobalAddressRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.globalSetLabelsRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.globalSetLabelsRequestResource != null && message.hasOwnProperty("globalSetLabelsRequestResource"))
                                object.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.toObject(message.globalSetLabelsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetLabelsGlobalAddressRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalAddressRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetLabelsGlobalAddressRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetLabelsGlobalAddressRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalAddressRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetLabelsGlobalAddressRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetLabelsGlobalAddressRequest";
                        };
    
                        return SetLabelsGlobalAddressRequest;
                    })();
    
                    v1.SetLabelsGlobalForwardingRuleRequest = (function() {
    
                        /**
                         * Properties of a SetLabelsGlobalForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetLabelsGlobalForwardingRuleRequest
                         * @property {google.cloud.compute.v1.IGlobalSetLabelsRequest|null} [globalSetLabelsRequestResource] SetLabelsGlobalForwardingRuleRequest globalSetLabelsRequestResource
                         * @property {string|null} [project] SetLabelsGlobalForwardingRuleRequest project
                         * @property {string|null} [resource] SetLabelsGlobalForwardingRuleRequest resource
                         */
    
                        /**
                         * Constructs a new SetLabelsGlobalForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetLabelsGlobalForwardingRuleRequest.
                         * @implements ISetLabelsGlobalForwardingRuleRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetLabelsGlobalForwardingRuleRequest=} [properties] Properties to set
                         */
                        function SetLabelsGlobalForwardingRuleRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetLabelsGlobalForwardingRuleRequest globalSetLabelsRequestResource.
                         * @member {google.cloud.compute.v1.IGlobalSetLabelsRequest|null|undefined} globalSetLabelsRequestResource
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest
                         * @instance
                         */
                        SetLabelsGlobalForwardingRuleRequest.prototype.globalSetLabelsRequestResource = null;
    
                        /**
                         * SetLabelsGlobalForwardingRuleRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest
                         * @instance
                         */
                        SetLabelsGlobalForwardingRuleRequest.prototype.project = "";
    
                        /**
                         * SetLabelsGlobalForwardingRuleRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest
                         * @instance
                         */
                        SetLabelsGlobalForwardingRuleRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetLabelsGlobalForwardingRuleRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsGlobalForwardingRuleRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest} SetLabelsGlobalForwardingRuleRequest instance
                         */
                        SetLabelsGlobalForwardingRuleRequest.create = function create(properties) {
                            return new SetLabelsGlobalForwardingRuleRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetLabelsGlobalForwardingRuleRequest message. Does not implicitly {@link google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsGlobalForwardingRuleRequest} message SetLabelsGlobalForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsGlobalForwardingRuleRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.globalSetLabelsRequestResource != null && Object.hasOwnProperty.call(message, "globalSetLabelsRequestResource"))
                                $root.google.cloud.compute.v1.GlobalSetLabelsRequest.encode(message.globalSetLabelsRequestResource, writer.uint32(/* id 319917189, wireType 2 =*/2559337514).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetLabelsGlobalForwardingRuleRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsGlobalForwardingRuleRequest} message SetLabelsGlobalForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsGlobalForwardingRuleRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetLabelsGlobalForwardingRuleRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest} SetLabelsGlobalForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsGlobalForwardingRuleRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 319917189: {
                                        message.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetLabelsGlobalForwardingRuleRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest} SetLabelsGlobalForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsGlobalForwardingRuleRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetLabelsGlobalForwardingRuleRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetLabelsGlobalForwardingRuleRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.globalSetLabelsRequestResource != null && message.hasOwnProperty("globalSetLabelsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.verify(message.globalSetLabelsRequestResource);
                                if (error)
                                    return "globalSetLabelsRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetLabelsGlobalForwardingRuleRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest} SetLabelsGlobalForwardingRuleRequest
                         */
                        SetLabelsGlobalForwardingRuleRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest();
                            if (object.globalSetLabelsRequestResource != null) {
                                if (typeof object.globalSetLabelsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest.globalSetLabelsRequestResource: object expected");
                                message.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.fromObject(object.globalSetLabelsRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetLabelsGlobalForwardingRuleRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest} message SetLabelsGlobalForwardingRuleRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetLabelsGlobalForwardingRuleRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.globalSetLabelsRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.globalSetLabelsRequestResource != null && message.hasOwnProperty("globalSetLabelsRequestResource"))
                                object.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.toObject(message.globalSetLabelsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetLabelsGlobalForwardingRuleRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetLabelsGlobalForwardingRuleRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetLabelsGlobalForwardingRuleRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetLabelsGlobalForwardingRuleRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest";
                        };
    
                        return SetLabelsGlobalForwardingRuleRequest;
                    })();
    
                    v1.SetLabelsImageRequest = (function() {
    
                        /**
                         * Properties of a SetLabelsImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetLabelsImageRequest
                         * @property {google.cloud.compute.v1.IGlobalSetLabelsRequest|null} [globalSetLabelsRequestResource] SetLabelsImageRequest globalSetLabelsRequestResource
                         * @property {string|null} [project] SetLabelsImageRequest project
                         * @property {string|null} [resource] SetLabelsImageRequest resource
                         */
    
                        /**
                         * Constructs a new SetLabelsImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetLabelsImageRequest.
                         * @implements ISetLabelsImageRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetLabelsImageRequest=} [properties] Properties to set
                         */
                        function SetLabelsImageRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetLabelsImageRequest globalSetLabelsRequestResource.
                         * @member {google.cloud.compute.v1.IGlobalSetLabelsRequest|null|undefined} globalSetLabelsRequestResource
                         * @memberof google.cloud.compute.v1.SetLabelsImageRequest
                         * @instance
                         */
                        SetLabelsImageRequest.prototype.globalSetLabelsRequestResource = null;
    
                        /**
                         * SetLabelsImageRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetLabelsImageRequest
                         * @instance
                         */
                        SetLabelsImageRequest.prototype.project = "";
    
                        /**
                         * SetLabelsImageRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetLabelsImageRequest
                         * @instance
                         */
                        SetLabelsImageRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetLabelsImageRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetLabelsImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsImageRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetLabelsImageRequest} SetLabelsImageRequest instance
                         */
                        SetLabelsImageRequest.create = function create(properties) {
                            return new SetLabelsImageRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetLabelsImageRequest message. Does not implicitly {@link google.cloud.compute.v1.SetLabelsImageRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetLabelsImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsImageRequest} message SetLabelsImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsImageRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.globalSetLabelsRequestResource != null && Object.hasOwnProperty.call(message, "globalSetLabelsRequestResource"))
                                $root.google.cloud.compute.v1.GlobalSetLabelsRequest.encode(message.globalSetLabelsRequestResource, writer.uint32(/* id 319917189, wireType 2 =*/2559337514).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetLabelsImageRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetLabelsImageRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsImageRequest} message SetLabelsImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsImageRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetLabelsImageRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetLabelsImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetLabelsImageRequest} SetLabelsImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsImageRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetLabelsImageRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 319917189: {
                                        message.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetLabelsImageRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetLabelsImageRequest} SetLabelsImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsImageRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetLabelsImageRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetLabelsImageRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetLabelsImageRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.globalSetLabelsRequestResource != null && message.hasOwnProperty("globalSetLabelsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.verify(message.globalSetLabelsRequestResource);
                                if (error)
                                    return "globalSetLabelsRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetLabelsImageRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetLabelsImageRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetLabelsImageRequest} SetLabelsImageRequest
                         */
                        SetLabelsImageRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetLabelsImageRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetLabelsImageRequest();
                            if (object.globalSetLabelsRequestResource != null) {
                                if (typeof object.globalSetLabelsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetLabelsImageRequest.globalSetLabelsRequestResource: object expected");
                                message.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.fromObject(object.globalSetLabelsRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetLabelsImageRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetLabelsImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetLabelsImageRequest} message SetLabelsImageRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetLabelsImageRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.globalSetLabelsRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.globalSetLabelsRequestResource != null && message.hasOwnProperty("globalSetLabelsRequestResource"))
                                object.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.toObject(message.globalSetLabelsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetLabelsImageRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetLabelsImageRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetLabelsImageRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetLabelsImageRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetLabelsImageRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetLabelsImageRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetLabelsImageRequest";
                        };
    
                        return SetLabelsImageRequest;
                    })();
    
                    v1.SetLabelsInstanceRequest = (function() {
    
                        /**
                         * Properties of a SetLabelsInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetLabelsInstanceRequest
                         * @property {string|null} [instance] SetLabelsInstanceRequest instance
                         * @property {google.cloud.compute.v1.IInstancesSetLabelsRequest|null} [instancesSetLabelsRequestResource] SetLabelsInstanceRequest instancesSetLabelsRequestResource
                         * @property {string|null} [project] SetLabelsInstanceRequest project
                         * @property {string|null} [requestId] SetLabelsInstanceRequest requestId
                         * @property {string|null} [zone] SetLabelsInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new SetLabelsInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetLabelsInstanceRequest.
                         * @implements ISetLabelsInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetLabelsInstanceRequest=} [properties] Properties to set
                         */
                        function SetLabelsInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetLabelsInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.SetLabelsInstanceRequest
                         * @instance
                         */
                        SetLabelsInstanceRequest.prototype.instance = "";
    
                        /**
                         * SetLabelsInstanceRequest instancesSetLabelsRequestResource.
                         * @member {google.cloud.compute.v1.IInstancesSetLabelsRequest|null|undefined} instancesSetLabelsRequestResource
                         * @memberof google.cloud.compute.v1.SetLabelsInstanceRequest
                         * @instance
                         */
                        SetLabelsInstanceRequest.prototype.instancesSetLabelsRequestResource = null;
    
                        /**
                         * SetLabelsInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetLabelsInstanceRequest
                         * @instance
                         */
                        SetLabelsInstanceRequest.prototype.project = "";
    
                        /**
                         * SetLabelsInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetLabelsInstanceRequest
                         * @instance
                         */
                        SetLabelsInstanceRequest.prototype.requestId = null;
    
                        /**
                         * SetLabelsInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SetLabelsInstanceRequest
                         * @instance
                         */
                        SetLabelsInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetLabelsInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetLabelsInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(SetLabelsInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetLabelsInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetLabelsInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetLabelsInstanceRequest} SetLabelsInstanceRequest instance
                         */
                        SetLabelsInstanceRequest.create = function create(properties) {
                            return new SetLabelsInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetLabelsInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.SetLabelsInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetLabelsInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsInstanceRequest} message SetLabelsInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.instancesSetLabelsRequestResource != null && Object.hasOwnProperty.call(message, "instancesSetLabelsRequestResource"))
                                $root.google.cloud.compute.v1.InstancesSetLabelsRequest.encode(message.instancesSetLabelsRequestResource, writer.uint32(/* id 207749344, wireType 2 =*/1661994754).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetLabelsInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetLabelsInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsInstanceRequest} message SetLabelsInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetLabelsInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetLabelsInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetLabelsInstanceRequest} SetLabelsInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetLabelsInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 207749344: {
                                        message.instancesSetLabelsRequestResource = $root.google.cloud.compute.v1.InstancesSetLabelsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetLabelsInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetLabelsInstanceRequest} SetLabelsInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetLabelsInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetLabelsInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetLabelsInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.instancesSetLabelsRequestResource != null && message.hasOwnProperty("instancesSetLabelsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.InstancesSetLabelsRequest.verify(message.instancesSetLabelsRequestResource);
                                if (error)
                                    return "instancesSetLabelsRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetLabelsInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetLabelsInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetLabelsInstanceRequest} SetLabelsInstanceRequest
                         */
                        SetLabelsInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetLabelsInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetLabelsInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.instancesSetLabelsRequestResource != null) {
                                if (typeof object.instancesSetLabelsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetLabelsInstanceRequest.instancesSetLabelsRequestResource: object expected");
                                message.instancesSetLabelsRequestResource = $root.google.cloud.compute.v1.InstancesSetLabelsRequest.fromObject(object.instancesSetLabelsRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetLabelsInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetLabelsInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetLabelsInstanceRequest} message SetLabelsInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetLabelsInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.instancesSetLabelsRequestResource = null;
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.instancesSetLabelsRequestResource != null && message.hasOwnProperty("instancesSetLabelsRequestResource"))
                                object.instancesSetLabelsRequestResource = $root.google.cloud.compute.v1.InstancesSetLabelsRequest.toObject(message.instancesSetLabelsRequestResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this SetLabelsInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetLabelsInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetLabelsInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetLabelsInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetLabelsInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetLabelsInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetLabelsInstanceRequest";
                        };
    
                        return SetLabelsInstanceRequest;
                    })();
    
                    v1.SetLabelsInterconnectAttachmentRequest = (function() {
    
                        /**
                         * Properties of a SetLabelsInterconnectAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetLabelsInterconnectAttachmentRequest
                         * @property {string|null} [project] SetLabelsInterconnectAttachmentRequest project
                         * @property {string|null} [region] SetLabelsInterconnectAttachmentRequest region
                         * @property {google.cloud.compute.v1.IRegionSetLabelsRequest|null} [regionSetLabelsRequestResource] SetLabelsInterconnectAttachmentRequest regionSetLabelsRequestResource
                         * @property {string|null} [requestId] SetLabelsInterconnectAttachmentRequest requestId
                         * @property {string|null} [resource] SetLabelsInterconnectAttachmentRequest resource
                         */
    
                        /**
                         * Constructs a new SetLabelsInterconnectAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetLabelsInterconnectAttachmentRequest.
                         * @implements ISetLabelsInterconnectAttachmentRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetLabelsInterconnectAttachmentRequest=} [properties] Properties to set
                         */
                        function SetLabelsInterconnectAttachmentRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetLabelsInterconnectAttachmentRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest
                         * @instance
                         */
                        SetLabelsInterconnectAttachmentRequest.prototype.project = "";
    
                        /**
                         * SetLabelsInterconnectAttachmentRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest
                         * @instance
                         */
                        SetLabelsInterconnectAttachmentRequest.prototype.region = "";
    
                        /**
                         * SetLabelsInterconnectAttachmentRequest regionSetLabelsRequestResource.
                         * @member {google.cloud.compute.v1.IRegionSetLabelsRequest|null|undefined} regionSetLabelsRequestResource
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest
                         * @instance
                         */
                        SetLabelsInterconnectAttachmentRequest.prototype.regionSetLabelsRequestResource = null;
    
                        /**
                         * SetLabelsInterconnectAttachmentRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest
                         * @instance
                         */
                        SetLabelsInterconnectAttachmentRequest.prototype.requestId = null;
    
                        /**
                         * SetLabelsInterconnectAttachmentRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest
                         * @instance
                         */
                        SetLabelsInterconnectAttachmentRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetLabelsInterconnectAttachmentRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest
                         * @instance
                         */
                        Object.defineProperty(SetLabelsInterconnectAttachmentRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetLabelsInterconnectAttachmentRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsInterconnectAttachmentRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest} SetLabelsInterconnectAttachmentRequest instance
                         */
                        SetLabelsInterconnectAttachmentRequest.create = function create(properties) {
                            return new SetLabelsInterconnectAttachmentRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetLabelsInterconnectAttachmentRequest message. Does not implicitly {@link google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsInterconnectAttachmentRequest} message SetLabelsInterconnectAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsInterconnectAttachmentRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.regionSetLabelsRequestResource != null && Object.hasOwnProperty.call(message, "regionSetLabelsRequestResource"))
                                $root.google.cloud.compute.v1.RegionSetLabelsRequest.encode(message.regionSetLabelsRequestResource, writer.uint32(/* id 259357782, wireType 2 =*/2074862258).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetLabelsInterconnectAttachmentRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsInterconnectAttachmentRequest} message SetLabelsInterconnectAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsInterconnectAttachmentRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetLabelsInterconnectAttachmentRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest} SetLabelsInterconnectAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsInterconnectAttachmentRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 259357782: {
                                        message.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetLabelsInterconnectAttachmentRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest} SetLabelsInterconnectAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsInterconnectAttachmentRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetLabelsInterconnectAttachmentRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetLabelsInterconnectAttachmentRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionSetLabelsRequestResource != null && message.hasOwnProperty("regionSetLabelsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionSetLabelsRequest.verify(message.regionSetLabelsRequestResource);
                                if (error)
                                    return "regionSetLabelsRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetLabelsInterconnectAttachmentRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest} SetLabelsInterconnectAttachmentRequest
                         */
                        SetLabelsInterconnectAttachmentRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionSetLabelsRequestResource != null) {
                                if (typeof object.regionSetLabelsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest.regionSetLabelsRequestResource: object expected");
                                message.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.fromObject(object.regionSetLabelsRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetLabelsInterconnectAttachmentRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest} message SetLabelsInterconnectAttachmentRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetLabelsInterconnectAttachmentRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.regionSetLabelsRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.regionSetLabelsRequestResource != null && message.hasOwnProperty("regionSetLabelsRequestResource"))
                                object.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.toObject(message.regionSetLabelsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetLabelsInterconnectAttachmentRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetLabelsInterconnectAttachmentRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetLabelsInterconnectAttachmentRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetLabelsInterconnectAttachmentRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest";
                        };
    
                        return SetLabelsInterconnectAttachmentRequest;
                    })();
    
                    v1.SetLabelsInterconnectRequest = (function() {
    
                        /**
                         * Properties of a SetLabelsInterconnectRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetLabelsInterconnectRequest
                         * @property {google.cloud.compute.v1.IGlobalSetLabelsRequest|null} [globalSetLabelsRequestResource] SetLabelsInterconnectRequest globalSetLabelsRequestResource
                         * @property {string|null} [project] SetLabelsInterconnectRequest project
                         * @property {string|null} [resource] SetLabelsInterconnectRequest resource
                         */
    
                        /**
                         * Constructs a new SetLabelsInterconnectRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetLabelsInterconnectRequest.
                         * @implements ISetLabelsInterconnectRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetLabelsInterconnectRequest=} [properties] Properties to set
                         */
                        function SetLabelsInterconnectRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetLabelsInterconnectRequest globalSetLabelsRequestResource.
                         * @member {google.cloud.compute.v1.IGlobalSetLabelsRequest|null|undefined} globalSetLabelsRequestResource
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectRequest
                         * @instance
                         */
                        SetLabelsInterconnectRequest.prototype.globalSetLabelsRequestResource = null;
    
                        /**
                         * SetLabelsInterconnectRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectRequest
                         * @instance
                         */
                        SetLabelsInterconnectRequest.prototype.project = "";
    
                        /**
                         * SetLabelsInterconnectRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectRequest
                         * @instance
                         */
                        SetLabelsInterconnectRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetLabelsInterconnectRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsInterconnectRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetLabelsInterconnectRequest} SetLabelsInterconnectRequest instance
                         */
                        SetLabelsInterconnectRequest.create = function create(properties) {
                            return new SetLabelsInterconnectRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetLabelsInterconnectRequest message. Does not implicitly {@link google.cloud.compute.v1.SetLabelsInterconnectRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsInterconnectRequest} message SetLabelsInterconnectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsInterconnectRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.globalSetLabelsRequestResource != null && Object.hasOwnProperty.call(message, "globalSetLabelsRequestResource"))
                                $root.google.cloud.compute.v1.GlobalSetLabelsRequest.encode(message.globalSetLabelsRequestResource, writer.uint32(/* id 319917189, wireType 2 =*/2559337514).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetLabelsInterconnectRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetLabelsInterconnectRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsInterconnectRequest} message SetLabelsInterconnectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsInterconnectRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetLabelsInterconnectRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetLabelsInterconnectRequest} SetLabelsInterconnectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsInterconnectRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetLabelsInterconnectRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 319917189: {
                                        message.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetLabelsInterconnectRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetLabelsInterconnectRequest} SetLabelsInterconnectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsInterconnectRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetLabelsInterconnectRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetLabelsInterconnectRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.globalSetLabelsRequestResource != null && message.hasOwnProperty("globalSetLabelsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.verify(message.globalSetLabelsRequestResource);
                                if (error)
                                    return "globalSetLabelsRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetLabelsInterconnectRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetLabelsInterconnectRequest} SetLabelsInterconnectRequest
                         */
                        SetLabelsInterconnectRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetLabelsInterconnectRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetLabelsInterconnectRequest();
                            if (object.globalSetLabelsRequestResource != null) {
                                if (typeof object.globalSetLabelsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetLabelsInterconnectRequest.globalSetLabelsRequestResource: object expected");
                                message.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.fromObject(object.globalSetLabelsRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetLabelsInterconnectRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetLabelsInterconnectRequest} message SetLabelsInterconnectRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetLabelsInterconnectRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.globalSetLabelsRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.globalSetLabelsRequestResource != null && message.hasOwnProperty("globalSetLabelsRequestResource"))
                                object.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.toObject(message.globalSetLabelsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetLabelsInterconnectRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetLabelsInterconnectRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetLabelsInterconnectRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetLabelsInterconnectRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetLabelsInterconnectRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetLabelsInterconnectRequest";
                        };
    
                        return SetLabelsInterconnectRequest;
                    })();
    
                    v1.SetLabelsRegionDiskRequest = (function() {
    
                        /**
                         * Properties of a SetLabelsRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetLabelsRegionDiskRequest
                         * @property {string|null} [project] SetLabelsRegionDiskRequest project
                         * @property {string|null} [region] SetLabelsRegionDiskRequest region
                         * @property {google.cloud.compute.v1.IRegionSetLabelsRequest|null} [regionSetLabelsRequestResource] SetLabelsRegionDiskRequest regionSetLabelsRequestResource
                         * @property {string|null} [requestId] SetLabelsRegionDiskRequest requestId
                         * @property {string|null} [resource] SetLabelsRegionDiskRequest resource
                         */
    
                        /**
                         * Constructs a new SetLabelsRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetLabelsRegionDiskRequest.
                         * @implements ISetLabelsRegionDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetLabelsRegionDiskRequest=} [properties] Properties to set
                         */
                        function SetLabelsRegionDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetLabelsRegionDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetLabelsRegionDiskRequest
                         * @instance
                         */
                        SetLabelsRegionDiskRequest.prototype.project = "";
    
                        /**
                         * SetLabelsRegionDiskRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetLabelsRegionDiskRequest
                         * @instance
                         */
                        SetLabelsRegionDiskRequest.prototype.region = "";
    
                        /**
                         * SetLabelsRegionDiskRequest regionSetLabelsRequestResource.
                         * @member {google.cloud.compute.v1.IRegionSetLabelsRequest|null|undefined} regionSetLabelsRequestResource
                         * @memberof google.cloud.compute.v1.SetLabelsRegionDiskRequest
                         * @instance
                         */
                        SetLabelsRegionDiskRequest.prototype.regionSetLabelsRequestResource = null;
    
                        /**
                         * SetLabelsRegionDiskRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetLabelsRegionDiskRequest
                         * @instance
                         */
                        SetLabelsRegionDiskRequest.prototype.requestId = null;
    
                        /**
                         * SetLabelsRegionDiskRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetLabelsRegionDiskRequest
                         * @instance
                         */
                        SetLabelsRegionDiskRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetLabelsRegionDiskRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetLabelsRegionDiskRequest
                         * @instance
                         */
                        Object.defineProperty(SetLabelsRegionDiskRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetLabelsRegionDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetLabelsRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsRegionDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetLabelsRegionDiskRequest} SetLabelsRegionDiskRequest instance
                         */
                        SetLabelsRegionDiskRequest.create = function create(properties) {
                            return new SetLabelsRegionDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetLabelsRegionDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.SetLabelsRegionDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetLabelsRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsRegionDiskRequest} message SetLabelsRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsRegionDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.regionSetLabelsRequestResource != null && Object.hasOwnProperty.call(message, "regionSetLabelsRequestResource"))
                                $root.google.cloud.compute.v1.RegionSetLabelsRequest.encode(message.regionSetLabelsRequestResource, writer.uint32(/* id 259357782, wireType 2 =*/2074862258).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetLabelsRegionDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetLabelsRegionDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsRegionDiskRequest} message SetLabelsRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsRegionDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetLabelsRegionDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetLabelsRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetLabelsRegionDiskRequest} SetLabelsRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsRegionDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetLabelsRegionDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 259357782: {
                                        message.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetLabelsRegionDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetLabelsRegionDiskRequest} SetLabelsRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsRegionDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetLabelsRegionDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetLabelsRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetLabelsRegionDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionSetLabelsRequestResource != null && message.hasOwnProperty("regionSetLabelsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionSetLabelsRequest.verify(message.regionSetLabelsRequestResource);
                                if (error)
                                    return "regionSetLabelsRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetLabelsRegionDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetLabelsRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetLabelsRegionDiskRequest} SetLabelsRegionDiskRequest
                         */
                        SetLabelsRegionDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetLabelsRegionDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetLabelsRegionDiskRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionSetLabelsRequestResource != null) {
                                if (typeof object.regionSetLabelsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetLabelsRegionDiskRequest.regionSetLabelsRequestResource: object expected");
                                message.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.fromObject(object.regionSetLabelsRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetLabelsRegionDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetLabelsRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetLabelsRegionDiskRequest} message SetLabelsRegionDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetLabelsRegionDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.regionSetLabelsRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.regionSetLabelsRequestResource != null && message.hasOwnProperty("regionSetLabelsRequestResource"))
                                object.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.toObject(message.regionSetLabelsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetLabelsRegionDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetLabelsRegionDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetLabelsRegionDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetLabelsRegionDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetLabelsRegionDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetLabelsRegionDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetLabelsRegionDiskRequest";
                        };
    
                        return SetLabelsRegionDiskRequest;
                    })();
    
                    v1.SetLabelsSecurityPolicyRequest = (function() {
    
                        /**
                         * Properties of a SetLabelsSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetLabelsSecurityPolicyRequest
                         * @property {google.cloud.compute.v1.IGlobalSetLabelsRequest|null} [globalSetLabelsRequestResource] SetLabelsSecurityPolicyRequest globalSetLabelsRequestResource
                         * @property {string|null} [project] SetLabelsSecurityPolicyRequest project
                         * @property {string|null} [resource] SetLabelsSecurityPolicyRequest resource
                         */
    
                        /**
                         * Constructs a new SetLabelsSecurityPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetLabelsSecurityPolicyRequest.
                         * @implements ISetLabelsSecurityPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetLabelsSecurityPolicyRequest=} [properties] Properties to set
                         */
                        function SetLabelsSecurityPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetLabelsSecurityPolicyRequest globalSetLabelsRequestResource.
                         * @member {google.cloud.compute.v1.IGlobalSetLabelsRequest|null|undefined} globalSetLabelsRequestResource
                         * @memberof google.cloud.compute.v1.SetLabelsSecurityPolicyRequest
                         * @instance
                         */
                        SetLabelsSecurityPolicyRequest.prototype.globalSetLabelsRequestResource = null;
    
                        /**
                         * SetLabelsSecurityPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetLabelsSecurityPolicyRequest
                         * @instance
                         */
                        SetLabelsSecurityPolicyRequest.prototype.project = "";
    
                        /**
                         * SetLabelsSecurityPolicyRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetLabelsSecurityPolicyRequest
                         * @instance
                         */
                        SetLabelsSecurityPolicyRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetLabelsSecurityPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetLabelsSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsSecurityPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetLabelsSecurityPolicyRequest} SetLabelsSecurityPolicyRequest instance
                         */
                        SetLabelsSecurityPolicyRequest.create = function create(properties) {
                            return new SetLabelsSecurityPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetLabelsSecurityPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetLabelsSecurityPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetLabelsSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsSecurityPolicyRequest} message SetLabelsSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsSecurityPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.globalSetLabelsRequestResource != null && Object.hasOwnProperty.call(message, "globalSetLabelsRequestResource"))
                                $root.google.cloud.compute.v1.GlobalSetLabelsRequest.encode(message.globalSetLabelsRequestResource, writer.uint32(/* id 319917189, wireType 2 =*/2559337514).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetLabelsSecurityPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetLabelsSecurityPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsSecurityPolicyRequest} message SetLabelsSecurityPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsSecurityPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetLabelsSecurityPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetLabelsSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetLabelsSecurityPolicyRequest} SetLabelsSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsSecurityPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetLabelsSecurityPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 319917189: {
                                        message.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetLabelsSecurityPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsSecurityPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetLabelsSecurityPolicyRequest} SetLabelsSecurityPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsSecurityPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetLabelsSecurityPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetLabelsSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetLabelsSecurityPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.globalSetLabelsRequestResource != null && message.hasOwnProperty("globalSetLabelsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.verify(message.globalSetLabelsRequestResource);
                                if (error)
                                    return "globalSetLabelsRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetLabelsSecurityPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetLabelsSecurityPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetLabelsSecurityPolicyRequest} SetLabelsSecurityPolicyRequest
                         */
                        SetLabelsSecurityPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetLabelsSecurityPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetLabelsSecurityPolicyRequest();
                            if (object.globalSetLabelsRequestResource != null) {
                                if (typeof object.globalSetLabelsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetLabelsSecurityPolicyRequest.globalSetLabelsRequestResource: object expected");
                                message.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.fromObject(object.globalSetLabelsRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetLabelsSecurityPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetLabelsSecurityPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetLabelsSecurityPolicyRequest} message SetLabelsSecurityPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetLabelsSecurityPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.globalSetLabelsRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.globalSetLabelsRequestResource != null && message.hasOwnProperty("globalSetLabelsRequestResource"))
                                object.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.toObject(message.globalSetLabelsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetLabelsSecurityPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetLabelsSecurityPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetLabelsSecurityPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetLabelsSecurityPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetLabelsSecurityPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetLabelsSecurityPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetLabelsSecurityPolicyRequest";
                        };
    
                        return SetLabelsSecurityPolicyRequest;
                    })();
    
                    v1.SetLabelsSnapshotRequest = (function() {
    
                        /**
                         * Properties of a SetLabelsSnapshotRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetLabelsSnapshotRequest
                         * @property {google.cloud.compute.v1.IGlobalSetLabelsRequest|null} [globalSetLabelsRequestResource] SetLabelsSnapshotRequest globalSetLabelsRequestResource
                         * @property {string|null} [project] SetLabelsSnapshotRequest project
                         * @property {string|null} [resource] SetLabelsSnapshotRequest resource
                         */
    
                        /**
                         * Constructs a new SetLabelsSnapshotRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetLabelsSnapshotRequest.
                         * @implements ISetLabelsSnapshotRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetLabelsSnapshotRequest=} [properties] Properties to set
                         */
                        function SetLabelsSnapshotRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetLabelsSnapshotRequest globalSetLabelsRequestResource.
                         * @member {google.cloud.compute.v1.IGlobalSetLabelsRequest|null|undefined} globalSetLabelsRequestResource
                         * @memberof google.cloud.compute.v1.SetLabelsSnapshotRequest
                         * @instance
                         */
                        SetLabelsSnapshotRequest.prototype.globalSetLabelsRequestResource = null;
    
                        /**
                         * SetLabelsSnapshotRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetLabelsSnapshotRequest
                         * @instance
                         */
                        SetLabelsSnapshotRequest.prototype.project = "";
    
                        /**
                         * SetLabelsSnapshotRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetLabelsSnapshotRequest
                         * @instance
                         */
                        SetLabelsSnapshotRequest.prototype.resource = "";
    
                        /**
                         * Creates a new SetLabelsSnapshotRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetLabelsSnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsSnapshotRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetLabelsSnapshotRequest} SetLabelsSnapshotRequest instance
                         */
                        SetLabelsSnapshotRequest.create = function create(properties) {
                            return new SetLabelsSnapshotRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetLabelsSnapshotRequest message. Does not implicitly {@link google.cloud.compute.v1.SetLabelsSnapshotRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetLabelsSnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsSnapshotRequest} message SetLabelsSnapshotRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsSnapshotRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.globalSetLabelsRequestResource != null && Object.hasOwnProperty.call(message, "globalSetLabelsRequestResource"))
                                $root.google.cloud.compute.v1.GlobalSetLabelsRequest.encode(message.globalSetLabelsRequestResource, writer.uint32(/* id 319917189, wireType 2 =*/2559337514).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetLabelsSnapshotRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetLabelsSnapshotRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsSnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsSnapshotRequest} message SetLabelsSnapshotRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsSnapshotRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetLabelsSnapshotRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetLabelsSnapshotRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetLabelsSnapshotRequest} SetLabelsSnapshotRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsSnapshotRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetLabelsSnapshotRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 319917189: {
                                        message.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetLabelsSnapshotRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsSnapshotRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetLabelsSnapshotRequest} SetLabelsSnapshotRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsSnapshotRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetLabelsSnapshotRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetLabelsSnapshotRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetLabelsSnapshotRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.globalSetLabelsRequestResource != null && message.hasOwnProperty("globalSetLabelsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.verify(message.globalSetLabelsRequestResource);
                                if (error)
                                    return "globalSetLabelsRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetLabelsSnapshotRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetLabelsSnapshotRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetLabelsSnapshotRequest} SetLabelsSnapshotRequest
                         */
                        SetLabelsSnapshotRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetLabelsSnapshotRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetLabelsSnapshotRequest();
                            if (object.globalSetLabelsRequestResource != null) {
                                if (typeof object.globalSetLabelsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetLabelsSnapshotRequest.globalSetLabelsRequestResource: object expected");
                                message.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.fromObject(object.globalSetLabelsRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetLabelsSnapshotRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetLabelsSnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetLabelsSnapshotRequest} message SetLabelsSnapshotRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetLabelsSnapshotRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.globalSetLabelsRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.globalSetLabelsRequestResource != null && message.hasOwnProperty("globalSetLabelsRequestResource"))
                                object.globalSetLabelsRequestResource = $root.google.cloud.compute.v1.GlobalSetLabelsRequest.toObject(message.globalSetLabelsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetLabelsSnapshotRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetLabelsSnapshotRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetLabelsSnapshotRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetLabelsSnapshotRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetLabelsSnapshotRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetLabelsSnapshotRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetLabelsSnapshotRequest";
                        };
    
                        return SetLabelsSnapshotRequest;
                    })();
    
                    v1.SetLabelsTargetVpnGatewayRequest = (function() {
    
                        /**
                         * Properties of a SetLabelsTargetVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetLabelsTargetVpnGatewayRequest
                         * @property {string|null} [project] SetLabelsTargetVpnGatewayRequest project
                         * @property {string|null} [region] SetLabelsTargetVpnGatewayRequest region
                         * @property {google.cloud.compute.v1.IRegionSetLabelsRequest|null} [regionSetLabelsRequestResource] SetLabelsTargetVpnGatewayRequest regionSetLabelsRequestResource
                         * @property {string|null} [requestId] SetLabelsTargetVpnGatewayRequest requestId
                         * @property {string|null} [resource] SetLabelsTargetVpnGatewayRequest resource
                         */
    
                        /**
                         * Constructs a new SetLabelsTargetVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetLabelsTargetVpnGatewayRequest.
                         * @implements ISetLabelsTargetVpnGatewayRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetLabelsTargetVpnGatewayRequest=} [properties] Properties to set
                         */
                        function SetLabelsTargetVpnGatewayRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetLabelsTargetVpnGatewayRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest
                         * @instance
                         */
                        SetLabelsTargetVpnGatewayRequest.prototype.project = "";
    
                        /**
                         * SetLabelsTargetVpnGatewayRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest
                         * @instance
                         */
                        SetLabelsTargetVpnGatewayRequest.prototype.region = "";
    
                        /**
                         * SetLabelsTargetVpnGatewayRequest regionSetLabelsRequestResource.
                         * @member {google.cloud.compute.v1.IRegionSetLabelsRequest|null|undefined} regionSetLabelsRequestResource
                         * @memberof google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest
                         * @instance
                         */
                        SetLabelsTargetVpnGatewayRequest.prototype.regionSetLabelsRequestResource = null;
    
                        /**
                         * SetLabelsTargetVpnGatewayRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest
                         * @instance
                         */
                        SetLabelsTargetVpnGatewayRequest.prototype.requestId = null;
    
                        /**
                         * SetLabelsTargetVpnGatewayRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest
                         * @instance
                         */
                        SetLabelsTargetVpnGatewayRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetLabelsTargetVpnGatewayRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest
                         * @instance
                         */
                        Object.defineProperty(SetLabelsTargetVpnGatewayRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetLabelsTargetVpnGatewayRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsTargetVpnGatewayRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest} SetLabelsTargetVpnGatewayRequest instance
                         */
                        SetLabelsTargetVpnGatewayRequest.create = function create(properties) {
                            return new SetLabelsTargetVpnGatewayRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetLabelsTargetVpnGatewayRequest message. Does not implicitly {@link google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsTargetVpnGatewayRequest} message SetLabelsTargetVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsTargetVpnGatewayRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.regionSetLabelsRequestResource != null && Object.hasOwnProperty.call(message, "regionSetLabelsRequestResource"))
                                $root.google.cloud.compute.v1.RegionSetLabelsRequest.encode(message.regionSetLabelsRequestResource, writer.uint32(/* id 259357782, wireType 2 =*/2074862258).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetLabelsTargetVpnGatewayRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsTargetVpnGatewayRequest} message SetLabelsTargetVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsTargetVpnGatewayRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetLabelsTargetVpnGatewayRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest} SetLabelsTargetVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsTargetVpnGatewayRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 259357782: {
                                        message.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetLabelsTargetVpnGatewayRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest} SetLabelsTargetVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsTargetVpnGatewayRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetLabelsTargetVpnGatewayRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetLabelsTargetVpnGatewayRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionSetLabelsRequestResource != null && message.hasOwnProperty("regionSetLabelsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionSetLabelsRequest.verify(message.regionSetLabelsRequestResource);
                                if (error)
                                    return "regionSetLabelsRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetLabelsTargetVpnGatewayRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest} SetLabelsTargetVpnGatewayRequest
                         */
                        SetLabelsTargetVpnGatewayRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionSetLabelsRequestResource != null) {
                                if (typeof object.regionSetLabelsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest.regionSetLabelsRequestResource: object expected");
                                message.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.fromObject(object.regionSetLabelsRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetLabelsTargetVpnGatewayRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest} message SetLabelsTargetVpnGatewayRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetLabelsTargetVpnGatewayRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.regionSetLabelsRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.regionSetLabelsRequestResource != null && message.hasOwnProperty("regionSetLabelsRequestResource"))
                                object.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.toObject(message.regionSetLabelsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetLabelsTargetVpnGatewayRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetLabelsTargetVpnGatewayRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetLabelsTargetVpnGatewayRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetLabelsTargetVpnGatewayRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest";
                        };
    
                        return SetLabelsTargetVpnGatewayRequest;
                    })();
    
                    v1.SetLabelsVpnGatewayRequest = (function() {
    
                        /**
                         * Properties of a SetLabelsVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetLabelsVpnGatewayRequest
                         * @property {string|null} [project] SetLabelsVpnGatewayRequest project
                         * @property {string|null} [region] SetLabelsVpnGatewayRequest region
                         * @property {google.cloud.compute.v1.IRegionSetLabelsRequest|null} [regionSetLabelsRequestResource] SetLabelsVpnGatewayRequest regionSetLabelsRequestResource
                         * @property {string|null} [requestId] SetLabelsVpnGatewayRequest requestId
                         * @property {string|null} [resource] SetLabelsVpnGatewayRequest resource
                         */
    
                        /**
                         * Constructs a new SetLabelsVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetLabelsVpnGatewayRequest.
                         * @implements ISetLabelsVpnGatewayRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetLabelsVpnGatewayRequest=} [properties] Properties to set
                         */
                        function SetLabelsVpnGatewayRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetLabelsVpnGatewayRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetLabelsVpnGatewayRequest
                         * @instance
                         */
                        SetLabelsVpnGatewayRequest.prototype.project = "";
    
                        /**
                         * SetLabelsVpnGatewayRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetLabelsVpnGatewayRequest
                         * @instance
                         */
                        SetLabelsVpnGatewayRequest.prototype.region = "";
    
                        /**
                         * SetLabelsVpnGatewayRequest regionSetLabelsRequestResource.
                         * @member {google.cloud.compute.v1.IRegionSetLabelsRequest|null|undefined} regionSetLabelsRequestResource
                         * @memberof google.cloud.compute.v1.SetLabelsVpnGatewayRequest
                         * @instance
                         */
                        SetLabelsVpnGatewayRequest.prototype.regionSetLabelsRequestResource = null;
    
                        /**
                         * SetLabelsVpnGatewayRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetLabelsVpnGatewayRequest
                         * @instance
                         */
                        SetLabelsVpnGatewayRequest.prototype.requestId = null;
    
                        /**
                         * SetLabelsVpnGatewayRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetLabelsVpnGatewayRequest
                         * @instance
                         */
                        SetLabelsVpnGatewayRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetLabelsVpnGatewayRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetLabelsVpnGatewayRequest
                         * @instance
                         */
                        Object.defineProperty(SetLabelsVpnGatewayRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetLabelsVpnGatewayRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetLabelsVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsVpnGatewayRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetLabelsVpnGatewayRequest} SetLabelsVpnGatewayRequest instance
                         */
                        SetLabelsVpnGatewayRequest.create = function create(properties) {
                            return new SetLabelsVpnGatewayRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetLabelsVpnGatewayRequest message. Does not implicitly {@link google.cloud.compute.v1.SetLabelsVpnGatewayRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetLabelsVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsVpnGatewayRequest} message SetLabelsVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsVpnGatewayRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.regionSetLabelsRequestResource != null && Object.hasOwnProperty.call(message, "regionSetLabelsRequestResource"))
                                $root.google.cloud.compute.v1.RegionSetLabelsRequest.encode(message.regionSetLabelsRequestResource, writer.uint32(/* id 259357782, wireType 2 =*/2074862258).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetLabelsVpnGatewayRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetLabelsVpnGatewayRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsVpnGatewayRequest} message SetLabelsVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsVpnGatewayRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetLabelsVpnGatewayRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetLabelsVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetLabelsVpnGatewayRequest} SetLabelsVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsVpnGatewayRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetLabelsVpnGatewayRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 259357782: {
                                        message.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetLabelsVpnGatewayRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetLabelsVpnGatewayRequest} SetLabelsVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsVpnGatewayRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetLabelsVpnGatewayRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetLabelsVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetLabelsVpnGatewayRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionSetLabelsRequestResource != null && message.hasOwnProperty("regionSetLabelsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionSetLabelsRequest.verify(message.regionSetLabelsRequestResource);
                                if (error)
                                    return "regionSetLabelsRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetLabelsVpnGatewayRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetLabelsVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetLabelsVpnGatewayRequest} SetLabelsVpnGatewayRequest
                         */
                        SetLabelsVpnGatewayRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetLabelsVpnGatewayRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetLabelsVpnGatewayRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionSetLabelsRequestResource != null) {
                                if (typeof object.regionSetLabelsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetLabelsVpnGatewayRequest.regionSetLabelsRequestResource: object expected");
                                message.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.fromObject(object.regionSetLabelsRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetLabelsVpnGatewayRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetLabelsVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetLabelsVpnGatewayRequest} message SetLabelsVpnGatewayRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetLabelsVpnGatewayRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.regionSetLabelsRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.regionSetLabelsRequestResource != null && message.hasOwnProperty("regionSetLabelsRequestResource"))
                                object.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.toObject(message.regionSetLabelsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetLabelsVpnGatewayRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetLabelsVpnGatewayRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetLabelsVpnGatewayRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetLabelsVpnGatewayRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetLabelsVpnGatewayRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetLabelsVpnGatewayRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetLabelsVpnGatewayRequest";
                        };
    
                        return SetLabelsVpnGatewayRequest;
                    })();
    
                    v1.SetLabelsVpnTunnelRequest = (function() {
    
                        /**
                         * Properties of a SetLabelsVpnTunnelRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetLabelsVpnTunnelRequest
                         * @property {string|null} [project] SetLabelsVpnTunnelRequest project
                         * @property {string|null} [region] SetLabelsVpnTunnelRequest region
                         * @property {google.cloud.compute.v1.IRegionSetLabelsRequest|null} [regionSetLabelsRequestResource] SetLabelsVpnTunnelRequest regionSetLabelsRequestResource
                         * @property {string|null} [requestId] SetLabelsVpnTunnelRequest requestId
                         * @property {string|null} [resource] SetLabelsVpnTunnelRequest resource
                         */
    
                        /**
                         * Constructs a new SetLabelsVpnTunnelRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetLabelsVpnTunnelRequest.
                         * @implements ISetLabelsVpnTunnelRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetLabelsVpnTunnelRequest=} [properties] Properties to set
                         */
                        function SetLabelsVpnTunnelRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetLabelsVpnTunnelRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetLabelsVpnTunnelRequest
                         * @instance
                         */
                        SetLabelsVpnTunnelRequest.prototype.project = "";
    
                        /**
                         * SetLabelsVpnTunnelRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetLabelsVpnTunnelRequest
                         * @instance
                         */
                        SetLabelsVpnTunnelRequest.prototype.region = "";
    
                        /**
                         * SetLabelsVpnTunnelRequest regionSetLabelsRequestResource.
                         * @member {google.cloud.compute.v1.IRegionSetLabelsRequest|null|undefined} regionSetLabelsRequestResource
                         * @memberof google.cloud.compute.v1.SetLabelsVpnTunnelRequest
                         * @instance
                         */
                        SetLabelsVpnTunnelRequest.prototype.regionSetLabelsRequestResource = null;
    
                        /**
                         * SetLabelsVpnTunnelRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetLabelsVpnTunnelRequest
                         * @instance
                         */
                        SetLabelsVpnTunnelRequest.prototype.requestId = null;
    
                        /**
                         * SetLabelsVpnTunnelRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.SetLabelsVpnTunnelRequest
                         * @instance
                         */
                        SetLabelsVpnTunnelRequest.prototype.resource = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetLabelsVpnTunnelRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetLabelsVpnTunnelRequest
                         * @instance
                         */
                        Object.defineProperty(SetLabelsVpnTunnelRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetLabelsVpnTunnelRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetLabelsVpnTunnelRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsVpnTunnelRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetLabelsVpnTunnelRequest} SetLabelsVpnTunnelRequest instance
                         */
                        SetLabelsVpnTunnelRequest.create = function create(properties) {
                            return new SetLabelsVpnTunnelRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetLabelsVpnTunnelRequest message. Does not implicitly {@link google.cloud.compute.v1.SetLabelsVpnTunnelRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetLabelsVpnTunnelRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsVpnTunnelRequest} message SetLabelsVpnTunnelRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsVpnTunnelRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.regionSetLabelsRequestResource != null && Object.hasOwnProperty.call(message, "regionSetLabelsRequestResource"))
                                $root.google.cloud.compute.v1.RegionSetLabelsRequest.encode(message.regionSetLabelsRequestResource, writer.uint32(/* id 259357782, wireType 2 =*/2074862258).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetLabelsVpnTunnelRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetLabelsVpnTunnelRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsVpnTunnelRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetLabelsVpnTunnelRequest} message SetLabelsVpnTunnelRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetLabelsVpnTunnelRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetLabelsVpnTunnelRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetLabelsVpnTunnelRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetLabelsVpnTunnelRequest} SetLabelsVpnTunnelRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsVpnTunnelRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetLabelsVpnTunnelRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 259357782: {
                                        message.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetLabelsVpnTunnelRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetLabelsVpnTunnelRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetLabelsVpnTunnelRequest} SetLabelsVpnTunnelRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetLabelsVpnTunnelRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetLabelsVpnTunnelRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetLabelsVpnTunnelRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetLabelsVpnTunnelRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionSetLabelsRequestResource != null && message.hasOwnProperty("regionSetLabelsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionSetLabelsRequest.verify(message.regionSetLabelsRequestResource);
                                if (error)
                                    return "regionSetLabelsRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetLabelsVpnTunnelRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetLabelsVpnTunnelRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetLabelsVpnTunnelRequest} SetLabelsVpnTunnelRequest
                         */
                        SetLabelsVpnTunnelRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetLabelsVpnTunnelRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetLabelsVpnTunnelRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionSetLabelsRequestResource != null) {
                                if (typeof object.regionSetLabelsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetLabelsVpnTunnelRequest.regionSetLabelsRequestResource: object expected");
                                message.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.fromObject(object.regionSetLabelsRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetLabelsVpnTunnelRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetLabelsVpnTunnelRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetLabelsVpnTunnelRequest} message SetLabelsVpnTunnelRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetLabelsVpnTunnelRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.regionSetLabelsRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.regionSetLabelsRequestResource != null && message.hasOwnProperty("regionSetLabelsRequestResource"))
                                object.regionSetLabelsRequestResource = $root.google.cloud.compute.v1.RegionSetLabelsRequest.toObject(message.regionSetLabelsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetLabelsVpnTunnelRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetLabelsVpnTunnelRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetLabelsVpnTunnelRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetLabelsVpnTunnelRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetLabelsVpnTunnelRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetLabelsVpnTunnelRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetLabelsVpnTunnelRequest";
                        };
    
                        return SetLabelsVpnTunnelRequest;
                    })();
    
                    v1.SetMachineResourcesInstanceRequest = (function() {
    
                        /**
                         * Properties of a SetMachineResourcesInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetMachineResourcesInstanceRequest
                         * @property {string|null} [instance] SetMachineResourcesInstanceRequest instance
                         * @property {google.cloud.compute.v1.IInstancesSetMachineResourcesRequest|null} [instancesSetMachineResourcesRequestResource] SetMachineResourcesInstanceRequest instancesSetMachineResourcesRequestResource
                         * @property {string|null} [project] SetMachineResourcesInstanceRequest project
                         * @property {string|null} [requestId] SetMachineResourcesInstanceRequest requestId
                         * @property {string|null} [zone] SetMachineResourcesInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new SetMachineResourcesInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetMachineResourcesInstanceRequest.
                         * @implements ISetMachineResourcesInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetMachineResourcesInstanceRequest=} [properties] Properties to set
                         */
                        function SetMachineResourcesInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetMachineResourcesInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.SetMachineResourcesInstanceRequest
                         * @instance
                         */
                        SetMachineResourcesInstanceRequest.prototype.instance = "";
    
                        /**
                         * SetMachineResourcesInstanceRequest instancesSetMachineResourcesRequestResource.
                         * @member {google.cloud.compute.v1.IInstancesSetMachineResourcesRequest|null|undefined} instancesSetMachineResourcesRequestResource
                         * @memberof google.cloud.compute.v1.SetMachineResourcesInstanceRequest
                         * @instance
                         */
                        SetMachineResourcesInstanceRequest.prototype.instancesSetMachineResourcesRequestResource = null;
    
                        /**
                         * SetMachineResourcesInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetMachineResourcesInstanceRequest
                         * @instance
                         */
                        SetMachineResourcesInstanceRequest.prototype.project = "";
    
                        /**
                         * SetMachineResourcesInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetMachineResourcesInstanceRequest
                         * @instance
                         */
                        SetMachineResourcesInstanceRequest.prototype.requestId = null;
    
                        /**
                         * SetMachineResourcesInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SetMachineResourcesInstanceRequest
                         * @instance
                         */
                        SetMachineResourcesInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetMachineResourcesInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetMachineResourcesInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(SetMachineResourcesInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetMachineResourcesInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetMachineResourcesInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetMachineResourcesInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetMachineResourcesInstanceRequest} SetMachineResourcesInstanceRequest instance
                         */
                        SetMachineResourcesInstanceRequest.create = function create(properties) {
                            return new SetMachineResourcesInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetMachineResourcesInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.SetMachineResourcesInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetMachineResourcesInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetMachineResourcesInstanceRequest} message SetMachineResourcesInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetMachineResourcesInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.instancesSetMachineResourcesRequestResource != null && Object.hasOwnProperty.call(message, "instancesSetMachineResourcesRequestResource"))
                                $root.google.cloud.compute.v1.InstancesSetMachineResourcesRequest.encode(message.instancesSetMachineResourcesRequestResource, writer.uint32(/* id 196286318, wireType 2 =*/1570290546).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetMachineResourcesInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetMachineResourcesInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetMachineResourcesInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetMachineResourcesInstanceRequest} message SetMachineResourcesInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetMachineResourcesInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetMachineResourcesInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetMachineResourcesInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetMachineResourcesInstanceRequest} SetMachineResourcesInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetMachineResourcesInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetMachineResourcesInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 196286318: {
                                        message.instancesSetMachineResourcesRequestResource = $root.google.cloud.compute.v1.InstancesSetMachineResourcesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetMachineResourcesInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetMachineResourcesInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetMachineResourcesInstanceRequest} SetMachineResourcesInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetMachineResourcesInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetMachineResourcesInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetMachineResourcesInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetMachineResourcesInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.instancesSetMachineResourcesRequestResource != null && message.hasOwnProperty("instancesSetMachineResourcesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.InstancesSetMachineResourcesRequest.verify(message.instancesSetMachineResourcesRequestResource);
                                if (error)
                                    return "instancesSetMachineResourcesRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetMachineResourcesInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetMachineResourcesInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetMachineResourcesInstanceRequest} SetMachineResourcesInstanceRequest
                         */
                        SetMachineResourcesInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetMachineResourcesInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetMachineResourcesInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.instancesSetMachineResourcesRequestResource != null) {
                                if (typeof object.instancesSetMachineResourcesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetMachineResourcesInstanceRequest.instancesSetMachineResourcesRequestResource: object expected");
                                message.instancesSetMachineResourcesRequestResource = $root.google.cloud.compute.v1.InstancesSetMachineResourcesRequest.fromObject(object.instancesSetMachineResourcesRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetMachineResourcesInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetMachineResourcesInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetMachineResourcesInstanceRequest} message SetMachineResourcesInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetMachineResourcesInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.instancesSetMachineResourcesRequestResource = null;
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.instancesSetMachineResourcesRequestResource != null && message.hasOwnProperty("instancesSetMachineResourcesRequestResource"))
                                object.instancesSetMachineResourcesRequestResource = $root.google.cloud.compute.v1.InstancesSetMachineResourcesRequest.toObject(message.instancesSetMachineResourcesRequestResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this SetMachineResourcesInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetMachineResourcesInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetMachineResourcesInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetMachineResourcesInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetMachineResourcesInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetMachineResourcesInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetMachineResourcesInstanceRequest";
                        };
    
                        return SetMachineResourcesInstanceRequest;
                    })();
    
                    v1.SetMachineTypeInstanceRequest = (function() {
    
                        /**
                         * Properties of a SetMachineTypeInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetMachineTypeInstanceRequest
                         * @property {string|null} [instance] SetMachineTypeInstanceRequest instance
                         * @property {google.cloud.compute.v1.IInstancesSetMachineTypeRequest|null} [instancesSetMachineTypeRequestResource] SetMachineTypeInstanceRequest instancesSetMachineTypeRequestResource
                         * @property {string|null} [project] SetMachineTypeInstanceRequest project
                         * @property {string|null} [requestId] SetMachineTypeInstanceRequest requestId
                         * @property {string|null} [zone] SetMachineTypeInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new SetMachineTypeInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetMachineTypeInstanceRequest.
                         * @implements ISetMachineTypeInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetMachineTypeInstanceRequest=} [properties] Properties to set
                         */
                        function SetMachineTypeInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetMachineTypeInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.SetMachineTypeInstanceRequest
                         * @instance
                         */
                        SetMachineTypeInstanceRequest.prototype.instance = "";
    
                        /**
                         * SetMachineTypeInstanceRequest instancesSetMachineTypeRequestResource.
                         * @member {google.cloud.compute.v1.IInstancesSetMachineTypeRequest|null|undefined} instancesSetMachineTypeRequestResource
                         * @memberof google.cloud.compute.v1.SetMachineTypeInstanceRequest
                         * @instance
                         */
                        SetMachineTypeInstanceRequest.prototype.instancesSetMachineTypeRequestResource = null;
    
                        /**
                         * SetMachineTypeInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetMachineTypeInstanceRequest
                         * @instance
                         */
                        SetMachineTypeInstanceRequest.prototype.project = "";
    
                        /**
                         * SetMachineTypeInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetMachineTypeInstanceRequest
                         * @instance
                         */
                        SetMachineTypeInstanceRequest.prototype.requestId = null;
    
                        /**
                         * SetMachineTypeInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SetMachineTypeInstanceRequest
                         * @instance
                         */
                        SetMachineTypeInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetMachineTypeInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetMachineTypeInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(SetMachineTypeInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetMachineTypeInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetMachineTypeInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetMachineTypeInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetMachineTypeInstanceRequest} SetMachineTypeInstanceRequest instance
                         */
                        SetMachineTypeInstanceRequest.create = function create(properties) {
                            return new SetMachineTypeInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetMachineTypeInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.SetMachineTypeInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetMachineTypeInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetMachineTypeInstanceRequest} message SetMachineTypeInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetMachineTypeInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instancesSetMachineTypeRequestResource != null && Object.hasOwnProperty.call(message, "instancesSetMachineTypeRequestResource"))
                                $root.google.cloud.compute.v1.InstancesSetMachineTypeRequest.encode(message.instancesSetMachineTypeRequestResource, writer.uint32(/* id 254157709, wireType 2 =*/2033261674).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetMachineTypeInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetMachineTypeInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetMachineTypeInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetMachineTypeInstanceRequest} message SetMachineTypeInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetMachineTypeInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetMachineTypeInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetMachineTypeInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetMachineTypeInstanceRequest} SetMachineTypeInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetMachineTypeInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetMachineTypeInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 254157709: {
                                        message.instancesSetMachineTypeRequestResource = $root.google.cloud.compute.v1.InstancesSetMachineTypeRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetMachineTypeInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetMachineTypeInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetMachineTypeInstanceRequest} SetMachineTypeInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetMachineTypeInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetMachineTypeInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetMachineTypeInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetMachineTypeInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.instancesSetMachineTypeRequestResource != null && message.hasOwnProperty("instancesSetMachineTypeRequestResource")) {
                                var error = $root.google.cloud.compute.v1.InstancesSetMachineTypeRequest.verify(message.instancesSetMachineTypeRequestResource);
                                if (error)
                                    return "instancesSetMachineTypeRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetMachineTypeInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetMachineTypeInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetMachineTypeInstanceRequest} SetMachineTypeInstanceRequest
                         */
                        SetMachineTypeInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetMachineTypeInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetMachineTypeInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.instancesSetMachineTypeRequestResource != null) {
                                if (typeof object.instancesSetMachineTypeRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetMachineTypeInstanceRequest.instancesSetMachineTypeRequestResource: object expected");
                                message.instancesSetMachineTypeRequestResource = $root.google.cloud.compute.v1.InstancesSetMachineTypeRequest.fromObject(object.instancesSetMachineTypeRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetMachineTypeInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetMachineTypeInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetMachineTypeInstanceRequest} message SetMachineTypeInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetMachineTypeInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                                object.instancesSetMachineTypeRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instancesSetMachineTypeRequestResource != null && message.hasOwnProperty("instancesSetMachineTypeRequestResource"))
                                object.instancesSetMachineTypeRequestResource = $root.google.cloud.compute.v1.InstancesSetMachineTypeRequest.toObject(message.instancesSetMachineTypeRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetMachineTypeInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetMachineTypeInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetMachineTypeInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetMachineTypeInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetMachineTypeInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetMachineTypeInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetMachineTypeInstanceRequest";
                        };
    
                        return SetMachineTypeInstanceRequest;
                    })();
    
                    v1.SetMetadataInstanceRequest = (function() {
    
                        /**
                         * Properties of a SetMetadataInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetMetadataInstanceRequest
                         * @property {string|null} [instance] SetMetadataInstanceRequest instance
                         * @property {google.cloud.compute.v1.IMetadata|null} [metadataResource] SetMetadataInstanceRequest metadataResource
                         * @property {string|null} [project] SetMetadataInstanceRequest project
                         * @property {string|null} [requestId] SetMetadataInstanceRequest requestId
                         * @property {string|null} [zone] SetMetadataInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new SetMetadataInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetMetadataInstanceRequest.
                         * @implements ISetMetadataInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetMetadataInstanceRequest=} [properties] Properties to set
                         */
                        function SetMetadataInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetMetadataInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.SetMetadataInstanceRequest
                         * @instance
                         */
                        SetMetadataInstanceRequest.prototype.instance = "";
    
                        /**
                         * SetMetadataInstanceRequest metadataResource.
                         * @member {google.cloud.compute.v1.IMetadata|null|undefined} metadataResource
                         * @memberof google.cloud.compute.v1.SetMetadataInstanceRequest
                         * @instance
                         */
                        SetMetadataInstanceRequest.prototype.metadataResource = null;
    
                        /**
                         * SetMetadataInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetMetadataInstanceRequest
                         * @instance
                         */
                        SetMetadataInstanceRequest.prototype.project = "";
    
                        /**
                         * SetMetadataInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetMetadataInstanceRequest
                         * @instance
                         */
                        SetMetadataInstanceRequest.prototype.requestId = null;
    
                        /**
                         * SetMetadataInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SetMetadataInstanceRequest
                         * @instance
                         */
                        SetMetadataInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetMetadataInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetMetadataInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(SetMetadataInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetMetadataInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetMetadataInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetMetadataInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetMetadataInstanceRequest} SetMetadataInstanceRequest instance
                         */
                        SetMetadataInstanceRequest.create = function create(properties) {
                            return new SetMetadataInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetMetadataInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.SetMetadataInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetMetadataInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetMetadataInstanceRequest} message SetMetadataInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetMetadataInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.metadataResource != null && Object.hasOwnProperty.call(message, "metadataResource"))
                                $root.google.cloud.compute.v1.Metadata.encode(message.metadataResource, writer.uint32(/* id 291086110, wireType 2 =*/2328688882).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetMetadataInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetMetadataInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetMetadataInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetMetadataInstanceRequest} message SetMetadataInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetMetadataInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetMetadataInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetMetadataInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetMetadataInstanceRequest} SetMetadataInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetMetadataInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetMetadataInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 291086110: {
                                        message.metadataResource = $root.google.cloud.compute.v1.Metadata.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetMetadataInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetMetadataInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetMetadataInstanceRequest} SetMetadataInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetMetadataInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetMetadataInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetMetadataInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetMetadataInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.metadataResource != null && message.hasOwnProperty("metadataResource")) {
                                var error = $root.google.cloud.compute.v1.Metadata.verify(message.metadataResource);
                                if (error)
                                    return "metadataResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetMetadataInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetMetadataInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetMetadataInstanceRequest} SetMetadataInstanceRequest
                         */
                        SetMetadataInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetMetadataInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetMetadataInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.metadataResource != null) {
                                if (typeof object.metadataResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetMetadataInstanceRequest.metadataResource: object expected");
                                message.metadataResource = $root.google.cloud.compute.v1.Metadata.fromObject(object.metadataResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetMetadataInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetMetadataInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetMetadataInstanceRequest} message SetMetadataInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetMetadataInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                                object.metadataResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.metadataResource != null && message.hasOwnProperty("metadataResource"))
                                object.metadataResource = $root.google.cloud.compute.v1.Metadata.toObject(message.metadataResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetMetadataInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetMetadataInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetMetadataInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetMetadataInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetMetadataInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetMetadataInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetMetadataInstanceRequest";
                        };
    
                        return SetMetadataInstanceRequest;
                    })();
    
                    v1.SetMinCpuPlatformInstanceRequest = (function() {
    
                        /**
                         * Properties of a SetMinCpuPlatformInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetMinCpuPlatformInstanceRequest
                         * @property {string|null} [instance] SetMinCpuPlatformInstanceRequest instance
                         * @property {google.cloud.compute.v1.IInstancesSetMinCpuPlatformRequest|null} [instancesSetMinCpuPlatformRequestResource] SetMinCpuPlatformInstanceRequest instancesSetMinCpuPlatformRequestResource
                         * @property {string|null} [project] SetMinCpuPlatformInstanceRequest project
                         * @property {string|null} [requestId] SetMinCpuPlatformInstanceRequest requestId
                         * @property {string|null} [zone] SetMinCpuPlatformInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new SetMinCpuPlatformInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetMinCpuPlatformInstanceRequest.
                         * @implements ISetMinCpuPlatformInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetMinCpuPlatformInstanceRequest=} [properties] Properties to set
                         */
                        function SetMinCpuPlatformInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetMinCpuPlatformInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest
                         * @instance
                         */
                        SetMinCpuPlatformInstanceRequest.prototype.instance = "";
    
                        /**
                         * SetMinCpuPlatformInstanceRequest instancesSetMinCpuPlatformRequestResource.
                         * @member {google.cloud.compute.v1.IInstancesSetMinCpuPlatformRequest|null|undefined} instancesSetMinCpuPlatformRequestResource
                         * @memberof google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest
                         * @instance
                         */
                        SetMinCpuPlatformInstanceRequest.prototype.instancesSetMinCpuPlatformRequestResource = null;
    
                        /**
                         * SetMinCpuPlatformInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest
                         * @instance
                         */
                        SetMinCpuPlatformInstanceRequest.prototype.project = "";
    
                        /**
                         * SetMinCpuPlatformInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest
                         * @instance
                         */
                        SetMinCpuPlatformInstanceRequest.prototype.requestId = null;
    
                        /**
                         * SetMinCpuPlatformInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest
                         * @instance
                         */
                        SetMinCpuPlatformInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetMinCpuPlatformInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(SetMinCpuPlatformInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetMinCpuPlatformInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetMinCpuPlatformInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest} SetMinCpuPlatformInstanceRequest instance
                         */
                        SetMinCpuPlatformInstanceRequest.create = function create(properties) {
                            return new SetMinCpuPlatformInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetMinCpuPlatformInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetMinCpuPlatformInstanceRequest} message SetMinCpuPlatformInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetMinCpuPlatformInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.instancesSetMinCpuPlatformRequestResource != null && Object.hasOwnProperty.call(message, "instancesSetMinCpuPlatformRequestResource"))
                                $root.google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest.encode(message.instancesSetMinCpuPlatformRequestResource, writer.uint32(/* id 148459368, wireType 2 =*/1187674946).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetMinCpuPlatformInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetMinCpuPlatformInstanceRequest} message SetMinCpuPlatformInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetMinCpuPlatformInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetMinCpuPlatformInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest} SetMinCpuPlatformInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetMinCpuPlatformInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 148459368: {
                                        message.instancesSetMinCpuPlatformRequestResource = $root.google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetMinCpuPlatformInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest} SetMinCpuPlatformInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetMinCpuPlatformInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetMinCpuPlatformInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetMinCpuPlatformInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.instancesSetMinCpuPlatformRequestResource != null && message.hasOwnProperty("instancesSetMinCpuPlatformRequestResource")) {
                                var error = $root.google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest.verify(message.instancesSetMinCpuPlatformRequestResource);
                                if (error)
                                    return "instancesSetMinCpuPlatformRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetMinCpuPlatformInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest} SetMinCpuPlatformInstanceRequest
                         */
                        SetMinCpuPlatformInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.instancesSetMinCpuPlatformRequestResource != null) {
                                if (typeof object.instancesSetMinCpuPlatformRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest.instancesSetMinCpuPlatformRequestResource: object expected");
                                message.instancesSetMinCpuPlatformRequestResource = $root.google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest.fromObject(object.instancesSetMinCpuPlatformRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetMinCpuPlatformInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest} message SetMinCpuPlatformInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetMinCpuPlatformInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.instancesSetMinCpuPlatformRequestResource = null;
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.instancesSetMinCpuPlatformRequestResource != null && message.hasOwnProperty("instancesSetMinCpuPlatformRequestResource"))
                                object.instancesSetMinCpuPlatformRequestResource = $root.google.cloud.compute.v1.InstancesSetMinCpuPlatformRequest.toObject(message.instancesSetMinCpuPlatformRequestResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this SetMinCpuPlatformInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetMinCpuPlatformInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetMinCpuPlatformInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetMinCpuPlatformInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest";
                        };
    
                        return SetMinCpuPlatformInstanceRequest;
                    })();
    
                    v1.SetNamedPortsInstanceGroupRequest = (function() {
    
                        /**
                         * Properties of a SetNamedPortsInstanceGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetNamedPortsInstanceGroupRequest
                         * @property {string|null} [instanceGroup] SetNamedPortsInstanceGroupRequest instanceGroup
                         * @property {google.cloud.compute.v1.IInstanceGroupsSetNamedPortsRequest|null} [instanceGroupsSetNamedPortsRequestResource] SetNamedPortsInstanceGroupRequest instanceGroupsSetNamedPortsRequestResource
                         * @property {string|null} [project] SetNamedPortsInstanceGroupRequest project
                         * @property {string|null} [requestId] SetNamedPortsInstanceGroupRequest requestId
                         * @property {string|null} [zone] SetNamedPortsInstanceGroupRequest zone
                         */
    
                        /**
                         * Constructs a new SetNamedPortsInstanceGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetNamedPortsInstanceGroupRequest.
                         * @implements ISetNamedPortsInstanceGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetNamedPortsInstanceGroupRequest=} [properties] Properties to set
                         */
                        function SetNamedPortsInstanceGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetNamedPortsInstanceGroupRequest instanceGroup.
                         * @member {string} instanceGroup
                         * @memberof google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest
                         * @instance
                         */
                        SetNamedPortsInstanceGroupRequest.prototype.instanceGroup = "";
    
                        /**
                         * SetNamedPortsInstanceGroupRequest instanceGroupsSetNamedPortsRequestResource.
                         * @member {google.cloud.compute.v1.IInstanceGroupsSetNamedPortsRequest|null|undefined} instanceGroupsSetNamedPortsRequestResource
                         * @memberof google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest
                         * @instance
                         */
                        SetNamedPortsInstanceGroupRequest.prototype.instanceGroupsSetNamedPortsRequestResource = null;
    
                        /**
                         * SetNamedPortsInstanceGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest
                         * @instance
                         */
                        SetNamedPortsInstanceGroupRequest.prototype.project = "";
    
                        /**
                         * SetNamedPortsInstanceGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest
                         * @instance
                         */
                        SetNamedPortsInstanceGroupRequest.prototype.requestId = null;
    
                        /**
                         * SetNamedPortsInstanceGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest
                         * @instance
                         */
                        SetNamedPortsInstanceGroupRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetNamedPortsInstanceGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest
                         * @instance
                         */
                        Object.defineProperty(SetNamedPortsInstanceGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetNamedPortsInstanceGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetNamedPortsInstanceGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest} SetNamedPortsInstanceGroupRequest instance
                         */
                        SetNamedPortsInstanceGroupRequest.create = function create(properties) {
                            return new SetNamedPortsInstanceGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetNamedPortsInstanceGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetNamedPortsInstanceGroupRequest} message SetNamedPortsInstanceGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetNamedPortsInstanceGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.instanceGroup != null && Object.hasOwnProperty.call(message, "instanceGroup"))
                                writer.uint32(/* id 81095253, wireType 2 =*/648762026).string(message.instanceGroup);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupsSetNamedPortsRequestResource != null && Object.hasOwnProperty.call(message, "instanceGroupsSetNamedPortsRequestResource"))
                                $root.google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest.encode(message.instanceGroupsSetNamedPortsRequestResource, writer.uint32(/* id 385151535, wireType 2 =*/3081212282).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetNamedPortsInstanceGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetNamedPortsInstanceGroupRequest} message SetNamedPortsInstanceGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetNamedPortsInstanceGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetNamedPortsInstanceGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest} SetNamedPortsInstanceGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetNamedPortsInstanceGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 81095253: {
                                        message.instanceGroup = reader.string();
                                        break;
                                    }
                                case 385151535: {
                                        message.instanceGroupsSetNamedPortsRequestResource = $root.google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetNamedPortsInstanceGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest} SetNamedPortsInstanceGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetNamedPortsInstanceGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetNamedPortsInstanceGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetNamedPortsInstanceGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroup != null && message.hasOwnProperty("instanceGroup"))
                                if (!$util.isString(message.instanceGroup))
                                    return "instanceGroup: string expected";
                            if (message.instanceGroupsSetNamedPortsRequestResource != null && message.hasOwnProperty("instanceGroupsSetNamedPortsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest.verify(message.instanceGroupsSetNamedPortsRequestResource);
                                if (error)
                                    return "instanceGroupsSetNamedPortsRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetNamedPortsInstanceGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest} SetNamedPortsInstanceGroupRequest
                         */
                        SetNamedPortsInstanceGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest();
                            if (object.instanceGroup != null)
                                message.instanceGroup = String(object.instanceGroup);
                            if (object.instanceGroupsSetNamedPortsRequestResource != null) {
                                if (typeof object.instanceGroupsSetNamedPortsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest.instanceGroupsSetNamedPortsRequestResource: object expected");
                                message.instanceGroupsSetNamedPortsRequestResource = $root.google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest.fromObject(object.instanceGroupsSetNamedPortsRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetNamedPortsInstanceGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest} message SetNamedPortsInstanceGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetNamedPortsInstanceGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instanceGroup = "";
                                object.project = "";
                                object.instanceGroupsSetNamedPortsRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.instanceGroup != null && message.hasOwnProperty("instanceGroup"))
                                object.instanceGroup = message.instanceGroup;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupsSetNamedPortsRequestResource != null && message.hasOwnProperty("instanceGroupsSetNamedPortsRequestResource"))
                                object.instanceGroupsSetNamedPortsRequestResource = $root.google.cloud.compute.v1.InstanceGroupsSetNamedPortsRequest.toObject(message.instanceGroupsSetNamedPortsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetNamedPortsInstanceGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetNamedPortsInstanceGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetNamedPortsInstanceGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetNamedPortsInstanceGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest";
                        };
    
                        return SetNamedPortsInstanceGroupRequest;
                    })();
    
                    v1.SetNamedPortsRegionInstanceGroupRequest = (function() {
    
                        /**
                         * Properties of a SetNamedPortsRegionInstanceGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetNamedPortsRegionInstanceGroupRequest
                         * @property {string|null} [instanceGroup] SetNamedPortsRegionInstanceGroupRequest instanceGroup
                         * @property {string|null} [project] SetNamedPortsRegionInstanceGroupRequest project
                         * @property {string|null} [region] SetNamedPortsRegionInstanceGroupRequest region
                         * @property {google.cloud.compute.v1.IRegionInstanceGroupsSetNamedPortsRequest|null} [regionInstanceGroupsSetNamedPortsRequestResource] SetNamedPortsRegionInstanceGroupRequest regionInstanceGroupsSetNamedPortsRequestResource
                         * @property {string|null} [requestId] SetNamedPortsRegionInstanceGroupRequest requestId
                         */
    
                        /**
                         * Constructs a new SetNamedPortsRegionInstanceGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetNamedPortsRegionInstanceGroupRequest.
                         * @implements ISetNamedPortsRegionInstanceGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetNamedPortsRegionInstanceGroupRequest=} [properties] Properties to set
                         */
                        function SetNamedPortsRegionInstanceGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetNamedPortsRegionInstanceGroupRequest instanceGroup.
                         * @member {string} instanceGroup
                         * @memberof google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest
                         * @instance
                         */
                        SetNamedPortsRegionInstanceGroupRequest.prototype.instanceGroup = "";
    
                        /**
                         * SetNamedPortsRegionInstanceGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest
                         * @instance
                         */
                        SetNamedPortsRegionInstanceGroupRequest.prototype.project = "";
    
                        /**
                         * SetNamedPortsRegionInstanceGroupRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest
                         * @instance
                         */
                        SetNamedPortsRegionInstanceGroupRequest.prototype.region = "";
    
                        /**
                         * SetNamedPortsRegionInstanceGroupRequest regionInstanceGroupsSetNamedPortsRequestResource.
                         * @member {google.cloud.compute.v1.IRegionInstanceGroupsSetNamedPortsRequest|null|undefined} regionInstanceGroupsSetNamedPortsRequestResource
                         * @memberof google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest
                         * @instance
                         */
                        SetNamedPortsRegionInstanceGroupRequest.prototype.regionInstanceGroupsSetNamedPortsRequestResource = null;
    
                        /**
                         * SetNamedPortsRegionInstanceGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest
                         * @instance
                         */
                        SetNamedPortsRegionInstanceGroupRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetNamedPortsRegionInstanceGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest
                         * @instance
                         */
                        Object.defineProperty(SetNamedPortsRegionInstanceGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetNamedPortsRegionInstanceGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetNamedPortsRegionInstanceGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest} SetNamedPortsRegionInstanceGroupRequest instance
                         */
                        SetNamedPortsRegionInstanceGroupRequest.create = function create(properties) {
                            return new SetNamedPortsRegionInstanceGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetNamedPortsRegionInstanceGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetNamedPortsRegionInstanceGroupRequest} message SetNamedPortsRegionInstanceGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetNamedPortsRegionInstanceGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.regionInstanceGroupsSetNamedPortsRequestResource != null && Object.hasOwnProperty.call(message, "regionInstanceGroupsSetNamedPortsRequestResource"))
                                $root.google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest.encode(message.regionInstanceGroupsSetNamedPortsRequestResource, writer.uint32(/* id 1574938, wireType 2 =*/12599506).fork()).ldelim();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.instanceGroup != null && Object.hasOwnProperty.call(message, "instanceGroup"))
                                writer.uint32(/* id 81095253, wireType 2 =*/648762026).string(message.instanceGroup);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetNamedPortsRegionInstanceGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetNamedPortsRegionInstanceGroupRequest} message SetNamedPortsRegionInstanceGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetNamedPortsRegionInstanceGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetNamedPortsRegionInstanceGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest} SetNamedPortsRegionInstanceGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetNamedPortsRegionInstanceGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 81095253: {
                                        message.instanceGroup = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 1574938: {
                                        message.regionInstanceGroupsSetNamedPortsRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetNamedPortsRegionInstanceGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest} SetNamedPortsRegionInstanceGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetNamedPortsRegionInstanceGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetNamedPortsRegionInstanceGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetNamedPortsRegionInstanceGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroup != null && message.hasOwnProperty("instanceGroup"))
                                if (!$util.isString(message.instanceGroup))
                                    return "instanceGroup: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionInstanceGroupsSetNamedPortsRequestResource != null && message.hasOwnProperty("regionInstanceGroupsSetNamedPortsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest.verify(message.regionInstanceGroupsSetNamedPortsRequestResource);
                                if (error)
                                    return "regionInstanceGroupsSetNamedPortsRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetNamedPortsRegionInstanceGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest} SetNamedPortsRegionInstanceGroupRequest
                         */
                        SetNamedPortsRegionInstanceGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest();
                            if (object.instanceGroup != null)
                                message.instanceGroup = String(object.instanceGroup);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionInstanceGroupsSetNamedPortsRequestResource != null) {
                                if (typeof object.regionInstanceGroupsSetNamedPortsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest.regionInstanceGroupsSetNamedPortsRequestResource: object expected");
                                message.regionInstanceGroupsSetNamedPortsRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest.fromObject(object.regionInstanceGroupsSetNamedPortsRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetNamedPortsRegionInstanceGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest} message SetNamedPortsRegionInstanceGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetNamedPortsRegionInstanceGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.regionInstanceGroupsSetNamedPortsRequestResource = null;
                                object.instanceGroup = "";
                                object.region = "";
                                object.project = "";
                            }
                            if (message.regionInstanceGroupsSetNamedPortsRequestResource != null && message.hasOwnProperty("regionInstanceGroupsSetNamedPortsRequestResource"))
                                object.regionInstanceGroupsSetNamedPortsRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupsSetNamedPortsRequest.toObject(message.regionInstanceGroupsSetNamedPortsRequestResource, options);
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.instanceGroup != null && message.hasOwnProperty("instanceGroup"))
                                object.instanceGroup = message.instanceGroup;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this SetNamedPortsRegionInstanceGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetNamedPortsRegionInstanceGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetNamedPortsRegionInstanceGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetNamedPortsRegionInstanceGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest";
                        };
    
                        return SetNamedPortsRegionInstanceGroupRequest;
                    })();
    
                    v1.SetNodeTemplateNodeGroupRequest = (function() {
    
                        /**
                         * Properties of a SetNodeTemplateNodeGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetNodeTemplateNodeGroupRequest
                         * @property {string|null} [nodeGroup] SetNodeTemplateNodeGroupRequest nodeGroup
                         * @property {google.cloud.compute.v1.INodeGroupsSetNodeTemplateRequest|null} [nodeGroupsSetNodeTemplateRequestResource] SetNodeTemplateNodeGroupRequest nodeGroupsSetNodeTemplateRequestResource
                         * @property {string|null} [project] SetNodeTemplateNodeGroupRequest project
                         * @property {string|null} [requestId] SetNodeTemplateNodeGroupRequest requestId
                         * @property {string|null} [zone] SetNodeTemplateNodeGroupRequest zone
                         */
    
                        /**
                         * Constructs a new SetNodeTemplateNodeGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetNodeTemplateNodeGroupRequest.
                         * @implements ISetNodeTemplateNodeGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetNodeTemplateNodeGroupRequest=} [properties] Properties to set
                         */
                        function SetNodeTemplateNodeGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetNodeTemplateNodeGroupRequest nodeGroup.
                         * @member {string} nodeGroup
                         * @memberof google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest
                         * @instance
                         */
                        SetNodeTemplateNodeGroupRequest.prototype.nodeGroup = "";
    
                        /**
                         * SetNodeTemplateNodeGroupRequest nodeGroupsSetNodeTemplateRequestResource.
                         * @member {google.cloud.compute.v1.INodeGroupsSetNodeTemplateRequest|null|undefined} nodeGroupsSetNodeTemplateRequestResource
                         * @memberof google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest
                         * @instance
                         */
                        SetNodeTemplateNodeGroupRequest.prototype.nodeGroupsSetNodeTemplateRequestResource = null;
    
                        /**
                         * SetNodeTemplateNodeGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest
                         * @instance
                         */
                        SetNodeTemplateNodeGroupRequest.prototype.project = "";
    
                        /**
                         * SetNodeTemplateNodeGroupRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest
                         * @instance
                         */
                        SetNodeTemplateNodeGroupRequest.prototype.requestId = null;
    
                        /**
                         * SetNodeTemplateNodeGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest
                         * @instance
                         */
                        SetNodeTemplateNodeGroupRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetNodeTemplateNodeGroupRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest
                         * @instance
                         */
                        Object.defineProperty(SetNodeTemplateNodeGroupRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetNodeTemplateNodeGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetNodeTemplateNodeGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest} SetNodeTemplateNodeGroupRequest instance
                         */
                        SetNodeTemplateNodeGroupRequest.create = function create(properties) {
                            return new SetNodeTemplateNodeGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetNodeTemplateNodeGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetNodeTemplateNodeGroupRequest} message SetNodeTemplateNodeGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetNodeTemplateNodeGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.nodeGroupsSetNodeTemplateRequestResource != null && Object.hasOwnProperty.call(message, "nodeGroupsSetNodeTemplateRequestResource"))
                                $root.google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest.encode(message.nodeGroupsSetNodeTemplateRequestResource, writer.uint32(/* id 117382321, wireType 2 =*/939058570).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.nodeGroup != null && Object.hasOwnProperty.call(message, "nodeGroup"))
                                writer.uint32(/* id 469958146, wireType 2 =*/3759665170).string(message.nodeGroup);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetNodeTemplateNodeGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetNodeTemplateNodeGroupRequest} message SetNodeTemplateNodeGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetNodeTemplateNodeGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetNodeTemplateNodeGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest} SetNodeTemplateNodeGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetNodeTemplateNodeGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 469958146: {
                                        message.nodeGroup = reader.string();
                                        break;
                                    }
                                case 117382321: {
                                        message.nodeGroupsSetNodeTemplateRequestResource = $root.google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetNodeTemplateNodeGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest} SetNodeTemplateNodeGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetNodeTemplateNodeGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetNodeTemplateNodeGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetNodeTemplateNodeGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.nodeGroup != null && message.hasOwnProperty("nodeGroup"))
                                if (!$util.isString(message.nodeGroup))
                                    return "nodeGroup: string expected";
                            if (message.nodeGroupsSetNodeTemplateRequestResource != null && message.hasOwnProperty("nodeGroupsSetNodeTemplateRequestResource")) {
                                var error = $root.google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest.verify(message.nodeGroupsSetNodeTemplateRequestResource);
                                if (error)
                                    return "nodeGroupsSetNodeTemplateRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetNodeTemplateNodeGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest} SetNodeTemplateNodeGroupRequest
                         */
                        SetNodeTemplateNodeGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest();
                            if (object.nodeGroup != null)
                                message.nodeGroup = String(object.nodeGroup);
                            if (object.nodeGroupsSetNodeTemplateRequestResource != null) {
                                if (typeof object.nodeGroupsSetNodeTemplateRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest.nodeGroupsSetNodeTemplateRequestResource: object expected");
                                message.nodeGroupsSetNodeTemplateRequestResource = $root.google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest.fromObject(object.nodeGroupsSetNodeTemplateRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetNodeTemplateNodeGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest} message SetNodeTemplateNodeGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetNodeTemplateNodeGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.nodeGroupsSetNodeTemplateRequestResource = null;
                                object.project = "";
                                object.nodeGroup = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.nodeGroupsSetNodeTemplateRequestResource != null && message.hasOwnProperty("nodeGroupsSetNodeTemplateRequestResource"))
                                object.nodeGroupsSetNodeTemplateRequestResource = $root.google.cloud.compute.v1.NodeGroupsSetNodeTemplateRequest.toObject(message.nodeGroupsSetNodeTemplateRequestResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.nodeGroup != null && message.hasOwnProperty("nodeGroup"))
                                object.nodeGroup = message.nodeGroup;
                            return object;
                        };
    
                        /**
                         * Converts this SetNodeTemplateNodeGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetNodeTemplateNodeGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetNodeTemplateNodeGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetNodeTemplateNodeGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest";
                        };
    
                        return SetNodeTemplateNodeGroupRequest;
                    })();
    
                    v1.SetPrivateIpGoogleAccessSubnetworkRequest = (function() {
    
                        /**
                         * Properties of a SetPrivateIpGoogleAccessSubnetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetPrivateIpGoogleAccessSubnetworkRequest
                         * @property {string|null} [project] SetPrivateIpGoogleAccessSubnetworkRequest project
                         * @property {string|null} [region] SetPrivateIpGoogleAccessSubnetworkRequest region
                         * @property {string|null} [requestId] SetPrivateIpGoogleAccessSubnetworkRequest requestId
                         * @property {string|null} [subnetwork] SetPrivateIpGoogleAccessSubnetworkRequest subnetwork
                         * @property {google.cloud.compute.v1.ISubnetworksSetPrivateIpGoogleAccessRequest|null} [subnetworksSetPrivateIpGoogleAccessRequestResource] SetPrivateIpGoogleAccessSubnetworkRequest subnetworksSetPrivateIpGoogleAccessRequestResource
                         */
    
                        /**
                         * Constructs a new SetPrivateIpGoogleAccessSubnetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetPrivateIpGoogleAccessSubnetworkRequest.
                         * @implements ISetPrivateIpGoogleAccessSubnetworkRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetPrivateIpGoogleAccessSubnetworkRequest=} [properties] Properties to set
                         */
                        function SetPrivateIpGoogleAccessSubnetworkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetPrivateIpGoogleAccessSubnetworkRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest
                         * @instance
                         */
                        SetPrivateIpGoogleAccessSubnetworkRequest.prototype.project = "";
    
                        /**
                         * SetPrivateIpGoogleAccessSubnetworkRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest
                         * @instance
                         */
                        SetPrivateIpGoogleAccessSubnetworkRequest.prototype.region = "";
    
                        /**
                         * SetPrivateIpGoogleAccessSubnetworkRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest
                         * @instance
                         */
                        SetPrivateIpGoogleAccessSubnetworkRequest.prototype.requestId = null;
    
                        /**
                         * SetPrivateIpGoogleAccessSubnetworkRequest subnetwork.
                         * @member {string} subnetwork
                         * @memberof google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest
                         * @instance
                         */
                        SetPrivateIpGoogleAccessSubnetworkRequest.prototype.subnetwork = "";
    
                        /**
                         * SetPrivateIpGoogleAccessSubnetworkRequest subnetworksSetPrivateIpGoogleAccessRequestResource.
                         * @member {google.cloud.compute.v1.ISubnetworksSetPrivateIpGoogleAccessRequest|null|undefined} subnetworksSetPrivateIpGoogleAccessRequestResource
                         * @memberof google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest
                         * @instance
                         */
                        SetPrivateIpGoogleAccessSubnetworkRequest.prototype.subnetworksSetPrivateIpGoogleAccessRequestResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetPrivateIpGoogleAccessSubnetworkRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest
                         * @instance
                         */
                        Object.defineProperty(SetPrivateIpGoogleAccessSubnetworkRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetPrivateIpGoogleAccessSubnetworkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetPrivateIpGoogleAccessSubnetworkRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest} SetPrivateIpGoogleAccessSubnetworkRequest instance
                         */
                        SetPrivateIpGoogleAccessSubnetworkRequest.create = function create(properties) {
                            return new SetPrivateIpGoogleAccessSubnetworkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetPrivateIpGoogleAccessSubnetworkRequest message. Does not implicitly {@link google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetPrivateIpGoogleAccessSubnetworkRequest} message SetPrivateIpGoogleAccessSubnetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetPrivateIpGoogleAccessSubnetworkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.subnetworksSetPrivateIpGoogleAccessRequestResource != null && Object.hasOwnProperty.call(message, "subnetworksSetPrivateIpGoogleAccessRequestResource"))
                                $root.google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest.encode(message.subnetworksSetPrivateIpGoogleAccessRequestResource, writer.uint32(/* id 268920696, wireType 2 =*/2151365570).fork()).ldelim();
                            if (message.subnetwork != null && Object.hasOwnProperty.call(message, "subnetwork"))
                                writer.uint32(/* id 307827694, wireType 2 =*/2462621554).string(message.subnetwork);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetPrivateIpGoogleAccessSubnetworkRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetPrivateIpGoogleAccessSubnetworkRequest} message SetPrivateIpGoogleAccessSubnetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetPrivateIpGoogleAccessSubnetworkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetPrivateIpGoogleAccessSubnetworkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest} SetPrivateIpGoogleAccessSubnetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetPrivateIpGoogleAccessSubnetworkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 307827694: {
                                        message.subnetwork = reader.string();
                                        break;
                                    }
                                case 268920696: {
                                        message.subnetworksSetPrivateIpGoogleAccessRequestResource = $root.google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetPrivateIpGoogleAccessSubnetworkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest} SetPrivateIpGoogleAccessSubnetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetPrivateIpGoogleAccessSubnetworkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetPrivateIpGoogleAccessSubnetworkRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetPrivateIpGoogleAccessSubnetworkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork"))
                                if (!$util.isString(message.subnetwork))
                                    return "subnetwork: string expected";
                            if (message.subnetworksSetPrivateIpGoogleAccessRequestResource != null && message.hasOwnProperty("subnetworksSetPrivateIpGoogleAccessRequestResource")) {
                                var error = $root.google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest.verify(message.subnetworksSetPrivateIpGoogleAccessRequestResource);
                                if (error)
                                    return "subnetworksSetPrivateIpGoogleAccessRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetPrivateIpGoogleAccessSubnetworkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest} SetPrivateIpGoogleAccessSubnetworkRequest
                         */
                        SetPrivateIpGoogleAccessSubnetworkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.subnetwork != null)
                                message.subnetwork = String(object.subnetwork);
                            if (object.subnetworksSetPrivateIpGoogleAccessRequestResource != null) {
                                if (typeof object.subnetworksSetPrivateIpGoogleAccessRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest.subnetworksSetPrivateIpGoogleAccessRequestResource: object expected");
                                message.subnetworksSetPrivateIpGoogleAccessRequestResource = $root.google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest.fromObject(object.subnetworksSetPrivateIpGoogleAccessRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetPrivateIpGoogleAccessSubnetworkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest} message SetPrivateIpGoogleAccessSubnetworkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetPrivateIpGoogleAccessSubnetworkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.subnetworksSetPrivateIpGoogleAccessRequestResource = null;
                                object.subnetwork = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.subnetworksSetPrivateIpGoogleAccessRequestResource != null && message.hasOwnProperty("subnetworksSetPrivateIpGoogleAccessRequestResource"))
                                object.subnetworksSetPrivateIpGoogleAccessRequestResource = $root.google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest.toObject(message.subnetworksSetPrivateIpGoogleAccessRequestResource, options);
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork"))
                                object.subnetwork = message.subnetwork;
                            return object;
                        };
    
                        /**
                         * Converts this SetPrivateIpGoogleAccessSubnetworkRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetPrivateIpGoogleAccessSubnetworkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetPrivateIpGoogleAccessSubnetworkRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetPrivateIpGoogleAccessSubnetworkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest";
                        };
    
                        return SetPrivateIpGoogleAccessSubnetworkRequest;
                    })();
    
                    v1.SetProxyHeaderTargetSslProxyRequest = (function() {
    
                        /**
                         * Properties of a SetProxyHeaderTargetSslProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetProxyHeaderTargetSslProxyRequest
                         * @property {string|null} [project] SetProxyHeaderTargetSslProxyRequest project
                         * @property {string|null} [requestId] SetProxyHeaderTargetSslProxyRequest requestId
                         * @property {google.cloud.compute.v1.ITargetSslProxiesSetProxyHeaderRequest|null} [targetSslProxiesSetProxyHeaderRequestResource] SetProxyHeaderTargetSslProxyRequest targetSslProxiesSetProxyHeaderRequestResource
                         * @property {string|null} [targetSslProxy] SetProxyHeaderTargetSslProxyRequest targetSslProxy
                         */
    
                        /**
                         * Constructs a new SetProxyHeaderTargetSslProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetProxyHeaderTargetSslProxyRequest.
                         * @implements ISetProxyHeaderTargetSslProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetProxyHeaderTargetSslProxyRequest=} [properties] Properties to set
                         */
                        function SetProxyHeaderTargetSslProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetProxyHeaderTargetSslProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest
                         * @instance
                         */
                        SetProxyHeaderTargetSslProxyRequest.prototype.project = "";
    
                        /**
                         * SetProxyHeaderTargetSslProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest
                         * @instance
                         */
                        SetProxyHeaderTargetSslProxyRequest.prototype.requestId = null;
    
                        /**
                         * SetProxyHeaderTargetSslProxyRequest targetSslProxiesSetProxyHeaderRequestResource.
                         * @member {google.cloud.compute.v1.ITargetSslProxiesSetProxyHeaderRequest|null|undefined} targetSslProxiesSetProxyHeaderRequestResource
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest
                         * @instance
                         */
                        SetProxyHeaderTargetSslProxyRequest.prototype.targetSslProxiesSetProxyHeaderRequestResource = null;
    
                        /**
                         * SetProxyHeaderTargetSslProxyRequest targetSslProxy.
                         * @member {string} targetSslProxy
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest
                         * @instance
                         */
                        SetProxyHeaderTargetSslProxyRequest.prototype.targetSslProxy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetProxyHeaderTargetSslProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest
                         * @instance
                         */
                        Object.defineProperty(SetProxyHeaderTargetSslProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetProxyHeaderTargetSslProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetProxyHeaderTargetSslProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest} SetProxyHeaderTargetSslProxyRequest instance
                         */
                        SetProxyHeaderTargetSslProxyRequest.create = function create(properties) {
                            return new SetProxyHeaderTargetSslProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetProxyHeaderTargetSslProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetProxyHeaderTargetSslProxyRequest} message SetProxyHeaderTargetSslProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetProxyHeaderTargetSslProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetSslProxiesSetProxyHeaderRequestResource != null && Object.hasOwnProperty.call(message, "targetSslProxiesSetProxyHeaderRequestResource"))
                                $root.google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest.encode(message.targetSslProxiesSetProxyHeaderRequestResource, writer.uint32(/* id 205284526, wireType 2 =*/1642276210).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetSslProxy != null && Object.hasOwnProperty.call(message, "targetSslProxy"))
                                writer.uint32(/* id 338795853, wireType 2 =*/2710366826).string(message.targetSslProxy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetProxyHeaderTargetSslProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetProxyHeaderTargetSslProxyRequest} message SetProxyHeaderTargetSslProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetProxyHeaderTargetSslProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetProxyHeaderTargetSslProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest} SetProxyHeaderTargetSslProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetProxyHeaderTargetSslProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 205284526: {
                                        message.targetSslProxiesSetProxyHeaderRequestResource = $root.google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 338795853: {
                                        message.targetSslProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetProxyHeaderTargetSslProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest} SetProxyHeaderTargetSslProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetProxyHeaderTargetSslProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetProxyHeaderTargetSslProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetProxyHeaderTargetSslProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetSslProxiesSetProxyHeaderRequestResource != null && message.hasOwnProperty("targetSslProxiesSetProxyHeaderRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest.verify(message.targetSslProxiesSetProxyHeaderRequestResource);
                                if (error)
                                    return "targetSslProxiesSetProxyHeaderRequestResource." + error;
                            }
                            if (message.targetSslProxy != null && message.hasOwnProperty("targetSslProxy"))
                                if (!$util.isString(message.targetSslProxy))
                                    return "targetSslProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetProxyHeaderTargetSslProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest} SetProxyHeaderTargetSslProxyRequest
                         */
                        SetProxyHeaderTargetSslProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetSslProxiesSetProxyHeaderRequestResource != null) {
                                if (typeof object.targetSslProxiesSetProxyHeaderRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest.targetSslProxiesSetProxyHeaderRequestResource: object expected");
                                message.targetSslProxiesSetProxyHeaderRequestResource = $root.google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest.fromObject(object.targetSslProxiesSetProxyHeaderRequestResource);
                            }
                            if (object.targetSslProxy != null)
                                message.targetSslProxy = String(object.targetSslProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetProxyHeaderTargetSslProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest} message SetProxyHeaderTargetSslProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetProxyHeaderTargetSslProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetSslProxiesSetProxyHeaderRequestResource = null;
                                object.project = "";
                                object.targetSslProxy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetSslProxiesSetProxyHeaderRequestResource != null && message.hasOwnProperty("targetSslProxiesSetProxyHeaderRequestResource"))
                                object.targetSslProxiesSetProxyHeaderRequestResource = $root.google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest.toObject(message.targetSslProxiesSetProxyHeaderRequestResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetSslProxy != null && message.hasOwnProperty("targetSslProxy"))
                                object.targetSslProxy = message.targetSslProxy;
                            return object;
                        };
    
                        /**
                         * Converts this SetProxyHeaderTargetSslProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetProxyHeaderTargetSslProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetProxyHeaderTargetSslProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetProxyHeaderTargetSslProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest";
                        };
    
                        return SetProxyHeaderTargetSslProxyRequest;
                    })();
    
                    v1.SetProxyHeaderTargetTcpProxyRequest = (function() {
    
                        /**
                         * Properties of a SetProxyHeaderTargetTcpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetProxyHeaderTargetTcpProxyRequest
                         * @property {string|null} [project] SetProxyHeaderTargetTcpProxyRequest project
                         * @property {string|null} [requestId] SetProxyHeaderTargetTcpProxyRequest requestId
                         * @property {google.cloud.compute.v1.ITargetTcpProxiesSetProxyHeaderRequest|null} [targetTcpProxiesSetProxyHeaderRequestResource] SetProxyHeaderTargetTcpProxyRequest targetTcpProxiesSetProxyHeaderRequestResource
                         * @property {string|null} [targetTcpProxy] SetProxyHeaderTargetTcpProxyRequest targetTcpProxy
                         */
    
                        /**
                         * Constructs a new SetProxyHeaderTargetTcpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetProxyHeaderTargetTcpProxyRequest.
                         * @implements ISetProxyHeaderTargetTcpProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetProxyHeaderTargetTcpProxyRequest=} [properties] Properties to set
                         */
                        function SetProxyHeaderTargetTcpProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetProxyHeaderTargetTcpProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest
                         * @instance
                         */
                        SetProxyHeaderTargetTcpProxyRequest.prototype.project = "";
    
                        /**
                         * SetProxyHeaderTargetTcpProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest
                         * @instance
                         */
                        SetProxyHeaderTargetTcpProxyRequest.prototype.requestId = null;
    
                        /**
                         * SetProxyHeaderTargetTcpProxyRequest targetTcpProxiesSetProxyHeaderRequestResource.
                         * @member {google.cloud.compute.v1.ITargetTcpProxiesSetProxyHeaderRequest|null|undefined} targetTcpProxiesSetProxyHeaderRequestResource
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest
                         * @instance
                         */
                        SetProxyHeaderTargetTcpProxyRequest.prototype.targetTcpProxiesSetProxyHeaderRequestResource = null;
    
                        /**
                         * SetProxyHeaderTargetTcpProxyRequest targetTcpProxy.
                         * @member {string} targetTcpProxy
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest
                         * @instance
                         */
                        SetProxyHeaderTargetTcpProxyRequest.prototype.targetTcpProxy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetProxyHeaderTargetTcpProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest
                         * @instance
                         */
                        Object.defineProperty(SetProxyHeaderTargetTcpProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetProxyHeaderTargetTcpProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetProxyHeaderTargetTcpProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest} SetProxyHeaderTargetTcpProxyRequest instance
                         */
                        SetProxyHeaderTargetTcpProxyRequest.create = function create(properties) {
                            return new SetProxyHeaderTargetTcpProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetProxyHeaderTargetTcpProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetProxyHeaderTargetTcpProxyRequest} message SetProxyHeaderTargetTcpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetProxyHeaderTargetTcpProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetTcpProxiesSetProxyHeaderRequestResource != null && Object.hasOwnProperty.call(message, "targetTcpProxiesSetProxyHeaderRequestResource"))
                                $root.google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest.encode(message.targetTcpProxiesSetProxyHeaderRequestResource, writer.uint32(/* id 219958339, wireType 2 =*/1759666714).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetTcpProxy != null && Object.hasOwnProperty.call(message, "targetTcpProxy"))
                                writer.uint32(/* id 503065442, wireType 2 =*/4024523538).string(message.targetTcpProxy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetProxyHeaderTargetTcpProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetProxyHeaderTargetTcpProxyRequest} message SetProxyHeaderTargetTcpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetProxyHeaderTargetTcpProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetProxyHeaderTargetTcpProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest} SetProxyHeaderTargetTcpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetProxyHeaderTargetTcpProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 219958339: {
                                        message.targetTcpProxiesSetProxyHeaderRequestResource = $root.google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 503065442: {
                                        message.targetTcpProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetProxyHeaderTargetTcpProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest} SetProxyHeaderTargetTcpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetProxyHeaderTargetTcpProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetProxyHeaderTargetTcpProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetProxyHeaderTargetTcpProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetTcpProxiesSetProxyHeaderRequestResource != null && message.hasOwnProperty("targetTcpProxiesSetProxyHeaderRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest.verify(message.targetTcpProxiesSetProxyHeaderRequestResource);
                                if (error)
                                    return "targetTcpProxiesSetProxyHeaderRequestResource." + error;
                            }
                            if (message.targetTcpProxy != null && message.hasOwnProperty("targetTcpProxy"))
                                if (!$util.isString(message.targetTcpProxy))
                                    return "targetTcpProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetProxyHeaderTargetTcpProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest} SetProxyHeaderTargetTcpProxyRequest
                         */
                        SetProxyHeaderTargetTcpProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetTcpProxiesSetProxyHeaderRequestResource != null) {
                                if (typeof object.targetTcpProxiesSetProxyHeaderRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest.targetTcpProxiesSetProxyHeaderRequestResource: object expected");
                                message.targetTcpProxiesSetProxyHeaderRequestResource = $root.google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest.fromObject(object.targetTcpProxiesSetProxyHeaderRequestResource);
                            }
                            if (object.targetTcpProxy != null)
                                message.targetTcpProxy = String(object.targetTcpProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetProxyHeaderTargetTcpProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest} message SetProxyHeaderTargetTcpProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetProxyHeaderTargetTcpProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetTcpProxiesSetProxyHeaderRequestResource = null;
                                object.project = "";
                                object.targetTcpProxy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetTcpProxiesSetProxyHeaderRequestResource != null && message.hasOwnProperty("targetTcpProxiesSetProxyHeaderRequestResource"))
                                object.targetTcpProxiesSetProxyHeaderRequestResource = $root.google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest.toObject(message.targetTcpProxiesSetProxyHeaderRequestResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetTcpProxy != null && message.hasOwnProperty("targetTcpProxy"))
                                object.targetTcpProxy = message.targetTcpProxy;
                            return object;
                        };
    
                        /**
                         * Converts this SetProxyHeaderTargetTcpProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetProxyHeaderTargetTcpProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetProxyHeaderTargetTcpProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetProxyHeaderTargetTcpProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest";
                        };
    
                        return SetProxyHeaderTargetTcpProxyRequest;
                    })();
    
                    v1.SetQuicOverrideTargetHttpsProxyRequest = (function() {
    
                        /**
                         * Properties of a SetQuicOverrideTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetQuicOverrideTargetHttpsProxyRequest
                         * @property {string|null} [project] SetQuicOverrideTargetHttpsProxyRequest project
                         * @property {string|null} [requestId] SetQuicOverrideTargetHttpsProxyRequest requestId
                         * @property {google.cloud.compute.v1.ITargetHttpsProxiesSetQuicOverrideRequest|null} [targetHttpsProxiesSetQuicOverrideRequestResource] SetQuicOverrideTargetHttpsProxyRequest targetHttpsProxiesSetQuicOverrideRequestResource
                         * @property {string|null} [targetHttpsProxy] SetQuicOverrideTargetHttpsProxyRequest targetHttpsProxy
                         */
    
                        /**
                         * Constructs a new SetQuicOverrideTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetQuicOverrideTargetHttpsProxyRequest.
                         * @implements ISetQuicOverrideTargetHttpsProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetQuicOverrideTargetHttpsProxyRequest=} [properties] Properties to set
                         */
                        function SetQuicOverrideTargetHttpsProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetQuicOverrideTargetHttpsProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest
                         * @instance
                         */
                        SetQuicOverrideTargetHttpsProxyRequest.prototype.project = "";
    
                        /**
                         * SetQuicOverrideTargetHttpsProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest
                         * @instance
                         */
                        SetQuicOverrideTargetHttpsProxyRequest.prototype.requestId = null;
    
                        /**
                         * SetQuicOverrideTargetHttpsProxyRequest targetHttpsProxiesSetQuicOverrideRequestResource.
                         * @member {google.cloud.compute.v1.ITargetHttpsProxiesSetQuicOverrideRequest|null|undefined} targetHttpsProxiesSetQuicOverrideRequestResource
                         * @memberof google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest
                         * @instance
                         */
                        SetQuicOverrideTargetHttpsProxyRequest.prototype.targetHttpsProxiesSetQuicOverrideRequestResource = null;
    
                        /**
                         * SetQuicOverrideTargetHttpsProxyRequest targetHttpsProxy.
                         * @member {string} targetHttpsProxy
                         * @memberof google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest
                         * @instance
                         */
                        SetQuicOverrideTargetHttpsProxyRequest.prototype.targetHttpsProxy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetQuicOverrideTargetHttpsProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest
                         * @instance
                         */
                        Object.defineProperty(SetQuicOverrideTargetHttpsProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetQuicOverrideTargetHttpsProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetQuicOverrideTargetHttpsProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest} SetQuicOverrideTargetHttpsProxyRequest instance
                         */
                        SetQuicOverrideTargetHttpsProxyRequest.create = function create(properties) {
                            return new SetQuicOverrideTargetHttpsProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetQuicOverrideTargetHttpsProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetQuicOverrideTargetHttpsProxyRequest} message SetQuicOverrideTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetQuicOverrideTargetHttpsProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetHttpsProxy != null && Object.hasOwnProperty.call(message, "targetHttpsProxy"))
                                writer.uint32(/* id 52336748, wireType 2 =*/418693986).string(message.targetHttpsProxy);
                            if (message.targetHttpsProxiesSetQuicOverrideRequestResource != null && Object.hasOwnProperty.call(message, "targetHttpsProxiesSetQuicOverrideRequestResource"))
                                $root.google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest.encode(message.targetHttpsProxiesSetQuicOverrideRequestResource, writer.uint32(/* id 72940258, wireType 2 =*/583522066).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetQuicOverrideTargetHttpsProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetQuicOverrideTargetHttpsProxyRequest} message SetQuicOverrideTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetQuicOverrideTargetHttpsProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetQuicOverrideTargetHttpsProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest} SetQuicOverrideTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetQuicOverrideTargetHttpsProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 72940258: {
                                        message.targetHttpsProxiesSetQuicOverrideRequestResource = $root.google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 52336748: {
                                        message.targetHttpsProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetQuicOverrideTargetHttpsProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest} SetQuicOverrideTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetQuicOverrideTargetHttpsProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetQuicOverrideTargetHttpsProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetQuicOverrideTargetHttpsProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetHttpsProxiesSetQuicOverrideRequestResource != null && message.hasOwnProperty("targetHttpsProxiesSetQuicOverrideRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest.verify(message.targetHttpsProxiesSetQuicOverrideRequestResource);
                                if (error)
                                    return "targetHttpsProxiesSetQuicOverrideRequestResource." + error;
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                if (!$util.isString(message.targetHttpsProxy))
                                    return "targetHttpsProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetQuicOverrideTargetHttpsProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest} SetQuicOverrideTargetHttpsProxyRequest
                         */
                        SetQuicOverrideTargetHttpsProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetHttpsProxiesSetQuicOverrideRequestResource != null) {
                                if (typeof object.targetHttpsProxiesSetQuicOverrideRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest.targetHttpsProxiesSetQuicOverrideRequestResource: object expected");
                                message.targetHttpsProxiesSetQuicOverrideRequestResource = $root.google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest.fromObject(object.targetHttpsProxiesSetQuicOverrideRequestResource);
                            }
                            if (object.targetHttpsProxy != null)
                                message.targetHttpsProxy = String(object.targetHttpsProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetQuicOverrideTargetHttpsProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest} message SetQuicOverrideTargetHttpsProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetQuicOverrideTargetHttpsProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetHttpsProxy = "";
                                object.targetHttpsProxiesSetQuicOverrideRequestResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                object.targetHttpsProxy = message.targetHttpsProxy;
                            if (message.targetHttpsProxiesSetQuicOverrideRequestResource != null && message.hasOwnProperty("targetHttpsProxiesSetQuicOverrideRequestResource"))
                                object.targetHttpsProxiesSetQuicOverrideRequestResource = $root.google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest.toObject(message.targetHttpsProxiesSetQuicOverrideRequestResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this SetQuicOverrideTargetHttpsProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetQuicOverrideTargetHttpsProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetQuicOverrideTargetHttpsProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetQuicOverrideTargetHttpsProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest";
                        };
    
                        return SetQuicOverrideTargetHttpsProxyRequest;
                    })();
    
                    v1.SetSchedulingInstanceRequest = (function() {
    
                        /**
                         * Properties of a SetSchedulingInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetSchedulingInstanceRequest
                         * @property {string|null} [instance] SetSchedulingInstanceRequest instance
                         * @property {string|null} [project] SetSchedulingInstanceRequest project
                         * @property {string|null} [requestId] SetSchedulingInstanceRequest requestId
                         * @property {google.cloud.compute.v1.IScheduling|null} [schedulingResource] SetSchedulingInstanceRequest schedulingResource
                         * @property {string|null} [zone] SetSchedulingInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new SetSchedulingInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetSchedulingInstanceRequest.
                         * @implements ISetSchedulingInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetSchedulingInstanceRequest=} [properties] Properties to set
                         */
                        function SetSchedulingInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetSchedulingInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.SetSchedulingInstanceRequest
                         * @instance
                         */
                        SetSchedulingInstanceRequest.prototype.instance = "";
    
                        /**
                         * SetSchedulingInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetSchedulingInstanceRequest
                         * @instance
                         */
                        SetSchedulingInstanceRequest.prototype.project = "";
    
                        /**
                         * SetSchedulingInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetSchedulingInstanceRequest
                         * @instance
                         */
                        SetSchedulingInstanceRequest.prototype.requestId = null;
    
                        /**
                         * SetSchedulingInstanceRequest schedulingResource.
                         * @member {google.cloud.compute.v1.IScheduling|null|undefined} schedulingResource
                         * @memberof google.cloud.compute.v1.SetSchedulingInstanceRequest
                         * @instance
                         */
                        SetSchedulingInstanceRequest.prototype.schedulingResource = null;
    
                        /**
                         * SetSchedulingInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SetSchedulingInstanceRequest
                         * @instance
                         */
                        SetSchedulingInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetSchedulingInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetSchedulingInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(SetSchedulingInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetSchedulingInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetSchedulingInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSchedulingInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetSchedulingInstanceRequest} SetSchedulingInstanceRequest instance
                         */
                        SetSchedulingInstanceRequest.create = function create(properties) {
                            return new SetSchedulingInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetSchedulingInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.SetSchedulingInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetSchedulingInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSchedulingInstanceRequest} message SetSchedulingInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetSchedulingInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.schedulingResource != null && Object.hasOwnProperty.call(message, "schedulingResource"))
                                $root.google.cloud.compute.v1.Scheduling.encode(message.schedulingResource, writer.uint32(/* id 463181401, wireType 2 =*/3705451210).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetSchedulingInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetSchedulingInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetSchedulingInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSchedulingInstanceRequest} message SetSchedulingInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetSchedulingInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetSchedulingInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetSchedulingInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetSchedulingInstanceRequest} SetSchedulingInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetSchedulingInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetSchedulingInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 463181401: {
                                        message.schedulingResource = $root.google.cloud.compute.v1.Scheduling.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetSchedulingInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetSchedulingInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetSchedulingInstanceRequest} SetSchedulingInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetSchedulingInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetSchedulingInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetSchedulingInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetSchedulingInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.schedulingResource != null && message.hasOwnProperty("schedulingResource")) {
                                var error = $root.google.cloud.compute.v1.Scheduling.verify(message.schedulingResource);
                                if (error)
                                    return "schedulingResource." + error;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetSchedulingInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetSchedulingInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetSchedulingInstanceRequest} SetSchedulingInstanceRequest
                         */
                        SetSchedulingInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetSchedulingInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetSchedulingInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.schedulingResource != null) {
                                if (typeof object.schedulingResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetSchedulingInstanceRequest.schedulingResource: object expected");
                                message.schedulingResource = $root.google.cloud.compute.v1.Scheduling.fromObject(object.schedulingResource);
                            }
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetSchedulingInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetSchedulingInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetSchedulingInstanceRequest} message SetSchedulingInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetSchedulingInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                                object.schedulingResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.schedulingResource != null && message.hasOwnProperty("schedulingResource"))
                                object.schedulingResource = $root.google.cloud.compute.v1.Scheduling.toObject(message.schedulingResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetSchedulingInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetSchedulingInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetSchedulingInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetSchedulingInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetSchedulingInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetSchedulingInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetSchedulingInstanceRequest";
                        };
    
                        return SetSchedulingInstanceRequest;
                    })();
    
                    v1.SetSecurityPolicyBackendServiceRequest = (function() {
    
                        /**
                         * Properties of a SetSecurityPolicyBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetSecurityPolicyBackendServiceRequest
                         * @property {string|null} [backendService] SetSecurityPolicyBackendServiceRequest backendService
                         * @property {string|null} [project] SetSecurityPolicyBackendServiceRequest project
                         * @property {string|null} [requestId] SetSecurityPolicyBackendServiceRequest requestId
                         * @property {google.cloud.compute.v1.ISecurityPolicyReference|null} [securityPolicyReferenceResource] SetSecurityPolicyBackendServiceRequest securityPolicyReferenceResource
                         */
    
                        /**
                         * Constructs a new SetSecurityPolicyBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetSecurityPolicyBackendServiceRequest.
                         * @implements ISetSecurityPolicyBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetSecurityPolicyBackendServiceRequest=} [properties] Properties to set
                         */
                        function SetSecurityPolicyBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetSecurityPolicyBackendServiceRequest backendService.
                         * @member {string} backendService
                         * @memberof google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest
                         * @instance
                         */
                        SetSecurityPolicyBackendServiceRequest.prototype.backendService = "";
    
                        /**
                         * SetSecurityPolicyBackendServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest
                         * @instance
                         */
                        SetSecurityPolicyBackendServiceRequest.prototype.project = "";
    
                        /**
                         * SetSecurityPolicyBackendServiceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest
                         * @instance
                         */
                        SetSecurityPolicyBackendServiceRequest.prototype.requestId = null;
    
                        /**
                         * SetSecurityPolicyBackendServiceRequest securityPolicyReferenceResource.
                         * @member {google.cloud.compute.v1.ISecurityPolicyReference|null|undefined} securityPolicyReferenceResource
                         * @memberof google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest
                         * @instance
                         */
                        SetSecurityPolicyBackendServiceRequest.prototype.securityPolicyReferenceResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetSecurityPolicyBackendServiceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest
                         * @instance
                         */
                        Object.defineProperty(SetSecurityPolicyBackendServiceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetSecurityPolicyBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSecurityPolicyBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest} SetSecurityPolicyBackendServiceRequest instance
                         */
                        SetSecurityPolicyBackendServiceRequest.create = function create(properties) {
                            return new SetSecurityPolicyBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetSecurityPolicyBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSecurityPolicyBackendServiceRequest} message SetSecurityPolicyBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetSecurityPolicyBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.securityPolicyReferenceResource != null && Object.hasOwnProperty.call(message, "securityPolicyReferenceResource"))
                                $root.google.cloud.compute.v1.SecurityPolicyReference.encode(message.securityPolicyReferenceResource, writer.uint32(/* id 204135024, wireType 2 =*/1633080194).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.backendService != null && Object.hasOwnProperty.call(message, "backendService"))
                                writer.uint32(/* id 306946058, wireType 2 =*/2455568466).string(message.backendService);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetSecurityPolicyBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSecurityPolicyBackendServiceRequest} message SetSecurityPolicyBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetSecurityPolicyBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetSecurityPolicyBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest} SetSecurityPolicyBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetSecurityPolicyBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 306946058: {
                                        message.backendService = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 204135024: {
                                        message.securityPolicyReferenceResource = $root.google.cloud.compute.v1.SecurityPolicyReference.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetSecurityPolicyBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest} SetSecurityPolicyBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetSecurityPolicyBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetSecurityPolicyBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetSecurityPolicyBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                if (!$util.isString(message.backendService))
                                    return "backendService: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.securityPolicyReferenceResource != null && message.hasOwnProperty("securityPolicyReferenceResource")) {
                                var error = $root.google.cloud.compute.v1.SecurityPolicyReference.verify(message.securityPolicyReferenceResource);
                                if (error)
                                    return "securityPolicyReferenceResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetSecurityPolicyBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest} SetSecurityPolicyBackendServiceRequest
                         */
                        SetSecurityPolicyBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest();
                            if (object.backendService != null)
                                message.backendService = String(object.backendService);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.securityPolicyReferenceResource != null) {
                                if (typeof object.securityPolicyReferenceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest.securityPolicyReferenceResource: object expected");
                                message.securityPolicyReferenceResource = $root.google.cloud.compute.v1.SecurityPolicyReference.fromObject(object.securityPolicyReferenceResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetSecurityPolicyBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest} message SetSecurityPolicyBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetSecurityPolicyBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.securityPolicyReferenceResource = null;
                                object.project = "";
                                object.backendService = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.securityPolicyReferenceResource != null && message.hasOwnProperty("securityPolicyReferenceResource"))
                                object.securityPolicyReferenceResource = $root.google.cloud.compute.v1.SecurityPolicyReference.toObject(message.securityPolicyReferenceResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                object.backendService = message.backendService;
                            return object;
                        };
    
                        /**
                         * Converts this SetSecurityPolicyBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetSecurityPolicyBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetSecurityPolicyBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetSecurityPolicyBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest";
                        };
    
                        return SetSecurityPolicyBackendServiceRequest;
                    })();
    
                    v1.SetServiceAccountInstanceRequest = (function() {
    
                        /**
                         * Properties of a SetServiceAccountInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetServiceAccountInstanceRequest
                         * @property {string|null} [instance] SetServiceAccountInstanceRequest instance
                         * @property {google.cloud.compute.v1.IInstancesSetServiceAccountRequest|null} [instancesSetServiceAccountRequestResource] SetServiceAccountInstanceRequest instancesSetServiceAccountRequestResource
                         * @property {string|null} [project] SetServiceAccountInstanceRequest project
                         * @property {string|null} [requestId] SetServiceAccountInstanceRequest requestId
                         * @property {string|null} [zone] SetServiceAccountInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new SetServiceAccountInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetServiceAccountInstanceRequest.
                         * @implements ISetServiceAccountInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetServiceAccountInstanceRequest=} [properties] Properties to set
                         */
                        function SetServiceAccountInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetServiceAccountInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.SetServiceAccountInstanceRequest
                         * @instance
                         */
                        SetServiceAccountInstanceRequest.prototype.instance = "";
    
                        /**
                         * SetServiceAccountInstanceRequest instancesSetServiceAccountRequestResource.
                         * @member {google.cloud.compute.v1.IInstancesSetServiceAccountRequest|null|undefined} instancesSetServiceAccountRequestResource
                         * @memberof google.cloud.compute.v1.SetServiceAccountInstanceRequest
                         * @instance
                         */
                        SetServiceAccountInstanceRequest.prototype.instancesSetServiceAccountRequestResource = null;
    
                        /**
                         * SetServiceAccountInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetServiceAccountInstanceRequest
                         * @instance
                         */
                        SetServiceAccountInstanceRequest.prototype.project = "";
    
                        /**
                         * SetServiceAccountInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetServiceAccountInstanceRequest
                         * @instance
                         */
                        SetServiceAccountInstanceRequest.prototype.requestId = null;
    
                        /**
                         * SetServiceAccountInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SetServiceAccountInstanceRequest
                         * @instance
                         */
                        SetServiceAccountInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetServiceAccountInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetServiceAccountInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(SetServiceAccountInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetServiceAccountInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetServiceAccountInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetServiceAccountInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetServiceAccountInstanceRequest} SetServiceAccountInstanceRequest instance
                         */
                        SetServiceAccountInstanceRequest.create = function create(properties) {
                            return new SetServiceAccountInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetServiceAccountInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.SetServiceAccountInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetServiceAccountInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetServiceAccountInstanceRequest} message SetServiceAccountInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetServiceAccountInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instancesSetServiceAccountRequestResource != null && Object.hasOwnProperty.call(message, "instancesSetServiceAccountRequestResource"))
                                $root.google.cloud.compute.v1.InstancesSetServiceAccountRequest.encode(message.instancesSetServiceAccountRequestResource, writer.uint32(/* id 275550008, wireType 2 =*/2204400066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetServiceAccountInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetServiceAccountInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetServiceAccountInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetServiceAccountInstanceRequest} message SetServiceAccountInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetServiceAccountInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetServiceAccountInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetServiceAccountInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetServiceAccountInstanceRequest} SetServiceAccountInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetServiceAccountInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetServiceAccountInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 275550008: {
                                        message.instancesSetServiceAccountRequestResource = $root.google.cloud.compute.v1.InstancesSetServiceAccountRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetServiceAccountInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetServiceAccountInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetServiceAccountInstanceRequest} SetServiceAccountInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetServiceAccountInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetServiceAccountInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetServiceAccountInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetServiceAccountInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.instancesSetServiceAccountRequestResource != null && message.hasOwnProperty("instancesSetServiceAccountRequestResource")) {
                                var error = $root.google.cloud.compute.v1.InstancesSetServiceAccountRequest.verify(message.instancesSetServiceAccountRequestResource);
                                if (error)
                                    return "instancesSetServiceAccountRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetServiceAccountInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetServiceAccountInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetServiceAccountInstanceRequest} SetServiceAccountInstanceRequest
                         */
                        SetServiceAccountInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetServiceAccountInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetServiceAccountInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.instancesSetServiceAccountRequestResource != null) {
                                if (typeof object.instancesSetServiceAccountRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetServiceAccountInstanceRequest.instancesSetServiceAccountRequestResource: object expected");
                                message.instancesSetServiceAccountRequestResource = $root.google.cloud.compute.v1.InstancesSetServiceAccountRequest.fromObject(object.instancesSetServiceAccountRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetServiceAccountInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetServiceAccountInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetServiceAccountInstanceRequest} message SetServiceAccountInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetServiceAccountInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                                object.instancesSetServiceAccountRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instancesSetServiceAccountRequestResource != null && message.hasOwnProperty("instancesSetServiceAccountRequestResource"))
                                object.instancesSetServiceAccountRequestResource = $root.google.cloud.compute.v1.InstancesSetServiceAccountRequest.toObject(message.instancesSetServiceAccountRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetServiceAccountInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetServiceAccountInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetServiceAccountInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetServiceAccountInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetServiceAccountInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetServiceAccountInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetServiceAccountInstanceRequest";
                        };
    
                        return SetServiceAccountInstanceRequest;
                    })();
    
                    v1.SetShieldedInstanceIntegrityPolicyInstanceRequest = (function() {
    
                        /**
                         * Properties of a SetShieldedInstanceIntegrityPolicyInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @property {string|null} [instance] SetShieldedInstanceIntegrityPolicyInstanceRequest instance
                         * @property {string|null} [project] SetShieldedInstanceIntegrityPolicyInstanceRequest project
                         * @property {string|null} [requestId] SetShieldedInstanceIntegrityPolicyInstanceRequest requestId
                         * @property {google.cloud.compute.v1.IShieldedInstanceIntegrityPolicy|null} [shieldedInstanceIntegrityPolicyResource] SetShieldedInstanceIntegrityPolicyInstanceRequest shieldedInstanceIntegrityPolicyResource
                         * @property {string|null} [zone] SetShieldedInstanceIntegrityPolicyInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new SetShieldedInstanceIntegrityPolicyInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetShieldedInstanceIntegrityPolicyInstanceRequest.
                         * @implements ISetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetShieldedInstanceIntegrityPolicyInstanceRequest=} [properties] Properties to set
                         */
                        function SetShieldedInstanceIntegrityPolicyInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetShieldedInstanceIntegrityPolicyInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @instance
                         */
                        SetShieldedInstanceIntegrityPolicyInstanceRequest.prototype.instance = "";
    
                        /**
                         * SetShieldedInstanceIntegrityPolicyInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @instance
                         */
                        SetShieldedInstanceIntegrityPolicyInstanceRequest.prototype.project = "";
    
                        /**
                         * SetShieldedInstanceIntegrityPolicyInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @instance
                         */
                        SetShieldedInstanceIntegrityPolicyInstanceRequest.prototype.requestId = null;
    
                        /**
                         * SetShieldedInstanceIntegrityPolicyInstanceRequest shieldedInstanceIntegrityPolicyResource.
                         * @member {google.cloud.compute.v1.IShieldedInstanceIntegrityPolicy|null|undefined} shieldedInstanceIntegrityPolicyResource
                         * @memberof google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @instance
                         */
                        SetShieldedInstanceIntegrityPolicyInstanceRequest.prototype.shieldedInstanceIntegrityPolicyResource = null;
    
                        /**
                         * SetShieldedInstanceIntegrityPolicyInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @instance
                         */
                        SetShieldedInstanceIntegrityPolicyInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetShieldedInstanceIntegrityPolicyInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(SetShieldedInstanceIntegrityPolicyInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetShieldedInstanceIntegrityPolicyInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetShieldedInstanceIntegrityPolicyInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest} SetShieldedInstanceIntegrityPolicyInstanceRequest instance
                         */
                        SetShieldedInstanceIntegrityPolicyInstanceRequest.create = function create(properties) {
                            return new SetShieldedInstanceIntegrityPolicyInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetShieldedInstanceIntegrityPolicyInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetShieldedInstanceIntegrityPolicyInstanceRequest} message SetShieldedInstanceIntegrityPolicyInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetShieldedInstanceIntegrityPolicyInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.shieldedInstanceIntegrityPolicyResource != null && Object.hasOwnProperty.call(message, "shieldedInstanceIntegrityPolicyResource"))
                                $root.google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy.encode(message.shieldedInstanceIntegrityPolicyResource, writer.uint32(/* id 409169462, wireType 2 =*/3273355698).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetShieldedInstanceIntegrityPolicyInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetShieldedInstanceIntegrityPolicyInstanceRequest} message SetShieldedInstanceIntegrityPolicyInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetShieldedInstanceIntegrityPolicyInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetShieldedInstanceIntegrityPolicyInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest} SetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetShieldedInstanceIntegrityPolicyInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 409169462: {
                                        message.shieldedInstanceIntegrityPolicyResource = $root.google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetShieldedInstanceIntegrityPolicyInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest} SetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetShieldedInstanceIntegrityPolicyInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetShieldedInstanceIntegrityPolicyInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetShieldedInstanceIntegrityPolicyInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.shieldedInstanceIntegrityPolicyResource != null && message.hasOwnProperty("shieldedInstanceIntegrityPolicyResource")) {
                                var error = $root.google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy.verify(message.shieldedInstanceIntegrityPolicyResource);
                                if (error)
                                    return "shieldedInstanceIntegrityPolicyResource." + error;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetShieldedInstanceIntegrityPolicyInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest} SetShieldedInstanceIntegrityPolicyInstanceRequest
                         */
                        SetShieldedInstanceIntegrityPolicyInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.shieldedInstanceIntegrityPolicyResource != null) {
                                if (typeof object.shieldedInstanceIntegrityPolicyResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest.shieldedInstanceIntegrityPolicyResource: object expected");
                                message.shieldedInstanceIntegrityPolicyResource = $root.google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy.fromObject(object.shieldedInstanceIntegrityPolicyResource);
                            }
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetShieldedInstanceIntegrityPolicyInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest} message SetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetShieldedInstanceIntegrityPolicyInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                                object.shieldedInstanceIntegrityPolicyResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.shieldedInstanceIntegrityPolicyResource != null && message.hasOwnProperty("shieldedInstanceIntegrityPolicyResource"))
                                object.shieldedInstanceIntegrityPolicyResource = $root.google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy.toObject(message.shieldedInstanceIntegrityPolicyResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetShieldedInstanceIntegrityPolicyInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetShieldedInstanceIntegrityPolicyInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetShieldedInstanceIntegrityPolicyInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest";
                        };
    
                        return SetShieldedInstanceIntegrityPolicyInstanceRequest;
                    })();
    
                    v1.SetSslCertificatesRegionTargetHttpsProxyRequest = (function() {
    
                        /**
                         * Properties of a SetSslCertificatesRegionTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetSslCertificatesRegionTargetHttpsProxyRequest
                         * @property {string|null} [project] SetSslCertificatesRegionTargetHttpsProxyRequest project
                         * @property {string|null} [region] SetSslCertificatesRegionTargetHttpsProxyRequest region
                         * @property {google.cloud.compute.v1.IRegionTargetHttpsProxiesSetSslCertificatesRequest|null} [regionTargetHttpsProxiesSetSslCertificatesRequestResource] SetSslCertificatesRegionTargetHttpsProxyRequest regionTargetHttpsProxiesSetSslCertificatesRequestResource
                         * @property {string|null} [requestId] SetSslCertificatesRegionTargetHttpsProxyRequest requestId
                         * @property {string|null} [targetHttpsProxy] SetSslCertificatesRegionTargetHttpsProxyRequest targetHttpsProxy
                         */
    
                        /**
                         * Constructs a new SetSslCertificatesRegionTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetSslCertificatesRegionTargetHttpsProxyRequest.
                         * @implements ISetSslCertificatesRegionTargetHttpsProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetSslCertificatesRegionTargetHttpsProxyRequest=} [properties] Properties to set
                         */
                        function SetSslCertificatesRegionTargetHttpsProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetSslCertificatesRegionTargetHttpsProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        SetSslCertificatesRegionTargetHttpsProxyRequest.prototype.project = "";
    
                        /**
                         * SetSslCertificatesRegionTargetHttpsProxyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        SetSslCertificatesRegionTargetHttpsProxyRequest.prototype.region = "";
    
                        /**
                         * SetSslCertificatesRegionTargetHttpsProxyRequest regionTargetHttpsProxiesSetSslCertificatesRequestResource.
                         * @member {google.cloud.compute.v1.IRegionTargetHttpsProxiesSetSslCertificatesRequest|null|undefined} regionTargetHttpsProxiesSetSslCertificatesRequestResource
                         * @memberof google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        SetSslCertificatesRegionTargetHttpsProxyRequest.prototype.regionTargetHttpsProxiesSetSslCertificatesRequestResource = null;
    
                        /**
                         * SetSslCertificatesRegionTargetHttpsProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        SetSslCertificatesRegionTargetHttpsProxyRequest.prototype.requestId = null;
    
                        /**
                         * SetSslCertificatesRegionTargetHttpsProxyRequest targetHttpsProxy.
                         * @member {string} targetHttpsProxy
                         * @memberof google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        SetSslCertificatesRegionTargetHttpsProxyRequest.prototype.targetHttpsProxy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetSslCertificatesRegionTargetHttpsProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        Object.defineProperty(SetSslCertificatesRegionTargetHttpsProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetSslCertificatesRegionTargetHttpsProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSslCertificatesRegionTargetHttpsProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest} SetSslCertificatesRegionTargetHttpsProxyRequest instance
                         */
                        SetSslCertificatesRegionTargetHttpsProxyRequest.create = function create(properties) {
                            return new SetSslCertificatesRegionTargetHttpsProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetSslCertificatesRegionTargetHttpsProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSslCertificatesRegionTargetHttpsProxyRequest} message SetSslCertificatesRegionTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetSslCertificatesRegionTargetHttpsProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetHttpsProxy != null && Object.hasOwnProperty.call(message, "targetHttpsProxy"))
                                writer.uint32(/* id 52336748, wireType 2 =*/418693986).string(message.targetHttpsProxy);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.regionTargetHttpsProxiesSetSslCertificatesRequestResource != null && Object.hasOwnProperty.call(message, "regionTargetHttpsProxiesSetSslCertificatesRequestResource"))
                                $root.google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest.encode(message.regionTargetHttpsProxiesSetSslCertificatesRequestResource, writer.uint32(/* id 390693383, wireType 2 =*/3125547066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetSslCertificatesRegionTargetHttpsProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSslCertificatesRegionTargetHttpsProxyRequest} message SetSslCertificatesRegionTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetSslCertificatesRegionTargetHttpsProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetSslCertificatesRegionTargetHttpsProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest} SetSslCertificatesRegionTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetSslCertificatesRegionTargetHttpsProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 390693383: {
                                        message.regionTargetHttpsProxiesSetSslCertificatesRequestResource = $root.google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 52336748: {
                                        message.targetHttpsProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetSslCertificatesRegionTargetHttpsProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest} SetSslCertificatesRegionTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetSslCertificatesRegionTargetHttpsProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetSslCertificatesRegionTargetHttpsProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetSslCertificatesRegionTargetHttpsProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionTargetHttpsProxiesSetSslCertificatesRequestResource != null && message.hasOwnProperty("regionTargetHttpsProxiesSetSslCertificatesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest.verify(message.regionTargetHttpsProxiesSetSslCertificatesRequestResource);
                                if (error)
                                    return "regionTargetHttpsProxiesSetSslCertificatesRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                if (!$util.isString(message.targetHttpsProxy))
                                    return "targetHttpsProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetSslCertificatesRegionTargetHttpsProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest} SetSslCertificatesRegionTargetHttpsProxyRequest
                         */
                        SetSslCertificatesRegionTargetHttpsProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionTargetHttpsProxiesSetSslCertificatesRequestResource != null) {
                                if (typeof object.regionTargetHttpsProxiesSetSslCertificatesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest.regionTargetHttpsProxiesSetSslCertificatesRequestResource: object expected");
                                message.regionTargetHttpsProxiesSetSslCertificatesRequestResource = $root.google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest.fromObject(object.regionTargetHttpsProxiesSetSslCertificatesRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetHttpsProxy != null)
                                message.targetHttpsProxy = String(object.targetHttpsProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetSslCertificatesRegionTargetHttpsProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest} message SetSslCertificatesRegionTargetHttpsProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetSslCertificatesRegionTargetHttpsProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetHttpsProxy = "";
                                object.region = "";
                                object.project = "";
                                object.regionTargetHttpsProxiesSetSslCertificatesRequestResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                object.targetHttpsProxy = message.targetHttpsProxy;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.regionTargetHttpsProxiesSetSslCertificatesRequestResource != null && message.hasOwnProperty("regionTargetHttpsProxiesSetSslCertificatesRequestResource"))
                                object.regionTargetHttpsProxiesSetSslCertificatesRequestResource = $root.google.cloud.compute.v1.RegionTargetHttpsProxiesSetSslCertificatesRequest.toObject(message.regionTargetHttpsProxiesSetSslCertificatesRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetSslCertificatesRegionTargetHttpsProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetSslCertificatesRegionTargetHttpsProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetSslCertificatesRegionTargetHttpsProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetSslCertificatesRegionTargetHttpsProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest";
                        };
    
                        return SetSslCertificatesRegionTargetHttpsProxyRequest;
                    })();
    
                    v1.SetSslCertificatesTargetHttpsProxyRequest = (function() {
    
                        /**
                         * Properties of a SetSslCertificatesTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetSslCertificatesTargetHttpsProxyRequest
                         * @property {string|null} [project] SetSslCertificatesTargetHttpsProxyRequest project
                         * @property {string|null} [requestId] SetSslCertificatesTargetHttpsProxyRequest requestId
                         * @property {google.cloud.compute.v1.ITargetHttpsProxiesSetSslCertificatesRequest|null} [targetHttpsProxiesSetSslCertificatesRequestResource] SetSslCertificatesTargetHttpsProxyRequest targetHttpsProxiesSetSslCertificatesRequestResource
                         * @property {string|null} [targetHttpsProxy] SetSslCertificatesTargetHttpsProxyRequest targetHttpsProxy
                         */
    
                        /**
                         * Constructs a new SetSslCertificatesTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetSslCertificatesTargetHttpsProxyRequest.
                         * @implements ISetSslCertificatesTargetHttpsProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetSslCertificatesTargetHttpsProxyRequest=} [properties] Properties to set
                         */
                        function SetSslCertificatesTargetHttpsProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetSslCertificatesTargetHttpsProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest
                         * @instance
                         */
                        SetSslCertificatesTargetHttpsProxyRequest.prototype.project = "";
    
                        /**
                         * SetSslCertificatesTargetHttpsProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest
                         * @instance
                         */
                        SetSslCertificatesTargetHttpsProxyRequest.prototype.requestId = null;
    
                        /**
                         * SetSslCertificatesTargetHttpsProxyRequest targetHttpsProxiesSetSslCertificatesRequestResource.
                         * @member {google.cloud.compute.v1.ITargetHttpsProxiesSetSslCertificatesRequest|null|undefined} targetHttpsProxiesSetSslCertificatesRequestResource
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest
                         * @instance
                         */
                        SetSslCertificatesTargetHttpsProxyRequest.prototype.targetHttpsProxiesSetSslCertificatesRequestResource = null;
    
                        /**
                         * SetSslCertificatesTargetHttpsProxyRequest targetHttpsProxy.
                         * @member {string} targetHttpsProxy
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest
                         * @instance
                         */
                        SetSslCertificatesTargetHttpsProxyRequest.prototype.targetHttpsProxy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetSslCertificatesTargetHttpsProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest
                         * @instance
                         */
                        Object.defineProperty(SetSslCertificatesTargetHttpsProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetSslCertificatesTargetHttpsProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSslCertificatesTargetHttpsProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest} SetSslCertificatesTargetHttpsProxyRequest instance
                         */
                        SetSslCertificatesTargetHttpsProxyRequest.create = function create(properties) {
                            return new SetSslCertificatesTargetHttpsProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetSslCertificatesTargetHttpsProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSslCertificatesTargetHttpsProxyRequest} message SetSslCertificatesTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetSslCertificatesTargetHttpsProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetHttpsProxy != null && Object.hasOwnProperty.call(message, "targetHttpsProxy"))
                                writer.uint32(/* id 52336748, wireType 2 =*/418693986).string(message.targetHttpsProxy);
                            if (message.targetHttpsProxiesSetSslCertificatesRequestResource != null && Object.hasOwnProperty.call(message, "targetHttpsProxiesSetSslCertificatesRequestResource"))
                                $root.google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest.encode(message.targetHttpsProxiesSetSslCertificatesRequestResource, writer.uint32(/* id 223122908, wireType 2 =*/1784983266).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetSslCertificatesTargetHttpsProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSslCertificatesTargetHttpsProxyRequest} message SetSslCertificatesTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetSslCertificatesTargetHttpsProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetSslCertificatesTargetHttpsProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest} SetSslCertificatesTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetSslCertificatesTargetHttpsProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 223122908: {
                                        message.targetHttpsProxiesSetSslCertificatesRequestResource = $root.google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 52336748: {
                                        message.targetHttpsProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetSslCertificatesTargetHttpsProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest} SetSslCertificatesTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetSslCertificatesTargetHttpsProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetSslCertificatesTargetHttpsProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetSslCertificatesTargetHttpsProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetHttpsProxiesSetSslCertificatesRequestResource != null && message.hasOwnProperty("targetHttpsProxiesSetSslCertificatesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest.verify(message.targetHttpsProxiesSetSslCertificatesRequestResource);
                                if (error)
                                    return "targetHttpsProxiesSetSslCertificatesRequestResource." + error;
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                if (!$util.isString(message.targetHttpsProxy))
                                    return "targetHttpsProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetSslCertificatesTargetHttpsProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest} SetSslCertificatesTargetHttpsProxyRequest
                         */
                        SetSslCertificatesTargetHttpsProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetHttpsProxiesSetSslCertificatesRequestResource != null) {
                                if (typeof object.targetHttpsProxiesSetSslCertificatesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest.targetHttpsProxiesSetSslCertificatesRequestResource: object expected");
                                message.targetHttpsProxiesSetSslCertificatesRequestResource = $root.google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest.fromObject(object.targetHttpsProxiesSetSslCertificatesRequestResource);
                            }
                            if (object.targetHttpsProxy != null)
                                message.targetHttpsProxy = String(object.targetHttpsProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetSslCertificatesTargetHttpsProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest} message SetSslCertificatesTargetHttpsProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetSslCertificatesTargetHttpsProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetHttpsProxy = "";
                                object.targetHttpsProxiesSetSslCertificatesRequestResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                object.targetHttpsProxy = message.targetHttpsProxy;
                            if (message.targetHttpsProxiesSetSslCertificatesRequestResource != null && message.hasOwnProperty("targetHttpsProxiesSetSslCertificatesRequestResource"))
                                object.targetHttpsProxiesSetSslCertificatesRequestResource = $root.google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest.toObject(message.targetHttpsProxiesSetSslCertificatesRequestResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this SetSslCertificatesTargetHttpsProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetSslCertificatesTargetHttpsProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetSslCertificatesTargetHttpsProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetSslCertificatesTargetHttpsProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest";
                        };
    
                        return SetSslCertificatesTargetHttpsProxyRequest;
                    })();
    
                    v1.SetSslCertificatesTargetSslProxyRequest = (function() {
    
                        /**
                         * Properties of a SetSslCertificatesTargetSslProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetSslCertificatesTargetSslProxyRequest
                         * @property {string|null} [project] SetSslCertificatesTargetSslProxyRequest project
                         * @property {string|null} [requestId] SetSslCertificatesTargetSslProxyRequest requestId
                         * @property {google.cloud.compute.v1.ITargetSslProxiesSetSslCertificatesRequest|null} [targetSslProxiesSetSslCertificatesRequestResource] SetSslCertificatesTargetSslProxyRequest targetSslProxiesSetSslCertificatesRequestResource
                         * @property {string|null} [targetSslProxy] SetSslCertificatesTargetSslProxyRequest targetSslProxy
                         */
    
                        /**
                         * Constructs a new SetSslCertificatesTargetSslProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetSslCertificatesTargetSslProxyRequest.
                         * @implements ISetSslCertificatesTargetSslProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetSslCertificatesTargetSslProxyRequest=} [properties] Properties to set
                         */
                        function SetSslCertificatesTargetSslProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetSslCertificatesTargetSslProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest
                         * @instance
                         */
                        SetSslCertificatesTargetSslProxyRequest.prototype.project = "";
    
                        /**
                         * SetSslCertificatesTargetSslProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest
                         * @instance
                         */
                        SetSslCertificatesTargetSslProxyRequest.prototype.requestId = null;
    
                        /**
                         * SetSslCertificatesTargetSslProxyRequest targetSslProxiesSetSslCertificatesRequestResource.
                         * @member {google.cloud.compute.v1.ITargetSslProxiesSetSslCertificatesRequest|null|undefined} targetSslProxiesSetSslCertificatesRequestResource
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest
                         * @instance
                         */
                        SetSslCertificatesTargetSslProxyRequest.prototype.targetSslProxiesSetSslCertificatesRequestResource = null;
    
                        /**
                         * SetSslCertificatesTargetSslProxyRequest targetSslProxy.
                         * @member {string} targetSslProxy
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest
                         * @instance
                         */
                        SetSslCertificatesTargetSslProxyRequest.prototype.targetSslProxy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetSslCertificatesTargetSslProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest
                         * @instance
                         */
                        Object.defineProperty(SetSslCertificatesTargetSslProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetSslCertificatesTargetSslProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSslCertificatesTargetSslProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest} SetSslCertificatesTargetSslProxyRequest instance
                         */
                        SetSslCertificatesTargetSslProxyRequest.create = function create(properties) {
                            return new SetSslCertificatesTargetSslProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetSslCertificatesTargetSslProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSslCertificatesTargetSslProxyRequest} message SetSslCertificatesTargetSslProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetSslCertificatesTargetSslProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetSslProxiesSetSslCertificatesRequestResource != null && Object.hasOwnProperty.call(message, "targetSslProxiesSetSslCertificatesRequestResource"))
                                $root.google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest.encode(message.targetSslProxiesSetSslCertificatesRequestResource, writer.uint32(/* id 147940797, wireType 2 =*/1183526378).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.targetSslProxy != null && Object.hasOwnProperty.call(message, "targetSslProxy"))
                                writer.uint32(/* id 338795853, wireType 2 =*/2710366826).string(message.targetSslProxy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetSslCertificatesTargetSslProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSslCertificatesTargetSslProxyRequest} message SetSslCertificatesTargetSslProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetSslCertificatesTargetSslProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetSslCertificatesTargetSslProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest} SetSslCertificatesTargetSslProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetSslCertificatesTargetSslProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 147940797: {
                                        message.targetSslProxiesSetSslCertificatesRequestResource = $root.google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 338795853: {
                                        message.targetSslProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetSslCertificatesTargetSslProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest} SetSslCertificatesTargetSslProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetSslCertificatesTargetSslProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetSslCertificatesTargetSslProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetSslCertificatesTargetSslProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetSslProxiesSetSslCertificatesRequestResource != null && message.hasOwnProperty("targetSslProxiesSetSslCertificatesRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest.verify(message.targetSslProxiesSetSslCertificatesRequestResource);
                                if (error)
                                    return "targetSslProxiesSetSslCertificatesRequestResource." + error;
                            }
                            if (message.targetSslProxy != null && message.hasOwnProperty("targetSslProxy"))
                                if (!$util.isString(message.targetSslProxy))
                                    return "targetSslProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetSslCertificatesTargetSslProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest} SetSslCertificatesTargetSslProxyRequest
                         */
                        SetSslCertificatesTargetSslProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetSslProxiesSetSslCertificatesRequestResource != null) {
                                if (typeof object.targetSslProxiesSetSslCertificatesRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest.targetSslProxiesSetSslCertificatesRequestResource: object expected");
                                message.targetSslProxiesSetSslCertificatesRequestResource = $root.google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest.fromObject(object.targetSslProxiesSetSslCertificatesRequestResource);
                            }
                            if (object.targetSslProxy != null)
                                message.targetSslProxy = String(object.targetSslProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetSslCertificatesTargetSslProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest} message SetSslCertificatesTargetSslProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetSslCertificatesTargetSslProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetSslProxiesSetSslCertificatesRequestResource = null;
                                object.project = "";
                                object.targetSslProxy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetSslProxiesSetSslCertificatesRequestResource != null && message.hasOwnProperty("targetSslProxiesSetSslCertificatesRequestResource"))
                                object.targetSslProxiesSetSslCertificatesRequestResource = $root.google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest.toObject(message.targetSslProxiesSetSslCertificatesRequestResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.targetSslProxy != null && message.hasOwnProperty("targetSslProxy"))
                                object.targetSslProxy = message.targetSslProxy;
                            return object;
                        };
    
                        /**
                         * Converts this SetSslCertificatesTargetSslProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetSslCertificatesTargetSslProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetSslCertificatesTargetSslProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetSslCertificatesTargetSslProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest";
                        };
    
                        return SetSslCertificatesTargetSslProxyRequest;
                    })();
    
                    v1.SetSslPolicyTargetHttpsProxyRequest = (function() {
    
                        /**
                         * Properties of a SetSslPolicyTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetSslPolicyTargetHttpsProxyRequest
                         * @property {string|null} [project] SetSslPolicyTargetHttpsProxyRequest project
                         * @property {string|null} [requestId] SetSslPolicyTargetHttpsProxyRequest requestId
                         * @property {google.cloud.compute.v1.ISslPolicyReference|null} [sslPolicyReferenceResource] SetSslPolicyTargetHttpsProxyRequest sslPolicyReferenceResource
                         * @property {string|null} [targetHttpsProxy] SetSslPolicyTargetHttpsProxyRequest targetHttpsProxy
                         */
    
                        /**
                         * Constructs a new SetSslPolicyTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetSslPolicyTargetHttpsProxyRequest.
                         * @implements ISetSslPolicyTargetHttpsProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetSslPolicyTargetHttpsProxyRequest=} [properties] Properties to set
                         */
                        function SetSslPolicyTargetHttpsProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetSslPolicyTargetHttpsProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest
                         * @instance
                         */
                        SetSslPolicyTargetHttpsProxyRequest.prototype.project = "";
    
                        /**
                         * SetSslPolicyTargetHttpsProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest
                         * @instance
                         */
                        SetSslPolicyTargetHttpsProxyRequest.prototype.requestId = null;
    
                        /**
                         * SetSslPolicyTargetHttpsProxyRequest sslPolicyReferenceResource.
                         * @member {google.cloud.compute.v1.ISslPolicyReference|null|undefined} sslPolicyReferenceResource
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest
                         * @instance
                         */
                        SetSslPolicyTargetHttpsProxyRequest.prototype.sslPolicyReferenceResource = null;
    
                        /**
                         * SetSslPolicyTargetHttpsProxyRequest targetHttpsProxy.
                         * @member {string} targetHttpsProxy
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest
                         * @instance
                         */
                        SetSslPolicyTargetHttpsProxyRequest.prototype.targetHttpsProxy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetSslPolicyTargetHttpsProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest
                         * @instance
                         */
                        Object.defineProperty(SetSslPolicyTargetHttpsProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetSslPolicyTargetHttpsProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSslPolicyTargetHttpsProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest} SetSslPolicyTargetHttpsProxyRequest instance
                         */
                        SetSslPolicyTargetHttpsProxyRequest.create = function create(properties) {
                            return new SetSslPolicyTargetHttpsProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetSslPolicyTargetHttpsProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSslPolicyTargetHttpsProxyRequest} message SetSslPolicyTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetSslPolicyTargetHttpsProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetHttpsProxy != null && Object.hasOwnProperty.call(message, "targetHttpsProxy"))
                                writer.uint32(/* id 52336748, wireType 2 =*/418693986).string(message.targetHttpsProxy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.sslPolicyReferenceResource != null && Object.hasOwnProperty.call(message, "sslPolicyReferenceResource"))
                                $root.google.cloud.compute.v1.SslPolicyReference.encode(message.sslPolicyReferenceResource, writer.uint32(/* id 235403836, wireType 2 =*/1883230690).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetSslPolicyTargetHttpsProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSslPolicyTargetHttpsProxyRequest} message SetSslPolicyTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetSslPolicyTargetHttpsProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetSslPolicyTargetHttpsProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest} SetSslPolicyTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetSslPolicyTargetHttpsProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 235403836: {
                                        message.sslPolicyReferenceResource = $root.google.cloud.compute.v1.SslPolicyReference.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 52336748: {
                                        message.targetHttpsProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetSslPolicyTargetHttpsProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest} SetSslPolicyTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetSslPolicyTargetHttpsProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetSslPolicyTargetHttpsProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetSslPolicyTargetHttpsProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.sslPolicyReferenceResource != null && message.hasOwnProperty("sslPolicyReferenceResource")) {
                                var error = $root.google.cloud.compute.v1.SslPolicyReference.verify(message.sslPolicyReferenceResource);
                                if (error)
                                    return "sslPolicyReferenceResource." + error;
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                if (!$util.isString(message.targetHttpsProxy))
                                    return "targetHttpsProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetSslPolicyTargetHttpsProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest} SetSslPolicyTargetHttpsProxyRequest
                         */
                        SetSslPolicyTargetHttpsProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.sslPolicyReferenceResource != null) {
                                if (typeof object.sslPolicyReferenceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest.sslPolicyReferenceResource: object expected");
                                message.sslPolicyReferenceResource = $root.google.cloud.compute.v1.SslPolicyReference.fromObject(object.sslPolicyReferenceResource);
                            }
                            if (object.targetHttpsProxy != null)
                                message.targetHttpsProxy = String(object.targetHttpsProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetSslPolicyTargetHttpsProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest} message SetSslPolicyTargetHttpsProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetSslPolicyTargetHttpsProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetHttpsProxy = "";
                                object.project = "";
                                object.sslPolicyReferenceResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                object.targetHttpsProxy = message.targetHttpsProxy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.sslPolicyReferenceResource != null && message.hasOwnProperty("sslPolicyReferenceResource"))
                                object.sslPolicyReferenceResource = $root.google.cloud.compute.v1.SslPolicyReference.toObject(message.sslPolicyReferenceResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetSslPolicyTargetHttpsProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetSslPolicyTargetHttpsProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetSslPolicyTargetHttpsProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetSslPolicyTargetHttpsProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest";
                        };
    
                        return SetSslPolicyTargetHttpsProxyRequest;
                    })();
    
                    v1.SetSslPolicyTargetSslProxyRequest = (function() {
    
                        /**
                         * Properties of a SetSslPolicyTargetSslProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetSslPolicyTargetSslProxyRequest
                         * @property {string|null} [project] SetSslPolicyTargetSslProxyRequest project
                         * @property {string|null} [requestId] SetSslPolicyTargetSslProxyRequest requestId
                         * @property {google.cloud.compute.v1.ISslPolicyReference|null} [sslPolicyReferenceResource] SetSslPolicyTargetSslProxyRequest sslPolicyReferenceResource
                         * @property {string|null} [targetSslProxy] SetSslPolicyTargetSslProxyRequest targetSslProxy
                         */
    
                        /**
                         * Constructs a new SetSslPolicyTargetSslProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetSslPolicyTargetSslProxyRequest.
                         * @implements ISetSslPolicyTargetSslProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetSslPolicyTargetSslProxyRequest=} [properties] Properties to set
                         */
                        function SetSslPolicyTargetSslProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetSslPolicyTargetSslProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest
                         * @instance
                         */
                        SetSslPolicyTargetSslProxyRequest.prototype.project = "";
    
                        /**
                         * SetSslPolicyTargetSslProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest
                         * @instance
                         */
                        SetSslPolicyTargetSslProxyRequest.prototype.requestId = null;
    
                        /**
                         * SetSslPolicyTargetSslProxyRequest sslPolicyReferenceResource.
                         * @member {google.cloud.compute.v1.ISslPolicyReference|null|undefined} sslPolicyReferenceResource
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest
                         * @instance
                         */
                        SetSslPolicyTargetSslProxyRequest.prototype.sslPolicyReferenceResource = null;
    
                        /**
                         * SetSslPolicyTargetSslProxyRequest targetSslProxy.
                         * @member {string} targetSslProxy
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest
                         * @instance
                         */
                        SetSslPolicyTargetSslProxyRequest.prototype.targetSslProxy = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetSslPolicyTargetSslProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest
                         * @instance
                         */
                        Object.defineProperty(SetSslPolicyTargetSslProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetSslPolicyTargetSslProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSslPolicyTargetSslProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest} SetSslPolicyTargetSslProxyRequest instance
                         */
                        SetSslPolicyTargetSslProxyRequest.create = function create(properties) {
                            return new SetSslPolicyTargetSslProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetSslPolicyTargetSslProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSslPolicyTargetSslProxyRequest} message SetSslPolicyTargetSslProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetSslPolicyTargetSslProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.sslPolicyReferenceResource != null && Object.hasOwnProperty.call(message, "sslPolicyReferenceResource"))
                                $root.google.cloud.compute.v1.SslPolicyReference.encode(message.sslPolicyReferenceResource, writer.uint32(/* id 235403836, wireType 2 =*/1883230690).fork()).ldelim();
                            if (message.targetSslProxy != null && Object.hasOwnProperty.call(message, "targetSslProxy"))
                                writer.uint32(/* id 338795853, wireType 2 =*/2710366826).string(message.targetSslProxy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetSslPolicyTargetSslProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetSslPolicyTargetSslProxyRequest} message SetSslPolicyTargetSslProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetSslPolicyTargetSslProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetSslPolicyTargetSslProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest} SetSslPolicyTargetSslProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetSslPolicyTargetSslProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 235403836: {
                                        message.sslPolicyReferenceResource = $root.google.cloud.compute.v1.SslPolicyReference.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 338795853: {
                                        message.targetSslProxy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetSslPolicyTargetSslProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest} SetSslPolicyTargetSslProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetSslPolicyTargetSslProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetSslPolicyTargetSslProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetSslPolicyTargetSslProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.sslPolicyReferenceResource != null && message.hasOwnProperty("sslPolicyReferenceResource")) {
                                var error = $root.google.cloud.compute.v1.SslPolicyReference.verify(message.sslPolicyReferenceResource);
                                if (error)
                                    return "sslPolicyReferenceResource." + error;
                            }
                            if (message.targetSslProxy != null && message.hasOwnProperty("targetSslProxy"))
                                if (!$util.isString(message.targetSslProxy))
                                    return "targetSslProxy: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetSslPolicyTargetSslProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest} SetSslPolicyTargetSslProxyRequest
                         */
                        SetSslPolicyTargetSslProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.sslPolicyReferenceResource != null) {
                                if (typeof object.sslPolicyReferenceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest.sslPolicyReferenceResource: object expected");
                                message.sslPolicyReferenceResource = $root.google.cloud.compute.v1.SslPolicyReference.fromObject(object.sslPolicyReferenceResource);
                            }
                            if (object.targetSslProxy != null)
                                message.targetSslProxy = String(object.targetSslProxy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetSslPolicyTargetSslProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest} message SetSslPolicyTargetSslProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetSslPolicyTargetSslProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.sslPolicyReferenceResource = null;
                                object.targetSslProxy = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.sslPolicyReferenceResource != null && message.hasOwnProperty("sslPolicyReferenceResource"))
                                object.sslPolicyReferenceResource = $root.google.cloud.compute.v1.SslPolicyReference.toObject(message.sslPolicyReferenceResource, options);
                            if (message.targetSslProxy != null && message.hasOwnProperty("targetSslProxy"))
                                object.targetSslProxy = message.targetSslProxy;
                            return object;
                        };
    
                        /**
                         * Converts this SetSslPolicyTargetSslProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetSslPolicyTargetSslProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetSslPolicyTargetSslProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetSslPolicyTargetSslProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest";
                        };
    
                        return SetSslPolicyTargetSslProxyRequest;
                    })();
    
                    v1.SetTagsInstanceRequest = (function() {
    
                        /**
                         * Properties of a SetTagsInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetTagsInstanceRequest
                         * @property {string|null} [instance] SetTagsInstanceRequest instance
                         * @property {string|null} [project] SetTagsInstanceRequest project
                         * @property {string|null} [requestId] SetTagsInstanceRequest requestId
                         * @property {google.cloud.compute.v1.ITags|null} [tagsResource] SetTagsInstanceRequest tagsResource
                         * @property {string|null} [zone] SetTagsInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new SetTagsInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetTagsInstanceRequest.
                         * @implements ISetTagsInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetTagsInstanceRequest=} [properties] Properties to set
                         */
                        function SetTagsInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetTagsInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.SetTagsInstanceRequest
                         * @instance
                         */
                        SetTagsInstanceRequest.prototype.instance = "";
    
                        /**
                         * SetTagsInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetTagsInstanceRequest
                         * @instance
                         */
                        SetTagsInstanceRequest.prototype.project = "";
    
                        /**
                         * SetTagsInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetTagsInstanceRequest
                         * @instance
                         */
                        SetTagsInstanceRequest.prototype.requestId = null;
    
                        /**
                         * SetTagsInstanceRequest tagsResource.
                         * @member {google.cloud.compute.v1.ITags|null|undefined} tagsResource
                         * @memberof google.cloud.compute.v1.SetTagsInstanceRequest
                         * @instance
                         */
                        SetTagsInstanceRequest.prototype.tagsResource = null;
    
                        /**
                         * SetTagsInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SetTagsInstanceRequest
                         * @instance
                         */
                        SetTagsInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetTagsInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetTagsInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(SetTagsInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetTagsInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetTagsInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetTagsInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetTagsInstanceRequest} SetTagsInstanceRequest instance
                         */
                        SetTagsInstanceRequest.create = function create(properties) {
                            return new SetTagsInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetTagsInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.SetTagsInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetTagsInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetTagsInstanceRequest} message SetTagsInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetTagsInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.tagsResource != null && Object.hasOwnProperty.call(message, "tagsResource"))
                                $root.google.cloud.compute.v1.Tags.encode(message.tagsResource, writer.uint32(/* id 331435380, wireType 2 =*/2651483042).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetTagsInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetTagsInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetTagsInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetTagsInstanceRequest} message SetTagsInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetTagsInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetTagsInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetTagsInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetTagsInstanceRequest} SetTagsInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetTagsInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetTagsInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 331435380: {
                                        message.tagsResource = $root.google.cloud.compute.v1.Tags.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetTagsInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetTagsInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetTagsInstanceRequest} SetTagsInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetTagsInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetTagsInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetTagsInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetTagsInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.tagsResource != null && message.hasOwnProperty("tagsResource")) {
                                var error = $root.google.cloud.compute.v1.Tags.verify(message.tagsResource);
                                if (error)
                                    return "tagsResource." + error;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetTagsInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetTagsInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetTagsInstanceRequest} SetTagsInstanceRequest
                         */
                        SetTagsInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetTagsInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetTagsInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.tagsResource != null) {
                                if (typeof object.tagsResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetTagsInstanceRequest.tagsResource: object expected");
                                message.tagsResource = $root.google.cloud.compute.v1.Tags.fromObject(object.tagsResource);
                            }
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetTagsInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetTagsInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetTagsInstanceRequest} message SetTagsInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetTagsInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                                object.tagsResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.tagsResource != null && message.hasOwnProperty("tagsResource"))
                                object.tagsResource = $root.google.cloud.compute.v1.Tags.toObject(message.tagsResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetTagsInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetTagsInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetTagsInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetTagsInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetTagsInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetTagsInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetTagsInstanceRequest";
                        };
    
                        return SetTagsInstanceRequest;
                    })();
    
                    v1.SetTargetForwardingRuleRequest = (function() {
    
                        /**
                         * Properties of a SetTargetForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetTargetForwardingRuleRequest
                         * @property {string|null} [forwardingRule] SetTargetForwardingRuleRequest forwardingRule
                         * @property {string|null} [project] SetTargetForwardingRuleRequest project
                         * @property {string|null} [region] SetTargetForwardingRuleRequest region
                         * @property {string|null} [requestId] SetTargetForwardingRuleRequest requestId
                         * @property {google.cloud.compute.v1.ITargetReference|null} [targetReferenceResource] SetTargetForwardingRuleRequest targetReferenceResource
                         */
    
                        /**
                         * Constructs a new SetTargetForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetTargetForwardingRuleRequest.
                         * @implements ISetTargetForwardingRuleRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetTargetForwardingRuleRequest=} [properties] Properties to set
                         */
                        function SetTargetForwardingRuleRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetTargetForwardingRuleRequest forwardingRule.
                         * @member {string} forwardingRule
                         * @memberof google.cloud.compute.v1.SetTargetForwardingRuleRequest
                         * @instance
                         */
                        SetTargetForwardingRuleRequest.prototype.forwardingRule = "";
    
                        /**
                         * SetTargetForwardingRuleRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetTargetForwardingRuleRequest
                         * @instance
                         */
                        SetTargetForwardingRuleRequest.prototype.project = "";
    
                        /**
                         * SetTargetForwardingRuleRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetTargetForwardingRuleRequest
                         * @instance
                         */
                        SetTargetForwardingRuleRequest.prototype.region = "";
    
                        /**
                         * SetTargetForwardingRuleRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetTargetForwardingRuleRequest
                         * @instance
                         */
                        SetTargetForwardingRuleRequest.prototype.requestId = null;
    
                        /**
                         * SetTargetForwardingRuleRequest targetReferenceResource.
                         * @member {google.cloud.compute.v1.ITargetReference|null|undefined} targetReferenceResource
                         * @memberof google.cloud.compute.v1.SetTargetForwardingRuleRequest
                         * @instance
                         */
                        SetTargetForwardingRuleRequest.prototype.targetReferenceResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetTargetForwardingRuleRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetTargetForwardingRuleRequest
                         * @instance
                         */
                        Object.defineProperty(SetTargetForwardingRuleRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetTargetForwardingRuleRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetTargetForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetTargetForwardingRuleRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetTargetForwardingRuleRequest} SetTargetForwardingRuleRequest instance
                         */
                        SetTargetForwardingRuleRequest.create = function create(properties) {
                            return new SetTargetForwardingRuleRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetTargetForwardingRuleRequest message. Does not implicitly {@link google.cloud.compute.v1.SetTargetForwardingRuleRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetTargetForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetTargetForwardingRuleRequest} message SetTargetForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetTargetForwardingRuleRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.forwardingRule != null && Object.hasOwnProperty.call(message, "forwardingRule"))
                                writer.uint32(/* id 269964030, wireType 2 =*/2159712242).string(message.forwardingRule);
                            if (message.targetReferenceResource != null && Object.hasOwnProperty.call(message, "targetReferenceResource"))
                                $root.google.cloud.compute.v1.TargetReference.encode(message.targetReferenceResource, writer.uint32(/* id 523721712, wireType 2 =*/4189773698).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetTargetForwardingRuleRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetTargetForwardingRuleRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetTargetForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetTargetForwardingRuleRequest} message SetTargetForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetTargetForwardingRuleRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetTargetForwardingRuleRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetTargetForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetTargetForwardingRuleRequest} SetTargetForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetTargetForwardingRuleRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetTargetForwardingRuleRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 269964030: {
                                        message.forwardingRule = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 523721712: {
                                        message.targetReferenceResource = $root.google.cloud.compute.v1.TargetReference.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetTargetForwardingRuleRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetTargetForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetTargetForwardingRuleRequest} SetTargetForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetTargetForwardingRuleRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetTargetForwardingRuleRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetTargetForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetTargetForwardingRuleRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule"))
                                if (!$util.isString(message.forwardingRule))
                                    return "forwardingRule: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetReferenceResource != null && message.hasOwnProperty("targetReferenceResource")) {
                                var error = $root.google.cloud.compute.v1.TargetReference.verify(message.targetReferenceResource);
                                if (error)
                                    return "targetReferenceResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetTargetForwardingRuleRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetTargetForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetTargetForwardingRuleRequest} SetTargetForwardingRuleRequest
                         */
                        SetTargetForwardingRuleRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetTargetForwardingRuleRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetTargetForwardingRuleRequest();
                            if (object.forwardingRule != null)
                                message.forwardingRule = String(object.forwardingRule);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetReferenceResource != null) {
                                if (typeof object.targetReferenceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetTargetForwardingRuleRequest.targetReferenceResource: object expected");
                                message.targetReferenceResource = $root.google.cloud.compute.v1.TargetReference.fromObject(object.targetReferenceResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetTargetForwardingRuleRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetTargetForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetTargetForwardingRuleRequest} message SetTargetForwardingRuleRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetTargetForwardingRuleRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.forwardingRule = "";
                                object.targetReferenceResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule"))
                                object.forwardingRule = message.forwardingRule;
                            if (message.targetReferenceResource != null && message.hasOwnProperty("targetReferenceResource"))
                                object.targetReferenceResource = $root.google.cloud.compute.v1.TargetReference.toObject(message.targetReferenceResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetTargetForwardingRuleRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetTargetForwardingRuleRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetTargetForwardingRuleRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetTargetForwardingRuleRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetTargetForwardingRuleRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetTargetForwardingRuleRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetTargetForwardingRuleRequest";
                        };
    
                        return SetTargetForwardingRuleRequest;
                    })();
    
                    v1.SetTargetGlobalForwardingRuleRequest = (function() {
    
                        /**
                         * Properties of a SetTargetGlobalForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetTargetGlobalForwardingRuleRequest
                         * @property {string|null} [forwardingRule] SetTargetGlobalForwardingRuleRequest forwardingRule
                         * @property {string|null} [project] SetTargetGlobalForwardingRuleRequest project
                         * @property {string|null} [requestId] SetTargetGlobalForwardingRuleRequest requestId
                         * @property {google.cloud.compute.v1.ITargetReference|null} [targetReferenceResource] SetTargetGlobalForwardingRuleRequest targetReferenceResource
                         */
    
                        /**
                         * Constructs a new SetTargetGlobalForwardingRuleRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetTargetGlobalForwardingRuleRequest.
                         * @implements ISetTargetGlobalForwardingRuleRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetTargetGlobalForwardingRuleRequest=} [properties] Properties to set
                         */
                        function SetTargetGlobalForwardingRuleRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetTargetGlobalForwardingRuleRequest forwardingRule.
                         * @member {string} forwardingRule
                         * @memberof google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest
                         * @instance
                         */
                        SetTargetGlobalForwardingRuleRequest.prototype.forwardingRule = "";
    
                        /**
                         * SetTargetGlobalForwardingRuleRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest
                         * @instance
                         */
                        SetTargetGlobalForwardingRuleRequest.prototype.project = "";
    
                        /**
                         * SetTargetGlobalForwardingRuleRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest
                         * @instance
                         */
                        SetTargetGlobalForwardingRuleRequest.prototype.requestId = null;
    
                        /**
                         * SetTargetGlobalForwardingRuleRequest targetReferenceResource.
                         * @member {google.cloud.compute.v1.ITargetReference|null|undefined} targetReferenceResource
                         * @memberof google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest
                         * @instance
                         */
                        SetTargetGlobalForwardingRuleRequest.prototype.targetReferenceResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetTargetGlobalForwardingRuleRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest
                         * @instance
                         */
                        Object.defineProperty(SetTargetGlobalForwardingRuleRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetTargetGlobalForwardingRuleRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetTargetGlobalForwardingRuleRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest} SetTargetGlobalForwardingRuleRequest instance
                         */
                        SetTargetGlobalForwardingRuleRequest.create = function create(properties) {
                            return new SetTargetGlobalForwardingRuleRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetTargetGlobalForwardingRuleRequest message. Does not implicitly {@link google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetTargetGlobalForwardingRuleRequest} message SetTargetGlobalForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetTargetGlobalForwardingRuleRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.forwardingRule != null && Object.hasOwnProperty.call(message, "forwardingRule"))
                                writer.uint32(/* id 269964030, wireType 2 =*/2159712242).string(message.forwardingRule);
                            if (message.targetReferenceResource != null && Object.hasOwnProperty.call(message, "targetReferenceResource"))
                                $root.google.cloud.compute.v1.TargetReference.encode(message.targetReferenceResource, writer.uint32(/* id 523721712, wireType 2 =*/4189773698).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetTargetGlobalForwardingRuleRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetTargetGlobalForwardingRuleRequest} message SetTargetGlobalForwardingRuleRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetTargetGlobalForwardingRuleRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetTargetGlobalForwardingRuleRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest} SetTargetGlobalForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetTargetGlobalForwardingRuleRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 269964030: {
                                        message.forwardingRule = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 523721712: {
                                        message.targetReferenceResource = $root.google.cloud.compute.v1.TargetReference.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetTargetGlobalForwardingRuleRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest} SetTargetGlobalForwardingRuleRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetTargetGlobalForwardingRuleRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetTargetGlobalForwardingRuleRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetTargetGlobalForwardingRuleRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule"))
                                if (!$util.isString(message.forwardingRule))
                                    return "forwardingRule: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetReferenceResource != null && message.hasOwnProperty("targetReferenceResource")) {
                                var error = $root.google.cloud.compute.v1.TargetReference.verify(message.targetReferenceResource);
                                if (error)
                                    return "targetReferenceResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetTargetGlobalForwardingRuleRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest} SetTargetGlobalForwardingRuleRequest
                         */
                        SetTargetGlobalForwardingRuleRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest();
                            if (object.forwardingRule != null)
                                message.forwardingRule = String(object.forwardingRule);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetReferenceResource != null) {
                                if (typeof object.targetReferenceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest.targetReferenceResource: object expected");
                                message.targetReferenceResource = $root.google.cloud.compute.v1.TargetReference.fromObject(object.targetReferenceResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetTargetGlobalForwardingRuleRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest} message SetTargetGlobalForwardingRuleRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetTargetGlobalForwardingRuleRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.forwardingRule = "";
                                object.targetReferenceResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.forwardingRule != null && message.hasOwnProperty("forwardingRule"))
                                object.forwardingRule = message.forwardingRule;
                            if (message.targetReferenceResource != null && message.hasOwnProperty("targetReferenceResource"))
                                object.targetReferenceResource = $root.google.cloud.compute.v1.TargetReference.toObject(message.targetReferenceResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetTargetGlobalForwardingRuleRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetTargetGlobalForwardingRuleRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetTargetGlobalForwardingRuleRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetTargetGlobalForwardingRuleRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest";
                        };
    
                        return SetTargetGlobalForwardingRuleRequest;
                    })();
    
                    v1.SetTargetPoolsInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a SetTargetPoolsInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetTargetPoolsInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] SetTargetPoolsInstanceGroupManagerRequest instanceGroupManager
                         * @property {google.cloud.compute.v1.IInstanceGroupManagersSetTargetPoolsRequest|null} [instanceGroupManagersSetTargetPoolsRequestResource] SetTargetPoolsInstanceGroupManagerRequest instanceGroupManagersSetTargetPoolsRequestResource
                         * @property {string|null} [project] SetTargetPoolsInstanceGroupManagerRequest project
                         * @property {string|null} [requestId] SetTargetPoolsInstanceGroupManagerRequest requestId
                         * @property {string|null} [zone] SetTargetPoolsInstanceGroupManagerRequest zone
                         */
    
                        /**
                         * Constructs a new SetTargetPoolsInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetTargetPoolsInstanceGroupManagerRequest.
                         * @implements ISetTargetPoolsInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetTargetPoolsInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function SetTargetPoolsInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetTargetPoolsInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest
                         * @instance
                         */
                        SetTargetPoolsInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * SetTargetPoolsInstanceGroupManagerRequest instanceGroupManagersSetTargetPoolsRequestResource.
                         * @member {google.cloud.compute.v1.IInstanceGroupManagersSetTargetPoolsRequest|null|undefined} instanceGroupManagersSetTargetPoolsRequestResource
                         * @memberof google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest
                         * @instance
                         */
                        SetTargetPoolsInstanceGroupManagerRequest.prototype.instanceGroupManagersSetTargetPoolsRequestResource = null;
    
                        /**
                         * SetTargetPoolsInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest
                         * @instance
                         */
                        SetTargetPoolsInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * SetTargetPoolsInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest
                         * @instance
                         */
                        SetTargetPoolsInstanceGroupManagerRequest.prototype.requestId = null;
    
                        /**
                         * SetTargetPoolsInstanceGroupManagerRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest
                         * @instance
                         */
                        SetTargetPoolsInstanceGroupManagerRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetTargetPoolsInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(SetTargetPoolsInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetTargetPoolsInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetTargetPoolsInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest} SetTargetPoolsInstanceGroupManagerRequest instance
                         */
                        SetTargetPoolsInstanceGroupManagerRequest.create = function create(properties) {
                            return new SetTargetPoolsInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetTargetPoolsInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetTargetPoolsInstanceGroupManagerRequest} message SetTargetPoolsInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetTargetPoolsInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            if (message.instanceGroupManagersSetTargetPoolsRequestResource != null && Object.hasOwnProperty.call(message, "instanceGroupManagersSetTargetPoolsRequestResource"))
                                $root.google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest.encode(message.instanceGroupManagersSetTargetPoolsRequestResource, writer.uint32(/* id 281150216, wireType 2 =*/2249201730).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetTargetPoolsInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetTargetPoolsInstanceGroupManagerRequest} message SetTargetPoolsInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetTargetPoolsInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetTargetPoolsInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest} SetTargetPoolsInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetTargetPoolsInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 281150216: {
                                        message.instanceGroupManagersSetTargetPoolsRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetTargetPoolsInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest} SetTargetPoolsInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetTargetPoolsInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetTargetPoolsInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetTargetPoolsInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.instanceGroupManagersSetTargetPoolsRequestResource != null && message.hasOwnProperty("instanceGroupManagersSetTargetPoolsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest.verify(message.instanceGroupManagersSetTargetPoolsRequestResource);
                                if (error)
                                    return "instanceGroupManagersSetTargetPoolsRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SetTargetPoolsInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest} SetTargetPoolsInstanceGroupManagerRequest
                         */
                        SetTargetPoolsInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.instanceGroupManagersSetTargetPoolsRequestResource != null) {
                                if (typeof object.instanceGroupManagersSetTargetPoolsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest.instanceGroupManagersSetTargetPoolsRequestResource: object expected");
                                message.instanceGroupManagersSetTargetPoolsRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest.fromObject(object.instanceGroupManagersSetTargetPoolsRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetTargetPoolsInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest} message SetTargetPoolsInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetTargetPoolsInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                                object.instanceGroupManagersSetTargetPoolsRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            if (message.instanceGroupManagersSetTargetPoolsRequestResource != null && message.hasOwnProperty("instanceGroupManagersSetTargetPoolsRequestResource"))
                                object.instanceGroupManagersSetTargetPoolsRequestResource = $root.google.cloud.compute.v1.InstanceGroupManagersSetTargetPoolsRequest.toObject(message.instanceGroupManagersSetTargetPoolsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetTargetPoolsInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetTargetPoolsInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetTargetPoolsInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetTargetPoolsInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest";
                        };
    
                        return SetTargetPoolsInstanceGroupManagerRequest;
                    })();
    
                    v1.SetTargetPoolsRegionInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of a SetTargetPoolsRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetTargetPoolsRegionInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] SetTargetPoolsRegionInstanceGroupManagerRequest instanceGroupManager
                         * @property {string|null} [project] SetTargetPoolsRegionInstanceGroupManagerRequest project
                         * @property {string|null} [region] SetTargetPoolsRegionInstanceGroupManagerRequest region
                         * @property {google.cloud.compute.v1.IRegionInstanceGroupManagersSetTargetPoolsRequest|null} [regionInstanceGroupManagersSetTargetPoolsRequestResource] SetTargetPoolsRegionInstanceGroupManagerRequest regionInstanceGroupManagersSetTargetPoolsRequestResource
                         * @property {string|null} [requestId] SetTargetPoolsRegionInstanceGroupManagerRequest requestId
                         */
    
                        /**
                         * Constructs a new SetTargetPoolsRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetTargetPoolsRegionInstanceGroupManagerRequest.
                         * @implements ISetTargetPoolsRegionInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetTargetPoolsRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function SetTargetPoolsRegionInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetTargetPoolsRegionInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        SetTargetPoolsRegionInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * SetTargetPoolsRegionInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        SetTargetPoolsRegionInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * SetTargetPoolsRegionInstanceGroupManagerRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        SetTargetPoolsRegionInstanceGroupManagerRequest.prototype.region = "";
    
                        /**
                         * SetTargetPoolsRegionInstanceGroupManagerRequest regionInstanceGroupManagersSetTargetPoolsRequestResource.
                         * @member {google.cloud.compute.v1.IRegionInstanceGroupManagersSetTargetPoolsRequest|null|undefined} regionInstanceGroupManagersSetTargetPoolsRequestResource
                         * @memberof google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        SetTargetPoolsRegionInstanceGroupManagerRequest.prototype.regionInstanceGroupManagersSetTargetPoolsRequestResource = null;
    
                        /**
                         * SetTargetPoolsRegionInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        SetTargetPoolsRegionInstanceGroupManagerRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetTargetPoolsRegionInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(SetTargetPoolsRegionInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetTargetPoolsRegionInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetTargetPoolsRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest} SetTargetPoolsRegionInstanceGroupManagerRequest instance
                         */
                        SetTargetPoolsRegionInstanceGroupManagerRequest.create = function create(properties) {
                            return new SetTargetPoolsRegionInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetTargetPoolsRegionInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetTargetPoolsRegionInstanceGroupManagerRequest} message SetTargetPoolsRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetTargetPoolsRegionInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.regionInstanceGroupManagersSetTargetPoolsRequestResource != null && Object.hasOwnProperty.call(message, "regionInstanceGroupManagersSetTargetPoolsRequestResource"))
                                $root.google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest.encode(message.regionInstanceGroupManagersSetTargetPoolsRequestResource, writer.uint32(/* id 78734717, wireType 2 =*/629877738).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetTargetPoolsRegionInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetTargetPoolsRegionInstanceGroupManagerRequest} message SetTargetPoolsRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetTargetPoolsRegionInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetTargetPoolsRegionInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest} SetTargetPoolsRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetTargetPoolsRegionInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 78734717: {
                                        message.regionInstanceGroupManagersSetTargetPoolsRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetTargetPoolsRegionInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest} SetTargetPoolsRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetTargetPoolsRegionInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetTargetPoolsRegionInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetTargetPoolsRegionInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionInstanceGroupManagersSetTargetPoolsRequestResource != null && message.hasOwnProperty("regionInstanceGroupManagersSetTargetPoolsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest.verify(message.regionInstanceGroupManagersSetTargetPoolsRequestResource);
                                if (error)
                                    return "regionInstanceGroupManagersSetTargetPoolsRequestResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetTargetPoolsRegionInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest} SetTargetPoolsRegionInstanceGroupManagerRequest
                         */
                        SetTargetPoolsRegionInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionInstanceGroupManagersSetTargetPoolsRequestResource != null) {
                                if (typeof object.regionInstanceGroupManagersSetTargetPoolsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest.regionInstanceGroupManagersSetTargetPoolsRequestResource: object expected");
                                message.regionInstanceGroupManagersSetTargetPoolsRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest.fromObject(object.regionInstanceGroupManagersSetTargetPoolsRequestResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetTargetPoolsRegionInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest} message SetTargetPoolsRegionInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetTargetPoolsRegionInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.regionInstanceGroupManagersSetTargetPoolsRequestResource = null;
                                object.region = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.regionInstanceGroupManagersSetTargetPoolsRequestResource != null && message.hasOwnProperty("regionInstanceGroupManagersSetTargetPoolsRequestResource"))
                                object.regionInstanceGroupManagersSetTargetPoolsRequestResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagersSetTargetPoolsRequest.toObject(message.regionInstanceGroupManagersSetTargetPoolsRequestResource, options);
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            return object;
                        };
    
                        /**
                         * Converts this SetTargetPoolsRegionInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetTargetPoolsRegionInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetTargetPoolsRegionInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetTargetPoolsRegionInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest";
                        };
    
                        return SetTargetPoolsRegionInstanceGroupManagerRequest;
                    })();
    
                    v1.SetUrlMapRegionTargetHttpProxyRequest = (function() {
    
                        /**
                         * Properties of a SetUrlMapRegionTargetHttpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetUrlMapRegionTargetHttpProxyRequest
                         * @property {string|null} [project] SetUrlMapRegionTargetHttpProxyRequest project
                         * @property {string|null} [region] SetUrlMapRegionTargetHttpProxyRequest region
                         * @property {string|null} [requestId] SetUrlMapRegionTargetHttpProxyRequest requestId
                         * @property {string|null} [targetHttpProxy] SetUrlMapRegionTargetHttpProxyRequest targetHttpProxy
                         * @property {google.cloud.compute.v1.IUrlMapReference|null} [urlMapReferenceResource] SetUrlMapRegionTargetHttpProxyRequest urlMapReferenceResource
                         */
    
                        /**
                         * Constructs a new SetUrlMapRegionTargetHttpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetUrlMapRegionTargetHttpProxyRequest.
                         * @implements ISetUrlMapRegionTargetHttpProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetUrlMapRegionTargetHttpProxyRequest=} [properties] Properties to set
                         */
                        function SetUrlMapRegionTargetHttpProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetUrlMapRegionTargetHttpProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest
                         * @instance
                         */
                        SetUrlMapRegionTargetHttpProxyRequest.prototype.project = "";
    
                        /**
                         * SetUrlMapRegionTargetHttpProxyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest
                         * @instance
                         */
                        SetUrlMapRegionTargetHttpProxyRequest.prototype.region = "";
    
                        /**
                         * SetUrlMapRegionTargetHttpProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest
                         * @instance
                         */
                        SetUrlMapRegionTargetHttpProxyRequest.prototype.requestId = null;
    
                        /**
                         * SetUrlMapRegionTargetHttpProxyRequest targetHttpProxy.
                         * @member {string} targetHttpProxy
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest
                         * @instance
                         */
                        SetUrlMapRegionTargetHttpProxyRequest.prototype.targetHttpProxy = "";
    
                        /**
                         * SetUrlMapRegionTargetHttpProxyRequest urlMapReferenceResource.
                         * @member {google.cloud.compute.v1.IUrlMapReference|null|undefined} urlMapReferenceResource
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest
                         * @instance
                         */
                        SetUrlMapRegionTargetHttpProxyRequest.prototype.urlMapReferenceResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetUrlMapRegionTargetHttpProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest
                         * @instance
                         */
                        Object.defineProperty(SetUrlMapRegionTargetHttpProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetUrlMapRegionTargetHttpProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetUrlMapRegionTargetHttpProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest} SetUrlMapRegionTargetHttpProxyRequest instance
                         */
                        SetUrlMapRegionTargetHttpProxyRequest.create = function create(properties) {
                            return new SetUrlMapRegionTargetHttpProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetUrlMapRegionTargetHttpProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetUrlMapRegionTargetHttpProxyRequest} message SetUrlMapRegionTargetHttpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetUrlMapRegionTargetHttpProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.targetHttpProxy != null && Object.hasOwnProperty.call(message, "targetHttpProxy"))
                                writer.uint32(/* id 206872421, wireType 2 =*/1654979370).string(message.targetHttpProxy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.urlMapReferenceResource != null && Object.hasOwnProperty.call(message, "urlMapReferenceResource"))
                                $root.google.cloud.compute.v1.UrlMapReference.encode(message.urlMapReferenceResource, writer.uint32(/* id 398701333, wireType 2 =*/3189610666).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetUrlMapRegionTargetHttpProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetUrlMapRegionTargetHttpProxyRequest} message SetUrlMapRegionTargetHttpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetUrlMapRegionTargetHttpProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetUrlMapRegionTargetHttpProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest} SetUrlMapRegionTargetHttpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetUrlMapRegionTargetHttpProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 206872421: {
                                        message.targetHttpProxy = reader.string();
                                        break;
                                    }
                                case 398701333: {
                                        message.urlMapReferenceResource = $root.google.cloud.compute.v1.UrlMapReference.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetUrlMapRegionTargetHttpProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest} SetUrlMapRegionTargetHttpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetUrlMapRegionTargetHttpProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetUrlMapRegionTargetHttpProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetUrlMapRegionTargetHttpProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetHttpProxy != null && message.hasOwnProperty("targetHttpProxy"))
                                if (!$util.isString(message.targetHttpProxy))
                                    return "targetHttpProxy: string expected";
                            if (message.urlMapReferenceResource != null && message.hasOwnProperty("urlMapReferenceResource")) {
                                var error = $root.google.cloud.compute.v1.UrlMapReference.verify(message.urlMapReferenceResource);
                                if (error)
                                    return "urlMapReferenceResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetUrlMapRegionTargetHttpProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest} SetUrlMapRegionTargetHttpProxyRequest
                         */
                        SetUrlMapRegionTargetHttpProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetHttpProxy != null)
                                message.targetHttpProxy = String(object.targetHttpProxy);
                            if (object.urlMapReferenceResource != null) {
                                if (typeof object.urlMapReferenceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest.urlMapReferenceResource: object expected");
                                message.urlMapReferenceResource = $root.google.cloud.compute.v1.UrlMapReference.fromObject(object.urlMapReferenceResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetUrlMapRegionTargetHttpProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest} message SetUrlMapRegionTargetHttpProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetUrlMapRegionTargetHttpProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.targetHttpProxy = "";
                                object.project = "";
                                object.urlMapReferenceResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.targetHttpProxy != null && message.hasOwnProperty("targetHttpProxy"))
                                object.targetHttpProxy = message.targetHttpProxy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.urlMapReferenceResource != null && message.hasOwnProperty("urlMapReferenceResource"))
                                object.urlMapReferenceResource = $root.google.cloud.compute.v1.UrlMapReference.toObject(message.urlMapReferenceResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetUrlMapRegionTargetHttpProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetUrlMapRegionTargetHttpProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetUrlMapRegionTargetHttpProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetUrlMapRegionTargetHttpProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest";
                        };
    
                        return SetUrlMapRegionTargetHttpProxyRequest;
                    })();
    
                    v1.SetUrlMapRegionTargetHttpsProxyRequest = (function() {
    
                        /**
                         * Properties of a SetUrlMapRegionTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetUrlMapRegionTargetHttpsProxyRequest
                         * @property {string|null} [project] SetUrlMapRegionTargetHttpsProxyRequest project
                         * @property {string|null} [region] SetUrlMapRegionTargetHttpsProxyRequest region
                         * @property {string|null} [requestId] SetUrlMapRegionTargetHttpsProxyRequest requestId
                         * @property {string|null} [targetHttpsProxy] SetUrlMapRegionTargetHttpsProxyRequest targetHttpsProxy
                         * @property {google.cloud.compute.v1.IUrlMapReference|null} [urlMapReferenceResource] SetUrlMapRegionTargetHttpsProxyRequest urlMapReferenceResource
                         */
    
                        /**
                         * Constructs a new SetUrlMapRegionTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetUrlMapRegionTargetHttpsProxyRequest.
                         * @implements ISetUrlMapRegionTargetHttpsProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetUrlMapRegionTargetHttpsProxyRequest=} [properties] Properties to set
                         */
                        function SetUrlMapRegionTargetHttpsProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetUrlMapRegionTargetHttpsProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        SetUrlMapRegionTargetHttpsProxyRequest.prototype.project = "";
    
                        /**
                         * SetUrlMapRegionTargetHttpsProxyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        SetUrlMapRegionTargetHttpsProxyRequest.prototype.region = "";
    
                        /**
                         * SetUrlMapRegionTargetHttpsProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        SetUrlMapRegionTargetHttpsProxyRequest.prototype.requestId = null;
    
                        /**
                         * SetUrlMapRegionTargetHttpsProxyRequest targetHttpsProxy.
                         * @member {string} targetHttpsProxy
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        SetUrlMapRegionTargetHttpsProxyRequest.prototype.targetHttpsProxy = "";
    
                        /**
                         * SetUrlMapRegionTargetHttpsProxyRequest urlMapReferenceResource.
                         * @member {google.cloud.compute.v1.IUrlMapReference|null|undefined} urlMapReferenceResource
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        SetUrlMapRegionTargetHttpsProxyRequest.prototype.urlMapReferenceResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetUrlMapRegionTargetHttpsProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest
                         * @instance
                         */
                        Object.defineProperty(SetUrlMapRegionTargetHttpsProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetUrlMapRegionTargetHttpsProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetUrlMapRegionTargetHttpsProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest} SetUrlMapRegionTargetHttpsProxyRequest instance
                         */
                        SetUrlMapRegionTargetHttpsProxyRequest.create = function create(properties) {
                            return new SetUrlMapRegionTargetHttpsProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetUrlMapRegionTargetHttpsProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetUrlMapRegionTargetHttpsProxyRequest} message SetUrlMapRegionTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetUrlMapRegionTargetHttpsProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetHttpsProxy != null && Object.hasOwnProperty.call(message, "targetHttpsProxy"))
                                writer.uint32(/* id 52336748, wireType 2 =*/418693986).string(message.targetHttpsProxy);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.urlMapReferenceResource != null && Object.hasOwnProperty.call(message, "urlMapReferenceResource"))
                                $root.google.cloud.compute.v1.UrlMapReference.encode(message.urlMapReferenceResource, writer.uint32(/* id 398701333, wireType 2 =*/3189610666).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetUrlMapRegionTargetHttpsProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetUrlMapRegionTargetHttpsProxyRequest} message SetUrlMapRegionTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetUrlMapRegionTargetHttpsProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetUrlMapRegionTargetHttpsProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest} SetUrlMapRegionTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetUrlMapRegionTargetHttpsProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 52336748: {
                                        message.targetHttpsProxy = reader.string();
                                        break;
                                    }
                                case 398701333: {
                                        message.urlMapReferenceResource = $root.google.cloud.compute.v1.UrlMapReference.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetUrlMapRegionTargetHttpsProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest} SetUrlMapRegionTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetUrlMapRegionTargetHttpsProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetUrlMapRegionTargetHttpsProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetUrlMapRegionTargetHttpsProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                if (!$util.isString(message.targetHttpsProxy))
                                    return "targetHttpsProxy: string expected";
                            if (message.urlMapReferenceResource != null && message.hasOwnProperty("urlMapReferenceResource")) {
                                var error = $root.google.cloud.compute.v1.UrlMapReference.verify(message.urlMapReferenceResource);
                                if (error)
                                    return "urlMapReferenceResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetUrlMapRegionTargetHttpsProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest} SetUrlMapRegionTargetHttpsProxyRequest
                         */
                        SetUrlMapRegionTargetHttpsProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetHttpsProxy != null)
                                message.targetHttpsProxy = String(object.targetHttpsProxy);
                            if (object.urlMapReferenceResource != null) {
                                if (typeof object.urlMapReferenceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest.urlMapReferenceResource: object expected");
                                message.urlMapReferenceResource = $root.google.cloud.compute.v1.UrlMapReference.fromObject(object.urlMapReferenceResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetUrlMapRegionTargetHttpsProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest} message SetUrlMapRegionTargetHttpsProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetUrlMapRegionTargetHttpsProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetHttpsProxy = "";
                                object.region = "";
                                object.project = "";
                                object.urlMapReferenceResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                object.targetHttpsProxy = message.targetHttpsProxy;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.urlMapReferenceResource != null && message.hasOwnProperty("urlMapReferenceResource"))
                                object.urlMapReferenceResource = $root.google.cloud.compute.v1.UrlMapReference.toObject(message.urlMapReferenceResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetUrlMapRegionTargetHttpsProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetUrlMapRegionTargetHttpsProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetUrlMapRegionTargetHttpsProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetUrlMapRegionTargetHttpsProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest";
                        };
    
                        return SetUrlMapRegionTargetHttpsProxyRequest;
                    })();
    
                    v1.SetUrlMapTargetHttpProxyRequest = (function() {
    
                        /**
                         * Properties of a SetUrlMapTargetHttpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetUrlMapTargetHttpProxyRequest
                         * @property {string|null} [project] SetUrlMapTargetHttpProxyRequest project
                         * @property {string|null} [requestId] SetUrlMapTargetHttpProxyRequest requestId
                         * @property {string|null} [targetHttpProxy] SetUrlMapTargetHttpProxyRequest targetHttpProxy
                         * @property {google.cloud.compute.v1.IUrlMapReference|null} [urlMapReferenceResource] SetUrlMapTargetHttpProxyRequest urlMapReferenceResource
                         */
    
                        /**
                         * Constructs a new SetUrlMapTargetHttpProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetUrlMapTargetHttpProxyRequest.
                         * @implements ISetUrlMapTargetHttpProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetUrlMapTargetHttpProxyRequest=} [properties] Properties to set
                         */
                        function SetUrlMapTargetHttpProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetUrlMapTargetHttpProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest
                         * @instance
                         */
                        SetUrlMapTargetHttpProxyRequest.prototype.project = "";
    
                        /**
                         * SetUrlMapTargetHttpProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest
                         * @instance
                         */
                        SetUrlMapTargetHttpProxyRequest.prototype.requestId = null;
    
                        /**
                         * SetUrlMapTargetHttpProxyRequest targetHttpProxy.
                         * @member {string} targetHttpProxy
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest
                         * @instance
                         */
                        SetUrlMapTargetHttpProxyRequest.prototype.targetHttpProxy = "";
    
                        /**
                         * SetUrlMapTargetHttpProxyRequest urlMapReferenceResource.
                         * @member {google.cloud.compute.v1.IUrlMapReference|null|undefined} urlMapReferenceResource
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest
                         * @instance
                         */
                        SetUrlMapTargetHttpProxyRequest.prototype.urlMapReferenceResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetUrlMapTargetHttpProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest
                         * @instance
                         */
                        Object.defineProperty(SetUrlMapTargetHttpProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetUrlMapTargetHttpProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetUrlMapTargetHttpProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest} SetUrlMapTargetHttpProxyRequest instance
                         */
                        SetUrlMapTargetHttpProxyRequest.create = function create(properties) {
                            return new SetUrlMapTargetHttpProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetUrlMapTargetHttpProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetUrlMapTargetHttpProxyRequest} message SetUrlMapTargetHttpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetUrlMapTargetHttpProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetHttpProxy != null && Object.hasOwnProperty.call(message, "targetHttpProxy"))
                                writer.uint32(/* id 206872421, wireType 2 =*/1654979370).string(message.targetHttpProxy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.urlMapReferenceResource != null && Object.hasOwnProperty.call(message, "urlMapReferenceResource"))
                                $root.google.cloud.compute.v1.UrlMapReference.encode(message.urlMapReferenceResource, writer.uint32(/* id 398701333, wireType 2 =*/3189610666).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetUrlMapTargetHttpProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetUrlMapTargetHttpProxyRequest} message SetUrlMapTargetHttpProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetUrlMapTargetHttpProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetUrlMapTargetHttpProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest} SetUrlMapTargetHttpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetUrlMapTargetHttpProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 206872421: {
                                        message.targetHttpProxy = reader.string();
                                        break;
                                    }
                                case 398701333: {
                                        message.urlMapReferenceResource = $root.google.cloud.compute.v1.UrlMapReference.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetUrlMapTargetHttpProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest} SetUrlMapTargetHttpProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetUrlMapTargetHttpProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetUrlMapTargetHttpProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetUrlMapTargetHttpProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetHttpProxy != null && message.hasOwnProperty("targetHttpProxy"))
                                if (!$util.isString(message.targetHttpProxy))
                                    return "targetHttpProxy: string expected";
                            if (message.urlMapReferenceResource != null && message.hasOwnProperty("urlMapReferenceResource")) {
                                var error = $root.google.cloud.compute.v1.UrlMapReference.verify(message.urlMapReferenceResource);
                                if (error)
                                    return "urlMapReferenceResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetUrlMapTargetHttpProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest} SetUrlMapTargetHttpProxyRequest
                         */
                        SetUrlMapTargetHttpProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetHttpProxy != null)
                                message.targetHttpProxy = String(object.targetHttpProxy);
                            if (object.urlMapReferenceResource != null) {
                                if (typeof object.urlMapReferenceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest.urlMapReferenceResource: object expected");
                                message.urlMapReferenceResource = $root.google.cloud.compute.v1.UrlMapReference.fromObject(object.urlMapReferenceResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetUrlMapTargetHttpProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest} message SetUrlMapTargetHttpProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetUrlMapTargetHttpProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetHttpProxy = "";
                                object.project = "";
                                object.urlMapReferenceResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetHttpProxy != null && message.hasOwnProperty("targetHttpProxy"))
                                object.targetHttpProxy = message.targetHttpProxy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.urlMapReferenceResource != null && message.hasOwnProperty("urlMapReferenceResource"))
                                object.urlMapReferenceResource = $root.google.cloud.compute.v1.UrlMapReference.toObject(message.urlMapReferenceResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetUrlMapTargetHttpProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetUrlMapTargetHttpProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetUrlMapTargetHttpProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetUrlMapTargetHttpProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest";
                        };
    
                        return SetUrlMapTargetHttpProxyRequest;
                    })();
    
                    v1.SetUrlMapTargetHttpsProxyRequest = (function() {
    
                        /**
                         * Properties of a SetUrlMapTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetUrlMapTargetHttpsProxyRequest
                         * @property {string|null} [project] SetUrlMapTargetHttpsProxyRequest project
                         * @property {string|null} [requestId] SetUrlMapTargetHttpsProxyRequest requestId
                         * @property {string|null} [targetHttpsProxy] SetUrlMapTargetHttpsProxyRequest targetHttpsProxy
                         * @property {google.cloud.compute.v1.IUrlMapReference|null} [urlMapReferenceResource] SetUrlMapTargetHttpsProxyRequest urlMapReferenceResource
                         */
    
                        /**
                         * Constructs a new SetUrlMapTargetHttpsProxyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetUrlMapTargetHttpsProxyRequest.
                         * @implements ISetUrlMapTargetHttpsProxyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetUrlMapTargetHttpsProxyRequest=} [properties] Properties to set
                         */
                        function SetUrlMapTargetHttpsProxyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetUrlMapTargetHttpsProxyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest
                         * @instance
                         */
                        SetUrlMapTargetHttpsProxyRequest.prototype.project = "";
    
                        /**
                         * SetUrlMapTargetHttpsProxyRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest
                         * @instance
                         */
                        SetUrlMapTargetHttpsProxyRequest.prototype.requestId = null;
    
                        /**
                         * SetUrlMapTargetHttpsProxyRequest targetHttpsProxy.
                         * @member {string} targetHttpsProxy
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest
                         * @instance
                         */
                        SetUrlMapTargetHttpsProxyRequest.prototype.targetHttpsProxy = "";
    
                        /**
                         * SetUrlMapTargetHttpsProxyRequest urlMapReferenceResource.
                         * @member {google.cloud.compute.v1.IUrlMapReference|null|undefined} urlMapReferenceResource
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest
                         * @instance
                         */
                        SetUrlMapTargetHttpsProxyRequest.prototype.urlMapReferenceResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetUrlMapTargetHttpsProxyRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest
                         * @instance
                         */
                        Object.defineProperty(SetUrlMapTargetHttpsProxyRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetUrlMapTargetHttpsProxyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetUrlMapTargetHttpsProxyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest} SetUrlMapTargetHttpsProxyRequest instance
                         */
                        SetUrlMapTargetHttpsProxyRequest.create = function create(properties) {
                            return new SetUrlMapTargetHttpsProxyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetUrlMapTargetHttpsProxyRequest message. Does not implicitly {@link google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetUrlMapTargetHttpsProxyRequest} message SetUrlMapTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetUrlMapTargetHttpsProxyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.targetHttpsProxy != null && Object.hasOwnProperty.call(message, "targetHttpsProxy"))
                                writer.uint32(/* id 52336748, wireType 2 =*/418693986).string(message.targetHttpsProxy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.urlMapReferenceResource != null && Object.hasOwnProperty.call(message, "urlMapReferenceResource"))
                                $root.google.cloud.compute.v1.UrlMapReference.encode(message.urlMapReferenceResource, writer.uint32(/* id 398701333, wireType 2 =*/3189610666).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetUrlMapTargetHttpsProxyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetUrlMapTargetHttpsProxyRequest} message SetUrlMapTargetHttpsProxyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetUrlMapTargetHttpsProxyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetUrlMapTargetHttpsProxyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest} SetUrlMapTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetUrlMapTargetHttpsProxyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 52336748: {
                                        message.targetHttpsProxy = reader.string();
                                        break;
                                    }
                                case 398701333: {
                                        message.urlMapReferenceResource = $root.google.cloud.compute.v1.UrlMapReference.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetUrlMapTargetHttpsProxyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest} SetUrlMapTargetHttpsProxyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetUrlMapTargetHttpsProxyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetUrlMapTargetHttpsProxyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetUrlMapTargetHttpsProxyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                if (!$util.isString(message.targetHttpsProxy))
                                    return "targetHttpsProxy: string expected";
                            if (message.urlMapReferenceResource != null && message.hasOwnProperty("urlMapReferenceResource")) {
                                var error = $root.google.cloud.compute.v1.UrlMapReference.verify(message.urlMapReferenceResource);
                                if (error)
                                    return "urlMapReferenceResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetUrlMapTargetHttpsProxyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest} SetUrlMapTargetHttpsProxyRequest
                         */
                        SetUrlMapTargetHttpsProxyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.targetHttpsProxy != null)
                                message.targetHttpsProxy = String(object.targetHttpsProxy);
                            if (object.urlMapReferenceResource != null) {
                                if (typeof object.urlMapReferenceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest.urlMapReferenceResource: object expected");
                                message.urlMapReferenceResource = $root.google.cloud.compute.v1.UrlMapReference.fromObject(object.urlMapReferenceResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetUrlMapTargetHttpsProxyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest} message SetUrlMapTargetHttpsProxyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetUrlMapTargetHttpsProxyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.targetHttpsProxy = "";
                                object.project = "";
                                object.urlMapReferenceResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.targetHttpsProxy != null && message.hasOwnProperty("targetHttpsProxy"))
                                object.targetHttpsProxy = message.targetHttpsProxy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.urlMapReferenceResource != null && message.hasOwnProperty("urlMapReferenceResource"))
                                object.urlMapReferenceResource = $root.google.cloud.compute.v1.UrlMapReference.toObject(message.urlMapReferenceResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this SetUrlMapTargetHttpsProxyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetUrlMapTargetHttpsProxyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetUrlMapTargetHttpsProxyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetUrlMapTargetHttpsProxyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest";
                        };
    
                        return SetUrlMapTargetHttpsProxyRequest;
                    })();
    
                    v1.SetUsageExportBucketProjectRequest = (function() {
    
                        /**
                         * Properties of a SetUsageExportBucketProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISetUsageExportBucketProjectRequest
                         * @property {string|null} [project] SetUsageExportBucketProjectRequest project
                         * @property {string|null} [requestId] SetUsageExportBucketProjectRequest requestId
                         * @property {google.cloud.compute.v1.IUsageExportLocation|null} [usageExportLocationResource] SetUsageExportBucketProjectRequest usageExportLocationResource
                         */
    
                        /**
                         * Constructs a new SetUsageExportBucketProjectRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SetUsageExportBucketProjectRequest.
                         * @implements ISetUsageExportBucketProjectRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISetUsageExportBucketProjectRequest=} [properties] Properties to set
                         */
                        function SetUsageExportBucketProjectRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SetUsageExportBucketProjectRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SetUsageExportBucketProjectRequest
                         * @instance
                         */
                        SetUsageExportBucketProjectRequest.prototype.project = "";
    
                        /**
                         * SetUsageExportBucketProjectRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SetUsageExportBucketProjectRequest
                         * @instance
                         */
                        SetUsageExportBucketProjectRequest.prototype.requestId = null;
    
                        /**
                         * SetUsageExportBucketProjectRequest usageExportLocationResource.
                         * @member {google.cloud.compute.v1.IUsageExportLocation|null|undefined} usageExportLocationResource
                         * @memberof google.cloud.compute.v1.SetUsageExportBucketProjectRequest
                         * @instance
                         */
                        SetUsageExportBucketProjectRequest.prototype.usageExportLocationResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SetUsageExportBucketProjectRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SetUsageExportBucketProjectRequest
                         * @instance
                         */
                        Object.defineProperty(SetUsageExportBucketProjectRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SetUsageExportBucketProjectRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SetUsageExportBucketProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetUsageExportBucketProjectRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SetUsageExportBucketProjectRequest} SetUsageExportBucketProjectRequest instance
                         */
                        SetUsageExportBucketProjectRequest.create = function create(properties) {
                            return new SetUsageExportBucketProjectRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SetUsageExportBucketProjectRequest message. Does not implicitly {@link google.cloud.compute.v1.SetUsageExportBucketProjectRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SetUsageExportBucketProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetUsageExportBucketProjectRequest} message SetUsageExportBucketProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetUsageExportBucketProjectRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.usageExportLocationResource != null && Object.hasOwnProperty.call(message, "usageExportLocationResource"))
                                $root.google.cloud.compute.v1.UsageExportLocation.encode(message.usageExportLocationResource, writer.uint32(/* id 20260459, wireType 2 =*/162083674).fork()).ldelim();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SetUsageExportBucketProjectRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SetUsageExportBucketProjectRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SetUsageExportBucketProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISetUsageExportBucketProjectRequest} message SetUsageExportBucketProjectRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SetUsageExportBucketProjectRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SetUsageExportBucketProjectRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SetUsageExportBucketProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SetUsageExportBucketProjectRequest} SetUsageExportBucketProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetUsageExportBucketProjectRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SetUsageExportBucketProjectRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 20260459: {
                                        message.usageExportLocationResource = $root.google.cloud.compute.v1.UsageExportLocation.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SetUsageExportBucketProjectRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SetUsageExportBucketProjectRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SetUsageExportBucketProjectRequest} SetUsageExportBucketProjectRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SetUsageExportBucketProjectRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SetUsageExportBucketProjectRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SetUsageExportBucketProjectRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SetUsageExportBucketProjectRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.usageExportLocationResource != null && message.hasOwnProperty("usageExportLocationResource")) {
                                var error = $root.google.cloud.compute.v1.UsageExportLocation.verify(message.usageExportLocationResource);
                                if (error)
                                    return "usageExportLocationResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SetUsageExportBucketProjectRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SetUsageExportBucketProjectRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SetUsageExportBucketProjectRequest} SetUsageExportBucketProjectRequest
                         */
                        SetUsageExportBucketProjectRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SetUsageExportBucketProjectRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SetUsageExportBucketProjectRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.usageExportLocationResource != null) {
                                if (typeof object.usageExportLocationResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SetUsageExportBucketProjectRequest.usageExportLocationResource: object expected");
                                message.usageExportLocationResource = $root.google.cloud.compute.v1.UsageExportLocation.fromObject(object.usageExportLocationResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SetUsageExportBucketProjectRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SetUsageExportBucketProjectRequest
                         * @static
                         * @param {google.cloud.compute.v1.SetUsageExportBucketProjectRequest} message SetUsageExportBucketProjectRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SetUsageExportBucketProjectRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.usageExportLocationResource = null;
                                object.project = "";
                            }
                            if (message.usageExportLocationResource != null && message.hasOwnProperty("usageExportLocationResource"))
                                object.usageExportLocationResource = $root.google.cloud.compute.v1.UsageExportLocation.toObject(message.usageExportLocationResource, options);
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this SetUsageExportBucketProjectRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SetUsageExportBucketProjectRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SetUsageExportBucketProjectRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SetUsageExportBucketProjectRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SetUsageExportBucketProjectRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SetUsageExportBucketProjectRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SetUsageExportBucketProjectRequest";
                        };
    
                        return SetUsageExportBucketProjectRequest;
                    })();
    
                    v1.ShareSettings = (function() {
    
                        /**
                         * Properties of a ShareSettings.
                         * @memberof google.cloud.compute.v1
                         * @interface IShareSettings
                         * @property {Object.<string,google.cloud.compute.v1.IShareSettingsProjectConfig>|null} [projectMap] ShareSettings projectMap
                         * @property {string|null} [shareType] ShareSettings shareType
                         */
    
                        /**
                         * Constructs a new ShareSettings.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ShareSettings.
                         * @implements IShareSettings
                         * @constructor
                         * @param {google.cloud.compute.v1.IShareSettings=} [properties] Properties to set
                         */
                        function ShareSettings(properties) {
                            this.projectMap = {};
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ShareSettings projectMap.
                         * @member {Object.<string,google.cloud.compute.v1.IShareSettingsProjectConfig>} projectMap
                         * @memberof google.cloud.compute.v1.ShareSettings
                         * @instance
                         */
                        ShareSettings.prototype.projectMap = $util.emptyObject;
    
                        /**
                         * ShareSettings shareType.
                         * @member {string|null|undefined} shareType
                         * @memberof google.cloud.compute.v1.ShareSettings
                         * @instance
                         */
                        ShareSettings.prototype.shareType = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ShareSettings _shareType.
                         * @member {"shareType"|undefined} _shareType
                         * @memberof google.cloud.compute.v1.ShareSettings
                         * @instance
                         */
                        Object.defineProperty(ShareSettings.prototype, "_shareType", {
                            get: $util.oneOfGetter($oneOfFields = ["shareType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ShareSettings instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ShareSettings
                         * @static
                         * @param {google.cloud.compute.v1.IShareSettings=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ShareSettings} ShareSettings instance
                         */
                        ShareSettings.create = function create(properties) {
                            return new ShareSettings(properties);
                        };
    
                        /**
                         * Encodes the specified ShareSettings message. Does not implicitly {@link google.cloud.compute.v1.ShareSettings.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ShareSettings
                         * @static
                         * @param {google.cloud.compute.v1.IShareSettings} message ShareSettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ShareSettings.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.projectMap != null && Object.hasOwnProperty.call(message, "projectMap"))
                                for (var keys = Object.keys(message.projectMap), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 134212406, wireType 2 =*/1073699250).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.ShareSettingsProjectConfig.encode(message.projectMap[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.shareType != null && Object.hasOwnProperty.call(message, "shareType"))
                                writer.uint32(/* id 359533466, wireType 2 =*/2876267730).string(message.shareType);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ShareSettings message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ShareSettings.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ShareSettings
                         * @static
                         * @param {google.cloud.compute.v1.IShareSettings} message ShareSettings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ShareSettings.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ShareSettings message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ShareSettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ShareSettings} ShareSettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ShareSettings.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ShareSettings(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 134212406: {
                                        if (message.projectMap === $util.emptyObject)
                                            message.projectMap = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.ShareSettingsProjectConfig.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.projectMap[key] = value;
                                        break;
                                    }
                                case 359533466: {
                                        message.shareType = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ShareSettings message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ShareSettings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ShareSettings} ShareSettings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ShareSettings.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ShareSettings message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ShareSettings
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ShareSettings.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.projectMap != null && message.hasOwnProperty("projectMap")) {
                                if (!$util.isObject(message.projectMap))
                                    return "projectMap: object expected";
                                var key = Object.keys(message.projectMap);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ShareSettingsProjectConfig.verify(message.projectMap[key[i]]);
                                    if (error)
                                        return "projectMap." + error;
                                }
                            }
                            if (message.shareType != null && message.hasOwnProperty("shareType")) {
                                properties._shareType = 1;
                                if (!$util.isString(message.shareType))
                                    return "shareType: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ShareSettings message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ShareSettings
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ShareSettings} ShareSettings
                         */
                        ShareSettings.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ShareSettings)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ShareSettings();
                            if (object.projectMap) {
                                if (typeof object.projectMap !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ShareSettings.projectMap: object expected");
                                message.projectMap = {};
                                for (var keys = Object.keys(object.projectMap), i = 0; i < keys.length; ++i) {
                                    if (typeof object.projectMap[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ShareSettings.projectMap: object expected");
                                    message.projectMap[keys[i]] = $root.google.cloud.compute.v1.ShareSettingsProjectConfig.fromObject(object.projectMap[keys[i]]);
                                }
                            }
                            if (object.shareType != null)
                                message.shareType = String(object.shareType);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ShareSettings message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ShareSettings
                         * @static
                         * @param {google.cloud.compute.v1.ShareSettings} message ShareSettings
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ShareSettings.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.objects || options.defaults)
                                object.projectMap = {};
                            var keys2;
                            if (message.projectMap && (keys2 = Object.keys(message.projectMap)).length) {
                                object.projectMap = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.projectMap[keys2[j]] = $root.google.cloud.compute.v1.ShareSettingsProjectConfig.toObject(message.projectMap[keys2[j]], options);
                            }
                            if (message.shareType != null && message.hasOwnProperty("shareType")) {
                                object.shareType = message.shareType;
                                if (options.oneofs)
                                    object._shareType = "shareType";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ShareSettings to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ShareSettings
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ShareSettings.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ShareSettings
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ShareSettings
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ShareSettings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ShareSettings";
                        };
    
                        /**
                         * ShareType enum.
                         * @name google.cloud.compute.v1.ShareSettings.ShareType
                         * @enum {number}
                         * @property {number} UNDEFINED_SHARE_TYPE=0 UNDEFINED_SHARE_TYPE value
                         * @property {number} LOCAL=72607563 LOCAL value
                         * @property {number} ORGANIZATION=274978099 ORGANIZATION value
                         * @property {number} SHARE_TYPE_UNSPECIFIED=494771730 SHARE_TYPE_UNSPECIFIED value
                         * @property {number} SPECIFIC_PROJECTS=347838695 SPECIFIC_PROJECTS value
                         */
                        ShareSettings.ShareType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_SHARE_TYPE"] = 0;
                            values[valuesById[72607563] = "LOCAL"] = 72607563;
                            values[valuesById[274978099] = "ORGANIZATION"] = 274978099;
                            values[valuesById[494771730] = "SHARE_TYPE_UNSPECIFIED"] = 494771730;
                            values[valuesById[347838695] = "SPECIFIC_PROJECTS"] = 347838695;
                            return values;
                        })();
    
                        return ShareSettings;
                    })();
    
                    v1.ShareSettingsProjectConfig = (function() {
    
                        /**
                         * Properties of a ShareSettingsProjectConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface IShareSettingsProjectConfig
                         * @property {string|null} [projectId] ShareSettingsProjectConfig projectId
                         */
    
                        /**
                         * Constructs a new ShareSettingsProjectConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ShareSettingsProjectConfig.
                         * @implements IShareSettingsProjectConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.IShareSettingsProjectConfig=} [properties] Properties to set
                         */
                        function ShareSettingsProjectConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ShareSettingsProjectConfig projectId.
                         * @member {string|null|undefined} projectId
                         * @memberof google.cloud.compute.v1.ShareSettingsProjectConfig
                         * @instance
                         */
                        ShareSettingsProjectConfig.prototype.projectId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ShareSettingsProjectConfig _projectId.
                         * @member {"projectId"|undefined} _projectId
                         * @memberof google.cloud.compute.v1.ShareSettingsProjectConfig
                         * @instance
                         */
                        Object.defineProperty(ShareSettingsProjectConfig.prototype, "_projectId", {
                            get: $util.oneOfGetter($oneOfFields = ["projectId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ShareSettingsProjectConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ShareSettingsProjectConfig
                         * @static
                         * @param {google.cloud.compute.v1.IShareSettingsProjectConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ShareSettingsProjectConfig} ShareSettingsProjectConfig instance
                         */
                        ShareSettingsProjectConfig.create = function create(properties) {
                            return new ShareSettingsProjectConfig(properties);
                        };
    
                        /**
                         * Encodes the specified ShareSettingsProjectConfig message. Does not implicitly {@link google.cloud.compute.v1.ShareSettingsProjectConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ShareSettingsProjectConfig
                         * @static
                         * @param {google.cloud.compute.v1.IShareSettingsProjectConfig} message ShareSettingsProjectConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ShareSettingsProjectConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.projectId != null && Object.hasOwnProperty.call(message, "projectId"))
                                writer.uint32(/* id 177513473, wireType 2 =*/1420107786).string(message.projectId);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ShareSettingsProjectConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ShareSettingsProjectConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ShareSettingsProjectConfig
                         * @static
                         * @param {google.cloud.compute.v1.IShareSettingsProjectConfig} message ShareSettingsProjectConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ShareSettingsProjectConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ShareSettingsProjectConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ShareSettingsProjectConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ShareSettingsProjectConfig} ShareSettingsProjectConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ShareSettingsProjectConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ShareSettingsProjectConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 177513473: {
                                        message.projectId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ShareSettingsProjectConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ShareSettingsProjectConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ShareSettingsProjectConfig} ShareSettingsProjectConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ShareSettingsProjectConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ShareSettingsProjectConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ShareSettingsProjectConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ShareSettingsProjectConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.projectId != null && message.hasOwnProperty("projectId")) {
                                properties._projectId = 1;
                                if (!$util.isString(message.projectId))
                                    return "projectId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ShareSettingsProjectConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ShareSettingsProjectConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ShareSettingsProjectConfig} ShareSettingsProjectConfig
                         */
                        ShareSettingsProjectConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ShareSettingsProjectConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ShareSettingsProjectConfig();
                            if (object.projectId != null)
                                message.projectId = String(object.projectId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ShareSettingsProjectConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ShareSettingsProjectConfig
                         * @static
                         * @param {google.cloud.compute.v1.ShareSettingsProjectConfig} message ShareSettingsProjectConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ShareSettingsProjectConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.projectId != null && message.hasOwnProperty("projectId")) {
                                object.projectId = message.projectId;
                                if (options.oneofs)
                                    object._projectId = "projectId";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ShareSettingsProjectConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ShareSettingsProjectConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ShareSettingsProjectConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ShareSettingsProjectConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ShareSettingsProjectConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ShareSettingsProjectConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ShareSettingsProjectConfig";
                        };
    
                        return ShareSettingsProjectConfig;
                    })();
    
                    v1.ShieldedInstanceConfig = (function() {
    
                        /**
                         * Properties of a ShieldedInstanceConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface IShieldedInstanceConfig
                         * @property {boolean|null} [enableIntegrityMonitoring] ShieldedInstanceConfig enableIntegrityMonitoring
                         * @property {boolean|null} [enableSecureBoot] ShieldedInstanceConfig enableSecureBoot
                         * @property {boolean|null} [enableVtpm] ShieldedInstanceConfig enableVtpm
                         */
    
                        /**
                         * Constructs a new ShieldedInstanceConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ShieldedInstanceConfig.
                         * @implements IShieldedInstanceConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.IShieldedInstanceConfig=} [properties] Properties to set
                         */
                        function ShieldedInstanceConfig(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ShieldedInstanceConfig enableIntegrityMonitoring.
                         * @member {boolean|null|undefined} enableIntegrityMonitoring
                         * @memberof google.cloud.compute.v1.ShieldedInstanceConfig
                         * @instance
                         */
                        ShieldedInstanceConfig.prototype.enableIntegrityMonitoring = null;
    
                        /**
                         * ShieldedInstanceConfig enableSecureBoot.
                         * @member {boolean|null|undefined} enableSecureBoot
                         * @memberof google.cloud.compute.v1.ShieldedInstanceConfig
                         * @instance
                         */
                        ShieldedInstanceConfig.prototype.enableSecureBoot = null;
    
                        /**
                         * ShieldedInstanceConfig enableVtpm.
                         * @member {boolean|null|undefined} enableVtpm
                         * @memberof google.cloud.compute.v1.ShieldedInstanceConfig
                         * @instance
                         */
                        ShieldedInstanceConfig.prototype.enableVtpm = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ShieldedInstanceConfig _enableIntegrityMonitoring.
                         * @member {"enableIntegrityMonitoring"|undefined} _enableIntegrityMonitoring
                         * @memberof google.cloud.compute.v1.ShieldedInstanceConfig
                         * @instance
                         */
                        Object.defineProperty(ShieldedInstanceConfig.prototype, "_enableIntegrityMonitoring", {
                            get: $util.oneOfGetter($oneOfFields = ["enableIntegrityMonitoring"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ShieldedInstanceConfig _enableSecureBoot.
                         * @member {"enableSecureBoot"|undefined} _enableSecureBoot
                         * @memberof google.cloud.compute.v1.ShieldedInstanceConfig
                         * @instance
                         */
                        Object.defineProperty(ShieldedInstanceConfig.prototype, "_enableSecureBoot", {
                            get: $util.oneOfGetter($oneOfFields = ["enableSecureBoot"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ShieldedInstanceConfig _enableVtpm.
                         * @member {"enableVtpm"|undefined} _enableVtpm
                         * @memberof google.cloud.compute.v1.ShieldedInstanceConfig
                         * @instance
                         */
                        Object.defineProperty(ShieldedInstanceConfig.prototype, "_enableVtpm", {
                            get: $util.oneOfGetter($oneOfFields = ["enableVtpm"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ShieldedInstanceConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ShieldedInstanceConfig
                         * @static
                         * @param {google.cloud.compute.v1.IShieldedInstanceConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ShieldedInstanceConfig} ShieldedInstanceConfig instance
                         */
                        ShieldedInstanceConfig.create = function create(properties) {
                            return new ShieldedInstanceConfig(properties);
                        };
    
                        /**
                         * Encodes the specified ShieldedInstanceConfig message. Does not implicitly {@link google.cloud.compute.v1.ShieldedInstanceConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ShieldedInstanceConfig
                         * @static
                         * @param {google.cloud.compute.v1.IShieldedInstanceConfig} message ShieldedInstanceConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ShieldedInstanceConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.enableSecureBoot != null && Object.hasOwnProperty.call(message, "enableSecureBoot"))
                                writer.uint32(/* id 123568638, wireType 0 =*/988549104).bool(message.enableSecureBoot);
                            if (message.enableVtpm != null && Object.hasOwnProperty.call(message, "enableVtpm"))
                                writer.uint32(/* id 181858935, wireType 0 =*/1454871480).bool(message.enableVtpm);
                            if (message.enableIntegrityMonitoring != null && Object.hasOwnProperty.call(message, "enableIntegrityMonitoring"))
                                writer.uint32(/* id 409071030, wireType 0 =*/3272568240).bool(message.enableIntegrityMonitoring);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ShieldedInstanceConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ShieldedInstanceConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ShieldedInstanceConfig
                         * @static
                         * @param {google.cloud.compute.v1.IShieldedInstanceConfig} message ShieldedInstanceConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ShieldedInstanceConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ShieldedInstanceConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ShieldedInstanceConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ShieldedInstanceConfig} ShieldedInstanceConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ShieldedInstanceConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ShieldedInstanceConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 409071030: {
                                        message.enableIntegrityMonitoring = reader.bool();
                                        break;
                                    }
                                case 123568638: {
                                        message.enableSecureBoot = reader.bool();
                                        break;
                                    }
                                case 181858935: {
                                        message.enableVtpm = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ShieldedInstanceConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ShieldedInstanceConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ShieldedInstanceConfig} ShieldedInstanceConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ShieldedInstanceConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ShieldedInstanceConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ShieldedInstanceConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ShieldedInstanceConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.enableIntegrityMonitoring != null && message.hasOwnProperty("enableIntegrityMonitoring")) {
                                properties._enableIntegrityMonitoring = 1;
                                if (typeof message.enableIntegrityMonitoring !== "boolean")
                                    return "enableIntegrityMonitoring: boolean expected";
                            }
                            if (message.enableSecureBoot != null && message.hasOwnProperty("enableSecureBoot")) {
                                properties._enableSecureBoot = 1;
                                if (typeof message.enableSecureBoot !== "boolean")
                                    return "enableSecureBoot: boolean expected";
                            }
                            if (message.enableVtpm != null && message.hasOwnProperty("enableVtpm")) {
                                properties._enableVtpm = 1;
                                if (typeof message.enableVtpm !== "boolean")
                                    return "enableVtpm: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ShieldedInstanceConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ShieldedInstanceConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ShieldedInstanceConfig} ShieldedInstanceConfig
                         */
                        ShieldedInstanceConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ShieldedInstanceConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ShieldedInstanceConfig();
                            if (object.enableIntegrityMonitoring != null)
                                message.enableIntegrityMonitoring = Boolean(object.enableIntegrityMonitoring);
                            if (object.enableSecureBoot != null)
                                message.enableSecureBoot = Boolean(object.enableSecureBoot);
                            if (object.enableVtpm != null)
                                message.enableVtpm = Boolean(object.enableVtpm);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ShieldedInstanceConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ShieldedInstanceConfig
                         * @static
                         * @param {google.cloud.compute.v1.ShieldedInstanceConfig} message ShieldedInstanceConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ShieldedInstanceConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.enableSecureBoot != null && message.hasOwnProperty("enableSecureBoot")) {
                                object.enableSecureBoot = message.enableSecureBoot;
                                if (options.oneofs)
                                    object._enableSecureBoot = "enableSecureBoot";
                            }
                            if (message.enableVtpm != null && message.hasOwnProperty("enableVtpm")) {
                                object.enableVtpm = message.enableVtpm;
                                if (options.oneofs)
                                    object._enableVtpm = "enableVtpm";
                            }
                            if (message.enableIntegrityMonitoring != null && message.hasOwnProperty("enableIntegrityMonitoring")) {
                                object.enableIntegrityMonitoring = message.enableIntegrityMonitoring;
                                if (options.oneofs)
                                    object._enableIntegrityMonitoring = "enableIntegrityMonitoring";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ShieldedInstanceConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ShieldedInstanceConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ShieldedInstanceConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ShieldedInstanceConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ShieldedInstanceConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ShieldedInstanceConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ShieldedInstanceConfig";
                        };
    
                        return ShieldedInstanceConfig;
                    })();
    
                    v1.ShieldedInstanceIdentity = (function() {
    
                        /**
                         * Properties of a ShieldedInstanceIdentity.
                         * @memberof google.cloud.compute.v1
                         * @interface IShieldedInstanceIdentity
                         * @property {google.cloud.compute.v1.IShieldedInstanceIdentityEntry|null} [encryptionKey] ShieldedInstanceIdentity encryptionKey
                         * @property {string|null} [kind] ShieldedInstanceIdentity kind
                         * @property {google.cloud.compute.v1.IShieldedInstanceIdentityEntry|null} [signingKey] ShieldedInstanceIdentity signingKey
                         */
    
                        /**
                         * Constructs a new ShieldedInstanceIdentity.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ShieldedInstanceIdentity.
                         * @implements IShieldedInstanceIdentity
                         * @constructor
                         * @param {google.cloud.compute.v1.IShieldedInstanceIdentity=} [properties] Properties to set
                         */
                        function ShieldedInstanceIdentity(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ShieldedInstanceIdentity encryptionKey.
                         * @member {google.cloud.compute.v1.IShieldedInstanceIdentityEntry|null|undefined} encryptionKey
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentity
                         * @instance
                         */
                        ShieldedInstanceIdentity.prototype.encryptionKey = null;
    
                        /**
                         * ShieldedInstanceIdentity kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentity
                         * @instance
                         */
                        ShieldedInstanceIdentity.prototype.kind = null;
    
                        /**
                         * ShieldedInstanceIdentity signingKey.
                         * @member {google.cloud.compute.v1.IShieldedInstanceIdentityEntry|null|undefined} signingKey
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentity
                         * @instance
                         */
                        ShieldedInstanceIdentity.prototype.signingKey = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ShieldedInstanceIdentity _encryptionKey.
                         * @member {"encryptionKey"|undefined} _encryptionKey
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentity
                         * @instance
                         */
                        Object.defineProperty(ShieldedInstanceIdentity.prototype, "_encryptionKey", {
                            get: $util.oneOfGetter($oneOfFields = ["encryptionKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ShieldedInstanceIdentity _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentity
                         * @instance
                         */
                        Object.defineProperty(ShieldedInstanceIdentity.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ShieldedInstanceIdentity _signingKey.
                         * @member {"signingKey"|undefined} _signingKey
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentity
                         * @instance
                         */
                        Object.defineProperty(ShieldedInstanceIdentity.prototype, "_signingKey", {
                            get: $util.oneOfGetter($oneOfFields = ["signingKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ShieldedInstanceIdentity instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentity
                         * @static
                         * @param {google.cloud.compute.v1.IShieldedInstanceIdentity=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ShieldedInstanceIdentity} ShieldedInstanceIdentity instance
                         */
                        ShieldedInstanceIdentity.create = function create(properties) {
                            return new ShieldedInstanceIdentity(properties);
                        };
    
                        /**
                         * Encodes the specified ShieldedInstanceIdentity message. Does not implicitly {@link google.cloud.compute.v1.ShieldedInstanceIdentity.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentity
                         * @static
                         * @param {google.cloud.compute.v1.IShieldedInstanceIdentity} message ShieldedInstanceIdentity message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ShieldedInstanceIdentity.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.signingKey != null && Object.hasOwnProperty.call(message, "signingKey"))
                                $root.google.cloud.compute.v1.ShieldedInstanceIdentityEntry.encode(message.signingKey, writer.uint32(/* id 320948261, wireType 2 =*/2567586090).fork()).ldelim();
                            if (message.encryptionKey != null && Object.hasOwnProperty.call(message, "encryptionKey"))
                                $root.google.cloud.compute.v1.ShieldedInstanceIdentityEntry.encode(message.encryptionKey, writer.uint32(/* id 488268707, wireType 2 =*/3906149658).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ShieldedInstanceIdentity message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ShieldedInstanceIdentity.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentity
                         * @static
                         * @param {google.cloud.compute.v1.IShieldedInstanceIdentity} message ShieldedInstanceIdentity message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ShieldedInstanceIdentity.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ShieldedInstanceIdentity message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentity
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ShieldedInstanceIdentity} ShieldedInstanceIdentity
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ShieldedInstanceIdentity.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ShieldedInstanceIdentity();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 488268707: {
                                        message.encryptionKey = $root.google.cloud.compute.v1.ShieldedInstanceIdentityEntry.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 320948261: {
                                        message.signingKey = $root.google.cloud.compute.v1.ShieldedInstanceIdentityEntry.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ShieldedInstanceIdentity message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentity
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ShieldedInstanceIdentity} ShieldedInstanceIdentity
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ShieldedInstanceIdentity.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ShieldedInstanceIdentity message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentity
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ShieldedInstanceIdentity.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.encryptionKey != null && message.hasOwnProperty("encryptionKey")) {
                                properties._encryptionKey = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ShieldedInstanceIdentityEntry.verify(message.encryptionKey);
                                    if (error)
                                        return "encryptionKey." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.signingKey != null && message.hasOwnProperty("signingKey")) {
                                properties._signingKey = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.ShieldedInstanceIdentityEntry.verify(message.signingKey);
                                    if (error)
                                        return "signingKey." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ShieldedInstanceIdentity message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentity
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ShieldedInstanceIdentity} ShieldedInstanceIdentity
                         */
                        ShieldedInstanceIdentity.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ShieldedInstanceIdentity)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ShieldedInstanceIdentity();
                            if (object.encryptionKey != null) {
                                if (typeof object.encryptionKey !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ShieldedInstanceIdentity.encryptionKey: object expected");
                                message.encryptionKey = $root.google.cloud.compute.v1.ShieldedInstanceIdentityEntry.fromObject(object.encryptionKey);
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.signingKey != null) {
                                if (typeof object.signingKey !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ShieldedInstanceIdentity.signingKey: object expected");
                                message.signingKey = $root.google.cloud.compute.v1.ShieldedInstanceIdentityEntry.fromObject(object.signingKey);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ShieldedInstanceIdentity message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentity
                         * @static
                         * @param {google.cloud.compute.v1.ShieldedInstanceIdentity} message ShieldedInstanceIdentity
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ShieldedInstanceIdentity.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.signingKey != null && message.hasOwnProperty("signingKey")) {
                                object.signingKey = $root.google.cloud.compute.v1.ShieldedInstanceIdentityEntry.toObject(message.signingKey, options);
                                if (options.oneofs)
                                    object._signingKey = "signingKey";
                            }
                            if (message.encryptionKey != null && message.hasOwnProperty("encryptionKey")) {
                                object.encryptionKey = $root.google.cloud.compute.v1.ShieldedInstanceIdentityEntry.toObject(message.encryptionKey, options);
                                if (options.oneofs)
                                    object._encryptionKey = "encryptionKey";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ShieldedInstanceIdentity to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentity
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ShieldedInstanceIdentity.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ShieldedInstanceIdentity
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentity
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ShieldedInstanceIdentity.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ShieldedInstanceIdentity";
                        };
    
                        return ShieldedInstanceIdentity;
                    })();
    
                    v1.ShieldedInstanceIdentityEntry = (function() {
    
                        /**
                         * Properties of a ShieldedInstanceIdentityEntry.
                         * @memberof google.cloud.compute.v1
                         * @interface IShieldedInstanceIdentityEntry
                         * @property {string|null} [ekCert] ShieldedInstanceIdentityEntry ekCert
                         * @property {string|null} [ekPub] ShieldedInstanceIdentityEntry ekPub
                         */
    
                        /**
                         * Constructs a new ShieldedInstanceIdentityEntry.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ShieldedInstanceIdentityEntry.
                         * @implements IShieldedInstanceIdentityEntry
                         * @constructor
                         * @param {google.cloud.compute.v1.IShieldedInstanceIdentityEntry=} [properties] Properties to set
                         */
                        function ShieldedInstanceIdentityEntry(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ShieldedInstanceIdentityEntry ekCert.
                         * @member {string|null|undefined} ekCert
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentityEntry
                         * @instance
                         */
                        ShieldedInstanceIdentityEntry.prototype.ekCert = null;
    
                        /**
                         * ShieldedInstanceIdentityEntry ekPub.
                         * @member {string|null|undefined} ekPub
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentityEntry
                         * @instance
                         */
                        ShieldedInstanceIdentityEntry.prototype.ekPub = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ShieldedInstanceIdentityEntry _ekCert.
                         * @member {"ekCert"|undefined} _ekCert
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentityEntry
                         * @instance
                         */
                        Object.defineProperty(ShieldedInstanceIdentityEntry.prototype, "_ekCert", {
                            get: $util.oneOfGetter($oneOfFields = ["ekCert"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ShieldedInstanceIdentityEntry _ekPub.
                         * @member {"ekPub"|undefined} _ekPub
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentityEntry
                         * @instance
                         */
                        Object.defineProperty(ShieldedInstanceIdentityEntry.prototype, "_ekPub", {
                            get: $util.oneOfGetter($oneOfFields = ["ekPub"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ShieldedInstanceIdentityEntry instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentityEntry
                         * @static
                         * @param {google.cloud.compute.v1.IShieldedInstanceIdentityEntry=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ShieldedInstanceIdentityEntry} ShieldedInstanceIdentityEntry instance
                         */
                        ShieldedInstanceIdentityEntry.create = function create(properties) {
                            return new ShieldedInstanceIdentityEntry(properties);
                        };
    
                        /**
                         * Encodes the specified ShieldedInstanceIdentityEntry message. Does not implicitly {@link google.cloud.compute.v1.ShieldedInstanceIdentityEntry.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentityEntry
                         * @static
                         * @param {google.cloud.compute.v1.IShieldedInstanceIdentityEntry} message ShieldedInstanceIdentityEntry message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ShieldedInstanceIdentityEntry.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.ekPub != null && Object.hasOwnProperty.call(message, "ekPub"))
                                writer.uint32(/* id 308947940, wireType 2 =*/2471583522).string(message.ekPub);
                            if (message.ekCert != null && Object.hasOwnProperty.call(message, "ekCert"))
                                writer.uint32(/* id 450178589, wireType 2 =*/3601428714).string(message.ekCert);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ShieldedInstanceIdentityEntry message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ShieldedInstanceIdentityEntry.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentityEntry
                         * @static
                         * @param {google.cloud.compute.v1.IShieldedInstanceIdentityEntry} message ShieldedInstanceIdentityEntry message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ShieldedInstanceIdentityEntry.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ShieldedInstanceIdentityEntry message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentityEntry
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ShieldedInstanceIdentityEntry} ShieldedInstanceIdentityEntry
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ShieldedInstanceIdentityEntry.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ShieldedInstanceIdentityEntry();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 450178589: {
                                        message.ekCert = reader.string();
                                        break;
                                    }
                                case 308947940: {
                                        message.ekPub = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ShieldedInstanceIdentityEntry message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentityEntry
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ShieldedInstanceIdentityEntry} ShieldedInstanceIdentityEntry
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ShieldedInstanceIdentityEntry.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ShieldedInstanceIdentityEntry message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentityEntry
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ShieldedInstanceIdentityEntry.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.ekCert != null && message.hasOwnProperty("ekCert")) {
                                properties._ekCert = 1;
                                if (!$util.isString(message.ekCert))
                                    return "ekCert: string expected";
                            }
                            if (message.ekPub != null && message.hasOwnProperty("ekPub")) {
                                properties._ekPub = 1;
                                if (!$util.isString(message.ekPub))
                                    return "ekPub: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ShieldedInstanceIdentityEntry message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentityEntry
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ShieldedInstanceIdentityEntry} ShieldedInstanceIdentityEntry
                         */
                        ShieldedInstanceIdentityEntry.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ShieldedInstanceIdentityEntry)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ShieldedInstanceIdentityEntry();
                            if (object.ekCert != null)
                                message.ekCert = String(object.ekCert);
                            if (object.ekPub != null)
                                message.ekPub = String(object.ekPub);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ShieldedInstanceIdentityEntry message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentityEntry
                         * @static
                         * @param {google.cloud.compute.v1.ShieldedInstanceIdentityEntry} message ShieldedInstanceIdentityEntry
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ShieldedInstanceIdentityEntry.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.ekPub != null && message.hasOwnProperty("ekPub")) {
                                object.ekPub = message.ekPub;
                                if (options.oneofs)
                                    object._ekPub = "ekPub";
                            }
                            if (message.ekCert != null && message.hasOwnProperty("ekCert")) {
                                object.ekCert = message.ekCert;
                                if (options.oneofs)
                                    object._ekCert = "ekCert";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ShieldedInstanceIdentityEntry to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentityEntry
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ShieldedInstanceIdentityEntry.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ShieldedInstanceIdentityEntry
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIdentityEntry
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ShieldedInstanceIdentityEntry.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ShieldedInstanceIdentityEntry";
                        };
    
                        return ShieldedInstanceIdentityEntry;
                    })();
    
                    v1.ShieldedInstanceIntegrityPolicy = (function() {
    
                        /**
                         * Properties of a ShieldedInstanceIntegrityPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IShieldedInstanceIntegrityPolicy
                         * @property {boolean|null} [updateAutoLearnPolicy] ShieldedInstanceIntegrityPolicy updateAutoLearnPolicy
                         */
    
                        /**
                         * Constructs a new ShieldedInstanceIntegrityPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ShieldedInstanceIntegrityPolicy.
                         * @implements IShieldedInstanceIntegrityPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IShieldedInstanceIntegrityPolicy=} [properties] Properties to set
                         */
                        function ShieldedInstanceIntegrityPolicy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ShieldedInstanceIntegrityPolicy updateAutoLearnPolicy.
                         * @member {boolean|null|undefined} updateAutoLearnPolicy
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy
                         * @instance
                         */
                        ShieldedInstanceIntegrityPolicy.prototype.updateAutoLearnPolicy = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ShieldedInstanceIntegrityPolicy _updateAutoLearnPolicy.
                         * @member {"updateAutoLearnPolicy"|undefined} _updateAutoLearnPolicy
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy
                         * @instance
                         */
                        Object.defineProperty(ShieldedInstanceIntegrityPolicy.prototype, "_updateAutoLearnPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["updateAutoLearnPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ShieldedInstanceIntegrityPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IShieldedInstanceIntegrityPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy} ShieldedInstanceIntegrityPolicy instance
                         */
                        ShieldedInstanceIntegrityPolicy.create = function create(properties) {
                            return new ShieldedInstanceIntegrityPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified ShieldedInstanceIntegrityPolicy message. Does not implicitly {@link google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IShieldedInstanceIntegrityPolicy} message ShieldedInstanceIntegrityPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ShieldedInstanceIntegrityPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.updateAutoLearnPolicy != null && Object.hasOwnProperty.call(message, "updateAutoLearnPolicy"))
                                writer.uint32(/* id 245490215, wireType 0 =*/1963921720).bool(message.updateAutoLearnPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ShieldedInstanceIntegrityPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IShieldedInstanceIntegrityPolicy} message ShieldedInstanceIntegrityPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ShieldedInstanceIntegrityPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ShieldedInstanceIntegrityPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy} ShieldedInstanceIntegrityPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ShieldedInstanceIntegrityPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 245490215: {
                                        message.updateAutoLearnPolicy = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ShieldedInstanceIntegrityPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy} ShieldedInstanceIntegrityPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ShieldedInstanceIntegrityPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ShieldedInstanceIntegrityPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ShieldedInstanceIntegrityPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.updateAutoLearnPolicy != null && message.hasOwnProperty("updateAutoLearnPolicy")) {
                                properties._updateAutoLearnPolicy = 1;
                                if (typeof message.updateAutoLearnPolicy !== "boolean")
                                    return "updateAutoLearnPolicy: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ShieldedInstanceIntegrityPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy} ShieldedInstanceIntegrityPolicy
                         */
                        ShieldedInstanceIntegrityPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy();
                            if (object.updateAutoLearnPolicy != null)
                                message.updateAutoLearnPolicy = Boolean(object.updateAutoLearnPolicy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ShieldedInstanceIntegrityPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy
                         * @static
                         * @param {google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy} message ShieldedInstanceIntegrityPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ShieldedInstanceIntegrityPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.updateAutoLearnPolicy != null && message.hasOwnProperty("updateAutoLearnPolicy")) {
                                object.updateAutoLearnPolicy = message.updateAutoLearnPolicy;
                                if (options.oneofs)
                                    object._updateAutoLearnPolicy = "updateAutoLearnPolicy";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ShieldedInstanceIntegrityPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ShieldedInstanceIntegrityPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ShieldedInstanceIntegrityPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ShieldedInstanceIntegrityPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ShieldedInstanceIntegrityPolicy";
                        };
    
                        return ShieldedInstanceIntegrityPolicy;
                    })();
    
                    v1.SignedUrlKey = (function() {
    
                        /**
                         * Properties of a SignedUrlKey.
                         * @memberof google.cloud.compute.v1
                         * @interface ISignedUrlKey
                         * @property {string|null} [keyName] SignedUrlKey keyName
                         * @property {string|null} [keyValue] SignedUrlKey keyValue
                         */
    
                        /**
                         * Constructs a new SignedUrlKey.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SignedUrlKey.
                         * @implements ISignedUrlKey
                         * @constructor
                         * @param {google.cloud.compute.v1.ISignedUrlKey=} [properties] Properties to set
                         */
                        function SignedUrlKey(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SignedUrlKey keyName.
                         * @member {string|null|undefined} keyName
                         * @memberof google.cloud.compute.v1.SignedUrlKey
                         * @instance
                         */
                        SignedUrlKey.prototype.keyName = null;
    
                        /**
                         * SignedUrlKey keyValue.
                         * @member {string|null|undefined} keyValue
                         * @memberof google.cloud.compute.v1.SignedUrlKey
                         * @instance
                         */
                        SignedUrlKey.prototype.keyValue = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SignedUrlKey _keyName.
                         * @member {"keyName"|undefined} _keyName
                         * @memberof google.cloud.compute.v1.SignedUrlKey
                         * @instance
                         */
                        Object.defineProperty(SignedUrlKey.prototype, "_keyName", {
                            get: $util.oneOfGetter($oneOfFields = ["keyName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SignedUrlKey _keyValue.
                         * @member {"keyValue"|undefined} _keyValue
                         * @memberof google.cloud.compute.v1.SignedUrlKey
                         * @instance
                         */
                        Object.defineProperty(SignedUrlKey.prototype, "_keyValue", {
                            get: $util.oneOfGetter($oneOfFields = ["keyValue"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SignedUrlKey instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SignedUrlKey
                         * @static
                         * @param {google.cloud.compute.v1.ISignedUrlKey=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SignedUrlKey} SignedUrlKey instance
                         */
                        SignedUrlKey.create = function create(properties) {
                            return new SignedUrlKey(properties);
                        };
    
                        /**
                         * Encodes the specified SignedUrlKey message. Does not implicitly {@link google.cloud.compute.v1.SignedUrlKey.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SignedUrlKey
                         * @static
                         * @param {google.cloud.compute.v1.ISignedUrlKey} message SignedUrlKey message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SignedUrlKey.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.keyName != null && Object.hasOwnProperty.call(message, "keyName"))
                                writer.uint32(/* id 500938859, wireType 2 =*/4007510874).string(message.keyName);
                            if (message.keyValue != null && Object.hasOwnProperty.call(message, "keyValue"))
                                writer.uint32(/* id 504106897, wireType 2 =*/4032855178).string(message.keyValue);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SignedUrlKey message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SignedUrlKey.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SignedUrlKey
                         * @static
                         * @param {google.cloud.compute.v1.ISignedUrlKey} message SignedUrlKey message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SignedUrlKey.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SignedUrlKey message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SignedUrlKey
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SignedUrlKey} SignedUrlKey
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SignedUrlKey.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SignedUrlKey();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 500938859: {
                                        message.keyName = reader.string();
                                        break;
                                    }
                                case 504106897: {
                                        message.keyValue = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SignedUrlKey message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SignedUrlKey
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SignedUrlKey} SignedUrlKey
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SignedUrlKey.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SignedUrlKey message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SignedUrlKey
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SignedUrlKey.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.keyName != null && message.hasOwnProperty("keyName")) {
                                properties._keyName = 1;
                                if (!$util.isString(message.keyName))
                                    return "keyName: string expected";
                            }
                            if (message.keyValue != null && message.hasOwnProperty("keyValue")) {
                                properties._keyValue = 1;
                                if (!$util.isString(message.keyValue))
                                    return "keyValue: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SignedUrlKey message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SignedUrlKey
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SignedUrlKey} SignedUrlKey
                         */
                        SignedUrlKey.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SignedUrlKey)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SignedUrlKey();
                            if (object.keyName != null)
                                message.keyName = String(object.keyName);
                            if (object.keyValue != null)
                                message.keyValue = String(object.keyValue);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SignedUrlKey message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SignedUrlKey
                         * @static
                         * @param {google.cloud.compute.v1.SignedUrlKey} message SignedUrlKey
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SignedUrlKey.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.keyName != null && message.hasOwnProperty("keyName")) {
                                object.keyName = message.keyName;
                                if (options.oneofs)
                                    object._keyName = "keyName";
                            }
                            if (message.keyValue != null && message.hasOwnProperty("keyValue")) {
                                object.keyValue = message.keyValue;
                                if (options.oneofs)
                                    object._keyValue = "keyValue";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SignedUrlKey to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SignedUrlKey
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SignedUrlKey.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SignedUrlKey
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SignedUrlKey
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SignedUrlKey.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SignedUrlKey";
                        };
    
                        return SignedUrlKey;
                    })();
    
                    v1.SimulateMaintenanceEventInstanceRequest = (function() {
    
                        /**
                         * Properties of a SimulateMaintenanceEventInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISimulateMaintenanceEventInstanceRequest
                         * @property {string|null} [instance] SimulateMaintenanceEventInstanceRequest instance
                         * @property {string|null} [project] SimulateMaintenanceEventInstanceRequest project
                         * @property {string|null} [zone] SimulateMaintenanceEventInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new SimulateMaintenanceEventInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SimulateMaintenanceEventInstanceRequest.
                         * @implements ISimulateMaintenanceEventInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISimulateMaintenanceEventInstanceRequest=} [properties] Properties to set
                         */
                        function SimulateMaintenanceEventInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SimulateMaintenanceEventInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest
                         * @instance
                         */
                        SimulateMaintenanceEventInstanceRequest.prototype.instance = "";
    
                        /**
                         * SimulateMaintenanceEventInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest
                         * @instance
                         */
                        SimulateMaintenanceEventInstanceRequest.prototype.project = "";
    
                        /**
                         * SimulateMaintenanceEventInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest
                         * @instance
                         */
                        SimulateMaintenanceEventInstanceRequest.prototype.zone = "";
    
                        /**
                         * Creates a new SimulateMaintenanceEventInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISimulateMaintenanceEventInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest} SimulateMaintenanceEventInstanceRequest instance
                         */
                        SimulateMaintenanceEventInstanceRequest.create = function create(properties) {
                            return new SimulateMaintenanceEventInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SimulateMaintenanceEventInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISimulateMaintenanceEventInstanceRequest} message SimulateMaintenanceEventInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SimulateMaintenanceEventInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SimulateMaintenanceEventInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISimulateMaintenanceEventInstanceRequest} message SimulateMaintenanceEventInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SimulateMaintenanceEventInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SimulateMaintenanceEventInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest} SimulateMaintenanceEventInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SimulateMaintenanceEventInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SimulateMaintenanceEventInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest} SimulateMaintenanceEventInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SimulateMaintenanceEventInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SimulateMaintenanceEventInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SimulateMaintenanceEventInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SimulateMaintenanceEventInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest} SimulateMaintenanceEventInstanceRequest
                         */
                        SimulateMaintenanceEventInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SimulateMaintenanceEventInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest} message SimulateMaintenanceEventInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SimulateMaintenanceEventInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this SimulateMaintenanceEventInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SimulateMaintenanceEventInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SimulateMaintenanceEventInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SimulateMaintenanceEventInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest";
                        };
    
                        return SimulateMaintenanceEventInstanceRequest;
                    })();
    
                    v1.Snapshot = (function() {
    
                        /**
                         * Properties of a Snapshot.
                         * @memberof google.cloud.compute.v1
                         * @interface ISnapshot
                         * @property {string|null} [architecture] Snapshot architecture
                         * @property {boolean|null} [autoCreated] Snapshot autoCreated
                         * @property {string|null} [chainName] Snapshot chainName
                         * @property {number|Long|null} [creationSizeBytes] Snapshot creationSizeBytes
                         * @property {string|null} [creationTimestamp] Snapshot creationTimestamp
                         * @property {string|null} [description] Snapshot description
                         * @property {number|Long|null} [diskSizeGb] Snapshot diskSizeGb
                         * @property {number|Long|null} [downloadBytes] Snapshot downloadBytes
                         * @property {number|Long|null} [id] Snapshot id
                         * @property {string|null} [kind] Snapshot kind
                         * @property {string|null} [labelFingerprint] Snapshot labelFingerprint
                         * @property {Object.<string,string>|null} [labels] Snapshot labels
                         * @property {Array.<number|Long>|null} [licenseCodes] Snapshot licenseCodes
                         * @property {Array.<string>|null} [licenses] Snapshot licenses
                         * @property {string|null} [locationHint] Snapshot locationHint
                         * @property {string|null} [name] Snapshot name
                         * @property {boolean|null} [satisfiesPzs] Snapshot satisfiesPzs
                         * @property {string|null} [selfLink] Snapshot selfLink
                         * @property {google.cloud.compute.v1.ICustomerEncryptionKey|null} [snapshotEncryptionKey] Snapshot snapshotEncryptionKey
                         * @property {string|null} [snapshotType] Snapshot snapshotType
                         * @property {string|null} [sourceDisk] Snapshot sourceDisk
                         * @property {google.cloud.compute.v1.ICustomerEncryptionKey|null} [sourceDiskEncryptionKey] Snapshot sourceDiskEncryptionKey
                         * @property {string|null} [sourceDiskId] Snapshot sourceDiskId
                         * @property {string|null} [sourceSnapshotSchedulePolicy] Snapshot sourceSnapshotSchedulePolicy
                         * @property {string|null} [sourceSnapshotSchedulePolicyId] Snapshot sourceSnapshotSchedulePolicyId
                         * @property {string|null} [status] Snapshot status
                         * @property {number|Long|null} [storageBytes] Snapshot storageBytes
                         * @property {string|null} [storageBytesStatus] Snapshot storageBytesStatus
                         * @property {Array.<string>|null} [storageLocations] Snapshot storageLocations
                         */
    
                        /**
                         * Constructs a new Snapshot.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Snapshot.
                         * @implements ISnapshot
                         * @constructor
                         * @param {google.cloud.compute.v1.ISnapshot=} [properties] Properties to set
                         */
                        function Snapshot(properties) {
                            this.labels = {};
                            this.licenseCodes = [];
                            this.licenses = [];
                            this.storageLocations = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Snapshot architecture.
                         * @member {string|null|undefined} architecture
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.architecture = null;
    
                        /**
                         * Snapshot autoCreated.
                         * @member {boolean|null|undefined} autoCreated
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.autoCreated = null;
    
                        /**
                         * Snapshot chainName.
                         * @member {string|null|undefined} chainName
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.chainName = null;
    
                        /**
                         * Snapshot creationSizeBytes.
                         * @member {number|Long|null|undefined} creationSizeBytes
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.creationSizeBytes = null;
    
                        /**
                         * Snapshot creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.creationTimestamp = null;
    
                        /**
                         * Snapshot description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.description = null;
    
                        /**
                         * Snapshot diskSizeGb.
                         * @member {number|Long|null|undefined} diskSizeGb
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.diskSizeGb = null;
    
                        /**
                         * Snapshot downloadBytes.
                         * @member {number|Long|null|undefined} downloadBytes
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.downloadBytes = null;
    
                        /**
                         * Snapshot id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.id = null;
    
                        /**
                         * Snapshot kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.kind = null;
    
                        /**
                         * Snapshot labelFingerprint.
                         * @member {string|null|undefined} labelFingerprint
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.labelFingerprint = null;
    
                        /**
                         * Snapshot labels.
                         * @member {Object.<string,string>} labels
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.labels = $util.emptyObject;
    
                        /**
                         * Snapshot licenseCodes.
                         * @member {Array.<number|Long>} licenseCodes
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.licenseCodes = $util.emptyArray;
    
                        /**
                         * Snapshot licenses.
                         * @member {Array.<string>} licenses
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.licenses = $util.emptyArray;
    
                        /**
                         * Snapshot locationHint.
                         * @member {string|null|undefined} locationHint
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.locationHint = null;
    
                        /**
                         * Snapshot name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.name = null;
    
                        /**
                         * Snapshot satisfiesPzs.
                         * @member {boolean|null|undefined} satisfiesPzs
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.satisfiesPzs = null;
    
                        /**
                         * Snapshot selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.selfLink = null;
    
                        /**
                         * Snapshot snapshotEncryptionKey.
                         * @member {google.cloud.compute.v1.ICustomerEncryptionKey|null|undefined} snapshotEncryptionKey
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.snapshotEncryptionKey = null;
    
                        /**
                         * Snapshot snapshotType.
                         * @member {string|null|undefined} snapshotType
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.snapshotType = null;
    
                        /**
                         * Snapshot sourceDisk.
                         * @member {string|null|undefined} sourceDisk
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.sourceDisk = null;
    
                        /**
                         * Snapshot sourceDiskEncryptionKey.
                         * @member {google.cloud.compute.v1.ICustomerEncryptionKey|null|undefined} sourceDiskEncryptionKey
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.sourceDiskEncryptionKey = null;
    
                        /**
                         * Snapshot sourceDiskId.
                         * @member {string|null|undefined} sourceDiskId
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.sourceDiskId = null;
    
                        /**
                         * Snapshot sourceSnapshotSchedulePolicy.
                         * @member {string|null|undefined} sourceSnapshotSchedulePolicy
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.sourceSnapshotSchedulePolicy = null;
    
                        /**
                         * Snapshot sourceSnapshotSchedulePolicyId.
                         * @member {string|null|undefined} sourceSnapshotSchedulePolicyId
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.sourceSnapshotSchedulePolicyId = null;
    
                        /**
                         * Snapshot status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.status = null;
    
                        /**
                         * Snapshot storageBytes.
                         * @member {number|Long|null|undefined} storageBytes
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.storageBytes = null;
    
                        /**
                         * Snapshot storageBytesStatus.
                         * @member {string|null|undefined} storageBytesStatus
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.storageBytesStatus = null;
    
                        /**
                         * Snapshot storageLocations.
                         * @member {Array.<string>} storageLocations
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Snapshot.prototype.storageLocations = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Snapshot _architecture.
                         * @member {"architecture"|undefined} _architecture
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_architecture", {
                            get: $util.oneOfGetter($oneOfFields = ["architecture"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _autoCreated.
                         * @member {"autoCreated"|undefined} _autoCreated
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_autoCreated", {
                            get: $util.oneOfGetter($oneOfFields = ["autoCreated"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _chainName.
                         * @member {"chainName"|undefined} _chainName
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_chainName", {
                            get: $util.oneOfGetter($oneOfFields = ["chainName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _creationSizeBytes.
                         * @member {"creationSizeBytes"|undefined} _creationSizeBytes
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_creationSizeBytes", {
                            get: $util.oneOfGetter($oneOfFields = ["creationSizeBytes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _diskSizeGb.
                         * @member {"diskSizeGb"|undefined} _diskSizeGb
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_diskSizeGb", {
                            get: $util.oneOfGetter($oneOfFields = ["diskSizeGb"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _downloadBytes.
                         * @member {"downloadBytes"|undefined} _downloadBytes
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_downloadBytes", {
                            get: $util.oneOfGetter($oneOfFields = ["downloadBytes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _labelFingerprint.
                         * @member {"labelFingerprint"|undefined} _labelFingerprint
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_labelFingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["labelFingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _locationHint.
                         * @member {"locationHint"|undefined} _locationHint
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_locationHint", {
                            get: $util.oneOfGetter($oneOfFields = ["locationHint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _satisfiesPzs.
                         * @member {"satisfiesPzs"|undefined} _satisfiesPzs
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_satisfiesPzs", {
                            get: $util.oneOfGetter($oneOfFields = ["satisfiesPzs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _snapshotEncryptionKey.
                         * @member {"snapshotEncryptionKey"|undefined} _snapshotEncryptionKey
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_snapshotEncryptionKey", {
                            get: $util.oneOfGetter($oneOfFields = ["snapshotEncryptionKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _snapshotType.
                         * @member {"snapshotType"|undefined} _snapshotType
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_snapshotType", {
                            get: $util.oneOfGetter($oneOfFields = ["snapshotType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _sourceDisk.
                         * @member {"sourceDisk"|undefined} _sourceDisk
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_sourceDisk", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceDisk"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _sourceDiskEncryptionKey.
                         * @member {"sourceDiskEncryptionKey"|undefined} _sourceDiskEncryptionKey
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_sourceDiskEncryptionKey", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceDiskEncryptionKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _sourceDiskId.
                         * @member {"sourceDiskId"|undefined} _sourceDiskId
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_sourceDiskId", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceDiskId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _sourceSnapshotSchedulePolicy.
                         * @member {"sourceSnapshotSchedulePolicy"|undefined} _sourceSnapshotSchedulePolicy
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_sourceSnapshotSchedulePolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceSnapshotSchedulePolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _sourceSnapshotSchedulePolicyId.
                         * @member {"sourceSnapshotSchedulePolicyId"|undefined} _sourceSnapshotSchedulePolicyId
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_sourceSnapshotSchedulePolicyId", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceSnapshotSchedulePolicyId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _storageBytes.
                         * @member {"storageBytes"|undefined} _storageBytes
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_storageBytes", {
                            get: $util.oneOfGetter($oneOfFields = ["storageBytes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Snapshot _storageBytesStatus.
                         * @member {"storageBytesStatus"|undefined} _storageBytesStatus
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         */
                        Object.defineProperty(Snapshot.prototype, "_storageBytesStatus", {
                            get: $util.oneOfGetter($oneOfFields = ["storageBytesStatus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Snapshot instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @static
                         * @param {google.cloud.compute.v1.ISnapshot=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Snapshot} Snapshot instance
                         */
                        Snapshot.create = function create(properties) {
                            return new Snapshot(properties);
                        };
    
                        /**
                         * Encodes the specified Snapshot message. Does not implicitly {@link google.cloud.compute.v1.Snapshot.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @static
                         * @param {google.cloud.compute.v1.ISnapshot} message Snapshot message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Snapshot.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.snapshotEncryptionKey != null && Object.hasOwnProperty.call(message, "snapshotEncryptionKey"))
                                $root.google.cloud.compute.v1.CustomerEncryptionKey.encode(message.snapshotEncryptionKey, writer.uint32(/* id 43334526, wireType 2 =*/346676210).fork()).ldelim();
                            if (message.licenseCodes != null && message.licenseCodes.length) {
                                writer.uint32(/* id 45482664, wireType 2 =*/363861314).fork();
                                for (var i = 0; i < message.licenseCodes.length; ++i)
                                    writer.int64(message.licenseCodes[i]);
                                writer.ldelim();
                            }
                            if (message.chainName != null && Object.hasOwnProperty.call(message, "chainName"))
                                writer.uint32(/* id 68644169, wireType 2 =*/549153354).string(message.chainName);
                            if (message.sourceSnapshotSchedulePolicyId != null && Object.hasOwnProperty.call(message, "sourceSnapshotSchedulePolicyId"))
                                writer.uint32(/* id 70489047, wireType 2 =*/563912378).string(message.sourceSnapshotSchedulePolicyId);
                            if (message.snapshotType != null && Object.hasOwnProperty.call(message, "snapshotType"))
                                writer.uint32(/* id 124349653, wireType 2 =*/994797226).string(message.snapshotType);
                            if (message.creationSizeBytes != null && Object.hasOwnProperty.call(message, "creationSizeBytes"))
                                writer.uint32(/* id 125400077, wireType 0 =*/1003200616).int64(message.creationSizeBytes);
                            if (message.labelFingerprint != null && Object.hasOwnProperty.call(message, "labelFingerprint"))
                                writer.uint32(/* id 178124825, wireType 2 =*/1424998602).string(message.labelFingerprint);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.sourceSnapshotSchedulePolicy != null && Object.hasOwnProperty.call(message, "sourceSnapshotSchedulePolicy"))
                                writer.uint32(/* id 235756291, wireType 2 =*/1886050330).string(message.sourceSnapshotSchedulePolicy);
                            if (message.architecture != null && Object.hasOwnProperty.call(message, "architecture"))
                                writer.uint32(/* id 302803283, wireType 2 =*/2422426266).string(message.architecture);
                            if (message.diskSizeGb != null && Object.hasOwnProperty.call(message, "diskSizeGb"))
                                writer.uint32(/* id 316263735, wireType 0 =*/2530109880).int64(message.diskSizeGb);
                            if (message.storageLocations != null && message.storageLocations.length)
                                for (var i = 0; i < message.storageLocations.length; ++i)
                                    writer.uint32(/* id 328005274, wireType 2 =*/2624042194).string(message.storageLocations[i]);
                            if (message.licenses != null && message.licenses.length)
                                for (var i = 0; i < message.licenses.length; ++i)
                                    writer.uint32(/* id 337642578, wireType 2 =*/2701140626).string(message.licenses[i]);
                            if (message.locationHint != null && Object.hasOwnProperty.call(message, "locationHint"))
                                writer.uint32(/* id 350519505, wireType 2 =*/2804156042).string(message.locationHint);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.storageBytes != null && Object.hasOwnProperty.call(message, "storageBytes"))
                                writer.uint32(/* id 424631719, wireType 0 =*/3397053752).int64(message.storageBytes);
                            if (message.downloadBytes != null && Object.hasOwnProperty.call(message, "downloadBytes"))
                                writer.uint32(/* id 435054068, wireType 0 =*/3480432544).int64(message.downloadBytes);
                            if (message.sourceDisk != null && Object.hasOwnProperty.call(message, "sourceDisk"))
                                writer.uint32(/* id 451753793, wireType 2 =*/3614030346).string(message.sourceDisk);
                            if (message.sourceDiskId != null && Object.hasOwnProperty.call(message, "sourceDiskId"))
                                writer.uint32(/* id 454190809, wireType 2 =*/3633526474).string(message.sourceDiskId);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.autoCreated != null && Object.hasOwnProperty.call(message, "autoCreated"))
                                writer.uint32(/* id 463922264, wireType 0 =*/3711378112).bool(message.autoCreated);
                            if (message.satisfiesPzs != null && Object.hasOwnProperty.call(message, "satisfiesPzs"))
                                writer.uint32(/* id 480964267, wireType 0 =*/3847714136).bool(message.satisfiesPzs);
                            if (message.storageBytesStatus != null && Object.hasOwnProperty.call(message, "storageBytesStatus"))
                                writer.uint32(/* id 490739082, wireType 2 =*/3925912658).string(message.storageBytesStatus);
                            if (message.labels != null && Object.hasOwnProperty.call(message, "labels"))
                                for (var keys = Object.keys(message.labels), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 500195327, wireType 2 =*/4001562618).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.labels[keys[i]]).ldelim();
                            if (message.sourceDiskEncryptionKey != null && Object.hasOwnProperty.call(message, "sourceDiskEncryptionKey"))
                                $root.google.cloud.compute.v1.CustomerEncryptionKey.encode(message.sourceDiskEncryptionKey, writer.uint32(/* id 531501153, wireType 2 =*/4252009226).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Snapshot message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Snapshot.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @static
                         * @param {google.cloud.compute.v1.ISnapshot} message Snapshot message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Snapshot.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Snapshot message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Snapshot} Snapshot
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Snapshot.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Snapshot(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 302803283: {
                                        message.architecture = reader.string();
                                        break;
                                    }
                                case 463922264: {
                                        message.autoCreated = reader.bool();
                                        break;
                                    }
                                case 68644169: {
                                        message.chainName = reader.string();
                                        break;
                                    }
                                case 125400077: {
                                        message.creationSizeBytes = reader.int64();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 316263735: {
                                        message.diskSizeGb = reader.int64();
                                        break;
                                    }
                                case 435054068: {
                                        message.downloadBytes = reader.int64();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 178124825: {
                                        message.labelFingerprint = reader.string();
                                        break;
                                    }
                                case 500195327: {
                                        if (message.labels === $util.emptyObject)
                                            message.labels = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.labels[key] = value;
                                        break;
                                    }
                                case 45482664: {
                                        if (!(message.licenseCodes && message.licenseCodes.length))
                                            message.licenseCodes = [];
                                        if ((tag & 7) === 2) {
                                            var end2 = reader.uint32() + reader.pos;
                                            while (reader.pos < end2)
                                                message.licenseCodes.push(reader.int64());
                                        } else
                                            message.licenseCodes.push(reader.int64());
                                        break;
                                    }
                                case 337642578: {
                                        if (!(message.licenses && message.licenses.length))
                                            message.licenses = [];
                                        message.licenses.push(reader.string());
                                        break;
                                    }
                                case 350519505: {
                                        message.locationHint = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 480964267: {
                                        message.satisfiesPzs = reader.bool();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 43334526: {
                                        message.snapshotEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 124349653: {
                                        message.snapshotType = reader.string();
                                        break;
                                    }
                                case 451753793: {
                                        message.sourceDisk = reader.string();
                                        break;
                                    }
                                case 531501153: {
                                        message.sourceDiskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 454190809: {
                                        message.sourceDiskId = reader.string();
                                        break;
                                    }
                                case 235756291: {
                                        message.sourceSnapshotSchedulePolicy = reader.string();
                                        break;
                                    }
                                case 70489047: {
                                        message.sourceSnapshotSchedulePolicyId = reader.string();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                case 424631719: {
                                        message.storageBytes = reader.int64();
                                        break;
                                    }
                                case 490739082: {
                                        message.storageBytesStatus = reader.string();
                                        break;
                                    }
                                case 328005274: {
                                        if (!(message.storageLocations && message.storageLocations.length))
                                            message.storageLocations = [];
                                        message.storageLocations.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Snapshot message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Snapshot} Snapshot
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Snapshot.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Snapshot message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Snapshot.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.architecture != null && message.hasOwnProperty("architecture")) {
                                properties._architecture = 1;
                                if (!$util.isString(message.architecture))
                                    return "architecture: string expected";
                            }
                            if (message.autoCreated != null && message.hasOwnProperty("autoCreated")) {
                                properties._autoCreated = 1;
                                if (typeof message.autoCreated !== "boolean")
                                    return "autoCreated: boolean expected";
                            }
                            if (message.chainName != null && message.hasOwnProperty("chainName")) {
                                properties._chainName = 1;
                                if (!$util.isString(message.chainName))
                                    return "chainName: string expected";
                            }
                            if (message.creationSizeBytes != null && message.hasOwnProperty("creationSizeBytes")) {
                                properties._creationSizeBytes = 1;
                                if (!$util.isInteger(message.creationSizeBytes) && !(message.creationSizeBytes && $util.isInteger(message.creationSizeBytes.low) && $util.isInteger(message.creationSizeBytes.high)))
                                    return "creationSizeBytes: integer|Long expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.diskSizeGb != null && message.hasOwnProperty("diskSizeGb")) {
                                properties._diskSizeGb = 1;
                                if (!$util.isInteger(message.diskSizeGb) && !(message.diskSizeGb && $util.isInteger(message.diskSizeGb.low) && $util.isInteger(message.diskSizeGb.high)))
                                    return "diskSizeGb: integer|Long expected";
                            }
                            if (message.downloadBytes != null && message.hasOwnProperty("downloadBytes")) {
                                properties._downloadBytes = 1;
                                if (!$util.isInteger(message.downloadBytes) && !(message.downloadBytes && $util.isInteger(message.downloadBytes.low) && $util.isInteger(message.downloadBytes.high)))
                                    return "downloadBytes: integer|Long expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                properties._labelFingerprint = 1;
                                if (!$util.isString(message.labelFingerprint))
                                    return "labelFingerprint: string expected";
                            }
                            if (message.labels != null && message.hasOwnProperty("labels")) {
                                if (!$util.isObject(message.labels))
                                    return "labels: object expected";
                                var key = Object.keys(message.labels);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.labels[key[i]]))
                                        return "labels: string{k:string} expected";
                            }
                            if (message.licenseCodes != null && message.hasOwnProperty("licenseCodes")) {
                                if (!Array.isArray(message.licenseCodes))
                                    return "licenseCodes: array expected";
                                for (var i = 0; i < message.licenseCodes.length; ++i)
                                    if (!$util.isInteger(message.licenseCodes[i]) && !(message.licenseCodes[i] && $util.isInteger(message.licenseCodes[i].low) && $util.isInteger(message.licenseCodes[i].high)))
                                        return "licenseCodes: integer|Long[] expected";
                            }
                            if (message.licenses != null && message.hasOwnProperty("licenses")) {
                                if (!Array.isArray(message.licenses))
                                    return "licenses: array expected";
                                for (var i = 0; i < message.licenses.length; ++i)
                                    if (!$util.isString(message.licenses[i]))
                                        return "licenses: string[] expected";
                            }
                            if (message.locationHint != null && message.hasOwnProperty("locationHint")) {
                                properties._locationHint = 1;
                                if (!$util.isString(message.locationHint))
                                    return "locationHint: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.satisfiesPzs != null && message.hasOwnProperty("satisfiesPzs")) {
                                properties._satisfiesPzs = 1;
                                if (typeof message.satisfiesPzs !== "boolean")
                                    return "satisfiesPzs: boolean expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.snapshotEncryptionKey != null && message.hasOwnProperty("snapshotEncryptionKey")) {
                                properties._snapshotEncryptionKey = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.CustomerEncryptionKey.verify(message.snapshotEncryptionKey);
                                    if (error)
                                        return "snapshotEncryptionKey." + error;
                                }
                            }
                            if (message.snapshotType != null && message.hasOwnProperty("snapshotType")) {
                                properties._snapshotType = 1;
                                if (!$util.isString(message.snapshotType))
                                    return "snapshotType: string expected";
                            }
                            if (message.sourceDisk != null && message.hasOwnProperty("sourceDisk")) {
                                properties._sourceDisk = 1;
                                if (!$util.isString(message.sourceDisk))
                                    return "sourceDisk: string expected";
                            }
                            if (message.sourceDiskEncryptionKey != null && message.hasOwnProperty("sourceDiskEncryptionKey")) {
                                properties._sourceDiskEncryptionKey = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.CustomerEncryptionKey.verify(message.sourceDiskEncryptionKey);
                                    if (error)
                                        return "sourceDiskEncryptionKey." + error;
                                }
                            }
                            if (message.sourceDiskId != null && message.hasOwnProperty("sourceDiskId")) {
                                properties._sourceDiskId = 1;
                                if (!$util.isString(message.sourceDiskId))
                                    return "sourceDiskId: string expected";
                            }
                            if (message.sourceSnapshotSchedulePolicy != null && message.hasOwnProperty("sourceSnapshotSchedulePolicy")) {
                                properties._sourceSnapshotSchedulePolicy = 1;
                                if (!$util.isString(message.sourceSnapshotSchedulePolicy))
                                    return "sourceSnapshotSchedulePolicy: string expected";
                            }
                            if (message.sourceSnapshotSchedulePolicyId != null && message.hasOwnProperty("sourceSnapshotSchedulePolicyId")) {
                                properties._sourceSnapshotSchedulePolicyId = 1;
                                if (!$util.isString(message.sourceSnapshotSchedulePolicyId))
                                    return "sourceSnapshotSchedulePolicyId: string expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            if (message.storageBytes != null && message.hasOwnProperty("storageBytes")) {
                                properties._storageBytes = 1;
                                if (!$util.isInteger(message.storageBytes) && !(message.storageBytes && $util.isInteger(message.storageBytes.low) && $util.isInteger(message.storageBytes.high)))
                                    return "storageBytes: integer|Long expected";
                            }
                            if (message.storageBytesStatus != null && message.hasOwnProperty("storageBytesStatus")) {
                                properties._storageBytesStatus = 1;
                                if (!$util.isString(message.storageBytesStatus))
                                    return "storageBytesStatus: string expected";
                            }
                            if (message.storageLocations != null && message.hasOwnProperty("storageLocations")) {
                                if (!Array.isArray(message.storageLocations))
                                    return "storageLocations: array expected";
                                for (var i = 0; i < message.storageLocations.length; ++i)
                                    if (!$util.isString(message.storageLocations[i]))
                                        return "storageLocations: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Snapshot message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Snapshot} Snapshot
                         */
                        Snapshot.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Snapshot)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Snapshot();
                            if (object.architecture != null)
                                message.architecture = String(object.architecture);
                            if (object.autoCreated != null)
                                message.autoCreated = Boolean(object.autoCreated);
                            if (object.chainName != null)
                                message.chainName = String(object.chainName);
                            if (object.creationSizeBytes != null)
                                if ($util.Long)
                                    (message.creationSizeBytes = $util.Long.fromValue(object.creationSizeBytes)).unsigned = false;
                                else if (typeof object.creationSizeBytes === "string")
                                    message.creationSizeBytes = parseInt(object.creationSizeBytes, 10);
                                else if (typeof object.creationSizeBytes === "number")
                                    message.creationSizeBytes = object.creationSizeBytes;
                                else if (typeof object.creationSizeBytes === "object")
                                    message.creationSizeBytes = new $util.LongBits(object.creationSizeBytes.low >>> 0, object.creationSizeBytes.high >>> 0).toNumber();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.diskSizeGb != null)
                                if ($util.Long)
                                    (message.diskSizeGb = $util.Long.fromValue(object.diskSizeGb)).unsigned = false;
                                else if (typeof object.diskSizeGb === "string")
                                    message.diskSizeGb = parseInt(object.diskSizeGb, 10);
                                else if (typeof object.diskSizeGb === "number")
                                    message.diskSizeGb = object.diskSizeGb;
                                else if (typeof object.diskSizeGb === "object")
                                    message.diskSizeGb = new $util.LongBits(object.diskSizeGb.low >>> 0, object.diskSizeGb.high >>> 0).toNumber();
                            if (object.downloadBytes != null)
                                if ($util.Long)
                                    (message.downloadBytes = $util.Long.fromValue(object.downloadBytes)).unsigned = false;
                                else if (typeof object.downloadBytes === "string")
                                    message.downloadBytes = parseInt(object.downloadBytes, 10);
                                else if (typeof object.downloadBytes === "number")
                                    message.downloadBytes = object.downloadBytes;
                                else if (typeof object.downloadBytes === "object")
                                    message.downloadBytes = new $util.LongBits(object.downloadBytes.low >>> 0, object.downloadBytes.high >>> 0).toNumber();
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.labelFingerprint != null)
                                message.labelFingerprint = String(object.labelFingerprint);
                            if (object.labels) {
                                if (typeof object.labels !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Snapshot.labels: object expected");
                                message.labels = {};
                                for (var keys = Object.keys(object.labels), i = 0; i < keys.length; ++i)
                                    message.labels[keys[i]] = String(object.labels[keys[i]]);
                            }
                            if (object.licenseCodes) {
                                if (!Array.isArray(object.licenseCodes))
                                    throw TypeError(".google.cloud.compute.v1.Snapshot.licenseCodes: array expected");
                                message.licenseCodes = [];
                                for (var i = 0; i < object.licenseCodes.length; ++i)
                                    if ($util.Long)
                                        (message.licenseCodes[i] = $util.Long.fromValue(object.licenseCodes[i])).unsigned = false;
                                    else if (typeof object.licenseCodes[i] === "string")
                                        message.licenseCodes[i] = parseInt(object.licenseCodes[i], 10);
                                    else if (typeof object.licenseCodes[i] === "number")
                                        message.licenseCodes[i] = object.licenseCodes[i];
                                    else if (typeof object.licenseCodes[i] === "object")
                                        message.licenseCodes[i] = new $util.LongBits(object.licenseCodes[i].low >>> 0, object.licenseCodes[i].high >>> 0).toNumber();
                            }
                            if (object.licenses) {
                                if (!Array.isArray(object.licenses))
                                    throw TypeError(".google.cloud.compute.v1.Snapshot.licenses: array expected");
                                message.licenses = [];
                                for (var i = 0; i < object.licenses.length; ++i)
                                    message.licenses[i] = String(object.licenses[i]);
                            }
                            if (object.locationHint != null)
                                message.locationHint = String(object.locationHint);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.satisfiesPzs != null)
                                message.satisfiesPzs = Boolean(object.satisfiesPzs);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.snapshotEncryptionKey != null) {
                                if (typeof object.snapshotEncryptionKey !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Snapshot.snapshotEncryptionKey: object expected");
                                message.snapshotEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.fromObject(object.snapshotEncryptionKey);
                            }
                            if (object.snapshotType != null)
                                message.snapshotType = String(object.snapshotType);
                            if (object.sourceDisk != null)
                                message.sourceDisk = String(object.sourceDisk);
                            if (object.sourceDiskEncryptionKey != null) {
                                if (typeof object.sourceDiskEncryptionKey !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Snapshot.sourceDiskEncryptionKey: object expected");
                                message.sourceDiskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.fromObject(object.sourceDiskEncryptionKey);
                            }
                            if (object.sourceDiskId != null)
                                message.sourceDiskId = String(object.sourceDiskId);
                            if (object.sourceSnapshotSchedulePolicy != null)
                                message.sourceSnapshotSchedulePolicy = String(object.sourceSnapshotSchedulePolicy);
                            if (object.sourceSnapshotSchedulePolicyId != null)
                                message.sourceSnapshotSchedulePolicyId = String(object.sourceSnapshotSchedulePolicyId);
                            if (object.status != null)
                                message.status = String(object.status);
                            if (object.storageBytes != null)
                                if ($util.Long)
                                    (message.storageBytes = $util.Long.fromValue(object.storageBytes)).unsigned = false;
                                else if (typeof object.storageBytes === "string")
                                    message.storageBytes = parseInt(object.storageBytes, 10);
                                else if (typeof object.storageBytes === "number")
                                    message.storageBytes = object.storageBytes;
                                else if (typeof object.storageBytes === "object")
                                    message.storageBytes = new $util.LongBits(object.storageBytes.low >>> 0, object.storageBytes.high >>> 0).toNumber();
                            if (object.storageBytesStatus != null)
                                message.storageBytesStatus = String(object.storageBytesStatus);
                            if (object.storageLocations) {
                                if (!Array.isArray(object.storageLocations))
                                    throw TypeError(".google.cloud.compute.v1.Snapshot.storageLocations: array expected");
                                message.storageLocations = [];
                                for (var i = 0; i < object.storageLocations.length; ++i)
                                    message.storageLocations[i] = String(object.storageLocations[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Snapshot message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @static
                         * @param {google.cloud.compute.v1.Snapshot} message Snapshot
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Snapshot.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.licenseCodes = [];
                                object.storageLocations = [];
                                object.licenses = [];
                            }
                            if (options.objects || options.defaults)
                                object.labels = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.snapshotEncryptionKey != null && message.hasOwnProperty("snapshotEncryptionKey")) {
                                object.snapshotEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.toObject(message.snapshotEncryptionKey, options);
                                if (options.oneofs)
                                    object._snapshotEncryptionKey = "snapshotEncryptionKey";
                            }
                            if (message.licenseCodes && message.licenseCodes.length) {
                                object.licenseCodes = [];
                                for (var j = 0; j < message.licenseCodes.length; ++j)
                                    if (typeof message.licenseCodes[j] === "number")
                                        object.licenseCodes[j] = options.longs === String ? String(message.licenseCodes[j]) : message.licenseCodes[j];
                                    else
                                        object.licenseCodes[j] = options.longs === String ? $util.Long.prototype.toString.call(message.licenseCodes[j]) : options.longs === Number ? new $util.LongBits(message.licenseCodes[j].low >>> 0, message.licenseCodes[j].high >>> 0).toNumber() : message.licenseCodes[j];
                            }
                            if (message.chainName != null && message.hasOwnProperty("chainName")) {
                                object.chainName = message.chainName;
                                if (options.oneofs)
                                    object._chainName = "chainName";
                            }
                            if (message.sourceSnapshotSchedulePolicyId != null && message.hasOwnProperty("sourceSnapshotSchedulePolicyId")) {
                                object.sourceSnapshotSchedulePolicyId = message.sourceSnapshotSchedulePolicyId;
                                if (options.oneofs)
                                    object._sourceSnapshotSchedulePolicyId = "sourceSnapshotSchedulePolicyId";
                            }
                            if (message.snapshotType != null && message.hasOwnProperty("snapshotType")) {
                                object.snapshotType = message.snapshotType;
                                if (options.oneofs)
                                    object._snapshotType = "snapshotType";
                            }
                            if (message.creationSizeBytes != null && message.hasOwnProperty("creationSizeBytes")) {
                                if (typeof message.creationSizeBytes === "number")
                                    object.creationSizeBytes = options.longs === String ? String(message.creationSizeBytes) : message.creationSizeBytes;
                                else
                                    object.creationSizeBytes = options.longs === String ? $util.Long.prototype.toString.call(message.creationSizeBytes) : options.longs === Number ? new $util.LongBits(message.creationSizeBytes.low >>> 0, message.creationSizeBytes.high >>> 0).toNumber() : message.creationSizeBytes;
                                if (options.oneofs)
                                    object._creationSizeBytes = "creationSizeBytes";
                            }
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                object.labelFingerprint = message.labelFingerprint;
                                if (options.oneofs)
                                    object._labelFingerprint = "labelFingerprint";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.sourceSnapshotSchedulePolicy != null && message.hasOwnProperty("sourceSnapshotSchedulePolicy")) {
                                object.sourceSnapshotSchedulePolicy = message.sourceSnapshotSchedulePolicy;
                                if (options.oneofs)
                                    object._sourceSnapshotSchedulePolicy = "sourceSnapshotSchedulePolicy";
                            }
                            if (message.architecture != null && message.hasOwnProperty("architecture")) {
                                object.architecture = message.architecture;
                                if (options.oneofs)
                                    object._architecture = "architecture";
                            }
                            if (message.diskSizeGb != null && message.hasOwnProperty("diskSizeGb")) {
                                if (typeof message.diskSizeGb === "number")
                                    object.diskSizeGb = options.longs === String ? String(message.diskSizeGb) : message.diskSizeGb;
                                else
                                    object.diskSizeGb = options.longs === String ? $util.Long.prototype.toString.call(message.diskSizeGb) : options.longs === Number ? new $util.LongBits(message.diskSizeGb.low >>> 0, message.diskSizeGb.high >>> 0).toNumber() : message.diskSizeGb;
                                if (options.oneofs)
                                    object._diskSizeGb = "diskSizeGb";
                            }
                            if (message.storageLocations && message.storageLocations.length) {
                                object.storageLocations = [];
                                for (var j = 0; j < message.storageLocations.length; ++j)
                                    object.storageLocations[j] = message.storageLocations[j];
                            }
                            if (message.licenses && message.licenses.length) {
                                object.licenses = [];
                                for (var j = 0; j < message.licenses.length; ++j)
                                    object.licenses[j] = message.licenses[j];
                            }
                            if (message.locationHint != null && message.hasOwnProperty("locationHint")) {
                                object.locationHint = message.locationHint;
                                if (options.oneofs)
                                    object._locationHint = "locationHint";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.storageBytes != null && message.hasOwnProperty("storageBytes")) {
                                if (typeof message.storageBytes === "number")
                                    object.storageBytes = options.longs === String ? String(message.storageBytes) : message.storageBytes;
                                else
                                    object.storageBytes = options.longs === String ? $util.Long.prototype.toString.call(message.storageBytes) : options.longs === Number ? new $util.LongBits(message.storageBytes.low >>> 0, message.storageBytes.high >>> 0).toNumber() : message.storageBytes;
                                if (options.oneofs)
                                    object._storageBytes = "storageBytes";
                            }
                            if (message.downloadBytes != null && message.hasOwnProperty("downloadBytes")) {
                                if (typeof message.downloadBytes === "number")
                                    object.downloadBytes = options.longs === String ? String(message.downloadBytes) : message.downloadBytes;
                                else
                                    object.downloadBytes = options.longs === String ? $util.Long.prototype.toString.call(message.downloadBytes) : options.longs === Number ? new $util.LongBits(message.downloadBytes.low >>> 0, message.downloadBytes.high >>> 0).toNumber() : message.downloadBytes;
                                if (options.oneofs)
                                    object._downloadBytes = "downloadBytes";
                            }
                            if (message.sourceDisk != null && message.hasOwnProperty("sourceDisk")) {
                                object.sourceDisk = message.sourceDisk;
                                if (options.oneofs)
                                    object._sourceDisk = "sourceDisk";
                            }
                            if (message.sourceDiskId != null && message.hasOwnProperty("sourceDiskId")) {
                                object.sourceDiskId = message.sourceDiskId;
                                if (options.oneofs)
                                    object._sourceDiskId = "sourceDiskId";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.autoCreated != null && message.hasOwnProperty("autoCreated")) {
                                object.autoCreated = message.autoCreated;
                                if (options.oneofs)
                                    object._autoCreated = "autoCreated";
                            }
                            if (message.satisfiesPzs != null && message.hasOwnProperty("satisfiesPzs")) {
                                object.satisfiesPzs = message.satisfiesPzs;
                                if (options.oneofs)
                                    object._satisfiesPzs = "satisfiesPzs";
                            }
                            if (message.storageBytesStatus != null && message.hasOwnProperty("storageBytesStatus")) {
                                object.storageBytesStatus = message.storageBytesStatus;
                                if (options.oneofs)
                                    object._storageBytesStatus = "storageBytesStatus";
                            }
                            var keys2;
                            if (message.labels && (keys2 = Object.keys(message.labels)).length) {
                                object.labels = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.labels[keys2[j]] = message.labels[keys2[j]];
                            }
                            if (message.sourceDiskEncryptionKey != null && message.hasOwnProperty("sourceDiskEncryptionKey")) {
                                object.sourceDiskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.toObject(message.sourceDiskEncryptionKey, options);
                                if (options.oneofs)
                                    object._sourceDiskEncryptionKey = "sourceDiskEncryptionKey";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Snapshot to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Snapshot.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Snapshot
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Snapshot
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Snapshot.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Snapshot";
                        };
    
                        /**
                         * Architecture enum.
                         * @name google.cloud.compute.v1.Snapshot.Architecture
                         * @enum {number}
                         * @property {number} UNDEFINED_ARCHITECTURE=0 UNDEFINED_ARCHITECTURE value
                         * @property {number} ARCHITECTURE_UNSPECIFIED=394750507 ARCHITECTURE_UNSPECIFIED value
                         * @property {number} ARM64=62547450 ARM64 value
                         * @property {number} X86_64=425300551 X86_64 value
                         */
                        Snapshot.Architecture = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ARCHITECTURE"] = 0;
                            values[valuesById[394750507] = "ARCHITECTURE_UNSPECIFIED"] = 394750507;
                            values[valuesById[62547450] = "ARM64"] = 62547450;
                            values[valuesById[425300551] = "X86_64"] = 425300551;
                            return values;
                        })();
    
                        /**
                         * SnapshotType enum.
                         * @name google.cloud.compute.v1.Snapshot.SnapshotType
                         * @enum {number}
                         * @property {number} UNDEFINED_SNAPSHOT_TYPE=0 UNDEFINED_SNAPSHOT_TYPE value
                         * @property {number} ARCHIVE=506752162 ARCHIVE value
                         * @property {number} STANDARD=484642493 STANDARD value
                         */
                        Snapshot.SnapshotType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_SNAPSHOT_TYPE"] = 0;
                            values[valuesById[506752162] = "ARCHIVE"] = 506752162;
                            values[valuesById[484642493] = "STANDARD"] = 484642493;
                            return values;
                        })();
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.Snapshot.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} CREATING=455564985 CREATING value
                         * @property {number} DELETING=528602024 DELETING value
                         * @property {number} FAILED=455706685 FAILED value
                         * @property {number} READY=77848963 READY value
                         * @property {number} UPLOADING=267603489 UPLOADING value
                         */
                        Snapshot.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[455564985] = "CREATING"] = 455564985;
                            values[valuesById[528602024] = "DELETING"] = 528602024;
                            values[valuesById[455706685] = "FAILED"] = 455706685;
                            values[valuesById[77848963] = "READY"] = 77848963;
                            values[valuesById[267603489] = "UPLOADING"] = 267603489;
                            return values;
                        })();
    
                        /**
                         * StorageBytesStatus enum.
                         * @name google.cloud.compute.v1.Snapshot.StorageBytesStatus
                         * @enum {number}
                         * @property {number} UNDEFINED_STORAGE_BYTES_STATUS=0 UNDEFINED_STORAGE_BYTES_STATUS value
                         * @property {number} UPDATING=494614342 UPDATING value
                         * @property {number} UP_TO_DATE=101306702 UP_TO_DATE value
                         */
                        Snapshot.StorageBytesStatus = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STORAGE_BYTES_STATUS"] = 0;
                            values[valuesById[494614342] = "UPDATING"] = 494614342;
                            values[valuesById[101306702] = "UP_TO_DATE"] = 101306702;
                            return values;
                        })();
    
                        return Snapshot;
                    })();
    
                    v1.SnapshotList = (function() {
    
                        /**
                         * Properties of a SnapshotList.
                         * @memberof google.cloud.compute.v1
                         * @interface ISnapshotList
                         * @property {string|null} [id] SnapshotList id
                         * @property {Array.<google.cloud.compute.v1.ISnapshot>|null} [items] SnapshotList items
                         * @property {string|null} [kind] SnapshotList kind
                         * @property {string|null} [nextPageToken] SnapshotList nextPageToken
                         * @property {string|null} [selfLink] SnapshotList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] SnapshotList warning
                         */
    
                        /**
                         * Constructs a new SnapshotList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SnapshotList.
                         * @implements ISnapshotList
                         * @constructor
                         * @param {google.cloud.compute.v1.ISnapshotList=} [properties] Properties to set
                         */
                        function SnapshotList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SnapshotList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @instance
                         */
                        SnapshotList.prototype.id = null;
    
                        /**
                         * SnapshotList items.
                         * @member {Array.<google.cloud.compute.v1.ISnapshot>} items
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @instance
                         */
                        SnapshotList.prototype.items = $util.emptyArray;
    
                        /**
                         * SnapshotList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @instance
                         */
                        SnapshotList.prototype.kind = null;
    
                        /**
                         * SnapshotList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @instance
                         */
                        SnapshotList.prototype.nextPageToken = null;
    
                        /**
                         * SnapshotList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @instance
                         */
                        SnapshotList.prototype.selfLink = null;
    
                        /**
                         * SnapshotList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @instance
                         */
                        SnapshotList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SnapshotList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @instance
                         */
                        Object.defineProperty(SnapshotList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SnapshotList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @instance
                         */
                        Object.defineProperty(SnapshotList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SnapshotList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @instance
                         */
                        Object.defineProperty(SnapshotList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SnapshotList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @instance
                         */
                        Object.defineProperty(SnapshotList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SnapshotList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @instance
                         */
                        Object.defineProperty(SnapshotList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SnapshotList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @static
                         * @param {google.cloud.compute.v1.ISnapshotList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SnapshotList} SnapshotList instance
                         */
                        SnapshotList.create = function create(properties) {
                            return new SnapshotList(properties);
                        };
    
                        /**
                         * Encodes the specified SnapshotList message. Does not implicitly {@link google.cloud.compute.v1.SnapshotList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @static
                         * @param {google.cloud.compute.v1.ISnapshotList} message SnapshotList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SnapshotList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Snapshot.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SnapshotList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SnapshotList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @static
                         * @param {google.cloud.compute.v1.ISnapshotList} message SnapshotList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SnapshotList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SnapshotList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SnapshotList} SnapshotList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SnapshotList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SnapshotList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Snapshot.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SnapshotList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SnapshotList} SnapshotList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SnapshotList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SnapshotList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SnapshotList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Snapshot.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SnapshotList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SnapshotList} SnapshotList
                         */
                        SnapshotList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SnapshotList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SnapshotList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.SnapshotList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SnapshotList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Snapshot.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SnapshotList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SnapshotList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @static
                         * @param {google.cloud.compute.v1.SnapshotList} message SnapshotList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SnapshotList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Snapshot.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SnapshotList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SnapshotList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SnapshotList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SnapshotList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SnapshotList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SnapshotList";
                        };
    
                        return SnapshotList;
                    })();
    
                    v1.SourceDiskEncryptionKey = (function() {
    
                        /**
                         * Properties of a SourceDiskEncryptionKey.
                         * @memberof google.cloud.compute.v1
                         * @interface ISourceDiskEncryptionKey
                         * @property {google.cloud.compute.v1.ICustomerEncryptionKey|null} [diskEncryptionKey] SourceDiskEncryptionKey diskEncryptionKey
                         * @property {string|null} [sourceDisk] SourceDiskEncryptionKey sourceDisk
                         */
    
                        /**
                         * Constructs a new SourceDiskEncryptionKey.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SourceDiskEncryptionKey.
                         * @implements ISourceDiskEncryptionKey
                         * @constructor
                         * @param {google.cloud.compute.v1.ISourceDiskEncryptionKey=} [properties] Properties to set
                         */
                        function SourceDiskEncryptionKey(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SourceDiskEncryptionKey diskEncryptionKey.
                         * @member {google.cloud.compute.v1.ICustomerEncryptionKey|null|undefined} diskEncryptionKey
                         * @memberof google.cloud.compute.v1.SourceDiskEncryptionKey
                         * @instance
                         */
                        SourceDiskEncryptionKey.prototype.diskEncryptionKey = null;
    
                        /**
                         * SourceDiskEncryptionKey sourceDisk.
                         * @member {string|null|undefined} sourceDisk
                         * @memberof google.cloud.compute.v1.SourceDiskEncryptionKey
                         * @instance
                         */
                        SourceDiskEncryptionKey.prototype.sourceDisk = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SourceDiskEncryptionKey _diskEncryptionKey.
                         * @member {"diskEncryptionKey"|undefined} _diskEncryptionKey
                         * @memberof google.cloud.compute.v1.SourceDiskEncryptionKey
                         * @instance
                         */
                        Object.defineProperty(SourceDiskEncryptionKey.prototype, "_diskEncryptionKey", {
                            get: $util.oneOfGetter($oneOfFields = ["diskEncryptionKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SourceDiskEncryptionKey _sourceDisk.
                         * @member {"sourceDisk"|undefined} _sourceDisk
                         * @memberof google.cloud.compute.v1.SourceDiskEncryptionKey
                         * @instance
                         */
                        Object.defineProperty(SourceDiskEncryptionKey.prototype, "_sourceDisk", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceDisk"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SourceDiskEncryptionKey instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SourceDiskEncryptionKey
                         * @static
                         * @param {google.cloud.compute.v1.ISourceDiskEncryptionKey=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SourceDiskEncryptionKey} SourceDiskEncryptionKey instance
                         */
                        SourceDiskEncryptionKey.create = function create(properties) {
                            return new SourceDiskEncryptionKey(properties);
                        };
    
                        /**
                         * Encodes the specified SourceDiskEncryptionKey message. Does not implicitly {@link google.cloud.compute.v1.SourceDiskEncryptionKey.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SourceDiskEncryptionKey
                         * @static
                         * @param {google.cloud.compute.v1.ISourceDiskEncryptionKey} message SourceDiskEncryptionKey message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SourceDiskEncryptionKey.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.diskEncryptionKey != null && Object.hasOwnProperty.call(message, "diskEncryptionKey"))
                                $root.google.cloud.compute.v1.CustomerEncryptionKey.encode(message.diskEncryptionKey, writer.uint32(/* id 271660677, wireType 2 =*/2173285418).fork()).ldelim();
                            if (message.sourceDisk != null && Object.hasOwnProperty.call(message, "sourceDisk"))
                                writer.uint32(/* id 451753793, wireType 2 =*/3614030346).string(message.sourceDisk);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SourceDiskEncryptionKey message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SourceDiskEncryptionKey.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SourceDiskEncryptionKey
                         * @static
                         * @param {google.cloud.compute.v1.ISourceDiskEncryptionKey} message SourceDiskEncryptionKey message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SourceDiskEncryptionKey.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SourceDiskEncryptionKey message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SourceDiskEncryptionKey
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SourceDiskEncryptionKey} SourceDiskEncryptionKey
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SourceDiskEncryptionKey.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SourceDiskEncryptionKey();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 271660677: {
                                        message.diskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 451753793: {
                                        message.sourceDisk = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SourceDiskEncryptionKey message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SourceDiskEncryptionKey
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SourceDiskEncryptionKey} SourceDiskEncryptionKey
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SourceDiskEncryptionKey.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SourceDiskEncryptionKey message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SourceDiskEncryptionKey
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SourceDiskEncryptionKey.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.diskEncryptionKey != null && message.hasOwnProperty("diskEncryptionKey")) {
                                properties._diskEncryptionKey = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.CustomerEncryptionKey.verify(message.diskEncryptionKey);
                                    if (error)
                                        return "diskEncryptionKey." + error;
                                }
                            }
                            if (message.sourceDisk != null && message.hasOwnProperty("sourceDisk")) {
                                properties._sourceDisk = 1;
                                if (!$util.isString(message.sourceDisk))
                                    return "sourceDisk: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SourceDiskEncryptionKey message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SourceDiskEncryptionKey
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SourceDiskEncryptionKey} SourceDiskEncryptionKey
                         */
                        SourceDiskEncryptionKey.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SourceDiskEncryptionKey)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SourceDiskEncryptionKey();
                            if (object.diskEncryptionKey != null) {
                                if (typeof object.diskEncryptionKey !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SourceDiskEncryptionKey.diskEncryptionKey: object expected");
                                message.diskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.fromObject(object.diskEncryptionKey);
                            }
                            if (object.sourceDisk != null)
                                message.sourceDisk = String(object.sourceDisk);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SourceDiskEncryptionKey message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SourceDiskEncryptionKey
                         * @static
                         * @param {google.cloud.compute.v1.SourceDiskEncryptionKey} message SourceDiskEncryptionKey
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SourceDiskEncryptionKey.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.diskEncryptionKey != null && message.hasOwnProperty("diskEncryptionKey")) {
                                object.diskEncryptionKey = $root.google.cloud.compute.v1.CustomerEncryptionKey.toObject(message.diskEncryptionKey, options);
                                if (options.oneofs)
                                    object._diskEncryptionKey = "diskEncryptionKey";
                            }
                            if (message.sourceDisk != null && message.hasOwnProperty("sourceDisk")) {
                                object.sourceDisk = message.sourceDisk;
                                if (options.oneofs)
                                    object._sourceDisk = "sourceDisk";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SourceDiskEncryptionKey to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SourceDiskEncryptionKey
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SourceDiskEncryptionKey.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SourceDiskEncryptionKey
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SourceDiskEncryptionKey
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SourceDiskEncryptionKey.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SourceDiskEncryptionKey";
                        };
    
                        return SourceDiskEncryptionKey;
                    })();
    
                    v1.SourceInstanceParams = (function() {
    
                        /**
                         * Properties of a SourceInstanceParams.
                         * @memberof google.cloud.compute.v1
                         * @interface ISourceInstanceParams
                         * @property {Array.<google.cloud.compute.v1.IDiskInstantiationConfig>|null} [diskConfigs] SourceInstanceParams diskConfigs
                         */
    
                        /**
                         * Constructs a new SourceInstanceParams.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SourceInstanceParams.
                         * @implements ISourceInstanceParams
                         * @constructor
                         * @param {google.cloud.compute.v1.ISourceInstanceParams=} [properties] Properties to set
                         */
                        function SourceInstanceParams(properties) {
                            this.diskConfigs = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SourceInstanceParams diskConfigs.
                         * @member {Array.<google.cloud.compute.v1.IDiskInstantiationConfig>} diskConfigs
                         * @memberof google.cloud.compute.v1.SourceInstanceParams
                         * @instance
                         */
                        SourceInstanceParams.prototype.diskConfigs = $util.emptyArray;
    
                        /**
                         * Creates a new SourceInstanceParams instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SourceInstanceParams
                         * @static
                         * @param {google.cloud.compute.v1.ISourceInstanceParams=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SourceInstanceParams} SourceInstanceParams instance
                         */
                        SourceInstanceParams.create = function create(properties) {
                            return new SourceInstanceParams(properties);
                        };
    
                        /**
                         * Encodes the specified SourceInstanceParams message. Does not implicitly {@link google.cloud.compute.v1.SourceInstanceParams.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SourceInstanceParams
                         * @static
                         * @param {google.cloud.compute.v1.ISourceInstanceParams} message SourceInstanceParams message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SourceInstanceParams.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.diskConfigs != null && message.diskConfigs.length)
                                for (var i = 0; i < message.diskConfigs.length; ++i)
                                    $root.google.cloud.compute.v1.DiskInstantiationConfig.encode(message.diskConfigs[i], writer.uint32(/* id 235580623, wireType 2 =*/1884644986).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SourceInstanceParams message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SourceInstanceParams.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SourceInstanceParams
                         * @static
                         * @param {google.cloud.compute.v1.ISourceInstanceParams} message SourceInstanceParams message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SourceInstanceParams.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SourceInstanceParams message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SourceInstanceParams
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SourceInstanceParams} SourceInstanceParams
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SourceInstanceParams.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SourceInstanceParams();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 235580623: {
                                        if (!(message.diskConfigs && message.diskConfigs.length))
                                            message.diskConfigs = [];
                                        message.diskConfigs.push($root.google.cloud.compute.v1.DiskInstantiationConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SourceInstanceParams message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SourceInstanceParams
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SourceInstanceParams} SourceInstanceParams
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SourceInstanceParams.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SourceInstanceParams message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SourceInstanceParams
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SourceInstanceParams.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.diskConfigs != null && message.hasOwnProperty("diskConfigs")) {
                                if (!Array.isArray(message.diskConfigs))
                                    return "diskConfigs: array expected";
                                for (var i = 0; i < message.diskConfigs.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.DiskInstantiationConfig.verify(message.diskConfigs[i]);
                                    if (error)
                                        return "diskConfigs." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SourceInstanceParams message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SourceInstanceParams
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SourceInstanceParams} SourceInstanceParams
                         */
                        SourceInstanceParams.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SourceInstanceParams)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SourceInstanceParams();
                            if (object.diskConfigs) {
                                if (!Array.isArray(object.diskConfigs))
                                    throw TypeError(".google.cloud.compute.v1.SourceInstanceParams.diskConfigs: array expected");
                                message.diskConfigs = [];
                                for (var i = 0; i < object.diskConfigs.length; ++i) {
                                    if (typeof object.diskConfigs[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SourceInstanceParams.diskConfigs: object expected");
                                    message.diskConfigs[i] = $root.google.cloud.compute.v1.DiskInstantiationConfig.fromObject(object.diskConfigs[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SourceInstanceParams message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SourceInstanceParams
                         * @static
                         * @param {google.cloud.compute.v1.SourceInstanceParams} message SourceInstanceParams
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SourceInstanceParams.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.diskConfigs = [];
                            if (message.diskConfigs && message.diskConfigs.length) {
                                object.diskConfigs = [];
                                for (var j = 0; j < message.diskConfigs.length; ++j)
                                    object.diskConfigs[j] = $root.google.cloud.compute.v1.DiskInstantiationConfig.toObject(message.diskConfigs[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SourceInstanceParams to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SourceInstanceParams
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SourceInstanceParams.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SourceInstanceParams
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SourceInstanceParams
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SourceInstanceParams.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SourceInstanceParams";
                        };
    
                        return SourceInstanceParams;
                    })();
    
                    v1.SourceInstanceProperties = (function() {
    
                        /**
                         * Properties of a SourceInstanceProperties.
                         * @memberof google.cloud.compute.v1
                         * @interface ISourceInstanceProperties
                         * @property {boolean|null} [canIpForward] SourceInstanceProperties canIpForward
                         * @property {boolean|null} [deletionProtection] SourceInstanceProperties deletionProtection
                         * @property {string|null} [description] SourceInstanceProperties description
                         * @property {Array.<google.cloud.compute.v1.ISavedAttachedDisk>|null} [disks] SourceInstanceProperties disks
                         * @property {Array.<google.cloud.compute.v1.IAcceleratorConfig>|null} [guestAccelerators] SourceInstanceProperties guestAccelerators
                         * @property {string|null} [keyRevocationActionType] SourceInstanceProperties keyRevocationActionType
                         * @property {Object.<string,string>|null} [labels] SourceInstanceProperties labels
                         * @property {string|null} [machineType] SourceInstanceProperties machineType
                         * @property {google.cloud.compute.v1.IMetadata|null} [metadata] SourceInstanceProperties metadata
                         * @property {string|null} [minCpuPlatform] SourceInstanceProperties minCpuPlatform
                         * @property {Array.<google.cloud.compute.v1.INetworkInterface>|null} [networkInterfaces] SourceInstanceProperties networkInterfaces
                         * @property {google.cloud.compute.v1.IScheduling|null} [scheduling] SourceInstanceProperties scheduling
                         * @property {Array.<google.cloud.compute.v1.IServiceAccount>|null} [serviceAccounts] SourceInstanceProperties serviceAccounts
                         * @property {google.cloud.compute.v1.ITags|null} [tags] SourceInstanceProperties tags
                         */
    
                        /**
                         * Constructs a new SourceInstanceProperties.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SourceInstanceProperties.
                         * @implements ISourceInstanceProperties
                         * @constructor
                         * @param {google.cloud.compute.v1.ISourceInstanceProperties=} [properties] Properties to set
                         */
                        function SourceInstanceProperties(properties) {
                            this.disks = [];
                            this.guestAccelerators = [];
                            this.labels = {};
                            this.networkInterfaces = [];
                            this.serviceAccounts = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SourceInstanceProperties canIpForward.
                         * @member {boolean|null|undefined} canIpForward
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        SourceInstanceProperties.prototype.canIpForward = null;
    
                        /**
                         * SourceInstanceProperties deletionProtection.
                         * @member {boolean|null|undefined} deletionProtection
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        SourceInstanceProperties.prototype.deletionProtection = null;
    
                        /**
                         * SourceInstanceProperties description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        SourceInstanceProperties.prototype.description = null;
    
                        /**
                         * SourceInstanceProperties disks.
                         * @member {Array.<google.cloud.compute.v1.ISavedAttachedDisk>} disks
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        SourceInstanceProperties.prototype.disks = $util.emptyArray;
    
                        /**
                         * SourceInstanceProperties guestAccelerators.
                         * @member {Array.<google.cloud.compute.v1.IAcceleratorConfig>} guestAccelerators
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        SourceInstanceProperties.prototype.guestAccelerators = $util.emptyArray;
    
                        /**
                         * SourceInstanceProperties keyRevocationActionType.
                         * @member {string|null|undefined} keyRevocationActionType
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        SourceInstanceProperties.prototype.keyRevocationActionType = null;
    
                        /**
                         * SourceInstanceProperties labels.
                         * @member {Object.<string,string>} labels
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        SourceInstanceProperties.prototype.labels = $util.emptyObject;
    
                        /**
                         * SourceInstanceProperties machineType.
                         * @member {string|null|undefined} machineType
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        SourceInstanceProperties.prototype.machineType = null;
    
                        /**
                         * SourceInstanceProperties metadata.
                         * @member {google.cloud.compute.v1.IMetadata|null|undefined} metadata
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        SourceInstanceProperties.prototype.metadata = null;
    
                        /**
                         * SourceInstanceProperties minCpuPlatform.
                         * @member {string|null|undefined} minCpuPlatform
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        SourceInstanceProperties.prototype.minCpuPlatform = null;
    
                        /**
                         * SourceInstanceProperties networkInterfaces.
                         * @member {Array.<google.cloud.compute.v1.INetworkInterface>} networkInterfaces
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        SourceInstanceProperties.prototype.networkInterfaces = $util.emptyArray;
    
                        /**
                         * SourceInstanceProperties scheduling.
                         * @member {google.cloud.compute.v1.IScheduling|null|undefined} scheduling
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        SourceInstanceProperties.prototype.scheduling = null;
    
                        /**
                         * SourceInstanceProperties serviceAccounts.
                         * @member {Array.<google.cloud.compute.v1.IServiceAccount>} serviceAccounts
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        SourceInstanceProperties.prototype.serviceAccounts = $util.emptyArray;
    
                        /**
                         * SourceInstanceProperties tags.
                         * @member {google.cloud.compute.v1.ITags|null|undefined} tags
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        SourceInstanceProperties.prototype.tags = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SourceInstanceProperties _canIpForward.
                         * @member {"canIpForward"|undefined} _canIpForward
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        Object.defineProperty(SourceInstanceProperties.prototype, "_canIpForward", {
                            get: $util.oneOfGetter($oneOfFields = ["canIpForward"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SourceInstanceProperties _deletionProtection.
                         * @member {"deletionProtection"|undefined} _deletionProtection
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        Object.defineProperty(SourceInstanceProperties.prototype, "_deletionProtection", {
                            get: $util.oneOfGetter($oneOfFields = ["deletionProtection"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SourceInstanceProperties _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        Object.defineProperty(SourceInstanceProperties.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SourceInstanceProperties _keyRevocationActionType.
                         * @member {"keyRevocationActionType"|undefined} _keyRevocationActionType
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        Object.defineProperty(SourceInstanceProperties.prototype, "_keyRevocationActionType", {
                            get: $util.oneOfGetter($oneOfFields = ["keyRevocationActionType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SourceInstanceProperties _machineType.
                         * @member {"machineType"|undefined} _machineType
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        Object.defineProperty(SourceInstanceProperties.prototype, "_machineType", {
                            get: $util.oneOfGetter($oneOfFields = ["machineType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SourceInstanceProperties _metadata.
                         * @member {"metadata"|undefined} _metadata
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        Object.defineProperty(SourceInstanceProperties.prototype, "_metadata", {
                            get: $util.oneOfGetter($oneOfFields = ["metadata"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SourceInstanceProperties _minCpuPlatform.
                         * @member {"minCpuPlatform"|undefined} _minCpuPlatform
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        Object.defineProperty(SourceInstanceProperties.prototype, "_minCpuPlatform", {
                            get: $util.oneOfGetter($oneOfFields = ["minCpuPlatform"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SourceInstanceProperties _scheduling.
                         * @member {"scheduling"|undefined} _scheduling
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        Object.defineProperty(SourceInstanceProperties.prototype, "_scheduling", {
                            get: $util.oneOfGetter($oneOfFields = ["scheduling"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SourceInstanceProperties _tags.
                         * @member {"tags"|undefined} _tags
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         */
                        Object.defineProperty(SourceInstanceProperties.prototype, "_tags", {
                            get: $util.oneOfGetter($oneOfFields = ["tags"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SourceInstanceProperties instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @static
                         * @param {google.cloud.compute.v1.ISourceInstanceProperties=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SourceInstanceProperties} SourceInstanceProperties instance
                         */
                        SourceInstanceProperties.create = function create(properties) {
                            return new SourceInstanceProperties(properties);
                        };
    
                        /**
                         * Encodes the specified SourceInstanceProperties message. Does not implicitly {@link google.cloud.compute.v1.SourceInstanceProperties.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @static
                         * @param {google.cloud.compute.v1.ISourceInstanceProperties} message SourceInstanceProperties message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SourceInstanceProperties.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.tags != null && Object.hasOwnProperty.call(message, "tags"))
                                $root.google.cloud.compute.v1.Tags.encode(message.tags, writer.uint32(/* id 3552281, wireType 2 =*/28418250).fork()).ldelim();
                            if (message.networkInterfaces != null && message.networkInterfaces.length)
                                for (var i = 0; i < message.networkInterfaces.length; ++i)
                                    $root.google.cloud.compute.v1.NetworkInterface.encode(message.networkInterfaces[i], writer.uint32(/* id 52735243, wireType 2 =*/421881946).fork()).ldelim();
                            if (message.metadata != null && Object.hasOwnProperty.call(message, "metadata"))
                                $root.google.cloud.compute.v1.Metadata.encode(message.metadata, writer.uint32(/* id 86866735, wireType 2 =*/694933882).fork()).ldelim();
                            if (message.disks != null && message.disks.length)
                                for (var i = 0; i < message.disks.length; ++i)
                                    $root.google.cloud.compute.v1.SavedAttachedDisk.encode(message.disks[i], writer.uint32(/* id 95594102, wireType 2 =*/764752818).fork()).ldelim();
                            if (message.machineType != null && Object.hasOwnProperty.call(message, "machineType"))
                                writer.uint32(/* id 227711026, wireType 2 =*/1821688210).string(message.machineType);
                            if (message.keyRevocationActionType != null && Object.hasOwnProperty.call(message, "keyRevocationActionType"))
                                writer.uint32(/* id 235941474, wireType 2 =*/1887531794).string(message.keyRevocationActionType);
                            if (message.minCpuPlatform != null && Object.hasOwnProperty.call(message, "minCpuPlatform"))
                                writer.uint32(/* id 242912759, wireType 2 =*/1943302074).string(message.minCpuPlatform);
                            if (message.serviceAccounts != null && message.serviceAccounts.length)
                                for (var i = 0; i < message.serviceAccounts.length; ++i)
                                    $root.google.cloud.compute.v1.ServiceAccount.encode(message.serviceAccounts[i], writer.uint32(/* id 277537328, wireType 2 =*/2220298626).fork()).ldelim();
                            if (message.scheduling != null && Object.hasOwnProperty.call(message, "scheduling"))
                                $root.google.cloud.compute.v1.Scheduling.encode(message.scheduling, writer.uint32(/* id 386688404, wireType 2 =*/3093507234).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.deletionProtection != null && Object.hasOwnProperty.call(message, "deletionProtection"))
                                writer.uint32(/* id 458014698, wireType 0 =*/3664117584).bool(message.deletionProtection);
                            if (message.guestAccelerators != null && message.guestAccelerators.length)
                                for (var i = 0; i < message.guestAccelerators.length; ++i)
                                    $root.google.cloud.compute.v1.AcceleratorConfig.encode(message.guestAccelerators[i], writer.uint32(/* id 463595119, wireType 2 =*/3708760954).fork()).ldelim();
                            if (message.canIpForward != null && Object.hasOwnProperty.call(message, "canIpForward"))
                                writer.uint32(/* id 467731324, wireType 0 =*/3741850592).bool(message.canIpForward);
                            if (message.labels != null && Object.hasOwnProperty.call(message, "labels"))
                                for (var keys = Object.keys(message.labels), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 500195327, wireType 2 =*/4001562618).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.labels[keys[i]]).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SourceInstanceProperties message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SourceInstanceProperties.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @static
                         * @param {google.cloud.compute.v1.ISourceInstanceProperties} message SourceInstanceProperties message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SourceInstanceProperties.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SourceInstanceProperties message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SourceInstanceProperties} SourceInstanceProperties
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SourceInstanceProperties.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SourceInstanceProperties(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 467731324: {
                                        message.canIpForward = reader.bool();
                                        break;
                                    }
                                case 458014698: {
                                        message.deletionProtection = reader.bool();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 95594102: {
                                        if (!(message.disks && message.disks.length))
                                            message.disks = [];
                                        message.disks.push($root.google.cloud.compute.v1.SavedAttachedDisk.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 463595119: {
                                        if (!(message.guestAccelerators && message.guestAccelerators.length))
                                            message.guestAccelerators = [];
                                        message.guestAccelerators.push($root.google.cloud.compute.v1.AcceleratorConfig.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 235941474: {
                                        message.keyRevocationActionType = reader.string();
                                        break;
                                    }
                                case 500195327: {
                                        if (message.labels === $util.emptyObject)
                                            message.labels = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.labels[key] = value;
                                        break;
                                    }
                                case 227711026: {
                                        message.machineType = reader.string();
                                        break;
                                    }
                                case 86866735: {
                                        message.metadata = $root.google.cloud.compute.v1.Metadata.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 242912759: {
                                        message.minCpuPlatform = reader.string();
                                        break;
                                    }
                                case 52735243: {
                                        if (!(message.networkInterfaces && message.networkInterfaces.length))
                                            message.networkInterfaces = [];
                                        message.networkInterfaces.push($root.google.cloud.compute.v1.NetworkInterface.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 386688404: {
                                        message.scheduling = $root.google.cloud.compute.v1.Scheduling.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 277537328: {
                                        if (!(message.serviceAccounts && message.serviceAccounts.length))
                                            message.serviceAccounts = [];
                                        message.serviceAccounts.push($root.google.cloud.compute.v1.ServiceAccount.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3552281: {
                                        message.tags = $root.google.cloud.compute.v1.Tags.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SourceInstanceProperties message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SourceInstanceProperties} SourceInstanceProperties
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SourceInstanceProperties.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SourceInstanceProperties message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SourceInstanceProperties.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.canIpForward != null && message.hasOwnProperty("canIpForward")) {
                                properties._canIpForward = 1;
                                if (typeof message.canIpForward !== "boolean")
                                    return "canIpForward: boolean expected";
                            }
                            if (message.deletionProtection != null && message.hasOwnProperty("deletionProtection")) {
                                properties._deletionProtection = 1;
                                if (typeof message.deletionProtection !== "boolean")
                                    return "deletionProtection: boolean expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.disks != null && message.hasOwnProperty("disks")) {
                                if (!Array.isArray(message.disks))
                                    return "disks: array expected";
                                for (var i = 0; i < message.disks.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.SavedAttachedDisk.verify(message.disks[i]);
                                    if (error)
                                        return "disks." + error;
                                }
                            }
                            if (message.guestAccelerators != null && message.hasOwnProperty("guestAccelerators")) {
                                if (!Array.isArray(message.guestAccelerators))
                                    return "guestAccelerators: array expected";
                                for (var i = 0; i < message.guestAccelerators.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.AcceleratorConfig.verify(message.guestAccelerators[i]);
                                    if (error)
                                        return "guestAccelerators." + error;
                                }
                            }
                            if (message.keyRevocationActionType != null && message.hasOwnProperty("keyRevocationActionType")) {
                                properties._keyRevocationActionType = 1;
                                if (!$util.isString(message.keyRevocationActionType))
                                    return "keyRevocationActionType: string expected";
                            }
                            if (message.labels != null && message.hasOwnProperty("labels")) {
                                if (!$util.isObject(message.labels))
                                    return "labels: object expected";
                                var key = Object.keys(message.labels);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.labels[key[i]]))
                                        return "labels: string{k:string} expected";
                            }
                            if (message.machineType != null && message.hasOwnProperty("machineType")) {
                                properties._machineType = 1;
                                if (!$util.isString(message.machineType))
                                    return "machineType: string expected";
                            }
                            if (message.metadata != null && message.hasOwnProperty("metadata")) {
                                properties._metadata = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Metadata.verify(message.metadata);
                                    if (error)
                                        return "metadata." + error;
                                }
                            }
                            if (message.minCpuPlatform != null && message.hasOwnProperty("minCpuPlatform")) {
                                properties._minCpuPlatform = 1;
                                if (!$util.isString(message.minCpuPlatform))
                                    return "minCpuPlatform: string expected";
                            }
                            if (message.networkInterfaces != null && message.hasOwnProperty("networkInterfaces")) {
                                if (!Array.isArray(message.networkInterfaces))
                                    return "networkInterfaces: array expected";
                                for (var i = 0; i < message.networkInterfaces.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.NetworkInterface.verify(message.networkInterfaces[i]);
                                    if (error)
                                        return "networkInterfaces." + error;
                                }
                            }
                            if (message.scheduling != null && message.hasOwnProperty("scheduling")) {
                                properties._scheduling = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Scheduling.verify(message.scheduling);
                                    if (error)
                                        return "scheduling." + error;
                                }
                            }
                            if (message.serviceAccounts != null && message.hasOwnProperty("serviceAccounts")) {
                                if (!Array.isArray(message.serviceAccounts))
                                    return "serviceAccounts: array expected";
                                for (var i = 0; i < message.serviceAccounts.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.ServiceAccount.verify(message.serviceAccounts[i]);
                                    if (error)
                                        return "serviceAccounts." + error;
                                }
                            }
                            if (message.tags != null && message.hasOwnProperty("tags")) {
                                properties._tags = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Tags.verify(message.tags);
                                    if (error)
                                        return "tags." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SourceInstanceProperties message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SourceInstanceProperties} SourceInstanceProperties
                         */
                        SourceInstanceProperties.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SourceInstanceProperties)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SourceInstanceProperties();
                            if (object.canIpForward != null)
                                message.canIpForward = Boolean(object.canIpForward);
                            if (object.deletionProtection != null)
                                message.deletionProtection = Boolean(object.deletionProtection);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.disks) {
                                if (!Array.isArray(object.disks))
                                    throw TypeError(".google.cloud.compute.v1.SourceInstanceProperties.disks: array expected");
                                message.disks = [];
                                for (var i = 0; i < object.disks.length; ++i) {
                                    if (typeof object.disks[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SourceInstanceProperties.disks: object expected");
                                    message.disks[i] = $root.google.cloud.compute.v1.SavedAttachedDisk.fromObject(object.disks[i]);
                                }
                            }
                            if (object.guestAccelerators) {
                                if (!Array.isArray(object.guestAccelerators))
                                    throw TypeError(".google.cloud.compute.v1.SourceInstanceProperties.guestAccelerators: array expected");
                                message.guestAccelerators = [];
                                for (var i = 0; i < object.guestAccelerators.length; ++i) {
                                    if (typeof object.guestAccelerators[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SourceInstanceProperties.guestAccelerators: object expected");
                                    message.guestAccelerators[i] = $root.google.cloud.compute.v1.AcceleratorConfig.fromObject(object.guestAccelerators[i]);
                                }
                            }
                            if (object.keyRevocationActionType != null)
                                message.keyRevocationActionType = String(object.keyRevocationActionType);
                            if (object.labels) {
                                if (typeof object.labels !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SourceInstanceProperties.labels: object expected");
                                message.labels = {};
                                for (var keys = Object.keys(object.labels), i = 0; i < keys.length; ++i)
                                    message.labels[keys[i]] = String(object.labels[keys[i]]);
                            }
                            if (object.machineType != null)
                                message.machineType = String(object.machineType);
                            if (object.metadata != null) {
                                if (typeof object.metadata !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SourceInstanceProperties.metadata: object expected");
                                message.metadata = $root.google.cloud.compute.v1.Metadata.fromObject(object.metadata);
                            }
                            if (object.minCpuPlatform != null)
                                message.minCpuPlatform = String(object.minCpuPlatform);
                            if (object.networkInterfaces) {
                                if (!Array.isArray(object.networkInterfaces))
                                    throw TypeError(".google.cloud.compute.v1.SourceInstanceProperties.networkInterfaces: array expected");
                                message.networkInterfaces = [];
                                for (var i = 0; i < object.networkInterfaces.length; ++i) {
                                    if (typeof object.networkInterfaces[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SourceInstanceProperties.networkInterfaces: object expected");
                                    message.networkInterfaces[i] = $root.google.cloud.compute.v1.NetworkInterface.fromObject(object.networkInterfaces[i]);
                                }
                            }
                            if (object.scheduling != null) {
                                if (typeof object.scheduling !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SourceInstanceProperties.scheduling: object expected");
                                message.scheduling = $root.google.cloud.compute.v1.Scheduling.fromObject(object.scheduling);
                            }
                            if (object.serviceAccounts) {
                                if (!Array.isArray(object.serviceAccounts))
                                    throw TypeError(".google.cloud.compute.v1.SourceInstanceProperties.serviceAccounts: array expected");
                                message.serviceAccounts = [];
                                for (var i = 0; i < object.serviceAccounts.length; ++i) {
                                    if (typeof object.serviceAccounts[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SourceInstanceProperties.serviceAccounts: object expected");
                                    message.serviceAccounts[i] = $root.google.cloud.compute.v1.ServiceAccount.fromObject(object.serviceAccounts[i]);
                                }
                            }
                            if (object.tags != null) {
                                if (typeof object.tags !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SourceInstanceProperties.tags: object expected");
                                message.tags = $root.google.cloud.compute.v1.Tags.fromObject(object.tags);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SourceInstanceProperties message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @static
                         * @param {google.cloud.compute.v1.SourceInstanceProperties} message SourceInstanceProperties
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SourceInstanceProperties.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.networkInterfaces = [];
                                object.disks = [];
                                object.serviceAccounts = [];
                                object.guestAccelerators = [];
                            }
                            if (options.objects || options.defaults)
                                object.labels = {};
                            if (message.tags != null && message.hasOwnProperty("tags")) {
                                object.tags = $root.google.cloud.compute.v1.Tags.toObject(message.tags, options);
                                if (options.oneofs)
                                    object._tags = "tags";
                            }
                            if (message.networkInterfaces && message.networkInterfaces.length) {
                                object.networkInterfaces = [];
                                for (var j = 0; j < message.networkInterfaces.length; ++j)
                                    object.networkInterfaces[j] = $root.google.cloud.compute.v1.NetworkInterface.toObject(message.networkInterfaces[j], options);
                            }
                            if (message.metadata != null && message.hasOwnProperty("metadata")) {
                                object.metadata = $root.google.cloud.compute.v1.Metadata.toObject(message.metadata, options);
                                if (options.oneofs)
                                    object._metadata = "metadata";
                            }
                            if (message.disks && message.disks.length) {
                                object.disks = [];
                                for (var j = 0; j < message.disks.length; ++j)
                                    object.disks[j] = $root.google.cloud.compute.v1.SavedAttachedDisk.toObject(message.disks[j], options);
                            }
                            if (message.machineType != null && message.hasOwnProperty("machineType")) {
                                object.machineType = message.machineType;
                                if (options.oneofs)
                                    object._machineType = "machineType";
                            }
                            if (message.keyRevocationActionType != null && message.hasOwnProperty("keyRevocationActionType")) {
                                object.keyRevocationActionType = message.keyRevocationActionType;
                                if (options.oneofs)
                                    object._keyRevocationActionType = "keyRevocationActionType";
                            }
                            if (message.minCpuPlatform != null && message.hasOwnProperty("minCpuPlatform")) {
                                object.minCpuPlatform = message.minCpuPlatform;
                                if (options.oneofs)
                                    object._minCpuPlatform = "minCpuPlatform";
                            }
                            if (message.serviceAccounts && message.serviceAccounts.length) {
                                object.serviceAccounts = [];
                                for (var j = 0; j < message.serviceAccounts.length; ++j)
                                    object.serviceAccounts[j] = $root.google.cloud.compute.v1.ServiceAccount.toObject(message.serviceAccounts[j], options);
                            }
                            if (message.scheduling != null && message.hasOwnProperty("scheduling")) {
                                object.scheduling = $root.google.cloud.compute.v1.Scheduling.toObject(message.scheduling, options);
                                if (options.oneofs)
                                    object._scheduling = "scheduling";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.deletionProtection != null && message.hasOwnProperty("deletionProtection")) {
                                object.deletionProtection = message.deletionProtection;
                                if (options.oneofs)
                                    object._deletionProtection = "deletionProtection";
                            }
                            if (message.guestAccelerators && message.guestAccelerators.length) {
                                object.guestAccelerators = [];
                                for (var j = 0; j < message.guestAccelerators.length; ++j)
                                    object.guestAccelerators[j] = $root.google.cloud.compute.v1.AcceleratorConfig.toObject(message.guestAccelerators[j], options);
                            }
                            if (message.canIpForward != null && message.hasOwnProperty("canIpForward")) {
                                object.canIpForward = message.canIpForward;
                                if (options.oneofs)
                                    object._canIpForward = "canIpForward";
                            }
                            var keys2;
                            if (message.labels && (keys2 = Object.keys(message.labels)).length) {
                                object.labels = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.labels[keys2[j]] = message.labels[keys2[j]];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SourceInstanceProperties to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SourceInstanceProperties.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SourceInstanceProperties
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SourceInstanceProperties
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SourceInstanceProperties.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SourceInstanceProperties";
                        };
    
                        /**
                         * KeyRevocationActionType enum.
                         * @name google.cloud.compute.v1.SourceInstanceProperties.KeyRevocationActionType
                         * @enum {number}
                         * @property {number} UNDEFINED_KEY_REVOCATION_ACTION_TYPE=0 UNDEFINED_KEY_REVOCATION_ACTION_TYPE value
                         * @property {number} KEY_REVOCATION_ACTION_TYPE_UNSPECIFIED=467110106 KEY_REVOCATION_ACTION_TYPE_UNSPECIFIED value
                         * @property {number} NONE=2402104 NONE value
                         * @property {number} STOP=2555906 STOP value
                         */
                        SourceInstanceProperties.KeyRevocationActionType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_KEY_REVOCATION_ACTION_TYPE"] = 0;
                            values[valuesById[467110106] = "KEY_REVOCATION_ACTION_TYPE_UNSPECIFIED"] = 467110106;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            values[valuesById[2555906] = "STOP"] = 2555906;
                            return values;
                        })();
    
                        return SourceInstanceProperties;
                    })();
    
                    v1.SslCertificate = (function() {
    
                        /**
                         * Properties of a SslCertificate.
                         * @memberof google.cloud.compute.v1
                         * @interface ISslCertificate
                         * @property {string|null} [certificate] SslCertificate certificate
                         * @property {string|null} [creationTimestamp] SslCertificate creationTimestamp
                         * @property {string|null} [description] SslCertificate description
                         * @property {string|null} [expireTime] SslCertificate expireTime
                         * @property {number|Long|null} [id] SslCertificate id
                         * @property {string|null} [kind] SslCertificate kind
                         * @property {google.cloud.compute.v1.ISslCertificateManagedSslCertificate|null} [managed] SslCertificate managed
                         * @property {string|null} [name] SslCertificate name
                         * @property {string|null} [privateKey] SslCertificate privateKey
                         * @property {string|null} [region] SslCertificate region
                         * @property {string|null} [selfLink] SslCertificate selfLink
                         * @property {google.cloud.compute.v1.ISslCertificateSelfManagedSslCertificate|null} [selfManaged] SslCertificate selfManaged
                         * @property {Array.<string>|null} [subjectAlternativeNames] SslCertificate subjectAlternativeNames
                         * @property {string|null} [type] SslCertificate type
                         */
    
                        /**
                         * Constructs a new SslCertificate.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SslCertificate.
                         * @implements ISslCertificate
                         * @constructor
                         * @param {google.cloud.compute.v1.ISslCertificate=} [properties] Properties to set
                         */
                        function SslCertificate(properties) {
                            this.subjectAlternativeNames = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SslCertificate certificate.
                         * @member {string|null|undefined} certificate
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        SslCertificate.prototype.certificate = null;
    
                        /**
                         * SslCertificate creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        SslCertificate.prototype.creationTimestamp = null;
    
                        /**
                         * SslCertificate description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        SslCertificate.prototype.description = null;
    
                        /**
                         * SslCertificate expireTime.
                         * @member {string|null|undefined} expireTime
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        SslCertificate.prototype.expireTime = null;
    
                        /**
                         * SslCertificate id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        SslCertificate.prototype.id = null;
    
                        /**
                         * SslCertificate kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        SslCertificate.prototype.kind = null;
    
                        /**
                         * SslCertificate managed.
                         * @member {google.cloud.compute.v1.ISslCertificateManagedSslCertificate|null|undefined} managed
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        SslCertificate.prototype.managed = null;
    
                        /**
                         * SslCertificate name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        SslCertificate.prototype.name = null;
    
                        /**
                         * SslCertificate privateKey.
                         * @member {string|null|undefined} privateKey
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        SslCertificate.prototype.privateKey = null;
    
                        /**
                         * SslCertificate region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        SslCertificate.prototype.region = null;
    
                        /**
                         * SslCertificate selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        SslCertificate.prototype.selfLink = null;
    
                        /**
                         * SslCertificate selfManaged.
                         * @member {google.cloud.compute.v1.ISslCertificateSelfManagedSslCertificate|null|undefined} selfManaged
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        SslCertificate.prototype.selfManaged = null;
    
                        /**
                         * SslCertificate subjectAlternativeNames.
                         * @member {Array.<string>} subjectAlternativeNames
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        SslCertificate.prototype.subjectAlternativeNames = $util.emptyArray;
    
                        /**
                         * SslCertificate type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        SslCertificate.prototype.type = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SslCertificate _certificate.
                         * @member {"certificate"|undefined} _certificate
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        Object.defineProperty(SslCertificate.prototype, "_certificate", {
                            get: $util.oneOfGetter($oneOfFields = ["certificate"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificate _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        Object.defineProperty(SslCertificate.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificate _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        Object.defineProperty(SslCertificate.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificate _expireTime.
                         * @member {"expireTime"|undefined} _expireTime
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        Object.defineProperty(SslCertificate.prototype, "_expireTime", {
                            get: $util.oneOfGetter($oneOfFields = ["expireTime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificate _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        Object.defineProperty(SslCertificate.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificate _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        Object.defineProperty(SslCertificate.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificate _managed.
                         * @member {"managed"|undefined} _managed
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        Object.defineProperty(SslCertificate.prototype, "_managed", {
                            get: $util.oneOfGetter($oneOfFields = ["managed"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificate _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        Object.defineProperty(SslCertificate.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificate _privateKey.
                         * @member {"privateKey"|undefined} _privateKey
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        Object.defineProperty(SslCertificate.prototype, "_privateKey", {
                            get: $util.oneOfGetter($oneOfFields = ["privateKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificate _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        Object.defineProperty(SslCertificate.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificate _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        Object.defineProperty(SslCertificate.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificate _selfManaged.
                         * @member {"selfManaged"|undefined} _selfManaged
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        Object.defineProperty(SslCertificate.prototype, "_selfManaged", {
                            get: $util.oneOfGetter($oneOfFields = ["selfManaged"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificate _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         */
                        Object.defineProperty(SslCertificate.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SslCertificate instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @static
                         * @param {google.cloud.compute.v1.ISslCertificate=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SslCertificate} SslCertificate instance
                         */
                        SslCertificate.create = function create(properties) {
                            return new SslCertificate(properties);
                        };
    
                        /**
                         * Encodes the specified SslCertificate message. Does not implicitly {@link google.cloud.compute.v1.SslCertificate.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @static
                         * @param {google.cloud.compute.v1.ISslCertificate} message SslCertificate message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslCertificate.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.managed != null && Object.hasOwnProperty.call(message, "managed"))
                                $root.google.cloud.compute.v1.SslCertificateManagedSslCertificate.encode(message.managed, writer.uint32(/* id 298389407, wireType 2 =*/2387115258).fork()).ldelim();
                            if (message.selfManaged != null && Object.hasOwnProperty.call(message, "selfManaged"))
                                $root.google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate.encode(message.selfManaged, writer.uint32(/* id 329284012, wireType 2 =*/2634272098).fork()).ldelim();
                            if (message.certificate != null && Object.hasOwnProperty.call(message, "certificate"))
                                writer.uint32(/* id 341787031, wireType 2 =*/2734296250).string(message.certificate);
                            if (message.privateKey != null && Object.hasOwnProperty.call(message, "privateKey"))
                                writer.uint32(/* id 361331107, wireType 2 =*/2890648858).string(message.privateKey);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.expireTime != null && Object.hasOwnProperty.call(message, "expireTime"))
                                writer.uint32(/* id 440691181, wireType 2 =*/3525529450).string(message.expireTime);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.subjectAlternativeNames != null && message.subjectAlternativeNames.length)
                                for (var i = 0; i < message.subjectAlternativeNames.length; ++i)
                                    writer.uint32(/* id 528807907, wireType 2 =*/4230463258).string(message.subjectAlternativeNames[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SslCertificate message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SslCertificate.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @static
                         * @param {google.cloud.compute.v1.ISslCertificate} message SslCertificate message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslCertificate.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SslCertificate message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SslCertificate} SslCertificate
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslCertificate.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SslCertificate();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 341787031: {
                                        message.certificate = reader.string();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 440691181: {
                                        message.expireTime = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 298389407: {
                                        message.managed = $root.google.cloud.compute.v1.SslCertificateManagedSslCertificate.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 361331107: {
                                        message.privateKey = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 329284012: {
                                        message.selfManaged = $root.google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 528807907: {
                                        if (!(message.subjectAlternativeNames && message.subjectAlternativeNames.length))
                                            message.subjectAlternativeNames = [];
                                        message.subjectAlternativeNames.push(reader.string());
                                        break;
                                    }
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SslCertificate message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SslCertificate} SslCertificate
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslCertificate.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SslCertificate message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SslCertificate.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.certificate != null && message.hasOwnProperty("certificate")) {
                                properties._certificate = 1;
                                if (!$util.isString(message.certificate))
                                    return "certificate: string expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.expireTime != null && message.hasOwnProperty("expireTime")) {
                                properties._expireTime = 1;
                                if (!$util.isString(message.expireTime))
                                    return "expireTime: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.managed != null && message.hasOwnProperty("managed")) {
                                properties._managed = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SslCertificateManagedSslCertificate.verify(message.managed);
                                    if (error)
                                        return "managed." + error;
                                }
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.privateKey != null && message.hasOwnProperty("privateKey")) {
                                properties._privateKey = 1;
                                if (!$util.isString(message.privateKey))
                                    return "privateKey: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.selfManaged != null && message.hasOwnProperty("selfManaged")) {
                                properties._selfManaged = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate.verify(message.selfManaged);
                                    if (error)
                                        return "selfManaged." + error;
                                }
                            }
                            if (message.subjectAlternativeNames != null && message.hasOwnProperty("subjectAlternativeNames")) {
                                if (!Array.isArray(message.subjectAlternativeNames))
                                    return "subjectAlternativeNames: array expected";
                                for (var i = 0; i < message.subjectAlternativeNames.length; ++i)
                                    if (!$util.isString(message.subjectAlternativeNames[i]))
                                        return "subjectAlternativeNames: string[] expected";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SslCertificate message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SslCertificate} SslCertificate
                         */
                        SslCertificate.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SslCertificate)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SslCertificate();
                            if (object.certificate != null)
                                message.certificate = String(object.certificate);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.expireTime != null)
                                message.expireTime = String(object.expireTime);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.managed != null) {
                                if (typeof object.managed !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SslCertificate.managed: object expected");
                                message.managed = $root.google.cloud.compute.v1.SslCertificateManagedSslCertificate.fromObject(object.managed);
                            }
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.privateKey != null)
                                message.privateKey = String(object.privateKey);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.selfManaged != null) {
                                if (typeof object.selfManaged !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SslCertificate.selfManaged: object expected");
                                message.selfManaged = $root.google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate.fromObject(object.selfManaged);
                            }
                            if (object.subjectAlternativeNames) {
                                if (!Array.isArray(object.subjectAlternativeNames))
                                    throw TypeError(".google.cloud.compute.v1.SslCertificate.subjectAlternativeNames: array expected");
                                message.subjectAlternativeNames = [];
                                for (var i = 0; i < object.subjectAlternativeNames.length; ++i)
                                    message.subjectAlternativeNames[i] = String(object.subjectAlternativeNames[i]);
                            }
                            if (object.type != null)
                                message.type = String(object.type);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SslCertificate message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @static
                         * @param {google.cloud.compute.v1.SslCertificate} message SslCertificate
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SslCertificate.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.subjectAlternativeNames = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.managed != null && message.hasOwnProperty("managed")) {
                                object.managed = $root.google.cloud.compute.v1.SslCertificateManagedSslCertificate.toObject(message.managed, options);
                                if (options.oneofs)
                                    object._managed = "managed";
                            }
                            if (message.selfManaged != null && message.hasOwnProperty("selfManaged")) {
                                object.selfManaged = $root.google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate.toObject(message.selfManaged, options);
                                if (options.oneofs)
                                    object._selfManaged = "selfManaged";
                            }
                            if (message.certificate != null && message.hasOwnProperty("certificate")) {
                                object.certificate = message.certificate;
                                if (options.oneofs)
                                    object._certificate = "certificate";
                            }
                            if (message.privateKey != null && message.hasOwnProperty("privateKey")) {
                                object.privateKey = message.privateKey;
                                if (options.oneofs)
                                    object._privateKey = "privateKey";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.expireTime != null && message.hasOwnProperty("expireTime")) {
                                object.expireTime = message.expireTime;
                                if (options.oneofs)
                                    object._expireTime = "expireTime";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.subjectAlternativeNames && message.subjectAlternativeNames.length) {
                                object.subjectAlternativeNames = [];
                                for (var j = 0; j < message.subjectAlternativeNames.length; ++j)
                                    object.subjectAlternativeNames[j] = message.subjectAlternativeNames[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SslCertificate to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SslCertificate.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SslCertificate
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SslCertificate
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SslCertificate.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SslCertificate";
                        };
    
                        /**
                         * Type enum.
                         * @name google.cloud.compute.v1.SslCertificate.Type
                         * @enum {number}
                         * @property {number} UNDEFINED_TYPE=0 UNDEFINED_TYPE value
                         * @property {number} MANAGED=479501183 MANAGED value
                         * @property {number} SELF_MANAGED=434437516 SELF_MANAGED value
                         * @property {number} TYPE_UNSPECIFIED=437714322 TYPE_UNSPECIFIED value
                         */
                        SslCertificate.Type = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TYPE"] = 0;
                            values[valuesById[479501183] = "MANAGED"] = 479501183;
                            values[valuesById[434437516] = "SELF_MANAGED"] = 434437516;
                            values[valuesById[437714322] = "TYPE_UNSPECIFIED"] = 437714322;
                            return values;
                        })();
    
                        return SslCertificate;
                    })();
    
                    v1.SslCertificateAggregatedList = (function() {
    
                        /**
                         * Properties of a SslCertificateAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface ISslCertificateAggregatedList
                         * @property {string|null} [id] SslCertificateAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.ISslCertificatesScopedList>|null} [items] SslCertificateAggregatedList items
                         * @property {string|null} [kind] SslCertificateAggregatedList kind
                         * @property {string|null} [nextPageToken] SslCertificateAggregatedList nextPageToken
                         * @property {string|null} [selfLink] SslCertificateAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] SslCertificateAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] SslCertificateAggregatedList warning
                         */
    
                        /**
                         * Constructs a new SslCertificateAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SslCertificateAggregatedList.
                         * @implements ISslCertificateAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.ISslCertificateAggregatedList=} [properties] Properties to set
                         */
                        function SslCertificateAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SslCertificateAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @instance
                         */
                        SslCertificateAggregatedList.prototype.id = null;
    
                        /**
                         * SslCertificateAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.ISslCertificatesScopedList>} items
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @instance
                         */
                        SslCertificateAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * SslCertificateAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @instance
                         */
                        SslCertificateAggregatedList.prototype.kind = null;
    
                        /**
                         * SslCertificateAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @instance
                         */
                        SslCertificateAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * SslCertificateAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @instance
                         */
                        SslCertificateAggregatedList.prototype.selfLink = null;
    
                        /**
                         * SslCertificateAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @instance
                         */
                        SslCertificateAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * SslCertificateAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @instance
                         */
                        SslCertificateAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SslCertificateAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SslCertificateAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificateAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SslCertificateAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificateAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SslCertificateAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificateAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SslCertificateAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificateAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SslCertificateAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SslCertificateAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ISslCertificateAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SslCertificateAggregatedList} SslCertificateAggregatedList instance
                         */
                        SslCertificateAggregatedList.create = function create(properties) {
                            return new SslCertificateAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified SslCertificateAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.SslCertificateAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ISslCertificateAggregatedList} message SslCertificateAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslCertificateAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.SslCertificatesScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SslCertificateAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SslCertificateAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ISslCertificateAggregatedList} message SslCertificateAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslCertificateAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SslCertificateAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SslCertificateAggregatedList} SslCertificateAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslCertificateAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SslCertificateAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.SslCertificatesScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SslCertificateAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SslCertificateAggregatedList} SslCertificateAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslCertificateAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SslCertificateAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SslCertificateAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.SslCertificatesScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SslCertificateAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SslCertificateAggregatedList} SslCertificateAggregatedList
                         */
                        SslCertificateAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SslCertificateAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SslCertificateAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SslCertificateAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SslCertificateAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.SslCertificatesScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.SslCertificateAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SslCertificateAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SslCertificateAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.SslCertificateAggregatedList} message SslCertificateAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SslCertificateAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.SslCertificatesScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SslCertificateAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SslCertificateAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SslCertificateAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SslCertificateAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SslCertificateAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SslCertificateAggregatedList";
                        };
    
                        return SslCertificateAggregatedList;
                    })();
    
                    v1.SslCertificateList = (function() {
    
                        /**
                         * Properties of a SslCertificateList.
                         * @memberof google.cloud.compute.v1
                         * @interface ISslCertificateList
                         * @property {string|null} [id] SslCertificateList id
                         * @property {Array.<google.cloud.compute.v1.ISslCertificate>|null} [items] SslCertificateList items
                         * @property {string|null} [kind] SslCertificateList kind
                         * @property {string|null} [nextPageToken] SslCertificateList nextPageToken
                         * @property {string|null} [selfLink] SslCertificateList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] SslCertificateList warning
                         */
    
                        /**
                         * Constructs a new SslCertificateList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SslCertificateList.
                         * @implements ISslCertificateList
                         * @constructor
                         * @param {google.cloud.compute.v1.ISslCertificateList=} [properties] Properties to set
                         */
                        function SslCertificateList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SslCertificateList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @instance
                         */
                        SslCertificateList.prototype.id = null;
    
                        /**
                         * SslCertificateList items.
                         * @member {Array.<google.cloud.compute.v1.ISslCertificate>} items
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @instance
                         */
                        SslCertificateList.prototype.items = $util.emptyArray;
    
                        /**
                         * SslCertificateList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @instance
                         */
                        SslCertificateList.prototype.kind = null;
    
                        /**
                         * SslCertificateList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @instance
                         */
                        SslCertificateList.prototype.nextPageToken = null;
    
                        /**
                         * SslCertificateList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @instance
                         */
                        SslCertificateList.prototype.selfLink = null;
    
                        /**
                         * SslCertificateList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @instance
                         */
                        SslCertificateList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SslCertificateList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @instance
                         */
                        Object.defineProperty(SslCertificateList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificateList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @instance
                         */
                        Object.defineProperty(SslCertificateList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificateList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @instance
                         */
                        Object.defineProperty(SslCertificateList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificateList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @instance
                         */
                        Object.defineProperty(SslCertificateList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificateList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @instance
                         */
                        Object.defineProperty(SslCertificateList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SslCertificateList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @static
                         * @param {google.cloud.compute.v1.ISslCertificateList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SslCertificateList} SslCertificateList instance
                         */
                        SslCertificateList.create = function create(properties) {
                            return new SslCertificateList(properties);
                        };
    
                        /**
                         * Encodes the specified SslCertificateList message. Does not implicitly {@link google.cloud.compute.v1.SslCertificateList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @static
                         * @param {google.cloud.compute.v1.ISslCertificateList} message SslCertificateList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslCertificateList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.SslCertificate.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SslCertificateList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SslCertificateList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @static
                         * @param {google.cloud.compute.v1.ISslCertificateList} message SslCertificateList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslCertificateList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SslCertificateList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SslCertificateList} SslCertificateList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslCertificateList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SslCertificateList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.SslCertificate.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SslCertificateList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SslCertificateList} SslCertificateList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslCertificateList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SslCertificateList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SslCertificateList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.SslCertificate.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SslCertificateList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SslCertificateList} SslCertificateList
                         */
                        SslCertificateList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SslCertificateList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SslCertificateList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.SslCertificateList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SslCertificateList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.SslCertificate.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SslCertificateList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SslCertificateList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @static
                         * @param {google.cloud.compute.v1.SslCertificateList} message SslCertificateList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SslCertificateList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.SslCertificate.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SslCertificateList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SslCertificateList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SslCertificateList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SslCertificateList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SslCertificateList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SslCertificateList";
                        };
    
                        return SslCertificateList;
                    })();
    
                    v1.SslCertificateManagedSslCertificate = (function() {
    
                        /**
                         * Properties of a SslCertificateManagedSslCertificate.
                         * @memberof google.cloud.compute.v1
                         * @interface ISslCertificateManagedSslCertificate
                         * @property {Object.<string,string>|null} [domainStatus] SslCertificateManagedSslCertificate domainStatus
                         * @property {Array.<string>|null} [domains] SslCertificateManagedSslCertificate domains
                         * @property {string|null} [status] SslCertificateManagedSslCertificate status
                         */
    
                        /**
                         * Constructs a new SslCertificateManagedSslCertificate.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SslCertificateManagedSslCertificate.
                         * @implements ISslCertificateManagedSslCertificate
                         * @constructor
                         * @param {google.cloud.compute.v1.ISslCertificateManagedSslCertificate=} [properties] Properties to set
                         */
                        function SslCertificateManagedSslCertificate(properties) {
                            this.domainStatus = {};
                            this.domains = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SslCertificateManagedSslCertificate domainStatus.
                         * @member {Object.<string,string>} domainStatus
                         * @memberof google.cloud.compute.v1.SslCertificateManagedSslCertificate
                         * @instance
                         */
                        SslCertificateManagedSslCertificate.prototype.domainStatus = $util.emptyObject;
    
                        /**
                         * SslCertificateManagedSslCertificate domains.
                         * @member {Array.<string>} domains
                         * @memberof google.cloud.compute.v1.SslCertificateManagedSslCertificate
                         * @instance
                         */
                        SslCertificateManagedSslCertificate.prototype.domains = $util.emptyArray;
    
                        /**
                         * SslCertificateManagedSslCertificate status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.SslCertificateManagedSslCertificate
                         * @instance
                         */
                        SslCertificateManagedSslCertificate.prototype.status = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SslCertificateManagedSslCertificate _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.SslCertificateManagedSslCertificate
                         * @instance
                         */
                        Object.defineProperty(SslCertificateManagedSslCertificate.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SslCertificateManagedSslCertificate instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SslCertificateManagedSslCertificate
                         * @static
                         * @param {google.cloud.compute.v1.ISslCertificateManagedSslCertificate=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SslCertificateManagedSslCertificate} SslCertificateManagedSslCertificate instance
                         */
                        SslCertificateManagedSslCertificate.create = function create(properties) {
                            return new SslCertificateManagedSslCertificate(properties);
                        };
    
                        /**
                         * Encodes the specified SslCertificateManagedSslCertificate message. Does not implicitly {@link google.cloud.compute.v1.SslCertificateManagedSslCertificate.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SslCertificateManagedSslCertificate
                         * @static
                         * @param {google.cloud.compute.v1.ISslCertificateManagedSslCertificate} message SslCertificateManagedSslCertificate message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslCertificateManagedSslCertificate.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.domains != null && message.domains.length)
                                for (var i = 0; i < message.domains.length; ++i)
                                    writer.uint32(/* id 226935855, wireType 2 =*/1815486842).string(message.domains[i]);
                            if (message.domainStatus != null && Object.hasOwnProperty.call(message, "domainStatus"))
                                for (var keys = Object.keys(message.domainStatus), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 360305613, wireType 2 =*/2882444906).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.domainStatus[keys[i]]).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SslCertificateManagedSslCertificate message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SslCertificateManagedSslCertificate.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SslCertificateManagedSslCertificate
                         * @static
                         * @param {google.cloud.compute.v1.ISslCertificateManagedSslCertificate} message SslCertificateManagedSslCertificate message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslCertificateManagedSslCertificate.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SslCertificateManagedSslCertificate message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SslCertificateManagedSslCertificate
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SslCertificateManagedSslCertificate} SslCertificateManagedSslCertificate
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslCertificateManagedSslCertificate.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SslCertificateManagedSslCertificate(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 360305613: {
                                        if (message.domainStatus === $util.emptyObject)
                                            message.domainStatus = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.domainStatus[key] = value;
                                        break;
                                    }
                                case 226935855: {
                                        if (!(message.domains && message.domains.length))
                                            message.domains = [];
                                        message.domains.push(reader.string());
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SslCertificateManagedSslCertificate message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SslCertificateManagedSslCertificate
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SslCertificateManagedSslCertificate} SslCertificateManagedSslCertificate
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslCertificateManagedSslCertificate.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SslCertificateManagedSslCertificate message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SslCertificateManagedSslCertificate
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SslCertificateManagedSslCertificate.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.domainStatus != null && message.hasOwnProperty("domainStatus")) {
                                if (!$util.isObject(message.domainStatus))
                                    return "domainStatus: object expected";
                                var key = Object.keys(message.domainStatus);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.domainStatus[key[i]]))
                                        return "domainStatus: string{k:string} expected";
                            }
                            if (message.domains != null && message.hasOwnProperty("domains")) {
                                if (!Array.isArray(message.domains))
                                    return "domains: array expected";
                                for (var i = 0; i < message.domains.length; ++i)
                                    if (!$util.isString(message.domains[i]))
                                        return "domains: string[] expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SslCertificateManagedSslCertificate message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SslCertificateManagedSslCertificate
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SslCertificateManagedSslCertificate} SslCertificateManagedSslCertificate
                         */
                        SslCertificateManagedSslCertificate.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SslCertificateManagedSslCertificate)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SslCertificateManagedSslCertificate();
                            if (object.domainStatus) {
                                if (typeof object.domainStatus !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SslCertificateManagedSslCertificate.domainStatus: object expected");
                                message.domainStatus = {};
                                for (var keys = Object.keys(object.domainStatus), i = 0; i < keys.length; ++i)
                                    message.domainStatus[keys[i]] = String(object.domainStatus[keys[i]]);
                            }
                            if (object.domains) {
                                if (!Array.isArray(object.domains))
                                    throw TypeError(".google.cloud.compute.v1.SslCertificateManagedSslCertificate.domains: array expected");
                                message.domains = [];
                                for (var i = 0; i < object.domains.length; ++i)
                                    message.domains[i] = String(object.domains[i]);
                            }
                            if (object.status != null)
                                message.status = String(object.status);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SslCertificateManagedSslCertificate message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SslCertificateManagedSslCertificate
                         * @static
                         * @param {google.cloud.compute.v1.SslCertificateManagedSslCertificate} message SslCertificateManagedSslCertificate
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SslCertificateManagedSslCertificate.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.domains = [];
                            if (options.objects || options.defaults)
                                object.domainStatus = {};
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.domains && message.domains.length) {
                                object.domains = [];
                                for (var j = 0; j < message.domains.length; ++j)
                                    object.domains[j] = message.domains[j];
                            }
                            var keys2;
                            if (message.domainStatus && (keys2 = Object.keys(message.domainStatus)).length) {
                                object.domainStatus = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.domainStatus[keys2[j]] = message.domainStatus[keys2[j]];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SslCertificateManagedSslCertificate to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SslCertificateManagedSslCertificate
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SslCertificateManagedSslCertificate.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SslCertificateManagedSslCertificate
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SslCertificateManagedSslCertificate
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SslCertificateManagedSslCertificate.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SslCertificateManagedSslCertificate";
                        };
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.SslCertificateManagedSslCertificate.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} ACTIVE=314733318 ACTIVE value
                         * @property {number} MANAGED_CERTIFICATE_STATUS_UNSPECIFIED=474800850 MANAGED_CERTIFICATE_STATUS_UNSPECIFIED value
                         * @property {number} PROVISIONING=290896621 PROVISIONING value
                         * @property {number} PROVISIONING_FAILED=76813775 PROVISIONING_FAILED value
                         * @property {number} PROVISIONING_FAILED_PERMANENTLY=275036203 PROVISIONING_FAILED_PERMANENTLY value
                         * @property {number} RENEWAL_FAILED=434659076 RENEWAL_FAILED value
                         */
                        SslCertificateManagedSslCertificate.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[314733318] = "ACTIVE"] = 314733318;
                            values[valuesById[474800850] = "MANAGED_CERTIFICATE_STATUS_UNSPECIFIED"] = 474800850;
                            values[valuesById[290896621] = "PROVISIONING"] = 290896621;
                            values[valuesById[76813775] = "PROVISIONING_FAILED"] = 76813775;
                            values[valuesById[275036203] = "PROVISIONING_FAILED_PERMANENTLY"] = 275036203;
                            values[valuesById[434659076] = "RENEWAL_FAILED"] = 434659076;
                            return values;
                        })();
    
                        return SslCertificateManagedSslCertificate;
                    })();
    
                    v1.SslCertificateSelfManagedSslCertificate = (function() {
    
                        /**
                         * Properties of a SslCertificateSelfManagedSslCertificate.
                         * @memberof google.cloud.compute.v1
                         * @interface ISslCertificateSelfManagedSslCertificate
                         * @property {string|null} [certificate] SslCertificateSelfManagedSslCertificate certificate
                         * @property {string|null} [privateKey] SslCertificateSelfManagedSslCertificate privateKey
                         */
    
                        /**
                         * Constructs a new SslCertificateSelfManagedSslCertificate.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SslCertificateSelfManagedSslCertificate.
                         * @implements ISslCertificateSelfManagedSslCertificate
                         * @constructor
                         * @param {google.cloud.compute.v1.ISslCertificateSelfManagedSslCertificate=} [properties] Properties to set
                         */
                        function SslCertificateSelfManagedSslCertificate(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SslCertificateSelfManagedSslCertificate certificate.
                         * @member {string|null|undefined} certificate
                         * @memberof google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate
                         * @instance
                         */
                        SslCertificateSelfManagedSslCertificate.prototype.certificate = null;
    
                        /**
                         * SslCertificateSelfManagedSslCertificate privateKey.
                         * @member {string|null|undefined} privateKey
                         * @memberof google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate
                         * @instance
                         */
                        SslCertificateSelfManagedSslCertificate.prototype.privateKey = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SslCertificateSelfManagedSslCertificate _certificate.
                         * @member {"certificate"|undefined} _certificate
                         * @memberof google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate
                         * @instance
                         */
                        Object.defineProperty(SslCertificateSelfManagedSslCertificate.prototype, "_certificate", {
                            get: $util.oneOfGetter($oneOfFields = ["certificate"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslCertificateSelfManagedSslCertificate _privateKey.
                         * @member {"privateKey"|undefined} _privateKey
                         * @memberof google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate
                         * @instance
                         */
                        Object.defineProperty(SslCertificateSelfManagedSslCertificate.prototype, "_privateKey", {
                            get: $util.oneOfGetter($oneOfFields = ["privateKey"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SslCertificateSelfManagedSslCertificate instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate
                         * @static
                         * @param {google.cloud.compute.v1.ISslCertificateSelfManagedSslCertificate=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate} SslCertificateSelfManagedSslCertificate instance
                         */
                        SslCertificateSelfManagedSslCertificate.create = function create(properties) {
                            return new SslCertificateSelfManagedSslCertificate(properties);
                        };
    
                        /**
                         * Encodes the specified SslCertificateSelfManagedSslCertificate message. Does not implicitly {@link google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate
                         * @static
                         * @param {google.cloud.compute.v1.ISslCertificateSelfManagedSslCertificate} message SslCertificateSelfManagedSslCertificate message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslCertificateSelfManagedSslCertificate.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.certificate != null && Object.hasOwnProperty.call(message, "certificate"))
                                writer.uint32(/* id 341787031, wireType 2 =*/2734296250).string(message.certificate);
                            if (message.privateKey != null && Object.hasOwnProperty.call(message, "privateKey"))
                                writer.uint32(/* id 361331107, wireType 2 =*/2890648858).string(message.privateKey);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SslCertificateSelfManagedSslCertificate message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate
                         * @static
                         * @param {google.cloud.compute.v1.ISslCertificateSelfManagedSslCertificate} message SslCertificateSelfManagedSslCertificate message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslCertificateSelfManagedSslCertificate.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SslCertificateSelfManagedSslCertificate message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate} SslCertificateSelfManagedSslCertificate
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslCertificateSelfManagedSslCertificate.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 341787031: {
                                        message.certificate = reader.string();
                                        break;
                                    }
                                case 361331107: {
                                        message.privateKey = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SslCertificateSelfManagedSslCertificate message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate} SslCertificateSelfManagedSslCertificate
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslCertificateSelfManagedSslCertificate.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SslCertificateSelfManagedSslCertificate message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SslCertificateSelfManagedSslCertificate.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.certificate != null && message.hasOwnProperty("certificate")) {
                                properties._certificate = 1;
                                if (!$util.isString(message.certificate))
                                    return "certificate: string expected";
                            }
                            if (message.privateKey != null && message.hasOwnProperty("privateKey")) {
                                properties._privateKey = 1;
                                if (!$util.isString(message.privateKey))
                                    return "privateKey: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SslCertificateSelfManagedSslCertificate message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate} SslCertificateSelfManagedSslCertificate
                         */
                        SslCertificateSelfManagedSslCertificate.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate();
                            if (object.certificate != null)
                                message.certificate = String(object.certificate);
                            if (object.privateKey != null)
                                message.privateKey = String(object.privateKey);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SslCertificateSelfManagedSslCertificate message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate
                         * @static
                         * @param {google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate} message SslCertificateSelfManagedSslCertificate
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SslCertificateSelfManagedSslCertificate.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.certificate != null && message.hasOwnProperty("certificate")) {
                                object.certificate = message.certificate;
                                if (options.oneofs)
                                    object._certificate = "certificate";
                            }
                            if (message.privateKey != null && message.hasOwnProperty("privateKey")) {
                                object.privateKey = message.privateKey;
                                if (options.oneofs)
                                    object._privateKey = "privateKey";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SslCertificateSelfManagedSslCertificate to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SslCertificateSelfManagedSslCertificate.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SslCertificateSelfManagedSslCertificate
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SslCertificateSelfManagedSslCertificate.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SslCertificateSelfManagedSslCertificate";
                        };
    
                        return SslCertificateSelfManagedSslCertificate;
                    })();
    
                    v1.SslCertificatesScopedList = (function() {
    
                        /**
                         * Properties of a SslCertificatesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface ISslCertificatesScopedList
                         * @property {Array.<google.cloud.compute.v1.ISslCertificate>|null} [sslCertificates] SslCertificatesScopedList sslCertificates
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] SslCertificatesScopedList warning
                         */
    
                        /**
                         * Constructs a new SslCertificatesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SslCertificatesScopedList.
                         * @implements ISslCertificatesScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.ISslCertificatesScopedList=} [properties] Properties to set
                         */
                        function SslCertificatesScopedList(properties) {
                            this.sslCertificates = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SslCertificatesScopedList sslCertificates.
                         * @member {Array.<google.cloud.compute.v1.ISslCertificate>} sslCertificates
                         * @memberof google.cloud.compute.v1.SslCertificatesScopedList
                         * @instance
                         */
                        SslCertificatesScopedList.prototype.sslCertificates = $util.emptyArray;
    
                        /**
                         * SslCertificatesScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.SslCertificatesScopedList
                         * @instance
                         */
                        SslCertificatesScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SslCertificatesScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.SslCertificatesScopedList
                         * @instance
                         */
                        Object.defineProperty(SslCertificatesScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SslCertificatesScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SslCertificatesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ISslCertificatesScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SslCertificatesScopedList} SslCertificatesScopedList instance
                         */
                        SslCertificatesScopedList.create = function create(properties) {
                            return new SslCertificatesScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified SslCertificatesScopedList message. Does not implicitly {@link google.cloud.compute.v1.SslCertificatesScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SslCertificatesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ISslCertificatesScopedList} message SslCertificatesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslCertificatesScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.sslCertificates != null && message.sslCertificates.length)
                                for (var i = 0; i < message.sslCertificates.length; ++i)
                                    $root.google.cloud.compute.v1.SslCertificate.encode(message.sslCertificates[i], writer.uint32(/* id 366006543, wireType 2 =*/2928052346).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SslCertificatesScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SslCertificatesScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SslCertificatesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ISslCertificatesScopedList} message SslCertificatesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslCertificatesScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SslCertificatesScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SslCertificatesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SslCertificatesScopedList} SslCertificatesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslCertificatesScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SslCertificatesScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 366006543: {
                                        if (!(message.sslCertificates && message.sslCertificates.length))
                                            message.sslCertificates = [];
                                        message.sslCertificates.push($root.google.cloud.compute.v1.SslCertificate.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SslCertificatesScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SslCertificatesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SslCertificatesScopedList} SslCertificatesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslCertificatesScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SslCertificatesScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SslCertificatesScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SslCertificatesScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.sslCertificates != null && message.hasOwnProperty("sslCertificates")) {
                                if (!Array.isArray(message.sslCertificates))
                                    return "sslCertificates: array expected";
                                for (var i = 0; i < message.sslCertificates.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.SslCertificate.verify(message.sslCertificates[i]);
                                    if (error)
                                        return "sslCertificates." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SslCertificatesScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SslCertificatesScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SslCertificatesScopedList} SslCertificatesScopedList
                         */
                        SslCertificatesScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SslCertificatesScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SslCertificatesScopedList();
                            if (object.sslCertificates) {
                                if (!Array.isArray(object.sslCertificates))
                                    throw TypeError(".google.cloud.compute.v1.SslCertificatesScopedList.sslCertificates: array expected");
                                message.sslCertificates = [];
                                for (var i = 0; i < object.sslCertificates.length; ++i) {
                                    if (typeof object.sslCertificates[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SslCertificatesScopedList.sslCertificates: object expected");
                                    message.sslCertificates[i] = $root.google.cloud.compute.v1.SslCertificate.fromObject(object.sslCertificates[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SslCertificatesScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SslCertificatesScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SslCertificatesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.SslCertificatesScopedList} message SslCertificatesScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SslCertificatesScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.sslCertificates = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.sslCertificates && message.sslCertificates.length) {
                                object.sslCertificates = [];
                                for (var j = 0; j < message.sslCertificates.length; ++j)
                                    object.sslCertificates[j] = $root.google.cloud.compute.v1.SslCertificate.toObject(message.sslCertificates[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SslCertificatesScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SslCertificatesScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SslCertificatesScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SslCertificatesScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SslCertificatesScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SslCertificatesScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SslCertificatesScopedList";
                        };
    
                        return SslCertificatesScopedList;
                    })();
    
                    v1.SslPoliciesAggregatedList = (function() {
    
                        /**
                         * Properties of a SslPoliciesAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface ISslPoliciesAggregatedList
                         * @property {string|null} [etag] SslPoliciesAggregatedList etag
                         * @property {string|null} [id] SslPoliciesAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.ISslPoliciesScopedList>|null} [items] SslPoliciesAggregatedList items
                         * @property {string|null} [kind] SslPoliciesAggregatedList kind
                         * @property {string|null} [nextPageToken] SslPoliciesAggregatedList nextPageToken
                         * @property {string|null} [selfLink] SslPoliciesAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] SslPoliciesAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] SslPoliciesAggregatedList warning
                         */
    
                        /**
                         * Constructs a new SslPoliciesAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SslPoliciesAggregatedList.
                         * @implements ISslPoliciesAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.ISslPoliciesAggregatedList=} [properties] Properties to set
                         */
                        function SslPoliciesAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SslPoliciesAggregatedList etag.
                         * @member {string|null|undefined} etag
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @instance
                         */
                        SslPoliciesAggregatedList.prototype.etag = null;
    
                        /**
                         * SslPoliciesAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @instance
                         */
                        SslPoliciesAggregatedList.prototype.id = null;
    
                        /**
                         * SslPoliciesAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.ISslPoliciesScopedList>} items
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @instance
                         */
                        SslPoliciesAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * SslPoliciesAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @instance
                         */
                        SslPoliciesAggregatedList.prototype.kind = null;
    
                        /**
                         * SslPoliciesAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @instance
                         */
                        SslPoliciesAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * SslPoliciesAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @instance
                         */
                        SslPoliciesAggregatedList.prototype.selfLink = null;
    
                        /**
                         * SslPoliciesAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @instance
                         */
                        SslPoliciesAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * SslPoliciesAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @instance
                         */
                        SslPoliciesAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SslPoliciesAggregatedList _etag.
                         * @member {"etag"|undefined} _etag
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SslPoliciesAggregatedList.prototype, "_etag", {
                            get: $util.oneOfGetter($oneOfFields = ["etag"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslPoliciesAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SslPoliciesAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslPoliciesAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SslPoliciesAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslPoliciesAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SslPoliciesAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslPoliciesAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SslPoliciesAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslPoliciesAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SslPoliciesAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SslPoliciesAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ISslPoliciesAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SslPoliciesAggregatedList} SslPoliciesAggregatedList instance
                         */
                        SslPoliciesAggregatedList.create = function create(properties) {
                            return new SslPoliciesAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified SslPoliciesAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.SslPoliciesAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ISslPoliciesAggregatedList} message SslPoliciesAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslPoliciesAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.etag != null && Object.hasOwnProperty.call(message, "etag"))
                                writer.uint32(/* id 3123477, wireType 2 =*/24987818).string(message.etag);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.SslPoliciesScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SslPoliciesAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SslPoliciesAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ISslPoliciesAggregatedList} message SslPoliciesAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslPoliciesAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SslPoliciesAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SslPoliciesAggregatedList} SslPoliciesAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslPoliciesAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SslPoliciesAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3123477: {
                                        message.etag = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.SslPoliciesScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SslPoliciesAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SslPoliciesAggregatedList} SslPoliciesAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslPoliciesAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SslPoliciesAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SslPoliciesAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                properties._etag = 1;
                                if (!$util.isString(message.etag))
                                    return "etag: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.SslPoliciesScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SslPoliciesAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SslPoliciesAggregatedList} SslPoliciesAggregatedList
                         */
                        SslPoliciesAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SslPoliciesAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SslPoliciesAggregatedList();
                            if (object.etag != null)
                                message.etag = String(object.etag);
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SslPoliciesAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SslPoliciesAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.SslPoliciesScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.SslPoliciesAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SslPoliciesAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SslPoliciesAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.SslPoliciesAggregatedList} message SslPoliciesAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SslPoliciesAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                object.etag = message.etag;
                                if (options.oneofs)
                                    object._etag = "etag";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.SslPoliciesScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SslPoliciesAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SslPoliciesAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SslPoliciesAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SslPoliciesAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SslPoliciesAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SslPoliciesAggregatedList";
                        };
    
                        return SslPoliciesAggregatedList;
                    })();
    
                    v1.SslPoliciesList = (function() {
    
                        /**
                         * Properties of a SslPoliciesList.
                         * @memberof google.cloud.compute.v1
                         * @interface ISslPoliciesList
                         * @property {string|null} [id] SslPoliciesList id
                         * @property {Array.<google.cloud.compute.v1.ISslPolicy>|null} [items] SslPoliciesList items
                         * @property {string|null} [kind] SslPoliciesList kind
                         * @property {string|null} [nextPageToken] SslPoliciesList nextPageToken
                         * @property {string|null} [selfLink] SslPoliciesList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] SslPoliciesList warning
                         */
    
                        /**
                         * Constructs a new SslPoliciesList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SslPoliciesList.
                         * @implements ISslPoliciesList
                         * @constructor
                         * @param {google.cloud.compute.v1.ISslPoliciesList=} [properties] Properties to set
                         */
                        function SslPoliciesList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SslPoliciesList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @instance
                         */
                        SslPoliciesList.prototype.id = null;
    
                        /**
                         * SslPoliciesList items.
                         * @member {Array.<google.cloud.compute.v1.ISslPolicy>} items
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @instance
                         */
                        SslPoliciesList.prototype.items = $util.emptyArray;
    
                        /**
                         * SslPoliciesList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @instance
                         */
                        SslPoliciesList.prototype.kind = null;
    
                        /**
                         * SslPoliciesList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @instance
                         */
                        SslPoliciesList.prototype.nextPageToken = null;
    
                        /**
                         * SslPoliciesList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @instance
                         */
                        SslPoliciesList.prototype.selfLink = null;
    
                        /**
                         * SslPoliciesList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @instance
                         */
                        SslPoliciesList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SslPoliciesList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @instance
                         */
                        Object.defineProperty(SslPoliciesList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslPoliciesList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @instance
                         */
                        Object.defineProperty(SslPoliciesList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslPoliciesList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @instance
                         */
                        Object.defineProperty(SslPoliciesList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslPoliciesList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @instance
                         */
                        Object.defineProperty(SslPoliciesList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslPoliciesList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @instance
                         */
                        Object.defineProperty(SslPoliciesList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SslPoliciesList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @static
                         * @param {google.cloud.compute.v1.ISslPoliciesList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SslPoliciesList} SslPoliciesList instance
                         */
                        SslPoliciesList.create = function create(properties) {
                            return new SslPoliciesList(properties);
                        };
    
                        /**
                         * Encodes the specified SslPoliciesList message. Does not implicitly {@link google.cloud.compute.v1.SslPoliciesList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @static
                         * @param {google.cloud.compute.v1.ISslPoliciesList} message SslPoliciesList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslPoliciesList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.SslPolicy.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SslPoliciesList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SslPoliciesList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @static
                         * @param {google.cloud.compute.v1.ISslPoliciesList} message SslPoliciesList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslPoliciesList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SslPoliciesList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SslPoliciesList} SslPoliciesList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslPoliciesList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SslPoliciesList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.SslPolicy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SslPoliciesList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SslPoliciesList} SslPoliciesList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslPoliciesList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SslPoliciesList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SslPoliciesList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.SslPolicy.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SslPoliciesList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SslPoliciesList} SslPoliciesList
                         */
                        SslPoliciesList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SslPoliciesList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SslPoliciesList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.SslPoliciesList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SslPoliciesList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.SslPolicy.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SslPoliciesList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SslPoliciesList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @static
                         * @param {google.cloud.compute.v1.SslPoliciesList} message SslPoliciesList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SslPoliciesList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.SslPolicy.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SslPoliciesList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SslPoliciesList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SslPoliciesList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SslPoliciesList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SslPoliciesList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SslPoliciesList";
                        };
    
                        return SslPoliciesList;
                    })();
    
                    v1.SslPoliciesListAvailableFeaturesResponse = (function() {
    
                        /**
                         * Properties of a SslPoliciesListAvailableFeaturesResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface ISslPoliciesListAvailableFeaturesResponse
                         * @property {Array.<string>|null} [features] SslPoliciesListAvailableFeaturesResponse features
                         */
    
                        /**
                         * Constructs a new SslPoliciesListAvailableFeaturesResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SslPoliciesListAvailableFeaturesResponse.
                         * @implements ISslPoliciesListAvailableFeaturesResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.ISslPoliciesListAvailableFeaturesResponse=} [properties] Properties to set
                         */
                        function SslPoliciesListAvailableFeaturesResponse(properties) {
                            this.features = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SslPoliciesListAvailableFeaturesResponse features.
                         * @member {Array.<string>} features
                         * @memberof google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse
                         * @instance
                         */
                        SslPoliciesListAvailableFeaturesResponse.prototype.features = $util.emptyArray;
    
                        /**
                         * Creates a new SslPoliciesListAvailableFeaturesResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse
                         * @static
                         * @param {google.cloud.compute.v1.ISslPoliciesListAvailableFeaturesResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse} SslPoliciesListAvailableFeaturesResponse instance
                         */
                        SslPoliciesListAvailableFeaturesResponse.create = function create(properties) {
                            return new SslPoliciesListAvailableFeaturesResponse(properties);
                        };
    
                        /**
                         * Encodes the specified SslPoliciesListAvailableFeaturesResponse message. Does not implicitly {@link google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse
                         * @static
                         * @param {google.cloud.compute.v1.ISslPoliciesListAvailableFeaturesResponse} message SslPoliciesListAvailableFeaturesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslPoliciesListAvailableFeaturesResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.features != null && message.features.length)
                                for (var i = 0; i < message.features.length; ++i)
                                    writer.uint32(/* id 246211645, wireType 2 =*/1969693162).string(message.features[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SslPoliciesListAvailableFeaturesResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse
                         * @static
                         * @param {google.cloud.compute.v1.ISslPoliciesListAvailableFeaturesResponse} message SslPoliciesListAvailableFeaturesResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslPoliciesListAvailableFeaturesResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SslPoliciesListAvailableFeaturesResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse} SslPoliciesListAvailableFeaturesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslPoliciesListAvailableFeaturesResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 246211645: {
                                        if (!(message.features && message.features.length))
                                            message.features = [];
                                        message.features.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SslPoliciesListAvailableFeaturesResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse} SslPoliciesListAvailableFeaturesResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslPoliciesListAvailableFeaturesResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SslPoliciesListAvailableFeaturesResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SslPoliciesListAvailableFeaturesResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.features != null && message.hasOwnProperty("features")) {
                                if (!Array.isArray(message.features))
                                    return "features: array expected";
                                for (var i = 0; i < message.features.length; ++i)
                                    if (!$util.isString(message.features[i]))
                                        return "features: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SslPoliciesListAvailableFeaturesResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse} SslPoliciesListAvailableFeaturesResponse
                         */
                        SslPoliciesListAvailableFeaturesResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse();
                            if (object.features) {
                                if (!Array.isArray(object.features))
                                    throw TypeError(".google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse.features: array expected");
                                message.features = [];
                                for (var i = 0; i < object.features.length; ++i)
                                    message.features[i] = String(object.features[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SslPoliciesListAvailableFeaturesResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse
                         * @static
                         * @param {google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse} message SslPoliciesListAvailableFeaturesResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SslPoliciesListAvailableFeaturesResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.features = [];
                            if (message.features && message.features.length) {
                                object.features = [];
                                for (var j = 0; j < message.features.length; ++j)
                                    object.features[j] = message.features[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SslPoliciesListAvailableFeaturesResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SslPoliciesListAvailableFeaturesResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SslPoliciesListAvailableFeaturesResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SslPoliciesListAvailableFeaturesResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse";
                        };
    
                        return SslPoliciesListAvailableFeaturesResponse;
                    })();
    
                    v1.SslPoliciesScopedList = (function() {
    
                        /**
                         * Properties of a SslPoliciesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface ISslPoliciesScopedList
                         * @property {Array.<google.cloud.compute.v1.ISslPolicy>|null} [sslPolicies] SslPoliciesScopedList sslPolicies
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] SslPoliciesScopedList warning
                         */
    
                        /**
                         * Constructs a new SslPoliciesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SslPoliciesScopedList.
                         * @implements ISslPoliciesScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.ISslPoliciesScopedList=} [properties] Properties to set
                         */
                        function SslPoliciesScopedList(properties) {
                            this.sslPolicies = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SslPoliciesScopedList sslPolicies.
                         * @member {Array.<google.cloud.compute.v1.ISslPolicy>} sslPolicies
                         * @memberof google.cloud.compute.v1.SslPoliciesScopedList
                         * @instance
                         */
                        SslPoliciesScopedList.prototype.sslPolicies = $util.emptyArray;
    
                        /**
                         * SslPoliciesScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.SslPoliciesScopedList
                         * @instance
                         */
                        SslPoliciesScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SslPoliciesScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.SslPoliciesScopedList
                         * @instance
                         */
                        Object.defineProperty(SslPoliciesScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SslPoliciesScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SslPoliciesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ISslPoliciesScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SslPoliciesScopedList} SslPoliciesScopedList instance
                         */
                        SslPoliciesScopedList.create = function create(properties) {
                            return new SslPoliciesScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified SslPoliciesScopedList message. Does not implicitly {@link google.cloud.compute.v1.SslPoliciesScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SslPoliciesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ISslPoliciesScopedList} message SslPoliciesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslPoliciesScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.sslPolicies != null && message.sslPolicies.length)
                                for (var i = 0; i < message.sslPolicies.length; ++i)
                                    $root.google.cloud.compute.v1.SslPolicy.encode(message.sslPolicies[i], writer.uint32(/* id 209941027, wireType 2 =*/1679528218).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SslPoliciesScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SslPoliciesScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SslPoliciesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ISslPoliciesScopedList} message SslPoliciesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslPoliciesScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SslPoliciesScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SslPoliciesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SslPoliciesScopedList} SslPoliciesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslPoliciesScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SslPoliciesScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 209941027: {
                                        if (!(message.sslPolicies && message.sslPolicies.length))
                                            message.sslPolicies = [];
                                        message.sslPolicies.push($root.google.cloud.compute.v1.SslPolicy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SslPoliciesScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SslPoliciesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SslPoliciesScopedList} SslPoliciesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslPoliciesScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SslPoliciesScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SslPoliciesScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SslPoliciesScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.sslPolicies != null && message.hasOwnProperty("sslPolicies")) {
                                if (!Array.isArray(message.sslPolicies))
                                    return "sslPolicies: array expected";
                                for (var i = 0; i < message.sslPolicies.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.SslPolicy.verify(message.sslPolicies[i]);
                                    if (error)
                                        return "sslPolicies." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SslPoliciesScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SslPoliciesScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SslPoliciesScopedList} SslPoliciesScopedList
                         */
                        SslPoliciesScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SslPoliciesScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SslPoliciesScopedList();
                            if (object.sslPolicies) {
                                if (!Array.isArray(object.sslPolicies))
                                    throw TypeError(".google.cloud.compute.v1.SslPoliciesScopedList.sslPolicies: array expected");
                                message.sslPolicies = [];
                                for (var i = 0; i < object.sslPolicies.length; ++i) {
                                    if (typeof object.sslPolicies[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SslPoliciesScopedList.sslPolicies: object expected");
                                    message.sslPolicies[i] = $root.google.cloud.compute.v1.SslPolicy.fromObject(object.sslPolicies[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SslPoliciesScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SslPoliciesScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SslPoliciesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.SslPoliciesScopedList} message SslPoliciesScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SslPoliciesScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.sslPolicies = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.sslPolicies && message.sslPolicies.length) {
                                object.sslPolicies = [];
                                for (var j = 0; j < message.sslPolicies.length; ++j)
                                    object.sslPolicies[j] = $root.google.cloud.compute.v1.SslPolicy.toObject(message.sslPolicies[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SslPoliciesScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SslPoliciesScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SslPoliciesScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SslPoliciesScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SslPoliciesScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SslPoliciesScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SslPoliciesScopedList";
                        };
    
                        return SslPoliciesScopedList;
                    })();
    
                    v1.SslPolicy = (function() {
    
                        /**
                         * Properties of a SslPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface ISslPolicy
                         * @property {string|null} [creationTimestamp] SslPolicy creationTimestamp
                         * @property {Array.<string>|null} [customFeatures] SslPolicy customFeatures
                         * @property {string|null} [description] SslPolicy description
                         * @property {Array.<string>|null} [enabledFeatures] SslPolicy enabledFeatures
                         * @property {string|null} [fingerprint] SslPolicy fingerprint
                         * @property {number|Long|null} [id] SslPolicy id
                         * @property {string|null} [kind] SslPolicy kind
                         * @property {string|null} [minTlsVersion] SslPolicy minTlsVersion
                         * @property {string|null} [name] SslPolicy name
                         * @property {string|null} [profile] SslPolicy profile
                         * @property {string|null} [region] SslPolicy region
                         * @property {string|null} [selfLink] SslPolicy selfLink
                         * @property {Array.<google.cloud.compute.v1.IWarnings>|null} [warnings] SslPolicy warnings
                         */
    
                        /**
                         * Constructs a new SslPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SslPolicy.
                         * @implements ISslPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.ISslPolicy=} [properties] Properties to set
                         */
                        function SslPolicy(properties) {
                            this.customFeatures = [];
                            this.enabledFeatures = [];
                            this.warnings = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SslPolicy creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        SslPolicy.prototype.creationTimestamp = null;
    
                        /**
                         * SslPolicy customFeatures.
                         * @member {Array.<string>} customFeatures
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        SslPolicy.prototype.customFeatures = $util.emptyArray;
    
                        /**
                         * SslPolicy description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        SslPolicy.prototype.description = null;
    
                        /**
                         * SslPolicy enabledFeatures.
                         * @member {Array.<string>} enabledFeatures
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        SslPolicy.prototype.enabledFeatures = $util.emptyArray;
    
                        /**
                         * SslPolicy fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        SslPolicy.prototype.fingerprint = null;
    
                        /**
                         * SslPolicy id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        SslPolicy.prototype.id = null;
    
                        /**
                         * SslPolicy kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        SslPolicy.prototype.kind = null;
    
                        /**
                         * SslPolicy minTlsVersion.
                         * @member {string|null|undefined} minTlsVersion
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        SslPolicy.prototype.minTlsVersion = null;
    
                        /**
                         * SslPolicy name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        SslPolicy.prototype.name = null;
    
                        /**
                         * SslPolicy profile.
                         * @member {string|null|undefined} profile
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        SslPolicy.prototype.profile = null;
    
                        /**
                         * SslPolicy region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        SslPolicy.prototype.region = null;
    
                        /**
                         * SslPolicy selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        SslPolicy.prototype.selfLink = null;
    
                        /**
                         * SslPolicy warnings.
                         * @member {Array.<google.cloud.compute.v1.IWarnings>} warnings
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        SslPolicy.prototype.warnings = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SslPolicy _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        Object.defineProperty(SslPolicy.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslPolicy _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        Object.defineProperty(SslPolicy.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslPolicy _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        Object.defineProperty(SslPolicy.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslPolicy _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        Object.defineProperty(SslPolicy.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslPolicy _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        Object.defineProperty(SslPolicy.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslPolicy _minTlsVersion.
                         * @member {"minTlsVersion"|undefined} _minTlsVersion
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        Object.defineProperty(SslPolicy.prototype, "_minTlsVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["minTlsVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslPolicy _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        Object.defineProperty(SslPolicy.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslPolicy _profile.
                         * @member {"profile"|undefined} _profile
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        Object.defineProperty(SslPolicy.prototype, "_profile", {
                            get: $util.oneOfGetter($oneOfFields = ["profile"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslPolicy _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        Object.defineProperty(SslPolicy.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SslPolicy _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         */
                        Object.defineProperty(SslPolicy.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SslPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @static
                         * @param {google.cloud.compute.v1.ISslPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SslPolicy} SslPolicy instance
                         */
                        SslPolicy.create = function create(properties) {
                            return new SslPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified SslPolicy message. Does not implicitly {@link google.cloud.compute.v1.SslPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @static
                         * @param {google.cloud.compute.v1.ISslPolicy} message SslPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.minTlsVersion != null && Object.hasOwnProperty.call(message, "minTlsVersion"))
                                writer.uint32(/* id 8155943, wireType 2 =*/65247546).string(message.minTlsVersion);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.customFeatures != null && message.customFeatures.length)
                                for (var i = 0; i < message.customFeatures.length; ++i)
                                    writer.uint32(/* id 34789707, wireType 2 =*/278317658).string(message.customFeatures[i]);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.profile != null && Object.hasOwnProperty.call(message, "profile"))
                                writer.uint32(/* id 227445161, wireType 2 =*/1819561290).string(message.profile);
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.enabledFeatures != null && message.enabledFeatures.length)
                                for (var i = 0; i < message.enabledFeatures.length; ++i)
                                    writer.uint32(/* id 469017467, wireType 2 =*/3752139738).string(message.enabledFeatures[i]);
                            if (message.warnings != null && message.warnings.length)
                                for (var i = 0; i < message.warnings.length; ++i)
                                    $root.google.cloud.compute.v1.Warnings.encode(message.warnings[i], writer.uint32(/* id 498091095, wireType 2 =*/3984728762).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SslPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SslPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @static
                         * @param {google.cloud.compute.v1.ISslPolicy} message SslPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SslPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SslPolicy} SslPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SslPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 34789707: {
                                        if (!(message.customFeatures && message.customFeatures.length))
                                            message.customFeatures = [];
                                        message.customFeatures.push(reader.string());
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 469017467: {
                                        if (!(message.enabledFeatures && message.enabledFeatures.length))
                                            message.enabledFeatures = [];
                                        message.enabledFeatures.push(reader.string());
                                        break;
                                    }
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 8155943: {
                                        message.minTlsVersion = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 227445161: {
                                        message.profile = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 498091095: {
                                        if (!(message.warnings && message.warnings.length))
                                            message.warnings = [];
                                        message.warnings.push($root.google.cloud.compute.v1.Warnings.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SslPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SslPolicy} SslPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SslPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SslPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.customFeatures != null && message.hasOwnProperty("customFeatures")) {
                                if (!Array.isArray(message.customFeatures))
                                    return "customFeatures: array expected";
                                for (var i = 0; i < message.customFeatures.length; ++i)
                                    if (!$util.isString(message.customFeatures[i]))
                                        return "customFeatures: string[] expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.enabledFeatures != null && message.hasOwnProperty("enabledFeatures")) {
                                if (!Array.isArray(message.enabledFeatures))
                                    return "enabledFeatures: array expected";
                                for (var i = 0; i < message.enabledFeatures.length; ++i)
                                    if (!$util.isString(message.enabledFeatures[i]))
                                        return "enabledFeatures: string[] expected";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.minTlsVersion != null && message.hasOwnProperty("minTlsVersion")) {
                                properties._minTlsVersion = 1;
                                if (!$util.isString(message.minTlsVersion))
                                    return "minTlsVersion: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.profile != null && message.hasOwnProperty("profile")) {
                                properties._profile = 1;
                                if (!$util.isString(message.profile))
                                    return "profile: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warnings != null && message.hasOwnProperty("warnings")) {
                                if (!Array.isArray(message.warnings))
                                    return "warnings: array expected";
                                for (var i = 0; i < message.warnings.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Warnings.verify(message.warnings[i]);
                                    if (error)
                                        return "warnings." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SslPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SslPolicy} SslPolicy
                         */
                        SslPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SslPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SslPolicy();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.customFeatures) {
                                if (!Array.isArray(object.customFeatures))
                                    throw TypeError(".google.cloud.compute.v1.SslPolicy.customFeatures: array expected");
                                message.customFeatures = [];
                                for (var i = 0; i < object.customFeatures.length; ++i)
                                    message.customFeatures[i] = String(object.customFeatures[i]);
                            }
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.enabledFeatures) {
                                if (!Array.isArray(object.enabledFeatures))
                                    throw TypeError(".google.cloud.compute.v1.SslPolicy.enabledFeatures: array expected");
                                message.enabledFeatures = [];
                                for (var i = 0; i < object.enabledFeatures.length; ++i)
                                    message.enabledFeatures[i] = String(object.enabledFeatures[i]);
                            }
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.minTlsVersion != null)
                                message.minTlsVersion = String(object.minTlsVersion);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.profile != null)
                                message.profile = String(object.profile);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warnings) {
                                if (!Array.isArray(object.warnings))
                                    throw TypeError(".google.cloud.compute.v1.SslPolicy.warnings: array expected");
                                message.warnings = [];
                                for (var i = 0; i < object.warnings.length; ++i) {
                                    if (typeof object.warnings[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SslPolicy.warnings: object expected");
                                    message.warnings[i] = $root.google.cloud.compute.v1.Warnings.fromObject(object.warnings[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SslPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @static
                         * @param {google.cloud.compute.v1.SslPolicy} message SslPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SslPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.customFeatures = [];
                                object.enabledFeatures = [];
                                object.warnings = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.minTlsVersion != null && message.hasOwnProperty("minTlsVersion")) {
                                object.minTlsVersion = message.minTlsVersion;
                                if (options.oneofs)
                                    object._minTlsVersion = "minTlsVersion";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.customFeatures && message.customFeatures.length) {
                                object.customFeatures = [];
                                for (var j = 0; j < message.customFeatures.length; ++j)
                                    object.customFeatures[j] = message.customFeatures[j];
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.profile != null && message.hasOwnProperty("profile")) {
                                object.profile = message.profile;
                                if (options.oneofs)
                                    object._profile = "profile";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.enabledFeatures && message.enabledFeatures.length) {
                                object.enabledFeatures = [];
                                for (var j = 0; j < message.enabledFeatures.length; ++j)
                                    object.enabledFeatures[j] = message.enabledFeatures[j];
                            }
                            if (message.warnings && message.warnings.length) {
                                object.warnings = [];
                                for (var j = 0; j < message.warnings.length; ++j)
                                    object.warnings[j] = $root.google.cloud.compute.v1.Warnings.toObject(message.warnings[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SslPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SslPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SslPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SslPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SslPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SslPolicy";
                        };
    
                        /**
                         * MinTlsVersion enum.
                         * @name google.cloud.compute.v1.SslPolicy.MinTlsVersion
                         * @enum {number}
                         * @property {number} UNDEFINED_MIN_TLS_VERSION=0 UNDEFINED_MIN_TLS_VERSION value
                         * @property {number} TLS_1_0=33116734 TLS_1_0 value
                         * @property {number} TLS_1_1=33116735 TLS_1_1 value
                         * @property {number} TLS_1_2=33116736 TLS_1_2 value
                         */
                        SslPolicy.MinTlsVersion = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_MIN_TLS_VERSION"] = 0;
                            values[valuesById[33116734] = "TLS_1_0"] = 33116734;
                            values[valuesById[33116735] = "TLS_1_1"] = 33116735;
                            values[valuesById[33116736] = "TLS_1_2"] = 33116736;
                            return values;
                        })();
    
                        /**
                         * Profile enum.
                         * @name google.cloud.compute.v1.SslPolicy.Profile
                         * @enum {number}
                         * @property {number} UNDEFINED_PROFILE=0 UNDEFINED_PROFILE value
                         * @property {number} COMPATIBLE=179357396 COMPATIBLE value
                         * @property {number} CUSTOM=388595569 CUSTOM value
                         * @property {number} MODERN=132013855 MODERN value
                         * @property {number} RESTRICTED=261551195 RESTRICTED value
                         */
                        SslPolicy.Profile = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PROFILE"] = 0;
                            values[valuesById[179357396] = "COMPATIBLE"] = 179357396;
                            values[valuesById[388595569] = "CUSTOM"] = 388595569;
                            values[valuesById[132013855] = "MODERN"] = 132013855;
                            values[valuesById[261551195] = "RESTRICTED"] = 261551195;
                            return values;
                        })();
    
                        return SslPolicy;
                    })();
    
                    v1.SslPolicyReference = (function() {
    
                        /**
                         * Properties of a SslPolicyReference.
                         * @memberof google.cloud.compute.v1
                         * @interface ISslPolicyReference
                         * @property {string|null} [sslPolicy] SslPolicyReference sslPolicy
                         */
    
                        /**
                         * Constructs a new SslPolicyReference.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SslPolicyReference.
                         * @implements ISslPolicyReference
                         * @constructor
                         * @param {google.cloud.compute.v1.ISslPolicyReference=} [properties] Properties to set
                         */
                        function SslPolicyReference(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SslPolicyReference sslPolicy.
                         * @member {string|null|undefined} sslPolicy
                         * @memberof google.cloud.compute.v1.SslPolicyReference
                         * @instance
                         */
                        SslPolicyReference.prototype.sslPolicy = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SslPolicyReference _sslPolicy.
                         * @member {"sslPolicy"|undefined} _sslPolicy
                         * @memberof google.cloud.compute.v1.SslPolicyReference
                         * @instance
                         */
                        Object.defineProperty(SslPolicyReference.prototype, "_sslPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["sslPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SslPolicyReference instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SslPolicyReference
                         * @static
                         * @param {google.cloud.compute.v1.ISslPolicyReference=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SslPolicyReference} SslPolicyReference instance
                         */
                        SslPolicyReference.create = function create(properties) {
                            return new SslPolicyReference(properties);
                        };
    
                        /**
                         * Encodes the specified SslPolicyReference message. Does not implicitly {@link google.cloud.compute.v1.SslPolicyReference.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SslPolicyReference
                         * @static
                         * @param {google.cloud.compute.v1.ISslPolicyReference} message SslPolicyReference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslPolicyReference.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.sslPolicy != null && Object.hasOwnProperty.call(message, "sslPolicy"))
                                writer.uint32(/* id 295190213, wireType 2 =*/2361521706).string(message.sslPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SslPolicyReference message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SslPolicyReference.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SslPolicyReference
                         * @static
                         * @param {google.cloud.compute.v1.ISslPolicyReference} message SslPolicyReference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SslPolicyReference.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SslPolicyReference message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SslPolicyReference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SslPolicyReference} SslPolicyReference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslPolicyReference.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SslPolicyReference();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 295190213: {
                                        message.sslPolicy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SslPolicyReference message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SslPolicyReference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SslPolicyReference} SslPolicyReference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SslPolicyReference.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SslPolicyReference message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SslPolicyReference
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SslPolicyReference.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.sslPolicy != null && message.hasOwnProperty("sslPolicy")) {
                                properties._sslPolicy = 1;
                                if (!$util.isString(message.sslPolicy))
                                    return "sslPolicy: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SslPolicyReference message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SslPolicyReference
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SslPolicyReference} SslPolicyReference
                         */
                        SslPolicyReference.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SslPolicyReference)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SslPolicyReference();
                            if (object.sslPolicy != null)
                                message.sslPolicy = String(object.sslPolicy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SslPolicyReference message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SslPolicyReference
                         * @static
                         * @param {google.cloud.compute.v1.SslPolicyReference} message SslPolicyReference
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SslPolicyReference.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.sslPolicy != null && message.hasOwnProperty("sslPolicy")) {
                                object.sslPolicy = message.sslPolicy;
                                if (options.oneofs)
                                    object._sslPolicy = "sslPolicy";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SslPolicyReference to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SslPolicyReference
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SslPolicyReference.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SslPolicyReference
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SslPolicyReference
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SslPolicyReference.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SslPolicyReference";
                        };
    
                        return SslPolicyReference;
                    })();
    
                    v1.StartInstanceRequest = (function() {
    
                        /**
                         * Properties of a StartInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IStartInstanceRequest
                         * @property {string|null} [instance] StartInstanceRequest instance
                         * @property {string|null} [project] StartInstanceRequest project
                         * @property {string|null} [requestId] StartInstanceRequest requestId
                         * @property {string|null} [zone] StartInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new StartInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a StartInstanceRequest.
                         * @implements IStartInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IStartInstanceRequest=} [properties] Properties to set
                         */
                        function StartInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * StartInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.StartInstanceRequest
                         * @instance
                         */
                        StartInstanceRequest.prototype.instance = "";
    
                        /**
                         * StartInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.StartInstanceRequest
                         * @instance
                         */
                        StartInstanceRequest.prototype.project = "";
    
                        /**
                         * StartInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.StartInstanceRequest
                         * @instance
                         */
                        StartInstanceRequest.prototype.requestId = null;
    
                        /**
                         * StartInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.StartInstanceRequest
                         * @instance
                         */
                        StartInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * StartInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.StartInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(StartInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new StartInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.StartInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IStartInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.StartInstanceRequest} StartInstanceRequest instance
                         */
                        StartInstanceRequest.create = function create(properties) {
                            return new StartInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified StartInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.StartInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.StartInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IStartInstanceRequest} message StartInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        StartInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified StartInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.StartInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.StartInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IStartInstanceRequest} message StartInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        StartInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a StartInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.StartInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.StartInstanceRequest} StartInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        StartInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.StartInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a StartInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.StartInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.StartInstanceRequest} StartInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        StartInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a StartInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.StartInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        StartInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a StartInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.StartInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.StartInstanceRequest} StartInstanceRequest
                         */
                        StartInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.StartInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.StartInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a StartInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.StartInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.StartInstanceRequest} message StartInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        StartInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this StartInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.StartInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        StartInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for StartInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.StartInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        StartInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.StartInstanceRequest";
                        };
    
                        return StartInstanceRequest;
                    })();
    
                    v1.StartWithEncryptionKeyInstanceRequest = (function() {
    
                        /**
                         * Properties of a StartWithEncryptionKeyInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IStartWithEncryptionKeyInstanceRequest
                         * @property {string|null} [instance] StartWithEncryptionKeyInstanceRequest instance
                         * @property {google.cloud.compute.v1.IInstancesStartWithEncryptionKeyRequest|null} [instancesStartWithEncryptionKeyRequestResource] StartWithEncryptionKeyInstanceRequest instancesStartWithEncryptionKeyRequestResource
                         * @property {string|null} [project] StartWithEncryptionKeyInstanceRequest project
                         * @property {string|null} [requestId] StartWithEncryptionKeyInstanceRequest requestId
                         * @property {string|null} [zone] StartWithEncryptionKeyInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new StartWithEncryptionKeyInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a StartWithEncryptionKeyInstanceRequest.
                         * @implements IStartWithEncryptionKeyInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IStartWithEncryptionKeyInstanceRequest=} [properties] Properties to set
                         */
                        function StartWithEncryptionKeyInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * StartWithEncryptionKeyInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest
                         * @instance
                         */
                        StartWithEncryptionKeyInstanceRequest.prototype.instance = "";
    
                        /**
                         * StartWithEncryptionKeyInstanceRequest instancesStartWithEncryptionKeyRequestResource.
                         * @member {google.cloud.compute.v1.IInstancesStartWithEncryptionKeyRequest|null|undefined} instancesStartWithEncryptionKeyRequestResource
                         * @memberof google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest
                         * @instance
                         */
                        StartWithEncryptionKeyInstanceRequest.prototype.instancesStartWithEncryptionKeyRequestResource = null;
    
                        /**
                         * StartWithEncryptionKeyInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest
                         * @instance
                         */
                        StartWithEncryptionKeyInstanceRequest.prototype.project = "";
    
                        /**
                         * StartWithEncryptionKeyInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest
                         * @instance
                         */
                        StartWithEncryptionKeyInstanceRequest.prototype.requestId = null;
    
                        /**
                         * StartWithEncryptionKeyInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest
                         * @instance
                         */
                        StartWithEncryptionKeyInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * StartWithEncryptionKeyInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(StartWithEncryptionKeyInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new StartWithEncryptionKeyInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IStartWithEncryptionKeyInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest} StartWithEncryptionKeyInstanceRequest instance
                         */
                        StartWithEncryptionKeyInstanceRequest.create = function create(properties) {
                            return new StartWithEncryptionKeyInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified StartWithEncryptionKeyInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IStartWithEncryptionKeyInstanceRequest} message StartWithEncryptionKeyInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        StartWithEncryptionKeyInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instancesStartWithEncryptionKeyRequestResource != null && Object.hasOwnProperty.call(message, "instancesStartWithEncryptionKeyRequestResource"))
                                $root.google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest.encode(message.instancesStartWithEncryptionKeyRequestResource, writer.uint32(/* id 441712511, wireType 2 =*/3533700090).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified StartWithEncryptionKeyInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IStartWithEncryptionKeyInstanceRequest} message StartWithEncryptionKeyInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        StartWithEncryptionKeyInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a StartWithEncryptionKeyInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest} StartWithEncryptionKeyInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        StartWithEncryptionKeyInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 441712511: {
                                        message.instancesStartWithEncryptionKeyRequestResource = $root.google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a StartWithEncryptionKeyInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest} StartWithEncryptionKeyInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        StartWithEncryptionKeyInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a StartWithEncryptionKeyInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        StartWithEncryptionKeyInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.instancesStartWithEncryptionKeyRequestResource != null && message.hasOwnProperty("instancesStartWithEncryptionKeyRequestResource")) {
                                var error = $root.google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest.verify(message.instancesStartWithEncryptionKeyRequestResource);
                                if (error)
                                    return "instancesStartWithEncryptionKeyRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a StartWithEncryptionKeyInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest} StartWithEncryptionKeyInstanceRequest
                         */
                        StartWithEncryptionKeyInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.instancesStartWithEncryptionKeyRequestResource != null) {
                                if (typeof object.instancesStartWithEncryptionKeyRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest.instancesStartWithEncryptionKeyRequestResource: object expected");
                                message.instancesStartWithEncryptionKeyRequestResource = $root.google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest.fromObject(object.instancesStartWithEncryptionKeyRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a StartWithEncryptionKeyInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest} message StartWithEncryptionKeyInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        StartWithEncryptionKeyInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                                object.instancesStartWithEncryptionKeyRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instancesStartWithEncryptionKeyRequestResource != null && message.hasOwnProperty("instancesStartWithEncryptionKeyRequestResource"))
                                object.instancesStartWithEncryptionKeyRequestResource = $root.google.cloud.compute.v1.InstancesStartWithEncryptionKeyRequest.toObject(message.instancesStartWithEncryptionKeyRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this StartWithEncryptionKeyInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        StartWithEncryptionKeyInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for StartWithEncryptionKeyInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        StartWithEncryptionKeyInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest";
                        };
    
                        return StartWithEncryptionKeyInstanceRequest;
                    })();
    
                    v1.StatefulPolicy = (function() {
    
                        /**
                         * Properties of a StatefulPolicy.
                         * @memberof google.cloud.compute.v1
                         * @interface IStatefulPolicy
                         * @property {google.cloud.compute.v1.IStatefulPolicyPreservedState|null} [preservedState] StatefulPolicy preservedState
                         */
    
                        /**
                         * Constructs a new StatefulPolicy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a StatefulPolicy.
                         * @implements IStatefulPolicy
                         * @constructor
                         * @param {google.cloud.compute.v1.IStatefulPolicy=} [properties] Properties to set
                         */
                        function StatefulPolicy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * StatefulPolicy preservedState.
                         * @member {google.cloud.compute.v1.IStatefulPolicyPreservedState|null|undefined} preservedState
                         * @memberof google.cloud.compute.v1.StatefulPolicy
                         * @instance
                         */
                        StatefulPolicy.prototype.preservedState = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * StatefulPolicy _preservedState.
                         * @member {"preservedState"|undefined} _preservedState
                         * @memberof google.cloud.compute.v1.StatefulPolicy
                         * @instance
                         */
                        Object.defineProperty(StatefulPolicy.prototype, "_preservedState", {
                            get: $util.oneOfGetter($oneOfFields = ["preservedState"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new StatefulPolicy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.StatefulPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IStatefulPolicy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.StatefulPolicy} StatefulPolicy instance
                         */
                        StatefulPolicy.create = function create(properties) {
                            return new StatefulPolicy(properties);
                        };
    
                        /**
                         * Encodes the specified StatefulPolicy message. Does not implicitly {@link google.cloud.compute.v1.StatefulPolicy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.StatefulPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IStatefulPolicy} message StatefulPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        StatefulPolicy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.preservedState != null && Object.hasOwnProperty.call(message, "preservedState"))
                                $root.google.cloud.compute.v1.StatefulPolicyPreservedState.encode(message.preservedState, writer.uint32(/* id 2634026, wireType 2 =*/21072210).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified StatefulPolicy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.StatefulPolicy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.StatefulPolicy
                         * @static
                         * @param {google.cloud.compute.v1.IStatefulPolicy} message StatefulPolicy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        StatefulPolicy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a StatefulPolicy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.StatefulPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.StatefulPolicy} StatefulPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        StatefulPolicy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.StatefulPolicy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 2634026: {
                                        message.preservedState = $root.google.cloud.compute.v1.StatefulPolicyPreservedState.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a StatefulPolicy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.StatefulPolicy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.StatefulPolicy} StatefulPolicy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        StatefulPolicy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a StatefulPolicy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.StatefulPolicy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        StatefulPolicy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.preservedState != null && message.hasOwnProperty("preservedState")) {
                                properties._preservedState = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.StatefulPolicyPreservedState.verify(message.preservedState);
                                    if (error)
                                        return "preservedState." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a StatefulPolicy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.StatefulPolicy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.StatefulPolicy} StatefulPolicy
                         */
                        StatefulPolicy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.StatefulPolicy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.StatefulPolicy();
                            if (object.preservedState != null) {
                                if (typeof object.preservedState !== "object")
                                    throw TypeError(".google.cloud.compute.v1.StatefulPolicy.preservedState: object expected");
                                message.preservedState = $root.google.cloud.compute.v1.StatefulPolicyPreservedState.fromObject(object.preservedState);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a StatefulPolicy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.StatefulPolicy
                         * @static
                         * @param {google.cloud.compute.v1.StatefulPolicy} message StatefulPolicy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        StatefulPolicy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.preservedState != null && message.hasOwnProperty("preservedState")) {
                                object.preservedState = $root.google.cloud.compute.v1.StatefulPolicyPreservedState.toObject(message.preservedState, options);
                                if (options.oneofs)
                                    object._preservedState = "preservedState";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this StatefulPolicy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.StatefulPolicy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        StatefulPolicy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for StatefulPolicy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.StatefulPolicy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        StatefulPolicy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.StatefulPolicy";
                        };
    
                        return StatefulPolicy;
                    })();
    
                    v1.StatefulPolicyPreservedState = (function() {
    
                        /**
                         * Properties of a StatefulPolicyPreservedState.
                         * @memberof google.cloud.compute.v1
                         * @interface IStatefulPolicyPreservedState
                         * @property {Object.<string,google.cloud.compute.v1.IStatefulPolicyPreservedStateDiskDevice>|null} [disks] StatefulPolicyPreservedState disks
                         */
    
                        /**
                         * Constructs a new StatefulPolicyPreservedState.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a StatefulPolicyPreservedState.
                         * @implements IStatefulPolicyPreservedState
                         * @constructor
                         * @param {google.cloud.compute.v1.IStatefulPolicyPreservedState=} [properties] Properties to set
                         */
                        function StatefulPolicyPreservedState(properties) {
                            this.disks = {};
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * StatefulPolicyPreservedState disks.
                         * @member {Object.<string,google.cloud.compute.v1.IStatefulPolicyPreservedStateDiskDevice>} disks
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedState
                         * @instance
                         */
                        StatefulPolicyPreservedState.prototype.disks = $util.emptyObject;
    
                        /**
                         * Creates a new StatefulPolicyPreservedState instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedState
                         * @static
                         * @param {google.cloud.compute.v1.IStatefulPolicyPreservedState=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.StatefulPolicyPreservedState} StatefulPolicyPreservedState instance
                         */
                        StatefulPolicyPreservedState.create = function create(properties) {
                            return new StatefulPolicyPreservedState(properties);
                        };
    
                        /**
                         * Encodes the specified StatefulPolicyPreservedState message. Does not implicitly {@link google.cloud.compute.v1.StatefulPolicyPreservedState.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedState
                         * @static
                         * @param {google.cloud.compute.v1.IStatefulPolicyPreservedState} message StatefulPolicyPreservedState message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        StatefulPolicyPreservedState.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.disks != null && Object.hasOwnProperty.call(message, "disks"))
                                for (var keys = Object.keys(message.disks), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 95594102, wireType 2 =*/764752818).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice.encode(message.disks[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            return writer;
                        };
    
                        /**
                         * Encodes the specified StatefulPolicyPreservedState message, length delimited. Does not implicitly {@link google.cloud.compute.v1.StatefulPolicyPreservedState.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedState
                         * @static
                         * @param {google.cloud.compute.v1.IStatefulPolicyPreservedState} message StatefulPolicyPreservedState message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        StatefulPolicyPreservedState.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a StatefulPolicyPreservedState message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedState
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.StatefulPolicyPreservedState} StatefulPolicyPreservedState
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        StatefulPolicyPreservedState.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.StatefulPolicyPreservedState(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 95594102: {
                                        if (message.disks === $util.emptyObject)
                                            message.disks = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.disks[key] = value;
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a StatefulPolicyPreservedState message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedState
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.StatefulPolicyPreservedState} StatefulPolicyPreservedState
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        StatefulPolicyPreservedState.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a StatefulPolicyPreservedState message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedState
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        StatefulPolicyPreservedState.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.disks != null && message.hasOwnProperty("disks")) {
                                if (!$util.isObject(message.disks))
                                    return "disks: object expected";
                                var key = Object.keys(message.disks);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice.verify(message.disks[key[i]]);
                                    if (error)
                                        return "disks." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a StatefulPolicyPreservedState message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedState
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.StatefulPolicyPreservedState} StatefulPolicyPreservedState
                         */
                        StatefulPolicyPreservedState.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.StatefulPolicyPreservedState)
                                return object;
                            var message = new $root.google.cloud.compute.v1.StatefulPolicyPreservedState();
                            if (object.disks) {
                                if (typeof object.disks !== "object")
                                    throw TypeError(".google.cloud.compute.v1.StatefulPolicyPreservedState.disks: object expected");
                                message.disks = {};
                                for (var keys = Object.keys(object.disks), i = 0; i < keys.length; ++i) {
                                    if (typeof object.disks[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.StatefulPolicyPreservedState.disks: object expected");
                                    message.disks[keys[i]] = $root.google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice.fromObject(object.disks[keys[i]]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a StatefulPolicyPreservedState message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedState
                         * @static
                         * @param {google.cloud.compute.v1.StatefulPolicyPreservedState} message StatefulPolicyPreservedState
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        StatefulPolicyPreservedState.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.objects || options.defaults)
                                object.disks = {};
                            var keys2;
                            if (message.disks && (keys2 = Object.keys(message.disks)).length) {
                                object.disks = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.disks[keys2[j]] = $root.google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice.toObject(message.disks[keys2[j]], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this StatefulPolicyPreservedState to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedState
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        StatefulPolicyPreservedState.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for StatefulPolicyPreservedState
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedState
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        StatefulPolicyPreservedState.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.StatefulPolicyPreservedState";
                        };
    
                        return StatefulPolicyPreservedState;
                    })();
    
                    v1.StatefulPolicyPreservedStateDiskDevice = (function() {
    
                        /**
                         * Properties of a StatefulPolicyPreservedStateDiskDevice.
                         * @memberof google.cloud.compute.v1
                         * @interface IStatefulPolicyPreservedStateDiskDevice
                         * @property {string|null} [autoDelete] StatefulPolicyPreservedStateDiskDevice autoDelete
                         */
    
                        /**
                         * Constructs a new StatefulPolicyPreservedStateDiskDevice.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a StatefulPolicyPreservedStateDiskDevice.
                         * @implements IStatefulPolicyPreservedStateDiskDevice
                         * @constructor
                         * @param {google.cloud.compute.v1.IStatefulPolicyPreservedStateDiskDevice=} [properties] Properties to set
                         */
                        function StatefulPolicyPreservedStateDiskDevice(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * StatefulPolicyPreservedStateDiskDevice autoDelete.
                         * @member {string|null|undefined} autoDelete
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice
                         * @instance
                         */
                        StatefulPolicyPreservedStateDiskDevice.prototype.autoDelete = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * StatefulPolicyPreservedStateDiskDevice _autoDelete.
                         * @member {"autoDelete"|undefined} _autoDelete
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice
                         * @instance
                         */
                        Object.defineProperty(StatefulPolicyPreservedStateDiskDevice.prototype, "_autoDelete", {
                            get: $util.oneOfGetter($oneOfFields = ["autoDelete"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new StatefulPolicyPreservedStateDiskDevice instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice
                         * @static
                         * @param {google.cloud.compute.v1.IStatefulPolicyPreservedStateDiskDevice=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice} StatefulPolicyPreservedStateDiskDevice instance
                         */
                        StatefulPolicyPreservedStateDiskDevice.create = function create(properties) {
                            return new StatefulPolicyPreservedStateDiskDevice(properties);
                        };
    
                        /**
                         * Encodes the specified StatefulPolicyPreservedStateDiskDevice message. Does not implicitly {@link google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice
                         * @static
                         * @param {google.cloud.compute.v1.IStatefulPolicyPreservedStateDiskDevice} message StatefulPolicyPreservedStateDiskDevice message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        StatefulPolicyPreservedStateDiskDevice.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.autoDelete != null && Object.hasOwnProperty.call(message, "autoDelete"))
                                writer.uint32(/* id 464761403, wireType 2 =*/3718091226).string(message.autoDelete);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified StatefulPolicyPreservedStateDiskDevice message, length delimited. Does not implicitly {@link google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice
                         * @static
                         * @param {google.cloud.compute.v1.IStatefulPolicyPreservedStateDiskDevice} message StatefulPolicyPreservedStateDiskDevice message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        StatefulPolicyPreservedStateDiskDevice.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a StatefulPolicyPreservedStateDiskDevice message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice} StatefulPolicyPreservedStateDiskDevice
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        StatefulPolicyPreservedStateDiskDevice.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 464761403: {
                                        message.autoDelete = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a StatefulPolicyPreservedStateDiskDevice message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice} StatefulPolicyPreservedStateDiskDevice
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        StatefulPolicyPreservedStateDiskDevice.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a StatefulPolicyPreservedStateDiskDevice message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        StatefulPolicyPreservedStateDiskDevice.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoDelete != null && message.hasOwnProperty("autoDelete")) {
                                properties._autoDelete = 1;
                                if (!$util.isString(message.autoDelete))
                                    return "autoDelete: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a StatefulPolicyPreservedStateDiskDevice message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice} StatefulPolicyPreservedStateDiskDevice
                         */
                        StatefulPolicyPreservedStateDiskDevice.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice)
                                return object;
                            var message = new $root.google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice();
                            if (object.autoDelete != null)
                                message.autoDelete = String(object.autoDelete);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a StatefulPolicyPreservedStateDiskDevice message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice
                         * @static
                         * @param {google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice} message StatefulPolicyPreservedStateDiskDevice
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        StatefulPolicyPreservedStateDiskDevice.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.autoDelete != null && message.hasOwnProperty("autoDelete")) {
                                object.autoDelete = message.autoDelete;
                                if (options.oneofs)
                                    object._autoDelete = "autoDelete";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this StatefulPolicyPreservedStateDiskDevice to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        StatefulPolicyPreservedStateDiskDevice.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for StatefulPolicyPreservedStateDiskDevice
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        StatefulPolicyPreservedStateDiskDevice.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice";
                        };
    
                        /**
                         * AutoDelete enum.
                         * @name google.cloud.compute.v1.StatefulPolicyPreservedStateDiskDevice.AutoDelete
                         * @enum {number}
                         * @property {number} UNDEFINED_AUTO_DELETE=0 UNDEFINED_AUTO_DELETE value
                         * @property {number} NEVER=74175084 NEVER value
                         * @property {number} ON_PERMANENT_INSTANCE_DELETION=95727719 ON_PERMANENT_INSTANCE_DELETION value
                         */
                        StatefulPolicyPreservedStateDiskDevice.AutoDelete = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_AUTO_DELETE"] = 0;
                            values[valuesById[74175084] = "NEVER"] = 74175084;
                            values[valuesById[95727719] = "ON_PERMANENT_INSTANCE_DELETION"] = 95727719;
                            return values;
                        })();
    
                        return StatefulPolicyPreservedStateDiskDevice;
                    })();
    
                    v1.StopInstanceRequest = (function() {
    
                        /**
                         * Properties of a StopInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IStopInstanceRequest
                         * @property {string|null} [instance] StopInstanceRequest instance
                         * @property {string|null} [project] StopInstanceRequest project
                         * @property {string|null} [requestId] StopInstanceRequest requestId
                         * @property {string|null} [zone] StopInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new StopInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a StopInstanceRequest.
                         * @implements IStopInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IStopInstanceRequest=} [properties] Properties to set
                         */
                        function StopInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * StopInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.StopInstanceRequest
                         * @instance
                         */
                        StopInstanceRequest.prototype.instance = "";
    
                        /**
                         * StopInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.StopInstanceRequest
                         * @instance
                         */
                        StopInstanceRequest.prototype.project = "";
    
                        /**
                         * StopInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.StopInstanceRequest
                         * @instance
                         */
                        StopInstanceRequest.prototype.requestId = null;
    
                        /**
                         * StopInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.StopInstanceRequest
                         * @instance
                         */
                        StopInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * StopInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.StopInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(StopInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new StopInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.StopInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IStopInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.StopInstanceRequest} StopInstanceRequest instance
                         */
                        StopInstanceRequest.create = function create(properties) {
                            return new StopInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified StopInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.StopInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.StopInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IStopInstanceRequest} message StopInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        StopInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified StopInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.StopInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.StopInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IStopInstanceRequest} message StopInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        StopInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a StopInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.StopInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.StopInstanceRequest} StopInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        StopInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.StopInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a StopInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.StopInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.StopInstanceRequest} StopInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        StopInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a StopInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.StopInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        StopInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a StopInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.StopInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.StopInstanceRequest} StopInstanceRequest
                         */
                        StopInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.StopInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.StopInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a StopInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.StopInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.StopInstanceRequest} message StopInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        StopInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this StopInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.StopInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        StopInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for StopInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.StopInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        StopInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.StopInstanceRequest";
                        };
    
                        return StopInstanceRequest;
                    })();
    
                    v1.Subnetwork = (function() {
    
                        /**
                         * Properties of a Subnetwork.
                         * @memberof google.cloud.compute.v1
                         * @interface ISubnetwork
                         * @property {string|null} [creationTimestamp] Subnetwork creationTimestamp
                         * @property {string|null} [description] Subnetwork description
                         * @property {boolean|null} [enableFlowLogs] Subnetwork enableFlowLogs
                         * @property {string|null} [externalIpv6Prefix] Subnetwork externalIpv6Prefix
                         * @property {string|null} [fingerprint] Subnetwork fingerprint
                         * @property {string|null} [gatewayAddress] Subnetwork gatewayAddress
                         * @property {number|Long|null} [id] Subnetwork id
                         * @property {string|null} [internalIpv6Prefix] Subnetwork internalIpv6Prefix
                         * @property {string|null} [ipCidrRange] Subnetwork ipCidrRange
                         * @property {string|null} [ipv6AccessType] Subnetwork ipv6AccessType
                         * @property {string|null} [ipv6CidrRange] Subnetwork ipv6CidrRange
                         * @property {string|null} [kind] Subnetwork kind
                         * @property {google.cloud.compute.v1.ISubnetworkLogConfig|null} [logConfig] Subnetwork logConfig
                         * @property {string|null} [name] Subnetwork name
                         * @property {string|null} [network] Subnetwork network
                         * @property {boolean|null} [privateIpGoogleAccess] Subnetwork privateIpGoogleAccess
                         * @property {string|null} [privateIpv6GoogleAccess] Subnetwork privateIpv6GoogleAccess
                         * @property {string|null} [purpose] Subnetwork purpose
                         * @property {string|null} [region] Subnetwork region
                         * @property {string|null} [role] Subnetwork role
                         * @property {Array.<google.cloud.compute.v1.ISubnetworkSecondaryRange>|null} [secondaryIpRanges] Subnetwork secondaryIpRanges
                         * @property {string|null} [selfLink] Subnetwork selfLink
                         * @property {string|null} [stackType] Subnetwork stackType
                         * @property {string|null} [state] Subnetwork state
                         */
    
                        /**
                         * Constructs a new Subnetwork.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Subnetwork.
                         * @implements ISubnetwork
                         * @constructor
                         * @param {google.cloud.compute.v1.ISubnetwork=} [properties] Properties to set
                         */
                        function Subnetwork(properties) {
                            this.secondaryIpRanges = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Subnetwork creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.creationTimestamp = null;
    
                        /**
                         * Subnetwork description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.description = null;
    
                        /**
                         * Subnetwork enableFlowLogs.
                         * @member {boolean|null|undefined} enableFlowLogs
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.enableFlowLogs = null;
    
                        /**
                         * Subnetwork externalIpv6Prefix.
                         * @member {string|null|undefined} externalIpv6Prefix
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.externalIpv6Prefix = null;
    
                        /**
                         * Subnetwork fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.fingerprint = null;
    
                        /**
                         * Subnetwork gatewayAddress.
                         * @member {string|null|undefined} gatewayAddress
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.gatewayAddress = null;
    
                        /**
                         * Subnetwork id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.id = null;
    
                        /**
                         * Subnetwork internalIpv6Prefix.
                         * @member {string|null|undefined} internalIpv6Prefix
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.internalIpv6Prefix = null;
    
                        /**
                         * Subnetwork ipCidrRange.
                         * @member {string|null|undefined} ipCidrRange
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.ipCidrRange = null;
    
                        /**
                         * Subnetwork ipv6AccessType.
                         * @member {string|null|undefined} ipv6AccessType
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.ipv6AccessType = null;
    
                        /**
                         * Subnetwork ipv6CidrRange.
                         * @member {string|null|undefined} ipv6CidrRange
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.ipv6CidrRange = null;
    
                        /**
                         * Subnetwork kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.kind = null;
    
                        /**
                         * Subnetwork logConfig.
                         * @member {google.cloud.compute.v1.ISubnetworkLogConfig|null|undefined} logConfig
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.logConfig = null;
    
                        /**
                         * Subnetwork name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.name = null;
    
                        /**
                         * Subnetwork network.
                         * @member {string|null|undefined} network
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.network = null;
    
                        /**
                         * Subnetwork privateIpGoogleAccess.
                         * @member {boolean|null|undefined} privateIpGoogleAccess
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.privateIpGoogleAccess = null;
    
                        /**
                         * Subnetwork privateIpv6GoogleAccess.
                         * @member {string|null|undefined} privateIpv6GoogleAccess
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.privateIpv6GoogleAccess = null;
    
                        /**
                         * Subnetwork purpose.
                         * @member {string|null|undefined} purpose
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.purpose = null;
    
                        /**
                         * Subnetwork region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.region = null;
    
                        /**
                         * Subnetwork role.
                         * @member {string|null|undefined} role
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.role = null;
    
                        /**
                         * Subnetwork secondaryIpRanges.
                         * @member {Array.<google.cloud.compute.v1.ISubnetworkSecondaryRange>} secondaryIpRanges
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.secondaryIpRanges = $util.emptyArray;
    
                        /**
                         * Subnetwork selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.selfLink = null;
    
                        /**
                         * Subnetwork stackType.
                         * @member {string|null|undefined} stackType
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.stackType = null;
    
                        /**
                         * Subnetwork state.
                         * @member {string|null|undefined} state
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Subnetwork.prototype.state = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Subnetwork _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _enableFlowLogs.
                         * @member {"enableFlowLogs"|undefined} _enableFlowLogs
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_enableFlowLogs", {
                            get: $util.oneOfGetter($oneOfFields = ["enableFlowLogs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _externalIpv6Prefix.
                         * @member {"externalIpv6Prefix"|undefined} _externalIpv6Prefix
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_externalIpv6Prefix", {
                            get: $util.oneOfGetter($oneOfFields = ["externalIpv6Prefix"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _gatewayAddress.
                         * @member {"gatewayAddress"|undefined} _gatewayAddress
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_gatewayAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["gatewayAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _internalIpv6Prefix.
                         * @member {"internalIpv6Prefix"|undefined} _internalIpv6Prefix
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_internalIpv6Prefix", {
                            get: $util.oneOfGetter($oneOfFields = ["internalIpv6Prefix"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _ipCidrRange.
                         * @member {"ipCidrRange"|undefined} _ipCidrRange
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_ipCidrRange", {
                            get: $util.oneOfGetter($oneOfFields = ["ipCidrRange"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _ipv6AccessType.
                         * @member {"ipv6AccessType"|undefined} _ipv6AccessType
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_ipv6AccessType", {
                            get: $util.oneOfGetter($oneOfFields = ["ipv6AccessType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _ipv6CidrRange.
                         * @member {"ipv6CidrRange"|undefined} _ipv6CidrRange
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_ipv6CidrRange", {
                            get: $util.oneOfGetter($oneOfFields = ["ipv6CidrRange"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _logConfig.
                         * @member {"logConfig"|undefined} _logConfig
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_logConfig", {
                            get: $util.oneOfGetter($oneOfFields = ["logConfig"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _network.
                         * @member {"network"|undefined} _network
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_network", {
                            get: $util.oneOfGetter($oneOfFields = ["network"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _privateIpGoogleAccess.
                         * @member {"privateIpGoogleAccess"|undefined} _privateIpGoogleAccess
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_privateIpGoogleAccess", {
                            get: $util.oneOfGetter($oneOfFields = ["privateIpGoogleAccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _privateIpv6GoogleAccess.
                         * @member {"privateIpv6GoogleAccess"|undefined} _privateIpv6GoogleAccess
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_privateIpv6GoogleAccess", {
                            get: $util.oneOfGetter($oneOfFields = ["privateIpv6GoogleAccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _purpose.
                         * @member {"purpose"|undefined} _purpose
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_purpose", {
                            get: $util.oneOfGetter($oneOfFields = ["purpose"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _role.
                         * @member {"role"|undefined} _role
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_role", {
                            get: $util.oneOfGetter($oneOfFields = ["role"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _stackType.
                         * @member {"stackType"|undefined} _stackType
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_stackType", {
                            get: $util.oneOfGetter($oneOfFields = ["stackType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Subnetwork _state.
                         * @member {"state"|undefined} _state
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         */
                        Object.defineProperty(Subnetwork.prototype, "_state", {
                            get: $util.oneOfGetter($oneOfFields = ["state"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Subnetwork instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetwork=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Subnetwork} Subnetwork instance
                         */
                        Subnetwork.create = function create(properties) {
                            return new Subnetwork(properties);
                        };
    
                        /**
                         * Encodes the specified Subnetwork message. Does not implicitly {@link google.cloud.compute.v1.Subnetwork.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetwork} message Subnetwork message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Subnetwork.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.role != null && Object.hasOwnProperty.call(message, "role"))
                                writer.uint32(/* id 3506294, wireType 2 =*/28050354).string(message.role);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.privateIpv6GoogleAccess != null && Object.hasOwnProperty.call(message, "privateIpv6GoogleAccess"))
                                writer.uint32(/* id 48277006, wireType 2 =*/386216050).string(message.privateIpv6GoogleAccess);
                            if (message.ipCidrRange != null && Object.hasOwnProperty.call(message, "ipCidrRange"))
                                writer.uint32(/* id 98117322, wireType 2 =*/784938578).string(message.ipCidrRange);
                            if (message.state != null && Object.hasOwnProperty.call(message, "state"))
                                writer.uint32(/* id 109757585, wireType 2 =*/878060682).string(message.state);
                            if (message.secondaryIpRanges != null && message.secondaryIpRanges.length)
                                for (var i = 0; i < message.secondaryIpRanges.length; ++i)
                                    $root.google.cloud.compute.v1.SubnetworkSecondaryRange.encode(message.secondaryIpRanges[i], writer.uint32(/* id 136658915, wireType 2 =*/1093271322).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.externalIpv6Prefix != null && Object.hasOwnProperty.call(message, "externalIpv6Prefix"))
                                writer.uint32(/* id 139299190, wireType 2 =*/1114393522).string(message.externalIpv6Prefix);
                            if (message.enableFlowLogs != null && Object.hasOwnProperty.call(message, "enableFlowLogs"))
                                writer.uint32(/* id 151544420, wireType 0 =*/1212355360).bool(message.enableFlowLogs);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.ipv6CidrRange != null && Object.hasOwnProperty.call(message, "ipv6CidrRange"))
                                writer.uint32(/* id 273141258, wireType 2 =*/2185130066).string(message.ipv6CidrRange);
                            if (message.purpose != null && Object.hasOwnProperty.call(message, "purpose"))
                                writer.uint32(/* id 316407070, wireType 2 =*/2531256562).string(message.purpose);
                            if (message.logConfig != null && Object.hasOwnProperty.call(message, "logConfig"))
                                $root.google.cloud.compute.v1.SubnetworkLogConfig.encode(message.logConfig, writer.uint32(/* id 351299741, wireType 2 =*/2810397930).fork()).ldelim();
                            if (message.privateIpGoogleAccess != null && Object.hasOwnProperty.call(message, "privateIpGoogleAccess"))
                                writer.uint32(/* id 421491790, wireType 0 =*/3371934320).bool(message.privateIpGoogleAccess);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.stackType != null && Object.hasOwnProperty.call(message, "stackType"))
                                writer.uint32(/* id 425908881, wireType 2 =*/3407271050).string(message.stackType);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.gatewayAddress != null && Object.hasOwnProperty.call(message, "gatewayAddress"))
                                writer.uint32(/* id 459867385, wireType 2 =*/3678939082).string(message.gatewayAddress);
                            if (message.ipv6AccessType != null && Object.hasOwnProperty.call(message, "ipv6AccessType"))
                                writer.uint32(/* id 504658653, wireType 2 =*/4037269226).string(message.ipv6AccessType);
                            if (message.internalIpv6Prefix != null && Object.hasOwnProperty.call(message, "internalIpv6Prefix"))
                                writer.uint32(/* id 506270056, wireType 2 =*/4050160450).string(message.internalIpv6Prefix);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Subnetwork message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Subnetwork.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetwork} message Subnetwork message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Subnetwork.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Subnetwork message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Subnetwork} Subnetwork
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Subnetwork.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Subnetwork();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 151544420: {
                                        message.enableFlowLogs = reader.bool();
                                        break;
                                    }
                                case 139299190: {
                                        message.externalIpv6Prefix = reader.string();
                                        break;
                                    }
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 459867385: {
                                        message.gatewayAddress = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 506270056: {
                                        message.internalIpv6Prefix = reader.string();
                                        break;
                                    }
                                case 98117322: {
                                        message.ipCidrRange = reader.string();
                                        break;
                                    }
                                case 504658653: {
                                        message.ipv6AccessType = reader.string();
                                        break;
                                    }
                                case 273141258: {
                                        message.ipv6CidrRange = reader.string();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 351299741: {
                                        message.logConfig = $root.google.cloud.compute.v1.SubnetworkLogConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 421491790: {
                                        message.privateIpGoogleAccess = reader.bool();
                                        break;
                                    }
                                case 48277006: {
                                        message.privateIpv6GoogleAccess = reader.string();
                                        break;
                                    }
                                case 316407070: {
                                        message.purpose = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 3506294: {
                                        message.role = reader.string();
                                        break;
                                    }
                                case 136658915: {
                                        if (!(message.secondaryIpRanges && message.secondaryIpRanges.length))
                                            message.secondaryIpRanges = [];
                                        message.secondaryIpRanges.push($root.google.cloud.compute.v1.SubnetworkSecondaryRange.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 425908881: {
                                        message.stackType = reader.string();
                                        break;
                                    }
                                case 109757585: {
                                        message.state = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Subnetwork message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Subnetwork} Subnetwork
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Subnetwork.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Subnetwork message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Subnetwork.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.enableFlowLogs != null && message.hasOwnProperty("enableFlowLogs")) {
                                properties._enableFlowLogs = 1;
                                if (typeof message.enableFlowLogs !== "boolean")
                                    return "enableFlowLogs: boolean expected";
                            }
                            if (message.externalIpv6Prefix != null && message.hasOwnProperty("externalIpv6Prefix")) {
                                properties._externalIpv6Prefix = 1;
                                if (!$util.isString(message.externalIpv6Prefix))
                                    return "externalIpv6Prefix: string expected";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.gatewayAddress != null && message.hasOwnProperty("gatewayAddress")) {
                                properties._gatewayAddress = 1;
                                if (!$util.isString(message.gatewayAddress))
                                    return "gatewayAddress: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.internalIpv6Prefix != null && message.hasOwnProperty("internalIpv6Prefix")) {
                                properties._internalIpv6Prefix = 1;
                                if (!$util.isString(message.internalIpv6Prefix))
                                    return "internalIpv6Prefix: string expected";
                            }
                            if (message.ipCidrRange != null && message.hasOwnProperty("ipCidrRange")) {
                                properties._ipCidrRange = 1;
                                if (!$util.isString(message.ipCidrRange))
                                    return "ipCidrRange: string expected";
                            }
                            if (message.ipv6AccessType != null && message.hasOwnProperty("ipv6AccessType")) {
                                properties._ipv6AccessType = 1;
                                if (!$util.isString(message.ipv6AccessType))
                                    return "ipv6AccessType: string expected";
                            }
                            if (message.ipv6CidrRange != null && message.hasOwnProperty("ipv6CidrRange")) {
                                properties._ipv6CidrRange = 1;
                                if (!$util.isString(message.ipv6CidrRange))
                                    return "ipv6CidrRange: string expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.logConfig != null && message.hasOwnProperty("logConfig")) {
                                properties._logConfig = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.SubnetworkLogConfig.verify(message.logConfig);
                                    if (error)
                                        return "logConfig." + error;
                                }
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                properties._network = 1;
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            }
                            if (message.privateIpGoogleAccess != null && message.hasOwnProperty("privateIpGoogleAccess")) {
                                properties._privateIpGoogleAccess = 1;
                                if (typeof message.privateIpGoogleAccess !== "boolean")
                                    return "privateIpGoogleAccess: boolean expected";
                            }
                            if (message.privateIpv6GoogleAccess != null && message.hasOwnProperty("privateIpv6GoogleAccess")) {
                                properties._privateIpv6GoogleAccess = 1;
                                if (!$util.isString(message.privateIpv6GoogleAccess))
                                    return "privateIpv6GoogleAccess: string expected";
                            }
                            if (message.purpose != null && message.hasOwnProperty("purpose")) {
                                properties._purpose = 1;
                                if (!$util.isString(message.purpose))
                                    return "purpose: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.role != null && message.hasOwnProperty("role")) {
                                properties._role = 1;
                                if (!$util.isString(message.role))
                                    return "role: string expected";
                            }
                            if (message.secondaryIpRanges != null && message.hasOwnProperty("secondaryIpRanges")) {
                                if (!Array.isArray(message.secondaryIpRanges))
                                    return "secondaryIpRanges: array expected";
                                for (var i = 0; i < message.secondaryIpRanges.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.SubnetworkSecondaryRange.verify(message.secondaryIpRanges[i]);
                                    if (error)
                                        return "secondaryIpRanges." + error;
                                }
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.stackType != null && message.hasOwnProperty("stackType")) {
                                properties._stackType = 1;
                                if (!$util.isString(message.stackType))
                                    return "stackType: string expected";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                properties._state = 1;
                                if (!$util.isString(message.state))
                                    return "state: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Subnetwork message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Subnetwork} Subnetwork
                         */
                        Subnetwork.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Subnetwork)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Subnetwork();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.enableFlowLogs != null)
                                message.enableFlowLogs = Boolean(object.enableFlowLogs);
                            if (object.externalIpv6Prefix != null)
                                message.externalIpv6Prefix = String(object.externalIpv6Prefix);
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.gatewayAddress != null)
                                message.gatewayAddress = String(object.gatewayAddress);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.internalIpv6Prefix != null)
                                message.internalIpv6Prefix = String(object.internalIpv6Prefix);
                            if (object.ipCidrRange != null)
                                message.ipCidrRange = String(object.ipCidrRange);
                            if (object.ipv6AccessType != null)
                                message.ipv6AccessType = String(object.ipv6AccessType);
                            if (object.ipv6CidrRange != null)
                                message.ipv6CidrRange = String(object.ipv6CidrRange);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.logConfig != null) {
                                if (typeof object.logConfig !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Subnetwork.logConfig: object expected");
                                message.logConfig = $root.google.cloud.compute.v1.SubnetworkLogConfig.fromObject(object.logConfig);
                            }
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.privateIpGoogleAccess != null)
                                message.privateIpGoogleAccess = Boolean(object.privateIpGoogleAccess);
                            if (object.privateIpv6GoogleAccess != null)
                                message.privateIpv6GoogleAccess = String(object.privateIpv6GoogleAccess);
                            if (object.purpose != null)
                                message.purpose = String(object.purpose);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.role != null)
                                message.role = String(object.role);
                            if (object.secondaryIpRanges) {
                                if (!Array.isArray(object.secondaryIpRanges))
                                    throw TypeError(".google.cloud.compute.v1.Subnetwork.secondaryIpRanges: array expected");
                                message.secondaryIpRanges = [];
                                for (var i = 0; i < object.secondaryIpRanges.length; ++i) {
                                    if (typeof object.secondaryIpRanges[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Subnetwork.secondaryIpRanges: object expected");
                                    message.secondaryIpRanges[i] = $root.google.cloud.compute.v1.SubnetworkSecondaryRange.fromObject(object.secondaryIpRanges[i]);
                                }
                            }
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.stackType != null)
                                message.stackType = String(object.stackType);
                            if (object.state != null)
                                message.state = String(object.state);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Subnetwork message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @static
                         * @param {google.cloud.compute.v1.Subnetwork} message Subnetwork
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Subnetwork.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.secondaryIpRanges = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.role != null && message.hasOwnProperty("role")) {
                                object.role = message.role;
                                if (options.oneofs)
                                    object._role = "role";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.privateIpv6GoogleAccess != null && message.hasOwnProperty("privateIpv6GoogleAccess")) {
                                object.privateIpv6GoogleAccess = message.privateIpv6GoogleAccess;
                                if (options.oneofs)
                                    object._privateIpv6GoogleAccess = "privateIpv6GoogleAccess";
                            }
                            if (message.ipCidrRange != null && message.hasOwnProperty("ipCidrRange")) {
                                object.ipCidrRange = message.ipCidrRange;
                                if (options.oneofs)
                                    object._ipCidrRange = "ipCidrRange";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                object.state = message.state;
                                if (options.oneofs)
                                    object._state = "state";
                            }
                            if (message.secondaryIpRanges && message.secondaryIpRanges.length) {
                                object.secondaryIpRanges = [];
                                for (var j = 0; j < message.secondaryIpRanges.length; ++j)
                                    object.secondaryIpRanges[j] = $root.google.cloud.compute.v1.SubnetworkSecondaryRange.toObject(message.secondaryIpRanges[j], options);
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.externalIpv6Prefix != null && message.hasOwnProperty("externalIpv6Prefix")) {
                                object.externalIpv6Prefix = message.externalIpv6Prefix;
                                if (options.oneofs)
                                    object._externalIpv6Prefix = "externalIpv6Prefix";
                            }
                            if (message.enableFlowLogs != null && message.hasOwnProperty("enableFlowLogs")) {
                                object.enableFlowLogs = message.enableFlowLogs;
                                if (options.oneofs)
                                    object._enableFlowLogs = "enableFlowLogs";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                object.network = message.network;
                                if (options.oneofs)
                                    object._network = "network";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.ipv6CidrRange != null && message.hasOwnProperty("ipv6CidrRange")) {
                                object.ipv6CidrRange = message.ipv6CidrRange;
                                if (options.oneofs)
                                    object._ipv6CidrRange = "ipv6CidrRange";
                            }
                            if (message.purpose != null && message.hasOwnProperty("purpose")) {
                                object.purpose = message.purpose;
                                if (options.oneofs)
                                    object._purpose = "purpose";
                            }
                            if (message.logConfig != null && message.hasOwnProperty("logConfig")) {
                                object.logConfig = $root.google.cloud.compute.v1.SubnetworkLogConfig.toObject(message.logConfig, options);
                                if (options.oneofs)
                                    object._logConfig = "logConfig";
                            }
                            if (message.privateIpGoogleAccess != null && message.hasOwnProperty("privateIpGoogleAccess")) {
                                object.privateIpGoogleAccess = message.privateIpGoogleAccess;
                                if (options.oneofs)
                                    object._privateIpGoogleAccess = "privateIpGoogleAccess";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.stackType != null && message.hasOwnProperty("stackType")) {
                                object.stackType = message.stackType;
                                if (options.oneofs)
                                    object._stackType = "stackType";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.gatewayAddress != null && message.hasOwnProperty("gatewayAddress")) {
                                object.gatewayAddress = message.gatewayAddress;
                                if (options.oneofs)
                                    object._gatewayAddress = "gatewayAddress";
                            }
                            if (message.ipv6AccessType != null && message.hasOwnProperty("ipv6AccessType")) {
                                object.ipv6AccessType = message.ipv6AccessType;
                                if (options.oneofs)
                                    object._ipv6AccessType = "ipv6AccessType";
                            }
                            if (message.internalIpv6Prefix != null && message.hasOwnProperty("internalIpv6Prefix")) {
                                object.internalIpv6Prefix = message.internalIpv6Prefix;
                                if (options.oneofs)
                                    object._internalIpv6Prefix = "internalIpv6Prefix";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Subnetwork to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Subnetwork.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Subnetwork
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Subnetwork
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Subnetwork.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Subnetwork";
                        };
    
                        /**
                         * Ipv6AccessType enum.
                         * @name google.cloud.compute.v1.Subnetwork.Ipv6AccessType
                         * @enum {number}
                         * @property {number} UNDEFINED_IPV6_ACCESS_TYPE=0 UNDEFINED_IPV6_ACCESS_TYPE value
                         * @property {number} EXTERNAL=35607499 EXTERNAL value
                         * @property {number} INTERNAL=279295677 INTERNAL value
                         * @property {number} UNSPECIFIED_IPV6_ACCESS_TYPE=313080613 UNSPECIFIED_IPV6_ACCESS_TYPE value
                         */
                        Subnetwork.Ipv6AccessType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_IPV6_ACCESS_TYPE"] = 0;
                            values[valuesById[35607499] = "EXTERNAL"] = 35607499;
                            values[valuesById[279295677] = "INTERNAL"] = 279295677;
                            values[valuesById[313080613] = "UNSPECIFIED_IPV6_ACCESS_TYPE"] = 313080613;
                            return values;
                        })();
    
                        /**
                         * PrivateIpv6GoogleAccess enum.
                         * @name google.cloud.compute.v1.Subnetwork.PrivateIpv6GoogleAccess
                         * @enum {number}
                         * @property {number} UNDEFINED_PRIVATE_IPV6_GOOGLE_ACCESS=0 UNDEFINED_PRIVATE_IPV6_GOOGLE_ACCESS value
                         * @property {number} DISABLE_GOOGLE_ACCESS=450958579 DISABLE_GOOGLE_ACCESS value
                         * @property {number} ENABLE_BIDIRECTIONAL_ACCESS_TO_GOOGLE=427975994 ENABLE_BIDIRECTIONAL_ACCESS_TO_GOOGLE value
                         * @property {number} ENABLE_OUTBOUND_VM_ACCESS_TO_GOOGLE=288210263 ENABLE_OUTBOUND_VM_ACCESS_TO_GOOGLE value
                         */
                        Subnetwork.PrivateIpv6GoogleAccess = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PRIVATE_IPV6_GOOGLE_ACCESS"] = 0;
                            values[valuesById[450958579] = "DISABLE_GOOGLE_ACCESS"] = 450958579;
                            values[valuesById[427975994] = "ENABLE_BIDIRECTIONAL_ACCESS_TO_GOOGLE"] = 427975994;
                            values[valuesById[288210263] = "ENABLE_OUTBOUND_VM_ACCESS_TO_GOOGLE"] = 288210263;
                            return values;
                        })();
    
                        /**
                         * Purpose enum.
                         * @name google.cloud.compute.v1.Subnetwork.Purpose
                         * @enum {number}
                         * @property {number} UNDEFINED_PURPOSE=0 UNDEFINED_PURPOSE value
                         * @property {number} INTERNAL_HTTPS_LOAD_BALANCER=248748889 INTERNAL_HTTPS_LOAD_BALANCER value
                         * @property {number} PRIVATE=403485027 PRIVATE value
                         * @property {number} PRIVATE_RFC_1918=254902107 PRIVATE_RFC_1918 value
                         * @property {number} PRIVATE_SERVICE_CONNECT=48134724 PRIVATE_SERVICE_CONNECT value
                         * @property {number} REGIONAL_MANAGED_PROXY=153049966 REGIONAL_MANAGED_PROXY value
                         */
                        Subnetwork.Purpose = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PURPOSE"] = 0;
                            values[valuesById[248748889] = "INTERNAL_HTTPS_LOAD_BALANCER"] = 248748889;
                            values[valuesById[403485027] = "PRIVATE"] = 403485027;
                            values[valuesById[254902107] = "PRIVATE_RFC_1918"] = 254902107;
                            values[valuesById[48134724] = "PRIVATE_SERVICE_CONNECT"] = 48134724;
                            values[valuesById[153049966] = "REGIONAL_MANAGED_PROXY"] = 153049966;
                            return values;
                        })();
    
                        /**
                         * Role enum.
                         * @name google.cloud.compute.v1.Subnetwork.Role
                         * @enum {number}
                         * @property {number} UNDEFINED_ROLE=0 UNDEFINED_ROLE value
                         * @property {number} ACTIVE=314733318 ACTIVE value
                         * @property {number} BACKUP=341010882 BACKUP value
                         */
                        Subnetwork.Role = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ROLE"] = 0;
                            values[valuesById[314733318] = "ACTIVE"] = 314733318;
                            values[valuesById[341010882] = "BACKUP"] = 341010882;
                            return values;
                        })();
    
                        /**
                         * StackType enum.
                         * @name google.cloud.compute.v1.Subnetwork.StackType
                         * @enum {number}
                         * @property {number} UNDEFINED_STACK_TYPE=0 UNDEFINED_STACK_TYPE value
                         * @property {number} IPV4_IPV6=22197249 IPV4_IPV6 value
                         * @property {number} IPV4_ONLY=22373798 IPV4_ONLY value
                         * @property {number} UNSPECIFIED_STACK_TYPE=298084569 UNSPECIFIED_STACK_TYPE value
                         */
                        Subnetwork.StackType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STACK_TYPE"] = 0;
                            values[valuesById[22197249] = "IPV4_IPV6"] = 22197249;
                            values[valuesById[22373798] = "IPV4_ONLY"] = 22373798;
                            values[valuesById[298084569] = "UNSPECIFIED_STACK_TYPE"] = 298084569;
                            return values;
                        })();
    
                        /**
                         * State enum.
                         * @name google.cloud.compute.v1.Subnetwork.State
                         * @enum {number}
                         * @property {number} UNDEFINED_STATE=0 UNDEFINED_STATE value
                         * @property {number} DRAINING=480455402 DRAINING value
                         * @property {number} READY=77848963 READY value
                         */
                        Subnetwork.State = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATE"] = 0;
                            values[valuesById[480455402] = "DRAINING"] = 480455402;
                            values[valuesById[77848963] = "READY"] = 77848963;
                            return values;
                        })();
    
                        return Subnetwork;
                    })();
    
                    v1.SubnetworkAggregatedList = (function() {
    
                        /**
                         * Properties of a SubnetworkAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface ISubnetworkAggregatedList
                         * @property {string|null} [id] SubnetworkAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.ISubnetworksScopedList>|null} [items] SubnetworkAggregatedList items
                         * @property {string|null} [kind] SubnetworkAggregatedList kind
                         * @property {string|null} [nextPageToken] SubnetworkAggregatedList nextPageToken
                         * @property {string|null} [selfLink] SubnetworkAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] SubnetworkAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] SubnetworkAggregatedList warning
                         */
    
                        /**
                         * Constructs a new SubnetworkAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SubnetworkAggregatedList.
                         * @implements ISubnetworkAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.ISubnetworkAggregatedList=} [properties] Properties to set
                         */
                        function SubnetworkAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SubnetworkAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @instance
                         */
                        SubnetworkAggregatedList.prototype.id = null;
    
                        /**
                         * SubnetworkAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.ISubnetworksScopedList>} items
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @instance
                         */
                        SubnetworkAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * SubnetworkAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @instance
                         */
                        SubnetworkAggregatedList.prototype.kind = null;
    
                        /**
                         * SubnetworkAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @instance
                         */
                        SubnetworkAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * SubnetworkAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @instance
                         */
                        SubnetworkAggregatedList.prototype.selfLink = null;
    
                        /**
                         * SubnetworkAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @instance
                         */
                        SubnetworkAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * SubnetworkAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @instance
                         */
                        SubnetworkAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SubnetworkAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SubnetworkAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SubnetworkAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SubnetworkAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SubnetworkAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SubnetworkAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SubnetworkAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SubnetworkAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SubnetworkAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @instance
                         */
                        Object.defineProperty(SubnetworkAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SubnetworkAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworkAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SubnetworkAggregatedList} SubnetworkAggregatedList instance
                         */
                        SubnetworkAggregatedList.create = function create(properties) {
                            return new SubnetworkAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified SubnetworkAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.SubnetworkAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworkAggregatedList} message SubnetworkAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SubnetworkAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.SubnetworksScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SubnetworkAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SubnetworkAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworkAggregatedList} message SubnetworkAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SubnetworkAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SubnetworkAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SubnetworkAggregatedList} SubnetworkAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SubnetworkAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SubnetworkAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.SubnetworksScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SubnetworkAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SubnetworkAggregatedList} SubnetworkAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SubnetworkAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SubnetworkAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SubnetworkAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.SubnetworksScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SubnetworkAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SubnetworkAggregatedList} SubnetworkAggregatedList
                         */
                        SubnetworkAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SubnetworkAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SubnetworkAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SubnetworkAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SubnetworkAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.SubnetworksScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.SubnetworkAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SubnetworkAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SubnetworkAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.SubnetworkAggregatedList} message SubnetworkAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SubnetworkAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.SubnetworksScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SubnetworkAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SubnetworkAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SubnetworkAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SubnetworkAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SubnetworkAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SubnetworkAggregatedList";
                        };
    
                        return SubnetworkAggregatedList;
                    })();
    
                    v1.SubnetworkList = (function() {
    
                        /**
                         * Properties of a SubnetworkList.
                         * @memberof google.cloud.compute.v1
                         * @interface ISubnetworkList
                         * @property {string|null} [id] SubnetworkList id
                         * @property {Array.<google.cloud.compute.v1.ISubnetwork>|null} [items] SubnetworkList items
                         * @property {string|null} [kind] SubnetworkList kind
                         * @property {string|null} [nextPageToken] SubnetworkList nextPageToken
                         * @property {string|null} [selfLink] SubnetworkList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] SubnetworkList warning
                         */
    
                        /**
                         * Constructs a new SubnetworkList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SubnetworkList.
                         * @implements ISubnetworkList
                         * @constructor
                         * @param {google.cloud.compute.v1.ISubnetworkList=} [properties] Properties to set
                         */
                        function SubnetworkList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SubnetworkList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @instance
                         */
                        SubnetworkList.prototype.id = null;
    
                        /**
                         * SubnetworkList items.
                         * @member {Array.<google.cloud.compute.v1.ISubnetwork>} items
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @instance
                         */
                        SubnetworkList.prototype.items = $util.emptyArray;
    
                        /**
                         * SubnetworkList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @instance
                         */
                        SubnetworkList.prototype.kind = null;
    
                        /**
                         * SubnetworkList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @instance
                         */
                        SubnetworkList.prototype.nextPageToken = null;
    
                        /**
                         * SubnetworkList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @instance
                         */
                        SubnetworkList.prototype.selfLink = null;
    
                        /**
                         * SubnetworkList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @instance
                         */
                        SubnetworkList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SubnetworkList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @instance
                         */
                        Object.defineProperty(SubnetworkList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SubnetworkList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @instance
                         */
                        Object.defineProperty(SubnetworkList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SubnetworkList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @instance
                         */
                        Object.defineProperty(SubnetworkList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SubnetworkList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @instance
                         */
                        Object.defineProperty(SubnetworkList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SubnetworkList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @instance
                         */
                        Object.defineProperty(SubnetworkList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SubnetworkList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworkList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SubnetworkList} SubnetworkList instance
                         */
                        SubnetworkList.create = function create(properties) {
                            return new SubnetworkList(properties);
                        };
    
                        /**
                         * Encodes the specified SubnetworkList message. Does not implicitly {@link google.cloud.compute.v1.SubnetworkList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworkList} message SubnetworkList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SubnetworkList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Subnetwork.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SubnetworkList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SubnetworkList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworkList} message SubnetworkList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SubnetworkList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SubnetworkList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SubnetworkList} SubnetworkList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SubnetworkList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SubnetworkList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Subnetwork.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SubnetworkList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SubnetworkList} SubnetworkList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SubnetworkList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SubnetworkList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SubnetworkList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Subnetwork.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SubnetworkList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SubnetworkList} SubnetworkList
                         */
                        SubnetworkList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SubnetworkList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SubnetworkList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.SubnetworkList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SubnetworkList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Subnetwork.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SubnetworkList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SubnetworkList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @static
                         * @param {google.cloud.compute.v1.SubnetworkList} message SubnetworkList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SubnetworkList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Subnetwork.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SubnetworkList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SubnetworkList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SubnetworkList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SubnetworkList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SubnetworkList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SubnetworkList";
                        };
    
                        return SubnetworkList;
                    })();
    
                    v1.SubnetworkLogConfig = (function() {
    
                        /**
                         * Properties of a SubnetworkLogConfig.
                         * @memberof google.cloud.compute.v1
                         * @interface ISubnetworkLogConfig
                         * @property {string|null} [aggregationInterval] SubnetworkLogConfig aggregationInterval
                         * @property {boolean|null} [enable] SubnetworkLogConfig enable
                         * @property {string|null} [filterExpr] SubnetworkLogConfig filterExpr
                         * @property {number|null} [flowSampling] SubnetworkLogConfig flowSampling
                         * @property {string|null} [metadata] SubnetworkLogConfig metadata
                         * @property {Array.<string>|null} [metadataFields] SubnetworkLogConfig metadataFields
                         */
    
                        /**
                         * Constructs a new SubnetworkLogConfig.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SubnetworkLogConfig.
                         * @implements ISubnetworkLogConfig
                         * @constructor
                         * @param {google.cloud.compute.v1.ISubnetworkLogConfig=} [properties] Properties to set
                         */
                        function SubnetworkLogConfig(properties) {
                            this.metadataFields = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SubnetworkLogConfig aggregationInterval.
                         * @member {string|null|undefined} aggregationInterval
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @instance
                         */
                        SubnetworkLogConfig.prototype.aggregationInterval = null;
    
                        /**
                         * SubnetworkLogConfig enable.
                         * @member {boolean|null|undefined} enable
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @instance
                         */
                        SubnetworkLogConfig.prototype.enable = null;
    
                        /**
                         * SubnetworkLogConfig filterExpr.
                         * @member {string|null|undefined} filterExpr
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @instance
                         */
                        SubnetworkLogConfig.prototype.filterExpr = null;
    
                        /**
                         * SubnetworkLogConfig flowSampling.
                         * @member {number|null|undefined} flowSampling
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @instance
                         */
                        SubnetworkLogConfig.prototype.flowSampling = null;
    
                        /**
                         * SubnetworkLogConfig metadata.
                         * @member {string|null|undefined} metadata
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @instance
                         */
                        SubnetworkLogConfig.prototype.metadata = null;
    
                        /**
                         * SubnetworkLogConfig metadataFields.
                         * @member {Array.<string>} metadataFields
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @instance
                         */
                        SubnetworkLogConfig.prototype.metadataFields = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SubnetworkLogConfig _aggregationInterval.
                         * @member {"aggregationInterval"|undefined} _aggregationInterval
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @instance
                         */
                        Object.defineProperty(SubnetworkLogConfig.prototype, "_aggregationInterval", {
                            get: $util.oneOfGetter($oneOfFields = ["aggregationInterval"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SubnetworkLogConfig _enable.
                         * @member {"enable"|undefined} _enable
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @instance
                         */
                        Object.defineProperty(SubnetworkLogConfig.prototype, "_enable", {
                            get: $util.oneOfGetter($oneOfFields = ["enable"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SubnetworkLogConfig _filterExpr.
                         * @member {"filterExpr"|undefined} _filterExpr
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @instance
                         */
                        Object.defineProperty(SubnetworkLogConfig.prototype, "_filterExpr", {
                            get: $util.oneOfGetter($oneOfFields = ["filterExpr"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SubnetworkLogConfig _flowSampling.
                         * @member {"flowSampling"|undefined} _flowSampling
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @instance
                         */
                        Object.defineProperty(SubnetworkLogConfig.prototype, "_flowSampling", {
                            get: $util.oneOfGetter($oneOfFields = ["flowSampling"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SubnetworkLogConfig _metadata.
                         * @member {"metadata"|undefined} _metadata
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @instance
                         */
                        Object.defineProperty(SubnetworkLogConfig.prototype, "_metadata", {
                            get: $util.oneOfGetter($oneOfFields = ["metadata"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SubnetworkLogConfig instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworkLogConfig=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SubnetworkLogConfig} SubnetworkLogConfig instance
                         */
                        SubnetworkLogConfig.create = function create(properties) {
                            return new SubnetworkLogConfig(properties);
                        };
    
                        /**
                         * Encodes the specified SubnetworkLogConfig message. Does not implicitly {@link google.cloud.compute.v1.SubnetworkLogConfig.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworkLogConfig} message SubnetworkLogConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SubnetworkLogConfig.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.metadata != null && Object.hasOwnProperty.call(message, "metadata"))
                                writer.uint32(/* id 86866735, wireType 2 =*/694933882).string(message.metadata);
                            if (message.aggregationInterval != null && Object.hasOwnProperty.call(message, "aggregationInterval"))
                                writer.uint32(/* id 174919042, wireType 2 =*/1399352338).string(message.aggregationInterval);
                            if (message.filterExpr != null && Object.hasOwnProperty.call(message, "filterExpr"))
                                writer.uint32(/* id 183374428, wireType 2 =*/1466995426).string(message.filterExpr);
                            if (message.enable != null && Object.hasOwnProperty.call(message, "enable"))
                                writer.uint32(/* id 311764355, wireType 0 =*/2494114840).bool(message.enable);
                            if (message.metadataFields != null && message.metadataFields.length)
                                for (var i = 0; i < message.metadataFields.length; ++i)
                                    writer.uint32(/* id 378461641, wireType 2 =*/3027693130).string(message.metadataFields[i]);
                            if (message.flowSampling != null && Object.hasOwnProperty.call(message, "flowSampling"))
                                writer.uint32(/* id 530150360, wireType 5 =*/4241202885).float(message.flowSampling);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SubnetworkLogConfig message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SubnetworkLogConfig.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworkLogConfig} message SubnetworkLogConfig message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SubnetworkLogConfig.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SubnetworkLogConfig message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SubnetworkLogConfig} SubnetworkLogConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SubnetworkLogConfig.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SubnetworkLogConfig();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 174919042: {
                                        message.aggregationInterval = reader.string();
                                        break;
                                    }
                                case 311764355: {
                                        message.enable = reader.bool();
                                        break;
                                    }
                                case 183374428: {
                                        message.filterExpr = reader.string();
                                        break;
                                    }
                                case 530150360: {
                                        message.flowSampling = reader.float();
                                        break;
                                    }
                                case 86866735: {
                                        message.metadata = reader.string();
                                        break;
                                    }
                                case 378461641: {
                                        if (!(message.metadataFields && message.metadataFields.length))
                                            message.metadataFields = [];
                                        message.metadataFields.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SubnetworkLogConfig message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SubnetworkLogConfig} SubnetworkLogConfig
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SubnetworkLogConfig.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SubnetworkLogConfig message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SubnetworkLogConfig.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.aggregationInterval != null && message.hasOwnProperty("aggregationInterval")) {
                                properties._aggregationInterval = 1;
                                if (!$util.isString(message.aggregationInterval))
                                    return "aggregationInterval: string expected";
                            }
                            if (message.enable != null && message.hasOwnProperty("enable")) {
                                properties._enable = 1;
                                if (typeof message.enable !== "boolean")
                                    return "enable: boolean expected";
                            }
                            if (message.filterExpr != null && message.hasOwnProperty("filterExpr")) {
                                properties._filterExpr = 1;
                                if (!$util.isString(message.filterExpr))
                                    return "filterExpr: string expected";
                            }
                            if (message.flowSampling != null && message.hasOwnProperty("flowSampling")) {
                                properties._flowSampling = 1;
                                if (typeof message.flowSampling !== "number")
                                    return "flowSampling: number expected";
                            }
                            if (message.metadata != null && message.hasOwnProperty("metadata")) {
                                properties._metadata = 1;
                                if (!$util.isString(message.metadata))
                                    return "metadata: string expected";
                            }
                            if (message.metadataFields != null && message.hasOwnProperty("metadataFields")) {
                                if (!Array.isArray(message.metadataFields))
                                    return "metadataFields: array expected";
                                for (var i = 0; i < message.metadataFields.length; ++i)
                                    if (!$util.isString(message.metadataFields[i]))
                                        return "metadataFields: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SubnetworkLogConfig message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SubnetworkLogConfig} SubnetworkLogConfig
                         */
                        SubnetworkLogConfig.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SubnetworkLogConfig)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SubnetworkLogConfig();
                            if (object.aggregationInterval != null)
                                message.aggregationInterval = String(object.aggregationInterval);
                            if (object.enable != null)
                                message.enable = Boolean(object.enable);
                            if (object.filterExpr != null)
                                message.filterExpr = String(object.filterExpr);
                            if (object.flowSampling != null)
                                message.flowSampling = Number(object.flowSampling);
                            if (object.metadata != null)
                                message.metadata = String(object.metadata);
                            if (object.metadataFields) {
                                if (!Array.isArray(object.metadataFields))
                                    throw TypeError(".google.cloud.compute.v1.SubnetworkLogConfig.metadataFields: array expected");
                                message.metadataFields = [];
                                for (var i = 0; i < object.metadataFields.length; ++i)
                                    message.metadataFields[i] = String(object.metadataFields[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SubnetworkLogConfig message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @static
                         * @param {google.cloud.compute.v1.SubnetworkLogConfig} message SubnetworkLogConfig
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SubnetworkLogConfig.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.metadataFields = [];
                            if (message.metadata != null && message.hasOwnProperty("metadata")) {
                                object.metadata = message.metadata;
                                if (options.oneofs)
                                    object._metadata = "metadata";
                            }
                            if (message.aggregationInterval != null && message.hasOwnProperty("aggregationInterval")) {
                                object.aggregationInterval = message.aggregationInterval;
                                if (options.oneofs)
                                    object._aggregationInterval = "aggregationInterval";
                            }
                            if (message.filterExpr != null && message.hasOwnProperty("filterExpr")) {
                                object.filterExpr = message.filterExpr;
                                if (options.oneofs)
                                    object._filterExpr = "filterExpr";
                            }
                            if (message.enable != null && message.hasOwnProperty("enable")) {
                                object.enable = message.enable;
                                if (options.oneofs)
                                    object._enable = "enable";
                            }
                            if (message.metadataFields && message.metadataFields.length) {
                                object.metadataFields = [];
                                for (var j = 0; j < message.metadataFields.length; ++j)
                                    object.metadataFields[j] = message.metadataFields[j];
                            }
                            if (message.flowSampling != null && message.hasOwnProperty("flowSampling")) {
                                object.flowSampling = options.json && !isFinite(message.flowSampling) ? String(message.flowSampling) : message.flowSampling;
                                if (options.oneofs)
                                    object._flowSampling = "flowSampling";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SubnetworkLogConfig to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SubnetworkLogConfig.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SubnetworkLogConfig
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SubnetworkLogConfig
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SubnetworkLogConfig.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SubnetworkLogConfig";
                        };
    
                        /**
                         * AggregationInterval enum.
                         * @name google.cloud.compute.v1.SubnetworkLogConfig.AggregationInterval
                         * @enum {number}
                         * @property {number} UNDEFINED_AGGREGATION_INTERVAL=0 UNDEFINED_AGGREGATION_INTERVAL value
                         * @property {number} INTERVAL_10_MIN=487155916 INTERVAL_10_MIN value
                         * @property {number} INTERVAL_15_MIN=491773521 INTERVAL_15_MIN value
                         * @property {number} INTERVAL_1_MIN=69052714 INTERVAL_1_MIN value
                         * @property {number} INTERVAL_30_SEC=7548937 INTERVAL_30_SEC value
                         * @property {number} INTERVAL_5_MIN=72746798 INTERVAL_5_MIN value
                         * @property {number} INTERVAL_5_SEC=72752429 INTERVAL_5_SEC value
                         */
                        SubnetworkLogConfig.AggregationInterval = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_AGGREGATION_INTERVAL"] = 0;
                            values[valuesById[487155916] = "INTERVAL_10_MIN"] = 487155916;
                            values[valuesById[491773521] = "INTERVAL_15_MIN"] = 491773521;
                            values[valuesById[69052714] = "INTERVAL_1_MIN"] = 69052714;
                            values[valuesById[7548937] = "INTERVAL_30_SEC"] = 7548937;
                            values[valuesById[72746798] = "INTERVAL_5_MIN"] = 72746798;
                            values[valuesById[72752429] = "INTERVAL_5_SEC"] = 72752429;
                            return values;
                        })();
    
                        /**
                         * Metadata enum.
                         * @name google.cloud.compute.v1.SubnetworkLogConfig.Metadata
                         * @enum {number}
                         * @property {number} UNDEFINED_METADATA=0 UNDEFINED_METADATA value
                         * @property {number} CUSTOM_METADATA=62450749 CUSTOM_METADATA value
                         * @property {number} EXCLUDE_ALL_METADATA=334519954 EXCLUDE_ALL_METADATA value
                         * @property {number} INCLUDE_ALL_METADATA=164619908 INCLUDE_ALL_METADATA value
                         */
                        SubnetworkLogConfig.Metadata = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_METADATA"] = 0;
                            values[valuesById[62450749] = "CUSTOM_METADATA"] = 62450749;
                            values[valuesById[334519954] = "EXCLUDE_ALL_METADATA"] = 334519954;
                            values[valuesById[164619908] = "INCLUDE_ALL_METADATA"] = 164619908;
                            return values;
                        })();
    
                        return SubnetworkLogConfig;
                    })();
    
                    v1.SubnetworkSecondaryRange = (function() {
    
                        /**
                         * Properties of a SubnetworkSecondaryRange.
                         * @memberof google.cloud.compute.v1
                         * @interface ISubnetworkSecondaryRange
                         * @property {string|null} [ipCidrRange] SubnetworkSecondaryRange ipCidrRange
                         * @property {string|null} [rangeName] SubnetworkSecondaryRange rangeName
                         */
    
                        /**
                         * Constructs a new SubnetworkSecondaryRange.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SubnetworkSecondaryRange.
                         * @implements ISubnetworkSecondaryRange
                         * @constructor
                         * @param {google.cloud.compute.v1.ISubnetworkSecondaryRange=} [properties] Properties to set
                         */
                        function SubnetworkSecondaryRange(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SubnetworkSecondaryRange ipCidrRange.
                         * @member {string|null|undefined} ipCidrRange
                         * @memberof google.cloud.compute.v1.SubnetworkSecondaryRange
                         * @instance
                         */
                        SubnetworkSecondaryRange.prototype.ipCidrRange = null;
    
                        /**
                         * SubnetworkSecondaryRange rangeName.
                         * @member {string|null|undefined} rangeName
                         * @memberof google.cloud.compute.v1.SubnetworkSecondaryRange
                         * @instance
                         */
                        SubnetworkSecondaryRange.prototype.rangeName = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SubnetworkSecondaryRange _ipCidrRange.
                         * @member {"ipCidrRange"|undefined} _ipCidrRange
                         * @memberof google.cloud.compute.v1.SubnetworkSecondaryRange
                         * @instance
                         */
                        Object.defineProperty(SubnetworkSecondaryRange.prototype, "_ipCidrRange", {
                            get: $util.oneOfGetter($oneOfFields = ["ipCidrRange"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * SubnetworkSecondaryRange _rangeName.
                         * @member {"rangeName"|undefined} _rangeName
                         * @memberof google.cloud.compute.v1.SubnetworkSecondaryRange
                         * @instance
                         */
                        Object.defineProperty(SubnetworkSecondaryRange.prototype, "_rangeName", {
                            get: $util.oneOfGetter($oneOfFields = ["rangeName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SubnetworkSecondaryRange instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SubnetworkSecondaryRange
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworkSecondaryRange=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SubnetworkSecondaryRange} SubnetworkSecondaryRange instance
                         */
                        SubnetworkSecondaryRange.create = function create(properties) {
                            return new SubnetworkSecondaryRange(properties);
                        };
    
                        /**
                         * Encodes the specified SubnetworkSecondaryRange message. Does not implicitly {@link google.cloud.compute.v1.SubnetworkSecondaryRange.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SubnetworkSecondaryRange
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworkSecondaryRange} message SubnetworkSecondaryRange message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SubnetworkSecondaryRange.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.ipCidrRange != null && Object.hasOwnProperty.call(message, "ipCidrRange"))
                                writer.uint32(/* id 98117322, wireType 2 =*/784938578).string(message.ipCidrRange);
                            if (message.rangeName != null && Object.hasOwnProperty.call(message, "rangeName"))
                                writer.uint32(/* id 332216397, wireType 2 =*/2657731178).string(message.rangeName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SubnetworkSecondaryRange message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SubnetworkSecondaryRange.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SubnetworkSecondaryRange
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworkSecondaryRange} message SubnetworkSecondaryRange message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SubnetworkSecondaryRange.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SubnetworkSecondaryRange message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SubnetworkSecondaryRange
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SubnetworkSecondaryRange} SubnetworkSecondaryRange
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SubnetworkSecondaryRange.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SubnetworkSecondaryRange();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 98117322: {
                                        message.ipCidrRange = reader.string();
                                        break;
                                    }
                                case 332216397: {
                                        message.rangeName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SubnetworkSecondaryRange message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SubnetworkSecondaryRange
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SubnetworkSecondaryRange} SubnetworkSecondaryRange
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SubnetworkSecondaryRange.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SubnetworkSecondaryRange message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SubnetworkSecondaryRange
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SubnetworkSecondaryRange.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.ipCidrRange != null && message.hasOwnProperty("ipCidrRange")) {
                                properties._ipCidrRange = 1;
                                if (!$util.isString(message.ipCidrRange))
                                    return "ipCidrRange: string expected";
                            }
                            if (message.rangeName != null && message.hasOwnProperty("rangeName")) {
                                properties._rangeName = 1;
                                if (!$util.isString(message.rangeName))
                                    return "rangeName: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SubnetworkSecondaryRange message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SubnetworkSecondaryRange
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SubnetworkSecondaryRange} SubnetworkSecondaryRange
                         */
                        SubnetworkSecondaryRange.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SubnetworkSecondaryRange)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SubnetworkSecondaryRange();
                            if (object.ipCidrRange != null)
                                message.ipCidrRange = String(object.ipCidrRange);
                            if (object.rangeName != null)
                                message.rangeName = String(object.rangeName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SubnetworkSecondaryRange message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SubnetworkSecondaryRange
                         * @static
                         * @param {google.cloud.compute.v1.SubnetworkSecondaryRange} message SubnetworkSecondaryRange
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SubnetworkSecondaryRange.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.ipCidrRange != null && message.hasOwnProperty("ipCidrRange")) {
                                object.ipCidrRange = message.ipCidrRange;
                                if (options.oneofs)
                                    object._ipCidrRange = "ipCidrRange";
                            }
                            if (message.rangeName != null && message.hasOwnProperty("rangeName")) {
                                object.rangeName = message.rangeName;
                                if (options.oneofs)
                                    object._rangeName = "rangeName";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SubnetworkSecondaryRange to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SubnetworkSecondaryRange
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SubnetworkSecondaryRange.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SubnetworkSecondaryRange
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SubnetworkSecondaryRange
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SubnetworkSecondaryRange.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SubnetworkSecondaryRange";
                        };
    
                        return SubnetworkSecondaryRange;
                    })();
    
                    v1.SubnetworksExpandIpCidrRangeRequest = (function() {
    
                        /**
                         * Properties of a SubnetworksExpandIpCidrRangeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISubnetworksExpandIpCidrRangeRequest
                         * @property {string|null} [ipCidrRange] SubnetworksExpandIpCidrRangeRequest ipCidrRange
                         */
    
                        /**
                         * Constructs a new SubnetworksExpandIpCidrRangeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SubnetworksExpandIpCidrRangeRequest.
                         * @implements ISubnetworksExpandIpCidrRangeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISubnetworksExpandIpCidrRangeRequest=} [properties] Properties to set
                         */
                        function SubnetworksExpandIpCidrRangeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SubnetworksExpandIpCidrRangeRequest ipCidrRange.
                         * @member {string|null|undefined} ipCidrRange
                         * @memberof google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest
                         * @instance
                         */
                        SubnetworksExpandIpCidrRangeRequest.prototype.ipCidrRange = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SubnetworksExpandIpCidrRangeRequest _ipCidrRange.
                         * @member {"ipCidrRange"|undefined} _ipCidrRange
                         * @memberof google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest
                         * @instance
                         */
                        Object.defineProperty(SubnetworksExpandIpCidrRangeRequest.prototype, "_ipCidrRange", {
                            get: $util.oneOfGetter($oneOfFields = ["ipCidrRange"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SubnetworksExpandIpCidrRangeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworksExpandIpCidrRangeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest} SubnetworksExpandIpCidrRangeRequest instance
                         */
                        SubnetworksExpandIpCidrRangeRequest.create = function create(properties) {
                            return new SubnetworksExpandIpCidrRangeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SubnetworksExpandIpCidrRangeRequest message. Does not implicitly {@link google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworksExpandIpCidrRangeRequest} message SubnetworksExpandIpCidrRangeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SubnetworksExpandIpCidrRangeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.ipCidrRange != null && Object.hasOwnProperty.call(message, "ipCidrRange"))
                                writer.uint32(/* id 98117322, wireType 2 =*/784938578).string(message.ipCidrRange);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SubnetworksExpandIpCidrRangeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworksExpandIpCidrRangeRequest} message SubnetworksExpandIpCidrRangeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SubnetworksExpandIpCidrRangeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SubnetworksExpandIpCidrRangeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest} SubnetworksExpandIpCidrRangeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SubnetworksExpandIpCidrRangeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 98117322: {
                                        message.ipCidrRange = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SubnetworksExpandIpCidrRangeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest} SubnetworksExpandIpCidrRangeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SubnetworksExpandIpCidrRangeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SubnetworksExpandIpCidrRangeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SubnetworksExpandIpCidrRangeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.ipCidrRange != null && message.hasOwnProperty("ipCidrRange")) {
                                properties._ipCidrRange = 1;
                                if (!$util.isString(message.ipCidrRange))
                                    return "ipCidrRange: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SubnetworksExpandIpCidrRangeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest} SubnetworksExpandIpCidrRangeRequest
                         */
                        SubnetworksExpandIpCidrRangeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest();
                            if (object.ipCidrRange != null)
                                message.ipCidrRange = String(object.ipCidrRange);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SubnetworksExpandIpCidrRangeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest
                         * @static
                         * @param {google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest} message SubnetworksExpandIpCidrRangeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SubnetworksExpandIpCidrRangeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.ipCidrRange != null && message.hasOwnProperty("ipCidrRange")) {
                                object.ipCidrRange = message.ipCidrRange;
                                if (options.oneofs)
                                    object._ipCidrRange = "ipCidrRange";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SubnetworksExpandIpCidrRangeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SubnetworksExpandIpCidrRangeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SubnetworksExpandIpCidrRangeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SubnetworksExpandIpCidrRangeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SubnetworksExpandIpCidrRangeRequest";
                        };
    
                        return SubnetworksExpandIpCidrRangeRequest;
                    })();
    
                    v1.SubnetworksScopedList = (function() {
    
                        /**
                         * Properties of a SubnetworksScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface ISubnetworksScopedList
                         * @property {Array.<google.cloud.compute.v1.ISubnetwork>|null} [subnetworks] SubnetworksScopedList subnetworks
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] SubnetworksScopedList warning
                         */
    
                        /**
                         * Constructs a new SubnetworksScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SubnetworksScopedList.
                         * @implements ISubnetworksScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.ISubnetworksScopedList=} [properties] Properties to set
                         */
                        function SubnetworksScopedList(properties) {
                            this.subnetworks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SubnetworksScopedList subnetworks.
                         * @member {Array.<google.cloud.compute.v1.ISubnetwork>} subnetworks
                         * @memberof google.cloud.compute.v1.SubnetworksScopedList
                         * @instance
                         */
                        SubnetworksScopedList.prototype.subnetworks = $util.emptyArray;
    
                        /**
                         * SubnetworksScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.SubnetworksScopedList
                         * @instance
                         */
                        SubnetworksScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SubnetworksScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.SubnetworksScopedList
                         * @instance
                         */
                        Object.defineProperty(SubnetworksScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SubnetworksScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SubnetworksScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworksScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SubnetworksScopedList} SubnetworksScopedList instance
                         */
                        SubnetworksScopedList.create = function create(properties) {
                            return new SubnetworksScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified SubnetworksScopedList message. Does not implicitly {@link google.cloud.compute.v1.SubnetworksScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SubnetworksScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworksScopedList} message SubnetworksScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SubnetworksScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.subnetworks != null && message.subnetworks.length)
                                for (var i = 0; i < message.subnetworks.length; ++i)
                                    $root.google.cloud.compute.v1.Subnetwork.encode(message.subnetworks[i], writer.uint32(/* id 415853125, wireType 2 =*/3326825002).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SubnetworksScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SubnetworksScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SubnetworksScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworksScopedList} message SubnetworksScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SubnetworksScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SubnetworksScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SubnetworksScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SubnetworksScopedList} SubnetworksScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SubnetworksScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SubnetworksScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 415853125: {
                                        if (!(message.subnetworks && message.subnetworks.length))
                                            message.subnetworks = [];
                                        message.subnetworks.push($root.google.cloud.compute.v1.Subnetwork.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SubnetworksScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SubnetworksScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SubnetworksScopedList} SubnetworksScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SubnetworksScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SubnetworksScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SubnetworksScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SubnetworksScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.subnetworks != null && message.hasOwnProperty("subnetworks")) {
                                if (!Array.isArray(message.subnetworks))
                                    return "subnetworks: array expected";
                                for (var i = 0; i < message.subnetworks.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Subnetwork.verify(message.subnetworks[i]);
                                    if (error)
                                        return "subnetworks." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SubnetworksScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SubnetworksScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SubnetworksScopedList} SubnetworksScopedList
                         */
                        SubnetworksScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SubnetworksScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SubnetworksScopedList();
                            if (object.subnetworks) {
                                if (!Array.isArray(object.subnetworks))
                                    throw TypeError(".google.cloud.compute.v1.SubnetworksScopedList.subnetworks: array expected");
                                message.subnetworks = [];
                                for (var i = 0; i < object.subnetworks.length; ++i) {
                                    if (typeof object.subnetworks[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.SubnetworksScopedList.subnetworks: object expected");
                                    message.subnetworks[i] = $root.google.cloud.compute.v1.Subnetwork.fromObject(object.subnetworks[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.SubnetworksScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SubnetworksScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SubnetworksScopedList
                         * @static
                         * @param {google.cloud.compute.v1.SubnetworksScopedList} message SubnetworksScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SubnetworksScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.subnetworks = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.subnetworks && message.subnetworks.length) {
                                object.subnetworks = [];
                                for (var j = 0; j < message.subnetworks.length; ++j)
                                    object.subnetworks[j] = $root.google.cloud.compute.v1.Subnetwork.toObject(message.subnetworks[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SubnetworksScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SubnetworksScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SubnetworksScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SubnetworksScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SubnetworksScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SubnetworksScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SubnetworksScopedList";
                        };
    
                        return SubnetworksScopedList;
                    })();
    
                    v1.SubnetworksSetPrivateIpGoogleAccessRequest = (function() {
    
                        /**
                         * Properties of a SubnetworksSetPrivateIpGoogleAccessRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISubnetworksSetPrivateIpGoogleAccessRequest
                         * @property {boolean|null} [privateIpGoogleAccess] SubnetworksSetPrivateIpGoogleAccessRequest privateIpGoogleAccess
                         */
    
                        /**
                         * Constructs a new SubnetworksSetPrivateIpGoogleAccessRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SubnetworksSetPrivateIpGoogleAccessRequest.
                         * @implements ISubnetworksSetPrivateIpGoogleAccessRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISubnetworksSetPrivateIpGoogleAccessRequest=} [properties] Properties to set
                         */
                        function SubnetworksSetPrivateIpGoogleAccessRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SubnetworksSetPrivateIpGoogleAccessRequest privateIpGoogleAccess.
                         * @member {boolean|null|undefined} privateIpGoogleAccess
                         * @memberof google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest
                         * @instance
                         */
                        SubnetworksSetPrivateIpGoogleAccessRequest.prototype.privateIpGoogleAccess = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SubnetworksSetPrivateIpGoogleAccessRequest _privateIpGoogleAccess.
                         * @member {"privateIpGoogleAccess"|undefined} _privateIpGoogleAccess
                         * @memberof google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest
                         * @instance
                         */
                        Object.defineProperty(SubnetworksSetPrivateIpGoogleAccessRequest.prototype, "_privateIpGoogleAccess", {
                            get: $util.oneOfGetter($oneOfFields = ["privateIpGoogleAccess"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SubnetworksSetPrivateIpGoogleAccessRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworksSetPrivateIpGoogleAccessRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest} SubnetworksSetPrivateIpGoogleAccessRequest instance
                         */
                        SubnetworksSetPrivateIpGoogleAccessRequest.create = function create(properties) {
                            return new SubnetworksSetPrivateIpGoogleAccessRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SubnetworksSetPrivateIpGoogleAccessRequest message. Does not implicitly {@link google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworksSetPrivateIpGoogleAccessRequest} message SubnetworksSetPrivateIpGoogleAccessRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SubnetworksSetPrivateIpGoogleAccessRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.privateIpGoogleAccess != null && Object.hasOwnProperty.call(message, "privateIpGoogleAccess"))
                                writer.uint32(/* id 421491790, wireType 0 =*/3371934320).bool(message.privateIpGoogleAccess);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SubnetworksSetPrivateIpGoogleAccessRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISubnetworksSetPrivateIpGoogleAccessRequest} message SubnetworksSetPrivateIpGoogleAccessRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SubnetworksSetPrivateIpGoogleAccessRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SubnetworksSetPrivateIpGoogleAccessRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest} SubnetworksSetPrivateIpGoogleAccessRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SubnetworksSetPrivateIpGoogleAccessRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 421491790: {
                                        message.privateIpGoogleAccess = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SubnetworksSetPrivateIpGoogleAccessRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest} SubnetworksSetPrivateIpGoogleAccessRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SubnetworksSetPrivateIpGoogleAccessRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SubnetworksSetPrivateIpGoogleAccessRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SubnetworksSetPrivateIpGoogleAccessRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.privateIpGoogleAccess != null && message.hasOwnProperty("privateIpGoogleAccess")) {
                                properties._privateIpGoogleAccess = 1;
                                if (typeof message.privateIpGoogleAccess !== "boolean")
                                    return "privateIpGoogleAccess: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SubnetworksSetPrivateIpGoogleAccessRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest} SubnetworksSetPrivateIpGoogleAccessRequest
                         */
                        SubnetworksSetPrivateIpGoogleAccessRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest();
                            if (object.privateIpGoogleAccess != null)
                                message.privateIpGoogleAccess = Boolean(object.privateIpGoogleAccess);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SubnetworksSetPrivateIpGoogleAccessRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest
                         * @static
                         * @param {google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest} message SubnetworksSetPrivateIpGoogleAccessRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SubnetworksSetPrivateIpGoogleAccessRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.privateIpGoogleAccess != null && message.hasOwnProperty("privateIpGoogleAccess")) {
                                object.privateIpGoogleAccess = message.privateIpGoogleAccess;
                                if (options.oneofs)
                                    object._privateIpGoogleAccess = "privateIpGoogleAccess";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this SubnetworksSetPrivateIpGoogleAccessRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SubnetworksSetPrivateIpGoogleAccessRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SubnetworksSetPrivateIpGoogleAccessRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SubnetworksSetPrivateIpGoogleAccessRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SubnetworksSetPrivateIpGoogleAccessRequest";
                        };
    
                        return SubnetworksSetPrivateIpGoogleAccessRequest;
                    })();
    
                    v1.Subsetting = (function() {
    
                        /**
                         * Properties of a Subsetting.
                         * @memberof google.cloud.compute.v1
                         * @interface ISubsetting
                         * @property {string|null} [policy] Subsetting policy
                         */
    
                        /**
                         * Constructs a new Subsetting.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Subsetting.
                         * @implements ISubsetting
                         * @constructor
                         * @param {google.cloud.compute.v1.ISubsetting=} [properties] Properties to set
                         */
                        function Subsetting(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Subsetting policy.
                         * @member {string|null|undefined} policy
                         * @memberof google.cloud.compute.v1.Subsetting
                         * @instance
                         */
                        Subsetting.prototype.policy = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Subsetting _policy.
                         * @member {"policy"|undefined} _policy
                         * @memberof google.cloud.compute.v1.Subsetting
                         * @instance
                         */
                        Object.defineProperty(Subsetting.prototype, "_policy", {
                            get: $util.oneOfGetter($oneOfFields = ["policy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Subsetting instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Subsetting
                         * @static
                         * @param {google.cloud.compute.v1.ISubsetting=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Subsetting} Subsetting instance
                         */
                        Subsetting.create = function create(properties) {
                            return new Subsetting(properties);
                        };
    
                        /**
                         * Encodes the specified Subsetting message. Does not implicitly {@link google.cloud.compute.v1.Subsetting.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Subsetting
                         * @static
                         * @param {google.cloud.compute.v1.ISubsetting} message Subsetting message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Subsetting.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.policy != null && Object.hasOwnProperty.call(message, "policy"))
                                writer.uint32(/* id 91071794, wireType 2 =*/728574354).string(message.policy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Subsetting message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Subsetting.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Subsetting
                         * @static
                         * @param {google.cloud.compute.v1.ISubsetting} message Subsetting message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Subsetting.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Subsetting message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Subsetting
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Subsetting} Subsetting
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Subsetting.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Subsetting();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 91071794: {
                                        message.policy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Subsetting message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Subsetting
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Subsetting} Subsetting
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Subsetting.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Subsetting message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Subsetting
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Subsetting.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.policy != null && message.hasOwnProperty("policy")) {
                                properties._policy = 1;
                                if (!$util.isString(message.policy))
                                    return "policy: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Subsetting message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Subsetting
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Subsetting} Subsetting
                         */
                        Subsetting.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Subsetting)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Subsetting();
                            if (object.policy != null)
                                message.policy = String(object.policy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Subsetting message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Subsetting
                         * @static
                         * @param {google.cloud.compute.v1.Subsetting} message Subsetting
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Subsetting.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.policy != null && message.hasOwnProperty("policy")) {
                                object.policy = message.policy;
                                if (options.oneofs)
                                    object._policy = "policy";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Subsetting to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Subsetting
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Subsetting.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Subsetting
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Subsetting
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Subsetting.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Subsetting";
                        };
    
                        /**
                         * Policy enum.
                         * @name google.cloud.compute.v1.Subsetting.Policy
                         * @enum {number}
                         * @property {number} UNDEFINED_POLICY=0 UNDEFINED_POLICY value
                         * @property {number} CONSISTENT_HASH_SUBSETTING=108989492 CONSISTENT_HASH_SUBSETTING value
                         * @property {number} NONE=2402104 NONE value
                         */
                        Subsetting.Policy = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_POLICY"] = 0;
                            values[valuesById[108989492] = "CONSISTENT_HASH_SUBSETTING"] = 108989492;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            return values;
                        })();
    
                        return Subsetting;
                    })();
    
                    v1.SuspendInstanceRequest = (function() {
    
                        /**
                         * Properties of a SuspendInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISuspendInstanceRequest
                         * @property {string|null} [instance] SuspendInstanceRequest instance
                         * @property {string|null} [project] SuspendInstanceRequest project
                         * @property {string|null} [requestId] SuspendInstanceRequest requestId
                         * @property {string|null} [zone] SuspendInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new SuspendInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SuspendInstanceRequest.
                         * @implements ISuspendInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISuspendInstanceRequest=} [properties] Properties to set
                         */
                        function SuspendInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SuspendInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.SuspendInstanceRequest
                         * @instance
                         */
                        SuspendInstanceRequest.prototype.instance = "";
    
                        /**
                         * SuspendInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SuspendInstanceRequest
                         * @instance
                         */
                        SuspendInstanceRequest.prototype.project = "";
    
                        /**
                         * SuspendInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SuspendInstanceRequest
                         * @instance
                         */
                        SuspendInstanceRequest.prototype.requestId = null;
    
                        /**
                         * SuspendInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.SuspendInstanceRequest
                         * @instance
                         */
                        SuspendInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SuspendInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SuspendInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(SuspendInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SuspendInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SuspendInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISuspendInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SuspendInstanceRequest} SuspendInstanceRequest instance
                         */
                        SuspendInstanceRequest.create = function create(properties) {
                            return new SuspendInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SuspendInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.SuspendInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SuspendInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISuspendInstanceRequest} message SuspendInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SuspendInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SuspendInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SuspendInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SuspendInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISuspendInstanceRequest} message SuspendInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SuspendInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SuspendInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SuspendInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SuspendInstanceRequest} SuspendInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SuspendInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SuspendInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SuspendInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SuspendInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SuspendInstanceRequest} SuspendInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SuspendInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SuspendInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SuspendInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SuspendInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a SuspendInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SuspendInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SuspendInstanceRequest} SuspendInstanceRequest
                         */
                        SuspendInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SuspendInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SuspendInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SuspendInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SuspendInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.SuspendInstanceRequest} message SuspendInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SuspendInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this SuspendInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SuspendInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SuspendInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SuspendInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SuspendInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SuspendInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SuspendInstanceRequest";
                        };
    
                        return SuspendInstanceRequest;
                    })();
    
                    v1.SwitchToCustomModeNetworkRequest = (function() {
    
                        /**
                         * Properties of a SwitchToCustomModeNetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ISwitchToCustomModeNetworkRequest
                         * @property {string|null} [network] SwitchToCustomModeNetworkRequest network
                         * @property {string|null} [project] SwitchToCustomModeNetworkRequest project
                         * @property {string|null} [requestId] SwitchToCustomModeNetworkRequest requestId
                         */
    
                        /**
                         * Constructs a new SwitchToCustomModeNetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SwitchToCustomModeNetworkRequest.
                         * @implements ISwitchToCustomModeNetworkRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ISwitchToCustomModeNetworkRequest=} [properties] Properties to set
                         */
                        function SwitchToCustomModeNetworkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * SwitchToCustomModeNetworkRequest network.
                         * @member {string} network
                         * @memberof google.cloud.compute.v1.SwitchToCustomModeNetworkRequest
                         * @instance
                         */
                        SwitchToCustomModeNetworkRequest.prototype.network = "";
    
                        /**
                         * SwitchToCustomModeNetworkRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.SwitchToCustomModeNetworkRequest
                         * @instance
                         */
                        SwitchToCustomModeNetworkRequest.prototype.project = "";
    
                        /**
                         * SwitchToCustomModeNetworkRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.SwitchToCustomModeNetworkRequest
                         * @instance
                         */
                        SwitchToCustomModeNetworkRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * SwitchToCustomModeNetworkRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.SwitchToCustomModeNetworkRequest
                         * @instance
                         */
                        Object.defineProperty(SwitchToCustomModeNetworkRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new SwitchToCustomModeNetworkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.SwitchToCustomModeNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISwitchToCustomModeNetworkRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.SwitchToCustomModeNetworkRequest} SwitchToCustomModeNetworkRequest instance
                         */
                        SwitchToCustomModeNetworkRequest.create = function create(properties) {
                            return new SwitchToCustomModeNetworkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified SwitchToCustomModeNetworkRequest message. Does not implicitly {@link google.cloud.compute.v1.SwitchToCustomModeNetworkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.SwitchToCustomModeNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISwitchToCustomModeNetworkRequest} message SwitchToCustomModeNetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SwitchToCustomModeNetworkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified SwitchToCustomModeNetworkRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.SwitchToCustomModeNetworkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.SwitchToCustomModeNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.ISwitchToCustomModeNetworkRequest} message SwitchToCustomModeNetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        SwitchToCustomModeNetworkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a SwitchToCustomModeNetworkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.SwitchToCustomModeNetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.SwitchToCustomModeNetworkRequest} SwitchToCustomModeNetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SwitchToCustomModeNetworkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.SwitchToCustomModeNetworkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a SwitchToCustomModeNetworkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.SwitchToCustomModeNetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.SwitchToCustomModeNetworkRequest} SwitchToCustomModeNetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        SwitchToCustomModeNetworkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a SwitchToCustomModeNetworkRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.SwitchToCustomModeNetworkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        SwitchToCustomModeNetworkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.network != null && message.hasOwnProperty("network"))
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a SwitchToCustomModeNetworkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.SwitchToCustomModeNetworkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.SwitchToCustomModeNetworkRequest} SwitchToCustomModeNetworkRequest
                         */
                        SwitchToCustomModeNetworkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.SwitchToCustomModeNetworkRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.SwitchToCustomModeNetworkRequest();
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a SwitchToCustomModeNetworkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.SwitchToCustomModeNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.SwitchToCustomModeNetworkRequest} message SwitchToCustomModeNetworkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        SwitchToCustomModeNetworkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.network = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.network != null && message.hasOwnProperty("network"))
                                object.network = message.network;
                            return object;
                        };
    
                        /**
                         * Converts this SwitchToCustomModeNetworkRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.SwitchToCustomModeNetworkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        SwitchToCustomModeNetworkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for SwitchToCustomModeNetworkRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.SwitchToCustomModeNetworkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        SwitchToCustomModeNetworkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.SwitchToCustomModeNetworkRequest";
                        };
    
                        return SwitchToCustomModeNetworkRequest;
                    })();
    
                    v1.TCPHealthCheck = (function() {
    
                        /**
                         * Properties of a TCPHealthCheck.
                         * @memberof google.cloud.compute.v1
                         * @interface ITCPHealthCheck
                         * @property {number|null} [port] TCPHealthCheck port
                         * @property {string|null} [portName] TCPHealthCheck portName
                         * @property {string|null} [portSpecification] TCPHealthCheck portSpecification
                         * @property {string|null} [proxyHeader] TCPHealthCheck proxyHeader
                         * @property {string|null} [request] TCPHealthCheck request
                         * @property {string|null} [response] TCPHealthCheck response
                         */
    
                        /**
                         * Constructs a new TCPHealthCheck.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TCPHealthCheck.
                         * @implements ITCPHealthCheck
                         * @constructor
                         * @param {google.cloud.compute.v1.ITCPHealthCheck=} [properties] Properties to set
                         */
                        function TCPHealthCheck(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TCPHealthCheck port.
                         * @member {number|null|undefined} port
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @instance
                         */
                        TCPHealthCheck.prototype.port = null;
    
                        /**
                         * TCPHealthCheck portName.
                         * @member {string|null|undefined} portName
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @instance
                         */
                        TCPHealthCheck.prototype.portName = null;
    
                        /**
                         * TCPHealthCheck portSpecification.
                         * @member {string|null|undefined} portSpecification
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @instance
                         */
                        TCPHealthCheck.prototype.portSpecification = null;
    
                        /**
                         * TCPHealthCheck proxyHeader.
                         * @member {string|null|undefined} proxyHeader
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @instance
                         */
                        TCPHealthCheck.prototype.proxyHeader = null;
    
                        /**
                         * TCPHealthCheck request.
                         * @member {string|null|undefined} request
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @instance
                         */
                        TCPHealthCheck.prototype.request = null;
    
                        /**
                         * TCPHealthCheck response.
                         * @member {string|null|undefined} response
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @instance
                         */
                        TCPHealthCheck.prototype.response = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TCPHealthCheck _port.
                         * @member {"port"|undefined} _port
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @instance
                         */
                        Object.defineProperty(TCPHealthCheck.prototype, "_port", {
                            get: $util.oneOfGetter($oneOfFields = ["port"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TCPHealthCheck _portName.
                         * @member {"portName"|undefined} _portName
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @instance
                         */
                        Object.defineProperty(TCPHealthCheck.prototype, "_portName", {
                            get: $util.oneOfGetter($oneOfFields = ["portName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TCPHealthCheck _portSpecification.
                         * @member {"portSpecification"|undefined} _portSpecification
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @instance
                         */
                        Object.defineProperty(TCPHealthCheck.prototype, "_portSpecification", {
                            get: $util.oneOfGetter($oneOfFields = ["portSpecification"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TCPHealthCheck _proxyHeader.
                         * @member {"proxyHeader"|undefined} _proxyHeader
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @instance
                         */
                        Object.defineProperty(TCPHealthCheck.prototype, "_proxyHeader", {
                            get: $util.oneOfGetter($oneOfFields = ["proxyHeader"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TCPHealthCheck _request.
                         * @member {"request"|undefined} _request
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @instance
                         */
                        Object.defineProperty(TCPHealthCheck.prototype, "_request", {
                            get: $util.oneOfGetter($oneOfFields = ["request"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TCPHealthCheck _response.
                         * @member {"response"|undefined} _response
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @instance
                         */
                        Object.defineProperty(TCPHealthCheck.prototype, "_response", {
                            get: $util.oneOfGetter($oneOfFields = ["response"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TCPHealthCheck instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.ITCPHealthCheck=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TCPHealthCheck} TCPHealthCheck instance
                         */
                        TCPHealthCheck.create = function create(properties) {
                            return new TCPHealthCheck(properties);
                        };
    
                        /**
                         * Encodes the specified TCPHealthCheck message. Does not implicitly {@link google.cloud.compute.v1.TCPHealthCheck.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.ITCPHealthCheck} message TCPHealthCheck message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TCPHealthCheck.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.port != null && Object.hasOwnProperty.call(message, "port"))
                                writer.uint32(/* id 3446913, wireType 0 =*/27575304).int32(message.port);
                            if (message.request != null && Object.hasOwnProperty.call(message, "request"))
                                writer.uint32(/* id 21951119, wireType 2 =*/175608954).string(message.request);
                            if (message.portName != null && Object.hasOwnProperty.call(message, "portName"))
                                writer.uint32(/* id 41534345, wireType 2 =*/332274762).string(message.portName);
                            if (message.portSpecification != null && Object.hasOwnProperty.call(message, "portSpecification"))
                                writer.uint32(/* id 51590597, wireType 2 =*/412724778).string(message.portSpecification);
                            if (message.proxyHeader != null && Object.hasOwnProperty.call(message, "proxyHeader"))
                                writer.uint32(/* id 160374142, wireType 2 =*/1282993138).string(message.proxyHeader);
                            if (message.response != null && Object.hasOwnProperty.call(message, "response"))
                                writer.uint32(/* id 196547649, wireType 2 =*/1572381194).string(message.response);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TCPHealthCheck message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TCPHealthCheck.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.ITCPHealthCheck} message TCPHealthCheck message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TCPHealthCheck.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TCPHealthCheck message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TCPHealthCheck} TCPHealthCheck
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TCPHealthCheck.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TCPHealthCheck();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3446913: {
                                        message.port = reader.int32();
                                        break;
                                    }
                                case 41534345: {
                                        message.portName = reader.string();
                                        break;
                                    }
                                case 51590597: {
                                        message.portSpecification = reader.string();
                                        break;
                                    }
                                case 160374142: {
                                        message.proxyHeader = reader.string();
                                        break;
                                    }
                                case 21951119: {
                                        message.request = reader.string();
                                        break;
                                    }
                                case 196547649: {
                                        message.response = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TCPHealthCheck message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TCPHealthCheck} TCPHealthCheck
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TCPHealthCheck.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TCPHealthCheck message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TCPHealthCheck.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.port != null && message.hasOwnProperty("port")) {
                                properties._port = 1;
                                if (!$util.isInteger(message.port))
                                    return "port: integer expected";
                            }
                            if (message.portName != null && message.hasOwnProperty("portName")) {
                                properties._portName = 1;
                                if (!$util.isString(message.portName))
                                    return "portName: string expected";
                            }
                            if (message.portSpecification != null && message.hasOwnProperty("portSpecification")) {
                                properties._portSpecification = 1;
                                if (!$util.isString(message.portSpecification))
                                    return "portSpecification: string expected";
                            }
                            if (message.proxyHeader != null && message.hasOwnProperty("proxyHeader")) {
                                properties._proxyHeader = 1;
                                if (!$util.isString(message.proxyHeader))
                                    return "proxyHeader: string expected";
                            }
                            if (message.request != null && message.hasOwnProperty("request")) {
                                properties._request = 1;
                                if (!$util.isString(message.request))
                                    return "request: string expected";
                            }
                            if (message.response != null && message.hasOwnProperty("response")) {
                                properties._response = 1;
                                if (!$util.isString(message.response))
                                    return "response: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TCPHealthCheck message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TCPHealthCheck} TCPHealthCheck
                         */
                        TCPHealthCheck.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TCPHealthCheck)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TCPHealthCheck();
                            if (object.port != null)
                                message.port = object.port | 0;
                            if (object.portName != null)
                                message.portName = String(object.portName);
                            if (object.portSpecification != null)
                                message.portSpecification = String(object.portSpecification);
                            if (object.proxyHeader != null)
                                message.proxyHeader = String(object.proxyHeader);
                            if (object.request != null)
                                message.request = String(object.request);
                            if (object.response != null)
                                message.response = String(object.response);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TCPHealthCheck message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @static
                         * @param {google.cloud.compute.v1.TCPHealthCheck} message TCPHealthCheck
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TCPHealthCheck.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.port != null && message.hasOwnProperty("port")) {
                                object.port = message.port;
                                if (options.oneofs)
                                    object._port = "port";
                            }
                            if (message.request != null && message.hasOwnProperty("request")) {
                                object.request = message.request;
                                if (options.oneofs)
                                    object._request = "request";
                            }
                            if (message.portName != null && message.hasOwnProperty("portName")) {
                                object.portName = message.portName;
                                if (options.oneofs)
                                    object._portName = "portName";
                            }
                            if (message.portSpecification != null && message.hasOwnProperty("portSpecification")) {
                                object.portSpecification = message.portSpecification;
                                if (options.oneofs)
                                    object._portSpecification = "portSpecification";
                            }
                            if (message.proxyHeader != null && message.hasOwnProperty("proxyHeader")) {
                                object.proxyHeader = message.proxyHeader;
                                if (options.oneofs)
                                    object._proxyHeader = "proxyHeader";
                            }
                            if (message.response != null && message.hasOwnProperty("response")) {
                                object.response = message.response;
                                if (options.oneofs)
                                    object._response = "response";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TCPHealthCheck to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TCPHealthCheck.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TCPHealthCheck
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TCPHealthCheck
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TCPHealthCheck.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TCPHealthCheck";
                        };
    
                        /**
                         * PortSpecification enum.
                         * @name google.cloud.compute.v1.TCPHealthCheck.PortSpecification
                         * @enum {number}
                         * @property {number} UNDEFINED_PORT_SPECIFICATION=0 UNDEFINED_PORT_SPECIFICATION value
                         * @property {number} USE_FIXED_PORT=190235748 USE_FIXED_PORT value
                         * @property {number} USE_NAMED_PORT=349300671 USE_NAMED_PORT value
                         * @property {number} USE_SERVING_PORT=362637516 USE_SERVING_PORT value
                         */
                        TCPHealthCheck.PortSpecification = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PORT_SPECIFICATION"] = 0;
                            values[valuesById[190235748] = "USE_FIXED_PORT"] = 190235748;
                            values[valuesById[349300671] = "USE_NAMED_PORT"] = 349300671;
                            values[valuesById[362637516] = "USE_SERVING_PORT"] = 362637516;
                            return values;
                        })();
    
                        /**
                         * ProxyHeader enum.
                         * @name google.cloud.compute.v1.TCPHealthCheck.ProxyHeader
                         * @enum {number}
                         * @property {number} UNDEFINED_PROXY_HEADER=0 UNDEFINED_PROXY_HEADER value
                         * @property {number} NONE=2402104 NONE value
                         * @property {number} PROXY_V1=334352940 PROXY_V1 value
                         */
                        TCPHealthCheck.ProxyHeader = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PROXY_HEADER"] = 0;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            values[valuesById[334352940] = "PROXY_V1"] = 334352940;
                            return values;
                        })();
    
                        return TCPHealthCheck;
                    })();
    
                    v1.Tags = (function() {
    
                        /**
                         * Properties of a Tags.
                         * @memberof google.cloud.compute.v1
                         * @interface ITags
                         * @property {string|null} [fingerprint] Tags fingerprint
                         * @property {Array.<string>|null} [items] Tags items
                         */
    
                        /**
                         * Constructs a new Tags.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Tags.
                         * @implements ITags
                         * @constructor
                         * @param {google.cloud.compute.v1.ITags=} [properties] Properties to set
                         */
                        function Tags(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Tags fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.Tags
                         * @instance
                         */
                        Tags.prototype.fingerprint = null;
    
                        /**
                         * Tags items.
                         * @member {Array.<string>} items
                         * @memberof google.cloud.compute.v1.Tags
                         * @instance
                         */
                        Tags.prototype.items = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Tags _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.Tags
                         * @instance
                         */
                        Object.defineProperty(Tags.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Tags instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Tags
                         * @static
                         * @param {google.cloud.compute.v1.ITags=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Tags} Tags instance
                         */
                        Tags.create = function create(properties) {
                            return new Tags(properties);
                        };
    
                        /**
                         * Encodes the specified Tags message. Does not implicitly {@link google.cloud.compute.v1.Tags.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Tags
                         * @static
                         * @param {google.cloud.compute.v1.ITags} message Tags message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Tags.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).string(message.items[i]);
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Tags message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Tags.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Tags
                         * @static
                         * @param {google.cloud.compute.v1.ITags} message Tags message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Tags.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Tags message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Tags
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Tags} Tags
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Tags.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Tags();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Tags message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Tags
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Tags} Tags
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Tags.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Tags message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Tags
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Tags.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i)
                                    if (!$util.isString(message.items[i]))
                                        return "items: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Tags message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Tags
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Tags} Tags
                         */
                        Tags.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Tags)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Tags();
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.Tags.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i)
                                    message.items[i] = String(object.items[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Tags message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Tags
                         * @static
                         * @param {google.cloud.compute.v1.Tags} message Tags
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Tags.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = message.items[j];
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Tags to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Tags
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Tags.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Tags
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Tags
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Tags.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Tags";
                        };
    
                        return Tags;
                    })();
    
                    v1.TargetGrpcProxy = (function() {
    
                        /**
                         * Properties of a TargetGrpcProxy.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetGrpcProxy
                         * @property {string|null} [creationTimestamp] TargetGrpcProxy creationTimestamp
                         * @property {string|null} [description] TargetGrpcProxy description
                         * @property {string|null} [fingerprint] TargetGrpcProxy fingerprint
                         * @property {number|Long|null} [id] TargetGrpcProxy id
                         * @property {string|null} [kind] TargetGrpcProxy kind
                         * @property {string|null} [name] TargetGrpcProxy name
                         * @property {string|null} [selfLink] TargetGrpcProxy selfLink
                         * @property {string|null} [selfLinkWithId] TargetGrpcProxy selfLinkWithId
                         * @property {string|null} [urlMap] TargetGrpcProxy urlMap
                         * @property {boolean|null} [validateForProxyless] TargetGrpcProxy validateForProxyless
                         */
    
                        /**
                         * Constructs a new TargetGrpcProxy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetGrpcProxy.
                         * @implements ITargetGrpcProxy
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetGrpcProxy=} [properties] Properties to set
                         */
                        function TargetGrpcProxy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetGrpcProxy creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         */
                        TargetGrpcProxy.prototype.creationTimestamp = null;
    
                        /**
                         * TargetGrpcProxy description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         */
                        TargetGrpcProxy.prototype.description = null;
    
                        /**
                         * TargetGrpcProxy fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         */
                        TargetGrpcProxy.prototype.fingerprint = null;
    
                        /**
                         * TargetGrpcProxy id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         */
                        TargetGrpcProxy.prototype.id = null;
    
                        /**
                         * TargetGrpcProxy kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         */
                        TargetGrpcProxy.prototype.kind = null;
    
                        /**
                         * TargetGrpcProxy name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         */
                        TargetGrpcProxy.prototype.name = null;
    
                        /**
                         * TargetGrpcProxy selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         */
                        TargetGrpcProxy.prototype.selfLink = null;
    
                        /**
                         * TargetGrpcProxy selfLinkWithId.
                         * @member {string|null|undefined} selfLinkWithId
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         */
                        TargetGrpcProxy.prototype.selfLinkWithId = null;
    
                        /**
                         * TargetGrpcProxy urlMap.
                         * @member {string|null|undefined} urlMap
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         */
                        TargetGrpcProxy.prototype.urlMap = null;
    
                        /**
                         * TargetGrpcProxy validateForProxyless.
                         * @member {boolean|null|undefined} validateForProxyless
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         */
                        TargetGrpcProxy.prototype.validateForProxyless = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetGrpcProxy _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         */
                        Object.defineProperty(TargetGrpcProxy.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetGrpcProxy _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         */
                        Object.defineProperty(TargetGrpcProxy.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetGrpcProxy _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         */
                        Object.defineProperty(TargetGrpcProxy.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetGrpcProxy _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         */
                        Object.defineProperty(TargetGrpcProxy.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetGrpcProxy _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         */
                        Object.defineProperty(TargetGrpcProxy.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetGrpcProxy _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         */
                        Object.defineProperty(TargetGrpcProxy.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetGrpcProxy _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         */
                        Object.defineProperty(TargetGrpcProxy.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetGrpcProxy _selfLinkWithId.
                         * @member {"selfLinkWithId"|undefined} _selfLinkWithId
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         */
                        Object.defineProperty(TargetGrpcProxy.prototype, "_selfLinkWithId", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLinkWithId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetGrpcProxy _urlMap.
                         * @member {"urlMap"|undefined} _urlMap
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         */
                        Object.defineProperty(TargetGrpcProxy.prototype, "_urlMap", {
                            get: $util.oneOfGetter($oneOfFields = ["urlMap"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetGrpcProxy _validateForProxyless.
                         * @member {"validateForProxyless"|undefined} _validateForProxyless
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         */
                        Object.defineProperty(TargetGrpcProxy.prototype, "_validateForProxyless", {
                            get: $util.oneOfGetter($oneOfFields = ["validateForProxyless"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetGrpcProxy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @static
                         * @param {google.cloud.compute.v1.ITargetGrpcProxy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetGrpcProxy} TargetGrpcProxy instance
                         */
                        TargetGrpcProxy.create = function create(properties) {
                            return new TargetGrpcProxy(properties);
                        };
    
                        /**
                         * Encodes the specified TargetGrpcProxy message. Does not implicitly {@link google.cloud.compute.v1.TargetGrpcProxy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @static
                         * @param {google.cloud.compute.v1.ITargetGrpcProxy} message TargetGrpcProxy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetGrpcProxy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.selfLinkWithId != null && Object.hasOwnProperty.call(message, "selfLinkWithId"))
                                writer.uint32(/* id 44520962, wireType 2 =*/356167698).string(message.selfLinkWithId);
                            if (message.validateForProxyless != null && Object.hasOwnProperty.call(message, "validateForProxyless"))
                                writer.uint32(/* id 101822888, wireType 0 =*/814583104).bool(message.validateForProxyless);
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.urlMap != null && Object.hasOwnProperty.call(message, "urlMap"))
                                writer.uint32(/* id 367020684, wireType 2 =*/2936165474).string(message.urlMap);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetGrpcProxy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetGrpcProxy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @static
                         * @param {google.cloud.compute.v1.ITargetGrpcProxy} message TargetGrpcProxy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetGrpcProxy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetGrpcProxy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetGrpcProxy} TargetGrpcProxy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetGrpcProxy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetGrpcProxy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 44520962: {
                                        message.selfLinkWithId = reader.string();
                                        break;
                                    }
                                case 367020684: {
                                        message.urlMap = reader.string();
                                        break;
                                    }
                                case 101822888: {
                                        message.validateForProxyless = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetGrpcProxy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetGrpcProxy} TargetGrpcProxy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetGrpcProxy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetGrpcProxy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetGrpcProxy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.selfLinkWithId != null && message.hasOwnProperty("selfLinkWithId")) {
                                properties._selfLinkWithId = 1;
                                if (!$util.isString(message.selfLinkWithId))
                                    return "selfLinkWithId: string expected";
                            }
                            if (message.urlMap != null && message.hasOwnProperty("urlMap")) {
                                properties._urlMap = 1;
                                if (!$util.isString(message.urlMap))
                                    return "urlMap: string expected";
                            }
                            if (message.validateForProxyless != null && message.hasOwnProperty("validateForProxyless")) {
                                properties._validateForProxyless = 1;
                                if (typeof message.validateForProxyless !== "boolean")
                                    return "validateForProxyless: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetGrpcProxy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetGrpcProxy} TargetGrpcProxy
                         */
                        TargetGrpcProxy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetGrpcProxy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetGrpcProxy();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.selfLinkWithId != null)
                                message.selfLinkWithId = String(object.selfLinkWithId);
                            if (object.urlMap != null)
                                message.urlMap = String(object.urlMap);
                            if (object.validateForProxyless != null)
                                message.validateForProxyless = Boolean(object.validateForProxyless);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetGrpcProxy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @static
                         * @param {google.cloud.compute.v1.TargetGrpcProxy} message TargetGrpcProxy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetGrpcProxy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.selfLinkWithId != null && message.hasOwnProperty("selfLinkWithId")) {
                                object.selfLinkWithId = message.selfLinkWithId;
                                if (options.oneofs)
                                    object._selfLinkWithId = "selfLinkWithId";
                            }
                            if (message.validateForProxyless != null && message.hasOwnProperty("validateForProxyless")) {
                                object.validateForProxyless = message.validateForProxyless;
                                if (options.oneofs)
                                    object._validateForProxyless = "validateForProxyless";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.urlMap != null && message.hasOwnProperty("urlMap")) {
                                object.urlMap = message.urlMap;
                                if (options.oneofs)
                                    object._urlMap = "urlMap";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetGrpcProxy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetGrpcProxy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetGrpcProxy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetGrpcProxy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetGrpcProxy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetGrpcProxy";
                        };
    
                        return TargetGrpcProxy;
                    })();
    
                    v1.TargetGrpcProxyList = (function() {
    
                        /**
                         * Properties of a TargetGrpcProxyList.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetGrpcProxyList
                         * @property {string|null} [id] TargetGrpcProxyList id
                         * @property {Array.<google.cloud.compute.v1.ITargetGrpcProxy>|null} [items] TargetGrpcProxyList items
                         * @property {string|null} [kind] TargetGrpcProxyList kind
                         * @property {string|null} [nextPageToken] TargetGrpcProxyList nextPageToken
                         * @property {string|null} [selfLink] TargetGrpcProxyList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] TargetGrpcProxyList warning
                         */
    
                        /**
                         * Constructs a new TargetGrpcProxyList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetGrpcProxyList.
                         * @implements ITargetGrpcProxyList
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetGrpcProxyList=} [properties] Properties to set
                         */
                        function TargetGrpcProxyList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetGrpcProxyList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @instance
                         */
                        TargetGrpcProxyList.prototype.id = null;
    
                        /**
                         * TargetGrpcProxyList items.
                         * @member {Array.<google.cloud.compute.v1.ITargetGrpcProxy>} items
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @instance
                         */
                        TargetGrpcProxyList.prototype.items = $util.emptyArray;
    
                        /**
                         * TargetGrpcProxyList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @instance
                         */
                        TargetGrpcProxyList.prototype.kind = null;
    
                        /**
                         * TargetGrpcProxyList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @instance
                         */
                        TargetGrpcProxyList.prototype.nextPageToken = null;
    
                        /**
                         * TargetGrpcProxyList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @instance
                         */
                        TargetGrpcProxyList.prototype.selfLink = null;
    
                        /**
                         * TargetGrpcProxyList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @instance
                         */
                        TargetGrpcProxyList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetGrpcProxyList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetGrpcProxyList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetGrpcProxyList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetGrpcProxyList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetGrpcProxyList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetGrpcProxyList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetGrpcProxyList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetGrpcProxyList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetGrpcProxyList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetGrpcProxyList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetGrpcProxyList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetGrpcProxyList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetGrpcProxyList} TargetGrpcProxyList instance
                         */
                        TargetGrpcProxyList.create = function create(properties) {
                            return new TargetGrpcProxyList(properties);
                        };
    
                        /**
                         * Encodes the specified TargetGrpcProxyList message. Does not implicitly {@link google.cloud.compute.v1.TargetGrpcProxyList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetGrpcProxyList} message TargetGrpcProxyList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetGrpcProxyList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.TargetGrpcProxy.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetGrpcProxyList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetGrpcProxyList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetGrpcProxyList} message TargetGrpcProxyList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetGrpcProxyList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetGrpcProxyList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetGrpcProxyList} TargetGrpcProxyList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetGrpcProxyList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetGrpcProxyList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.TargetGrpcProxy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetGrpcProxyList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetGrpcProxyList} TargetGrpcProxyList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetGrpcProxyList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetGrpcProxyList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetGrpcProxyList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.TargetGrpcProxy.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetGrpcProxyList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetGrpcProxyList} TargetGrpcProxyList
                         */
                        TargetGrpcProxyList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetGrpcProxyList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetGrpcProxyList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.TargetGrpcProxyList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetGrpcProxyList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.TargetGrpcProxy.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetGrpcProxyList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetGrpcProxyList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @static
                         * @param {google.cloud.compute.v1.TargetGrpcProxyList} message TargetGrpcProxyList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetGrpcProxyList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.TargetGrpcProxy.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetGrpcProxyList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetGrpcProxyList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetGrpcProxyList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetGrpcProxyList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetGrpcProxyList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetGrpcProxyList";
                        };
    
                        return TargetGrpcProxyList;
                    })();
    
                    v1.TargetHttpProxiesScopedList = (function() {
    
                        /**
                         * Properties of a TargetHttpProxiesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetHttpProxiesScopedList
                         * @property {Array.<google.cloud.compute.v1.ITargetHttpProxy>|null} [targetHttpProxies] TargetHttpProxiesScopedList targetHttpProxies
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] TargetHttpProxiesScopedList warning
                         */
    
                        /**
                         * Constructs a new TargetHttpProxiesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetHttpProxiesScopedList.
                         * @implements ITargetHttpProxiesScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetHttpProxiesScopedList=} [properties] Properties to set
                         */
                        function TargetHttpProxiesScopedList(properties) {
                            this.targetHttpProxies = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetHttpProxiesScopedList targetHttpProxies.
                         * @member {Array.<google.cloud.compute.v1.ITargetHttpProxy>} targetHttpProxies
                         * @memberof google.cloud.compute.v1.TargetHttpProxiesScopedList
                         * @instance
                         */
                        TargetHttpProxiesScopedList.prototype.targetHttpProxies = $util.emptyArray;
    
                        /**
                         * TargetHttpProxiesScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.TargetHttpProxiesScopedList
                         * @instance
                         */
                        TargetHttpProxiesScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetHttpProxiesScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.TargetHttpProxiesScopedList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpProxiesScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetHttpProxiesScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetHttpProxiesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpProxiesScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetHttpProxiesScopedList} TargetHttpProxiesScopedList instance
                         */
                        TargetHttpProxiesScopedList.create = function create(properties) {
                            return new TargetHttpProxiesScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified TargetHttpProxiesScopedList message. Does not implicitly {@link google.cloud.compute.v1.TargetHttpProxiesScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetHttpProxiesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpProxiesScopedList} message TargetHttpProxiesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpProxiesScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.targetHttpProxies != null && message.targetHttpProxies.length)
                                for (var i = 0; i < message.targetHttpProxies.length; ++i)
                                    $root.google.cloud.compute.v1.TargetHttpProxy.encode(message.targetHttpProxies[i], writer.uint32(/* id 162147011, wireType 2 =*/1297176090).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetHttpProxiesScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetHttpProxiesScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpProxiesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpProxiesScopedList} message TargetHttpProxiesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpProxiesScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetHttpProxiesScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetHttpProxiesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetHttpProxiesScopedList} TargetHttpProxiesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpProxiesScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetHttpProxiesScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 162147011: {
                                        if (!(message.targetHttpProxies && message.targetHttpProxies.length))
                                            message.targetHttpProxies = [];
                                        message.targetHttpProxies.push($root.google.cloud.compute.v1.TargetHttpProxy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetHttpProxiesScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpProxiesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetHttpProxiesScopedList} TargetHttpProxiesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpProxiesScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetHttpProxiesScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetHttpProxiesScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetHttpProxiesScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.targetHttpProxies != null && message.hasOwnProperty("targetHttpProxies")) {
                                if (!Array.isArray(message.targetHttpProxies))
                                    return "targetHttpProxies: array expected";
                                for (var i = 0; i < message.targetHttpProxies.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.TargetHttpProxy.verify(message.targetHttpProxies[i]);
                                    if (error)
                                        return "targetHttpProxies." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetHttpProxiesScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetHttpProxiesScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetHttpProxiesScopedList} TargetHttpProxiesScopedList
                         */
                        TargetHttpProxiesScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetHttpProxiesScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetHttpProxiesScopedList();
                            if (object.targetHttpProxies) {
                                if (!Array.isArray(object.targetHttpProxies))
                                    throw TypeError(".google.cloud.compute.v1.TargetHttpProxiesScopedList.targetHttpProxies: array expected");
                                message.targetHttpProxies = [];
                                for (var i = 0; i < object.targetHttpProxies.length; ++i) {
                                    if (typeof object.targetHttpProxies[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetHttpProxiesScopedList.targetHttpProxies: object expected");
                                    message.targetHttpProxies[i] = $root.google.cloud.compute.v1.TargetHttpProxy.fromObject(object.targetHttpProxies[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetHttpProxiesScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetHttpProxiesScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetHttpProxiesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.TargetHttpProxiesScopedList} message TargetHttpProxiesScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetHttpProxiesScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.targetHttpProxies = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.targetHttpProxies && message.targetHttpProxies.length) {
                                object.targetHttpProxies = [];
                                for (var j = 0; j < message.targetHttpProxies.length; ++j)
                                    object.targetHttpProxies[j] = $root.google.cloud.compute.v1.TargetHttpProxy.toObject(message.targetHttpProxies[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetHttpProxiesScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetHttpProxiesScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetHttpProxiesScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetHttpProxiesScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetHttpProxiesScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetHttpProxiesScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetHttpProxiesScopedList";
                        };
    
                        return TargetHttpProxiesScopedList;
                    })();
    
                    v1.TargetHttpProxy = (function() {
    
                        /**
                         * Properties of a TargetHttpProxy.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetHttpProxy
                         * @property {string|null} [creationTimestamp] TargetHttpProxy creationTimestamp
                         * @property {string|null} [description] TargetHttpProxy description
                         * @property {string|null} [fingerprint] TargetHttpProxy fingerprint
                         * @property {number|Long|null} [id] TargetHttpProxy id
                         * @property {string|null} [kind] TargetHttpProxy kind
                         * @property {string|null} [name] TargetHttpProxy name
                         * @property {boolean|null} [proxyBind] TargetHttpProxy proxyBind
                         * @property {string|null} [region] TargetHttpProxy region
                         * @property {string|null} [selfLink] TargetHttpProxy selfLink
                         * @property {string|null} [urlMap] TargetHttpProxy urlMap
                         */
    
                        /**
                         * Constructs a new TargetHttpProxy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetHttpProxy.
                         * @implements ITargetHttpProxy
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetHttpProxy=} [properties] Properties to set
                         */
                        function TargetHttpProxy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetHttpProxy creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         */
                        TargetHttpProxy.prototype.creationTimestamp = null;
    
                        /**
                         * TargetHttpProxy description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         */
                        TargetHttpProxy.prototype.description = null;
    
                        /**
                         * TargetHttpProxy fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         */
                        TargetHttpProxy.prototype.fingerprint = null;
    
                        /**
                         * TargetHttpProxy id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         */
                        TargetHttpProxy.prototype.id = null;
    
                        /**
                         * TargetHttpProxy kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         */
                        TargetHttpProxy.prototype.kind = null;
    
                        /**
                         * TargetHttpProxy name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         */
                        TargetHttpProxy.prototype.name = null;
    
                        /**
                         * TargetHttpProxy proxyBind.
                         * @member {boolean|null|undefined} proxyBind
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         */
                        TargetHttpProxy.prototype.proxyBind = null;
    
                        /**
                         * TargetHttpProxy region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         */
                        TargetHttpProxy.prototype.region = null;
    
                        /**
                         * TargetHttpProxy selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         */
                        TargetHttpProxy.prototype.selfLink = null;
    
                        /**
                         * TargetHttpProxy urlMap.
                         * @member {string|null|undefined} urlMap
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         */
                        TargetHttpProxy.prototype.urlMap = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetHttpProxy _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpProxy.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpProxy _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpProxy.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpProxy _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpProxy.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpProxy _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpProxy.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpProxy _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpProxy.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpProxy _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpProxy.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpProxy _proxyBind.
                         * @member {"proxyBind"|undefined} _proxyBind
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpProxy.prototype, "_proxyBind", {
                            get: $util.oneOfGetter($oneOfFields = ["proxyBind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpProxy _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpProxy.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpProxy _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpProxy.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpProxy _urlMap.
                         * @member {"urlMap"|undefined} _urlMap
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpProxy.prototype, "_urlMap", {
                            get: $util.oneOfGetter($oneOfFields = ["urlMap"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetHttpProxy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpProxy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetHttpProxy} TargetHttpProxy instance
                         */
                        TargetHttpProxy.create = function create(properties) {
                            return new TargetHttpProxy(properties);
                        };
    
                        /**
                         * Encodes the specified TargetHttpProxy message. Does not implicitly {@link google.cloud.compute.v1.TargetHttpProxy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpProxy} message TargetHttpProxy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpProxy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.proxyBind != null && Object.hasOwnProperty.call(message, "proxyBind"))
                                writer.uint32(/* id 286025582, wireType 0 =*/2288204656).bool(message.proxyBind);
                            if (message.urlMap != null && Object.hasOwnProperty.call(message, "urlMap"))
                                writer.uint32(/* id 367020684, wireType 2 =*/2936165474).string(message.urlMap);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetHttpProxy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetHttpProxy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpProxy} message TargetHttpProxy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpProxy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetHttpProxy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetHttpProxy} TargetHttpProxy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpProxy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetHttpProxy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 286025582: {
                                        message.proxyBind = reader.bool();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 367020684: {
                                        message.urlMap = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetHttpProxy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetHttpProxy} TargetHttpProxy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpProxy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetHttpProxy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetHttpProxy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.proxyBind != null && message.hasOwnProperty("proxyBind")) {
                                properties._proxyBind = 1;
                                if (typeof message.proxyBind !== "boolean")
                                    return "proxyBind: boolean expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.urlMap != null && message.hasOwnProperty("urlMap")) {
                                properties._urlMap = 1;
                                if (!$util.isString(message.urlMap))
                                    return "urlMap: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetHttpProxy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetHttpProxy} TargetHttpProxy
                         */
                        TargetHttpProxy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetHttpProxy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetHttpProxy();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.proxyBind != null)
                                message.proxyBind = Boolean(object.proxyBind);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.urlMap != null)
                                message.urlMap = String(object.urlMap);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetHttpProxy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @static
                         * @param {google.cloud.compute.v1.TargetHttpProxy} message TargetHttpProxy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetHttpProxy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.proxyBind != null && message.hasOwnProperty("proxyBind")) {
                                object.proxyBind = message.proxyBind;
                                if (options.oneofs)
                                    object._proxyBind = "proxyBind";
                            }
                            if (message.urlMap != null && message.hasOwnProperty("urlMap")) {
                                object.urlMap = message.urlMap;
                                if (options.oneofs)
                                    object._urlMap = "urlMap";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetHttpProxy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetHttpProxy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetHttpProxy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetHttpProxy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetHttpProxy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetHttpProxy";
                        };
    
                        return TargetHttpProxy;
                    })();
    
                    v1.TargetHttpProxyAggregatedList = (function() {
    
                        /**
                         * Properties of a TargetHttpProxyAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetHttpProxyAggregatedList
                         * @property {string|null} [id] TargetHttpProxyAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.ITargetHttpProxiesScopedList>|null} [items] TargetHttpProxyAggregatedList items
                         * @property {string|null} [kind] TargetHttpProxyAggregatedList kind
                         * @property {string|null} [nextPageToken] TargetHttpProxyAggregatedList nextPageToken
                         * @property {string|null} [selfLink] TargetHttpProxyAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] TargetHttpProxyAggregatedList unreachables
                         */
    
                        /**
                         * Constructs a new TargetHttpProxyAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetHttpProxyAggregatedList.
                         * @implements ITargetHttpProxyAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetHttpProxyAggregatedList=} [properties] Properties to set
                         */
                        function TargetHttpProxyAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetHttpProxyAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetHttpProxyAggregatedList
                         * @instance
                         */
                        TargetHttpProxyAggregatedList.prototype.id = null;
    
                        /**
                         * TargetHttpProxyAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.ITargetHttpProxiesScopedList>} items
                         * @memberof google.cloud.compute.v1.TargetHttpProxyAggregatedList
                         * @instance
                         */
                        TargetHttpProxyAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * TargetHttpProxyAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetHttpProxyAggregatedList
                         * @instance
                         */
                        TargetHttpProxyAggregatedList.prototype.kind = null;
    
                        /**
                         * TargetHttpProxyAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.TargetHttpProxyAggregatedList
                         * @instance
                         */
                        TargetHttpProxyAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * TargetHttpProxyAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetHttpProxyAggregatedList
                         * @instance
                         */
                        TargetHttpProxyAggregatedList.prototype.selfLink = null;
    
                        /**
                         * TargetHttpProxyAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.TargetHttpProxyAggregatedList
                         * @instance
                         */
                        TargetHttpProxyAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetHttpProxyAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetHttpProxyAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpProxyAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpProxyAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetHttpProxyAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpProxyAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpProxyAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.TargetHttpProxyAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpProxyAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpProxyAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetHttpProxyAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpProxyAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetHttpProxyAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetHttpProxyAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpProxyAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetHttpProxyAggregatedList} TargetHttpProxyAggregatedList instance
                         */
                        TargetHttpProxyAggregatedList.create = function create(properties) {
                            return new TargetHttpProxyAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified TargetHttpProxyAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.TargetHttpProxyAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetHttpProxyAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpProxyAggregatedList} message TargetHttpProxyAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpProxyAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.TargetHttpProxiesScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetHttpProxyAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetHttpProxyAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpProxyAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpProxyAggregatedList} message TargetHttpProxyAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpProxyAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetHttpProxyAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetHttpProxyAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetHttpProxyAggregatedList} TargetHttpProxyAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpProxyAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetHttpProxyAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.TargetHttpProxiesScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetHttpProxyAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpProxyAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetHttpProxyAggregatedList} TargetHttpProxyAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpProxyAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetHttpProxyAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetHttpProxyAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetHttpProxyAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.TargetHttpProxiesScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetHttpProxyAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetHttpProxyAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetHttpProxyAggregatedList} TargetHttpProxyAggregatedList
                         */
                        TargetHttpProxyAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetHttpProxyAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetHttpProxyAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetHttpProxyAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetHttpProxyAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.TargetHttpProxiesScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.TargetHttpProxyAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetHttpProxyAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetHttpProxyAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.TargetHttpProxyAggregatedList} message TargetHttpProxyAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetHttpProxyAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.TargetHttpProxiesScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetHttpProxyAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetHttpProxyAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetHttpProxyAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetHttpProxyAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetHttpProxyAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetHttpProxyAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetHttpProxyAggregatedList";
                        };
    
                        return TargetHttpProxyAggregatedList;
                    })();
    
                    v1.TargetHttpProxyList = (function() {
    
                        /**
                         * Properties of a TargetHttpProxyList.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetHttpProxyList
                         * @property {string|null} [id] TargetHttpProxyList id
                         * @property {Array.<google.cloud.compute.v1.ITargetHttpProxy>|null} [items] TargetHttpProxyList items
                         * @property {string|null} [kind] TargetHttpProxyList kind
                         * @property {string|null} [nextPageToken] TargetHttpProxyList nextPageToken
                         * @property {string|null} [selfLink] TargetHttpProxyList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] TargetHttpProxyList warning
                         */
    
                        /**
                         * Constructs a new TargetHttpProxyList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetHttpProxyList.
                         * @implements ITargetHttpProxyList
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetHttpProxyList=} [properties] Properties to set
                         */
                        function TargetHttpProxyList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetHttpProxyList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @instance
                         */
                        TargetHttpProxyList.prototype.id = null;
    
                        /**
                         * TargetHttpProxyList items.
                         * @member {Array.<google.cloud.compute.v1.ITargetHttpProxy>} items
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @instance
                         */
                        TargetHttpProxyList.prototype.items = $util.emptyArray;
    
                        /**
                         * TargetHttpProxyList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @instance
                         */
                        TargetHttpProxyList.prototype.kind = null;
    
                        /**
                         * TargetHttpProxyList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @instance
                         */
                        TargetHttpProxyList.prototype.nextPageToken = null;
    
                        /**
                         * TargetHttpProxyList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @instance
                         */
                        TargetHttpProxyList.prototype.selfLink = null;
    
                        /**
                         * TargetHttpProxyList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @instance
                         */
                        TargetHttpProxyList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetHttpProxyList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpProxyList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpProxyList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpProxyList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpProxyList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpProxyList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpProxyList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpProxyList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpProxyList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpProxyList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetHttpProxyList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpProxyList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetHttpProxyList} TargetHttpProxyList instance
                         */
                        TargetHttpProxyList.create = function create(properties) {
                            return new TargetHttpProxyList(properties);
                        };
    
                        /**
                         * Encodes the specified TargetHttpProxyList message. Does not implicitly {@link google.cloud.compute.v1.TargetHttpProxyList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpProxyList} message TargetHttpProxyList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpProxyList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.TargetHttpProxy.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetHttpProxyList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetHttpProxyList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpProxyList} message TargetHttpProxyList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpProxyList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetHttpProxyList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetHttpProxyList} TargetHttpProxyList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpProxyList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetHttpProxyList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.TargetHttpProxy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetHttpProxyList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetHttpProxyList} TargetHttpProxyList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpProxyList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetHttpProxyList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetHttpProxyList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.TargetHttpProxy.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetHttpProxyList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetHttpProxyList} TargetHttpProxyList
                         */
                        TargetHttpProxyList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetHttpProxyList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetHttpProxyList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.TargetHttpProxyList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetHttpProxyList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.TargetHttpProxy.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetHttpProxyList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetHttpProxyList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @static
                         * @param {google.cloud.compute.v1.TargetHttpProxyList} message TargetHttpProxyList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetHttpProxyList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.TargetHttpProxy.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetHttpProxyList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetHttpProxyList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetHttpProxyList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetHttpProxyList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetHttpProxyList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetHttpProxyList";
                        };
    
                        return TargetHttpProxyList;
                    })();
    
                    v1.TargetHttpsProxiesScopedList = (function() {
    
                        /**
                         * Properties of a TargetHttpsProxiesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetHttpsProxiesScopedList
                         * @property {Array.<google.cloud.compute.v1.ITargetHttpsProxy>|null} [targetHttpsProxies] TargetHttpsProxiesScopedList targetHttpsProxies
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] TargetHttpsProxiesScopedList warning
                         */
    
                        /**
                         * Constructs a new TargetHttpsProxiesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetHttpsProxiesScopedList.
                         * @implements ITargetHttpsProxiesScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetHttpsProxiesScopedList=} [properties] Properties to set
                         */
                        function TargetHttpsProxiesScopedList(properties) {
                            this.targetHttpsProxies = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetHttpsProxiesScopedList targetHttpsProxies.
                         * @member {Array.<google.cloud.compute.v1.ITargetHttpsProxy>} targetHttpsProxies
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesScopedList
                         * @instance
                         */
                        TargetHttpsProxiesScopedList.prototype.targetHttpsProxies = $util.emptyArray;
    
                        /**
                         * TargetHttpsProxiesScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesScopedList
                         * @instance
                         */
                        TargetHttpsProxiesScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetHttpsProxiesScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesScopedList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxiesScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetHttpsProxiesScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxiesScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetHttpsProxiesScopedList} TargetHttpsProxiesScopedList instance
                         */
                        TargetHttpsProxiesScopedList.create = function create(properties) {
                            return new TargetHttpsProxiesScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified TargetHttpsProxiesScopedList message. Does not implicitly {@link google.cloud.compute.v1.TargetHttpsProxiesScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxiesScopedList} message TargetHttpsProxiesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpsProxiesScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.targetHttpsProxies != null && message.targetHttpsProxies.length)
                                for (var i = 0; i < message.targetHttpsProxies.length; ++i)
                                    $root.google.cloud.compute.v1.TargetHttpsProxy.encode(message.targetHttpsProxies[i], writer.uint32(/* id 366607882, wireType 2 =*/2932863058).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetHttpsProxiesScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetHttpsProxiesScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxiesScopedList} message TargetHttpsProxiesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpsProxiesScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetHttpsProxiesScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetHttpsProxiesScopedList} TargetHttpsProxiesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpsProxiesScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetHttpsProxiesScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 366607882: {
                                        if (!(message.targetHttpsProxies && message.targetHttpsProxies.length))
                                            message.targetHttpsProxies = [];
                                        message.targetHttpsProxies.push($root.google.cloud.compute.v1.TargetHttpsProxy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetHttpsProxiesScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetHttpsProxiesScopedList} TargetHttpsProxiesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpsProxiesScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetHttpsProxiesScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetHttpsProxiesScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.targetHttpsProxies != null && message.hasOwnProperty("targetHttpsProxies")) {
                                if (!Array.isArray(message.targetHttpsProxies))
                                    return "targetHttpsProxies: array expected";
                                for (var i = 0; i < message.targetHttpsProxies.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.TargetHttpsProxy.verify(message.targetHttpsProxies[i]);
                                    if (error)
                                        return "targetHttpsProxies." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetHttpsProxiesScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetHttpsProxiesScopedList} TargetHttpsProxiesScopedList
                         */
                        TargetHttpsProxiesScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetHttpsProxiesScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetHttpsProxiesScopedList();
                            if (object.targetHttpsProxies) {
                                if (!Array.isArray(object.targetHttpsProxies))
                                    throw TypeError(".google.cloud.compute.v1.TargetHttpsProxiesScopedList.targetHttpsProxies: array expected");
                                message.targetHttpsProxies = [];
                                for (var i = 0; i < object.targetHttpsProxies.length; ++i) {
                                    if (typeof object.targetHttpsProxies[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetHttpsProxiesScopedList.targetHttpsProxies: object expected");
                                    message.targetHttpsProxies[i] = $root.google.cloud.compute.v1.TargetHttpsProxy.fromObject(object.targetHttpsProxies[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetHttpsProxiesScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetHttpsProxiesScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.TargetHttpsProxiesScopedList} message TargetHttpsProxiesScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetHttpsProxiesScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.targetHttpsProxies = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.targetHttpsProxies && message.targetHttpsProxies.length) {
                                object.targetHttpsProxies = [];
                                for (var j = 0; j < message.targetHttpsProxies.length; ++j)
                                    object.targetHttpsProxies[j] = $root.google.cloud.compute.v1.TargetHttpsProxy.toObject(message.targetHttpsProxies[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetHttpsProxiesScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetHttpsProxiesScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetHttpsProxiesScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetHttpsProxiesScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetHttpsProxiesScopedList";
                        };
    
                        return TargetHttpsProxiesScopedList;
                    })();
    
                    v1.TargetHttpsProxiesSetCertificateMapRequest = (function() {
    
                        /**
                         * Properties of a TargetHttpsProxiesSetCertificateMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetHttpsProxiesSetCertificateMapRequest
                         * @property {string|null} [certificateMap] TargetHttpsProxiesSetCertificateMapRequest certificateMap
                         */
    
                        /**
                         * Constructs a new TargetHttpsProxiesSetCertificateMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetHttpsProxiesSetCertificateMapRequest.
                         * @implements ITargetHttpsProxiesSetCertificateMapRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetHttpsProxiesSetCertificateMapRequest=} [properties] Properties to set
                         */
                        function TargetHttpsProxiesSetCertificateMapRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetHttpsProxiesSetCertificateMapRequest certificateMap.
                         * @member {string|null|undefined} certificateMap
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest
                         * @instance
                         */
                        TargetHttpsProxiesSetCertificateMapRequest.prototype.certificateMap = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetHttpsProxiesSetCertificateMapRequest _certificateMap.
                         * @member {"certificateMap"|undefined} _certificateMap
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxiesSetCertificateMapRequest.prototype, "_certificateMap", {
                            get: $util.oneOfGetter($oneOfFields = ["certificateMap"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetHttpsProxiesSetCertificateMapRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxiesSetCertificateMapRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest} TargetHttpsProxiesSetCertificateMapRequest instance
                         */
                        TargetHttpsProxiesSetCertificateMapRequest.create = function create(properties) {
                            return new TargetHttpsProxiesSetCertificateMapRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TargetHttpsProxiesSetCertificateMapRequest message. Does not implicitly {@link google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxiesSetCertificateMapRequest} message TargetHttpsProxiesSetCertificateMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpsProxiesSetCertificateMapRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.certificateMap != null && Object.hasOwnProperty.call(message, "certificateMap"))
                                writer.uint32(/* id 156463796, wireType 2 =*/1251710370).string(message.certificateMap);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetHttpsProxiesSetCertificateMapRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxiesSetCertificateMapRequest} message TargetHttpsProxiesSetCertificateMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpsProxiesSetCertificateMapRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetHttpsProxiesSetCertificateMapRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest} TargetHttpsProxiesSetCertificateMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpsProxiesSetCertificateMapRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 156463796: {
                                        message.certificateMap = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetHttpsProxiesSetCertificateMapRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest} TargetHttpsProxiesSetCertificateMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpsProxiesSetCertificateMapRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetHttpsProxiesSetCertificateMapRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetHttpsProxiesSetCertificateMapRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.certificateMap != null && message.hasOwnProperty("certificateMap")) {
                                properties._certificateMap = 1;
                                if (!$util.isString(message.certificateMap))
                                    return "certificateMap: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetHttpsProxiesSetCertificateMapRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest} TargetHttpsProxiesSetCertificateMapRequest
                         */
                        TargetHttpsProxiesSetCertificateMapRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest();
                            if (object.certificateMap != null)
                                message.certificateMap = String(object.certificateMap);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetHttpsProxiesSetCertificateMapRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest} message TargetHttpsProxiesSetCertificateMapRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetHttpsProxiesSetCertificateMapRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.certificateMap != null && message.hasOwnProperty("certificateMap")) {
                                object.certificateMap = message.certificateMap;
                                if (options.oneofs)
                                    object._certificateMap = "certificateMap";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetHttpsProxiesSetCertificateMapRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetHttpsProxiesSetCertificateMapRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetHttpsProxiesSetCertificateMapRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetHttpsProxiesSetCertificateMapRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetHttpsProxiesSetCertificateMapRequest";
                        };
    
                        return TargetHttpsProxiesSetCertificateMapRequest;
                    })();
    
                    v1.TargetHttpsProxiesSetQuicOverrideRequest = (function() {
    
                        /**
                         * Properties of a TargetHttpsProxiesSetQuicOverrideRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetHttpsProxiesSetQuicOverrideRequest
                         * @property {string|null} [quicOverride] TargetHttpsProxiesSetQuicOverrideRequest quicOverride
                         */
    
                        /**
                         * Constructs a new TargetHttpsProxiesSetQuicOverrideRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetHttpsProxiesSetQuicOverrideRequest.
                         * @implements ITargetHttpsProxiesSetQuicOverrideRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetHttpsProxiesSetQuicOverrideRequest=} [properties] Properties to set
                         */
                        function TargetHttpsProxiesSetQuicOverrideRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetHttpsProxiesSetQuicOverrideRequest quicOverride.
                         * @member {string|null|undefined} quicOverride
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest
                         * @instance
                         */
                        TargetHttpsProxiesSetQuicOverrideRequest.prototype.quicOverride = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetHttpsProxiesSetQuicOverrideRequest _quicOverride.
                         * @member {"quicOverride"|undefined} _quicOverride
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxiesSetQuicOverrideRequest.prototype, "_quicOverride", {
                            get: $util.oneOfGetter($oneOfFields = ["quicOverride"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetHttpsProxiesSetQuicOverrideRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxiesSetQuicOverrideRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest} TargetHttpsProxiesSetQuicOverrideRequest instance
                         */
                        TargetHttpsProxiesSetQuicOverrideRequest.create = function create(properties) {
                            return new TargetHttpsProxiesSetQuicOverrideRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TargetHttpsProxiesSetQuicOverrideRequest message. Does not implicitly {@link google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxiesSetQuicOverrideRequest} message TargetHttpsProxiesSetQuicOverrideRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpsProxiesSetQuicOverrideRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.quicOverride != null && Object.hasOwnProperty.call(message, "quicOverride"))
                                writer.uint32(/* id 456577197, wireType 2 =*/3652617578).string(message.quicOverride);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetHttpsProxiesSetQuicOverrideRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxiesSetQuicOverrideRequest} message TargetHttpsProxiesSetQuicOverrideRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpsProxiesSetQuicOverrideRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetHttpsProxiesSetQuicOverrideRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest} TargetHttpsProxiesSetQuicOverrideRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpsProxiesSetQuicOverrideRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 456577197: {
                                        message.quicOverride = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetHttpsProxiesSetQuicOverrideRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest} TargetHttpsProxiesSetQuicOverrideRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpsProxiesSetQuicOverrideRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetHttpsProxiesSetQuicOverrideRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetHttpsProxiesSetQuicOverrideRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.quicOverride != null && message.hasOwnProperty("quicOverride")) {
                                properties._quicOverride = 1;
                                if (!$util.isString(message.quicOverride))
                                    return "quicOverride: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetHttpsProxiesSetQuicOverrideRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest} TargetHttpsProxiesSetQuicOverrideRequest
                         */
                        TargetHttpsProxiesSetQuicOverrideRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest();
                            if (object.quicOverride != null)
                                message.quicOverride = String(object.quicOverride);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetHttpsProxiesSetQuicOverrideRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest
                         * @static
                         * @param {google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest} message TargetHttpsProxiesSetQuicOverrideRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetHttpsProxiesSetQuicOverrideRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.quicOverride != null && message.hasOwnProperty("quicOverride")) {
                                object.quicOverride = message.quicOverride;
                                if (options.oneofs)
                                    object._quicOverride = "quicOverride";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetHttpsProxiesSetQuicOverrideRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetHttpsProxiesSetQuicOverrideRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetHttpsProxiesSetQuicOverrideRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetHttpsProxiesSetQuicOverrideRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest";
                        };
    
                        /**
                         * QuicOverride enum.
                         * @name google.cloud.compute.v1.TargetHttpsProxiesSetQuicOverrideRequest.QuicOverride
                         * @enum {number}
                         * @property {number} UNDEFINED_QUIC_OVERRIDE=0 UNDEFINED_QUIC_OVERRIDE value
                         * @property {number} DISABLE=241807048 DISABLE value
                         * @property {number} ENABLE=438835587 ENABLE value
                         * @property {number} NONE=2402104 NONE value
                         */
                        TargetHttpsProxiesSetQuicOverrideRequest.QuicOverride = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_QUIC_OVERRIDE"] = 0;
                            values[valuesById[241807048] = "DISABLE"] = 241807048;
                            values[valuesById[438835587] = "ENABLE"] = 438835587;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            return values;
                        })();
    
                        return TargetHttpsProxiesSetQuicOverrideRequest;
                    })();
    
                    v1.TargetHttpsProxiesSetSslCertificatesRequest = (function() {
    
                        /**
                         * Properties of a TargetHttpsProxiesSetSslCertificatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetHttpsProxiesSetSslCertificatesRequest
                         * @property {Array.<string>|null} [sslCertificates] TargetHttpsProxiesSetSslCertificatesRequest sslCertificates
                         */
    
                        /**
                         * Constructs a new TargetHttpsProxiesSetSslCertificatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetHttpsProxiesSetSslCertificatesRequest.
                         * @implements ITargetHttpsProxiesSetSslCertificatesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetHttpsProxiesSetSslCertificatesRequest=} [properties] Properties to set
                         */
                        function TargetHttpsProxiesSetSslCertificatesRequest(properties) {
                            this.sslCertificates = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetHttpsProxiesSetSslCertificatesRequest sslCertificates.
                         * @member {Array.<string>} sslCertificates
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest
                         * @instance
                         */
                        TargetHttpsProxiesSetSslCertificatesRequest.prototype.sslCertificates = $util.emptyArray;
    
                        /**
                         * Creates a new TargetHttpsProxiesSetSslCertificatesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxiesSetSslCertificatesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest} TargetHttpsProxiesSetSslCertificatesRequest instance
                         */
                        TargetHttpsProxiesSetSslCertificatesRequest.create = function create(properties) {
                            return new TargetHttpsProxiesSetSslCertificatesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TargetHttpsProxiesSetSslCertificatesRequest message. Does not implicitly {@link google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxiesSetSslCertificatesRequest} message TargetHttpsProxiesSetSslCertificatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpsProxiesSetSslCertificatesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.sslCertificates != null && message.sslCertificates.length)
                                for (var i = 0; i < message.sslCertificates.length; ++i)
                                    writer.uint32(/* id 366006543, wireType 2 =*/2928052346).string(message.sslCertificates[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetHttpsProxiesSetSslCertificatesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxiesSetSslCertificatesRequest} message TargetHttpsProxiesSetSslCertificatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpsProxiesSetSslCertificatesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetHttpsProxiesSetSslCertificatesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest} TargetHttpsProxiesSetSslCertificatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpsProxiesSetSslCertificatesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 366006543: {
                                        if (!(message.sslCertificates && message.sslCertificates.length))
                                            message.sslCertificates = [];
                                        message.sslCertificates.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetHttpsProxiesSetSslCertificatesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest} TargetHttpsProxiesSetSslCertificatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpsProxiesSetSslCertificatesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetHttpsProxiesSetSslCertificatesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetHttpsProxiesSetSslCertificatesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.sslCertificates != null && message.hasOwnProperty("sslCertificates")) {
                                if (!Array.isArray(message.sslCertificates))
                                    return "sslCertificates: array expected";
                                for (var i = 0; i < message.sslCertificates.length; ++i)
                                    if (!$util.isString(message.sslCertificates[i]))
                                        return "sslCertificates: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetHttpsProxiesSetSslCertificatesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest} TargetHttpsProxiesSetSslCertificatesRequest
                         */
                        TargetHttpsProxiesSetSslCertificatesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest();
                            if (object.sslCertificates) {
                                if (!Array.isArray(object.sslCertificates))
                                    throw TypeError(".google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest.sslCertificates: array expected");
                                message.sslCertificates = [];
                                for (var i = 0; i < object.sslCertificates.length; ++i)
                                    message.sslCertificates[i] = String(object.sslCertificates[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetHttpsProxiesSetSslCertificatesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest} message TargetHttpsProxiesSetSslCertificatesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetHttpsProxiesSetSslCertificatesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.sslCertificates = [];
                            if (message.sslCertificates && message.sslCertificates.length) {
                                object.sslCertificates = [];
                                for (var j = 0; j < message.sslCertificates.length; ++j)
                                    object.sslCertificates[j] = message.sslCertificates[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetHttpsProxiesSetSslCertificatesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetHttpsProxiesSetSslCertificatesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetHttpsProxiesSetSslCertificatesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetHttpsProxiesSetSslCertificatesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetHttpsProxiesSetSslCertificatesRequest";
                        };
    
                        return TargetHttpsProxiesSetSslCertificatesRequest;
                    })();
    
                    v1.TargetHttpsProxy = (function() {
    
                        /**
                         * Properties of a TargetHttpsProxy.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetHttpsProxy
                         * @property {string|null} [authorizationPolicy] TargetHttpsProxy authorizationPolicy
                         * @property {string|null} [certificateMap] TargetHttpsProxy certificateMap
                         * @property {string|null} [creationTimestamp] TargetHttpsProxy creationTimestamp
                         * @property {string|null} [description] TargetHttpsProxy description
                         * @property {string|null} [fingerprint] TargetHttpsProxy fingerprint
                         * @property {number|Long|null} [id] TargetHttpsProxy id
                         * @property {string|null} [kind] TargetHttpsProxy kind
                         * @property {string|null} [name] TargetHttpsProxy name
                         * @property {boolean|null} [proxyBind] TargetHttpsProxy proxyBind
                         * @property {string|null} [quicOverride] TargetHttpsProxy quicOverride
                         * @property {string|null} [region] TargetHttpsProxy region
                         * @property {string|null} [selfLink] TargetHttpsProxy selfLink
                         * @property {string|null} [serverTlsPolicy] TargetHttpsProxy serverTlsPolicy
                         * @property {Array.<string>|null} [sslCertificates] TargetHttpsProxy sslCertificates
                         * @property {string|null} [sslPolicy] TargetHttpsProxy sslPolicy
                         * @property {string|null} [urlMap] TargetHttpsProxy urlMap
                         */
    
                        /**
                         * Constructs a new TargetHttpsProxy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetHttpsProxy.
                         * @implements ITargetHttpsProxy
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetHttpsProxy=} [properties] Properties to set
                         */
                        function TargetHttpsProxy(properties) {
                            this.sslCertificates = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetHttpsProxy authorizationPolicy.
                         * @member {string|null|undefined} authorizationPolicy
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        TargetHttpsProxy.prototype.authorizationPolicy = null;
    
                        /**
                         * TargetHttpsProxy certificateMap.
                         * @member {string|null|undefined} certificateMap
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        TargetHttpsProxy.prototype.certificateMap = null;
    
                        /**
                         * TargetHttpsProxy creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        TargetHttpsProxy.prototype.creationTimestamp = null;
    
                        /**
                         * TargetHttpsProxy description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        TargetHttpsProxy.prototype.description = null;
    
                        /**
                         * TargetHttpsProxy fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        TargetHttpsProxy.prototype.fingerprint = null;
    
                        /**
                         * TargetHttpsProxy id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        TargetHttpsProxy.prototype.id = null;
    
                        /**
                         * TargetHttpsProxy kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        TargetHttpsProxy.prototype.kind = null;
    
                        /**
                         * TargetHttpsProxy name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        TargetHttpsProxy.prototype.name = null;
    
                        /**
                         * TargetHttpsProxy proxyBind.
                         * @member {boolean|null|undefined} proxyBind
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        TargetHttpsProxy.prototype.proxyBind = null;
    
                        /**
                         * TargetHttpsProxy quicOverride.
                         * @member {string|null|undefined} quicOverride
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        TargetHttpsProxy.prototype.quicOverride = null;
    
                        /**
                         * TargetHttpsProxy region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        TargetHttpsProxy.prototype.region = null;
    
                        /**
                         * TargetHttpsProxy selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        TargetHttpsProxy.prototype.selfLink = null;
    
                        /**
                         * TargetHttpsProxy serverTlsPolicy.
                         * @member {string|null|undefined} serverTlsPolicy
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        TargetHttpsProxy.prototype.serverTlsPolicy = null;
    
                        /**
                         * TargetHttpsProxy sslCertificates.
                         * @member {Array.<string>} sslCertificates
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        TargetHttpsProxy.prototype.sslCertificates = $util.emptyArray;
    
                        /**
                         * TargetHttpsProxy sslPolicy.
                         * @member {string|null|undefined} sslPolicy
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        TargetHttpsProxy.prototype.sslPolicy = null;
    
                        /**
                         * TargetHttpsProxy urlMap.
                         * @member {string|null|undefined} urlMap
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        TargetHttpsProxy.prototype.urlMap = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetHttpsProxy _authorizationPolicy.
                         * @member {"authorizationPolicy"|undefined} _authorizationPolicy
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxy.prototype, "_authorizationPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["authorizationPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxy _certificateMap.
                         * @member {"certificateMap"|undefined} _certificateMap
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxy.prototype, "_certificateMap", {
                            get: $util.oneOfGetter($oneOfFields = ["certificateMap"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxy _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxy.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxy _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxy.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxy _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxy.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxy _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxy.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxy _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxy.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxy _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxy.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxy _proxyBind.
                         * @member {"proxyBind"|undefined} _proxyBind
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxy.prototype, "_proxyBind", {
                            get: $util.oneOfGetter($oneOfFields = ["proxyBind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxy _quicOverride.
                         * @member {"quicOverride"|undefined} _quicOverride
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxy.prototype, "_quicOverride", {
                            get: $util.oneOfGetter($oneOfFields = ["quicOverride"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxy _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxy.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxy _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxy.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxy _serverTlsPolicy.
                         * @member {"serverTlsPolicy"|undefined} _serverTlsPolicy
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxy.prototype, "_serverTlsPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["serverTlsPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxy _sslPolicy.
                         * @member {"sslPolicy"|undefined} _sslPolicy
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxy.prototype, "_sslPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["sslPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxy _urlMap.
                         * @member {"urlMap"|undefined} _urlMap
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxy.prototype, "_urlMap", {
                            get: $util.oneOfGetter($oneOfFields = ["urlMap"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetHttpsProxy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetHttpsProxy} TargetHttpsProxy instance
                         */
                        TargetHttpsProxy.create = function create(properties) {
                            return new TargetHttpsProxy(properties);
                        };
    
                        /**
                         * Encodes the specified TargetHttpsProxy message. Does not implicitly {@link google.cloud.compute.v1.TargetHttpsProxy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxy} message TargetHttpsProxy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpsProxy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.authorizationPolicy != null && Object.hasOwnProperty.call(message, "authorizationPolicy"))
                                writer.uint32(/* id 33945528, wireType 2 =*/271564226).string(message.authorizationPolicy);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.certificateMap != null && Object.hasOwnProperty.call(message, "certificateMap"))
                                writer.uint32(/* id 156463796, wireType 2 =*/1251710370).string(message.certificateMap);
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.proxyBind != null && Object.hasOwnProperty.call(message, "proxyBind"))
                                writer.uint32(/* id 286025582, wireType 0 =*/2288204656).bool(message.proxyBind);
                            if (message.sslPolicy != null && Object.hasOwnProperty.call(message, "sslPolicy"))
                                writer.uint32(/* id 295190213, wireType 2 =*/2361521706).string(message.sslPolicy);
                            if (message.serverTlsPolicy != null && Object.hasOwnProperty.call(message, "serverTlsPolicy"))
                                writer.uint32(/* id 295825266, wireType 2 =*/2366602130).string(message.serverTlsPolicy);
                            if (message.sslCertificates != null && message.sslCertificates.length)
                                for (var i = 0; i < message.sslCertificates.length; ++i)
                                    writer.uint32(/* id 366006543, wireType 2 =*/2928052346).string(message.sslCertificates[i]);
                            if (message.urlMap != null && Object.hasOwnProperty.call(message, "urlMap"))
                                writer.uint32(/* id 367020684, wireType 2 =*/2936165474).string(message.urlMap);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.quicOverride != null && Object.hasOwnProperty.call(message, "quicOverride"))
                                writer.uint32(/* id 456577197, wireType 2 =*/3652617578).string(message.quicOverride);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetHttpsProxy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetHttpsProxy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxy} message TargetHttpsProxy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpsProxy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetHttpsProxy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetHttpsProxy} TargetHttpsProxy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpsProxy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetHttpsProxy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 33945528: {
                                        message.authorizationPolicy = reader.string();
                                        break;
                                    }
                                case 156463796: {
                                        message.certificateMap = reader.string();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 286025582: {
                                        message.proxyBind = reader.bool();
                                        break;
                                    }
                                case 456577197: {
                                        message.quicOverride = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 295825266: {
                                        message.serverTlsPolicy = reader.string();
                                        break;
                                    }
                                case 366006543: {
                                        if (!(message.sslCertificates && message.sslCertificates.length))
                                            message.sslCertificates = [];
                                        message.sslCertificates.push(reader.string());
                                        break;
                                    }
                                case 295190213: {
                                        message.sslPolicy = reader.string();
                                        break;
                                    }
                                case 367020684: {
                                        message.urlMap = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetHttpsProxy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetHttpsProxy} TargetHttpsProxy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpsProxy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetHttpsProxy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetHttpsProxy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.authorizationPolicy != null && message.hasOwnProperty("authorizationPolicy")) {
                                properties._authorizationPolicy = 1;
                                if (!$util.isString(message.authorizationPolicy))
                                    return "authorizationPolicy: string expected";
                            }
                            if (message.certificateMap != null && message.hasOwnProperty("certificateMap")) {
                                properties._certificateMap = 1;
                                if (!$util.isString(message.certificateMap))
                                    return "certificateMap: string expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.proxyBind != null && message.hasOwnProperty("proxyBind")) {
                                properties._proxyBind = 1;
                                if (typeof message.proxyBind !== "boolean")
                                    return "proxyBind: boolean expected";
                            }
                            if (message.quicOverride != null && message.hasOwnProperty("quicOverride")) {
                                properties._quicOverride = 1;
                                if (!$util.isString(message.quicOverride))
                                    return "quicOverride: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.serverTlsPolicy != null && message.hasOwnProperty("serverTlsPolicy")) {
                                properties._serverTlsPolicy = 1;
                                if (!$util.isString(message.serverTlsPolicy))
                                    return "serverTlsPolicy: string expected";
                            }
                            if (message.sslCertificates != null && message.hasOwnProperty("sslCertificates")) {
                                if (!Array.isArray(message.sslCertificates))
                                    return "sslCertificates: array expected";
                                for (var i = 0; i < message.sslCertificates.length; ++i)
                                    if (!$util.isString(message.sslCertificates[i]))
                                        return "sslCertificates: string[] expected";
                            }
                            if (message.sslPolicy != null && message.hasOwnProperty("sslPolicy")) {
                                properties._sslPolicy = 1;
                                if (!$util.isString(message.sslPolicy))
                                    return "sslPolicy: string expected";
                            }
                            if (message.urlMap != null && message.hasOwnProperty("urlMap")) {
                                properties._urlMap = 1;
                                if (!$util.isString(message.urlMap))
                                    return "urlMap: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetHttpsProxy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetHttpsProxy} TargetHttpsProxy
                         */
                        TargetHttpsProxy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetHttpsProxy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetHttpsProxy();
                            if (object.authorizationPolicy != null)
                                message.authorizationPolicy = String(object.authorizationPolicy);
                            if (object.certificateMap != null)
                                message.certificateMap = String(object.certificateMap);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.proxyBind != null)
                                message.proxyBind = Boolean(object.proxyBind);
                            if (object.quicOverride != null)
                                message.quicOverride = String(object.quicOverride);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.serverTlsPolicy != null)
                                message.serverTlsPolicy = String(object.serverTlsPolicy);
                            if (object.sslCertificates) {
                                if (!Array.isArray(object.sslCertificates))
                                    throw TypeError(".google.cloud.compute.v1.TargetHttpsProxy.sslCertificates: array expected");
                                message.sslCertificates = [];
                                for (var i = 0; i < object.sslCertificates.length; ++i)
                                    message.sslCertificates[i] = String(object.sslCertificates[i]);
                            }
                            if (object.sslPolicy != null)
                                message.sslPolicy = String(object.sslPolicy);
                            if (object.urlMap != null)
                                message.urlMap = String(object.urlMap);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetHttpsProxy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @static
                         * @param {google.cloud.compute.v1.TargetHttpsProxy} message TargetHttpsProxy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetHttpsProxy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.sslCertificates = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.authorizationPolicy != null && message.hasOwnProperty("authorizationPolicy")) {
                                object.authorizationPolicy = message.authorizationPolicy;
                                if (options.oneofs)
                                    object._authorizationPolicy = "authorizationPolicy";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.certificateMap != null && message.hasOwnProperty("certificateMap")) {
                                object.certificateMap = message.certificateMap;
                                if (options.oneofs)
                                    object._certificateMap = "certificateMap";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.proxyBind != null && message.hasOwnProperty("proxyBind")) {
                                object.proxyBind = message.proxyBind;
                                if (options.oneofs)
                                    object._proxyBind = "proxyBind";
                            }
                            if (message.sslPolicy != null && message.hasOwnProperty("sslPolicy")) {
                                object.sslPolicy = message.sslPolicy;
                                if (options.oneofs)
                                    object._sslPolicy = "sslPolicy";
                            }
                            if (message.serverTlsPolicy != null && message.hasOwnProperty("serverTlsPolicy")) {
                                object.serverTlsPolicy = message.serverTlsPolicy;
                                if (options.oneofs)
                                    object._serverTlsPolicy = "serverTlsPolicy";
                            }
                            if (message.sslCertificates && message.sslCertificates.length) {
                                object.sslCertificates = [];
                                for (var j = 0; j < message.sslCertificates.length; ++j)
                                    object.sslCertificates[j] = message.sslCertificates[j];
                            }
                            if (message.urlMap != null && message.hasOwnProperty("urlMap")) {
                                object.urlMap = message.urlMap;
                                if (options.oneofs)
                                    object._urlMap = "urlMap";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.quicOverride != null && message.hasOwnProperty("quicOverride")) {
                                object.quicOverride = message.quicOverride;
                                if (options.oneofs)
                                    object._quicOverride = "quicOverride";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetHttpsProxy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetHttpsProxy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetHttpsProxy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetHttpsProxy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetHttpsProxy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetHttpsProxy";
                        };
    
                        /**
                         * QuicOverride enum.
                         * @name google.cloud.compute.v1.TargetHttpsProxy.QuicOverride
                         * @enum {number}
                         * @property {number} UNDEFINED_QUIC_OVERRIDE=0 UNDEFINED_QUIC_OVERRIDE value
                         * @property {number} DISABLE=241807048 DISABLE value
                         * @property {number} ENABLE=438835587 ENABLE value
                         * @property {number} NONE=2402104 NONE value
                         */
                        TargetHttpsProxy.QuicOverride = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_QUIC_OVERRIDE"] = 0;
                            values[valuesById[241807048] = "DISABLE"] = 241807048;
                            values[valuesById[438835587] = "ENABLE"] = 438835587;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            return values;
                        })();
    
                        return TargetHttpsProxy;
                    })();
    
                    v1.TargetHttpsProxyAggregatedList = (function() {
    
                        /**
                         * Properties of a TargetHttpsProxyAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetHttpsProxyAggregatedList
                         * @property {string|null} [id] TargetHttpsProxyAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.ITargetHttpsProxiesScopedList>|null} [items] TargetHttpsProxyAggregatedList items
                         * @property {string|null} [kind] TargetHttpsProxyAggregatedList kind
                         * @property {string|null} [nextPageToken] TargetHttpsProxyAggregatedList nextPageToken
                         * @property {string|null} [selfLink] TargetHttpsProxyAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] TargetHttpsProxyAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] TargetHttpsProxyAggregatedList warning
                         */
    
                        /**
                         * Constructs a new TargetHttpsProxyAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetHttpsProxyAggregatedList.
                         * @implements ITargetHttpsProxyAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetHttpsProxyAggregatedList=} [properties] Properties to set
                         */
                        function TargetHttpsProxyAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetHttpsProxyAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @instance
                         */
                        TargetHttpsProxyAggregatedList.prototype.id = null;
    
                        /**
                         * TargetHttpsProxyAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.ITargetHttpsProxiesScopedList>} items
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @instance
                         */
                        TargetHttpsProxyAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * TargetHttpsProxyAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @instance
                         */
                        TargetHttpsProxyAggregatedList.prototype.kind = null;
    
                        /**
                         * TargetHttpsProxyAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @instance
                         */
                        TargetHttpsProxyAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * TargetHttpsProxyAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @instance
                         */
                        TargetHttpsProxyAggregatedList.prototype.selfLink = null;
    
                        /**
                         * TargetHttpsProxyAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @instance
                         */
                        TargetHttpsProxyAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * TargetHttpsProxyAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @instance
                         */
                        TargetHttpsProxyAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetHttpsProxyAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxyAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxyAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxyAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxyAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxyAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxyAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxyAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxyAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxyAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetHttpsProxyAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxyAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetHttpsProxyAggregatedList} TargetHttpsProxyAggregatedList instance
                         */
                        TargetHttpsProxyAggregatedList.create = function create(properties) {
                            return new TargetHttpsProxyAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified TargetHttpsProxyAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.TargetHttpsProxyAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxyAggregatedList} message TargetHttpsProxyAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpsProxyAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.TargetHttpsProxiesScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetHttpsProxyAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetHttpsProxyAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxyAggregatedList} message TargetHttpsProxyAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpsProxyAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetHttpsProxyAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetHttpsProxyAggregatedList} TargetHttpsProxyAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpsProxyAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetHttpsProxyAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.TargetHttpsProxiesScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetHttpsProxyAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetHttpsProxyAggregatedList} TargetHttpsProxyAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpsProxyAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetHttpsProxyAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetHttpsProxyAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.TargetHttpsProxiesScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetHttpsProxyAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetHttpsProxyAggregatedList} TargetHttpsProxyAggregatedList
                         */
                        TargetHttpsProxyAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetHttpsProxyAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetHttpsProxyAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetHttpsProxyAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetHttpsProxyAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.TargetHttpsProxiesScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.TargetHttpsProxyAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetHttpsProxyAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetHttpsProxyAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.TargetHttpsProxyAggregatedList} message TargetHttpsProxyAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetHttpsProxyAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.TargetHttpsProxiesScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetHttpsProxyAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetHttpsProxyAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetHttpsProxyAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetHttpsProxyAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetHttpsProxyAggregatedList";
                        };
    
                        return TargetHttpsProxyAggregatedList;
                    })();
    
                    v1.TargetHttpsProxyList = (function() {
    
                        /**
                         * Properties of a TargetHttpsProxyList.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetHttpsProxyList
                         * @property {string|null} [id] TargetHttpsProxyList id
                         * @property {Array.<google.cloud.compute.v1.ITargetHttpsProxy>|null} [items] TargetHttpsProxyList items
                         * @property {string|null} [kind] TargetHttpsProxyList kind
                         * @property {string|null} [nextPageToken] TargetHttpsProxyList nextPageToken
                         * @property {string|null} [selfLink] TargetHttpsProxyList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] TargetHttpsProxyList warning
                         */
    
                        /**
                         * Constructs a new TargetHttpsProxyList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetHttpsProxyList.
                         * @implements ITargetHttpsProxyList
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetHttpsProxyList=} [properties] Properties to set
                         */
                        function TargetHttpsProxyList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetHttpsProxyList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @instance
                         */
                        TargetHttpsProxyList.prototype.id = null;
    
                        /**
                         * TargetHttpsProxyList items.
                         * @member {Array.<google.cloud.compute.v1.ITargetHttpsProxy>} items
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @instance
                         */
                        TargetHttpsProxyList.prototype.items = $util.emptyArray;
    
                        /**
                         * TargetHttpsProxyList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @instance
                         */
                        TargetHttpsProxyList.prototype.kind = null;
    
                        /**
                         * TargetHttpsProxyList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @instance
                         */
                        TargetHttpsProxyList.prototype.nextPageToken = null;
    
                        /**
                         * TargetHttpsProxyList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @instance
                         */
                        TargetHttpsProxyList.prototype.selfLink = null;
    
                        /**
                         * TargetHttpsProxyList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @instance
                         */
                        TargetHttpsProxyList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetHttpsProxyList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxyList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxyList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxyList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxyList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxyList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxyList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxyList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetHttpsProxyList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetHttpsProxyList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetHttpsProxyList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxyList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetHttpsProxyList} TargetHttpsProxyList instance
                         */
                        TargetHttpsProxyList.create = function create(properties) {
                            return new TargetHttpsProxyList(properties);
                        };
    
                        /**
                         * Encodes the specified TargetHttpsProxyList message. Does not implicitly {@link google.cloud.compute.v1.TargetHttpsProxyList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxyList} message TargetHttpsProxyList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpsProxyList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.TargetHttpsProxy.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetHttpsProxyList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetHttpsProxyList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetHttpsProxyList} message TargetHttpsProxyList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetHttpsProxyList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetHttpsProxyList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetHttpsProxyList} TargetHttpsProxyList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpsProxyList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetHttpsProxyList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.TargetHttpsProxy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetHttpsProxyList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetHttpsProxyList} TargetHttpsProxyList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetHttpsProxyList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetHttpsProxyList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetHttpsProxyList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.TargetHttpsProxy.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetHttpsProxyList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetHttpsProxyList} TargetHttpsProxyList
                         */
                        TargetHttpsProxyList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetHttpsProxyList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetHttpsProxyList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.TargetHttpsProxyList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetHttpsProxyList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.TargetHttpsProxy.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetHttpsProxyList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetHttpsProxyList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @static
                         * @param {google.cloud.compute.v1.TargetHttpsProxyList} message TargetHttpsProxyList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetHttpsProxyList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.TargetHttpsProxy.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetHttpsProxyList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetHttpsProxyList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetHttpsProxyList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetHttpsProxyList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetHttpsProxyList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetHttpsProxyList";
                        };
    
                        return TargetHttpsProxyList;
                    })();
    
                    v1.TargetInstance = (function() {
    
                        /**
                         * Properties of a TargetInstance.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetInstance
                         * @property {string|null} [creationTimestamp] TargetInstance creationTimestamp
                         * @property {string|null} [description] TargetInstance description
                         * @property {number|Long|null} [id] TargetInstance id
                         * @property {string|null} [instance] TargetInstance instance
                         * @property {string|null} [kind] TargetInstance kind
                         * @property {string|null} [name] TargetInstance name
                         * @property {string|null} [natPolicy] TargetInstance natPolicy
                         * @property {string|null} [network] TargetInstance network
                         * @property {string|null} [selfLink] TargetInstance selfLink
                         * @property {string|null} [zone] TargetInstance zone
                         */
    
                        /**
                         * Constructs a new TargetInstance.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetInstance.
                         * @implements ITargetInstance
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetInstance=} [properties] Properties to set
                         */
                        function TargetInstance(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetInstance creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         */
                        TargetInstance.prototype.creationTimestamp = null;
    
                        /**
                         * TargetInstance description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         */
                        TargetInstance.prototype.description = null;
    
                        /**
                         * TargetInstance id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         */
                        TargetInstance.prototype.id = null;
    
                        /**
                         * TargetInstance instance.
                         * @member {string|null|undefined} instance
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         */
                        TargetInstance.prototype.instance = null;
    
                        /**
                         * TargetInstance kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         */
                        TargetInstance.prototype.kind = null;
    
                        /**
                         * TargetInstance name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         */
                        TargetInstance.prototype.name = null;
    
                        /**
                         * TargetInstance natPolicy.
                         * @member {string|null|undefined} natPolicy
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         */
                        TargetInstance.prototype.natPolicy = null;
    
                        /**
                         * TargetInstance network.
                         * @member {string|null|undefined} network
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         */
                        TargetInstance.prototype.network = null;
    
                        /**
                         * TargetInstance selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         */
                        TargetInstance.prototype.selfLink = null;
    
                        /**
                         * TargetInstance zone.
                         * @member {string|null|undefined} zone
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         */
                        TargetInstance.prototype.zone = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetInstance _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         */
                        Object.defineProperty(TargetInstance.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetInstance _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         */
                        Object.defineProperty(TargetInstance.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetInstance _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         */
                        Object.defineProperty(TargetInstance.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetInstance _instance.
                         * @member {"instance"|undefined} _instance
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         */
                        Object.defineProperty(TargetInstance.prototype, "_instance", {
                            get: $util.oneOfGetter($oneOfFields = ["instance"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetInstance _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         */
                        Object.defineProperty(TargetInstance.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetInstance _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         */
                        Object.defineProperty(TargetInstance.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetInstance _natPolicy.
                         * @member {"natPolicy"|undefined} _natPolicy
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         */
                        Object.defineProperty(TargetInstance.prototype, "_natPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["natPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetInstance _network.
                         * @member {"network"|undefined} _network
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         */
                        Object.defineProperty(TargetInstance.prototype, "_network", {
                            get: $util.oneOfGetter($oneOfFields = ["network"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetInstance _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         */
                        Object.defineProperty(TargetInstance.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetInstance _zone.
                         * @member {"zone"|undefined} _zone
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         */
                        Object.defineProperty(TargetInstance.prototype, "_zone", {
                            get: $util.oneOfGetter($oneOfFields = ["zone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetInstance instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @static
                         * @param {google.cloud.compute.v1.ITargetInstance=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetInstance} TargetInstance instance
                         */
                        TargetInstance.create = function create(properties) {
                            return new TargetInstance(properties);
                        };
    
                        /**
                         * Encodes the specified TargetInstance message. Does not implicitly {@link google.cloud.compute.v1.TargetInstance.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @static
                         * @param {google.cloud.compute.v1.ITargetInstance} message TargetInstance message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetInstance.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.natPolicy != null && Object.hasOwnProperty.call(message, "natPolicy"))
                                writer.uint32(/* id 509780496, wireType 2 =*/4078243970).string(message.natPolicy);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetInstance message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetInstance.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @static
                         * @param {google.cloud.compute.v1.ITargetInstance} message TargetInstance message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetInstance.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetInstance message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetInstance} TargetInstance
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetInstance.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetInstance();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 509780496: {
                                        message.natPolicy = reader.string();
                                        break;
                                    }
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetInstance message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetInstance} TargetInstance
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetInstance.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetInstance message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetInstance.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.instance != null && message.hasOwnProperty("instance")) {
                                properties._instance = 1;
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.natPolicy != null && message.hasOwnProperty("natPolicy")) {
                                properties._natPolicy = 1;
                                if (!$util.isString(message.natPolicy))
                                    return "natPolicy: string expected";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                properties._network = 1;
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                properties._zone = 1;
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetInstance message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetInstance} TargetInstance
                         */
                        TargetInstance.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetInstance)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetInstance();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.natPolicy != null)
                                message.natPolicy = String(object.natPolicy);
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetInstance message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @static
                         * @param {google.cloud.compute.v1.TargetInstance} message TargetInstance
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetInstance.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                object.zone = message.zone;
                                if (options.oneofs)
                                    object._zone = "zone";
                            }
                            if (message.instance != null && message.hasOwnProperty("instance")) {
                                object.instance = message.instance;
                                if (options.oneofs)
                                    object._instance = "instance";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                object.network = message.network;
                                if (options.oneofs)
                                    object._network = "network";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.natPolicy != null && message.hasOwnProperty("natPolicy")) {
                                object.natPolicy = message.natPolicy;
                                if (options.oneofs)
                                    object._natPolicy = "natPolicy";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetInstance to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetInstance.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetInstance
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetInstance
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetInstance.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetInstance";
                        };
    
                        /**
                         * NatPolicy enum.
                         * @name google.cloud.compute.v1.TargetInstance.NatPolicy
                         * @enum {number}
                         * @property {number} UNDEFINED_NAT_POLICY=0 UNDEFINED_NAT_POLICY value
                         * @property {number} NO_NAT=161455491 NO_NAT value
                         */
                        TargetInstance.NatPolicy = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_NAT_POLICY"] = 0;
                            values[valuesById[161455491] = "NO_NAT"] = 161455491;
                            return values;
                        })();
    
                        return TargetInstance;
                    })();
    
                    v1.TargetInstanceAggregatedList = (function() {
    
                        /**
                         * Properties of a TargetInstanceAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetInstanceAggregatedList
                         * @property {string|null} [id] TargetInstanceAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.ITargetInstancesScopedList>|null} [items] TargetInstanceAggregatedList items
                         * @property {string|null} [kind] TargetInstanceAggregatedList kind
                         * @property {string|null} [nextPageToken] TargetInstanceAggregatedList nextPageToken
                         * @property {string|null} [selfLink] TargetInstanceAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] TargetInstanceAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] TargetInstanceAggregatedList warning
                         */
    
                        /**
                         * Constructs a new TargetInstanceAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetInstanceAggregatedList.
                         * @implements ITargetInstanceAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetInstanceAggregatedList=} [properties] Properties to set
                         */
                        function TargetInstanceAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetInstanceAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @instance
                         */
                        TargetInstanceAggregatedList.prototype.id = null;
    
                        /**
                         * TargetInstanceAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.ITargetInstancesScopedList>} items
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @instance
                         */
                        TargetInstanceAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * TargetInstanceAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @instance
                         */
                        TargetInstanceAggregatedList.prototype.kind = null;
    
                        /**
                         * TargetInstanceAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @instance
                         */
                        TargetInstanceAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * TargetInstanceAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @instance
                         */
                        TargetInstanceAggregatedList.prototype.selfLink = null;
    
                        /**
                         * TargetInstanceAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @instance
                         */
                        TargetInstanceAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * TargetInstanceAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @instance
                         */
                        TargetInstanceAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetInstanceAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetInstanceAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetInstanceAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetInstanceAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetInstanceAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetInstanceAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetInstanceAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetInstanceAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetInstanceAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetInstanceAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetInstanceAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetInstanceAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetInstanceAggregatedList} TargetInstanceAggregatedList instance
                         */
                        TargetInstanceAggregatedList.create = function create(properties) {
                            return new TargetInstanceAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified TargetInstanceAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.TargetInstanceAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetInstanceAggregatedList} message TargetInstanceAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetInstanceAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.TargetInstancesScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetInstanceAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetInstanceAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetInstanceAggregatedList} message TargetInstanceAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetInstanceAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetInstanceAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetInstanceAggregatedList} TargetInstanceAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetInstanceAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetInstanceAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.TargetInstancesScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetInstanceAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetInstanceAggregatedList} TargetInstanceAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetInstanceAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetInstanceAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetInstanceAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.TargetInstancesScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetInstanceAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetInstanceAggregatedList} TargetInstanceAggregatedList
                         */
                        TargetInstanceAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetInstanceAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetInstanceAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetInstanceAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetInstanceAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.TargetInstancesScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.TargetInstanceAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetInstanceAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetInstanceAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.TargetInstanceAggregatedList} message TargetInstanceAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetInstanceAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.TargetInstancesScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetInstanceAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetInstanceAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetInstanceAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetInstanceAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetInstanceAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetInstanceAggregatedList";
                        };
    
                        return TargetInstanceAggregatedList;
                    })();
    
                    v1.TargetInstanceList = (function() {
    
                        /**
                         * Properties of a TargetInstanceList.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetInstanceList
                         * @property {string|null} [id] TargetInstanceList id
                         * @property {Array.<google.cloud.compute.v1.ITargetInstance>|null} [items] TargetInstanceList items
                         * @property {string|null} [kind] TargetInstanceList kind
                         * @property {string|null} [nextPageToken] TargetInstanceList nextPageToken
                         * @property {string|null} [selfLink] TargetInstanceList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] TargetInstanceList warning
                         */
    
                        /**
                         * Constructs a new TargetInstanceList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetInstanceList.
                         * @implements ITargetInstanceList
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetInstanceList=} [properties] Properties to set
                         */
                        function TargetInstanceList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetInstanceList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @instance
                         */
                        TargetInstanceList.prototype.id = null;
    
                        /**
                         * TargetInstanceList items.
                         * @member {Array.<google.cloud.compute.v1.ITargetInstance>} items
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @instance
                         */
                        TargetInstanceList.prototype.items = $util.emptyArray;
    
                        /**
                         * TargetInstanceList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @instance
                         */
                        TargetInstanceList.prototype.kind = null;
    
                        /**
                         * TargetInstanceList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @instance
                         */
                        TargetInstanceList.prototype.nextPageToken = null;
    
                        /**
                         * TargetInstanceList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @instance
                         */
                        TargetInstanceList.prototype.selfLink = null;
    
                        /**
                         * TargetInstanceList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @instance
                         */
                        TargetInstanceList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetInstanceList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @instance
                         */
                        Object.defineProperty(TargetInstanceList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetInstanceList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @instance
                         */
                        Object.defineProperty(TargetInstanceList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetInstanceList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @instance
                         */
                        Object.defineProperty(TargetInstanceList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetInstanceList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @instance
                         */
                        Object.defineProperty(TargetInstanceList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetInstanceList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @instance
                         */
                        Object.defineProperty(TargetInstanceList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetInstanceList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetInstanceList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetInstanceList} TargetInstanceList instance
                         */
                        TargetInstanceList.create = function create(properties) {
                            return new TargetInstanceList(properties);
                        };
    
                        /**
                         * Encodes the specified TargetInstanceList message. Does not implicitly {@link google.cloud.compute.v1.TargetInstanceList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetInstanceList} message TargetInstanceList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetInstanceList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.TargetInstance.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetInstanceList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetInstanceList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetInstanceList} message TargetInstanceList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetInstanceList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetInstanceList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetInstanceList} TargetInstanceList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetInstanceList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetInstanceList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.TargetInstance.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetInstanceList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetInstanceList} TargetInstanceList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetInstanceList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetInstanceList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetInstanceList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.TargetInstance.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetInstanceList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetInstanceList} TargetInstanceList
                         */
                        TargetInstanceList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetInstanceList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetInstanceList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.TargetInstanceList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetInstanceList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.TargetInstance.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetInstanceList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetInstanceList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @static
                         * @param {google.cloud.compute.v1.TargetInstanceList} message TargetInstanceList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetInstanceList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.TargetInstance.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetInstanceList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetInstanceList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetInstanceList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetInstanceList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetInstanceList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetInstanceList";
                        };
    
                        return TargetInstanceList;
                    })();
    
                    v1.TargetInstancesScopedList = (function() {
    
                        /**
                         * Properties of a TargetInstancesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetInstancesScopedList
                         * @property {Array.<google.cloud.compute.v1.ITargetInstance>|null} [targetInstances] TargetInstancesScopedList targetInstances
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] TargetInstancesScopedList warning
                         */
    
                        /**
                         * Constructs a new TargetInstancesScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetInstancesScopedList.
                         * @implements ITargetInstancesScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetInstancesScopedList=} [properties] Properties to set
                         */
                        function TargetInstancesScopedList(properties) {
                            this.targetInstances = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetInstancesScopedList targetInstances.
                         * @member {Array.<google.cloud.compute.v1.ITargetInstance>} targetInstances
                         * @memberof google.cloud.compute.v1.TargetInstancesScopedList
                         * @instance
                         */
                        TargetInstancesScopedList.prototype.targetInstances = $util.emptyArray;
    
                        /**
                         * TargetInstancesScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.TargetInstancesScopedList
                         * @instance
                         */
                        TargetInstancesScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetInstancesScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.TargetInstancesScopedList
                         * @instance
                         */
                        Object.defineProperty(TargetInstancesScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetInstancesScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetInstancesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetInstancesScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetInstancesScopedList} TargetInstancesScopedList instance
                         */
                        TargetInstancesScopedList.create = function create(properties) {
                            return new TargetInstancesScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified TargetInstancesScopedList message. Does not implicitly {@link google.cloud.compute.v1.TargetInstancesScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetInstancesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetInstancesScopedList} message TargetInstancesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetInstancesScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.targetInstances != null && message.targetInstances.length)
                                for (var i = 0; i < message.targetInstances.length; ++i)
                                    $root.google.cloud.compute.v1.TargetInstance.encode(message.targetInstances[i], writer.uint32(/* id 392915280, wireType 2 =*/3143322242).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetInstancesScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetInstancesScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetInstancesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetInstancesScopedList} message TargetInstancesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetInstancesScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetInstancesScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetInstancesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetInstancesScopedList} TargetInstancesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetInstancesScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetInstancesScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 392915280: {
                                        if (!(message.targetInstances && message.targetInstances.length))
                                            message.targetInstances = [];
                                        message.targetInstances.push($root.google.cloud.compute.v1.TargetInstance.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetInstancesScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetInstancesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetInstancesScopedList} TargetInstancesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetInstancesScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetInstancesScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetInstancesScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetInstancesScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.targetInstances != null && message.hasOwnProperty("targetInstances")) {
                                if (!Array.isArray(message.targetInstances))
                                    return "targetInstances: array expected";
                                for (var i = 0; i < message.targetInstances.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.TargetInstance.verify(message.targetInstances[i]);
                                    if (error)
                                        return "targetInstances." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetInstancesScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetInstancesScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetInstancesScopedList} TargetInstancesScopedList
                         */
                        TargetInstancesScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetInstancesScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetInstancesScopedList();
                            if (object.targetInstances) {
                                if (!Array.isArray(object.targetInstances))
                                    throw TypeError(".google.cloud.compute.v1.TargetInstancesScopedList.targetInstances: array expected");
                                message.targetInstances = [];
                                for (var i = 0; i < object.targetInstances.length; ++i) {
                                    if (typeof object.targetInstances[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetInstancesScopedList.targetInstances: object expected");
                                    message.targetInstances[i] = $root.google.cloud.compute.v1.TargetInstance.fromObject(object.targetInstances[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetInstancesScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetInstancesScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetInstancesScopedList
                         * @static
                         * @param {google.cloud.compute.v1.TargetInstancesScopedList} message TargetInstancesScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetInstancesScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.targetInstances = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.targetInstances && message.targetInstances.length) {
                                object.targetInstances = [];
                                for (var j = 0; j < message.targetInstances.length; ++j)
                                    object.targetInstances[j] = $root.google.cloud.compute.v1.TargetInstance.toObject(message.targetInstances[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetInstancesScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetInstancesScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetInstancesScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetInstancesScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetInstancesScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetInstancesScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetInstancesScopedList";
                        };
    
                        return TargetInstancesScopedList;
                    })();
    
                    v1.TargetPool = (function() {
    
                        /**
                         * Properties of a TargetPool.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetPool
                         * @property {string|null} [backupPool] TargetPool backupPool
                         * @property {string|null} [creationTimestamp] TargetPool creationTimestamp
                         * @property {string|null} [description] TargetPool description
                         * @property {number|null} [failoverRatio] TargetPool failoverRatio
                         * @property {Array.<string>|null} [healthChecks] TargetPool healthChecks
                         * @property {number|Long|null} [id] TargetPool id
                         * @property {Array.<string>|null} [instances] TargetPool instances
                         * @property {string|null} [kind] TargetPool kind
                         * @property {string|null} [name] TargetPool name
                         * @property {string|null} [region] TargetPool region
                         * @property {string|null} [selfLink] TargetPool selfLink
                         * @property {string|null} [sessionAffinity] TargetPool sessionAffinity
                         */
    
                        /**
                         * Constructs a new TargetPool.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetPool.
                         * @implements ITargetPool
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetPool=} [properties] Properties to set
                         */
                        function TargetPool(properties) {
                            this.healthChecks = [];
                            this.instances = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetPool backupPool.
                         * @member {string|null|undefined} backupPool
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        TargetPool.prototype.backupPool = null;
    
                        /**
                         * TargetPool creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        TargetPool.prototype.creationTimestamp = null;
    
                        /**
                         * TargetPool description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        TargetPool.prototype.description = null;
    
                        /**
                         * TargetPool failoverRatio.
                         * @member {number|null|undefined} failoverRatio
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        TargetPool.prototype.failoverRatio = null;
    
                        /**
                         * TargetPool healthChecks.
                         * @member {Array.<string>} healthChecks
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        TargetPool.prototype.healthChecks = $util.emptyArray;
    
                        /**
                         * TargetPool id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        TargetPool.prototype.id = null;
    
                        /**
                         * TargetPool instances.
                         * @member {Array.<string>} instances
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        TargetPool.prototype.instances = $util.emptyArray;
    
                        /**
                         * TargetPool kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        TargetPool.prototype.kind = null;
    
                        /**
                         * TargetPool name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        TargetPool.prototype.name = null;
    
                        /**
                         * TargetPool region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        TargetPool.prototype.region = null;
    
                        /**
                         * TargetPool selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        TargetPool.prototype.selfLink = null;
    
                        /**
                         * TargetPool sessionAffinity.
                         * @member {string|null|undefined} sessionAffinity
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        TargetPool.prototype.sessionAffinity = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetPool _backupPool.
                         * @member {"backupPool"|undefined} _backupPool
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        Object.defineProperty(TargetPool.prototype, "_backupPool", {
                            get: $util.oneOfGetter($oneOfFields = ["backupPool"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetPool _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        Object.defineProperty(TargetPool.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetPool _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        Object.defineProperty(TargetPool.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetPool _failoverRatio.
                         * @member {"failoverRatio"|undefined} _failoverRatio
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        Object.defineProperty(TargetPool.prototype, "_failoverRatio", {
                            get: $util.oneOfGetter($oneOfFields = ["failoverRatio"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetPool _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        Object.defineProperty(TargetPool.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetPool _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        Object.defineProperty(TargetPool.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetPool _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        Object.defineProperty(TargetPool.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetPool _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        Object.defineProperty(TargetPool.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetPool _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        Object.defineProperty(TargetPool.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetPool _sessionAffinity.
                         * @member {"sessionAffinity"|undefined} _sessionAffinity
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         */
                        Object.defineProperty(TargetPool.prototype, "_sessionAffinity", {
                            get: $util.oneOfGetter($oneOfFields = ["sessionAffinity"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetPool instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPool=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetPool} TargetPool instance
                         */
                        TargetPool.create = function create(properties) {
                            return new TargetPool(properties);
                        };
    
                        /**
                         * Encodes the specified TargetPool message. Does not implicitly {@link google.cloud.compute.v1.TargetPool.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPool} message TargetPool message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetPool.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.instances != null && message.instances.length)
                                for (var i = 0; i < message.instances.length; ++i)
                                    writer.uint32(/* id 29097598, wireType 2 =*/232780786).string(message.instances[i]);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.backupPool != null && Object.hasOwnProperty.call(message, "backupPool"))
                                writer.uint32(/* id 45884537, wireType 2 =*/367076298).string(message.backupPool);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.failoverRatio != null && Object.hasOwnProperty.call(message, "failoverRatio"))
                                writer.uint32(/* id 212667006, wireType 5 =*/1701336053).float(message.failoverRatio);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.healthChecks != null && message.healthChecks.length)
                                for (var i = 0; i < message.healthChecks.length; ++i)
                                    writer.uint32(/* id 448370606, wireType 2 =*/3586964850).string(message.healthChecks[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.sessionAffinity != null && Object.hasOwnProperty.call(message, "sessionAffinity"))
                                writer.uint32(/* id 463888561, wireType 2 =*/3711108490).string(message.sessionAffinity);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetPool message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetPool.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPool} message TargetPool message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetPool.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetPool message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetPool} TargetPool
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetPool.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetPool();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 45884537: {
                                        message.backupPool = reader.string();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 212667006: {
                                        message.failoverRatio = reader.float();
                                        break;
                                    }
                                case 448370606: {
                                        if (!(message.healthChecks && message.healthChecks.length))
                                            message.healthChecks = [];
                                        message.healthChecks.push(reader.string());
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 29097598: {
                                        if (!(message.instances && message.instances.length))
                                            message.instances = [];
                                        message.instances.push(reader.string());
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 463888561: {
                                        message.sessionAffinity = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetPool message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetPool} TargetPool
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetPool.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetPool message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetPool.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backupPool != null && message.hasOwnProperty("backupPool")) {
                                properties._backupPool = 1;
                                if (!$util.isString(message.backupPool))
                                    return "backupPool: string expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.failoverRatio != null && message.hasOwnProperty("failoverRatio")) {
                                properties._failoverRatio = 1;
                                if (typeof message.failoverRatio !== "number")
                                    return "failoverRatio: number expected";
                            }
                            if (message.healthChecks != null && message.hasOwnProperty("healthChecks")) {
                                if (!Array.isArray(message.healthChecks))
                                    return "healthChecks: array expected";
                                for (var i = 0; i < message.healthChecks.length; ++i)
                                    if (!$util.isString(message.healthChecks[i]))
                                        return "healthChecks: string[] expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.instances != null && message.hasOwnProperty("instances")) {
                                if (!Array.isArray(message.instances))
                                    return "instances: array expected";
                                for (var i = 0; i < message.instances.length; ++i)
                                    if (!$util.isString(message.instances[i]))
                                        return "instances: string[] expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.sessionAffinity != null && message.hasOwnProperty("sessionAffinity")) {
                                properties._sessionAffinity = 1;
                                if (!$util.isString(message.sessionAffinity))
                                    return "sessionAffinity: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetPool message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetPool} TargetPool
                         */
                        TargetPool.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetPool)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetPool();
                            if (object.backupPool != null)
                                message.backupPool = String(object.backupPool);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.failoverRatio != null)
                                message.failoverRatio = Number(object.failoverRatio);
                            if (object.healthChecks) {
                                if (!Array.isArray(object.healthChecks))
                                    throw TypeError(".google.cloud.compute.v1.TargetPool.healthChecks: array expected");
                                message.healthChecks = [];
                                for (var i = 0; i < object.healthChecks.length; ++i)
                                    message.healthChecks[i] = String(object.healthChecks[i]);
                            }
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.instances) {
                                if (!Array.isArray(object.instances))
                                    throw TypeError(".google.cloud.compute.v1.TargetPool.instances: array expected");
                                message.instances = [];
                                for (var i = 0; i < object.instances.length; ++i)
                                    message.instances[i] = String(object.instances[i]);
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.sessionAffinity != null)
                                message.sessionAffinity = String(object.sessionAffinity);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetPool message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @static
                         * @param {google.cloud.compute.v1.TargetPool} message TargetPool
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetPool.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.instances = [];
                                object.healthChecks = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.instances && message.instances.length) {
                                object.instances = [];
                                for (var j = 0; j < message.instances.length; ++j)
                                    object.instances[j] = message.instances[j];
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.backupPool != null && message.hasOwnProperty("backupPool")) {
                                object.backupPool = message.backupPool;
                                if (options.oneofs)
                                    object._backupPool = "backupPool";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.failoverRatio != null && message.hasOwnProperty("failoverRatio")) {
                                object.failoverRatio = options.json && !isFinite(message.failoverRatio) ? String(message.failoverRatio) : message.failoverRatio;
                                if (options.oneofs)
                                    object._failoverRatio = "failoverRatio";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.healthChecks && message.healthChecks.length) {
                                object.healthChecks = [];
                                for (var j = 0; j < message.healthChecks.length; ++j)
                                    object.healthChecks[j] = message.healthChecks[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.sessionAffinity != null && message.hasOwnProperty("sessionAffinity")) {
                                object.sessionAffinity = message.sessionAffinity;
                                if (options.oneofs)
                                    object._sessionAffinity = "sessionAffinity";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetPool to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetPool.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetPool
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetPool
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetPool.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetPool";
                        };
    
                        /**
                         * SessionAffinity enum.
                         * @name google.cloud.compute.v1.TargetPool.SessionAffinity
                         * @enum {number}
                         * @property {number} UNDEFINED_SESSION_AFFINITY=0 UNDEFINED_SESSION_AFFINITY value
                         * @property {number} CLIENT_IP=345665051 CLIENT_IP value
                         * @property {number} CLIENT_IP_NO_DESTINATION=106122516 CLIENT_IP_NO_DESTINATION value
                         * @property {number} CLIENT_IP_PORT_PROTO=221722926 CLIENT_IP_PORT_PROTO value
                         * @property {number} CLIENT_IP_PROTO=25322148 CLIENT_IP_PROTO value
                         * @property {number} GENERATED_COOKIE=370321204 GENERATED_COOKIE value
                         * @property {number} HEADER_FIELD=200737960 HEADER_FIELD value
                         * @property {number} HTTP_COOKIE=494981627 HTTP_COOKIE value
                         * @property {number} NONE=2402104 NONE value
                         */
                        TargetPool.SessionAffinity = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_SESSION_AFFINITY"] = 0;
                            values[valuesById[345665051] = "CLIENT_IP"] = 345665051;
                            values[valuesById[106122516] = "CLIENT_IP_NO_DESTINATION"] = 106122516;
                            values[valuesById[221722926] = "CLIENT_IP_PORT_PROTO"] = 221722926;
                            values[valuesById[25322148] = "CLIENT_IP_PROTO"] = 25322148;
                            values[valuesById[370321204] = "GENERATED_COOKIE"] = 370321204;
                            values[valuesById[200737960] = "HEADER_FIELD"] = 200737960;
                            values[valuesById[494981627] = "HTTP_COOKIE"] = 494981627;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            return values;
                        })();
    
                        return TargetPool;
                    })();
    
                    v1.TargetPoolAggregatedList = (function() {
    
                        /**
                         * Properties of a TargetPoolAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetPoolAggregatedList
                         * @property {string|null} [id] TargetPoolAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.ITargetPoolsScopedList>|null} [items] TargetPoolAggregatedList items
                         * @property {string|null} [kind] TargetPoolAggregatedList kind
                         * @property {string|null} [nextPageToken] TargetPoolAggregatedList nextPageToken
                         * @property {string|null} [selfLink] TargetPoolAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] TargetPoolAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] TargetPoolAggregatedList warning
                         */
    
                        /**
                         * Constructs a new TargetPoolAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetPoolAggregatedList.
                         * @implements ITargetPoolAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetPoolAggregatedList=} [properties] Properties to set
                         */
                        function TargetPoolAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetPoolAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @instance
                         */
                        TargetPoolAggregatedList.prototype.id = null;
    
                        /**
                         * TargetPoolAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.ITargetPoolsScopedList>} items
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @instance
                         */
                        TargetPoolAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * TargetPoolAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @instance
                         */
                        TargetPoolAggregatedList.prototype.kind = null;
    
                        /**
                         * TargetPoolAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @instance
                         */
                        TargetPoolAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * TargetPoolAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @instance
                         */
                        TargetPoolAggregatedList.prototype.selfLink = null;
    
                        /**
                         * TargetPoolAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @instance
                         */
                        TargetPoolAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * TargetPoolAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @instance
                         */
                        TargetPoolAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetPoolAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetPoolAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetPoolAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetPoolAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetPoolAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetPoolAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetPoolAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetPoolAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetPoolAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetPoolAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetPoolAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetPoolAggregatedList} TargetPoolAggregatedList instance
                         */
                        TargetPoolAggregatedList.create = function create(properties) {
                            return new TargetPoolAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified TargetPoolAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.TargetPoolAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolAggregatedList} message TargetPoolAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetPoolAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.TargetPoolsScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetPoolAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetPoolAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolAggregatedList} message TargetPoolAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetPoolAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetPoolAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetPoolAggregatedList} TargetPoolAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetPoolAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetPoolAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.TargetPoolsScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetPoolAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetPoolAggregatedList} TargetPoolAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetPoolAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetPoolAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetPoolAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.TargetPoolsScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetPoolAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetPoolAggregatedList} TargetPoolAggregatedList
                         */
                        TargetPoolAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetPoolAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetPoolAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetPoolAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetPoolAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.TargetPoolsScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.TargetPoolAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetPoolAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetPoolAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.TargetPoolAggregatedList} message TargetPoolAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetPoolAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.TargetPoolsScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetPoolAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetPoolAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetPoolAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetPoolAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetPoolAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetPoolAggregatedList";
                        };
    
                        return TargetPoolAggregatedList;
                    })();
    
                    v1.TargetPoolInstanceHealth = (function() {
    
                        /**
                         * Properties of a TargetPoolInstanceHealth.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetPoolInstanceHealth
                         * @property {Array.<google.cloud.compute.v1.IHealthStatus>|null} [healthStatus] TargetPoolInstanceHealth healthStatus
                         * @property {string|null} [kind] TargetPoolInstanceHealth kind
                         */
    
                        /**
                         * Constructs a new TargetPoolInstanceHealth.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetPoolInstanceHealth.
                         * @implements ITargetPoolInstanceHealth
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetPoolInstanceHealth=} [properties] Properties to set
                         */
                        function TargetPoolInstanceHealth(properties) {
                            this.healthStatus = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetPoolInstanceHealth healthStatus.
                         * @member {Array.<google.cloud.compute.v1.IHealthStatus>} healthStatus
                         * @memberof google.cloud.compute.v1.TargetPoolInstanceHealth
                         * @instance
                         */
                        TargetPoolInstanceHealth.prototype.healthStatus = $util.emptyArray;
    
                        /**
                         * TargetPoolInstanceHealth kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetPoolInstanceHealth
                         * @instance
                         */
                        TargetPoolInstanceHealth.prototype.kind = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetPoolInstanceHealth _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetPoolInstanceHealth
                         * @instance
                         */
                        Object.defineProperty(TargetPoolInstanceHealth.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetPoolInstanceHealth instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetPoolInstanceHealth
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolInstanceHealth=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetPoolInstanceHealth} TargetPoolInstanceHealth instance
                         */
                        TargetPoolInstanceHealth.create = function create(properties) {
                            return new TargetPoolInstanceHealth(properties);
                        };
    
                        /**
                         * Encodes the specified TargetPoolInstanceHealth message. Does not implicitly {@link google.cloud.compute.v1.TargetPoolInstanceHealth.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetPoolInstanceHealth
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolInstanceHealth} message TargetPoolInstanceHealth message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetPoolInstanceHealth.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.healthStatus != null && message.healthStatus.length)
                                for (var i = 0; i < message.healthStatus.length; ++i)
                                    $root.google.cloud.compute.v1.HealthStatus.encode(message.healthStatus[i], writer.uint32(/* id 380545845, wireType 2 =*/3044366762).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetPoolInstanceHealth message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetPoolInstanceHealth.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetPoolInstanceHealth
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolInstanceHealth} message TargetPoolInstanceHealth message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetPoolInstanceHealth.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetPoolInstanceHealth message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetPoolInstanceHealth
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetPoolInstanceHealth} TargetPoolInstanceHealth
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetPoolInstanceHealth.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetPoolInstanceHealth();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 380545845: {
                                        if (!(message.healthStatus && message.healthStatus.length))
                                            message.healthStatus = [];
                                        message.healthStatus.push($root.google.cloud.compute.v1.HealthStatus.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetPoolInstanceHealth message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetPoolInstanceHealth
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetPoolInstanceHealth} TargetPoolInstanceHealth
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetPoolInstanceHealth.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetPoolInstanceHealth message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetPoolInstanceHealth
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetPoolInstanceHealth.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.healthStatus != null && message.hasOwnProperty("healthStatus")) {
                                if (!Array.isArray(message.healthStatus))
                                    return "healthStatus: array expected";
                                for (var i = 0; i < message.healthStatus.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.HealthStatus.verify(message.healthStatus[i]);
                                    if (error)
                                        return "healthStatus." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetPoolInstanceHealth message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetPoolInstanceHealth
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetPoolInstanceHealth} TargetPoolInstanceHealth
                         */
                        TargetPoolInstanceHealth.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetPoolInstanceHealth)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetPoolInstanceHealth();
                            if (object.healthStatus) {
                                if (!Array.isArray(object.healthStatus))
                                    throw TypeError(".google.cloud.compute.v1.TargetPoolInstanceHealth.healthStatus: array expected");
                                message.healthStatus = [];
                                for (var i = 0; i < object.healthStatus.length; ++i) {
                                    if (typeof object.healthStatus[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetPoolInstanceHealth.healthStatus: object expected");
                                    message.healthStatus[i] = $root.google.cloud.compute.v1.HealthStatus.fromObject(object.healthStatus[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetPoolInstanceHealth message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetPoolInstanceHealth
                         * @static
                         * @param {google.cloud.compute.v1.TargetPoolInstanceHealth} message TargetPoolInstanceHealth
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetPoolInstanceHealth.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.healthStatus = [];
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.healthStatus && message.healthStatus.length) {
                                object.healthStatus = [];
                                for (var j = 0; j < message.healthStatus.length; ++j)
                                    object.healthStatus[j] = $root.google.cloud.compute.v1.HealthStatus.toObject(message.healthStatus[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetPoolInstanceHealth to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetPoolInstanceHealth
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetPoolInstanceHealth.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetPoolInstanceHealth
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetPoolInstanceHealth
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetPoolInstanceHealth.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetPoolInstanceHealth";
                        };
    
                        return TargetPoolInstanceHealth;
                    })();
    
                    v1.TargetPoolList = (function() {
    
                        /**
                         * Properties of a TargetPoolList.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetPoolList
                         * @property {string|null} [id] TargetPoolList id
                         * @property {Array.<google.cloud.compute.v1.ITargetPool>|null} [items] TargetPoolList items
                         * @property {string|null} [kind] TargetPoolList kind
                         * @property {string|null} [nextPageToken] TargetPoolList nextPageToken
                         * @property {string|null} [selfLink] TargetPoolList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] TargetPoolList warning
                         */
    
                        /**
                         * Constructs a new TargetPoolList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetPoolList.
                         * @implements ITargetPoolList
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetPoolList=} [properties] Properties to set
                         */
                        function TargetPoolList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetPoolList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @instance
                         */
                        TargetPoolList.prototype.id = null;
    
                        /**
                         * TargetPoolList items.
                         * @member {Array.<google.cloud.compute.v1.ITargetPool>} items
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @instance
                         */
                        TargetPoolList.prototype.items = $util.emptyArray;
    
                        /**
                         * TargetPoolList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @instance
                         */
                        TargetPoolList.prototype.kind = null;
    
                        /**
                         * TargetPoolList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @instance
                         */
                        TargetPoolList.prototype.nextPageToken = null;
    
                        /**
                         * TargetPoolList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @instance
                         */
                        TargetPoolList.prototype.selfLink = null;
    
                        /**
                         * TargetPoolList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @instance
                         */
                        TargetPoolList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetPoolList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @instance
                         */
                        Object.defineProperty(TargetPoolList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetPoolList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @instance
                         */
                        Object.defineProperty(TargetPoolList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetPoolList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @instance
                         */
                        Object.defineProperty(TargetPoolList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetPoolList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @instance
                         */
                        Object.defineProperty(TargetPoolList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetPoolList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @instance
                         */
                        Object.defineProperty(TargetPoolList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetPoolList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetPoolList} TargetPoolList instance
                         */
                        TargetPoolList.create = function create(properties) {
                            return new TargetPoolList(properties);
                        };
    
                        /**
                         * Encodes the specified TargetPoolList message. Does not implicitly {@link google.cloud.compute.v1.TargetPoolList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolList} message TargetPoolList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetPoolList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.TargetPool.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetPoolList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetPoolList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolList} message TargetPoolList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetPoolList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetPoolList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetPoolList} TargetPoolList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetPoolList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetPoolList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.TargetPool.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetPoolList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetPoolList} TargetPoolList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetPoolList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetPoolList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetPoolList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.TargetPool.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetPoolList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetPoolList} TargetPoolList
                         */
                        TargetPoolList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetPoolList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetPoolList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.TargetPoolList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetPoolList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.TargetPool.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetPoolList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetPoolList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @static
                         * @param {google.cloud.compute.v1.TargetPoolList} message TargetPoolList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetPoolList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.TargetPool.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetPoolList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetPoolList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetPoolList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetPoolList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetPoolList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetPoolList";
                        };
    
                        return TargetPoolList;
                    })();
    
                    v1.TargetPoolsAddHealthCheckRequest = (function() {
    
                        /**
                         * Properties of a TargetPoolsAddHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetPoolsAddHealthCheckRequest
                         * @property {Array.<google.cloud.compute.v1.IHealthCheckReference>|null} [healthChecks] TargetPoolsAddHealthCheckRequest healthChecks
                         */
    
                        /**
                         * Constructs a new TargetPoolsAddHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetPoolsAddHealthCheckRequest.
                         * @implements ITargetPoolsAddHealthCheckRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetPoolsAddHealthCheckRequest=} [properties] Properties to set
                         */
                        function TargetPoolsAddHealthCheckRequest(properties) {
                            this.healthChecks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetPoolsAddHealthCheckRequest healthChecks.
                         * @member {Array.<google.cloud.compute.v1.IHealthCheckReference>} healthChecks
                         * @memberof google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest
                         * @instance
                         */
                        TargetPoolsAddHealthCheckRequest.prototype.healthChecks = $util.emptyArray;
    
                        /**
                         * Creates a new TargetPoolsAddHealthCheckRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolsAddHealthCheckRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest} TargetPoolsAddHealthCheckRequest instance
                         */
                        TargetPoolsAddHealthCheckRequest.create = function create(properties) {
                            return new TargetPoolsAddHealthCheckRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TargetPoolsAddHealthCheckRequest message. Does not implicitly {@link google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolsAddHealthCheckRequest} message TargetPoolsAddHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetPoolsAddHealthCheckRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.healthChecks != null && message.healthChecks.length)
                                for (var i = 0; i < message.healthChecks.length; ++i)
                                    $root.google.cloud.compute.v1.HealthCheckReference.encode(message.healthChecks[i], writer.uint32(/* id 448370606, wireType 2 =*/3586964850).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetPoolsAddHealthCheckRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolsAddHealthCheckRequest} message TargetPoolsAddHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetPoolsAddHealthCheckRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetPoolsAddHealthCheckRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest} TargetPoolsAddHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetPoolsAddHealthCheckRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 448370606: {
                                        if (!(message.healthChecks && message.healthChecks.length))
                                            message.healthChecks = [];
                                        message.healthChecks.push($root.google.cloud.compute.v1.HealthCheckReference.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetPoolsAddHealthCheckRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest} TargetPoolsAddHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetPoolsAddHealthCheckRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetPoolsAddHealthCheckRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetPoolsAddHealthCheckRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.healthChecks != null && message.hasOwnProperty("healthChecks")) {
                                if (!Array.isArray(message.healthChecks))
                                    return "healthChecks: array expected";
                                for (var i = 0; i < message.healthChecks.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.HealthCheckReference.verify(message.healthChecks[i]);
                                    if (error)
                                        return "healthChecks." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetPoolsAddHealthCheckRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest} TargetPoolsAddHealthCheckRequest
                         */
                        TargetPoolsAddHealthCheckRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest();
                            if (object.healthChecks) {
                                if (!Array.isArray(object.healthChecks))
                                    throw TypeError(".google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest.healthChecks: array expected");
                                message.healthChecks = [];
                                for (var i = 0; i < object.healthChecks.length; ++i) {
                                    if (typeof object.healthChecks[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest.healthChecks: object expected");
                                    message.healthChecks[i] = $root.google.cloud.compute.v1.HealthCheckReference.fromObject(object.healthChecks[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetPoolsAddHealthCheckRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest} message TargetPoolsAddHealthCheckRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetPoolsAddHealthCheckRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.healthChecks = [];
                            if (message.healthChecks && message.healthChecks.length) {
                                object.healthChecks = [];
                                for (var j = 0; j < message.healthChecks.length; ++j)
                                    object.healthChecks[j] = $root.google.cloud.compute.v1.HealthCheckReference.toObject(message.healthChecks[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetPoolsAddHealthCheckRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetPoolsAddHealthCheckRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetPoolsAddHealthCheckRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetPoolsAddHealthCheckRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetPoolsAddHealthCheckRequest";
                        };
    
                        return TargetPoolsAddHealthCheckRequest;
                    })();
    
                    v1.TargetPoolsAddInstanceRequest = (function() {
    
                        /**
                         * Properties of a TargetPoolsAddInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetPoolsAddInstanceRequest
                         * @property {Array.<google.cloud.compute.v1.IInstanceReference>|null} [instances] TargetPoolsAddInstanceRequest instances
                         */
    
                        /**
                         * Constructs a new TargetPoolsAddInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetPoolsAddInstanceRequest.
                         * @implements ITargetPoolsAddInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetPoolsAddInstanceRequest=} [properties] Properties to set
                         */
                        function TargetPoolsAddInstanceRequest(properties) {
                            this.instances = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetPoolsAddInstanceRequest instances.
                         * @member {Array.<google.cloud.compute.v1.IInstanceReference>} instances
                         * @memberof google.cloud.compute.v1.TargetPoolsAddInstanceRequest
                         * @instance
                         */
                        TargetPoolsAddInstanceRequest.prototype.instances = $util.emptyArray;
    
                        /**
                         * Creates a new TargetPoolsAddInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetPoolsAddInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolsAddInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetPoolsAddInstanceRequest} TargetPoolsAddInstanceRequest instance
                         */
                        TargetPoolsAddInstanceRequest.create = function create(properties) {
                            return new TargetPoolsAddInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TargetPoolsAddInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.TargetPoolsAddInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetPoolsAddInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolsAddInstanceRequest} message TargetPoolsAddInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetPoolsAddInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instances != null && message.instances.length)
                                for (var i = 0; i < message.instances.length; ++i)
                                    $root.google.cloud.compute.v1.InstanceReference.encode(message.instances[i], writer.uint32(/* id 29097598, wireType 2 =*/232780786).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetPoolsAddInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetPoolsAddInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetPoolsAddInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolsAddInstanceRequest} message TargetPoolsAddInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetPoolsAddInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetPoolsAddInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetPoolsAddInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetPoolsAddInstanceRequest} TargetPoolsAddInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetPoolsAddInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetPoolsAddInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 29097598: {
                                        if (!(message.instances && message.instances.length))
                                            message.instances = [];
                                        message.instances.push($root.google.cloud.compute.v1.InstanceReference.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetPoolsAddInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetPoolsAddInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetPoolsAddInstanceRequest} TargetPoolsAddInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetPoolsAddInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetPoolsAddInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetPoolsAddInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetPoolsAddInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instances != null && message.hasOwnProperty("instances")) {
                                if (!Array.isArray(message.instances))
                                    return "instances: array expected";
                                for (var i = 0; i < message.instances.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstanceReference.verify(message.instances[i]);
                                    if (error)
                                        return "instances." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetPoolsAddInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetPoolsAddInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetPoolsAddInstanceRequest} TargetPoolsAddInstanceRequest
                         */
                        TargetPoolsAddInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetPoolsAddInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetPoolsAddInstanceRequest();
                            if (object.instances) {
                                if (!Array.isArray(object.instances))
                                    throw TypeError(".google.cloud.compute.v1.TargetPoolsAddInstanceRequest.instances: array expected");
                                message.instances = [];
                                for (var i = 0; i < object.instances.length; ++i) {
                                    if (typeof object.instances[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetPoolsAddInstanceRequest.instances: object expected");
                                    message.instances[i] = $root.google.cloud.compute.v1.InstanceReference.fromObject(object.instances[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetPoolsAddInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetPoolsAddInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.TargetPoolsAddInstanceRequest} message TargetPoolsAddInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetPoolsAddInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.instances = [];
                            if (message.instances && message.instances.length) {
                                object.instances = [];
                                for (var j = 0; j < message.instances.length; ++j)
                                    object.instances[j] = $root.google.cloud.compute.v1.InstanceReference.toObject(message.instances[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetPoolsAddInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetPoolsAddInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetPoolsAddInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetPoolsAddInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetPoolsAddInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetPoolsAddInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetPoolsAddInstanceRequest";
                        };
    
                        return TargetPoolsAddInstanceRequest;
                    })();
    
                    v1.TargetPoolsRemoveHealthCheckRequest = (function() {
    
                        /**
                         * Properties of a TargetPoolsRemoveHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetPoolsRemoveHealthCheckRequest
                         * @property {Array.<google.cloud.compute.v1.IHealthCheckReference>|null} [healthChecks] TargetPoolsRemoveHealthCheckRequest healthChecks
                         */
    
                        /**
                         * Constructs a new TargetPoolsRemoveHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetPoolsRemoveHealthCheckRequest.
                         * @implements ITargetPoolsRemoveHealthCheckRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetPoolsRemoveHealthCheckRequest=} [properties] Properties to set
                         */
                        function TargetPoolsRemoveHealthCheckRequest(properties) {
                            this.healthChecks = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetPoolsRemoveHealthCheckRequest healthChecks.
                         * @member {Array.<google.cloud.compute.v1.IHealthCheckReference>} healthChecks
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest
                         * @instance
                         */
                        TargetPoolsRemoveHealthCheckRequest.prototype.healthChecks = $util.emptyArray;
    
                        /**
                         * Creates a new TargetPoolsRemoveHealthCheckRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolsRemoveHealthCheckRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest} TargetPoolsRemoveHealthCheckRequest instance
                         */
                        TargetPoolsRemoveHealthCheckRequest.create = function create(properties) {
                            return new TargetPoolsRemoveHealthCheckRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TargetPoolsRemoveHealthCheckRequest message. Does not implicitly {@link google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolsRemoveHealthCheckRequest} message TargetPoolsRemoveHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetPoolsRemoveHealthCheckRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.healthChecks != null && message.healthChecks.length)
                                for (var i = 0; i < message.healthChecks.length; ++i)
                                    $root.google.cloud.compute.v1.HealthCheckReference.encode(message.healthChecks[i], writer.uint32(/* id 448370606, wireType 2 =*/3586964850).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetPoolsRemoveHealthCheckRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolsRemoveHealthCheckRequest} message TargetPoolsRemoveHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetPoolsRemoveHealthCheckRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetPoolsRemoveHealthCheckRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest} TargetPoolsRemoveHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetPoolsRemoveHealthCheckRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 448370606: {
                                        if (!(message.healthChecks && message.healthChecks.length))
                                            message.healthChecks = [];
                                        message.healthChecks.push($root.google.cloud.compute.v1.HealthCheckReference.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetPoolsRemoveHealthCheckRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest} TargetPoolsRemoveHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetPoolsRemoveHealthCheckRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetPoolsRemoveHealthCheckRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetPoolsRemoveHealthCheckRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.healthChecks != null && message.hasOwnProperty("healthChecks")) {
                                if (!Array.isArray(message.healthChecks))
                                    return "healthChecks: array expected";
                                for (var i = 0; i < message.healthChecks.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.HealthCheckReference.verify(message.healthChecks[i]);
                                    if (error)
                                        return "healthChecks." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetPoolsRemoveHealthCheckRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest} TargetPoolsRemoveHealthCheckRequest
                         */
                        TargetPoolsRemoveHealthCheckRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest();
                            if (object.healthChecks) {
                                if (!Array.isArray(object.healthChecks))
                                    throw TypeError(".google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest.healthChecks: array expected");
                                message.healthChecks = [];
                                for (var i = 0; i < object.healthChecks.length; ++i) {
                                    if (typeof object.healthChecks[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest.healthChecks: object expected");
                                    message.healthChecks[i] = $root.google.cloud.compute.v1.HealthCheckReference.fromObject(object.healthChecks[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetPoolsRemoveHealthCheckRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest} message TargetPoolsRemoveHealthCheckRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetPoolsRemoveHealthCheckRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.healthChecks = [];
                            if (message.healthChecks && message.healthChecks.length) {
                                object.healthChecks = [];
                                for (var j = 0; j < message.healthChecks.length; ++j)
                                    object.healthChecks[j] = $root.google.cloud.compute.v1.HealthCheckReference.toObject(message.healthChecks[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetPoolsRemoveHealthCheckRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetPoolsRemoveHealthCheckRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetPoolsRemoveHealthCheckRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetPoolsRemoveHealthCheckRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetPoolsRemoveHealthCheckRequest";
                        };
    
                        return TargetPoolsRemoveHealthCheckRequest;
                    })();
    
                    v1.TargetPoolsRemoveInstanceRequest = (function() {
    
                        /**
                         * Properties of a TargetPoolsRemoveInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetPoolsRemoveInstanceRequest
                         * @property {Array.<google.cloud.compute.v1.IInstanceReference>|null} [instances] TargetPoolsRemoveInstanceRequest instances
                         */
    
                        /**
                         * Constructs a new TargetPoolsRemoveInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetPoolsRemoveInstanceRequest.
                         * @implements ITargetPoolsRemoveInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetPoolsRemoveInstanceRequest=} [properties] Properties to set
                         */
                        function TargetPoolsRemoveInstanceRequest(properties) {
                            this.instances = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetPoolsRemoveInstanceRequest instances.
                         * @member {Array.<google.cloud.compute.v1.IInstanceReference>} instances
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest
                         * @instance
                         */
                        TargetPoolsRemoveInstanceRequest.prototype.instances = $util.emptyArray;
    
                        /**
                         * Creates a new TargetPoolsRemoveInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolsRemoveInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest} TargetPoolsRemoveInstanceRequest instance
                         */
                        TargetPoolsRemoveInstanceRequest.create = function create(properties) {
                            return new TargetPoolsRemoveInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TargetPoolsRemoveInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolsRemoveInstanceRequest} message TargetPoolsRemoveInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetPoolsRemoveInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instances != null && message.instances.length)
                                for (var i = 0; i < message.instances.length; ++i)
                                    $root.google.cloud.compute.v1.InstanceReference.encode(message.instances[i], writer.uint32(/* id 29097598, wireType 2 =*/232780786).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetPoolsRemoveInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolsRemoveInstanceRequest} message TargetPoolsRemoveInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetPoolsRemoveInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetPoolsRemoveInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest} TargetPoolsRemoveInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetPoolsRemoveInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 29097598: {
                                        if (!(message.instances && message.instances.length))
                                            message.instances = [];
                                        message.instances.push($root.google.cloud.compute.v1.InstanceReference.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetPoolsRemoveInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest} TargetPoolsRemoveInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetPoolsRemoveInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetPoolsRemoveInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetPoolsRemoveInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.instances != null && message.hasOwnProperty("instances")) {
                                if (!Array.isArray(message.instances))
                                    return "instances: array expected";
                                for (var i = 0; i < message.instances.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.InstanceReference.verify(message.instances[i]);
                                    if (error)
                                        return "instances." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetPoolsRemoveInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest} TargetPoolsRemoveInstanceRequest
                         */
                        TargetPoolsRemoveInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest();
                            if (object.instances) {
                                if (!Array.isArray(object.instances))
                                    throw TypeError(".google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest.instances: array expected");
                                message.instances = [];
                                for (var i = 0; i < object.instances.length; ++i) {
                                    if (typeof object.instances[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest.instances: object expected");
                                    message.instances[i] = $root.google.cloud.compute.v1.InstanceReference.fromObject(object.instances[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetPoolsRemoveInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest} message TargetPoolsRemoveInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetPoolsRemoveInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.instances = [];
                            if (message.instances && message.instances.length) {
                                object.instances = [];
                                for (var j = 0; j < message.instances.length; ++j)
                                    object.instances[j] = $root.google.cloud.compute.v1.InstanceReference.toObject(message.instances[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetPoolsRemoveInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetPoolsRemoveInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetPoolsRemoveInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetPoolsRemoveInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetPoolsRemoveInstanceRequest";
                        };
    
                        return TargetPoolsRemoveInstanceRequest;
                    })();
    
                    v1.TargetPoolsScopedList = (function() {
    
                        /**
                         * Properties of a TargetPoolsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetPoolsScopedList
                         * @property {Array.<google.cloud.compute.v1.ITargetPool>|null} [targetPools] TargetPoolsScopedList targetPools
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] TargetPoolsScopedList warning
                         */
    
                        /**
                         * Constructs a new TargetPoolsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetPoolsScopedList.
                         * @implements ITargetPoolsScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetPoolsScopedList=} [properties] Properties to set
                         */
                        function TargetPoolsScopedList(properties) {
                            this.targetPools = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetPoolsScopedList targetPools.
                         * @member {Array.<google.cloud.compute.v1.ITargetPool>} targetPools
                         * @memberof google.cloud.compute.v1.TargetPoolsScopedList
                         * @instance
                         */
                        TargetPoolsScopedList.prototype.targetPools = $util.emptyArray;
    
                        /**
                         * TargetPoolsScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.TargetPoolsScopedList
                         * @instance
                         */
                        TargetPoolsScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetPoolsScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.TargetPoolsScopedList
                         * @instance
                         */
                        Object.defineProperty(TargetPoolsScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetPoolsScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetPoolsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolsScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetPoolsScopedList} TargetPoolsScopedList instance
                         */
                        TargetPoolsScopedList.create = function create(properties) {
                            return new TargetPoolsScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified TargetPoolsScopedList message. Does not implicitly {@link google.cloud.compute.v1.TargetPoolsScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetPoolsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolsScopedList} message TargetPoolsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetPoolsScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.targetPools != null && message.targetPools.length)
                                for (var i = 0; i < message.targetPools.length; ++i)
                                    $root.google.cloud.compute.v1.TargetPool.encode(message.targetPools[i], writer.uint32(/* id 336072617, wireType 2 =*/2688580938).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetPoolsScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetPoolsScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetPoolsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetPoolsScopedList} message TargetPoolsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetPoolsScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetPoolsScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetPoolsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetPoolsScopedList} TargetPoolsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetPoolsScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetPoolsScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336072617: {
                                        if (!(message.targetPools && message.targetPools.length))
                                            message.targetPools = [];
                                        message.targetPools.push($root.google.cloud.compute.v1.TargetPool.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetPoolsScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetPoolsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetPoolsScopedList} TargetPoolsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetPoolsScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetPoolsScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetPoolsScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetPoolsScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.targetPools != null && message.hasOwnProperty("targetPools")) {
                                if (!Array.isArray(message.targetPools))
                                    return "targetPools: array expected";
                                for (var i = 0; i < message.targetPools.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.TargetPool.verify(message.targetPools[i]);
                                    if (error)
                                        return "targetPools." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetPoolsScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetPoolsScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetPoolsScopedList} TargetPoolsScopedList
                         */
                        TargetPoolsScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetPoolsScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetPoolsScopedList();
                            if (object.targetPools) {
                                if (!Array.isArray(object.targetPools))
                                    throw TypeError(".google.cloud.compute.v1.TargetPoolsScopedList.targetPools: array expected");
                                message.targetPools = [];
                                for (var i = 0; i < object.targetPools.length; ++i) {
                                    if (typeof object.targetPools[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetPoolsScopedList.targetPools: object expected");
                                    message.targetPools[i] = $root.google.cloud.compute.v1.TargetPool.fromObject(object.targetPools[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetPoolsScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetPoolsScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetPoolsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.TargetPoolsScopedList} message TargetPoolsScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetPoolsScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.targetPools = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.targetPools && message.targetPools.length) {
                                object.targetPools = [];
                                for (var j = 0; j < message.targetPools.length; ++j)
                                    object.targetPools[j] = $root.google.cloud.compute.v1.TargetPool.toObject(message.targetPools[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetPoolsScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetPoolsScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetPoolsScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetPoolsScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetPoolsScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetPoolsScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetPoolsScopedList";
                        };
    
                        return TargetPoolsScopedList;
                    })();
    
                    v1.TargetReference = (function() {
    
                        /**
                         * Properties of a TargetReference.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetReference
                         * @property {string|null} [target] TargetReference target
                         */
    
                        /**
                         * Constructs a new TargetReference.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetReference.
                         * @implements ITargetReference
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetReference=} [properties] Properties to set
                         */
                        function TargetReference(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetReference target.
                         * @member {string|null|undefined} target
                         * @memberof google.cloud.compute.v1.TargetReference
                         * @instance
                         */
                        TargetReference.prototype.target = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetReference _target.
                         * @member {"target"|undefined} _target
                         * @memberof google.cloud.compute.v1.TargetReference
                         * @instance
                         */
                        Object.defineProperty(TargetReference.prototype, "_target", {
                            get: $util.oneOfGetter($oneOfFields = ["target"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetReference instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetReference
                         * @static
                         * @param {google.cloud.compute.v1.ITargetReference=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetReference} TargetReference instance
                         */
                        TargetReference.create = function create(properties) {
                            return new TargetReference(properties);
                        };
    
                        /**
                         * Encodes the specified TargetReference message. Does not implicitly {@link google.cloud.compute.v1.TargetReference.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetReference
                         * @static
                         * @param {google.cloud.compute.v1.ITargetReference} message TargetReference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetReference.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.target != null && Object.hasOwnProperty.call(message, "target"))
                                writer.uint32(/* id 192835985, wireType 2 =*/1542687882).string(message.target);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetReference message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetReference.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetReference
                         * @static
                         * @param {google.cloud.compute.v1.ITargetReference} message TargetReference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetReference.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetReference message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetReference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetReference} TargetReference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetReference.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetReference();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 192835985: {
                                        message.target = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetReference message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetReference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetReference} TargetReference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetReference.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetReference message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetReference
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetReference.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.target != null && message.hasOwnProperty("target")) {
                                properties._target = 1;
                                if (!$util.isString(message.target))
                                    return "target: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetReference message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetReference
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetReference} TargetReference
                         */
                        TargetReference.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetReference)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetReference();
                            if (object.target != null)
                                message.target = String(object.target);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetReference message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetReference
                         * @static
                         * @param {google.cloud.compute.v1.TargetReference} message TargetReference
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetReference.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.target != null && message.hasOwnProperty("target")) {
                                object.target = message.target;
                                if (options.oneofs)
                                    object._target = "target";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetReference to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetReference
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetReference.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetReference
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetReference
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetReference.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetReference";
                        };
    
                        return TargetReference;
                    })();
    
                    v1.TargetSslProxiesSetBackendServiceRequest = (function() {
    
                        /**
                         * Properties of a TargetSslProxiesSetBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetSslProxiesSetBackendServiceRequest
                         * @property {string|null} [service] TargetSslProxiesSetBackendServiceRequest service
                         */
    
                        /**
                         * Constructs a new TargetSslProxiesSetBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetSslProxiesSetBackendServiceRequest.
                         * @implements ITargetSslProxiesSetBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetSslProxiesSetBackendServiceRequest=} [properties] Properties to set
                         */
                        function TargetSslProxiesSetBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetSslProxiesSetBackendServiceRequest service.
                         * @member {string|null|undefined} service
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest
                         * @instance
                         */
                        TargetSslProxiesSetBackendServiceRequest.prototype.service = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetSslProxiesSetBackendServiceRequest _service.
                         * @member {"service"|undefined} _service
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest
                         * @instance
                         */
                        Object.defineProperty(TargetSslProxiesSetBackendServiceRequest.prototype, "_service", {
                            get: $util.oneOfGetter($oneOfFields = ["service"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetSslProxiesSetBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetSslProxiesSetBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest} TargetSslProxiesSetBackendServiceRequest instance
                         */
                        TargetSslProxiesSetBackendServiceRequest.create = function create(properties) {
                            return new TargetSslProxiesSetBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TargetSslProxiesSetBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetSslProxiesSetBackendServiceRequest} message TargetSslProxiesSetBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetSslProxiesSetBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.service != null && Object.hasOwnProperty.call(message, "service"))
                                writer.uint32(/* id 373540533, wireType 2 =*/2988324266).string(message.service);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetSslProxiesSetBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetSslProxiesSetBackendServiceRequest} message TargetSslProxiesSetBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetSslProxiesSetBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetSslProxiesSetBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest} TargetSslProxiesSetBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetSslProxiesSetBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 373540533: {
                                        message.service = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetSslProxiesSetBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest} TargetSslProxiesSetBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetSslProxiesSetBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetSslProxiesSetBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetSslProxiesSetBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.service != null && message.hasOwnProperty("service")) {
                                properties._service = 1;
                                if (!$util.isString(message.service))
                                    return "service: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetSslProxiesSetBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest} TargetSslProxiesSetBackendServiceRequest
                         */
                        TargetSslProxiesSetBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest();
                            if (object.service != null)
                                message.service = String(object.service);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetSslProxiesSetBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest} message TargetSslProxiesSetBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetSslProxiesSetBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.service != null && message.hasOwnProperty("service")) {
                                object.service = message.service;
                                if (options.oneofs)
                                    object._service = "service";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetSslProxiesSetBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetSslProxiesSetBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetSslProxiesSetBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetSslProxiesSetBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetSslProxiesSetBackendServiceRequest";
                        };
    
                        return TargetSslProxiesSetBackendServiceRequest;
                    })();
    
                    v1.TargetSslProxiesSetCertificateMapRequest = (function() {
    
                        /**
                         * Properties of a TargetSslProxiesSetCertificateMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetSslProxiesSetCertificateMapRequest
                         * @property {string|null} [certificateMap] TargetSslProxiesSetCertificateMapRequest certificateMap
                         */
    
                        /**
                         * Constructs a new TargetSslProxiesSetCertificateMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetSslProxiesSetCertificateMapRequest.
                         * @implements ITargetSslProxiesSetCertificateMapRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetSslProxiesSetCertificateMapRequest=} [properties] Properties to set
                         */
                        function TargetSslProxiesSetCertificateMapRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetSslProxiesSetCertificateMapRequest certificateMap.
                         * @member {string|null|undefined} certificateMap
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest
                         * @instance
                         */
                        TargetSslProxiesSetCertificateMapRequest.prototype.certificateMap = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetSslProxiesSetCertificateMapRequest _certificateMap.
                         * @member {"certificateMap"|undefined} _certificateMap
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest
                         * @instance
                         */
                        Object.defineProperty(TargetSslProxiesSetCertificateMapRequest.prototype, "_certificateMap", {
                            get: $util.oneOfGetter($oneOfFields = ["certificateMap"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetSslProxiesSetCertificateMapRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetSslProxiesSetCertificateMapRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest} TargetSslProxiesSetCertificateMapRequest instance
                         */
                        TargetSslProxiesSetCertificateMapRequest.create = function create(properties) {
                            return new TargetSslProxiesSetCertificateMapRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TargetSslProxiesSetCertificateMapRequest message. Does not implicitly {@link google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetSslProxiesSetCertificateMapRequest} message TargetSslProxiesSetCertificateMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetSslProxiesSetCertificateMapRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.certificateMap != null && Object.hasOwnProperty.call(message, "certificateMap"))
                                writer.uint32(/* id 156463796, wireType 2 =*/1251710370).string(message.certificateMap);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetSslProxiesSetCertificateMapRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetSslProxiesSetCertificateMapRequest} message TargetSslProxiesSetCertificateMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetSslProxiesSetCertificateMapRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetSslProxiesSetCertificateMapRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest} TargetSslProxiesSetCertificateMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetSslProxiesSetCertificateMapRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 156463796: {
                                        message.certificateMap = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetSslProxiesSetCertificateMapRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest} TargetSslProxiesSetCertificateMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetSslProxiesSetCertificateMapRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetSslProxiesSetCertificateMapRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetSslProxiesSetCertificateMapRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.certificateMap != null && message.hasOwnProperty("certificateMap")) {
                                properties._certificateMap = 1;
                                if (!$util.isString(message.certificateMap))
                                    return "certificateMap: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetSslProxiesSetCertificateMapRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest} TargetSslProxiesSetCertificateMapRequest
                         */
                        TargetSslProxiesSetCertificateMapRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest();
                            if (object.certificateMap != null)
                                message.certificateMap = String(object.certificateMap);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetSslProxiesSetCertificateMapRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest} message TargetSslProxiesSetCertificateMapRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetSslProxiesSetCertificateMapRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.certificateMap != null && message.hasOwnProperty("certificateMap")) {
                                object.certificateMap = message.certificateMap;
                                if (options.oneofs)
                                    object._certificateMap = "certificateMap";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetSslProxiesSetCertificateMapRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetSslProxiesSetCertificateMapRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetSslProxiesSetCertificateMapRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetSslProxiesSetCertificateMapRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetSslProxiesSetCertificateMapRequest";
                        };
    
                        return TargetSslProxiesSetCertificateMapRequest;
                    })();
    
                    v1.TargetSslProxiesSetProxyHeaderRequest = (function() {
    
                        /**
                         * Properties of a TargetSslProxiesSetProxyHeaderRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetSslProxiesSetProxyHeaderRequest
                         * @property {string|null} [proxyHeader] TargetSslProxiesSetProxyHeaderRequest proxyHeader
                         */
    
                        /**
                         * Constructs a new TargetSslProxiesSetProxyHeaderRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetSslProxiesSetProxyHeaderRequest.
                         * @implements ITargetSslProxiesSetProxyHeaderRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetSslProxiesSetProxyHeaderRequest=} [properties] Properties to set
                         */
                        function TargetSslProxiesSetProxyHeaderRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetSslProxiesSetProxyHeaderRequest proxyHeader.
                         * @member {string|null|undefined} proxyHeader
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest
                         * @instance
                         */
                        TargetSslProxiesSetProxyHeaderRequest.prototype.proxyHeader = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetSslProxiesSetProxyHeaderRequest _proxyHeader.
                         * @member {"proxyHeader"|undefined} _proxyHeader
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest
                         * @instance
                         */
                        Object.defineProperty(TargetSslProxiesSetProxyHeaderRequest.prototype, "_proxyHeader", {
                            get: $util.oneOfGetter($oneOfFields = ["proxyHeader"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetSslProxiesSetProxyHeaderRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetSslProxiesSetProxyHeaderRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest} TargetSslProxiesSetProxyHeaderRequest instance
                         */
                        TargetSslProxiesSetProxyHeaderRequest.create = function create(properties) {
                            return new TargetSslProxiesSetProxyHeaderRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TargetSslProxiesSetProxyHeaderRequest message. Does not implicitly {@link google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetSslProxiesSetProxyHeaderRequest} message TargetSslProxiesSetProxyHeaderRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetSslProxiesSetProxyHeaderRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.proxyHeader != null && Object.hasOwnProperty.call(message, "proxyHeader"))
                                writer.uint32(/* id 160374142, wireType 2 =*/1282993138).string(message.proxyHeader);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetSslProxiesSetProxyHeaderRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetSslProxiesSetProxyHeaderRequest} message TargetSslProxiesSetProxyHeaderRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetSslProxiesSetProxyHeaderRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetSslProxiesSetProxyHeaderRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest} TargetSslProxiesSetProxyHeaderRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetSslProxiesSetProxyHeaderRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 160374142: {
                                        message.proxyHeader = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetSslProxiesSetProxyHeaderRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest} TargetSslProxiesSetProxyHeaderRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetSslProxiesSetProxyHeaderRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetSslProxiesSetProxyHeaderRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetSslProxiesSetProxyHeaderRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.proxyHeader != null && message.hasOwnProperty("proxyHeader")) {
                                properties._proxyHeader = 1;
                                if (!$util.isString(message.proxyHeader))
                                    return "proxyHeader: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetSslProxiesSetProxyHeaderRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest} TargetSslProxiesSetProxyHeaderRequest
                         */
                        TargetSslProxiesSetProxyHeaderRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest();
                            if (object.proxyHeader != null)
                                message.proxyHeader = String(object.proxyHeader);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetSslProxiesSetProxyHeaderRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest
                         * @static
                         * @param {google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest} message TargetSslProxiesSetProxyHeaderRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetSslProxiesSetProxyHeaderRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.proxyHeader != null && message.hasOwnProperty("proxyHeader")) {
                                object.proxyHeader = message.proxyHeader;
                                if (options.oneofs)
                                    object._proxyHeader = "proxyHeader";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetSslProxiesSetProxyHeaderRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetSslProxiesSetProxyHeaderRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetSslProxiesSetProxyHeaderRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetSslProxiesSetProxyHeaderRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest";
                        };
    
                        /**
                         * ProxyHeader enum.
                         * @name google.cloud.compute.v1.TargetSslProxiesSetProxyHeaderRequest.ProxyHeader
                         * @enum {number}
                         * @property {number} UNDEFINED_PROXY_HEADER=0 UNDEFINED_PROXY_HEADER value
                         * @property {number} NONE=2402104 NONE value
                         * @property {number} PROXY_V1=334352940 PROXY_V1 value
                         */
                        TargetSslProxiesSetProxyHeaderRequest.ProxyHeader = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PROXY_HEADER"] = 0;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            values[valuesById[334352940] = "PROXY_V1"] = 334352940;
                            return values;
                        })();
    
                        return TargetSslProxiesSetProxyHeaderRequest;
                    })();
    
                    v1.TargetSslProxiesSetSslCertificatesRequest = (function() {
    
                        /**
                         * Properties of a TargetSslProxiesSetSslCertificatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetSslProxiesSetSslCertificatesRequest
                         * @property {Array.<string>|null} [sslCertificates] TargetSslProxiesSetSslCertificatesRequest sslCertificates
                         */
    
                        /**
                         * Constructs a new TargetSslProxiesSetSslCertificatesRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetSslProxiesSetSslCertificatesRequest.
                         * @implements ITargetSslProxiesSetSslCertificatesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetSslProxiesSetSslCertificatesRequest=} [properties] Properties to set
                         */
                        function TargetSslProxiesSetSslCertificatesRequest(properties) {
                            this.sslCertificates = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetSslProxiesSetSslCertificatesRequest sslCertificates.
                         * @member {Array.<string>} sslCertificates
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest
                         * @instance
                         */
                        TargetSslProxiesSetSslCertificatesRequest.prototype.sslCertificates = $util.emptyArray;
    
                        /**
                         * Creates a new TargetSslProxiesSetSslCertificatesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetSslProxiesSetSslCertificatesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest} TargetSslProxiesSetSslCertificatesRequest instance
                         */
                        TargetSslProxiesSetSslCertificatesRequest.create = function create(properties) {
                            return new TargetSslProxiesSetSslCertificatesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TargetSslProxiesSetSslCertificatesRequest message. Does not implicitly {@link google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetSslProxiesSetSslCertificatesRequest} message TargetSslProxiesSetSslCertificatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetSslProxiesSetSslCertificatesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.sslCertificates != null && message.sslCertificates.length)
                                for (var i = 0; i < message.sslCertificates.length; ++i)
                                    writer.uint32(/* id 366006543, wireType 2 =*/2928052346).string(message.sslCertificates[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetSslProxiesSetSslCertificatesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetSslProxiesSetSslCertificatesRequest} message TargetSslProxiesSetSslCertificatesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetSslProxiesSetSslCertificatesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetSslProxiesSetSslCertificatesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest} TargetSslProxiesSetSslCertificatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetSslProxiesSetSslCertificatesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 366006543: {
                                        if (!(message.sslCertificates && message.sslCertificates.length))
                                            message.sslCertificates = [];
                                        message.sslCertificates.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetSslProxiesSetSslCertificatesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest} TargetSslProxiesSetSslCertificatesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetSslProxiesSetSslCertificatesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetSslProxiesSetSslCertificatesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetSslProxiesSetSslCertificatesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.sslCertificates != null && message.hasOwnProperty("sslCertificates")) {
                                if (!Array.isArray(message.sslCertificates))
                                    return "sslCertificates: array expected";
                                for (var i = 0; i < message.sslCertificates.length; ++i)
                                    if (!$util.isString(message.sslCertificates[i]))
                                        return "sslCertificates: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetSslProxiesSetSslCertificatesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest} TargetSslProxiesSetSslCertificatesRequest
                         */
                        TargetSslProxiesSetSslCertificatesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest();
                            if (object.sslCertificates) {
                                if (!Array.isArray(object.sslCertificates))
                                    throw TypeError(".google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest.sslCertificates: array expected");
                                message.sslCertificates = [];
                                for (var i = 0; i < object.sslCertificates.length; ++i)
                                    message.sslCertificates[i] = String(object.sslCertificates[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetSslProxiesSetSslCertificatesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest
                         * @static
                         * @param {google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest} message TargetSslProxiesSetSslCertificatesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetSslProxiesSetSslCertificatesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.sslCertificates = [];
                            if (message.sslCertificates && message.sslCertificates.length) {
                                object.sslCertificates = [];
                                for (var j = 0; j < message.sslCertificates.length; ++j)
                                    object.sslCertificates[j] = message.sslCertificates[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetSslProxiesSetSslCertificatesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetSslProxiesSetSslCertificatesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetSslProxiesSetSslCertificatesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetSslProxiesSetSslCertificatesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetSslProxiesSetSslCertificatesRequest";
                        };
    
                        return TargetSslProxiesSetSslCertificatesRequest;
                    })();
    
                    v1.TargetSslProxy = (function() {
    
                        /**
                         * Properties of a TargetSslProxy.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetSslProxy
                         * @property {string|null} [certificateMap] TargetSslProxy certificateMap
                         * @property {string|null} [creationTimestamp] TargetSslProxy creationTimestamp
                         * @property {string|null} [description] TargetSslProxy description
                         * @property {number|Long|null} [id] TargetSslProxy id
                         * @property {string|null} [kind] TargetSslProxy kind
                         * @property {string|null} [name] TargetSslProxy name
                         * @property {string|null} [proxyHeader] TargetSslProxy proxyHeader
                         * @property {string|null} [selfLink] TargetSslProxy selfLink
                         * @property {string|null} [service] TargetSslProxy service
                         * @property {Array.<string>|null} [sslCertificates] TargetSslProxy sslCertificates
                         * @property {string|null} [sslPolicy] TargetSslProxy sslPolicy
                         */
    
                        /**
                         * Constructs a new TargetSslProxy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetSslProxy.
                         * @implements ITargetSslProxy
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetSslProxy=} [properties] Properties to set
                         */
                        function TargetSslProxy(properties) {
                            this.sslCertificates = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetSslProxy certificateMap.
                         * @member {string|null|undefined} certificateMap
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        TargetSslProxy.prototype.certificateMap = null;
    
                        /**
                         * TargetSslProxy creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        TargetSslProxy.prototype.creationTimestamp = null;
    
                        /**
                         * TargetSslProxy description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        TargetSslProxy.prototype.description = null;
    
                        /**
                         * TargetSslProxy id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        TargetSslProxy.prototype.id = null;
    
                        /**
                         * TargetSslProxy kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        TargetSslProxy.prototype.kind = null;
    
                        /**
                         * TargetSslProxy name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        TargetSslProxy.prototype.name = null;
    
                        /**
                         * TargetSslProxy proxyHeader.
                         * @member {string|null|undefined} proxyHeader
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        TargetSslProxy.prototype.proxyHeader = null;
    
                        /**
                         * TargetSslProxy selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        TargetSslProxy.prototype.selfLink = null;
    
                        /**
                         * TargetSslProxy service.
                         * @member {string|null|undefined} service
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        TargetSslProxy.prototype.service = null;
    
                        /**
                         * TargetSslProxy sslCertificates.
                         * @member {Array.<string>} sslCertificates
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        TargetSslProxy.prototype.sslCertificates = $util.emptyArray;
    
                        /**
                         * TargetSslProxy sslPolicy.
                         * @member {string|null|undefined} sslPolicy
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        TargetSslProxy.prototype.sslPolicy = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetSslProxy _certificateMap.
                         * @member {"certificateMap"|undefined} _certificateMap
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        Object.defineProperty(TargetSslProxy.prototype, "_certificateMap", {
                            get: $util.oneOfGetter($oneOfFields = ["certificateMap"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetSslProxy _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        Object.defineProperty(TargetSslProxy.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetSslProxy _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        Object.defineProperty(TargetSslProxy.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetSslProxy _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        Object.defineProperty(TargetSslProxy.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetSslProxy _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        Object.defineProperty(TargetSslProxy.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetSslProxy _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        Object.defineProperty(TargetSslProxy.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetSslProxy _proxyHeader.
                         * @member {"proxyHeader"|undefined} _proxyHeader
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        Object.defineProperty(TargetSslProxy.prototype, "_proxyHeader", {
                            get: $util.oneOfGetter($oneOfFields = ["proxyHeader"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetSslProxy _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        Object.defineProperty(TargetSslProxy.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetSslProxy _service.
                         * @member {"service"|undefined} _service
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        Object.defineProperty(TargetSslProxy.prototype, "_service", {
                            get: $util.oneOfGetter($oneOfFields = ["service"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetSslProxy _sslPolicy.
                         * @member {"sslPolicy"|undefined} _sslPolicy
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         */
                        Object.defineProperty(TargetSslProxy.prototype, "_sslPolicy", {
                            get: $util.oneOfGetter($oneOfFields = ["sslPolicy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetSslProxy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @static
                         * @param {google.cloud.compute.v1.ITargetSslProxy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetSslProxy} TargetSslProxy instance
                         */
                        TargetSslProxy.create = function create(properties) {
                            return new TargetSslProxy(properties);
                        };
    
                        /**
                         * Encodes the specified TargetSslProxy message. Does not implicitly {@link google.cloud.compute.v1.TargetSslProxy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @static
                         * @param {google.cloud.compute.v1.ITargetSslProxy} message TargetSslProxy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetSslProxy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.certificateMap != null && Object.hasOwnProperty.call(message, "certificateMap"))
                                writer.uint32(/* id 156463796, wireType 2 =*/1251710370).string(message.certificateMap);
                            if (message.proxyHeader != null && Object.hasOwnProperty.call(message, "proxyHeader"))
                                writer.uint32(/* id 160374142, wireType 2 =*/1282993138).string(message.proxyHeader);
                            if (message.sslPolicy != null && Object.hasOwnProperty.call(message, "sslPolicy"))
                                writer.uint32(/* id 295190213, wireType 2 =*/2361521706).string(message.sslPolicy);
                            if (message.sslCertificates != null && message.sslCertificates.length)
                                for (var i = 0; i < message.sslCertificates.length; ++i)
                                    writer.uint32(/* id 366006543, wireType 2 =*/2928052346).string(message.sslCertificates[i]);
                            if (message.service != null && Object.hasOwnProperty.call(message, "service"))
                                writer.uint32(/* id 373540533, wireType 2 =*/2988324266).string(message.service);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetSslProxy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetSslProxy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @static
                         * @param {google.cloud.compute.v1.ITargetSslProxy} message TargetSslProxy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetSslProxy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetSslProxy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetSslProxy} TargetSslProxy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetSslProxy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetSslProxy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 156463796: {
                                        message.certificateMap = reader.string();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 160374142: {
                                        message.proxyHeader = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 373540533: {
                                        message.service = reader.string();
                                        break;
                                    }
                                case 366006543: {
                                        if (!(message.sslCertificates && message.sslCertificates.length))
                                            message.sslCertificates = [];
                                        message.sslCertificates.push(reader.string());
                                        break;
                                    }
                                case 295190213: {
                                        message.sslPolicy = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetSslProxy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetSslProxy} TargetSslProxy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetSslProxy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetSslProxy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetSslProxy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.certificateMap != null && message.hasOwnProperty("certificateMap")) {
                                properties._certificateMap = 1;
                                if (!$util.isString(message.certificateMap))
                                    return "certificateMap: string expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.proxyHeader != null && message.hasOwnProperty("proxyHeader")) {
                                properties._proxyHeader = 1;
                                if (!$util.isString(message.proxyHeader))
                                    return "proxyHeader: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.service != null && message.hasOwnProperty("service")) {
                                properties._service = 1;
                                if (!$util.isString(message.service))
                                    return "service: string expected";
                            }
                            if (message.sslCertificates != null && message.hasOwnProperty("sslCertificates")) {
                                if (!Array.isArray(message.sslCertificates))
                                    return "sslCertificates: array expected";
                                for (var i = 0; i < message.sslCertificates.length; ++i)
                                    if (!$util.isString(message.sslCertificates[i]))
                                        return "sslCertificates: string[] expected";
                            }
                            if (message.sslPolicy != null && message.hasOwnProperty("sslPolicy")) {
                                properties._sslPolicy = 1;
                                if (!$util.isString(message.sslPolicy))
                                    return "sslPolicy: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetSslProxy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetSslProxy} TargetSslProxy
                         */
                        TargetSslProxy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetSslProxy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetSslProxy();
                            if (object.certificateMap != null)
                                message.certificateMap = String(object.certificateMap);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.proxyHeader != null)
                                message.proxyHeader = String(object.proxyHeader);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.service != null)
                                message.service = String(object.service);
                            if (object.sslCertificates) {
                                if (!Array.isArray(object.sslCertificates))
                                    throw TypeError(".google.cloud.compute.v1.TargetSslProxy.sslCertificates: array expected");
                                message.sslCertificates = [];
                                for (var i = 0; i < object.sslCertificates.length; ++i)
                                    message.sslCertificates[i] = String(object.sslCertificates[i]);
                            }
                            if (object.sslPolicy != null)
                                message.sslPolicy = String(object.sslPolicy);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetSslProxy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @static
                         * @param {google.cloud.compute.v1.TargetSslProxy} message TargetSslProxy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetSslProxy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.sslCertificates = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.certificateMap != null && message.hasOwnProperty("certificateMap")) {
                                object.certificateMap = message.certificateMap;
                                if (options.oneofs)
                                    object._certificateMap = "certificateMap";
                            }
                            if (message.proxyHeader != null && message.hasOwnProperty("proxyHeader")) {
                                object.proxyHeader = message.proxyHeader;
                                if (options.oneofs)
                                    object._proxyHeader = "proxyHeader";
                            }
                            if (message.sslPolicy != null && message.hasOwnProperty("sslPolicy")) {
                                object.sslPolicy = message.sslPolicy;
                                if (options.oneofs)
                                    object._sslPolicy = "sslPolicy";
                            }
                            if (message.sslCertificates && message.sslCertificates.length) {
                                object.sslCertificates = [];
                                for (var j = 0; j < message.sslCertificates.length; ++j)
                                    object.sslCertificates[j] = message.sslCertificates[j];
                            }
                            if (message.service != null && message.hasOwnProperty("service")) {
                                object.service = message.service;
                                if (options.oneofs)
                                    object._service = "service";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetSslProxy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetSslProxy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetSslProxy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetSslProxy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetSslProxy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetSslProxy";
                        };
    
                        /**
                         * ProxyHeader enum.
                         * @name google.cloud.compute.v1.TargetSslProxy.ProxyHeader
                         * @enum {number}
                         * @property {number} UNDEFINED_PROXY_HEADER=0 UNDEFINED_PROXY_HEADER value
                         * @property {number} NONE=2402104 NONE value
                         * @property {number} PROXY_V1=334352940 PROXY_V1 value
                         */
                        TargetSslProxy.ProxyHeader = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PROXY_HEADER"] = 0;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            values[valuesById[334352940] = "PROXY_V1"] = 334352940;
                            return values;
                        })();
    
                        return TargetSslProxy;
                    })();
    
                    v1.TargetSslProxyList = (function() {
    
                        /**
                         * Properties of a TargetSslProxyList.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetSslProxyList
                         * @property {string|null} [id] TargetSslProxyList id
                         * @property {Array.<google.cloud.compute.v1.ITargetSslProxy>|null} [items] TargetSslProxyList items
                         * @property {string|null} [kind] TargetSslProxyList kind
                         * @property {string|null} [nextPageToken] TargetSslProxyList nextPageToken
                         * @property {string|null} [selfLink] TargetSslProxyList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] TargetSslProxyList warning
                         */
    
                        /**
                         * Constructs a new TargetSslProxyList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetSslProxyList.
                         * @implements ITargetSslProxyList
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetSslProxyList=} [properties] Properties to set
                         */
                        function TargetSslProxyList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetSslProxyList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @instance
                         */
                        TargetSslProxyList.prototype.id = null;
    
                        /**
                         * TargetSslProxyList items.
                         * @member {Array.<google.cloud.compute.v1.ITargetSslProxy>} items
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @instance
                         */
                        TargetSslProxyList.prototype.items = $util.emptyArray;
    
                        /**
                         * TargetSslProxyList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @instance
                         */
                        TargetSslProxyList.prototype.kind = null;
    
                        /**
                         * TargetSslProxyList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @instance
                         */
                        TargetSslProxyList.prototype.nextPageToken = null;
    
                        /**
                         * TargetSslProxyList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @instance
                         */
                        TargetSslProxyList.prototype.selfLink = null;
    
                        /**
                         * TargetSslProxyList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @instance
                         */
                        TargetSslProxyList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetSslProxyList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetSslProxyList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetSslProxyList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetSslProxyList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetSslProxyList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetSslProxyList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetSslProxyList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetSslProxyList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetSslProxyList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetSslProxyList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetSslProxyList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetSslProxyList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetSslProxyList} TargetSslProxyList instance
                         */
                        TargetSslProxyList.create = function create(properties) {
                            return new TargetSslProxyList(properties);
                        };
    
                        /**
                         * Encodes the specified TargetSslProxyList message. Does not implicitly {@link google.cloud.compute.v1.TargetSslProxyList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetSslProxyList} message TargetSslProxyList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetSslProxyList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.TargetSslProxy.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetSslProxyList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetSslProxyList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetSslProxyList} message TargetSslProxyList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetSslProxyList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetSslProxyList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetSslProxyList} TargetSslProxyList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetSslProxyList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetSslProxyList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.TargetSslProxy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetSslProxyList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetSslProxyList} TargetSslProxyList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetSslProxyList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetSslProxyList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetSslProxyList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.TargetSslProxy.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetSslProxyList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetSslProxyList} TargetSslProxyList
                         */
                        TargetSslProxyList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetSslProxyList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetSslProxyList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.TargetSslProxyList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetSslProxyList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.TargetSslProxy.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetSslProxyList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetSslProxyList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @static
                         * @param {google.cloud.compute.v1.TargetSslProxyList} message TargetSslProxyList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetSslProxyList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.TargetSslProxy.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetSslProxyList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetSslProxyList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetSslProxyList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetSslProxyList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetSslProxyList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetSslProxyList";
                        };
    
                        return TargetSslProxyList;
                    })();
    
                    v1.TargetTcpProxiesSetBackendServiceRequest = (function() {
    
                        /**
                         * Properties of a TargetTcpProxiesSetBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetTcpProxiesSetBackendServiceRequest
                         * @property {string|null} [service] TargetTcpProxiesSetBackendServiceRequest service
                         */
    
                        /**
                         * Constructs a new TargetTcpProxiesSetBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetTcpProxiesSetBackendServiceRequest.
                         * @implements ITargetTcpProxiesSetBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetTcpProxiesSetBackendServiceRequest=} [properties] Properties to set
                         */
                        function TargetTcpProxiesSetBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetTcpProxiesSetBackendServiceRequest service.
                         * @member {string|null|undefined} service
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest
                         * @instance
                         */
                        TargetTcpProxiesSetBackendServiceRequest.prototype.service = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetTcpProxiesSetBackendServiceRequest _service.
                         * @member {"service"|undefined} _service
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest
                         * @instance
                         */
                        Object.defineProperty(TargetTcpProxiesSetBackendServiceRequest.prototype, "_service", {
                            get: $util.oneOfGetter($oneOfFields = ["service"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetTcpProxiesSetBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetTcpProxiesSetBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest} TargetTcpProxiesSetBackendServiceRequest instance
                         */
                        TargetTcpProxiesSetBackendServiceRequest.create = function create(properties) {
                            return new TargetTcpProxiesSetBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TargetTcpProxiesSetBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetTcpProxiesSetBackendServiceRequest} message TargetTcpProxiesSetBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetTcpProxiesSetBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.service != null && Object.hasOwnProperty.call(message, "service"))
                                writer.uint32(/* id 373540533, wireType 2 =*/2988324266).string(message.service);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetTcpProxiesSetBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetTcpProxiesSetBackendServiceRequest} message TargetTcpProxiesSetBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetTcpProxiesSetBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetTcpProxiesSetBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest} TargetTcpProxiesSetBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetTcpProxiesSetBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 373540533: {
                                        message.service = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetTcpProxiesSetBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest} TargetTcpProxiesSetBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetTcpProxiesSetBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetTcpProxiesSetBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetTcpProxiesSetBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.service != null && message.hasOwnProperty("service")) {
                                properties._service = 1;
                                if (!$util.isString(message.service))
                                    return "service: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetTcpProxiesSetBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest} TargetTcpProxiesSetBackendServiceRequest
                         */
                        TargetTcpProxiesSetBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest();
                            if (object.service != null)
                                message.service = String(object.service);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetTcpProxiesSetBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest} message TargetTcpProxiesSetBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetTcpProxiesSetBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.service != null && message.hasOwnProperty("service")) {
                                object.service = message.service;
                                if (options.oneofs)
                                    object._service = "service";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetTcpProxiesSetBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetTcpProxiesSetBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetTcpProxiesSetBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetTcpProxiesSetBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetTcpProxiesSetBackendServiceRequest";
                        };
    
                        return TargetTcpProxiesSetBackendServiceRequest;
                    })();
    
                    v1.TargetTcpProxiesSetProxyHeaderRequest = (function() {
    
                        /**
                         * Properties of a TargetTcpProxiesSetProxyHeaderRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetTcpProxiesSetProxyHeaderRequest
                         * @property {string|null} [proxyHeader] TargetTcpProxiesSetProxyHeaderRequest proxyHeader
                         */
    
                        /**
                         * Constructs a new TargetTcpProxiesSetProxyHeaderRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetTcpProxiesSetProxyHeaderRequest.
                         * @implements ITargetTcpProxiesSetProxyHeaderRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetTcpProxiesSetProxyHeaderRequest=} [properties] Properties to set
                         */
                        function TargetTcpProxiesSetProxyHeaderRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetTcpProxiesSetProxyHeaderRequest proxyHeader.
                         * @member {string|null|undefined} proxyHeader
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest
                         * @instance
                         */
                        TargetTcpProxiesSetProxyHeaderRequest.prototype.proxyHeader = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetTcpProxiesSetProxyHeaderRequest _proxyHeader.
                         * @member {"proxyHeader"|undefined} _proxyHeader
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest
                         * @instance
                         */
                        Object.defineProperty(TargetTcpProxiesSetProxyHeaderRequest.prototype, "_proxyHeader", {
                            get: $util.oneOfGetter($oneOfFields = ["proxyHeader"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetTcpProxiesSetProxyHeaderRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetTcpProxiesSetProxyHeaderRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest} TargetTcpProxiesSetProxyHeaderRequest instance
                         */
                        TargetTcpProxiesSetProxyHeaderRequest.create = function create(properties) {
                            return new TargetTcpProxiesSetProxyHeaderRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TargetTcpProxiesSetProxyHeaderRequest message. Does not implicitly {@link google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetTcpProxiesSetProxyHeaderRequest} message TargetTcpProxiesSetProxyHeaderRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetTcpProxiesSetProxyHeaderRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.proxyHeader != null && Object.hasOwnProperty.call(message, "proxyHeader"))
                                writer.uint32(/* id 160374142, wireType 2 =*/1282993138).string(message.proxyHeader);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetTcpProxiesSetProxyHeaderRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITargetTcpProxiesSetProxyHeaderRequest} message TargetTcpProxiesSetProxyHeaderRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetTcpProxiesSetProxyHeaderRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetTcpProxiesSetProxyHeaderRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest} TargetTcpProxiesSetProxyHeaderRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetTcpProxiesSetProxyHeaderRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 160374142: {
                                        message.proxyHeader = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetTcpProxiesSetProxyHeaderRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest} TargetTcpProxiesSetProxyHeaderRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetTcpProxiesSetProxyHeaderRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetTcpProxiesSetProxyHeaderRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetTcpProxiesSetProxyHeaderRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.proxyHeader != null && message.hasOwnProperty("proxyHeader")) {
                                properties._proxyHeader = 1;
                                if (!$util.isString(message.proxyHeader))
                                    return "proxyHeader: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetTcpProxiesSetProxyHeaderRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest} TargetTcpProxiesSetProxyHeaderRequest
                         */
                        TargetTcpProxiesSetProxyHeaderRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest();
                            if (object.proxyHeader != null)
                                message.proxyHeader = String(object.proxyHeader);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetTcpProxiesSetProxyHeaderRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest
                         * @static
                         * @param {google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest} message TargetTcpProxiesSetProxyHeaderRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetTcpProxiesSetProxyHeaderRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.proxyHeader != null && message.hasOwnProperty("proxyHeader")) {
                                object.proxyHeader = message.proxyHeader;
                                if (options.oneofs)
                                    object._proxyHeader = "proxyHeader";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetTcpProxiesSetProxyHeaderRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetTcpProxiesSetProxyHeaderRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetTcpProxiesSetProxyHeaderRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetTcpProxiesSetProxyHeaderRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest";
                        };
    
                        /**
                         * ProxyHeader enum.
                         * @name google.cloud.compute.v1.TargetTcpProxiesSetProxyHeaderRequest.ProxyHeader
                         * @enum {number}
                         * @property {number} UNDEFINED_PROXY_HEADER=0 UNDEFINED_PROXY_HEADER value
                         * @property {number} NONE=2402104 NONE value
                         * @property {number} PROXY_V1=334352940 PROXY_V1 value
                         */
                        TargetTcpProxiesSetProxyHeaderRequest.ProxyHeader = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PROXY_HEADER"] = 0;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            values[valuesById[334352940] = "PROXY_V1"] = 334352940;
                            return values;
                        })();
    
                        return TargetTcpProxiesSetProxyHeaderRequest;
                    })();
    
                    v1.TargetTcpProxy = (function() {
    
                        /**
                         * Properties of a TargetTcpProxy.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetTcpProxy
                         * @property {string|null} [creationTimestamp] TargetTcpProxy creationTimestamp
                         * @property {string|null} [description] TargetTcpProxy description
                         * @property {number|Long|null} [id] TargetTcpProxy id
                         * @property {string|null} [kind] TargetTcpProxy kind
                         * @property {string|null} [name] TargetTcpProxy name
                         * @property {boolean|null} [proxyBind] TargetTcpProxy proxyBind
                         * @property {string|null} [proxyHeader] TargetTcpProxy proxyHeader
                         * @property {string|null} [region] TargetTcpProxy region
                         * @property {string|null} [selfLink] TargetTcpProxy selfLink
                         * @property {string|null} [service] TargetTcpProxy service
                         */
    
                        /**
                         * Constructs a new TargetTcpProxy.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetTcpProxy.
                         * @implements ITargetTcpProxy
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetTcpProxy=} [properties] Properties to set
                         */
                        function TargetTcpProxy(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetTcpProxy creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         */
                        TargetTcpProxy.prototype.creationTimestamp = null;
    
                        /**
                         * TargetTcpProxy description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         */
                        TargetTcpProxy.prototype.description = null;
    
                        /**
                         * TargetTcpProxy id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         */
                        TargetTcpProxy.prototype.id = null;
    
                        /**
                         * TargetTcpProxy kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         */
                        TargetTcpProxy.prototype.kind = null;
    
                        /**
                         * TargetTcpProxy name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         */
                        TargetTcpProxy.prototype.name = null;
    
                        /**
                         * TargetTcpProxy proxyBind.
                         * @member {boolean|null|undefined} proxyBind
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         */
                        TargetTcpProxy.prototype.proxyBind = null;
    
                        /**
                         * TargetTcpProxy proxyHeader.
                         * @member {string|null|undefined} proxyHeader
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         */
                        TargetTcpProxy.prototype.proxyHeader = null;
    
                        /**
                         * TargetTcpProxy region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         */
                        TargetTcpProxy.prototype.region = null;
    
                        /**
                         * TargetTcpProxy selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         */
                        TargetTcpProxy.prototype.selfLink = null;
    
                        /**
                         * TargetTcpProxy service.
                         * @member {string|null|undefined} service
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         */
                        TargetTcpProxy.prototype.service = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetTcpProxy _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         */
                        Object.defineProperty(TargetTcpProxy.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetTcpProxy _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         */
                        Object.defineProperty(TargetTcpProxy.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetTcpProxy _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         */
                        Object.defineProperty(TargetTcpProxy.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetTcpProxy _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         */
                        Object.defineProperty(TargetTcpProxy.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetTcpProxy _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         */
                        Object.defineProperty(TargetTcpProxy.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetTcpProxy _proxyBind.
                         * @member {"proxyBind"|undefined} _proxyBind
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         */
                        Object.defineProperty(TargetTcpProxy.prototype, "_proxyBind", {
                            get: $util.oneOfGetter($oneOfFields = ["proxyBind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetTcpProxy _proxyHeader.
                         * @member {"proxyHeader"|undefined} _proxyHeader
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         */
                        Object.defineProperty(TargetTcpProxy.prototype, "_proxyHeader", {
                            get: $util.oneOfGetter($oneOfFields = ["proxyHeader"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetTcpProxy _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         */
                        Object.defineProperty(TargetTcpProxy.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetTcpProxy _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         */
                        Object.defineProperty(TargetTcpProxy.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetTcpProxy _service.
                         * @member {"service"|undefined} _service
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         */
                        Object.defineProperty(TargetTcpProxy.prototype, "_service", {
                            get: $util.oneOfGetter($oneOfFields = ["service"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetTcpProxy instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @static
                         * @param {google.cloud.compute.v1.ITargetTcpProxy=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetTcpProxy} TargetTcpProxy instance
                         */
                        TargetTcpProxy.create = function create(properties) {
                            return new TargetTcpProxy(properties);
                        };
    
                        /**
                         * Encodes the specified TargetTcpProxy message. Does not implicitly {@link google.cloud.compute.v1.TargetTcpProxy.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @static
                         * @param {google.cloud.compute.v1.ITargetTcpProxy} message TargetTcpProxy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetTcpProxy.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.proxyHeader != null && Object.hasOwnProperty.call(message, "proxyHeader"))
                                writer.uint32(/* id 160374142, wireType 2 =*/1282993138).string(message.proxyHeader);
                            if (message.proxyBind != null && Object.hasOwnProperty.call(message, "proxyBind"))
                                writer.uint32(/* id 286025582, wireType 0 =*/2288204656).bool(message.proxyBind);
                            if (message.service != null && Object.hasOwnProperty.call(message, "service"))
                                writer.uint32(/* id 373540533, wireType 2 =*/2988324266).string(message.service);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetTcpProxy message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetTcpProxy.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @static
                         * @param {google.cloud.compute.v1.ITargetTcpProxy} message TargetTcpProxy message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetTcpProxy.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetTcpProxy message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetTcpProxy} TargetTcpProxy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetTcpProxy.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetTcpProxy();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 286025582: {
                                        message.proxyBind = reader.bool();
                                        break;
                                    }
                                case 160374142: {
                                        message.proxyHeader = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 373540533: {
                                        message.service = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetTcpProxy message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetTcpProxy} TargetTcpProxy
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetTcpProxy.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetTcpProxy message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetTcpProxy.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.proxyBind != null && message.hasOwnProperty("proxyBind")) {
                                properties._proxyBind = 1;
                                if (typeof message.proxyBind !== "boolean")
                                    return "proxyBind: boolean expected";
                            }
                            if (message.proxyHeader != null && message.hasOwnProperty("proxyHeader")) {
                                properties._proxyHeader = 1;
                                if (!$util.isString(message.proxyHeader))
                                    return "proxyHeader: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.service != null && message.hasOwnProperty("service")) {
                                properties._service = 1;
                                if (!$util.isString(message.service))
                                    return "service: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetTcpProxy message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetTcpProxy} TargetTcpProxy
                         */
                        TargetTcpProxy.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetTcpProxy)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetTcpProxy();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.proxyBind != null)
                                message.proxyBind = Boolean(object.proxyBind);
                            if (object.proxyHeader != null)
                                message.proxyHeader = String(object.proxyHeader);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.service != null)
                                message.service = String(object.service);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetTcpProxy message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @static
                         * @param {google.cloud.compute.v1.TargetTcpProxy} message TargetTcpProxy
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetTcpProxy.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.proxyHeader != null && message.hasOwnProperty("proxyHeader")) {
                                object.proxyHeader = message.proxyHeader;
                                if (options.oneofs)
                                    object._proxyHeader = "proxyHeader";
                            }
                            if (message.proxyBind != null && message.hasOwnProperty("proxyBind")) {
                                object.proxyBind = message.proxyBind;
                                if (options.oneofs)
                                    object._proxyBind = "proxyBind";
                            }
                            if (message.service != null && message.hasOwnProperty("service")) {
                                object.service = message.service;
                                if (options.oneofs)
                                    object._service = "service";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetTcpProxy to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetTcpProxy.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetTcpProxy
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetTcpProxy
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetTcpProxy.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetTcpProxy";
                        };
    
                        /**
                         * ProxyHeader enum.
                         * @name google.cloud.compute.v1.TargetTcpProxy.ProxyHeader
                         * @enum {number}
                         * @property {number} UNDEFINED_PROXY_HEADER=0 UNDEFINED_PROXY_HEADER value
                         * @property {number} NONE=2402104 NONE value
                         * @property {number} PROXY_V1=334352940 PROXY_V1 value
                         */
                        TargetTcpProxy.ProxyHeader = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PROXY_HEADER"] = 0;
                            values[valuesById[2402104] = "NONE"] = 2402104;
                            values[valuesById[334352940] = "PROXY_V1"] = 334352940;
                            return values;
                        })();
    
                        return TargetTcpProxy;
                    })();
    
                    v1.TargetTcpProxyList = (function() {
    
                        /**
                         * Properties of a TargetTcpProxyList.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetTcpProxyList
                         * @property {string|null} [id] TargetTcpProxyList id
                         * @property {Array.<google.cloud.compute.v1.ITargetTcpProxy>|null} [items] TargetTcpProxyList items
                         * @property {string|null} [kind] TargetTcpProxyList kind
                         * @property {string|null} [nextPageToken] TargetTcpProxyList nextPageToken
                         * @property {string|null} [selfLink] TargetTcpProxyList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] TargetTcpProxyList warning
                         */
    
                        /**
                         * Constructs a new TargetTcpProxyList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetTcpProxyList.
                         * @implements ITargetTcpProxyList
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetTcpProxyList=} [properties] Properties to set
                         */
                        function TargetTcpProxyList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetTcpProxyList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @instance
                         */
                        TargetTcpProxyList.prototype.id = null;
    
                        /**
                         * TargetTcpProxyList items.
                         * @member {Array.<google.cloud.compute.v1.ITargetTcpProxy>} items
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @instance
                         */
                        TargetTcpProxyList.prototype.items = $util.emptyArray;
    
                        /**
                         * TargetTcpProxyList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @instance
                         */
                        TargetTcpProxyList.prototype.kind = null;
    
                        /**
                         * TargetTcpProxyList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @instance
                         */
                        TargetTcpProxyList.prototype.nextPageToken = null;
    
                        /**
                         * TargetTcpProxyList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @instance
                         */
                        TargetTcpProxyList.prototype.selfLink = null;
    
                        /**
                         * TargetTcpProxyList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @instance
                         */
                        TargetTcpProxyList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetTcpProxyList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetTcpProxyList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetTcpProxyList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetTcpProxyList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetTcpProxyList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetTcpProxyList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetTcpProxyList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetTcpProxyList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetTcpProxyList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @instance
                         */
                        Object.defineProperty(TargetTcpProxyList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetTcpProxyList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetTcpProxyList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetTcpProxyList} TargetTcpProxyList instance
                         */
                        TargetTcpProxyList.create = function create(properties) {
                            return new TargetTcpProxyList(properties);
                        };
    
                        /**
                         * Encodes the specified TargetTcpProxyList message. Does not implicitly {@link google.cloud.compute.v1.TargetTcpProxyList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetTcpProxyList} message TargetTcpProxyList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetTcpProxyList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.TargetTcpProxy.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetTcpProxyList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetTcpProxyList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetTcpProxyList} message TargetTcpProxyList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetTcpProxyList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetTcpProxyList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetTcpProxyList} TargetTcpProxyList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetTcpProxyList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetTcpProxyList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.TargetTcpProxy.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetTcpProxyList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetTcpProxyList} TargetTcpProxyList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetTcpProxyList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetTcpProxyList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetTcpProxyList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.TargetTcpProxy.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetTcpProxyList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetTcpProxyList} TargetTcpProxyList
                         */
                        TargetTcpProxyList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetTcpProxyList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetTcpProxyList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.TargetTcpProxyList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetTcpProxyList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.TargetTcpProxy.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetTcpProxyList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetTcpProxyList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @static
                         * @param {google.cloud.compute.v1.TargetTcpProxyList} message TargetTcpProxyList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetTcpProxyList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.TargetTcpProxy.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetTcpProxyList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetTcpProxyList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetTcpProxyList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetTcpProxyList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetTcpProxyList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetTcpProxyList";
                        };
    
                        return TargetTcpProxyList;
                    })();
    
                    v1.TargetVpnGateway = (function() {
    
                        /**
                         * Properties of a TargetVpnGateway.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetVpnGateway
                         * @property {string|null} [creationTimestamp] TargetVpnGateway creationTimestamp
                         * @property {string|null} [description] TargetVpnGateway description
                         * @property {Array.<string>|null} [forwardingRules] TargetVpnGateway forwardingRules
                         * @property {number|Long|null} [id] TargetVpnGateway id
                         * @property {string|null} [kind] TargetVpnGateway kind
                         * @property {string|null} [name] TargetVpnGateway name
                         * @property {string|null} [network] TargetVpnGateway network
                         * @property {string|null} [region] TargetVpnGateway region
                         * @property {string|null} [selfLink] TargetVpnGateway selfLink
                         * @property {string|null} [status] TargetVpnGateway status
                         * @property {Array.<string>|null} [tunnels] TargetVpnGateway tunnels
                         */
    
                        /**
                         * Constructs a new TargetVpnGateway.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetVpnGateway.
                         * @implements ITargetVpnGateway
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetVpnGateway=} [properties] Properties to set
                         */
                        function TargetVpnGateway(properties) {
                            this.forwardingRules = [];
                            this.tunnels = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetVpnGateway creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         */
                        TargetVpnGateway.prototype.creationTimestamp = null;
    
                        /**
                         * TargetVpnGateway description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         */
                        TargetVpnGateway.prototype.description = null;
    
                        /**
                         * TargetVpnGateway forwardingRules.
                         * @member {Array.<string>} forwardingRules
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         */
                        TargetVpnGateway.prototype.forwardingRules = $util.emptyArray;
    
                        /**
                         * TargetVpnGateway id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         */
                        TargetVpnGateway.prototype.id = null;
    
                        /**
                         * TargetVpnGateway kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         */
                        TargetVpnGateway.prototype.kind = null;
    
                        /**
                         * TargetVpnGateway name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         */
                        TargetVpnGateway.prototype.name = null;
    
                        /**
                         * TargetVpnGateway network.
                         * @member {string|null|undefined} network
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         */
                        TargetVpnGateway.prototype.network = null;
    
                        /**
                         * TargetVpnGateway region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         */
                        TargetVpnGateway.prototype.region = null;
    
                        /**
                         * TargetVpnGateway selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         */
                        TargetVpnGateway.prototype.selfLink = null;
    
                        /**
                         * TargetVpnGateway status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         */
                        TargetVpnGateway.prototype.status = null;
    
                        /**
                         * TargetVpnGateway tunnels.
                         * @member {Array.<string>} tunnels
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         */
                        TargetVpnGateway.prototype.tunnels = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetVpnGateway _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         */
                        Object.defineProperty(TargetVpnGateway.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetVpnGateway _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         */
                        Object.defineProperty(TargetVpnGateway.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetVpnGateway _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         */
                        Object.defineProperty(TargetVpnGateway.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetVpnGateway _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         */
                        Object.defineProperty(TargetVpnGateway.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetVpnGateway _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         */
                        Object.defineProperty(TargetVpnGateway.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetVpnGateway _network.
                         * @member {"network"|undefined} _network
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         */
                        Object.defineProperty(TargetVpnGateway.prototype, "_network", {
                            get: $util.oneOfGetter($oneOfFields = ["network"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetVpnGateway _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         */
                        Object.defineProperty(TargetVpnGateway.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetVpnGateway _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         */
                        Object.defineProperty(TargetVpnGateway.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetVpnGateway _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         */
                        Object.defineProperty(TargetVpnGateway.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetVpnGateway instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @static
                         * @param {google.cloud.compute.v1.ITargetVpnGateway=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetVpnGateway} TargetVpnGateway instance
                         */
                        TargetVpnGateway.create = function create(properties) {
                            return new TargetVpnGateway(properties);
                        };
    
                        /**
                         * Encodes the specified TargetVpnGateway message. Does not implicitly {@link google.cloud.compute.v1.TargetVpnGateway.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @static
                         * @param {google.cloud.compute.v1.ITargetVpnGateway} message TargetVpnGateway message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetVpnGateway.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.tunnels != null && message.tunnels.length)
                                for (var i = 0; i < message.tunnels.length; ++i)
                                    writer.uint32(/* id 104561931, wireType 2 =*/836495450).string(message.tunnels[i]);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            if (message.forwardingRules != null && message.forwardingRules.length)
                                for (var i = 0; i < message.forwardingRules.length; ++i)
                                    writer.uint32(/* id 315821365, wireType 2 =*/2526570922).string(message.forwardingRules[i]);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetVpnGateway message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetVpnGateway.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @static
                         * @param {google.cloud.compute.v1.ITargetVpnGateway} message TargetVpnGateway message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetVpnGateway.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetVpnGateway message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetVpnGateway} TargetVpnGateway
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetVpnGateway.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetVpnGateway();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 315821365: {
                                        if (!(message.forwardingRules && message.forwardingRules.length))
                                            message.forwardingRules = [];
                                        message.forwardingRules.push(reader.string());
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                case 104561931: {
                                        if (!(message.tunnels && message.tunnels.length))
                                            message.tunnels = [];
                                        message.tunnels.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetVpnGateway message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetVpnGateway} TargetVpnGateway
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetVpnGateway.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetVpnGateway message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetVpnGateway.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.forwardingRules != null && message.hasOwnProperty("forwardingRules")) {
                                if (!Array.isArray(message.forwardingRules))
                                    return "forwardingRules: array expected";
                                for (var i = 0; i < message.forwardingRules.length; ++i)
                                    if (!$util.isString(message.forwardingRules[i]))
                                        return "forwardingRules: string[] expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                properties._network = 1;
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            if (message.tunnels != null && message.hasOwnProperty("tunnels")) {
                                if (!Array.isArray(message.tunnels))
                                    return "tunnels: array expected";
                                for (var i = 0; i < message.tunnels.length; ++i)
                                    if (!$util.isString(message.tunnels[i]))
                                        return "tunnels: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetVpnGateway message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetVpnGateway} TargetVpnGateway
                         */
                        TargetVpnGateway.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetVpnGateway)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetVpnGateway();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.forwardingRules) {
                                if (!Array.isArray(object.forwardingRules))
                                    throw TypeError(".google.cloud.compute.v1.TargetVpnGateway.forwardingRules: array expected");
                                message.forwardingRules = [];
                                for (var i = 0; i < object.forwardingRules.length; ++i)
                                    message.forwardingRules[i] = String(object.forwardingRules[i]);
                            }
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.status != null)
                                message.status = String(object.status);
                            if (object.tunnels) {
                                if (!Array.isArray(object.tunnels))
                                    throw TypeError(".google.cloud.compute.v1.TargetVpnGateway.tunnels: array expected");
                                message.tunnels = [];
                                for (var i = 0; i < object.tunnels.length; ++i)
                                    message.tunnels[i] = String(object.tunnels[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetVpnGateway message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @static
                         * @param {google.cloud.compute.v1.TargetVpnGateway} message TargetVpnGateway
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetVpnGateway.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.tunnels = [];
                                object.forwardingRules = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.tunnels && message.tunnels.length) {
                                object.tunnels = [];
                                for (var j = 0; j < message.tunnels.length; ++j)
                                    object.tunnels[j] = message.tunnels[j];
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                object.network = message.network;
                                if (options.oneofs)
                                    object._network = "network";
                            }
                            if (message.forwardingRules && message.forwardingRules.length) {
                                object.forwardingRules = [];
                                for (var j = 0; j < message.forwardingRules.length; ++j)
                                    object.forwardingRules[j] = message.forwardingRules[j];
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetVpnGateway to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetVpnGateway.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetVpnGateway
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetVpnGateway
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetVpnGateway.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetVpnGateway";
                        };
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.TargetVpnGateway.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} CREATING=455564985 CREATING value
                         * @property {number} DELETING=528602024 DELETING value
                         * @property {number} FAILED=455706685 FAILED value
                         * @property {number} READY=77848963 READY value
                         */
                        TargetVpnGateway.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[455564985] = "CREATING"] = 455564985;
                            values[valuesById[528602024] = "DELETING"] = 528602024;
                            values[valuesById[455706685] = "FAILED"] = 455706685;
                            values[valuesById[77848963] = "READY"] = 77848963;
                            return values;
                        })();
    
                        return TargetVpnGateway;
                    })();
    
                    v1.TargetVpnGatewayAggregatedList = (function() {
    
                        /**
                         * Properties of a TargetVpnGatewayAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetVpnGatewayAggregatedList
                         * @property {string|null} [id] TargetVpnGatewayAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.ITargetVpnGatewaysScopedList>|null} [items] TargetVpnGatewayAggregatedList items
                         * @property {string|null} [kind] TargetVpnGatewayAggregatedList kind
                         * @property {string|null} [nextPageToken] TargetVpnGatewayAggregatedList nextPageToken
                         * @property {string|null} [selfLink] TargetVpnGatewayAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] TargetVpnGatewayAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] TargetVpnGatewayAggregatedList warning
                         */
    
                        /**
                         * Constructs a new TargetVpnGatewayAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetVpnGatewayAggregatedList.
                         * @implements ITargetVpnGatewayAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetVpnGatewayAggregatedList=} [properties] Properties to set
                         */
                        function TargetVpnGatewayAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetVpnGatewayAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @instance
                         */
                        TargetVpnGatewayAggregatedList.prototype.id = null;
    
                        /**
                         * TargetVpnGatewayAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.ITargetVpnGatewaysScopedList>} items
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @instance
                         */
                        TargetVpnGatewayAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * TargetVpnGatewayAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @instance
                         */
                        TargetVpnGatewayAggregatedList.prototype.kind = null;
    
                        /**
                         * TargetVpnGatewayAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @instance
                         */
                        TargetVpnGatewayAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * TargetVpnGatewayAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @instance
                         */
                        TargetVpnGatewayAggregatedList.prototype.selfLink = null;
    
                        /**
                         * TargetVpnGatewayAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @instance
                         */
                        TargetVpnGatewayAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * TargetVpnGatewayAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @instance
                         */
                        TargetVpnGatewayAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetVpnGatewayAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetVpnGatewayAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetVpnGatewayAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetVpnGatewayAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetVpnGatewayAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetVpnGatewayAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetVpnGatewayAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetVpnGatewayAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetVpnGatewayAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @instance
                         */
                        Object.defineProperty(TargetVpnGatewayAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetVpnGatewayAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetVpnGatewayAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetVpnGatewayAggregatedList} TargetVpnGatewayAggregatedList instance
                         */
                        TargetVpnGatewayAggregatedList.create = function create(properties) {
                            return new TargetVpnGatewayAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified TargetVpnGatewayAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.TargetVpnGatewayAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetVpnGatewayAggregatedList} message TargetVpnGatewayAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetVpnGatewayAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.TargetVpnGatewaysScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetVpnGatewayAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetVpnGatewayAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetVpnGatewayAggregatedList} message TargetVpnGatewayAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetVpnGatewayAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetVpnGatewayAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetVpnGatewayAggregatedList} TargetVpnGatewayAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetVpnGatewayAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetVpnGatewayAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.TargetVpnGatewaysScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetVpnGatewayAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetVpnGatewayAggregatedList} TargetVpnGatewayAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetVpnGatewayAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetVpnGatewayAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetVpnGatewayAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.TargetVpnGatewaysScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetVpnGatewayAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetVpnGatewayAggregatedList} TargetVpnGatewayAggregatedList
                         */
                        TargetVpnGatewayAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetVpnGatewayAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetVpnGatewayAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetVpnGatewayAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetVpnGatewayAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.TargetVpnGatewaysScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.TargetVpnGatewayAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetVpnGatewayAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetVpnGatewayAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.TargetVpnGatewayAggregatedList} message TargetVpnGatewayAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetVpnGatewayAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.TargetVpnGatewaysScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetVpnGatewayAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetVpnGatewayAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetVpnGatewayAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetVpnGatewayAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetVpnGatewayAggregatedList";
                        };
    
                        return TargetVpnGatewayAggregatedList;
                    })();
    
                    v1.TargetVpnGatewayList = (function() {
    
                        /**
                         * Properties of a TargetVpnGatewayList.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetVpnGatewayList
                         * @property {string|null} [id] TargetVpnGatewayList id
                         * @property {Array.<google.cloud.compute.v1.ITargetVpnGateway>|null} [items] TargetVpnGatewayList items
                         * @property {string|null} [kind] TargetVpnGatewayList kind
                         * @property {string|null} [nextPageToken] TargetVpnGatewayList nextPageToken
                         * @property {string|null} [selfLink] TargetVpnGatewayList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] TargetVpnGatewayList warning
                         */
    
                        /**
                         * Constructs a new TargetVpnGatewayList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetVpnGatewayList.
                         * @implements ITargetVpnGatewayList
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetVpnGatewayList=} [properties] Properties to set
                         */
                        function TargetVpnGatewayList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetVpnGatewayList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @instance
                         */
                        TargetVpnGatewayList.prototype.id = null;
    
                        /**
                         * TargetVpnGatewayList items.
                         * @member {Array.<google.cloud.compute.v1.ITargetVpnGateway>} items
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @instance
                         */
                        TargetVpnGatewayList.prototype.items = $util.emptyArray;
    
                        /**
                         * TargetVpnGatewayList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @instance
                         */
                        TargetVpnGatewayList.prototype.kind = null;
    
                        /**
                         * TargetVpnGatewayList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @instance
                         */
                        TargetVpnGatewayList.prototype.nextPageToken = null;
    
                        /**
                         * TargetVpnGatewayList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @instance
                         */
                        TargetVpnGatewayList.prototype.selfLink = null;
    
                        /**
                         * TargetVpnGatewayList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @instance
                         */
                        TargetVpnGatewayList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetVpnGatewayList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @instance
                         */
                        Object.defineProperty(TargetVpnGatewayList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetVpnGatewayList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @instance
                         */
                        Object.defineProperty(TargetVpnGatewayList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetVpnGatewayList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @instance
                         */
                        Object.defineProperty(TargetVpnGatewayList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetVpnGatewayList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @instance
                         */
                        Object.defineProperty(TargetVpnGatewayList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TargetVpnGatewayList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @instance
                         */
                        Object.defineProperty(TargetVpnGatewayList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetVpnGatewayList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetVpnGatewayList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetVpnGatewayList} TargetVpnGatewayList instance
                         */
                        TargetVpnGatewayList.create = function create(properties) {
                            return new TargetVpnGatewayList(properties);
                        };
    
                        /**
                         * Encodes the specified TargetVpnGatewayList message. Does not implicitly {@link google.cloud.compute.v1.TargetVpnGatewayList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetVpnGatewayList} message TargetVpnGatewayList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetVpnGatewayList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.TargetVpnGateway.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetVpnGatewayList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetVpnGatewayList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetVpnGatewayList} message TargetVpnGatewayList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetVpnGatewayList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetVpnGatewayList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetVpnGatewayList} TargetVpnGatewayList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetVpnGatewayList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetVpnGatewayList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.TargetVpnGateway.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetVpnGatewayList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetVpnGatewayList} TargetVpnGatewayList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetVpnGatewayList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetVpnGatewayList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetVpnGatewayList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.TargetVpnGateway.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetVpnGatewayList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetVpnGatewayList} TargetVpnGatewayList
                         */
                        TargetVpnGatewayList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetVpnGatewayList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetVpnGatewayList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.TargetVpnGatewayList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetVpnGatewayList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.TargetVpnGateway.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetVpnGatewayList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetVpnGatewayList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @static
                         * @param {google.cloud.compute.v1.TargetVpnGatewayList} message TargetVpnGatewayList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetVpnGatewayList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.TargetVpnGateway.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetVpnGatewayList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetVpnGatewayList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetVpnGatewayList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetVpnGatewayList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetVpnGatewayList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetVpnGatewayList";
                        };
    
                        return TargetVpnGatewayList;
                    })();
    
                    v1.TargetVpnGatewaysScopedList = (function() {
    
                        /**
                         * Properties of a TargetVpnGatewaysScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface ITargetVpnGatewaysScopedList
                         * @property {Array.<google.cloud.compute.v1.ITargetVpnGateway>|null} [targetVpnGateways] TargetVpnGatewaysScopedList targetVpnGateways
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] TargetVpnGatewaysScopedList warning
                         */
    
                        /**
                         * Constructs a new TargetVpnGatewaysScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetVpnGatewaysScopedList.
                         * @implements ITargetVpnGatewaysScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.ITargetVpnGatewaysScopedList=} [properties] Properties to set
                         */
                        function TargetVpnGatewaysScopedList(properties) {
                            this.targetVpnGateways = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TargetVpnGatewaysScopedList targetVpnGateways.
                         * @member {Array.<google.cloud.compute.v1.ITargetVpnGateway>} targetVpnGateways
                         * @memberof google.cloud.compute.v1.TargetVpnGatewaysScopedList
                         * @instance
                         */
                        TargetVpnGatewaysScopedList.prototype.targetVpnGateways = $util.emptyArray;
    
                        /**
                         * TargetVpnGatewaysScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.TargetVpnGatewaysScopedList
                         * @instance
                         */
                        TargetVpnGatewaysScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TargetVpnGatewaysScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.TargetVpnGatewaysScopedList
                         * @instance
                         */
                        Object.defineProperty(TargetVpnGatewaysScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TargetVpnGatewaysScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetVpnGatewaysScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetVpnGatewaysScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TargetVpnGatewaysScopedList} TargetVpnGatewaysScopedList instance
                         */
                        TargetVpnGatewaysScopedList.create = function create(properties) {
                            return new TargetVpnGatewaysScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified TargetVpnGatewaysScopedList message. Does not implicitly {@link google.cloud.compute.v1.TargetVpnGatewaysScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TargetVpnGatewaysScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetVpnGatewaysScopedList} message TargetVpnGatewaysScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetVpnGatewaysScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.targetVpnGateways != null && message.targetVpnGateways.length)
                                for (var i = 0; i < message.targetVpnGateways.length; ++i)
                                    $root.google.cloud.compute.v1.TargetVpnGateway.encode(message.targetVpnGateways[i], writer.uint32(/* id 401770888, wireType 2 =*/3214167106).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TargetVpnGatewaysScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TargetVpnGatewaysScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TargetVpnGatewaysScopedList
                         * @static
                         * @param {google.cloud.compute.v1.ITargetVpnGatewaysScopedList} message TargetVpnGatewaysScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TargetVpnGatewaysScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TargetVpnGatewaysScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TargetVpnGatewaysScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TargetVpnGatewaysScopedList} TargetVpnGatewaysScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetVpnGatewaysScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TargetVpnGatewaysScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 401770888: {
                                        if (!(message.targetVpnGateways && message.targetVpnGateways.length))
                                            message.targetVpnGateways = [];
                                        message.targetVpnGateways.push($root.google.cloud.compute.v1.TargetVpnGateway.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TargetVpnGatewaysScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TargetVpnGatewaysScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TargetVpnGatewaysScopedList} TargetVpnGatewaysScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TargetVpnGatewaysScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TargetVpnGatewaysScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TargetVpnGatewaysScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TargetVpnGatewaysScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.targetVpnGateways != null && message.hasOwnProperty("targetVpnGateways")) {
                                if (!Array.isArray(message.targetVpnGateways))
                                    return "targetVpnGateways: array expected";
                                for (var i = 0; i < message.targetVpnGateways.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.TargetVpnGateway.verify(message.targetVpnGateways[i]);
                                    if (error)
                                        return "targetVpnGateways." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TargetVpnGatewaysScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TargetVpnGatewaysScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TargetVpnGatewaysScopedList} TargetVpnGatewaysScopedList
                         */
                        TargetVpnGatewaysScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TargetVpnGatewaysScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TargetVpnGatewaysScopedList();
                            if (object.targetVpnGateways) {
                                if (!Array.isArray(object.targetVpnGateways))
                                    throw TypeError(".google.cloud.compute.v1.TargetVpnGatewaysScopedList.targetVpnGateways: array expected");
                                message.targetVpnGateways = [];
                                for (var i = 0; i < object.targetVpnGateways.length; ++i) {
                                    if (typeof object.targetVpnGateways[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TargetVpnGatewaysScopedList.targetVpnGateways: object expected");
                                    message.targetVpnGateways[i] = $root.google.cloud.compute.v1.TargetVpnGateway.fromObject(object.targetVpnGateways[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TargetVpnGatewaysScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TargetVpnGatewaysScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TargetVpnGatewaysScopedList
                         * @static
                         * @param {google.cloud.compute.v1.TargetVpnGatewaysScopedList} message TargetVpnGatewaysScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TargetVpnGatewaysScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.targetVpnGateways = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.targetVpnGateways && message.targetVpnGateways.length) {
                                object.targetVpnGateways = [];
                                for (var j = 0; j < message.targetVpnGateways.length; ++j)
                                    object.targetVpnGateways[j] = $root.google.cloud.compute.v1.TargetVpnGateway.toObject(message.targetVpnGateways[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TargetVpnGatewaysScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TargetVpnGatewaysScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TargetVpnGatewaysScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TargetVpnGatewaysScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TargetVpnGatewaysScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TargetVpnGatewaysScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TargetVpnGatewaysScopedList";
                        };
    
                        return TargetVpnGatewaysScopedList;
                    })();
    
                    v1.TestFailure = (function() {
    
                        /**
                         * Properties of a TestFailure.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestFailure
                         * @property {string|null} [actualOutputUrl] TestFailure actualOutputUrl
                         * @property {number|null} [actualRedirectResponseCode] TestFailure actualRedirectResponseCode
                         * @property {string|null} [actualService] TestFailure actualService
                         * @property {string|null} [expectedOutputUrl] TestFailure expectedOutputUrl
                         * @property {number|null} [expectedRedirectResponseCode] TestFailure expectedRedirectResponseCode
                         * @property {string|null} [expectedService] TestFailure expectedService
                         * @property {Array.<google.cloud.compute.v1.IUrlMapTestHeader>|null} [headers] TestFailure headers
                         * @property {string|null} [host] TestFailure host
                         * @property {string|null} [path] TestFailure path
                         */
    
                        /**
                         * Constructs a new TestFailure.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestFailure.
                         * @implements ITestFailure
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestFailure=} [properties] Properties to set
                         */
                        function TestFailure(properties) {
                            this.headers = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestFailure actualOutputUrl.
                         * @member {string|null|undefined} actualOutputUrl
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @instance
                         */
                        TestFailure.prototype.actualOutputUrl = null;
    
                        /**
                         * TestFailure actualRedirectResponseCode.
                         * @member {number|null|undefined} actualRedirectResponseCode
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @instance
                         */
                        TestFailure.prototype.actualRedirectResponseCode = null;
    
                        /**
                         * TestFailure actualService.
                         * @member {string|null|undefined} actualService
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @instance
                         */
                        TestFailure.prototype.actualService = null;
    
                        /**
                         * TestFailure expectedOutputUrl.
                         * @member {string|null|undefined} expectedOutputUrl
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @instance
                         */
                        TestFailure.prototype.expectedOutputUrl = null;
    
                        /**
                         * TestFailure expectedRedirectResponseCode.
                         * @member {number|null|undefined} expectedRedirectResponseCode
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @instance
                         */
                        TestFailure.prototype.expectedRedirectResponseCode = null;
    
                        /**
                         * TestFailure expectedService.
                         * @member {string|null|undefined} expectedService
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @instance
                         */
                        TestFailure.prototype.expectedService = null;
    
                        /**
                         * TestFailure headers.
                         * @member {Array.<google.cloud.compute.v1.IUrlMapTestHeader>} headers
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @instance
                         */
                        TestFailure.prototype.headers = $util.emptyArray;
    
                        /**
                         * TestFailure host.
                         * @member {string|null|undefined} host
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @instance
                         */
                        TestFailure.prototype.host = null;
    
                        /**
                         * TestFailure path.
                         * @member {string|null|undefined} path
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @instance
                         */
                        TestFailure.prototype.path = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * TestFailure _actualOutputUrl.
                         * @member {"actualOutputUrl"|undefined} _actualOutputUrl
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @instance
                         */
                        Object.defineProperty(TestFailure.prototype, "_actualOutputUrl", {
                            get: $util.oneOfGetter($oneOfFields = ["actualOutputUrl"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TestFailure _actualRedirectResponseCode.
                         * @member {"actualRedirectResponseCode"|undefined} _actualRedirectResponseCode
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @instance
                         */
                        Object.defineProperty(TestFailure.prototype, "_actualRedirectResponseCode", {
                            get: $util.oneOfGetter($oneOfFields = ["actualRedirectResponseCode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TestFailure _actualService.
                         * @member {"actualService"|undefined} _actualService
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @instance
                         */
                        Object.defineProperty(TestFailure.prototype, "_actualService", {
                            get: $util.oneOfGetter($oneOfFields = ["actualService"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TestFailure _expectedOutputUrl.
                         * @member {"expectedOutputUrl"|undefined} _expectedOutputUrl
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @instance
                         */
                        Object.defineProperty(TestFailure.prototype, "_expectedOutputUrl", {
                            get: $util.oneOfGetter($oneOfFields = ["expectedOutputUrl"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TestFailure _expectedRedirectResponseCode.
                         * @member {"expectedRedirectResponseCode"|undefined} _expectedRedirectResponseCode
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @instance
                         */
                        Object.defineProperty(TestFailure.prototype, "_expectedRedirectResponseCode", {
                            get: $util.oneOfGetter($oneOfFields = ["expectedRedirectResponseCode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TestFailure _expectedService.
                         * @member {"expectedService"|undefined} _expectedService
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @instance
                         */
                        Object.defineProperty(TestFailure.prototype, "_expectedService", {
                            get: $util.oneOfGetter($oneOfFields = ["expectedService"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TestFailure _host.
                         * @member {"host"|undefined} _host
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @instance
                         */
                        Object.defineProperty(TestFailure.prototype, "_host", {
                            get: $util.oneOfGetter($oneOfFields = ["host"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * TestFailure _path.
                         * @member {"path"|undefined} _path
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @instance
                         */
                        Object.defineProperty(TestFailure.prototype, "_path", {
                            get: $util.oneOfGetter($oneOfFields = ["path"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new TestFailure instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @static
                         * @param {google.cloud.compute.v1.ITestFailure=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestFailure} TestFailure instance
                         */
                        TestFailure.create = function create(properties) {
                            return new TestFailure(properties);
                        };
    
                        /**
                         * Encodes the specified TestFailure message. Does not implicitly {@link google.cloud.compute.v1.TestFailure.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @static
                         * @param {google.cloud.compute.v1.ITestFailure} message TestFailure message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestFailure.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.host != null && Object.hasOwnProperty.call(message, "host"))
                                writer.uint32(/* id 3208616, wireType 2 =*/25668930).string(message.host);
                            if (message.path != null && Object.hasOwnProperty.call(message, "path"))
                                writer.uint32(/* id 3433509, wireType 2 =*/27468074).string(message.path);
                            if (message.expectedRedirectResponseCode != null && Object.hasOwnProperty.call(message, "expectedRedirectResponseCode"))
                                writer.uint32(/* id 18888047, wireType 0 =*/151104376).int32(message.expectedRedirectResponseCode);
                            if (message.actualRedirectResponseCode != null && Object.hasOwnProperty.call(message, "actualRedirectResponseCode"))
                                writer.uint32(/* id 42926553, wireType 0 =*/343412424).int32(message.actualRedirectResponseCode);
                            if (message.expectedService != null && Object.hasOwnProperty.call(message, "expectedService"))
                                writer.uint32(/* id 133987374, wireType 2 =*/1071898994).string(message.expectedService);
                            if (message.headers != null && message.headers.length)
                                for (var i = 0; i < message.headers.length; ++i)
                                    $root.google.cloud.compute.v1.UrlMapTestHeader.encode(message.headers[i], writer.uint32(/* id 258436998, wireType 2 =*/2067495986).fork()).ldelim();
                            if (message.actualOutputUrl != null && Object.hasOwnProperty.call(message, "actualOutputUrl"))
                                writer.uint32(/* id 287075458, wireType 2 =*/2296603666).string(message.actualOutputUrl);
                            if (message.expectedOutputUrl != null && Object.hasOwnProperty.call(message, "expectedOutputUrl"))
                                writer.uint32(/* id 433967384, wireType 2 =*/3471739074).string(message.expectedOutputUrl);
                            if (message.actualService != null && Object.hasOwnProperty.call(message, "actualService"))
                                writer.uint32(/* id 440379652, wireType 2 =*/3523037218).string(message.actualService);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestFailure message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestFailure.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @static
                         * @param {google.cloud.compute.v1.ITestFailure} message TestFailure message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestFailure.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestFailure message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestFailure} TestFailure
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestFailure.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestFailure();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 287075458: {
                                        message.actualOutputUrl = reader.string();
                                        break;
                                    }
                                case 42926553: {
                                        message.actualRedirectResponseCode = reader.int32();
                                        break;
                                    }
                                case 440379652: {
                                        message.actualService = reader.string();
                                        break;
                                    }
                                case 433967384: {
                                        message.expectedOutputUrl = reader.string();
                                        break;
                                    }
                                case 18888047: {
                                        message.expectedRedirectResponseCode = reader.int32();
                                        break;
                                    }
                                case 133987374: {
                                        message.expectedService = reader.string();
                                        break;
                                    }
                                case 258436998: {
                                        if (!(message.headers && message.headers.length))
                                            message.headers = [];
                                        message.headers.push($root.google.cloud.compute.v1.UrlMapTestHeader.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3208616: {
                                        message.host = reader.string();
                                        break;
                                    }
                                case 3433509: {
                                        message.path = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestFailure message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestFailure} TestFailure
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestFailure.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestFailure message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestFailure.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.actualOutputUrl != null && message.hasOwnProperty("actualOutputUrl")) {
                                properties._actualOutputUrl = 1;
                                if (!$util.isString(message.actualOutputUrl))
                                    return "actualOutputUrl: string expected";
                            }
                            if (message.actualRedirectResponseCode != null && message.hasOwnProperty("actualRedirectResponseCode")) {
                                properties._actualRedirectResponseCode = 1;
                                if (!$util.isInteger(message.actualRedirectResponseCode))
                                    return "actualRedirectResponseCode: integer expected";
                            }
                            if (message.actualService != null && message.hasOwnProperty("actualService")) {
                                properties._actualService = 1;
                                if (!$util.isString(message.actualService))
                                    return "actualService: string expected";
                            }
                            if (message.expectedOutputUrl != null && message.hasOwnProperty("expectedOutputUrl")) {
                                properties._expectedOutputUrl = 1;
                                if (!$util.isString(message.expectedOutputUrl))
                                    return "expectedOutputUrl: string expected";
                            }
                            if (message.expectedRedirectResponseCode != null && message.hasOwnProperty("expectedRedirectResponseCode")) {
                                properties._expectedRedirectResponseCode = 1;
                                if (!$util.isInteger(message.expectedRedirectResponseCode))
                                    return "expectedRedirectResponseCode: integer expected";
                            }
                            if (message.expectedService != null && message.hasOwnProperty("expectedService")) {
                                properties._expectedService = 1;
                                if (!$util.isString(message.expectedService))
                                    return "expectedService: string expected";
                            }
                            if (message.headers != null && message.hasOwnProperty("headers")) {
                                if (!Array.isArray(message.headers))
                                    return "headers: array expected";
                                for (var i = 0; i < message.headers.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.UrlMapTestHeader.verify(message.headers[i]);
                                    if (error)
                                        return "headers." + error;
                                }
                            }
                            if (message.host != null && message.hasOwnProperty("host")) {
                                properties._host = 1;
                                if (!$util.isString(message.host))
                                    return "host: string expected";
                            }
                            if (message.path != null && message.hasOwnProperty("path")) {
                                properties._path = 1;
                                if (!$util.isString(message.path))
                                    return "path: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TestFailure message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestFailure} TestFailure
                         */
                        TestFailure.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestFailure)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestFailure();
                            if (object.actualOutputUrl != null)
                                message.actualOutputUrl = String(object.actualOutputUrl);
                            if (object.actualRedirectResponseCode != null)
                                message.actualRedirectResponseCode = object.actualRedirectResponseCode | 0;
                            if (object.actualService != null)
                                message.actualService = String(object.actualService);
                            if (object.expectedOutputUrl != null)
                                message.expectedOutputUrl = String(object.expectedOutputUrl);
                            if (object.expectedRedirectResponseCode != null)
                                message.expectedRedirectResponseCode = object.expectedRedirectResponseCode | 0;
                            if (object.expectedService != null)
                                message.expectedService = String(object.expectedService);
                            if (object.headers) {
                                if (!Array.isArray(object.headers))
                                    throw TypeError(".google.cloud.compute.v1.TestFailure.headers: array expected");
                                message.headers = [];
                                for (var i = 0; i < object.headers.length; ++i) {
                                    if (typeof object.headers[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.TestFailure.headers: object expected");
                                    message.headers[i] = $root.google.cloud.compute.v1.UrlMapTestHeader.fromObject(object.headers[i]);
                                }
                            }
                            if (object.host != null)
                                message.host = String(object.host);
                            if (object.path != null)
                                message.path = String(object.path);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestFailure message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @static
                         * @param {google.cloud.compute.v1.TestFailure} message TestFailure
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestFailure.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.headers = [];
                            if (message.host != null && message.hasOwnProperty("host")) {
                                object.host = message.host;
                                if (options.oneofs)
                                    object._host = "host";
                            }
                            if (message.path != null && message.hasOwnProperty("path")) {
                                object.path = message.path;
                                if (options.oneofs)
                                    object._path = "path";
                            }
                            if (message.expectedRedirectResponseCode != null && message.hasOwnProperty("expectedRedirectResponseCode")) {
                                object.expectedRedirectResponseCode = message.expectedRedirectResponseCode;
                                if (options.oneofs)
                                    object._expectedRedirectResponseCode = "expectedRedirectResponseCode";
                            }
                            if (message.actualRedirectResponseCode != null && message.hasOwnProperty("actualRedirectResponseCode")) {
                                object.actualRedirectResponseCode = message.actualRedirectResponseCode;
                                if (options.oneofs)
                                    object._actualRedirectResponseCode = "actualRedirectResponseCode";
                            }
                            if (message.expectedService != null && message.hasOwnProperty("expectedService")) {
                                object.expectedService = message.expectedService;
                                if (options.oneofs)
                                    object._expectedService = "expectedService";
                            }
                            if (message.headers && message.headers.length) {
                                object.headers = [];
                                for (var j = 0; j < message.headers.length; ++j)
                                    object.headers[j] = $root.google.cloud.compute.v1.UrlMapTestHeader.toObject(message.headers[j], options);
                            }
                            if (message.actualOutputUrl != null && message.hasOwnProperty("actualOutputUrl")) {
                                object.actualOutputUrl = message.actualOutputUrl;
                                if (options.oneofs)
                                    object._actualOutputUrl = "actualOutputUrl";
                            }
                            if (message.expectedOutputUrl != null && message.hasOwnProperty("expectedOutputUrl")) {
                                object.expectedOutputUrl = message.expectedOutputUrl;
                                if (options.oneofs)
                                    object._expectedOutputUrl = "expectedOutputUrl";
                            }
                            if (message.actualService != null && message.hasOwnProperty("actualService")) {
                                object.actualService = message.actualService;
                                if (options.oneofs)
                                    object._actualService = "actualService";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TestFailure to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestFailure.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestFailure
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestFailure
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestFailure.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestFailure";
                        };
    
                        return TestFailure;
                    })();
    
                    v1.TestIamPermissionsDiskRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsDiskRequest
                         * @property {string|null} [project] TestIamPermissionsDiskRequest project
                         * @property {string|null} [resource] TestIamPermissionsDiskRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsDiskRequest testPermissionsRequestResource
                         * @property {string|null} [zone] TestIamPermissionsDiskRequest zone
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsDiskRequest.
                         * @implements ITestIamPermissionsDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsDiskRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsDiskRequest
                         * @instance
                         */
                        TestIamPermissionsDiskRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsDiskRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsDiskRequest
                         * @instance
                         */
                        TestIamPermissionsDiskRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsDiskRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsDiskRequest
                         * @instance
                         */
                        TestIamPermissionsDiskRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * TestIamPermissionsDiskRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.TestIamPermissionsDiskRequest
                         * @instance
                         */
                        TestIamPermissionsDiskRequest.prototype.zone = "";
    
                        /**
                         * Creates a new TestIamPermissionsDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsDiskRequest} TestIamPermissionsDiskRequest instance
                         */
                        TestIamPermissionsDiskRequest.create = function create(properties) {
                            return new TestIamPermissionsDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsDiskRequest} message TestIamPermissionsDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsDiskRequest} message TestIamPermissionsDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsDiskRequest} TestIamPermissionsDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsDiskRequest} TestIamPermissionsDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsDiskRequest} TestIamPermissionsDiskRequest
                         */
                        TestIamPermissionsDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsDiskRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsDiskRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsDiskRequest} message TestIamPermissionsDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsDiskRequest";
                        };
    
                        return TestIamPermissionsDiskRequest;
                    })();
    
                    v1.TestIamPermissionsExternalVpnGatewayRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsExternalVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsExternalVpnGatewayRequest
                         * @property {string|null} [project] TestIamPermissionsExternalVpnGatewayRequest project
                         * @property {string|null} [resource] TestIamPermissionsExternalVpnGatewayRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsExternalVpnGatewayRequest testPermissionsRequestResource
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsExternalVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsExternalVpnGatewayRequest.
                         * @implements ITestIamPermissionsExternalVpnGatewayRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsExternalVpnGatewayRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsExternalVpnGatewayRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsExternalVpnGatewayRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest
                         * @instance
                         */
                        TestIamPermissionsExternalVpnGatewayRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsExternalVpnGatewayRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest
                         * @instance
                         */
                        TestIamPermissionsExternalVpnGatewayRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsExternalVpnGatewayRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest
                         * @instance
                         */
                        TestIamPermissionsExternalVpnGatewayRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * Creates a new TestIamPermissionsExternalVpnGatewayRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsExternalVpnGatewayRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest} TestIamPermissionsExternalVpnGatewayRequest instance
                         */
                        TestIamPermissionsExternalVpnGatewayRequest.create = function create(properties) {
                            return new TestIamPermissionsExternalVpnGatewayRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsExternalVpnGatewayRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsExternalVpnGatewayRequest} message TestIamPermissionsExternalVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsExternalVpnGatewayRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsExternalVpnGatewayRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsExternalVpnGatewayRequest} message TestIamPermissionsExternalVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsExternalVpnGatewayRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsExternalVpnGatewayRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest} TestIamPermissionsExternalVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsExternalVpnGatewayRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsExternalVpnGatewayRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest} TestIamPermissionsExternalVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsExternalVpnGatewayRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsExternalVpnGatewayRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsExternalVpnGatewayRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsExternalVpnGatewayRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest} TestIamPermissionsExternalVpnGatewayRequest
                         */
                        TestIamPermissionsExternalVpnGatewayRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsExternalVpnGatewayRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest} message TestIamPermissionsExternalVpnGatewayRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsExternalVpnGatewayRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsExternalVpnGatewayRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsExternalVpnGatewayRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsExternalVpnGatewayRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsExternalVpnGatewayRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest";
                        };
    
                        return TestIamPermissionsExternalVpnGatewayRequest;
                    })();
    
                    v1.TestIamPermissionsFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsFirewallPolicyRequest
                         * @property {string|null} [resource] TestIamPermissionsFirewallPolicyRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsFirewallPolicyRequest testPermissionsRequestResource
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsFirewallPolicyRequest.
                         * @implements ITestIamPermissionsFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsFirewallPolicyRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest
                         * @instance
                         */
                        TestIamPermissionsFirewallPolicyRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsFirewallPolicyRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest
                         * @instance
                         */
                        TestIamPermissionsFirewallPolicyRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * Creates a new TestIamPermissionsFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest} TestIamPermissionsFirewallPolicyRequest instance
                         */
                        TestIamPermissionsFirewallPolicyRequest.create = function create(properties) {
                            return new TestIamPermissionsFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsFirewallPolicyRequest} message TestIamPermissionsFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsFirewallPolicyRequest} message TestIamPermissionsFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest} TestIamPermissionsFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest} TestIamPermissionsFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest} TestIamPermissionsFirewallPolicyRequest
                         */
                        TestIamPermissionsFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest();
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest} message TestIamPermissionsFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest";
                        };
    
                        return TestIamPermissionsFirewallPolicyRequest;
                    })();
    
                    v1.TestIamPermissionsImageRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsImageRequest
                         * @property {string|null} [project] TestIamPermissionsImageRequest project
                         * @property {string|null} [resource] TestIamPermissionsImageRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsImageRequest testPermissionsRequestResource
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsImageRequest.
                         * @implements ITestIamPermissionsImageRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsImageRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsImageRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsImageRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsImageRequest
                         * @instance
                         */
                        TestIamPermissionsImageRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsImageRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsImageRequest
                         * @instance
                         */
                        TestIamPermissionsImageRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsImageRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsImageRequest
                         * @instance
                         */
                        TestIamPermissionsImageRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * Creates a new TestIamPermissionsImageRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsImageRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsImageRequest} TestIamPermissionsImageRequest instance
                         */
                        TestIamPermissionsImageRequest.create = function create(properties) {
                            return new TestIamPermissionsImageRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsImageRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsImageRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsImageRequest} message TestIamPermissionsImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsImageRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsImageRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsImageRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsImageRequest} message TestIamPermissionsImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsImageRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsImageRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsImageRequest} TestIamPermissionsImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsImageRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsImageRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsImageRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsImageRequest} TestIamPermissionsImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsImageRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsImageRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsImageRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsImageRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsImageRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsImageRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsImageRequest} TestIamPermissionsImageRequest
                         */
                        TestIamPermissionsImageRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsImageRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsImageRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsImageRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsImageRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsImageRequest} message TestIamPermissionsImageRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsImageRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsImageRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsImageRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsImageRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsImageRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsImageRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsImageRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsImageRequest";
                        };
    
                        return TestIamPermissionsImageRequest;
                    })();
    
                    v1.TestIamPermissionsInstanceRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsInstanceRequest
                         * @property {string|null} [project] TestIamPermissionsInstanceRequest project
                         * @property {string|null} [resource] TestIamPermissionsInstanceRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsInstanceRequest testPermissionsRequestResource
                         * @property {string|null} [zone] TestIamPermissionsInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsInstanceRequest.
                         * @implements ITestIamPermissionsInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsInstanceRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceRequest
                         * @instance
                         */
                        TestIamPermissionsInstanceRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsInstanceRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceRequest
                         * @instance
                         */
                        TestIamPermissionsInstanceRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsInstanceRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceRequest
                         * @instance
                         */
                        TestIamPermissionsInstanceRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * TestIamPermissionsInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceRequest
                         * @instance
                         */
                        TestIamPermissionsInstanceRequest.prototype.zone = "";
    
                        /**
                         * Creates a new TestIamPermissionsInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsInstanceRequest} TestIamPermissionsInstanceRequest instance
                         */
                        TestIamPermissionsInstanceRequest.create = function create(properties) {
                            return new TestIamPermissionsInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsInstanceRequest} message TestIamPermissionsInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsInstanceRequest} message TestIamPermissionsInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsInstanceRequest} TestIamPermissionsInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsInstanceRequest} TestIamPermissionsInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsInstanceRequest} TestIamPermissionsInstanceRequest
                         */
                        TestIamPermissionsInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsInstanceRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsInstanceRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsInstanceRequest} message TestIamPermissionsInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsInstanceRequest";
                        };
    
                        return TestIamPermissionsInstanceRequest;
                    })();
    
                    v1.TestIamPermissionsInstanceTemplateRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsInstanceTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsInstanceTemplateRequest
                         * @property {string|null} [project] TestIamPermissionsInstanceTemplateRequest project
                         * @property {string|null} [resource] TestIamPermissionsInstanceTemplateRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsInstanceTemplateRequest testPermissionsRequestResource
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsInstanceTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsInstanceTemplateRequest.
                         * @implements ITestIamPermissionsInstanceTemplateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsInstanceTemplateRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsInstanceTemplateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsInstanceTemplateRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest
                         * @instance
                         */
                        TestIamPermissionsInstanceTemplateRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsInstanceTemplateRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest
                         * @instance
                         */
                        TestIamPermissionsInstanceTemplateRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsInstanceTemplateRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest
                         * @instance
                         */
                        TestIamPermissionsInstanceTemplateRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * Creates a new TestIamPermissionsInstanceTemplateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsInstanceTemplateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest} TestIamPermissionsInstanceTemplateRequest instance
                         */
                        TestIamPermissionsInstanceTemplateRequest.create = function create(properties) {
                            return new TestIamPermissionsInstanceTemplateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsInstanceTemplateRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsInstanceTemplateRequest} message TestIamPermissionsInstanceTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsInstanceTemplateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsInstanceTemplateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsInstanceTemplateRequest} message TestIamPermissionsInstanceTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsInstanceTemplateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsInstanceTemplateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest} TestIamPermissionsInstanceTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsInstanceTemplateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsInstanceTemplateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest} TestIamPermissionsInstanceTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsInstanceTemplateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsInstanceTemplateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsInstanceTemplateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsInstanceTemplateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest} TestIamPermissionsInstanceTemplateRequest
                         */
                        TestIamPermissionsInstanceTemplateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsInstanceTemplateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest} message TestIamPermissionsInstanceTemplateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsInstanceTemplateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsInstanceTemplateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsInstanceTemplateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsInstanceTemplateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsInstanceTemplateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest";
                        };
    
                        return TestIamPermissionsInstanceTemplateRequest;
                    })();
    
                    v1.TestIamPermissionsLicenseCodeRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsLicenseCodeRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsLicenseCodeRequest
                         * @property {string|null} [project] TestIamPermissionsLicenseCodeRequest project
                         * @property {string|null} [resource] TestIamPermissionsLicenseCodeRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsLicenseCodeRequest testPermissionsRequestResource
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsLicenseCodeRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsLicenseCodeRequest.
                         * @implements ITestIamPermissionsLicenseCodeRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsLicenseCodeRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsLicenseCodeRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsLicenseCodeRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest
                         * @instance
                         */
                        TestIamPermissionsLicenseCodeRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsLicenseCodeRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest
                         * @instance
                         */
                        TestIamPermissionsLicenseCodeRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsLicenseCodeRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest
                         * @instance
                         */
                        TestIamPermissionsLicenseCodeRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * Creates a new TestIamPermissionsLicenseCodeRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsLicenseCodeRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest} TestIamPermissionsLicenseCodeRequest instance
                         */
                        TestIamPermissionsLicenseCodeRequest.create = function create(properties) {
                            return new TestIamPermissionsLicenseCodeRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsLicenseCodeRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsLicenseCodeRequest} message TestIamPermissionsLicenseCodeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsLicenseCodeRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsLicenseCodeRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsLicenseCodeRequest} message TestIamPermissionsLicenseCodeRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsLicenseCodeRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsLicenseCodeRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest} TestIamPermissionsLicenseCodeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsLicenseCodeRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsLicenseCodeRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest} TestIamPermissionsLicenseCodeRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsLicenseCodeRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsLicenseCodeRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsLicenseCodeRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsLicenseCodeRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest} TestIamPermissionsLicenseCodeRequest
                         */
                        TestIamPermissionsLicenseCodeRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsLicenseCodeRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest} message TestIamPermissionsLicenseCodeRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsLicenseCodeRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsLicenseCodeRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsLicenseCodeRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsLicenseCodeRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsLicenseCodeRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest";
                        };
    
                        return TestIamPermissionsLicenseCodeRequest;
                    })();
    
                    v1.TestIamPermissionsLicenseRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsLicenseRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsLicenseRequest
                         * @property {string|null} [project] TestIamPermissionsLicenseRequest project
                         * @property {string|null} [resource] TestIamPermissionsLicenseRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsLicenseRequest testPermissionsRequestResource
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsLicenseRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsLicenseRequest.
                         * @implements ITestIamPermissionsLicenseRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsLicenseRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsLicenseRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsLicenseRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseRequest
                         * @instance
                         */
                        TestIamPermissionsLicenseRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsLicenseRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseRequest
                         * @instance
                         */
                        TestIamPermissionsLicenseRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsLicenseRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseRequest
                         * @instance
                         */
                        TestIamPermissionsLicenseRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * Creates a new TestIamPermissionsLicenseRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsLicenseRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsLicenseRequest} TestIamPermissionsLicenseRequest instance
                         */
                        TestIamPermissionsLicenseRequest.create = function create(properties) {
                            return new TestIamPermissionsLicenseRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsLicenseRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsLicenseRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsLicenseRequest} message TestIamPermissionsLicenseRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsLicenseRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsLicenseRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsLicenseRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsLicenseRequest} message TestIamPermissionsLicenseRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsLicenseRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsLicenseRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsLicenseRequest} TestIamPermissionsLicenseRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsLicenseRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsLicenseRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsLicenseRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsLicenseRequest} TestIamPermissionsLicenseRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsLicenseRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsLicenseRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsLicenseRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsLicenseRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsLicenseRequest} TestIamPermissionsLicenseRequest
                         */
                        TestIamPermissionsLicenseRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsLicenseRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsLicenseRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsLicenseRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsLicenseRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsLicenseRequest} message TestIamPermissionsLicenseRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsLicenseRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsLicenseRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsLicenseRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsLicenseRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsLicenseRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsLicenseRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsLicenseRequest";
                        };
    
                        return TestIamPermissionsLicenseRequest;
                    })();
    
                    v1.TestIamPermissionsMachineImageRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsMachineImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsMachineImageRequest
                         * @property {string|null} [project] TestIamPermissionsMachineImageRequest project
                         * @property {string|null} [resource] TestIamPermissionsMachineImageRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsMachineImageRequest testPermissionsRequestResource
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsMachineImageRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsMachineImageRequest.
                         * @implements ITestIamPermissionsMachineImageRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsMachineImageRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsMachineImageRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsMachineImageRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsMachineImageRequest
                         * @instance
                         */
                        TestIamPermissionsMachineImageRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsMachineImageRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsMachineImageRequest
                         * @instance
                         */
                        TestIamPermissionsMachineImageRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsMachineImageRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsMachineImageRequest
                         * @instance
                         */
                        TestIamPermissionsMachineImageRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * Creates a new TestIamPermissionsMachineImageRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsMachineImageRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsMachineImageRequest} TestIamPermissionsMachineImageRequest instance
                         */
                        TestIamPermissionsMachineImageRequest.create = function create(properties) {
                            return new TestIamPermissionsMachineImageRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsMachineImageRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsMachineImageRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsMachineImageRequest} message TestIamPermissionsMachineImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsMachineImageRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsMachineImageRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsMachineImageRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsMachineImageRequest} message TestIamPermissionsMachineImageRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsMachineImageRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsMachineImageRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsMachineImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsMachineImageRequest} TestIamPermissionsMachineImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsMachineImageRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsMachineImageRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsMachineImageRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsMachineImageRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsMachineImageRequest} TestIamPermissionsMachineImageRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsMachineImageRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsMachineImageRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsMachineImageRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsMachineImageRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsMachineImageRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsMachineImageRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsMachineImageRequest} TestIamPermissionsMachineImageRequest
                         */
                        TestIamPermissionsMachineImageRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsMachineImageRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsMachineImageRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsMachineImageRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsMachineImageRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsMachineImageRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsMachineImageRequest} message TestIamPermissionsMachineImageRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsMachineImageRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsMachineImageRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsMachineImageRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsMachineImageRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsMachineImageRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsMachineImageRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsMachineImageRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsMachineImageRequest";
                        };
    
                        return TestIamPermissionsMachineImageRequest;
                    })();
    
                    v1.TestIamPermissionsNetworkEndpointGroupRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsNetworkEndpointGroupRequest
                         * @property {string|null} [project] TestIamPermissionsNetworkEndpointGroupRequest project
                         * @property {string|null} [resource] TestIamPermissionsNetworkEndpointGroupRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsNetworkEndpointGroupRequest testPermissionsRequestResource
                         * @property {string|null} [zone] TestIamPermissionsNetworkEndpointGroupRequest zone
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsNetworkEndpointGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsNetworkEndpointGroupRequest.
                         * @implements ITestIamPermissionsNetworkEndpointGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNetworkEndpointGroupRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsNetworkEndpointGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsNetworkEndpointGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest
                         * @instance
                         */
                        TestIamPermissionsNetworkEndpointGroupRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsNetworkEndpointGroupRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest
                         * @instance
                         */
                        TestIamPermissionsNetworkEndpointGroupRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsNetworkEndpointGroupRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest
                         * @instance
                         */
                        TestIamPermissionsNetworkEndpointGroupRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * TestIamPermissionsNetworkEndpointGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest
                         * @instance
                         */
                        TestIamPermissionsNetworkEndpointGroupRequest.prototype.zone = "";
    
                        /**
                         * Creates a new TestIamPermissionsNetworkEndpointGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNetworkEndpointGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest} TestIamPermissionsNetworkEndpointGroupRequest instance
                         */
                        TestIamPermissionsNetworkEndpointGroupRequest.create = function create(properties) {
                            return new TestIamPermissionsNetworkEndpointGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsNetworkEndpointGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNetworkEndpointGroupRequest} message TestIamPermissionsNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsNetworkEndpointGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsNetworkEndpointGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNetworkEndpointGroupRequest} message TestIamPermissionsNetworkEndpointGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsNetworkEndpointGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsNetworkEndpointGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest} TestIamPermissionsNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsNetworkEndpointGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsNetworkEndpointGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest} TestIamPermissionsNetworkEndpointGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsNetworkEndpointGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsNetworkEndpointGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsNetworkEndpointGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsNetworkEndpointGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest} TestIamPermissionsNetworkEndpointGroupRequest
                         */
                        TestIamPermissionsNetworkEndpointGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsNetworkEndpointGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest} message TestIamPermissionsNetworkEndpointGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsNetworkEndpointGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsNetworkEndpointGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsNetworkEndpointGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsNetworkEndpointGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsNetworkEndpointGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest";
                        };
    
                        return TestIamPermissionsNetworkEndpointGroupRequest;
                    })();
    
                    v1.TestIamPermissionsNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsNetworkFirewallPolicyRequest
                         * @property {string|null} [project] TestIamPermissionsNetworkFirewallPolicyRequest project
                         * @property {string|null} [resource] TestIamPermissionsNetworkFirewallPolicyRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsNetworkFirewallPolicyRequest testPermissionsRequestResource
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsNetworkFirewallPolicyRequest.
                         * @implements ITestIamPermissionsNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest
                         * @instance
                         */
                        TestIamPermissionsNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsNetworkFirewallPolicyRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest
                         * @instance
                         */
                        TestIamPermissionsNetworkFirewallPolicyRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsNetworkFirewallPolicyRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest
                         * @instance
                         */
                        TestIamPermissionsNetworkFirewallPolicyRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * Creates a new TestIamPermissionsNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest} TestIamPermissionsNetworkFirewallPolicyRequest instance
                         */
                        TestIamPermissionsNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new TestIamPermissionsNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNetworkFirewallPolicyRequest} message TestIamPermissionsNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNetworkFirewallPolicyRequest} message TestIamPermissionsNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest} TestIamPermissionsNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest} TestIamPermissionsNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest} TestIamPermissionsNetworkFirewallPolicyRequest
                         */
                        TestIamPermissionsNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest} message TestIamPermissionsNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest";
                        };
    
                        return TestIamPermissionsNetworkFirewallPolicyRequest;
                    })();
    
                    v1.TestIamPermissionsNodeGroupRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsNodeGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsNodeGroupRequest
                         * @property {string|null} [project] TestIamPermissionsNodeGroupRequest project
                         * @property {string|null} [resource] TestIamPermissionsNodeGroupRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsNodeGroupRequest testPermissionsRequestResource
                         * @property {string|null} [zone] TestIamPermissionsNodeGroupRequest zone
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsNodeGroupRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsNodeGroupRequest.
                         * @implements ITestIamPermissionsNodeGroupRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNodeGroupRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsNodeGroupRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsNodeGroupRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest
                         * @instance
                         */
                        TestIamPermissionsNodeGroupRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsNodeGroupRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest
                         * @instance
                         */
                        TestIamPermissionsNodeGroupRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsNodeGroupRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest
                         * @instance
                         */
                        TestIamPermissionsNodeGroupRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * TestIamPermissionsNodeGroupRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest
                         * @instance
                         */
                        TestIamPermissionsNodeGroupRequest.prototype.zone = "";
    
                        /**
                         * Creates a new TestIamPermissionsNodeGroupRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNodeGroupRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest} TestIamPermissionsNodeGroupRequest instance
                         */
                        TestIamPermissionsNodeGroupRequest.create = function create(properties) {
                            return new TestIamPermissionsNodeGroupRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsNodeGroupRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNodeGroupRequest} message TestIamPermissionsNodeGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsNodeGroupRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsNodeGroupRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNodeGroupRequest} message TestIamPermissionsNodeGroupRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsNodeGroupRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsNodeGroupRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest} TestIamPermissionsNodeGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsNodeGroupRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsNodeGroupRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest} TestIamPermissionsNodeGroupRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsNodeGroupRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsNodeGroupRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsNodeGroupRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsNodeGroupRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest} TestIamPermissionsNodeGroupRequest
                         */
                        TestIamPermissionsNodeGroupRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsNodeGroupRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest} message TestIamPermissionsNodeGroupRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsNodeGroupRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsNodeGroupRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsNodeGroupRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsNodeGroupRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsNodeGroupRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest";
                        };
    
                        return TestIamPermissionsNodeGroupRequest;
                    })();
    
                    v1.TestIamPermissionsNodeTemplateRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsNodeTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsNodeTemplateRequest
                         * @property {string|null} [project] TestIamPermissionsNodeTemplateRequest project
                         * @property {string|null} [region] TestIamPermissionsNodeTemplateRequest region
                         * @property {string|null} [resource] TestIamPermissionsNodeTemplateRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsNodeTemplateRequest testPermissionsRequestResource
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsNodeTemplateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsNodeTemplateRequest.
                         * @implements ITestIamPermissionsNodeTemplateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNodeTemplateRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsNodeTemplateRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsNodeTemplateRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest
                         * @instance
                         */
                        TestIamPermissionsNodeTemplateRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsNodeTemplateRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest
                         * @instance
                         */
                        TestIamPermissionsNodeTemplateRequest.prototype.region = "";
    
                        /**
                         * TestIamPermissionsNodeTemplateRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest
                         * @instance
                         */
                        TestIamPermissionsNodeTemplateRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsNodeTemplateRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest
                         * @instance
                         */
                        TestIamPermissionsNodeTemplateRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * Creates a new TestIamPermissionsNodeTemplateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNodeTemplateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest} TestIamPermissionsNodeTemplateRequest instance
                         */
                        TestIamPermissionsNodeTemplateRequest.create = function create(properties) {
                            return new TestIamPermissionsNodeTemplateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsNodeTemplateRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNodeTemplateRequest} message TestIamPermissionsNodeTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsNodeTemplateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsNodeTemplateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNodeTemplateRequest} message TestIamPermissionsNodeTemplateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsNodeTemplateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsNodeTemplateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest} TestIamPermissionsNodeTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsNodeTemplateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsNodeTemplateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest} TestIamPermissionsNodeTemplateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsNodeTemplateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsNodeTemplateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsNodeTemplateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsNodeTemplateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest} TestIamPermissionsNodeTemplateRequest
                         */
                        TestIamPermissionsNodeTemplateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsNodeTemplateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest} message TestIamPermissionsNodeTemplateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsNodeTemplateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsNodeTemplateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsNodeTemplateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsNodeTemplateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsNodeTemplateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest";
                        };
    
                        return TestIamPermissionsNodeTemplateRequest;
                    })();
    
                    v1.TestIamPermissionsPacketMirroringRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsPacketMirroringRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsPacketMirroringRequest
                         * @property {string|null} [project] TestIamPermissionsPacketMirroringRequest project
                         * @property {string|null} [region] TestIamPermissionsPacketMirroringRequest region
                         * @property {string|null} [resource] TestIamPermissionsPacketMirroringRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsPacketMirroringRequest testPermissionsRequestResource
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsPacketMirroringRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsPacketMirroringRequest.
                         * @implements ITestIamPermissionsPacketMirroringRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsPacketMirroringRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsPacketMirroringRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsPacketMirroringRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest
                         * @instance
                         */
                        TestIamPermissionsPacketMirroringRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsPacketMirroringRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest
                         * @instance
                         */
                        TestIamPermissionsPacketMirroringRequest.prototype.region = "";
    
                        /**
                         * TestIamPermissionsPacketMirroringRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest
                         * @instance
                         */
                        TestIamPermissionsPacketMirroringRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsPacketMirroringRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest
                         * @instance
                         */
                        TestIamPermissionsPacketMirroringRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * Creates a new TestIamPermissionsPacketMirroringRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsPacketMirroringRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest} TestIamPermissionsPacketMirroringRequest instance
                         */
                        TestIamPermissionsPacketMirroringRequest.create = function create(properties) {
                            return new TestIamPermissionsPacketMirroringRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsPacketMirroringRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsPacketMirroringRequest} message TestIamPermissionsPacketMirroringRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsPacketMirroringRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsPacketMirroringRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsPacketMirroringRequest} message TestIamPermissionsPacketMirroringRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsPacketMirroringRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsPacketMirroringRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest} TestIamPermissionsPacketMirroringRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsPacketMirroringRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsPacketMirroringRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest} TestIamPermissionsPacketMirroringRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsPacketMirroringRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsPacketMirroringRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsPacketMirroringRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsPacketMirroringRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest} TestIamPermissionsPacketMirroringRequest
                         */
                        TestIamPermissionsPacketMirroringRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsPacketMirroringRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest} message TestIamPermissionsPacketMirroringRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsPacketMirroringRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsPacketMirroringRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsPacketMirroringRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsPacketMirroringRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsPacketMirroringRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest";
                        };
    
                        return TestIamPermissionsPacketMirroringRequest;
                    })();
    
                    v1.TestIamPermissionsRegionDiskRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsRegionDiskRequest
                         * @property {string|null} [project] TestIamPermissionsRegionDiskRequest project
                         * @property {string|null} [region] TestIamPermissionsRegionDiskRequest region
                         * @property {string|null} [resource] TestIamPermissionsRegionDiskRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsRegionDiskRequest testPermissionsRequestResource
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsRegionDiskRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsRegionDiskRequest.
                         * @implements ITestIamPermissionsRegionDiskRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsRegionDiskRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsRegionDiskRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsRegionDiskRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest
                         * @instance
                         */
                        TestIamPermissionsRegionDiskRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsRegionDiskRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest
                         * @instance
                         */
                        TestIamPermissionsRegionDiskRequest.prototype.region = "";
    
                        /**
                         * TestIamPermissionsRegionDiskRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest
                         * @instance
                         */
                        TestIamPermissionsRegionDiskRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsRegionDiskRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest
                         * @instance
                         */
                        TestIamPermissionsRegionDiskRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * Creates a new TestIamPermissionsRegionDiskRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsRegionDiskRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest} TestIamPermissionsRegionDiskRequest instance
                         */
                        TestIamPermissionsRegionDiskRequest.create = function create(properties) {
                            return new TestIamPermissionsRegionDiskRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsRegionDiskRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsRegionDiskRequest} message TestIamPermissionsRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsRegionDiskRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsRegionDiskRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsRegionDiskRequest} message TestIamPermissionsRegionDiskRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsRegionDiskRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsRegionDiskRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest} TestIamPermissionsRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsRegionDiskRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsRegionDiskRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest} TestIamPermissionsRegionDiskRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsRegionDiskRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsRegionDiskRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsRegionDiskRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsRegionDiskRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest} TestIamPermissionsRegionDiskRequest
                         */
                        TestIamPermissionsRegionDiskRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsRegionDiskRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest} message TestIamPermissionsRegionDiskRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsRegionDiskRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsRegionDiskRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsRegionDiskRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsRegionDiskRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsRegionDiskRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest";
                        };
    
                        return TestIamPermissionsRegionDiskRequest;
                    })();
    
                    v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsRegionNetworkFirewallPolicyRequest
                         * @property {string|null} [project] TestIamPermissionsRegionNetworkFirewallPolicyRequest project
                         * @property {string|null} [region] TestIamPermissionsRegionNetworkFirewallPolicyRequest region
                         * @property {string|null} [resource] TestIamPermissionsRegionNetworkFirewallPolicyRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsRegionNetworkFirewallPolicyRequest testPermissionsRequestResource
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsRegionNetworkFirewallPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsRegionNetworkFirewallPolicyRequest.
                         * @implements ITestIamPermissionsRegionNetworkFirewallPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsRegionNetworkFirewallPolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsRegionNetworkFirewallPolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        TestIamPermissionsRegionNetworkFirewallPolicyRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsRegionNetworkFirewallPolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        TestIamPermissionsRegionNetworkFirewallPolicyRequest.prototype.region = "";
    
                        /**
                         * TestIamPermissionsRegionNetworkFirewallPolicyRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        TestIamPermissionsRegionNetworkFirewallPolicyRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsRegionNetworkFirewallPolicyRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest
                         * @instance
                         */
                        TestIamPermissionsRegionNetworkFirewallPolicyRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * Creates a new TestIamPermissionsRegionNetworkFirewallPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsRegionNetworkFirewallPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest} TestIamPermissionsRegionNetworkFirewallPolicyRequest instance
                         */
                        TestIamPermissionsRegionNetworkFirewallPolicyRequest.create = function create(properties) {
                            return new TestIamPermissionsRegionNetworkFirewallPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsRegionNetworkFirewallPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsRegionNetworkFirewallPolicyRequest} message TestIamPermissionsRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsRegionNetworkFirewallPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsRegionNetworkFirewallPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsRegionNetworkFirewallPolicyRequest} message TestIamPermissionsRegionNetworkFirewallPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsRegionNetworkFirewallPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsRegionNetworkFirewallPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest} TestIamPermissionsRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsRegionNetworkFirewallPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsRegionNetworkFirewallPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest} TestIamPermissionsRegionNetworkFirewallPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsRegionNetworkFirewallPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsRegionNetworkFirewallPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsRegionNetworkFirewallPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsRegionNetworkFirewallPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest} TestIamPermissionsRegionNetworkFirewallPolicyRequest
                         */
                        TestIamPermissionsRegionNetworkFirewallPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsRegionNetworkFirewallPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest} message TestIamPermissionsRegionNetworkFirewallPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsRegionNetworkFirewallPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsRegionNetworkFirewallPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsRegionNetworkFirewallPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsRegionNetworkFirewallPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsRegionNetworkFirewallPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest";
                        };
    
                        return TestIamPermissionsRegionNetworkFirewallPolicyRequest;
                    })();
    
                    v1.TestIamPermissionsReservationRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsReservationRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsReservationRequest
                         * @property {string|null} [project] TestIamPermissionsReservationRequest project
                         * @property {string|null} [resource] TestIamPermissionsReservationRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsReservationRequest testPermissionsRequestResource
                         * @property {string|null} [zone] TestIamPermissionsReservationRequest zone
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsReservationRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsReservationRequest.
                         * @implements ITestIamPermissionsReservationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsReservationRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsReservationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsReservationRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsReservationRequest
                         * @instance
                         */
                        TestIamPermissionsReservationRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsReservationRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsReservationRequest
                         * @instance
                         */
                        TestIamPermissionsReservationRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsReservationRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsReservationRequest
                         * @instance
                         */
                        TestIamPermissionsReservationRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * TestIamPermissionsReservationRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.TestIamPermissionsReservationRequest
                         * @instance
                         */
                        TestIamPermissionsReservationRequest.prototype.zone = "";
    
                        /**
                         * Creates a new TestIamPermissionsReservationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsReservationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsReservationRequest} TestIamPermissionsReservationRequest instance
                         */
                        TestIamPermissionsReservationRequest.create = function create(properties) {
                            return new TestIamPermissionsReservationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsReservationRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsReservationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsReservationRequest} message TestIamPermissionsReservationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsReservationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsReservationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsReservationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsReservationRequest} message TestIamPermissionsReservationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsReservationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsReservationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsReservationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsReservationRequest} TestIamPermissionsReservationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsReservationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsReservationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsReservationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsReservationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsReservationRequest} TestIamPermissionsReservationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsReservationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsReservationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsReservationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsReservationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsReservationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsReservationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsReservationRequest} TestIamPermissionsReservationRequest
                         */
                        TestIamPermissionsReservationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsReservationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsReservationRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsReservationRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsReservationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsReservationRequest} message TestIamPermissionsReservationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsReservationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsReservationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsReservationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsReservationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsReservationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsReservationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsReservationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsReservationRequest";
                        };
    
                        return TestIamPermissionsReservationRequest;
                    })();
    
                    v1.TestIamPermissionsResourcePolicyRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsResourcePolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsResourcePolicyRequest
                         * @property {string|null} [project] TestIamPermissionsResourcePolicyRequest project
                         * @property {string|null} [region] TestIamPermissionsResourcePolicyRequest region
                         * @property {string|null} [resource] TestIamPermissionsResourcePolicyRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsResourcePolicyRequest testPermissionsRequestResource
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsResourcePolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsResourcePolicyRequest.
                         * @implements ITestIamPermissionsResourcePolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsResourcePolicyRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsResourcePolicyRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsResourcePolicyRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest
                         * @instance
                         */
                        TestIamPermissionsResourcePolicyRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsResourcePolicyRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest
                         * @instance
                         */
                        TestIamPermissionsResourcePolicyRequest.prototype.region = "";
    
                        /**
                         * TestIamPermissionsResourcePolicyRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest
                         * @instance
                         */
                        TestIamPermissionsResourcePolicyRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsResourcePolicyRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest
                         * @instance
                         */
                        TestIamPermissionsResourcePolicyRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * Creates a new TestIamPermissionsResourcePolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsResourcePolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest} TestIamPermissionsResourcePolicyRequest instance
                         */
                        TestIamPermissionsResourcePolicyRequest.create = function create(properties) {
                            return new TestIamPermissionsResourcePolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsResourcePolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsResourcePolicyRequest} message TestIamPermissionsResourcePolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsResourcePolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsResourcePolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsResourcePolicyRequest} message TestIamPermissionsResourcePolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsResourcePolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsResourcePolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest} TestIamPermissionsResourcePolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsResourcePolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsResourcePolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest} TestIamPermissionsResourcePolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsResourcePolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsResourcePolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsResourcePolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsResourcePolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest} TestIamPermissionsResourcePolicyRequest
                         */
                        TestIamPermissionsResourcePolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsResourcePolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest} message TestIamPermissionsResourcePolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsResourcePolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsResourcePolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsResourcePolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsResourcePolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsResourcePolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest";
                        };
    
                        return TestIamPermissionsResourcePolicyRequest;
                    })();
    
                    v1.TestIamPermissionsServiceAttachmentRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsServiceAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsServiceAttachmentRequest
                         * @property {string|null} [project] TestIamPermissionsServiceAttachmentRequest project
                         * @property {string|null} [region] TestIamPermissionsServiceAttachmentRequest region
                         * @property {string|null} [resource] TestIamPermissionsServiceAttachmentRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsServiceAttachmentRequest testPermissionsRequestResource
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsServiceAttachmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsServiceAttachmentRequest.
                         * @implements ITestIamPermissionsServiceAttachmentRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsServiceAttachmentRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsServiceAttachmentRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsServiceAttachmentRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest
                         * @instance
                         */
                        TestIamPermissionsServiceAttachmentRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsServiceAttachmentRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest
                         * @instance
                         */
                        TestIamPermissionsServiceAttachmentRequest.prototype.region = "";
    
                        /**
                         * TestIamPermissionsServiceAttachmentRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest
                         * @instance
                         */
                        TestIamPermissionsServiceAttachmentRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsServiceAttachmentRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest
                         * @instance
                         */
                        TestIamPermissionsServiceAttachmentRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * Creates a new TestIamPermissionsServiceAttachmentRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsServiceAttachmentRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest} TestIamPermissionsServiceAttachmentRequest instance
                         */
                        TestIamPermissionsServiceAttachmentRequest.create = function create(properties) {
                            return new TestIamPermissionsServiceAttachmentRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsServiceAttachmentRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsServiceAttachmentRequest} message TestIamPermissionsServiceAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsServiceAttachmentRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsServiceAttachmentRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsServiceAttachmentRequest} message TestIamPermissionsServiceAttachmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsServiceAttachmentRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsServiceAttachmentRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest} TestIamPermissionsServiceAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsServiceAttachmentRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsServiceAttachmentRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest} TestIamPermissionsServiceAttachmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsServiceAttachmentRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsServiceAttachmentRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsServiceAttachmentRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsServiceAttachmentRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest} TestIamPermissionsServiceAttachmentRequest
                         */
                        TestIamPermissionsServiceAttachmentRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsServiceAttachmentRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest} message TestIamPermissionsServiceAttachmentRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsServiceAttachmentRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsServiceAttachmentRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsServiceAttachmentRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsServiceAttachmentRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsServiceAttachmentRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest";
                        };
    
                        return TestIamPermissionsServiceAttachmentRequest;
                    })();
    
                    v1.TestIamPermissionsSnapshotRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsSnapshotRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsSnapshotRequest
                         * @property {string|null} [project] TestIamPermissionsSnapshotRequest project
                         * @property {string|null} [resource] TestIamPermissionsSnapshotRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsSnapshotRequest testPermissionsRequestResource
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsSnapshotRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsSnapshotRequest.
                         * @implements ITestIamPermissionsSnapshotRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsSnapshotRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsSnapshotRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsSnapshotRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSnapshotRequest
                         * @instance
                         */
                        TestIamPermissionsSnapshotRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsSnapshotRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSnapshotRequest
                         * @instance
                         */
                        TestIamPermissionsSnapshotRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsSnapshotRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSnapshotRequest
                         * @instance
                         */
                        TestIamPermissionsSnapshotRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * Creates a new TestIamPermissionsSnapshotRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsSnapshotRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsSnapshotRequest} TestIamPermissionsSnapshotRequest instance
                         */
                        TestIamPermissionsSnapshotRequest.create = function create(properties) {
                            return new TestIamPermissionsSnapshotRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsSnapshotRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsSnapshotRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsSnapshotRequest} message TestIamPermissionsSnapshotRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsSnapshotRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsSnapshotRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsSnapshotRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsSnapshotRequest} message TestIamPermissionsSnapshotRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsSnapshotRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsSnapshotRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSnapshotRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsSnapshotRequest} TestIamPermissionsSnapshotRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsSnapshotRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsSnapshotRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsSnapshotRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSnapshotRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsSnapshotRequest} TestIamPermissionsSnapshotRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsSnapshotRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsSnapshotRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSnapshotRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsSnapshotRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsSnapshotRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSnapshotRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsSnapshotRequest} TestIamPermissionsSnapshotRequest
                         */
                        TestIamPermissionsSnapshotRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsSnapshotRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsSnapshotRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsSnapshotRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsSnapshotRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSnapshotRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsSnapshotRequest} message TestIamPermissionsSnapshotRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsSnapshotRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsSnapshotRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSnapshotRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsSnapshotRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsSnapshotRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSnapshotRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsSnapshotRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsSnapshotRequest";
                        };
    
                        return TestIamPermissionsSnapshotRequest;
                    })();
    
                    v1.TestIamPermissionsSubnetworkRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsSubnetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsSubnetworkRequest
                         * @property {string|null} [project] TestIamPermissionsSubnetworkRequest project
                         * @property {string|null} [region] TestIamPermissionsSubnetworkRequest region
                         * @property {string|null} [resource] TestIamPermissionsSubnetworkRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsSubnetworkRequest testPermissionsRequestResource
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsSubnetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsSubnetworkRequest.
                         * @implements ITestIamPermissionsSubnetworkRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsSubnetworkRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsSubnetworkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsSubnetworkRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest
                         * @instance
                         */
                        TestIamPermissionsSubnetworkRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsSubnetworkRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest
                         * @instance
                         */
                        TestIamPermissionsSubnetworkRequest.prototype.region = "";
    
                        /**
                         * TestIamPermissionsSubnetworkRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest
                         * @instance
                         */
                        TestIamPermissionsSubnetworkRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsSubnetworkRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest
                         * @instance
                         */
                        TestIamPermissionsSubnetworkRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * Creates a new TestIamPermissionsSubnetworkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsSubnetworkRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest} TestIamPermissionsSubnetworkRequest instance
                         */
                        TestIamPermissionsSubnetworkRequest.create = function create(properties) {
                            return new TestIamPermissionsSubnetworkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsSubnetworkRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsSubnetworkRequest} message TestIamPermissionsSubnetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsSubnetworkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsSubnetworkRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsSubnetworkRequest} message TestIamPermissionsSubnetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsSubnetworkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsSubnetworkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest} TestIamPermissionsSubnetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsSubnetworkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsSubnetworkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest} TestIamPermissionsSubnetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsSubnetworkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsSubnetworkRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsSubnetworkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsSubnetworkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest} TestIamPermissionsSubnetworkRequest
                         */
                        TestIamPermissionsSubnetworkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsSubnetworkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest} message TestIamPermissionsSubnetworkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsSubnetworkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsSubnetworkRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsSubnetworkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsSubnetworkRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsSubnetworkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest";
                        };
    
                        return TestIamPermissionsSubnetworkRequest;
                    })();
    
                    v1.TestIamPermissionsVpnGatewayRequest = (function() {
    
                        /**
                         * Properties of a TestIamPermissionsVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestIamPermissionsVpnGatewayRequest
                         * @property {string|null} [project] TestIamPermissionsVpnGatewayRequest project
                         * @property {string|null} [region] TestIamPermissionsVpnGatewayRequest region
                         * @property {string|null} [resource] TestIamPermissionsVpnGatewayRequest resource
                         * @property {google.cloud.compute.v1.ITestPermissionsRequest|null} [testPermissionsRequestResource] TestIamPermissionsVpnGatewayRequest testPermissionsRequestResource
                         */
    
                        /**
                         * Constructs a new TestIamPermissionsVpnGatewayRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestIamPermissionsVpnGatewayRequest.
                         * @implements ITestIamPermissionsVpnGatewayRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestIamPermissionsVpnGatewayRequest=} [properties] Properties to set
                         */
                        function TestIamPermissionsVpnGatewayRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestIamPermissionsVpnGatewayRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest
                         * @instance
                         */
                        TestIamPermissionsVpnGatewayRequest.prototype.project = "";
    
                        /**
                         * TestIamPermissionsVpnGatewayRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest
                         * @instance
                         */
                        TestIamPermissionsVpnGatewayRequest.prototype.region = "";
    
                        /**
                         * TestIamPermissionsVpnGatewayRequest resource.
                         * @member {string} resource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest
                         * @instance
                         */
                        TestIamPermissionsVpnGatewayRequest.prototype.resource = "";
    
                        /**
                         * TestIamPermissionsVpnGatewayRequest testPermissionsRequestResource.
                         * @member {google.cloud.compute.v1.ITestPermissionsRequest|null|undefined} testPermissionsRequestResource
                         * @memberof google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest
                         * @instance
                         */
                        TestIamPermissionsVpnGatewayRequest.prototype.testPermissionsRequestResource = null;
    
                        /**
                         * Creates a new TestIamPermissionsVpnGatewayRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsVpnGatewayRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest} TestIamPermissionsVpnGatewayRequest instance
                         */
                        TestIamPermissionsVpnGatewayRequest.create = function create(properties) {
                            return new TestIamPermissionsVpnGatewayRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsVpnGatewayRequest message. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsVpnGatewayRequest} message TestIamPermissionsVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsVpnGatewayRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                writer.uint32(/* id 195806222, wireType 2 =*/1566449778).string(message.resource);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.testPermissionsRequestResource != null && Object.hasOwnProperty.call(message, "testPermissionsRequestResource"))
                                $root.google.cloud.compute.v1.TestPermissionsRequest.encode(message.testPermissionsRequestResource, writer.uint32(/* id 439214758, wireType 2 =*/3513718066).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestIamPermissionsVpnGatewayRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestIamPermissionsVpnGatewayRequest} message TestIamPermissionsVpnGatewayRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestIamPermissionsVpnGatewayRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestIamPermissionsVpnGatewayRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest} TestIamPermissionsVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsVpnGatewayRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = reader.string();
                                        break;
                                    }
                                case 439214758: {
                                        message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestIamPermissionsVpnGatewayRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest} TestIamPermissionsVpnGatewayRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestIamPermissionsVpnGatewayRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestIamPermissionsVpnGatewayRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestIamPermissionsVpnGatewayRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                if (!$util.isString(message.resource))
                                    return "resource: string expected";
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource")) {
                                var error = $root.google.cloud.compute.v1.TestPermissionsRequest.verify(message.testPermissionsRequestResource);
                                if (error)
                                    return "testPermissionsRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TestIamPermissionsVpnGatewayRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest} TestIamPermissionsVpnGatewayRequest
                         */
                        TestIamPermissionsVpnGatewayRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.resource != null)
                                message.resource = String(object.resource);
                            if (object.testPermissionsRequestResource != null) {
                                if (typeof object.testPermissionsRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest.testPermissionsRequestResource: object expected");
                                message.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.fromObject(object.testPermissionsRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestIamPermissionsVpnGatewayRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest} message TestIamPermissionsVpnGatewayRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestIamPermissionsVpnGatewayRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.resource = "";
                                object.project = "";
                                object.testPermissionsRequestResource = null;
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.resource != null && message.hasOwnProperty("resource"))
                                object.resource = message.resource;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.testPermissionsRequestResource != null && message.hasOwnProperty("testPermissionsRequestResource"))
                                object.testPermissionsRequestResource = $root.google.cloud.compute.v1.TestPermissionsRequest.toObject(message.testPermissionsRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this TestIamPermissionsVpnGatewayRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestIamPermissionsVpnGatewayRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestIamPermissionsVpnGatewayRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestIamPermissionsVpnGatewayRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest";
                        };
    
                        return TestIamPermissionsVpnGatewayRequest;
                    })();
    
                    v1.TestPermissionsRequest = (function() {
    
                        /**
                         * Properties of a TestPermissionsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestPermissionsRequest
                         * @property {Array.<string>|null} [permissions] TestPermissionsRequest permissions
                         */
    
                        /**
                         * Constructs a new TestPermissionsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestPermissionsRequest.
                         * @implements ITestPermissionsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestPermissionsRequest=} [properties] Properties to set
                         */
                        function TestPermissionsRequest(properties) {
                            this.permissions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestPermissionsRequest permissions.
                         * @member {Array.<string>} permissions
                         * @memberof google.cloud.compute.v1.TestPermissionsRequest
                         * @instance
                         */
                        TestPermissionsRequest.prototype.permissions = $util.emptyArray;
    
                        /**
                         * Creates a new TestPermissionsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestPermissionsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestPermissionsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestPermissionsRequest} TestPermissionsRequest instance
                         */
                        TestPermissionsRequest.create = function create(properties) {
                            return new TestPermissionsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified TestPermissionsRequest message. Does not implicitly {@link google.cloud.compute.v1.TestPermissionsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestPermissionsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestPermissionsRequest} message TestPermissionsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestPermissionsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.permissions != null && message.permissions.length)
                                for (var i = 0; i < message.permissions.length; ++i)
                                    writer.uint32(/* id 59962500, wireType 2 =*/479700002).string(message.permissions[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestPermissionsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestPermissionsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestPermissionsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ITestPermissionsRequest} message TestPermissionsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestPermissionsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestPermissionsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestPermissionsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestPermissionsRequest} TestPermissionsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestPermissionsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestPermissionsRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 59962500: {
                                        if (!(message.permissions && message.permissions.length))
                                            message.permissions = [];
                                        message.permissions.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestPermissionsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestPermissionsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestPermissionsRequest} TestPermissionsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestPermissionsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestPermissionsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestPermissionsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestPermissionsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.permissions != null && message.hasOwnProperty("permissions")) {
                                if (!Array.isArray(message.permissions))
                                    return "permissions: array expected";
                                for (var i = 0; i < message.permissions.length; ++i)
                                    if (!$util.isString(message.permissions[i]))
                                        return "permissions: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TestPermissionsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestPermissionsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestPermissionsRequest} TestPermissionsRequest
                         */
                        TestPermissionsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestPermissionsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestPermissionsRequest();
                            if (object.permissions) {
                                if (!Array.isArray(object.permissions))
                                    throw TypeError(".google.cloud.compute.v1.TestPermissionsRequest.permissions: array expected");
                                message.permissions = [];
                                for (var i = 0; i < object.permissions.length; ++i)
                                    message.permissions[i] = String(object.permissions[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestPermissionsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestPermissionsRequest
                         * @static
                         * @param {google.cloud.compute.v1.TestPermissionsRequest} message TestPermissionsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestPermissionsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.permissions = [];
                            if (message.permissions && message.permissions.length) {
                                object.permissions = [];
                                for (var j = 0; j < message.permissions.length; ++j)
                                    object.permissions[j] = message.permissions[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TestPermissionsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestPermissionsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestPermissionsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestPermissionsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestPermissionsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestPermissionsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestPermissionsRequest";
                        };
    
                        return TestPermissionsRequest;
                    })();
    
                    v1.TestPermissionsResponse = (function() {
    
                        /**
                         * Properties of a TestPermissionsResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface ITestPermissionsResponse
                         * @property {Array.<string>|null} [permissions] TestPermissionsResponse permissions
                         */
    
                        /**
                         * Constructs a new TestPermissionsResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TestPermissionsResponse.
                         * @implements ITestPermissionsResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.ITestPermissionsResponse=} [properties] Properties to set
                         */
                        function TestPermissionsResponse(properties) {
                            this.permissions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * TestPermissionsResponse permissions.
                         * @member {Array.<string>} permissions
                         * @memberof google.cloud.compute.v1.TestPermissionsResponse
                         * @instance
                         */
                        TestPermissionsResponse.prototype.permissions = $util.emptyArray;
    
                        /**
                         * Creates a new TestPermissionsResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.TestPermissionsResponse
                         * @static
                         * @param {google.cloud.compute.v1.ITestPermissionsResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.TestPermissionsResponse} TestPermissionsResponse instance
                         */
                        TestPermissionsResponse.create = function create(properties) {
                            return new TestPermissionsResponse(properties);
                        };
    
                        /**
                         * Encodes the specified TestPermissionsResponse message. Does not implicitly {@link google.cloud.compute.v1.TestPermissionsResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.TestPermissionsResponse
                         * @static
                         * @param {google.cloud.compute.v1.ITestPermissionsResponse} message TestPermissionsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestPermissionsResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.permissions != null && message.permissions.length)
                                for (var i = 0; i < message.permissions.length; ++i)
                                    writer.uint32(/* id 59962500, wireType 2 =*/479700002).string(message.permissions[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified TestPermissionsResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.TestPermissionsResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.TestPermissionsResponse
                         * @static
                         * @param {google.cloud.compute.v1.ITestPermissionsResponse} message TestPermissionsResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        TestPermissionsResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a TestPermissionsResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.TestPermissionsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.TestPermissionsResponse} TestPermissionsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestPermissionsResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.TestPermissionsResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 59962500: {
                                        if (!(message.permissions && message.permissions.length))
                                            message.permissions = [];
                                        message.permissions.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a TestPermissionsResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.TestPermissionsResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.TestPermissionsResponse} TestPermissionsResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        TestPermissionsResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a TestPermissionsResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.TestPermissionsResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        TestPermissionsResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.permissions != null && message.hasOwnProperty("permissions")) {
                                if (!Array.isArray(message.permissions))
                                    return "permissions: array expected";
                                for (var i = 0; i < message.permissions.length; ++i)
                                    if (!$util.isString(message.permissions[i]))
                                        return "permissions: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a TestPermissionsResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.TestPermissionsResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.TestPermissionsResponse} TestPermissionsResponse
                         */
                        TestPermissionsResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.TestPermissionsResponse)
                                return object;
                            var message = new $root.google.cloud.compute.v1.TestPermissionsResponse();
                            if (object.permissions) {
                                if (!Array.isArray(object.permissions))
                                    throw TypeError(".google.cloud.compute.v1.TestPermissionsResponse.permissions: array expected");
                                message.permissions = [];
                                for (var i = 0; i < object.permissions.length; ++i)
                                    message.permissions[i] = String(object.permissions[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a TestPermissionsResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.TestPermissionsResponse
                         * @static
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} message TestPermissionsResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        TestPermissionsResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.permissions = [];
                            if (message.permissions && message.permissions.length) {
                                object.permissions = [];
                                for (var j = 0; j < message.permissions.length; ++j)
                                    object.permissions[j] = message.permissions[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this TestPermissionsResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.TestPermissionsResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        TestPermissionsResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for TestPermissionsResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.TestPermissionsResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        TestPermissionsResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.TestPermissionsResponse";
                        };
    
                        return TestPermissionsResponse;
                    })();
    
                    v1.Uint128 = (function() {
    
                        /**
                         * Properties of an Uint128.
                         * @memberof google.cloud.compute.v1
                         * @interface IUint128
                         * @property {number|Long|null} [high] Uint128 high
                         * @property {number|Long|null} [low] Uint128 low
                         */
    
                        /**
                         * Constructs a new Uint128.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an Uint128.
                         * @implements IUint128
                         * @constructor
                         * @param {google.cloud.compute.v1.IUint128=} [properties] Properties to set
                         */
                        function Uint128(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Uint128 high.
                         * @member {number|Long|null|undefined} high
                         * @memberof google.cloud.compute.v1.Uint128
                         * @instance
                         */
                        Uint128.prototype.high = null;
    
                        /**
                         * Uint128 low.
                         * @member {number|Long|null|undefined} low
                         * @memberof google.cloud.compute.v1.Uint128
                         * @instance
                         */
                        Uint128.prototype.low = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Uint128 _high.
                         * @member {"high"|undefined} _high
                         * @memberof google.cloud.compute.v1.Uint128
                         * @instance
                         */
                        Object.defineProperty(Uint128.prototype, "_high", {
                            get: $util.oneOfGetter($oneOfFields = ["high"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Uint128 _low.
                         * @member {"low"|undefined} _low
                         * @memberof google.cloud.compute.v1.Uint128
                         * @instance
                         */
                        Object.defineProperty(Uint128.prototype, "_low", {
                            get: $util.oneOfGetter($oneOfFields = ["low"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Uint128 instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Uint128
                         * @static
                         * @param {google.cloud.compute.v1.IUint128=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Uint128} Uint128 instance
                         */
                        Uint128.create = function create(properties) {
                            return new Uint128(properties);
                        };
    
                        /**
                         * Encodes the specified Uint128 message. Does not implicitly {@link google.cloud.compute.v1.Uint128.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Uint128
                         * @static
                         * @param {google.cloud.compute.v1.IUint128} message Uint128 message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Uint128.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.low != null && Object.hasOwnProperty.call(message, "low"))
                                writer.uint32(/* id 107348, wireType 0 =*/858784).uint64(message.low);
                            if (message.high != null && Object.hasOwnProperty.call(message, "high"))
                                writer.uint32(/* id 3202466, wireType 0 =*/25619728).uint64(message.high);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Uint128 message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Uint128.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Uint128
                         * @static
                         * @param {google.cloud.compute.v1.IUint128} message Uint128 message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Uint128.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Uint128 message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Uint128
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Uint128} Uint128
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Uint128.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Uint128();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3202466: {
                                        message.high = reader.uint64();
                                        break;
                                    }
                                case 107348: {
                                        message.low = reader.uint64();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Uint128 message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Uint128
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Uint128} Uint128
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Uint128.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Uint128 message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Uint128
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Uint128.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.high != null && message.hasOwnProperty("high")) {
                                properties._high = 1;
                                if (!$util.isInteger(message.high) && !(message.high && $util.isInteger(message.high.low) && $util.isInteger(message.high.high)))
                                    return "high: integer|Long expected";
                            }
                            if (message.low != null && message.hasOwnProperty("low")) {
                                properties._low = 1;
                                if (!$util.isInteger(message.low) && !(message.low && $util.isInteger(message.low.low) && $util.isInteger(message.low.high)))
                                    return "low: integer|Long expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an Uint128 message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Uint128
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Uint128} Uint128
                         */
                        Uint128.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Uint128)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Uint128();
                            if (object.high != null)
                                if ($util.Long)
                                    (message.high = $util.Long.fromValue(object.high)).unsigned = true;
                                else if (typeof object.high === "string")
                                    message.high = parseInt(object.high, 10);
                                else if (typeof object.high === "number")
                                    message.high = object.high;
                                else if (typeof object.high === "object")
                                    message.high = new $util.LongBits(object.high.low >>> 0, object.high.high >>> 0).toNumber(true);
                            if (object.low != null)
                                if ($util.Long)
                                    (message.low = $util.Long.fromValue(object.low)).unsigned = true;
                                else if (typeof object.low === "string")
                                    message.low = parseInt(object.low, 10);
                                else if (typeof object.low === "number")
                                    message.low = object.low;
                                else if (typeof object.low === "object")
                                    message.low = new $util.LongBits(object.low.low >>> 0, object.low.high >>> 0).toNumber(true);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Uint128 message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Uint128
                         * @static
                         * @param {google.cloud.compute.v1.Uint128} message Uint128
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Uint128.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.low != null && message.hasOwnProperty("low")) {
                                if (typeof message.low === "number")
                                    object.low = options.longs === String ? String(message.low) : message.low;
                                else
                                    object.low = options.longs === String ? $util.Long.prototype.toString.call(message.low) : options.longs === Number ? new $util.LongBits(message.low.low >>> 0, message.low.high >>> 0).toNumber(true) : message.low;
                                if (options.oneofs)
                                    object._low = "low";
                            }
                            if (message.high != null && message.hasOwnProperty("high")) {
                                if (typeof message.high === "number")
                                    object.high = options.longs === String ? String(message.high) : message.high;
                                else
                                    object.high = options.longs === String ? $util.Long.prototype.toString.call(message.high) : options.longs === Number ? new $util.LongBits(message.high.low >>> 0, message.high.high >>> 0).toNumber(true) : message.high;
                                if (options.oneofs)
                                    object._high = "high";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Uint128 to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Uint128
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Uint128.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Uint128
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Uint128
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Uint128.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Uint128";
                        };
    
                        return Uint128;
                    })();
    
                    v1.UpdateAccessConfigInstanceRequest = (function() {
    
                        /**
                         * Properties of an UpdateAccessConfigInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdateAccessConfigInstanceRequest
                         * @property {google.cloud.compute.v1.IAccessConfig|null} [accessConfigResource] UpdateAccessConfigInstanceRequest accessConfigResource
                         * @property {string|null} [instance] UpdateAccessConfigInstanceRequest instance
                         * @property {string|null} [networkInterface] UpdateAccessConfigInstanceRequest networkInterface
                         * @property {string|null} [project] UpdateAccessConfigInstanceRequest project
                         * @property {string|null} [requestId] UpdateAccessConfigInstanceRequest requestId
                         * @property {string|null} [zone] UpdateAccessConfigInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new UpdateAccessConfigInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdateAccessConfigInstanceRequest.
                         * @implements IUpdateAccessConfigInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdateAccessConfigInstanceRequest=} [properties] Properties to set
                         */
                        function UpdateAccessConfigInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateAccessConfigInstanceRequest accessConfigResource.
                         * @member {google.cloud.compute.v1.IAccessConfig|null|undefined} accessConfigResource
                         * @memberof google.cloud.compute.v1.UpdateAccessConfigInstanceRequest
                         * @instance
                         */
                        UpdateAccessConfigInstanceRequest.prototype.accessConfigResource = null;
    
                        /**
                         * UpdateAccessConfigInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.UpdateAccessConfigInstanceRequest
                         * @instance
                         */
                        UpdateAccessConfigInstanceRequest.prototype.instance = "";
    
                        /**
                         * UpdateAccessConfigInstanceRequest networkInterface.
                         * @member {string} networkInterface
                         * @memberof google.cloud.compute.v1.UpdateAccessConfigInstanceRequest
                         * @instance
                         */
                        UpdateAccessConfigInstanceRequest.prototype.networkInterface = "";
    
                        /**
                         * UpdateAccessConfigInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdateAccessConfigInstanceRequest
                         * @instance
                         */
                        UpdateAccessConfigInstanceRequest.prototype.project = "";
    
                        /**
                         * UpdateAccessConfigInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdateAccessConfigInstanceRequest
                         * @instance
                         */
                        UpdateAccessConfigInstanceRequest.prototype.requestId = null;
    
                        /**
                         * UpdateAccessConfigInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.UpdateAccessConfigInstanceRequest
                         * @instance
                         */
                        UpdateAccessConfigInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdateAccessConfigInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdateAccessConfigInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateAccessConfigInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdateAccessConfigInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdateAccessConfigInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateAccessConfigInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdateAccessConfigInstanceRequest} UpdateAccessConfigInstanceRequest instance
                         */
                        UpdateAccessConfigInstanceRequest.create = function create(properties) {
                            return new UpdateAccessConfigInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateAccessConfigInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdateAccessConfigInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdateAccessConfigInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateAccessConfigInstanceRequest} message UpdateAccessConfigInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateAccessConfigInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.networkInterface != null && Object.hasOwnProperty.call(message, "networkInterface"))
                                writer.uint32(/* id 365387880, wireType 2 =*/2923103042).string(message.networkInterface);
                            if (message.accessConfigResource != null && Object.hasOwnProperty.call(message, "accessConfigResource"))
                                $root.google.cloud.compute.v1.AccessConfig.encode(message.accessConfigResource, writer.uint32(/* id 387825552, wireType 2 =*/3102604418).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateAccessConfigInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdateAccessConfigInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateAccessConfigInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateAccessConfigInstanceRequest} message UpdateAccessConfigInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateAccessConfigInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateAccessConfigInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdateAccessConfigInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdateAccessConfigInstanceRequest} UpdateAccessConfigInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateAccessConfigInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdateAccessConfigInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 387825552: {
                                        message.accessConfigResource = $root.google.cloud.compute.v1.AccessConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 365387880: {
                                        message.networkInterface = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateAccessConfigInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateAccessConfigInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdateAccessConfigInstanceRequest} UpdateAccessConfigInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateAccessConfigInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateAccessConfigInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdateAccessConfigInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateAccessConfigInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.accessConfigResource != null && message.hasOwnProperty("accessConfigResource")) {
                                var error = $root.google.cloud.compute.v1.AccessConfig.verify(message.accessConfigResource);
                                if (error)
                                    return "accessConfigResource." + error;
                            }
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.networkInterface != null && message.hasOwnProperty("networkInterface"))
                                if (!$util.isString(message.networkInterface))
                                    return "networkInterface: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an UpdateAccessConfigInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdateAccessConfigInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdateAccessConfigInstanceRequest} UpdateAccessConfigInstanceRequest
                         */
                        UpdateAccessConfigInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdateAccessConfigInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdateAccessConfigInstanceRequest();
                            if (object.accessConfigResource != null) {
                                if (typeof object.accessConfigResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdateAccessConfigInstanceRequest.accessConfigResource: object expected");
                                message.accessConfigResource = $root.google.cloud.compute.v1.AccessConfig.fromObject(object.accessConfigResource);
                            }
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.networkInterface != null)
                                message.networkInterface = String(object.networkInterface);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateAccessConfigInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdateAccessConfigInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdateAccessConfigInstanceRequest} message UpdateAccessConfigInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateAccessConfigInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                                object.networkInterface = "";
                                object.accessConfigResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.networkInterface != null && message.hasOwnProperty("networkInterface"))
                                object.networkInterface = message.networkInterface;
                            if (message.accessConfigResource != null && message.hasOwnProperty("accessConfigResource"))
                                object.accessConfigResource = $root.google.cloud.compute.v1.AccessConfig.toObject(message.accessConfigResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateAccessConfigInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdateAccessConfigInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateAccessConfigInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateAccessConfigInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdateAccessConfigInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateAccessConfigInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdateAccessConfigInstanceRequest";
                        };
    
                        return UpdateAccessConfigInstanceRequest;
                    })();
    
                    v1.UpdateAutoscalerRequest = (function() {
    
                        /**
                         * Properties of an UpdateAutoscalerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdateAutoscalerRequest
                         * @property {string|null} [autoscaler] UpdateAutoscalerRequest autoscaler
                         * @property {google.cloud.compute.v1.IAutoscaler|null} [autoscalerResource] UpdateAutoscalerRequest autoscalerResource
                         * @property {string|null} [project] UpdateAutoscalerRequest project
                         * @property {string|null} [requestId] UpdateAutoscalerRequest requestId
                         * @property {string|null} [zone] UpdateAutoscalerRequest zone
                         */
    
                        /**
                         * Constructs a new UpdateAutoscalerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdateAutoscalerRequest.
                         * @implements IUpdateAutoscalerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdateAutoscalerRequest=} [properties] Properties to set
                         */
                        function UpdateAutoscalerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateAutoscalerRequest autoscaler.
                         * @member {string|null|undefined} autoscaler
                         * @memberof google.cloud.compute.v1.UpdateAutoscalerRequest
                         * @instance
                         */
                        UpdateAutoscalerRequest.prototype.autoscaler = null;
    
                        /**
                         * UpdateAutoscalerRequest autoscalerResource.
                         * @member {google.cloud.compute.v1.IAutoscaler|null|undefined} autoscalerResource
                         * @memberof google.cloud.compute.v1.UpdateAutoscalerRequest
                         * @instance
                         */
                        UpdateAutoscalerRequest.prototype.autoscalerResource = null;
    
                        /**
                         * UpdateAutoscalerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdateAutoscalerRequest
                         * @instance
                         */
                        UpdateAutoscalerRequest.prototype.project = "";
    
                        /**
                         * UpdateAutoscalerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdateAutoscalerRequest
                         * @instance
                         */
                        UpdateAutoscalerRequest.prototype.requestId = null;
    
                        /**
                         * UpdateAutoscalerRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.UpdateAutoscalerRequest
                         * @instance
                         */
                        UpdateAutoscalerRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdateAutoscalerRequest _autoscaler.
                         * @member {"autoscaler"|undefined} _autoscaler
                         * @memberof google.cloud.compute.v1.UpdateAutoscalerRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateAutoscalerRequest.prototype, "_autoscaler", {
                            get: $util.oneOfGetter($oneOfFields = ["autoscaler"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UpdateAutoscalerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdateAutoscalerRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateAutoscalerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdateAutoscalerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdateAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateAutoscalerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdateAutoscalerRequest} UpdateAutoscalerRequest instance
                         */
                        UpdateAutoscalerRequest.create = function create(properties) {
                            return new UpdateAutoscalerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateAutoscalerRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdateAutoscalerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdateAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateAutoscalerRequest} message UpdateAutoscalerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateAutoscalerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.autoscalerResource != null && Object.hasOwnProperty.call(message, "autoscalerResource"))
                                $root.google.cloud.compute.v1.Autoscaler.encode(message.autoscalerResource, writer.uint32(/* id 207616118, wireType 2 =*/1660928946).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.autoscaler != null && Object.hasOwnProperty.call(message, "autoscaler"))
                                writer.uint32(/* id 517258967, wireType 2 =*/4138071738).string(message.autoscaler);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateAutoscalerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdateAutoscalerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateAutoscalerRequest} message UpdateAutoscalerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateAutoscalerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateAutoscalerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdateAutoscalerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdateAutoscalerRequest} UpdateAutoscalerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateAutoscalerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdateAutoscalerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 517258967: {
                                        message.autoscaler = reader.string();
                                        break;
                                    }
                                case 207616118: {
                                        message.autoscalerResource = $root.google.cloud.compute.v1.Autoscaler.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateAutoscalerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateAutoscalerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdateAutoscalerRequest} UpdateAutoscalerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateAutoscalerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateAutoscalerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdateAutoscalerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateAutoscalerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoscaler != null && message.hasOwnProperty("autoscaler")) {
                                properties._autoscaler = 1;
                                if (!$util.isString(message.autoscaler))
                                    return "autoscaler: string expected";
                            }
                            if (message.autoscalerResource != null && message.hasOwnProperty("autoscalerResource")) {
                                var error = $root.google.cloud.compute.v1.Autoscaler.verify(message.autoscalerResource);
                                if (error)
                                    return "autoscalerResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an UpdateAutoscalerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdateAutoscalerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdateAutoscalerRequest} UpdateAutoscalerRequest
                         */
                        UpdateAutoscalerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdateAutoscalerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdateAutoscalerRequest();
                            if (object.autoscaler != null)
                                message.autoscaler = String(object.autoscaler);
                            if (object.autoscalerResource != null) {
                                if (typeof object.autoscalerResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdateAutoscalerRequest.autoscalerResource: object expected");
                                message.autoscalerResource = $root.google.cloud.compute.v1.Autoscaler.fromObject(object.autoscalerResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateAutoscalerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdateAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdateAutoscalerRequest} message UpdateAutoscalerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateAutoscalerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.autoscalerResource = null;
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.autoscalerResource != null && message.hasOwnProperty("autoscalerResource"))
                                object.autoscalerResource = $root.google.cloud.compute.v1.Autoscaler.toObject(message.autoscalerResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.autoscaler != null && message.hasOwnProperty("autoscaler")) {
                                object.autoscaler = message.autoscaler;
                                if (options.oneofs)
                                    object._autoscaler = "autoscaler";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UpdateAutoscalerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdateAutoscalerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateAutoscalerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateAutoscalerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdateAutoscalerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateAutoscalerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdateAutoscalerRequest";
                        };
    
                        return UpdateAutoscalerRequest;
                    })();
    
                    v1.UpdateBackendBucketRequest = (function() {
    
                        /**
                         * Properties of an UpdateBackendBucketRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdateBackendBucketRequest
                         * @property {string|null} [backendBucket] UpdateBackendBucketRequest backendBucket
                         * @property {google.cloud.compute.v1.IBackendBucket|null} [backendBucketResource] UpdateBackendBucketRequest backendBucketResource
                         * @property {string|null} [project] UpdateBackendBucketRequest project
                         * @property {string|null} [requestId] UpdateBackendBucketRequest requestId
                         */
    
                        /**
                         * Constructs a new UpdateBackendBucketRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdateBackendBucketRequest.
                         * @implements IUpdateBackendBucketRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdateBackendBucketRequest=} [properties] Properties to set
                         */
                        function UpdateBackendBucketRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateBackendBucketRequest backendBucket.
                         * @member {string} backendBucket
                         * @memberof google.cloud.compute.v1.UpdateBackendBucketRequest
                         * @instance
                         */
                        UpdateBackendBucketRequest.prototype.backendBucket = "";
    
                        /**
                         * UpdateBackendBucketRequest backendBucketResource.
                         * @member {google.cloud.compute.v1.IBackendBucket|null|undefined} backendBucketResource
                         * @memberof google.cloud.compute.v1.UpdateBackendBucketRequest
                         * @instance
                         */
                        UpdateBackendBucketRequest.prototype.backendBucketResource = null;
    
                        /**
                         * UpdateBackendBucketRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdateBackendBucketRequest
                         * @instance
                         */
                        UpdateBackendBucketRequest.prototype.project = "";
    
                        /**
                         * UpdateBackendBucketRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdateBackendBucketRequest
                         * @instance
                         */
                        UpdateBackendBucketRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdateBackendBucketRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdateBackendBucketRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateBackendBucketRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdateBackendBucketRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdateBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateBackendBucketRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdateBackendBucketRequest} UpdateBackendBucketRequest instance
                         */
                        UpdateBackendBucketRequest.create = function create(properties) {
                            return new UpdateBackendBucketRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateBackendBucketRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdateBackendBucketRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdateBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateBackendBucketRequest} message UpdateBackendBucketRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateBackendBucketRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.backendBucket != null && Object.hasOwnProperty.call(message, "backendBucket"))
                                writer.uint32(/* id 91714037, wireType 2 =*/733712298).string(message.backendBucket);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.backendBucketResource != null && Object.hasOwnProperty.call(message, "backendBucketResource"))
                                $root.google.cloud.compute.v1.BackendBucket.encode(message.backendBucketResource, writer.uint32(/* id 380757784, wireType 2 =*/3046062274).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateBackendBucketRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdateBackendBucketRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateBackendBucketRequest} message UpdateBackendBucketRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateBackendBucketRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateBackendBucketRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdateBackendBucketRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdateBackendBucketRequest} UpdateBackendBucketRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateBackendBucketRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdateBackendBucketRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 91714037: {
                                        message.backendBucket = reader.string();
                                        break;
                                    }
                                case 380757784: {
                                        message.backendBucketResource = $root.google.cloud.compute.v1.BackendBucket.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateBackendBucketRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateBackendBucketRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdateBackendBucketRequest} UpdateBackendBucketRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateBackendBucketRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateBackendBucketRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdateBackendBucketRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateBackendBucketRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendBucket != null && message.hasOwnProperty("backendBucket"))
                                if (!$util.isString(message.backendBucket))
                                    return "backendBucket: string expected";
                            if (message.backendBucketResource != null && message.hasOwnProperty("backendBucketResource")) {
                                var error = $root.google.cloud.compute.v1.BackendBucket.verify(message.backendBucketResource);
                                if (error)
                                    return "backendBucketResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateBackendBucketRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdateBackendBucketRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdateBackendBucketRequest} UpdateBackendBucketRequest
                         */
                        UpdateBackendBucketRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdateBackendBucketRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdateBackendBucketRequest();
                            if (object.backendBucket != null)
                                message.backendBucket = String(object.backendBucket);
                            if (object.backendBucketResource != null) {
                                if (typeof object.backendBucketResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdateBackendBucketRequest.backendBucketResource: object expected");
                                message.backendBucketResource = $root.google.cloud.compute.v1.BackendBucket.fromObject(object.backendBucketResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateBackendBucketRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdateBackendBucketRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdateBackendBucketRequest} message UpdateBackendBucketRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateBackendBucketRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.backendBucket = "";
                                object.project = "";
                                object.backendBucketResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.backendBucket != null && message.hasOwnProperty("backendBucket"))
                                object.backendBucket = message.backendBucket;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.backendBucketResource != null && message.hasOwnProperty("backendBucketResource"))
                                object.backendBucketResource = $root.google.cloud.compute.v1.BackendBucket.toObject(message.backendBucketResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateBackendBucketRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdateBackendBucketRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateBackendBucketRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateBackendBucketRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdateBackendBucketRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateBackendBucketRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdateBackendBucketRequest";
                        };
    
                        return UpdateBackendBucketRequest;
                    })();
    
                    v1.UpdateBackendServiceRequest = (function() {
    
                        /**
                         * Properties of an UpdateBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdateBackendServiceRequest
                         * @property {string|null} [backendService] UpdateBackendServiceRequest backendService
                         * @property {google.cloud.compute.v1.IBackendService|null} [backendServiceResource] UpdateBackendServiceRequest backendServiceResource
                         * @property {string|null} [project] UpdateBackendServiceRequest project
                         * @property {string|null} [requestId] UpdateBackendServiceRequest requestId
                         */
    
                        /**
                         * Constructs a new UpdateBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdateBackendServiceRequest.
                         * @implements IUpdateBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdateBackendServiceRequest=} [properties] Properties to set
                         */
                        function UpdateBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateBackendServiceRequest backendService.
                         * @member {string} backendService
                         * @memberof google.cloud.compute.v1.UpdateBackendServiceRequest
                         * @instance
                         */
                        UpdateBackendServiceRequest.prototype.backendService = "";
    
                        /**
                         * UpdateBackendServiceRequest backendServiceResource.
                         * @member {google.cloud.compute.v1.IBackendService|null|undefined} backendServiceResource
                         * @memberof google.cloud.compute.v1.UpdateBackendServiceRequest
                         * @instance
                         */
                        UpdateBackendServiceRequest.prototype.backendServiceResource = null;
    
                        /**
                         * UpdateBackendServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdateBackendServiceRequest
                         * @instance
                         */
                        UpdateBackendServiceRequest.prototype.project = "";
    
                        /**
                         * UpdateBackendServiceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdateBackendServiceRequest
                         * @instance
                         */
                        UpdateBackendServiceRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdateBackendServiceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdateBackendServiceRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateBackendServiceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdateBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdateBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdateBackendServiceRequest} UpdateBackendServiceRequest instance
                         */
                        UpdateBackendServiceRequest.create = function create(properties) {
                            return new UpdateBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdateBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdateBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateBackendServiceRequest} message UpdateBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.backendService != null && Object.hasOwnProperty.call(message, "backendService"))
                                writer.uint32(/* id 306946058, wireType 2 =*/2455568466).string(message.backendService);
                            if (message.backendServiceResource != null && Object.hasOwnProperty.call(message, "backendServiceResource"))
                                $root.google.cloud.compute.v1.BackendService.encode(message.backendServiceResource, writer.uint32(/* id 347586723, wireType 2 =*/2780693786).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdateBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateBackendServiceRequest} message UpdateBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdateBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdateBackendServiceRequest} UpdateBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdateBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 306946058: {
                                        message.backendService = reader.string();
                                        break;
                                    }
                                case 347586723: {
                                        message.backendServiceResource = $root.google.cloud.compute.v1.BackendService.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdateBackendServiceRequest} UpdateBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdateBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                if (!$util.isString(message.backendService))
                                    return "backendService: string expected";
                            if (message.backendServiceResource != null && message.hasOwnProperty("backendServiceResource")) {
                                var error = $root.google.cloud.compute.v1.BackendService.verify(message.backendServiceResource);
                                if (error)
                                    return "backendServiceResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdateBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdateBackendServiceRequest} UpdateBackendServiceRequest
                         */
                        UpdateBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdateBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdateBackendServiceRequest();
                            if (object.backendService != null)
                                message.backendService = String(object.backendService);
                            if (object.backendServiceResource != null) {
                                if (typeof object.backendServiceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdateBackendServiceRequest.backendServiceResource: object expected");
                                message.backendServiceResource = $root.google.cloud.compute.v1.BackendService.fromObject(object.backendServiceResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdateBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdateBackendServiceRequest} message UpdateBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.backendService = "";
                                object.backendServiceResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                object.backendService = message.backendService;
                            if (message.backendServiceResource != null && message.hasOwnProperty("backendServiceResource"))
                                object.backendServiceResource = $root.google.cloud.compute.v1.BackendService.toObject(message.backendServiceResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdateBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdateBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdateBackendServiceRequest";
                        };
    
                        return UpdateBackendServiceRequest;
                    })();
    
                    v1.UpdateDisplayDeviceInstanceRequest = (function() {
    
                        /**
                         * Properties of an UpdateDisplayDeviceInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdateDisplayDeviceInstanceRequest
                         * @property {google.cloud.compute.v1.IDisplayDevice|null} [displayDeviceResource] UpdateDisplayDeviceInstanceRequest displayDeviceResource
                         * @property {string|null} [instance] UpdateDisplayDeviceInstanceRequest instance
                         * @property {string|null} [project] UpdateDisplayDeviceInstanceRequest project
                         * @property {string|null} [requestId] UpdateDisplayDeviceInstanceRequest requestId
                         * @property {string|null} [zone] UpdateDisplayDeviceInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new UpdateDisplayDeviceInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdateDisplayDeviceInstanceRequest.
                         * @implements IUpdateDisplayDeviceInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdateDisplayDeviceInstanceRequest=} [properties] Properties to set
                         */
                        function UpdateDisplayDeviceInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateDisplayDeviceInstanceRequest displayDeviceResource.
                         * @member {google.cloud.compute.v1.IDisplayDevice|null|undefined} displayDeviceResource
                         * @memberof google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest
                         * @instance
                         */
                        UpdateDisplayDeviceInstanceRequest.prototype.displayDeviceResource = null;
    
                        /**
                         * UpdateDisplayDeviceInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest
                         * @instance
                         */
                        UpdateDisplayDeviceInstanceRequest.prototype.instance = "";
    
                        /**
                         * UpdateDisplayDeviceInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest
                         * @instance
                         */
                        UpdateDisplayDeviceInstanceRequest.prototype.project = "";
    
                        /**
                         * UpdateDisplayDeviceInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest
                         * @instance
                         */
                        UpdateDisplayDeviceInstanceRequest.prototype.requestId = null;
    
                        /**
                         * UpdateDisplayDeviceInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest
                         * @instance
                         */
                        UpdateDisplayDeviceInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdateDisplayDeviceInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateDisplayDeviceInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdateDisplayDeviceInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateDisplayDeviceInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest} UpdateDisplayDeviceInstanceRequest instance
                         */
                        UpdateDisplayDeviceInstanceRequest.create = function create(properties) {
                            return new UpdateDisplayDeviceInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateDisplayDeviceInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateDisplayDeviceInstanceRequest} message UpdateDisplayDeviceInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateDisplayDeviceInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.displayDeviceResource != null && Object.hasOwnProperty.call(message, "displayDeviceResource"))
                                $root.google.cloud.compute.v1.DisplayDevice.encode(message.displayDeviceResource, writer.uint32(/* id 289686106, wireType 2 =*/2317488850).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateDisplayDeviceInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateDisplayDeviceInstanceRequest} message UpdateDisplayDeviceInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateDisplayDeviceInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateDisplayDeviceInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest} UpdateDisplayDeviceInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateDisplayDeviceInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 289686106: {
                                        message.displayDeviceResource = $root.google.cloud.compute.v1.DisplayDevice.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateDisplayDeviceInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest} UpdateDisplayDeviceInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateDisplayDeviceInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateDisplayDeviceInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateDisplayDeviceInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.displayDeviceResource != null && message.hasOwnProperty("displayDeviceResource")) {
                                var error = $root.google.cloud.compute.v1.DisplayDevice.verify(message.displayDeviceResource);
                                if (error)
                                    return "displayDeviceResource." + error;
                            }
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an UpdateDisplayDeviceInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest} UpdateDisplayDeviceInstanceRequest
                         */
                        UpdateDisplayDeviceInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest();
                            if (object.displayDeviceResource != null) {
                                if (typeof object.displayDeviceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest.displayDeviceResource: object expected");
                                message.displayDeviceResource = $root.google.cloud.compute.v1.DisplayDevice.fromObject(object.displayDeviceResource);
                            }
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateDisplayDeviceInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest} message UpdateDisplayDeviceInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateDisplayDeviceInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                                object.displayDeviceResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.displayDeviceResource != null && message.hasOwnProperty("displayDeviceResource"))
                                object.displayDeviceResource = $root.google.cloud.compute.v1.DisplayDevice.toObject(message.displayDeviceResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateDisplayDeviceInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateDisplayDeviceInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateDisplayDeviceInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateDisplayDeviceInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest";
                        };
    
                        return UpdateDisplayDeviceInstanceRequest;
                    })();
    
                    v1.UpdateFirewallRequest = (function() {
    
                        /**
                         * Properties of an UpdateFirewallRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdateFirewallRequest
                         * @property {string|null} [firewall] UpdateFirewallRequest firewall
                         * @property {google.cloud.compute.v1.IFirewall|null} [firewallResource] UpdateFirewallRequest firewallResource
                         * @property {string|null} [project] UpdateFirewallRequest project
                         * @property {string|null} [requestId] UpdateFirewallRequest requestId
                         */
    
                        /**
                         * Constructs a new UpdateFirewallRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdateFirewallRequest.
                         * @implements IUpdateFirewallRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdateFirewallRequest=} [properties] Properties to set
                         */
                        function UpdateFirewallRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateFirewallRequest firewall.
                         * @member {string} firewall
                         * @memberof google.cloud.compute.v1.UpdateFirewallRequest
                         * @instance
                         */
                        UpdateFirewallRequest.prototype.firewall = "";
    
                        /**
                         * UpdateFirewallRequest firewallResource.
                         * @member {google.cloud.compute.v1.IFirewall|null|undefined} firewallResource
                         * @memberof google.cloud.compute.v1.UpdateFirewallRequest
                         * @instance
                         */
                        UpdateFirewallRequest.prototype.firewallResource = null;
    
                        /**
                         * UpdateFirewallRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdateFirewallRequest
                         * @instance
                         */
                        UpdateFirewallRequest.prototype.project = "";
    
                        /**
                         * UpdateFirewallRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdateFirewallRequest
                         * @instance
                         */
                        UpdateFirewallRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdateFirewallRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdateFirewallRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateFirewallRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdateFirewallRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdateFirewallRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateFirewallRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdateFirewallRequest} UpdateFirewallRequest instance
                         */
                        UpdateFirewallRequest.create = function create(properties) {
                            return new UpdateFirewallRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateFirewallRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdateFirewallRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdateFirewallRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateFirewallRequest} message UpdateFirewallRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateFirewallRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.firewallResource != null && Object.hasOwnProperty.call(message, "firewallResource"))
                                $root.google.cloud.compute.v1.Firewall.encode(message.firewallResource, writer.uint32(/* id 41425005, wireType 2 =*/331400042).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.firewall != null && Object.hasOwnProperty.call(message, "firewall"))
                                writer.uint32(/* id 511016192, wireType 2 =*/4088129538).string(message.firewall);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateFirewallRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdateFirewallRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateFirewallRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateFirewallRequest} message UpdateFirewallRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateFirewallRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateFirewallRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdateFirewallRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdateFirewallRequest} UpdateFirewallRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateFirewallRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdateFirewallRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 511016192: {
                                        message.firewall = reader.string();
                                        break;
                                    }
                                case 41425005: {
                                        message.firewallResource = $root.google.cloud.compute.v1.Firewall.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateFirewallRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateFirewallRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdateFirewallRequest} UpdateFirewallRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateFirewallRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateFirewallRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdateFirewallRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateFirewallRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.firewall != null && message.hasOwnProperty("firewall"))
                                if (!$util.isString(message.firewall))
                                    return "firewall: string expected";
                            if (message.firewallResource != null && message.hasOwnProperty("firewallResource")) {
                                var error = $root.google.cloud.compute.v1.Firewall.verify(message.firewallResource);
                                if (error)
                                    return "firewallResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateFirewallRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdateFirewallRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdateFirewallRequest} UpdateFirewallRequest
                         */
                        UpdateFirewallRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdateFirewallRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdateFirewallRequest();
                            if (object.firewall != null)
                                message.firewall = String(object.firewall);
                            if (object.firewallResource != null) {
                                if (typeof object.firewallResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdateFirewallRequest.firewallResource: object expected");
                                message.firewallResource = $root.google.cloud.compute.v1.Firewall.fromObject(object.firewallResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateFirewallRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdateFirewallRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdateFirewallRequest} message UpdateFirewallRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateFirewallRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.firewallResource = null;
                                object.project = "";
                                object.firewall = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.firewallResource != null && message.hasOwnProperty("firewallResource"))
                                object.firewallResource = $root.google.cloud.compute.v1.Firewall.toObject(message.firewallResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.firewall != null && message.hasOwnProperty("firewall"))
                                object.firewall = message.firewall;
                            return object;
                        };
    
                        /**
                         * Converts this UpdateFirewallRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdateFirewallRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateFirewallRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateFirewallRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdateFirewallRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateFirewallRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdateFirewallRequest";
                        };
    
                        return UpdateFirewallRequest;
                    })();
    
                    v1.UpdateHealthCheckRequest = (function() {
    
                        /**
                         * Properties of an UpdateHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdateHealthCheckRequest
                         * @property {string|null} [healthCheck] UpdateHealthCheckRequest healthCheck
                         * @property {google.cloud.compute.v1.IHealthCheck|null} [healthCheckResource] UpdateHealthCheckRequest healthCheckResource
                         * @property {string|null} [project] UpdateHealthCheckRequest project
                         * @property {string|null} [requestId] UpdateHealthCheckRequest requestId
                         */
    
                        /**
                         * Constructs a new UpdateHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdateHealthCheckRequest.
                         * @implements IUpdateHealthCheckRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdateHealthCheckRequest=} [properties] Properties to set
                         */
                        function UpdateHealthCheckRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateHealthCheckRequest healthCheck.
                         * @member {string} healthCheck
                         * @memberof google.cloud.compute.v1.UpdateHealthCheckRequest
                         * @instance
                         */
                        UpdateHealthCheckRequest.prototype.healthCheck = "";
    
                        /**
                         * UpdateHealthCheckRequest healthCheckResource.
                         * @member {google.cloud.compute.v1.IHealthCheck|null|undefined} healthCheckResource
                         * @memberof google.cloud.compute.v1.UpdateHealthCheckRequest
                         * @instance
                         */
                        UpdateHealthCheckRequest.prototype.healthCheckResource = null;
    
                        /**
                         * UpdateHealthCheckRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdateHealthCheckRequest
                         * @instance
                         */
                        UpdateHealthCheckRequest.prototype.project = "";
    
                        /**
                         * UpdateHealthCheckRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdateHealthCheckRequest
                         * @instance
                         */
                        UpdateHealthCheckRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdateHealthCheckRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdateHealthCheckRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateHealthCheckRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdateHealthCheckRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdateHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateHealthCheckRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdateHealthCheckRequest} UpdateHealthCheckRequest instance
                         */
                        UpdateHealthCheckRequest.create = function create(properties) {
                            return new UpdateHealthCheckRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateHealthCheckRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdateHealthCheckRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdateHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateHealthCheckRequest} message UpdateHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateHealthCheckRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.healthCheckResource != null && Object.hasOwnProperty.call(message, "healthCheckResource"))
                                $root.google.cloud.compute.v1.HealthCheck.encode(message.healthCheckResource, writer.uint32(/* id 201925032, wireType 2 =*/1615400258).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.healthCheck != null && Object.hasOwnProperty.call(message, "healthCheck"))
                                writer.uint32(/* id 308876645, wireType 2 =*/2471013162).string(message.healthCheck);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateHealthCheckRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdateHealthCheckRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateHealthCheckRequest} message UpdateHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateHealthCheckRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateHealthCheckRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdateHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdateHealthCheckRequest} UpdateHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateHealthCheckRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdateHealthCheckRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 308876645: {
                                        message.healthCheck = reader.string();
                                        break;
                                    }
                                case 201925032: {
                                        message.healthCheckResource = $root.google.cloud.compute.v1.HealthCheck.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateHealthCheckRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdateHealthCheckRequest} UpdateHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateHealthCheckRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateHealthCheckRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdateHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateHealthCheckRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck"))
                                if (!$util.isString(message.healthCheck))
                                    return "healthCheck: string expected";
                            if (message.healthCheckResource != null && message.hasOwnProperty("healthCheckResource")) {
                                var error = $root.google.cloud.compute.v1.HealthCheck.verify(message.healthCheckResource);
                                if (error)
                                    return "healthCheckResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateHealthCheckRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdateHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdateHealthCheckRequest} UpdateHealthCheckRequest
                         */
                        UpdateHealthCheckRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdateHealthCheckRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdateHealthCheckRequest();
                            if (object.healthCheck != null)
                                message.healthCheck = String(object.healthCheck);
                            if (object.healthCheckResource != null) {
                                if (typeof object.healthCheckResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdateHealthCheckRequest.healthCheckResource: object expected");
                                message.healthCheckResource = $root.google.cloud.compute.v1.HealthCheck.fromObject(object.healthCheckResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateHealthCheckRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdateHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdateHealthCheckRequest} message UpdateHealthCheckRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateHealthCheckRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.healthCheckResource = null;
                                object.project = "";
                                object.healthCheck = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.healthCheckResource != null && message.hasOwnProperty("healthCheckResource"))
                                object.healthCheckResource = $root.google.cloud.compute.v1.HealthCheck.toObject(message.healthCheckResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck"))
                                object.healthCheck = message.healthCheck;
                            return object;
                        };
    
                        /**
                         * Converts this UpdateHealthCheckRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdateHealthCheckRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateHealthCheckRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateHealthCheckRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdateHealthCheckRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateHealthCheckRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdateHealthCheckRequest";
                        };
    
                        return UpdateHealthCheckRequest;
                    })();
    
                    v1.UpdateInstanceRequest = (function() {
    
                        /**
                         * Properties of an UpdateInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdateInstanceRequest
                         * @property {string|null} [instance] UpdateInstanceRequest instance
                         * @property {google.cloud.compute.v1.IInstance|null} [instanceResource] UpdateInstanceRequest instanceResource
                         * @property {string|null} [minimalAction] UpdateInstanceRequest minimalAction
                         * @property {string|null} [mostDisruptiveAllowedAction] UpdateInstanceRequest mostDisruptiveAllowedAction
                         * @property {string|null} [project] UpdateInstanceRequest project
                         * @property {string|null} [requestId] UpdateInstanceRequest requestId
                         * @property {string|null} [zone] UpdateInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new UpdateInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdateInstanceRequest.
                         * @implements IUpdateInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdateInstanceRequest=} [properties] Properties to set
                         */
                        function UpdateInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.UpdateInstanceRequest
                         * @instance
                         */
                        UpdateInstanceRequest.prototype.instance = "";
    
                        /**
                         * UpdateInstanceRequest instanceResource.
                         * @member {google.cloud.compute.v1.IInstance|null|undefined} instanceResource
                         * @memberof google.cloud.compute.v1.UpdateInstanceRequest
                         * @instance
                         */
                        UpdateInstanceRequest.prototype.instanceResource = null;
    
                        /**
                         * UpdateInstanceRequest minimalAction.
                         * @member {string|null|undefined} minimalAction
                         * @memberof google.cloud.compute.v1.UpdateInstanceRequest
                         * @instance
                         */
                        UpdateInstanceRequest.prototype.minimalAction = null;
    
                        /**
                         * UpdateInstanceRequest mostDisruptiveAllowedAction.
                         * @member {string|null|undefined} mostDisruptiveAllowedAction
                         * @memberof google.cloud.compute.v1.UpdateInstanceRequest
                         * @instance
                         */
                        UpdateInstanceRequest.prototype.mostDisruptiveAllowedAction = null;
    
                        /**
                         * UpdateInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdateInstanceRequest
                         * @instance
                         */
                        UpdateInstanceRequest.prototype.project = "";
    
                        /**
                         * UpdateInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdateInstanceRequest
                         * @instance
                         */
                        UpdateInstanceRequest.prototype.requestId = null;
    
                        /**
                         * UpdateInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.UpdateInstanceRequest
                         * @instance
                         */
                        UpdateInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdateInstanceRequest _minimalAction.
                         * @member {"minimalAction"|undefined} _minimalAction
                         * @memberof google.cloud.compute.v1.UpdateInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateInstanceRequest.prototype, "_minimalAction", {
                            get: $util.oneOfGetter($oneOfFields = ["minimalAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UpdateInstanceRequest _mostDisruptiveAllowedAction.
                         * @member {"mostDisruptiveAllowedAction"|undefined} _mostDisruptiveAllowedAction
                         * @memberof google.cloud.compute.v1.UpdateInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateInstanceRequest.prototype, "_mostDisruptiveAllowedAction", {
                            get: $util.oneOfGetter($oneOfFields = ["mostDisruptiveAllowedAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UpdateInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdateInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdateInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdateInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdateInstanceRequest} UpdateInstanceRequest instance
                         */
                        UpdateInstanceRequest.create = function create(properties) {
                            return new UpdateInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdateInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdateInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateInstanceRequest} message UpdateInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.mostDisruptiveAllowedAction != null && Object.hasOwnProperty.call(message, "mostDisruptiveAllowedAction"))
                                writer.uint32(/* id 66103053, wireType 2 =*/528824426).string(message.mostDisruptiveAllowedAction);
                            if (message.instanceResource != null && Object.hasOwnProperty.call(message, "instanceResource"))
                                $root.google.cloud.compute.v1.Instance.encode(message.instanceResource, writer.uint32(/* id 215988344, wireType 2 =*/1727906754).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.minimalAction != null && Object.hasOwnProperty.call(message, "minimalAction"))
                                writer.uint32(/* id 270567060, wireType 2 =*/2164536482).string(message.minimalAction);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdateInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateInstanceRequest} message UpdateInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdateInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdateInstanceRequest} UpdateInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdateInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 215988344: {
                                        message.instanceResource = $root.google.cloud.compute.v1.Instance.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 270567060: {
                                        message.minimalAction = reader.string();
                                        break;
                                    }
                                case 66103053: {
                                        message.mostDisruptiveAllowedAction = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdateInstanceRequest} UpdateInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdateInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.instanceResource != null && message.hasOwnProperty("instanceResource")) {
                                var error = $root.google.cloud.compute.v1.Instance.verify(message.instanceResource);
                                if (error)
                                    return "instanceResource." + error;
                            }
                            if (message.minimalAction != null && message.hasOwnProperty("minimalAction")) {
                                properties._minimalAction = 1;
                                if (!$util.isString(message.minimalAction))
                                    return "minimalAction: string expected";
                            }
                            if (message.mostDisruptiveAllowedAction != null && message.hasOwnProperty("mostDisruptiveAllowedAction")) {
                                properties._mostDisruptiveAllowedAction = 1;
                                if (!$util.isString(message.mostDisruptiveAllowedAction))
                                    return "mostDisruptiveAllowedAction: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an UpdateInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdateInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdateInstanceRequest} UpdateInstanceRequest
                         */
                        UpdateInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdateInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdateInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.instanceResource != null) {
                                if (typeof object.instanceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdateInstanceRequest.instanceResource: object expected");
                                message.instanceResource = $root.google.cloud.compute.v1.Instance.fromObject(object.instanceResource);
                            }
                            if (object.minimalAction != null)
                                message.minimalAction = String(object.minimalAction);
                            if (object.mostDisruptiveAllowedAction != null)
                                message.mostDisruptiveAllowedAction = String(object.mostDisruptiveAllowedAction);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdateInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdateInstanceRequest} message UpdateInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.instanceResource = null;
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.mostDisruptiveAllowedAction != null && message.hasOwnProperty("mostDisruptiveAllowedAction")) {
                                object.mostDisruptiveAllowedAction = message.mostDisruptiveAllowedAction;
                                if (options.oneofs)
                                    object._mostDisruptiveAllowedAction = "mostDisruptiveAllowedAction";
                            }
                            if (message.instanceResource != null && message.hasOwnProperty("instanceResource"))
                                object.instanceResource = $root.google.cloud.compute.v1.Instance.toObject(message.instanceResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.minimalAction != null && message.hasOwnProperty("minimalAction")) {
                                object.minimalAction = message.minimalAction;
                                if (options.oneofs)
                                    object._minimalAction = "minimalAction";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UpdateInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdateInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdateInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdateInstanceRequest";
                        };
    
                        /**
                         * MinimalAction enum.
                         * @name google.cloud.compute.v1.UpdateInstanceRequest.MinimalAction
                         * @enum {number}
                         * @property {number} UNDEFINED_MINIMAL_ACTION=0 UNDEFINED_MINIMAL_ACTION value
                         */
                        UpdateInstanceRequest.MinimalAction = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_MINIMAL_ACTION"] = 0;
                            return values;
                        })();
    
                        /**
                         * MostDisruptiveAllowedAction enum.
                         * @name google.cloud.compute.v1.UpdateInstanceRequest.MostDisruptiveAllowedAction
                         * @enum {number}
                         * @property {number} UNDEFINED_MOST_DISRUPTIVE_ALLOWED_ACTION=0 UNDEFINED_MOST_DISRUPTIVE_ALLOWED_ACTION value
                         */
                        UpdateInstanceRequest.MostDisruptiveAllowedAction = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_MOST_DISRUPTIVE_ALLOWED_ACTION"] = 0;
                            return values;
                        })();
    
                        return UpdateInstanceRequest;
                    })();
    
                    v1.UpdateNetworkInterfaceInstanceRequest = (function() {
    
                        /**
                         * Properties of an UpdateNetworkInterfaceInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdateNetworkInterfaceInstanceRequest
                         * @property {string|null} [instance] UpdateNetworkInterfaceInstanceRequest instance
                         * @property {string|null} [networkInterface] UpdateNetworkInterfaceInstanceRequest networkInterface
                         * @property {google.cloud.compute.v1.INetworkInterface|null} [networkInterfaceResource] UpdateNetworkInterfaceInstanceRequest networkInterfaceResource
                         * @property {string|null} [project] UpdateNetworkInterfaceInstanceRequest project
                         * @property {string|null} [requestId] UpdateNetworkInterfaceInstanceRequest requestId
                         * @property {string|null} [zone] UpdateNetworkInterfaceInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new UpdateNetworkInterfaceInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdateNetworkInterfaceInstanceRequest.
                         * @implements IUpdateNetworkInterfaceInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdateNetworkInterfaceInstanceRequest=} [properties] Properties to set
                         */
                        function UpdateNetworkInterfaceInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateNetworkInterfaceInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest
                         * @instance
                         */
                        UpdateNetworkInterfaceInstanceRequest.prototype.instance = "";
    
                        /**
                         * UpdateNetworkInterfaceInstanceRequest networkInterface.
                         * @member {string} networkInterface
                         * @memberof google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest
                         * @instance
                         */
                        UpdateNetworkInterfaceInstanceRequest.prototype.networkInterface = "";
    
                        /**
                         * UpdateNetworkInterfaceInstanceRequest networkInterfaceResource.
                         * @member {google.cloud.compute.v1.INetworkInterface|null|undefined} networkInterfaceResource
                         * @memberof google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest
                         * @instance
                         */
                        UpdateNetworkInterfaceInstanceRequest.prototype.networkInterfaceResource = null;
    
                        /**
                         * UpdateNetworkInterfaceInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest
                         * @instance
                         */
                        UpdateNetworkInterfaceInstanceRequest.prototype.project = "";
    
                        /**
                         * UpdateNetworkInterfaceInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest
                         * @instance
                         */
                        UpdateNetworkInterfaceInstanceRequest.prototype.requestId = null;
    
                        /**
                         * UpdateNetworkInterfaceInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest
                         * @instance
                         */
                        UpdateNetworkInterfaceInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdateNetworkInterfaceInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateNetworkInterfaceInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdateNetworkInterfaceInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateNetworkInterfaceInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest} UpdateNetworkInterfaceInstanceRequest instance
                         */
                        UpdateNetworkInterfaceInstanceRequest.create = function create(properties) {
                            return new UpdateNetworkInterfaceInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateNetworkInterfaceInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateNetworkInterfaceInstanceRequest} message UpdateNetworkInterfaceInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateNetworkInterfaceInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.networkInterfaceResource != null && Object.hasOwnProperty.call(message, "networkInterfaceResource"))
                                $root.google.cloud.compute.v1.NetworkInterface.encode(message.networkInterfaceResource, writer.uint32(/* id 325814789, wireType 2 =*/2606518314).fork()).ldelim();
                            if (message.networkInterface != null && Object.hasOwnProperty.call(message, "networkInterface"))
                                writer.uint32(/* id 365387880, wireType 2 =*/2923103042).string(message.networkInterface);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateNetworkInterfaceInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateNetworkInterfaceInstanceRequest} message UpdateNetworkInterfaceInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateNetworkInterfaceInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateNetworkInterfaceInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest} UpdateNetworkInterfaceInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateNetworkInterfaceInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 365387880: {
                                        message.networkInterface = reader.string();
                                        break;
                                    }
                                case 325814789: {
                                        message.networkInterfaceResource = $root.google.cloud.compute.v1.NetworkInterface.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateNetworkInterfaceInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest} UpdateNetworkInterfaceInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateNetworkInterfaceInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateNetworkInterfaceInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateNetworkInterfaceInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.networkInterface != null && message.hasOwnProperty("networkInterface"))
                                if (!$util.isString(message.networkInterface))
                                    return "networkInterface: string expected";
                            if (message.networkInterfaceResource != null && message.hasOwnProperty("networkInterfaceResource")) {
                                var error = $root.google.cloud.compute.v1.NetworkInterface.verify(message.networkInterfaceResource);
                                if (error)
                                    return "networkInterfaceResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an UpdateNetworkInterfaceInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest} UpdateNetworkInterfaceInstanceRequest
                         */
                        UpdateNetworkInterfaceInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.networkInterface != null)
                                message.networkInterface = String(object.networkInterface);
                            if (object.networkInterfaceResource != null) {
                                if (typeof object.networkInterfaceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest.networkInterfaceResource: object expected");
                                message.networkInterfaceResource = $root.google.cloud.compute.v1.NetworkInterface.fromObject(object.networkInterfaceResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateNetworkInterfaceInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest} message UpdateNetworkInterfaceInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateNetworkInterfaceInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                                object.networkInterfaceResource = null;
                                object.networkInterface = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.networkInterfaceResource != null && message.hasOwnProperty("networkInterfaceResource"))
                                object.networkInterfaceResource = $root.google.cloud.compute.v1.NetworkInterface.toObject(message.networkInterfaceResource, options);
                            if (message.networkInterface != null && message.hasOwnProperty("networkInterface"))
                                object.networkInterface = message.networkInterface;
                            return object;
                        };
    
                        /**
                         * Converts this UpdateNetworkInterfaceInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateNetworkInterfaceInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateNetworkInterfaceInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateNetworkInterfaceInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest";
                        };
    
                        return UpdateNetworkInterfaceInstanceRequest;
                    })();
    
                    v1.UpdatePeeringNetworkRequest = (function() {
    
                        /**
                         * Properties of an UpdatePeeringNetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdatePeeringNetworkRequest
                         * @property {string|null} [network] UpdatePeeringNetworkRequest network
                         * @property {google.cloud.compute.v1.INetworksUpdatePeeringRequest|null} [networksUpdatePeeringRequestResource] UpdatePeeringNetworkRequest networksUpdatePeeringRequestResource
                         * @property {string|null} [project] UpdatePeeringNetworkRequest project
                         * @property {string|null} [requestId] UpdatePeeringNetworkRequest requestId
                         */
    
                        /**
                         * Constructs a new UpdatePeeringNetworkRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdatePeeringNetworkRequest.
                         * @implements IUpdatePeeringNetworkRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdatePeeringNetworkRequest=} [properties] Properties to set
                         */
                        function UpdatePeeringNetworkRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdatePeeringNetworkRequest network.
                         * @member {string} network
                         * @memberof google.cloud.compute.v1.UpdatePeeringNetworkRequest
                         * @instance
                         */
                        UpdatePeeringNetworkRequest.prototype.network = "";
    
                        /**
                         * UpdatePeeringNetworkRequest networksUpdatePeeringRequestResource.
                         * @member {google.cloud.compute.v1.INetworksUpdatePeeringRequest|null|undefined} networksUpdatePeeringRequestResource
                         * @memberof google.cloud.compute.v1.UpdatePeeringNetworkRequest
                         * @instance
                         */
                        UpdatePeeringNetworkRequest.prototype.networksUpdatePeeringRequestResource = null;
    
                        /**
                         * UpdatePeeringNetworkRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdatePeeringNetworkRequest
                         * @instance
                         */
                        UpdatePeeringNetworkRequest.prototype.project = "";
    
                        /**
                         * UpdatePeeringNetworkRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdatePeeringNetworkRequest
                         * @instance
                         */
                        UpdatePeeringNetworkRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdatePeeringNetworkRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdatePeeringNetworkRequest
                         * @instance
                         */
                        Object.defineProperty(UpdatePeeringNetworkRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdatePeeringNetworkRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdatePeeringNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdatePeeringNetworkRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdatePeeringNetworkRequest} UpdatePeeringNetworkRequest instance
                         */
                        UpdatePeeringNetworkRequest.create = function create(properties) {
                            return new UpdatePeeringNetworkRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdatePeeringNetworkRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdatePeeringNetworkRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdatePeeringNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdatePeeringNetworkRequest} message UpdatePeeringNetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdatePeeringNetworkRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.networksUpdatePeeringRequestResource != null && Object.hasOwnProperty.call(message, "networksUpdatePeeringRequestResource"))
                                $root.google.cloud.compute.v1.NetworksUpdatePeeringRequest.encode(message.networksUpdatePeeringRequestResource, writer.uint32(/* id 224433497, wireType 2 =*/1795467978).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdatePeeringNetworkRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdatePeeringNetworkRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdatePeeringNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdatePeeringNetworkRequest} message UpdatePeeringNetworkRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdatePeeringNetworkRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdatePeeringNetworkRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdatePeeringNetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdatePeeringNetworkRequest} UpdatePeeringNetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdatePeeringNetworkRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdatePeeringNetworkRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 224433497: {
                                        message.networksUpdatePeeringRequestResource = $root.google.cloud.compute.v1.NetworksUpdatePeeringRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdatePeeringNetworkRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdatePeeringNetworkRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdatePeeringNetworkRequest} UpdatePeeringNetworkRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdatePeeringNetworkRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdatePeeringNetworkRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdatePeeringNetworkRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdatePeeringNetworkRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.network != null && message.hasOwnProperty("network"))
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            if (message.networksUpdatePeeringRequestResource != null && message.hasOwnProperty("networksUpdatePeeringRequestResource")) {
                                var error = $root.google.cloud.compute.v1.NetworksUpdatePeeringRequest.verify(message.networksUpdatePeeringRequestResource);
                                if (error)
                                    return "networksUpdatePeeringRequestResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdatePeeringNetworkRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdatePeeringNetworkRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdatePeeringNetworkRequest} UpdatePeeringNetworkRequest
                         */
                        UpdatePeeringNetworkRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdatePeeringNetworkRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdatePeeringNetworkRequest();
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.networksUpdatePeeringRequestResource != null) {
                                if (typeof object.networksUpdatePeeringRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdatePeeringNetworkRequest.networksUpdatePeeringRequestResource: object expected");
                                message.networksUpdatePeeringRequestResource = $root.google.cloud.compute.v1.NetworksUpdatePeeringRequest.fromObject(object.networksUpdatePeeringRequestResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdatePeeringNetworkRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdatePeeringNetworkRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdatePeeringNetworkRequest} message UpdatePeeringNetworkRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdatePeeringNetworkRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.networksUpdatePeeringRequestResource = null;
                                object.project = "";
                                object.network = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.networksUpdatePeeringRequestResource != null && message.hasOwnProperty("networksUpdatePeeringRequestResource"))
                                object.networksUpdatePeeringRequestResource = $root.google.cloud.compute.v1.NetworksUpdatePeeringRequest.toObject(message.networksUpdatePeeringRequestResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.network != null && message.hasOwnProperty("network"))
                                object.network = message.network;
                            return object;
                        };
    
                        /**
                         * Converts this UpdatePeeringNetworkRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdatePeeringNetworkRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdatePeeringNetworkRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdatePeeringNetworkRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdatePeeringNetworkRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdatePeeringNetworkRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdatePeeringNetworkRequest";
                        };
    
                        return UpdatePeeringNetworkRequest;
                    })();
    
                    v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of an UpdatePerInstanceConfigsInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] UpdatePerInstanceConfigsInstanceGroupManagerRequest instanceGroupManager
                         * @property {google.cloud.compute.v1.IInstanceGroupManagersUpdatePerInstanceConfigsReq|null} [instanceGroupManagersUpdatePerInstanceConfigsReqResource] UpdatePerInstanceConfigsInstanceGroupManagerRequest instanceGroupManagersUpdatePerInstanceConfigsReqResource
                         * @property {string|null} [project] UpdatePerInstanceConfigsInstanceGroupManagerRequest project
                         * @property {string|null} [requestId] UpdatePerInstanceConfigsInstanceGroupManagerRequest requestId
                         * @property {string|null} [zone] UpdatePerInstanceConfigsInstanceGroupManagerRequest zone
                         */
    
                        /**
                         * Constructs a new UpdatePerInstanceConfigsInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdatePerInstanceConfigsInstanceGroupManagerRequest.
                         * @implements IUpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdatePerInstanceConfigsInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function UpdatePerInstanceConfigsInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdatePerInstanceConfigsInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @instance
                         */
                        UpdatePerInstanceConfigsInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * UpdatePerInstanceConfigsInstanceGroupManagerRequest instanceGroupManagersUpdatePerInstanceConfigsReqResource.
                         * @member {google.cloud.compute.v1.IInstanceGroupManagersUpdatePerInstanceConfigsReq|null|undefined} instanceGroupManagersUpdatePerInstanceConfigsReqResource
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @instance
                         */
                        UpdatePerInstanceConfigsInstanceGroupManagerRequest.prototype.instanceGroupManagersUpdatePerInstanceConfigsReqResource = null;
    
                        /**
                         * UpdatePerInstanceConfigsInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @instance
                         */
                        UpdatePerInstanceConfigsInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * UpdatePerInstanceConfigsInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @instance
                         */
                        UpdatePerInstanceConfigsInstanceGroupManagerRequest.prototype.requestId = null;
    
                        /**
                         * UpdatePerInstanceConfigsInstanceGroupManagerRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @instance
                         */
                        UpdatePerInstanceConfigsInstanceGroupManagerRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdatePerInstanceConfigsInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(UpdatePerInstanceConfigsInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdatePerInstanceConfigsInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdatePerInstanceConfigsInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest} UpdatePerInstanceConfigsInstanceGroupManagerRequest instance
                         */
                        UpdatePerInstanceConfigsInstanceGroupManagerRequest.create = function create(properties) {
                            return new UpdatePerInstanceConfigsInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdatePerInstanceConfigsInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdatePerInstanceConfigsInstanceGroupManagerRequest} message UpdatePerInstanceConfigsInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdatePerInstanceConfigsInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.instanceGroupManagersUpdatePerInstanceConfigsReqResource != null && Object.hasOwnProperty.call(message, "instanceGroupManagersUpdatePerInstanceConfigsReqResource"))
                                $root.google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq.encode(message.instanceGroupManagersUpdatePerInstanceConfigsReqResource, writer.uint32(/* id 141402302, wireType 2 =*/1131218418).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdatePerInstanceConfigsInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdatePerInstanceConfigsInstanceGroupManagerRequest} message UpdatePerInstanceConfigsInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdatePerInstanceConfigsInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdatePerInstanceConfigsInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest} UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdatePerInstanceConfigsInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 141402302: {
                                        message.instanceGroupManagersUpdatePerInstanceConfigsReqResource = $root.google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdatePerInstanceConfigsInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest} UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdatePerInstanceConfigsInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdatePerInstanceConfigsInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdatePerInstanceConfigsInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.instanceGroupManagersUpdatePerInstanceConfigsReqResource != null && message.hasOwnProperty("instanceGroupManagersUpdatePerInstanceConfigsReqResource")) {
                                var error = $root.google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq.verify(message.instanceGroupManagersUpdatePerInstanceConfigsReqResource);
                                if (error)
                                    return "instanceGroupManagersUpdatePerInstanceConfigsReqResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an UpdatePerInstanceConfigsInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest} UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         */
                        UpdatePerInstanceConfigsInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.instanceGroupManagersUpdatePerInstanceConfigsReqResource != null) {
                                if (typeof object.instanceGroupManagersUpdatePerInstanceConfigsReqResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest.instanceGroupManagersUpdatePerInstanceConfigsReqResource: object expected");
                                message.instanceGroupManagersUpdatePerInstanceConfigsReqResource = $root.google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq.fromObject(object.instanceGroupManagersUpdatePerInstanceConfigsReqResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdatePerInstanceConfigsInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest} message UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdatePerInstanceConfigsInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instanceGroupManagersUpdatePerInstanceConfigsReqResource = null;
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.instanceGroupManagersUpdatePerInstanceConfigsReqResource != null && message.hasOwnProperty("instanceGroupManagersUpdatePerInstanceConfigsReqResource"))
                                object.instanceGroupManagersUpdatePerInstanceConfigsReqResource = $root.google.cloud.compute.v1.InstanceGroupManagersUpdatePerInstanceConfigsReq.toObject(message.instanceGroupManagersUpdatePerInstanceConfigsReqResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            return object;
                        };
    
                        /**
                         * Converts this UpdatePerInstanceConfigsInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdatePerInstanceConfigsInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdatePerInstanceConfigsInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest";
                        };
    
                        return UpdatePerInstanceConfigsInstanceGroupManagerRequest;
                    })();
    
                    v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest = (function() {
    
                        /**
                         * Properties of an UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @property {string|null} [instanceGroupManager] UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest instanceGroupManager
                         * @property {string|null} [project] UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest project
                         * @property {string|null} [region] UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest region
                         * @property {google.cloud.compute.v1.IRegionInstanceGroupManagerUpdateInstanceConfigReq|null} [regionInstanceGroupManagerUpdateInstanceConfigReqResource] UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest regionInstanceGroupManagerUpdateInstanceConfigReqResource
                         * @property {string|null} [requestId] UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest requestId
                         */
    
                        /**
                         * Constructs a new UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.
                         * @implements IUpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdatePerInstanceConfigsRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         */
                        function UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest instanceGroupManager.
                         * @member {string} instanceGroupManager
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.prototype.instanceGroupManager = "";
    
                        /**
                         * UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.prototype.project = "";
    
                        /**
                         * UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.prototype.region = "";
    
                        /**
                         * UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest regionInstanceGroupManagerUpdateInstanceConfigReqResource.
                         * @member {google.cloud.compute.v1.IRegionInstanceGroupManagerUpdateInstanceConfigReq|null|undefined} regionInstanceGroupManagerUpdateInstanceConfigReqResource
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.prototype.regionInstanceGroupManagerUpdateInstanceConfigReqResource = null;
    
                        /**
                         * UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @instance
                         */
                        Object.defineProperty(UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdatePerInstanceConfigsRegionInstanceGroupManagerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest} UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest instance
                         */
                        UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.create = function create(properties) {
                            return new UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdatePerInstanceConfigsRegionInstanceGroupManagerRequest} message UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.regionInstanceGroupManagerUpdateInstanceConfigReqResource != null && Object.hasOwnProperty.call(message, "regionInstanceGroupManagerUpdateInstanceConfigReqResource"))
                                $root.google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq.encode(message.regionInstanceGroupManagerUpdateInstanceConfigReqResource, writer.uint32(/* id 89036583, wireType 2 =*/712292666).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.instanceGroupManager != null && Object.hasOwnProperty.call(message, "instanceGroupManager"))
                                writer.uint32(/* id 249363395, wireType 2 =*/1994907162).string(message.instanceGroupManager);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdatePerInstanceConfigsRegionInstanceGroupManagerRequest} message UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest} UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 249363395: {
                                        message.instanceGroupManager = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 89036583: {
                                        message.regionInstanceGroupManagerUpdateInstanceConfigReqResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest} UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                if (!$util.isString(message.instanceGroupManager))
                                    return "instanceGroupManager: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionInstanceGroupManagerUpdateInstanceConfigReqResource != null && message.hasOwnProperty("regionInstanceGroupManagerUpdateInstanceConfigReqResource")) {
                                var error = $root.google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq.verify(message.regionInstanceGroupManagerUpdateInstanceConfigReqResource);
                                if (error)
                                    return "regionInstanceGroupManagerUpdateInstanceConfigReqResource." + error;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest} UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         */
                        UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest();
                            if (object.instanceGroupManager != null)
                                message.instanceGroupManager = String(object.instanceGroupManager);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionInstanceGroupManagerUpdateInstanceConfigReqResource != null) {
                                if (typeof object.regionInstanceGroupManagerUpdateInstanceConfigReqResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.regionInstanceGroupManagerUpdateInstanceConfigReqResource: object expected");
                                message.regionInstanceGroupManagerUpdateInstanceConfigReqResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq.fromObject(object.regionInstanceGroupManagerUpdateInstanceConfigReqResource);
                            }
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest} message UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.regionInstanceGroupManagerUpdateInstanceConfigReqResource = null;
                                object.region = "";
                                object.project = "";
                                object.instanceGroupManager = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.regionInstanceGroupManagerUpdateInstanceConfigReqResource != null && message.hasOwnProperty("regionInstanceGroupManagerUpdateInstanceConfigReqResource"))
                                object.regionInstanceGroupManagerUpdateInstanceConfigReqResource = $root.google.cloud.compute.v1.RegionInstanceGroupManagerUpdateInstanceConfigReq.toObject(message.regionInstanceGroupManagerUpdateInstanceConfigReqResource, options);
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.instanceGroupManager != null && message.hasOwnProperty("instanceGroupManager"))
                                object.instanceGroupManager = message.instanceGroupManager;
                            return object;
                        };
    
                        /**
                         * Converts this UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest";
                        };
    
                        return UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest;
                    })();
    
                    v1.UpdateRegionAutoscalerRequest = (function() {
    
                        /**
                         * Properties of an UpdateRegionAutoscalerRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdateRegionAutoscalerRequest
                         * @property {string|null} [autoscaler] UpdateRegionAutoscalerRequest autoscaler
                         * @property {google.cloud.compute.v1.IAutoscaler|null} [autoscalerResource] UpdateRegionAutoscalerRequest autoscalerResource
                         * @property {string|null} [project] UpdateRegionAutoscalerRequest project
                         * @property {string|null} [region] UpdateRegionAutoscalerRequest region
                         * @property {string|null} [requestId] UpdateRegionAutoscalerRequest requestId
                         */
    
                        /**
                         * Constructs a new UpdateRegionAutoscalerRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdateRegionAutoscalerRequest.
                         * @implements IUpdateRegionAutoscalerRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdateRegionAutoscalerRequest=} [properties] Properties to set
                         */
                        function UpdateRegionAutoscalerRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateRegionAutoscalerRequest autoscaler.
                         * @member {string|null|undefined} autoscaler
                         * @memberof google.cloud.compute.v1.UpdateRegionAutoscalerRequest
                         * @instance
                         */
                        UpdateRegionAutoscalerRequest.prototype.autoscaler = null;
    
                        /**
                         * UpdateRegionAutoscalerRequest autoscalerResource.
                         * @member {google.cloud.compute.v1.IAutoscaler|null|undefined} autoscalerResource
                         * @memberof google.cloud.compute.v1.UpdateRegionAutoscalerRequest
                         * @instance
                         */
                        UpdateRegionAutoscalerRequest.prototype.autoscalerResource = null;
    
                        /**
                         * UpdateRegionAutoscalerRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdateRegionAutoscalerRequest
                         * @instance
                         */
                        UpdateRegionAutoscalerRequest.prototype.project = "";
    
                        /**
                         * UpdateRegionAutoscalerRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.UpdateRegionAutoscalerRequest
                         * @instance
                         */
                        UpdateRegionAutoscalerRequest.prototype.region = "";
    
                        /**
                         * UpdateRegionAutoscalerRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdateRegionAutoscalerRequest
                         * @instance
                         */
                        UpdateRegionAutoscalerRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdateRegionAutoscalerRequest _autoscaler.
                         * @member {"autoscaler"|undefined} _autoscaler
                         * @memberof google.cloud.compute.v1.UpdateRegionAutoscalerRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateRegionAutoscalerRequest.prototype, "_autoscaler", {
                            get: $util.oneOfGetter($oneOfFields = ["autoscaler"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UpdateRegionAutoscalerRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdateRegionAutoscalerRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateRegionAutoscalerRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdateRegionAutoscalerRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdateRegionAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateRegionAutoscalerRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdateRegionAutoscalerRequest} UpdateRegionAutoscalerRequest instance
                         */
                        UpdateRegionAutoscalerRequest.create = function create(properties) {
                            return new UpdateRegionAutoscalerRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateRegionAutoscalerRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdateRegionAutoscalerRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdateRegionAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateRegionAutoscalerRequest} message UpdateRegionAutoscalerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateRegionAutoscalerRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.autoscalerResource != null && Object.hasOwnProperty.call(message, "autoscalerResource"))
                                $root.google.cloud.compute.v1.Autoscaler.encode(message.autoscalerResource, writer.uint32(/* id 207616118, wireType 2 =*/1660928946).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.autoscaler != null && Object.hasOwnProperty.call(message, "autoscaler"))
                                writer.uint32(/* id 517258967, wireType 2 =*/4138071738).string(message.autoscaler);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateRegionAutoscalerRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdateRegionAutoscalerRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateRegionAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateRegionAutoscalerRequest} message UpdateRegionAutoscalerRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateRegionAutoscalerRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateRegionAutoscalerRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdateRegionAutoscalerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdateRegionAutoscalerRequest} UpdateRegionAutoscalerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateRegionAutoscalerRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdateRegionAutoscalerRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 517258967: {
                                        message.autoscaler = reader.string();
                                        break;
                                    }
                                case 207616118: {
                                        message.autoscalerResource = $root.google.cloud.compute.v1.Autoscaler.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateRegionAutoscalerRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateRegionAutoscalerRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdateRegionAutoscalerRequest} UpdateRegionAutoscalerRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateRegionAutoscalerRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateRegionAutoscalerRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdateRegionAutoscalerRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateRegionAutoscalerRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.autoscaler != null && message.hasOwnProperty("autoscaler")) {
                                properties._autoscaler = 1;
                                if (!$util.isString(message.autoscaler))
                                    return "autoscaler: string expected";
                            }
                            if (message.autoscalerResource != null && message.hasOwnProperty("autoscalerResource")) {
                                var error = $root.google.cloud.compute.v1.Autoscaler.verify(message.autoscalerResource);
                                if (error)
                                    return "autoscalerResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateRegionAutoscalerRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdateRegionAutoscalerRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdateRegionAutoscalerRequest} UpdateRegionAutoscalerRequest
                         */
                        UpdateRegionAutoscalerRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdateRegionAutoscalerRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdateRegionAutoscalerRequest();
                            if (object.autoscaler != null)
                                message.autoscaler = String(object.autoscaler);
                            if (object.autoscalerResource != null) {
                                if (typeof object.autoscalerResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdateRegionAutoscalerRequest.autoscalerResource: object expected");
                                message.autoscalerResource = $root.google.cloud.compute.v1.Autoscaler.fromObject(object.autoscalerResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateRegionAutoscalerRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdateRegionAutoscalerRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdateRegionAutoscalerRequest} message UpdateRegionAutoscalerRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateRegionAutoscalerRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.autoscalerResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.autoscalerResource != null && message.hasOwnProperty("autoscalerResource"))
                                object.autoscalerResource = $root.google.cloud.compute.v1.Autoscaler.toObject(message.autoscalerResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.autoscaler != null && message.hasOwnProperty("autoscaler")) {
                                object.autoscaler = message.autoscaler;
                                if (options.oneofs)
                                    object._autoscaler = "autoscaler";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UpdateRegionAutoscalerRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdateRegionAutoscalerRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateRegionAutoscalerRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateRegionAutoscalerRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdateRegionAutoscalerRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateRegionAutoscalerRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdateRegionAutoscalerRequest";
                        };
    
                        return UpdateRegionAutoscalerRequest;
                    })();
    
                    v1.UpdateRegionBackendServiceRequest = (function() {
    
                        /**
                         * Properties of an UpdateRegionBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdateRegionBackendServiceRequest
                         * @property {string|null} [backendService] UpdateRegionBackendServiceRequest backendService
                         * @property {google.cloud.compute.v1.IBackendService|null} [backendServiceResource] UpdateRegionBackendServiceRequest backendServiceResource
                         * @property {string|null} [project] UpdateRegionBackendServiceRequest project
                         * @property {string|null} [region] UpdateRegionBackendServiceRequest region
                         * @property {string|null} [requestId] UpdateRegionBackendServiceRequest requestId
                         */
    
                        /**
                         * Constructs a new UpdateRegionBackendServiceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdateRegionBackendServiceRequest.
                         * @implements IUpdateRegionBackendServiceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdateRegionBackendServiceRequest=} [properties] Properties to set
                         */
                        function UpdateRegionBackendServiceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateRegionBackendServiceRequest backendService.
                         * @member {string} backendService
                         * @memberof google.cloud.compute.v1.UpdateRegionBackendServiceRequest
                         * @instance
                         */
                        UpdateRegionBackendServiceRequest.prototype.backendService = "";
    
                        /**
                         * UpdateRegionBackendServiceRequest backendServiceResource.
                         * @member {google.cloud.compute.v1.IBackendService|null|undefined} backendServiceResource
                         * @memberof google.cloud.compute.v1.UpdateRegionBackendServiceRequest
                         * @instance
                         */
                        UpdateRegionBackendServiceRequest.prototype.backendServiceResource = null;
    
                        /**
                         * UpdateRegionBackendServiceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdateRegionBackendServiceRequest
                         * @instance
                         */
                        UpdateRegionBackendServiceRequest.prototype.project = "";
    
                        /**
                         * UpdateRegionBackendServiceRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.UpdateRegionBackendServiceRequest
                         * @instance
                         */
                        UpdateRegionBackendServiceRequest.prototype.region = "";
    
                        /**
                         * UpdateRegionBackendServiceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdateRegionBackendServiceRequest
                         * @instance
                         */
                        UpdateRegionBackendServiceRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdateRegionBackendServiceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdateRegionBackendServiceRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateRegionBackendServiceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdateRegionBackendServiceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdateRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateRegionBackendServiceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdateRegionBackendServiceRequest} UpdateRegionBackendServiceRequest instance
                         */
                        UpdateRegionBackendServiceRequest.create = function create(properties) {
                            return new UpdateRegionBackendServiceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateRegionBackendServiceRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdateRegionBackendServiceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdateRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateRegionBackendServiceRequest} message UpdateRegionBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateRegionBackendServiceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.backendService != null && Object.hasOwnProperty.call(message, "backendService"))
                                writer.uint32(/* id 306946058, wireType 2 =*/2455568466).string(message.backendService);
                            if (message.backendServiceResource != null && Object.hasOwnProperty.call(message, "backendServiceResource"))
                                $root.google.cloud.compute.v1.BackendService.encode(message.backendServiceResource, writer.uint32(/* id 347586723, wireType 2 =*/2780693786).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateRegionBackendServiceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdateRegionBackendServiceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateRegionBackendServiceRequest} message UpdateRegionBackendServiceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateRegionBackendServiceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateRegionBackendServiceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdateRegionBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdateRegionBackendServiceRequest} UpdateRegionBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateRegionBackendServiceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdateRegionBackendServiceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 306946058: {
                                        message.backendService = reader.string();
                                        break;
                                    }
                                case 347586723: {
                                        message.backendServiceResource = $root.google.cloud.compute.v1.BackendService.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateRegionBackendServiceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateRegionBackendServiceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdateRegionBackendServiceRequest} UpdateRegionBackendServiceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateRegionBackendServiceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateRegionBackendServiceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdateRegionBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateRegionBackendServiceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                if (!$util.isString(message.backendService))
                                    return "backendService: string expected";
                            if (message.backendServiceResource != null && message.hasOwnProperty("backendServiceResource")) {
                                var error = $root.google.cloud.compute.v1.BackendService.verify(message.backendServiceResource);
                                if (error)
                                    return "backendServiceResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateRegionBackendServiceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdateRegionBackendServiceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdateRegionBackendServiceRequest} UpdateRegionBackendServiceRequest
                         */
                        UpdateRegionBackendServiceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdateRegionBackendServiceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdateRegionBackendServiceRequest();
                            if (object.backendService != null)
                                message.backendService = String(object.backendService);
                            if (object.backendServiceResource != null) {
                                if (typeof object.backendServiceResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdateRegionBackendServiceRequest.backendServiceResource: object expected");
                                message.backendServiceResource = $root.google.cloud.compute.v1.BackendService.fromObject(object.backendServiceResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateRegionBackendServiceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdateRegionBackendServiceRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdateRegionBackendServiceRequest} message UpdateRegionBackendServiceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateRegionBackendServiceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.backendService = "";
                                object.backendServiceResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.backendService != null && message.hasOwnProperty("backendService"))
                                object.backendService = message.backendService;
                            if (message.backendServiceResource != null && message.hasOwnProperty("backendServiceResource"))
                                object.backendServiceResource = $root.google.cloud.compute.v1.BackendService.toObject(message.backendServiceResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateRegionBackendServiceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdateRegionBackendServiceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateRegionBackendServiceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateRegionBackendServiceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdateRegionBackendServiceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateRegionBackendServiceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdateRegionBackendServiceRequest";
                        };
    
                        return UpdateRegionBackendServiceRequest;
                    })();
    
                    v1.UpdateRegionCommitmentRequest = (function() {
    
                        /**
                         * Properties of an UpdateRegionCommitmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdateRegionCommitmentRequest
                         * @property {string|null} [commitment] UpdateRegionCommitmentRequest commitment
                         * @property {google.cloud.compute.v1.ICommitment|null} [commitmentResource] UpdateRegionCommitmentRequest commitmentResource
                         * @property {string|null} [paths] UpdateRegionCommitmentRequest paths
                         * @property {string|null} [project] UpdateRegionCommitmentRequest project
                         * @property {string|null} [region] UpdateRegionCommitmentRequest region
                         * @property {string|null} [requestId] UpdateRegionCommitmentRequest requestId
                         * @property {string|null} [updateMask] UpdateRegionCommitmentRequest updateMask
                         */
    
                        /**
                         * Constructs a new UpdateRegionCommitmentRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdateRegionCommitmentRequest.
                         * @implements IUpdateRegionCommitmentRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdateRegionCommitmentRequest=} [properties] Properties to set
                         */
                        function UpdateRegionCommitmentRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateRegionCommitmentRequest commitment.
                         * @member {string} commitment
                         * @memberof google.cloud.compute.v1.UpdateRegionCommitmentRequest
                         * @instance
                         */
                        UpdateRegionCommitmentRequest.prototype.commitment = "";
    
                        /**
                         * UpdateRegionCommitmentRequest commitmentResource.
                         * @member {google.cloud.compute.v1.ICommitment|null|undefined} commitmentResource
                         * @memberof google.cloud.compute.v1.UpdateRegionCommitmentRequest
                         * @instance
                         */
                        UpdateRegionCommitmentRequest.prototype.commitmentResource = null;
    
                        /**
                         * UpdateRegionCommitmentRequest paths.
                         * @member {string|null|undefined} paths
                         * @memberof google.cloud.compute.v1.UpdateRegionCommitmentRequest
                         * @instance
                         */
                        UpdateRegionCommitmentRequest.prototype.paths = null;
    
                        /**
                         * UpdateRegionCommitmentRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdateRegionCommitmentRequest
                         * @instance
                         */
                        UpdateRegionCommitmentRequest.prototype.project = "";
    
                        /**
                         * UpdateRegionCommitmentRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.UpdateRegionCommitmentRequest
                         * @instance
                         */
                        UpdateRegionCommitmentRequest.prototype.region = "";
    
                        /**
                         * UpdateRegionCommitmentRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdateRegionCommitmentRequest
                         * @instance
                         */
                        UpdateRegionCommitmentRequest.prototype.requestId = null;
    
                        /**
                         * UpdateRegionCommitmentRequest updateMask.
                         * @member {string|null|undefined} updateMask
                         * @memberof google.cloud.compute.v1.UpdateRegionCommitmentRequest
                         * @instance
                         */
                        UpdateRegionCommitmentRequest.prototype.updateMask = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdateRegionCommitmentRequest _paths.
                         * @member {"paths"|undefined} _paths
                         * @memberof google.cloud.compute.v1.UpdateRegionCommitmentRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateRegionCommitmentRequest.prototype, "_paths", {
                            get: $util.oneOfGetter($oneOfFields = ["paths"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UpdateRegionCommitmentRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdateRegionCommitmentRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateRegionCommitmentRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UpdateRegionCommitmentRequest _updateMask.
                         * @member {"updateMask"|undefined} _updateMask
                         * @memberof google.cloud.compute.v1.UpdateRegionCommitmentRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateRegionCommitmentRequest.prototype, "_updateMask", {
                            get: $util.oneOfGetter($oneOfFields = ["updateMask"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdateRegionCommitmentRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdateRegionCommitmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateRegionCommitmentRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdateRegionCommitmentRequest} UpdateRegionCommitmentRequest instance
                         */
                        UpdateRegionCommitmentRequest.create = function create(properties) {
                            return new UpdateRegionCommitmentRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateRegionCommitmentRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdateRegionCommitmentRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdateRegionCommitmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateRegionCommitmentRequest} message UpdateRegionCommitmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateRegionCommitmentRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.paths != null && Object.hasOwnProperty.call(message, "paths"))
                                writer.uint32(/* id 106438894, wireType 2 =*/851511154).string(message.paths);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.commitmentResource != null && Object.hasOwnProperty.call(message, "commitmentResource"))
                                $root.google.cloud.compute.v1.Commitment.encode(message.commitmentResource, writer.uint32(/* id 244240888, wireType 2 =*/1953927106).fork()).ldelim();
                            if (message.commitment != null && Object.hasOwnProperty.call(message, "commitment"))
                                writer.uint32(/* id 482134805, wireType 2 =*/3857078442).string(message.commitment);
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                writer.uint32(/* id 500079778, wireType 2 =*/4000638226).string(message.updateMask);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateRegionCommitmentRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdateRegionCommitmentRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateRegionCommitmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateRegionCommitmentRequest} message UpdateRegionCommitmentRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateRegionCommitmentRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateRegionCommitmentRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdateRegionCommitmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdateRegionCommitmentRequest} UpdateRegionCommitmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateRegionCommitmentRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdateRegionCommitmentRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 482134805: {
                                        message.commitment = reader.string();
                                        break;
                                    }
                                case 244240888: {
                                        message.commitmentResource = $root.google.cloud.compute.v1.Commitment.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 106438894: {
                                        message.paths = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 500079778: {
                                        message.updateMask = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateRegionCommitmentRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateRegionCommitmentRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdateRegionCommitmentRequest} UpdateRegionCommitmentRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateRegionCommitmentRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateRegionCommitmentRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdateRegionCommitmentRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateRegionCommitmentRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.commitment != null && message.hasOwnProperty("commitment"))
                                if (!$util.isString(message.commitment))
                                    return "commitment: string expected";
                            if (message.commitmentResource != null && message.hasOwnProperty("commitmentResource")) {
                                var error = $root.google.cloud.compute.v1.Commitment.verify(message.commitmentResource);
                                if (error)
                                    return "commitmentResource." + error;
                            }
                            if (message.paths != null && message.hasOwnProperty("paths")) {
                                properties._paths = 1;
                                if (!$util.isString(message.paths))
                                    return "paths: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                properties._updateMask = 1;
                                if (!$util.isString(message.updateMask))
                                    return "updateMask: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateRegionCommitmentRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdateRegionCommitmentRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdateRegionCommitmentRequest} UpdateRegionCommitmentRequest
                         */
                        UpdateRegionCommitmentRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdateRegionCommitmentRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdateRegionCommitmentRequest();
                            if (object.commitment != null)
                                message.commitment = String(object.commitment);
                            if (object.commitmentResource != null) {
                                if (typeof object.commitmentResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdateRegionCommitmentRequest.commitmentResource: object expected");
                                message.commitmentResource = $root.google.cloud.compute.v1.Commitment.fromObject(object.commitmentResource);
                            }
                            if (object.paths != null)
                                message.paths = String(object.paths);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.updateMask != null)
                                message.updateMask = String(object.updateMask);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateRegionCommitmentRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdateRegionCommitmentRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdateRegionCommitmentRequest} message UpdateRegionCommitmentRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateRegionCommitmentRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.commitmentResource = null;
                                object.commitment = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.paths != null && message.hasOwnProperty("paths")) {
                                object.paths = message.paths;
                                if (options.oneofs)
                                    object._paths = "paths";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.commitmentResource != null && message.hasOwnProperty("commitmentResource"))
                                object.commitmentResource = $root.google.cloud.compute.v1.Commitment.toObject(message.commitmentResource, options);
                            if (message.commitment != null && message.hasOwnProperty("commitment"))
                                object.commitment = message.commitment;
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                object.updateMask = message.updateMask;
                                if (options.oneofs)
                                    object._updateMask = "updateMask";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UpdateRegionCommitmentRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdateRegionCommitmentRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateRegionCommitmentRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateRegionCommitmentRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdateRegionCommitmentRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateRegionCommitmentRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdateRegionCommitmentRequest";
                        };
    
                        return UpdateRegionCommitmentRequest;
                    })();
    
                    v1.UpdateRegionHealthCheckRequest = (function() {
    
                        /**
                         * Properties of an UpdateRegionHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdateRegionHealthCheckRequest
                         * @property {string|null} [healthCheck] UpdateRegionHealthCheckRequest healthCheck
                         * @property {google.cloud.compute.v1.IHealthCheck|null} [healthCheckResource] UpdateRegionHealthCheckRequest healthCheckResource
                         * @property {string|null} [project] UpdateRegionHealthCheckRequest project
                         * @property {string|null} [region] UpdateRegionHealthCheckRequest region
                         * @property {string|null} [requestId] UpdateRegionHealthCheckRequest requestId
                         */
    
                        /**
                         * Constructs a new UpdateRegionHealthCheckRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdateRegionHealthCheckRequest.
                         * @implements IUpdateRegionHealthCheckRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdateRegionHealthCheckRequest=} [properties] Properties to set
                         */
                        function UpdateRegionHealthCheckRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateRegionHealthCheckRequest healthCheck.
                         * @member {string} healthCheck
                         * @memberof google.cloud.compute.v1.UpdateRegionHealthCheckRequest
                         * @instance
                         */
                        UpdateRegionHealthCheckRequest.prototype.healthCheck = "";
    
                        /**
                         * UpdateRegionHealthCheckRequest healthCheckResource.
                         * @member {google.cloud.compute.v1.IHealthCheck|null|undefined} healthCheckResource
                         * @memberof google.cloud.compute.v1.UpdateRegionHealthCheckRequest
                         * @instance
                         */
                        UpdateRegionHealthCheckRequest.prototype.healthCheckResource = null;
    
                        /**
                         * UpdateRegionHealthCheckRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdateRegionHealthCheckRequest
                         * @instance
                         */
                        UpdateRegionHealthCheckRequest.prototype.project = "";
    
                        /**
                         * UpdateRegionHealthCheckRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.UpdateRegionHealthCheckRequest
                         * @instance
                         */
                        UpdateRegionHealthCheckRequest.prototype.region = "";
    
                        /**
                         * UpdateRegionHealthCheckRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdateRegionHealthCheckRequest
                         * @instance
                         */
                        UpdateRegionHealthCheckRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdateRegionHealthCheckRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdateRegionHealthCheckRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateRegionHealthCheckRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdateRegionHealthCheckRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdateRegionHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateRegionHealthCheckRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdateRegionHealthCheckRequest} UpdateRegionHealthCheckRequest instance
                         */
                        UpdateRegionHealthCheckRequest.create = function create(properties) {
                            return new UpdateRegionHealthCheckRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateRegionHealthCheckRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdateRegionHealthCheckRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdateRegionHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateRegionHealthCheckRequest} message UpdateRegionHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateRegionHealthCheckRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.healthCheckResource != null && Object.hasOwnProperty.call(message, "healthCheckResource"))
                                $root.google.cloud.compute.v1.HealthCheck.encode(message.healthCheckResource, writer.uint32(/* id 201925032, wireType 2 =*/1615400258).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.healthCheck != null && Object.hasOwnProperty.call(message, "healthCheck"))
                                writer.uint32(/* id 308876645, wireType 2 =*/2471013162).string(message.healthCheck);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateRegionHealthCheckRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdateRegionHealthCheckRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateRegionHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateRegionHealthCheckRequest} message UpdateRegionHealthCheckRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateRegionHealthCheckRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateRegionHealthCheckRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdateRegionHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdateRegionHealthCheckRequest} UpdateRegionHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateRegionHealthCheckRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdateRegionHealthCheckRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 308876645: {
                                        message.healthCheck = reader.string();
                                        break;
                                    }
                                case 201925032: {
                                        message.healthCheckResource = $root.google.cloud.compute.v1.HealthCheck.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateRegionHealthCheckRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateRegionHealthCheckRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdateRegionHealthCheckRequest} UpdateRegionHealthCheckRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateRegionHealthCheckRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateRegionHealthCheckRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdateRegionHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateRegionHealthCheckRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck"))
                                if (!$util.isString(message.healthCheck))
                                    return "healthCheck: string expected";
                            if (message.healthCheckResource != null && message.hasOwnProperty("healthCheckResource")) {
                                var error = $root.google.cloud.compute.v1.HealthCheck.verify(message.healthCheckResource);
                                if (error)
                                    return "healthCheckResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateRegionHealthCheckRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdateRegionHealthCheckRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdateRegionHealthCheckRequest} UpdateRegionHealthCheckRequest
                         */
                        UpdateRegionHealthCheckRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdateRegionHealthCheckRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdateRegionHealthCheckRequest();
                            if (object.healthCheck != null)
                                message.healthCheck = String(object.healthCheck);
                            if (object.healthCheckResource != null) {
                                if (typeof object.healthCheckResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdateRegionHealthCheckRequest.healthCheckResource: object expected");
                                message.healthCheckResource = $root.google.cloud.compute.v1.HealthCheck.fromObject(object.healthCheckResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateRegionHealthCheckRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdateRegionHealthCheckRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdateRegionHealthCheckRequest} message UpdateRegionHealthCheckRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateRegionHealthCheckRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.healthCheckResource = null;
                                object.project = "";
                                object.healthCheck = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.healthCheckResource != null && message.hasOwnProperty("healthCheckResource"))
                                object.healthCheckResource = $root.google.cloud.compute.v1.HealthCheck.toObject(message.healthCheckResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.healthCheck != null && message.hasOwnProperty("healthCheck"))
                                object.healthCheck = message.healthCheck;
                            return object;
                        };
    
                        /**
                         * Converts this UpdateRegionHealthCheckRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdateRegionHealthCheckRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateRegionHealthCheckRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateRegionHealthCheckRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdateRegionHealthCheckRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateRegionHealthCheckRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdateRegionHealthCheckRequest";
                        };
    
                        return UpdateRegionHealthCheckRequest;
                    })();
    
                    v1.UpdateRegionUrlMapRequest = (function() {
    
                        /**
                         * Properties of an UpdateRegionUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdateRegionUrlMapRequest
                         * @property {string|null} [project] UpdateRegionUrlMapRequest project
                         * @property {string|null} [region] UpdateRegionUrlMapRequest region
                         * @property {string|null} [requestId] UpdateRegionUrlMapRequest requestId
                         * @property {string|null} [urlMap] UpdateRegionUrlMapRequest urlMap
                         * @property {google.cloud.compute.v1.IUrlMap|null} [urlMapResource] UpdateRegionUrlMapRequest urlMapResource
                         */
    
                        /**
                         * Constructs a new UpdateRegionUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdateRegionUrlMapRequest.
                         * @implements IUpdateRegionUrlMapRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdateRegionUrlMapRequest=} [properties] Properties to set
                         */
                        function UpdateRegionUrlMapRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateRegionUrlMapRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdateRegionUrlMapRequest
                         * @instance
                         */
                        UpdateRegionUrlMapRequest.prototype.project = "";
    
                        /**
                         * UpdateRegionUrlMapRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.UpdateRegionUrlMapRequest
                         * @instance
                         */
                        UpdateRegionUrlMapRequest.prototype.region = "";
    
                        /**
                         * UpdateRegionUrlMapRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdateRegionUrlMapRequest
                         * @instance
                         */
                        UpdateRegionUrlMapRequest.prototype.requestId = null;
    
                        /**
                         * UpdateRegionUrlMapRequest urlMap.
                         * @member {string} urlMap
                         * @memberof google.cloud.compute.v1.UpdateRegionUrlMapRequest
                         * @instance
                         */
                        UpdateRegionUrlMapRequest.prototype.urlMap = "";
    
                        /**
                         * UpdateRegionUrlMapRequest urlMapResource.
                         * @member {google.cloud.compute.v1.IUrlMap|null|undefined} urlMapResource
                         * @memberof google.cloud.compute.v1.UpdateRegionUrlMapRequest
                         * @instance
                         */
                        UpdateRegionUrlMapRequest.prototype.urlMapResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdateRegionUrlMapRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdateRegionUrlMapRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateRegionUrlMapRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdateRegionUrlMapRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdateRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateRegionUrlMapRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdateRegionUrlMapRequest} UpdateRegionUrlMapRequest instance
                         */
                        UpdateRegionUrlMapRequest.create = function create(properties) {
                            return new UpdateRegionUrlMapRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateRegionUrlMapRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdateRegionUrlMapRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdateRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateRegionUrlMapRequest} message UpdateRegionUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateRegionUrlMapRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.urlMapResource != null && Object.hasOwnProperty.call(message, "urlMapResource"))
                                $root.google.cloud.compute.v1.UrlMap.encode(message.urlMapResource, writer.uint32(/* id 168675425, wireType 2 =*/1349403402).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.urlMap != null && Object.hasOwnProperty.call(message, "urlMap"))
                                writer.uint32(/* id 367020684, wireType 2 =*/2936165474).string(message.urlMap);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateRegionUrlMapRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdateRegionUrlMapRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateRegionUrlMapRequest} message UpdateRegionUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateRegionUrlMapRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateRegionUrlMapRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdateRegionUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdateRegionUrlMapRequest} UpdateRegionUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateRegionUrlMapRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdateRegionUrlMapRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 367020684: {
                                        message.urlMap = reader.string();
                                        break;
                                    }
                                case 168675425: {
                                        message.urlMapResource = $root.google.cloud.compute.v1.UrlMap.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateRegionUrlMapRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateRegionUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdateRegionUrlMapRequest} UpdateRegionUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateRegionUrlMapRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateRegionUrlMapRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdateRegionUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateRegionUrlMapRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                if (!$util.isString(message.urlMap))
                                    return "urlMap: string expected";
                            if (message.urlMapResource != null && message.hasOwnProperty("urlMapResource")) {
                                var error = $root.google.cloud.compute.v1.UrlMap.verify(message.urlMapResource);
                                if (error)
                                    return "urlMapResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateRegionUrlMapRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdateRegionUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdateRegionUrlMapRequest} UpdateRegionUrlMapRequest
                         */
                        UpdateRegionUrlMapRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdateRegionUrlMapRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdateRegionUrlMapRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.urlMap != null)
                                message.urlMap = String(object.urlMap);
                            if (object.urlMapResource != null) {
                                if (typeof object.urlMapResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdateRegionUrlMapRequest.urlMapResource: object expected");
                                message.urlMapResource = $root.google.cloud.compute.v1.UrlMap.fromObject(object.urlMapResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateRegionUrlMapRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdateRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdateRegionUrlMapRequest} message UpdateRegionUrlMapRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateRegionUrlMapRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.urlMapResource = null;
                                object.project = "";
                                object.urlMap = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.urlMapResource != null && message.hasOwnProperty("urlMapResource"))
                                object.urlMapResource = $root.google.cloud.compute.v1.UrlMap.toObject(message.urlMapResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                object.urlMap = message.urlMap;
                            return object;
                        };
    
                        /**
                         * Converts this UpdateRegionUrlMapRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdateRegionUrlMapRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateRegionUrlMapRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateRegionUrlMapRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdateRegionUrlMapRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateRegionUrlMapRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdateRegionUrlMapRequest";
                        };
    
                        return UpdateRegionUrlMapRequest;
                    })();
    
                    v1.UpdateReservationRequest = (function() {
    
                        /**
                         * Properties of an UpdateReservationRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdateReservationRequest
                         * @property {string|null} [paths] UpdateReservationRequest paths
                         * @property {string|null} [project] UpdateReservationRequest project
                         * @property {string|null} [requestId] UpdateReservationRequest requestId
                         * @property {string|null} [reservation] UpdateReservationRequest reservation
                         * @property {google.cloud.compute.v1.IReservation|null} [reservationResource] UpdateReservationRequest reservationResource
                         * @property {string|null} [updateMask] UpdateReservationRequest updateMask
                         * @property {string|null} [zone] UpdateReservationRequest zone
                         */
    
                        /**
                         * Constructs a new UpdateReservationRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdateReservationRequest.
                         * @implements IUpdateReservationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdateReservationRequest=} [properties] Properties to set
                         */
                        function UpdateReservationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateReservationRequest paths.
                         * @member {string|null|undefined} paths
                         * @memberof google.cloud.compute.v1.UpdateReservationRequest
                         * @instance
                         */
                        UpdateReservationRequest.prototype.paths = null;
    
                        /**
                         * UpdateReservationRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdateReservationRequest
                         * @instance
                         */
                        UpdateReservationRequest.prototype.project = "";
    
                        /**
                         * UpdateReservationRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdateReservationRequest
                         * @instance
                         */
                        UpdateReservationRequest.prototype.requestId = null;
    
                        /**
                         * UpdateReservationRequest reservation.
                         * @member {string} reservation
                         * @memberof google.cloud.compute.v1.UpdateReservationRequest
                         * @instance
                         */
                        UpdateReservationRequest.prototype.reservation = "";
    
                        /**
                         * UpdateReservationRequest reservationResource.
                         * @member {google.cloud.compute.v1.IReservation|null|undefined} reservationResource
                         * @memberof google.cloud.compute.v1.UpdateReservationRequest
                         * @instance
                         */
                        UpdateReservationRequest.prototype.reservationResource = null;
    
                        /**
                         * UpdateReservationRequest updateMask.
                         * @member {string|null|undefined} updateMask
                         * @memberof google.cloud.compute.v1.UpdateReservationRequest
                         * @instance
                         */
                        UpdateReservationRequest.prototype.updateMask = null;
    
                        /**
                         * UpdateReservationRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.UpdateReservationRequest
                         * @instance
                         */
                        UpdateReservationRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdateReservationRequest _paths.
                         * @member {"paths"|undefined} _paths
                         * @memberof google.cloud.compute.v1.UpdateReservationRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateReservationRequest.prototype, "_paths", {
                            get: $util.oneOfGetter($oneOfFields = ["paths"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UpdateReservationRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdateReservationRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateReservationRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UpdateReservationRequest _updateMask.
                         * @member {"updateMask"|undefined} _updateMask
                         * @memberof google.cloud.compute.v1.UpdateReservationRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateReservationRequest.prototype, "_updateMask", {
                            get: $util.oneOfGetter($oneOfFields = ["updateMask"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdateReservationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdateReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateReservationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdateReservationRequest} UpdateReservationRequest instance
                         */
                        UpdateReservationRequest.create = function create(properties) {
                            return new UpdateReservationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateReservationRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdateReservationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdateReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateReservationRequest} message UpdateReservationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateReservationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.reservation != null && Object.hasOwnProperty.call(message, "reservation"))
                                writer.uint32(/* id 47530956, wireType 2 =*/380247650).string(message.reservation);
                            if (message.paths != null && Object.hasOwnProperty.call(message, "paths"))
                                writer.uint32(/* id 106438894, wireType 2 =*/851511154).string(message.paths);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.reservationResource != null && Object.hasOwnProperty.call(message, "reservationResource"))
                                $root.google.cloud.compute.v1.Reservation.encode(message.reservationResource, writer.uint32(/* id 285030177, wireType 2 =*/2280241418).fork()).ldelim();
                            if (message.updateMask != null && Object.hasOwnProperty.call(message, "updateMask"))
                                writer.uint32(/* id 500079778, wireType 2 =*/4000638226).string(message.updateMask);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateReservationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdateReservationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateReservationRequest} message UpdateReservationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateReservationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateReservationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdateReservationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdateReservationRequest} UpdateReservationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateReservationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdateReservationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 106438894: {
                                        message.paths = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 47530956: {
                                        message.reservation = reader.string();
                                        break;
                                    }
                                case 285030177: {
                                        message.reservationResource = $root.google.cloud.compute.v1.Reservation.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 500079778: {
                                        message.updateMask = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateReservationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateReservationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdateReservationRequest} UpdateReservationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateReservationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateReservationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdateReservationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateReservationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.paths != null && message.hasOwnProperty("paths")) {
                                properties._paths = 1;
                                if (!$util.isString(message.paths))
                                    return "paths: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.reservation != null && message.hasOwnProperty("reservation"))
                                if (!$util.isString(message.reservation))
                                    return "reservation: string expected";
                            if (message.reservationResource != null && message.hasOwnProperty("reservationResource")) {
                                var error = $root.google.cloud.compute.v1.Reservation.verify(message.reservationResource);
                                if (error)
                                    return "reservationResource." + error;
                            }
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                properties._updateMask = 1;
                                if (!$util.isString(message.updateMask))
                                    return "updateMask: string expected";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an UpdateReservationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdateReservationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdateReservationRequest} UpdateReservationRequest
                         */
                        UpdateReservationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdateReservationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdateReservationRequest();
                            if (object.paths != null)
                                message.paths = String(object.paths);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.reservation != null)
                                message.reservation = String(object.reservation);
                            if (object.reservationResource != null) {
                                if (typeof object.reservationResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdateReservationRequest.reservationResource: object expected");
                                message.reservationResource = $root.google.cloud.compute.v1.Reservation.fromObject(object.reservationResource);
                            }
                            if (object.updateMask != null)
                                message.updateMask = String(object.updateMask);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateReservationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdateReservationRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdateReservationRequest} message UpdateReservationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateReservationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.reservation = "";
                                object.project = "";
                                object.reservationResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.reservation != null && message.hasOwnProperty("reservation"))
                                object.reservation = message.reservation;
                            if (message.paths != null && message.hasOwnProperty("paths")) {
                                object.paths = message.paths;
                                if (options.oneofs)
                                    object._paths = "paths";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.reservationResource != null && message.hasOwnProperty("reservationResource"))
                                object.reservationResource = $root.google.cloud.compute.v1.Reservation.toObject(message.reservationResource, options);
                            if (message.updateMask != null && message.hasOwnProperty("updateMask")) {
                                object.updateMask = message.updateMask;
                                if (options.oneofs)
                                    object._updateMask = "updateMask";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UpdateReservationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdateReservationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateReservationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateReservationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdateReservationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateReservationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdateReservationRequest";
                        };
    
                        return UpdateReservationRequest;
                    })();
    
                    v1.UpdateRouterRequest = (function() {
    
                        /**
                         * Properties of an UpdateRouterRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdateRouterRequest
                         * @property {string|null} [project] UpdateRouterRequest project
                         * @property {string|null} [region] UpdateRouterRequest region
                         * @property {string|null} [requestId] UpdateRouterRequest requestId
                         * @property {string|null} [router] UpdateRouterRequest router
                         * @property {google.cloud.compute.v1.IRouter|null} [routerResource] UpdateRouterRequest routerResource
                         */
    
                        /**
                         * Constructs a new UpdateRouterRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdateRouterRequest.
                         * @implements IUpdateRouterRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdateRouterRequest=} [properties] Properties to set
                         */
                        function UpdateRouterRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateRouterRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdateRouterRequest
                         * @instance
                         */
                        UpdateRouterRequest.prototype.project = "";
    
                        /**
                         * UpdateRouterRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.UpdateRouterRequest
                         * @instance
                         */
                        UpdateRouterRequest.prototype.region = "";
    
                        /**
                         * UpdateRouterRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdateRouterRequest
                         * @instance
                         */
                        UpdateRouterRequest.prototype.requestId = null;
    
                        /**
                         * UpdateRouterRequest router.
                         * @member {string} router
                         * @memberof google.cloud.compute.v1.UpdateRouterRequest
                         * @instance
                         */
                        UpdateRouterRequest.prototype.router = "";
    
                        /**
                         * UpdateRouterRequest routerResource.
                         * @member {google.cloud.compute.v1.IRouter|null|undefined} routerResource
                         * @memberof google.cloud.compute.v1.UpdateRouterRequest
                         * @instance
                         */
                        UpdateRouterRequest.prototype.routerResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdateRouterRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdateRouterRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateRouterRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdateRouterRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdateRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateRouterRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdateRouterRequest} UpdateRouterRequest instance
                         */
                        UpdateRouterRequest.create = function create(properties) {
                            return new UpdateRouterRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateRouterRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdateRouterRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdateRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateRouterRequest} message UpdateRouterRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateRouterRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.router != null && Object.hasOwnProperty.call(message, "router"))
                                writer.uint32(/* id 148608841, wireType 2 =*/1188870730).string(message.router);
                            if (message.routerResource != null && Object.hasOwnProperty.call(message, "routerResource"))
                                $root.google.cloud.compute.v1.Router.encode(message.routerResource, writer.uint32(/* id 155222084, wireType 2 =*/1241776674).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateRouterRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdateRouterRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateRouterRequest} message UpdateRouterRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateRouterRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateRouterRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdateRouterRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdateRouterRequest} UpdateRouterRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateRouterRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdateRouterRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 148608841: {
                                        message.router = reader.string();
                                        break;
                                    }
                                case 155222084: {
                                        message.routerResource = $root.google.cloud.compute.v1.Router.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateRouterRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateRouterRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdateRouterRequest} UpdateRouterRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateRouterRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateRouterRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdateRouterRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateRouterRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.router != null && message.hasOwnProperty("router"))
                                if (!$util.isString(message.router))
                                    return "router: string expected";
                            if (message.routerResource != null && message.hasOwnProperty("routerResource")) {
                                var error = $root.google.cloud.compute.v1.Router.verify(message.routerResource);
                                if (error)
                                    return "routerResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateRouterRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdateRouterRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdateRouterRequest} UpdateRouterRequest
                         */
                        UpdateRouterRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdateRouterRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdateRouterRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.router != null)
                                message.router = String(object.router);
                            if (object.routerResource != null) {
                                if (typeof object.routerResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdateRouterRequest.routerResource: object expected");
                                message.routerResource = $root.google.cloud.compute.v1.Router.fromObject(object.routerResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateRouterRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdateRouterRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdateRouterRequest} message UpdateRouterRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateRouterRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.router = "";
                                object.routerResource = null;
                                object.project = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.router != null && message.hasOwnProperty("router"))
                                object.router = message.router;
                            if (message.routerResource != null && message.hasOwnProperty("routerResource"))
                                object.routerResource = $root.google.cloud.compute.v1.Router.toObject(message.routerResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this UpdateRouterRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdateRouterRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateRouterRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateRouterRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdateRouterRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateRouterRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdateRouterRequest";
                        };
    
                        return UpdateRouterRequest;
                    })();
    
                    v1.UpdateShieldedInstanceConfigInstanceRequest = (function() {
    
                        /**
                         * Properties of an UpdateShieldedInstanceConfigInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdateShieldedInstanceConfigInstanceRequest
                         * @property {string|null} [instance] UpdateShieldedInstanceConfigInstanceRequest instance
                         * @property {string|null} [project] UpdateShieldedInstanceConfigInstanceRequest project
                         * @property {string|null} [requestId] UpdateShieldedInstanceConfigInstanceRequest requestId
                         * @property {google.cloud.compute.v1.IShieldedInstanceConfig|null} [shieldedInstanceConfigResource] UpdateShieldedInstanceConfigInstanceRequest shieldedInstanceConfigResource
                         * @property {string|null} [zone] UpdateShieldedInstanceConfigInstanceRequest zone
                         */
    
                        /**
                         * Constructs a new UpdateShieldedInstanceConfigInstanceRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdateShieldedInstanceConfigInstanceRequest.
                         * @implements IUpdateShieldedInstanceConfigInstanceRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdateShieldedInstanceConfigInstanceRequest=} [properties] Properties to set
                         */
                        function UpdateShieldedInstanceConfigInstanceRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateShieldedInstanceConfigInstanceRequest instance.
                         * @member {string} instance
                         * @memberof google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest
                         * @instance
                         */
                        UpdateShieldedInstanceConfigInstanceRequest.prototype.instance = "";
    
                        /**
                         * UpdateShieldedInstanceConfigInstanceRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest
                         * @instance
                         */
                        UpdateShieldedInstanceConfigInstanceRequest.prototype.project = "";
    
                        /**
                         * UpdateShieldedInstanceConfigInstanceRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest
                         * @instance
                         */
                        UpdateShieldedInstanceConfigInstanceRequest.prototype.requestId = null;
    
                        /**
                         * UpdateShieldedInstanceConfigInstanceRequest shieldedInstanceConfigResource.
                         * @member {google.cloud.compute.v1.IShieldedInstanceConfig|null|undefined} shieldedInstanceConfigResource
                         * @memberof google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest
                         * @instance
                         */
                        UpdateShieldedInstanceConfigInstanceRequest.prototype.shieldedInstanceConfigResource = null;
    
                        /**
                         * UpdateShieldedInstanceConfigInstanceRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest
                         * @instance
                         */
                        UpdateShieldedInstanceConfigInstanceRequest.prototype.zone = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdateShieldedInstanceConfigInstanceRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateShieldedInstanceConfigInstanceRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdateShieldedInstanceConfigInstanceRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateShieldedInstanceConfigInstanceRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest} UpdateShieldedInstanceConfigInstanceRequest instance
                         */
                        UpdateShieldedInstanceConfigInstanceRequest.create = function create(properties) {
                            return new UpdateShieldedInstanceConfigInstanceRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateShieldedInstanceConfigInstanceRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateShieldedInstanceConfigInstanceRequest} message UpdateShieldedInstanceConfigInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateShieldedInstanceConfigInstanceRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.instance != null && Object.hasOwnProperty.call(message, "instance"))
                                writer.uint32(/* id 18257045, wireType 2 =*/146056362).string(message.instance);
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.shieldedInstanceConfigResource != null && Object.hasOwnProperty.call(message, "shieldedInstanceConfigResource"))
                                $root.google.cloud.compute.v1.ShieldedInstanceConfig.encode(message.shieldedInstanceConfigResource, writer.uint32(/* id 272059224, wireType 2 =*/2176473794).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateShieldedInstanceConfigInstanceRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateShieldedInstanceConfigInstanceRequest} message UpdateShieldedInstanceConfigInstanceRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateShieldedInstanceConfigInstanceRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateShieldedInstanceConfigInstanceRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest} UpdateShieldedInstanceConfigInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateShieldedInstanceConfigInstanceRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 18257045: {
                                        message.instance = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 272059224: {
                                        message.shieldedInstanceConfigResource = $root.google.cloud.compute.v1.ShieldedInstanceConfig.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateShieldedInstanceConfigInstanceRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest} UpdateShieldedInstanceConfigInstanceRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateShieldedInstanceConfigInstanceRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateShieldedInstanceConfigInstanceRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateShieldedInstanceConfigInstanceRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                if (!$util.isString(message.instance))
                                    return "instance: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.shieldedInstanceConfigResource != null && message.hasOwnProperty("shieldedInstanceConfigResource")) {
                                var error = $root.google.cloud.compute.v1.ShieldedInstanceConfig.verify(message.shieldedInstanceConfigResource);
                                if (error)
                                    return "shieldedInstanceConfigResource." + error;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an UpdateShieldedInstanceConfigInstanceRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest} UpdateShieldedInstanceConfigInstanceRequest
                         */
                        UpdateShieldedInstanceConfigInstanceRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest();
                            if (object.instance != null)
                                message.instance = String(object.instance);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.shieldedInstanceConfigResource != null) {
                                if (typeof object.shieldedInstanceConfigResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest.shieldedInstanceConfigResource: object expected");
                                message.shieldedInstanceConfigResource = $root.google.cloud.compute.v1.ShieldedInstanceConfig.fromObject(object.shieldedInstanceConfigResource);
                            }
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateShieldedInstanceConfigInstanceRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest} message UpdateShieldedInstanceConfigInstanceRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateShieldedInstanceConfigInstanceRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.instance = "";
                                object.project = "";
                                object.shieldedInstanceConfigResource = null;
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.instance != null && message.hasOwnProperty("instance"))
                                object.instance = message.instance;
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.shieldedInstanceConfigResource != null && message.hasOwnProperty("shieldedInstanceConfigResource"))
                                object.shieldedInstanceConfigResource = $root.google.cloud.compute.v1.ShieldedInstanceConfig.toObject(message.shieldedInstanceConfigResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this UpdateShieldedInstanceConfigInstanceRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateShieldedInstanceConfigInstanceRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateShieldedInstanceConfigInstanceRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateShieldedInstanceConfigInstanceRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest";
                        };
    
                        return UpdateShieldedInstanceConfigInstanceRequest;
                    })();
    
                    v1.UpdateUrlMapRequest = (function() {
    
                        /**
                         * Properties of an UpdateUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUpdateUrlMapRequest
                         * @property {string|null} [project] UpdateUrlMapRequest project
                         * @property {string|null} [requestId] UpdateUrlMapRequest requestId
                         * @property {string|null} [urlMap] UpdateUrlMapRequest urlMap
                         * @property {google.cloud.compute.v1.IUrlMap|null} [urlMapResource] UpdateUrlMapRequest urlMapResource
                         */
    
                        /**
                         * Constructs a new UpdateUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UpdateUrlMapRequest.
                         * @implements IUpdateUrlMapRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUpdateUrlMapRequest=} [properties] Properties to set
                         */
                        function UpdateUrlMapRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UpdateUrlMapRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.UpdateUrlMapRequest
                         * @instance
                         */
                        UpdateUrlMapRequest.prototype.project = "";
    
                        /**
                         * UpdateUrlMapRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1.UpdateUrlMapRequest
                         * @instance
                         */
                        UpdateUrlMapRequest.prototype.requestId = null;
    
                        /**
                         * UpdateUrlMapRequest urlMap.
                         * @member {string} urlMap
                         * @memberof google.cloud.compute.v1.UpdateUrlMapRequest
                         * @instance
                         */
                        UpdateUrlMapRequest.prototype.urlMap = "";
    
                        /**
                         * UpdateUrlMapRequest urlMapResource.
                         * @member {google.cloud.compute.v1.IUrlMap|null|undefined} urlMapResource
                         * @memberof google.cloud.compute.v1.UpdateUrlMapRequest
                         * @instance
                         */
                        UpdateUrlMapRequest.prototype.urlMapResource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UpdateUrlMapRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1.UpdateUrlMapRequest
                         * @instance
                         */
                        Object.defineProperty(UpdateUrlMapRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UpdateUrlMapRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UpdateUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateUrlMapRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UpdateUrlMapRequest} UpdateUrlMapRequest instance
                         */
                        UpdateUrlMapRequest.create = function create(properties) {
                            return new UpdateUrlMapRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UpdateUrlMapRequest message. Does not implicitly {@link google.cloud.compute.v1.UpdateUrlMapRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UpdateUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateUrlMapRequest} message UpdateUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateUrlMapRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.urlMapResource != null && Object.hasOwnProperty.call(message, "urlMapResource"))
                                $root.google.cloud.compute.v1.UrlMap.encode(message.urlMapResource, writer.uint32(/* id 168675425, wireType 2 =*/1349403402).fork()).ldelim();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.urlMap != null && Object.hasOwnProperty.call(message, "urlMap"))
                                writer.uint32(/* id 367020684, wireType 2 =*/2936165474).string(message.urlMap);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UpdateUrlMapRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UpdateUrlMapRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUpdateUrlMapRequest} message UpdateUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UpdateUrlMapRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UpdateUrlMapRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UpdateUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UpdateUrlMapRequest} UpdateUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateUrlMapRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UpdateUrlMapRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                case 367020684: {
                                        message.urlMap = reader.string();
                                        break;
                                    }
                                case 168675425: {
                                        message.urlMapResource = $root.google.cloud.compute.v1.UrlMap.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UpdateUrlMapRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UpdateUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UpdateUrlMapRequest} UpdateUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UpdateUrlMapRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UpdateUrlMapRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UpdateUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UpdateUrlMapRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                if (!$util.isString(message.urlMap))
                                    return "urlMap: string expected";
                            if (message.urlMapResource != null && message.hasOwnProperty("urlMapResource")) {
                                var error = $root.google.cloud.compute.v1.UrlMap.verify(message.urlMapResource);
                                if (error)
                                    return "urlMapResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UpdateUrlMapRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UpdateUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UpdateUrlMapRequest} UpdateUrlMapRequest
                         */
                        UpdateUrlMapRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UpdateUrlMapRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UpdateUrlMapRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            if (object.urlMap != null)
                                message.urlMap = String(object.urlMap);
                            if (object.urlMapResource != null) {
                                if (typeof object.urlMapResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UpdateUrlMapRequest.urlMapResource: object expected");
                                message.urlMapResource = $root.google.cloud.compute.v1.UrlMap.fromObject(object.urlMapResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UpdateUrlMapRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UpdateUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.UpdateUrlMapRequest} message UpdateUrlMapRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UpdateUrlMapRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.urlMapResource = null;
                                object.project = "";
                                object.urlMap = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.urlMapResource != null && message.hasOwnProperty("urlMapResource"))
                                object.urlMapResource = $root.google.cloud.compute.v1.UrlMap.toObject(message.urlMapResource, options);
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                object.urlMap = message.urlMap;
                            return object;
                        };
    
                        /**
                         * Converts this UpdateUrlMapRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UpdateUrlMapRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UpdateUrlMapRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UpdateUrlMapRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UpdateUrlMapRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UpdateUrlMapRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UpdateUrlMapRequest";
                        };
    
                        return UpdateUrlMapRequest;
                    })();
    
                    v1.UrlMap = (function() {
    
                        /**
                         * Properties of an UrlMap.
                         * @memberof google.cloud.compute.v1
                         * @interface IUrlMap
                         * @property {string|null} [creationTimestamp] UrlMap creationTimestamp
                         * @property {google.cloud.compute.v1.IHttpRouteAction|null} [defaultRouteAction] UrlMap defaultRouteAction
                         * @property {string|null} [defaultService] UrlMap defaultService
                         * @property {google.cloud.compute.v1.IHttpRedirectAction|null} [defaultUrlRedirect] UrlMap defaultUrlRedirect
                         * @property {string|null} [description] UrlMap description
                         * @property {string|null} [fingerprint] UrlMap fingerprint
                         * @property {google.cloud.compute.v1.IHttpHeaderAction|null} [headerAction] UrlMap headerAction
                         * @property {Array.<google.cloud.compute.v1.IHostRule>|null} [hostRules] UrlMap hostRules
                         * @property {number|Long|null} [id] UrlMap id
                         * @property {string|null} [kind] UrlMap kind
                         * @property {string|null} [name] UrlMap name
                         * @property {Array.<google.cloud.compute.v1.IPathMatcher>|null} [pathMatchers] UrlMap pathMatchers
                         * @property {string|null} [region] UrlMap region
                         * @property {string|null} [selfLink] UrlMap selfLink
                         * @property {Array.<google.cloud.compute.v1.IUrlMapTest>|null} [tests] UrlMap tests
                         */
    
                        /**
                         * Constructs a new UrlMap.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UrlMap.
                         * @implements IUrlMap
                         * @constructor
                         * @param {google.cloud.compute.v1.IUrlMap=} [properties] Properties to set
                         */
                        function UrlMap(properties) {
                            this.hostRules = [];
                            this.pathMatchers = [];
                            this.tests = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UrlMap creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        UrlMap.prototype.creationTimestamp = null;
    
                        /**
                         * UrlMap defaultRouteAction.
                         * @member {google.cloud.compute.v1.IHttpRouteAction|null|undefined} defaultRouteAction
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        UrlMap.prototype.defaultRouteAction = null;
    
                        /**
                         * UrlMap defaultService.
                         * @member {string|null|undefined} defaultService
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        UrlMap.prototype.defaultService = null;
    
                        /**
                         * UrlMap defaultUrlRedirect.
                         * @member {google.cloud.compute.v1.IHttpRedirectAction|null|undefined} defaultUrlRedirect
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        UrlMap.prototype.defaultUrlRedirect = null;
    
                        /**
                         * UrlMap description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        UrlMap.prototype.description = null;
    
                        /**
                         * UrlMap fingerprint.
                         * @member {string|null|undefined} fingerprint
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        UrlMap.prototype.fingerprint = null;
    
                        /**
                         * UrlMap headerAction.
                         * @member {google.cloud.compute.v1.IHttpHeaderAction|null|undefined} headerAction
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        UrlMap.prototype.headerAction = null;
    
                        /**
                         * UrlMap hostRules.
                         * @member {Array.<google.cloud.compute.v1.IHostRule>} hostRules
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        UrlMap.prototype.hostRules = $util.emptyArray;
    
                        /**
                         * UrlMap id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        UrlMap.prototype.id = null;
    
                        /**
                         * UrlMap kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        UrlMap.prototype.kind = null;
    
                        /**
                         * UrlMap name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        UrlMap.prototype.name = null;
    
                        /**
                         * UrlMap pathMatchers.
                         * @member {Array.<google.cloud.compute.v1.IPathMatcher>} pathMatchers
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        UrlMap.prototype.pathMatchers = $util.emptyArray;
    
                        /**
                         * UrlMap region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        UrlMap.prototype.region = null;
    
                        /**
                         * UrlMap selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        UrlMap.prototype.selfLink = null;
    
                        /**
                         * UrlMap tests.
                         * @member {Array.<google.cloud.compute.v1.IUrlMapTest>} tests
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        UrlMap.prototype.tests = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UrlMap _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        Object.defineProperty(UrlMap.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMap _defaultRouteAction.
                         * @member {"defaultRouteAction"|undefined} _defaultRouteAction
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        Object.defineProperty(UrlMap.prototype, "_defaultRouteAction", {
                            get: $util.oneOfGetter($oneOfFields = ["defaultRouteAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMap _defaultService.
                         * @member {"defaultService"|undefined} _defaultService
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        Object.defineProperty(UrlMap.prototype, "_defaultService", {
                            get: $util.oneOfGetter($oneOfFields = ["defaultService"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMap _defaultUrlRedirect.
                         * @member {"defaultUrlRedirect"|undefined} _defaultUrlRedirect
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        Object.defineProperty(UrlMap.prototype, "_defaultUrlRedirect", {
                            get: $util.oneOfGetter($oneOfFields = ["defaultUrlRedirect"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMap _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        Object.defineProperty(UrlMap.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMap _fingerprint.
                         * @member {"fingerprint"|undefined} _fingerprint
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        Object.defineProperty(UrlMap.prototype, "_fingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["fingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMap _headerAction.
                         * @member {"headerAction"|undefined} _headerAction
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        Object.defineProperty(UrlMap.prototype, "_headerAction", {
                            get: $util.oneOfGetter($oneOfFields = ["headerAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMap _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        Object.defineProperty(UrlMap.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMap _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        Object.defineProperty(UrlMap.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMap _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        Object.defineProperty(UrlMap.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMap _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        Object.defineProperty(UrlMap.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMap _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         */
                        Object.defineProperty(UrlMap.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UrlMap instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMap=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UrlMap} UrlMap instance
                         */
                        UrlMap.create = function create(properties) {
                            return new UrlMap(properties);
                        };
    
                        /**
                         * Encodes the specified UrlMap message. Does not implicitly {@link google.cloud.compute.v1.UrlMap.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMap} message UrlMap message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlMap.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.tests != null && message.tests.length)
                                for (var i = 0; i < message.tests.length; ++i)
                                    $root.google.cloud.compute.v1.UrlMapTest.encode(message.tests[i], writer.uint32(/* id 110251553, wireType 2 =*/882012426).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.fingerprint != null && Object.hasOwnProperty.call(message, "fingerprint"))
                                writer.uint32(/* id 234678500, wireType 2 =*/1877428002).string(message.fingerprint);
                            if (message.pathMatchers != null && message.pathMatchers.length)
                                for (var i = 0; i < message.pathMatchers.length; ++i)
                                    $root.google.cloud.compute.v1.PathMatcher.encode(message.pathMatchers[i], writer.uint32(/* id 271664219, wireType 2 =*/2173313754).fork()).ldelim();
                            if (message.hostRules != null && message.hostRules.length)
                                for (var i = 0; i < message.hostRules.length; ++i)
                                    $root.google.cloud.compute.v1.HostRule.encode(message.hostRules[i], writer.uint32(/* id 311804832, wireType 2 =*/2494438658).fork()).ldelim();
                            if (message.headerAction != null && Object.hasOwnProperty.call(message, "headerAction"))
                                $root.google.cloud.compute.v1.HttpHeaderAction.encode(message.headerAction, writer.uint32(/* id 328077352, wireType 2 =*/2624618818).fork()).ldelim();
                            if (message.defaultUrlRedirect != null && Object.hasOwnProperty.call(message, "defaultUrlRedirect"))
                                $root.google.cloud.compute.v1.HttpRedirectAction.encode(message.defaultUrlRedirect, writer.uint32(/* id 359503338, wireType 2 =*/2876026706).fork()).ldelim();
                            if (message.defaultService != null && Object.hasOwnProperty.call(message, "defaultService"))
                                writer.uint32(/* id 370242231, wireType 2 =*/2961937850).string(message.defaultService);
                            if (message.defaultRouteAction != null && Object.hasOwnProperty.call(message, "defaultRouteAction"))
                                $root.google.cloud.compute.v1.HttpRouteAction.encode(message.defaultRouteAction, writer.uint32(/* id 378919466, wireType 2 =*/3031355730).fork()).ldelim();
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UrlMap message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UrlMap.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMap} message UrlMap message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlMap.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UrlMap message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UrlMap} UrlMap
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlMap.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UrlMap();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 378919466: {
                                        message.defaultRouteAction = $root.google.cloud.compute.v1.HttpRouteAction.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 370242231: {
                                        message.defaultService = reader.string();
                                        break;
                                    }
                                case 359503338: {
                                        message.defaultUrlRedirect = $root.google.cloud.compute.v1.HttpRedirectAction.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 234678500: {
                                        message.fingerprint = reader.string();
                                        break;
                                    }
                                case 328077352: {
                                        message.headerAction = $root.google.cloud.compute.v1.HttpHeaderAction.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 311804832: {
                                        if (!(message.hostRules && message.hostRules.length))
                                            message.hostRules = [];
                                        message.hostRules.push($root.google.cloud.compute.v1.HostRule.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 271664219: {
                                        if (!(message.pathMatchers && message.pathMatchers.length))
                                            message.pathMatchers = [];
                                        message.pathMatchers.push($root.google.cloud.compute.v1.PathMatcher.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 110251553: {
                                        if (!(message.tests && message.tests.length))
                                            message.tests = [];
                                        message.tests.push($root.google.cloud.compute.v1.UrlMapTest.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UrlMap message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UrlMap} UrlMap
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlMap.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UrlMap message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UrlMap.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.defaultRouteAction != null && message.hasOwnProperty("defaultRouteAction")) {
                                properties._defaultRouteAction = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HttpRouteAction.verify(message.defaultRouteAction);
                                    if (error)
                                        return "defaultRouteAction." + error;
                                }
                            }
                            if (message.defaultService != null && message.hasOwnProperty("defaultService")) {
                                properties._defaultService = 1;
                                if (!$util.isString(message.defaultService))
                                    return "defaultService: string expected";
                            }
                            if (message.defaultUrlRedirect != null && message.hasOwnProperty("defaultUrlRedirect")) {
                                properties._defaultUrlRedirect = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HttpRedirectAction.verify(message.defaultUrlRedirect);
                                    if (error)
                                        return "defaultUrlRedirect." + error;
                                }
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                properties._fingerprint = 1;
                                if (!$util.isString(message.fingerprint))
                                    return "fingerprint: string expected";
                            }
                            if (message.headerAction != null && message.hasOwnProperty("headerAction")) {
                                properties._headerAction = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HttpHeaderAction.verify(message.headerAction);
                                    if (error)
                                        return "headerAction." + error;
                                }
                            }
                            if (message.hostRules != null && message.hasOwnProperty("hostRules")) {
                                if (!Array.isArray(message.hostRules))
                                    return "hostRules: array expected";
                                for (var i = 0; i < message.hostRules.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.HostRule.verify(message.hostRules[i]);
                                    if (error)
                                        return "hostRules." + error;
                                }
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.pathMatchers != null && message.hasOwnProperty("pathMatchers")) {
                                if (!Array.isArray(message.pathMatchers))
                                    return "pathMatchers: array expected";
                                for (var i = 0; i < message.pathMatchers.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.PathMatcher.verify(message.pathMatchers[i]);
                                    if (error)
                                        return "pathMatchers." + error;
                                }
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.tests != null && message.hasOwnProperty("tests")) {
                                if (!Array.isArray(message.tests))
                                    return "tests: array expected";
                                for (var i = 0; i < message.tests.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.UrlMapTest.verify(message.tests[i]);
                                    if (error)
                                        return "tests." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UrlMap message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UrlMap} UrlMap
                         */
                        UrlMap.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UrlMap)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UrlMap();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.defaultRouteAction != null) {
                                if (typeof object.defaultRouteAction !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UrlMap.defaultRouteAction: object expected");
                                message.defaultRouteAction = $root.google.cloud.compute.v1.HttpRouteAction.fromObject(object.defaultRouteAction);
                            }
                            if (object.defaultService != null)
                                message.defaultService = String(object.defaultService);
                            if (object.defaultUrlRedirect != null) {
                                if (typeof object.defaultUrlRedirect !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UrlMap.defaultUrlRedirect: object expected");
                                message.defaultUrlRedirect = $root.google.cloud.compute.v1.HttpRedirectAction.fromObject(object.defaultUrlRedirect);
                            }
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.fingerprint != null)
                                message.fingerprint = String(object.fingerprint);
                            if (object.headerAction != null) {
                                if (typeof object.headerAction !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UrlMap.headerAction: object expected");
                                message.headerAction = $root.google.cloud.compute.v1.HttpHeaderAction.fromObject(object.headerAction);
                            }
                            if (object.hostRules) {
                                if (!Array.isArray(object.hostRules))
                                    throw TypeError(".google.cloud.compute.v1.UrlMap.hostRules: array expected");
                                message.hostRules = [];
                                for (var i = 0; i < object.hostRules.length; ++i) {
                                    if (typeof object.hostRules[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.UrlMap.hostRules: object expected");
                                    message.hostRules[i] = $root.google.cloud.compute.v1.HostRule.fromObject(object.hostRules[i]);
                                }
                            }
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.pathMatchers) {
                                if (!Array.isArray(object.pathMatchers))
                                    throw TypeError(".google.cloud.compute.v1.UrlMap.pathMatchers: array expected");
                                message.pathMatchers = [];
                                for (var i = 0; i < object.pathMatchers.length; ++i) {
                                    if (typeof object.pathMatchers[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.UrlMap.pathMatchers: object expected");
                                    message.pathMatchers[i] = $root.google.cloud.compute.v1.PathMatcher.fromObject(object.pathMatchers[i]);
                                }
                            }
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.tests) {
                                if (!Array.isArray(object.tests))
                                    throw TypeError(".google.cloud.compute.v1.UrlMap.tests: array expected");
                                message.tests = [];
                                for (var i = 0; i < object.tests.length; ++i) {
                                    if (typeof object.tests[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.UrlMap.tests: object expected");
                                    message.tests[i] = $root.google.cloud.compute.v1.UrlMapTest.fromObject(object.tests[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UrlMap message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @static
                         * @param {google.cloud.compute.v1.UrlMap} message UrlMap
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UrlMap.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.tests = [];
                                object.pathMatchers = [];
                                object.hostRules = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.tests && message.tests.length) {
                                object.tests = [];
                                for (var j = 0; j < message.tests.length; ++j)
                                    object.tests[j] = $root.google.cloud.compute.v1.UrlMapTest.toObject(message.tests[j], options);
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.fingerprint != null && message.hasOwnProperty("fingerprint")) {
                                object.fingerprint = message.fingerprint;
                                if (options.oneofs)
                                    object._fingerprint = "fingerprint";
                            }
                            if (message.pathMatchers && message.pathMatchers.length) {
                                object.pathMatchers = [];
                                for (var j = 0; j < message.pathMatchers.length; ++j)
                                    object.pathMatchers[j] = $root.google.cloud.compute.v1.PathMatcher.toObject(message.pathMatchers[j], options);
                            }
                            if (message.hostRules && message.hostRules.length) {
                                object.hostRules = [];
                                for (var j = 0; j < message.hostRules.length; ++j)
                                    object.hostRules[j] = $root.google.cloud.compute.v1.HostRule.toObject(message.hostRules[j], options);
                            }
                            if (message.headerAction != null && message.hasOwnProperty("headerAction")) {
                                object.headerAction = $root.google.cloud.compute.v1.HttpHeaderAction.toObject(message.headerAction, options);
                                if (options.oneofs)
                                    object._headerAction = "headerAction";
                            }
                            if (message.defaultUrlRedirect != null && message.hasOwnProperty("defaultUrlRedirect")) {
                                object.defaultUrlRedirect = $root.google.cloud.compute.v1.HttpRedirectAction.toObject(message.defaultUrlRedirect, options);
                                if (options.oneofs)
                                    object._defaultUrlRedirect = "defaultUrlRedirect";
                            }
                            if (message.defaultService != null && message.hasOwnProperty("defaultService")) {
                                object.defaultService = message.defaultService;
                                if (options.oneofs)
                                    object._defaultService = "defaultService";
                            }
                            if (message.defaultRouteAction != null && message.hasOwnProperty("defaultRouteAction")) {
                                object.defaultRouteAction = $root.google.cloud.compute.v1.HttpRouteAction.toObject(message.defaultRouteAction, options);
                                if (options.oneofs)
                                    object._defaultRouteAction = "defaultRouteAction";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UrlMap to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UrlMap.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UrlMap
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UrlMap
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UrlMap.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UrlMap";
                        };
    
                        return UrlMap;
                    })();
    
                    v1.UrlMapList = (function() {
    
                        /**
                         * Properties of an UrlMapList.
                         * @memberof google.cloud.compute.v1
                         * @interface IUrlMapList
                         * @property {string|null} [id] UrlMapList id
                         * @property {Array.<google.cloud.compute.v1.IUrlMap>|null} [items] UrlMapList items
                         * @property {string|null} [kind] UrlMapList kind
                         * @property {string|null} [nextPageToken] UrlMapList nextPageToken
                         * @property {string|null} [selfLink] UrlMapList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] UrlMapList warning
                         */
    
                        /**
                         * Constructs a new UrlMapList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UrlMapList.
                         * @implements IUrlMapList
                         * @constructor
                         * @param {google.cloud.compute.v1.IUrlMapList=} [properties] Properties to set
                         */
                        function UrlMapList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UrlMapList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @instance
                         */
                        UrlMapList.prototype.id = null;
    
                        /**
                         * UrlMapList items.
                         * @member {Array.<google.cloud.compute.v1.IUrlMap>} items
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @instance
                         */
                        UrlMapList.prototype.items = $util.emptyArray;
    
                        /**
                         * UrlMapList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @instance
                         */
                        UrlMapList.prototype.kind = null;
    
                        /**
                         * UrlMapList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @instance
                         */
                        UrlMapList.prototype.nextPageToken = null;
    
                        /**
                         * UrlMapList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @instance
                         */
                        UrlMapList.prototype.selfLink = null;
    
                        /**
                         * UrlMapList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @instance
                         */
                        UrlMapList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UrlMapList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @instance
                         */
                        Object.defineProperty(UrlMapList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMapList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @instance
                         */
                        Object.defineProperty(UrlMapList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMapList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @instance
                         */
                        Object.defineProperty(UrlMapList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMapList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @instance
                         */
                        Object.defineProperty(UrlMapList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMapList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @instance
                         */
                        Object.defineProperty(UrlMapList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UrlMapList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UrlMapList} UrlMapList instance
                         */
                        UrlMapList.create = function create(properties) {
                            return new UrlMapList(properties);
                        };
    
                        /**
                         * Encodes the specified UrlMapList message. Does not implicitly {@link google.cloud.compute.v1.UrlMapList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapList} message UrlMapList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlMapList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.UrlMap.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UrlMapList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UrlMapList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapList} message UrlMapList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlMapList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UrlMapList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UrlMapList} UrlMapList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlMapList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UrlMapList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.UrlMap.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UrlMapList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UrlMapList} UrlMapList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlMapList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UrlMapList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UrlMapList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.UrlMap.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UrlMapList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UrlMapList} UrlMapList
                         */
                        UrlMapList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UrlMapList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UrlMapList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.UrlMapList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.UrlMapList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.UrlMap.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UrlMapList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UrlMapList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @static
                         * @param {google.cloud.compute.v1.UrlMapList} message UrlMapList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UrlMapList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.UrlMap.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UrlMapList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UrlMapList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UrlMapList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UrlMapList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UrlMapList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UrlMapList";
                        };
    
                        return UrlMapList;
                    })();
    
                    v1.UrlMapReference = (function() {
    
                        /**
                         * Properties of an UrlMapReference.
                         * @memberof google.cloud.compute.v1
                         * @interface IUrlMapReference
                         * @property {string|null} [urlMap] UrlMapReference urlMap
                         */
    
                        /**
                         * Constructs a new UrlMapReference.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UrlMapReference.
                         * @implements IUrlMapReference
                         * @constructor
                         * @param {google.cloud.compute.v1.IUrlMapReference=} [properties] Properties to set
                         */
                        function UrlMapReference(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UrlMapReference urlMap.
                         * @member {string|null|undefined} urlMap
                         * @memberof google.cloud.compute.v1.UrlMapReference
                         * @instance
                         */
                        UrlMapReference.prototype.urlMap = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UrlMapReference _urlMap.
                         * @member {"urlMap"|undefined} _urlMap
                         * @memberof google.cloud.compute.v1.UrlMapReference
                         * @instance
                         */
                        Object.defineProperty(UrlMapReference.prototype, "_urlMap", {
                            get: $util.oneOfGetter($oneOfFields = ["urlMap"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UrlMapReference instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UrlMapReference
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapReference=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UrlMapReference} UrlMapReference instance
                         */
                        UrlMapReference.create = function create(properties) {
                            return new UrlMapReference(properties);
                        };
    
                        /**
                         * Encodes the specified UrlMapReference message. Does not implicitly {@link google.cloud.compute.v1.UrlMapReference.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UrlMapReference
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapReference} message UrlMapReference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlMapReference.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.urlMap != null && Object.hasOwnProperty.call(message, "urlMap"))
                                writer.uint32(/* id 367020684, wireType 2 =*/2936165474).string(message.urlMap);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UrlMapReference message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UrlMapReference.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UrlMapReference
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapReference} message UrlMapReference message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlMapReference.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UrlMapReference message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UrlMapReference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UrlMapReference} UrlMapReference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlMapReference.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UrlMapReference();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 367020684: {
                                        message.urlMap = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UrlMapReference message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UrlMapReference
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UrlMapReference} UrlMapReference
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlMapReference.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UrlMapReference message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UrlMapReference
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UrlMapReference.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.urlMap != null && message.hasOwnProperty("urlMap")) {
                                properties._urlMap = 1;
                                if (!$util.isString(message.urlMap))
                                    return "urlMap: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UrlMapReference message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UrlMapReference
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UrlMapReference} UrlMapReference
                         */
                        UrlMapReference.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UrlMapReference)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UrlMapReference();
                            if (object.urlMap != null)
                                message.urlMap = String(object.urlMap);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UrlMapReference message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UrlMapReference
                         * @static
                         * @param {google.cloud.compute.v1.UrlMapReference} message UrlMapReference
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UrlMapReference.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.urlMap != null && message.hasOwnProperty("urlMap")) {
                                object.urlMap = message.urlMap;
                                if (options.oneofs)
                                    object._urlMap = "urlMap";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UrlMapReference to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UrlMapReference
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UrlMapReference.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UrlMapReference
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UrlMapReference
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UrlMapReference.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UrlMapReference";
                        };
    
                        return UrlMapReference;
                    })();
    
                    v1.UrlMapTest = (function() {
    
                        /**
                         * Properties of an UrlMapTest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUrlMapTest
                         * @property {string|null} [description] UrlMapTest description
                         * @property {string|null} [expectedOutputUrl] UrlMapTest expectedOutputUrl
                         * @property {number|null} [expectedRedirectResponseCode] UrlMapTest expectedRedirectResponseCode
                         * @property {Array.<google.cloud.compute.v1.IUrlMapTestHeader>|null} [headers] UrlMapTest headers
                         * @property {string|null} [host] UrlMapTest host
                         * @property {string|null} [path] UrlMapTest path
                         * @property {string|null} [service] UrlMapTest service
                         */
    
                        /**
                         * Constructs a new UrlMapTest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UrlMapTest.
                         * @implements IUrlMapTest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUrlMapTest=} [properties] Properties to set
                         */
                        function UrlMapTest(properties) {
                            this.headers = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UrlMapTest description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @instance
                         */
                        UrlMapTest.prototype.description = null;
    
                        /**
                         * UrlMapTest expectedOutputUrl.
                         * @member {string|null|undefined} expectedOutputUrl
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @instance
                         */
                        UrlMapTest.prototype.expectedOutputUrl = null;
    
                        /**
                         * UrlMapTest expectedRedirectResponseCode.
                         * @member {number|null|undefined} expectedRedirectResponseCode
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @instance
                         */
                        UrlMapTest.prototype.expectedRedirectResponseCode = null;
    
                        /**
                         * UrlMapTest headers.
                         * @member {Array.<google.cloud.compute.v1.IUrlMapTestHeader>} headers
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @instance
                         */
                        UrlMapTest.prototype.headers = $util.emptyArray;
    
                        /**
                         * UrlMapTest host.
                         * @member {string|null|undefined} host
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @instance
                         */
                        UrlMapTest.prototype.host = null;
    
                        /**
                         * UrlMapTest path.
                         * @member {string|null|undefined} path
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @instance
                         */
                        UrlMapTest.prototype.path = null;
    
                        /**
                         * UrlMapTest service.
                         * @member {string|null|undefined} service
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @instance
                         */
                        UrlMapTest.prototype.service = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UrlMapTest _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @instance
                         */
                        Object.defineProperty(UrlMapTest.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMapTest _expectedOutputUrl.
                         * @member {"expectedOutputUrl"|undefined} _expectedOutputUrl
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @instance
                         */
                        Object.defineProperty(UrlMapTest.prototype, "_expectedOutputUrl", {
                            get: $util.oneOfGetter($oneOfFields = ["expectedOutputUrl"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMapTest _expectedRedirectResponseCode.
                         * @member {"expectedRedirectResponseCode"|undefined} _expectedRedirectResponseCode
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @instance
                         */
                        Object.defineProperty(UrlMapTest.prototype, "_expectedRedirectResponseCode", {
                            get: $util.oneOfGetter($oneOfFields = ["expectedRedirectResponseCode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMapTest _host.
                         * @member {"host"|undefined} _host
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @instance
                         */
                        Object.defineProperty(UrlMapTest.prototype, "_host", {
                            get: $util.oneOfGetter($oneOfFields = ["host"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMapTest _path.
                         * @member {"path"|undefined} _path
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @instance
                         */
                        Object.defineProperty(UrlMapTest.prototype, "_path", {
                            get: $util.oneOfGetter($oneOfFields = ["path"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMapTest _service.
                         * @member {"service"|undefined} _service
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @instance
                         */
                        Object.defineProperty(UrlMapTest.prototype, "_service", {
                            get: $util.oneOfGetter($oneOfFields = ["service"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UrlMapTest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapTest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UrlMapTest} UrlMapTest instance
                         */
                        UrlMapTest.create = function create(properties) {
                            return new UrlMapTest(properties);
                        };
    
                        /**
                         * Encodes the specified UrlMapTest message. Does not implicitly {@link google.cloud.compute.v1.UrlMapTest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapTest} message UrlMapTest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlMapTest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.host != null && Object.hasOwnProperty.call(message, "host"))
                                writer.uint32(/* id 3208616, wireType 2 =*/25668930).string(message.host);
                            if (message.path != null && Object.hasOwnProperty.call(message, "path"))
                                writer.uint32(/* id 3433509, wireType 2 =*/27468074).string(message.path);
                            if (message.expectedRedirectResponseCode != null && Object.hasOwnProperty.call(message, "expectedRedirectResponseCode"))
                                writer.uint32(/* id 18888047, wireType 0 =*/151104376).int32(message.expectedRedirectResponseCode);
                            if (message.headers != null && message.headers.length)
                                for (var i = 0; i < message.headers.length; ++i)
                                    $root.google.cloud.compute.v1.UrlMapTestHeader.encode(message.headers[i], writer.uint32(/* id 258436998, wireType 2 =*/2067495986).fork()).ldelim();
                            if (message.service != null && Object.hasOwnProperty.call(message, "service"))
                                writer.uint32(/* id 373540533, wireType 2 =*/2988324266).string(message.service);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.expectedOutputUrl != null && Object.hasOwnProperty.call(message, "expectedOutputUrl"))
                                writer.uint32(/* id 433967384, wireType 2 =*/3471739074).string(message.expectedOutputUrl);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UrlMapTest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UrlMapTest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapTest} message UrlMapTest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlMapTest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UrlMapTest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UrlMapTest} UrlMapTest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlMapTest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UrlMapTest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 433967384: {
                                        message.expectedOutputUrl = reader.string();
                                        break;
                                    }
                                case 18888047: {
                                        message.expectedRedirectResponseCode = reader.int32();
                                        break;
                                    }
                                case 258436998: {
                                        if (!(message.headers && message.headers.length))
                                            message.headers = [];
                                        message.headers.push($root.google.cloud.compute.v1.UrlMapTestHeader.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3208616: {
                                        message.host = reader.string();
                                        break;
                                    }
                                case 3433509: {
                                        message.path = reader.string();
                                        break;
                                    }
                                case 373540533: {
                                        message.service = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UrlMapTest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UrlMapTest} UrlMapTest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlMapTest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UrlMapTest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UrlMapTest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.expectedOutputUrl != null && message.hasOwnProperty("expectedOutputUrl")) {
                                properties._expectedOutputUrl = 1;
                                if (!$util.isString(message.expectedOutputUrl))
                                    return "expectedOutputUrl: string expected";
                            }
                            if (message.expectedRedirectResponseCode != null && message.hasOwnProperty("expectedRedirectResponseCode")) {
                                properties._expectedRedirectResponseCode = 1;
                                if (!$util.isInteger(message.expectedRedirectResponseCode))
                                    return "expectedRedirectResponseCode: integer expected";
                            }
                            if (message.headers != null && message.hasOwnProperty("headers")) {
                                if (!Array.isArray(message.headers))
                                    return "headers: array expected";
                                for (var i = 0; i < message.headers.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.UrlMapTestHeader.verify(message.headers[i]);
                                    if (error)
                                        return "headers." + error;
                                }
                            }
                            if (message.host != null && message.hasOwnProperty("host")) {
                                properties._host = 1;
                                if (!$util.isString(message.host))
                                    return "host: string expected";
                            }
                            if (message.path != null && message.hasOwnProperty("path")) {
                                properties._path = 1;
                                if (!$util.isString(message.path))
                                    return "path: string expected";
                            }
                            if (message.service != null && message.hasOwnProperty("service")) {
                                properties._service = 1;
                                if (!$util.isString(message.service))
                                    return "service: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UrlMapTest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UrlMapTest} UrlMapTest
                         */
                        UrlMapTest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UrlMapTest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UrlMapTest();
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.expectedOutputUrl != null)
                                message.expectedOutputUrl = String(object.expectedOutputUrl);
                            if (object.expectedRedirectResponseCode != null)
                                message.expectedRedirectResponseCode = object.expectedRedirectResponseCode | 0;
                            if (object.headers) {
                                if (!Array.isArray(object.headers))
                                    throw TypeError(".google.cloud.compute.v1.UrlMapTest.headers: array expected");
                                message.headers = [];
                                for (var i = 0; i < object.headers.length; ++i) {
                                    if (typeof object.headers[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.UrlMapTest.headers: object expected");
                                    message.headers[i] = $root.google.cloud.compute.v1.UrlMapTestHeader.fromObject(object.headers[i]);
                                }
                            }
                            if (object.host != null)
                                message.host = String(object.host);
                            if (object.path != null)
                                message.path = String(object.path);
                            if (object.service != null)
                                message.service = String(object.service);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UrlMapTest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @static
                         * @param {google.cloud.compute.v1.UrlMapTest} message UrlMapTest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UrlMapTest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.headers = [];
                            if (message.host != null && message.hasOwnProperty("host")) {
                                object.host = message.host;
                                if (options.oneofs)
                                    object._host = "host";
                            }
                            if (message.path != null && message.hasOwnProperty("path")) {
                                object.path = message.path;
                                if (options.oneofs)
                                    object._path = "path";
                            }
                            if (message.expectedRedirectResponseCode != null && message.hasOwnProperty("expectedRedirectResponseCode")) {
                                object.expectedRedirectResponseCode = message.expectedRedirectResponseCode;
                                if (options.oneofs)
                                    object._expectedRedirectResponseCode = "expectedRedirectResponseCode";
                            }
                            if (message.headers && message.headers.length) {
                                object.headers = [];
                                for (var j = 0; j < message.headers.length; ++j)
                                    object.headers[j] = $root.google.cloud.compute.v1.UrlMapTestHeader.toObject(message.headers[j], options);
                            }
                            if (message.service != null && message.hasOwnProperty("service")) {
                                object.service = message.service;
                                if (options.oneofs)
                                    object._service = "service";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.expectedOutputUrl != null && message.hasOwnProperty("expectedOutputUrl")) {
                                object.expectedOutputUrl = message.expectedOutputUrl;
                                if (options.oneofs)
                                    object._expectedOutputUrl = "expectedOutputUrl";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UrlMapTest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UrlMapTest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UrlMapTest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UrlMapTest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UrlMapTest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UrlMapTest";
                        };
    
                        return UrlMapTest;
                    })();
    
                    v1.UrlMapTestHeader = (function() {
    
                        /**
                         * Properties of an UrlMapTestHeader.
                         * @memberof google.cloud.compute.v1
                         * @interface IUrlMapTestHeader
                         * @property {string|null} [name] UrlMapTestHeader name
                         * @property {string|null} [value] UrlMapTestHeader value
                         */
    
                        /**
                         * Constructs a new UrlMapTestHeader.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UrlMapTestHeader.
                         * @implements IUrlMapTestHeader
                         * @constructor
                         * @param {google.cloud.compute.v1.IUrlMapTestHeader=} [properties] Properties to set
                         */
                        function UrlMapTestHeader(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UrlMapTestHeader name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.UrlMapTestHeader
                         * @instance
                         */
                        UrlMapTestHeader.prototype.name = null;
    
                        /**
                         * UrlMapTestHeader value.
                         * @member {string|null|undefined} value
                         * @memberof google.cloud.compute.v1.UrlMapTestHeader
                         * @instance
                         */
                        UrlMapTestHeader.prototype.value = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UrlMapTestHeader _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.UrlMapTestHeader
                         * @instance
                         */
                        Object.defineProperty(UrlMapTestHeader.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMapTestHeader _value.
                         * @member {"value"|undefined} _value
                         * @memberof google.cloud.compute.v1.UrlMapTestHeader
                         * @instance
                         */
                        Object.defineProperty(UrlMapTestHeader.prototype, "_value", {
                            get: $util.oneOfGetter($oneOfFields = ["value"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UrlMapTestHeader instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UrlMapTestHeader
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapTestHeader=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UrlMapTestHeader} UrlMapTestHeader instance
                         */
                        UrlMapTestHeader.create = function create(properties) {
                            return new UrlMapTestHeader(properties);
                        };
    
                        /**
                         * Encodes the specified UrlMapTestHeader message. Does not implicitly {@link google.cloud.compute.v1.UrlMapTestHeader.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UrlMapTestHeader
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapTestHeader} message UrlMapTestHeader message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlMapTestHeader.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                writer.uint32(/* id 111972721, wireType 2 =*/895781770).string(message.value);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UrlMapTestHeader message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UrlMapTestHeader.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UrlMapTestHeader
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapTestHeader} message UrlMapTestHeader message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlMapTestHeader.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UrlMapTestHeader message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UrlMapTestHeader
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UrlMapTestHeader} UrlMapTestHeader
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlMapTestHeader.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UrlMapTestHeader();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 111972721: {
                                        message.value = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UrlMapTestHeader message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UrlMapTestHeader
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UrlMapTestHeader} UrlMapTestHeader
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlMapTestHeader.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UrlMapTestHeader message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UrlMapTestHeader
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UrlMapTestHeader.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                properties._value = 1;
                                if (!$util.isString(message.value))
                                    return "value: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UrlMapTestHeader message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UrlMapTestHeader
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UrlMapTestHeader} UrlMapTestHeader
                         */
                        UrlMapTestHeader.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UrlMapTestHeader)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UrlMapTestHeader();
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.value != null)
                                message.value = String(object.value);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UrlMapTestHeader message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UrlMapTestHeader
                         * @static
                         * @param {google.cloud.compute.v1.UrlMapTestHeader} message UrlMapTestHeader
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UrlMapTestHeader.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                object.value = message.value;
                                if (options.oneofs)
                                    object._value = "value";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UrlMapTestHeader to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UrlMapTestHeader
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UrlMapTestHeader.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UrlMapTestHeader
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UrlMapTestHeader
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UrlMapTestHeader.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UrlMapTestHeader";
                        };
    
                        return UrlMapTestHeader;
                    })();
    
                    v1.UrlMapValidationResult = (function() {
    
                        /**
                         * Properties of an UrlMapValidationResult.
                         * @memberof google.cloud.compute.v1
                         * @interface IUrlMapValidationResult
                         * @property {Array.<string>|null} [loadErrors] UrlMapValidationResult loadErrors
                         * @property {boolean|null} [loadSucceeded] UrlMapValidationResult loadSucceeded
                         * @property {Array.<google.cloud.compute.v1.ITestFailure>|null} [testFailures] UrlMapValidationResult testFailures
                         * @property {boolean|null} [testPassed] UrlMapValidationResult testPassed
                         */
    
                        /**
                         * Constructs a new UrlMapValidationResult.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UrlMapValidationResult.
                         * @implements IUrlMapValidationResult
                         * @constructor
                         * @param {google.cloud.compute.v1.IUrlMapValidationResult=} [properties] Properties to set
                         */
                        function UrlMapValidationResult(properties) {
                            this.loadErrors = [];
                            this.testFailures = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UrlMapValidationResult loadErrors.
                         * @member {Array.<string>} loadErrors
                         * @memberof google.cloud.compute.v1.UrlMapValidationResult
                         * @instance
                         */
                        UrlMapValidationResult.prototype.loadErrors = $util.emptyArray;
    
                        /**
                         * UrlMapValidationResult loadSucceeded.
                         * @member {boolean|null|undefined} loadSucceeded
                         * @memberof google.cloud.compute.v1.UrlMapValidationResult
                         * @instance
                         */
                        UrlMapValidationResult.prototype.loadSucceeded = null;
    
                        /**
                         * UrlMapValidationResult testFailures.
                         * @member {Array.<google.cloud.compute.v1.ITestFailure>} testFailures
                         * @memberof google.cloud.compute.v1.UrlMapValidationResult
                         * @instance
                         */
                        UrlMapValidationResult.prototype.testFailures = $util.emptyArray;
    
                        /**
                         * UrlMapValidationResult testPassed.
                         * @member {boolean|null|undefined} testPassed
                         * @memberof google.cloud.compute.v1.UrlMapValidationResult
                         * @instance
                         */
                        UrlMapValidationResult.prototype.testPassed = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UrlMapValidationResult _loadSucceeded.
                         * @member {"loadSucceeded"|undefined} _loadSucceeded
                         * @memberof google.cloud.compute.v1.UrlMapValidationResult
                         * @instance
                         */
                        Object.defineProperty(UrlMapValidationResult.prototype, "_loadSucceeded", {
                            get: $util.oneOfGetter($oneOfFields = ["loadSucceeded"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMapValidationResult _testPassed.
                         * @member {"testPassed"|undefined} _testPassed
                         * @memberof google.cloud.compute.v1.UrlMapValidationResult
                         * @instance
                         */
                        Object.defineProperty(UrlMapValidationResult.prototype, "_testPassed", {
                            get: $util.oneOfGetter($oneOfFields = ["testPassed"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UrlMapValidationResult instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UrlMapValidationResult
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapValidationResult=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UrlMapValidationResult} UrlMapValidationResult instance
                         */
                        UrlMapValidationResult.create = function create(properties) {
                            return new UrlMapValidationResult(properties);
                        };
    
                        /**
                         * Encodes the specified UrlMapValidationResult message. Does not implicitly {@link google.cloud.compute.v1.UrlMapValidationResult.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UrlMapValidationResult
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapValidationResult} message UrlMapValidationResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlMapValidationResult.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.loadSucceeded != null && Object.hasOwnProperty.call(message, "loadSucceeded"))
                                writer.uint32(/* id 128326216, wireType 0 =*/1026609728).bool(message.loadSucceeded);
                            if (message.testPassed != null && Object.hasOwnProperty.call(message, "testPassed"))
                                writer.uint32(/* id 192708797, wireType 0 =*/1541670376).bool(message.testPassed);
                            if (message.loadErrors != null && message.loadErrors.length)
                                for (var i = 0; i < message.loadErrors.length; ++i)
                                    writer.uint32(/* id 310147300, wireType 2 =*/2481178402).string(message.loadErrors[i]);
                            if (message.testFailures != null && message.testFailures.length)
                                for (var i = 0; i < message.testFailures.length; ++i)
                                    $root.google.cloud.compute.v1.TestFailure.encode(message.testFailures[i], writer.uint32(/* id 505934134, wireType 2 =*/4047473074).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UrlMapValidationResult message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UrlMapValidationResult.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UrlMapValidationResult
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapValidationResult} message UrlMapValidationResult message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlMapValidationResult.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UrlMapValidationResult message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UrlMapValidationResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UrlMapValidationResult} UrlMapValidationResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlMapValidationResult.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UrlMapValidationResult();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 310147300: {
                                        if (!(message.loadErrors && message.loadErrors.length))
                                            message.loadErrors = [];
                                        message.loadErrors.push(reader.string());
                                        break;
                                    }
                                case 128326216: {
                                        message.loadSucceeded = reader.bool();
                                        break;
                                    }
                                case 505934134: {
                                        if (!(message.testFailures && message.testFailures.length))
                                            message.testFailures = [];
                                        message.testFailures.push($root.google.cloud.compute.v1.TestFailure.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 192708797: {
                                        message.testPassed = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UrlMapValidationResult message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UrlMapValidationResult
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UrlMapValidationResult} UrlMapValidationResult
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlMapValidationResult.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UrlMapValidationResult message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UrlMapValidationResult
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UrlMapValidationResult.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.loadErrors != null && message.hasOwnProperty("loadErrors")) {
                                if (!Array.isArray(message.loadErrors))
                                    return "loadErrors: array expected";
                                for (var i = 0; i < message.loadErrors.length; ++i)
                                    if (!$util.isString(message.loadErrors[i]))
                                        return "loadErrors: string[] expected";
                            }
                            if (message.loadSucceeded != null && message.hasOwnProperty("loadSucceeded")) {
                                properties._loadSucceeded = 1;
                                if (typeof message.loadSucceeded !== "boolean")
                                    return "loadSucceeded: boolean expected";
                            }
                            if (message.testFailures != null && message.hasOwnProperty("testFailures")) {
                                if (!Array.isArray(message.testFailures))
                                    return "testFailures: array expected";
                                for (var i = 0; i < message.testFailures.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.TestFailure.verify(message.testFailures[i]);
                                    if (error)
                                        return "testFailures." + error;
                                }
                            }
                            if (message.testPassed != null && message.hasOwnProperty("testPassed")) {
                                properties._testPassed = 1;
                                if (typeof message.testPassed !== "boolean")
                                    return "testPassed: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UrlMapValidationResult message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UrlMapValidationResult
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UrlMapValidationResult} UrlMapValidationResult
                         */
                        UrlMapValidationResult.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UrlMapValidationResult)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UrlMapValidationResult();
                            if (object.loadErrors) {
                                if (!Array.isArray(object.loadErrors))
                                    throw TypeError(".google.cloud.compute.v1.UrlMapValidationResult.loadErrors: array expected");
                                message.loadErrors = [];
                                for (var i = 0; i < object.loadErrors.length; ++i)
                                    message.loadErrors[i] = String(object.loadErrors[i]);
                            }
                            if (object.loadSucceeded != null)
                                message.loadSucceeded = Boolean(object.loadSucceeded);
                            if (object.testFailures) {
                                if (!Array.isArray(object.testFailures))
                                    throw TypeError(".google.cloud.compute.v1.UrlMapValidationResult.testFailures: array expected");
                                message.testFailures = [];
                                for (var i = 0; i < object.testFailures.length; ++i) {
                                    if (typeof object.testFailures[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.UrlMapValidationResult.testFailures: object expected");
                                    message.testFailures[i] = $root.google.cloud.compute.v1.TestFailure.fromObject(object.testFailures[i]);
                                }
                            }
                            if (object.testPassed != null)
                                message.testPassed = Boolean(object.testPassed);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UrlMapValidationResult message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UrlMapValidationResult
                         * @static
                         * @param {google.cloud.compute.v1.UrlMapValidationResult} message UrlMapValidationResult
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UrlMapValidationResult.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.loadErrors = [];
                                object.testFailures = [];
                            }
                            if (message.loadSucceeded != null && message.hasOwnProperty("loadSucceeded")) {
                                object.loadSucceeded = message.loadSucceeded;
                                if (options.oneofs)
                                    object._loadSucceeded = "loadSucceeded";
                            }
                            if (message.testPassed != null && message.hasOwnProperty("testPassed")) {
                                object.testPassed = message.testPassed;
                                if (options.oneofs)
                                    object._testPassed = "testPassed";
                            }
                            if (message.loadErrors && message.loadErrors.length) {
                                object.loadErrors = [];
                                for (var j = 0; j < message.loadErrors.length; ++j)
                                    object.loadErrors[j] = message.loadErrors[j];
                            }
                            if (message.testFailures && message.testFailures.length) {
                                object.testFailures = [];
                                for (var j = 0; j < message.testFailures.length; ++j)
                                    object.testFailures[j] = $root.google.cloud.compute.v1.TestFailure.toObject(message.testFailures[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UrlMapValidationResult to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UrlMapValidationResult
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UrlMapValidationResult.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UrlMapValidationResult
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UrlMapValidationResult
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UrlMapValidationResult.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UrlMapValidationResult";
                        };
    
                        return UrlMapValidationResult;
                    })();
    
                    v1.UrlMapsAggregatedList = (function() {
    
                        /**
                         * Properties of an UrlMapsAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IUrlMapsAggregatedList
                         * @property {string|null} [id] UrlMapsAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IUrlMapsScopedList>|null} [items] UrlMapsAggregatedList items
                         * @property {string|null} [kind] UrlMapsAggregatedList kind
                         * @property {string|null} [nextPageToken] UrlMapsAggregatedList nextPageToken
                         * @property {string|null} [selfLink] UrlMapsAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] UrlMapsAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] UrlMapsAggregatedList warning
                         */
    
                        /**
                         * Constructs a new UrlMapsAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UrlMapsAggregatedList.
                         * @implements IUrlMapsAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IUrlMapsAggregatedList=} [properties] Properties to set
                         */
                        function UrlMapsAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UrlMapsAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @instance
                         */
                        UrlMapsAggregatedList.prototype.id = null;
    
                        /**
                         * UrlMapsAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IUrlMapsScopedList>} items
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @instance
                         */
                        UrlMapsAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * UrlMapsAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @instance
                         */
                        UrlMapsAggregatedList.prototype.kind = null;
    
                        /**
                         * UrlMapsAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @instance
                         */
                        UrlMapsAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * UrlMapsAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @instance
                         */
                        UrlMapsAggregatedList.prototype.selfLink = null;
    
                        /**
                         * UrlMapsAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @instance
                         */
                        UrlMapsAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * UrlMapsAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @instance
                         */
                        UrlMapsAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UrlMapsAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @instance
                         */
                        Object.defineProperty(UrlMapsAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMapsAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @instance
                         */
                        Object.defineProperty(UrlMapsAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMapsAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @instance
                         */
                        Object.defineProperty(UrlMapsAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMapsAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @instance
                         */
                        Object.defineProperty(UrlMapsAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlMapsAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @instance
                         */
                        Object.defineProperty(UrlMapsAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UrlMapsAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapsAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UrlMapsAggregatedList} UrlMapsAggregatedList instance
                         */
                        UrlMapsAggregatedList.create = function create(properties) {
                            return new UrlMapsAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified UrlMapsAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.UrlMapsAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapsAggregatedList} message UrlMapsAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlMapsAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.UrlMapsScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UrlMapsAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UrlMapsAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapsAggregatedList} message UrlMapsAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlMapsAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UrlMapsAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UrlMapsAggregatedList} UrlMapsAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlMapsAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UrlMapsAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.UrlMapsScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UrlMapsAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UrlMapsAggregatedList} UrlMapsAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlMapsAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UrlMapsAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UrlMapsAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.UrlMapsScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UrlMapsAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UrlMapsAggregatedList} UrlMapsAggregatedList
                         */
                        UrlMapsAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UrlMapsAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UrlMapsAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UrlMapsAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.UrlMapsAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.UrlMapsScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.UrlMapsAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UrlMapsAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UrlMapsAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.UrlMapsAggregatedList} message UrlMapsAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UrlMapsAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.UrlMapsScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UrlMapsAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UrlMapsAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UrlMapsAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UrlMapsAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UrlMapsAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UrlMapsAggregatedList";
                        };
    
                        return UrlMapsAggregatedList;
                    })();
    
                    v1.UrlMapsScopedList = (function() {
    
                        /**
                         * Properties of an UrlMapsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IUrlMapsScopedList
                         * @property {Array.<google.cloud.compute.v1.IUrlMap>|null} [urlMaps] UrlMapsScopedList urlMaps
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] UrlMapsScopedList warning
                         */
    
                        /**
                         * Constructs a new UrlMapsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UrlMapsScopedList.
                         * @implements IUrlMapsScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IUrlMapsScopedList=} [properties] Properties to set
                         */
                        function UrlMapsScopedList(properties) {
                            this.urlMaps = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UrlMapsScopedList urlMaps.
                         * @member {Array.<google.cloud.compute.v1.IUrlMap>} urlMaps
                         * @memberof google.cloud.compute.v1.UrlMapsScopedList
                         * @instance
                         */
                        UrlMapsScopedList.prototype.urlMaps = $util.emptyArray;
    
                        /**
                         * UrlMapsScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.UrlMapsScopedList
                         * @instance
                         */
                        UrlMapsScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UrlMapsScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.UrlMapsScopedList
                         * @instance
                         */
                        Object.defineProperty(UrlMapsScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UrlMapsScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UrlMapsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapsScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UrlMapsScopedList} UrlMapsScopedList instance
                         */
                        UrlMapsScopedList.create = function create(properties) {
                            return new UrlMapsScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified UrlMapsScopedList message. Does not implicitly {@link google.cloud.compute.v1.UrlMapsScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UrlMapsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapsScopedList} message UrlMapsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlMapsScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.urlMaps != null && message.urlMaps.length)
                                for (var i = 0; i < message.urlMaps.length; ++i)
                                    $root.google.cloud.compute.v1.UrlMap.encode(message.urlMaps[i], writer.uint32(/* id 103352167, wireType 2 =*/826817338).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UrlMapsScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UrlMapsScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UrlMapsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapsScopedList} message UrlMapsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlMapsScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UrlMapsScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UrlMapsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UrlMapsScopedList} UrlMapsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlMapsScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UrlMapsScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 103352167: {
                                        if (!(message.urlMaps && message.urlMaps.length))
                                            message.urlMaps = [];
                                        message.urlMaps.push($root.google.cloud.compute.v1.UrlMap.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UrlMapsScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UrlMapsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UrlMapsScopedList} UrlMapsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlMapsScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UrlMapsScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UrlMapsScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UrlMapsScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.urlMaps != null && message.hasOwnProperty("urlMaps")) {
                                if (!Array.isArray(message.urlMaps))
                                    return "urlMaps: array expected";
                                for (var i = 0; i < message.urlMaps.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.UrlMap.verify(message.urlMaps[i]);
                                    if (error)
                                        return "urlMaps." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UrlMapsScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UrlMapsScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UrlMapsScopedList} UrlMapsScopedList
                         */
                        UrlMapsScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UrlMapsScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UrlMapsScopedList();
                            if (object.urlMaps) {
                                if (!Array.isArray(object.urlMaps))
                                    throw TypeError(".google.cloud.compute.v1.UrlMapsScopedList.urlMaps: array expected");
                                message.urlMaps = [];
                                for (var i = 0; i < object.urlMaps.length; ++i) {
                                    if (typeof object.urlMaps[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.UrlMapsScopedList.urlMaps: object expected");
                                    message.urlMaps[i] = $root.google.cloud.compute.v1.UrlMap.fromObject(object.urlMaps[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UrlMapsScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UrlMapsScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UrlMapsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.UrlMapsScopedList} message UrlMapsScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UrlMapsScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.urlMaps = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.urlMaps && message.urlMaps.length) {
                                object.urlMaps = [];
                                for (var j = 0; j < message.urlMaps.length; ++j)
                                    object.urlMaps[j] = $root.google.cloud.compute.v1.UrlMap.toObject(message.urlMaps[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UrlMapsScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UrlMapsScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UrlMapsScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UrlMapsScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UrlMapsScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UrlMapsScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UrlMapsScopedList";
                        };
    
                        return UrlMapsScopedList;
                    })();
    
                    v1.UrlMapsValidateRequest = (function() {
    
                        /**
                         * Properties of an UrlMapsValidateRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IUrlMapsValidateRequest
                         * @property {Array.<string>|null} [loadBalancingSchemes] UrlMapsValidateRequest loadBalancingSchemes
                         * @property {google.cloud.compute.v1.IUrlMap|null} [resource] UrlMapsValidateRequest resource
                         */
    
                        /**
                         * Constructs a new UrlMapsValidateRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UrlMapsValidateRequest.
                         * @implements IUrlMapsValidateRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IUrlMapsValidateRequest=} [properties] Properties to set
                         */
                        function UrlMapsValidateRequest(properties) {
                            this.loadBalancingSchemes = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UrlMapsValidateRequest loadBalancingSchemes.
                         * @member {Array.<string>} loadBalancingSchemes
                         * @memberof google.cloud.compute.v1.UrlMapsValidateRequest
                         * @instance
                         */
                        UrlMapsValidateRequest.prototype.loadBalancingSchemes = $util.emptyArray;
    
                        /**
                         * UrlMapsValidateRequest resource.
                         * @member {google.cloud.compute.v1.IUrlMap|null|undefined} resource
                         * @memberof google.cloud.compute.v1.UrlMapsValidateRequest
                         * @instance
                         */
                        UrlMapsValidateRequest.prototype.resource = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UrlMapsValidateRequest _resource.
                         * @member {"resource"|undefined} _resource
                         * @memberof google.cloud.compute.v1.UrlMapsValidateRequest
                         * @instance
                         */
                        Object.defineProperty(UrlMapsValidateRequest.prototype, "_resource", {
                            get: $util.oneOfGetter($oneOfFields = ["resource"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UrlMapsValidateRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UrlMapsValidateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapsValidateRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UrlMapsValidateRequest} UrlMapsValidateRequest instance
                         */
                        UrlMapsValidateRequest.create = function create(properties) {
                            return new UrlMapsValidateRequest(properties);
                        };
    
                        /**
                         * Encodes the specified UrlMapsValidateRequest message. Does not implicitly {@link google.cloud.compute.v1.UrlMapsValidateRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UrlMapsValidateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapsValidateRequest} message UrlMapsValidateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlMapsValidateRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.loadBalancingSchemes != null && message.loadBalancingSchemes.length)
                                for (var i = 0; i < message.loadBalancingSchemes.length; ++i)
                                    writer.uint32(/* id 6308527, wireType 2 =*/50468218).string(message.loadBalancingSchemes[i]);
                            if (message.resource != null && Object.hasOwnProperty.call(message, "resource"))
                                $root.google.cloud.compute.v1.UrlMap.encode(message.resource, writer.uint32(/* id 195806222, wireType 2 =*/1566449778).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UrlMapsValidateRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UrlMapsValidateRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UrlMapsValidateRequest
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapsValidateRequest} message UrlMapsValidateRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlMapsValidateRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UrlMapsValidateRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UrlMapsValidateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UrlMapsValidateRequest} UrlMapsValidateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlMapsValidateRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UrlMapsValidateRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 6308527: {
                                        if (!(message.loadBalancingSchemes && message.loadBalancingSchemes.length))
                                            message.loadBalancingSchemes = [];
                                        message.loadBalancingSchemes.push(reader.string());
                                        break;
                                    }
                                case 195806222: {
                                        message.resource = $root.google.cloud.compute.v1.UrlMap.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UrlMapsValidateRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UrlMapsValidateRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UrlMapsValidateRequest} UrlMapsValidateRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlMapsValidateRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UrlMapsValidateRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UrlMapsValidateRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UrlMapsValidateRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.loadBalancingSchemes != null && message.hasOwnProperty("loadBalancingSchemes")) {
                                if (!Array.isArray(message.loadBalancingSchemes))
                                    return "loadBalancingSchemes: array expected";
                                for (var i = 0; i < message.loadBalancingSchemes.length; ++i)
                                    if (!$util.isString(message.loadBalancingSchemes[i]))
                                        return "loadBalancingSchemes: string[] expected";
                            }
                            if (message.resource != null && message.hasOwnProperty("resource")) {
                                properties._resource = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.UrlMap.verify(message.resource);
                                    if (error)
                                        return "resource." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UrlMapsValidateRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UrlMapsValidateRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UrlMapsValidateRequest} UrlMapsValidateRequest
                         */
                        UrlMapsValidateRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UrlMapsValidateRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UrlMapsValidateRequest();
                            if (object.loadBalancingSchemes) {
                                if (!Array.isArray(object.loadBalancingSchemes))
                                    throw TypeError(".google.cloud.compute.v1.UrlMapsValidateRequest.loadBalancingSchemes: array expected");
                                message.loadBalancingSchemes = [];
                                for (var i = 0; i < object.loadBalancingSchemes.length; ++i)
                                    message.loadBalancingSchemes[i] = String(object.loadBalancingSchemes[i]);
                            }
                            if (object.resource != null) {
                                if (typeof object.resource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UrlMapsValidateRequest.resource: object expected");
                                message.resource = $root.google.cloud.compute.v1.UrlMap.fromObject(object.resource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UrlMapsValidateRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UrlMapsValidateRequest
                         * @static
                         * @param {google.cloud.compute.v1.UrlMapsValidateRequest} message UrlMapsValidateRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UrlMapsValidateRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.loadBalancingSchemes = [];
                            if (message.loadBalancingSchemes && message.loadBalancingSchemes.length) {
                                object.loadBalancingSchemes = [];
                                for (var j = 0; j < message.loadBalancingSchemes.length; ++j)
                                    object.loadBalancingSchemes[j] = message.loadBalancingSchemes[j];
                            }
                            if (message.resource != null && message.hasOwnProperty("resource")) {
                                object.resource = $root.google.cloud.compute.v1.UrlMap.toObject(message.resource, options);
                                if (options.oneofs)
                                    object._resource = "resource";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UrlMapsValidateRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UrlMapsValidateRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UrlMapsValidateRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UrlMapsValidateRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UrlMapsValidateRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UrlMapsValidateRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UrlMapsValidateRequest";
                        };
    
                        /**
                         * LoadBalancingSchemes enum.
                         * @name google.cloud.compute.v1.UrlMapsValidateRequest.LoadBalancingSchemes
                         * @enum {number}
                         * @property {number} UNDEFINED_LOAD_BALANCING_SCHEMES=0 UNDEFINED_LOAD_BALANCING_SCHEMES value
                         * @property {number} EXTERNAL=35607499 EXTERNAL value
                         * @property {number} EXTERNAL_MANAGED=512006923 EXTERNAL_MANAGED value
                         * @property {number} LOAD_BALANCING_SCHEME_UNSPECIFIED=526507452 LOAD_BALANCING_SCHEME_UNSPECIFIED value
                         */
                        UrlMapsValidateRequest.LoadBalancingSchemes = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_LOAD_BALANCING_SCHEMES"] = 0;
                            values[valuesById[35607499] = "EXTERNAL"] = 35607499;
                            values[valuesById[512006923] = "EXTERNAL_MANAGED"] = 512006923;
                            values[valuesById[526507452] = "LOAD_BALANCING_SCHEME_UNSPECIFIED"] = 526507452;
                            return values;
                        })();
    
                        return UrlMapsValidateRequest;
                    })();
    
                    v1.UrlMapsValidateResponse = (function() {
    
                        /**
                         * Properties of an UrlMapsValidateResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface IUrlMapsValidateResponse
                         * @property {google.cloud.compute.v1.IUrlMapValidationResult|null} [result] UrlMapsValidateResponse result
                         */
    
                        /**
                         * Constructs a new UrlMapsValidateResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UrlMapsValidateResponse.
                         * @implements IUrlMapsValidateResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.IUrlMapsValidateResponse=} [properties] Properties to set
                         */
                        function UrlMapsValidateResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UrlMapsValidateResponse result.
                         * @member {google.cloud.compute.v1.IUrlMapValidationResult|null|undefined} result
                         * @memberof google.cloud.compute.v1.UrlMapsValidateResponse
                         * @instance
                         */
                        UrlMapsValidateResponse.prototype.result = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UrlMapsValidateResponse _result.
                         * @member {"result"|undefined} _result
                         * @memberof google.cloud.compute.v1.UrlMapsValidateResponse
                         * @instance
                         */
                        Object.defineProperty(UrlMapsValidateResponse.prototype, "_result", {
                            get: $util.oneOfGetter($oneOfFields = ["result"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UrlMapsValidateResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UrlMapsValidateResponse
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapsValidateResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UrlMapsValidateResponse} UrlMapsValidateResponse instance
                         */
                        UrlMapsValidateResponse.create = function create(properties) {
                            return new UrlMapsValidateResponse(properties);
                        };
    
                        /**
                         * Encodes the specified UrlMapsValidateResponse message. Does not implicitly {@link google.cloud.compute.v1.UrlMapsValidateResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UrlMapsValidateResponse
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapsValidateResponse} message UrlMapsValidateResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlMapsValidateResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.result != null && Object.hasOwnProperty.call(message, "result"))
                                $root.google.cloud.compute.v1.UrlMapValidationResult.encode(message.result, writer.uint32(/* id 139315229, wireType 2 =*/1114521834).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UrlMapsValidateResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UrlMapsValidateResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UrlMapsValidateResponse
                         * @static
                         * @param {google.cloud.compute.v1.IUrlMapsValidateResponse} message UrlMapsValidateResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlMapsValidateResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UrlMapsValidateResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UrlMapsValidateResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UrlMapsValidateResponse} UrlMapsValidateResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlMapsValidateResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UrlMapsValidateResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 139315229: {
                                        message.result = $root.google.cloud.compute.v1.UrlMapValidationResult.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UrlMapsValidateResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UrlMapsValidateResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UrlMapsValidateResponse} UrlMapsValidateResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlMapsValidateResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UrlMapsValidateResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UrlMapsValidateResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UrlMapsValidateResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.result != null && message.hasOwnProperty("result")) {
                                properties._result = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.UrlMapValidationResult.verify(message.result);
                                    if (error)
                                        return "result." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UrlMapsValidateResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UrlMapsValidateResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UrlMapsValidateResponse} UrlMapsValidateResponse
                         */
                        UrlMapsValidateResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UrlMapsValidateResponse)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UrlMapsValidateResponse();
                            if (object.result != null) {
                                if (typeof object.result !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UrlMapsValidateResponse.result: object expected");
                                message.result = $root.google.cloud.compute.v1.UrlMapValidationResult.fromObject(object.result);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UrlMapsValidateResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UrlMapsValidateResponse
                         * @static
                         * @param {google.cloud.compute.v1.UrlMapsValidateResponse} message UrlMapsValidateResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UrlMapsValidateResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.result != null && message.hasOwnProperty("result")) {
                                object.result = $root.google.cloud.compute.v1.UrlMapValidationResult.toObject(message.result, options);
                                if (options.oneofs)
                                    object._result = "result";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UrlMapsValidateResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UrlMapsValidateResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UrlMapsValidateResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UrlMapsValidateResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UrlMapsValidateResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UrlMapsValidateResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UrlMapsValidateResponse";
                        };
    
                        return UrlMapsValidateResponse;
                    })();
    
                    v1.UrlRewrite = (function() {
    
                        /**
                         * Properties of an UrlRewrite.
                         * @memberof google.cloud.compute.v1
                         * @interface IUrlRewrite
                         * @property {string|null} [hostRewrite] UrlRewrite hostRewrite
                         * @property {string|null} [pathPrefixRewrite] UrlRewrite pathPrefixRewrite
                         */
    
                        /**
                         * Constructs a new UrlRewrite.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UrlRewrite.
                         * @implements IUrlRewrite
                         * @constructor
                         * @param {google.cloud.compute.v1.IUrlRewrite=} [properties] Properties to set
                         */
                        function UrlRewrite(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UrlRewrite hostRewrite.
                         * @member {string|null|undefined} hostRewrite
                         * @memberof google.cloud.compute.v1.UrlRewrite
                         * @instance
                         */
                        UrlRewrite.prototype.hostRewrite = null;
    
                        /**
                         * UrlRewrite pathPrefixRewrite.
                         * @member {string|null|undefined} pathPrefixRewrite
                         * @memberof google.cloud.compute.v1.UrlRewrite
                         * @instance
                         */
                        UrlRewrite.prototype.pathPrefixRewrite = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UrlRewrite _hostRewrite.
                         * @member {"hostRewrite"|undefined} _hostRewrite
                         * @memberof google.cloud.compute.v1.UrlRewrite
                         * @instance
                         */
                        Object.defineProperty(UrlRewrite.prototype, "_hostRewrite", {
                            get: $util.oneOfGetter($oneOfFields = ["hostRewrite"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UrlRewrite _pathPrefixRewrite.
                         * @member {"pathPrefixRewrite"|undefined} _pathPrefixRewrite
                         * @memberof google.cloud.compute.v1.UrlRewrite
                         * @instance
                         */
                        Object.defineProperty(UrlRewrite.prototype, "_pathPrefixRewrite", {
                            get: $util.oneOfGetter($oneOfFields = ["pathPrefixRewrite"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UrlRewrite instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UrlRewrite
                         * @static
                         * @param {google.cloud.compute.v1.IUrlRewrite=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UrlRewrite} UrlRewrite instance
                         */
                        UrlRewrite.create = function create(properties) {
                            return new UrlRewrite(properties);
                        };
    
                        /**
                         * Encodes the specified UrlRewrite message. Does not implicitly {@link google.cloud.compute.v1.UrlRewrite.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UrlRewrite
                         * @static
                         * @param {google.cloud.compute.v1.IUrlRewrite} message UrlRewrite message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlRewrite.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pathPrefixRewrite != null && Object.hasOwnProperty.call(message, "pathPrefixRewrite"))
                                writer.uint32(/* id 41186361, wireType 2 =*/329490890).string(message.pathPrefixRewrite);
                            if (message.hostRewrite != null && Object.hasOwnProperty.call(message, "hostRewrite"))
                                writer.uint32(/* id 159819253, wireType 2 =*/1278554026).string(message.hostRewrite);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UrlRewrite message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UrlRewrite.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UrlRewrite
                         * @static
                         * @param {google.cloud.compute.v1.IUrlRewrite} message UrlRewrite message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UrlRewrite.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an UrlRewrite message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UrlRewrite
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UrlRewrite} UrlRewrite
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlRewrite.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UrlRewrite();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 159819253: {
                                        message.hostRewrite = reader.string();
                                        break;
                                    }
                                case 41186361: {
                                        message.pathPrefixRewrite = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an UrlRewrite message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UrlRewrite
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UrlRewrite} UrlRewrite
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UrlRewrite.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an UrlRewrite message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UrlRewrite
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UrlRewrite.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.hostRewrite != null && message.hasOwnProperty("hostRewrite")) {
                                properties._hostRewrite = 1;
                                if (!$util.isString(message.hostRewrite))
                                    return "hostRewrite: string expected";
                            }
                            if (message.pathPrefixRewrite != null && message.hasOwnProperty("pathPrefixRewrite")) {
                                properties._pathPrefixRewrite = 1;
                                if (!$util.isString(message.pathPrefixRewrite))
                                    return "pathPrefixRewrite: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an UrlRewrite message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UrlRewrite
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UrlRewrite} UrlRewrite
                         */
                        UrlRewrite.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UrlRewrite)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UrlRewrite();
                            if (object.hostRewrite != null)
                                message.hostRewrite = String(object.hostRewrite);
                            if (object.pathPrefixRewrite != null)
                                message.pathPrefixRewrite = String(object.pathPrefixRewrite);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an UrlRewrite message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UrlRewrite
                         * @static
                         * @param {google.cloud.compute.v1.UrlRewrite} message UrlRewrite
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UrlRewrite.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.pathPrefixRewrite != null && message.hasOwnProperty("pathPrefixRewrite")) {
                                object.pathPrefixRewrite = message.pathPrefixRewrite;
                                if (options.oneofs)
                                    object._pathPrefixRewrite = "pathPrefixRewrite";
                            }
                            if (message.hostRewrite != null && message.hasOwnProperty("hostRewrite")) {
                                object.hostRewrite = message.hostRewrite;
                                if (options.oneofs)
                                    object._hostRewrite = "hostRewrite";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UrlRewrite to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UrlRewrite
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UrlRewrite.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UrlRewrite
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UrlRewrite
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UrlRewrite.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UrlRewrite";
                        };
    
                        return UrlRewrite;
                    })();
    
                    v1.UsableSubnetwork = (function() {
    
                        /**
                         * Properties of a UsableSubnetwork.
                         * @memberof google.cloud.compute.v1
                         * @interface IUsableSubnetwork
                         * @property {string|null} [externalIpv6Prefix] UsableSubnetwork externalIpv6Prefix
                         * @property {string|null} [internalIpv6Prefix] UsableSubnetwork internalIpv6Prefix
                         * @property {string|null} [ipCidrRange] UsableSubnetwork ipCidrRange
                         * @property {string|null} [ipv6AccessType] UsableSubnetwork ipv6AccessType
                         * @property {string|null} [network] UsableSubnetwork network
                         * @property {string|null} [purpose] UsableSubnetwork purpose
                         * @property {string|null} [role] UsableSubnetwork role
                         * @property {Array.<google.cloud.compute.v1.IUsableSubnetworkSecondaryRange>|null} [secondaryIpRanges] UsableSubnetwork secondaryIpRanges
                         * @property {string|null} [stackType] UsableSubnetwork stackType
                         * @property {string|null} [subnetwork] UsableSubnetwork subnetwork
                         */
    
                        /**
                         * Constructs a new UsableSubnetwork.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a UsableSubnetwork.
                         * @implements IUsableSubnetwork
                         * @constructor
                         * @param {google.cloud.compute.v1.IUsableSubnetwork=} [properties] Properties to set
                         */
                        function UsableSubnetwork(properties) {
                            this.secondaryIpRanges = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UsableSubnetwork externalIpv6Prefix.
                         * @member {string|null|undefined} externalIpv6Prefix
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @instance
                         */
                        UsableSubnetwork.prototype.externalIpv6Prefix = null;
    
                        /**
                         * UsableSubnetwork internalIpv6Prefix.
                         * @member {string|null|undefined} internalIpv6Prefix
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @instance
                         */
                        UsableSubnetwork.prototype.internalIpv6Prefix = null;
    
                        /**
                         * UsableSubnetwork ipCidrRange.
                         * @member {string|null|undefined} ipCidrRange
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @instance
                         */
                        UsableSubnetwork.prototype.ipCidrRange = null;
    
                        /**
                         * UsableSubnetwork ipv6AccessType.
                         * @member {string|null|undefined} ipv6AccessType
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @instance
                         */
                        UsableSubnetwork.prototype.ipv6AccessType = null;
    
                        /**
                         * UsableSubnetwork network.
                         * @member {string|null|undefined} network
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @instance
                         */
                        UsableSubnetwork.prototype.network = null;
    
                        /**
                         * UsableSubnetwork purpose.
                         * @member {string|null|undefined} purpose
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @instance
                         */
                        UsableSubnetwork.prototype.purpose = null;
    
                        /**
                         * UsableSubnetwork role.
                         * @member {string|null|undefined} role
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @instance
                         */
                        UsableSubnetwork.prototype.role = null;
    
                        /**
                         * UsableSubnetwork secondaryIpRanges.
                         * @member {Array.<google.cloud.compute.v1.IUsableSubnetworkSecondaryRange>} secondaryIpRanges
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @instance
                         */
                        UsableSubnetwork.prototype.secondaryIpRanges = $util.emptyArray;
    
                        /**
                         * UsableSubnetwork stackType.
                         * @member {string|null|undefined} stackType
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @instance
                         */
                        UsableSubnetwork.prototype.stackType = null;
    
                        /**
                         * UsableSubnetwork subnetwork.
                         * @member {string|null|undefined} subnetwork
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @instance
                         */
                        UsableSubnetwork.prototype.subnetwork = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UsableSubnetwork _externalIpv6Prefix.
                         * @member {"externalIpv6Prefix"|undefined} _externalIpv6Prefix
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @instance
                         */
                        Object.defineProperty(UsableSubnetwork.prototype, "_externalIpv6Prefix", {
                            get: $util.oneOfGetter($oneOfFields = ["externalIpv6Prefix"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UsableSubnetwork _internalIpv6Prefix.
                         * @member {"internalIpv6Prefix"|undefined} _internalIpv6Prefix
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @instance
                         */
                        Object.defineProperty(UsableSubnetwork.prototype, "_internalIpv6Prefix", {
                            get: $util.oneOfGetter($oneOfFields = ["internalIpv6Prefix"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UsableSubnetwork _ipCidrRange.
                         * @member {"ipCidrRange"|undefined} _ipCidrRange
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @instance
                         */
                        Object.defineProperty(UsableSubnetwork.prototype, "_ipCidrRange", {
                            get: $util.oneOfGetter($oneOfFields = ["ipCidrRange"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UsableSubnetwork _ipv6AccessType.
                         * @member {"ipv6AccessType"|undefined} _ipv6AccessType
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @instance
                         */
                        Object.defineProperty(UsableSubnetwork.prototype, "_ipv6AccessType", {
                            get: $util.oneOfGetter($oneOfFields = ["ipv6AccessType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UsableSubnetwork _network.
                         * @member {"network"|undefined} _network
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @instance
                         */
                        Object.defineProperty(UsableSubnetwork.prototype, "_network", {
                            get: $util.oneOfGetter($oneOfFields = ["network"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UsableSubnetwork _purpose.
                         * @member {"purpose"|undefined} _purpose
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @instance
                         */
                        Object.defineProperty(UsableSubnetwork.prototype, "_purpose", {
                            get: $util.oneOfGetter($oneOfFields = ["purpose"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UsableSubnetwork _role.
                         * @member {"role"|undefined} _role
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @instance
                         */
                        Object.defineProperty(UsableSubnetwork.prototype, "_role", {
                            get: $util.oneOfGetter($oneOfFields = ["role"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UsableSubnetwork _stackType.
                         * @member {"stackType"|undefined} _stackType
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @instance
                         */
                        Object.defineProperty(UsableSubnetwork.prototype, "_stackType", {
                            get: $util.oneOfGetter($oneOfFields = ["stackType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UsableSubnetwork _subnetwork.
                         * @member {"subnetwork"|undefined} _subnetwork
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @instance
                         */
                        Object.defineProperty(UsableSubnetwork.prototype, "_subnetwork", {
                            get: $util.oneOfGetter($oneOfFields = ["subnetwork"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UsableSubnetwork instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @static
                         * @param {google.cloud.compute.v1.IUsableSubnetwork=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UsableSubnetwork} UsableSubnetwork instance
                         */
                        UsableSubnetwork.create = function create(properties) {
                            return new UsableSubnetwork(properties);
                        };
    
                        /**
                         * Encodes the specified UsableSubnetwork message. Does not implicitly {@link google.cloud.compute.v1.UsableSubnetwork.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @static
                         * @param {google.cloud.compute.v1.IUsableSubnetwork} message UsableSubnetwork message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UsableSubnetwork.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.role != null && Object.hasOwnProperty.call(message, "role"))
                                writer.uint32(/* id 3506294, wireType 2 =*/28050354).string(message.role);
                            if (message.ipCidrRange != null && Object.hasOwnProperty.call(message, "ipCidrRange"))
                                writer.uint32(/* id 98117322, wireType 2 =*/784938578).string(message.ipCidrRange);
                            if (message.secondaryIpRanges != null && message.secondaryIpRanges.length)
                                for (var i = 0; i < message.secondaryIpRanges.length; ++i)
                                    $root.google.cloud.compute.v1.UsableSubnetworkSecondaryRange.encode(message.secondaryIpRanges[i], writer.uint32(/* id 136658915, wireType 2 =*/1093271322).fork()).ldelim();
                            if (message.externalIpv6Prefix != null && Object.hasOwnProperty.call(message, "externalIpv6Prefix"))
                                writer.uint32(/* id 139299190, wireType 2 =*/1114393522).string(message.externalIpv6Prefix);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            if (message.subnetwork != null && Object.hasOwnProperty.call(message, "subnetwork"))
                                writer.uint32(/* id 307827694, wireType 2 =*/2462621554).string(message.subnetwork);
                            if (message.purpose != null && Object.hasOwnProperty.call(message, "purpose"))
                                writer.uint32(/* id 316407070, wireType 2 =*/2531256562).string(message.purpose);
                            if (message.stackType != null && Object.hasOwnProperty.call(message, "stackType"))
                                writer.uint32(/* id 425908881, wireType 2 =*/3407271050).string(message.stackType);
                            if (message.ipv6AccessType != null && Object.hasOwnProperty.call(message, "ipv6AccessType"))
                                writer.uint32(/* id 504658653, wireType 2 =*/4037269226).string(message.ipv6AccessType);
                            if (message.internalIpv6Prefix != null && Object.hasOwnProperty.call(message, "internalIpv6Prefix"))
                                writer.uint32(/* id 506270056, wireType 2 =*/4050160450).string(message.internalIpv6Prefix);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UsableSubnetwork message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UsableSubnetwork.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @static
                         * @param {google.cloud.compute.v1.IUsableSubnetwork} message UsableSubnetwork message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UsableSubnetwork.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a UsableSubnetwork message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UsableSubnetwork} UsableSubnetwork
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UsableSubnetwork.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UsableSubnetwork();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 139299190: {
                                        message.externalIpv6Prefix = reader.string();
                                        break;
                                    }
                                case 506270056: {
                                        message.internalIpv6Prefix = reader.string();
                                        break;
                                    }
                                case 98117322: {
                                        message.ipCidrRange = reader.string();
                                        break;
                                    }
                                case 504658653: {
                                        message.ipv6AccessType = reader.string();
                                        break;
                                    }
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 316407070: {
                                        message.purpose = reader.string();
                                        break;
                                    }
                                case 3506294: {
                                        message.role = reader.string();
                                        break;
                                    }
                                case 136658915: {
                                        if (!(message.secondaryIpRanges && message.secondaryIpRanges.length))
                                            message.secondaryIpRanges = [];
                                        message.secondaryIpRanges.push($root.google.cloud.compute.v1.UsableSubnetworkSecondaryRange.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 425908881: {
                                        message.stackType = reader.string();
                                        break;
                                    }
                                case 307827694: {
                                        message.subnetwork = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a UsableSubnetwork message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UsableSubnetwork} UsableSubnetwork
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UsableSubnetwork.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a UsableSubnetwork message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UsableSubnetwork.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.externalIpv6Prefix != null && message.hasOwnProperty("externalIpv6Prefix")) {
                                properties._externalIpv6Prefix = 1;
                                if (!$util.isString(message.externalIpv6Prefix))
                                    return "externalIpv6Prefix: string expected";
                            }
                            if (message.internalIpv6Prefix != null && message.hasOwnProperty("internalIpv6Prefix")) {
                                properties._internalIpv6Prefix = 1;
                                if (!$util.isString(message.internalIpv6Prefix))
                                    return "internalIpv6Prefix: string expected";
                            }
                            if (message.ipCidrRange != null && message.hasOwnProperty("ipCidrRange")) {
                                properties._ipCidrRange = 1;
                                if (!$util.isString(message.ipCidrRange))
                                    return "ipCidrRange: string expected";
                            }
                            if (message.ipv6AccessType != null && message.hasOwnProperty("ipv6AccessType")) {
                                properties._ipv6AccessType = 1;
                                if (!$util.isString(message.ipv6AccessType))
                                    return "ipv6AccessType: string expected";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                properties._network = 1;
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            }
                            if (message.purpose != null && message.hasOwnProperty("purpose")) {
                                properties._purpose = 1;
                                if (!$util.isString(message.purpose))
                                    return "purpose: string expected";
                            }
                            if (message.role != null && message.hasOwnProperty("role")) {
                                properties._role = 1;
                                if (!$util.isString(message.role))
                                    return "role: string expected";
                            }
                            if (message.secondaryIpRanges != null && message.hasOwnProperty("secondaryIpRanges")) {
                                if (!Array.isArray(message.secondaryIpRanges))
                                    return "secondaryIpRanges: array expected";
                                for (var i = 0; i < message.secondaryIpRanges.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.UsableSubnetworkSecondaryRange.verify(message.secondaryIpRanges[i]);
                                    if (error)
                                        return "secondaryIpRanges." + error;
                                }
                            }
                            if (message.stackType != null && message.hasOwnProperty("stackType")) {
                                properties._stackType = 1;
                                if (!$util.isString(message.stackType))
                                    return "stackType: string expected";
                            }
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork")) {
                                properties._subnetwork = 1;
                                if (!$util.isString(message.subnetwork))
                                    return "subnetwork: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a UsableSubnetwork message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UsableSubnetwork} UsableSubnetwork
                         */
                        UsableSubnetwork.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UsableSubnetwork)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UsableSubnetwork();
                            if (object.externalIpv6Prefix != null)
                                message.externalIpv6Prefix = String(object.externalIpv6Prefix);
                            if (object.internalIpv6Prefix != null)
                                message.internalIpv6Prefix = String(object.internalIpv6Prefix);
                            if (object.ipCidrRange != null)
                                message.ipCidrRange = String(object.ipCidrRange);
                            if (object.ipv6AccessType != null)
                                message.ipv6AccessType = String(object.ipv6AccessType);
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.purpose != null)
                                message.purpose = String(object.purpose);
                            if (object.role != null)
                                message.role = String(object.role);
                            if (object.secondaryIpRanges) {
                                if (!Array.isArray(object.secondaryIpRanges))
                                    throw TypeError(".google.cloud.compute.v1.UsableSubnetwork.secondaryIpRanges: array expected");
                                message.secondaryIpRanges = [];
                                for (var i = 0; i < object.secondaryIpRanges.length; ++i) {
                                    if (typeof object.secondaryIpRanges[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.UsableSubnetwork.secondaryIpRanges: object expected");
                                    message.secondaryIpRanges[i] = $root.google.cloud.compute.v1.UsableSubnetworkSecondaryRange.fromObject(object.secondaryIpRanges[i]);
                                }
                            }
                            if (object.stackType != null)
                                message.stackType = String(object.stackType);
                            if (object.subnetwork != null)
                                message.subnetwork = String(object.subnetwork);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a UsableSubnetwork message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @static
                         * @param {google.cloud.compute.v1.UsableSubnetwork} message UsableSubnetwork
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UsableSubnetwork.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.secondaryIpRanges = [];
                            if (message.role != null && message.hasOwnProperty("role")) {
                                object.role = message.role;
                                if (options.oneofs)
                                    object._role = "role";
                            }
                            if (message.ipCidrRange != null && message.hasOwnProperty("ipCidrRange")) {
                                object.ipCidrRange = message.ipCidrRange;
                                if (options.oneofs)
                                    object._ipCidrRange = "ipCidrRange";
                            }
                            if (message.secondaryIpRanges && message.secondaryIpRanges.length) {
                                object.secondaryIpRanges = [];
                                for (var j = 0; j < message.secondaryIpRanges.length; ++j)
                                    object.secondaryIpRanges[j] = $root.google.cloud.compute.v1.UsableSubnetworkSecondaryRange.toObject(message.secondaryIpRanges[j], options);
                            }
                            if (message.externalIpv6Prefix != null && message.hasOwnProperty("externalIpv6Prefix")) {
                                object.externalIpv6Prefix = message.externalIpv6Prefix;
                                if (options.oneofs)
                                    object._externalIpv6Prefix = "externalIpv6Prefix";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                object.network = message.network;
                                if (options.oneofs)
                                    object._network = "network";
                            }
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork")) {
                                object.subnetwork = message.subnetwork;
                                if (options.oneofs)
                                    object._subnetwork = "subnetwork";
                            }
                            if (message.purpose != null && message.hasOwnProperty("purpose")) {
                                object.purpose = message.purpose;
                                if (options.oneofs)
                                    object._purpose = "purpose";
                            }
                            if (message.stackType != null && message.hasOwnProperty("stackType")) {
                                object.stackType = message.stackType;
                                if (options.oneofs)
                                    object._stackType = "stackType";
                            }
                            if (message.ipv6AccessType != null && message.hasOwnProperty("ipv6AccessType")) {
                                object.ipv6AccessType = message.ipv6AccessType;
                                if (options.oneofs)
                                    object._ipv6AccessType = "ipv6AccessType";
                            }
                            if (message.internalIpv6Prefix != null && message.hasOwnProperty("internalIpv6Prefix")) {
                                object.internalIpv6Prefix = message.internalIpv6Prefix;
                                if (options.oneofs)
                                    object._internalIpv6Prefix = "internalIpv6Prefix";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UsableSubnetwork to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UsableSubnetwork.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UsableSubnetwork
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UsableSubnetwork
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UsableSubnetwork.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UsableSubnetwork";
                        };
    
                        /**
                         * Ipv6AccessType enum.
                         * @name google.cloud.compute.v1.UsableSubnetwork.Ipv6AccessType
                         * @enum {number}
                         * @property {number} UNDEFINED_IPV6_ACCESS_TYPE=0 UNDEFINED_IPV6_ACCESS_TYPE value
                         * @property {number} EXTERNAL=35607499 EXTERNAL value
                         * @property {number} INTERNAL=279295677 INTERNAL value
                         */
                        UsableSubnetwork.Ipv6AccessType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_IPV6_ACCESS_TYPE"] = 0;
                            values[valuesById[35607499] = "EXTERNAL"] = 35607499;
                            values[valuesById[279295677] = "INTERNAL"] = 279295677;
                            return values;
                        })();
    
                        /**
                         * Purpose enum.
                         * @name google.cloud.compute.v1.UsableSubnetwork.Purpose
                         * @enum {number}
                         * @property {number} UNDEFINED_PURPOSE=0 UNDEFINED_PURPOSE value
                         * @property {number} INTERNAL_HTTPS_LOAD_BALANCER=248748889 INTERNAL_HTTPS_LOAD_BALANCER value
                         * @property {number} PRIVATE=403485027 PRIVATE value
                         * @property {number} PRIVATE_RFC_1918=254902107 PRIVATE_RFC_1918 value
                         * @property {number} PRIVATE_SERVICE_CONNECT=48134724 PRIVATE_SERVICE_CONNECT value
                         * @property {number} REGIONAL_MANAGED_PROXY=153049966 REGIONAL_MANAGED_PROXY value
                         */
                        UsableSubnetwork.Purpose = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PURPOSE"] = 0;
                            values[valuesById[248748889] = "INTERNAL_HTTPS_LOAD_BALANCER"] = 248748889;
                            values[valuesById[403485027] = "PRIVATE"] = 403485027;
                            values[valuesById[254902107] = "PRIVATE_RFC_1918"] = 254902107;
                            values[valuesById[48134724] = "PRIVATE_SERVICE_CONNECT"] = 48134724;
                            values[valuesById[153049966] = "REGIONAL_MANAGED_PROXY"] = 153049966;
                            return values;
                        })();
    
                        /**
                         * Role enum.
                         * @name google.cloud.compute.v1.UsableSubnetwork.Role
                         * @enum {number}
                         * @property {number} UNDEFINED_ROLE=0 UNDEFINED_ROLE value
                         * @property {number} ACTIVE=314733318 ACTIVE value
                         * @property {number} BACKUP=341010882 BACKUP value
                         */
                        UsableSubnetwork.Role = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ROLE"] = 0;
                            values[valuesById[314733318] = "ACTIVE"] = 314733318;
                            values[valuesById[341010882] = "BACKUP"] = 341010882;
                            return values;
                        })();
    
                        /**
                         * StackType enum.
                         * @name google.cloud.compute.v1.UsableSubnetwork.StackType
                         * @enum {number}
                         * @property {number} UNDEFINED_STACK_TYPE=0 UNDEFINED_STACK_TYPE value
                         * @property {number} IPV4_IPV6=22197249 IPV4_IPV6 value
                         * @property {number} IPV4_ONLY=22373798 IPV4_ONLY value
                         */
                        UsableSubnetwork.StackType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STACK_TYPE"] = 0;
                            values[valuesById[22197249] = "IPV4_IPV6"] = 22197249;
                            values[valuesById[22373798] = "IPV4_ONLY"] = 22373798;
                            return values;
                        })();
    
                        return UsableSubnetwork;
                    })();
    
                    v1.UsableSubnetworkSecondaryRange = (function() {
    
                        /**
                         * Properties of a UsableSubnetworkSecondaryRange.
                         * @memberof google.cloud.compute.v1
                         * @interface IUsableSubnetworkSecondaryRange
                         * @property {string|null} [ipCidrRange] UsableSubnetworkSecondaryRange ipCidrRange
                         * @property {string|null} [rangeName] UsableSubnetworkSecondaryRange rangeName
                         */
    
                        /**
                         * Constructs a new UsableSubnetworkSecondaryRange.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a UsableSubnetworkSecondaryRange.
                         * @implements IUsableSubnetworkSecondaryRange
                         * @constructor
                         * @param {google.cloud.compute.v1.IUsableSubnetworkSecondaryRange=} [properties] Properties to set
                         */
                        function UsableSubnetworkSecondaryRange(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UsableSubnetworkSecondaryRange ipCidrRange.
                         * @member {string|null|undefined} ipCidrRange
                         * @memberof google.cloud.compute.v1.UsableSubnetworkSecondaryRange
                         * @instance
                         */
                        UsableSubnetworkSecondaryRange.prototype.ipCidrRange = null;
    
                        /**
                         * UsableSubnetworkSecondaryRange rangeName.
                         * @member {string|null|undefined} rangeName
                         * @memberof google.cloud.compute.v1.UsableSubnetworkSecondaryRange
                         * @instance
                         */
                        UsableSubnetworkSecondaryRange.prototype.rangeName = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UsableSubnetworkSecondaryRange _ipCidrRange.
                         * @member {"ipCidrRange"|undefined} _ipCidrRange
                         * @memberof google.cloud.compute.v1.UsableSubnetworkSecondaryRange
                         * @instance
                         */
                        Object.defineProperty(UsableSubnetworkSecondaryRange.prototype, "_ipCidrRange", {
                            get: $util.oneOfGetter($oneOfFields = ["ipCidrRange"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UsableSubnetworkSecondaryRange _rangeName.
                         * @member {"rangeName"|undefined} _rangeName
                         * @memberof google.cloud.compute.v1.UsableSubnetworkSecondaryRange
                         * @instance
                         */
                        Object.defineProperty(UsableSubnetworkSecondaryRange.prototype, "_rangeName", {
                            get: $util.oneOfGetter($oneOfFields = ["rangeName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UsableSubnetworkSecondaryRange instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UsableSubnetworkSecondaryRange
                         * @static
                         * @param {google.cloud.compute.v1.IUsableSubnetworkSecondaryRange=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UsableSubnetworkSecondaryRange} UsableSubnetworkSecondaryRange instance
                         */
                        UsableSubnetworkSecondaryRange.create = function create(properties) {
                            return new UsableSubnetworkSecondaryRange(properties);
                        };
    
                        /**
                         * Encodes the specified UsableSubnetworkSecondaryRange message. Does not implicitly {@link google.cloud.compute.v1.UsableSubnetworkSecondaryRange.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UsableSubnetworkSecondaryRange
                         * @static
                         * @param {google.cloud.compute.v1.IUsableSubnetworkSecondaryRange} message UsableSubnetworkSecondaryRange message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UsableSubnetworkSecondaryRange.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.ipCidrRange != null && Object.hasOwnProperty.call(message, "ipCidrRange"))
                                writer.uint32(/* id 98117322, wireType 2 =*/784938578).string(message.ipCidrRange);
                            if (message.rangeName != null && Object.hasOwnProperty.call(message, "rangeName"))
                                writer.uint32(/* id 332216397, wireType 2 =*/2657731178).string(message.rangeName);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UsableSubnetworkSecondaryRange message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UsableSubnetworkSecondaryRange.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UsableSubnetworkSecondaryRange
                         * @static
                         * @param {google.cloud.compute.v1.IUsableSubnetworkSecondaryRange} message UsableSubnetworkSecondaryRange message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UsableSubnetworkSecondaryRange.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a UsableSubnetworkSecondaryRange message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UsableSubnetworkSecondaryRange
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UsableSubnetworkSecondaryRange} UsableSubnetworkSecondaryRange
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UsableSubnetworkSecondaryRange.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UsableSubnetworkSecondaryRange();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 98117322: {
                                        message.ipCidrRange = reader.string();
                                        break;
                                    }
                                case 332216397: {
                                        message.rangeName = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a UsableSubnetworkSecondaryRange message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UsableSubnetworkSecondaryRange
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UsableSubnetworkSecondaryRange} UsableSubnetworkSecondaryRange
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UsableSubnetworkSecondaryRange.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a UsableSubnetworkSecondaryRange message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UsableSubnetworkSecondaryRange
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UsableSubnetworkSecondaryRange.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.ipCidrRange != null && message.hasOwnProperty("ipCidrRange")) {
                                properties._ipCidrRange = 1;
                                if (!$util.isString(message.ipCidrRange))
                                    return "ipCidrRange: string expected";
                            }
                            if (message.rangeName != null && message.hasOwnProperty("rangeName")) {
                                properties._rangeName = 1;
                                if (!$util.isString(message.rangeName))
                                    return "rangeName: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a UsableSubnetworkSecondaryRange message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UsableSubnetworkSecondaryRange
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UsableSubnetworkSecondaryRange} UsableSubnetworkSecondaryRange
                         */
                        UsableSubnetworkSecondaryRange.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UsableSubnetworkSecondaryRange)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UsableSubnetworkSecondaryRange();
                            if (object.ipCidrRange != null)
                                message.ipCidrRange = String(object.ipCidrRange);
                            if (object.rangeName != null)
                                message.rangeName = String(object.rangeName);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a UsableSubnetworkSecondaryRange message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UsableSubnetworkSecondaryRange
                         * @static
                         * @param {google.cloud.compute.v1.UsableSubnetworkSecondaryRange} message UsableSubnetworkSecondaryRange
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UsableSubnetworkSecondaryRange.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.ipCidrRange != null && message.hasOwnProperty("ipCidrRange")) {
                                object.ipCidrRange = message.ipCidrRange;
                                if (options.oneofs)
                                    object._ipCidrRange = "ipCidrRange";
                            }
                            if (message.rangeName != null && message.hasOwnProperty("rangeName")) {
                                object.rangeName = message.rangeName;
                                if (options.oneofs)
                                    object._rangeName = "rangeName";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UsableSubnetworkSecondaryRange to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UsableSubnetworkSecondaryRange
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UsableSubnetworkSecondaryRange.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UsableSubnetworkSecondaryRange
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UsableSubnetworkSecondaryRange
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UsableSubnetworkSecondaryRange.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UsableSubnetworkSecondaryRange";
                        };
    
                        return UsableSubnetworkSecondaryRange;
                    })();
    
                    v1.UsableSubnetworksAggregatedList = (function() {
    
                        /**
                         * Properties of a UsableSubnetworksAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IUsableSubnetworksAggregatedList
                         * @property {string|null} [id] UsableSubnetworksAggregatedList id
                         * @property {Array.<google.cloud.compute.v1.IUsableSubnetwork>|null} [items] UsableSubnetworksAggregatedList items
                         * @property {string|null} [kind] UsableSubnetworksAggregatedList kind
                         * @property {string|null} [nextPageToken] UsableSubnetworksAggregatedList nextPageToken
                         * @property {string|null} [selfLink] UsableSubnetworksAggregatedList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] UsableSubnetworksAggregatedList warning
                         */
    
                        /**
                         * Constructs a new UsableSubnetworksAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a UsableSubnetworksAggregatedList.
                         * @implements IUsableSubnetworksAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IUsableSubnetworksAggregatedList=} [properties] Properties to set
                         */
                        function UsableSubnetworksAggregatedList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UsableSubnetworksAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @instance
                         */
                        UsableSubnetworksAggregatedList.prototype.id = null;
    
                        /**
                         * UsableSubnetworksAggregatedList items.
                         * @member {Array.<google.cloud.compute.v1.IUsableSubnetwork>} items
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @instance
                         */
                        UsableSubnetworksAggregatedList.prototype.items = $util.emptyArray;
    
                        /**
                         * UsableSubnetworksAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @instance
                         */
                        UsableSubnetworksAggregatedList.prototype.kind = null;
    
                        /**
                         * UsableSubnetworksAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @instance
                         */
                        UsableSubnetworksAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * UsableSubnetworksAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @instance
                         */
                        UsableSubnetworksAggregatedList.prototype.selfLink = null;
    
                        /**
                         * UsableSubnetworksAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @instance
                         */
                        UsableSubnetworksAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UsableSubnetworksAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @instance
                         */
                        Object.defineProperty(UsableSubnetworksAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UsableSubnetworksAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @instance
                         */
                        Object.defineProperty(UsableSubnetworksAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UsableSubnetworksAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @instance
                         */
                        Object.defineProperty(UsableSubnetworksAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UsableSubnetworksAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @instance
                         */
                        Object.defineProperty(UsableSubnetworksAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UsableSubnetworksAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @instance
                         */
                        Object.defineProperty(UsableSubnetworksAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UsableSubnetworksAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IUsableSubnetworksAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UsableSubnetworksAggregatedList} UsableSubnetworksAggregatedList instance
                         */
                        UsableSubnetworksAggregatedList.create = function create(properties) {
                            return new UsableSubnetworksAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified UsableSubnetworksAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.UsableSubnetworksAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IUsableSubnetworksAggregatedList} message UsableSubnetworksAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UsableSubnetworksAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.UsableSubnetwork.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UsableSubnetworksAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UsableSubnetworksAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IUsableSubnetworksAggregatedList} message UsableSubnetworksAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UsableSubnetworksAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a UsableSubnetworksAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UsableSubnetworksAggregatedList} UsableSubnetworksAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UsableSubnetworksAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UsableSubnetworksAggregatedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.UsableSubnetwork.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a UsableSubnetworksAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UsableSubnetworksAggregatedList} UsableSubnetworksAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UsableSubnetworksAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a UsableSubnetworksAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UsableSubnetworksAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.UsableSubnetwork.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a UsableSubnetworksAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UsableSubnetworksAggregatedList} UsableSubnetworksAggregatedList
                         */
                        UsableSubnetworksAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UsableSubnetworksAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UsableSubnetworksAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.UsableSubnetworksAggregatedList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.UsableSubnetworksAggregatedList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.UsableSubnetwork.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.UsableSubnetworksAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a UsableSubnetworksAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.UsableSubnetworksAggregatedList} message UsableSubnetworksAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UsableSubnetworksAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.UsableSubnetwork.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UsableSubnetworksAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UsableSubnetworksAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UsableSubnetworksAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UsableSubnetworksAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UsableSubnetworksAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UsableSubnetworksAggregatedList";
                        };
    
                        return UsableSubnetworksAggregatedList;
                    })();
    
                    v1.UsageExportLocation = (function() {
    
                        /**
                         * Properties of a UsageExportLocation.
                         * @memberof google.cloud.compute.v1
                         * @interface IUsageExportLocation
                         * @property {string|null} [bucketName] UsageExportLocation bucketName
                         * @property {string|null} [reportNamePrefix] UsageExportLocation reportNamePrefix
                         */
    
                        /**
                         * Constructs a new UsageExportLocation.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a UsageExportLocation.
                         * @implements IUsageExportLocation
                         * @constructor
                         * @param {google.cloud.compute.v1.IUsageExportLocation=} [properties] Properties to set
                         */
                        function UsageExportLocation(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * UsageExportLocation bucketName.
                         * @member {string|null|undefined} bucketName
                         * @memberof google.cloud.compute.v1.UsageExportLocation
                         * @instance
                         */
                        UsageExportLocation.prototype.bucketName = null;
    
                        /**
                         * UsageExportLocation reportNamePrefix.
                         * @member {string|null|undefined} reportNamePrefix
                         * @memberof google.cloud.compute.v1.UsageExportLocation
                         * @instance
                         */
                        UsageExportLocation.prototype.reportNamePrefix = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * UsageExportLocation _bucketName.
                         * @member {"bucketName"|undefined} _bucketName
                         * @memberof google.cloud.compute.v1.UsageExportLocation
                         * @instance
                         */
                        Object.defineProperty(UsageExportLocation.prototype, "_bucketName", {
                            get: $util.oneOfGetter($oneOfFields = ["bucketName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * UsageExportLocation _reportNamePrefix.
                         * @member {"reportNamePrefix"|undefined} _reportNamePrefix
                         * @memberof google.cloud.compute.v1.UsageExportLocation
                         * @instance
                         */
                        Object.defineProperty(UsageExportLocation.prototype, "_reportNamePrefix", {
                            get: $util.oneOfGetter($oneOfFields = ["reportNamePrefix"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new UsageExportLocation instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.UsageExportLocation
                         * @static
                         * @param {google.cloud.compute.v1.IUsageExportLocation=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.UsageExportLocation} UsageExportLocation instance
                         */
                        UsageExportLocation.create = function create(properties) {
                            return new UsageExportLocation(properties);
                        };
    
                        /**
                         * Encodes the specified UsageExportLocation message. Does not implicitly {@link google.cloud.compute.v1.UsageExportLocation.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.UsageExportLocation
                         * @static
                         * @param {google.cloud.compute.v1.IUsageExportLocation} message UsageExportLocation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UsageExportLocation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.bucketName != null && Object.hasOwnProperty.call(message, "bucketName"))
                                writer.uint32(/* id 283610048, wireType 2 =*/2268880386).string(message.bucketName);
                            if (message.reportNamePrefix != null && Object.hasOwnProperty.call(message, "reportNamePrefix"))
                                writer.uint32(/* id 320198715, wireType 2 =*/2561589722).string(message.reportNamePrefix);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified UsageExportLocation message, length delimited. Does not implicitly {@link google.cloud.compute.v1.UsageExportLocation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.UsageExportLocation
                         * @static
                         * @param {google.cloud.compute.v1.IUsageExportLocation} message UsageExportLocation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        UsageExportLocation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a UsageExportLocation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.UsageExportLocation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.UsageExportLocation} UsageExportLocation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UsageExportLocation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.UsageExportLocation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 283610048: {
                                        message.bucketName = reader.string();
                                        break;
                                    }
                                case 320198715: {
                                        message.reportNamePrefix = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a UsageExportLocation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.UsageExportLocation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.UsageExportLocation} UsageExportLocation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        UsageExportLocation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a UsageExportLocation message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.UsageExportLocation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        UsageExportLocation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.bucketName != null && message.hasOwnProperty("bucketName")) {
                                properties._bucketName = 1;
                                if (!$util.isString(message.bucketName))
                                    return "bucketName: string expected";
                            }
                            if (message.reportNamePrefix != null && message.hasOwnProperty("reportNamePrefix")) {
                                properties._reportNamePrefix = 1;
                                if (!$util.isString(message.reportNamePrefix))
                                    return "reportNamePrefix: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a UsageExportLocation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.UsageExportLocation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.UsageExportLocation} UsageExportLocation
                         */
                        UsageExportLocation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.UsageExportLocation)
                                return object;
                            var message = new $root.google.cloud.compute.v1.UsageExportLocation();
                            if (object.bucketName != null)
                                message.bucketName = String(object.bucketName);
                            if (object.reportNamePrefix != null)
                                message.reportNamePrefix = String(object.reportNamePrefix);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a UsageExportLocation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.UsageExportLocation
                         * @static
                         * @param {google.cloud.compute.v1.UsageExportLocation} message UsageExportLocation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        UsageExportLocation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.bucketName != null && message.hasOwnProperty("bucketName")) {
                                object.bucketName = message.bucketName;
                                if (options.oneofs)
                                    object._bucketName = "bucketName";
                            }
                            if (message.reportNamePrefix != null && message.hasOwnProperty("reportNamePrefix")) {
                                object.reportNamePrefix = message.reportNamePrefix;
                                if (options.oneofs)
                                    object._reportNamePrefix = "reportNamePrefix";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this UsageExportLocation to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.UsageExportLocation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        UsageExportLocation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for UsageExportLocation
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.UsageExportLocation
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        UsageExportLocation.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.UsageExportLocation";
                        };
    
                        return UsageExportLocation;
                    })();
    
                    v1.ValidateRegionUrlMapRequest = (function() {
    
                        /**
                         * Properties of a ValidateRegionUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IValidateRegionUrlMapRequest
                         * @property {string|null} [project] ValidateRegionUrlMapRequest project
                         * @property {string|null} [region] ValidateRegionUrlMapRequest region
                         * @property {google.cloud.compute.v1.IRegionUrlMapsValidateRequest|null} [regionUrlMapsValidateRequestResource] ValidateRegionUrlMapRequest regionUrlMapsValidateRequestResource
                         * @property {string|null} [urlMap] ValidateRegionUrlMapRequest urlMap
                         */
    
                        /**
                         * Constructs a new ValidateRegionUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ValidateRegionUrlMapRequest.
                         * @implements IValidateRegionUrlMapRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IValidateRegionUrlMapRequest=} [properties] Properties to set
                         */
                        function ValidateRegionUrlMapRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ValidateRegionUrlMapRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ValidateRegionUrlMapRequest
                         * @instance
                         */
                        ValidateRegionUrlMapRequest.prototype.project = "";
    
                        /**
                         * ValidateRegionUrlMapRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.ValidateRegionUrlMapRequest
                         * @instance
                         */
                        ValidateRegionUrlMapRequest.prototype.region = "";
    
                        /**
                         * ValidateRegionUrlMapRequest regionUrlMapsValidateRequestResource.
                         * @member {google.cloud.compute.v1.IRegionUrlMapsValidateRequest|null|undefined} regionUrlMapsValidateRequestResource
                         * @memberof google.cloud.compute.v1.ValidateRegionUrlMapRequest
                         * @instance
                         */
                        ValidateRegionUrlMapRequest.prototype.regionUrlMapsValidateRequestResource = null;
    
                        /**
                         * ValidateRegionUrlMapRequest urlMap.
                         * @member {string} urlMap
                         * @memberof google.cloud.compute.v1.ValidateRegionUrlMapRequest
                         * @instance
                         */
                        ValidateRegionUrlMapRequest.prototype.urlMap = "";
    
                        /**
                         * Creates a new ValidateRegionUrlMapRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ValidateRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IValidateRegionUrlMapRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ValidateRegionUrlMapRequest} ValidateRegionUrlMapRequest instance
                         */
                        ValidateRegionUrlMapRequest.create = function create(properties) {
                            return new ValidateRegionUrlMapRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ValidateRegionUrlMapRequest message. Does not implicitly {@link google.cloud.compute.v1.ValidateRegionUrlMapRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ValidateRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IValidateRegionUrlMapRequest} message ValidateRegionUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ValidateRegionUrlMapRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.regionUrlMapsValidateRequestResource != null && Object.hasOwnProperty.call(message, "regionUrlMapsValidateRequestResource"))
                                $root.google.cloud.compute.v1.RegionUrlMapsValidateRequest.encode(message.regionUrlMapsValidateRequestResource, writer.uint32(/* id 56632858, wireType 2 =*/453062866).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.urlMap != null && Object.hasOwnProperty.call(message, "urlMap"))
                                writer.uint32(/* id 367020684, wireType 2 =*/2936165474).string(message.urlMap);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ValidateRegionUrlMapRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ValidateRegionUrlMapRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ValidateRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IValidateRegionUrlMapRequest} message ValidateRegionUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ValidateRegionUrlMapRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ValidateRegionUrlMapRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ValidateRegionUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ValidateRegionUrlMapRequest} ValidateRegionUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ValidateRegionUrlMapRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ValidateRegionUrlMapRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 56632858: {
                                        message.regionUrlMapsValidateRequestResource = $root.google.cloud.compute.v1.RegionUrlMapsValidateRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 367020684: {
                                        message.urlMap = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ValidateRegionUrlMapRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ValidateRegionUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ValidateRegionUrlMapRequest} ValidateRegionUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ValidateRegionUrlMapRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ValidateRegionUrlMapRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ValidateRegionUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ValidateRegionUrlMapRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.regionUrlMapsValidateRequestResource != null && message.hasOwnProperty("regionUrlMapsValidateRequestResource")) {
                                var error = $root.google.cloud.compute.v1.RegionUrlMapsValidateRequest.verify(message.regionUrlMapsValidateRequestResource);
                                if (error)
                                    return "regionUrlMapsValidateRequestResource." + error;
                            }
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                if (!$util.isString(message.urlMap))
                                    return "urlMap: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ValidateRegionUrlMapRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ValidateRegionUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ValidateRegionUrlMapRequest} ValidateRegionUrlMapRequest
                         */
                        ValidateRegionUrlMapRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ValidateRegionUrlMapRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ValidateRegionUrlMapRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.regionUrlMapsValidateRequestResource != null) {
                                if (typeof object.regionUrlMapsValidateRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ValidateRegionUrlMapRequest.regionUrlMapsValidateRequestResource: object expected");
                                message.regionUrlMapsValidateRequestResource = $root.google.cloud.compute.v1.RegionUrlMapsValidateRequest.fromObject(object.regionUrlMapsValidateRequestResource);
                            }
                            if (object.urlMap != null)
                                message.urlMap = String(object.urlMap);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ValidateRegionUrlMapRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ValidateRegionUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.ValidateRegionUrlMapRequest} message ValidateRegionUrlMapRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ValidateRegionUrlMapRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.regionUrlMapsValidateRequestResource = null;
                                object.region = "";
                                object.project = "";
                                object.urlMap = "";
                            }
                            if (message.regionUrlMapsValidateRequestResource != null && message.hasOwnProperty("regionUrlMapsValidateRequestResource"))
                                object.regionUrlMapsValidateRequestResource = $root.google.cloud.compute.v1.RegionUrlMapsValidateRequest.toObject(message.regionUrlMapsValidateRequestResource, options);
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                object.urlMap = message.urlMap;
                            return object;
                        };
    
                        /**
                         * Converts this ValidateRegionUrlMapRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ValidateRegionUrlMapRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ValidateRegionUrlMapRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ValidateRegionUrlMapRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ValidateRegionUrlMapRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ValidateRegionUrlMapRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ValidateRegionUrlMapRequest";
                        };
    
                        return ValidateRegionUrlMapRequest;
                    })();
    
                    v1.ValidateUrlMapRequest = (function() {
    
                        /**
                         * Properties of a ValidateUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IValidateUrlMapRequest
                         * @property {string|null} [project] ValidateUrlMapRequest project
                         * @property {string|null} [urlMap] ValidateUrlMapRequest urlMap
                         * @property {google.cloud.compute.v1.IUrlMapsValidateRequest|null} [urlMapsValidateRequestResource] ValidateUrlMapRequest urlMapsValidateRequestResource
                         */
    
                        /**
                         * Constructs a new ValidateUrlMapRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ValidateUrlMapRequest.
                         * @implements IValidateUrlMapRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IValidateUrlMapRequest=} [properties] Properties to set
                         */
                        function ValidateUrlMapRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ValidateUrlMapRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.ValidateUrlMapRequest
                         * @instance
                         */
                        ValidateUrlMapRequest.prototype.project = "";
    
                        /**
                         * ValidateUrlMapRequest urlMap.
                         * @member {string} urlMap
                         * @memberof google.cloud.compute.v1.ValidateUrlMapRequest
                         * @instance
                         */
                        ValidateUrlMapRequest.prototype.urlMap = "";
    
                        /**
                         * ValidateUrlMapRequest urlMapsValidateRequestResource.
                         * @member {google.cloud.compute.v1.IUrlMapsValidateRequest|null|undefined} urlMapsValidateRequestResource
                         * @memberof google.cloud.compute.v1.ValidateUrlMapRequest
                         * @instance
                         */
                        ValidateUrlMapRequest.prototype.urlMapsValidateRequestResource = null;
    
                        /**
                         * Creates a new ValidateUrlMapRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ValidateUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IValidateUrlMapRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ValidateUrlMapRequest} ValidateUrlMapRequest instance
                         */
                        ValidateUrlMapRequest.create = function create(properties) {
                            return new ValidateUrlMapRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ValidateUrlMapRequest message. Does not implicitly {@link google.cloud.compute.v1.ValidateUrlMapRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ValidateUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IValidateUrlMapRequest} message ValidateUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ValidateUrlMapRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.urlMap != null && Object.hasOwnProperty.call(message, "urlMap"))
                                writer.uint32(/* id 367020684, wireType 2 =*/2936165474).string(message.urlMap);
                            if (message.urlMapsValidateRequestResource != null && Object.hasOwnProperty.call(message, "urlMapsValidateRequestResource"))
                                $root.google.cloud.compute.v1.UrlMapsValidateRequest.encode(message.urlMapsValidateRequestResource, writer.uint32(/* id 395913455, wireType 2 =*/3167307642).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ValidateUrlMapRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ValidateUrlMapRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ValidateUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.IValidateUrlMapRequest} message ValidateUrlMapRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ValidateUrlMapRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ValidateUrlMapRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ValidateUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ValidateUrlMapRequest} ValidateUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ValidateUrlMapRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ValidateUrlMapRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 367020684: {
                                        message.urlMap = reader.string();
                                        break;
                                    }
                                case 395913455: {
                                        message.urlMapsValidateRequestResource = $root.google.cloud.compute.v1.UrlMapsValidateRequest.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ValidateUrlMapRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ValidateUrlMapRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ValidateUrlMapRequest} ValidateUrlMapRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ValidateUrlMapRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ValidateUrlMapRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ValidateUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ValidateUrlMapRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                if (!$util.isString(message.urlMap))
                                    return "urlMap: string expected";
                            if (message.urlMapsValidateRequestResource != null && message.hasOwnProperty("urlMapsValidateRequestResource")) {
                                var error = $root.google.cloud.compute.v1.UrlMapsValidateRequest.verify(message.urlMapsValidateRequestResource);
                                if (error)
                                    return "urlMapsValidateRequestResource." + error;
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ValidateUrlMapRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ValidateUrlMapRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ValidateUrlMapRequest} ValidateUrlMapRequest
                         */
                        ValidateUrlMapRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ValidateUrlMapRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ValidateUrlMapRequest();
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.urlMap != null)
                                message.urlMap = String(object.urlMap);
                            if (object.urlMapsValidateRequestResource != null) {
                                if (typeof object.urlMapsValidateRequestResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ValidateUrlMapRequest.urlMapsValidateRequestResource: object expected");
                                message.urlMapsValidateRequestResource = $root.google.cloud.compute.v1.UrlMapsValidateRequest.fromObject(object.urlMapsValidateRequestResource);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ValidateUrlMapRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ValidateUrlMapRequest
                         * @static
                         * @param {google.cloud.compute.v1.ValidateUrlMapRequest} message ValidateUrlMapRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ValidateUrlMapRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.project = "";
                                object.urlMap = "";
                                object.urlMapsValidateRequestResource = null;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.urlMap != null && message.hasOwnProperty("urlMap"))
                                object.urlMap = message.urlMap;
                            if (message.urlMapsValidateRequestResource != null && message.hasOwnProperty("urlMapsValidateRequestResource"))
                                object.urlMapsValidateRequestResource = $root.google.cloud.compute.v1.UrlMapsValidateRequest.toObject(message.urlMapsValidateRequestResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this ValidateUrlMapRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ValidateUrlMapRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ValidateUrlMapRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ValidateUrlMapRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ValidateUrlMapRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ValidateUrlMapRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ValidateUrlMapRequest";
                        };
    
                        return ValidateUrlMapRequest;
                    })();
    
                    v1.VmEndpointNatMappings = (function() {
    
                        /**
                         * Properties of a VmEndpointNatMappings.
                         * @memberof google.cloud.compute.v1
                         * @interface IVmEndpointNatMappings
                         * @property {string|null} [instanceName] VmEndpointNatMappings instanceName
                         * @property {Array.<google.cloud.compute.v1.IVmEndpointNatMappingsInterfaceNatMappings>|null} [interfaceNatMappings] VmEndpointNatMappings interfaceNatMappings
                         */
    
                        /**
                         * Constructs a new VmEndpointNatMappings.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a VmEndpointNatMappings.
                         * @implements IVmEndpointNatMappings
                         * @constructor
                         * @param {google.cloud.compute.v1.IVmEndpointNatMappings=} [properties] Properties to set
                         */
                        function VmEndpointNatMappings(properties) {
                            this.interfaceNatMappings = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * VmEndpointNatMappings instanceName.
                         * @member {string|null|undefined} instanceName
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappings
                         * @instance
                         */
                        VmEndpointNatMappings.prototype.instanceName = null;
    
                        /**
                         * VmEndpointNatMappings interfaceNatMappings.
                         * @member {Array.<google.cloud.compute.v1.IVmEndpointNatMappingsInterfaceNatMappings>} interfaceNatMappings
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappings
                         * @instance
                         */
                        VmEndpointNatMappings.prototype.interfaceNatMappings = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * VmEndpointNatMappings _instanceName.
                         * @member {"instanceName"|undefined} _instanceName
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappings
                         * @instance
                         */
                        Object.defineProperty(VmEndpointNatMappings.prototype, "_instanceName", {
                            get: $util.oneOfGetter($oneOfFields = ["instanceName"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new VmEndpointNatMappings instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappings
                         * @static
                         * @param {google.cloud.compute.v1.IVmEndpointNatMappings=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.VmEndpointNatMappings} VmEndpointNatMappings instance
                         */
                        VmEndpointNatMappings.create = function create(properties) {
                            return new VmEndpointNatMappings(properties);
                        };
    
                        /**
                         * Encodes the specified VmEndpointNatMappings message. Does not implicitly {@link google.cloud.compute.v1.VmEndpointNatMappings.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappings
                         * @static
                         * @param {google.cloud.compute.v1.IVmEndpointNatMappings} message VmEndpointNatMappings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VmEndpointNatMappings.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.instanceName != null && Object.hasOwnProperty.call(message, "instanceName"))
                                writer.uint32(/* id 227947509, wireType 2 =*/1823580074).string(message.instanceName);
                            if (message.interfaceNatMappings != null && message.interfaceNatMappings.length)
                                for (var i = 0; i < message.interfaceNatMappings.length; ++i)
                                    $root.google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings.encode(message.interfaceNatMappings[i], writer.uint32(/* id 256196617, wireType 2 =*/2049572938).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified VmEndpointNatMappings message, length delimited. Does not implicitly {@link google.cloud.compute.v1.VmEndpointNatMappings.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappings
                         * @static
                         * @param {google.cloud.compute.v1.IVmEndpointNatMappings} message VmEndpointNatMappings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VmEndpointNatMappings.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a VmEndpointNatMappings message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.VmEndpointNatMappings} VmEndpointNatMappings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VmEndpointNatMappings.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.VmEndpointNatMappings();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 227947509: {
                                        message.instanceName = reader.string();
                                        break;
                                    }
                                case 256196617: {
                                        if (!(message.interfaceNatMappings && message.interfaceNatMappings.length))
                                            message.interfaceNatMappings = [];
                                        message.interfaceNatMappings.push($root.google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a VmEndpointNatMappings message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.VmEndpointNatMappings} VmEndpointNatMappings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VmEndpointNatMappings.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a VmEndpointNatMappings message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappings
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VmEndpointNatMappings.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.instanceName != null && message.hasOwnProperty("instanceName")) {
                                properties._instanceName = 1;
                                if (!$util.isString(message.instanceName))
                                    return "instanceName: string expected";
                            }
                            if (message.interfaceNatMappings != null && message.hasOwnProperty("interfaceNatMappings")) {
                                if (!Array.isArray(message.interfaceNatMappings))
                                    return "interfaceNatMappings: array expected";
                                for (var i = 0; i < message.interfaceNatMappings.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings.verify(message.interfaceNatMappings[i]);
                                    if (error)
                                        return "interfaceNatMappings." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a VmEndpointNatMappings message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappings
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.VmEndpointNatMappings} VmEndpointNatMappings
                         */
                        VmEndpointNatMappings.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.VmEndpointNatMappings)
                                return object;
                            var message = new $root.google.cloud.compute.v1.VmEndpointNatMappings();
                            if (object.instanceName != null)
                                message.instanceName = String(object.instanceName);
                            if (object.interfaceNatMappings) {
                                if (!Array.isArray(object.interfaceNatMappings))
                                    throw TypeError(".google.cloud.compute.v1.VmEndpointNatMappings.interfaceNatMappings: array expected");
                                message.interfaceNatMappings = [];
                                for (var i = 0; i < object.interfaceNatMappings.length; ++i) {
                                    if (typeof object.interfaceNatMappings[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.VmEndpointNatMappings.interfaceNatMappings: object expected");
                                    message.interfaceNatMappings[i] = $root.google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings.fromObject(object.interfaceNatMappings[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a VmEndpointNatMappings message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappings
                         * @static
                         * @param {google.cloud.compute.v1.VmEndpointNatMappings} message VmEndpointNatMappings
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VmEndpointNatMappings.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.interfaceNatMappings = [];
                            if (message.instanceName != null && message.hasOwnProperty("instanceName")) {
                                object.instanceName = message.instanceName;
                                if (options.oneofs)
                                    object._instanceName = "instanceName";
                            }
                            if (message.interfaceNatMappings && message.interfaceNatMappings.length) {
                                object.interfaceNatMappings = [];
                                for (var j = 0; j < message.interfaceNatMappings.length; ++j)
                                    object.interfaceNatMappings[j] = $root.google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings.toObject(message.interfaceNatMappings[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this VmEndpointNatMappings to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappings
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VmEndpointNatMappings.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for VmEndpointNatMappings
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappings
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        VmEndpointNatMappings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.VmEndpointNatMappings";
                        };
    
                        return VmEndpointNatMappings;
                    })();
    
                    v1.VmEndpointNatMappingsInterfaceNatMappings = (function() {
    
                        /**
                         * Properties of a VmEndpointNatMappingsInterfaceNatMappings.
                         * @memberof google.cloud.compute.v1
                         * @interface IVmEndpointNatMappingsInterfaceNatMappings
                         * @property {Array.<string>|null} [drainNatIpPortRanges] VmEndpointNatMappingsInterfaceNatMappings drainNatIpPortRanges
                         * @property {Array.<string>|null} [natIpPortRanges] VmEndpointNatMappingsInterfaceNatMappings natIpPortRanges
                         * @property {number|null} [numTotalDrainNatPorts] VmEndpointNatMappingsInterfaceNatMappings numTotalDrainNatPorts
                         * @property {number|null} [numTotalNatPorts] VmEndpointNatMappingsInterfaceNatMappings numTotalNatPorts
                         * @property {Array.<google.cloud.compute.v1.IVmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings>|null} [ruleMappings] VmEndpointNatMappingsInterfaceNatMappings ruleMappings
                         * @property {string|null} [sourceAliasIpRange] VmEndpointNatMappingsInterfaceNatMappings sourceAliasIpRange
                         * @property {string|null} [sourceVirtualIp] VmEndpointNatMappingsInterfaceNatMappings sourceVirtualIp
                         */
    
                        /**
                         * Constructs a new VmEndpointNatMappingsInterfaceNatMappings.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a VmEndpointNatMappingsInterfaceNatMappings.
                         * @implements IVmEndpointNatMappingsInterfaceNatMappings
                         * @constructor
                         * @param {google.cloud.compute.v1.IVmEndpointNatMappingsInterfaceNatMappings=} [properties] Properties to set
                         */
                        function VmEndpointNatMappingsInterfaceNatMappings(properties) {
                            this.drainNatIpPortRanges = [];
                            this.natIpPortRanges = [];
                            this.ruleMappings = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * VmEndpointNatMappingsInterfaceNatMappings drainNatIpPortRanges.
                         * @member {Array.<string>} drainNatIpPortRanges
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @instance
                         */
                        VmEndpointNatMappingsInterfaceNatMappings.prototype.drainNatIpPortRanges = $util.emptyArray;
    
                        /**
                         * VmEndpointNatMappingsInterfaceNatMappings natIpPortRanges.
                         * @member {Array.<string>} natIpPortRanges
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @instance
                         */
                        VmEndpointNatMappingsInterfaceNatMappings.prototype.natIpPortRanges = $util.emptyArray;
    
                        /**
                         * VmEndpointNatMappingsInterfaceNatMappings numTotalDrainNatPorts.
                         * @member {number|null|undefined} numTotalDrainNatPorts
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @instance
                         */
                        VmEndpointNatMappingsInterfaceNatMappings.prototype.numTotalDrainNatPorts = null;
    
                        /**
                         * VmEndpointNatMappingsInterfaceNatMappings numTotalNatPorts.
                         * @member {number|null|undefined} numTotalNatPorts
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @instance
                         */
                        VmEndpointNatMappingsInterfaceNatMappings.prototype.numTotalNatPorts = null;
    
                        /**
                         * VmEndpointNatMappingsInterfaceNatMappings ruleMappings.
                         * @member {Array.<google.cloud.compute.v1.IVmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings>} ruleMappings
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @instance
                         */
                        VmEndpointNatMappingsInterfaceNatMappings.prototype.ruleMappings = $util.emptyArray;
    
                        /**
                         * VmEndpointNatMappingsInterfaceNatMappings sourceAliasIpRange.
                         * @member {string|null|undefined} sourceAliasIpRange
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @instance
                         */
                        VmEndpointNatMappingsInterfaceNatMappings.prototype.sourceAliasIpRange = null;
    
                        /**
                         * VmEndpointNatMappingsInterfaceNatMappings sourceVirtualIp.
                         * @member {string|null|undefined} sourceVirtualIp
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @instance
                         */
                        VmEndpointNatMappingsInterfaceNatMappings.prototype.sourceVirtualIp = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * VmEndpointNatMappingsInterfaceNatMappings _numTotalDrainNatPorts.
                         * @member {"numTotalDrainNatPorts"|undefined} _numTotalDrainNatPorts
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @instance
                         */
                        Object.defineProperty(VmEndpointNatMappingsInterfaceNatMappings.prototype, "_numTotalDrainNatPorts", {
                            get: $util.oneOfGetter($oneOfFields = ["numTotalDrainNatPorts"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VmEndpointNatMappingsInterfaceNatMappings _numTotalNatPorts.
                         * @member {"numTotalNatPorts"|undefined} _numTotalNatPorts
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @instance
                         */
                        Object.defineProperty(VmEndpointNatMappingsInterfaceNatMappings.prototype, "_numTotalNatPorts", {
                            get: $util.oneOfGetter($oneOfFields = ["numTotalNatPorts"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VmEndpointNatMappingsInterfaceNatMappings _sourceAliasIpRange.
                         * @member {"sourceAliasIpRange"|undefined} _sourceAliasIpRange
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @instance
                         */
                        Object.defineProperty(VmEndpointNatMappingsInterfaceNatMappings.prototype, "_sourceAliasIpRange", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceAliasIpRange"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VmEndpointNatMappingsInterfaceNatMappings _sourceVirtualIp.
                         * @member {"sourceVirtualIp"|undefined} _sourceVirtualIp
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @instance
                         */
                        Object.defineProperty(VmEndpointNatMappingsInterfaceNatMappings.prototype, "_sourceVirtualIp", {
                            get: $util.oneOfGetter($oneOfFields = ["sourceVirtualIp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new VmEndpointNatMappingsInterfaceNatMappings instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @static
                         * @param {google.cloud.compute.v1.IVmEndpointNatMappingsInterfaceNatMappings=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings} VmEndpointNatMappingsInterfaceNatMappings instance
                         */
                        VmEndpointNatMappingsInterfaceNatMappings.create = function create(properties) {
                            return new VmEndpointNatMappingsInterfaceNatMappings(properties);
                        };
    
                        /**
                         * Encodes the specified VmEndpointNatMappingsInterfaceNatMappings message. Does not implicitly {@link google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @static
                         * @param {google.cloud.compute.v1.IVmEndpointNatMappingsInterfaceNatMappings} message VmEndpointNatMappingsInterfaceNatMappings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VmEndpointNatMappingsInterfaceNatMappings.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.sourceVirtualIp != null && Object.hasOwnProperty.call(message, "sourceVirtualIp"))
                                writer.uint32(/* id 149836159, wireType 2 =*/1198689274).string(message.sourceVirtualIp);
                            if (message.numTotalNatPorts != null && Object.hasOwnProperty.call(message, "numTotalNatPorts"))
                                writer.uint32(/* id 299904384, wireType 0 =*/2399235072).int32(message.numTotalNatPorts);
                            if (message.numTotalDrainNatPorts != null && Object.hasOwnProperty.call(message, "numTotalDrainNatPorts"))
                                writer.uint32(/* id 335532793, wireType 0 =*/2684262344).int32(message.numTotalDrainNatPorts);
                            if (message.drainNatIpPortRanges != null && message.drainNatIpPortRanges.length)
                                for (var i = 0; i < message.drainNatIpPortRanges.length; ++i)
                                    writer.uint32(/* id 395440577, wireType 2 =*/3163524618).string(message.drainNatIpPortRanges[i]);
                            if (message.sourceAliasIpRange != null && Object.hasOwnProperty.call(message, "sourceAliasIpRange"))
                                writer.uint32(/* id 440340952, wireType 2 =*/3522727618).string(message.sourceAliasIpRange);
                            if (message.ruleMappings != null && message.ruleMappings.length)
                                for (var i = 0; i < message.ruleMappings.length; ++i)
                                    $root.google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.encode(message.ruleMappings[i], writer.uint32(/* id 486192968, wireType 2 =*/3889543746).fork()).ldelim();
                            if (message.natIpPortRanges != null && message.natIpPortRanges.length)
                                for (var i = 0; i < message.natIpPortRanges.length; ++i)
                                    writer.uint32(/* id 531830810, wireType 2 =*/4254646482).string(message.natIpPortRanges[i]);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified VmEndpointNatMappingsInterfaceNatMappings message, length delimited. Does not implicitly {@link google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @static
                         * @param {google.cloud.compute.v1.IVmEndpointNatMappingsInterfaceNatMappings} message VmEndpointNatMappingsInterfaceNatMappings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VmEndpointNatMappingsInterfaceNatMappings.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a VmEndpointNatMappingsInterfaceNatMappings message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings} VmEndpointNatMappingsInterfaceNatMappings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VmEndpointNatMappingsInterfaceNatMappings.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 395440577: {
                                        if (!(message.drainNatIpPortRanges && message.drainNatIpPortRanges.length))
                                            message.drainNatIpPortRanges = [];
                                        message.drainNatIpPortRanges.push(reader.string());
                                        break;
                                    }
                                case 531830810: {
                                        if (!(message.natIpPortRanges && message.natIpPortRanges.length))
                                            message.natIpPortRanges = [];
                                        message.natIpPortRanges.push(reader.string());
                                        break;
                                    }
                                case 335532793: {
                                        message.numTotalDrainNatPorts = reader.int32();
                                        break;
                                    }
                                case 299904384: {
                                        message.numTotalNatPorts = reader.int32();
                                        break;
                                    }
                                case 486192968: {
                                        if (!(message.ruleMappings && message.ruleMappings.length))
                                            message.ruleMappings = [];
                                        message.ruleMappings.push($root.google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 440340952: {
                                        message.sourceAliasIpRange = reader.string();
                                        break;
                                    }
                                case 149836159: {
                                        message.sourceVirtualIp = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a VmEndpointNatMappingsInterfaceNatMappings message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings} VmEndpointNatMappingsInterfaceNatMappings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VmEndpointNatMappingsInterfaceNatMappings.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a VmEndpointNatMappingsInterfaceNatMappings message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VmEndpointNatMappingsInterfaceNatMappings.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.drainNatIpPortRanges != null && message.hasOwnProperty("drainNatIpPortRanges")) {
                                if (!Array.isArray(message.drainNatIpPortRanges))
                                    return "drainNatIpPortRanges: array expected";
                                for (var i = 0; i < message.drainNatIpPortRanges.length; ++i)
                                    if (!$util.isString(message.drainNatIpPortRanges[i]))
                                        return "drainNatIpPortRanges: string[] expected";
                            }
                            if (message.natIpPortRanges != null && message.hasOwnProperty("natIpPortRanges")) {
                                if (!Array.isArray(message.natIpPortRanges))
                                    return "natIpPortRanges: array expected";
                                for (var i = 0; i < message.natIpPortRanges.length; ++i)
                                    if (!$util.isString(message.natIpPortRanges[i]))
                                        return "natIpPortRanges: string[] expected";
                            }
                            if (message.numTotalDrainNatPorts != null && message.hasOwnProperty("numTotalDrainNatPorts")) {
                                properties._numTotalDrainNatPorts = 1;
                                if (!$util.isInteger(message.numTotalDrainNatPorts))
                                    return "numTotalDrainNatPorts: integer expected";
                            }
                            if (message.numTotalNatPorts != null && message.hasOwnProperty("numTotalNatPorts")) {
                                properties._numTotalNatPorts = 1;
                                if (!$util.isInteger(message.numTotalNatPorts))
                                    return "numTotalNatPorts: integer expected";
                            }
                            if (message.ruleMappings != null && message.hasOwnProperty("ruleMappings")) {
                                if (!Array.isArray(message.ruleMappings))
                                    return "ruleMappings: array expected";
                                for (var i = 0; i < message.ruleMappings.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.verify(message.ruleMappings[i]);
                                    if (error)
                                        return "ruleMappings." + error;
                                }
                            }
                            if (message.sourceAliasIpRange != null && message.hasOwnProperty("sourceAliasIpRange")) {
                                properties._sourceAliasIpRange = 1;
                                if (!$util.isString(message.sourceAliasIpRange))
                                    return "sourceAliasIpRange: string expected";
                            }
                            if (message.sourceVirtualIp != null && message.hasOwnProperty("sourceVirtualIp")) {
                                properties._sourceVirtualIp = 1;
                                if (!$util.isString(message.sourceVirtualIp))
                                    return "sourceVirtualIp: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a VmEndpointNatMappingsInterfaceNatMappings message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings} VmEndpointNatMappingsInterfaceNatMappings
                         */
                        VmEndpointNatMappingsInterfaceNatMappings.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings)
                                return object;
                            var message = new $root.google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings();
                            if (object.drainNatIpPortRanges) {
                                if (!Array.isArray(object.drainNatIpPortRanges))
                                    throw TypeError(".google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings.drainNatIpPortRanges: array expected");
                                message.drainNatIpPortRanges = [];
                                for (var i = 0; i < object.drainNatIpPortRanges.length; ++i)
                                    message.drainNatIpPortRanges[i] = String(object.drainNatIpPortRanges[i]);
                            }
                            if (object.natIpPortRanges) {
                                if (!Array.isArray(object.natIpPortRanges))
                                    throw TypeError(".google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings.natIpPortRanges: array expected");
                                message.natIpPortRanges = [];
                                for (var i = 0; i < object.natIpPortRanges.length; ++i)
                                    message.natIpPortRanges[i] = String(object.natIpPortRanges[i]);
                            }
                            if (object.numTotalDrainNatPorts != null)
                                message.numTotalDrainNatPorts = object.numTotalDrainNatPorts | 0;
                            if (object.numTotalNatPorts != null)
                                message.numTotalNatPorts = object.numTotalNatPorts | 0;
                            if (object.ruleMappings) {
                                if (!Array.isArray(object.ruleMappings))
                                    throw TypeError(".google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings.ruleMappings: array expected");
                                message.ruleMappings = [];
                                for (var i = 0; i < object.ruleMappings.length; ++i) {
                                    if (typeof object.ruleMappings[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings.ruleMappings: object expected");
                                    message.ruleMappings[i] = $root.google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.fromObject(object.ruleMappings[i]);
                                }
                            }
                            if (object.sourceAliasIpRange != null)
                                message.sourceAliasIpRange = String(object.sourceAliasIpRange);
                            if (object.sourceVirtualIp != null)
                                message.sourceVirtualIp = String(object.sourceVirtualIp);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a VmEndpointNatMappingsInterfaceNatMappings message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @static
                         * @param {google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings} message VmEndpointNatMappingsInterfaceNatMappings
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VmEndpointNatMappingsInterfaceNatMappings.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.drainNatIpPortRanges = [];
                                object.ruleMappings = [];
                                object.natIpPortRanges = [];
                            }
                            if (message.sourceVirtualIp != null && message.hasOwnProperty("sourceVirtualIp")) {
                                object.sourceVirtualIp = message.sourceVirtualIp;
                                if (options.oneofs)
                                    object._sourceVirtualIp = "sourceVirtualIp";
                            }
                            if (message.numTotalNatPorts != null && message.hasOwnProperty("numTotalNatPorts")) {
                                object.numTotalNatPorts = message.numTotalNatPorts;
                                if (options.oneofs)
                                    object._numTotalNatPorts = "numTotalNatPorts";
                            }
                            if (message.numTotalDrainNatPorts != null && message.hasOwnProperty("numTotalDrainNatPorts")) {
                                object.numTotalDrainNatPorts = message.numTotalDrainNatPorts;
                                if (options.oneofs)
                                    object._numTotalDrainNatPorts = "numTotalDrainNatPorts";
                            }
                            if (message.drainNatIpPortRanges && message.drainNatIpPortRanges.length) {
                                object.drainNatIpPortRanges = [];
                                for (var j = 0; j < message.drainNatIpPortRanges.length; ++j)
                                    object.drainNatIpPortRanges[j] = message.drainNatIpPortRanges[j];
                            }
                            if (message.sourceAliasIpRange != null && message.hasOwnProperty("sourceAliasIpRange")) {
                                object.sourceAliasIpRange = message.sourceAliasIpRange;
                                if (options.oneofs)
                                    object._sourceAliasIpRange = "sourceAliasIpRange";
                            }
                            if (message.ruleMappings && message.ruleMappings.length) {
                                object.ruleMappings = [];
                                for (var j = 0; j < message.ruleMappings.length; ++j)
                                    object.ruleMappings[j] = $root.google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.toObject(message.ruleMappings[j], options);
                            }
                            if (message.natIpPortRanges && message.natIpPortRanges.length) {
                                object.natIpPortRanges = [];
                                for (var j = 0; j < message.natIpPortRanges.length; ++j)
                                    object.natIpPortRanges[j] = message.natIpPortRanges[j];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this VmEndpointNatMappingsInterfaceNatMappings to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VmEndpointNatMappingsInterfaceNatMappings.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for VmEndpointNatMappingsInterfaceNatMappings
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        VmEndpointNatMappingsInterfaceNatMappings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappings";
                        };
    
                        return VmEndpointNatMappingsInterfaceNatMappings;
                    })();
    
                    v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings = (function() {
    
                        /**
                         * Properties of a VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.
                         * @memberof google.cloud.compute.v1
                         * @interface IVmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @property {Array.<string>|null} [drainNatIpPortRanges] VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings drainNatIpPortRanges
                         * @property {Array.<string>|null} [natIpPortRanges] VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings natIpPortRanges
                         * @property {number|null} [numTotalDrainNatPorts] VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings numTotalDrainNatPorts
                         * @property {number|null} [numTotalNatPorts] VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings numTotalNatPorts
                         * @property {number|null} [ruleNumber] VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings ruleNumber
                         */
    
                        /**
                         * Constructs a new VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.
                         * @implements IVmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @constructor
                         * @param {google.cloud.compute.v1.IVmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings=} [properties] Properties to set
                         */
                        function VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings(properties) {
                            this.drainNatIpPortRanges = [];
                            this.natIpPortRanges = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings drainNatIpPortRanges.
                         * @member {Array.<string>} drainNatIpPortRanges
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @instance
                         */
                        VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.prototype.drainNatIpPortRanges = $util.emptyArray;
    
                        /**
                         * VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings natIpPortRanges.
                         * @member {Array.<string>} natIpPortRanges
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @instance
                         */
                        VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.prototype.natIpPortRanges = $util.emptyArray;
    
                        /**
                         * VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings numTotalDrainNatPorts.
                         * @member {number|null|undefined} numTotalDrainNatPorts
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @instance
                         */
                        VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.prototype.numTotalDrainNatPorts = null;
    
                        /**
                         * VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings numTotalNatPorts.
                         * @member {number|null|undefined} numTotalNatPorts
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @instance
                         */
                        VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.prototype.numTotalNatPorts = null;
    
                        /**
                         * VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings ruleNumber.
                         * @member {number|null|undefined} ruleNumber
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @instance
                         */
                        VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.prototype.ruleNumber = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings _numTotalDrainNatPorts.
                         * @member {"numTotalDrainNatPorts"|undefined} _numTotalDrainNatPorts
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @instance
                         */
                        Object.defineProperty(VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.prototype, "_numTotalDrainNatPorts", {
                            get: $util.oneOfGetter($oneOfFields = ["numTotalDrainNatPorts"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings _numTotalNatPorts.
                         * @member {"numTotalNatPorts"|undefined} _numTotalNatPorts
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @instance
                         */
                        Object.defineProperty(VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.prototype, "_numTotalNatPorts", {
                            get: $util.oneOfGetter($oneOfFields = ["numTotalNatPorts"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings _ruleNumber.
                         * @member {"ruleNumber"|undefined} _ruleNumber
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @instance
                         */
                        Object.defineProperty(VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.prototype, "_ruleNumber", {
                            get: $util.oneOfGetter($oneOfFields = ["ruleNumber"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @static
                         * @param {google.cloud.compute.v1.IVmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings} VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings instance
                         */
                        VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.create = function create(properties) {
                            return new VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings(properties);
                        };
    
                        /**
                         * Encodes the specified VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings message. Does not implicitly {@link google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @static
                         * @param {google.cloud.compute.v1.IVmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings} message VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.numTotalNatPorts != null && Object.hasOwnProperty.call(message, "numTotalNatPorts"))
                                writer.uint32(/* id 299904384, wireType 0 =*/2399235072).int32(message.numTotalNatPorts);
                            if (message.numTotalDrainNatPorts != null && Object.hasOwnProperty.call(message, "numTotalDrainNatPorts"))
                                writer.uint32(/* id 335532793, wireType 0 =*/2684262344).int32(message.numTotalDrainNatPorts);
                            if (message.drainNatIpPortRanges != null && message.drainNatIpPortRanges.length)
                                for (var i = 0; i < message.drainNatIpPortRanges.length; ++i)
                                    writer.uint32(/* id 395440577, wireType 2 =*/3163524618).string(message.drainNatIpPortRanges[i]);
                            if (message.natIpPortRanges != null && message.natIpPortRanges.length)
                                for (var i = 0; i < message.natIpPortRanges.length; ++i)
                                    writer.uint32(/* id 531830810, wireType 2 =*/4254646482).string(message.natIpPortRanges[i]);
                            if (message.ruleNumber != null && Object.hasOwnProperty.call(message, "ruleNumber"))
                                writer.uint32(/* id 535211500, wireType 0 =*/4281692000).int32(message.ruleNumber);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings message, length delimited. Does not implicitly {@link google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @static
                         * @param {google.cloud.compute.v1.IVmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings} message VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings} VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 395440577: {
                                        if (!(message.drainNatIpPortRanges && message.drainNatIpPortRanges.length))
                                            message.drainNatIpPortRanges = [];
                                        message.drainNatIpPortRanges.push(reader.string());
                                        break;
                                    }
                                case 531830810: {
                                        if (!(message.natIpPortRanges && message.natIpPortRanges.length))
                                            message.natIpPortRanges = [];
                                        message.natIpPortRanges.push(reader.string());
                                        break;
                                    }
                                case 335532793: {
                                        message.numTotalDrainNatPorts = reader.int32();
                                        break;
                                    }
                                case 299904384: {
                                        message.numTotalNatPorts = reader.int32();
                                        break;
                                    }
                                case 535211500: {
                                        message.ruleNumber = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings} VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.drainNatIpPortRanges != null && message.hasOwnProperty("drainNatIpPortRanges")) {
                                if (!Array.isArray(message.drainNatIpPortRanges))
                                    return "drainNatIpPortRanges: array expected";
                                for (var i = 0; i < message.drainNatIpPortRanges.length; ++i)
                                    if (!$util.isString(message.drainNatIpPortRanges[i]))
                                        return "drainNatIpPortRanges: string[] expected";
                            }
                            if (message.natIpPortRanges != null && message.hasOwnProperty("natIpPortRanges")) {
                                if (!Array.isArray(message.natIpPortRanges))
                                    return "natIpPortRanges: array expected";
                                for (var i = 0; i < message.natIpPortRanges.length; ++i)
                                    if (!$util.isString(message.natIpPortRanges[i]))
                                        return "natIpPortRanges: string[] expected";
                            }
                            if (message.numTotalDrainNatPorts != null && message.hasOwnProperty("numTotalDrainNatPorts")) {
                                properties._numTotalDrainNatPorts = 1;
                                if (!$util.isInteger(message.numTotalDrainNatPorts))
                                    return "numTotalDrainNatPorts: integer expected";
                            }
                            if (message.numTotalNatPorts != null && message.hasOwnProperty("numTotalNatPorts")) {
                                properties._numTotalNatPorts = 1;
                                if (!$util.isInteger(message.numTotalNatPorts))
                                    return "numTotalNatPorts: integer expected";
                            }
                            if (message.ruleNumber != null && message.hasOwnProperty("ruleNumber")) {
                                properties._ruleNumber = 1;
                                if (!$util.isInteger(message.ruleNumber))
                                    return "ruleNumber: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings} VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         */
                        VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings)
                                return object;
                            var message = new $root.google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings();
                            if (object.drainNatIpPortRanges) {
                                if (!Array.isArray(object.drainNatIpPortRanges))
                                    throw TypeError(".google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.drainNatIpPortRanges: array expected");
                                message.drainNatIpPortRanges = [];
                                for (var i = 0; i < object.drainNatIpPortRanges.length; ++i)
                                    message.drainNatIpPortRanges[i] = String(object.drainNatIpPortRanges[i]);
                            }
                            if (object.natIpPortRanges) {
                                if (!Array.isArray(object.natIpPortRanges))
                                    throw TypeError(".google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.natIpPortRanges: array expected");
                                message.natIpPortRanges = [];
                                for (var i = 0; i < object.natIpPortRanges.length; ++i)
                                    message.natIpPortRanges[i] = String(object.natIpPortRanges[i]);
                            }
                            if (object.numTotalDrainNatPorts != null)
                                message.numTotalDrainNatPorts = object.numTotalDrainNatPorts | 0;
                            if (object.numTotalNatPorts != null)
                                message.numTotalNatPorts = object.numTotalNatPorts | 0;
                            if (object.ruleNumber != null)
                                message.ruleNumber = object.ruleNumber | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @static
                         * @param {google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings} message VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.drainNatIpPortRanges = [];
                                object.natIpPortRanges = [];
                            }
                            if (message.numTotalNatPorts != null && message.hasOwnProperty("numTotalNatPorts")) {
                                object.numTotalNatPorts = message.numTotalNatPorts;
                                if (options.oneofs)
                                    object._numTotalNatPorts = "numTotalNatPorts";
                            }
                            if (message.numTotalDrainNatPorts != null && message.hasOwnProperty("numTotalDrainNatPorts")) {
                                object.numTotalDrainNatPorts = message.numTotalDrainNatPorts;
                                if (options.oneofs)
                                    object._numTotalDrainNatPorts = "numTotalDrainNatPorts";
                            }
                            if (message.drainNatIpPortRanges && message.drainNatIpPortRanges.length) {
                                object.drainNatIpPortRanges = [];
                                for (var j = 0; j < message.drainNatIpPortRanges.length; ++j)
                                    object.drainNatIpPortRanges[j] = message.drainNatIpPortRanges[j];
                            }
                            if (message.natIpPortRanges && message.natIpPortRanges.length) {
                                object.natIpPortRanges = [];
                                for (var j = 0; j < message.natIpPortRanges.length; ++j)
                                    object.natIpPortRanges[j] = message.natIpPortRanges[j];
                            }
                            if (message.ruleNumber != null && message.hasOwnProperty("ruleNumber")) {
                                object.ruleNumber = message.ruleNumber;
                                if (options.oneofs)
                                    object._ruleNumber = "ruleNumber";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings";
                        };
    
                        return VmEndpointNatMappingsInterfaceNatMappingsNatRuleMappings;
                    })();
    
                    v1.VmEndpointNatMappingsList = (function() {
    
                        /**
                         * Properties of a VmEndpointNatMappingsList.
                         * @memberof google.cloud.compute.v1
                         * @interface IVmEndpointNatMappingsList
                         * @property {string|null} [id] VmEndpointNatMappingsList id
                         * @property {string|null} [kind] VmEndpointNatMappingsList kind
                         * @property {string|null} [nextPageToken] VmEndpointNatMappingsList nextPageToken
                         * @property {Array.<google.cloud.compute.v1.IVmEndpointNatMappings>|null} [result] VmEndpointNatMappingsList result
                         * @property {string|null} [selfLink] VmEndpointNatMappingsList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] VmEndpointNatMappingsList warning
                         */
    
                        /**
                         * Constructs a new VmEndpointNatMappingsList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a VmEndpointNatMappingsList.
                         * @implements IVmEndpointNatMappingsList
                         * @constructor
                         * @param {google.cloud.compute.v1.IVmEndpointNatMappingsList=} [properties] Properties to set
                         */
                        function VmEndpointNatMappingsList(properties) {
                            this.result = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * VmEndpointNatMappingsList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @instance
                         */
                        VmEndpointNatMappingsList.prototype.id = null;
    
                        /**
                         * VmEndpointNatMappingsList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @instance
                         */
                        VmEndpointNatMappingsList.prototype.kind = null;
    
                        /**
                         * VmEndpointNatMappingsList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @instance
                         */
                        VmEndpointNatMappingsList.prototype.nextPageToken = null;
    
                        /**
                         * VmEndpointNatMappingsList result.
                         * @member {Array.<google.cloud.compute.v1.IVmEndpointNatMappings>} result
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @instance
                         */
                        VmEndpointNatMappingsList.prototype.result = $util.emptyArray;
    
                        /**
                         * VmEndpointNatMappingsList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @instance
                         */
                        VmEndpointNatMappingsList.prototype.selfLink = null;
    
                        /**
                         * VmEndpointNatMappingsList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @instance
                         */
                        VmEndpointNatMappingsList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * VmEndpointNatMappingsList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @instance
                         */
                        Object.defineProperty(VmEndpointNatMappingsList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VmEndpointNatMappingsList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @instance
                         */
                        Object.defineProperty(VmEndpointNatMappingsList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VmEndpointNatMappingsList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @instance
                         */
                        Object.defineProperty(VmEndpointNatMappingsList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VmEndpointNatMappingsList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @instance
                         */
                        Object.defineProperty(VmEndpointNatMappingsList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VmEndpointNatMappingsList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @instance
                         */
                        Object.defineProperty(VmEndpointNatMappingsList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new VmEndpointNatMappingsList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @static
                         * @param {google.cloud.compute.v1.IVmEndpointNatMappingsList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.VmEndpointNatMappingsList} VmEndpointNatMappingsList instance
                         */
                        VmEndpointNatMappingsList.create = function create(properties) {
                            return new VmEndpointNatMappingsList(properties);
                        };
    
                        /**
                         * Encodes the specified VmEndpointNatMappingsList message. Does not implicitly {@link google.cloud.compute.v1.VmEndpointNatMappingsList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @static
                         * @param {google.cloud.compute.v1.IVmEndpointNatMappingsList} message VmEndpointNatMappingsList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VmEndpointNatMappingsList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.result != null && message.result.length)
                                for (var i = 0; i < message.result.length; ++i)
                                    $root.google.cloud.compute.v1.VmEndpointNatMappings.encode(message.result[i], writer.uint32(/* id 139315229, wireType 2 =*/1114521834).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified VmEndpointNatMappingsList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.VmEndpointNatMappingsList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @static
                         * @param {google.cloud.compute.v1.IVmEndpointNatMappingsList} message VmEndpointNatMappingsList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VmEndpointNatMappingsList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a VmEndpointNatMappingsList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.VmEndpointNatMappingsList} VmEndpointNatMappingsList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VmEndpointNatMappingsList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.VmEndpointNatMappingsList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 139315229: {
                                        if (!(message.result && message.result.length))
                                            message.result = [];
                                        message.result.push($root.google.cloud.compute.v1.VmEndpointNatMappings.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a VmEndpointNatMappingsList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.VmEndpointNatMappingsList} VmEndpointNatMappingsList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VmEndpointNatMappingsList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a VmEndpointNatMappingsList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VmEndpointNatMappingsList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.result != null && message.hasOwnProperty("result")) {
                                if (!Array.isArray(message.result))
                                    return "result: array expected";
                                for (var i = 0; i < message.result.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.VmEndpointNatMappings.verify(message.result[i]);
                                    if (error)
                                        return "result." + error;
                                }
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a VmEndpointNatMappingsList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.VmEndpointNatMappingsList} VmEndpointNatMappingsList
                         */
                        VmEndpointNatMappingsList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.VmEndpointNatMappingsList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.VmEndpointNatMappingsList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.result) {
                                if (!Array.isArray(object.result))
                                    throw TypeError(".google.cloud.compute.v1.VmEndpointNatMappingsList.result: array expected");
                                message.result = [];
                                for (var i = 0; i < object.result.length; ++i) {
                                    if (typeof object.result[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.VmEndpointNatMappingsList.result: object expected");
                                    message.result[i] = $root.google.cloud.compute.v1.VmEndpointNatMappings.fromObject(object.result[i]);
                                }
                            }
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.VmEndpointNatMappingsList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a VmEndpointNatMappingsList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @static
                         * @param {google.cloud.compute.v1.VmEndpointNatMappingsList} message VmEndpointNatMappingsList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VmEndpointNatMappingsList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.result = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.result && message.result.length) {
                                object.result = [];
                                for (var j = 0; j < message.result.length; ++j)
                                    object.result[j] = $root.google.cloud.compute.v1.VmEndpointNatMappings.toObject(message.result[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this VmEndpointNatMappingsList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VmEndpointNatMappingsList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for VmEndpointNatMappingsList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.VmEndpointNatMappingsList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        VmEndpointNatMappingsList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.VmEndpointNatMappingsList";
                        };
    
                        return VmEndpointNatMappingsList;
                    })();
    
                    v1.VpnGateway = (function() {
    
                        /**
                         * Properties of a VpnGateway.
                         * @memberof google.cloud.compute.v1
                         * @interface IVpnGateway
                         * @property {string|null} [creationTimestamp] VpnGateway creationTimestamp
                         * @property {string|null} [description] VpnGateway description
                         * @property {number|Long|null} [id] VpnGateway id
                         * @property {string|null} [kind] VpnGateway kind
                         * @property {string|null} [labelFingerprint] VpnGateway labelFingerprint
                         * @property {Object.<string,string>|null} [labels] VpnGateway labels
                         * @property {string|null} [name] VpnGateway name
                         * @property {string|null} [network] VpnGateway network
                         * @property {string|null} [region] VpnGateway region
                         * @property {string|null} [selfLink] VpnGateway selfLink
                         * @property {string|null} [stackType] VpnGateway stackType
                         * @property {Array.<google.cloud.compute.v1.IVpnGatewayVpnGatewayInterface>|null} [vpnInterfaces] VpnGateway vpnInterfaces
                         */
    
                        /**
                         * Constructs a new VpnGateway.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a VpnGateway.
                         * @implements IVpnGateway
                         * @constructor
                         * @param {google.cloud.compute.v1.IVpnGateway=} [properties] Properties to set
                         */
                        function VpnGateway(properties) {
                            this.labels = {};
                            this.vpnInterfaces = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * VpnGateway creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        VpnGateway.prototype.creationTimestamp = null;
    
                        /**
                         * VpnGateway description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        VpnGateway.prototype.description = null;
    
                        /**
                         * VpnGateway id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        VpnGateway.prototype.id = null;
    
                        /**
                         * VpnGateway kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        VpnGateway.prototype.kind = null;
    
                        /**
                         * VpnGateway labelFingerprint.
                         * @member {string|null|undefined} labelFingerprint
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        VpnGateway.prototype.labelFingerprint = null;
    
                        /**
                         * VpnGateway labels.
                         * @member {Object.<string,string>} labels
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        VpnGateway.prototype.labels = $util.emptyObject;
    
                        /**
                         * VpnGateway name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        VpnGateway.prototype.name = null;
    
                        /**
                         * VpnGateway network.
                         * @member {string|null|undefined} network
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        VpnGateway.prototype.network = null;
    
                        /**
                         * VpnGateway region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        VpnGateway.prototype.region = null;
    
                        /**
                         * VpnGateway selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        VpnGateway.prototype.selfLink = null;
    
                        /**
                         * VpnGateway stackType.
                         * @member {string|null|undefined} stackType
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        VpnGateway.prototype.stackType = null;
    
                        /**
                         * VpnGateway vpnInterfaces.
                         * @member {Array.<google.cloud.compute.v1.IVpnGatewayVpnGatewayInterface>} vpnInterfaces
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        VpnGateway.prototype.vpnInterfaces = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * VpnGateway _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        Object.defineProperty(VpnGateway.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGateway _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        Object.defineProperty(VpnGateway.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGateway _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        Object.defineProperty(VpnGateway.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGateway _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        Object.defineProperty(VpnGateway.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGateway _labelFingerprint.
                         * @member {"labelFingerprint"|undefined} _labelFingerprint
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        Object.defineProperty(VpnGateway.prototype, "_labelFingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["labelFingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGateway _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        Object.defineProperty(VpnGateway.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGateway _network.
                         * @member {"network"|undefined} _network
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        Object.defineProperty(VpnGateway.prototype, "_network", {
                            get: $util.oneOfGetter($oneOfFields = ["network"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGateway _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        Object.defineProperty(VpnGateway.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGateway _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        Object.defineProperty(VpnGateway.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGateway _stackType.
                         * @member {"stackType"|undefined} _stackType
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         */
                        Object.defineProperty(VpnGateway.prototype, "_stackType", {
                            get: $util.oneOfGetter($oneOfFields = ["stackType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new VpnGateway instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGateway=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.VpnGateway} VpnGateway instance
                         */
                        VpnGateway.create = function create(properties) {
                            return new VpnGateway(properties);
                        };
    
                        /**
                         * Encodes the specified VpnGateway message. Does not implicitly {@link google.cloud.compute.v1.VpnGateway.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGateway} message VpnGateway message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnGateway.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.vpnInterfaces != null && message.vpnInterfaces.length)
                                for (var i = 0; i < message.vpnInterfaces.length; ++i)
                                    $root.google.cloud.compute.v1.VpnGatewayVpnGatewayInterface.encode(message.vpnInterfaces[i], writer.uint32(/* id 91842181, wireType 2 =*/734737450).fork()).ldelim();
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.labelFingerprint != null && Object.hasOwnProperty.call(message, "labelFingerprint"))
                                writer.uint32(/* id 178124825, wireType 2 =*/1424998602).string(message.labelFingerprint);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.stackType != null && Object.hasOwnProperty.call(message, "stackType"))
                                writer.uint32(/* id 425908881, wireType 2 =*/3407271050).string(message.stackType);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.labels != null && Object.hasOwnProperty.call(message, "labels"))
                                for (var keys = Object.keys(message.labels), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 500195327, wireType 2 =*/4001562618).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.labels[keys[i]]).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified VpnGateway message, length delimited. Does not implicitly {@link google.cloud.compute.v1.VpnGateway.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGateway} message VpnGateway message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnGateway.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a VpnGateway message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.VpnGateway} VpnGateway
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnGateway.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.VpnGateway(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 178124825: {
                                        message.labelFingerprint = reader.string();
                                        break;
                                    }
                                case 500195327: {
                                        if (message.labels === $util.emptyObject)
                                            message.labels = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.labels[key] = value;
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 425908881: {
                                        message.stackType = reader.string();
                                        break;
                                    }
                                case 91842181: {
                                        if (!(message.vpnInterfaces && message.vpnInterfaces.length))
                                            message.vpnInterfaces = [];
                                        message.vpnInterfaces.push($root.google.cloud.compute.v1.VpnGatewayVpnGatewayInterface.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a VpnGateway message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.VpnGateway} VpnGateway
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnGateway.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a VpnGateway message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VpnGateway.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                properties._labelFingerprint = 1;
                                if (!$util.isString(message.labelFingerprint))
                                    return "labelFingerprint: string expected";
                            }
                            if (message.labels != null && message.hasOwnProperty("labels")) {
                                if (!$util.isObject(message.labels))
                                    return "labels: object expected";
                                var key = Object.keys(message.labels);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.labels[key[i]]))
                                        return "labels: string{k:string} expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                properties._network = 1;
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.stackType != null && message.hasOwnProperty("stackType")) {
                                properties._stackType = 1;
                                if (!$util.isString(message.stackType))
                                    return "stackType: string expected";
                            }
                            if (message.vpnInterfaces != null && message.hasOwnProperty("vpnInterfaces")) {
                                if (!Array.isArray(message.vpnInterfaces))
                                    return "vpnInterfaces: array expected";
                                for (var i = 0; i < message.vpnInterfaces.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.VpnGatewayVpnGatewayInterface.verify(message.vpnInterfaces[i]);
                                    if (error)
                                        return "vpnInterfaces." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a VpnGateway message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.VpnGateway} VpnGateway
                         */
                        VpnGateway.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.VpnGateway)
                                return object;
                            var message = new $root.google.cloud.compute.v1.VpnGateway();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.labelFingerprint != null)
                                message.labelFingerprint = String(object.labelFingerprint);
                            if (object.labels) {
                                if (typeof object.labels !== "object")
                                    throw TypeError(".google.cloud.compute.v1.VpnGateway.labels: object expected");
                                message.labels = {};
                                for (var keys = Object.keys(object.labels), i = 0; i < keys.length; ++i)
                                    message.labels[keys[i]] = String(object.labels[keys[i]]);
                            }
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.stackType != null)
                                message.stackType = String(object.stackType);
                            if (object.vpnInterfaces) {
                                if (!Array.isArray(object.vpnInterfaces))
                                    throw TypeError(".google.cloud.compute.v1.VpnGateway.vpnInterfaces: array expected");
                                message.vpnInterfaces = [];
                                for (var i = 0; i < object.vpnInterfaces.length; ++i) {
                                    if (typeof object.vpnInterfaces[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.VpnGateway.vpnInterfaces: object expected");
                                    message.vpnInterfaces[i] = $root.google.cloud.compute.v1.VpnGatewayVpnGatewayInterface.fromObject(object.vpnInterfaces[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a VpnGateway message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @static
                         * @param {google.cloud.compute.v1.VpnGateway} message VpnGateway
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VpnGateway.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.vpnInterfaces = [];
                            if (options.objects || options.defaults)
                                object.labels = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.vpnInterfaces && message.vpnInterfaces.length) {
                                object.vpnInterfaces = [];
                                for (var j = 0; j < message.vpnInterfaces.length; ++j)
                                    object.vpnInterfaces[j] = $root.google.cloud.compute.v1.VpnGatewayVpnGatewayInterface.toObject(message.vpnInterfaces[j], options);
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                object.labelFingerprint = message.labelFingerprint;
                                if (options.oneofs)
                                    object._labelFingerprint = "labelFingerprint";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                object.network = message.network;
                                if (options.oneofs)
                                    object._network = "network";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.stackType != null && message.hasOwnProperty("stackType")) {
                                object.stackType = message.stackType;
                                if (options.oneofs)
                                    object._stackType = "stackType";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            var keys2;
                            if (message.labels && (keys2 = Object.keys(message.labels)).length) {
                                object.labels = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.labels[keys2[j]] = message.labels[keys2[j]];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this VpnGateway to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VpnGateway.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for VpnGateway
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.VpnGateway
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        VpnGateway.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.VpnGateway";
                        };
    
                        /**
                         * StackType enum.
                         * @name google.cloud.compute.v1.VpnGateway.StackType
                         * @enum {number}
                         * @property {number} UNDEFINED_STACK_TYPE=0 UNDEFINED_STACK_TYPE value
                         * @property {number} IPV4_IPV6=22197249 IPV4_IPV6 value
                         * @property {number} IPV4_ONLY=22373798 IPV4_ONLY value
                         */
                        VpnGateway.StackType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STACK_TYPE"] = 0;
                            values[valuesById[22197249] = "IPV4_IPV6"] = 22197249;
                            values[valuesById[22373798] = "IPV4_ONLY"] = 22373798;
                            return values;
                        })();
    
                        return VpnGateway;
                    })();
    
                    v1.VpnGatewayAggregatedList = (function() {
    
                        /**
                         * Properties of a VpnGatewayAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IVpnGatewayAggregatedList
                         * @property {string|null} [id] VpnGatewayAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IVpnGatewaysScopedList>|null} [items] VpnGatewayAggregatedList items
                         * @property {string|null} [kind] VpnGatewayAggregatedList kind
                         * @property {string|null} [nextPageToken] VpnGatewayAggregatedList nextPageToken
                         * @property {string|null} [selfLink] VpnGatewayAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] VpnGatewayAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] VpnGatewayAggregatedList warning
                         */
    
                        /**
                         * Constructs a new VpnGatewayAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a VpnGatewayAggregatedList.
                         * @implements IVpnGatewayAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IVpnGatewayAggregatedList=} [properties] Properties to set
                         */
                        function VpnGatewayAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * VpnGatewayAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @instance
                         */
                        VpnGatewayAggregatedList.prototype.id = null;
    
                        /**
                         * VpnGatewayAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IVpnGatewaysScopedList>} items
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @instance
                         */
                        VpnGatewayAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * VpnGatewayAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @instance
                         */
                        VpnGatewayAggregatedList.prototype.kind = null;
    
                        /**
                         * VpnGatewayAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @instance
                         */
                        VpnGatewayAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * VpnGatewayAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @instance
                         */
                        VpnGatewayAggregatedList.prototype.selfLink = null;
    
                        /**
                         * VpnGatewayAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @instance
                         */
                        VpnGatewayAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * VpnGatewayAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @instance
                         */
                        VpnGatewayAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * VpnGatewayAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGatewayAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGatewayAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGatewayAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGatewayAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new VpnGatewayAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.VpnGatewayAggregatedList} VpnGatewayAggregatedList instance
                         */
                        VpnGatewayAggregatedList.create = function create(properties) {
                            return new VpnGatewayAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified VpnGatewayAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.VpnGatewayAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayAggregatedList} message VpnGatewayAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnGatewayAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.VpnGatewaysScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified VpnGatewayAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.VpnGatewayAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayAggregatedList} message VpnGatewayAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnGatewayAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a VpnGatewayAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.VpnGatewayAggregatedList} VpnGatewayAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnGatewayAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.VpnGatewayAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.VpnGatewaysScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a VpnGatewayAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.VpnGatewayAggregatedList} VpnGatewayAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnGatewayAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a VpnGatewayAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VpnGatewayAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.VpnGatewaysScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a VpnGatewayAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.VpnGatewayAggregatedList} VpnGatewayAggregatedList
                         */
                        VpnGatewayAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.VpnGatewayAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.VpnGatewayAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.VpnGatewayAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.VpnGatewayAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.VpnGatewaysScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.VpnGatewayAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.VpnGatewayAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a VpnGatewayAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.VpnGatewayAggregatedList} message VpnGatewayAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VpnGatewayAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.VpnGatewaysScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this VpnGatewayAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VpnGatewayAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for VpnGatewayAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.VpnGatewayAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        VpnGatewayAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.VpnGatewayAggregatedList";
                        };
    
                        return VpnGatewayAggregatedList;
                    })();
    
                    v1.VpnGatewayList = (function() {
    
                        /**
                         * Properties of a VpnGatewayList.
                         * @memberof google.cloud.compute.v1
                         * @interface IVpnGatewayList
                         * @property {string|null} [id] VpnGatewayList id
                         * @property {Array.<google.cloud.compute.v1.IVpnGateway>|null} [items] VpnGatewayList items
                         * @property {string|null} [kind] VpnGatewayList kind
                         * @property {string|null} [nextPageToken] VpnGatewayList nextPageToken
                         * @property {string|null} [selfLink] VpnGatewayList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] VpnGatewayList warning
                         */
    
                        /**
                         * Constructs a new VpnGatewayList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a VpnGatewayList.
                         * @implements IVpnGatewayList
                         * @constructor
                         * @param {google.cloud.compute.v1.IVpnGatewayList=} [properties] Properties to set
                         */
                        function VpnGatewayList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * VpnGatewayList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @instance
                         */
                        VpnGatewayList.prototype.id = null;
    
                        /**
                         * VpnGatewayList items.
                         * @member {Array.<google.cloud.compute.v1.IVpnGateway>} items
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @instance
                         */
                        VpnGatewayList.prototype.items = $util.emptyArray;
    
                        /**
                         * VpnGatewayList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @instance
                         */
                        VpnGatewayList.prototype.kind = null;
    
                        /**
                         * VpnGatewayList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @instance
                         */
                        VpnGatewayList.prototype.nextPageToken = null;
    
                        /**
                         * VpnGatewayList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @instance
                         */
                        VpnGatewayList.prototype.selfLink = null;
    
                        /**
                         * VpnGatewayList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @instance
                         */
                        VpnGatewayList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * VpnGatewayList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGatewayList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGatewayList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGatewayList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGatewayList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new VpnGatewayList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.VpnGatewayList} VpnGatewayList instance
                         */
                        VpnGatewayList.create = function create(properties) {
                            return new VpnGatewayList(properties);
                        };
    
                        /**
                         * Encodes the specified VpnGatewayList message. Does not implicitly {@link google.cloud.compute.v1.VpnGatewayList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayList} message VpnGatewayList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnGatewayList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.VpnGateway.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified VpnGatewayList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.VpnGatewayList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayList} message VpnGatewayList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnGatewayList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a VpnGatewayList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.VpnGatewayList} VpnGatewayList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnGatewayList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.VpnGatewayList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.VpnGateway.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a VpnGatewayList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.VpnGatewayList} VpnGatewayList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnGatewayList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a VpnGatewayList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VpnGatewayList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.VpnGateway.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a VpnGatewayList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.VpnGatewayList} VpnGatewayList
                         */
                        VpnGatewayList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.VpnGatewayList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.VpnGatewayList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.VpnGatewayList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.VpnGatewayList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.VpnGateway.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.VpnGatewayList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a VpnGatewayList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @static
                         * @param {google.cloud.compute.v1.VpnGatewayList} message VpnGatewayList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VpnGatewayList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.VpnGateway.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this VpnGatewayList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VpnGatewayList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for VpnGatewayList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.VpnGatewayList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        VpnGatewayList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.VpnGatewayList";
                        };
    
                        return VpnGatewayList;
                    })();
    
                    v1.VpnGatewayStatus = (function() {
    
                        /**
                         * Properties of a VpnGatewayStatus.
                         * @memberof google.cloud.compute.v1
                         * @interface IVpnGatewayStatus
                         * @property {Array.<google.cloud.compute.v1.IVpnGatewayStatusVpnConnection>|null} [vpnConnections] VpnGatewayStatus vpnConnections
                         */
    
                        /**
                         * Constructs a new VpnGatewayStatus.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a VpnGatewayStatus.
                         * @implements IVpnGatewayStatus
                         * @constructor
                         * @param {google.cloud.compute.v1.IVpnGatewayStatus=} [properties] Properties to set
                         */
                        function VpnGatewayStatus(properties) {
                            this.vpnConnections = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * VpnGatewayStatus vpnConnections.
                         * @member {Array.<google.cloud.compute.v1.IVpnGatewayStatusVpnConnection>} vpnConnections
                         * @memberof google.cloud.compute.v1.VpnGatewayStatus
                         * @instance
                         */
                        VpnGatewayStatus.prototype.vpnConnections = $util.emptyArray;
    
                        /**
                         * Creates a new VpnGatewayStatus instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.VpnGatewayStatus
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayStatus=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.VpnGatewayStatus} VpnGatewayStatus instance
                         */
                        VpnGatewayStatus.create = function create(properties) {
                            return new VpnGatewayStatus(properties);
                        };
    
                        /**
                         * Encodes the specified VpnGatewayStatus message. Does not implicitly {@link google.cloud.compute.v1.VpnGatewayStatus.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.VpnGatewayStatus
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayStatus} message VpnGatewayStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnGatewayStatus.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.vpnConnections != null && message.vpnConnections.length)
                                for (var i = 0; i < message.vpnConnections.length; ++i)
                                    $root.google.cloud.compute.v1.VpnGatewayStatusVpnConnection.encode(message.vpnConnections[i], writer.uint32(/* id 439334538, wireType 2 =*/3514676306).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified VpnGatewayStatus message, length delimited. Does not implicitly {@link google.cloud.compute.v1.VpnGatewayStatus.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.VpnGatewayStatus
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayStatus} message VpnGatewayStatus message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnGatewayStatus.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a VpnGatewayStatus message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.VpnGatewayStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.VpnGatewayStatus} VpnGatewayStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnGatewayStatus.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.VpnGatewayStatus();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 439334538: {
                                        if (!(message.vpnConnections && message.vpnConnections.length))
                                            message.vpnConnections = [];
                                        message.vpnConnections.push($root.google.cloud.compute.v1.VpnGatewayStatusVpnConnection.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a VpnGatewayStatus message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.VpnGatewayStatus
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.VpnGatewayStatus} VpnGatewayStatus
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnGatewayStatus.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a VpnGatewayStatus message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.VpnGatewayStatus
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VpnGatewayStatus.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.vpnConnections != null && message.hasOwnProperty("vpnConnections")) {
                                if (!Array.isArray(message.vpnConnections))
                                    return "vpnConnections: array expected";
                                for (var i = 0; i < message.vpnConnections.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.VpnGatewayStatusVpnConnection.verify(message.vpnConnections[i]);
                                    if (error)
                                        return "vpnConnections." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a VpnGatewayStatus message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.VpnGatewayStatus
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.VpnGatewayStatus} VpnGatewayStatus
                         */
                        VpnGatewayStatus.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.VpnGatewayStatus)
                                return object;
                            var message = new $root.google.cloud.compute.v1.VpnGatewayStatus();
                            if (object.vpnConnections) {
                                if (!Array.isArray(object.vpnConnections))
                                    throw TypeError(".google.cloud.compute.v1.VpnGatewayStatus.vpnConnections: array expected");
                                message.vpnConnections = [];
                                for (var i = 0; i < object.vpnConnections.length; ++i) {
                                    if (typeof object.vpnConnections[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.VpnGatewayStatus.vpnConnections: object expected");
                                    message.vpnConnections[i] = $root.google.cloud.compute.v1.VpnGatewayStatusVpnConnection.fromObject(object.vpnConnections[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a VpnGatewayStatus message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.VpnGatewayStatus
                         * @static
                         * @param {google.cloud.compute.v1.VpnGatewayStatus} message VpnGatewayStatus
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VpnGatewayStatus.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.vpnConnections = [];
                            if (message.vpnConnections && message.vpnConnections.length) {
                                object.vpnConnections = [];
                                for (var j = 0; j < message.vpnConnections.length; ++j)
                                    object.vpnConnections[j] = $root.google.cloud.compute.v1.VpnGatewayStatusVpnConnection.toObject(message.vpnConnections[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this VpnGatewayStatus to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.VpnGatewayStatus
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VpnGatewayStatus.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for VpnGatewayStatus
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.VpnGatewayStatus
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        VpnGatewayStatus.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.VpnGatewayStatus";
                        };
    
                        return VpnGatewayStatus;
                    })();
    
                    v1.VpnGatewayStatusHighAvailabilityRequirementState = (function() {
    
                        /**
                         * Properties of a VpnGatewayStatusHighAvailabilityRequirementState.
                         * @memberof google.cloud.compute.v1
                         * @interface IVpnGatewayStatusHighAvailabilityRequirementState
                         * @property {string|null} [state] VpnGatewayStatusHighAvailabilityRequirementState state
                         * @property {string|null} [unsatisfiedReason] VpnGatewayStatusHighAvailabilityRequirementState unsatisfiedReason
                         */
    
                        /**
                         * Constructs a new VpnGatewayStatusHighAvailabilityRequirementState.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a VpnGatewayStatusHighAvailabilityRequirementState.
                         * @implements IVpnGatewayStatusHighAvailabilityRequirementState
                         * @constructor
                         * @param {google.cloud.compute.v1.IVpnGatewayStatusHighAvailabilityRequirementState=} [properties] Properties to set
                         */
                        function VpnGatewayStatusHighAvailabilityRequirementState(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * VpnGatewayStatusHighAvailabilityRequirementState state.
                         * @member {string|null|undefined} state
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState
                         * @instance
                         */
                        VpnGatewayStatusHighAvailabilityRequirementState.prototype.state = null;
    
                        /**
                         * VpnGatewayStatusHighAvailabilityRequirementState unsatisfiedReason.
                         * @member {string|null|undefined} unsatisfiedReason
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState
                         * @instance
                         */
                        VpnGatewayStatusHighAvailabilityRequirementState.prototype.unsatisfiedReason = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * VpnGatewayStatusHighAvailabilityRequirementState _state.
                         * @member {"state"|undefined} _state
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayStatusHighAvailabilityRequirementState.prototype, "_state", {
                            get: $util.oneOfGetter($oneOfFields = ["state"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGatewayStatusHighAvailabilityRequirementState _unsatisfiedReason.
                         * @member {"unsatisfiedReason"|undefined} _unsatisfiedReason
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayStatusHighAvailabilityRequirementState.prototype, "_unsatisfiedReason", {
                            get: $util.oneOfGetter($oneOfFields = ["unsatisfiedReason"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new VpnGatewayStatusHighAvailabilityRequirementState instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayStatusHighAvailabilityRequirementState=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState} VpnGatewayStatusHighAvailabilityRequirementState instance
                         */
                        VpnGatewayStatusHighAvailabilityRequirementState.create = function create(properties) {
                            return new VpnGatewayStatusHighAvailabilityRequirementState(properties);
                        };
    
                        /**
                         * Encodes the specified VpnGatewayStatusHighAvailabilityRequirementState message. Does not implicitly {@link google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayStatusHighAvailabilityRequirementState} message VpnGatewayStatusHighAvailabilityRequirementState message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnGatewayStatusHighAvailabilityRequirementState.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.unsatisfiedReason != null && Object.hasOwnProperty.call(message, "unsatisfiedReason"))
                                writer.uint32(/* id 55016330, wireType 2 =*/440130642).string(message.unsatisfiedReason);
                            if (message.state != null && Object.hasOwnProperty.call(message, "state"))
                                writer.uint32(/* id 109757585, wireType 2 =*/878060682).string(message.state);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified VpnGatewayStatusHighAvailabilityRequirementState message, length delimited. Does not implicitly {@link google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayStatusHighAvailabilityRequirementState} message VpnGatewayStatusHighAvailabilityRequirementState message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnGatewayStatusHighAvailabilityRequirementState.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a VpnGatewayStatusHighAvailabilityRequirementState message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState} VpnGatewayStatusHighAvailabilityRequirementState
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnGatewayStatusHighAvailabilityRequirementState.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 109757585: {
                                        message.state = reader.string();
                                        break;
                                    }
                                case 55016330: {
                                        message.unsatisfiedReason = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a VpnGatewayStatusHighAvailabilityRequirementState message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState} VpnGatewayStatusHighAvailabilityRequirementState
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnGatewayStatusHighAvailabilityRequirementState.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a VpnGatewayStatusHighAvailabilityRequirementState message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VpnGatewayStatusHighAvailabilityRequirementState.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.state != null && message.hasOwnProperty("state")) {
                                properties._state = 1;
                                if (!$util.isString(message.state))
                                    return "state: string expected";
                            }
                            if (message.unsatisfiedReason != null && message.hasOwnProperty("unsatisfiedReason")) {
                                properties._unsatisfiedReason = 1;
                                if (!$util.isString(message.unsatisfiedReason))
                                    return "unsatisfiedReason: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a VpnGatewayStatusHighAvailabilityRequirementState message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState} VpnGatewayStatusHighAvailabilityRequirementState
                         */
                        VpnGatewayStatusHighAvailabilityRequirementState.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState)
                                return object;
                            var message = new $root.google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState();
                            if (object.state != null)
                                message.state = String(object.state);
                            if (object.unsatisfiedReason != null)
                                message.unsatisfiedReason = String(object.unsatisfiedReason);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a VpnGatewayStatusHighAvailabilityRequirementState message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState
                         * @static
                         * @param {google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState} message VpnGatewayStatusHighAvailabilityRequirementState
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VpnGatewayStatusHighAvailabilityRequirementState.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.unsatisfiedReason != null && message.hasOwnProperty("unsatisfiedReason")) {
                                object.unsatisfiedReason = message.unsatisfiedReason;
                                if (options.oneofs)
                                    object._unsatisfiedReason = "unsatisfiedReason";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                object.state = message.state;
                                if (options.oneofs)
                                    object._state = "state";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this VpnGatewayStatusHighAvailabilityRequirementState to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VpnGatewayStatusHighAvailabilityRequirementState.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for VpnGatewayStatusHighAvailabilityRequirementState
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        VpnGatewayStatusHighAvailabilityRequirementState.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState";
                        };
    
                        /**
                         * State enum.
                         * @name google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState.State
                         * @enum {number}
                         * @property {number} UNDEFINED_STATE=0 UNDEFINED_STATE value
                         * @property {number} CONNECTION_REDUNDANCY_MET=505242907 CONNECTION_REDUNDANCY_MET value
                         * @property {number} CONNECTION_REDUNDANCY_NOT_MET=511863311 CONNECTION_REDUNDANCY_NOT_MET value
                         */
                        VpnGatewayStatusHighAvailabilityRequirementState.State = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATE"] = 0;
                            values[valuesById[505242907] = "CONNECTION_REDUNDANCY_MET"] = 505242907;
                            values[valuesById[511863311] = "CONNECTION_REDUNDANCY_NOT_MET"] = 511863311;
                            return values;
                        })();
    
                        /**
                         * UnsatisfiedReason enum.
                         * @name google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState.UnsatisfiedReason
                         * @enum {number}
                         * @property {number} UNDEFINED_UNSATISFIED_REASON=0 UNDEFINED_UNSATISFIED_REASON value
                         * @property {number} INCOMPLETE_TUNNELS_COVERAGE=55917437 INCOMPLETE_TUNNELS_COVERAGE value
                         */
                        VpnGatewayStatusHighAvailabilityRequirementState.UnsatisfiedReason = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_UNSATISFIED_REASON"] = 0;
                            values[valuesById[55917437] = "INCOMPLETE_TUNNELS_COVERAGE"] = 55917437;
                            return values;
                        })();
    
                        return VpnGatewayStatusHighAvailabilityRequirementState;
                    })();
    
                    v1.VpnGatewayStatusTunnel = (function() {
    
                        /**
                         * Properties of a VpnGatewayStatusTunnel.
                         * @memberof google.cloud.compute.v1
                         * @interface IVpnGatewayStatusTunnel
                         * @property {number|null} [localGatewayInterface] VpnGatewayStatusTunnel localGatewayInterface
                         * @property {number|null} [peerGatewayInterface] VpnGatewayStatusTunnel peerGatewayInterface
                         * @property {string|null} [tunnelUrl] VpnGatewayStatusTunnel tunnelUrl
                         */
    
                        /**
                         * Constructs a new VpnGatewayStatusTunnel.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a VpnGatewayStatusTunnel.
                         * @implements IVpnGatewayStatusTunnel
                         * @constructor
                         * @param {google.cloud.compute.v1.IVpnGatewayStatusTunnel=} [properties] Properties to set
                         */
                        function VpnGatewayStatusTunnel(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * VpnGatewayStatusTunnel localGatewayInterface.
                         * @member {number|null|undefined} localGatewayInterface
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusTunnel
                         * @instance
                         */
                        VpnGatewayStatusTunnel.prototype.localGatewayInterface = null;
    
                        /**
                         * VpnGatewayStatusTunnel peerGatewayInterface.
                         * @member {number|null|undefined} peerGatewayInterface
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusTunnel
                         * @instance
                         */
                        VpnGatewayStatusTunnel.prototype.peerGatewayInterface = null;
    
                        /**
                         * VpnGatewayStatusTunnel tunnelUrl.
                         * @member {string|null|undefined} tunnelUrl
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusTunnel
                         * @instance
                         */
                        VpnGatewayStatusTunnel.prototype.tunnelUrl = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * VpnGatewayStatusTunnel _localGatewayInterface.
                         * @member {"localGatewayInterface"|undefined} _localGatewayInterface
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayStatusTunnel.prototype, "_localGatewayInterface", {
                            get: $util.oneOfGetter($oneOfFields = ["localGatewayInterface"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGatewayStatusTunnel _peerGatewayInterface.
                         * @member {"peerGatewayInterface"|undefined} _peerGatewayInterface
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayStatusTunnel.prototype, "_peerGatewayInterface", {
                            get: $util.oneOfGetter($oneOfFields = ["peerGatewayInterface"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGatewayStatusTunnel _tunnelUrl.
                         * @member {"tunnelUrl"|undefined} _tunnelUrl
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayStatusTunnel.prototype, "_tunnelUrl", {
                            get: $util.oneOfGetter($oneOfFields = ["tunnelUrl"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new VpnGatewayStatusTunnel instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusTunnel
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayStatusTunnel=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.VpnGatewayStatusTunnel} VpnGatewayStatusTunnel instance
                         */
                        VpnGatewayStatusTunnel.create = function create(properties) {
                            return new VpnGatewayStatusTunnel(properties);
                        };
    
                        /**
                         * Encodes the specified VpnGatewayStatusTunnel message. Does not implicitly {@link google.cloud.compute.v1.VpnGatewayStatusTunnel.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusTunnel
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayStatusTunnel} message VpnGatewayStatusTunnel message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnGatewayStatusTunnel.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.tunnelUrl != null && Object.hasOwnProperty.call(message, "tunnelUrl"))
                                writer.uint32(/* id 78975256, wireType 2 =*/631802050).string(message.tunnelUrl);
                            if (message.localGatewayInterface != null && Object.hasOwnProperty.call(message, "localGatewayInterface"))
                                writer.uint32(/* id 158764330, wireType 0 =*/1270114640).uint32(message.localGatewayInterface);
                            if (message.peerGatewayInterface != null && Object.hasOwnProperty.call(message, "peerGatewayInterface"))
                                writer.uint32(/* id 214380385, wireType 0 =*/1715043080).uint32(message.peerGatewayInterface);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified VpnGatewayStatusTunnel message, length delimited. Does not implicitly {@link google.cloud.compute.v1.VpnGatewayStatusTunnel.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusTunnel
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayStatusTunnel} message VpnGatewayStatusTunnel message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnGatewayStatusTunnel.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a VpnGatewayStatusTunnel message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusTunnel
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.VpnGatewayStatusTunnel} VpnGatewayStatusTunnel
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnGatewayStatusTunnel.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.VpnGatewayStatusTunnel();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 158764330: {
                                        message.localGatewayInterface = reader.uint32();
                                        break;
                                    }
                                case 214380385: {
                                        message.peerGatewayInterface = reader.uint32();
                                        break;
                                    }
                                case 78975256: {
                                        message.tunnelUrl = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a VpnGatewayStatusTunnel message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusTunnel
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.VpnGatewayStatusTunnel} VpnGatewayStatusTunnel
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnGatewayStatusTunnel.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a VpnGatewayStatusTunnel message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusTunnel
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VpnGatewayStatusTunnel.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.localGatewayInterface != null && message.hasOwnProperty("localGatewayInterface")) {
                                properties._localGatewayInterface = 1;
                                if (!$util.isInteger(message.localGatewayInterface))
                                    return "localGatewayInterface: integer expected";
                            }
                            if (message.peerGatewayInterface != null && message.hasOwnProperty("peerGatewayInterface")) {
                                properties._peerGatewayInterface = 1;
                                if (!$util.isInteger(message.peerGatewayInterface))
                                    return "peerGatewayInterface: integer expected";
                            }
                            if (message.tunnelUrl != null && message.hasOwnProperty("tunnelUrl")) {
                                properties._tunnelUrl = 1;
                                if (!$util.isString(message.tunnelUrl))
                                    return "tunnelUrl: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a VpnGatewayStatusTunnel message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusTunnel
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.VpnGatewayStatusTunnel} VpnGatewayStatusTunnel
                         */
                        VpnGatewayStatusTunnel.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.VpnGatewayStatusTunnel)
                                return object;
                            var message = new $root.google.cloud.compute.v1.VpnGatewayStatusTunnel();
                            if (object.localGatewayInterface != null)
                                message.localGatewayInterface = object.localGatewayInterface >>> 0;
                            if (object.peerGatewayInterface != null)
                                message.peerGatewayInterface = object.peerGatewayInterface >>> 0;
                            if (object.tunnelUrl != null)
                                message.tunnelUrl = String(object.tunnelUrl);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a VpnGatewayStatusTunnel message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusTunnel
                         * @static
                         * @param {google.cloud.compute.v1.VpnGatewayStatusTunnel} message VpnGatewayStatusTunnel
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VpnGatewayStatusTunnel.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.tunnelUrl != null && message.hasOwnProperty("tunnelUrl")) {
                                object.tunnelUrl = message.tunnelUrl;
                                if (options.oneofs)
                                    object._tunnelUrl = "tunnelUrl";
                            }
                            if (message.localGatewayInterface != null && message.hasOwnProperty("localGatewayInterface")) {
                                object.localGatewayInterface = message.localGatewayInterface;
                                if (options.oneofs)
                                    object._localGatewayInterface = "localGatewayInterface";
                            }
                            if (message.peerGatewayInterface != null && message.hasOwnProperty("peerGatewayInterface")) {
                                object.peerGatewayInterface = message.peerGatewayInterface;
                                if (options.oneofs)
                                    object._peerGatewayInterface = "peerGatewayInterface";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this VpnGatewayStatusTunnel to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusTunnel
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VpnGatewayStatusTunnel.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for VpnGatewayStatusTunnel
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusTunnel
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        VpnGatewayStatusTunnel.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.VpnGatewayStatusTunnel";
                        };
    
                        return VpnGatewayStatusTunnel;
                    })();
    
                    v1.VpnGatewayStatusVpnConnection = (function() {
    
                        /**
                         * Properties of a VpnGatewayStatusVpnConnection.
                         * @memberof google.cloud.compute.v1
                         * @interface IVpnGatewayStatusVpnConnection
                         * @property {string|null} [peerExternalGateway] VpnGatewayStatusVpnConnection peerExternalGateway
                         * @property {string|null} [peerGcpGateway] VpnGatewayStatusVpnConnection peerGcpGateway
                         * @property {google.cloud.compute.v1.IVpnGatewayStatusHighAvailabilityRequirementState|null} [state] VpnGatewayStatusVpnConnection state
                         * @property {Array.<google.cloud.compute.v1.IVpnGatewayStatusTunnel>|null} [tunnels] VpnGatewayStatusVpnConnection tunnels
                         */
    
                        /**
                         * Constructs a new VpnGatewayStatusVpnConnection.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a VpnGatewayStatusVpnConnection.
                         * @implements IVpnGatewayStatusVpnConnection
                         * @constructor
                         * @param {google.cloud.compute.v1.IVpnGatewayStatusVpnConnection=} [properties] Properties to set
                         */
                        function VpnGatewayStatusVpnConnection(properties) {
                            this.tunnels = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * VpnGatewayStatusVpnConnection peerExternalGateway.
                         * @member {string|null|undefined} peerExternalGateway
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusVpnConnection
                         * @instance
                         */
                        VpnGatewayStatusVpnConnection.prototype.peerExternalGateway = null;
    
                        /**
                         * VpnGatewayStatusVpnConnection peerGcpGateway.
                         * @member {string|null|undefined} peerGcpGateway
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusVpnConnection
                         * @instance
                         */
                        VpnGatewayStatusVpnConnection.prototype.peerGcpGateway = null;
    
                        /**
                         * VpnGatewayStatusVpnConnection state.
                         * @member {google.cloud.compute.v1.IVpnGatewayStatusHighAvailabilityRequirementState|null|undefined} state
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusVpnConnection
                         * @instance
                         */
                        VpnGatewayStatusVpnConnection.prototype.state = null;
    
                        /**
                         * VpnGatewayStatusVpnConnection tunnels.
                         * @member {Array.<google.cloud.compute.v1.IVpnGatewayStatusTunnel>} tunnels
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusVpnConnection
                         * @instance
                         */
                        VpnGatewayStatusVpnConnection.prototype.tunnels = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * VpnGatewayStatusVpnConnection _peerExternalGateway.
                         * @member {"peerExternalGateway"|undefined} _peerExternalGateway
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusVpnConnection
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayStatusVpnConnection.prototype, "_peerExternalGateway", {
                            get: $util.oneOfGetter($oneOfFields = ["peerExternalGateway"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGatewayStatusVpnConnection _peerGcpGateway.
                         * @member {"peerGcpGateway"|undefined} _peerGcpGateway
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusVpnConnection
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayStatusVpnConnection.prototype, "_peerGcpGateway", {
                            get: $util.oneOfGetter($oneOfFields = ["peerGcpGateway"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGatewayStatusVpnConnection _state.
                         * @member {"state"|undefined} _state
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusVpnConnection
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayStatusVpnConnection.prototype, "_state", {
                            get: $util.oneOfGetter($oneOfFields = ["state"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new VpnGatewayStatusVpnConnection instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusVpnConnection
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayStatusVpnConnection=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.VpnGatewayStatusVpnConnection} VpnGatewayStatusVpnConnection instance
                         */
                        VpnGatewayStatusVpnConnection.create = function create(properties) {
                            return new VpnGatewayStatusVpnConnection(properties);
                        };
    
                        /**
                         * Encodes the specified VpnGatewayStatusVpnConnection message. Does not implicitly {@link google.cloud.compute.v1.VpnGatewayStatusVpnConnection.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusVpnConnection
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayStatusVpnConnection} message VpnGatewayStatusVpnConnection message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnGatewayStatusVpnConnection.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.tunnels != null && message.tunnels.length)
                                for (var i = 0; i < message.tunnels.length; ++i)
                                    $root.google.cloud.compute.v1.VpnGatewayStatusTunnel.encode(message.tunnels[i], writer.uint32(/* id 104561931, wireType 2 =*/836495450).fork()).ldelim();
                            if (message.state != null && Object.hasOwnProperty.call(message, "state"))
                                $root.google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState.encode(message.state, writer.uint32(/* id 109757585, wireType 2 =*/878060682).fork()).ldelim();
                            if (message.peerGcpGateway != null && Object.hasOwnProperty.call(message, "peerGcpGateway"))
                                writer.uint32(/* id 281867452, wireType 2 =*/2254939618).string(message.peerGcpGateway);
                            if (message.peerExternalGateway != null && Object.hasOwnProperty.call(message, "peerExternalGateway"))
                                writer.uint32(/* id 384956173, wireType 2 =*/3079649386).string(message.peerExternalGateway);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified VpnGatewayStatusVpnConnection message, length delimited. Does not implicitly {@link google.cloud.compute.v1.VpnGatewayStatusVpnConnection.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusVpnConnection
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayStatusVpnConnection} message VpnGatewayStatusVpnConnection message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnGatewayStatusVpnConnection.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a VpnGatewayStatusVpnConnection message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusVpnConnection
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.VpnGatewayStatusVpnConnection} VpnGatewayStatusVpnConnection
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnGatewayStatusVpnConnection.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.VpnGatewayStatusVpnConnection();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 384956173: {
                                        message.peerExternalGateway = reader.string();
                                        break;
                                    }
                                case 281867452: {
                                        message.peerGcpGateway = reader.string();
                                        break;
                                    }
                                case 109757585: {
                                        message.state = $root.google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 104561931: {
                                        if (!(message.tunnels && message.tunnels.length))
                                            message.tunnels = [];
                                        message.tunnels.push($root.google.cloud.compute.v1.VpnGatewayStatusTunnel.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a VpnGatewayStatusVpnConnection message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusVpnConnection
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.VpnGatewayStatusVpnConnection} VpnGatewayStatusVpnConnection
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnGatewayStatusVpnConnection.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a VpnGatewayStatusVpnConnection message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusVpnConnection
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VpnGatewayStatusVpnConnection.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.peerExternalGateway != null && message.hasOwnProperty("peerExternalGateway")) {
                                properties._peerExternalGateway = 1;
                                if (!$util.isString(message.peerExternalGateway))
                                    return "peerExternalGateway: string expected";
                            }
                            if (message.peerGcpGateway != null && message.hasOwnProperty("peerGcpGateway")) {
                                properties._peerGcpGateway = 1;
                                if (!$util.isString(message.peerGcpGateway))
                                    return "peerGcpGateway: string expected";
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                properties._state = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState.verify(message.state);
                                    if (error)
                                        return "state." + error;
                                }
                            }
                            if (message.tunnels != null && message.hasOwnProperty("tunnels")) {
                                if (!Array.isArray(message.tunnels))
                                    return "tunnels: array expected";
                                for (var i = 0; i < message.tunnels.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.VpnGatewayStatusTunnel.verify(message.tunnels[i]);
                                    if (error)
                                        return "tunnels." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a VpnGatewayStatusVpnConnection message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusVpnConnection
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.VpnGatewayStatusVpnConnection} VpnGatewayStatusVpnConnection
                         */
                        VpnGatewayStatusVpnConnection.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.VpnGatewayStatusVpnConnection)
                                return object;
                            var message = new $root.google.cloud.compute.v1.VpnGatewayStatusVpnConnection();
                            if (object.peerExternalGateway != null)
                                message.peerExternalGateway = String(object.peerExternalGateway);
                            if (object.peerGcpGateway != null)
                                message.peerGcpGateway = String(object.peerGcpGateway);
                            if (object.state != null) {
                                if (typeof object.state !== "object")
                                    throw TypeError(".google.cloud.compute.v1.VpnGatewayStatusVpnConnection.state: object expected");
                                message.state = $root.google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState.fromObject(object.state);
                            }
                            if (object.tunnels) {
                                if (!Array.isArray(object.tunnels))
                                    throw TypeError(".google.cloud.compute.v1.VpnGatewayStatusVpnConnection.tunnels: array expected");
                                message.tunnels = [];
                                for (var i = 0; i < object.tunnels.length; ++i) {
                                    if (typeof object.tunnels[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.VpnGatewayStatusVpnConnection.tunnels: object expected");
                                    message.tunnels[i] = $root.google.cloud.compute.v1.VpnGatewayStatusTunnel.fromObject(object.tunnels[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a VpnGatewayStatusVpnConnection message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusVpnConnection
                         * @static
                         * @param {google.cloud.compute.v1.VpnGatewayStatusVpnConnection} message VpnGatewayStatusVpnConnection
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VpnGatewayStatusVpnConnection.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.tunnels = [];
                            if (message.tunnels && message.tunnels.length) {
                                object.tunnels = [];
                                for (var j = 0; j < message.tunnels.length; ++j)
                                    object.tunnels[j] = $root.google.cloud.compute.v1.VpnGatewayStatusTunnel.toObject(message.tunnels[j], options);
                            }
                            if (message.state != null && message.hasOwnProperty("state")) {
                                object.state = $root.google.cloud.compute.v1.VpnGatewayStatusHighAvailabilityRequirementState.toObject(message.state, options);
                                if (options.oneofs)
                                    object._state = "state";
                            }
                            if (message.peerGcpGateway != null && message.hasOwnProperty("peerGcpGateway")) {
                                object.peerGcpGateway = message.peerGcpGateway;
                                if (options.oneofs)
                                    object._peerGcpGateway = "peerGcpGateway";
                            }
                            if (message.peerExternalGateway != null && message.hasOwnProperty("peerExternalGateway")) {
                                object.peerExternalGateway = message.peerExternalGateway;
                                if (options.oneofs)
                                    object._peerExternalGateway = "peerExternalGateway";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this VpnGatewayStatusVpnConnection to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusVpnConnection
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VpnGatewayStatusVpnConnection.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for VpnGatewayStatusVpnConnection
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.VpnGatewayStatusVpnConnection
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        VpnGatewayStatusVpnConnection.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.VpnGatewayStatusVpnConnection";
                        };
    
                        return VpnGatewayStatusVpnConnection;
                    })();
    
                    v1.VpnGatewayVpnGatewayInterface = (function() {
    
                        /**
                         * Properties of a VpnGatewayVpnGatewayInterface.
                         * @memberof google.cloud.compute.v1
                         * @interface IVpnGatewayVpnGatewayInterface
                         * @property {number|null} [id] VpnGatewayVpnGatewayInterface id
                         * @property {string|null} [interconnectAttachment] VpnGatewayVpnGatewayInterface interconnectAttachment
                         * @property {string|null} [ipAddress] VpnGatewayVpnGatewayInterface ipAddress
                         */
    
                        /**
                         * Constructs a new VpnGatewayVpnGatewayInterface.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a VpnGatewayVpnGatewayInterface.
                         * @implements IVpnGatewayVpnGatewayInterface
                         * @constructor
                         * @param {google.cloud.compute.v1.IVpnGatewayVpnGatewayInterface=} [properties] Properties to set
                         */
                        function VpnGatewayVpnGatewayInterface(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * VpnGatewayVpnGatewayInterface id.
                         * @member {number|null|undefined} id
                         * @memberof google.cloud.compute.v1.VpnGatewayVpnGatewayInterface
                         * @instance
                         */
                        VpnGatewayVpnGatewayInterface.prototype.id = null;
    
                        /**
                         * VpnGatewayVpnGatewayInterface interconnectAttachment.
                         * @member {string|null|undefined} interconnectAttachment
                         * @memberof google.cloud.compute.v1.VpnGatewayVpnGatewayInterface
                         * @instance
                         */
                        VpnGatewayVpnGatewayInterface.prototype.interconnectAttachment = null;
    
                        /**
                         * VpnGatewayVpnGatewayInterface ipAddress.
                         * @member {string|null|undefined} ipAddress
                         * @memberof google.cloud.compute.v1.VpnGatewayVpnGatewayInterface
                         * @instance
                         */
                        VpnGatewayVpnGatewayInterface.prototype.ipAddress = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * VpnGatewayVpnGatewayInterface _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.VpnGatewayVpnGatewayInterface
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayVpnGatewayInterface.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGatewayVpnGatewayInterface _interconnectAttachment.
                         * @member {"interconnectAttachment"|undefined} _interconnectAttachment
                         * @memberof google.cloud.compute.v1.VpnGatewayVpnGatewayInterface
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayVpnGatewayInterface.prototype, "_interconnectAttachment", {
                            get: $util.oneOfGetter($oneOfFields = ["interconnectAttachment"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnGatewayVpnGatewayInterface _ipAddress.
                         * @member {"ipAddress"|undefined} _ipAddress
                         * @memberof google.cloud.compute.v1.VpnGatewayVpnGatewayInterface
                         * @instance
                         */
                        Object.defineProperty(VpnGatewayVpnGatewayInterface.prototype, "_ipAddress", {
                            get: $util.oneOfGetter($oneOfFields = ["ipAddress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new VpnGatewayVpnGatewayInterface instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.VpnGatewayVpnGatewayInterface
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayVpnGatewayInterface=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.VpnGatewayVpnGatewayInterface} VpnGatewayVpnGatewayInterface instance
                         */
                        VpnGatewayVpnGatewayInterface.create = function create(properties) {
                            return new VpnGatewayVpnGatewayInterface(properties);
                        };
    
                        /**
                         * Encodes the specified VpnGatewayVpnGatewayInterface message. Does not implicitly {@link google.cloud.compute.v1.VpnGatewayVpnGatewayInterface.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.VpnGatewayVpnGatewayInterface
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayVpnGatewayInterface} message VpnGatewayVpnGatewayInterface message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnGatewayVpnGatewayInterface.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint32(message.id);
                            if (message.interconnectAttachment != null && Object.hasOwnProperty.call(message, "interconnectAttachment"))
                                writer.uint32(/* id 308135284, wireType 2 =*/2465082274).string(message.interconnectAttachment);
                            if (message.ipAddress != null && Object.hasOwnProperty.call(message, "ipAddress"))
                                writer.uint32(/* id 406272220, wireType 2 =*/3250177762).string(message.ipAddress);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified VpnGatewayVpnGatewayInterface message, length delimited. Does not implicitly {@link google.cloud.compute.v1.VpnGatewayVpnGatewayInterface.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.VpnGatewayVpnGatewayInterface
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewayVpnGatewayInterface} message VpnGatewayVpnGatewayInterface message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnGatewayVpnGatewayInterface.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a VpnGatewayVpnGatewayInterface message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.VpnGatewayVpnGatewayInterface
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.VpnGatewayVpnGatewayInterface} VpnGatewayVpnGatewayInterface
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnGatewayVpnGatewayInterface.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.VpnGatewayVpnGatewayInterface();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.uint32();
                                        break;
                                    }
                                case 308135284: {
                                        message.interconnectAttachment = reader.string();
                                        break;
                                    }
                                case 406272220: {
                                        message.ipAddress = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a VpnGatewayVpnGatewayInterface message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.VpnGatewayVpnGatewayInterface
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.VpnGatewayVpnGatewayInterface} VpnGatewayVpnGatewayInterface
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnGatewayVpnGatewayInterface.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a VpnGatewayVpnGatewayInterface message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.VpnGatewayVpnGatewayInterface
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VpnGatewayVpnGatewayInterface.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id))
                                    return "id: integer expected";
                            }
                            if (message.interconnectAttachment != null && message.hasOwnProperty("interconnectAttachment")) {
                                properties._interconnectAttachment = 1;
                                if (!$util.isString(message.interconnectAttachment))
                                    return "interconnectAttachment: string expected";
                            }
                            if (message.ipAddress != null && message.hasOwnProperty("ipAddress")) {
                                properties._ipAddress = 1;
                                if (!$util.isString(message.ipAddress))
                                    return "ipAddress: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a VpnGatewayVpnGatewayInterface message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.VpnGatewayVpnGatewayInterface
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.VpnGatewayVpnGatewayInterface} VpnGatewayVpnGatewayInterface
                         */
                        VpnGatewayVpnGatewayInterface.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.VpnGatewayVpnGatewayInterface)
                                return object;
                            var message = new $root.google.cloud.compute.v1.VpnGatewayVpnGatewayInterface();
                            if (object.id != null)
                                message.id = object.id >>> 0;
                            if (object.interconnectAttachment != null)
                                message.interconnectAttachment = String(object.interconnectAttachment);
                            if (object.ipAddress != null)
                                message.ipAddress = String(object.ipAddress);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a VpnGatewayVpnGatewayInterface message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.VpnGatewayVpnGatewayInterface
                         * @static
                         * @param {google.cloud.compute.v1.VpnGatewayVpnGatewayInterface} message VpnGatewayVpnGatewayInterface
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VpnGatewayVpnGatewayInterface.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.interconnectAttachment != null && message.hasOwnProperty("interconnectAttachment")) {
                                object.interconnectAttachment = message.interconnectAttachment;
                                if (options.oneofs)
                                    object._interconnectAttachment = "interconnectAttachment";
                            }
                            if (message.ipAddress != null && message.hasOwnProperty("ipAddress")) {
                                object.ipAddress = message.ipAddress;
                                if (options.oneofs)
                                    object._ipAddress = "ipAddress";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this VpnGatewayVpnGatewayInterface to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.VpnGatewayVpnGatewayInterface
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VpnGatewayVpnGatewayInterface.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for VpnGatewayVpnGatewayInterface
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.VpnGatewayVpnGatewayInterface
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        VpnGatewayVpnGatewayInterface.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.VpnGatewayVpnGatewayInterface";
                        };
    
                        return VpnGatewayVpnGatewayInterface;
                    })();
    
                    v1.VpnGatewaysGetStatusResponse = (function() {
    
                        /**
                         * Properties of a VpnGatewaysGetStatusResponse.
                         * @memberof google.cloud.compute.v1
                         * @interface IVpnGatewaysGetStatusResponse
                         * @property {google.cloud.compute.v1.IVpnGatewayStatus|null} [result] VpnGatewaysGetStatusResponse result
                         */
    
                        /**
                         * Constructs a new VpnGatewaysGetStatusResponse.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a VpnGatewaysGetStatusResponse.
                         * @implements IVpnGatewaysGetStatusResponse
                         * @constructor
                         * @param {google.cloud.compute.v1.IVpnGatewaysGetStatusResponse=} [properties] Properties to set
                         */
                        function VpnGatewaysGetStatusResponse(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * VpnGatewaysGetStatusResponse result.
                         * @member {google.cloud.compute.v1.IVpnGatewayStatus|null|undefined} result
                         * @memberof google.cloud.compute.v1.VpnGatewaysGetStatusResponse
                         * @instance
                         */
                        VpnGatewaysGetStatusResponse.prototype.result = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * VpnGatewaysGetStatusResponse _result.
                         * @member {"result"|undefined} _result
                         * @memberof google.cloud.compute.v1.VpnGatewaysGetStatusResponse
                         * @instance
                         */
                        Object.defineProperty(VpnGatewaysGetStatusResponse.prototype, "_result", {
                            get: $util.oneOfGetter($oneOfFields = ["result"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new VpnGatewaysGetStatusResponse instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.VpnGatewaysGetStatusResponse
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewaysGetStatusResponse=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.VpnGatewaysGetStatusResponse} VpnGatewaysGetStatusResponse instance
                         */
                        VpnGatewaysGetStatusResponse.create = function create(properties) {
                            return new VpnGatewaysGetStatusResponse(properties);
                        };
    
                        /**
                         * Encodes the specified VpnGatewaysGetStatusResponse message. Does not implicitly {@link google.cloud.compute.v1.VpnGatewaysGetStatusResponse.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.VpnGatewaysGetStatusResponse
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewaysGetStatusResponse} message VpnGatewaysGetStatusResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnGatewaysGetStatusResponse.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.result != null && Object.hasOwnProperty.call(message, "result"))
                                $root.google.cloud.compute.v1.VpnGatewayStatus.encode(message.result, writer.uint32(/* id 139315229, wireType 2 =*/1114521834).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified VpnGatewaysGetStatusResponse message, length delimited. Does not implicitly {@link google.cloud.compute.v1.VpnGatewaysGetStatusResponse.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.VpnGatewaysGetStatusResponse
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewaysGetStatusResponse} message VpnGatewaysGetStatusResponse message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnGatewaysGetStatusResponse.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a VpnGatewaysGetStatusResponse message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.VpnGatewaysGetStatusResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.VpnGatewaysGetStatusResponse} VpnGatewaysGetStatusResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnGatewaysGetStatusResponse.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.VpnGatewaysGetStatusResponse();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 139315229: {
                                        message.result = $root.google.cloud.compute.v1.VpnGatewayStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a VpnGatewaysGetStatusResponse message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.VpnGatewaysGetStatusResponse
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.VpnGatewaysGetStatusResponse} VpnGatewaysGetStatusResponse
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnGatewaysGetStatusResponse.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a VpnGatewaysGetStatusResponse message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.VpnGatewaysGetStatusResponse
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VpnGatewaysGetStatusResponse.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.result != null && message.hasOwnProperty("result")) {
                                properties._result = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.VpnGatewayStatus.verify(message.result);
                                    if (error)
                                        return "result." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a VpnGatewaysGetStatusResponse message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.VpnGatewaysGetStatusResponse
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.VpnGatewaysGetStatusResponse} VpnGatewaysGetStatusResponse
                         */
                        VpnGatewaysGetStatusResponse.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.VpnGatewaysGetStatusResponse)
                                return object;
                            var message = new $root.google.cloud.compute.v1.VpnGatewaysGetStatusResponse();
                            if (object.result != null) {
                                if (typeof object.result !== "object")
                                    throw TypeError(".google.cloud.compute.v1.VpnGatewaysGetStatusResponse.result: object expected");
                                message.result = $root.google.cloud.compute.v1.VpnGatewayStatus.fromObject(object.result);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a VpnGatewaysGetStatusResponse message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.VpnGatewaysGetStatusResponse
                         * @static
                         * @param {google.cloud.compute.v1.VpnGatewaysGetStatusResponse} message VpnGatewaysGetStatusResponse
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VpnGatewaysGetStatusResponse.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.result != null && message.hasOwnProperty("result")) {
                                object.result = $root.google.cloud.compute.v1.VpnGatewayStatus.toObject(message.result, options);
                                if (options.oneofs)
                                    object._result = "result";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this VpnGatewaysGetStatusResponse to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.VpnGatewaysGetStatusResponse
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VpnGatewaysGetStatusResponse.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for VpnGatewaysGetStatusResponse
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.VpnGatewaysGetStatusResponse
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        VpnGatewaysGetStatusResponse.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.VpnGatewaysGetStatusResponse";
                        };
    
                        return VpnGatewaysGetStatusResponse;
                    })();
    
                    v1.VpnGatewaysScopedList = (function() {
    
                        /**
                         * Properties of a VpnGatewaysScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IVpnGatewaysScopedList
                         * @property {Array.<google.cloud.compute.v1.IVpnGateway>|null} [vpnGateways] VpnGatewaysScopedList vpnGateways
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] VpnGatewaysScopedList warning
                         */
    
                        /**
                         * Constructs a new VpnGatewaysScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a VpnGatewaysScopedList.
                         * @implements IVpnGatewaysScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IVpnGatewaysScopedList=} [properties] Properties to set
                         */
                        function VpnGatewaysScopedList(properties) {
                            this.vpnGateways = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * VpnGatewaysScopedList vpnGateways.
                         * @member {Array.<google.cloud.compute.v1.IVpnGateway>} vpnGateways
                         * @memberof google.cloud.compute.v1.VpnGatewaysScopedList
                         * @instance
                         */
                        VpnGatewaysScopedList.prototype.vpnGateways = $util.emptyArray;
    
                        /**
                         * VpnGatewaysScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.VpnGatewaysScopedList
                         * @instance
                         */
                        VpnGatewaysScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * VpnGatewaysScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.VpnGatewaysScopedList
                         * @instance
                         */
                        Object.defineProperty(VpnGatewaysScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new VpnGatewaysScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.VpnGatewaysScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewaysScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.VpnGatewaysScopedList} VpnGatewaysScopedList instance
                         */
                        VpnGatewaysScopedList.create = function create(properties) {
                            return new VpnGatewaysScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified VpnGatewaysScopedList message. Does not implicitly {@link google.cloud.compute.v1.VpnGatewaysScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.VpnGatewaysScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewaysScopedList} message VpnGatewaysScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnGatewaysScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.vpnGateways != null && message.vpnGateways.length)
                                for (var i = 0; i < message.vpnGateways.length; ++i)
                                    $root.google.cloud.compute.v1.VpnGateway.encode(message.vpnGateways[i], writer.uint32(/* id 259177882, wireType 2 =*/2073423058).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified VpnGatewaysScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.VpnGatewaysScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.VpnGatewaysScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IVpnGatewaysScopedList} message VpnGatewaysScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnGatewaysScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a VpnGatewaysScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.VpnGatewaysScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.VpnGatewaysScopedList} VpnGatewaysScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnGatewaysScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.VpnGatewaysScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 259177882: {
                                        if (!(message.vpnGateways && message.vpnGateways.length))
                                            message.vpnGateways = [];
                                        message.vpnGateways.push($root.google.cloud.compute.v1.VpnGateway.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a VpnGatewaysScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.VpnGatewaysScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.VpnGatewaysScopedList} VpnGatewaysScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnGatewaysScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a VpnGatewaysScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.VpnGatewaysScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VpnGatewaysScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.vpnGateways != null && message.hasOwnProperty("vpnGateways")) {
                                if (!Array.isArray(message.vpnGateways))
                                    return "vpnGateways: array expected";
                                for (var i = 0; i < message.vpnGateways.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.VpnGateway.verify(message.vpnGateways[i]);
                                    if (error)
                                        return "vpnGateways." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a VpnGatewaysScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.VpnGatewaysScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.VpnGatewaysScopedList} VpnGatewaysScopedList
                         */
                        VpnGatewaysScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.VpnGatewaysScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.VpnGatewaysScopedList();
                            if (object.vpnGateways) {
                                if (!Array.isArray(object.vpnGateways))
                                    throw TypeError(".google.cloud.compute.v1.VpnGatewaysScopedList.vpnGateways: array expected");
                                message.vpnGateways = [];
                                for (var i = 0; i < object.vpnGateways.length; ++i) {
                                    if (typeof object.vpnGateways[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.VpnGatewaysScopedList.vpnGateways: object expected");
                                    message.vpnGateways[i] = $root.google.cloud.compute.v1.VpnGateway.fromObject(object.vpnGateways[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.VpnGatewaysScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a VpnGatewaysScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.VpnGatewaysScopedList
                         * @static
                         * @param {google.cloud.compute.v1.VpnGatewaysScopedList} message VpnGatewaysScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VpnGatewaysScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.vpnGateways = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.vpnGateways && message.vpnGateways.length) {
                                object.vpnGateways = [];
                                for (var j = 0; j < message.vpnGateways.length; ++j)
                                    object.vpnGateways[j] = $root.google.cloud.compute.v1.VpnGateway.toObject(message.vpnGateways[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this VpnGatewaysScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.VpnGatewaysScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VpnGatewaysScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for VpnGatewaysScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.VpnGatewaysScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        VpnGatewaysScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.VpnGatewaysScopedList";
                        };
    
                        return VpnGatewaysScopedList;
                    })();
    
                    v1.VpnTunnel = (function() {
    
                        /**
                         * Properties of a VpnTunnel.
                         * @memberof google.cloud.compute.v1
                         * @interface IVpnTunnel
                         * @property {string|null} [creationTimestamp] VpnTunnel creationTimestamp
                         * @property {string|null} [description] VpnTunnel description
                         * @property {string|null} [detailedStatus] VpnTunnel detailedStatus
                         * @property {number|Long|null} [id] VpnTunnel id
                         * @property {number|null} [ikeVersion] VpnTunnel ikeVersion
                         * @property {string|null} [kind] VpnTunnel kind
                         * @property {Array.<string>|null} [localTrafficSelector] VpnTunnel localTrafficSelector
                         * @property {string|null} [name] VpnTunnel name
                         * @property {string|null} [peerExternalGateway] VpnTunnel peerExternalGateway
                         * @property {number|null} [peerExternalGatewayInterface] VpnTunnel peerExternalGatewayInterface
                         * @property {string|null} [peerGcpGateway] VpnTunnel peerGcpGateway
                         * @property {string|null} [peerIp] VpnTunnel peerIp
                         * @property {string|null} [region] VpnTunnel region
                         * @property {Array.<string>|null} [remoteTrafficSelector] VpnTunnel remoteTrafficSelector
                         * @property {string|null} [router] VpnTunnel router
                         * @property {string|null} [selfLink] VpnTunnel selfLink
                         * @property {string|null} [sharedSecret] VpnTunnel sharedSecret
                         * @property {string|null} [sharedSecretHash] VpnTunnel sharedSecretHash
                         * @property {string|null} [status] VpnTunnel status
                         * @property {string|null} [targetVpnGateway] VpnTunnel targetVpnGateway
                         * @property {string|null} [vpnGateway] VpnTunnel vpnGateway
                         * @property {number|null} [vpnGatewayInterface] VpnTunnel vpnGatewayInterface
                         */
    
                        /**
                         * Constructs a new VpnTunnel.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a VpnTunnel.
                         * @implements IVpnTunnel
                         * @constructor
                         * @param {google.cloud.compute.v1.IVpnTunnel=} [properties] Properties to set
                         */
                        function VpnTunnel(properties) {
                            this.localTrafficSelector = [];
                            this.remoteTrafficSelector = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * VpnTunnel creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.creationTimestamp = null;
    
                        /**
                         * VpnTunnel description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.description = null;
    
                        /**
                         * VpnTunnel detailedStatus.
                         * @member {string|null|undefined} detailedStatus
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.detailedStatus = null;
    
                        /**
                         * VpnTunnel id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.id = null;
    
                        /**
                         * VpnTunnel ikeVersion.
                         * @member {number|null|undefined} ikeVersion
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.ikeVersion = null;
    
                        /**
                         * VpnTunnel kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.kind = null;
    
                        /**
                         * VpnTunnel localTrafficSelector.
                         * @member {Array.<string>} localTrafficSelector
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.localTrafficSelector = $util.emptyArray;
    
                        /**
                         * VpnTunnel name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.name = null;
    
                        /**
                         * VpnTunnel peerExternalGateway.
                         * @member {string|null|undefined} peerExternalGateway
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.peerExternalGateway = null;
    
                        /**
                         * VpnTunnel peerExternalGatewayInterface.
                         * @member {number|null|undefined} peerExternalGatewayInterface
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.peerExternalGatewayInterface = null;
    
                        /**
                         * VpnTunnel peerGcpGateway.
                         * @member {string|null|undefined} peerGcpGateway
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.peerGcpGateway = null;
    
                        /**
                         * VpnTunnel peerIp.
                         * @member {string|null|undefined} peerIp
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.peerIp = null;
    
                        /**
                         * VpnTunnel region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.region = null;
    
                        /**
                         * VpnTunnel remoteTrafficSelector.
                         * @member {Array.<string>} remoteTrafficSelector
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.remoteTrafficSelector = $util.emptyArray;
    
                        /**
                         * VpnTunnel router.
                         * @member {string|null|undefined} router
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.router = null;
    
                        /**
                         * VpnTunnel selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.selfLink = null;
    
                        /**
                         * VpnTunnel sharedSecret.
                         * @member {string|null|undefined} sharedSecret
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.sharedSecret = null;
    
                        /**
                         * VpnTunnel sharedSecretHash.
                         * @member {string|null|undefined} sharedSecretHash
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.sharedSecretHash = null;
    
                        /**
                         * VpnTunnel status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.status = null;
    
                        /**
                         * VpnTunnel targetVpnGateway.
                         * @member {string|null|undefined} targetVpnGateway
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.targetVpnGateway = null;
    
                        /**
                         * VpnTunnel vpnGateway.
                         * @member {string|null|undefined} vpnGateway
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.vpnGateway = null;
    
                        /**
                         * VpnTunnel vpnGatewayInterface.
                         * @member {number|null|undefined} vpnGatewayInterface
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        VpnTunnel.prototype.vpnGatewayInterface = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * VpnTunnel _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnTunnel.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnel _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnTunnel.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnel _detailedStatus.
                         * @member {"detailedStatus"|undefined} _detailedStatus
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnTunnel.prototype, "_detailedStatus", {
                            get: $util.oneOfGetter($oneOfFields = ["detailedStatus"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnel _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnTunnel.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnel _ikeVersion.
                         * @member {"ikeVersion"|undefined} _ikeVersion
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnTunnel.prototype, "_ikeVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["ikeVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnel _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnTunnel.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnel _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnTunnel.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnel _peerExternalGateway.
                         * @member {"peerExternalGateway"|undefined} _peerExternalGateway
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnTunnel.prototype, "_peerExternalGateway", {
                            get: $util.oneOfGetter($oneOfFields = ["peerExternalGateway"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnel _peerExternalGatewayInterface.
                         * @member {"peerExternalGatewayInterface"|undefined} _peerExternalGatewayInterface
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnTunnel.prototype, "_peerExternalGatewayInterface", {
                            get: $util.oneOfGetter($oneOfFields = ["peerExternalGatewayInterface"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnel _peerGcpGateway.
                         * @member {"peerGcpGateway"|undefined} _peerGcpGateway
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnTunnel.prototype, "_peerGcpGateway", {
                            get: $util.oneOfGetter($oneOfFields = ["peerGcpGateway"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnel _peerIp.
                         * @member {"peerIp"|undefined} _peerIp
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnTunnel.prototype, "_peerIp", {
                            get: $util.oneOfGetter($oneOfFields = ["peerIp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnel _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnTunnel.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnel _router.
                         * @member {"router"|undefined} _router
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnTunnel.prototype, "_router", {
                            get: $util.oneOfGetter($oneOfFields = ["router"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnel _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnTunnel.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnel _sharedSecret.
                         * @member {"sharedSecret"|undefined} _sharedSecret
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnTunnel.prototype, "_sharedSecret", {
                            get: $util.oneOfGetter($oneOfFields = ["sharedSecret"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnel _sharedSecretHash.
                         * @member {"sharedSecretHash"|undefined} _sharedSecretHash
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnTunnel.prototype, "_sharedSecretHash", {
                            get: $util.oneOfGetter($oneOfFields = ["sharedSecretHash"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnel _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnTunnel.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnel _targetVpnGateway.
                         * @member {"targetVpnGateway"|undefined} _targetVpnGateway
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnTunnel.prototype, "_targetVpnGateway", {
                            get: $util.oneOfGetter($oneOfFields = ["targetVpnGateway"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnel _vpnGateway.
                         * @member {"vpnGateway"|undefined} _vpnGateway
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnTunnel.prototype, "_vpnGateway", {
                            get: $util.oneOfGetter($oneOfFields = ["vpnGateway"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnel _vpnGatewayInterface.
                         * @member {"vpnGatewayInterface"|undefined} _vpnGatewayInterface
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         */
                        Object.defineProperty(VpnTunnel.prototype, "_vpnGatewayInterface", {
                            get: $util.oneOfGetter($oneOfFields = ["vpnGatewayInterface"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new VpnTunnel instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @static
                         * @param {google.cloud.compute.v1.IVpnTunnel=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.VpnTunnel} VpnTunnel instance
                         */
                        VpnTunnel.create = function create(properties) {
                            return new VpnTunnel(properties);
                        };
    
                        /**
                         * Encodes the specified VpnTunnel message. Does not implicitly {@link google.cloud.compute.v1.VpnTunnel.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @static
                         * @param {google.cloud.compute.v1.IVpnTunnel} message VpnTunnel message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnTunnel.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.vpnGatewayInterface != null && Object.hasOwnProperty.call(message, "vpnGatewayInterface"))
                                writer.uint32(/* id 95979123, wireType 0 =*/767832984).int32(message.vpnGatewayInterface);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.router != null && Object.hasOwnProperty.call(message, "router"))
                                writer.uint32(/* id 148608841, wireType 2 =*/1188870730).string(message.router);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.ikeVersion != null && Object.hasOwnProperty.call(message, "ikeVersion"))
                                writer.uint32(/* id 218376220, wireType 0 =*/1747009760).int32(message.ikeVersion);
                            if (message.peerGcpGateway != null && Object.hasOwnProperty.call(message, "peerGcpGateway"))
                                writer.uint32(/* id 281867452, wireType 2 =*/2254939618).string(message.peerGcpGateway);
                            if (message.localTrafficSelector != null && message.localTrafficSelector.length)
                                for (var i = 0; i < message.localTrafficSelector.length; ++i)
                                    writer.uint32(/* id 317314613, wireType 2 =*/2538516906).string(message.localTrafficSelector[i]);
                            if (message.detailedStatus != null && Object.hasOwnProperty.call(message, "detailedStatus"))
                                writer.uint32(/* id 333501025, wireType 2 =*/2668008202).string(message.detailedStatus);
                            if (message.remoteTrafficSelector != null && message.remoteTrafficSelector.length)
                                for (var i = 0; i < message.remoteTrafficSelector.length; ++i)
                                    writer.uint32(/* id 358887098, wireType 2 =*/2871096786).string(message.remoteTrafficSelector[i]);
                            if (message.sharedSecret != null && Object.hasOwnProperty.call(message, "sharedSecret"))
                                writer.uint32(/* id 381932490, wireType 2 =*/3055459922).string(message.sharedSecret);
                            if (message.peerIp != null && Object.hasOwnProperty.call(message, "peerIp"))
                                writer.uint32(/* id 383249700, wireType 2 =*/3065997602).string(message.peerIp);
                            if (message.peerExternalGateway != null && Object.hasOwnProperty.call(message, "peerExternalGateway"))
                                writer.uint32(/* id 384956173, wireType 2 =*/3079649386).string(message.peerExternalGateway);
                            if (message.sharedSecretHash != null && Object.hasOwnProperty.call(message, "sharedSecretHash"))
                                writer.uint32(/* id 398881891, wireType 2 =*/3191055130).string(message.sharedSecretHash);
                            if (message.vpnGateway != null && Object.hasOwnProperty.call(message, "vpnGateway"))
                                writer.uint32(/* id 406684153, wireType 2 =*/3253473226).string(message.vpnGateway);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.peerExternalGatewayInterface != null && Object.hasOwnProperty.call(message, "peerExternalGatewayInterface"))
                                writer.uint32(/* id 452768391, wireType 0 =*/3622147128).int32(message.peerExternalGatewayInterface);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.targetVpnGateway != null && Object.hasOwnProperty.call(message, "targetVpnGateway"))
                                writer.uint32(/* id 532512843, wireType 2 =*/4260102746).string(message.targetVpnGateway);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified VpnTunnel message, length delimited. Does not implicitly {@link google.cloud.compute.v1.VpnTunnel.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @static
                         * @param {google.cloud.compute.v1.IVpnTunnel} message VpnTunnel message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnTunnel.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a VpnTunnel message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.VpnTunnel} VpnTunnel
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnTunnel.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.VpnTunnel();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 333501025: {
                                        message.detailedStatus = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 218376220: {
                                        message.ikeVersion = reader.int32();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 317314613: {
                                        if (!(message.localTrafficSelector && message.localTrafficSelector.length))
                                            message.localTrafficSelector = [];
                                        message.localTrafficSelector.push(reader.string());
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 384956173: {
                                        message.peerExternalGateway = reader.string();
                                        break;
                                    }
                                case 452768391: {
                                        message.peerExternalGatewayInterface = reader.int32();
                                        break;
                                    }
                                case 281867452: {
                                        message.peerGcpGateway = reader.string();
                                        break;
                                    }
                                case 383249700: {
                                        message.peerIp = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 358887098: {
                                        if (!(message.remoteTrafficSelector && message.remoteTrafficSelector.length))
                                            message.remoteTrafficSelector = [];
                                        message.remoteTrafficSelector.push(reader.string());
                                        break;
                                    }
                                case 148608841: {
                                        message.router = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 381932490: {
                                        message.sharedSecret = reader.string();
                                        break;
                                    }
                                case 398881891: {
                                        message.sharedSecretHash = reader.string();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                case 532512843: {
                                        message.targetVpnGateway = reader.string();
                                        break;
                                    }
                                case 406684153: {
                                        message.vpnGateway = reader.string();
                                        break;
                                    }
                                case 95979123: {
                                        message.vpnGatewayInterface = reader.int32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a VpnTunnel message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.VpnTunnel} VpnTunnel
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnTunnel.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a VpnTunnel message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VpnTunnel.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.detailedStatus != null && message.hasOwnProperty("detailedStatus")) {
                                properties._detailedStatus = 1;
                                if (!$util.isString(message.detailedStatus))
                                    return "detailedStatus: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.ikeVersion != null && message.hasOwnProperty("ikeVersion")) {
                                properties._ikeVersion = 1;
                                if (!$util.isInteger(message.ikeVersion))
                                    return "ikeVersion: integer expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.localTrafficSelector != null && message.hasOwnProperty("localTrafficSelector")) {
                                if (!Array.isArray(message.localTrafficSelector))
                                    return "localTrafficSelector: array expected";
                                for (var i = 0; i < message.localTrafficSelector.length; ++i)
                                    if (!$util.isString(message.localTrafficSelector[i]))
                                        return "localTrafficSelector: string[] expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.peerExternalGateway != null && message.hasOwnProperty("peerExternalGateway")) {
                                properties._peerExternalGateway = 1;
                                if (!$util.isString(message.peerExternalGateway))
                                    return "peerExternalGateway: string expected";
                            }
                            if (message.peerExternalGatewayInterface != null && message.hasOwnProperty("peerExternalGatewayInterface")) {
                                properties._peerExternalGatewayInterface = 1;
                                if (!$util.isInteger(message.peerExternalGatewayInterface))
                                    return "peerExternalGatewayInterface: integer expected";
                            }
                            if (message.peerGcpGateway != null && message.hasOwnProperty("peerGcpGateway")) {
                                properties._peerGcpGateway = 1;
                                if (!$util.isString(message.peerGcpGateway))
                                    return "peerGcpGateway: string expected";
                            }
                            if (message.peerIp != null && message.hasOwnProperty("peerIp")) {
                                properties._peerIp = 1;
                                if (!$util.isString(message.peerIp))
                                    return "peerIp: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.remoteTrafficSelector != null && message.hasOwnProperty("remoteTrafficSelector")) {
                                if (!Array.isArray(message.remoteTrafficSelector))
                                    return "remoteTrafficSelector: array expected";
                                for (var i = 0; i < message.remoteTrafficSelector.length; ++i)
                                    if (!$util.isString(message.remoteTrafficSelector[i]))
                                        return "remoteTrafficSelector: string[] expected";
                            }
                            if (message.router != null && message.hasOwnProperty("router")) {
                                properties._router = 1;
                                if (!$util.isString(message.router))
                                    return "router: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.sharedSecret != null && message.hasOwnProperty("sharedSecret")) {
                                properties._sharedSecret = 1;
                                if (!$util.isString(message.sharedSecret))
                                    return "sharedSecret: string expected";
                            }
                            if (message.sharedSecretHash != null && message.hasOwnProperty("sharedSecretHash")) {
                                properties._sharedSecretHash = 1;
                                if (!$util.isString(message.sharedSecretHash))
                                    return "sharedSecretHash: string expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            if (message.targetVpnGateway != null && message.hasOwnProperty("targetVpnGateway")) {
                                properties._targetVpnGateway = 1;
                                if (!$util.isString(message.targetVpnGateway))
                                    return "targetVpnGateway: string expected";
                            }
                            if (message.vpnGateway != null && message.hasOwnProperty("vpnGateway")) {
                                properties._vpnGateway = 1;
                                if (!$util.isString(message.vpnGateway))
                                    return "vpnGateway: string expected";
                            }
                            if (message.vpnGatewayInterface != null && message.hasOwnProperty("vpnGatewayInterface")) {
                                properties._vpnGatewayInterface = 1;
                                if (!$util.isInteger(message.vpnGatewayInterface))
                                    return "vpnGatewayInterface: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a VpnTunnel message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.VpnTunnel} VpnTunnel
                         */
                        VpnTunnel.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.VpnTunnel)
                                return object;
                            var message = new $root.google.cloud.compute.v1.VpnTunnel();
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.detailedStatus != null)
                                message.detailedStatus = String(object.detailedStatus);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.ikeVersion != null)
                                message.ikeVersion = object.ikeVersion | 0;
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.localTrafficSelector) {
                                if (!Array.isArray(object.localTrafficSelector))
                                    throw TypeError(".google.cloud.compute.v1.VpnTunnel.localTrafficSelector: array expected");
                                message.localTrafficSelector = [];
                                for (var i = 0; i < object.localTrafficSelector.length; ++i)
                                    message.localTrafficSelector[i] = String(object.localTrafficSelector[i]);
                            }
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.peerExternalGateway != null)
                                message.peerExternalGateway = String(object.peerExternalGateway);
                            if (object.peerExternalGatewayInterface != null)
                                message.peerExternalGatewayInterface = object.peerExternalGatewayInterface | 0;
                            if (object.peerGcpGateway != null)
                                message.peerGcpGateway = String(object.peerGcpGateway);
                            if (object.peerIp != null)
                                message.peerIp = String(object.peerIp);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.remoteTrafficSelector) {
                                if (!Array.isArray(object.remoteTrafficSelector))
                                    throw TypeError(".google.cloud.compute.v1.VpnTunnel.remoteTrafficSelector: array expected");
                                message.remoteTrafficSelector = [];
                                for (var i = 0; i < object.remoteTrafficSelector.length; ++i)
                                    message.remoteTrafficSelector[i] = String(object.remoteTrafficSelector[i]);
                            }
                            if (object.router != null)
                                message.router = String(object.router);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.sharedSecret != null)
                                message.sharedSecret = String(object.sharedSecret);
                            if (object.sharedSecretHash != null)
                                message.sharedSecretHash = String(object.sharedSecretHash);
                            if (object.status != null)
                                message.status = String(object.status);
                            if (object.targetVpnGateway != null)
                                message.targetVpnGateway = String(object.targetVpnGateway);
                            if (object.vpnGateway != null)
                                message.vpnGateway = String(object.vpnGateway);
                            if (object.vpnGatewayInterface != null)
                                message.vpnGatewayInterface = object.vpnGatewayInterface | 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a VpnTunnel message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @static
                         * @param {google.cloud.compute.v1.VpnTunnel} message VpnTunnel
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VpnTunnel.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.localTrafficSelector = [];
                                object.remoteTrafficSelector = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.vpnGatewayInterface != null && message.hasOwnProperty("vpnGatewayInterface")) {
                                object.vpnGatewayInterface = message.vpnGatewayInterface;
                                if (options.oneofs)
                                    object._vpnGatewayInterface = "vpnGatewayInterface";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.router != null && message.hasOwnProperty("router")) {
                                object.router = message.router;
                                if (options.oneofs)
                                    object._router = "router";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.ikeVersion != null && message.hasOwnProperty("ikeVersion")) {
                                object.ikeVersion = message.ikeVersion;
                                if (options.oneofs)
                                    object._ikeVersion = "ikeVersion";
                            }
                            if (message.peerGcpGateway != null && message.hasOwnProperty("peerGcpGateway")) {
                                object.peerGcpGateway = message.peerGcpGateway;
                                if (options.oneofs)
                                    object._peerGcpGateway = "peerGcpGateway";
                            }
                            if (message.localTrafficSelector && message.localTrafficSelector.length) {
                                object.localTrafficSelector = [];
                                for (var j = 0; j < message.localTrafficSelector.length; ++j)
                                    object.localTrafficSelector[j] = message.localTrafficSelector[j];
                            }
                            if (message.detailedStatus != null && message.hasOwnProperty("detailedStatus")) {
                                object.detailedStatus = message.detailedStatus;
                                if (options.oneofs)
                                    object._detailedStatus = "detailedStatus";
                            }
                            if (message.remoteTrafficSelector && message.remoteTrafficSelector.length) {
                                object.remoteTrafficSelector = [];
                                for (var j = 0; j < message.remoteTrafficSelector.length; ++j)
                                    object.remoteTrafficSelector[j] = message.remoteTrafficSelector[j];
                            }
                            if (message.sharedSecret != null && message.hasOwnProperty("sharedSecret")) {
                                object.sharedSecret = message.sharedSecret;
                                if (options.oneofs)
                                    object._sharedSecret = "sharedSecret";
                            }
                            if (message.peerIp != null && message.hasOwnProperty("peerIp")) {
                                object.peerIp = message.peerIp;
                                if (options.oneofs)
                                    object._peerIp = "peerIp";
                            }
                            if (message.peerExternalGateway != null && message.hasOwnProperty("peerExternalGateway")) {
                                object.peerExternalGateway = message.peerExternalGateway;
                                if (options.oneofs)
                                    object._peerExternalGateway = "peerExternalGateway";
                            }
                            if (message.sharedSecretHash != null && message.hasOwnProperty("sharedSecretHash")) {
                                object.sharedSecretHash = message.sharedSecretHash;
                                if (options.oneofs)
                                    object._sharedSecretHash = "sharedSecretHash";
                            }
                            if (message.vpnGateway != null && message.hasOwnProperty("vpnGateway")) {
                                object.vpnGateway = message.vpnGateway;
                                if (options.oneofs)
                                    object._vpnGateway = "vpnGateway";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.peerExternalGatewayInterface != null && message.hasOwnProperty("peerExternalGatewayInterface")) {
                                object.peerExternalGatewayInterface = message.peerExternalGatewayInterface;
                                if (options.oneofs)
                                    object._peerExternalGatewayInterface = "peerExternalGatewayInterface";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.targetVpnGateway != null && message.hasOwnProperty("targetVpnGateway")) {
                                object.targetVpnGateway = message.targetVpnGateway;
                                if (options.oneofs)
                                    object._targetVpnGateway = "targetVpnGateway";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this VpnTunnel to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VpnTunnel.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for VpnTunnel
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.VpnTunnel
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        VpnTunnel.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.VpnTunnel";
                        };
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.VpnTunnel.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} ALLOCATING_RESOURCES=320922816 ALLOCATING_RESOURCES value
                         * @property {number} AUTHORIZATION_ERROR=23580290 AUTHORIZATION_ERROR value
                         * @property {number} DEPROVISIONING=428935662 DEPROVISIONING value
                         * @property {number} ESTABLISHED=88852344 ESTABLISHED value
                         * @property {number} FAILED=455706685 FAILED value
                         * @property {number} FIRST_HANDSHAKE=191393000 FIRST_HANDSHAKE value
                         * @property {number} NEGOTIATION_FAILURE=360325868 NEGOTIATION_FAILURE value
                         * @property {number} NETWORK_ERROR=193912951 NETWORK_ERROR value
                         * @property {number} NO_INCOMING_PACKETS=119983216 NO_INCOMING_PACKETS value
                         * @property {number} PROVISIONING=290896621 PROVISIONING value
                         * @property {number} REJECTED=174130302 REJECTED value
                         * @property {number} STOPPED=444276141 STOPPED value
                         * @property {number} WAITING_FOR_FULL_CONFIG=41640522 WAITING_FOR_FULL_CONFIG value
                         */
                        VpnTunnel.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[320922816] = "ALLOCATING_RESOURCES"] = 320922816;
                            values[valuesById[23580290] = "AUTHORIZATION_ERROR"] = 23580290;
                            values[valuesById[428935662] = "DEPROVISIONING"] = 428935662;
                            values[valuesById[88852344] = "ESTABLISHED"] = 88852344;
                            values[valuesById[455706685] = "FAILED"] = 455706685;
                            values[valuesById[191393000] = "FIRST_HANDSHAKE"] = 191393000;
                            values[valuesById[360325868] = "NEGOTIATION_FAILURE"] = 360325868;
                            values[valuesById[193912951] = "NETWORK_ERROR"] = 193912951;
                            values[valuesById[119983216] = "NO_INCOMING_PACKETS"] = 119983216;
                            values[valuesById[290896621] = "PROVISIONING"] = 290896621;
                            values[valuesById[174130302] = "REJECTED"] = 174130302;
                            values[valuesById[444276141] = "STOPPED"] = 444276141;
                            values[valuesById[41640522] = "WAITING_FOR_FULL_CONFIG"] = 41640522;
                            return values;
                        })();
    
                        return VpnTunnel;
                    })();
    
                    v1.VpnTunnelAggregatedList = (function() {
    
                        /**
                         * Properties of a VpnTunnelAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IVpnTunnelAggregatedList
                         * @property {string|null} [id] VpnTunnelAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1.IVpnTunnelsScopedList>|null} [items] VpnTunnelAggregatedList items
                         * @property {string|null} [kind] VpnTunnelAggregatedList kind
                         * @property {string|null} [nextPageToken] VpnTunnelAggregatedList nextPageToken
                         * @property {string|null} [selfLink] VpnTunnelAggregatedList selfLink
                         * @property {Array.<string>|null} [unreachables] VpnTunnelAggregatedList unreachables
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] VpnTunnelAggregatedList warning
                         */
    
                        /**
                         * Constructs a new VpnTunnelAggregatedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a VpnTunnelAggregatedList.
                         * @implements IVpnTunnelAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IVpnTunnelAggregatedList=} [properties] Properties to set
                         */
                        function VpnTunnelAggregatedList(properties) {
                            this.items = {};
                            this.unreachables = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * VpnTunnelAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @instance
                         */
                        VpnTunnelAggregatedList.prototype.id = null;
    
                        /**
                         * VpnTunnelAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1.IVpnTunnelsScopedList>} items
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @instance
                         */
                        VpnTunnelAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * VpnTunnelAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @instance
                         */
                        VpnTunnelAggregatedList.prototype.kind = null;
    
                        /**
                         * VpnTunnelAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @instance
                         */
                        VpnTunnelAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * VpnTunnelAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @instance
                         */
                        VpnTunnelAggregatedList.prototype.selfLink = null;
    
                        /**
                         * VpnTunnelAggregatedList unreachables.
                         * @member {Array.<string>} unreachables
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @instance
                         */
                        VpnTunnelAggregatedList.prototype.unreachables = $util.emptyArray;
    
                        /**
                         * VpnTunnelAggregatedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @instance
                         */
                        VpnTunnelAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * VpnTunnelAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @instance
                         */
                        Object.defineProperty(VpnTunnelAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnelAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @instance
                         */
                        Object.defineProperty(VpnTunnelAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnelAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @instance
                         */
                        Object.defineProperty(VpnTunnelAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnelAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @instance
                         */
                        Object.defineProperty(VpnTunnelAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnelAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @instance
                         */
                        Object.defineProperty(VpnTunnelAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new VpnTunnelAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IVpnTunnelAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.VpnTunnelAggregatedList} VpnTunnelAggregatedList instance
                         */
                        VpnTunnelAggregatedList.create = function create(properties) {
                            return new VpnTunnelAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified VpnTunnelAggregatedList message. Does not implicitly {@link google.cloud.compute.v1.VpnTunnelAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IVpnTunnelAggregatedList} message VpnTunnelAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnTunnelAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1.VpnTunnelsScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.unreachables != null && message.unreachables.length)
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    writer.uint32(/* id 243372063, wireType 2 =*/1946976506).string(message.unreachables[i]);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified VpnTunnelAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.VpnTunnelAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.IVpnTunnelAggregatedList} message VpnTunnelAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnTunnelAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a VpnTunnelAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.VpnTunnelAggregatedList} VpnTunnelAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnTunnelAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.VpnTunnelAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1.VpnTunnelsScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 243372063: {
                                        if (!(message.unreachables && message.unreachables.length))
                                            message.unreachables = [];
                                        message.unreachables.push(reader.string());
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a VpnTunnelAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.VpnTunnelAggregatedList} VpnTunnelAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnTunnelAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a VpnTunnelAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VpnTunnelAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.VpnTunnelsScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.unreachables != null && message.hasOwnProperty("unreachables")) {
                                if (!Array.isArray(message.unreachables))
                                    return "unreachables: array expected";
                                for (var i = 0; i < message.unreachables.length; ++i)
                                    if (!$util.isString(message.unreachables[i]))
                                        return "unreachables: string[] expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a VpnTunnelAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.VpnTunnelAggregatedList} VpnTunnelAggregatedList
                         */
                        VpnTunnelAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.VpnTunnelAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.VpnTunnelAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1.VpnTunnelAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.VpnTunnelAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1.VpnTunnelsScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.unreachables) {
                                if (!Array.isArray(object.unreachables))
                                    throw TypeError(".google.cloud.compute.v1.VpnTunnelAggregatedList.unreachables: array expected");
                                message.unreachables = [];
                                for (var i = 0; i < object.unreachables.length; ++i)
                                    message.unreachables[i] = String(object.unreachables[i]);
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.VpnTunnelAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a VpnTunnelAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1.VpnTunnelAggregatedList} message VpnTunnelAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VpnTunnelAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.unreachables = [];
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1.VpnTunnelsScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.unreachables && message.unreachables.length) {
                                object.unreachables = [];
                                for (var j = 0; j < message.unreachables.length; ++j)
                                    object.unreachables[j] = message.unreachables[j];
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this VpnTunnelAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VpnTunnelAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for VpnTunnelAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.VpnTunnelAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        VpnTunnelAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.VpnTunnelAggregatedList";
                        };
    
                        return VpnTunnelAggregatedList;
                    })();
    
                    v1.VpnTunnelList = (function() {
    
                        /**
                         * Properties of a VpnTunnelList.
                         * @memberof google.cloud.compute.v1
                         * @interface IVpnTunnelList
                         * @property {string|null} [id] VpnTunnelList id
                         * @property {Array.<google.cloud.compute.v1.IVpnTunnel>|null} [items] VpnTunnelList items
                         * @property {string|null} [kind] VpnTunnelList kind
                         * @property {string|null} [nextPageToken] VpnTunnelList nextPageToken
                         * @property {string|null} [selfLink] VpnTunnelList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] VpnTunnelList warning
                         */
    
                        /**
                         * Constructs a new VpnTunnelList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a VpnTunnelList.
                         * @implements IVpnTunnelList
                         * @constructor
                         * @param {google.cloud.compute.v1.IVpnTunnelList=} [properties] Properties to set
                         */
                        function VpnTunnelList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * VpnTunnelList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @instance
                         */
                        VpnTunnelList.prototype.id = null;
    
                        /**
                         * VpnTunnelList items.
                         * @member {Array.<google.cloud.compute.v1.IVpnTunnel>} items
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @instance
                         */
                        VpnTunnelList.prototype.items = $util.emptyArray;
    
                        /**
                         * VpnTunnelList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @instance
                         */
                        VpnTunnelList.prototype.kind = null;
    
                        /**
                         * VpnTunnelList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @instance
                         */
                        VpnTunnelList.prototype.nextPageToken = null;
    
                        /**
                         * VpnTunnelList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @instance
                         */
                        VpnTunnelList.prototype.selfLink = null;
    
                        /**
                         * VpnTunnelList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @instance
                         */
                        VpnTunnelList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * VpnTunnelList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @instance
                         */
                        Object.defineProperty(VpnTunnelList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnelList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @instance
                         */
                        Object.defineProperty(VpnTunnelList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnelList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @instance
                         */
                        Object.defineProperty(VpnTunnelList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnelList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @instance
                         */
                        Object.defineProperty(VpnTunnelList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * VpnTunnelList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @instance
                         */
                        Object.defineProperty(VpnTunnelList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new VpnTunnelList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @static
                         * @param {google.cloud.compute.v1.IVpnTunnelList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.VpnTunnelList} VpnTunnelList instance
                         */
                        VpnTunnelList.create = function create(properties) {
                            return new VpnTunnelList(properties);
                        };
    
                        /**
                         * Encodes the specified VpnTunnelList message. Does not implicitly {@link google.cloud.compute.v1.VpnTunnelList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @static
                         * @param {google.cloud.compute.v1.IVpnTunnelList} message VpnTunnelList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnTunnelList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.VpnTunnel.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified VpnTunnelList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.VpnTunnelList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @static
                         * @param {google.cloud.compute.v1.IVpnTunnelList} message VpnTunnelList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnTunnelList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a VpnTunnelList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.VpnTunnelList} VpnTunnelList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnTunnelList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.VpnTunnelList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.VpnTunnel.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a VpnTunnelList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.VpnTunnelList} VpnTunnelList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnTunnelList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a VpnTunnelList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VpnTunnelList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.VpnTunnel.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a VpnTunnelList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.VpnTunnelList} VpnTunnelList
                         */
                        VpnTunnelList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.VpnTunnelList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.VpnTunnelList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.VpnTunnelList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.VpnTunnelList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.VpnTunnel.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.VpnTunnelList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a VpnTunnelList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @static
                         * @param {google.cloud.compute.v1.VpnTunnelList} message VpnTunnelList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VpnTunnelList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.VpnTunnel.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this VpnTunnelList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VpnTunnelList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for VpnTunnelList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.VpnTunnelList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        VpnTunnelList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.VpnTunnelList";
                        };
    
                        return VpnTunnelList;
                    })();
    
                    v1.VpnTunnelsScopedList = (function() {
    
                        /**
                         * Properties of a VpnTunnelsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @interface IVpnTunnelsScopedList
                         * @property {Array.<google.cloud.compute.v1.IVpnTunnel>|null} [vpnTunnels] VpnTunnelsScopedList vpnTunnels
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] VpnTunnelsScopedList warning
                         */
    
                        /**
                         * Constructs a new VpnTunnelsScopedList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a VpnTunnelsScopedList.
                         * @implements IVpnTunnelsScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1.IVpnTunnelsScopedList=} [properties] Properties to set
                         */
                        function VpnTunnelsScopedList(properties) {
                            this.vpnTunnels = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * VpnTunnelsScopedList vpnTunnels.
                         * @member {Array.<google.cloud.compute.v1.IVpnTunnel>} vpnTunnels
                         * @memberof google.cloud.compute.v1.VpnTunnelsScopedList
                         * @instance
                         */
                        VpnTunnelsScopedList.prototype.vpnTunnels = $util.emptyArray;
    
                        /**
                         * VpnTunnelsScopedList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.VpnTunnelsScopedList
                         * @instance
                         */
                        VpnTunnelsScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * VpnTunnelsScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.VpnTunnelsScopedList
                         * @instance
                         */
                        Object.defineProperty(VpnTunnelsScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new VpnTunnelsScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.VpnTunnelsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IVpnTunnelsScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.VpnTunnelsScopedList} VpnTunnelsScopedList instance
                         */
                        VpnTunnelsScopedList.create = function create(properties) {
                            return new VpnTunnelsScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified VpnTunnelsScopedList message. Does not implicitly {@link google.cloud.compute.v1.VpnTunnelsScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.VpnTunnelsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IVpnTunnelsScopedList} message VpnTunnelsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnTunnelsScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.vpnTunnels != null && message.vpnTunnels.length)
                                for (var i = 0; i < message.vpnTunnels.length; ++i)
                                    $root.google.cloud.compute.v1.VpnTunnel.encode(message.vpnTunnels[i], writer.uint32(/* id 163494080, wireType 2 =*/1307952642).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified VpnTunnelsScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.VpnTunnelsScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.VpnTunnelsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.IVpnTunnelsScopedList} message VpnTunnelsScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        VpnTunnelsScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a VpnTunnelsScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.VpnTunnelsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.VpnTunnelsScopedList} VpnTunnelsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnTunnelsScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.VpnTunnelsScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 163494080: {
                                        if (!(message.vpnTunnels && message.vpnTunnels.length))
                                            message.vpnTunnels = [];
                                        message.vpnTunnels.push($root.google.cloud.compute.v1.VpnTunnel.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a VpnTunnelsScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.VpnTunnelsScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.VpnTunnelsScopedList} VpnTunnelsScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        VpnTunnelsScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a VpnTunnelsScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.VpnTunnelsScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        VpnTunnelsScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.vpnTunnels != null && message.hasOwnProperty("vpnTunnels")) {
                                if (!Array.isArray(message.vpnTunnels))
                                    return "vpnTunnels: array expected";
                                for (var i = 0; i < message.vpnTunnels.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.VpnTunnel.verify(message.vpnTunnels[i]);
                                    if (error)
                                        return "vpnTunnels." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a VpnTunnelsScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.VpnTunnelsScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.VpnTunnelsScopedList} VpnTunnelsScopedList
                         */
                        VpnTunnelsScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.VpnTunnelsScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.VpnTunnelsScopedList();
                            if (object.vpnTunnels) {
                                if (!Array.isArray(object.vpnTunnels))
                                    throw TypeError(".google.cloud.compute.v1.VpnTunnelsScopedList.vpnTunnels: array expected");
                                message.vpnTunnels = [];
                                for (var i = 0; i < object.vpnTunnels.length; ++i) {
                                    if (typeof object.vpnTunnels[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.VpnTunnelsScopedList.vpnTunnels: object expected");
                                    message.vpnTunnels[i] = $root.google.cloud.compute.v1.VpnTunnel.fromObject(object.vpnTunnels[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.VpnTunnelsScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a VpnTunnelsScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.VpnTunnelsScopedList
                         * @static
                         * @param {google.cloud.compute.v1.VpnTunnelsScopedList} message VpnTunnelsScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        VpnTunnelsScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.vpnTunnels = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.vpnTunnels && message.vpnTunnels.length) {
                                object.vpnTunnels = [];
                                for (var j = 0; j < message.vpnTunnels.length; ++j)
                                    object.vpnTunnels[j] = $root.google.cloud.compute.v1.VpnTunnel.toObject(message.vpnTunnels[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this VpnTunnelsScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.VpnTunnelsScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        VpnTunnelsScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for VpnTunnelsScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.VpnTunnelsScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        VpnTunnelsScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.VpnTunnelsScopedList";
                        };
    
                        return VpnTunnelsScopedList;
                    })();
    
                    v1.WafExpressionSet = (function() {
    
                        /**
                         * Properties of a WafExpressionSet.
                         * @memberof google.cloud.compute.v1
                         * @interface IWafExpressionSet
                         * @property {Array.<string>|null} [aliases] WafExpressionSet aliases
                         * @property {Array.<google.cloud.compute.v1.IWafExpressionSetExpression>|null} [expressions] WafExpressionSet expressions
                         * @property {string|null} [id] WafExpressionSet id
                         */
    
                        /**
                         * Constructs a new WafExpressionSet.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a WafExpressionSet.
                         * @implements IWafExpressionSet
                         * @constructor
                         * @param {google.cloud.compute.v1.IWafExpressionSet=} [properties] Properties to set
                         */
                        function WafExpressionSet(properties) {
                            this.aliases = [];
                            this.expressions = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * WafExpressionSet aliases.
                         * @member {Array.<string>} aliases
                         * @memberof google.cloud.compute.v1.WafExpressionSet
                         * @instance
                         */
                        WafExpressionSet.prototype.aliases = $util.emptyArray;
    
                        /**
                         * WafExpressionSet expressions.
                         * @member {Array.<google.cloud.compute.v1.IWafExpressionSetExpression>} expressions
                         * @memberof google.cloud.compute.v1.WafExpressionSet
                         * @instance
                         */
                        WafExpressionSet.prototype.expressions = $util.emptyArray;
    
                        /**
                         * WafExpressionSet id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.WafExpressionSet
                         * @instance
                         */
                        WafExpressionSet.prototype.id = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * WafExpressionSet _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.WafExpressionSet
                         * @instance
                         */
                        Object.defineProperty(WafExpressionSet.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new WafExpressionSet instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.WafExpressionSet
                         * @static
                         * @param {google.cloud.compute.v1.IWafExpressionSet=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.WafExpressionSet} WafExpressionSet instance
                         */
                        WafExpressionSet.create = function create(properties) {
                            return new WafExpressionSet(properties);
                        };
    
                        /**
                         * Encodes the specified WafExpressionSet message. Does not implicitly {@link google.cloud.compute.v1.WafExpressionSet.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.WafExpressionSet
                         * @static
                         * @param {google.cloud.compute.v1.IWafExpressionSet} message WafExpressionSet message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WafExpressionSet.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.aliases != null && message.aliases.length)
                                for (var i = 0; i < message.aliases.length; ++i)
                                    writer.uint32(/* id 159207166, wireType 2 =*/1273657330).string(message.aliases[i]);
                            if (message.expressions != null && message.expressions.length)
                                for (var i = 0; i < message.expressions.length; ++i)
                                    $root.google.cloud.compute.v1.WafExpressionSetExpression.encode(message.expressions[i], writer.uint32(/* id 175554779, wireType 2 =*/1404438234).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified WafExpressionSet message, length delimited. Does not implicitly {@link google.cloud.compute.v1.WafExpressionSet.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.WafExpressionSet
                         * @static
                         * @param {google.cloud.compute.v1.IWafExpressionSet} message WafExpressionSet message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WafExpressionSet.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a WafExpressionSet message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.WafExpressionSet
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.WafExpressionSet} WafExpressionSet
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WafExpressionSet.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.WafExpressionSet();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 159207166: {
                                        if (!(message.aliases && message.aliases.length))
                                            message.aliases = [];
                                        message.aliases.push(reader.string());
                                        break;
                                    }
                                case 175554779: {
                                        if (!(message.expressions && message.expressions.length))
                                            message.expressions = [];
                                        message.expressions.push($root.google.cloud.compute.v1.WafExpressionSetExpression.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a WafExpressionSet message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.WafExpressionSet
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.WafExpressionSet} WafExpressionSet
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WafExpressionSet.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a WafExpressionSet message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.WafExpressionSet
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        WafExpressionSet.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.aliases != null && message.hasOwnProperty("aliases")) {
                                if (!Array.isArray(message.aliases))
                                    return "aliases: array expected";
                                for (var i = 0; i < message.aliases.length; ++i)
                                    if (!$util.isString(message.aliases[i]))
                                        return "aliases: string[] expected";
                            }
                            if (message.expressions != null && message.hasOwnProperty("expressions")) {
                                if (!Array.isArray(message.expressions))
                                    return "expressions: array expected";
                                for (var i = 0; i < message.expressions.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.WafExpressionSetExpression.verify(message.expressions[i]);
                                    if (error)
                                        return "expressions." + error;
                                }
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a WafExpressionSet message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.WafExpressionSet
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.WafExpressionSet} WafExpressionSet
                         */
                        WafExpressionSet.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.WafExpressionSet)
                                return object;
                            var message = new $root.google.cloud.compute.v1.WafExpressionSet();
                            if (object.aliases) {
                                if (!Array.isArray(object.aliases))
                                    throw TypeError(".google.cloud.compute.v1.WafExpressionSet.aliases: array expected");
                                message.aliases = [];
                                for (var i = 0; i < object.aliases.length; ++i)
                                    message.aliases[i] = String(object.aliases[i]);
                            }
                            if (object.expressions) {
                                if (!Array.isArray(object.expressions))
                                    throw TypeError(".google.cloud.compute.v1.WafExpressionSet.expressions: array expected");
                                message.expressions = [];
                                for (var i = 0; i < object.expressions.length; ++i) {
                                    if (typeof object.expressions[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.WafExpressionSet.expressions: object expected");
                                    message.expressions[i] = $root.google.cloud.compute.v1.WafExpressionSetExpression.fromObject(object.expressions[i]);
                                }
                            }
                            if (object.id != null)
                                message.id = String(object.id);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a WafExpressionSet message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.WafExpressionSet
                         * @static
                         * @param {google.cloud.compute.v1.WafExpressionSet} message WafExpressionSet
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        WafExpressionSet.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults) {
                                object.aliases = [];
                                object.expressions = [];
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.aliases && message.aliases.length) {
                                object.aliases = [];
                                for (var j = 0; j < message.aliases.length; ++j)
                                    object.aliases[j] = message.aliases[j];
                            }
                            if (message.expressions && message.expressions.length) {
                                object.expressions = [];
                                for (var j = 0; j < message.expressions.length; ++j)
                                    object.expressions[j] = $root.google.cloud.compute.v1.WafExpressionSetExpression.toObject(message.expressions[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this WafExpressionSet to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.WafExpressionSet
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        WafExpressionSet.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for WafExpressionSet
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.WafExpressionSet
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        WafExpressionSet.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.WafExpressionSet";
                        };
    
                        return WafExpressionSet;
                    })();
    
                    v1.WafExpressionSetExpression = (function() {
    
                        /**
                         * Properties of a WafExpressionSetExpression.
                         * @memberof google.cloud.compute.v1
                         * @interface IWafExpressionSetExpression
                         * @property {string|null} [id] WafExpressionSetExpression id
                         */
    
                        /**
                         * Constructs a new WafExpressionSetExpression.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a WafExpressionSetExpression.
                         * @implements IWafExpressionSetExpression
                         * @constructor
                         * @param {google.cloud.compute.v1.IWafExpressionSetExpression=} [properties] Properties to set
                         */
                        function WafExpressionSetExpression(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * WafExpressionSetExpression id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.WafExpressionSetExpression
                         * @instance
                         */
                        WafExpressionSetExpression.prototype.id = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * WafExpressionSetExpression _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.WafExpressionSetExpression
                         * @instance
                         */
                        Object.defineProperty(WafExpressionSetExpression.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new WafExpressionSetExpression instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.WafExpressionSetExpression
                         * @static
                         * @param {google.cloud.compute.v1.IWafExpressionSetExpression=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.WafExpressionSetExpression} WafExpressionSetExpression instance
                         */
                        WafExpressionSetExpression.create = function create(properties) {
                            return new WafExpressionSetExpression(properties);
                        };
    
                        /**
                         * Encodes the specified WafExpressionSetExpression message. Does not implicitly {@link google.cloud.compute.v1.WafExpressionSetExpression.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.WafExpressionSetExpression
                         * @static
                         * @param {google.cloud.compute.v1.IWafExpressionSetExpression} message WafExpressionSetExpression message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WafExpressionSetExpression.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified WafExpressionSetExpression message, length delimited. Does not implicitly {@link google.cloud.compute.v1.WafExpressionSetExpression.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.WafExpressionSetExpression
                         * @static
                         * @param {google.cloud.compute.v1.IWafExpressionSetExpression} message WafExpressionSetExpression message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WafExpressionSetExpression.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a WafExpressionSetExpression message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.WafExpressionSetExpression
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.WafExpressionSetExpression} WafExpressionSetExpression
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WafExpressionSetExpression.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.WafExpressionSetExpression();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a WafExpressionSetExpression message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.WafExpressionSetExpression
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.WafExpressionSetExpression} WafExpressionSetExpression
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WafExpressionSetExpression.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a WafExpressionSetExpression message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.WafExpressionSetExpression
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        WafExpressionSetExpression.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a WafExpressionSetExpression message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.WafExpressionSetExpression
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.WafExpressionSetExpression} WafExpressionSetExpression
                         */
                        WafExpressionSetExpression.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.WafExpressionSetExpression)
                                return object;
                            var message = new $root.google.cloud.compute.v1.WafExpressionSetExpression();
                            if (object.id != null)
                                message.id = String(object.id);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a WafExpressionSetExpression message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.WafExpressionSetExpression
                         * @static
                         * @param {google.cloud.compute.v1.WafExpressionSetExpression} message WafExpressionSetExpression
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        WafExpressionSetExpression.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this WafExpressionSetExpression to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.WafExpressionSetExpression
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        WafExpressionSetExpression.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for WafExpressionSetExpression
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.WafExpressionSetExpression
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        WafExpressionSetExpression.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.WafExpressionSetExpression";
                        };
    
                        return WafExpressionSetExpression;
                    })();
    
                    v1.WaitGlobalOperationRequest = (function() {
    
                        /**
                         * Properties of a WaitGlobalOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IWaitGlobalOperationRequest
                         * @property {string|null} [operation] WaitGlobalOperationRequest operation
                         * @property {string|null} [project] WaitGlobalOperationRequest project
                         */
    
                        /**
                         * Constructs a new WaitGlobalOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a WaitGlobalOperationRequest.
                         * @implements IWaitGlobalOperationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IWaitGlobalOperationRequest=} [properties] Properties to set
                         */
                        function WaitGlobalOperationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * WaitGlobalOperationRequest operation.
                         * @member {string} operation
                         * @memberof google.cloud.compute.v1.WaitGlobalOperationRequest
                         * @instance
                         */
                        WaitGlobalOperationRequest.prototype.operation = "";
    
                        /**
                         * WaitGlobalOperationRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.WaitGlobalOperationRequest
                         * @instance
                         */
                        WaitGlobalOperationRequest.prototype.project = "";
    
                        /**
                         * Creates a new WaitGlobalOperationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.WaitGlobalOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IWaitGlobalOperationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.WaitGlobalOperationRequest} WaitGlobalOperationRequest instance
                         */
                        WaitGlobalOperationRequest.create = function create(properties) {
                            return new WaitGlobalOperationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified WaitGlobalOperationRequest message. Does not implicitly {@link google.cloud.compute.v1.WaitGlobalOperationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.WaitGlobalOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IWaitGlobalOperationRequest} message WaitGlobalOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WaitGlobalOperationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operation != null && Object.hasOwnProperty.call(message, "operation"))
                                writer.uint32(/* id 52090215, wireType 2 =*/416721722).string(message.operation);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified WaitGlobalOperationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.WaitGlobalOperationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.WaitGlobalOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IWaitGlobalOperationRequest} message WaitGlobalOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WaitGlobalOperationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a WaitGlobalOperationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.WaitGlobalOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.WaitGlobalOperationRequest} WaitGlobalOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WaitGlobalOperationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.WaitGlobalOperationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 52090215: {
                                        message.operation = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a WaitGlobalOperationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.WaitGlobalOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.WaitGlobalOperationRequest} WaitGlobalOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WaitGlobalOperationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a WaitGlobalOperationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.WaitGlobalOperationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        WaitGlobalOperationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                if (!$util.isString(message.operation))
                                    return "operation: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a WaitGlobalOperationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.WaitGlobalOperationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.WaitGlobalOperationRequest} WaitGlobalOperationRequest
                         */
                        WaitGlobalOperationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.WaitGlobalOperationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.WaitGlobalOperationRequest();
                            if (object.operation != null)
                                message.operation = String(object.operation);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a WaitGlobalOperationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.WaitGlobalOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.WaitGlobalOperationRequest} message WaitGlobalOperationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        WaitGlobalOperationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.operation = "";
                                object.project = "";
                            }
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                object.operation = message.operation;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this WaitGlobalOperationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.WaitGlobalOperationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        WaitGlobalOperationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for WaitGlobalOperationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.WaitGlobalOperationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        WaitGlobalOperationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.WaitGlobalOperationRequest";
                        };
    
                        return WaitGlobalOperationRequest;
                    })();
    
                    v1.WaitRegionOperationRequest = (function() {
    
                        /**
                         * Properties of a WaitRegionOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IWaitRegionOperationRequest
                         * @property {string|null} [operation] WaitRegionOperationRequest operation
                         * @property {string|null} [project] WaitRegionOperationRequest project
                         * @property {string|null} [region] WaitRegionOperationRequest region
                         */
    
                        /**
                         * Constructs a new WaitRegionOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a WaitRegionOperationRequest.
                         * @implements IWaitRegionOperationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IWaitRegionOperationRequest=} [properties] Properties to set
                         */
                        function WaitRegionOperationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * WaitRegionOperationRequest operation.
                         * @member {string} operation
                         * @memberof google.cloud.compute.v1.WaitRegionOperationRequest
                         * @instance
                         */
                        WaitRegionOperationRequest.prototype.operation = "";
    
                        /**
                         * WaitRegionOperationRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.WaitRegionOperationRequest
                         * @instance
                         */
                        WaitRegionOperationRequest.prototype.project = "";
    
                        /**
                         * WaitRegionOperationRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1.WaitRegionOperationRequest
                         * @instance
                         */
                        WaitRegionOperationRequest.prototype.region = "";
    
                        /**
                         * Creates a new WaitRegionOperationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.WaitRegionOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IWaitRegionOperationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.WaitRegionOperationRequest} WaitRegionOperationRequest instance
                         */
                        WaitRegionOperationRequest.create = function create(properties) {
                            return new WaitRegionOperationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified WaitRegionOperationRequest message. Does not implicitly {@link google.cloud.compute.v1.WaitRegionOperationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.WaitRegionOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IWaitRegionOperationRequest} message WaitRegionOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WaitRegionOperationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operation != null && Object.hasOwnProperty.call(message, "operation"))
                                writer.uint32(/* id 52090215, wireType 2 =*/416721722).string(message.operation);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified WaitRegionOperationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.WaitRegionOperationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.WaitRegionOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IWaitRegionOperationRequest} message WaitRegionOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WaitRegionOperationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a WaitRegionOperationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.WaitRegionOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.WaitRegionOperationRequest} WaitRegionOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WaitRegionOperationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.WaitRegionOperationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 52090215: {
                                        message.operation = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a WaitRegionOperationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.WaitRegionOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.WaitRegionOperationRequest} WaitRegionOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WaitRegionOperationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a WaitRegionOperationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.WaitRegionOperationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        WaitRegionOperationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                if (!$util.isString(message.operation))
                                    return "operation: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a WaitRegionOperationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.WaitRegionOperationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.WaitRegionOperationRequest} WaitRegionOperationRequest
                         */
                        WaitRegionOperationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.WaitRegionOperationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.WaitRegionOperationRequest();
                            if (object.operation != null)
                                message.operation = String(object.operation);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a WaitRegionOperationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.WaitRegionOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.WaitRegionOperationRequest} message WaitRegionOperationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        WaitRegionOperationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.operation = "";
                                object.region = "";
                                object.project = "";
                            }
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                object.operation = message.operation;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this WaitRegionOperationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.WaitRegionOperationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        WaitRegionOperationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for WaitRegionOperationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.WaitRegionOperationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        WaitRegionOperationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.WaitRegionOperationRequest";
                        };
    
                        return WaitRegionOperationRequest;
                    })();
    
                    v1.WaitZoneOperationRequest = (function() {
    
                        /**
                         * Properties of a WaitZoneOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IWaitZoneOperationRequest
                         * @property {string|null} [operation] WaitZoneOperationRequest operation
                         * @property {string|null} [project] WaitZoneOperationRequest project
                         * @property {string|null} [zone] WaitZoneOperationRequest zone
                         */
    
                        /**
                         * Constructs a new WaitZoneOperationRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a WaitZoneOperationRequest.
                         * @implements IWaitZoneOperationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IWaitZoneOperationRequest=} [properties] Properties to set
                         */
                        function WaitZoneOperationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * WaitZoneOperationRequest operation.
                         * @member {string} operation
                         * @memberof google.cloud.compute.v1.WaitZoneOperationRequest
                         * @instance
                         */
                        WaitZoneOperationRequest.prototype.operation = "";
    
                        /**
                         * WaitZoneOperationRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1.WaitZoneOperationRequest
                         * @instance
                         */
                        WaitZoneOperationRequest.prototype.project = "";
    
                        /**
                         * WaitZoneOperationRequest zone.
                         * @member {string} zone
                         * @memberof google.cloud.compute.v1.WaitZoneOperationRequest
                         * @instance
                         */
                        WaitZoneOperationRequest.prototype.zone = "";
    
                        /**
                         * Creates a new WaitZoneOperationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.WaitZoneOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IWaitZoneOperationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.WaitZoneOperationRequest} WaitZoneOperationRequest instance
                         */
                        WaitZoneOperationRequest.create = function create(properties) {
                            return new WaitZoneOperationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified WaitZoneOperationRequest message. Does not implicitly {@link google.cloud.compute.v1.WaitZoneOperationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.WaitZoneOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IWaitZoneOperationRequest} message WaitZoneOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WaitZoneOperationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.operation != null && Object.hasOwnProperty.call(message, "operation"))
                                writer.uint32(/* id 52090215, wireType 2 =*/416721722).string(message.operation);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified WaitZoneOperationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.WaitZoneOperationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.WaitZoneOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.IWaitZoneOperationRequest} message WaitZoneOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WaitZoneOperationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a WaitZoneOperationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.WaitZoneOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.WaitZoneOperationRequest} WaitZoneOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WaitZoneOperationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.WaitZoneOperationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 52090215: {
                                        message.operation = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a WaitZoneOperationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.WaitZoneOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.WaitZoneOperationRequest} WaitZoneOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WaitZoneOperationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a WaitZoneOperationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.WaitZoneOperationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        WaitZoneOperationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                if (!$util.isString(message.operation))
                                    return "operation: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a WaitZoneOperationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.WaitZoneOperationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.WaitZoneOperationRequest} WaitZoneOperationRequest
                         */
                        WaitZoneOperationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.WaitZoneOperationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.WaitZoneOperationRequest();
                            if (object.operation != null)
                                message.operation = String(object.operation);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a WaitZoneOperationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.WaitZoneOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1.WaitZoneOperationRequest} message WaitZoneOperationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        WaitZoneOperationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.zone = "";
                                object.operation = "";
                                object.project = "";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone"))
                                object.zone = message.zone;
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                object.operation = message.operation;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this WaitZoneOperationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.WaitZoneOperationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        WaitZoneOperationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for WaitZoneOperationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.WaitZoneOperationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        WaitZoneOperationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.WaitZoneOperationRequest";
                        };
    
                        return WaitZoneOperationRequest;
                    })();
    
                    v1.Warning = (function() {
    
                        /**
                         * Properties of a Warning.
                         * @memberof google.cloud.compute.v1
                         * @interface IWarning
                         * @property {string|null} [code] Warning code
                         * @property {Array.<google.cloud.compute.v1.IData>|null} [data] Warning data
                         * @property {string|null} [message] Warning message
                         */
    
                        /**
                         * Constructs a new Warning.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Warning.
                         * @implements IWarning
                         * @constructor
                         * @param {google.cloud.compute.v1.IWarning=} [properties] Properties to set
                         */
                        function Warning(properties) {
                            this.data = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Warning code.
                         * @member {string|null|undefined} code
                         * @memberof google.cloud.compute.v1.Warning
                         * @instance
                         */
                        Warning.prototype.code = null;
    
                        /**
                         * Warning data.
                         * @member {Array.<google.cloud.compute.v1.IData>} data
                         * @memberof google.cloud.compute.v1.Warning
                         * @instance
                         */
                        Warning.prototype.data = $util.emptyArray;
    
                        /**
                         * Warning message.
                         * @member {string|null|undefined} message
                         * @memberof google.cloud.compute.v1.Warning
                         * @instance
                         */
                        Warning.prototype.message = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Warning _code.
                         * @member {"code"|undefined} _code
                         * @memberof google.cloud.compute.v1.Warning
                         * @instance
                         */
                        Object.defineProperty(Warning.prototype, "_code", {
                            get: $util.oneOfGetter($oneOfFields = ["code"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Warning _message.
                         * @member {"message"|undefined} _message
                         * @memberof google.cloud.compute.v1.Warning
                         * @instance
                         */
                        Object.defineProperty(Warning.prototype, "_message", {
                            get: $util.oneOfGetter($oneOfFields = ["message"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Warning instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Warning
                         * @static
                         * @param {google.cloud.compute.v1.IWarning=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Warning} Warning instance
                         */
                        Warning.create = function create(properties) {
                            return new Warning(properties);
                        };
    
                        /**
                         * Encodes the specified Warning message. Does not implicitly {@link google.cloud.compute.v1.Warning.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Warning
                         * @static
                         * @param {google.cloud.compute.v1.IWarning} message Warning message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Warning.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.code != null && Object.hasOwnProperty.call(message, "code"))
                                writer.uint32(/* id 3059181, wireType 2 =*/24473450).string(message.code);
                            if (message.data != null && message.data.length)
                                for (var i = 0; i < message.data.length; ++i)
                                    $root.google.cloud.compute.v1.Data.encode(message.data[i], writer.uint32(/* id 3076010, wireType 2 =*/24608082).fork()).ldelim();
                            if (message.message != null && Object.hasOwnProperty.call(message, "message"))
                                writer.uint32(/* id 418054151, wireType 2 =*/3344433210).string(message.message);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Warning message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Warning.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Warning
                         * @static
                         * @param {google.cloud.compute.v1.IWarning} message Warning message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Warning.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Warning message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Warning
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Warning} Warning
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Warning.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Warning();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3059181: {
                                        message.code = reader.string();
                                        break;
                                    }
                                case 3076010: {
                                        if (!(message.data && message.data.length))
                                            message.data = [];
                                        message.data.push($root.google.cloud.compute.v1.Data.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 418054151: {
                                        message.message = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Warning message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Warning
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Warning} Warning
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Warning.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Warning message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Warning
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Warning.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.code != null && message.hasOwnProperty("code")) {
                                properties._code = 1;
                                if (!$util.isString(message.code))
                                    return "code: string expected";
                            }
                            if (message.data != null && message.hasOwnProperty("data")) {
                                if (!Array.isArray(message.data))
                                    return "data: array expected";
                                for (var i = 0; i < message.data.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Data.verify(message.data[i]);
                                    if (error)
                                        return "data." + error;
                                }
                            }
                            if (message.message != null && message.hasOwnProperty("message")) {
                                properties._message = 1;
                                if (!$util.isString(message.message))
                                    return "message: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Warning message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Warning
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Warning} Warning
                         */
                        Warning.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Warning)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Warning();
                            if (object.code != null)
                                message.code = String(object.code);
                            if (object.data) {
                                if (!Array.isArray(object.data))
                                    throw TypeError(".google.cloud.compute.v1.Warning.data: array expected");
                                message.data = [];
                                for (var i = 0; i < object.data.length; ++i) {
                                    if (typeof object.data[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Warning.data: object expected");
                                    message.data[i] = $root.google.cloud.compute.v1.Data.fromObject(object.data[i]);
                                }
                            }
                            if (object.message != null)
                                message.message = String(object.message);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Warning message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Warning
                         * @static
                         * @param {google.cloud.compute.v1.Warning} message Warning
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Warning.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.data = [];
                            if (message.code != null && message.hasOwnProperty("code")) {
                                object.code = message.code;
                                if (options.oneofs)
                                    object._code = "code";
                            }
                            if (message.data && message.data.length) {
                                object.data = [];
                                for (var j = 0; j < message.data.length; ++j)
                                    object.data[j] = $root.google.cloud.compute.v1.Data.toObject(message.data[j], options);
                            }
                            if (message.message != null && message.hasOwnProperty("message")) {
                                object.message = message.message;
                                if (options.oneofs)
                                    object._message = "message";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Warning to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Warning
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Warning.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Warning
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Warning
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Warning.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Warning";
                        };
    
                        /**
                         * Code enum.
                         * @name google.cloud.compute.v1.Warning.Code
                         * @enum {number}
                         * @property {number} UNDEFINED_CODE=0 UNDEFINED_CODE value
                         * @property {number} CLEANUP_FAILED=150308440 CLEANUP_FAILED value
                         * @property {number} DEPRECATED_RESOURCE_USED=391835586 DEPRECATED_RESOURCE_USED value
                         * @property {number} DEPRECATED_TYPE_USED=346526230 DEPRECATED_TYPE_USED value
                         * @property {number} DISK_SIZE_LARGER_THAN_IMAGE_SIZE=369442967 DISK_SIZE_LARGER_THAN_IMAGE_SIZE value
                         * @property {number} EXPERIMENTAL_TYPE_USED=451954443 EXPERIMENTAL_TYPE_USED value
                         * @property {number} EXTERNAL_API_WARNING=175546307 EXTERNAL_API_WARNING value
                         * @property {number} FIELD_VALUE_OVERRIDEN=329669423 FIELD_VALUE_OVERRIDEN value
                         * @property {number} INJECTED_KERNELS_DEPRECATED=417377419 INJECTED_KERNELS_DEPRECATED value
                         * @property {number} INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB=401542606 INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB value
                         * @property {number} LARGE_DEPLOYMENT_WARNING=481440678 LARGE_DEPLOYMENT_WARNING value
                         * @property {number} MISSING_TYPE_DEPENDENCY=344505463 MISSING_TYPE_DEPENDENCY value
                         * @property {number} NEXT_HOP_ADDRESS_NOT_ASSIGNED=324964999 NEXT_HOP_ADDRESS_NOT_ASSIGNED value
                         * @property {number} NEXT_HOP_CANNOT_IP_FORWARD=383382887 NEXT_HOP_CANNOT_IP_FORWARD value
                         * @property {number} NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE=146748434 NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE value
                         * @property {number} NEXT_HOP_INSTANCE_NOT_FOUND=464250446 NEXT_HOP_INSTANCE_NOT_FOUND value
                         * @property {number} NEXT_HOP_INSTANCE_NOT_ON_NETWORK=243758146 NEXT_HOP_INSTANCE_NOT_ON_NETWORK value
                         * @property {number} NEXT_HOP_NOT_RUNNING=417081265 NEXT_HOP_NOT_RUNNING value
                         * @property {number} NOT_CRITICAL_ERROR=105763924 NOT_CRITICAL_ERROR value
                         * @property {number} NO_RESULTS_ON_PAGE=30036744 NO_RESULTS_ON_PAGE value
                         * @property {number} PARTIAL_SUCCESS=39966469 PARTIAL_SUCCESS value
                         * @property {number} REQUIRED_TOS_AGREEMENT=3745539 REQUIRED_TOS_AGREEMENT value
                         * @property {number} RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING=496728641 RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING value
                         * @property {number} RESOURCE_NOT_DELETED=168598460 RESOURCE_NOT_DELETED value
                         * @property {number} SCHEMA_VALIDATION_IGNORED=275245642 SCHEMA_VALIDATION_IGNORED value
                         * @property {number} SINGLE_INSTANCE_PROPERTY_TEMPLATE=268305617 SINGLE_INSTANCE_PROPERTY_TEMPLATE value
                         * @property {number} UNDECLARED_PROPERTIES=390513439 UNDECLARED_PROPERTIES value
                         * @property {number} UNREACHABLE=13328052 UNREACHABLE value
                         */
                        Warning.Code = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_CODE"] = 0;
                            values[valuesById[150308440] = "CLEANUP_FAILED"] = 150308440;
                            values[valuesById[391835586] = "DEPRECATED_RESOURCE_USED"] = 391835586;
                            values[valuesById[346526230] = "DEPRECATED_TYPE_USED"] = 346526230;
                            values[valuesById[369442967] = "DISK_SIZE_LARGER_THAN_IMAGE_SIZE"] = 369442967;
                            values[valuesById[451954443] = "EXPERIMENTAL_TYPE_USED"] = 451954443;
                            values[valuesById[175546307] = "EXTERNAL_API_WARNING"] = 175546307;
                            values[valuesById[329669423] = "FIELD_VALUE_OVERRIDEN"] = 329669423;
                            values[valuesById[417377419] = "INJECTED_KERNELS_DEPRECATED"] = 417377419;
                            values[valuesById[401542606] = "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB"] = 401542606;
                            values[valuesById[481440678] = "LARGE_DEPLOYMENT_WARNING"] = 481440678;
                            values[valuesById[344505463] = "MISSING_TYPE_DEPENDENCY"] = 344505463;
                            values[valuesById[324964999] = "NEXT_HOP_ADDRESS_NOT_ASSIGNED"] = 324964999;
                            values[valuesById[383382887] = "NEXT_HOP_CANNOT_IP_FORWARD"] = 383382887;
                            values[valuesById[146748434] = "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE"] = 146748434;
                            values[valuesById[464250446] = "NEXT_HOP_INSTANCE_NOT_FOUND"] = 464250446;
                            values[valuesById[243758146] = "NEXT_HOP_INSTANCE_NOT_ON_NETWORK"] = 243758146;
                            values[valuesById[417081265] = "NEXT_HOP_NOT_RUNNING"] = 417081265;
                            values[valuesById[105763924] = "NOT_CRITICAL_ERROR"] = 105763924;
                            values[valuesById[30036744] = "NO_RESULTS_ON_PAGE"] = 30036744;
                            values[valuesById[39966469] = "PARTIAL_SUCCESS"] = 39966469;
                            values[valuesById[3745539] = "REQUIRED_TOS_AGREEMENT"] = 3745539;
                            values[valuesById[496728641] = "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING"] = 496728641;
                            values[valuesById[168598460] = "RESOURCE_NOT_DELETED"] = 168598460;
                            values[valuesById[275245642] = "SCHEMA_VALIDATION_IGNORED"] = 275245642;
                            values[valuesById[268305617] = "SINGLE_INSTANCE_PROPERTY_TEMPLATE"] = 268305617;
                            values[valuesById[390513439] = "UNDECLARED_PROPERTIES"] = 390513439;
                            values[valuesById[13328052] = "UNREACHABLE"] = 13328052;
                            return values;
                        })();
    
                        return Warning;
                    })();
    
                    v1.Warnings = (function() {
    
                        /**
                         * Properties of a Warnings.
                         * @memberof google.cloud.compute.v1
                         * @interface IWarnings
                         * @property {string|null} [code] Warnings code
                         * @property {Array.<google.cloud.compute.v1.IData>|null} [data] Warnings data
                         * @property {string|null} [message] Warnings message
                         */
    
                        /**
                         * Constructs a new Warnings.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Warnings.
                         * @implements IWarnings
                         * @constructor
                         * @param {google.cloud.compute.v1.IWarnings=} [properties] Properties to set
                         */
                        function Warnings(properties) {
                            this.data = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Warnings code.
                         * @member {string|null|undefined} code
                         * @memberof google.cloud.compute.v1.Warnings
                         * @instance
                         */
                        Warnings.prototype.code = null;
    
                        /**
                         * Warnings data.
                         * @member {Array.<google.cloud.compute.v1.IData>} data
                         * @memberof google.cloud.compute.v1.Warnings
                         * @instance
                         */
                        Warnings.prototype.data = $util.emptyArray;
    
                        /**
                         * Warnings message.
                         * @member {string|null|undefined} message
                         * @memberof google.cloud.compute.v1.Warnings
                         * @instance
                         */
                        Warnings.prototype.message = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Warnings _code.
                         * @member {"code"|undefined} _code
                         * @memberof google.cloud.compute.v1.Warnings
                         * @instance
                         */
                        Object.defineProperty(Warnings.prototype, "_code", {
                            get: $util.oneOfGetter($oneOfFields = ["code"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Warnings _message.
                         * @member {"message"|undefined} _message
                         * @memberof google.cloud.compute.v1.Warnings
                         * @instance
                         */
                        Object.defineProperty(Warnings.prototype, "_message", {
                            get: $util.oneOfGetter($oneOfFields = ["message"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Warnings instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Warnings
                         * @static
                         * @param {google.cloud.compute.v1.IWarnings=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Warnings} Warnings instance
                         */
                        Warnings.create = function create(properties) {
                            return new Warnings(properties);
                        };
    
                        /**
                         * Encodes the specified Warnings message. Does not implicitly {@link google.cloud.compute.v1.Warnings.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Warnings
                         * @static
                         * @param {google.cloud.compute.v1.IWarnings} message Warnings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Warnings.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.code != null && Object.hasOwnProperty.call(message, "code"))
                                writer.uint32(/* id 3059181, wireType 2 =*/24473450).string(message.code);
                            if (message.data != null && message.data.length)
                                for (var i = 0; i < message.data.length; ++i)
                                    $root.google.cloud.compute.v1.Data.encode(message.data[i], writer.uint32(/* id 3076010, wireType 2 =*/24608082).fork()).ldelim();
                            if (message.message != null && Object.hasOwnProperty.call(message, "message"))
                                writer.uint32(/* id 418054151, wireType 2 =*/3344433210).string(message.message);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Warnings message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Warnings.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Warnings
                         * @static
                         * @param {google.cloud.compute.v1.IWarnings} message Warnings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Warnings.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Warnings message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Warnings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Warnings} Warnings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Warnings.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Warnings();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3059181: {
                                        message.code = reader.string();
                                        break;
                                    }
                                case 3076010: {
                                        if (!(message.data && message.data.length))
                                            message.data = [];
                                        message.data.push($root.google.cloud.compute.v1.Data.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 418054151: {
                                        message.message = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Warnings message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Warnings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Warnings} Warnings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Warnings.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Warnings message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Warnings
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Warnings.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.code != null && message.hasOwnProperty("code")) {
                                properties._code = 1;
                                if (!$util.isString(message.code))
                                    return "code: string expected";
                            }
                            if (message.data != null && message.hasOwnProperty("data")) {
                                if (!Array.isArray(message.data))
                                    return "data: array expected";
                                for (var i = 0; i < message.data.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Data.verify(message.data[i]);
                                    if (error)
                                        return "data." + error;
                                }
                            }
                            if (message.message != null && message.hasOwnProperty("message")) {
                                properties._message = 1;
                                if (!$util.isString(message.message))
                                    return "message: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Warnings message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Warnings
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Warnings} Warnings
                         */
                        Warnings.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Warnings)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Warnings();
                            if (object.code != null)
                                message.code = String(object.code);
                            if (object.data) {
                                if (!Array.isArray(object.data))
                                    throw TypeError(".google.cloud.compute.v1.Warnings.data: array expected");
                                message.data = [];
                                for (var i = 0; i < object.data.length; ++i) {
                                    if (typeof object.data[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.Warnings.data: object expected");
                                    message.data[i] = $root.google.cloud.compute.v1.Data.fromObject(object.data[i]);
                                }
                            }
                            if (object.message != null)
                                message.message = String(object.message);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Warnings message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Warnings
                         * @static
                         * @param {google.cloud.compute.v1.Warnings} message Warnings
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Warnings.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.data = [];
                            if (message.code != null && message.hasOwnProperty("code")) {
                                object.code = message.code;
                                if (options.oneofs)
                                    object._code = "code";
                            }
                            if (message.data && message.data.length) {
                                object.data = [];
                                for (var j = 0; j < message.data.length; ++j)
                                    object.data[j] = $root.google.cloud.compute.v1.Data.toObject(message.data[j], options);
                            }
                            if (message.message != null && message.hasOwnProperty("message")) {
                                object.message = message.message;
                                if (options.oneofs)
                                    object._message = "message";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Warnings to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Warnings
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Warnings.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Warnings
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Warnings
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Warnings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Warnings";
                        };
    
                        /**
                         * Code enum.
                         * @name google.cloud.compute.v1.Warnings.Code
                         * @enum {number}
                         * @property {number} UNDEFINED_CODE=0 UNDEFINED_CODE value
                         * @property {number} CLEANUP_FAILED=150308440 CLEANUP_FAILED value
                         * @property {number} DEPRECATED_RESOURCE_USED=391835586 DEPRECATED_RESOURCE_USED value
                         * @property {number} DEPRECATED_TYPE_USED=346526230 DEPRECATED_TYPE_USED value
                         * @property {number} DISK_SIZE_LARGER_THAN_IMAGE_SIZE=369442967 DISK_SIZE_LARGER_THAN_IMAGE_SIZE value
                         * @property {number} EXPERIMENTAL_TYPE_USED=451954443 EXPERIMENTAL_TYPE_USED value
                         * @property {number} EXTERNAL_API_WARNING=175546307 EXTERNAL_API_WARNING value
                         * @property {number} FIELD_VALUE_OVERRIDEN=329669423 FIELD_VALUE_OVERRIDEN value
                         * @property {number} INJECTED_KERNELS_DEPRECATED=417377419 INJECTED_KERNELS_DEPRECATED value
                         * @property {number} INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB=401542606 INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB value
                         * @property {number} LARGE_DEPLOYMENT_WARNING=481440678 LARGE_DEPLOYMENT_WARNING value
                         * @property {number} MISSING_TYPE_DEPENDENCY=344505463 MISSING_TYPE_DEPENDENCY value
                         * @property {number} NEXT_HOP_ADDRESS_NOT_ASSIGNED=324964999 NEXT_HOP_ADDRESS_NOT_ASSIGNED value
                         * @property {number} NEXT_HOP_CANNOT_IP_FORWARD=383382887 NEXT_HOP_CANNOT_IP_FORWARD value
                         * @property {number} NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE=146748434 NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE value
                         * @property {number} NEXT_HOP_INSTANCE_NOT_FOUND=464250446 NEXT_HOP_INSTANCE_NOT_FOUND value
                         * @property {number} NEXT_HOP_INSTANCE_NOT_ON_NETWORK=243758146 NEXT_HOP_INSTANCE_NOT_ON_NETWORK value
                         * @property {number} NEXT_HOP_NOT_RUNNING=417081265 NEXT_HOP_NOT_RUNNING value
                         * @property {number} NOT_CRITICAL_ERROR=105763924 NOT_CRITICAL_ERROR value
                         * @property {number} NO_RESULTS_ON_PAGE=30036744 NO_RESULTS_ON_PAGE value
                         * @property {number} PARTIAL_SUCCESS=39966469 PARTIAL_SUCCESS value
                         * @property {number} REQUIRED_TOS_AGREEMENT=3745539 REQUIRED_TOS_AGREEMENT value
                         * @property {number} RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING=496728641 RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING value
                         * @property {number} RESOURCE_NOT_DELETED=168598460 RESOURCE_NOT_DELETED value
                         * @property {number} SCHEMA_VALIDATION_IGNORED=275245642 SCHEMA_VALIDATION_IGNORED value
                         * @property {number} SINGLE_INSTANCE_PROPERTY_TEMPLATE=268305617 SINGLE_INSTANCE_PROPERTY_TEMPLATE value
                         * @property {number} UNDECLARED_PROPERTIES=390513439 UNDECLARED_PROPERTIES value
                         * @property {number} UNREACHABLE=13328052 UNREACHABLE value
                         */
                        Warnings.Code = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_CODE"] = 0;
                            values[valuesById[150308440] = "CLEANUP_FAILED"] = 150308440;
                            values[valuesById[391835586] = "DEPRECATED_RESOURCE_USED"] = 391835586;
                            values[valuesById[346526230] = "DEPRECATED_TYPE_USED"] = 346526230;
                            values[valuesById[369442967] = "DISK_SIZE_LARGER_THAN_IMAGE_SIZE"] = 369442967;
                            values[valuesById[451954443] = "EXPERIMENTAL_TYPE_USED"] = 451954443;
                            values[valuesById[175546307] = "EXTERNAL_API_WARNING"] = 175546307;
                            values[valuesById[329669423] = "FIELD_VALUE_OVERRIDEN"] = 329669423;
                            values[valuesById[417377419] = "INJECTED_KERNELS_DEPRECATED"] = 417377419;
                            values[valuesById[401542606] = "INVALID_HEALTH_CHECK_FOR_DYNAMIC_WIEGHTED_LB"] = 401542606;
                            values[valuesById[481440678] = "LARGE_DEPLOYMENT_WARNING"] = 481440678;
                            values[valuesById[344505463] = "MISSING_TYPE_DEPENDENCY"] = 344505463;
                            values[valuesById[324964999] = "NEXT_HOP_ADDRESS_NOT_ASSIGNED"] = 324964999;
                            values[valuesById[383382887] = "NEXT_HOP_CANNOT_IP_FORWARD"] = 383382887;
                            values[valuesById[146748434] = "NEXT_HOP_INSTANCE_HAS_NO_IPV6_INTERFACE"] = 146748434;
                            values[valuesById[464250446] = "NEXT_HOP_INSTANCE_NOT_FOUND"] = 464250446;
                            values[valuesById[243758146] = "NEXT_HOP_INSTANCE_NOT_ON_NETWORK"] = 243758146;
                            values[valuesById[417081265] = "NEXT_HOP_NOT_RUNNING"] = 417081265;
                            values[valuesById[105763924] = "NOT_CRITICAL_ERROR"] = 105763924;
                            values[valuesById[30036744] = "NO_RESULTS_ON_PAGE"] = 30036744;
                            values[valuesById[39966469] = "PARTIAL_SUCCESS"] = 39966469;
                            values[valuesById[3745539] = "REQUIRED_TOS_AGREEMENT"] = 3745539;
                            values[valuesById[496728641] = "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING"] = 496728641;
                            values[valuesById[168598460] = "RESOURCE_NOT_DELETED"] = 168598460;
                            values[valuesById[275245642] = "SCHEMA_VALIDATION_IGNORED"] = 275245642;
                            values[valuesById[268305617] = "SINGLE_INSTANCE_PROPERTY_TEMPLATE"] = 268305617;
                            values[valuesById[390513439] = "UNDECLARED_PROPERTIES"] = 390513439;
                            values[valuesById[13328052] = "UNREACHABLE"] = 13328052;
                            return values;
                        })();
    
                        return Warnings;
                    })();
    
                    v1.WeightedBackendService = (function() {
    
                        /**
                         * Properties of a WeightedBackendService.
                         * @memberof google.cloud.compute.v1
                         * @interface IWeightedBackendService
                         * @property {string|null} [backendService] WeightedBackendService backendService
                         * @property {google.cloud.compute.v1.IHttpHeaderAction|null} [headerAction] WeightedBackendService headerAction
                         * @property {number|null} [weight] WeightedBackendService weight
                         */
    
                        /**
                         * Constructs a new WeightedBackendService.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a WeightedBackendService.
                         * @implements IWeightedBackendService
                         * @constructor
                         * @param {google.cloud.compute.v1.IWeightedBackendService=} [properties] Properties to set
                         */
                        function WeightedBackendService(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * WeightedBackendService backendService.
                         * @member {string|null|undefined} backendService
                         * @memberof google.cloud.compute.v1.WeightedBackendService
                         * @instance
                         */
                        WeightedBackendService.prototype.backendService = null;
    
                        /**
                         * WeightedBackendService headerAction.
                         * @member {google.cloud.compute.v1.IHttpHeaderAction|null|undefined} headerAction
                         * @memberof google.cloud.compute.v1.WeightedBackendService
                         * @instance
                         */
                        WeightedBackendService.prototype.headerAction = null;
    
                        /**
                         * WeightedBackendService weight.
                         * @member {number|null|undefined} weight
                         * @memberof google.cloud.compute.v1.WeightedBackendService
                         * @instance
                         */
                        WeightedBackendService.prototype.weight = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * WeightedBackendService _backendService.
                         * @member {"backendService"|undefined} _backendService
                         * @memberof google.cloud.compute.v1.WeightedBackendService
                         * @instance
                         */
                        Object.defineProperty(WeightedBackendService.prototype, "_backendService", {
                            get: $util.oneOfGetter($oneOfFields = ["backendService"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * WeightedBackendService _headerAction.
                         * @member {"headerAction"|undefined} _headerAction
                         * @memberof google.cloud.compute.v1.WeightedBackendService
                         * @instance
                         */
                        Object.defineProperty(WeightedBackendService.prototype, "_headerAction", {
                            get: $util.oneOfGetter($oneOfFields = ["headerAction"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * WeightedBackendService _weight.
                         * @member {"weight"|undefined} _weight
                         * @memberof google.cloud.compute.v1.WeightedBackendService
                         * @instance
                         */
                        Object.defineProperty(WeightedBackendService.prototype, "_weight", {
                            get: $util.oneOfGetter($oneOfFields = ["weight"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new WeightedBackendService instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.WeightedBackendService
                         * @static
                         * @param {google.cloud.compute.v1.IWeightedBackendService=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.WeightedBackendService} WeightedBackendService instance
                         */
                        WeightedBackendService.create = function create(properties) {
                            return new WeightedBackendService(properties);
                        };
    
                        /**
                         * Encodes the specified WeightedBackendService message. Does not implicitly {@link google.cloud.compute.v1.WeightedBackendService.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.WeightedBackendService
                         * @static
                         * @param {google.cloud.compute.v1.IWeightedBackendService} message WeightedBackendService message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WeightedBackendService.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.weight != null && Object.hasOwnProperty.call(message, "weight"))
                                writer.uint32(/* id 282149496, wireType 0 =*/2257195968).uint32(message.weight);
                            if (message.backendService != null && Object.hasOwnProperty.call(message, "backendService"))
                                writer.uint32(/* id 306946058, wireType 2 =*/2455568466).string(message.backendService);
                            if (message.headerAction != null && Object.hasOwnProperty.call(message, "headerAction"))
                                $root.google.cloud.compute.v1.HttpHeaderAction.encode(message.headerAction, writer.uint32(/* id 328077352, wireType 2 =*/2624618818).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified WeightedBackendService message, length delimited. Does not implicitly {@link google.cloud.compute.v1.WeightedBackendService.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.WeightedBackendService
                         * @static
                         * @param {google.cloud.compute.v1.IWeightedBackendService} message WeightedBackendService message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WeightedBackendService.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a WeightedBackendService message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.WeightedBackendService
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.WeightedBackendService} WeightedBackendService
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WeightedBackendService.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.WeightedBackendService();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 306946058: {
                                        message.backendService = reader.string();
                                        break;
                                    }
                                case 328077352: {
                                        message.headerAction = $root.google.cloud.compute.v1.HttpHeaderAction.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 282149496: {
                                        message.weight = reader.uint32();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a WeightedBackendService message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.WeightedBackendService
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.WeightedBackendService} WeightedBackendService
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WeightedBackendService.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a WeightedBackendService message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.WeightedBackendService
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        WeightedBackendService.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.backendService != null && message.hasOwnProperty("backendService")) {
                                properties._backendService = 1;
                                if (!$util.isString(message.backendService))
                                    return "backendService: string expected";
                            }
                            if (message.headerAction != null && message.hasOwnProperty("headerAction")) {
                                properties._headerAction = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.HttpHeaderAction.verify(message.headerAction);
                                    if (error)
                                        return "headerAction." + error;
                                }
                            }
                            if (message.weight != null && message.hasOwnProperty("weight")) {
                                properties._weight = 1;
                                if (!$util.isInteger(message.weight))
                                    return "weight: integer expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a WeightedBackendService message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.WeightedBackendService
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.WeightedBackendService} WeightedBackendService
                         */
                        WeightedBackendService.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.WeightedBackendService)
                                return object;
                            var message = new $root.google.cloud.compute.v1.WeightedBackendService();
                            if (object.backendService != null)
                                message.backendService = String(object.backendService);
                            if (object.headerAction != null) {
                                if (typeof object.headerAction !== "object")
                                    throw TypeError(".google.cloud.compute.v1.WeightedBackendService.headerAction: object expected");
                                message.headerAction = $root.google.cloud.compute.v1.HttpHeaderAction.fromObject(object.headerAction);
                            }
                            if (object.weight != null)
                                message.weight = object.weight >>> 0;
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a WeightedBackendService message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.WeightedBackendService
                         * @static
                         * @param {google.cloud.compute.v1.WeightedBackendService} message WeightedBackendService
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        WeightedBackendService.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.weight != null && message.hasOwnProperty("weight")) {
                                object.weight = message.weight;
                                if (options.oneofs)
                                    object._weight = "weight";
                            }
                            if (message.backendService != null && message.hasOwnProperty("backendService")) {
                                object.backendService = message.backendService;
                                if (options.oneofs)
                                    object._backendService = "backendService";
                            }
                            if (message.headerAction != null && message.hasOwnProperty("headerAction")) {
                                object.headerAction = $root.google.cloud.compute.v1.HttpHeaderAction.toObject(message.headerAction, options);
                                if (options.oneofs)
                                    object._headerAction = "headerAction";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this WeightedBackendService to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.WeightedBackendService
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        WeightedBackendService.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for WeightedBackendService
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.WeightedBackendService
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        WeightedBackendService.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.WeightedBackendService";
                        };
    
                        return WeightedBackendService;
                    })();
    
                    v1.XpnHostList = (function() {
    
                        /**
                         * Properties of a XpnHostList.
                         * @memberof google.cloud.compute.v1
                         * @interface IXpnHostList
                         * @property {string|null} [id] XpnHostList id
                         * @property {Array.<google.cloud.compute.v1.IProject>|null} [items] XpnHostList items
                         * @property {string|null} [kind] XpnHostList kind
                         * @property {string|null} [nextPageToken] XpnHostList nextPageToken
                         * @property {string|null} [selfLink] XpnHostList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] XpnHostList warning
                         */
    
                        /**
                         * Constructs a new XpnHostList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a XpnHostList.
                         * @implements IXpnHostList
                         * @constructor
                         * @param {google.cloud.compute.v1.IXpnHostList=} [properties] Properties to set
                         */
                        function XpnHostList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * XpnHostList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @instance
                         */
                        XpnHostList.prototype.id = null;
    
                        /**
                         * XpnHostList items.
                         * @member {Array.<google.cloud.compute.v1.IProject>} items
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @instance
                         */
                        XpnHostList.prototype.items = $util.emptyArray;
    
                        /**
                         * XpnHostList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @instance
                         */
                        XpnHostList.prototype.kind = null;
    
                        /**
                         * XpnHostList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @instance
                         */
                        XpnHostList.prototype.nextPageToken = null;
    
                        /**
                         * XpnHostList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @instance
                         */
                        XpnHostList.prototype.selfLink = null;
    
                        /**
                         * XpnHostList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @instance
                         */
                        XpnHostList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * XpnHostList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @instance
                         */
                        Object.defineProperty(XpnHostList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * XpnHostList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @instance
                         */
                        Object.defineProperty(XpnHostList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * XpnHostList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @instance
                         */
                        Object.defineProperty(XpnHostList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * XpnHostList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @instance
                         */
                        Object.defineProperty(XpnHostList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * XpnHostList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @instance
                         */
                        Object.defineProperty(XpnHostList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new XpnHostList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @static
                         * @param {google.cloud.compute.v1.IXpnHostList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.XpnHostList} XpnHostList instance
                         */
                        XpnHostList.create = function create(properties) {
                            return new XpnHostList(properties);
                        };
    
                        /**
                         * Encodes the specified XpnHostList message. Does not implicitly {@link google.cloud.compute.v1.XpnHostList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @static
                         * @param {google.cloud.compute.v1.IXpnHostList} message XpnHostList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        XpnHostList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Project.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified XpnHostList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.XpnHostList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @static
                         * @param {google.cloud.compute.v1.IXpnHostList} message XpnHostList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        XpnHostList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a XpnHostList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.XpnHostList} XpnHostList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        XpnHostList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.XpnHostList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Project.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a XpnHostList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.XpnHostList} XpnHostList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        XpnHostList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a XpnHostList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        XpnHostList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Project.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a XpnHostList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.XpnHostList} XpnHostList
                         */
                        XpnHostList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.XpnHostList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.XpnHostList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.XpnHostList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.XpnHostList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Project.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.XpnHostList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a XpnHostList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @static
                         * @param {google.cloud.compute.v1.XpnHostList} message XpnHostList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        XpnHostList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Project.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this XpnHostList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        XpnHostList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for XpnHostList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.XpnHostList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        XpnHostList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.XpnHostList";
                        };
    
                        return XpnHostList;
                    })();
    
                    v1.XpnResourceId = (function() {
    
                        /**
                         * Properties of a XpnResourceId.
                         * @memberof google.cloud.compute.v1
                         * @interface IXpnResourceId
                         * @property {string|null} [id] XpnResourceId id
                         * @property {string|null} [type] XpnResourceId type
                         */
    
                        /**
                         * Constructs a new XpnResourceId.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a XpnResourceId.
                         * @implements IXpnResourceId
                         * @constructor
                         * @param {google.cloud.compute.v1.IXpnResourceId=} [properties] Properties to set
                         */
                        function XpnResourceId(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * XpnResourceId id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.XpnResourceId
                         * @instance
                         */
                        XpnResourceId.prototype.id = null;
    
                        /**
                         * XpnResourceId type.
                         * @member {string|null|undefined} type
                         * @memberof google.cloud.compute.v1.XpnResourceId
                         * @instance
                         */
                        XpnResourceId.prototype.type = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * XpnResourceId _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.XpnResourceId
                         * @instance
                         */
                        Object.defineProperty(XpnResourceId.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * XpnResourceId _type.
                         * @member {"type"|undefined} _type
                         * @memberof google.cloud.compute.v1.XpnResourceId
                         * @instance
                         */
                        Object.defineProperty(XpnResourceId.prototype, "_type", {
                            get: $util.oneOfGetter($oneOfFields = ["type"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new XpnResourceId instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.XpnResourceId
                         * @static
                         * @param {google.cloud.compute.v1.IXpnResourceId=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.XpnResourceId} XpnResourceId instance
                         */
                        XpnResourceId.create = function create(properties) {
                            return new XpnResourceId(properties);
                        };
    
                        /**
                         * Encodes the specified XpnResourceId message. Does not implicitly {@link google.cloud.compute.v1.XpnResourceId.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.XpnResourceId
                         * @static
                         * @param {google.cloud.compute.v1.IXpnResourceId} message XpnResourceId message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        XpnResourceId.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                                writer.uint32(/* id 3575610, wireType 2 =*/28604882).string(message.type);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified XpnResourceId message, length delimited. Does not implicitly {@link google.cloud.compute.v1.XpnResourceId.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.XpnResourceId
                         * @static
                         * @param {google.cloud.compute.v1.IXpnResourceId} message XpnResourceId message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        XpnResourceId.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a XpnResourceId message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.XpnResourceId
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.XpnResourceId} XpnResourceId
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        XpnResourceId.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.XpnResourceId();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 3575610: {
                                        message.type = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a XpnResourceId message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.XpnResourceId
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.XpnResourceId} XpnResourceId
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        XpnResourceId.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a XpnResourceId message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.XpnResourceId
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        XpnResourceId.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                properties._type = 1;
                                if (!$util.isString(message.type))
                                    return "type: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a XpnResourceId message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.XpnResourceId
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.XpnResourceId} XpnResourceId
                         */
                        XpnResourceId.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.XpnResourceId)
                                return object;
                            var message = new $root.google.cloud.compute.v1.XpnResourceId();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.type != null)
                                message.type = String(object.type);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a XpnResourceId message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.XpnResourceId
                         * @static
                         * @param {google.cloud.compute.v1.XpnResourceId} message XpnResourceId
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        XpnResourceId.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.type != null && message.hasOwnProperty("type")) {
                                object.type = message.type;
                                if (options.oneofs)
                                    object._type = "type";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this XpnResourceId to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.XpnResourceId
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        XpnResourceId.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for XpnResourceId
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.XpnResourceId
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        XpnResourceId.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.XpnResourceId";
                        };
    
                        /**
                         * Type enum.
                         * @name google.cloud.compute.v1.XpnResourceId.Type
                         * @enum {number}
                         * @property {number} UNDEFINED_TYPE=0 UNDEFINED_TYPE value
                         * @property {number} PROJECT=408671993 PROJECT value
                         * @property {number} XPN_RESOURCE_TYPE_UNSPECIFIED=151607034 XPN_RESOURCE_TYPE_UNSPECIFIED value
                         */
                        XpnResourceId.Type = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_TYPE"] = 0;
                            values[valuesById[408671993] = "PROJECT"] = 408671993;
                            values[valuesById[151607034] = "XPN_RESOURCE_TYPE_UNSPECIFIED"] = 151607034;
                            return values;
                        })();
    
                        return XpnResourceId;
                    })();
    
                    v1.Zone = (function() {
    
                        /**
                         * Properties of a Zone.
                         * @memberof google.cloud.compute.v1
                         * @interface IZone
                         * @property {Array.<string>|null} [availableCpuPlatforms] Zone availableCpuPlatforms
                         * @property {string|null} [creationTimestamp] Zone creationTimestamp
                         * @property {google.cloud.compute.v1.IDeprecationStatus|null} [deprecated] Zone deprecated
                         * @property {string|null} [description] Zone description
                         * @property {number|Long|null} [id] Zone id
                         * @property {string|null} [kind] Zone kind
                         * @property {string|null} [name] Zone name
                         * @property {string|null} [region] Zone region
                         * @property {string|null} [selfLink] Zone selfLink
                         * @property {string|null} [status] Zone status
                         * @property {boolean|null} [supportsPzs] Zone supportsPzs
                         */
    
                        /**
                         * Constructs a new Zone.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Zone.
                         * @implements IZone
                         * @constructor
                         * @param {google.cloud.compute.v1.IZone=} [properties] Properties to set
                         */
                        function Zone(properties) {
                            this.availableCpuPlatforms = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Zone availableCpuPlatforms.
                         * @member {Array.<string>} availableCpuPlatforms
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Zone.prototype.availableCpuPlatforms = $util.emptyArray;
    
                        /**
                         * Zone creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Zone.prototype.creationTimestamp = null;
    
                        /**
                         * Zone deprecated.
                         * @member {google.cloud.compute.v1.IDeprecationStatus|null|undefined} deprecated
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Zone.prototype.deprecated = null;
    
                        /**
                         * Zone description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Zone.prototype.description = null;
    
                        /**
                         * Zone id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Zone.prototype.id = null;
    
                        /**
                         * Zone kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Zone.prototype.kind = null;
    
                        /**
                         * Zone name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Zone.prototype.name = null;
    
                        /**
                         * Zone region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Zone.prototype.region = null;
    
                        /**
                         * Zone selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Zone.prototype.selfLink = null;
    
                        /**
                         * Zone status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Zone.prototype.status = null;
    
                        /**
                         * Zone supportsPzs.
                         * @member {boolean|null|undefined} supportsPzs
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Zone.prototype.supportsPzs = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Zone _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Object.defineProperty(Zone.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Zone _deprecated.
                         * @member {"deprecated"|undefined} _deprecated
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Object.defineProperty(Zone.prototype, "_deprecated", {
                            get: $util.oneOfGetter($oneOfFields = ["deprecated"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Zone _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Object.defineProperty(Zone.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Zone _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Object.defineProperty(Zone.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Zone _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Object.defineProperty(Zone.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Zone _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Object.defineProperty(Zone.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Zone _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Object.defineProperty(Zone.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Zone _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Object.defineProperty(Zone.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Zone _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Object.defineProperty(Zone.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Zone _supportsPzs.
                         * @member {"supportsPzs"|undefined} _supportsPzs
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         */
                        Object.defineProperty(Zone.prototype, "_supportsPzs", {
                            get: $util.oneOfGetter($oneOfFields = ["supportsPzs"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Zone instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.Zone
                         * @static
                         * @param {google.cloud.compute.v1.IZone=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.Zone} Zone instance
                         */
                        Zone.create = function create(properties) {
                            return new Zone(properties);
                        };
    
                        /**
                         * Encodes the specified Zone message. Does not implicitly {@link google.cloud.compute.v1.Zone.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.Zone
                         * @static
                         * @param {google.cloud.compute.v1.IZone} message Zone message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Zone.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.supportsPzs != null && Object.hasOwnProperty.call(message, "supportsPzs"))
                                writer.uint32(/* id 83983214, wireType 0 =*/671865712).bool(message.supportsPzs);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.availableCpuPlatforms != null && message.availableCpuPlatforms.length)
                                for (var i = 0; i < message.availableCpuPlatforms.length; ++i)
                                    writer.uint32(/* id 175536531, wireType 2 =*/1404292250).string(message.availableCpuPlatforms[i]);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                                $root.google.cloud.compute.v1.DeprecationStatus.encode(message.deprecated, writer.uint32(/* id 515138995, wireType 2 =*/4121111962).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Zone message, length delimited. Does not implicitly {@link google.cloud.compute.v1.Zone.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.Zone
                         * @static
                         * @param {google.cloud.compute.v1.IZone} message Zone message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Zone.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Zone message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.Zone
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.Zone} Zone
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Zone.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.Zone();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 175536531: {
                                        if (!(message.availableCpuPlatforms && message.availableCpuPlatforms.length))
                                            message.availableCpuPlatforms = [];
                                        message.availableCpuPlatforms.push(reader.string());
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 515138995: {
                                        message.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                case 83983214: {
                                        message.supportsPzs = reader.bool();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Zone message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.Zone
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.Zone} Zone
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Zone.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Zone message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.Zone
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Zone.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.availableCpuPlatforms != null && message.hasOwnProperty("availableCpuPlatforms")) {
                                if (!Array.isArray(message.availableCpuPlatforms))
                                    return "availableCpuPlatforms: array expected";
                                for (var i = 0; i < message.availableCpuPlatforms.length; ++i)
                                    if (!$util.isString(message.availableCpuPlatforms[i]))
                                        return "availableCpuPlatforms: string[] expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.deprecated != null && message.hasOwnProperty("deprecated")) {
                                properties._deprecated = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.DeprecationStatus.verify(message.deprecated);
                                    if (error)
                                        return "deprecated." + error;
                                }
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            if (message.supportsPzs != null && message.hasOwnProperty("supportsPzs")) {
                                properties._supportsPzs = 1;
                                if (typeof message.supportsPzs !== "boolean")
                                    return "supportsPzs: boolean expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Zone message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.Zone
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.Zone} Zone
                         */
                        Zone.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.Zone)
                                return object;
                            var message = new $root.google.cloud.compute.v1.Zone();
                            if (object.availableCpuPlatforms) {
                                if (!Array.isArray(object.availableCpuPlatforms))
                                    throw TypeError(".google.cloud.compute.v1.Zone.availableCpuPlatforms: array expected");
                                message.availableCpuPlatforms = [];
                                for (var i = 0; i < object.availableCpuPlatforms.length; ++i)
                                    message.availableCpuPlatforms[i] = String(object.availableCpuPlatforms[i]);
                            }
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.deprecated != null) {
                                if (typeof object.deprecated !== "object")
                                    throw TypeError(".google.cloud.compute.v1.Zone.deprecated: object expected");
                                message.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.fromObject(object.deprecated);
                            }
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.status != null)
                                message.status = String(object.status);
                            if (object.supportsPzs != null)
                                message.supportsPzs = Boolean(object.supportsPzs);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Zone message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.Zone
                         * @static
                         * @param {google.cloud.compute.v1.Zone} message Zone
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Zone.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.availableCpuPlatforms = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.supportsPzs != null && message.hasOwnProperty("supportsPzs")) {
                                object.supportsPzs = message.supportsPzs;
                                if (options.oneofs)
                                    object._supportsPzs = "supportsPzs";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.availableCpuPlatforms && message.availableCpuPlatforms.length) {
                                object.availableCpuPlatforms = [];
                                for (var j = 0; j < message.availableCpuPlatforms.length; ++j)
                                    object.availableCpuPlatforms[j] = message.availableCpuPlatforms[j];
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.deprecated != null && message.hasOwnProperty("deprecated")) {
                                object.deprecated = $root.google.cloud.compute.v1.DeprecationStatus.toObject(message.deprecated, options);
                                if (options.oneofs)
                                    object._deprecated = "deprecated";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Zone to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.Zone
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Zone.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Zone
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.Zone
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Zone.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.Zone";
                        };
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1.Zone.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} DOWN=2104482 DOWN value
                         * @property {number} UP=2715 UP value
                         */
                        Zone.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[2104482] = "DOWN"] = 2104482;
                            values[valuesById[2715] = "UP"] = 2715;
                            return values;
                        })();
    
                        return Zone;
                    })();
    
                    v1.ZoneList = (function() {
    
                        /**
                         * Properties of a ZoneList.
                         * @memberof google.cloud.compute.v1
                         * @interface IZoneList
                         * @property {string|null} [id] ZoneList id
                         * @property {Array.<google.cloud.compute.v1.IZone>|null} [items] ZoneList items
                         * @property {string|null} [kind] ZoneList kind
                         * @property {string|null} [nextPageToken] ZoneList nextPageToken
                         * @property {string|null} [selfLink] ZoneList selfLink
                         * @property {google.cloud.compute.v1.IWarning|null} [warning] ZoneList warning
                         */
    
                        /**
                         * Constructs a new ZoneList.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ZoneList.
                         * @implements IZoneList
                         * @constructor
                         * @param {google.cloud.compute.v1.IZoneList=} [properties] Properties to set
                         */
                        function ZoneList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ZoneList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @instance
                         */
                        ZoneList.prototype.id = null;
    
                        /**
                         * ZoneList items.
                         * @member {Array.<google.cloud.compute.v1.IZone>} items
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @instance
                         */
                        ZoneList.prototype.items = $util.emptyArray;
    
                        /**
                         * ZoneList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @instance
                         */
                        ZoneList.prototype.kind = null;
    
                        /**
                         * ZoneList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @instance
                         */
                        ZoneList.prototype.nextPageToken = null;
    
                        /**
                         * ZoneList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @instance
                         */
                        ZoneList.prototype.selfLink = null;
    
                        /**
                         * ZoneList warning.
                         * @member {google.cloud.compute.v1.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @instance
                         */
                        ZoneList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ZoneList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @instance
                         */
                        Object.defineProperty(ZoneList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ZoneList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @instance
                         */
                        Object.defineProperty(ZoneList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ZoneList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @instance
                         */
                        Object.defineProperty(ZoneList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ZoneList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @instance
                         */
                        Object.defineProperty(ZoneList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ZoneList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @instance
                         */
                        Object.defineProperty(ZoneList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ZoneList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @static
                         * @param {google.cloud.compute.v1.IZoneList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ZoneList} ZoneList instance
                         */
                        ZoneList.create = function create(properties) {
                            return new ZoneList(properties);
                        };
    
                        /**
                         * Encodes the specified ZoneList message. Does not implicitly {@link google.cloud.compute.v1.ZoneList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @static
                         * @param {google.cloud.compute.v1.IZoneList} message ZoneList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ZoneList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1.Zone.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ZoneList message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ZoneList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @static
                         * @param {google.cloud.compute.v1.IZoneList} message ZoneList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ZoneList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ZoneList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ZoneList} ZoneList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ZoneList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ZoneList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1.Zone.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ZoneList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ZoneList} ZoneList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ZoneList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ZoneList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ZoneList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Zone.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ZoneList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ZoneList} ZoneList
                         */
                        ZoneList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ZoneList)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ZoneList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1.ZoneList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ZoneList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1.Zone.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ZoneList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ZoneList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @static
                         * @param {google.cloud.compute.v1.ZoneList} message ZoneList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ZoneList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1.Zone.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ZoneList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ZoneList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ZoneList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ZoneList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ZoneList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ZoneList";
                        };
    
                        return ZoneList;
                    })();
    
                    v1.ZoneSetLabelsRequest = (function() {
    
                        /**
                         * Properties of a ZoneSetLabelsRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IZoneSetLabelsRequest
                         * @property {string|null} [labelFingerprint] ZoneSetLabelsRequest labelFingerprint
                         * @property {Object.<string,string>|null} [labels] ZoneSetLabelsRequest labels
                         */
    
                        /**
                         * Constructs a new ZoneSetLabelsRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ZoneSetLabelsRequest.
                         * @implements IZoneSetLabelsRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IZoneSetLabelsRequest=} [properties] Properties to set
                         */
                        function ZoneSetLabelsRequest(properties) {
                            this.labels = {};
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ZoneSetLabelsRequest labelFingerprint.
                         * @member {string|null|undefined} labelFingerprint
                         * @memberof google.cloud.compute.v1.ZoneSetLabelsRequest
                         * @instance
                         */
                        ZoneSetLabelsRequest.prototype.labelFingerprint = null;
    
                        /**
                         * ZoneSetLabelsRequest labels.
                         * @member {Object.<string,string>} labels
                         * @memberof google.cloud.compute.v1.ZoneSetLabelsRequest
                         * @instance
                         */
                        ZoneSetLabelsRequest.prototype.labels = $util.emptyObject;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ZoneSetLabelsRequest _labelFingerprint.
                         * @member {"labelFingerprint"|undefined} _labelFingerprint
                         * @memberof google.cloud.compute.v1.ZoneSetLabelsRequest
                         * @instance
                         */
                        Object.defineProperty(ZoneSetLabelsRequest.prototype, "_labelFingerprint", {
                            get: $util.oneOfGetter($oneOfFields = ["labelFingerprint"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ZoneSetLabelsRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ZoneSetLabelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IZoneSetLabelsRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ZoneSetLabelsRequest} ZoneSetLabelsRequest instance
                         */
                        ZoneSetLabelsRequest.create = function create(properties) {
                            return new ZoneSetLabelsRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ZoneSetLabelsRequest message. Does not implicitly {@link google.cloud.compute.v1.ZoneSetLabelsRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ZoneSetLabelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IZoneSetLabelsRequest} message ZoneSetLabelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ZoneSetLabelsRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.labelFingerprint != null && Object.hasOwnProperty.call(message, "labelFingerprint"))
                                writer.uint32(/* id 178124825, wireType 2 =*/1424998602).string(message.labelFingerprint);
                            if (message.labels != null && Object.hasOwnProperty.call(message, "labels"))
                                for (var keys = Object.keys(message.labels), i = 0; i < keys.length; ++i)
                                    writer.uint32(/* id 500195327, wireType 2 =*/4001562618).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.labels[keys[i]]).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ZoneSetLabelsRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ZoneSetLabelsRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ZoneSetLabelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.IZoneSetLabelsRequest} message ZoneSetLabelsRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ZoneSetLabelsRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ZoneSetLabelsRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ZoneSetLabelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ZoneSetLabelsRequest} ZoneSetLabelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ZoneSetLabelsRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ZoneSetLabelsRequest(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 178124825: {
                                        message.labelFingerprint = reader.string();
                                        break;
                                    }
                                case 500195327: {
                                        if (message.labels === $util.emptyObject)
                                            message.labels = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = "";
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = reader.string();
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.labels[key] = value;
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ZoneSetLabelsRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ZoneSetLabelsRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ZoneSetLabelsRequest} ZoneSetLabelsRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ZoneSetLabelsRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ZoneSetLabelsRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ZoneSetLabelsRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ZoneSetLabelsRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                properties._labelFingerprint = 1;
                                if (!$util.isString(message.labelFingerprint))
                                    return "labelFingerprint: string expected";
                            }
                            if (message.labels != null && message.hasOwnProperty("labels")) {
                                if (!$util.isObject(message.labels))
                                    return "labels: object expected";
                                var key = Object.keys(message.labels);
                                for (var i = 0; i < key.length; ++i)
                                    if (!$util.isString(message.labels[key[i]]))
                                        return "labels: string{k:string} expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ZoneSetLabelsRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ZoneSetLabelsRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ZoneSetLabelsRequest} ZoneSetLabelsRequest
                         */
                        ZoneSetLabelsRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ZoneSetLabelsRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ZoneSetLabelsRequest();
                            if (object.labelFingerprint != null)
                                message.labelFingerprint = String(object.labelFingerprint);
                            if (object.labels) {
                                if (typeof object.labels !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ZoneSetLabelsRequest.labels: object expected");
                                message.labels = {};
                                for (var keys = Object.keys(object.labels), i = 0; i < keys.length; ++i)
                                    message.labels[keys[i]] = String(object.labels[keys[i]]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ZoneSetLabelsRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ZoneSetLabelsRequest
                         * @static
                         * @param {google.cloud.compute.v1.ZoneSetLabelsRequest} message ZoneSetLabelsRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ZoneSetLabelsRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.objects || options.defaults)
                                object.labels = {};
                            if (message.labelFingerprint != null && message.hasOwnProperty("labelFingerprint")) {
                                object.labelFingerprint = message.labelFingerprint;
                                if (options.oneofs)
                                    object._labelFingerprint = "labelFingerprint";
                            }
                            var keys2;
                            if (message.labels && (keys2 = Object.keys(message.labels)).length) {
                                object.labels = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.labels[keys2[j]] = message.labels[keys2[j]];
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ZoneSetLabelsRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ZoneSetLabelsRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ZoneSetLabelsRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ZoneSetLabelsRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ZoneSetLabelsRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ZoneSetLabelsRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ZoneSetLabelsRequest";
                        };
    
                        return ZoneSetLabelsRequest;
                    })();
    
                    v1.ZoneSetPolicyRequest = (function() {
    
                        /**
                         * Properties of a ZoneSetPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @interface IZoneSetPolicyRequest
                         * @property {Array.<google.cloud.compute.v1.IBinding>|null} [bindings] ZoneSetPolicyRequest bindings
                         * @property {string|null} [etag] ZoneSetPolicyRequest etag
                         * @property {google.cloud.compute.v1.IPolicy|null} [policy] ZoneSetPolicyRequest policy
                         */
    
                        /**
                         * Constructs a new ZoneSetPolicyRequest.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ZoneSetPolicyRequest.
                         * @implements IZoneSetPolicyRequest
                         * @constructor
                         * @param {google.cloud.compute.v1.IZoneSetPolicyRequest=} [properties] Properties to set
                         */
                        function ZoneSetPolicyRequest(properties) {
                            this.bindings = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ZoneSetPolicyRequest bindings.
                         * @member {Array.<google.cloud.compute.v1.IBinding>} bindings
                         * @memberof google.cloud.compute.v1.ZoneSetPolicyRequest
                         * @instance
                         */
                        ZoneSetPolicyRequest.prototype.bindings = $util.emptyArray;
    
                        /**
                         * ZoneSetPolicyRequest etag.
                         * @member {string|null|undefined} etag
                         * @memberof google.cloud.compute.v1.ZoneSetPolicyRequest
                         * @instance
                         */
                        ZoneSetPolicyRequest.prototype.etag = null;
    
                        /**
                         * ZoneSetPolicyRequest policy.
                         * @member {google.cloud.compute.v1.IPolicy|null|undefined} policy
                         * @memberof google.cloud.compute.v1.ZoneSetPolicyRequest
                         * @instance
                         */
                        ZoneSetPolicyRequest.prototype.policy = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ZoneSetPolicyRequest _etag.
                         * @member {"etag"|undefined} _etag
                         * @memberof google.cloud.compute.v1.ZoneSetPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(ZoneSetPolicyRequest.prototype, "_etag", {
                            get: $util.oneOfGetter($oneOfFields = ["etag"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ZoneSetPolicyRequest _policy.
                         * @member {"policy"|undefined} _policy
                         * @memberof google.cloud.compute.v1.ZoneSetPolicyRequest
                         * @instance
                         */
                        Object.defineProperty(ZoneSetPolicyRequest.prototype, "_policy", {
                            get: $util.oneOfGetter($oneOfFields = ["policy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ZoneSetPolicyRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1.ZoneSetPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IZoneSetPolicyRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1.ZoneSetPolicyRequest} ZoneSetPolicyRequest instance
                         */
                        ZoneSetPolicyRequest.create = function create(properties) {
                            return new ZoneSetPolicyRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ZoneSetPolicyRequest message. Does not implicitly {@link google.cloud.compute.v1.ZoneSetPolicyRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1.ZoneSetPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IZoneSetPolicyRequest} message ZoneSetPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ZoneSetPolicyRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.etag != null && Object.hasOwnProperty.call(message, "etag"))
                                writer.uint32(/* id 3123477, wireType 2 =*/24987818).string(message.etag);
                            if (message.policy != null && Object.hasOwnProperty.call(message, "policy"))
                                $root.google.cloud.compute.v1.Policy.encode(message.policy, writer.uint32(/* id 91071794, wireType 2 =*/728574354).fork()).ldelim();
                            if (message.bindings != null && message.bindings.length)
                                for (var i = 0; i < message.bindings.length; ++i)
                                    $root.google.cloud.compute.v1.Binding.encode(message.bindings[i], writer.uint32(/* id 403251854, wireType 2 =*/3226014834).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ZoneSetPolicyRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1.ZoneSetPolicyRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1.ZoneSetPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.IZoneSetPolicyRequest} message ZoneSetPolicyRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ZoneSetPolicyRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ZoneSetPolicyRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1.ZoneSetPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1.ZoneSetPolicyRequest} ZoneSetPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ZoneSetPolicyRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1.ZoneSetPolicyRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 403251854: {
                                        if (!(message.bindings && message.bindings.length))
                                            message.bindings = [];
                                        message.bindings.push($root.google.cloud.compute.v1.Binding.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3123477: {
                                        message.etag = reader.string();
                                        break;
                                    }
                                case 91071794: {
                                        message.policy = $root.google.cloud.compute.v1.Policy.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ZoneSetPolicyRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1.ZoneSetPolicyRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1.ZoneSetPolicyRequest} ZoneSetPolicyRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ZoneSetPolicyRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ZoneSetPolicyRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1.ZoneSetPolicyRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ZoneSetPolicyRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.bindings != null && message.hasOwnProperty("bindings")) {
                                if (!Array.isArray(message.bindings))
                                    return "bindings: array expected";
                                for (var i = 0; i < message.bindings.length; ++i) {
                                    var error = $root.google.cloud.compute.v1.Binding.verify(message.bindings[i]);
                                    if (error)
                                        return "bindings." + error;
                                }
                            }
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                properties._etag = 1;
                                if (!$util.isString(message.etag))
                                    return "etag: string expected";
                            }
                            if (message.policy != null && message.hasOwnProperty("policy")) {
                                properties._policy = 1;
                                {
                                    var error = $root.google.cloud.compute.v1.Policy.verify(message.policy);
                                    if (error)
                                        return "policy." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates a ZoneSetPolicyRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1.ZoneSetPolicyRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1.ZoneSetPolicyRequest} ZoneSetPolicyRequest
                         */
                        ZoneSetPolicyRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1.ZoneSetPolicyRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1.ZoneSetPolicyRequest();
                            if (object.bindings) {
                                if (!Array.isArray(object.bindings))
                                    throw TypeError(".google.cloud.compute.v1.ZoneSetPolicyRequest.bindings: array expected");
                                message.bindings = [];
                                for (var i = 0; i < object.bindings.length; ++i) {
                                    if (typeof object.bindings[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1.ZoneSetPolicyRequest.bindings: object expected");
                                    message.bindings[i] = $root.google.cloud.compute.v1.Binding.fromObject(object.bindings[i]);
                                }
                            }
                            if (object.etag != null)
                                message.etag = String(object.etag);
                            if (object.policy != null) {
                                if (typeof object.policy !== "object")
                                    throw TypeError(".google.cloud.compute.v1.ZoneSetPolicyRequest.policy: object expected");
                                message.policy = $root.google.cloud.compute.v1.Policy.fromObject(object.policy);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ZoneSetPolicyRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1.ZoneSetPolicyRequest
                         * @static
                         * @param {google.cloud.compute.v1.ZoneSetPolicyRequest} message ZoneSetPolicyRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ZoneSetPolicyRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.bindings = [];
                            if (message.etag != null && message.hasOwnProperty("etag")) {
                                object.etag = message.etag;
                                if (options.oneofs)
                                    object._etag = "etag";
                            }
                            if (message.policy != null && message.hasOwnProperty("policy")) {
                                object.policy = $root.google.cloud.compute.v1.Policy.toObject(message.policy, options);
                                if (options.oneofs)
                                    object._policy = "policy";
                            }
                            if (message.bindings && message.bindings.length) {
                                object.bindings = [];
                                for (var j = 0; j < message.bindings.length; ++j)
                                    object.bindings[j] = $root.google.cloud.compute.v1.Binding.toObject(message.bindings[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ZoneSetPolicyRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1.ZoneSetPolicyRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ZoneSetPolicyRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ZoneSetPolicyRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1.ZoneSetPolicyRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ZoneSetPolicyRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1.ZoneSetPolicyRequest";
                        };
    
                        return ZoneSetPolicyRequest;
                    })();
    
                    v1.AcceleratorTypes = (function() {
    
                        /**
                         * Constructs a new AcceleratorTypes service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an AcceleratorTypes
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function AcceleratorTypes(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (AcceleratorTypes.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = AcceleratorTypes;
    
                        /**
                         * Creates new AcceleratorTypes service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.AcceleratorTypes
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {AcceleratorTypes} RPC service. Useful where requests and/or responses are streamed.
                         */
                        AcceleratorTypes.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.AcceleratorTypes|aggregatedList}.
                         * @memberof google.cloud.compute.v1.AcceleratorTypes
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.AcceleratorTypeAggregatedList} [response] AcceleratorTypeAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.AcceleratorTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListAcceleratorTypesRequest} request AggregatedListAcceleratorTypesRequest message or plain object
                         * @param {google.cloud.compute.v1.AcceleratorTypes.AggregatedListCallback} callback Node-style callback called with the error, if any, and AcceleratorTypeAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AcceleratorTypes.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListAcceleratorTypesRequest, $root.google.cloud.compute.v1.AcceleratorTypeAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.AcceleratorTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListAcceleratorTypesRequest} request AggregatedListAcceleratorTypesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.AcceleratorTypeAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.AcceleratorTypes|get}.
                         * @memberof google.cloud.compute.v1.AcceleratorTypes
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.AcceleratorType} [response] AcceleratorType
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.AcceleratorTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IGetAcceleratorTypeRequest} request GetAcceleratorTypeRequest message or plain object
                         * @param {google.cloud.compute.v1.AcceleratorTypes.GetCallback} callback Node-style callback called with the error, if any, and AcceleratorType
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AcceleratorTypes.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetAcceleratorTypeRequest, $root.google.cloud.compute.v1.AcceleratorType, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.AcceleratorTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IGetAcceleratorTypeRequest} request GetAcceleratorTypeRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.AcceleratorType>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.AcceleratorTypes|list}.
                         * @memberof google.cloud.compute.v1.AcceleratorTypes
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.AcceleratorTypeList} [response] AcceleratorTypeList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.AcceleratorTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IListAcceleratorTypesRequest} request ListAcceleratorTypesRequest message or plain object
                         * @param {google.cloud.compute.v1.AcceleratorTypes.ListCallback} callback Node-style callback called with the error, if any, and AcceleratorTypeList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(AcceleratorTypes.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListAcceleratorTypesRequest, $root.google.cloud.compute.v1.AcceleratorTypeList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.AcceleratorTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IListAcceleratorTypesRequest} request ListAcceleratorTypesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.AcceleratorTypeList>} Promise
                         * @variation 2
                         */
    
                        return AcceleratorTypes;
                    })();
    
                    v1.Addresses = (function() {
    
                        /**
                         * Constructs a new Addresses service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an Addresses
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function Addresses(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (Addresses.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = Addresses;
    
                        /**
                         * Creates new Addresses service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.Addresses
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {Addresses} RPC service. Useful where requests and/or responses are streamed.
                         */
                        Addresses.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Addresses|aggregatedList}.
                         * @memberof google.cloud.compute.v1.Addresses
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.AddressAggregatedList} [response] AddressAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.Addresses
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListAddressesRequest} request AggregatedListAddressesRequest message or plain object
                         * @param {google.cloud.compute.v1.Addresses.AggregatedListCallback} callback Node-style callback called with the error, if any, and AddressAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Addresses.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListAddressesRequest, $root.google.cloud.compute.v1.AddressAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.Addresses
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListAddressesRequest} request AggregatedListAddressesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.AddressAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Addresses|delete_}.
                         * @memberof google.cloud.compute.v1.Addresses
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Addresses
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteAddressRequest} request DeleteAddressRequest message or plain object
                         * @param {google.cloud.compute.v1.Addresses.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Addresses.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteAddressRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Addresses
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteAddressRequest} request DeleteAddressRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Addresses|get}.
                         * @memberof google.cloud.compute.v1.Addresses
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Address} [response] Address
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Addresses
                         * @instance
                         * @param {google.cloud.compute.v1.IGetAddressRequest} request GetAddressRequest message or plain object
                         * @param {google.cloud.compute.v1.Addresses.GetCallback} callback Node-style callback called with the error, if any, and Address
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Addresses.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetAddressRequest, $root.google.cloud.compute.v1.Address, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Addresses
                         * @instance
                         * @param {google.cloud.compute.v1.IGetAddressRequest} request GetAddressRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Address>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Addresses|insert}.
                         * @memberof google.cloud.compute.v1.Addresses
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Addresses
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertAddressRequest} request InsertAddressRequest message or plain object
                         * @param {google.cloud.compute.v1.Addresses.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Addresses.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertAddressRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Addresses
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertAddressRequest} request InsertAddressRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Addresses|list}.
                         * @memberof google.cloud.compute.v1.Addresses
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.AddressList} [response] AddressList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Addresses
                         * @instance
                         * @param {google.cloud.compute.v1.IListAddressesRequest} request ListAddressesRequest message or plain object
                         * @param {google.cloud.compute.v1.Addresses.ListCallback} callback Node-style callback called with the error, if any, and AddressList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Addresses.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListAddressesRequest, $root.google.cloud.compute.v1.AddressList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Addresses
                         * @instance
                         * @param {google.cloud.compute.v1.IListAddressesRequest} request ListAddressesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.AddressList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Addresses|setLabels}.
                         * @memberof google.cloud.compute.v1.Addresses
                         * @typedef SetLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.Addresses
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsAddressRequest} request SetLabelsAddressRequest message or plain object
                         * @param {google.cloud.compute.v1.Addresses.SetLabelsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Addresses.prototype.setLabels = function setLabels(request, callback) {
                            return this.rpcCall(setLabels, $root.google.cloud.compute.v1.SetLabelsAddressRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetLabels" });
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.Addresses
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsAddressRequest} request SetLabelsAddressRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return Addresses;
                    })();
    
                    v1.Autoscalers = (function() {
    
                        /**
                         * Constructs a new Autoscalers service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an Autoscalers
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function Autoscalers(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (Autoscalers.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = Autoscalers;
    
                        /**
                         * Creates new Autoscalers service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {Autoscalers} RPC service. Useful where requests and/or responses are streamed.
                         */
                        Autoscalers.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Autoscalers|aggregatedList}.
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.AutoscalerAggregatedList} [response] AutoscalerAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListAutoscalersRequest} request AggregatedListAutoscalersRequest message or plain object
                         * @param {google.cloud.compute.v1.Autoscalers.AggregatedListCallback} callback Node-style callback called with the error, if any, and AutoscalerAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Autoscalers.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListAutoscalersRequest, $root.google.cloud.compute.v1.AutoscalerAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListAutoscalersRequest} request AggregatedListAutoscalersRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.AutoscalerAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Autoscalers|delete_}.
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteAutoscalerRequest} request DeleteAutoscalerRequest message or plain object
                         * @param {google.cloud.compute.v1.Autoscalers.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Autoscalers.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteAutoscalerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteAutoscalerRequest} request DeleteAutoscalerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Autoscalers|get}.
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Autoscaler} [response] Autoscaler
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IGetAutoscalerRequest} request GetAutoscalerRequest message or plain object
                         * @param {google.cloud.compute.v1.Autoscalers.GetCallback} callback Node-style callback called with the error, if any, and Autoscaler
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Autoscalers.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetAutoscalerRequest, $root.google.cloud.compute.v1.Autoscaler, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IGetAutoscalerRequest} request GetAutoscalerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Autoscaler>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Autoscalers|insert}.
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertAutoscalerRequest} request InsertAutoscalerRequest message or plain object
                         * @param {google.cloud.compute.v1.Autoscalers.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Autoscalers.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertAutoscalerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertAutoscalerRequest} request InsertAutoscalerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Autoscalers|list}.
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.AutoscalerList} [response] AutoscalerList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IListAutoscalersRequest} request ListAutoscalersRequest message or plain object
                         * @param {google.cloud.compute.v1.Autoscalers.ListCallback} callback Node-style callback called with the error, if any, and AutoscalerList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Autoscalers.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListAutoscalersRequest, $root.google.cloud.compute.v1.AutoscalerList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IListAutoscalersRequest} request ListAutoscalersRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.AutoscalerList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Autoscalers|patch}.
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchAutoscalerRequest} request PatchAutoscalerRequest message or plain object
                         * @param {google.cloud.compute.v1.Autoscalers.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Autoscalers.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchAutoscalerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchAutoscalerRequest} request PatchAutoscalerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Autoscalers|update}.
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @typedef UpdateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateAutoscalerRequest} request UpdateAutoscalerRequest message or plain object
                         * @param {google.cloud.compute.v1.Autoscalers.UpdateCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Autoscalers.prototype.update = function update(request, callback) {
                            return this.rpcCall(update, $root.google.cloud.compute.v1.UpdateAutoscalerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Update" });
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.Autoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateAutoscalerRequest} request UpdateAutoscalerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return Autoscalers;
                    })();
    
                    v1.BackendBuckets = (function() {
    
                        /**
                         * Constructs a new BackendBuckets service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendBuckets
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function BackendBuckets(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (BackendBuckets.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = BackendBuckets;
    
                        /**
                         * Creates new BackendBuckets service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {BackendBuckets} RPC service. Useful where requests and/or responses are streamed.
                         */
                        BackendBuckets.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendBuckets|addSignedUrlKey}.
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @typedef AddSignedUrlKeyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AddSignedUrlKey.
                         * @function addSignedUrlKey
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @instance
                         * @param {google.cloud.compute.v1.IAddSignedUrlKeyBackendBucketRequest} request AddSignedUrlKeyBackendBucketRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendBuckets.AddSignedUrlKeyCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendBuckets.prototype.addSignedUrlKey = function addSignedUrlKey(request, callback) {
                            return this.rpcCall(addSignedUrlKey, $root.google.cloud.compute.v1.AddSignedUrlKeyBackendBucketRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AddSignedUrlKey" });
    
                        /**
                         * Calls AddSignedUrlKey.
                         * @function addSignedUrlKey
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @instance
                         * @param {google.cloud.compute.v1.IAddSignedUrlKeyBackendBucketRequest} request AddSignedUrlKeyBackendBucketRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendBuckets|delete_}.
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteBackendBucketRequest} request DeleteBackendBucketRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendBuckets.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendBuckets.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteBackendBucketRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteBackendBucketRequest} request DeleteBackendBucketRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendBuckets|deleteSignedUrlKey}.
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @typedef DeleteSignedUrlKeyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls DeleteSignedUrlKey.
                         * @function deleteSignedUrlKey
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteSignedUrlKeyBackendBucketRequest} request DeleteSignedUrlKeyBackendBucketRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendBuckets.DeleteSignedUrlKeyCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendBuckets.prototype.deleteSignedUrlKey = function deleteSignedUrlKey(request, callback) {
                            return this.rpcCall(deleteSignedUrlKey, $root.google.cloud.compute.v1.DeleteSignedUrlKeyBackendBucketRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "DeleteSignedUrlKey" });
    
                        /**
                         * Calls DeleteSignedUrlKey.
                         * @function deleteSignedUrlKey
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteSignedUrlKeyBackendBucketRequest} request DeleteSignedUrlKeyBackendBucketRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendBuckets|get}.
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.BackendBucket} [response] BackendBucket
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @instance
                         * @param {google.cloud.compute.v1.IGetBackendBucketRequest} request GetBackendBucketRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendBuckets.GetCallback} callback Node-style callback called with the error, if any, and BackendBucket
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendBuckets.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetBackendBucketRequest, $root.google.cloud.compute.v1.BackendBucket, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @instance
                         * @param {google.cloud.compute.v1.IGetBackendBucketRequest} request GetBackendBucketRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.BackendBucket>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendBuckets|insert}.
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertBackendBucketRequest} request InsertBackendBucketRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendBuckets.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendBuckets.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertBackendBucketRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertBackendBucketRequest} request InsertBackendBucketRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendBuckets|list}.
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.BackendBucketList} [response] BackendBucketList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @instance
                         * @param {google.cloud.compute.v1.IListBackendBucketsRequest} request ListBackendBucketsRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendBuckets.ListCallback} callback Node-style callback called with the error, if any, and BackendBucketList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendBuckets.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListBackendBucketsRequest, $root.google.cloud.compute.v1.BackendBucketList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @instance
                         * @param {google.cloud.compute.v1.IListBackendBucketsRequest} request ListBackendBucketsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.BackendBucketList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendBuckets|patch}.
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchBackendBucketRequest} request PatchBackendBucketRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendBuckets.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendBuckets.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchBackendBucketRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchBackendBucketRequest} request PatchBackendBucketRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendBuckets|setEdgeSecurityPolicy}.
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @typedef SetEdgeSecurityPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetEdgeSecurityPolicy.
                         * @function setEdgeSecurityPolicy
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @instance
                         * @param {google.cloud.compute.v1.ISetEdgeSecurityPolicyBackendBucketRequest} request SetEdgeSecurityPolicyBackendBucketRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendBuckets.SetEdgeSecurityPolicyCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendBuckets.prototype.setEdgeSecurityPolicy = function setEdgeSecurityPolicy(request, callback) {
                            return this.rpcCall(setEdgeSecurityPolicy, $root.google.cloud.compute.v1.SetEdgeSecurityPolicyBackendBucketRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetEdgeSecurityPolicy" });
    
                        /**
                         * Calls SetEdgeSecurityPolicy.
                         * @function setEdgeSecurityPolicy
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @instance
                         * @param {google.cloud.compute.v1.ISetEdgeSecurityPolicyBackendBucketRequest} request SetEdgeSecurityPolicyBackendBucketRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendBuckets|update}.
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @typedef UpdateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateBackendBucketRequest} request UpdateBackendBucketRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendBuckets.UpdateCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendBuckets.prototype.update = function update(request, callback) {
                            return this.rpcCall(update, $root.google.cloud.compute.v1.UpdateBackendBucketRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Update" });
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.BackendBuckets
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateBackendBucketRequest} request UpdateBackendBucketRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return BackendBuckets;
                    })();
    
                    v1.BackendServices = (function() {
    
                        /**
                         * Constructs a new BackendServices service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a BackendServices
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function BackendServices(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (BackendServices.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = BackendServices;
    
                        /**
                         * Creates new BackendServices service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {BackendServices} RPC service. Useful where requests and/or responses are streamed.
                         */
                        BackendServices.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendServices|addSignedUrlKey}.
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @typedef AddSignedUrlKeyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AddSignedUrlKey.
                         * @function addSignedUrlKey
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IAddSignedUrlKeyBackendServiceRequest} request AddSignedUrlKeyBackendServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendServices.AddSignedUrlKeyCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendServices.prototype.addSignedUrlKey = function addSignedUrlKey(request, callback) {
                            return this.rpcCall(addSignedUrlKey, $root.google.cloud.compute.v1.AddSignedUrlKeyBackendServiceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AddSignedUrlKey" });
    
                        /**
                         * Calls AddSignedUrlKey.
                         * @function addSignedUrlKey
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IAddSignedUrlKeyBackendServiceRequest} request AddSignedUrlKeyBackendServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendServices|aggregatedList}.
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.BackendServiceAggregatedList} [response] BackendServiceAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListBackendServicesRequest} request AggregatedListBackendServicesRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendServices.AggregatedListCallback} callback Node-style callback called with the error, if any, and BackendServiceAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendServices.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListBackendServicesRequest, $root.google.cloud.compute.v1.BackendServiceAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListBackendServicesRequest} request AggregatedListBackendServicesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.BackendServiceAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendServices|delete_}.
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteBackendServiceRequest} request DeleteBackendServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendServices.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendServices.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteBackendServiceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteBackendServiceRequest} request DeleteBackendServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendServices|deleteSignedUrlKey}.
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @typedef DeleteSignedUrlKeyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls DeleteSignedUrlKey.
                         * @function deleteSignedUrlKey
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteSignedUrlKeyBackendServiceRequest} request DeleteSignedUrlKeyBackendServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendServices.DeleteSignedUrlKeyCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendServices.prototype.deleteSignedUrlKey = function deleteSignedUrlKey(request, callback) {
                            return this.rpcCall(deleteSignedUrlKey, $root.google.cloud.compute.v1.DeleteSignedUrlKeyBackendServiceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "DeleteSignedUrlKey" });
    
                        /**
                         * Calls DeleteSignedUrlKey.
                         * @function deleteSignedUrlKey
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteSignedUrlKeyBackendServiceRequest} request DeleteSignedUrlKeyBackendServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendServices|get}.
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.BackendService} [response] BackendService
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IGetBackendServiceRequest} request GetBackendServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendServices.GetCallback} callback Node-style callback called with the error, if any, and BackendService
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendServices.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetBackendServiceRequest, $root.google.cloud.compute.v1.BackendService, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IGetBackendServiceRequest} request GetBackendServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.BackendService>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendServices|getHealth}.
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @typedef GetHealthCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.BackendServiceGroupHealth} [response] BackendServiceGroupHealth
                         */
    
                        /**
                         * Calls GetHealth.
                         * @function getHealth
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IGetHealthBackendServiceRequest} request GetHealthBackendServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendServices.GetHealthCallback} callback Node-style callback called with the error, if any, and BackendServiceGroupHealth
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendServices.prototype.getHealth = function getHealth(request, callback) {
                            return this.rpcCall(getHealth, $root.google.cloud.compute.v1.GetHealthBackendServiceRequest, $root.google.cloud.compute.v1.BackendServiceGroupHealth, request, callback);
                        }, "name", { value: "GetHealth" });
    
                        /**
                         * Calls GetHealth.
                         * @function getHealth
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IGetHealthBackendServiceRequest} request GetHealthBackendServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.BackendServiceGroupHealth>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendServices|getIamPolicy}.
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @typedef GetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyBackendServiceRequest} request GetIamPolicyBackendServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendServices.GetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendServices.prototype.getIamPolicy = function getIamPolicy(request, callback) {
                            return this.rpcCall(getIamPolicy, $root.google.cloud.compute.v1.GetIamPolicyBackendServiceRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "GetIamPolicy" });
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyBackendServiceRequest} request GetIamPolicyBackendServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendServices|insert}.
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertBackendServiceRequest} request InsertBackendServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendServices.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendServices.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertBackendServiceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertBackendServiceRequest} request InsertBackendServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendServices|list}.
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.BackendServiceList} [response] BackendServiceList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IListBackendServicesRequest} request ListBackendServicesRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendServices.ListCallback} callback Node-style callback called with the error, if any, and BackendServiceList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendServices.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListBackendServicesRequest, $root.google.cloud.compute.v1.BackendServiceList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IListBackendServicesRequest} request ListBackendServicesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.BackendServiceList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendServices|patch}.
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchBackendServiceRequest} request PatchBackendServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendServices.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendServices.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchBackendServiceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchBackendServiceRequest} request PatchBackendServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendServices|setEdgeSecurityPolicy}.
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @typedef SetEdgeSecurityPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetEdgeSecurityPolicy.
                         * @function setEdgeSecurityPolicy
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.ISetEdgeSecurityPolicyBackendServiceRequest} request SetEdgeSecurityPolicyBackendServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendServices.SetEdgeSecurityPolicyCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendServices.prototype.setEdgeSecurityPolicy = function setEdgeSecurityPolicy(request, callback) {
                            return this.rpcCall(setEdgeSecurityPolicy, $root.google.cloud.compute.v1.SetEdgeSecurityPolicyBackendServiceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetEdgeSecurityPolicy" });
    
                        /**
                         * Calls SetEdgeSecurityPolicy.
                         * @function setEdgeSecurityPolicy
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.ISetEdgeSecurityPolicyBackendServiceRequest} request SetEdgeSecurityPolicyBackendServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendServices|setIamPolicy}.
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @typedef SetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyBackendServiceRequest} request SetIamPolicyBackendServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendServices.SetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendServices.prototype.setIamPolicy = function setIamPolicy(request, callback) {
                            return this.rpcCall(setIamPolicy, $root.google.cloud.compute.v1.SetIamPolicyBackendServiceRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "SetIamPolicy" });
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyBackendServiceRequest} request SetIamPolicyBackendServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendServices|setSecurityPolicy}.
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @typedef SetSecurityPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetSecurityPolicy.
                         * @function setSecurityPolicy
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.ISetSecurityPolicyBackendServiceRequest} request SetSecurityPolicyBackendServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendServices.SetSecurityPolicyCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendServices.prototype.setSecurityPolicy = function setSecurityPolicy(request, callback) {
                            return this.rpcCall(setSecurityPolicy, $root.google.cloud.compute.v1.SetSecurityPolicyBackendServiceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetSecurityPolicy" });
    
                        /**
                         * Calls SetSecurityPolicy.
                         * @function setSecurityPolicy
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.ISetSecurityPolicyBackendServiceRequest} request SetSecurityPolicyBackendServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.BackendServices|update}.
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @typedef UpdateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateBackendServiceRequest} request UpdateBackendServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.BackendServices.UpdateCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(BackendServices.prototype.update = function update(request, callback) {
                            return this.rpcCall(update, $root.google.cloud.compute.v1.UpdateBackendServiceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Update" });
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.BackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateBackendServiceRequest} request UpdateBackendServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return BackendServices;
                    })();
    
                    v1.DiskTypes = (function() {
    
                        /**
                         * Constructs a new DiskTypes service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a DiskTypes
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function DiskTypes(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (DiskTypes.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = DiskTypes;
    
                        /**
                         * Creates new DiskTypes service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.DiskTypes
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {DiskTypes} RPC service. Useful where requests and/or responses are streamed.
                         */
                        DiskTypes.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.DiskTypes|aggregatedList}.
                         * @memberof google.cloud.compute.v1.DiskTypes
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.DiskTypeAggregatedList} [response] DiskTypeAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.DiskTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListDiskTypesRequest} request AggregatedListDiskTypesRequest message or plain object
                         * @param {google.cloud.compute.v1.DiskTypes.AggregatedListCallback} callback Node-style callback called with the error, if any, and DiskTypeAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(DiskTypes.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListDiskTypesRequest, $root.google.cloud.compute.v1.DiskTypeAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.DiskTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListDiskTypesRequest} request AggregatedListDiskTypesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.DiskTypeAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.DiskTypes|get}.
                         * @memberof google.cloud.compute.v1.DiskTypes
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.DiskType} [response] DiskType
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.DiskTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IGetDiskTypeRequest} request GetDiskTypeRequest message or plain object
                         * @param {google.cloud.compute.v1.DiskTypes.GetCallback} callback Node-style callback called with the error, if any, and DiskType
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(DiskTypes.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetDiskTypeRequest, $root.google.cloud.compute.v1.DiskType, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.DiskTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IGetDiskTypeRequest} request GetDiskTypeRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.DiskType>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.DiskTypes|list}.
                         * @memberof google.cloud.compute.v1.DiskTypes
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.DiskTypeList} [response] DiskTypeList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.DiskTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IListDiskTypesRequest} request ListDiskTypesRequest message or plain object
                         * @param {google.cloud.compute.v1.DiskTypes.ListCallback} callback Node-style callback called with the error, if any, and DiskTypeList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(DiskTypes.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListDiskTypesRequest, $root.google.cloud.compute.v1.DiskTypeList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.DiskTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IListDiskTypesRequest} request ListDiskTypesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.DiskTypeList>} Promise
                         * @variation 2
                         */
    
                        return DiskTypes;
                    })();
    
                    v1.Disks = (function() {
    
                        /**
                         * Constructs a new Disks service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Disks
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function Disks(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (Disks.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = Disks;
    
                        /**
                         * Creates new Disks service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.Disks
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {Disks} RPC service. Useful where requests and/or responses are streamed.
                         */
                        Disks.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Disks|addResourcePolicies}.
                         * @memberof google.cloud.compute.v1.Disks
                         * @typedef AddResourcePoliciesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AddResourcePolicies.
                         * @function addResourcePolicies
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.IAddResourcePoliciesDiskRequest} request AddResourcePoliciesDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.Disks.AddResourcePoliciesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Disks.prototype.addResourcePolicies = function addResourcePolicies(request, callback) {
                            return this.rpcCall(addResourcePolicies, $root.google.cloud.compute.v1.AddResourcePoliciesDiskRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AddResourcePolicies" });
    
                        /**
                         * Calls AddResourcePolicies.
                         * @function addResourcePolicies
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.IAddResourcePoliciesDiskRequest} request AddResourcePoliciesDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Disks|aggregatedList}.
                         * @memberof google.cloud.compute.v1.Disks
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.DiskAggregatedList} [response] DiskAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListDisksRequest} request AggregatedListDisksRequest message or plain object
                         * @param {google.cloud.compute.v1.Disks.AggregatedListCallback} callback Node-style callback called with the error, if any, and DiskAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Disks.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListDisksRequest, $root.google.cloud.compute.v1.DiskAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListDisksRequest} request AggregatedListDisksRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.DiskAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Disks|createSnapshot}.
                         * @memberof google.cloud.compute.v1.Disks
                         * @typedef CreateSnapshotCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls CreateSnapshot.
                         * @function createSnapshot
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.ICreateSnapshotDiskRequest} request CreateSnapshotDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.Disks.CreateSnapshotCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Disks.prototype.createSnapshot = function createSnapshot(request, callback) {
                            return this.rpcCall(createSnapshot, $root.google.cloud.compute.v1.CreateSnapshotDiskRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "CreateSnapshot" });
    
                        /**
                         * Calls CreateSnapshot.
                         * @function createSnapshot
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.ICreateSnapshotDiskRequest} request CreateSnapshotDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Disks|delete_}.
                         * @memberof google.cloud.compute.v1.Disks
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteDiskRequest} request DeleteDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.Disks.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Disks.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteDiskRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteDiskRequest} request DeleteDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Disks|get}.
                         * @memberof google.cloud.compute.v1.Disks
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Disk} [response] Disk
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.IGetDiskRequest} request GetDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.Disks.GetCallback} callback Node-style callback called with the error, if any, and Disk
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Disks.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetDiskRequest, $root.google.cloud.compute.v1.Disk, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.IGetDiskRequest} request GetDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Disk>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Disks|getIamPolicy}.
                         * @memberof google.cloud.compute.v1.Disks
                         * @typedef GetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyDiskRequest} request GetIamPolicyDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.Disks.GetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Disks.prototype.getIamPolicy = function getIamPolicy(request, callback) {
                            return this.rpcCall(getIamPolicy, $root.google.cloud.compute.v1.GetIamPolicyDiskRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "GetIamPolicy" });
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyDiskRequest} request GetIamPolicyDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Disks|insert}.
                         * @memberof google.cloud.compute.v1.Disks
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertDiskRequest} request InsertDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.Disks.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Disks.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertDiskRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertDiskRequest} request InsertDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Disks|list}.
                         * @memberof google.cloud.compute.v1.Disks
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.DiskList} [response] DiskList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.IListDisksRequest} request ListDisksRequest message or plain object
                         * @param {google.cloud.compute.v1.Disks.ListCallback} callback Node-style callback called with the error, if any, and DiskList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Disks.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListDisksRequest, $root.google.cloud.compute.v1.DiskList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.IListDisksRequest} request ListDisksRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.DiskList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Disks|removeResourcePolicies}.
                         * @memberof google.cloud.compute.v1.Disks
                         * @typedef RemoveResourcePoliciesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls RemoveResourcePolicies.
                         * @function removeResourcePolicies
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveResourcePoliciesDiskRequest} request RemoveResourcePoliciesDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.Disks.RemoveResourcePoliciesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Disks.prototype.removeResourcePolicies = function removeResourcePolicies(request, callback) {
                            return this.rpcCall(removeResourcePolicies, $root.google.cloud.compute.v1.RemoveResourcePoliciesDiskRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "RemoveResourcePolicies" });
    
                        /**
                         * Calls RemoveResourcePolicies.
                         * @function removeResourcePolicies
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveResourcePoliciesDiskRequest} request RemoveResourcePoliciesDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Disks|resize}.
                         * @memberof google.cloud.compute.v1.Disks
                         * @typedef ResizeCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Resize.
                         * @function resize
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.IResizeDiskRequest} request ResizeDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.Disks.ResizeCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Disks.prototype.resize = function resize(request, callback) {
                            return this.rpcCall(resize, $root.google.cloud.compute.v1.ResizeDiskRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Resize" });
    
                        /**
                         * Calls Resize.
                         * @function resize
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.IResizeDiskRequest} request ResizeDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Disks|setIamPolicy}.
                         * @memberof google.cloud.compute.v1.Disks
                         * @typedef SetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyDiskRequest} request SetIamPolicyDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.Disks.SetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Disks.prototype.setIamPolicy = function setIamPolicy(request, callback) {
                            return this.rpcCall(setIamPolicy, $root.google.cloud.compute.v1.SetIamPolicyDiskRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "SetIamPolicy" });
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyDiskRequest} request SetIamPolicyDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Disks|setLabels}.
                         * @memberof google.cloud.compute.v1.Disks
                         * @typedef SetLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsDiskRequest} request SetLabelsDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.Disks.SetLabelsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Disks.prototype.setLabels = function setLabels(request, callback) {
                            return this.rpcCall(setLabels, $root.google.cloud.compute.v1.SetLabelsDiskRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetLabels" });
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsDiskRequest} request SetLabelsDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Disks|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.Disks
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsDiskRequest} request TestIamPermissionsDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.Disks.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Disks.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsDiskRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.Disks
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsDiskRequest} request TestIamPermissionsDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        return Disks;
                    })();
    
                    v1.ExternalVpnGateways = (function() {
    
                        /**
                         * Constructs a new ExternalVpnGateways service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an ExternalVpnGateways
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function ExternalVpnGateways(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (ExternalVpnGateways.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = ExternalVpnGateways;
    
                        /**
                         * Creates new ExternalVpnGateways service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.ExternalVpnGateways
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {ExternalVpnGateways} RPC service. Useful where requests and/or responses are streamed.
                         */
                        ExternalVpnGateways.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ExternalVpnGateways|delete_}.
                         * @memberof google.cloud.compute.v1.ExternalVpnGateways
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.ExternalVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteExternalVpnGatewayRequest} request DeleteExternalVpnGatewayRequest message or plain object
                         * @param {google.cloud.compute.v1.ExternalVpnGateways.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ExternalVpnGateways.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteExternalVpnGatewayRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.ExternalVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteExternalVpnGatewayRequest} request DeleteExternalVpnGatewayRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ExternalVpnGateways|get}.
                         * @memberof google.cloud.compute.v1.ExternalVpnGateways
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ExternalVpnGateway} [response] ExternalVpnGateway
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.ExternalVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IGetExternalVpnGatewayRequest} request GetExternalVpnGatewayRequest message or plain object
                         * @param {google.cloud.compute.v1.ExternalVpnGateways.GetCallback} callback Node-style callback called with the error, if any, and ExternalVpnGateway
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ExternalVpnGateways.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetExternalVpnGatewayRequest, $root.google.cloud.compute.v1.ExternalVpnGateway, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.ExternalVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IGetExternalVpnGatewayRequest} request GetExternalVpnGatewayRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ExternalVpnGateway>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ExternalVpnGateways|insert}.
                         * @memberof google.cloud.compute.v1.ExternalVpnGateways
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.ExternalVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertExternalVpnGatewayRequest} request InsertExternalVpnGatewayRequest message or plain object
                         * @param {google.cloud.compute.v1.ExternalVpnGateways.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ExternalVpnGateways.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertExternalVpnGatewayRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.ExternalVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertExternalVpnGatewayRequest} request InsertExternalVpnGatewayRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ExternalVpnGateways|list}.
                         * @memberof google.cloud.compute.v1.ExternalVpnGateways
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ExternalVpnGatewayList} [response] ExternalVpnGatewayList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.ExternalVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IListExternalVpnGatewaysRequest} request ListExternalVpnGatewaysRequest message or plain object
                         * @param {google.cloud.compute.v1.ExternalVpnGateways.ListCallback} callback Node-style callback called with the error, if any, and ExternalVpnGatewayList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ExternalVpnGateways.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListExternalVpnGatewaysRequest, $root.google.cloud.compute.v1.ExternalVpnGatewayList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.ExternalVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IListExternalVpnGatewaysRequest} request ListExternalVpnGatewaysRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ExternalVpnGatewayList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ExternalVpnGateways|setLabels}.
                         * @memberof google.cloud.compute.v1.ExternalVpnGateways
                         * @typedef SetLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.ExternalVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsExternalVpnGatewayRequest} request SetLabelsExternalVpnGatewayRequest message or plain object
                         * @param {google.cloud.compute.v1.ExternalVpnGateways.SetLabelsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ExternalVpnGateways.prototype.setLabels = function setLabels(request, callback) {
                            return this.rpcCall(setLabels, $root.google.cloud.compute.v1.SetLabelsExternalVpnGatewayRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetLabels" });
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.ExternalVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsExternalVpnGatewayRequest} request SetLabelsExternalVpnGatewayRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ExternalVpnGateways|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.ExternalVpnGateways
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.ExternalVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsExternalVpnGatewayRequest} request TestIamPermissionsExternalVpnGatewayRequest message or plain object
                         * @param {google.cloud.compute.v1.ExternalVpnGateways.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ExternalVpnGateways.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsExternalVpnGatewayRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.ExternalVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsExternalVpnGatewayRequest} request TestIamPermissionsExternalVpnGatewayRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        return ExternalVpnGateways;
                    })();
    
                    v1.FirewallPolicies = (function() {
    
                        /**
                         * Constructs a new FirewallPolicies service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a FirewallPolicies
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function FirewallPolicies(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (FirewallPolicies.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = FirewallPolicies;
    
                        /**
                         * Creates new FirewallPolicies service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {FirewallPolicies} RPC service. Useful where requests and/or responses are streamed.
                         */
                        FirewallPolicies.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.FirewallPolicies|addAssociation}.
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @typedef AddAssociationCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AddAssociation.
                         * @function addAssociation
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IAddAssociationFirewallPolicyRequest} request AddAssociationFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.FirewallPolicies.AddAssociationCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FirewallPolicies.prototype.addAssociation = function addAssociation(request, callback) {
                            return this.rpcCall(addAssociation, $root.google.cloud.compute.v1.AddAssociationFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AddAssociation" });
    
                        /**
                         * Calls AddAssociation.
                         * @function addAssociation
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IAddAssociationFirewallPolicyRequest} request AddAssociationFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.FirewallPolicies|addRule}.
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @typedef AddRuleCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AddRule.
                         * @function addRule
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IAddRuleFirewallPolicyRequest} request AddRuleFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.FirewallPolicies.AddRuleCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FirewallPolicies.prototype.addRule = function addRule(request, callback) {
                            return this.rpcCall(addRule, $root.google.cloud.compute.v1.AddRuleFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AddRule" });
    
                        /**
                         * Calls AddRule.
                         * @function addRule
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IAddRuleFirewallPolicyRequest} request AddRuleFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.FirewallPolicies|cloneRules}.
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @typedef CloneRulesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls CloneRules.
                         * @function cloneRules
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ICloneRulesFirewallPolicyRequest} request CloneRulesFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.FirewallPolicies.CloneRulesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FirewallPolicies.prototype.cloneRules = function cloneRules(request, callback) {
                            return this.rpcCall(cloneRules, $root.google.cloud.compute.v1.CloneRulesFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "CloneRules" });
    
                        /**
                         * Calls CloneRules.
                         * @function cloneRules
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ICloneRulesFirewallPolicyRequest} request CloneRulesFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.FirewallPolicies|delete_}.
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteFirewallPolicyRequest} request DeleteFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.FirewallPolicies.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FirewallPolicies.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteFirewallPolicyRequest} request DeleteFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.FirewallPolicies|get}.
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.FirewallPolicy} [response] FirewallPolicy
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetFirewallPolicyRequest} request GetFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.FirewallPolicies.GetCallback} callback Node-style callback called with the error, if any, and FirewallPolicy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FirewallPolicies.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetFirewallPolicyRequest, $root.google.cloud.compute.v1.FirewallPolicy, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetFirewallPolicyRequest} request GetFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.FirewallPolicy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.FirewallPolicies|getAssociation}.
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @typedef GetAssociationCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.FirewallPolicyAssociation} [response] FirewallPolicyAssociation
                         */
    
                        /**
                         * Calls GetAssociation.
                         * @function getAssociation
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetAssociationFirewallPolicyRequest} request GetAssociationFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.FirewallPolicies.GetAssociationCallback} callback Node-style callback called with the error, if any, and FirewallPolicyAssociation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FirewallPolicies.prototype.getAssociation = function getAssociation(request, callback) {
                            return this.rpcCall(getAssociation, $root.google.cloud.compute.v1.GetAssociationFirewallPolicyRequest, $root.google.cloud.compute.v1.FirewallPolicyAssociation, request, callback);
                        }, "name", { value: "GetAssociation" });
    
                        /**
                         * Calls GetAssociation.
                         * @function getAssociation
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetAssociationFirewallPolicyRequest} request GetAssociationFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.FirewallPolicyAssociation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.FirewallPolicies|getIamPolicy}.
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @typedef GetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyFirewallPolicyRequest} request GetIamPolicyFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.FirewallPolicies.GetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FirewallPolicies.prototype.getIamPolicy = function getIamPolicy(request, callback) {
                            return this.rpcCall(getIamPolicy, $root.google.cloud.compute.v1.GetIamPolicyFirewallPolicyRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "GetIamPolicy" });
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyFirewallPolicyRequest} request GetIamPolicyFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.FirewallPolicies|getRule}.
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @typedef GetRuleCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.FirewallPolicyRule} [response] FirewallPolicyRule
                         */
    
                        /**
                         * Calls GetRule.
                         * @function getRule
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRuleFirewallPolicyRequest} request GetRuleFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.FirewallPolicies.GetRuleCallback} callback Node-style callback called with the error, if any, and FirewallPolicyRule
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FirewallPolicies.prototype.getRule = function getRule(request, callback) {
                            return this.rpcCall(getRule, $root.google.cloud.compute.v1.GetRuleFirewallPolicyRequest, $root.google.cloud.compute.v1.FirewallPolicyRule, request, callback);
                        }, "name", { value: "GetRule" });
    
                        /**
                         * Calls GetRule.
                         * @function getRule
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRuleFirewallPolicyRequest} request GetRuleFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.FirewallPolicyRule>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.FirewallPolicies|insert}.
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertFirewallPolicyRequest} request InsertFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.FirewallPolicies.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FirewallPolicies.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertFirewallPolicyRequest} request InsertFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.FirewallPolicies|list}.
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.FirewallPolicyList} [response] FirewallPolicyList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListFirewallPoliciesRequest} request ListFirewallPoliciesRequest message or plain object
                         * @param {google.cloud.compute.v1.FirewallPolicies.ListCallback} callback Node-style callback called with the error, if any, and FirewallPolicyList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FirewallPolicies.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListFirewallPoliciesRequest, $root.google.cloud.compute.v1.FirewallPolicyList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListFirewallPoliciesRequest} request ListFirewallPoliciesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.FirewallPolicyList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.FirewallPolicies|listAssociations}.
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @typedef ListAssociationsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse} [response] FirewallPoliciesListAssociationsResponse
                         */
    
                        /**
                         * Calls ListAssociations.
                         * @function listAssociations
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListAssociationsFirewallPolicyRequest} request ListAssociationsFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.FirewallPolicies.ListAssociationsCallback} callback Node-style callback called with the error, if any, and FirewallPoliciesListAssociationsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FirewallPolicies.prototype.listAssociations = function listAssociations(request, callback) {
                            return this.rpcCall(listAssociations, $root.google.cloud.compute.v1.ListAssociationsFirewallPolicyRequest, $root.google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse, request, callback);
                        }, "name", { value: "ListAssociations" });
    
                        /**
                         * Calls ListAssociations.
                         * @function listAssociations
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListAssociationsFirewallPolicyRequest} request ListAssociationsFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.FirewallPoliciesListAssociationsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.FirewallPolicies|move}.
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @typedef MoveCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Move.
                         * @function move
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IMoveFirewallPolicyRequest} request MoveFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.FirewallPolicies.MoveCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FirewallPolicies.prototype.move = function move(request, callback) {
                            return this.rpcCall(move, $root.google.cloud.compute.v1.MoveFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Move" });
    
                        /**
                         * Calls Move.
                         * @function move
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IMoveFirewallPolicyRequest} request MoveFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.FirewallPolicies|patch}.
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchFirewallPolicyRequest} request PatchFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.FirewallPolicies.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FirewallPolicies.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchFirewallPolicyRequest} request PatchFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.FirewallPolicies|patchRule}.
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @typedef PatchRuleCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls PatchRule.
                         * @function patchRule
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRuleFirewallPolicyRequest} request PatchRuleFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.FirewallPolicies.PatchRuleCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FirewallPolicies.prototype.patchRule = function patchRule(request, callback) {
                            return this.rpcCall(patchRule, $root.google.cloud.compute.v1.PatchRuleFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "PatchRule" });
    
                        /**
                         * Calls PatchRule.
                         * @function patchRule
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRuleFirewallPolicyRequest} request PatchRuleFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.FirewallPolicies|removeAssociation}.
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @typedef RemoveAssociationCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls RemoveAssociation.
                         * @function removeAssociation
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveAssociationFirewallPolicyRequest} request RemoveAssociationFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.FirewallPolicies.RemoveAssociationCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FirewallPolicies.prototype.removeAssociation = function removeAssociation(request, callback) {
                            return this.rpcCall(removeAssociation, $root.google.cloud.compute.v1.RemoveAssociationFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "RemoveAssociation" });
    
                        /**
                         * Calls RemoveAssociation.
                         * @function removeAssociation
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveAssociationFirewallPolicyRequest} request RemoveAssociationFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.FirewallPolicies|removeRule}.
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @typedef RemoveRuleCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls RemoveRule.
                         * @function removeRule
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveRuleFirewallPolicyRequest} request RemoveRuleFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.FirewallPolicies.RemoveRuleCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FirewallPolicies.prototype.removeRule = function removeRule(request, callback) {
                            return this.rpcCall(removeRule, $root.google.cloud.compute.v1.RemoveRuleFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "RemoveRule" });
    
                        /**
                         * Calls RemoveRule.
                         * @function removeRule
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveRuleFirewallPolicyRequest} request RemoveRuleFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.FirewallPolicies|setIamPolicy}.
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @typedef SetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyFirewallPolicyRequest} request SetIamPolicyFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.FirewallPolicies.SetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FirewallPolicies.prototype.setIamPolicy = function setIamPolicy(request, callback) {
                            return this.rpcCall(setIamPolicy, $root.google.cloud.compute.v1.SetIamPolicyFirewallPolicyRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "SetIamPolicy" });
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyFirewallPolicyRequest} request SetIamPolicyFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.FirewallPolicies|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsFirewallPolicyRequest} request TestIamPermissionsFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.FirewallPolicies.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(FirewallPolicies.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsFirewallPolicyRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.FirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsFirewallPolicyRequest} request TestIamPermissionsFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        return FirewallPolicies;
                    })();
    
                    v1.Firewalls = (function() {
    
                        /**
                         * Constructs a new Firewalls service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Firewalls
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function Firewalls(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (Firewalls.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = Firewalls;
    
                        /**
                         * Creates new Firewalls service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.Firewalls
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {Firewalls} RPC service. Useful where requests and/or responses are streamed.
                         */
                        Firewalls.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Firewalls|delete_}.
                         * @memberof google.cloud.compute.v1.Firewalls
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Firewalls
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteFirewallRequest} request DeleteFirewallRequest message or plain object
                         * @param {google.cloud.compute.v1.Firewalls.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Firewalls.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteFirewallRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Firewalls
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteFirewallRequest} request DeleteFirewallRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Firewalls|get}.
                         * @memberof google.cloud.compute.v1.Firewalls
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Firewall} [response] Firewall
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Firewalls
                         * @instance
                         * @param {google.cloud.compute.v1.IGetFirewallRequest} request GetFirewallRequest message or plain object
                         * @param {google.cloud.compute.v1.Firewalls.GetCallback} callback Node-style callback called with the error, if any, and Firewall
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Firewalls.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetFirewallRequest, $root.google.cloud.compute.v1.Firewall, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Firewalls
                         * @instance
                         * @param {google.cloud.compute.v1.IGetFirewallRequest} request GetFirewallRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Firewall>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Firewalls|insert}.
                         * @memberof google.cloud.compute.v1.Firewalls
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Firewalls
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertFirewallRequest} request InsertFirewallRequest message or plain object
                         * @param {google.cloud.compute.v1.Firewalls.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Firewalls.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertFirewallRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Firewalls
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertFirewallRequest} request InsertFirewallRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Firewalls|list}.
                         * @memberof google.cloud.compute.v1.Firewalls
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.FirewallList} [response] FirewallList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Firewalls
                         * @instance
                         * @param {google.cloud.compute.v1.IListFirewallsRequest} request ListFirewallsRequest message or plain object
                         * @param {google.cloud.compute.v1.Firewalls.ListCallback} callback Node-style callback called with the error, if any, and FirewallList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Firewalls.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListFirewallsRequest, $root.google.cloud.compute.v1.FirewallList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Firewalls
                         * @instance
                         * @param {google.cloud.compute.v1.IListFirewallsRequest} request ListFirewallsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.FirewallList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Firewalls|patch}.
                         * @memberof google.cloud.compute.v1.Firewalls
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.Firewalls
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchFirewallRequest} request PatchFirewallRequest message or plain object
                         * @param {google.cloud.compute.v1.Firewalls.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Firewalls.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchFirewallRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.Firewalls
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchFirewallRequest} request PatchFirewallRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Firewalls|update}.
                         * @memberof google.cloud.compute.v1.Firewalls
                         * @typedef UpdateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.Firewalls
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateFirewallRequest} request UpdateFirewallRequest message or plain object
                         * @param {google.cloud.compute.v1.Firewalls.UpdateCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Firewalls.prototype.update = function update(request, callback) {
                            return this.rpcCall(update, $root.google.cloud.compute.v1.UpdateFirewallRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Update" });
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.Firewalls
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateFirewallRequest} request UpdateFirewallRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return Firewalls;
                    })();
    
                    v1.ForwardingRules = (function() {
    
                        /**
                         * Constructs a new ForwardingRules service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ForwardingRules
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function ForwardingRules(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (ForwardingRules.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = ForwardingRules;
    
                        /**
                         * Creates new ForwardingRules service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {ForwardingRules} RPC service. Useful where requests and/or responses are streamed.
                         */
                        ForwardingRules.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ForwardingRules|aggregatedList}.
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ForwardingRuleAggregatedList} [response] ForwardingRuleAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListForwardingRulesRequest} request AggregatedListForwardingRulesRequest message or plain object
                         * @param {google.cloud.compute.v1.ForwardingRules.AggregatedListCallback} callback Node-style callback called with the error, if any, and ForwardingRuleAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ForwardingRules.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListForwardingRulesRequest, $root.google.cloud.compute.v1.ForwardingRuleAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListForwardingRulesRequest} request AggregatedListForwardingRulesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ForwardingRuleAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ForwardingRules|delete_}.
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteForwardingRuleRequest} request DeleteForwardingRuleRequest message or plain object
                         * @param {google.cloud.compute.v1.ForwardingRules.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ForwardingRules.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteForwardingRuleRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteForwardingRuleRequest} request DeleteForwardingRuleRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ForwardingRules|get}.
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ForwardingRule} [response] ForwardingRule
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IGetForwardingRuleRequest} request GetForwardingRuleRequest message or plain object
                         * @param {google.cloud.compute.v1.ForwardingRules.GetCallback} callback Node-style callback called with the error, if any, and ForwardingRule
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ForwardingRules.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetForwardingRuleRequest, $root.google.cloud.compute.v1.ForwardingRule, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IGetForwardingRuleRequest} request GetForwardingRuleRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ForwardingRule>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ForwardingRules|insert}.
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertForwardingRuleRequest} request InsertForwardingRuleRequest message or plain object
                         * @param {google.cloud.compute.v1.ForwardingRules.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ForwardingRules.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertForwardingRuleRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertForwardingRuleRequest} request InsertForwardingRuleRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ForwardingRules|list}.
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ForwardingRuleList} [response] ForwardingRuleList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IListForwardingRulesRequest} request ListForwardingRulesRequest message or plain object
                         * @param {google.cloud.compute.v1.ForwardingRules.ListCallback} callback Node-style callback called with the error, if any, and ForwardingRuleList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ForwardingRules.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListForwardingRulesRequest, $root.google.cloud.compute.v1.ForwardingRuleList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IListForwardingRulesRequest} request ListForwardingRulesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ForwardingRuleList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ForwardingRules|patch}.
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchForwardingRuleRequest} request PatchForwardingRuleRequest message or plain object
                         * @param {google.cloud.compute.v1.ForwardingRules.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ForwardingRules.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchForwardingRuleRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchForwardingRuleRequest} request PatchForwardingRuleRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ForwardingRules|setLabels}.
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @typedef SetLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsForwardingRuleRequest} request SetLabelsForwardingRuleRequest message or plain object
                         * @param {google.cloud.compute.v1.ForwardingRules.SetLabelsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ForwardingRules.prototype.setLabels = function setLabels(request, callback) {
                            return this.rpcCall(setLabels, $root.google.cloud.compute.v1.SetLabelsForwardingRuleRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetLabels" });
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsForwardingRuleRequest} request SetLabelsForwardingRuleRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ForwardingRules|setTarget}.
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @typedef SetTargetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetTarget.
                         * @function setTarget
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.ISetTargetForwardingRuleRequest} request SetTargetForwardingRuleRequest message or plain object
                         * @param {google.cloud.compute.v1.ForwardingRules.SetTargetCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ForwardingRules.prototype.setTarget = function setTarget(request, callback) {
                            return this.rpcCall(setTarget, $root.google.cloud.compute.v1.SetTargetForwardingRuleRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetTarget" });
    
                        /**
                         * Calls SetTarget.
                         * @function setTarget
                         * @memberof google.cloud.compute.v1.ForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.ISetTargetForwardingRuleRequest} request SetTargetForwardingRuleRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return ForwardingRules;
                    })();
    
                    v1.GlobalAddresses = (function() {
    
                        /**
                         * Constructs a new GlobalAddresses service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GlobalAddresses
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function GlobalAddresses(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (GlobalAddresses.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = GlobalAddresses;
    
                        /**
                         * Creates new GlobalAddresses service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.GlobalAddresses
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {GlobalAddresses} RPC service. Useful where requests and/or responses are streamed.
                         */
                        GlobalAddresses.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalAddresses|delete_}.
                         * @memberof google.cloud.compute.v1.GlobalAddresses
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.GlobalAddresses
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteGlobalAddressRequest} request DeleteGlobalAddressRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalAddresses.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalAddresses.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteGlobalAddressRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.GlobalAddresses
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteGlobalAddressRequest} request DeleteGlobalAddressRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalAddresses|get}.
                         * @memberof google.cloud.compute.v1.GlobalAddresses
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Address} [response] Address
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.GlobalAddresses
                         * @instance
                         * @param {google.cloud.compute.v1.IGetGlobalAddressRequest} request GetGlobalAddressRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalAddresses.GetCallback} callback Node-style callback called with the error, if any, and Address
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalAddresses.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetGlobalAddressRequest, $root.google.cloud.compute.v1.Address, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.GlobalAddresses
                         * @instance
                         * @param {google.cloud.compute.v1.IGetGlobalAddressRequest} request GetGlobalAddressRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Address>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalAddresses|insert}.
                         * @memberof google.cloud.compute.v1.GlobalAddresses
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.GlobalAddresses
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertGlobalAddressRequest} request InsertGlobalAddressRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalAddresses.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalAddresses.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertGlobalAddressRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.GlobalAddresses
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertGlobalAddressRequest} request InsertGlobalAddressRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalAddresses|list}.
                         * @memberof google.cloud.compute.v1.GlobalAddresses
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.AddressList} [response] AddressList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.GlobalAddresses
                         * @instance
                         * @param {google.cloud.compute.v1.IListGlobalAddressesRequest} request ListGlobalAddressesRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalAddresses.ListCallback} callback Node-style callback called with the error, if any, and AddressList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalAddresses.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListGlobalAddressesRequest, $root.google.cloud.compute.v1.AddressList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.GlobalAddresses
                         * @instance
                         * @param {google.cloud.compute.v1.IListGlobalAddressesRequest} request ListGlobalAddressesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.AddressList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalAddresses|setLabels}.
                         * @memberof google.cloud.compute.v1.GlobalAddresses
                         * @typedef SetLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.GlobalAddresses
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsGlobalAddressRequest} request SetLabelsGlobalAddressRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalAddresses.SetLabelsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalAddresses.prototype.setLabels = function setLabels(request, callback) {
                            return this.rpcCall(setLabels, $root.google.cloud.compute.v1.SetLabelsGlobalAddressRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetLabels" });
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.GlobalAddresses
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsGlobalAddressRequest} request SetLabelsGlobalAddressRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return GlobalAddresses;
                    })();
    
                    v1.GlobalForwardingRules = (function() {
    
                        /**
                         * Constructs a new GlobalForwardingRules service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GlobalForwardingRules
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function GlobalForwardingRules(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (GlobalForwardingRules.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = GlobalForwardingRules;
    
                        /**
                         * Creates new GlobalForwardingRules service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {GlobalForwardingRules} RPC service. Useful where requests and/or responses are streamed.
                         */
                        GlobalForwardingRules.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalForwardingRules|delete_}.
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteGlobalForwardingRuleRequest} request DeleteGlobalForwardingRuleRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalForwardingRules.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalForwardingRules.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteGlobalForwardingRuleRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteGlobalForwardingRuleRequest} request DeleteGlobalForwardingRuleRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalForwardingRules|get}.
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ForwardingRule} [response] ForwardingRule
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IGetGlobalForwardingRuleRequest} request GetGlobalForwardingRuleRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalForwardingRules.GetCallback} callback Node-style callback called with the error, if any, and ForwardingRule
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalForwardingRules.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetGlobalForwardingRuleRequest, $root.google.cloud.compute.v1.ForwardingRule, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IGetGlobalForwardingRuleRequest} request GetGlobalForwardingRuleRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ForwardingRule>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalForwardingRules|insert}.
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertGlobalForwardingRuleRequest} request InsertGlobalForwardingRuleRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalForwardingRules.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalForwardingRules.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertGlobalForwardingRuleRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertGlobalForwardingRuleRequest} request InsertGlobalForwardingRuleRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalForwardingRules|list}.
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ForwardingRuleList} [response] ForwardingRuleList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IListGlobalForwardingRulesRequest} request ListGlobalForwardingRulesRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalForwardingRules.ListCallback} callback Node-style callback called with the error, if any, and ForwardingRuleList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalForwardingRules.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListGlobalForwardingRulesRequest, $root.google.cloud.compute.v1.ForwardingRuleList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IListGlobalForwardingRulesRequest} request ListGlobalForwardingRulesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ForwardingRuleList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalForwardingRules|patch}.
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchGlobalForwardingRuleRequest} request PatchGlobalForwardingRuleRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalForwardingRules.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalForwardingRules.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchGlobalForwardingRuleRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchGlobalForwardingRuleRequest} request PatchGlobalForwardingRuleRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalForwardingRules|setLabels}.
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @typedef SetLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsGlobalForwardingRuleRequest} request SetLabelsGlobalForwardingRuleRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalForwardingRules.SetLabelsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalForwardingRules.prototype.setLabels = function setLabels(request, callback) {
                            return this.rpcCall(setLabels, $root.google.cloud.compute.v1.SetLabelsGlobalForwardingRuleRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetLabels" });
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsGlobalForwardingRuleRequest} request SetLabelsGlobalForwardingRuleRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalForwardingRules|setTarget}.
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @typedef SetTargetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetTarget.
                         * @function setTarget
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.ISetTargetGlobalForwardingRuleRequest} request SetTargetGlobalForwardingRuleRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalForwardingRules.SetTargetCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalForwardingRules.prototype.setTarget = function setTarget(request, callback) {
                            return this.rpcCall(setTarget, $root.google.cloud.compute.v1.SetTargetGlobalForwardingRuleRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetTarget" });
    
                        /**
                         * Calls SetTarget.
                         * @function setTarget
                         * @memberof google.cloud.compute.v1.GlobalForwardingRules
                         * @instance
                         * @param {google.cloud.compute.v1.ISetTargetGlobalForwardingRuleRequest} request SetTargetGlobalForwardingRuleRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return GlobalForwardingRules;
                    })();
    
                    v1.GlobalNetworkEndpointGroups = (function() {
    
                        /**
                         * Constructs a new GlobalNetworkEndpointGroups service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GlobalNetworkEndpointGroups
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function GlobalNetworkEndpointGroups(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (GlobalNetworkEndpointGroups.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = GlobalNetworkEndpointGroups;
    
                        /**
                         * Creates new GlobalNetworkEndpointGroups service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {GlobalNetworkEndpointGroups} RPC service. Useful where requests and/or responses are streamed.
                         */
                        GlobalNetworkEndpointGroups.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalNetworkEndpointGroups|attachNetworkEndpoints}.
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @typedef AttachNetworkEndpointsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AttachNetworkEndpoints.
                         * @function attachNetworkEndpoints
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IAttachNetworkEndpointsGlobalNetworkEndpointGroupRequest} request AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalNetworkEndpointGroups.AttachNetworkEndpointsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalNetworkEndpointGroups.prototype.attachNetworkEndpoints = function attachNetworkEndpoints(request, callback) {
                            return this.rpcCall(attachNetworkEndpoints, $root.google.cloud.compute.v1.AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AttachNetworkEndpoints" });
    
                        /**
                         * Calls AttachNetworkEndpoints.
                         * @function attachNetworkEndpoints
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IAttachNetworkEndpointsGlobalNetworkEndpointGroupRequest} request AttachNetworkEndpointsGlobalNetworkEndpointGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalNetworkEndpointGroups|delete_}.
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteGlobalNetworkEndpointGroupRequest} request DeleteGlobalNetworkEndpointGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalNetworkEndpointGroups.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalNetworkEndpointGroups.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteGlobalNetworkEndpointGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteGlobalNetworkEndpointGroupRequest} request DeleteGlobalNetworkEndpointGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalNetworkEndpointGroups|detachNetworkEndpoints}.
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @typedef DetachNetworkEndpointsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls DetachNetworkEndpoints.
                         * @function detachNetworkEndpoints
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IDetachNetworkEndpointsGlobalNetworkEndpointGroupRequest} request DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalNetworkEndpointGroups.DetachNetworkEndpointsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalNetworkEndpointGroups.prototype.detachNetworkEndpoints = function detachNetworkEndpoints(request, callback) {
                            return this.rpcCall(detachNetworkEndpoints, $root.google.cloud.compute.v1.DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "DetachNetworkEndpoints" });
    
                        /**
                         * Calls DetachNetworkEndpoints.
                         * @function detachNetworkEndpoints
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IDetachNetworkEndpointsGlobalNetworkEndpointGroupRequest} request DetachNetworkEndpointsGlobalNetworkEndpointGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalNetworkEndpointGroups|get}.
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NetworkEndpointGroup} [response] NetworkEndpointGroup
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IGetGlobalNetworkEndpointGroupRequest} request GetGlobalNetworkEndpointGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalNetworkEndpointGroups.GetCallback} callback Node-style callback called with the error, if any, and NetworkEndpointGroup
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalNetworkEndpointGroups.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetGlobalNetworkEndpointGroupRequest, $root.google.cloud.compute.v1.NetworkEndpointGroup, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IGetGlobalNetworkEndpointGroupRequest} request GetGlobalNetworkEndpointGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NetworkEndpointGroup>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalNetworkEndpointGroups|insert}.
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertGlobalNetworkEndpointGroupRequest} request InsertGlobalNetworkEndpointGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalNetworkEndpointGroups.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalNetworkEndpointGroups.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertGlobalNetworkEndpointGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertGlobalNetworkEndpointGroupRequest} request InsertGlobalNetworkEndpointGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalNetworkEndpointGroups|list}.
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NetworkEndpointGroupList} [response] NetworkEndpointGroupList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListGlobalNetworkEndpointGroupsRequest} request ListGlobalNetworkEndpointGroupsRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalNetworkEndpointGroups.ListCallback} callback Node-style callback called with the error, if any, and NetworkEndpointGroupList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalNetworkEndpointGroups.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListGlobalNetworkEndpointGroupsRequest, $root.google.cloud.compute.v1.NetworkEndpointGroupList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListGlobalNetworkEndpointGroupsRequest} request ListGlobalNetworkEndpointGroupsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NetworkEndpointGroupList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalNetworkEndpointGroups|listNetworkEndpoints}.
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @typedef ListNetworkEndpointsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints} [response] NetworkEndpointGroupsListNetworkEndpoints
                         */
    
                        /**
                         * Calls ListNetworkEndpoints.
                         * @function listNetworkEndpoints
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListNetworkEndpointsGlobalNetworkEndpointGroupsRequest} request ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalNetworkEndpointGroups.ListNetworkEndpointsCallback} callback Node-style callback called with the error, if any, and NetworkEndpointGroupsListNetworkEndpoints
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalNetworkEndpointGroups.prototype.listNetworkEndpoints = function listNetworkEndpoints(request, callback) {
                            return this.rpcCall(listNetworkEndpoints, $root.google.cloud.compute.v1.ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest, $root.google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints, request, callback);
                        }, "name", { value: "ListNetworkEndpoints" });
    
                        /**
                         * Calls ListNetworkEndpoints.
                         * @function listNetworkEndpoints
                         * @memberof google.cloud.compute.v1.GlobalNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListNetworkEndpointsGlobalNetworkEndpointGroupsRequest} request ListNetworkEndpointsGlobalNetworkEndpointGroupsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints>} Promise
                         * @variation 2
                         */
    
                        return GlobalNetworkEndpointGroups;
                    })();
    
                    v1.GlobalOperations = (function() {
    
                        /**
                         * Constructs a new GlobalOperations service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GlobalOperations
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function GlobalOperations(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (GlobalOperations.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = GlobalOperations;
    
                        /**
                         * Creates new GlobalOperations service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.GlobalOperations
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {GlobalOperations} RPC service. Useful where requests and/or responses are streamed.
                         */
                        GlobalOperations.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalOperations|aggregatedList}.
                         * @memberof google.cloud.compute.v1.GlobalOperations
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.OperationAggregatedList} [response] OperationAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.GlobalOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListGlobalOperationsRequest} request AggregatedListGlobalOperationsRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalOperations.AggregatedListCallback} callback Node-style callback called with the error, if any, and OperationAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalOperations.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListGlobalOperationsRequest, $root.google.cloud.compute.v1.OperationAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.GlobalOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListGlobalOperationsRequest} request AggregatedListGlobalOperationsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.OperationAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalOperations|delete_}.
                         * @memberof google.cloud.compute.v1.GlobalOperations
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.DeleteGlobalOperationResponse} [response] DeleteGlobalOperationResponse
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.GlobalOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteGlobalOperationRequest} request DeleteGlobalOperationRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalOperations.DeleteCallback} callback Node-style callback called with the error, if any, and DeleteGlobalOperationResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalOperations.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteGlobalOperationRequest, $root.google.cloud.compute.v1.DeleteGlobalOperationResponse, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.GlobalOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteGlobalOperationRequest} request DeleteGlobalOperationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.DeleteGlobalOperationResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalOperations|get}.
                         * @memberof google.cloud.compute.v1.GlobalOperations
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.GlobalOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IGetGlobalOperationRequest} request GetGlobalOperationRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalOperations.GetCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalOperations.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetGlobalOperationRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.GlobalOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IGetGlobalOperationRequest} request GetGlobalOperationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalOperations|list}.
                         * @memberof google.cloud.compute.v1.GlobalOperations
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.OperationList} [response] OperationList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.GlobalOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IListGlobalOperationsRequest} request ListGlobalOperationsRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalOperations.ListCallback} callback Node-style callback called with the error, if any, and OperationList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalOperations.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListGlobalOperationsRequest, $root.google.cloud.compute.v1.OperationList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.GlobalOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IListGlobalOperationsRequest} request ListGlobalOperationsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.OperationList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalOperations|wait}.
                         * @memberof google.cloud.compute.v1.GlobalOperations
                         * @typedef WaitCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Wait.
                         * @function wait
                         * @memberof google.cloud.compute.v1.GlobalOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IWaitGlobalOperationRequest} request WaitGlobalOperationRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalOperations.WaitCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalOperations.prototype.wait = function wait(request, callback) {
                            return this.rpcCall(wait, $root.google.cloud.compute.v1.WaitGlobalOperationRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Wait" });
    
                        /**
                         * Calls Wait.
                         * @function wait
                         * @memberof google.cloud.compute.v1.GlobalOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IWaitGlobalOperationRequest} request WaitGlobalOperationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return GlobalOperations;
                    })();
    
                    v1.GlobalOrganizationOperations = (function() {
    
                        /**
                         * Constructs a new GlobalOrganizationOperations service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GlobalOrganizationOperations
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function GlobalOrganizationOperations(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (GlobalOrganizationOperations.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = GlobalOrganizationOperations;
    
                        /**
                         * Creates new GlobalOrganizationOperations service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.GlobalOrganizationOperations
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {GlobalOrganizationOperations} RPC service. Useful where requests and/or responses are streamed.
                         */
                        GlobalOrganizationOperations.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalOrganizationOperations|delete_}.
                         * @memberof google.cloud.compute.v1.GlobalOrganizationOperations
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse} [response] DeleteGlobalOrganizationOperationResponse
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.GlobalOrganizationOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteGlobalOrganizationOperationRequest} request DeleteGlobalOrganizationOperationRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalOrganizationOperations.DeleteCallback} callback Node-style callback called with the error, if any, and DeleteGlobalOrganizationOperationResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalOrganizationOperations.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteGlobalOrganizationOperationRequest, $root.google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.GlobalOrganizationOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteGlobalOrganizationOperationRequest} request DeleteGlobalOrganizationOperationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.DeleteGlobalOrganizationOperationResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalOrganizationOperations|get}.
                         * @memberof google.cloud.compute.v1.GlobalOrganizationOperations
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.GlobalOrganizationOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IGetGlobalOrganizationOperationRequest} request GetGlobalOrganizationOperationRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalOrganizationOperations.GetCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalOrganizationOperations.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetGlobalOrganizationOperationRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.GlobalOrganizationOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IGetGlobalOrganizationOperationRequest} request GetGlobalOrganizationOperationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalOrganizationOperations|list}.
                         * @memberof google.cloud.compute.v1.GlobalOrganizationOperations
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.OperationList} [response] OperationList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.GlobalOrganizationOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IListGlobalOrganizationOperationsRequest} request ListGlobalOrganizationOperationsRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalOrganizationOperations.ListCallback} callback Node-style callback called with the error, if any, and OperationList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalOrganizationOperations.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListGlobalOrganizationOperationsRequest, $root.google.cloud.compute.v1.OperationList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.GlobalOrganizationOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IListGlobalOrganizationOperationsRequest} request ListGlobalOrganizationOperationsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.OperationList>} Promise
                         * @variation 2
                         */
    
                        return GlobalOrganizationOperations;
                    })();
    
                    v1.GlobalPublicDelegatedPrefixes = (function() {
    
                        /**
                         * Constructs a new GlobalPublicDelegatedPrefixes service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a GlobalPublicDelegatedPrefixes
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function GlobalPublicDelegatedPrefixes(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (GlobalPublicDelegatedPrefixes.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = GlobalPublicDelegatedPrefixes;
    
                        /**
                         * Creates new GlobalPublicDelegatedPrefixes service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.GlobalPublicDelegatedPrefixes
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {GlobalPublicDelegatedPrefixes} RPC service. Useful where requests and/or responses are streamed.
                         */
                        GlobalPublicDelegatedPrefixes.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalPublicDelegatedPrefixes|delete_}.
                         * @memberof google.cloud.compute.v1.GlobalPublicDelegatedPrefixes
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.GlobalPublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteGlobalPublicDelegatedPrefixeRequest} request DeleteGlobalPublicDelegatedPrefixeRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalPublicDelegatedPrefixes.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalPublicDelegatedPrefixes.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteGlobalPublicDelegatedPrefixeRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.GlobalPublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteGlobalPublicDelegatedPrefixeRequest} request DeleteGlobalPublicDelegatedPrefixeRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalPublicDelegatedPrefixes|get}.
                         * @memberof google.cloud.compute.v1.GlobalPublicDelegatedPrefixes
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.PublicDelegatedPrefix} [response] PublicDelegatedPrefix
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.GlobalPublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IGetGlobalPublicDelegatedPrefixeRequest} request GetGlobalPublicDelegatedPrefixeRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalPublicDelegatedPrefixes.GetCallback} callback Node-style callback called with the error, if any, and PublicDelegatedPrefix
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalPublicDelegatedPrefixes.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetGlobalPublicDelegatedPrefixeRequest, $root.google.cloud.compute.v1.PublicDelegatedPrefix, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.GlobalPublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IGetGlobalPublicDelegatedPrefixeRequest} request GetGlobalPublicDelegatedPrefixeRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.PublicDelegatedPrefix>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalPublicDelegatedPrefixes|insert}.
                         * @memberof google.cloud.compute.v1.GlobalPublicDelegatedPrefixes
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.GlobalPublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertGlobalPublicDelegatedPrefixeRequest} request InsertGlobalPublicDelegatedPrefixeRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalPublicDelegatedPrefixes.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalPublicDelegatedPrefixes.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertGlobalPublicDelegatedPrefixeRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.GlobalPublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertGlobalPublicDelegatedPrefixeRequest} request InsertGlobalPublicDelegatedPrefixeRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalPublicDelegatedPrefixes|list}.
                         * @memberof google.cloud.compute.v1.GlobalPublicDelegatedPrefixes
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.PublicDelegatedPrefixList} [response] PublicDelegatedPrefixList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.GlobalPublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IListGlobalPublicDelegatedPrefixesRequest} request ListGlobalPublicDelegatedPrefixesRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalPublicDelegatedPrefixes.ListCallback} callback Node-style callback called with the error, if any, and PublicDelegatedPrefixList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalPublicDelegatedPrefixes.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListGlobalPublicDelegatedPrefixesRequest, $root.google.cloud.compute.v1.PublicDelegatedPrefixList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.GlobalPublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IListGlobalPublicDelegatedPrefixesRequest} request ListGlobalPublicDelegatedPrefixesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.PublicDelegatedPrefixList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.GlobalPublicDelegatedPrefixes|patch}.
                         * @memberof google.cloud.compute.v1.GlobalPublicDelegatedPrefixes
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.GlobalPublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchGlobalPublicDelegatedPrefixeRequest} request PatchGlobalPublicDelegatedPrefixeRequest message or plain object
                         * @param {google.cloud.compute.v1.GlobalPublicDelegatedPrefixes.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(GlobalPublicDelegatedPrefixes.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchGlobalPublicDelegatedPrefixeRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.GlobalPublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchGlobalPublicDelegatedPrefixeRequest} request PatchGlobalPublicDelegatedPrefixeRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return GlobalPublicDelegatedPrefixes;
                    })();
    
                    v1.HealthChecks = (function() {
    
                        /**
                         * Constructs a new HealthChecks service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a HealthChecks
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function HealthChecks(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (HealthChecks.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = HealthChecks;
    
                        /**
                         * Creates new HealthChecks service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {HealthChecks} RPC service. Useful where requests and/or responses are streamed.
                         */
                        HealthChecks.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.HealthChecks|aggregatedList}.
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.HealthChecksAggregatedList} [response] HealthChecksAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListHealthChecksRequest} request AggregatedListHealthChecksRequest message or plain object
                         * @param {google.cloud.compute.v1.HealthChecks.AggregatedListCallback} callback Node-style callback called with the error, if any, and HealthChecksAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(HealthChecks.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListHealthChecksRequest, $root.google.cloud.compute.v1.HealthChecksAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListHealthChecksRequest} request AggregatedListHealthChecksRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.HealthChecksAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.HealthChecks|delete_}.
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteHealthCheckRequest} request DeleteHealthCheckRequest message or plain object
                         * @param {google.cloud.compute.v1.HealthChecks.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(HealthChecks.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteHealthCheckRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteHealthCheckRequest} request DeleteHealthCheckRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.HealthChecks|get}.
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.HealthCheck} [response] HealthCheck
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IGetHealthCheckRequest} request GetHealthCheckRequest message or plain object
                         * @param {google.cloud.compute.v1.HealthChecks.GetCallback} callback Node-style callback called with the error, if any, and HealthCheck
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(HealthChecks.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetHealthCheckRequest, $root.google.cloud.compute.v1.HealthCheck, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IGetHealthCheckRequest} request GetHealthCheckRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.HealthCheck>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.HealthChecks|insert}.
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertHealthCheckRequest} request InsertHealthCheckRequest message or plain object
                         * @param {google.cloud.compute.v1.HealthChecks.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(HealthChecks.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertHealthCheckRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertHealthCheckRequest} request InsertHealthCheckRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.HealthChecks|list}.
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.HealthCheckList} [response] HealthCheckList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IListHealthChecksRequest} request ListHealthChecksRequest message or plain object
                         * @param {google.cloud.compute.v1.HealthChecks.ListCallback} callback Node-style callback called with the error, if any, and HealthCheckList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(HealthChecks.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListHealthChecksRequest, $root.google.cloud.compute.v1.HealthCheckList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IListHealthChecksRequest} request ListHealthChecksRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.HealthCheckList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.HealthChecks|patch}.
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchHealthCheckRequest} request PatchHealthCheckRequest message or plain object
                         * @param {google.cloud.compute.v1.HealthChecks.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(HealthChecks.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchHealthCheckRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchHealthCheckRequest} request PatchHealthCheckRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.HealthChecks|update}.
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @typedef UpdateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateHealthCheckRequest} request UpdateHealthCheckRequest message or plain object
                         * @param {google.cloud.compute.v1.HealthChecks.UpdateCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(HealthChecks.prototype.update = function update(request, callback) {
                            return this.rpcCall(update, $root.google.cloud.compute.v1.UpdateHealthCheckRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Update" });
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.HealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateHealthCheckRequest} request UpdateHealthCheckRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return HealthChecks;
                    })();
    
                    v1.ImageFamilyViews = (function() {
    
                        /**
                         * Constructs a new ImageFamilyViews service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an ImageFamilyViews
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function ImageFamilyViews(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (ImageFamilyViews.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = ImageFamilyViews;
    
                        /**
                         * Creates new ImageFamilyViews service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.ImageFamilyViews
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {ImageFamilyViews} RPC service. Useful where requests and/or responses are streamed.
                         */
                        ImageFamilyViews.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ImageFamilyViews|get}.
                         * @memberof google.cloud.compute.v1.ImageFamilyViews
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ImageFamilyView} [response] ImageFamilyView
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.ImageFamilyViews
                         * @instance
                         * @param {google.cloud.compute.v1.IGetImageFamilyViewRequest} request GetImageFamilyViewRequest message or plain object
                         * @param {google.cloud.compute.v1.ImageFamilyViews.GetCallback} callback Node-style callback called with the error, if any, and ImageFamilyView
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ImageFamilyViews.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetImageFamilyViewRequest, $root.google.cloud.compute.v1.ImageFamilyView, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.ImageFamilyViews
                         * @instance
                         * @param {google.cloud.compute.v1.IGetImageFamilyViewRequest} request GetImageFamilyViewRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ImageFamilyView>} Promise
                         * @variation 2
                         */
    
                        return ImageFamilyViews;
                    })();
    
                    v1.Images = (function() {
    
                        /**
                         * Constructs a new Images service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an Images
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function Images(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (Images.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = Images;
    
                        /**
                         * Creates new Images service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.Images
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {Images} RPC service. Useful where requests and/or responses are streamed.
                         */
                        Images.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Images|delete_}.
                         * @memberof google.cloud.compute.v1.Images
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteImageRequest} request DeleteImageRequest message or plain object
                         * @param {google.cloud.compute.v1.Images.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Images.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteImageRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteImageRequest} request DeleteImageRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Images|deprecate}.
                         * @memberof google.cloud.compute.v1.Images
                         * @typedef DeprecateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Deprecate.
                         * @function deprecate
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.IDeprecateImageRequest} request DeprecateImageRequest message or plain object
                         * @param {google.cloud.compute.v1.Images.DeprecateCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Images.prototype.deprecate = function deprecate(request, callback) {
                            return this.rpcCall(deprecate, $root.google.cloud.compute.v1.DeprecateImageRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Deprecate" });
    
                        /**
                         * Calls Deprecate.
                         * @function deprecate
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.IDeprecateImageRequest} request DeprecateImageRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Images|get}.
                         * @memberof google.cloud.compute.v1.Images
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Image} [response] Image
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.IGetImageRequest} request GetImageRequest message or plain object
                         * @param {google.cloud.compute.v1.Images.GetCallback} callback Node-style callback called with the error, if any, and Image
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Images.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetImageRequest, $root.google.cloud.compute.v1.Image, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.IGetImageRequest} request GetImageRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Image>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Images|getFromFamily}.
                         * @memberof google.cloud.compute.v1.Images
                         * @typedef GetFromFamilyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Image} [response] Image
                         */
    
                        /**
                         * Calls GetFromFamily.
                         * @function getFromFamily
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.IGetFromFamilyImageRequest} request GetFromFamilyImageRequest message or plain object
                         * @param {google.cloud.compute.v1.Images.GetFromFamilyCallback} callback Node-style callback called with the error, if any, and Image
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Images.prototype.getFromFamily = function getFromFamily(request, callback) {
                            return this.rpcCall(getFromFamily, $root.google.cloud.compute.v1.GetFromFamilyImageRequest, $root.google.cloud.compute.v1.Image, request, callback);
                        }, "name", { value: "GetFromFamily" });
    
                        /**
                         * Calls GetFromFamily.
                         * @function getFromFamily
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.IGetFromFamilyImageRequest} request GetFromFamilyImageRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Image>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Images|getIamPolicy}.
                         * @memberof google.cloud.compute.v1.Images
                         * @typedef GetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyImageRequest} request GetIamPolicyImageRequest message or plain object
                         * @param {google.cloud.compute.v1.Images.GetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Images.prototype.getIamPolicy = function getIamPolicy(request, callback) {
                            return this.rpcCall(getIamPolicy, $root.google.cloud.compute.v1.GetIamPolicyImageRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "GetIamPolicy" });
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyImageRequest} request GetIamPolicyImageRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Images|insert}.
                         * @memberof google.cloud.compute.v1.Images
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertImageRequest} request InsertImageRequest message or plain object
                         * @param {google.cloud.compute.v1.Images.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Images.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertImageRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertImageRequest} request InsertImageRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Images|list}.
                         * @memberof google.cloud.compute.v1.Images
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ImageList} [response] ImageList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.IListImagesRequest} request ListImagesRequest message or plain object
                         * @param {google.cloud.compute.v1.Images.ListCallback} callback Node-style callback called with the error, if any, and ImageList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Images.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListImagesRequest, $root.google.cloud.compute.v1.ImageList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.IListImagesRequest} request ListImagesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ImageList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Images|patch}.
                         * @memberof google.cloud.compute.v1.Images
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchImageRequest} request PatchImageRequest message or plain object
                         * @param {google.cloud.compute.v1.Images.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Images.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchImageRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchImageRequest} request PatchImageRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Images|setIamPolicy}.
                         * @memberof google.cloud.compute.v1.Images
                         * @typedef SetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyImageRequest} request SetIamPolicyImageRequest message or plain object
                         * @param {google.cloud.compute.v1.Images.SetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Images.prototype.setIamPolicy = function setIamPolicy(request, callback) {
                            return this.rpcCall(setIamPolicy, $root.google.cloud.compute.v1.SetIamPolicyImageRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "SetIamPolicy" });
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyImageRequest} request SetIamPolicyImageRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Images|setLabels}.
                         * @memberof google.cloud.compute.v1.Images
                         * @typedef SetLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsImageRequest} request SetLabelsImageRequest message or plain object
                         * @param {google.cloud.compute.v1.Images.SetLabelsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Images.prototype.setLabels = function setLabels(request, callback) {
                            return this.rpcCall(setLabels, $root.google.cloud.compute.v1.SetLabelsImageRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetLabels" });
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsImageRequest} request SetLabelsImageRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Images|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.Images
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsImageRequest} request TestIamPermissionsImageRequest message or plain object
                         * @param {google.cloud.compute.v1.Images.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Images.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsImageRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.Images
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsImageRequest} request TestIamPermissionsImageRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        return Images;
                    })();
    
                    v1.InstanceGroupManagers = (function() {
    
                        /**
                         * Constructs a new InstanceGroupManagers service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroupManagers
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function InstanceGroupManagers(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (InstanceGroupManagers.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = InstanceGroupManagers;
    
                        /**
                         * Creates new InstanceGroupManagers service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {InstanceGroupManagers} RPC service. Useful where requests and/or responses are streamed.
                         */
                        InstanceGroupManagers.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroupManagers|abandonInstances}.
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @typedef AbandonInstancesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AbandonInstances.
                         * @function abandonInstances
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IAbandonInstancesInstanceGroupManagerRequest} request AbandonInstancesInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroupManagers.AbandonInstancesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroupManagers.prototype.abandonInstances = function abandonInstances(request, callback) {
                            return this.rpcCall(abandonInstances, $root.google.cloud.compute.v1.AbandonInstancesInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AbandonInstances" });
    
                        /**
                         * Calls AbandonInstances.
                         * @function abandonInstances
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IAbandonInstancesInstanceGroupManagerRequest} request AbandonInstancesInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroupManagers|aggregatedList}.
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InstanceGroupManagerAggregatedList} [response] InstanceGroupManagerAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListInstanceGroupManagersRequest} request AggregatedListInstanceGroupManagersRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroupManagers.AggregatedListCallback} callback Node-style callback called with the error, if any, and InstanceGroupManagerAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroupManagers.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListInstanceGroupManagersRequest, $root.google.cloud.compute.v1.InstanceGroupManagerAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListInstanceGroupManagersRequest} request AggregatedListInstanceGroupManagersRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InstanceGroupManagerAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroupManagers|applyUpdatesToInstances}.
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @typedef ApplyUpdatesToInstancesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls ApplyUpdatesToInstances.
                         * @function applyUpdatesToInstances
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IApplyUpdatesToInstancesInstanceGroupManagerRequest} request ApplyUpdatesToInstancesInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroupManagers.ApplyUpdatesToInstancesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroupManagers.prototype.applyUpdatesToInstances = function applyUpdatesToInstances(request, callback) {
                            return this.rpcCall(applyUpdatesToInstances, $root.google.cloud.compute.v1.ApplyUpdatesToInstancesInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "ApplyUpdatesToInstances" });
    
                        /**
                         * Calls ApplyUpdatesToInstances.
                         * @function applyUpdatesToInstances
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IApplyUpdatesToInstancesInstanceGroupManagerRequest} request ApplyUpdatesToInstancesInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroupManagers|createInstances}.
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @typedef CreateInstancesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls CreateInstances.
                         * @function createInstances
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.ICreateInstancesInstanceGroupManagerRequest} request CreateInstancesInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroupManagers.CreateInstancesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroupManagers.prototype.createInstances = function createInstances(request, callback) {
                            return this.rpcCall(createInstances, $root.google.cloud.compute.v1.CreateInstancesInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "CreateInstances" });
    
                        /**
                         * Calls CreateInstances.
                         * @function createInstances
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.ICreateInstancesInstanceGroupManagerRequest} request CreateInstancesInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroupManagers|delete_}.
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteInstanceGroupManagerRequest} request DeleteInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroupManagers.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroupManagers.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteInstanceGroupManagerRequest} request DeleteInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroupManagers|deleteInstances}.
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @typedef DeleteInstancesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls DeleteInstances.
                         * @function deleteInstances
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteInstancesInstanceGroupManagerRequest} request DeleteInstancesInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroupManagers.DeleteInstancesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroupManagers.prototype.deleteInstances = function deleteInstances(request, callback) {
                            return this.rpcCall(deleteInstances, $root.google.cloud.compute.v1.DeleteInstancesInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "DeleteInstances" });
    
                        /**
                         * Calls DeleteInstances.
                         * @function deleteInstances
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteInstancesInstanceGroupManagerRequest} request DeleteInstancesInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroupManagers|deletePerInstanceConfigs}.
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @typedef DeletePerInstanceConfigsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls DeletePerInstanceConfigs.
                         * @function deletePerInstanceConfigs
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IDeletePerInstanceConfigsInstanceGroupManagerRequest} request DeletePerInstanceConfigsInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroupManagers.DeletePerInstanceConfigsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroupManagers.prototype.deletePerInstanceConfigs = function deletePerInstanceConfigs(request, callback) {
                            return this.rpcCall(deletePerInstanceConfigs, $root.google.cloud.compute.v1.DeletePerInstanceConfigsInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "DeletePerInstanceConfigs" });
    
                        /**
                         * Calls DeletePerInstanceConfigs.
                         * @function deletePerInstanceConfigs
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IDeletePerInstanceConfigsInstanceGroupManagerRequest} request DeletePerInstanceConfigsInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroupManagers|get}.
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InstanceGroupManager} [response] InstanceGroupManager
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IGetInstanceGroupManagerRequest} request GetInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroupManagers.GetCallback} callback Node-style callback called with the error, if any, and InstanceGroupManager
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroupManagers.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetInstanceGroupManagerRequest, $root.google.cloud.compute.v1.InstanceGroupManager, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IGetInstanceGroupManagerRequest} request GetInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InstanceGroupManager>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroupManagers|insert}.
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertInstanceGroupManagerRequest} request InsertInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroupManagers.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroupManagers.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertInstanceGroupManagerRequest} request InsertInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroupManagers|list}.
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InstanceGroupManagerList} [response] InstanceGroupManagerList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IListInstanceGroupManagersRequest} request ListInstanceGroupManagersRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroupManagers.ListCallback} callback Node-style callback called with the error, if any, and InstanceGroupManagerList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroupManagers.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListInstanceGroupManagersRequest, $root.google.cloud.compute.v1.InstanceGroupManagerList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IListInstanceGroupManagersRequest} request ListInstanceGroupManagersRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InstanceGroupManagerList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroupManagers|listErrors}.
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @typedef ListErrorsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse} [response] InstanceGroupManagersListErrorsResponse
                         */
    
                        /**
                         * Calls ListErrors.
                         * @function listErrors
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IListErrorsInstanceGroupManagersRequest} request ListErrorsInstanceGroupManagersRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroupManagers.ListErrorsCallback} callback Node-style callback called with the error, if any, and InstanceGroupManagersListErrorsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroupManagers.prototype.listErrors = function listErrors(request, callback) {
                            return this.rpcCall(listErrors, $root.google.cloud.compute.v1.ListErrorsInstanceGroupManagersRequest, $root.google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse, request, callback);
                        }, "name", { value: "ListErrors" });
    
                        /**
                         * Calls ListErrors.
                         * @function listErrors
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IListErrorsInstanceGroupManagersRequest} request ListErrorsInstanceGroupManagersRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InstanceGroupManagersListErrorsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroupManagers|listManagedInstances}.
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @typedef ListManagedInstancesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse} [response] InstanceGroupManagersListManagedInstancesResponse
                         */
    
                        /**
                         * Calls ListManagedInstances.
                         * @function listManagedInstances
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IListManagedInstancesInstanceGroupManagersRequest} request ListManagedInstancesInstanceGroupManagersRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroupManagers.ListManagedInstancesCallback} callback Node-style callback called with the error, if any, and InstanceGroupManagersListManagedInstancesResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroupManagers.prototype.listManagedInstances = function listManagedInstances(request, callback) {
                            return this.rpcCall(listManagedInstances, $root.google.cloud.compute.v1.ListManagedInstancesInstanceGroupManagersRequest, $root.google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse, request, callback);
                        }, "name", { value: "ListManagedInstances" });
    
                        /**
                         * Calls ListManagedInstances.
                         * @function listManagedInstances
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IListManagedInstancesInstanceGroupManagersRequest} request ListManagedInstancesInstanceGroupManagersRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InstanceGroupManagersListManagedInstancesResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroupManagers|listPerInstanceConfigs}.
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @typedef ListPerInstanceConfigsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp} [response] InstanceGroupManagersListPerInstanceConfigsResp
                         */
    
                        /**
                         * Calls ListPerInstanceConfigs.
                         * @function listPerInstanceConfigs
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IListPerInstanceConfigsInstanceGroupManagersRequest} request ListPerInstanceConfigsInstanceGroupManagersRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroupManagers.ListPerInstanceConfigsCallback} callback Node-style callback called with the error, if any, and InstanceGroupManagersListPerInstanceConfigsResp
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroupManagers.prototype.listPerInstanceConfigs = function listPerInstanceConfigs(request, callback) {
                            return this.rpcCall(listPerInstanceConfigs, $root.google.cloud.compute.v1.ListPerInstanceConfigsInstanceGroupManagersRequest, $root.google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp, request, callback);
                        }, "name", { value: "ListPerInstanceConfigs" });
    
                        /**
                         * Calls ListPerInstanceConfigs.
                         * @function listPerInstanceConfigs
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IListPerInstanceConfigsInstanceGroupManagersRequest} request ListPerInstanceConfigsInstanceGroupManagersRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InstanceGroupManagersListPerInstanceConfigsResp>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroupManagers|patch}.
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchInstanceGroupManagerRequest} request PatchInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroupManagers.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroupManagers.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchInstanceGroupManagerRequest} request PatchInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroupManagers|patchPerInstanceConfigs}.
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @typedef PatchPerInstanceConfigsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls PatchPerInstanceConfigs.
                         * @function patchPerInstanceConfigs
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchPerInstanceConfigsInstanceGroupManagerRequest} request PatchPerInstanceConfigsInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroupManagers.PatchPerInstanceConfigsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroupManagers.prototype.patchPerInstanceConfigs = function patchPerInstanceConfigs(request, callback) {
                            return this.rpcCall(patchPerInstanceConfigs, $root.google.cloud.compute.v1.PatchPerInstanceConfigsInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "PatchPerInstanceConfigs" });
    
                        /**
                         * Calls PatchPerInstanceConfigs.
                         * @function patchPerInstanceConfigs
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchPerInstanceConfigsInstanceGroupManagerRequest} request PatchPerInstanceConfigsInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroupManagers|recreateInstances}.
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @typedef RecreateInstancesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls RecreateInstances.
                         * @function recreateInstances
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IRecreateInstancesInstanceGroupManagerRequest} request RecreateInstancesInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroupManagers.RecreateInstancesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroupManagers.prototype.recreateInstances = function recreateInstances(request, callback) {
                            return this.rpcCall(recreateInstances, $root.google.cloud.compute.v1.RecreateInstancesInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "RecreateInstances" });
    
                        /**
                         * Calls RecreateInstances.
                         * @function recreateInstances
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IRecreateInstancesInstanceGroupManagerRequest} request RecreateInstancesInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroupManagers|resize}.
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @typedef ResizeCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Resize.
                         * @function resize
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IResizeInstanceGroupManagerRequest} request ResizeInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroupManagers.ResizeCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroupManagers.prototype.resize = function resize(request, callback) {
                            return this.rpcCall(resize, $root.google.cloud.compute.v1.ResizeInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Resize" });
    
                        /**
                         * Calls Resize.
                         * @function resize
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IResizeInstanceGroupManagerRequest} request ResizeInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroupManagers|setInstanceTemplate}.
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @typedef SetInstanceTemplateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetInstanceTemplate.
                         * @function setInstanceTemplate
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.ISetInstanceTemplateInstanceGroupManagerRequest} request SetInstanceTemplateInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroupManagers.SetInstanceTemplateCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroupManagers.prototype.setInstanceTemplate = function setInstanceTemplate(request, callback) {
                            return this.rpcCall(setInstanceTemplate, $root.google.cloud.compute.v1.SetInstanceTemplateInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetInstanceTemplate" });
    
                        /**
                         * Calls SetInstanceTemplate.
                         * @function setInstanceTemplate
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.ISetInstanceTemplateInstanceGroupManagerRequest} request SetInstanceTemplateInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroupManagers|setTargetPools}.
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @typedef SetTargetPoolsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetTargetPools.
                         * @function setTargetPools
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.ISetTargetPoolsInstanceGroupManagerRequest} request SetTargetPoolsInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroupManagers.SetTargetPoolsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroupManagers.prototype.setTargetPools = function setTargetPools(request, callback) {
                            return this.rpcCall(setTargetPools, $root.google.cloud.compute.v1.SetTargetPoolsInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetTargetPools" });
    
                        /**
                         * Calls SetTargetPools.
                         * @function setTargetPools
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.ISetTargetPoolsInstanceGroupManagerRequest} request SetTargetPoolsInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroupManagers|updatePerInstanceConfigs}.
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @typedef UpdatePerInstanceConfigsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls UpdatePerInstanceConfigs.
                         * @function updatePerInstanceConfigs
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdatePerInstanceConfigsInstanceGroupManagerRequest} request UpdatePerInstanceConfigsInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroupManagers.UpdatePerInstanceConfigsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroupManagers.prototype.updatePerInstanceConfigs = function updatePerInstanceConfigs(request, callback) {
                            return this.rpcCall(updatePerInstanceConfigs, $root.google.cloud.compute.v1.UpdatePerInstanceConfigsInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "UpdatePerInstanceConfigs" });
    
                        /**
                         * Calls UpdatePerInstanceConfigs.
                         * @function updatePerInstanceConfigs
                         * @memberof google.cloud.compute.v1.InstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdatePerInstanceConfigsInstanceGroupManagerRequest} request UpdatePerInstanceConfigsInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return InstanceGroupManagers;
                    })();
    
                    v1.InstanceGroups = (function() {
    
                        /**
                         * Constructs a new InstanceGroups service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceGroups
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function InstanceGroups(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (InstanceGroups.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = InstanceGroups;
    
                        /**
                         * Creates new InstanceGroups service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {InstanceGroups} RPC service. Useful where requests and/or responses are streamed.
                         */
                        InstanceGroups.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroups|addInstances}.
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @typedef AddInstancesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AddInstances.
                         * @function addInstances
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IAddInstancesInstanceGroupRequest} request AddInstancesInstanceGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroups.AddInstancesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroups.prototype.addInstances = function addInstances(request, callback) {
                            return this.rpcCall(addInstances, $root.google.cloud.compute.v1.AddInstancesInstanceGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AddInstances" });
    
                        /**
                         * Calls AddInstances.
                         * @function addInstances
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IAddInstancesInstanceGroupRequest} request AddInstancesInstanceGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroups|aggregatedList}.
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InstanceGroupAggregatedList} [response] InstanceGroupAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListInstanceGroupsRequest} request AggregatedListInstanceGroupsRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroups.AggregatedListCallback} callback Node-style callback called with the error, if any, and InstanceGroupAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroups.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListInstanceGroupsRequest, $root.google.cloud.compute.v1.InstanceGroupAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListInstanceGroupsRequest} request AggregatedListInstanceGroupsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InstanceGroupAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroups|delete_}.
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteInstanceGroupRequest} request DeleteInstanceGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroups.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroups.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteInstanceGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteInstanceGroupRequest} request DeleteInstanceGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroups|get}.
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InstanceGroup} [response] InstanceGroup
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IGetInstanceGroupRequest} request GetInstanceGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroups.GetCallback} callback Node-style callback called with the error, if any, and InstanceGroup
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroups.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetInstanceGroupRequest, $root.google.cloud.compute.v1.InstanceGroup, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IGetInstanceGroupRequest} request GetInstanceGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InstanceGroup>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroups|insert}.
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertInstanceGroupRequest} request InsertInstanceGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroups.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroups.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertInstanceGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertInstanceGroupRequest} request InsertInstanceGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroups|list}.
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InstanceGroupList} [response] InstanceGroupList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListInstanceGroupsRequest} request ListInstanceGroupsRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroups.ListCallback} callback Node-style callback called with the error, if any, and InstanceGroupList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroups.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListInstanceGroupsRequest, $root.google.cloud.compute.v1.InstanceGroupList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListInstanceGroupsRequest} request ListInstanceGroupsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InstanceGroupList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroups|listInstances}.
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @typedef ListInstancesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InstanceGroupsListInstances} [response] InstanceGroupsListInstances
                         */
    
                        /**
                         * Calls ListInstances.
                         * @function listInstances
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListInstancesInstanceGroupsRequest} request ListInstancesInstanceGroupsRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroups.ListInstancesCallback} callback Node-style callback called with the error, if any, and InstanceGroupsListInstances
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroups.prototype.listInstances = function listInstances(request, callback) {
                            return this.rpcCall(listInstances, $root.google.cloud.compute.v1.ListInstancesInstanceGroupsRequest, $root.google.cloud.compute.v1.InstanceGroupsListInstances, request, callback);
                        }, "name", { value: "ListInstances" });
    
                        /**
                         * Calls ListInstances.
                         * @function listInstances
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListInstancesInstanceGroupsRequest} request ListInstancesInstanceGroupsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InstanceGroupsListInstances>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroups|removeInstances}.
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @typedef RemoveInstancesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls RemoveInstances.
                         * @function removeInstances
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveInstancesInstanceGroupRequest} request RemoveInstancesInstanceGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroups.RemoveInstancesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroups.prototype.removeInstances = function removeInstances(request, callback) {
                            return this.rpcCall(removeInstances, $root.google.cloud.compute.v1.RemoveInstancesInstanceGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "RemoveInstances" });
    
                        /**
                         * Calls RemoveInstances.
                         * @function removeInstances
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveInstancesInstanceGroupRequest} request RemoveInstancesInstanceGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceGroups|setNamedPorts}.
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @typedef SetNamedPortsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetNamedPorts.
                         * @function setNamedPorts
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.ISetNamedPortsInstanceGroupRequest} request SetNamedPortsInstanceGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceGroups.SetNamedPortsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceGroups.prototype.setNamedPorts = function setNamedPorts(request, callback) {
                            return this.rpcCall(setNamedPorts, $root.google.cloud.compute.v1.SetNamedPortsInstanceGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetNamedPorts" });
    
                        /**
                         * Calls SetNamedPorts.
                         * @function setNamedPorts
                         * @memberof google.cloud.compute.v1.InstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.ISetNamedPortsInstanceGroupRequest} request SetNamedPortsInstanceGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return InstanceGroups;
                    })();
    
                    v1.InstanceTemplates = (function() {
    
                        /**
                         * Constructs a new InstanceTemplates service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InstanceTemplates
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function InstanceTemplates(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (InstanceTemplates.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = InstanceTemplates;
    
                        /**
                         * Creates new InstanceTemplates service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {InstanceTemplates} RPC service. Useful where requests and/or responses are streamed.
                         */
                        InstanceTemplates.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceTemplates|delete_}.
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteInstanceTemplateRequest} request DeleteInstanceTemplateRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceTemplates.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceTemplates.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteInstanceTemplateRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteInstanceTemplateRequest} request DeleteInstanceTemplateRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceTemplates|get}.
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InstanceTemplate} [response] InstanceTemplate
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IGetInstanceTemplateRequest} request GetInstanceTemplateRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceTemplates.GetCallback} callback Node-style callback called with the error, if any, and InstanceTemplate
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceTemplates.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetInstanceTemplateRequest, $root.google.cloud.compute.v1.InstanceTemplate, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IGetInstanceTemplateRequest} request GetInstanceTemplateRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InstanceTemplate>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceTemplates|getIamPolicy}.
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @typedef GetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyInstanceTemplateRequest} request GetIamPolicyInstanceTemplateRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceTemplates.GetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceTemplates.prototype.getIamPolicy = function getIamPolicy(request, callback) {
                            return this.rpcCall(getIamPolicy, $root.google.cloud.compute.v1.GetIamPolicyInstanceTemplateRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "GetIamPolicy" });
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyInstanceTemplateRequest} request GetIamPolicyInstanceTemplateRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceTemplates|insert}.
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertInstanceTemplateRequest} request InsertInstanceTemplateRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceTemplates.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceTemplates.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertInstanceTemplateRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertInstanceTemplateRequest} request InsertInstanceTemplateRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceTemplates|list}.
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InstanceTemplateList} [response] InstanceTemplateList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IListInstanceTemplatesRequest} request ListInstanceTemplatesRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceTemplates.ListCallback} callback Node-style callback called with the error, if any, and InstanceTemplateList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceTemplates.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListInstanceTemplatesRequest, $root.google.cloud.compute.v1.InstanceTemplateList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IListInstanceTemplatesRequest} request ListInstanceTemplatesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InstanceTemplateList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceTemplates|setIamPolicy}.
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @typedef SetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyInstanceTemplateRequest} request SetIamPolicyInstanceTemplateRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceTemplates.SetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceTemplates.prototype.setIamPolicy = function setIamPolicy(request, callback) {
                            return this.rpcCall(setIamPolicy, $root.google.cloud.compute.v1.SetIamPolicyInstanceTemplateRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "SetIamPolicy" });
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyInstanceTemplateRequest} request SetIamPolicyInstanceTemplateRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InstanceTemplates|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsInstanceTemplateRequest} request TestIamPermissionsInstanceTemplateRequest message or plain object
                         * @param {google.cloud.compute.v1.InstanceTemplates.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InstanceTemplates.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsInstanceTemplateRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.InstanceTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsInstanceTemplateRequest} request TestIamPermissionsInstanceTemplateRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        return InstanceTemplates;
                    })();
    
                    v1.Instances = (function() {
    
                        /**
                         * Constructs a new Instances service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an Instances
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function Instances(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (Instances.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = Instances;
    
                        /**
                         * Creates new Instances service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.Instances
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {Instances} RPC service. Useful where requests and/or responses are streamed.
                         */
                        Instances.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|addAccessConfig}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef AddAccessConfigCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AddAccessConfig.
                         * @function addAccessConfig
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IAddAccessConfigInstanceRequest} request AddAccessConfigInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.AddAccessConfigCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.addAccessConfig = function addAccessConfig(request, callback) {
                            return this.rpcCall(addAccessConfig, $root.google.cloud.compute.v1.AddAccessConfigInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AddAccessConfig" });
    
                        /**
                         * Calls AddAccessConfig.
                         * @function addAccessConfig
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IAddAccessConfigInstanceRequest} request AddAccessConfigInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|addResourcePolicies}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef AddResourcePoliciesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AddResourcePolicies.
                         * @function addResourcePolicies
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IAddResourcePoliciesInstanceRequest} request AddResourcePoliciesInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.AddResourcePoliciesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.addResourcePolicies = function addResourcePolicies(request, callback) {
                            return this.rpcCall(addResourcePolicies, $root.google.cloud.compute.v1.AddResourcePoliciesInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AddResourcePolicies" });
    
                        /**
                         * Calls AddResourcePolicies.
                         * @function addResourcePolicies
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IAddResourcePoliciesInstanceRequest} request AddResourcePoliciesInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|aggregatedList}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InstanceAggregatedList} [response] InstanceAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListInstancesRequest} request AggregatedListInstancesRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.AggregatedListCallback} callback Node-style callback called with the error, if any, and InstanceAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListInstancesRequest, $root.google.cloud.compute.v1.InstanceAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListInstancesRequest} request AggregatedListInstancesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InstanceAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|attachDisk}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef AttachDiskCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AttachDisk.
                         * @function attachDisk
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IAttachDiskInstanceRequest} request AttachDiskInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.AttachDiskCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.attachDisk = function attachDisk(request, callback) {
                            return this.rpcCall(attachDisk, $root.google.cloud.compute.v1.AttachDiskInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AttachDisk" });
    
                        /**
                         * Calls AttachDisk.
                         * @function attachDisk
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IAttachDiskInstanceRequest} request AttachDiskInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|bulkInsert}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef BulkInsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls BulkInsert.
                         * @function bulkInsert
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IBulkInsertInstanceRequest} request BulkInsertInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.BulkInsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.bulkInsert = function bulkInsert(request, callback) {
                            return this.rpcCall(bulkInsert, $root.google.cloud.compute.v1.BulkInsertInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "BulkInsert" });
    
                        /**
                         * Calls BulkInsert.
                         * @function bulkInsert
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IBulkInsertInstanceRequest} request BulkInsertInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|delete_}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteInstanceRequest} request DeleteInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteInstanceRequest} request DeleteInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|deleteAccessConfig}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef DeleteAccessConfigCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls DeleteAccessConfig.
                         * @function deleteAccessConfig
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteAccessConfigInstanceRequest} request DeleteAccessConfigInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.DeleteAccessConfigCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.deleteAccessConfig = function deleteAccessConfig(request, callback) {
                            return this.rpcCall(deleteAccessConfig, $root.google.cloud.compute.v1.DeleteAccessConfigInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "DeleteAccessConfig" });
    
                        /**
                         * Calls DeleteAccessConfig.
                         * @function deleteAccessConfig
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteAccessConfigInstanceRequest} request DeleteAccessConfigInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|detachDisk}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef DetachDiskCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls DetachDisk.
                         * @function detachDisk
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IDetachDiskInstanceRequest} request DetachDiskInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.DetachDiskCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.detachDisk = function detachDisk(request, callback) {
                            return this.rpcCall(detachDisk, $root.google.cloud.compute.v1.DetachDiskInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "DetachDisk" });
    
                        /**
                         * Calls DetachDisk.
                         * @function detachDisk
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IDetachDiskInstanceRequest} request DetachDiskInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|get}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Instance} [response] Instance
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IGetInstanceRequest} request GetInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.GetCallback} callback Node-style callback called with the error, if any, and Instance
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetInstanceRequest, $root.google.cloud.compute.v1.Instance, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IGetInstanceRequest} request GetInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Instance>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|getEffectiveFirewalls}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef GetEffectiveFirewallsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse} [response] InstancesGetEffectiveFirewallsResponse
                         */
    
                        /**
                         * Calls GetEffectiveFirewalls.
                         * @function getEffectiveFirewalls
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IGetEffectiveFirewallsInstanceRequest} request GetEffectiveFirewallsInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.GetEffectiveFirewallsCallback} callback Node-style callback called with the error, if any, and InstancesGetEffectiveFirewallsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.getEffectiveFirewalls = function getEffectiveFirewalls(request, callback) {
                            return this.rpcCall(getEffectiveFirewalls, $root.google.cloud.compute.v1.GetEffectiveFirewallsInstanceRequest, $root.google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse, request, callback);
                        }, "name", { value: "GetEffectiveFirewalls" });
    
                        /**
                         * Calls GetEffectiveFirewalls.
                         * @function getEffectiveFirewalls
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IGetEffectiveFirewallsInstanceRequest} request GetEffectiveFirewallsInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InstancesGetEffectiveFirewallsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|getGuestAttributes}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef GetGuestAttributesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.GuestAttributes} [response] GuestAttributes
                         */
    
                        /**
                         * Calls GetGuestAttributes.
                         * @function getGuestAttributes
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IGetGuestAttributesInstanceRequest} request GetGuestAttributesInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.GetGuestAttributesCallback} callback Node-style callback called with the error, if any, and GuestAttributes
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.getGuestAttributes = function getGuestAttributes(request, callback) {
                            return this.rpcCall(getGuestAttributes, $root.google.cloud.compute.v1.GetGuestAttributesInstanceRequest, $root.google.cloud.compute.v1.GuestAttributes, request, callback);
                        }, "name", { value: "GetGuestAttributes" });
    
                        /**
                         * Calls GetGuestAttributes.
                         * @function getGuestAttributes
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IGetGuestAttributesInstanceRequest} request GetGuestAttributesInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.GuestAttributes>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|getIamPolicy}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef GetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyInstanceRequest} request GetIamPolicyInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.GetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.getIamPolicy = function getIamPolicy(request, callback) {
                            return this.rpcCall(getIamPolicy, $root.google.cloud.compute.v1.GetIamPolicyInstanceRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "GetIamPolicy" });
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyInstanceRequest} request GetIamPolicyInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|getScreenshot}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef GetScreenshotCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Screenshot} [response] Screenshot
                         */
    
                        /**
                         * Calls GetScreenshot.
                         * @function getScreenshot
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IGetScreenshotInstanceRequest} request GetScreenshotInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.GetScreenshotCallback} callback Node-style callback called with the error, if any, and Screenshot
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.getScreenshot = function getScreenshot(request, callback) {
                            return this.rpcCall(getScreenshot, $root.google.cloud.compute.v1.GetScreenshotInstanceRequest, $root.google.cloud.compute.v1.Screenshot, request, callback);
                        }, "name", { value: "GetScreenshot" });
    
                        /**
                         * Calls GetScreenshot.
                         * @function getScreenshot
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IGetScreenshotInstanceRequest} request GetScreenshotInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Screenshot>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|getSerialPortOutput}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef GetSerialPortOutputCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SerialPortOutput} [response] SerialPortOutput
                         */
    
                        /**
                         * Calls GetSerialPortOutput.
                         * @function getSerialPortOutput
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IGetSerialPortOutputInstanceRequest} request GetSerialPortOutputInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.GetSerialPortOutputCallback} callback Node-style callback called with the error, if any, and SerialPortOutput
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.getSerialPortOutput = function getSerialPortOutput(request, callback) {
                            return this.rpcCall(getSerialPortOutput, $root.google.cloud.compute.v1.GetSerialPortOutputInstanceRequest, $root.google.cloud.compute.v1.SerialPortOutput, request, callback);
                        }, "name", { value: "GetSerialPortOutput" });
    
                        /**
                         * Calls GetSerialPortOutput.
                         * @function getSerialPortOutput
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IGetSerialPortOutputInstanceRequest} request GetSerialPortOutputInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SerialPortOutput>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|getShieldedInstanceIdentity}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef GetShieldedInstanceIdentityCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ShieldedInstanceIdentity} [response] ShieldedInstanceIdentity
                         */
    
                        /**
                         * Calls GetShieldedInstanceIdentity.
                         * @function getShieldedInstanceIdentity
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IGetShieldedInstanceIdentityInstanceRequest} request GetShieldedInstanceIdentityInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.GetShieldedInstanceIdentityCallback} callback Node-style callback called with the error, if any, and ShieldedInstanceIdentity
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.getShieldedInstanceIdentity = function getShieldedInstanceIdentity(request, callback) {
                            return this.rpcCall(getShieldedInstanceIdentity, $root.google.cloud.compute.v1.GetShieldedInstanceIdentityInstanceRequest, $root.google.cloud.compute.v1.ShieldedInstanceIdentity, request, callback);
                        }, "name", { value: "GetShieldedInstanceIdentity" });
    
                        /**
                         * Calls GetShieldedInstanceIdentity.
                         * @function getShieldedInstanceIdentity
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IGetShieldedInstanceIdentityInstanceRequest} request GetShieldedInstanceIdentityInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ShieldedInstanceIdentity>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|insert}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertInstanceRequest} request InsertInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertInstanceRequest} request InsertInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|list}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InstanceList} [response] InstanceList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IListInstancesRequest} request ListInstancesRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.ListCallback} callback Node-style callback called with the error, if any, and InstanceList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListInstancesRequest, $root.google.cloud.compute.v1.InstanceList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IListInstancesRequest} request ListInstancesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InstanceList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|listReferrers}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef ListReferrersCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InstanceListReferrers} [response] InstanceListReferrers
                         */
    
                        /**
                         * Calls ListReferrers.
                         * @function listReferrers
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IListReferrersInstancesRequest} request ListReferrersInstancesRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.ListReferrersCallback} callback Node-style callback called with the error, if any, and InstanceListReferrers
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.listReferrers = function listReferrers(request, callback) {
                            return this.rpcCall(listReferrers, $root.google.cloud.compute.v1.ListReferrersInstancesRequest, $root.google.cloud.compute.v1.InstanceListReferrers, request, callback);
                        }, "name", { value: "ListReferrers" });
    
                        /**
                         * Calls ListReferrers.
                         * @function listReferrers
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IListReferrersInstancesRequest} request ListReferrersInstancesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InstanceListReferrers>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|removeResourcePolicies}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef RemoveResourcePoliciesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls RemoveResourcePolicies.
                         * @function removeResourcePolicies
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveResourcePoliciesInstanceRequest} request RemoveResourcePoliciesInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.RemoveResourcePoliciesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.removeResourcePolicies = function removeResourcePolicies(request, callback) {
                            return this.rpcCall(removeResourcePolicies, $root.google.cloud.compute.v1.RemoveResourcePoliciesInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "RemoveResourcePolicies" });
    
                        /**
                         * Calls RemoveResourcePolicies.
                         * @function removeResourcePolicies
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveResourcePoliciesInstanceRequest} request RemoveResourcePoliciesInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|reset}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef ResetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Reset.
                         * @function reset
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IResetInstanceRequest} request ResetInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.ResetCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.reset = function reset(request, callback) {
                            return this.rpcCall(reset, $root.google.cloud.compute.v1.ResetInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Reset" });
    
                        /**
                         * Calls Reset.
                         * @function reset
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IResetInstanceRequest} request ResetInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|resume}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef ResumeCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Resume.
                         * @function resume
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IResumeInstanceRequest} request ResumeInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.ResumeCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.resume = function resume(request, callback) {
                            return this.rpcCall(resume, $root.google.cloud.compute.v1.ResumeInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Resume" });
    
                        /**
                         * Calls Resume.
                         * @function resume
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IResumeInstanceRequest} request ResumeInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|sendDiagnosticInterrupt}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef SendDiagnosticInterruptCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse} [response] SendDiagnosticInterruptInstanceResponse
                         */
    
                        /**
                         * Calls SendDiagnosticInterrupt.
                         * @function sendDiagnosticInterrupt
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISendDiagnosticInterruptInstanceRequest} request SendDiagnosticInterruptInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.SendDiagnosticInterruptCallback} callback Node-style callback called with the error, if any, and SendDiagnosticInterruptInstanceResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.sendDiagnosticInterrupt = function sendDiagnosticInterrupt(request, callback) {
                            return this.rpcCall(sendDiagnosticInterrupt, $root.google.cloud.compute.v1.SendDiagnosticInterruptInstanceRequest, $root.google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse, request, callback);
                        }, "name", { value: "SendDiagnosticInterrupt" });
    
                        /**
                         * Calls SendDiagnosticInterrupt.
                         * @function sendDiagnosticInterrupt
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISendDiagnosticInterruptInstanceRequest} request SendDiagnosticInterruptInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SendDiagnosticInterruptInstanceResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|setDeletionProtection}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef SetDeletionProtectionCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetDeletionProtection.
                         * @function setDeletionProtection
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetDeletionProtectionInstanceRequest} request SetDeletionProtectionInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.SetDeletionProtectionCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.setDeletionProtection = function setDeletionProtection(request, callback) {
                            return this.rpcCall(setDeletionProtection, $root.google.cloud.compute.v1.SetDeletionProtectionInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetDeletionProtection" });
    
                        /**
                         * Calls SetDeletionProtection.
                         * @function setDeletionProtection
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetDeletionProtectionInstanceRequest} request SetDeletionProtectionInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|setDiskAutoDelete}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef SetDiskAutoDeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetDiskAutoDelete.
                         * @function setDiskAutoDelete
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetDiskAutoDeleteInstanceRequest} request SetDiskAutoDeleteInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.SetDiskAutoDeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.setDiskAutoDelete = function setDiskAutoDelete(request, callback) {
                            return this.rpcCall(setDiskAutoDelete, $root.google.cloud.compute.v1.SetDiskAutoDeleteInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetDiskAutoDelete" });
    
                        /**
                         * Calls SetDiskAutoDelete.
                         * @function setDiskAutoDelete
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetDiskAutoDeleteInstanceRequest} request SetDiskAutoDeleteInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|setIamPolicy}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef SetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyInstanceRequest} request SetIamPolicyInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.SetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.setIamPolicy = function setIamPolicy(request, callback) {
                            return this.rpcCall(setIamPolicy, $root.google.cloud.compute.v1.SetIamPolicyInstanceRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "SetIamPolicy" });
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyInstanceRequest} request SetIamPolicyInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|setLabels}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef SetLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsInstanceRequest} request SetLabelsInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.SetLabelsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.setLabels = function setLabels(request, callback) {
                            return this.rpcCall(setLabels, $root.google.cloud.compute.v1.SetLabelsInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetLabels" });
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsInstanceRequest} request SetLabelsInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|setMachineResources}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef SetMachineResourcesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetMachineResources.
                         * @function setMachineResources
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetMachineResourcesInstanceRequest} request SetMachineResourcesInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.SetMachineResourcesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.setMachineResources = function setMachineResources(request, callback) {
                            return this.rpcCall(setMachineResources, $root.google.cloud.compute.v1.SetMachineResourcesInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetMachineResources" });
    
                        /**
                         * Calls SetMachineResources.
                         * @function setMachineResources
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetMachineResourcesInstanceRequest} request SetMachineResourcesInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|setMachineType}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef SetMachineTypeCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetMachineType.
                         * @function setMachineType
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetMachineTypeInstanceRequest} request SetMachineTypeInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.SetMachineTypeCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.setMachineType = function setMachineType(request, callback) {
                            return this.rpcCall(setMachineType, $root.google.cloud.compute.v1.SetMachineTypeInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetMachineType" });
    
                        /**
                         * Calls SetMachineType.
                         * @function setMachineType
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetMachineTypeInstanceRequest} request SetMachineTypeInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|setMetadata}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef SetMetadataCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetMetadata.
                         * @function setMetadata
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetMetadataInstanceRequest} request SetMetadataInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.SetMetadataCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.setMetadata = function setMetadata(request, callback) {
                            return this.rpcCall(setMetadata, $root.google.cloud.compute.v1.SetMetadataInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetMetadata" });
    
                        /**
                         * Calls SetMetadata.
                         * @function setMetadata
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetMetadataInstanceRequest} request SetMetadataInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|setMinCpuPlatform}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef SetMinCpuPlatformCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetMinCpuPlatform.
                         * @function setMinCpuPlatform
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetMinCpuPlatformInstanceRequest} request SetMinCpuPlatformInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.SetMinCpuPlatformCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.setMinCpuPlatform = function setMinCpuPlatform(request, callback) {
                            return this.rpcCall(setMinCpuPlatform, $root.google.cloud.compute.v1.SetMinCpuPlatformInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetMinCpuPlatform" });
    
                        /**
                         * Calls SetMinCpuPlatform.
                         * @function setMinCpuPlatform
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetMinCpuPlatformInstanceRequest} request SetMinCpuPlatformInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|setScheduling}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef SetSchedulingCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetScheduling.
                         * @function setScheduling
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetSchedulingInstanceRequest} request SetSchedulingInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.SetSchedulingCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.setScheduling = function setScheduling(request, callback) {
                            return this.rpcCall(setScheduling, $root.google.cloud.compute.v1.SetSchedulingInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetScheduling" });
    
                        /**
                         * Calls SetScheduling.
                         * @function setScheduling
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetSchedulingInstanceRequest} request SetSchedulingInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|setServiceAccount}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef SetServiceAccountCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetServiceAccount.
                         * @function setServiceAccount
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetServiceAccountInstanceRequest} request SetServiceAccountInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.SetServiceAccountCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.setServiceAccount = function setServiceAccount(request, callback) {
                            return this.rpcCall(setServiceAccount, $root.google.cloud.compute.v1.SetServiceAccountInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetServiceAccount" });
    
                        /**
                         * Calls SetServiceAccount.
                         * @function setServiceAccount
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetServiceAccountInstanceRequest} request SetServiceAccountInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|setShieldedInstanceIntegrityPolicy}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef SetShieldedInstanceIntegrityPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetShieldedInstanceIntegrityPolicy.
                         * @function setShieldedInstanceIntegrityPolicy
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetShieldedInstanceIntegrityPolicyInstanceRequest} request SetShieldedInstanceIntegrityPolicyInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.SetShieldedInstanceIntegrityPolicyCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.setShieldedInstanceIntegrityPolicy = function setShieldedInstanceIntegrityPolicy(request, callback) {
                            return this.rpcCall(setShieldedInstanceIntegrityPolicy, $root.google.cloud.compute.v1.SetShieldedInstanceIntegrityPolicyInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetShieldedInstanceIntegrityPolicy" });
    
                        /**
                         * Calls SetShieldedInstanceIntegrityPolicy.
                         * @function setShieldedInstanceIntegrityPolicy
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetShieldedInstanceIntegrityPolicyInstanceRequest} request SetShieldedInstanceIntegrityPolicyInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|setTags}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef SetTagsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetTags.
                         * @function setTags
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetTagsInstanceRequest} request SetTagsInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.SetTagsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.setTags = function setTags(request, callback) {
                            return this.rpcCall(setTags, $root.google.cloud.compute.v1.SetTagsInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetTags" });
    
                        /**
                         * Calls SetTags.
                         * @function setTags
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISetTagsInstanceRequest} request SetTagsInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|simulateMaintenanceEvent}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef SimulateMaintenanceEventCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SimulateMaintenanceEvent.
                         * @function simulateMaintenanceEvent
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISimulateMaintenanceEventInstanceRequest} request SimulateMaintenanceEventInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.SimulateMaintenanceEventCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.simulateMaintenanceEvent = function simulateMaintenanceEvent(request, callback) {
                            return this.rpcCall(simulateMaintenanceEvent, $root.google.cloud.compute.v1.SimulateMaintenanceEventInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SimulateMaintenanceEvent" });
    
                        /**
                         * Calls SimulateMaintenanceEvent.
                         * @function simulateMaintenanceEvent
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISimulateMaintenanceEventInstanceRequest} request SimulateMaintenanceEventInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|start}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef StartCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Start.
                         * @function start
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IStartInstanceRequest} request StartInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.StartCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.start = function start(request, callback) {
                            return this.rpcCall(start, $root.google.cloud.compute.v1.StartInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Start" });
    
                        /**
                         * Calls Start.
                         * @function start
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IStartInstanceRequest} request StartInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|startWithEncryptionKey}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef StartWithEncryptionKeyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls StartWithEncryptionKey.
                         * @function startWithEncryptionKey
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IStartWithEncryptionKeyInstanceRequest} request StartWithEncryptionKeyInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.StartWithEncryptionKeyCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.startWithEncryptionKey = function startWithEncryptionKey(request, callback) {
                            return this.rpcCall(startWithEncryptionKey, $root.google.cloud.compute.v1.StartWithEncryptionKeyInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "StartWithEncryptionKey" });
    
                        /**
                         * Calls StartWithEncryptionKey.
                         * @function startWithEncryptionKey
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IStartWithEncryptionKeyInstanceRequest} request StartWithEncryptionKeyInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|stop}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef StopCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Stop.
                         * @function stop
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IStopInstanceRequest} request StopInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.StopCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.stop = function stop(request, callback) {
                            return this.rpcCall(stop, $root.google.cloud.compute.v1.StopInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Stop" });
    
                        /**
                         * Calls Stop.
                         * @function stop
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IStopInstanceRequest} request StopInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|suspend}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef SuspendCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Suspend.
                         * @function suspend
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISuspendInstanceRequest} request SuspendInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.SuspendCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.suspend = function suspend(request, callback) {
                            return this.rpcCall(suspend, $root.google.cloud.compute.v1.SuspendInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Suspend" });
    
                        /**
                         * Calls Suspend.
                         * @function suspend
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ISuspendInstanceRequest} request SuspendInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsInstanceRequest} request TestIamPermissionsInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsInstanceRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsInstanceRequest} request TestIamPermissionsInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|update}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef UpdateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateInstanceRequest} request UpdateInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.UpdateCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.update = function update(request, callback) {
                            return this.rpcCall(update, $root.google.cloud.compute.v1.UpdateInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Update" });
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateInstanceRequest} request UpdateInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|updateAccessConfig}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef UpdateAccessConfigCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls UpdateAccessConfig.
                         * @function updateAccessConfig
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateAccessConfigInstanceRequest} request UpdateAccessConfigInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.UpdateAccessConfigCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.updateAccessConfig = function updateAccessConfig(request, callback) {
                            return this.rpcCall(updateAccessConfig, $root.google.cloud.compute.v1.UpdateAccessConfigInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "UpdateAccessConfig" });
    
                        /**
                         * Calls UpdateAccessConfig.
                         * @function updateAccessConfig
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateAccessConfigInstanceRequest} request UpdateAccessConfigInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|updateDisplayDevice}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef UpdateDisplayDeviceCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls UpdateDisplayDevice.
                         * @function updateDisplayDevice
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateDisplayDeviceInstanceRequest} request UpdateDisplayDeviceInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.UpdateDisplayDeviceCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.updateDisplayDevice = function updateDisplayDevice(request, callback) {
                            return this.rpcCall(updateDisplayDevice, $root.google.cloud.compute.v1.UpdateDisplayDeviceInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "UpdateDisplayDevice" });
    
                        /**
                         * Calls UpdateDisplayDevice.
                         * @function updateDisplayDevice
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateDisplayDeviceInstanceRequest} request UpdateDisplayDeviceInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|updateNetworkInterface}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef UpdateNetworkInterfaceCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls UpdateNetworkInterface.
                         * @function updateNetworkInterface
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateNetworkInterfaceInstanceRequest} request UpdateNetworkInterfaceInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.UpdateNetworkInterfaceCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.updateNetworkInterface = function updateNetworkInterface(request, callback) {
                            return this.rpcCall(updateNetworkInterface, $root.google.cloud.compute.v1.UpdateNetworkInterfaceInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "UpdateNetworkInterface" });
    
                        /**
                         * Calls UpdateNetworkInterface.
                         * @function updateNetworkInterface
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateNetworkInterfaceInstanceRequest} request UpdateNetworkInterfaceInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Instances|updateShieldedInstanceConfig}.
                         * @memberof google.cloud.compute.v1.Instances
                         * @typedef UpdateShieldedInstanceConfigCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls UpdateShieldedInstanceConfig.
                         * @function updateShieldedInstanceConfig
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateShieldedInstanceConfigInstanceRequest} request UpdateShieldedInstanceConfigInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.Instances.UpdateShieldedInstanceConfigCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Instances.prototype.updateShieldedInstanceConfig = function updateShieldedInstanceConfig(request, callback) {
                            return this.rpcCall(updateShieldedInstanceConfig, $root.google.cloud.compute.v1.UpdateShieldedInstanceConfigInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "UpdateShieldedInstanceConfig" });
    
                        /**
                         * Calls UpdateShieldedInstanceConfig.
                         * @function updateShieldedInstanceConfig
                         * @memberof google.cloud.compute.v1.Instances
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateShieldedInstanceConfigInstanceRequest} request UpdateShieldedInstanceConfigInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return Instances;
                    })();
    
                    v1.InterconnectAttachments = (function() {
    
                        /**
                         * Constructs a new InterconnectAttachments service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InterconnectAttachments
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function InterconnectAttachments(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (InterconnectAttachments.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = InterconnectAttachments;
    
                        /**
                         * Creates new InterconnectAttachments service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {InterconnectAttachments} RPC service. Useful where requests and/or responses are streamed.
                         */
                        InterconnectAttachments.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InterconnectAttachments|aggregatedList}.
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InterconnectAttachmentAggregatedList} [response] InterconnectAttachmentAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListInterconnectAttachmentsRequest} request AggregatedListInterconnectAttachmentsRequest message or plain object
                         * @param {google.cloud.compute.v1.InterconnectAttachments.AggregatedListCallback} callback Node-style callback called with the error, if any, and InterconnectAttachmentAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InterconnectAttachments.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListInterconnectAttachmentsRequest, $root.google.cloud.compute.v1.InterconnectAttachmentAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListInterconnectAttachmentsRequest} request AggregatedListInterconnectAttachmentsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InterconnectAttachmentAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InterconnectAttachments|delete_}.
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteInterconnectAttachmentRequest} request DeleteInterconnectAttachmentRequest message or plain object
                         * @param {google.cloud.compute.v1.InterconnectAttachments.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InterconnectAttachments.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteInterconnectAttachmentRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteInterconnectAttachmentRequest} request DeleteInterconnectAttachmentRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InterconnectAttachments|get}.
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InterconnectAttachment} [response] InterconnectAttachment
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IGetInterconnectAttachmentRequest} request GetInterconnectAttachmentRequest message or plain object
                         * @param {google.cloud.compute.v1.InterconnectAttachments.GetCallback} callback Node-style callback called with the error, if any, and InterconnectAttachment
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InterconnectAttachments.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetInterconnectAttachmentRequest, $root.google.cloud.compute.v1.InterconnectAttachment, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IGetInterconnectAttachmentRequest} request GetInterconnectAttachmentRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InterconnectAttachment>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InterconnectAttachments|insert}.
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertInterconnectAttachmentRequest} request InsertInterconnectAttachmentRequest message or plain object
                         * @param {google.cloud.compute.v1.InterconnectAttachments.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InterconnectAttachments.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertInterconnectAttachmentRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertInterconnectAttachmentRequest} request InsertInterconnectAttachmentRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InterconnectAttachments|list}.
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InterconnectAttachmentList} [response] InterconnectAttachmentList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IListInterconnectAttachmentsRequest} request ListInterconnectAttachmentsRequest message or plain object
                         * @param {google.cloud.compute.v1.InterconnectAttachments.ListCallback} callback Node-style callback called with the error, if any, and InterconnectAttachmentList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InterconnectAttachments.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListInterconnectAttachmentsRequest, $root.google.cloud.compute.v1.InterconnectAttachmentList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IListInterconnectAttachmentsRequest} request ListInterconnectAttachmentsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InterconnectAttachmentList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InterconnectAttachments|patch}.
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchInterconnectAttachmentRequest} request PatchInterconnectAttachmentRequest message or plain object
                         * @param {google.cloud.compute.v1.InterconnectAttachments.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InterconnectAttachments.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchInterconnectAttachmentRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchInterconnectAttachmentRequest} request PatchInterconnectAttachmentRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InterconnectAttachments|setLabels}.
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @typedef SetLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsInterconnectAttachmentRequest} request SetLabelsInterconnectAttachmentRequest message or plain object
                         * @param {google.cloud.compute.v1.InterconnectAttachments.SetLabelsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InterconnectAttachments.prototype.setLabels = function setLabels(request, callback) {
                            return this.rpcCall(setLabels, $root.google.cloud.compute.v1.SetLabelsInterconnectAttachmentRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetLabels" });
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.InterconnectAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsInterconnectAttachmentRequest} request SetLabelsInterconnectAttachmentRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return InterconnectAttachments;
                    })();
    
                    v1.InterconnectLocations = (function() {
    
                        /**
                         * Constructs a new InterconnectLocations service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an InterconnectLocations
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function InterconnectLocations(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (InterconnectLocations.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = InterconnectLocations;
    
                        /**
                         * Creates new InterconnectLocations service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.InterconnectLocations
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {InterconnectLocations} RPC service. Useful where requests and/or responses are streamed.
                         */
                        InterconnectLocations.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InterconnectLocations|get}.
                         * @memberof google.cloud.compute.v1.InterconnectLocations
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InterconnectLocation} [response] InterconnectLocation
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.InterconnectLocations
                         * @instance
                         * @param {google.cloud.compute.v1.IGetInterconnectLocationRequest} request GetInterconnectLocationRequest message or plain object
                         * @param {google.cloud.compute.v1.InterconnectLocations.GetCallback} callback Node-style callback called with the error, if any, and InterconnectLocation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InterconnectLocations.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetInterconnectLocationRequest, $root.google.cloud.compute.v1.InterconnectLocation, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.InterconnectLocations
                         * @instance
                         * @param {google.cloud.compute.v1.IGetInterconnectLocationRequest} request GetInterconnectLocationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InterconnectLocation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.InterconnectLocations|list}.
                         * @memberof google.cloud.compute.v1.InterconnectLocations
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InterconnectLocationList} [response] InterconnectLocationList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.InterconnectLocations
                         * @instance
                         * @param {google.cloud.compute.v1.IListInterconnectLocationsRequest} request ListInterconnectLocationsRequest message or plain object
                         * @param {google.cloud.compute.v1.InterconnectLocations.ListCallback} callback Node-style callback called with the error, if any, and InterconnectLocationList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(InterconnectLocations.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListInterconnectLocationsRequest, $root.google.cloud.compute.v1.InterconnectLocationList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.InterconnectLocations
                         * @instance
                         * @param {google.cloud.compute.v1.IListInterconnectLocationsRequest} request ListInterconnectLocationsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InterconnectLocationList>} Promise
                         * @variation 2
                         */
    
                        return InterconnectLocations;
                    })();
    
                    v1.Interconnects = (function() {
    
                        /**
                         * Constructs a new Interconnects service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an Interconnects
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function Interconnects(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (Interconnects.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = Interconnects;
    
                        /**
                         * Creates new Interconnects service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {Interconnects} RPC service. Useful where requests and/or responses are streamed.
                         */
                        Interconnects.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Interconnects|delete_}.
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteInterconnectRequest} request DeleteInterconnectRequest message or plain object
                         * @param {google.cloud.compute.v1.Interconnects.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Interconnects.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteInterconnectRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteInterconnectRequest} request DeleteInterconnectRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Interconnects|get}.
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Interconnect} [response] Interconnect
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @instance
                         * @param {google.cloud.compute.v1.IGetInterconnectRequest} request GetInterconnectRequest message or plain object
                         * @param {google.cloud.compute.v1.Interconnects.GetCallback} callback Node-style callback called with the error, if any, and Interconnect
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Interconnects.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetInterconnectRequest, $root.google.cloud.compute.v1.Interconnect, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @instance
                         * @param {google.cloud.compute.v1.IGetInterconnectRequest} request GetInterconnectRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Interconnect>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Interconnects|getDiagnostics}.
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @typedef GetDiagnosticsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse} [response] InterconnectsGetDiagnosticsResponse
                         */
    
                        /**
                         * Calls GetDiagnostics.
                         * @function getDiagnostics
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @instance
                         * @param {google.cloud.compute.v1.IGetDiagnosticsInterconnectRequest} request GetDiagnosticsInterconnectRequest message or plain object
                         * @param {google.cloud.compute.v1.Interconnects.GetDiagnosticsCallback} callback Node-style callback called with the error, if any, and InterconnectsGetDiagnosticsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Interconnects.prototype.getDiagnostics = function getDiagnostics(request, callback) {
                            return this.rpcCall(getDiagnostics, $root.google.cloud.compute.v1.GetDiagnosticsInterconnectRequest, $root.google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse, request, callback);
                        }, "name", { value: "GetDiagnostics" });
    
                        /**
                         * Calls GetDiagnostics.
                         * @function getDiagnostics
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @instance
                         * @param {google.cloud.compute.v1.IGetDiagnosticsInterconnectRequest} request GetDiagnosticsInterconnectRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InterconnectsGetDiagnosticsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Interconnects|insert}.
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertInterconnectRequest} request InsertInterconnectRequest message or plain object
                         * @param {google.cloud.compute.v1.Interconnects.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Interconnects.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertInterconnectRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertInterconnectRequest} request InsertInterconnectRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Interconnects|list}.
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InterconnectList} [response] InterconnectList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @instance
                         * @param {google.cloud.compute.v1.IListInterconnectsRequest} request ListInterconnectsRequest message or plain object
                         * @param {google.cloud.compute.v1.Interconnects.ListCallback} callback Node-style callback called with the error, if any, and InterconnectList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Interconnects.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListInterconnectsRequest, $root.google.cloud.compute.v1.InterconnectList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @instance
                         * @param {google.cloud.compute.v1.IListInterconnectsRequest} request ListInterconnectsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InterconnectList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Interconnects|patch}.
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchInterconnectRequest} request PatchInterconnectRequest message or plain object
                         * @param {google.cloud.compute.v1.Interconnects.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Interconnects.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchInterconnectRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchInterconnectRequest} request PatchInterconnectRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Interconnects|setLabels}.
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @typedef SetLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsInterconnectRequest} request SetLabelsInterconnectRequest message or plain object
                         * @param {google.cloud.compute.v1.Interconnects.SetLabelsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Interconnects.prototype.setLabels = function setLabels(request, callback) {
                            return this.rpcCall(setLabels, $root.google.cloud.compute.v1.SetLabelsInterconnectRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetLabels" });
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.Interconnects
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsInterconnectRequest} request SetLabelsInterconnectRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return Interconnects;
                    })();
    
                    v1.LicenseCodes = (function() {
    
                        /**
                         * Constructs a new LicenseCodes service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a LicenseCodes
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function LicenseCodes(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (LicenseCodes.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = LicenseCodes;
    
                        /**
                         * Creates new LicenseCodes service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.LicenseCodes
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {LicenseCodes} RPC service. Useful where requests and/or responses are streamed.
                         */
                        LicenseCodes.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.LicenseCodes|get}.
                         * @memberof google.cloud.compute.v1.LicenseCodes
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.LicenseCode} [response] LicenseCode
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.LicenseCodes
                         * @instance
                         * @param {google.cloud.compute.v1.IGetLicenseCodeRequest} request GetLicenseCodeRequest message or plain object
                         * @param {google.cloud.compute.v1.LicenseCodes.GetCallback} callback Node-style callback called with the error, if any, and LicenseCode
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(LicenseCodes.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetLicenseCodeRequest, $root.google.cloud.compute.v1.LicenseCode, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.LicenseCodes
                         * @instance
                         * @param {google.cloud.compute.v1.IGetLicenseCodeRequest} request GetLicenseCodeRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.LicenseCode>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.LicenseCodes|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.LicenseCodes
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.LicenseCodes
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsLicenseCodeRequest} request TestIamPermissionsLicenseCodeRequest message or plain object
                         * @param {google.cloud.compute.v1.LicenseCodes.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(LicenseCodes.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsLicenseCodeRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.LicenseCodes
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsLicenseCodeRequest} request TestIamPermissionsLicenseCodeRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        return LicenseCodes;
                    })();
    
                    v1.Licenses = (function() {
    
                        /**
                         * Constructs a new Licenses service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Licenses
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function Licenses(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (Licenses.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = Licenses;
    
                        /**
                         * Creates new Licenses service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.Licenses
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {Licenses} RPC service. Useful where requests and/or responses are streamed.
                         */
                        Licenses.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Licenses|delete_}.
                         * @memberof google.cloud.compute.v1.Licenses
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Licenses
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteLicenseRequest} request DeleteLicenseRequest message or plain object
                         * @param {google.cloud.compute.v1.Licenses.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Licenses.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteLicenseRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Licenses
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteLicenseRequest} request DeleteLicenseRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Licenses|get}.
                         * @memberof google.cloud.compute.v1.Licenses
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.License} [response] License
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Licenses
                         * @instance
                         * @param {google.cloud.compute.v1.IGetLicenseRequest} request GetLicenseRequest message or plain object
                         * @param {google.cloud.compute.v1.Licenses.GetCallback} callback Node-style callback called with the error, if any, and License
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Licenses.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetLicenseRequest, $root.google.cloud.compute.v1.License, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Licenses
                         * @instance
                         * @param {google.cloud.compute.v1.IGetLicenseRequest} request GetLicenseRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.License>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Licenses|getIamPolicy}.
                         * @memberof google.cloud.compute.v1.Licenses
                         * @typedef GetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.Licenses
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyLicenseRequest} request GetIamPolicyLicenseRequest message or plain object
                         * @param {google.cloud.compute.v1.Licenses.GetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Licenses.prototype.getIamPolicy = function getIamPolicy(request, callback) {
                            return this.rpcCall(getIamPolicy, $root.google.cloud.compute.v1.GetIamPolicyLicenseRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "GetIamPolicy" });
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.Licenses
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyLicenseRequest} request GetIamPolicyLicenseRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Licenses|insert}.
                         * @memberof google.cloud.compute.v1.Licenses
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Licenses
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertLicenseRequest} request InsertLicenseRequest message or plain object
                         * @param {google.cloud.compute.v1.Licenses.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Licenses.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertLicenseRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Licenses
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertLicenseRequest} request InsertLicenseRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Licenses|list}.
                         * @memberof google.cloud.compute.v1.Licenses
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.LicensesListResponse} [response] LicensesListResponse
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Licenses
                         * @instance
                         * @param {google.cloud.compute.v1.IListLicensesRequest} request ListLicensesRequest message or plain object
                         * @param {google.cloud.compute.v1.Licenses.ListCallback} callback Node-style callback called with the error, if any, and LicensesListResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Licenses.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListLicensesRequest, $root.google.cloud.compute.v1.LicensesListResponse, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Licenses
                         * @instance
                         * @param {google.cloud.compute.v1.IListLicensesRequest} request ListLicensesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.LicensesListResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Licenses|setIamPolicy}.
                         * @memberof google.cloud.compute.v1.Licenses
                         * @typedef SetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.Licenses
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyLicenseRequest} request SetIamPolicyLicenseRequest message or plain object
                         * @param {google.cloud.compute.v1.Licenses.SetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Licenses.prototype.setIamPolicy = function setIamPolicy(request, callback) {
                            return this.rpcCall(setIamPolicy, $root.google.cloud.compute.v1.SetIamPolicyLicenseRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "SetIamPolicy" });
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.Licenses
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyLicenseRequest} request SetIamPolicyLicenseRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Licenses|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.Licenses
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.Licenses
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsLicenseRequest} request TestIamPermissionsLicenseRequest message or plain object
                         * @param {google.cloud.compute.v1.Licenses.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Licenses.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsLicenseRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.Licenses
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsLicenseRequest} request TestIamPermissionsLicenseRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        return Licenses;
                    })();
    
                    v1.MachineImages = (function() {
    
                        /**
                         * Constructs a new MachineImages service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a MachineImages
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function MachineImages(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (MachineImages.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = MachineImages;
    
                        /**
                         * Creates new MachineImages service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {MachineImages} RPC service. Useful where requests and/or responses are streamed.
                         */
                        MachineImages.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.MachineImages|delete_}.
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteMachineImageRequest} request DeleteMachineImageRequest message or plain object
                         * @param {google.cloud.compute.v1.MachineImages.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MachineImages.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteMachineImageRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteMachineImageRequest} request DeleteMachineImageRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.MachineImages|get}.
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.MachineImage} [response] MachineImage
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @instance
                         * @param {google.cloud.compute.v1.IGetMachineImageRequest} request GetMachineImageRequest message or plain object
                         * @param {google.cloud.compute.v1.MachineImages.GetCallback} callback Node-style callback called with the error, if any, and MachineImage
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MachineImages.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetMachineImageRequest, $root.google.cloud.compute.v1.MachineImage, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @instance
                         * @param {google.cloud.compute.v1.IGetMachineImageRequest} request GetMachineImageRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.MachineImage>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.MachineImages|getIamPolicy}.
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @typedef GetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyMachineImageRequest} request GetIamPolicyMachineImageRequest message or plain object
                         * @param {google.cloud.compute.v1.MachineImages.GetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MachineImages.prototype.getIamPolicy = function getIamPolicy(request, callback) {
                            return this.rpcCall(getIamPolicy, $root.google.cloud.compute.v1.GetIamPolicyMachineImageRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "GetIamPolicy" });
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyMachineImageRequest} request GetIamPolicyMachineImageRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.MachineImages|insert}.
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertMachineImageRequest} request InsertMachineImageRequest message or plain object
                         * @param {google.cloud.compute.v1.MachineImages.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MachineImages.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertMachineImageRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertMachineImageRequest} request InsertMachineImageRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.MachineImages|list}.
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.MachineImageList} [response] MachineImageList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @instance
                         * @param {google.cloud.compute.v1.IListMachineImagesRequest} request ListMachineImagesRequest message or plain object
                         * @param {google.cloud.compute.v1.MachineImages.ListCallback} callback Node-style callback called with the error, if any, and MachineImageList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MachineImages.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListMachineImagesRequest, $root.google.cloud.compute.v1.MachineImageList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @instance
                         * @param {google.cloud.compute.v1.IListMachineImagesRequest} request ListMachineImagesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.MachineImageList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.MachineImages|setIamPolicy}.
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @typedef SetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyMachineImageRequest} request SetIamPolicyMachineImageRequest message or plain object
                         * @param {google.cloud.compute.v1.MachineImages.SetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MachineImages.prototype.setIamPolicy = function setIamPolicy(request, callback) {
                            return this.rpcCall(setIamPolicy, $root.google.cloud.compute.v1.SetIamPolicyMachineImageRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "SetIamPolicy" });
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyMachineImageRequest} request SetIamPolicyMachineImageRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.MachineImages|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsMachineImageRequest} request TestIamPermissionsMachineImageRequest message or plain object
                         * @param {google.cloud.compute.v1.MachineImages.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MachineImages.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsMachineImageRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.MachineImages
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsMachineImageRequest} request TestIamPermissionsMachineImageRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        return MachineImages;
                    })();
    
                    v1.MachineTypes = (function() {
    
                        /**
                         * Constructs a new MachineTypes service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a MachineTypes
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function MachineTypes(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (MachineTypes.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = MachineTypes;
    
                        /**
                         * Creates new MachineTypes service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.MachineTypes
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {MachineTypes} RPC service. Useful where requests and/or responses are streamed.
                         */
                        MachineTypes.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.MachineTypes|aggregatedList}.
                         * @memberof google.cloud.compute.v1.MachineTypes
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.MachineTypeAggregatedList} [response] MachineTypeAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.MachineTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListMachineTypesRequest} request AggregatedListMachineTypesRequest message or plain object
                         * @param {google.cloud.compute.v1.MachineTypes.AggregatedListCallback} callback Node-style callback called with the error, if any, and MachineTypeAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MachineTypes.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListMachineTypesRequest, $root.google.cloud.compute.v1.MachineTypeAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.MachineTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListMachineTypesRequest} request AggregatedListMachineTypesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.MachineTypeAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.MachineTypes|get}.
                         * @memberof google.cloud.compute.v1.MachineTypes
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.MachineType} [response] MachineType
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.MachineTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IGetMachineTypeRequest} request GetMachineTypeRequest message or plain object
                         * @param {google.cloud.compute.v1.MachineTypes.GetCallback} callback Node-style callback called with the error, if any, and MachineType
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MachineTypes.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetMachineTypeRequest, $root.google.cloud.compute.v1.MachineType, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.MachineTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IGetMachineTypeRequest} request GetMachineTypeRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.MachineType>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.MachineTypes|list}.
                         * @memberof google.cloud.compute.v1.MachineTypes
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.MachineTypeList} [response] MachineTypeList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.MachineTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IListMachineTypesRequest} request ListMachineTypesRequest message or plain object
                         * @param {google.cloud.compute.v1.MachineTypes.ListCallback} callback Node-style callback called with the error, if any, and MachineTypeList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(MachineTypes.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListMachineTypesRequest, $root.google.cloud.compute.v1.MachineTypeList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.MachineTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IListMachineTypesRequest} request ListMachineTypesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.MachineTypeList>} Promise
                         * @variation 2
                         */
    
                        return MachineTypes;
                    })();
    
                    v1.NetworkEdgeSecurityServices = (function() {
    
                        /**
                         * Constructs a new NetworkEdgeSecurityServices service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkEdgeSecurityServices
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function NetworkEdgeSecurityServices(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (NetworkEdgeSecurityServices.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = NetworkEdgeSecurityServices;
    
                        /**
                         * Creates new NetworkEdgeSecurityServices service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServices
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {NetworkEdgeSecurityServices} RPC service. Useful where requests and/or responses are streamed.
                         */
                        NetworkEdgeSecurityServices.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkEdgeSecurityServices|aggregatedList}.
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServices
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList} [response] NetworkEdgeSecurityServiceAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServices
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListNetworkEdgeSecurityServicesRequest} request AggregatedListNetworkEdgeSecurityServicesRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkEdgeSecurityServices.AggregatedListCallback} callback Node-style callback called with the error, if any, and NetworkEdgeSecurityServiceAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkEdgeSecurityServices.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListNetworkEdgeSecurityServicesRequest, $root.google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServices
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListNetworkEdgeSecurityServicesRequest} request AggregatedListNetworkEdgeSecurityServicesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NetworkEdgeSecurityServiceAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkEdgeSecurityServices|delete_}.
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServices
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServices
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteNetworkEdgeSecurityServiceRequest} request DeleteNetworkEdgeSecurityServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkEdgeSecurityServices.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkEdgeSecurityServices.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteNetworkEdgeSecurityServiceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServices
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteNetworkEdgeSecurityServiceRequest} request DeleteNetworkEdgeSecurityServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkEdgeSecurityServices|get}.
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServices
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NetworkEdgeSecurityService} [response] NetworkEdgeSecurityService
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServices
                         * @instance
                         * @param {google.cloud.compute.v1.IGetNetworkEdgeSecurityServiceRequest} request GetNetworkEdgeSecurityServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkEdgeSecurityServices.GetCallback} callback Node-style callback called with the error, if any, and NetworkEdgeSecurityService
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkEdgeSecurityServices.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetNetworkEdgeSecurityServiceRequest, $root.google.cloud.compute.v1.NetworkEdgeSecurityService, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServices
                         * @instance
                         * @param {google.cloud.compute.v1.IGetNetworkEdgeSecurityServiceRequest} request GetNetworkEdgeSecurityServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NetworkEdgeSecurityService>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkEdgeSecurityServices|insert}.
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServices
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServices
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertNetworkEdgeSecurityServiceRequest} request InsertNetworkEdgeSecurityServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkEdgeSecurityServices.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkEdgeSecurityServices.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertNetworkEdgeSecurityServiceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServices
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertNetworkEdgeSecurityServiceRequest} request InsertNetworkEdgeSecurityServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkEdgeSecurityServices|patch}.
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServices
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServices
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchNetworkEdgeSecurityServiceRequest} request PatchNetworkEdgeSecurityServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkEdgeSecurityServices.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkEdgeSecurityServices.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchNetworkEdgeSecurityServiceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.NetworkEdgeSecurityServices
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchNetworkEdgeSecurityServiceRequest} request PatchNetworkEdgeSecurityServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return NetworkEdgeSecurityServices;
                    })();
    
                    v1.NetworkEndpointGroups = (function() {
    
                        /**
                         * Constructs a new NetworkEndpointGroups service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkEndpointGroups
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function NetworkEndpointGroups(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (NetworkEndpointGroups.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = NetworkEndpointGroups;
    
                        /**
                         * Creates new NetworkEndpointGroups service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {NetworkEndpointGroups} RPC service. Useful where requests and/or responses are streamed.
                         */
                        NetworkEndpointGroups.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkEndpointGroups|aggregatedList}.
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NetworkEndpointGroupAggregatedList} [response] NetworkEndpointGroupAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListNetworkEndpointGroupsRequest} request AggregatedListNetworkEndpointGroupsRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkEndpointGroups.AggregatedListCallback} callback Node-style callback called with the error, if any, and NetworkEndpointGroupAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkEndpointGroups.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListNetworkEndpointGroupsRequest, $root.google.cloud.compute.v1.NetworkEndpointGroupAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListNetworkEndpointGroupsRequest} request AggregatedListNetworkEndpointGroupsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NetworkEndpointGroupAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkEndpointGroups|attachNetworkEndpoints}.
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @typedef AttachNetworkEndpointsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AttachNetworkEndpoints.
                         * @function attachNetworkEndpoints
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IAttachNetworkEndpointsNetworkEndpointGroupRequest} request AttachNetworkEndpointsNetworkEndpointGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkEndpointGroups.AttachNetworkEndpointsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkEndpointGroups.prototype.attachNetworkEndpoints = function attachNetworkEndpoints(request, callback) {
                            return this.rpcCall(attachNetworkEndpoints, $root.google.cloud.compute.v1.AttachNetworkEndpointsNetworkEndpointGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AttachNetworkEndpoints" });
    
                        /**
                         * Calls AttachNetworkEndpoints.
                         * @function attachNetworkEndpoints
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IAttachNetworkEndpointsNetworkEndpointGroupRequest} request AttachNetworkEndpointsNetworkEndpointGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkEndpointGroups|delete_}.
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteNetworkEndpointGroupRequest} request DeleteNetworkEndpointGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkEndpointGroups.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkEndpointGroups.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteNetworkEndpointGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteNetworkEndpointGroupRequest} request DeleteNetworkEndpointGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkEndpointGroups|detachNetworkEndpoints}.
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @typedef DetachNetworkEndpointsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls DetachNetworkEndpoints.
                         * @function detachNetworkEndpoints
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IDetachNetworkEndpointsNetworkEndpointGroupRequest} request DetachNetworkEndpointsNetworkEndpointGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkEndpointGroups.DetachNetworkEndpointsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkEndpointGroups.prototype.detachNetworkEndpoints = function detachNetworkEndpoints(request, callback) {
                            return this.rpcCall(detachNetworkEndpoints, $root.google.cloud.compute.v1.DetachNetworkEndpointsNetworkEndpointGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "DetachNetworkEndpoints" });
    
                        /**
                         * Calls DetachNetworkEndpoints.
                         * @function detachNetworkEndpoints
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IDetachNetworkEndpointsNetworkEndpointGroupRequest} request DetachNetworkEndpointsNetworkEndpointGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkEndpointGroups|get}.
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NetworkEndpointGroup} [response] NetworkEndpointGroup
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IGetNetworkEndpointGroupRequest} request GetNetworkEndpointGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkEndpointGroups.GetCallback} callback Node-style callback called with the error, if any, and NetworkEndpointGroup
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkEndpointGroups.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetNetworkEndpointGroupRequest, $root.google.cloud.compute.v1.NetworkEndpointGroup, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IGetNetworkEndpointGroupRequest} request GetNetworkEndpointGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NetworkEndpointGroup>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkEndpointGroups|insert}.
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertNetworkEndpointGroupRequest} request InsertNetworkEndpointGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkEndpointGroups.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkEndpointGroups.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertNetworkEndpointGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertNetworkEndpointGroupRequest} request InsertNetworkEndpointGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkEndpointGroups|list}.
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NetworkEndpointGroupList} [response] NetworkEndpointGroupList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListNetworkEndpointGroupsRequest} request ListNetworkEndpointGroupsRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkEndpointGroups.ListCallback} callback Node-style callback called with the error, if any, and NetworkEndpointGroupList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkEndpointGroups.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListNetworkEndpointGroupsRequest, $root.google.cloud.compute.v1.NetworkEndpointGroupList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListNetworkEndpointGroupsRequest} request ListNetworkEndpointGroupsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NetworkEndpointGroupList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkEndpointGroups|listNetworkEndpoints}.
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @typedef ListNetworkEndpointsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints} [response] NetworkEndpointGroupsListNetworkEndpoints
                         */
    
                        /**
                         * Calls ListNetworkEndpoints.
                         * @function listNetworkEndpoints
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListNetworkEndpointsNetworkEndpointGroupsRequest} request ListNetworkEndpointsNetworkEndpointGroupsRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkEndpointGroups.ListNetworkEndpointsCallback} callback Node-style callback called with the error, if any, and NetworkEndpointGroupsListNetworkEndpoints
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkEndpointGroups.prototype.listNetworkEndpoints = function listNetworkEndpoints(request, callback) {
                            return this.rpcCall(listNetworkEndpoints, $root.google.cloud.compute.v1.ListNetworkEndpointsNetworkEndpointGroupsRequest, $root.google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints, request, callback);
                        }, "name", { value: "ListNetworkEndpoints" });
    
                        /**
                         * Calls ListNetworkEndpoints.
                         * @function listNetworkEndpoints
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListNetworkEndpointsNetworkEndpointGroupsRequest} request ListNetworkEndpointsNetworkEndpointGroupsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NetworkEndpointGroupsListNetworkEndpoints>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkEndpointGroups|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNetworkEndpointGroupRequest} request TestIamPermissionsNetworkEndpointGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkEndpointGroups.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkEndpointGroups.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsNetworkEndpointGroupRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.NetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNetworkEndpointGroupRequest} request TestIamPermissionsNetworkEndpointGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        return NetworkEndpointGroups;
                    })();
    
                    v1.NetworkFirewallPolicies = (function() {
    
                        /**
                         * Constructs a new NetworkFirewallPolicies service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NetworkFirewallPolicies
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function NetworkFirewallPolicies(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (NetworkFirewallPolicies.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = NetworkFirewallPolicies;
    
                        /**
                         * Creates new NetworkFirewallPolicies service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {NetworkFirewallPolicies} RPC service. Useful where requests and/or responses are streamed.
                         */
                        NetworkFirewallPolicies.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkFirewallPolicies|addAssociation}.
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @typedef AddAssociationCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AddAssociation.
                         * @function addAssociation
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IAddAssociationNetworkFirewallPolicyRequest} request AddAssociationNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkFirewallPolicies.AddAssociationCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkFirewallPolicies.prototype.addAssociation = function addAssociation(request, callback) {
                            return this.rpcCall(addAssociation, $root.google.cloud.compute.v1.AddAssociationNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AddAssociation" });
    
                        /**
                         * Calls AddAssociation.
                         * @function addAssociation
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IAddAssociationNetworkFirewallPolicyRequest} request AddAssociationNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkFirewallPolicies|addRule}.
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @typedef AddRuleCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AddRule.
                         * @function addRule
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IAddRuleNetworkFirewallPolicyRequest} request AddRuleNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkFirewallPolicies.AddRuleCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkFirewallPolicies.prototype.addRule = function addRule(request, callback) {
                            return this.rpcCall(addRule, $root.google.cloud.compute.v1.AddRuleNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AddRule" });
    
                        /**
                         * Calls AddRule.
                         * @function addRule
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IAddRuleNetworkFirewallPolicyRequest} request AddRuleNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkFirewallPolicies|cloneRules}.
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @typedef CloneRulesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls CloneRules.
                         * @function cloneRules
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ICloneRulesNetworkFirewallPolicyRequest} request CloneRulesNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkFirewallPolicies.CloneRulesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkFirewallPolicies.prototype.cloneRules = function cloneRules(request, callback) {
                            return this.rpcCall(cloneRules, $root.google.cloud.compute.v1.CloneRulesNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "CloneRules" });
    
                        /**
                         * Calls CloneRules.
                         * @function cloneRules
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ICloneRulesNetworkFirewallPolicyRequest} request CloneRulesNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkFirewallPolicies|delete_}.
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteNetworkFirewallPolicyRequest} request DeleteNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkFirewallPolicies.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkFirewallPolicies.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteNetworkFirewallPolicyRequest} request DeleteNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkFirewallPolicies|get}.
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.FirewallPolicy} [response] FirewallPolicy
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetNetworkFirewallPolicyRequest} request GetNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkFirewallPolicies.GetCallback} callback Node-style callback called with the error, if any, and FirewallPolicy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkFirewallPolicies.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.FirewallPolicy, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetNetworkFirewallPolicyRequest} request GetNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.FirewallPolicy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkFirewallPolicies|getAssociation}.
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @typedef GetAssociationCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.FirewallPolicyAssociation} [response] FirewallPolicyAssociation
                         */
    
                        /**
                         * Calls GetAssociation.
                         * @function getAssociation
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetAssociationNetworkFirewallPolicyRequest} request GetAssociationNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkFirewallPolicies.GetAssociationCallback} callback Node-style callback called with the error, if any, and FirewallPolicyAssociation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkFirewallPolicies.prototype.getAssociation = function getAssociation(request, callback) {
                            return this.rpcCall(getAssociation, $root.google.cloud.compute.v1.GetAssociationNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.FirewallPolicyAssociation, request, callback);
                        }, "name", { value: "GetAssociation" });
    
                        /**
                         * Calls GetAssociation.
                         * @function getAssociation
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetAssociationNetworkFirewallPolicyRequest} request GetAssociationNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.FirewallPolicyAssociation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkFirewallPolicies|getIamPolicy}.
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @typedef GetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyNetworkFirewallPolicyRequest} request GetIamPolicyNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkFirewallPolicies.GetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkFirewallPolicies.prototype.getIamPolicy = function getIamPolicy(request, callback) {
                            return this.rpcCall(getIamPolicy, $root.google.cloud.compute.v1.GetIamPolicyNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "GetIamPolicy" });
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyNetworkFirewallPolicyRequest} request GetIamPolicyNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkFirewallPolicies|getRule}.
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @typedef GetRuleCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.FirewallPolicyRule} [response] FirewallPolicyRule
                         */
    
                        /**
                         * Calls GetRule.
                         * @function getRule
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRuleNetworkFirewallPolicyRequest} request GetRuleNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkFirewallPolicies.GetRuleCallback} callback Node-style callback called with the error, if any, and FirewallPolicyRule
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkFirewallPolicies.prototype.getRule = function getRule(request, callback) {
                            return this.rpcCall(getRule, $root.google.cloud.compute.v1.GetRuleNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.FirewallPolicyRule, request, callback);
                        }, "name", { value: "GetRule" });
    
                        /**
                         * Calls GetRule.
                         * @function getRule
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRuleNetworkFirewallPolicyRequest} request GetRuleNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.FirewallPolicyRule>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkFirewallPolicies|insert}.
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertNetworkFirewallPolicyRequest} request InsertNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkFirewallPolicies.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkFirewallPolicies.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertNetworkFirewallPolicyRequest} request InsertNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkFirewallPolicies|list}.
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.FirewallPolicyList} [response] FirewallPolicyList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListNetworkFirewallPoliciesRequest} request ListNetworkFirewallPoliciesRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkFirewallPolicies.ListCallback} callback Node-style callback called with the error, if any, and FirewallPolicyList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkFirewallPolicies.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListNetworkFirewallPoliciesRequest, $root.google.cloud.compute.v1.FirewallPolicyList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListNetworkFirewallPoliciesRequest} request ListNetworkFirewallPoliciesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.FirewallPolicyList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkFirewallPolicies|patch}.
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchNetworkFirewallPolicyRequest} request PatchNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkFirewallPolicies.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkFirewallPolicies.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchNetworkFirewallPolicyRequest} request PatchNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkFirewallPolicies|patchRule}.
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @typedef PatchRuleCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls PatchRule.
                         * @function patchRule
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRuleNetworkFirewallPolicyRequest} request PatchRuleNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkFirewallPolicies.PatchRuleCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkFirewallPolicies.prototype.patchRule = function patchRule(request, callback) {
                            return this.rpcCall(patchRule, $root.google.cloud.compute.v1.PatchRuleNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "PatchRule" });
    
                        /**
                         * Calls PatchRule.
                         * @function patchRule
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRuleNetworkFirewallPolicyRequest} request PatchRuleNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkFirewallPolicies|removeAssociation}.
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @typedef RemoveAssociationCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls RemoveAssociation.
                         * @function removeAssociation
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveAssociationNetworkFirewallPolicyRequest} request RemoveAssociationNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkFirewallPolicies.RemoveAssociationCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkFirewallPolicies.prototype.removeAssociation = function removeAssociation(request, callback) {
                            return this.rpcCall(removeAssociation, $root.google.cloud.compute.v1.RemoveAssociationNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "RemoveAssociation" });
    
                        /**
                         * Calls RemoveAssociation.
                         * @function removeAssociation
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveAssociationNetworkFirewallPolicyRequest} request RemoveAssociationNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkFirewallPolicies|removeRule}.
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @typedef RemoveRuleCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls RemoveRule.
                         * @function removeRule
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveRuleNetworkFirewallPolicyRequest} request RemoveRuleNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkFirewallPolicies.RemoveRuleCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkFirewallPolicies.prototype.removeRule = function removeRule(request, callback) {
                            return this.rpcCall(removeRule, $root.google.cloud.compute.v1.RemoveRuleNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "RemoveRule" });
    
                        /**
                         * Calls RemoveRule.
                         * @function removeRule
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveRuleNetworkFirewallPolicyRequest} request RemoveRuleNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkFirewallPolicies|setIamPolicy}.
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @typedef SetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyNetworkFirewallPolicyRequest} request SetIamPolicyNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkFirewallPolicies.SetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkFirewallPolicies.prototype.setIamPolicy = function setIamPolicy(request, callback) {
                            return this.rpcCall(setIamPolicy, $root.google.cloud.compute.v1.SetIamPolicyNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "SetIamPolicy" });
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyNetworkFirewallPolicyRequest} request SetIamPolicyNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NetworkFirewallPolicies|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNetworkFirewallPolicyRequest} request TestIamPermissionsNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.NetworkFirewallPolicies.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NetworkFirewallPolicies.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.NetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNetworkFirewallPolicyRequest} request TestIamPermissionsNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        return NetworkFirewallPolicies;
                    })();
    
                    v1.Networks = (function() {
    
                        /**
                         * Constructs a new Networks service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Networks
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function Networks(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (Networks.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = Networks;
    
                        /**
                         * Creates new Networks service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.Networks
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {Networks} RPC service. Useful where requests and/or responses are streamed.
                         */
                        Networks.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Networks|addPeering}.
                         * @memberof google.cloud.compute.v1.Networks
                         * @typedef AddPeeringCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AddPeering.
                         * @function addPeering
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.IAddPeeringNetworkRequest} request AddPeeringNetworkRequest message or plain object
                         * @param {google.cloud.compute.v1.Networks.AddPeeringCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Networks.prototype.addPeering = function addPeering(request, callback) {
                            return this.rpcCall(addPeering, $root.google.cloud.compute.v1.AddPeeringNetworkRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AddPeering" });
    
                        /**
                         * Calls AddPeering.
                         * @function addPeering
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.IAddPeeringNetworkRequest} request AddPeeringNetworkRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Networks|delete_}.
                         * @memberof google.cloud.compute.v1.Networks
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteNetworkRequest} request DeleteNetworkRequest message or plain object
                         * @param {google.cloud.compute.v1.Networks.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Networks.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteNetworkRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteNetworkRequest} request DeleteNetworkRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Networks|get}.
                         * @memberof google.cloud.compute.v1.Networks
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Network} [response] Network
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.IGetNetworkRequest} request GetNetworkRequest message or plain object
                         * @param {google.cloud.compute.v1.Networks.GetCallback} callback Node-style callback called with the error, if any, and Network
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Networks.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetNetworkRequest, $root.google.cloud.compute.v1.Network, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.IGetNetworkRequest} request GetNetworkRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Network>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Networks|getEffectiveFirewalls}.
                         * @memberof google.cloud.compute.v1.Networks
                         * @typedef GetEffectiveFirewallsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse} [response] NetworksGetEffectiveFirewallsResponse
                         */
    
                        /**
                         * Calls GetEffectiveFirewalls.
                         * @function getEffectiveFirewalls
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.IGetEffectiveFirewallsNetworkRequest} request GetEffectiveFirewallsNetworkRequest message or plain object
                         * @param {google.cloud.compute.v1.Networks.GetEffectiveFirewallsCallback} callback Node-style callback called with the error, if any, and NetworksGetEffectiveFirewallsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Networks.prototype.getEffectiveFirewalls = function getEffectiveFirewalls(request, callback) {
                            return this.rpcCall(getEffectiveFirewalls, $root.google.cloud.compute.v1.GetEffectiveFirewallsNetworkRequest, $root.google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse, request, callback);
                        }, "name", { value: "GetEffectiveFirewalls" });
    
                        /**
                         * Calls GetEffectiveFirewalls.
                         * @function getEffectiveFirewalls
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.IGetEffectiveFirewallsNetworkRequest} request GetEffectiveFirewallsNetworkRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NetworksGetEffectiveFirewallsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Networks|insert}.
                         * @memberof google.cloud.compute.v1.Networks
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertNetworkRequest} request InsertNetworkRequest message or plain object
                         * @param {google.cloud.compute.v1.Networks.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Networks.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertNetworkRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertNetworkRequest} request InsertNetworkRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Networks|list}.
                         * @memberof google.cloud.compute.v1.Networks
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NetworkList} [response] NetworkList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.IListNetworksRequest} request ListNetworksRequest message or plain object
                         * @param {google.cloud.compute.v1.Networks.ListCallback} callback Node-style callback called with the error, if any, and NetworkList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Networks.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListNetworksRequest, $root.google.cloud.compute.v1.NetworkList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.IListNetworksRequest} request ListNetworksRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NetworkList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Networks|listPeeringRoutes}.
                         * @memberof google.cloud.compute.v1.Networks
                         * @typedef ListPeeringRoutesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ExchangedPeeringRoutesList} [response] ExchangedPeeringRoutesList
                         */
    
                        /**
                         * Calls ListPeeringRoutes.
                         * @function listPeeringRoutes
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.IListPeeringRoutesNetworksRequest} request ListPeeringRoutesNetworksRequest message or plain object
                         * @param {google.cloud.compute.v1.Networks.ListPeeringRoutesCallback} callback Node-style callback called with the error, if any, and ExchangedPeeringRoutesList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Networks.prototype.listPeeringRoutes = function listPeeringRoutes(request, callback) {
                            return this.rpcCall(listPeeringRoutes, $root.google.cloud.compute.v1.ListPeeringRoutesNetworksRequest, $root.google.cloud.compute.v1.ExchangedPeeringRoutesList, request, callback);
                        }, "name", { value: "ListPeeringRoutes" });
    
                        /**
                         * Calls ListPeeringRoutes.
                         * @function listPeeringRoutes
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.IListPeeringRoutesNetworksRequest} request ListPeeringRoutesNetworksRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ExchangedPeeringRoutesList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Networks|patch}.
                         * @memberof google.cloud.compute.v1.Networks
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchNetworkRequest} request PatchNetworkRequest message or plain object
                         * @param {google.cloud.compute.v1.Networks.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Networks.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchNetworkRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchNetworkRequest} request PatchNetworkRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Networks|removePeering}.
                         * @memberof google.cloud.compute.v1.Networks
                         * @typedef RemovePeeringCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls RemovePeering.
                         * @function removePeering
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.IRemovePeeringNetworkRequest} request RemovePeeringNetworkRequest message or plain object
                         * @param {google.cloud.compute.v1.Networks.RemovePeeringCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Networks.prototype.removePeering = function removePeering(request, callback) {
                            return this.rpcCall(removePeering, $root.google.cloud.compute.v1.RemovePeeringNetworkRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "RemovePeering" });
    
                        /**
                         * Calls RemovePeering.
                         * @function removePeering
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.IRemovePeeringNetworkRequest} request RemovePeeringNetworkRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Networks|switchToCustomMode}.
                         * @memberof google.cloud.compute.v1.Networks
                         * @typedef SwitchToCustomModeCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SwitchToCustomMode.
                         * @function switchToCustomMode
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.ISwitchToCustomModeNetworkRequest} request SwitchToCustomModeNetworkRequest message or plain object
                         * @param {google.cloud.compute.v1.Networks.SwitchToCustomModeCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Networks.prototype.switchToCustomMode = function switchToCustomMode(request, callback) {
                            return this.rpcCall(switchToCustomMode, $root.google.cloud.compute.v1.SwitchToCustomModeNetworkRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SwitchToCustomMode" });
    
                        /**
                         * Calls SwitchToCustomMode.
                         * @function switchToCustomMode
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.ISwitchToCustomModeNetworkRequest} request SwitchToCustomModeNetworkRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Networks|updatePeering}.
                         * @memberof google.cloud.compute.v1.Networks
                         * @typedef UpdatePeeringCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls UpdatePeering.
                         * @function updatePeering
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdatePeeringNetworkRequest} request UpdatePeeringNetworkRequest message or plain object
                         * @param {google.cloud.compute.v1.Networks.UpdatePeeringCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Networks.prototype.updatePeering = function updatePeering(request, callback) {
                            return this.rpcCall(updatePeering, $root.google.cloud.compute.v1.UpdatePeeringNetworkRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "UpdatePeering" });
    
                        /**
                         * Calls UpdatePeering.
                         * @function updatePeering
                         * @memberof google.cloud.compute.v1.Networks
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdatePeeringNetworkRequest} request UpdatePeeringNetworkRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return Networks;
                    })();
    
                    v1.NodeGroups = (function() {
    
                        /**
                         * Constructs a new NodeGroups service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeGroups
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function NodeGroups(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (NodeGroups.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = NodeGroups;
    
                        /**
                         * Creates new NodeGroups service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {NodeGroups} RPC service. Useful where requests and/or responses are streamed.
                         */
                        NodeGroups.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeGroups|addNodes}.
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @typedef AddNodesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AddNodes.
                         * @function addNodes
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IAddNodesNodeGroupRequest} request AddNodesNodeGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeGroups.AddNodesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeGroups.prototype.addNodes = function addNodes(request, callback) {
                            return this.rpcCall(addNodes, $root.google.cloud.compute.v1.AddNodesNodeGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AddNodes" });
    
                        /**
                         * Calls AddNodes.
                         * @function addNodes
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IAddNodesNodeGroupRequest} request AddNodesNodeGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeGroups|aggregatedList}.
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NodeGroupAggregatedList} [response] NodeGroupAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListNodeGroupsRequest} request AggregatedListNodeGroupsRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeGroups.AggregatedListCallback} callback Node-style callback called with the error, if any, and NodeGroupAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeGroups.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListNodeGroupsRequest, $root.google.cloud.compute.v1.NodeGroupAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListNodeGroupsRequest} request AggregatedListNodeGroupsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NodeGroupAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeGroups|delete_}.
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteNodeGroupRequest} request DeleteNodeGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeGroups.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeGroups.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteNodeGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteNodeGroupRequest} request DeleteNodeGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeGroups|deleteNodes}.
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @typedef DeleteNodesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls DeleteNodes.
                         * @function deleteNodes
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteNodesNodeGroupRequest} request DeleteNodesNodeGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeGroups.DeleteNodesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeGroups.prototype.deleteNodes = function deleteNodes(request, callback) {
                            return this.rpcCall(deleteNodes, $root.google.cloud.compute.v1.DeleteNodesNodeGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "DeleteNodes" });
    
                        /**
                         * Calls DeleteNodes.
                         * @function deleteNodes
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteNodesNodeGroupRequest} request DeleteNodesNodeGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeGroups|get}.
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NodeGroup} [response] NodeGroup
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IGetNodeGroupRequest} request GetNodeGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeGroups.GetCallback} callback Node-style callback called with the error, if any, and NodeGroup
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeGroups.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetNodeGroupRequest, $root.google.cloud.compute.v1.NodeGroup, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IGetNodeGroupRequest} request GetNodeGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NodeGroup>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeGroups|getIamPolicy}.
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @typedef GetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyNodeGroupRequest} request GetIamPolicyNodeGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeGroups.GetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeGroups.prototype.getIamPolicy = function getIamPolicy(request, callback) {
                            return this.rpcCall(getIamPolicy, $root.google.cloud.compute.v1.GetIamPolicyNodeGroupRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "GetIamPolicy" });
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyNodeGroupRequest} request GetIamPolicyNodeGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeGroups|insert}.
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertNodeGroupRequest} request InsertNodeGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeGroups.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeGroups.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertNodeGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertNodeGroupRequest} request InsertNodeGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeGroups|list}.
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NodeGroupList} [response] NodeGroupList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListNodeGroupsRequest} request ListNodeGroupsRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeGroups.ListCallback} callback Node-style callback called with the error, if any, and NodeGroupList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeGroups.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListNodeGroupsRequest, $root.google.cloud.compute.v1.NodeGroupList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListNodeGroupsRequest} request ListNodeGroupsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NodeGroupList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeGroups|listNodes}.
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @typedef ListNodesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NodeGroupsListNodes} [response] NodeGroupsListNodes
                         */
    
                        /**
                         * Calls ListNodes.
                         * @function listNodes
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListNodesNodeGroupsRequest} request ListNodesNodeGroupsRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeGroups.ListNodesCallback} callback Node-style callback called with the error, if any, and NodeGroupsListNodes
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeGroups.prototype.listNodes = function listNodes(request, callback) {
                            return this.rpcCall(listNodes, $root.google.cloud.compute.v1.ListNodesNodeGroupsRequest, $root.google.cloud.compute.v1.NodeGroupsListNodes, request, callback);
                        }, "name", { value: "ListNodes" });
    
                        /**
                         * Calls ListNodes.
                         * @function listNodes
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListNodesNodeGroupsRequest} request ListNodesNodeGroupsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NodeGroupsListNodes>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeGroups|patch}.
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchNodeGroupRequest} request PatchNodeGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeGroups.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeGroups.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchNodeGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchNodeGroupRequest} request PatchNodeGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeGroups|setIamPolicy}.
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @typedef SetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyNodeGroupRequest} request SetIamPolicyNodeGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeGroups.SetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeGroups.prototype.setIamPolicy = function setIamPolicy(request, callback) {
                            return this.rpcCall(setIamPolicy, $root.google.cloud.compute.v1.SetIamPolicyNodeGroupRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "SetIamPolicy" });
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyNodeGroupRequest} request SetIamPolicyNodeGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeGroups|setNodeTemplate}.
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @typedef SetNodeTemplateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetNodeTemplate.
                         * @function setNodeTemplate
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.ISetNodeTemplateNodeGroupRequest} request SetNodeTemplateNodeGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeGroups.SetNodeTemplateCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeGroups.prototype.setNodeTemplate = function setNodeTemplate(request, callback) {
                            return this.rpcCall(setNodeTemplate, $root.google.cloud.compute.v1.SetNodeTemplateNodeGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetNodeTemplate" });
    
                        /**
                         * Calls SetNodeTemplate.
                         * @function setNodeTemplate
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.ISetNodeTemplateNodeGroupRequest} request SetNodeTemplateNodeGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeGroups|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNodeGroupRequest} request TestIamPermissionsNodeGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeGroups.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeGroups.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsNodeGroupRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.NodeGroups
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNodeGroupRequest} request TestIamPermissionsNodeGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        return NodeGroups;
                    })();
    
                    v1.NodeTemplates = (function() {
    
                        /**
                         * Constructs a new NodeTemplates service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeTemplates
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function NodeTemplates(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (NodeTemplates.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = NodeTemplates;
    
                        /**
                         * Creates new NodeTemplates service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {NodeTemplates} RPC service. Useful where requests and/or responses are streamed.
                         */
                        NodeTemplates.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeTemplates|aggregatedList}.
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NodeTemplateAggregatedList} [response] NodeTemplateAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListNodeTemplatesRequest} request AggregatedListNodeTemplatesRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeTemplates.AggregatedListCallback} callback Node-style callback called with the error, if any, and NodeTemplateAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeTemplates.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListNodeTemplatesRequest, $root.google.cloud.compute.v1.NodeTemplateAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListNodeTemplatesRequest} request AggregatedListNodeTemplatesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NodeTemplateAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeTemplates|delete_}.
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteNodeTemplateRequest} request DeleteNodeTemplateRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeTemplates.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeTemplates.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteNodeTemplateRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteNodeTemplateRequest} request DeleteNodeTemplateRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeTemplates|get}.
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NodeTemplate} [response] NodeTemplate
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IGetNodeTemplateRequest} request GetNodeTemplateRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeTemplates.GetCallback} callback Node-style callback called with the error, if any, and NodeTemplate
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeTemplates.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetNodeTemplateRequest, $root.google.cloud.compute.v1.NodeTemplate, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IGetNodeTemplateRequest} request GetNodeTemplateRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NodeTemplate>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeTemplates|getIamPolicy}.
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @typedef GetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyNodeTemplateRequest} request GetIamPolicyNodeTemplateRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeTemplates.GetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeTemplates.prototype.getIamPolicy = function getIamPolicy(request, callback) {
                            return this.rpcCall(getIamPolicy, $root.google.cloud.compute.v1.GetIamPolicyNodeTemplateRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "GetIamPolicy" });
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyNodeTemplateRequest} request GetIamPolicyNodeTemplateRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeTemplates|insert}.
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertNodeTemplateRequest} request InsertNodeTemplateRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeTemplates.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeTemplates.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertNodeTemplateRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertNodeTemplateRequest} request InsertNodeTemplateRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeTemplates|list}.
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NodeTemplateList} [response] NodeTemplateList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IListNodeTemplatesRequest} request ListNodeTemplatesRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeTemplates.ListCallback} callback Node-style callback called with the error, if any, and NodeTemplateList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeTemplates.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListNodeTemplatesRequest, $root.google.cloud.compute.v1.NodeTemplateList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.IListNodeTemplatesRequest} request ListNodeTemplatesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NodeTemplateList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeTemplates|setIamPolicy}.
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @typedef SetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyNodeTemplateRequest} request SetIamPolicyNodeTemplateRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeTemplates.SetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeTemplates.prototype.setIamPolicy = function setIamPolicy(request, callback) {
                            return this.rpcCall(setIamPolicy, $root.google.cloud.compute.v1.SetIamPolicyNodeTemplateRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "SetIamPolicy" });
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyNodeTemplateRequest} request SetIamPolicyNodeTemplateRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeTemplates|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNodeTemplateRequest} request TestIamPermissionsNodeTemplateRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeTemplates.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeTemplates.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsNodeTemplateRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.NodeTemplates
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsNodeTemplateRequest} request TestIamPermissionsNodeTemplateRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        return NodeTemplates;
                    })();
    
                    v1.NodeTypes = (function() {
    
                        /**
                         * Constructs a new NodeTypes service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a NodeTypes
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function NodeTypes(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (NodeTypes.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = NodeTypes;
    
                        /**
                         * Creates new NodeTypes service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.NodeTypes
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {NodeTypes} RPC service. Useful where requests and/or responses are streamed.
                         */
                        NodeTypes.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeTypes|aggregatedList}.
                         * @memberof google.cloud.compute.v1.NodeTypes
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NodeTypeAggregatedList} [response] NodeTypeAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.NodeTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListNodeTypesRequest} request AggregatedListNodeTypesRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeTypes.AggregatedListCallback} callback Node-style callback called with the error, if any, and NodeTypeAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeTypes.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListNodeTypesRequest, $root.google.cloud.compute.v1.NodeTypeAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.NodeTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListNodeTypesRequest} request AggregatedListNodeTypesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NodeTypeAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeTypes|get}.
                         * @memberof google.cloud.compute.v1.NodeTypes
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NodeType} [response] NodeType
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.NodeTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IGetNodeTypeRequest} request GetNodeTypeRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeTypes.GetCallback} callback Node-style callback called with the error, if any, and NodeType
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeTypes.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetNodeTypeRequest, $root.google.cloud.compute.v1.NodeType, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.NodeTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IGetNodeTypeRequest} request GetNodeTypeRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NodeType>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.NodeTypes|list}.
                         * @memberof google.cloud.compute.v1.NodeTypes
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NodeTypeList} [response] NodeTypeList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.NodeTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IListNodeTypesRequest} request ListNodeTypesRequest message or plain object
                         * @param {google.cloud.compute.v1.NodeTypes.ListCallback} callback Node-style callback called with the error, if any, and NodeTypeList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(NodeTypes.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListNodeTypesRequest, $root.google.cloud.compute.v1.NodeTypeList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.NodeTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IListNodeTypesRequest} request ListNodeTypesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NodeTypeList>} Promise
                         * @variation 2
                         */
    
                        return NodeTypes;
                    })();
    
                    v1.PacketMirrorings = (function() {
    
                        /**
                         * Constructs a new PacketMirrorings service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PacketMirrorings
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function PacketMirrorings(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (PacketMirrorings.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = PacketMirrorings;
    
                        /**
                         * Creates new PacketMirrorings service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {PacketMirrorings} RPC service. Useful where requests and/or responses are streamed.
                         */
                        PacketMirrorings.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.PacketMirrorings|aggregatedList}.
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.PacketMirroringAggregatedList} [response] PacketMirroringAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListPacketMirroringsRequest} request AggregatedListPacketMirroringsRequest message or plain object
                         * @param {google.cloud.compute.v1.PacketMirrorings.AggregatedListCallback} callback Node-style callback called with the error, if any, and PacketMirroringAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(PacketMirrorings.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListPacketMirroringsRequest, $root.google.cloud.compute.v1.PacketMirroringAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListPacketMirroringsRequest} request AggregatedListPacketMirroringsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.PacketMirroringAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.PacketMirrorings|delete_}.
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @instance
                         * @param {google.cloud.compute.v1.IDeletePacketMirroringRequest} request DeletePacketMirroringRequest message or plain object
                         * @param {google.cloud.compute.v1.PacketMirrorings.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(PacketMirrorings.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeletePacketMirroringRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @instance
                         * @param {google.cloud.compute.v1.IDeletePacketMirroringRequest} request DeletePacketMirroringRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.PacketMirrorings|get}.
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.PacketMirroring} [response] PacketMirroring
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @instance
                         * @param {google.cloud.compute.v1.IGetPacketMirroringRequest} request GetPacketMirroringRequest message or plain object
                         * @param {google.cloud.compute.v1.PacketMirrorings.GetCallback} callback Node-style callback called with the error, if any, and PacketMirroring
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(PacketMirrorings.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetPacketMirroringRequest, $root.google.cloud.compute.v1.PacketMirroring, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @instance
                         * @param {google.cloud.compute.v1.IGetPacketMirroringRequest} request GetPacketMirroringRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.PacketMirroring>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.PacketMirrorings|insert}.
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertPacketMirroringRequest} request InsertPacketMirroringRequest message or plain object
                         * @param {google.cloud.compute.v1.PacketMirrorings.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(PacketMirrorings.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertPacketMirroringRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertPacketMirroringRequest} request InsertPacketMirroringRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.PacketMirrorings|list}.
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.PacketMirroringList} [response] PacketMirroringList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @instance
                         * @param {google.cloud.compute.v1.IListPacketMirroringsRequest} request ListPacketMirroringsRequest message or plain object
                         * @param {google.cloud.compute.v1.PacketMirrorings.ListCallback} callback Node-style callback called with the error, if any, and PacketMirroringList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(PacketMirrorings.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListPacketMirroringsRequest, $root.google.cloud.compute.v1.PacketMirroringList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @instance
                         * @param {google.cloud.compute.v1.IListPacketMirroringsRequest} request ListPacketMirroringsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.PacketMirroringList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.PacketMirrorings|patch}.
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchPacketMirroringRequest} request PatchPacketMirroringRequest message or plain object
                         * @param {google.cloud.compute.v1.PacketMirrorings.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(PacketMirrorings.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchPacketMirroringRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchPacketMirroringRequest} request PatchPacketMirroringRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.PacketMirrorings|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsPacketMirroringRequest} request TestIamPermissionsPacketMirroringRequest message or plain object
                         * @param {google.cloud.compute.v1.PacketMirrorings.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(PacketMirrorings.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsPacketMirroringRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.PacketMirrorings
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsPacketMirroringRequest} request TestIamPermissionsPacketMirroringRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        return PacketMirrorings;
                    })();
    
                    v1.Projects = (function() {
    
                        /**
                         * Constructs a new Projects service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Projects
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function Projects(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (Projects.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = Projects;
    
                        /**
                         * Creates new Projects service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.Projects
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {Projects} RPC service. Useful where requests and/or responses are streamed.
                         */
                        Projects.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Projects|disableXpnHost}.
                         * @memberof google.cloud.compute.v1.Projects
                         * @typedef DisableXpnHostCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls DisableXpnHost.
                         * @function disableXpnHost
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.IDisableXpnHostProjectRequest} request DisableXpnHostProjectRequest message or plain object
                         * @param {google.cloud.compute.v1.Projects.DisableXpnHostCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Projects.prototype.disableXpnHost = function disableXpnHost(request, callback) {
                            return this.rpcCall(disableXpnHost, $root.google.cloud.compute.v1.DisableXpnHostProjectRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "DisableXpnHost" });
    
                        /**
                         * Calls DisableXpnHost.
                         * @function disableXpnHost
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.IDisableXpnHostProjectRequest} request DisableXpnHostProjectRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Projects|disableXpnResource}.
                         * @memberof google.cloud.compute.v1.Projects
                         * @typedef DisableXpnResourceCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls DisableXpnResource.
                         * @function disableXpnResource
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.IDisableXpnResourceProjectRequest} request DisableXpnResourceProjectRequest message or plain object
                         * @param {google.cloud.compute.v1.Projects.DisableXpnResourceCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Projects.prototype.disableXpnResource = function disableXpnResource(request, callback) {
                            return this.rpcCall(disableXpnResource, $root.google.cloud.compute.v1.DisableXpnResourceProjectRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "DisableXpnResource" });
    
                        /**
                         * Calls DisableXpnResource.
                         * @function disableXpnResource
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.IDisableXpnResourceProjectRequest} request DisableXpnResourceProjectRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Projects|enableXpnHost}.
                         * @memberof google.cloud.compute.v1.Projects
                         * @typedef EnableXpnHostCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls EnableXpnHost.
                         * @function enableXpnHost
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.IEnableXpnHostProjectRequest} request EnableXpnHostProjectRequest message or plain object
                         * @param {google.cloud.compute.v1.Projects.EnableXpnHostCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Projects.prototype.enableXpnHost = function enableXpnHost(request, callback) {
                            return this.rpcCall(enableXpnHost, $root.google.cloud.compute.v1.EnableXpnHostProjectRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "EnableXpnHost" });
    
                        /**
                         * Calls EnableXpnHost.
                         * @function enableXpnHost
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.IEnableXpnHostProjectRequest} request EnableXpnHostProjectRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Projects|enableXpnResource}.
                         * @memberof google.cloud.compute.v1.Projects
                         * @typedef EnableXpnResourceCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls EnableXpnResource.
                         * @function enableXpnResource
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.IEnableXpnResourceProjectRequest} request EnableXpnResourceProjectRequest message or plain object
                         * @param {google.cloud.compute.v1.Projects.EnableXpnResourceCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Projects.prototype.enableXpnResource = function enableXpnResource(request, callback) {
                            return this.rpcCall(enableXpnResource, $root.google.cloud.compute.v1.EnableXpnResourceProjectRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "EnableXpnResource" });
    
                        /**
                         * Calls EnableXpnResource.
                         * @function enableXpnResource
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.IEnableXpnResourceProjectRequest} request EnableXpnResourceProjectRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Projects|get}.
                         * @memberof google.cloud.compute.v1.Projects
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Project} [response] Project
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.IGetProjectRequest} request GetProjectRequest message or plain object
                         * @param {google.cloud.compute.v1.Projects.GetCallback} callback Node-style callback called with the error, if any, and Project
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Projects.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetProjectRequest, $root.google.cloud.compute.v1.Project, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.IGetProjectRequest} request GetProjectRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Project>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Projects|getXpnHost}.
                         * @memberof google.cloud.compute.v1.Projects
                         * @typedef GetXpnHostCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Project} [response] Project
                         */
    
                        /**
                         * Calls GetXpnHost.
                         * @function getXpnHost
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.IGetXpnHostProjectRequest} request GetXpnHostProjectRequest message or plain object
                         * @param {google.cloud.compute.v1.Projects.GetXpnHostCallback} callback Node-style callback called with the error, if any, and Project
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Projects.prototype.getXpnHost = function getXpnHost(request, callback) {
                            return this.rpcCall(getXpnHost, $root.google.cloud.compute.v1.GetXpnHostProjectRequest, $root.google.cloud.compute.v1.Project, request, callback);
                        }, "name", { value: "GetXpnHost" });
    
                        /**
                         * Calls GetXpnHost.
                         * @function getXpnHost
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.IGetXpnHostProjectRequest} request GetXpnHostProjectRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Project>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Projects|getXpnResources}.
                         * @memberof google.cloud.compute.v1.Projects
                         * @typedef GetXpnResourcesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ProjectsGetXpnResources} [response] ProjectsGetXpnResources
                         */
    
                        /**
                         * Calls GetXpnResources.
                         * @function getXpnResources
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.IGetXpnResourcesProjectsRequest} request GetXpnResourcesProjectsRequest message or plain object
                         * @param {google.cloud.compute.v1.Projects.GetXpnResourcesCallback} callback Node-style callback called with the error, if any, and ProjectsGetXpnResources
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Projects.prototype.getXpnResources = function getXpnResources(request, callback) {
                            return this.rpcCall(getXpnResources, $root.google.cloud.compute.v1.GetXpnResourcesProjectsRequest, $root.google.cloud.compute.v1.ProjectsGetXpnResources, request, callback);
                        }, "name", { value: "GetXpnResources" });
    
                        /**
                         * Calls GetXpnResources.
                         * @function getXpnResources
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.IGetXpnResourcesProjectsRequest} request GetXpnResourcesProjectsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ProjectsGetXpnResources>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Projects|listXpnHosts}.
                         * @memberof google.cloud.compute.v1.Projects
                         * @typedef ListXpnHostsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.XpnHostList} [response] XpnHostList
                         */
    
                        /**
                         * Calls ListXpnHosts.
                         * @function listXpnHosts
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.IListXpnHostsProjectsRequest} request ListXpnHostsProjectsRequest message or plain object
                         * @param {google.cloud.compute.v1.Projects.ListXpnHostsCallback} callback Node-style callback called with the error, if any, and XpnHostList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Projects.prototype.listXpnHosts = function listXpnHosts(request, callback) {
                            return this.rpcCall(listXpnHosts, $root.google.cloud.compute.v1.ListXpnHostsProjectsRequest, $root.google.cloud.compute.v1.XpnHostList, request, callback);
                        }, "name", { value: "ListXpnHosts" });
    
                        /**
                         * Calls ListXpnHosts.
                         * @function listXpnHosts
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.IListXpnHostsProjectsRequest} request ListXpnHostsProjectsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.XpnHostList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Projects|moveDisk}.
                         * @memberof google.cloud.compute.v1.Projects
                         * @typedef MoveDiskCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls MoveDisk.
                         * @function moveDisk
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.IMoveDiskProjectRequest} request MoveDiskProjectRequest message or plain object
                         * @param {google.cloud.compute.v1.Projects.MoveDiskCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Projects.prototype.moveDisk = function moveDisk(request, callback) {
                            return this.rpcCall(moveDisk, $root.google.cloud.compute.v1.MoveDiskProjectRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "MoveDisk" });
    
                        /**
                         * Calls MoveDisk.
                         * @function moveDisk
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.IMoveDiskProjectRequest} request MoveDiskProjectRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Projects|moveInstance}.
                         * @memberof google.cloud.compute.v1.Projects
                         * @typedef MoveInstanceCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls MoveInstance.
                         * @function moveInstance
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.IMoveInstanceProjectRequest} request MoveInstanceProjectRequest message or plain object
                         * @param {google.cloud.compute.v1.Projects.MoveInstanceCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Projects.prototype.moveInstance = function moveInstance(request, callback) {
                            return this.rpcCall(moveInstance, $root.google.cloud.compute.v1.MoveInstanceProjectRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "MoveInstance" });
    
                        /**
                         * Calls MoveInstance.
                         * @function moveInstance
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.IMoveInstanceProjectRequest} request MoveInstanceProjectRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Projects|setCommonInstanceMetadata}.
                         * @memberof google.cloud.compute.v1.Projects
                         * @typedef SetCommonInstanceMetadataCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetCommonInstanceMetadata.
                         * @function setCommonInstanceMetadata
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.ISetCommonInstanceMetadataProjectRequest} request SetCommonInstanceMetadataProjectRequest message or plain object
                         * @param {google.cloud.compute.v1.Projects.SetCommonInstanceMetadataCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Projects.prototype.setCommonInstanceMetadata = function setCommonInstanceMetadata(request, callback) {
                            return this.rpcCall(setCommonInstanceMetadata, $root.google.cloud.compute.v1.SetCommonInstanceMetadataProjectRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetCommonInstanceMetadata" });
    
                        /**
                         * Calls SetCommonInstanceMetadata.
                         * @function setCommonInstanceMetadata
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.ISetCommonInstanceMetadataProjectRequest} request SetCommonInstanceMetadataProjectRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Projects|setDefaultNetworkTier}.
                         * @memberof google.cloud.compute.v1.Projects
                         * @typedef SetDefaultNetworkTierCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetDefaultNetworkTier.
                         * @function setDefaultNetworkTier
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.ISetDefaultNetworkTierProjectRequest} request SetDefaultNetworkTierProjectRequest message or plain object
                         * @param {google.cloud.compute.v1.Projects.SetDefaultNetworkTierCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Projects.prototype.setDefaultNetworkTier = function setDefaultNetworkTier(request, callback) {
                            return this.rpcCall(setDefaultNetworkTier, $root.google.cloud.compute.v1.SetDefaultNetworkTierProjectRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetDefaultNetworkTier" });
    
                        /**
                         * Calls SetDefaultNetworkTier.
                         * @function setDefaultNetworkTier
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.ISetDefaultNetworkTierProjectRequest} request SetDefaultNetworkTierProjectRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Projects|setUsageExportBucket}.
                         * @memberof google.cloud.compute.v1.Projects
                         * @typedef SetUsageExportBucketCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetUsageExportBucket.
                         * @function setUsageExportBucket
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.ISetUsageExportBucketProjectRequest} request SetUsageExportBucketProjectRequest message or plain object
                         * @param {google.cloud.compute.v1.Projects.SetUsageExportBucketCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Projects.prototype.setUsageExportBucket = function setUsageExportBucket(request, callback) {
                            return this.rpcCall(setUsageExportBucket, $root.google.cloud.compute.v1.SetUsageExportBucketProjectRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetUsageExportBucket" });
    
                        /**
                         * Calls SetUsageExportBucket.
                         * @function setUsageExportBucket
                         * @memberof google.cloud.compute.v1.Projects
                         * @instance
                         * @param {google.cloud.compute.v1.ISetUsageExportBucketProjectRequest} request SetUsageExportBucketProjectRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return Projects;
                    })();
    
                    v1.PublicAdvertisedPrefixes = (function() {
    
                        /**
                         * Constructs a new PublicAdvertisedPrefixes service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PublicAdvertisedPrefixes
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function PublicAdvertisedPrefixes(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (PublicAdvertisedPrefixes.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = PublicAdvertisedPrefixes;
    
                        /**
                         * Creates new PublicAdvertisedPrefixes service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixes
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {PublicAdvertisedPrefixes} RPC service. Useful where requests and/or responses are streamed.
                         */
                        PublicAdvertisedPrefixes.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.PublicAdvertisedPrefixes|delete_}.
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixes
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IDeletePublicAdvertisedPrefixeRequest} request DeletePublicAdvertisedPrefixeRequest message or plain object
                         * @param {google.cloud.compute.v1.PublicAdvertisedPrefixes.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(PublicAdvertisedPrefixes.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeletePublicAdvertisedPrefixeRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IDeletePublicAdvertisedPrefixeRequest} request DeletePublicAdvertisedPrefixeRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.PublicAdvertisedPrefixes|get}.
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixes
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.PublicAdvertisedPrefix} [response] PublicAdvertisedPrefix
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IGetPublicAdvertisedPrefixeRequest} request GetPublicAdvertisedPrefixeRequest message or plain object
                         * @param {google.cloud.compute.v1.PublicAdvertisedPrefixes.GetCallback} callback Node-style callback called with the error, if any, and PublicAdvertisedPrefix
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(PublicAdvertisedPrefixes.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetPublicAdvertisedPrefixeRequest, $root.google.cloud.compute.v1.PublicAdvertisedPrefix, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IGetPublicAdvertisedPrefixeRequest} request GetPublicAdvertisedPrefixeRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.PublicAdvertisedPrefix>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.PublicAdvertisedPrefixes|insert}.
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixes
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertPublicAdvertisedPrefixeRequest} request InsertPublicAdvertisedPrefixeRequest message or plain object
                         * @param {google.cloud.compute.v1.PublicAdvertisedPrefixes.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(PublicAdvertisedPrefixes.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertPublicAdvertisedPrefixeRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertPublicAdvertisedPrefixeRequest} request InsertPublicAdvertisedPrefixeRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.PublicAdvertisedPrefixes|list}.
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixes
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.PublicAdvertisedPrefixList} [response] PublicAdvertisedPrefixList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IListPublicAdvertisedPrefixesRequest} request ListPublicAdvertisedPrefixesRequest message or plain object
                         * @param {google.cloud.compute.v1.PublicAdvertisedPrefixes.ListCallback} callback Node-style callback called with the error, if any, and PublicAdvertisedPrefixList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(PublicAdvertisedPrefixes.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListPublicAdvertisedPrefixesRequest, $root.google.cloud.compute.v1.PublicAdvertisedPrefixList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IListPublicAdvertisedPrefixesRequest} request ListPublicAdvertisedPrefixesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.PublicAdvertisedPrefixList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.PublicAdvertisedPrefixes|patch}.
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixes
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchPublicAdvertisedPrefixeRequest} request PatchPublicAdvertisedPrefixeRequest message or plain object
                         * @param {google.cloud.compute.v1.PublicAdvertisedPrefixes.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(PublicAdvertisedPrefixes.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchPublicAdvertisedPrefixeRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.PublicAdvertisedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchPublicAdvertisedPrefixeRequest} request PatchPublicAdvertisedPrefixeRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return PublicAdvertisedPrefixes;
                    })();
    
                    v1.PublicDelegatedPrefixes = (function() {
    
                        /**
                         * Constructs a new PublicDelegatedPrefixes service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a PublicDelegatedPrefixes
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function PublicDelegatedPrefixes(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (PublicDelegatedPrefixes.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = PublicDelegatedPrefixes;
    
                        /**
                         * Creates new PublicDelegatedPrefixes service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixes
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {PublicDelegatedPrefixes} RPC service. Useful where requests and/or responses are streamed.
                         */
                        PublicDelegatedPrefixes.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.PublicDelegatedPrefixes|aggregatedList}.
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixes
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList} [response] PublicDelegatedPrefixAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListPublicDelegatedPrefixesRequest} request AggregatedListPublicDelegatedPrefixesRequest message or plain object
                         * @param {google.cloud.compute.v1.PublicDelegatedPrefixes.AggregatedListCallback} callback Node-style callback called with the error, if any, and PublicDelegatedPrefixAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(PublicDelegatedPrefixes.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListPublicDelegatedPrefixesRequest, $root.google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListPublicDelegatedPrefixesRequest} request AggregatedListPublicDelegatedPrefixesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.PublicDelegatedPrefixAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.PublicDelegatedPrefixes|delete_}.
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixes
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IDeletePublicDelegatedPrefixeRequest} request DeletePublicDelegatedPrefixeRequest message or plain object
                         * @param {google.cloud.compute.v1.PublicDelegatedPrefixes.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(PublicDelegatedPrefixes.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeletePublicDelegatedPrefixeRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IDeletePublicDelegatedPrefixeRequest} request DeletePublicDelegatedPrefixeRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.PublicDelegatedPrefixes|get}.
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixes
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.PublicDelegatedPrefix} [response] PublicDelegatedPrefix
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IGetPublicDelegatedPrefixeRequest} request GetPublicDelegatedPrefixeRequest message or plain object
                         * @param {google.cloud.compute.v1.PublicDelegatedPrefixes.GetCallback} callback Node-style callback called with the error, if any, and PublicDelegatedPrefix
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(PublicDelegatedPrefixes.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetPublicDelegatedPrefixeRequest, $root.google.cloud.compute.v1.PublicDelegatedPrefix, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IGetPublicDelegatedPrefixeRequest} request GetPublicDelegatedPrefixeRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.PublicDelegatedPrefix>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.PublicDelegatedPrefixes|insert}.
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixes
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertPublicDelegatedPrefixeRequest} request InsertPublicDelegatedPrefixeRequest message or plain object
                         * @param {google.cloud.compute.v1.PublicDelegatedPrefixes.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(PublicDelegatedPrefixes.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertPublicDelegatedPrefixeRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertPublicDelegatedPrefixeRequest} request InsertPublicDelegatedPrefixeRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.PublicDelegatedPrefixes|list}.
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixes
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.PublicDelegatedPrefixList} [response] PublicDelegatedPrefixList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IListPublicDelegatedPrefixesRequest} request ListPublicDelegatedPrefixesRequest message or plain object
                         * @param {google.cloud.compute.v1.PublicDelegatedPrefixes.ListCallback} callback Node-style callback called with the error, if any, and PublicDelegatedPrefixList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(PublicDelegatedPrefixes.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListPublicDelegatedPrefixesRequest, $root.google.cloud.compute.v1.PublicDelegatedPrefixList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IListPublicDelegatedPrefixesRequest} request ListPublicDelegatedPrefixesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.PublicDelegatedPrefixList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.PublicDelegatedPrefixes|patch}.
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixes
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchPublicDelegatedPrefixeRequest} request PatchPublicDelegatedPrefixeRequest message or plain object
                         * @param {google.cloud.compute.v1.PublicDelegatedPrefixes.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(PublicDelegatedPrefixes.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchPublicDelegatedPrefixeRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.PublicDelegatedPrefixes
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchPublicDelegatedPrefixeRequest} request PatchPublicDelegatedPrefixeRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return PublicDelegatedPrefixes;
                    })();
    
                    v1.RegionAutoscalers = (function() {
    
                        /**
                         * Constructs a new RegionAutoscalers service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionAutoscalers
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionAutoscalers(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionAutoscalers.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionAutoscalers;
    
                        /**
                         * Creates new RegionAutoscalers service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionAutoscalers
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionAutoscalers} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionAutoscalers.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionAutoscalers|delete_}.
                         * @memberof google.cloud.compute.v1.RegionAutoscalers
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionAutoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionAutoscalerRequest} request DeleteRegionAutoscalerRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionAutoscalers.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionAutoscalers.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteRegionAutoscalerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionAutoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionAutoscalerRequest} request DeleteRegionAutoscalerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionAutoscalers|get}.
                         * @memberof google.cloud.compute.v1.RegionAutoscalers
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Autoscaler} [response] Autoscaler
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionAutoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionAutoscalerRequest} request GetRegionAutoscalerRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionAutoscalers.GetCallback} callback Node-style callback called with the error, if any, and Autoscaler
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionAutoscalers.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionAutoscalerRequest, $root.google.cloud.compute.v1.Autoscaler, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionAutoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionAutoscalerRequest} request GetRegionAutoscalerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Autoscaler>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionAutoscalers|insert}.
                         * @memberof google.cloud.compute.v1.RegionAutoscalers
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionAutoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionAutoscalerRequest} request InsertRegionAutoscalerRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionAutoscalers.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionAutoscalers.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertRegionAutoscalerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionAutoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionAutoscalerRequest} request InsertRegionAutoscalerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionAutoscalers|list}.
                         * @memberof google.cloud.compute.v1.RegionAutoscalers
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.RegionAutoscalerList} [response] RegionAutoscalerList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionAutoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionAutoscalersRequest} request ListRegionAutoscalersRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionAutoscalers.ListCallback} callback Node-style callback called with the error, if any, and RegionAutoscalerList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionAutoscalers.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionAutoscalersRequest, $root.google.cloud.compute.v1.RegionAutoscalerList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionAutoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionAutoscalersRequest} request ListRegionAutoscalersRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.RegionAutoscalerList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionAutoscalers|patch}.
                         * @memberof google.cloud.compute.v1.RegionAutoscalers
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.RegionAutoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRegionAutoscalerRequest} request PatchRegionAutoscalerRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionAutoscalers.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionAutoscalers.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchRegionAutoscalerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.RegionAutoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRegionAutoscalerRequest} request PatchRegionAutoscalerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionAutoscalers|update}.
                         * @memberof google.cloud.compute.v1.RegionAutoscalers
                         * @typedef UpdateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.RegionAutoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateRegionAutoscalerRequest} request UpdateRegionAutoscalerRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionAutoscalers.UpdateCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionAutoscalers.prototype.update = function update(request, callback) {
                            return this.rpcCall(update, $root.google.cloud.compute.v1.UpdateRegionAutoscalerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Update" });
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.RegionAutoscalers
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateRegionAutoscalerRequest} request UpdateRegionAutoscalerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return RegionAutoscalers;
                    })();
    
                    v1.RegionBackendServices = (function() {
    
                        /**
                         * Constructs a new RegionBackendServices service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionBackendServices
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionBackendServices(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionBackendServices.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionBackendServices;
    
                        /**
                         * Creates new RegionBackendServices service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionBackendServices} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionBackendServices.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionBackendServices|delete_}.
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionBackendServiceRequest} request DeleteRegionBackendServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionBackendServices.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionBackendServices.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteRegionBackendServiceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionBackendServiceRequest} request DeleteRegionBackendServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionBackendServices|get}.
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.BackendService} [response] BackendService
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionBackendServiceRequest} request GetRegionBackendServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionBackendServices.GetCallback} callback Node-style callback called with the error, if any, and BackendService
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionBackendServices.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionBackendServiceRequest, $root.google.cloud.compute.v1.BackendService, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionBackendServiceRequest} request GetRegionBackendServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.BackendService>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionBackendServices|getHealth}.
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @typedef GetHealthCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.BackendServiceGroupHealth} [response] BackendServiceGroupHealth
                         */
    
                        /**
                         * Calls GetHealth.
                         * @function getHealth
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IGetHealthRegionBackendServiceRequest} request GetHealthRegionBackendServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionBackendServices.GetHealthCallback} callback Node-style callback called with the error, if any, and BackendServiceGroupHealth
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionBackendServices.prototype.getHealth = function getHealth(request, callback) {
                            return this.rpcCall(getHealth, $root.google.cloud.compute.v1.GetHealthRegionBackendServiceRequest, $root.google.cloud.compute.v1.BackendServiceGroupHealth, request, callback);
                        }, "name", { value: "GetHealth" });
    
                        /**
                         * Calls GetHealth.
                         * @function getHealth
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IGetHealthRegionBackendServiceRequest} request GetHealthRegionBackendServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.BackendServiceGroupHealth>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionBackendServices|getIamPolicy}.
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @typedef GetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyRegionBackendServiceRequest} request GetIamPolicyRegionBackendServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionBackendServices.GetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionBackendServices.prototype.getIamPolicy = function getIamPolicy(request, callback) {
                            return this.rpcCall(getIamPolicy, $root.google.cloud.compute.v1.GetIamPolicyRegionBackendServiceRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "GetIamPolicy" });
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyRegionBackendServiceRequest} request GetIamPolicyRegionBackendServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionBackendServices|insert}.
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionBackendServiceRequest} request InsertRegionBackendServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionBackendServices.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionBackendServices.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertRegionBackendServiceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionBackendServiceRequest} request InsertRegionBackendServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionBackendServices|list}.
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.BackendServiceList} [response] BackendServiceList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionBackendServicesRequest} request ListRegionBackendServicesRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionBackendServices.ListCallback} callback Node-style callback called with the error, if any, and BackendServiceList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionBackendServices.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionBackendServicesRequest, $root.google.cloud.compute.v1.BackendServiceList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionBackendServicesRequest} request ListRegionBackendServicesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.BackendServiceList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionBackendServices|patch}.
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRegionBackendServiceRequest} request PatchRegionBackendServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionBackendServices.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionBackendServices.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchRegionBackendServiceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRegionBackendServiceRequest} request PatchRegionBackendServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionBackendServices|setIamPolicy}.
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @typedef SetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyRegionBackendServiceRequest} request SetIamPolicyRegionBackendServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionBackendServices.SetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionBackendServices.prototype.setIamPolicy = function setIamPolicy(request, callback) {
                            return this.rpcCall(setIamPolicy, $root.google.cloud.compute.v1.SetIamPolicyRegionBackendServiceRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "SetIamPolicy" });
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyRegionBackendServiceRequest} request SetIamPolicyRegionBackendServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionBackendServices|update}.
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @typedef UpdateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateRegionBackendServiceRequest} request UpdateRegionBackendServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionBackendServices.UpdateCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionBackendServices.prototype.update = function update(request, callback) {
                            return this.rpcCall(update, $root.google.cloud.compute.v1.UpdateRegionBackendServiceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Update" });
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.RegionBackendServices
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateRegionBackendServiceRequest} request UpdateRegionBackendServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return RegionBackendServices;
                    })();
    
                    v1.RegionCommitments = (function() {
    
                        /**
                         * Constructs a new RegionCommitments service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionCommitments
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionCommitments(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionCommitments.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionCommitments;
    
                        /**
                         * Creates new RegionCommitments service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionCommitments
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionCommitments} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionCommitments.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionCommitments|aggregatedList}.
                         * @memberof google.cloud.compute.v1.RegionCommitments
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.CommitmentAggregatedList} [response] CommitmentAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.RegionCommitments
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListRegionCommitmentsRequest} request AggregatedListRegionCommitmentsRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionCommitments.AggregatedListCallback} callback Node-style callback called with the error, if any, and CommitmentAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionCommitments.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListRegionCommitmentsRequest, $root.google.cloud.compute.v1.CommitmentAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.RegionCommitments
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListRegionCommitmentsRequest} request AggregatedListRegionCommitmentsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.CommitmentAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionCommitments|get}.
                         * @memberof google.cloud.compute.v1.RegionCommitments
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Commitment} [response] Commitment
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionCommitments
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionCommitmentRequest} request GetRegionCommitmentRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionCommitments.GetCallback} callback Node-style callback called with the error, if any, and Commitment
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionCommitments.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionCommitmentRequest, $root.google.cloud.compute.v1.Commitment, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionCommitments
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionCommitmentRequest} request GetRegionCommitmentRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Commitment>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionCommitments|insert}.
                         * @memberof google.cloud.compute.v1.RegionCommitments
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionCommitments
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionCommitmentRequest} request InsertRegionCommitmentRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionCommitments.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionCommitments.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertRegionCommitmentRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionCommitments
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionCommitmentRequest} request InsertRegionCommitmentRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionCommitments|list}.
                         * @memberof google.cloud.compute.v1.RegionCommitments
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.CommitmentList} [response] CommitmentList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionCommitments
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionCommitmentsRequest} request ListRegionCommitmentsRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionCommitments.ListCallback} callback Node-style callback called with the error, if any, and CommitmentList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionCommitments.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionCommitmentsRequest, $root.google.cloud.compute.v1.CommitmentList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionCommitments
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionCommitmentsRequest} request ListRegionCommitmentsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.CommitmentList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionCommitments|update}.
                         * @memberof google.cloud.compute.v1.RegionCommitments
                         * @typedef UpdateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.RegionCommitments
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateRegionCommitmentRequest} request UpdateRegionCommitmentRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionCommitments.UpdateCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionCommitments.prototype.update = function update(request, callback) {
                            return this.rpcCall(update, $root.google.cloud.compute.v1.UpdateRegionCommitmentRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Update" });
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.RegionCommitments
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateRegionCommitmentRequest} request UpdateRegionCommitmentRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return RegionCommitments;
                    })();
    
                    v1.RegionDiskTypes = (function() {
    
                        /**
                         * Constructs a new RegionDiskTypes service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionDiskTypes
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionDiskTypes(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionDiskTypes.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionDiskTypes;
    
                        /**
                         * Creates new RegionDiskTypes service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionDiskTypes
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionDiskTypes} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionDiskTypes.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionDiskTypes|get}.
                         * @memberof google.cloud.compute.v1.RegionDiskTypes
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.DiskType} [response] DiskType
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionDiskTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionDiskTypeRequest} request GetRegionDiskTypeRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionDiskTypes.GetCallback} callback Node-style callback called with the error, if any, and DiskType
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionDiskTypes.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionDiskTypeRequest, $root.google.cloud.compute.v1.DiskType, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionDiskTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionDiskTypeRequest} request GetRegionDiskTypeRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.DiskType>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionDiskTypes|list}.
                         * @memberof google.cloud.compute.v1.RegionDiskTypes
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.RegionDiskTypeList} [response] RegionDiskTypeList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionDiskTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionDiskTypesRequest} request ListRegionDiskTypesRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionDiskTypes.ListCallback} callback Node-style callback called with the error, if any, and RegionDiskTypeList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionDiskTypes.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionDiskTypesRequest, $root.google.cloud.compute.v1.RegionDiskTypeList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionDiskTypes
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionDiskTypesRequest} request ListRegionDiskTypesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.RegionDiskTypeList>} Promise
                         * @variation 2
                         */
    
                        return RegionDiskTypes;
                    })();
    
                    v1.RegionDisks = (function() {
    
                        /**
                         * Constructs a new RegionDisks service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionDisks
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionDisks(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionDisks.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionDisks;
    
                        /**
                         * Creates new RegionDisks service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionDisks} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionDisks.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionDisks|addResourcePolicies}.
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @typedef AddResourcePoliciesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AddResourcePolicies.
                         * @function addResourcePolicies
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.IAddResourcePoliciesRegionDiskRequest} request AddResourcePoliciesRegionDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionDisks.AddResourcePoliciesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionDisks.prototype.addResourcePolicies = function addResourcePolicies(request, callback) {
                            return this.rpcCall(addResourcePolicies, $root.google.cloud.compute.v1.AddResourcePoliciesRegionDiskRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AddResourcePolicies" });
    
                        /**
                         * Calls AddResourcePolicies.
                         * @function addResourcePolicies
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.IAddResourcePoliciesRegionDiskRequest} request AddResourcePoliciesRegionDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionDisks|createSnapshot}.
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @typedef CreateSnapshotCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls CreateSnapshot.
                         * @function createSnapshot
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.ICreateSnapshotRegionDiskRequest} request CreateSnapshotRegionDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionDisks.CreateSnapshotCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionDisks.prototype.createSnapshot = function createSnapshot(request, callback) {
                            return this.rpcCall(createSnapshot, $root.google.cloud.compute.v1.CreateSnapshotRegionDiskRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "CreateSnapshot" });
    
                        /**
                         * Calls CreateSnapshot.
                         * @function createSnapshot
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.ICreateSnapshotRegionDiskRequest} request CreateSnapshotRegionDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionDisks|delete_}.
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionDiskRequest} request DeleteRegionDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionDisks.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionDisks.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteRegionDiskRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionDiskRequest} request DeleteRegionDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionDisks|get}.
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Disk} [response] Disk
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionDiskRequest} request GetRegionDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionDisks.GetCallback} callback Node-style callback called with the error, if any, and Disk
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionDisks.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionDiskRequest, $root.google.cloud.compute.v1.Disk, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionDiskRequest} request GetRegionDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Disk>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionDisks|getIamPolicy}.
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @typedef GetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyRegionDiskRequest} request GetIamPolicyRegionDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionDisks.GetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionDisks.prototype.getIamPolicy = function getIamPolicy(request, callback) {
                            return this.rpcCall(getIamPolicy, $root.google.cloud.compute.v1.GetIamPolicyRegionDiskRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "GetIamPolicy" });
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyRegionDiskRequest} request GetIamPolicyRegionDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionDisks|insert}.
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionDiskRequest} request InsertRegionDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionDisks.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionDisks.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertRegionDiskRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionDiskRequest} request InsertRegionDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionDisks|list}.
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.DiskList} [response] DiskList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionDisksRequest} request ListRegionDisksRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionDisks.ListCallback} callback Node-style callback called with the error, if any, and DiskList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionDisks.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionDisksRequest, $root.google.cloud.compute.v1.DiskList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionDisksRequest} request ListRegionDisksRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.DiskList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionDisks|removeResourcePolicies}.
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @typedef RemoveResourcePoliciesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls RemoveResourcePolicies.
                         * @function removeResourcePolicies
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveResourcePoliciesRegionDiskRequest} request RemoveResourcePoliciesRegionDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionDisks.RemoveResourcePoliciesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionDisks.prototype.removeResourcePolicies = function removeResourcePolicies(request, callback) {
                            return this.rpcCall(removeResourcePolicies, $root.google.cloud.compute.v1.RemoveResourcePoliciesRegionDiskRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "RemoveResourcePolicies" });
    
                        /**
                         * Calls RemoveResourcePolicies.
                         * @function removeResourcePolicies
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveResourcePoliciesRegionDiskRequest} request RemoveResourcePoliciesRegionDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionDisks|resize}.
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @typedef ResizeCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Resize.
                         * @function resize
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.IResizeRegionDiskRequest} request ResizeRegionDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionDisks.ResizeCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionDisks.prototype.resize = function resize(request, callback) {
                            return this.rpcCall(resize, $root.google.cloud.compute.v1.ResizeRegionDiskRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Resize" });
    
                        /**
                         * Calls Resize.
                         * @function resize
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.IResizeRegionDiskRequest} request ResizeRegionDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionDisks|setIamPolicy}.
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @typedef SetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyRegionDiskRequest} request SetIamPolicyRegionDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionDisks.SetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionDisks.prototype.setIamPolicy = function setIamPolicy(request, callback) {
                            return this.rpcCall(setIamPolicy, $root.google.cloud.compute.v1.SetIamPolicyRegionDiskRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "SetIamPolicy" });
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyRegionDiskRequest} request SetIamPolicyRegionDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionDisks|setLabels}.
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @typedef SetLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsRegionDiskRequest} request SetLabelsRegionDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionDisks.SetLabelsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionDisks.prototype.setLabels = function setLabels(request, callback) {
                            return this.rpcCall(setLabels, $root.google.cloud.compute.v1.SetLabelsRegionDiskRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetLabels" });
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsRegionDiskRequest} request SetLabelsRegionDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionDisks|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsRegionDiskRequest} request TestIamPermissionsRegionDiskRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionDisks.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionDisks.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsRegionDiskRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.RegionDisks
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsRegionDiskRequest} request TestIamPermissionsRegionDiskRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        return RegionDisks;
                    })();
    
                    v1.RegionHealthCheckServices = (function() {
    
                        /**
                         * Constructs a new RegionHealthCheckServices service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionHealthCheckServices
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionHealthCheckServices(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionHealthCheckServices.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionHealthCheckServices;
    
                        /**
                         * Creates new RegionHealthCheckServices service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionHealthCheckServices
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionHealthCheckServices} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionHealthCheckServices.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionHealthCheckServices|delete_}.
                         * @memberof google.cloud.compute.v1.RegionHealthCheckServices
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionHealthCheckServices
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionHealthCheckServiceRequest} request DeleteRegionHealthCheckServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionHealthCheckServices.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionHealthCheckServices.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteRegionHealthCheckServiceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionHealthCheckServices
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionHealthCheckServiceRequest} request DeleteRegionHealthCheckServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionHealthCheckServices|get}.
                         * @memberof google.cloud.compute.v1.RegionHealthCheckServices
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.HealthCheckService} [response] HealthCheckService
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionHealthCheckServices
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionHealthCheckServiceRequest} request GetRegionHealthCheckServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionHealthCheckServices.GetCallback} callback Node-style callback called with the error, if any, and HealthCheckService
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionHealthCheckServices.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionHealthCheckServiceRequest, $root.google.cloud.compute.v1.HealthCheckService, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionHealthCheckServices
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionHealthCheckServiceRequest} request GetRegionHealthCheckServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.HealthCheckService>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionHealthCheckServices|insert}.
                         * @memberof google.cloud.compute.v1.RegionHealthCheckServices
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionHealthCheckServices
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionHealthCheckServiceRequest} request InsertRegionHealthCheckServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionHealthCheckServices.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionHealthCheckServices.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertRegionHealthCheckServiceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionHealthCheckServices
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionHealthCheckServiceRequest} request InsertRegionHealthCheckServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionHealthCheckServices|list}.
                         * @memberof google.cloud.compute.v1.RegionHealthCheckServices
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.HealthCheckServicesList} [response] HealthCheckServicesList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionHealthCheckServices
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionHealthCheckServicesRequest} request ListRegionHealthCheckServicesRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionHealthCheckServices.ListCallback} callback Node-style callback called with the error, if any, and HealthCheckServicesList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionHealthCheckServices.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionHealthCheckServicesRequest, $root.google.cloud.compute.v1.HealthCheckServicesList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionHealthCheckServices
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionHealthCheckServicesRequest} request ListRegionHealthCheckServicesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.HealthCheckServicesList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionHealthCheckServices|patch}.
                         * @memberof google.cloud.compute.v1.RegionHealthCheckServices
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.RegionHealthCheckServices
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRegionHealthCheckServiceRequest} request PatchRegionHealthCheckServiceRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionHealthCheckServices.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionHealthCheckServices.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchRegionHealthCheckServiceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.RegionHealthCheckServices
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRegionHealthCheckServiceRequest} request PatchRegionHealthCheckServiceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return RegionHealthCheckServices;
                    })();
    
                    v1.RegionHealthChecks = (function() {
    
                        /**
                         * Constructs a new RegionHealthChecks service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionHealthChecks
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionHealthChecks(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionHealthChecks.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionHealthChecks;
    
                        /**
                         * Creates new RegionHealthChecks service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionHealthChecks
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionHealthChecks} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionHealthChecks.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionHealthChecks|delete_}.
                         * @memberof google.cloud.compute.v1.RegionHealthChecks
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionHealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionHealthCheckRequest} request DeleteRegionHealthCheckRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionHealthChecks.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionHealthChecks.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteRegionHealthCheckRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionHealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionHealthCheckRequest} request DeleteRegionHealthCheckRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionHealthChecks|get}.
                         * @memberof google.cloud.compute.v1.RegionHealthChecks
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.HealthCheck} [response] HealthCheck
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionHealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionHealthCheckRequest} request GetRegionHealthCheckRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionHealthChecks.GetCallback} callback Node-style callback called with the error, if any, and HealthCheck
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionHealthChecks.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionHealthCheckRequest, $root.google.cloud.compute.v1.HealthCheck, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionHealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionHealthCheckRequest} request GetRegionHealthCheckRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.HealthCheck>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionHealthChecks|insert}.
                         * @memberof google.cloud.compute.v1.RegionHealthChecks
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionHealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionHealthCheckRequest} request InsertRegionHealthCheckRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionHealthChecks.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionHealthChecks.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertRegionHealthCheckRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionHealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionHealthCheckRequest} request InsertRegionHealthCheckRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionHealthChecks|list}.
                         * @memberof google.cloud.compute.v1.RegionHealthChecks
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.HealthCheckList} [response] HealthCheckList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionHealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionHealthChecksRequest} request ListRegionHealthChecksRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionHealthChecks.ListCallback} callback Node-style callback called with the error, if any, and HealthCheckList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionHealthChecks.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionHealthChecksRequest, $root.google.cloud.compute.v1.HealthCheckList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionHealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionHealthChecksRequest} request ListRegionHealthChecksRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.HealthCheckList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionHealthChecks|patch}.
                         * @memberof google.cloud.compute.v1.RegionHealthChecks
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.RegionHealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRegionHealthCheckRequest} request PatchRegionHealthCheckRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionHealthChecks.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionHealthChecks.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchRegionHealthCheckRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.RegionHealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRegionHealthCheckRequest} request PatchRegionHealthCheckRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionHealthChecks|update}.
                         * @memberof google.cloud.compute.v1.RegionHealthChecks
                         * @typedef UpdateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.RegionHealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateRegionHealthCheckRequest} request UpdateRegionHealthCheckRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionHealthChecks.UpdateCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionHealthChecks.prototype.update = function update(request, callback) {
                            return this.rpcCall(update, $root.google.cloud.compute.v1.UpdateRegionHealthCheckRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Update" });
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.RegionHealthChecks
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateRegionHealthCheckRequest} request UpdateRegionHealthCheckRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return RegionHealthChecks;
                    })();
    
                    v1.RegionInstanceGroupManagers = (function() {
    
                        /**
                         * Constructs a new RegionInstanceGroupManagers service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstanceGroupManagers
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionInstanceGroupManagers(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionInstanceGroupManagers.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionInstanceGroupManagers;
    
                        /**
                         * Creates new RegionInstanceGroupManagers service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionInstanceGroupManagers} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionInstanceGroupManagers.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroupManagers|abandonInstances}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @typedef AbandonInstancesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AbandonInstances.
                         * @function abandonInstances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IAbandonInstancesRegionInstanceGroupManagerRequest} request AbandonInstancesRegionInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagers.AbandonInstancesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroupManagers.prototype.abandonInstances = function abandonInstances(request, callback) {
                            return this.rpcCall(abandonInstances, $root.google.cloud.compute.v1.AbandonInstancesRegionInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AbandonInstances" });
    
                        /**
                         * Calls AbandonInstances.
                         * @function abandonInstances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IAbandonInstancesRegionInstanceGroupManagerRequest} request AbandonInstancesRegionInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroupManagers|applyUpdatesToInstances}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @typedef ApplyUpdatesToInstancesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls ApplyUpdatesToInstances.
                         * @function applyUpdatesToInstances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IApplyUpdatesToInstancesRegionInstanceGroupManagerRequest} request ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagers.ApplyUpdatesToInstancesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroupManagers.prototype.applyUpdatesToInstances = function applyUpdatesToInstances(request, callback) {
                            return this.rpcCall(applyUpdatesToInstances, $root.google.cloud.compute.v1.ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "ApplyUpdatesToInstances" });
    
                        /**
                         * Calls ApplyUpdatesToInstances.
                         * @function applyUpdatesToInstances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IApplyUpdatesToInstancesRegionInstanceGroupManagerRequest} request ApplyUpdatesToInstancesRegionInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroupManagers|createInstances}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @typedef CreateInstancesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls CreateInstances.
                         * @function createInstances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.ICreateInstancesRegionInstanceGroupManagerRequest} request CreateInstancesRegionInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagers.CreateInstancesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroupManagers.prototype.createInstances = function createInstances(request, callback) {
                            return this.rpcCall(createInstances, $root.google.cloud.compute.v1.CreateInstancesRegionInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "CreateInstances" });
    
                        /**
                         * Calls CreateInstances.
                         * @function createInstances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.ICreateInstancesRegionInstanceGroupManagerRequest} request CreateInstancesRegionInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroupManagers|delete_}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionInstanceGroupManagerRequest} request DeleteRegionInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagers.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroupManagers.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteRegionInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionInstanceGroupManagerRequest} request DeleteRegionInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroupManagers|deleteInstances}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @typedef DeleteInstancesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls DeleteInstances.
                         * @function deleteInstances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteInstancesRegionInstanceGroupManagerRequest} request DeleteInstancesRegionInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagers.DeleteInstancesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroupManagers.prototype.deleteInstances = function deleteInstances(request, callback) {
                            return this.rpcCall(deleteInstances, $root.google.cloud.compute.v1.DeleteInstancesRegionInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "DeleteInstances" });
    
                        /**
                         * Calls DeleteInstances.
                         * @function deleteInstances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteInstancesRegionInstanceGroupManagerRequest} request DeleteInstancesRegionInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroupManagers|deletePerInstanceConfigs}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @typedef DeletePerInstanceConfigsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls DeletePerInstanceConfigs.
                         * @function deletePerInstanceConfigs
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IDeletePerInstanceConfigsRegionInstanceGroupManagerRequest} request DeletePerInstanceConfigsRegionInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagers.DeletePerInstanceConfigsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroupManagers.prototype.deletePerInstanceConfigs = function deletePerInstanceConfigs(request, callback) {
                            return this.rpcCall(deletePerInstanceConfigs, $root.google.cloud.compute.v1.DeletePerInstanceConfigsRegionInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "DeletePerInstanceConfigs" });
    
                        /**
                         * Calls DeletePerInstanceConfigs.
                         * @function deletePerInstanceConfigs
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IDeletePerInstanceConfigsRegionInstanceGroupManagerRequest} request DeletePerInstanceConfigsRegionInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroupManagers|get}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InstanceGroupManager} [response] InstanceGroupManager
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionInstanceGroupManagerRequest} request GetRegionInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagers.GetCallback} callback Node-style callback called with the error, if any, and InstanceGroupManager
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroupManagers.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionInstanceGroupManagerRequest, $root.google.cloud.compute.v1.InstanceGroupManager, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionInstanceGroupManagerRequest} request GetRegionInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InstanceGroupManager>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroupManagers|insert}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionInstanceGroupManagerRequest} request InsertRegionInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagers.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroupManagers.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertRegionInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionInstanceGroupManagerRequest} request InsertRegionInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroupManagers|list}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagerList} [response] RegionInstanceGroupManagerList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionInstanceGroupManagersRequest} request ListRegionInstanceGroupManagersRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagers.ListCallback} callback Node-style callback called with the error, if any, and RegionInstanceGroupManagerList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroupManagers.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionInstanceGroupManagersRequest, $root.google.cloud.compute.v1.RegionInstanceGroupManagerList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionInstanceGroupManagersRequest} request ListRegionInstanceGroupManagersRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.RegionInstanceGroupManagerList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroupManagers|listErrors}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @typedef ListErrorsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse} [response] RegionInstanceGroupManagersListErrorsResponse
                         */
    
                        /**
                         * Calls ListErrors.
                         * @function listErrors
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IListErrorsRegionInstanceGroupManagersRequest} request ListErrorsRegionInstanceGroupManagersRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagers.ListErrorsCallback} callback Node-style callback called with the error, if any, and RegionInstanceGroupManagersListErrorsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroupManagers.prototype.listErrors = function listErrors(request, callback) {
                            return this.rpcCall(listErrors, $root.google.cloud.compute.v1.ListErrorsRegionInstanceGroupManagersRequest, $root.google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse, request, callback);
                        }, "name", { value: "ListErrors" });
    
                        /**
                         * Calls ListErrors.
                         * @function listErrors
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IListErrorsRegionInstanceGroupManagersRequest} request ListErrorsRegionInstanceGroupManagersRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.RegionInstanceGroupManagersListErrorsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroupManagers|listManagedInstances}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @typedef ListManagedInstancesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse} [response] RegionInstanceGroupManagersListInstancesResponse
                         */
    
                        /**
                         * Calls ListManagedInstances.
                         * @function listManagedInstances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IListManagedInstancesRegionInstanceGroupManagersRequest} request ListManagedInstancesRegionInstanceGroupManagersRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagers.ListManagedInstancesCallback} callback Node-style callback called with the error, if any, and RegionInstanceGroupManagersListInstancesResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroupManagers.prototype.listManagedInstances = function listManagedInstances(request, callback) {
                            return this.rpcCall(listManagedInstances, $root.google.cloud.compute.v1.ListManagedInstancesRegionInstanceGroupManagersRequest, $root.google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse, request, callback);
                        }, "name", { value: "ListManagedInstances" });
    
                        /**
                         * Calls ListManagedInstances.
                         * @function listManagedInstances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IListManagedInstancesRegionInstanceGroupManagersRequest} request ListManagedInstancesRegionInstanceGroupManagersRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.RegionInstanceGroupManagersListInstancesResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroupManagers|listPerInstanceConfigs}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @typedef ListPerInstanceConfigsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp} [response] RegionInstanceGroupManagersListInstanceConfigsResp
                         */
    
                        /**
                         * Calls ListPerInstanceConfigs.
                         * @function listPerInstanceConfigs
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IListPerInstanceConfigsRegionInstanceGroupManagersRequest} request ListPerInstanceConfigsRegionInstanceGroupManagersRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagers.ListPerInstanceConfigsCallback} callback Node-style callback called with the error, if any, and RegionInstanceGroupManagersListInstanceConfigsResp
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroupManagers.prototype.listPerInstanceConfigs = function listPerInstanceConfigs(request, callback) {
                            return this.rpcCall(listPerInstanceConfigs, $root.google.cloud.compute.v1.ListPerInstanceConfigsRegionInstanceGroupManagersRequest, $root.google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp, request, callback);
                        }, "name", { value: "ListPerInstanceConfigs" });
    
                        /**
                         * Calls ListPerInstanceConfigs.
                         * @function listPerInstanceConfigs
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IListPerInstanceConfigsRegionInstanceGroupManagersRequest} request ListPerInstanceConfigsRegionInstanceGroupManagersRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.RegionInstanceGroupManagersListInstanceConfigsResp>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroupManagers|patch}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRegionInstanceGroupManagerRequest} request PatchRegionInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagers.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroupManagers.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchRegionInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRegionInstanceGroupManagerRequest} request PatchRegionInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroupManagers|patchPerInstanceConfigs}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @typedef PatchPerInstanceConfigsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls PatchPerInstanceConfigs.
                         * @function patchPerInstanceConfigs
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchPerInstanceConfigsRegionInstanceGroupManagerRequest} request PatchPerInstanceConfigsRegionInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagers.PatchPerInstanceConfigsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroupManagers.prototype.patchPerInstanceConfigs = function patchPerInstanceConfigs(request, callback) {
                            return this.rpcCall(patchPerInstanceConfigs, $root.google.cloud.compute.v1.PatchPerInstanceConfigsRegionInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "PatchPerInstanceConfigs" });
    
                        /**
                         * Calls PatchPerInstanceConfigs.
                         * @function patchPerInstanceConfigs
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchPerInstanceConfigsRegionInstanceGroupManagerRequest} request PatchPerInstanceConfigsRegionInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroupManagers|recreateInstances}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @typedef RecreateInstancesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls RecreateInstances.
                         * @function recreateInstances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IRecreateInstancesRegionInstanceGroupManagerRequest} request RecreateInstancesRegionInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagers.RecreateInstancesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroupManagers.prototype.recreateInstances = function recreateInstances(request, callback) {
                            return this.rpcCall(recreateInstances, $root.google.cloud.compute.v1.RecreateInstancesRegionInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "RecreateInstances" });
    
                        /**
                         * Calls RecreateInstances.
                         * @function recreateInstances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IRecreateInstancesRegionInstanceGroupManagerRequest} request RecreateInstancesRegionInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroupManagers|resize}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @typedef ResizeCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Resize.
                         * @function resize
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IResizeRegionInstanceGroupManagerRequest} request ResizeRegionInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagers.ResizeCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroupManagers.prototype.resize = function resize(request, callback) {
                            return this.rpcCall(resize, $root.google.cloud.compute.v1.ResizeRegionInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Resize" });
    
                        /**
                         * Calls Resize.
                         * @function resize
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IResizeRegionInstanceGroupManagerRequest} request ResizeRegionInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroupManagers|setInstanceTemplate}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @typedef SetInstanceTemplateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetInstanceTemplate.
                         * @function setInstanceTemplate
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.ISetInstanceTemplateRegionInstanceGroupManagerRequest} request SetInstanceTemplateRegionInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagers.SetInstanceTemplateCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroupManagers.prototype.setInstanceTemplate = function setInstanceTemplate(request, callback) {
                            return this.rpcCall(setInstanceTemplate, $root.google.cloud.compute.v1.SetInstanceTemplateRegionInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetInstanceTemplate" });
    
                        /**
                         * Calls SetInstanceTemplate.
                         * @function setInstanceTemplate
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.ISetInstanceTemplateRegionInstanceGroupManagerRequest} request SetInstanceTemplateRegionInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroupManagers|setTargetPools}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @typedef SetTargetPoolsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetTargetPools.
                         * @function setTargetPools
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.ISetTargetPoolsRegionInstanceGroupManagerRequest} request SetTargetPoolsRegionInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagers.SetTargetPoolsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroupManagers.prototype.setTargetPools = function setTargetPools(request, callback) {
                            return this.rpcCall(setTargetPools, $root.google.cloud.compute.v1.SetTargetPoolsRegionInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetTargetPools" });
    
                        /**
                         * Calls SetTargetPools.
                         * @function setTargetPools
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.ISetTargetPoolsRegionInstanceGroupManagerRequest} request SetTargetPoolsRegionInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroupManagers|updatePerInstanceConfigs}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @typedef UpdatePerInstanceConfigsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls UpdatePerInstanceConfigs.
                         * @function updatePerInstanceConfigs
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdatePerInstanceConfigsRegionInstanceGroupManagerRequest} request UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroupManagers.UpdatePerInstanceConfigsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroupManagers.prototype.updatePerInstanceConfigs = function updatePerInstanceConfigs(request, callback) {
                            return this.rpcCall(updatePerInstanceConfigs, $root.google.cloud.compute.v1.UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "UpdatePerInstanceConfigs" });
    
                        /**
                         * Calls UpdatePerInstanceConfigs.
                         * @function updatePerInstanceConfigs
                         * @memberof google.cloud.compute.v1.RegionInstanceGroupManagers
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdatePerInstanceConfigsRegionInstanceGroupManagerRequest} request UpdatePerInstanceConfigsRegionInstanceGroupManagerRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return RegionInstanceGroupManagers;
                    })();
    
                    v1.RegionInstanceGroups = (function() {
    
                        /**
                         * Constructs a new RegionInstanceGroups service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstanceGroups
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionInstanceGroups(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionInstanceGroups.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionInstanceGroups;
    
                        /**
                         * Creates new RegionInstanceGroups service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstanceGroups
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionInstanceGroups} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionInstanceGroups.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroups|get}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroups
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.InstanceGroup} [response] InstanceGroup
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionInstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionInstanceGroupRequest} request GetRegionInstanceGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroups.GetCallback} callback Node-style callback called with the error, if any, and InstanceGroup
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroups.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionInstanceGroupRequest, $root.google.cloud.compute.v1.InstanceGroup, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionInstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionInstanceGroupRequest} request GetRegionInstanceGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.InstanceGroup>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroups|list}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroups
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.RegionInstanceGroupList} [response] RegionInstanceGroupList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionInstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionInstanceGroupsRequest} request ListRegionInstanceGroupsRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroups.ListCallback} callback Node-style callback called with the error, if any, and RegionInstanceGroupList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroups.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionInstanceGroupsRequest, $root.google.cloud.compute.v1.RegionInstanceGroupList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionInstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionInstanceGroupsRequest} request ListRegionInstanceGroupsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.RegionInstanceGroupList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroups|listInstances}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroups
                         * @typedef ListInstancesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.RegionInstanceGroupsListInstances} [response] RegionInstanceGroupsListInstances
                         */
    
                        /**
                         * Calls ListInstances.
                         * @function listInstances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListInstancesRegionInstanceGroupsRequest} request ListInstancesRegionInstanceGroupsRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroups.ListInstancesCallback} callback Node-style callback called with the error, if any, and RegionInstanceGroupsListInstances
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroups.prototype.listInstances = function listInstances(request, callback) {
                            return this.rpcCall(listInstances, $root.google.cloud.compute.v1.ListInstancesRegionInstanceGroupsRequest, $root.google.cloud.compute.v1.RegionInstanceGroupsListInstances, request, callback);
                        }, "name", { value: "ListInstances" });
    
                        /**
                         * Calls ListInstances.
                         * @function listInstances
                         * @memberof google.cloud.compute.v1.RegionInstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListInstancesRegionInstanceGroupsRequest} request ListInstancesRegionInstanceGroupsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.RegionInstanceGroupsListInstances>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstanceGroups|setNamedPorts}.
                         * @memberof google.cloud.compute.v1.RegionInstanceGroups
                         * @typedef SetNamedPortsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetNamedPorts.
                         * @function setNamedPorts
                         * @memberof google.cloud.compute.v1.RegionInstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.ISetNamedPortsRegionInstanceGroupRequest} request SetNamedPortsRegionInstanceGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstanceGroups.SetNamedPortsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstanceGroups.prototype.setNamedPorts = function setNamedPorts(request, callback) {
                            return this.rpcCall(setNamedPorts, $root.google.cloud.compute.v1.SetNamedPortsRegionInstanceGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetNamedPorts" });
    
                        /**
                         * Calls SetNamedPorts.
                         * @function setNamedPorts
                         * @memberof google.cloud.compute.v1.RegionInstanceGroups
                         * @instance
                         * @param {google.cloud.compute.v1.ISetNamedPortsRegionInstanceGroupRequest} request SetNamedPortsRegionInstanceGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return RegionInstanceGroups;
                    })();
    
                    v1.RegionInstances = (function() {
    
                        /**
                         * Constructs a new RegionInstances service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionInstances
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionInstances(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionInstances.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionInstances;
    
                        /**
                         * Creates new RegionInstances service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionInstances
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionInstances} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionInstances.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionInstances|bulkInsert}.
                         * @memberof google.cloud.compute.v1.RegionInstances
                         * @typedef BulkInsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls BulkInsert.
                         * @function bulkInsert
                         * @memberof google.cloud.compute.v1.RegionInstances
                         * @instance
                         * @param {google.cloud.compute.v1.IBulkInsertRegionInstanceRequest} request BulkInsertRegionInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionInstances.BulkInsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionInstances.prototype.bulkInsert = function bulkInsert(request, callback) {
                            return this.rpcCall(bulkInsert, $root.google.cloud.compute.v1.BulkInsertRegionInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "BulkInsert" });
    
                        /**
                         * Calls BulkInsert.
                         * @function bulkInsert
                         * @memberof google.cloud.compute.v1.RegionInstances
                         * @instance
                         * @param {google.cloud.compute.v1.IBulkInsertRegionInstanceRequest} request BulkInsertRegionInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return RegionInstances;
                    })();
    
                    v1.RegionNetworkEndpointGroups = (function() {
    
                        /**
                         * Constructs a new RegionNetworkEndpointGroups service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionNetworkEndpointGroups
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionNetworkEndpointGroups(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionNetworkEndpointGroups.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionNetworkEndpointGroups;
    
                        /**
                         * Creates new RegionNetworkEndpointGroups service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionNetworkEndpointGroups
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionNetworkEndpointGroups} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionNetworkEndpointGroups.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkEndpointGroups|delete_}.
                         * @memberof google.cloud.compute.v1.RegionNetworkEndpointGroups
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionNetworkEndpointGroupRequest} request DeleteRegionNetworkEndpointGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkEndpointGroups.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkEndpointGroups.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteRegionNetworkEndpointGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionNetworkEndpointGroupRequest} request DeleteRegionNetworkEndpointGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkEndpointGroups|get}.
                         * @memberof google.cloud.compute.v1.RegionNetworkEndpointGroups
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NetworkEndpointGroup} [response] NetworkEndpointGroup
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionNetworkEndpointGroupRequest} request GetRegionNetworkEndpointGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkEndpointGroups.GetCallback} callback Node-style callback called with the error, if any, and NetworkEndpointGroup
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkEndpointGroups.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionNetworkEndpointGroupRequest, $root.google.cloud.compute.v1.NetworkEndpointGroup, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionNetworkEndpointGroupRequest} request GetRegionNetworkEndpointGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NetworkEndpointGroup>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkEndpointGroups|insert}.
                         * @memberof google.cloud.compute.v1.RegionNetworkEndpointGroups
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionNetworkEndpointGroupRequest} request InsertRegionNetworkEndpointGroupRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkEndpointGroups.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkEndpointGroups.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertRegionNetworkEndpointGroupRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionNetworkEndpointGroupRequest} request InsertRegionNetworkEndpointGroupRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkEndpointGroups|list}.
                         * @memberof google.cloud.compute.v1.RegionNetworkEndpointGroups
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NetworkEndpointGroupList} [response] NetworkEndpointGroupList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionNetworkEndpointGroupsRequest} request ListRegionNetworkEndpointGroupsRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkEndpointGroups.ListCallback} callback Node-style callback called with the error, if any, and NetworkEndpointGroupList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkEndpointGroups.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionNetworkEndpointGroupsRequest, $root.google.cloud.compute.v1.NetworkEndpointGroupList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionNetworkEndpointGroups
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionNetworkEndpointGroupsRequest} request ListRegionNetworkEndpointGroupsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NetworkEndpointGroupList>} Promise
                         * @variation 2
                         */
    
                        return RegionNetworkEndpointGroups;
                    })();
    
                    v1.RegionNetworkFirewallPolicies = (function() {
    
                        /**
                         * Constructs a new RegionNetworkFirewallPolicies service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionNetworkFirewallPolicies
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionNetworkFirewallPolicies(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionNetworkFirewallPolicies.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionNetworkFirewallPolicies;
    
                        /**
                         * Creates new RegionNetworkFirewallPolicies service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionNetworkFirewallPolicies} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionNetworkFirewallPolicies.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkFirewallPolicies|addAssociation}.
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @typedef AddAssociationCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AddAssociation.
                         * @function addAssociation
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IAddAssociationRegionNetworkFirewallPolicyRequest} request AddAssociationRegionNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkFirewallPolicies.AddAssociationCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkFirewallPolicies.prototype.addAssociation = function addAssociation(request, callback) {
                            return this.rpcCall(addAssociation, $root.google.cloud.compute.v1.AddAssociationRegionNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AddAssociation" });
    
                        /**
                         * Calls AddAssociation.
                         * @function addAssociation
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IAddAssociationRegionNetworkFirewallPolicyRequest} request AddAssociationRegionNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkFirewallPolicies|addRule}.
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @typedef AddRuleCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AddRule.
                         * @function addRule
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IAddRuleRegionNetworkFirewallPolicyRequest} request AddRuleRegionNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkFirewallPolicies.AddRuleCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkFirewallPolicies.prototype.addRule = function addRule(request, callback) {
                            return this.rpcCall(addRule, $root.google.cloud.compute.v1.AddRuleRegionNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AddRule" });
    
                        /**
                         * Calls AddRule.
                         * @function addRule
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IAddRuleRegionNetworkFirewallPolicyRequest} request AddRuleRegionNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkFirewallPolicies|cloneRules}.
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @typedef CloneRulesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls CloneRules.
                         * @function cloneRules
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ICloneRulesRegionNetworkFirewallPolicyRequest} request CloneRulesRegionNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkFirewallPolicies.CloneRulesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkFirewallPolicies.prototype.cloneRules = function cloneRules(request, callback) {
                            return this.rpcCall(cloneRules, $root.google.cloud.compute.v1.CloneRulesRegionNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "CloneRules" });
    
                        /**
                         * Calls CloneRules.
                         * @function cloneRules
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ICloneRulesRegionNetworkFirewallPolicyRequest} request CloneRulesRegionNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkFirewallPolicies|delete_}.
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionNetworkFirewallPolicyRequest} request DeleteRegionNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkFirewallPolicies.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkFirewallPolicies.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteRegionNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionNetworkFirewallPolicyRequest} request DeleteRegionNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkFirewallPolicies|get}.
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.FirewallPolicy} [response] FirewallPolicy
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionNetworkFirewallPolicyRequest} request GetRegionNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkFirewallPolicies.GetCallback} callback Node-style callback called with the error, if any, and FirewallPolicy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkFirewallPolicies.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.FirewallPolicy, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionNetworkFirewallPolicyRequest} request GetRegionNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.FirewallPolicy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkFirewallPolicies|getAssociation}.
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @typedef GetAssociationCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.FirewallPolicyAssociation} [response] FirewallPolicyAssociation
                         */
    
                        /**
                         * Calls GetAssociation.
                         * @function getAssociation
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetAssociationRegionNetworkFirewallPolicyRequest} request GetAssociationRegionNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkFirewallPolicies.GetAssociationCallback} callback Node-style callback called with the error, if any, and FirewallPolicyAssociation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkFirewallPolicies.prototype.getAssociation = function getAssociation(request, callback) {
                            return this.rpcCall(getAssociation, $root.google.cloud.compute.v1.GetAssociationRegionNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.FirewallPolicyAssociation, request, callback);
                        }, "name", { value: "GetAssociation" });
    
                        /**
                         * Calls GetAssociation.
                         * @function getAssociation
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetAssociationRegionNetworkFirewallPolicyRequest} request GetAssociationRegionNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.FirewallPolicyAssociation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkFirewallPolicies|getEffectiveFirewalls}.
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @typedef GetEffectiveFirewallsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse} [response] RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         */
    
                        /**
                         * Calls GetEffectiveFirewalls.
                         * @function getEffectiveFirewalls
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetEffectiveFirewallsRegionNetworkFirewallPolicyRequest} request GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkFirewallPolicies.GetEffectiveFirewallsCallback} callback Node-style callback called with the error, if any, and RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkFirewallPolicies.prototype.getEffectiveFirewalls = function getEffectiveFirewalls(request, callback) {
                            return this.rpcCall(getEffectiveFirewalls, $root.google.cloud.compute.v1.GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse, request, callback);
                        }, "name", { value: "GetEffectiveFirewalls" });
    
                        /**
                         * Calls GetEffectiveFirewalls.
                         * @function getEffectiveFirewalls
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetEffectiveFirewallsRegionNetworkFirewallPolicyRequest} request GetEffectiveFirewallsRegionNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.RegionNetworkFirewallPoliciesGetEffectiveFirewallsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkFirewallPolicies|getIamPolicy}.
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @typedef GetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyRegionNetworkFirewallPolicyRequest} request GetIamPolicyRegionNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkFirewallPolicies.GetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkFirewallPolicies.prototype.getIamPolicy = function getIamPolicy(request, callback) {
                            return this.rpcCall(getIamPolicy, $root.google.cloud.compute.v1.GetIamPolicyRegionNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "GetIamPolicy" });
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyRegionNetworkFirewallPolicyRequest} request GetIamPolicyRegionNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkFirewallPolicies|getRule}.
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @typedef GetRuleCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.FirewallPolicyRule} [response] FirewallPolicyRule
                         */
    
                        /**
                         * Calls GetRule.
                         * @function getRule
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRuleRegionNetworkFirewallPolicyRequest} request GetRuleRegionNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkFirewallPolicies.GetRuleCallback} callback Node-style callback called with the error, if any, and FirewallPolicyRule
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkFirewallPolicies.prototype.getRule = function getRule(request, callback) {
                            return this.rpcCall(getRule, $root.google.cloud.compute.v1.GetRuleRegionNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.FirewallPolicyRule, request, callback);
                        }, "name", { value: "GetRule" });
    
                        /**
                         * Calls GetRule.
                         * @function getRule
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRuleRegionNetworkFirewallPolicyRequest} request GetRuleRegionNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.FirewallPolicyRule>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkFirewallPolicies|insert}.
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionNetworkFirewallPolicyRequest} request InsertRegionNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkFirewallPolicies.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkFirewallPolicies.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertRegionNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionNetworkFirewallPolicyRequest} request InsertRegionNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkFirewallPolicies|list}.
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.FirewallPolicyList} [response] FirewallPolicyList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionNetworkFirewallPoliciesRequest} request ListRegionNetworkFirewallPoliciesRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkFirewallPolicies.ListCallback} callback Node-style callback called with the error, if any, and FirewallPolicyList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkFirewallPolicies.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionNetworkFirewallPoliciesRequest, $root.google.cloud.compute.v1.FirewallPolicyList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionNetworkFirewallPoliciesRequest} request ListRegionNetworkFirewallPoliciesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.FirewallPolicyList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkFirewallPolicies|patch}.
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRegionNetworkFirewallPolicyRequest} request PatchRegionNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkFirewallPolicies.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkFirewallPolicies.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchRegionNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRegionNetworkFirewallPolicyRequest} request PatchRegionNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkFirewallPolicies|patchRule}.
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @typedef PatchRuleCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls PatchRule.
                         * @function patchRule
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRuleRegionNetworkFirewallPolicyRequest} request PatchRuleRegionNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkFirewallPolicies.PatchRuleCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkFirewallPolicies.prototype.patchRule = function patchRule(request, callback) {
                            return this.rpcCall(patchRule, $root.google.cloud.compute.v1.PatchRuleRegionNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "PatchRule" });
    
                        /**
                         * Calls PatchRule.
                         * @function patchRule
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRuleRegionNetworkFirewallPolicyRequest} request PatchRuleRegionNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkFirewallPolicies|removeAssociation}.
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @typedef RemoveAssociationCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls RemoveAssociation.
                         * @function removeAssociation
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveAssociationRegionNetworkFirewallPolicyRequest} request RemoveAssociationRegionNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkFirewallPolicies.RemoveAssociationCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkFirewallPolicies.prototype.removeAssociation = function removeAssociation(request, callback) {
                            return this.rpcCall(removeAssociation, $root.google.cloud.compute.v1.RemoveAssociationRegionNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "RemoveAssociation" });
    
                        /**
                         * Calls RemoveAssociation.
                         * @function removeAssociation
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveAssociationRegionNetworkFirewallPolicyRequest} request RemoveAssociationRegionNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkFirewallPolicies|removeRule}.
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @typedef RemoveRuleCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls RemoveRule.
                         * @function removeRule
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveRuleRegionNetworkFirewallPolicyRequest} request RemoveRuleRegionNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkFirewallPolicies.RemoveRuleCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkFirewallPolicies.prototype.removeRule = function removeRule(request, callback) {
                            return this.rpcCall(removeRule, $root.google.cloud.compute.v1.RemoveRuleRegionNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "RemoveRule" });
    
                        /**
                         * Calls RemoveRule.
                         * @function removeRule
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveRuleRegionNetworkFirewallPolicyRequest} request RemoveRuleRegionNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkFirewallPolicies|setIamPolicy}.
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @typedef SetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyRegionNetworkFirewallPolicyRequest} request SetIamPolicyRegionNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkFirewallPolicies.SetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkFirewallPolicies.prototype.setIamPolicy = function setIamPolicy(request, callback) {
                            return this.rpcCall(setIamPolicy, $root.google.cloud.compute.v1.SetIamPolicyRegionNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "SetIamPolicy" });
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyRegionNetworkFirewallPolicyRequest} request SetIamPolicyRegionNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNetworkFirewallPolicies|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsRegionNetworkFirewallPolicyRequest} request TestIamPermissionsRegionNetworkFirewallPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNetworkFirewallPolicies.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNetworkFirewallPolicies.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsRegionNetworkFirewallPolicyRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.RegionNetworkFirewallPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsRegionNetworkFirewallPolicyRequest} request TestIamPermissionsRegionNetworkFirewallPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        return RegionNetworkFirewallPolicies;
                    })();
    
                    v1.RegionNotificationEndpoints = (function() {
    
                        /**
                         * Constructs a new RegionNotificationEndpoints service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionNotificationEndpoints
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionNotificationEndpoints(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionNotificationEndpoints.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionNotificationEndpoints;
    
                        /**
                         * Creates new RegionNotificationEndpoints service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionNotificationEndpoints
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionNotificationEndpoints} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionNotificationEndpoints.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNotificationEndpoints|delete_}.
                         * @memberof google.cloud.compute.v1.RegionNotificationEndpoints
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionNotificationEndpoints
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionNotificationEndpointRequest} request DeleteRegionNotificationEndpointRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNotificationEndpoints.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNotificationEndpoints.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteRegionNotificationEndpointRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionNotificationEndpoints
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionNotificationEndpointRequest} request DeleteRegionNotificationEndpointRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNotificationEndpoints|get}.
                         * @memberof google.cloud.compute.v1.RegionNotificationEndpoints
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NotificationEndpoint} [response] NotificationEndpoint
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionNotificationEndpoints
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionNotificationEndpointRequest} request GetRegionNotificationEndpointRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNotificationEndpoints.GetCallback} callback Node-style callback called with the error, if any, and NotificationEndpoint
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNotificationEndpoints.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionNotificationEndpointRequest, $root.google.cloud.compute.v1.NotificationEndpoint, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionNotificationEndpoints
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionNotificationEndpointRequest} request GetRegionNotificationEndpointRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NotificationEndpoint>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNotificationEndpoints|insert}.
                         * @memberof google.cloud.compute.v1.RegionNotificationEndpoints
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionNotificationEndpoints
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionNotificationEndpointRequest} request InsertRegionNotificationEndpointRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNotificationEndpoints.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNotificationEndpoints.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertRegionNotificationEndpointRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionNotificationEndpoints
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionNotificationEndpointRequest} request InsertRegionNotificationEndpointRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionNotificationEndpoints|list}.
                         * @memberof google.cloud.compute.v1.RegionNotificationEndpoints
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.NotificationEndpointList} [response] NotificationEndpointList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionNotificationEndpoints
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionNotificationEndpointsRequest} request ListRegionNotificationEndpointsRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionNotificationEndpoints.ListCallback} callback Node-style callback called with the error, if any, and NotificationEndpointList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionNotificationEndpoints.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionNotificationEndpointsRequest, $root.google.cloud.compute.v1.NotificationEndpointList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionNotificationEndpoints
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionNotificationEndpointsRequest} request ListRegionNotificationEndpointsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.NotificationEndpointList>} Promise
                         * @variation 2
                         */
    
                        return RegionNotificationEndpoints;
                    })();
    
                    v1.RegionOperations = (function() {
    
                        /**
                         * Constructs a new RegionOperations service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionOperations
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionOperations(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionOperations.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionOperations;
    
                        /**
                         * Creates new RegionOperations service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionOperations
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionOperations} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionOperations.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionOperations|delete_}.
                         * @memberof google.cloud.compute.v1.RegionOperations
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.DeleteRegionOperationResponse} [response] DeleteRegionOperationResponse
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionOperationRequest} request DeleteRegionOperationRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionOperations.DeleteCallback} callback Node-style callback called with the error, if any, and DeleteRegionOperationResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionOperations.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteRegionOperationRequest, $root.google.cloud.compute.v1.DeleteRegionOperationResponse, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionOperationRequest} request DeleteRegionOperationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.DeleteRegionOperationResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionOperations|get}.
                         * @memberof google.cloud.compute.v1.RegionOperations
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionOperationRequest} request GetRegionOperationRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionOperations.GetCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionOperations.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionOperationRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionOperationRequest} request GetRegionOperationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionOperations|list}.
                         * @memberof google.cloud.compute.v1.RegionOperations
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.OperationList} [response] OperationList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionOperationsRequest} request ListRegionOperationsRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionOperations.ListCallback} callback Node-style callback called with the error, if any, and OperationList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionOperations.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionOperationsRequest, $root.google.cloud.compute.v1.OperationList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionOperationsRequest} request ListRegionOperationsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.OperationList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionOperations|wait}.
                         * @memberof google.cloud.compute.v1.RegionOperations
                         * @typedef WaitCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Wait.
                         * @function wait
                         * @memberof google.cloud.compute.v1.RegionOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IWaitRegionOperationRequest} request WaitRegionOperationRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionOperations.WaitCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionOperations.prototype.wait = function wait(request, callback) {
                            return this.rpcCall(wait, $root.google.cloud.compute.v1.WaitRegionOperationRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Wait" });
    
                        /**
                         * Calls Wait.
                         * @function wait
                         * @memberof google.cloud.compute.v1.RegionOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IWaitRegionOperationRequest} request WaitRegionOperationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return RegionOperations;
                    })();
    
                    v1.RegionSecurityPolicies = (function() {
    
                        /**
                         * Constructs a new RegionSecurityPolicies service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionSecurityPolicies
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionSecurityPolicies(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionSecurityPolicies.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionSecurityPolicies;
    
                        /**
                         * Creates new RegionSecurityPolicies service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionSecurityPolicies
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionSecurityPolicies} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionSecurityPolicies.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionSecurityPolicies|delete_}.
                         * @memberof google.cloud.compute.v1.RegionSecurityPolicies
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionSecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionSecurityPolicyRequest} request DeleteRegionSecurityPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionSecurityPolicies.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionSecurityPolicies.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteRegionSecurityPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionSecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionSecurityPolicyRequest} request DeleteRegionSecurityPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionSecurityPolicies|get}.
                         * @memberof google.cloud.compute.v1.RegionSecurityPolicies
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SecurityPolicy} [response] SecurityPolicy
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionSecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionSecurityPolicyRequest} request GetRegionSecurityPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionSecurityPolicies.GetCallback} callback Node-style callback called with the error, if any, and SecurityPolicy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionSecurityPolicies.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionSecurityPolicyRequest, $root.google.cloud.compute.v1.SecurityPolicy, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionSecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionSecurityPolicyRequest} request GetRegionSecurityPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SecurityPolicy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionSecurityPolicies|insert}.
                         * @memberof google.cloud.compute.v1.RegionSecurityPolicies
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionSecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionSecurityPolicyRequest} request InsertRegionSecurityPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionSecurityPolicies.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionSecurityPolicies.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertRegionSecurityPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionSecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionSecurityPolicyRequest} request InsertRegionSecurityPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionSecurityPolicies|list}.
                         * @memberof google.cloud.compute.v1.RegionSecurityPolicies
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SecurityPolicyList} [response] SecurityPolicyList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionSecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionSecurityPoliciesRequest} request ListRegionSecurityPoliciesRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionSecurityPolicies.ListCallback} callback Node-style callback called with the error, if any, and SecurityPolicyList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionSecurityPolicies.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionSecurityPoliciesRequest, $root.google.cloud.compute.v1.SecurityPolicyList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionSecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionSecurityPoliciesRequest} request ListRegionSecurityPoliciesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SecurityPolicyList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionSecurityPolicies|patch}.
                         * @memberof google.cloud.compute.v1.RegionSecurityPolicies
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.RegionSecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRegionSecurityPolicyRequest} request PatchRegionSecurityPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionSecurityPolicies.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionSecurityPolicies.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchRegionSecurityPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.RegionSecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRegionSecurityPolicyRequest} request PatchRegionSecurityPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return RegionSecurityPolicies;
                    })();
    
                    v1.RegionSslCertificates = (function() {
    
                        /**
                         * Constructs a new RegionSslCertificates service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionSslCertificates
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionSslCertificates(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionSslCertificates.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionSslCertificates;
    
                        /**
                         * Creates new RegionSslCertificates service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionSslCertificates
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionSslCertificates} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionSslCertificates.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionSslCertificates|delete_}.
                         * @memberof google.cloud.compute.v1.RegionSslCertificates
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionSslCertificates
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionSslCertificateRequest} request DeleteRegionSslCertificateRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionSslCertificates.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionSslCertificates.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteRegionSslCertificateRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionSslCertificates
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionSslCertificateRequest} request DeleteRegionSslCertificateRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionSslCertificates|get}.
                         * @memberof google.cloud.compute.v1.RegionSslCertificates
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SslCertificate} [response] SslCertificate
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionSslCertificates
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionSslCertificateRequest} request GetRegionSslCertificateRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionSslCertificates.GetCallback} callback Node-style callback called with the error, if any, and SslCertificate
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionSslCertificates.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionSslCertificateRequest, $root.google.cloud.compute.v1.SslCertificate, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionSslCertificates
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionSslCertificateRequest} request GetRegionSslCertificateRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SslCertificate>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionSslCertificates|insert}.
                         * @memberof google.cloud.compute.v1.RegionSslCertificates
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionSslCertificates
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionSslCertificateRequest} request InsertRegionSslCertificateRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionSslCertificates.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionSslCertificates.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertRegionSslCertificateRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionSslCertificates
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionSslCertificateRequest} request InsertRegionSslCertificateRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionSslCertificates|list}.
                         * @memberof google.cloud.compute.v1.RegionSslCertificates
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SslCertificateList} [response] SslCertificateList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionSslCertificates
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionSslCertificatesRequest} request ListRegionSslCertificatesRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionSslCertificates.ListCallback} callback Node-style callback called with the error, if any, and SslCertificateList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionSslCertificates.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionSslCertificatesRequest, $root.google.cloud.compute.v1.SslCertificateList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionSslCertificates
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionSslCertificatesRequest} request ListRegionSslCertificatesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SslCertificateList>} Promise
                         * @variation 2
                         */
    
                        return RegionSslCertificates;
                    })();
    
                    v1.RegionSslPolicies = (function() {
    
                        /**
                         * Constructs a new RegionSslPolicies service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionSslPolicies
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionSslPolicies(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionSslPolicies.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionSslPolicies;
    
                        /**
                         * Creates new RegionSslPolicies service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionSslPolicies
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionSslPolicies} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionSslPolicies.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionSslPolicies|delete_}.
                         * @memberof google.cloud.compute.v1.RegionSslPolicies
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionSslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionSslPolicyRequest} request DeleteRegionSslPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionSslPolicies.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionSslPolicies.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteRegionSslPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionSslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionSslPolicyRequest} request DeleteRegionSslPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionSslPolicies|get}.
                         * @memberof google.cloud.compute.v1.RegionSslPolicies
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SslPolicy} [response] SslPolicy
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionSslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionSslPolicyRequest} request GetRegionSslPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionSslPolicies.GetCallback} callback Node-style callback called with the error, if any, and SslPolicy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionSslPolicies.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionSslPolicyRequest, $root.google.cloud.compute.v1.SslPolicy, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionSslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionSslPolicyRequest} request GetRegionSslPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SslPolicy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionSslPolicies|insert}.
                         * @memberof google.cloud.compute.v1.RegionSslPolicies
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionSslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionSslPolicyRequest} request InsertRegionSslPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionSslPolicies.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionSslPolicies.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertRegionSslPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionSslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionSslPolicyRequest} request InsertRegionSslPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionSslPolicies|list}.
                         * @memberof google.cloud.compute.v1.RegionSslPolicies
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SslPoliciesList} [response] SslPoliciesList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionSslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionSslPoliciesRequest} request ListRegionSslPoliciesRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionSslPolicies.ListCallback} callback Node-style callback called with the error, if any, and SslPoliciesList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionSslPolicies.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionSslPoliciesRequest, $root.google.cloud.compute.v1.SslPoliciesList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionSslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionSslPoliciesRequest} request ListRegionSslPoliciesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SslPoliciesList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionSslPolicies|listAvailableFeatures}.
                         * @memberof google.cloud.compute.v1.RegionSslPolicies
                         * @typedef ListAvailableFeaturesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse} [response] SslPoliciesListAvailableFeaturesResponse
                         */
    
                        /**
                         * Calls ListAvailableFeatures.
                         * @function listAvailableFeatures
                         * @memberof google.cloud.compute.v1.RegionSslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListAvailableFeaturesRegionSslPoliciesRequest} request ListAvailableFeaturesRegionSslPoliciesRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionSslPolicies.ListAvailableFeaturesCallback} callback Node-style callback called with the error, if any, and SslPoliciesListAvailableFeaturesResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionSslPolicies.prototype.listAvailableFeatures = function listAvailableFeatures(request, callback) {
                            return this.rpcCall(listAvailableFeatures, $root.google.cloud.compute.v1.ListAvailableFeaturesRegionSslPoliciesRequest, $root.google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse, request, callback);
                        }, "name", { value: "ListAvailableFeatures" });
    
                        /**
                         * Calls ListAvailableFeatures.
                         * @function listAvailableFeatures
                         * @memberof google.cloud.compute.v1.RegionSslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListAvailableFeaturesRegionSslPoliciesRequest} request ListAvailableFeaturesRegionSslPoliciesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionSslPolicies|patch}.
                         * @memberof google.cloud.compute.v1.RegionSslPolicies
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.RegionSslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRegionSslPolicyRequest} request PatchRegionSslPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionSslPolicies.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionSslPolicies.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchRegionSslPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.RegionSslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRegionSslPolicyRequest} request PatchRegionSslPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return RegionSslPolicies;
                    })();
    
                    v1.RegionTargetHttpProxies = (function() {
    
                        /**
                         * Constructs a new RegionTargetHttpProxies service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionTargetHttpProxies
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionTargetHttpProxies(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionTargetHttpProxies.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionTargetHttpProxies;
    
                        /**
                         * Creates new RegionTargetHttpProxies service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionTargetHttpProxies
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionTargetHttpProxies} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionTargetHttpProxies.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionTargetHttpProxies|delete_}.
                         * @memberof google.cloud.compute.v1.RegionTargetHttpProxies
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionTargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionTargetHttpProxyRequest} request DeleteRegionTargetHttpProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionTargetHttpProxies.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionTargetHttpProxies.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteRegionTargetHttpProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionTargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionTargetHttpProxyRequest} request DeleteRegionTargetHttpProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionTargetHttpProxies|get}.
                         * @memberof google.cloud.compute.v1.RegionTargetHttpProxies
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetHttpProxy} [response] TargetHttpProxy
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionTargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionTargetHttpProxyRequest} request GetRegionTargetHttpProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionTargetHttpProxies.GetCallback} callback Node-style callback called with the error, if any, and TargetHttpProxy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionTargetHttpProxies.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionTargetHttpProxyRequest, $root.google.cloud.compute.v1.TargetHttpProxy, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionTargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionTargetHttpProxyRequest} request GetRegionTargetHttpProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetHttpProxy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionTargetHttpProxies|insert}.
                         * @memberof google.cloud.compute.v1.RegionTargetHttpProxies
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionTargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionTargetHttpProxyRequest} request InsertRegionTargetHttpProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionTargetHttpProxies.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionTargetHttpProxies.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertRegionTargetHttpProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionTargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionTargetHttpProxyRequest} request InsertRegionTargetHttpProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionTargetHttpProxies|list}.
                         * @memberof google.cloud.compute.v1.RegionTargetHttpProxies
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetHttpProxyList} [response] TargetHttpProxyList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionTargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionTargetHttpProxiesRequest} request ListRegionTargetHttpProxiesRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionTargetHttpProxies.ListCallback} callback Node-style callback called with the error, if any, and TargetHttpProxyList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionTargetHttpProxies.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionTargetHttpProxiesRequest, $root.google.cloud.compute.v1.TargetHttpProxyList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionTargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionTargetHttpProxiesRequest} request ListRegionTargetHttpProxiesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetHttpProxyList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionTargetHttpProxies|setUrlMap}.
                         * @memberof google.cloud.compute.v1.RegionTargetHttpProxies
                         * @typedef SetUrlMapCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetUrlMap.
                         * @function setUrlMap
                         * @memberof google.cloud.compute.v1.RegionTargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetUrlMapRegionTargetHttpProxyRequest} request SetUrlMapRegionTargetHttpProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionTargetHttpProxies.SetUrlMapCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionTargetHttpProxies.prototype.setUrlMap = function setUrlMap(request, callback) {
                            return this.rpcCall(setUrlMap, $root.google.cloud.compute.v1.SetUrlMapRegionTargetHttpProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetUrlMap" });
    
                        /**
                         * Calls SetUrlMap.
                         * @function setUrlMap
                         * @memberof google.cloud.compute.v1.RegionTargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetUrlMapRegionTargetHttpProxyRequest} request SetUrlMapRegionTargetHttpProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return RegionTargetHttpProxies;
                    })();
    
                    v1.RegionTargetHttpsProxies = (function() {
    
                        /**
                         * Constructs a new RegionTargetHttpsProxies service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionTargetHttpsProxies
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionTargetHttpsProxies(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionTargetHttpsProxies.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionTargetHttpsProxies;
    
                        /**
                         * Creates new RegionTargetHttpsProxies service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionTargetHttpsProxies} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionTargetHttpsProxies.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionTargetHttpsProxies|delete_}.
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionTargetHttpsProxyRequest} request DeleteRegionTargetHttpsProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionTargetHttpsProxies.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionTargetHttpsProxies.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteRegionTargetHttpsProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionTargetHttpsProxyRequest} request DeleteRegionTargetHttpsProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionTargetHttpsProxies|get}.
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetHttpsProxy} [response] TargetHttpsProxy
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionTargetHttpsProxyRequest} request GetRegionTargetHttpsProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionTargetHttpsProxies.GetCallback} callback Node-style callback called with the error, if any, and TargetHttpsProxy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionTargetHttpsProxies.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionTargetHttpsProxyRequest, $root.google.cloud.compute.v1.TargetHttpsProxy, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionTargetHttpsProxyRequest} request GetRegionTargetHttpsProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetHttpsProxy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionTargetHttpsProxies|insert}.
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionTargetHttpsProxyRequest} request InsertRegionTargetHttpsProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionTargetHttpsProxies.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionTargetHttpsProxies.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertRegionTargetHttpsProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionTargetHttpsProxyRequest} request InsertRegionTargetHttpsProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionTargetHttpsProxies|list}.
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetHttpsProxyList} [response] TargetHttpsProxyList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionTargetHttpsProxiesRequest} request ListRegionTargetHttpsProxiesRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionTargetHttpsProxies.ListCallback} callback Node-style callback called with the error, if any, and TargetHttpsProxyList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionTargetHttpsProxies.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionTargetHttpsProxiesRequest, $root.google.cloud.compute.v1.TargetHttpsProxyList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionTargetHttpsProxiesRequest} request ListRegionTargetHttpsProxiesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetHttpsProxyList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionTargetHttpsProxies|patch}.
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRegionTargetHttpsProxyRequest} request PatchRegionTargetHttpsProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionTargetHttpsProxies.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionTargetHttpsProxies.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchRegionTargetHttpsProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRegionTargetHttpsProxyRequest} request PatchRegionTargetHttpsProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionTargetHttpsProxies|setSslCertificates}.
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @typedef SetSslCertificatesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetSslCertificates.
                         * @function setSslCertificates
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetSslCertificatesRegionTargetHttpsProxyRequest} request SetSslCertificatesRegionTargetHttpsProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionTargetHttpsProxies.SetSslCertificatesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionTargetHttpsProxies.prototype.setSslCertificates = function setSslCertificates(request, callback) {
                            return this.rpcCall(setSslCertificates, $root.google.cloud.compute.v1.SetSslCertificatesRegionTargetHttpsProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetSslCertificates" });
    
                        /**
                         * Calls SetSslCertificates.
                         * @function setSslCertificates
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetSslCertificatesRegionTargetHttpsProxyRequest} request SetSslCertificatesRegionTargetHttpsProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionTargetHttpsProxies|setUrlMap}.
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @typedef SetUrlMapCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetUrlMap.
                         * @function setUrlMap
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetUrlMapRegionTargetHttpsProxyRequest} request SetUrlMapRegionTargetHttpsProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionTargetHttpsProxies.SetUrlMapCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionTargetHttpsProxies.prototype.setUrlMap = function setUrlMap(request, callback) {
                            return this.rpcCall(setUrlMap, $root.google.cloud.compute.v1.SetUrlMapRegionTargetHttpsProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetUrlMap" });
    
                        /**
                         * Calls SetUrlMap.
                         * @function setUrlMap
                         * @memberof google.cloud.compute.v1.RegionTargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetUrlMapRegionTargetHttpsProxyRequest} request SetUrlMapRegionTargetHttpsProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return RegionTargetHttpsProxies;
                    })();
    
                    v1.RegionTargetTcpProxies = (function() {
    
                        /**
                         * Constructs a new RegionTargetTcpProxies service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionTargetTcpProxies
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionTargetTcpProxies(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionTargetTcpProxies.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionTargetTcpProxies;
    
                        /**
                         * Creates new RegionTargetTcpProxies service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionTargetTcpProxies
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionTargetTcpProxies} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionTargetTcpProxies.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionTargetTcpProxies|delete_}.
                         * @memberof google.cloud.compute.v1.RegionTargetTcpProxies
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionTargetTcpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionTargetTcpProxyRequest} request DeleteRegionTargetTcpProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionTargetTcpProxies.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionTargetTcpProxies.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteRegionTargetTcpProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionTargetTcpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionTargetTcpProxyRequest} request DeleteRegionTargetTcpProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionTargetTcpProxies|get}.
                         * @memberof google.cloud.compute.v1.RegionTargetTcpProxies
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetTcpProxy} [response] TargetTcpProxy
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionTargetTcpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionTargetTcpProxyRequest} request GetRegionTargetTcpProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionTargetTcpProxies.GetCallback} callback Node-style callback called with the error, if any, and TargetTcpProxy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionTargetTcpProxies.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionTargetTcpProxyRequest, $root.google.cloud.compute.v1.TargetTcpProxy, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionTargetTcpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionTargetTcpProxyRequest} request GetRegionTargetTcpProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetTcpProxy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionTargetTcpProxies|insert}.
                         * @memberof google.cloud.compute.v1.RegionTargetTcpProxies
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionTargetTcpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionTargetTcpProxyRequest} request InsertRegionTargetTcpProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionTargetTcpProxies.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionTargetTcpProxies.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertRegionTargetTcpProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionTargetTcpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionTargetTcpProxyRequest} request InsertRegionTargetTcpProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionTargetTcpProxies|list}.
                         * @memberof google.cloud.compute.v1.RegionTargetTcpProxies
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetTcpProxyList} [response] TargetTcpProxyList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionTargetTcpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionTargetTcpProxiesRequest} request ListRegionTargetTcpProxiesRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionTargetTcpProxies.ListCallback} callback Node-style callback called with the error, if any, and TargetTcpProxyList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionTargetTcpProxies.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionTargetTcpProxiesRequest, $root.google.cloud.compute.v1.TargetTcpProxyList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionTargetTcpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionTargetTcpProxiesRequest} request ListRegionTargetTcpProxiesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetTcpProxyList>} Promise
                         * @variation 2
                         */
    
                        return RegionTargetTcpProxies;
                    })();
    
                    v1.RegionUrlMaps = (function() {
    
                        /**
                         * Constructs a new RegionUrlMaps service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a RegionUrlMaps
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionUrlMaps(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionUrlMaps.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionUrlMaps;
    
                        /**
                         * Creates new RegionUrlMaps service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionUrlMaps} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionUrlMaps.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionUrlMaps|delete_}.
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionUrlMapRequest} request DeleteRegionUrlMapRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionUrlMaps.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionUrlMaps.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteRegionUrlMapRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRegionUrlMapRequest} request DeleteRegionUrlMapRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionUrlMaps|get}.
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.UrlMap} [response] UrlMap
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionUrlMapRequest} request GetRegionUrlMapRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionUrlMaps.GetCallback} callback Node-style callback called with the error, if any, and UrlMap
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionUrlMaps.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionUrlMapRequest, $root.google.cloud.compute.v1.UrlMap, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionUrlMapRequest} request GetRegionUrlMapRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.UrlMap>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionUrlMaps|insert}.
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionUrlMapRequest} request InsertRegionUrlMapRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionUrlMaps.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionUrlMaps.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertRegionUrlMapRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRegionUrlMapRequest} request InsertRegionUrlMapRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionUrlMaps|list}.
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.UrlMapList} [response] UrlMapList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionUrlMapsRequest} request ListRegionUrlMapsRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionUrlMaps.ListCallback} callback Node-style callback called with the error, if any, and UrlMapList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionUrlMaps.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionUrlMapsRequest, $root.google.cloud.compute.v1.UrlMapList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionUrlMapsRequest} request ListRegionUrlMapsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.UrlMapList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionUrlMaps|patch}.
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRegionUrlMapRequest} request PatchRegionUrlMapRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionUrlMaps.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionUrlMaps.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchRegionUrlMapRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRegionUrlMapRequest} request PatchRegionUrlMapRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionUrlMaps|update}.
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @typedef UpdateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateRegionUrlMapRequest} request UpdateRegionUrlMapRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionUrlMaps.UpdateCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionUrlMaps.prototype.update = function update(request, callback) {
                            return this.rpcCall(update, $root.google.cloud.compute.v1.UpdateRegionUrlMapRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Update" });
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateRegionUrlMapRequest} request UpdateRegionUrlMapRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.RegionUrlMaps|validate}.
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @typedef ValidateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.UrlMapsValidateResponse} [response] UrlMapsValidateResponse
                         */
    
                        /**
                         * Calls Validate.
                         * @function validate
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IValidateRegionUrlMapRequest} request ValidateRegionUrlMapRequest message or plain object
                         * @param {google.cloud.compute.v1.RegionUrlMaps.ValidateCallback} callback Node-style callback called with the error, if any, and UrlMapsValidateResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionUrlMaps.prototype.validate = function validate(request, callback) {
                            return this.rpcCall(validate, $root.google.cloud.compute.v1.ValidateRegionUrlMapRequest, $root.google.cloud.compute.v1.UrlMapsValidateResponse, request, callback);
                        }, "name", { value: "Validate" });
    
                        /**
                         * Calls Validate.
                         * @function validate
                         * @memberof google.cloud.compute.v1.RegionUrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IValidateRegionUrlMapRequest} request ValidateRegionUrlMapRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.UrlMapsValidateResponse>} Promise
                         * @variation 2
                         */
    
                        return RegionUrlMaps;
                    })();
    
                    v1.Regions = (function() {
    
                        /**
                         * Constructs a new Regions service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Regions
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function Regions(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (Regions.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = Regions;
    
                        /**
                         * Creates new Regions service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.Regions
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {Regions} RPC service. Useful where requests and/or responses are streamed.
                         */
                        Regions.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Regions|get}.
                         * @memberof google.cloud.compute.v1.Regions
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Region} [response] Region
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Regions
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionRequest} request GetRegionRequest message or plain object
                         * @param {google.cloud.compute.v1.Regions.GetCallback} callback Node-style callback called with the error, if any, and Region
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Regions.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRegionRequest, $root.google.cloud.compute.v1.Region, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Regions
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRegionRequest} request GetRegionRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Region>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Regions|list}.
                         * @memberof google.cloud.compute.v1.Regions
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.RegionList} [response] RegionList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Regions
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionsRequest} request ListRegionsRequest message or plain object
                         * @param {google.cloud.compute.v1.Regions.ListCallback} callback Node-style callback called with the error, if any, and RegionList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Regions.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRegionsRequest, $root.google.cloud.compute.v1.RegionList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Regions
                         * @instance
                         * @param {google.cloud.compute.v1.IListRegionsRequest} request ListRegionsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.RegionList>} Promise
                         * @variation 2
                         */
    
                        return Regions;
                    })();
    
                    v1.Reservations = (function() {
    
                        /**
                         * Constructs a new Reservations service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Reservations
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function Reservations(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (Reservations.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = Reservations;
    
                        /**
                         * Creates new Reservations service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.Reservations
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {Reservations} RPC service. Useful where requests and/or responses are streamed.
                         */
                        Reservations.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Reservations|aggregatedList}.
                         * @memberof google.cloud.compute.v1.Reservations
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ReservationAggregatedList} [response] ReservationAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.Reservations
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListReservationsRequest} request AggregatedListReservationsRequest message or plain object
                         * @param {google.cloud.compute.v1.Reservations.AggregatedListCallback} callback Node-style callback called with the error, if any, and ReservationAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Reservations.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListReservationsRequest, $root.google.cloud.compute.v1.ReservationAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.Reservations
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListReservationsRequest} request AggregatedListReservationsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ReservationAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Reservations|delete_}.
                         * @memberof google.cloud.compute.v1.Reservations
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Reservations
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteReservationRequest} request DeleteReservationRequest message or plain object
                         * @param {google.cloud.compute.v1.Reservations.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Reservations.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteReservationRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Reservations
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteReservationRequest} request DeleteReservationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Reservations|get}.
                         * @memberof google.cloud.compute.v1.Reservations
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Reservation} [response] Reservation
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Reservations
                         * @instance
                         * @param {google.cloud.compute.v1.IGetReservationRequest} request GetReservationRequest message or plain object
                         * @param {google.cloud.compute.v1.Reservations.GetCallback} callback Node-style callback called with the error, if any, and Reservation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Reservations.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetReservationRequest, $root.google.cloud.compute.v1.Reservation, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Reservations
                         * @instance
                         * @param {google.cloud.compute.v1.IGetReservationRequest} request GetReservationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Reservation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Reservations|getIamPolicy}.
                         * @memberof google.cloud.compute.v1.Reservations
                         * @typedef GetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.Reservations
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyReservationRequest} request GetIamPolicyReservationRequest message or plain object
                         * @param {google.cloud.compute.v1.Reservations.GetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Reservations.prototype.getIamPolicy = function getIamPolicy(request, callback) {
                            return this.rpcCall(getIamPolicy, $root.google.cloud.compute.v1.GetIamPolicyReservationRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "GetIamPolicy" });
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.Reservations
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyReservationRequest} request GetIamPolicyReservationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Reservations|insert}.
                         * @memberof google.cloud.compute.v1.Reservations
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Reservations
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertReservationRequest} request InsertReservationRequest message or plain object
                         * @param {google.cloud.compute.v1.Reservations.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Reservations.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertReservationRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Reservations
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertReservationRequest} request InsertReservationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Reservations|list}.
                         * @memberof google.cloud.compute.v1.Reservations
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ReservationList} [response] ReservationList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Reservations
                         * @instance
                         * @param {google.cloud.compute.v1.IListReservationsRequest} request ListReservationsRequest message or plain object
                         * @param {google.cloud.compute.v1.Reservations.ListCallback} callback Node-style callback called with the error, if any, and ReservationList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Reservations.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListReservationsRequest, $root.google.cloud.compute.v1.ReservationList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Reservations
                         * @instance
                         * @param {google.cloud.compute.v1.IListReservationsRequest} request ListReservationsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ReservationList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Reservations|resize}.
                         * @memberof google.cloud.compute.v1.Reservations
                         * @typedef ResizeCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Resize.
                         * @function resize
                         * @memberof google.cloud.compute.v1.Reservations
                         * @instance
                         * @param {google.cloud.compute.v1.IResizeReservationRequest} request ResizeReservationRequest message or plain object
                         * @param {google.cloud.compute.v1.Reservations.ResizeCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Reservations.prototype.resize = function resize(request, callback) {
                            return this.rpcCall(resize, $root.google.cloud.compute.v1.ResizeReservationRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Resize" });
    
                        /**
                         * Calls Resize.
                         * @function resize
                         * @memberof google.cloud.compute.v1.Reservations
                         * @instance
                         * @param {google.cloud.compute.v1.IResizeReservationRequest} request ResizeReservationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Reservations|setIamPolicy}.
                         * @memberof google.cloud.compute.v1.Reservations
                         * @typedef SetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.Reservations
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyReservationRequest} request SetIamPolicyReservationRequest message or plain object
                         * @param {google.cloud.compute.v1.Reservations.SetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Reservations.prototype.setIamPolicy = function setIamPolicy(request, callback) {
                            return this.rpcCall(setIamPolicy, $root.google.cloud.compute.v1.SetIamPolicyReservationRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "SetIamPolicy" });
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.Reservations
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyReservationRequest} request SetIamPolicyReservationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Reservations|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.Reservations
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.Reservations
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsReservationRequest} request TestIamPermissionsReservationRequest message or plain object
                         * @param {google.cloud.compute.v1.Reservations.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Reservations.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsReservationRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.Reservations
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsReservationRequest} request TestIamPermissionsReservationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Reservations|update}.
                         * @memberof google.cloud.compute.v1.Reservations
                         * @typedef UpdateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.Reservations
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateReservationRequest} request UpdateReservationRequest message or plain object
                         * @param {google.cloud.compute.v1.Reservations.UpdateCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Reservations.prototype.update = function update(request, callback) {
                            return this.rpcCall(update, $root.google.cloud.compute.v1.UpdateReservationRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Update" });
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.Reservations
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateReservationRequest} request UpdateReservationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return Reservations;
                    })();
    
                    v1.ResourcePolicies = (function() {
    
                        /**
                         * Constructs a new ResourcePolicies service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ResourcePolicies
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function ResourcePolicies(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (ResourcePolicies.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = ResourcePolicies;
    
                        /**
                         * Creates new ResourcePolicies service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {ResourcePolicies} RPC service. Useful where requests and/or responses are streamed.
                         */
                        ResourcePolicies.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ResourcePolicies|aggregatedList}.
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ResourcePolicyAggregatedList} [response] ResourcePolicyAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListResourcePoliciesRequest} request AggregatedListResourcePoliciesRequest message or plain object
                         * @param {google.cloud.compute.v1.ResourcePolicies.AggregatedListCallback} callback Node-style callback called with the error, if any, and ResourcePolicyAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ResourcePolicies.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListResourcePoliciesRequest, $root.google.cloud.compute.v1.ResourcePolicyAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListResourcePoliciesRequest} request AggregatedListResourcePoliciesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ResourcePolicyAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ResourcePolicies|delete_}.
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteResourcePolicyRequest} request DeleteResourcePolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.ResourcePolicies.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ResourcePolicies.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteResourcePolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteResourcePolicyRequest} request DeleteResourcePolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ResourcePolicies|get}.
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ResourcePolicy} [response] ResourcePolicy
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetResourcePolicyRequest} request GetResourcePolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.ResourcePolicies.GetCallback} callback Node-style callback called with the error, if any, and ResourcePolicy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ResourcePolicies.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetResourcePolicyRequest, $root.google.cloud.compute.v1.ResourcePolicy, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetResourcePolicyRequest} request GetResourcePolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ResourcePolicy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ResourcePolicies|getIamPolicy}.
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @typedef GetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyResourcePolicyRequest} request GetIamPolicyResourcePolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.ResourcePolicies.GetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ResourcePolicies.prototype.getIamPolicy = function getIamPolicy(request, callback) {
                            return this.rpcCall(getIamPolicy, $root.google.cloud.compute.v1.GetIamPolicyResourcePolicyRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "GetIamPolicy" });
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyResourcePolicyRequest} request GetIamPolicyResourcePolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ResourcePolicies|insert}.
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertResourcePolicyRequest} request InsertResourcePolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.ResourcePolicies.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ResourcePolicies.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertResourcePolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertResourcePolicyRequest} request InsertResourcePolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ResourcePolicies|list}.
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ResourcePolicyList} [response] ResourcePolicyList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListResourcePoliciesRequest} request ListResourcePoliciesRequest message or plain object
                         * @param {google.cloud.compute.v1.ResourcePolicies.ListCallback} callback Node-style callback called with the error, if any, and ResourcePolicyList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ResourcePolicies.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListResourcePoliciesRequest, $root.google.cloud.compute.v1.ResourcePolicyList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListResourcePoliciesRequest} request ListResourcePoliciesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ResourcePolicyList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ResourcePolicies|setIamPolicy}.
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @typedef SetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyResourcePolicyRequest} request SetIamPolicyResourcePolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.ResourcePolicies.SetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ResourcePolicies.prototype.setIamPolicy = function setIamPolicy(request, callback) {
                            return this.rpcCall(setIamPolicy, $root.google.cloud.compute.v1.SetIamPolicyResourcePolicyRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "SetIamPolicy" });
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyResourcePolicyRequest} request SetIamPolicyResourcePolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ResourcePolicies|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsResourcePolicyRequest} request TestIamPermissionsResourcePolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.ResourcePolicies.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ResourcePolicies.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsResourcePolicyRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.ResourcePolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsResourcePolicyRequest} request TestIamPermissionsResourcePolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        return ResourcePolicies;
                    })();
    
                    v1.Routers = (function() {
    
                        /**
                         * Constructs a new Routers service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Routers
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function Routers(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (Routers.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = Routers;
    
                        /**
                         * Creates new Routers service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.Routers
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {Routers} RPC service. Useful where requests and/or responses are streamed.
                         */
                        Routers.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Routers|aggregatedList}.
                         * @memberof google.cloud.compute.v1.Routers
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.RouterAggregatedList} [response] RouterAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.Routers
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListRoutersRequest} request AggregatedListRoutersRequest message or plain object
                         * @param {google.cloud.compute.v1.Routers.AggregatedListCallback} callback Node-style callback called with the error, if any, and RouterAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Routers.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListRoutersRequest, $root.google.cloud.compute.v1.RouterAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.Routers
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListRoutersRequest} request AggregatedListRoutersRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.RouterAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Routers|delete_}.
                         * @memberof google.cloud.compute.v1.Routers
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Routers
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRouterRequest} request DeleteRouterRequest message or plain object
                         * @param {google.cloud.compute.v1.Routers.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Routers.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteRouterRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Routers
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRouterRequest} request DeleteRouterRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Routers|get}.
                         * @memberof google.cloud.compute.v1.Routers
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Router} [response] Router
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Routers
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRouterRequest} request GetRouterRequest message or plain object
                         * @param {google.cloud.compute.v1.Routers.GetCallback} callback Node-style callback called with the error, if any, and Router
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Routers.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRouterRequest, $root.google.cloud.compute.v1.Router, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Routers
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRouterRequest} request GetRouterRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Router>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Routers|getNatMappingInfo}.
                         * @memberof google.cloud.compute.v1.Routers
                         * @typedef GetNatMappingInfoCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.VmEndpointNatMappingsList} [response] VmEndpointNatMappingsList
                         */
    
                        /**
                         * Calls GetNatMappingInfo.
                         * @function getNatMappingInfo
                         * @memberof google.cloud.compute.v1.Routers
                         * @instance
                         * @param {google.cloud.compute.v1.IGetNatMappingInfoRoutersRequest} request GetNatMappingInfoRoutersRequest message or plain object
                         * @param {google.cloud.compute.v1.Routers.GetNatMappingInfoCallback} callback Node-style callback called with the error, if any, and VmEndpointNatMappingsList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Routers.prototype.getNatMappingInfo = function getNatMappingInfo(request, callback) {
                            return this.rpcCall(getNatMappingInfo, $root.google.cloud.compute.v1.GetNatMappingInfoRoutersRequest, $root.google.cloud.compute.v1.VmEndpointNatMappingsList, request, callback);
                        }, "name", { value: "GetNatMappingInfo" });
    
                        /**
                         * Calls GetNatMappingInfo.
                         * @function getNatMappingInfo
                         * @memberof google.cloud.compute.v1.Routers
                         * @instance
                         * @param {google.cloud.compute.v1.IGetNatMappingInfoRoutersRequest} request GetNatMappingInfoRoutersRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.VmEndpointNatMappingsList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Routers|getRouterStatus}.
                         * @memberof google.cloud.compute.v1.Routers
                         * @typedef GetRouterStatusCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.RouterStatusResponse} [response] RouterStatusResponse
                         */
    
                        /**
                         * Calls GetRouterStatus.
                         * @function getRouterStatus
                         * @memberof google.cloud.compute.v1.Routers
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRouterStatusRouterRequest} request GetRouterStatusRouterRequest message or plain object
                         * @param {google.cloud.compute.v1.Routers.GetRouterStatusCallback} callback Node-style callback called with the error, if any, and RouterStatusResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Routers.prototype.getRouterStatus = function getRouterStatus(request, callback) {
                            return this.rpcCall(getRouterStatus, $root.google.cloud.compute.v1.GetRouterStatusRouterRequest, $root.google.cloud.compute.v1.RouterStatusResponse, request, callback);
                        }, "name", { value: "GetRouterStatus" });
    
                        /**
                         * Calls GetRouterStatus.
                         * @function getRouterStatus
                         * @memberof google.cloud.compute.v1.Routers
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRouterStatusRouterRequest} request GetRouterStatusRouterRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.RouterStatusResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Routers|insert}.
                         * @memberof google.cloud.compute.v1.Routers
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Routers
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRouterRequest} request InsertRouterRequest message or plain object
                         * @param {google.cloud.compute.v1.Routers.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Routers.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertRouterRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Routers
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRouterRequest} request InsertRouterRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Routers|list}.
                         * @memberof google.cloud.compute.v1.Routers
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.RouterList} [response] RouterList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Routers
                         * @instance
                         * @param {google.cloud.compute.v1.IListRoutersRequest} request ListRoutersRequest message or plain object
                         * @param {google.cloud.compute.v1.Routers.ListCallback} callback Node-style callback called with the error, if any, and RouterList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Routers.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRoutersRequest, $root.google.cloud.compute.v1.RouterList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Routers
                         * @instance
                         * @param {google.cloud.compute.v1.IListRoutersRequest} request ListRoutersRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.RouterList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Routers|patch}.
                         * @memberof google.cloud.compute.v1.Routers
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.Routers
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRouterRequest} request PatchRouterRequest message or plain object
                         * @param {google.cloud.compute.v1.Routers.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Routers.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchRouterRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.Routers
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRouterRequest} request PatchRouterRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Routers|preview}.
                         * @memberof google.cloud.compute.v1.Routers
                         * @typedef PreviewCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.RoutersPreviewResponse} [response] RoutersPreviewResponse
                         */
    
                        /**
                         * Calls Preview.
                         * @function preview
                         * @memberof google.cloud.compute.v1.Routers
                         * @instance
                         * @param {google.cloud.compute.v1.IPreviewRouterRequest} request PreviewRouterRequest message or plain object
                         * @param {google.cloud.compute.v1.Routers.PreviewCallback} callback Node-style callback called with the error, if any, and RoutersPreviewResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Routers.prototype.preview = function preview(request, callback) {
                            return this.rpcCall(preview, $root.google.cloud.compute.v1.PreviewRouterRequest, $root.google.cloud.compute.v1.RoutersPreviewResponse, request, callback);
                        }, "name", { value: "Preview" });
    
                        /**
                         * Calls Preview.
                         * @function preview
                         * @memberof google.cloud.compute.v1.Routers
                         * @instance
                         * @param {google.cloud.compute.v1.IPreviewRouterRequest} request PreviewRouterRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.RoutersPreviewResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Routers|update}.
                         * @memberof google.cloud.compute.v1.Routers
                         * @typedef UpdateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.Routers
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateRouterRequest} request UpdateRouterRequest message or plain object
                         * @param {google.cloud.compute.v1.Routers.UpdateCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Routers.prototype.update = function update(request, callback) {
                            return this.rpcCall(update, $root.google.cloud.compute.v1.UpdateRouterRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Update" });
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.Routers
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateRouterRequest} request UpdateRouterRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return Routers;
                    })();
    
                    v1.Routes = (function() {
    
                        /**
                         * Constructs a new Routes service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Routes
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function Routes(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (Routes.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = Routes;
    
                        /**
                         * Creates new Routes service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.Routes
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {Routes} RPC service. Useful where requests and/or responses are streamed.
                         */
                        Routes.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Routes|delete_}.
                         * @memberof google.cloud.compute.v1.Routes
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Routes
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRouteRequest} request DeleteRouteRequest message or plain object
                         * @param {google.cloud.compute.v1.Routes.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Routes.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteRouteRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Routes
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteRouteRequest} request DeleteRouteRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Routes|get}.
                         * @memberof google.cloud.compute.v1.Routes
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Route} [response] Route
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Routes
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRouteRequest} request GetRouteRequest message or plain object
                         * @param {google.cloud.compute.v1.Routes.GetCallback} callback Node-style callback called with the error, if any, and Route
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Routes.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetRouteRequest, $root.google.cloud.compute.v1.Route, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Routes
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRouteRequest} request GetRouteRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Route>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Routes|insert}.
                         * @memberof google.cloud.compute.v1.Routes
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Routes
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRouteRequest} request InsertRouteRequest message or plain object
                         * @param {google.cloud.compute.v1.Routes.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Routes.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertRouteRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Routes
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertRouteRequest} request InsertRouteRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Routes|list}.
                         * @memberof google.cloud.compute.v1.Routes
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.RouteList} [response] RouteList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Routes
                         * @instance
                         * @param {google.cloud.compute.v1.IListRoutesRequest} request ListRoutesRequest message or plain object
                         * @param {google.cloud.compute.v1.Routes.ListCallback} callback Node-style callback called with the error, if any, and RouteList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Routes.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListRoutesRequest, $root.google.cloud.compute.v1.RouteList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Routes
                         * @instance
                         * @param {google.cloud.compute.v1.IListRoutesRequest} request ListRoutesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.RouteList>} Promise
                         * @variation 2
                         */
    
                        return Routes;
                    })();
    
                    v1.SecurityPolicies = (function() {
    
                        /**
                         * Constructs a new SecurityPolicies service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SecurityPolicies
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function SecurityPolicies(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (SecurityPolicies.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = SecurityPolicies;
    
                        /**
                         * Creates new SecurityPolicies service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {SecurityPolicies} RPC service. Useful where requests and/or responses are streamed.
                         */
                        SecurityPolicies.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SecurityPolicies|addRule}.
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @typedef AddRuleCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AddRule.
                         * @function addRule
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IAddRuleSecurityPolicyRequest} request AddRuleSecurityPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.SecurityPolicies.AddRuleCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SecurityPolicies.prototype.addRule = function addRule(request, callback) {
                            return this.rpcCall(addRule, $root.google.cloud.compute.v1.AddRuleSecurityPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AddRule" });
    
                        /**
                         * Calls AddRule.
                         * @function addRule
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IAddRuleSecurityPolicyRequest} request AddRuleSecurityPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SecurityPolicies|aggregatedList}.
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SecurityPoliciesAggregatedList} [response] SecurityPoliciesAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListSecurityPoliciesRequest} request AggregatedListSecurityPoliciesRequest message or plain object
                         * @param {google.cloud.compute.v1.SecurityPolicies.AggregatedListCallback} callback Node-style callback called with the error, if any, and SecurityPoliciesAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SecurityPolicies.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListSecurityPoliciesRequest, $root.google.cloud.compute.v1.SecurityPoliciesAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListSecurityPoliciesRequest} request AggregatedListSecurityPoliciesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SecurityPoliciesAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SecurityPolicies|delete_}.
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteSecurityPolicyRequest} request DeleteSecurityPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.SecurityPolicies.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SecurityPolicies.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteSecurityPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteSecurityPolicyRequest} request DeleteSecurityPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SecurityPolicies|get}.
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SecurityPolicy} [response] SecurityPolicy
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetSecurityPolicyRequest} request GetSecurityPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.SecurityPolicies.GetCallback} callback Node-style callback called with the error, if any, and SecurityPolicy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SecurityPolicies.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetSecurityPolicyRequest, $root.google.cloud.compute.v1.SecurityPolicy, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetSecurityPolicyRequest} request GetSecurityPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SecurityPolicy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SecurityPolicies|getRule}.
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @typedef GetRuleCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SecurityPolicyRule} [response] SecurityPolicyRule
                         */
    
                        /**
                         * Calls GetRule.
                         * @function getRule
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRuleSecurityPolicyRequest} request GetRuleSecurityPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.SecurityPolicies.GetRuleCallback} callback Node-style callback called with the error, if any, and SecurityPolicyRule
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SecurityPolicies.prototype.getRule = function getRule(request, callback) {
                            return this.rpcCall(getRule, $root.google.cloud.compute.v1.GetRuleSecurityPolicyRequest, $root.google.cloud.compute.v1.SecurityPolicyRule, request, callback);
                        }, "name", { value: "GetRule" });
    
                        /**
                         * Calls GetRule.
                         * @function getRule
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetRuleSecurityPolicyRequest} request GetRuleSecurityPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SecurityPolicyRule>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SecurityPolicies|insert}.
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertSecurityPolicyRequest} request InsertSecurityPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.SecurityPolicies.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SecurityPolicies.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertSecurityPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertSecurityPolicyRequest} request InsertSecurityPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SecurityPolicies|list}.
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SecurityPolicyList} [response] SecurityPolicyList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListSecurityPoliciesRequest} request ListSecurityPoliciesRequest message or plain object
                         * @param {google.cloud.compute.v1.SecurityPolicies.ListCallback} callback Node-style callback called with the error, if any, and SecurityPolicyList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SecurityPolicies.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListSecurityPoliciesRequest, $root.google.cloud.compute.v1.SecurityPolicyList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListSecurityPoliciesRequest} request ListSecurityPoliciesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SecurityPolicyList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SecurityPolicies|listPreconfiguredExpressionSets}.
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @typedef ListPreconfiguredExpressionSetsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse} [response] SecurityPoliciesListPreconfiguredExpressionSetsResponse
                         */
    
                        /**
                         * Calls ListPreconfiguredExpressionSets.
                         * @function listPreconfiguredExpressionSets
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListPreconfiguredExpressionSetsSecurityPoliciesRequest} request ListPreconfiguredExpressionSetsSecurityPoliciesRequest message or plain object
                         * @param {google.cloud.compute.v1.SecurityPolicies.ListPreconfiguredExpressionSetsCallback} callback Node-style callback called with the error, if any, and SecurityPoliciesListPreconfiguredExpressionSetsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SecurityPolicies.prototype.listPreconfiguredExpressionSets = function listPreconfiguredExpressionSets(request, callback) {
                            return this.rpcCall(listPreconfiguredExpressionSets, $root.google.cloud.compute.v1.ListPreconfiguredExpressionSetsSecurityPoliciesRequest, $root.google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse, request, callback);
                        }, "name", { value: "ListPreconfiguredExpressionSets" });
    
                        /**
                         * Calls ListPreconfiguredExpressionSets.
                         * @function listPreconfiguredExpressionSets
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListPreconfiguredExpressionSetsSecurityPoliciesRequest} request ListPreconfiguredExpressionSetsSecurityPoliciesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SecurityPoliciesListPreconfiguredExpressionSetsResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SecurityPolicies|patch}.
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchSecurityPolicyRequest} request PatchSecurityPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.SecurityPolicies.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SecurityPolicies.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchSecurityPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchSecurityPolicyRequest} request PatchSecurityPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SecurityPolicies|patchRule}.
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @typedef PatchRuleCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls PatchRule.
                         * @function patchRule
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRuleSecurityPolicyRequest} request PatchRuleSecurityPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.SecurityPolicies.PatchRuleCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SecurityPolicies.prototype.patchRule = function patchRule(request, callback) {
                            return this.rpcCall(patchRule, $root.google.cloud.compute.v1.PatchRuleSecurityPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "PatchRule" });
    
                        /**
                         * Calls PatchRule.
                         * @function patchRule
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchRuleSecurityPolicyRequest} request PatchRuleSecurityPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SecurityPolicies|removeRule}.
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @typedef RemoveRuleCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls RemoveRule.
                         * @function removeRule
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveRuleSecurityPolicyRequest} request RemoveRuleSecurityPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.SecurityPolicies.RemoveRuleCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SecurityPolicies.prototype.removeRule = function removeRule(request, callback) {
                            return this.rpcCall(removeRule, $root.google.cloud.compute.v1.RemoveRuleSecurityPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "RemoveRule" });
    
                        /**
                         * Calls RemoveRule.
                         * @function removeRule
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveRuleSecurityPolicyRequest} request RemoveRuleSecurityPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SecurityPolicies|setLabels}.
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @typedef SetLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsSecurityPolicyRequest} request SetLabelsSecurityPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.SecurityPolicies.SetLabelsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SecurityPolicies.prototype.setLabels = function setLabels(request, callback) {
                            return this.rpcCall(setLabels, $root.google.cloud.compute.v1.SetLabelsSecurityPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetLabels" });
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.SecurityPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsSecurityPolicyRequest} request SetLabelsSecurityPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return SecurityPolicies;
                    })();
    
                    v1.ServiceAttachments = (function() {
    
                        /**
                         * Constructs a new ServiceAttachments service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ServiceAttachments
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function ServiceAttachments(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (ServiceAttachments.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = ServiceAttachments;
    
                        /**
                         * Creates new ServiceAttachments service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {ServiceAttachments} RPC service. Useful where requests and/or responses are streamed.
                         */
                        ServiceAttachments.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ServiceAttachments|aggregatedList}.
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ServiceAttachmentAggregatedList} [response] ServiceAttachmentAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListServiceAttachmentsRequest} request AggregatedListServiceAttachmentsRequest message or plain object
                         * @param {google.cloud.compute.v1.ServiceAttachments.AggregatedListCallback} callback Node-style callback called with the error, if any, and ServiceAttachmentAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ServiceAttachments.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListServiceAttachmentsRequest, $root.google.cloud.compute.v1.ServiceAttachmentAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListServiceAttachmentsRequest} request AggregatedListServiceAttachmentsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ServiceAttachmentAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ServiceAttachments|delete_}.
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteServiceAttachmentRequest} request DeleteServiceAttachmentRequest message or plain object
                         * @param {google.cloud.compute.v1.ServiceAttachments.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ServiceAttachments.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteServiceAttachmentRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteServiceAttachmentRequest} request DeleteServiceAttachmentRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ServiceAttachments|get}.
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ServiceAttachment} [response] ServiceAttachment
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IGetServiceAttachmentRequest} request GetServiceAttachmentRequest message or plain object
                         * @param {google.cloud.compute.v1.ServiceAttachments.GetCallback} callback Node-style callback called with the error, if any, and ServiceAttachment
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ServiceAttachments.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetServiceAttachmentRequest, $root.google.cloud.compute.v1.ServiceAttachment, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IGetServiceAttachmentRequest} request GetServiceAttachmentRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ServiceAttachment>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ServiceAttachments|getIamPolicy}.
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @typedef GetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyServiceAttachmentRequest} request GetIamPolicyServiceAttachmentRequest message or plain object
                         * @param {google.cloud.compute.v1.ServiceAttachments.GetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ServiceAttachments.prototype.getIamPolicy = function getIamPolicy(request, callback) {
                            return this.rpcCall(getIamPolicy, $root.google.cloud.compute.v1.GetIamPolicyServiceAttachmentRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "GetIamPolicy" });
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicyServiceAttachmentRequest} request GetIamPolicyServiceAttachmentRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ServiceAttachments|insert}.
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertServiceAttachmentRequest} request InsertServiceAttachmentRequest message or plain object
                         * @param {google.cloud.compute.v1.ServiceAttachments.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ServiceAttachments.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertServiceAttachmentRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertServiceAttachmentRequest} request InsertServiceAttachmentRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ServiceAttachments|list}.
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ServiceAttachmentList} [response] ServiceAttachmentList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IListServiceAttachmentsRequest} request ListServiceAttachmentsRequest message or plain object
                         * @param {google.cloud.compute.v1.ServiceAttachments.ListCallback} callback Node-style callback called with the error, if any, and ServiceAttachmentList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ServiceAttachments.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListServiceAttachmentsRequest, $root.google.cloud.compute.v1.ServiceAttachmentList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IListServiceAttachmentsRequest} request ListServiceAttachmentsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ServiceAttachmentList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ServiceAttachments|patch}.
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchServiceAttachmentRequest} request PatchServiceAttachmentRequest message or plain object
                         * @param {google.cloud.compute.v1.ServiceAttachments.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ServiceAttachments.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchServiceAttachmentRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchServiceAttachmentRequest} request PatchServiceAttachmentRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ServiceAttachments|setIamPolicy}.
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @typedef SetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyServiceAttachmentRequest} request SetIamPolicyServiceAttachmentRequest message or plain object
                         * @param {google.cloud.compute.v1.ServiceAttachments.SetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ServiceAttachments.prototype.setIamPolicy = function setIamPolicy(request, callback) {
                            return this.rpcCall(setIamPolicy, $root.google.cloud.compute.v1.SetIamPolicyServiceAttachmentRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "SetIamPolicy" });
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicyServiceAttachmentRequest} request SetIamPolicyServiceAttachmentRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ServiceAttachments|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsServiceAttachmentRequest} request TestIamPermissionsServiceAttachmentRequest message or plain object
                         * @param {google.cloud.compute.v1.ServiceAttachments.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ServiceAttachments.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsServiceAttachmentRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.ServiceAttachments
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsServiceAttachmentRequest} request TestIamPermissionsServiceAttachmentRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        return ServiceAttachments;
                    })();
    
                    v1.Snapshots = (function() {
    
                        /**
                         * Constructs a new Snapshots service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Snapshots
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function Snapshots(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (Snapshots.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = Snapshots;
    
                        /**
                         * Creates new Snapshots service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {Snapshots} RPC service. Useful where requests and/or responses are streamed.
                         */
                        Snapshots.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Snapshots|delete_}.
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteSnapshotRequest} request DeleteSnapshotRequest message or plain object
                         * @param {google.cloud.compute.v1.Snapshots.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Snapshots.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteSnapshotRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteSnapshotRequest} request DeleteSnapshotRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Snapshots|get}.
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Snapshot} [response] Snapshot
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @instance
                         * @param {google.cloud.compute.v1.IGetSnapshotRequest} request GetSnapshotRequest message or plain object
                         * @param {google.cloud.compute.v1.Snapshots.GetCallback} callback Node-style callback called with the error, if any, and Snapshot
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Snapshots.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetSnapshotRequest, $root.google.cloud.compute.v1.Snapshot, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @instance
                         * @param {google.cloud.compute.v1.IGetSnapshotRequest} request GetSnapshotRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Snapshot>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Snapshots|getIamPolicy}.
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @typedef GetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicySnapshotRequest} request GetIamPolicySnapshotRequest message or plain object
                         * @param {google.cloud.compute.v1.Snapshots.GetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Snapshots.prototype.getIamPolicy = function getIamPolicy(request, callback) {
                            return this.rpcCall(getIamPolicy, $root.google.cloud.compute.v1.GetIamPolicySnapshotRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "GetIamPolicy" });
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicySnapshotRequest} request GetIamPolicySnapshotRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Snapshots|insert}.
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertSnapshotRequest} request InsertSnapshotRequest message or plain object
                         * @param {google.cloud.compute.v1.Snapshots.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Snapshots.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertSnapshotRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertSnapshotRequest} request InsertSnapshotRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Snapshots|list}.
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SnapshotList} [response] SnapshotList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @instance
                         * @param {google.cloud.compute.v1.IListSnapshotsRequest} request ListSnapshotsRequest message or plain object
                         * @param {google.cloud.compute.v1.Snapshots.ListCallback} callback Node-style callback called with the error, if any, and SnapshotList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Snapshots.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListSnapshotsRequest, $root.google.cloud.compute.v1.SnapshotList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @instance
                         * @param {google.cloud.compute.v1.IListSnapshotsRequest} request ListSnapshotsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SnapshotList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Snapshots|setIamPolicy}.
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @typedef SetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicySnapshotRequest} request SetIamPolicySnapshotRequest message or plain object
                         * @param {google.cloud.compute.v1.Snapshots.SetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Snapshots.prototype.setIamPolicy = function setIamPolicy(request, callback) {
                            return this.rpcCall(setIamPolicy, $root.google.cloud.compute.v1.SetIamPolicySnapshotRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "SetIamPolicy" });
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicySnapshotRequest} request SetIamPolicySnapshotRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Snapshots|setLabels}.
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @typedef SetLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsSnapshotRequest} request SetLabelsSnapshotRequest message or plain object
                         * @param {google.cloud.compute.v1.Snapshots.SetLabelsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Snapshots.prototype.setLabels = function setLabels(request, callback) {
                            return this.rpcCall(setLabels, $root.google.cloud.compute.v1.SetLabelsSnapshotRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetLabels" });
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsSnapshotRequest} request SetLabelsSnapshotRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Snapshots|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsSnapshotRequest} request TestIamPermissionsSnapshotRequest message or plain object
                         * @param {google.cloud.compute.v1.Snapshots.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Snapshots.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsSnapshotRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.Snapshots
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsSnapshotRequest} request TestIamPermissionsSnapshotRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        return Snapshots;
                    })();
    
                    v1.SslCertificates = (function() {
    
                        /**
                         * Constructs a new SslCertificates service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SslCertificates
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function SslCertificates(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (SslCertificates.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = SslCertificates;
    
                        /**
                         * Creates new SslCertificates service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.SslCertificates
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {SslCertificates} RPC service. Useful where requests and/or responses are streamed.
                         */
                        SslCertificates.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SslCertificates|aggregatedList}.
                         * @memberof google.cloud.compute.v1.SslCertificates
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SslCertificateAggregatedList} [response] SslCertificateAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.SslCertificates
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListSslCertificatesRequest} request AggregatedListSslCertificatesRequest message or plain object
                         * @param {google.cloud.compute.v1.SslCertificates.AggregatedListCallback} callback Node-style callback called with the error, if any, and SslCertificateAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SslCertificates.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListSslCertificatesRequest, $root.google.cloud.compute.v1.SslCertificateAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.SslCertificates
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListSslCertificatesRequest} request AggregatedListSslCertificatesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SslCertificateAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SslCertificates|delete_}.
                         * @memberof google.cloud.compute.v1.SslCertificates
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.SslCertificates
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteSslCertificateRequest} request DeleteSslCertificateRequest message or plain object
                         * @param {google.cloud.compute.v1.SslCertificates.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SslCertificates.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteSslCertificateRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.SslCertificates
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteSslCertificateRequest} request DeleteSslCertificateRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SslCertificates|get}.
                         * @memberof google.cloud.compute.v1.SslCertificates
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SslCertificate} [response] SslCertificate
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.SslCertificates
                         * @instance
                         * @param {google.cloud.compute.v1.IGetSslCertificateRequest} request GetSslCertificateRequest message or plain object
                         * @param {google.cloud.compute.v1.SslCertificates.GetCallback} callback Node-style callback called with the error, if any, and SslCertificate
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SslCertificates.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetSslCertificateRequest, $root.google.cloud.compute.v1.SslCertificate, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.SslCertificates
                         * @instance
                         * @param {google.cloud.compute.v1.IGetSslCertificateRequest} request GetSslCertificateRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SslCertificate>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SslCertificates|insert}.
                         * @memberof google.cloud.compute.v1.SslCertificates
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.SslCertificates
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertSslCertificateRequest} request InsertSslCertificateRequest message or plain object
                         * @param {google.cloud.compute.v1.SslCertificates.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SslCertificates.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertSslCertificateRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.SslCertificates
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertSslCertificateRequest} request InsertSslCertificateRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SslCertificates|list}.
                         * @memberof google.cloud.compute.v1.SslCertificates
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SslCertificateList} [response] SslCertificateList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.SslCertificates
                         * @instance
                         * @param {google.cloud.compute.v1.IListSslCertificatesRequest} request ListSslCertificatesRequest message or plain object
                         * @param {google.cloud.compute.v1.SslCertificates.ListCallback} callback Node-style callback called with the error, if any, and SslCertificateList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SslCertificates.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListSslCertificatesRequest, $root.google.cloud.compute.v1.SslCertificateList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.SslCertificates
                         * @instance
                         * @param {google.cloud.compute.v1.IListSslCertificatesRequest} request ListSslCertificatesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SslCertificateList>} Promise
                         * @variation 2
                         */
    
                        return SslCertificates;
                    })();
    
                    v1.SslPolicies = (function() {
    
                        /**
                         * Constructs a new SslPolicies service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a SslPolicies
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function SslPolicies(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (SslPolicies.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = SslPolicies;
    
                        /**
                         * Creates new SslPolicies service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {SslPolicies} RPC service. Useful where requests and/or responses are streamed.
                         */
                        SslPolicies.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SslPolicies|aggregatedList}.
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SslPoliciesAggregatedList} [response] SslPoliciesAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListSslPoliciesRequest} request AggregatedListSslPoliciesRequest message or plain object
                         * @param {google.cloud.compute.v1.SslPolicies.AggregatedListCallback} callback Node-style callback called with the error, if any, and SslPoliciesAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SslPolicies.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListSslPoliciesRequest, $root.google.cloud.compute.v1.SslPoliciesAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListSslPoliciesRequest} request AggregatedListSslPoliciesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SslPoliciesAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SslPolicies|delete_}.
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteSslPolicyRequest} request DeleteSslPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.SslPolicies.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SslPolicies.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteSslPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteSslPolicyRequest} request DeleteSslPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SslPolicies|get}.
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SslPolicy} [response] SslPolicy
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetSslPolicyRequest} request GetSslPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.SslPolicies.GetCallback} callback Node-style callback called with the error, if any, and SslPolicy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SslPolicies.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetSslPolicyRequest, $root.google.cloud.compute.v1.SslPolicy, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetSslPolicyRequest} request GetSslPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SslPolicy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SslPolicies|insert}.
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertSslPolicyRequest} request InsertSslPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.SslPolicies.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SslPolicies.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertSslPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertSslPolicyRequest} request InsertSslPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SslPolicies|list}.
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SslPoliciesList} [response] SslPoliciesList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListSslPoliciesRequest} request ListSslPoliciesRequest message or plain object
                         * @param {google.cloud.compute.v1.SslPolicies.ListCallback} callback Node-style callback called with the error, if any, and SslPoliciesList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SslPolicies.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListSslPoliciesRequest, $root.google.cloud.compute.v1.SslPoliciesList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListSslPoliciesRequest} request ListSslPoliciesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SslPoliciesList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SslPolicies|listAvailableFeatures}.
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @typedef ListAvailableFeaturesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse} [response] SslPoliciesListAvailableFeaturesResponse
                         */
    
                        /**
                         * Calls ListAvailableFeatures.
                         * @function listAvailableFeatures
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListAvailableFeaturesSslPoliciesRequest} request ListAvailableFeaturesSslPoliciesRequest message or plain object
                         * @param {google.cloud.compute.v1.SslPolicies.ListAvailableFeaturesCallback} callback Node-style callback called with the error, if any, and SslPoliciesListAvailableFeaturesResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SslPolicies.prototype.listAvailableFeatures = function listAvailableFeatures(request, callback) {
                            return this.rpcCall(listAvailableFeatures, $root.google.cloud.compute.v1.ListAvailableFeaturesSslPoliciesRequest, $root.google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse, request, callback);
                        }, "name", { value: "ListAvailableFeatures" });
    
                        /**
                         * Calls ListAvailableFeatures.
                         * @function listAvailableFeatures
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IListAvailableFeaturesSslPoliciesRequest} request ListAvailableFeaturesSslPoliciesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SslPoliciesListAvailableFeaturesResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.SslPolicies|patch}.
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchSslPolicyRequest} request PatchSslPolicyRequest message or plain object
                         * @param {google.cloud.compute.v1.SslPolicies.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(SslPolicies.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchSslPolicyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.SslPolicies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchSslPolicyRequest} request PatchSslPolicyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return SslPolicies;
                    })();
    
                    v1.Subnetworks = (function() {
    
                        /**
                         * Constructs a new Subnetworks service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Subnetworks
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function Subnetworks(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (Subnetworks.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = Subnetworks;
    
                        /**
                         * Creates new Subnetworks service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {Subnetworks} RPC service. Useful where requests and/or responses are streamed.
                         */
                        Subnetworks.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Subnetworks|aggregatedList}.
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SubnetworkAggregatedList} [response] SubnetworkAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListSubnetworksRequest} request AggregatedListSubnetworksRequest message or plain object
                         * @param {google.cloud.compute.v1.Subnetworks.AggregatedListCallback} callback Node-style callback called with the error, if any, and SubnetworkAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Subnetworks.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListSubnetworksRequest, $root.google.cloud.compute.v1.SubnetworkAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListSubnetworksRequest} request AggregatedListSubnetworksRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SubnetworkAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Subnetworks|delete_}.
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteSubnetworkRequest} request DeleteSubnetworkRequest message or plain object
                         * @param {google.cloud.compute.v1.Subnetworks.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Subnetworks.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteSubnetworkRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteSubnetworkRequest} request DeleteSubnetworkRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Subnetworks|expandIpCidrRange}.
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @typedef ExpandIpCidrRangeCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls ExpandIpCidrRange.
                         * @function expandIpCidrRange
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.IExpandIpCidrRangeSubnetworkRequest} request ExpandIpCidrRangeSubnetworkRequest message or plain object
                         * @param {google.cloud.compute.v1.Subnetworks.ExpandIpCidrRangeCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Subnetworks.prototype.expandIpCidrRange = function expandIpCidrRange(request, callback) {
                            return this.rpcCall(expandIpCidrRange, $root.google.cloud.compute.v1.ExpandIpCidrRangeSubnetworkRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "ExpandIpCidrRange" });
    
                        /**
                         * Calls ExpandIpCidrRange.
                         * @function expandIpCidrRange
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.IExpandIpCidrRangeSubnetworkRequest} request ExpandIpCidrRangeSubnetworkRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Subnetworks|get}.
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Subnetwork} [response] Subnetwork
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.IGetSubnetworkRequest} request GetSubnetworkRequest message or plain object
                         * @param {google.cloud.compute.v1.Subnetworks.GetCallback} callback Node-style callback called with the error, if any, and Subnetwork
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Subnetworks.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetSubnetworkRequest, $root.google.cloud.compute.v1.Subnetwork, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.IGetSubnetworkRequest} request GetSubnetworkRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Subnetwork>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Subnetworks|getIamPolicy}.
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @typedef GetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicySubnetworkRequest} request GetIamPolicySubnetworkRequest message or plain object
                         * @param {google.cloud.compute.v1.Subnetworks.GetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Subnetworks.prototype.getIamPolicy = function getIamPolicy(request, callback) {
                            return this.rpcCall(getIamPolicy, $root.google.cloud.compute.v1.GetIamPolicySubnetworkRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "GetIamPolicy" });
    
                        /**
                         * Calls GetIamPolicy.
                         * @function getIamPolicy
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.IGetIamPolicySubnetworkRequest} request GetIamPolicySubnetworkRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Subnetworks|insert}.
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertSubnetworkRequest} request InsertSubnetworkRequest message or plain object
                         * @param {google.cloud.compute.v1.Subnetworks.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Subnetworks.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertSubnetworkRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertSubnetworkRequest} request InsertSubnetworkRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Subnetworks|list}.
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.SubnetworkList} [response] SubnetworkList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.IListSubnetworksRequest} request ListSubnetworksRequest message or plain object
                         * @param {google.cloud.compute.v1.Subnetworks.ListCallback} callback Node-style callback called with the error, if any, and SubnetworkList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Subnetworks.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListSubnetworksRequest, $root.google.cloud.compute.v1.SubnetworkList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.IListSubnetworksRequest} request ListSubnetworksRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.SubnetworkList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Subnetworks|listUsable}.
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @typedef ListUsableCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.UsableSubnetworksAggregatedList} [response] UsableSubnetworksAggregatedList
                         */
    
                        /**
                         * Calls ListUsable.
                         * @function listUsable
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.IListUsableSubnetworksRequest} request ListUsableSubnetworksRequest message or plain object
                         * @param {google.cloud.compute.v1.Subnetworks.ListUsableCallback} callback Node-style callback called with the error, if any, and UsableSubnetworksAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Subnetworks.prototype.listUsable = function listUsable(request, callback) {
                            return this.rpcCall(listUsable, $root.google.cloud.compute.v1.ListUsableSubnetworksRequest, $root.google.cloud.compute.v1.UsableSubnetworksAggregatedList, request, callback);
                        }, "name", { value: "ListUsable" });
    
                        /**
                         * Calls ListUsable.
                         * @function listUsable
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.IListUsableSubnetworksRequest} request ListUsableSubnetworksRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.UsableSubnetworksAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Subnetworks|patch}.
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchSubnetworkRequest} request PatchSubnetworkRequest message or plain object
                         * @param {google.cloud.compute.v1.Subnetworks.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Subnetworks.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchSubnetworkRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchSubnetworkRequest} request PatchSubnetworkRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Subnetworks|setIamPolicy}.
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @typedef SetIamPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Policy} [response] Policy
                         */
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicySubnetworkRequest} request SetIamPolicySubnetworkRequest message or plain object
                         * @param {google.cloud.compute.v1.Subnetworks.SetIamPolicyCallback} callback Node-style callback called with the error, if any, and Policy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Subnetworks.prototype.setIamPolicy = function setIamPolicy(request, callback) {
                            return this.rpcCall(setIamPolicy, $root.google.cloud.compute.v1.SetIamPolicySubnetworkRequest, $root.google.cloud.compute.v1.Policy, request, callback);
                        }, "name", { value: "SetIamPolicy" });
    
                        /**
                         * Calls SetIamPolicy.
                         * @function setIamPolicy
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.ISetIamPolicySubnetworkRequest} request SetIamPolicySubnetworkRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Policy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Subnetworks|setPrivateIpGoogleAccess}.
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @typedef SetPrivateIpGoogleAccessCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetPrivateIpGoogleAccess.
                         * @function setPrivateIpGoogleAccess
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.ISetPrivateIpGoogleAccessSubnetworkRequest} request SetPrivateIpGoogleAccessSubnetworkRequest message or plain object
                         * @param {google.cloud.compute.v1.Subnetworks.SetPrivateIpGoogleAccessCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Subnetworks.prototype.setPrivateIpGoogleAccess = function setPrivateIpGoogleAccess(request, callback) {
                            return this.rpcCall(setPrivateIpGoogleAccess, $root.google.cloud.compute.v1.SetPrivateIpGoogleAccessSubnetworkRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetPrivateIpGoogleAccess" });
    
                        /**
                         * Calls SetPrivateIpGoogleAccess.
                         * @function setPrivateIpGoogleAccess
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.ISetPrivateIpGoogleAccessSubnetworkRequest} request SetPrivateIpGoogleAccessSubnetworkRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Subnetworks|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsSubnetworkRequest} request TestIamPermissionsSubnetworkRequest message or plain object
                         * @param {google.cloud.compute.v1.Subnetworks.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Subnetworks.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsSubnetworkRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.Subnetworks
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsSubnetworkRequest} request TestIamPermissionsSubnetworkRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        return Subnetworks;
                    })();
    
                    v1.TargetGrpcProxies = (function() {
    
                        /**
                         * Constructs a new TargetGrpcProxies service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetGrpcProxies
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function TargetGrpcProxies(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (TargetGrpcProxies.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = TargetGrpcProxies;
    
                        /**
                         * Creates new TargetGrpcProxies service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetGrpcProxies
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {TargetGrpcProxies} RPC service. Useful where requests and/or responses are streamed.
                         */
                        TargetGrpcProxies.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetGrpcProxies|delete_}.
                         * @memberof google.cloud.compute.v1.TargetGrpcProxies
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.TargetGrpcProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteTargetGrpcProxyRequest} request DeleteTargetGrpcProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetGrpcProxies.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetGrpcProxies.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteTargetGrpcProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.TargetGrpcProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteTargetGrpcProxyRequest} request DeleteTargetGrpcProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetGrpcProxies|get}.
                         * @memberof google.cloud.compute.v1.TargetGrpcProxies
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetGrpcProxy} [response] TargetGrpcProxy
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.TargetGrpcProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetTargetGrpcProxyRequest} request GetTargetGrpcProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetGrpcProxies.GetCallback} callback Node-style callback called with the error, if any, and TargetGrpcProxy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetGrpcProxies.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetTargetGrpcProxyRequest, $root.google.cloud.compute.v1.TargetGrpcProxy, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.TargetGrpcProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetTargetGrpcProxyRequest} request GetTargetGrpcProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetGrpcProxy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetGrpcProxies|insert}.
                         * @memberof google.cloud.compute.v1.TargetGrpcProxies
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.TargetGrpcProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertTargetGrpcProxyRequest} request InsertTargetGrpcProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetGrpcProxies.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetGrpcProxies.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertTargetGrpcProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.TargetGrpcProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertTargetGrpcProxyRequest} request InsertTargetGrpcProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetGrpcProxies|list}.
                         * @memberof google.cloud.compute.v1.TargetGrpcProxies
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetGrpcProxyList} [response] TargetGrpcProxyList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.TargetGrpcProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IListTargetGrpcProxiesRequest} request ListTargetGrpcProxiesRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetGrpcProxies.ListCallback} callback Node-style callback called with the error, if any, and TargetGrpcProxyList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetGrpcProxies.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListTargetGrpcProxiesRequest, $root.google.cloud.compute.v1.TargetGrpcProxyList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.TargetGrpcProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IListTargetGrpcProxiesRequest} request ListTargetGrpcProxiesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetGrpcProxyList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetGrpcProxies|patch}.
                         * @memberof google.cloud.compute.v1.TargetGrpcProxies
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.TargetGrpcProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchTargetGrpcProxyRequest} request PatchTargetGrpcProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetGrpcProxies.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetGrpcProxies.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchTargetGrpcProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.TargetGrpcProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchTargetGrpcProxyRequest} request PatchTargetGrpcProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return TargetGrpcProxies;
                    })();
    
                    v1.TargetHttpProxies = (function() {
    
                        /**
                         * Constructs a new TargetHttpProxies service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetHttpProxies
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function TargetHttpProxies(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (TargetHttpProxies.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = TargetHttpProxies;
    
                        /**
                         * Creates new TargetHttpProxies service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {TargetHttpProxies} RPC service. Useful where requests and/or responses are streamed.
                         */
                        TargetHttpProxies.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetHttpProxies|aggregatedList}.
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetHttpProxyAggregatedList} [response] TargetHttpProxyAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListTargetHttpProxiesRequest} request AggregatedListTargetHttpProxiesRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetHttpProxies.AggregatedListCallback} callback Node-style callback called with the error, if any, and TargetHttpProxyAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetHttpProxies.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListTargetHttpProxiesRequest, $root.google.cloud.compute.v1.TargetHttpProxyAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListTargetHttpProxiesRequest} request AggregatedListTargetHttpProxiesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetHttpProxyAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetHttpProxies|delete_}.
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteTargetHttpProxyRequest} request DeleteTargetHttpProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetHttpProxies.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetHttpProxies.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteTargetHttpProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteTargetHttpProxyRequest} request DeleteTargetHttpProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetHttpProxies|get}.
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetHttpProxy} [response] TargetHttpProxy
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetTargetHttpProxyRequest} request GetTargetHttpProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetHttpProxies.GetCallback} callback Node-style callback called with the error, if any, and TargetHttpProxy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetHttpProxies.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetTargetHttpProxyRequest, $root.google.cloud.compute.v1.TargetHttpProxy, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetTargetHttpProxyRequest} request GetTargetHttpProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetHttpProxy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetHttpProxies|insert}.
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertTargetHttpProxyRequest} request InsertTargetHttpProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetHttpProxies.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetHttpProxies.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertTargetHttpProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertTargetHttpProxyRequest} request InsertTargetHttpProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetHttpProxies|list}.
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetHttpProxyList} [response] TargetHttpProxyList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IListTargetHttpProxiesRequest} request ListTargetHttpProxiesRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetHttpProxies.ListCallback} callback Node-style callback called with the error, if any, and TargetHttpProxyList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetHttpProxies.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListTargetHttpProxiesRequest, $root.google.cloud.compute.v1.TargetHttpProxyList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IListTargetHttpProxiesRequest} request ListTargetHttpProxiesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetHttpProxyList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetHttpProxies|patch}.
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchTargetHttpProxyRequest} request PatchTargetHttpProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetHttpProxies.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetHttpProxies.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchTargetHttpProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchTargetHttpProxyRequest} request PatchTargetHttpProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetHttpProxies|setUrlMap}.
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @typedef SetUrlMapCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetUrlMap.
                         * @function setUrlMap
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetUrlMapTargetHttpProxyRequest} request SetUrlMapTargetHttpProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetHttpProxies.SetUrlMapCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetHttpProxies.prototype.setUrlMap = function setUrlMap(request, callback) {
                            return this.rpcCall(setUrlMap, $root.google.cloud.compute.v1.SetUrlMapTargetHttpProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetUrlMap" });
    
                        /**
                         * Calls SetUrlMap.
                         * @function setUrlMap
                         * @memberof google.cloud.compute.v1.TargetHttpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetUrlMapTargetHttpProxyRequest} request SetUrlMapTargetHttpProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return TargetHttpProxies;
                    })();
    
                    v1.TargetHttpsProxies = (function() {
    
                        /**
                         * Constructs a new TargetHttpsProxies service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetHttpsProxies
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function TargetHttpsProxies(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (TargetHttpsProxies.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = TargetHttpsProxies;
    
                        /**
                         * Creates new TargetHttpsProxies service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {TargetHttpsProxies} RPC service. Useful where requests and/or responses are streamed.
                         */
                        TargetHttpsProxies.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetHttpsProxies|aggregatedList}.
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetHttpsProxyAggregatedList} [response] TargetHttpsProxyAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListTargetHttpsProxiesRequest} request AggregatedListTargetHttpsProxiesRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetHttpsProxies.AggregatedListCallback} callback Node-style callback called with the error, if any, and TargetHttpsProxyAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetHttpsProxies.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListTargetHttpsProxiesRequest, $root.google.cloud.compute.v1.TargetHttpsProxyAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListTargetHttpsProxiesRequest} request AggregatedListTargetHttpsProxiesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetHttpsProxyAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetHttpsProxies|delete_}.
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteTargetHttpsProxyRequest} request DeleteTargetHttpsProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetHttpsProxies.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetHttpsProxies.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteTargetHttpsProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteTargetHttpsProxyRequest} request DeleteTargetHttpsProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetHttpsProxies|get}.
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetHttpsProxy} [response] TargetHttpsProxy
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetTargetHttpsProxyRequest} request GetTargetHttpsProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetHttpsProxies.GetCallback} callback Node-style callback called with the error, if any, and TargetHttpsProxy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetHttpsProxies.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetTargetHttpsProxyRequest, $root.google.cloud.compute.v1.TargetHttpsProxy, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetTargetHttpsProxyRequest} request GetTargetHttpsProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetHttpsProxy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetHttpsProxies|insert}.
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertTargetHttpsProxyRequest} request InsertTargetHttpsProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetHttpsProxies.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetHttpsProxies.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertTargetHttpsProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertTargetHttpsProxyRequest} request InsertTargetHttpsProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetHttpsProxies|list}.
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetHttpsProxyList} [response] TargetHttpsProxyList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IListTargetHttpsProxiesRequest} request ListTargetHttpsProxiesRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetHttpsProxies.ListCallback} callback Node-style callback called with the error, if any, and TargetHttpsProxyList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetHttpsProxies.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListTargetHttpsProxiesRequest, $root.google.cloud.compute.v1.TargetHttpsProxyList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IListTargetHttpsProxiesRequest} request ListTargetHttpsProxiesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetHttpsProxyList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetHttpsProxies|patch}.
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchTargetHttpsProxyRequest} request PatchTargetHttpsProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetHttpsProxies.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetHttpsProxies.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchTargetHttpsProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchTargetHttpsProxyRequest} request PatchTargetHttpsProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetHttpsProxies|setCertificateMap}.
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @typedef SetCertificateMapCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetCertificateMap.
                         * @function setCertificateMap
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetCertificateMapTargetHttpsProxyRequest} request SetCertificateMapTargetHttpsProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetHttpsProxies.SetCertificateMapCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetHttpsProxies.prototype.setCertificateMap = function setCertificateMap(request, callback) {
                            return this.rpcCall(setCertificateMap, $root.google.cloud.compute.v1.SetCertificateMapTargetHttpsProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetCertificateMap" });
    
                        /**
                         * Calls SetCertificateMap.
                         * @function setCertificateMap
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetCertificateMapTargetHttpsProxyRequest} request SetCertificateMapTargetHttpsProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetHttpsProxies|setQuicOverride}.
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @typedef SetQuicOverrideCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetQuicOverride.
                         * @function setQuicOverride
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetQuicOverrideTargetHttpsProxyRequest} request SetQuicOverrideTargetHttpsProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetHttpsProxies.SetQuicOverrideCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetHttpsProxies.prototype.setQuicOverride = function setQuicOverride(request, callback) {
                            return this.rpcCall(setQuicOverride, $root.google.cloud.compute.v1.SetQuicOverrideTargetHttpsProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetQuicOverride" });
    
                        /**
                         * Calls SetQuicOverride.
                         * @function setQuicOverride
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetQuicOverrideTargetHttpsProxyRequest} request SetQuicOverrideTargetHttpsProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetHttpsProxies|setSslCertificates}.
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @typedef SetSslCertificatesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetSslCertificates.
                         * @function setSslCertificates
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetSslCertificatesTargetHttpsProxyRequest} request SetSslCertificatesTargetHttpsProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetHttpsProxies.SetSslCertificatesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetHttpsProxies.prototype.setSslCertificates = function setSslCertificates(request, callback) {
                            return this.rpcCall(setSslCertificates, $root.google.cloud.compute.v1.SetSslCertificatesTargetHttpsProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetSslCertificates" });
    
                        /**
                         * Calls SetSslCertificates.
                         * @function setSslCertificates
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetSslCertificatesTargetHttpsProxyRequest} request SetSslCertificatesTargetHttpsProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetHttpsProxies|setSslPolicy}.
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @typedef SetSslPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetSslPolicy.
                         * @function setSslPolicy
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetSslPolicyTargetHttpsProxyRequest} request SetSslPolicyTargetHttpsProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetHttpsProxies.SetSslPolicyCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetHttpsProxies.prototype.setSslPolicy = function setSslPolicy(request, callback) {
                            return this.rpcCall(setSslPolicy, $root.google.cloud.compute.v1.SetSslPolicyTargetHttpsProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetSslPolicy" });
    
                        /**
                         * Calls SetSslPolicy.
                         * @function setSslPolicy
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetSslPolicyTargetHttpsProxyRequest} request SetSslPolicyTargetHttpsProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetHttpsProxies|setUrlMap}.
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @typedef SetUrlMapCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetUrlMap.
                         * @function setUrlMap
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetUrlMapTargetHttpsProxyRequest} request SetUrlMapTargetHttpsProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetHttpsProxies.SetUrlMapCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetHttpsProxies.prototype.setUrlMap = function setUrlMap(request, callback) {
                            return this.rpcCall(setUrlMap, $root.google.cloud.compute.v1.SetUrlMapTargetHttpsProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetUrlMap" });
    
                        /**
                         * Calls SetUrlMap.
                         * @function setUrlMap
                         * @memberof google.cloud.compute.v1.TargetHttpsProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetUrlMapTargetHttpsProxyRequest} request SetUrlMapTargetHttpsProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return TargetHttpsProxies;
                    })();
    
                    v1.TargetInstances = (function() {
    
                        /**
                         * Constructs a new TargetInstances service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetInstances
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function TargetInstances(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (TargetInstances.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = TargetInstances;
    
                        /**
                         * Creates new TargetInstances service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetInstances
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {TargetInstances} RPC service. Useful where requests and/or responses are streamed.
                         */
                        TargetInstances.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetInstances|aggregatedList}.
                         * @memberof google.cloud.compute.v1.TargetInstances
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetInstanceAggregatedList} [response] TargetInstanceAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.TargetInstances
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListTargetInstancesRequest} request AggregatedListTargetInstancesRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetInstances.AggregatedListCallback} callback Node-style callback called with the error, if any, and TargetInstanceAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetInstances.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListTargetInstancesRequest, $root.google.cloud.compute.v1.TargetInstanceAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.TargetInstances
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListTargetInstancesRequest} request AggregatedListTargetInstancesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetInstanceAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetInstances|delete_}.
                         * @memberof google.cloud.compute.v1.TargetInstances
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.TargetInstances
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteTargetInstanceRequest} request DeleteTargetInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetInstances.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetInstances.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteTargetInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.TargetInstances
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteTargetInstanceRequest} request DeleteTargetInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetInstances|get}.
                         * @memberof google.cloud.compute.v1.TargetInstances
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetInstance} [response] TargetInstance
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.TargetInstances
                         * @instance
                         * @param {google.cloud.compute.v1.IGetTargetInstanceRequest} request GetTargetInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetInstances.GetCallback} callback Node-style callback called with the error, if any, and TargetInstance
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetInstances.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetTargetInstanceRequest, $root.google.cloud.compute.v1.TargetInstance, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.TargetInstances
                         * @instance
                         * @param {google.cloud.compute.v1.IGetTargetInstanceRequest} request GetTargetInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetInstance>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetInstances|insert}.
                         * @memberof google.cloud.compute.v1.TargetInstances
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.TargetInstances
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertTargetInstanceRequest} request InsertTargetInstanceRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetInstances.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetInstances.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertTargetInstanceRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.TargetInstances
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertTargetInstanceRequest} request InsertTargetInstanceRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetInstances|list}.
                         * @memberof google.cloud.compute.v1.TargetInstances
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetInstanceList} [response] TargetInstanceList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.TargetInstances
                         * @instance
                         * @param {google.cloud.compute.v1.IListTargetInstancesRequest} request ListTargetInstancesRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetInstances.ListCallback} callback Node-style callback called with the error, if any, and TargetInstanceList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetInstances.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListTargetInstancesRequest, $root.google.cloud.compute.v1.TargetInstanceList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.TargetInstances
                         * @instance
                         * @param {google.cloud.compute.v1.IListTargetInstancesRequest} request ListTargetInstancesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetInstanceList>} Promise
                         * @variation 2
                         */
    
                        return TargetInstances;
                    })();
    
                    v1.TargetPools = (function() {
    
                        /**
                         * Constructs a new TargetPools service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetPools
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function TargetPools(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (TargetPools.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = TargetPools;
    
                        /**
                         * Creates new TargetPools service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {TargetPools} RPC service. Useful where requests and/or responses are streamed.
                         */
                        TargetPools.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetPools|addHealthCheck}.
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @typedef AddHealthCheckCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AddHealthCheck.
                         * @function addHealthCheck
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.IAddHealthCheckTargetPoolRequest} request AddHealthCheckTargetPoolRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetPools.AddHealthCheckCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetPools.prototype.addHealthCheck = function addHealthCheck(request, callback) {
                            return this.rpcCall(addHealthCheck, $root.google.cloud.compute.v1.AddHealthCheckTargetPoolRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AddHealthCheck" });
    
                        /**
                         * Calls AddHealthCheck.
                         * @function addHealthCheck
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.IAddHealthCheckTargetPoolRequest} request AddHealthCheckTargetPoolRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetPools|addInstance}.
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @typedef AddInstanceCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls AddInstance.
                         * @function addInstance
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.IAddInstanceTargetPoolRequest} request AddInstanceTargetPoolRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetPools.AddInstanceCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetPools.prototype.addInstance = function addInstance(request, callback) {
                            return this.rpcCall(addInstance, $root.google.cloud.compute.v1.AddInstanceTargetPoolRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "AddInstance" });
    
                        /**
                         * Calls AddInstance.
                         * @function addInstance
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.IAddInstanceTargetPoolRequest} request AddInstanceTargetPoolRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetPools|aggregatedList}.
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetPoolAggregatedList} [response] TargetPoolAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListTargetPoolsRequest} request AggregatedListTargetPoolsRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetPools.AggregatedListCallback} callback Node-style callback called with the error, if any, and TargetPoolAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetPools.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListTargetPoolsRequest, $root.google.cloud.compute.v1.TargetPoolAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListTargetPoolsRequest} request AggregatedListTargetPoolsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetPoolAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetPools|delete_}.
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteTargetPoolRequest} request DeleteTargetPoolRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetPools.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetPools.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteTargetPoolRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteTargetPoolRequest} request DeleteTargetPoolRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetPools|get}.
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetPool} [response] TargetPool
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.IGetTargetPoolRequest} request GetTargetPoolRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetPools.GetCallback} callback Node-style callback called with the error, if any, and TargetPool
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetPools.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetTargetPoolRequest, $root.google.cloud.compute.v1.TargetPool, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.IGetTargetPoolRequest} request GetTargetPoolRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetPool>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetPools|getHealth}.
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @typedef GetHealthCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetPoolInstanceHealth} [response] TargetPoolInstanceHealth
                         */
    
                        /**
                         * Calls GetHealth.
                         * @function getHealth
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.IGetHealthTargetPoolRequest} request GetHealthTargetPoolRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetPools.GetHealthCallback} callback Node-style callback called with the error, if any, and TargetPoolInstanceHealth
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetPools.prototype.getHealth = function getHealth(request, callback) {
                            return this.rpcCall(getHealth, $root.google.cloud.compute.v1.GetHealthTargetPoolRequest, $root.google.cloud.compute.v1.TargetPoolInstanceHealth, request, callback);
                        }, "name", { value: "GetHealth" });
    
                        /**
                         * Calls GetHealth.
                         * @function getHealth
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.IGetHealthTargetPoolRequest} request GetHealthTargetPoolRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetPoolInstanceHealth>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetPools|insert}.
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertTargetPoolRequest} request InsertTargetPoolRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetPools.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetPools.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertTargetPoolRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertTargetPoolRequest} request InsertTargetPoolRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetPools|list}.
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetPoolList} [response] TargetPoolList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.IListTargetPoolsRequest} request ListTargetPoolsRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetPools.ListCallback} callback Node-style callback called with the error, if any, and TargetPoolList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetPools.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListTargetPoolsRequest, $root.google.cloud.compute.v1.TargetPoolList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.IListTargetPoolsRequest} request ListTargetPoolsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetPoolList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetPools|removeHealthCheck}.
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @typedef RemoveHealthCheckCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls RemoveHealthCheck.
                         * @function removeHealthCheck
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveHealthCheckTargetPoolRequest} request RemoveHealthCheckTargetPoolRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetPools.RemoveHealthCheckCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetPools.prototype.removeHealthCheck = function removeHealthCheck(request, callback) {
                            return this.rpcCall(removeHealthCheck, $root.google.cloud.compute.v1.RemoveHealthCheckTargetPoolRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "RemoveHealthCheck" });
    
                        /**
                         * Calls RemoveHealthCheck.
                         * @function removeHealthCheck
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveHealthCheckTargetPoolRequest} request RemoveHealthCheckTargetPoolRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetPools|removeInstance}.
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @typedef RemoveInstanceCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls RemoveInstance.
                         * @function removeInstance
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveInstanceTargetPoolRequest} request RemoveInstanceTargetPoolRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetPools.RemoveInstanceCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetPools.prototype.removeInstance = function removeInstance(request, callback) {
                            return this.rpcCall(removeInstance, $root.google.cloud.compute.v1.RemoveInstanceTargetPoolRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "RemoveInstance" });
    
                        /**
                         * Calls RemoveInstance.
                         * @function removeInstance
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.IRemoveInstanceTargetPoolRequest} request RemoveInstanceTargetPoolRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetPools|setBackup}.
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @typedef SetBackupCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetBackup.
                         * @function setBackup
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.ISetBackupTargetPoolRequest} request SetBackupTargetPoolRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetPools.SetBackupCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetPools.prototype.setBackup = function setBackup(request, callback) {
                            return this.rpcCall(setBackup, $root.google.cloud.compute.v1.SetBackupTargetPoolRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetBackup" });
    
                        /**
                         * Calls SetBackup.
                         * @function setBackup
                         * @memberof google.cloud.compute.v1.TargetPools
                         * @instance
                         * @param {google.cloud.compute.v1.ISetBackupTargetPoolRequest} request SetBackupTargetPoolRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return TargetPools;
                    })();
    
                    v1.TargetSslProxies = (function() {
    
                        /**
                         * Constructs a new TargetSslProxies service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetSslProxies
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function TargetSslProxies(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (TargetSslProxies.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = TargetSslProxies;
    
                        /**
                         * Creates new TargetSslProxies service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {TargetSslProxies} RPC service. Useful where requests and/or responses are streamed.
                         */
                        TargetSslProxies.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetSslProxies|delete_}.
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteTargetSslProxyRequest} request DeleteTargetSslProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetSslProxies.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetSslProxies.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteTargetSslProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteTargetSslProxyRequest} request DeleteTargetSslProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetSslProxies|get}.
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetSslProxy} [response] TargetSslProxy
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetTargetSslProxyRequest} request GetTargetSslProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetSslProxies.GetCallback} callback Node-style callback called with the error, if any, and TargetSslProxy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetSslProxies.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetTargetSslProxyRequest, $root.google.cloud.compute.v1.TargetSslProxy, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetTargetSslProxyRequest} request GetTargetSslProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetSslProxy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetSslProxies|insert}.
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertTargetSslProxyRequest} request InsertTargetSslProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetSslProxies.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetSslProxies.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertTargetSslProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertTargetSslProxyRequest} request InsertTargetSslProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetSslProxies|list}.
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetSslProxyList} [response] TargetSslProxyList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IListTargetSslProxiesRequest} request ListTargetSslProxiesRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetSslProxies.ListCallback} callback Node-style callback called with the error, if any, and TargetSslProxyList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetSslProxies.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListTargetSslProxiesRequest, $root.google.cloud.compute.v1.TargetSslProxyList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IListTargetSslProxiesRequest} request ListTargetSslProxiesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetSslProxyList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetSslProxies|setBackendService}.
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @typedef SetBackendServiceCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetBackendService.
                         * @function setBackendService
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetBackendServiceTargetSslProxyRequest} request SetBackendServiceTargetSslProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetSslProxies.SetBackendServiceCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetSslProxies.prototype.setBackendService = function setBackendService(request, callback) {
                            return this.rpcCall(setBackendService, $root.google.cloud.compute.v1.SetBackendServiceTargetSslProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetBackendService" });
    
                        /**
                         * Calls SetBackendService.
                         * @function setBackendService
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetBackendServiceTargetSslProxyRequest} request SetBackendServiceTargetSslProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetSslProxies|setCertificateMap}.
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @typedef SetCertificateMapCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetCertificateMap.
                         * @function setCertificateMap
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetCertificateMapTargetSslProxyRequest} request SetCertificateMapTargetSslProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetSslProxies.SetCertificateMapCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetSslProxies.prototype.setCertificateMap = function setCertificateMap(request, callback) {
                            return this.rpcCall(setCertificateMap, $root.google.cloud.compute.v1.SetCertificateMapTargetSslProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetCertificateMap" });
    
                        /**
                         * Calls SetCertificateMap.
                         * @function setCertificateMap
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetCertificateMapTargetSslProxyRequest} request SetCertificateMapTargetSslProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetSslProxies|setProxyHeader}.
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @typedef SetProxyHeaderCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetProxyHeader.
                         * @function setProxyHeader
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetProxyHeaderTargetSslProxyRequest} request SetProxyHeaderTargetSslProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetSslProxies.SetProxyHeaderCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetSslProxies.prototype.setProxyHeader = function setProxyHeader(request, callback) {
                            return this.rpcCall(setProxyHeader, $root.google.cloud.compute.v1.SetProxyHeaderTargetSslProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetProxyHeader" });
    
                        /**
                         * Calls SetProxyHeader.
                         * @function setProxyHeader
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetProxyHeaderTargetSslProxyRequest} request SetProxyHeaderTargetSslProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetSslProxies|setSslCertificates}.
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @typedef SetSslCertificatesCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetSslCertificates.
                         * @function setSslCertificates
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetSslCertificatesTargetSslProxyRequest} request SetSslCertificatesTargetSslProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetSslProxies.SetSslCertificatesCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetSslProxies.prototype.setSslCertificates = function setSslCertificates(request, callback) {
                            return this.rpcCall(setSslCertificates, $root.google.cloud.compute.v1.SetSslCertificatesTargetSslProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetSslCertificates" });
    
                        /**
                         * Calls SetSslCertificates.
                         * @function setSslCertificates
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetSslCertificatesTargetSslProxyRequest} request SetSslCertificatesTargetSslProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetSslProxies|setSslPolicy}.
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @typedef SetSslPolicyCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetSslPolicy.
                         * @function setSslPolicy
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetSslPolicyTargetSslProxyRequest} request SetSslPolicyTargetSslProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetSslProxies.SetSslPolicyCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetSslProxies.prototype.setSslPolicy = function setSslPolicy(request, callback) {
                            return this.rpcCall(setSslPolicy, $root.google.cloud.compute.v1.SetSslPolicyTargetSslProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetSslPolicy" });
    
                        /**
                         * Calls SetSslPolicy.
                         * @function setSslPolicy
                         * @memberof google.cloud.compute.v1.TargetSslProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetSslPolicyTargetSslProxyRequest} request SetSslPolicyTargetSslProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return TargetSslProxies;
                    })();
    
                    v1.TargetTcpProxies = (function() {
    
                        /**
                         * Constructs a new TargetTcpProxies service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetTcpProxies
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function TargetTcpProxies(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (TargetTcpProxies.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = TargetTcpProxies;
    
                        /**
                         * Creates new TargetTcpProxies service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetTcpProxies
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {TargetTcpProxies} RPC service. Useful where requests and/or responses are streamed.
                         */
                        TargetTcpProxies.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetTcpProxies|delete_}.
                         * @memberof google.cloud.compute.v1.TargetTcpProxies
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.TargetTcpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteTargetTcpProxyRequest} request DeleteTargetTcpProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetTcpProxies.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetTcpProxies.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteTargetTcpProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.TargetTcpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteTargetTcpProxyRequest} request DeleteTargetTcpProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetTcpProxies|get}.
                         * @memberof google.cloud.compute.v1.TargetTcpProxies
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetTcpProxy} [response] TargetTcpProxy
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.TargetTcpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetTargetTcpProxyRequest} request GetTargetTcpProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetTcpProxies.GetCallback} callback Node-style callback called with the error, if any, and TargetTcpProxy
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetTcpProxies.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetTargetTcpProxyRequest, $root.google.cloud.compute.v1.TargetTcpProxy, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.TargetTcpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IGetTargetTcpProxyRequest} request GetTargetTcpProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetTcpProxy>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetTcpProxies|insert}.
                         * @memberof google.cloud.compute.v1.TargetTcpProxies
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.TargetTcpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertTargetTcpProxyRequest} request InsertTargetTcpProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetTcpProxies.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetTcpProxies.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertTargetTcpProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.TargetTcpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertTargetTcpProxyRequest} request InsertTargetTcpProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetTcpProxies|list}.
                         * @memberof google.cloud.compute.v1.TargetTcpProxies
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetTcpProxyList} [response] TargetTcpProxyList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.TargetTcpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IListTargetTcpProxiesRequest} request ListTargetTcpProxiesRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetTcpProxies.ListCallback} callback Node-style callback called with the error, if any, and TargetTcpProxyList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetTcpProxies.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListTargetTcpProxiesRequest, $root.google.cloud.compute.v1.TargetTcpProxyList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.TargetTcpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.IListTargetTcpProxiesRequest} request ListTargetTcpProxiesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetTcpProxyList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetTcpProxies|setBackendService}.
                         * @memberof google.cloud.compute.v1.TargetTcpProxies
                         * @typedef SetBackendServiceCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetBackendService.
                         * @function setBackendService
                         * @memberof google.cloud.compute.v1.TargetTcpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetBackendServiceTargetTcpProxyRequest} request SetBackendServiceTargetTcpProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetTcpProxies.SetBackendServiceCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetTcpProxies.prototype.setBackendService = function setBackendService(request, callback) {
                            return this.rpcCall(setBackendService, $root.google.cloud.compute.v1.SetBackendServiceTargetTcpProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetBackendService" });
    
                        /**
                         * Calls SetBackendService.
                         * @function setBackendService
                         * @memberof google.cloud.compute.v1.TargetTcpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetBackendServiceTargetTcpProxyRequest} request SetBackendServiceTargetTcpProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetTcpProxies|setProxyHeader}.
                         * @memberof google.cloud.compute.v1.TargetTcpProxies
                         * @typedef SetProxyHeaderCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetProxyHeader.
                         * @function setProxyHeader
                         * @memberof google.cloud.compute.v1.TargetTcpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetProxyHeaderTargetTcpProxyRequest} request SetProxyHeaderTargetTcpProxyRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetTcpProxies.SetProxyHeaderCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetTcpProxies.prototype.setProxyHeader = function setProxyHeader(request, callback) {
                            return this.rpcCall(setProxyHeader, $root.google.cloud.compute.v1.SetProxyHeaderTargetTcpProxyRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetProxyHeader" });
    
                        /**
                         * Calls SetProxyHeader.
                         * @function setProxyHeader
                         * @memberof google.cloud.compute.v1.TargetTcpProxies
                         * @instance
                         * @param {google.cloud.compute.v1.ISetProxyHeaderTargetTcpProxyRequest} request SetProxyHeaderTargetTcpProxyRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return TargetTcpProxies;
                    })();
    
                    v1.TargetVpnGateways = (function() {
    
                        /**
                         * Constructs a new TargetVpnGateways service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a TargetVpnGateways
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function TargetVpnGateways(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (TargetVpnGateways.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = TargetVpnGateways;
    
                        /**
                         * Creates new TargetVpnGateways service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.TargetVpnGateways
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {TargetVpnGateways} RPC service. Useful where requests and/or responses are streamed.
                         */
                        TargetVpnGateways.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetVpnGateways|aggregatedList}.
                         * @memberof google.cloud.compute.v1.TargetVpnGateways
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetVpnGatewayAggregatedList} [response] TargetVpnGatewayAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.TargetVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListTargetVpnGatewaysRequest} request AggregatedListTargetVpnGatewaysRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetVpnGateways.AggregatedListCallback} callback Node-style callback called with the error, if any, and TargetVpnGatewayAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetVpnGateways.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListTargetVpnGatewaysRequest, $root.google.cloud.compute.v1.TargetVpnGatewayAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.TargetVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListTargetVpnGatewaysRequest} request AggregatedListTargetVpnGatewaysRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetVpnGatewayAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetVpnGateways|delete_}.
                         * @memberof google.cloud.compute.v1.TargetVpnGateways
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.TargetVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteTargetVpnGatewayRequest} request DeleteTargetVpnGatewayRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetVpnGateways.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetVpnGateways.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteTargetVpnGatewayRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.TargetVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteTargetVpnGatewayRequest} request DeleteTargetVpnGatewayRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetVpnGateways|get}.
                         * @memberof google.cloud.compute.v1.TargetVpnGateways
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetVpnGateway} [response] TargetVpnGateway
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.TargetVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IGetTargetVpnGatewayRequest} request GetTargetVpnGatewayRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetVpnGateways.GetCallback} callback Node-style callback called with the error, if any, and TargetVpnGateway
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetVpnGateways.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetTargetVpnGatewayRequest, $root.google.cloud.compute.v1.TargetVpnGateway, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.TargetVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IGetTargetVpnGatewayRequest} request GetTargetVpnGatewayRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetVpnGateway>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetVpnGateways|insert}.
                         * @memberof google.cloud.compute.v1.TargetVpnGateways
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.TargetVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertTargetVpnGatewayRequest} request InsertTargetVpnGatewayRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetVpnGateways.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetVpnGateways.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertTargetVpnGatewayRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.TargetVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertTargetVpnGatewayRequest} request InsertTargetVpnGatewayRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetVpnGateways|list}.
                         * @memberof google.cloud.compute.v1.TargetVpnGateways
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TargetVpnGatewayList} [response] TargetVpnGatewayList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.TargetVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IListTargetVpnGatewaysRequest} request ListTargetVpnGatewaysRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetVpnGateways.ListCallback} callback Node-style callback called with the error, if any, and TargetVpnGatewayList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetVpnGateways.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListTargetVpnGatewaysRequest, $root.google.cloud.compute.v1.TargetVpnGatewayList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.TargetVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IListTargetVpnGatewaysRequest} request ListTargetVpnGatewaysRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TargetVpnGatewayList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.TargetVpnGateways|setLabels}.
                         * @memberof google.cloud.compute.v1.TargetVpnGateways
                         * @typedef SetLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.TargetVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsTargetVpnGatewayRequest} request SetLabelsTargetVpnGatewayRequest message or plain object
                         * @param {google.cloud.compute.v1.TargetVpnGateways.SetLabelsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(TargetVpnGateways.prototype.setLabels = function setLabels(request, callback) {
                            return this.rpcCall(setLabels, $root.google.cloud.compute.v1.SetLabelsTargetVpnGatewayRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetLabels" });
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.TargetVpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsTargetVpnGatewayRequest} request SetLabelsTargetVpnGatewayRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return TargetVpnGateways;
                    })();
    
                    v1.UrlMaps = (function() {
    
                        /**
                         * Constructs a new UrlMaps service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents an UrlMaps
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function UrlMaps(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (UrlMaps.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = UrlMaps;
    
                        /**
                         * Creates new UrlMaps service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {UrlMaps} RPC service. Useful where requests and/or responses are streamed.
                         */
                        UrlMaps.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.UrlMaps|aggregatedList}.
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.UrlMapsAggregatedList} [response] UrlMapsAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListUrlMapsRequest} request AggregatedListUrlMapsRequest message or plain object
                         * @param {google.cloud.compute.v1.UrlMaps.AggregatedListCallback} callback Node-style callback called with the error, if any, and UrlMapsAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(UrlMaps.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListUrlMapsRequest, $root.google.cloud.compute.v1.UrlMapsAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListUrlMapsRequest} request AggregatedListUrlMapsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.UrlMapsAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.UrlMaps|delete_}.
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteUrlMapRequest} request DeleteUrlMapRequest message or plain object
                         * @param {google.cloud.compute.v1.UrlMaps.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(UrlMaps.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteUrlMapRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteUrlMapRequest} request DeleteUrlMapRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.UrlMaps|get}.
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.UrlMap} [response] UrlMap
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IGetUrlMapRequest} request GetUrlMapRequest message or plain object
                         * @param {google.cloud.compute.v1.UrlMaps.GetCallback} callback Node-style callback called with the error, if any, and UrlMap
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(UrlMaps.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetUrlMapRequest, $root.google.cloud.compute.v1.UrlMap, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IGetUrlMapRequest} request GetUrlMapRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.UrlMap>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.UrlMaps|insert}.
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertUrlMapRequest} request InsertUrlMapRequest message or plain object
                         * @param {google.cloud.compute.v1.UrlMaps.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(UrlMaps.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertUrlMapRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertUrlMapRequest} request InsertUrlMapRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.UrlMaps|invalidateCache}.
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @typedef InvalidateCacheCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls InvalidateCache.
                         * @function invalidateCache
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IInvalidateCacheUrlMapRequest} request InvalidateCacheUrlMapRequest message or plain object
                         * @param {google.cloud.compute.v1.UrlMaps.InvalidateCacheCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(UrlMaps.prototype.invalidateCache = function invalidateCache(request, callback) {
                            return this.rpcCall(invalidateCache, $root.google.cloud.compute.v1.InvalidateCacheUrlMapRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "InvalidateCache" });
    
                        /**
                         * Calls InvalidateCache.
                         * @function invalidateCache
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IInvalidateCacheUrlMapRequest} request InvalidateCacheUrlMapRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.UrlMaps|list}.
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.UrlMapList} [response] UrlMapList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IListUrlMapsRequest} request ListUrlMapsRequest message or plain object
                         * @param {google.cloud.compute.v1.UrlMaps.ListCallback} callback Node-style callback called with the error, if any, and UrlMapList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(UrlMaps.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListUrlMapsRequest, $root.google.cloud.compute.v1.UrlMapList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IListUrlMapsRequest} request ListUrlMapsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.UrlMapList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.UrlMaps|patch}.
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @typedef PatchCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchUrlMapRequest} request PatchUrlMapRequest message or plain object
                         * @param {google.cloud.compute.v1.UrlMaps.PatchCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(UrlMaps.prototype.patch = function patch(request, callback) {
                            return this.rpcCall(patch, $root.google.cloud.compute.v1.PatchUrlMapRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Patch" });
    
                        /**
                         * Calls Patch.
                         * @function patch
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IPatchUrlMapRequest} request PatchUrlMapRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.UrlMaps|update}.
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @typedef UpdateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateUrlMapRequest} request UpdateUrlMapRequest message or plain object
                         * @param {google.cloud.compute.v1.UrlMaps.UpdateCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(UrlMaps.prototype.update = function update(request, callback) {
                            return this.rpcCall(update, $root.google.cloud.compute.v1.UpdateUrlMapRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Update" });
    
                        /**
                         * Calls Update.
                         * @function update
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IUpdateUrlMapRequest} request UpdateUrlMapRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.UrlMaps|validate}.
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @typedef ValidateCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.UrlMapsValidateResponse} [response] UrlMapsValidateResponse
                         */
    
                        /**
                         * Calls Validate.
                         * @function validate
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IValidateUrlMapRequest} request ValidateUrlMapRequest message or plain object
                         * @param {google.cloud.compute.v1.UrlMaps.ValidateCallback} callback Node-style callback called with the error, if any, and UrlMapsValidateResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(UrlMaps.prototype.validate = function validate(request, callback) {
                            return this.rpcCall(validate, $root.google.cloud.compute.v1.ValidateUrlMapRequest, $root.google.cloud.compute.v1.UrlMapsValidateResponse, request, callback);
                        }, "name", { value: "Validate" });
    
                        /**
                         * Calls Validate.
                         * @function validate
                         * @memberof google.cloud.compute.v1.UrlMaps
                         * @instance
                         * @param {google.cloud.compute.v1.IValidateUrlMapRequest} request ValidateUrlMapRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.UrlMapsValidateResponse>} Promise
                         * @variation 2
                         */
    
                        return UrlMaps;
                    })();
    
                    v1.VpnGateways = (function() {
    
                        /**
                         * Constructs a new VpnGateways service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a VpnGateways
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function VpnGateways(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (VpnGateways.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = VpnGateways;
    
                        /**
                         * Creates new VpnGateways service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {VpnGateways} RPC service. Useful where requests and/or responses are streamed.
                         */
                        VpnGateways.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.VpnGateways|aggregatedList}.
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.VpnGatewayAggregatedList} [response] VpnGatewayAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListVpnGatewaysRequest} request AggregatedListVpnGatewaysRequest message or plain object
                         * @param {google.cloud.compute.v1.VpnGateways.AggregatedListCallback} callback Node-style callback called with the error, if any, and VpnGatewayAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(VpnGateways.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListVpnGatewaysRequest, $root.google.cloud.compute.v1.VpnGatewayAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListVpnGatewaysRequest} request AggregatedListVpnGatewaysRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.VpnGatewayAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.VpnGateways|delete_}.
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteVpnGatewayRequest} request DeleteVpnGatewayRequest message or plain object
                         * @param {google.cloud.compute.v1.VpnGateways.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(VpnGateways.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteVpnGatewayRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteVpnGatewayRequest} request DeleteVpnGatewayRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.VpnGateways|get}.
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.VpnGateway} [response] VpnGateway
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IGetVpnGatewayRequest} request GetVpnGatewayRequest message or plain object
                         * @param {google.cloud.compute.v1.VpnGateways.GetCallback} callback Node-style callback called with the error, if any, and VpnGateway
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(VpnGateways.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetVpnGatewayRequest, $root.google.cloud.compute.v1.VpnGateway, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IGetVpnGatewayRequest} request GetVpnGatewayRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.VpnGateway>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.VpnGateways|getStatus}.
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @typedef GetStatusCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.VpnGatewaysGetStatusResponse} [response] VpnGatewaysGetStatusResponse
                         */
    
                        /**
                         * Calls GetStatus.
                         * @function getStatus
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IGetStatusVpnGatewayRequest} request GetStatusVpnGatewayRequest message or plain object
                         * @param {google.cloud.compute.v1.VpnGateways.GetStatusCallback} callback Node-style callback called with the error, if any, and VpnGatewaysGetStatusResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(VpnGateways.prototype.getStatus = function getStatus(request, callback) {
                            return this.rpcCall(getStatus, $root.google.cloud.compute.v1.GetStatusVpnGatewayRequest, $root.google.cloud.compute.v1.VpnGatewaysGetStatusResponse, request, callback);
                        }, "name", { value: "GetStatus" });
    
                        /**
                         * Calls GetStatus.
                         * @function getStatus
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IGetStatusVpnGatewayRequest} request GetStatusVpnGatewayRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.VpnGatewaysGetStatusResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.VpnGateways|insert}.
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertVpnGatewayRequest} request InsertVpnGatewayRequest message or plain object
                         * @param {google.cloud.compute.v1.VpnGateways.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(VpnGateways.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertVpnGatewayRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertVpnGatewayRequest} request InsertVpnGatewayRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.VpnGateways|list}.
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.VpnGatewayList} [response] VpnGatewayList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IListVpnGatewaysRequest} request ListVpnGatewaysRequest message or plain object
                         * @param {google.cloud.compute.v1.VpnGateways.ListCallback} callback Node-style callback called with the error, if any, and VpnGatewayList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(VpnGateways.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListVpnGatewaysRequest, $root.google.cloud.compute.v1.VpnGatewayList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.IListVpnGatewaysRequest} request ListVpnGatewaysRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.VpnGatewayList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.VpnGateways|setLabels}.
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @typedef SetLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsVpnGatewayRequest} request SetLabelsVpnGatewayRequest message or plain object
                         * @param {google.cloud.compute.v1.VpnGateways.SetLabelsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(VpnGateways.prototype.setLabels = function setLabels(request, callback) {
                            return this.rpcCall(setLabels, $root.google.cloud.compute.v1.SetLabelsVpnGatewayRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetLabels" });
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsVpnGatewayRequest} request SetLabelsVpnGatewayRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.VpnGateways|testIamPermissions}.
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @typedef TestIamPermissionsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.TestPermissionsResponse} [response] TestPermissionsResponse
                         */
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsVpnGatewayRequest} request TestIamPermissionsVpnGatewayRequest message or plain object
                         * @param {google.cloud.compute.v1.VpnGateways.TestIamPermissionsCallback} callback Node-style callback called with the error, if any, and TestPermissionsResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(VpnGateways.prototype.testIamPermissions = function testIamPermissions(request, callback) {
                            return this.rpcCall(testIamPermissions, $root.google.cloud.compute.v1.TestIamPermissionsVpnGatewayRequest, $root.google.cloud.compute.v1.TestPermissionsResponse, request, callback);
                        }, "name", { value: "TestIamPermissions" });
    
                        /**
                         * Calls TestIamPermissions.
                         * @function testIamPermissions
                         * @memberof google.cloud.compute.v1.VpnGateways
                         * @instance
                         * @param {google.cloud.compute.v1.ITestIamPermissionsVpnGatewayRequest} request TestIamPermissionsVpnGatewayRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.TestPermissionsResponse>} Promise
                         * @variation 2
                         */
    
                        return VpnGateways;
                    })();
    
                    v1.VpnTunnels = (function() {
    
                        /**
                         * Constructs a new VpnTunnels service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a VpnTunnels
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function VpnTunnels(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (VpnTunnels.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = VpnTunnels;
    
                        /**
                         * Creates new VpnTunnels service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.VpnTunnels
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {VpnTunnels} RPC service. Useful where requests and/or responses are streamed.
                         */
                        VpnTunnels.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.VpnTunnels|aggregatedList}.
                         * @memberof google.cloud.compute.v1.VpnTunnels
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.VpnTunnelAggregatedList} [response] VpnTunnelAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.VpnTunnels
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListVpnTunnelsRequest} request AggregatedListVpnTunnelsRequest message or plain object
                         * @param {google.cloud.compute.v1.VpnTunnels.AggregatedListCallback} callback Node-style callback called with the error, if any, and VpnTunnelAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(VpnTunnels.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1.AggregatedListVpnTunnelsRequest, $root.google.cloud.compute.v1.VpnTunnelAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1.VpnTunnels
                         * @instance
                         * @param {google.cloud.compute.v1.IAggregatedListVpnTunnelsRequest} request AggregatedListVpnTunnelsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.VpnTunnelAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.VpnTunnels|delete_}.
                         * @memberof google.cloud.compute.v1.VpnTunnels
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.VpnTunnels
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteVpnTunnelRequest} request DeleteVpnTunnelRequest message or plain object
                         * @param {google.cloud.compute.v1.VpnTunnels.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(VpnTunnels.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteVpnTunnelRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.VpnTunnels
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteVpnTunnelRequest} request DeleteVpnTunnelRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.VpnTunnels|get}.
                         * @memberof google.cloud.compute.v1.VpnTunnels
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.VpnTunnel} [response] VpnTunnel
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.VpnTunnels
                         * @instance
                         * @param {google.cloud.compute.v1.IGetVpnTunnelRequest} request GetVpnTunnelRequest message or plain object
                         * @param {google.cloud.compute.v1.VpnTunnels.GetCallback} callback Node-style callback called with the error, if any, and VpnTunnel
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(VpnTunnels.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetVpnTunnelRequest, $root.google.cloud.compute.v1.VpnTunnel, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.VpnTunnels
                         * @instance
                         * @param {google.cloud.compute.v1.IGetVpnTunnelRequest} request GetVpnTunnelRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.VpnTunnel>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.VpnTunnels|insert}.
                         * @memberof google.cloud.compute.v1.VpnTunnels
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.VpnTunnels
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertVpnTunnelRequest} request InsertVpnTunnelRequest message or plain object
                         * @param {google.cloud.compute.v1.VpnTunnels.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(VpnTunnels.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1.InsertVpnTunnelRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1.VpnTunnels
                         * @instance
                         * @param {google.cloud.compute.v1.IInsertVpnTunnelRequest} request InsertVpnTunnelRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.VpnTunnels|list}.
                         * @memberof google.cloud.compute.v1.VpnTunnels
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.VpnTunnelList} [response] VpnTunnelList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.VpnTunnels
                         * @instance
                         * @param {google.cloud.compute.v1.IListVpnTunnelsRequest} request ListVpnTunnelsRequest message or plain object
                         * @param {google.cloud.compute.v1.VpnTunnels.ListCallback} callback Node-style callback called with the error, if any, and VpnTunnelList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(VpnTunnels.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListVpnTunnelsRequest, $root.google.cloud.compute.v1.VpnTunnelList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.VpnTunnels
                         * @instance
                         * @param {google.cloud.compute.v1.IListVpnTunnelsRequest} request ListVpnTunnelsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.VpnTunnelList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.VpnTunnels|setLabels}.
                         * @memberof google.cloud.compute.v1.VpnTunnels
                         * @typedef SetLabelsCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.VpnTunnels
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsVpnTunnelRequest} request SetLabelsVpnTunnelRequest message or plain object
                         * @param {google.cloud.compute.v1.VpnTunnels.SetLabelsCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(VpnTunnels.prototype.setLabels = function setLabels(request, callback) {
                            return this.rpcCall(setLabels, $root.google.cloud.compute.v1.SetLabelsVpnTunnelRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "SetLabels" });
    
                        /**
                         * Calls SetLabels.
                         * @function setLabels
                         * @memberof google.cloud.compute.v1.VpnTunnels
                         * @instance
                         * @param {google.cloud.compute.v1.ISetLabelsVpnTunnelRequest} request SetLabelsVpnTunnelRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return VpnTunnels;
                    })();
    
                    v1.ZoneOperations = (function() {
    
                        /**
                         * Constructs a new ZoneOperations service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a ZoneOperations
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function ZoneOperations(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (ZoneOperations.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = ZoneOperations;
    
                        /**
                         * Creates new ZoneOperations service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.ZoneOperations
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {ZoneOperations} RPC service. Useful where requests and/or responses are streamed.
                         */
                        ZoneOperations.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ZoneOperations|delete_}.
                         * @memberof google.cloud.compute.v1.ZoneOperations
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.DeleteZoneOperationResponse} [response] DeleteZoneOperationResponse
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.ZoneOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteZoneOperationRequest} request DeleteZoneOperationRequest message or plain object
                         * @param {google.cloud.compute.v1.ZoneOperations.DeleteCallback} callback Node-style callback called with the error, if any, and DeleteZoneOperationResponse
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ZoneOperations.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1.DeleteZoneOperationRequest, $root.google.cloud.compute.v1.DeleteZoneOperationResponse, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1.ZoneOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IDeleteZoneOperationRequest} request DeleteZoneOperationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.DeleteZoneOperationResponse>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ZoneOperations|get}.
                         * @memberof google.cloud.compute.v1.ZoneOperations
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.ZoneOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IGetZoneOperationRequest} request GetZoneOperationRequest message or plain object
                         * @param {google.cloud.compute.v1.ZoneOperations.GetCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ZoneOperations.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetZoneOperationRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.ZoneOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IGetZoneOperationRequest} request GetZoneOperationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ZoneOperations|list}.
                         * @memberof google.cloud.compute.v1.ZoneOperations
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.OperationList} [response] OperationList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.ZoneOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IListZoneOperationsRequest} request ListZoneOperationsRequest message or plain object
                         * @param {google.cloud.compute.v1.ZoneOperations.ListCallback} callback Node-style callback called with the error, if any, and OperationList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ZoneOperations.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListZoneOperationsRequest, $root.google.cloud.compute.v1.OperationList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.ZoneOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IListZoneOperationsRequest} request ListZoneOperationsRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.OperationList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.ZoneOperations|wait}.
                         * @memberof google.cloud.compute.v1.ZoneOperations
                         * @typedef WaitCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Wait.
                         * @function wait
                         * @memberof google.cloud.compute.v1.ZoneOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IWaitZoneOperationRequest} request WaitZoneOperationRequest message or plain object
                         * @param {google.cloud.compute.v1.ZoneOperations.WaitCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(ZoneOperations.prototype.wait = function wait(request, callback) {
                            return this.rpcCall(wait, $root.google.cloud.compute.v1.WaitZoneOperationRequest, $root.google.cloud.compute.v1.Operation, request, callback);
                        }, "name", { value: "Wait" });
    
                        /**
                         * Calls Wait.
                         * @function wait
                         * @memberof google.cloud.compute.v1.ZoneOperations
                         * @instance
                         * @param {google.cloud.compute.v1.IWaitZoneOperationRequest} request WaitZoneOperationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Operation>} Promise
                         * @variation 2
                         */
    
                        return ZoneOperations;
                    })();
    
                    v1.Zones = (function() {
    
                        /**
                         * Constructs a new Zones service.
                         * @memberof google.cloud.compute.v1
                         * @classdesc Represents a Zones
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function Zones(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (Zones.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = Zones;
    
                        /**
                         * Creates new Zones service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1.Zones
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {Zones} RPC service. Useful where requests and/or responses are streamed.
                         */
                        Zones.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Zones|get}.
                         * @memberof google.cloud.compute.v1.Zones
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.Zone} [response] Zone
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Zones
                         * @instance
                         * @param {google.cloud.compute.v1.IGetZoneRequest} request GetZoneRequest message or plain object
                         * @param {google.cloud.compute.v1.Zones.GetCallback} callback Node-style callback called with the error, if any, and Zone
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Zones.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1.GetZoneRequest, $root.google.cloud.compute.v1.Zone, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1.Zones
                         * @instance
                         * @param {google.cloud.compute.v1.IGetZoneRequest} request GetZoneRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.Zone>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1.Zones|list}.
                         * @memberof google.cloud.compute.v1.Zones
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1.ZoneList} [response] ZoneList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Zones
                         * @instance
                         * @param {google.cloud.compute.v1.IListZonesRequest} request ListZonesRequest message or plain object
                         * @param {google.cloud.compute.v1.Zones.ListCallback} callback Node-style callback called with the error, if any, and ZoneList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Zones.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1.ListZonesRequest, $root.google.cloud.compute.v1.ZoneList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1.Zones
                         * @instance
                         * @param {google.cloud.compute.v1.IListZonesRequest} request ListZonesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1.ZoneList>} Promise
                         * @variation 2
                         */
    
                        return Zones;
                    })();
    
                    return v1;
                })();
    
                compute.v1small = (function() {
    
                    /**
                     * Namespace v1small.
                     * @memberof google.cloud.compute
                     * @namespace
                     */
                    var v1small = {};
    
                    v1small.Address = (function() {
    
                        /**
                         * Properties of an Address.
                         * @memberof google.cloud.compute.v1small
                         * @interface IAddress
                         * @property {string|null} [address] Address address
                         * @property {string|null} [addressType] Address addressType
                         * @property {string|null} [creationTimestamp] Address creationTimestamp
                         * @property {string|null} [description] Address description
                         * @property {number|Long|null} [id] Address id
                         * @property {string|null} [ipVersion] Address ipVersion
                         * @property {string|null} [kind] Address kind
                         * @property {string|null} [name] Address name
                         * @property {string|null} [network] Address network
                         * @property {string|null} [networkTier] Address networkTier
                         * @property {number|null} [prefixLength] Address prefixLength
                         * @property {string|null} [purpose] Address purpose
                         * @property {string|null} [region] Address region
                         * @property {string|null} [selfLink] Address selfLink
                         * @property {string|null} [status] Address status
                         * @property {string|null} [subnetwork] Address subnetwork
                         * @property {Array.<string>|null} [users] Address users
                         */
    
                        /**
                         * Constructs a new Address.
                         * @memberof google.cloud.compute.v1small
                         * @classdesc Represents an Address.
                         * @implements IAddress
                         * @constructor
                         * @param {google.cloud.compute.v1small.IAddress=} [properties] Properties to set
                         */
                        function Address(properties) {
                            this.users = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Address address.
                         * @member {string|null|undefined} address
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Address.prototype.address = null;
    
                        /**
                         * Address addressType.
                         * @member {string|null|undefined} addressType
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Address.prototype.addressType = null;
    
                        /**
                         * Address creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Address.prototype.creationTimestamp = null;
    
                        /**
                         * Address description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Address.prototype.description = null;
    
                        /**
                         * Address id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Address.prototype.id = null;
    
                        /**
                         * Address ipVersion.
                         * @member {string|null|undefined} ipVersion
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Address.prototype.ipVersion = null;
    
                        /**
                         * Address kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Address.prototype.kind = null;
    
                        /**
                         * Address name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Address.prototype.name = null;
    
                        /**
                         * Address network.
                         * @member {string|null|undefined} network
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Address.prototype.network = null;
    
                        /**
                         * Address networkTier.
                         * @member {string|null|undefined} networkTier
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Address.prototype.networkTier = null;
    
                        /**
                         * Address prefixLength.
                         * @member {number|null|undefined} prefixLength
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Address.prototype.prefixLength = null;
    
                        /**
                         * Address purpose.
                         * @member {string|null|undefined} purpose
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Address.prototype.purpose = null;
    
                        /**
                         * Address region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Address.prototype.region = null;
    
                        /**
                         * Address selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Address.prototype.selfLink = null;
    
                        /**
                         * Address status.
                         * @member {string|null|undefined} status
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Address.prototype.status = null;
    
                        /**
                         * Address subnetwork.
                         * @member {string|null|undefined} subnetwork
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Address.prototype.subnetwork = null;
    
                        /**
                         * Address users.
                         * @member {Array.<string>} users
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Address.prototype.users = $util.emptyArray;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Address _address.
                         * @member {"address"|undefined} _address
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_address", {
                            get: $util.oneOfGetter($oneOfFields = ["address"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _addressType.
                         * @member {"addressType"|undefined} _addressType
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_addressType", {
                            get: $util.oneOfGetter($oneOfFields = ["addressType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _ipVersion.
                         * @member {"ipVersion"|undefined} _ipVersion
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_ipVersion", {
                            get: $util.oneOfGetter($oneOfFields = ["ipVersion"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _network.
                         * @member {"network"|undefined} _network
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_network", {
                            get: $util.oneOfGetter($oneOfFields = ["network"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _networkTier.
                         * @member {"networkTier"|undefined} _networkTier
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_networkTier", {
                            get: $util.oneOfGetter($oneOfFields = ["networkTier"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _prefixLength.
                         * @member {"prefixLength"|undefined} _prefixLength
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_prefixLength", {
                            get: $util.oneOfGetter($oneOfFields = ["prefixLength"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _purpose.
                         * @member {"purpose"|undefined} _purpose
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_purpose", {
                            get: $util.oneOfGetter($oneOfFields = ["purpose"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Address _subnetwork.
                         * @member {"subnetwork"|undefined} _subnetwork
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         */
                        Object.defineProperty(Address.prototype, "_subnetwork", {
                            get: $util.oneOfGetter($oneOfFields = ["subnetwork"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Address instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1small.Address
                         * @static
                         * @param {google.cloud.compute.v1small.IAddress=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1small.Address} Address instance
                         */
                        Address.create = function create(properties) {
                            return new Address(properties);
                        };
    
                        /**
                         * Encodes the specified Address message. Does not implicitly {@link google.cloud.compute.v1small.Address.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1small.Address
                         * @static
                         * @param {google.cloud.compute.v1small.IAddress} message Address message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Address.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.users != null && message.users.length)
                                for (var i = 0; i < message.users.length; ++i)
                                    writer.uint32(/* id 111578632, wireType 2 =*/892629058).string(message.users[i]);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 2 =*/1450082194).string(message.status);
                            if (message.network != null && Object.hasOwnProperty.call(message, "network"))
                                writer.uint32(/* id 232872494, wireType 2 =*/1862979954).string(message.network);
                            if (message.addressType != null && Object.hasOwnProperty.call(message, "addressType"))
                                writer.uint32(/* id 264307877, wireType 2 =*/2114463018).string(message.addressType);
                            if (message.ipVersion != null && Object.hasOwnProperty.call(message, "ipVersion"))
                                writer.uint32(/* id 294959552, wireType 2 =*/2359676418).string(message.ipVersion);
                            if (message.subnetwork != null && Object.hasOwnProperty.call(message, "subnetwork"))
                                writer.uint32(/* id 307827694, wireType 2 =*/2462621554).string(message.subnetwork);
                            if (message.purpose != null && Object.hasOwnProperty.call(message, "purpose"))
                                writer.uint32(/* id 316407070, wireType 2 =*/2531256562).string(message.purpose);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.prefixLength != null && Object.hasOwnProperty.call(message, "prefixLength"))
                                writer.uint32(/* id 453565747, wireType 0 =*/3628525976).int32(message.prefixLength);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.address != null && Object.hasOwnProperty.call(message, "address"))
                                writer.uint32(/* id 462920692, wireType 2 =*/3703365538).string(message.address);
                            if (message.networkTier != null && Object.hasOwnProperty.call(message, "networkTier"))
                                writer.uint32(/* id 517397843, wireType 2 =*/4139182746).string(message.networkTier);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Address message, length delimited. Does not implicitly {@link google.cloud.compute.v1small.Address.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1small.Address
                         * @static
                         * @param {google.cloud.compute.v1small.IAddress} message Address message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Address.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Address message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1small.Address
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1small.Address} Address
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Address.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1small.Address();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 462920692: {
                                        message.address = reader.string();
                                        break;
                                    }
                                case 264307877: {
                                        message.addressType = reader.string();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 294959552: {
                                        message.ipVersion = reader.string();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 232872494: {
                                        message.network = reader.string();
                                        break;
                                    }
                                case 517397843: {
                                        message.networkTier = reader.string();
                                        break;
                                    }
                                case 453565747: {
                                        message.prefixLength = reader.int32();
                                        break;
                                    }
                                case 316407070: {
                                        message.purpose = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.string();
                                        break;
                                    }
                                case 307827694: {
                                        message.subnetwork = reader.string();
                                        break;
                                    }
                                case 111578632: {
                                        if (!(message.users && message.users.length))
                                            message.users = [];
                                        message.users.push(reader.string());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Address message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1small.Address
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1small.Address} Address
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Address.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Address message.
                         * @function verify
                         * @memberof google.cloud.compute.v1small.Address
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Address.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.address != null && message.hasOwnProperty("address")) {
                                properties._address = 1;
                                if (!$util.isString(message.address))
                                    return "address: string expected";
                            }
                            if (message.addressType != null && message.hasOwnProperty("addressType")) {
                                properties._addressType = 1;
                                if (!$util.isString(message.addressType))
                                    return "addressType: string expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.ipVersion != null && message.hasOwnProperty("ipVersion")) {
                                properties._ipVersion = 1;
                                if (!$util.isString(message.ipVersion))
                                    return "ipVersion: string expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                properties._network = 1;
                                if (!$util.isString(message.network))
                                    return "network: string expected";
                            }
                            if (message.networkTier != null && message.hasOwnProperty("networkTier")) {
                                properties._networkTier = 1;
                                if (!$util.isString(message.networkTier))
                                    return "networkTier: string expected";
                            }
                            if (message.prefixLength != null && message.hasOwnProperty("prefixLength")) {
                                properties._prefixLength = 1;
                                if (!$util.isInteger(message.prefixLength))
                                    return "prefixLength: integer expected";
                            }
                            if (message.purpose != null && message.hasOwnProperty("purpose")) {
                                properties._purpose = 1;
                                if (!$util.isString(message.purpose))
                                    return "purpose: string expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                if (!$util.isString(message.status))
                                    return "status: string expected";
                            }
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork")) {
                                properties._subnetwork = 1;
                                if (!$util.isString(message.subnetwork))
                                    return "subnetwork: string expected";
                            }
                            if (message.users != null && message.hasOwnProperty("users")) {
                                if (!Array.isArray(message.users))
                                    return "users: array expected";
                                for (var i = 0; i < message.users.length; ++i)
                                    if (!$util.isString(message.users[i]))
                                        return "users: string[] expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an Address message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1small.Address
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1small.Address} Address
                         */
                        Address.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1small.Address)
                                return object;
                            var message = new $root.google.cloud.compute.v1small.Address();
                            if (object.address != null)
                                message.address = String(object.address);
                            if (object.addressType != null)
                                message.addressType = String(object.addressType);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.ipVersion != null)
                                message.ipVersion = String(object.ipVersion);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.network != null)
                                message.network = String(object.network);
                            if (object.networkTier != null)
                                message.networkTier = String(object.networkTier);
                            if (object.prefixLength != null)
                                message.prefixLength = object.prefixLength | 0;
                            if (object.purpose != null)
                                message.purpose = String(object.purpose);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.status != null)
                                message.status = String(object.status);
                            if (object.subnetwork != null)
                                message.subnetwork = String(object.subnetwork);
                            if (object.users) {
                                if (!Array.isArray(object.users))
                                    throw TypeError(".google.cloud.compute.v1small.Address.users: array expected");
                                message.users = [];
                                for (var i = 0; i < object.users.length; ++i)
                                    message.users[i] = String(object.users[i]);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Address message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1small.Address
                         * @static
                         * @param {google.cloud.compute.v1small.Address} message Address
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Address.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.users = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.users && message.users.length) {
                                object.users = [];
                                for (var j = 0; j < message.users.length; ++j)
                                    object.users[j] = message.users[j];
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.network != null && message.hasOwnProperty("network")) {
                                object.network = message.network;
                                if (options.oneofs)
                                    object._network = "network";
                            }
                            if (message.addressType != null && message.hasOwnProperty("addressType")) {
                                object.addressType = message.addressType;
                                if (options.oneofs)
                                    object._addressType = "addressType";
                            }
                            if (message.ipVersion != null && message.hasOwnProperty("ipVersion")) {
                                object.ipVersion = message.ipVersion;
                                if (options.oneofs)
                                    object._ipVersion = "ipVersion";
                            }
                            if (message.subnetwork != null && message.hasOwnProperty("subnetwork")) {
                                object.subnetwork = message.subnetwork;
                                if (options.oneofs)
                                    object._subnetwork = "subnetwork";
                            }
                            if (message.purpose != null && message.hasOwnProperty("purpose")) {
                                object.purpose = message.purpose;
                                if (options.oneofs)
                                    object._purpose = "purpose";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.prefixLength != null && message.hasOwnProperty("prefixLength")) {
                                object.prefixLength = message.prefixLength;
                                if (options.oneofs)
                                    object._prefixLength = "prefixLength";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.address != null && message.hasOwnProperty("address")) {
                                object.address = message.address;
                                if (options.oneofs)
                                    object._address = "address";
                            }
                            if (message.networkTier != null && message.hasOwnProperty("networkTier")) {
                                object.networkTier = message.networkTier;
                                if (options.oneofs)
                                    object._networkTier = "networkTier";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Address to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1small.Address
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Address.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Address
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1small.Address
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Address.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1small.Address";
                        };
    
                        /**
                         * AddressType enum.
                         * @name google.cloud.compute.v1small.Address.AddressType
                         * @enum {number}
                         * @property {number} UNDEFINED_ADDRESS_TYPE=0 UNDEFINED_ADDRESS_TYPE value
                         * @property {number} EXTERNAL=35607499 EXTERNAL value
                         * @property {number} INTERNAL=279295677 INTERNAL value
                         * @property {number} UNSPECIFIED_TYPE=53933922 UNSPECIFIED_TYPE value
                         */
                        Address.AddressType = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_ADDRESS_TYPE"] = 0;
                            values[valuesById[35607499] = "EXTERNAL"] = 35607499;
                            values[valuesById[279295677] = "INTERNAL"] = 279295677;
                            values[valuesById[53933922] = "UNSPECIFIED_TYPE"] = 53933922;
                            return values;
                        })();
    
                        /**
                         * IpVersion enum.
                         * @name google.cloud.compute.v1small.Address.IpVersion
                         * @enum {number}
                         * @property {number} UNDEFINED_IP_VERSION=0 UNDEFINED_IP_VERSION value
                         * @property {number} IPV4=2254341 IPV4 value
                         * @property {number} IPV6=2254343 IPV6 value
                         * @property {number} UNSPECIFIED_VERSION=21850000 UNSPECIFIED_VERSION value
                         */
                        Address.IpVersion = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_IP_VERSION"] = 0;
                            values[valuesById[2254341] = "IPV4"] = 2254341;
                            values[valuesById[2254343] = "IPV6"] = 2254343;
                            values[valuesById[21850000] = "UNSPECIFIED_VERSION"] = 21850000;
                            return values;
                        })();
    
                        /**
                         * NetworkTier enum.
                         * @name google.cloud.compute.v1small.Address.NetworkTier
                         * @enum {number}
                         * @property {number} UNDEFINED_NETWORK_TIER=0 UNDEFINED_NETWORK_TIER value
                         * @property {number} PREMIUM=399530551 PREMIUM value
                         * @property {number} STANDARD=484642493 STANDARD value
                         */
                        Address.NetworkTier = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_NETWORK_TIER"] = 0;
                            values[valuesById[399530551] = "PREMIUM"] = 399530551;
                            values[valuesById[484642493] = "STANDARD"] = 484642493;
                            return values;
                        })();
    
                        /**
                         * Purpose enum.
                         * @name google.cloud.compute.v1small.Address.Purpose
                         * @enum {number}
                         * @property {number} UNDEFINED_PURPOSE=0 UNDEFINED_PURPOSE value
                         * @property {number} DNS_RESOLVER=476114556 DNS_RESOLVER value
                         * @property {number} GCE_ENDPOINT=230515243 GCE_ENDPOINT value
                         * @property {number} NAT_AUTO=163666477 NAT_AUTO value
                         * @property {number} VPC_PEERING=400800170 VPC_PEERING value
                         */
                        Address.Purpose = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_PURPOSE"] = 0;
                            values[valuesById[476114556] = "DNS_RESOLVER"] = 476114556;
                            values[valuesById[230515243] = "GCE_ENDPOINT"] = 230515243;
                            values[valuesById[163666477] = "NAT_AUTO"] = 163666477;
                            values[valuesById[400800170] = "VPC_PEERING"] = 400800170;
                            return values;
                        })();
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1small.Address.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} IN_USE=17393485 IN_USE value
                         * @property {number} RESERVED=432241448 RESERVED value
                         * @property {number} RESERVING=514587225 RESERVING value
                         */
                        Address.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[17393485] = "IN_USE"] = 17393485;
                            values[valuesById[432241448] = "RESERVED"] = 432241448;
                            values[valuesById[514587225] = "RESERVING"] = 514587225;
                            return values;
                        })();
    
                        return Address;
                    })();
    
                    v1small.AddressAggregatedList = (function() {
    
                        /**
                         * Properties of an AddressAggregatedList.
                         * @memberof google.cloud.compute.v1small
                         * @interface IAddressAggregatedList
                         * @property {string|null} [id] AddressAggregatedList id
                         * @property {Object.<string,google.cloud.compute.v1small.IAddressesScopedList>|null} [items] AddressAggregatedList items
                         * @property {string|null} [kind] AddressAggregatedList kind
                         * @property {string|null} [nextPageToken] AddressAggregatedList nextPageToken
                         * @property {string|null} [selfLink] AddressAggregatedList selfLink
                         * @property {google.cloud.compute.v1small.IWarning|null} [warning] AddressAggregatedList warning
                         */
    
                        /**
                         * Constructs a new AddressAggregatedList.
                         * @memberof google.cloud.compute.v1small
                         * @classdesc Represents an AddressAggregatedList.
                         * @implements IAddressAggregatedList
                         * @constructor
                         * @param {google.cloud.compute.v1small.IAddressAggregatedList=} [properties] Properties to set
                         */
                        function AddressAggregatedList(properties) {
                            this.items = {};
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddressAggregatedList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @instance
                         */
                        AddressAggregatedList.prototype.id = null;
    
                        /**
                         * AddressAggregatedList items.
                         * @member {Object.<string,google.cloud.compute.v1small.IAddressesScopedList>} items
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @instance
                         */
                        AddressAggregatedList.prototype.items = $util.emptyObject;
    
                        /**
                         * AddressAggregatedList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @instance
                         */
                        AddressAggregatedList.prototype.kind = null;
    
                        /**
                         * AddressAggregatedList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @instance
                         */
                        AddressAggregatedList.prototype.nextPageToken = null;
    
                        /**
                         * AddressAggregatedList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @instance
                         */
                        AddressAggregatedList.prototype.selfLink = null;
    
                        /**
                         * AddressAggregatedList warning.
                         * @member {google.cloud.compute.v1small.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @instance
                         */
                        AddressAggregatedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddressAggregatedList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @instance
                         */
                        Object.defineProperty(AddressAggregatedList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddressAggregatedList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @instance
                         */
                        Object.defineProperty(AddressAggregatedList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddressAggregatedList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @instance
                         */
                        Object.defineProperty(AddressAggregatedList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddressAggregatedList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @instance
                         */
                        Object.defineProperty(AddressAggregatedList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddressAggregatedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @instance
                         */
                        Object.defineProperty(AddressAggregatedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddressAggregatedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1small.IAddressAggregatedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1small.AddressAggregatedList} AddressAggregatedList instance
                         */
                        AddressAggregatedList.create = function create(properties) {
                            return new AddressAggregatedList(properties);
                        };
    
                        /**
                         * Encodes the specified AddressAggregatedList message. Does not implicitly {@link google.cloud.compute.v1small.AddressAggregatedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1small.IAddressAggregatedList} message AddressAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddressAggregatedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1small.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && Object.hasOwnProperty.call(message, "items"))
                                for (var keys = Object.keys(message.items), i = 0; i < keys.length; ++i) {
                                    writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                                    $root.google.cloud.compute.v1small.AddressesScopedList.encode(message.items[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                                }
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddressAggregatedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1small.AddressAggregatedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1small.IAddressAggregatedList} message AddressAggregatedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddressAggregatedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddressAggregatedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1small.AddressAggregatedList} AddressAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddressAggregatedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1small.AddressAggregatedList(), key, value;
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (message.items === $util.emptyObject)
                                            message.items = {};
                                        var end2 = reader.uint32() + reader.pos;
                                        key = "";
                                        value = null;
                                        while (reader.pos < end2) {
                                            var tag2 = reader.uint32();
                                            switch (tag2 >>> 3) {
                                            case 1:
                                                key = reader.string();
                                                break;
                                            case 2:
                                                value = $root.google.cloud.compute.v1small.AddressesScopedList.decode(reader, reader.uint32());
                                                break;
                                            default:
                                                reader.skipType(tag2 & 7);
                                                break;
                                            }
                                        }
                                        message.items[key] = value;
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1small.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddressAggregatedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1small.AddressAggregatedList} AddressAggregatedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddressAggregatedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddressAggregatedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddressAggregatedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!$util.isObject(message.items))
                                    return "items: object expected";
                                var key = Object.keys(message.items);
                                for (var i = 0; i < key.length; ++i) {
                                    var error = $root.google.cloud.compute.v1small.AddressesScopedList.verify(message.items[key[i]]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1small.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AddressAggregatedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1small.AddressAggregatedList} AddressAggregatedList
                         */
                        AddressAggregatedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1small.AddressAggregatedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1small.AddressAggregatedList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (typeof object.items !== "object")
                                    throw TypeError(".google.cloud.compute.v1small.AddressAggregatedList.items: object expected");
                                message.items = {};
                                for (var keys = Object.keys(object.items), i = 0; i < keys.length; ++i) {
                                    if (typeof object.items[keys[i]] !== "object")
                                        throw TypeError(".google.cloud.compute.v1small.AddressAggregatedList.items: object expected");
                                    message.items[keys[i]] = $root.google.cloud.compute.v1small.AddressesScopedList.fromObject(object.items[keys[i]]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1small.AddressAggregatedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1small.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddressAggregatedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @static
                         * @param {google.cloud.compute.v1small.AddressAggregatedList} message AddressAggregatedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddressAggregatedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.objects || options.defaults)
                                object.items = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1small.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            var keys2;
                            if (message.items && (keys2 = Object.keys(message.items)).length) {
                                object.items = {};
                                for (var j = 0; j < keys2.length; ++j)
                                    object.items[keys2[j]] = $root.google.cloud.compute.v1small.AddressesScopedList.toObject(message.items[keys2[j]], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AddressAggregatedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddressAggregatedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddressAggregatedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1small.AddressAggregatedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddressAggregatedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1small.AddressAggregatedList";
                        };
    
                        return AddressAggregatedList;
                    })();
    
                    v1small.AddressList = (function() {
    
                        /**
                         * Properties of an AddressList.
                         * @memberof google.cloud.compute.v1small
                         * @interface IAddressList
                         * @property {string|null} [id] AddressList id
                         * @property {Array.<google.cloud.compute.v1small.IAddress>|null} [items] AddressList items
                         * @property {string|null} [kind] AddressList kind
                         * @property {string|null} [nextPageToken] AddressList nextPageToken
                         * @property {string|null} [selfLink] AddressList selfLink
                         * @property {google.cloud.compute.v1small.IWarning|null} [warning] AddressList warning
                         */
    
                        /**
                         * Constructs a new AddressList.
                         * @memberof google.cloud.compute.v1small
                         * @classdesc Represents an AddressList.
                         * @implements IAddressList
                         * @constructor
                         * @param {google.cloud.compute.v1small.IAddressList=} [properties] Properties to set
                         */
                        function AddressList(properties) {
                            this.items = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddressList id.
                         * @member {string|null|undefined} id
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @instance
                         */
                        AddressList.prototype.id = null;
    
                        /**
                         * AddressList items.
                         * @member {Array.<google.cloud.compute.v1small.IAddress>} items
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @instance
                         */
                        AddressList.prototype.items = $util.emptyArray;
    
                        /**
                         * AddressList kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @instance
                         */
                        AddressList.prototype.kind = null;
    
                        /**
                         * AddressList nextPageToken.
                         * @member {string|null|undefined} nextPageToken
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @instance
                         */
                        AddressList.prototype.nextPageToken = null;
    
                        /**
                         * AddressList selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @instance
                         */
                        AddressList.prototype.selfLink = null;
    
                        /**
                         * AddressList warning.
                         * @member {google.cloud.compute.v1small.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @instance
                         */
                        AddressList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddressList _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @instance
                         */
                        Object.defineProperty(AddressList.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddressList _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @instance
                         */
                        Object.defineProperty(AddressList.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddressList _nextPageToken.
                         * @member {"nextPageToken"|undefined} _nextPageToken
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @instance
                         */
                        Object.defineProperty(AddressList.prototype, "_nextPageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["nextPageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddressList _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @instance
                         */
                        Object.defineProperty(AddressList.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AddressList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @instance
                         */
                        Object.defineProperty(AddressList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddressList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @static
                         * @param {google.cloud.compute.v1small.IAddressList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1small.AddressList} AddressList instance
                         */
                        AddressList.create = function create(properties) {
                            return new AddressList(properties);
                        };
    
                        /**
                         * Encodes the specified AddressList message. Does not implicitly {@link google.cloud.compute.v1small.AddressList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @static
                         * @param {google.cloud.compute.v1small.IAddressList} message AddressList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddressList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 2 =*/26842).string(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1small.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.nextPageToken != null && Object.hasOwnProperty.call(message, "nextPageToken"))
                                writer.uint32(/* id 79797525, wireType 2 =*/638380202).string(message.nextPageToken);
                            if (message.items != null && message.items.length)
                                for (var i = 0; i < message.items.length; ++i)
                                    $root.google.cloud.compute.v1small.Address.encode(message.items[i], writer.uint32(/* id 100526016, wireType 2 =*/804208130).fork()).ldelim();
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddressList message, length delimited. Does not implicitly {@link google.cloud.compute.v1small.AddressList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @static
                         * @param {google.cloud.compute.v1small.IAddressList} message AddressList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddressList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddressList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1small.AddressList} AddressList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddressList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1small.AddressList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3355: {
                                        message.id = reader.string();
                                        break;
                                    }
                                case 100526016: {
                                        if (!(message.items && message.items.length))
                                            message.items = [];
                                        message.items.push($root.google.cloud.compute.v1small.Address.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 79797525: {
                                        message.nextPageToken = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1small.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddressList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1small.AddressList} AddressList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddressList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddressList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddressList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isString(message.id))
                                    return "id: string expected";
                            }
                            if (message.items != null && message.hasOwnProperty("items")) {
                                if (!Array.isArray(message.items))
                                    return "items: array expected";
                                for (var i = 0; i < message.items.length; ++i) {
                                    var error = $root.google.cloud.compute.v1small.Address.verify(message.items[i]);
                                    if (error)
                                        return "items." + error;
                                }
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                properties._nextPageToken = 1;
                                if (!$util.isString(message.nextPageToken))
                                    return "nextPageToken: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1small.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AddressList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1small.AddressList} AddressList
                         */
                        AddressList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1small.AddressList)
                                return object;
                            var message = new $root.google.cloud.compute.v1small.AddressList();
                            if (object.id != null)
                                message.id = String(object.id);
                            if (object.items) {
                                if (!Array.isArray(object.items))
                                    throw TypeError(".google.cloud.compute.v1small.AddressList.items: array expected");
                                message.items = [];
                                for (var i = 0; i < object.items.length; ++i) {
                                    if (typeof object.items[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1small.AddressList.items: object expected");
                                    message.items[i] = $root.google.cloud.compute.v1small.Address.fromObject(object.items[i]);
                                }
                            }
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.nextPageToken != null)
                                message.nextPageToken = String(object.nextPageToken);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1small.AddressList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1small.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddressList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @static
                         * @param {google.cloud.compute.v1small.AddressList} message AddressList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddressList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.items = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                object.id = message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1small.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.nextPageToken != null && message.hasOwnProperty("nextPageToken")) {
                                object.nextPageToken = message.nextPageToken;
                                if (options.oneofs)
                                    object._nextPageToken = "nextPageToken";
                            }
                            if (message.items && message.items.length) {
                                object.items = [];
                                for (var j = 0; j < message.items.length; ++j)
                                    object.items[j] = $root.google.cloud.compute.v1small.Address.toObject(message.items[j], options);
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AddressList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddressList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddressList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1small.AddressList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddressList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1small.AddressList";
                        };
    
                        return AddressList;
                    })();
    
                    v1small.AddressesScopedList = (function() {
    
                        /**
                         * Properties of an AddressesScopedList.
                         * @memberof google.cloud.compute.v1small
                         * @interface IAddressesScopedList
                         * @property {Array.<google.cloud.compute.v1small.IAddress>|null} [addresses] AddressesScopedList addresses
                         * @property {google.cloud.compute.v1small.IWarning|null} [warning] AddressesScopedList warning
                         */
    
                        /**
                         * Constructs a new AddressesScopedList.
                         * @memberof google.cloud.compute.v1small
                         * @classdesc Represents an AddressesScopedList.
                         * @implements IAddressesScopedList
                         * @constructor
                         * @param {google.cloud.compute.v1small.IAddressesScopedList=} [properties] Properties to set
                         */
                        function AddressesScopedList(properties) {
                            this.addresses = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AddressesScopedList addresses.
                         * @member {Array.<google.cloud.compute.v1small.IAddress>} addresses
                         * @memberof google.cloud.compute.v1small.AddressesScopedList
                         * @instance
                         */
                        AddressesScopedList.prototype.addresses = $util.emptyArray;
    
                        /**
                         * AddressesScopedList warning.
                         * @member {google.cloud.compute.v1small.IWarning|null|undefined} warning
                         * @memberof google.cloud.compute.v1small.AddressesScopedList
                         * @instance
                         */
                        AddressesScopedList.prototype.warning = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AddressesScopedList _warning.
                         * @member {"warning"|undefined} _warning
                         * @memberof google.cloud.compute.v1small.AddressesScopedList
                         * @instance
                         */
                        Object.defineProperty(AddressesScopedList.prototype, "_warning", {
                            get: $util.oneOfGetter($oneOfFields = ["warning"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AddressesScopedList instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1small.AddressesScopedList
                         * @static
                         * @param {google.cloud.compute.v1small.IAddressesScopedList=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1small.AddressesScopedList} AddressesScopedList instance
                         */
                        AddressesScopedList.create = function create(properties) {
                            return new AddressesScopedList(properties);
                        };
    
                        /**
                         * Encodes the specified AddressesScopedList message. Does not implicitly {@link google.cloud.compute.v1small.AddressesScopedList.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1small.AddressesScopedList
                         * @static
                         * @param {google.cloud.compute.v1small.IAddressesScopedList} message AddressesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddressesScopedList.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.warning != null && Object.hasOwnProperty.call(message, "warning"))
                                $root.google.cloud.compute.v1small.Warning.encode(message.warning, writer.uint32(/* id 50704284, wireType 2 =*/405634274).fork()).ldelim();
                            if (message.addresses != null && message.addresses.length)
                                for (var i = 0; i < message.addresses.length; ++i)
                                    $root.google.cloud.compute.v1small.Address.encode(message.addresses[i], writer.uint32(/* id 337673122, wireType 2 =*/2701384978).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AddressesScopedList message, length delimited. Does not implicitly {@link google.cloud.compute.v1small.AddressesScopedList.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1small.AddressesScopedList
                         * @static
                         * @param {google.cloud.compute.v1small.IAddressesScopedList} message AddressesScopedList message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AddressesScopedList.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AddressesScopedList message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1small.AddressesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1small.AddressesScopedList} AddressesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddressesScopedList.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1small.AddressesScopedList();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 337673122: {
                                        if (!(message.addresses && message.addresses.length))
                                            message.addresses = [];
                                        message.addresses.push($root.google.cloud.compute.v1small.Address.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 50704284: {
                                        message.warning = $root.google.cloud.compute.v1small.Warning.decode(reader, reader.uint32());
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AddressesScopedList message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1small.AddressesScopedList
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1small.AddressesScopedList} AddressesScopedList
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AddressesScopedList.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AddressesScopedList message.
                         * @function verify
                         * @memberof google.cloud.compute.v1small.AddressesScopedList
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AddressesScopedList.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.addresses != null && message.hasOwnProperty("addresses")) {
                                if (!Array.isArray(message.addresses))
                                    return "addresses: array expected";
                                for (var i = 0; i < message.addresses.length; ++i) {
                                    var error = $root.google.cloud.compute.v1small.Address.verify(message.addresses[i]);
                                    if (error)
                                        return "addresses." + error;
                                }
                            }
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                properties._warning = 1;
                                {
                                    var error = $root.google.cloud.compute.v1small.Warning.verify(message.warning);
                                    if (error)
                                        return "warning." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an AddressesScopedList message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1small.AddressesScopedList
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1small.AddressesScopedList} AddressesScopedList
                         */
                        AddressesScopedList.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1small.AddressesScopedList)
                                return object;
                            var message = new $root.google.cloud.compute.v1small.AddressesScopedList();
                            if (object.addresses) {
                                if (!Array.isArray(object.addresses))
                                    throw TypeError(".google.cloud.compute.v1small.AddressesScopedList.addresses: array expected");
                                message.addresses = [];
                                for (var i = 0; i < object.addresses.length; ++i) {
                                    if (typeof object.addresses[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1small.AddressesScopedList.addresses: object expected");
                                    message.addresses[i] = $root.google.cloud.compute.v1small.Address.fromObject(object.addresses[i]);
                                }
                            }
                            if (object.warning != null) {
                                if (typeof object.warning !== "object")
                                    throw TypeError(".google.cloud.compute.v1small.AddressesScopedList.warning: object expected");
                                message.warning = $root.google.cloud.compute.v1small.Warning.fromObject(object.warning);
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AddressesScopedList message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1small.AddressesScopedList
                         * @static
                         * @param {google.cloud.compute.v1small.AddressesScopedList} message AddressesScopedList
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AddressesScopedList.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.addresses = [];
                            if (message.warning != null && message.hasOwnProperty("warning")) {
                                object.warning = $root.google.cloud.compute.v1small.Warning.toObject(message.warning, options);
                                if (options.oneofs)
                                    object._warning = "warning";
                            }
                            if (message.addresses && message.addresses.length) {
                                object.addresses = [];
                                for (var j = 0; j < message.addresses.length; ++j)
                                    object.addresses[j] = $root.google.cloud.compute.v1small.Address.toObject(message.addresses[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AddressesScopedList to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1small.AddressesScopedList
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AddressesScopedList.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AddressesScopedList
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1small.AddressesScopedList
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AddressesScopedList.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1small.AddressesScopedList";
                        };
    
                        return AddressesScopedList;
                    })();
    
                    v1small.AggregatedListAddressesRequest = (function() {
    
                        /**
                         * Properties of an AggregatedListAddressesRequest.
                         * @memberof google.cloud.compute.v1small
                         * @interface IAggregatedListAddressesRequest
                         * @property {string|null} [filter] AggregatedListAddressesRequest filter
                         * @property {boolean|null} [includeAllScopes] AggregatedListAddressesRequest includeAllScopes
                         * @property {number|null} [maxResults] AggregatedListAddressesRequest maxResults
                         * @property {string|null} [orderBy] AggregatedListAddressesRequest orderBy
                         * @property {string|null} [pageToken] AggregatedListAddressesRequest pageToken
                         * @property {string|null} [project] AggregatedListAddressesRequest project
                         */
    
                        /**
                         * Constructs a new AggregatedListAddressesRequest.
                         * @memberof google.cloud.compute.v1small
                         * @classdesc Represents an AggregatedListAddressesRequest.
                         * @implements IAggregatedListAddressesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1small.IAggregatedListAddressesRequest=} [properties] Properties to set
                         */
                        function AggregatedListAddressesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * AggregatedListAddressesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @instance
                         */
                        AggregatedListAddressesRequest.prototype.filter = null;
    
                        /**
                         * AggregatedListAddressesRequest includeAllScopes.
                         * @member {boolean|null|undefined} includeAllScopes
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @instance
                         */
                        AggregatedListAddressesRequest.prototype.includeAllScopes = null;
    
                        /**
                         * AggregatedListAddressesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @instance
                         */
                        AggregatedListAddressesRequest.prototype.maxResults = null;
    
                        /**
                         * AggregatedListAddressesRequest orderBy.
                         * @member {string|null|undefined} orderBy
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @instance
                         */
                        AggregatedListAddressesRequest.prototype.orderBy = null;
    
                        /**
                         * AggregatedListAddressesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @instance
                         */
                        AggregatedListAddressesRequest.prototype.pageToken = null;
    
                        /**
                         * AggregatedListAddressesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @instance
                         */
                        AggregatedListAddressesRequest.prototype.project = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * AggregatedListAddressesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAddressesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListAddressesRequest _includeAllScopes.
                         * @member {"includeAllScopes"|undefined} _includeAllScopes
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAddressesRequest.prototype, "_includeAllScopes", {
                            get: $util.oneOfGetter($oneOfFields = ["includeAllScopes"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListAddressesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAddressesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListAddressesRequest _orderBy.
                         * @member {"orderBy"|undefined} _orderBy
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAddressesRequest.prototype, "_orderBy", {
                            get: $util.oneOfGetter($oneOfFields = ["orderBy"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * AggregatedListAddressesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(AggregatedListAddressesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new AggregatedListAddressesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @static
                         * @param {google.cloud.compute.v1small.IAggregatedListAddressesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1small.AggregatedListAddressesRequest} AggregatedListAddressesRequest instance
                         */
                        AggregatedListAddressesRequest.create = function create(properties) {
                            return new AggregatedListAddressesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified AggregatedListAddressesRequest message. Does not implicitly {@link google.cloud.compute.v1small.AggregatedListAddressesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @static
                         * @param {google.cloud.compute.v1small.IAggregatedListAddressesRequest} message AggregatedListAddressesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListAddressesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            if (message.includeAllScopes != null && Object.hasOwnProperty.call(message, "includeAllScopes"))
                                writer.uint32(/* id 391327988, wireType 0 =*/3130623904).bool(message.includeAllScopes);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified AggregatedListAddressesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1small.AggregatedListAddressesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @static
                         * @param {google.cloud.compute.v1small.IAggregatedListAddressesRequest} message AggregatedListAddressesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        AggregatedListAddressesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an AggregatedListAddressesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1small.AggregatedListAddressesRequest} AggregatedListAddressesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListAddressesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1small.AggregatedListAddressesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 391327988: {
                                        message.includeAllScopes = reader.bool();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an AggregatedListAddressesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1small.AggregatedListAddressesRequest} AggregatedListAddressesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        AggregatedListAddressesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an AggregatedListAddressesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        AggregatedListAddressesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                properties._includeAllScopes = 1;
                                if (typeof message.includeAllScopes !== "boolean")
                                    return "includeAllScopes: boolean expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                properties._orderBy = 1;
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            return null;
                        };
    
                        /**
                         * Creates an AggregatedListAddressesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1small.AggregatedListAddressesRequest} AggregatedListAddressesRequest
                         */
                        AggregatedListAddressesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1small.AggregatedListAddressesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1small.AggregatedListAddressesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.includeAllScopes != null)
                                message.includeAllScopes = Boolean(object.includeAllScopes);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an AggregatedListAddressesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @static
                         * @param {google.cloud.compute.v1small.AggregatedListAddressesRequest} message AggregatedListAddressesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        AggregatedListAddressesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults)
                                object.project = "";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy")) {
                                object.orderBy = message.orderBy;
                                if (options.oneofs)
                                    object._orderBy = "orderBy";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            if (message.includeAllScopes != null && message.hasOwnProperty("includeAllScopes")) {
                                object.includeAllScopes = message.includeAllScopes;
                                if (options.oneofs)
                                    object._includeAllScopes = "includeAllScopes";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this AggregatedListAddressesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        AggregatedListAddressesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for AggregatedListAddressesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1small.AggregatedListAddressesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        AggregatedListAddressesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1small.AggregatedListAddressesRequest";
                        };
    
                        return AggregatedListAddressesRequest;
                    })();
    
                    v1small.Data = (function() {
    
                        /**
                         * Properties of a Data.
                         * @memberof google.cloud.compute.v1small
                         * @interface IData
                         * @property {string|null} [key] Data key
                         * @property {string|null} [value] Data value
                         */
    
                        /**
                         * Constructs a new Data.
                         * @memberof google.cloud.compute.v1small
                         * @classdesc Represents a Data.
                         * @implements IData
                         * @constructor
                         * @param {google.cloud.compute.v1small.IData=} [properties] Properties to set
                         */
                        function Data(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Data key.
                         * @member {string|null|undefined} key
                         * @memberof google.cloud.compute.v1small.Data
                         * @instance
                         */
                        Data.prototype.key = null;
    
                        /**
                         * Data value.
                         * @member {string|null|undefined} value
                         * @memberof google.cloud.compute.v1small.Data
                         * @instance
                         */
                        Data.prototype.value = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Data _key.
                         * @member {"key"|undefined} _key
                         * @memberof google.cloud.compute.v1small.Data
                         * @instance
                         */
                        Object.defineProperty(Data.prototype, "_key", {
                            get: $util.oneOfGetter($oneOfFields = ["key"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Data _value.
                         * @member {"value"|undefined} _value
                         * @memberof google.cloud.compute.v1small.Data
                         * @instance
                         */
                        Object.defineProperty(Data.prototype, "_value", {
                            get: $util.oneOfGetter($oneOfFields = ["value"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Data instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1small.Data
                         * @static
                         * @param {google.cloud.compute.v1small.IData=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1small.Data} Data instance
                         */
                        Data.create = function create(properties) {
                            return new Data(properties);
                        };
    
                        /**
                         * Encodes the specified Data message. Does not implicitly {@link google.cloud.compute.v1small.Data.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1small.Data
                         * @static
                         * @param {google.cloud.compute.v1small.IData} message Data message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Data.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.key != null && Object.hasOwnProperty.call(message, "key"))
                                writer.uint32(/* id 106079, wireType 2 =*/848634).string(message.key);
                            if (message.value != null && Object.hasOwnProperty.call(message, "value"))
                                writer.uint32(/* id 111972721, wireType 2 =*/895781770).string(message.value);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Data message, length delimited. Does not implicitly {@link google.cloud.compute.v1small.Data.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1small.Data
                         * @static
                         * @param {google.cloud.compute.v1small.IData} message Data message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Data.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Data message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1small.Data
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1small.Data} Data
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Data.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1small.Data();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 106079: {
                                        message.key = reader.string();
                                        break;
                                    }
                                case 111972721: {
                                        message.value = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Data message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1small.Data
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1small.Data} Data
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Data.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Data message.
                         * @function verify
                         * @memberof google.cloud.compute.v1small.Data
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Data.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.key != null && message.hasOwnProperty("key")) {
                                properties._key = 1;
                                if (!$util.isString(message.key))
                                    return "key: string expected";
                            }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                properties._value = 1;
                                if (!$util.isString(message.value))
                                    return "value: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Data message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1small.Data
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1small.Data} Data
                         */
                        Data.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1small.Data)
                                return object;
                            var message = new $root.google.cloud.compute.v1small.Data();
                            if (object.key != null)
                                message.key = String(object.key);
                            if (object.value != null)
                                message.value = String(object.value);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Data message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1small.Data
                         * @static
                         * @param {google.cloud.compute.v1small.Data} message Data
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Data.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.key != null && message.hasOwnProperty("key")) {
                                object.key = message.key;
                                if (options.oneofs)
                                    object._key = "key";
                            }
                            if (message.value != null && message.hasOwnProperty("value")) {
                                object.value = message.value;
                                if (options.oneofs)
                                    object._value = "value";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Data to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1small.Data
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Data.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Data
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1small.Data
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Data.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1small.Data";
                        };
    
                        return Data;
                    })();
    
                    v1small.DeleteAddressRequest = (function() {
    
                        /**
                         * Properties of a DeleteAddressRequest.
                         * @memberof google.cloud.compute.v1small
                         * @interface IDeleteAddressRequest
                         * @property {string|null} [address] DeleteAddressRequest address
                         * @property {string|null} [project] DeleteAddressRequest project
                         * @property {string|null} [region] DeleteAddressRequest region
                         * @property {string|null} [requestId] DeleteAddressRequest requestId
                         */
    
                        /**
                         * Constructs a new DeleteAddressRequest.
                         * @memberof google.cloud.compute.v1small
                         * @classdesc Represents a DeleteAddressRequest.
                         * @implements IDeleteAddressRequest
                         * @constructor
                         * @param {google.cloud.compute.v1small.IDeleteAddressRequest=} [properties] Properties to set
                         */
                        function DeleteAddressRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * DeleteAddressRequest address.
                         * @member {string} address
                         * @memberof google.cloud.compute.v1small.DeleteAddressRequest
                         * @instance
                         */
                        DeleteAddressRequest.prototype.address = "";
    
                        /**
                         * DeleteAddressRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1small.DeleteAddressRequest
                         * @instance
                         */
                        DeleteAddressRequest.prototype.project = "";
    
                        /**
                         * DeleteAddressRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1small.DeleteAddressRequest
                         * @instance
                         */
                        DeleteAddressRequest.prototype.region = "";
    
                        /**
                         * DeleteAddressRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1small.DeleteAddressRequest
                         * @instance
                         */
                        DeleteAddressRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * DeleteAddressRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1small.DeleteAddressRequest
                         * @instance
                         */
                        Object.defineProperty(DeleteAddressRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new DeleteAddressRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1small.DeleteAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1small.IDeleteAddressRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1small.DeleteAddressRequest} DeleteAddressRequest instance
                         */
                        DeleteAddressRequest.create = function create(properties) {
                            return new DeleteAddressRequest(properties);
                        };
    
                        /**
                         * Encodes the specified DeleteAddressRequest message. Does not implicitly {@link google.cloud.compute.v1small.DeleteAddressRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1small.DeleteAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1small.IDeleteAddressRequest} message DeleteAddressRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteAddressRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.address != null && Object.hasOwnProperty.call(message, "address"))
                                writer.uint32(/* id 462920692, wireType 2 =*/3703365538).string(message.address);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified DeleteAddressRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1small.DeleteAddressRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1small.DeleteAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1small.IDeleteAddressRequest} message DeleteAddressRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        DeleteAddressRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a DeleteAddressRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1small.DeleteAddressRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1small.DeleteAddressRequest} DeleteAddressRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteAddressRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1small.DeleteAddressRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 462920692: {
                                        message.address = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a DeleteAddressRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1small.DeleteAddressRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1small.DeleteAddressRequest} DeleteAddressRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        DeleteAddressRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a DeleteAddressRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1small.DeleteAddressRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        DeleteAddressRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.address != null && message.hasOwnProperty("address"))
                                if (!$util.isString(message.address))
                                    return "address: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a DeleteAddressRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1small.DeleteAddressRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1small.DeleteAddressRequest} DeleteAddressRequest
                         */
                        DeleteAddressRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1small.DeleteAddressRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1small.DeleteAddressRequest();
                            if (object.address != null)
                                message.address = String(object.address);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a DeleteAddressRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1small.DeleteAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1small.DeleteAddressRequest} message DeleteAddressRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        DeleteAddressRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.address = "";
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.address != null && message.hasOwnProperty("address"))
                                object.address = message.address;
                            return object;
                        };
    
                        /**
                         * Converts this DeleteAddressRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1small.DeleteAddressRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        DeleteAddressRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for DeleteAddressRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1small.DeleteAddressRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        DeleteAddressRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1small.DeleteAddressRequest";
                        };
    
                        return DeleteAddressRequest;
                    })();
    
                    v1small.Error = (function() {
    
                        /**
                         * Properties of an Error.
                         * @memberof google.cloud.compute.v1small
                         * @interface IError
                         * @property {Array.<google.cloud.compute.v1small.IErrors>|null} [errors] Error errors
                         */
    
                        /**
                         * Constructs a new Error.
                         * @memberof google.cloud.compute.v1small
                         * @classdesc Represents an Error.
                         * @implements IError
                         * @constructor
                         * @param {google.cloud.compute.v1small.IError=} [properties] Properties to set
                         */
                        function Error(properties) {
                            this.errors = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Error errors.
                         * @member {Array.<google.cloud.compute.v1small.IErrors>} errors
                         * @memberof google.cloud.compute.v1small.Error
                         * @instance
                         */
                        Error.prototype.errors = $util.emptyArray;
    
                        /**
                         * Creates a new Error instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1small.Error
                         * @static
                         * @param {google.cloud.compute.v1small.IError=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1small.Error} Error instance
                         */
                        Error.create = function create(properties) {
                            return new Error(properties);
                        };
    
                        /**
                         * Encodes the specified Error message. Does not implicitly {@link google.cloud.compute.v1small.Error.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1small.Error
                         * @static
                         * @param {google.cloud.compute.v1small.IError} message Error message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Error.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.errors != null && message.errors.length)
                                for (var i = 0; i < message.errors.length; ++i)
                                    $root.google.cloud.compute.v1small.Errors.encode(message.errors[i], writer.uint32(/* id 315977579, wireType 2 =*/2527820634).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Error message, length delimited. Does not implicitly {@link google.cloud.compute.v1small.Error.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1small.Error
                         * @static
                         * @param {google.cloud.compute.v1small.IError} message Error message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Error.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Error message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1small.Error
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1small.Error} Error
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Error.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1small.Error();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 315977579: {
                                        if (!(message.errors && message.errors.length))
                                            message.errors = [];
                                        message.errors.push($root.google.cloud.compute.v1small.Errors.decode(reader, reader.uint32()));
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Error message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1small.Error
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1small.Error} Error
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Error.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Error message.
                         * @function verify
                         * @memberof google.cloud.compute.v1small.Error
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Error.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.errors != null && message.hasOwnProperty("errors")) {
                                if (!Array.isArray(message.errors))
                                    return "errors: array expected";
                                for (var i = 0; i < message.errors.length; ++i) {
                                    var error = $root.google.cloud.compute.v1small.Errors.verify(message.errors[i]);
                                    if (error)
                                        return "errors." + error;
                                }
                            }
                            return null;
                        };
    
                        /**
                         * Creates an Error message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1small.Error
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1small.Error} Error
                         */
                        Error.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1small.Error)
                                return object;
                            var message = new $root.google.cloud.compute.v1small.Error();
                            if (object.errors) {
                                if (!Array.isArray(object.errors))
                                    throw TypeError(".google.cloud.compute.v1small.Error.errors: array expected");
                                message.errors = [];
                                for (var i = 0; i < object.errors.length; ++i) {
                                    if (typeof object.errors[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1small.Error.errors: object expected");
                                    message.errors[i] = $root.google.cloud.compute.v1small.Errors.fromObject(object.errors[i]);
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Error message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1small.Error
                         * @static
                         * @param {google.cloud.compute.v1small.Error} message Error
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Error.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.errors = [];
                            if (message.errors && message.errors.length) {
                                object.errors = [];
                                for (var j = 0; j < message.errors.length; ++j)
                                    object.errors[j] = $root.google.cloud.compute.v1small.Errors.toObject(message.errors[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Error to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1small.Error
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Error.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Error
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1small.Error
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Error.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1small.Error";
                        };
    
                        return Error;
                    })();
    
                    v1small.Errors = (function() {
    
                        /**
                         * Properties of an Errors.
                         * @memberof google.cloud.compute.v1small
                         * @interface IErrors
                         * @property {string|null} [code] Errors code
                         * @property {string|null} [location] Errors location
                         * @property {string|null} [message] Errors message
                         */
    
                        /**
                         * Constructs a new Errors.
                         * @memberof google.cloud.compute.v1small
                         * @classdesc Represents an Errors.
                         * @implements IErrors
                         * @constructor
                         * @param {google.cloud.compute.v1small.IErrors=} [properties] Properties to set
                         */
                        function Errors(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Errors code.
                         * @member {string|null|undefined} code
                         * @memberof google.cloud.compute.v1small.Errors
                         * @instance
                         */
                        Errors.prototype.code = null;
    
                        /**
                         * Errors location.
                         * @member {string|null|undefined} location
                         * @memberof google.cloud.compute.v1small.Errors
                         * @instance
                         */
                        Errors.prototype.location = null;
    
                        /**
                         * Errors message.
                         * @member {string|null|undefined} message
                         * @memberof google.cloud.compute.v1small.Errors
                         * @instance
                         */
                        Errors.prototype.message = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Errors _code.
                         * @member {"code"|undefined} _code
                         * @memberof google.cloud.compute.v1small.Errors
                         * @instance
                         */
                        Object.defineProperty(Errors.prototype, "_code", {
                            get: $util.oneOfGetter($oneOfFields = ["code"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Errors _location.
                         * @member {"location"|undefined} _location
                         * @memberof google.cloud.compute.v1small.Errors
                         * @instance
                         */
                        Object.defineProperty(Errors.prototype, "_location", {
                            get: $util.oneOfGetter($oneOfFields = ["location"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Errors _message.
                         * @member {"message"|undefined} _message
                         * @memberof google.cloud.compute.v1small.Errors
                         * @instance
                         */
                        Object.defineProperty(Errors.prototype, "_message", {
                            get: $util.oneOfGetter($oneOfFields = ["message"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Errors instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1small.Errors
                         * @static
                         * @param {google.cloud.compute.v1small.IErrors=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1small.Errors} Errors instance
                         */
                        Errors.create = function create(properties) {
                            return new Errors(properties);
                        };
    
                        /**
                         * Encodes the specified Errors message. Does not implicitly {@link google.cloud.compute.v1small.Errors.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1small.Errors
                         * @static
                         * @param {google.cloud.compute.v1small.IErrors} message Errors message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Errors.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.code != null && Object.hasOwnProperty.call(message, "code"))
                                writer.uint32(/* id 3059181, wireType 2 =*/24473450).string(message.code);
                            if (message.location != null && Object.hasOwnProperty.call(message, "location"))
                                writer.uint32(/* id 290430901, wireType 2 =*/2323447210).string(message.location);
                            if (message.message != null && Object.hasOwnProperty.call(message, "message"))
                                writer.uint32(/* id 418054151, wireType 2 =*/3344433210).string(message.message);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Errors message, length delimited. Does not implicitly {@link google.cloud.compute.v1small.Errors.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1small.Errors
                         * @static
                         * @param {google.cloud.compute.v1small.IErrors} message Errors message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Errors.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Errors message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1small.Errors
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1small.Errors} Errors
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Errors.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1small.Errors();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3059181: {
                                        message.code = reader.string();
                                        break;
                                    }
                                case 290430901: {
                                        message.location = reader.string();
                                        break;
                                    }
                                case 418054151: {
                                        message.message = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Errors message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1small.Errors
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1small.Errors} Errors
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Errors.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Errors message.
                         * @function verify
                         * @memberof google.cloud.compute.v1small.Errors
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Errors.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.code != null && message.hasOwnProperty("code")) {
                                properties._code = 1;
                                if (!$util.isString(message.code))
                                    return "code: string expected";
                            }
                            if (message.location != null && message.hasOwnProperty("location")) {
                                properties._location = 1;
                                if (!$util.isString(message.location))
                                    return "location: string expected";
                            }
                            if (message.message != null && message.hasOwnProperty("message")) {
                                properties._message = 1;
                                if (!$util.isString(message.message))
                                    return "message: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an Errors message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1small.Errors
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1small.Errors} Errors
                         */
                        Errors.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1small.Errors)
                                return object;
                            var message = new $root.google.cloud.compute.v1small.Errors();
                            if (object.code != null)
                                message.code = String(object.code);
                            if (object.location != null)
                                message.location = String(object.location);
                            if (object.message != null)
                                message.message = String(object.message);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Errors message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1small.Errors
                         * @static
                         * @param {google.cloud.compute.v1small.Errors} message Errors
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Errors.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (message.code != null && message.hasOwnProperty("code")) {
                                object.code = message.code;
                                if (options.oneofs)
                                    object._code = "code";
                            }
                            if (message.location != null && message.hasOwnProperty("location")) {
                                object.location = message.location;
                                if (options.oneofs)
                                    object._location = "location";
                            }
                            if (message.message != null && message.hasOwnProperty("message")) {
                                object.message = message.message;
                                if (options.oneofs)
                                    object._message = "message";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Errors to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1small.Errors
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Errors.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Errors
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1small.Errors
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Errors.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1small.Errors";
                        };
    
                        return Errors;
                    })();
    
                    v1small.GetRegionOperationRequest = (function() {
    
                        /**
                         * Properties of a GetRegionOperationRequest.
                         * @memberof google.cloud.compute.v1small
                         * @interface IGetRegionOperationRequest
                         * @property {string|null} [operation] GetRegionOperationRequest operation
                         * @property {string|null} [project] GetRegionOperationRequest project
                         * @property {string|null} [region] GetRegionOperationRequest region
                         */
    
                        /**
                         * Constructs a new GetRegionOperationRequest.
                         * @memberof google.cloud.compute.v1small
                         * @classdesc Represents a GetRegionOperationRequest.
                         * @implements IGetRegionOperationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1small.IGetRegionOperationRequest=} [properties] Properties to set
                         */
                        function GetRegionOperationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * GetRegionOperationRequest operation.
                         * @member {string} operation
                         * @memberof google.cloud.compute.v1small.GetRegionOperationRequest
                         * @instance
                         */
                        GetRegionOperationRequest.prototype.operation = "";
    
                        /**
                         * GetRegionOperationRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1small.GetRegionOperationRequest
                         * @instance
                         */
                        GetRegionOperationRequest.prototype.project = "";
    
                        /**
                         * GetRegionOperationRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1small.GetRegionOperationRequest
                         * @instance
                         */
                        GetRegionOperationRequest.prototype.region = "";
    
                        /**
                         * Creates a new GetRegionOperationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1small.GetRegionOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1small.IGetRegionOperationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1small.GetRegionOperationRequest} GetRegionOperationRequest instance
                         */
                        GetRegionOperationRequest.create = function create(properties) {
                            return new GetRegionOperationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified GetRegionOperationRequest message. Does not implicitly {@link google.cloud.compute.v1small.GetRegionOperationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1small.GetRegionOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1small.IGetRegionOperationRequest} message GetRegionOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionOperationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operation != null && Object.hasOwnProperty.call(message, "operation"))
                                writer.uint32(/* id 52090215, wireType 2 =*/416721722).string(message.operation);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified GetRegionOperationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1small.GetRegionOperationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1small.GetRegionOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1small.IGetRegionOperationRequest} message GetRegionOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        GetRegionOperationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a GetRegionOperationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1small.GetRegionOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1small.GetRegionOperationRequest} GetRegionOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionOperationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1small.GetRegionOperationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 52090215: {
                                        message.operation = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a GetRegionOperationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1small.GetRegionOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1small.GetRegionOperationRequest} GetRegionOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        GetRegionOperationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a GetRegionOperationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1small.GetRegionOperationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        GetRegionOperationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                if (!$util.isString(message.operation))
                                    return "operation: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a GetRegionOperationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1small.GetRegionOperationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1small.GetRegionOperationRequest} GetRegionOperationRequest
                         */
                        GetRegionOperationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1small.GetRegionOperationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1small.GetRegionOperationRequest();
                            if (object.operation != null)
                                message.operation = String(object.operation);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a GetRegionOperationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1small.GetRegionOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1small.GetRegionOperationRequest} message GetRegionOperationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        GetRegionOperationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.operation = "";
                                object.region = "";
                                object.project = "";
                            }
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                object.operation = message.operation;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this GetRegionOperationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1small.GetRegionOperationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        GetRegionOperationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for GetRegionOperationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1small.GetRegionOperationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        GetRegionOperationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1small.GetRegionOperationRequest";
                        };
    
                        return GetRegionOperationRequest;
                    })();
    
                    v1small.InsertAddressRequest = (function() {
    
                        /**
                         * Properties of an InsertAddressRequest.
                         * @memberof google.cloud.compute.v1small
                         * @interface IInsertAddressRequest
                         * @property {google.cloud.compute.v1small.IAddress|null} [addressResource] InsertAddressRequest addressResource
                         * @property {string|null} [project] InsertAddressRequest project
                         * @property {string|null} [region] InsertAddressRequest region
                         * @property {string|null} [requestId] InsertAddressRequest requestId
                         */
    
                        /**
                         * Constructs a new InsertAddressRequest.
                         * @memberof google.cloud.compute.v1small
                         * @classdesc Represents an InsertAddressRequest.
                         * @implements IInsertAddressRequest
                         * @constructor
                         * @param {google.cloud.compute.v1small.IInsertAddressRequest=} [properties] Properties to set
                         */
                        function InsertAddressRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * InsertAddressRequest addressResource.
                         * @member {google.cloud.compute.v1small.IAddress|null|undefined} addressResource
                         * @memberof google.cloud.compute.v1small.InsertAddressRequest
                         * @instance
                         */
                        InsertAddressRequest.prototype.addressResource = null;
    
                        /**
                         * InsertAddressRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1small.InsertAddressRequest
                         * @instance
                         */
                        InsertAddressRequest.prototype.project = "";
    
                        /**
                         * InsertAddressRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1small.InsertAddressRequest
                         * @instance
                         */
                        InsertAddressRequest.prototype.region = "";
    
                        /**
                         * InsertAddressRequest requestId.
                         * @member {string|null|undefined} requestId
                         * @memberof google.cloud.compute.v1small.InsertAddressRequest
                         * @instance
                         */
                        InsertAddressRequest.prototype.requestId = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * InsertAddressRequest _requestId.
                         * @member {"requestId"|undefined} _requestId
                         * @memberof google.cloud.compute.v1small.InsertAddressRequest
                         * @instance
                         */
                        Object.defineProperty(InsertAddressRequest.prototype, "_requestId", {
                            get: $util.oneOfGetter($oneOfFields = ["requestId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new InsertAddressRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1small.InsertAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1small.IInsertAddressRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1small.InsertAddressRequest} InsertAddressRequest instance
                         */
                        InsertAddressRequest.create = function create(properties) {
                            return new InsertAddressRequest(properties);
                        };
    
                        /**
                         * Encodes the specified InsertAddressRequest message. Does not implicitly {@link google.cloud.compute.v1small.InsertAddressRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1small.InsertAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1small.IInsertAddressRequest} message InsertAddressRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertAddressRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.requestId != null && Object.hasOwnProperty.call(message, "requestId"))
                                writer.uint32(/* id 37109963, wireType 2 =*/296879706).string(message.requestId);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.addressResource != null && Object.hasOwnProperty.call(message, "addressResource"))
                                $root.google.cloud.compute.v1small.Address.encode(message.addressResource, writer.uint32(/* id 483888121, wireType 2 =*/3871104970).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified InsertAddressRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1small.InsertAddressRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1small.InsertAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1small.IInsertAddressRequest} message InsertAddressRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        InsertAddressRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an InsertAddressRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1small.InsertAddressRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1small.InsertAddressRequest} InsertAddressRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertAddressRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1small.InsertAddressRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 483888121: {
                                        message.addressResource = $root.google.cloud.compute.v1small.Address.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 37109963: {
                                        message.requestId = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an InsertAddressRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1small.InsertAddressRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1small.InsertAddressRequest} InsertAddressRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        InsertAddressRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an InsertAddressRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1small.InsertAddressRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        InsertAddressRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.addressResource != null && message.hasOwnProperty("addressResource")) {
                                var error = $root.google.cloud.compute.v1small.Address.verify(message.addressResource);
                                if (error)
                                    return "addressResource." + error;
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                properties._requestId = 1;
                                if (!$util.isString(message.requestId))
                                    return "requestId: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an InsertAddressRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1small.InsertAddressRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1small.InsertAddressRequest} InsertAddressRequest
                         */
                        InsertAddressRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1small.InsertAddressRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1small.InsertAddressRequest();
                            if (object.addressResource != null) {
                                if (typeof object.addressResource !== "object")
                                    throw TypeError(".google.cloud.compute.v1small.InsertAddressRequest.addressResource: object expected");
                                message.addressResource = $root.google.cloud.compute.v1small.Address.fromObject(object.addressResource);
                            }
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.requestId != null)
                                message.requestId = String(object.requestId);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an InsertAddressRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1small.InsertAddressRequest
                         * @static
                         * @param {google.cloud.compute.v1small.InsertAddressRequest} message InsertAddressRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        InsertAddressRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.project = "";
                                object.addressResource = null;
                            }
                            if (message.requestId != null && message.hasOwnProperty("requestId")) {
                                object.requestId = message.requestId;
                                if (options.oneofs)
                                    object._requestId = "requestId";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.addressResource != null && message.hasOwnProperty("addressResource"))
                                object.addressResource = $root.google.cloud.compute.v1small.Address.toObject(message.addressResource, options);
                            return object;
                        };
    
                        /**
                         * Converts this InsertAddressRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1small.InsertAddressRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        InsertAddressRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for InsertAddressRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1small.InsertAddressRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        InsertAddressRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1small.InsertAddressRequest";
                        };
    
                        return InsertAddressRequest;
                    })();
    
                    v1small.ListAddressesRequest = (function() {
    
                        /**
                         * Properties of a ListAddressesRequest.
                         * @memberof google.cloud.compute.v1small
                         * @interface IListAddressesRequest
                         * @property {string|null} [filter] ListAddressesRequest filter
                         * @property {number|null} [maxResults] ListAddressesRequest maxResults
                         * @property {string|null} [orderBy] ListAddressesRequest orderBy
                         * @property {string|null} [pageToken] ListAddressesRequest pageToken
                         * @property {string|null} [project] ListAddressesRequest project
                         * @property {string|null} [region] ListAddressesRequest region
                         */
    
                        /**
                         * Constructs a new ListAddressesRequest.
                         * @memberof google.cloud.compute.v1small
                         * @classdesc Represents a ListAddressesRequest.
                         * @implements IListAddressesRequest
                         * @constructor
                         * @param {google.cloud.compute.v1small.IListAddressesRequest=} [properties] Properties to set
                         */
                        function ListAddressesRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * ListAddressesRequest filter.
                         * @member {string|null|undefined} filter
                         * @memberof google.cloud.compute.v1small.ListAddressesRequest
                         * @instance
                         */
                        ListAddressesRequest.prototype.filter = null;
    
                        /**
                         * ListAddressesRequest maxResults.
                         * @member {number|null|undefined} maxResults
                         * @memberof google.cloud.compute.v1small.ListAddressesRequest
                         * @instance
                         */
                        ListAddressesRequest.prototype.maxResults = null;
    
                        /**
                         * ListAddressesRequest orderBy.
                         * @member {string} orderBy
                         * @memberof google.cloud.compute.v1small.ListAddressesRequest
                         * @instance
                         */
                        ListAddressesRequest.prototype.orderBy = "";
    
                        /**
                         * ListAddressesRequest pageToken.
                         * @member {string|null|undefined} pageToken
                         * @memberof google.cloud.compute.v1small.ListAddressesRequest
                         * @instance
                         */
                        ListAddressesRequest.prototype.pageToken = null;
    
                        /**
                         * ListAddressesRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1small.ListAddressesRequest
                         * @instance
                         */
                        ListAddressesRequest.prototype.project = "";
    
                        /**
                         * ListAddressesRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1small.ListAddressesRequest
                         * @instance
                         */
                        ListAddressesRequest.prototype.region = "";
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * ListAddressesRequest _filter.
                         * @member {"filter"|undefined} _filter
                         * @memberof google.cloud.compute.v1small.ListAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAddressesRequest.prototype, "_filter", {
                            get: $util.oneOfGetter($oneOfFields = ["filter"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAddressesRequest _maxResults.
                         * @member {"maxResults"|undefined} _maxResults
                         * @memberof google.cloud.compute.v1small.ListAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAddressesRequest.prototype, "_maxResults", {
                            get: $util.oneOfGetter($oneOfFields = ["maxResults"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * ListAddressesRequest _pageToken.
                         * @member {"pageToken"|undefined} _pageToken
                         * @memberof google.cloud.compute.v1small.ListAddressesRequest
                         * @instance
                         */
                        Object.defineProperty(ListAddressesRequest.prototype, "_pageToken", {
                            get: $util.oneOfGetter($oneOfFields = ["pageToken"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new ListAddressesRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1small.ListAddressesRequest
                         * @static
                         * @param {google.cloud.compute.v1small.IListAddressesRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1small.ListAddressesRequest} ListAddressesRequest instance
                         */
                        ListAddressesRequest.create = function create(properties) {
                            return new ListAddressesRequest(properties);
                        };
    
                        /**
                         * Encodes the specified ListAddressesRequest message. Does not implicitly {@link google.cloud.compute.v1small.ListAddressesRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1small.ListAddressesRequest
                         * @static
                         * @param {google.cloud.compute.v1small.IListAddressesRequest} message ListAddressesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAddressesRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.pageToken != null && Object.hasOwnProperty.call(message, "pageToken"))
                                writer.uint32(/* id 19994697, wireType 2 =*/159957578).string(message.pageToken);
                            if (message.maxResults != null && Object.hasOwnProperty.call(message, "maxResults"))
                                writer.uint32(/* id 54715419, wireType 0 =*/437723352).uint32(message.maxResults);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.orderBy != null && Object.hasOwnProperty.call(message, "orderBy"))
                                writer.uint32(/* id 160562920, wireType 2 =*/1284503362).string(message.orderBy);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            if (message.filter != null && Object.hasOwnProperty.call(message, "filter"))
                                writer.uint32(/* id 336120696, wireType 2 =*/2688965570).string(message.filter);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified ListAddressesRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1small.ListAddressesRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1small.ListAddressesRequest
                         * @static
                         * @param {google.cloud.compute.v1small.IListAddressesRequest} message ListAddressesRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        ListAddressesRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a ListAddressesRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1small.ListAddressesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1small.ListAddressesRequest} ListAddressesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAddressesRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1small.ListAddressesRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 336120696: {
                                        message.filter = reader.string();
                                        break;
                                    }
                                case 54715419: {
                                        message.maxResults = reader.uint32();
                                        break;
                                    }
                                case 160562920: {
                                        message.orderBy = reader.string();
                                        break;
                                    }
                                case 19994697: {
                                        message.pageToken = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a ListAddressesRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1small.ListAddressesRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1small.ListAddressesRequest} ListAddressesRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        ListAddressesRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a ListAddressesRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1small.ListAddressesRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        ListAddressesRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                properties._filter = 1;
                                if (!$util.isString(message.filter))
                                    return "filter: string expected";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                properties._maxResults = 1;
                                if (!$util.isInteger(message.maxResults))
                                    return "maxResults: integer expected";
                            }
                            if (message.orderBy != null && message.hasOwnProperty("orderBy"))
                                if (!$util.isString(message.orderBy))
                                    return "orderBy: string expected";
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                properties._pageToken = 1;
                                if (!$util.isString(message.pageToken))
                                    return "pageToken: string expected";
                            }
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a ListAddressesRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1small.ListAddressesRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1small.ListAddressesRequest} ListAddressesRequest
                         */
                        ListAddressesRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1small.ListAddressesRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1small.ListAddressesRequest();
                            if (object.filter != null)
                                message.filter = String(object.filter);
                            if (object.maxResults != null)
                                message.maxResults = object.maxResults >>> 0;
                            if (object.orderBy != null)
                                message.orderBy = String(object.orderBy);
                            if (object.pageToken != null)
                                message.pageToken = String(object.pageToken);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a ListAddressesRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1small.ListAddressesRequest
                         * @static
                         * @param {google.cloud.compute.v1small.ListAddressesRequest} message ListAddressesRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        ListAddressesRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.region = "";
                                object.orderBy = "";
                                object.project = "";
                            }
                            if (message.pageToken != null && message.hasOwnProperty("pageToken")) {
                                object.pageToken = message.pageToken;
                                if (options.oneofs)
                                    object._pageToken = "pageToken";
                            }
                            if (message.maxResults != null && message.hasOwnProperty("maxResults")) {
                                object.maxResults = message.maxResults;
                                if (options.oneofs)
                                    object._maxResults = "maxResults";
                            }
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.orderBy != null && message.hasOwnProperty("orderBy"))
                                object.orderBy = message.orderBy;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            if (message.filter != null && message.hasOwnProperty("filter")) {
                                object.filter = message.filter;
                                if (options.oneofs)
                                    object._filter = "filter";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this ListAddressesRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1small.ListAddressesRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        ListAddressesRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for ListAddressesRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1small.ListAddressesRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        ListAddressesRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1small.ListAddressesRequest";
                        };
    
                        return ListAddressesRequest;
                    })();
    
                    v1small.Operation = (function() {
    
                        /**
                         * Properties of an Operation.
                         * @memberof google.cloud.compute.v1small
                         * @interface IOperation
                         * @property {string|null} [clientOperationId] Operation clientOperationId
                         * @property {string|null} [creationTimestamp] Operation creationTimestamp
                         * @property {string|null} [description] Operation description
                         * @property {string|null} [endTime] Operation endTime
                         * @property {google.cloud.compute.v1small.IError|null} [error] Operation error
                         * @property {string|null} [httpErrorMessage] Operation httpErrorMessage
                         * @property {number|null} [httpErrorStatusCode] Operation httpErrorStatusCode
                         * @property {number|Long|null} [id] Operation id
                         * @property {string|null} [insertTime] Operation insertTime
                         * @property {string|null} [kind] Operation kind
                         * @property {string|null} [name] Operation name
                         * @property {string|null} [operationType] Operation operationType
                         * @property {number|null} [progress] Operation progress
                         * @property {string|null} [region] Operation region
                         * @property {string|null} [selfLink] Operation selfLink
                         * @property {string|null} [startTime] Operation startTime
                         * @property {google.cloud.compute.v1small.Operation.Status|null} [status] Operation status
                         * @property {string|null} [statusMessage] Operation statusMessage
                         * @property {number|Long|null} [targetId] Operation targetId
                         * @property {string|null} [targetLink] Operation targetLink
                         * @property {string|null} [user] Operation user
                         * @property {Array.<google.cloud.compute.v1small.IWarnings>|null} [warnings] Operation warnings
                         * @property {string|null} [zone] Operation zone
                         */
    
                        /**
                         * Constructs a new Operation.
                         * @memberof google.cloud.compute.v1small
                         * @classdesc Represents an Operation.
                         * @implements IOperation
                         * @constructor
                         * @param {google.cloud.compute.v1small.IOperation=} [properties] Properties to set
                         */
                        function Operation(properties) {
                            this.warnings = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Operation clientOperationId.
                         * @member {string|null|undefined} clientOperationId
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.clientOperationId = null;
    
                        /**
                         * Operation creationTimestamp.
                         * @member {string|null|undefined} creationTimestamp
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.creationTimestamp = null;
    
                        /**
                         * Operation description.
                         * @member {string|null|undefined} description
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.description = null;
    
                        /**
                         * Operation endTime.
                         * @member {string|null|undefined} endTime
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.endTime = null;
    
                        /**
                         * Operation error.
                         * @member {google.cloud.compute.v1small.IError|null|undefined} error
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.error = null;
    
                        /**
                         * Operation httpErrorMessage.
                         * @member {string|null|undefined} httpErrorMessage
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.httpErrorMessage = null;
    
                        /**
                         * Operation httpErrorStatusCode.
                         * @member {number|null|undefined} httpErrorStatusCode
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.httpErrorStatusCode = null;
    
                        /**
                         * Operation id.
                         * @member {number|Long|null|undefined} id
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.id = null;
    
                        /**
                         * Operation insertTime.
                         * @member {string|null|undefined} insertTime
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.insertTime = null;
    
                        /**
                         * Operation kind.
                         * @member {string|null|undefined} kind
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.kind = null;
    
                        /**
                         * Operation name.
                         * @member {string|null|undefined} name
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.name = null;
    
                        /**
                         * Operation operationType.
                         * @member {string|null|undefined} operationType
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.operationType = null;
    
                        /**
                         * Operation progress.
                         * @member {number|null|undefined} progress
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.progress = null;
    
                        /**
                         * Operation region.
                         * @member {string|null|undefined} region
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.region = null;
    
                        /**
                         * Operation selfLink.
                         * @member {string|null|undefined} selfLink
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.selfLink = null;
    
                        /**
                         * Operation startTime.
                         * @member {string|null|undefined} startTime
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.startTime = null;
    
                        /**
                         * Operation status.
                         * @member {google.cloud.compute.v1small.Operation.Status|null|undefined} status
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.status = null;
    
                        /**
                         * Operation statusMessage.
                         * @member {string|null|undefined} statusMessage
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.statusMessage = null;
    
                        /**
                         * Operation targetId.
                         * @member {number|Long|null|undefined} targetId
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.targetId = null;
    
                        /**
                         * Operation targetLink.
                         * @member {string|null|undefined} targetLink
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.targetLink = null;
    
                        /**
                         * Operation user.
                         * @member {string|null|undefined} user
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.user = null;
    
                        /**
                         * Operation warnings.
                         * @member {Array.<google.cloud.compute.v1small.IWarnings>} warnings
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.warnings = $util.emptyArray;
    
                        /**
                         * Operation zone.
                         * @member {string|null|undefined} zone
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Operation.prototype.zone = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Operation _clientOperationId.
                         * @member {"clientOperationId"|undefined} _clientOperationId
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_clientOperationId", {
                            get: $util.oneOfGetter($oneOfFields = ["clientOperationId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _creationTimestamp.
                         * @member {"creationTimestamp"|undefined} _creationTimestamp
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_creationTimestamp", {
                            get: $util.oneOfGetter($oneOfFields = ["creationTimestamp"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _description.
                         * @member {"description"|undefined} _description
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_description", {
                            get: $util.oneOfGetter($oneOfFields = ["description"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _endTime.
                         * @member {"endTime"|undefined} _endTime
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_endTime", {
                            get: $util.oneOfGetter($oneOfFields = ["endTime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _error.
                         * @member {"error"|undefined} _error
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_error", {
                            get: $util.oneOfGetter($oneOfFields = ["error"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _httpErrorMessage.
                         * @member {"httpErrorMessage"|undefined} _httpErrorMessage
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_httpErrorMessage", {
                            get: $util.oneOfGetter($oneOfFields = ["httpErrorMessage"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _httpErrorStatusCode.
                         * @member {"httpErrorStatusCode"|undefined} _httpErrorStatusCode
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_httpErrorStatusCode", {
                            get: $util.oneOfGetter($oneOfFields = ["httpErrorStatusCode"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _id.
                         * @member {"id"|undefined} _id
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_id", {
                            get: $util.oneOfGetter($oneOfFields = ["id"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _insertTime.
                         * @member {"insertTime"|undefined} _insertTime
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_insertTime", {
                            get: $util.oneOfGetter($oneOfFields = ["insertTime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _kind.
                         * @member {"kind"|undefined} _kind
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_kind", {
                            get: $util.oneOfGetter($oneOfFields = ["kind"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _name.
                         * @member {"name"|undefined} _name
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_name", {
                            get: $util.oneOfGetter($oneOfFields = ["name"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _operationType.
                         * @member {"operationType"|undefined} _operationType
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_operationType", {
                            get: $util.oneOfGetter($oneOfFields = ["operationType"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _progress.
                         * @member {"progress"|undefined} _progress
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_progress", {
                            get: $util.oneOfGetter($oneOfFields = ["progress"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _region.
                         * @member {"region"|undefined} _region
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_region", {
                            get: $util.oneOfGetter($oneOfFields = ["region"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _selfLink.
                         * @member {"selfLink"|undefined} _selfLink
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_selfLink", {
                            get: $util.oneOfGetter($oneOfFields = ["selfLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _startTime.
                         * @member {"startTime"|undefined} _startTime
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_startTime", {
                            get: $util.oneOfGetter($oneOfFields = ["startTime"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _status.
                         * @member {"status"|undefined} _status
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_status", {
                            get: $util.oneOfGetter($oneOfFields = ["status"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _statusMessage.
                         * @member {"statusMessage"|undefined} _statusMessage
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_statusMessage", {
                            get: $util.oneOfGetter($oneOfFields = ["statusMessage"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _targetId.
                         * @member {"targetId"|undefined} _targetId
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_targetId", {
                            get: $util.oneOfGetter($oneOfFields = ["targetId"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _targetLink.
                         * @member {"targetLink"|undefined} _targetLink
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_targetLink", {
                            get: $util.oneOfGetter($oneOfFields = ["targetLink"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _user.
                         * @member {"user"|undefined} _user
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_user", {
                            get: $util.oneOfGetter($oneOfFields = ["user"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Operation _zone.
                         * @member {"zone"|undefined} _zone
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         */
                        Object.defineProperty(Operation.prototype, "_zone", {
                            get: $util.oneOfGetter($oneOfFields = ["zone"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Operation instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1small.Operation
                         * @static
                         * @param {google.cloud.compute.v1small.IOperation=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1small.Operation} Operation instance
                         */
                        Operation.create = function create(properties) {
                            return new Operation(properties);
                        };
    
                        /**
                         * Encodes the specified Operation message. Does not implicitly {@link google.cloud.compute.v1small.Operation.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1small.Operation
                         * @static
                         * @param {google.cloud.compute.v1small.IOperation} message Operation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Operation.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.id != null && Object.hasOwnProperty.call(message, "id"))
                                writer.uint32(/* id 3355, wireType 0 =*/26840).uint64(message.id);
                            if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                                writer.uint32(/* id 3292052, wireType 2 =*/26336418).string(message.kind);
                            if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                                writer.uint32(/* id 3373707, wireType 2 =*/26989658).string(message.name);
                            if (message.user != null && Object.hasOwnProperty.call(message, "user"))
                                writer.uint32(/* id 3599307, wireType 2 =*/28794458).string(message.user);
                            if (message.zone != null && Object.hasOwnProperty.call(message, "zone"))
                                writer.uint32(/* id 3744684, wireType 2 =*/29957474).string(message.zone);
                            if (message.creationTimestamp != null && Object.hasOwnProperty.call(message, "creationTimestamp"))
                                writer.uint32(/* id 30525366, wireType 2 =*/244202930).string(message.creationTimestamp);
                            if (message.startTime != null && Object.hasOwnProperty.call(message, "startTime"))
                                writer.uint32(/* id 37467274, wireType 2 =*/299738194).string(message.startTime);
                            if (message.targetLink != null && Object.hasOwnProperty.call(message, "targetLink"))
                                writer.uint32(/* id 62671336, wireType 2 =*/501370690).string(message.targetLink);
                            if (message.progress != null && Object.hasOwnProperty.call(message, "progress"))
                                writer.uint32(/* id 72663597, wireType 0 =*/581308776).int32(message.progress);
                            if (message.error != null && Object.hasOwnProperty.call(message, "error"))
                                $root.google.cloud.compute.v1small.Error.encode(message.error, writer.uint32(/* id 96784904, wireType 2 =*/774279234).fork()).ldelim();
                            if (message.endTime != null && Object.hasOwnProperty.call(message, "endTime"))
                                writer.uint32(/* id 114938801, wireType 2 =*/919510410).string(message.endTime);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.operationType != null && Object.hasOwnProperty.call(message, "operationType"))
                                writer.uint32(/* id 177650450, wireType 2 =*/1421203602).string(message.operationType);
                            if (message.status != null && Object.hasOwnProperty.call(message, "status"))
                                writer.uint32(/* id 181260274, wireType 0 =*/1450082192).int32(message.status);
                            if (message.httpErrorMessage != null && Object.hasOwnProperty.call(message, "httpErrorMessage"))
                                writer.uint32(/* id 202521945, wireType 2 =*/1620175562).string(message.httpErrorMessage);
                            if (message.targetId != null && Object.hasOwnProperty.call(message, "targetId"))
                                writer.uint32(/* id 258165385, wireType 0 =*/2065323080).uint64(message.targetId);
                            if (message.clientOperationId != null && Object.hasOwnProperty.call(message, "clientOperationId"))
                                writer.uint32(/* id 297240295, wireType 2 =*/2377922362).string(message.clientOperationId);
                            if (message.statusMessage != null && Object.hasOwnProperty.call(message, "statusMessage"))
                                writer.uint32(/* id 297428154, wireType 2 =*/2379425234).string(message.statusMessage);
                            if (message.httpErrorStatusCode != null && Object.hasOwnProperty.call(message, "httpErrorStatusCode"))
                                writer.uint32(/* id 312345196, wireType 0 =*/2498761568).int32(message.httpErrorStatusCode);
                            if (message.description != null && Object.hasOwnProperty.call(message, "description"))
                                writer.uint32(/* id 422937596, wireType 2 =*/3383500770).string(message.description);
                            if (message.insertTime != null && Object.hasOwnProperty.call(message, "insertTime"))
                                writer.uint32(/* id 433722515, wireType 2 =*/3469780122).string(message.insertTime);
                            if (message.selfLink != null && Object.hasOwnProperty.call(message, "selfLink"))
                                writer.uint32(/* id 456214797, wireType 2 =*/3649718378).string(message.selfLink);
                            if (message.warnings != null && message.warnings.length)
                                for (var i = 0; i < message.warnings.length; ++i)
                                    $root.google.cloud.compute.v1small.Warnings.encode(message.warnings[i], writer.uint32(/* id 498091095, wireType 2 =*/3984728762).fork()).ldelim();
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Operation message, length delimited. Does not implicitly {@link google.cloud.compute.v1small.Operation.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1small.Operation
                         * @static
                         * @param {google.cloud.compute.v1small.IOperation} message Operation message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Operation.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes an Operation message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1small.Operation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1small.Operation} Operation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Operation.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1small.Operation();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 297240295: {
                                        message.clientOperationId = reader.string();
                                        break;
                                    }
                                case 30525366: {
                                        message.creationTimestamp = reader.string();
                                        break;
                                    }
                                case 422937596: {
                                        message.description = reader.string();
                                        break;
                                    }
                                case 114938801: {
                                        message.endTime = reader.string();
                                        break;
                                    }
                                case 96784904: {
                                        message.error = $root.google.cloud.compute.v1small.Error.decode(reader, reader.uint32());
                                        break;
                                    }
                                case 202521945: {
                                        message.httpErrorMessage = reader.string();
                                        break;
                                    }
                                case 312345196: {
                                        message.httpErrorStatusCode = reader.int32();
                                        break;
                                    }
                                case 3355: {
                                        message.id = reader.uint64();
                                        break;
                                    }
                                case 433722515: {
                                        message.insertTime = reader.string();
                                        break;
                                    }
                                case 3292052: {
                                        message.kind = reader.string();
                                        break;
                                    }
                                case 3373707: {
                                        message.name = reader.string();
                                        break;
                                    }
                                case 177650450: {
                                        message.operationType = reader.string();
                                        break;
                                    }
                                case 72663597: {
                                        message.progress = reader.int32();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                case 456214797: {
                                        message.selfLink = reader.string();
                                        break;
                                    }
                                case 37467274: {
                                        message.startTime = reader.string();
                                        break;
                                    }
                                case 181260274: {
                                        message.status = reader.int32();
                                        break;
                                    }
                                case 297428154: {
                                        message.statusMessage = reader.string();
                                        break;
                                    }
                                case 258165385: {
                                        message.targetId = reader.uint64();
                                        break;
                                    }
                                case 62671336: {
                                        message.targetLink = reader.string();
                                        break;
                                    }
                                case 3599307: {
                                        message.user = reader.string();
                                        break;
                                    }
                                case 498091095: {
                                        if (!(message.warnings && message.warnings.length))
                                            message.warnings = [];
                                        message.warnings.push($root.google.cloud.compute.v1small.Warnings.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 3744684: {
                                        message.zone = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes an Operation message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1small.Operation
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1small.Operation} Operation
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Operation.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies an Operation message.
                         * @function verify
                         * @memberof google.cloud.compute.v1small.Operation
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Operation.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.clientOperationId != null && message.hasOwnProperty("clientOperationId")) {
                                properties._clientOperationId = 1;
                                if (!$util.isString(message.clientOperationId))
                                    return "clientOperationId: string expected";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                properties._creationTimestamp = 1;
                                if (!$util.isString(message.creationTimestamp))
                                    return "creationTimestamp: string expected";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                properties._description = 1;
                                if (!$util.isString(message.description))
                                    return "description: string expected";
                            }
                            if (message.endTime != null && message.hasOwnProperty("endTime")) {
                                properties._endTime = 1;
                                if (!$util.isString(message.endTime))
                                    return "endTime: string expected";
                            }
                            if (message.error != null && message.hasOwnProperty("error")) {
                                properties._error = 1;
                                {
                                    var error = $root.google.cloud.compute.v1small.Error.verify(message.error);
                                    if (error)
                                        return "error." + error;
                                }
                            }
                            if (message.httpErrorMessage != null && message.hasOwnProperty("httpErrorMessage")) {
                                properties._httpErrorMessage = 1;
                                if (!$util.isString(message.httpErrorMessage))
                                    return "httpErrorMessage: string expected";
                            }
                            if (message.httpErrorStatusCode != null && message.hasOwnProperty("httpErrorStatusCode")) {
                                properties._httpErrorStatusCode = 1;
                                if (!$util.isInteger(message.httpErrorStatusCode))
                                    return "httpErrorStatusCode: integer expected";
                            }
                            if (message.id != null && message.hasOwnProperty("id")) {
                                properties._id = 1;
                                if (!$util.isInteger(message.id) && !(message.id && $util.isInteger(message.id.low) && $util.isInteger(message.id.high)))
                                    return "id: integer|Long expected";
                            }
                            if (message.insertTime != null && message.hasOwnProperty("insertTime")) {
                                properties._insertTime = 1;
                                if (!$util.isString(message.insertTime))
                                    return "insertTime: string expected";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                properties._kind = 1;
                                if (!$util.isString(message.kind))
                                    return "kind: string expected";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                properties._name = 1;
                                if (!$util.isString(message.name))
                                    return "name: string expected";
                            }
                            if (message.operationType != null && message.hasOwnProperty("operationType")) {
                                properties._operationType = 1;
                                if (!$util.isString(message.operationType))
                                    return "operationType: string expected";
                            }
                            if (message.progress != null && message.hasOwnProperty("progress")) {
                                properties._progress = 1;
                                if (!$util.isInteger(message.progress))
                                    return "progress: integer expected";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                properties._region = 1;
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                properties._selfLink = 1;
                                if (!$util.isString(message.selfLink))
                                    return "selfLink: string expected";
                            }
                            if (message.startTime != null && message.hasOwnProperty("startTime")) {
                                properties._startTime = 1;
                                if (!$util.isString(message.startTime))
                                    return "startTime: string expected";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                properties._status = 1;
                                switch (message.status) {
                                default:
                                    return "status: enum value expected";
                                case 0:
                                case 2104194:
                                case 35394935:
                                case 121282975:
                                    break;
                                }
                            }
                            if (message.statusMessage != null && message.hasOwnProperty("statusMessage")) {
                                properties._statusMessage = 1;
                                if (!$util.isString(message.statusMessage))
                                    return "statusMessage: string expected";
                            }
                            if (message.targetId != null && message.hasOwnProperty("targetId")) {
                                properties._targetId = 1;
                                if (!$util.isInteger(message.targetId) && !(message.targetId && $util.isInteger(message.targetId.low) && $util.isInteger(message.targetId.high)))
                                    return "targetId: integer|Long expected";
                            }
                            if (message.targetLink != null && message.hasOwnProperty("targetLink")) {
                                properties._targetLink = 1;
                                if (!$util.isString(message.targetLink))
                                    return "targetLink: string expected";
                            }
                            if (message.user != null && message.hasOwnProperty("user")) {
                                properties._user = 1;
                                if (!$util.isString(message.user))
                                    return "user: string expected";
                            }
                            if (message.warnings != null && message.hasOwnProperty("warnings")) {
                                if (!Array.isArray(message.warnings))
                                    return "warnings: array expected";
                                for (var i = 0; i < message.warnings.length; ++i) {
                                    var error = $root.google.cloud.compute.v1small.Warnings.verify(message.warnings[i]);
                                    if (error)
                                        return "warnings." + error;
                                }
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                properties._zone = 1;
                                if (!$util.isString(message.zone))
                                    return "zone: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates an Operation message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1small.Operation
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1small.Operation} Operation
                         */
                        Operation.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1small.Operation)
                                return object;
                            var message = new $root.google.cloud.compute.v1small.Operation();
                            if (object.clientOperationId != null)
                                message.clientOperationId = String(object.clientOperationId);
                            if (object.creationTimestamp != null)
                                message.creationTimestamp = String(object.creationTimestamp);
                            if (object.description != null)
                                message.description = String(object.description);
                            if (object.endTime != null)
                                message.endTime = String(object.endTime);
                            if (object.error != null) {
                                if (typeof object.error !== "object")
                                    throw TypeError(".google.cloud.compute.v1small.Operation.error: object expected");
                                message.error = $root.google.cloud.compute.v1small.Error.fromObject(object.error);
                            }
                            if (object.httpErrorMessage != null)
                                message.httpErrorMessage = String(object.httpErrorMessage);
                            if (object.httpErrorStatusCode != null)
                                message.httpErrorStatusCode = object.httpErrorStatusCode | 0;
                            if (object.id != null)
                                if ($util.Long)
                                    (message.id = $util.Long.fromValue(object.id)).unsigned = true;
                                else if (typeof object.id === "string")
                                    message.id = parseInt(object.id, 10);
                                else if (typeof object.id === "number")
                                    message.id = object.id;
                                else if (typeof object.id === "object")
                                    message.id = new $util.LongBits(object.id.low >>> 0, object.id.high >>> 0).toNumber(true);
                            if (object.insertTime != null)
                                message.insertTime = String(object.insertTime);
                            if (object.kind != null)
                                message.kind = String(object.kind);
                            if (object.name != null)
                                message.name = String(object.name);
                            if (object.operationType != null)
                                message.operationType = String(object.operationType);
                            if (object.progress != null)
                                message.progress = object.progress | 0;
                            if (object.region != null)
                                message.region = String(object.region);
                            if (object.selfLink != null)
                                message.selfLink = String(object.selfLink);
                            if (object.startTime != null)
                                message.startTime = String(object.startTime);
                            switch (object.status) {
                            default:
                                if (typeof object.status === "number") {
                                    message.status = object.status;
                                    break;
                                }
                                break;
                            case "UNDEFINED_STATUS":
                            case 0:
                                message.status = 0;
                                break;
                            case "DONE":
                            case 2104194:
                                message.status = 2104194;
                                break;
                            case "PENDING":
                            case 35394935:
                                message.status = 35394935;
                                break;
                            case "RUNNING":
                            case 121282975:
                                message.status = 121282975;
                                break;
                            }
                            if (object.statusMessage != null)
                                message.statusMessage = String(object.statusMessage);
                            if (object.targetId != null)
                                if ($util.Long)
                                    (message.targetId = $util.Long.fromValue(object.targetId)).unsigned = true;
                                else if (typeof object.targetId === "string")
                                    message.targetId = parseInt(object.targetId, 10);
                                else if (typeof object.targetId === "number")
                                    message.targetId = object.targetId;
                                else if (typeof object.targetId === "object")
                                    message.targetId = new $util.LongBits(object.targetId.low >>> 0, object.targetId.high >>> 0).toNumber(true);
                            if (object.targetLink != null)
                                message.targetLink = String(object.targetLink);
                            if (object.user != null)
                                message.user = String(object.user);
                            if (object.warnings) {
                                if (!Array.isArray(object.warnings))
                                    throw TypeError(".google.cloud.compute.v1small.Operation.warnings: array expected");
                                message.warnings = [];
                                for (var i = 0; i < object.warnings.length; ++i) {
                                    if (typeof object.warnings[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1small.Operation.warnings: object expected");
                                    message.warnings[i] = $root.google.cloud.compute.v1small.Warnings.fromObject(object.warnings[i]);
                                }
                            }
                            if (object.zone != null)
                                message.zone = String(object.zone);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from an Operation message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1small.Operation
                         * @static
                         * @param {google.cloud.compute.v1small.Operation} message Operation
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Operation.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.warnings = [];
                            if (message.id != null && message.hasOwnProperty("id")) {
                                if (typeof message.id === "number")
                                    object.id = options.longs === String ? String(message.id) : message.id;
                                else
                                    object.id = options.longs === String ? $util.Long.prototype.toString.call(message.id) : options.longs === Number ? new $util.LongBits(message.id.low >>> 0, message.id.high >>> 0).toNumber(true) : message.id;
                                if (options.oneofs)
                                    object._id = "id";
                            }
                            if (message.kind != null && message.hasOwnProperty("kind")) {
                                object.kind = message.kind;
                                if (options.oneofs)
                                    object._kind = "kind";
                            }
                            if (message.name != null && message.hasOwnProperty("name")) {
                                object.name = message.name;
                                if (options.oneofs)
                                    object._name = "name";
                            }
                            if (message.user != null && message.hasOwnProperty("user")) {
                                object.user = message.user;
                                if (options.oneofs)
                                    object._user = "user";
                            }
                            if (message.zone != null && message.hasOwnProperty("zone")) {
                                object.zone = message.zone;
                                if (options.oneofs)
                                    object._zone = "zone";
                            }
                            if (message.creationTimestamp != null && message.hasOwnProperty("creationTimestamp")) {
                                object.creationTimestamp = message.creationTimestamp;
                                if (options.oneofs)
                                    object._creationTimestamp = "creationTimestamp";
                            }
                            if (message.startTime != null && message.hasOwnProperty("startTime")) {
                                object.startTime = message.startTime;
                                if (options.oneofs)
                                    object._startTime = "startTime";
                            }
                            if (message.targetLink != null && message.hasOwnProperty("targetLink")) {
                                object.targetLink = message.targetLink;
                                if (options.oneofs)
                                    object._targetLink = "targetLink";
                            }
                            if (message.progress != null && message.hasOwnProperty("progress")) {
                                object.progress = message.progress;
                                if (options.oneofs)
                                    object._progress = "progress";
                            }
                            if (message.error != null && message.hasOwnProperty("error")) {
                                object.error = $root.google.cloud.compute.v1small.Error.toObject(message.error, options);
                                if (options.oneofs)
                                    object._error = "error";
                            }
                            if (message.endTime != null && message.hasOwnProperty("endTime")) {
                                object.endTime = message.endTime;
                                if (options.oneofs)
                                    object._endTime = "endTime";
                            }
                            if (message.region != null && message.hasOwnProperty("region")) {
                                object.region = message.region;
                                if (options.oneofs)
                                    object._region = "region";
                            }
                            if (message.operationType != null && message.hasOwnProperty("operationType")) {
                                object.operationType = message.operationType;
                                if (options.oneofs)
                                    object._operationType = "operationType";
                            }
                            if (message.status != null && message.hasOwnProperty("status")) {
                                object.status = options.enums === String ? $root.google.cloud.compute.v1small.Operation.Status[message.status] === undefined ? message.status : $root.google.cloud.compute.v1small.Operation.Status[message.status] : message.status;
                                if (options.oneofs)
                                    object._status = "status";
                            }
                            if (message.httpErrorMessage != null && message.hasOwnProperty("httpErrorMessage")) {
                                object.httpErrorMessage = message.httpErrorMessage;
                                if (options.oneofs)
                                    object._httpErrorMessage = "httpErrorMessage";
                            }
                            if (message.targetId != null && message.hasOwnProperty("targetId")) {
                                if (typeof message.targetId === "number")
                                    object.targetId = options.longs === String ? String(message.targetId) : message.targetId;
                                else
                                    object.targetId = options.longs === String ? $util.Long.prototype.toString.call(message.targetId) : options.longs === Number ? new $util.LongBits(message.targetId.low >>> 0, message.targetId.high >>> 0).toNumber(true) : message.targetId;
                                if (options.oneofs)
                                    object._targetId = "targetId";
                            }
                            if (message.clientOperationId != null && message.hasOwnProperty("clientOperationId")) {
                                object.clientOperationId = message.clientOperationId;
                                if (options.oneofs)
                                    object._clientOperationId = "clientOperationId";
                            }
                            if (message.statusMessage != null && message.hasOwnProperty("statusMessage")) {
                                object.statusMessage = message.statusMessage;
                                if (options.oneofs)
                                    object._statusMessage = "statusMessage";
                            }
                            if (message.httpErrorStatusCode != null && message.hasOwnProperty("httpErrorStatusCode")) {
                                object.httpErrorStatusCode = message.httpErrorStatusCode;
                                if (options.oneofs)
                                    object._httpErrorStatusCode = "httpErrorStatusCode";
                            }
                            if (message.description != null && message.hasOwnProperty("description")) {
                                object.description = message.description;
                                if (options.oneofs)
                                    object._description = "description";
                            }
                            if (message.insertTime != null && message.hasOwnProperty("insertTime")) {
                                object.insertTime = message.insertTime;
                                if (options.oneofs)
                                    object._insertTime = "insertTime";
                            }
                            if (message.selfLink != null && message.hasOwnProperty("selfLink")) {
                                object.selfLink = message.selfLink;
                                if (options.oneofs)
                                    object._selfLink = "selfLink";
                            }
                            if (message.warnings && message.warnings.length) {
                                object.warnings = [];
                                for (var j = 0; j < message.warnings.length; ++j)
                                    object.warnings[j] = $root.google.cloud.compute.v1small.Warnings.toObject(message.warnings[j], options);
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Operation to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1small.Operation
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Operation.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Operation
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1small.Operation
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Operation.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1small.Operation";
                        };
    
                        /**
                         * Status enum.
                         * @name google.cloud.compute.v1small.Operation.Status
                         * @enum {number}
                         * @property {number} UNDEFINED_STATUS=0 UNDEFINED_STATUS value
                         * @property {number} DONE=2104194 DONE value
                         * @property {number} PENDING=35394935 PENDING value
                         * @property {number} RUNNING=121282975 RUNNING value
                         */
                        Operation.Status = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_STATUS"] = 0;
                            values[valuesById[2104194] = "DONE"] = 2104194;
                            values[valuesById[35394935] = "PENDING"] = 35394935;
                            values[valuesById[121282975] = "RUNNING"] = 121282975;
                            return values;
                        })();
    
                        return Operation;
                    })();
    
                    v1small.WaitRegionOperationRequest = (function() {
    
                        /**
                         * Properties of a WaitRegionOperationRequest.
                         * @memberof google.cloud.compute.v1small
                         * @interface IWaitRegionOperationRequest
                         * @property {string|null} [operation] WaitRegionOperationRequest operation
                         * @property {string|null} [project] WaitRegionOperationRequest project
                         * @property {string|null} [region] WaitRegionOperationRequest region
                         */
    
                        /**
                         * Constructs a new WaitRegionOperationRequest.
                         * @memberof google.cloud.compute.v1small
                         * @classdesc Represents a WaitRegionOperationRequest.
                         * @implements IWaitRegionOperationRequest
                         * @constructor
                         * @param {google.cloud.compute.v1small.IWaitRegionOperationRequest=} [properties] Properties to set
                         */
                        function WaitRegionOperationRequest(properties) {
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * WaitRegionOperationRequest operation.
                         * @member {string} operation
                         * @memberof google.cloud.compute.v1small.WaitRegionOperationRequest
                         * @instance
                         */
                        WaitRegionOperationRequest.prototype.operation = "";
    
                        /**
                         * WaitRegionOperationRequest project.
                         * @member {string} project
                         * @memberof google.cloud.compute.v1small.WaitRegionOperationRequest
                         * @instance
                         */
                        WaitRegionOperationRequest.prototype.project = "";
    
                        /**
                         * WaitRegionOperationRequest region.
                         * @member {string} region
                         * @memberof google.cloud.compute.v1small.WaitRegionOperationRequest
                         * @instance
                         */
                        WaitRegionOperationRequest.prototype.region = "";
    
                        /**
                         * Creates a new WaitRegionOperationRequest instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1small.WaitRegionOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1small.IWaitRegionOperationRequest=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1small.WaitRegionOperationRequest} WaitRegionOperationRequest instance
                         */
                        WaitRegionOperationRequest.create = function create(properties) {
                            return new WaitRegionOperationRequest(properties);
                        };
    
                        /**
                         * Encodes the specified WaitRegionOperationRequest message. Does not implicitly {@link google.cloud.compute.v1small.WaitRegionOperationRequest.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1small.WaitRegionOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1small.IWaitRegionOperationRequest} message WaitRegionOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WaitRegionOperationRequest.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.operation != null && Object.hasOwnProperty.call(message, "operation"))
                                writer.uint32(/* id 52090215, wireType 2 =*/416721722).string(message.operation);
                            if (message.region != null && Object.hasOwnProperty.call(message, "region"))
                                writer.uint32(/* id 138946292, wireType 2 =*/1111570338).string(message.region);
                            if (message.project != null && Object.hasOwnProperty.call(message, "project"))
                                writer.uint32(/* id 227560217, wireType 2 =*/1820481738).string(message.project);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified WaitRegionOperationRequest message, length delimited. Does not implicitly {@link google.cloud.compute.v1small.WaitRegionOperationRequest.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1small.WaitRegionOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1small.IWaitRegionOperationRequest} message WaitRegionOperationRequest message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        WaitRegionOperationRequest.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a WaitRegionOperationRequest message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1small.WaitRegionOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1small.WaitRegionOperationRequest} WaitRegionOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WaitRegionOperationRequest.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1small.WaitRegionOperationRequest();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 52090215: {
                                        message.operation = reader.string();
                                        break;
                                    }
                                case 227560217: {
                                        message.project = reader.string();
                                        break;
                                    }
                                case 138946292: {
                                        message.region = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a WaitRegionOperationRequest message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1small.WaitRegionOperationRequest
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1small.WaitRegionOperationRequest} WaitRegionOperationRequest
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        WaitRegionOperationRequest.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a WaitRegionOperationRequest message.
                         * @function verify
                         * @memberof google.cloud.compute.v1small.WaitRegionOperationRequest
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        WaitRegionOperationRequest.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                if (!$util.isString(message.operation))
                                    return "operation: string expected";
                            if (message.project != null && message.hasOwnProperty("project"))
                                if (!$util.isString(message.project))
                                    return "project: string expected";
                            if (message.region != null && message.hasOwnProperty("region"))
                                if (!$util.isString(message.region))
                                    return "region: string expected";
                            return null;
                        };
    
                        /**
                         * Creates a WaitRegionOperationRequest message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1small.WaitRegionOperationRequest
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1small.WaitRegionOperationRequest} WaitRegionOperationRequest
                         */
                        WaitRegionOperationRequest.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1small.WaitRegionOperationRequest)
                                return object;
                            var message = new $root.google.cloud.compute.v1small.WaitRegionOperationRequest();
                            if (object.operation != null)
                                message.operation = String(object.operation);
                            if (object.project != null)
                                message.project = String(object.project);
                            if (object.region != null)
                                message.region = String(object.region);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a WaitRegionOperationRequest message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1small.WaitRegionOperationRequest
                         * @static
                         * @param {google.cloud.compute.v1small.WaitRegionOperationRequest} message WaitRegionOperationRequest
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        WaitRegionOperationRequest.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.defaults) {
                                object.operation = "";
                                object.region = "";
                                object.project = "";
                            }
                            if (message.operation != null && message.hasOwnProperty("operation"))
                                object.operation = message.operation;
                            if (message.region != null && message.hasOwnProperty("region"))
                                object.region = message.region;
                            if (message.project != null && message.hasOwnProperty("project"))
                                object.project = message.project;
                            return object;
                        };
    
                        /**
                         * Converts this WaitRegionOperationRequest to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1small.WaitRegionOperationRequest
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        WaitRegionOperationRequest.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for WaitRegionOperationRequest
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1small.WaitRegionOperationRequest
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        WaitRegionOperationRequest.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1small.WaitRegionOperationRequest";
                        };
    
                        return WaitRegionOperationRequest;
                    })();
    
                    v1small.Warning = (function() {
    
                        /**
                         * Properties of a Warning.
                         * @memberof google.cloud.compute.v1small
                         * @interface IWarning
                         * @property {string|null} [code] Warning code
                         * @property {Array.<google.cloud.compute.v1small.IData>|null} [data] Warning data
                         * @property {string|null} [message] Warning message
                         */
    
                        /**
                         * Constructs a new Warning.
                         * @memberof google.cloud.compute.v1small
                         * @classdesc Represents a Warning.
                         * @implements IWarning
                         * @constructor
                         * @param {google.cloud.compute.v1small.IWarning=} [properties] Properties to set
                         */
                        function Warning(properties) {
                            this.data = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Warning code.
                         * @member {string|null|undefined} code
                         * @memberof google.cloud.compute.v1small.Warning
                         * @instance
                         */
                        Warning.prototype.code = null;
    
                        /**
                         * Warning data.
                         * @member {Array.<google.cloud.compute.v1small.IData>} data
                         * @memberof google.cloud.compute.v1small.Warning
                         * @instance
                         */
                        Warning.prototype.data = $util.emptyArray;
    
                        /**
                         * Warning message.
                         * @member {string|null|undefined} message
                         * @memberof google.cloud.compute.v1small.Warning
                         * @instance
                         */
                        Warning.prototype.message = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Warning _code.
                         * @member {"code"|undefined} _code
                         * @memberof google.cloud.compute.v1small.Warning
                         * @instance
                         */
                        Object.defineProperty(Warning.prototype, "_code", {
                            get: $util.oneOfGetter($oneOfFields = ["code"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Warning _message.
                         * @member {"message"|undefined} _message
                         * @memberof google.cloud.compute.v1small.Warning
                         * @instance
                         */
                        Object.defineProperty(Warning.prototype, "_message", {
                            get: $util.oneOfGetter($oneOfFields = ["message"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Warning instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1small.Warning
                         * @static
                         * @param {google.cloud.compute.v1small.IWarning=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1small.Warning} Warning instance
                         */
                        Warning.create = function create(properties) {
                            return new Warning(properties);
                        };
    
                        /**
                         * Encodes the specified Warning message. Does not implicitly {@link google.cloud.compute.v1small.Warning.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1small.Warning
                         * @static
                         * @param {google.cloud.compute.v1small.IWarning} message Warning message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Warning.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.code != null && Object.hasOwnProperty.call(message, "code"))
                                writer.uint32(/* id 3059181, wireType 2 =*/24473450).string(message.code);
                            if (message.data != null && message.data.length)
                                for (var i = 0; i < message.data.length; ++i)
                                    $root.google.cloud.compute.v1small.Data.encode(message.data[i], writer.uint32(/* id 3076010, wireType 2 =*/24608082).fork()).ldelim();
                            if (message.message != null && Object.hasOwnProperty.call(message, "message"))
                                writer.uint32(/* id 418054151, wireType 2 =*/3344433210).string(message.message);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Warning message, length delimited. Does not implicitly {@link google.cloud.compute.v1small.Warning.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1small.Warning
                         * @static
                         * @param {google.cloud.compute.v1small.IWarning} message Warning message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Warning.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Warning message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1small.Warning
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1small.Warning} Warning
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Warning.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1small.Warning();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3059181: {
                                        message.code = reader.string();
                                        break;
                                    }
                                case 3076010: {
                                        if (!(message.data && message.data.length))
                                            message.data = [];
                                        message.data.push($root.google.cloud.compute.v1small.Data.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 418054151: {
                                        message.message = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Warning message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1small.Warning
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1small.Warning} Warning
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Warning.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Warning message.
                         * @function verify
                         * @memberof google.cloud.compute.v1small.Warning
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Warning.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.code != null && message.hasOwnProperty("code")) {
                                properties._code = 1;
                                if (!$util.isString(message.code))
                                    return "code: string expected";
                            }
                            if (message.data != null && message.hasOwnProperty("data")) {
                                if (!Array.isArray(message.data))
                                    return "data: array expected";
                                for (var i = 0; i < message.data.length; ++i) {
                                    var error = $root.google.cloud.compute.v1small.Data.verify(message.data[i]);
                                    if (error)
                                        return "data." + error;
                                }
                            }
                            if (message.message != null && message.hasOwnProperty("message")) {
                                properties._message = 1;
                                if (!$util.isString(message.message))
                                    return "message: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Warning message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1small.Warning
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1small.Warning} Warning
                         */
                        Warning.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1small.Warning)
                                return object;
                            var message = new $root.google.cloud.compute.v1small.Warning();
                            if (object.code != null)
                                message.code = String(object.code);
                            if (object.data) {
                                if (!Array.isArray(object.data))
                                    throw TypeError(".google.cloud.compute.v1small.Warning.data: array expected");
                                message.data = [];
                                for (var i = 0; i < object.data.length; ++i) {
                                    if (typeof object.data[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1small.Warning.data: object expected");
                                    message.data[i] = $root.google.cloud.compute.v1small.Data.fromObject(object.data[i]);
                                }
                            }
                            if (object.message != null)
                                message.message = String(object.message);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Warning message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1small.Warning
                         * @static
                         * @param {google.cloud.compute.v1small.Warning} message Warning
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Warning.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.data = [];
                            if (message.code != null && message.hasOwnProperty("code")) {
                                object.code = message.code;
                                if (options.oneofs)
                                    object._code = "code";
                            }
                            if (message.data && message.data.length) {
                                object.data = [];
                                for (var j = 0; j < message.data.length; ++j)
                                    object.data[j] = $root.google.cloud.compute.v1small.Data.toObject(message.data[j], options);
                            }
                            if (message.message != null && message.hasOwnProperty("message")) {
                                object.message = message.message;
                                if (options.oneofs)
                                    object._message = "message";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Warning to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1small.Warning
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Warning.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Warning
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1small.Warning
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Warning.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1small.Warning";
                        };
    
                        /**
                         * Code enum.
                         * @name google.cloud.compute.v1small.Warning.Code
                         * @enum {number}
                         * @property {number} UNDEFINED_CODE=0 UNDEFINED_CODE value
                         * @property {number} CLEANUP_FAILED=150308440 CLEANUP_FAILED value
                         * @property {number} DEPRECATED_RESOURCE_USED=391835586 DEPRECATED_RESOURCE_USED value
                         * @property {number} DEPRECATED_TYPE_USED=346526230 DEPRECATED_TYPE_USED value
                         * @property {number} DISK_SIZE_LARGER_THAN_IMAGE_SIZE=369442967 DISK_SIZE_LARGER_THAN_IMAGE_SIZE value
                         * @property {number} EXPERIMENTAL_TYPE_USED=451954443 EXPERIMENTAL_TYPE_USED value
                         * @property {number} EXTERNAL_API_WARNING=175546307 EXTERNAL_API_WARNING value
                         * @property {number} FIELD_VALUE_OVERRIDEN=329669423 FIELD_VALUE_OVERRIDEN value
                         * @property {number} INJECTED_KERNELS_DEPRECATED=417377419 INJECTED_KERNELS_DEPRECATED value
                         * @property {number} MISSING_TYPE_DEPENDENCY=344505463 MISSING_TYPE_DEPENDENCY value
                         * @property {number} NEXT_HOP_ADDRESS_NOT_ASSIGNED=324964999 NEXT_HOP_ADDRESS_NOT_ASSIGNED value
                         * @property {number} NEXT_HOP_CANNOT_IP_FORWARD=383382887 NEXT_HOP_CANNOT_IP_FORWARD value
                         * @property {number} NEXT_HOP_INSTANCE_NOT_FOUND=464250446 NEXT_HOP_INSTANCE_NOT_FOUND value
                         * @property {number} NEXT_HOP_INSTANCE_NOT_ON_NETWORK=243758146 NEXT_HOP_INSTANCE_NOT_ON_NETWORK value
                         * @property {number} NEXT_HOP_NOT_RUNNING=417081265 NEXT_HOP_NOT_RUNNING value
                         * @property {number} NOT_CRITICAL_ERROR=105763924 NOT_CRITICAL_ERROR value
                         * @property {number} NO_RESULTS_ON_PAGE=30036744 NO_RESULTS_ON_PAGE value
                         * @property {number} REQUIRED_TOS_AGREEMENT=3745539 REQUIRED_TOS_AGREEMENT value
                         * @property {number} RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING=496728641 RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING value
                         * @property {number} RESOURCE_NOT_DELETED=168598460 RESOURCE_NOT_DELETED value
                         * @property {number} SCHEMA_VALIDATION_IGNORED=275245642 SCHEMA_VALIDATION_IGNORED value
                         * @property {number} SINGLE_INSTANCE_PROPERTY_TEMPLATE=268305617 SINGLE_INSTANCE_PROPERTY_TEMPLATE value
                         * @property {number} UNDECLARED_PROPERTIES=390513439 UNDECLARED_PROPERTIES value
                         * @property {number} UNREACHABLE=13328052 UNREACHABLE value
                         */
                        Warning.Code = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_CODE"] = 0;
                            values[valuesById[150308440] = "CLEANUP_FAILED"] = 150308440;
                            values[valuesById[391835586] = "DEPRECATED_RESOURCE_USED"] = 391835586;
                            values[valuesById[346526230] = "DEPRECATED_TYPE_USED"] = 346526230;
                            values[valuesById[369442967] = "DISK_SIZE_LARGER_THAN_IMAGE_SIZE"] = 369442967;
                            values[valuesById[451954443] = "EXPERIMENTAL_TYPE_USED"] = 451954443;
                            values[valuesById[175546307] = "EXTERNAL_API_WARNING"] = 175546307;
                            values[valuesById[329669423] = "FIELD_VALUE_OVERRIDEN"] = 329669423;
                            values[valuesById[417377419] = "INJECTED_KERNELS_DEPRECATED"] = 417377419;
                            values[valuesById[344505463] = "MISSING_TYPE_DEPENDENCY"] = 344505463;
                            values[valuesById[324964999] = "NEXT_HOP_ADDRESS_NOT_ASSIGNED"] = 324964999;
                            values[valuesById[383382887] = "NEXT_HOP_CANNOT_IP_FORWARD"] = 383382887;
                            values[valuesById[464250446] = "NEXT_HOP_INSTANCE_NOT_FOUND"] = 464250446;
                            values[valuesById[243758146] = "NEXT_HOP_INSTANCE_NOT_ON_NETWORK"] = 243758146;
                            values[valuesById[417081265] = "NEXT_HOP_NOT_RUNNING"] = 417081265;
                            values[valuesById[105763924] = "NOT_CRITICAL_ERROR"] = 105763924;
                            values[valuesById[30036744] = "NO_RESULTS_ON_PAGE"] = 30036744;
                            values[valuesById[3745539] = "REQUIRED_TOS_AGREEMENT"] = 3745539;
                            values[valuesById[496728641] = "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING"] = 496728641;
                            values[valuesById[168598460] = "RESOURCE_NOT_DELETED"] = 168598460;
                            values[valuesById[275245642] = "SCHEMA_VALIDATION_IGNORED"] = 275245642;
                            values[valuesById[268305617] = "SINGLE_INSTANCE_PROPERTY_TEMPLATE"] = 268305617;
                            values[valuesById[390513439] = "UNDECLARED_PROPERTIES"] = 390513439;
                            values[valuesById[13328052] = "UNREACHABLE"] = 13328052;
                            return values;
                        })();
    
                        return Warning;
                    })();
    
                    v1small.Warnings = (function() {
    
                        /**
                         * Properties of a Warnings.
                         * @memberof google.cloud.compute.v1small
                         * @interface IWarnings
                         * @property {string|null} [code] Warnings code
                         * @property {Array.<google.cloud.compute.v1small.IData>|null} [data] Warnings data
                         * @property {string|null} [message] Warnings message
                         */
    
                        /**
                         * Constructs a new Warnings.
                         * @memberof google.cloud.compute.v1small
                         * @classdesc Represents a Warnings.
                         * @implements IWarnings
                         * @constructor
                         * @param {google.cloud.compute.v1small.IWarnings=} [properties] Properties to set
                         */
                        function Warnings(properties) {
                            this.data = [];
                            if (properties)
                                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                    if (properties[keys[i]] != null)
                                        this[keys[i]] = properties[keys[i]];
                        }
    
                        /**
                         * Warnings code.
                         * @member {string|null|undefined} code
                         * @memberof google.cloud.compute.v1small.Warnings
                         * @instance
                         */
                        Warnings.prototype.code = null;
    
                        /**
                         * Warnings data.
                         * @member {Array.<google.cloud.compute.v1small.IData>} data
                         * @memberof google.cloud.compute.v1small.Warnings
                         * @instance
                         */
                        Warnings.prototype.data = $util.emptyArray;
    
                        /**
                         * Warnings message.
                         * @member {string|null|undefined} message
                         * @memberof google.cloud.compute.v1small.Warnings
                         * @instance
                         */
                        Warnings.prototype.message = null;
    
                        // OneOf field names bound to virtual getters and setters
                        var $oneOfFields;
    
                        /**
                         * Warnings _code.
                         * @member {"code"|undefined} _code
                         * @memberof google.cloud.compute.v1small.Warnings
                         * @instance
                         */
                        Object.defineProperty(Warnings.prototype, "_code", {
                            get: $util.oneOfGetter($oneOfFields = ["code"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Warnings _message.
                         * @member {"message"|undefined} _message
                         * @memberof google.cloud.compute.v1small.Warnings
                         * @instance
                         */
                        Object.defineProperty(Warnings.prototype, "_message", {
                            get: $util.oneOfGetter($oneOfFields = ["message"]),
                            set: $util.oneOfSetter($oneOfFields)
                        });
    
                        /**
                         * Creates a new Warnings instance using the specified properties.
                         * @function create
                         * @memberof google.cloud.compute.v1small.Warnings
                         * @static
                         * @param {google.cloud.compute.v1small.IWarnings=} [properties] Properties to set
                         * @returns {google.cloud.compute.v1small.Warnings} Warnings instance
                         */
                        Warnings.create = function create(properties) {
                            return new Warnings(properties);
                        };
    
                        /**
                         * Encodes the specified Warnings message. Does not implicitly {@link google.cloud.compute.v1small.Warnings.verify|verify} messages.
                         * @function encode
                         * @memberof google.cloud.compute.v1small.Warnings
                         * @static
                         * @param {google.cloud.compute.v1small.IWarnings} message Warnings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Warnings.encode = function encode(message, writer) {
                            if (!writer)
                                writer = $Writer.create();
                            if (message.code != null && Object.hasOwnProperty.call(message, "code"))
                                writer.uint32(/* id 3059181, wireType 2 =*/24473450).string(message.code);
                            if (message.data != null && message.data.length)
                                for (var i = 0; i < message.data.length; ++i)
                                    $root.google.cloud.compute.v1small.Data.encode(message.data[i], writer.uint32(/* id 3076010, wireType 2 =*/24608082).fork()).ldelim();
                            if (message.message != null && Object.hasOwnProperty.call(message, "message"))
                                writer.uint32(/* id 418054151, wireType 2 =*/3344433210).string(message.message);
                            return writer;
                        };
    
                        /**
                         * Encodes the specified Warnings message, length delimited. Does not implicitly {@link google.cloud.compute.v1small.Warnings.verify|verify} messages.
                         * @function encodeDelimited
                         * @memberof google.cloud.compute.v1small.Warnings
                         * @static
                         * @param {google.cloud.compute.v1small.IWarnings} message Warnings message or plain object to encode
                         * @param {$protobuf.Writer} [writer] Writer to encode to
                         * @returns {$protobuf.Writer} Writer
                         */
                        Warnings.encodeDelimited = function encodeDelimited(message, writer) {
                            return this.encode(message, writer).ldelim();
                        };
    
                        /**
                         * Decodes a Warnings message from the specified reader or buffer.
                         * @function decode
                         * @memberof google.cloud.compute.v1small.Warnings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @param {number} [length] Message length if known beforehand
                         * @returns {google.cloud.compute.v1small.Warnings} Warnings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Warnings.decode = function decode(reader, length) {
                            if (!(reader instanceof $Reader))
                                reader = $Reader.create(reader);
                            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.cloud.compute.v1small.Warnings();
                            while (reader.pos < end) {
                                var tag = reader.uint32();
                                switch (tag >>> 3) {
                                case 3059181: {
                                        message.code = reader.string();
                                        break;
                                    }
                                case 3076010: {
                                        if (!(message.data && message.data.length))
                                            message.data = [];
                                        message.data.push($root.google.cloud.compute.v1small.Data.decode(reader, reader.uint32()));
                                        break;
                                    }
                                case 418054151: {
                                        message.message = reader.string();
                                        break;
                                    }
                                default:
                                    reader.skipType(tag & 7);
                                    break;
                                }
                            }
                            return message;
                        };
    
                        /**
                         * Decodes a Warnings message from the specified reader or buffer, length delimited.
                         * @function decodeDelimited
                         * @memberof google.cloud.compute.v1small.Warnings
                         * @static
                         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                         * @returns {google.cloud.compute.v1small.Warnings} Warnings
                         * @throws {Error} If the payload is not a reader or valid buffer
                         * @throws {$protobuf.util.ProtocolError} If required fields are missing
                         */
                        Warnings.decodeDelimited = function decodeDelimited(reader) {
                            if (!(reader instanceof $Reader))
                                reader = new $Reader(reader);
                            return this.decode(reader, reader.uint32());
                        };
    
                        /**
                         * Verifies a Warnings message.
                         * @function verify
                         * @memberof google.cloud.compute.v1small.Warnings
                         * @static
                         * @param {Object.<string,*>} message Plain object to verify
                         * @returns {string|null} `null` if valid, otherwise the reason why it is not
                         */
                        Warnings.verify = function verify(message) {
                            if (typeof message !== "object" || message === null)
                                return "object expected";
                            var properties = {};
                            if (message.code != null && message.hasOwnProperty("code")) {
                                properties._code = 1;
                                if (!$util.isString(message.code))
                                    return "code: string expected";
                            }
                            if (message.data != null && message.hasOwnProperty("data")) {
                                if (!Array.isArray(message.data))
                                    return "data: array expected";
                                for (var i = 0; i < message.data.length; ++i) {
                                    var error = $root.google.cloud.compute.v1small.Data.verify(message.data[i]);
                                    if (error)
                                        return "data." + error;
                                }
                            }
                            if (message.message != null && message.hasOwnProperty("message")) {
                                properties._message = 1;
                                if (!$util.isString(message.message))
                                    return "message: string expected";
                            }
                            return null;
                        };
    
                        /**
                         * Creates a Warnings message from a plain object. Also converts values to their respective internal types.
                         * @function fromObject
                         * @memberof google.cloud.compute.v1small.Warnings
                         * @static
                         * @param {Object.<string,*>} object Plain object
                         * @returns {google.cloud.compute.v1small.Warnings} Warnings
                         */
                        Warnings.fromObject = function fromObject(object) {
                            if (object instanceof $root.google.cloud.compute.v1small.Warnings)
                                return object;
                            var message = new $root.google.cloud.compute.v1small.Warnings();
                            if (object.code != null)
                                message.code = String(object.code);
                            if (object.data) {
                                if (!Array.isArray(object.data))
                                    throw TypeError(".google.cloud.compute.v1small.Warnings.data: array expected");
                                message.data = [];
                                for (var i = 0; i < object.data.length; ++i) {
                                    if (typeof object.data[i] !== "object")
                                        throw TypeError(".google.cloud.compute.v1small.Warnings.data: object expected");
                                    message.data[i] = $root.google.cloud.compute.v1small.Data.fromObject(object.data[i]);
                                }
                            }
                            if (object.message != null)
                                message.message = String(object.message);
                            return message;
                        };
    
                        /**
                         * Creates a plain object from a Warnings message. Also converts values to other types if specified.
                         * @function toObject
                         * @memberof google.cloud.compute.v1small.Warnings
                         * @static
                         * @param {google.cloud.compute.v1small.Warnings} message Warnings
                         * @param {$protobuf.IConversionOptions} [options] Conversion options
                         * @returns {Object.<string,*>} Plain object
                         */
                        Warnings.toObject = function toObject(message, options) {
                            if (!options)
                                options = {};
                            var object = {};
                            if (options.arrays || options.defaults)
                                object.data = [];
                            if (message.code != null && message.hasOwnProperty("code")) {
                                object.code = message.code;
                                if (options.oneofs)
                                    object._code = "code";
                            }
                            if (message.data && message.data.length) {
                                object.data = [];
                                for (var j = 0; j < message.data.length; ++j)
                                    object.data[j] = $root.google.cloud.compute.v1small.Data.toObject(message.data[j], options);
                            }
                            if (message.message != null && message.hasOwnProperty("message")) {
                                object.message = message.message;
                                if (options.oneofs)
                                    object._message = "message";
                            }
                            return object;
                        };
    
                        /**
                         * Converts this Warnings to JSON.
                         * @function toJSON
                         * @memberof google.cloud.compute.v1small.Warnings
                         * @instance
                         * @returns {Object.<string,*>} JSON object
                         */
                        Warnings.prototype.toJSON = function toJSON() {
                            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                        };
    
                        /**
                         * Gets the default type url for Warnings
                         * @function getTypeUrl
                         * @memberof google.cloud.compute.v1small.Warnings
                         * @static
                         * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                         * @returns {string} The default type url
                         */
                        Warnings.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                            if (typeUrlPrefix === undefined) {
                                typeUrlPrefix = "type.googleapis.com";
                            }
                            return typeUrlPrefix + "/google.cloud.compute.v1small.Warnings";
                        };
    
                        /**
                         * Code enum.
                         * @name google.cloud.compute.v1small.Warnings.Code
                         * @enum {number}
                         * @property {number} UNDEFINED_CODE=0 UNDEFINED_CODE value
                         * @property {number} CLEANUP_FAILED=150308440 CLEANUP_FAILED value
                         * @property {number} DEPRECATED_RESOURCE_USED=391835586 DEPRECATED_RESOURCE_USED value
                         * @property {number} DEPRECATED_TYPE_USED=346526230 DEPRECATED_TYPE_USED value
                         * @property {number} DISK_SIZE_LARGER_THAN_IMAGE_SIZE=369442967 DISK_SIZE_LARGER_THAN_IMAGE_SIZE value
                         * @property {number} EXPERIMENTAL_TYPE_USED=451954443 EXPERIMENTAL_TYPE_USED value
                         * @property {number} EXTERNAL_API_WARNING=175546307 EXTERNAL_API_WARNING value
                         * @property {number} FIELD_VALUE_OVERRIDEN=329669423 FIELD_VALUE_OVERRIDEN value
                         * @property {number} INJECTED_KERNELS_DEPRECATED=417377419 INJECTED_KERNELS_DEPRECATED value
                         * @property {number} MISSING_TYPE_DEPENDENCY=344505463 MISSING_TYPE_DEPENDENCY value
                         * @property {number} NEXT_HOP_ADDRESS_NOT_ASSIGNED=324964999 NEXT_HOP_ADDRESS_NOT_ASSIGNED value
                         * @property {number} NEXT_HOP_CANNOT_IP_FORWARD=383382887 NEXT_HOP_CANNOT_IP_FORWARD value
                         * @property {number} NEXT_HOP_INSTANCE_NOT_FOUND=464250446 NEXT_HOP_INSTANCE_NOT_FOUND value
                         * @property {number} NEXT_HOP_INSTANCE_NOT_ON_NETWORK=243758146 NEXT_HOP_INSTANCE_NOT_ON_NETWORK value
                         * @property {number} NEXT_HOP_NOT_RUNNING=417081265 NEXT_HOP_NOT_RUNNING value
                         * @property {number} NOT_CRITICAL_ERROR=105763924 NOT_CRITICAL_ERROR value
                         * @property {number} NO_RESULTS_ON_PAGE=30036744 NO_RESULTS_ON_PAGE value
                         * @property {number} REQUIRED_TOS_AGREEMENT=3745539 REQUIRED_TOS_AGREEMENT value
                         * @property {number} RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING=496728641 RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING value
                         * @property {number} RESOURCE_NOT_DELETED=168598460 RESOURCE_NOT_DELETED value
                         * @property {number} SCHEMA_VALIDATION_IGNORED=275245642 SCHEMA_VALIDATION_IGNORED value
                         * @property {number} SINGLE_INSTANCE_PROPERTY_TEMPLATE=268305617 SINGLE_INSTANCE_PROPERTY_TEMPLATE value
                         * @property {number} UNDECLARED_PROPERTIES=390513439 UNDECLARED_PROPERTIES value
                         * @property {number} UNREACHABLE=13328052 UNREACHABLE value
                         */
                        Warnings.Code = (function() {
                            var valuesById = {}, values = Object.create(valuesById);
                            values[valuesById[0] = "UNDEFINED_CODE"] = 0;
                            values[valuesById[150308440] = "CLEANUP_FAILED"] = 150308440;
                            values[valuesById[391835586] = "DEPRECATED_RESOURCE_USED"] = 391835586;
                            values[valuesById[346526230] = "DEPRECATED_TYPE_USED"] = 346526230;
                            values[valuesById[369442967] = "DISK_SIZE_LARGER_THAN_IMAGE_SIZE"] = 369442967;
                            values[valuesById[451954443] = "EXPERIMENTAL_TYPE_USED"] = 451954443;
                            values[valuesById[175546307] = "EXTERNAL_API_WARNING"] = 175546307;
                            values[valuesById[329669423] = "FIELD_VALUE_OVERRIDEN"] = 329669423;
                            values[valuesById[417377419] = "INJECTED_KERNELS_DEPRECATED"] = 417377419;
                            values[valuesById[344505463] = "MISSING_TYPE_DEPENDENCY"] = 344505463;
                            values[valuesById[324964999] = "NEXT_HOP_ADDRESS_NOT_ASSIGNED"] = 324964999;
                            values[valuesById[383382887] = "NEXT_HOP_CANNOT_IP_FORWARD"] = 383382887;
                            values[valuesById[464250446] = "NEXT_HOP_INSTANCE_NOT_FOUND"] = 464250446;
                            values[valuesById[243758146] = "NEXT_HOP_INSTANCE_NOT_ON_NETWORK"] = 243758146;
                            values[valuesById[417081265] = "NEXT_HOP_NOT_RUNNING"] = 417081265;
                            values[valuesById[105763924] = "NOT_CRITICAL_ERROR"] = 105763924;
                            values[valuesById[30036744] = "NO_RESULTS_ON_PAGE"] = 30036744;
                            values[valuesById[3745539] = "REQUIRED_TOS_AGREEMENT"] = 3745539;
                            values[valuesById[496728641] = "RESOURCE_IN_USE_BY_OTHER_RESOURCE_WARNING"] = 496728641;
                            values[valuesById[168598460] = "RESOURCE_NOT_DELETED"] = 168598460;
                            values[valuesById[275245642] = "SCHEMA_VALIDATION_IGNORED"] = 275245642;
                            values[valuesById[268305617] = "SINGLE_INSTANCE_PROPERTY_TEMPLATE"] = 268305617;
                            values[valuesById[390513439] = "UNDECLARED_PROPERTIES"] = 390513439;
                            values[valuesById[13328052] = "UNREACHABLE"] = 13328052;
                            return values;
                        })();
    
                        return Warnings;
                    })();
    
                    v1small.Addresses = (function() {
    
                        /**
                         * Constructs a new Addresses service.
                         * @memberof google.cloud.compute.v1small
                         * @classdesc Represents an Addresses
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function Addresses(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (Addresses.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = Addresses;
    
                        /**
                         * Creates new Addresses service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1small.Addresses
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {Addresses} RPC service. Useful where requests and/or responses are streamed.
                         */
                        Addresses.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1small.Addresses|aggregatedList}.
                         * @memberof google.cloud.compute.v1small.Addresses
                         * @typedef AggregatedListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1small.AddressAggregatedList} [response] AddressAggregatedList
                         */
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1small.Addresses
                         * @instance
                         * @param {google.cloud.compute.v1small.IAggregatedListAddressesRequest} request AggregatedListAddressesRequest message or plain object
                         * @param {google.cloud.compute.v1small.Addresses.AggregatedListCallback} callback Node-style callback called with the error, if any, and AddressAggregatedList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Addresses.prototype.aggregatedList = function aggregatedList(request, callback) {
                            return this.rpcCall(aggregatedList, $root.google.cloud.compute.v1small.AggregatedListAddressesRequest, $root.google.cloud.compute.v1small.AddressAggregatedList, request, callback);
                        }, "name", { value: "AggregatedList" });
    
                        /**
                         * Calls AggregatedList.
                         * @function aggregatedList
                         * @memberof google.cloud.compute.v1small.Addresses
                         * @instance
                         * @param {google.cloud.compute.v1small.IAggregatedListAddressesRequest} request AggregatedListAddressesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1small.AddressAggregatedList>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1small.Addresses|delete_}.
                         * @memberof google.cloud.compute.v1small.Addresses
                         * @typedef DeleteCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1small.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1small.Addresses
                         * @instance
                         * @param {google.cloud.compute.v1small.IDeleteAddressRequest} request DeleteAddressRequest message or plain object
                         * @param {google.cloud.compute.v1small.Addresses.DeleteCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Addresses.prototype["delete"] = function delete_(request, callback) {
                            return this.rpcCall(delete_, $root.google.cloud.compute.v1small.DeleteAddressRequest, $root.google.cloud.compute.v1small.Operation, request, callback);
                        }, "name", { value: "Delete" });
    
                        /**
                         * Calls Delete.
                         * @function delete
                         * @memberof google.cloud.compute.v1small.Addresses
                         * @instance
                         * @param {google.cloud.compute.v1small.IDeleteAddressRequest} request DeleteAddressRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1small.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1small.Addresses|insert}.
                         * @memberof google.cloud.compute.v1small.Addresses
                         * @typedef InsertCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1small.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1small.Addresses
                         * @instance
                         * @param {google.cloud.compute.v1small.IInsertAddressRequest} request InsertAddressRequest message or plain object
                         * @param {google.cloud.compute.v1small.Addresses.InsertCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Addresses.prototype.insert = function insert(request, callback) {
                            return this.rpcCall(insert, $root.google.cloud.compute.v1small.InsertAddressRequest, $root.google.cloud.compute.v1small.Operation, request, callback);
                        }, "name", { value: "Insert" });
    
                        /**
                         * Calls Insert.
                         * @function insert
                         * @memberof google.cloud.compute.v1small.Addresses
                         * @instance
                         * @param {google.cloud.compute.v1small.IInsertAddressRequest} request InsertAddressRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1small.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1small.Addresses|list}.
                         * @memberof google.cloud.compute.v1small.Addresses
                         * @typedef ListCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1small.AddressList} [response] AddressList
                         */
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1small.Addresses
                         * @instance
                         * @param {google.cloud.compute.v1small.IListAddressesRequest} request ListAddressesRequest message or plain object
                         * @param {google.cloud.compute.v1small.Addresses.ListCallback} callback Node-style callback called with the error, if any, and AddressList
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(Addresses.prototype.list = function list(request, callback) {
                            return this.rpcCall(list, $root.google.cloud.compute.v1small.ListAddressesRequest, $root.google.cloud.compute.v1small.AddressList, request, callback);
                        }, "name", { value: "List" });
    
                        /**
                         * Calls List.
                         * @function list
                         * @memberof google.cloud.compute.v1small.Addresses
                         * @instance
                         * @param {google.cloud.compute.v1small.IListAddressesRequest} request ListAddressesRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1small.AddressList>} Promise
                         * @variation 2
                         */
    
                        return Addresses;
                    })();
    
                    v1small.RegionOperations = (function() {
    
                        /**
                         * Constructs a new RegionOperations service.
                         * @memberof google.cloud.compute.v1small
                         * @classdesc Represents a RegionOperations
                         * @extends $protobuf.rpc.Service
                         * @constructor
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         */
                        function RegionOperations(rpcImpl, requestDelimited, responseDelimited) {
                            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
                        }
    
                        (RegionOperations.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = RegionOperations;
    
                        /**
                         * Creates new RegionOperations service using the specified rpc implementation.
                         * @function create
                         * @memberof google.cloud.compute.v1small.RegionOperations
                         * @static
                         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
                         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
                         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
                         * @returns {RegionOperations} RPC service. Useful where requests and/or responses are streamed.
                         */
                        RegionOperations.create = function create(rpcImpl, requestDelimited, responseDelimited) {
                            return new this(rpcImpl, requestDelimited, responseDelimited);
                        };
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1small.RegionOperations|get}.
                         * @memberof google.cloud.compute.v1small.RegionOperations
                         * @typedef GetCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1small.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1small.RegionOperations
                         * @instance
                         * @param {google.cloud.compute.v1small.IGetRegionOperationRequest} request GetRegionOperationRequest message or plain object
                         * @param {google.cloud.compute.v1small.RegionOperations.GetCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionOperations.prototype.get = function get(request, callback) {
                            return this.rpcCall(get, $root.google.cloud.compute.v1small.GetRegionOperationRequest, $root.google.cloud.compute.v1small.Operation, request, callback);
                        }, "name", { value: "Get" });
    
                        /**
                         * Calls Get.
                         * @function get
                         * @memberof google.cloud.compute.v1small.RegionOperations
                         * @instance
                         * @param {google.cloud.compute.v1small.IGetRegionOperationRequest} request GetRegionOperationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1small.Operation>} Promise
                         * @variation 2
                         */
    
                        /**
                         * Callback as used by {@link google.cloud.compute.v1small.RegionOperations|wait}.
                         * @memberof google.cloud.compute.v1small.RegionOperations
                         * @typedef WaitCallback
                         * @type {function}
                         * @param {Error|null} error Error, if any
                         * @param {google.cloud.compute.v1small.Operation} [response] Operation
                         */
    
                        /**
                         * Calls Wait.
                         * @function wait
                         * @memberof google.cloud.compute.v1small.RegionOperations
                         * @instance
                         * @param {google.cloud.compute.v1small.IWaitRegionOperationRequest} request WaitRegionOperationRequest message or plain object
                         * @param {google.cloud.compute.v1small.RegionOperations.WaitCallback} callback Node-style callback called with the error, if any, and Operation
                         * @returns {undefined}
                         * @variation 1
                         */
                        Object.defineProperty(RegionOperations.prototype.wait = function wait(request, callback) {
                            return this.rpcCall(wait, $root.google.cloud.compute.v1small.WaitRegionOperationRequest, $root.google.cloud.compute.v1small.Operation, request, callback);
                        }, "name", { value: "Wait" });
    
                        /**
                         * Calls Wait.
                         * @function wait
                         * @memberof google.cloud.compute.v1small.RegionOperations
                         * @instance
                         * @param {google.cloud.compute.v1small.IWaitRegionOperationRequest} request WaitRegionOperationRequest message or plain object
                         * @returns {Promise<google.cloud.compute.v1small.Operation>} Promise
                         * @variation 2
                         */
    
                        return RegionOperations;
                    })();
    
                    return v1small;
                })();
    
                return compute;
            })();
    
            return cloud;
        })();
    
        google.api = (function() {
    
            /**
             * Namespace api.
             * @memberof google
             * @namespace
             */
            var api = {};
    
            api.Http = (function() {
    
                /**
                 * Properties of a Http.
                 * @memberof google.api
                 * @interface IHttp
                 * @property {Array.<google.api.IHttpRule>|null} [rules] Http rules
                 * @property {boolean|null} [fullyDecodeReservedExpansion] Http fullyDecodeReservedExpansion
                 */
    
                /**
                 * Constructs a new Http.
                 * @memberof google.api
                 * @classdesc Represents a Http.
                 * @implements IHttp
                 * @constructor
                 * @param {google.api.IHttp=} [properties] Properties to set
                 */
                function Http(properties) {
                    this.rules = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * Http rules.
                 * @member {Array.<google.api.IHttpRule>} rules
                 * @memberof google.api.Http
                 * @instance
                 */
                Http.prototype.rules = $util.emptyArray;
    
                /**
                 * Http fullyDecodeReservedExpansion.
                 * @member {boolean} fullyDecodeReservedExpansion
                 * @memberof google.api.Http
                 * @instance
                 */
                Http.prototype.fullyDecodeReservedExpansion = false;
    
                /**
                 * Creates a new Http instance using the specified properties.
                 * @function create
                 * @memberof google.api.Http
                 * @static
                 * @param {google.api.IHttp=} [properties] Properties to set
                 * @returns {google.api.Http} Http instance
                 */
                Http.create = function create(properties) {
                    return new Http(properties);
                };
    
                /**
                 * Encodes the specified Http message. Does not implicitly {@link google.api.Http.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.Http
                 * @static
                 * @param {google.api.IHttp} message Http message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Http.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.rules != null && message.rules.length)
                        for (var i = 0; i < message.rules.length; ++i)
                            $root.google.api.HttpRule.encode(message.rules[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                    if (message.fullyDecodeReservedExpansion != null && Object.hasOwnProperty.call(message, "fullyDecodeReservedExpansion"))
                        writer.uint32(/* id 2, wireType 0 =*/16).bool(message.fullyDecodeReservedExpansion);
                    return writer;
                };
    
                /**
                 * Encodes the specified Http message, length delimited. Does not implicitly {@link google.api.Http.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.Http
                 * @static
                 * @param {google.api.IHttp} message Http message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Http.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a Http message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.Http
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.Http} Http
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Http.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.Http();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                if (!(message.rules && message.rules.length))
                                    message.rules = [];
                                message.rules.push($root.google.api.HttpRule.decode(reader, reader.uint32()));
                                break;
                            }
                        case 2: {
                                message.fullyDecodeReservedExpansion = reader.bool();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a Http message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.Http
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.Http} Http
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Http.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a Http message.
                 * @function verify
                 * @memberof google.api.Http
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                Http.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.rules != null && message.hasOwnProperty("rules")) {
                        if (!Array.isArray(message.rules))
                            return "rules: array expected";
                        for (var i = 0; i < message.rules.length; ++i) {
                            var error = $root.google.api.HttpRule.verify(message.rules[i]);
                            if (error)
                                return "rules." + error;
                        }
                    }
                    if (message.fullyDecodeReservedExpansion != null && message.hasOwnProperty("fullyDecodeReservedExpansion"))
                        if (typeof message.fullyDecodeReservedExpansion !== "boolean")
                            return "fullyDecodeReservedExpansion: boolean expected";
                    return null;
                };
    
                /**
                 * Creates a Http message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.Http
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.Http} Http
                 */
                Http.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.Http)
                        return object;
                    var message = new $root.google.api.Http();
                    if (object.rules) {
                        if (!Array.isArray(object.rules))
                            throw TypeError(".google.api.Http.rules: array expected");
                        message.rules = [];
                        for (var i = 0; i < object.rules.length; ++i) {
                            if (typeof object.rules[i] !== "object")
                                throw TypeError(".google.api.Http.rules: object expected");
                            message.rules[i] = $root.google.api.HttpRule.fromObject(object.rules[i]);
                        }
                    }
                    if (object.fullyDecodeReservedExpansion != null)
                        message.fullyDecodeReservedExpansion = Boolean(object.fullyDecodeReservedExpansion);
                    return message;
                };
    
                /**
                 * Creates a plain object from a Http message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.Http
                 * @static
                 * @param {google.api.Http} message Http
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                Http.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.rules = [];
                    if (options.defaults)
                        object.fullyDecodeReservedExpansion = false;
                    if (message.rules && message.rules.length) {
                        object.rules = [];
                        for (var j = 0; j < message.rules.length; ++j)
                            object.rules[j] = $root.google.api.HttpRule.toObject(message.rules[j], options);
                    }
                    if (message.fullyDecodeReservedExpansion != null && message.hasOwnProperty("fullyDecodeReservedExpansion"))
                        object.fullyDecodeReservedExpansion = message.fullyDecodeReservedExpansion;
                    return object;
                };
    
                /**
                 * Converts this Http to JSON.
                 * @function toJSON
                 * @memberof google.api.Http
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                Http.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for Http
                 * @function getTypeUrl
                 * @memberof google.api.Http
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                Http.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.Http";
                };
    
                return Http;
            })();
    
            api.HttpRule = (function() {
    
                /**
                 * Properties of a HttpRule.
                 * @memberof google.api
                 * @interface IHttpRule
                 * @property {string|null} [selector] HttpRule selector
                 * @property {string|null} [get] HttpRule get
                 * @property {string|null} [put] HttpRule put
                 * @property {string|null} [post] HttpRule post
                 * @property {string|null} ["delete"] HttpRule delete
                 * @property {string|null} [patch] HttpRule patch
                 * @property {google.api.ICustomHttpPattern|null} [custom] HttpRule custom
                 * @property {string|null} [body] HttpRule body
                 * @property {string|null} [responseBody] HttpRule responseBody
                 * @property {Array.<google.api.IHttpRule>|null} [additionalBindings] HttpRule additionalBindings
                 */
    
                /**
                 * Constructs a new HttpRule.
                 * @memberof google.api
                 * @classdesc Represents a HttpRule.
                 * @implements IHttpRule
                 * @constructor
                 * @param {google.api.IHttpRule=} [properties] Properties to set
                 */
                function HttpRule(properties) {
                    this.additionalBindings = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * HttpRule selector.
                 * @member {string} selector
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                HttpRule.prototype.selector = "";
    
                /**
                 * HttpRule get.
                 * @member {string|null|undefined} get
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                HttpRule.prototype.get = null;
    
                /**
                 * HttpRule put.
                 * @member {string|null|undefined} put
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                HttpRule.prototype.put = null;
    
                /**
                 * HttpRule post.
                 * @member {string|null|undefined} post
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                HttpRule.prototype.post = null;
    
                /**
                 * HttpRule delete.
                 * @member {string|null|undefined} delete
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                HttpRule.prototype["delete"] = null;
    
                /**
                 * HttpRule patch.
                 * @member {string|null|undefined} patch
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                HttpRule.prototype.patch = null;
    
                /**
                 * HttpRule custom.
                 * @member {google.api.ICustomHttpPattern|null|undefined} custom
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                HttpRule.prototype.custom = null;
    
                /**
                 * HttpRule body.
                 * @member {string} body
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                HttpRule.prototype.body = "";
    
                /**
                 * HttpRule responseBody.
                 * @member {string} responseBody
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                HttpRule.prototype.responseBody = "";
    
                /**
                 * HttpRule additionalBindings.
                 * @member {Array.<google.api.IHttpRule>} additionalBindings
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                HttpRule.prototype.additionalBindings = $util.emptyArray;
    
                // OneOf field names bound to virtual getters and setters
                var $oneOfFields;
    
                /**
                 * HttpRule pattern.
                 * @member {"get"|"put"|"post"|"delete"|"patch"|"custom"|undefined} pattern
                 * @memberof google.api.HttpRule
                 * @instance
                 */
                Object.defineProperty(HttpRule.prototype, "pattern", {
                    get: $util.oneOfGetter($oneOfFields = ["get", "put", "post", "delete", "patch", "custom"]),
                    set: $util.oneOfSetter($oneOfFields)
                });
    
                /**
                 * Creates a new HttpRule instance using the specified properties.
                 * @function create
                 * @memberof google.api.HttpRule
                 * @static
                 * @param {google.api.IHttpRule=} [properties] Properties to set
                 * @returns {google.api.HttpRule} HttpRule instance
                 */
                HttpRule.create = function create(properties) {
                    return new HttpRule(properties);
                };
    
                /**
                 * Encodes the specified HttpRule message. Does not implicitly {@link google.api.HttpRule.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.HttpRule
                 * @static
                 * @param {google.api.IHttpRule} message HttpRule message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                HttpRule.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.selector != null && Object.hasOwnProperty.call(message, "selector"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.selector);
                    if (message.get != null && Object.hasOwnProperty.call(message, "get"))
                        writer.uint32(/* id 2, wireType 2 =*/18).string(message.get);
                    if (message.put != null && Object.hasOwnProperty.call(message, "put"))
                        writer.uint32(/* id 3, wireType 2 =*/26).string(message.put);
                    if (message.post != null && Object.hasOwnProperty.call(message, "post"))
                        writer.uint32(/* id 4, wireType 2 =*/34).string(message.post);
                    if (message["delete"] != null && Object.hasOwnProperty.call(message, "delete"))
                        writer.uint32(/* id 5, wireType 2 =*/42).string(message["delete"]);
                    if (message.patch != null && Object.hasOwnProperty.call(message, "patch"))
                        writer.uint32(/* id 6, wireType 2 =*/50).string(message.patch);
                    if (message.body != null && Object.hasOwnProperty.call(message, "body"))
                        writer.uint32(/* id 7, wireType 2 =*/58).string(message.body);
                    if (message.custom != null && Object.hasOwnProperty.call(message, "custom"))
                        $root.google.api.CustomHttpPattern.encode(message.custom, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                    if (message.additionalBindings != null && message.additionalBindings.length)
                        for (var i = 0; i < message.additionalBindings.length; ++i)
                            $root.google.api.HttpRule.encode(message.additionalBindings[i], writer.uint32(/* id 11, wireType 2 =*/90).fork()).ldelim();
                    if (message.responseBody != null && Object.hasOwnProperty.call(message, "responseBody"))
                        writer.uint32(/* id 12, wireType 2 =*/98).string(message.responseBody);
                    return writer;
                };
    
                /**
                 * Encodes the specified HttpRule message, length delimited. Does not implicitly {@link google.api.HttpRule.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.HttpRule
                 * @static
                 * @param {google.api.IHttpRule} message HttpRule message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                HttpRule.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a HttpRule message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.HttpRule
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.HttpRule} HttpRule
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                HttpRule.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.HttpRule();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.selector = reader.string();
                                break;
                            }
                        case 2: {
                                message.get = reader.string();
                                break;
                            }
                        case 3: {
                                message.put = reader.string();
                                break;
                            }
                        case 4: {
                                message.post = reader.string();
                                break;
                            }
                        case 5: {
                                message["delete"] = reader.string();
                                break;
                            }
                        case 6: {
                                message.patch = reader.string();
                                break;
                            }
                        case 8: {
                                message.custom = $root.google.api.CustomHttpPattern.decode(reader, reader.uint32());
                                break;
                            }
                        case 7: {
                                message.body = reader.string();
                                break;
                            }
                        case 12: {
                                message.responseBody = reader.string();
                                break;
                            }
                        case 11: {
                                if (!(message.additionalBindings && message.additionalBindings.length))
                                    message.additionalBindings = [];
                                message.additionalBindings.push($root.google.api.HttpRule.decode(reader, reader.uint32()));
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a HttpRule message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.HttpRule
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.HttpRule} HttpRule
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                HttpRule.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a HttpRule message.
                 * @function verify
                 * @memberof google.api.HttpRule
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                HttpRule.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    var properties = {};
                    if (message.selector != null && message.hasOwnProperty("selector"))
                        if (!$util.isString(message.selector))
                            return "selector: string expected";
                    if (message.get != null && message.hasOwnProperty("get")) {
                        properties.pattern = 1;
                        if (!$util.isString(message.get))
                            return "get: string expected";
                    }
                    if (message.put != null && message.hasOwnProperty("put")) {
                        if (properties.pattern === 1)
                            return "pattern: multiple values";
                        properties.pattern = 1;
                        if (!$util.isString(message.put))
                            return "put: string expected";
                    }
                    if (message.post != null && message.hasOwnProperty("post")) {
                        if (properties.pattern === 1)
                            return "pattern: multiple values";
                        properties.pattern = 1;
                        if (!$util.isString(message.post))
                            return "post: string expected";
                    }
                    if (message["delete"] != null && message.hasOwnProperty("delete")) {
                        if (properties.pattern === 1)
                            return "pattern: multiple values";
                        properties.pattern = 1;
                        if (!$util.isString(message["delete"]))
                            return "delete: string expected";
                    }
                    if (message.patch != null && message.hasOwnProperty("patch")) {
                        if (properties.pattern === 1)
                            return "pattern: multiple values";
                        properties.pattern = 1;
                        if (!$util.isString(message.patch))
                            return "patch: string expected";
                    }
                    if (message.custom != null && message.hasOwnProperty("custom")) {
                        if (properties.pattern === 1)
                            return "pattern: multiple values";
                        properties.pattern = 1;
                        {
                            var error = $root.google.api.CustomHttpPattern.verify(message.custom);
                            if (error)
                                return "custom." + error;
                        }
                    }
                    if (message.body != null && message.hasOwnProperty("body"))
                        if (!$util.isString(message.body))
                            return "body: string expected";
                    if (message.responseBody != null && message.hasOwnProperty("responseBody"))
                        if (!$util.isString(message.responseBody))
                            return "responseBody: string expected";
                    if (message.additionalBindings != null && message.hasOwnProperty("additionalBindings")) {
                        if (!Array.isArray(message.additionalBindings))
                            return "additionalBindings: array expected";
                        for (var i = 0; i < message.additionalBindings.length; ++i) {
                            var error = $root.google.api.HttpRule.verify(message.additionalBindings[i]);
                            if (error)
                                return "additionalBindings." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates a HttpRule message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.HttpRule
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.HttpRule} HttpRule
                 */
                HttpRule.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.HttpRule)
                        return object;
                    var message = new $root.google.api.HttpRule();
                    if (object.selector != null)
                        message.selector = String(object.selector);
                    if (object.get != null)
                        message.get = String(object.get);
                    if (object.put != null)
                        message.put = String(object.put);
                    if (object.post != null)
                        message.post = String(object.post);
                    if (object["delete"] != null)
                        message["delete"] = String(object["delete"]);
                    if (object.patch != null)
                        message.patch = String(object.patch);
                    if (object.custom != null) {
                        if (typeof object.custom !== "object")
                            throw TypeError(".google.api.HttpRule.custom: object expected");
                        message.custom = $root.google.api.CustomHttpPattern.fromObject(object.custom);
                    }
                    if (object.body != null)
                        message.body = String(object.body);
                    if (object.responseBody != null)
                        message.responseBody = String(object.responseBody);
                    if (object.additionalBindings) {
                        if (!Array.isArray(object.additionalBindings))
                            throw TypeError(".google.api.HttpRule.additionalBindings: array expected");
                        message.additionalBindings = [];
                        for (var i = 0; i < object.additionalBindings.length; ++i) {
                            if (typeof object.additionalBindings[i] !== "object")
                                throw TypeError(".google.api.HttpRule.additionalBindings: object expected");
                            message.additionalBindings[i] = $root.google.api.HttpRule.fromObject(object.additionalBindings[i]);
                        }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a HttpRule message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.HttpRule
                 * @static
                 * @param {google.api.HttpRule} message HttpRule
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                HttpRule.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.additionalBindings = [];
                    if (options.defaults) {
                        object.selector = "";
                        object.body = "";
                        object.responseBody = "";
                    }
                    if (message.selector != null && message.hasOwnProperty("selector"))
                        object.selector = message.selector;
                    if (message.get != null && message.hasOwnProperty("get")) {
                        object.get = message.get;
                        if (options.oneofs)
                            object.pattern = "get";
                    }
                    if (message.put != null && message.hasOwnProperty("put")) {
                        object.put = message.put;
                        if (options.oneofs)
                            object.pattern = "put";
                    }
                    if (message.post != null && message.hasOwnProperty("post")) {
                        object.post = message.post;
                        if (options.oneofs)
                            object.pattern = "post";
                    }
                    if (message["delete"] != null && message.hasOwnProperty("delete")) {
                        object["delete"] = message["delete"];
                        if (options.oneofs)
                            object.pattern = "delete";
                    }
                    if (message.patch != null && message.hasOwnProperty("patch")) {
                        object.patch = message.patch;
                        if (options.oneofs)
                            object.pattern = "patch";
                    }
                    if (message.body != null && message.hasOwnProperty("body"))
                        object.body = message.body;
                    if (message.custom != null && message.hasOwnProperty("custom")) {
                        object.custom = $root.google.api.CustomHttpPattern.toObject(message.custom, options);
                        if (options.oneofs)
                            object.pattern = "custom";
                    }
                    if (message.additionalBindings && message.additionalBindings.length) {
                        object.additionalBindings = [];
                        for (var j = 0; j < message.additionalBindings.length; ++j)
                            object.additionalBindings[j] = $root.google.api.HttpRule.toObject(message.additionalBindings[j], options);
                    }
                    if (message.responseBody != null && message.hasOwnProperty("responseBody"))
                        object.responseBody = message.responseBody;
                    return object;
                };
    
                /**
                 * Converts this HttpRule to JSON.
                 * @function toJSON
                 * @memberof google.api.HttpRule
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                HttpRule.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for HttpRule
                 * @function getTypeUrl
                 * @memberof google.api.HttpRule
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                HttpRule.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.HttpRule";
                };
    
                return HttpRule;
            })();
    
            api.CustomHttpPattern = (function() {
    
                /**
                 * Properties of a CustomHttpPattern.
                 * @memberof google.api
                 * @interface ICustomHttpPattern
                 * @property {string|null} [kind] CustomHttpPattern kind
                 * @property {string|null} [path] CustomHttpPattern path
                 */
    
                /**
                 * Constructs a new CustomHttpPattern.
                 * @memberof google.api
                 * @classdesc Represents a CustomHttpPattern.
                 * @implements ICustomHttpPattern
                 * @constructor
                 * @param {google.api.ICustomHttpPattern=} [properties] Properties to set
                 */
                function CustomHttpPattern(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * CustomHttpPattern kind.
                 * @member {string} kind
                 * @memberof google.api.CustomHttpPattern
                 * @instance
                 */
                CustomHttpPattern.prototype.kind = "";
    
                /**
                 * CustomHttpPattern path.
                 * @member {string} path
                 * @memberof google.api.CustomHttpPattern
                 * @instance
                 */
                CustomHttpPattern.prototype.path = "";
    
                /**
                 * Creates a new CustomHttpPattern instance using the specified properties.
                 * @function create
                 * @memberof google.api.CustomHttpPattern
                 * @static
                 * @param {google.api.ICustomHttpPattern=} [properties] Properties to set
                 * @returns {google.api.CustomHttpPattern} CustomHttpPattern instance
                 */
                CustomHttpPattern.create = function create(properties) {
                    return new CustomHttpPattern(properties);
                };
    
                /**
                 * Encodes the specified CustomHttpPattern message. Does not implicitly {@link google.api.CustomHttpPattern.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.CustomHttpPattern
                 * @static
                 * @param {google.api.ICustomHttpPattern} message CustomHttpPattern message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                CustomHttpPattern.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.kind != null && Object.hasOwnProperty.call(message, "kind"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.kind);
                    if (message.path != null && Object.hasOwnProperty.call(message, "path"))
                        writer.uint32(/* id 2, wireType 2 =*/18).string(message.path);
                    return writer;
                };
    
                /**
                 * Encodes the specified CustomHttpPattern message, length delimited. Does not implicitly {@link google.api.CustomHttpPattern.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.CustomHttpPattern
                 * @static
                 * @param {google.api.ICustomHttpPattern} message CustomHttpPattern message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                CustomHttpPattern.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a CustomHttpPattern message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.CustomHttpPattern
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.CustomHttpPattern} CustomHttpPattern
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                CustomHttpPattern.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.CustomHttpPattern();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.kind = reader.string();
                                break;
                            }
                        case 2: {
                                message.path = reader.string();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a CustomHttpPattern message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.CustomHttpPattern
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.CustomHttpPattern} CustomHttpPattern
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                CustomHttpPattern.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a CustomHttpPattern message.
                 * @function verify
                 * @memberof google.api.CustomHttpPattern
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                CustomHttpPattern.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.kind != null && message.hasOwnProperty("kind"))
                        if (!$util.isString(message.kind))
                            return "kind: string expected";
                    if (message.path != null && message.hasOwnProperty("path"))
                        if (!$util.isString(message.path))
                            return "path: string expected";
                    return null;
                };
    
                /**
                 * Creates a CustomHttpPattern message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.CustomHttpPattern
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.CustomHttpPattern} CustomHttpPattern
                 */
                CustomHttpPattern.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.CustomHttpPattern)
                        return object;
                    var message = new $root.google.api.CustomHttpPattern();
                    if (object.kind != null)
                        message.kind = String(object.kind);
                    if (object.path != null)
                        message.path = String(object.path);
                    return message;
                };
    
                /**
                 * Creates a plain object from a CustomHttpPattern message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.CustomHttpPattern
                 * @static
                 * @param {google.api.CustomHttpPattern} message CustomHttpPattern
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                CustomHttpPattern.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.kind = "";
                        object.path = "";
                    }
                    if (message.kind != null && message.hasOwnProperty("kind"))
                        object.kind = message.kind;
                    if (message.path != null && message.hasOwnProperty("path"))
                        object.path = message.path;
                    return object;
                };
    
                /**
                 * Converts this CustomHttpPattern to JSON.
                 * @function toJSON
                 * @memberof google.api.CustomHttpPattern
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                CustomHttpPattern.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for CustomHttpPattern
                 * @function getTypeUrl
                 * @memberof google.api.CustomHttpPattern
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                CustomHttpPattern.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.CustomHttpPattern";
                };
    
                return CustomHttpPattern;
            })();
    
            /**
             * FieldBehavior enum.
             * @name google.api.FieldBehavior
             * @enum {number}
             * @property {number} FIELD_BEHAVIOR_UNSPECIFIED=0 FIELD_BEHAVIOR_UNSPECIFIED value
             * @property {number} OPTIONAL=1 OPTIONAL value
             * @property {number} REQUIRED=2 REQUIRED value
             * @property {number} OUTPUT_ONLY=3 OUTPUT_ONLY value
             * @property {number} INPUT_ONLY=4 INPUT_ONLY value
             * @property {number} IMMUTABLE=5 IMMUTABLE value
             * @property {number} UNORDERED_LIST=6 UNORDERED_LIST value
             * @property {number} NON_EMPTY_DEFAULT=7 NON_EMPTY_DEFAULT value
             */
            api.FieldBehavior = (function() {
                var valuesById = {}, values = Object.create(valuesById);
                values[valuesById[0] = "FIELD_BEHAVIOR_UNSPECIFIED"] = 0;
                values[valuesById[1] = "OPTIONAL"] = 1;
                values[valuesById[2] = "REQUIRED"] = 2;
                values[valuesById[3] = "OUTPUT_ONLY"] = 3;
                values[valuesById[4] = "INPUT_ONLY"] = 4;
                values[valuesById[5] = "IMMUTABLE"] = 5;
                values[valuesById[6] = "UNORDERED_LIST"] = 6;
                values[valuesById[7] = "NON_EMPTY_DEFAULT"] = 7;
                return values;
            })();
    
            api.ResourceDescriptor = (function() {
    
                /**
                 * Properties of a ResourceDescriptor.
                 * @memberof google.api
                 * @interface IResourceDescriptor
                 * @property {string|null} [type] ResourceDescriptor type
                 * @property {Array.<string>|null} [pattern] ResourceDescriptor pattern
                 * @property {string|null} [nameField] ResourceDescriptor nameField
                 * @property {google.api.ResourceDescriptor.History|null} [history] ResourceDescriptor history
                 * @property {string|null} [plural] ResourceDescriptor plural
                 * @property {string|null} [singular] ResourceDescriptor singular
                 * @property {Array.<google.api.ResourceDescriptor.Style>|null} [style] ResourceDescriptor style
                 */
    
                /**
                 * Constructs a new ResourceDescriptor.
                 * @memberof google.api
                 * @classdesc Represents a ResourceDescriptor.
                 * @implements IResourceDescriptor
                 * @constructor
                 * @param {google.api.IResourceDescriptor=} [properties] Properties to set
                 */
                function ResourceDescriptor(properties) {
                    this.pattern = [];
                    this.style = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * ResourceDescriptor type.
                 * @member {string} type
                 * @memberof google.api.ResourceDescriptor
                 * @instance
                 */
                ResourceDescriptor.prototype.type = "";
    
                /**
                 * ResourceDescriptor pattern.
                 * @member {Array.<string>} pattern
                 * @memberof google.api.ResourceDescriptor
                 * @instance
                 */
                ResourceDescriptor.prototype.pattern = $util.emptyArray;
    
                /**
                 * ResourceDescriptor nameField.
                 * @member {string} nameField
                 * @memberof google.api.ResourceDescriptor
                 * @instance
                 */
                ResourceDescriptor.prototype.nameField = "";
    
                /**
                 * ResourceDescriptor history.
                 * @member {google.api.ResourceDescriptor.History} history
                 * @memberof google.api.ResourceDescriptor
                 * @instance
                 */
                ResourceDescriptor.prototype.history = 0;
    
                /**
                 * ResourceDescriptor plural.
                 * @member {string} plural
                 * @memberof google.api.ResourceDescriptor
                 * @instance
                 */
                ResourceDescriptor.prototype.plural = "";
    
                /**
                 * ResourceDescriptor singular.
                 * @member {string} singular
                 * @memberof google.api.ResourceDescriptor
                 * @instance
                 */
                ResourceDescriptor.prototype.singular = "";
    
                /**
                 * ResourceDescriptor style.
                 * @member {Array.<google.api.ResourceDescriptor.Style>} style
                 * @memberof google.api.ResourceDescriptor
                 * @instance
                 */
                ResourceDescriptor.prototype.style = $util.emptyArray;
    
                /**
                 * Creates a new ResourceDescriptor instance using the specified properties.
                 * @function create
                 * @memberof google.api.ResourceDescriptor
                 * @static
                 * @param {google.api.IResourceDescriptor=} [properties] Properties to set
                 * @returns {google.api.ResourceDescriptor} ResourceDescriptor instance
                 */
                ResourceDescriptor.create = function create(properties) {
                    return new ResourceDescriptor(properties);
                };
    
                /**
                 * Encodes the specified ResourceDescriptor message. Does not implicitly {@link google.api.ResourceDescriptor.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.ResourceDescriptor
                 * @static
                 * @param {google.api.IResourceDescriptor} message ResourceDescriptor message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ResourceDescriptor.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.type);
                    if (message.pattern != null && message.pattern.length)
                        for (var i = 0; i < message.pattern.length; ++i)
                            writer.uint32(/* id 2, wireType 2 =*/18).string(message.pattern[i]);
                    if (message.nameField != null && Object.hasOwnProperty.call(message, "nameField"))
                        writer.uint32(/* id 3, wireType 2 =*/26).string(message.nameField);
                    if (message.history != null && Object.hasOwnProperty.call(message, "history"))
                        writer.uint32(/* id 4, wireType 0 =*/32).int32(message.history);
                    if (message.plural != null && Object.hasOwnProperty.call(message, "plural"))
                        writer.uint32(/* id 5, wireType 2 =*/42).string(message.plural);
                    if (message.singular != null && Object.hasOwnProperty.call(message, "singular"))
                        writer.uint32(/* id 6, wireType 2 =*/50).string(message.singular);
                    if (message.style != null && message.style.length) {
                        writer.uint32(/* id 10, wireType 2 =*/82).fork();
                        for (var i = 0; i < message.style.length; ++i)
                            writer.int32(message.style[i]);
                        writer.ldelim();
                    }
                    return writer;
                };
    
                /**
                 * Encodes the specified ResourceDescriptor message, length delimited. Does not implicitly {@link google.api.ResourceDescriptor.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.ResourceDescriptor
                 * @static
                 * @param {google.api.IResourceDescriptor} message ResourceDescriptor message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ResourceDescriptor.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a ResourceDescriptor message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.ResourceDescriptor
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.ResourceDescriptor} ResourceDescriptor
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ResourceDescriptor.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.ResourceDescriptor();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.type = reader.string();
                                break;
                            }
                        case 2: {
                                if (!(message.pattern && message.pattern.length))
                                    message.pattern = [];
                                message.pattern.push(reader.string());
                                break;
                            }
                        case 3: {
                                message.nameField = reader.string();
                                break;
                            }
                        case 4: {
                                message.history = reader.int32();
                                break;
                            }
                        case 5: {
                                message.plural = reader.string();
                                break;
                            }
                        case 6: {
                                message.singular = reader.string();
                                break;
                            }
                        case 10: {
                                if (!(message.style && message.style.length))
                                    message.style = [];
                                if ((tag & 7) === 2) {
                                    var end2 = reader.uint32() + reader.pos;
                                    while (reader.pos < end2)
                                        message.style.push(reader.int32());
                                } else
                                    message.style.push(reader.int32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a ResourceDescriptor message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.ResourceDescriptor
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.ResourceDescriptor} ResourceDescriptor
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ResourceDescriptor.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a ResourceDescriptor message.
                 * @function verify
                 * @memberof google.api.ResourceDescriptor
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                ResourceDescriptor.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.type != null && message.hasOwnProperty("type"))
                        if (!$util.isString(message.type))
                            return "type: string expected";
                    if (message.pattern != null && message.hasOwnProperty("pattern")) {
                        if (!Array.isArray(message.pattern))
                            return "pattern: array expected";
                        for (var i = 0; i < message.pattern.length; ++i)
                            if (!$util.isString(message.pattern[i]))
                                return "pattern: string[] expected";
                    }
                    if (message.nameField != null && message.hasOwnProperty("nameField"))
                        if (!$util.isString(message.nameField))
                            return "nameField: string expected";
                    if (message.history != null && message.hasOwnProperty("history"))
                        switch (message.history) {
                        default:
                            return "history: enum value expected";
                        case 0:
                        case 1:
                        case 2:
                            break;
                        }
                    if (message.plural != null && message.hasOwnProperty("plural"))
                        if (!$util.isString(message.plural))
                            return "plural: string expected";
                    if (message.singular != null && message.hasOwnProperty("singular"))
                        if (!$util.isString(message.singular))
                            return "singular: string expected";
                    if (message.style != null && message.hasOwnProperty("style")) {
                        if (!Array.isArray(message.style))
                            return "style: array expected";
                        for (var i = 0; i < message.style.length; ++i)
                            switch (message.style[i]) {
                            default:
                                return "style: enum value[] expected";
                            case 0:
                            case 1:
                                break;
                            }
                    }
                    return null;
                };
    
                /**
                 * Creates a ResourceDescriptor message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.ResourceDescriptor
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.ResourceDescriptor} ResourceDescriptor
                 */
                ResourceDescriptor.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.ResourceDescriptor)
                        return object;
                    var message = new $root.google.api.ResourceDescriptor();
                    if (object.type != null)
                        message.type = String(object.type);
                    if (object.pattern) {
                        if (!Array.isArray(object.pattern))
                            throw TypeError(".google.api.ResourceDescriptor.pattern: array expected");
                        message.pattern = [];
                        for (var i = 0; i < object.pattern.length; ++i)
                            message.pattern[i] = String(object.pattern[i]);
                    }
                    if (object.nameField != null)
                        message.nameField = String(object.nameField);
                    switch (object.history) {
                    default:
                        if (typeof object.history === "number") {
                            message.history = object.history;
                            break;
                        }
                        break;
                    case "HISTORY_UNSPECIFIED":
                    case 0:
                        message.history = 0;
                        break;
                    case "ORIGINALLY_SINGLE_PATTERN":
                    case 1:
                        message.history = 1;
                        break;
                    case "FUTURE_MULTI_PATTERN":
                    case 2:
                        message.history = 2;
                        break;
                    }
                    if (object.plural != null)
                        message.plural = String(object.plural);
                    if (object.singular != null)
                        message.singular = String(object.singular);
                    if (object.style) {
                        if (!Array.isArray(object.style))
                            throw TypeError(".google.api.ResourceDescriptor.style: array expected");
                        message.style = [];
                        for (var i = 0; i < object.style.length; ++i)
                            switch (object.style[i]) {
                            default:
                                if (typeof object.style[i] === "number") {
                                    message.style[i] = object.style[i];
                                    break;
                                }
                            case "STYLE_UNSPECIFIED":
                            case 0:
                                message.style[i] = 0;
                                break;
                            case "DECLARATIVE_FRIENDLY":
                            case 1:
                                message.style[i] = 1;
                                break;
                            }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a ResourceDescriptor message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.ResourceDescriptor
                 * @static
                 * @param {google.api.ResourceDescriptor} message ResourceDescriptor
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                ResourceDescriptor.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults) {
                        object.pattern = [];
                        object.style = [];
                    }
                    if (options.defaults) {
                        object.type = "";
                        object.nameField = "";
                        object.history = options.enums === String ? "HISTORY_UNSPECIFIED" : 0;
                        object.plural = "";
                        object.singular = "";
                    }
                    if (message.type != null && message.hasOwnProperty("type"))
                        object.type = message.type;
                    if (message.pattern && message.pattern.length) {
                        object.pattern = [];
                        for (var j = 0; j < message.pattern.length; ++j)
                            object.pattern[j] = message.pattern[j];
                    }
                    if (message.nameField != null && message.hasOwnProperty("nameField"))
                        object.nameField = message.nameField;
                    if (message.history != null && message.hasOwnProperty("history"))
                        object.history = options.enums === String ? $root.google.api.ResourceDescriptor.History[message.history] === undefined ? message.history : $root.google.api.ResourceDescriptor.History[message.history] : message.history;
                    if (message.plural != null && message.hasOwnProperty("plural"))
                        object.plural = message.plural;
                    if (message.singular != null && message.hasOwnProperty("singular"))
                        object.singular = message.singular;
                    if (message.style && message.style.length) {
                        object.style = [];
                        for (var j = 0; j < message.style.length; ++j)
                            object.style[j] = options.enums === String ? $root.google.api.ResourceDescriptor.Style[message.style[j]] === undefined ? message.style[j] : $root.google.api.ResourceDescriptor.Style[message.style[j]] : message.style[j];
                    }
                    return object;
                };
    
                /**
                 * Converts this ResourceDescriptor to JSON.
                 * @function toJSON
                 * @memberof google.api.ResourceDescriptor
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                ResourceDescriptor.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for ResourceDescriptor
                 * @function getTypeUrl
                 * @memberof google.api.ResourceDescriptor
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                ResourceDescriptor.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.ResourceDescriptor";
                };
    
                /**
                 * History enum.
                 * @name google.api.ResourceDescriptor.History
                 * @enum {number}
                 * @property {number} HISTORY_UNSPECIFIED=0 HISTORY_UNSPECIFIED value
                 * @property {number} ORIGINALLY_SINGLE_PATTERN=1 ORIGINALLY_SINGLE_PATTERN value
                 * @property {number} FUTURE_MULTI_PATTERN=2 FUTURE_MULTI_PATTERN value
                 */
                ResourceDescriptor.History = (function() {
                    var valuesById = {}, values = Object.create(valuesById);
                    values[valuesById[0] = "HISTORY_UNSPECIFIED"] = 0;
                    values[valuesById[1] = "ORIGINALLY_SINGLE_PATTERN"] = 1;
                    values[valuesById[2] = "FUTURE_MULTI_PATTERN"] = 2;
                    return values;
                })();
    
                /**
                 * Style enum.
                 * @name google.api.ResourceDescriptor.Style
                 * @enum {number}
                 * @property {number} STYLE_UNSPECIFIED=0 STYLE_UNSPECIFIED value
                 * @property {number} DECLARATIVE_FRIENDLY=1 DECLARATIVE_FRIENDLY value
                 */
                ResourceDescriptor.Style = (function() {
                    var valuesById = {}, values = Object.create(valuesById);
                    values[valuesById[0] = "STYLE_UNSPECIFIED"] = 0;
                    values[valuesById[1] = "DECLARATIVE_FRIENDLY"] = 1;
                    return values;
                })();
    
                return ResourceDescriptor;
            })();
    
            api.ResourceReference = (function() {
    
                /**
                 * Properties of a ResourceReference.
                 * @memberof google.api
                 * @interface IResourceReference
                 * @property {string|null} [type] ResourceReference type
                 * @property {string|null} [childType] ResourceReference childType
                 */
    
                /**
                 * Constructs a new ResourceReference.
                 * @memberof google.api
                 * @classdesc Represents a ResourceReference.
                 * @implements IResourceReference
                 * @constructor
                 * @param {google.api.IResourceReference=} [properties] Properties to set
                 */
                function ResourceReference(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * ResourceReference type.
                 * @member {string} type
                 * @memberof google.api.ResourceReference
                 * @instance
                 */
                ResourceReference.prototype.type = "";
    
                /**
                 * ResourceReference childType.
                 * @member {string} childType
                 * @memberof google.api.ResourceReference
                 * @instance
                 */
                ResourceReference.prototype.childType = "";
    
                /**
                 * Creates a new ResourceReference instance using the specified properties.
                 * @function create
                 * @memberof google.api.ResourceReference
                 * @static
                 * @param {google.api.IResourceReference=} [properties] Properties to set
                 * @returns {google.api.ResourceReference} ResourceReference instance
                 */
                ResourceReference.create = function create(properties) {
                    return new ResourceReference(properties);
                };
    
                /**
                 * Encodes the specified ResourceReference message. Does not implicitly {@link google.api.ResourceReference.verify|verify} messages.
                 * @function encode
                 * @memberof google.api.ResourceReference
                 * @static
                 * @param {google.api.IResourceReference} message ResourceReference message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ResourceReference.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.type);
                    if (message.childType != null && Object.hasOwnProperty.call(message, "childType"))
                        writer.uint32(/* id 2, wireType 2 =*/18).string(message.childType);
                    return writer;
                };
    
                /**
                 * Encodes the specified ResourceReference message, length delimited. Does not implicitly {@link google.api.ResourceReference.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.api.ResourceReference
                 * @static
                 * @param {google.api.IResourceReference} message ResourceReference message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ResourceReference.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a ResourceReference message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.api.ResourceReference
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.api.ResourceReference} ResourceReference
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ResourceReference.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.api.ResourceReference();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.type = reader.string();
                                break;
                            }
                        case 2: {
                                message.childType = reader.string();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a ResourceReference message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.api.ResourceReference
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.api.ResourceReference} ResourceReference
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ResourceReference.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a ResourceReference message.
                 * @function verify
                 * @memberof google.api.ResourceReference
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                ResourceReference.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.type != null && message.hasOwnProperty("type"))
                        if (!$util.isString(message.type))
                            return "type: string expected";
                    if (message.childType != null && message.hasOwnProperty("childType"))
                        if (!$util.isString(message.childType))
                            return "childType: string expected";
                    return null;
                };
    
                /**
                 * Creates a ResourceReference message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.api.ResourceReference
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.api.ResourceReference} ResourceReference
                 */
                ResourceReference.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.api.ResourceReference)
                        return object;
                    var message = new $root.google.api.ResourceReference();
                    if (object.type != null)
                        message.type = String(object.type);
                    if (object.childType != null)
                        message.childType = String(object.childType);
                    return message;
                };
    
                /**
                 * Creates a plain object from a ResourceReference message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.api.ResourceReference
                 * @static
                 * @param {google.api.ResourceReference} message ResourceReference
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                ResourceReference.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.type = "";
                        object.childType = "";
                    }
                    if (message.type != null && message.hasOwnProperty("type"))
                        object.type = message.type;
                    if (message.childType != null && message.hasOwnProperty("childType"))
                        object.childType = message.childType;
                    return object;
                };
    
                /**
                 * Converts this ResourceReference to JSON.
                 * @function toJSON
                 * @memberof google.api.ResourceReference
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                ResourceReference.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for ResourceReference
                 * @function getTypeUrl
                 * @memberof google.api.ResourceReference
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                ResourceReference.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.api.ResourceReference";
                };
    
                return ResourceReference;
            })();
    
            return api;
        })();
    
        google.protobuf = (function() {
    
            /**
             * Namespace protobuf.
             * @memberof google
             * @namespace
             */
            var protobuf = {};
    
            protobuf.FileDescriptorSet = (function() {
    
                /**
                 * Properties of a FileDescriptorSet.
                 * @memberof google.protobuf
                 * @interface IFileDescriptorSet
                 * @property {Array.<google.protobuf.IFileDescriptorProto>|null} [file] FileDescriptorSet file
                 */
    
                /**
                 * Constructs a new FileDescriptorSet.
                 * @memberof google.protobuf
                 * @classdesc Represents a FileDescriptorSet.
                 * @implements IFileDescriptorSet
                 * @constructor
                 * @param {google.protobuf.IFileDescriptorSet=} [properties] Properties to set
                 */
                function FileDescriptorSet(properties) {
                    this.file = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * FileDescriptorSet file.
                 * @member {Array.<google.protobuf.IFileDescriptorProto>} file
                 * @memberof google.protobuf.FileDescriptorSet
                 * @instance
                 */
                FileDescriptorSet.prototype.file = $util.emptyArray;
    
                /**
                 * Creates a new FileDescriptorSet instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.FileDescriptorSet
                 * @static
                 * @param {google.protobuf.IFileDescriptorSet=} [properties] Properties to set
                 * @returns {google.protobuf.FileDescriptorSet} FileDescriptorSet instance
                 */
                FileDescriptorSet.create = function create(properties) {
                    return new FileDescriptorSet(properties);
                };
    
                /**
                 * Encodes the specified FileDescriptorSet message. Does not implicitly {@link google.protobuf.FileDescriptorSet.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.FileDescriptorSet
                 * @static
                 * @param {google.protobuf.IFileDescriptorSet} message FileDescriptorSet message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FileDescriptorSet.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.file != null && message.file.length)
                        for (var i = 0; i < message.file.length; ++i)
                            $root.google.protobuf.FileDescriptorProto.encode(message.file[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified FileDescriptorSet message, length delimited. Does not implicitly {@link google.protobuf.FileDescriptorSet.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.FileDescriptorSet
                 * @static
                 * @param {google.protobuf.IFileDescriptorSet} message FileDescriptorSet message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FileDescriptorSet.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a FileDescriptorSet message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.FileDescriptorSet
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.FileDescriptorSet} FileDescriptorSet
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FileDescriptorSet.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.FileDescriptorSet();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                if (!(message.file && message.file.length))
                                    message.file = [];
                                message.file.push($root.google.protobuf.FileDescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a FileDescriptorSet message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.FileDescriptorSet
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.FileDescriptorSet} FileDescriptorSet
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FileDescriptorSet.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a FileDescriptorSet message.
                 * @function verify
                 * @memberof google.protobuf.FileDescriptorSet
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                FileDescriptorSet.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.file != null && message.hasOwnProperty("file")) {
                        if (!Array.isArray(message.file))
                            return "file: array expected";
                        for (var i = 0; i < message.file.length; ++i) {
                            var error = $root.google.protobuf.FileDescriptorProto.verify(message.file[i]);
                            if (error)
                                return "file." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates a FileDescriptorSet message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.FileDescriptorSet
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.FileDescriptorSet} FileDescriptorSet
                 */
                FileDescriptorSet.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.FileDescriptorSet)
                        return object;
                    var message = new $root.google.protobuf.FileDescriptorSet();
                    if (object.file) {
                        if (!Array.isArray(object.file))
                            throw TypeError(".google.protobuf.FileDescriptorSet.file: array expected");
                        message.file = [];
                        for (var i = 0; i < object.file.length; ++i) {
                            if (typeof object.file[i] !== "object")
                                throw TypeError(".google.protobuf.FileDescriptorSet.file: object expected");
                            message.file[i] = $root.google.protobuf.FileDescriptorProto.fromObject(object.file[i]);
                        }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a FileDescriptorSet message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.FileDescriptorSet
                 * @static
                 * @param {google.protobuf.FileDescriptorSet} message FileDescriptorSet
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                FileDescriptorSet.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.file = [];
                    if (message.file && message.file.length) {
                        object.file = [];
                        for (var j = 0; j < message.file.length; ++j)
                            object.file[j] = $root.google.protobuf.FileDescriptorProto.toObject(message.file[j], options);
                    }
                    return object;
                };
    
                /**
                 * Converts this FileDescriptorSet to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.FileDescriptorSet
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                FileDescriptorSet.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for FileDescriptorSet
                 * @function getTypeUrl
                 * @memberof google.protobuf.FileDescriptorSet
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                FileDescriptorSet.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.FileDescriptorSet";
                };
    
                return FileDescriptorSet;
            })();
    
            protobuf.FileDescriptorProto = (function() {
    
                /**
                 * Properties of a FileDescriptorProto.
                 * @memberof google.protobuf
                 * @interface IFileDescriptorProto
                 * @property {string|null} [name] FileDescriptorProto name
                 * @property {string|null} ["package"] FileDescriptorProto package
                 * @property {Array.<string>|null} [dependency] FileDescriptorProto dependency
                 * @property {Array.<number>|null} [publicDependency] FileDescriptorProto publicDependency
                 * @property {Array.<number>|null} [weakDependency] FileDescriptorProto weakDependency
                 * @property {Array.<google.protobuf.IDescriptorProto>|null} [messageType] FileDescriptorProto messageType
                 * @property {Array.<google.protobuf.IEnumDescriptorProto>|null} [enumType] FileDescriptorProto enumType
                 * @property {Array.<google.protobuf.IServiceDescriptorProto>|null} [service] FileDescriptorProto service
                 * @property {Array.<google.protobuf.IFieldDescriptorProto>|null} [extension] FileDescriptorProto extension
                 * @property {google.protobuf.IFileOptions|null} [options] FileDescriptorProto options
                 * @property {google.protobuf.ISourceCodeInfo|null} [sourceCodeInfo] FileDescriptorProto sourceCodeInfo
                 * @property {string|null} [syntax] FileDescriptorProto syntax
                 * @property {string|null} [edition] FileDescriptorProto edition
                 */
    
                /**
                 * Constructs a new FileDescriptorProto.
                 * @memberof google.protobuf
                 * @classdesc Represents a FileDescriptorProto.
                 * @implements IFileDescriptorProto
                 * @constructor
                 * @param {google.protobuf.IFileDescriptorProto=} [properties] Properties to set
                 */
                function FileDescriptorProto(properties) {
                    this.dependency = [];
                    this.publicDependency = [];
                    this.weakDependency = [];
                    this.messageType = [];
                    this.enumType = [];
                    this.service = [];
                    this.extension = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * FileDescriptorProto name.
                 * @member {string} name
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.name = "";
    
                /**
                 * FileDescriptorProto package.
                 * @member {string} package
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype["package"] = "";
    
                /**
                 * FileDescriptorProto dependency.
                 * @member {Array.<string>} dependency
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.dependency = $util.emptyArray;
    
                /**
                 * FileDescriptorProto publicDependency.
                 * @member {Array.<number>} publicDependency
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.publicDependency = $util.emptyArray;
    
                /**
                 * FileDescriptorProto weakDependency.
                 * @member {Array.<number>} weakDependency
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.weakDependency = $util.emptyArray;
    
                /**
                 * FileDescriptorProto messageType.
                 * @member {Array.<google.protobuf.IDescriptorProto>} messageType
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.messageType = $util.emptyArray;
    
                /**
                 * FileDescriptorProto enumType.
                 * @member {Array.<google.protobuf.IEnumDescriptorProto>} enumType
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.enumType = $util.emptyArray;
    
                /**
                 * FileDescriptorProto service.
                 * @member {Array.<google.protobuf.IServiceDescriptorProto>} service
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.service = $util.emptyArray;
    
                /**
                 * FileDescriptorProto extension.
                 * @member {Array.<google.protobuf.IFieldDescriptorProto>} extension
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.extension = $util.emptyArray;
    
                /**
                 * FileDescriptorProto options.
                 * @member {google.protobuf.IFileOptions|null|undefined} options
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.options = null;
    
                /**
                 * FileDescriptorProto sourceCodeInfo.
                 * @member {google.protobuf.ISourceCodeInfo|null|undefined} sourceCodeInfo
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.sourceCodeInfo = null;
    
                /**
                 * FileDescriptorProto syntax.
                 * @member {string} syntax
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.syntax = "";
    
                /**
                 * FileDescriptorProto edition.
                 * @member {string} edition
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 */
                FileDescriptorProto.prototype.edition = "";
    
                /**
                 * Creates a new FileDescriptorProto instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.FileDescriptorProto
                 * @static
                 * @param {google.protobuf.IFileDescriptorProto=} [properties] Properties to set
                 * @returns {google.protobuf.FileDescriptorProto} FileDescriptorProto instance
                 */
                FileDescriptorProto.create = function create(properties) {
                    return new FileDescriptorProto(properties);
                };
    
                /**
                 * Encodes the specified FileDescriptorProto message. Does not implicitly {@link google.protobuf.FileDescriptorProto.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.FileDescriptorProto
                 * @static
                 * @param {google.protobuf.IFileDescriptorProto} message FileDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FileDescriptorProto.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                    if (message["package"] != null && Object.hasOwnProperty.call(message, "package"))
                        writer.uint32(/* id 2, wireType 2 =*/18).string(message["package"]);
                    if (message.dependency != null && message.dependency.length)
                        for (var i = 0; i < message.dependency.length; ++i)
                            writer.uint32(/* id 3, wireType 2 =*/26).string(message.dependency[i]);
                    if (message.messageType != null && message.messageType.length)
                        for (var i = 0; i < message.messageType.length; ++i)
                            $root.google.protobuf.DescriptorProto.encode(message.messageType[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                    if (message.enumType != null && message.enumType.length)
                        for (var i = 0; i < message.enumType.length; ++i)
                            $root.google.protobuf.EnumDescriptorProto.encode(message.enumType[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                    if (message.service != null && message.service.length)
                        for (var i = 0; i < message.service.length; ++i)
                            $root.google.protobuf.ServiceDescriptorProto.encode(message.service[i], writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                    if (message.extension != null && message.extension.length)
                        for (var i = 0; i < message.extension.length; ++i)
                            $root.google.protobuf.FieldDescriptorProto.encode(message.extension[i], writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                    if (message.options != null && Object.hasOwnProperty.call(message, "options"))
                        $root.google.protobuf.FileOptions.encode(message.options, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                    if (message.sourceCodeInfo != null && Object.hasOwnProperty.call(message, "sourceCodeInfo"))
                        $root.google.protobuf.SourceCodeInfo.encode(message.sourceCodeInfo, writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                    if (message.publicDependency != null && message.publicDependency.length)
                        for (var i = 0; i < message.publicDependency.length; ++i)
                            writer.uint32(/* id 10, wireType 0 =*/80).int32(message.publicDependency[i]);
                    if (message.weakDependency != null && message.weakDependency.length)
                        for (var i = 0; i < message.weakDependency.length; ++i)
                            writer.uint32(/* id 11, wireType 0 =*/88).int32(message.weakDependency[i]);
                    if (message.syntax != null && Object.hasOwnProperty.call(message, "syntax"))
                        writer.uint32(/* id 12, wireType 2 =*/98).string(message.syntax);
                    if (message.edition != null && Object.hasOwnProperty.call(message, "edition"))
                        writer.uint32(/* id 13, wireType 2 =*/106).string(message.edition);
                    return writer;
                };
    
                /**
                 * Encodes the specified FileDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.FileDescriptorProto.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.FileDescriptorProto
                 * @static
                 * @param {google.protobuf.IFileDescriptorProto} message FileDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FileDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a FileDescriptorProto message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.FileDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.FileDescriptorProto} FileDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FileDescriptorProto.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.FileDescriptorProto();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.name = reader.string();
                                break;
                            }
                        case 2: {
                                message["package"] = reader.string();
                                break;
                            }
                        case 3: {
                                if (!(message.dependency && message.dependency.length))
                                    message.dependency = [];
                                message.dependency.push(reader.string());
                                break;
                            }
                        case 10: {
                                if (!(message.publicDependency && message.publicDependency.length))
                                    message.publicDependency = [];
                                if ((tag & 7) === 2) {
                                    var end2 = reader.uint32() + reader.pos;
                                    while (reader.pos < end2)
                                        message.publicDependency.push(reader.int32());
                                } else
                                    message.publicDependency.push(reader.int32());
                                break;
                            }
                        case 11: {
                                if (!(message.weakDependency && message.weakDependency.length))
                                    message.weakDependency = [];
                                if ((tag & 7) === 2) {
                                    var end2 = reader.uint32() + reader.pos;
                                    while (reader.pos < end2)
                                        message.weakDependency.push(reader.int32());
                                } else
                                    message.weakDependency.push(reader.int32());
                                break;
                            }
                        case 4: {
                                if (!(message.messageType && message.messageType.length))
                                    message.messageType = [];
                                message.messageType.push($root.google.protobuf.DescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 5: {
                                if (!(message.enumType && message.enumType.length))
                                    message.enumType = [];
                                message.enumType.push($root.google.protobuf.EnumDescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 6: {
                                if (!(message.service && message.service.length))
                                    message.service = [];
                                message.service.push($root.google.protobuf.ServiceDescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 7: {
                                if (!(message.extension && message.extension.length))
                                    message.extension = [];
                                message.extension.push($root.google.protobuf.FieldDescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 8: {
                                message.options = $root.google.protobuf.FileOptions.decode(reader, reader.uint32());
                                break;
                            }
                        case 9: {
                                message.sourceCodeInfo = $root.google.protobuf.SourceCodeInfo.decode(reader, reader.uint32());
                                break;
                            }
                        case 12: {
                                message.syntax = reader.string();
                                break;
                            }
                        case 13: {
                                message.edition = reader.string();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a FileDescriptorProto message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.FileDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.FileDescriptorProto} FileDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FileDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a FileDescriptorProto message.
                 * @function verify
                 * @memberof google.protobuf.FileDescriptorProto
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                FileDescriptorProto.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.name != null && message.hasOwnProperty("name"))
                        if (!$util.isString(message.name))
                            return "name: string expected";
                    if (message["package"] != null && message.hasOwnProperty("package"))
                        if (!$util.isString(message["package"]))
                            return "package: string expected";
                    if (message.dependency != null && message.hasOwnProperty("dependency")) {
                        if (!Array.isArray(message.dependency))
                            return "dependency: array expected";
                        for (var i = 0; i < message.dependency.length; ++i)
                            if (!$util.isString(message.dependency[i]))
                                return "dependency: string[] expected";
                    }
                    if (message.publicDependency != null && message.hasOwnProperty("publicDependency")) {
                        if (!Array.isArray(message.publicDependency))
                            return "publicDependency: array expected";
                        for (var i = 0; i < message.publicDependency.length; ++i)
                            if (!$util.isInteger(message.publicDependency[i]))
                                return "publicDependency: integer[] expected";
                    }
                    if (message.weakDependency != null && message.hasOwnProperty("weakDependency")) {
                        if (!Array.isArray(message.weakDependency))
                            return "weakDependency: array expected";
                        for (var i = 0; i < message.weakDependency.length; ++i)
                            if (!$util.isInteger(message.weakDependency[i]))
                                return "weakDependency: integer[] expected";
                    }
                    if (message.messageType != null && message.hasOwnProperty("messageType")) {
                        if (!Array.isArray(message.messageType))
                            return "messageType: array expected";
                        for (var i = 0; i < message.messageType.length; ++i) {
                            var error = $root.google.protobuf.DescriptorProto.verify(message.messageType[i]);
                            if (error)
                                return "messageType." + error;
                        }
                    }
                    if (message.enumType != null && message.hasOwnProperty("enumType")) {
                        if (!Array.isArray(message.enumType))
                            return "enumType: array expected";
                        for (var i = 0; i < message.enumType.length; ++i) {
                            var error = $root.google.protobuf.EnumDescriptorProto.verify(message.enumType[i]);
                            if (error)
                                return "enumType." + error;
                        }
                    }
                    if (message.service != null && message.hasOwnProperty("service")) {
                        if (!Array.isArray(message.service))
                            return "service: array expected";
                        for (var i = 0; i < message.service.length; ++i) {
                            var error = $root.google.protobuf.ServiceDescriptorProto.verify(message.service[i]);
                            if (error)
                                return "service." + error;
                        }
                    }
                    if (message.extension != null && message.hasOwnProperty("extension")) {
                        if (!Array.isArray(message.extension))
                            return "extension: array expected";
                        for (var i = 0; i < message.extension.length; ++i) {
                            var error = $root.google.protobuf.FieldDescriptorProto.verify(message.extension[i]);
                            if (error)
                                return "extension." + error;
                        }
                    }
                    if (message.options != null && message.hasOwnProperty("options")) {
                        var error = $root.google.protobuf.FileOptions.verify(message.options);
                        if (error)
                            return "options." + error;
                    }
                    if (message.sourceCodeInfo != null && message.hasOwnProperty("sourceCodeInfo")) {
                        var error = $root.google.protobuf.SourceCodeInfo.verify(message.sourceCodeInfo);
                        if (error)
                            return "sourceCodeInfo." + error;
                    }
                    if (message.syntax != null && message.hasOwnProperty("syntax"))
                        if (!$util.isString(message.syntax))
                            return "syntax: string expected";
                    if (message.edition != null && message.hasOwnProperty("edition"))
                        if (!$util.isString(message.edition))
                            return "edition: string expected";
                    return null;
                };
    
                /**
                 * Creates a FileDescriptorProto message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.FileDescriptorProto
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.FileDescriptorProto} FileDescriptorProto
                 */
                FileDescriptorProto.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.FileDescriptorProto)
                        return object;
                    var message = new $root.google.protobuf.FileDescriptorProto();
                    if (object.name != null)
                        message.name = String(object.name);
                    if (object["package"] != null)
                        message["package"] = String(object["package"]);
                    if (object.dependency) {
                        if (!Array.isArray(object.dependency))
                            throw TypeError(".google.protobuf.FileDescriptorProto.dependency: array expected");
                        message.dependency = [];
                        for (var i = 0; i < object.dependency.length; ++i)
                            message.dependency[i] = String(object.dependency[i]);
                    }
                    if (object.publicDependency) {
                        if (!Array.isArray(object.publicDependency))
                            throw TypeError(".google.protobuf.FileDescriptorProto.publicDependency: array expected");
                        message.publicDependency = [];
                        for (var i = 0; i < object.publicDependency.length; ++i)
                            message.publicDependency[i] = object.publicDependency[i] | 0;
                    }
                    if (object.weakDependency) {
                        if (!Array.isArray(object.weakDependency))
                            throw TypeError(".google.protobuf.FileDescriptorProto.weakDependency: array expected");
                        message.weakDependency = [];
                        for (var i = 0; i < object.weakDependency.length; ++i)
                            message.weakDependency[i] = object.weakDependency[i] | 0;
                    }
                    if (object.messageType) {
                        if (!Array.isArray(object.messageType))
                            throw TypeError(".google.protobuf.FileDescriptorProto.messageType: array expected");
                        message.messageType = [];
                        for (var i = 0; i < object.messageType.length; ++i) {
                            if (typeof object.messageType[i] !== "object")
                                throw TypeError(".google.protobuf.FileDescriptorProto.messageType: object expected");
                            message.messageType[i] = $root.google.protobuf.DescriptorProto.fromObject(object.messageType[i]);
                        }
                    }
                    if (object.enumType) {
                        if (!Array.isArray(object.enumType))
                            throw TypeError(".google.protobuf.FileDescriptorProto.enumType: array expected");
                        message.enumType = [];
                        for (var i = 0; i < object.enumType.length; ++i) {
                            if (typeof object.enumType[i] !== "object")
                                throw TypeError(".google.protobuf.FileDescriptorProto.enumType: object expected");
                            message.enumType[i] = $root.google.protobuf.EnumDescriptorProto.fromObject(object.enumType[i]);
                        }
                    }
                    if (object.service) {
                        if (!Array.isArray(object.service))
                            throw TypeError(".google.protobuf.FileDescriptorProto.service: array expected");
                        message.service = [];
                        for (var i = 0; i < object.service.length; ++i) {
                            if (typeof object.service[i] !== "object")
                                throw TypeError(".google.protobuf.FileDescriptorProto.service: object expected");
                            message.service[i] = $root.google.protobuf.ServiceDescriptorProto.fromObject(object.service[i]);
                        }
                    }
                    if (object.extension) {
                        if (!Array.isArray(object.extension))
                            throw TypeError(".google.protobuf.FileDescriptorProto.extension: array expected");
                        message.extension = [];
                        for (var i = 0; i < object.extension.length; ++i) {
                            if (typeof object.extension[i] !== "object")
                                throw TypeError(".google.protobuf.FileDescriptorProto.extension: object expected");
                            message.extension[i] = $root.google.protobuf.FieldDescriptorProto.fromObject(object.extension[i]);
                        }
                    }
                    if (object.options != null) {
                        if (typeof object.options !== "object")
                            throw TypeError(".google.protobuf.FileDescriptorProto.options: object expected");
                        message.options = $root.google.protobuf.FileOptions.fromObject(object.options);
                    }
                    if (object.sourceCodeInfo != null) {
                        if (typeof object.sourceCodeInfo !== "object")
                            throw TypeError(".google.protobuf.FileDescriptorProto.sourceCodeInfo: object expected");
                        message.sourceCodeInfo = $root.google.protobuf.SourceCodeInfo.fromObject(object.sourceCodeInfo);
                    }
                    if (object.syntax != null)
                        message.syntax = String(object.syntax);
                    if (object.edition != null)
                        message.edition = String(object.edition);
                    return message;
                };
    
                /**
                 * Creates a plain object from a FileDescriptorProto message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.FileDescriptorProto
                 * @static
                 * @param {google.protobuf.FileDescriptorProto} message FileDescriptorProto
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                FileDescriptorProto.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults) {
                        object.dependency = [];
                        object.messageType = [];
                        object.enumType = [];
                        object.service = [];
                        object.extension = [];
                        object.publicDependency = [];
                        object.weakDependency = [];
                    }
                    if (options.defaults) {
                        object.name = "";
                        object["package"] = "";
                        object.options = null;
                        object.sourceCodeInfo = null;
                        object.syntax = "";
                        object.edition = "";
                    }
                    if (message.name != null && message.hasOwnProperty("name"))
                        object.name = message.name;
                    if (message["package"] != null && message.hasOwnProperty("package"))
                        object["package"] = message["package"];
                    if (message.dependency && message.dependency.length) {
                        object.dependency = [];
                        for (var j = 0; j < message.dependency.length; ++j)
                            object.dependency[j] = message.dependency[j];
                    }
                    if (message.messageType && message.messageType.length) {
                        object.messageType = [];
                        for (var j = 0; j < message.messageType.length; ++j)
                            object.messageType[j] = $root.google.protobuf.DescriptorProto.toObject(message.messageType[j], options);
                    }
                    if (message.enumType && message.enumType.length) {
                        object.enumType = [];
                        for (var j = 0; j < message.enumType.length; ++j)
                            object.enumType[j] = $root.google.protobuf.EnumDescriptorProto.toObject(message.enumType[j], options);
                    }
                    if (message.service && message.service.length) {
                        object.service = [];
                        for (var j = 0; j < message.service.length; ++j)
                            object.service[j] = $root.google.protobuf.ServiceDescriptorProto.toObject(message.service[j], options);
                    }
                    if (message.extension && message.extension.length) {
                        object.extension = [];
                        for (var j = 0; j < message.extension.length; ++j)
                            object.extension[j] = $root.google.protobuf.FieldDescriptorProto.toObject(message.extension[j], options);
                    }
                    if (message.options != null && message.hasOwnProperty("options"))
                        object.options = $root.google.protobuf.FileOptions.toObject(message.options, options);
                    if (message.sourceCodeInfo != null && message.hasOwnProperty("sourceCodeInfo"))
                        object.sourceCodeInfo = $root.google.protobuf.SourceCodeInfo.toObject(message.sourceCodeInfo, options);
                    if (message.publicDependency && message.publicDependency.length) {
                        object.publicDependency = [];
                        for (var j = 0; j < message.publicDependency.length; ++j)
                            object.publicDependency[j] = message.publicDependency[j];
                    }
                    if (message.weakDependency && message.weakDependency.length) {
                        object.weakDependency = [];
                        for (var j = 0; j < message.weakDependency.length; ++j)
                            object.weakDependency[j] = message.weakDependency[j];
                    }
                    if (message.syntax != null && message.hasOwnProperty("syntax"))
                        object.syntax = message.syntax;
                    if (message.edition != null && message.hasOwnProperty("edition"))
                        object.edition = message.edition;
                    return object;
                };
    
                /**
                 * Converts this FileDescriptorProto to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.FileDescriptorProto
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                FileDescriptorProto.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for FileDescriptorProto
                 * @function getTypeUrl
                 * @memberof google.protobuf.FileDescriptorProto
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                FileDescriptorProto.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.FileDescriptorProto";
                };
    
                return FileDescriptorProto;
            })();
    
            protobuf.DescriptorProto = (function() {
    
                /**
                 * Properties of a DescriptorProto.
                 * @memberof google.protobuf
                 * @interface IDescriptorProto
                 * @property {string|null} [name] DescriptorProto name
                 * @property {Array.<google.protobuf.IFieldDescriptorProto>|null} [field] DescriptorProto field
                 * @property {Array.<google.protobuf.IFieldDescriptorProto>|null} [extension] DescriptorProto extension
                 * @property {Array.<google.protobuf.IDescriptorProto>|null} [nestedType] DescriptorProto nestedType
                 * @property {Array.<google.protobuf.IEnumDescriptorProto>|null} [enumType] DescriptorProto enumType
                 * @property {Array.<google.protobuf.DescriptorProto.IExtensionRange>|null} [extensionRange] DescriptorProto extensionRange
                 * @property {Array.<google.protobuf.IOneofDescriptorProto>|null} [oneofDecl] DescriptorProto oneofDecl
                 * @property {google.protobuf.IMessageOptions|null} [options] DescriptorProto options
                 * @property {Array.<google.protobuf.DescriptorProto.IReservedRange>|null} [reservedRange] DescriptorProto reservedRange
                 * @property {Array.<string>|null} [reservedName] DescriptorProto reservedName
                 */
    
                /**
                 * Constructs a new DescriptorProto.
                 * @memberof google.protobuf
                 * @classdesc Represents a DescriptorProto.
                 * @implements IDescriptorProto
                 * @constructor
                 * @param {google.protobuf.IDescriptorProto=} [properties] Properties to set
                 */
                function DescriptorProto(properties) {
                    this.field = [];
                    this.extension = [];
                    this.nestedType = [];
                    this.enumType = [];
                    this.extensionRange = [];
                    this.oneofDecl = [];
                    this.reservedRange = [];
                    this.reservedName = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * DescriptorProto name.
                 * @member {string} name
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 */
                DescriptorProto.prototype.name = "";
    
                /**
                 * DescriptorProto field.
                 * @member {Array.<google.protobuf.IFieldDescriptorProto>} field
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 */
                DescriptorProto.prototype.field = $util.emptyArray;
    
                /**
                 * DescriptorProto extension.
                 * @member {Array.<google.protobuf.IFieldDescriptorProto>} extension
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 */
                DescriptorProto.prototype.extension = $util.emptyArray;
    
                /**
                 * DescriptorProto nestedType.
                 * @member {Array.<google.protobuf.IDescriptorProto>} nestedType
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 */
                DescriptorProto.prototype.nestedType = $util.emptyArray;
    
                /**
                 * DescriptorProto enumType.
                 * @member {Array.<google.protobuf.IEnumDescriptorProto>} enumType
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 */
                DescriptorProto.prototype.enumType = $util.emptyArray;
    
                /**
                 * DescriptorProto extensionRange.
                 * @member {Array.<google.protobuf.DescriptorProto.IExtensionRange>} extensionRange
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 */
                DescriptorProto.prototype.extensionRange = $util.emptyArray;
    
                /**
                 * DescriptorProto oneofDecl.
                 * @member {Array.<google.protobuf.IOneofDescriptorProto>} oneofDecl
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 */
                DescriptorProto.prototype.oneofDecl = $util.emptyArray;
    
                /**
                 * DescriptorProto options.
                 * @member {google.protobuf.IMessageOptions|null|undefined} options
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 */
                DescriptorProto.prototype.options = null;
    
                /**
                 * DescriptorProto reservedRange.
                 * @member {Array.<google.protobuf.DescriptorProto.IReservedRange>} reservedRange
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 */
                DescriptorProto.prototype.reservedRange = $util.emptyArray;
    
                /**
                 * DescriptorProto reservedName.
                 * @member {Array.<string>} reservedName
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 */
                DescriptorProto.prototype.reservedName = $util.emptyArray;
    
                /**
                 * Creates a new DescriptorProto instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.DescriptorProto
                 * @static
                 * @param {google.protobuf.IDescriptorProto=} [properties] Properties to set
                 * @returns {google.protobuf.DescriptorProto} DescriptorProto instance
                 */
                DescriptorProto.create = function create(properties) {
                    return new DescriptorProto(properties);
                };
    
                /**
                 * Encodes the specified DescriptorProto message. Does not implicitly {@link google.protobuf.DescriptorProto.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.DescriptorProto
                 * @static
                 * @param {google.protobuf.IDescriptorProto} message DescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                DescriptorProto.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                    if (message.field != null && message.field.length)
                        for (var i = 0; i < message.field.length; ++i)
                            $root.google.protobuf.FieldDescriptorProto.encode(message.field[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                    if (message.nestedType != null && message.nestedType.length)
                        for (var i = 0; i < message.nestedType.length; ++i)
                            $root.google.protobuf.DescriptorProto.encode(message.nestedType[i], writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                    if (message.enumType != null && message.enumType.length)
                        for (var i = 0; i < message.enumType.length; ++i)
                            $root.google.protobuf.EnumDescriptorProto.encode(message.enumType[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                    if (message.extensionRange != null && message.extensionRange.length)
                        for (var i = 0; i < message.extensionRange.length; ++i)
                            $root.google.protobuf.DescriptorProto.ExtensionRange.encode(message.extensionRange[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
                    if (message.extension != null && message.extension.length)
                        for (var i = 0; i < message.extension.length; ++i)
                            $root.google.protobuf.FieldDescriptorProto.encode(message.extension[i], writer.uint32(/* id 6, wireType 2 =*/50).fork()).ldelim();
                    if (message.options != null && Object.hasOwnProperty.call(message, "options"))
                        $root.google.protobuf.MessageOptions.encode(message.options, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
                    if (message.oneofDecl != null && message.oneofDecl.length)
                        for (var i = 0; i < message.oneofDecl.length; ++i)
                            $root.google.protobuf.OneofDescriptorProto.encode(message.oneofDecl[i], writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                    if (message.reservedRange != null && message.reservedRange.length)
                        for (var i = 0; i < message.reservedRange.length; ++i)
                            $root.google.protobuf.DescriptorProto.ReservedRange.encode(message.reservedRange[i], writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
                    if (message.reservedName != null && message.reservedName.length)
                        for (var i = 0; i < message.reservedName.length; ++i)
                            writer.uint32(/* id 10, wireType 2 =*/82).string(message.reservedName[i]);
                    return writer;
                };
    
                /**
                 * Encodes the specified DescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.DescriptorProto.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.DescriptorProto
                 * @static
                 * @param {google.protobuf.IDescriptorProto} message DescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                DescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a DescriptorProto message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.DescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.DescriptorProto} DescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                DescriptorProto.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.DescriptorProto();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.name = reader.string();
                                break;
                            }
                        case 2: {
                                if (!(message.field && message.field.length))
                                    message.field = [];
                                message.field.push($root.google.protobuf.FieldDescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 6: {
                                if (!(message.extension && message.extension.length))
                                    message.extension = [];
                                message.extension.push($root.google.protobuf.FieldDescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 3: {
                                if (!(message.nestedType && message.nestedType.length))
                                    message.nestedType = [];
                                message.nestedType.push($root.google.protobuf.DescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 4: {
                                if (!(message.enumType && message.enumType.length))
                                    message.enumType = [];
                                message.enumType.push($root.google.protobuf.EnumDescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 5: {
                                if (!(message.extensionRange && message.extensionRange.length))
                                    message.extensionRange = [];
                                message.extensionRange.push($root.google.protobuf.DescriptorProto.ExtensionRange.decode(reader, reader.uint32()));
                                break;
                            }
                        case 8: {
                                if (!(message.oneofDecl && message.oneofDecl.length))
                                    message.oneofDecl = [];
                                message.oneofDecl.push($root.google.protobuf.OneofDescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 7: {
                                message.options = $root.google.protobuf.MessageOptions.decode(reader, reader.uint32());
                                break;
                            }
                        case 9: {
                                if (!(message.reservedRange && message.reservedRange.length))
                                    message.reservedRange = [];
                                message.reservedRange.push($root.google.protobuf.DescriptorProto.ReservedRange.decode(reader, reader.uint32()));
                                break;
                            }
                        case 10: {
                                if (!(message.reservedName && message.reservedName.length))
                                    message.reservedName = [];
                                message.reservedName.push(reader.string());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a DescriptorProto message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.DescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.DescriptorProto} DescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                DescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a DescriptorProto message.
                 * @function verify
                 * @memberof google.protobuf.DescriptorProto
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                DescriptorProto.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.name != null && message.hasOwnProperty("name"))
                        if (!$util.isString(message.name))
                            return "name: string expected";
                    if (message.field != null && message.hasOwnProperty("field")) {
                        if (!Array.isArray(message.field))
                            return "field: array expected";
                        for (var i = 0; i < message.field.length; ++i) {
                            var error = $root.google.protobuf.FieldDescriptorProto.verify(message.field[i]);
                            if (error)
                                return "field." + error;
                        }
                    }
                    if (message.extension != null && message.hasOwnProperty("extension")) {
                        if (!Array.isArray(message.extension))
                            return "extension: array expected";
                        for (var i = 0; i < message.extension.length; ++i) {
                            var error = $root.google.protobuf.FieldDescriptorProto.verify(message.extension[i]);
                            if (error)
                                return "extension." + error;
                        }
                    }
                    if (message.nestedType != null && message.hasOwnProperty("nestedType")) {
                        if (!Array.isArray(message.nestedType))
                            return "nestedType: array expected";
                        for (var i = 0; i < message.nestedType.length; ++i) {
                            var error = $root.google.protobuf.DescriptorProto.verify(message.nestedType[i]);
                            if (error)
                                return "nestedType." + error;
                        }
                    }
                    if (message.enumType != null && message.hasOwnProperty("enumType")) {
                        if (!Array.isArray(message.enumType))
                            return "enumType: array expected";
                        for (var i = 0; i < message.enumType.length; ++i) {
                            var error = $root.google.protobuf.EnumDescriptorProto.verify(message.enumType[i]);
                            if (error)
                                return "enumType." + error;
                        }
                    }
                    if (message.extensionRange != null && message.hasOwnProperty("extensionRange")) {
                        if (!Array.isArray(message.extensionRange))
                            return "extensionRange: array expected";
                        for (var i = 0; i < message.extensionRange.length; ++i) {
                            var error = $root.google.protobuf.DescriptorProto.ExtensionRange.verify(message.extensionRange[i]);
                            if (error)
                                return "extensionRange." + error;
                        }
                    }
                    if (message.oneofDecl != null && message.hasOwnProperty("oneofDecl")) {
                        if (!Array.isArray(message.oneofDecl))
                            return "oneofDecl: array expected";
                        for (var i = 0; i < message.oneofDecl.length; ++i) {
                            var error = $root.google.protobuf.OneofDescriptorProto.verify(message.oneofDecl[i]);
                            if (error)
                                return "oneofDecl." + error;
                        }
                    }
                    if (message.options != null && message.hasOwnProperty("options")) {
                        var error = $root.google.protobuf.MessageOptions.verify(message.options);
                        if (error)
                            return "options." + error;
                    }
                    if (message.reservedRange != null && message.hasOwnProperty("reservedRange")) {
                        if (!Array.isArray(message.reservedRange))
                            return "reservedRange: array expected";
                        for (var i = 0; i < message.reservedRange.length; ++i) {
                            var error = $root.google.protobuf.DescriptorProto.ReservedRange.verify(message.reservedRange[i]);
                            if (error)
                                return "reservedRange." + error;
                        }
                    }
                    if (message.reservedName != null && message.hasOwnProperty("reservedName")) {
                        if (!Array.isArray(message.reservedName))
                            return "reservedName: array expected";
                        for (var i = 0; i < message.reservedName.length; ++i)
                            if (!$util.isString(message.reservedName[i]))
                                return "reservedName: string[] expected";
                    }
                    return null;
                };
    
                /**
                 * Creates a DescriptorProto message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.DescriptorProto
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.DescriptorProto} DescriptorProto
                 */
                DescriptorProto.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.DescriptorProto)
                        return object;
                    var message = new $root.google.protobuf.DescriptorProto();
                    if (object.name != null)
                        message.name = String(object.name);
                    if (object.field) {
                        if (!Array.isArray(object.field))
                            throw TypeError(".google.protobuf.DescriptorProto.field: array expected");
                        message.field = [];
                        for (var i = 0; i < object.field.length; ++i) {
                            if (typeof object.field[i] !== "object")
                                throw TypeError(".google.protobuf.DescriptorProto.field: object expected");
                            message.field[i] = $root.google.protobuf.FieldDescriptorProto.fromObject(object.field[i]);
                        }
                    }
                    if (object.extension) {
                        if (!Array.isArray(object.extension))
                            throw TypeError(".google.protobuf.DescriptorProto.extension: array expected");
                        message.extension = [];
                        for (var i = 0; i < object.extension.length; ++i) {
                            if (typeof object.extension[i] !== "object")
                                throw TypeError(".google.protobuf.DescriptorProto.extension: object expected");
                            message.extension[i] = $root.google.protobuf.FieldDescriptorProto.fromObject(object.extension[i]);
                        }
                    }
                    if (object.nestedType) {
                        if (!Array.isArray(object.nestedType))
                            throw TypeError(".google.protobuf.DescriptorProto.nestedType: array expected");
                        message.nestedType = [];
                        for (var i = 0; i < object.nestedType.length; ++i) {
                            if (typeof object.nestedType[i] !== "object")
                                throw TypeError(".google.protobuf.DescriptorProto.nestedType: object expected");
                            message.nestedType[i] = $root.google.protobuf.DescriptorProto.fromObject(object.nestedType[i]);
                        }
                    }
                    if (object.enumType) {
                        if (!Array.isArray(object.enumType))
                            throw TypeError(".google.protobuf.DescriptorProto.enumType: array expected");
                        message.enumType = [];
                        for (var i = 0; i < object.enumType.length; ++i) {
                            if (typeof object.enumType[i] !== "object")
                                throw TypeError(".google.protobuf.DescriptorProto.enumType: object expected");
                            message.enumType[i] = $root.google.protobuf.EnumDescriptorProto.fromObject(object.enumType[i]);
                        }
                    }
                    if (object.extensionRange) {
                        if (!Array.isArray(object.extensionRange))
                            throw TypeError(".google.protobuf.DescriptorProto.extensionRange: array expected");
                        message.extensionRange = [];
                        for (var i = 0; i < object.extensionRange.length; ++i) {
                            if (typeof object.extensionRange[i] !== "object")
                                throw TypeError(".google.protobuf.DescriptorProto.extensionRange: object expected");
                            message.extensionRange[i] = $root.google.protobuf.DescriptorProto.ExtensionRange.fromObject(object.extensionRange[i]);
                        }
                    }
                    if (object.oneofDecl) {
                        if (!Array.isArray(object.oneofDecl))
                            throw TypeError(".google.protobuf.DescriptorProto.oneofDecl: array expected");
                        message.oneofDecl = [];
                        for (var i = 0; i < object.oneofDecl.length; ++i) {
                            if (typeof object.oneofDecl[i] !== "object")
                                throw TypeError(".google.protobuf.DescriptorProto.oneofDecl: object expected");
                            message.oneofDecl[i] = $root.google.protobuf.OneofDescriptorProto.fromObject(object.oneofDecl[i]);
                        }
                    }
                    if (object.options != null) {
                        if (typeof object.options !== "object")
                            throw TypeError(".google.protobuf.DescriptorProto.options: object expected");
                        message.options = $root.google.protobuf.MessageOptions.fromObject(object.options);
                    }
                    if (object.reservedRange) {
                        if (!Array.isArray(object.reservedRange))
                            throw TypeError(".google.protobuf.DescriptorProto.reservedRange: array expected");
                        message.reservedRange = [];
                        for (var i = 0; i < object.reservedRange.length; ++i) {
                            if (typeof object.reservedRange[i] !== "object")
                                throw TypeError(".google.protobuf.DescriptorProto.reservedRange: object expected");
                            message.reservedRange[i] = $root.google.protobuf.DescriptorProto.ReservedRange.fromObject(object.reservedRange[i]);
                        }
                    }
                    if (object.reservedName) {
                        if (!Array.isArray(object.reservedName))
                            throw TypeError(".google.protobuf.DescriptorProto.reservedName: array expected");
                        message.reservedName = [];
                        for (var i = 0; i < object.reservedName.length; ++i)
                            message.reservedName[i] = String(object.reservedName[i]);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a DescriptorProto message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.DescriptorProto
                 * @static
                 * @param {google.protobuf.DescriptorProto} message DescriptorProto
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                DescriptorProto.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults) {
                        object.field = [];
                        object.nestedType = [];
                        object.enumType = [];
                        object.extensionRange = [];
                        object.extension = [];
                        object.oneofDecl = [];
                        object.reservedRange = [];
                        object.reservedName = [];
                    }
                    if (options.defaults) {
                        object.name = "";
                        object.options = null;
                    }
                    if (message.name != null && message.hasOwnProperty("name"))
                        object.name = message.name;
                    if (message.field && message.field.length) {
                        object.field = [];
                        for (var j = 0; j < message.field.length; ++j)
                            object.field[j] = $root.google.protobuf.FieldDescriptorProto.toObject(message.field[j], options);
                    }
                    if (message.nestedType && message.nestedType.length) {
                        object.nestedType = [];
                        for (var j = 0; j < message.nestedType.length; ++j)
                            object.nestedType[j] = $root.google.protobuf.DescriptorProto.toObject(message.nestedType[j], options);
                    }
                    if (message.enumType && message.enumType.length) {
                        object.enumType = [];
                        for (var j = 0; j < message.enumType.length; ++j)
                            object.enumType[j] = $root.google.protobuf.EnumDescriptorProto.toObject(message.enumType[j], options);
                    }
                    if (message.extensionRange && message.extensionRange.length) {
                        object.extensionRange = [];
                        for (var j = 0; j < message.extensionRange.length; ++j)
                            object.extensionRange[j] = $root.google.protobuf.DescriptorProto.ExtensionRange.toObject(message.extensionRange[j], options);
                    }
                    if (message.extension && message.extension.length) {
                        object.extension = [];
                        for (var j = 0; j < message.extension.length; ++j)
                            object.extension[j] = $root.google.protobuf.FieldDescriptorProto.toObject(message.extension[j], options);
                    }
                    if (message.options != null && message.hasOwnProperty("options"))
                        object.options = $root.google.protobuf.MessageOptions.toObject(message.options, options);
                    if (message.oneofDecl && message.oneofDecl.length) {
                        object.oneofDecl = [];
                        for (var j = 0; j < message.oneofDecl.length; ++j)
                            object.oneofDecl[j] = $root.google.protobuf.OneofDescriptorProto.toObject(message.oneofDecl[j], options);
                    }
                    if (message.reservedRange && message.reservedRange.length) {
                        object.reservedRange = [];
                        for (var j = 0; j < message.reservedRange.length; ++j)
                            object.reservedRange[j] = $root.google.protobuf.DescriptorProto.ReservedRange.toObject(message.reservedRange[j], options);
                    }
                    if (message.reservedName && message.reservedName.length) {
                        object.reservedName = [];
                        for (var j = 0; j < message.reservedName.length; ++j)
                            object.reservedName[j] = message.reservedName[j];
                    }
                    return object;
                };
    
                /**
                 * Converts this DescriptorProto to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.DescriptorProto
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                DescriptorProto.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for DescriptorProto
                 * @function getTypeUrl
                 * @memberof google.protobuf.DescriptorProto
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                DescriptorProto.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.DescriptorProto";
                };
    
                DescriptorProto.ExtensionRange = (function() {
    
                    /**
                     * Properties of an ExtensionRange.
                     * @memberof google.protobuf.DescriptorProto
                     * @interface IExtensionRange
                     * @property {number|null} [start] ExtensionRange start
                     * @property {number|null} [end] ExtensionRange end
                     * @property {google.protobuf.IExtensionRangeOptions|null} [options] ExtensionRange options
                     */
    
                    /**
                     * Constructs a new ExtensionRange.
                     * @memberof google.protobuf.DescriptorProto
                     * @classdesc Represents an ExtensionRange.
                     * @implements IExtensionRange
                     * @constructor
                     * @param {google.protobuf.DescriptorProto.IExtensionRange=} [properties] Properties to set
                     */
                    function ExtensionRange(properties) {
                        if (properties)
                            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                if (properties[keys[i]] != null)
                                    this[keys[i]] = properties[keys[i]];
                    }
    
                    /**
                     * ExtensionRange start.
                     * @member {number} start
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @instance
                     */
                    ExtensionRange.prototype.start = 0;
    
                    /**
                     * ExtensionRange end.
                     * @member {number} end
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @instance
                     */
                    ExtensionRange.prototype.end = 0;
    
                    /**
                     * ExtensionRange options.
                     * @member {google.protobuf.IExtensionRangeOptions|null|undefined} options
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @instance
                     */
                    ExtensionRange.prototype.options = null;
    
                    /**
                     * Creates a new ExtensionRange instance using the specified properties.
                     * @function create
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @static
                     * @param {google.protobuf.DescriptorProto.IExtensionRange=} [properties] Properties to set
                     * @returns {google.protobuf.DescriptorProto.ExtensionRange} ExtensionRange instance
                     */
                    ExtensionRange.create = function create(properties) {
                        return new ExtensionRange(properties);
                    };
    
                    /**
                     * Encodes the specified ExtensionRange message. Does not implicitly {@link google.protobuf.DescriptorProto.ExtensionRange.verify|verify} messages.
                     * @function encode
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @static
                     * @param {google.protobuf.DescriptorProto.IExtensionRange} message ExtensionRange message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    ExtensionRange.encode = function encode(message, writer) {
                        if (!writer)
                            writer = $Writer.create();
                        if (message.start != null && Object.hasOwnProperty.call(message, "start"))
                            writer.uint32(/* id 1, wireType 0 =*/8).int32(message.start);
                        if (message.end != null && Object.hasOwnProperty.call(message, "end"))
                            writer.uint32(/* id 2, wireType 0 =*/16).int32(message.end);
                        if (message.options != null && Object.hasOwnProperty.call(message, "options"))
                            $root.google.protobuf.ExtensionRangeOptions.encode(message.options, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                        return writer;
                    };
    
                    /**
                     * Encodes the specified ExtensionRange message, length delimited. Does not implicitly {@link google.protobuf.DescriptorProto.ExtensionRange.verify|verify} messages.
                     * @function encodeDelimited
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @static
                     * @param {google.protobuf.DescriptorProto.IExtensionRange} message ExtensionRange message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    ExtensionRange.encodeDelimited = function encodeDelimited(message, writer) {
                        return this.encode(message, writer).ldelim();
                    };
    
                    /**
                     * Decodes an ExtensionRange message from the specified reader or buffer.
                     * @function decode
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @param {number} [length] Message length if known beforehand
                     * @returns {google.protobuf.DescriptorProto.ExtensionRange} ExtensionRange
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    ExtensionRange.decode = function decode(reader, length) {
                        if (!(reader instanceof $Reader))
                            reader = $Reader.create(reader);
                        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.DescriptorProto.ExtensionRange();
                        while (reader.pos < end) {
                            var tag = reader.uint32();
                            switch (tag >>> 3) {
                            case 1: {
                                    message.start = reader.int32();
                                    break;
                                }
                            case 2: {
                                    message.end = reader.int32();
                                    break;
                                }
                            case 3: {
                                    message.options = $root.google.protobuf.ExtensionRangeOptions.decode(reader, reader.uint32());
                                    break;
                                }
                            default:
                                reader.skipType(tag & 7);
                                break;
                            }
                        }
                        return message;
                    };
    
                    /**
                     * Decodes an ExtensionRange message from the specified reader or buffer, length delimited.
                     * @function decodeDelimited
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @returns {google.protobuf.DescriptorProto.ExtensionRange} ExtensionRange
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    ExtensionRange.decodeDelimited = function decodeDelimited(reader) {
                        if (!(reader instanceof $Reader))
                            reader = new $Reader(reader);
                        return this.decode(reader, reader.uint32());
                    };
    
                    /**
                     * Verifies an ExtensionRange message.
                     * @function verify
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @static
                     * @param {Object.<string,*>} message Plain object to verify
                     * @returns {string|null} `null` if valid, otherwise the reason why it is not
                     */
                    ExtensionRange.verify = function verify(message) {
                        if (typeof message !== "object" || message === null)
                            return "object expected";
                        if (message.start != null && message.hasOwnProperty("start"))
                            if (!$util.isInteger(message.start))
                                return "start: integer expected";
                        if (message.end != null && message.hasOwnProperty("end"))
                            if (!$util.isInteger(message.end))
                                return "end: integer expected";
                        if (message.options != null && message.hasOwnProperty("options")) {
                            var error = $root.google.protobuf.ExtensionRangeOptions.verify(message.options);
                            if (error)
                                return "options." + error;
                        }
                        return null;
                    };
    
                    /**
                     * Creates an ExtensionRange message from a plain object. Also converts values to their respective internal types.
                     * @function fromObject
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @static
                     * @param {Object.<string,*>} object Plain object
                     * @returns {google.protobuf.DescriptorProto.ExtensionRange} ExtensionRange
                     */
                    ExtensionRange.fromObject = function fromObject(object) {
                        if (object instanceof $root.google.protobuf.DescriptorProto.ExtensionRange)
                            return object;
                        var message = new $root.google.protobuf.DescriptorProto.ExtensionRange();
                        if (object.start != null)
                            message.start = object.start | 0;
                        if (object.end != null)
                            message.end = object.end | 0;
                        if (object.options != null) {
                            if (typeof object.options !== "object")
                                throw TypeError(".google.protobuf.DescriptorProto.ExtensionRange.options: object expected");
                            message.options = $root.google.protobuf.ExtensionRangeOptions.fromObject(object.options);
                        }
                        return message;
                    };
    
                    /**
                     * Creates a plain object from an ExtensionRange message. Also converts values to other types if specified.
                     * @function toObject
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @static
                     * @param {google.protobuf.DescriptorProto.ExtensionRange} message ExtensionRange
                     * @param {$protobuf.IConversionOptions} [options] Conversion options
                     * @returns {Object.<string,*>} Plain object
                     */
                    ExtensionRange.toObject = function toObject(message, options) {
                        if (!options)
                            options = {};
                        var object = {};
                        if (options.defaults) {
                            object.start = 0;
                            object.end = 0;
                            object.options = null;
                        }
                        if (message.start != null && message.hasOwnProperty("start"))
                            object.start = message.start;
                        if (message.end != null && message.hasOwnProperty("end"))
                            object.end = message.end;
                        if (message.options != null && message.hasOwnProperty("options"))
                            object.options = $root.google.protobuf.ExtensionRangeOptions.toObject(message.options, options);
                        return object;
                    };
    
                    /**
                     * Converts this ExtensionRange to JSON.
                     * @function toJSON
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @instance
                     * @returns {Object.<string,*>} JSON object
                     */
                    ExtensionRange.prototype.toJSON = function toJSON() {
                        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                    };
    
                    /**
                     * Gets the default type url for ExtensionRange
                     * @function getTypeUrl
                     * @memberof google.protobuf.DescriptorProto.ExtensionRange
                     * @static
                     * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                     * @returns {string} The default type url
                     */
                    ExtensionRange.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                        if (typeUrlPrefix === undefined) {
                            typeUrlPrefix = "type.googleapis.com";
                        }
                        return typeUrlPrefix + "/google.protobuf.DescriptorProto.ExtensionRange";
                    };
    
                    return ExtensionRange;
                })();
    
                DescriptorProto.ReservedRange = (function() {
    
                    /**
                     * Properties of a ReservedRange.
                     * @memberof google.protobuf.DescriptorProto
                     * @interface IReservedRange
                     * @property {number|null} [start] ReservedRange start
                     * @property {number|null} [end] ReservedRange end
                     */
    
                    /**
                     * Constructs a new ReservedRange.
                     * @memberof google.protobuf.DescriptorProto
                     * @classdesc Represents a ReservedRange.
                     * @implements IReservedRange
                     * @constructor
                     * @param {google.protobuf.DescriptorProto.IReservedRange=} [properties] Properties to set
                     */
                    function ReservedRange(properties) {
                        if (properties)
                            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                if (properties[keys[i]] != null)
                                    this[keys[i]] = properties[keys[i]];
                    }
    
                    /**
                     * ReservedRange start.
                     * @member {number} start
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @instance
                     */
                    ReservedRange.prototype.start = 0;
    
                    /**
                     * ReservedRange end.
                     * @member {number} end
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @instance
                     */
                    ReservedRange.prototype.end = 0;
    
                    /**
                     * Creates a new ReservedRange instance using the specified properties.
                     * @function create
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @static
                     * @param {google.protobuf.DescriptorProto.IReservedRange=} [properties] Properties to set
                     * @returns {google.protobuf.DescriptorProto.ReservedRange} ReservedRange instance
                     */
                    ReservedRange.create = function create(properties) {
                        return new ReservedRange(properties);
                    };
    
                    /**
                     * Encodes the specified ReservedRange message. Does not implicitly {@link google.protobuf.DescriptorProto.ReservedRange.verify|verify} messages.
                     * @function encode
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @static
                     * @param {google.protobuf.DescriptorProto.IReservedRange} message ReservedRange message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    ReservedRange.encode = function encode(message, writer) {
                        if (!writer)
                            writer = $Writer.create();
                        if (message.start != null && Object.hasOwnProperty.call(message, "start"))
                            writer.uint32(/* id 1, wireType 0 =*/8).int32(message.start);
                        if (message.end != null && Object.hasOwnProperty.call(message, "end"))
                            writer.uint32(/* id 2, wireType 0 =*/16).int32(message.end);
                        return writer;
                    };
    
                    /**
                     * Encodes the specified ReservedRange message, length delimited. Does not implicitly {@link google.protobuf.DescriptorProto.ReservedRange.verify|verify} messages.
                     * @function encodeDelimited
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @static
                     * @param {google.protobuf.DescriptorProto.IReservedRange} message ReservedRange message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    ReservedRange.encodeDelimited = function encodeDelimited(message, writer) {
                        return this.encode(message, writer).ldelim();
                    };
    
                    /**
                     * Decodes a ReservedRange message from the specified reader or buffer.
                     * @function decode
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @param {number} [length] Message length if known beforehand
                     * @returns {google.protobuf.DescriptorProto.ReservedRange} ReservedRange
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    ReservedRange.decode = function decode(reader, length) {
                        if (!(reader instanceof $Reader))
                            reader = $Reader.create(reader);
                        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.DescriptorProto.ReservedRange();
                        while (reader.pos < end) {
                            var tag = reader.uint32();
                            switch (tag >>> 3) {
                            case 1: {
                                    message.start = reader.int32();
                                    break;
                                }
                            case 2: {
                                    message.end = reader.int32();
                                    break;
                                }
                            default:
                                reader.skipType(tag & 7);
                                break;
                            }
                        }
                        return message;
                    };
    
                    /**
                     * Decodes a ReservedRange message from the specified reader or buffer, length delimited.
                     * @function decodeDelimited
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @returns {google.protobuf.DescriptorProto.ReservedRange} ReservedRange
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    ReservedRange.decodeDelimited = function decodeDelimited(reader) {
                        if (!(reader instanceof $Reader))
                            reader = new $Reader(reader);
                        return this.decode(reader, reader.uint32());
                    };
    
                    /**
                     * Verifies a ReservedRange message.
                     * @function verify
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @static
                     * @param {Object.<string,*>} message Plain object to verify
                     * @returns {string|null} `null` if valid, otherwise the reason why it is not
                     */
                    ReservedRange.verify = function verify(message) {
                        if (typeof message !== "object" || message === null)
                            return "object expected";
                        if (message.start != null && message.hasOwnProperty("start"))
                            if (!$util.isInteger(message.start))
                                return "start: integer expected";
                        if (message.end != null && message.hasOwnProperty("end"))
                            if (!$util.isInteger(message.end))
                                return "end: integer expected";
                        return null;
                    };
    
                    /**
                     * Creates a ReservedRange message from a plain object. Also converts values to their respective internal types.
                     * @function fromObject
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @static
                     * @param {Object.<string,*>} object Plain object
                     * @returns {google.protobuf.DescriptorProto.ReservedRange} ReservedRange
                     */
                    ReservedRange.fromObject = function fromObject(object) {
                        if (object instanceof $root.google.protobuf.DescriptorProto.ReservedRange)
                            return object;
                        var message = new $root.google.protobuf.DescriptorProto.ReservedRange();
                        if (object.start != null)
                            message.start = object.start | 0;
                        if (object.end != null)
                            message.end = object.end | 0;
                        return message;
                    };
    
                    /**
                     * Creates a plain object from a ReservedRange message. Also converts values to other types if specified.
                     * @function toObject
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @static
                     * @param {google.protobuf.DescriptorProto.ReservedRange} message ReservedRange
                     * @param {$protobuf.IConversionOptions} [options] Conversion options
                     * @returns {Object.<string,*>} Plain object
                     */
                    ReservedRange.toObject = function toObject(message, options) {
                        if (!options)
                            options = {};
                        var object = {};
                        if (options.defaults) {
                            object.start = 0;
                            object.end = 0;
                        }
                        if (message.start != null && message.hasOwnProperty("start"))
                            object.start = message.start;
                        if (message.end != null && message.hasOwnProperty("end"))
                            object.end = message.end;
                        return object;
                    };
    
                    /**
                     * Converts this ReservedRange to JSON.
                     * @function toJSON
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @instance
                     * @returns {Object.<string,*>} JSON object
                     */
                    ReservedRange.prototype.toJSON = function toJSON() {
                        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                    };
    
                    /**
                     * Gets the default type url for ReservedRange
                     * @function getTypeUrl
                     * @memberof google.protobuf.DescriptorProto.ReservedRange
                     * @static
                     * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                     * @returns {string} The default type url
                     */
                    ReservedRange.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                        if (typeUrlPrefix === undefined) {
                            typeUrlPrefix = "type.googleapis.com";
                        }
                        return typeUrlPrefix + "/google.protobuf.DescriptorProto.ReservedRange";
                    };
    
                    return ReservedRange;
                })();
    
                return DescriptorProto;
            })();
    
            protobuf.ExtensionRangeOptions = (function() {
    
                /**
                 * Properties of an ExtensionRangeOptions.
                 * @memberof google.protobuf
                 * @interface IExtensionRangeOptions
                 * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] ExtensionRangeOptions uninterpretedOption
                 */
    
                /**
                 * Constructs a new ExtensionRangeOptions.
                 * @memberof google.protobuf
                 * @classdesc Represents an ExtensionRangeOptions.
                 * @implements IExtensionRangeOptions
                 * @constructor
                 * @param {google.protobuf.IExtensionRangeOptions=} [properties] Properties to set
                 */
                function ExtensionRangeOptions(properties) {
                    this.uninterpretedOption = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * ExtensionRangeOptions uninterpretedOption.
                 * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @instance
                 */
                ExtensionRangeOptions.prototype.uninterpretedOption = $util.emptyArray;
    
                /**
                 * Creates a new ExtensionRangeOptions instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @static
                 * @param {google.protobuf.IExtensionRangeOptions=} [properties] Properties to set
                 * @returns {google.protobuf.ExtensionRangeOptions} ExtensionRangeOptions instance
                 */
                ExtensionRangeOptions.create = function create(properties) {
                    return new ExtensionRangeOptions(properties);
                };
    
                /**
                 * Encodes the specified ExtensionRangeOptions message. Does not implicitly {@link google.protobuf.ExtensionRangeOptions.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @static
                 * @param {google.protobuf.IExtensionRangeOptions} message ExtensionRangeOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ExtensionRangeOptions.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                        for (var i = 0; i < message.uninterpretedOption.length; ++i)
                            $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified ExtensionRangeOptions message, length delimited. Does not implicitly {@link google.protobuf.ExtensionRangeOptions.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @static
                 * @param {google.protobuf.IExtensionRangeOptions} message ExtensionRangeOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ExtensionRangeOptions.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an ExtensionRangeOptions message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.ExtensionRangeOptions} ExtensionRangeOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ExtensionRangeOptions.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.ExtensionRangeOptions();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 999: {
                                if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                                    message.uninterpretedOption = [];
                                message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an ExtensionRangeOptions message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.ExtensionRangeOptions} ExtensionRangeOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ExtensionRangeOptions.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an ExtensionRangeOptions message.
                 * @function verify
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                ExtensionRangeOptions.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                        if (!Array.isArray(message.uninterpretedOption))
                            return "uninterpretedOption: array expected";
                        for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                            var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                            if (error)
                                return "uninterpretedOption." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates an ExtensionRangeOptions message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.ExtensionRangeOptions} ExtensionRangeOptions
                 */
                ExtensionRangeOptions.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.ExtensionRangeOptions)
                        return object;
                    var message = new $root.google.protobuf.ExtensionRangeOptions();
                    if (object.uninterpretedOption) {
                        if (!Array.isArray(object.uninterpretedOption))
                            throw TypeError(".google.protobuf.ExtensionRangeOptions.uninterpretedOption: array expected");
                        message.uninterpretedOption = [];
                        for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                            if (typeof object.uninterpretedOption[i] !== "object")
                                throw TypeError(".google.protobuf.ExtensionRangeOptions.uninterpretedOption: object expected");
                            message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                        }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from an ExtensionRangeOptions message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @static
                 * @param {google.protobuf.ExtensionRangeOptions} message ExtensionRangeOptions
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                ExtensionRangeOptions.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.uninterpretedOption = [];
                    if (message.uninterpretedOption && message.uninterpretedOption.length) {
                        object.uninterpretedOption = [];
                        for (var j = 0; j < message.uninterpretedOption.length; ++j)
                            object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                    }
                    return object;
                };
    
                /**
                 * Converts this ExtensionRangeOptions to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                ExtensionRangeOptions.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for ExtensionRangeOptions
                 * @function getTypeUrl
                 * @memberof google.protobuf.ExtensionRangeOptions
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                ExtensionRangeOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.ExtensionRangeOptions";
                };
    
                return ExtensionRangeOptions;
            })();
    
            protobuf.FieldDescriptorProto = (function() {
    
                /**
                 * Properties of a FieldDescriptorProto.
                 * @memberof google.protobuf
                 * @interface IFieldDescriptorProto
                 * @property {string|null} [name] FieldDescriptorProto name
                 * @property {number|null} [number] FieldDescriptorProto number
                 * @property {google.protobuf.FieldDescriptorProto.Label|null} [label] FieldDescriptorProto label
                 * @property {google.protobuf.FieldDescriptorProto.Type|null} [type] FieldDescriptorProto type
                 * @property {string|null} [typeName] FieldDescriptorProto typeName
                 * @property {string|null} [extendee] FieldDescriptorProto extendee
                 * @property {string|null} [defaultValue] FieldDescriptorProto defaultValue
                 * @property {number|null} [oneofIndex] FieldDescriptorProto oneofIndex
                 * @property {string|null} [jsonName] FieldDescriptorProto jsonName
                 * @property {google.protobuf.IFieldOptions|null} [options] FieldDescriptorProto options
                 * @property {boolean|null} [proto3Optional] FieldDescriptorProto proto3Optional
                 */
    
                /**
                 * Constructs a new FieldDescriptorProto.
                 * @memberof google.protobuf
                 * @classdesc Represents a FieldDescriptorProto.
                 * @implements IFieldDescriptorProto
                 * @constructor
                 * @param {google.protobuf.IFieldDescriptorProto=} [properties] Properties to set
                 */
                function FieldDescriptorProto(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * FieldDescriptorProto name.
                 * @member {string} name
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.name = "";
    
                /**
                 * FieldDescriptorProto number.
                 * @member {number} number
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.number = 0;
    
                /**
                 * FieldDescriptorProto label.
                 * @member {google.protobuf.FieldDescriptorProto.Label} label
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.label = 1;
    
                /**
                 * FieldDescriptorProto type.
                 * @member {google.protobuf.FieldDescriptorProto.Type} type
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.type = 1;
    
                /**
                 * FieldDescriptorProto typeName.
                 * @member {string} typeName
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.typeName = "";
    
                /**
                 * FieldDescriptorProto extendee.
                 * @member {string} extendee
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.extendee = "";
    
                /**
                 * FieldDescriptorProto defaultValue.
                 * @member {string} defaultValue
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.defaultValue = "";
    
                /**
                 * FieldDescriptorProto oneofIndex.
                 * @member {number} oneofIndex
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.oneofIndex = 0;
    
                /**
                 * FieldDescriptorProto jsonName.
                 * @member {string} jsonName
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.jsonName = "";
    
                /**
                 * FieldDescriptorProto options.
                 * @member {google.protobuf.IFieldOptions|null|undefined} options
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.options = null;
    
                /**
                 * FieldDescriptorProto proto3Optional.
                 * @member {boolean} proto3Optional
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 */
                FieldDescriptorProto.prototype.proto3Optional = false;
    
                /**
                 * Creates a new FieldDescriptorProto instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @static
                 * @param {google.protobuf.IFieldDescriptorProto=} [properties] Properties to set
                 * @returns {google.protobuf.FieldDescriptorProto} FieldDescriptorProto instance
                 */
                FieldDescriptorProto.create = function create(properties) {
                    return new FieldDescriptorProto(properties);
                };
    
                /**
                 * Encodes the specified FieldDescriptorProto message. Does not implicitly {@link google.protobuf.FieldDescriptorProto.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @static
                 * @param {google.protobuf.IFieldDescriptorProto} message FieldDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FieldDescriptorProto.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                    if (message.extendee != null && Object.hasOwnProperty.call(message, "extendee"))
                        writer.uint32(/* id 2, wireType 2 =*/18).string(message.extendee);
                    if (message.number != null && Object.hasOwnProperty.call(message, "number"))
                        writer.uint32(/* id 3, wireType 0 =*/24).int32(message.number);
                    if (message.label != null && Object.hasOwnProperty.call(message, "label"))
                        writer.uint32(/* id 4, wireType 0 =*/32).int32(message.label);
                    if (message.type != null && Object.hasOwnProperty.call(message, "type"))
                        writer.uint32(/* id 5, wireType 0 =*/40).int32(message.type);
                    if (message.typeName != null && Object.hasOwnProperty.call(message, "typeName"))
                        writer.uint32(/* id 6, wireType 2 =*/50).string(message.typeName);
                    if (message.defaultValue != null && Object.hasOwnProperty.call(message, "defaultValue"))
                        writer.uint32(/* id 7, wireType 2 =*/58).string(message.defaultValue);
                    if (message.options != null && Object.hasOwnProperty.call(message, "options"))
                        $root.google.protobuf.FieldOptions.encode(message.options, writer.uint32(/* id 8, wireType 2 =*/66).fork()).ldelim();
                    if (message.oneofIndex != null && Object.hasOwnProperty.call(message, "oneofIndex"))
                        writer.uint32(/* id 9, wireType 0 =*/72).int32(message.oneofIndex);
                    if (message.jsonName != null && Object.hasOwnProperty.call(message, "jsonName"))
                        writer.uint32(/* id 10, wireType 2 =*/82).string(message.jsonName);
                    if (message.proto3Optional != null && Object.hasOwnProperty.call(message, "proto3Optional"))
                        writer.uint32(/* id 17, wireType 0 =*/136).bool(message.proto3Optional);
                    return writer;
                };
    
                /**
                 * Encodes the specified FieldDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.FieldDescriptorProto.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @static
                 * @param {google.protobuf.IFieldDescriptorProto} message FieldDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FieldDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a FieldDescriptorProto message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.FieldDescriptorProto} FieldDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FieldDescriptorProto.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.FieldDescriptorProto();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.name = reader.string();
                                break;
                            }
                        case 3: {
                                message.number = reader.int32();
                                break;
                            }
                        case 4: {
                                message.label = reader.int32();
                                break;
                            }
                        case 5: {
                                message.type = reader.int32();
                                break;
                            }
                        case 6: {
                                message.typeName = reader.string();
                                break;
                            }
                        case 2: {
                                message.extendee = reader.string();
                                break;
                            }
                        case 7: {
                                message.defaultValue = reader.string();
                                break;
                            }
                        case 9: {
                                message.oneofIndex = reader.int32();
                                break;
                            }
                        case 10: {
                                message.jsonName = reader.string();
                                break;
                            }
                        case 8: {
                                message.options = $root.google.protobuf.FieldOptions.decode(reader, reader.uint32());
                                break;
                            }
                        case 17: {
                                message.proto3Optional = reader.bool();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a FieldDescriptorProto message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.FieldDescriptorProto} FieldDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FieldDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a FieldDescriptorProto message.
                 * @function verify
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                FieldDescriptorProto.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.name != null && message.hasOwnProperty("name"))
                        if (!$util.isString(message.name))
                            return "name: string expected";
                    if (message.number != null && message.hasOwnProperty("number"))
                        if (!$util.isInteger(message.number))
                            return "number: integer expected";
                    if (message.label != null && message.hasOwnProperty("label"))
                        switch (message.label) {
                        default:
                            return "label: enum value expected";
                        case 1:
                        case 2:
                        case 3:
                            break;
                        }
                    if (message.type != null && message.hasOwnProperty("type"))
                        switch (message.type) {
                        default:
                            return "type: enum value expected";
                        case 1:
                        case 2:
                        case 3:
                        case 4:
                        case 5:
                        case 6:
                        case 7:
                        case 8:
                        case 9:
                        case 10:
                        case 11:
                        case 12:
                        case 13:
                        case 14:
                        case 15:
                        case 16:
                        case 17:
                        case 18:
                            break;
                        }
                    if (message.typeName != null && message.hasOwnProperty("typeName"))
                        if (!$util.isString(message.typeName))
                            return "typeName: string expected";
                    if (message.extendee != null && message.hasOwnProperty("extendee"))
                        if (!$util.isString(message.extendee))
                            return "extendee: string expected";
                    if (message.defaultValue != null && message.hasOwnProperty("defaultValue"))
                        if (!$util.isString(message.defaultValue))
                            return "defaultValue: string expected";
                    if (message.oneofIndex != null && message.hasOwnProperty("oneofIndex"))
                        if (!$util.isInteger(message.oneofIndex))
                            return "oneofIndex: integer expected";
                    if (message.jsonName != null && message.hasOwnProperty("jsonName"))
                        if (!$util.isString(message.jsonName))
                            return "jsonName: string expected";
                    if (message.options != null && message.hasOwnProperty("options")) {
                        var error = $root.google.protobuf.FieldOptions.verify(message.options);
                        if (error)
                            return "options." + error;
                    }
                    if (message.proto3Optional != null && message.hasOwnProperty("proto3Optional"))
                        if (typeof message.proto3Optional !== "boolean")
                            return "proto3Optional: boolean expected";
                    return null;
                };
    
                /**
                 * Creates a FieldDescriptorProto message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.FieldDescriptorProto} FieldDescriptorProto
                 */
                FieldDescriptorProto.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.FieldDescriptorProto)
                        return object;
                    var message = new $root.google.protobuf.FieldDescriptorProto();
                    if (object.name != null)
                        message.name = String(object.name);
                    if (object.number != null)
                        message.number = object.number | 0;
                    switch (object.label) {
                    default:
                        if (typeof object.label === "number") {
                            message.label = object.label;
                            break;
                        }
                        break;
                    case "LABEL_OPTIONAL":
                    case 1:
                        message.label = 1;
                        break;
                    case "LABEL_REQUIRED":
                    case 2:
                        message.label = 2;
                        break;
                    case "LABEL_REPEATED":
                    case 3:
                        message.label = 3;
                        break;
                    }
                    switch (object.type) {
                    default:
                        if (typeof object.type === "number") {
                            message.type = object.type;
                            break;
                        }
                        break;
                    case "TYPE_DOUBLE":
                    case 1:
                        message.type = 1;
                        break;
                    case "TYPE_FLOAT":
                    case 2:
                        message.type = 2;
                        break;
                    case "TYPE_INT64":
                    case 3:
                        message.type = 3;
                        break;
                    case "TYPE_UINT64":
                    case 4:
                        message.type = 4;
                        break;
                    case "TYPE_INT32":
                    case 5:
                        message.type = 5;
                        break;
                    case "TYPE_FIXED64":
                    case 6:
                        message.type = 6;
                        break;
                    case "TYPE_FIXED32":
                    case 7:
                        message.type = 7;
                        break;
                    case "TYPE_BOOL":
                    case 8:
                        message.type = 8;
                        break;
                    case "TYPE_STRING":
                    case 9:
                        message.type = 9;
                        break;
                    case "TYPE_GROUP":
                    case 10:
                        message.type = 10;
                        break;
                    case "TYPE_MESSAGE":
                    case 11:
                        message.type = 11;
                        break;
                    case "TYPE_BYTES":
                    case 12:
                        message.type = 12;
                        break;
                    case "TYPE_UINT32":
                    case 13:
                        message.type = 13;
                        break;
                    case "TYPE_ENUM":
                    case 14:
                        message.type = 14;
                        break;
                    case "TYPE_SFIXED32":
                    case 15:
                        message.type = 15;
                        break;
                    case "TYPE_SFIXED64":
                    case 16:
                        message.type = 16;
                        break;
                    case "TYPE_SINT32":
                    case 17:
                        message.type = 17;
                        break;
                    case "TYPE_SINT64":
                    case 18:
                        message.type = 18;
                        break;
                    }
                    if (object.typeName != null)
                        message.typeName = String(object.typeName);
                    if (object.extendee != null)
                        message.extendee = String(object.extendee);
                    if (object.defaultValue != null)
                        message.defaultValue = String(object.defaultValue);
                    if (object.oneofIndex != null)
                        message.oneofIndex = object.oneofIndex | 0;
                    if (object.jsonName != null)
                        message.jsonName = String(object.jsonName);
                    if (object.options != null) {
                        if (typeof object.options !== "object")
                            throw TypeError(".google.protobuf.FieldDescriptorProto.options: object expected");
                        message.options = $root.google.protobuf.FieldOptions.fromObject(object.options);
                    }
                    if (object.proto3Optional != null)
                        message.proto3Optional = Boolean(object.proto3Optional);
                    return message;
                };
    
                /**
                 * Creates a plain object from a FieldDescriptorProto message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @static
                 * @param {google.protobuf.FieldDescriptorProto} message FieldDescriptorProto
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                FieldDescriptorProto.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.name = "";
                        object.extendee = "";
                        object.number = 0;
                        object.label = options.enums === String ? "LABEL_OPTIONAL" : 1;
                        object.type = options.enums === String ? "TYPE_DOUBLE" : 1;
                        object.typeName = "";
                        object.defaultValue = "";
                        object.options = null;
                        object.oneofIndex = 0;
                        object.jsonName = "";
                        object.proto3Optional = false;
                    }
                    if (message.name != null && message.hasOwnProperty("name"))
                        object.name = message.name;
                    if (message.extendee != null && message.hasOwnProperty("extendee"))
                        object.extendee = message.extendee;
                    if (message.number != null && message.hasOwnProperty("number"))
                        object.number = message.number;
                    if (message.label != null && message.hasOwnProperty("label"))
                        object.label = options.enums === String ? $root.google.protobuf.FieldDescriptorProto.Label[message.label] === undefined ? message.label : $root.google.protobuf.FieldDescriptorProto.Label[message.label] : message.label;
                    if (message.type != null && message.hasOwnProperty("type"))
                        object.type = options.enums === String ? $root.google.protobuf.FieldDescriptorProto.Type[message.type] === undefined ? message.type : $root.google.protobuf.FieldDescriptorProto.Type[message.type] : message.type;
                    if (message.typeName != null && message.hasOwnProperty("typeName"))
                        object.typeName = message.typeName;
                    if (message.defaultValue != null && message.hasOwnProperty("defaultValue"))
                        object.defaultValue = message.defaultValue;
                    if (message.options != null && message.hasOwnProperty("options"))
                        object.options = $root.google.protobuf.FieldOptions.toObject(message.options, options);
                    if (message.oneofIndex != null && message.hasOwnProperty("oneofIndex"))
                        object.oneofIndex = message.oneofIndex;
                    if (message.jsonName != null && message.hasOwnProperty("jsonName"))
                        object.jsonName = message.jsonName;
                    if (message.proto3Optional != null && message.hasOwnProperty("proto3Optional"))
                        object.proto3Optional = message.proto3Optional;
                    return object;
                };
    
                /**
                 * Converts this FieldDescriptorProto to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                FieldDescriptorProto.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for FieldDescriptorProto
                 * @function getTypeUrl
                 * @memberof google.protobuf.FieldDescriptorProto
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                FieldDescriptorProto.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.FieldDescriptorProto";
                };
    
                /**
                 * Type enum.
                 * @name google.protobuf.FieldDescriptorProto.Type
                 * @enum {number}
                 * @property {number} TYPE_DOUBLE=1 TYPE_DOUBLE value
                 * @property {number} TYPE_FLOAT=2 TYPE_FLOAT value
                 * @property {number} TYPE_INT64=3 TYPE_INT64 value
                 * @property {number} TYPE_UINT64=4 TYPE_UINT64 value
                 * @property {number} TYPE_INT32=5 TYPE_INT32 value
                 * @property {number} TYPE_FIXED64=6 TYPE_FIXED64 value
                 * @property {number} TYPE_FIXED32=7 TYPE_FIXED32 value
                 * @property {number} TYPE_BOOL=8 TYPE_BOOL value
                 * @property {number} TYPE_STRING=9 TYPE_STRING value
                 * @property {number} TYPE_GROUP=10 TYPE_GROUP value
                 * @property {number} TYPE_MESSAGE=11 TYPE_MESSAGE value
                 * @property {number} TYPE_BYTES=12 TYPE_BYTES value
                 * @property {number} TYPE_UINT32=13 TYPE_UINT32 value
                 * @property {number} TYPE_ENUM=14 TYPE_ENUM value
                 * @property {number} TYPE_SFIXED32=15 TYPE_SFIXED32 value
                 * @property {number} TYPE_SFIXED64=16 TYPE_SFIXED64 value
                 * @property {number} TYPE_SINT32=17 TYPE_SINT32 value
                 * @property {number} TYPE_SINT64=18 TYPE_SINT64 value
                 */
                FieldDescriptorProto.Type = (function() {
                    var valuesById = {}, values = Object.create(valuesById);
                    values[valuesById[1] = "TYPE_DOUBLE"] = 1;
                    values[valuesById[2] = "TYPE_FLOAT"] = 2;
                    values[valuesById[3] = "TYPE_INT64"] = 3;
                    values[valuesById[4] = "TYPE_UINT64"] = 4;
                    values[valuesById[5] = "TYPE_INT32"] = 5;
                    values[valuesById[6] = "TYPE_FIXED64"] = 6;
                    values[valuesById[7] = "TYPE_FIXED32"] = 7;
                    values[valuesById[8] = "TYPE_BOOL"] = 8;
                    values[valuesById[9] = "TYPE_STRING"] = 9;
                    values[valuesById[10] = "TYPE_GROUP"] = 10;
                    values[valuesById[11] = "TYPE_MESSAGE"] = 11;
                    values[valuesById[12] = "TYPE_BYTES"] = 12;
                    values[valuesById[13] = "TYPE_UINT32"] = 13;
                    values[valuesById[14] = "TYPE_ENUM"] = 14;
                    values[valuesById[15] = "TYPE_SFIXED32"] = 15;
                    values[valuesById[16] = "TYPE_SFIXED64"] = 16;
                    values[valuesById[17] = "TYPE_SINT32"] = 17;
                    values[valuesById[18] = "TYPE_SINT64"] = 18;
                    return values;
                })();
    
                /**
                 * Label enum.
                 * @name google.protobuf.FieldDescriptorProto.Label
                 * @enum {number}
                 * @property {number} LABEL_OPTIONAL=1 LABEL_OPTIONAL value
                 * @property {number} LABEL_REQUIRED=2 LABEL_REQUIRED value
                 * @property {number} LABEL_REPEATED=3 LABEL_REPEATED value
                 */
                FieldDescriptorProto.Label = (function() {
                    var valuesById = {}, values = Object.create(valuesById);
                    values[valuesById[1] = "LABEL_OPTIONAL"] = 1;
                    values[valuesById[2] = "LABEL_REQUIRED"] = 2;
                    values[valuesById[3] = "LABEL_REPEATED"] = 3;
                    return values;
                })();
    
                return FieldDescriptorProto;
            })();
    
            protobuf.OneofDescriptorProto = (function() {
    
                /**
                 * Properties of an OneofDescriptorProto.
                 * @memberof google.protobuf
                 * @interface IOneofDescriptorProto
                 * @property {string|null} [name] OneofDescriptorProto name
                 * @property {google.protobuf.IOneofOptions|null} [options] OneofDescriptorProto options
                 */
    
                /**
                 * Constructs a new OneofDescriptorProto.
                 * @memberof google.protobuf
                 * @classdesc Represents an OneofDescriptorProto.
                 * @implements IOneofDescriptorProto
                 * @constructor
                 * @param {google.protobuf.IOneofDescriptorProto=} [properties] Properties to set
                 */
                function OneofDescriptorProto(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * OneofDescriptorProto name.
                 * @member {string} name
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @instance
                 */
                OneofDescriptorProto.prototype.name = "";
    
                /**
                 * OneofDescriptorProto options.
                 * @member {google.protobuf.IOneofOptions|null|undefined} options
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @instance
                 */
                OneofDescriptorProto.prototype.options = null;
    
                /**
                 * Creates a new OneofDescriptorProto instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @static
                 * @param {google.protobuf.IOneofDescriptorProto=} [properties] Properties to set
                 * @returns {google.protobuf.OneofDescriptorProto} OneofDescriptorProto instance
                 */
                OneofDescriptorProto.create = function create(properties) {
                    return new OneofDescriptorProto(properties);
                };
    
                /**
                 * Encodes the specified OneofDescriptorProto message. Does not implicitly {@link google.protobuf.OneofDescriptorProto.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @static
                 * @param {google.protobuf.IOneofDescriptorProto} message OneofDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                OneofDescriptorProto.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                    if (message.options != null && Object.hasOwnProperty.call(message, "options"))
                        $root.google.protobuf.OneofOptions.encode(message.options, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified OneofDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.OneofDescriptorProto.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @static
                 * @param {google.protobuf.IOneofDescriptorProto} message OneofDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                OneofDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an OneofDescriptorProto message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.OneofDescriptorProto} OneofDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                OneofDescriptorProto.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.OneofDescriptorProto();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.name = reader.string();
                                break;
                            }
                        case 2: {
                                message.options = $root.google.protobuf.OneofOptions.decode(reader, reader.uint32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an OneofDescriptorProto message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.OneofDescriptorProto} OneofDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                OneofDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an OneofDescriptorProto message.
                 * @function verify
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                OneofDescriptorProto.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.name != null && message.hasOwnProperty("name"))
                        if (!$util.isString(message.name))
                            return "name: string expected";
                    if (message.options != null && message.hasOwnProperty("options")) {
                        var error = $root.google.protobuf.OneofOptions.verify(message.options);
                        if (error)
                            return "options." + error;
                    }
                    return null;
                };
    
                /**
                 * Creates an OneofDescriptorProto message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.OneofDescriptorProto} OneofDescriptorProto
                 */
                OneofDescriptorProto.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.OneofDescriptorProto)
                        return object;
                    var message = new $root.google.protobuf.OneofDescriptorProto();
                    if (object.name != null)
                        message.name = String(object.name);
                    if (object.options != null) {
                        if (typeof object.options !== "object")
                            throw TypeError(".google.protobuf.OneofDescriptorProto.options: object expected");
                        message.options = $root.google.protobuf.OneofOptions.fromObject(object.options);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from an OneofDescriptorProto message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @static
                 * @param {google.protobuf.OneofDescriptorProto} message OneofDescriptorProto
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                OneofDescriptorProto.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.name = "";
                        object.options = null;
                    }
                    if (message.name != null && message.hasOwnProperty("name"))
                        object.name = message.name;
                    if (message.options != null && message.hasOwnProperty("options"))
                        object.options = $root.google.protobuf.OneofOptions.toObject(message.options, options);
                    return object;
                };
    
                /**
                 * Converts this OneofDescriptorProto to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                OneofDescriptorProto.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for OneofDescriptorProto
                 * @function getTypeUrl
                 * @memberof google.protobuf.OneofDescriptorProto
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                OneofDescriptorProto.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.OneofDescriptorProto";
                };
    
                return OneofDescriptorProto;
            })();
    
            protobuf.EnumDescriptorProto = (function() {
    
                /**
                 * Properties of an EnumDescriptorProto.
                 * @memberof google.protobuf
                 * @interface IEnumDescriptorProto
                 * @property {string|null} [name] EnumDescriptorProto name
                 * @property {Array.<google.protobuf.IEnumValueDescriptorProto>|null} [value] EnumDescriptorProto value
                 * @property {google.protobuf.IEnumOptions|null} [options] EnumDescriptorProto options
                 * @property {Array.<google.protobuf.EnumDescriptorProto.IEnumReservedRange>|null} [reservedRange] EnumDescriptorProto reservedRange
                 * @property {Array.<string>|null} [reservedName] EnumDescriptorProto reservedName
                 */
    
                /**
                 * Constructs a new EnumDescriptorProto.
                 * @memberof google.protobuf
                 * @classdesc Represents an EnumDescriptorProto.
                 * @implements IEnumDescriptorProto
                 * @constructor
                 * @param {google.protobuf.IEnumDescriptorProto=} [properties] Properties to set
                 */
                function EnumDescriptorProto(properties) {
                    this.value = [];
                    this.reservedRange = [];
                    this.reservedName = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * EnumDescriptorProto name.
                 * @member {string} name
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @instance
                 */
                EnumDescriptorProto.prototype.name = "";
    
                /**
                 * EnumDescriptorProto value.
                 * @member {Array.<google.protobuf.IEnumValueDescriptorProto>} value
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @instance
                 */
                EnumDescriptorProto.prototype.value = $util.emptyArray;
    
                /**
                 * EnumDescriptorProto options.
                 * @member {google.protobuf.IEnumOptions|null|undefined} options
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @instance
                 */
                EnumDescriptorProto.prototype.options = null;
    
                /**
                 * EnumDescriptorProto reservedRange.
                 * @member {Array.<google.protobuf.EnumDescriptorProto.IEnumReservedRange>} reservedRange
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @instance
                 */
                EnumDescriptorProto.prototype.reservedRange = $util.emptyArray;
    
                /**
                 * EnumDescriptorProto reservedName.
                 * @member {Array.<string>} reservedName
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @instance
                 */
                EnumDescriptorProto.prototype.reservedName = $util.emptyArray;
    
                /**
                 * Creates a new EnumDescriptorProto instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @static
                 * @param {google.protobuf.IEnumDescriptorProto=} [properties] Properties to set
                 * @returns {google.protobuf.EnumDescriptorProto} EnumDescriptorProto instance
                 */
                EnumDescriptorProto.create = function create(properties) {
                    return new EnumDescriptorProto(properties);
                };
    
                /**
                 * Encodes the specified EnumDescriptorProto message. Does not implicitly {@link google.protobuf.EnumDescriptorProto.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @static
                 * @param {google.protobuf.IEnumDescriptorProto} message EnumDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                EnumDescriptorProto.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                    if (message.value != null && message.value.length)
                        for (var i = 0; i < message.value.length; ++i)
                            $root.google.protobuf.EnumValueDescriptorProto.encode(message.value[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                    if (message.options != null && Object.hasOwnProperty.call(message, "options"))
                        $root.google.protobuf.EnumOptions.encode(message.options, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                    if (message.reservedRange != null && message.reservedRange.length)
                        for (var i = 0; i < message.reservedRange.length; ++i)
                            $root.google.protobuf.EnumDescriptorProto.EnumReservedRange.encode(message.reservedRange[i], writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                    if (message.reservedName != null && message.reservedName.length)
                        for (var i = 0; i < message.reservedName.length; ++i)
                            writer.uint32(/* id 5, wireType 2 =*/42).string(message.reservedName[i]);
                    return writer;
                };
    
                /**
                 * Encodes the specified EnumDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.EnumDescriptorProto.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @static
                 * @param {google.protobuf.IEnumDescriptorProto} message EnumDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                EnumDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an EnumDescriptorProto message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.EnumDescriptorProto} EnumDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                EnumDescriptorProto.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.EnumDescriptorProto();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.name = reader.string();
                                break;
                            }
                        case 2: {
                                if (!(message.value && message.value.length))
                                    message.value = [];
                                message.value.push($root.google.protobuf.EnumValueDescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 3: {
                                message.options = $root.google.protobuf.EnumOptions.decode(reader, reader.uint32());
                                break;
                            }
                        case 4: {
                                if (!(message.reservedRange && message.reservedRange.length))
                                    message.reservedRange = [];
                                message.reservedRange.push($root.google.protobuf.EnumDescriptorProto.EnumReservedRange.decode(reader, reader.uint32()));
                                break;
                            }
                        case 5: {
                                if (!(message.reservedName && message.reservedName.length))
                                    message.reservedName = [];
                                message.reservedName.push(reader.string());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an EnumDescriptorProto message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.EnumDescriptorProto} EnumDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                EnumDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an EnumDescriptorProto message.
                 * @function verify
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                EnumDescriptorProto.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.name != null && message.hasOwnProperty("name"))
                        if (!$util.isString(message.name))
                            return "name: string expected";
                    if (message.value != null && message.hasOwnProperty("value")) {
                        if (!Array.isArray(message.value))
                            return "value: array expected";
                        for (var i = 0; i < message.value.length; ++i) {
                            var error = $root.google.protobuf.EnumValueDescriptorProto.verify(message.value[i]);
                            if (error)
                                return "value." + error;
                        }
                    }
                    if (message.options != null && message.hasOwnProperty("options")) {
                        var error = $root.google.protobuf.EnumOptions.verify(message.options);
                        if (error)
                            return "options." + error;
                    }
                    if (message.reservedRange != null && message.hasOwnProperty("reservedRange")) {
                        if (!Array.isArray(message.reservedRange))
                            return "reservedRange: array expected";
                        for (var i = 0; i < message.reservedRange.length; ++i) {
                            var error = $root.google.protobuf.EnumDescriptorProto.EnumReservedRange.verify(message.reservedRange[i]);
                            if (error)
                                return "reservedRange." + error;
                        }
                    }
                    if (message.reservedName != null && message.hasOwnProperty("reservedName")) {
                        if (!Array.isArray(message.reservedName))
                            return "reservedName: array expected";
                        for (var i = 0; i < message.reservedName.length; ++i)
                            if (!$util.isString(message.reservedName[i]))
                                return "reservedName: string[] expected";
                    }
                    return null;
                };
    
                /**
                 * Creates an EnumDescriptorProto message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.EnumDescriptorProto} EnumDescriptorProto
                 */
                EnumDescriptorProto.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.EnumDescriptorProto)
                        return object;
                    var message = new $root.google.protobuf.EnumDescriptorProto();
                    if (object.name != null)
                        message.name = String(object.name);
                    if (object.value) {
                        if (!Array.isArray(object.value))
                            throw TypeError(".google.protobuf.EnumDescriptorProto.value: array expected");
                        message.value = [];
                        for (var i = 0; i < object.value.length; ++i) {
                            if (typeof object.value[i] !== "object")
                                throw TypeError(".google.protobuf.EnumDescriptorProto.value: object expected");
                            message.value[i] = $root.google.protobuf.EnumValueDescriptorProto.fromObject(object.value[i]);
                        }
                    }
                    if (object.options != null) {
                        if (typeof object.options !== "object")
                            throw TypeError(".google.protobuf.EnumDescriptorProto.options: object expected");
                        message.options = $root.google.protobuf.EnumOptions.fromObject(object.options);
                    }
                    if (object.reservedRange) {
                        if (!Array.isArray(object.reservedRange))
                            throw TypeError(".google.protobuf.EnumDescriptorProto.reservedRange: array expected");
                        message.reservedRange = [];
                        for (var i = 0; i < object.reservedRange.length; ++i) {
                            if (typeof object.reservedRange[i] !== "object")
                                throw TypeError(".google.protobuf.EnumDescriptorProto.reservedRange: object expected");
                            message.reservedRange[i] = $root.google.protobuf.EnumDescriptorProto.EnumReservedRange.fromObject(object.reservedRange[i]);
                        }
                    }
                    if (object.reservedName) {
                        if (!Array.isArray(object.reservedName))
                            throw TypeError(".google.protobuf.EnumDescriptorProto.reservedName: array expected");
                        message.reservedName = [];
                        for (var i = 0; i < object.reservedName.length; ++i)
                            message.reservedName[i] = String(object.reservedName[i]);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from an EnumDescriptorProto message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @static
                 * @param {google.protobuf.EnumDescriptorProto} message EnumDescriptorProto
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                EnumDescriptorProto.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults) {
                        object.value = [];
                        object.reservedRange = [];
                        object.reservedName = [];
                    }
                    if (options.defaults) {
                        object.name = "";
                        object.options = null;
                    }
                    if (message.name != null && message.hasOwnProperty("name"))
                        object.name = message.name;
                    if (message.value && message.value.length) {
                        object.value = [];
                        for (var j = 0; j < message.value.length; ++j)
                            object.value[j] = $root.google.protobuf.EnumValueDescriptorProto.toObject(message.value[j], options);
                    }
                    if (message.options != null && message.hasOwnProperty("options"))
                        object.options = $root.google.protobuf.EnumOptions.toObject(message.options, options);
                    if (message.reservedRange && message.reservedRange.length) {
                        object.reservedRange = [];
                        for (var j = 0; j < message.reservedRange.length; ++j)
                            object.reservedRange[j] = $root.google.protobuf.EnumDescriptorProto.EnumReservedRange.toObject(message.reservedRange[j], options);
                    }
                    if (message.reservedName && message.reservedName.length) {
                        object.reservedName = [];
                        for (var j = 0; j < message.reservedName.length; ++j)
                            object.reservedName[j] = message.reservedName[j];
                    }
                    return object;
                };
    
                /**
                 * Converts this EnumDescriptorProto to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                EnumDescriptorProto.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for EnumDescriptorProto
                 * @function getTypeUrl
                 * @memberof google.protobuf.EnumDescriptorProto
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                EnumDescriptorProto.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.EnumDescriptorProto";
                };
    
                EnumDescriptorProto.EnumReservedRange = (function() {
    
                    /**
                     * Properties of an EnumReservedRange.
                     * @memberof google.protobuf.EnumDescriptorProto
                     * @interface IEnumReservedRange
                     * @property {number|null} [start] EnumReservedRange start
                     * @property {number|null} [end] EnumReservedRange end
                     */
    
                    /**
                     * Constructs a new EnumReservedRange.
                     * @memberof google.protobuf.EnumDescriptorProto
                     * @classdesc Represents an EnumReservedRange.
                     * @implements IEnumReservedRange
                     * @constructor
                     * @param {google.protobuf.EnumDescriptorProto.IEnumReservedRange=} [properties] Properties to set
                     */
                    function EnumReservedRange(properties) {
                        if (properties)
                            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                if (properties[keys[i]] != null)
                                    this[keys[i]] = properties[keys[i]];
                    }
    
                    /**
                     * EnumReservedRange start.
                     * @member {number} start
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @instance
                     */
                    EnumReservedRange.prototype.start = 0;
    
                    /**
                     * EnumReservedRange end.
                     * @member {number} end
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @instance
                     */
                    EnumReservedRange.prototype.end = 0;
    
                    /**
                     * Creates a new EnumReservedRange instance using the specified properties.
                     * @function create
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @static
                     * @param {google.protobuf.EnumDescriptorProto.IEnumReservedRange=} [properties] Properties to set
                     * @returns {google.protobuf.EnumDescriptorProto.EnumReservedRange} EnumReservedRange instance
                     */
                    EnumReservedRange.create = function create(properties) {
                        return new EnumReservedRange(properties);
                    };
    
                    /**
                     * Encodes the specified EnumReservedRange message. Does not implicitly {@link google.protobuf.EnumDescriptorProto.EnumReservedRange.verify|verify} messages.
                     * @function encode
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @static
                     * @param {google.protobuf.EnumDescriptorProto.IEnumReservedRange} message EnumReservedRange message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    EnumReservedRange.encode = function encode(message, writer) {
                        if (!writer)
                            writer = $Writer.create();
                        if (message.start != null && Object.hasOwnProperty.call(message, "start"))
                            writer.uint32(/* id 1, wireType 0 =*/8).int32(message.start);
                        if (message.end != null && Object.hasOwnProperty.call(message, "end"))
                            writer.uint32(/* id 2, wireType 0 =*/16).int32(message.end);
                        return writer;
                    };
    
                    /**
                     * Encodes the specified EnumReservedRange message, length delimited. Does not implicitly {@link google.protobuf.EnumDescriptorProto.EnumReservedRange.verify|verify} messages.
                     * @function encodeDelimited
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @static
                     * @param {google.protobuf.EnumDescriptorProto.IEnumReservedRange} message EnumReservedRange message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    EnumReservedRange.encodeDelimited = function encodeDelimited(message, writer) {
                        return this.encode(message, writer).ldelim();
                    };
    
                    /**
                     * Decodes an EnumReservedRange message from the specified reader or buffer.
                     * @function decode
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @param {number} [length] Message length if known beforehand
                     * @returns {google.protobuf.EnumDescriptorProto.EnumReservedRange} EnumReservedRange
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    EnumReservedRange.decode = function decode(reader, length) {
                        if (!(reader instanceof $Reader))
                            reader = $Reader.create(reader);
                        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.EnumDescriptorProto.EnumReservedRange();
                        while (reader.pos < end) {
                            var tag = reader.uint32();
                            switch (tag >>> 3) {
                            case 1: {
                                    message.start = reader.int32();
                                    break;
                                }
                            case 2: {
                                    message.end = reader.int32();
                                    break;
                                }
                            default:
                                reader.skipType(tag & 7);
                                break;
                            }
                        }
                        return message;
                    };
    
                    /**
                     * Decodes an EnumReservedRange message from the specified reader or buffer, length delimited.
                     * @function decodeDelimited
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @returns {google.protobuf.EnumDescriptorProto.EnumReservedRange} EnumReservedRange
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    EnumReservedRange.decodeDelimited = function decodeDelimited(reader) {
                        if (!(reader instanceof $Reader))
                            reader = new $Reader(reader);
                        return this.decode(reader, reader.uint32());
                    };
    
                    /**
                     * Verifies an EnumReservedRange message.
                     * @function verify
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @static
                     * @param {Object.<string,*>} message Plain object to verify
                     * @returns {string|null} `null` if valid, otherwise the reason why it is not
                     */
                    EnumReservedRange.verify = function verify(message) {
                        if (typeof message !== "object" || message === null)
                            return "object expected";
                        if (message.start != null && message.hasOwnProperty("start"))
                            if (!$util.isInteger(message.start))
                                return "start: integer expected";
                        if (message.end != null && message.hasOwnProperty("end"))
                            if (!$util.isInteger(message.end))
                                return "end: integer expected";
                        return null;
                    };
    
                    /**
                     * Creates an EnumReservedRange message from a plain object. Also converts values to their respective internal types.
                     * @function fromObject
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @static
                     * @param {Object.<string,*>} object Plain object
                     * @returns {google.protobuf.EnumDescriptorProto.EnumReservedRange} EnumReservedRange
                     */
                    EnumReservedRange.fromObject = function fromObject(object) {
                        if (object instanceof $root.google.protobuf.EnumDescriptorProto.EnumReservedRange)
                            return object;
                        var message = new $root.google.protobuf.EnumDescriptorProto.EnumReservedRange();
                        if (object.start != null)
                            message.start = object.start | 0;
                        if (object.end != null)
                            message.end = object.end | 0;
                        return message;
                    };
    
                    /**
                     * Creates a plain object from an EnumReservedRange message. Also converts values to other types if specified.
                     * @function toObject
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @static
                     * @param {google.protobuf.EnumDescriptorProto.EnumReservedRange} message EnumReservedRange
                     * @param {$protobuf.IConversionOptions} [options] Conversion options
                     * @returns {Object.<string,*>} Plain object
                     */
                    EnumReservedRange.toObject = function toObject(message, options) {
                        if (!options)
                            options = {};
                        var object = {};
                        if (options.defaults) {
                            object.start = 0;
                            object.end = 0;
                        }
                        if (message.start != null && message.hasOwnProperty("start"))
                            object.start = message.start;
                        if (message.end != null && message.hasOwnProperty("end"))
                            object.end = message.end;
                        return object;
                    };
    
                    /**
                     * Converts this EnumReservedRange to JSON.
                     * @function toJSON
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @instance
                     * @returns {Object.<string,*>} JSON object
                     */
                    EnumReservedRange.prototype.toJSON = function toJSON() {
                        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                    };
    
                    /**
                     * Gets the default type url for EnumReservedRange
                     * @function getTypeUrl
                     * @memberof google.protobuf.EnumDescriptorProto.EnumReservedRange
                     * @static
                     * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                     * @returns {string} The default type url
                     */
                    EnumReservedRange.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                        if (typeUrlPrefix === undefined) {
                            typeUrlPrefix = "type.googleapis.com";
                        }
                        return typeUrlPrefix + "/google.protobuf.EnumDescriptorProto.EnumReservedRange";
                    };
    
                    return EnumReservedRange;
                })();
    
                return EnumDescriptorProto;
            })();
    
            protobuf.EnumValueDescriptorProto = (function() {
    
                /**
                 * Properties of an EnumValueDescriptorProto.
                 * @memberof google.protobuf
                 * @interface IEnumValueDescriptorProto
                 * @property {string|null} [name] EnumValueDescriptorProto name
                 * @property {number|null} [number] EnumValueDescriptorProto number
                 * @property {google.protobuf.IEnumValueOptions|null} [options] EnumValueDescriptorProto options
                 */
    
                /**
                 * Constructs a new EnumValueDescriptorProto.
                 * @memberof google.protobuf
                 * @classdesc Represents an EnumValueDescriptorProto.
                 * @implements IEnumValueDescriptorProto
                 * @constructor
                 * @param {google.protobuf.IEnumValueDescriptorProto=} [properties] Properties to set
                 */
                function EnumValueDescriptorProto(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * EnumValueDescriptorProto name.
                 * @member {string} name
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @instance
                 */
                EnumValueDescriptorProto.prototype.name = "";
    
                /**
                 * EnumValueDescriptorProto number.
                 * @member {number} number
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @instance
                 */
                EnumValueDescriptorProto.prototype.number = 0;
    
                /**
                 * EnumValueDescriptorProto options.
                 * @member {google.protobuf.IEnumValueOptions|null|undefined} options
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @instance
                 */
                EnumValueDescriptorProto.prototype.options = null;
    
                /**
                 * Creates a new EnumValueDescriptorProto instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @static
                 * @param {google.protobuf.IEnumValueDescriptorProto=} [properties] Properties to set
                 * @returns {google.protobuf.EnumValueDescriptorProto} EnumValueDescriptorProto instance
                 */
                EnumValueDescriptorProto.create = function create(properties) {
                    return new EnumValueDescriptorProto(properties);
                };
    
                /**
                 * Encodes the specified EnumValueDescriptorProto message. Does not implicitly {@link google.protobuf.EnumValueDescriptorProto.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @static
                 * @param {google.protobuf.IEnumValueDescriptorProto} message EnumValueDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                EnumValueDescriptorProto.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                    if (message.number != null && Object.hasOwnProperty.call(message, "number"))
                        writer.uint32(/* id 2, wireType 0 =*/16).int32(message.number);
                    if (message.options != null && Object.hasOwnProperty.call(message, "options"))
                        $root.google.protobuf.EnumValueOptions.encode(message.options, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified EnumValueDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.EnumValueDescriptorProto.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @static
                 * @param {google.protobuf.IEnumValueDescriptorProto} message EnumValueDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                EnumValueDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an EnumValueDescriptorProto message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.EnumValueDescriptorProto} EnumValueDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                EnumValueDescriptorProto.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.EnumValueDescriptorProto();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.name = reader.string();
                                break;
                            }
                        case 2: {
                                message.number = reader.int32();
                                break;
                            }
                        case 3: {
                                message.options = $root.google.protobuf.EnumValueOptions.decode(reader, reader.uint32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an EnumValueDescriptorProto message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.EnumValueDescriptorProto} EnumValueDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                EnumValueDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an EnumValueDescriptorProto message.
                 * @function verify
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                EnumValueDescriptorProto.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.name != null && message.hasOwnProperty("name"))
                        if (!$util.isString(message.name))
                            return "name: string expected";
                    if (message.number != null && message.hasOwnProperty("number"))
                        if (!$util.isInteger(message.number))
                            return "number: integer expected";
                    if (message.options != null && message.hasOwnProperty("options")) {
                        var error = $root.google.protobuf.EnumValueOptions.verify(message.options);
                        if (error)
                            return "options." + error;
                    }
                    return null;
                };
    
                /**
                 * Creates an EnumValueDescriptorProto message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.EnumValueDescriptorProto} EnumValueDescriptorProto
                 */
                EnumValueDescriptorProto.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.EnumValueDescriptorProto)
                        return object;
                    var message = new $root.google.protobuf.EnumValueDescriptorProto();
                    if (object.name != null)
                        message.name = String(object.name);
                    if (object.number != null)
                        message.number = object.number | 0;
                    if (object.options != null) {
                        if (typeof object.options !== "object")
                            throw TypeError(".google.protobuf.EnumValueDescriptorProto.options: object expected");
                        message.options = $root.google.protobuf.EnumValueOptions.fromObject(object.options);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from an EnumValueDescriptorProto message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @static
                 * @param {google.protobuf.EnumValueDescriptorProto} message EnumValueDescriptorProto
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                EnumValueDescriptorProto.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.name = "";
                        object.number = 0;
                        object.options = null;
                    }
                    if (message.name != null && message.hasOwnProperty("name"))
                        object.name = message.name;
                    if (message.number != null && message.hasOwnProperty("number"))
                        object.number = message.number;
                    if (message.options != null && message.hasOwnProperty("options"))
                        object.options = $root.google.protobuf.EnumValueOptions.toObject(message.options, options);
                    return object;
                };
    
                /**
                 * Converts this EnumValueDescriptorProto to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                EnumValueDescriptorProto.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for EnumValueDescriptorProto
                 * @function getTypeUrl
                 * @memberof google.protobuf.EnumValueDescriptorProto
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                EnumValueDescriptorProto.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.EnumValueDescriptorProto";
                };
    
                return EnumValueDescriptorProto;
            })();
    
            protobuf.ServiceDescriptorProto = (function() {
    
                /**
                 * Properties of a ServiceDescriptorProto.
                 * @memberof google.protobuf
                 * @interface IServiceDescriptorProto
                 * @property {string|null} [name] ServiceDescriptorProto name
                 * @property {Array.<google.protobuf.IMethodDescriptorProto>|null} [method] ServiceDescriptorProto method
                 * @property {google.protobuf.IServiceOptions|null} [options] ServiceDescriptorProto options
                 */
    
                /**
                 * Constructs a new ServiceDescriptorProto.
                 * @memberof google.protobuf
                 * @classdesc Represents a ServiceDescriptorProto.
                 * @implements IServiceDescriptorProto
                 * @constructor
                 * @param {google.protobuf.IServiceDescriptorProto=} [properties] Properties to set
                 */
                function ServiceDescriptorProto(properties) {
                    this.method = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * ServiceDescriptorProto name.
                 * @member {string} name
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @instance
                 */
                ServiceDescriptorProto.prototype.name = "";
    
                /**
                 * ServiceDescriptorProto method.
                 * @member {Array.<google.protobuf.IMethodDescriptorProto>} method
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @instance
                 */
                ServiceDescriptorProto.prototype.method = $util.emptyArray;
    
                /**
                 * ServiceDescriptorProto options.
                 * @member {google.protobuf.IServiceOptions|null|undefined} options
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @instance
                 */
                ServiceDescriptorProto.prototype.options = null;
    
                /**
                 * Creates a new ServiceDescriptorProto instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @static
                 * @param {google.protobuf.IServiceDescriptorProto=} [properties] Properties to set
                 * @returns {google.protobuf.ServiceDescriptorProto} ServiceDescriptorProto instance
                 */
                ServiceDescriptorProto.create = function create(properties) {
                    return new ServiceDescriptorProto(properties);
                };
    
                /**
                 * Encodes the specified ServiceDescriptorProto message. Does not implicitly {@link google.protobuf.ServiceDescriptorProto.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @static
                 * @param {google.protobuf.IServiceDescriptorProto} message ServiceDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ServiceDescriptorProto.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                    if (message.method != null && message.method.length)
                        for (var i = 0; i < message.method.length; ++i)
                            $root.google.protobuf.MethodDescriptorProto.encode(message.method[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                    if (message.options != null && Object.hasOwnProperty.call(message, "options"))
                        $root.google.protobuf.ServiceOptions.encode(message.options, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified ServiceDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.ServiceDescriptorProto.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @static
                 * @param {google.protobuf.IServiceDescriptorProto} message ServiceDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ServiceDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a ServiceDescriptorProto message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.ServiceDescriptorProto} ServiceDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ServiceDescriptorProto.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.ServiceDescriptorProto();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.name = reader.string();
                                break;
                            }
                        case 2: {
                                if (!(message.method && message.method.length))
                                    message.method = [];
                                message.method.push($root.google.protobuf.MethodDescriptorProto.decode(reader, reader.uint32()));
                                break;
                            }
                        case 3: {
                                message.options = $root.google.protobuf.ServiceOptions.decode(reader, reader.uint32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a ServiceDescriptorProto message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.ServiceDescriptorProto} ServiceDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ServiceDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a ServiceDescriptorProto message.
                 * @function verify
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                ServiceDescriptorProto.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.name != null && message.hasOwnProperty("name"))
                        if (!$util.isString(message.name))
                            return "name: string expected";
                    if (message.method != null && message.hasOwnProperty("method")) {
                        if (!Array.isArray(message.method))
                            return "method: array expected";
                        for (var i = 0; i < message.method.length; ++i) {
                            var error = $root.google.protobuf.MethodDescriptorProto.verify(message.method[i]);
                            if (error)
                                return "method." + error;
                        }
                    }
                    if (message.options != null && message.hasOwnProperty("options")) {
                        var error = $root.google.protobuf.ServiceOptions.verify(message.options);
                        if (error)
                            return "options." + error;
                    }
                    return null;
                };
    
                /**
                 * Creates a ServiceDescriptorProto message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.ServiceDescriptorProto} ServiceDescriptorProto
                 */
                ServiceDescriptorProto.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.ServiceDescriptorProto)
                        return object;
                    var message = new $root.google.protobuf.ServiceDescriptorProto();
                    if (object.name != null)
                        message.name = String(object.name);
                    if (object.method) {
                        if (!Array.isArray(object.method))
                            throw TypeError(".google.protobuf.ServiceDescriptorProto.method: array expected");
                        message.method = [];
                        for (var i = 0; i < object.method.length; ++i) {
                            if (typeof object.method[i] !== "object")
                                throw TypeError(".google.protobuf.ServiceDescriptorProto.method: object expected");
                            message.method[i] = $root.google.protobuf.MethodDescriptorProto.fromObject(object.method[i]);
                        }
                    }
                    if (object.options != null) {
                        if (typeof object.options !== "object")
                            throw TypeError(".google.protobuf.ServiceDescriptorProto.options: object expected");
                        message.options = $root.google.protobuf.ServiceOptions.fromObject(object.options);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a ServiceDescriptorProto message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @static
                 * @param {google.protobuf.ServiceDescriptorProto} message ServiceDescriptorProto
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                ServiceDescriptorProto.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.method = [];
                    if (options.defaults) {
                        object.name = "";
                        object.options = null;
                    }
                    if (message.name != null && message.hasOwnProperty("name"))
                        object.name = message.name;
                    if (message.method && message.method.length) {
                        object.method = [];
                        for (var j = 0; j < message.method.length; ++j)
                            object.method[j] = $root.google.protobuf.MethodDescriptorProto.toObject(message.method[j], options);
                    }
                    if (message.options != null && message.hasOwnProperty("options"))
                        object.options = $root.google.protobuf.ServiceOptions.toObject(message.options, options);
                    return object;
                };
    
                /**
                 * Converts this ServiceDescriptorProto to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                ServiceDescriptorProto.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for ServiceDescriptorProto
                 * @function getTypeUrl
                 * @memberof google.protobuf.ServiceDescriptorProto
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                ServiceDescriptorProto.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.ServiceDescriptorProto";
                };
    
                return ServiceDescriptorProto;
            })();
    
            protobuf.MethodDescriptorProto = (function() {
    
                /**
                 * Properties of a MethodDescriptorProto.
                 * @memberof google.protobuf
                 * @interface IMethodDescriptorProto
                 * @property {string|null} [name] MethodDescriptorProto name
                 * @property {string|null} [inputType] MethodDescriptorProto inputType
                 * @property {string|null} [outputType] MethodDescriptorProto outputType
                 * @property {google.protobuf.IMethodOptions|null} [options] MethodDescriptorProto options
                 * @property {boolean|null} [clientStreaming] MethodDescriptorProto clientStreaming
                 * @property {boolean|null} [serverStreaming] MethodDescriptorProto serverStreaming
                 */
    
                /**
                 * Constructs a new MethodDescriptorProto.
                 * @memberof google.protobuf
                 * @classdesc Represents a MethodDescriptorProto.
                 * @implements IMethodDescriptorProto
                 * @constructor
                 * @param {google.protobuf.IMethodDescriptorProto=} [properties] Properties to set
                 */
                function MethodDescriptorProto(properties) {
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * MethodDescriptorProto name.
                 * @member {string} name
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @instance
                 */
                MethodDescriptorProto.prototype.name = "";
    
                /**
                 * MethodDescriptorProto inputType.
                 * @member {string} inputType
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @instance
                 */
                MethodDescriptorProto.prototype.inputType = "";
    
                /**
                 * MethodDescriptorProto outputType.
                 * @member {string} outputType
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @instance
                 */
                MethodDescriptorProto.prototype.outputType = "";
    
                /**
                 * MethodDescriptorProto options.
                 * @member {google.protobuf.IMethodOptions|null|undefined} options
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @instance
                 */
                MethodDescriptorProto.prototype.options = null;
    
                /**
                 * MethodDescriptorProto clientStreaming.
                 * @member {boolean} clientStreaming
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @instance
                 */
                MethodDescriptorProto.prototype.clientStreaming = false;
    
                /**
                 * MethodDescriptorProto serverStreaming.
                 * @member {boolean} serverStreaming
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @instance
                 */
                MethodDescriptorProto.prototype.serverStreaming = false;
    
                /**
                 * Creates a new MethodDescriptorProto instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @static
                 * @param {google.protobuf.IMethodDescriptorProto=} [properties] Properties to set
                 * @returns {google.protobuf.MethodDescriptorProto} MethodDescriptorProto instance
                 */
                MethodDescriptorProto.create = function create(properties) {
                    return new MethodDescriptorProto(properties);
                };
    
                /**
                 * Encodes the specified MethodDescriptorProto message. Does not implicitly {@link google.protobuf.MethodDescriptorProto.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @static
                 * @param {google.protobuf.IMethodDescriptorProto} message MethodDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                MethodDescriptorProto.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.name != null && Object.hasOwnProperty.call(message, "name"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.name);
                    if (message.inputType != null && Object.hasOwnProperty.call(message, "inputType"))
                        writer.uint32(/* id 2, wireType 2 =*/18).string(message.inputType);
                    if (message.outputType != null && Object.hasOwnProperty.call(message, "outputType"))
                        writer.uint32(/* id 3, wireType 2 =*/26).string(message.outputType);
                    if (message.options != null && Object.hasOwnProperty.call(message, "options"))
                        $root.google.protobuf.MethodOptions.encode(message.options, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
                    if (message.clientStreaming != null && Object.hasOwnProperty.call(message, "clientStreaming"))
                        writer.uint32(/* id 5, wireType 0 =*/40).bool(message.clientStreaming);
                    if (message.serverStreaming != null && Object.hasOwnProperty.call(message, "serverStreaming"))
                        writer.uint32(/* id 6, wireType 0 =*/48).bool(message.serverStreaming);
                    return writer;
                };
    
                /**
                 * Encodes the specified MethodDescriptorProto message, length delimited. Does not implicitly {@link google.protobuf.MethodDescriptorProto.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @static
                 * @param {google.protobuf.IMethodDescriptorProto} message MethodDescriptorProto message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                MethodDescriptorProto.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a MethodDescriptorProto message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.MethodDescriptorProto} MethodDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                MethodDescriptorProto.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.MethodDescriptorProto();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.name = reader.string();
                                break;
                            }
                        case 2: {
                                message.inputType = reader.string();
                                break;
                            }
                        case 3: {
                                message.outputType = reader.string();
                                break;
                            }
                        case 4: {
                                message.options = $root.google.protobuf.MethodOptions.decode(reader, reader.uint32());
                                break;
                            }
                        case 5: {
                                message.clientStreaming = reader.bool();
                                break;
                            }
                        case 6: {
                                message.serverStreaming = reader.bool();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a MethodDescriptorProto message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.MethodDescriptorProto} MethodDescriptorProto
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                MethodDescriptorProto.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a MethodDescriptorProto message.
                 * @function verify
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                MethodDescriptorProto.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.name != null && message.hasOwnProperty("name"))
                        if (!$util.isString(message.name))
                            return "name: string expected";
                    if (message.inputType != null && message.hasOwnProperty("inputType"))
                        if (!$util.isString(message.inputType))
                            return "inputType: string expected";
                    if (message.outputType != null && message.hasOwnProperty("outputType"))
                        if (!$util.isString(message.outputType))
                            return "outputType: string expected";
                    if (message.options != null && message.hasOwnProperty("options")) {
                        var error = $root.google.protobuf.MethodOptions.verify(message.options);
                        if (error)
                            return "options." + error;
                    }
                    if (message.clientStreaming != null && message.hasOwnProperty("clientStreaming"))
                        if (typeof message.clientStreaming !== "boolean")
                            return "clientStreaming: boolean expected";
                    if (message.serverStreaming != null && message.hasOwnProperty("serverStreaming"))
                        if (typeof message.serverStreaming !== "boolean")
                            return "serverStreaming: boolean expected";
                    return null;
                };
    
                /**
                 * Creates a MethodDescriptorProto message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.MethodDescriptorProto} MethodDescriptorProto
                 */
                MethodDescriptorProto.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.MethodDescriptorProto)
                        return object;
                    var message = new $root.google.protobuf.MethodDescriptorProto();
                    if (object.name != null)
                        message.name = String(object.name);
                    if (object.inputType != null)
                        message.inputType = String(object.inputType);
                    if (object.outputType != null)
                        message.outputType = String(object.outputType);
                    if (object.options != null) {
                        if (typeof object.options !== "object")
                            throw TypeError(".google.protobuf.MethodDescriptorProto.options: object expected");
                        message.options = $root.google.protobuf.MethodOptions.fromObject(object.options);
                    }
                    if (object.clientStreaming != null)
                        message.clientStreaming = Boolean(object.clientStreaming);
                    if (object.serverStreaming != null)
                        message.serverStreaming = Boolean(object.serverStreaming);
                    return message;
                };
    
                /**
                 * Creates a plain object from a MethodDescriptorProto message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @static
                 * @param {google.protobuf.MethodDescriptorProto} message MethodDescriptorProto
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                MethodDescriptorProto.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.defaults) {
                        object.name = "";
                        object.inputType = "";
                        object.outputType = "";
                        object.options = null;
                        object.clientStreaming = false;
                        object.serverStreaming = false;
                    }
                    if (message.name != null && message.hasOwnProperty("name"))
                        object.name = message.name;
                    if (message.inputType != null && message.hasOwnProperty("inputType"))
                        object.inputType = message.inputType;
                    if (message.outputType != null && message.hasOwnProperty("outputType"))
                        object.outputType = message.outputType;
                    if (message.options != null && message.hasOwnProperty("options"))
                        object.options = $root.google.protobuf.MethodOptions.toObject(message.options, options);
                    if (message.clientStreaming != null && message.hasOwnProperty("clientStreaming"))
                        object.clientStreaming = message.clientStreaming;
                    if (message.serverStreaming != null && message.hasOwnProperty("serverStreaming"))
                        object.serverStreaming = message.serverStreaming;
                    return object;
                };
    
                /**
                 * Converts this MethodDescriptorProto to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                MethodDescriptorProto.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for MethodDescriptorProto
                 * @function getTypeUrl
                 * @memberof google.protobuf.MethodDescriptorProto
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                MethodDescriptorProto.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.MethodDescriptorProto";
                };
    
                return MethodDescriptorProto;
            })();
    
            protobuf.FileOptions = (function() {
    
                /**
                 * Properties of a FileOptions.
                 * @memberof google.protobuf
                 * @interface IFileOptions
                 * @property {string|null} [javaPackage] FileOptions javaPackage
                 * @property {string|null} [javaOuterClassname] FileOptions javaOuterClassname
                 * @property {boolean|null} [javaMultipleFiles] FileOptions javaMultipleFiles
                 * @property {boolean|null} [javaGenerateEqualsAndHash] FileOptions javaGenerateEqualsAndHash
                 * @property {boolean|null} [javaStringCheckUtf8] FileOptions javaStringCheckUtf8
                 * @property {google.protobuf.FileOptions.OptimizeMode|null} [optimizeFor] FileOptions optimizeFor
                 * @property {string|null} [goPackage] FileOptions goPackage
                 * @property {boolean|null} [ccGenericServices] FileOptions ccGenericServices
                 * @property {boolean|null} [javaGenericServices] FileOptions javaGenericServices
                 * @property {boolean|null} [pyGenericServices] FileOptions pyGenericServices
                 * @property {boolean|null} [phpGenericServices] FileOptions phpGenericServices
                 * @property {boolean|null} [deprecated] FileOptions deprecated
                 * @property {boolean|null} [ccEnableArenas] FileOptions ccEnableArenas
                 * @property {string|null} [objcClassPrefix] FileOptions objcClassPrefix
                 * @property {string|null} [csharpNamespace] FileOptions csharpNamespace
                 * @property {string|null} [swiftPrefix] FileOptions swiftPrefix
                 * @property {string|null} [phpClassPrefix] FileOptions phpClassPrefix
                 * @property {string|null} [phpNamespace] FileOptions phpNamespace
                 * @property {string|null} [phpMetadataNamespace] FileOptions phpMetadataNamespace
                 * @property {string|null} [rubyPackage] FileOptions rubyPackage
                 * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] FileOptions uninterpretedOption
                 * @property {Array.<google.api.IResourceDescriptor>|null} [".google.api.resourceDefinition"] FileOptions .google.api.resourceDefinition
                 */
    
                /**
                 * Constructs a new FileOptions.
                 * @memberof google.protobuf
                 * @classdesc Represents a FileOptions.
                 * @implements IFileOptions
                 * @constructor
                 * @param {google.protobuf.IFileOptions=} [properties] Properties to set
                 */
                function FileOptions(properties) {
                    this.uninterpretedOption = [];
                    this[".google.api.resourceDefinition"] = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * FileOptions javaPackage.
                 * @member {string} javaPackage
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.javaPackage = "";
    
                /**
                 * FileOptions javaOuterClassname.
                 * @member {string} javaOuterClassname
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.javaOuterClassname = "";
    
                /**
                 * FileOptions javaMultipleFiles.
                 * @member {boolean} javaMultipleFiles
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.javaMultipleFiles = false;
    
                /**
                 * FileOptions javaGenerateEqualsAndHash.
                 * @member {boolean} javaGenerateEqualsAndHash
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.javaGenerateEqualsAndHash = false;
    
                /**
                 * FileOptions javaStringCheckUtf8.
                 * @member {boolean} javaStringCheckUtf8
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.javaStringCheckUtf8 = false;
    
                /**
                 * FileOptions optimizeFor.
                 * @member {google.protobuf.FileOptions.OptimizeMode} optimizeFor
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.optimizeFor = 1;
    
                /**
                 * FileOptions goPackage.
                 * @member {string} goPackage
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.goPackage = "";
    
                /**
                 * FileOptions ccGenericServices.
                 * @member {boolean} ccGenericServices
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.ccGenericServices = false;
    
                /**
                 * FileOptions javaGenericServices.
                 * @member {boolean} javaGenericServices
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.javaGenericServices = false;
    
                /**
                 * FileOptions pyGenericServices.
                 * @member {boolean} pyGenericServices
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.pyGenericServices = false;
    
                /**
                 * FileOptions phpGenericServices.
                 * @member {boolean} phpGenericServices
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.phpGenericServices = false;
    
                /**
                 * FileOptions deprecated.
                 * @member {boolean} deprecated
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.deprecated = false;
    
                /**
                 * FileOptions ccEnableArenas.
                 * @member {boolean} ccEnableArenas
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.ccEnableArenas = true;
    
                /**
                 * FileOptions objcClassPrefix.
                 * @member {string} objcClassPrefix
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.objcClassPrefix = "";
    
                /**
                 * FileOptions csharpNamespace.
                 * @member {string} csharpNamespace
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.csharpNamespace = "";
    
                /**
                 * FileOptions swiftPrefix.
                 * @member {string} swiftPrefix
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.swiftPrefix = "";
    
                /**
                 * FileOptions phpClassPrefix.
                 * @member {string} phpClassPrefix
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.phpClassPrefix = "";
    
                /**
                 * FileOptions phpNamespace.
                 * @member {string} phpNamespace
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.phpNamespace = "";
    
                /**
                 * FileOptions phpMetadataNamespace.
                 * @member {string} phpMetadataNamespace
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.phpMetadataNamespace = "";
    
                /**
                 * FileOptions rubyPackage.
                 * @member {string} rubyPackage
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.rubyPackage = "";
    
                /**
                 * FileOptions uninterpretedOption.
                 * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype.uninterpretedOption = $util.emptyArray;
    
                /**
                 * FileOptions .google.api.resourceDefinition.
                 * @member {Array.<google.api.IResourceDescriptor>} .google.api.resourceDefinition
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 */
                FileOptions.prototype[".google.api.resourceDefinition"] = $util.emptyArray;
    
                /**
                 * Creates a new FileOptions instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.FileOptions
                 * @static
                 * @param {google.protobuf.IFileOptions=} [properties] Properties to set
                 * @returns {google.protobuf.FileOptions} FileOptions instance
                 */
                FileOptions.create = function create(properties) {
                    return new FileOptions(properties);
                };
    
                /**
                 * Encodes the specified FileOptions message. Does not implicitly {@link google.protobuf.FileOptions.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.FileOptions
                 * @static
                 * @param {google.protobuf.IFileOptions} message FileOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FileOptions.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.javaPackage != null && Object.hasOwnProperty.call(message, "javaPackage"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.javaPackage);
                    if (message.javaOuterClassname != null && Object.hasOwnProperty.call(message, "javaOuterClassname"))
                        writer.uint32(/* id 8, wireType 2 =*/66).string(message.javaOuterClassname);
                    if (message.optimizeFor != null && Object.hasOwnProperty.call(message, "optimizeFor"))
                        writer.uint32(/* id 9, wireType 0 =*/72).int32(message.optimizeFor);
                    if (message.javaMultipleFiles != null && Object.hasOwnProperty.call(message, "javaMultipleFiles"))
                        writer.uint32(/* id 10, wireType 0 =*/80).bool(message.javaMultipleFiles);
                    if (message.goPackage != null && Object.hasOwnProperty.call(message, "goPackage"))
                        writer.uint32(/* id 11, wireType 2 =*/90).string(message.goPackage);
                    if (message.ccGenericServices != null && Object.hasOwnProperty.call(message, "ccGenericServices"))
                        writer.uint32(/* id 16, wireType 0 =*/128).bool(message.ccGenericServices);
                    if (message.javaGenericServices != null && Object.hasOwnProperty.call(message, "javaGenericServices"))
                        writer.uint32(/* id 17, wireType 0 =*/136).bool(message.javaGenericServices);
                    if (message.pyGenericServices != null && Object.hasOwnProperty.call(message, "pyGenericServices"))
                        writer.uint32(/* id 18, wireType 0 =*/144).bool(message.pyGenericServices);
                    if (message.javaGenerateEqualsAndHash != null && Object.hasOwnProperty.call(message, "javaGenerateEqualsAndHash"))
                        writer.uint32(/* id 20, wireType 0 =*/160).bool(message.javaGenerateEqualsAndHash);
                    if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                        writer.uint32(/* id 23, wireType 0 =*/184).bool(message.deprecated);
                    if (message.javaStringCheckUtf8 != null && Object.hasOwnProperty.call(message, "javaStringCheckUtf8"))
                        writer.uint32(/* id 27, wireType 0 =*/216).bool(message.javaStringCheckUtf8);
                    if (message.ccEnableArenas != null && Object.hasOwnProperty.call(message, "ccEnableArenas"))
                        writer.uint32(/* id 31, wireType 0 =*/248).bool(message.ccEnableArenas);
                    if (message.objcClassPrefix != null && Object.hasOwnProperty.call(message, "objcClassPrefix"))
                        writer.uint32(/* id 36, wireType 2 =*/290).string(message.objcClassPrefix);
                    if (message.csharpNamespace != null && Object.hasOwnProperty.call(message, "csharpNamespace"))
                        writer.uint32(/* id 37, wireType 2 =*/298).string(message.csharpNamespace);
                    if (message.swiftPrefix != null && Object.hasOwnProperty.call(message, "swiftPrefix"))
                        writer.uint32(/* id 39, wireType 2 =*/314).string(message.swiftPrefix);
                    if (message.phpClassPrefix != null && Object.hasOwnProperty.call(message, "phpClassPrefix"))
                        writer.uint32(/* id 40, wireType 2 =*/322).string(message.phpClassPrefix);
                    if (message.phpNamespace != null && Object.hasOwnProperty.call(message, "phpNamespace"))
                        writer.uint32(/* id 41, wireType 2 =*/330).string(message.phpNamespace);
                    if (message.phpGenericServices != null && Object.hasOwnProperty.call(message, "phpGenericServices"))
                        writer.uint32(/* id 42, wireType 0 =*/336).bool(message.phpGenericServices);
                    if (message.phpMetadataNamespace != null && Object.hasOwnProperty.call(message, "phpMetadataNamespace"))
                        writer.uint32(/* id 44, wireType 2 =*/354).string(message.phpMetadataNamespace);
                    if (message.rubyPackage != null && Object.hasOwnProperty.call(message, "rubyPackage"))
                        writer.uint32(/* id 45, wireType 2 =*/362).string(message.rubyPackage);
                    if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                        for (var i = 0; i < message.uninterpretedOption.length; ++i)
                            $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                    if (message[".google.api.resourceDefinition"] != null && message[".google.api.resourceDefinition"].length)
                        for (var i = 0; i < message[".google.api.resourceDefinition"].length; ++i)
                            $root.google.api.ResourceDescriptor.encode(message[".google.api.resourceDefinition"][i], writer.uint32(/* id 1053, wireType 2 =*/8426).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified FileOptions message, length delimited. Does not implicitly {@link google.protobuf.FileOptions.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.FileOptions
                 * @static
                 * @param {google.protobuf.IFileOptions} message FileOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FileOptions.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a FileOptions message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.FileOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.FileOptions} FileOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FileOptions.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.FileOptions();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.javaPackage = reader.string();
                                break;
                            }
                        case 8: {
                                message.javaOuterClassname = reader.string();
                                break;
                            }
                        case 10: {
                                message.javaMultipleFiles = reader.bool();
                                break;
                            }
                        case 20: {
                                message.javaGenerateEqualsAndHash = reader.bool();
                                break;
                            }
                        case 27: {
                                message.javaStringCheckUtf8 = reader.bool();
                                break;
                            }
                        case 9: {
                                message.optimizeFor = reader.int32();
                                break;
                            }
                        case 11: {
                                message.goPackage = reader.string();
                                break;
                            }
                        case 16: {
                                message.ccGenericServices = reader.bool();
                                break;
                            }
                        case 17: {
                                message.javaGenericServices = reader.bool();
                                break;
                            }
                        case 18: {
                                message.pyGenericServices = reader.bool();
                                break;
                            }
                        case 42: {
                                message.phpGenericServices = reader.bool();
                                break;
                            }
                        case 23: {
                                message.deprecated = reader.bool();
                                break;
                            }
                        case 31: {
                                message.ccEnableArenas = reader.bool();
                                break;
                            }
                        case 36: {
                                message.objcClassPrefix = reader.string();
                                break;
                            }
                        case 37: {
                                message.csharpNamespace = reader.string();
                                break;
                            }
                        case 39: {
                                message.swiftPrefix = reader.string();
                                break;
                            }
                        case 40: {
                                message.phpClassPrefix = reader.string();
                                break;
                            }
                        case 41: {
                                message.phpNamespace = reader.string();
                                break;
                            }
                        case 44: {
                                message.phpMetadataNamespace = reader.string();
                                break;
                            }
                        case 45: {
                                message.rubyPackage = reader.string();
                                break;
                            }
                        case 999: {
                                if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                                    message.uninterpretedOption = [];
                                message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                                break;
                            }
                        case 1053: {
                                if (!(message[".google.api.resourceDefinition"] && message[".google.api.resourceDefinition"].length))
                                    message[".google.api.resourceDefinition"] = [];
                                message[".google.api.resourceDefinition"].push($root.google.api.ResourceDescriptor.decode(reader, reader.uint32()));
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a FileOptions message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.FileOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.FileOptions} FileOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FileOptions.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a FileOptions message.
                 * @function verify
                 * @memberof google.protobuf.FileOptions
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                FileOptions.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.javaPackage != null && message.hasOwnProperty("javaPackage"))
                        if (!$util.isString(message.javaPackage))
                            return "javaPackage: string expected";
                    if (message.javaOuterClassname != null && message.hasOwnProperty("javaOuterClassname"))
                        if (!$util.isString(message.javaOuterClassname))
                            return "javaOuterClassname: string expected";
                    if (message.javaMultipleFiles != null && message.hasOwnProperty("javaMultipleFiles"))
                        if (typeof message.javaMultipleFiles !== "boolean")
                            return "javaMultipleFiles: boolean expected";
                    if (message.javaGenerateEqualsAndHash != null && message.hasOwnProperty("javaGenerateEqualsAndHash"))
                        if (typeof message.javaGenerateEqualsAndHash !== "boolean")
                            return "javaGenerateEqualsAndHash: boolean expected";
                    if (message.javaStringCheckUtf8 != null && message.hasOwnProperty("javaStringCheckUtf8"))
                        if (typeof message.javaStringCheckUtf8 !== "boolean")
                            return "javaStringCheckUtf8: boolean expected";
                    if (message.optimizeFor != null && message.hasOwnProperty("optimizeFor"))
                        switch (message.optimizeFor) {
                        default:
                            return "optimizeFor: enum value expected";
                        case 1:
                        case 2:
                        case 3:
                            break;
                        }
                    if (message.goPackage != null && message.hasOwnProperty("goPackage"))
                        if (!$util.isString(message.goPackage))
                            return "goPackage: string expected";
                    if (message.ccGenericServices != null && message.hasOwnProperty("ccGenericServices"))
                        if (typeof message.ccGenericServices !== "boolean")
                            return "ccGenericServices: boolean expected";
                    if (message.javaGenericServices != null && message.hasOwnProperty("javaGenericServices"))
                        if (typeof message.javaGenericServices !== "boolean")
                            return "javaGenericServices: boolean expected";
                    if (message.pyGenericServices != null && message.hasOwnProperty("pyGenericServices"))
                        if (typeof message.pyGenericServices !== "boolean")
                            return "pyGenericServices: boolean expected";
                    if (message.phpGenericServices != null && message.hasOwnProperty("phpGenericServices"))
                        if (typeof message.phpGenericServices !== "boolean")
                            return "phpGenericServices: boolean expected";
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        if (typeof message.deprecated !== "boolean")
                            return "deprecated: boolean expected";
                    if (message.ccEnableArenas != null && message.hasOwnProperty("ccEnableArenas"))
                        if (typeof message.ccEnableArenas !== "boolean")
                            return "ccEnableArenas: boolean expected";
                    if (message.objcClassPrefix != null && message.hasOwnProperty("objcClassPrefix"))
                        if (!$util.isString(message.objcClassPrefix))
                            return "objcClassPrefix: string expected";
                    if (message.csharpNamespace != null && message.hasOwnProperty("csharpNamespace"))
                        if (!$util.isString(message.csharpNamespace))
                            return "csharpNamespace: string expected";
                    if (message.swiftPrefix != null && message.hasOwnProperty("swiftPrefix"))
                        if (!$util.isString(message.swiftPrefix))
                            return "swiftPrefix: string expected";
                    if (message.phpClassPrefix != null && message.hasOwnProperty("phpClassPrefix"))
                        if (!$util.isString(message.phpClassPrefix))
                            return "phpClassPrefix: string expected";
                    if (message.phpNamespace != null && message.hasOwnProperty("phpNamespace"))
                        if (!$util.isString(message.phpNamespace))
                            return "phpNamespace: string expected";
                    if (message.phpMetadataNamespace != null && message.hasOwnProperty("phpMetadataNamespace"))
                        if (!$util.isString(message.phpMetadataNamespace))
                            return "phpMetadataNamespace: string expected";
                    if (message.rubyPackage != null && message.hasOwnProperty("rubyPackage"))
                        if (!$util.isString(message.rubyPackage))
                            return "rubyPackage: string expected";
                    if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                        if (!Array.isArray(message.uninterpretedOption))
                            return "uninterpretedOption: array expected";
                        for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                            var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                            if (error)
                                return "uninterpretedOption." + error;
                        }
                    }
                    if (message[".google.api.resourceDefinition"] != null && message.hasOwnProperty(".google.api.resourceDefinition")) {
                        if (!Array.isArray(message[".google.api.resourceDefinition"]))
                            return ".google.api.resourceDefinition: array expected";
                        for (var i = 0; i < message[".google.api.resourceDefinition"].length; ++i) {
                            var error = $root.google.api.ResourceDescriptor.verify(message[".google.api.resourceDefinition"][i]);
                            if (error)
                                return ".google.api.resourceDefinition." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates a FileOptions message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.FileOptions
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.FileOptions} FileOptions
                 */
                FileOptions.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.FileOptions)
                        return object;
                    var message = new $root.google.protobuf.FileOptions();
                    if (object.javaPackage != null)
                        message.javaPackage = String(object.javaPackage);
                    if (object.javaOuterClassname != null)
                        message.javaOuterClassname = String(object.javaOuterClassname);
                    if (object.javaMultipleFiles != null)
                        message.javaMultipleFiles = Boolean(object.javaMultipleFiles);
                    if (object.javaGenerateEqualsAndHash != null)
                        message.javaGenerateEqualsAndHash = Boolean(object.javaGenerateEqualsAndHash);
                    if (object.javaStringCheckUtf8 != null)
                        message.javaStringCheckUtf8 = Boolean(object.javaStringCheckUtf8);
                    switch (object.optimizeFor) {
                    default:
                        if (typeof object.optimizeFor === "number") {
                            message.optimizeFor = object.optimizeFor;
                            break;
                        }
                        break;
                    case "SPEED":
                    case 1:
                        message.optimizeFor = 1;
                        break;
                    case "CODE_SIZE":
                    case 2:
                        message.optimizeFor = 2;
                        break;
                    case "LITE_RUNTIME":
                    case 3:
                        message.optimizeFor = 3;
                        break;
                    }
                    if (object.goPackage != null)
                        message.goPackage = String(object.goPackage);
                    if (object.ccGenericServices != null)
                        message.ccGenericServices = Boolean(object.ccGenericServices);
                    if (object.javaGenericServices != null)
                        message.javaGenericServices = Boolean(object.javaGenericServices);
                    if (object.pyGenericServices != null)
                        message.pyGenericServices = Boolean(object.pyGenericServices);
                    if (object.phpGenericServices != null)
                        message.phpGenericServices = Boolean(object.phpGenericServices);
                    if (object.deprecated != null)
                        message.deprecated = Boolean(object.deprecated);
                    if (object.ccEnableArenas != null)
                        message.ccEnableArenas = Boolean(object.ccEnableArenas);
                    if (object.objcClassPrefix != null)
                        message.objcClassPrefix = String(object.objcClassPrefix);
                    if (object.csharpNamespace != null)
                        message.csharpNamespace = String(object.csharpNamespace);
                    if (object.swiftPrefix != null)
                        message.swiftPrefix = String(object.swiftPrefix);
                    if (object.phpClassPrefix != null)
                        message.phpClassPrefix = String(object.phpClassPrefix);
                    if (object.phpNamespace != null)
                        message.phpNamespace = String(object.phpNamespace);
                    if (object.phpMetadataNamespace != null)
                        message.phpMetadataNamespace = String(object.phpMetadataNamespace);
                    if (object.rubyPackage != null)
                        message.rubyPackage = String(object.rubyPackage);
                    if (object.uninterpretedOption) {
                        if (!Array.isArray(object.uninterpretedOption))
                            throw TypeError(".google.protobuf.FileOptions.uninterpretedOption: array expected");
                        message.uninterpretedOption = [];
                        for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                            if (typeof object.uninterpretedOption[i] !== "object")
                                throw TypeError(".google.protobuf.FileOptions.uninterpretedOption: object expected");
                            message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                        }
                    }
                    if (object[".google.api.resourceDefinition"]) {
                        if (!Array.isArray(object[".google.api.resourceDefinition"]))
                            throw TypeError(".google.protobuf.FileOptions..google.api.resourceDefinition: array expected");
                        message[".google.api.resourceDefinition"] = [];
                        for (var i = 0; i < object[".google.api.resourceDefinition"].length; ++i) {
                            if (typeof object[".google.api.resourceDefinition"][i] !== "object")
                                throw TypeError(".google.protobuf.FileOptions..google.api.resourceDefinition: object expected");
                            message[".google.api.resourceDefinition"][i] = $root.google.api.ResourceDescriptor.fromObject(object[".google.api.resourceDefinition"][i]);
                        }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a FileOptions message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.FileOptions
                 * @static
                 * @param {google.protobuf.FileOptions} message FileOptions
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                FileOptions.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults) {
                        object.uninterpretedOption = [];
                        object[".google.api.resourceDefinition"] = [];
                    }
                    if (options.defaults) {
                        object.javaPackage = "";
                        object.javaOuterClassname = "";
                        object.optimizeFor = options.enums === String ? "SPEED" : 1;
                        object.javaMultipleFiles = false;
                        object.goPackage = "";
                        object.ccGenericServices = false;
                        object.javaGenericServices = false;
                        object.pyGenericServices = false;
                        object.javaGenerateEqualsAndHash = false;
                        object.deprecated = false;
                        object.javaStringCheckUtf8 = false;
                        object.ccEnableArenas = true;
                        object.objcClassPrefix = "";
                        object.csharpNamespace = "";
                        object.swiftPrefix = "";
                        object.phpClassPrefix = "";
                        object.phpNamespace = "";
                        object.phpGenericServices = false;
                        object.phpMetadataNamespace = "";
                        object.rubyPackage = "";
                    }
                    if (message.javaPackage != null && message.hasOwnProperty("javaPackage"))
                        object.javaPackage = message.javaPackage;
                    if (message.javaOuterClassname != null && message.hasOwnProperty("javaOuterClassname"))
                        object.javaOuterClassname = message.javaOuterClassname;
                    if (message.optimizeFor != null && message.hasOwnProperty("optimizeFor"))
                        object.optimizeFor = options.enums === String ? $root.google.protobuf.FileOptions.OptimizeMode[message.optimizeFor] === undefined ? message.optimizeFor : $root.google.protobuf.FileOptions.OptimizeMode[message.optimizeFor] : message.optimizeFor;
                    if (message.javaMultipleFiles != null && message.hasOwnProperty("javaMultipleFiles"))
                        object.javaMultipleFiles = message.javaMultipleFiles;
                    if (message.goPackage != null && message.hasOwnProperty("goPackage"))
                        object.goPackage = message.goPackage;
                    if (message.ccGenericServices != null && message.hasOwnProperty("ccGenericServices"))
                        object.ccGenericServices = message.ccGenericServices;
                    if (message.javaGenericServices != null && message.hasOwnProperty("javaGenericServices"))
                        object.javaGenericServices = message.javaGenericServices;
                    if (message.pyGenericServices != null && message.hasOwnProperty("pyGenericServices"))
                        object.pyGenericServices = message.pyGenericServices;
                    if (message.javaGenerateEqualsAndHash != null && message.hasOwnProperty("javaGenerateEqualsAndHash"))
                        object.javaGenerateEqualsAndHash = message.javaGenerateEqualsAndHash;
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        object.deprecated = message.deprecated;
                    if (message.javaStringCheckUtf8 != null && message.hasOwnProperty("javaStringCheckUtf8"))
                        object.javaStringCheckUtf8 = message.javaStringCheckUtf8;
                    if (message.ccEnableArenas != null && message.hasOwnProperty("ccEnableArenas"))
                        object.ccEnableArenas = message.ccEnableArenas;
                    if (message.objcClassPrefix != null && message.hasOwnProperty("objcClassPrefix"))
                        object.objcClassPrefix = message.objcClassPrefix;
                    if (message.csharpNamespace != null && message.hasOwnProperty("csharpNamespace"))
                        object.csharpNamespace = message.csharpNamespace;
                    if (message.swiftPrefix != null && message.hasOwnProperty("swiftPrefix"))
                        object.swiftPrefix = message.swiftPrefix;
                    if (message.phpClassPrefix != null && message.hasOwnProperty("phpClassPrefix"))
                        object.phpClassPrefix = message.phpClassPrefix;
                    if (message.phpNamespace != null && message.hasOwnProperty("phpNamespace"))
                        object.phpNamespace = message.phpNamespace;
                    if (message.phpGenericServices != null && message.hasOwnProperty("phpGenericServices"))
                        object.phpGenericServices = message.phpGenericServices;
                    if (message.phpMetadataNamespace != null && message.hasOwnProperty("phpMetadataNamespace"))
                        object.phpMetadataNamespace = message.phpMetadataNamespace;
                    if (message.rubyPackage != null && message.hasOwnProperty("rubyPackage"))
                        object.rubyPackage = message.rubyPackage;
                    if (message.uninterpretedOption && message.uninterpretedOption.length) {
                        object.uninterpretedOption = [];
                        for (var j = 0; j < message.uninterpretedOption.length; ++j)
                            object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                    }
                    if (message[".google.api.resourceDefinition"] && message[".google.api.resourceDefinition"].length) {
                        object[".google.api.resourceDefinition"] = [];
                        for (var j = 0; j < message[".google.api.resourceDefinition"].length; ++j)
                            object[".google.api.resourceDefinition"][j] = $root.google.api.ResourceDescriptor.toObject(message[".google.api.resourceDefinition"][j], options);
                    }
                    return object;
                };
    
                /**
                 * Converts this FileOptions to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.FileOptions
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                FileOptions.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for FileOptions
                 * @function getTypeUrl
                 * @memberof google.protobuf.FileOptions
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                FileOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.FileOptions";
                };
    
                /**
                 * OptimizeMode enum.
                 * @name google.protobuf.FileOptions.OptimizeMode
                 * @enum {number}
                 * @property {number} SPEED=1 SPEED value
                 * @property {number} CODE_SIZE=2 CODE_SIZE value
                 * @property {number} LITE_RUNTIME=3 LITE_RUNTIME value
                 */
                FileOptions.OptimizeMode = (function() {
                    var valuesById = {}, values = Object.create(valuesById);
                    values[valuesById[1] = "SPEED"] = 1;
                    values[valuesById[2] = "CODE_SIZE"] = 2;
                    values[valuesById[3] = "LITE_RUNTIME"] = 3;
                    return values;
                })();
    
                return FileOptions;
            })();
    
            protobuf.MessageOptions = (function() {
    
                /**
                 * Properties of a MessageOptions.
                 * @memberof google.protobuf
                 * @interface IMessageOptions
                 * @property {boolean|null} [messageSetWireFormat] MessageOptions messageSetWireFormat
                 * @property {boolean|null} [noStandardDescriptorAccessor] MessageOptions noStandardDescriptorAccessor
                 * @property {boolean|null} [deprecated] MessageOptions deprecated
                 * @property {boolean|null} [mapEntry] MessageOptions mapEntry
                 * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] MessageOptions uninterpretedOption
                 * @property {google.api.IResourceDescriptor|null} [".google.api.resource"] MessageOptions .google.api.resource
                 */
    
                /**
                 * Constructs a new MessageOptions.
                 * @memberof google.protobuf
                 * @classdesc Represents a MessageOptions.
                 * @implements IMessageOptions
                 * @constructor
                 * @param {google.protobuf.IMessageOptions=} [properties] Properties to set
                 */
                function MessageOptions(properties) {
                    this.uninterpretedOption = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * MessageOptions messageSetWireFormat.
                 * @member {boolean} messageSetWireFormat
                 * @memberof google.protobuf.MessageOptions
                 * @instance
                 */
                MessageOptions.prototype.messageSetWireFormat = false;
    
                /**
                 * MessageOptions noStandardDescriptorAccessor.
                 * @member {boolean} noStandardDescriptorAccessor
                 * @memberof google.protobuf.MessageOptions
                 * @instance
                 */
                MessageOptions.prototype.noStandardDescriptorAccessor = false;
    
                /**
                 * MessageOptions deprecated.
                 * @member {boolean} deprecated
                 * @memberof google.protobuf.MessageOptions
                 * @instance
                 */
                MessageOptions.prototype.deprecated = false;
    
                /**
                 * MessageOptions mapEntry.
                 * @member {boolean} mapEntry
                 * @memberof google.protobuf.MessageOptions
                 * @instance
                 */
                MessageOptions.prototype.mapEntry = false;
    
                /**
                 * MessageOptions uninterpretedOption.
                 * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
                 * @memberof google.protobuf.MessageOptions
                 * @instance
                 */
                MessageOptions.prototype.uninterpretedOption = $util.emptyArray;
    
                /**
                 * MessageOptions .google.api.resource.
                 * @member {google.api.IResourceDescriptor|null|undefined} .google.api.resource
                 * @memberof google.protobuf.MessageOptions
                 * @instance
                 */
                MessageOptions.prototype[".google.api.resource"] = null;
    
                /**
                 * Creates a new MessageOptions instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.MessageOptions
                 * @static
                 * @param {google.protobuf.IMessageOptions=} [properties] Properties to set
                 * @returns {google.protobuf.MessageOptions} MessageOptions instance
                 */
                MessageOptions.create = function create(properties) {
                    return new MessageOptions(properties);
                };
    
                /**
                 * Encodes the specified MessageOptions message. Does not implicitly {@link google.protobuf.MessageOptions.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.MessageOptions
                 * @static
                 * @param {google.protobuf.IMessageOptions} message MessageOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                MessageOptions.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.messageSetWireFormat != null && Object.hasOwnProperty.call(message, "messageSetWireFormat"))
                        writer.uint32(/* id 1, wireType 0 =*/8).bool(message.messageSetWireFormat);
                    if (message.noStandardDescriptorAccessor != null && Object.hasOwnProperty.call(message, "noStandardDescriptorAccessor"))
                        writer.uint32(/* id 2, wireType 0 =*/16).bool(message.noStandardDescriptorAccessor);
                    if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                        writer.uint32(/* id 3, wireType 0 =*/24).bool(message.deprecated);
                    if (message.mapEntry != null && Object.hasOwnProperty.call(message, "mapEntry"))
                        writer.uint32(/* id 7, wireType 0 =*/56).bool(message.mapEntry);
                    if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                        for (var i = 0; i < message.uninterpretedOption.length; ++i)
                            $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                    if (message[".google.api.resource"] != null && Object.hasOwnProperty.call(message, ".google.api.resource"))
                        $root.google.api.ResourceDescriptor.encode(message[".google.api.resource"], writer.uint32(/* id 1053, wireType 2 =*/8426).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified MessageOptions message, length delimited. Does not implicitly {@link google.protobuf.MessageOptions.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.MessageOptions
                 * @static
                 * @param {google.protobuf.IMessageOptions} message MessageOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                MessageOptions.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a MessageOptions message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.MessageOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.MessageOptions} MessageOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                MessageOptions.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.MessageOptions();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.messageSetWireFormat = reader.bool();
                                break;
                            }
                        case 2: {
                                message.noStandardDescriptorAccessor = reader.bool();
                                break;
                            }
                        case 3: {
                                message.deprecated = reader.bool();
                                break;
                            }
                        case 7: {
                                message.mapEntry = reader.bool();
                                break;
                            }
                        case 999: {
                                if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                                    message.uninterpretedOption = [];
                                message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                                break;
                            }
                        case 1053: {
                                message[".google.api.resource"] = $root.google.api.ResourceDescriptor.decode(reader, reader.uint32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a MessageOptions message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.MessageOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.MessageOptions} MessageOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                MessageOptions.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a MessageOptions message.
                 * @function verify
                 * @memberof google.protobuf.MessageOptions
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                MessageOptions.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.messageSetWireFormat != null && message.hasOwnProperty("messageSetWireFormat"))
                        if (typeof message.messageSetWireFormat !== "boolean")
                            return "messageSetWireFormat: boolean expected";
                    if (message.noStandardDescriptorAccessor != null && message.hasOwnProperty("noStandardDescriptorAccessor"))
                        if (typeof message.noStandardDescriptorAccessor !== "boolean")
                            return "noStandardDescriptorAccessor: boolean expected";
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        if (typeof message.deprecated !== "boolean")
                            return "deprecated: boolean expected";
                    if (message.mapEntry != null && message.hasOwnProperty("mapEntry"))
                        if (typeof message.mapEntry !== "boolean")
                            return "mapEntry: boolean expected";
                    if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                        if (!Array.isArray(message.uninterpretedOption))
                            return "uninterpretedOption: array expected";
                        for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                            var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                            if (error)
                                return "uninterpretedOption." + error;
                        }
                    }
                    if (message[".google.api.resource"] != null && message.hasOwnProperty(".google.api.resource")) {
                        var error = $root.google.api.ResourceDescriptor.verify(message[".google.api.resource"]);
                        if (error)
                            return ".google.api.resource." + error;
                    }
                    return null;
                };
    
                /**
                 * Creates a MessageOptions message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.MessageOptions
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.MessageOptions} MessageOptions
                 */
                MessageOptions.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.MessageOptions)
                        return object;
                    var message = new $root.google.protobuf.MessageOptions();
                    if (object.messageSetWireFormat != null)
                        message.messageSetWireFormat = Boolean(object.messageSetWireFormat);
                    if (object.noStandardDescriptorAccessor != null)
                        message.noStandardDescriptorAccessor = Boolean(object.noStandardDescriptorAccessor);
                    if (object.deprecated != null)
                        message.deprecated = Boolean(object.deprecated);
                    if (object.mapEntry != null)
                        message.mapEntry = Boolean(object.mapEntry);
                    if (object.uninterpretedOption) {
                        if (!Array.isArray(object.uninterpretedOption))
                            throw TypeError(".google.protobuf.MessageOptions.uninterpretedOption: array expected");
                        message.uninterpretedOption = [];
                        for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                            if (typeof object.uninterpretedOption[i] !== "object")
                                throw TypeError(".google.protobuf.MessageOptions.uninterpretedOption: object expected");
                            message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                        }
                    }
                    if (object[".google.api.resource"] != null) {
                        if (typeof object[".google.api.resource"] !== "object")
                            throw TypeError(".google.protobuf.MessageOptions..google.api.resource: object expected");
                        message[".google.api.resource"] = $root.google.api.ResourceDescriptor.fromObject(object[".google.api.resource"]);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a MessageOptions message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.MessageOptions
                 * @static
                 * @param {google.protobuf.MessageOptions} message MessageOptions
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                MessageOptions.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.uninterpretedOption = [];
                    if (options.defaults) {
                        object.messageSetWireFormat = false;
                        object.noStandardDescriptorAccessor = false;
                        object.deprecated = false;
                        object.mapEntry = false;
                        object[".google.api.resource"] = null;
                    }
                    if (message.messageSetWireFormat != null && message.hasOwnProperty("messageSetWireFormat"))
                        object.messageSetWireFormat = message.messageSetWireFormat;
                    if (message.noStandardDescriptorAccessor != null && message.hasOwnProperty("noStandardDescriptorAccessor"))
                        object.noStandardDescriptorAccessor = message.noStandardDescriptorAccessor;
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        object.deprecated = message.deprecated;
                    if (message.mapEntry != null && message.hasOwnProperty("mapEntry"))
                        object.mapEntry = message.mapEntry;
                    if (message.uninterpretedOption && message.uninterpretedOption.length) {
                        object.uninterpretedOption = [];
                        for (var j = 0; j < message.uninterpretedOption.length; ++j)
                            object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                    }
                    if (message[".google.api.resource"] != null && message.hasOwnProperty(".google.api.resource"))
                        object[".google.api.resource"] = $root.google.api.ResourceDescriptor.toObject(message[".google.api.resource"], options);
                    return object;
                };
    
                /**
                 * Converts this MessageOptions to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.MessageOptions
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                MessageOptions.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for MessageOptions
                 * @function getTypeUrl
                 * @memberof google.protobuf.MessageOptions
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                MessageOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.MessageOptions";
                };
    
                return MessageOptions;
            })();
    
            protobuf.FieldOptions = (function() {
    
                /**
                 * Properties of a FieldOptions.
                 * @memberof google.protobuf
                 * @interface IFieldOptions
                 * @property {google.protobuf.FieldOptions.CType|null} [ctype] FieldOptions ctype
                 * @property {boolean|null} [packed] FieldOptions packed
                 * @property {google.protobuf.FieldOptions.JSType|null} [jstype] FieldOptions jstype
                 * @property {boolean|null} [lazy] FieldOptions lazy
                 * @property {boolean|null} [unverifiedLazy] FieldOptions unverifiedLazy
                 * @property {boolean|null} [deprecated] FieldOptions deprecated
                 * @property {boolean|null} [weak] FieldOptions weak
                 * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] FieldOptions uninterpretedOption
                 * @property {Array.<google.api.FieldBehavior>|null} [".google.api.fieldBehavior"] FieldOptions .google.api.fieldBehavior
                 * @property {google.api.IResourceReference|null} [".google.api.resourceReference"] FieldOptions .google.api.resourceReference
                 */
    
                /**
                 * Constructs a new FieldOptions.
                 * @memberof google.protobuf
                 * @classdesc Represents a FieldOptions.
                 * @implements IFieldOptions
                 * @constructor
                 * @param {google.protobuf.IFieldOptions=} [properties] Properties to set
                 */
                function FieldOptions(properties) {
                    this.uninterpretedOption = [];
                    this[".google.api.fieldBehavior"] = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * FieldOptions ctype.
                 * @member {google.protobuf.FieldOptions.CType} ctype
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype.ctype = 0;
    
                /**
                 * FieldOptions packed.
                 * @member {boolean} packed
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype.packed = false;
    
                /**
                 * FieldOptions jstype.
                 * @member {google.protobuf.FieldOptions.JSType} jstype
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype.jstype = 0;
    
                /**
                 * FieldOptions lazy.
                 * @member {boolean} lazy
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype.lazy = false;
    
                /**
                 * FieldOptions unverifiedLazy.
                 * @member {boolean} unverifiedLazy
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype.unverifiedLazy = false;
    
                /**
                 * FieldOptions deprecated.
                 * @member {boolean} deprecated
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype.deprecated = false;
    
                /**
                 * FieldOptions weak.
                 * @member {boolean} weak
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype.weak = false;
    
                /**
                 * FieldOptions uninterpretedOption.
                 * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype.uninterpretedOption = $util.emptyArray;
    
                /**
                 * FieldOptions .google.api.fieldBehavior.
                 * @member {Array.<google.api.FieldBehavior>} .google.api.fieldBehavior
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype[".google.api.fieldBehavior"] = $util.emptyArray;
    
                /**
                 * FieldOptions .google.api.resourceReference.
                 * @member {google.api.IResourceReference|null|undefined} .google.api.resourceReference
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 */
                FieldOptions.prototype[".google.api.resourceReference"] = null;
    
                /**
                 * Creates a new FieldOptions instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.FieldOptions
                 * @static
                 * @param {google.protobuf.IFieldOptions=} [properties] Properties to set
                 * @returns {google.protobuf.FieldOptions} FieldOptions instance
                 */
                FieldOptions.create = function create(properties) {
                    return new FieldOptions(properties);
                };
    
                /**
                 * Encodes the specified FieldOptions message. Does not implicitly {@link google.protobuf.FieldOptions.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.FieldOptions
                 * @static
                 * @param {google.protobuf.IFieldOptions} message FieldOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FieldOptions.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.ctype != null && Object.hasOwnProperty.call(message, "ctype"))
                        writer.uint32(/* id 1, wireType 0 =*/8).int32(message.ctype);
                    if (message.packed != null && Object.hasOwnProperty.call(message, "packed"))
                        writer.uint32(/* id 2, wireType 0 =*/16).bool(message.packed);
                    if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                        writer.uint32(/* id 3, wireType 0 =*/24).bool(message.deprecated);
                    if (message.lazy != null && Object.hasOwnProperty.call(message, "lazy"))
                        writer.uint32(/* id 5, wireType 0 =*/40).bool(message.lazy);
                    if (message.jstype != null && Object.hasOwnProperty.call(message, "jstype"))
                        writer.uint32(/* id 6, wireType 0 =*/48).int32(message.jstype);
                    if (message.weak != null && Object.hasOwnProperty.call(message, "weak"))
                        writer.uint32(/* id 10, wireType 0 =*/80).bool(message.weak);
                    if (message.unverifiedLazy != null && Object.hasOwnProperty.call(message, "unverifiedLazy"))
                        writer.uint32(/* id 15, wireType 0 =*/120).bool(message.unverifiedLazy);
                    if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                        for (var i = 0; i < message.uninterpretedOption.length; ++i)
                            $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                    if (message[".google.api.fieldBehavior"] != null && message[".google.api.fieldBehavior"].length) {
                        writer.uint32(/* id 1052, wireType 2 =*/8418).fork();
                        for (var i = 0; i < message[".google.api.fieldBehavior"].length; ++i)
                            writer.int32(message[".google.api.fieldBehavior"][i]);
                        writer.ldelim();
                    }
                    if (message[".google.api.resourceReference"] != null && Object.hasOwnProperty.call(message, ".google.api.resourceReference"))
                        $root.google.api.ResourceReference.encode(message[".google.api.resourceReference"], writer.uint32(/* id 1055, wireType 2 =*/8442).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified FieldOptions message, length delimited. Does not implicitly {@link google.protobuf.FieldOptions.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.FieldOptions
                 * @static
                 * @param {google.protobuf.IFieldOptions} message FieldOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                FieldOptions.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a FieldOptions message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.FieldOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.FieldOptions} FieldOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FieldOptions.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.FieldOptions();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.ctype = reader.int32();
                                break;
                            }
                        case 2: {
                                message.packed = reader.bool();
                                break;
                            }
                        case 6: {
                                message.jstype = reader.int32();
                                break;
                            }
                        case 5: {
                                message.lazy = reader.bool();
                                break;
                            }
                        case 15: {
                                message.unverifiedLazy = reader.bool();
                                break;
                            }
                        case 3: {
                                message.deprecated = reader.bool();
                                break;
                            }
                        case 10: {
                                message.weak = reader.bool();
                                break;
                            }
                        case 999: {
                                if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                                    message.uninterpretedOption = [];
                                message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                                break;
                            }
                        case 1052: {
                                if (!(message[".google.api.fieldBehavior"] && message[".google.api.fieldBehavior"].length))
                                    message[".google.api.fieldBehavior"] = [];
                                if ((tag & 7) === 2) {
                                    var end2 = reader.uint32() + reader.pos;
                                    while (reader.pos < end2)
                                        message[".google.api.fieldBehavior"].push(reader.int32());
                                } else
                                    message[".google.api.fieldBehavior"].push(reader.int32());
                                break;
                            }
                        case 1055: {
                                message[".google.api.resourceReference"] = $root.google.api.ResourceReference.decode(reader, reader.uint32());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a FieldOptions message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.FieldOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.FieldOptions} FieldOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                FieldOptions.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a FieldOptions message.
                 * @function verify
                 * @memberof google.protobuf.FieldOptions
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                FieldOptions.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.ctype != null && message.hasOwnProperty("ctype"))
                        switch (message.ctype) {
                        default:
                            return "ctype: enum value expected";
                        case 0:
                        case 1:
                        case 2:
                            break;
                        }
                    if (message.packed != null && message.hasOwnProperty("packed"))
                        if (typeof message.packed !== "boolean")
                            return "packed: boolean expected";
                    if (message.jstype != null && message.hasOwnProperty("jstype"))
                        switch (message.jstype) {
                        default:
                            return "jstype: enum value expected";
                        case 0:
                        case 1:
                        case 2:
                            break;
                        }
                    if (message.lazy != null && message.hasOwnProperty("lazy"))
                        if (typeof message.lazy !== "boolean")
                            return "lazy: boolean expected";
                    if (message.unverifiedLazy != null && message.hasOwnProperty("unverifiedLazy"))
                        if (typeof message.unverifiedLazy !== "boolean")
                            return "unverifiedLazy: boolean expected";
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        if (typeof message.deprecated !== "boolean")
                            return "deprecated: boolean expected";
                    if (message.weak != null && message.hasOwnProperty("weak"))
                        if (typeof message.weak !== "boolean")
                            return "weak: boolean expected";
                    if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                        if (!Array.isArray(message.uninterpretedOption))
                            return "uninterpretedOption: array expected";
                        for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                            var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                            if (error)
                                return "uninterpretedOption." + error;
                        }
                    }
                    if (message[".google.api.fieldBehavior"] != null && message.hasOwnProperty(".google.api.fieldBehavior")) {
                        if (!Array.isArray(message[".google.api.fieldBehavior"]))
                            return ".google.api.fieldBehavior: array expected";
                        for (var i = 0; i < message[".google.api.fieldBehavior"].length; ++i)
                            switch (message[".google.api.fieldBehavior"][i]) {
                            default:
                                return ".google.api.fieldBehavior: enum value[] expected";
                            case 0:
                            case 1:
                            case 2:
                            case 3:
                            case 4:
                            case 5:
                            case 6:
                            case 7:
                                break;
                            }
                    }
                    if (message[".google.api.resourceReference"] != null && message.hasOwnProperty(".google.api.resourceReference")) {
                        var error = $root.google.api.ResourceReference.verify(message[".google.api.resourceReference"]);
                        if (error)
                            return ".google.api.resourceReference." + error;
                    }
                    return null;
                };
    
                /**
                 * Creates a FieldOptions message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.FieldOptions
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.FieldOptions} FieldOptions
                 */
                FieldOptions.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.FieldOptions)
                        return object;
                    var message = new $root.google.protobuf.FieldOptions();
                    switch (object.ctype) {
                    default:
                        if (typeof object.ctype === "number") {
                            message.ctype = object.ctype;
                            break;
                        }
                        break;
                    case "STRING":
                    case 0:
                        message.ctype = 0;
                        break;
                    case "CORD":
                    case 1:
                        message.ctype = 1;
                        break;
                    case "STRING_PIECE":
                    case 2:
                        message.ctype = 2;
                        break;
                    }
                    if (object.packed != null)
                        message.packed = Boolean(object.packed);
                    switch (object.jstype) {
                    default:
                        if (typeof object.jstype === "number") {
                            message.jstype = object.jstype;
                            break;
                        }
                        break;
                    case "JS_NORMAL":
                    case 0:
                        message.jstype = 0;
                        break;
                    case "JS_STRING":
                    case 1:
                        message.jstype = 1;
                        break;
                    case "JS_NUMBER":
                    case 2:
                        message.jstype = 2;
                        break;
                    }
                    if (object.lazy != null)
                        message.lazy = Boolean(object.lazy);
                    if (object.unverifiedLazy != null)
                        message.unverifiedLazy = Boolean(object.unverifiedLazy);
                    if (object.deprecated != null)
                        message.deprecated = Boolean(object.deprecated);
                    if (object.weak != null)
                        message.weak = Boolean(object.weak);
                    if (object.uninterpretedOption) {
                        if (!Array.isArray(object.uninterpretedOption))
                            throw TypeError(".google.protobuf.FieldOptions.uninterpretedOption: array expected");
                        message.uninterpretedOption = [];
                        for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                            if (typeof object.uninterpretedOption[i] !== "object")
                                throw TypeError(".google.protobuf.FieldOptions.uninterpretedOption: object expected");
                            message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                        }
                    }
                    if (object[".google.api.fieldBehavior"]) {
                        if (!Array.isArray(object[".google.api.fieldBehavior"]))
                            throw TypeError(".google.protobuf.FieldOptions..google.api.fieldBehavior: array expected");
                        message[".google.api.fieldBehavior"] = [];
                        for (var i = 0; i < object[".google.api.fieldBehavior"].length; ++i)
                            switch (object[".google.api.fieldBehavior"][i]) {
                            default:
                                if (typeof object[".google.api.fieldBehavior"][i] === "number") {
                                    message[".google.api.fieldBehavior"][i] = object[".google.api.fieldBehavior"][i];
                                    break;
                                }
                            case "FIELD_BEHAVIOR_UNSPECIFIED":
                            case 0:
                                message[".google.api.fieldBehavior"][i] = 0;
                                break;
                            case "OPTIONAL":
                            case 1:
                                message[".google.api.fieldBehavior"][i] = 1;
                                break;
                            case "REQUIRED":
                            case 2:
                                message[".google.api.fieldBehavior"][i] = 2;
                                break;
                            case "OUTPUT_ONLY":
                            case 3:
                                message[".google.api.fieldBehavior"][i] = 3;
                                break;
                            case "INPUT_ONLY":
                            case 4:
                                message[".google.api.fieldBehavior"][i] = 4;
                                break;
                            case "IMMUTABLE":
                            case 5:
                                message[".google.api.fieldBehavior"][i] = 5;
                                break;
                            case "UNORDERED_LIST":
                            case 6:
                                message[".google.api.fieldBehavior"][i] = 6;
                                break;
                            case "NON_EMPTY_DEFAULT":
                            case 7:
                                message[".google.api.fieldBehavior"][i] = 7;
                                break;
                            }
                    }
                    if (object[".google.api.resourceReference"] != null) {
                        if (typeof object[".google.api.resourceReference"] !== "object")
                            throw TypeError(".google.protobuf.FieldOptions..google.api.resourceReference: object expected");
                        message[".google.api.resourceReference"] = $root.google.api.ResourceReference.fromObject(object[".google.api.resourceReference"]);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a FieldOptions message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.FieldOptions
                 * @static
                 * @param {google.protobuf.FieldOptions} message FieldOptions
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                FieldOptions.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults) {
                        object.uninterpretedOption = [];
                        object[".google.api.fieldBehavior"] = [];
                    }
                    if (options.defaults) {
                        object.ctype = options.enums === String ? "STRING" : 0;
                        object.packed = false;
                        object.deprecated = false;
                        object.lazy = false;
                        object.jstype = options.enums === String ? "JS_NORMAL" : 0;
                        object.weak = false;
                        object.unverifiedLazy = false;
                        object[".google.api.resourceReference"] = null;
                    }
                    if (message.ctype != null && message.hasOwnProperty("ctype"))
                        object.ctype = options.enums === String ? $root.google.protobuf.FieldOptions.CType[message.ctype] === undefined ? message.ctype : $root.google.protobuf.FieldOptions.CType[message.ctype] : message.ctype;
                    if (message.packed != null && message.hasOwnProperty("packed"))
                        object.packed = message.packed;
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        object.deprecated = message.deprecated;
                    if (message.lazy != null && message.hasOwnProperty("lazy"))
                        object.lazy = message.lazy;
                    if (message.jstype != null && message.hasOwnProperty("jstype"))
                        object.jstype = options.enums === String ? $root.google.protobuf.FieldOptions.JSType[message.jstype] === undefined ? message.jstype : $root.google.protobuf.FieldOptions.JSType[message.jstype] : message.jstype;
                    if (message.weak != null && message.hasOwnProperty("weak"))
                        object.weak = message.weak;
                    if (message.unverifiedLazy != null && message.hasOwnProperty("unverifiedLazy"))
                        object.unverifiedLazy = message.unverifiedLazy;
                    if (message.uninterpretedOption && message.uninterpretedOption.length) {
                        object.uninterpretedOption = [];
                        for (var j = 0; j < message.uninterpretedOption.length; ++j)
                            object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                    }
                    if (message[".google.api.fieldBehavior"] && message[".google.api.fieldBehavior"].length) {
                        object[".google.api.fieldBehavior"] = [];
                        for (var j = 0; j < message[".google.api.fieldBehavior"].length; ++j)
                            object[".google.api.fieldBehavior"][j] = options.enums === String ? $root.google.api.FieldBehavior[message[".google.api.fieldBehavior"][j]] === undefined ? message[".google.api.fieldBehavior"][j] : $root.google.api.FieldBehavior[message[".google.api.fieldBehavior"][j]] : message[".google.api.fieldBehavior"][j];
                    }
                    if (message[".google.api.resourceReference"] != null && message.hasOwnProperty(".google.api.resourceReference"))
                        object[".google.api.resourceReference"] = $root.google.api.ResourceReference.toObject(message[".google.api.resourceReference"], options);
                    return object;
                };
    
                /**
                 * Converts this FieldOptions to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.FieldOptions
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                FieldOptions.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for FieldOptions
                 * @function getTypeUrl
                 * @memberof google.protobuf.FieldOptions
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                FieldOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.FieldOptions";
                };
    
                /**
                 * CType enum.
                 * @name google.protobuf.FieldOptions.CType
                 * @enum {number}
                 * @property {number} STRING=0 STRING value
                 * @property {number} CORD=1 CORD value
                 * @property {number} STRING_PIECE=2 STRING_PIECE value
                 */
                FieldOptions.CType = (function() {
                    var valuesById = {}, values = Object.create(valuesById);
                    values[valuesById[0] = "STRING"] = 0;
                    values[valuesById[1] = "CORD"] = 1;
                    values[valuesById[2] = "STRING_PIECE"] = 2;
                    return values;
                })();
    
                /**
                 * JSType enum.
                 * @name google.protobuf.FieldOptions.JSType
                 * @enum {number}
                 * @property {number} JS_NORMAL=0 JS_NORMAL value
                 * @property {number} JS_STRING=1 JS_STRING value
                 * @property {number} JS_NUMBER=2 JS_NUMBER value
                 */
                FieldOptions.JSType = (function() {
                    var valuesById = {}, values = Object.create(valuesById);
                    values[valuesById[0] = "JS_NORMAL"] = 0;
                    values[valuesById[1] = "JS_STRING"] = 1;
                    values[valuesById[2] = "JS_NUMBER"] = 2;
                    return values;
                })();
    
                return FieldOptions;
            })();
    
            protobuf.OneofOptions = (function() {
    
                /**
                 * Properties of an OneofOptions.
                 * @memberof google.protobuf
                 * @interface IOneofOptions
                 * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] OneofOptions uninterpretedOption
                 */
    
                /**
                 * Constructs a new OneofOptions.
                 * @memberof google.protobuf
                 * @classdesc Represents an OneofOptions.
                 * @implements IOneofOptions
                 * @constructor
                 * @param {google.protobuf.IOneofOptions=} [properties] Properties to set
                 */
                function OneofOptions(properties) {
                    this.uninterpretedOption = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * OneofOptions uninterpretedOption.
                 * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
                 * @memberof google.protobuf.OneofOptions
                 * @instance
                 */
                OneofOptions.prototype.uninterpretedOption = $util.emptyArray;
    
                /**
                 * Creates a new OneofOptions instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.OneofOptions
                 * @static
                 * @param {google.protobuf.IOneofOptions=} [properties] Properties to set
                 * @returns {google.protobuf.OneofOptions} OneofOptions instance
                 */
                OneofOptions.create = function create(properties) {
                    return new OneofOptions(properties);
                };
    
                /**
                 * Encodes the specified OneofOptions message. Does not implicitly {@link google.protobuf.OneofOptions.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.OneofOptions
                 * @static
                 * @param {google.protobuf.IOneofOptions} message OneofOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                OneofOptions.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                        for (var i = 0; i < message.uninterpretedOption.length; ++i)
                            $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified OneofOptions message, length delimited. Does not implicitly {@link google.protobuf.OneofOptions.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.OneofOptions
                 * @static
                 * @param {google.protobuf.IOneofOptions} message OneofOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                OneofOptions.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an OneofOptions message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.OneofOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.OneofOptions} OneofOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                OneofOptions.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.OneofOptions();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 999: {
                                if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                                    message.uninterpretedOption = [];
                                message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an OneofOptions message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.OneofOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.OneofOptions} OneofOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                OneofOptions.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an OneofOptions message.
                 * @function verify
                 * @memberof google.protobuf.OneofOptions
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                OneofOptions.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                        if (!Array.isArray(message.uninterpretedOption))
                            return "uninterpretedOption: array expected";
                        for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                            var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                            if (error)
                                return "uninterpretedOption." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates an OneofOptions message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.OneofOptions
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.OneofOptions} OneofOptions
                 */
                OneofOptions.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.OneofOptions)
                        return object;
                    var message = new $root.google.protobuf.OneofOptions();
                    if (object.uninterpretedOption) {
                        if (!Array.isArray(object.uninterpretedOption))
                            throw TypeError(".google.protobuf.OneofOptions.uninterpretedOption: array expected");
                        message.uninterpretedOption = [];
                        for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                            if (typeof object.uninterpretedOption[i] !== "object")
                                throw TypeError(".google.protobuf.OneofOptions.uninterpretedOption: object expected");
                            message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                        }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from an OneofOptions message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.OneofOptions
                 * @static
                 * @param {google.protobuf.OneofOptions} message OneofOptions
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                OneofOptions.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.uninterpretedOption = [];
                    if (message.uninterpretedOption && message.uninterpretedOption.length) {
                        object.uninterpretedOption = [];
                        for (var j = 0; j < message.uninterpretedOption.length; ++j)
                            object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                    }
                    return object;
                };
    
                /**
                 * Converts this OneofOptions to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.OneofOptions
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                OneofOptions.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for OneofOptions
                 * @function getTypeUrl
                 * @memberof google.protobuf.OneofOptions
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                OneofOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.OneofOptions";
                };
    
                return OneofOptions;
            })();
    
            protobuf.EnumOptions = (function() {
    
                /**
                 * Properties of an EnumOptions.
                 * @memberof google.protobuf
                 * @interface IEnumOptions
                 * @property {boolean|null} [allowAlias] EnumOptions allowAlias
                 * @property {boolean|null} [deprecated] EnumOptions deprecated
                 * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] EnumOptions uninterpretedOption
                 */
    
                /**
                 * Constructs a new EnumOptions.
                 * @memberof google.protobuf
                 * @classdesc Represents an EnumOptions.
                 * @implements IEnumOptions
                 * @constructor
                 * @param {google.protobuf.IEnumOptions=} [properties] Properties to set
                 */
                function EnumOptions(properties) {
                    this.uninterpretedOption = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * EnumOptions allowAlias.
                 * @member {boolean} allowAlias
                 * @memberof google.protobuf.EnumOptions
                 * @instance
                 */
                EnumOptions.prototype.allowAlias = false;
    
                /**
                 * EnumOptions deprecated.
                 * @member {boolean} deprecated
                 * @memberof google.protobuf.EnumOptions
                 * @instance
                 */
                EnumOptions.prototype.deprecated = false;
    
                /**
                 * EnumOptions uninterpretedOption.
                 * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
                 * @memberof google.protobuf.EnumOptions
                 * @instance
                 */
                EnumOptions.prototype.uninterpretedOption = $util.emptyArray;
    
                /**
                 * Creates a new EnumOptions instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.EnumOptions
                 * @static
                 * @param {google.protobuf.IEnumOptions=} [properties] Properties to set
                 * @returns {google.protobuf.EnumOptions} EnumOptions instance
                 */
                EnumOptions.create = function create(properties) {
                    return new EnumOptions(properties);
                };
    
                /**
                 * Encodes the specified EnumOptions message. Does not implicitly {@link google.protobuf.EnumOptions.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.EnumOptions
                 * @static
                 * @param {google.protobuf.IEnumOptions} message EnumOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                EnumOptions.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.allowAlias != null && Object.hasOwnProperty.call(message, "allowAlias"))
                        writer.uint32(/* id 2, wireType 0 =*/16).bool(message.allowAlias);
                    if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                        writer.uint32(/* id 3, wireType 0 =*/24).bool(message.deprecated);
                    if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                        for (var i = 0; i < message.uninterpretedOption.length; ++i)
                            $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified EnumOptions message, length delimited. Does not implicitly {@link google.protobuf.EnumOptions.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.EnumOptions
                 * @static
                 * @param {google.protobuf.IEnumOptions} message EnumOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                EnumOptions.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an EnumOptions message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.EnumOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.EnumOptions} EnumOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                EnumOptions.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.EnumOptions();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 2: {
                                message.allowAlias = reader.bool();
                                break;
                            }
                        case 3: {
                                message.deprecated = reader.bool();
                                break;
                            }
                        case 999: {
                                if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                                    message.uninterpretedOption = [];
                                message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an EnumOptions message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.EnumOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.EnumOptions} EnumOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                EnumOptions.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an EnumOptions message.
                 * @function verify
                 * @memberof google.protobuf.EnumOptions
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                EnumOptions.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.allowAlias != null && message.hasOwnProperty("allowAlias"))
                        if (typeof message.allowAlias !== "boolean")
                            return "allowAlias: boolean expected";
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        if (typeof message.deprecated !== "boolean")
                            return "deprecated: boolean expected";
                    if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                        if (!Array.isArray(message.uninterpretedOption))
                            return "uninterpretedOption: array expected";
                        for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                            var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                            if (error)
                                return "uninterpretedOption." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates an EnumOptions message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.EnumOptions
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.EnumOptions} EnumOptions
                 */
                EnumOptions.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.EnumOptions)
                        return object;
                    var message = new $root.google.protobuf.EnumOptions();
                    if (object.allowAlias != null)
                        message.allowAlias = Boolean(object.allowAlias);
                    if (object.deprecated != null)
                        message.deprecated = Boolean(object.deprecated);
                    if (object.uninterpretedOption) {
                        if (!Array.isArray(object.uninterpretedOption))
                            throw TypeError(".google.protobuf.EnumOptions.uninterpretedOption: array expected");
                        message.uninterpretedOption = [];
                        for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                            if (typeof object.uninterpretedOption[i] !== "object")
                                throw TypeError(".google.protobuf.EnumOptions.uninterpretedOption: object expected");
                            message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                        }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from an EnumOptions message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.EnumOptions
                 * @static
                 * @param {google.protobuf.EnumOptions} message EnumOptions
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                EnumOptions.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.uninterpretedOption = [];
                    if (options.defaults) {
                        object.allowAlias = false;
                        object.deprecated = false;
                    }
                    if (message.allowAlias != null && message.hasOwnProperty("allowAlias"))
                        object.allowAlias = message.allowAlias;
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        object.deprecated = message.deprecated;
                    if (message.uninterpretedOption && message.uninterpretedOption.length) {
                        object.uninterpretedOption = [];
                        for (var j = 0; j < message.uninterpretedOption.length; ++j)
                            object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                    }
                    return object;
                };
    
                /**
                 * Converts this EnumOptions to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.EnumOptions
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                EnumOptions.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for EnumOptions
                 * @function getTypeUrl
                 * @memberof google.protobuf.EnumOptions
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                EnumOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.EnumOptions";
                };
    
                return EnumOptions;
            })();
    
            protobuf.EnumValueOptions = (function() {
    
                /**
                 * Properties of an EnumValueOptions.
                 * @memberof google.protobuf
                 * @interface IEnumValueOptions
                 * @property {boolean|null} [deprecated] EnumValueOptions deprecated
                 * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] EnumValueOptions uninterpretedOption
                 */
    
                /**
                 * Constructs a new EnumValueOptions.
                 * @memberof google.protobuf
                 * @classdesc Represents an EnumValueOptions.
                 * @implements IEnumValueOptions
                 * @constructor
                 * @param {google.protobuf.IEnumValueOptions=} [properties] Properties to set
                 */
                function EnumValueOptions(properties) {
                    this.uninterpretedOption = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * EnumValueOptions deprecated.
                 * @member {boolean} deprecated
                 * @memberof google.protobuf.EnumValueOptions
                 * @instance
                 */
                EnumValueOptions.prototype.deprecated = false;
    
                /**
                 * EnumValueOptions uninterpretedOption.
                 * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
                 * @memberof google.protobuf.EnumValueOptions
                 * @instance
                 */
                EnumValueOptions.prototype.uninterpretedOption = $util.emptyArray;
    
                /**
                 * Creates a new EnumValueOptions instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.EnumValueOptions
                 * @static
                 * @param {google.protobuf.IEnumValueOptions=} [properties] Properties to set
                 * @returns {google.protobuf.EnumValueOptions} EnumValueOptions instance
                 */
                EnumValueOptions.create = function create(properties) {
                    return new EnumValueOptions(properties);
                };
    
                /**
                 * Encodes the specified EnumValueOptions message. Does not implicitly {@link google.protobuf.EnumValueOptions.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.EnumValueOptions
                 * @static
                 * @param {google.protobuf.IEnumValueOptions} message EnumValueOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                EnumValueOptions.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                        writer.uint32(/* id 1, wireType 0 =*/8).bool(message.deprecated);
                    if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                        for (var i = 0; i < message.uninterpretedOption.length; ++i)
                            $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified EnumValueOptions message, length delimited. Does not implicitly {@link google.protobuf.EnumValueOptions.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.EnumValueOptions
                 * @static
                 * @param {google.protobuf.IEnumValueOptions} message EnumValueOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                EnumValueOptions.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an EnumValueOptions message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.EnumValueOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.EnumValueOptions} EnumValueOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                EnumValueOptions.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.EnumValueOptions();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                message.deprecated = reader.bool();
                                break;
                            }
                        case 999: {
                                if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                                    message.uninterpretedOption = [];
                                message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an EnumValueOptions message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.EnumValueOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.EnumValueOptions} EnumValueOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                EnumValueOptions.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an EnumValueOptions message.
                 * @function verify
                 * @memberof google.protobuf.EnumValueOptions
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                EnumValueOptions.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        if (typeof message.deprecated !== "boolean")
                            return "deprecated: boolean expected";
                    if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                        if (!Array.isArray(message.uninterpretedOption))
                            return "uninterpretedOption: array expected";
                        for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                            var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                            if (error)
                                return "uninterpretedOption." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates an EnumValueOptions message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.EnumValueOptions
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.EnumValueOptions} EnumValueOptions
                 */
                EnumValueOptions.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.EnumValueOptions)
                        return object;
                    var message = new $root.google.protobuf.EnumValueOptions();
                    if (object.deprecated != null)
                        message.deprecated = Boolean(object.deprecated);
                    if (object.uninterpretedOption) {
                        if (!Array.isArray(object.uninterpretedOption))
                            throw TypeError(".google.protobuf.EnumValueOptions.uninterpretedOption: array expected");
                        message.uninterpretedOption = [];
                        for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                            if (typeof object.uninterpretedOption[i] !== "object")
                                throw TypeError(".google.protobuf.EnumValueOptions.uninterpretedOption: object expected");
                            message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                        }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from an EnumValueOptions message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.EnumValueOptions
                 * @static
                 * @param {google.protobuf.EnumValueOptions} message EnumValueOptions
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                EnumValueOptions.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.uninterpretedOption = [];
                    if (options.defaults)
                        object.deprecated = false;
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        object.deprecated = message.deprecated;
                    if (message.uninterpretedOption && message.uninterpretedOption.length) {
                        object.uninterpretedOption = [];
                        for (var j = 0; j < message.uninterpretedOption.length; ++j)
                            object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                    }
                    return object;
                };
    
                /**
                 * Converts this EnumValueOptions to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.EnumValueOptions
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                EnumValueOptions.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for EnumValueOptions
                 * @function getTypeUrl
                 * @memberof google.protobuf.EnumValueOptions
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                EnumValueOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.EnumValueOptions";
                };
    
                return EnumValueOptions;
            })();
    
            protobuf.ServiceOptions = (function() {
    
                /**
                 * Properties of a ServiceOptions.
                 * @memberof google.protobuf
                 * @interface IServiceOptions
                 * @property {boolean|null} [deprecated] ServiceOptions deprecated
                 * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] ServiceOptions uninterpretedOption
                 * @property {string|null} [".google.api.defaultHost"] ServiceOptions .google.api.defaultHost
                 * @property {string|null} [".google.api.oauthScopes"] ServiceOptions .google.api.oauthScopes
                 */
    
                /**
                 * Constructs a new ServiceOptions.
                 * @memberof google.protobuf
                 * @classdesc Represents a ServiceOptions.
                 * @implements IServiceOptions
                 * @constructor
                 * @param {google.protobuf.IServiceOptions=} [properties] Properties to set
                 */
                function ServiceOptions(properties) {
                    this.uninterpretedOption = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * ServiceOptions deprecated.
                 * @member {boolean} deprecated
                 * @memberof google.protobuf.ServiceOptions
                 * @instance
                 */
                ServiceOptions.prototype.deprecated = false;
    
                /**
                 * ServiceOptions uninterpretedOption.
                 * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
                 * @memberof google.protobuf.ServiceOptions
                 * @instance
                 */
                ServiceOptions.prototype.uninterpretedOption = $util.emptyArray;
    
                /**
                 * ServiceOptions .google.api.defaultHost.
                 * @member {string} .google.api.defaultHost
                 * @memberof google.protobuf.ServiceOptions
                 * @instance
                 */
                ServiceOptions.prototype[".google.api.defaultHost"] = "";
    
                /**
                 * ServiceOptions .google.api.oauthScopes.
                 * @member {string} .google.api.oauthScopes
                 * @memberof google.protobuf.ServiceOptions
                 * @instance
                 */
                ServiceOptions.prototype[".google.api.oauthScopes"] = "";
    
                /**
                 * Creates a new ServiceOptions instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.ServiceOptions
                 * @static
                 * @param {google.protobuf.IServiceOptions=} [properties] Properties to set
                 * @returns {google.protobuf.ServiceOptions} ServiceOptions instance
                 */
                ServiceOptions.create = function create(properties) {
                    return new ServiceOptions(properties);
                };
    
                /**
                 * Encodes the specified ServiceOptions message. Does not implicitly {@link google.protobuf.ServiceOptions.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.ServiceOptions
                 * @static
                 * @param {google.protobuf.IServiceOptions} message ServiceOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ServiceOptions.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                        writer.uint32(/* id 33, wireType 0 =*/264).bool(message.deprecated);
                    if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                        for (var i = 0; i < message.uninterpretedOption.length; ++i)
                            $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                    if (message[".google.api.defaultHost"] != null && Object.hasOwnProperty.call(message, ".google.api.defaultHost"))
                        writer.uint32(/* id 1049, wireType 2 =*/8394).string(message[".google.api.defaultHost"]);
                    if (message[".google.api.oauthScopes"] != null && Object.hasOwnProperty.call(message, ".google.api.oauthScopes"))
                        writer.uint32(/* id 1050, wireType 2 =*/8402).string(message[".google.api.oauthScopes"]);
                    return writer;
                };
    
                /**
                 * Encodes the specified ServiceOptions message, length delimited. Does not implicitly {@link google.protobuf.ServiceOptions.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.ServiceOptions
                 * @static
                 * @param {google.protobuf.IServiceOptions} message ServiceOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                ServiceOptions.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a ServiceOptions message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.ServiceOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.ServiceOptions} ServiceOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ServiceOptions.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.ServiceOptions();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 33: {
                                message.deprecated = reader.bool();
                                break;
                            }
                        case 999: {
                                if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                                    message.uninterpretedOption = [];
                                message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                                break;
                            }
                        case 1049: {
                                message[".google.api.defaultHost"] = reader.string();
                                break;
                            }
                        case 1050: {
                                message[".google.api.oauthScopes"] = reader.string();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a ServiceOptions message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.ServiceOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.ServiceOptions} ServiceOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                ServiceOptions.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a ServiceOptions message.
                 * @function verify
                 * @memberof google.protobuf.ServiceOptions
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                ServiceOptions.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        if (typeof message.deprecated !== "boolean")
                            return "deprecated: boolean expected";
                    if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                        if (!Array.isArray(message.uninterpretedOption))
                            return "uninterpretedOption: array expected";
                        for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                            var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                            if (error)
                                return "uninterpretedOption." + error;
                        }
                    }
                    if (message[".google.api.defaultHost"] != null && message.hasOwnProperty(".google.api.defaultHost"))
                        if (!$util.isString(message[".google.api.defaultHost"]))
                            return ".google.api.defaultHost: string expected";
                    if (message[".google.api.oauthScopes"] != null && message.hasOwnProperty(".google.api.oauthScopes"))
                        if (!$util.isString(message[".google.api.oauthScopes"]))
                            return ".google.api.oauthScopes: string expected";
                    return null;
                };
    
                /**
                 * Creates a ServiceOptions message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.ServiceOptions
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.ServiceOptions} ServiceOptions
                 */
                ServiceOptions.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.ServiceOptions)
                        return object;
                    var message = new $root.google.protobuf.ServiceOptions();
                    if (object.deprecated != null)
                        message.deprecated = Boolean(object.deprecated);
                    if (object.uninterpretedOption) {
                        if (!Array.isArray(object.uninterpretedOption))
                            throw TypeError(".google.protobuf.ServiceOptions.uninterpretedOption: array expected");
                        message.uninterpretedOption = [];
                        for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                            if (typeof object.uninterpretedOption[i] !== "object")
                                throw TypeError(".google.protobuf.ServiceOptions.uninterpretedOption: object expected");
                            message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                        }
                    }
                    if (object[".google.api.defaultHost"] != null)
                        message[".google.api.defaultHost"] = String(object[".google.api.defaultHost"]);
                    if (object[".google.api.oauthScopes"] != null)
                        message[".google.api.oauthScopes"] = String(object[".google.api.oauthScopes"]);
                    return message;
                };
    
                /**
                 * Creates a plain object from a ServiceOptions message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.ServiceOptions
                 * @static
                 * @param {google.protobuf.ServiceOptions} message ServiceOptions
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                ServiceOptions.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.uninterpretedOption = [];
                    if (options.defaults) {
                        object.deprecated = false;
                        object[".google.api.defaultHost"] = "";
                        object[".google.api.oauthScopes"] = "";
                    }
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        object.deprecated = message.deprecated;
                    if (message.uninterpretedOption && message.uninterpretedOption.length) {
                        object.uninterpretedOption = [];
                        for (var j = 0; j < message.uninterpretedOption.length; ++j)
                            object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                    }
                    if (message[".google.api.defaultHost"] != null && message.hasOwnProperty(".google.api.defaultHost"))
                        object[".google.api.defaultHost"] = message[".google.api.defaultHost"];
                    if (message[".google.api.oauthScopes"] != null && message.hasOwnProperty(".google.api.oauthScopes"))
                        object[".google.api.oauthScopes"] = message[".google.api.oauthScopes"];
                    return object;
                };
    
                /**
                 * Converts this ServiceOptions to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.ServiceOptions
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                ServiceOptions.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for ServiceOptions
                 * @function getTypeUrl
                 * @memberof google.protobuf.ServiceOptions
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                ServiceOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.ServiceOptions";
                };
    
                return ServiceOptions;
            })();
    
            protobuf.MethodOptions = (function() {
    
                /**
                 * Properties of a MethodOptions.
                 * @memberof google.protobuf
                 * @interface IMethodOptions
                 * @property {boolean|null} [deprecated] MethodOptions deprecated
                 * @property {google.protobuf.MethodOptions.IdempotencyLevel|null} [idempotencyLevel] MethodOptions idempotencyLevel
                 * @property {Array.<google.protobuf.IUninterpretedOption>|null} [uninterpretedOption] MethodOptions uninterpretedOption
                 * @property {google.api.IHttpRule|null} [".google.api.http"] MethodOptions .google.api.http
                 * @property {Array.<string>|null} [".google.api.methodSignature"] MethodOptions .google.api.methodSignature
                 */
    
                /**
                 * Constructs a new MethodOptions.
                 * @memberof google.protobuf
                 * @classdesc Represents a MethodOptions.
                 * @implements IMethodOptions
                 * @constructor
                 * @param {google.protobuf.IMethodOptions=} [properties] Properties to set
                 */
                function MethodOptions(properties) {
                    this.uninterpretedOption = [];
                    this[".google.api.methodSignature"] = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * MethodOptions deprecated.
                 * @member {boolean} deprecated
                 * @memberof google.protobuf.MethodOptions
                 * @instance
                 */
                MethodOptions.prototype.deprecated = false;
    
                /**
                 * MethodOptions idempotencyLevel.
                 * @member {google.protobuf.MethodOptions.IdempotencyLevel} idempotencyLevel
                 * @memberof google.protobuf.MethodOptions
                 * @instance
                 */
                MethodOptions.prototype.idempotencyLevel = 0;
    
                /**
                 * MethodOptions uninterpretedOption.
                 * @member {Array.<google.protobuf.IUninterpretedOption>} uninterpretedOption
                 * @memberof google.protobuf.MethodOptions
                 * @instance
                 */
                MethodOptions.prototype.uninterpretedOption = $util.emptyArray;
    
                /**
                 * MethodOptions .google.api.http.
                 * @member {google.api.IHttpRule|null|undefined} .google.api.http
                 * @memberof google.protobuf.MethodOptions
                 * @instance
                 */
                MethodOptions.prototype[".google.api.http"] = null;
    
                /**
                 * MethodOptions .google.api.methodSignature.
                 * @member {Array.<string>} .google.api.methodSignature
                 * @memberof google.protobuf.MethodOptions
                 * @instance
                 */
                MethodOptions.prototype[".google.api.methodSignature"] = $util.emptyArray;
    
                /**
                 * Creates a new MethodOptions instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.MethodOptions
                 * @static
                 * @param {google.protobuf.IMethodOptions=} [properties] Properties to set
                 * @returns {google.protobuf.MethodOptions} MethodOptions instance
                 */
                MethodOptions.create = function create(properties) {
                    return new MethodOptions(properties);
                };
    
                /**
                 * Encodes the specified MethodOptions message. Does not implicitly {@link google.protobuf.MethodOptions.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.MethodOptions
                 * @static
                 * @param {google.protobuf.IMethodOptions} message MethodOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                MethodOptions.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.deprecated != null && Object.hasOwnProperty.call(message, "deprecated"))
                        writer.uint32(/* id 33, wireType 0 =*/264).bool(message.deprecated);
                    if (message.idempotencyLevel != null && Object.hasOwnProperty.call(message, "idempotencyLevel"))
                        writer.uint32(/* id 34, wireType 0 =*/272).int32(message.idempotencyLevel);
                    if (message.uninterpretedOption != null && message.uninterpretedOption.length)
                        for (var i = 0; i < message.uninterpretedOption.length; ++i)
                            $root.google.protobuf.UninterpretedOption.encode(message.uninterpretedOption[i], writer.uint32(/* id 999, wireType 2 =*/7994).fork()).ldelim();
                    if (message[".google.api.methodSignature"] != null && message[".google.api.methodSignature"].length)
                        for (var i = 0; i < message[".google.api.methodSignature"].length; ++i)
                            writer.uint32(/* id 1051, wireType 2 =*/8410).string(message[".google.api.methodSignature"][i]);
                    if (message[".google.api.http"] != null && Object.hasOwnProperty.call(message, ".google.api.http"))
                        $root.google.api.HttpRule.encode(message[".google.api.http"], writer.uint32(/* id 72295728, wireType 2 =*/578365826).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified MethodOptions message, length delimited. Does not implicitly {@link google.protobuf.MethodOptions.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.MethodOptions
                 * @static
                 * @param {google.protobuf.IMethodOptions} message MethodOptions message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                MethodOptions.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a MethodOptions message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.MethodOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.MethodOptions} MethodOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                MethodOptions.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.MethodOptions();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 33: {
                                message.deprecated = reader.bool();
                                break;
                            }
                        case 34: {
                                message.idempotencyLevel = reader.int32();
                                break;
                            }
                        case 999: {
                                if (!(message.uninterpretedOption && message.uninterpretedOption.length))
                                    message.uninterpretedOption = [];
                                message.uninterpretedOption.push($root.google.protobuf.UninterpretedOption.decode(reader, reader.uint32()));
                                break;
                            }
                        case 72295728: {
                                message[".google.api.http"] = $root.google.api.HttpRule.decode(reader, reader.uint32());
                                break;
                            }
                        case 1051: {
                                if (!(message[".google.api.methodSignature"] && message[".google.api.methodSignature"].length))
                                    message[".google.api.methodSignature"] = [];
                                message[".google.api.methodSignature"].push(reader.string());
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a MethodOptions message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.MethodOptions
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.MethodOptions} MethodOptions
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                MethodOptions.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a MethodOptions message.
                 * @function verify
                 * @memberof google.protobuf.MethodOptions
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                MethodOptions.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        if (typeof message.deprecated !== "boolean")
                            return "deprecated: boolean expected";
                    if (message.idempotencyLevel != null && message.hasOwnProperty("idempotencyLevel"))
                        switch (message.idempotencyLevel) {
                        default:
                            return "idempotencyLevel: enum value expected";
                        case 0:
                        case 1:
                        case 2:
                            break;
                        }
                    if (message.uninterpretedOption != null && message.hasOwnProperty("uninterpretedOption")) {
                        if (!Array.isArray(message.uninterpretedOption))
                            return "uninterpretedOption: array expected";
                        for (var i = 0; i < message.uninterpretedOption.length; ++i) {
                            var error = $root.google.protobuf.UninterpretedOption.verify(message.uninterpretedOption[i]);
                            if (error)
                                return "uninterpretedOption." + error;
                        }
                    }
                    if (message[".google.api.http"] != null && message.hasOwnProperty(".google.api.http")) {
                        var error = $root.google.api.HttpRule.verify(message[".google.api.http"]);
                        if (error)
                            return ".google.api.http." + error;
                    }
                    if (message[".google.api.methodSignature"] != null && message.hasOwnProperty(".google.api.methodSignature")) {
                        if (!Array.isArray(message[".google.api.methodSignature"]))
                            return ".google.api.methodSignature: array expected";
                        for (var i = 0; i < message[".google.api.methodSignature"].length; ++i)
                            if (!$util.isString(message[".google.api.methodSignature"][i]))
                                return ".google.api.methodSignature: string[] expected";
                    }
                    return null;
                };
    
                /**
                 * Creates a MethodOptions message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.MethodOptions
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.MethodOptions} MethodOptions
                 */
                MethodOptions.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.MethodOptions)
                        return object;
                    var message = new $root.google.protobuf.MethodOptions();
                    if (object.deprecated != null)
                        message.deprecated = Boolean(object.deprecated);
                    switch (object.idempotencyLevel) {
                    default:
                        if (typeof object.idempotencyLevel === "number") {
                            message.idempotencyLevel = object.idempotencyLevel;
                            break;
                        }
                        break;
                    case "IDEMPOTENCY_UNKNOWN":
                    case 0:
                        message.idempotencyLevel = 0;
                        break;
                    case "NO_SIDE_EFFECTS":
                    case 1:
                        message.idempotencyLevel = 1;
                        break;
                    case "IDEMPOTENT":
                    case 2:
                        message.idempotencyLevel = 2;
                        break;
                    }
                    if (object.uninterpretedOption) {
                        if (!Array.isArray(object.uninterpretedOption))
                            throw TypeError(".google.protobuf.MethodOptions.uninterpretedOption: array expected");
                        message.uninterpretedOption = [];
                        for (var i = 0; i < object.uninterpretedOption.length; ++i) {
                            if (typeof object.uninterpretedOption[i] !== "object")
                                throw TypeError(".google.protobuf.MethodOptions.uninterpretedOption: object expected");
                            message.uninterpretedOption[i] = $root.google.protobuf.UninterpretedOption.fromObject(object.uninterpretedOption[i]);
                        }
                    }
                    if (object[".google.api.http"] != null) {
                        if (typeof object[".google.api.http"] !== "object")
                            throw TypeError(".google.protobuf.MethodOptions..google.api.http: object expected");
                        message[".google.api.http"] = $root.google.api.HttpRule.fromObject(object[".google.api.http"]);
                    }
                    if (object[".google.api.methodSignature"]) {
                        if (!Array.isArray(object[".google.api.methodSignature"]))
                            throw TypeError(".google.protobuf.MethodOptions..google.api.methodSignature: array expected");
                        message[".google.api.methodSignature"] = [];
                        for (var i = 0; i < object[".google.api.methodSignature"].length; ++i)
                            message[".google.api.methodSignature"][i] = String(object[".google.api.methodSignature"][i]);
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a MethodOptions message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.MethodOptions
                 * @static
                 * @param {google.protobuf.MethodOptions} message MethodOptions
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                MethodOptions.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults) {
                        object.uninterpretedOption = [];
                        object[".google.api.methodSignature"] = [];
                    }
                    if (options.defaults) {
                        object.deprecated = false;
                        object.idempotencyLevel = options.enums === String ? "IDEMPOTENCY_UNKNOWN" : 0;
                        object[".google.api.http"] = null;
                    }
                    if (message.deprecated != null && message.hasOwnProperty("deprecated"))
                        object.deprecated = message.deprecated;
                    if (message.idempotencyLevel != null && message.hasOwnProperty("idempotencyLevel"))
                        object.idempotencyLevel = options.enums === String ? $root.google.protobuf.MethodOptions.IdempotencyLevel[message.idempotencyLevel] === undefined ? message.idempotencyLevel : $root.google.protobuf.MethodOptions.IdempotencyLevel[message.idempotencyLevel] : message.idempotencyLevel;
                    if (message.uninterpretedOption && message.uninterpretedOption.length) {
                        object.uninterpretedOption = [];
                        for (var j = 0; j < message.uninterpretedOption.length; ++j)
                            object.uninterpretedOption[j] = $root.google.protobuf.UninterpretedOption.toObject(message.uninterpretedOption[j], options);
                    }
                    if (message[".google.api.methodSignature"] && message[".google.api.methodSignature"].length) {
                        object[".google.api.methodSignature"] = [];
                        for (var j = 0; j < message[".google.api.methodSignature"].length; ++j)
                            object[".google.api.methodSignature"][j] = message[".google.api.methodSignature"][j];
                    }
                    if (message[".google.api.http"] != null && message.hasOwnProperty(".google.api.http"))
                        object[".google.api.http"] = $root.google.api.HttpRule.toObject(message[".google.api.http"], options);
                    return object;
                };
    
                /**
                 * Converts this MethodOptions to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.MethodOptions
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                MethodOptions.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for MethodOptions
                 * @function getTypeUrl
                 * @memberof google.protobuf.MethodOptions
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                MethodOptions.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.MethodOptions";
                };
    
                /**
                 * IdempotencyLevel enum.
                 * @name google.protobuf.MethodOptions.IdempotencyLevel
                 * @enum {number}
                 * @property {number} IDEMPOTENCY_UNKNOWN=0 IDEMPOTENCY_UNKNOWN value
                 * @property {number} NO_SIDE_EFFECTS=1 NO_SIDE_EFFECTS value
                 * @property {number} IDEMPOTENT=2 IDEMPOTENT value
                 */
                MethodOptions.IdempotencyLevel = (function() {
                    var valuesById = {}, values = Object.create(valuesById);
                    values[valuesById[0] = "IDEMPOTENCY_UNKNOWN"] = 0;
                    values[valuesById[1] = "NO_SIDE_EFFECTS"] = 1;
                    values[valuesById[2] = "IDEMPOTENT"] = 2;
                    return values;
                })();
    
                return MethodOptions;
            })();
    
            protobuf.UninterpretedOption = (function() {
    
                /**
                 * Properties of an UninterpretedOption.
                 * @memberof google.protobuf
                 * @interface IUninterpretedOption
                 * @property {Array.<google.protobuf.UninterpretedOption.INamePart>|null} [name] UninterpretedOption name
                 * @property {string|null} [identifierValue] UninterpretedOption identifierValue
                 * @property {number|Long|null} [positiveIntValue] UninterpretedOption positiveIntValue
                 * @property {number|Long|null} [negativeIntValue] UninterpretedOption negativeIntValue
                 * @property {number|null} [doubleValue] UninterpretedOption doubleValue
                 * @property {Uint8Array|null} [stringValue] UninterpretedOption stringValue
                 * @property {string|null} [aggregateValue] UninterpretedOption aggregateValue
                 */
    
                /**
                 * Constructs a new UninterpretedOption.
                 * @memberof google.protobuf
                 * @classdesc Represents an UninterpretedOption.
                 * @implements IUninterpretedOption
                 * @constructor
                 * @param {google.protobuf.IUninterpretedOption=} [properties] Properties to set
                 */
                function UninterpretedOption(properties) {
                    this.name = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * UninterpretedOption name.
                 * @member {Array.<google.protobuf.UninterpretedOption.INamePart>} name
                 * @memberof google.protobuf.UninterpretedOption
                 * @instance
                 */
                UninterpretedOption.prototype.name = $util.emptyArray;
    
                /**
                 * UninterpretedOption identifierValue.
                 * @member {string} identifierValue
                 * @memberof google.protobuf.UninterpretedOption
                 * @instance
                 */
                UninterpretedOption.prototype.identifierValue = "";
    
                /**
                 * UninterpretedOption positiveIntValue.
                 * @member {number|Long} positiveIntValue
                 * @memberof google.protobuf.UninterpretedOption
                 * @instance
                 */
                UninterpretedOption.prototype.positiveIntValue = $util.Long ? $util.Long.fromBits(0,0,true) : 0;
    
                /**
                 * UninterpretedOption negativeIntValue.
                 * @member {number|Long} negativeIntValue
                 * @memberof google.protobuf.UninterpretedOption
                 * @instance
                 */
                UninterpretedOption.prototype.negativeIntValue = $util.Long ? $util.Long.fromBits(0,0,false) : 0;
    
                /**
                 * UninterpretedOption doubleValue.
                 * @member {number} doubleValue
                 * @memberof google.protobuf.UninterpretedOption
                 * @instance
                 */
                UninterpretedOption.prototype.doubleValue = 0;
    
                /**
                 * UninterpretedOption stringValue.
                 * @member {Uint8Array} stringValue
                 * @memberof google.protobuf.UninterpretedOption
                 * @instance
                 */
                UninterpretedOption.prototype.stringValue = $util.newBuffer([]);
    
                /**
                 * UninterpretedOption aggregateValue.
                 * @member {string} aggregateValue
                 * @memberof google.protobuf.UninterpretedOption
                 * @instance
                 */
                UninterpretedOption.prototype.aggregateValue = "";
    
                /**
                 * Creates a new UninterpretedOption instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.UninterpretedOption
                 * @static
                 * @param {google.protobuf.IUninterpretedOption=} [properties] Properties to set
                 * @returns {google.protobuf.UninterpretedOption} UninterpretedOption instance
                 */
                UninterpretedOption.create = function create(properties) {
                    return new UninterpretedOption(properties);
                };
    
                /**
                 * Encodes the specified UninterpretedOption message. Does not implicitly {@link google.protobuf.UninterpretedOption.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.UninterpretedOption
                 * @static
                 * @param {google.protobuf.IUninterpretedOption} message UninterpretedOption message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                UninterpretedOption.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.name != null && message.name.length)
                        for (var i = 0; i < message.name.length; ++i)
                            $root.google.protobuf.UninterpretedOption.NamePart.encode(message.name[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
                    if (message.identifierValue != null && Object.hasOwnProperty.call(message, "identifierValue"))
                        writer.uint32(/* id 3, wireType 2 =*/26).string(message.identifierValue);
                    if (message.positiveIntValue != null && Object.hasOwnProperty.call(message, "positiveIntValue"))
                        writer.uint32(/* id 4, wireType 0 =*/32).uint64(message.positiveIntValue);
                    if (message.negativeIntValue != null && Object.hasOwnProperty.call(message, "negativeIntValue"))
                        writer.uint32(/* id 5, wireType 0 =*/40).int64(message.negativeIntValue);
                    if (message.doubleValue != null && Object.hasOwnProperty.call(message, "doubleValue"))
                        writer.uint32(/* id 6, wireType 1 =*/49).double(message.doubleValue);
                    if (message.stringValue != null && Object.hasOwnProperty.call(message, "stringValue"))
                        writer.uint32(/* id 7, wireType 2 =*/58).bytes(message.stringValue);
                    if (message.aggregateValue != null && Object.hasOwnProperty.call(message, "aggregateValue"))
                        writer.uint32(/* id 8, wireType 2 =*/66).string(message.aggregateValue);
                    return writer;
                };
    
                /**
                 * Encodes the specified UninterpretedOption message, length delimited. Does not implicitly {@link google.protobuf.UninterpretedOption.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.UninterpretedOption
                 * @static
                 * @param {google.protobuf.IUninterpretedOption} message UninterpretedOption message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                UninterpretedOption.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes an UninterpretedOption message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.UninterpretedOption
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.UninterpretedOption} UninterpretedOption
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                UninterpretedOption.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.UninterpretedOption();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 2: {
                                if (!(message.name && message.name.length))
                                    message.name = [];
                                message.name.push($root.google.protobuf.UninterpretedOption.NamePart.decode(reader, reader.uint32()));
                                break;
                            }
                        case 3: {
                                message.identifierValue = reader.string();
                                break;
                            }
                        case 4: {
                                message.positiveIntValue = reader.uint64();
                                break;
                            }
                        case 5: {
                                message.negativeIntValue = reader.int64();
                                break;
                            }
                        case 6: {
                                message.doubleValue = reader.double();
                                break;
                            }
                        case 7: {
                                message.stringValue = reader.bytes();
                                break;
                            }
                        case 8: {
                                message.aggregateValue = reader.string();
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes an UninterpretedOption message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.UninterpretedOption
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.UninterpretedOption} UninterpretedOption
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                UninterpretedOption.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies an UninterpretedOption message.
                 * @function verify
                 * @memberof google.protobuf.UninterpretedOption
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                UninterpretedOption.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.name != null && message.hasOwnProperty("name")) {
                        if (!Array.isArray(message.name))
                            return "name: array expected";
                        for (var i = 0; i < message.name.length; ++i) {
                            var error = $root.google.protobuf.UninterpretedOption.NamePart.verify(message.name[i]);
                            if (error)
                                return "name." + error;
                        }
                    }
                    if (message.identifierValue != null && message.hasOwnProperty("identifierValue"))
                        if (!$util.isString(message.identifierValue))
                            return "identifierValue: string expected";
                    if (message.positiveIntValue != null && message.hasOwnProperty("positiveIntValue"))
                        if (!$util.isInteger(message.positiveIntValue) && !(message.positiveIntValue && $util.isInteger(message.positiveIntValue.low) && $util.isInteger(message.positiveIntValue.high)))
                            return "positiveIntValue: integer|Long expected";
                    if (message.negativeIntValue != null && message.hasOwnProperty("negativeIntValue"))
                        if (!$util.isInteger(message.negativeIntValue) && !(message.negativeIntValue && $util.isInteger(message.negativeIntValue.low) && $util.isInteger(message.negativeIntValue.high)))
                            return "negativeIntValue: integer|Long expected";
                    if (message.doubleValue != null && message.hasOwnProperty("doubleValue"))
                        if (typeof message.doubleValue !== "number")
                            return "doubleValue: number expected";
                    if (message.stringValue != null && message.hasOwnProperty("stringValue"))
                        if (!(message.stringValue && typeof message.stringValue.length === "number" || $util.isString(message.stringValue)))
                            return "stringValue: buffer expected";
                    if (message.aggregateValue != null && message.hasOwnProperty("aggregateValue"))
                        if (!$util.isString(message.aggregateValue))
                            return "aggregateValue: string expected";
                    return null;
                };
    
                /**
                 * Creates an UninterpretedOption message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.UninterpretedOption
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.UninterpretedOption} UninterpretedOption
                 */
                UninterpretedOption.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.UninterpretedOption)
                        return object;
                    var message = new $root.google.protobuf.UninterpretedOption();
                    if (object.name) {
                        if (!Array.isArray(object.name))
                            throw TypeError(".google.protobuf.UninterpretedOption.name: array expected");
                        message.name = [];
                        for (var i = 0; i < object.name.length; ++i) {
                            if (typeof object.name[i] !== "object")
                                throw TypeError(".google.protobuf.UninterpretedOption.name: object expected");
                            message.name[i] = $root.google.protobuf.UninterpretedOption.NamePart.fromObject(object.name[i]);
                        }
                    }
                    if (object.identifierValue != null)
                        message.identifierValue = String(object.identifierValue);
                    if (object.positiveIntValue != null)
                        if ($util.Long)
                            (message.positiveIntValue = $util.Long.fromValue(object.positiveIntValue)).unsigned = true;
                        else if (typeof object.positiveIntValue === "string")
                            message.positiveIntValue = parseInt(object.positiveIntValue, 10);
                        else if (typeof object.positiveIntValue === "number")
                            message.positiveIntValue = object.positiveIntValue;
                        else if (typeof object.positiveIntValue === "object")
                            message.positiveIntValue = new $util.LongBits(object.positiveIntValue.low >>> 0, object.positiveIntValue.high >>> 0).toNumber(true);
                    if (object.negativeIntValue != null)
                        if ($util.Long)
                            (message.negativeIntValue = $util.Long.fromValue(object.negativeIntValue)).unsigned = false;
                        else if (typeof object.negativeIntValue === "string")
                            message.negativeIntValue = parseInt(object.negativeIntValue, 10);
                        else if (typeof object.negativeIntValue === "number")
                            message.negativeIntValue = object.negativeIntValue;
                        else if (typeof object.negativeIntValue === "object")
                            message.negativeIntValue = new $util.LongBits(object.negativeIntValue.low >>> 0, object.negativeIntValue.high >>> 0).toNumber();
                    if (object.doubleValue != null)
                        message.doubleValue = Number(object.doubleValue);
                    if (object.stringValue != null)
                        if (typeof object.stringValue === "string")
                            $util.base64.decode(object.stringValue, message.stringValue = $util.newBuffer($util.base64.length(object.stringValue)), 0);
                        else if (object.stringValue.length >= 0)
                            message.stringValue = object.stringValue;
                    if (object.aggregateValue != null)
                        message.aggregateValue = String(object.aggregateValue);
                    return message;
                };
    
                /**
                 * Creates a plain object from an UninterpretedOption message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.UninterpretedOption
                 * @static
                 * @param {google.protobuf.UninterpretedOption} message UninterpretedOption
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                UninterpretedOption.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.name = [];
                    if (options.defaults) {
                        object.identifierValue = "";
                        if ($util.Long) {
                            var long = new $util.Long(0, 0, true);
                            object.positiveIntValue = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                        } else
                            object.positiveIntValue = options.longs === String ? "0" : 0;
                        if ($util.Long) {
                            var long = new $util.Long(0, 0, false);
                            object.negativeIntValue = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                        } else
                            object.negativeIntValue = options.longs === String ? "0" : 0;
                        object.doubleValue = 0;
                        if (options.bytes === String)
                            object.stringValue = "";
                        else {
                            object.stringValue = [];
                            if (options.bytes !== Array)
                                object.stringValue = $util.newBuffer(object.stringValue);
                        }
                        object.aggregateValue = "";
                    }
                    if (message.name && message.name.length) {
                        object.name = [];
                        for (var j = 0; j < message.name.length; ++j)
                            object.name[j] = $root.google.protobuf.UninterpretedOption.NamePart.toObject(message.name[j], options);
                    }
                    if (message.identifierValue != null && message.hasOwnProperty("identifierValue"))
                        object.identifierValue = message.identifierValue;
                    if (message.positiveIntValue != null && message.hasOwnProperty("positiveIntValue"))
                        if (typeof message.positiveIntValue === "number")
                            object.positiveIntValue = options.longs === String ? String(message.positiveIntValue) : message.positiveIntValue;
                        else
                            object.positiveIntValue = options.longs === String ? $util.Long.prototype.toString.call(message.positiveIntValue) : options.longs === Number ? new $util.LongBits(message.positiveIntValue.low >>> 0, message.positiveIntValue.high >>> 0).toNumber(true) : message.positiveIntValue;
                    if (message.negativeIntValue != null && message.hasOwnProperty("negativeIntValue"))
                        if (typeof message.negativeIntValue === "number")
                            object.negativeIntValue = options.longs === String ? String(message.negativeIntValue) : message.negativeIntValue;
                        else
                            object.negativeIntValue = options.longs === String ? $util.Long.prototype.toString.call(message.negativeIntValue) : options.longs === Number ? new $util.LongBits(message.negativeIntValue.low >>> 0, message.negativeIntValue.high >>> 0).toNumber() : message.negativeIntValue;
                    if (message.doubleValue != null && message.hasOwnProperty("doubleValue"))
                        object.doubleValue = options.json && !isFinite(message.doubleValue) ? String(message.doubleValue) : message.doubleValue;
                    if (message.stringValue != null && message.hasOwnProperty("stringValue"))
                        object.stringValue = options.bytes === String ? $util.base64.encode(message.stringValue, 0, message.stringValue.length) : options.bytes === Array ? Array.prototype.slice.call(message.stringValue) : message.stringValue;
                    if (message.aggregateValue != null && message.hasOwnProperty("aggregateValue"))
                        object.aggregateValue = message.aggregateValue;
                    return object;
                };
    
                /**
                 * Converts this UninterpretedOption to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.UninterpretedOption
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                UninterpretedOption.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for UninterpretedOption
                 * @function getTypeUrl
                 * @memberof google.protobuf.UninterpretedOption
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                UninterpretedOption.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.UninterpretedOption";
                };
    
                UninterpretedOption.NamePart = (function() {
    
                    /**
                     * Properties of a NamePart.
                     * @memberof google.protobuf.UninterpretedOption
                     * @interface INamePart
                     * @property {string} namePart NamePart namePart
                     * @property {boolean} isExtension NamePart isExtension
                     */
    
                    /**
                     * Constructs a new NamePart.
                     * @memberof google.protobuf.UninterpretedOption
                     * @classdesc Represents a NamePart.
                     * @implements INamePart
                     * @constructor
                     * @param {google.protobuf.UninterpretedOption.INamePart=} [properties] Properties to set
                     */
                    function NamePart(properties) {
                        if (properties)
                            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                if (properties[keys[i]] != null)
                                    this[keys[i]] = properties[keys[i]];
                    }
    
                    /**
                     * NamePart namePart.
                     * @member {string} namePart
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @instance
                     */
                    NamePart.prototype.namePart = "";
    
                    /**
                     * NamePart isExtension.
                     * @member {boolean} isExtension
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @instance
                     */
                    NamePart.prototype.isExtension = false;
    
                    /**
                     * Creates a new NamePart instance using the specified properties.
                     * @function create
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @static
                     * @param {google.protobuf.UninterpretedOption.INamePart=} [properties] Properties to set
                     * @returns {google.protobuf.UninterpretedOption.NamePart} NamePart instance
                     */
                    NamePart.create = function create(properties) {
                        return new NamePart(properties);
                    };
    
                    /**
                     * Encodes the specified NamePart message. Does not implicitly {@link google.protobuf.UninterpretedOption.NamePart.verify|verify} messages.
                     * @function encode
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @static
                     * @param {google.protobuf.UninterpretedOption.INamePart} message NamePart message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    NamePart.encode = function encode(message, writer) {
                        if (!writer)
                            writer = $Writer.create();
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.namePart);
                        writer.uint32(/* id 2, wireType 0 =*/16).bool(message.isExtension);
                        return writer;
                    };
    
                    /**
                     * Encodes the specified NamePart message, length delimited. Does not implicitly {@link google.protobuf.UninterpretedOption.NamePart.verify|verify} messages.
                     * @function encodeDelimited
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @static
                     * @param {google.protobuf.UninterpretedOption.INamePart} message NamePart message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    NamePart.encodeDelimited = function encodeDelimited(message, writer) {
                        return this.encode(message, writer).ldelim();
                    };
    
                    /**
                     * Decodes a NamePart message from the specified reader or buffer.
                     * @function decode
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @param {number} [length] Message length if known beforehand
                     * @returns {google.protobuf.UninterpretedOption.NamePart} NamePart
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    NamePart.decode = function decode(reader, length) {
                        if (!(reader instanceof $Reader))
                            reader = $Reader.create(reader);
                        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.UninterpretedOption.NamePart();
                        while (reader.pos < end) {
                            var tag = reader.uint32();
                            switch (tag >>> 3) {
                            case 1: {
                                    message.namePart = reader.string();
                                    break;
                                }
                            case 2: {
                                    message.isExtension = reader.bool();
                                    break;
                                }
                            default:
                                reader.skipType(tag & 7);
                                break;
                            }
                        }
                        if (!message.hasOwnProperty("namePart"))
                            throw $util.ProtocolError("missing required 'namePart'", { instance: message });
                        if (!message.hasOwnProperty("isExtension"))
                            throw $util.ProtocolError("missing required 'isExtension'", { instance: message });
                        return message;
                    };
    
                    /**
                     * Decodes a NamePart message from the specified reader or buffer, length delimited.
                     * @function decodeDelimited
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @returns {google.protobuf.UninterpretedOption.NamePart} NamePart
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    NamePart.decodeDelimited = function decodeDelimited(reader) {
                        if (!(reader instanceof $Reader))
                            reader = new $Reader(reader);
                        return this.decode(reader, reader.uint32());
                    };
    
                    /**
                     * Verifies a NamePart message.
                     * @function verify
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @static
                     * @param {Object.<string,*>} message Plain object to verify
                     * @returns {string|null} `null` if valid, otherwise the reason why it is not
                     */
                    NamePart.verify = function verify(message) {
                        if (typeof message !== "object" || message === null)
                            return "object expected";
                        if (!$util.isString(message.namePart))
                            return "namePart: string expected";
                        if (typeof message.isExtension !== "boolean")
                            return "isExtension: boolean expected";
                        return null;
                    };
    
                    /**
                     * Creates a NamePart message from a plain object. Also converts values to their respective internal types.
                     * @function fromObject
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @static
                     * @param {Object.<string,*>} object Plain object
                     * @returns {google.protobuf.UninterpretedOption.NamePart} NamePart
                     */
                    NamePart.fromObject = function fromObject(object) {
                        if (object instanceof $root.google.protobuf.UninterpretedOption.NamePart)
                            return object;
                        var message = new $root.google.protobuf.UninterpretedOption.NamePart();
                        if (object.namePart != null)
                            message.namePart = String(object.namePart);
                        if (object.isExtension != null)
                            message.isExtension = Boolean(object.isExtension);
                        return message;
                    };
    
                    /**
                     * Creates a plain object from a NamePart message. Also converts values to other types if specified.
                     * @function toObject
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @static
                     * @param {google.protobuf.UninterpretedOption.NamePart} message NamePart
                     * @param {$protobuf.IConversionOptions} [options] Conversion options
                     * @returns {Object.<string,*>} Plain object
                     */
                    NamePart.toObject = function toObject(message, options) {
                        if (!options)
                            options = {};
                        var object = {};
                        if (options.defaults) {
                            object.namePart = "";
                            object.isExtension = false;
                        }
                        if (message.namePart != null && message.hasOwnProperty("namePart"))
                            object.namePart = message.namePart;
                        if (message.isExtension != null && message.hasOwnProperty("isExtension"))
                            object.isExtension = message.isExtension;
                        return object;
                    };
    
                    /**
                     * Converts this NamePart to JSON.
                     * @function toJSON
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @instance
                     * @returns {Object.<string,*>} JSON object
                     */
                    NamePart.prototype.toJSON = function toJSON() {
                        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                    };
    
                    /**
                     * Gets the default type url for NamePart
                     * @function getTypeUrl
                     * @memberof google.protobuf.UninterpretedOption.NamePart
                     * @static
                     * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                     * @returns {string} The default type url
                     */
                    NamePart.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                        if (typeUrlPrefix === undefined) {
                            typeUrlPrefix = "type.googleapis.com";
                        }
                        return typeUrlPrefix + "/google.protobuf.UninterpretedOption.NamePart";
                    };
    
                    return NamePart;
                })();
    
                return UninterpretedOption;
            })();
    
            protobuf.SourceCodeInfo = (function() {
    
                /**
                 * Properties of a SourceCodeInfo.
                 * @memberof google.protobuf
                 * @interface ISourceCodeInfo
                 * @property {Array.<google.protobuf.SourceCodeInfo.ILocation>|null} [location] SourceCodeInfo location
                 */
    
                /**
                 * Constructs a new SourceCodeInfo.
                 * @memberof google.protobuf
                 * @classdesc Represents a SourceCodeInfo.
                 * @implements ISourceCodeInfo
                 * @constructor
                 * @param {google.protobuf.ISourceCodeInfo=} [properties] Properties to set
                 */
                function SourceCodeInfo(properties) {
                    this.location = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * SourceCodeInfo location.
                 * @member {Array.<google.protobuf.SourceCodeInfo.ILocation>} location
                 * @memberof google.protobuf.SourceCodeInfo
                 * @instance
                 */
                SourceCodeInfo.prototype.location = $util.emptyArray;
    
                /**
                 * Creates a new SourceCodeInfo instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.SourceCodeInfo
                 * @static
                 * @param {google.protobuf.ISourceCodeInfo=} [properties] Properties to set
                 * @returns {google.protobuf.SourceCodeInfo} SourceCodeInfo instance
                 */
                SourceCodeInfo.create = function create(properties) {
                    return new SourceCodeInfo(properties);
                };
    
                /**
                 * Encodes the specified SourceCodeInfo message. Does not implicitly {@link google.protobuf.SourceCodeInfo.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.SourceCodeInfo
                 * @static
                 * @param {google.protobuf.ISourceCodeInfo} message SourceCodeInfo message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                SourceCodeInfo.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.location != null && message.location.length)
                        for (var i = 0; i < message.location.length; ++i)
                            $root.google.protobuf.SourceCodeInfo.Location.encode(message.location[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified SourceCodeInfo message, length delimited. Does not implicitly {@link google.protobuf.SourceCodeInfo.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.SourceCodeInfo
                 * @static
                 * @param {google.protobuf.ISourceCodeInfo} message SourceCodeInfo message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                SourceCodeInfo.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a SourceCodeInfo message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.SourceCodeInfo
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.SourceCodeInfo} SourceCodeInfo
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                SourceCodeInfo.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.SourceCodeInfo();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                if (!(message.location && message.location.length))
                                    message.location = [];
                                message.location.push($root.google.protobuf.SourceCodeInfo.Location.decode(reader, reader.uint32()));
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a SourceCodeInfo message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.SourceCodeInfo
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.SourceCodeInfo} SourceCodeInfo
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                SourceCodeInfo.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a SourceCodeInfo message.
                 * @function verify
                 * @memberof google.protobuf.SourceCodeInfo
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                SourceCodeInfo.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.location != null && message.hasOwnProperty("location")) {
                        if (!Array.isArray(message.location))
                            return "location: array expected";
                        for (var i = 0; i < message.location.length; ++i) {
                            var error = $root.google.protobuf.SourceCodeInfo.Location.verify(message.location[i]);
                            if (error)
                                return "location." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates a SourceCodeInfo message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.SourceCodeInfo
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.SourceCodeInfo} SourceCodeInfo
                 */
                SourceCodeInfo.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.SourceCodeInfo)
                        return object;
                    var message = new $root.google.protobuf.SourceCodeInfo();
                    if (object.location) {
                        if (!Array.isArray(object.location))
                            throw TypeError(".google.protobuf.SourceCodeInfo.location: array expected");
                        message.location = [];
                        for (var i = 0; i < object.location.length; ++i) {
                            if (typeof object.location[i] !== "object")
                                throw TypeError(".google.protobuf.SourceCodeInfo.location: object expected");
                            message.location[i] = $root.google.protobuf.SourceCodeInfo.Location.fromObject(object.location[i]);
                        }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a SourceCodeInfo message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.SourceCodeInfo
                 * @static
                 * @param {google.protobuf.SourceCodeInfo} message SourceCodeInfo
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                SourceCodeInfo.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.location = [];
                    if (message.location && message.location.length) {
                        object.location = [];
                        for (var j = 0; j < message.location.length; ++j)
                            object.location[j] = $root.google.protobuf.SourceCodeInfo.Location.toObject(message.location[j], options);
                    }
                    return object;
                };
    
                /**
                 * Converts this SourceCodeInfo to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.SourceCodeInfo
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                SourceCodeInfo.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for SourceCodeInfo
                 * @function getTypeUrl
                 * @memberof google.protobuf.SourceCodeInfo
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                SourceCodeInfo.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.SourceCodeInfo";
                };
    
                SourceCodeInfo.Location = (function() {
    
                    /**
                     * Properties of a Location.
                     * @memberof google.protobuf.SourceCodeInfo
                     * @interface ILocation
                     * @property {Array.<number>|null} [path] Location path
                     * @property {Array.<number>|null} [span] Location span
                     * @property {string|null} [leadingComments] Location leadingComments
                     * @property {string|null} [trailingComments] Location trailingComments
                     * @property {Array.<string>|null} [leadingDetachedComments] Location leadingDetachedComments
                     */
    
                    /**
                     * Constructs a new Location.
                     * @memberof google.protobuf.SourceCodeInfo
                     * @classdesc Represents a Location.
                     * @implements ILocation
                     * @constructor
                     * @param {google.protobuf.SourceCodeInfo.ILocation=} [properties] Properties to set
                     */
                    function Location(properties) {
                        this.path = [];
                        this.span = [];
                        this.leadingDetachedComments = [];
                        if (properties)
                            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                if (properties[keys[i]] != null)
                                    this[keys[i]] = properties[keys[i]];
                    }
    
                    /**
                     * Location path.
                     * @member {Array.<number>} path
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @instance
                     */
                    Location.prototype.path = $util.emptyArray;
    
                    /**
                     * Location span.
                     * @member {Array.<number>} span
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @instance
                     */
                    Location.prototype.span = $util.emptyArray;
    
                    /**
                     * Location leadingComments.
                     * @member {string} leadingComments
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @instance
                     */
                    Location.prototype.leadingComments = "";
    
                    /**
                     * Location trailingComments.
                     * @member {string} trailingComments
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @instance
                     */
                    Location.prototype.trailingComments = "";
    
                    /**
                     * Location leadingDetachedComments.
                     * @member {Array.<string>} leadingDetachedComments
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @instance
                     */
                    Location.prototype.leadingDetachedComments = $util.emptyArray;
    
                    /**
                     * Creates a new Location instance using the specified properties.
                     * @function create
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @static
                     * @param {google.protobuf.SourceCodeInfo.ILocation=} [properties] Properties to set
                     * @returns {google.protobuf.SourceCodeInfo.Location} Location instance
                     */
                    Location.create = function create(properties) {
                        return new Location(properties);
                    };
    
                    /**
                     * Encodes the specified Location message. Does not implicitly {@link google.protobuf.SourceCodeInfo.Location.verify|verify} messages.
                     * @function encode
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @static
                     * @param {google.protobuf.SourceCodeInfo.ILocation} message Location message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    Location.encode = function encode(message, writer) {
                        if (!writer)
                            writer = $Writer.create();
                        if (message.path != null && message.path.length) {
                            writer.uint32(/* id 1, wireType 2 =*/10).fork();
                            for (var i = 0; i < message.path.length; ++i)
                                writer.int32(message.path[i]);
                            writer.ldelim();
                        }
                        if (message.span != null && message.span.length) {
                            writer.uint32(/* id 2, wireType 2 =*/18).fork();
                            for (var i = 0; i < message.span.length; ++i)
                                writer.int32(message.span[i]);
                            writer.ldelim();
                        }
                        if (message.leadingComments != null && Object.hasOwnProperty.call(message, "leadingComments"))
                            writer.uint32(/* id 3, wireType 2 =*/26).string(message.leadingComments);
                        if (message.trailingComments != null && Object.hasOwnProperty.call(message, "trailingComments"))
                            writer.uint32(/* id 4, wireType 2 =*/34).string(message.trailingComments);
                        if (message.leadingDetachedComments != null && message.leadingDetachedComments.length)
                            for (var i = 0; i < message.leadingDetachedComments.length; ++i)
                                writer.uint32(/* id 6, wireType 2 =*/50).string(message.leadingDetachedComments[i]);
                        return writer;
                    };
    
                    /**
                     * Encodes the specified Location message, length delimited. Does not implicitly {@link google.protobuf.SourceCodeInfo.Location.verify|verify} messages.
                     * @function encodeDelimited
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @static
                     * @param {google.protobuf.SourceCodeInfo.ILocation} message Location message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    Location.encodeDelimited = function encodeDelimited(message, writer) {
                        return this.encode(message, writer).ldelim();
                    };
    
                    /**
                     * Decodes a Location message from the specified reader or buffer.
                     * @function decode
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @param {number} [length] Message length if known beforehand
                     * @returns {google.protobuf.SourceCodeInfo.Location} Location
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    Location.decode = function decode(reader, length) {
                        if (!(reader instanceof $Reader))
                            reader = $Reader.create(reader);
                        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.SourceCodeInfo.Location();
                        while (reader.pos < end) {
                            var tag = reader.uint32();
                            switch (tag >>> 3) {
                            case 1: {
                                    if (!(message.path && message.path.length))
                                        message.path = [];
                                    if ((tag & 7) === 2) {
                                        var end2 = reader.uint32() + reader.pos;
                                        while (reader.pos < end2)
                                            message.path.push(reader.int32());
                                    } else
                                        message.path.push(reader.int32());
                                    break;
                                }
                            case 2: {
                                    if (!(message.span && message.span.length))
                                        message.span = [];
                                    if ((tag & 7) === 2) {
                                        var end2 = reader.uint32() + reader.pos;
                                        while (reader.pos < end2)
                                            message.span.push(reader.int32());
                                    } else
                                        message.span.push(reader.int32());
                                    break;
                                }
                            case 3: {
                                    message.leadingComments = reader.string();
                                    break;
                                }
                            case 4: {
                                    message.trailingComments = reader.string();
                                    break;
                                }
                            case 6: {
                                    if (!(message.leadingDetachedComments && message.leadingDetachedComments.length))
                                        message.leadingDetachedComments = [];
                                    message.leadingDetachedComments.push(reader.string());
                                    break;
                                }
                            default:
                                reader.skipType(tag & 7);
                                break;
                            }
                        }
                        return message;
                    };
    
                    /**
                     * Decodes a Location message from the specified reader or buffer, length delimited.
                     * @function decodeDelimited
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @returns {google.protobuf.SourceCodeInfo.Location} Location
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    Location.decodeDelimited = function decodeDelimited(reader) {
                        if (!(reader instanceof $Reader))
                            reader = new $Reader(reader);
                        return this.decode(reader, reader.uint32());
                    };
    
                    /**
                     * Verifies a Location message.
                     * @function verify
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @static
                     * @param {Object.<string,*>} message Plain object to verify
                     * @returns {string|null} `null` if valid, otherwise the reason why it is not
                     */
                    Location.verify = function verify(message) {
                        if (typeof message !== "object" || message === null)
                            return "object expected";
                        if (message.path != null && message.hasOwnProperty("path")) {
                            if (!Array.isArray(message.path))
                                return "path: array expected";
                            for (var i = 0; i < message.path.length; ++i)
                                if (!$util.isInteger(message.path[i]))
                                    return "path: integer[] expected";
                        }
                        if (message.span != null && message.hasOwnProperty("span")) {
                            if (!Array.isArray(message.span))
                                return "span: array expected";
                            for (var i = 0; i < message.span.length; ++i)
                                if (!$util.isInteger(message.span[i]))
                                    return "span: integer[] expected";
                        }
                        if (message.leadingComments != null && message.hasOwnProperty("leadingComments"))
                            if (!$util.isString(message.leadingComments))
                                return "leadingComments: string expected";
                        if (message.trailingComments != null && message.hasOwnProperty("trailingComments"))
                            if (!$util.isString(message.trailingComments))
                                return "trailingComments: string expected";
                        if (message.leadingDetachedComments != null && message.hasOwnProperty("leadingDetachedComments")) {
                            if (!Array.isArray(message.leadingDetachedComments))
                                return "leadingDetachedComments: array expected";
                            for (var i = 0; i < message.leadingDetachedComments.length; ++i)
                                if (!$util.isString(message.leadingDetachedComments[i]))
                                    return "leadingDetachedComments: string[] expected";
                        }
                        return null;
                    };
    
                    /**
                     * Creates a Location message from a plain object. Also converts values to their respective internal types.
                     * @function fromObject
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @static
                     * @param {Object.<string,*>} object Plain object
                     * @returns {google.protobuf.SourceCodeInfo.Location} Location
                     */
                    Location.fromObject = function fromObject(object) {
                        if (object instanceof $root.google.protobuf.SourceCodeInfo.Location)
                            return object;
                        var message = new $root.google.protobuf.SourceCodeInfo.Location();
                        if (object.path) {
                            if (!Array.isArray(object.path))
                                throw TypeError(".google.protobuf.SourceCodeInfo.Location.path: array expected");
                            message.path = [];
                            for (var i = 0; i < object.path.length; ++i)
                                message.path[i] = object.path[i] | 0;
                        }
                        if (object.span) {
                            if (!Array.isArray(object.span))
                                throw TypeError(".google.protobuf.SourceCodeInfo.Location.span: array expected");
                            message.span = [];
                            for (var i = 0; i < object.span.length; ++i)
                                message.span[i] = object.span[i] | 0;
                        }
                        if (object.leadingComments != null)
                            message.leadingComments = String(object.leadingComments);
                        if (object.trailingComments != null)
                            message.trailingComments = String(object.trailingComments);
                        if (object.leadingDetachedComments) {
                            if (!Array.isArray(object.leadingDetachedComments))
                                throw TypeError(".google.protobuf.SourceCodeInfo.Location.leadingDetachedComments: array expected");
                            message.leadingDetachedComments = [];
                            for (var i = 0; i < object.leadingDetachedComments.length; ++i)
                                message.leadingDetachedComments[i] = String(object.leadingDetachedComments[i]);
                        }
                        return message;
                    };
    
                    /**
                     * Creates a plain object from a Location message. Also converts values to other types if specified.
                     * @function toObject
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @static
                     * @param {google.protobuf.SourceCodeInfo.Location} message Location
                     * @param {$protobuf.IConversionOptions} [options] Conversion options
                     * @returns {Object.<string,*>} Plain object
                     */
                    Location.toObject = function toObject(message, options) {
                        if (!options)
                            options = {};
                        var object = {};
                        if (options.arrays || options.defaults) {
                            object.path = [];
                            object.span = [];
                            object.leadingDetachedComments = [];
                        }
                        if (options.defaults) {
                            object.leadingComments = "";
                            object.trailingComments = "";
                        }
                        if (message.path && message.path.length) {
                            object.path = [];
                            for (var j = 0; j < message.path.length; ++j)
                                object.path[j] = message.path[j];
                        }
                        if (message.span && message.span.length) {
                            object.span = [];
                            for (var j = 0; j < message.span.length; ++j)
                                object.span[j] = message.span[j];
                        }
                        if (message.leadingComments != null && message.hasOwnProperty("leadingComments"))
                            object.leadingComments = message.leadingComments;
                        if (message.trailingComments != null && message.hasOwnProperty("trailingComments"))
                            object.trailingComments = message.trailingComments;
                        if (message.leadingDetachedComments && message.leadingDetachedComments.length) {
                            object.leadingDetachedComments = [];
                            for (var j = 0; j < message.leadingDetachedComments.length; ++j)
                                object.leadingDetachedComments[j] = message.leadingDetachedComments[j];
                        }
                        return object;
                    };
    
                    /**
                     * Converts this Location to JSON.
                     * @function toJSON
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @instance
                     * @returns {Object.<string,*>} JSON object
                     */
                    Location.prototype.toJSON = function toJSON() {
                        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                    };
    
                    /**
                     * Gets the default type url for Location
                     * @function getTypeUrl
                     * @memberof google.protobuf.SourceCodeInfo.Location
                     * @static
                     * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                     * @returns {string} The default type url
                     */
                    Location.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                        if (typeUrlPrefix === undefined) {
                            typeUrlPrefix = "type.googleapis.com";
                        }
                        return typeUrlPrefix + "/google.protobuf.SourceCodeInfo.Location";
                    };
    
                    return Location;
                })();
    
                return SourceCodeInfo;
            })();
    
            protobuf.GeneratedCodeInfo = (function() {
    
                /**
                 * Properties of a GeneratedCodeInfo.
                 * @memberof google.protobuf
                 * @interface IGeneratedCodeInfo
                 * @property {Array.<google.protobuf.GeneratedCodeInfo.IAnnotation>|null} [annotation] GeneratedCodeInfo annotation
                 */
    
                /**
                 * Constructs a new GeneratedCodeInfo.
                 * @memberof google.protobuf
                 * @classdesc Represents a GeneratedCodeInfo.
                 * @implements IGeneratedCodeInfo
                 * @constructor
                 * @param {google.protobuf.IGeneratedCodeInfo=} [properties] Properties to set
                 */
                function GeneratedCodeInfo(properties) {
                    this.annotation = [];
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }
    
                /**
                 * GeneratedCodeInfo annotation.
                 * @member {Array.<google.protobuf.GeneratedCodeInfo.IAnnotation>} annotation
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @instance
                 */
                GeneratedCodeInfo.prototype.annotation = $util.emptyArray;
    
                /**
                 * Creates a new GeneratedCodeInfo instance using the specified properties.
                 * @function create
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @static
                 * @param {google.protobuf.IGeneratedCodeInfo=} [properties] Properties to set
                 * @returns {google.protobuf.GeneratedCodeInfo} GeneratedCodeInfo instance
                 */
                GeneratedCodeInfo.create = function create(properties) {
                    return new GeneratedCodeInfo(properties);
                };
    
                /**
                 * Encodes the specified GeneratedCodeInfo message. Does not implicitly {@link google.protobuf.GeneratedCodeInfo.verify|verify} messages.
                 * @function encode
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @static
                 * @param {google.protobuf.IGeneratedCodeInfo} message GeneratedCodeInfo message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                GeneratedCodeInfo.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.annotation != null && message.annotation.length)
                        for (var i = 0; i < message.annotation.length; ++i)
                            $root.google.protobuf.GeneratedCodeInfo.Annotation.encode(message.annotation[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                    return writer;
                };
    
                /**
                 * Encodes the specified GeneratedCodeInfo message, length delimited. Does not implicitly {@link google.protobuf.GeneratedCodeInfo.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @static
                 * @param {google.protobuf.IGeneratedCodeInfo} message GeneratedCodeInfo message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                GeneratedCodeInfo.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };
    
                /**
                 * Decodes a GeneratedCodeInfo message from the specified reader or buffer.
                 * @function decode
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {google.protobuf.GeneratedCodeInfo} GeneratedCodeInfo
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                GeneratedCodeInfo.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.GeneratedCodeInfo();
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1: {
                                if (!(message.annotation && message.annotation.length))
                                    message.annotation = [];
                                message.annotation.push($root.google.protobuf.GeneratedCodeInfo.Annotation.decode(reader, reader.uint32()));
                                break;
                            }
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };
    
                /**
                 * Decodes a GeneratedCodeInfo message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {google.protobuf.GeneratedCodeInfo} GeneratedCodeInfo
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                GeneratedCodeInfo.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };
    
                /**
                 * Verifies a GeneratedCodeInfo message.
                 * @function verify
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                GeneratedCodeInfo.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.annotation != null && message.hasOwnProperty("annotation")) {
                        if (!Array.isArray(message.annotation))
                            return "annotation: array expected";
                        for (var i = 0; i < message.annotation.length; ++i) {
                            var error = $root.google.protobuf.GeneratedCodeInfo.Annotation.verify(message.annotation[i]);
                            if (error)
                                return "annotation." + error;
                        }
                    }
                    return null;
                };
    
                /**
                 * Creates a GeneratedCodeInfo message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {google.protobuf.GeneratedCodeInfo} GeneratedCodeInfo
                 */
                GeneratedCodeInfo.fromObject = function fromObject(object) {
                    if (object instanceof $root.google.protobuf.GeneratedCodeInfo)
                        return object;
                    var message = new $root.google.protobuf.GeneratedCodeInfo();
                    if (object.annotation) {
                        if (!Array.isArray(object.annotation))
                            throw TypeError(".google.protobuf.GeneratedCodeInfo.annotation: array expected");
                        message.annotation = [];
                        for (var i = 0; i < object.annotation.length; ++i) {
                            if (typeof object.annotation[i] !== "object")
                                throw TypeError(".google.protobuf.GeneratedCodeInfo.annotation: object expected");
                            message.annotation[i] = $root.google.protobuf.GeneratedCodeInfo.Annotation.fromObject(object.annotation[i]);
                        }
                    }
                    return message;
                };
    
                /**
                 * Creates a plain object from a GeneratedCodeInfo message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @static
                 * @param {google.protobuf.GeneratedCodeInfo} message GeneratedCodeInfo
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                GeneratedCodeInfo.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.annotation = [];
                    if (message.annotation && message.annotation.length) {
                        object.annotation = [];
                        for (var j = 0; j < message.annotation.length; ++j)
                            object.annotation[j] = $root.google.protobuf.GeneratedCodeInfo.Annotation.toObject(message.annotation[j], options);
                    }
                    return object;
                };
    
                /**
                 * Converts this GeneratedCodeInfo to JSON.
                 * @function toJSON
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                GeneratedCodeInfo.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };
    
                /**
                 * Gets the default type url for GeneratedCodeInfo
                 * @function getTypeUrl
                 * @memberof google.protobuf.GeneratedCodeInfo
                 * @static
                 * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                 * @returns {string} The default type url
                 */
                GeneratedCodeInfo.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                    if (typeUrlPrefix === undefined) {
                        typeUrlPrefix = "type.googleapis.com";
                    }
                    return typeUrlPrefix + "/google.protobuf.GeneratedCodeInfo";
                };
    
                GeneratedCodeInfo.Annotation = (function() {
    
                    /**
                     * Properties of an Annotation.
                     * @memberof google.protobuf.GeneratedCodeInfo
                     * @interface IAnnotation
                     * @property {Array.<number>|null} [path] Annotation path
                     * @property {string|null} [sourceFile] Annotation sourceFile
                     * @property {number|null} [begin] Annotation begin
                     * @property {number|null} [end] Annotation end
                     * @property {google.protobuf.GeneratedCodeInfo.Annotation.Semantic|null} [semantic] Annotation semantic
                     */
    
                    /**
                     * Constructs a new Annotation.
                     * @memberof google.protobuf.GeneratedCodeInfo
                     * @classdesc Represents an Annotation.
                     * @implements IAnnotation
                     * @constructor
                     * @param {google.protobuf.GeneratedCodeInfo.IAnnotation=} [properties] Properties to set
                     */
                    function Annotation(properties) {
                        this.path = [];
                        if (properties)
                            for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                                if (properties[keys[i]] != null)
                                    this[keys[i]] = properties[keys[i]];
                    }
    
                    /**
                     * Annotation path.
                     * @member {Array.<number>} path
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @instance
                     */
                    Annotation.prototype.path = $util.emptyArray;
    
                    /**
                     * Annotation sourceFile.
                     * @member {string} sourceFile
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @instance
                     */
                    Annotation.prototype.sourceFile = "";
    
                    /**
                     * Annotation begin.
                     * @member {number} begin
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @instance
                     */
                    Annotation.prototype.begin = 0;
    
                    /**
                     * Annotation end.
                     * @member {number} end
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @instance
                     */
                    Annotation.prototype.end = 0;
    
                    /**
                     * Annotation semantic.
                     * @member {google.protobuf.GeneratedCodeInfo.Annotation.Semantic} semantic
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @instance
                     */
                    Annotation.prototype.semantic = 0;
    
                    /**
                     * Creates a new Annotation instance using the specified properties.
                     * @function create
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @static
                     * @param {google.protobuf.GeneratedCodeInfo.IAnnotation=} [properties] Properties to set
                     * @returns {google.protobuf.GeneratedCodeInfo.Annotation} Annotation instance
                     */
                    Annotation.create = function create(properties) {
                        return new Annotation(properties);
                    };
    
                    /**
                     * Encodes the specified Annotation message. Does not implicitly {@link google.protobuf.GeneratedCodeInfo.Annotation.verify|verify} messages.
                     * @function encode
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @static
                     * @param {google.protobuf.GeneratedCodeInfo.IAnnotation} message Annotation message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    Annotation.encode = function encode(message, writer) {
                        if (!writer)
                            writer = $Writer.create();
                        if (message.path != null && message.path.length) {
                            writer.uint32(/* id 1, wireType 2 =*/10).fork();
                            for (var i = 0; i < message.path.length; ++i)
                                writer.int32(message.path[i]);
                            writer.ldelim();
                        }
                        if (message.sourceFile != null && Object.hasOwnProperty.call(message, "sourceFile"))
                            writer.uint32(/* id 2, wireType 2 =*/18).string(message.sourceFile);
                        if (message.begin != null && Object.hasOwnProperty.call(message, "begin"))
                            writer.uint32(/* id 3, wireType 0 =*/24).int32(message.begin);
                        if (message.end != null && Object.hasOwnProperty.call(message, "end"))
                            writer.uint32(/* id 4, wireType 0 =*/32).int32(message.end);
                        if (message.semantic != null && Object.hasOwnProperty.call(message, "semantic"))
                            writer.uint32(/* id 5, wireType 0 =*/40).int32(message.semantic);
                        return writer;
                    };
    
                    /**
                     * Encodes the specified Annotation message, length delimited. Does not implicitly {@link google.protobuf.GeneratedCodeInfo.Annotation.verify|verify} messages.
                     * @function encodeDelimited
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @static
                     * @param {google.protobuf.GeneratedCodeInfo.IAnnotation} message Annotation message or plain object to encode
                     * @param {$protobuf.Writer} [writer] Writer to encode to
                     * @returns {$protobuf.Writer} Writer
                     */
                    Annotation.encodeDelimited = function encodeDelimited(message, writer) {
                        return this.encode(message, writer).ldelim();
                    };
    
                    /**
                     * Decodes an Annotation message from the specified reader or buffer.
                     * @function decode
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @param {number} [length] Message length if known beforehand
                     * @returns {google.protobuf.GeneratedCodeInfo.Annotation} Annotation
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    Annotation.decode = function decode(reader, length) {
                        if (!(reader instanceof $Reader))
                            reader = $Reader.create(reader);
                        var end = length === undefined ? reader.len : reader.pos + length, message = new $root.google.protobuf.GeneratedCodeInfo.Annotation();
                        while (reader.pos < end) {
                            var tag = reader.uint32();
                            switch (tag >>> 3) {
                            case 1: {
                                    if (!(message.path && message.path.length))
                                        message.path = [];
                                    if ((tag & 7) === 2) {
                                        var end2 = reader.uint32() + reader.pos;
                                        while (reader.pos < end2)
                                            message.path.push(reader.int32());
                                    } else
                                        message.path.push(reader.int32());
                                    break;
                                }
                            case 2: {
                                    message.sourceFile = reader.string();
                                    break;
                                }
                            case 3: {
                                    message.begin = reader.int32();
                                    break;
                                }
                            case 4: {
                                    message.end = reader.int32();
                                    break;
                                }
                            case 5: {
                                    message.semantic = reader.int32();
                                    break;
                                }
                            default:
                                reader.skipType(tag & 7);
                                break;
                            }
                        }
                        return message;
                    };
    
                    /**
                     * Decodes an Annotation message from the specified reader or buffer, length delimited.
                     * @function decodeDelimited
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @static
                     * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                     * @returns {google.protobuf.GeneratedCodeInfo.Annotation} Annotation
                     * @throws {Error} If the payload is not a reader or valid buffer
                     * @throws {$protobuf.util.ProtocolError} If required fields are missing
                     */
                    Annotation.decodeDelimited = function decodeDelimited(reader) {
                        if (!(reader instanceof $Reader))
                            reader = new $Reader(reader);
                        return this.decode(reader, reader.uint32());
                    };
    
                    /**
                     * Verifies an Annotation message.
                     * @function verify
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @static
                     * @param {Object.<string,*>} message Plain object to verify
                     * @returns {string|null} `null` if valid, otherwise the reason why it is not
                     */
                    Annotation.verify = function verify(message) {
                        if (typeof message !== "object" || message === null)
                            return "object expected";
                        if (message.path != null && message.hasOwnProperty("path")) {
                            if (!Array.isArray(message.path))
                                return "path: array expected";
                            for (var i = 0; i < message.path.length; ++i)
                                if (!$util.isInteger(message.path[i]))
                                    return "path: integer[] expected";
                        }
                        if (message.sourceFile != null && message.hasOwnProperty("sourceFile"))
                            if (!$util.isString(message.sourceFile))
                                return "sourceFile: string expected";
                        if (message.begin != null && message.hasOwnProperty("begin"))
                            if (!$util.isInteger(message.begin))
                                return "begin: integer expected";
                        if (message.end != null && message.hasOwnProperty("end"))
                            if (!$util.isInteger(message.end))
                                return "end: integer expected";
                        if (message.semantic != null && message.hasOwnProperty("semantic"))
                            switch (message.semantic) {
                            default:
                                return "semantic: enum value expected";
                            case 0:
                            case 1:
                            case 2:
                                break;
                            }
                        return null;
                    };
    
                    /**
                     * Creates an Annotation message from a plain object. Also converts values to their respective internal types.
                     * @function fromObject
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @static
                     * @param {Object.<string,*>} object Plain object
                     * @returns {google.protobuf.GeneratedCodeInfo.Annotation} Annotation
                     */
                    Annotation.fromObject = function fromObject(object) {
                        if (object instanceof $root.google.protobuf.GeneratedCodeInfo.Annotation)
                            return object;
                        var message = new $root.google.protobuf.GeneratedCodeInfo.Annotation();
                        if (object.path) {
                            if (!Array.isArray(object.path))
                                throw TypeError(".google.protobuf.GeneratedCodeInfo.Annotation.path: array expected");
                            message.path = [];
                            for (var i = 0; i < object.path.length; ++i)
                                message.path[i] = object.path[i] | 0;
                        }
                        if (object.sourceFile != null)
                            message.sourceFile = String(object.sourceFile);
                        if (object.begin != null)
                            message.begin = object.begin | 0;
                        if (object.end != null)
                            message.end = object.end | 0;
                        switch (object.semantic) {
                        default:
                            if (typeof object.semantic === "number") {
                                message.semantic = object.semantic;
                                break;
                            }
                            break;
                        case "NONE":
                        case 0:
                            message.semantic = 0;
                            break;
                        case "SET":
                        case 1:
                            message.semantic = 1;
                            break;
                        case "ALIAS":
                        case 2:
                            message.semantic = 2;
                            break;
                        }
                        return message;
                    };
    
                    /**
                     * Creates a plain object from an Annotation message. Also converts values to other types if specified.
                     * @function toObject
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @static
                     * @param {google.protobuf.GeneratedCodeInfo.Annotation} message Annotation
                     * @param {$protobuf.IConversionOptions} [options] Conversion options
                     * @returns {Object.<string,*>} Plain object
                     */
                    Annotation.toObject = function toObject(message, options) {
                        if (!options)
                            options = {};
                        var object = {};
                        if (options.arrays || options.defaults)
                            object.path = [];
                        if (options.defaults) {
                            object.sourceFile = "";
                            object.begin = 0;
                            object.end = 0;
                            object.semantic = options.enums === String ? "NONE" : 0;
                        }
                        if (message.path && message.path.length) {
                            object.path = [];
                            for (var j = 0; j < message.path.length; ++j)
                                object.path[j] = message.path[j];
                        }
                        if (message.sourceFile != null && message.hasOwnProperty("sourceFile"))
                            object.sourceFile = message.sourceFile;
                        if (message.begin != null && message.hasOwnProperty("begin"))
                            object.begin = message.begin;
                        if (message.end != null && message.hasOwnProperty("end"))
                            object.end = message.end;
                        if (message.semantic != null && message.hasOwnProperty("semantic"))
                            object.semantic = options.enums === String ? $root.google.protobuf.GeneratedCodeInfo.Annotation.Semantic[message.semantic] === undefined ? message.semantic : $root.google.protobuf.GeneratedCodeInfo.Annotation.Semantic[message.semantic] : message.semantic;
                        return object;
                    };
    
                    /**
                     * Converts this Annotation to JSON.
                     * @function toJSON
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @instance
                     * @returns {Object.<string,*>} JSON object
                     */
                    Annotation.prototype.toJSON = function toJSON() {
                        return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                    };
    
                    /**
                     * Gets the default type url for Annotation
                     * @function getTypeUrl
                     * @memberof google.protobuf.GeneratedCodeInfo.Annotation
                     * @static
                     * @param {string} [typeUrlPrefix] your custom typeUrlPrefix(default "type.googleapis.com")
                     * @returns {string} The default type url
                     */
                    Annotation.getTypeUrl = function getTypeUrl(typeUrlPrefix) {
                        if (typeUrlPrefix === undefined) {
                            typeUrlPrefix = "type.googleapis.com";
                        }
                        return typeUrlPrefix + "/google.protobuf.GeneratedCodeInfo.Annotation";
                    };
    
                    /**
                     * Semantic enum.
                     * @name google.protobuf.GeneratedCodeInfo.Annotation.Semantic
                     * @enum {number}
                     * @property {number} NONE=0 NONE value
                     * @property {number} SET=1 SET value
                     * @property {number} ALIAS=2 ALIAS value
                     */
                    Annotation.Semantic = (function() {
                        var valuesById = {}, values = Object.create(valuesById);
                        values[valuesById[0] = "NONE"] = 0;
                        values[valuesById[1] = "SET"] = 1;
                        values[valuesById[2] = "ALIAS"] = 2;
                        return values;
                    })();
    
                    return Annotation;
                })();
    
                return GeneratedCodeInfo;
            })();
    
            return protobuf;
        })();
    
        return google;
    })();

    return $root;
});
